--
-- PostgreSQL database dump
--

-- Dumped from database version 12.9 (Ubuntu 12.9-0ubuntu0.20.04.1)
-- Dumped by pg_dump version 12.9 (Ubuntu 12.9-0ubuntu0.20.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: archive; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE archive WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect archive

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: archive; Type: DATABASE PROPERTIES; Schema: -; Owner: -
--

ALTER DATABASE archive SET default_transaction_isolation TO 'serializable';


\connect archive

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: chain_status_type; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.chain_status_type AS ENUM (
    'canonical',
    'orphaned',
    'pending'
);


--
-- Name: internal_command_type; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.internal_command_type AS ENUM (
    'fee_transfer_via_coinbase',
    'fee_transfer',
    'coinbase'
);


--
-- Name: user_command_status; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.user_command_status AS ENUM (
    'applied',
    'failed'
);


--
-- Name: user_command_type; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.user_command_type AS ENUM (
    'payment',
    'delegation',
    'create_token',
    'create_account',
    'mint_tokens'
);


SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: balances; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.balances (
    id integer NOT NULL,
    public_key_id integer NOT NULL,
    balance bigint NOT NULL,
    block_id integer NOT NULL,
    block_height integer NOT NULL,
    block_sequence_no integer NOT NULL,
    block_secondary_sequence_no integer NOT NULL,
    nonce bigint
);


--
-- Name: balances_temp_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.balances_temp_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: balances_temp_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.balances_temp_id_seq OWNED BY public.balances.id;


--
-- Name: blocks; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.blocks (
    id integer NOT NULL,
    state_hash text NOT NULL,
    parent_id integer,
    parent_hash text NOT NULL,
    creator_id integer NOT NULL,
    block_winner_id integer NOT NULL,
    snarked_ledger_hash_id integer NOT NULL,
    staking_epoch_data_id integer NOT NULL,
    next_epoch_data_id integer NOT NULL,
    ledger_hash text NOT NULL,
    height bigint NOT NULL,
    global_slot bigint NOT NULL,
    global_slot_since_genesis bigint NOT NULL,
    "timestamp" bigint NOT NULL,
    chain_status public.chain_status_type DEFAULT 'pending'::public.chain_status_type NOT NULL
);


--
-- Name: blocks_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.blocks_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: blocks_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.blocks_id_seq OWNED BY public.blocks.id;


--
-- Name: blocks_internal_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.blocks_internal_commands (
    block_id integer,
    internal_command_id integer,
    sequence_no integer,
    secondary_sequence_no integer,
    receiver_balance integer,
    receiver_account_creation_fee_paid bigint
);


--
-- Name: blocks_user_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.blocks_user_commands (
    block_id integer,
    user_command_id integer,
    sequence_no integer,
    status public.user_command_status,
    failure_reason text,
    fee_payer_account_creation_fee_paid bigint,
    receiver_account_creation_fee_paid bigint,
    created_token bigint,
    fee_payer_balance integer,
    source_balance integer,
    receiver_balance integer
);


--
-- Name: epoch_data; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.epoch_data (
    id integer NOT NULL,
    seed text NOT NULL,
    ledger_hash_id integer NOT NULL
);


--
-- Name: epoch_data_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.epoch_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: epoch_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.epoch_data_id_seq OWNED BY public.epoch_data.id;


--
-- Name: internal_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.internal_commands (
    id integer NOT NULL,
    type public.internal_command_type NOT NULL,
    receiver_id integer NOT NULL,
    fee bigint NOT NULL,
    token bigint NOT NULL,
    hash text NOT NULL
);


--
-- Name: internal_commands_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.internal_commands_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: internal_commands_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.internal_commands_id_seq OWNED BY public.internal_commands.id;


--
-- Name: public_keys; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.public_keys (
    id integer NOT NULL,
    value text NOT NULL
);


--
-- Name: public_keys_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.public_keys_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: public_keys_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.public_keys_id_seq OWNED BY public.public_keys.id;


--
-- Name: snarked_ledger_hashes; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.snarked_ledger_hashes (
    id integer NOT NULL,
    value text NOT NULL
);


--
-- Name: snarked_ledger_hashes_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.snarked_ledger_hashes_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: snarked_ledger_hashes_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.snarked_ledger_hashes_id_seq OWNED BY public.snarked_ledger_hashes.id;


--
-- Name: timing_info; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.timing_info (
    id integer NOT NULL,
    public_key_id integer NOT NULL,
    token bigint NOT NULL,
    initial_balance bigint NOT NULL,
    initial_minimum_balance bigint NOT NULL,
    cliff_time bigint NOT NULL,
    cliff_amount bigint NOT NULL,
    vesting_period bigint NOT NULL,
    vesting_increment bigint NOT NULL
);


--
-- Name: timing_info_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.timing_info_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: timing_info_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.timing_info_id_seq OWNED BY public.timing_info.id;


--
-- Name: user_commands; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_commands (
    id integer NOT NULL,
    type public.user_command_type NOT NULL,
    fee_payer_id integer NOT NULL,
    source_id integer NOT NULL,
    receiver_id integer NOT NULL,
    fee_token bigint NOT NULL,
    token bigint NOT NULL,
    nonce bigint NOT NULL,
    amount bigint,
    fee bigint NOT NULL,
    valid_until bigint,
    memo text NOT NULL,
    hash text NOT NULL
);


--
-- Name: user_commands_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.user_commands_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: user_commands_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.user_commands_id_seq OWNED BY public.user_commands.id;


--
-- Name: balances id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances ALTER COLUMN id SET DEFAULT nextval('public.balances_temp_id_seq'::regclass);


--
-- Name: blocks id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks ALTER COLUMN id SET DEFAULT nextval('public.blocks_id_seq'::regclass);


--
-- Name: epoch_data id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.epoch_data ALTER COLUMN id SET DEFAULT nextval('public.epoch_data_id_seq'::regclass);


--
-- Name: internal_commands id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands ALTER COLUMN id SET DEFAULT nextval('public.internal_commands_id_seq'::regclass);


--
-- Name: public_keys id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_keys ALTER COLUMN id SET DEFAULT nextval('public.public_keys_id_seq'::regclass);


--
-- Name: snarked_ledger_hashes id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.snarked_ledger_hashes ALTER COLUMN id SET DEFAULT nextval('public.snarked_ledger_hashes_id_seq'::regclass);


--
-- Name: timing_info id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.timing_info ALTER COLUMN id SET DEFAULT nextval('public.timing_info_id_seq'::regclass);


--
-- Name: user_commands id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands ALTER COLUMN id SET DEFAULT nextval('public.user_commands_id_seq'::regclass);


--
-- Data for Name: balances; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.balances (id, public_key_id, balance, block_id, block_height, block_sequence_no, block_secondary_sequence_no, nonce) FROM stdin;
3	42	150000000	11789	5945	127	1	\N
6	42	67440020000000	557	314	1	0	\N
7	42	67440020000000	1290	712	1	0	\N
9	42	67440030000000	557	314	2	0	\N
10	42	67440030000000	1290	712	2	0	\N
12	42	68160040000000	1618	874	1	0	\N
13	42	68160040000000	1779	953	1	0	\N
14	42	68160040000000	2196	1157	1	0	\N
15	42	68160040000000	2249	1183	0	0	\N
16	42	68160040000000	2321	1215	1	0	\N
18	42	68160050000000	1618	874	2	0	\N
19	42	68160050000000	1779	953	2	0	\N
20	42	68160050000000	2196	1157	2	0	\N
21	42	68160050000000	2321	1215	2	0	\N
26	42	69980595000000	23802	11847	7	0	\N
30	42	69980620000000	23802	11847	8	0	\N
37	42	71420619000000	24135	12014	2	0	\N
40	42	71420630000000	24135	12014	3	0	\N
43	42	72140626000000	24490	12179	4	0	\N
44	42	72140626000000	24860	12344	8	0	\N
47	42	72140648000000	24490	12179	5	0	\N
48	42	72140652000000	24860	12344	9	0	\N
49	42	72480200000000	4715	2438	1	0	\N
50	42	72480200000000	4846	2510	1	0	\N
52	42	72480210000000	4715	2438	2	0	\N
53	42	72480210000000	4846	2510	2	0	\N
58	42	73580674000000	25984	12840	2	0	\N
61	42	73580685000000	25984	12840	3	0	\N
63	42	74300675000000	26537	13128	5	0	\N
64	42	74300675000000	26702	13206	3	0	\N
65	42	74300675000000	26997	13353	8	0	\N
67	42	74300687000000	26702	13206	4	0	\N
68	42	74300698000000	26537	13128	6	0	\N
70	42	74300710000000	26997	13353	9	0	\N
74	42	75357820000000	6237	3226	2	0	\N
75	42	75357820000000	6397	3315	0	0	\N
77	42	75357840000000	6237	3226	3	0	\N
79	42	75358020000000	6190	3205	1	0	\N
80	42	75358030000000	6190	3205	2	0	\N
81	42	75360220000000	5632	2926	0	0	\N
82	42	75740709000000	27411	13554	3	0	\N
84	42	75740721000000	27411	13554	4	0	\N
96	42	77233202000000	20278	9953	73	0	\N
101	42	77949382000000	19177	9676	3	0	\N
102	42	77949382000000	19333	9748	4	0	\N
103	42	77949382000000	22896	11445	4	0	\N
104	42	77949382000000	23168	11568	2	0	\N
106	42	77949393000000	23168	11568	3	0	\N
108	42	77949394000000	19177	9676	4	0	\N
109	42	77949395000000	19333	9748	5	0	\N
110	42	77949395000000	22896	11445	5	0	\N
111	42	77953202000000	20278	9953	126	0	\N
112	42	77953722000000	20278	9953	127	0	\N
125	42	80060822000000	29443	14517	2	0	\N
127	42	80060833000000	29443	14517	3	0	\N
129	42	80397960000000	8912	4617	2	0	\N
130	42	80397960000000	9062	4697	4	0	\N
132	42	80397980000000	8912	4617	3	0	\N
134	42	80398000000000	9062	4697	5	0	\N
8	42	67440020000000	1473	804	2	0	0
11	42	67440040000000	1473	804	3	0	0
17	42	68160040000000	2405	1258	1	0	0
22	42	68160050000000	2405	1258	2	0	0
23	42	68880050000000	3319	1721	2	0	0
25	42	69600070000000	3468	1801	0	0	0
31	42	70320070000000	3760	1950	1	0	0
32	42	70320080000000	3760	1950	2	0	0
35	42	71040080000000	3831	1988	2	0	0
36	42	71040190000000	3831	1988	3	0	0
42	42	71760200000000	4074	2117	2	0	0
51	42	72480200000000	5264	2733	2	0	0
54	42	72480220000000	5264	2733	3	0	0
57	42	73200220000000	5506	2865	0	0	0
71	42	74640220000000	5573	2897	0	0	0
76	42	75357820000000	6713	3472	2	0	4
78	42	75357840000000	6713	3472	3	0	4
86	42	76077840000000	6958	3590	2	0	4
87	42	76077860000000	6958	3590	3	0	4
91	42	76797880000000	6996	3611	3	0	4
97	42	77517880000000	7044	3635	4	0	4
98	42	77517920000000	7044	3635	5	0	4
113	42	78237920000000	7286	3766	1	0	4
114	42	78237930000000	7286	3766	2	0	4
120	42	78957950000000	7750	4018	3	0	4
1	8	10953000000000	8314	4303	1	0	0
2	8	10953010000000	8314	4303	2	0	0
123	42	79677950000000	8663	4485	1	0	4
131	42	80397960000000	9097	4714	2	0	4
133	42	80397980000000	9097	4714	3	0	4
94	42	77229360000000	18653	9400	4	0	8
95	42	77229382000000	18653	9400	5	0	8
105	42	77949382000000	23261	11606	2	0	8
117	42	78669393000000	23341	11647	4	0	8
118	42	78669415000000	23341	11647	5	0	8
27	42	69980595000000	23827	11861	3	0	12
28	42	69980607000000	23827	11861	4	0	12
29	42	69980617000000	23974	11930	1	0	12
34	42	70700619000000	23974	11930	5	0	12
38	42	71420619000000	24325	12098	7	0	12
39	42	71420626000000	24325	12098	8	0	12
45	42	72140626000000	25014	12411	2	0	12
55	42	72860637000000	25107	12458	10	0	12
56	42	72860674000000	25107	12458	11	0	12
59	42	73580674000000	26349	13029	1	0	12
60	42	73580675000000	26349	13029	2	0	12
66	42	74300675000000	27169	13435	5	0	12
72	42	75020698000000	27241	13470	2	0	12
73	42	75020709000000	27241	13470	3	0	12
83	42	75740709000000	27914	13806	3	0	12
85	42	75740730000000	27914	13806	4	0	12
88	42	76460730000000	28246	13966	3	0	12
92	42	77180742000000	28284	13983	2	0	12
93	42	77180753000000	28284	13983	3	0	12
99	42	77900753000000	28415	14042	5	0	12
100	42	77900785000000	28415	14042	6	0	12
116	42	78620796000000	28440	14055	3	0	12
121	42	79340796000000	29130	14362	8	0	12
122	42	79340822000000	29130	14362	9	0	12
126	42	80060822000000	29457	14527	7	0	12
128	42	80060851500000	29457	14527	8	0	12
136	42	80780870500000	29874	14723	11	0	12
143	42	82220889500000	30173	14845	9	0	\N
144	42	82220907500000	30173	14845	10	0	\N
145	42	82558040000000	9610	4986	5	0	\N
148	42	82558063000000	9610	4986	6	0	\N
153	42	84718150000000	10167	5269	2	0	\N
155	42	84718170000000	10167	5269	3	0	\N
162	42	86878240000000	11127	5720	2	0	\N
165	42	86878260000000	11127	5720	3	0	\N
166	42	86878351000000	13990	7169	4	0	\N
167	42	86878557000000	11789	5945	63	0	\N
168	42	87598251000000	14182	7238	6	0	\N
169	42	87598251000000	14570	7429	6	0	\N
170	42	87598251000000	14613	7450	3	0	\N
173	42	87598263000000	14613	7450	4	0	\N
174	42	87598275000000	14182	7238	7	0	\N
175	42	87598284000000	14570	7429	7	0	\N
176	42	87598557000000	11789	5945	126	0	\N
177	42	88318262000000	14984	7634	1	0	\N
178	42	88318262000000	15087	7686	2	0	\N
180	42	88318272000000	14984	7634	2	0	\N
181	42	88318273000000	15087	7686	3	0	\N
183	42	89038286000000	15686	7980	3	0	\N
185	42	89038298000000	15686	7980	4	0	\N
191	42	91198434000000	17228	8729	6	0	\N
194	42	91198458000000	17228	8729	7	0	\N
195	42	91918456000000	17576	8894	3	0	\N
197	42	91918468000000	17576	8894	4	0	\N
201	42	93358480000000	18505	9321	3	0	\N
202	42	93358492000000	18505	9321	4	0	\N
203	43	200000192	18687	9414	4	0	\N
204	43	66720000000000	8	6	1	0	\N
205	43	66720000000000	240	142	1	0	\N
206	43	66720000000000	375	213	1	0	\N
208	43	66720010000000	8	6	2	0	\N
209	43	66720010000000	240	142	2	0	\N
210	43	66720010000000	375	213	2	0	\N
212	43	67440040000000	617	347	1	0	\N
213	43	67440040000000	687	384	2	0	\N
214	43	67440040000000	905	503	2	0	\N
216	43	67440050000000	617	347	2	0	\N
218	43	67440060000000	687	384	3	0	\N
219	43	67440060000000	905	503	3	0	\N
220	43	67440469890000	10739	5543	2	0	\N
222	43	67440489890000	10739	5543	3	0	\N
224	43	68160050000000	1119	617	2	0	\N
226	43	68160070000000	1119	617	3	0	\N
228	43	68160489890000	11035	5681	1	0	\N
229	43	68160489890000	11037	5681	2	0	\N
230	43	68160489890000	11396	5852	2	0	\N
231	43	68160489890000	11409	5861	3	0	\N
232	43	68160489890000	11580	5956	1	0	\N
234	43	68160490890000	11580	5956	2	0	\N
236	43	68160499890000	11035	5681	2	0	\N
237	43	68160500890000	11396	5852	3	0	\N
238	43	68160509890000	11037	5681	3	0	\N
239	43	68160510890000	11409	5861	4	0	\N
240	43	68880070000000	1843	985	1	0	\N
241	43	68880070000000	1845	984	2	0	\N
242	43	68880070000000	2193	1155	4	0	\N
244	43	68880070000000	2195	1112	62	0	\N
245	43	68880080000000	1843	985	2	0	\N
246	43	68880090000000	1845	984	3	0	\N
248	43	68880110000000	2193	1155	5	0	\N
251	43	68880780000000	2195	1112	63	0	\N
252	43	69600100000000	2216	1165	3	0	\N
255	43	69600130000000	2216	1165	4	0	\N
258	43	70320030890000	22923	11458	3	0	\N
260	43	70320042890000	22923	11458	4	0	\N
262	43	70320110000000	2518	1322	3	0	\N
265	43	70320140000000	2518	1322	4	0	\N
268	43	71040042890000	23722	11814	6	0	\N
269	43	71040042890000	23839	11864	3	0	\N
271	43	71040054890000	23839	11864	4	0	\N
215	43	67440040000000	994	548	1	0	0
217	43	67440050000000	994	548	2	0	0
225	43	68160050000000	1567	853	2	0	0
227	43	68160070000000	1567	853	3	0	0
243	43	68880070000000	2194	1156	3	0	0
253	43	69600100000000	2218	1167	1	0	0
254	43	69600110000000	2218	1167	2	0	0
263	43	70320110000000	2610	1373	2	0	0
264	43	70320130000000	2610	1373	3	0	0
137	42	81117980000000	9105	4718	2	0	4
141	42	81838000000000	9219	4780	4	0	4
142	42	81838040000000	9219	4780	5	0	4
146	42	82558040000000	9755	5054	2	0	4
147	42	82558060000000	9755	5054	3	0	4
150	42	83278130000000	9762	5059	8	0	4
151	42	83998130000000	9795	5079	2	0	4
152	42	83998150000000	9795	5079	3	0	4
154	42	84718150000000	10562	5455	2	0	4
156	42	84718170000000	10562	5455	3	0	4
223	43	67440489890000	10740	5543	3	0	1
157	42	84718190000000	10742	5545	2	0	4
158	42	85438190000000	10742	5545	4	0	4
159	42	85438200000000	10742	5545	5	0	4
160	42	86158200000000	11119	5716	4	0	4
163	42	86878240000000	11477	5899	2	0	4
164	42	86878251000000	11477	5899	3	0	4
233	43	68160489890000	11799	6064	1	0	1
235	43	68160490890000	11799	6064	2	0	1
250	43	68880492890000	11831	6081	3	0	1
256	43	69600492890000	11904	6121	1	0	1
257	43	69600493890000	11904	6121	2	0	1
266	43	70320493890000	12101	6231	2	0	1
267	43	70320495890000	12101	6231	3	0	1
172	42	87598262000000	14845	7566	3	0	4
179	42	88318262000000	15668	7975	6	0	4
182	42	88318286000000	15668	7975	7	0	4
184	42	89038286000000	16318	8291	5	0	4
186	42	89038399000000	16318	8291	6	0	4
188	42	89758411000000	16991	8607	4	0	4
189	42	90478411000000	17056	8637	5	0	4
190	42	90478434000000	17056	8637	6	0	4
192	42	91198434000000	17332	8780	4	0	4
196	42	91918456000000	17877	9023	3	0	4
198	42	91918468000000	17877	9023	4	0	4
199	42	92638468000000	17894	9029	3	0	4
200	42	92638480000000	17894	9029	4	0	4
259	43	70320030890000	23547	11738	3	0	3
270	43	71040042890000	23925	11906	3	0	3
272	43	71040054890000	23925	11906	4	0	3
139	42	81500870500000	30053	14796	10	0	12
140	42	81500889500000	30053	14796	11	0	12
273	43	71040066890000	23722	11814	7	0	\N
276	43	71040495890000	12167	6265	0	0	\N
277	43	71040495890000	12169	6265	1	0	\N
278	43	71040495890000	13003	6703	6	0	\N
280	43	71040496890000	12169	6265	2	0	\N
282	43	71040537890000	13003	6703	7	0	\N
285	43	71760140000000	3418	1777	1	0	\N
287	43	71760150000000	3418	1777	2	0	\N
297	43	73200078890000	25052	12431	2	0	\N
299	43	73200089890000	25052	12431	3	0	\N
301	43	73200160000000	4643	2329	18	0	\N
306	43	73201960000000	4643	2329	19	0	\N
312	43	73920702890000	13973	7160	2	0	\N
313	43	73920722890000	13973	7160	3	0	\N
315	43	74640103890000	25766	12744	3	0	\N
317	43	74640115890000	25766	12744	4	0	\N
319	43	74640209999000	5255	2727	0	0	\N
326	43	75360209999000	5259	2728	0	0	\N
327	43	75360230000000	5257	2729	0	0	\N
328	43	75360230000000	5413	2817	0	0	\N
329	43	75360230000000	5425	2822	0	0	\N
331	43	75360743890000	14072	7201	4	0	\N
333	43	75360756890000	14072	7201	5	0	\N
338	43	76080230000000	5709	2960	0	0	\N
341	43	76080756890000	14402	7349	4	0	\N
342	43	76080756890000	14404	7230	6	0	\N
345	43	76080769890000	14402	7349	5	0	\N
346	43	76080807890000	14404	7230	7	0	\N
353	43	76800807890000	14425	7231	2	0	\N
354	43	76800809890000	14425	7231	3	0	\N
357	43	77520250000000	6128	3178	1	0	\N
358	43	77520250000000	6262	3243	1	0	\N
360	43	77520260000000	6128	3178	2	0	\N
361	43	77520260000000	6262	3243	2	0	\N
367	43	78240310000000	6600	3413	4	0	\N
368	43	78240310000000	6846	3542	6	0	\N
369	43	78240310000000	6848	3542	3	0	\N
371	43	78240310000000	6943	3583	1	0	\N
372	43	78240320000000	6943	3583	2	0	\N
374	43	78240340000000	6848	3542	4	0	\N
375	43	78240350000000	6600	3413	5	0	\N
376	43	78240370000000	6846	3542	7	0	\N
377	43	78240789890000	15254	7771	4	0	\N
378	43	78240789890000	15582	7932	1	0	\N
379	43	78240789890000	15849	8061	10	0	\N
380	43	78240789890000	16042	8157	4	0	\N
381	43	78240789890000	16186	8226	11	0	\N
383	43	78240799890000	15582	7932	2	0	\N
385	43	78240802890000	16042	8157	5	0	\N
386	43	78240811890000	15254	7771	5	0	\N
387	43	78240826890000	15849	8061	11	0	\N
388	43	78240827890000	16186	8226	12	0	\N
393	43	78960400000000	8460	4337	6	0	\N
396	43	79680245890000	27049	13373	6	0	\N
397	43	79680245890000	27057	13376	6	0	\N
400	43	79680269890000	27049	13373	7	0	\N
401	43	79680269890000	27057	13376	7	0	\N
402	43	79680340000000	7554	3912	1	0	\N
404	43	79680350000000	7554	3912	2	0	\N
406	43	79680400000000	8460	4337	7	0	\N
407	43	79680813890000	17940	9049	3	0	\N
286	43	71760140000000	3829	1987	1	0	0
288	43	71760150000000	3829	1987	2	0	0
293	43	72480150000000	4332	2244	1	0	0
294	43	72480160000000	4332	2244	2	0	0
302	43	73200160000000	4644	2400	1	0	0
309	43	73920170000000	4862	2517	4	0	0
310	43	73920210000000	4862	2517	5	0	0
320	43	74640210000000	5256	2728	2	0	0
321	43	74640230000000	5256	2728	3	0	0
330	43	75360230000000	5426	2822	0	0	0
340	43	76080240000000	5803	3011	2	0	0
349	43	76800240000000	6112	3169	1	0	0
350	43	76800250000000	6112	3169	2	0	0
359	43	77520250000000	6546	3392	6	0	0
370	43	78240310000000	6941	3583	2	0	0
373	43	78240330000000	6941	3583	3	0	0
391	43	78960330000000	7457	3857	1	0	0
392	43	78960340000000	7457	3857	2	0	0
403	43	79680340000000	8458	4382	1	0	0
279	43	71040495890000	13005	6703	5	0	1
281	43	71040527890000	13005	6703	6	0	1
289	43	71760527890000	13017	6710	5	0	1
290	43	71760649890000	13017	6710	6	0	1
295	43	72480649890000	13394	6902	7	0	1
304	43	73200674890000	13416	6912	10	0	1
305	43	73200702890000	13416	6912	11	0	1
311	43	73920702890000	13972	7160	8	0	1
314	43	73920728890000	13972	7160	9	0	1
323	43	74640743890000	14030	7188	7	0	1
332	43	75360743890000	14116	7215	4	0	1
334	43	75360756890000	14116	7215	5	0	1
343	43	76080756890000	14424	7359	3	0	1
344	43	76080768890000	14424	7359	4	0	1
352	43	76800778890000	15016	7651	2	0	1
363	43	77520778890000	15046	7665	2	0	1
364	43	77520789890000	15046	7665	3	0	1
382	43	78240789890000	16497	8391	3	0	1
384	43	78240801890000	16497	8391	4	0	1
395	43	78960813890000	17575	8894	4	0	1
408	43	79680813890000	17941	9049	4	0	1
283	43	71760054890000	24044	11965	2	0	3
284	43	71760056890000	24044	11965	3	0	3
292	43	72480078890000	24880	12353	5	0	3
298	43	73200078890000	25176	12491	4	0	3
300	43	73200091890000	25176	12491	5	0	3
307	43	73920091890000	25536	12642	3	0	3
308	43	73920103890000	25536	12642	4	0	3
318	43	74640116890000	26013	12857	5	0	3
324	43	75360116890000	26161	12931	6	0	3
325	43	75360131890000	26161	12931	7	0	3
335	43	76080131890000	26228	12967	3	0	3
336	43	76080143890000	26228	12967	4	0	3
347	43	76800173890000	26243	12974	18	0	3
348	43	76800196890000	26243	12974	19	0	3
355	43	77520196890000	26250	12978	4	0	3
356	43	77520209890000	26250	12978	5	0	3
366	43	78240221890000	26289	13003	4	0	3
389	43	78960221890000	26901	13303	6	0	3
390	43	78960245890000	26901	13303	7	0	3
398	43	79680245890000	27192	13448	3	0	3
399	43	79680257890000	27192	13448	4	0	3
409	43	79680825890000	17940	9049	4	0	\N
414	43	80400350000000	8716	4386	0	0	\N
416	43	80400826890000	18128	9141	7	0	\N
419	43	80400847890000	18687	9414	1	0	\N
420	43	80400847890000	18688	9414	1	0	\N
421	43	80400860890000	18128	9141	8	0	\N
422	43	81120269890000	27549	13618	3	0	\N
424	43	81120281890000	27549	13618	4	0	\N
429	43	81120847890000	18687	9414	3	0	\N
430	43	81120847890000	18688	9414	3	0	\N
431	43	81120848890000	18688	9414	4	0	\N
438	43	81840440000000	8781	4555	4	0	\N
441	43	82559440000000	8781	4555	5	0	\N
442	43	82560292890000	28287	13984	2	0	\N
443	43	82560292890000	28350	14015	2	0	\N
446	43	82560303890000	28287	13984	3	0	\N
447	43	82560303890000	28350	14015	3	0	\N
451	43	82561880911580	30267	14812	115	0	\N
452	43	83280295890000	29133	14364	2	0	\N
453	43	83280295890000	29523	14559	2	0	\N
454	43	83280295890000	29963	14757	5	0	\N
455	43	83280297890000	29523	14559	3	0	\N
456	43	83280306890000	29133	14364	3	0	\N
457	43	83280309890000	29963	14757	6	0	\N
459	43	83280970890000	19399	9776	4	0	\N
462	43	83280983890000	19399	9776	5	0	\N
463	43	83281880911580	30267	14812	124	0	\N
464	43	83281888886366	30267	14812	125	1	\N
471	43	84720985890000	20657	10393	4	0	\N
474	43	84720998890000	20657	10393	5	0	\N
476	43	85440490890000	9456	4902	0	0	\N
479	43	85440996890000	21680	10765	14	0	\N
481	43	85441118890000	21680	10765	15	0	\N
482	43	86160510890000	9536	4945	3	0	\N
483	43	86160510890000	9652	5008	2	0	\N
484	43	86160510890000	9739	5041	4	0	\N
485	43	86160510890000	9740	5046	7	0	\N
486	43	86160510890000	9742	5045	4	0	\N
487	43	86160510890000	10169	5269	2	0	\N
489	43	86160530890000	9652	5008	3	0	\N
490	43	86160530890000	10169	5269	3	0	\N
491	43	86160532890000	9739	5041	5	0	\N
492	43	86160532890000	9742	5045	5	0	\N
494	43	86160571890000	9740	5046	8	0	\N
495	43	86160630890000	9536	4945	4	0	\N
496	43	86161008890000	21752	10892	3	0	\N
498	43	86161020890000	21752	10892	4	0	\N
500	43	86161118890000	21754	10766	7	0	\N
501	43	86161279890000	21754	10766	8	0	\N
502	43	86880570890000	10417	5389	3	0	\N
503	43	86880600890000	10417	5389	4	0	\N
505	43	86881021890000	22225	11125	3	0	\N
507	43	86881033890000	22225	11125	4	0	\N
508	43	86881279890000	22071	10767	11	0	\N
509	43	86881328890000	22071	10767	12	0	\N
510	43	87601032890000	22543	11278	3	0	\N
511	43	87601032890000	22606	11309	2	0	\N
512	43	87601043890000	22606	11309	3	0	\N
513	43	87601044890000	22543	11278	4	0	\N
514	44	4900	2174	1147	2	0	\N
521	44	68880130000000	787	435	3	0	\N
522	44	68880130000000	1205	664	1	0	\N
523	44	68880130000000	1298	716	4	0	\N
525	44	68880140000000	1205	664	2	0	\N
527	44	68880160000000	787	435	4	0	\N
528	44	68880170000000	1298	716	5	0	\N
531	44	70320140000000	2173	1147	0	0	\N
532	44	70320150000000	2174	1147	1	0	\N
535	44	71040160000000	2351	1229	2	0	\N
536	44	71040160000000	2614	1375	5	0	\N
537	44	71040160000000	3136	1631	1	0	\N
538	44	71040160000000	3288	1708	8	0	\N
539	44	71040160000000	3437	1785	0	0	\N
540	44	71040160000000	3522	1830	0	0	\N
541	44	71040160000000	3615	1876	0	0	\N
543	44	71040170000000	3136	1631	2	0	\N
544	44	71040180000000	2351	1229	3	0	\N
517	44	67440010000000	371	211	2	0	0
518	44	67440120000000	371	211	3	0	0
519	44	68160120000000	722	404	1	0	0
520	44	68160130000000	722	404	2	0	0
524	44	68880130000000	1421	773	1	0	0
529	44	69600140000000	1752	938	1	0	0
530	44	69600150000000	1752	938	2	0	0
533	44	70320150000000	2175	1147	1	0	0
534	44	70320160000000	2175	1147	2	0	0
542	44	71040160000000	3823	1982	2	0	0
415	43	80400360000000	8659	4484	2	0	0
426	43	81120360000000	8717	4520	2	0	0
427	43	81120380000000	8717	4520	3	0	0
435	43	81840380000000	8727	4526	2	0	0
437	43	81840440000000	8780	4555	4	0	0
448	43	82560439890000	8780	4555	5	0	0
458	43	83280439890000	8940	4636	0	0	0
465	43	84000439890000	9165	4750	2	0	0
466	43	84000459890000	9165	4750	3	0	0
470	43	84720490890000	9316	4832	5	0	0
475	43	85440490890000	9455	4903	2	0	0
477	43	85440510890000	9455	4903	3	0	0
488	43	86160510890000	10213	5288	6	0	0
493	43	86160570890000	10213	5288	7	0	0
417	43	80400826890000	18147	9150	2	0	1
418	43	80400837890000	18147	9150	3	0	1
428	43	81120837890000	19034	9598	2	0	1
432	43	81120848890000	19034	9598	3	0	1
440	43	81840958890000	19067	9616	3	0	1
449	43	82560958890000	19135	9652	3	0	1
450	43	82560970890000	19135	9652	4	0	1
460	43	83280970890000	20110	10122	2	0	1
461	43	83280972890000	20110	10122	3	0	1
468	43	84000985890000	20304	10224	5	0	1
472	43	84720985890000	20929	10523	2	0	1
473	43	84720996890000	20929	10523	3	0	1
478	43	85440996890000	21679	10861	3	0	1
480	43	85441008890000	21679	10861	4	0	1
499	43	86161021890000	22070	11036	5	0	1
504	43	86881021890000	22223	11125	2	0	1
506	43	86881032890000	22223	11125	3	0	1
411	43	80400257890000	27254	13475	3	0	3
423	43	81120269890000	27919	13809	3	0	3
425	43	81120281890000	27919	13809	4	0	3
433	43	81840281890000	28137	13908	2	0	3
434	43	81840292890000	28137	13908	3	0	3
444	43	82560292890000	28920	14263	3	0	3
546	44	71040210000000	2614	1375	6	0	\N
547	44	71040240000000	3288	1708	9	0	\N
548	44	71760180000000	4089	2125	2	0	\N
549	44	71760180000000	4160	2163	1	0	\N
550	44	71760180000000	4220	2193	1	0	\N
551	44	71760180000000	4224	2195	2	0	\N
552	44	71760180000000	4587	2372	5	0	\N
553	44	71760180000000	4589	2323	88	0	\N
554	44	71760180000000	4835	2505	3	0	\N
556	44	71760190000000	4160	2163	2	0	\N
557	44	71760190000000	4220	2193	2	0	\N
559	44	71760200000000	4224	2195	3	0	\N
560	44	71760210000000	4835	2505	4	0	\N
561	44	71760290000000	4089	2125	3	0	\N
562	44	71760320000000	4587	2372	6	0	\N
563	44	71762680000000	4589	2323	89	0	\N
570	44	74640330000000	5719	2965	0	0	\N
575	44	76080480000000	6372	3301	3	0	\N
577	44	76080510000000	6372	3301	4	0	\N
585	44	78960850000000	7562	3916	1	0	\N
586	44	78960850000000	7609	3932	0	0	\N
588	44	78960850000000	7611	3938	3	0	\N
589	44	78960860000000	7562	3916	2	0	\N
591	44	78960880000000	7611	3938	4	0	\N
592	44	79680860000000	7800	4045	1	0	\N
594	44	79680870000000	7800	4045	2	0	\N
596	44	80400880000000	8176	4236	2	0	\N
599	44	80400900000000	8176	4236	3	0	\N
606	44	83261008000000	9617	4989	2	0	\N
607	44	83261028000000	9617	4989	3	0	\N
608	45	175000	26174	12940	15	0	\N
609	45	400000	26392	12900	117	0	\N
610	45	170000000	2760	1231	118	0	\N
611	45	2160409999970	2569	1144	14	0	\N
612	45	5997327599990	22835	11419	4	0	\N
613	45	7200259999710	2485	1230	104	0	\N
614	45	7920771396340	2760	1231	127	0	\N
615	45	13343305503785	25697	12715	5	0	\N
616	45	15120819999979	17698	8947	3	1	\N
617	45	66000000000010	2485	1230	103	0	\N
618	45	66000000000010	2569	1144	13	0	\N
619	45	66000000000410	2760	1231	126	0	\N
626	45	66000000001310	25895	12799	11	0	\N
627	45	66000000001420	29292	14435	6	0	\N
628	45	66000000001470	29293	14435	5	1	\N
629	45	67440065009990	27685	13681	8	0	\N
630	45	70318959999990	2339	1222	2	1	\N
631	45	71761489999980	2703	1289	127	0	\N
632	45	73920149999990	2032	1072	3	1	\N
633	45	75362369999990	4306	1996	127	1	\N
634	45	76512227890090	23397	11486	81	1	\N
636	55	66720000000000	10000	5184	2	0	\N
637	55	66720000000000	11125	5693	78	0	\N
638	55	66720000000000	11511	5913	2	0	\N
639	55	66720000000000	12209	6269	6	0	\N
641	55	66720011000000	10000	5184	3	0	\N
642	55	66720011000000	11511	5913	3	0	\N
645	55	66720190000000	12209	6269	7	0	\N
646	55	66720780000000	11125	5693	79	0	\N
648	55	67440030000000	337	193	2	0	\N
649	55	67440030000000	2454	1284	1	0	\N
650	55	67440030000000	4112	2137	1	0	\N
651	55	67440030000000	7296	3614	0	0	\N
652	55	67440030000000	7297	3632	0	0	\N
653	55	67440030000000	8343	4320	3	0	\N
655	55	67440040000000	2454	1284	2	0	\N
656	55	67440040000000	4112	2137	2	0	\N
659	55	67440050000000	337	193	3	0	\N
660	55	67440150000000	8343	4320	4	0	\N
662	55	68160049000000	26444	13081	6	0	\N
663	55	68160049000000	28339	14009	2	0	\N
664	55	68160049000000	29036	14315	1	0	\N
665	55	68160049000000	29845	14709	5	0	\N
666	55	68160059000000	29036	14315	2	0	\N
668	55	68160060000000	28339	14009	3	0	\N
669	55	68160063000000	29845	14709	6	0	\N
670	55	68160073000000	26444	13081	7	0	\N
671	58	21552253851155	21532	10801	5	1	\N
672	58	66720000000000	664	369	1	0	0
673	58	66720010000000	664	369	2	0	0
674	58	67440010000000	772	429	3	0	0
675	58	67440040000000	772	429	4	0	0
678	58	68160040000000	951	530	2	0	0
620	45	66000000000660	2534	1333	4	0	0
621	45	66000000001040	2604	1370	3	1	0
545	44	71040180000000	3823	1982	3	0	0
555	44	71760180000000	4884	2529	1	0	0
558	44	71760190000000	4884	2529	2	0	0
565	44	72480310000000	4960	2571	4	0	0
566	44	73200310000000	5000	2593	1	0	0
567	44	73200320000000	5000	2593	2	0	0
622	45	66000000001050	5180	2689	6	1	0
569	44	73920330000000	5353	2779	2	0	0
571	44	74640330000000	6060	3148	2	0	0
572	44	74640350000000	6060	3148	3	0	0
573	44	75360350000000	6213	3215	4	0	0
574	44	75360480000000	6213	3215	5	0	0
578	44	76080800000000	6763	3500	6	0	0
579	44	76800800000000	6898	3564	2	0	0
580	44	76800820000000	6898	3564	3	0	0
581	44	77520820000000	7210	3727	1	0	0
582	44	77520830000000	7210	3727	2	0	0
584	44	78240850000000	7496	3878	3	0	0
587	44	78960850000000	7610	3938	1	0	0
590	44	78960860000000	7610	3938	2	0	0
593	44	79680860000000	7822	4055	2	0	0
654	55	67440030000000	8392	4349	1	0	0
657	55	67440040000000	8392	4349	2	0	0
597	44	80400880000000	8503	4404	1	0	0
598	44	80400890000000	8503	4404	2	0	0
600	44	81120890000000	8562	4438	2	0	0
602	44	81840910000000	8711	4518	8	0	0
603	44	81840990000000	8711	4518	9	0	0
661	55	68160040000000	9071	4703	2	0	0
667	55	68160060000000	9071	4703	3	0	0
624	45	66000000001290	9179	4757	8	0	0
605	44	82561010000000	9332	4841	3	0	0
676	58	68105914999659	10136	5257	4	0	6
677	58	68106224999659	10136	5257	5	0	6
680	58	68826224999659	10424	5391	2	0	6
640	55	66720000000000	20358	10254	6	0	11
643	55	66720024000000	20358	10254	7	0	11
647	55	67440024000000	22660	11329	7	0	11
658	55	67440049000000	22660	11329	8	0	11
688	58	70266264999659	11011	5669	6	0	\N
691	58	70266414999659	11011	5669	7	0	\N
692	58	70320080000000	1359	745	1	0	\N
693	58	70320080000000	1423	774	2	0	\N
695	58	70320090000000	1359	745	2	0	\N
696	58	70320100000000	1423	774	3	0	\N
698	58	70986265999659	11838	6086	1	0	\N
700	58	70986266999659	11838	6086	2	0	\N
702	58	71027296999641	21532	10801	3	0	\N
703	58	71027296999641	21536	10801	3	0	\N
704	58	71027296999641	22804	11403	3	0	\N
705	58	71027296999641	22840	11422	3	0	\N
707	58	71027308999641	21536	10801	4	0	\N
708	58	71027308999641	22804	11403	4	0	\N
709	58	71027308999641	22840	11422	4	0	\N
711	58	71040110000000	1799	962	3	0	\N
712	58	71040110000000	1876	998	1	0	\N
713	58	71040110000000	1928	1025	3	0	\N
715	58	71040120000000	1876	998	2	0	\N
717	58	71040140000000	1928	1025	4	0	\N
718	58	71040230000000	1799	962	4	0	\N
721	58	71747308999641	23227	11591	5	0	\N
722	58	71747308999641	23336	11644	2	0	\N
723	58	71747308999641	23808	11851	5	0	\N
724	58	71747308999641	23909	11898	3	0	\N
725	58	71747308999641	23911	11898	4	0	\N
726	58	71747308999641	24505	12159	0	0	\N
728	58	71747319999641	23336	11644	3	0	\N
730	58	71747320999641	23909	11898	4	0	\N
731	58	71747321999641	23911	11898	5	0	\N
732	58	71747430999641	23227	11591	6	0	\N
733	58	71747571999641	23808	11851	6	0	\N
736	58	72426269999659	12019	6186	1	0	\N
738	58	72426270999659	12019	6186	2	0	\N
742	58	72480140000000	2737	1437	1	0	\N
744	58	72480150000000	2737	1437	2	0	\N
748	58	73187368999641	25516	12634	3	0	\N
750	58	73187380999641	25516	12634	4	0	\N
754	58	73866283999659	12488	6437	1	0	\N
755	58	73866283999659	12631	6517	2	0	\N
757	58	73866284999659	12488	6437	2	0	\N
758	58	73866294999659	12631	6517	3	0	\N
760	58	73866464999659	12848	6585	17	0	\N
763	58	73907854999641	26060	12862	58	0	\N
764	58	73920190000000	4257	2209	1	0	\N
765	58	73920190000000	4404	2282	10	0	\N
767	58	73920200000000	4257	2209	2	0	\N
769	58	73920290000000	4404	2282	11	0	\N
772	58	74586464999659	12848	6585	90	0	\N
773	58	74586869999659	12848	6585	91	0	\N
774	58	74587201999659	12880	6586	53	0	\N
777	58	74627854999641	26060	12862	64	0	\N
778	58	74627859999641	26060	12862	65	0	\N
779	58	74629059999641	26193	12863	120	0	\N
780	58	74640210000000	4680	2419	1	0	\N
782	58	74640220000000	4680	2419	2	0	\N
786	58	75307201999659	12880	6586	63	0	\N
787	58	75307210999659	12880	6586	64	0	\N
790	58	75349059999641	26193	12863	126	0	\N
791	58	75349100999641	26193	12863	127	0	\N
792	58	75360230000000	4827	2501	0	0	\N
795	58	75360240000000	6040	3136	1	0	\N
798	58	76027210999659	12930	6587	61	0	\N
799	58	76027541999659	12930	6587	62	0	\N
800	58	76067492999641	26638	13178	4	0	\N
802	58	76067505999641	26638	13178	5	0	\N
805	58	76080240000000	6040	3136	2	0	\N
806	58	76080250000000	6632	3427	1	0	\N
807	58	76746327999659	13235	6819	1	0	\N
808	58	76746327999659	13237	6819	3	0	\N
809	58	76746327999659	13315	6859	3	0	\N
811	58	76746337999659	13235	6819	2	0	\N
812	58	76746339999659	13237	6819	4	0	\N
813	58	76746339999659	13315	6859	4	0	\N
686	58	69600070000000	1088	602	1	0	0
687	58	69600080000000	1088	602	2	0	0
694	58	70320080000000	1426	775	3	0	0
697	58	70320110000000	1426	775	4	0	0
714	58	71040110000000	2291	1202	1	0	0
734	58	71760120000000	2317	1213	2	0	0
735	58	71760140000000	2317	1213	3	0	0
743	58	72480140000000	3246	1685	2	0	0
745	58	72480160000000	3246	1685	3	0	0
752	58	73200160000000	4047	2102	3	0	0
766	58	73920190000000	4512	2334	2	0	0
768	58	73920210000000	4512	2334	3	0	0
781	58	74640210000000	4759	2459	2	0	0
783	58	74640230000000	4759	2459	3	0	0
794	58	75360240000000	6039	3136	1	0	0
804	58	76080240000000	6039	3136	2	0	0
681	58	68826244999659	10424	5391	3	0	6
684	58	69546244999659	10970	5651	2	0	6
685	58	69546264999659	10970	5651	3	0	6
690	58	70266275999659	11289	5799	3	0	6
699	58	70986265999659	11856	6094	2	0	7
701	58	70986267999659	11856	6094	3	0	7
719	58	71706267999659	12001	6176	2	0	7
720	58	71706269999659	12001	6176	3	0	7
739	58	72426270999659	12200	6283	2	0	7
746	58	73146270999659	12248	6308	4	0	7
747	58	73146283999659	12248	6308	5	0	7
756	58	73866283999659	12632	6517	2	0	7
770	58	74586294999659	12847	6625	2	0	7
771	58	74586305999659	12847	6625	3	0	7
784	58	75306305999659	12879	6641	2	0	7
785	58	75306316999659	12879	6641	3	0	7
796	58	76026316999659	12928	6664	2	0	7
810	58	76746327999659	13401	6905	6	0	7
814	58	76746351999659	13401	6905	7	0	7
706	58	71027296999641	23081	11524	3	0	12
710	58	71027308999641	23081	11524	4	0	12
727	58	71747308999641	24506	12188	2	0	12
740	58	72467319999641	25084	12452	13	0	12
741	58	72467368999641	25084	12452	14	0	12
749	58	73187368999641	25714	12720	9	0	12
751	58	73187404999641	25714	12720	10	0	12
762	58	73907427999641	25748	12736	6	0	12
775	58	74627427999641	26059	12878	6	0	12
776	58	74627478999641	26059	12878	7	0	12
788	58	75347478999641	26192	12948	5	0	12
789	58	75347492999641	26192	12948	6	0	12
803	58	76067528999641	26682	13198	10	0	12
815	58	76787528999641	26746	13229	7	0	12
816	58	76787553999641	26746	13229	8	0	12
817	58	76800240000000	6280	3253	1	0	\N
818	58	76800240000000	6316	3270	1	0	\N
819	58	76800240000000	6630	3427	0	0	\N
821	58	76800250000000	6280	3253	2	0	\N
822	58	76800250000000	6316	3270	2	0	\N
823	58	76800250000000	6632	3427	5	0	\N
824	58	76800280000000	6632	3427	6	0	\N
828	58	77466389999659	13917	7135	3	0	\N
829	58	77507553999641	27206	13456	3	0	\N
831	58	77507565999641	27206	13456	4	0	\N
835	58	78186377999659	13915	7127	3	0	\N
837	58	78186380999659	13915	7127	4	0	\N
838	58	78186389999659	13917	7135	5	0	\N
839	58	78186390999659	13917	7135	6	0	\N
845	58	78906380999659	13984	7128	3	0	\N
847	58	78906401999659	13984	7128	4	0	\N
853	58	79626401999659	14000	7129	5	0	\N
854	58	79626406999659	14000	7129	6	0	\N
856	58	79626435999659	14070	7200	4	0	\N
857	58	79626435999659	14234	7267	4	0	\N
859	58	79626448999659	14070	7200	5	0	\N
860	58	79626448999659	14234	7267	5	0	\N
861	58	79667601999641	27428	13560	3	0	\N
863	58	79667613999641	27428	13560	4	0	\N
867	58	80346406999659	14071	7130	13	0	\N
868	58	80346436999641	14530	7411	2	0	\N
870	58	80346447999641	14530	7411	3	0	\N
871	58	80346450999659	14071	7130	14	0	\N
879	58	81107624999641	27777	13725	2	0	\N
881	58	81107635999641	27777	13725	3	0	\N
883	58	81120420000000	6973	3598	2	0	\N
885	58	81120440000000	6973	3598	3	0	\N
889	58	81827648999641	27980	13840	3	0	\N
890	58	81827648999641	28241	13962	2	0	\N
891	58	81827648999641	28278	13980	2	0	\N
892	58	81827648999641	28280	13980	2	0	\N
894	58	81827659999641	28241	13962	3	0	\N
895	58	81827659999641	28278	13980	3	0	\N
896	58	81827659999641	28280	13980	3	0	\N
897	58	81827660999641	27980	13840	4	0	\N
899	58	81840440000000	7188	3715	1	0	\N
901	58	81840450000000	7188	3715	2	0	\N
909	58	83226505999641	15485	7884	3	0	\N
910	58	83226505999641	15486	7879	0	0	\N
911	58	83226505999641	15748	8009	14	0	\N
913	58	83226517999641	15485	7884	4	0	\N
915	58	83226538999641	16401	8343	2	0	\N
917	58	83226654999641	15748	8009	15	0	\N
922	58	83946518999641	16053	8165	6	0	\N
923	58	83946518999641	16077	8173	0	0	\N
924	58	83946518999641	16078	8173	1	0	\N
925	58	83946518999641	16160	8213	3	0	\N
926	58	83946528999641	16078	8173	2	0	\N
927	58	83946530999641	16160	8213	4	0	\N
928	58	83946538999641	16401	8343	8	0	\N
930	58	83946542999641	16053	8165	7	0	\N
931	58	83946543999641	16401	8343	9	0	\N
933	58	83987686999641	29158	14378	2	0	\N
934	58	83987686999641	29212	14397	3	0	\N
936	58	83987697999641	29158	14378	3	0	\N
938	58	83987698999641	29212	14397	4	0	\N
939	58	84000490000000	7356	3801	9	0	\N
941	58	84000490000000	7373	3807	29	0	\N
942	58	84000580000000	7356	3801	10	0	\N
943	58	84000795000000	7373	3807	30	0	\N
945	58	84001215000000	8610	4332	22	0	\N
946	58	84666543999641	16546	8410	14	0	\N
947	58	84666543999641	16910	8574	7	0	\N
948	58	84666543999641	16912	8574	7	0	\N
949	58	84666543999641	16954	8593	4	0	\N
952	58	84666565999641	16954	8593	5	0	\N
833	58	77520280000000	6783	3512	2	0	0
834	58	77520300000000	6783	3512	3	0	0
843	58	78240300000000	6791	3516	4	0	0
844	58	78240340000000	6791	3516	5	0	0
851	58	78960340000000	6854	3545	4	0	0
865	58	79680380000000	6858	3547	2	0	0
866	58	79680400000000	6858	3547	3	0	0
875	58	80400400000000	6956	3589	2	0	0
876	58	80400420000000	6956	3589	3	0	0
884	58	81120420000000	7045	3636	2	0	0
900	58	81840440000000	7191	3718	2	0	0
902	58	81840460000000	7191	3718	3	0	0
907	58	82560460000000	7214	3730	1	0	0
908	58	82560470000000	7214	3730	2	0	0
921	58	83280490000000	7235	3740	3	0	0
940	58	84000490000000	7372	3807	30	0	0
944	58	84000805000000	7372	3807	31	0	0
826	58	77466351999659	13457	6933	8	0	7
827	58	77466377999659	13457	6933	9	0	7
840	58	78186392999659	13985	7165	7	0	7
846	58	78906392999659	14001	7173	16	0	7
848	58	78906435999659	14001	7173	17	0	7
855	58	79626435999649	14257	7279	4	0	7
858	58	79626436999641	14257	7279	6	0	7
872	58	80346460999641	14627	7456	7	0	7
877	58	81066460999641	14695	7483	4	0	7
878	58	81066482999641	14695	7483	5	0	7
887	58	81786482999641	14722	7497	2	0	7
903	58	82506493999641	15017	7652	3	0	7
904	58	82506505999641	15017	7652	4	0	7
912	58	83226505999641	15843	8059	4	0	7
914	58	83226518999641	15843	8059	5	0	7
916	58	83226538999641	16402	8343	2	0	7
932	58	83946543999641	16402	8343	9	0	7
950	58	84666543999641	16990	8606	2	0	7
951	58	84666554999641	16990	8606	3	0	7
830	58	77507553999641	27230	13465	3	0	12
832	58	77507565999641	27230	13465	4	0	12
842	58	78227577999641	27338	13515	4	0	12
849	58	78947577999641	27396	13547	6	0	12
850	58	78947601999641	27396	13547	7	0	12
862	58	79667601999641	27634	13658	3	0	12
873	58	80387613999641	27730	13699	2	0	12
874	58	80387624999641	27730	13699	3	0	12
880	58	81107624999641	27907	13802	6	0	12
882	58	81107648999641	27907	13802	7	0	12
893	58	81827648999641	28298	13988	5	0	12
905	58	82547671999641	28916	14262	2	0	12
906	58	82547673999641	28916	14262	3	0	12
918	58	83267673999641	29089	14341	4	0	12
919	58	83267686999641	29089	14341	5	0	12
935	58	83987686999641	29213	14397	2	0	12
953	58	84666568999641	16910	8574	8	0	\N
954	58	84666568999641	16912	8574	8	0	\N
955	58	84666602999641	16546	8410	15	0	\N
958	58	84720795000000	7375	3808	1	0	\N
959	58	84720805000000	7375	3808	2	0	\N
960	58	84720805000000	7759	4022	1	0	\N
961	58	84720805000000	7760	4021	2	0	\N
962	58	84720805000000	8112	4206	1	0	\N
964	58	84720815000000	7759	4022	2	0	\N
965	58	84720815000000	8112	4206	2	0	\N
967	58	84720825000000	7760	4021	3	0	\N
968	58	84721215000000	8610	4332	23	0	\N
971	58	85427708999641	29495	14544	3	0	\N
973	58	85427720999641	29495	14544	4	0	\N
980	58	86148075999641	29986	14751	46	0	\N
981	58	86160825000000	9096	4714	2	0	\N
983	58	86160845000000	9096	4714	3	0	\N
987	58	86867849999641	29985	14765	19	0	\N
988	58	86867886999641	29985	14765	20	0	\N
989	58	86868075999641	29986	14751	122	0	\N
990	58	86868150747275	29986	14751	125	1	\N
993	58	87546588999641	17619	8910	3	0	\N
995	58	87546600999641	17619	8910	4	0	\N
999	58	88986624999641	19228	9697	5	0	\N
1000	58	88986624999641	19357	9759	15	0	\N
1001	58	88986624999641	19374	9768	3	0	\N
1003	58	88986636999641	19374	9768	4	0	\N
1004	58	88986647999641	19228	9697	6	0	\N
1006	58	88986702999641	19357	9759	16	0	\N
1007	58	89706648999641	19547	9846	3	0	\N
1008	58	89706648999641	19612	9879	7	0	\N
1009	58	89706648999641	19637	9892	3	0	\N
1010	58	89706648999641	19686	9914	10	0	\N
1011	58	89706648999641	19687	9914	9	0	\N
1012	58	89706648999641	19838	9994	3	0	\N
1013	58	89706648999641	19907	10025	10	0	\N
1015	58	89706660999641	19547	9846	4	0	\N
1016	58	89706660999641	19637	9892	4	0	\N
1017	58	89706660999641	19838	9994	4	0	\N
1019	58	89706673999641	19612	9879	8	0	\N
1020	58	89706685999641	19907	10025	11	0	\N
1021	58	89706720999641	19687	9914	10	0	\N
1022	58	89706730999641	19686	9914	11	0	\N
1025	58	91146684999641	20394	10276	1	0	\N
1026	58	91146684999641	20397	10276	3	0	\N
1028	58	91146694999641	20394	10276	2	0	\N
1029	58	91146696999641	20397	10276	4	0	\N
1039	64	69600056000000	26741	13227	4	0	\N
1040	64	69600069000000	26741	13227	5	0	\N
1041	69	66720000000000	927	516	1	0	\N
1043	69	66720010000000	927	516	2	0	\N
1047	69	68160022000000	18781	9464	2	0	\N
1048	69	68160033000000	18781	9464	3	0	\N
1049	75	18300002	13327	6790	111	0	\N
1050	75	23773138077629	19647	9878	110	0	\N
1051	75	24086293950000	17751	8898	71	0	\N
1055	75	68160013000000	23383	11663	12	0	\N
1056	75	68160079000000	23383	11663	13	0	\N
1057	95	66720000000000	5482	2854	0	0	\N
1064	96	68161222000000	23011	11494	8	0	\N
1065	96	68161248000000	23011	11494	9	0	\N
1068	101	67440010000000	16956	8594	6	0	\N
1069	101	67440043000000	16956	8594	7	0	\N
1071	102	66720010000000	27516	13602	1	0	\N
1072	102	67440010000000	27516	13602	4	0	\N
1073	102	67440012000000	27516	13602	5	0	\N
1078	111	68160030000000	6197	3208	1	0	\N
1080	111	68160040000000	6197	3208	2	0	\N
1082	111	68880040000000	7807	4048	1	0	\N
1083	111	68880040000000	15776	8025	8	0	\N
1085	111	68880050000000	7807	4048	2	0	\N
1087	111	68880057000000	15776	8025	9	0	\N
1074	111	66720000000000	1948	1033	2	0	0
1075	111	66720020000000	1948	1033	3	0	0
1031	64	66720000000000	2424	1269	1	0	0
1032	64	66720010000000	2424	1269	2	0	0
1042	69	66720000000000	5156	2675	1	0	0
1076	111	67440020000000	6144	3185	1	0	0
1077	111	67440030000000	6144	3185	2	0	0
1079	111	68160030000000	6310	3266	1	0	0
1081	111	68160040000000	6310	3266	2	0	0
1060	96	66721200000000	6383	3307	1	0	0
1070	102	66720000000000	8419	4362	0	0	0
963	58	84720805000000	8609	4463	1	0	0
966	58	84720815000000	8609	4463	2	0	0
975	58	85440815000000	8684	4501	1	0	0
1033	64	67440010000000	8978	4657	2	0	0
1034	64	67440030000000	8978	4657	3	0	0
982	58	86160825000000	9543	4948	2	0	0
984	58	86160845000000	9543	4948	3	0	0
991	58	86880845000000	9671	5019	2	0	0
1052	75	66720000000000	12428	6407	0	0	0
1045	69	67440010000000	14593	7442	3	0	0
1046	69	67440022000000	14593	7442	4	0	0
1053	75	67440000000000	15646	7961	4	0	0
1054	75	67440013000000	15646	7961	5	0	0
1063	96	67441222000000	15983	8125	4	0	0
969	58	85386554999641	17009	8616	5	0	7
970	58	85386577999641	17009	8616	6	0	7
977	58	86106577999641	17064	8643	0	0	7
1086	111	68880052000000	17131	8681	4	0	0
985	58	86826577999641	17493	8855	2	0	7
986	58	86826588999641	17493	8855	3	0	7
994	58	87546588999641	17932	9045	7	0	7
996	58	87546613999641	17932	9045	8	0	7
998	58	88266624999641	18221	9178	3	0	7
1002	58	88986624999641	19424	9789	6	0	7
1005	58	88986648999641	19424	9789	7	0	7
1088	111	69600052000000	19774	9957	3	0	0
1014	58	89706648999641	20058	10098	3	0	7
1023	58	90426660999641	20282	10214	6	0	7
1024	58	90426684999641	20282	10214	7	0	7
1027	58	91146684999641	20502	10323	3	0	7
1030	58	91146696999641	20502	10323	4	0	7
1036	64	68160043000000	24300	12085	5	0	0
1037	64	68880043000000	26253	12981	4	0	0
1038	64	68880056000000	26253	12981	5	0	0
956	58	84707697999641	29240	14409	2	0	12
957	58	84707708999641	29240	14409	3	0	12
974	58	85427830999641	29576	14583	6	0	12
1058	95	66720000000000	29765	14670	12	0	0
1059	95	66720021000000	29765	14670	13	0	0
978	58	86147830999641	29917	14739	10	0	12
979	58	86147849999641	29917	14739	11	0	12
1090	111	70320064000000	20443	10296	2	0	\N
1092	111	70320075000000	20443	10296	3	0	\N
1096	111	71760077000000	21937	10975	3	0	\N
1098	111	71760089000000	21937	10975	4	0	\N
1102	114	200000001	14024	7185	11	1	\N
1103	114	66722733000000	14024	7185	10	0	\N
1104	114	66722733000000	14025	7185	10	0	\N
1105	114	66722740000000	13761	7070	1	0	\N
1107	114	66722750000000	13761	7070	2	0	\N
1109	114	66722761000000	14025	7185	11	0	\N
1110	115	200100000	20559	10228	64	0	\N
1111	115	272999977	20646	10357	125	0	\N
1112	115	273999976	21871	10800	12	0	\N
1113	115	33839441907992	18187	9170	6	0	\N
1114	115	66720000000000	6774	3506	2	0	\N
1117	115	66720020000000	6774	3506	3	0	\N
1118	115	67440001000000	12129	6247	1	0	\N
1119	115	67440002000000	12129	6247	2	0	\N
1120	121	66720000000000	9954	5168	1	0	\N
1121	121	66720010000000	9954	5168	2	0	\N
1123	132	66721000000000	29126	14235	63	0	\N
1124	132	66721369000000	29126	14235	64	0	\N
1126	149	66000004010000	19710	9924	4	1	\N
1129	149	67440010000000	384	218	1	0	\N
1131	149	67440020000000	384	218	2	0	\N
1139	149	69149587000341	10234	5296	3	0	\N
1140	149	69149587000341	10301	5329	3	0	\N
1141	149	69149587000341	10400	5376	2	0	\N
1143	149	69149607000341	10400	5376	3	0	\N
1144	149	69149617000341	10301	5329	4	0	\N
1146	149	69149707000341	10234	5296	4	0	\N
1163	149	71760120000000	4125	2144	1	0	\N
1164	149	71760120000000	4551	2115	0	0	\N
1165	149	71760120000000	4552	2132	0	0	\N
1167	149	71760130000000	4125	2144	2	0	\N
1169	149	71855252000341	22441	11231	2	0	\N
1170	149	71855252000341	22442	11231	3	0	\N
1172	149	71855263000341	22441	11231	3	0	\N
1173	149	71855264000341	22442	11231	4	0	\N
1177	149	72480130000000	4819	2496	1	0	\N
1179	149	72480140000000	4819	2496	2	0	\N
1181	149	72575264000341	22747	11376	3	0	\N
1183	149	72575276000341	22747	11376	4	0	\N
1187	149	73200140000000	5555	2889	0	0	\N
1188	149	73200140000000	5843	3031	3	0	\N
1191	149	73200170000000	5843	3031	4	0	\N
1200	149	74190042000341	12333	6356	1	0	\N
1201	149	74190042000341	12350	6367	2	0	\N
1203	149	74190043000341	12333	6356	2	0	\N
1204	149	74190044000341	12350	6367	3	0	\N
1208	149	74735311000341	23534	11731	3	0	\N
1209	149	74735311000341	23601	11759	14	0	\N
1211	149	74735323000341	23534	11731	4	0	\N
1213	149	74735397000341	23601	11759	15	0	\N
1214	149	74910053000341	12814	6607	3	0	\N
1217	149	74910083000341	12814	6607	4	0	\N
1130	149	67440010000000	438	248	1	0	0
1132	149	67440020000000	438	248	2	0	0
1133	149	68160020000000	577	325	3	0	0
1134	149	68160050000000	577	325	4	0	0
1137	149	68880050000000	2166	1143	1	0	0
1147	149	69600060000000	2206	1161	1	0	0
1148	149	69600070000000	2206	1161	2	0	0
1151	149	70320070000000	2395	1252	4	0	0
1152	149	70320110000000	2395	1252	5	0	0
1157	149	71040110000000	3366	1751	1	0	0
1166	149	71760120000000	4692	2426	1	0	0
1168	149	71760130000000	4692	2426	2	0	0
1178	149	72480130000000	5131	2660	1	0	0
1180	149	72480140000000	5131	2660	2	0	0
1190	149	73200160000000	7050	3639	3	0	0
1196	149	73920160000000	7259	3755	1	0	0
1197	149	73920170000000	7259	3755	2	0	0
1206	149	74640170000000	7647	3957	1	0	0
1207	149	74640180000000	7647	3957	2	0	0
1219	149	75360195000000	8289	4293	3	0	0
1224	149	76080195000000	8447	4376	1	0	0
1135	149	68429537000341	10190	5277	5	0	4
1136	149	68429587000341	10190	5277	6	0	4
1142	149	69149587000341	10410	5384	5	0	4
1125	145	66000010000000	10455	5405	15	1	0
1149	149	69869637000341	10907	5626	5	0	4
1150	149	69870017000341	10907	5626	6	0	4
1155	149	70590017000341	11013	5670	1	0	4
1161	149	71310027000341	11440	5877	4	0	4
1162	149	71310049000341	11440	5877	5	0	4
1115	115	66720000000000	11809	6069	1	0	0
1116	115	66720001000000	11809	6069	2	0	0
1175	149	72030039000341	12105	6233	1	0	5
1185	149	72750040000341	12155	6260	1	0	5
1186	149	72750041000341	12155	6260	2	0	5
1194	149	73470041000341	12281	6321	1	0	5
1195	149	73470042000341	12281	6321	2	0	5
1202	149	74190042000341	12558	6471	2	0	5
1215	149	74910053000341	13023	6713	2	0	5
1216	149	74910064000341	13023	6713	3	0	5
1222	149	75630064000341	13046	6727	3	0	5
1223	149	75630076000341	13046	6727	4	0	5
1108	114	66722753000000	13762	7070	5	0	6
1089	111	69600064000000	19774	9957	4	0	0
1091	111	70320064000000	21198	10644	2	0	0
1093	111	70320075000000	21198	10644	3	0	0
1094	111	71040075000000	21313	10698	2	0	0
1153	149	70415228000341	21424	10744	3	0	10
1154	149	70415240000341	21424	10744	4	0	10
1159	149	71135240000341	21514	10793	3	0	10
1160	149	71135252000341	21514	10793	4	0	10
1097	111	71760077000000	22343	11184	7	0	0
1171	149	71855252000341	22677	11338	3	0	10
1174	149	71855264000341	22677	11338	4	0	10
1182	149	72575264000341	23095	11532	7	0	10
1184	149	72575289000341	23095	11532	8	0	10
1193	149	73295300000341	23237	11596	3	0	10
1198	149	74015300000341	23453	11695	2	0	10
1199	149	74015311000341	23453	11695	3	0	10
1210	149	74735311000341	24345	12107	3	0	10
1212	149	74735323000341	24345	12107	4	0	10
1221	149	75455335000341	24819	12324	4	0	10
1100	111	72480102000000	27144	13422	8	0	0
1101	111	72480137000000	27144	13422	9	0	0
1226	149	76175335000341	24857	12342	7	0	\N
1229	149	76175360000341	24857	12342	8	0	\N
1230	149	76350076000341	13684	7032	2	0	\N
1232	149	76350087000341	13684	7032	3	0	\N
1236	149	76800306000000	8939	4635	1	0	\N
1237	149	76895347000341	26202	12953	2	0	\N
1239	149	76895349000341	26202	12953	3	0	\N
1244	149	77520306000000	8939	4635	5	0	\N
1246	149	77520336000000	8939	4635	6	0	\N
1251	149	78240307000000	9338	4845	2	0	\N
1253	149	78240327000000	9338	4845	3	0	\N
1263	149	79230162000341	14215	7256	4	0	\N
1265	149	79230175000341	14215	7256	5	0	\N
1267	149	79680407000000	9863	5116	2	0	\N
1269	149	79680427000000	9863	5116	3	0	\N
1273	149	79950181000341	14391	7343	3	0	\N
1276	149	79950193000341	14391	7343	4	0	\N
1281	149	81215454000341	27669	13674	3	0	\N
1283	149	81215466000341	27669	13674	4	0	\N
1289	149	82110225000341	15772	8023	10	0	\N
1290	149	82110225000341	15789	8032	3	0	\N
1291	149	82110225000341	16084	8175	2	0	\N
1292	149	82110225000341	16154	8205	28	0	\N
1293	149	82110225000341	16244	8257	4	0	\N
1294	149	82110225000341	16723	8494	7	0	\N
1296	149	82110227000341	16084	8175	3	0	\N
1297	149	82110238000341	16244	8257	5	0	\N
1299	149	82110246000341	15789	8032	4	0	\N
1300	149	82110250000341	16723	8494	8	0	\N
1301	149	82110271000341	15772	8023	11	0	\N
1302	149	82110334000341	16154	8205	29	0	\N
1303	149	82655478000341	28311	13997	2	0	\N
1305	149	82655489000341	28311	13997	3	0	\N
1309	149	83375512000341	28793	14205	5	0	\N
1311	149	83375512000341	29693	14357	0	0	\N
1312	149	83375512000341	29700	14358	0	0	\N
1313	149	83375512000341	29701	14372	0	0	\N
1315	149	83375535000341	28793	14205	6	0	\N
1316	149	83550251000341	17775	8980	10	0	\N
1319	149	83550288000341	17775	8980	11	0	\N
1322	149	84270262000341	18309	9223	19	0	\N
1325	149	84270722000341	18309	9223	20	0	\N
1326	149	84815535000341	29532	14563	4	0	\N
1327	149	84815535000341	29699	14647	6	0	\N
1328	149	84815548000341	29532	14563	5	0	\N
1329	149	84815550000341	29699	14647	7	0	\N
1330	149	84990283000340	19710	9924	3	0	\N
1331	149	84990283000341	19626	9885	13	0	\N
1332	149	84990283000341	19711	9924	3	0	\N
1333	149	84990283000341	19783	9962	3	0	\N
1335	149	84990295000341	19711	9924	4	0	\N
1336	149	84990295000341	19783	9962	4	0	\N
1337	149	84990332000341	19626	9885	14	0	\N
1339	149	85710601000341	20324	10236	4	0	\N
1341	149	85710614000341	20324	10236	5	0	\N
1343	149	86430614000341	20341	10237	38	0	\N
1345	149	86430616000341	20504	10321	0	0	\N
1346	149	86430616000341	20506	10323	0	0	\N
1348	149	86430751000341	20341	10237	39	0	\N
1349	152	66000010000000	5041	2615	1	0	\N
1350	152	66000020000000	5041	2615	2	0	\N
1353	152	66000110100000	29756	14666	21	1	\N
1356	152	66000110400000	29930	14727	98	1	\N
1358	152	66000110400000	30126	14825	21	1	\N
1359	152	66000110800000	30207	14832	123	1	\N
1360	152	66000112100000	30001	14734	124	0	\N
1235	149	76800296000000	8448	4377	2	0	0
1243	149	77520296000000	9085	4711	2	0	0
1245	149	77520307000000	9085	4711	3	0	0
1252	149	78240307000000	9668	5018	2	0	0
1254	149	78240327000000	9668	5018	3	0	0
1260	149	78960407000000	9789	5074	9	0	0
1268	149	79680407000000	10029	5203	4	0	0
1270	149	79680447000000	10029	5203	5	0	0
1231	149	76350076000341	13697	7037	2	0	5
1233	149	76350087000341	13697	7037	3	0	5
1242	149	77070110000341	13810	7091	6	0	5
1249	149	77790110000341	13932	7141	11	0	5
1250	149	77790148000341	13932	7141	12	0	5
1257	149	78510148000341	14011	7181	5	0	5
1352	152	66000110000000	14257	7279	5	0	0
1264	149	79230162000341	14278	7289	10	0	5
1266	149	79230181000341	14278	7289	11	0	5
1274	149	79950181000341	14531	7411	2	0	5
1275	149	79950192000341	14531	7411	3	0	5
1280	149	80670203000341	14821	7554	3	0	5
1285	149	81390203000341	15539	7909	4	0	5
1286	149	81390225000341	15539	7909	5	0	5
1295	149	82110225000341	16768	8511	4	0	5
1298	149	82110238000341	16768	8511	5	0	5
1308	149	82830251000341	17071	8647	5	0	5
1317	149	83550251000341	18026	9094	2	0	5
1318	149	83550262000341	18026	9094	3	0	5
1323	149	84270262000341	18685	9413	3	0	5
1334	149	84990283000341	20087	10111	39	0	5
1338	149	84990601000341	20087	10111	40	0	5
1340	149	85710601000341	20339	10244	6	0	5
1342	149	85710616000341	20339	10244	7	0	5
1344	149	86430616000341	20503	10324	3	0	5
1227	149	76175335000341	24885	12355	3	0	10
1228	149	76175347000341	24885	12355	4	0	10
1238	149	76895347000341	26288	13002	7	0	10
1240	149	76895381000341	26288	13002	8	0	10
1247	149	77615381000341	26388	13052	7	0	10
1255	149	78335406000341	26573	13148	4	0	10
1256	149	78335419000341	26573	13148	5	0	10
1261	149	79055419000341	27292	13489	2	0	10
1262	149	79055430000341	27292	13489	3	0	10
1272	149	79775442000341	27339	13516	4	0	10
1277	149	80495442000341	27613	13647	3	0	10
1278	149	80495454000341	27613	13647	4	0	10
1282	149	81215454000341	27875	13781	3	0	10
1284	149	81215466000341	27875	13781	4	0	10
1288	149	81935478000341	27900	13795	4	0	10
1304	149	82655478000341	28653	14147	7	0	10
1306	149	82655512000341	28653	14147	8	0	10
1310	149	83375512000341	29176	14384	2	0	10
1314	149	83375523000341	29176	14384	3	0	10
1321	149	84095535000341	29277	14428	4	0	10
1354	152	66000110200000	29818	14692	13	0	0
1355	152	66000110300000	29837	14703	10	1	0
1357	152	66000110400000	30125	14825	21	1	0
1361	152	66000112400000	30223	14735	52	0	\N
1364	162	67440010000000	8149	4205	2	0	\N
1365	162	67440010000000	8151	4225	4	0	\N
1366	162	67440010000000	12887	6644	2	0	\N
1367	162	67440010000000	12891	6644	2	0	\N
1369	162	67440021000000	12887	6644	3	0	\N
1370	162	67440021000000	12891	6644	3	0	\N
1372	162	67440111000000	8149	4205	3	0	\N
1373	162	67440140000000	8151	4225	5	0	\N
1374	162	68160022000000	20687	10404	3	0	\N
1375	162	68160022000000	25634	12687	12	0	\N
1376	162	68160034000000	20687	10404	4	0	\N
1377	162	68160070000000	25634	12687	13	0	\N
1378	167	9307365500000	17740	8966	9	0	\N
1379	167	15121469500000	18006	9083	7	0	\N
1384	167	82180967500000	19349	9656	23	1	\N
1385	167	139687624499992	20162	10084	126	0	\N
1386	171	1434959020000	14652	7467	4	0	\N
1387	171	66000000001050	4306	1996	127	0	\N
1388	171	66720000000000	268	156	1	0	\N
1390	171	66720010000000	268	156	2	0	\N
1396	171	68150240524688	10228	5293	1	0	\N
1397	171	68150240524688	10484	5419	9	0	\N
1399	171	68150250524688	10228	5293	2	0	\N
1401	171	68150330524688	10484	5419	10	0	\N
1402	171	68160020000000	1063	588	3	0	\N
1404	171	68160050000000	1063	588	4	0	\N
1408	171	68870260524688	11184	5743	4	0	\N
1411	171	68870300524688	11184	5743	5	0	\N
1418	171	69600060000000	1570	855	1	0	\N
1419	171	69600060000000	1574	857	1	0	\N
1420	171	69600060000000	1761	942	1	0	\N
1421	171	69600060000000	1878	998	1	0	\N
1423	171	69600070000000	1570	855	2	0	\N
1424	171	69600070000000	1574	857	2	0	\N
1425	171	69600070000000	1761	942	2	0	\N
1426	171	69600070000000	1878	998	2	0	\N
1436	171	71030274524688	11936	6143	1	0	\N
1437	171	71030274524688	12009	6180	1	0	\N
1439	171	71030275524688	11936	6143	2	0	\N
1440	171	71030275524688	12009	6180	2	0	\N
1442	171	71040090000000	2434	1274	2	0	\N
1443	171	71040090000000	2471	1294	1	0	\N
1445	171	71040100000000	2471	1294	2	0	\N
1447	171	71040110000000	2434	1274	3	0	\N
1448	171	71706689696494	21858	10938	3	0	\N
1449	171	71706689696494	22295	11160	4	0	\N
1450	171	71706689696494	22464	11241	3	0	\N
1452	171	71706701696494	21858	10938	4	0	\N
1453	171	71706701696494	22464	11241	4	0	\N
1455	171	71706711696494	22295	11160	5	0	\N
1456	171	71750296524688	12740	6568	2	0	\N
1457	171	71750296524688	12841	6622	4	0	\N
1459	171	71750307524688	12740	6568	3	0	\N
1461	171	71750327524688	12841	6622	5	0	\N
1469	171	73146713696494	23002	11490	3	0	\N
1471	171	73146725696494	23002	11490	4	0	\N
1477	171	73866737696494	23387	11570	4	0	\N
1478	171	73866737696494	24082	11987	2	0	\N
1480	171	73866748696494	24082	11987	3	0	\N
1482	171	73866858696494	23387	11570	5	0	\N
1483	171	73866884696494	23499	11571	17	0	\N
1484	171	73910347624688	14652	7467	3	0	\N
1485	171	73910357524688	14924	7603	1	0	\N
1487	171	73910367524688	14924	7603	2	0	\N
1492	171	74586884596494	23499	11571	18	0	\N
1496	171	74640330000000	4306	1996	2	0	\N
1394	171	67440010000000	1020	565	1	0	0
1395	171	67440020000000	1020	565	2	0	0
1403	171	68160020000000	1413	770	3	0	0
1405	171	68160050000000	1413	770	4	0	0
1412	171	68880050000000	1558	848	1	0	0
1362	162	66720000000000	2009	1061	1	0	0
1363	162	66720010000000	2009	1061	2	0	0
1422	171	69600060000000	2145	1132	1	0	0
1427	171	69600070000000	2145	1132	2	0	0
1432	171	70320070000000	2371	1238	2	0	0
1444	171	71040090000000	2809	1468	1	0	0
1446	171	71040100000000	2809	1468	2	0	0
1462	171	71760100000000	2832	1480	2	0	0
1463	171	71760120000000	2832	1480	3	0	0
1475	171	73200120000000	3414	1775	1	0	0
1476	171	73200130000000	3414	1775	2	0	0
1489	171	73920130000000	3458	1795	0	0	0
1495	171	74640130000000	3626	1880	0	0	0
1392	171	67430220524688	10205	5285	2	0	4
1398	171	68150240524688	10702	5525	2	0	4
1400	171	68150260524688	10702	5525	3	0	4
1409	171	68870260524688	11463	5891	2	0	4
1410	171	68870271524688	11463	5891	3	0	4
1416	171	69590271524688	11784	6057	1	0	4
1430	171	70310272524688	11801	6065	2	0	4
1431	171	70310274524688	11801	6065	3	0	4
1438	171	71030274524688	12709	6554	4	0	4
1441	171	71030296524688	12709	6554	5	0	4
1460	171	71750308524688	13103	6753	4	0	4
1466	171	72470308524688	13749	7064	7	0	4
1467	171	72470333524688	13749	7064	8	0	4
1473	171	73190333524688	14385	7340	6	0	4
1474	171	73190357524688	14385	7340	7	0	4
1371	162	67440022000000	14395	7346	4	0	0
1380	167	66000000000200	14679	7478	26	1	0
1486	171	73910357524688	14931	7608	1	0	4
1488	171	73910367524688	14931	7608	2	0	4
1493	171	74630367524688	14947	7614	2	0	4
1381	167	66000000100200	17501	8860	8	1	0
1382	167	66000000600200	17747	8967	7	0	0
1383	167	66000001100200	19865	10007	5	0	0
1406	171	68826633696494	20704	10412	3	0	8
1414	171	69546645696494	21035	10572	2	0	8
1415	171	69546656696494	21035	10572	3	0	8
1428	171	70266656696494	21097	10596	4	0	8
1429	171	70266678696494	21097	10596	5	0	8
1434	171	70986678696494	21784	10906	2	0	8
1451	171	71706689696494	22470	11243	3	0	8
1454	171	71706701696494	22470	11243	4	0	8
1464	171	72426701696494	22837	11420	3	0	8
1465	171	72426713696494	22837	11420	4	0	8
1470	171	73146713696494	23068	11517	6	0	8
1479	171	73866737696494	24177	12034	2	0	8
1481	171	73866748696494	24177	12034	3	0	8
1490	171	74586748696494	24400	12132	3	0	8
1491	171	74586760696494	24400	12132	4	0	8
1497	171	75306760696494	24668	12252	3	0	\N
1498	171	75306760696494	24975	12394	8	0	\N
1499	171	75306760696494	24977	12395	3	0	\N
1501	171	75306772696494	24668	12252	4	0	\N
1502	171	75306772696494	24977	12395	4	0	\N
1504	171	75306786696494	24975	12394	9	0	\N
1505	171	75306884596494	23779	11572	0	0	\N
1506	171	75350378524688	15010	7646	2	0	\N
1508	171	75350378524688	15382	7623	0	0	\N
1509	171	75350378524688	15384	7639	0	0	\N
1511	171	75350389524688	15010	7646	3	0	\N
1512	171	75350988524688	15862	7978	42	0	\N
1514	171	75360330000000	4306	1996	126	0	\N
1515	171	75362389999990	4347	1997	2	0	\N
1516	171	76026772696494	25262	12531	4	0	\N
1517	171	76026772696494	25396	12587	7	0	\N
1518	171	76026772696494	25863	12785	8	0	\N
1519	171	76026772696494	25961	12828	2	0	\N
1520	171	76026772696494	26087	12892	2	0	\N
1522	171	76026783696494	25961	12828	3	0	\N
1523	171	76026783696494	26087	12892	3	0	\N
1525	171	76026785696494	25262	12531	5	0	\N
1526	171	76026806696494	25396	12587	8	0	\N
1527	171	76026807696494	25863	12785	9	0	\N
1528	171	76070388524688	15156	7725	2	0	\N
1529	171	76070388524688	15386	7728	0	0	\N
1530	171	76070388524688	15390	7743	0	0	\N
1531	171	76070388524688	15493	7839	4	0	\N
1533	171	76070399524688	15156	7725	3	0	\N
1535	171	76070428524688	15493	7839	5	0	\N
1536	171	76070988524688	15862	7978	43	0	\N
1537	171	76080130000000	5724	2966	0	0	\N
1540	171	76082389999990	4347	1997	126	0	\N
1541	171	76083619999990	4347	1997	127	0	\N
1544	171	76747418696494	27150	13180	62	0	\N
1549	171	77466798696494	27897	13793	7	0	\N
1550	171	77466798696494	28825	14218	8	0	\N
1551	171	77466798696494	28918	14262	2	0	\N
1552	171	77466798696494	29174	14382	3	0	\N
1554	171	77466800696494	28918	14262	3	0	\N
1555	171	77466810696494	29174	14382	4	0	\N
1557	171	77466823696494	27897	13793	8	0	\N
1558	171	77466824696494	28825	14218	9	0	\N
1559	171	77467418696494	27150	13180	126	0	\N
1560	171	77468048696494	27150	13180	127	0	\N
1561	171	77468668696494	27180	13181	62	0	\N
1562	171	77510424524688	16384	8333	3	0	\N
1563	171	77510424524688	16825	8539	2	0	\N
1564	171	77510424524688	17177	8706	4	0	\N
1565	171	77510424524688	17266	8745	3	0	\N
1568	171	77510435524688	16825	8539	3	0	\N
1569	171	77510436524688	16384	8333	4	0	\N
1570	171	77510436524688	17266	8745	4	0	\N
1571	171	77510437524688	17177	8706	5	0	\N
1572	171	77520150000000	6481	3359	2	0	\N
1574	171	77520170000000	6481	3359	3	0	\N
1578	171	78188668696494	27180	13181	126	0	\N
1579	171	78189298696494	27180	13181	127	0	\N
1580	171	78230425524688	17515	8868	3	0	\N
1581	171	78230425524688	17552	8887	3	0	\N
1583	171	78230437524688	17515	8868	4	0	\N
1584	171	78230437524688	17552	8887	4	0	\N
1586	171	78240190000000	6796	3518	2	0	\N
1589	171	78240210000000	6796	3518	3	0	\N
1590	171	78906822696494	29445	14517	2	0	\N
1593	171	78906833696494	29445	14517	3	0	\N
1596	171	78960200000000	7905	4094	2	0	\N
1598	171	78960211000000	7905	4094	3	0	\N
1601	171	79680200000000	8488	4396	1	0	\N
1602	171	79680200000000	8802	4564	2	0	\N
1604	171	79680210000000	8488	4396	2	0	\N
1605	171	79680220000000	8802	4564	3	0	\N
1609	171	80400240000000	9033	4683	3	0	\N
1612	171	80400270000000	9033	4683	4	0	\N
1613	171	81110501524688	18743	9444	4	0	\N
1615	171	81110514524688	18743	9444	5	0	\N
1619	171	81830532524688	19546	9845	10	0	\N
1620	171	81830532524688	19590	9866	3	0	\N
1621	171	81830532524688	20038	10087	5	0	\N
1623	171	81830544524688	19590	9866	4	0	\N
1625	171	81830569524688	19546	9845	11	0	\N
1626	171	81830754524688	20038	10087	6	0	\N
1627	171	81840270000000	9749	5050	1	0	\N
1628	171	81840270000000	9778	5066	4	0	\N
1629	171	81840280000000	9749	5050	2	0	\N
1630	171	81840310000000	9778	5066	5	0	\N
1631	176	66000100000000	19438	9605	0	0	\N
1539	171	76080140000000	6282	3253	2	0	0
1547	171	76800140000000	6470	3353	1	0	0
1548	171	76800150000000	6470	3353	2	0	0
1573	171	77520150000000	6676	3450	4	0	0
1575	171	77520190000000	6676	3450	5	0	0
1588	171	78240200000000	7695	3987	2	0	0
1597	171	78960200000000	8418	4361	0	0	0
1603	171	79680200000000	8899	4610	4	0	0
1606	171	79680240000000	8899	4610	5	0	0
1610	171	80400240000000	9203	4771	2	0	0
1617	171	81120260000000	9231	4784	1	0	0
1618	171	81120270000000	9231	4784	2	0	0
1507	171	75350378524688	15137	7716	1	0	4
1510	171	75350388524688	15137	7716	2	0	4
1534	171	76070400524688	16018	8144	4	0	4
1545	171	76790400524688	16119	8194	6	0	4
1546	171	76790424524688	16119	8194	7	0	4
1566	171	77510424524688	17334	8781	1	0	4
1567	171	77510425524688	17334	8781	2	0	4
1585	171	78230437524688	17831	9004	4	0	4
1594	171	78950437524688	17891	9028	6	0	4
1595	171	78950452524688	17891	9028	7	0	4
1599	171	79670452524688	17966	9062	10	0	4
1600	171	79670489524688	17966	9062	11	0	4
1608	171	80390501524688	18121	9138	4	0	4
1614	171	81110501524688	19110	9640	3	0	4
1616	171	81110532524688	19110	9640	4	0	4
1622	171	81830532524688	20514	10327	3	0	4
1632	176	66720000000000	24494	12181	3	0	0
1500	171	75306760696494	25048	12428	3	0	8
1503	171	75306772696494	25048	12428	4	0	8
1521	171	76026772696494	26092	12894	2	0	8
1524	171	76026783696494	26092	12894	3	0	8
1543	171	76746798696494	26261	12985	7	0	8
1553	171	77466798696494	29232	14405	3	0	8
1556	171	77466810696494	29232	14405	4	0	8
1576	171	78186810696494	29257	14419	3	0	8
1577	171	78186822696494	29257	14419	4	0	8
1592	171	78906831696494	29656	14626	10	0	8
1636	189	66720100000000	10592	5470	4	0	\N
1637	189	66720140000000	10592	5470	5	0	\N
1638	212	201000000	18192	9170	6	1	\N
1639	212	6373527610000	19679	9912	10	0	\N
1640	212	13678839652984	18249	9193	3	0	\N
1641	212	66000000210000	16812	8533	12	0	\N
1644	212	84990294990340	19710	9924	4	0	\N
1645	212	85324171870000	20130	10133	8	1	\N
1650	235	66720000000000	8809	4567	1	0	\N
1651	235	66720010000000	8809	4567	2	0	\N
1657	238	66000410000000	9291	4683	16	0	\N
1658	238	66001520000000	16586	8277	63	0	\N
1660	238	66720170000000	11045	5683	2	0	\N
1663	238	66720190000000	11045	5683	3	0	\N
1665	238	66720200000000	3537	1835	0	0	\N
1666	238	66720410000000	9291	4683	126	0	\N
1667	238	66721500000000	9291	4683	127	0	\N
1668	238	66721520000000	16586	8277	126	0	\N
1669	238	66722140000000	16586	8277	127	0	\N
1676	243	68880050000000	8881	4600	4	0	\N
1677	243	68880050000000	19810	9976	3	0	\N
1678	243	68880062000000	19810	9976	4	0	\N
1679	243	68880090000000	8881	4600	5	0	\N
1680	247	66720000000000	21124	10610	3	0	\N
1681	247	66720012000000	21124	10610	4	0	\N
1682	248	14400518990000	17975	9065	9	0	\N
1684	248	66000001500000	16812	8533	12	1	\N
1685	255	66001000000000	8781	4555	5	0	\N
1686	255	66001000000000	14019	7185	0	0	\N
1688	262	66000200000000	2912	1465	52	0	\N
1689	262	66000200000000	5725	2815	0	0	\N
1690	263	66720000000000	18491	9313	3	0	\N
1691	263	66720012000000	18491	9313	4	0	\N
1692	289	1434963970000	20646	10357	124	0	\N
1693	289	10033146851140	13466	6753	77	0	\N
1694	289	20160499000000	9197	4570	126	0	\N
1695	289	23362267894000	19419	9550	4	1	\N
1696	289	66010000000000	14856	7571	4	0	\N
1697	298	66720000000000	198	117	1	0	\N
1698	298	66720000000000	300	173	1	0	\N
1700	298	66720010000000	198	117	2	0	\N
1701	298	66720010000000	300	173	2	0	\N
1707	298	68879430000000	1134	627	2	0	\N
1708	298	68879430000000	1160	639	1	0	\N
1710	298	68879440000000	1160	639	2	0	\N
1712	298	68879450000000	1134	627	3	0	\N
1715	298	70319450000000	1616	873	1	0	\N
1717	298	70319460000000	1616	873	2	0	\N
1721	300	66720000000000	12567	6476	2	0	\N
1723	300	66720011000000	12567	6476	3	0	\N
1725	301	66720490000000	10372	5363	2	0	\N
1726	301	66720490000000	10373	5363	1	0	\N
1727	301	66720490000000	10374	5363	2	0	\N
1730	301	66720500000000	10373	5363	2	0	\N
1731	301	66720510000000	10372	5363	3	0	\N
1732	301	66720510000000	10374	5363	3	0	\N
1733	302	66720000000000	19158	9664	3	0	\N
1734	302	66720000000000	26238	12972	3	0	\N
1735	302	66720012000000	19158	9664	4	0	\N
1736	302	66720012000000	26238	12972	4	0	\N
1738	303	66720000000000	8410	4358	1	0	\N
1648	228	66000010000000	6767	3503	0	0	0
1739	303	66720010000000	8410	4358	2	0	\N
1742	303	67440026000000	29267	14425	6	0	\N
1743	303	67440026000000	29268	14425	4	0	\N
1744	303	67440048000000	29268	14425	5	0	\N
1745	303	67440050000000	29267	14425	7	0	\N
1746	311	66000000000010	2032	1072	3	0	\N
1751	311	68160040000000	302	173	1	0	\N
1753	311	68160050000000	302	173	2	0	\N
1761	311	71040090000000	1230	679	2	0	\N
1762	311	71040090000000	1273	702	1	0	\N
1764	311	71040100000000	1273	702	2	0	\N
1766	311	71040110000000	1230	679	3	0	\N
1767	311	71760100000000	1533	839	1	0	\N
1749	311	67440010000000	85	52	3	0	0
1750	311	67440040000000	85	52	4	0	0
1752	311	68160040000000	423	241	1	0	0
1754	311	68160050000000	423	241	2	0	0
1699	298	66720000000000	649	364	1	0	0
1755	311	68880050000000	688	384	2	0	0
1756	311	68880070000000	688	384	3	0	0
1703	298	67440010000000	690	385	1	0	0
1704	298	67440020000000	690	385	2	0	0
1757	311	69600070000000	921	512	1	0	0
1705	298	68159420000000	985	546	1	0	2
1706	298	68159430000000	985	546	2	0	2
1670	243	66720000000000	1045	580	1	0	0
1671	243	66720010000000	1045	580	2	0	0
1760	311	70320090000000	1183	653	2	0	0
1709	298	68879430000000	1305	720	1	0	2
1711	298	68879440000000	1305	720	2	0	2
1763	311	71040090000000	1361	746	1	0	0
1765	311	71040100000000	1361	746	2	0	0
1713	298	69599440000000	1548	844	1	0	2
1714	298	69599450000000	1548	844	2	0	2
1716	298	70319450000000	1716	922	1	0	2
1718	298	70319460000000	1716	922	2	0	2
1719	298	71039460000000	2120	1118	1	0	2
1672	243	67440010000000	5947	3082	2	0	0
1673	243	67440030000000	5947	3082	3	0	0
1674	243	68160030000000	8006	4148	2	0	0
1675	243	68160050000000	8006	4148	3	0	0
1652	235	66720030000000	8808	4567	4	0	0
1653	235	67440030000000	9153	4742	2	0	0
1654	235	67440050000000	9153	4742	3	0	0
1659	238	66720160000000	9290	4818	2	0	2
1662	238	66720180000000	9290	4818	3	0	2
1729	301	66720491000000	12213	6291	2	0	1
1737	303	66000024000000	13112	6757	6	0	0
1740	303	66720024000000	13112	6757	9	0	0
1741	303	66720026000000	13112	6757	10	0	0
1661	238	66720170000000	16585	8428	8	0	3
1683	248	66000000070000	16813	8533	12	0	0
1642	212	66000004000000	17188	8710	10	0	0
1655	235	68160050000000	18921	9545	1	0	0
1656	235	68160060000000	18921	9545	2	0	0
1722	300	66720000000000	21522	10797	3	0	0
1724	300	66720012000000	21522	10797	4	0	0
1633	176	66720012000000	24494	12181	4	0	0
1634	188	66720900000000	28235	13960	2	0	1
1635	188	66720911000000	28235	13960	3	0	1
1647	216	66720017000000	30158	14839	9	0	0
1769	311	71760110000000	1533	839	2	0	\N
1777	311	73920130000000	2032	1072	2	0	\N
1778	311	73920130000000	2033	1072	2	0	\N
1779	311	73920150000000	2033	1072	3	0	\N
1780	311	74640050000000	2200	1159	1	0	\N
1781	311	74640050000000	2283	1197	1	0	\N
1783	311	74640060000000	2200	1159	2	0	\N
1784	311	74640060000000	2283	1197	2	0	\N
1785	317	66000325000000	2760	1231	121	0	\N
1786	317	66720000000000	6531	3385	2	0	\N
1787	317	66720020000000	6531	3385	3	0	\N
1788	326	66720000000000	21559	10810	3	0	\N
1790	326	66720012000000	21559	10810	4	0	\N
1794	327	66720000000000	1704	916	1	0	\N
1795	327	66720000000000	3897	2023	1	0	\N
1796	327	66720010000000	1704	916	2	0	\N
1797	327	66720010000000	3897	2023	2	0	\N
1798	329	200000100	16514	8400	5	1	\N
1799	329	200000500	16512	8400	5	1	\N
1800	329	901501000	2911	1518	6	0	\N
1801	329	66000510000000	2912	1465	51	0	\N
1804	329	66719999500000	2910	1518	0	0	\N
1805	329	66719999999500	2911	1518	5	0	\N
1806	329	66720000000000	2914	1518	5	0	\N
1807	329	66720050000000	2914	1518	6	0	\N
1808	329	66720410000000	2912	1465	52	0	\N
1811	329	67444609999900	16512	8400	4	0	\N
1812	329	67444610000000	16514	8400	4	0	\N
1813	329	67444610000000	16515	8400	4	0	\N
1814	329	67444610000000	17067	8541	5	0	\N
1817	329	67444623000000	16515	8400	5	0	\N
1818	329	67444660000000	17067	8541	6	0	\N
1819	329	68164612000000	23037	11502	10	0	\N
1820	329	68164649000000	23037	11502	11	0	\N
1829	337	68880043000000	19873	10010	2	0	\N
1830	337	68880054000000	19873	10010	3	0	\N
1832	338	66720000000000	17573	8883	37	0	\N
1834	338	66720154000000	17573	8883	38	0	\N
1836	338	67440014000000	25677	12706	3	0	\N
1837	338	67440014000000	25678	12706	4	0	\N
1839	338	67440026000000	25677	12706	4	0	\N
1840	338	67440027000000	25678	12706	5	0	\N
1841	340	66720000000000	19103	9634	6	0	\N
1842	340	66720024000000	19103	9634	7	0	\N
1843	341	155000000	12263	6036	17	1	\N
1844	341	7819515899991	12838	6620	2	1	\N
1845	341	11674511943000	14361	7330	5	1	\N
1846	341	66000000000001	9045	4429	3	0	\N
1848	341	66001000000002	11879	6105	3	0	\N
1849	341	66001000000002	11882	6106	4	0	\N
1850	341	66001028000001	30114	14820	11	0	\N
1851	341	66720000000000	762	369	6	0	\N
1852	341	66720000000000	763	424	1	0	\N
1853	341	66720010000000	763	424	2	0	\N
1854	341	66720720000000	762	369	7	0	\N
1855	341	66720990000001	27466	13574	8	0	\N
1856	341	66721000000001	14361	7330	4	0	\N
1857	341	66721000000001	14363	7330	4	0	\N
1858	341	66721007000001	27466	13574	9	0	\N
1859	341	66721013000001	14363	7330	5	0	\N
1860	341	66721028000001	30114	14820	27	0	\N
1861	341	66721042999001	30114	14820	28	1	\N
1862	344	66720000000000	261	152	1	0	\N
1863	344	66720000000000	6749	3493	4	0	\N
1864	344	66720010000000	261	152	2	0	\N
1865	344	66720040000000	6749	3493	5	0	\N
1868	349	200000001	8626	4336	127	1	\N
1871	349	66720290000000	8626	4336	9	0	\N
1872	349	67440010000000	8624	4471	1	0	\N
1874	349	67440020000000	8624	4471	2	0	\N
1876	349	67440035000000	17701	8947	4	0	\N
1877	349	67440290000000	8626	4336	124	0	\N
1878	349	68160030000000	19119	9645	2	0	\N
1879	349	68160041000000	19119	9645	3	0	\N
1880	350	66000012000000	19860	10005	3	0	\N
1881	350	66720000000000	7156	3697	1	0	\N
1882	350	66720010000000	7156	3697	2	0	\N
1883	350	66720012000000	19860	10005	6	0	\N
1884	350	66720014000000	19860	10005	7	0	\N
1895	363	68160050000000	7410	3830	2	0	\N
1896	363	68160070000000	7410	3830	3	0	\N
1899	364	67440012000000	21013	10565	3	0	\N
1900	364	67440012000000	27039	13360	4	0	\N
1901	364	67440012000000	27042	13370	5	0	\N
1902	364	67440016000000	27039	13360	5	0	\N
1903	364	67440024000000	21013	10565	4	0	\N
1904	364	67440026000000	27042	13370	6	0	\N
1770	311	71760110000000	1538	841	2	0	0
1771	311	72480110000000	1764	945	1	0	0
1772	311	72480120000000	1764	945	2	0	0
1773	311	73200120000000	1999	1057	1	0	0
1774	311	73200130000000	1999	1057	2	0	0
1776	311	73920050000000	2034	1072	3	0	0
1821	336	66720000000000	2080	1098	1	0	0
1822	336	66720010000000	2080	1098	2	0	0
1782	311	74640050000000	2284	1197	0	0	0
1823	337	66720000000000	2342	1224	2	0	0
1802	329	66719850000000	2913	1518	5	0	0
1803	329	66719900000000	2913	1518	6	0	0
1869	349	66720000000000	3154	1640	1	0	0
1870	349	66720010000000	3154	1640	2	0	0
1894	363	67440050000000	6567	3400	3	0	0
1873	349	67440010000000	8625	4471	2	0	0
1875	349	67440030000000	8625	4471	3	0	0
1809	329	66724590000000	10130	5254	2	0	4
1810	329	66724610000000	10130	5254	3	0	4
1826	337	67440040000000	10303	5330	3	0	0
1885	360	66720000000000	12008	6180	1	0	0
1886	360	66720001000000	12008	6180	2	0	0
1815	329	67444610000000	17068	8645	3	0	4
1816	329	67444622000000	17068	8645	4	0	4
1833	338	66720024000000	17571	8893	7	0	0
1827	337	68160040000000	19485	9822	3	0	0
1828	337	68160043000000	19485	9822	4	0	0
1897	364	66720000000000	20808	10461	3	0	0
1887	360	67440001000000	21718	10879	3	0	0
1888	360	67440013000000	21718	10879	4	0	0
1889	362	66720000000000	23882	11887	7	0	0
1890	362	66720025000000	23882	11887	8	0	0
1789	326	66720000000000	23954	11918	6	0	0
1835	338	67440014000000	25676	12706	2	0	1
1838	338	67440025000000	25676	12706	3	0	1
1866	344	66720090000000	27829	13755	12	0	1
1867	344	66720138000000	27829	13755	13	0	1
1792	326	67440015000000	30148	14833	8	0	0
1907	366	66720000000000	7967	4128	0	0	\N
1910	369	66000000000020	2703	1289	127	1	\N
1911	369	66000000030000	12261	6241	127	0	\N
1916	369	68160070000000	160	96	2	0	\N
1917	369	68160070000000	263	153	1	0	\N
1919	369	68160080000000	263	153	2	0	\N
1920	369	68160090000000	160	96	3	0	\N
1921	369	68880070000000	425	242	1	0	\N
1922	369	68880070000000	1138	629	1	0	\N
1924	369	68880080000000	425	242	2	0	\N
1925	369	68880080000000	1138	629	2	0	\N
1927	369	69600070000000	1552	846	0	0	\N
1928	369	69600080000000	1553	846	3	0	\N
1929	369	69600080000000	1556	846	3	0	\N
1932	369	69600110000000	1553	846	4	0	\N
1933	369	69600110000000	1556	846	4	0	\N
1934	369	70320090000000	1629	879	1	0	\N
1935	369	70320090000000	1784	955	1	0	\N
1937	369	70320090000000	2211	1161	1	0	\N
1938	369	70320100000000	1629	879	2	0	\N
1939	369	70320100000000	1784	955	2	0	\N
1940	369	70320100000000	2211	1161	2	0	\N
1942	369	71040110000000	2227	1174	1	0	\N
1944	369	71040120000000	2227	1174	2	0	\N
1946	369	71040520000000	2703	1289	28	0	\N
1947	369	71760120000000	2701	1419	1	0	\N
1948	369	71760120000000	2725	1431	2	0	\N
1949	369	71760120000000	2833	1480	3	0	\N
1951	369	71760130000000	2701	1419	2	0	\N
1953	369	71760140000000	2725	1431	3	0	\N
1954	369	71760150000000	2833	1480	4	0	\N
1955	369	71760520000000	2703	1289	126	0	\N
1956	369	71761769999980	2728	1290	28	0	\N
1960	369	72276365190850	22291	11157	3	0	\N
1961	369	72480130000000	3157	1641	1	0	\N
1963	369	72480140000000	3157	1641	2	0	\N
1965	369	72481769999980	2728	1290	93	0	\N
1966	369	72482409999980	2728	1290	94	0	\N
1968	369	72996365190850	22291	11157	8	0	\N
1970	369	72996369190850	22291	11157	9	0	\N
1972	369	73716365290830	22409	11217	3	0	\N
1973	369	73716365290830	22423	11223	7	0	\N
1975	369	73716377290830	22409	11217	4	0	\N
1976	369	73716390290830	22423	11223	8	0	\N
1982	369	74640150000000	3849	1999	2	0	\N
1984	369	74640170000000	3849	1999	3	0	\N
1986	369	75156464290830	23567	11745	6	0	\N
1987	369	75156464290830	23574	11748	4	0	\N
1989	369	75156477290830	23574	11748	5	0	\N
1991	369	75156488290830	23567	11745	7	0	\N
1994	369	75876477290830	23738	11824	6	0	\N
1995	369	75876477290830	23739	11824	4	0	\N
1997	369	75876490290830	23739	11824	5	0	\N
1998	369	75876492290830	23738	11824	7	0	\N
2000	369	76080190000000	4135	2151	1	0	\N
2002	369	76080200000000	4135	2151	2	0	\N
2004	369	76081970000000	4407	2212	122	0	\N
2007	369	76800210000000	4253	2207	2	0	\N
2009	369	76800230000000	4253	2207	3	0	\N
2011	369	76801970000000	4407	2212	126	0	\N
2012	369	76802000000000	4407	2212	127	0	\N
2013	369	77316549290830	25016	12412	2	0	\N
2014	369	77316549290830	25094	12456	3	0	\N
2016	369	77316560290830	25016	12412	3	0	\N
2017	369	77316561290830	25094	12456	4	0	\N
2019	369	77520300000000	4446	2304	2	0	\N
2022	369	77520311000000	4446	2304	3	0	\N
2023	369	77522000000000	4449	2213	24	0	\N
2024	369	77523050000000	4449	2213	25	0	\N
2029	369	78612155412810	20534	10336	5	0	\N
2031	369	78612207412810	20534	10336	6	0	\N
2034	369	78756575290830	26070	12884	6	0	\N
2035	369	78756608290830	26070	12884	7	0	\N
2039	369	79332267412810	20589	10357	4	0	\N
2040	369	79332267412810	20840	10474	3	0	\N
1914	369	67440030000000	116	69	4	0	0
1915	369	67440070000000	116	69	5	0	0
1918	369	68160070000000	264	153	0	0	0
1923	369	68880070000000	1528	837	1	0	0
1926	369	68880080000000	1528	837	2	0	0
1931	369	69600090000000	1590	864	2	0	0
1936	369	70320090000000	2210	1163	2	0	0
1941	369	70320110000000	2210	1163	3	0	0
1943	369	71040110000000	2380	1246	1	0	0
1945	369	71040120000000	2380	1246	2	0	0
1952	369	71760130000000	2834	1481	2	0	0
1962	369	72480130000000	3399	1768	1	0	0
1964	369	72480140000000	3399	1768	2	0	0
1971	369	73200140000000	3634	1884	0	0	0
1979	369	73920150000000	3689	1916	2	0	0
1983	369	74640150000000	3906	2029	2	0	0
1985	369	74640170000000	3906	2029	3	0	0
1992	369	75360170000000	4021	2086	2	0	0
1993	369	75360190000000	4021	2086	3	0	0
2003	369	76080210000000	4178	2175	3	0	0
2008	369	76800210000000	4406	2283	9	0	0
2010	369	76800300000000	4406	2283	10	0	0
2020	369	77520300000000	4598	2378	1	0	0
2021	369	77520310000000	4598	2378	2	0	0
2028	369	78240320000000	4952	2565	2	0	0
2037	369	78960320000000	5194	2701	1	0	0
2038	369	78960330000000	5194	2701	2	0	0
1905	365	66720000000000	11820	6074	1	0	0
2030	369	78612155412810	20576	10353	4	0	15
2032	369	78612267412810	20576	10353	5	0	15
1957	369	72276064190850	22196	11110	10	0	16
1958	369	72276344190850	22196	11110	11	0	16
1959	369	72276365190850	22289	11157	3	0	16
1969	369	72996365290830	22289	11157	10	1	16
1974	369	73716365290830	22480	11248	8	0	16
1977	369	73716427290830	22480	11248	9	0	16
1908	367	66720000000000	23099	11535	3	0	0
1909	367	66720012000000	23099	11535	4	0	0
1981	369	74436464290830	23480	11707	11	0	16
1988	369	75156464290830	23689	11798	4	0	16
1990	369	75156477290830	23689	11798	5	0	16
1996	369	75876477290830	23918	11902	11	0	16
2005	369	76596515290830	23962	11923	7	0	16
2006	369	76596549290830	23962	11923	8	0	16
2015	369	77316549290830	25175	12490	3	0	16
2018	369	77316561290830	25175	12490	4	0	16
2025	369	78036561290830	25740	12734	5	0	16
2033	369	78756575290830	26069	12884	8	0	16
2036	369	78756619290830	26069	12884	9	0	16
2043	369	79332288412810	20840	10474	4	0	\N
2044	369	79332289412810	20589	10357	5	0	\N
2050	369	80196630290830	26143	12923	2	0	\N
2053	369	80196641290830	26143	12923	3	0	\N
2054	369	80400330000000	5477	2852	0	0	\N
2055	369	80400330000000	5716	2964	2	0	\N
2057	369	80400330000000	6120	3173	1	0	\N
2058	369	80400330000000	6121	3173	1	0	\N
2060	369	80400340000000	6120	3173	2	0	\N
2061	369	80400340000000	6121	3173	2	0	\N
2062	369	80400530000000	5716	2964	3	0	\N
2067	369	80916655290830	27513	13602	1	0	\N
2073	369	81222102000000	17632	8702	50	0	\N
2074	369	81636655290830	27513	13602	3	0	\N
2079	369	81941422000000	17107	8668	2	0	\N
2081	369	81941433000000	17107	8668	3	0	\N
2083	369	81942102000000	17632	8702	126	0	\N
2084	369	81942852000000	17632	8702	127	0	\N
2085	369	81943352000000	17651	8703	50	0	\N
2088	369	82560370000000	6909	3570	1	0	\N
2090	369	82560380000000	6909	3570	2	0	\N
2094	369	82663352000000	17651	8703	126	0	\N
2095	369	82664102000000	17651	8703	127	0	\N
2096	369	83076669290830	28482	14076	2	0	\N
2097	369	83076669290830	28550	14104	2	0	\N
2098	369	83076669290830	28830	14220	7	0	\N
2099	369	83076669290830	28993	14294	3	0	\N
2101	369	83076680290830	28482	14076	3	0	\N
2102	369	83076680290830	28550	14104	3	0	\N
2103	369	83076681290830	28993	14294	4	0	\N
2104	369	83076694290830	28830	14220	8	0	\N
2106	369	83280390000000	7675	3973	5	0	\N
2107	369	83280390000000	7829	4060	1	0	\N
2108	369	83280390000000	8037	4166	1	0	\N
2110	369	83280400000000	7829	4060	2	0	\N
2111	369	83280400000000	8037	4166	2	0	\N
2112	369	83280440000000	7675	3973	6	0	\N
2116	369	83796662000000	18509	9323	3	0	\N
2117	369	83796662000000	18510	9323	2	0	\N
2119	369	83796664000000	18510	9323	3	0	\N
2121	369	83796674000000	18509	9323	4	0	\N
2134	369	84821482000000	17976	9066	4	0	\N
2135	369	84821482000000	18033	9098	4	0	\N
2136	369	84821482000000	18130	9143	3	0	\N
2137	369	84821494000000	18130	9143	4	0	\N
2138	369	84821504000000	17976	9066	5	0	\N
2139	369	84821504000000	18033	9098	5	0	\N
2144	369	85236753290830	29687	14642	9	0	\N
2145	369	85236771290830	29687	14642	10	0	\N
2147	369	85237478000000	19200	9473	58	0	\N
2150	369	85956718000000	18760	9457	3	0	\N
2151	369	85956718000000	19198	9686	7	0	\N
2153	369	85956730000000	18760	9457	4	0	\N
2155	369	85956743000000	19198	9686	8	0	\N
2156	369	85956772290830	29711	14650	30	0	\N
2157	369	85956772290830	29722	14654	9	0	\N
2158	369	85956772290830	29767	14672	19	0	\N
2161	369	85956809290830	29767	14672	20	0	\N
2162	369	85956829290830	29711	14650	31	0	\N
2163	369	85956839290830	29722	14654	10	0	\N
2164	369	85957478000000	19200	9473	126	0	\N
2165	369	85958148000000	19200	9473	127	0	\N
2173	369	86677183290830	30207	14832	35	0	\N
2174	369	86880532000000	9189	4763	4	0	\N
2176	369	86880572000000	9189	4763	5	0	\N
2059	369	80400340000000	6119	3173	2	0	0
2069	369	81120340000000	6465	3350	1	0	0
2070	369	81120350000000	6465	3350	2	0	0
2077	369	81840350000000	6543	3390	2	0	0
2078	369	81840370000000	6543	3390	3	0	0
2091	369	82560390000000	6912	3570	3	0	0
2109	369	83280390000000	8082	4191	4	0	0
2113	369	83280452000000	8082	4191	5	0	0
2124	369	84000452000000	8127	4214	1	0	0
2125	369	84000462000000	8127	4214	2	0	0
2133	369	84720472000000	8154	4227	2	0	0
2148	369	85440472000000	8667	4488	4	0	0
2149	369	85440512000000	8667	4488	5	0	0
2166	369	86160512000000	8686	4502	2	0	0
2168	369	86160562000000	9379	4866	3	0	0
2175	369	86880562000000	9379	4866	5	0	0
2071	369	81221410000000	16755	8506	3	0	4
2072	369	81221422000000	16755	8506	4	0	4
2080	369	81941422000000	17631	8914	3	0	4
2092	369	82661434000000	17652	8924	2	0	4
2093	369	82661445000000	17652	8924	3	0	4
2114	369	83381445000000	17865	9016	3	0	4
2115	369	83381457000000	17865	9016	4	0	4
2126	369	84101457000000	17901	9032	7	0	4
2118	369	83796662000000	18550	9346	2	0	12
2120	369	83796673000000	18550	9346	3	0	12
2128	369	84516673000000	18583	9366	4	0	12
2129	369	84516695000000	18583	9366	5	0	12
2141	369	85236718000000	18750	9450	6	0	12
2142	369	85236728000000	19534	9841	1	0	12
2152	369	85956728000000	19534	9841	4	0	12
2154	369	85956730000000	19534	9841	5	0	12
2169	369	86676730000000	19581	9864	3	0	12
2041	369	79332267412810	21708	10874	3	0	15
2042	369	79332279412810	21708	10874	4	0	15
2048	369	80052279412810	21822	10922	12	0	15
2049	369	80052327412810	21822	10922	13	0	15
2063	369	80772327412810	21989	10995	6	0	15
2045	369	79476619290830	26085	12891	2	0	16
2046	369	79476630290830	26085	12891	3	0	16
2051	369	80196630290830	26464	13090	3	0	16
2052	369	80196633290830	26464	13090	4	0	16
2066	369	80916645290830	27380	13539	4	0	16
2068	369	80916655290830	27515	13602	1	0	16
2075	369	81636655290830	27515	13602	4	0	16
2076	369	81636657290830	27515	13602	5	0	16
2086	369	82356657290830	27623	13652	3	0	16
2100	369	83076669290830	29064	14330	9	0	16
2105	369	83076705290830	29064	14330	10	0	16
2122	369	83796705290830	29138	14367	6	0	16
2123	369	83796729290830	29138	14367	7	0	16
2130	369	84516729290830	29543	14566	6	0	16
2143	369	85236753290830	29686	14642	10	0	16
2146	369	85236772290830	29686	14642	11	0	16
2159	369	85956772290830	29769	14672	17	0	16
2160	369	85956807290830	29769	14672	18	0	16
2172	369	86676845290830	29881	14726	21	0	16
2180	369	87396768000000	19897	10022	4	0	\N
2181	369	87396768000000	19899	10022	4	0	\N
2182	369	87396845290830	30039	14790	22	0	\N
2183	369	87396894290830	30039	14790	23	0	\N
2184	369	87397183290830	30207	14832	121	0	\N
2185	369	87397599525475	30207	14832	124	1	\N
2190	369	88116768000000	19897	10022	5	0	\N
2191	369	88116768000000	19899	10022	5	0	\N
2194	369	88836767000000	20107	10120	4	0	\N
2196	369	88836789000000	20107	10120	5	0	\N
2198	369	89040672000000	10434	5397	2	0	\N
2199	369	89040672000000	10492	5422	22	0	\N
2200	369	89040672000000	10493	5422	22	0	\N
2202	369	89040692000000	10434	5397	3	0	\N
2204	369	89040892000000	10492	5422	23	0	\N
2205	369	89040892000000	10493	5422	23	0	\N
2206	369	89760712000000	11428	5870	5	0	\N
2209	369	89760744000000	11428	5870	6	0	\N
2210	369	90480723000000	11708	5963	7	0	\N
2212	369	90480893000000	11708	5963	8	0	\N
2213	369	90481035000000	12261	6241	38	0	\N
2214	369	91200723000000	11825	6077	1	0	\N
2215	369	91200723000000	12259	6313	3	0	\N
2216	369	91200723000000	12639	6520	6	0	\N
2217	369	91200723000000	13311	6859	3	0	\N
2219	369	91200724000000	11825	6077	2	0	\N
2220	369	91200726000000	12259	6313	4	0	\N
2221	369	91200735000000	13311	6859	4	0	\N
2223	369	91200756000000	12639	6520	7	0	\N
2224	369	91200892000000	11823	5964	0	0	\N
2225	369	91201035000000	12261	6241	125	0	\N
2226	369	91204368891000	12640	6242	38	0	\N
2229	369	91921501000000	14348	7192	74	0	\N
2230	369	91924368891000	12640	6242	126	0	\N
2231	369	91925238891000	12640	6242	127	0	\N
2232	369	92640760000000	13862	7114	7	0	\N
2233	369	92640760000000	14005	7177	13	0	\N
2236	369	92640776000000	13862	7114	8	0	\N
2237	369	92640811000000	14005	7177	14	0	\N
2238	369	92641501000000	14348	7192	126	0	\N
2239	369	92642011000000	14348	7192	127	0	\N
2240	369	92642625000000	14364	7193	74	0	\N
2243	369	93362625000000	14364	7193	126	0	\N
2244	369	93362703000000	14364	7193	127	0	\N
2251	369	96240841000000	15004	7643	2	0	\N
2253	369	96240852000000	15004	7643	3	0	\N
2257	369	97680865000000	15488	7778	0	0	\N
2259	369	97680865000000	15490	7790	0	0	\N
2260	369	97680865000000	15491	7801	0	0	\N
2261	369	97680865000000	15492	7813	0	0	\N
2266	369	99270885000000	15775	8024	8	0	\N
2268	369	99270902000000	15775	8024	9	0	\N
2271	379	1000000200	2760	1231	117	1	\N
2272	379	66000090001000	5255	2727	0	0	\N
2279	389	68880058000000	20595	10359	6	0	\N
2280	389	68880091000000	20595	10359	7	0	\N
2285	404	68160031000000	23444	11691	2	0	\N
2286	404	68160042000000	23444	11691	3	0	\N
2287	405	66720000000000	3185	1653	1	0	\N
2289	405	66720010000000	3185	1653	2	0	\N
2290	405	67440000000000	22700	11349	4	0	\N
2291	405	67440013000000	22700	11349	5	0	\N
2292	407	66720000000000	13496	6950	4	0	\N
2293	407	66720000000000	18987	9575	4	0	\N
2295	407	66720000000000	26821	13144	69	0	\N
2296	407	66720013000000	13496	6950	5	0	\N
2297	407	66720013000000	18987	9575	5	0	\N
2299	407	66720690000000	26821	13144	70	0	\N
2300	411	66121690000000	10230	5007	15	0	\N
2304	411	66726400000000	24713	12273	7	0	\N
2306	411	66726452000000	24713	12273	8	0	\N
2309	411	66841690000000	10230	5007	76	0	\N
2310	411	66843480000000	10230	5007	77	0	\N
2311	413	66720000000000	22800	11402	4	0	\N
2312	413	66720013000000	22800	11402	5	0	\N
2273	389	66720000000000	7089	3659	2	0	0
2274	389	66720020000000	7089	3659	3	0	0
2301	411	66720000000000	9014	4673	2	0	0
2302	411	66720020000000	9014	4673	3	0	0
2177	369	86880572000000	9379	4866	6	0	0
2187	369	87600642000000	9856	5111	8	0	0
2307	411	66839890000000	10229	5294	4	0	3
2308	411	66839930000000	10229	5294	5	0	3
2192	369	88320642000000	10274	5317	3	0	0
2193	369	88320672000000	10274	5317	4	0	0
2203	369	89040712000000	10861	5606	5	0	0
2207	369	89760712000000	11438	5876	2	0	0
2208	369	89760723000000	11438	5876	3	0	0
2211	369	90480723000000	11709	6021	0	0	0
2275	389	67440020000000	13118	6761	8	0	0
2276	389	67440046000000	13118	6761	9	0	0
2218	369	91200723000000	13584	6987	5	0	0
2222	369	91200747000000	13584	6987	6	0	0
2227	369	91920747000000	13642	7013	4	0	0
2234	369	92640760000000	14347	7323	4	0	0
2235	369	92640773000000	14347	7323	5	0	0
2241	369	93360773000000	14365	7331	4	0	0
2242	369	93360795000000	14365	7331	5	0	0
2245	369	94080795000000	14598	7443	3	0	0
2247	369	94800807000000	14818	7552	4	0	0
2248	369	94800829000000	14818	7552	5	0	0
2249	369	95520829000000	14995	7639	3	0	0
2250	369	95520841000000	14995	7639	4	0	0
2254	369	96240853000000	15030	7659	4	0	0
2255	369	96960853000000	15193	7742	3	0	0
2256	369	96960865000000	15193	7742	4	0	0
2258	369	97680865000000	15489	7885	1	0	0
2262	369	97680875000000	15489	7885	2	0	0
2264	369	98550885000000	15572	7927	3	0	0
2277	389	68160046000000	15762	8016	3	0	0
2278	389	68160058000000	15762	8016	4	0	0
2265	369	99270885000000	15774	8024	3	0	0
2267	369	99270897000000	15774	8024	4	0	0
2270	369	99990910000000	16050	8163	5	0	0
2178	369	87396742000000	19792	9968	4	0	12
2179	369	87396755000000	19792	9968	5	0	12
2188	369	88116755000000	20042	10089	3	0	12
2195	369	88836767000000	20265	10206	7	0	12
2197	369	88836792000000	20265	10206	8	0	12
2283	404	67440020000000	20809	10462	2	0	0
2284	404	67440031000000	20809	10462	3	0	0
2303	411	66726400000000	24711	12273	7	0	6
2294	407	66720000000000	26820	13263	4	0	0
2298	407	66720022000000	26820	13263	5	0	0
2317	415	66720000000000	2963	1539	1	0	\N
2318	415	66720000000000	8860	4592	2	0	\N
2320	415	66720010000000	2963	1539	2	0	\N
2322	415	66720020000000	8860	4592	3	0	\N
2325	416	200100011	5836	3029	8	1	\N
2327	416	66000020000000	14898	7590	6	0	\N
2328	416	66000020000000	19364	9763	6	0	\N
2329	416	58260151362557268	25895	12799	12	1	\N
2330	417	8303105450010	24642	12242	9	0	\N
2336	435	180000000	20646	10357	126	1	\N
2337	435	6526641990000	12143	6254	3	1	\N
2338	435	9000300000000	21870	10799	126	0	\N
2339	435	17280440490000	10701	5524	10	0	\N
2341	435	66000000030000	12141	6254	4	0	\N
2342	435	66000000030000	23353	11407	106	0	\N
2343	435	66000000030000	23397	11486	100	0	\N
2344	435	68160051990000	14300	7221	6	1	\N
2345	435	91201128891000	12261	6241	127	1	\N
2347	439	66000050000000	10882	5613	5	0	\N
2348	439	66000050000000	10883	5613	5	0	\N
2349	439	66000050000000	10884	5613	5	0	\N
2350	439	66000050000000	10885	5613	5	0	\N
2351	439	66720000000000	10879	5605	6	0	\N
2352	439	66720000000000	10881	5613	4	0	\N
2353	439	66720040000000	10881	5613	5	0	\N
2355	439	66720050000000	10882	5613	6	0	\N
2356	439	66720050000000	10883	5613	6	0	\N
2357	439	66720050000000	10884	5613	6	0	\N
2358	439	66720050000000	10885	5613	6	0	\N
2359	439	66720060000000	10879	5605	7	0	\N
2360	441	66000490000000	2362	1062	31	0	\N
2361	441	66720000000000	2361	1234	1	0	\N
2362	441	66720010000000	2361	1234	2	0	\N
2363	441	66720490000000	2362	1062	126	0	\N
2364	441	66721430000000	2362	1062	127	0	\N
2365	442	25000000	20836	10417	39	0	\N
2367	446	66720000000000	23861	11876	7	0	\N
2368	446	66720025000000	23861	11876	8	0	\N
2369	457	66000025000000	6202	3210	11	0	\N
2370	457	66720000000000	7499	3881	1	0	\N
2371	457	66720000000000	8443	4375	0	0	\N
2372	457	66720000000000	19038	9602	2	0	\N
2373	457	66720010000000	7499	3881	2	0	\N
2374	457	66720011000000	19038	9602	3	0	\N
2375	470	7956392985638	15514	7894	7	0	\N
2378	470	66720011000000	9833	5096	3	0	\N
2381	470	66720041000000	9833	5096	4	0	\N
2386	470	67440031000000	9846	5104	5	0	\N
2388	470	67440065000000	20519	10329	6	0	\N
2389	470	67440065000000	20524	10330	4	0	\N
2390	470	67440065000000	20582	10355	8	0	\N
2392	470	67440078000000	20524	10330	5	0	\N
2393	470	67440081000000	9846	5104	6	0	\N
2394	470	67440089000000	20519	10329	7	0	\N
2397	470	67440100000000	20582	10355	9	0	\N
2398	470	68160030000000	562	317	2	0	\N
2401	470	68160050000000	562	317	3	0	\N
2403	470	68160091000000	10340	5352	3	0	\N
2407	470	68160121000000	10340	5352	4	0	\N
2408	470	68160221000000	10367	5362	2	0	\N
2411	470	68880111000000	10433	5396	4	0	\N
2412	470	68880111000000	10572	5459	2	0	\N
2415	470	68880131000000	10572	5459	3	0	\N
2417	470	68880151000000	10433	5396	5	0	\N
2418	470	68880221000000	10367	5362	6	0	\N
2419	470	68880251000000	10367	5362	7	0	\N
2420	470	69600050000000	826	455	2	0	\N
2421	470	69600050000000	1010	559	1	0	\N
2422	470	69600050000000	1012	559	2	0	\N
2424	470	69600060000000	1010	559	2	0	\N
2426	470	69600070000000	826	455	3	0	\N
2427	470	69600070000000	1012	559	3	0	\N
2428	470	69600114000000	21172	10633	2	0	\N
2430	470	69600125000000	21172	10633	3	0	\N
2432	470	69600141000000	10672	5509	6	0	\N
2433	470	69600141000000	10673	5509	8	0	\N
2434	470	69600141000000	10940	5639	2	0	\N
2435	470	69600141000000	10972	5653	3	0	\N
2437	470	69600161000000	10940	5639	3	0	\N
2438	470	69600171000000	10972	5653	4	0	\N
2440	470	69600201000000	10672	5509	7	0	\N
2441	470	69600221000000	10673	5509	9	0	\N
2448	470	71040070000000	1418	772	1	0	\N
2384	470	67440020000000	112	68	1	0	0
2385	470	67440030000000	112	68	2	0	0
2399	470	68160030000000	582	329	1	0	0
2400	470	68160040000000	582	329	2	0	0
2409	470	68880040000000	731	410	1	0	0
2423	470	69600050000000	1313	724	1	0	0
2425	470	69600060000000	1313	724	2	0	0
2442	470	70320060000000	1400	766	1	0	0
2443	470	70320070000000	1400	766	2	0	0
2340	435	66000000020000	9137	4733	5	0	0
2380	470	66720031000000	9832	5096	3	0	6
2387	470	67440031000000	9847	5104	6	0	6
2395	470	67440091000000	9847	5104	7	0	6
2402	470	68160091000000	10339	5352	2	0	6
2413	470	68880111000000	10573	5459	3	0	6
2416	470	68880141000000	10573	5459	4	0	6
2346	439	66000050000000	10880	5613	5	0	0
2354	439	66720050000000	10880	5613	6	0	0
2436	470	69600141000000	10973	5653	4	0	6
2445	470	70320181000000	11039	5682	2	0	6
2447	470	70320201000000	11039	5682	3	0	6
2313	414	66720000000000	14716	7492	2	0	0
2314	414	66720011000000	14716	7492	3	0	0
2319	415	66720000000000	18397	9273	2	0	0
2323	415	67440011000000	18882	9523	1	0	0
2324	415	67440021000000	18882	9523	2	0	0
2331	417	66000040000000	19330	9747	4	0	0
2332	417	66720040000000	19330	9747	11	0	0
2382	470	66720053000000	20314	10231	3	0	11
2383	470	66720065000000	20314	10231	4	0	11
2391	470	67440065000000	20583	10355	7	0	11
2396	470	67440099000000	20583	10355	8	0	11
2404	470	68160099000000	20626	10375	6	0	11
2414	470	68880114000000	20758	10435	0	0	11
2429	470	69600114000000	21321	10703	4	0	11
2431	470	69600136000000	21321	10703	5	0	11
2444	470	70320136000000	21402	10735	11	0	11
2446	470	70320193000000	21402	10735	12	0	11
2334	418	66720000000000	26416	13069	4	0	0
2335	418	66720013000000	26416	13069	5	0	0
2315	414	66720011000000	29948	14749	11	0	1
2316	414	66720040000000	29948	14749	12	0	1
2450	470	71040080000000	1418	772	2	0	\N
2453	470	71040201000000	11263	5787	10	0	\N
2456	470	71040283000000	11263	5787	11	0	\N
2458	470	71760081000000	1588	863	1	0	\N
2460	470	71760091000000	1588	863	2	0	\N
2464	470	71760229000000	22444	11232	3	0	\N
2466	470	71760293000000	11772	6052	2	0	\N
2467	470	71760293000000	11774	6052	3	0	\N
2470	470	71760304000000	11772	6052	3	0	\N
2471	470	71760305000000	11774	6052	4	0	\N
2474	470	72480217000000	22239	11131	7	0	\N
2475	470	72480229000000	22444	11232	4	0	\N
2477	470	72480269000000	22239	11131	8	0	\N
2483	470	73200229000000	22595	11304	5	0	\N
2485	470	73200261000000	22595	11304	6	0	\N
2486	470	73200296000000	12439	6413	0	0	\N
2487	470	73200296000000	12643	6521	2	0	\N
2488	470	73200296000000	12644	6521	3	0	\N
2489	470	73200296000000	12834	6619	1	0	\N
2490	470	73200296000000	12835	6619	1	0	\N
2492	470	73200306000000	12834	6619	2	0	\N
2493	470	73200306000000	12835	6619	2	0	\N
2494	470	73200307000000	12643	6521	3	0	\N
2496	470	73200317000000	12644	6521	4	0	\N
2499	470	73920251000000	22869	11431	4	0	\N
2500	470	73920251000000	22870	11431	5	0	\N
2501	470	73920251000000	23205	11584	4	0	\N
2502	470	73920251000000	23377	11665	5	0	\N
2504	470	73920264000000	22869	11431	5	0	\N
2505	470	73920273000000	23205	11584	5	0	\N
2507	470	73920274000000	22870	11431	6	0	\N
2508	470	73920283000000	23377	11665	6	0	\N
2509	470	73920307000000	13205	6804	3	0	\N
2510	470	73920307000000	13206	6804	1	0	\N
2511	470	73920307000000	13398	6903	8	0	\N
2513	470	73920307000000	13805	7089	6	0	\N
2514	470	73920317000000	13206	6804	2	0	\N
2515	470	73920319000000	13205	6804	4	0	\N
2517	470	73920331000000	13805	7089	7	0	\N
2518	470	73920333000000	13398	6903	9	0	\N
2521	470	74640273000000	23664	11786	4	0	\N
2523	470	74640286000000	23664	11786	5	0	\N
2527	470	75360211000000	2960	1538	1	0	\N
2529	470	75360221000000	2960	1538	2	0	\N
2532	470	75360360000000	14109	7212	5	0	\N
2533	470	75360360000000	14110	7212	6	0	\N
2534	470	75360360000000	14287	7292	4	0	\N
2535	470	75360360000000	14288	7292	6	0	\N
2537	470	75360373000000	14287	7292	5	0	\N
2539	470	75360375000000	14288	7292	7	0	\N
2540	470	75360383000000	14109	7212	6	0	\N
2541	470	75360384000000	14110	7212	7	0	\N
2542	470	75361002000000	25200	12455	126	0	\N
2543	470	76080221000000	3222	1674	1	0	\N
2545	470	76080231000000	3222	1674	2	0	\N
2547	470	76080298000000	24425	12148	2	0	\N
2549	470	76080309000000	24425	12148	3	0	\N
2552	470	76080393000000	15513	7894	1	0	\N
2553	470	76080393000000	15514	7894	1	0	\N
2554	470	76081002000000	25200	12455	127	0	\N
2555	470	76800271000000	3452	1792	0	0	\N
2556	470	76800271000000	4275	2217	2	0	\N
2557	470	76800271000000	4277	2217	3	0	\N
2561	470	76800310000000	25401	12588	8	0	\N
2563	470	76800336000000	25401	12588	9	0	\N
2565	470	76800381000000	4275	2217	3	0	\N
2567	470	76800391000000	4277	2217	4	0	\N
2568	470	76800393000000	15513	7894	6	0	\N
2569	470	76800393000000	15514	7894	6	0	\N
2570	470	76800415000000	15513	7894	7	0	\N
2571	470	77520281000000	4632	2396	1	0	\N
2572	470	77520281000000	4660	2409	1	0	\N
2574	470	77520281000000	5136	2662	1	0	\N
2575	470	77520291000000	4632	2396	2	0	\N
2576	470	77520291000000	4660	2409	2	0	\N
2577	470	77520291000000	5136	2662	2	0	\N
2581	470	77520383000000	15753	8011	7	0	\N
2582	470	77520383000000	15755	8011	8	0	\N
2583	470	77520383000000	15878	8002	1	0	\N
2584	470	77520383000000	15879	8012	1	0	\N
2459	470	71760081000000	1885	1002	1	0	0
2461	470	71760091000000	1885	1002	2	0	0
2472	470	72480091000000	1966	1040	6	0	0
2473	470	72480151000000	1966	1040	7	0	0
2480	470	73200151000000	2527	1328	1	0	0
2497	470	73920161000000	2720	1429	3	0	0
2498	470	73920191000000	2720	1429	4	0	0
2519	470	74640191000000	2935	1527	2	0	0
2520	470	74640211000000	2935	1527	3	0	0
2528	470	75360211000000	2973	1546	1	0	0
2544	470	76080221000000	3325	1724	5	0	0
2546	470	76080271000000	3325	1724	6	0	0
2558	470	76800271000000	4524	2341	1	0	0
2559	470	76800281000000	4524	2341	2	0	0
2578	470	77520301000000	5135	2662	3	0	0
2454	470	71040201000000	11265	5787	11	0	6
2457	470	71040293000000	11265	5787	12	0	6
2468	470	71760293000000	12002	6177	2	0	6
2469	470	71760295000000	12002	6177	3	0	6
2479	470	72480296000000	12383	6387	2	0	6
2491	470	73200296000000	12860	6631	2	0	6
2495	470	73200307000000	12860	6631	3	0	6
2512	470	73920307000000	13804	7089	5	0	6
2516	470	73920330000000	13804	7089	6	0	6
2526	470	74640360000000	13832	7102	22	0	6
2536	470	75360360000000	14438	7367	4	0	6
2538	470	75360373000000	14438	7367	5	0	6
2551	470	76080373000000	14810	7546	0	0	6
2566	470	76800383000000	15570	7925	2	0	6
2452	470	71040193000000	21641	10842	3	0	11
2455	470	71040205000000	21641	10842	4	0	11
2462	470	71760205000000	21675	10858	3	0	11
2463	470	71760217000000	21675	10858	4	0	11
2476	470	72480229000000	22445	11232	4	0	11
2482	470	73200229000000	22593	11304	4	0	11
2484	470	73200251000000	22593	11304	5	0	11
2503	470	73920251000000	23378	11665	4	0	11
2506	470	73920273000000	23378	11665	5	0	11
2524	470	74640298000000	23671	11789	8	0	11
2531	470	75360298000000	23856	11875	0	0	11
2548	470	76080298000000	25197	12500	3	0	11
2550	470	76080310000000	25197	12500	4	0	11
2562	470	76800334000000	25399	12588	7	0	11
2579	470	77520334000000	25548	12649	8	0	11
2580	470	77520369000000	25548	12649	9	0	11
2585	470	77520383000000	15885	8076	4	0	\N
2586	470	77520383000000	15886	8029	1	0	\N
2588	470	77520383000000	16214	8239	7	0	\N
2589	470	77520384000000	15878	8002	2	0	\N
2590	470	77520384000000	15879	8012	2	0	\N
2591	470	77520384000000	15886	8029	2	0	\N
2592	470	77520405000000	15885	8076	5	0	\N
2594	470	77520408000000	15753	8011	8	0	\N
2595	470	77520409000000	15755	8011	9	0	\N
2596	470	77520417000000	16214	8239	8	0	\N
2598	470	77520428000000	16223	8245	3	0	\N
2601	470	78239349000000	25910	12805	2	0	\N
2602	470	78239360000000	25910	12805	3	0	\N
2605	470	78240369000000	25837	12775	3	0	\N
2606	470	78240369000000	25881	12791	2	0	\N
2607	470	78240380000000	25881	12791	3	0	\N
2608	470	78240381000000	25837	12775	4	0	\N
2610	470	78240428000000	16223	8245	8	0	\N
2611	470	78240432000000	16223	8245	9	0	\N
2612	470	78835351000000	28127	13904	2	0	\N
2613	470	78835351000000	28130	13904	1	0	\N
2615	470	78835351000000	28200	13942	2	0	\N
2616	470	78835361000000	28130	13904	2	0	\N
2617	470	78835362000000	28127	13904	3	0	\N
2618	470	78835362000000	28200	13942	3	0	\N
2620	470	78960311000000	5350	2777	1	0	\N
2622	470	78960321000000	5350	2777	2	0	\N
2624	470	78960419000000	17392	8809	7	0	\N
2626	470	78960444000000	17392	8809	8	0	\N
2628	470	79555372000000	28460	14064	2	0	\N
2630	470	79555383000000	28460	14064	3	0	\N
2632	470	79680331000000	6090	3161	2	0	\N
2633	470	79680331000000	6131	3179	2	0	\N
2634	470	79680331000000	6132	3179	1	0	\N
2636	470	79680341000000	6132	3179	2	0	\N
2638	470	79680351000000	6090	3161	3	0	\N
2639	470	79680351000000	6131	3179	3	0	\N
2640	470	79680445000000	17801	8992	3	0	\N
2641	470	79680445000000	17804	8992	5	0	\N
2642	470	79680445000000	17805	8993	5	0	\N
2644	470	79680457000000	17801	8992	4	0	\N
2645	470	79680459000000	17804	8992	6	0	\N
2646	470	79680459000000	17805	8993	6	0	\N
2650	470	80400341000000	6849	3542	6	0	\N
2651	470	80400341000000	6850	3542	7	0	\N
2653	470	80400341000000	6852	3543	3	0	\N
2655	470	80400371000000	6852	3543	4	0	\N
2656	470	80400401000000	6849	3542	7	0	\N
2657	470	80400411000000	6850	3542	8	0	\N
2658	470	80400461000000	17838	9007	6	0	\N
2659	470	80400461000000	17841	9007	7	0	\N
2660	470	80400461000000	17903	9032	7	0	\N
2661	470	80400461000000	17905	9031	10	0	\N
2662	470	80400461000000	18063	9110	1	0	\N
2664	470	80400471000000	18063	9110	2	0	\N
2666	470	80400485000000	17838	9007	7	0	\N
2667	470	80400486000000	17841	9007	8	0	\N
2668	470	80400486000000	17903	9032	8	0	\N
2669	470	80400503000000	18593	9370	3	0	\N
2670	470	80400507000000	17905	9031	11	0	\N
2675	470	81120482000000	18286	9214	3	0	\N
2676	470	81120482000000	18287	9214	4	0	\N
2677	470	81120482000000	18599	9370	1	0	\N
2678	470	81120482000000	18893	9530	2	0	\N
2679	470	81120482000000	18896	9529	4	0	\N
2681	470	81120482000000	18904	9534	4	0	\N
2682	470	81120483000000	18599	9370	2	0	\N
2683	470	81120493000000	18893	9530	3	0	\N
2684	470	81120494000000	18286	9214	4	0	\N
2685	470	81120503000000	18593	9370	6	0	\N
2687	470	81120504000000	18287	9214	5	0	\N
2688	470	81120505000000	18593	9370	7	0	\N
2689	470	81120513000000	18896	9529	5	0	\N
2690	470	81120513000000	18904	9534	5	0	\N
2693	470	81840381000000	7026	3622	4	0	\N
2694	470	81840381000000	7161	3698	3	0	\N
2695	470	81840381000000	7164	3700	1	0	\N
2696	470	81840381000000	7241	3742	1	0	\N
2698	470	81840381000000	7413	3831	2	0	\N
2699	470	81840391000000	7164	3700	2	0	\N
2700	470	81840391000000	7241	3742	2	0	\N
2702	470	81840401000000	7413	3831	3	0	\N
2703	470	81840421000000	7026	3622	5	0	\N
2704	470	81840501000000	7161	3698	4	0	\N
2708	470	82560391000000	7431	3839	2	0	\N
2710	470	82560411000000	7431	3839	3	0	\N
2716	470	84000411000000	7590	3925	2	0	\N
2718	470	84000431000000	7590	3925	3	0	\N
2719	470	84720421000000	8393	4349	1	0	\N
2621	470	78960311000000	5812	3015	2	0	0
2623	470	78960331000000	5812	3015	3	0	0
2635	470	79680331000000	6157	3189	1	0	0
2637	470	79680341000000	6157	3189	2	0	0
2652	470	80400341000000	6851	3543	2	0	0
2673	470	81120361000000	6985	3605	2	0	0
2674	470	81120381000000	6985	3605	3	0	0
2697	470	81840381000000	7412	3831	1	0	0
2701	470	81840391000000	7412	3831	2	0	0
2707	470	82560391000000	7430	3839	1	0	0
2713	470	83280401000000	7448	3851	1	0	0
2714	470	83280411000000	7448	3851	2	0	0
2715	470	84000411000000	7589	3925	1	0	0
2717	470	84000421000000	7589	3925	2	0	0
2587	470	77520383000000	16213	8239	6	0	6
2593	470	77520407000000	16213	8239	7	0	6
2597	470	77520419000000	16222	8245	3	0	6
2609	470	78240419000000	16222	8245	4	0	6
2625	470	78960419000000	17393	8809	8	0	6
2643	470	79680445000000	17807	8993	7	0	6
2647	470	79680461000000	17807	8993	8	0	6
2663	470	80400461000000	18065	9110	3	0	6
2665	470	80400482000000	18065	9110	4	0	6
2680	470	81120482000000	18903	9535	3	0	6
2599	470	78115339000000	26912	13309	3	0	13
2600	470	78115351000000	26912	13309	4	0	13
2614	470	78835351000000	28199	13942	3	0	13
2619	470	78835372000000	28199	13942	4	0	13
2631	470	79555384000000	28866	14237	4	0	13
2648	470	80275384000000	29041	14322	3	0	13
2649	470	80275396000000	29041	14322	4	0	13
2671	470	80995396000000	29233	14406	6	0	13
2672	470	80995420000000	29233	14406	7	0	13
2692	470	81715433000000	29317	14447	5	0	13
2705	470	82435433000000	29650	14622	19	0	13
2706	470	82435569000000	29650	14622	20	0	13
2711	470	83155568999999	29959	14755	7	0	13
2712	470	83155584964999	29959	14755	8	0	13
2721	470	84720431000000	8393	4349	2	0	\N
2724	470	86160431000000	9698	5031	5	0	\N
2725	470	86160431000000	9699	5031	8	0	\N
2726	470	86160571000000	9698	5031	6	0	\N
2727	470	86160601000000	9699	5031	9	0	\N
2728	471	5615237060108	11504	5793	40	0	\N
2729	471	66000100000000	14794	7292	0	0	\N
2730	484	111200000	22325	11174	8	1	\N
2737	484	68254074000000	20880	10475	21	0	\N
2740	484	68880030000000	648	364	1	0	\N
2742	484	68880040000000	648	364	2	0	\N
2744	484	68973814000000	21969	10699	0	0	\N
2745	484	68973814000000	21970	10713	0	0	\N
2746	484	68973814000000	21971	10726	0	0	\N
2749	484	68974074000000	20880	10475	90	0	\N
2750	484	68974322000000	20880	10475	91	0	\N
2751	484	68975152000000	21065	10476	57	0	\N
2758	484	69695152000000	21065	10476	126	0	\N
2759	484	69695832000000	21065	10476	127	0	\N
2760	484	69696402000000	21188	10477	57	0	\N
2761	484	70028770000000	17499	8859	2	0	\N
2763	484	70028781000000	17499	8859	3	0	\N
2766	484	70320070000000	913	507	2	0	\N
2767	484	70320070000000	1507	826	1	0	\N
2769	484	70320080000000	1507	826	2	0	\N
2771	484	70320090000000	913	507	3	0	\N
2773	484	70413850000000	22261	11140	2	0	\N
2774	484	70413861000000	22261	11140	3	0	\N
2776	484	70413873000000	22361	11192	2	0	\N
2777	484	70416402000000	21188	10477	108	0	\N
2778	484	70416902000000	21188	10477	109	0	\N
2779	484	70748781000000	17735	8964	7	0	\N
2780	484	70748781000000	17860	9014	3	0	\N
2781	484	70748781000000	17878	9023	3	0	\N
2782	484	70748781000000	18050	9105	3	0	\N
2783	484	70748781000000	18642	9395	2	0	\N
2784	484	70748792000000	18642	9395	3	0	\N
2785	484	70748793000000	17860	9014	4	0	\N
2786	484	70748793000000	17878	9023	4	0	\N
2787	484	70748793000000	18050	9105	4	0	\N
2788	484	70748806000000	18780	9464	2	0	\N
2790	484	70748815000000	17735	8964	8	0	\N
2791	484	70748817000000	18780	9464	3	0	\N
2795	484	71133862000000	22324	11174	7	0	\N
2796	484	71133862000000	22325	11174	7	0	\N
2798	484	71133873000000	22361	11192	5	0	\N
2799	484	71133875000000	22361	11192	6	0	\N
2801	484	71133887000000	22324	11174	8	0	\N
2802	484	71468817000000	19280	9720	3	0	\N
2804	484	71468829000000	19280	9720	4	0	\N
2808	484	71853876000000	23125	11551	1	0	\N
2810	484	71853877000000	23125	11551	2	0	\N
2818	484	72908857000000	19489	9824	4	0	\N
2819	484	72908857000000	19869	10009	3	0	\N
2821	484	72908869000000	19869	10009	4	0	\N
2823	484	72908879000000	19489	9824	5	0	\N
2826	484	73293900000000	23798	11846	4	0	\N
2827	484	73293900000000	24227	12057	4	0	\N
2828	484	73293900000000	24656	12247	3	0	\N
2830	484	73293912000000	24656	12247	4	0	\N
2832	484	73293913000000	24227	12057	5	0	\N
2833	484	73293922000000	23798	11846	5	0	\N
2836	484	73628929000000	20248	10197	8	0	\N
2839	484	74013912000000	25003	12404	3	0	\N
2840	484	74013912000000	25529	12638	9	0	\N
2841	484	74013912000000	25969	12830	4	0	\N
2842	484	74013912000000	26016	12858	3	0	\N
2843	484	74013912000000	26479	13097	4	0	\N
2844	484	74013912000000	26600	13159	4	0	\N
2845	484	74013912000000	26658	13187	3	0	\N
2848	484	74013924000000	25003	12404	4	0	\N
2849	484	74013924000000	26016	12858	4	0	\N
2850	484	74013924000000	26658	13187	4	0	\N
2851	484	74013925000000	25969	12830	5	0	\N
2852	484	74013925000000	26479	13097	5	0	\N
2853	484	74013925000000	26600	13159	5	0	\N
2854	484	74013948000000	25529	12638	10	0	\N
2855	484	74348929000000	20248	10197	10	0	\N
2856	484	74348930000000	20248	10197	11	0	\N
2733	484	67440010000000	233	138	1	0	0
2734	484	67440020000000	233	138	2	0	0
2735	484	68160020000000	565	319	1	0	0
2736	484	68160030000000	565	319	2	0	0
2741	484	68880030000000	855	475	3	0	0
2754	484	69600060000000	893	496	1	0	0
2755	484	69600070000000	893	496	2	0	0
2768	484	70320070000000	1685	905	1	0	0
2770	484	70320080000000	1685	905	2	0	0
2793	484	71040080000000	1934	1028	1	0	0
2806	484	71760090000000	2358	1233	1	0	0
2807	484	71760100000000	2358	1233	2	0	0
2814	484	72480100000000	2374	1241	1	0	0
2815	484	72480110000000	2374	1241	2	0	0
2825	484	73200120000000	2458	1287	2	0	0
2837	484	73920120000000	2490	1304	1	0	0
2838	484	73920130000000	2490	1304	2	0	0
2722	470	84720431000000	8545	4427	2	0	0
2723	470	85440431000000	8677	4496	0	0	0
2739	484	68588758000000	17283	8753	4	0	4
2752	484	69308758000000	17299	8763	3	0	4
2753	484	69308770000000	17299	8763	4	0	4
2762	484	70028770000000	17708	8950	2	0	4
2764	484	70028781000000	17708	8950	3	0	4
2789	484	70748806000000	18938	9554	2	0	4
2792	484	70748817000000	18938	9554	3	0	4
2803	484	71468817000000	19298	9729	3	0	4
2805	484	71468829000000	19298	9729	4	0	4
2813	484	72188857000000	19341	9752	11	0	4
2820	484	72908857000000	19887	10017	3	0	4
2822	484	72908869000000	19887	10017	4	0	4
2834	484	73628869000000	20046	10091	7	0	4
2835	484	73628894000000	20046	10091	8	0	4
2748	484	68973825000000	22029	11014	3	0	8
2756	484	69693825000000	22174	11094	7	0	8
2757	484	69693850000000	22174	11094	8	0	8
2772	484	70413850000000	22260	11140	3	0	8
2775	484	70413862000000	22260	11140	4	0	8
2800	484	71133876000000	22873	11434	6	0	8
2809	484	71853876000000	23126	11551	3	0	8
2811	484	71853888000000	23126	11551	4	0	8
2816	484	72573888000000	23705	11805	3	0	8
2829	484	73293900000000	24675	12255	3	0	8
2831	484	73293912000000	24675	12255	4	0	8
2846	484	74013912000000	26659	13187	2	0	8
2847	484	74013923000000	26659	13187	3	0	8
2857	484	74640130000000	2979	1549	1	0	\N
2859	484	74640140000000	2979	1549	2	0	\N
2862	484	74733957000000	28374	14027	1	0	\N
2863	484	74733957000000	28376	14027	1	0	\N
2864	484	75360130000000	3797	1968	1	0	\N
2865	484	75360130000000	3918	2033	1	0	\N
2867	484	75360140000000	3797	1968	2	0	\N
2868	484	75360140000000	3918	2033	2	0	\N
2870	484	75453947000000	27300	13494	3	0	\N
2871	484	75453947000000	27392	13544	3	0	\N
2872	484	75453947000000	27398	13548	3	0	\N
2873	484	75453947000000	27912	13804	6	0	\N
2874	484	75453947000000	28190	13935	5	0	\N
2876	484	75453957000000	28374	14027	3	0	\N
2877	484	75453957000000	28376	14027	3	0	\N
2878	484	75453958000000	28374	14027	4	0	\N
2879	484	75453958000000	28376	14027	4	0	\N
2880	484	75453959000000	27300	13494	4	0	\N
2881	484	75453959000000	27392	13544	4	0	\N
2882	484	75453959000000	27398	13548	4	0	\N
2884	484	75453970000000	28190	13935	6	0	\N
2885	484	75453971000000	27912	13804	7	0	\N
2892	484	76893972000000	28924	14265	7	0	\N
2895	484	76893997000000	28924	14265	8	0	\N
2896	484	77520171000000	4625	2393	1	0	\N
2897	484	77520171000000	4882	2528	3	0	\N
2899	484	77520181000000	4625	2393	2	0	\N
2900	484	77520201000000	4882	2528	4	0	\N
2902	484	77613985000000	29191	14391	4	0	\N
2904	484	77613998000000	29191	14391	5	0	\N
2906	484	78240201000000	5004	2594	1	0	\N
2908	484	78240211000000	5004	2594	2	0	\N
2914	484	79054009000000	29636	14615	3	0	\N
2915	484	79054009000000	29637	14615	2	0	\N
2917	484	79054020000000	29637	14615	3	0	\N
2918	484	79054021000000	29636	14615	4	0	\N
2920	484	79680221000000	5392	2806	0	0	\N
2923	484	79774068000000	29926	14742	19	0	\N
2926	484	79774105000000	29926	14742	20	0	\N
2928	484	81120222000000	5651	2932	0	0	\N
2933	484	82560252000000	6027	3127	1	0	\N
2934	484	82560252000000	6111	3169	1	0	\N
2936	484	82560262000000	6027	3127	2	0	\N
2937	484	82560262000000	6111	3169	2	0	\N
2939	484	83280272000000	6695	3461	4	0	\N
2941	484	83280312000000	6695	3461	5	0	\N
2943	484	84000352000000	6954	3560	76	0	\N
2946	484	84001202000000	6954	3560	77	0	\N
2947	484	84001547000000	7424	3561	24	0	\N
2950	484	84721547000000	7424	3561	126	0	\N
2951	484	84722647000000	7424	3561	127	0	\N
2952	484	85440502000000	8501	4403	1	0	\N
2954	484	85440512000000	8501	4403	2	0	\N
2956	484	86160522000000	9109	4720	2	0	\N
2957	484	86160522000000	9152	4741	2	0	\N
2959	484	86160542000000	9109	4720	3	0	\N
2960	484	86160542000000	9152	4741	3	0	\N
2964	484	87600572000000	9764	5060	3	0	\N
2967	484	87600602000000	9764	5060	4	0	\N
2968	484	88320592000000	10652	5501	4	0	\N
2970	484	88320632000000	10652	5501	5	0	\N
2972	484	89040632000000	10813	5580	2	0	\N
2974	484	89040652000000	10813	5580	3	0	\N
2982	484	91920754000000	13193	6798	8	0	\N
2983	484	91920754000000	13203	6803	2	0	\N
2984	484	91920754000000	13612	6998	3	0	\N
2986	484	91920756000000	13203	6803	3	0	\N
2987	484	91920762000000	13193	6798	9	0	\N
2988	484	91920766000000	13612	6998	4	0	\N
2990	484	91921731000000	14282	7207	95	0	\N
2991	484	92640781000000	13958	7153	1	0	\N
2869	484	75360140000000	4146	2157	2	0	0
2886	484	76080140000000	4151	2160	1	0	0
2887	484	76080150000000	4151	2160	2	0	0
2890	484	76800150000000	4185	2179	3	0	0
2891	484	76800171000000	4185	2179	4	0	0
2901	484	77520201000000	4889	2533	4	0	0
2907	484	78240201000000	5101	2649	1	0	0
2909	484	78240211000000	5101	2649	2	0	0
2912	484	78960211000000	5290	2748	1	0	0
2913	484	78960221000000	5290	2748	2	0	0
2922	484	79680222000000	5459	2841	2	0	0
2927	484	80400222000000	5646	2930	0	0	0
2929	484	81120222000000	5874	3045	2	0	0
2930	484	81120242000000	5874	3045	3	0	0
2932	484	81840252000000	6003	3114	2	0	0
2935	484	82560252000000	6502	3370	2	0	0
2938	484	82560272000000	6502	3370	3	0	0
2940	484	83280272000000	6759	3499	8	0	0
2942	484	83280352000000	6759	3499	9	0	0
2945	484	84000382000000	8273	4285	4	0	0
2948	484	84720382000000	8342	4320	3	0	0
2949	484	84720502000000	8342	4320	4	0	0
2953	484	85440502000000	8884	4603	2	0	0
2955	484	85440522000000	8884	4603	3	0	0
2961	484	86160542000000	9369	4860	3	0	0
2962	484	86880542000000	9761	5058	3	0	0
2963	484	86880572000000	9761	5058	4	0	0
2965	484	87600572000000	10534	5440	2	0	0
2969	484	88320592000000	10741	5544	4	0	0
2971	484	88320632000000	10741	5544	5	0	0
2973	484	89040632000000	10875	5611	5	0	0
2975	484	89040682000000	10875	5611	6	0	0
2976	484	89760682000000	10878	5612	2	0	0
2978	484	90480702000000	11224	5767	4	0	0
2979	484	90480742000000	11224	5767	5	0	0
2980	484	91200742000000	12244	6305	3	0	0
2981	484	91200754000000	12244	6305	4	0	0
2985	484	91920754000000	13716	7049	9	0	0
2992	484	92640781000000	14797	7538	3	0	0
2860	484	74733923000000	26769	13238	6	0	8
2861	484	74733947000000	26769	13238	7	0	8
2875	484	75453947000000	28685	14161	4	0	8
2888	484	76173960000000	28700	14169	3	0	8
2889	484	76173972000000	28700	14169	4	0	8
2893	484	76893972000000	29086	14338	4	0	8
2894	484	76893985000000	29086	14338	5	0	8
2903	484	77613985000000	29303	14439	4	0	8
2910	484	78333998000000	29385	14487	2	0	8
2911	484	78334009000000	29385	14487	3	0	8
2916	484	79054009000000	29851	14712	14	0	8
2919	484	79054068000000	29851	14712	15	0	8
2924	484	79774068000000	30224	14862	9	0	8
2993	484	92640791000000	13958	7153	2	0	\N
2995	484	92641731000000	14282	7207	114	0	\N
2996	484	92641893000000	14282	7207	115	0	\N
2997	484	93360802000000	15159	7727	3	0	\N
2998	484	93360802000000	15233	7759	3	0	\N
3000	484	93360814000000	15159	7727	4	0	\N
3001	484	93360814000000	15233	7759	4	0	\N
3003	484	94080814000000	15858	8065	3	0	\N
3004	484	94080814000000	15975	8120	3	0	\N
3006	484	94080826000000	15858	8065	4	0	\N
3007	484	94080826000000	15975	8120	4	0	\N
3009	484	94800826000000	16250	8258	2	0	\N
3010	484	94800826000000	16326	8298	4	0	\N
3011	484	94800826000000	16571	8423	8	0	\N
3012	484	94800837000000	16250	8258	3	0	\N
3013	484	94800839000000	16326	8298	5	0	\N
3014	484	94800861000000	16571	8423	9	0	\N
3018	497	66720000000000	11220	5764	2	0	\N
3019	497	66720000000000	14599	7443	0	0	\N
3020	497	66720000000000	14600	7443	3	0	\N
3023	497	66720011000000	21811	10917	3	0	\N
3025	497	66720012000000	14600	7443	4	0	\N
3027	497	66720020000000	11220	5764	3	0	\N
3028	497	66720023000000	21811	10917	4	0	\N
3032	497	67440023000000	25715	12720	9	0	\N
3033	497	67440023000000	26784	13094	19	0	\N
3034	497	67440023000000	27350	13522	3	0	\N
3035	497	67440035000000	27350	13522	4	0	\N
3036	497	67440052000000	26784	13094	20	0	\N
3037	497	67440059000000	25715	12720	10	0	\N
3042	506	66720000000000	13426	6918	1	0	\N
3044	506	66720010000000	13426	6918	2	0	\N
3046	510	66720000000000	1903	1014	1	0	\N
3047	510	66720010000000	1903	1014	2	0	\N
3048	510	67439990000000	10159	5265	2	0	\N
3049	510	67440010000000	10159	5265	3	0	\N
3050	519	66720000000000	1578	859	1	0	\N
3052	519	66720010000000	1578	859	2	0	\N
3063	526	66720000000000	6744	3489	2	0	\N
3064	526	66720000000000	14053	7195	2	0	\N
3067	526	66720020000000	6744	3489	3	0	\N
3068	526	66720020000000	14053	7195	3	0	\N
3069	526	66720065000000	19127	9648	2	0	\N
3071	526	66720076000000	19127	9648	3	0	\N
3075	526	67440075000000	15150	7723	5	0	\N
3076	526	67440090000000	19638	9892	3	0	\N
3077	526	67440090000000	20375	10265	3	0	\N
3079	526	67440102000000	19638	9892	4	0	\N
3080	526	67440102000000	20375	10265	4	0	\N
3082	526	68160052000000	14942	7611	2	0	\N
3083	526	68160052000000	15338	7817	7	0	\N
3084	526	68160052000000	16071	8172	7	0	\N
3085	526	68160052000000	16467	8376	4	0	\N
3086	526	68160052000000	16964	8523	8	0	\N
3088	526	68160063000000	14942	7611	3	0	\N
3090	526	68160065000000	16467	8376	5	0	\N
3091	526	68160075000000	15150	7723	7	0	\N
3092	526	68160076000000	15150	7723	8	0	\N
3093	526	68160077000000	16071	8172	8	0	\N
3094	526	68160086000000	15338	7817	8	0	\N
3095	526	68160114000000	20562	10350	2	0	\N
3097	526	68160116000000	20562	10350	3	0	\N
3099	526	68160222000000	16964	8523	9	0	\N
3100	526	68880063000000	18114	9136	2	0	\N
3101	526	68880063000000	18470	9307	2	0	\N
3103	526	68880074000000	18114	9136	3	0	\N
3104	526	68880074000000	18470	9307	3	0	\N
3106	526	68880149000000	20772	10439	12	0	\N
3109	526	68880222000000	17205	8524	11	0	\N
3110	526	68880305000000	17205	8524	12	0	\N
3111	526	68880332000000	20772	10439	13	0	\N
3112	526	68881310000000	21302	10573	106	0	\N
3113	526	69600074000000	18797	9472	3	0	\N
3116	526	69600086000000	18797	9472	4	0	\N
3117	526	69600160000000	21005	10562	2	0	\N
3118	526	69600160000000	21339	10710	3	0	\N
3119	526	69600160000000	22651	11326	3	0	\N
3121	526	69600171000000	21005	10562	3	0	\N
3122	526	69600172000000	21339	10710	4	0	\N
3123	526	69600172000000	22651	11326	4	0	\N
3125	526	69600305000000	17261	8525	0	0	\N
3126	526	69601310000000	21302	10573	126	0	\N
3127	526	69601500000000	21302	10573	127	0	\N
3128	526	69603380000000	21591	10574	106	0	\N
3059	525	66720000000000	2646	1392	1	0	0
3060	525	66720010000000	2646	1392	2	0	0
3017	497	66720000000000	7954	4121	1	0	0
3022	497	66720010000000	7954	4121	2	0	0
3015	495	66720000000000	10519	5432	2	0	0
3065	526	66720000000000	14262	7282	4	0	0
3066	526	66720013000000	14262	7282	5	0	0
3073	526	67440013000000	14303	7299	12	0	0
3074	526	67440052000000	14303	7299	13	0	0
3043	506	66720000000000	14602	7444	3	0	0
2994	484	92640802000000	14797	7538	4	0	0
3061	525	67440010000000	15378	7833	6	0	0
3062	525	67440034000000	15378	7833	7	0	0
2999	484	93360802000000	15707	7987	3	0	0
3021	497	66720000000000	15799	8040	3	0	1
3026	497	66720012000000	15799	8040	4	0	1
3005	484	94080814000000	15997	8134	3	0	0
3008	484	94080826000000	15997	8134	4	0	0
3038	498	66721250000000	17416	8821	2	0	3
3087	526	68160052000000	17654	8925	2	0	0
3089	526	68160063000000	17654	8925	3	0	0
3102	526	68880063000000	18645	9395	2	0	0
3105	526	68880074000000	18645	9395	3	0	0
3114	526	69600074000000	18932	9550	2	0	0
3070	526	66720065000000	19191	9683	7	0	2
3072	526	66720090000000	19191	9683	8	0	2
3078	526	67440090000000	20420	10287	6	0	2
3081	526	67440114000000	20420	10287	7	0	2
3098	526	68160149000000	20700	10411	9	0	2
3107	526	68880149000000	20932	10525	2	0	2
3108	526	68880160000000	20932	10525	3	0	2
3024	497	66720011000000	21812	10917	3	0	2
3029	497	66720023000000	21812	10917	4	0	2
3124	526	69600197000000	22825	11415	11	0	2
3040	498	67441252000000	27910	13803	3	0	3
3041	498	67441264000000	27910	13803	4	0	3
3055	519	67441917000000	28417	14044	2	0	0
3056	519	67441928000000	28417	14044	3	0	0
3058	519	68161941000000	29322	14450	5	0	0
3030	497	67437010000000	30049	14793	10	0	6
3031	497	67437029000000	30049	14793	11	0	6
3131	526	70323380000000	21591	10574	126	0	\N
3132	526	70323570000000	21591	10574	127	0	\N
3133	526	71040209000000	22915	11455	4	0	\N
3136	526	71040222000000	22915	11455	5	0	\N
3141	526	72481145000000	24514	12096	54	0	\N
3142	526	73200245000000	23572	11747	3	0	\N
3143	526	73200245000000	23618	11766	3	0	\N
3145	526	73200257000000	23572	11747	4	0	\N
3146	526	73200257000000	23618	11766	4	0	\N
3148	526	73201145000000	24514	12096	126	0	\N
3149	526	73201855000000	24514	12096	127	0	\N
3150	526	73920279000000	24662	12250	4	0	\N
3151	526	73920279000000	25053	12431	2	0	\N
3153	526	73920290000000	25053	12431	3	0	\N
3155	526	73920292000000	24662	12250	5	0	\N
3156	526	74640291000000	25419	12596	5	0	\N
3157	526	74640291000000	25421	12596	3	0	\N
3160	526	74640303000000	25421	12596	4	0	\N
3161	526	74640305000000	25419	12596	6	0	\N
3164	528	66002380000000	9438	4656	20	0	\N
3165	528	66722380000000	9438	4656	26	0	\N
3166	528	66722430000000	9438	4656	27	0	\N
3167	529	66700000000000	7840	4014	0	0	\N
3168	529	66720000000000	9709	5035	3	0	\N
3171	529	66720030000000	9709	5035	4	0	\N
3174	532	66720000000000	11737	6031	7	0	\N
3175	532	66720000000000	11787	6058	2	0	\N
3176	532	66720000000000	11815	6070	1	0	\N
3177	532	66720000000000	11949	6152	2	0	\N
3178	532	66720000000000	12144	6254	2	0	\N
3179	532	66720000000000	12208	6289	1	0	\N
3180	532	66720000000000	12237	6301	1	0	\N
3182	532	66720001000000	11815	6070	2	0	\N
3183	532	66720001000000	12208	6289	2	0	\N
3184	532	66720001000000	12237	6301	2	0	\N
3186	532	66720002000000	11787	6058	3	0	\N
3187	532	66720002000000	11949	6152	3	0	\N
3188	532	66720002000000	12144	6254	3	0	\N
3189	532	66720043000000	11737	6031	8	0	\N
3192	532	68160012000000	12776	6586	2	0	\N
3193	532	68160012000000	13085	6741	4	0	\N
3195	532	68160023000000	12776	6586	3	0	\N
3196	532	68160025000000	13085	6741	5	0	\N
3198	532	68880026000000	13479	6941	4	0	\N
3199	532	68880026000000	13637	7010	14	0	\N
3202	532	68880039000000	13479	6941	5	0	\N
3203	532	68880058000000	13637	7010	15	0	\N
3206	532	69600059000000	15702	7985	1	0	\N
3207	532	70320049000000	15367	7828	5	0	\N
3208	532	70320049000000	16464	8374	2	0	\N
3209	532	70320059000000	15702	7985	8	0	\N
3210	532	70320060000000	16464	8374	3	0	\N
3211	532	70320072000000	15367	7828	6	0	\N
3212	532	70320074000000	15702	7985	9	0	\N
3213	547	66720000000000	21538	10774	1	0	\N
3215	547	66720010000000	21538	10774	2	0	\N
3217	554	66720000000000	2241	974	3	0	\N
3218	554	66720210000000	2241	974	4	0	\N
3226	555	67440002000000	19672	9908	5	0	\N
3227	555	67440043000000	19672	9908	6	0	\N
3229	555	67440075000000	28636	14140	2	0	\N
3231	555	68160075000000	28636	14140	3	0	\N
3241	564	67440011000000	25908	12804	7	0	\N
3242	564	67440045000000	25908	12804	8	0	\N
3245	576	1601300000	14898	7590	5	1	\N
3246	576	8053017459	11057	5687	5	1	\N
3247	576	66720000000000	492	273	1	0	\N
3248	576	66720000000000	521	292	5	0	\N
3249	576	66720000000000	628	353	1	0	\N
3251	576	66720010000000	492	273	2	0	\N
3252	576	66720010000000	628	353	2	0	\N
3254	576	66720050000000	521	292	6	0	\N
3255	576	67440010000000	780	433	3	0	\N
3256	576	67440010000000	1018	563	1	0	\N
3258	576	67440020000000	1018	563	2	0	\N
3260	576	67440040000000	780	433	4	0	\N
3235	563	67440010000000	509	285	1	0	0
3236	563	67440020000000	509	285	2	0	0
3237	563	68160020000000	587	331	1	0	0
3238	563	68160030000000	587	331	2	0	0
3250	576	66720000000000	665	370	1	0	0
3257	576	67440010000000	1157	637	1	0	0
3259	576	67440020000000	1157	637	2	0	0
3261	576	68160020000000	1190	657	1	0	0
3262	576	68160030000000	1190	657	2	0	0
3239	564	66720000000000	10001	5184	2	0	0
3263	576	68675594938283	11897	6116	2	0	4
3264	576	68675596938283	11897	6116	3	0	4
3181	532	66720000000000	12389	6390	1	0	0
3185	532	66720001000000	12389	6390	2	0	0
3191	532	67440012000000	12769	6584	3	0	0
3223	555	66720000000000	13028	6716	2	0	0
3224	555	66720002000000	13028	6716	3	0	0
3194	532	68160012000000	13348	6880	5	0	0
3197	532	68160026000000	13348	6880	6	0	0
3201	532	68880037000000	13689	7033	3	0	0
3219	554	66730000000000	14718	7493	2	0	0
3220	554	66730011000000	14718	7493	3	0	0
3204	532	69600037000000	15351	7823	3	0	0
3205	532	69600049000000	15351	7823	4	0	0
3244	568	66720012000000	15859	8065	4	0	0
3221	554	67450011000000	15893	8080	3	0	0
3222	554	67450023000000	15893	8080	4	0	0
3169	529	66720000000000	17962	9060	7	0	0
3225	555	67440002000000	19670	9908	8	0	0
3228	555	67440064000000	19670	9908	9	0	0
3129	526	70320197000000	22895	11444	3	0	2
3130	526	70320209000000	22895	11444	4	0	2
3134	526	71040209000000	23096	11533	3	0	2
3137	526	71760221000000	23104	11539	3	0	2
3138	526	71760233000000	23104	11539	4	0	2
3214	547	66720000000000	23233	11593	2	0	0
3216	547	66720011000000	23233	11593	3	0	0
3139	526	72480233000000	23508	11718	3	0	2
3144	526	73200245000000	24516	12192	7	0	2
3147	526	73200279000000	24516	12192	8	0	2
3152	526	73920279000000	25101	12457	3	0	2
3154	526	73920291000000	25101	12457	4	0	2
3159	526	74640302000000	26045	12869	3	0	2
3162	526	75360302000000	26777	13241	4	0	2
3163	526	75360315000000	26777	13241	5	0	2
3172	529	67440025000000	27966	13834	4	0	0
3173	529	67440047000000	27966	13834	5	0	0
3232	555	68160075000000	28637	14140	3	0	0
3273	576	70320050000000	1434	781	1	0	\N
3275	576	70320060000000	1434	781	2	0	\N
3277	576	70397454726897	21523	10797	2	0	\N
3278	576	70397454726897	21524	10797	3	0	\N
3280	576	70397465726897	21523	10797	3	0	\N
3281	576	70397466726897	21524	10797	4	0	\N
3283	576	70397476726897	22507	11258	1	0	\N
3286	576	71040070000000	1587	862	1	0	\N
3287	576	71040070000000	2295	1204	2	0	\N
3288	576	71040070000000	2532	1304	51	0	\N
3290	576	71040080000000	1587	862	2	0	\N
3291	576	71040090000000	2295	1204	3	0	\N
3292	576	71040610000000	2532	1304	52	0	\N
3294	576	71117476726897	22507	11258	12	0	\N
3296	576	71117540726897	22507	11258	13	0	\N
3297	576	71117780726897	23222	11568	32	0	\N
3304	576	71837780726897	23222	11568	68	0	\N
3305	576	71837815726897	23222	11568	69	0	\N
3306	576	71838490726897	23312	11569	90	0	\N
3313	576	72558490726897	23312	11569	110	0	\N
3314	576	72558509726897	23312	11569	111	0	\N
3315	576	72995647938283	13344	6877	4	0	\N
3318	576	72995660938283	13344	6877	5	0	\N
3319	576	73200100000000	4295	2228	1	0	\N
3321	576	73200110000000	4295	2228	2	0	\N
3325	576	73715659938283	13465	6936	3	0	\N
3327	576	73715671938283	13465	6936	4	0	\N
3330	576	73920210000000	4392	2275	8	0	\N
3332	576	73920290000000	4392	2275	9	0	\N
3333	576	73997521726897	23926	11907	3	0	\N
3334	576	73997521726897	23941	11914	6	0	\N
3335	576	73997521726897	24003	11944	3	0	\N
3338	576	73997533726897	23926	11907	4	0	\N
3339	576	73997533726897	24003	11944	4	0	\N
3340	576	73997545726897	23941	11914	7	0	\N
3342	576	74435671938283	13606	6995	4	0	\N
3343	576	74435684938283	13606	6995	5	0	\N
3344	576	74640250000000	4430	2297	1	0	\N
3345	576	74640250000000	4431	2283	29	0	\N
3346	576	74640250000000	4616	2390	3	0	\N
3347	576	74640250000000	4746	2453	2	0	\N
3349	576	74640260000000	4430	2297	2	0	\N
3350	576	74640270000000	4746	2453	3	0	\N
3351	576	74640370000000	4616	2390	4	0	\N
3352	576	74641053000000	4431	2283	30	0	\N
3353	576	74643923000000	4617	2284	53	0	\N
3360	576	75363923000000	4617	2284	99	0	\N
3361	576	75364373000000	4617	2284	100	0	\N
3362	576	75437544726897	24437	12152	7	0	\N
3364	576	75437578726897	24437	12152	8	0	\N
3366	576	75772594938283	10731	5538	2	0	\N
3368	576	75772614938283	10731	5538	3	0	\N
3370	576	75875702938283	13887	7126	4	0	\N
3371	576	75875702938283	14108	7212	4	0	\N
3373	576	75875702938283	14175	7237	2	0	\N
3374	576	75875715938283	13887	7126	5	0	\N
3375	576	75875715938283	14108	7212	5	0	\N
3376	576	75875722938283	14175	7237	3	0	\N
3382	576	76492644938283	10865	5607	2	0	\N
3383	576	76492644938283	11056	5687	4	0	\N
3384	576	76492644938283	11057	5687	4	0	\N
3385	576	76492664938283	10865	5607	3	0	\N
3386	576	76492684938283	11056	5687	5	0	\N
3392	576	76877618726897	24812	12321	5	0	\N
3393	576	76877618726897	25385	12585	0	0	\N
3394	576	76877618726897	25391	12585	3	0	\N
3395	576	76877618726897	25455	12609	2	0	\N
3396	576	76877618726897	25456	12609	3	0	\N
3398	576	76877629726897	25455	12609	3	0	\N
3399	576	76877630726897	25391	12585	4	0	\N
3400	576	76877630726897	25456	12609	4	0	\N
3269	576	69600040000000	1378	755	1	0	0
3270	576	69600050000000	1378	755	2	0	0
3274	576	70320050000000	1520	832	2	0	0
3276	576	70320070000000	1520	832	3	0	0
3289	576	71040070000000	2533	1332	0	0	0
3301	576	71760080000000	3045	1582	2	0	0
3309	576	72480080000000	3110	1615	2	0	0
3310	576	72480100000000	3110	1615	3	0	0
3320	576	73200100000000	4354	2256	2	0	0
3322	576	73200210000000	4354	2256	3	0	0
3331	576	73920250000000	4391	2277	5	0	0
3348	576	74640250000000	4907	2540	0	0	0
3358	576	75360250000000	5166	2681	2	0	0
3359	576	75360270000000	5166	2681	3	0	0
3379	576	76080290000000	5199	2704	3	0	0
3390	576	76800290000000	5225	2716	1	0	0
3391	576	76800300000000	5225	2716	2	0	0
3367	576	75772594938283	10800	5574	5	0	3
3369	576	75772644938283	10800	5574	6	0	3
3268	576	69395598938283	11991	6171	3	0	4
3271	576	70115598938283	12318	6347	1	0	4
3272	576	70115599938283	12318	6347	2	0	4
3284	576	70835599938283	12414	6402	1	0	4
3285	576	70835600938283	12414	6402	2	0	4
3299	576	71555611938283	12646	6523	3	0	4
3307	576	72275611938283	13180	6790	9	0	4
3308	576	72275647938283	13180	6790	10	0	4
3316	576	72995647938283	13355	6883	3	0	4
3326	576	73715659938283	13574	6980	3	0	4
3328	576	73715671938283	13574	6980	4	0	4
3341	576	74435671938283	13605	6995	0	0	4
3356	576	75155671938283	13884	7124	13	0	4
3357	576	75155702938283	13884	7124	14	0	4
3377	576	75875728938283	14174	7237	9	0	4
3387	576	76595728938283	14349	7324	3	0	4
3388	576	76595740938283	14349	7324	4	0	4
3389	576	76595791938283	15796	8038	6	0	4
3279	576	70397454726897	21924	10971	3	0	9
3293	576	71117466726897	22811	11408	3	0	9
3295	576	71117478726897	22811	11408	4	0	9
3302	576	71837478726897	23221	11590	3	0	9
3303	576	71837499726897	23221	11590	4	0	9
3312	576	72557509726897	23311	11633	2	0	9
3323	576	73277509726897	23744	11826	3	0	9
3324	576	73277521726897	23744	11826	4	0	9
3336	576	73997521726897	24098	11996	2	0	9
3337	576	73997532726897	24098	11996	3	0	9
3355	576	74717544726897	24208	12049	4	0	9
3363	576	75437544726897	24617	12234	17	0	9
3365	576	75437606726897	24617	12234	18	0	9
3380	576	76157606726897	24802	12317	3	0	9
3381	576	76157618726897	24802	12317	4	0	9
3401	576	76877641726897	24812	12321	6	0	\N
3403	576	77315739938284	14896	7420	0	0	\N
3404	576	77315740938283	14619	7418	0	0	\N
3405	576	77315740938283	14620	7453	3	0	\N
3406	576	77315740938283	14686	7479	3	0	\N
3407	576	77315740938283	14898	7590	4	0	\N
3408	576	77315740938283	14935	7609	5	0	\N
3409	576	77315752938283	14620	7453	4	0	\N
3410	576	77315752938283	14686	7479	4	0	\N
3411	576	77315763938283	14935	7609	6	0	\N
3414	576	77316040938283	14683	7419	30	0	\N
3415	576	77520300000000	5589	2905	0	0	\N
3416	576	77520300000000	5922	3068	1	0	\N
3418	576	77520310000000	5922	3068	2	0	\N
3420	576	77597642726897	25713	12720	9	0	\N
3422	576	77597642726897	25771	12743	9	0	\N
3424	576	77597678726897	25713	12720	10	0	\N
3425	576	77597678726897	25771	12743	10	0	\N
3426	576	78035790938283	14683	7419	31	0	\N
3431	576	78317654726897	25906	12804	7	0	\N
3432	576	78317654726897	26314	13016	3	0	\N
3435	576	78317666726897	26314	13016	4	0	\N
3436	576	78317688726897	25906	12804	8	0	\N
3437	576	78755813938283	16132	8202	2	0	\N
3438	576	78755813938283	16310	8287	7	0	\N
3439	576	78755813938283	16393	8334	2	0	\N
3441	576	78755815938283	16393	8334	3	0	\N
3442	576	78755824938283	16132	8202	3	0	\N
3443	576	78755838938283	16310	8287	8	0	\N
3447	576	79037665726897	26551	13137	3	0	\N
3449	576	79037677726897	26551	13137	4	0	\N
3451	576	79475815938283	16662	8335	24	0	\N
3452	576	79475850938283	16664	8465	3	0	\N
3455	576	79475862938283	16664	8465	4	0	\N
3456	576	79476072938283	16662	8335	25	0	\N
3462	576	80196072938283	16729	8336	0	0	\N
3463	576	80400440000000	7748	4016	1	0	\N
3465	576	80400450000000	7748	4016	2	0	\N
3467	576	80477702726897	27044	13233	14	0	\N
3470	576	80477735726897	27044	13233	15	0	\N
3472	576	80916072938283	16810	8337	8	0	\N
3473	576	80916224938283	16810	8337	9	0	\N
3478	576	81197735726897	27164	13234	6	0	\N
3479	576	81197741726897	27164	13234	7	0	\N
3481	576	81635861938283	17885	9026	7	0	\N
3483	576	81635886938283	17885	9026	8	0	\N
3484	576	81840470000000	8044	4168	1	0	\N
3485	576	81840470000000	8090	4195	1	0	\N
3487	576	81840470000000	8469	4387	5	0	\N
3488	576	81840480000000	8044	4168	2	0	\N
3489	576	81840480000000	8090	4195	2	0	\N
3491	576	81840520000000	8469	4387	6	0	\N
3492	576	81917726726897	27436	13562	3	0	\N
3493	576	81917726726897	27657	13667	3	0	\N
3496	576	81917738726897	27436	13562	4	0	\N
3497	576	81917738726897	27657	13667	4	0	\N
3498	576	82355886938283	18257	9196	1	0	\N
3500	576	82355887938283	18257	9196	2	0	\N
3506	576	83075898938283	18312	9225	3	0	\N
3507	576	83075898938283	18419	9286	3	0	\N
3509	576	83075910938283	18312	9225	4	0	\N
3510	576	83075910938283	18419	9286	4	0	\N
3514	576	83357762726897	28837	14224	3	0	\N
3515	576	83357762726897	28889	14250	0	0	\N
3517	576	83357774726897	28837	14224	4	0	\N
3519	576	83795920938283	18667	9406	2	0	\N
3520	576	83795920938283	19415	9785	3	0	\N
3521	576	83795920938283	20005	10072	5	0	\N
3522	576	83795931938283	18667	9406	3	0	\N
3523	576	83795932938283	19415	9785	4	0	\N
3524	576	83796042938283	20005	10072	6	0	\N
3525	576	84000550000000	8804	4564	0	0	\N
3532	576	84725371726895	20371	10262	17	0	\N
3533	576	84725371726895	20518	10329	4	0	\N
3534	576	84725371726895	20521	10329	6	0	\N
3536	576	84725371726895	20775	10439	6	0	\N
3429	576	78240360000000	6495	3366	2	0	0
3430	576	78240380000000	6495	3366	3	0	0
3445	576	78960380000000	6931	3577	4	0	0
3446	576	78960420000000	6931	3577	5	0	0
3457	576	79680420000000	7138	3688	2	0	0
3464	576	80400440000000	7845	4066	2	0	0
3466	576	80400460000000	7845	4066	3	0	0
3474	576	81120460000000	7929	4111	1	0	0
3475	576	81120470000000	7929	4111	2	0	0
3486	576	81840470000000	8468	4387	5	0	0
3502	576	82560520000000	8553	4431	1	0	0
3503	576	82560530000000	8553	4431	2	0	0
3512	576	83280530000000	8777	4553	2	0	0
3513	576	83280550000000	8777	4553	3	0	0
3527	576	84000590000000	8805	4565	5	0	0
3412	576	77315791938283	15796	8038	17	0	4
3413	576	77315801938283	15796	8038	18	0	4
3427	576	78035801938283	15922	8095	3	0	4
3428	576	78035813938283	15922	8095	4	0	4
3444	576	78755850938283	16394	8339	11	0	4
3453	576	79475850938283	16731	8497	2	0	4
3454	576	79475861938283	16731	8497	3	0	4
3461	576	80195861938283	16811	8532	0	0	4
3471	576	80915861938283	17779	8983	0	0	4
3482	576	81635886938283	17884	9026	8	0	4
3499	576	82355886938283	18258	9196	3	0	4
3501	576	82355898938283	18258	9196	4	0	4
3508	576	83075898938283	18633	9389	4	0	4
3528	576	84005346726895	20275	10211	7	0	4
3529	576	84005371726895	20275	10211	8	0	4
3535	576	84725371726895	20773	10439	12	0	4
3402	576	76877642726897	25558	12655	7	0	9
3421	576	77597642726897	25770	12745	3	0	9
3433	576	78317654726897	26316	13016	2	0	9
3434	576	78317665726897	26316	13016	3	0	9
3448	576	79037665726897	26644	13181	6	0	9
3450	576	79037689726897	26644	13181	7	0	9
3459	576	79757689726897	26696	13204	4	0	9
3468	576	80477702726897	27045	13371	3	0	9
3469	576	80477714726897	27045	13371	4	0	9
3476	576	81197714726897	27165	13433	3	0	9
3477	576	81197726726897	27165	13433	4	0	9
3495	576	81917737726897	28382	14030	3	0	9
3504	576	82637737726897	28724	14175	7	0	9
3505	576	82637762726897	28724	14175	8	0	9
3516	576	83357762726897	28892	14252	6	0	9
3518	576	83357786726897	28892	14252	7	0	9
3531	576	84077799726897	29106	14348	5	0	9
3537	576	84725393726895	20518	10329	5	0	\N
3538	576	84725395726895	20521	10329	7	0	\N
3539	576	84725397726895	20371	10262	18	0	\N
3540	576	84725494726895	20775	10439	7	0	\N
3545	576	84797836726897	29771	14673	6	0	\N
3546	576	85055674938283	10566	5457	2	0	\N
3547	576	85055694938283	10566	5457	3	0	\N
3548	576	85517812726897	29472	14534	3	0	\N
3549	576	85517824726897	29472	14534	4	0	\N
3551	576	85517836726897	29771	14673	16	0	\N
3552	576	85517845701738	29771	14673	18	1	\N
3554	596	66720000000000	246	145	4	0	\N
3555	596	66720000000000	387	221	2	0	\N
3558	596	66720020000000	387	221	3	0	\N
3559	596	66720130000000	246	145	5	0	\N
3572	596	71760102000000	2311	1210	3	0	\N
3573	596	71760102000000	2313	1203	13	0	\N
3576	596	71760132000000	2311	1210	4	0	\N
3577	596	71760232000000	2313	1203	14	0	\N
3588	596	76080212000000	3237	1681	1	0	\N
3590	596	76080222000000	3237	1681	2	0	\N
3591	596	76800212000000	3525	1830	0	0	\N
3598	596	78960252000000	4526	2342	1	0	\N
3599	596	78960252000000	4635	2397	1	0	\N
3601	596	78960262000000	4526	2342	2	0	\N
3602	596	78960262000000	4635	2397	2	0	\N
3606	596	80400282000000	5440	2831	1	0	\N
3608	596	80400283000000	5440	2831	2	0	\N
3610	596	81120292000000	5834	3028	1	0	\N
3612	596	81120302000000	5834	3028	2	0	\N
3614	596	81840302000000	6033	3131	1	0	\N
3616	596	81840312000000	6033	3131	2	0	\N
3618	596	82560322000000	6459	3346	4	0	\N
3619	596	82560322000000	7006	3614	2	0	\N
3620	596	82560322000000	7100	3665	2	0	\N
3621	596	82560322000000	7102	3665	1	0	\N
3622	596	82560322000000	7166	3701	1	0	\N
3623	596	82560322000000	7500	3881	1	0	\N
3624	596	82560322000000	7571	3919	1	0	\N
3625	596	82560322000000	7572	3886	3	0	\N
3626	596	82560322000000	8220	4260	2	0	\N
3628	596	82560332000000	7102	3665	2	0	\N
3629	596	82560332000000	7166	3701	2	0	\N
3630	596	82560332000000	7500	3881	2	0	\N
3631	596	82560332000000	7571	3919	2	0	\N
3633	596	82560334000000	7572	3886	4	0	\N
3634	596	82560342000000	7006	3614	3	0	\N
3635	596	82560342000000	7100	3665	3	0	\N
3636	596	82560362000000	6459	3346	5	0	\N
3637	596	82560432000000	8220	4260	3	0	\N
3638	596	83280332000000	8568	4441	1	0	\N
3639	596	83280332000000	8695	4508	1	0	\N
3641	596	83280342000000	8568	4441	2	0	\N
3642	596	83280342000000	8695	4508	2	0	\N
3646	596	84720362000000	9162	4748	4	0	\N
3647	596	84720402000000	9162	4748	5	0	\N
3650	599	67440012000000	18305	9221	2	0	\N
3652	599	67440023000000	18305	9221	3	0	\N
3654	603	66720000000000	7826	4058	1	0	\N
3655	603	66720010000000	7826	4058	2	0	\N
3658	606	200001600	6399	3316	4	1	\N
3659	606	66720000000000	289	165	1	0	\N
3661	606	66720010000000	289	165	2	0	\N
3663	606	67440010000000	332	191	1	0	\N
3665	606	67440020000000	332	191	2	0	\N
3667	606	67486513286230	20567	10351	8	0	\N
3668	606	67486513286230	20585	10356	10	0	\N
3669	606	67486513286230	21317	10701	13	0	\N
3670	606	67486513286230	21318	10701	13	0	\N
3672	606	67486548286230	20567	10351	9	0	\N
3664	606	67440010000000	569	321	1	0	0
3666	606	67440020000000	569	321	2	0	0
3556	596	66720000000000	979	544	1	0	0
3557	596	66720010000000	979	544	2	0	0
3560	596	67440010000000	1259	697	1	0	0
3562	596	68160020000000	1303	718	3	0	0
3563	596	68160041000000	1303	718	4	0	0
3564	596	68880041000000	1374	753	2	0	0
3565	596	68880061000000	1374	753	3	0	0
3566	596	69600061000000	1479	807	3	0	0
3568	596	70320082000000	1976	1044	1	0	0
3569	596	70320092000000	1976	1044	2	0	0
3570	596	71040092000000	2110	1112	1	0	0
3571	596	71040102000000	2110	1112	2	0	0
3575	596	71760112000000	2450	1282	2	0	0
3578	596	72480112000000	2462	1289	2	0	0
3579	596	72480132000000	2462	1289	3	0	0
3580	596	73200132000000	2802	1465	3	0	0
3581	596	73200162000000	2802	1465	4	0	0
3583	596	73920182000000	2863	1498	3	0	0
3584	596	74640182000000	2967	1541	1	0	0
3585	596	74640192000000	2967	1541	2	0	0
3586	596	75360192000000	3044	1581	2	0	0
3587	596	75360212000000	3044	1581	3	0	0
3592	596	76800212000000	3958	2058	1	0	0
3593	596	76800222000000	3958	2058	2	0	0
3594	596	77520222000000	4145	2156	2	0	0
3595	596	77520242000000	4145	2156	3	0	0
3597	596	78240252000000	4489	2326	2	0	0
3600	596	78960252000000	4664	2411	1	0	0
3603	596	78960262000000	4664	2411	2	0	0
3604	596	79680262000000	5364	2786	2	0	0
3605	596	79680282000000	5364	2786	3	0	0
3609	596	80400292000000	5779	2998	2	0	0
3611	596	81120292000000	5911	3064	1	0	0
3613	596	81120302000000	5911	3064	2	0	0
3615	596	81840302000000	6436	3331	2	0	0
3617	596	81840322000000	6436	3331	3	0	0
3657	603	66721210000000	8470	4388	2	0	0
3627	596	82560322000000	8566	4440	1	0	0
3632	596	82560332000000	8566	4440	2	0	0
3640	596	83280332000000	8708	4516	1	0	0
3644	596	84000342000000	8932	4631	2	0	0
3645	596	84000362000000	8932	4631	3	0	0
3648	599	66720000000000	18067	9112	3	0	0
3649	599	66720012000000	18067	9112	4	0	0
3651	599	67440012000000	19233	9698	3	0	0
3541	576	84725554726895	20773	10439	13	0	4
3671	606	67486513286230	21319	10701	13	0	18
3542	576	84797799726897	29247	14414	4	0	9
3543	576	84797812726897	29247	14414	5	0	9
3544	576	84797836726897	29770	14673	6	0	9
3553	576	85517857726738	29770	14673	30	0	9
3673	606	67486562286230	21317	10701	14	0	\N
3674	606	67486562286230	21318	10701	14	0	\N
3676	606	67486595286230	20585	10356	11	0	\N
3677	606	67819584812962	10379	5366	6	0	\N
3680	606	67820044812962	10379	5366	7	0	\N
3681	606	68160020000000	746	418	1	0	\N
3683	606	68160030000000	746	418	2	0	\N
3685	606	68206562286230	21465	10769	10	0	\N
3688	606	68206599286230	21465	10769	11	0	\N
3690	606	68206608286230	22726	11362	4	0	\N
3691	606	68206608286230	22727	11362	4	0	\N
3696	606	68926586286230	22347	11186	4	0	\N
3697	606	68926586286230	22407	11217	2	0	\N
3698	606	68926586286230	22408	11217	3	0	\N
3699	606	68926597286230	22407	11217	3	0	\N
3700	606	68926598286230	22408	11217	4	0	\N
3701	606	68926599286230	22347	11186	5	0	\N
3703	606	68926608286230	22726	11362	5	0	\N
3704	606	68926608286230	22727	11362	5	0	\N
3705	606	69259646812962	10751	5548	3	0	\N
3707	606	69259676812962	10751	5548	4	0	\N
3709	606	69600050000000	1951	1034	1	0	\N
3711	606	69600060000000	1951	1034	2	0	\N
3714	606	69979686812962	10929	5635	8	0	\N
3715	606	69979686812962	10933	5636	2	0	\N
3716	606	69979686812962	11278	5794	2	0	\N
3718	606	69979697812962	11278	5794	3	0	\N
3719	606	69979706812962	10933	5636	3	0	\N
3721	606	69979757812962	10929	5635	9	0	\N
3722	606	70320050000000	2393	1250	1	0	\N
3724	606	70320060000000	2393	1250	2	0	\N
3728	606	70699719812962	11629	5985	1	0	\N
3729	606	70699719812962	11830	6080	2	0	\N
3730	606	70699719812962	11903	6120	2	0	\N
3732	606	70699720812962	11629	5985	2	0	\N
3733	606	70699721812962	11830	6080	3	0	\N
3734	606	70699721812962	11903	6120	3	0	\N
3736	606	71037746812962	14892	7589	2	0	\N
3737	606	71037746812962	14894	7589	2	0	\N
3738	606	71037746812962	14895	7589	2	0	\N
3739	606	71040070000000	2488	1303	1	0	\N
3740	606	71040070000000	2622	1378	1	0	\N
3742	606	71040080000000	2488	1303	2	0	\N
3743	606	71040080000000	2622	1378	2	0	\N
3745	606	71086633286230	22958	11471	4	0	\N
3746	606	71086633286230	22969	11475	2	0	\N
3748	606	71086644286230	22969	11475	3	0	\N
3749	606	71086646286230	22958	11471	5	0	\N
3751	606	71419721812962	12158	6261	2	0	\N
3752	606	71419721812962	12159	6261	1	0	\N
3753	606	71419721812962	12431	6409	0	0	\N
3754	606	71419721812962	12433	6409	0	0	\N
3755	606	71419721812962	12457	6418	0	0	\N
3757	606	71419731812962	12159	6261	2	0	\N
3758	606	71419732812962	12158	6261	3	0	\N
3760	606	71419742812962	13072	6737	1	0	\N
3761	606	71419742812962	13074	6737	1	0	\N
3762	606	71757726812962	15145	7720	2	0	\N
3763	606	71757726812962	15146	7709	26	0	\N
3765	606	71757737812962	15145	7720	3	0	\N
3767	606	71757746812962	14892	7589	9	0	\N
3768	606	71757746812962	14894	7589	9	0	\N
3769	606	71757746812962	14895	7589	9	0	\N
3770	606	71757752812962	14892	7589	10	0	\N
3771	606	71757752812962	14894	7589	10	0	\N
3772	606	71757752812962	14895	7589	10	0	\N
3773	606	71757896812962	15146	7709	27	0	\N
3774	606	71758336812962	15196	7710	44	0	\N
3779	606	72137702812962	13491	6948	5	0	\N
3780	606	72137702812962	13492	6948	9	0	\N
3781	606	72137702812962	14204	7249	8	0	\N
3782	606	72137702812962	14269	7285	1	0	\N
3784	606	72137712812962	14269	7285	2	0	\N
3786	606	72137728812962	14204	7249	9	0	\N
3787	606	72137734812962	13491	6948	6	0	\N
3788	606	72137738812962	13492	6948	10	0	\N
3789	606	72139742812962	13072	6737	5	0	\N
3790	606	72139742812962	13074	6737	2	0	\N
3791	606	72139745812962	13072	6737	6	0	\N
3792	606	72477737812962	15438	7863	5	0	\N
3793	606	72477737812962	15440	7857	28	0	\N
3796	606	72477760812962	15438	7863	6	0	\N
3797	606	72477873812962	15440	7857	29	0	\N
3798	606	72478336812962	15196	7710	77	0	\N
3799	606	72478395812962	15196	7710	78	0	\N
3804	606	72857726812962	14670	7475	9	0	\N
3805	606	72857798812962	14670	7475	10	0	\N
3806	606	73197748812962	15727	7996	4	0	\N
3807	606	73197748812962	15855	8063	6	0	\N
3694	606	68880030000000	1931	1027	2	0	0
3695	606	68880050000000	1931	1027	3	0	0
3710	606	69600050000000	2268	1190	0	0	0
3723	606	70320050000000	2394	1251	2	0	0
3725	606	70320070000000	2394	1251	3	0	0
3744	606	71040080000000	2733	1435	2	0	0
3775	606	71760080000000	3235	1680	4	0	0
3776	606	71760120000000	3235	1680	5	0	0
3800	606	72480120000000	3250	1687	1	0	0
3801	606	72480130000000	3250	1687	2	0	0
3679	606	67819604812962	10516	5431	3	0	8
3692	606	68539604812962	10689	5519	5	0	8
3693	606	68539646812962	10689	5519	6	0	8
3706	606	69259646812962	10801	5575	4	0	8
3717	606	69979686812962	11444	5879	6	0	8
3720	606	69979719812962	11444	5879	7	0	8
3731	606	70699719812962	11976	6164	2	0	8
3735	606	70699721812962	11976	6164	3	0	8
3756	606	71419721812962	12948	6674	2	0	8
3783	606	72137702812962	14521	7405	6	0	11
3785	606	72137726812962	14521	7405	7	0	11
3764	606	71757726812962	15195	7743	2	0	12
3766	606	71757737812962	15195	7743	3	0	12
3794	606	72477737812962	15620	7951	2	0	12
3808	606	73197748812962	15924	8096	6	0	12
3675	606	67486562286230	21319	10701	14	0	18
3686	606	68206562286230	21624	10834	6	0	18
3687	606	68206586286230	21624	10834	7	0	18
3702	606	68926608286230	22725	11362	5	0	18
3712	606	69646608286230	22780	11393	4	0	18
3713	606	69646621286230	22780	11393	5	0	18
3726	606	70366621286230	22872	11433	3	0	18
3727	606	70366633286230	22872	11433	4	0	18
3750	606	71086646286230	23113	11544	5	0	18
3777	606	71806646286230	23743	11825	2	0	18
3778	606	71806657286230	23743	11825	3	0	18
3802	606	72526657286230	24598	12227	2	0	18
3803	606	72526668286230	24598	12227	3	0	18
3809	606	73197761812962	15727	7996	5	0	\N
3810	606	73197772812962	15855	8063	7	0	\N
3812	606	73200130000000	3651	1894	0	0	\N
3815	606	73246668286230	24610	12232	3	0	\N
3816	606	73246668286230	24684	12262	10	0	\N
3817	606	73246668286230	24755	12293	3	0	\N
3818	606	73246668286230	24757	12293	2	0	\N
3820	606	73246679286230	24757	12293	3	0	\N
3821	606	73246680286230	24610	12232	4	0	\N
3822	606	73246680286230	24755	12293	4	0	\N
3824	606	73246705286230	24684	12262	11	0	\N
3829	606	73966680286230	24884	12355	3	0	\N
3831	606	73966692286230	24884	12355	4	0	\N
3833	606	74637783812962	16013	8142	4	0	\N
3834	606	74637783812962	16257	8262	3	0	\N
3835	606	74637783812962	16271	8271	8	0	\N
3836	606	74637783812962	16481	8381	3	0	\N
3838	606	74637783812962	16632	8449	5	0	\N
3839	606	74637795812962	16257	8262	4	0	\N
3840	606	74637795812962	16481	8381	4	0	\N
3841	606	74637796812962	16013	8142	5	0	\N
3842	606	74637809812962	16271	8271	9	0	\N
3843	606	74637816812962	16632	8449	6	0	\N
3845	606	74638007812962	16855	8528	19	0	\N
3846	606	74640150000000	4374	2268	1	0	\N
3847	606	74640150000000	4513	2334	2	0	\N
3849	606	74640160000000	4374	2268	2	0	\N
3850	606	74640170000000	4513	2334	3	0	\N
3852	606	74686795286230	25467	12615	3	0	\N
3853	606	74686795286230	25515	12634	3	0	\N
3855	606	74686807286230	25467	12615	4	0	\N
3856	606	74686807286230	25515	12634	4	0	\N
3860	606	75358007812962	16855	8528	81	0	\N
3861	606	75358131812962	16855	8528	82	0	\N
3862	606	75358206812962	17328	8762	62	0	\N
3863	606	75360180000000	4757	2457	1	0	\N
3864	606	75360180000000	4758	2458	1	0	\N
3865	606	75360180000000	5420	2819	0	0	\N
3867	606	75360190000000	4757	2457	2	0	\N
3868	606	75360190000000	4758	2458	2	0	\N
3874	606	76078206812962	17328	8762	68	0	\N
3875	606	76078211812962	17328	8762	69	0	\N
3880	606	76797840812962	17641	8918	3	0	\N
3881	606	76797840812962	17763	8974	3	0	\N
3883	606	76797852812962	17641	8918	4	0	\N
3884	606	76797852812962	17763	8974	4	0	\N
3888	606	76800260000000	7370	3806	7	0	\N
3889	606	76846865286230	26423	13072	3	0	\N
3890	606	76846865286230	26697	13204	4	0	\N
3892	606	76846877286230	26423	13072	4	0	\N
3894	606	76846878286230	26697	13204	5	0	\N
3895	606	77517858812962	18340	9240	0	0	\N
3897	606	77517858812962	18416	9284	7	0	\N
3898	606	77517892812962	18416	9284	8	0	\N
3900	606	77520190000000	6960	3590	2	0	\N
3902	606	77520210000000	6399	3316	3	0	\N
3903	606	77520210000000	6400	3316	3	0	\N
3904	606	77520210000000	6554	3396	3	0	\N
3905	606	77520210000000	6960	3590	3	0	\N
3906	606	77520231000000	6554	3396	4	0	\N
3907	606	77520240000000	6400	3316	4	0	\N
3909	606	77520260000000	7370	3806	8	0	\N
3912	606	77567071286230	27030	13356	33	0	\N
3914	606	78237895812962	18681	9372	92	0	\N
3916	606	78238437812962	18681	9372	93	0	\N
3917	606	78240250000000	7379	3809	1	0	\N
3918	606	78240250000000	8054	4172	1	0	\N
3920	606	78240260000000	7379	3809	2	0	\N
3921	606	78240260000000	8054	4172	2	0	\N
3922	606	78240290000000	8782	4555	4	0	\N
3923	606	78240290000000	8783	4555	4	0	\N
3924	606	78286803286230	27072	13384	2	0	\N
3925	606	78286814286230	27072	13384	3	0	\N
3926	606	78286903286230	27031	13368	3	0	\N
3927	606	78286903286230	27034	13368	2	0	\N
3929	606	78286914286230	27034	13368	3	0	\N
3930	606	78286915286230	27031	13368	4	0	\N
3932	606	78287070286231	27030	13356	34	0	\N
3933	606	78957951812962	18739	9442	4	0	\N
3934	606	78957951812962	18740	9442	3	0	\N
3936	606	78957963812962	18740	9442	4	0	\N
3937	606	78957964812962	18739	9442	5	0	\N
3939	606	78960250000000	8660	4484	1	0	\N
3940	606	78960250000000	8850	4586	2	0	\N
3942	606	78960260000000	8660	4484	2	0	\N
3943	606	78960270000000	8850	4586	3	0	\N
3827	606	73920140000000	4349	2253	1	0	0
3828	606	73920150000000	4349	2253	2	0	0
3848	606	74640150000000	4596	2377	3	0	0
3851	606	74640180000000	4596	2377	4	0	0
3866	606	75360180000000	5835	3028	1	0	0
3876	606	76080190000000	6269	3248	1	0	0
3877	606	76080200000000	6269	3248	2	0	0
3886	606	76800200000000	6322	3272	1	0	0
3887	606	76800210000000	6322	3272	2	0	0
3901	606	77520190000000	7371	3806	6	0	1
3919	606	78240250000000	8431	4369	0	0	1
3941	606	78960250000000	8861	4592	2	0	1
3944	606	78960270000000	8861	4592	3	0	1
3811	606	73197772812962	15924	8096	7	0	12
3826	606	73917783812962	15929	8098	3	0	12
3837	606	74637783812962	16631	8449	6	0	12
3844	606	74637817812962	16631	8449	7	0	12
3858	606	75357817812962	16854	8551	3	0	12
3859	606	75357829812962	16854	8551	4	0	12
3873	606	76077840812962	17327	8778	3	0	12
3882	606	76797840812962	18205	9173	6	0	12
3885	606	76797858812962	18205	9173	7	0	12
3896	606	77517858812962	18415	9284	10	0	12
3899	606	77517895812962	18415	9284	11	0	12
3915	606	78237951812962	18680	9411	12	0	12
3935	606	78957951812962	18948	9558	3	0	12
3938	606	78957972812962	18948	9558	4	0	12
3819	606	73246668286230	24828	12328	3	0	18
3830	606	73966680286230	25403	12589	7	0	18
3832	606	73966795286230	25403	12589	8	0	18
3854	606	74686795286230	25613	12676	3	0	18
3857	606	74686807286230	25613	12676	4	0	18
3870	606	75406807286230	25849	12779	6	0	18
3878	606	76126831286230	26366	13040	7	0	18
3879	606	76126865286230	26366	13040	8	0	18
3891	606	76846865286230	26848	13280	3	0	18
3893	606	76846877286230	26848	13280	4	0	18
3910	606	77566877286230	26960	13334	7	0	18
3928	606	78286903286230	27073	13384	3	0	18
3931	606	78286915286230	27073	13384	4	0	18
3945	606	78960290000000	8782	4555	5	0	\N
3946	606	78960290000000	8783	4555	5	0	\N
3947	606	79006915286230	27120	13409	3	0	\N
3949	606	79006927286230	27120	13409	4	0	\N
3955	606	79726927286230	27540	13614	3	0	\N
3957	606	79726939286230	27540	13614	4	0	\N
3959	606	79727201286230	29098	14190	1	0	\N
3960	606	80398037812962	19359	9759	15	0	\N
3961	606	80398037812962	19674	9909	18	0	\N
3964	606	80398115812962	19359	9759	16	0	\N
3965	606	80398181812962	19674	9909	19	0	\N
3968	606	80446951286230	27751	13709	2	0	\N
3969	606	80446951286230	28047	13871	3	0	\N
3971	606	80446962286230	27751	13709	3	0	\N
3972	606	80446963286230	28047	13871	4	0	\N
3974	606	80446997286230	29199	14394	6	0	\N
3976	606	80446997286230	29204	14394	6	0	\N
3977	606	80447201286230	29098	14190	13	0	\N
3978	606	80447274824690	29098	14190	14	0	\N
3981	606	81120310000000	9122	4725	2	0	\N
3983	606	81120330000000	9122	4725	3	0	\N
3986	606	81166997286230	29199	14394	9	0	\N
3987	606	81166997286230	29204	14394	9	0	\N
3988	606	81166999286230	29199	14394	10	0	\N
3989	606	81166999286230	29204	14394	10	0	\N
3992	606	81838172812962	19954	10048	13	0	\N
3995	606	81838221812962	19954	10048	14	0	\N
4006	606	82607092286229	29479	14537	11	0	\N
4007	606	82607092286229	29481	14537	11	0	\N
4008	606	83280390000000	9844	5102	2	0	\N
4009	606	83280410000000	9844	5102	3	0	\N
4011	606	83327092286229	29479	14537	12	0	\N
4012	606	83327092286229	29481	14537	12	0	\N
4015	606	84766008286229	30024	14783	8	0	\N
4017	606	84766008286229	30026	14783	2	0	\N
4018	606	84766019286229	30026	14783	3	0	\N
4020	606	84766025286229	30024	14783	9	0	\N
4022	606	85486024286229	30140	14830	11	0	\N
4023	606	85486024286229	30141	14830	6	0	\N
4024	606	85486030286229	30141	14830	7	0	\N
4025	606	85486044286229	30140	14830	12	0	\N
4029	607	67440001000000	14085	7205	9	0	\N
4030	607	67440037000000	14085	7205	10	0	\N
4031	608	14405161000008	6422	3050	91	0	\N
4033	610	66000000001310	27685	13681	8	1	\N
4035	610	66720000000000	25096	12456	3	0	\N
4037	610	66720012000000	25096	12456	4	0	\N
4043	610	67440032000000	26598	13158	6	0	\N
4044	610	67440032000000	27087	13392	6	0	\N
4045	610	67440032000000	27685	13681	7	0	\N
4046	610	67440032000000	27834	13756	3	0	\N
4048	610	67440044000000	27834	13756	4	0	\N
4050	610	67440056000000	26598	13158	7	0	\N
4051	610	67440056000000	27087	13392	7	0	\N
4052	610	68160024000000	25705	12718	3	0	\N
4053	610	68160024000000	25784	12752	6	0	\N
4054	610	68160036000000	25705	12718	4	0	\N
4055	610	68160044000000	27962	13832	7	0	\N
4056	610	68160044000000	28406	14039	2	0	\N
4057	610	68160044000000	28448	14059	4	0	\N
4059	610	68160048000000	25784	12752	7	0	\N
4060	610	68160055000000	28406	14039	3	0	\N
4062	610	68160066000000	28448	14059	5	0	\N
4063	610	68160078000000	27962	13832	8	0	\N
4064	610	68880056000000	28595	14121	9	0	\N
4065	610	68880056000000	29460	14527	7	0	\N
4066	610	68880056000000	29497	14544	3	0	\N
4067	610	68880056000000	30236	14865	10	0	\N
4068	610	68880056000000	30249	14873	11	0	\N
4070	610	68880068000000	29497	14544	4	0	\N
4072	610	68880075000000	30236	14865	11	0	\N
4073	610	68880076000000	30249	14873	12	0	\N
4074	610	68880085500000	29460	14527	8	0	\N
4075	610	68880110000000	28595	14121	10	0	\N
4076	613	15840301001008	12838	6620	3	0	\N
4077	613	20880645000000	10701	5524	9	1	\N
4078	613	66720000000000	3494	1662	0	0	\N
4079	618	66720000000000	1821	975	1	0	\N
4080	618	66720000000000	5149	2670	2	0	\N
3966	606	80400290000000	9110	4720	2	0	1
3967	606	80400310000000	9110	4720	3	0	1
3982	606	81120310000000	9575	4966	2	0	1
3984	606	81120330000000	9575	4966	3	0	1
3996	606	81840330000000	9628	4996	2	0	1
4001	606	82560350000000	9702	5033	4	0	1
4002	606	82560390000000	9702	5033	5	0	1
4027	607	66720000000000	11979	6165	1	0	0
4028	607	66720001000000	11979	6165	2	0	0
3951	606	79677972812962	19311	9738	11	0	12
3962	606	80398037812962	19816	9981	5	0	12
3963	606	80398060812962	19816	9981	6	0	12
3979	606	81118060812962	19913	10028	4	0	12
3980	606	81118172812962	19913	10028	5	0	12
3994	606	81838213812962	19955	10048	6	0	12
3990	606	81555194812962	20196	10171	6	0	14
3991	606	81555227812962	20196	10171	7	0	14
4032	608	66000020000000	23699	11802	9	1	0
4036	610	66720000000000	25211	12505	3	0	0
4041	610	67440012000000	25441	12604	3	0	0
4042	610	67440024000000	25441	12604	4	0	0
4034	610	66000031000000	26082	12889	1	0	3
4039	610	66720031000000	26082	12889	3	0	3
4040	610	66720032000000	26082	12889	4	0	3
3950	606	79006927286230	27453	13568	4	0	18
3956	606	79726927286230	27599	13641	6	0	18
3958	606	79726951286230	27599	13641	7	0	18
4047	610	67440032000000	27929	13815	3	0	3
4058	610	68160044000000	28501	14085	3	0	3
4061	610	68160056000000	28501	14085	4	0	3
3970	606	80446951286230	29094	14344	4	0	18
3973	606	80446964286230	29094	14344	5	0	18
3975	606	80446997286230	29203	14394	6	0	18
3998	606	81886997286229	29309	14443	3	0	18
3999	606	81887009286229	29309	14443	4	0	18
4000	606	81887019286229	29411	14501	1	0	18
4003	606	82607019286229	29411	14501	10	0	18
4004	606	82607045286229	29411	14501	11	0	18
4010	606	83327092286229	29477	14537	12	0	18
4013	606	84047092286229	29651	14623	7	0	18
4014	606	84047108286229	29651	14623	8	0	18
4016	606	84766008286229	30025	14783	7	0	19
4021	606	85486024286229	30137	14830	14	0	19
4026	606	85486047286229	30137	14830	15	0	19
4069	610	68880056000000	30287	14891	6	0	3
4071	610	68880071000000	30287	14891	7	0	3
4081	618	66720000000000	5880	3048	2	0	\N
4083	618	66720010000000	1821	975	2	0	\N
4084	618	66720020000000	5149	2670	3	0	\N
4085	618	66720020000000	5880	3048	3	0	\N
4087	618	67440020000000	9376	4864	3	0	\N
4088	618	67440050000000	9376	4864	4	0	\N
4089	621	66720000000000	9130	4729	1	0	\N
4091	621	66720010000000	9130	4729	2	0	\N
4093	621	66720168000000	17961	8954	94	0	\N
4096	621	67440168000000	17961	8954	95	0	\N
4097	621	68160044000000	23944	11915	3	0	\N
4099	621	68160056000000	23944	11915	4	0	\N
4102	621	68880057000000	26580	13078	6	0	\N
4103	621	68880063000000	26580	13078	7	0	\N
4107	623	67439940000000	27397	13548	3	0	\N
4108	623	67439940000000	28385	14032	2	0	\N
4109	623	67439951000000	28385	14032	3	0	\N
4110	623	67439952000000	27397	13548	4	0	\N
4114	632	200000002	20185	9927	126	1	\N
4115	632	200000004	23877	11814	126	1	\N
4116	632	66720000000000	26	15	2	0	\N
4117	632	66720000000000	422	241	1	0	\N
4119	632	66720010000000	422	241	2	0	\N
4121	632	66720020000000	26	15	3	0	\N
4124	632	68160060000000	1274	702	1	0	\N
4126	632	68160070000000	1274	702	2	0	\N
4132	632	69597201000000	20441	10294	2	0	\N
4134	632	69597212000000	20441	10294	3	0	\N
4136	632	69600080000000	2131	1126	1	0	\N
4137	632	69600080000000	2164	1143	1	0	\N
4139	632	69600090000000	2131	1126	2	0	\N
4140	632	69600090000000	2164	1143	2	0	\N
4142	632	69602224000000	20185	9927	35	0	\N
4145	632	70317277000000	20936	10526	9	0	\N
4147	632	70317380000000	20936	10526	10	0	\N
4151	632	70322224000000	20185	9927	125	0	\N
4152	632	70460921000000	17300	8764	6	0	\N
4154	632	70460945000000	17300	8764	7	0	\N
4156	632	71037489000000	21470	10770	3	0	\N
4158	632	71037501000000	21470	10770	4	0	\N
4166	632	71760130000000	3464	1799	0	0	\N
4172	632	72480130000000	3878	2014	1	0	\N
4173	632	72480130000000	3962	2060	1	0	\N
4175	632	72480140000000	3878	2014	2	0	\N
4176	632	72480140000000	3962	2060	2	0	\N
4187	632	73917550000000	22967	11473	3	0	\N
4188	632	73917562000000	22967	11473	4	0	\N
4190	632	73918204000000	23877	11814	40	0	\N
4193	632	74061222000000	17938	9048	3	0	\N
4195	632	74061234000000	17938	9048	4	0	\N
4197	632	74540261000000	4397	2280	10	0	\N
4198	632	74540361000000	4397	2280	11	0	\N
4199	632	74637563000000	23542	11734	2	0	\N
4200	632	74637563000000	23876	11882	20	0	\N
4202	632	74637574000000	23542	11734	3	0	\N
4204	632	74637637000000	23876	11882	21	0	\N
4205	632	74638204000000	23877	11814	125	0	\N
4208	632	74781235000000	18375	9261	3	0	\N
4211	632	74781247000000	18375	9261	4	0	\N
4214	632	75360361000000	4486	2324	1	0	\N
4216	632	75360371000000	4486	2324	2	0	\N
4122	632	67440010000000	676	377	5	0	0
4123	632	67440060000000	676	377	6	0	0
4125	632	68160060000000	1369	750	1	0	0
4127	632	68160070000000	1369	750	2	0	0
4128	632	68880070000000	1575	858	1	0	0
4138	632	69600080000000	2647	1393	1	0	0
4141	632	69600090000000	2647	1393	2	0	0
4149	632	70320090000000	2742	1439	2	0	0
4150	632	70320110000000	2742	1439	3	0	0
4160	632	71040110000000	2871	1502	2	0	0
4167	632	71760130000000	3560	1847	0	0	0
4174	632	72480130000000	4116	2139	2	0	0
4177	632	72480240000000	4116	2139	3	0	0
4182	632	73200240000000	4170	2170	1	0	0
4191	632	73920250000000	4190	2181	2	0	0
4192	632	73920261000000	4190	2181	3	0	0
4206	632	74640261000000	4398	2280	10	0	0
4207	632	74640361000000	4398	2280	11	0	0
4215	632	75360361000000	4584	2371	1	0	0
4106	623	66720040000000	5777	2996	5	0	0
4082	618	66720000000000	7245	3745	2	0	0
4086	618	66720020000000	7245	3745	3	0	0
4090	621	66720000000000	9131	4729	2	0	0
4092	621	66720020000000	9131	4729	3	0	0
4113	631	66720501000000	12309	6341	2	0	0
4130	632	69020874000000	17011	8617	4	0	5
4131	632	69020896000000	17011	8617	5	0	5
4143	632	69740896000000	17260	8742	7	0	5
4153	632	70460921000000	17450	8837	18	0	5
4155	632	70461155000000	17450	8837	19	0	5
4162	632	71181155000000	17513	8867	2	0	5
4163	632	71181166000000	17513	8867	3	0	5
4168	632	71901166000000	17663	8929	4	0	5
4178	632	72621188000000	17694	8943	4	0	5
4179	632	72621210000000	17694	8943	5	0	5
4184	632	73341210000000	17861	9014	3	0	5
4185	632	73341222000000	17861	9014	4	0	5
4194	632	74061222000000	17939	9048	4	0	5
4094	621	67440020000000	17960	9059	6	0	0
4095	621	67440044000000	17960	9059	7	0	0
4209	632	74781235000000	18464	9304	2	0	5
4210	632	74781246000000	18464	9304	3	0	5
4135	632	69597277000000	20525	10331	14	0	9
4146	632	70317277000000	20942	10531	5	0	9
4148	632	70317489000000	20942	10531	6	0	9
4157	632	71037489000000	21595	10825	6	0	9
4159	632	71037513000000	21595	10825	7	0	9
4165	632	71757525000000	21809	10916	4	0	9
4170	632	72477525000000	22392	11210	4	0	9
4171	632	72477538000000	22392	11210	5	0	9
4180	632	73197538000000	22692	11346	3	0	9
4181	632	73197550000000	22692	11346	4	0	9
4189	632	73917563000000	22966	11473	5	0	9
4201	632	74637563000000	24154	12022	3	0	9
4203	632	74637575000000	24154	12022	4	0	9
4212	632	75357575000000	24453	12160	3	0	9
4098	621	68160044000000	25422	12597	4	0	0
4100	621	68160057000000	25422	12597	5	0	0
4101	621	68880057000000	26579	13152	6	0	0
4104	621	68880081000000	26579	13152	7	0	0
4218	632	75501246000000	18812	9480	5	0	\N
4221	632	75501278000000	18812	9480	6	0	\N
4222	632	76077587000000	24716	12275	7	0	\N
4225	632	76077639000000	24716	12275	8	0	\N
4226	632	76080371000000	4654	2404	2	0	\N
4229	632	76080391000000	4654	2404	3	0	\N
4230	632	76221256000000	19144	9657	3	0	\N
4231	632	76221256000000	19246	9704	3	0	\N
4233	632	76221268000000	19144	9657	4	0	\N
4234	632	76221268000000	19246	9704	4	0	\N
4240	632	76941269000000	19397	9776	4	0	\N
4241	632	76941269000000	19749	9925	84	0	\N
4244	632	76941282000000	19397	9776	5	0	\N
4245	632	76941614000000	19749	9925	85	0	\N
4246	632	76942864000000	19944	9926	35	0	\N
4247	632	77517625000000	25210	12505	3	0	\N
4248	632	77517625000000	25383	12583	3	0	\N
4249	632	77517625000000	25818	12766	12	0	\N
4250	632	77517625000000	25848	12778	2	0	\N
4252	632	77517636000000	25848	12778	3	0	\N
4253	632	77517637000000	25210	12505	4	0	\N
4254	632	77517637000000	25383	12583	4	0	\N
4256	632	77517673000000	25818	12766	13	0	\N
4257	632	77520391000000	4961	2572	2	0	\N
4259	632	77520411000000	4961	2572	3	0	\N
4261	632	77661281000000	19942	10041	3	0	\N
4262	632	77661293000000	19942	10041	4	0	\N
4263	632	77662864000000	19944	9926	126	0	\N
4264	632	77663764000000	19944	9926	127	0	\N
4266	632	78237637000000	26338	13025	1	0	\N
4267	632	78237647000000	26338	13025	2	0	\N
4273	632	78960431000000	8020	4158	2	0	\N
4275	632	78960451000000	8020	4158	3	0	\N
4279	632	79677718000000	27597	13640	7	0	\N
4281	632	79680453000000	8126	4213	1	0	\N
4283	632	79680463000000	8126	4213	2	0	\N
4285	632	79680483000000	8246	4270	5	0	\N
4286	632	80397718000000	27597	13640	8	0	\N
4288	632	80400473000000	8300	4297	1	0	\N
4290	632	80400483000000	8300	4297	2	0	\N
4294	632	81120493000000	8445	4375	0	0	\N
4295	632	81120493000000	8539	4424	1	0	\N
4297	632	81120503000000	8539	4424	2	0	\N
4303	632	82557741000000	28079	13882	19	0	\N
4306	632	82557832000000	28079	13882	20	0	\N
4313	632	83997764000000	28824	14218	8	0	\N
4314	632	83997764000000	28896	14253	4	0	\N
4316	632	83997777000000	28896	14253	5	0	\N
4318	632	83997790000000	28824	14218	9	0	\N
4319	632	84000603000000	9103	4717	2	0	\N
4320	632	84000603000000	9454	4903	2	0	\N
4322	632	84000603000000	10442	5402	3	0	\N
4323	632	84000623000000	9103	4717	3	0	\N
4324	632	84000623000000	9454	4903	3	0	\N
4326	632	84000633000000	10442	5402	4	0	\N
4331	632	85437801000000	29607	14601	3	0	\N
4332	632	85437801000000	30150	14834	10	0	\N
4333	632	85437801000000	30218	14859	11	0	\N
4334	632	85437801000000	30219	14859	10	0	\N
4335	632	85437801000000	30259	14877	41	0	\N
4336	632	85437813000000	29607	14601	4	0	\N
4337	632	85437820000000	30150	14834	11	0	\N
4338	632	85437827934869	30219	14859	13	0	\N
4339	632	85437828934869	30218	14859	14	0	\N
4340	632	85437980000000	30259	14877	42	0	\N
4341	632	85440643000000	10955	5645	5	0	\N
4344	632	85440983000000	10955	5645	6	0	\N
4347	632	86880694000000	11621	5981	1	0	\N
4349	632	86880695000000	11621	5981	2	0	\N
4228	632	76080381000000	4688	2424	2	0	0
4238	632	76800381000000	4762	2460	1	0	0
4239	632	76800391000000	4762	2460	2	0	0
4258	632	77520391000000	6021	3124	3	0	0
4260	632	77520421000000	6021	3124	4	0	0
4270	632	78240431000000	7835	4062	2	0	0
4274	632	78960431000000	8074	4186	4	0	0
4276	632	78960453000000	8074	4186	5	0	0
4282	632	79680453000000	8181	4239	2	0	0
4284	632	79680473000000	8181	4239	3	0	0
4291	632	80400493000000	8382	4343	3	0	0
4296	632	81120493000000	8540	4424	1	0	0
4298	632	81120503000000	8540	4424	2	0	0
4301	632	81840503000000	8556	4434	1	0	0
4307	632	82560513000000	8796	4560	2	0	0
4308	632	82560533000000	8796	4560	3	0	0
4311	632	83280533000000	8831	4578	3	0	0
4312	632	83280603000000	8831	4578	4	0	0
4321	632	84000603000000	10441	5402	2	0	0
4329	632	84720623000000	10747	5547	2	0	0
4330	632	84720643000000	10747	5547	3	0	0
4342	632	85440643000000	11208	5755	4	0	0
4343	632	85440683000000	11208	5755	5	0	0
4345	632	86160683000000	11243	5776	2	0	0
4348	632	86880694000000	11622	5981	0	0	0
4350	632	87600694000000	11677	6004	1	0	0
4351	632	87600695000000	11677	6004	2	0	0
4352	632	88320695000000	11775	6053	2	0	0
4220	632	75501256000000	18822	9485	2	0	5
4232	632	76221256000000	19346	9755	4	0	5
4235	632	76221269000000	19346	9755	5	0	5
4242	632	76941269000000	19750	9943	3	0	5
4243	632	76941281000000	19750	9943	4	0	5
4224	632	76077600000000	24785	12307	5	0	9
4236	632	76797600000000	25203	12501	7	0	9
4237	632	76797625000000	25203	12501	8	0	9
4251	632	77517625000000	26266	12989	3	0	9
4255	632	77517637000000	26266	12989	4	0	9
4268	632	78237648000000	26337	13025	3	0	9
4271	632	78957648000000	27061	13379	6	0	9
4272	632	78957672000000	27061	13379	7	0	9
4277	632	79677672000000	27532	13612	3	0	9
4280	632	79677718000000	27598	13640	7	0	9
4287	632	80397718000000	27598	13640	8	0	9
4292	632	81117718000000	27745	13706	2	0	9
4293	632	81117729000000	27745	13706	3	0	9
4299	632	81837729000000	28028	13862	3	0	9
4304	632	82557741000000	28358	14019	2	0	9
4305	632	82557752000000	28358	14019	3	0	9
4309	632	83277752000000	28544	14103	3	0	9
4310	632	83277764000000	28544	14103	4	0	9
4315	632	83997764000000	29135	14365	7	0	9
4327	632	84717789000000	29399	14494	3	0	9
4328	632	84717801000000	29399	14494	4	0	9
4356	632	89760698000000	12478	6430	3	0	\N
4358	632	89760719000000	12478	6430	4	0	\N
4364	632	91920763000000	12683	6541	2	0	\N
4366	632	91920774000000	12683	6541	3	0	\N
4368	632	92640785000000	12996	6700	4	0	\N
4369	632	92640785000000	12997	6700	4	0	\N
4370	632	92640785000000	13139	6772	4	0	\N
4373	632	92640798000000	13139	6772	5	0	\N
4374	632	92640807000000	12996	6700	5	0	\N
4375	632	92640807000000	12997	6700	5	0	\N
4376	632	93360797000000	13567	6978	8	0	\N
4378	632	93360797000000	13877	6918	0	0	\N
4379	632	93360797000000	13881	6931	0	0	\N
4381	632	93360859000000	13567	6978	9	0	\N
4385	632	94800835000000	13929	7139	3	0	\N
4387	632	94800847000000	13929	7139	4	0	\N
4390	632	96240858000000	14346	7322	8	0	\N
4393	632	96240884000000	14346	7322	9	0	\N
4396	632	97680892000000	15063	7671	4	0	\N
4398	632	97680923000000	15063	7671	5	0	\N
4402	632	99120938000000	15397	7841	2	0	\N
4404	632	99120949000000	15397	7841	3	0	\N
4410	633	1	3004	1359	70	0	\N
4411	633	9040300	23290	11485	81	0	\N
4412	633	287999962	23397	11486	99	0	\N
4413	633	66000000000010	2339	1222	2	0	\N
4414	633	66000000001310	23397	11486	81	0	\N
4415	633	66000004090000	20130	10133	8	0	\N
4422	633	68160020000000	950	530	2	0	\N
4425	633	68160040000000	950	530	3	0	\N
4426	633	68763849900000	11023	5675	1	0	\N
4428	633	68763859900000	11023	5675	2	0	\N
4430	633	68880030000000	1163	641	1	0	\N
4431	633	68880030000000	1363	747	2	0	\N
4432	633	68880030000000	1367	749	1	0	\N
4433	633	68880030000000	1448	787	1	0	\N
4434	633	68880030000000	1953	1035	1	0	\N
4436	633	68880040000000	1163	641	2	0	\N
4437	633	68880040000000	1367	749	2	0	\N
4438	633	68880040000000	1448	787	2	0	\N
4439	633	68880040000000	1953	1035	2	0	\N
4441	633	68880041000000	1363	747	3	0	\N
4444	633	69483869900000	11311	5810	2	0	\N
4446	633	69483880900000	11311	5810	3	0	\N
4448	633	69600040000000	2057	1087	1	0	\N
4450	633	69600050000000	2057	1087	2	0	\N
4456	633	70318950000000	2338	1222	1	0	\N
4457	633	70318950000000	2339	1222	1	0	\N
4459	633	70318960000000	2338	1222	2	0	\N
4461	633	70319390000000	3004	1359	34	0	\N
4462	633	70749314900000	21388	10730	4	0	\N
4464	633	70749336900000	21388	10730	5	0	\N
4468	633	71038960000000	2442	1277	1	0	\N
4469	633	71038960000000	2478	1298	1	0	\N
4470	633	71038960000000	3003	1560	0	0	\N
4471	633	71038960000000	3104	1612	1	0	\N
4473	633	71038970000000	2442	1277	2	0	\N
4474	633	71038970000000	2478	1298	2	0	\N
4475	633	71038970000000	3104	1612	2	0	\N
4477	633	71039390000000	3004	1359	69	0	\N
4478	633	71469336900000	21810	10917	3	0	\N
4480	633	71469348900000	21810	10917	4	0	\N
4485	633	71758970000000	3993	2072	1	0	\N
4487	633	71758980000000	3993	2072	2	0	\N
4418	633	67440010000000	551	312	1	0	0
4419	633	67440020000000	551	312	2	0	0
4423	633	68160020000000	957	534	1	0	0
4424	633	68160030000000	957	534	2	0	0
4435	633	68880030000000	1954	1035	1	0	0
4449	633	69600040000000	2059	1087	1	0	0
4451	633	69600050000000	2059	1087	2	0	0
4458	633	70318950000000	2353	1230	1	0	1
4460	633	70318960000000	2353	1230	2	0	1
4472	633	71038960000000	3261	1694	1	0	1
4484	633	71758970000000	3989	2072	1	0	1
4486	633	71758980000000	3989	2072	2	0	1
4420	633	68043829900000	10964	5650	2	0	5
4421	633	68043849900000	10964	5650	3	0	5
4429	633	68763869900000	11070	5695	3	0	5
4445	633	69483869900000	11328	5817	3	0	5
4447	633	69483890900000	11328	5817	4	0	5
4454	633	70203890900000	11619	5979	3	0	5
4455	633	70203893900000	11619	5979	4	0	5
4467	633	70923894900000	11747	6038	2	0	5
4353	632	88320697000000	11775	6053	3	0	0
4482	633	71643894900000	11926	6138	1	0	5
4483	633	71643895900000	11926	6138	2	0	5
4354	632	89040697000000	12044	6200	1	0	0
4357	632	89760698000000	12511	6447	3	0	0
4359	632	89760719000000	12511	6447	4	0	0
4360	632	90480719000000	12535	6460	2	0	0
4361	632	90480730000000	12535	6460	3	0	0
4363	632	91200763000000	12637	6519	7	0	0
4365	632	91920763000000	12875	6639	4	0	0
4367	632	91920785000000	12875	6639	5	0	0
4371	632	92640785000000	13171	6786	3	0	0
4372	632	92640797000000	13171	6786	4	0	0
4380	632	93360809000000	13592	6990	4	0	0
4382	632	94080809000000	13879	7122	8	0	0
4383	632	94080835000000	13879	7122	9	0	0
4384	632	94800835000000	13927	7139	1	0	0
4386	632	94800845000000	13927	7139	2	0	0
4389	632	95520858000000	14244	7271	5	0	0
4391	632	96240858000000	14580	7434	1	0	0
4392	632	96240859000000	14580	7434	2	0	0
4394	632	96960859000000	14826	7557	6	0	0
4397	632	97680892000000	15148	7722	6	0	0
4400	632	98400925000000	15173	7731	4	0	0
4401	632	98400938000000	15173	7731	5	0	0
4403	632	99120938000000	15538	7908	2	0	0
4405	632	99120949000000	15538	7908	3	0	0
4406	632	99840949000000	16020	8145	4	0	0
4407	632	99840962000000	16020	8145	5	0	0
4408	632	100560962000000	16081	8174	3	0	0
4409	632	100560974000000	16081	8174	4	0	0
4442	633	69309138900000	20479	10313	26	0	9
4452	633	70029303900000	20873	10492	2	0	9
4453	633	70029314900000	20873	10492	3	0	9
4463	633	70749314900000	21389	10730	4	0	9
4465	633	70749336900000	21389	10730	5	0	9
4481	633	71469348900000	21861	10940	4	0	9
4488	633	72189348900000	21907	10962	6	0	9
4490	633	72363895900000	12130	6248	3	0	\N
4491	633	72363895900000	12294	6332	10	0	\N
4494	633	72363898900000	12130	6248	4	0	\N
4495	633	72364697900000	12294	6332	11	0	\N
4496	633	72478980000000	4073	2117	1	0	\N
4498	633	72478990000000	4073	2117	2	0	\N
4504	633	73083948900000	13179	6789	3	0	\N
4507	633	73629398900000	22354	11162	10	0	\N
4510	633	73629444900000	22354	11162	11	0	\N
4511	633	73803918900000	12676	6538	4	0	\N
4512	633	73803918900000	12868	6635	8	0	\N
4513	633	73803918900000	13322	6855	44	0	\N
4515	633	73803940900000	12676	6538	5	0	\N
4516	633	73803948900000	13179	6789	13	0	\N
4518	633	73803962900000	12868	6635	9	0	\N
4519	633	73803984900000	13179	6789	14	0	\N
4520	633	73804097900000	13322	6855	45	0	\N
4525	633	74349444900000	22382	11163	1	0	\N
4526	633	74349445900000	22382	11163	2	0	\N
4529	633	74639130000000	4448	2304	2	0	\N
4530	633	74639130000000	4678	2418	2	0	\N
4532	633	74639141000000	4448	2304	3	0	\N
4533	633	74639150000000	4678	2418	3	0	\N
4536	633	75069445900000	22425	11164	0	0	\N
4538	633	75070255900000	22754	11165	81	0	\N
4539	633	75070258900000	23151	11484	81	0	\N
4542	633	75359260000000	5439	2831	1	0	\N
4544	633	75359261000000	5439	2831	2	0	\N
4545	633	75789448900000	22756	11377	10	0	\N
4546	633	75789448900000	23148	11561	3	0	\N
4547	633	75789448900000	23288	11620	2	0	\N
4549	633	75789459900000	23288	11620	3	0	\N
4550	633	75789460900000	23148	11561	4	0	\N
4552	633	75789480900000	23888	11892	1	0	\N
4553	633	75789480900000	23889	11892	1	0	\N
4554	633	75789485900000	22756	11377	11	0	\N
4555	633	75790255900000	22754	11165	121	0	\N
4556	633	75790258900000	23151	11484	126	0	\N
4557	633	75790581900000	23151	11484	127	0	\N
4558	633	75790645900000	22754	11165	122	0	\N
4559	633	75964003900000	14092	7206	4	0	\N
4560	633	75964003900000	14093	7206	1	0	\N
4562	633	75964013900000	14093	7206	2	0	\N
4563	633	75964016900000	14092	7206	5	0	\N
4567	633	76509480900000	23888	11892	4	0	\N
4568	633	76509480900000	23889	11892	4	0	\N
4570	633	76509482900000	23888	11892	5	0	\N
4571	633	76509482900000	23889	11892	5	0	\N
4572	633	76511445890100	23290	11485	126	0	\N
4573	633	76511489890100	23290	11485	127	0	\N
4574	633	76684016900000	14461	7383	4	0	\N
4575	633	76684016900000	14601	7444	3	0	\N
4577	633	76684028900000	14601	7444	4	0	\N
4579	633	76684029900000	14461	7383	5	0	\N
4580	633	76799260000000	5934	3074	1	0	\N
4581	633	76799260000000	6076	3156	2	0	\N
4583	633	76799270000000	5934	3074	2	0	\N
4585	633	76799280000000	6076	3156	3	0	\N
4586	633	77229481900000	24229	12057	4	0	\N
4587	633	77229481900000	24341	12105	3	0	\N
4589	633	77229493900000	24341	12105	4	0	\N
4590	633	77229494900000	24229	12057	5	0	\N
4592	633	77232227890090	23397	11486	98	0	\N
4597	633	77949494900000	25526	12637	3	0	\N
4598	633	77949494900000	25944	12602	0	0	\N
4599	633	77949494900000	25945	12822	5	0	\N
4600	633	77949494900000	25947	12614	0	0	\N
4601	633	77949494900000	25949	12626	0	0	\N
4602	633	77949494900000	25950	12637	0	0	\N
4603	633	77949494900000	26227	12966	24	0	\N
4604	633	77949494900000	26235	12834	0	0	\N
4606	633	77949494900000	26239	12847	0	0	\N
4607	633	77949494900000	26240	12862	0	0	\N
4608	633	77949494900000	26241	12875	0	0	\N
4609	633	77949506900000	25526	12637	4	0	\N
4611	633	77949526900000	25945	12822	6	0	\N
4612	633	77949581900000	26227	12966	25	0	\N
4617	633	78669506900000	26832	13269	3	0	\N
4619	633	78669518900000	26832	13269	4	0	\N
4505	633	73198990000000	4433	2298	4	0	1
4506	633	73199120000000	4433	2298	5	0	1
4521	633	73919120000000	4441	2302	1	0	1
4522	633	73919130000000	4441	2302	2	0	1
4531	633	74639130000000	4915	2543	4	0	1
4543	633	75359260000000	5604	2911	0	0	1
4565	633	76079260000000	5882	3050	0	0	1
4582	633	76799260000000	6130	3179	1	0	1
4584	633	76799270000000	6130	3179	2	0	1
4595	633	77519270000000	6163	3192	3	0	1
4615	633	78239300000000	7107	3669	2	0	1
4616	633	78239320000000	7107	3669	3	0	1
4623	633	78959320000000	7109	3670	4	0	1
4624	633	78959360000000	7109	3670	5	0	1
4493	633	72363896900000	12348	6366	2	0	5
4502	633	73083896900000	12576	6482	4	0	5
4503	633	73083918900000	12576	6482	5	0	5
4514	633	73803918900000	13323	6865	9	0	5
4517	633	73803954900000	13323	6865	10	0	5
4528	633	74523991900000	13563	6976	11	0	5
4540	633	75243991900000	13651	7017	3	0	5
4541	633	75244003900000	13651	7017	4	0	5
4561	633	75964003900000	14236	7267	4	0	5
4564	633	75964016900000	14236	7267	5	0	5
4578	633	76684028900000	14618	7453	4	0	5
4593	633	77404028900000	14650	7467	3	0	5
4594	633	77404040900000	14650	7467	4	0	5
4613	633	78124040900000	14752	7511	2	0	5
4621	633	78844051900000	14944	7612	1	0	5
4622	633	78844061900000	14944	7612	2	0	5
4489	633	72189372900000	21907	10962	7	0	9
4500	633	72909372900000	22270	11146	8	0	9
4501	633	72909398900000	22270	11146	9	0	9
4509	633	73629410900000	22357	11190	4	0	9
4523	633	74349410900000	22383	11206	4	0	9
4524	633	74349423900000	22383	11206	5	0	9
4535	633	75069423900000	22426	11224	7	0	9
4537	633	75069448900000	22426	11224	8	0	9
4551	633	75789470900000	23392	11671	5	0	9
4566	633	76509470900000	24125	12008	2	0	9
4569	633	76509481900000	24125	12008	3	0	9
4588	633	77229481900000	25303	12553	4	0	9
4605	633	77949494900000	26236	12972	3	0	9
4610	633	77949506900000	26236	12972	4	0	9
4618	633	78669506900000	26926	13318	3	0	9
4620	633	78669518900000	26926	13318	4	0	9
4627	633	79564061900000	15068	7673	2	0	\N
4629	633	79564072900000	15068	7673	3	0	\N
4636	633	80109580900000	27360	13526	11	0	\N
4641	633	80829542900000	27306	13498	3	0	\N
4642	633	80829554900000	27306	13498	4	0	\N
4644	633	80829580900000	27360	13526	13	0	\N
4646	633	80829581900000	27360	13526	14	0	\N
4649	633	81005168900000	17248	8624	106	0	\N
4650	633	81119380000000	7899	4093	2	0	\N
4653	633	81119400000000	7899	4093	3	0	\N
4654	633	81549581900000	27415	13556	3	0	\N
4656	633	81549593900000	27415	13556	4	0	\N
4658	633	81550233900000	28104	13758	63	0	\N
4661	633	81725168900000	17248	8624	126	0	\N
4662	633	81725358900000	17248	8624	127	0	\N
4667	633	82270233900000	28104	13758	126	0	\N
4668	633	82270853900000	28104	13758	127	0	\N
4670	633	82444110900000	17350	8789	3	0	\N
4671	633	82444122900000	17350	8789	4	0	\N
4673	633	82989628900000	28619	14132	4	0	\N
4676	633	82989641900000	28619	14132	5	0	\N
4677	633	83164110900000	17768	8976	7	0	\N
4678	633	83164110900000	17900	9031	7	0	\N
4679	633	83164110900000	17909	9034	2	0	\N
4681	633	83164112900000	17909	9034	3	0	\N
4683	633	83164135900000	17768	8976	8	0	\N
4684	633	83164135900000	17900	9031	8	0	\N
4685	633	83279400000000	10201	5283	2	0	\N
4687	633	83279420000000	10201	5283	3	0	\N
4689	633	83884122900000	18079	9118	3	0	\N
4690	633	83884122900000	18757	9455	2	0	\N
4691	633	83884122900000	19279	9719	6	0	\N
4692	633	83884122900000	19735	9935	3	0	\N
4693	633	83884122900000	19736	9935	2	0	\N
4695	633	83884122900000	19752	9944	0	0	\N
4696	633	83884124900000	19736	9935	3	0	\N
4697	633	83884133900000	18757	9455	3	0	\N
4698	633	83884134900000	18079	9118	4	0	\N
4699	633	83884134900000	19735	9935	4	0	\N
4701	633	83884146900000	19279	9719	7	0	\N
4703	633	83999840000000	10306	5332	6	0	\N
4705	633	83999900000000	10306	5332	7	0	\N
4709	633	84719890000000	10371	5363	2	0	\N
4711	633	84719910000000	10371	5363	3	0	\N
4712	633	85324146900000	20128	10133	7	0	\N
4713	633	85324146900000	20130	10133	7	0	\N
4715	633	85324171900000	20128	10133	8	0	\N
4717	633	85439909900000	10485	5420	2	0	\N
4719	633	85439929900000	10485	5420	3	0	\N
4722	633	86764206900000	20268	10208	3	0	\N
4724	633	86764218900000	20268	10208	4	0	\N
4726	633	87484218900000	20480	10312	0	0	\N
4727	639	66720000000000	14101	7155	0	0	\N
4730	641	100000019	25120	12288	82	0	\N
4731	641	150000000	14377	7164	68	0	\N
4732	641	200000014	25120	12288	126	0	\N
4733	641	200000040	8837	4582	5	1	\N
4734	641	206000000	18192	9170	7	0	\N
4735	641	66000001100200	19349	9656	23	0	\N
4736	641	66000006930000	19401	9658	2	1	\N
4741	641	67255460000000	11738	6032	0	0	\N
4744	641	67440010000000	368	209	2	0	\N
4745	641	67440010000000	602	341	1	0	\N
4747	641	67440020000000	602	341	2	0	\N
4748	641	67440030000000	368	209	3	0	\N
4754	641	68160240000000	982	544	1	0	\N
4755	641	68160240000000	1294	714	2	0	\N
4757	641	68160250000000	982	544	2	0	\N
4759	641	68160260000000	1294	714	3	0	\N
4746	641	67440010000000	861	477	4	0	0
4749	641	67440240000000	861	477	5	0	0
4756	641	68160240000000	1627	878	1	0	0
4758	641	68160250000000	1627	878	2	0	0
4631	633	79679360000000	7168	3702	1	0	1
4639	633	80399370000000	7227	3736	1	0	1
4640	633	80399380000000	7227	3736	2	0	1
4651	633	81119380000000	8312	4301	1	0	1
4652	633	81119390000000	8312	4301	2	0	1
4663	633	81839390000000	8386	4346	1	0	1
4672	633	82559400000000	9907	5138	0	0	1
4739	641	67111490000000	10063	5219	4	0	4
4740	641	67111530000000	10063	5219	5	0	4
4686	633	83279400000000	10265	5310	8	0	1
4702	633	83999840000000	10305	5332	5	0	1
4704	633	83999890000000	10305	5332	6	0	1
4708	633	84719889900000	10370	5363	2	0	1
4710	633	84719909900000	10370	5363	3	0	1
4750	641	67831530000000	10425	5392	4	0	4
4718	633	85439909900000	10491	5421	0	0	1
4742	641	67255460000000	11739	6032	5	0	8
4743	641	67255474000000	11739	6032	6	0	8
4752	641	67975474000000	12011	6182	6	0	8
4753	641	67975480000000	12011	6182	7	0	8
4628	633	79564061900000	15246	7767	2	0	5
4630	633	79564072900000	15246	7767	3	0	5
4637	633	80284072900000	15682	7979	3	0	5
4638	633	80284084900000	15682	7979	4	0	5
4648	633	81004108900000	16215	8240	7	0	5
4659	633	81724108900000	17246	8736	2	0	5
4660	633	81724110900000	17246	8736	3	0	5
4669	633	82444110900000	17347	8789	0	0	5
4680	633	83164110900000	17944	9051	3	0	5
4694	633	83884122900000	19751	9944	3	0	5
4700	633	83884134900000	19751	9944	4	0	5
4706	633	84604134900000	19808	9976	3	0	5
4707	633	84604146900000	19808	9976	4	0	5
4714	633	85324146900000	20199	10173	8	0	5
4720	633	86044181900000	20258	10203	7	0	5
4721	633	86044206900000	20258	10203	8	0	5
4723	633	86764206900000	20456	10301	3	0	5
4725	633	86764218900000	20456	10301	4	0	5
4729	640	67440019000000	26790	13247	4	0	1
4625	633	79389518900000	27003	13357	3	0	9
4626	633	79389530900000	27003	13357	4	0	9
4633	633	80109530900000	27231	13466	3	0	9
4634	633	80109542900000	27231	13466	4	0	9
4643	633	80829580900000	27359	13526	13	0	9
4645	633	80829581900000	27359	13526	14	0	9
4655	633	81549581900000	27784	13728	4	0	9
4657	633	81549603900000	27784	13728	5	0	9
4665	633	82269603900000	28106	13893	7	0	9
4674	633	82989628900000	29252	14416	3	0	9
4675	633	82989640900000	29252	14416	4	0	9
4764	641	68695480000000	12120	6243	0	0	\N
4769	641	69219790000000	12926	6662	4	0	\N
4772	641	69219812000000	12926	6662	5	0	\N
4775	641	69603570000000	20701	10411	8	0	\N
4777	641	69603570000000	21368	10723	4	0	\N
4778	641	69603570000000	21369	10723	4	0	\N
4780	641	69603583000000	21368	10723	5	0	\N
4781	641	69603583000000	21369	10723	5	0	\N
4782	641	69603605000000	20701	10411	9	0	\N
4789	641	70659812000000	13402	6905	6	0	\N
4790	641	70659812000000	13405	6905	2	0	\N
4792	641	70659812000000	13534	6967	1	0	\N
4793	641	70659822000000	13534	6967	2	0	\N
4795	641	70659832000000	13405	6905	3	0	\N
4796	641	70659836000000	13402	6905	7	0	\N
4797	641	71040290000000	2364	1235	3	0	\N
4799	641	71040290000000	2501	1266	69	0	\N
4800	641	71040290000000	2814	1301	0	0	\N
4801	641	71040320000000	2364	1235	4	0	\N
4803	641	71040980000000	2501	1266	70	0	\N
4804	641	71041460000000	2655	1267	36	0	\N
4805	641	71043596000000	21472	10770	3	0	\N
4807	641	71043608000000	21472	10770	4	0	\N
4809	641	71379824000000	13870	7118	8	0	\N
4810	641	71379824000000	13871	7118	2	0	\N
4811	641	71379824000000	13982	7163	11	0	\N
4814	641	71379844000000	13871	7118	3	0	\N
4815	641	71379850000000	13870	7118	9	0	\N
4816	641	71379862000000	13982	7163	12	0	\N
4817	641	71380246000000	14377	7164	38	0	\N
4818	641	71380997000000	14376	7222	116	0	\N
4819	641	71760290000000	2851	1302	0	0	\N
4822	641	71761460000000	2655	1267	87	0	\N
4823	641	71761685777778	2655	1267	89	0	\N
4826	641	72099837000000	14429	7350	0	0	\N
4828	641	72099837000000	14655	7182	0	0	\N
4830	641	72100246000000	14377	7164	67	0	\N
4831	641	72100997000000	14376	7222	126	0	\N
4832	641	72101087000000	14376	7222	127	0	\N
4833	641	72480290000000	3041	1303	0	0	\N
4834	641	72480380000000	2753	1441	1	0	\N
4836	641	72480390000000	2753	1441	2	0	\N
4839	641	72483659000000	22505	11257	19	0	\N
4841	641	72483804000000	22505	11257	20	0	\N
4842	641	72819525000000	14387	7165	0	0	\N
4843	641	72819837000000	14475	7351	1	0	\N
4844	641	72819837100000	14656	7467	3	0	\N
4845	641	72819847000000	14477	7388	5	0	\N
4847	641	72819849100000	14656	7467	4	0	\N
4849	641	72819888000000	14477	7388	6	0	\N
4850	641	72819937000000	14475	7351	2	0	\N
4851	641	73200390000000	2852	1493	1	0	\N
4853	641	73200400000000	2852	1493	2	0	\N
4855	641	73203802000000	22625	11316	4	0	\N
4856	641	73203802000000	22626	11316	3	0	\N
4857	641	73203802000000	22939	11462	3	0	\N
4859	641	73203814000000	22626	11316	4	0	\N
4860	641	73203814000000	22939	11462	4	0	\N
4862	641	73203815000000	22625	11316	5	0	\N
4863	641	73539525000000	14430	7166	45	0	\N
4866	641	73539975000000	14430	7166	46	0	\N
4870	641	74259902000000	15187	7737	2	0	\N
4871	641	74259902000000	15207	7747	3	0	\N
4873	641	74259913000000	15187	7737	3	0	\N
4874	641	74259914000000	15207	7747	4	0	\N
4876	641	74640410000000	3964	2060	1	0	\N
4877	641	74640410000000	3966	1988	6	0	\N
4878	641	74640410000000	4345	2113	39	0	\N
4880	641	74640420000000	3964	2060	2	0	\N
4882	641	74640515000000	3966	1988	7	0	\N
4883	641	74643266000000	4345	2113	40	0	\N
4886	641	74643980000000	4571	2260	86	0	\N
4893	641	75363980000000	4571	2260	126	0	\N
4894	641	75364370000000	4571	2260	127	0	\N
4895	641	75366260000000	4843	2261	86	0	\N
4896	641	75699947000000	15532	7904	3	0	\N
4773	641	69600260000000	1985	1049	2	0	0
4774	641	69600280000000	1985	1049	3	0	0
4785	641	70320280000000	2192	1155	1	0	0
4786	641	70320290000000	2192	1155	2	0	0
4798	641	71040290000000	2500	1310	4	0	0
4820	641	71760330000000	2654	1396	5	0	0
4821	641	71760380000000	2654	1396	6	0	0
4835	641	72480380000000	2815	1472	1	0	0
4837	641	72480390000000	2815	1472	2	0	0
4852	641	73200390000000	3042	1580	2	0	0
4867	641	73920410000000	3460	1797	0	0	0
4879	641	74640410000000	4346	2251	1	0	0
4881	641	74640420000000	4346	2251	2	0	0
4889	641	75360420000000	4570	2364	1	0	0
4762	641	68551570000000	10711	5530	2	0	4
4763	641	68551590000000	10711	5530	3	0	4
4765	641	68695480000000	12121	6243	2	0	8
4766	641	68695482000000	12121	6243	3	0	8
4761	641	68499790000000	12403	6398	3	0	12
4771	641	69219801000000	12949	6675	3	0	12
4783	641	69939801000000	12953	6678	2	0	12
4784	641	69939812000000	12953	6678	3	0	12
4791	641	70659812000000	13533	6967	3	0	12
4794	641	70659824000000	13533	6967	4	0	12
4813	641	71379837000000	13983	7164	5	0	12
4827	641	72099837000000	14431	7362	1	0	12
4829	641	72099847000000	14431	7362	2	0	12
4846	641	72819847000000	14778	7525	6	0	12
4864	641	73539880000000	14801	7541	4	0	12
4865	641	73539902000000	14801	7541	5	0	12
4872	641	74259902000000	15439	7863	5	0	12
4875	641	74259925000000	15439	7863	6	0	12
4887	641	74979925000000	15481	7881	4	0	12
4776	641	69603570000000	21367	10723	4	0	16
4779	641	69603583000000	21367	10723	5	0	16
4787	641	70323583000000	21438	10752	4	0	16
4788	641	70323596000000	21438	10752	5	0	16
4806	641	71043596000000	21790	10909	8	0	16
4824	641	71763622000000	22137	11072	10	0	16
4825	641	71763659000000	22137	11072	11	0	16
4838	641	72483659000000	22504	11257	17	0	16
4840	641	72483802000000	22504	11257	18	0	16
4861	641	73203814000000	23101	11536	4	0	16
4868	641	73923814000000	23153	11562	4	0	16
4869	641	73923827000000	23153	11562	5	0	16
4884	641	74643827000000	23886	11890	3	0	16
4885	641	74643839000000	23886	11890	4	0	16
4892	641	75363851000000	23984	11936	4	0	16
4899	641	75699959000000	15532	7904	4	0	\N
4904	641	76084584000000	24815	12287	82	0	\N
4905	641	76086260000000	4843	2261	126	0	\N
4906	641	76086650000000	4843	2261	127	0	\N
4907	641	76087690000000	4895	2262	86	0	\N
4908	641	76419958000000	15637	7958	4	0	\N
4909	641	76419958000000	15950	8108	6	0	\N
4911	641	76419971000000	15637	7958	5	0	\N
4913	641	76419982000000	15950	8108	7	0	\N
4914	641	76800450000000	4893	2535	1	0	\N
4916	641	76800460000000	4893	2535	2	0	\N
4918	641	76803872000000	24432	12149	3	0	\N
4919	641	76803872000000	24814	12321	5	0	\N
4920	641	76803872000000	25119	12464	6	0	\N
4921	641	76803872000000	25351	12565	1	0	\N
4923	641	76803872000000	25353	12570	4	0	\N
4925	641	76803884000000	24432	12149	4	0	\N
4926	641	76803885000000	25353	12570	5	0	\N
4927	641	76803895000000	24814	12321	6	0	\N
4928	641	76803896000000	25119	12464	7	0	\N
4929	641	76803972000000	25351	12565	2	0	\N
4930	641	76804584000000	24815	12287	126	0	\N
4931	641	76804627000000	24815	12287	127	0	\N
4932	641	76807690000000	4895	2262	104	0	\N
4933	641	76807860000000	4895	2262	105	0	\N
4940	641	77525536999997	25120	12288	125	0	\N
4942	641	77859996000000	17092	8522	0	0	\N
4950	641	78960480000000	5141	2663	2	0	\N
4953	641	78960590000000	5141	2663	3	0	\N
4955	641	78963909000000	25760	12741	3	0	\N
4957	641	78963921000000	25760	12741	4	0	\N
4958	641	78964315000000	26467	13066	79	0	\N
4959	641	78964481000000	26468	13028	56	0	\N
4964	641	79683921000000	26466	13091	3	0	\N
4966	641	79683933000000	26466	13091	4	0	\N
4968	641	79684315000000	26467	13066	120	0	\N
4969	641	79684355000000	26467	13066	121	0	\N
4970	641	79684481000000	26468	13028	126	0	\N
4971	641	79684829000000	26468	13028	127	0	\N
4972	641	79685205000000	26775	13067	85	0	\N
4973	641	79685389000000	26776	13029	56	0	\N
4974	641	80020033000000	17686	8863	9	0	\N
4975	641	80020033000000	17687	8940	2	0	\N
4977	641	80020044000000	17687	8940	3	0	\N
4979	641	80020105000000	17686	8863	10	0	\N
4984	641	80405205000000	26775	13067	126	0	\N
4985	641	80405389000000	26776	13029	126	0	\N
4986	641	80405605000000	26775	13067	127	0	\N
4987	641	80406079000000	26776	13029	127	0	\N
4988	641	80740045000000	18155	9153	14	0	\N
4990	641	80740194000000	18155	9153	15	0	\N
4996	641	81460194000000	18182	9168	3	0	\N
4997	641	81460194000000	18183	9159	0	0	\N
4998	641	81460194000000	18192	9170	5	0	\N
4999	641	81460194000000	18194	9170	5	0	\N
5001	641	81460194000000	19321	9655	46	0	\N
5002	641	81460206000000	18182	9168	4	0	\N
5004	641	81460217000000	18194	9170	6	0	\N
5005	641	81460713000000	19321	9655	47	0	\N
5006	641	81460893000000	19349	9656	9	0	\N
5010	641	82180207000000	19348	9751	0	0	\N
5011	641	82180207000000	19377	9768	3	0	\N
5012	641	82180207000000	19380	9768	2	0	\N
5014	641	82180218000000	19380	9768	3	0	\N
5015	641	82180219000000	19377	9768	4	0	\N
5017	641	82180893000000	19349	9656	22	0	\N
5020	641	82561260000000	7070	3623	53	0	\N
5021	641	82563948000000	27818	13748	3	0	\N
5022	641	82563948000000	28163	13925	7	0	\N
5025	641	82563960000000	27818	13748	4	0	\N
5026	641	82563982000000	28163	13925	8	0	\N
5027	641	82899967500000	19379	9657	5	0	\N
5028	641	82900008500000	19379	9657	6	0	\N
5029	641	82900220000000	19512	9832	4	0	\N
5030	641	82900220000000	19592	9867	3	0	\N
5031	641	82900220000000	19593	9845	0	0	\N
4915	641	76800450000000	4996	2590	1	0	0
4917	641	76800460000000	4996	2590	2	0	0
4936	641	77520460000000	5060	2625	1	0	0
4937	641	77520470000000	5060	2625	2	0	0
4944	641	78240470000000	5064	2627	1	0	0
4951	641	78960480000000	5189	2697	1	0	0
4952	641	78960490000000	5189	2697	2	0	0
4962	641	79680490000000	5300	2753	2	0	0
4963	641	79680510000000	5300	2753	3	0	0
4980	641	80400510000000	5313	2762	1	0	0
4992	641	81120520000000	6521	3379	2	0	0
4993	641	81120540000000	6521	3379	3	0	0
5007	641	81840540000000	6607	3417	8	0	0
5008	641	81840620000000	6607	3417	9	0	0
5019	641	82560640000000	6964	3592	3	0	0
4897	641	75699947000000	15571	7926	2	0	12
4898	641	75699958000000	15571	7926	3	0	12
4910	641	76419958000000	16056	8166	4	0	12
4912	641	76419971000000	16056	8166	5	0	12
4935	641	77139996000000	16724	8494	8	0	12
4941	641	77859996000000	16932	8582	3	0	12
4943	641	77860008000000	16932	8582	4	0	12
4948	641	78580008000000	17091	8660	3	0	12
4949	641	78580020000000	17091	8660	4	0	12
4961	641	79300033000000	17211	8720	5	0	12
4976	641	80020033000000	17872	9020	3	0	12
4978	641	80020045000000	17872	9020	4	0	12
4989	641	80740045000000	18156	9153	14	0	12
5000	641	81460194000000	19320	9743	4	0	12
5003	641	81460207000000	19320	9743	5	0	12
5013	641	82180207000000	19400	9777	4	0	12
5016	641	82180220000000	19400	9777	5	0	12
5032	641	82900220000000	19722	9930	3	0	12
4903	641	76083872000000	24401	12133	4	0	16
4922	641	76803872000000	25352	12570	1	0	16
4924	641	76803873000000	25352	12570	2	0	16
4938	641	77523873000000	25432	12601	3	0	16
4939	641	77523885000000	25432	12601	4	0	16
4947	641	78243909000000	25726	12728	7	0	16
4954	641	78963909000000	25759	12741	3	0	16
4956	641	78963921000000	25759	12741	4	0	16
4965	641	79683921000000	26774	13240	6	0	16
4982	641	80403945000000	26980	13341	2	0	16
4983	641	80403947000000	26980	13341	3	0	16
4994	641	81123947000000	27052	13374	1	0	16
4995	641	81123948000000	27052	13374	2	0	16
5009	641	81843948000000	27684	13680	0	0	16
5024	641	82563959000000	28245	13965	3	0	16
5033	641	82900220000000	19724	9928	12	0	\N
5034	641	82900232000000	19592	9867	4	0	\N
5036	641	82900233000000	19512	9832	5	0	\N
5037	641	82900268000000	19724	9928	13	0	\N
5038	641	82900615000000	19768	9929	86	0	\N
5039	641	83280640000000	7068	3648	3	0	\N
5041	641	83280640000000	7526	3673	0	0	\N
5043	641	83280760000000	7068	3648	4	0	\N
5044	641	83281260000000	7070	3623	73	0	\N
5045	641	83281540000000	7070	3623	74	0	\N
5046	641	83281780000000	7341	3695	85	0	\N
5047	641	83282780000000	7150	3624	106	0	\N
5050	641	83620008500000	19401	9658	1	0	\N
5051	641	83620220000000	19723	9846	96	0	\N
5054	641	83620615000000	19768	9929	94	0	\N
5055	641	83620622000000	19768	9929	95	0	\N
5056	641	83621171000000	19723	9846	97	0	\N
5057	641	84000750000000	7340	3700	6	0	\N
5060	641	84000900000000	7340	3700	7	0	\N
5061	641	84001780000000	7341	3695	126	0	\N
5062	641	84002180000000	7341	3695	127	0	\N
5063	641	84002780000000	7150	3624	126	0	\N
5064	641	84003045000000	7529	3696	85	0	\N
5065	641	84003060000000	7150	3624	127	0	\N
5068	641	84340251000000	19875	9992	16	0	\N
5071	641	84340393000000	19875	9992	17	0	\N
5072	641	84341171000000	19766	9847	6	0	\N
5073	641	84341177000000	19766	9847	7	0	\N
5074	641	84720770000000	7723	3999	1	0	\N
5076	641	84720780000000	7723	3999	2	0	\N
5078	641	84723045000000	7529	3696	126	0	\N
5079	641	84723445000000	7529	3696	127	0	\N
5080	641	84724008500000	28545	14103	3	0	\N
5081	641	84724008500000	28546	14103	2	0	\N
5082	641	84724008500000	28604	14125	3	0	\N
5084	641	84724019500000	28546	14103	3	0	\N
5086	641	84724020500000	28545	14103	4	0	\N
5087	641	84724020500000	28604	14125	4	0	\N
5088	641	84724066500000	29482	14537	11	0	\N
5089	641	85060264000000	19920	10033	4	0	\N
5090	641	85060264000000	20006	10072	5	0	\N
5091	641	85060277000000	19920	10033	5	0	\N
5092	641	85060386000000	20006	10072	6	0	\N
5093	641	85060393000000	19921	9993	15	0	\N
5094	641	85060975000000	19921	9993	16	0	\N
5097	641	85444019500000	28942	14273	2	0	\N
5098	641	85444019500000	28943	14273	3	0	\N
5099	641	85444019500000	29033	14317	3	0	\N
5100	641	85444019500000	29217	14399	3	0	\N
5101	641	85444019500000	29218	14399	2	0	\N
5102	641	85444019500000	29221	14400	3	0	\N
5103	641	85444021500000	29218	14399	3	0	\N
5104	641	85444030500000	28942	14273	3	0	\N
5105	641	85444031500000	28943	14273	4	0	\N
5106	641	85444031500000	29033	14317	4	0	\N
5107	641	85444031500000	29217	14399	4	0	\N
5108	641	85444031500000	29221	14400	4	0	\N
5109	641	85444066500000	29482	14537	12	0	\N
5110	641	86160820000000	8620	4469	1	0	\N
5111	641	86160820000000	8629	4472	2	0	\N
5113	641	86160830000000	8620	4469	2	0	\N
5114	641	86160840000000	8629	4472	3	0	\N
5116	641	86880849999996	8837	4582	4	0	\N
5117	641	86880850000000	8838	4582	4	0	\N
5119	641	86880890000000	8838	4582	5	0	\N
5125	641	89040930000000	10062	5056	1	0	\N
5126	641	89040940000000	10062	5056	2	0	\N
5127	646	10000004	8626	4336	126	0	\N
5128	646	10703400	8986	4661	8	1	\N
5129	646	190000020	12263	6036	14	1	\N
5130	646	200000007	8988	4661	9	0	\N
5131	646	2161050010000	21836	10868	120	0	\N
5132	646	3404497009996	11536	5928	8	0	\N
5133	646	4340285010000	12593	6492	5	0	\N
5134	646	4894956060108	11426	5792	127	0	\N
5135	646	6993570630000	24306	12087	9	0	\N
5136	646	7698526740000	13234	6760	57	0	\N
5137	646	23326762009798	20695	10325	30	0	\N
5138	646	23762049009999	11604	5818	126	0	\N
5148	646	83620008510000	19401	9658	2	0	\N
5149	646	303129332829988	25375	12473	14	0	\N
5152	662	6478360000000	3826	1793	113	1	\N
5153	662	66000900000000	3826	1793	81	0	\N
5156	662	66720900000000	3826	1793	112	0	\N
5159	662	68160143000000	25566	12657	9	0	\N
5160	662	68160179000000	25566	12657	10	0	\N
5161	667	66000975000000	16623	8389	84	0	\N
5162	667	66720000000000	1264	698	4	0	\N
5163	667	66720040000000	1264	698	5	0	\N
5166	667	66720975000000	16623	8389	102	0	\N
5167	667	66721055000000	16623	8389	103	0	\N
5042	641	83280750000000	7149	3694	3	0	0
5058	641	84000750000000	7527	3897	2	0	0
5059	641	84000770000000	7527	3897	3	0	0
5075	641	84720770000000	7799	4044	2	0	0
5077	641	84720790000000	7799	4044	3	0	0
5096	641	85440820000000	7975	4133	4	0	0
5112	641	86160820000000	8825	4576	3	0	0
5115	641	86160850000000	8825	4576	4	0	0
5118	641	86880850000000	8839	4582	4	0	0
5120	641	86880890000000	8839	4582	5	0	0
5141	646	66000003960000	8992	4662	3	0	0
5121	641	87600890000000	9158	4745	2	0	0
5122	641	87600910000000	9158	4745	3	0	0
5123	641	88320910000000	9241	4793	2	0	0
5164	667	66720095000000	16621	8443	3	0	1
5165	667	66720107000000	16621	8443	4	0	1
5150	651	66720000000000	16770	8513	7	0	0
5151	651	66720025000000	16770	8513	8	0	0
5142	646	66000005940000	18691	9416	8	0	0
5155	662	66720120000000	19083	9626	4	0	0
5035	641	82900232000000	19722	9930	4	0	12
5052	641	83620232000000	19767	9952	10	0	12
5053	641	83620251000000	19767	9952	11	0	12
5069	641	84340251000000	19876	10011	4	0	12
5143	646	66000006930000	20083	10110	9	1	0
5157	662	67440120000000	21091	10595	5	0	0
5158	662	67440143000000	21091	10595	6	0	0
5145	646	66720007920000	24173	12032	8	0	0
5147	646	66720043910000	24967	12391	5	0	0
5048	641	83283959000000	28332	14006	6	0	16
5049	641	83283992000000	28332	14006	7	0	16
5066	641	84003992000000	28473	14071	3	0	16
5067	641	84004008500000	28473	14071	4	0	16
5085	641	84724019500000	28616	14130	3	0	16
5170	676	67440010000000	6360	3185	11	0	\N
5173	676	67441011000000	6360	3185	12	0	\N
5174	676	68160021000000	22100	11050	7	0	\N
5175	676	68160046000000	22100	11050	8	0	\N
5176	679	66720000000000	7467	3863	1	0	\N
5179	679	66720010000000	7467	3863	2	0	\N
5182	686	66000000030000	14300	7221	6	0	\N
5183	686	66720000000000	3868	2008	2	0	\N
5184	686	66720000000000	4054	2106	2	0	\N
5187	686	66720020000000	3868	2008	3	0	\N
5188	686	66720020000000	4054	2106	3	0	\N
5191	686	68160011000000	13021	6712	3	0	\N
5192	686	68160011000000	14300	7221	5	0	\N
5194	686	68160032000000	13021	6712	4	0	\N
5202	689	66720000000000	6488	3256	54	0	\N
5203	689	66720000000000	12106	6234	1	0	\N
5205	689	66720001000000	12106	6234	2	0	\N
5207	689	66722180000000	6488	3256	55	0	\N
5208	689	67440011000000	25246	12521	7	0	\N
5211	689	67440036000000	25246	12521	8	0	\N
5212	696	6342600113700	10223	5029	62	1	\N
5213	696	16560366000000	10180	5275	5	0	\N
5214	696	66000025000000	6202	3210	11	1	\N
5215	697	8641011500003	25191	12497	6	1	\N
5216	697	15121822000016	25146	12477	4	1	\N
5217	697	66000000499999	25146	12477	3	0	\N
5220	697	66000001499997	28569	13882	24	1	\N
5222	697	66000002499995	30191	14852	13	0	\N
5224	697	66000002499995	30223	14735	105	0	\N
5225	697	66000003499993	30210	14858	38	1	\N
5226	697	66000003499993	30211	14858	37	0	\N
5227	697	66000003499993	30213	14858	38	0	\N
5230	697	66000004499991	30240	14867	6	1	\N
5231	697	66000004499991	30241	14867	4	1	\N
5233	697	66000006999986	28626	13884	16	1	\N
5234	697	66720000000000	6634	3428	2	0	\N
5235	697	66720000000000	27146	13423	3	0	\N
5236	697	66720012000000	27146	13423	4	0	\N
5237	697	66720020000000	6634	3428	3	0	\N
5238	697	189367473475001	27041	13249	43	0	\N
5239	700	66720000000000	219	130	1	0	\N
5240	700	66720000000000	239	141	2	0	\N
5241	700	66720000000000	445	249	3	0	\N
5243	700	66720010000000	219	130	2	0	\N
5245	700	66720020000000	239	141	3	0	\N
5246	700	66720030000000	445	249	4	0	\N
5252	700	68160020000000	2706	1422	1	0	\N
5253	700	68160020000000	2775	1453	2	0	\N
5255	700	68160030000000	2706	1422	2	0	\N
5256	700	68160040000000	2775	1453	3	0	\N
5264	700	71040090000000	6429	3328	4	0	\N
5265	700	71040090000000	6438	3331	2	0	\N
5266	700	71040090000000	6825	3534	2	0	\N
5267	700	71040090000000	6902	3566	2	0	\N
5269	700	71040110000000	6438	3331	3	0	\N
5270	700	71040110000000	6825	3534	3	0	\N
5144	646	66000007920000	22506	11258	2	0	0
5219	697	66000000999998	28120	13902	6	0	0
5271	700	71040110000000	6902	3566	3	0	\N
5272	700	71040130000000	6429	3328	5	0	\N
5274	700	71760210000000	7280	3763	2	0	\N
5276	700	71760230000000	7280	3763	3	0	\N
5280	700	73200260000000	9520	4937	6	0	\N
5283	700	73200410000000	9520	4937	7	0	\N
5284	707	30400	16707	8428	127	1	\N
5285	707	40300	16784	8429	19	1	\N
5287	707	66000000050000	21870	10799	126	1	\N
5288	733	2720000000000	1837	981	1	0	\N
5289	733	2720000000000	15204	7747	3	0	\N
5290	733	2720000000000	15205	7747	2	0	\N
5292	733	2720002000000	15205	7747	3	0	\N
5293	733	2720010000000	1837	981	2	0	\N
5294	733	2720012000000	15204	7747	4	0	\N
5299	748	2722390000000	7619	3941	1	0	\N
5300	748	2722390000000	12551	6467	4	0	\N
5301	748	2722400000000	7619	3941	2	0	\N
5302	748	2722412000000	12551	6467	5	0	\N
5303	1271	100000027	27284	13408	126	1	\N
5304	1271	190000110	19256	9604	86	1	\N
5200	687	66720000000000	517	290	3	0	0
5201	687	66720030000000	517	290	4	0	0
5249	700	67440010000000	1201	662	1	0	0
5250	700	67440020000000	1201	662	2	0	0
5169	676	66720010000000	1862	992	2	0	0
5257	700	68160040000000	2847	1491	3	0	0
5258	700	68880040000000	3068	1594	2	0	0
5259	700	68880060000000	3068	1594	3	0	0
5260	700	69600060000000	4564	2360	2	0	0
5261	700	69600080000000	4564	2360	3	0	0
5263	700	70320090000000	5351	2777	2	0	0
5268	700	71040090000000	7114	3674	3	0	0
5273	700	71040210000000	7114	3674	4	0	0
5275	700	71760210000000	7310	3778	4	0	0
5278	700	72480250000000	7314	3780	1	0	0
5279	700	72480260000000	7314	3780	2	0	0
5185	686	66720000000000	7501	3881	1	0	0
5186	686	66720010000000	7501	3881	2	0	0
5281	700	73200260000000	9625	4994	2	0	0
5247	700	66721260000000	9972	5172	4	0	2
5248	700	66721300000000	9972	5172	5	0	2
5251	700	67441300000000	10694	5521	0	0	2
5177	679	66720000000000	11718	6025	1	0	0
5178	679	66720001000000	11718	6025	2	0	0
5190	686	67440011000000	11998	6174	2	0	0
5298	748	2722290000000	12550	6467	0	0	1
5204	689	66720000000000	13004	6702	2	0	0
5206	689	66720011000000	13004	6702	3	0	0
5295	733	2720012000000	17723	8957	4	0	0
5193	686	68160011000000	18075	9115	7	0	0
5195	686	68160045000000	18075	9115	8	0	0
5296	733	3440012000000	19396	9776	4	0	0
5297	733	3440025000000	19396	9776	5	0	0
5197	686	68880047000000	20698	10410	3	0	0
5171	676	67440010000000	21029	10570	2	0	0
5172	676	67440021000000	21029	10570	3	0	0
5198	686	69600047000000	23282	11616	2	0	0
5199	686	69600058000000	23282	11616	3	0	0
5181	685	66720012000000	25773	12746	4	0	0
5209	689	67440011000000	26086	12892	2	0	0
5210	689	67440022000000	26086	12892	3	0	0
5218	697	66000000499999	27149	13424	7	1	0
5223	697	66000002499995	30192	14852	13	0	0
5228	697	66000003499993	30214	14858	38	0	0
5229	697	66000004499991	30239	14867	10	1	0
5232	697	66000004999990	30277	14888	15	1	0
5305	1271	288999961	23366	11487	3	1	\N
5310	1271	1334766390000000	3233	1551	10	0	\N
5311	1271	1335486020000000	2858	1496	3	0	\N
5312	1271	1335486020000000	3595	1868	0	0	\N
5314	1271	1335486041000000	2858	1496	4	0	\N
5315	1271	1335486380000000	3233	1551	11	0	\N
5316	1271	1336206020000000	3717	1930	1	0	\N
5318	1271	1336206030000000	3717	1930	2	0	\N
5326	1271	1339086070000000	6210	3214	1	0	\N
5327	1271	1339086070000000	6238	3226	2	0	\N
5329	1271	1339086080000000	6210	3214	2	0	\N
5330	1271	1339086090000000	6238	3226	3	0	\N
5332	1271	1339806090000000	7719	3998	1	0	\N
5334	1271	1339806100000000	7719	3998	2	0	\N
5344	1271	1343406290000000	10665	5507	2	0	\N
5345	1271	1343406290000000	11555	5937	2	0	\N
5346	1271	1343406290000000	11749	6039	2	0	\N
5348	1271	1343406292000000	11555	5937	3	0	\N
5349	1271	1343406292000000	11749	6039	3	0	\N
5351	1271	1343406310000000	10665	5507	3	0	\N
5352	1271	1344126302000000	13974	7160	8	0	\N
5353	1271	1344126302000000	14176	7237	8	0	\N
5355	1271	1344126328000000	13974	7160	9	0	\N
5356	1271	1344126328000000	14176	7237	9	0	\N
5362	1271	1346286388000000	17721	8955	7	0	\N
5365	1271	1346286422000000	17721	8955	8	0	\N
5366	1271	1346286859000000	19256	9604	78	0	\N
5367	1271	1347006421000000	18589	9369	2	0	\N
5368	1271	1347006421000000	18763	9457	3	0	\N
5370	1271	1347006432000000	18589	9369	3	0	\N
5371	1271	1347006433000000	18763	9457	4	0	\N
5373	1271	1347006858999998	19256	9604	85	0	\N
5374	1271	1347726435000000	22277	11151	3	0	\N
5376	1271	1347726447000000	22277	11151	4	0	\N
5378	1271	1347726764999928	19438	9605	0	0	\N
5383	1271	1349886471000000	23223	11485	0	0	\N
5384	1271	1349886472000000	23314	11486	0	0	\N
5388	1271	1349887454000000	27284	13408	97	0	\N
5389	1271	1350606471900000	23366	11487	1	0	\N
5390	1271	1350606484000000	24730	12168	0	0	\N
5391	1271	1350606484000000	24731	12184	0	0	\N
5392	1271	1350606484000000	24733	12199	0	0	\N
5393	1271	1350606484000000	24888	12357	3	0	\N
5394	1271	1350606484000000	25158	12481	6	0	\N
5395	1271	1350606496000000	24888	12357	4	0	\N
5398	1271	1350606509000000	25158	12481	7	0	\N
5399	1271	1350607454000000	27284	13408	125	0	\N
5404	1394	2880040000000	14421	7357	5	0	\N
5407	1394	2880054000000	14421	7357	6	0	\N
5408	1394	4320053000000	14436	7366	3	0	\N
5410	1394	4320065000000	14436	7366	4	0	\N
5414	1394	7200091000000	14468	7385	4	0	\N
5415	1394	7200091000000	14501	7397	8	0	\N
5416	1394	7200091000000	14504	7398	4	0	\N
5417	1394	7200091000000	14517	7404	2	0	\N
5419	1394	7200102000000	14517	7404	3	0	\N
5421	1394	7200104000000	14468	7385	5	0	\N
5422	1394	7200104000000	14504	7398	5	0	\N
5423	1394	7200126000000	14501	7397	9	0	\N
5426	1394	10080126000000	14526	7410	2	0	\N
5427	1394	10080126000000	14535	7412	2	0	\N
5429	1394	10080137000000	14526	7410	3	0	\N
5430	1394	10080137000000	14535	7412	3	0	\N
5432	1394	11520138000000	14607	7447	3	0	\N
5434	1394	11520150000000	14607	7447	4	0	\N
5438	1394	14400162000000	14638	7460	6	0	\N
5439	1394	14400162000000	14646	7465	3	0	\N
5308	1271	1334766010000000	2771	1449	1	0	0
5309	1271	1334766020000000	2771	1449	2	0	0
5313	1271	1335486020000000	3642	1889	0	0	0
5317	1271	1336206020000000	4914	2542	1	0	0
5319	1271	1336206030000000	4914	2542	2	0	0
5321	1271	1336926040000000	5106	2650	2	0	0
5322	1271	1337646040000000	5165	2680	1	0	0
5323	1271	1337646050000000	5165	2680	2	0	0
5324	1271	1338366050000000	6068	3152	2	0	0
5325	1271	1338366070000000	6068	3152	3	0	0
5331	1271	1339086090000000	6907	3569	3	0	0
5333	1271	1339806090000000	8150	4225	4	0	0
5335	1271	1339806220000000	8150	4225	5	0	0
5336	1271	1340526220000000	9156	4744	2	0	0
5338	1271	1341246240000000	10054	5214	1	0	0
5339	1271	1341246250000000	10054	5214	2	0	0
5340	1271	1341966250000000	10273	5316	2	0	0
5341	1271	1341966270000000	10273	5316	3	0	0
5342	1271	1342686270000000	10605	5477	2	0	0
5347	1271	1343406290000000	13204	6804	3	0	0
5350	1271	1343406302000000	13204	6804	4	0	0
5402	1394	1440000000000	14378	7336	4	0	0
5403	1394	1440040000000	14378	7336	5	0	0
5405	1394	2880040000000	14426	7360	4	0	0
5409	1394	4320053000000	14445	7372	3	0	0
5411	1394	4320065000000	14445	7372	4	0	0
5412	1394	5760065000000	14456	7379	8	0	0
5413	1394	5760091000000	14456	7379	9	0	0
5420	1394	7200102000000	14523	7407	3	0	0
5424	1394	8640102000000	14525	7409	6	0	0
5425	1394	8640126000000	14525	7409	7	0	0
5428	1394	10080126000000	14587	7438	3	0	0
5431	1394	10080138000000	14587	7438	4	0	0
5435	1394	11520150000000	14623	7454	4	0	0
5436	1394	12960150000000	14626	7455	3	0	0
5437	1394	12960162000000	14626	7455	4	0	0
5440	1394	14400162000000	14665	7471	6	0	0
5354	1271	1344126302000000	15181	7735	6	0	0
5358	1271	1344126377000000	16140	8204	6	0	0
5359	1271	1344846377000000	16140	8204	7	0	0
5360	1271	1345566377000000	16817	8535	2	0	0
5361	1271	1345566388000000	16817	8535	3	0	0
5364	1271	1346286421000000	18059	9108	7	0	0
5369	1271	1347006421000000	19730	9932	5	0	0
5372	1271	1347006435000000	19730	9932	6	0	0
5375	1271	1347726435000000	22732	11366	3	0	0
5377	1271	1347726447000000	22732	11366	4	0	0
5380	1271	1348446459000000	22785	11395	4	0	0
5381	1271	1349166459000000	22917	11455	4	0	0
5382	1271	1349166472000000	22917	11455	5	0	0
5385	1271	1349886472000000	24247	12065	3	0	0
5386	1271	1349886484000000	24247	12065	4	0	0
5396	1271	1350606505500001	28120	13902	6	0	0
5397	1271	1350606505500003	28120	13902	7	1	0
5400	1271	1351326505500003	28494	14081	2	0	0
5401	1271	1351326516500003	28494	14081	3	0	0
5441	1394	14400174000000	14646	7465	4	0	\N
5442	1394	14400186000000	14638	7460	7	0	\N
5448	1394	18720497000000	14685	7479	9	0	\N
5449	1394	18720497000000	14702	7486	4	0	\N
5451	1394	18720519000000	14702	7486	5	0	\N
5453	1394	18720569000000	14685	7479	10	0	\N
5458	1394	23040551000000	14761	7518	2	0	\N
5459	1394	23040551000000	14764	7519	6	0	\N
5461	1394	23040562000000	14761	7518	3	0	\N
5463	1394	23040584000000	14764	7519	7	0	\N
5476	1394	33120671000000	14852	7569	2	0	\N
5478	1394	33120682000000	14852	7569	3	0	\N
5480	1394	34560682000000	14869	7575	2	0	\N
5482	1394	34560693000000	14869	7575	3	0	\N
5490	1394	40320745000000	14899	7590	4	0	\N
5492	1394	40320758000000	14899	7590	5	0	\N
5494	1394	41760813000000	14916	7600	2	0	\N
5495	1394	41760813000000	14919	7601	3	0	\N
5496	1394	41760813000000	14954	7616	3	0	\N
5497	1394	41760813000000	14958	7618	3	0	\N
5499	1394	41760824000000	14916	7600	3	0	\N
5501	1394	41760825000000	14919	7601	4	0	\N
5502	1394	41760825000000	14954	7616	4	0	\N
5503	1394	41760825000000	14958	7618	4	0	\N
5504	1394	43200824000000	15005	7644	5	0	\N
5507	1394	43200847000000	15005	7644	6	0	\N
5512	1394	47520858000000	15044	7664	2	0	\N
5514	1394	47520869000000	15044	7664	3	0	\N
5516	1394	48960869000000	15057	7669	3	0	\N
5519	1394	48960890000000	15057	7669	4	0	\N
5525	1394	53280924000000	15149	7723	5	0	\N
5526	1394	54720901000000	15143	7719	1	0	\N
5528	1394	54720911000000	15143	7719	2	0	\N
5530	1394	54720924000000	15149	7723	7	0	\N
5531	1394	54720925000000	15149	7723	8	0	\N
5536	1394	59041036000000	15165	7730	3	0	\N
5537	1394	59041036000000	15184	7736	3	0	\N
5540	1394	59041048000000	15165	7730	4	0	\N
5541	1394	59041057000000	15184	7736	4	0	\N
5542	1394	60481047000000	15216	7752	2	0	\N
5543	1394	60481047000000	15225	7756	3	0	\N
5544	1394	60481047000000	15237	7760	2	0	\N
5545	1394	60481047000000	15266	7776	1	0	\N
5547	1394	60481057000000	15266	7776	2	0	\N
5548	1394	60481058000000	15216	7752	3	0	\N
5549	1394	60481058000000	15237	7760	3	0	\N
5550	1394	60481059000000	15225	7756	4	0	\N
5562	1394	69121163000000	15306	7798	8	0	\N
5565	1394	69121198000000	15306	7798	9	0	\N
5566	1394	70561175000000	15328	7812	2	0	\N
5567	1394	70561175000000	15337	7817	7	0	\N
5568	1394	70561175000000	15342	7819	3	0	\N
5569	1394	70561175000000	15366	7828	5	0	\N
5571	1394	70561186000000	15328	7812	3	0	\N
5572	1394	70561187000000	15342	7819	4	0	\N
5573	1394	70561198000000	15366	7828	6	0	\N
5575	1394	70561209000000	15337	7817	8	0	\N
5445	1394	15840284000000	14666	7472	9	0	0
5446	1394	17280284000000	14667	7473	24	0	0
5447	1394	17280497000000	14667	7473	25	0	0
5450	1394	18720497000000	14708	7489	5	0	0
5452	1394	18720529000000	14708	7489	6	0	0
5455	1394	20160540000000	14744	7505	3	0	0
5456	1394	21600540000000	14756	7514	2	0	0
5457	1394	21600551000000	14756	7514	3	0	0
5460	1394	23040551000000	14772	7524	2	0	0
5462	1394	23040562000000	14772	7524	3	0	0
5465	1394	24480573000000	14791	7534	3	0	0
5466	1394	25920573000000	14802	7542	5	0	0
5467	1394	25920605000000	14802	7542	6	0	0
5468	1394	27360605000000	14814	7548	2	0	0
5470	1394	28800616000000	14827	7558	2	0	0
5471	1394	28800627000000	14827	7558	3	0	0
5472	1394	30240627000000	14836	7561	2	0	0
5473	1394	30240638000000	14836	7561	3	0	0
5474	1394	31680638000000	14849	7567	6	0	0
5477	1394	33120671000000	14864	7573	2	0	0
5479	1394	33120682000000	14864	7573	3	0	0
5481	1394	34560682000000	14877	7578	7	0	0
5483	1394	34560707000000	14877	7578	8	0	0
5484	1394	36000707000000	14879	7580	3	0	0
5486	1394	37440719000000	14890	7587	4	0	0
5487	1394	37440732000000	14890	7587	5	0	0
5488	1394	38880732000000	14891	7588	4	0	0
5489	1394	38880745000000	14891	7588	5	0	0
5493	1394	40320813000000	14914	7599	15	0	0
5498	1394	41760813000000	14961	7620	2	0	0
5500	1394	41760824000000	14961	7620	3	0	0
5505	1394	43200824000000	15008	7645	2	0	0
5506	1394	43200835000000	15008	7645	3	0	0
5509	1394	44640847000000	15014	7649	4	0	0
5510	1394	46080847000000	15032	7660	2	0	0
5511	1394	46080858000000	15032	7660	3	0	0
5513	1394	47520858000000	15049	7666	2	0	0
5515	1394	47520869000000	15049	7666	3	0	0
5518	1394	48960880000000	15083	7683	3	0	0
5520	1394	50400880000000	15089	7687	1	0	0
5521	1394	50400890000000	15089	7687	2	0	0
5522	1394	51840890000000	15097	7692	0	0	0
5524	1394	53280901000000	15100	7694	3	0	0
5527	1394	54720901000000	15155	7725	2	0	0
5529	1394	54720912000000	15155	7725	3	0	0
5532	1394	56160912000000	15158	7727	3	0	0
5533	1394	56160924000000	15158	7727	4	0	0
5535	1394	57601036000000	15160	7728	5	0	0
5538	1394	59041036000000	15213	7751	2	0	0
5539	1394	59041047000000	15213	7751	3	0	0
5546	1394	60481047000000	15273	7780	8	0	0
5551	1394	60481082000000	15273	7780	9	0	0
5553	1394	61921104000000	15275	7781	5	0	0
5554	1394	63361104000000	15279	7782	3	0	0
5555	1394	63361116000000	15279	7782	4	0	0
5556	1394	64801116000000	15283	7785	3	0	0
5558	1394	66241128000000	15288	7789	5	0	0
5559	1394	66241151000000	15288	7789	6	0	0
5560	1394	67681151000000	15292	7793	3	0	0
5561	1394	67681163000000	15292	7793	4	0	0
5563	1394	69121163000000	15310	7800	3	0	0
5570	1394	70561175000000	15369	7829	5	0	0
5574	1394	70561198000000	15369	7829	6	0	0
5576	1394	72001198000000	15383	7836	2	0	0
5585	1394	77761245000000	15416	7853	3	0	\N
5586	1394	77761245000000	15431	7859	3	0	\N
5587	1394	77761245000000	15436	7862	4	0	\N
5588	1394	77761245000000	15437	7863	5	0	\N
5590	1394	77761257000000	15416	7853	4	0	\N
5591	1394	77761257000000	15431	7859	4	0	\N
5592	1394	77761267000000	15436	7862	5	0	\N
5593	1394	77761268000000	15437	7863	6	0	\N
5597	1394	80641291000000	15451	7869	0	0	\N
5600	1394	82081302000000	15476	7879	2	0	\N
5601	1394	82081302000000	15478	7880	5	0	\N
5602	1394	82081302000000	15480	7881	4	0	\N
5605	1394	82081313000000	15476	7879	3	0	\N
5606	1394	82081324000000	15480	7881	5	0	\N
5607	1394	82081325000000	15478	7880	6	0	\N
5612	1394	86401387000000	15587	7934	4	0	\N
5615	1394	86401409000000	15587	7934	5	0	\N
5618	1394	89281409000000	15607	7944	2	0	\N
5620	1394	89281420000000	15607	7944	3	0	\N
5622	1394	90721443000000	15618	7950	5	0	\N
5623	1394	90721443000000	15619	7951	2	0	\N
5625	1394	90721454000000	15619	7951	3	0	\N
5627	1394	90721466000000	15618	7950	6	0	\N
5630	1394	93601468000000	15725	7995	3	0	\N
5632	1394	93601480000000	15725	7995	4	0	\N
5636	1394	96481493000000	15743	8006	3	0	\N
5638	1394	96481505000000	15743	8006	4	0	\N
5640	1394	97921518000000	15768	8019	7	0	\N
5643	1394	97921552000000	15768	8019	8	0	\N
5648	1394	102241597000000	15850	8061	10	0	\N
5649	1394	102241597000000	15871	8072	4	0	\N
5650	1394	102241597000000	15880	8076	1	0	\N
5652	1394	102241607000000	15880	8076	2	0	\N
5653	1394	102241610000000	15871	8072	5	0	\N
5655	1394	102241634000000	15850	8061	11	0	\N
5656	1394	103681633000000	15937	8102	3	0	\N
5658	1394	103681645000000	15937	8102	4	0	\N
5660	1394	105121657000000	15944	8106	3	0	\N
5661	1394	105121657000000	15957	8113	3	0	\N
5663	1394	105121669000000	15944	8106	4	0	\N
5664	1394	105121669000000	15957	8113	4	0	\N
5670	1394	109441767000000	16029	8151	3	0	\N
5672	1394	109441779000000	16029	8151	4	0	\N
5678	1394	113761817000000	16055	8166	4	0	\N
5679	1394	113761817000000	16059	8168	4	0	\N
5680	1394	113761817000000	16079	8174	3	0	\N
5682	1394	113761829000000	16079	8174	4	0	\N
5684	1394	113761830000000	16055	8166	5	0	\N
5685	1394	113761830000000	16059	8168	5	0	\N
5686	1394	115201829000000	16090	8178	22	0	\N
5689	1394	115201905000000	16090	8178	23	0	\N
5696	1394	120961878000000	16118	8194	6	0	\N
5697	1394	120961878000000	16131	8201	4	0	\N
5700	1394	120961891000000	16131	8201	5	0	\N
5701	1394	120961902000000	16118	8194	7	0	\N
5702	1394	122401890000000	16148	8209	3	0	\N
5704	1394	122401902000000	16148	8209	4	0	\N
5706	1394	123841915000000	16212	8239	5	0	\N
5709	1394	123841938000000	16212	8239	6	0	\N
5712	1394	126721940000000	16246	8258	2	0	\N
5579	1394	73441221000000	15398	7842	4	0	0
5580	1394	73441231000000	15403	7846	1	0	0
5581	1394	74881231000000	15403	7846	4	0	0
5582	1394	74881233000000	15403	7846	5	0	0
5583	1394	76321233000000	15415	7852	3	0	0
5589	1394	77761245000000	15447	7867	7	0	0
5594	1394	77761279000000	15447	7867	8	0	0
5595	1394	79201279000000	15449	7868	3	0	0
5596	1394	79201291000000	15449	7868	4	0	0
5598	1394	80641291000000	15470	7877	2	0	0
5603	1394	82081302000000	15511	7893	1	0	0
5604	1394	82081303000000	15511	7893	2	0	0
5608	1394	83521303000000	15537	7907	6	0	0
5609	1394	83521327000000	15537	7907	7	0	0
5611	1394	84961387000000	15561	7920	7	0	0
5613	1394	86401387000000	15588	7935	2	0	0
5614	1394	86401398000000	15588	7935	3	0	0
5616	1394	87841398000000	15602	7942	2	0	0
5617	1394	87841409000000	15602	7942	3	0	0
5621	1394	89281443000000	15608	7945	8	0	0
5624	1394	90721443000000	15625	7954	4	0	0
5626	1394	90721456000000	15625	7954	5	0	0
5628	1394	92161456000000	15721	7994	3	0	0
5629	1394	92161468000000	15721	7994	4	0	0
5633	1394	93601481000000	15726	7996	5	0	0
5634	1394	95041481000000	15733	8001	3	0	0
5635	1394	95041493000000	15733	8001	4	0	0
5637	1394	96481493000000	15754	8011	7	0	0
5641	1394	97921518000000	15795	8037	4	0	0
5642	1394	97921531000000	15795	8037	5	0	0
5644	1394	99361531000000	15805	8045	5	0	0
5645	1394	99361554000000	15805	8045	6	0	0
5646	1394	100801554000000	15834	8055	7	0	0
5651	1394	102241597000000	15889	8078	9	0	0
5654	1394	102241633000000	15889	8078	10	0	0
5657	1394	103681633000000	15942	8104	6	0	0
5659	1394	103681657000000	15942	8104	7	0	0
5662	1394	105121657000000	15995	8132	3	0	0
5666	1394	106561669000000	16004	8139	10	0	0
5667	1394	106561706000000	16004	8139	11	0	0
5668	1394	108001706000000	16007	8141	16	0	0
5669	1394	108001767000000	16007	8141	17	0	0
5673	1394	109441792000000	16035	8154	8	0	0
5674	1394	110881792000000	16044	8159	3	0	0
5675	1394	110881804000000	16044	8159	4	0	0
5676	1394	112321804000000	16045	8160	4	0	0
5677	1394	112321817000000	16045	8160	5	0	0
5683	1394	113761829000000	16085	8176	4	0	0
5687	1394	115201829000000	16096	8181	4	0	0
5688	1394	115201842000000	16096	8181	5	0	0
5690	1394	116641842000000	16098	8183	3	0	0
5691	1394	116641854000000	16098	8183	4	0	0
5693	1394	118081866000000	16110	8188	4	0	0
5694	1394	119521866000000	16113	8191	3	0	0
5695	1394	119521878000000	16113	8191	4	0	0
5698	1394	120961878000000	16144	8207	3	0	0
5703	1394	122401890000000	16192	8229	7	0	0
5705	1394	122401915000000	16192	8229	8	0	0
5707	1394	123841915000000	16218	8242	4	0	0
5708	1394	123841928000000	16218	8242	5	0	0
5710	1394	125281928000000	16243	8256	3	0	0
5714	1394	126721951000000	16246	8258	3	0	\N
5724	1394	133922199000000	16333	8302	4	0	\N
5726	1394	133922212000000	16333	8302	5	0	\N
5740	1394	144002469000000	16413	8349	4	0	\N
5741	1394	144002469000000	16420	8352	4	0	\N
5743	1394	144002482000000	16413	8349	5	0	\N
5744	1394	144002482000000	16420	8352	5	0	\N
5749	1394	146882495000000	16432	8356	7	0	\N
5752	1394	146882520000000	16432	8356	8	0	\N
5774	1394	162722743000000	16505	8396	3	0	\N
5776	1394	162722755000000	16505	8396	4	0	\N
5781	1394	165602829000000	16544	8410	14	0	\N
5782	1394	165602829000000	16550	8411	4	0	\N
5784	1394	165602842000000	16550	8411	5	0	\N
5786	1394	165602888000000	16544	8410	15	0	\N
5789	1394	168482876000000	16578	8426	10	0	\N
5792	1394	168482913000000	16578	8426	11	0	\N
5793	1394	168482919000000	16598	8434	1	0	\N
5795	1394	169922919000000	16598	8434	4	0	\N
5796	1394	169922921000000	16598	8434	5	0	\N
5803	1394	175682970000000	16645	8457	15	0	\N
5806	1394	175683030000000	16645	8457	16	0	\N
5807	1394	177122982000000	16663	8465	3	0	\N
5808	1394	177122982000000	16669	8468	3	0	\N
5810	1394	177122994000000	16663	8465	4	0	\N
5811	1394	177122994000000	16669	8468	4	0	\N
5813	1394	178562995000000	16706	8488	7	0	\N
5814	1394	178562995000000	16730	8497	2	0	\N
5816	1394	178563006000000	16730	8497	3	0	\N
5818	1394	178563020000000	16706	8488	8	0	\N
5825	1394	184323045000000	16763	8508	3	0	\N
5827	1394	184323057000000	16763	8508	4	0	\N
5829	1394	185763057000000	16773	8514	13	0	\N
5830	1394	185763057000000	16797	8525	11	0	\N
5831	1394	185763057000000	16821	8538	3	0	\N
5832	1394	185763057000000	16835	8543	4	0	\N
5834	1394	185763069000000	16821	8538	4	0	\N
5836	1394	185763070000000	16835	8543	5	0	\N
5837	1394	185763106000000	16773	8514	14	0	\N
5838	1394	185763221000000	16797	8525	12	0	\N
5841	1394	188643082000000	16915	8575	3	0	\N
5842	1394	188643082000000	16920	8577	4	0	\N
5843	1394	188643082000000	16937	8585	7	0	\N
5846	1394	188643094000000	16915	8575	4	0	\N
5847	1394	188643095000000	16920	8577	5	0	\N
5848	1394	188643107000000	16937	8585	8	0	\N
5716	1394	128161989000000	16313	8288	3	0	0
5717	1394	128162001000000	16313	8288	4	0	0
5718	1394	129602001000000	16320	8292	3	0	0
5719	1394	129602013000000	16320	8292	4	0	0
5720	1394	131042013000000	16329	8300	21	0	0
5722	1394	132482187000000	16331	8301	3	0	0
5723	1394	132482199000000	16331	8301	4	0	0
5725	1394	133922199000000	16335	8303	6	0	0
5727	1394	133922322000000	16335	8303	7	0	0
5728	1394	135362322000000	16339	8307	4	0	0
5730	1394	136802409000000	16342	8310	3	0	0
5731	1394	136802421000000	16342	8310	4	0	0
5732	1394	138242421000000	16345	8312	3	0	0
5733	1394	138242433000000	16345	8312	4	0	0
5735	1394	139682445000000	16355	8318	4	0	0
5736	1394	141122445000000	16381	8332	3	0	0
5737	1394	141122457000000	16381	8332	4	0	0
5738	1394	142562457000000	16383	8333	3	0	0
5739	1394	142562469000000	16383	8333	4	0	0
5745	1394	144002482000000	16426	8354	5	0	0
5746	1394	145442482000000	16429	8355	4	0	0
5747	1394	145442495000000	16429	8355	5	0	0
5748	1394	145442505000000	16444	8363	1	0	0
5750	1394	146882505000000	16444	8363	4	0	0
5753	1394	148322507000000	16448	8366	7	0	0
5754	1394	148322532000000	16448	8366	8	0	0
5755	1394	149762532000000	16451	8368	8	0	0
5756	1394	149762567000000	16451	8368	9	0	0
5758	1394	151202579000000	16455	8369	4	0	0
5759	1394	152642579000000	16465	8375	3	0	0
5760	1394	152642591000000	16465	8375	4	0	0
5761	1394	154082591000000	16470	8377	3	0	0
5762	1394	154082603000000	16470	8377	4	0	0
5764	1394	155522633000000	16483	8383	15	0	0
5765	1394	155522662000000	16483	8383	16	0	0
5766	1394	156962662000000	16488	8384	3	0	0
5767	1394	156962674000000	16488	8384	4	0	0
5768	1394	158402674000000	16491	8387	4	0	0
5770	1394	159842696000000	16501	8394	3	0	0
5771	1394	159842708000000	16501	8394	4	0	0
5772	1394	161282708000000	16503	8395	8	0	0
5773	1394	161282743000000	16503	8395	9	0	0
5777	1394	162722768000000	16508	8398	8	0	0
5778	1394	162722808000000	16510	8399	4	0	0
5779	1394	164162808000000	16510	8399	17	0	0
5780	1394	164162829000000	16510	8399	18	0	0
5783	1394	165602829000000	16554	8413	5	0	0
5787	1394	167042852000000	16562	8418	6	0	0
5788	1394	167042876000000	16562	8418	7	0	0
5790	1394	168482876000000	16589	8430	5	0	0
5791	1394	168482909000000	16589	8430	6	0	0
5794	1394	169922909000000	16611	8437	6	0	0
5798	1394	171362933000000	16613	8439	3	0	0
5799	1394	171362945000000	16613	8439	4	0	0
5800	1394	172802945000000	16638	8453	7	0	0
5801	1394	172802970000000	16638	8453	8	0	0
5804	1394	175682970000000	16646	8458	3	0	0
5805	1394	175682982000000	16646	8458	4	0	0
5809	1394	177122982000000	16698	8483	4	0	0
5812	1394	177122995000000	16698	8483	5	0	0
5815	1394	178562995000000	16733	8498	3	0	0
5819	1394	180003007000000	16735	8499	4	0	0
5820	1394	180003020000000	16735	8499	5	0	0
5821	1394	181443020000000	16751	8503	4	0	0
5822	1394	181443042000000	16751	8503	5	0	0
5823	1394	182883042000000	16760	8507	3	0	0
5826	1394	184323045000000	16764	8509	3	0	0
5828	1394	184323057000000	16764	8509	4	0	0
5833	1394	185763057000000	16842	8545	3	0	0
5835	1394	185763069000000	16842	8545	4	0	0
5840	1394	187203082000000	16866	8554	5	0	0
5844	1394	188643082000000	16942	8588	1	0	0
5845	1394	188643092000000	16942	8588	2	0	0
5849	1394	190083092000000	16946	8589	2	0	\N
5851	1394	190083103000000	16946	8589	3	0	\N
5855	1394	192963136000000	16976	8600	2	0	\N
5856	1394	192963136000000	16986	8604	5	0	\N
5858	1394	192963147000000	16976	8600	3	0	\N
5860	1394	192963159000000	16986	8604	6	0	\N
5875	1394	204483229000000	17132	8681	3	0	\N
5877	1394	204483241000000	17132	8681	4	0	\N
5880	1394	207363264000000	17155	8696	10	0	\N
5883	1394	207363301000000	17155	8696	11	0	\N
5886	1394	210243288000000	17241	8734	7	0	\N
5889	1394	210243313000000	17241	8734	8	0	\N
5892	1394	211683333000000	17280	8752	2	0	\N
5894	1394	213123333000000	17280	8752	4	0	\N
5895	1394	213123334000000	17280	8752	5	0	\N
5899	1394	216003394000000	17321	8776	3	0	\N
5900	1394	216003394000000	17323	8777	7	0	\N
5902	1394	216003406000000	17321	8776	4	0	\N
5904	1394	216003518000000	17323	8777	8	0	\N
5905	1394	217443406000000	17373	8799	3	0	\N
5907	1394	217443418000000	17373	8799	4	0	\N
5911	1394	220323454000000	17386	8806	3	0	\N
5914	1394	220323466000000	17386	8806	4	0	\N
5915	1394	221763456000000	17413	8820	3	0	\N
5916	1394	221763456000000	17461	8843	9	0	\N
5917	1394	221763456000000	17487	8852	8	0	\N
5920	1394	221763468000000	17413	8820	4	0	\N
5921	1394	221763509000000	17487	8852	9	0	\N
5922	1394	221763528000000	17461	8843	10	0	\N
5923	1394	223203467000000	17500	8859	2	0	\N
5925	1394	223203478000000	17500	8859	3	0	\N
5927	1394	224643479000000	17504	8863	6	0	\N
5928	1394	224643479000000	17524	8872	2	0	\N
5929	1394	224643479000000	17550	8886	3	0	\N
5930	1394	224643479000000	17557	8888	3	0	\N
5932	1394	224643490000000	17524	8872	3	0	\N
5933	1394	224643491000000	17550	8886	4	0	\N
5934	1394	224643491000000	17557	8888	4	0	\N
5936	1394	224643503000000	17504	8863	7	0	\N
5937	1394	226083491000000	17570	8892	3	0	\N
5938	1394	226083491000000	17572	8893	6	0	\N
5941	1394	226083503000000	17570	8892	4	0	\N
5942	1394	226083515000000	17572	8893	7	0	\N
5943	1394	227523493000000	17606	8905	5	0	\N
5946	1394	227523515000000	17580	8894	9	0	\N
5947	1394	227523534000000	17606	8905	6	0	\N
5948	1394	227523551000000	17580	8894	10	0	\N
5955	1394	233283540000000	17644	8921	7	0	\N
5956	1394	233283540000000	17659	8927	2	0	\N
5957	1394	233283540000000	17664	8930	2	0	\N
5958	1394	233283540000000	17675	8935	2	0	\N
5960	1394	233283551000000	17659	8927	3	0	\N
5961	1394	233283551000000	17664	8930	3	0	\N
5962	1394	233283551000000	17675	8935	3	0	\N
5964	1394	233283592000000	17644	8921	8	0	\N
5967	1394	236163562000000	17711	8952	4	0	\N
5969	1394	236163584000000	17711	8952	5	0	\N
5973	1394	239043595000000	17746	8967	6	0	\N
5975	1394	239043619000000	17746	8967	7	0	\N
5977	1394	240483643000000	17762	8974	3	0	\N
5979	1394	240483655000000	17762	8974	4	0	\N
5853	1394	191523103000000	16958	8594	6	0	0
5854	1394	191523136000000	16958	8594	7	0	0
5857	1394	192963136000000	17019	8621	3	0	0
5859	1394	192963148000000	17019	8621	4	0	0
5861	1394	194403148000000	17036	8626	3	0	0
5863	1394	195843160000000	17050	8635	3	0	0
5864	1394	195843172000000	17050	8635	4	0	0
5865	1394	197283172000000	17087	8657	3	0	0
5866	1394	197283184000000	17087	8657	4	0	0
5867	1394	198723184000000	17088	8658	3	0	0
5869	1394	200163196000000	17111	8670	2	0	0
5870	1394	200163207000000	17111	8670	3	0	0
5871	1394	201603207000000	17121	8675	3	0	0
5872	1394	201603219000000	17121	8675	4	0	0
5874	1394	203043229000000	17128	8679	2	0	0
5876	1394	204483229000000	17146	8691	0	0	0
5878	1394	205923229000000	17147	8692	8	0	0
5879	1394	205923264000000	17147	8692	9	0	0
5881	1394	207363264000000	17191	8712	3	0	0
5884	1394	208803276000000	17198	8715	3	0	0
5885	1394	208803288000000	17198	8715	4	0	0
5887	1394	210243288000000	17259	8741	4	0	0
5888	1394	210243310000000	17259	8741	5	0	0
5890	1394	211683310000000	17272	8749	3	0	0
5893	1394	213123322000000	17298	8762	12	0	0
5896	1394	213123370000000	17298	8762	13	0	0
5897	1394	214563370000000	17302	8764	6	0	0
5898	1394	214563394000000	17302	8764	7	0	0
5903	1394	216003406000000	17343	8787	4	0	0
5906	1394	217443406000000	17378	8802	6	0	0
5908	1394	217443430000000	17378	8802	7	0	0
5909	1394	218883430000000	17381	8804	6	0	0
5910	1394	218883454000000	17381	8804	7	0	0
5913	1394	220323456000000	17402	8814	3	0	0
5918	1394	221763456000000	17496	8857	2	0	0
5919	1394	221763467000000	17496	8857	3	0	0
5924	1394	223203467000000	17503	8862	3	0	0
5926	1394	223203479000000	17503	8862	4	0	0
5935	1394	224643491000000	17561	8889	4	0	0
5939	1394	226083491000000	17603	8904	2	0	0
5940	1394	226083493000000	17603	8904	3	0	0
5944	1394	227523493000000	17608	8906	2	0	0
5949	1394	228963504000000	17616	8909	3	0	0
5950	1394	228963516000000	17616	8909	4	0	0
5951	1394	230403516000000	17622	8911	3	0	0
5952	1394	230403528000000	17622	8911	4	0	0
5953	1394	231843528000000	17640	8918	3	0	0
5959	1394	233283540000000	17685	8940	2	0	0
5963	1394	233283551000000	17685	8940	3	0	0
5965	1394	234723551000000	17707	8949	2	0	0
5966	1394	234723562000000	17707	8949	3	0	0
5968	1394	236163562000000	17717	8954	4	0	0
5971	1394	237603584000000	17722	8956	2	0	0
5972	1394	237603595000000	17722	8956	3	0	0
5974	1394	239043595000000	17756	8972	12	0	0
5976	1394	239043643000000	17756	8972	13	0	0
5980	1394	240483668000000	17767	8976	8	0	0
5981	1394	241923668000000	17772	8979	4	0	0
5982	1394	241923681000000	17772	8979	5	0	0
5983	1394	243363681000000	17782	8986	3	0	0
5984	1394	243363693000000	17782	8986	4	0	0
5985	1394	244803693000000	17799	8992	3	0	\N
5987	1394	244803705000000	17799	8992	4	0	\N
5989	1394	246243706000000	17852	9011	4	0	\N
5990	1394	246243706000000	17862	9015	4	0	\N
5992	1394	246243719000000	17852	9011	5	0	\N
5993	1394	246243719000000	17862	9015	5	0	\N
5995	1394	246243743000000	17881	9025	2	0	\N
5996	1394	247683732000000	17870	9019	4	0	\N
5998	1394	247683743000000	17881	9025	4	0	\N
5999	1394	247683744000000	17881	9025	5	0	\N
6000	1394	247683745000000	17870	9019	5	0	\N
6004	1394	250563759000000	17917	9038	3	0	\N
6006	1394	250563771000000	17917	9038	4	0	\N
6016	1394	257763888000000	18020	9090	4	0	\N
6019	1394	257763901000000	18020	9090	5	0	\N
6026	1394	263523954000000	18112	9136	2	0	\N
6027	1394	263523954000000	18136	9145	7	0	\N
6029	1394	263523965000000	18112	9136	3	0	\N
6031	1394	263523988000000	18136	9145	8	0	\N
6046	1394	275044073000000	18265	9200	2	0	\N
6048	1394	275044084000000	18265	9200	3	0	\N
6050	1394	276484084000000	18273	9206	5	0	\N
6051	1394	276484084000000	18297	9219	2	0	\N
6052	1394	276484084000000	18318	9227	2	0	\N
6054	1394	276484095000000	18297	9219	3	0	\N
6055	1394	276484095000000	18318	9227	3	0	\N
6057	1394	276484107000000	18273	9206	6	0	\N
6058	1394	277924095000000	18328	9232	5	0	\N
6059	1394	277924095000000	18330	9233	5	0	\N
6062	1394	277924118000000	18330	9233	6	0	\N
6063	1394	277924127000000	18328	9232	6	0	\N
6072	1394	283684175000000	18380	9264	1	0	\N
6074	1394	285124175000000	18380	9264	6	0	\N
6076	1394	285124188000000	18380	9264	7	0	\N
6079	1394	288004199000000	18402	9277	3	0	\N
6080	1394	288004199000000	18406	9278	3	0	\N
6081	1394	288004199000000	18411	9283	3	0	\N
6083	1394	288004211000000	18402	9277	4	0	\N
6084	1394	288004211000000	18411	9283	4	0	\N
6086	1394	288004220000000	18406	9278	4	0	\N
6091	1394	292324236000000	18455	9301	3	0	\N
6092	1394	292324236000000	18495	9315	4	0	\N
6093	1394	292324236000000	18502	9319	3	0	\N
6095	1394	292324248000000	18455	9301	4	0	\N
6096	1394	292324248000000	18502	9319	4	0	\N
6098	1394	292324258000000	18495	9315	5	0	\N
6100	1394	295204248000000	18524	9331	4	0	\N
6103	1394	295204261000000	18524	9331	5	0	\N
6108	1394	299524284000000	18544	9344	3	0	\N
6110	1394	299524296000000	18544	9344	4	0	\N
5991	1394	246243706000000	17867	9017	8	0	0
5994	1394	246243732000000	17867	9017	9	0	0
5997	1394	247683732000000	17899	9031	7	0	0
6001	1394	247683757000000	17899	9031	8	0	0
6002	1394	249123757000000	17906	9033	2	0	0
6005	1394	250563759000000	17921	9040	4	0	0
6007	1394	250563772000000	17921	9040	5	0	0
6008	1394	252003772000000	17928	9044	4	0	0
6009	1394	252003785000000	17928	9044	5	0	0
6010	1394	253443785000000	17968	9063	2	0	0
6012	1394	254883796000000	17984	9071	8	0	0
6013	1394	254883831000000	17984	9071	9	0	0
6014	1394	256323831000000	17992	9077	12	0	0
6015	1394	256323888000000	17992	9077	13	0	0
6018	1394	257763900000000	18023	9092	4	0	0
6020	1394	259203900000000	18046	9103	3	0	0
6021	1394	259203921000000	18046	9103	4	0	0
6022	1394	260643921000000	18052	9106	4	0	0
6023	1394	260643943000000	18052	9106	5	0	0
6025	1394	262083954000000	18082	9119	3	0	0
6028	1394	263523954000000	18139	9146	2	0	0
6030	1394	263523965000000	18139	9146	3	0	0
6032	1394	264963965000000	18162	9156	4	0	0
6033	1394	264963978000000	18162	9156	5	0	0
6035	1394	266403990000000	18165	9158	4	0	0
6036	1394	267843990000000	18171	9163	6	0	0
6037	1394	267844014000000	18171	9163	7	0	0
6038	1394	269284014000000	18219	9177	5	0	0
6040	1394	270724028000000	18246	9190	2	0	0
6041	1394	270724039000000	18246	9190	3	0	0
6042	1394	272164039000000	18262	9198	2	0	0
6043	1394	272164050000000	18262	9198	3	0	0
6044	1394	273604050000000	18263	9199	5	0	0
6047	1394	275044073000000	18270	9204	2	0	0
6049	1394	275044084000000	18270	9204	3	0	0
6053	1394	276484084000000	18324	9230	2	0	0
6056	1394	276484095000000	18324	9230	3	0	0
6060	1394	277924095000000	18345	9243	5	0	0
6064	1394	279364109000000	18365	9255	5	0	0
6065	1394	279364132000000	18365	9255	6	0	0
6066	1394	280804132000000	18373	9259	2	0	0
6067	1394	280804143000000	18373	9259	3	0	0
6069	1394	282244154000000	18374	9260	3	0	0
6070	1394	283684154000000	18378	9263	2	0	0
6071	1394	283684165000000	18378	9263	3	0	0
6073	1394	285124165000000	18386	9267	4	0	0
6075	1394	285124187000000	18386	9267	5	0	0
6078	1394	286564199000000	18388	9268	4	0	0
6082	1394	288004199000000	18417	9285	3	0	0
6085	1394	288004211000000	18417	9285	4	0	0
6087	1394	289444211000000	18426	9290	3	0	0
6088	1394	289444223000000	18426	9290	4	0	0
6090	1394	290884236000000	18447	9299	5	0	0
6094	1394	292324236000000	18518	9327	3	0	0
6097	1394	292324248000000	18518	9327	4	0	0
6099	1394	293764248000000	18521	9328	0	0	0
6102	1394	295204260000000	18530	9335	4	0	0
6104	1394	296644260000000	18538	9340	3	0	0
6105	1394	296644272000000	18538	9340	4	0	0
6106	1394	298084272000000	18539	9341	3	0	0
6107	1394	298084284000000	18539	9341	4	0	0
6111	1394	299524396000000	18548	9345	5	0	0
6112	1394	300964396000000	18556	9351	4	0	0
6113	1394	300964409000000	18556	9351	5	0	0
6114	1394	302404409000000	18560	9353	3	0	0
6115	1394	302404421000000	18560	9353	4	0	0
6117	1394	303844545000000	18561	9354	8	0	0
6118	1394	305284545000000	18572	9359	4	0	0
6119	1394	305284657000000	18572	9359	5	0	0
6120	1394	306724657000000	18576	9360	1	0	0
6126	1394	311044711000000	18605	9375	2	0	\N
6127	1394	311044711000000	18627	9387	5	0	\N
6129	1394	311044722000000	18605	9375	3	0	\N
6131	1394	311044734000000	18627	9387	6	0	\N
6138	1394	316804757000000	18725	9435	3	0	\N
6141	1394	316804769000000	18725	9435	4	0	\N
6144	1394	319684791000000	18762	9457	3	0	\N
6145	1394	319684791000000	18767	9458	3	0	\N
6148	1394	319684803000000	18762	9457	4	0	\N
6149	1394	319684902000000	18767	9458	4	0	\N
6150	1394	321124802000000	18806	9478	3	0	\N
6151	1394	321124802000000	18809	9479	2	0	\N
6152	1394	321124802000000	18823	9486	2	0	\N
6155	1394	321124813000000	18809	9479	3	0	\N
6156	1394	321124813000000	18823	9486	3	0	\N
6157	1394	321124814000000	18806	9478	4	0	\N
6164	1394	326884843000000	18913	9540	2	0	\N
6165	1394	326884843000000	18914	9541	2	0	\N
6166	1394	326884843000000	18922	9545	1	0	\N
6167	1394	326884843000000	18929	9548	1	0	\N
6168	1394	326884843000000	18947	9558	3	0	\N
6169	1394	326884843000000	18949	9559	1	0	\N
6171	1394	326884853000000	18922	9545	2	0	\N
6172	1394	326884853000000	18929	9548	2	0	\N
6173	1394	326884853000000	18949	9559	2	0	\N
6175	1394	326884854000000	18914	9541	3	0	\N
6176	1394	326884863000000	18913	9540	3	0	\N
6177	1394	326884864000000	18947	9558	4	0	\N
6178	1394	328324853000000	18967	9567	2	0	\N
6179	1394	328324853000000	18983	9573	2	0	\N
6181	1394	328324864000000	18967	9567	3	0	\N
6182	1394	328324864000000	18983	9573	3	0	\N
6190	1394	334084895000000	19052	9610	3	0	\N
6191	1394	334084895000000	19068	9617	1	0	\N
6193	1394	334084905000000	19068	9617	2	0	\N
6195	1394	334084916000000	19052	9610	4	0	\N
6198	1394	336964915000000	19087	9628	1	0	\N
6200	1394	336964925000000	19087	9628	2	0	\N
6220	1394	351365135000000	19199	9686	7	0	\N
6223	1394	351365160000000	19199	9686	8	0	\N
6230	1394	357125216000000	19251	9706	3	0	\N
6232	1394	357125228000000	19251	9706	4	0	\N
6234	1394	358565253000000	19275	9717	3	0	\N
6236	1394	358565265000000	19275	9717	4	0	\N
6238	1394	360005265000000	19287	9723	8	0	\N
6241	1394	360005327000000	19287	9723	9	0	\N
6246	1394	364325305000000	19325	9745	9	0	\N
6248	1394	364325368000000	19325	9745	10	0	\N
6250	1394	365765442000000	19334	9748	4	0	\N
6251	1394	365765442000000	19343	9752	10	0	\N
6254	1394	365765455000000	19334	9748	5	0	\N
6255	1394	365765470000000	19343	9752	11	0	\N
6256	1394	367205454000000	19351	9757	3	0	\N
6123	1394	308164700000000	18588	9368	7	0	0
6124	1394	309604700000000	18601	9371	2	0	0
6125	1394	309604711000000	18601	9371	3	0	0
6128	1394	311044711000000	18651	9398	2	0	0
6130	1394	311044722000000	18651	9398	3	0	0
6133	1394	312484734000000	18652	9399	4	0	0
6134	1394	313924734000000	18662	9404	3	0	0
6135	1394	313924746000000	18662	9404	4	0	0
6136	1394	315364746000000	18720	9432	2	0	0
6137	1394	315364757000000	18720	9432	3	0	0
6140	1394	316804768000000	18729	9437	3	0	0
6142	1394	318244768000000	18732	9439	5	0	0
6143	1394	318244791000000	18732	9439	6	0	0
6146	1394	319684791000000	18805	9477	2	0	0
6153	1394	321124802000000	18826	9487	1	0	0
6154	1394	321124812000000	18826	9487	2	0	0
6158	1394	322564812000000	18832	9490	1	0	0
6159	1394	322564822000000	18832	9490	2	0	0
6160	1394	324004822000000	18834	9492	2	0	0
6162	1394	325444833000000	18853	9505	1	0	0
6163	1394	325444843000000	18853	9505	2	0	0
6170	1394	326884843000000	18955	9562	1	0	0
6174	1394	326884853000000	18955	9562	2	0	0
6180	1394	328324853000000	19027	9593	2	0	0
6184	1394	329764864000000	19030	9596	1	0	0
6185	1394	329764874000000	19030	9596	2	0	0
6186	1394	331204874000000	19039	9602	2	0	0
6187	1394	331204885000000	19039	9602	3	0	0
6189	1394	332644895000000	19051	9609	2	0	0
6192	1394	334084895000000	19070	9618	1	0	0
6194	1394	334084905000000	19070	9618	2	0	0
6196	1394	335524905000000	19081	9624	1	0	0
6197	1394	335524915000000	19081	9624	2	0	0
6201	1394	336964976000000	19089	9629	8	0	0
6202	1394	338404976000000	19098	9632	3	0	0
6203	1394	338404988000000	19098	9632	4	0	0
6204	1394	339844988000000	19099	9633	3	0	0
6205	1394	339845000000000	19099	9633	4	0	0
6207	1394	341285024000000	19102	9634	7	0	0
6208	1394	342725024000000	19134	9651	10	0	0
6209	1394	342725061000000	19134	9651	11	0	0
6210	1394	344165061000000	19156	9663	4	0	0
6212	1394	345605074000000	19168	9669	7	0	0
6213	1394	345605099000000	19168	9669	8	0	0
6214	1394	347045099000000	19189	9681	3	0	0
6215	1394	347045111000000	19189	9681	4	0	0
6216	1394	348485111000000	19190	9682	3	0	0
6218	1394	349925123000000	19195	9684	3	0	0
6219	1394	349925135000000	19195	9684	4	0	0
6221	1394	351365135000000	19213	9693	3	0	0
6222	1394	351365147000000	19213	9693	4	0	0
6224	1394	352805147000000	19242	9700	3	0	0
6226	1394	354245159000000	19243	9701	5	0	0
6227	1394	354245182000000	19243	9701	6	0	0
6228	1394	355685182000000	19244	9702	7	0	0
6229	1394	355685216000000	19244	9702	8	0	0
6233	1394	357125253000000	19261	9709	11	0	0
6235	1394	358565253000000	19281	9720	3	0	0
6237	1394	358565265000000	19281	9720	4	0	0
6239	1394	360005265000000	19288	9724	4	0	0
6240	1394	360005278000000	19288	9724	5	0	0
6243	1394	361445280000000	19309	9736	3	0	0
6244	1394	362885280000000	19316	9740	7	0	0
6245	1394	362885305000000	19316	9740	8	0	0
6247	1394	364325305000000	19328	9746	11	0	0
6249	1394	364325442000000	19328	9746	12	0	0
6253	1394	365765454000000	19345	9754	4	0	0
6258	1394	367205466000000	19351	9757	4	0	\N
6260	1394	368645466000000	19373	9767	3	0	\N
6262	1394	368645478000000	19373	9767	4	0	\N
6270	1394	374405651000000	19432	9794	3	0	\N
6271	1394	374405651000000	19437	9796	3	0	\N
6273	1394	374405663000000	19432	9794	4	0	\N
6274	1394	374405663000000	19437	9796	4	0	\N
6276	1394	375845663000000	19449	9802	7	0	\N
6277	1394	375845663000000	19452	9803	5	0	\N
6279	1394	375845677000000	19452	9803	6	0	\N
6280	1394	375845688000000	19449	9802	8	0	\N
6284	1394	378725703000000	19463	9810	2	0	\N
6285	1394	378725703000000	19477	9819	5	0	\N
6286	1394	378725703000000	19484	9822	3	0	\N
6288	1394	378725706000000	19484	9822	4	0	\N
6289	1394	378725714000000	19463	9810	3	0	\N
6291	1394	378725717000000	19477	9819	6	0	\N
6292	1394	380165715000000	19516	9834	4	0	\N
6293	1394	380165715000000	19520	9835	3	0	\N
6295	1394	380165727000000	19520	9835	4	0	\N
6297	1394	380165728000000	19516	9834	5	0	\N
6300	1394	383045739000000	19541	9843	4	0	\N
6303	1394	383045752000000	19541	9843	5	0	\N
6306	1394	385925763000000	19588	9866	3	0	\N
6307	1394	385925763000000	19606	9875	3	0	\N
6309	1394	385925775000000	19588	9866	4	0	\N
6310	1394	385925775000000	19606	9875	4	0	\N
6314	1394	388805813000000	19627	9885	13	0	\N
6317	1394	388805862000000	19627	9885	14	0	\N
6332	1394	400326201000000	19748	9942	3	0	\N
6334	1394	400326213000000	19748	9942	4	0	\N
6340	1394	404646250000000	19790	9967	3	0	\N
6342	1394	404646262000000	19790	9967	4	0	\N
6344	1394	406086262000000	19851	10001	5	0	\N
6347	1394	406086285000000	19851	10001	6	0	\N
6352	1394	410406308500000	19905	10025	10	0	\N
6353	1394	410406308500000	19908	10026	4	0	\N
6354	1394	410406308500000	19925	10035	3	0	\N
6356	1394	410406320500000	19925	10035	4	0	\N
6358	1394	410406345500000	19905	10025	11	0	\N
6359	1394	410406420500000	19908	10026	5	0	\N
6364	1394	414726364500000	19985	10064	3	0	\N
6365	1394	414726364500000	19993	10068	3	0	\N
6367	1394	414726367500000	19985	10064	4	0	\N
6368	1394	414726376500000	19993	10068	4	0	\N
6370	1394	416166486500000	20004	10072	5	0	\N
6371	1394	416166486500000	20019	10077	4	0	\N
6373	1394	416166499500000	20019	10077	5	0	\N
6375	1394	416166608500000	20004	10072	6	0	\N
6376	1394	417606499500000	20072	10103	4	0	\N
6379	1394	417606512500000	20072	10103	5	0	\N
6381	1394	419046511500000	20080	10108	7	0	\N
6384	1394	419046563500000	20080	10108	8	0	\N
6385	1394	420486554500000	20102	10118	11	0	\N
6388	1394	420486628500000	20102	10118	12	0	\N
6261	1394	368645466000000	19409	9781	3	0	0
6263	1394	368645478000000	19409	9781	4	0	0
6264	1394	370085478000000	19411	9782	7	0	0
6265	1394	370085503000000	19411	9782	8	0	0
6266	1394	371525503000000	19418	9787	3	0	0
6268	1394	372965515000000	19430	9793	10	0	0
6269	1394	372965651000000	19430	9793	11	0	0
6272	1394	374405651000000	19443	9800	3	0	0
6275	1394	374405663000000	19443	9800	4	0	0
6278	1394	375845663000000	19453	9804	10	0	0
6282	1394	377285691000000	19456	9806	3	0	0
6283	1394	377285703000000	19456	9806	4	0	0
6287	1394	378725703000000	19486	9823	3	0	0
6290	1394	378725715000000	19486	9823	4	0	0
6296	1394	380165727000000	19523	9836	4	0	0
6298	1394	381605727000000	19537	9842	3	0	0
6299	1394	381605739000000	19537	9842	4	0	0
6301	1394	383045739000000	19542	9844	3	0	0
6302	1394	383045751000000	19542	9844	4	0	0
6305	1394	384485763000000	19564	9855	4	0	0
6308	1394	385925763000000	19611	9878	7	0	0
6311	1394	385925788000000	19611	9878	8	0	0
6312	1394	387365788000000	19613	9879	7	0	0
6313	1394	387365813000000	19613	9879	8	0	0
6316	1394	388805838000000	19628	9886	8	0	0
6318	1394	390245838000000	19634	9890	3	0	0
6319	1394	390245850000000	19634	9890	4	0	0
6320	1394	391685850000000	19665	9906	9	0	0
6322	1394	393125913000000	19676	9910	18	0	0
6323	1394	393126057000000	19676	9910	19	0	0
6324	1394	394566057000000	19696	9916	9	0	0
6325	1394	394566129000000	19696	9916	10	0	0
6326	1394	396006129000000	19718	9928	3	0	0
6328	1394	397446141000000	19740	9936	3	0	0
6329	1394	397446153000000	19740	9936	4	0	0
6330	1394	398886153000000	19745	9940	12	0	0
6331	1394	398886201000000	19745	9940	13	0	0
6333	1394	400326201000000	19761	9949	6	0	0
6336	1394	401766225000000	19777	9959	3	0	0
6337	1394	401766237000000	19777	9959	4	0	0
6338	1394	403206237000000	19788	9965	4	0	0
6339	1394	403206250000000	19788	9965	5	0	0
6343	1394	404646262000000	19848	9999	4	0	0
6345	1394	406086262000000	19864	10006	3	0	0
6346	1394	406086274000000	19864	10006	4	0	0
6348	1394	407526274000000	19865	10007	4	0	0
6349	1394	407526295500000	19865	10007	5	1	0
6351	1394	408966308500000	19892	10021	5	0	0
6355	1394	410406308500000	19956	10049	11	0	0
6357	1394	410406328500000	19956	10049	12	0	0
6360	1394	411846328500000	19967	10055	6	0	0
6361	1394	411846352500000	19967	10055	7	0	0
6363	1394	413286364500000	19970	10057	4	0	0
6366	1394	414726364500000	19997	10069	5	0	0
6369	1394	414726486500000	19997	10069	6	0	0
6372	1394	416166486500000	20054	10096	4	0	0
6377	1394	417606499500000	20075	10104	3	0	0
6378	1394	417606511500000	20075	10104	4	0	0
6380	1394	417606553500000	20082	10109	6	0	0
6382	1394	419046553500000	20082	10109	8	0	0
6383	1394	419046554500000	20082	10109	9	0	0
6387	1394	420486617500000	20104	10119	10	0	0
6389	1394	421926617500000	20118	10127	7	0	0
6390	1394	421926642500000	20118	10127	8	0	0
6391	1394	423366642500000	20119	10128	3	0	0
6392	1394	423366654500000	20119	10128	4	0	0
6395	1394	426246779500000	20135	10135	10	0	\N
6398	1394	426246825500000	20135	10135	11	0	\N
6399	1394	427686790500000	20139	10137	3	0	\N
6401	1394	427686802500000	20139	10137	4	0	\N
6407	1394	432007277500000	20169	10153	9	0	\N
6408	1394	432007277500000	20187	10166	3	0	\N
6410	1394	432007289500000	20187	10166	4	0	\N
6412	1394	432007323500000	20169	10153	10	0	\N
6415	1394	434887302500000	20216	10181	7	0	\N
6418	1394	434887327500000	20216	10181	8	0	\N
6421	1394	437767338500000	20240	10191	4	0	\N
6424	1394	437767360500000	20240	10191	5	0	\N
6431	1394	442087398500000	20273	10210	7	0	\N
6432	1394	442087398500000	20280	10213	4	0	\N
6433	1394	442087411500000	20280	10213	5	0	\N
6436	1394	442087423500000	20273	10210	8	0	\N
6439	1394	444967434500000	20298	10220	3	0	\N
6441	1394	444967446500000	20298	10220	4	0	\N
6443	1394	446407446500000	20315	10232	4	0	\N
6444	1394	446407446500000	20323	10236	4	0	\N
6446	1394	446407459500000	20315	10232	5	0	\N
6447	1394	446407459500000	20323	10236	5	0	\N
6453	1394	450727508500000	20374	10265	3	0	\N
6454	1394	450727508500000	20381	10268	3	0	\N
6456	1394	450727520500000	20374	10265	4	0	\N
6457	1394	450727520500000	20381	10268	4	0	\N
6459	1394	452167520500000	20416	10286	5	0	\N
6462	1394	452167534500000	20416	10286	6	0	\N
6469	1394	456487637500000	20516	10328	11	0	\N
6470	1394	457927581500000	20462	10304	3	0	\N
6472	1394	457927593500000	20462	10304	4	0	\N
6474	1394	457927637500000	20516	10328	23	0	\N
6475	1394	457927648500000	20516	10328	24	0	\N
6476	1394	459367604500000	20560	10349	14	0	\N
6479	1394	459367717500000	20560	10349	15	0	\N
6488	1394	466567699500000	20658	10393	4	0	\N
6491	1394	466567712500000	20658	10393	5	0	\N
6492	1394	468007711500000	20676	10400	9	0	\N
6493	1394	468007711500000	20710	10415	4	0	\N
6495	1394	468007724500000	20710	10415	5	0	\N
6496	1394	468007747500000	20676	10400	10	0	\N
6498	1394	469447748500000	20748	10431	6	0	\N
6499	1394	469447748500000	20755	10434	6	0	\N
6500	1394	469447748500000	20771	10439	12	0	\N
6503	1394	469447790500000	20748	10431	7	0	\N
6504	1394	469447790500000	20755	10434	7	0	\N
6505	1394	469447931500000	20771	10439	13	0	\N
6513	1394	475207943500000	20810	10462	2	0	\N
6514	1394	475207943500000	20816	10464	2	0	\N
6516	1394	475207954500000	20810	10462	3	0	\N
6517	1394	475207954500000	20816	10464	3	0	\N
6396	1394	426246779500000	20137	10136	2	0	0
6397	1394	426246790500000	20137	10136	3	0	0
6400	1394	427686790500000	20142	10138	5	0	0
6402	1394	427687022500000	20142	10138	6	0	0
6403	1394	429127022500000	20143	10139	6	0	0
6405	1394	430567264500000	20152	10143	4	0	0
6406	1394	430567277500000	20152	10143	5	0	0
6409	1394	432007277500000	20190	10167	4	0	0
6411	1394	432007290500000	20190	10167	5	0	0
6413	1394	433447290500000	20214	10180	3	0	0
6416	1394	434887302500000	20225	10183	3	0	0
6417	1394	434887314500000	20225	10183	4	0	0
6419	1394	436327314500000	20228	10184	6	0	0
6420	1394	436327338500000	20228	10184	7	0	0
6423	1394	437767350500000	20243	10193	4	0	0
6425	1394	437767385500000	20247	10197	8	0	0
6426	1394	439207385500000	20247	10197	10	0	0
6427	1394	439207386500000	20247	10197	11	0	0
6428	1394	440647386500000	20259	10204	3	0	0
6430	1394	440647419500000	20285	10215	3	0	0
6434	1394	442087419500000	20285	10215	7	0	0
6435	1394	442087422500000	20285	10215	8	0	0
6437	1394	443527422500000	20295	10217	3	0	0
6438	1394	443527434500000	20295	10217	4	0	0
6442	1394	444967446500000	20311	10230	4	0	0
6445	1394	446407446500000	20344	10246	6	0	0
6448	1394	446407470500000	20344	10246	7	0	0
6449	1394	447847470500000	20350	10250	3	0	0
6451	1394	449287482500000	20370	10262	17	0	0
6452	1394	449287508500000	20370	10262	18	0	0
6455	1394	450727508500000	20400	10278	3	0	0
6458	1394	450727520500000	20400	10278	4	0	0
6460	1394	452167520500000	20422	10288	3	0	0
6463	1394	453607532500000	20439	10294	3	0	0
6464	1394	453607544500000	20439	10294	4	0	0
6465	1394	455047544500000	20446	10297	4	0	0
6466	1394	455047557500000	20446	10297	5	0	0
6467	1394	456487557500000	20453	10300	6	0	0
6471	1394	457927581500000	20529	10334	4	0	0
6473	1394	457927604500000	20529	10334	5	0	0
6477	1394	459367604500000	20588	10357	4	0	0
6478	1394	459367626500000	20588	10357	5	0	0
6481	1394	460807663500000	20610	10366	11	0	0
6482	1394	462247663500000	20636	10383	2	0	0
6483	1394	462247674500000	20636	10383	3	0	0
6484	1394	463687674500000	20637	10384	4	0	0
6485	1394	463687687500000	20637	10384	5	0	0
6487	1394	465127699500000	20654	10392	4	0	0
6489	1394	466567699500000	20673	10399	3	0	0
6490	1394	466567711500000	20673	10399	4	0	0
6494	1394	468007711500000	20730	10421	10	0	0
6497	1394	468007748500000	20730	10421	11	0	0
6502	1394	469447769500000	20790	10448	4	0	0
6506	1394	470887769500000	20794	10451	6	0	0
6507	1394	470887820500000	20794	10451	7	0	0
6508	1394	472327820500000	20800	10455	3	0	0
6510	1394	473767832500000	20805	10459	7	0	0
6511	1394	473767943500000	20805	10459	8	0	0
6512	1394	473767953500000	20850	10479	1	0	0
6515	1394	475207953500000	20850	10479	4	0	0
6518	1394	475207955500000	20850	10479	5	0	0
6520	1394	476648044500000	20859	10484	16	0	0
6521	1394	478088044500000	20894	10502	3	0	0
6522	1394	478088056500000	20894	10502	4	0	0
6523	1394	479528056500000	20895	10503	2	0	0
6524	1394	479528067500000	20895	10503	3	0	0
6526	1394	480968079500000	20898	10505	4	0	0
6527	1394	482408079500000	20910	10511	7	0	0
6528	1394	482408113500000	20910	10511	8	0	0
6533	1394	486728236500000	20947	10534	7	0	\N
6536	1394	486728270500000	20947	10534	8	0	\N
6548	1394	495368314500000	21108	10601	4	0	\N
6549	1394	495368314500000	21111	10602	1	0	\N
6550	1394	495368314500000	21115	10604	2	0	\N
6551	1394	495368314500000	21127	10611	2	0	\N
6552	1394	495368314500000	21148	10620	2	0	\N
6553	1394	495368314500000	21149	10621	6	0	\N
6555	1394	495368324500000	21111	10602	2	0	\N
6556	1394	495368325500000	21115	10604	3	0	\N
6557	1394	495368325500000	21127	10611	3	0	\N
6558	1394	495368325500000	21148	10620	3	0	\N
6560	1394	495368336500000	21108	10601	5	0	\N
6561	1394	495368347500000	21149	10621	7	0	\N
6564	1394	498248336500000	21165	10630	2	0	\N
6565	1394	498248336500000	21173	10633	2	0	\N
6566	1394	498248336500000	21182	10637	2	0	\N
6568	1394	498248347500000	21165	10630	3	0	\N
6569	1394	498248347500000	21173	10633	3	0	\N
6570	1394	498248347500000	21182	10637	3	0	\N
6572	1394	499688369500000	21190	10640	8	0	\N
6575	1394	499688413500000	21190	10640	9	0	\N
6576	1394	501128380500000	21202	10646	6	0	\N
6579	1394	501128413500000	21202	10646	7	0	\N
6588	1394	508328467500000	21233	10663	2	0	\N
6590	1394	508328478500000	21233	10663	3	0	\N
6592	1394	509768478500000	21252	10671	8	0	\N
6593	1394	509768478500000	21254	10672	1	0	\N
6595	1394	509768488500000	21254	10672	2	0	\N
6597	1394	509768540500000	21252	10671	9	0	\N
6602	1394	512648558500000	21366	10722	4	0	\N
6603	1394	512648559500000	21283	10685	5	0	\N
6604	1394	514088536500000	21298	10694	3	0	\N
6606	1394	514088548500000	21298	10694	4	0	\N
6608	1394	514088558500000	21366	10722	7	0	\N
6609	1394	514088559500000	21283	10685	7	0	\N
6610	1394	514088560500000	21283	10685	8	0	\N
6611	1394	514088560500000	21366	10722	8	0	\N
6612	1394	515528549500000	21410	10738	3	0	\N
6615	1394	515528590500000	21410	10738	4	0	\N
6620	1394	519848624500000	21483	10772	4	0	\N
6622	1394	519848637500000	21483	10772	5	0	\N
6628	1394	524168693500000	21502	10784	2	0	\N
6630	1394	524168704500000	21502	10784	3	0	\N
6632	1394	525608705500000	21535	10801	3	0	\N
6635	1394	525608717500000	21535	10801	4	0	\N
6636	1394	527048708500000	21569	10814	3	0	\N
6639	1394	527048720500000	21569	10814	4	0	\N
6640	1394	528488718500000	21621	10834	4	0	\N
6643	1394	528488740500000	21621	10834	5	0	\N
6644	1394	529928729500000	21631	10838	3	0	\N
6647	1394	529928750500000	21631	10838	4	0	\N
6648	1394	531368741500000	21709	10875	5	0	\N
6651	1394	531368764500000	21709	10875	6	0	\N
6657	1394	537128789500000	21789	10909	8	0	\N
6658	1394	537128789500000	21791	10910	7	0	\N
6659	1394	537128789500000	21804	10914	6	0	\N
6661	1394	537128805500000	21791	10910	8	0	\N
6662	1394	537128813500000	21804	10914	7	0	\N
6664	1394	537128815500000	21789	10909	9	0	\N
6531	1394	485288125500000	20938	10527	3	0	0
6532	1394	485288236500000	20938	10527	4	0	0
6534	1394	486728236500000	20979	10552	2	0	0
6535	1394	486728247500000	20979	10552	3	0	0
6537	1394	488168247500000	21039	10573	1	0	0
6539	1394	489608257500000	21044	10576	2	0	0
6540	1394	489608268500000	21044	10576	3	0	0
6541	1394	491048268500000	21072	10587	3	0	0
6542	1394	491048280500000	21072	10587	4	0	0
6543	1394	491048302500000	21083	10593	4	0	0
6545	1394	492488303500000	21083	10593	7	0	0
6546	1394	493928303500000	21103	10599	2	0	0
6547	1394	493928314500000	21103	10599	3	0	0
6554	1394	495368314500000	21154	10624	2	0	0
6562	1394	496808325500000	21163	10629	2	0	0
6563	1394	496808336500000	21163	10629	3	0	0
6567	1394	498248336500000	21184	10638	6	0	0
6571	1394	498248369500000	21184	10638	7	0	0
6573	1394	499688369500000	21194	10642	2	0	0
6577	1394	501128380500000	21216	10653	2	0	0
6578	1394	501128391500000	21216	10653	3	0	0
6580	1394	502568391500000	21221	10655	6	0	0
6581	1394	502568424500000	21221	10655	7	0	0
6582	1394	504008424500000	21225	10658	2	0	0
6584	1394	505448435500000	21230	10661	1	0	0
6585	1394	505448445500000	21230	10661	2	0	0
6586	1394	506888445500000	21231	10662	4	0	0
6587	1394	506888467500000	21231	10662	5	0	0
6591	1394	508328478500000	21247	10669	3	0	0
6594	1394	509768478500000	21258	10675	2	0	0
6596	1394	509768489500000	21258	10675	3	0	0
6598	1394	511208489500000	21259	10676	2	0	0
6599	1394	511208500500000	21259	10676	3	0	0
6601	1394	512648536500000	21271	10681	10	0	0
6605	1394	514088536500000	21394	10733	4	0	0
6607	1394	514088549500000	21394	10733	5	0	0
6613	1394	515528549500000	21426	10745	4	0	0
6614	1394	515528562500000	21426	10745	5	0	0
6617	1394	516968599500000	21429	10747	11	0	0
6618	1394	518408599500000	21458	10766	7	0	0
6619	1394	518408624500000	21458	10766	8	0	0
6621	1394	519848624500000	21485	10774	7	0	0
6624	1394	521288649500000	21486	10775	3	0	0
6625	1394	521288661500000	21486	10775	4	0	0
6626	1394	522728661500000	21497	10781	5	0	0
6627	1394	522728693500000	21497	10781	6	0	0
6629	1394	524168693500000	21509	10789	3	0	0
6633	1394	525608705500000	21550	10806	3	0	0
6634	1394	525608708500000	21550	10806	4	0	0
6637	1394	527048708500000	21608	10829	1	0	0
6638	1394	527048718500000	21608	10829	2	0	0
6641	1394	528488718500000	21627	10835	2	0	0
6645	1394	529928729500000	21702	10870	3	0	0
6646	1394	529928741500000	21702	10870	4	0	0
6649	1394	531368741500000	21722	10882	3	0	0
6650	1394	531368753500000	21722	10882	4	0	0
6653	1394	534248753500000	21738	10887	6	0	0
6654	1394	534248777500000	21738	10887	7	0	0
6655	1394	535688777500000	21774	10902	3	0	0
6656	1394	535688789500000	21774	10902	4	0	0
6660	1394	537128789500000	21816	10919	6	0	0
6667	1394	540008849500000	21857	10938	3	0	\N
6669	1394	540008861500000	21857	10938	4	0	\N
6671	1394	541448861500000	21893	10955	3	0	\N
6672	1394	541448861500000	21896	10957	3	0	\N
6673	1394	541448861500000	21925	10972	3	0	\N
6674	1394	541448861500000	21932	10974	2	0	\N
6675	1394	541448861500000	21942	10976	3	0	\N
6677	1394	541448872500000	21932	10974	3	0	\N
6678	1394	541448873500000	21893	10955	4	0	\N
6679	1394	541448873500000	21896	10957	4	0	\N
6680	1394	541448873500000	21925	10972	4	0	\N
6681	1394	541448873500000	21942	10976	4	0	\N
6685	1394	544328921500000	21955	10985	9	0	\N
6686	1394	544328921500000	21992	10996	3	0	\N
6688	1394	544328933500000	21992	10996	4	0	\N
6690	1394	544328957500000	21955	10985	10	0	\N
6693	1394	547208957500000	22001	11001	3	0	\N
6695	1394	547208969500000	22001	11001	4	0	\N
6699	1394	550088982500000	22030	11015	7	0	\N
6700	1394	550088982500000	22032	11016	2	0	\N
6702	1394	550088993500000	22032	11016	3	0	\N
6704	1394	550089025500000	22030	11015	8	0	\N
6707	1394	552969004500000	22072	11037	6	0	\N
6710	1394	552969046500000	22072	11037	7	0	\N
6722	1394	563049076500000	22167	11088	5	0	\N
6725	1394	563049289500000	22167	11088	6	0	\N
6734	1394	570249140500000	22274	11149	3	0	\N
6736	1394	570249152500000	22274	11149	4	0	\N
6744	1394	574569200500000	22290	11157	3	0	\N
6746	1394	576009200500000	22290	11157	8	0	\N
6747	1394	576009204500000	22290	11157	9	0	\N
6749	1394	577449204500000	22298	11161	3	0	\N
6750	1394	577449204500000	22300	11163	3	0	\N
6752	1394	577449216500000	22298	11161	4	0	\N
6753	1394	577449216500000	22300	11163	4	0	\N
6761	1394	583209255500000	22355	11190	3	0	\N
6763	1394	583209267500000	22355	11190	4	0	\N
6767	1394	586089304500000	22419	11222	2	0	\N
6769	1394	586089315500000	22419	11222	3	0	\N
6777	1394	591849420500000	22481	11248	8	0	\N
6779	1394	591849482500000	22481	11248	9	0	\N
6781	1394	593289493500000	22491	11253	8	0	\N
6784	1394	593289528500000	22491	11253	9	0	\N
6794	1394	600489732500000	22539	11277	3	0	\N
6795	1394	600489732500000	22548	11280	13	0	\N
6797	1394	600489744500000	22539	11277	4	0	\N
6799	1394	600489781500000	22548	11280	14	0	\N
6668	1394	540008849500000	21876	10946	3	0	0
6670	1394	540008861500000	21876	10946	4	0	0
6676	1394	541448861500000	21950	10981	9	0	0
6682	1394	541448897500000	21950	10981	10	0	0
6683	1394	542888897500000	21953	10983	6	0	0
6687	1394	544328921500000	21994	10997	6	0	0
6689	1394	544328945500000	21994	10997	7	0	0
6691	1394	545768945500000	21997	11000	3	0	0
6692	1394	545768957500000	21997	11000	4	0	0
6694	1394	547208957500000	22013	11007	3	0	0
6697	1394	548648969500000	22016	11009	4	0	0
6698	1394	548648982500000	22016	11009	5	0	0
6701	1394	550088982500000	22039	11020	2	0	0
6703	1394	550088993500000	22039	11020	3	0	0
6706	1394	551529004500000	22043	11023	3	0	0
6708	1394	552969004500000	22088	11043	3	0	0
6709	1394	552969016500000	22088	11043	4	0	0
6711	1394	554409016500000	22095	11047	3	0	0
6712	1394	554409028500000	22095	11047	4	0	0
6714	1394	555849040500000	22124	11065	4	0	0
6715	1394	557289040500000	22146	11077	4	0	0
6716	1394	557289053500000	22146	11077	5	0	0
6717	1394	558729053500000	22149	11080	3	0	0
6718	1394	558729065500000	22149	11080	4	0	0
6720	1394	561609065500000	22158	11084	2	0	0
6721	1394	561609076500000	22158	11084	3	0	0
6723	1394	563049076500000	22187	11103	5	0	0
6724	1394	563049090500000	22187	11103	6	0	0
6727	1394	564489103500000	22194	11109	5	0	0
6728	1394	565929103500000	22247	11134	4	0	0
6729	1394	565929116500000	22247	11134	5	0	0
6730	1394	567369116500000	22269	11145	3	0	0
6731	1394	567369128500000	22269	11145	4	0	0
6733	1394	568809140500000	22271	11147	4	0	0
6735	1394	570249140500000	22278	11152	3	0	0
6737	1394	570249152500000	22278	11152	4	0	0
6738	1394	571689152500000	22280	11153	2	0	0
6739	1394	571689154500000	22280	11153	3	0	0
6741	1394	573129167500000	22282	11154	5	0	0
6742	1394	574569167500000	22287	11156	3	0	0
6743	1394	574569179500000	22287	11156	4	0	0
6745	1394	576009179500000	22293	11159	7	0	0
6751	1394	577449204500000	22310	11167	4	0	0
6754	1394	577449217500000	22310	11167	5	0	0
6755	1394	578889217500000	22311	11168	3	0	0
6756	1394	578889229500000	22311	11168	4	0	0
6757	1394	580329229500000	22339	11182	4	0	0
6759	1394	581769242500000	22353	11189	4	0	0
6760	1394	581769255500000	22353	11189	5	0	0
6762	1394	583209255500000	22410	11217	3	0	0
6764	1394	583209267500000	22410	11217	4	0	0
6765	1394	584649267500000	22412	11218	10	0	0
6768	1394	586089304500000	22428	11225	3	0	0
6770	1394	586089316500000	22428	11225	4	0	0
6771	1394	587529316500000	22465	11242	4	0	0
6772	1394	587529329500000	22465	11242	5	0	0
6774	1394	588969378500000	22474	11245	14	0	0
6775	1394	590409378500000	22475	11246	6	0	0
6776	1394	590409420500000	22475	11246	7	0	0
6778	1394	591849420500000	22485	11250	10	0	0
6780	1394	591849493500000	22485	11250	11	0	0
6783	1394	593289506500000	22515	11262	5	0	0
6785	1394	594729506500000	22520	11265	9	0	0
6786	1394	594729578500000	22520	11265	10	0	0
6787	1394	596169578500000	22521	11266	13	0	0
6788	1394	596169681500000	22521	11266	14	0	0
6790	1394	597609708500000	22529	11271	10	0	0
6791	1394	597609729500000	22532	11272	3	0	0
6792	1394	599049729500000	22532	11272	7	0	0
6793	1394	599049732500000	22532	11272	8	0	0
6798	1394	600489744500000	22559	11286	4	0	0
6800	1394	601929744500000	22598	11306	15	0	0
6804	1394	604809819500000	22654	11327	3	0	\N
6806	1394	604809831500000	22654	11327	4	0	\N
6808	1394	606249864500000	22698	11349	4	0	\N
6809	1394	606249864500000	22705	11351	7	0	\N
6810	1394	606249864500000	22709	11353	5	0	\N
6811	1394	606249864500000	22718	11358	2	0	\N
6813	1394	606249875500000	22718	11358	3	0	\N
6815	1394	606249877500000	22698	11349	5	0	\N
6816	1394	606249887500000	22709	11353	6	0	\N
6817	1394	606249898500000	22705	11351	8	0	\N
6826	1394	613449950500000	22773	11388	21	0	\N
6830	1394	613450025500000	22773	11388	22	0	\N
6831	1394	614889962500000	22781	11393	4	0	\N
6833	1394	614889975500000	22781	11393	5	0	\N
6841	1394	620650040500000	22849	11426	3	0	\N
6842	1394	620650040500000	22859	11428	5	0	\N
6844	1394	620650052500000	22849	11426	4	0	\N
6846	1394	620650063500000	22859	11428	6	0	\N
6847	1394	622090052500000	22877	11436	4	0	\N
6848	1394	622090052500000	22887	11442	4	0	\N
6849	1394	622090052500000	22912	11452	3	0	\N
6851	1394	622090064500000	22912	11452	4	0	\N
6853	1394	622090065500000	22877	11436	5	0	\N
6854	1394	622090065500000	22887	11442	5	0	\N
6855	1394	623530064500000	22937	11461	4	0	\N
6856	1394	623530064500000	22944	11465	16	0	\N
6857	1394	623530064500000	22947	11466	3	0	\N
6859	1394	623530076500000	22947	11466	4	0	\N
6860	1394	623530077500000	22937	11461	5	0	\N
6862	1394	623530125500000	22944	11465	17	0	\N
6863	1394	624970090500000	22962	11472	3	0	\N
6865	1394	624970102500000	22962	11472	4	0	\N
6867	1394	626410114500000	22982	11479	8	0	\N
6870	1394	626410149500000	22982	11479	9	0	\N
6871	1394	627850127500000	23001	11490	3	0	\N
6873	1394	627850139500000	23001	11490	4	0	\N
6876	1394	630730139500000	23039	11503	7	0	\N
6879	1394	630730164500000	23039	11503	8	0	\N
6883	1394	633610165500000	23061	11515	6	0	\N
6884	1394	633610165500000	23074	11520	3	0	\N
6886	1394	633610177500000	23074	11520	4	0	\N
6888	1394	633610189500000	23061	11515	7	0	\N
6891	1394	636490189500000	23140	11555	7	0	\N
6893	1394	636490214500000	23140	11555	8	0	\N
6895	1394	636490263500000	23182	11574	4	0	\N
6896	1394	637930223500000	23172	11569	3	0	\N
6899	1394	637930235500000	23172	11569	4	0	\N
6900	1394	637930263500000	23182	11574	13	0	\N
6901	1394	637930280500000	23182	11574	14	0	\N
6902	1394	639370234500000	23194	11579	3	0	\N
6903	1394	639370234500000	23202	11584	4	0	\N
6904	1394	639370234500000	23213	11586	2	0	\N
6905	1394	639370234500000	23217	11588	2	0	\N
6908	1394	639370245500000	23213	11586	3	0	\N
6909	1394	639370245500000	23217	11588	3	0	\N
6910	1394	639370246500000	23194	11579	4	0	\N
6911	1394	639370256500000	23202	11584	5	0	\N
6914	1394	642250246500000	23238	11596	2	0	\N
6915	1394	642250246500000	23241	11598	2	0	\N
6917	1394	642250257500000	23238	11596	3	0	\N
6918	1394	642250257500000	23241	11598	3	0	\N
6922	1394	645130269500000	23268	11609	2	0	\N
6925	1394	645130280500000	23268	11609	3	0	\N
6936	1394	653770367500000	23369	11662	4	0	\N
6803	1394	603369819500000	22603	11308	7	0	0
6805	1394	604809819500000	22696	11348	9	0	0
6807	1394	604809864500000	22696	11348	10	0	0
6812	1394	606249864500000	22729	11363	2	0	0
6814	1394	606249875500000	22729	11363	3	0	0
6819	1394	607689888500000	22740	11370	5	0	0
6820	1394	609129888500000	22755	11377	10	0	0
6821	1394	609129925500000	22755	11377	11	0	0
6822	1394	610569925500000	22766	11383	3	0	0
6823	1394	610569937500000	22766	11383	4	0	0
6825	1394	612009950500000	22770	11386	5	0	0
6827	1394	613449950500000	22778	11391	3	0	0
6828	1394	613449962500000	22778	11391	4	0	0
6829	1394	613449972500000	22791	11399	1	0	0
6834	1394	614889991500000	22791	11399	13	0	0
6835	1394	616329991500000	22808	11406	3	0	0
6836	1394	616330003500000	22808	11406	4	0	0
6837	1394	617770003500000	22818	11410	5	0	0
6838	1394	617770017500000	22818	11410	6	0	0
6840	1394	619210040500000	22846	11424	6	0	0
6843	1394	620650040500000	22871	11432	3	0	0
6845	1394	620650052500000	22871	11432	4	0	0
6850	1394	622090052500000	22927	11459	3	0	0
6852	1394	622090064500000	22927	11459	4	0	0
6861	1394	623530090500000	22951	11467	9	0	0
6864	1394	624970090500000	22968	11474	6	0	0
6866	1394	624970114500000	22968	11474	7	0	0
6868	1394	626410114500000	22994	11486	4	0	0
6872	1394	627850127500000	23016	11496	0	0	0
6874	1394	629290127500000	23022	11498	3	0	0
6875	1394	629290139500000	23022	11498	4	0	0
6877	1394	630730139500000	23045	11506	4	0	0
6878	1394	630730152500000	23045	11506	5	0	0
6881	1394	632170164500000	23058	11514	5	0	0
6882	1394	632170165500000	23058	11514	6	0	0
6885	1394	633610165500000	23103	11538	3	0	0
6887	1394	633610177500000	23103	11538	4	0	0
6889	1394	635050177500000	23112	11543	3	0	0
6892	1394	636490189500000	23159	11564	7	0	0
6894	1394	636490223500000	23159	11564	8	0	0
6897	1394	637930223500000	23190	11578	2	0	0
6898	1394	637930234500000	23190	11578	3	0	0
6907	1394	639370235500000	23234	11594	2	0	0
6912	1394	640810235500000	23236	11595	2	0	0
6913	1394	640810246500000	23236	11595	3	0	0
6916	1394	642250246500000	23253	11602	2	0	0
6919	1394	642250257500000	23253	11602	3	0	0
6921	1394	643690269500000	23263	11608	4	0	0
6923	1394	645130269500000	23278	11614	1	0	0
6924	1394	645130279500000	23278	11614	2	0	0
6926	1394	646570279500000	23295	11623	4	0	0
6927	1394	646570301500000	23295	11623	5	0	0
6929	1394	648010312500000	23310	11632	3	0	0
6930	1394	649450312500000	23331	11642	2	0	0
6931	1394	649450323500000	23331	11642	3	0	0
6932	1394	650890323500000	23352	11652	4	0	0
6934	1394	652330345500000	23365	11660	4	0	0
6935	1394	652330367500000	23365	11660	5	0	0
6939	1394	653770389500000	23369	11662	5	0	\N
6940	1394	655210378500000	23382	11667	2	0	\N
6941	1394	655210378500000	23399	11672	2	0	\N
6942	1394	655210378500000	23434	11690	2	0	\N
6943	1394	655210378500000	23441	11691	2	0	\N
6944	1394	655210378500000	23448	11692	2	0	\N
6946	1394	655210389500000	23382	11667	3	0	\N
6947	1394	655210389500000	23399	11672	3	0	\N
6948	1394	655210389500000	23434	11690	3	0	\N
6949	1394	655210389500000	23441	11691	3	0	\N
6950	1394	655210389500000	23448	11692	3	0	\N
6956	1394	659530426500000	23497	11714	4	0	\N
6957	1394	659530426500000	23505	11717	3	0	\N
6959	1394	659530438500000	23505	11717	4	0	\N
6960	1394	659530439500000	23497	11714	5	0	\N
6964	1394	662410455500000	23532	11730	4	0	\N
6967	1394	662410468500000	23532	11730	5	0	\N
6974	1394	668170519500000	23594	11756	6	0	\N
6975	1394	668170519500000	23603	11760	3	0	\N
6976	1394	668170519500000	23609	11761	3	0	\N
6977	1394	668170519500000	23613	11763	10	0	\N
6979	1394	668170531500000	23603	11760	4	0	\N
6980	1394	668170531500000	23609	11761	4	0	\N
6981	1394	668170543500000	23594	11756	7	0	\N
6983	1394	668170556500000	23613	11763	11	0	\N
6986	1394	671050571500000	23629	11771	3	0	\N
6987	1394	671050571500000	23639	11776	9	0	\N
6988	1394	671050571500000	23644	11778	7	0	\N
6989	1394	671050571500000	23646	11779	3	0	\N
6990	1394	671050571500000	23649	11781	4	0	\N
6992	1394	671050583500000	23629	11771	4	0	\N
6993	1394	671050583500000	23646	11779	4	0	\N
6994	1394	671050584500000	23649	11781	5	0	\N
6995	1394	671050596500000	23644	11778	8	0	\N
6997	1394	671050598500000	23639	11776	10	0	\N
6999	1394	672490596500000	23874	11800	0	0	\N
7001	1394	673930622500000	23723	11814	6	0	\N
7004	1394	673930646500000	23723	11814	7	0	\N
7005	1394	675370634500000	23735	11823	5	0	\N
7006	1394	675370634500000	23750	11829	1	0	\N
7008	1394	675370635500000	23750	11829	2	0	\N
7010	1394	675370648500000	23735	11823	6	0	\N
7012	1394	676810648500000	23741	11824	4	0	\N
7013	1394	676810661500000	23741	11824	5	0	\N
7015	1394	678250671500000	23812	11853	3	0	\N
7016	1394	678250671500000	23844	11869	3	0	\N
7018	1394	678250683500000	23812	11853	4	0	\N
7019	1394	678250683500000	23844	11869	4	0	\N
7020	1394	679690671500000	23929	11909	4	0	\N
7022	1394	679690702500000	23929	11909	5	0	\N
7026	1394	682570804500000	24000	11944	3	0	\N
7027	1394	682570804500000	24004	11945	5	0	\N
7028	1394	682570804500000	24007	11947	2	0	\N
7030	1394	682570815500000	24007	11947	3	0	\N
7031	1394	682570816500000	24000	11944	4	0	\N
7032	1394	682570818500000	24004	11945	6	0	\N
7038	1394	686890923500000	24038	11962	2	0	\N
7040	1394	686890934500000	24038	11962	3	0	\N
7042	1394	688330936500000	24050	11969	4	0	\N
7043	1394	688330936500000	24058	11973	2	0	\N
7045	1394	688330947500000	24058	11973	3	0	\N
7047	1394	688330958500000	24050	11969	5	0	\N
7048	1394	689770947500000	24074	11983	2	0	\N
7050	1394	689770958500000	24074	11983	3	0	\N
7056	1394	694090991500000	24159	12025	2	0	\N
7058	1394	694091002500000	24159	12025	3	0	\N
7064	1394	698411061500000	24226	12057	4	0	\N
7065	1394	698411061500000	24231	12058	3	0	\N
7066	1394	698411061500000	24241	12063	3	0	\N
7067	1394	698411061500000	24253	12068	8	0	\N
7069	1394	698411073500000	24231	12058	4	0	\N
7070	1394	698411073500000	24241	12063	4	0	\N
7071	1394	698411074500000	24226	12057	5	0	\N
7072	1394	698411123500000	24253	12068	9	0	\N
6945	1394	655210378500000	23468	11701	3	0	0
6951	1394	655210390500000	23468	11701	4	0	0
6952	1394	656650390500000	23469	11702	3	0	0
6953	1394	656650402500000	23469	11702	4	0	0
6954	1394	658090402500000	23484	11710	6	0	0
6958	1394	659530426500000	23520	11723	8	0	0
6961	1394	659530443500000	23520	11723	9	0	0
6962	1394	660970443500000	23524	11725	3	0	0
6963	1394	660970455500000	23524	11725	4	0	0
6965	1394	662410455500000	23541	11734	3	0	0
6968	1394	663850467500000	23544	11736	3	0	0
6969	1394	663850479500000	23544	11736	4	0	0
6970	1394	665290479500000	23552	11739	7	0	0
6971	1394	665290504500000	23552	11739	8	0	0
6973	1394	666730519500000	23558	11741	7	0	0
6978	1394	668170519500000	23625	11769	9	0	0
6982	1394	668170546500000	23625	11769	10	0	0
6984	1394	669610546500000	23627	11770	7	0	0
6985	1394	669610571500000	23627	11770	8	0	0
6996	1394	671050596500000	23687	11796	8	0	0
6998	1394	672490596500000	23718	11812	8	0	0
7000	1394	672490622500000	23718	11812	9	0	0
7002	1394	673930622500000	23729	11819	3	0	0
7003	1394	673930634500000	23729	11819	4	0	0
7009	1394	675370646500000	23778	11840	4	0	0
7011	1394	676810646500000	23801	11847	7	0	0
7014	1394	676810671500000	23801	11847	8	0	0
7017	1394	678250671500000	23878	11884	0	0	0
7023	1394	679690792500000	23968	11927	14	0	0
7024	1394	681130792500000	23994	11941	3	0	0
7025	1394	681130804500000	23994	11941	4	0	0
7029	1394	682570804500000	24010	11948	6	0	0
7033	1394	682570828500000	24010	11948	7	0	0
7035	1394	684010840500000	24022	11954	4	0	0
7036	1394	685450839500000	24027	11957	12	0	0
7037	1394	685450923500000	24027	11957	13	0	0
7039	1394	686890923500000	24043	11964	4	0	0
7041	1394	686890936500000	24043	11964	5	0	0
7046	1394	688330947500000	24061	11975	3	0	0
7049	1394	689770947500000	24083	11988	4	0	0
7051	1394	689770969500000	24083	11988	5	0	0
7052	1394	691210969500000	24092	11993	2	0	0
7054	1394	692650980500000	24134	12014	2	0	0
7055	1394	692650991500000	24134	12014	3	0	0
7057	1394	694090991500000	24178	12035	7	0	0
7059	1394	694091025500000	24178	12035	8	0	0
7060	1394	695531025500000	24197	12044	6	0	0
7062	1394	696971049500000	24224	12056	3	0	0
7063	1394	696971061500000	24224	12056	4	0	0
7068	1394	698411061500000	24256	12069	0	0	0
7073	1394	699851061500000	24276	12078	4	0	\N
7076	1394	699851074500000	24276	12078	5	0	\N
7077	1394	701291073500000	24292	12082	3	0	\N
7079	1394	701291085500000	24292	12082	4	0	\N
7081	1394	702731085500000	24312	12090	9	0	\N
7085	1394	702731121500000	24312	12090	10	0	\N
7090	1394	707051121500000	24344	12107	3	0	\N
7093	1394	707051133500000	24344	12107	4	0	\N
7094	1394	708491132500000	24375	12123	3	0	\N
7097	1394	708491243500000	24375	12123	4	0	\N
7100	1394	711371168500000	24422	12146	7	0	\N
7103	1394	711371202500000	24422	12146	8	0	\N
7106	1394	714251190500000	24504	12188	2	0	\N
7108	1394	714251201500000	24504	12188	3	0	\N
7118	1394	721451280500000	24568	12213	4	0	\N
7120	1394	721451280500000	25205	12213	0	0	\N
7122	1394	721451302500000	24568	12213	5	0	\N
7129	1394	727211347500000	24609	12232	3	0	\N
7130	1394	727211347500000	24630	12239	3	0	\N
7132	1394	727211359500000	24609	12232	4	0	\N
7133	1394	727211359500000	24630	12239	4	0	\N
7135	1394	728651459500000	24649	12244	4	0	\N
7136	1394	728651459500000	24659	12248	3	0	\N
7137	1394	728651459500000	24661	12250	4	0	\N
7138	1394	728651459500000	24671	12253	4	0	\N
7140	1394	728651471500000	24659	12248	4	0	\N
7141	1394	728651472500000	24649	12244	5	0	\N
7142	1394	728651472500000	24661	12250	5	0	\N
7143	1394	728651472500000	24671	12253	5	0	\N
7145	1394	730091472500000	24692	12265	6	0	\N
7147	1394	730091496500000	24692	12265	7	0	\N
7157	1394	735851972500000	24764	12296	4	0	\N
7158	1394	737291950500000	24776	12302	4	0	\N
7160	1394	737291963500000	24776	12302	5	0	\N
7161	1394	737291972500000	24764	12296	8	0	\N
7163	1394	737291975500000	24764	12296	9	0	\N
7166	1394	740171997500000	24821	12325	13	0	\N
7169	1394	740172047500000	24821	12325	14	0	\N
7171	1394	741612032500000	24833	12329	3	0	\N
7172	1394	741612044500000	24833	12329	4	0	\N
7177	1394	744492094500000	24848	12336	4	0	\N
7179	1394	744492107500000	24848	12336	5	0	\N
7185	1394	748812156500000	24882	12354	3	0	\N
7187	1394	748812168500000	24882	12354	4	0	\N
7189	1394	750252168500000	24887	12357	3	0	\N
7191	1394	750252180500000	24887	12357	4	0	\N
7202	1394	757452285440200	25013	12411	2	0	\N
7205	1394	757452296440200	25013	12411	3	0	\N
7078	1394	701291073500000	24309	12088	3	0	0
7080	1394	701291085500000	24309	12088	4	0	0
7082	1394	702731085500000	24337	12102	3	0	0
7083	1394	702731097500000	24337	12102	4	0	0
7084	1394	702731107500000	24339	12103	1	0	0
7087	1394	704171109500000	24339	12103	5	0	0
7088	1394	705611109500000	24343	12106	3	0	0
7089	1394	705611121500000	24343	12106	4	0	0
7091	1394	707051121500000	24368	12119	2	0	0
7092	1394	707051132500000	24368	12119	3	0	0
7096	1394	708491147500000	24407	12137	7	0	0
7098	1394	709931147500000	24411	12140	3	0	0
7099	1394	709931168500000	24411	12140	4	0	0
7101	1394	711371168500000	24441	12156	2	0	0
7104	1394	712811179500000	24471	12169	2	0	0
7105	1394	712811190500000	24471	12169	3	0	0
7107	1394	714251190500000	24512	12191	5	0	0
7109	1394	714251213500000	24512	12191	6	0	0
7110	1394	715691213500000	24529	12194	5	0	0
7112	1394	717131236500000	24541	12202	4	0	0
7113	1394	717131258500000	24541	12202	5	0	0
7114	1394	718571258500000	24548	12204	2	0	0
7115	1394	718571269500000	24548	12204	3	0	0
7116	1394	720011269500000	24562	12210	2	0	0
7119	1394	721451280500000	24579	12219	2	0	0
7121	1394	721451291500000	24579	12219	3	0	0
7123	1394	722891291500000	24581	12221	5	0	0
7124	1394	722891314500000	24581	12221	6	0	0
7126	1394	724331326500000	24601	12228	4	0	0
7127	1394	725771326500000	24602	12229	3	0	0
7128	1394	725771347500000	24602	12229	4	0	0
7131	1394	727211347500000	24645	12243	4	0	0
7134	1394	727211459500000	24645	12243	5	0	0
7144	1394	728651472500000	24691	12264	5	0	0
7146	1394	730091472500000	24701	12268	7	0	0
7148	1394	730091524500000	24701	12268	8	0	0
7149	1394	731531524500000	24703	12269	27	0	0
7150	1394	731531731500000	24703	12269	28	0	0
7152	1394	732971856500000	24726	12279	18	0	0
7153	1394	734411856500000	24727	12280	6	0	0
7154	1394	734411898500000	24727	12280	7	0	0
7155	1394	735851898500000	24739	12285	7	0	0
7159	1394	737291950500000	24779	12303	6	0	0
7162	1394	737291974500000	24779	12303	7	0	0
7164	1394	738731974500000	24818	12323	5	0	0
7165	1394	738731997500000	24818	12323	6	0	0
7167	1394	740171997500000	24827	12327	8	0	0
7170	1394	740172068500000	24837	12332	9	0	0
7173	1394	741612068500000	24837	12332	11	0	0
7174	1394	741612069500000	24837	12332	12	0	0
7175	1394	743052069500000	24839	12333	7	0	0
7176	1394	743052094500000	24839	12333	8	0	0
7180	1394	744492119500000	24850	12338	8	0	0
7181	1394	745932119500000	24851	12339	7	0	0
7182	1394	745932144500000	24851	12339	8	0	0
7183	1394	747372144500000	24875	12351	3	0	0
7186	1394	748812156500000	24886	12356	3	0	0
7188	1394	748812168500000	24886	12356	4	0	0
7190	1394	750252168500000	24892	12359	9	0	0
7192	1394	750252204500000	24892	12359	10	0	0
7193	1394	751692204500000	24898	12363	6	0	0
7195	1394	753132228500000	24925	12375	7	0	0
7196	1394	753132262500000	24925	12375	8	0	0
7197	1394	753132272500000	24967	12391	1	0	0
7198	1394	754572272499900	24967	12391	4	0	0
7199	1394	754572273440200	24967	12391	6	0	0
7201	1394	756012285440200	24978	12396	4	0	0
7203	1394	757452285440200	25025	12415	1	0	0
7204	1394	757452295440200	25025	12415	2	0	0
7206	1394	758892295440200	25029	12418	5	0	0
7208	1394	760332318440200	25037	12422	2	0	0
7212	1394	763212341440200	25072	12445	7	0	\N
7215	1394	763212375440200	25072	12445	8	0	\N
7216	1394	764652353440200	25117	12464	6	0	\N
7217	1394	764652353440200	25121	12465	3	0	\N
7219	1394	764652365440200	25121	12465	4	0	\N
7221	1394	764652377440200	25117	12464	7	0	\N
7246	1394	783372453440200	25325	12561	10	0	\N
7247	1394	783372453440200	25335	12565	8	0	\N
7249	1394	783372490440200	25325	12561	11	0	\N
7251	1394	783372578440200	25335	12565	9	0	\N
7256	1394	787692638440200	25367	12577	4	0	\N
7259	1394	787692651440200	25367	12577	5	0	\N
7264	1394	792012799440200	25436	12603	3	0	\N
7265	1394	792012799440200	25443	12605	3	0	\N
7266	1394	792012799440200	25452	12609	3	0	\N
7268	1394	792012811440200	25436	12603	4	0	\N
7269	1394	792012811440200	25443	12605	4	0	\N
7270	1394	792012811440200	25452	12609	4	0	\N
7272	1394	793452911440200	25485	12622	3	0	\N
7274	1394	793452923440200	25485	12622	4	0	\N
7280	1394	797772947440200	25535	12642	3	0	\N
7282	1394	797772959440200	25535	12642	4	0	\N
7286	1394	800652971440200	25616	12677	3	0	\N
7287	1394	800652971440200	25624	12681	10	0	\N
7289	1394	800652983440200	25616	12677	4	0	\N
7291	1394	800653017440200	25624	12681	11	0	\N
7294	1394	803532995440200	25667	12703	3	0	\N
7295	1394	803532995440200	25685	12709	6	0	\N
7296	1394	803532995440200	25727	12729	3	0	\N
7298	1394	803533007440200	25667	12703	4	0	\N
7299	1394	803533007440200	25727	12729	4	0	\N
7300	1394	803533019440200	25685	12709	7	0	\N
7306	1394	807853042440200	25823	12769	9	0	\N
7309	1394	807853078440200	25823	12769	10	0	\N
7310	1394	809293067440200	25833	12774	4	0	\N
7311	1394	809293067440200	25869	12788	3	0	\N
7312	1394	809293067440200	25876	12789	6	0	\N
7313	1394	809293067440200	25878	12790	6	0	\N
7316	1394	809293079440200	25869	12788	4	0	\N
7317	1394	809293080440200	25833	12774	5	0	\N
7319	1394	809293091440200	25876	12789	7	0	\N
7320	1394	809293100440200	25878	12790	7	0	\N
7321	1394	810733078440200	25888	12795	4	0	\N
7322	1394	810733078440200	25890	12796	2	0	\N
7323	1394	810733089440200	25890	12796	3	0	\N
7325	1394	810733100440200	25888	12795	5	0	\N
7326	1394	812173089440200	25899	12801	3	0	\N
7328	1394	812173110440200	25899	12801	4	0	\N
7330	1394	813613123440200	25909	12805	2	0	\N
7332	1394	813613134440200	25909	12805	3	0	\N
7336	1394	816493167440200	25955	12826	3	0	\N
7337	1394	816493167440200	25968	12830	4	0	\N
7340	1394	816493180440200	25968	12830	5	0	\N
7341	1394	816493188440200	25955	12826	4	0	\N
7211	1394	761772341440200	25067	12441	4	0	0
7213	1394	763212341440200	25110	12459	3	0	0
7214	1394	763212353440200	25110	12459	4	0	0
7218	1394	764652353440200	25128	12469	4	0	0
7220	1394	764652366440200	25128	12469	5	0	0
7223	1394	766092378440200	25159	12482	4	0	0
7224	1394	767532378440200	25173	12488	4	0	0
7225	1394	767532391440200	25173	12488	5	0	0
7226	1394	767532401440200	25192	12497	1	0	0
7227	1394	768972401440200	25192	12497	5	0	0
7229	1394	770412404440200	25214	12507	3	0	0
7230	1394	770412416440200	25214	12507	4	0	0
7231	1394	771852416440200	25233	12516	5	0	0
7232	1394	771852430440200	25233	12516	6	0	0
7234	1394	774732330440200	25242	12520	3	0	0
7235	1394	774732342440200	25242	12520	4	0	0
7236	1394	776172342440200	25244	12521	7	0	0
7237	1394	776172367440200	25244	12521	8	0	0
7238	1394	777612367440200	25250	12524	7	0	0
7240	1394	779052392440200	25256	12528	3	0	0
7241	1394	779052404440200	25256	12528	4	0	0
7242	1394	780492404440200	25319	12559	4	0	0
7243	1394	780492417440200	25319	12559	5	0	0
7244	1394	781932417440200	25323	12560	9	0	0
7248	1394	783372453440200	25354	12571	7	0	0
7250	1394	783372577440200	25354	12571	8	0	0
7252	1394	784812577440200	25360	12574	10	0	0
7253	1394	784812614440200	25360	12574	11	0	0
7255	1394	786252638440200	25363	12576	7	0	0
7257	1394	787692638440200	25372	12580	3	0	0
7258	1394	787692650440200	25372	12580	4	0	0
7260	1394	789132650440200	25406	12590	11	0	0
7261	1394	789132787440200	25406	12590	12	0	0
7263	1394	790572799440200	25407	12591	4	0	0
7267	1394	792012799440200	25457	12610	4	0	0
7271	1394	792012911440200	25457	12610	5	0	0
7273	1394	793452911440200	25487	12623	3	0	0
7275	1394	793452923440200	25487	12623	4	0	0
7277	1394	794892935440200	25511	12633	4	0	0
7278	1394	796332935440200	25525	12637	3	0	0
7279	1394	796332947440200	25525	12637	4	0	0
7281	1394	797772947440200	25577	12662	3	0	0
7284	1394	799212959440200	25590	12665	3	0	0
7285	1394	799212971440200	25590	12665	4	0	0
7288	1394	800652971440200	25639	12689	3	0	0
7290	1394	800652983440200	25639	12689	4	0	0
7292	1394	802092983440200	25655	12696	3	0	0
7297	1394	803532995440200	25775	12748	6	0	0
7301	1394	803533019440200	25775	12748	7	0	0
7302	1394	804973019440200	25780	12750	3	0	0
7303	1394	804973031440200	25780	12750	4	0	0
7304	1394	806413031440200	25799	12757	2	0	0
7307	1394	807853042440200	25829	12772	7	0	0
7308	1394	807853067440200	25829	12772	8	0	0
7314	1394	809293067440200	25884	12793	2	0	0
7315	1394	809293078440200	25884	12793	3	0	0
7324	1394	810733089440200	25894	12798	3	0	0
7327	1394	812173089440200	25907	12804	7	0	0
7329	1394	812173123440200	25907	12804	8	0	0
7331	1394	813613123440200	25918	12808	2	0	0
7333	1394	813613134440200	25918	12808	3	0	0
7335	1394	815053167440200	25925	12811	7	0	0
7338	1394	816493167440200	25981	12839	2	0	0
7339	1394	816493178440200	25981	12839	3	0	0
7342	1394	817933178440200	25982	12840	2	0	0
7343	1394	817933189440200	25982	12840	3	0	0
7362	1394	832333321440200	26120	12912	2	0	\N
7364	1394	832333332440200	26120	12912	3	0	\N
7369	1394	835213354440200	26132	12918	2	0	\N
7371	1394	835213365440200	26132	12918	3	0	\N
7373	1394	836653365440200	26153	12928	6	0	\N
7376	1394	836653389440200	26153	12928	7	0	\N
7379	1394	839533403440200	26177	12941	7	0	\N
7382	1394	839533428440200	26177	12941	8	0	\N
7383	1394	840973415440200	26204	12954	4	0	\N
7386	1394	840973428440200	26204	12954	5	0	\N
7387	1394	842413427440200	26221	12964	3	0	\N
7389	1394	842413439440200	26221	12964	4	0	\N
7397	1394	848173514440200	26237	12972	3	0	\N
7398	1394	848173514440200	26255	12983	3	0	\N
7400	1394	848173526440200	26237	12972	4	0	\N
7401	1394	848173526440200	26255	12983	4	0	\N
7403	1394	849613539440200	26267	12990	3	0	\N
7405	1394	849613551440200	26267	12990	4	0	\N
7407	1394	851053551440200	26275	12995	4	0	\N
7409	1394	851053564440200	26275	12995	5	0	\N
7413	1394	853933586440200	26294	13007	11	0	\N
7416	1394	853933633440200	26294	13007	12	0	\N
7417	1394	855373597440200	26319	13017	5	0	\N
7420	1394	855373620440200	26319	13017	6	0	\N
7421	1394	856813609440200	26344	13028	3	0	\N
7423	1394	856813621440200	26344	13028	4	0	\N
7433	1394	864013700440200	26382	13049	4	0	\N
7435	1394	864013713440200	26382	13049	5	0	\N
7439	1394	866893725440200	26412	13067	3	0	\N
7441	1394	866893737440200	26412	13067	4	0	\N
7445	1394	869773762440200	26427	13074	3	0	\N
7447	1394	869773774440200	26427	13074	4	0	\N
7455	1394	875533811440200	26489	13103	7	0	\N
7458	1394	875533836440200	26489	13103	8	0	\N
7461	1394	878413835440200	26516	13119	3	0	\N
7463	1394	878413847440200	26516	13119	4	0	\N
7471	1394	884173923440200	26560	13141	4	0	\N
7472	1394	884173923440200	26572	13148	4	0	\N
7473	1394	884173923440200	26577	13150	12	0	\N
7474	1394	884173923440200	26587	13154	6	0	\N
7476	1394	884173936440200	26560	13141	5	0	\N
7477	1394	884173936440200	26572	13148	5	0	\N
7478	1394	884173947440200	26587	13154	7	0	\N
7480	1394	884173962440200	26577	13150	13	0	\N
7347	1394	820813222440200	26062	12880	5	0	0
7348	1394	822253222440200	26079	12888	2	0	0
7349	1394	822253233440200	26079	12888	3	0	0
7350	1394	823693233440200	26093	12895	2	0	0
7351	1394	823693244440200	26093	12895	3	0	0
7353	1394	825133255440200	26094	12896	3	0	0
7354	1394	826573255440200	26098	12898	2	0	0
7355	1394	826573266440200	26098	12898	3	0	0
7356	1394	828013266440200	26106	12903	4	0	0
7357	1394	828013288440200	26106	12903	5	0	0
7359	1394	829453299440200	26116	12908	3	0	0
7360	1394	830893299440200	26117	12909	4	0	0
7361	1394	830893321440200	26117	12909	5	0	0
7363	1394	832333321440200	26122	12913	4	0	0
7366	1394	832333353440200	26126	12916	1	0	0
7367	1394	833773353440200	26126	12916	3	0	0
7368	1394	833773354440200	26126	12916	4	0	0
7370	1394	835213354440200	26145	12924	2	0	0
7372	1394	835213365440200	26145	12924	3	0	0
7375	1394	836653377440200	26162	12932	4	0	0
7377	1394	838093377440200	26167	12935	8	0	0
7378	1394	838093403440200	26167	12935	9	0	0
7380	1394	839533403440200	26200	12952	3	0	0
7381	1394	839533415440200	26200	12952	4	0	0
7385	1394	840973427440200	26212	12959	4	0	0
7388	1394	842413427440200	26224	12965	7	0	0
7390	1394	842413452440200	26224	12965	8	0	0
7391	1394	843853452440200	26229	12968	3	0	0
7393	1394	845293464440200	26230	12969	7	0	0
7394	1394	845293489440200	26230	12969	8	0	0
7395	1394	846733489440200	26233	12971	7	0	0
7396	1394	846733514440200	26233	12971	8	0	0
7399	1394	848173514440200	26265	12988	7	0	0
7404	1394	849613539440200	26273	12994	3	0	0
7406	1394	849613551440200	26273	12994	4	0	0
7408	1394	851053551440200	26277	12996	6	0	0
7410	1394	851053575440200	26277	12996	7	0	0
7411	1394	852493575440200	26293	13006	2	0	0
7414	1394	853933586440200	26297	13008	2	0	0
7415	1394	853933597440200	26297	13008	3	0	0
7418	1394	855373597440200	26335	13023	3	0	0
7419	1394	855373609440200	26335	13023	4	0	0
7424	1394	856813643440200	26351	13030	8	0	0
7425	1394	858253643440200	26359	13034	3	0	0
7426	1394	858253655440200	26359	13034	4	0	0
7427	1394	859693655440200	26360	13035	2	0	0
7428	1394	859693666440200	26360	13035	3	0	0
7430	1394	861133688440200	26367	13041	5	0	0
7431	1394	862573688440200	26379	13048	3	0	0
7432	1394	862573700440200	26379	13048	4	0	0
7434	1394	864013700440200	26395	13057	4	0	0
7436	1394	864013713440200	26395	13057	5	0	0
7438	1394	865453725440200	26402	13063	4	0	0
7440	1394	866893725440200	26418	13070	3	0	0
7442	1394	866893737440200	26418	13070	4	0	0
7443	1394	868333737440200	26419	13071	7	0	0
7446	1394	869773762440200	26439	13079	4	0	0
7448	1394	869773775440200	26439	13079	5	0	0
7449	1394	871213775440200	26465	13091	3	0	0
7450	1394	871213787440200	26465	13091	4	0	0
7451	1394	872653787440200	26485	13099	3	0	0
7453	1394	874093799440200	26486	13100	3	0	0
7454	1394	874093811440200	26486	13100	4	0	0
7456	1394	875533811440200	26492	13105	3	0	0
7457	1394	875533823440200	26492	13105	4	0	0
7459	1394	876973823440200	26500	13109	3	0	0
7462	1394	878413835440200	26519	13120	4	0	0
7464	1394	878413848440200	26519	13120	5	0	0
7465	1394	879853848440200	26527	13123	4	0	0
7466	1394	879853861440200	26527	13123	5	0	0
7468	1394	881293886440200	26538	13128	8	0	0
7469	1394	882733886440200	26546	13133	10	0	0
7470	1394	882733923440200	26546	13133	11	0	0
7475	1394	884173923440200	26591	13156	6	0	0
7479	1394	884173947440200	26591	13156	7	0	0
7486	1394	888493972440200	26609	13165	3	0	\N
7487	1394	888493972440200	26615	13168	8	0	\N
7488	1394	888493984440200	26609	13165	4	0	\N
7489	1394	888493989440200	26615	13168	9	0	\N
7494	1394	891374051440200	26631	13175	4	0	\N
7495	1394	891374051440200	26636	13178	4	0	\N
7497	1394	891374064440200	26631	13175	5	0	\N
7498	1394	891374064440200	26636	13178	5	0	\N
7506	1394	897134123440200	26700	13206	3	0	\N
7507	1394	897134123440200	26713	13213	6	0	\N
7509	1394	897134135440200	26700	13206	4	0	\N
7511	1394	897134147440200	26713	13213	7	0	\N
7516	1394	901454183440200	26732	13222	3	0	\N
7517	1394	901454183440200	26733	13223	5	0	\N
7519	1394	901454195440200	26732	13222	4	0	\N
7521	1394	901454197440200	26733	13223	6	0	\N
7522	1394	902894195440200	26771	13239	20	0	\N
7525	1394	902894269440200	26771	13239	21	0	\N
7528	1394	905774219440200	26791	13247	3	0	\N
7530	1394	905774231440200	26791	13247	4	0	\N
7533	1394	907214231440200	26810	13258	3	0	\N
7535	1394	907214243440200	26810	13258	4	0	\N
7547	1394	915854318440200	26854	13283	3	0	\N
7548	1394	915854318440200	26860	13285	3	0	\N
7550	1394	915854330440200	26854	13283	4	0	\N
7551	1394	915854330440200	26860	13285	4	0	\N
7557	1394	920174390440200	26911	13308	3	0	\N
7559	1394	920174402440200	26911	13308	4	0	\N
7565	1394	924494438440200	26927	13318	3	0	\N
7566	1394	924494438440200	26940	13325	3	0	\N
7567	1394	924494438440200	26942	13326	9	0	\N
7569	1394	924494450440200	26927	13318	4	0	\N
7570	1394	924494450440200	26940	13325	4	0	\N
7571	1394	924494474440200	26942	13326	10	0	\N
7573	1394	925934487440200	26959	13328	16	0	\N
7576	1394	925934548440200	26959	13328	17	0	\N
7577	1394	927374499440200	26993	13351	3	0	\N
7579	1394	927374511440200	26993	13351	4	0	\N
7581	1394	928814511440200	27005	13358	6	0	\N
7584	1394	928814535440200	27005	13358	7	0	\N
7585	1394	930254523440200	27018	13363	3	0	\N
7587	1394	930254535440200	27018	13363	4	0	\N
7605	1394	943214669440200	27128	13416	3	0	\N
7607	1394	943214681440200	27128	13416	4	0	\N
7611	1394	944654727440200	27153	13424	1	0	\N
7613	1394	946094727440200	27153	13424	13	0	\N
7615	1394	946094765440200	27153	13424	14	0	\N
7483	1394	887053960440200	26603	13161	3	0	0
7484	1394	887053972440200	26603	13161	4	0	0
7485	1394	887054038440200	26622	13169	21	0	0
7490	1394	888494038440200	26622	13169	23	0	0
7491	1394	888494039440200	26622	13169	24	0	0
7493	1394	889934051440200	26625	13171	4	0	0
7496	1394	891374051440200	26640	13179	9	0	0
7499	1394	891374087440200	26640	13179	10	0	0
7500	1394	892814087440200	26650	13183	3	0	0
7501	1394	892814099440200	26650	13183	4	0	0
7503	1394	894254111440200	26654	13184	4	0	0
7504	1394	895694111440200	26663	13189	3	0	0
7505	1394	895694123440200	26663	13189	4	0	0
7508	1394	897134123440200	26722	13217	4	0	0
7512	1394	898574136440200	26724	13218	8	0	0
7513	1394	898574171440200	26724	13218	9	0	0
7514	1394	900014171440200	26726	13220	3	0	0
7515	1394	900014183440200	26726	13220	4	0	0
7518	1394	901454183440200	26762	13234	3	0	0
7523	1394	902894195440200	26778	13242	3	0	0
7524	1394	902894207440200	26778	13242	4	0	0
7526	1394	904334207440200	26785	13245	3	0	0
7527	1394	904334219440200	26785	13245	4	0	0
7529	1394	905774219440200	26807	13257	3	0	0
7532	1394	905774241440200	26816	13261	1	0	0
7534	1394	907214241440200	26816	13261	5	0	0
7536	1394	907214244440200	26816	13261	6	0	0
7537	1394	908654244440200	26828	13266	2	0	0
7539	1394	910094255440200	26831	13268	4	0	0
7540	1394	910094268440200	26831	13268	5	0	0
7541	1394	911534268440200	26843	13275	3	0	0
7542	1394	911534280440200	26843	13275	4	0	0
7543	1394	912974280440200	26844	13276	4	0	0
7545	1394	914414293440200	26847	13279	7	0	0
7546	1394	914414318440200	26847	13279	8	0	0
7549	1394	915854318440200	26887	13296	4	0	0
7552	1394	915854331440200	26887	13296	5	0	0
7553	1394	917294331440200	26891	13298	3	0	0
7555	1394	918734343440200	26900	13302	11	0	0
7556	1394	918734390440200	26900	13302	12	0	0
7558	1394	920174390440200	26919	13314	6	0	0
7560	1394	920174414440200	26919	13314	7	0	0
7562	1394	921614426440200	26922	13315	4	0	0
7563	1394	923054426440200	26923	13316	3	0	0
7564	1394	923054438440200	26923	13316	4	0	0
7568	1394	924494438440200	26943	13327	13	0	0
7572	1394	924494487440200	26943	13327	14	0	0
7575	1394	925934499440200	26986	13346	4	0	0
7578	1394	927374499440200	26995	13352	3	0	0
7580	1394	927374511440200	26995	13352	4	0	0
7582	1394	928814511440200	27009	13359	3	0	0
7583	1394	928814523440200	27009	13359	4	0	0
7588	1394	930254547440200	27046	13372	7	0	0
7589	1394	931694547440200	27056	13376	6	0	0
7590	1394	931694571440200	27056	13376	7	0	0
7591	1394	933134571440200	27063	13381	3	0	0
7593	1394	934574583440200	27082	13390	3	0	0
7594	1394	934574595440200	27082	13390	4	0	0
7595	1394	936014595440200	27101	13399	6	0	0
7596	1394	936014619440200	27101	13399	7	0	0
7597	1394	936014631440200	27104	13401	3	0	0
7599	1394	938894631440200	27109	13403	3	0	0
7600	1394	938894643440200	27109	13403	4	0	0
7601	1394	940334643440200	27118	13408	3	0	0
7602	1394	940334655440200	27118	13408	4	0	0
7603	1394	941774655440200	27122	13411	5	0	0
7606	1394	943214669440200	27130	13417	9	0	0
7608	1394	943214705440200	27130	13417	10	0	0
7609	1394	944654705440200	27139	13420	3	0	0
7610	1394	944654717440200	27139	13420	4	0	0
7614	1394	946094759440200	27154	13426	7	0	0
7616	1394	947534759440200	27157	13428	6	0	0
7626	1394	954734855440200	27223	13463	3	0	\N
7628	1394	954734867440200	27223	13463	4	0	\N
7630	1394	956174891440200	27242	13471	4	0	\N
7633	1394	956174904440200	27242	13471	5	0	\N
7634	1394	957614903440200	27286	13487	2	0	\N
7636	1394	957614914440200	27286	13487	3	0	\N
7638	1394	959054915440200	27317	13504	3	0	\N
7639	1394	959054915440200	27318	13505	6	0	\N
7641	1394	959054927440200	27317	13504	4	0	\N
7643	1394	959054939440200	27318	13505	7	0	\N
7644	1394	960494927440200	27379	13539	3	0	\N
7645	1394	960494927440200	27388	13542	6	0	\N
7647	1394	960494939440200	27379	13539	4	0	\N
7649	1394	960494951440200	27388	13542	7	0	\N
7650	1394	961934939440200	27416	13556	3	0	\N
7652	1394	961934951440200	27416	13556	4	0	\N
7654	1394	963374975440200	27429	13560	3	0	\N
7656	1394	963374987440200	27429	13560	4	0	\N
7660	1394	966254999440200	27446	13566	6	0	\N
7663	1394	966255023440200	27446	13566	7	0	\N
7664	1394	967695011440200	27460	13573	9	0	\N
7666	1394	967695029440200	27460	13573	10	0	\N
7668	1394	969135062440200	27471	13577	7	0	\N
7670	1394	969135069440200	27471	13577	8	0	\N
7678	1394	974895174440200	27498	13593	4	0	\N
7681	1394	974895187440200	27498	13593	5	0	\N
7692	1394	983535259440200	27563	13624	3	0	\N
7694	1394	983535271440200	27563	13624	4	0	\N
7698	1394	986415295440200	27604	13643	0	0	\N
7701	1394	987855335440200	27631	13657	3	0	\N
7702	1394	987855335440200	27633	13658	3	0	\N
7704	1394	987855347440200	27631	13657	4	0	\N
7705	1394	987855347440200	27633	13658	4	0	\N
7707	1394	989295357440200	27671	13675	3	0	\N
7709	1394	989295369440200	27671	13675	4	0	\N
7711	1394	990735369440200	27694	13685	2	0	\N
7712	1394	990735369440200	27705	13689	10	0	\N
7714	1394	990735380440200	27694	13685	3	0	\N
7716	1394	990735442440200	27705	13689	11	0	\N
7725	1394	997935456440200	27766	13718	2	0	\N
7727	1394	997935467440200	27766	13718	3	0	\N
7741	1394	1008015573440200	27857	13770	3	0	\N
7743	1394	1008015585440200	27857	13770	4	0	\N
7619	1394	948974795440200	27163	13432	4	0	0
7620	1394	950414795440200	27174	13439	3	0	0
7621	1394	950414807440200	27174	13439	4	0	0
7622	1394	951854807440200	27197	13452	3	0	0
7623	1394	951854819440200	27197	13452	4	0	0
7625	1394	953294855440200	27217	13461	10	0	0
7627	1394	954734855440200	27239	13468	9	0	0
7629	1394	954734891440200	27239	13468	10	0	0
7631	1394	956174891440200	27268	13479	3	0	0
7632	1394	956174903440200	27268	13479	4	0	0
7637	1394	957614915440200	27315	13503	4	0	0
7640	1394	959054915440200	27345	13520	3	0	0
7642	1394	959054927440200	27345	13520	4	0	0
7646	1394	960494927440200	27402	13550	3	0	0
7651	1394	961934939440200	27420	13557	9	0	0
7653	1394	961934975440200	27420	13557	10	0	0
7655	1394	963374975440200	27432	13561	3	0	0
7657	1394	963374987440200	27432	13561	4	0	0
7658	1394	964814987440200	27433	13562	3	0	0
7661	1394	966254999440200	27454	13569	3	0	0
7662	1394	966255011440200	27454	13569	4	0	0
7665	1394	967695011440200	27467	13575	24	0	0
7667	1394	967695062440200	27467	13575	25	0	0
7669	1394	969135062440200	27477	13579	26	0	0
7672	1394	970575115440200	27479	13580	8	0	0
7673	1394	970575132440200	27479	13580	9	0	0
7674	1394	972015132440200	27482	13582	9	0	0
7675	1394	972015150440200	27482	13582	10	0	0
7677	1394	973455174440200	27494	13590	7	0	0
7679	1394	974895174440200	27500	13594	3	0	0
7680	1394	974895186440200	27500	13594	4	0	0
7682	1394	976335186440200	27506	13598	3	0	0
7683	1394	976335198440200	27506	13598	4	0	0
7685	1394	977775211440200	27521	13606	5	0	0
7686	1394	979215211440200	27531	13611	2	0	0
7687	1394	979215222440200	27531	13611	3	0	0
7688	1394	980655222440200	27548	13617	6	0	0
7689	1394	980655246440200	27548	13617	7	0	0
7691	1394	982095259440200	27559	13623	5	0	0
7693	1394	983535259440200	27566	13625	3	0	0
7695	1394	983535271440200	27566	13625	4	0	0
7696	1394	984975271440200	27579	13630	6	0	0
7699	1394	986415295440200	27615	13648	4	0	0
7700	1394	986415335440200	27615	13648	5	0	0
7703	1394	987855335440200	27645	13661	4	0	0
7706	1394	987855357440200	27645	13661	5	0	0
7708	1394	989295357440200	27678	13676	3	0	0
7713	1394	990735369440200	27709	13692	2	0	0
7715	1394	990735380440200	27709	13692	3	0	0
7717	1394	992175380440200	27717	13695	2	0	0
7718	1394	992175391440200	27717	13695	3	0	0
7719	1394	993615391440200	27724	13697	3	0	0
7721	1394	995055412440200	27734	13701	6	0	0
7722	1394	995055445440200	27734	13701	7	0	0
7723	1394	996495445440200	27761	13714	2	0	0
7724	1394	996495456440200	27761	13714	3	0	0
7728	1394	997935478440200	27785	13729	5	0	0
7729	1394	999375478440200	27789	13732	2	0	0
7730	1394	999375489440200	27789	13732	3	0	0
7731	1394	1000815489440200	27820	13749	3	0	0
7732	1394	1000815501440200	27820	13749	4	0	0
7734	1394	1002255513440200	27827	13753	4	0	0
7735	1394	1003695513440200	27836	13758	3	0	0
7736	1394	1003695525440200	27836	13758	4	0	0
7737	1394	1005135525440200	27843	13762	9	0	0
7738	1394	1005135561440200	27843	13762	10	0	0
7740	1394	1006575573440200	27847	13765	4	0	0
7742	1394	1008015573440200	27860	13772	3	0	0
7744	1394	1008015585440200	27860	13772	4	0	0
7745	1394	1009455585440200	27866	13777	7	0	0
7747	1394	1010895610440200	27878	13783	3	0	0
7748	1394	1010895622440200	27878	13783	4	0	0
7749	1394	1012335622440200	27885	13787	3	0	0
7750	1394	1012335634440200	27885	13787	4	0	0
7751	1394	1013775634440200	27890	13790	3	0	0
7755	1394	1016655658440200	27895	13793	7	0	\N
7756	1394	1016655658440200	27898	13794	3	0	\N
7758	1394	1016655670440200	27898	13794	4	0	\N
7760	1394	1016655683440200	27895	13793	8	0	\N
7763	1394	1019535706440200	27928	13815	3	0	\N
7764	1394	1019535706440200	27932	13817	3	0	\N
7766	1394	1019535718440200	27928	13815	4	0	\N
7767	1394	1019535718440200	27932	13817	4	0	\N
7773	1394	1023855767440200	27944	13825	3	0	\N
7774	1394	1023855767440200	27947	13826	6	0	\N
7775	1394	1023855767440200	27955	13830	6	0	\N
7777	1394	1023855779440200	27944	13825	4	0	\N
7779	1394	1023855791440200	27947	13826	7	0	\N
7780	1394	1023855791440200	27955	13830	7	0	\N
7783	1394	1026735803440200	27992	13845	3	0	\N
7785	1394	1026735815440200	27992	13845	4	0	\N
7787	1394	1028175815440200	28022	13860	3	0	\N
7789	1394	1028175827440200	28022	13860	4	0	\N
7791	1394	1029615827440200	28066	13878	6	0	\N
7794	1394	1029615851440200	28066	13878	7	0	\N
7795	1394	1031055839440200	28114	13897	7	0	\N
7798	1394	1031055864440200	28114	13897	8	0	\N
7799	1394	1032495852440200	28167	13927	2	0	\N
7801	1394	1032495863440200	28167	13927	3	0	\N
7807	1394	1036815897440200	28202	13943	1	0	\N
7809	1394	1036815898440200	28202	13943	2	0	\N
7815	1394	1041135931440200	28237	13961	2	0	\N
7816	1394	1041135931440200	28255	13970	2	0	\N
7817	1394	1041135931440200	28256	13971	2	0	\N
7819	1394	1041135942440200	28237	13961	3	0	\N
7820	1394	1041135942440200	28255	13970	3	0	\N
7821	1394	1041135942440200	28256	13971	3	0	\N
7827	1394	1045455965440200	28285	13984	2	0	\N
7829	1394	1045455976440200	28285	13984	3	0	\N
7833	1394	1048336032440200	28341	14011	8	0	\N
7835	1394	1048336032440200	28800	13999	0	0	\N
7836	1394	1048336032440200	28801	14012	0	0	\N
7837	1394	1048336032440200	28803	14024	0	0	\N
7839	1394	1048336076440200	28341	14011	9	0	\N
7840	1394	1049776043440200	28386	14032	2	0	\N
7842	1394	1049776054440200	28386	14032	3	0	\N
7844	1394	1051216054440200	28401	14038	4	0	\N
7846	1394	1051216054440200	28804	14037	0	0	\N
7848	1394	1051216076440200	28401	14038	5	0	\N
7849	1394	1052656065440200	28409	14040	3	0	\N
7850	1394	1052656065440200	28430	14051	2	0	\N
7852	1394	1052656076440200	28430	14051	3	0	\N
7854	1394	1052656086440200	28409	14040	4	0	\N
7855	1394	1054096076440200	28447	14059	4	0	\N
7858	1394	1054096098440200	28447	14059	5	0	\N
7863	1394	1058416120440200	28479	14075	2	0	\N
7864	1394	1058416120440200	28506	14086	3	0	\N
7866	1394	1058416131440200	28479	14075	3	0	\N
7867	1394	1058416132440200	28506	14086	4	0	\N
7869	1394	1059856133440200	28521	14092	3	0	\N
7872	1394	1059856145440200	28521	14092	4	0	\N
7873	1394	1061296144440200	28571	14113	6	0	\N
7874	1394	1061296144440200	28577	14114	7	0	\N
7875	1394	1061296144440200	28582	14115	5	0	\N
7877	1394	1061296167440200	28582	14115	6	0	\N
7878	1394	1061296168440200	28571	14113	7	0	\N
7879	1394	1061296169440200	28577	14114	8	0	\N
7883	1394	1062736202440200	28590	14119	1	0	\N
7885	1394	1064176202440200	28590	14119	4	0	\N
7886	1394	1064176204440200	28590	14119	5	0	\N
7757	1394	1016655658440200	27901	13796	6	0	0
7759	1394	1016655682440200	27901	13796	7	0	0
7761	1394	1018095682440200	27911	13804	6	0	0
7762	1394	1018095706440200	27911	13804	7	0	0
7765	1394	1019535706440200	27934	13818	7	0	0
7769	1394	1020975731440200	27936	13819	6	0	0
7770	1394	1020975755440200	27936	13819	7	0	0
7771	1394	1022415755440200	27940	13821	3	0	0
7772	1394	1022415767440200	27940	13821	4	0	0
7776	1394	1023855767440200	27982	13840	3	0	0
7781	1394	1025295779440200	27983	13841	6	0	0
7782	1394	1025295803440200	27983	13841	7	0	0
7784	1394	1026735803440200	27998	13847	3	0	0
7786	1394	1026735815440200	27998	13847	4	0	0
7790	1394	1028175827440200	28052	13872	4	0	0
7792	1394	1029615827440200	28095	13888	3	0	0
7793	1394	1029615839440200	28095	13888	4	0	0
7796	1394	1031055839440200	28118	13900	4	0	0
7797	1394	1031055852440200	28118	13900	5	0	0
7802	1394	1032495863440200	28187	13933	3	0	0
7803	1394	1033935863440200	28189	13935	5	0	0
7804	1394	1033935886440200	28189	13935	6	0	0
7805	1394	1035375886440200	28197	13940	2	0	0
7806	1394	1035375897440200	28197	13940	3	0	0
7810	1394	1036815908440200	28208	13946	3	0	0
7811	1394	1038255908440200	28214	13950	3	0	0
7812	1394	1038255920440200	28214	13950	4	0	0
7813	1394	1039695920440200	28219	13953	2	0	0
7818	1394	1041135931440200	28261	13972	3	0	0
7822	1394	1041135943440200	28261	13972	4	0	0
7823	1394	1042575943440200	28264	13974	2	0	0
7824	1394	1042575954440200	28264	13974	3	0	0
7825	1394	1044015954440200	28279	13980	2	0	0
7828	1394	1045455965440200	28309	13995	11	0	0
7830	1394	1045456021440200	28309	13995	12	0	0
7831	1394	1046896021440200	28313	13998	2	0	0
7832	1394	1046896032440200	28313	13998	3	0	0
7834	1394	1048336032440200	28372	14026	2	0	0
7841	1394	1049776043440200	28398	14036	2	0	0
7843	1394	1049776054440200	28398	14036	3	0	0
7845	1394	1051216054440200	28403	14039	2	0	0
7847	1394	1051216065440200	28403	14039	3	0	0
7853	1394	1052656076440200	28443	14057	3	0	0
7856	1394	1054096076440200	28451	14060	2	0	0
7857	1394	1054096087440200	28451	14060	3	0	0
7859	1394	1055536087440200	28465	14066	2	0	0
7860	1394	1055536098440200	28465	14066	3	0	0
7862	1394	1056976120440200	28471	14069	5	0	0
7865	1394	1058416120440200	28518	14090	4	0	0
7868	1394	1058416133440200	28518	14090	5	0	0
7870	1394	1059856133440200	28533	14098	2	0	0
7871	1394	1059856144440200	28533	14098	3	0	0
7880	1394	1061296180440200	28585	14117	10	0	0
7881	1394	1062736180440200	28587	14118	3	0	0
7882	1394	1062736192440200	28587	14118	4	0	0
7884	1394	1064176192440200	28597	14122	3	0	0
7888	1394	1065616204440200	28603	14125	3	0	0
7890	1394	1067056216440200	28609	14127	2	0	\N
7891	1394	1067056216440200	28640	14141	2	0	\N
7892	1394	1067056216440200	28648	14143	3	0	\N
7895	1394	1067056227440200	28609	14127	3	0	\N
7896	1394	1067056227440200	28640	14141	3	0	\N
7897	1394	1067056228440200	28648	14143	4	0	\N
7900	1394	1069936248440200	28680	14158	4	0	\N
7902	1394	1069936261440200	28680	14158	5	0	\N
7904	1394	1071376261440200	28714	14173	1	0	\N
7906	1394	1071376262440200	28714	14173	2	0	\N
7908	1394	1072816272440200	28749	14183	3	0	\N
7909	1394	1072816272440200	28755	14185	2	0	\N
7911	1394	1072816283440200	28755	14185	3	0	\N
7912	1394	1072816284440200	28749	14183	4	0	\N
7920	1394	1078576331440200	28865	14236	3	0	\N
7921	1394	1078576331440200	28875	14244	3	0	\N
7923	1394	1078576343440200	28875	14244	4	0	\N
7925	1394	1078576352440200	28865	14236	4	0	\N
7930	1394	1082896357440200	28890	14252	6	0	\N
7933	1394	1082896381440200	28890	14252	7	0	\N
7934	1394	1084336369440200	28927	14266	4	0	\N
7935	1394	1084336369440200	28932	14269	3	0	\N
7937	1394	1084336381440200	28932	14269	4	0	\N
7938	1394	1084336382440200	28927	14266	5	0	\N
7944	1394	1088656431440200	28981	14291	3	0	\N
7945	1394	1088656431440200	28991	14294	3	0	\N
7947	1394	1088656443440200	28981	14291	4	0	\N
7948	1394	1088656443440200	28991	14294	4	0	\N
7958	1394	1095856501440200	29034	14318	4	0	\N
7961	1394	1095856523440200	29034	14318	5	0	\N
7964	1394	1098736525440200	29057	14329	3	0	\N
7965	1394	1098736525440200	29060	14330	9	0	\N
7966	1394	1098736525440200	29085	14338	4	0	\N
7969	1394	1098736537440200	29057	14329	4	0	\N
7970	1394	1098736538440200	29085	14338	5	0	\N
7972	1394	1098736561440200	29060	14330	10	0	\N
7973	1394	1100176536440200	29103	14347	2	0	\N
7974	1394	1100176547440200	29103	14347	3	0	\N
7983	1394	1105936606440200	29168	14381	5	0	\N
7986	1394	1105936638440200	29168	14381	6	0	\N
7989	1394	1108816631440200	29236	14408	4	0	\N
7991	1394	1108816644440200	29236	14408	5	0	\N
7997	1394	1113136716440200	29275	14428	3	0	\N
8000	1394	1113136728440200	29275	14428	4	0	\N
8015	1394	1124656835440200	29376	14481	9	0	\N
8018	1394	1124656871440200	29376	14481	10	0	\N
8023	1394	1128976892440200	29430	14510	3	0	\N
7894	1394	1067056226440200	28661	14150	2	0	0
7898	1394	1068496226440200	28678	14157	4	0	0
7899	1394	1068496248440200	28678	14157	5	0	0
7901	1394	1069936248440200	28703	14171	4	0	0
7903	1394	1069936261440200	28703	14171	5	0	0
7907	1394	1071376272440200	28737	14180	3	0	0
7910	1394	1072816272440200	28779	14196	6	0	0
7913	1394	1072816296440200	28779	14196	7	0	0
7914	1394	1074256296440200	28821	14216	3	0	0
7915	1394	1074256308440200	28821	14216	4	0	0
7917	1394	1075696319440200	28822	14217	3	0	0
7918	1394	1075696331440200	28852	14230	3	0	0
7919	1394	1077136331440200	28852	14230	4	0	0
7922	1394	1078576331440200	28880	14246	3	0	0
7926	1394	1080016343440200	28884	14248	5	0	0
7927	1394	1080016366440200	28884	14248	6	0	0
7928	1394	1081456346440200	28887	14250	2	0	0
7929	1394	1081456357440200	28887	14250	3	0	0
7931	1394	1082896357440200	28899	14255	3	0	0
7936	1394	1084336369440200	28935	14270	4	0	0
7939	1394	1084336382440200	28935	14270	5	0	0
7940	1394	1085776382440200	28944	14274	3	0	0
7941	1394	1085776394440200	28944	14274	4	0	0
7942	1394	1087216394440200	28946	14275	10	0	0
7946	1394	1088656431440200	28996	14296	3	0	0
7949	1394	1088656443440200	28996	14296	4	0	0
7950	1394	1090096443440200	29003	14301	2	0	0
7951	1394	1090096454440200	29003	14301	3	0	0
7953	1394	1091536477440200	29007	14304	6	0	0
7954	1394	1092976477440200	29012	14306	3	0	0
7955	1394	1092976489440200	29012	14306	4	0	0
7956	1394	1094416489440200	29019	14311	3	0	0
7957	1394	1094416501440200	29019	14311	4	0	0
7960	1394	1095856513440200	29044	14324	4	0	0
7962	1394	1097296513440200	29049	14326	3	0	0
7963	1394	1097296525440200	29049	14326	4	0	0
7967	1394	1098736525440200	29099	14345	2	0	0
7968	1394	1098736536440200	29099	14345	3	0	0
7975	1394	1100176547440200	29119	14355	5	0	0
7976	1394	1100176549440200	29119	14355	6	0	0
7977	1394	1101616549440200	29120	14356	5	0	0
7978	1394	1101616572440200	29120	14356	6	0	0
7980	1394	1103056584440200	29124	14358	4	0	0
7981	1394	1104496584440200	29129	14361	4	0	0
7982	1394	1104496606440200	29129	14361	5	0	0
7984	1394	1105936606440200	29215	14398	4	0	0
7985	1394	1105936619440200	29215	14398	5	0	0
7988	1394	1107376631440200	29216	14399	4	0	0
7990	1394	1108816631440200	29246	14413	6	0	0
7992	1394	1108816655440200	29246	14413	7	0	0
7993	1394	1110256655440200	29262	14423	12	0	0
7994	1394	1110256703440200	29262	14423	13	0	0
7996	1394	1111696716440200	29265	14424	5	0	0
7998	1394	1113136716440200	29290	14434	2	0	0
7999	1394	1113136727440200	29290	14434	3	0	0
8001	1394	1114576727440200	29311	14444	7	0	0
8003	1394	1116016752440200	29312	14445	2	0	0
8004	1394	1116016763440200	29312	14445	3	0	0
8005	1394	1117456763440200	29318	14448	2	0	0
8006	1394	1117456774440200	29318	14448	3	0	0
8007	1394	1118896774440200	29335	14456	4	0	0
8009	1394	1120336787440200	29341	14460	3	0	0
8010	1394	1120336799440200	29341	14460	4	0	0
8011	1394	1121776799440200	29343	14461	6	0	0
8012	1394	1121776823440200	29343	14461	7	0	0
8013	1394	1123216823440200	29346	14463	3	0	0
8016	1394	1124656835440200	29390	14490	4	0	0
8017	1394	1124656848440200	29390	14490	5	0	0
8019	1394	1126096848440200	29396	14493	3	0	0
8020	1394	1126096860440200	29396	14493	4	0	0
8022	1394	1127536892440200	29425	14507	6	0	0
8024	1394	1128976892440200	29471	14534	3	0	0
8025	1394	1128976904440200	29430	14510	4	0	\N
8027	1394	1130416904440200	29483	14538	3	0	\N
8028	1394	1130416904440200	29492	14543	2	0	\N
8029	1394	1130416904440200	29500	14547	2	0	\N
8031	1394	1130416915440200	29492	14543	3	0	\N
8032	1394	1130416915440200	29500	14547	3	0	\N
8033	1394	1130416916440200	29483	14538	4	0	\N
8037	1394	1133296939440200	29520	14559	2	0	\N
8039	1394	1133296941440200	29520	14559	3	0	\N
8041	1394	1134736951440200	29548	14568	7	0	\N
8044	1394	1134736976440200	29548	14568	8	0	\N
8050	1394	1139056999440200	29621	14608	6	0	\N
8051	1394	1139056999440200	29625	14610	13	0	\N
8053	1394	1139057023440200	29621	14608	7	0	\N
8054	1394	1139057048440200	29625	14610	14	0	\N
8063	1394	1146257067565200	29694	14647	6	0	\N
8065	1394	1146257082565200	29694	14647	7	0	\N
8070	1394	1149137148565200	29727	14656	9	0	\N
8071	1394	1149137166565200	29727	14656	10	0	\N
8080	1394	1154897286565200	29776	14676	14	0	\N
8083	1394	1154897309565200	29776	14676	15	0	\N
8084	1394	1156337300565200	29819	14693	19	0	\N
8086	1394	1156337328565200	29819	14693	20	0	\N
8088	1394	1157777336565200	29850	14711	9	0	\N
8090	1394	1157777354564994	29850	14711	11	0	\N
8094	1394	1159217413565200	29879	14725	2	0	\N
8095	1394	1160657402565200	29886	14728	9	0	\N
8096	1394	1160657402565200	29888	14729	10	0	\N
8098	1394	1160657413565200	29879	14725	11	0	\N
8099	1394	1160657420565200	29886	14728	10	0	\N
8100	1394	1160657421170200	29879	14725	15	0	\N
8101	1394	1160657421565200	29888	14729	11	0	\N
8103	1394	1162097421565199	29958	14755	6	0	\N
8104	1394	1162097421565200	29906	14735	11	0	\N
8105	1394	1162097421565200	29919	14740	9	0	\N
8106	1394	1162097421565200	29923	14741	8	0	\N
8108	1394	1162097436530199	29958	14755	8	0	\N
8109	1394	1162097438565200	29923	14741	9	0	\N
8110	1394	1162097439565200	29919	14740	10	0	\N
8111	1394	1162097441565200	29906	14735	12	0	\N
8113	1394	1163537459565200	29980	14764	10	0	\N
8116	1394	1163537478565191	29980	14764	11	0	\N
8119	1394	1166417495299216	30051	14795	17	0	\N
8122	1394	1166417530153958	30051	14795	21	0	\N
8123	1394	1167857512299216	30074	14808	19	0	\N
8126	1394	1167857549299216	30074	14808	20	0	\N
8129	1394	1169297599299216	30210	14858	19	0	\N
8130	1394	1170737553299216	30144	14832	10	0	\N
8132	1394	1170737572299216	30144	14832	11	0	\N
8134	1394	1170737599299216	30210	14858	34	0	\N
8135	1394	1170737611923803	30210	14858	38	0	\N
8136	1394	1172177575299216	30252	14874	9	0	\N
8138	1394	1172177593299216	30252	14874	10	0	\N
8140	1394	1173617610803869	30282	14890	5	0	\N
8142	1394	1173617624803869	30282	14890	6	0	\N
8144	1395	100000001	27183	13445	8	0	\N
8145	1395	200000024	15601	7942	3	0	\N
8146	1395	272999977	16682	8474	9	0	\N
8147	1395	66000028400000	25895	12799	12	0	\N
8148	1395	57868010193533700	14373	7332	0	0	\N
8149	1395	57868010193533700	14397	7347	2	0	\N
8151	1395	57868010204533700	14397	7347	3	0	\N
8159	1395	57870890296533700	14487	7392	4	0	\N
8153	1395	57868730249533700	14413	7353	6	0	0
8154	1395	57868730273533700	14413	7353	7	0	0
8155	1395	57869450273533700	14419	7356	1	0	0
8156	1395	57869450283533700	14419	7356	2	0	0
8157	1395	57870170283533700	14457	7380	4	0	0
8160	1395	57870890296533700	14494	7395	4	0	0
8026	1394	1128976904440200	29471	14534	4	0	0
8030	1394	1130416904440200	29505	14551	3	0	0
8034	1394	1130416916440200	29505	14551	4	0	0
8035	1394	1131856916440200	29506	14552	5	0	0
8038	1394	1133296939440200	29545	14567	3	0	0
8040	1394	1133296951440200	29545	14567	4	0	0
8042	1394	1134736951440200	29558	14572	3	0	0
8043	1394	1134736963440200	29558	14572	4	0	0
8046	1394	1136176975440200	29583	14588	4	0	0
8047	1394	1136176985440200	29597	14594	1	0	0
8048	1394	1137616985440200	29597	14594	7	0	0
8049	1394	1137616999440200	29597	14594	8	0	0
8052	1394	1139056999440200	29630	14612	0	0	0
8056	1394	1140497011440200	29635	14615	4	0	0
8057	1394	1141937011440200	29639	14616	5	0	0
8058	1394	1141937025440200	29639	14616	6	0	0
8059	1394	1143377025440200	29646	14620	5	0	0
8060	1394	1143377039440200	29646	14620	6	0	0
8062	1394	1144817067565200	29675	14637	19	0	0
8064	1394	1146257067565200	29709	14650	30	0	0
8066	1394	1146257124565200	29709	14650	31	0	0
8067	1394	1147697124565200	29717	14652	15	0	0
8069	1394	1147697183565200	29739	14659	8	0	0
8072	1394	1149137183565200	29739	14659	38	0	0
8073	1394	1149137212565200	29739	14659	39	0	0
8074	1394	1150577212565200	29740	14660	9	0	0
8075	1394	1150577230565200	29740	14660	10	0	0
8077	1394	1152017264565200	29742	14661	17	0	0
8078	1394	1153457264565200	29766	14671	13	0	0
8079	1394	1153457286565200	29766	14671	14	0	0
8081	1394	1154897286565200	29808	14688	5	0	0
8082	1394	1154897300565200	29808	14688	6	0	0
8087	1394	1156337336565200	29840	14705	28	0	0
8089	1394	1157777336565200	29868	14721	10	0	0
8091	1394	1157777364565200	29868	14721	11	0	0
8092	1394	1159217364565200	29870	14722	20	0	0
8097	1394	1160657402565200	29895	14731	10	0	0
8102	1394	1160657421565200	29895	14731	11	0	0
8107	1394	1162097421565200	29978	14762	20	0	0
8112	1394	1162097459565200	29978	14762	21	0	0
8114	1394	1163537459565200	30012	14779	9	0	0
8117	1394	1164977477299216	30014	14781	9	0	0
8118	1394	1164977495299216	30014	14781	10	0	0
8120	1394	1166417495299216	30060	14799	8	0	0
8121	1394	1166417512299216	30060	14799	9	0	0
8124	1394	1167857512299216	30127	14826	8	0	0
8127	1394	1169297529299216	30134	14828	15	0	0
8128	1394	1169297553299216	30134	14828	16	0	0
8131	1394	1170737553299216	30228	14863	11	0	0
8133	1394	1170737575299216	30228	14863	12	0	0
8139	1394	1172177610803869	30257	14876	22	0	0
8141	1394	1173617610803869	30297	14893	5	0	0
8143	1394	1173617624803869	30297	14893	6	0	0
8161	1395	57870890309533700	14487	7392	5	0	\N
8165	1395	57872330333533700	14527	7410	2	0	\N
8167	1395	57872330344533700	14527	7410	3	0	\N
8173	1395	57874490377533700	14578	7432	2	0	\N
8175	1395	57874490388533700	14578	7432	3	0	\N
8177	1395	57875210389533700	14612	7450	3	0	\N
8180	1395	57875210401533700	14612	7450	4	0	\N
8181	1395	57875930391533700	14651	7467	3	0	\N
8182	1395	57875930391533700	14658	7468	3	0	\N
8184	1395	57875930403533700	14651	7467	4	0	\N
8185	1395	57875930403533700	14658	7468	4	0	\N
8188	1395	57876650403533700	15101	7471	0	0	\N
8191	1395	57877370414533700	15102	7484	0	0	\N
8193	1395	57878090436533700	14733	7500	8	0	\N
8196	1395	57878090480533700	14733	7500	9	0	\N
8199	1395	57879530480533700	14825	7556	4	0	\N
8202	1395	57879530502533700	14825	7556	5	0	\N
8203	1395	57880250491533700	14867	7575	2	0	\N
8204	1395	57880250491533700	14875	7577	2	0	\N
8206	1395	57880250502533700	14867	7575	3	0	\N
8207	1395	57880250502533700	14875	7577	3	0	\N
8209	1395	57880970503533700	14889	7587	4	0	\N
8212	1395	57880970516533700	14889	7587	5	0	\N
8215	1395	57882410526533700	14929	7608	1	0	\N
8216	1395	57882410526533700	14938	7609	5	0	\N
8217	1395	57882410526533700	14940	7610	2	0	\N
8219	1395	57882410536533700	14929	7608	2	0	\N
8220	1395	57882410537533700	14940	7610	3	0	\N
8222	1395	57882410549533700	14938	7609	6	0	\N
8231	1395	57885290603533700	15042	7663	1	0	\N
8233	1395	57886010603533700	15042	7663	4	0	\N
8234	1395	57886010605533700	15042	7663	5	0	\N
8238	1395	57887450635533700	15092	7690	0	0	\N
8243	1395	57888890666533700	15168	7731	4	0	\N
8244	1395	57888890666533700	15189	7739	11	0	\N
8247	1395	57888890679533700	15168	7731	5	0	\N
8248	1395	57888890731533700	15189	7739	12	0	\N
8249	1395	57889610677533700	15199	7745	3	0	\N
8250	1395	57889610677533700	15201	7746	2	0	\N
8251	1395	57889610677533700	15208	7748	4	0	\N
8252	1395	57889610677533700	15232	7759	3	0	\N
8254	1395	57889610688533700	15201	7746	3	0	\N
8255	1395	57889610689533700	15199	7745	4	0	\N
8256	1395	57889610689533700	15232	7759	4	0	\N
8258	1395	57889610699533700	15208	7748	5	0	\N
8259	1395	57890330689533700	15261	7774	3	0	\N
8260	1395	57890330689533700	15269	7777	5	0	\N
8261	1395	57890330689533700	15285	7787	10	0	\N
8264	1395	57890330701533700	15261	7774	4	0	\N
8265	1395	57890330712533700	15269	7777	6	0	\N
8266	1395	57890330735533700	15285	7787	11	0	\N
8267	1395	57891050700533700	15300	7797	0	0	\N
8269	1395	57891050700533700	15877	7795	0	0	\N
8271	1395	57891770735533700	15309	7800	3	0	\N
8272	1395	57891770735533700	15343	7820	2	0	\N
8274	1395	57891770735533700	15882	7811	0	0	\N
8275	1395	57891770746533700	15343	7820	3	0	\N
8277	1395	57891770747533700	15309	7800	4	0	\N
8284	1395	57894650801533700	15442	7864	2	0	\N
8286	1395	57894650812533700	15442	7864	3	0	\N
8292	1395	57896810858533700	15468	7876	1	0	\N
8294	1395	57896810868533700	15468	7876	2	0	\N
8164	1395	57871610333533700	14513	7403	7	0	0
8166	1395	57872330333533700	14536	7413	2	0	0
8168	1395	57872330344533700	14536	7413	3	0	0
8169	1395	57873050344533700	14538	7415	4	0	0
8170	1395	57873050366533700	14538	7415	5	0	0
8172	1395	57873770377533700	14544	7419	3	0	0
8174	1395	57874490377533700	14604	7445	3	0	0
8176	1395	57874490389533700	14604	7445	4	0	0
8178	1395	57875210389533700	14643	7462	2	0	0
8179	1395	57875210391533700	14643	7462	3	0	0
8186	1395	57875930403533700	14664	7470	4	0	0
8187	1395	57876650403533700	14693	7482	2	0	0
8189	1395	57876650414533700	14693	7482	3	0	0
8190	1395	57877370414533700	14703	7486	4	0	0
8194	1395	57878090436533700	14771	7523	2	0	0
8195	1395	57878090447533700	14771	7523	3	0	0
8197	1395	57878810447533700	14793	7536	6	0	0
8198	1395	57878810480533700	14793	7536	7	0	0
8200	1395	57879530480533700	14853	7570	2	0	0
8205	1395	57880250491533700	14884	7583	3	0	0
8208	1395	57880250503533700	14884	7583	4	0	0
8210	1395	57880970503533700	14907	7595	2	0	0
8211	1395	57880970514533700	14907	7595	3	0	0
8213	1395	57881690514533700	14928	7607	3	0	0
8218	1395	57882410526533700	14975	7630	4	0	0
8221	1395	57882410548533700	14975	7630	5	0	0
8223	1395	57883130548533700	14980	7632	2	0	0
8224	1395	57883130559533700	14980	7632	3	0	0
8226	1395	57883850570533700	15009	7646	3	0	0
8227	1395	57884570570533700	15028	7657	3	0	0
8228	1395	57884570582533700	15028	7657	4	0	0
8229	1395	57885290582533700	15029	7658	2	0	0
8230	1395	57885290593533700	15029	7658	3	0	0
8235	1395	57886010614533700	15056	7669	4	0	0
8236	1395	57886730614533700	15082	7682	3	0	0
8237	1395	57886730635533700	15082	7682	4	0	0
8239	1395	57887450635533700	15117	7705	1	0	0
8240	1395	57887450645533700	15117	7705	2	0	0
8242	1395	57888170666533700	15134	7715	4	0	0
8245	1395	57888890666533700	15192	7741	2	0	0
8246	1395	57888890677533700	15192	7741	3	0	0
8253	1395	57889610677533700	15242	7764	3	0	0
8262	1395	57890330689533700	15289	7790	2	0	0
8263	1395	57890330700533700	15289	7790	3	0	0
8268	1395	57891050700533700	15303	7798	8	0	0
8270	1395	57891050735533700	15303	7798	9	0	0
8273	1395	57891770735533700	15396	7841	2	0	0
8278	1395	57892490746533700	15405	7847	1	0	0
8279	1395	57892490756533700	15405	7847	2	0	0
8280	1395	57893210756533700	15411	7850	2	0	0
8281	1395	57893210767533700	15411	7850	3	0	0
8282	1395	57893930767533700	15432	7860	7	0	0
8285	1395	57894650801533700	15446	7866	2	0	0
8287	1395	57894650812533700	15446	7866	3	0	0
8288	1395	57895370812533700	15453	7870	7	0	0
8289	1395	57895370846533700	15453	7870	8	0	0
8291	1395	57896090858533700	15462	7874	4	0	0
8293	1395	57896810858533700	15484	7884	3	0	0
8295	1395	57896810870533700	15484	7884	4	0	0
8296	1395	57897530870533700	15519	7898	3	0	0
8298	1395	57898250882533700	15522	7900	6	0	\N
8301	1395	57898250916533700	15522	7900	7	0	\N
8302	1395	57898970894533700	15542	7911	4	0	\N
8304	1395	57898970916533700	15542	7911	5	0	\N
8309	1395	57900410945533705	15601	7942	2	0	\N
8310	1395	57900410945533706	15594	7938	2	0	\N
8312	1395	57900410947533706	15594	7938	3	0	\N
8314	1395	57901130956533706	15645	7961	4	0	\N
8316	1395	57901130969533706	15645	7961	5	0	\N
8320	1395	57902570992533706	15666	7975	6	0	\N
8321	1395	57902570992533706	15723	7995	3	0	\N
8323	1395	57902571004533706	15723	7995	4	0	\N
8324	1395	57902571016533706	15666	7975	7	0	\N
8326	1395	57903291017533706	15752	8011	7	0	\N
8329	1395	57903291042533706	15752	8011	8	0	\N
8336	1395	57906171068533706	15798	8039	3	0	\N
8338	1395	57906171080533706	15798	8039	4	0	\N
8344	1395	58031184088007706	15829	8053	5	0	\N
8345	1395	58031184088007706	15846	8060	3	0	\N
8347	1395	58031184100007706	15846	8060	4	0	\N
8348	1395	58031184120007706	15829	8053	6	0	\N
8350	1395	58031904125007706	15861	8066	7	0	\N
8351	1395	58031904125007706	15928	8098	2	0	\N
8352	1395	58031904125007706	15933	8100	3	0	\N
8353	1395	58031904125007706	15935	8101	3	0	\N
8355	1395	58031904136007706	15928	8098	3	0	\N
8356	1395	58031904137007706	15933	8100	4	0	\N
8357	1395	58031904137007706	15935	8101	4	0	\N
8359	1395	58031904150007706	15861	8066	8	0	\N
8360	1395	58032624137007706	15939	8103	3	0	\N
8361	1395	58032624137007706	15947	8107	3	0	\N
8362	1395	58032624137007706	15968	8117	6	0	\N
8364	1395	58032624149007706	15939	8103	4	0	\N
8365	1395	58032624149007706	15947	8107	4	0	\N
8367	1395	58032624161007706	15968	8117	7	0	\N
8368	1395	58033344149007706	16039	8157	4	0	\N
8370	1395	58033344162007706	16039	8157	5	0	\N
8374	1395	58034064210007706	16138	8204	6	0	\N
8375	1395	58034784186007706	16124	8198	7	0	\N
8378	1395	58034784210007706	16138	8204	7	0	\N
8379	1395	58034784211007706	16124	8198	8	0	\N
8382	1395	58036224211007706	16158	8213	3	0	\N
8384	1395	58036224223007706	16158	8213	4	0	\N
8388	1395	58037664236007706	16205	8235	6	0	\N
8391	1395	58037664269007706	16205	8235	7	0	\N
8392	1395	58038384247007706	16259	8263	3	0	\N
8394	1395	58038384259007706	16259	8263	4	0	\N
8398	1395	58039824284007706	16330	8300	21	0	\N
8401	1395	58039824458007706	16330	8300	22	0	\N
8404	1395	58041264332007706	16396	8340	3	0	\N
8406	1395	58041264344007706	16396	8340	4	0	\N
8408	1395	58041984344007706	16412	8349	4	0	\N
8410	1395	58041984357007706	16412	8349	5	0	\N
8412	1395	58042704366007706	16430	8355	4	0	\N
8415	1395	58042704379007706	16430	8355	5	0	\N
8418	1395	58044144390007706	16522	8403	4	0	\N
8420	1395	58044144403007706	16522	8403	5	0	\N
8422	1395	58044864412007706	16572	8423	8	0	\N
8423	1395	58044864412007706	16605	8436	3	0	\N
8424	1395	58044864412007706	16634	8450	4	0	\N
8426	1395	58044864424007706	16605	8436	4	0	\N
8428	1395	58044864425007706	16634	8450	5	0	\N
8429	1395	58044864447007706	16572	8423	9	0	\N
8300	1395	57898250894533700	15531	7904	4	0	0
8303	1395	57898970894533700	15547	7914	5	0	0
8305	1395	57898970917533700	15547	7914	6	0	0
8306	1395	57898970927533700	15551	7916	1	0	0
8307	1395	57899690927533700	15551	7916	9	0	0
8311	1395	57900410945533706	15613	7947	2	0	0
8313	1395	57900410956533706	15613	7947	3	0	0
8315	1395	57901130956533706	15647	7962	6	0	0
8317	1395	57901130980533706	15647	7962	7	0	0
8318	1395	57901850980533706	15652	7965	3	0	0
8322	1395	57902570992533706	15741	8005	7	0	0
8325	1395	57902571017533706	15741	8005	8	0	0
8327	1395	57903291017533706	15764	8017	3	0	0
8328	1395	57903291029533706	15764	8017	4	0	0
8331	1395	57904011041533706	15781	8027	4	0	0
8332	1395	57904731041533706	15786	8030	4	0	0
8333	1395	57904731054533706	15786	8030	5	0	0
8334	1395	57905451054533706	15790	8033	5	0	0
8335	1395	57905451068533706	15790	8033	6	0	0
8339	1395	57906171082533706	15802	8043	6	0	0
8340	1395	58029743989007706	15818	8050	5	0	0
8341	1395	58029744021007706	15818	8050	6	0	0
8342	1395	58030464021007706	15820	8051	13	0	0
8343	1395	58030464088007706	15820	8051	14	0	0
8349	1395	58031184125007706	15848	8061	11	0	0
8354	1395	58031904125007706	15938	8102	3	0	0
8358	1395	58031904137007706	15938	8102	4	0	0
8363	1395	58032624137007706	15993	8131	3	0	0
8369	1395	58033344149007706	16092	8179	7	0	0
8371	1395	58033344174007706	16092	8179	8	0	0
8372	1395	58034064174007706	16093	8180	3	0	0
8373	1395	58034064186007706	16093	8180	4	0	0
8376	1395	58034784186007706	16150	8210	4	0	0
8380	1395	58035504199007706	16152	8211	3	0	0
8381	1395	58035504211007706	16152	8211	4	0	0
8383	1395	58036224211007706	16162	8214	4	0	0
8385	1395	58036224224007706	16162	8214	5	0	0
8386	1395	58036944224007706	16166	8218	3	0	0
8389	1395	58037664236007706	16231	8251	2	0	0
8390	1395	58037664247007706	16231	8251	3	0	0
8393	1395	58038384247007706	16268	8268	7	0	0
8395	1395	58038384272007706	16268	8268	8	0	0
8397	1395	58039104284007706	16307	8286	4	0	0
8399	1395	58039824284007706	16359	8320	6	0	0
8400	1395	58039824308007706	16359	8320	7	0	0
8402	1395	58040544308007706	16380	8331	6	0	0
8403	1395	58040544332007706	16380	8331	7	0	0
8407	1395	58041264344007706	16403	8344	4	0	0
8409	1395	58041984344007706	16419	8351	4	0	0
8411	1395	58041984366007706	16419	8351	5	0	0
8413	1395	58042704366007706	16450	8367	3	0	0
8414	1395	58042704378007706	16450	8367	4	0	0
8417	1395	58043424390007706	16477	8380	4	0	0
8419	1395	58044144390007706	16567	8422	4	0	0
8421	1395	58044144412007706	16567	8422	5	0	0
8425	1395	58044864412007706	16637	8452	3	0	0
8430	1395	58045584424007706	16648	8459	3	0	0
8431	1395	58045584436007706	16648	8459	4	0	0
8432	1395	58046304436007706	16670	8468	3	0	0
8434	1395	58046304471007706	16682	8474	5	0	\N
8435	1395	58047024448007706	16678	8471	3	0	\N
8437	1395	58047024460007706	16678	8471	4	0	\N
8438	1395	58047024471007706	16682	8474	8	0	\N
8442	1395	58048464486007706	16727	8495	5	0	\N
8443	1395	58048464486007706	16746	8502	10	0	\N
8444	1395	58048464486007706	16754	8505	3	0	\N
8445	1395	58048464486007706	16759	8507	3	0	\N
8446	1395	58048464486007706	16779	8517	3	0	\N
8447	1395	58048464486007706	16782	8519	7	0	\N
8449	1395	58048464489007706	16759	8507	4	0	\N
8450	1395	58048464498007706	16754	8505	4	0	\N
8451	1395	58048464498007706	16779	8517	4	0	\N
8453	1395	58048464509007706	16727	8495	6	0	\N
8454	1395	58048464511007706	16782	8519	8	0	\N
8455	1395	58048464523007706	16746	8502	11	0	\N
8460	1395	58050624523007706	16851	8551	3	0	\N
8463	1395	58050624535007706	16851	8551	4	0	\N
8468	1395	58052784583007706	16894	8568	4	0	\N
8471	1395	58052784596007706	16894	8568	5	0	\N
8473	1395	58053504595007706	16945	8589	2	0	\N
8474	1395	58053504606007706	16945	8589	3	0	\N
8477	1395	58054224607007706	17030	8623	5	0	\N
8478	1395	58054224607007706	17038	8627	3	0	\N
8480	1395	58054224619007706	17038	8627	4	0	\N
8482	1395	58054224621007706	17030	8623	6	0	\N
8490	1395	58057104678007706	17176	8706	4	0	\N
8491	1395	58057104678007706	17187	8709	0	0	\N
8492	1395	58057104678007706	17217	8723	7	0	\N
8493	1395	58057104691007706	17176	8706	5	0	\N
8495	1395	58057104703007706	17217	8723	8	0	\N
8502	1395	58059264727007706	17374	8799	3	0	\N
8503	1395	58059264727007706	17379	8802	6	0	\N
8504	1395	58059264727007706	17382	8804	6	0	\N
8506	1395	58059264739007706	17374	8799	4	0	\N
8508	1395	58059264751007706	17379	8802	7	0	\N
8509	1395	58059264751007706	17382	8804	7	0	\N
8514	1395	58060704795007706	17440	8833	4	0	\N
8515	1395	58061424773007706	17408	8818	6	0	\N
8516	1395	58061424773007706	17415	8821	2	0	\N
8517	1395	58061424773007706	17437	8832	3	0	\N
8519	1395	58061424775007706	17415	8821	3	0	\N
8520	1395	58061424795007706	17440	8833	7	0	\N
8521	1395	58061424797007706	17408	8818	7	0	\N
8522	1395	58061424797007706	17440	8833	8	0	\N
8524	1395	58061424884007706	17437	8832	4	0	\N
8531	1395	58064304883007706	17529	8876	5	0	\N
8532	1395	58064304883007706	17544	8883	5	0	\N
8533	1395	58064304883007706	17585	8897	9	0	\N
8534	1395	58064304883007706	17589	8899	4	0	\N
8535	1395	58064304883007706	17614	8908	3	0	\N
8537	1395	58064304895007706	17614	8908	4	0	\N
8538	1395	58064304897007706	17529	8876	6	0	\N
8539	1395	58064304905007706	17589	8899	5	0	\N
8540	1395	58064304906007706	17544	8883	6	0	\N
8542	1395	58064304916007706	17649	8923	1	0	\N
8543	1395	58064304919007706	17585	8897	10	0	\N
8545	1395	58065024916007706	17649	8923	3	0	\N
8546	1395	58065024917007706	17649	8923	4	0	\N
8558	1395	58069344994007706	17770	8978	15	0	\N
8559	1395	58069344994007706	17783	8986	3	0	\N
8562	1395	58069345006007706	17783	8986	4	0	\N
8563	1395	58069345045007706	17770	8978	16	0	\N
8566	1395	58070785033007706	17822	9000	4	0	\N
8439	1395	58047024473007706	16692	8478	8	0	0
8440	1395	58047744473007706	16701	8486	4	0	0
8441	1395	58047744486007706	16701	8486	5	0	0
8448	1395	58048464486007706	16802	8528	3	0	0
8452	1395	58048464498007706	16802	8528	4	0	0
8457	1395	58049184512007706	16818	8536	6	0	0
8458	1395	58049904512007706	16819	8537	2	0	0
8459	1395	58049904523007706	16819	8537	3	0	0
8461	1395	58050624523007706	16872	8557	2	0	0
8462	1395	58050624534007706	16872	8557	3	0	0
8465	1395	58051344570007706	16876	8559	10	0	0
8466	1395	58052064570007706	16877	8560	4	0	0
8467	1395	58052064583007706	16877	8560	5	0	0
8469	1395	58052784583007706	16940	8587	3	0	0
8472	1395	58052784606007706	17016	8620	2	0	0
8475	1395	58053504606007706	17016	8620	4	0	0
8476	1395	58053504607007706	17016	8620	5	0	0
8479	1395	58054224607007706	17048	8634	3	0	0
8481	1395	58054224619007706	17048	8634	4	0	0
8484	1395	58054944654007706	17079	8651	9	0	0
8485	1395	58055664654007706	17084	8655	3	0	0
8486	1395	58055664666007706	17084	8655	4	0	0
8487	1395	58056384666007706	17165	8701	3	0	0
8488	1395	58056384678007706	17165	8701	4	0	0
8494	1395	58057104698007706	17231	8730	8	0	0
8496	1395	58057104703007706	17231	8730	9	0	0
8497	1395	58057104714007706	17281	8752	2	0	0
8498	1395	58057824714007706	17281	8752	4	0	0
8500	1395	58058544715007706	17337	8783	3	0	0
8501	1395	58058544727007706	17337	8783	4	0	0
8505	1395	58059264727007706	17395	8810	5	0	0
8507	1395	58059264750007706	17395	8810	6	0	0
8510	1395	58059984750007706	17396	8811	2	0	0
8512	1395	58060704761007706	17403	8815	3	0	0
8513	1395	58060704773007706	17403	8815	4	0	0
8518	1395	58061424773007706	17446	8835	6	0	0
8523	1395	58061424797007706	17446	8835	7	0	0
8525	1395	58062144797007706	17475	8847	3	0	0
8527	1395	58062864809007706	17492	8854	8	0	0
8528	1395	58062864871007706	17492	8854	9	0	0
8529	1395	58063584871007706	17527	8875	3	0	0
8530	1395	58063584883007706	17527	8875	4	0	0
8541	1395	58064304906007706	17643	8920	6	0	0
8544	1395	58065024906007706	17660	8927	2	0	0
8547	1395	58065024917007706	17660	8927	3	0	0
8548	1395	58065744917007706	17668	8931	2	0	0
8549	1395	58065744928007706	17668	8931	3	0	0
8551	1395	58066464939007706	17672	8933	3	0	0
8552	1395	58067184939007706	17680	8937	2	0	0
8553	1395	58067184950007706	17680	8937	3	0	0
8554	1395	58067904950007706	17692	8942	2	0	0
8555	1395	58067904961007706	17692	8942	3	0	0
8557	1395	58068624994007706	17697	8946	7	0	0
8560	1395	58069344994007706	17796	8989	2	0	0
8561	1395	58069344996007706	17796	8989	3	0	0
8564	1395	58070064996007706	17809	8994	10	0	0
8567	1395	58070785033007706	17823	9001	3	0	0
8568	1395	58070785045007706	17823	9001	4	0	0
8569	1395	58070785046007706	17822	9000	5	0	\N
8573	1395	58072225058007706	17893	9029	3	0	\N
8574	1395	58072225058007706	17911	9035	6	0	\N
8575	1395	58072225070007706	17893	9029	4	0	\N
8577	1395	58072225073007706	17911	9035	7	0	\N
8580	1395	58073665084007706	17990	9076	5	0	\N
8583	1395	58073665107007706	17990	9076	6	0	\N
8584	1395	58074385095007706	18025	9094	2	0	\N
8586	1395	58074385106007706	18025	9094	3	0	\N
8598	1395	58078705163007706	18113	9136	2	0	\N
8600	1395	58078705174007706	18113	9136	3	0	\N
8604	1395	58080145208007706	18157	9154	7	0	\N
8607	1395	58080145233007706	18157	9154	8	0	\N
8610	1395	58081585243007706	18181	9168	3	0	\N
8612	1395	58081585255007706	18181	9168	4	0	\N
8613	1395	58082305243007706	18206	9173	6	0	\N
8616	1395	58082305261007706	18206	9173	7	0	\N
8623	1395	58085185302007706	18303	9220	3	0	\N
8625	1395	58085185314007706	18303	9220	4	0	\N
8633	1395	58088065359007706	18391	9269	2	0	\N
8635	1395	58088065370007706	18391	9269	3	0	\N
8639	1395	58089505383007706	18433	9293	7	0	\N
8640	1395	58089505383007706	18437	9294	3	0	\N
8642	1395	58089505395007706	18437	9294	4	0	\N
8644	1395	58089505408007706	18433	9293	8	0	\N
8645	1395	58090225395007706	18451	9300	3	0	\N
8646	1395	58090225395007706	18458	9302	4	0	\N
8647	1395	58090225395007706	18513	9324	3	0	\N
8649	1395	58090225407007706	18451	9300	4	0	\N
8650	1395	58090225408007706	18458	9302	5	0	\N
8652	1395	58090225456007706	18513	9324	4	0	\N
8653	1395	58090945420007706	18541	9341	3	0	\N
8654	1395	58090945420007706	18555	9350	13	0	\N
8655	1395	58090945420007706	18558	9352	4	0	\N
8658	1395	58090945432007706	18541	9341	4	0	\N
8659	1395	58090945469007706	18555	9350	14	0	\N
8660	1395	58090945532007706	18558	9352	5	0	\N
8678	1395	58097425743007706	18676	9408	3	0	\N
8680	1395	58097425764007706	18676	9408	4	0	\N
8686	1395	58099585799007706	18737	9441	7	0	\N
8689	1395	58099585833007706	18737	9441	8	0	\N
8692	1395	58101025821007706	18764	9457	3	0	\N
8693	1395	58101025821007706	18798	9472	3	0	\N
8695	1395	58101025833007706	18764	9457	4	0	\N
8696	1395	58101025833007706	18798	9472	4	0	\N
8698	1395	58101745833007706	18825	9486	2	0	\N
8700	1395	58101745844007706	18825	9486	3	0	\N
8572	1395	58071505071007706	17926	9043	4	0	0
8576	1395	58072225071007706	17926	9043	5	0	0
8578	1395	58072945071007706	17933	9046	4	0	0
8579	1395	58072945084007706	17933	9046	5	0	0
8581	1395	58073665084007706	17998	9080	2	0	0
8585	1395	58074385095007706	18037	9099	3	0	0
8587	1395	58074385107007706	18037	9099	4	0	0
8588	1395	58075105107007706	18038	9100	2	0	0
8589	1395	58075105118007706	18038	9100	3	0	0
8590	1395	58075825118007706	18047	9104	2	0	0
8592	1395	58076545129007706	18080	9118	3	0	0
8593	1395	58076545141007706	18080	9118	4	0	0
8594	1395	58077265141007706	18090	9122	1	0	0
8595	1395	58077265151007706	18090	9122	2	0	0
8597	1395	58077985163007706	18097	9126	4	0	0
8599	1395	58078705163007706	18125	9140	5	0	0
8601	1395	58078705186007706	18125	9140	6	0	0
8602	1395	58079425186007706	18129	9142	4	0	0
8603	1395	58079425208007706	18129	9142	5	0	0
8606	1395	58080145220007706	18167	9160	4	0	0
8608	1395	58080865220007706	18175	9165	5	0	0
8609	1395	58080865243007706	18175	9165	6	0	0
8611	1395	58081585243007706	18184	9169	0	0	0
8614	1395	58082305243007706	18229	9182	3	0	0
8617	1395	58083025255007706	18271	9205	5	0	0
8618	1395	58083025278007706	18271	9205	6	0	0
8619	1395	58083745278007706	18276	9208	3	0	0
8620	1395	58083745290007706	18276	9208	4	0	0
8622	1395	58084465302007706	18285	9214	4	0	0
8624	1395	58085185302007706	18336	9238	5	0	0
8626	1395	58085185325007706	18336	9238	6	0	0
8627	1395	58085905325007706	18351	9246	2	0	0
8628	1395	58085905336007706	18351	9246	3	0	0
8630	1395	58086625347007706	18354	9249	3	0	0
8631	1395	58087345347007706	18376	9261	3	0	0
8632	1395	58087345359007706	18376	9261	4	0	0
8634	1395	58088065359007706	18410	9282	3	0	0
8636	1395	58088065371007706	18410	9282	4	0	0
8638	1395	58088785383007706	18430	9292	4	0	0
8641	1395	58089505383007706	18444	9297	3	0	0
8643	1395	58089505395007706	18444	9297	4	0	0
8648	1395	58090225395007706	18537	9339	7	0	0
8656	1395	58090945420007706	18578	9361	2	0	0
8657	1395	58090945431007706	18578	9361	3	0	0
8661	1395	58091665431007706	18587	9367	2	0	0
8662	1395	58091665442007706	18587	9367	3	0	0
8663	1395	58091665463007706	18598	9370	3	0	0
8665	1395	58092385465007706	18598	9370	7	0	0
8666	1395	58093105465007706	18604	9374	3	0	0
8667	1395	58093105477007706	18604	9374	4	0	0
8668	1395	58093825477007706	18606	9375	2	0	0
8669	1395	58093825488007706	18606	9375	3	0	0
8671	1395	58094545498007706	18617	9380	2	0	0
8672	1395	58095265498007706	18626	9386	2	0	0
8673	1395	58095265509007706	18626	9386	3	0	0
8674	1395	58095985509007706	18635	9390	5	0	0
8676	1395	58096705532007706	18639	9393	4	0	0
8677	1395	58096705743007706	18639	9393	5	0	0
8679	1395	58097425743007706	18682	9412	6	0	0
8681	1395	58097425776007706	18682	9412	7	0	0
8682	1395	58098145776007706	18706	9422	2	0	0
8684	1395	58098865787007706	18718	9430	3	0	0
8685	1395	58098865799007706	18718	9430	4	0	0
8687	1395	58099585799007706	18749	9449	2	0	0
8688	1395	58099585810007706	18749	9449	3	0	0
8690	1395	58100305810007706	18758	9455	2	0	0
8694	1395	58101025821007706	18807	9478	3	0	0
8697	1395	58101025833007706	18807	9478	4	0	0
8699	1395	58101745833007706	18843	9499	3	0	0
8701	1395	58101745854007706	18843	9499	4	0	0
8703	1395	58102465864007706	18866	9513	2	0	0
8704	1395	58103185864007706	18871	9516	3	0	0
8708	1395	58104625895007706	18916	9541	2	0	\N
8711	1395	58104625906007706	18916	9541	3	0	\N
8712	1395	58105345905007706	18939	9554	2	0	\N
8715	1395	58105345916007706	18939	9554	3	0	\N
8718	1395	58106785946007706	19041	9596	0	0	\N
8723	1395	58108225968007706	19066	9616	2	0	\N
8724	1395	58108225968007706	19084	9627	8	0	\N
8725	1395	58108225968007706	19100	9634	6	0	\N
8726	1395	58108225968007706	19107	9638	6	0	\N
8729	1395	58108225992007706	19100	9634	7	0	\N
8730	1395	58108226001007706	19107	9638	7	0	\N
8731	1395	58108226030007706	19084	9627	9	0	\N
8732	1395	58108226078007706	19066	9616	3	0	\N
8738	1395	58110386014007706	19162	9667	3	0	\N
8739	1395	58110386026007706	19162	9667	4	0	\N
8742	1395	58111106140007706	19193	9684	3	0	\N
8744	1395	58111106152007706	19193	9684	4	0	\N
8748	1395	58111826211007706	19217	9695	7	0	\N
8749	1395	58112546177007706	19203	9688	6	0	\N
8750	1395	58112546177007706	19208	9691	3	0	\N
8751	1395	58112546177007706	19234	9698	3	0	\N
8753	1395	58112546189007706	19208	9691	4	0	\N
8754	1395	58112546189007706	19234	9698	4	0	\N
8755	1395	58112546201007706	19203	9688	7	0	\N
8757	1395	58112546211007706	19217	9695	11	0	\N
8758	1395	58112546214007706	19217	9695	12	0	\N
8761	1395	58113986214007706	19326	9746	11	0	\N
8762	1395	58113986214007706	19361	9761	4	0	\N
8764	1395	58113986227007706	19361	9761	5	0	\N
8766	1395	58113986351007706	19326	9746	12	0	\N
8781	1395	58119746327007706	19555	9849	4	0	\N
8784	1395	58119746340007706	19555	9849	5	0	\N
8797	1395	58124786687007706	19769	9953	3	0	\N
8799	1395	58124786699007706	19769	9953	4	0	\N
8813	1395	58129826893007706	19896	10021	4	0	\N
8815	1395	58129826906007706	19896	10021	5	0	\N
8817	1395	58130546906007706	19936	10040	2	0	\N
8818	1395	58130546906007706	19941	10041	3	0	\N
8820	1395	58130546917007706	19936	10040	3	0	\N
8821	1395	58130546918007706	19941	10041	4	0	\N
8823	1395	58131266918007706	19963	10053	3	0	\N
8824	1395	58131266918007706	19975	10058	7	0	\N
8825	1395	58131266918007706	19982	10063	3	0	\N
8826	1395	58131266918007706	20014	10075	3	0	\N
8828	1395	58131266921007706	19982	10063	4	0	\N
8829	1395	58131266930007706	19963	10053	4	0	\N
8830	1395	58131266930007706	20014	10075	4	0	\N
8832	1395	58131266943007706	19975	10058	8	0	\N
8839	1395	58134146968007706	20073	10103	4	0	\N
8707	1395	58103905895007706	18877	9518	2	0	0
8709	1395	58104625895007706	18917	9542	1	0	0
8710	1395	58104625905007706	18917	9542	2	0	0
8713	1395	58105345905007706	18940	9555	1	0	0
8714	1395	58105345915007706	18940	9555	2	0	0
8717	1395	58106065946007706	18942	9556	5	0	0
8719	1395	58106785946007706	19048	9607	2	0	0
8720	1395	58106785957007706	19048	9607	3	0	0
8721	1395	58107505957007706	19058	9612	2	0	0
8722	1395	58107505968007706	19058	9612	3	0	0
8728	1395	58108225980007706	19109	9639	4	0	0
8733	1395	58108945980007706	19122	9646	4	0	0
8734	1395	58108946002007706	19122	9646	5	0	0
8735	1395	58109666002007706	19147	9659	3	0	0
8737	1395	58109666139007706	19186	9680	8	0	0
8740	1395	58110386139007706	19186	9680	10	0	0
8741	1395	58110386140007706	19186	9680	11	0	0
8743	1395	58111106140007706	19196	9685	3	0	0
8745	1395	58111106152007706	19196	9685	4	0	0
8747	1395	58111826177007706	19197	9686	8	0	0
8752	1395	58112546177007706	19290	9726	7	0	0
8756	1395	58112546202007706	19290	9726	8	0	0
8759	1395	58113266202007706	19301	9732	3	0	0
8760	1395	58113266214007706	19301	9732	4	0	0
8765	1395	58113986228007706	19405	9779	6	0	0
8767	1395	58114706228007706	19413	9784	6	0	0
8768	1395	58114706252007706	19413	9784	7	0	0
8769	1395	58115426252007706	19416	9786	4	0	0
8771	1395	58116146265007706	19429	9792	3	0	0
8772	1395	58116146277007706	19429	9792	4	0	0
8773	1395	58116866277007706	19436	9796	3	0	0
8774	1395	58116866289007706	19436	9796	4	0	0
8775	1395	58117586289007706	19442	9799	4	0	0
8777	1395	58118306303007706	19462	9810	2	0	0
8778	1395	58118306314007706	19462	9810	3	0	0
8779	1395	58119026314007706	19502	9830	4	0	0
8780	1395	58119026327007706	19502	9830	5	0	0
8782	1395	58119746327007706	19605	9875	3	0	0
8785	1395	58120466339007706	19656	9900	3	0	0
8786	1395	58120466351007706	19656	9900	4	0	0
8787	1395	58121186351007706	19673	9909	18	0	0
8788	1395	58121186495007706	19673	9909	19	0	0
8790	1395	58121906639007706	19698	9918	19	0	0
8791	1395	58122626639007706	19705	9922	6	0	0
8792	1395	58122626663007706	19705	9922	7	0	0
8793	1395	58123346663007706	19747	9942	3	0	0
8794	1395	58123346675007706	19747	9942	4	0	0
8796	1395	58124066687007706	19756	9946	4	0	0
8798	1395	58124786687007706	19780	9960	7	0	0
8800	1395	58124786712007706	19780	9960	8	0	0
8801	1395	58125506712007706	19802	9972	4	0	0
8802	1395	58125506734007706	19802	9972	5	0	0
8804	1395	58126226746007706	19805	9974	4	0	0
8805	1395	58126946746007706	19811	9977	1	0	0
8806	1395	58126946756007706	19811	9977	2	0	0
8807	1395	58127666756007706	19818	9982	2	0	0
8809	1395	58128386767007706	19858	10003	4	0	0
8810	1395	58128386879007706	19858	10003	5	0	0
8811	1395	58129106879007706	19859	10004	5	0	0
8812	1395	58129106893007706	19859	10004	6	0	0
8814	1395	58129826893007706	19927	10036	4	0	0
8819	1395	58130546906007706	19946	10043	3	0	0
8822	1395	58130546918007706	19946	10043	4	0	0
8827	1395	58131266918007706	20018	10076	4	0	0
8831	1395	58131266931007706	20018	10076	5	0	0
8833	1395	58131986931007706	20033	10085	3	0	0
8835	1395	58132706943007706	20044	10090	4	0	0
8836	1395	58132706956007706	20044	10090	5	0	0
8837	1395	58133426956007706	20064	10101	3	0	0
8838	1395	58133426968007706	20064	10101	4	0	0
8841	1395	58134146981007706	20073	10103	5	0	\N
8843	1395	58134867131007706	20105	10119	9	0	\N
8846	1395	58134867194007706	20105	10119	10	0	\N
8847	1395	58135587153007706	20114	10126	7	0	\N
8848	1395	58135587153007706	20145	10139	5	0	\N
8849	1395	58135587153007706	20161	10149	9	0	\N
8852	1395	58135587196007706	20114	10126	8	0	\N
8853	1395	58135587207007706	20161	10149	10	0	\N
8854	1395	58135587285007706	20145	10139	6	0	\N
8867	1395	58140627290007706	20218	10181	7	0	\N
8868	1395	58140627290007706	20222	10182	10	0	\N
8869	1395	58140627290007706	20241	10191	4	0	\N
8871	1395	58140627312007706	20241	10191	5	0	\N
8872	1395	58140627315007706	20218	10181	8	0	\N
8873	1395	58140627327007706	20222	10182	11	0	\N
8875	1395	58141347333007706	20253	10201	13	0	\N
8876	1395	58141347333007706	20267	10207	3	0	\N
8877	1395	58141347333007706	20277	10212	6	0	\N
8879	1395	58141347345007706	20267	10207	4	0	\N
8880	1395	58141347357007706	20277	10212	7	0	\N
8882	1395	58141347382007706	20253	10201	14	0	\N
8887	1395	58143507406007706	20322	10236	4	0	\N
8889	1395	58143507419007706	20322	10236	5	0	\N
8891	1395	58144227429007706	20330	10238	4	0	\N
8893	1395	58144227442007706	20330	10238	5	0	\N
8898	1395	58145667465007706	20349	10250	3	0	\N
8901	1395	58145667477007706	20349	10250	4	0	\N
8906	1395	58147827499507701	20419	10287	6	0	\N
8909	1395	58147827523507701	20419	10287	7	0	\N
8912	1395	58149267524507701	20472	10310	4	0	\N
8915	1395	58149267537507701	20472	10310	5	0	\N
8918	1395	58150707548507701	20545	10344	3	0	\N
8920	1395	58150707560507701	20545	10344	4	0	\N
8926	1395	58152867608507701	20591	10358	3	0	\N
8928	1395	58152867620507701	20591	10358	4	0	\N
8939	1395	58156468083507701	20643	10389	3	0	\N
8940	1395	58156468083507701	20656	10393	4	0	\N
8942	1395	58156468095507701	20643	10389	4	0	\N
8944	1395	58156468096507701	20656	10393	5	0	\N
8947	1395	58157908240507701	20707	10414	2	0	\N
8948	1395	58157908240507701	20724	10420	10	0	\N
8949	1395	58157908240507701	20739	10426	10	0	\N
8950	1395	58157908240507701	20743	10428	6	0	\N
8951	1395	58157908240507701	20765	10437	7	0	\N
8953	1395	58157908251507701	20707	10414	3	0	\N
8955	1395	58157908277507701	20724	10420	11	0	\N
8956	1395	58157908282507701	20743	10428	7	0	\N
8957	1395	58157908304507701	20739	10426	11	0	\N
8958	1395	58157908391507701	20765	10437	8	0	\N
8964	1395	58160068328507701	21473	10485	0	0	\N
8966	1395	58160788370507701	20883	10498	4	0	\N
8968	1395	58160788370507701	21474	10498	0	0	\N
8970	1395	58160788392507701	20883	10498	5	0	\N
8973	1395	58162228392507701	20916	10514	5	0	\N
8974	1395	58162228392507701	20919	10515	2	0	\N
8976	1395	58162228392507701	21475	10513	0	0	\N
8845	1395	58134867153007706	20108	10120	5	0	0
8850	1395	58135587153007706	20170	10154	6	0	0
8851	1395	58135587177007706	20170	10154	7	0	0
8855	1395	58136307177007706	20173	10157	3	0	0
8856	1395	58136307189007706	20173	10157	4	0	0
8858	1395	58137027203007706	20175	10159	6	0	0
8859	1395	58137747203007706	20183	10163	10	0	0
8860	1395	58137747240007706	20183	10163	11	0	0
8861	1395	58138467240007706	20202	10175	3	0	0
8862	1395	58138467252007706	20202	10175	4	0	0
8864	1395	58139187264007706	20207	10177	4	0	0
8865	1395	58139907264007706	20213	10179	8	0	0
8866	1395	58139907290007706	20213	10179	9	0	0
8870	1395	58140627290007706	20242	10192	7	0	0
8878	1395	58141347333007706	20296	10218	9	0	0
8881	1395	58141347369007706	20296	10218	10	0	0
8883	1395	58142067369007706	20297	10219	7	0	0
8884	1395	58142067394007706	20297	10219	8	0	0
8885	1395	58142787394007706	20301	10222	3	0	0
8888	1395	58143507406007706	20327	10237	5	0	0
8890	1395	58143507429007706	20327	10237	6	0	0
8892	1395	58144227429007706	20335	10242	6	0	0
8894	1395	58144227453007706	20335	10242	7	0	0
8895	1395	58144947453007706	20346	10247	3	0	0
8897	1395	58144947475007706	20355	10252	1	0	0
8899	1395	58145667475007706	20355	10252	4	0	0
8900	1395	58145667475507701	20355	10252	5	0	0
8902	1395	58146387475507701	20365	10259	3	0	0
8904	1395	58147107487507701	20373	10264	3	0	0
8905	1395	58147107499507701	20373	10264	4	0	0
8907	1395	58147827499507701	20451	10299	3	0	0
8908	1395	58147827511507701	20451	10299	4	0	0
8910	1395	58148547511507701	20468	10307	4	0	0
8913	1395	58149267524507701	20530	10335	3	0	0
8914	1395	58149267536507701	20530	10335	4	0	0
8916	1395	58149987536507701	20539	10338	3	0	0
8917	1395	58149987548507701	20539	10338	4	0	0
8919	1395	58150707548507701	20555	10348	4	0	0
8922	1395	58151427561507701	20561	10350	3	0	0
8923	1395	58151427573507701	20561	10350	4	0	0
8924	1395	58152147573507701	20565	10351	8	0	0
8925	1395	58152147608507701	20565	10351	9	0	0
8929	1395	58152867621507701	20599	10362	5	0	0
8930	1395	58153587621507701	20614	10368	3	0	0
8931	1395	58153587633507701	20614	10368	4	0	0
8932	1395	58153588056507701	20630	10379	9	0	0
8933	1395	58154308056507701	20630	10379	13	0	0
8935	1395	58155028059507701	20634	10382	3	0	0
8936	1395	58155028071507701	20634	10382	4	0	0
8937	1395	58155748071507701	20639	10385	3	0	0
8938	1395	58155748083507701	20639	10385	4	0	0
8941	1395	58156468083507701	20689	10406	3	0	0
8945	1395	58157188095507701	20693	10408	8	0	0
8946	1395	58157188240507701	20693	10408	9	0	0
8952	1395	58157908240507701	20821	10466	2	0	0
8954	1395	58157908251507701	20821	10466	3	0	0
8960	1395	58158628263507701	20829	10470	4	0	0
8961	1395	58159348263507701	20854	10481	10	0	0
8962	1395	58159348328507701	20854	10481	11	0	0
8963	1395	58160068328507701	20862	10487	5	0	0
8965	1395	58160068370507701	20862	10487	6	0	0
8969	1395	58160788381507701	20896	10504	3	0	0
8971	1395	58161508381507701	20908	10509	2	0	0
8972	1395	58161508392507701	20908	10509	3	0	0
8975	1395	58162228392507701	20940	10529	4	0	0
8977	1395	58162228403507701	20919	10515	3	0	\N
8978	1395	58162228424507701	20916	10514	6	0	\N
8980	1395	58162948523507701	20945	10534	7	0	\N
8981	1395	58162948523507701	20950	10536	2	0	\N
8982	1395	58162948523507701	20982	10553	2	0	\N
8983	1395	58162948523507701	20983	10554	2	0	\N
8985	1395	58162948534507701	20950	10536	3	0	\N
8986	1395	58162948534507701	20982	10553	3	0	\N
8987	1395	58162948534507701	20983	10554	3	0	\N
8989	1395	58162948557507701	20945	10534	8	0	\N
8990	1395	58163668534507701	21004	10562	2	0	\N
8991	1395	58163668534507701	21025	10569	6	0	\N
8992	1395	58163668534507701	21047	10577	3	0	\N
8994	1395	58163668545507701	21004	10562	3	0	\N
8996	1395	58163668546507701	21047	10577	4	0	\N
8997	1395	58163668567507701	21025	10569	7	0	\N
8998	1395	58164388545507701	21062	10584	6	0	\N
8999	1395	58164388545507701	21074	10588	2	0	\N
9000	1395	58164388545507701	21080	10591	2	0	\N
9002	1395	58164388556507701	21074	10588	3	0	\N
9003	1395	58164388556507701	21080	10591	3	0	\N
9006	1395	58164388596507701	21062	10584	7	0	\N
9007	1395	58165108556507701	21132	10613	3	0	\N
9008	1395	58165108556507701	21135	10614	4	0	\N
9009	1395	58165108556507701	21143	10616	2	0	\N
9010	1395	58165108567507701	21143	10616	3	0	\N
9011	1395	58165108568507701	21132	10613	4	0	\N
9013	1395	58165108578507701	21135	10614	5	0	\N
9015	1395	58165828611507701	21162	10628	2	0	\N
9016	1395	58165828611507701	21180	10635	2	0	\N
9018	1395	58165828622507701	21162	10628	3	0	\N
9019	1395	58165828622507701	21180	10635	3	0	\N
9021	1395	58166548633507701	21185	10638	6	0	\N
9022	1395	58166548633507701	21213	10651	2	0	\N
9023	1395	58166548633507701	21229	10660	4	0	\N
9024	1395	58166548633507701	21289	10690	4	0	\N
9026	1395	58166548644507701	21213	10651	3	0	\N
9027	1395	58166548646507701	21289	10690	5	0	\N
9028	1395	58166548655507701	21229	10660	5	0	\N
9030	1395	58166548666507701	21185	10638	7	0	\N
9039	1395	58170148755507701	21425	10745	4	0	\N
9040	1395	58170148755507701	21441	10754	6	0	\N
9041	1395	58170148755507701	21446	10757	3	0	\N
9043	1395	58170148767507701	21446	10757	4	0	\N
9044	1395	58170148768507701	21425	10745	5	0	\N
9046	1395	58170148788507701	21441	10754	7	0	\N
9049	1395	58171588787507701	21512	10792	4	0	\N
9050	1395	58171588787507701	21517	10795	3	0	\N
9051	1395	58171588787507701	21521	10797	3	0	\N
9054	1395	58171588799507701	21517	10795	4	0	\N
9055	1395	58171588799507701	21521	10797	4	0	\N
9056	1395	58171588800507701	21512	10792	5	0	\N
9064	1395	58174468836957278	21599	10827	3	0	\N
9065	1395	58174468836957278	21611	10831	3	0	\N
9066	1395	58174468836957278	21622	10834	6	0	\N
9067	1395	58174468836957278	21648	10846	3	0	\N
9069	1395	58174468848957278	21599	10827	4	0	\N
9070	1395	58174468848957278	21611	10831	4	0	\N
9071	1395	58174468848957278	21648	10846	4	0	\N
9073	1395	58174468860957278	21622	10834	7	0	\N
9076	1395	58175908870957278	21725	10883	2	0	\N
9078	1395	58175908872957278	21725	10883	3	0	\N
9080	1395	58176628882957278	21761	10896	3	0	\N
9082	1395	58176628894957278	21761	10896	4	0	\N
9086	1395	58178068930957278	21802	10914	6	0	\N
9087	1395	58178068930957278	21813	10918	6	0	\N
9088	1395	58178068930957278	21823	10922	12	0	\N
9091	1395	58178068954957278	21802	10914	7	0	\N
9092	1395	58178068954957278	21813	10918	7	0	\N
9093	1395	58178068978957278	21823	10922	13	0	\N
9094	1395	58178788941957278	21839	10931	3	0	\N
9096	1395	58178788953957278	21839	10931	4	0	\N
9098	1395	58179508953957278	21883	10950	3	0	\N
9100	1395	58179508965957278	21883	10950	4	0	\N
9106	1395	58181668989957278	21991	10996	3	0	\N
9107	1395	58181668989957278	22012	11007	3	0	\N
9108	1395	58181668989957278	22022	11010	3	0	\N
9110	1395	58181669001957278	21991	10996	4	0	\N
9111	1395	58181669001957278	22012	11007	4	0	\N
9112	1395	58181669001957278	22022	11010	4	0	\N
8988	1395	58162948534507701	20989	10557	3	0	0
8993	1395	58163668534507701	21057	10580	2	0	0
8995	1395	58163668545507701	21057	10580	3	0	0
9001	1395	58164388545507701	21126	10611	2	0	0
9004	1395	58164388556507701	21126	10611	3	0	0
9012	1395	58165108576507701	21146	10619	11	0	0
9014	1395	58165108611507701	21146	10619	12	0	0
9017	1395	58165828611507701	21181	10636	4	0	0
9020	1395	58165828633507701	21181	10636	5	0	0
9025	1395	58166548633507701	21296	10693	6	0	0
9031	1395	58167268657507701	21315	10699	4	0	0
9032	1395	58167268679507701	21315	10699	5	0	0
9033	1395	58167988679507701	21337	10710	3	0	0
9034	1395	58167988691507701	21337	10710	4	0	0
9036	1395	58168708743507701	21408	10738	6	0	0
9037	1395	58169428743507701	21419	10741	3	0	0
9038	1395	58169428755507701	21419	10741	4	0	0
9042	1395	58170148755507701	21448	10759	4	0	0
9045	1395	58170148777507701	21448	10759	5	0	0
9048	1395	58170868787507701	21491	10779	2	0	0
9052	1395	58171588787507701	21551	10807	2	0	0
9053	1395	58171588789507701	21551	10807	3	0	0
9057	1395	58172308789507701	21564	10813	4	0	0
9058	1395	58172308802507701	21564	10813	5	0	0
9060	1395	58173028824507701	21590	10824	8	0	0
9061	1395	58173028824957278	21590	10824	9	1	0
9062	1395	58173748824957278	21597	10826	3	0	0
9063	1395	58173748836957278	21597	10826	4	0	0
9072	1395	58174468848957278	21656	10848	4	0	0
9074	1395	58175188848957278	21663	10853	4	0	0
9075	1395	58175188870957278	21663	10853	5	0	0
9077	1395	58175908870957278	21755	10893	3	0	0
9079	1395	58175908882957278	21755	10893	4	0	0
9083	1395	58176628906957278	21794	10911	7	0	0
9084	1395	58177348906957278	21798	10912	6	0	0
9085	1395	58177348930957278	21798	10912	7	0	0
9089	1395	58178068930957278	21833	10927	2	0	0
9090	1395	58178068941957278	21833	10927	3	0	0
9097	1395	58178788953957278	21878	10947	4	0	0
9099	1395	58179508953957278	21888	10954	3	0	0
9101	1395	58179508965957278	21888	10954	4	0	0
9102	1395	58180228965957278	21941	10976	3	0	0
9104	1395	58180948977957278	21945	10979	3	0	0
9105	1395	58180948989957278	21945	10979	4	0	0
9109	1395	58181668989957278	22027	11013	3	0	0
9114	1395	58182389001957278	22058	11030	3	0	\N
9115	1395	58182389001957278	22062	11032	3	0	\N
9117	1395	58182389013957278	22058	11030	4	0	\N
9118	1395	58182389013957278	22062	11032	4	0	\N
9120	1395	58183109023957278	22108	11057	3	0	\N
9122	1395	58183109035957278	22108	11057	4	0	\N
9126	1395	58184549067957278	22123	11065	3	0	\N
9127	1395	58184549067957278	22143	11076	7	0	\N
9129	1395	58184549079957278	22123	11065	4	0	\N
9131	1395	58184549092957278	22143	11076	8	0	\N
9140	1395	58188149167957278	22224	11125	3	0	\N
9141	1395	58188149167957278	22228	11126	5	0	\N
9142	1395	58188149167957278	22268	11145	3	0	\N
9144	1395	58188149179957278	22224	11125	4	0	\N
9145	1395	58188149179957278	22268	11145	4	0	\N
9147	1395	58188149181957278	22228	11126	6	0	\N
9156	1395	58191749241957278	22390	11209	3	0	\N
9157	1395	58191749241957278	22406	11216	2	0	\N
9159	1395	58191749252957278	22406	11216	3	0	\N
9160	1395	58191749253957278	22390	11209	4	0	\N
9164	1395	58193189277957278	22452	11236	3	0	\N
9165	1395	58193189277957278	22458	11238	3	0	\N
9166	1395	58193189277957278	22492	11253	8	0	\N
9168	1395	58193189289957278	22452	11236	4	0	\N
9169	1395	58193189289957278	22458	11238	4	0	\N
9170	1395	58193189312957278	22492	11253	9	0	\N
9172	1395	58193909494957278	22514	11262	4	0	\N
9173	1395	58193909494957278	22519	11265	9	0	\N
9174	1395	58193909494957278	22535	11275	3	0	\N
9176	1395	58193909506957278	22535	11275	4	0	\N
9177	1395	58193909507957278	22514	11262	5	0	\N
9179	1395	58193909566957278	22519	11265	10	0	\N
9190	1395	58198229945957278	22676	11338	3	0	\N
9192	1395	58198229957957278	22676	11338	4	0	\N
9194	1395	58198949960957278	22707	11352	2	0	\N
9195	1395	58198949960957278	22739	11370	4	0	\N
9197	1395	58198949971957278	22707	11352	3	0	\N
9199	1395	58198949973957278	22739	11370	5	0	\N
9208	1395	58202550054957278	22817	11410	5	0	\N
9210	1395	58202550068957278	22817	11410	6	0	\N
9212	1395	58203270079957278	22854	11427	5	0	\N
9215	1395	58203270102957278	22854	11427	6	0	\N
9216	1395	58203990091957278	22905	11449	3	0	\N
9218	1395	58203990103957278	22905	11449	4	0	\N
9220	1395	58204710128957278	22936	11461	4	0	\N
9222	1395	58204710141957278	22936	11461	5	0	\N
9225	1395	58205430201957278	23021	11474	0	0	\N
9226	1395	58205430201957278	23023	11487	0	0	\N
9232	1395	58207590236957278	23050	11509	3	0	\N
9234	1395	58207590248957278	23050	11509	4	0	\N
9236	1395	58208310249957278	23093	11532	7	0	\N
9239	1395	58208310274957278	23093	11532	8	0	\N
9246	1395	58211190324957278	23169	11569	3	0	\N
9248	1395	58211190336957278	23169	11569	4	0	\N
9119	1395	58182389023957278	22080	11040	5	0	0
9121	1395	58183109023957278	22116	11060	5	0	0
9123	1395	58183109055957278	22116	11060	6	0	0
9124	1395	58183829055957278	22122	11064	3	0	0
9125	1395	58183829067957278	22122	11064	4	0	0
9130	1395	58184549081957278	22159	11085	6	0	0
9132	1395	58185269081957278	22173	11093	3	0	0
9133	1395	58185269093957278	22173	11093	4	0	0
9134	1395	58185989093957278	22177	11096	7	0	0
9135	1395	58185989118957278	22177	11096	8	0	0
9137	1395	58186709130957278	22202	11113	4	0	0
9138	1395	58187429130957278	22209	11118	10	0	0
9139	1395	58187429167957278	22209	11118	11	0	0
9143	1395	58188149167957278	22273	11149	3	0	0
9148	1395	58188869179957278	22364	11194	4	0	0
9149	1395	58188869192957278	22364	11194	5	0	0
9150	1395	58189589192957278	22372	11198	3	0	0
9151	1395	58189589204957278	22372	11198	4	0	0
9152	1395	58190309204957278	22373	11199	7	0	0
9154	1395	58191029229957278	22379	11204	3	0	0
9155	1395	58191029241957278	22379	11204	4	0	0
9158	1395	58191749241957278	22448	11234	3	0	0
9161	1395	58191749253957278	22448	11234	4	0	0
9162	1395	58192469253957278	22451	11235	6	0	0
9167	1395	58193189277957278	22499	11255	28	0	0
9171	1395	58193189494957278	22499	11255	29	0	0
9175	1395	58193909494957278	22561	11287	8	0	0
9178	1395	58193909520957278	22561	11287	9	0	0
9181	1395	58194629593957278	22573	11293	11	0	0
9182	1395	58195349593957278	22582	11298	6	0	0
9183	1395	58195349905957278	22582	11298	7	0	0
9184	1395	58196069905957278	22613	11312	7	0	0
9185	1395	58196069921957278	22613	11312	8	0	0
9187	1395	58196789933957278	22650	11326	4	0	0
9188	1395	58197509933957278	22672	11335	3	0	0
9189	1395	58197509945957278	22672	11335	4	0	0
9191	1395	58198229945957278	22694	11347	6	0	0
9193	1395	58198229960957278	22694	11347	7	0	0
9198	1395	58198949972957278	22757	11378	4	0	0
9200	1395	58199669972957278	22759	11380	4	0	0
9201	1395	58199669985957278	22759	11380	5	0	0
9202	1395	58200389985957278	22789	11397	8	0	0
9204	1395	58201110029957278	22799	11402	4	0	0
9205	1395	58201110042957278	22799	11402	5	0	0
9206	1395	58201830042957278	22802	11403	3	0	0
9207	1395	58201830054957278	22802	11403	4	0	0
9209	1395	58202550054957278	22819	11411	7	0	0
9213	1395	58203270079957278	22882	11438	3	0	0
9214	1395	58203270091957278	22882	11438	4	0	0
9217	1395	58203990091957278	22913	11453	10	0	0
9219	1395	58203990128957278	22913	11453	11	0	0
9221	1395	58204710128957278	22957	11470	19	0	0
9224	1395	58205430201957278	23003	11491	3	0	0
9228	1395	58206150213957278	23029	11499	2	0	0
9229	1395	58206150224957278	23029	11499	3	0	0
9230	1395	58206870224957278	23040	11504	3	0	0
9231	1395	58206870236957278	23040	11504	4	0	0
9233	1395	58207590236957278	23082	11525	4	0	0
9235	1395	58207590249957278	23082	11525	5	0	0
9237	1395	58208310249957278	23116	11546	4	0	0
9238	1395	58208310262957278	23116	11546	5	0	0
9241	1395	58209030275957278	23144	11557	5	0	0
9242	1395	58209750275957278	23145	11558	3	0	0
9243	1395	58209750287957278	23145	11558	4	0	0
9244	1395	58210470287957278	23147	11560	10	0	0
9245	1395	58210470324957278	23147	11560	11	0	0
9250	1395	58211910337957278	23193	11579	3	0	\N
9253	1395	58211910349957278	23193	11579	4	0	\N
9254	1395	58212630348957278	23281	11616	2	0	\N
9256	1395	58212630359957278	23281	11616	3	0	\N
9258	1395	58212630369957278	23359	11656	1	0	\N
9259	1395	58213350359957278	23309	11632	2	0	\N
9261	1395	58213350369957278	23359	11656	3	0	\N
9262	1395	58213350370957278	23309	11632	3	0	\N
9263	1395	58213350370957278	23359	11656	4	0	\N
9273	1395	58216950482957278	23467	11701	3	0	\N
9275	1395	58216950494957278	23467	11701	4	0	\N
9277	1395	58217670495957278	23510	11719	4	0	\N
9278	1395	58217670495957278	23522	11724	10	0	\N
9281	1395	58217670508957278	23510	11719	5	0	\N
9282	1395	58217670532957278	23522	11724	11	0	\N
9285	1395	58219110531957278	23589	11755	4	0	\N
9286	1395	58219110531957278	23593	11756	6	0	\N
9287	1395	58219110531957278	23597	11758	2	0	\N
9289	1395	58219110542957278	23597	11758	3	0	\N
9291	1395	58219110544957278	23589	11755	5	0	\N
9292	1395	58219110555957278	23593	11756	7	0	\N
9293	1395	58219830543957278	23662	11785	3	0	\N
9294	1395	58219830543957278	23672	11789	7	0	\N
9295	1395	58219830543957278	23692	11800	3	0	\N
9297	1395	58219830555957278	23662	11785	4	0	\N
9298	1395	58219830555957278	23692	11800	4	0	\N
9300	1395	58219830568957278	23672	11789	8	0	\N
9305	1395	58221990582957278	23831	11862	7	0	\N
9308	1395	58221990607957278	23831	11862	8	0	\N
9313	1395	58224150645957278	23924	11906	3	0	\N
9315	1395	58224150657957278	23924	11906	4	0	\N
9319	1395	58225590661957278	23971	11928	10	0	\N
9320	1395	58225590661957278	23972	11929	8	0	\N
9323	1395	58225590723957278	23972	11929	9	0	\N
9324	1395	58225590734957278	23971	11928	11	0	\N
9325	1395	58226310673957278	24042	11963	3	0	\N
9327	1395	58226310685957278	24042	11963	4	0	\N
9329	1395	58227030686957278	24095	11995	2	0	\N
9330	1395	58227030686957278	24168	12029	6	0	\N
9332	1395	58227030697957278	24095	11995	3	0	\N
9334	1395	58227030710957278	24168	12029	7	0	\N
9335	1395	58227750697957278	24191	12041	2	0	\N
9337	1395	58227750708957278	24191	12041	3	0	\N
9341	1395	58229190734957278	24230	12057	4	0	\N
9342	1395	58229190734957278	24234	12059	3	0	\N
9344	1395	58229190746957278	24234	12059	4	0	\N
9345	1395	58229190747957278	24230	12057	5	0	\N
9353	1395	58232070782957278	24364	12116	3	0	\N
9356	1395	58232070794957278	24364	12116	4	0	\N
9359	1395	58233510804957278	24410	12139	2	0	\N
9361	1395	58233510815957278	24410	12139	3	0	\N
9365	1395	58234950837957278	24445	12157	2	0	\N
9366	1395	58234950837957278	24459	12163	4	0	\N
9368	1395	58234950848957278	24445	12157	3	0	\N
9370	1395	58234950859957278	24459	12163	5	0	\N
9371	1395	58235670848957278	24513	12191	5	0	\N
9372	1395	58235670848957278	24528	12193	2	0	\N
9374	1395	58235670859957278	24528	12193	3	0	\N
9376	1395	58235670871957278	24513	12191	6	0	\N
9377	1395	58236390860957278	24570	12213	4	0	\N
9380	1395	58236390882957278	24570	12213	5	0	\N
9252	1395	58211910348957278	23212	11586	3	0	0
9255	1395	58212630348957278	23299	11626	2	0	0
9257	1395	58212630359957278	23299	11626	3	0	0
9260	1395	58213350359957278	23381	11667	2	0	0
9264	1395	58213350370957278	23381	11667	3	0	0
9266	1395	58214070425957278	23390	11670	11	0	0
9267	1395	58214790425957278	23407	11678	4	0	0
9268	1395	58214790447957278	23407	11678	5	0	0
9269	1395	58215510447957278	23447	11692	2	0	0
9270	1395	58215510458957278	23447	11692	3	0	0
9272	1395	58216230482957278	23464	11699	7	0	0
9274	1395	58216950482957278	23470	11703	4	0	0
9276	1395	58216950495957278	23470	11703	5	0	0
9279	1395	58217670495957278	23543	11735	3	0	0
9283	1395	58218390507957278	23554	11740	6	0	0
9284	1395	58218390531957278	23554	11740	7	0	0
9288	1395	58219110531957278	23634	11774	3	0	0
9290	1395	58219110543957278	23634	11774	4	0	0
9296	1395	58219830543957278	23702	11804	4	0	0
9301	1395	58220550556957278	23712	11810	4	0	0
9302	1395	58220550569957278	23712	11810	5	0	0
9303	1395	58221270569957278	23780	11841	4	0	0
9304	1395	58221270582957278	23780	11841	5	0	0
9306	1395	58221990582957278	23851	11873	3	0	0
9309	1395	58222710594957278	23864	11878	7	0	0
9310	1395	58222710619957278	23864	11878	8	0	0
9311	1395	58223430619957278	23887	11891	8	0	0
9312	1395	58223430645957278	23887	11891	9	0	0
9316	1395	58224150659957278	23940	11913	6	0	0
9317	1395	58224870659957278	23967	11926	2	0	0
9318	1395	58224870661957278	23967	11926	3	0	0
9321	1395	58225590661957278	24035	11961	3	0	0
9322	1395	58225590673957278	24035	11961	4	0	0
9328	1395	58226310686957278	24055	11970	5	0	0
9331	1395	58227030686957278	24184	12038	2	0	0
9333	1395	58227030697957278	24184	12038	3	0	0
9336	1395	58227750697957278	24211	12050	7	0	0
9338	1395	58227750722957278	24211	12050	8	0	0
9340	1395	58228470734957278	24220	12054	4	0	0
9343	1395	58229190734957278	24244	12064	4	0	0
9346	1395	58229190747957278	24244	12064	5	0	0
9347	1395	58229910747957278	24267	12074	3	0	0
9349	1395	58230630759957278	24342	12105	3	0	0
9350	1395	58230630771957278	24342	12105	4	0	0
9351	1395	58231350771957278	24355	12112	2	0	0
9352	1395	58231350782957278	24355	12112	3	0	0
9354	1395	58232070782957278	24389	12128	2	0	0
9357	1395	58232790793957278	24402	12134	2	0	0
9358	1395	58232790804957278	24402	12134	3	0	0
9360	1395	58233510804957278	24439	12154	4	0	0
9362	1395	58233510826957278	24439	12154	5	0	0
9363	1395	58234230826957278	24440	12155	2	0	0
9367	1395	58234950837957278	24479	12172	2	0	0
9369	1395	58234950848957278	24479	12172	3	0	0
9373	1395	58235670848957278	24559	12208	3	0	0
9375	1395	58235670860957278	24559	12208	4	0	0
9379	1395	58236390872957278	24669	12252	4	0	0
9381	1395	58237110872957278	24679	12258	5	0	0
9382	1395	58237110886957278	24679	12258	6	0	0
9383	1395	58237830886957278	24680	12259	3	0	0
9384	1395	58237830898957278	24680	12259	4	0	0
9392	1395	58239991032957278	24710	12272	6	0	\N
9393	1395	58240710972957278	24696	12266	5	0	\N
9396	1395	58240711004957278	24696	12266	6	0	\N
9397	1395	58240711014957278	24735	12283	3	0	\N
9398	1395	58240711032957278	24710	12272	9	0	\N
9399	1395	58240711034957278	24710	12272	10	0	\N
9402	1395	58241431014957278	24735	12283	8	0	\N
9403	1395	58241431036957278	24735	12283	9	0	\N
9406	1395	58242871031957278	24807	12319	3	0	\N
9409	1395	58242871052957278	24807	12319	4	0	\N
9410	1395	58243591043957278	24840	12333	7	0	\N
9413	1395	58243591068957278	24840	12333	8	0	\N
9418	1395	58245751059957278	24929	12375	4	0	\N
9419	1395	58245751059957278	24948	12382	3	0	\N
9420	1395	58245751059957278	24957	12385	4	0	\N
9421	1395	58245751059957278	24963	12387	8	0	\N
9422	1395	58245751059957278	25023	12414	4	0	\N
9425	1395	58245751062957278	24948	12382	4	0	\N
9426	1395	58245751063957278	24929	12375	5	0	\N
9427	1395	58245751072957278	24957	12385	5	0	\N
9428	1395	58245751081957278	25023	12414	5	0	\N
9429	1395	58245751094957278	24963	12387	9	0	\N
9432	1395	58247191074957278	25106	12457	4	0	\N
9433	1395	58247191074957278	25118	12464	6	0	\N
9436	1395	58247191087957278	25106	12457	5	0	\N
9437	1395	58247191098957278	25118	12464	7	0	\N
9439	1395	58247911087957278	25108	12458	6	0	\N
9441	1395	58247911120957278	25108	12458	7	0	\N
9442	1395	58248631100957278	25162	12483	4	0	\N
9443	1395	58248631100957278	25170	12486	3	0	\N
9445	1395	58248631112957278	25170	12486	4	0	\N
9447	1395	58248631113957278	25162	12483	5	0	\N
9452	1395	58250791136957278	25260	12531	4	0	\N
9455	1395	58250791149957278	25260	12531	5	0	\N
9456	1395	58251511138957277	25312	12558	0	0	\N
9457	1395	58251511138957278	25333	12565	4	0	\N
9460	1395	58251511241957278	25333	12565	5	0	\N
9461	1395	58252231139957278	25365	12577	2	0	\N
9463	1395	58252231141957278	25365	12577	3	0	\N
9465	1395	58252951142957278	25423	12598	2	0	\N
9467	1395	58252951153957278	25423	12598	3	0	\N
9471	1395	58254391179957278	25505	12631	3	0	\N
9472	1395	58254391179957278	25524	12637	3	0	\N
9473	1395	58254391179957278	25538	12644	2	0	\N
9475	1395	58254391190957278	25538	12644	3	0	\N
9476	1395	58254391191957278	25505	12631	4	0	\N
9477	1395	58254391191957278	25524	12637	4	0	\N
9479	1395	58255111203957278	25589	12665	3	0	\N
9480	1395	58255111203957278	25610	12675	5	0	\N
9481	1395	58255111203957278	25612	12676	3	0	\N
9483	1395	58255111215957278	25589	12665	4	0	\N
9484	1395	58255111215957278	25612	12676	4	0	\N
9485	1395	58255111217957278	25610	12675	6	0	\N
9491	1395	58257271264957278	25747	12736	5	0	\N
9492	1395	58257271264957278	25750	12738	4	0	\N
9494	1395	58257271277957278	25750	12738	5	0	\N
9496	1395	58257271287957278	25747	12736	6	0	\N
9499	1395	58258711289957278	25828	12772	7	0	\N
9502	1395	58258711314957278	25828	12772	8	0	\N
9505	1395	58260151324957268	25895	12799	11	0	\N
9506	1395	58260151324957278	25860	12785	8	0	\N
9509	1395	58260151359957278	25860	12785	9	0	\N
9512	1395	58261591346957278	25957	12827	4	0	\N
9513	1395	58261591346957278	25963	12829	5	0	\N
9514	1395	58261591346957278	25970	12831	2	0	\N
9516	1395	58261591357957278	25970	12831	3	0	\N
9517	1395	58261591368957278	25957	12827	5	0	\N
9518	1395	58261591369957278	25963	12829	6	0	\N
9387	1395	58238550936957278	24681	12260	13	0	0
9388	1395	58239270936957278	24683	12261	3	0	0
9389	1395	58239270948957278	24683	12261	4	0	0
9390	1395	58239990948957278	24693	12265	6	0	0
9391	1395	58239990972957278	24693	12265	7	0	0
9395	1395	58240710984957278	24715	12274	4	0	0
9400	1395	58241430984957278	24748	12289	4	0	0
9401	1395	58241431006957278	24748	12289	5	0	0
9404	1395	58242151006957278	24762	12294	7	0	0
9405	1395	58242151031957278	24762	12294	8	0	0
9408	1395	58242871043957278	24835	12331	4	0	0
9411	1395	58243591043957278	24858	12343	3	0	0
9412	1395	58243591055957278	24858	12343	4	0	0
9414	1395	58244311055957278	24891	12358	2	0	0
9416	1395	58245031057957278	24924	12374	2	0	0
9417	1395	58245031059957278	24924	12374	3	0	0
9423	1395	58245751059957278	25033	12420	2	0	0
9424	1395	58245751061957278	25033	12420	3	0	0
9430	1395	58246471061957278	25055	12432	4	0	0
9434	1395	58247191074957278	25127	12468	3	0	0
9435	1395	58247191086957278	25127	12468	4	0	0
9438	1395	58247911086957278	25144	12475	5	0	0
9440	1395	58247911100957278	25144	12475	6	0	0
9444	1395	58248631100957278	25248	12522	3	0	0
9448	1395	58249351112957278	25251	12525	3	0	0
9449	1395	58249351124957278	25251	12525	4	0	0
9450	1395	58250071124957278	25257	12529	3	0	0
9451	1395	58250071136957278	25257	12529	4	0	0
9454	1395	58250791138957278	25306	12556	3	0	0
9458	1395	58251511138957278	25345	12568	1	0	0
9459	1395	58251511139957278	25345	12568	2	0	0
9462	1395	58252231139957278	25393	12586	3	0	0
9464	1395	58252231142957278	25393	12586	4	0	0
9468	1395	58252951154957278	25434	12603	4	0	0
9469	1395	58253671154957278	25449	12607	7	0	0
9470	1395	58253671179957278	25449	12607	8	0	0
9474	1395	58254391179957278	25544	12646	6	0	0
9478	1395	58254391203957278	25544	12646	7	0	0
9486	1395	58255111227957278	25646	12692	7	0	0
9487	1395	58255831227957278	25709	12719	7	0	0
9488	1395	58255831252957278	25709	12719	8	0	0
9489	1395	58256551252957278	25724	12726	3	0	0
9493	1395	58257271264957278	25793	12755	4	0	0
9495	1395	58257271277957278	25793	12755	5	0	0
9497	1395	58257991277957278	25810	12762	3	0	0
9498	1395	58257991289957278	25810	12762	4	0	0
9500	1395	58258711289957278	25845	12778	2	0	0
9503	1395	58259431300957278	25851	12781	6	0	0
9504	1395	58259431324957278	25851	12781	7	0	0
9507	1395	58260151324957278	25904	12803	2	0	0
9508	1395	58260151335957278	25904	12803	3	0	0
9510	1395	58260871335957278	25913	12806	2	0	0
9515	1395	58261591346957278	26006	12852	7	0	0
9519	1395	58261591371957278	26006	12852	8	0	0
9520	1395	58262311371957278	26008	12854	6	0	0
9528	1395	58265191428957278	26041	12868	2	0	\N
9530	1395	58265191439957278	26041	12868	3	0	\N
9536	1395	58267351474957278	26155	12929	5	0	\N
9537	1395	58267351474957278	26159	12930	8	0	\N
9540	1395	58267351488957278	26155	12929	6	0	\N
9541	1395	58267351500957278	26159	12930	9	0	\N
9558	1395	58273831658957278	26307	13014	0	0	\N
9559	1395	58273831658957278	26318	13017	5	0	\N
9560	1395	58273831658957278	26322	13018	5	0	\N
9561	1395	58273831658957278	26326	13020	2	0	\N
9562	1395	58273831658957278	26362	13037	3	0	\N
9564	1395	58273831669957278	26326	13020	3	0	\N
9565	1395	58273831670957278	26362	13037	4	0	\N
9566	1395	58273831681957278	26318	13017	6	0	\N
9567	1395	58273831681957278	26322	13018	6	0	\N
9572	1395	58275991695957278	26410	13066	4	0	\N
9574	1395	58275991708957278	26410	13066	5	0	\N
9579	1395	58277431733957278	26440	13080	3	0	\N
9582	1395	58277431745957278	26440	13080	4	0	\N
9583	1395	58278151744957278	26470	13092	8	0	\N
9584	1395	58278151744957278	26475	13095	6	0	\N
9587	1395	58278151759957278	26475	13095	7	0	\N
9588	1395	58278151770957278	26470	13092	9	0	\N
9593	1395	58280311805957278	26504	13112	3	0	\N
9595	1395	58280311817957278	26504	13112	4	0	\N
9599	1395	58281751829957278	26610	13165	3	0	\N
9600	1395	58281751829957278	26616	13168	8	0	\N
9601	1395	58281751829957278	26675	13193	4	0	\N
9602	1395	58281751829957278	26679	13196	3	0	\N
9604	1395	58281751841957278	26610	13165	4	0	\N
9605	1395	58281751841957278	26679	13196	4	0	\N
9606	1395	58281751842957278	26675	13193	5	0	\N
9607	1395	58281751846957278	26616	13168	9	0	\N
9609	1395	58282471854957278	26683	13198	9	0	\N
9610	1395	58282471854957278	26728	13221	7	0	\N
9613	1395	58282471879957278	26728	13221	8	0	\N
9614	1395	58282471890957278	26683	13198	10	0	\N
9618	1395	58283911891957278	26744	13228	7	0	\N
9619	1395	58283911916957278	26744	13228	8	0	\N
9622	1395	58284631930957278	26789	13247	3	0	\N
9624	1395	58284631942957278	26789	13247	4	0	\N
9628	1395	58285352001957278	26815	13261	1	0	\N
9630	1395	58286072001957278	26815	13261	5	0	\N
9631	1395	58286072004957278	26815	13261	6	0	\N
9633	1395	58286792004957278	26862	13285	3	0	\N
9635	1395	58286792016957278	26862	13285	4	0	\N
9637	1395	58287512016957278	26890	13297	3	0	\N
9639	1395	58287512028957278	26890	13297	4	0	\N
9641	1395	58288232028957278	26925	13317	3	0	\N
9643	1395	58288232040957278	26925	13317	4	0	\N
9645	1395	58288952040957278	26967	13338	3	0	\N
9647	1395	58288952052957278	26967	13338	4	0	\N
9651	1395	58290392075957278	27021	13363	3	0	\N
9653	1395	58290392087957278	27021	13363	4	0	\N
9655	1395	58291112087957278	27051	13374	3	0	\N
9523	1395	58263031406957278	26024	12862	3	0	0
9524	1395	58263751406957278	26030	12864	2	0	0
9525	1395	58263751417957278	26030	12864	3	0	0
9526	1395	58264471417957278	26040	12867	2	0	0
9527	1395	58264471428957278	26040	12867	3	0	0
9531	1395	58265191439957278	26125	12915	3	0	0
9532	1395	58265911439957278	26142	12923	2	0	0
9533	1395	58265911450957278	26142	12923	3	0	0
9534	1395	58266631450957278	26147	12926	6	0	0
9535	1395	58266631474957278	26147	12926	7	0	0
9539	1395	58267351487957278	26203	12954	5	0	0
9542	1395	58268071487957278	26205	12955	13	0	0
9543	1395	58268071536957278	26205	12955	14	0	0
9544	1395	58268791536957278	26211	12958	3	0	0
9546	1395	58269511548957278	26215	12961	4	0	0
9547	1395	58269511561957278	26215	12961	5	0	0
9548	1395	58270231561957278	26222	12964	3	0	0
9549	1395	58270231573957278	26222	12964	4	0	0
9550	1395	58270951573957278	26242	12973	3	0	0
9552	1395	58271671585957278	26251	12979	13	0	0
9553	1395	58271671634957278	26251	12979	14	0	0
9554	1395	58272391634957278	26274	12995	4	0	0
9555	1395	58272391647957278	26274	12995	5	0	0
9556	1395	58273111647957278	26290	13004	2	0	0
9563	1395	58273831658957278	26365	13039	0	0	0
9568	1395	58274551658957278	26390	13054	7	0	0
9569	1395	58274551683957278	26390	13054	8	0	0
9570	1395	58275271683957278	26394	13056	3	0	0
9573	1395	58275991695957278	26430	13075	4	0	0
9575	1395	58275991708957278	26430	13075	5	0	0
9576	1395	58275991728957278	26432	13077	2	0	0
9577	1395	58276711728957278	26432	13077	8	0	0
9578	1395	58276711733957278	26432	13077	9	0	0
9581	1395	58277431744957278	26453	13084	3	0	0
9585	1395	58278151744957278	26488	13102	3	0	0
9586	1395	58278151756957278	26488	13102	4	0	0
9589	1395	58278871756957278	26491	13104	3	0	0
9590	1395	58278871768957278	26491	13104	4	0	0
9592	1395	58279591805957278	26495	13106	11	0	0
9594	1395	58280311805957278	26556	13140	3	0	0
9596	1395	58280311817957278	26556	13140	4	0	0
9597	1395	58281031817957278	26562	13143	3	0	0
9603	1395	58281751829957278	26680	13197	7	0	0
9608	1395	58281751854957278	26680	13197	8	0	0
9611	1395	58282471854957278	26735	13224	4	0	0
9612	1395	58282471867957278	26735	13224	5	0	0
9615	1395	58283191867957278	26736	13225	6	0	0
9617	1395	58283191922957278	26779	13243	4	0	0
9620	1395	58283911922957278	26779	13243	13	0	0
9621	1395	58283911930957278	26779	13243	14	0	0
9623	1395	58284631930957278	26811	13258	3	0	0
9625	1395	58284631942957278	26811	13258	4	0	0
9627	1395	58285351991957278	26814	13260	14	0	0
9629	1395	58286071991957278	26840	13273	4	0	0
9632	1395	58286072004957278	26840	13273	5	0	0
9634	1395	58286792004957278	26866	13287	3	0	0
9638	1395	58287512016957278	26904	13305	3	0	0
9640	1395	58287512028957278	26904	13305	4	0	0
9642	1395	58288232028957278	26928	13319	3	0	0
9644	1395	58288232040957278	26928	13319	4	0	0
9646	1395	58288952040957278	27012	13360	6	0	0
9649	1395	58289672064957278	27017	13362	2	0	0
9650	1395	58289672075957278	27017	13362	3	0	0
9652	1395	58290392075957278	27022	13364	3	0	0
9654	1395	58290392087957278	27022	13364	4	0	0
9656	1395	58291112087957278	27074	13385	3	0	0
9657	1395	58291112099957278	27051	13374	4	0	\N
9659	1395	58291832099957278	27077	13387	3	0	\N
9660	1395	58291832099957278	27096	13397	3	0	\N
9661	1395	58291832099957278	27123	13411	5	0	\N
9663	1395	58291832111957278	27077	13387	4	0	\N
9664	1395	58291832111957278	27096	13397	4	0	\N
9666	1395	58291832113957278	27123	13411	6	0	\N
9671	1395	58293272169957278	27183	13445	1	0	\N
9672	1395	58293992159957278	27178	13443	6	0	\N
9674	1395	58293992169957278	27183	13445	7	0	\N
9676	1395	58293992183957278	27178	13443	7	0	\N
9679	1395	58295432255957278	27218	13461	9	0	\N
9682	1395	58295432291957278	27218	13461	10	0	\N
9689	1395	58298312304957278	27276	13481	3	0	\N
9691	1395	58298312316957278	27276	13481	4	0	\N
9699	1395	58301192374957278	27372	13534	3	0	\N
9700	1395	58301192374957278	27377	13537	6	0	\N
9702	1395	58301192386957278	27372	13534	4	0	\N
9704	1395	58301192398957278	27377	13537	7	0	\N
9705	1395	58301912386957278	27401	13550	3	0	\N
9707	1395	58301912398957278	27401	13550	4	0	\N
9709	1395	58302632398957278	27434	13562	3	0	\N
9710	1395	58302632398957278	27480	13581	18	0	\N
9712	1395	58302632410957278	27434	13562	4	0	\N
9714	1395	58302632420957278	27514	13602	1	0	\N
9715	1395	58302632434957278	27480	13581	19	0	\N
9716	1395	58303352410957278	27501	13594	3	0	\N
9717	1395	58303352410957278	27526	13609	3	0	\N
9719	1395	58303352420957278	27514	13602	4	0	\N
9720	1395	58303352422957278	27501	13594	4	0	\N
9721	1395	58303352422957278	27514	13602	5	0	\N
9722	1395	58303352422957278	27526	13609	4	0	\N
9735	1395	58308392515957278	27640	13660	12	0	\N
9738	1395	58308392563957278	27640	13660	13	0	\N
9747	1395	58311992645957278	27732	13700	2	0	\N
9749	1395	58311992656957278	27732	13700	3	0	\N
9751	1395	58312712656957278	27758	13712	2	0	\N
9752	1395	58312712656957278	27778	13725	2	0	\N
9754	1395	58312712667957278	27758	13712	3	0	\N
9755	1395	58312712667957278	27778	13725	3	0	\N
9757	1395	58313432679957278	27791	13733	3	0	\N
9760	1395	58313432694957278	27791	13733	4	0	\N
9761	1395	58314152691957278	27846	13765	3	0	\N
9763	1395	58314152703957278	27846	13765	4	0	\N
9765	1395	58314872715957278	27862	13773	3	0	\N
9767	1395	58314872727957278	27862	13773	4	0	\N
9770	1395	58315592727957278	27873	13780	3	0	\N
9771	1395	58315592739957278	27873	13780	4	0	\N
9776	1395	58317032775957278	27909	13803	3	0	\N
9778	1395	58317032787957278	27909	13803	4	0	\N
9785	1395	58319912864457278	27953	13829	6	0	\N
9787	1395	58319912888457278	27953	13829	7	0	\N
9789	1395	58320632888457278	27969	13835	11	0	\N
9792	1395	58320632926457278	27969	13835	12	0	\N
9665	1395	58291832111957278	27136	13419	4	0	0
9667	1395	58292552111957278	27155	13427	3	0	0
9668	1395	58292552123957278	27155	13427	4	0	0
9669	1395	58293272123957278	27160	13430	9	0	0
9670	1395	58293272159957278	27160	13430	10	0	0
9675	1395	58293992171957278	27202	13454	4	0	0
9677	1395	58294712171957278	27215	13460	21	0	0
9678	1395	58294712255957278	27215	13460	22	0	0
9680	1395	58295432255957278	27244	13471	4	0	0
9681	1395	58295432268957278	27244	13471	5	0	0
9684	1395	58296152280957278	27245	13472	4	0	0
9685	1395	58296872280957278	27259	13477	3	0	0
9686	1395	58296872292957278	27259	13477	4	0	0
9687	1395	58297592292957278	27266	13478	3	0	0
9690	1395	58298312304957278	27294	13490	4	0	0
9692	1395	58298312326957278	27294	13490	5	0	0
9693	1395	58299032326957278	27302	13495	6	0	0
9694	1395	58299032350957278	27302	13495	7	0	0
9695	1395	58299752350957278	27343	13518	3	0	0
9697	1395	58300472362957278	27349	13522	3	0	0
9698	1395	58300472374957278	27349	13522	4	0	0
9701	1395	58301192374957278	27400	13549	3	0	0
9703	1395	58301192386957278	27400	13549	4	0	0
9706	1395	58301912386957278	27418	13556	3	0	0
9711	1395	58302632398957278	27491	13588	3	0	0
9713	1395	58302632410957278	27491	13588	4	0	0
9718	1395	58303352410957278	27539	13614	3	0	0
9723	1395	58303352422957278	27539	13614	4	0	0
9725	1395	58304072444957278	27542	13615	5	0	0
9726	1395	58304792444957278	27556	13621	3	0	0
9727	1395	58304792456957278	27556	13621	4	0	0
9728	1395	58305512456957278	27589	13636	2	0	0
9729	1395	58305512467957278	27589	13636	3	0	0
9731	1395	58306232491957278	27625	13653	7	0	0
9732	1395	58306952491957278	27629	13655	6	0	0
9733	1395	58306952515957278	27629	13655	7	0	0
9734	1395	58307672515957278	27638	13659	0	0	0
9736	1395	58308392515957278	27653	13665	3	0	0
9739	1395	58309112527957278	27665	13673	3	0	0
9740	1395	58309112539957278	27665	13673	4	0	0
9741	1395	58309832539957278	27680	13677	2	0	0
9742	1395	58309832550957278	27680	13677	3	0	0
9744	1395	58310552623957278	27704	13689	11	0	0
9745	1395	58311272623957278	27712	13693	4	0	0
9746	1395	58311272645957278	27712	13693	5	0	0
9748	1395	58311992645957278	27753	13710	2	0	0
9750	1395	58311992656957278	27753	13710	3	0	0
9756	1395	58312712679957278	27788	13731	6	0	0
9758	1395	58313432679957278	27811	13742	3	0	0
9759	1395	58313432691957278	27811	13742	4	0	0
9762	1395	58314152691957278	27859	13771	6	0	0
9764	1395	58314152715957278	27859	13771	7	0	0
9768	1395	58314872727957278	27863	13774	4	0	0
9769	1395	58314872760957278	27886	13788	6	0	0
9772	1395	58315592760957278	27886	13788	10	0	0
9773	1395	58315592763957278	27886	13788	11	0	0
9775	1395	58316312775957278	27892	13792	4	0	0
9777	1395	58317032775957278	27931	13816	9	0	0
9779	1395	58317032816457278	27931	13816	10	0	0
9780	1395	58317752816457278	27943	13824	9	0	0
9781	1395	58317752852457278	27943	13824	10	0	0
9783	1395	58318472864457278	27945	13825	4	0	0
9784	1395	58319192864457278	27950	13827	0	0	0
9786	1395	58319912864457278	27956	13830	6	0	0
9788	1395	58319912888457278	27956	13830	7	0	0
9790	1395	58320632888457278	27974	13836	3	0	0
9793	1395	58321352900457278	27981	13840	3	0	\N
9795	1395	58321352912457278	27981	13840	4	0	\N
9797	1395	58322072924457278	28008	13851	3	0	\N
9800	1395	58322072936457278	28008	13851	4	0	\N
9803	1395	58323512937457278	28063	13876	3	0	\N
9805	1395	58323512949457278	28063	13876	4	0	\N
9808	1395	58324232973457278	28093	13887	3	0	\N
9809	1395	58324232973457278	28098	13890	10	0	\N
9811	1395	58324232985457278	28093	13887	4	0	\N
9813	1395	58324233010457278	28098	13890	11	0	\N
9814	1395	58324952985457278	28176	13929	2	0	\N
9816	1395	58324952996457278	28176	13929	3	0	\N
9826	1395	58328553044457278	28282	13982	3	0	\N
9827	1395	58328553044457278	28290	13985	3	0	\N
9830	1395	58328553056457278	28282	13982	4	0	\N
9831	1395	58328553056457278	28290	13985	4	0	\N
9834	1395	58329993066457278	28399	14037	3	0	\N
9835	1395	58329993066457278	28404	14039	2	0	\N
9837	1395	58329993077457278	28404	14039	3	0	\N
9838	1395	58329993078457278	28399	14037	4	0	\N
9842	1395	58331433133457278	28455	14062	2	0	\N
9843	1395	58331433133457278	28466	14066	2	0	\N
9845	1395	58331433144457278	28455	14062	3	0	\N
9846	1395	58331433144457278	28466	14066	3	0	\N
9850	1395	58332873155457278	28527	14095	4	0	\N
9853	1395	58332873168457278	28527	14095	5	0	\N
9858	1395	58335033455457278	28654	14148	6	0	\N
9861	1395	58335033488457278	28654	14148	7	0	\N
9862	1395	58335753468457278	28713	14173	1	0	\N
9864	1395	58335753469457278	28713	14173	2	0	\N
9866	1395	58336473481457278	28740	14181	2	0	\N
9867	1395	58336473481457278	28744	14182	2	0	\N
9868	1395	58336473481457278	28750	14183	3	0	\N
9870	1395	58336473492457278	28740	14181	3	0	\N
9871	1395	58336473492457278	28744	14182	3	0	\N
9872	1395	58336473493457278	28750	14183	4	0	\N
9880	1395	58339353554457278	28857	14233	17	0	\N
9883	1395	58339353621995738	28857	14233	18	0	\N
9888	1395	58340793887457278	28983	14292	4	0	\N
9889	1395	58341513613457278	28959	14282	7	0	\N
9890	1395	58341513613457278	28965	14285	5	0	\N
9891	1395	58341513613457278	29021	14312	2	0	\N
9893	1395	58341513624457278	29021	14312	3	0	\N
9895	1395	58341513636457278	28965	14285	6	0	\N
9896	1395	58341513638457278	28959	14282	8	0	\N
9897	1395	58341513887457278	28983	14292	9	0	\N
9898	1395	58341513891457278	28983	14292	10	0	\N
9899	1395	58342233624457278	29080	14335	3	0	\N
9901	1395	58342233636457278	29080	14335	4	0	\N
9917	1395	58347993770457278	29224	14401	3	0	\N
9919	1395	58347993782457278	29224	14401	4	0	\N
9925	1395	58350153831457278	29244	14411	3	0	\N
9927	1395	58350153843457278	29244	14411	4	0	\N
9798	1395	58322072924457278	28021	13859	2	0	0
9799	1395	58322072935457278	28021	13859	3	0	0
9801	1395	58322792935457278	28043	13869	2	0	0
9802	1395	58322792937457278	28043	13869	3	0	0
9804	1395	58323512937457278	28065	13877	9	0	0
9807	1395	58323512983457278	28164	13926	1	0	0
9810	1395	58324232983457278	28164	13926	4	0	0
9812	1395	58324232985457278	28164	13926	5	0	0
9815	1395	58324952985457278	28207	13945	2	0	0
9817	1395	58324952996457278	28207	13945	3	0	0
9819	1395	58325673008457278	28242	13963	4	0	0
9820	1395	58326393008457278	28247	13967	3	0	0
9821	1395	58326393020457278	28247	13967	4	0	0
9822	1395	58327113020457278	28267	13975	3	0	0
9824	1395	58327833032457278	28281	13981	3	0	0
9825	1395	58327833044457278	28281	13981	4	0	0
9828	1395	58328553044457278	28318	14000	2	0	0
9829	1395	58328553055457278	28318	14000	3	0	0
9832	1395	58329273055457278	28394	14034	2	0	0
9836	1395	58329993066457278	28434	14053	7	0	0
9839	1395	58329993100457278	28434	14053	8	0	0
9840	1395	58330713100457278	28452	14061	6	0	0
9841	1395	58330713133457278	28452	14061	7	0	0
9844	1395	58331433133457278	28478	14075	2	0	0
9848	1395	58332153144457278	28496	14082	2	0	0
9849	1395	58332153155457278	28496	14082	3	0	0
9851	1395	58332873155457278	28530	14096	3	0	0
9852	1395	58332873167457278	28530	14096	4	0	0
9855	1395	58333593442457278	28531	14097	9	0	0
9856	1395	58334313442457278	28536	14099	4	0	0
9857	1395	58334313455457278	28536	14099	5	0	0
9859	1395	58335033455457278	28679	14158	4	0	0
9860	1395	58335033468457278	28679	14158	5	0	0
9865	1395	58335753481457278	28731	14177	5	0	0
9869	1395	58336473481457278	28769	14191	7	0	0
9873	1395	58336473506457278	28769	14191	8	0	0
9874	1395	58337193506457278	28791	14204	4	0	0
9875	1395	58337193519457278	28791	14204	5	0	0
9877	1395	58337913530457278	28820	14215	3	0	0
9878	1395	58338633530457278	28834	14222	6	0	0
9879	1395	58338633554457278	28834	14222	7	0	0
9881	1395	58339353554457278	28868	14239	2	0	0
9884	1395	58340073565457278	28878	14245	5	0	0
9885	1395	58340073588457278	28878	14245	6	0	0
9886	1395	58340793588457278	28930	14268	7	0	0
9887	1395	58340793613457278	28930	14268	8	0	0
9892	1395	58341513613457278	29037	14319	2	0	0
9900	1395	58342233624457278	29088	14340	3	0	0
9902	1395	58342233636457278	29088	14340	4	0	0
9903	1395	58342953636457278	29102	14346	10	0	0
9904	1395	58342953673457278	29102	14346	11	0	0
9905	1395	58343673673457278	29104	14347	2	0	0
9907	1395	58344393684457278	29123	14357	4	0	0
9908	1395	58344393697457278	29123	14357	5	0	0
9909	1395	58345113697457278	29142	14369	9	0	0
9910	1395	58345113733457278	29142	14369	10	0	0
9912	1395	58345833745457278	29175	14383	4	0	0
9913	1395	58346553745457278	29181	14386	3	0	0
9914	1395	58346553757457278	29181	14386	4	0	0
9915	1395	58347273757457278	29192	14391	4	0	0
9916	1395	58347273770457278	29192	14391	5	0	0
9920	1395	58347993793457278	29229	14403	6	0	0
9921	1395	58348713793457278	29230	14404	4	0	0
9922	1395	58348713806457278	29230	14404	5	0	0
9923	1395	58349433806457278	29234	14407	7	0	0
9924	1395	58349433831457278	29234	14407	8	0	0
9928	1395	58350153843457278	29245	14412	4	0	0
9933	1395	58352313879457278	29285	14431	3	0	\N
9934	1395	58352313879457278	29291	14434	2	0	\N
9935	1395	58352313879457278	29302	14438	5	0	\N
9937	1395	58352313890457278	29291	14434	3	0	\N
9938	1395	58352313891457278	29285	14431	4	0	\N
9940	1395	58352313902457278	29302	14438	6	0	\N
9943	1395	58353753904457278	29325	14451	3	0	\N
9944	1395	58353753904457278	29334	14455	3	0	\N
9946	1395	58353753916457278	29325	14451	4	0	\N
9947	1395	58353753916457278	29334	14455	4	0	\N
9955	1395	58356633975457278	29442	14516	14	0	\N
9956	1395	58356633975457278	29469	14532	8	0	\N
9957	1395	58356633975457278	29489	14541	7	0	\N
9960	1395	58356634000457278	29489	14541	8	0	\N
9961	1395	58356634013457278	29469	14532	9	0	\N
9962	1395	58356634025457278	29442	14516	15	0	\N
9965	1395	58358073998457278	29514	14556	4	0	\N
9966	1395	58358073998457278	29526	14561	4	0	\N
9967	1395	58358073998457278	29554	14570	8	0	\N
9968	1395	58358073998457278	29569	14578	6	0	\N
9971	1395	58358074011457278	29514	14556	5	0	\N
9972	1395	58358074011457278	29526	14561	5	0	\N
9973	1395	58358074022457278	29569	14578	7	0	\N
9974	1395	58358074024457278	29554	14570	9	0	\N
9975	1395	58358794010457278	29587	14589	8	0	\N
9977	1395	58358794036457278	29587	14589	9	0	\N
9979	1395	58359514058457278	29628	14611	2	0	\N
9981	1395	58359514060457278	29628	14611	3	0	\N
9983	1395	58359514097457278	29684	14641	5	0	\N
9986	1395	58360234097457278	29684	14641	18	0	\N
9988	1395	58360234109457270	29684	14641	19	0	\N
9989	1395	58360954090457278	29696	14647	6	0	\N
9990	1395	58360954090457278	29708	14649	6	0	\N
9991	1395	58360954090457278	29753	14665	3	0	\N
9992	1395	58360954096457278	29708	14649	7	0	\N
9993	1395	58360954102457278	29753	14665	4	0	\N
9995	1395	58360954105457278	29696	14647	7	0	\N
9996	1395	58361674103457278	29822	14695	9	0	\N
9998	1395	58361674121457278	29822	14695	10	0	\N
10002	1395	58363114142457072	29855	14715	10	0	\N
10003	1395	58363114142457072	29885	14728	9	0	\N
10004	1395	58363114142457072	29898	14732	10	0	\N
10005	1395	58363114142457072	29922	14741	8	0	\N
10007	1395	58363114159457072	29922	14741	9	0	\N
10008	1395	58363114160457072	29885	14728	10	0	\N
10009	1395	58363114161457072	29855	14715	11	0	\N
10011	1395	58363114260457072	29898	14732	11	0	\N
10012	1395	58363834170457072	29974	14761	18	0	\N
10013	1395	58363834170457072	29983	14765	19	0	\N
10016	1395	58363834206457072	29974	14761	19	0	\N
10017	1395	58363834207457072	29983	14765	20	0	\N
10027	1395	58367434303457072	30069	14805	11	0	\N
10030	1395	58367434323457072	30069	14805	12	0	\N
10033	1395	58368874376206711	30095	14816	9	0	\N
10035	1395	58368874394206711	30095	14816	10	0	\N
10037	1395	58368874458206711	30109	14820	11	0	\N
10040	1395	58369594458206711	30109	14820	53	0	\N
10041	1395	58369594499206711	30109	14820	54	0	\N
10048	1395	58372474502906275	30191	14852	10	0	\N
10050	1395	58372474529281173	30191	14852	11	1	\N
10056	1395	58374634611906275	30285	14891	6	0	\N
10057	1395	58374634611906275	30289	14892	13	0	\N
10059	1395	58374634626906275	30285	14891	7	0	\N
10060	1395	58374634642906275	30289	14892	14	0	\N
10062	1396	720000000000	168	101	4	0	\N
9929	1395	58350873843457278	29258	14420	3	0	0
9930	1395	58350873855457278	29258	14420	4	0	0
9931	1395	58351593855457278	29269	14425	6	0	0
9932	1395	58351593879457278	29269	14425	7	0	0
9936	1395	58352313879457278	29306	14441	4	0	0
9941	1395	58353033892457278	29321	14449	3	0	0
9942	1395	58353033904457278	29321	14449	4	0	0
9945	1395	58353753904457278	29352	14466	6	0	0
9948	1395	58353753928457278	29352	14466	7	0	0
9949	1395	58354473928457278	29372	14477	3	0	0
9951	1395	58355193940457278	29401	14496	4	0	0
9952	1395	58355193953457278	29401	14496	5	0	0
9953	1395	58355913953457278	29424	14506	4	0	0
9954	1395	58355913975457278	29424	14506	5	0	0
9959	1395	58356633986457278	29501	14547	3	0	0
9963	1395	58357353986457278	29504	14550	3	0	0
9964	1395	58357353998457278	29504	14550	4	0	0
9969	1395	58358073998457278	29581	14586	3	0	0
9970	1395	58358074010457278	29581	14586	4	0	0
9978	1395	58358794058457278	29596	14593	13	0	0
9980	1395	58359514058457278	29664	14631	7	0	0
9982	1395	58359514074457278	29664	14631	8	0	0
9984	1395	58360234074457278	29690	14645	7	0	0
9985	1395	58360234090457278	29690	14645	8	0	0
9994	1395	58360954103457278	29817	14691	5	0	0
9997	1395	58361674103457278	29842	14707	21	0	0
9999	1395	58361674124457278	29842	14707	22	0	0
10000	1395	58362394124457278	29849	14711	9	0	0
10006	1395	58363114142457072	29935	14745	10	0	0
10010	1395	58363114170457072	29935	14745	11	0	0
10014	1395	58363834170457072	30030	14785	13	0	0
10015	1395	58363834192457072	30030	14785	14	0	0
10018	1395	58364554192457072	30031	14786	19	0	0
10020	1395	58365274229457072	30058	14798	19	0	0
10021	1395	58365274266457072	30058	14798	20	0	0
10022	1395	58365994266457072	30066	14803	11	0	0
10023	1395	58365994286457072	30066	14803	12	0	0
10024	1395	58366714286457072	30067	14804	8	0	0
10026	1395	58366714315457072	30080	14811	3	0	0
10028	1395	58367434315457072	30080	14811	10	0	0
10029	1395	58367434321206711	30080	14811	12	1	0
10031	1395	58368154321206711	30086	14813	28	0	0
10034	1395	58368874376206711	30098	14817	26	0	0
10036	1395	58368874420206711	30098	14817	27	0	0
10038	1395	58369594420206711	30125	14825	19	0	0
10039	1395	58369594447906275	30125	14825	22	0	0
10042	1395	58370314447906275	30149	14834	10	0	0
10044	1395	58371034466906275	30162	14841	11	0	0
10045	1395	58371034486906275	30162	14841	12	0	0
10046	1395	58371754486906275	30186	14850	7	0	0
10047	1395	58371754502906275	30186	14850	8	0	0
10049	1395	58372474502906275	30203	14856	21	0	0
10052	1395	58373194565906275	30221	14860	9	0	0
10053	1395	58373194583906275	30221	14860	10	0	0
10054	1395	58373914583906275	30270	14883	19	0	0
10055	1395	58373914611906275	30270	14883	20	0	0
10061	1395	58374634747906275	30301	14894	11	0	0
10065	1396	720020000000	20413	10284	16	0	\N
10066	1396	720063000000	20413	10284	17	0	\N
10067	1396	720130000000	168	101	5	0	\N
10072	1402	200000042	13110	6757	10	0	\N
10083	1402	4320070000000	697	388	2	0	\N
10086	1402	4320090000000	697	388	3	0	\N
10089	1402	5760090000000	791	438	1	0	\N
10090	1402	5760090000000	890	495	3	0	\N
10092	1402	5760100000000	791	438	2	0	\N
10094	1402	5760111000000	890	495	4	0	\N
10107	1402	10800210000000	1186	655	3	0	\N
10110	1402	10800240000000	1186	655	4	0	\N
10117	1402	13680250000000	1310	722	1	0	\N
10119	1402	13680260000000	1310	722	2	0	\N
10121	1402	14400281000000	1415	771	1	0	\N
10123	1402	14400291000000	1415	771	2	0	\N
10129	1402	16560311000000	1513	828	2	0	\N
10130	1402	16560311000000	1668	896	2	0	\N
10132	1402	16560331000000	1513	828	3	0	\N
10133	1402	16560331000000	1668	896	3	0	\N
10135	1402	17280331000000	1692	910	2	0	\N
10136	1402	17280331000000	1807	967	1	0	\N
10138	1402	17280341000000	1807	967	2	0	\N
10140	1402	17280351000000	1692	910	3	0	\N
10143	1402	18720351000000	1968	1041	2	0	\N
10144	1402	18720351000000	1970	1042	1	0	\N
10145	1402	18720351000000	1980	1047	1	0	\N
10147	1402	18720361000000	1970	1042	2	0	\N
10148	1402	18720361000000	1980	1047	2	0	\N
10150	1402	18720371000000	1968	1041	3	0	\N
10155	1402	20160371000000	2177	1148	1	0	\N
10156	1402	20160371000000	2278	1194	1	0	\N
10158	1402	20160381000000	2177	1148	2	0	\N
10159	1402	20160381000000	2278	1194	2	0	\N
10163	1402	20880381000000	2400	1255	1	0	\N
10164	1402	20880381000000	2410	1261	1	0	\N
10165	1402	20880381000000	2483	1301	2	0	\N
10166	1402	20880381000000	2508	1316	3	0	\N
10168	1402	20880391000000	2400	1255	2	0	\N
10169	1402	20880391000000	2410	1261	2	0	\N
10170	1402	20880401000000	2483	1301	3	0	\N
10171	1402	20880411000000	2508	1316	4	0	\N
10173	1402	21062788145435	24157	12024	3	0	\N
10175	1402	21062800145435	24157	12024	4	0	\N
10176	1402	21062812145435	24205	12048	6	0	\N
10179	1402	21782788145435	24199	12046	4	0	\N
10180	1402	21782788145435	24214	12051	3	0	\N
10181	1402	21782788145435	24235	12060	4	0	\N
10182	1402	21782788145435	24298	12084	6	0	\N
10183	1402	21782788145435	24334	12101	11	0	\N
10185	1402	21782800145435	24214	12051	4	0	\N
10187	1402	21782801145435	24199	12046	5	0	\N
10188	1402	21782801145435	24235	12060	5	0	\N
10189	1402	21782812145435	24205	12048	7	0	\N
10190	1402	21782812145435	24298	12084	7	0	\N
10191	1402	21782835145435	24334	12101	12	0	\N
10192	1402	22320441000000	2581	1361	1	0	\N
10194	1402	22320451000000	2581	1361	2	0	\N
10200	1402	23222812145435	24521	12193	2	0	\N
10075	1402	720030000000	578	326	2	0	0
10076	1402	1440030000000	578	326	3	0	0
10077	1402	2160030000000	624	351	2	0	0
10078	1402	2160050000000	624	351	3	0	0
10079	1402	2880050000000	631	354	1	0	0
10081	1402	3600060000000	640	359	1	0	0
10082	1402	3600070000000	640	359	2	0	0
10084	1402	4320070000000	700	390	1	0	0
10085	1402	4320080000000	700	390	2	0	0
10087	1402	5040080000000	790	437	1	0	0
10091	1402	5760090000000	910	506	2	0	0
10093	1402	5760110000000	910	506	3	0	0
10095	1402	6480110000000	930	518	2	0	0
10096	1402	6480130000000	930	518	3	0	0
10098	1402	7200140000000	1042	579	2	0	0
10099	1402	7920140000000	1047	581	1	0	0
10100	1402	7920150000000	1047	581	2	0	0
10101	1402	8640150000000	1049	582	4	0	0
10102	1402	8640190000000	1049	582	5	0	0
10104	1402	9360200000000	1143	631	2	0	0
10105	1402	10080200000000	1171	644	1	0	0
10106	1402	10080210000000	1171	644	2	0	0
10108	1402	10800210000000	1197	660	1	0	0
10109	1402	10800220000000	1197	660	2	0	0
10112	1402	11520230000000	1225	675	2	0	0
10113	1402	12240230000000	1246	690	1	0	0
10114	1402	12240240000000	1246	690	2	0	0
10115	1402	12960240000000	1301	717	1	0	0
10118	1402	13680250000000	1356	744	4	0	0
10120	1402	13680281000000	1356	744	5	0	0
10122	1402	14400281000000	1427	776	1	0	0
10124	1402	14400291000000	1427	776	2	0	0
10125	1402	15120291000000	1446	786	1	0	0
10127	1402	15840301000000	1461	796	1	0	0
10128	1402	15840311000000	1461	796	2	0	0
10131	1402	16560311000000	1670	897	2	0	0
10134	1402	16560331000000	1670	897	3	0	0
10137	1402	17280331000000	1827	977	1	0	0
10141	1402	18000341000000	1912	1018	1	0	0
10142	1402	18000351000000	1912	1018	2	0	0
10146	1402	18720351000000	2053	1085	1	0	0
10149	1402	18720361000000	2053	1085	2	0	0
10152	1402	19440371000000	2074	1096	2	0	0
10157	1402	20160371000000	2315	1211	1	0	0
10160	1402	20160381000000	2315	1211	2	0	0
10167	1402	20880381000000	2549	1341	4	0	0
10172	1402	20880421000000	2549	1341	5	0	0
10178	1402	21600441000000	2554	1345	3	0	0
10193	1402	22320441000000	2591	1365	1	0	0
10195	1402	22320451000000	2591	1365	2	0	0
10198	1402	23040451000000	2866	1500	3	0	0
10199	1402	23040481000000	2866	1500	4	0	0
10069	1398	720010000000	5746	2978	2	0	0
10070	1398	1440010000000	10073	5224	13	0	0
10071	1398	1440131000000	10073	5224	14	0	0
10153	1402	19622767145435	24041	11963	2	0	66
10161	1402	20342778145435	24151	12020	1	0	66
10162	1402	20342788145435	24151	12020	2	0	66
10174	1402	21062788145435	24162	12026	0	0	66
10184	1402	21782788145435	24408	12138	3	0	66
10186	1402	21782800145435	24408	12138	4	0	66
10197	1402	22502812145435	24429	12149	4	0	66
10202	1402	23222823145435	24521	12193	3	0	\N
10208	1402	24480501000000	3011	1564	1	0	\N
10210	1402	24480511000000	3011	1564	2	0	\N
10214	1402	25200531000000	3148	1637	2	0	\N
10215	1402	25200531000000	3194	1658	1	0	\N
10216	1402	25200531000000	3206	1666	1	0	\N
10218	1402	25200541000000	3194	1658	2	0	\N
10219	1402	25200541000000	3206	1666	2	0	\N
10220	1402	25200551000000	3148	1637	3	0	\N
10224	1402	25739782421307	23995	11940	1	0	\N
10225	1402	25739792421307	23995	11940	2	0	\N
10232	1402	26822903145435	24618	12234	17	0	\N
10235	1402	26822965145435	24618	12234	18	0	\N
10240	1402	28080661000000	3400	1768	1	0	\N
10242	1402	28080671000000	3400	1768	2	0	\N
10245	1402	28800661000000	3479	1806	0	0	\N
10247	1402	28982991145435	24881	12353	4	0	\N
10250	1402	28983013145435	24881	12353	5	0	\N
10257	1402	30423015145435	25034	12421	3	0	\N
10258	1402	30423015145435	25100	12457	3	0	\N
10259	1402	30423015145435	25113	12462	3	0	\N
10261	1402	30423027145435	25100	12457	4	0	\N
10262	1402	30423027145435	25113	12462	4	0	\N
10264	1402	30423036145435	25034	12421	4	0	\N
10267	1402	31143027145435	25208	12505	3	0	\N
10268	1402	31143027145435	25235	12516	5	0	\N
10270	1402	31143039145435	25208	12505	4	0	\N
10271	1402	31143041145435	25235	12516	6	0	\N
10273	1402	31680701000000	3879	2014	1	0	\N
10275	1402	31680711000000	3879	2014	2	0	\N
10279	1402	32254029319298	13110	6757	6	0	\N
10285	1402	32974029319297	13110	6757	9	0	\N
10287	1402	33120731000000	3992	2072	1	0	\N
10288	1402	33120731000000	4099	2131	2	0	\N
10289	1402	33120731000000	4133	2150	1	0	\N
10291	1402	33120741000000	3992	2072	2	0	\N
10292	1402	33120741000000	4133	2150	2	0	\N
10293	1402	33120751000000	4099	2131	3	0	\N
10295	1402	33303065145435	25342	12566	3	0	\N
10296	1402	33303065145435	25346	12568	3	0	\N
10298	1402	33303077145435	25342	12566	4	0	\N
10299	1402	33303077145435	25346	12568	4	0	\N
10301	1402	33694059319298	13164	6783	5	0	\N
10304	1402	33694073319298	13164	6783	6	0	\N
10315	1402	35134096319298	13591	6990	3	0	\N
10317	1402	35134108319298	13591	6990	4	0	\N
10323	1402	35854120319298	13797	7085	4	0	\N
10325	1402	35854133319298	13797	7085	5	0	\N
10327	1402	36000811000000	4751	2455	1	0	\N
10329	1402	36000821000000	4751	2455	2	0	\N
10331	1402	36183139145435	25800	12757	2	0	\N
10333	1402	36183150145435	25800	12757	3	0	\N
10335	1402	36574146319298	13820	7096	7	0	\N
10336	1402	36574146319298	13859	7113	4	0	\N
10209	1402	24480501000000	3050	1585	3	0	0
10211	1402	24480531000000	3050	1585	4	0	0
10217	1402	25200531000000	3234	1679	8	0	0
10221	1402	25200611000000	3234	1679	9	0	0
10226	1402	25920611000000	3334	1730	3	0	0
10230	1402	26640641000000	3357	1744	1	0	0
10231	1402	26640651000000	3357	1744	2	0	0
10236	1402	27360651000000	3388	1763	1	0	0
10237	1402	27360661000000	3388	1763	2	0	0
10241	1402	28080661000000	3465	1799	0	0	0
10251	1402	29520661000000	3687	1915	2	0	0
10252	1402	29520681000000	3687	1915	3	0	0
10255	1402	30240681000000	3723	1932	1	0	0
10256	1402	30240691000000	3723	1932	2	0	0
10266	1402	30960701000000	3853	2000	2	0	0
10274	1402	31680701000000	3943	2047	2	0	0
10276	1402	31680721000000	3943	2047	3	0	0
10280	1402	32400721000000	3977	2065	1	0	0
10281	1402	32400731000000	3977	2065	2	0	0
10294	1402	33120751000000	4147	2158	3	0	0
10305	1402	33840751000000	4289	2223	1	0	0
10306	1402	33840761000000	4289	2223	2	0	0
10311	1402	34560761000000	4390	2276	3	0	0
10312	1402	34560791000000	4390	2276	4	0	0
10320	1402	35280811000000	4738	2450	3	0	0
10328	1402	36000811000000	4772	2466	1	0	0
10330	1402	36000821000000	4772	2466	2	0	0
10284	1402	32974005319298	13154	6778	9	0	33
10302	1402	33694059319298	13320	6863	3	0	33
10303	1402	33694071319298	13320	6863	4	0	33
10309	1402	34414071319298	13326	6868	7	0	33
10310	1402	34414096319298	13326	6868	8	0	33
10316	1402	35134096319298	13784	7080	6	0	33
10324	1402	35854120319298	13812	7092	8	0	33
10326	1402	35854146319298	13812	7092	9	0	33
10201	1402	23222812145435	24565	12212	2	0	66
10203	1402	23222823145435	24565	12212	3	0	66
10206	1402	23942823145435	24575	12216	2	0	66
10212	1402	24662834145435	24578	12218	2	0	66
10213	1402	24662845145435	24578	12218	3	0	66
10222	1402	25382845145435	24590	12224	6	0	66
10223	1402	25382878145435	24590	12224	7	0	66
10229	1402	26102903145435	24606	12231	8	0	66
10233	1402	26822903145435	24820	12325	13	0	66
10234	1402	26822953145435	24820	12325	14	0	66
10238	1402	27542953145435	24832	12329	3	0	66
10239	1402	27542965145435	24832	12329	4	0	66
10244	1402	28262991145435	24861	12344	9	0	66
10248	1402	28982991145435	24897	12362	4	0	66
10249	1402	28983004145435	24897	12362	5	0	66
10253	1402	29703004145435	25028	12417	2	0	66
10254	1402	29703015145435	25028	12417	3	0	66
10263	1402	30423027145435	25177	12492	4	0	66
10269	1402	31143027145435	25267	12534	6	0	66
10272	1402	31143051145435	25267	12534	7	0	66
10277	1402	31863051145435	25289	12545	2	0	66
10282	1402	32583053145435	25293	12547	3	0	66
10283	1402	32583065145435	25293	12547	4	0	66
10297	1402	33303065145435	25490	12624	3	0	66
10300	1402	33303077145435	25490	12624	4	0	66
10307	1402	34023077145435	25683	12707	10	0	66
10313	1402	34743114145435	25704	12717	4	0	66
10314	1402	34743127145435	25704	12717	5	0	66
10321	1402	35463127145435	25721	12724	3	0	66
10322	1402	35463139145435	25721	12724	4	0	66
10332	1402	36183139145435	25804	12759	3	0	66
10338	1402	36574159319298	13859	7113	5	0	\N
10340	1402	36574162319298	13820	7096	8	0	\N
10347	1402	37440831000000	4903	2538	1	0	\N
10349	1402	37440841000000	4903	2538	2	0	\N
10351	1402	37623188145435	25870	12788	3	0	\N
10354	1402	37623200145435	25870	12788	4	0	\N
10363	1402	38880951000000	5080	2636	2	0	\N
10364	1402	38880951000000	5133	2661	4	0	\N
10365	1402	38880951000000	5312	2762	1	0	\N
10366	1402	38880951000000	5331	2767	1	0	\N
10368	1402	38880961000000	5312	2762	2	0	\N
10369	1402	38880961000000	5331	2767	2	0	\N
10370	1402	38880962000000	5080	2636	3	0	\N
10372	1402	38880991000000	5133	2661	5	0	\N
10375	1402	39454192319298	14151	7224	3	0	\N
10376	1402	39454192319298	14209	7253	4	0	\N
10378	1402	39454204319298	14151	7224	4	0	\N
10379	1402	39454205319298	14209	7253	5	0	\N
10381	1402	39600971000000	5415	2818	1	0	\N
10383	1402	39600972000000	5415	2818	2	0	\N
10386	1402	40174228319298	14285	7292	4	0	\N
10388	1402	40174241319298	14285	7292	5	0	\N
10390	1402	40320971000000	5492	2857	0	0	\N
10396	1402	41040971000000	5530	2876	0	0	\N
10400	1402	41614267319298	14374	7334	3	0	\N
10401	1402	41614267319298	14533	7412	2	0	\N
10403	1402	41614278319298	14533	7412	3	0	\N
10404	1402	41614279319298	14374	7334	4	0	\N
10406	1402	41760971000000	5549	2885	0	0	\N
10407	1402	41760971000000	5585	2905	0	0	\N
10409	1402	41943322145435	26140	12921	2	0	\N
10412	1402	41943333145435	26140	12921	3	0	\N
10413	1402	42334297319298	14777	7525	6	0	\N
10416	1402	42334330319298	14777	7525	7	0	\N
10417	1402	42480971000000	5729	2968	0	0	\N
10422	1402	43054310319298	15052	7666	0	0	\N
10423	1402	43054310319298	15053	7667	0	0	\N
10427	1402	43201181000000	5851	3035	1	0	\N
10429	1402	43201191000000	5851	3035	2	0	\N
10434	1402	43921191000000	5968	3095	2	0	\N
10435	1402	43921191000000	6087	3160	1	0	\N
10437	1402	43921191000000	6627	3137	0	0	\N
10438	1402	43921191000000	6628	3143	0	0	\N
10439	1402	43921191000000	6629	3147	0	0	\N
10440	1402	43921201000000	6087	3160	2	0	\N
10442	1402	43921211000000	5968	3095	3	0	\N
10445	1402	44103674145435	26455	13068	68	0	\N
10446	1402	44494321319298	15139	7717	2	0	\N
10447	1402	44494321319298	15185	7737	2	0	\N
10449	1402	44494332319298	15139	7717	3	0	\N
10450	1402	44494332319298	15185	7737	3	0	\N
10452	1402	44641201000000	6174	3197	4	0	\N
10453	1402	44641201000000	6177	3199	5	0	\N
10456	1402	44641241000000	6174	3197	5	0	\N
10457	1402	44641251000000	6177	3199	6	0	\N
10460	1402	44823674145435	26455	13068	88	0	\N
10461	1402	44823693145435	26455	13068	89	0	\N
10462	1402	44824483145435	26564	13069	106	0	\N
10463	1402	45214386319298	15313	7802	3	0	\N
10465	1402	45214398319298	15313	7802	4	0	\N
10471	1402	45544483145435	26564	13069	126	0	\N
10472	1402	45544502145435	26564	13069	127	0	\N
10348	1402	37440831000000	4906	2539	1	0	0
10350	1402	37440841000000	4906	2539	2	0	0
10357	1402	38160841000000	5023	2608	2	0	0
10358	1402	38160951000000	5023	2608	3	0	0
10367	1402	38880951000000	5367	2788	2	0	0
10382	1402	39600971000000	5467	2847	0	0	0
10391	1402	40320971000000	5518	2870	0	0	0
10397	1402	41040971000000	5533	2877	0	0	0
10408	1402	41760971000000	5601	2910	0	0	0
10418	1402	42480971000000	5788	3003	3	0	0
10428	1402	43201181000000	5852	3036	1	0	0
10430	1402	43201191000000	5852	3036	2	0	0
10436	1402	43921191000000	6154	3188	1	0	0
10441	1402	43921201000000	6154	3188	2	0	0
10455	1402	44641211000000	6194	3207	2	0	0
10467	1402	45361211000000	6215	3216	1	0	0
10468	1402	45361221000000	6215	3216	2	0	0
10337	1402	36574146319298	13942	7144	4	0	33
10339	1402	36574159319298	13942	7144	5	0	33
10346	1402	37294169319298	14035	7189	2	0	33
10355	1402	38014169319298	14089	7206	1	0	33
10356	1402	38014179319298	14089	7206	2	0	33
10361	1402	38734179319298	14126	7219	4	0	33
10362	1402	38734192319298	14126	7219	5	0	33
10380	1402	39454228319298	14241	7269	10	0	33
10387	1402	40174228319298	14334	7315	4	0	33
10389	1402	40174241319298	14334	7315	5	0	33
10394	1402	40894241319298	14339	7319	8	0	33
10402	1402	41614267319298	14644	7463	12	0	33
10405	1402	41614297319298	14644	7463	13	0	33
10414	1402	42334297319298	14888	7586	4	0	33
10415	1402	42334310319298	14888	7586	5	0	33
10424	1402	43054310319298	15072	7675	1	0	33
10426	1402	43054321319298	15104	7696	1	0	33
10433	1402	43774321319298	15104	7696	2	0	33
10448	1402	44494321319298	15190	7739	11	0	33
10451	1402	44494386319298	15190	7739	12	0	33
10464	1402	45214386319298	15326	7811	3	0	33
10343	1402	36903151145435	25850	12780	10	0	66
10344	1402	36903188145435	25850	12780	11	0	66
10352	1402	37623188145435	25886	12794	2	0	66
10353	1402	37623199145435	25886	12794	3	0	66
10360	1402	38343255145435	25896	12799	12	0	66
10373	1402	39063255145435	25971	12831	2	0	66
10374	1402	39063266145435	25971	12831	3	0	66
10384	1402	39783266145435	25978	12836	4	0	66
10385	1402	39783288145435	25978	12836	5	0	66
10393	1402	40503300145435	26007	12853	4	0	66
10398	1402	41223300145435	26118	12910	4	0	66
10399	1402	41223322145435	26118	12910	5	0	66
10410	1402	41943322145435	26201	12953	2	0	66
10411	1402	41943324145435	26201	12953	3	0	66
10421	1402	42663336145435	26256	12983	4	0	66
10431	1402	43383336145435	26262	12986	7	0	66
10432	1402	43383361145435	26262	12986	8	0	66
10443	1402	44103361145435	26342	13027	2	0	66
10458	1402	44823372145435	26879	13293	3	0	66
10459	1402	44823384145435	26879	13293	4	0	66
10469	1402	45543384145435	26889	13297	3	0	66
10470	1402	45543396145435	26889	13297	4	0	66
10473	1402	45545131145435	26651	13070	106	0	\N
10474	1402	45934398319298	15362	7820	0	0	\N
10475	1402	45934398319298	15363	7824	0	0	\N
10482	1402	46265131145435	26651	13070	126	0	\N
10483	1402	46265150145435	26651	13070	127	0	\N
10484	1402	46654410319298	15679	7978	4	0	\N
10487	1402	46654423319298	15679	7978	5	0	\N
10488	1402	46801231000000	6318	3271	1	0	\N
10490	1402	46801241000000	6318	3271	2	0	\N
10493	1402	46985150145435	26681	13071	6	0	\N
10494	1402	46985210145435	26681	13071	7	0	\N
10503	1402	48241251000000	6835	3538	2	0	\N
10505	1402	48241271000000	6835	3538	3	0	\N
10507	1402	48423444145435	27214	13460	21	0	\N
10510	1402	48423528145435	27214	13460	22	0	\N
10511	1402	48814470319298	15887	8077	6	0	\N
10514	1402	48814494319298	15887	8077	7	0	\N
10515	1402	48961271000000	6899	3565	2	0	\N
10517	1402	48961291000000	6899	3565	3	0	\N
10519	1402	49143456145435	27243	13471	4	0	\N
10520	1402	49143456145435	27347	13521	3	0	\N
10522	1402	49143468145435	27347	13521	4	0	\N
10523	1402	49143469145435	27243	13471	5	0	\N
10525	1402	49534482319298	15902	8086	6	0	\N
10526	1402	49534482319298	15986	8126	3	0	\N
10528	1402	49534494319298	15986	8126	4	0	\N
10530	1402	49534506319298	15902	8086	7	0	\N
10531	1402	49534519319298	16139	8204	6	0	\N
10537	1402	50254495319298	16134	8203	7	0	\N
10539	1402	50254519319298	16139	8204	7	0	\N
10540	1402	50254520319298	16134	8203	8	0	\N
10550	1402	51303557145435	27564	13624	3	0	\N
10552	1402	51303569145435	27564	13624	4	0	\N
10556	1402	51841591000000	7066	3648	3	0	\N
10557	1402	51841591000000	7073	3651	2	0	\N
10558	1402	51841591000000	7099	3665	2	0	\N
10559	1402	51841591000000	7142	3691	3	0	\N
10562	1402	51841611000000	7073	3651	3	0	\N
10563	1402	51841611000000	7099	3665	3	0	\N
10564	1402	51841621000000	7142	3691	4	0	\N
10565	1402	51841711000000	7066	3648	4	0	\N
10567	1402	52414557319298	16452	8368	8	0	\N
10568	1402	52414557319298	16502	8395	8	0	\N
10571	1402	52414592319298	16452	8368	9	0	\N
10572	1402	52414592319298	16502	8395	9	0	\N
10575	1402	52743581145435	27687	13682	6	0	\N
10578	1402	52743605145435	27687	13682	7	0	\N
10583	1402	53463593145435	27842	13762	9	0	\N
10586	1402	53463629145435	27842	13762	10	0	\N
10587	1402	53854581319298	16815	8534	2	0	\N
10589	1402	53854592319298	16815	8534	3	0	\N
10593	1402	54183605145435	28033	13864	15	0	\N
10596	1402	54183665145435	28033	13864	16	0	\N
10597	1402	54574592319298	17020	8622	7	0	\N
10600	1402	54574617319298	17020	8622	8	0	\N
10601	1402	54721731000000	7420	3834	0	0	\N
10604	1402	54903617145435	28159	13925	7	0	\N
10607	1402	54903651145435	28159	13925	8	0	\N
10489	1402	46801231000000	6395	3315	0	0	0
10497	1402	47521231000000	6750	3494	2	0	0
10498	1402	47521251000000	6750	3494	3	0	0
10504	1402	48241251000000	6887	3558	2	0	0
10506	1402	48241271000000	6887	3558	3	0	0
10518	1402	48961291000000	6905	3568	3	0	0
10532	1402	49681291000000	6947	3585	3	0	0
10533	1402	49681411000000	6947	3585	4	0	0
10534	1402	49681531000000	7042	3634	3	0	0
10542	1402	50401531000000	7042	3634	6	0	0
10548	1402	51121551000000	7046	3637	4	0	0
10549	1402	51121591000000	7046	3637	5	0	0
10560	1402	51841591000000	7246	3746	1	0	0
10561	1402	51841601000000	7246	3746	2	0	0
10574	1402	52561631000000	7261	3756	4	0	0
10581	1402	53281631000000	7321	3784	1	0	0
10582	1402	53281641000000	7321	3784	2	0	0
10591	1402	54001641000000	7355	3801	9	0	0
10592	1402	54001731000000	7355	3801	10	0	0
10603	1402	54721751000000	7495	3877	3	0	0
10476	1402	45934398319298	15660	7970	3	0	33
10477	1402	45934410319298	15660	7970	4	0	33
10485	1402	46654410319298	15724	7995	3	0	33
10486	1402	46654422319298	15724	7995	4	0	33
10496	1402	47374446319298	15756	8012	7	0	33
10501	1402	48094446319298	15785	8029	6	0	33
10502	1402	48094470319298	15785	8029	7	0	33
10512	1402	48814470319298	15896	8083	3	0	33
10527	1402	49534482319298	16101	8184	4	0	33
10529	1402	49534495319298	16101	8184	5	0	33
10538	1402	50254495319298	16226	8248	7	0	33
10541	1402	50254520319298	16226	8248	8	0	33
10546	1402	50974520319298	16274	8272	3	0	33
10554	1402	51694532319298	16375	8329	7	0	33
10555	1402	51694557319298	16375	8329	8	0	33
10569	1402	52414557319298	16658	8463	3	0	33
10570	1402	52414569319298	16658	8463	4	0	33
10579	1402	53134569319298	16791	8522	3	0	33
10588	1402	53854581319298	16824	8539	2	0	33
10590	1402	53854592319298	16824	8539	3	0	33
10598	1402	54574592319298	17190	8711	4	0	33
10599	1402	54574605319298	17190	8711	5	0	33
10480	1402	46263396145435	26966	13338	3	0	66
10481	1402	46263408145435	26966	13338	4	0	66
10491	1402	46983408145435	27084	13392	6	0	66
10492	1402	46983432145435	27084	13392	7	0	66
10499	1402	47703432145435	27089	13393	3	0	66
10508	1402	48423444145435	27236	13467	3	0	66
10509	1402	48423456145435	27236	13467	4	0	66
10521	1402	49143456145435	27353	13524	6	0	66
10524	1402	49143480145435	27353	13524	7	0	66
10535	1402	49863480145435	27395	13546	15	0	66
10544	1402	50583540145435	27485	13585	8	0	66
10545	1402	50583557145435	27485	13585	9	0	66
10551	1402	51303557145435	27581	13631	6	0	66
10553	1402	51303581145435	27581	13631	7	0	66
10576	1402	52743581145435	27839	13761	3	0	66
10577	1402	52743593145435	27839	13761	4	0	66
10584	1402	53463593145435	27937	13820	3	0	66
10585	1402	53463605145435	27937	13820	4	0	66
10594	1402	54183605145435	28061	13875	3	0	66
10605	1402	54903617145435	28257	13971	2	0	66
10606	1402	54903628145435	28257	13971	3	0	66
10614	1402	56014618319298	17244	8735	3	0	\N
10617	1402	56014630319298	17244	8735	4	0	\N
10618	1402	56014651319298	17438	8833	4	0	\N
10619	1402	56161762000000	7544	3905	2	0	\N
10622	1402	56161782000000	7544	3905	3	0	\N
10626	1402	56734651319298	17438	8833	7	0	\N
10627	1402	56734653319298	17438	8833	8	0	\N
10631	1402	57063650145435	28469	14068	4	0	\N
10633	1402	57063672145435	28469	14068	5	0	\N
10635	1402	57454692319298	17593	8900	3	0	\N
10636	1402	57454692319298	17725	8958	3	0	\N
10637	1402	57454692319298	17828	9004	3	0	\N
10640	1402	57454704319298	17593	8900	4	0	\N
10641	1402	57454704319298	17725	8958	4	0	\N
10642	1402	57454704319298	17828	9004	4	0	\N
10643	1402	57601782000000	7771	4030	1	0	\N
10645	1402	57601792000000	7771	4030	2	0	\N
10647	1402	57783686812105	28515	14090	4	0	\N
10649	1402	57783699812105	28515	14090	5	0	\N
10651	1402	58174694319298	18036	9099	3	0	\N
10652	1402	58174694319298	18118	9137	11	0	\N
10655	1402	58174706319298	18036	9099	4	0	\N
10656	1402	58174750319298	18118	9137	12	0	\N
10657	1402	58321792000000	7919	4104	3	0	\N
10660	1402	58321822000000	7919	4104	4	0	\N
10663	1402	58894705319298	18298	9219	2	0	\N
10665	1402	58894716319298	18298	9219	3	0	\N
10673	1402	59762462000000	8050	4170	1	0	\N
10675	1402	59762472000000	8050	4170	2	0	\N
10685	1402	61054761319298	18584	9366	4	0	\N
10686	1402	61054761319298	18775	9461	2	0	\N
10687	1402	61054761319298	18894	9530	2	0	\N
10690	1402	61054772319298	18775	9461	3	0	\N
10691	1402	61054772319298	18894	9530	3	0	\N
10692	1402	61054783319298	18584	9366	5	0	\N
10698	1402	61774771319298	18989	9576	1	0	\N
10700	1402	61774781319298	18989	9576	2	0	\N
10702	1402	61922512000000	8139	4221	2	0	\N
10705	1402	61922532000000	8139	4221	3	0	\N
10714	1402	63214791319298	19101	9634	6	0	\N
10715	1402	63214791319298	19132	9649	6	0	\N
10716	1402	63214791319298	19188	9681	3	0	\N
10718	1402	63214803319298	19188	9681	4	0	\N
10720	1402	63214815319298	19101	9634	7	0	\N
10721	1402	63214815319298	19132	9649	7	0	\N
10722	1402	63362542000000	8252	4273	1	0	\N
10724	1402	63362552000000	8252	4273	2	0	\N
10728	1402	63934803319298	19371	9766	5	0	\N
10730	1402	63934817319298	19371	9766	6	0	\N
10732	1402	64082552000000	8395	4350	2	0	\N
10735	1402	64082567000000	8395	4350	3	0	\N
10738	1402	64654825319298	19425	9790	4	0	\N
10739	1402	64654825319298	19459	9809	3	0	\N
10741	1402	64654837319298	19459	9809	4	0	\N
10743	1402	64654838319298	19425	9790	5	0	\N
10744	1402	64802562000000	8497	4401	1	0	\N
10620	1402	56161762000000	7660	3965	1	0	0
10621	1402	56161772000000	7660	3965	2	0	0
10629	1402	56881772000000	7747	4016	1	0	0
10630	1402	56881782000000	7747	4016	2	0	0
10644	1402	57601782000000	7857	4074	1	0	0
10658	1402	58321792000000	7964	4127	1	0	0
10659	1402	58321802000000	7964	4127	2	0	0
10667	1402	59041802000000	8034	4164	12	0	0
10668	1402	59042462000000	8034	4164	13	0	0
10674	1402	59762462000000	8071	4184	2	0	0
10681	1402	60482482000000	8092	4196	1	0	0
10682	1402	60482492000000	8092	4196	2	0	0
10693	1402	61202492000000	8137	4220	2	0	0
10694	1402	61202512000000	8137	4220	3	0	0
10704	1402	61922522000000	8171	4234	2	0	0
10710	1402	62642522000000	8178	4236	2	0	0
10711	1402	62642542000000	8178	4236	3	0	0
10723	1402	63362542000000	8258	4276	1	0	0
10725	1402	63362552000000	8258	4276	2	0	0
10734	1402	64082562000000	8466	4386	2	0	0
10609	1402	55294618319298	17227	8728	5	0	33
10615	1402	56014618319298	17370	8798	2	0	33
10616	1402	56014629319298	17370	8798	3	0	33
10625	1402	56734629319298	17489	8853	9	0	33
10638	1402	57454692319298	17910	9034	2	0	33
10639	1402	57454694319298	17910	9034	3	0	33
10653	1402	58174694319298	18264	9200	2	0	33
10654	1402	58174705319298	18264	9200	3	0	33
10666	1402	58894716319298	18338	9239	3	0	33
10671	1402	59614716319298	18494	9315	4	0	33
10672	1402	59614738319298	18494	9315	5	0	33
10679	1402	60334738319298	18579	9362	5	0	33
10680	1402	60334761319298	18579	9362	6	0	33
10689	1402	61054771319298	18930	9549	2	0	33
10699	1402	61774771319298	19025	9591	1	0	33
10701	1402	61774781319298	19025	9591	2	0	33
10708	1402	62494781319298	19088	9628	1	0	33
10709	1402	62494791319298	19088	9628	2	0	33
10719	1402	63214803319298	19344	9753	4	0	33
10729	1402	63934803319298	19395	9775	4	0	33
10731	1402	63934825319298	19395	9775	5	0	33
10740	1402	64654825319298	19471	9815	3	0	33
10612	1402	55623628145435	28299	13989	2	0	66
10613	1402	55623639145435	28299	13989	3	0	66
10623	1402	56343639145435	28319	14001	2	0	66
10624	1402	56343650145435	28319	14001	3	0	66
10632	1402	57063650145435	28490	14080	7	0	66
10648	1402	57783686812105	28593	14121	9	0	66
10650	1402	57783740812105	28593	14121	10	0	66
10661	1402	58503740812105	28664	14152	2	0	66
10662	1402	58503751812105	28664	14152	3	0	66
10669	1402	59223751812105	28668	14154	4	0	66
10677	1402	59943773812105	28816	14212	3	0	66
10678	1402	59943785812105	28816	14212	4	0	66
10683	1402	60663785812105	28819	14214	3	0	66
10684	1402	60663797812105	28819	14214	4	0	66
10696	1402	61383821812105	28835	14223	7	0	66
10697	1402	61384095812105	28982	14292	4	0	66
10706	1402	62104095812105	28982	14292	9	0	66
10707	1402	62104099812105	28982	14292	10	0	66
10712	1402	62824099812105	29055	14328	6	0	66
10726	1402	63544123812105	29066	14331	4	0	66
10727	1402	63544136812105	29066	14331	5	0	66
10736	1402	64264136812105	29140	14368	3	0	66
10737	1402	64264148812105	29140	14368	4	0	66
10746	1402	64802572000000	8497	4401	2	0	\N
10750	1402	65374837319298	19505	9831	6	0	\N
10751	1402	65374837319298	19514	9833	3	0	\N
10752	1402	65374837319298	19522	9836	3	0	\N
10754	1402	65374849319298	19514	9833	4	0	\N
10755	1402	65374849319298	19522	9836	4	0	\N
10757	1402	65374861319298	19505	9831	7	0	\N
10760	1402	65704160812105	29342	14461	6	0	\N
10761	1402	65704160812105	29368	14475	3	0	\N
10763	1402	65704172812105	29368	14475	4	0	\N
10765	1402	65704184812105	29342	14461	7	0	\N
10768	1402	66242582000000	8643	4477	1	0	\N
10769	1402	66242582000000	8655	4484	1	0	\N
10770	1402	66242582000000	8675	4495	0	0	\N
10772	1402	66242592000000	8643	4477	2	0	\N
10773	1402	66242592000000	8655	4484	2	0	\N
10785	1402	67682612000000	8763	4547	2	0	\N
10787	1402	67682632000000	8763	4547	3	0	\N
10793	1402	68402632000000	8792	4558	4	0	\N
10794	1402	68402632000000	8864	4593	2	0	\N
10796	1402	68402652000000	8864	4593	3	0	\N
10798	1402	68402672000000	8792	4558	5	0	\N
10801	1402	68974898319298	19840	9996	4	0	\N
10802	1402	68974898319298	19932	10038	5	0	\N
10804	1402	68974911319298	19840	9996	5	0	\N
10806	1402	68974921319298	19932	10038	6	0	\N
10811	1402	69694911319298	20062	10101	3	0	\N
10813	1402	69694923319298	20062	10101	4	0	\N
10823	1402	70562752000000	9181	4757	4	0	\N
10827	1402	71134937319298	20342	10245	5	0	\N
10830	1402	71134960319298	20342	10245	6	0	\N
10831	1402	71282712000000	9311	4831	3	0	\N
10833	1402	71282733000000	9311	4831	4	0	\N
10834	1402	71282752000000	9181	4757	7	0	\N
10836	1402	71282772000000	9181	4757	8	0	\N
10847	1402	72574984319298	20426	10290	2	0	\N
10853	1402	73294984319298	20426	10290	4	0	\N
10854	1402	73294985319298	20426	10290	5	0	\N
10856	1402	73442803000000	9666	5017	2	0	\N
10857	1402	73442803000000	9669	5019	2	0	\N
10858	1402	73442803000000	9672	5020	5	0	\N
10859	1402	73442803000000	9721	5039	4	0	\N
10860	1402	73442803000000	9797	5080	3	0	\N
10861	1402	73442803000000	9813	5087	6	0	\N
10863	1402	73442823000000	9666	5017	3	0	\N
10864	1402	73442823000000	9669	5019	3	0	\N
10866	1402	73442833000000	9797	5080	4	0	\N
10867	1402	73442834000000	9721	5039	5	0	\N
10868	1402	73442844000000	9672	5020	6	0	\N
10869	1402	73442854000000	9813	5087	7	0	\N
10873	1402	74162823000000	9878	5124	2	0	\N
10874	1402	74162823000000	10003	5186	2	0	\N
10876	1402	74162843000000	9878	5124	3	0	\N
10877	1402	74162843000000	10003	5186	3	0	\N
10758	1402	65522572000000	8616	4466	1	0	0
10759	1402	65522582000000	8616	4466	2	0	0
10771	1402	66242582000000	8690	4504	1	0	0
10774	1402	66242592000000	8690	4504	2	0	0
10779	1402	66962592000000	8741	4536	2	0	0
10786	1402	67682612000000	8788	4557	2	0	0
10788	1402	67682632000000	8788	4557	3	0	0
10795	1402	68402632000000	8962	4647	2	0	0
10797	1402	68402652000000	8962	4647	3	0	0
10807	1402	69122652000000	9054	4693	2	0	0
10815	1402	69842672000000	9075	4707	2	0	0
10816	1402	69842692000000	9075	4707	3	0	0
10821	1402	70562692000000	9106	4719	2	0	0
10822	1402	70562712000000	9106	4719	3	0	0
10835	1402	71282752000000	9562	4959	5	0	0
10841	1402	72002752000000	9624	4993	3	0	0
10842	1402	72002773000000	9624	4993	4	0	0
10848	1402	72722773000000	9663	5015	3	0	0
10849	1402	72722803000000	9663	5015	4	0	0
10865	1402	73442823000000	9870	5119	3	0	0
10875	1402	74162823000000	10061	5218	14	0	0
10878	1402	74162963000000	10061	5218	15	0	0
10880	1402	74882963000000	10158	5265	2	0	0
10753	1402	65374837319298	19623	9883	3	0	33
10766	1402	66094849319298	19630	9888	3	0	33
10767	1402	66094861319298	19630	9888	4	0	33
10777	1402	66814861319298	19789	9966	3	0	33
10778	1402	66814873319298	19789	9966	4	0	33
10784	1402	67534885319298	19797	9970	4	0	33
10791	1402	68254885319298	19835	9992	4	0	33
10792	1402	68254898319298	19835	9992	5	0	33
10803	1402	68974898319298	20051	10093	4	0	33
10805	1402	68974911319298	20051	10093	5	0	33
10814	1402	69694923319298	20201	10174	4	0	33
10819	1402	70414923319298	20270	10209	5	0	33
10820	1402	70414937319298	20270	10209	6	0	33
10828	1402	71134937319298	20357	10253	3	0	33
10829	1402	71134949319298	20357	10253	4	0	33
10840	1402	71854961319298	20384	10270	4	0	33
10845	1402	72574961319298	20406	10281	3	0	33
10846	1402	72574973319298	20406	10281	4	0	33
10852	1402	73294973319298	20448	10298	3	0	33
10870	1402	74014985319298	20776	10440	5	0	33
10871	1402	74015026319298	20776	10440	6	0	33
10872	1402	74015036319298	20797	10453	1	0	33
10879	1402	74735036319298	20797	10453	2	0	33
10748	1402	64984148812105	29173	14382	3	0	66
10762	1402	65704160812105	29395	14492	5	0	66
10764	1402	65704174812105	29395	14492	6	0	66
10775	1402	66424174812105	29473	14535	4	0	66
10776	1402	66424187812105	29473	14535	5	0	66
10781	1402	67144187812105	29513	14556	4	0	66
10789	1402	67864200812105	29632	14613	11	0	66
10790	1402	67864238812105	29632	14613	12	0	66
10799	1402	68584238812105	29706	14649	7	0	66
10800	1402	68584254812105	29706	14649	8	0	66
10810	1402	69304274812105	29802	14684	12	0	66
10817	1402	70024274812105	29860	14718	10	0	66
10818	1402	70024293811104	29860	14718	11	0	66
10824	1402	70744293811104	30230	14864	27	0	66
10825	1402	70744347811104	30230	14864	28	0	66
10837	1402	71464385811104	30238	14866	24	0	66
10838	1402	71464395210775	30238	14866	25	1	66
10843	1402	72184395210775	30261	14878	49	0	66
10844	1402	72184489210775	30261	14878	50	0	66
10850	1402	72904489210775	30310	14897	2	0	66
10882	1402	75455036319298	20822	10466	2	0	\N
10883	1402	75455036319298	20845	10476	2	0	\N
10885	1402	75455047319298	20822	10466	3	0	\N
10886	1402	75455047319298	20845	10476	3	0	\N
10888	1402	75602983000000	10163	5267	12	0	\N
10891	1402	75603103000000	10163	5267	13	0	\N
10894	1402	76323003000000	10380	5367	4	0	\N
10896	1402	76323043000000	10380	5367	5	0	\N
10902	1402	77615079319298	21003	10562	2	0	\N
10903	1402	77615079319298	21052	10578	2	0	\N
10905	1402	77615090319298	21003	10562	3	0	\N
10906	1402	77615090319298	21052	10578	3	0	\N
10908	1402	77763073000000	10563	5454	4	0	\N
10911	1402	77763113000000	10563	5454	5	0	\N
10912	1402	77816175131128	13048	6728	5	0	\N
10913	1402	77816207131128	13048	6728	6	0	\N
10920	1402	79203133000000	10650	5500	2	0	\N
10922	1402	79203153000000	10650	5500	3	0	\N
10924	1402	79775174319298	21383	10728	7	0	\N
10925	1402	79775174319298	21403	10736	7	0	\N
10926	1402	79775174319298	21468	10769	10	0	\N
10927	1402	79775174319298	21543	10803	7	0	\N
10929	1402	79775181319298	21543	10803	8	0	\N
10931	1402	79775199319298	21383	10728	8	0	\N
10932	1402	79775211319298	21468	10769	11	0	\N
10933	1402	79775218319298	21403	10736	8	0	\N
10936	1402	80495186319298	21574	10814	6	0	\N
10939	1402	80495210319298	21574	10814	7	0	\N
10940	1402	80643183000000	10817	5582	3	0	\N
10941	1402	80643183000000	10825	5586	3	0	\N
10942	1402	80643183000000	10839	5594	2	0	\N
10944	1402	80643203000000	10839	5594	3	0	\N
10945	1402	80643213000000	10817	5582	4	0	\N
10946	1402	80643213000000	10825	5586	4	0	\N
10948	1402	81215199319298	23563	11744	4	0	\N
10950	1402	81215210319298	21580	10815	8	0	\N
10952	1402	81215221319298	23563	11744	5	0	\N
10953	1402	81215236319298	21580	10815	9	0	\N
10954	1402	81215636319298	21681	10816	40	0	\N
10955	1402	81363343000000	10847	5599	5	0	\N
10956	1402	81363343000000	10869	5609	5	0	\N
10958	1402	81363393000000	10847	5599	6	0	\N
10959	1402	81363393000000	10869	5609	6	0	\N
10961	1402	81363413000000	11108	5713	1	0	\N
10964	1402	81935636319298	21681	10816	126	0	\N
10965	1402	81935946319298	21681	10816	127	0	\N
10966	1402	81936428319298	21733	10817	40	0	\N
10968	1402	82083413000000	11108	5713	3	0	\N
10969	1402	82083423000000	11108	5713	4	0	\N
10973	1402	82656428319298	21733	10817	126	0	\N
10974	1402	82656513319298	21733	10817	127	0	\N
10975	1402	82656751319298	21776	10818	40	0	\N
10976	1402	82803423000000	11147	5728	4	0	\N
10979	1402	82803463000000	11147	5728	5	0	\N
10980	1402	83375247319298	23870	11881	3	0	\N
10981	1402	83375247319298	23904	11897	4	0	\N
10982	1402	83375247319298	23957	11920	3	0	\N
10983	1402	83375259319298	23870	11881	4	0	\N
10984	1402	83375259319298	23957	11920	4	0	\N
10985	1402	83375260319298	23904	11897	5	0	\N
10986	1402	83376751319298	21776	10818	70	0	\N
10987	1402	83376780319298	21776	10818	71	0	\N
10998	1402	87123661000000	11433	5873	2	0	\N
11000	1402	87123672000000	11433	5873	3	0	\N
11002	1402	87843672000000	11472	5896	10	0	\N
11003	1402	87843672000000	11545	5930	2	0	\N
11005	1402	87843683000000	11545	5930	3	0	\N
11007	1402	87843737000000	11472	5896	11	0	\N
11008	1402	88563683000000	11687	6008	2	0	\N
11011	1402	88563685000000	11687	6008	3	0	\N
10890	1402	75603003000000	10200	5282	3	0	0
10895	1402	76323003000000	10416	5388	5	0	0
10897	1402	76323053000000	10416	5388	6	0	0
10900	1402	77043053000000	10520	5433	2	0	0
10901	1402	77043073000000	10520	5433	3	0	0
10910	1402	77763093000000	10586	5467	3	0	0
10916	1402	78483093000000	10595	5472	4	0	0
10917	1402	78483133000000	10595	5472	5	0	0
10921	1402	79203133000000	10682	5514	2	0	0
10923	1402	79203153000000	10682	5514	3	0	0
10935	1402	79923183000000	10778	5564	4	0	0
10943	1402	80643183000000	10841	5595	7	0	0
10947	1402	80643343000000	10841	5595	8	0	0
10957	1402	81363343000000	11061	5690	6	0	0
10967	1402	82083403000000	11126	5720	2	0	0
10970	1402	82083423000000	11126	5720	3	0	0
10977	1402	82803423000000	11158	5736	2	0	0
10978	1402	82803443000000	11158	5736	3	0	0
10988	1402	83523443000000	11196	5748	2	0	0
10990	1402	84243463000000	11252	5781	7	0	0
10991	1402	84243524000000	11252	5781	8	0	0
10992	1402	84963524000000	11270	5790	8	0	0
10993	1402	84963595000000	11270	5790	9	0	0
10994	1402	85683595000000	11361	5834	10	0	0
10996	1402	86403650000000	11366	5838	2	0	0
10997	1402	86403661000000	11366	5838	3	0	0
10999	1402	87123661000000	11437	5875	2	0	0
11001	1402	87123672000000	11437	5875	3	0	0
11006	1402	87843683000000	11546	5931	3	0	0
11009	1402	88563683000000	11822	6076	1	0	0
11010	1402	88563684000000	11822	6076	2	0	0
11012	1402	89283684000000	12047	6201	1	0	0
11013	1402	89283685000000	12047	6201	2	0	0
11015	1402	90003686000000	12060	6207	2	0	0
11016	1402	90723686000000	12063	6209	4	0	0
10884	1402	75455036319298	20925	10520	3	0	33
10887	1402	75455057319298	20925	10520	4	0	33
10892	1402	76175057319298	20981	10553	2	0	33
10898	1402	76895068319298	20984	10554	2	0	33
10899	1402	76895079319298	20984	10554	3	0	33
10904	1402	77615079319298	21077	10589	2	0	33
10907	1402	77615090319298	21077	10589	3	0	33
10915	1402	78335101319298	21210	10650	3	0	33
10918	1402	79055101319298	21360	10721	19	0	33
10919	1402	79055174319298	21360	10721	20	0	33
10928	1402	79775174319298	21558	10810	3	0	33
10930	1402	79775186319298	21558	10810	4	0	33
10938	1402	80495199319298	23531	11730	5	0	33
10949	1402	81215199319298	23708	11808	4	0	33
10951	1402	81215212319298	23708	11808	5	0	33
10962	1402	81935212319298	23789	11844	5	0	33
10963	1402	81935235319298	23789	11844	6	0	33
10972	1402	82655247319298	23854	11874	4	0	33
11032	1402	97923699000000	12446	6415	0	0	\N
11036	1402	98643710000000	12570	6478	2	0	\N
11038	1402	98643721000000	12570	6478	3	0	\N
11041	1402	99363744000000	12701	6551	4	0	\N
11044	1402	99363766000000	12701	6551	5	0	\N
11045	1402	100083755000000	12806	6604	2	0	\N
11046	1402	100083755000000	12874	6639	4	0	\N
11047	1402	100083755000000	12881	6642	2	0	\N
11049	1402	100083766000000	12881	6642	3	0	\N
11051	1402	100083775000000	12806	6604	3	0	\N
11052	1402	100083777000000	12874	6639	5	0	\N
11057	1408	720000000000	6281	3253	1	0	\N
11058	1408	720000000000	21409	10738	5	0	\N
11059	1408	720010000000	6281	3253	2	0	\N
11060	1408	720052000000	21409	10738	6	0	\N
11061	1419	200000	5656	2814	14	1	\N
11072	1419	3340837280064	10176	5273	2	0	\N
11074	1419	3340857280064	10176	5273	3	0	\N
11076	1419	3600070000000	1420	772	1	0	\N
11078	1419	3600080000000	1420	772	2	0	\N
11080	1419	4060857280064	10407	5382	2	0	\N
11082	1419	4060877280064	10407	5382	3	0	\N
11086	1419	4781007280064	10745	5546	2	0	\N
11089	1419	4781027280064	10745	5546	3	0	\N
11092	1419	5501017280064	11128	5720	2	0	\N
11094	1419	5501037280064	11128	5720	3	0	\N
11100	1419	6048151560130	20359	10245	46	0	\N
11101	1419	6221037280064	11232	5771	5	0	\N
11102	1419	6221037280064	11290	5799	2	0	\N
11103	1419	6221037280064	11518	5915	2	0	\N
11104	1419	6221037280064	11618	5977	2	0	\N
11107	1419	6221039280064	11618	5977	3	0	\N
11108	1419	6221048280064	11290	5799	3	0	\N
11109	1419	6221048280064	11518	5915	3	0	\N
11110	1419	6221060280064	11232	5771	6	0	\N
11115	1419	6768151560130	20359	10245	47	0	\N
11122	1419	7488151560130	20378	10246	58	0	\N
11123	1419	7488360560130	20378	10246	59	0	\N
11124	1419	7488939560130	20478	10247	66	0	\N
11127	1419	7920150000000	2334	1220	3	0	\N
11130	1419	7920180000000	2334	1220	4	0	\N
11133	1419	8208939560130	20478	10247	126	0	\N
11134	1419	8208998560130	20478	10247	127	0	\N
11135	1419	8209738560130	20579	10248	66	0	\N
11136	1419	8381041280064	12150	6258	1	0	\N
11137	1419	8381041280064	12231	6299	1	0	\N
11138	1419	8381041280064	12252	6309	0	0	\N
11140	1419	8381042280064	12150	6258	2	0	\N
11141	1419	8381042280064	12231	6299	2	0	\N
11143	1419	8640170000000	3017	1566	1	0	\N
11144	1419	8640170000000	3053	1588	1	0	\N
11145	1419	8640170000000	3083	1600	1	0	\N
11147	1419	8640180000000	3017	1566	2	0	\N
11148	1419	8640180000000	3053	1588	2	0	\N
11149	1419	8640180000000	3083	1600	2	0	\N
11064	1419	1440020000000	522	293	2	0	0
11065	1419	1440040000000	522	293	3	0	0
11066	1419	2160040000000	734	411	1	0	0
11067	1419	2160050000000	734	411	2	0	0
11070	1419	2880050000000	736	413	2	0	0
11077	1419	3600070000000	1811	968	1	0	0
11079	1419	3600080000000	1811	968	2	0	0
11084	1419	4320080000000	1871	996	1	0	0
11085	1419	4320090000000	1871	996	2	0	0
11090	1419	5040090000000	2154	1139	2	0	0
11096	1419	5760110000000	2229	1175	1	0	0
11097	1419	5760120000000	2229	1175	2	0	0
11111	1419	6480120000000	2260	1187	2	0	0
11112	1419	6480140000000	2260	1187	3	0	0
11119	1419	7200150000000	2325	1218	2	0	0
11128	1419	7920150000000	2480	1299	2	0	0
11129	1419	7920170000000	2480	1299	3	0	0
11146	1419	8640170000000	3360	1746	2	0	0
11150	1419	8640190000000	3360	1746	3	0	0
11069	1419	2620837280064	10152	5262	3	0	3
11073	1419	3340837280064	10247	5300	2	0	3
11075	1419	3340857280064	10247	5300	3	0	3
11081	1419	4060857280064	10428	5394	15	0	3
11083	1419	4061007280064	10428	5394	16	0	3
11088	1419	4781017280064	10971	5652	2	0	3
11093	1419	5501017280064	11155	5734	2	0	3
11095	1419	5501037280064	11155	5734	3	0	3
11105	1419	6221037280064	12041	6198	1	0	3
11017	1402	90723690000000	12063	6209	5	0	0
11116	1419	6941038280064	12090	6224	2	0	3
11117	1419	6941040280064	12090	6224	3	0	3
11125	1419	7661040280064	12096	6228	1	0	3
11126	1419	7661041280064	12096	6228	2	0	3
11019	1402	91443692000000	12103	6232	3	0	0
11020	1402	92163692000000	12127	6246	2	0	0
11021	1402	92163694000000	12127	6246	3	0	0
11139	1419	8381041280064	12302	6336	2	0	3
11142	1419	8381142280064	12302	6336	3	0	3
11023	1402	92883695000000	12315	6346	2	0	0
11024	1402	93603695000000	12349	6367	2	0	0
11025	1402	93603697000000	12349	6367	3	0	0
11026	1402	94323697000000	12401	6397	0	0	0
11028	1402	95043699000000	12424	6405	3	0	0
11029	1402	95763699000000	12425	6406	0	0	0
11030	1402	96483699000000	12435	6411	0	0	0
11031	1402	97203699000000	12437	6412	0	0	0
11033	1402	97923699000000	12526	6455	2	0	0
11037	1402	98643710000000	12655	6528	7	0	0
11039	1402	98643744000000	12655	6528	8	0	0
11042	1402	99363744000000	12705	6553	2	0	0
11043	1402	99363755000000	12705	6553	3	0	0
11048	1402	100083755000000	12927	6663	2	0	0
11053	1402	100803766000000	12991	6697	2	0	0
11054	1402	100803777000000	12991	6697	3	0	0
11055	1402	101523777000000	13012	6707	1	0	0
11056	1402	101523787000000	13012	6707	2	0	0
11040	1402	98815350337135	13036	6721	3	0	3
11098	1419	6047949560130	20189	10166	3	0	6
11099	1419	6047961560130	20189	10166	4	0	6
11113	1419	6767961560130	20360	10255	3	0	6
11114	1419	6767973560130	20360	10255	4	0	6
11121	1419	7487997560130	20379	10266	7	0	6
11131	1419	8207997560130	20477	10312	4	0	6
11132	1419	8208019560130	20477	10312	5	0	6
11151	1419	8928019560130	20581	10354	3	0	6
11152	1419	8928031560130	20581	10354	4	0	6
11153	1419	8929738560130	20579	10248	101	0	\N
11154	1419	8929934560130	20579	10248	102	0	\N
11155	1419	9101142280064	12557	6471	2	0	\N
11156	1419	9101142280064	12559	6472	4	0	\N
11158	1419	9101153280064	12557	6471	3	0	\N
11160	1419	9101164280064	12559	6472	5	0	\N
11167	1419	9821174280064	13071	6737	1	0	\N
11168	1419	10080200000000	3492	1813	0	0	\N
11169	1419	10080200000000	3564	1849	0	0	\N
11175	1419	10541174280064	13071	6737	5	0	\N
11177	1419	10541177280064	13071	6737	6	0	\N
11178	1419	10800210000000	4017	2083	1	0	\N
11179	1419	10800210000000	4065	2112	1	0	\N
11180	1419	10800210000000	4241	2201	1	0	\N
11181	1419	10800210000000	4286	2222	3	0	\N
11183	1419	10800220000000	4017	2083	2	0	\N
11184	1419	10800220000000	4065	2112	2	0	\N
11185	1419	10800220000000	4241	2201	2	0	\N
11186	1419	10800240000000	4286	2222	4	0	\N
11188	1419	11088068560130	21375	10725	4	0	\N
11190	1419	11088081560130	21375	10725	5	0	\N
11192	1419	11261175280064	13397	6903	7	0	\N
11195	1419	11261200280064	13397	6903	8	0	\N
11202	1419	12240250000000	4648	2401	1	0	\N
11203	1419	12240250000000	4669	2414	1	0	\N
11205	1419	12240260000000	4648	2401	2	0	\N
11206	1419	12240260000000	4669	2414	2	0	\N
11208	1419	12528093560130	21602	10827	3	0	\N
11210	1419	12528105560130	21602	10827	4	0	\N
11212	1419	12701200280064	13627	7005	12	0	\N
11215	1419	12701239280064	13627	7005	13	0	\N
11216	1419	12960260000000	5432	2813	3	0	\N
11218	1419	12960263000000	5432	2813	4	0	\N
11220	1419	12961174000000	5656	2814	11	0	\N
11221	1419	13248128560130	21756	10893	3	0	\N
11222	1419	13248128560130	21773	10901	3	0	\N
11224	1419	13248140560130	21756	10893	4	0	\N
11225	1419	13248140560130	21773	10901	4	0	\N
11227	1419	13248162560130	22010	11006	1	0	\N
11228	1419	13248162560130	22011	11006	1	0	\N
11233	1419	13681174000000	5656	2814	13	0	\N
11234	1419	13968152560130	21901	10959	3	0	\N
11236	1419	13968162560130	22010	11006	3	0	\N
11237	1419	13968162560130	22011	11006	4	0	\N
11238	1419	13968163560130	22010	11006	4	0	\N
11239	1419	13968164560130	21901	10959	4	0	\N
11240	1419	13968164560130	22011	11006	5	0	\N
11242	1419	14141257280064	13936	7142	1	0	\N
11243	1419	14141257280064	13971	7159	3	0	\N
11245	1419	14141267280064	13936	7142	2	0	\N
11248	1419	14141287280064	13971	7159	4	0	\N
11249	1419	14400300000000	6412	3323	2	0	\N
11251	1419	14400320000000	6412	3323	3	0	\N
11253	1419	14401074900000	5725	2815	0	0	\N
11257	1419	15120320000000	6722	3478	4	0	\N
11258	1419	15120320000000	6828	3535	8	0	\N
11260	1419	15120360000000	6722	3478	5	0	\N
11262	1419	15120400000000	6828	3535	9	0	\N
11265	1419	15579278280064	14418	7355	1	0	\N
11266	1419	15579278280064	14674	7476	24	0	\N
11268	1419	15579288280064	14418	7355	2	0	\N
11270	1419	15579491280064	14674	7476	25	0	\N
11277	1419	16299330280064	14855	7571	3	0	\N
11278	1419	16299330280064	14856	7571	3	0	\N
11279	1419	16560380000000	7010	3615	5	0	\N
11282	1419	16560421000000	7010	3615	6	0	\N
11284	1419	16848227560130	22908	11450	12	0	\N
11285	1419	16848266560130	22908	11450	13	0	\N
11287	1419	17009330280064	14856	7571	4	0	\N
11288	1419	17019300280064	15130	7711	5	0	\N
11170	1419	10080200000000	3707	1924	1	0	0
11171	1419	10080210000000	3707	1924	2	0	0
11182	1419	10800210000000	4339	2249	3	0	0
11187	1419	10800240000000	4339	2249	4	0	0
11196	1419	11520240000000	4380	2272	1	0	0
11204	1419	12240250000000	5052	2622	1	0	0
11207	1419	12240260000000	5052	2622	2	0	0
11217	1419	12960260000000	6030	3128	3	0	0
11219	1419	12960290000000	6030	3128	4	0	0
11231	1419	13680290000000	6391	3313	1	0	0
11250	1419	14400300000000	6658	3442	2	0	0
11252	1419	14400320000000	6658	3442	3	0	0
11259	1419	15120320000000	6840	3539	4	0	0
11261	1419	15120360000000	6840	3539	5	0	0
11272	1419	15840380000000	6934	3578	3	0	0
11280	1419	16560380000000	7516	3891	1	0	0
11281	1419	16560390000000	7516	3891	2	0	0
11157	1419	9101142280064	12564	6474	2	0	3
11159	1419	9101153280064	12564	6474	3	0	3
11166	1419	9821164280064	12617	6509	3	0	3
11174	1419	10541164280064	13318	6861	2	0	3
11176	1419	10541175280064	13318	6861	3	0	3
11193	1419	11261175280064	13407	6906	4	0	3
11194	1419	11261188280064	13407	6906	5	0	3
11201	1419	11981200280064	13431	6920	4	0	3
11213	1419	12701200280064	13636	7010	14	0	3
11214	1419	12701232280064	13636	7010	15	0	3
11229	1419	13421232280064	13823	7097	7	0	3
11244	1419	14141257280064	14002	7174	2	0	3
11246	1419	14141268280064	14002	7174	3	0	3
11247	1419	14141278280064	14411	7351	1	0	3
11256	1419	14859278280064	14411	7351	2	0	3
11267	1419	15579278280064	14760	7517	2	0	3
11275	1419	16299289280064	14795	7537	2	0	3
11276	1419	16299300280064	14795	7537	3	0	3
11163	1419	9648031560130	20625	10374	7	0	6
11164	1419	9648047560130	20625	10374	8	0	6
11172	1419	10368047560130	20976	10550	3	0	6
11189	1419	11088068560130	21377	10725	4	0	6
11191	1419	11088081560130	21377	10725	5	0	6
11198	1419	11808081560130	21586	10822	3	0	6
11199	1419	11808093560130	21586	10822	4	0	6
11211	1419	12528128560130	21629	10836	9	0	6
11223	1419	13248128560130	21844	10933	6	0	6
11226	1419	13248152560130	21844	10933	7	0	6
11235	1419	13968152560130	22363	11193	9	0	6
11241	1419	13968188560130	22363	11193	10	0	6
11255	1419	14688200560130	22536	11275	4	0	6
11263	1419	15408200560130	22579	11296	5	0	6
11264	1419	15408214560130	22579	11296	6	0	6
11273	1419	16128214560130	22879	11436	4	0	6
11274	1419	16128227560130	22879	11436	5	0	6
11286	1419	16848269560130	22907	11450	16	0	6
11289	1419	17019300280064	15255	7771	4	0	\N
11290	1419	17019300280064	15530	7903	7	0	\N
11291	1419	17019300280064	15544	7911	4	0	\N
11293	1419	17019322280064	15255	7771	5	0	\N
11294	1419	17019322280064	15544	7911	5	0	\N
11296	1419	17019330280064	14855	7571	9	0	\N
11297	1419	17019332280064	15130	7711	6	0	\N
11298	1419	17019334280064	15530	7903	8	0	\N
11299	1419	17019344280064	14855	7571	10	0	\N
11302	1419	17568269560130	23073	11519	4	0	\N
11303	1419	17568269560130	23150	11561	3	0	\N
11305	1419	17568281560130	23150	11561	4	0	\N
11307	1419	17568282560130	23073	11519	5	0	\N
11312	1419	18287031560130	23903	11896	3	0	\N
11314	1419	18287043560130	23903	11896	4	0	\N
11316	1419	18459333280064	15918	8093	6	0	\N
11317	1419	18459333280064	16036	8155	4	0	\N
11319	1419	18459355280064	16036	8155	5	0	\N
11320	1419	18459357280064	15918	8093	7	0	\N
11322	1419	18720420000000	7708	3993	2	0	\N
11323	1419	18720420000000	7795	4041	1	0	\N
11325	1419	18720430000000	7795	4041	2	0	\N
11326	1419	18720440000000	7708	3993	3	0	\N
11331	1419	19179357280064	16064	8169	4	0	\N
11333	1419	19179379280064	16064	8169	5	0	\N
11337	1419	19726054560130	24278	12078	4	0	\N
11338	1419	19726054560130	24386	12127	7	0	\N
11341	1419	19726067560130	24278	12078	5	0	\N
11342	1419	19726088560130	24386	12127	8	0	\N
11343	1419	19727055560130	24243	12063	3	0	\N
11344	1419	19727067560130	24243	12063	4	0	\N
11355	1419	21166117559750	24741	12286	18	0	\N
11358	1419	21166252559750	24741	12286	19	0	\N
11359	1419	21339417280064	16414	8349	4	0	\N
11362	1419	21339430280064	16414	8349	5	0	\N
11363	1419	21600470000000	8635	4474	0	0	\N
11364	1419	21600470000000	8841	4583	6	0	\N
11367	1419	21600530000000	8841	4583	7	0	\N
11368	1419	21886129559750	25103	12457	3	0	\N
11369	1419	21886129559750	25105	12457	3	0	\N
11371	1419	21886141559750	25103	12457	4	0	\N
11372	1419	21886141559750	25105	12457	4	0	\N
11374	1419	21886154559750	25361	12575	3	0	\N
11380	1419	22606142559750	25261	12531	4	0	\N
11381	1419	22606154559750	25361	12575	5	0	\N
11384	1419	22606155559750	25261	12531	5	0	\N
11385	1419	22606155559750	25361	12575	6	0	\N
11388	1419	23040510000000	9299	4824	2	0	\N
11390	1419	23040530000000	9299	4824	3	0	\N
11392	1419	23326155559748	25458	12581	4	0	\N
11393	1419	23326155559748	25459	12605	0	0	\N
11394	1419	23326155559748	25460	12607	0	0	\N
11395	1419	23326155559748	25838	12775	3	0	\N
11398	1419	23326167559748	25838	12775	4	0	\N
11399	1419	23326186559748	26433	13077	2	0	\N
11400	1419	23326186559748	26434	13077	2	0	\N
11401	1419	23326186559748	26435	13077	2	0	\N
11402	1419	23326258559748	25458	12581	5	0	\N
11407	1419	24046155559748	25543	12608	1	0	\N
11408	1419	24046156559748	25543	12608	2	0	\N
11409	1419	24046166559748	26194	12949	6	0	\N
11412	1419	24046186559748	26433	13077	8	0	\N
11413	1419	24046186559748	26434	13077	8	0	\N
11414	1419	24046186559748	26435	13077	8	0	\N
11415	1419	24046190559748	26194	12949	7	0	\N
11416	1419	24046191559748	26433	13077	9	0	\N
11417	1419	24046191559748	26434	13077	9	0	\N
11418	1419	24046191559748	26435	13077	9	0	\N
11419	1419	24046258559748	25542	12582	1	0	\N
11420	1419	24046259559748	25542	12582	2	0	\N
11421	1419	24219479280064	16890	8566	3	0	\N
11423	1419	24219491280064	16890	8566	4	0	\N
11310	1419	18000410000000	7605	3936	1	0	0
11311	1419	18000420000000	7605	3936	2	0	0
11324	1419	18720420000000	7882	4084	2	0	0
11327	1419	18720440000000	7882	4084	3	0	0
11335	1419	19440440000000	8281	4289	1	0	0
11347	1419	20160450000000	8287	4292	1	0	0
11348	1419	20160460000000	8287	4292	2	0	0
11353	1419	20880460000000	8516	4412	1	0	0
11354	1419	20880470000000	8516	4412	2	0	0
11365	1419	21600470000000	8929	4628	2	0	0
11378	1419	22320490000000	9296	4822	2	0	0
11379	1419	22320510000000	9296	4822	3	0	0
11389	1419	23040510000000	9491	4923	2	0	0
11391	1419	23040530000000	9491	4923	3	0	0
11406	1419	23760591000000	9738	5045	8	0	0
11292	1419	17019300280064	15586	7934	4	0	3
11295	1419	17019322280064	15586	7934	5	0	3
11308	1419	17739322280064	15909	8088	2	0	3
11309	1419	17739333280064	15909	8088	3	0	3
11321	1419	18459357280064	16037	8155	7	0	3
11332	1419	19179357280064	16065	8169	6	0	3
11334	1419	19179381280064	16065	8169	7	0	3
11345	1419	19899381280064	16180	8224	4	0	3
11346	1419	19899394280064	16180	8224	5	0	3
11352	1419	20619417280064	16373	8328	6	0	3
11360	1419	21339417280064	16525	8404	3	0	3
11361	1419	21339429280064	16525	8404	4	0	3
11376	1419	22059429280064	16641	8455	4	0	3
11386	1419	22779442280064	16689	8477	7	0	3
11387	1419	22779467280064	16689	8477	8	0	3
11403	1419	23499467280064	16699	8484	3	0	3
11404	1419	23499479280064	16699	8484	4	0	3
11422	1419	24219479280064	17109	8669	4	0	3
11304	1419	17568269560130	23688	11797	3	0	6
11306	1419	17568281560130	23688	11797	4	0	6
11313	1419	18287031560130	24006	11946	3	0	7
11315	1419	18287043560130	24006	11946	4	0	7
11329	1419	19007043560130	24195	12042	3	0	7
11328	1419	19006064560130	24485	12175	1	0	8
11339	1419	19726064560130	24485	12175	3	0	8
11340	1419	19726065559750	24485	12175	4	1	8
11349	1419	20446065559750	24706	12270	7	0	8
11356	1419	21166117559750	24823	12326	3	0	8
11357	1419	21166129559750	24823	12326	4	0	8
11370	1419	21886129559750	25125	12466	4	0	8
11373	1419	21886142559750	25125	12466	5	0	8
11375	1419	21886154559750	25362	12575	3	0	8
11383	1419	22606155559748	25362	12575	6	1	8
11396	1419	23326155559748	26139	12921	2	0	8
11397	1419	23326166559748	26139	12921	3	0	8
11410	1419	24046166559748	26755	13232	4	0	8
11411	1419	24046179559748	26755	13232	5	0	8
11425	1419	24480591000000	9820	5089	12	0	\N
11426	1419	24480621000000	9820	5089	13	0	\N
11427	1419	24766156559748	25598	12609	0	0	\N
11428	1419	24766179559748	26781	13244	3	0	\N
11430	1419	24766191559748	26781	13244	4	0	\N
11432	1419	24766259559748	25597	12583	0	0	\N
11435	1419	25486156559748	25746	12610	4	0	\N
11436	1419	25486160559748	25746	12610	5	0	\N
11437	1419	25486203559748	27233	13466	3	0	\N
11438	1419	25486203559748	27235	13466	1	0	\N
11440	1419	25486213559748	27235	13466	2	0	\N
11441	1419	25486215559748	27233	13466	4	0	\N
11443	1419	25486259559748	25742	12584	4	0	\N
11444	1419	25486263559748	25742	12584	5	0	\N
11447	1419	26206160559748	25768	12611	1	0	\N
11448	1419	26206161559748	25768	12611	2	0	\N
11449	1419	26206215559748	27410	13554	3	0	\N
11450	1419	26206215559748	27462	13573	9	0	\N
11451	1419	26206215559748	27464	13573	5	0	\N
11452	1419	26206215559748	27620	13651	3	0	\N
11453	1419	26206215559748	28068	13879	4	0	\N
11455	1419	26206220559748	27464	13573	6	0	\N
11456	1419	26206227559748	27410	13554	4	0	\N
11457	1419	26206227559748	27620	13651	4	0	\N
11458	1419	26206228559748	28068	13879	5	0	\N
11459	1419	26206233559748	27462	13573	10	0	\N
11461	1419	26206263559748	25765	12585	1	0	\N
11462	1419	26206264559748	25765	12585	2	0	\N
11463	1419	26379540280064	17168	8702	10	0	\N
11464	1419	26379540280064	17329	8779	11	0	\N
11465	1419	26379540280064	17394	8810	5	0	\N
11467	1419	26379563280064	17394	8810	6	0	\N
11469	1419	26379577280064	17168	8702	11	0	\N
11470	1419	26380352280064	17329	8779	12	0	\N
11471	1419	26926240559748	28232	13958	6	0	\N
11473	1419	26926264559748	28232	13958	7	0	\N
11486	1419	28540161280064	18153	9118	63	0	\N
11487	1419	29086286559748	28535	14098	2	0	\N
11489	1419	29086297559748	28535	14098	3	0	\N
11491	1419	29259603280064	17907	9033	2	0	\N
11492	1419	29259603280064	18030	9096	3	0	\N
11493	1419	29259603280064	18048	9104	2	0	\N
11494	1419	29259605280064	17907	9033	3	0	\N
11495	1419	29259614280064	18048	9104	3	0	\N
11496	1419	29259615280064	18030	9096	4	0	\N
11499	1419	29260161280064	18153	9118	126	0	\N
11500	1419	29260223280064	18153	9118	127	0	\N
11501	1419	29261663280064	18435	9119	63	0	\N
11502	1419	29806322559748	29108	14349	3	0	\N
11503	1419	29806322559748	29122	14357	4	0	\N
11506	1419	29806334559748	29108	14349	4	0	\N
11507	1419	29806335559748	29122	14357	5	0	\N
11510	1419	29981663280064	18435	9119	126	0	\N
11511	1419	29982283280064	18435	9119	127	0	\N
11512	1419	30524331559748	29350	14465	6	0	\N
11514	1419	30524331559748	29378	14481	9	0	\N
11515	1419	30524355559748	29350	14465	7	0	\N
11516	1419	30524367559747	29378	14481	10	1	\N
11518	1419	30699697280064	18616	9380	1	0	\N
11520	1419	30699707280064	18616	9380	2	0	\N
11522	1419	31243376559748	29783	14666	1	0	\N
11524	1419	31244367559748	29402	14497	2	0	\N
11527	1419	31244378559748	29402	14497	3	0	\N
11530	1419	31963366559748	29512	14555	7	0	\N
11531	1419	31963366559748	29641	14617	3	0	\N
11532	1419	31963366559748	29789	14679	29	0	\N
11533	1419	31963376559748	29783	14666	74	0	\N
11535	1419	31963378559748	29641	14617	4	0	\N
11537	1419	31963391559748	29512	14555	8	0	\N
11538	1419	31963413559748	29789	14679	30	0	\N
11539	1419	31963599559603	29783	14666	77	0	\N
11544	1419	32683599559603	29788	14667	8	0	\N
11545	1419	32683625559603	29788	14667	9	0	\N
11548	1419	33403434424689	29911	14737	10	0	\N
11551	1419	33403453424689	29911	14737	11	0	\N
11552	1419	33403625559603	29914	14668	8	0	\N
11553	1419	33403840559603	29914	14668	9	0	\N
11556	1419	33579791280064	19154	9662	1	0	\N
11557	1419	33579791280064	19155	9662	1	0	\N
11558	1419	34123451424689	30035	14788	11	0	\N
11559	1419	34123471399489	30035	14788	13	0	\N
11560	1419	34123840559603	30036	14669	2	0	\N
11445	1419	25659503280064	17163	8699	10	0	3
11446	1419	25659540280064	17163	8699	11	0	3
11466	1419	26379540280064	17407	8818	6	0	3
11468	1419	26379564280064	17407	8818	7	0	3
11475	1419	27099564280064	17518	8870	3	0	3
11479	1419	27819576280064	17732	8962	6	0	3
11480	1419	27819600280064	17732	8962	7	0	3
11483	1419	28539600280064	17816	8997	3	0	3
11484	1419	28539603280064	17816	8997	4	0	3
11485	1419	28539670280064	18154	9152	13	0	3
11498	1419	29259672280064	18154	9152	17	0	3
11508	1419	29979672280064	18434	9293	7	0	3
11509	1419	29979697280064	18434	9293	8	0	3
11519	1419	30699697280064	18785	9466	5	0	3
11528	1419	31419720280064	18831	9489	3	0	3
11529	1419	31419741280064	18831	9489	4	0	3
11540	1419	32139741280064	18965	9566	1	0	3
11541	1419	32139751280064	18965	9566	2	0	3
11546	1419	32859751280064	18970	9568	2	0	3
11554	1419	33579771280064	18997	9579	1	0	3
11555	1419	33579781280064	18997	9579	2	0	3
11429	1419	24766179559748	26983	13344	6	0	8
11431	1419	24766203559748	26983	13344	7	0	8
11439	1419	25486203559748	27378	13538	3	0	8
11454	1419	26206215559748	28110	13895	7	0	8
11460	1419	26206240559748	28110	13895	8	0	8
11472	1419	26926240559748	28302	13990	6	0	8
11474	1419	26926264559748	28302	13990	7	0	8
11478	1419	27646275559748	28303	13991	3	0	8
11481	1419	28366275559748	28379	14028	2	0	8
11482	1419	28366286559748	28379	14028	3	0	8
11488	1419	29086286559748	28570	14112	9	0	8
11490	1419	29086322559748	28570	14112	10	0	8
11505	1419	29806333559748	29134	14364	3	0	8
11513	1419	30524331559748	29377	14481	9	0	10
11517	1419	30524367559748	29377	14481	10	0	10
11525	1419	31244367559748	29403	14497	1	0	10
11526	1419	31244368559748	29403	14497	2	0	10
11534	1419	31963377559748	29782	14678	13	0	12
11536	1419	31963387424689	29782	14678	17	1	12
11542	1419	32683387424689	29787	14679	29	0	12
11543	1419	32683434424689	29787	14679	30	0	12
11550	1419	33403451424689	29912	14737	9	0	12
11561	1419	34123842559603	30036	14669	3	0	\N
11562	1419	34299781280064	19259	9709	10	0	\N
11564	1419	34299791280064	19154	9662	5	0	\N
11565	1419	34299791280064	19155	9662	5	0	\N
11566	1419	34299794280064	19154	9662	6	0	\N
11567	1419	34299794280064	19155	9662	6	0	\N
11568	1419	34299818280064	19259	9709	11	0	\N
11570	1419	34299869280064	19478	9820	7	0	\N
11571	1419	35019844280064	19695	9916	9	0	\N
11572	1419	35019844280064	19779	9960	7	0	\N
11573	1419	35019844280064	19882	10015	3	0	\N
11574	1419	35019844280064	19883	10015	2	0	\N
11577	1419	35019855280064	19883	10015	3	0	\N
11578	1419	35019856280064	19882	10015	4	0	\N
11579	1419	35019869280064	19478	9820	9	0	\N
11580	1419	35019869280064	19779	9960	8	0	\N
11581	1419	35019870280064	19478	9820	10	0	\N
11582	1419	35019916280064	19695	9916	10	0	\N
11583	1419	35739847280064	19995	10068	3	0	\N
11586	1419	35739859280064	19995	10068	4	0	\N
11589	1420	125000	20559	10228	63	1	\N
11590	1420	800000	11281	5795	6	0	\N
11591	1420	2422222	4556	2357	0	0	\N
11592	1420	180000000	2655	1267	88	1	\N
11593	1420	210000000	12261	6241	126	1	\N
11594	1420	720000000000	1686	906	1	0	\N
11596	1420	720000000000	8339	4319	1	0	\N
11599	1420	720010000000	1686	906	2	0	\N
11600	1420	720010000000	8339	4319	2	0	\N
11604	1420	1434949120000	14652	7467	3	0	\N
11605	1420	1434949120000	14656	7467	3	0	\N
11607	1420	1434963970000	27685	13681	9	0	\N
11608	1420	1434996980000	22319	11173	7	0	\N
11609	1420	1434996980000	22321	11173	7	0	\N
11610	1420	1854875970000	30188	14851	23	0	\N
11612	1420	1854876960000	30215	14859	12	0	\N
11613	1420	1854876960000	30216	14859	12	0	\N
11614	1420	1854876960000	30217	14859	12	0	\N
11615	1420	1854876960000	30218	14859	13	0	\N
11616	1420	1854876960000	30219	14859	12	0	\N
11618	1420	1854877950000	30223	14735	100	0	\N
11622	1420	2154996980000	22319	11173	12	0	\N
11623	1420	2154996980000	22321	11173	12	0	\N
11624	1420	2155000980000	22319	11173	13	0	\N
11625	1420	2155000980000	22321	11173	13	0	\N
11626	1420	6526641792000	12141	6254	3	0	\N
11627	1420	12235629010000	27611	13576	81	0	\N
11628	1420	13148008075300	16784	8429	18	1	\N
11629	1420	13834563938000	16707	8428	125	0	\N
11630	1420	66000050000000	20646	10357	124	1	\N
11631	1420	73910349724688	14652	7467	4	1	\N
11632	1422	201000000	23976	11931	4	0	\N
11633	1422	203000000	23017	11497	14	0	\N
11636	1422	720020000000	1346	740	1	0	\N
11637	1422	720905000000	1594	785	88	0	\N
11638	1422	1440010000000	880	489	2	0	\N
11639	1422	1440010000000	1086	602	1	0	\N
11640	1422	1440010000000	1087	602	0	0	\N
11641	1422	1440010000000	1404	767	1	0	\N
11642	1422	1440010000000	1593	866	1	0	\N
11643	1422	1440010000000	1612	872	4	0	\N
11645	1422	1440020000000	1086	602	2	0	\N
11646	1422	1440020000000	1346	740	2	0	\N
11647	1422	1440020000000	1404	767	2	0	\N
11648	1422	1440020000000	1593	866	2	0	\N
11650	1422	1440030000000	880	489	3	0	\N
11651	1422	1440050000000	1612	872	5	0	\N
11652	1422	1440895000000	1594	785	89	0	\N
11653	1422	2160020000000	2437	1275	3	0	\N
11654	1422	2160020000000	2497	1308	1	0	\N
11655	1422	2160020000000	2687	1412	1	0	\N
11656	1422	2160020000000	2792	1462	1	0	\N
11657	1422	2160020000000	2875	1504	1	0	\N
11659	1422	2160020000000	2937	1429	0	0	\N
11660	1422	2160020000000	2938	1446	0	0	\N
11661	1422	2160020000000	2939	1465	0	0	\N
11662	1422	2160020000000	2940	1481	0	0	\N
11663	1422	2160030000000	2497	1308	2	0	\N
11664	1422	2160030000000	2687	1412	2	0	\N
11665	1422	2160030000000	2792	1462	2	0	\N
11666	1422	2160030000000	2875	1504	2	0	\N
11668	1422	2160050000000	2437	1275	4	0	\N
11669	1422	2160895000000	1611	786	0	0	\N
11670	1422	2880030000000	3429	1781	1	0	\N
11671	1422	2880030000000	3433	1783	0	0	\N
11672	1422	2880030000000	3545	1840	0	0	\N
11674	1422	2880040000000	3429	1781	2	0	\N
11681	1422	5040050000000	4191	2182	2	0	\N
11682	1422	5040050000000	4342	2250	1	0	\N
11683	1422	5040050000000	4624	2393	1	0	\N
11684	1422	5040050000000	4780	2469	1	0	\N
11685	1422	5040050000000	4837	2505	3	0	\N
11687	1422	5040060000000	4342	2250	2	0	\N
11688	1422	5040060000000	4624	2393	2	0	\N
11689	1422	5040060000000	4780	2469	2	0	\N
11691	1422	5040070000000	4191	2182	3	0	\N
11692	1422	5040080000000	4837	2505	4	0	\N
11693	1422	5184971860211	11962	6124	5	0	\N
11694	1422	5184971860211	11964	6158	1	0	\N
11695	1422	5184971860211	12029	6191	1	0	\N
11644	1422	1440010000000	1759	942	1	0	0
11649	1422	1440020000000	1759	942	2	0	0
11658	1422	2160020000000	2936	1528	1	0	0
11667	1422	2160030000000	2936	1528	2	0	0
11673	1422	2880030000000	3616	1876	0	0	0
11676	1422	3600040000000	3682	1912	2	0	0
11677	1422	4320040000000	3748	1943	1	0	0
11678	1422	4320050000000	3748	1943	2	0	0
11686	1422	5040050000000	4993	2588	1	0	0
11690	1422	5040060000000	4993	2588	2	0	0
11598	1420	720000220000	8784	4556	3	0	0
11679	1422	4464970860211	11824	6077	1	0	7
11680	1422	4464971860211	11824	6077	2	0	7
11696	1422	5184971860211	12287	6327	1	0	7
11602	1420	1434939220000	13121	6763	13	0	1
11603	1420	1434941200000	15153	7724	3	1	1
11606	1420	1434962980000	17188	8710	11	0	1
11563	1419	34299781280064	19440	9797	18	0	3
11569	1419	34299844280064	19440	9797	19	0	3
11576	1419	35019847280064	19986	10064	4	0	3
11584	1419	35739847280064	20112	10124	2	0	3
11585	1419	35739858280064	20112	10124	3	0	3
11587	1419	36459858280064	20151	10142	3	0	3
11588	1419	36459870280064	20151	10142	4	0	3
11621	1420	2154974980000	28145	13914	4	0	1
11611	1420	1854875970000	30190	14851	23	0	2
11617	1420	1854876960000	30220	14859	12	0	2
11619	1420	1854877950000	30277	14888	13	0	2
11697	1422	5184972860211	11964	6158	2	0	\N
11698	1422	5184972860211	12029	6191	2	0	\N
11700	1422	5204976860211	11962	6124	6	0	\N
11701	1422	5760060000000	5289	2748	1	0	\N
11702	1422	5760060000000	5436	2828	0	0	\N
11704	1422	5760070000000	5289	2748	2	0	\N
11705	1422	5904972860211	12340	6361	2	0	\N
11706	1422	5904972860211	12477	6430	3	0	\N
11709	1422	5904974860211	12340	6361	3	0	\N
11710	1422	5904993860211	12477	6430	4	0	\N
11711	1422	5924976860211	12027	6125	3	0	\N
11712	1422	5924979860211	12027	6125	4	0	\N
11713	1422	6480060000000	5676	2943	0	0	\N
11716	1422	6624973860211	12582	6485	1	0	\N
11717	1422	6624973860211	12663	6532	1	0	\N
11718	1422	6624973860211	12664	6532	2	0	\N
11720	1422	6624973860211	12790	6594	2	0	\N
11721	1422	6624974860211	12663	6532	2	0	\N
11722	1422	6624983860211	12582	6485	2	0	\N
11723	1422	6624984860211	12664	6532	3	0	\N
11724	1422	6624984860211	12790	6594	3	0	\N
11725	1422	7200070000000	5868	3041	3	0	\N
11726	1422	7200070000000	6001	3114	1	0	\N
11728	1422	7200080000000	6001	3114	2	0	\N
11730	1422	7200100000000	5868	3041	4	0	\N
11731	1422	7344973860211	14125	7219	4	0	\N
11732	1422	7344973860211	14127	7219	3	0	\N
11733	1422	7344973860211	14268	7284	12	0	\N
11734	1422	7344973860211	14370	7333	3	0	\N
11735	1422	7344973860211	14705	7488	2	0	\N
11737	1422	7344976860211	14127	7219	4	0	\N
11738	1422	7344984860211	14705	7488	3	0	\N
11739	1422	7344985860211	14370	7333	4	0	\N
11740	1422	7344986860211	14125	7219	5	0	\N
11741	1422	7345012860211	14268	7284	13	0	\N
11743	1422	7434554804270	23017	11497	13	0	\N
11744	1422	7434554804270	23018	11497	13	0	\N
11746	1422	7434603804270	23018	11497	14	0	\N
11750	1422	8065027860211	15873	8074	4	0	\N
11753	1422	8065040860211	15873	8074	5	0	\N
11754	1422	8154603804269	23976	11931	3	0	\N
11755	1422	8154603804270	23344	11649	2	0	\N
11757	1422	8154614804270	23344	11649	3	0	\N
11761	1422	8785039860211	16276	8274	4	0	\N
11763	1422	8785052860211	16276	8274	5	0	\N
11765	1422	8874615804270	23983	11936	3	0	\N
11766	1422	8874615804270	24066	11977	6	0	\N
11768	1422	8874627804270	23983	11936	4	0	\N
11769	1422	8874648804270	24066	11977	7	0	\N
11773	1422	9505052860211	16690	8478	7	0	\N
11775	1422	9505052860211	17385	8806	3	0	\N
11777	1422	9505064860211	17385	8806	4	0	\N
11778	1422	9505077860211	16690	8478	8	0	\N
11783	1422	10225053860211	18304	9221	2	0	\N
11786	1422	10225064860211	18304	9221	3	0	\N
11791	1422	10945063860211	18899	9533	2	0	\N
11793	1422	10945074860211	18899	9533	3	0	\N
11795	1422	11034683804270	24397	12131	2	0	\N
11797	1422	11034694804270	24397	12131	3	0	\N
11799	1422	11520200000000	7231	3738	2	0	\N
11802	1422	11520220000000	7231	3738	3	0	\N
11805	1422	11754694804270	24899	12364	4	0	\N
11808	1422	11754707804270	24899	12364	5	0	\N
11809	1422	12240210000000	8192	4247	2	0	\N
11811	1422	12240230000000	8192	4247	3	0	\N
11817	1422	12960210000000	8670	4490	0	0	\N
11821	1422	13194707804270	25712	12720	6	0	\N
11822	1422	13194707804270	25753	12739	3	0	\N
11824	1422	13194719804270	25753	12739	4	0	\N
11826	1422	13194740804270	25712	12720	7	0	\N
11827	1422	13371818852698	10770	5559	4	0	\N
11828	1422	13371818852698	10771	5559	4	0	\N
11829	1422	13371858852698	10770	5559	5	0	\N
11830	1422	13371858852698	10771	5559	5	0	\N
11715	1422	6480070000000	5841	3030	2	0	0
11727	1422	7200070000000	6133	3180	1	0	0
11729	1422	7200080000000	6133	3180	2	0	0
11748	1422	7920080000000	6522	3380	2	0	0
11749	1422	7920100000000	6522	3380	3	0	0
11760	1422	8640120000000	6539	3388	3	0	0
11771	1422	9360120000000	6719	3477	4	0	0
11772	1422	9360160000000	6719	3477	5	0	0
11781	1422	10080160000000	7182	3710	1	0	0
11782	1422	10080170000000	7182	3710	2	0	0
11790	1422	10800200000000	7216	3731	4	0	0
11800	1422	11520200000000	7292	3769	1	0	0
11801	1422	11520210000000	7292	3769	2	0	0
11810	1422	12240210000000	8193	4247	0	0	0
11818	1422	12960220000000	8669	4490	2	0	0
11831	1422	13680220000000	8702	4511	5	0	0
11832	1422	13680261000000	8702	4511	6	0	0
11699	1422	5184972860211	12287	6327	2	0	7
11707	1422	5904972860211	12482	6433	1	0	7
11719	1422	6624973860211	12789	6594	0	0	7
11736	1422	7344973860211	14881	7581	9	0	7
11742	1422	7345027860211	14881	7581	10	0	7
11751	1422	8065027860211	15978	8122	3	0	7
11752	1422	8065039860211	15978	8122	4	0	7
11764	1422	8785052860211	16490	8386	5	0	7
11774	1422	9505052860211	17384	8806	1	0	7
11776	1422	9505053860211	17384	8806	2	0	7
11784	1422	10225053860211	18880	9521	1	0	7
11792	1422	10945063860211	19054	9611	6	0	7
11794	1422	10945114860211	19054	9611	7	0	7
11803	1422	11665114860211	19235	9699	3	0	7
11804	1422	11665126860211	19235	9699	4	0	7
11812	1422	12385126860211	19319	9742	3	0	7
11819	1422	13105138860211	19332	9748	4	0	7
11820	1422	13105151860211	19332	9748	5	0	7
11745	1422	7434554804270	23019	11497	13	0	12
11747	1422	7434603804270	23019	11497	14	0	12
11756	1422	8154603804270	23975	11931	3	0	12
11767	1422	8874615804270	24067	11977	6	0	12
11770	1422	8874648804270	24067	11977	7	0	12
11779	1422	9594648804270	24127	12010	2	0	12
11780	1422	9594659804270	24127	12010	3	0	12
11788	1422	10314683804270	24318	12094	7	0	12
11796	1422	11034683804270	24500	12185	2	0	12
11798	1422	11034694804270	24500	12185	3	0	12
11806	1422	11754694804270	25413	12594	1	0	12
11807	1422	11754695804270	25413	12594	2	0	12
11815	1422	12474707804270	25498	12626	4	0	12
11823	1422	13194707804270	26404	13064	4	0	12
11825	1422	13194720804270	26404	13064	5	0	12
11833	1422	13825151860211	19450	9803	5	0	\N
11836	1422	13825165860211	19450	9803	6	0	\N
11837	1422	13914720804270	26764	13236	10	0	\N
11838	1422	13914720804270	26765	13236	7	0	\N
11839	1422	13914720804270	27191	13448	3	0	\N
11840	1422	13914720804270	27541	13615	3	0	\N
11842	1422	13914732804270	27191	13448	4	0	\N
11844	1422	13914741804270	27541	13615	4	0	\N
11845	1422	13914754804270	26765	13236	8	0	\N
11846	1422	13914757804270	26764	13236	11	0	\N
11849	1422	14545162860211	19508	9832	4	0	\N
11850	1422	14545162860211	19643	9893	7	0	\N
11852	1422	14545175860211	19508	9832	5	0	\N
11854	1422	14545187860211	19643	9893	8	0	\N
11865	1422	15985197860211	19928	10037	3	0	\N
11868	1422	15985209860211	19928	10037	4	0	\N
11875	1422	16794773741770	29494	14544	3	0	\N
11876	1422	16794773741770	29730	14657	7	0	\N
11877	1422	16794773741770	29871	14722	20	0	\N
11878	1422	16794773741770	29899	14732	10	0	\N
11879	1422	16794785741770	29494	14544	4	0	\N
11880	1422	16794789741770	29730	14657	8	0	\N
11881	1422	16794811741770	29871	14722	21	0	\N
11882	1422	16794891741770	29899	14732	11	0	\N
11885	1422	17425240860211	20402	10266	31	0	\N
11888	1422	17425433860211	20402	10266	32	0	\N
11891	1422	18145252860211	20566	10351	8	0	\N
11892	1422	18145252860211	20791	10449	4	0	\N
11895	1422	18145274860211	20791	10449	5	0	\N
11896	1422	18145287860211	20566	10351	9	0	\N
11897	1422	18145433860210	20564	10267	0	0	\N
11903	1422	19440472000000	10185	5276	2	0	\N
11905	1422	19440492000000	10185	5276	3	0	\N
11911	1422	20305288860211	21985	10992	3	0	\N
11912	1422	20305288860211	22236	11129	8	0	\N
11913	1422	20305288860211	22468	11243	2	0	\N
11914	1422	20305288860211	22642	11323	3	0	\N
11916	1422	20305299860211	22468	11243	3	0	\N
11917	1422	20305300860211	21985	10992	4	0	\N
11918	1422	20305300860211	22642	11323	4	0	\N
11920	1422	20305332860211	22236	11129	9	0	\N
11921	1422	20880510000000	10336	5350	2	0	\N
11922	1422	20880530000000	10336	5350	3	0	\N
11924	1422	21025324860211	22796	11401	2	0	\N
11925	1422	21025344860211	22796	11401	3	0	\N
11927	1423	200000	26127	12917	3	1	\N
11929	1423	200010000	16707	8428	126	0	\N
11930	1423	720000000000	758	424	1	0	\N
11931	1423	720010000000	758	424	2	0	\N
11933	1423	720193409879	10279	5319	10	0	\N
11934	1423	720571750023	20672	10399	3	0	\N
11935	1423	720571750023	20757	10435	0	0	\N
11936	1423	720571750023	20990	10557	2	0	\N
11938	1423	720582750023	20990	10557	3	0	\N
11940	1423	720583750023	20672	10399	4	0	\N
11943	1423	773539999985	12217	6078	113	0	\N
11948	1423	1440629750023	23413	11682	4	0	\N
11949	1423	1441454750023	26014	12665	85	0	\N
11953	1423	1493539999985	12217	6078	126	0	\N
11954	1423	1493551999985	12217	6078	127	0	\N
11955	1423	2160040000000	4149	2160	1	0	\N
11957	1423	2160050000000	4149	2160	2	0	\N
11959	1423	2160604750023	25560	12656	3	0	\N
11961	1423	2160616750023	25560	12656	4	0	\N
11963	1423	2161454750023	26014	12665	126	0	\N
11964	1423	2161854750023	26014	12665	127	0	\N
11944	1423	1440010000000	2172	1146	3	0	0
11945	1423	1440040000000	2172	1146	4	0	0
11956	1423	2160040000000	4926	2549	1	0	0
11958	1423	2160050000000	4926	2549	2	0	0
11967	1423	2880050000000	5822	3021	1	0	0
11847	1422	14400261000000	8806	4566	2	0	0
11848	1422	14400281000000	8806	4566	3	0	0
11857	1422	15120281000000	9352	4853	2	0	0
11858	1422	15120301000000	9352	4853	3	0	0
11863	1422	15840301000000	9448	4900	2	0	0
11871	1422	16560321000000	9486	4919	2	0	0
11872	1422	16560341000000	9486	4919	3	0	0
11883	1422	17280341000000	9569	4962	9	0	0
11884	1422	17280422000000	9569	4962	10	0	0
11890	1422	18000452000000	10010	5190	4	0	0
11898	1422	18720452000000	10081	5229	2	0	0
11899	1422	18720472000000	10081	5229	3	0	0
11904	1422	19440472000000	10186	5276	2	0	0
11906	1422	19440492000000	10186	5276	3	0	0
11910	1422	20160512000000	10267	5311	3	0	0
11941	1423	753177999985	10364	5360	2	0	15
11942	1423	753197999985	10364	5360	3	0	15
11950	1423	1473197999985	12215	6293	2	0	15
11951	1423	1473199999985	12215	6293	3	0	15
11966	1423	2193235999985	13699	7039	3	0	15
11834	1422	13825151860211	19451	9803	2	0	7
11835	1422	13825162860211	19451	9803	3	0	7
11851	1422	14545162860211	19704	9921	6	0	7
11859	1422	15265186860211	19814	9979	2	0	7
11860	1422	15265197860211	19814	9979	3	0	7
11866	1422	15985197860211	19929	10037	1	0	7
11867	1422	15985198860211	19929	10037	2	0	7
11873	1422	16705198860211	20132	10134	6	0	7
11886	1422	17425240860211	20403	10279	3	0	7
11887	1422	17425252860211	20403	10279	4	0	7
11893	1422	18145252860211	21118	10606	3	0	7
11894	1422	18145264860211	21118	10606	4	0	7
11937	1423	720571750023	21484	10773	2	0	29
11900	1422	18865264860211	21557	10809	3	0	7
11901	1422	18865276860211	21557	10809	4	0	7
11902	1422	18865287860211	21786	10907	2	0	7
11907	1422	19585287860211	21786	10907	4	0	7
11946	1423	1440582750023	21895	10956	4	0	29
11947	1423	1440604750023	21895	10956	5	0	29
11915	1422	20305288860211	22663	11331	9	0	7
11919	1422	20305324860211	22663	11331	10	0	7
11923	1422	21025324860211	22794	11401	6	0	7
11960	1423	2160604750023	26015	12858	3	0	29
11962	1423	2160616750023	26015	12858	4	0	29
11841	1422	13914720804270	28195	13938	3	0	12
11843	1422	13914732804270	28195	13938	4	0	12
11855	1422	14634732804270	28759	14187	2	0	12
11861	1422	15354743804270	28772	14193	4	0	12
11862	1422	15354756804270	28772	14193	5	0	12
11869	1422	16074756804270	29437	14513	4	0	12
11870	1422	16074773741770	29437	14513	5	0	12
11969	1423	2880616725023	26127	12917	2	0	\N
11979	1423	3600667750023	30223	14735	102	1	\N
11982	1423	4320080000000	8807	4567	2	0	\N
11983	1423	4320080000000	8836	4581	3	0	\N
11984	1423	4320100000000	8807	4567	3	0	\N
11985	1423	4320365000000	8836	4581	4	0	\N
11986	1423	4320642750023	27967	13835	11	0	\N
11987	1423	4320680750023	27967	13835	12	0	\N
11995	1425	914812000000	21606	10711	0	0	\N
11998	1425	1537446000000	27152	13424	1	0	\N
11999	1425	2257436000000	29351	14466	6	0	\N
12000	1425	2257446000000	27152	13424	13	0	\N
12001	1425	2257460000000	29351	14466	7	0	\N
12002	1425	2257484000000	27152	13424	14	0	\N
12009	1426	2880050000000	798	442	1	0	\N
12010	1426	2880050000000	1389	762	1	0	\N
12011	1426	2880050000000	1678	901	1	0	\N
12013	1426	2880060000000	798	442	2	0	\N
12014	1426	2880060000000	1389	762	2	0	\N
12015	1426	2880060000000	1678	901	2	0	\N
12019	1426	4320080000000	2215	1166	1	0	\N
12020	1426	4320080000000	2253	1184	3	0	\N
12021	1426	4320080000000	2254	1184	3	0	\N
12022	1426	4320080000000	2472	1295	1	0	\N
12023	1426	4320080000000	3401	1768	1	0	\N
12024	1426	4320080000000	3402	1741	41	0	\N
12026	1426	4320090000000	2215	1166	2	0	\N
12027	1426	4320090000000	2472	1295	2	0	\N
12028	1426	4320090000000	3401	1768	2	0	\N
12029	1426	4320110000000	2253	1184	4	0	\N
12030	1426	4320730000000	3402	1741	42	0	\N
12031	1426	5040080000000	3972	2064	1	0	\N
12032	1426	5040080000000	4219	2193	1	0	\N
12033	1426	5040080000000	4228	2197	1	0	\N
12035	1426	5040090000000	3972	2064	2	0	\N
12036	1426	5040090000000	4219	2193	2	0	\N
12037	1426	5040090000000	4228	2197	2	0	\N
12039	1426	5370258000000	21265	10679	4	0	\N
12042	1426	5370280000000	21265	10679	5	0	\N
12045	1426	6090270000000	21384	10729	3	0	\N
12047	1426	6090282000000	21384	10729	4	0	\N
12051	1426	6810283000000	22141	11075	11	0	\N
12052	1426	6810283000000	22145	11076	7	0	\N
12055	1426	6810308000000	22145	11076	8	0	\N
12056	1426	6810321000000	22141	11075	12	0	\N
12058	1426	7200250000000	5055	2622	1	0	\N
12060	1426	7200260000000	5055	2622	2	0	\N
12065	1426	7920260000000	5512	2868	1	0	\N
12066	1426	7920260000000	5514	2708	57	0	\N
12067	1426	7920260000000	5706	2960	0	0	\N
12069	1426	7920270000000	5512	2868	2	0	\N
12071	1426	7921640000000	5514	2708	58	0	\N
12076	1426	8640270000000	6075	3156	2	0	\N
12077	1426	8640270000000	6234	3226	2	0	\N
12078	1426	8640270000000	6365	3296	1	0	\N
12079	1426	8640270000000	6700	3464	2	0	\N
12080	1426	8640270000000	7064	3647	4	0	\N
12081	1426	8640270000000	7176	3707	1	0	\N
12083	1426	8640280000000	6365	3296	2	0	\N
12084	1426	8640280000000	7176	3707	2	0	\N
12086	1426	8640290000000	6075	3156	3	0	\N
12087	1426	8640290000000	6234	3226	3	0	\N
12088	1426	8640290000000	6700	3464	3	0	\N
12089	1426	8640310000000	7064	3647	5	0	\N
12090	1426	8640720000000	7354	3780	44	0	\N
12093	1426	8970321000000	23797	11846	4	0	\N
12096	1426	8970343000000	23797	11846	5	0	\N
12099	1426	9360720000000	7354	3780	59	0	\N
12100	1426	9360851000000	7354	3780	60	0	\N
12005	1426	1440030000000	465	261	1	0	0
12006	1426	1440040000000	465	261	2	0	0
12007	1426	2160040000000	735	412	1	0	0
12008	1426	2160050000000	735	412	2	0	0
12012	1426	2880050000000	1781	954	2	0	0
12017	1426	3600070000000	1829	978	1	0	0
12018	1426	3600080000000	1829	978	2	0	0
12025	1426	4320080000000	3602	1870	0	0	0
12034	1426	5040080000000	4274	2217	2	0	0
12038	1426	5040190000000	4274	2217	3	0	0
12044	1426	5760240000000	4368	2265	6	0	0
12049	1426	6480240000000	4778	2468	1	0	0
12050	1426	6480250000000	4778	2468	2	0	0
12057	1426	7200250000000	5054	2623	1	0	0
12068	1426	7920260000000	5920	3068	1	0	0
12070	1426	7920270000000	5920	3068	2	0	0
12082	1426	8640270000000	7240	3742	1	0	0
12085	1426	8640280000000	7240	3742	2	0	0
12097	1426	9360280000000	7352	3800	8	0	0
11975	1423	3600060000000	7506	3885	2	0	0
11976	1423	3600080000000	7506	3885	3	0	0
12061	1426	7484817000000	12332	6356	1	0	4
12062	1426	7484818000000	12332	6356	2	0	4
12072	1426	8204818000000	12345	6363	1	0	4
12091	1426	8924819000000	12670	6535	2	0	4
12092	1426	8924830000000	12670	6535	3	0	4
12101	1426	9644830000000	12682	6541	2	0	4
12102	1426	9644841000000	12682	6541	3	0	4
11973	1423	2913248999985	13723	7053	5	0	15
11974	1423	2913273999985	16339	8307	5	0	15
11980	1423	3633273999985	17528	8876	5	0	15
11981	1423	3633287999985	17528	8876	6	0	15
11988	1423	4353287999985	17531	8877	3	0	15
11993	1425	817400000000	18355	9250	3	0	0
11994	1425	817412000000	18355	9250	4	0	0
11990	1423	5073299999985	19828	9989	3	0	15
11991	1423	5073302999985	19828	9989	4	0	15
12040	1426	5370258000000	21287	10689	3	0	8
12046	1426	6090270000000	21640	10841	4	0	8
12048	1426	6090283000000	21640	10841	5	0	8
12053	1426	6810283000000	22203	11114	4	0	8
12054	1426	6810296000000	22203	11114	5	0	8
11997	1425	1537436000000	22377	11202	7	0	0
12063	1426	7530296000000	22596	11305	3	0	8
12064	1426	7530308000000	22596	11305	4	0	8
12074	1426	8250308000000	22960	11471	4	0	8
12075	1426	8250321000000	22960	11471	5	0	8
12095	1426	8970332000000	23987	11938	3	0	8
12103	1426	9690332000000	24060	11974	2	0	8
12104	1426	9690343000000	24060	11974	3	0	8
11970	1423	2880616750023	26130	12917	2	0	29
11971	1423	2880627750023	26130	12917	3	0	29
11978	1423	3600642750023	26474	13095	7	0	29
12105	1426	10080360000000	7607	3937	0	0	\N
12111	1426	10410343000000	24290	12081	4	0	\N
12112	1426	10410343000000	24462	12151	0	0	\N
12115	1426	10410356000000	24290	12081	5	0	\N
12116	1426	10800370000000	7765	4025	1	0	\N
12117	1426	10800380000000	7765	4025	2	0	\N
12119	1426	11084853000000	13603	6994	27	0	\N
12120	1426	11084853000000	13678	7029	3	0	\N
12122	1426	11084865000000	13678	7029	4	0	\N
12124	1426	11084943000000	13603	6994	28	0	\N
12125	1426	11129342999976	24530	12152	0	0	\N
12128	1426	11451342999976	24591	12153	0	0	\N
12129	1426	11520380000000	8267	4281	3	0	\N
12132	1426	11520401000000	8267	4281	4	0	\N
12135	1426	11850366000000	24593	12225	7	0	\N
12138	1426	11850400000000	24593	12225	8	0	\N
12139	1426	12171342999976	24788	12154	0	0	\N
12140	1426	12240390000000	8563	4439	2	0	\N
12141	1426	12240390000000	8587	4453	1	0	\N
12142	1426	12240390000000	8642	4477	1	0	\N
12143	1426	12240390000000	9069	4701	2	0	\N
12145	1426	12240400000000	8587	4453	2	0	\N
12146	1426	12240400000000	8642	4477	2	0	\N
12147	1426	12240410000000	8563	4439	3	0	\N
12148	1426	12240410000000	9069	4701	3	0	\N
12150	1426	12524918000000	14673	7476	24	0	\N
12151	1426	12524918000000	14832	7560	2	0	\N
12153	1426	12524929000000	14832	7560	3	0	\N
12155	1426	12525131000000	14673	7476	25	0	\N
12159	1426	12960430000000	9222	4781	2	0	\N
12161	1426	12960450000000	9222	4781	3	0	\N
12166	1426	13290428000000	26582	13153	6	0	\N
12167	1426	13290428000000	26583	13153	6	0	\N
12173	1426	14010428000000	26582	13153	8	0	\N
12174	1426	14010428000000	26583	13153	8	0	\N
12176	1426	14010429000000	26582	13153	9	0	\N
12177	1426	14010429000000	26583	13153	9	0	\N
12191	1426	15840510000000	10084	5232	26	0	\N
12192	1426	15840510000000	10128	5254	1	0	\N
12193	1426	15840510000000	10129	5254	2	0	\N
12194	1426	15840510000000	10131	5255	3	0	\N
12195	1426	15840510000000	10132	5255	4	0	\N
12197	1426	15840520000000	10128	5254	2	0	\N
12198	1426	15840530000000	10129	5254	3	0	\N
12199	1426	15840630000000	10131	5255	4	0	\N
12201	1426	15840640000000	10132	5255	5	0	\N
12202	1426	15840770000000	10084	5232	27	0	\N
12212	1426	16890472000000	27588	13635	6	0	\N
12214	1426	16890496000000	27588	13635	7	0	\N
12217	1426	17565039000000	16083	8175	3	0	\N
12219	1426	17565051000000	16083	8175	4	0	\N
12221	1426	17610494000000	28225	13932	2	0	\N
12224	1426	17610514000000	28225	13932	3	0	\N
12227	1426	18285057000000	16343	8310	3	0	\N
12229	1426	18285057000000	16581	8427	6	0	\N
12230	1426	18285069000000	16343	8310	4	0	\N
12232	1426	18285081000000	16581	8427	7	0	\N
12234	1426	18330514000000	28508	13933	21	0	\N
12236	1426	18330587166670	28508	13933	22	0	\N
12237	1426	18330939166670	28639	13934	67	0	\N
12108	1426	10080380000000	7890	4090	1	0	0
12118	1426	10800380000000	7890	4090	2	0	0
12130	1426	11520380000000	8512	4409	1	0	0
12131	1426	11520390000000	8512	4409	2	0	0
12144	1426	12240390000000	9114	4723	4	0	0
12158	1426	12960430000000	9221	4781	2	0	0
12160	1426	12960450000000	9221	4781	3	0	0
12169	1426	13680450000000	9399	4876	2	0	0
12170	1426	13680470000000	9399	4876	3	0	0
12179	1426	14400470000000	9548	4952	2	0	0
12185	1426	15120490000000	9743	5047	2	0	0
12186	1426	15120510000000	9743	5047	3	0	0
12196	1426	15840510000000	10133	5255	3	0	0
12200	1426	15840630000000	10133	5255	4	0	0
12208	1426	16560750000000	10420	5390	13	0	0
12215	1426	17280750000000	11138	5724	6	0	0
12216	1426	17280810000000	11138	5724	7	0	0
12225	1426	18000810000000	11354	5831	2	0	0
12226	1426	18000821000000	11354	5831	3	0	0
12239	1426	18720832000000	11513	5914	3	0	0
12240	1426	18720834000000	11596	5965	2	0	0
12109	1426	10364841000000	13462	6935	3	0	4
12110	1426	10364853000000	13462	6935	4	0	4
12121	1426	11084853000000	14266	7284	12	0	4
12133	1426	11804892000000	14435	7365	8	0	4
12134	1426	11804918000000	14435	7365	9	0	4
12152	1426	12524918000000	14974	7629	3	0	4
12154	1426	12524930000000	14974	7629	4	0	4
12163	1426	13244941000000	15075	7678	3	0	4
12171	1426	13964941000000	15115	7703	1	0	4
12172	1426	13964951000000	15115	7703	2	0	4
12181	1426	14684951000000	15262	7774	3	0	4
12182	1426	14684963000000	15262	7774	4	0	4
12188	1426	15404975000000	15430	7859	4	0	4
12203	1426	16124975000000	15580	7931	7	0	4
12204	1426	16125027000000	15580	7931	8	0	4
12209	1426	16845027000000	15965	8115	3	0	4
12210	1426	16845039000000	15965	8115	4	0	4
12220	1426	17565057000000	16236	8253	5	0	4
12228	1426	18285057000000	16580	8427	4	0	4
12231	1426	18285079000000	16580	8427	5	0	4
12113	1426	10410343000000	24463	12165	3	0	8
12126	1426	11130355000000	24531	12195	2	0	8
12127	1426	11130366000000	24531	12195	3	0	8
12136	1426	11850366000000	24790	12309	4	0	8
12137	1426	11850379000000	24790	12309	5	0	8
12156	1426	12570379000000	25718	12722	3	0	8
12164	1426	13290391000000	25967	12830	4	0	8
12165	1426	13290404000000	25967	12830	5	0	8
12168	1426	13290428000000	26584	13153	6	0	8
12175	1426	14010428000000	26584	13153	8	0	8
12178	1426	14010429000000	26584	13153	9	0	8
12184	1426	14730443000000	27198	13453	6	0	8
12189	1426	15450443000000	27412	13555	3	0	8
12190	1426	15450455000000	27412	13555	4	0	8
12205	1426	16170455000000	27465	13574	8	0	8
12211	1426	16890472000000	27587	13635	4	0	8
12213	1426	16890494000000	27587	13635	5	0	8
12222	1426	17610494000000	28226	13955	2	0	8
12223	1426	17610505000000	28226	13955	3	0	8
12233	1426	18330505000000	28507	14087	2	0	8
12241	1426	18720834000000	11597	5965	2	0	\N
12242	1426	18720834000000	11598	5965	2	0	\N
12245	1426	19050516000000	28638	14141	2	0	\N
12247	1426	19050527000000	28638	14141	3	0	\N
12249	1426	19050939166670	28639	13934	84	0	\N
12250	1426	19050947166385	28639	13934	85	0	\N
12252	1426	19440834000000	11597	5965	3	0	\N
12253	1426	19440834000000	11598	5965	3	0	\N
12254	1426	19725091000000	17169	8586	11	0	\N
12257	1426	19725183000000	17169	8586	12	0	\N
12258	1426	19770528000000	29336	14456	4	0	\N
12260	1426	19770541000000	29336	14456	5	0	\N
12265	1426	20445116000000	17348	8789	3	0	\N
12266	1426	20445116000000	17349	8789	2	0	\N
12267	1426	20445116000000	17405	8817	3	0	\N
12268	1426	20445116000000	17645	8921	7	0	\N
12270	1426	20445127000000	17349	8789	3	0	\N
12271	1426	20445128000000	17348	8789	4	0	\N
12272	1426	20445128000000	17405	8817	4	0	\N
12274	1426	20445168000000	17645	8921	8	0	\N
12277	1426	20880856000000	12181	6271	4	0	\N
12280	1426	20880860000000	12181	6271	5	0	\N
12283	1426	21885151000000	18966	9567	2	0	\N
12285	1426	21885162000000	18966	9567	3	0	\N
12291	1426	24045210000000	20076	10105	3	0	\N
12292	1426	24045210000000	20287	10216	5	0	\N
12294	1426	24045222000000	20076	10105	4	0	\N
12295	1426	24045233000000	20287	10216	6	0	\N
12301	1426	26205298000000	20803	10458	2	0	\N
12302	1426	26205298000000	20853	10481	10	0	\N
12303	1426	26205298000000	20872	10492	2	0	\N
12304	1426	26205298000000	20980	10553	2	0	\N
12305	1426	26205309000000	20803	10458	3	0	\N
12306	1426	26205309000000	20872	10492	3	0	\N
12307	1426	26205309000000	20980	10553	3	0	\N
12308	1426	26205363000000	20853	10481	11	0	\N
12310	1427	1439750000000	8277	4288	2	0	\N
12311	1427	1439750000000	8306	4299	1	0	\N
12312	1427	1439760000000	8306	4299	2	0	\N
12313	1427	1439761000000	8277	4288	3	0	\N
12316	1428	1440030000000	3738	1939	1	0	\N
12318	1428	1440040000000	3738	1939	2	0	\N
12321	1429	555000000000	20291	10216	7	0	\N
12323	1429	720000000000	10160	5265	2	0	\N
12324	1429	720000000000	11231	5771	5	0	\N
12326	1429	720020000000	10160	5265	3	0	\N
12327	1429	720023000000	11231	5771	6	0	\N
12328	1430	1390000000	16743	8215	68	0	\N
12329	1430	720000000000	7917	4103	1	0	\N
12330	1430	720000000000	16744	8404	1	0	\N
12331	1430	720010000000	7917	4103	2	0	\N
12332	1430	720010000000	16744	8404	2	0	\N
12333	1430	721390000000	16743	8215	126	0	\N
12334	1430	721960000000	16743	8215	127	0	\N
12335	1431	720000000000	4210	2191	1	0	\N
12336	1431	720010000000	4210	2191	2	0	\N
12338	1432	720000000000	8177	4236	2	0	\N
12340	1432	720020000000	8177	4236	3	0	\N
12343	1432	1441025000000	27326	13508	3	0	\N
12344	1432	1441025000000	27327	13508	3	0	\N
12348	1434	1439100000000	4319	2239	1	0	\N
12349	1434	1439100000000	4321	2236	0	0	\N
12351	1434	1439110000000	4319	2239	2	0	\N
12358	1434	3599144000000	28810	14210	3	0	\N
12360	1434	3599156000000	28810	14210	4	0	\N
12361	1435	720000000000	10178	5275	4	0	\N
12362	1435	720000000000	10182	5275	4	0	\N
12365	1435	720040000000	10178	5275	5	0	\N
12366	1435	720040000000	10182	5275	5	0	\N
12367	1436	720000000000	23562	11743	4	0	\N
12370	1436	720013000000	23562	11743	5	0	\N
12371	1438	99999999	21864	10943	4	0	\N
12372	1439	200000012	11875	6071	69	1	\N
12373	1439	250999999	12015	6134	81	0	\N
12374	1439	720000000000	989	547	1	0	\N
12375	1439	720000000000	1062	588	3	0	\N
12346	1434	720000000000	774	431	2	0	0
12347	1434	720110000000	774	431	3	0	0
12376	1439	720000000000	1211	667	1	0	0
12322	1429	720000000000	1904	1014	1	0	0
12325	1429	720010000000	1904	1014	2	0	0
12317	1428	1440030000000	5592	2906	0	0	0
12350	1434	1439100000000	9198	4767	2	0	1
12352	1434	1439120000000	9198	4767	3	0	1
12363	1435	720000000000	11454	5885	3	0	0
12364	1435	720021000000	11454	5885	4	0	0
12263	1426	20160834000000	11764	6048	4	0	0
12264	1426	20160856000000	11764	6048	5	0	0
12278	1426	20880856000000	12195	6278	1	0	0
12279	1426	20880857000000	12195	6278	2	0	0
12244	1426	19005091000000	16753	8505	4	0	4
12337	1432	12000000	16769	8512	3	0	0
12339	1432	720012000000	16769	8512	4	0	0
12255	1426	19725091000000	17170	8703	7	0	4
12256	1426	19725116000000	17170	8703	8	0	4
12273	1426	20445128000000	18302	9220	4	0	4
12281	1426	21165128000000	18333	9235	5	0	4
12282	1426	21165151000000	18333	9235	6	0	4
12284	1426	21885151000000	19105	9636	4	0	4
12286	1426	21885173000000	19105	9636	5	0	4
12288	1426	22605198000000	19601	9872	8	0	4
12289	1426	23325198000000	19699	9919	3	0	4
12290	1426	23325210000000	19699	9919	4	0	4
12293	1426	24045210000000	20290	10216	7	0	4
12297	1426	24765235000000	20616	10369	5	0	4
12298	1426	24765249000000	20616	10369	6	0	4
12299	1426	25485249000000	20666	10396	13	0	4
12300	1426	25485298000000	20666	10396	14	0	4
12319	1428	2160030000000	21765	10898	3	0	0
12341	1432	1440012000000	22126	11066	4	0	0
12342	1432	1440025000000	22126	11066	5	0	0
12353	1434	2159120000000	24056	11971	2	0	1
12354	1434	2159131000000	24056	11971	3	0	1
12355	1434	2879131000000	26716	13214	4	0	1
12357	1434	3599144000000	28809	14210	3	0	1
12359	1434	3599156000000	28809	14210	4	0	1
12246	1426	19050516000000	29082	14337	3	0	8
12248	1426	19050528000000	29082	14337	4	0	8
12369	1436	720012000000	29608	14601	4	0	0
12259	1426	19770528000000	29827	14697	9	0	8
12261	1426	19770546000000	29827	14697	10	0	8
12262	1426	19770560000000	29859	14717	5	0	8
12275	1426	20490560000000	29859	14717	11	0	8
12377	1439	720010000000	989	547	2	0	\N
12379	1439	720030000000	1062	588	4	0	\N
12380	1439	774375367000	10045	5015	61	1	\N
12383	1439	2160020000000	1354	743	2	0	\N
12385	1439	2160040000000	1354	743	3	0	\N
12397	1439	3600060000000	2267	1190	1	0	\N
12399	1439	3600070000000	2267	1190	2	0	\N
12404	1439	4303559578477	20206	10163	75	0	\N
12406	1439	4303868578477	20206	10163	76	0	\N
12409	1439	4612266998477	11490	5903	1	0	\N
12411	1439	4612276998477	11490	5903	2	0	\N
12413	1439	4612377998477	11875	6071	10	0	\N
12414	1439	4632310998477	12015	6134	33	0	\N
12417	1439	5023868578477	20212	10164	6	0	\N
12418	1439	5023892578477	20212	10164	7	0	\N
12419	1439	5024100578477	20236	10165	37	0	\N
12420	1439	5040080000000	2732	1434	2	0	\N
12421	1439	5040080000000	2925	1522	2	0	\N
12423	1439	5040100000000	2732	1434	3	0	\N
12424	1439	5040100000000	2925	1522	3	0	\N
12426	1439	5332277998477	11874	6103	1	0	\N
12427	1439	5332277998477	12014	6183	1	0	\N
12429	1439	5332278998477	11874	6103	2	0	\N
12430	1439	5332278998477	12014	6183	2	0	\N
12432	1439	5332377998477	11875	6071	68	0	\N
12433	1439	5352310998477	12015	6134	80	0	\N
12434	1439	5352547998467	12013	6072	68	0	\N
12435	1439	5355577998478	12372	6135	79	0	\N
12436	1439	5743583578477	20235	10188	4	0	\N
12437	1439	5743583578477	20523	10330	4	0	\N
12439	1439	5743583578477	20770	10438	2	0	\N
12440	1439	5743594578477	20770	10438	3	0	\N
12441	1439	5743596578477	20235	10188	5	0	\N
12442	1439	5743596578477	20523	10330	5	0	\N
12444	1439	5744100578477	20236	10165	54	0	\N
12445	1439	5744116578477	20236	10165	55	0	\N
12448	1439	6052279998477	12575	6481	2	0	\N
12450	1439	6052290998477	12575	6481	3	0	\N
12452	1439	6072547998467	12013	6072	120	0	\N
12453	1439	6075577998478	12372	6135	126	0	\N
12454	1439	6075641998478	12372	6135	127	0	\N
12455	1439	6463604578477	20831	10470	3	0	\N
12457	1439	6463616578477	20831	10470	4	0	\N
12459	1439	6480110000000	3531	1832	1	0	\N
12460	1439	6480110000000	3624	1879	0	0	\N
12461	1439	6480110000000	4606	2384	1	0	\N
12463	1439	6480111000000	3531	1832	2	0	\N
12464	1439	6480120000000	4606	2384	2	0	\N
12468	1439	7183641578477	22495	11254	4	0	\N
12469	1439	7183641578477	22498	11254	3	0	\N
12470	1439	7183641578477	22987	11482	6	0	\N
12472	1439	7183644578477	22498	11254	4	0	\N
12474	1439	7183663578477	22495	11254	5	0	\N
12475	1439	7183674578477	22987	11482	7	0	\N
12476	1439	7200120000000	4909	2541	3	0	\N
12478	1439	7200150000000	4909	2541	4	0	\N
12479	1439	7492312998477	13384	6897	8	0	\N
12480	1439	7492312998477	13809	7090	1	0	\N
12481	1439	7492312998477	14205	7249	8	0	\N
12483	1439	7492322998477	13809	7090	2	0	\N
12484	1439	7492338998477	13384	6897	9	0	\N
12485	1439	7492338998477	14205	7249	9	0	\N
12487	1439	7903654578477	23042	11505	3	0	\N
12488	1439	7903654578477	23293	11623	4	0	\N
12491	1439	7903666578477	23042	11505	4	0	\N
12492	1439	7903676578477	23293	11623	5	0	\N
12493	1439	7920120000000	5758	2985	1	0	\N
12495	1439	7920120000000	5982	3103	2	0	\N
12496	1439	7920130000000	5758	2985	2	0	\N
12498	1439	7920140000000	5982	3103	3	0	\N
12501	1439	8623665578477	23546	11738	3	0	\N
12503	1439	8623677578477	23546	11738	4	0	\N
12505	1439	8623701578477	24204	12048	6	0	\N
12506	1439	8623701578477	24206	12048	6	0	\N
12509	1439	8932379998477	14632	7459	9	0	\N
12512	1439	8932415998477	14632	7459	10	0	\N
12382	1439	1440020000000	1286	709	2	0	0
12384	1439	2160020000000	1757	941	2	0	0
12386	1439	2160040000000	1757	941	3	0	0
12391	1439	2880040000000	1772	951	2	0	0
12392	1439	2880060000000	1772	951	3	0	0
12400	1439	3600070000000	2536	1334	2	0	0
12407	1439	4320070000000	2679	1408	1	0	0
12408	1439	4320080000000	2679	1408	2	0	0
12422	1439	5040080000000	3251	1688	2	0	0
12425	1439	5040100000000	3251	1688	3	0	0
12447	1439	5760110000000	3520	1828	2	0	0
12462	1439	6480110000000	4782	2471	1	0	0
12465	1439	6480120000000	4782	2471	2	0	0
12477	1439	7200120000000	5701	2956	0	0	0
12497	1439	7920140000000	5981	3103	3	0	0
12507	1439	8640140000000	6246	3231	1	0	0
12508	1439	8640150000000	6246	3231	2	0	0
12387	1439	2452162998477	10692	5520	2	0	6
12388	1439	2452182998477	10692	5520	3	0	6
12394	1439	3172255998477	10816	5581	11	0	6
12401	1439	3892255998477	11320	5813	2	0	6
12402	1439	3892266998477	11320	5813	3	0	6
12410	1439	4612266998477	11508	5912	2	0	6
12412	1439	4612277998477	11508	5912	3	0	6
12431	1439	5332279998477	12371	6380	3	0	6
12449	1439	6052279998477	12702	6551	4	0	6
12451	1439	6052301998477	12702	6551	5	0	6
12466	1439	6772301998477	12763	6581	2	0	6
12482	1439	7492312998477	14505	7399	19	0	6
12486	1439	7492367998477	14505	7399	20	0	6
12499	1439	8212367998477	14555	7423	3	0	6
12500	1439	8212379998477	14555	7423	4	0	6
12510	1439	8932379998477	14837	7562	2	0	6
12389	1439	2863509578477	20177	10160	10	0	10
12390	1439	2863546578477	20177	10160	11	0	10
12395	1439	3583546578477	20179	10161	4	0	10
12396	1439	3583559578477	20179	10161	5	0	10
12403	1439	4303559578477	20204	10176	3	0	10
12415	1439	5023571578477	20211	10178	3	0	10
12416	1439	5023583578477	20211	10178	4	0	10
12438	1439	5743583578477	20769	10438	3	0	10
12443	1439	5743604578477	20769	10438	4	0	10
12458	1439	6463641578477	21476	10771	11	0	10
12471	1439	7183641578477	22988	11482	4	0	10
12473	1439	7183654578477	22988	11482	5	0	10
12489	1439	7903654578477	23322	11639	2	0	10
12490	1439	7903665578477	23322	11639	3	0	10
12504	1439	8623677578477	23719	11813	4	0	10
12513	1439	9343677578477	23923	11905	3	0	\N
12514	1439	9343677578477	24388	12128	2	0	\N
12516	1439	9343688578477	24388	12128	3	0	\N
12517	1439	9343689578477	23923	11905	4	0	\N
12519	1439	9343701578476	24204	12048	7	0	\N
12520	1439	9343701578477	24206	12048	7	0	\N
12523	1439	9652390998477	15276	7781	4	0	\N
12525	1439	9652412998477	15276	7781	5	0	\N
12527	1439	10063690578477	24712	12273	7	0	\N
12530	1439	10063742578477	24712	12273	8	0	\N
12533	1439	10372413998477	15448	7868	3	0	\N
12536	1439	10372425998477	15448	7868	4	0	\N
12537	1439	10783735578477	25152	12479	4	0	\N
12540	1439	10783749578477	25152	12479	5	0	\N
12542	1439	10783769578477	25417	12595	3	0	\N
12543	1439	10800180000000	7052	3640	2	0	\N
12546	1439	10800200000000	7052	3640	3	0	\N
12549	1439	11503748578477	25297	12550	2	0	\N
12550	1439	11503748578477	25299	12550	3	0	\N
12551	1439	11503759578477	25297	12550	3	0	\N
12552	1439	11503760578477	25299	12550	4	0	\N
12554	1439	11503769578477	25417	12595	6	0	\N
12555	1439	11503771578477	25417	12595	7	0	\N
12556	1439	11520190000000	7734	4008	1	0	\N
12557	1439	11520190000000	7736	3996	19	0	\N
12558	1439	11520190000000	7930	4111	1	0	\N
12559	1439	11520190000000	7958	4124	1	0	\N
12560	1439	11520190000000	8322	4307	1	0	\N
12562	1439	11520191000000	8322	4307	2	0	\N
12563	1439	11520200000000	7734	4008	2	0	\N
12564	1439	11520200000000	7930	4111	2	0	\N
12565	1439	11520200000000	7958	4124	2	0	\N
12567	1439	11520470000000	7736	3996	20	0	\N
12568	1439	11520840000000	7932	3997	37	0	\N
12569	1439	11812436998477	16423	8353	6	0	\N
12570	1439	11812436998477	16675	8470	7	0	\N
12573	1439	11812460998477	16423	8353	7	0	\N
12574	1439	11812461998477	16675	8470	8	0	\N
12575	1439	12223769578477	25767	12744	3	0	\N
12577	1439	12223781578477	25767	12744	4	0	\N
12582	1439	12240840000000	7932	3997	126	0	\N
12583	1439	12241900000000	7932	3997	127	0	\N
12584	1439	12242007000000	9824	5014	107	0	\N
12585	1439	12532459998477	16749	8503	4	0	\N
12586	1439	12532459998477	16831	8542	3	0	\N
12587	1439	12532459998477	17357	8698	3	0	\N
12588	1439	12532459998477	17411	8820	3	0	\N
12589	1439	12532459998477	17598	8890	20	0	\N
12590	1439	12532459998477	17786	8987	3	0	\N
12591	1439	12532459998477	19237	9699	3	0	\N
12592	1439	12532459998477	19258	9709	10	0	\N
12594	1439	12532471998477	16831	8542	4	0	\N
12595	1439	12532471998477	17411	8820	4	0	\N
12596	1439	12532471998477	17786	8987	4	0	\N
12597	1439	12532471998477	19237	9699	4	0	\N
12599	1439	12532481998477	16749	8503	5	0	\N
12601	1439	12532488998477	17598	8890	21	0	\N
12602	1439	12532496998477	19258	9709	11	0	\N
12603	1439	12532570998477	17357	8698	4	0	\N
12606	1439	12960250000000	9446	4899	2	0	\N
12607	1439	12960270000000	9446	4899	3	0	\N
12609	1439	12961900000000	7959	3998	31	0	\N
12610	1439	12962007000000	9824	5014	116	0	\N
12611	1439	12962051000000	9824	5014	117	0	\N
12612	1439	12962192000000	7959	3998	32	0	\N
12615	1439	13252518998477	19707	9923	5	0	\N
12616	1439	13252518998477	19708	9923	5	0	\N
12617	1439	13663875578477	27419	13556	3	0	\N
12618	1439	13663875578477	27602	13641	6	0	\N
12619	1439	13663875578477	27774	13723	2	0	\N
12620	1439	13663875578477	27970	13835	6	0	\N
12621	1439	13663875578477	27972	13835	11	0	\N
12623	1439	13663886578477	27774	13723	3	0	\N
12625	1439	13663887578477	27419	13556	4	0	\N
12626	1439	13663899578477	27602	13641	7	0	\N
12627	1439	13663908578477	27970	13835	7	0	\N
12628	1439	13663913578477	27972	13835	12	0	\N
12629	1439	13680277000000	10042	5210	2	0	\N
12630	1439	13680297000000	10042	5210	3	0	\N
12631	1439	13682051000000	10045	5015	60	0	\N
12634	1439	13972518998477	19707	9923	6	0	\N
12635	1439	13972518998477	19708	9923	6	0	\N
12636	1439	14383886578477	28781	14196	6	0	\N
12637	1439	14383886578477	28861	14234	3	0	\N
12640	1439	14383898578477	28861	14234	4	0	\N
12641	1439	14383910578477	28781	14196	7	0	\N
12647	1439	15412509998477	20100	10117	12	0	\N
12648	1439	15412856998477	20100	10117	13	0	\N
12531	1439	10080160000000	6731	3483	2	0	0
12532	1439	10080180000000	6731	3483	3	0	0
12544	1439	10800180000000	7502	3882	1	0	0
12545	1439	10800190000000	7502	3882	2	0	0
12561	1439	11520190000000	8971	4653	2	0	0
12579	1439	12240210000000	9047	4690	4	0	0
12580	1439	12240250000000	9047	4690	5	0	0
12581	1439	12240277000000	9821	5090	9	0	0
12608	1439	12960277000000	9821	5090	10	0	0
12524	1439	9652390998477	15445	7865	5	0	6
12534	1439	10372413998477	15457	7871	2	0	6
12535	1439	10372424998477	15457	7871	3	0	6
12547	1439	11092424998477	16155	8212	3	0	6
12548	1439	11092436998477	16155	8212	4	0	6
12572	1439	11812459998477	16726	8495	6	0	6
12593	1439	12532459998477	19466	9812	3	0	6
12598	1439	12532471998477	19466	9812	4	0	6
12600	1439	12532484998477	19578	9862	4	0	6
12613	1439	13252484998477	19578	9862	7	0	6
12632	1439	13972486998477	19935	10040	2	0	6
12633	1439	13972497998477	19935	10040	3	0	6
12642	1439	14692497998477	19959	10051	3	0	6
12643	1439	14692509998477	19959	10051	4	0	6
12515	1439	9343677578477	24689	12263	4	0	10
12528	1439	10063690578477	25019	12413	9	0	10
12529	1439	10063735578477	25019	12413	10	0	10
12538	1439	10783735578477	25241	12519	4	0	10
12539	1439	10783748578477	25241	12519	5	0	10
12553	1439	11503769578477	25416	12595	4	0	10
12576	1439	12223769578477	26053	12875	10	0	10
12578	1439	12223860578477	26053	12875	11	0	10
12604	1439	12943860578477	26370	13043	6	0	10
12605	1439	12943875578477	26370	13043	7	0	10
12624	1439	13663886578477	28192	13936	3	0	10
12638	1439	14383886578477	29381	14484	2	0	10
12639	1439	14383897578477	29381	14484	3	0	10
12644	1439	15103897578477	29400	14495	6	0	10
12645	1439	15103921578477	29400	14495	7	0	10
12652	1439	15823957578477	29716	14651	2	0	\N
12653	1439	15840301001008	12013	6072	121	0	\N
12655	1439	16543957578477	29716	14651	20	0	\N
12656	1439	16543974578477	29716	14651	21	0	\N
12658	1439	16544035578477	29876	14690	6	0	\N
12659	1439	17263975578477	29873	14723	7	0	\N
12660	1439	17263975578477	29875	14723	6	0	\N
12661	1439	17263975578477	29987	14766	19	0	\N
12663	1439	17263975578477	29989	14766	19	0	\N
12664	1439	17263990578477	29875	14723	7	0	\N
12665	1439	17263991578477	29873	14723	8	0	\N
12667	1439	17264012578477	29987	14766	20	0	\N
12668	1439	17264012578477	29989	14766	20	0	\N
12669	1439	17264035578477	29876	14690	121	0	\N
12670	1439	17264463056451	29876	14690	125	0	\N
12674	1439	18704034513346	30303	14895	3	0	\N
12675	1439	18704046513346	30303	14895	4	0	\N
12677	1440	200000017	17065	8644	2	0	\N
12678	1440	200000040	8626	4336	125	1	\N
12681	1440	721805045924	21515	10527	108	0	\N
12686	1440	1441805045924	21515	10527	126	0	\N
12690	1440	2160155045924	21705	10872	3	0	\N
12692	1440	2160167045924	21705	10872	4	0	\N
12693	1440	2592031151192	21515	10527	127	0	\N
12694	1440	2879020000000	10938	5639	2	0	\N
12696	1440	2879040000000	10938	5639	3	0	\N
12698	1440	2880030000000	452	255	1	0	\N
12699	1440	2880030000000	463	260	1	0	\N
12701	1440	2880040000000	452	255	2	0	\N
12702	1440	2880040000000	463	260	2	0	\N
12705	1440	2880166045924	22025	11011	1	0	\N
12706	1440	2880176045924	22025	11011	2	0	\N
12712	1440	3600070000000	1600	843	7	0	\N
12713	1440	3600080000000	1646	844	0	0	\N
12714	1440	3600090000000	1680	845	0	0	\N
12715	1440	3600178045924	22750	11376	2	0	\N
12717	1440	3600189045924	22750	11376	3	0	\N
12724	1440	4320192045924	22776	11389	3	0	\N
12726	1440	4320204045924	22776	11389	4	0	\N
12727	1440	5003274999976	11796	5819	126	0	\N
12730	1440	5039138000000	12059	6164	56	0	\N
12731	1440	5040070000000	2081	1099	1	0	\N
12733	1440	5040080000000	2081	1099	2	0	\N
12735	1440	5040204045924	23006	11493	3	0	\N
12737	1440	5040204045924	23079	11522	4	0	\N
12738	1440	5040216045924	23006	11493	4	0	\N
12739	1440	5040217045924	23079	11522	5	0	\N
12741	1440	5059196000000	12061	6109	114	0	\N
12742	1440	5759073000000	13504	6953	3	0	\N
12744	1440	5759085000000	13504	6953	4	0	\N
12746	1440	5759138000000	12059	6164	63	0	\N
12747	1440	5759144000000	12059	6164	64	0	\N
12748	1440	5760080000000	2352	1229	2	0	\N
12751	1440	5760100000000	2352	1229	3	0	\N
12752	1440	5760218045924	23160	11565	2	0	\N
12754	1440	5760229045924	23160	11565	3	0	\N
12756	1440	5760261045924	24583	12222	5	0	\N
12757	1440	5779196000000	12061	6109	126	0	\N
12758	1440	5779207000000	12061	6109	127	0	\N
12759	1440	6479096000000	13818	7094	16	0	\N
12760	1440	6479096000000	14193	7242	4	0	\N
12761	1440	6479096000000	14195	7242	1	0	\N
12763	1440	6479106000000	14195	7242	2	0	\N
12764	1440	6479109000000	14193	7242	5	0	\N
12766	1440	6479148000000	13818	7094	17	0	\N
12767	1440	6480090000000	3329	1724	12	0	\N
12770	1440	6480210000000	3329	1724	13	0	\N
12771	1440	6480229045924	23459	11697	3	0	\N
12772	1440	6480229045924	24262	12072	3	0	\N
12773	1440	6480229045924	24328	12099	3	0	\N
12774	1440	6480229045924	24913	12369	3	0	\N
12775	1440	6480229045924	24916	12369	3	0	\N
12776	1440	6480229045924	24989	12400	10	0	\N
12777	1440	6480229045924	25586	12591	3	0	\N
12778	1440	6480229045924	25587	12664	12	0	\N
12780	1440	6480241045924	23459	11697	4	0	\N
12781	1440	6480241045924	24262	12072	4	0	\N
12782	1440	6480241045924	24328	12099	4	0	\N
12783	1440	6480241045924	24913	12369	4	0	\N
12784	1440	6480241045924	24916	12369	4	0	\N
12682	1440	1440010000000	190	113	1	0	0
12683	1440	1440020000000	190	113	2	0	0
12687	1440	2160020000000	330	190	1	0	0
12688	1440	2160030000000	330	190	2	0	0
12700	1440	2880030000000	519	291	2	0	0
12710	1440	3600050000000	802	443	1	0	0
12711	1440	3600060000000	802	443	2	0	0
12721	1440	4320060000000	1888	1004	1	0	0
12722	1440	4320070000000	1888	1004	2	0	0
12732	1440	5040070000000	2153	1138	1	0	0
12749	1440	5760080000000	3253	1690	1	0	0
12750	1440	5760090000000	3253	1690	2	0	0
12768	1440	6480090000000	3705	1923	1	0	0
12769	1440	6480100000000	3705	1923	2	0	0
12697	1440	2879040000000	11030	5678	3	0	6
12708	1440	3599040000000	11032	5680	2	0	6
12709	1440	3599060000000	11032	5680	3	0	6
12719	1440	4319060000000	11499	5907	3	0	6
12720	1440	4319072000000	11499	5907	4	0	6
12729	1440	5039073000000	11790	6059	2	0	6
12743	1440	5759073000000	13792	7083	5	0	6
12745	1440	5759096000000	13792	7083	6	0	6
12762	1440	6479096000000	14228	7265	4	0	6
12765	1440	6479109000000	14228	7265	5	0	6
12685	1440	1440155045924	21516	10794	4	0	11
12689	1440	2160155045924	21704	10872	2	0	11
12691	1440	2160166045924	21704	10872	3	0	11
12704	1440	2880166045924	22024	11011	3	0	11
12716	1440	3600178045924	22763	11382	5	0	11
12718	1440	3600192045924	22763	11382	6	0	11
12723	1440	4320192045924	22775	11389	3	0	11
12725	1440	4320204045924	22775	11389	4	0	11
12736	1440	5040204045924	23077	11522	5	0	11
12753	1440	5760218045924	23239	11597	2	0	11
12755	1440	5760229045924	23239	11597	3	0	11
12779	1440	6480229045924	25608	12674	4	0	11
12649	1439	15823942578477	29515	14557	8	0	10
12650	1439	15823946578477	29515	14557	9	0	10
12654	1439	16543957578477	29715	14651	21	0	10
12657	1439	16543975578477	29715	14651	22	0	10
12662	1439	17263975578477	29988	14766	14	0	10
12666	1439	17264007578477	29988	14766	15	0	10
12672	1439	17984034513346	30220	14859	13	1	10
12673	1439	18704034513346	30302	14895	7	0	10
12676	1439	18704050513346	30302	14895	8	0	10
12786	1440	6480261045924	24583	12222	8	0	\N
12787	1440	6480263045924	24583	12222	9	0	\N
12788	1440	6480266045924	24989	12400	11	0	\N
12789	1440	6480277045924	25587	12664	13	0	\N
12790	1440	6480317045924	26620	13169	21	0	\N
12791	1440	6480331045924	25586	12591	4	0	\N
12794	1440	7200100000000	3790	1963	4	0	\N
12796	1440	7200140000000	3790	1963	5	0	\N
12797	1440	7200251045924	26825	13265	4	0	\N
12798	1440	7200251045924	26949	13330	3	0	\N
12799	1440	7200251045924	27040	13370	5	0	\N
12800	1440	7200251045924	27142	13421	3	0	\N
12801	1440	7200251045924	27555	13620	4	0	\N
12802	1440	7200251045924	27737	13703	2	0	\N
12803	1440	7200251045924	28249	13967	3	0	\N
12805	1440	7200262045924	27737	13703	3	0	\N
12807	1440	7200263045924	26949	13330	4	0	\N
12808	1440	7200263045924	27142	13421	4	0	\N
12809	1440	7200263045924	28249	13967	4	0	\N
12810	1440	7200264045924	26825	13265	5	0	\N
12811	1440	7200264045924	27555	13620	5	0	\N
12812	1440	7200265045924	27040	13370	6	0	\N
12813	1440	7200317045924	26620	13169	23	0	\N
12814	1440	7200318045924	26620	13169	24	0	\N
12816	1440	7200331045924	25607	12592	0	0	\N
12817	1440	7919121000000	14994	7638	5	0	\N
12820	1440	7919153000000	14994	7638	6	0	\N
12821	1440	7920262045924	28760	14187	2	0	\N
12822	1440	7920262045924	29300	14438	5	0	\N
12823	1440	7920262045924	29397	14494	3	0	\N
12825	1440	7920273045924	28760	14187	3	0	\N
12826	1440	7920274045924	29397	14494	4	0	\N
12828	1440	7920285045924	29300	14438	6	0	\N
12831	1440	7920560000000	1975	892	127	0	\N
12842	1440	9360409045924	30121	14822	23	0	\N
12843	1440	9360461077504	30121	14822	24	0	\N
12846	1440	10080360000000	5619	2919	0	0	\N
12858	1440	12239238000000	16714	8492	1	0	\N
12860	1440	12240410000000	6508	3374	2	0	\N
12863	1440	12240430000000	6508	3374	3	0	\N
12864	1440	12959228000000	16517	8401	3	0	\N
12865	1440	12959228000000	16537	8409	3	0	\N
12866	1440	12959228000000	16538	8409	2	0	\N
12867	1440	12959230000000	16538	8409	3	0	\N
12868	1440	12959238000000	16714	8492	4	0	\N
12870	1440	12959240000000	16517	8401	4	0	\N
12871	1440	12959240000000	16537	8409	4	0	\N
12872	1440	12959240000000	16714	8492	5	0	\N
12876	1440	13679239999999	17065	8644	1	0	\N
12877	1440	13679240000000	16792	8522	3	0	\N
12878	1440	13679240000000	16820	8537	2	0	\N
12880	1440	13679251000000	16820	8537	3	0	\N
12881	1440	13679252000000	16792	8522	4	0	\N
12886	1440	14399289000000	17189	8710	9	0	\N
12888	1440	14399325000000	17189	8710	10	0	\N
12889	1440	14400450000000	7551	3910	1	0	\N
12890	1440	14400450000000	7576	3920	1	0	\N
12891	1440	14400450000000	7925	4108	1	0	\N
12893	1440	14400460000000	7551	3910	2	0	\N
12894	1440	14400460000000	7576	3920	2	0	\N
12895	1440	14400460000000	7925	4108	2	0	\N
12902	1440	15839312049920	18326	9231	3	0	\N
12904	1440	15839324049920	18326	9231	4	0	\N
12907	1440	16559314049920	18389	9268	3	0	\N
12909	1440	16559326049920	18389	9268	4	0	\N
12913	1440	17279326049920	18534	9338	3	0	\N
12914	1440	17279326049920	18549	9345	4	0	\N
12917	1440	17279338049920	18534	9338	4	0	\N
12918	1440	17279349049920	19862	10005	3	0	\N
12920	1440	17279438049920	18549	9345	5	0	\N
12829	1440	7920320000000	4741	2452	2	0	0
12830	1440	7920340000000	4741	2452	3	0	0
12835	1440	8640340000000	4967	2575	1	0	0
12836	1440	8640350000000	4967	2575	2	0	0
12840	1440	9360350000000	5074	2632	1	0	0
12847	1440	10080360000000	5695	2952	0	0	0
12850	1440	10800360000000	6035	3132	3	0	0
12851	1440	10800390000000	6035	3132	4	0	0
12854	1440	11520390000000	6421	3325	2	0	0
12855	1440	11520410000000	6421	3325	3	0	0
12862	1440	12240420000000	7189	3716	2	0	0
12874	1440	12960420000000	7205	3723	2	0	0
12875	1440	12960440000000	7205	3723	3	0	0
12883	1440	13680440000000	7486	3872	1	0	0
12892	1440	14400450000000	7986	4140	3	0	0
12896	1440	14400570000000	7986	4140	4	0	0
12899	1440	15120570000000	8015	4153	2	0	0
12900	1440	15120581000000	8015	4153	3	0	0
12905	1440	15840581000000	8022	4159	2	0	0
12911	1440	16560601000000	8073	4185	2	0	0
12912	1440	16560612000000	8073	4185	3	0	0
12792	1440	7199109000000	14976	7631	3	0	6
12793	1440	7199121000000	14976	7631	4	0	6
12818	1440	7919121000000	15333	7815	4	0	6
12832	1440	8639143000000	15585	7933	2	0	6
12833	1440	8639154000000	15585	7933	3	0	6
12838	1440	9359154000000	15661	7971	4	0	6
12839	1440	9359167000000	15661	7971	5	0	6
12845	1440	10079179000000	15952	8110	4	0	6
12848	1440	10799179000000	16038	8156	3	0	6
12849	1440	10799191000000	16038	8156	4	0	6
12852	1440	11519191000000	16296	8280	4	0	6
12853	1440	11519204000000	16296	8280	5	0	6
12857	1440	12239228000000	16354	8317	7	0	6
12859	1440	12239238000000	16718	8492	1	0	6
12869	1440	12959238000000	16718	8492	4	0	6
12873	1440	12959240000000	16718	8492	5	0	6
12879	1440	13679240000000	17066	8644	13	0	6
12885	1440	14399289000000	17188	8710	9	0	6
12887	1440	14399289049920	17188	8710	10	1	6
12897	1440	15119289049920	17351	8790	5	0	6
12898	1440	15119312049920	17351	8790	6	0	6
12903	1440	15839314049920	18325	9231	3	0	6
12908	1440	16559314049920	18409	9281	3	0	6
12910	1440	16559326049920	18409	9281	4	0	6
12915	1440	17279326049920	18774	9461	2	0	6
12916	1440	17279337049920	18774	9461	3	0	6
12785	1440	6480251045924	25608	12674	5	0	11
12804	1440	7200251045924	28384	14032	2	0	11
12806	1440	7200262045924	28384	14032	3	0	11
12824	1440	7920262045924	29507	14553	3	0	11
12827	1440	7920274045924	29507	14553	4	0	11
12837	1440	8640409045924	29672	14635	19	0	11
12923	1440	17999337049920	19194	9684	3	0	\N
12924	1440	17999349049920	19194	9684	4	0	\N
12925	1440	17999349049920	19862	10005	6	0	\N
12928	1440	17999351049920	19862	10005	7	0	\N
12931	1440	18719351045924	19994	10068	3	0	\N
12932	1440	18719351045924	20036	10086	3	0	\N
12933	1440	18719351045924	20106	10119	9	0	\N
12934	1440	18719351045924	20144	10139	5	0	\N
12936	1440	18719363045924	19994	10068	4	0	\N
12937	1440	18719363045924	20036	10086	4	0	\N
12939	1440	18719414045924	20106	10119	10	0	\N
12940	1440	18719483045924	20144	10139	6	0	\N
12941	1440	18720642000000	9121	4725	2	0	\N
12943	1440	18720662000000	9121	4725	3	0	\N
12945	1440	19440662000000	9312	4831	3	0	\N
12948	1440	19440683000000	9312	4831	4	0	\N
12950	1440	20160672000000	9468	4899	27	0	\N
12953	1440	20160924000000	9468	4899	28	0	\N
12960	1440	23040760000000	10053	5214	1	0	\N
12962	1440	23040770000000	10053	5214	2	0	\N
12972	1443	100000000000	4397	2280	10	0	\N
12973	1443	720000000000	21593	10825	6	0	\N
12974	1443	720000000000	21596	10825	6	0	\N
12975	1443	720024000000	21593	10825	7	0	\N
12976	1443	720024000000	21596	10825	7	0	\N
12977	1444	25000000	10322	5340	5	0	\N
12978	1444	100000017	23462	11539	108	0	\N
12979	1444	200003000	7819	4054	5	0	\N
12980	1444	287999962	23462	11539	115	0	\N
12987	1444	2014665160000	9867	5118	4	0	\N
12988	1444	2014665160000	9874	5121	2	0	\N
12990	1444	2014685160000	9874	5121	3	0	\N
12991	1444	2014705160000	9867	5118	5	0	\N
12996	1444	2247575329999	20968	10546	2	0	\N
12998	1444	2247586329999	20968	10546	3	0	\N
13005	1444	2967619329999	21241	10667	1	0	\N
13006	1444	2967619329999	21242	10667	1	0	\N
13007	1444	3454935160000	10320	5340	4	0	\N
13008	1444	3454935160000	10322	5340	4	0	\N
13011	1444	3454975160000	10320	5340	5	0	\N
13016	1444	3687609329999	21270	10680	1	0	\N
13017	1444	3687610329999	21270	10680	2	0	\N
13018	1444	3687619329999	21241	10667	3	0	\N
13019	1444	3687619329999	21242	10667	3	0	\N
13020	1444	3687620329999	21241	10667	4	0	\N
13021	1444	3687620329999	21242	10667	4	0	\N
13024	1444	3687660329999	21647	10845	4	0	\N
13025	1444	4174955160000	11064	5692	2	0	\N
13026	1444	4174955160000	11628	5985	1	0	\N
13028	1444	4174956160000	11628	5985	2	0	\N
13030	1444	4174975160000	11064	5692	3	0	\N
13032	1444	4407620329999	21301	10695	4	0	\N
13033	1444	4407633329999	21301	10695	5	0	\N
13035	1444	4407660329999	21647	10845	9	0	\N
13037	1444	4407664329999	21647	10845	10	0	\N
13038	1444	4894956160000	11916	6130	1	0	\N
13040	1444	4894957160000	11916	6130	2	0	\N
13046	1444	5614957160000	12238	6302	1	0	\N
13048	1444	5614958160000	12238	6302	2	0	\N
13052	1444	5847676329999	22007	11005	3	0	\N
13054	1444	5847688329999	22007	11005	4	0	\N
12983	1444	1440010000000	210	123	2	0	0
12984	1444	1440030000000	210	123	3	0	0
12993	1444	2160030000000	497	277	2	0	0
12994	1444	2160050000000	497	277	3	0	0
13001	1444	2880050000000	952	531	2	0	0
13012	1444	3600070000000	1016	562	1	0	0
13013	1444	3600080000000	1016	562	2	0	0
13014	1444	3600090000000	1136	628	1	0	0
13031	1444	4320090000000	1136	628	2	0	0
13042	1444	5040090000000	2061	1089	1	0	0
13050	1444	5760100000000	2239	1180	2	0	0
13051	1444	5760120000000	2239	1180	3	0	0
12921	1440	17280612000000	8356	4327	2	0	0
12922	1440	17280632000000	8356	4327	3	0	0
12930	1440	18000642000000	8578	4447	2	0	0
12942	1440	18720642000000	9123	4725	2	0	0
12944	1440	18720662000000	9123	4725	3	0	0
12946	1440	19440662000000	9314	4831	1	0	0
12947	1440	19440672000000	9314	4831	2	0	0
12951	1440	20160692000000	9467	4909	3	0	0
12952	1440	20160712000000	9748	5050	2	0	0
12954	1440	20880712000000	9748	5050	4	0	0
12955	1440	20880713000000	9748	5050	5	0	0
12956	1440	21600713000000	9810	5086	9	0	0
12958	1440	22320740000000	9930	5154	2	0	0
12959	1440	22320760000000	9930	5154	3	0	0
12989	1444	2014665160000	10089	5234	12	0	5
12992	1444	2014875160000	10089	5234	13	0	5
13000	1444	2734935160000	10103	5242	7	0	5
12961	1440	23040760000000	10337	5350	2	0	0
12963	1440	23040780000000	10337	5350	3	0	0
12964	1440	23760780000000	10405	5381	6	0	0
12965	1440	23760840000000	10405	5381	7	0	0
12967	1440	24480850000000	10495	5423	2	0	0
13009	1444	3454935160000	10570	5458	2	0	5
13010	1444	3454955160000	10570	5458	3	0	5
13027	1444	4174955160000	11808	6068	1	0	5
13029	1444	4174956160000	11808	6068	2	0	5
13041	1444	4894957160000	11972	6161	2	0	5
13047	1444	5614957160000	12254	6310	1	0	5
13049	1444	5614958160000	12254	6310	2	0	5
13056	1444	6334958160000	13044	6725	3	0	5
12927	1440	17999351045924	19863	10005	7	0	6
12935	1440	18719351045924	20333	10240	3	0	6
12938	1440	18719363045924	20333	10240	4	0	6
12985	1444	1527563329999	20878	10495	3	0	12
12986	1444	1527575329999	20878	10495	4	0	12
12997	1444	2247586329999	20967	10546	3	0	12
13003	1444	2967586329999	21043	10575	5	0	12
13004	1444	2967609329999	21043	10575	6	0	12
12968	1441	720000000000	21144	10617	4	0	0
12969	1441	720022000000	21144	10617	5	0	0
13022	1444	3687620329999	21269	10680	3	0	12
13023	1444	3687660329999	21646	10845	4	0	12
13034	1444	4407660329999	21646	10845	9	0	12
13036	1444	4407664329999	21646	10845	10	0	12
13045	1444	5127676329999	21673	10857	4	0	12
12970	1441	1440022000000	22459	11238	3	0	0
12971	1441	1440034000000	22459	11238	4	0	0
13053	1444	5847676329999	22552	11283	6	0	12
13055	1444	5847700329999	22552	11283	7	0	12
13060	1444	6567700329999	22577	11295	11	0	\N
13062	1444	6567700329999	23008	11493	2	0	\N
13063	1444	6567711329999	23008	11493	3	0	\N
13065	1444	6567734329999	23135	11553	4	0	\N
13066	1444	6567738329999	22577	11295	12	0	\N
13071	1444	7287712329999	23136	11536	76	0	\N
13073	1444	7287734329999	23135	11553	8	0	\N
13074	1444	7287737329999	23135	11553	9	0	\N
13075	1444	7287986329999	23136	11536	77	0	\N
13076	1444	7288143329999	23156	11537	31	0	\N
13077	1444	7774983160000	13669	7024	3	0	\N
13078	1444	7774983160000	13671	7024	2	0	\N
13080	1444	7774983160000	13909	7133	2	0	\N
13081	1444	7774994160000	13671	7024	3	0	\N
13082	1444	7774995160000	13669	7024	4	0	\N
13083	1444	7775003160000	13909	7133	3	0	\N
13085	1444	7920150000000	3336	1732	3	0	\N
13088	1444	7920180000000	3336	1732	4	0	\N
13091	1444	8008143329999	23156	11537	48	0	\N
13092	1444	8008159329999	23156	11537	49	0	\N
13093	1444	8009339329999	23410	11538	109	0	\N
13095	1444	8495009160000	14023	7185	3	0	\N
13096	1444	8495030160000	14023	7185	4	0	\N
13098	1444	8495077159999	14213	7239	4	0	\N
13100	1444	8727723329999	23461	11697	3	0	\N
13101	1444	8727723329999	23777	11840	3	0	\N
13104	1444	8727735329999	23461	11697	4	0	\N
13105	1444	8727735329999	23777	11840	4	0	\N
13106	1444	8729339329999	23410	11538	126	0	\N
13107	1444	8729499329999	23410	11538	127	0	\N
13108	1444	9215037159999	14034	7189	3	0	\N
13109	1444	9215037159999	14037	7189	1	0	\N
13110	1444	9215037159999	14146	7223	3	0	\N
13111	1444	9215037159999	14148	7223	1	0	\N
13113	1444	9215038159999	14148	7223	2	0	\N
13114	1444	9215047159999	14037	7189	2	0	\N
13115	1444	9215049159999	14034	7189	4	0	\N
13116	1444	9215049159999	14146	7223	4	0	\N
13118	1444	9215077159999	14213	7239	15	0	\N
13119	1444	9260664124186	26436	13078	7	0	\N
13120	1444	9360160000000	3765	1954	2	0	\N
13122	1444	9360180000000	3765	1954	3	0	\N
13127	1444	9450129320098	23462	11539	114	0	\N
13128	1444	9935050159999	14687	7480	7	0	\N
13129	1444	9935050159999	14902	7593	4	0	\N
13132	1444	9935063159999	14902	7593	5	0	\N
13133	1444	9935111159999	14687	7480	8	0	\N
13136	1444	10167757329999	24709	12272	3	0	\N
13137	1444	10167769329999	24709	12272	4	0	\N
13142	1444	10800220000000	4243	2203	1	0	\N
13144	1444	10800230000000	4243	2203	2	0	\N
13146	1444	10887819329999	25131	12471	7	0	\N
13149	1444	10887844329999	25131	12471	8	0	\N
13154	1444	11607831329999	25640	12690	3	0	\N
13157	1444	11607843329999	25640	12690	4	0	\N
13158	1444	11674511943000	14213	7239	16	1	\N
13161	1444	12240360000000	4365	2264	1	0	\N
13163	1444	12240370000000	4365	2264	2	0	\N
13165	1444	12327842329991	26436	13078	6	0	\N
13168	1444	12815096159999	15711	7902	1	0	\N
13169	1444	12815096159999	15712	7990	3	0	\N
13171	1444	12815097159999	15711	7902	2	0	\N
13172	1444	12815108159999	15712	7990	4	0	\N
13174	1444	12960470000000	5002	2594	1	0	\N
13176	1444	12960480000000	5002	2594	2	0	\N
13180	1444	13535097159999	15745	7903	4	0	\N
13183	1444	13535209159999	15745	7903	5	0	\N
13186	1444	13767891329999	26898	13302	11	0	\N
13189	1444	13767938329999	26898	13302	12	0	\N
13069	1444	7200140000000	2916	1519	1	0	0
13070	1444	7200150000000	2916	1519	2	0	0
13086	1444	7920150000000	3392	1765	1	0	0
13087	1444	7920160000000	3392	1765	2	0	0
13099	1444	8640160000000	3514	1824	0	0	0
13123	1444	9360200000000	3789	1963	5	0	0
13134	1444	10080200000000	3883	2018	2	0	0
13135	1444	10080220000000	3883	2018	3	0	0
13143	1444	10800220000000	4246	2204	4	0	0
13145	1444	10800350000000	4246	2204	5	0	0
13153	1444	11520360000000	4333	2245	2	0	0
13162	1444	12240360000000	4670	2415	2	0	0
13164	1444	12240470000000	4670	2415	3	0	0
13175	1444	12960470000000	5072	2631	1	0	0
13184	1444	13680480000000	5096	2645	2	0	0
13185	1444	13680500000000	5096	2645	3	0	0
13192	1444	14400500000000	5227	2717	1	0	0
13057	1444	6334970160000	13044	6725	4	0	5
13067	1444	7054970160000	13250	6824	4	0	5
13079	1444	7774983160000	13908	7133	8	0	5
13084	1444	7775009160000	13908	7133	9	0	5
13094	1444	8495009160000	14020	7185	10	0	5
13097	1444	8495037159999	14020	7185	11	0	5
13112	1444	9215037159999	14212	7255	4	0	5
13130	1444	9935050159999	15059	7670	2	0	5
13131	1444	9935061159999	15059	7670	3	0	5
13140	1444	10655061159999	15138	7717	2	0	5
13141	1444	10655072159999	15138	7717	3	0	5
13151	1444	11375084159999	15290	7791	4	0	5
13159	1444	12095084159999	15482	7882	3	0	5
13160	1444	12095096159999	15482	7882	4	0	5
13170	1444	12815096159999	15746	8008	7	0	5
13173	1444	12815130159999	15746	8008	8	0	5
13182	1444	13535142159999	16209	8237	4	0	5
13190	1444	14255142159999	16542	8410	14	0	5
13191	1444	14255201159999	16542	8410	15	0	5
13061	1444	6567700329999	23007	11493	3	0	12
13072	1444	7287712329999	23154	11563	0	0	12
13089	1444	8007712329999	23409	11679	2	0	12
13090	1444	8007723329999	23409	11679	3	0	12
13102	1444	8727723329999	24405	12136	2	0	12
13103	1444	8727734329999	24405	12136	3	0	12
13125	1444	9447757329999	24533	12197	6	0	12
13126	1444	9447817329999	24708	12272	6	0	12
13138	1444	10167817329999	24708	12272	9	0	12
13139	1444	10167819329999	24708	12272	10	0	12
13147	1444	10887819329999	25481	12620	3	0	12
13155	1444	11607831329999	26056	12876	2	0	12
13156	1444	11607842329999	26056	12876	3	0	12
13166	1444	12327842329999	26437	13078	6	0	12
13167	1444	12327866329999	26437	13078	7	0	12
13178	1444	13047866329999	26513	13117	7	0	12
13187	1444	13767891329999	27103	13400	6	0	12
13188	1444	13767915329999	27103	13400	7	0	12
13194	1444	14487915329999	27478	13579	26	0	\N
13196	1444	14487968329999	27478	13579	27	0	\N
13197	1444	14975201159999	16873	8558	4	0	\N
13200	1444	14975214159999	16873	8558	5	0	\N
13201	1444	15120510000000	6016	3121	1	0	\N
13203	1444	15120520000000	6016	3121	2	0	\N
13207	1444	15695213159999	17074	8648	2	0	\N
13209	1444	15695224159999	17074	8648	3	0	\N
13211	1444	15840520000000	6377	3303	1	0	\N
13212	1444	15840520000000	6483	3360	2	0	\N
13213	1444	15840520000000	6549	3394	0	0	\N
13215	1444	15840530000000	6377	3303	2	0	\N
13216	1444	15840540000000	6483	3360	3	0	\N
13218	1444	16027929329999	27654	13666	3	0	\N
13219	1444	16027929329999	28618	14132	4	0	\N
13221	1444	16027929329999	28684	14150	0	0	\N
13222	1444	16027941329999	27654	13666	4	0	\N
13224	1444	16027942329999	28618	14132	5	0	\N
13225	1444	16415225159999	17410	8820	3	0	\N
13227	1444	16415237159999	17410	8820	4	0	\N
13229	1444	16415437159999	17994	9061	20	0	\N
13231	1444	16560540000000	6624	3426	4	0	\N
13232	1444	16560540000000	6625	3426	7	0	\N
13235	1444	16560580000000	6624	3426	5	0	\N
13236	1444	16560610000000	6625	3426	8	0	\N
13237	1444	16747941329999	29078	14335	4	0	\N
13238	1444	16747941329999	29079	14335	3	0	\N
13239	1444	16747941329999	29097	14344	4	0	\N
13240	1444	16747941329999	29250	14415	2	0	\N
13242	1444	16747952329999	29250	14415	3	0	\N
13243	1444	16747953329999	29079	14335	4	0	\N
13244	1444	16747954329999	29078	14335	5	0	\N
13245	1444	16747954329999	29097	14344	5	0	\N
13249	1444	17135437159999	17994	9061	98	0	\N
13250	1444	17135658159999	17994	9061	99	0	\N
13251	1444	17280560000000	7117	3677	11	0	\N
13252	1444	17280560000000	7315	3781	2	0	\N
13253	1444	17280560000000	7777	4033	1	0	\N
13254	1444	17280560000000	7819	4054	4	0	\N
13256	1444	17280570000000	7777	4033	2	0	\N
13257	1444	17280580000000	7315	3781	3	0	\N
13259	1444	17280670000000	7117	3677	12	0	\N
13262	1444	17467987329999	29666	14633	2	0	\N
13264	1444	17855249159999	18700	9419	4	0	\N
13267	1444	17855271159999	18700	9419	5	0	\N
13270	1444	18187987329999	29666	14633	19	0	\N
13272	1444	18188003329999	29666	14633	20	0	\N
13279	1444	18908003329999	29724	14654	6	0	\N
13280	1444	18908067329999	29724	14654	7	0	\N
13282	1444	18952370159999	20366	10259	3	0	\N
13284	1444	18952382159999	20366	10259	4	0	\N
13286	1444	19294432159999	19356	9731	11	0	\N
13289	1444	19295301159999	19151	9662	1	0	\N
13290	1444	19295301159999	19153	9662	1	0	\N
13293	1444	19628070329999	30180	14848	8	0	\N
13294	1444	19628070329999	30182	14848	4	0	\N
13295	1444	19628083329999	30182	14848	5	0	\N
13296	1444	19628087329999	30180	14848	9	0	\N
13297	1444	20014281159999	19295	9727	3	0	\N
13299	1444	20014293159999	19295	9727	4	0	\N
13301	1444	20014432059999	19356	9731	12	0	\N
13302	1444	20015301159999	19151	9662	5	0	\N
13303	1444	20015301159999	19153	9662	5	0	\N
13304	1444	20015304159999	19151	9662	6	0	\N
13305	1444	20015304159999	19153	9662	6	0	\N
13306	1444	20160653000000	9510	4932	3	0	\N
13307	1444	20160653000000	9704	5034	4	0	\N
13308	1444	20160653000000	9707	5034	2	0	\N
13309	1444	20160673000000	9707	5034	3	0	\N
13310	1444	20160683000000	9510	4932	4	0	\N
13311	1444	20160693000000	9704	5034	5	0	\N
13312	1444	20732358159999	19475	9819	5	0	\N
13315	1444	20732372159999	19475	9819	6	0	\N
13316	1445	720000000000	278	161	1	0	\N
13318	1445	720010000000	278	161	2	0	\N
13320	1445	1440020000000	455	256	2	0	\N
13323	1445	1440040000000	455	256	3	0	\N
13326	1445	2160030000000	1162	640	2	0	\N
13328	1445	2160050000000	1162	640	3	0	\N
13321	1445	1440020000000	1104	611	1	0	0
13322	1445	1440030000000	1104	611	2	0	0
13327	1445	2160030000000	1288	711	2	0	0
13193	1444	14400510000000	5227	2717	2	0	0
13202	1444	15120510000000	6036	3133	1	0	0
13214	1444	15840520000000	6550	3395	2	0	0
13217	1444	15840540000000	6550	3395	3	0	0
13233	1444	16560540000000	7085	3656	2	0	0
13234	1444	16560560000000	7085	3656	3	0	0
13255	1444	17280560000000	7820	4054	4	0	0
13268	1444	18000600000000	8081	4190	3	0	0
13269	1444	18000612000000	8081	4190	4	0	0
13276	1444	18720612000000	9293	4820	3	0	0
13277	1444	18720633000000	9293	4820	4	0	0
13292	1444	19440653000000	9509	4931	3	0	0
13198	1444	14975201159999	17069	8646	3	0	5
13199	1444	14975213159999	17069	8646	4	0	5
13208	1444	15695213159999	17352	8791	3	0	5
13210	1444	15695225159999	17352	8791	4	0	5
13228	1444	16415237159999	17581	8896	4	0	5
13247	1444	17135237159999	17993	9078	3	0	5
13248	1444	17135249159999	17993	9078	4	0	5
13265	1444	17855249159999	18887	9527	3	0	5
13266	1444	17855270159999	18887	9527	4	0	5
13275	1444	18575281159999	18982	9573	3	0	5
13287	1444	19295281159999	18995	9578	1	0	5
13288	1444	19295291159999	18995	9578	2	0	5
13298	1444	20014281159999	19355	9759	15	0	6
13313	1444	20732358159999	19476	9819	4	0	7
13314	1444	20732371159999	19476	9819	5	0	7
13283	1444	18952370159999	20551	10346	7	0	8
13285	1444	18952395159999	20551	10346	8	0	8
13195	1444	14487915329999	27492	13589	4	0	12
13205	1444	15307917329999	27605	13643	3	0	13
13206	1444	15307929329999	27605	13643	4	0	13
13220	1444	16027929329999	28683	14160	3	0	13
13223	1444	16027941329999	28683	14160	4	0	13
13324	1445	1724169000000	29439	14515	3	0	8
13241	1444	16747941329999	29559	14573	4	0	13
13246	1444	16747954329999	29559	14573	5	0	13
13260	1444	17467954329999	29565	14577	4	0	13
13261	1444	17467967329999	29565	14577	5	0	13
13271	1444	18187987329999	29667	14633	19	0	13
13273	1444	18188003329999	29667	14633	20	0	13
13278	1444	18908003329999	29723	14654	9	0	13
13281	1444	18908070329999	29723	14654	10	0	13
13338	1445	5077189000000	10866	5608	3	0	\N
13339	1445	5077219000000	10866	5608	4	0	\N
13340	1445	5760130000000	2036	1074	2	0	\N
13342	1445	5760150000000	2036	1074	3	0	\N
13344	1445	6480150000000	2355	1231	2	0	\N
13345	1445	6480150000000	2570	1353	1	0	\N
13347	1445	6480160000000	2570	1353	2	0	\N
13348	1445	6480170000000	2355	1231	3	0	\N
13350	1445	7200170000000	3587	1863	0	0	\N
13355	1445	8640190000000	4233	2199	5	0	\N
13356	1445	8640190000000	4944	2560	1	0	\N
13358	1445	8640200000000	4944	2560	2	0	\N
13360	1445	8640330000000	4233	2199	6	0	\N
13361	1445	9360200000000	5270	2736	2	0	\N
13363	1445	9360220000000	5270	2736	3	0	\N
13367	1445	11520220000000	5915	3067	3	0	\N
13368	1445	11520220000000	6103	3167	1	0	\N
13369	1445	11520220000000	6109	3168	4	0	\N
13371	1445	11520230000000	6103	3167	2	0	\N
13373	1445	11520250000000	5915	3067	4	0	\N
13374	1445	11520350000000	6109	3168	5	0	\N
13377	1445	12960240000000	7530	3898	2	0	\N
13380	1445	12960251000000	7530	3898	3	0	\N
13381	1445	13680250000000	7575	3920	1	0	\N
13383	1445	13680260000000	7575	3920	2	0	\N
13395	1446	720000000000	748	419	1	0	\N
13396	1446	720000000000	7472	3865	1	0	\N
13398	1446	720010000000	748	419	2	0	\N
13399	1446	720010000000	7472	3865	2	0	\N
13401	1447	10000001	4874	2326	113	0	\N
13404	1447	1434942190000	16707	8428	125	1	\N
13405	1447	1440010000000	57	33	1	0	\N
13407	1447	1440020000000	57	33	2	0	\N
13411	1447	2880030000000	431	245	1	0	\N
13412	1447	2880030000000	872	483	1	0	\N
13414	1447	2880040000000	431	245	2	0	\N
13415	1447	2880040000000	872	483	2	0	\N
13417	1447	2880580001000	13448	6928	10	1	\N
13418	1447	3019243759017	18196	9170	6	1	\N
13423	1447	5040060000000	1212	667	1	0	\N
13424	1447	5040060000000	1602	867	2	0	\N
13425	1447	5040060000000	1881	1000	1	0	\N
13426	1447	5040060000000	2170	1145	1	0	\N
13428	1447	5040070000000	1212	667	2	0	\N
13429	1447	5040070000000	1881	1000	2	0	\N
13430	1447	5040070000000	2170	1145	2	0	\N
13432	1447	5040080000000	1602	867	3	0	\N
13437	1447	5914360944000	10608	5479	2	0	\N
13439	1447	5914380944000	10608	5479	3	0	\N
13444	1447	6634380944000	11055	5673	42	0	\N
13446	1447	6634800944000	11055	5673	43	0	\N
13447	1447	7200100000000	3025	1572	1	0	\N
13448	1447	7200100000000	3043	1581	2	0	\N
13450	1447	7200110000000	3025	1572	2	0	\N
13452	1447	7200120000000	3043	1581	3	0	\N
13455	1447	7920110000000	3861	2005	1	0	\N
13456	1447	7920110000000	3930	2039	2	0	\N
13458	1447	7920120000000	3861	2005	2	0	\N
13460	1447	7920130000000	3930	2039	3	0	\N
13461	1447	8074461944000	11347	5828	4	0	\N
13464	1447	8074483944000	11347	5828	5	0	\N
13406	1447	1440010000000	223	132	1	0	0
13408	1447	1440020000000	223	132	2	0	0
13409	1447	2160020000000	429	244	1	0	0
13410	1447	2160030000000	429	244	2	0	0
13413	1447	2880030000000	928	517	1	0	0
13419	1447	3600040000000	1116	615	1	0	0
13420	1447	3600050000000	1116	615	2	0	0
13421	1447	4320050000000	1131	624	1	0	0
13422	1447	4320060000000	1131	624	2	0	0
13329	1445	2160050000000	1288	711	3	0	0
13331	1445	2880060000000	1502	822	2	0	0
13332	1445	3600060000000	1512	827	2	0	0
13333	1445	3600080000000	1512	827	3	0	0
13334	1445	4320080000000	1660	894	4	0	0
13336	1445	5040120000000	1892	1007	1	0	0
13337	1445	5040130000000	1892	1007	2	0	0
13341	1445	5760130000000	2037	1074	2	0	0
13343	1445	5760150000000	2037	1074	3	0	0
13427	1447	5040060000000	2505	1313	1	0	0
13435	1447	5760070000000	2559	1349	1	0	0
13436	1447	5760080000000	2559	1349	2	0	0
13346	1445	6480150000000	2776	1453	2	0	0
13349	1445	6480170000000	2776	1453	3	0	0
13441	1447	6480080000000	2923	1522	2	0	0
13351	1445	7200170000000	3671	1907	1	0	0
13352	1445	7200180000000	3671	1907	2	0	0
13449	1447	7200100000000	3857	2003	1	0	0
13451	1447	7200110000000	3857	2003	2	0	0
13354	1445	7920190000000	3948	2051	2	0	0
13457	1447	7920110000000	3957	2057	1	0	0
13459	1447	7920120000000	3957	2057	2	0	0
13357	1445	8640190000000	5083	2637	1	0	0
13359	1445	8640200000000	5083	2637	2	0	0
13364	1445	10080200000000	5427	2823	0	0	0
13365	1445	10800200000000	5805	3012	2	0	0
13366	1445	10800220000000	5805	3012	3	0	0
13370	1445	11520220000000	6159	3190	1	0	0
13372	1445	11520230000000	6159	3190	2	0	0
13376	1445	12240240000000	7445	3848	2	0	0
13378	1445	12960240000000	7540	3903	1	0	0
13379	1445	12960250000000	7540	3903	2	0	0
13382	1445	13680250000000	8118	4209	1	0	0
13385	1445	14400260000000	9275	4809	2	0	0
13386	1445	14400280000000	9275	4809	3	0	0
13387	1445	15120280000000	9386	4868	2	0	0
13388	1445	15120300000000	9386	4868	3	0	0
13389	1445	15840300000000	9910	5140	2	0	0
13391	1445	16560320000000	9992	5181	2	0	0
13392	1445	16560340000000	9992	5181	3	0	0
13433	1447	5194270944000	10483	5419	9	0	5
13434	1447	5194360944000	10483	5419	10	0	5
13438	1447	5914360944000	10830	5589	2	0	5
13443	1447	6634380944000	11053	5687	4	0	5
13445	1447	6634420944000	11053	5687	5	0	5
13453	1447	7354420944000	11248	5779	5	0	5
13454	1447	7354461944000	11248	5779	6	0	5
13463	1447	8074472944000	11496	5906	3	0	5
13397	1446	720000000000	21114	10603	3	0	0
13400	1446	720012000000	21114	10603	4	0	0
13393	1445	21598181000000	29605	14600	4	0	8
13394	1445	21598194000000	29605	14600	5	0	8
13465	1447	8640120000000	4279	2218	2	0	\N
13468	1447	8640140000000	4279	2218	3	0	\N
13471	1447	9215167159982	14213	7239	16	0	\N
13478	1447	10195454908540	12459	6140	11	1	\N
13479	1447	10234474944000	12037	6197	1	0	\N
13480	1447	10234474944000	12040	6198	1	0	\N
13482	1447	10234475944000	12037	6197	2	0	\N
13483	1447	10234475944000	12040	6198	2	0	\N
13488	1447	11081677683000	22970	11475	2	0	\N
13490	1447	11081688683000	22970	11475	3	0	\N
13494	1447	11674476944000	12485	6436	4	0	\N
13495	1447	11674476944000	12694	6546	2	0	\N
13496	1447	11674476944000	12864	6633	7	0	\N
13498	1447	11674480944000	12485	6436	5	0	\N
13499	1447	11674487944000	12694	6546	3	0	\N
13502	1447	11674519944000	12864	6633	8	0	\N
13503	1447	11717701982097	18367	9112	126	0	\N
13506	1447	12240210000000	5311	2762	1	0	\N
13508	1447	12240220000000	5311	2762	2	0	\N
13509	1447	12394501943000	13328	6869	3	0	\N
13510	1447	12394501943000	13422	6916	9	0	\N
13511	1447	12394501943000	13482	6943	9	0	\N
13512	1447	12394501943000	13545	6971	3	0	\N
13513	1447	12394501943000	13546	6971	1	0	\N
13514	1447	12394501943000	14441	7370	4	0	\N
13516	1447	12394511943000	13546	6971	2	0	\N
13518	1447	12394513943000	13328	6869	4	0	\N
13519	1447	12394513943000	13545	6971	4	0	\N
13520	1447	12394514943000	14441	7370	5	0	\N
13521	1447	12394528943000	13422	6916	10	0	\N
13522	1447	12394537943000	13482	6943	10	0	\N
13528	1447	13241710683000	23517	11722	5	0	\N
13531	1447	13241724683000	23517	11722	6	0	\N
13534	1447	13834523943000	15683	7980	3	0	\N
13535	1447	13834523943000	15980	8122	3	0	\N
13536	1447	13834523943000	16227	8248	7	0	\N
13537	1447	13834523943000	16228	8247	10	0	\N
13538	1447	13834523943000	16298	8282	3	0	\N
13540	1447	13834535943000	15683	7980	4	0	\N
13541	1447	13834535943000	15980	8122	4	0	\N
13542	1447	13834535943000	16298	8282	4	0	\N
13543	1447	13834548943000	16227	8248	8	0	\N
13545	1447	13834560943000	16228	8247	11	0	\N
13546	1447	13867184004000	17399	8813	10	1	\N
13547	1447	13868313077300	16784	8429	67	1	\N
13549	1447	13961720683000	23822	11858	3	0	\N
13551	1447	13961732683000	23822	11858	4	0	\N
13554	1447	14554558943000	16734	8499	4	0	\N
13556	1447	14554571943000	16734	8499	5	0	\N
13558	1447	14681731683000	23823	11859	5	0	\N
13559	1447	14681731683000	23825	11859	8	0	\N
13561	1447	14681754683000	23823	11859	6	0	\N
13562	1447	14681757683000	23825	11859	9	0	\N
13564	1447	14998583943000	18384	9001	0	0	\N
13569	1447	15401767683000	23953	11918	6	0	\N
13572	1447	15401782683000	23953	11918	7	0	\N
13575	1447	15994599943000	18465	9304	2	0	\N
13577	1447	15994610943000	18465	9304	3	0	\N
13579	1447	15995610943000	19379	9657	5	0	\N
13584	1447	16713600943000	19549	9847	7	0	\N
13586	1447	16713625943000	19549	9847	8	0	\N
13588	1447	16714610943000	19170	9671	3	0	\N
13589	1447	16714622943000	19170	9671	4	0	\N
13590	1447	16841804683000	24452	12160	3	0	\N
13592	1447	16841816683000	24452	12160	4	0	\N
13594	1447	17280320000000	7005	3614	2	0	\N
13595	1447	17280320000000	7012	3616	2	0	\N
13597	1447	17280340000000	7005	3614	3	0	\N
13598	1447	17280340000000	7012	3616	3	0	\N
13472	1447	9360130000000	4655	2405	1	0	0
13473	1447	9360140000000	4655	2405	2	0	0
13476	1447	10080140000000	4675	2417	1	0	0
13477	1447	10080150000000	4675	2417	2	0	0
13485	1447	10800150000000	4950	2563	5	0	0
13492	1447	11520200000000	4988	2585	1	0	0
13493	1447	11520210000000	4988	2585	2	0	0
13507	1447	12240210000000	5390	2805	0	0	0
13525	1447	12960210000000	5685	2946	0	0	0
13532	1447	13680210000000	5897	3057	1	0	0
13552	1447	14400220000000	6038	3135	2	0	0
13553	1447	14400240000000	6038	3135	3	0	0
13565	1447	15120240000000	6388	3311	2	0	0
13566	1447	15120260000000	6388	3311	3	0	0
13574	1447	15840300000000	6786	3514	5	0	0
13582	1447	16560300000000	6788	3515	2	0	0
13583	1447	16560320000000	6788	3515	3	0	0
13596	1447	17280320000000	7076	3652	13	0	0
13599	1447	17280450000000	7076	3652	14	0	0
13470	1447	8794473944000	11630	5986	2	0	5
13474	1447	9514473944000	12024	6188	1	0	5
13475	1447	9514474944000	12024	6188	2	0	5
13481	1447	10234474944000	12324	6352	2	0	5
13484	1447	10234476944000	12324	6352	3	0	5
13497	1447	11674476944000	13184	6793	6	0	5
13500	1447	11674500944000	13184	6793	7	0	5
13501	1447	11674501943000	13211	6808	4	0	5
13515	1447	12394501943000	15298	7796	2	0	5
13526	1447	13114512943000	15441	7864	2	0	5
13527	1447	13114523943000	15441	7864	3	0	5
13539	1447	13834523943000	16398	8341	8	0	5
13544	1447	13834558943000	16398	8341	9	0	5
13555	1447	14554558943000	16857	8552	7	0	5
13567	1447	15274583943000	18350	9245	7	0	5
13568	1447	15274599943000	18350	9245	8	0	5
13576	1447	15994599943000	18752	9452	2	0	5
13578	1447	15994610943000	18752	9452	3	0	5
13585	1447	16713600943000	19550	9847	7	0	6
13600	1447	17433625943000	19839	9995	3	0	6
13489	1447	11081677683000	23166	11568	2	0	10
13491	1447	11081688683000	23166	11568	3	0	10
13504	1447	11801688683000	23249	11601	2	0	10
13523	1447	12521699683000	23335	11644	2	0	10
13524	1447	12521710683000	23335	11644	3	0	10
13529	1447	13241710683000	23518	11722	1	0	10
13530	1447	13241720683000	23518	11722	2	0	10
13548	1447	13961720683000	23821	11858	2	0	10
13560	1447	14681731683000	23881	11886	9	0	10
13563	1447	14681767683000	23881	11886	10	0	10
13570	1447	15401767683000	24183	12037	3	0	10
13571	1447	15401779683000	24183	12037	4	0	10
13580	1447	16121779683000	24250	12067	7	0	10
13591	1447	16841804683000	24576	12217	3	0	10
13593	1447	16841816683000	24576	12217	4	0	10
13602	1447	17561816683000	24856	12342	7	0	\N
13604	1447	17561841683000	24856	12342	8	0	\N
13606	1447	18000450000000	7344	3796	1	0	\N
13608	1447	18000460000000	7344	3796	2	0	\N
13612	1447	18154639943000	20716	10188	67	0	\N
13613	1447	18154639943000	20786	10358	39	0	\N
13620	1447	19001863683000	25281	12540	4	0	\N
13623	1447	19001876683000	25281	12540	5	0	\N
13628	1447	19721875683000	25469	12615	3	0	\N
13629	1447	19721875683000	26476	13095	6	0	\N
13631	1447	19721887683000	25469	12615	4	0	\N
13632	1447	19721890683000	26476	13095	7	0	\N
13635	1447	20169495009977	12263	6036	15	0	\N
13636	1447	20313686943000	20986	10556	2	0	\N
13638	1447	20313697943000	20986	10556	3	0	\N
13640	1447	20441899683000	27102	13399	6	0	\N
13643	1447	20441923683000	27102	13399	7	0	\N
13644	1447	20880490000000	8826	4577	6	0	\N
13645	1447	20880490000000	9126	4727	2	0	\N
13646	1447	20880490000000	9434	4893	2	0	\N
13647	1447	20880490000000	9493	4925	5	0	\N
13649	1447	20880510000000	9126	4727	3	0	\N
13650	1447	20880510000000	9434	4893	3	0	\N
13652	1447	20880550000000	8826	4577	7	0	\N
13653	1447	20880780000000	9493	4925	6	0	\N
13654	1447	21033697943000	21370	10724	6	0	\N
13656	1447	21033721943000	21370	10724	7	0	\N
13658	1447	21161911683000	27417	13556	3	0	\N
13659	1447	21161911683000	27543	13615	4	0	\N
13661	1447	21161923683000	27417	13556	4	0	\N
13662	1447	21161933683000	27543	13615	5	0	\N
13668	1447	21881933683000	27595	13639	9	0	\N
13669	1447	21881933683000	27679	13677	2	0	\N
13671	1447	21881944683000	27679	13677	3	0	\N
13673	1447	21882005683000	27595	13639	10	0	\N
13676	1447	22473733943000	21848	10934	9	0	\N
13677	1447	22473733943000	21926	10972	3	0	\N
13679	1447	22473745943000	21926	10972	4	0	\N
13681	1447	22473769943000	21848	10934	10	0	\N
13695	1447	24041967683000	29440	14516	14	0	\N
13697	1447	24042017683000	29440	14516	15	0	\N
13700	1447	66000050000000	9197	4570	126	1	\N
13701	1447	66721003000001	14361	7330	5	0	\N
13702	1447	96484196801992	13370	6791	9	0	\N
13705	1448	1440010000000	346	197	3	0	\N
13707	1448	1440031000000	346	197	4	0	\N
13711	1448	2160040000000	679	379	2	0	\N
13712	1448	2160040000000	702	391	3	0	\N
13715	1448	2160070000000	702	391	4	0	\N
13716	1448	2160300000000	679	379	3	0	\N
13717	1448	2196592000001	10697	5524	8	0	\N
13719	1448	2196664000001	10697	5524	9	0	\N
13723	1448	2916664000001	10759	5554	4	0	\N
13724	1448	2916664000001	11009	5668	4	0	\N
13725	1448	2916664000001	11489	5903	1	0	\N
13726	1448	2916664000001	11514	5914	2	0	\N
13727	1448	2916664000001	11745	6036	2	0	\N
13728	1448	2916664000001	11986	6170	1	0	\N
13729	1448	2916664000001	12301	6336	2	0	\N
13730	1448	2916664000001	12581	6485	1	0	\N
13732	1448	2916665000001	11986	6170	2	0	\N
13733	1448	2916666000001	11745	6036	3	0	\N
13734	1448	2916674000001	11489	5903	2	0	\N
13735	1448	2916674000001	12581	6485	2	0	\N
13736	1448	2916675000001	11514	5914	3	0	\N
13706	1448	1440010000000	355	202	3	0	0
13708	1448	1440040000000	355	202	4	0	0
13713	1448	2160040000000	773	430	1	0	0
13714	1448	2160050000000	773	430	2	0	0
13721	1448	2880050000000	902	502	3	0	0
13607	1447	18000450000000	7673	3972	1	0	0
13609	1447	18000460000000	7673	3972	2	0	0
13616	1447	18720460000000	7685	3980	2	0	0
13617	1447	18720480000000	7685	3980	3	0	0
13624	1447	19440480000000	7801	4045	1	0	0
13634	1447	20160490000000	7818	4053	0	0	0
13648	1447	20880490000000	9496	4926	2	0	0
13651	1447	20880510000000	9496	4926	3	0	0
13664	1447	21600510000000	9532	4943	5	0	0
13674	1447	22320650000000	9656	5011	3	0	0
13675	1447	22320680000000	9656	5011	4	0	0
13684	1447	23040680000000	10023	5197	12	0	0
13685	1447	23040737000000	10023	5197	13	0	0
13691	1447	23760737000000	10143	5259	6	0	0
13698	1447	24480797000000	10153	5263	2	0	0
13699	1447	24480817000000	10153	5263	3	0	0
13709	1448	1476572000001	10588	5469	2	0	8
13710	1448	1476592000001	10588	5469	3	0	8
13718	1448	2196592000001	10698	5524	8	0	8
13731	1448	2916664000001	12760	6578	5	0	8
13601	1447	17433637943000	19839	9995	4	0	6
13610	1447	18153637943000	20172	10156	2	0	6
13611	1447	18153639943000	20172	10156	3	0	6
13619	1447	18873675943000	20675	10400	10	0	6
13626	1447	19593675943000	20886	10499	2	0	6
13627	1447	19593686943000	20886	10499	3	0	6
13637	1447	20313686943000	21204	10647	2	0	6
13639	1447	20313697943000	21204	10647	3	0	6
13657	1447	21033721943000	21371	10724	7	0	6
13666	1447	21753721943000	21396	10734	3	0	6
13667	1447	21753733943000	21396	10734	4	0	6
13678	1447	22473733943000	22564	11289	3	0	6
13680	1447	22473745943000	22564	11289	4	0	6
13687	1447	23193767943000	22714	11355	5	0	6
13693	1447	23913767943000	22807	11405	6	0	6
13694	1447	23913791943000	22807	11405	7	0	6
13603	1447	17561816683000	24962	12387	8	0	10
13614	1447	18281851683000	25060	12436	3	0	10
13615	1447	18281863683000	25060	12436	4	0	10
13621	1447	19001863683000	25300	12551	3	0	10
13622	1447	19001875683000	25300	12551	4	0	10
13630	1447	19721875683000	26906	13307	6	0	10
13641	1447	20441899683000	27125	13413	3	0	10
13642	1447	20441911683000	27125	13413	4	0	10
13660	1447	21161911683000	27584	13633	4	0	10
13663	1447	21161933683000	27584	13633	5	0	10
13670	1447	21881933683000	27757	13712	2	0	10
13682	1447	22601944683000	28138	13909	3	0	10
13683	1447	22601956683000	28138	13909	4	0	10
13688	1447	23321956683000	28435	14054	2	0	10
13689	1447	23321967683000	28435	14054	3	0	10
13696	1447	24041987683000	29903	14733	12	0	10
13738	1448	2916704000001	10759	5554	5	0	\N
13739	1448	2916704000001	11009	5668	5	0	\N
13740	1448	2916765000001	12301	6336	3	0	\N
13744	1448	3636687000001	12981	6693	2	0	\N
13745	1448	3636687000001	12983	6693	1	0	\N
13746	1448	3636687000001	13391	6901	3	0	\N
13747	1448	3636687000001	13476	6941	7	0	\N
13749	1448	3636688000001	12983	6693	2	0	\N
13750	1448	3636698000001	12981	6693	3	0	\N
13751	1448	3636699000001	13391	6901	4	0	\N
13753	1448	3636703000001	13476	6941	8	0	\N
13755	1448	4356700000001	14191	7242	4	0	\N
13756	1448	4356700000001	14512	7403	6	0	\N
13757	1448	4356700000001	14514	7403	6	0	\N
13760	1448	4356713000001	14191	7242	5	0	\N
13761	1448	4356724000001	14512	7403	7	0	\N
13762	1448	4356724000001	14514	7403	7	0	\N
13763	1448	5040190000000	2088	818	0	0	\N
13766	1448	5076711000001	14750	7510	2	0	\N
13767	1448	5076711000001	14978	7632	2	0	\N
13768	1448	5076711000001	15034	7661	5	0	\N
13769	1448	5076711000001	15330	7814	3	0	\N
13770	1448	5076711000001	15354	7818	0	0	\N
13771	1448	5076711000001	15355	7824	0	0	\N
13773	1448	5076722000001	14750	7510	3	0	\N
13774	1448	5076722000001	14978	7632	3	0	\N
13775	1448	5076723000001	15330	7814	4	0	\N
13777	1448	5076734000001	15034	7661	6	0	\N
13780	1448	5796723000001	15427	7858	2	0	\N
13782	1448	5796734000001	15427	7858	3	0	\N
13786	1448	6480220000000	2966	1540	1	0	\N
13787	1448	6480220000000	2972	1545	3	0	\N
13789	1448	6480230000000	2966	1540	2	0	\N
13791	1448	6480250000000	2972	1545	4	0	\N
13793	1448	6516736000001	15639	7953	17	0	\N
13795	1448	6516798000001	15639	7953	18	0	\N
13798	1448	7200230000000	3264	1696	1	0	\N
13799	1448	7200230000000	3859	2003	1	0	\N
13800	1448	7200230000000	4016	2083	1	0	\N
13802	1448	7200240000000	3264	1696	2	0	\N
13803	1448	7200240000000	3859	2003	2	0	\N
13804	1448	7200240000000	4016	2083	2	0	\N
13806	1448	7236749000001	16319	8291	5	0	\N
13807	1448	7236749000001	16533	8409	3	0	\N
13809	1448	7236761000001	16533	8409	4	0	\N
13811	1448	7236862000001	16319	8291	6	0	\N
13813	1448	7879801000001	23740	11824	4	0	\N
13814	1448	7879814000001	23740	11824	5	0	\N
13816	1448	7879838000001	24239	11999	13	0	\N
13817	1448	7920250000000	4537	2346	1	0	\N
13818	1448	7920250000000	4788	2476	2	0	\N
13819	1448	7920250000000	4803	2486	1	0	\N
13821	1448	7920260000000	4537	2346	2	0	\N
13822	1448	7920260000000	4803	2486	2	0	\N
13824	1448	7920270000000	4788	2476	3	0	\N
13825	1448	7956761000001	17157	8627	9	0	\N
13826	1448	7956761000001	17160	8697	7	0	\N
13827	1448	7956761000001	17194	8714	4	0	\N
13828	1448	7956761000001	17223	8725	3	0	\N
13829	1448	7956761000001	17364	8796	5	0	\N
13830	1448	7956761000001	17517	8870	3	0	\N
13831	1448	7956761000001	17729	8939	11	0	\N
13833	1448	7956772000001	17729	8939	12	0	\N
13834	1448	7956773000001	17223	8725	4	0	\N
13835	1448	7956773000001	17517	8870	4	0	\N
13836	1448	7956774000001	17194	8714	5	0	\N
13838	1448	7956784000001	17364	8796	6	0	\N
13839	1448	7956833000001	17157	8627	10	0	\N
13840	1448	7956885000001	17160	8697	8	0	\N
13841	1448	8599816000001	23913	11899	7	0	\N
13842	1448	8599816000001	24053	11969	4	0	\N
13845	1448	8599838000001	24053	11969	5	0	\N
13846	1448	8599838000001	24239	11999	14	0	\N
13847	1448	8599841000001	23913	11899	8	0	\N
13848	1448	8640260000000	5386	2803	0	0	\N
13851	1448	8676774000001	17995	9079	3	0	\N
13852	1448	8676774000001	18146	9150	2	0	\N
13853	1448	8676774000001	18216	9176	4	0	\N
13854	1448	8676774000001	18362	9253	2	0	\N
13856	1448	8676785000001	18146	9150	3	0	\N
13857	1448	8676785000001	18362	9253	3	0	\N
13858	1448	8676786000001	17995	9079	4	0	\N
13860	1448	8676787000001	18216	9176	5	0	\N
13861	1448	8676833000001	17193	8628	1	0	\N
13862	1448	8676834000001	17193	8628	2	0	\N
13863	1448	9319828000001	24260	12071	4	0	\N
13864	1448	9319828000001	24648	12244	4	0	\N
13867	1448	9319841000001	24260	12071	5	0	\N
13868	1448	9319841000001	24648	12244	5	0	\N
13869	1448	9319850000001	25744	12735	1	0	\N
13870	1448	9360261000000	5460	2842	0	0	\N
13743	1448	3600190000000	1348	740	1	0	0
13754	1448	4320190000000	1348	740	2	0	0
13764	1448	5040190000000	2226	1173	1	0	0
13765	1448	5040200000000	2226	1173	2	0	0
13778	1448	5760200000000	2731	1434	2	0	0
13788	1448	6480220000000	3184	1653	1	0	0
13790	1448	6480230000000	3184	1653	2	0	0
13801	1448	7200230000000	4225	2195	2	0	0
13805	1448	7200250000000	4225	2195	3	0	0
13820	1448	7920250000000	4815	2494	1	0	0
13849	1448	8640260000000	5410	2815	1	0	0
13850	1448	8640261000000	5410	2815	2	0	0
13871	1448	9360261000000	5607	2913	0	0	0
13737	1448	2916687000001	12760	6578	6	0	8
13752	1448	3636700000001	13518	6960	5	0	8
13758	1448	4356700000001	14706	7488	2	0	8
13759	1448	4356711000001	14706	7488	3	0	8
13772	1448	5076711000001	15356	7825	3	0	8
13776	1448	5076723000001	15356	7825	4	0	8
13783	1448	5796736000001	15622	7952	5	0	8
13792	1448	6516736000001	15635	7958	4	0	8
13794	1448	6516749000001	15635	7958	5	0	8
13808	1448	7236749000001	16830	8542	3	0	8
13810	1448	7236761000001	16830	8542	4	0	8
13837	1448	7956774000001	17730	8961	5	0	8
13855	1448	8676774000001	18413	9283	3	0	8
13859	1448	8676786000001	18413	9283	4	0	8
13872	1448	9396786000001	18961	9564	3	0	8
13785	1448	6439788000001	23611	11762	4	0	16
13796	1448	7159788000001	23678	11791	4	0	16
13797	1448	7159801000001	23678	11791	5	0	16
13812	1448	7879801000001	23737	11824	6	0	16
13815	1448	7879816000001	23737	11824	7	0	16
13844	1448	8599828000001	24242	12063	4	0	16
13865	1448	9319828000001	25376	12582	3	0	16
13866	1448	9319840000001	25376	12582	4	0	16
13874	1448	9396834000001	17221	8629	0	0	\N
13875	1448	9397608000001	19702	9886	81	0	\N
13876	1448	10039840000001	25494	12625	6	0	\N
13877	1448	10039840000001	25674	12706	3	0	\N
13879	1448	10039850000001	25744	12735	4	0	\N
13880	1448	10039852000001	25674	12706	4	0	\N
13881	1448	10039852000001	25744	12735	5	0	\N
13883	1448	10039864000001	25494	12625	7	0	\N
13884	1448	10080261000000	5707	2960	0	0	\N
13885	1448	10080261000000	5912	3065	0	0	\N
13890	1448	10117608000001	19702	9886	126	0	\N
13891	1448	10118048000001	19702	9886	127	0	\N
13892	1448	10281810000001	20291	10216	7	0	\N
13893	1448	10281835000001	20291	10216	8	0	\N
13898	1448	10836810000001	20041	10088	3	0	\N
13899	1448	10836810000001	20289	10216	7	0	\N
13900	1448	10836810000001	20660	10394	3	0	\N
13901	1448	10836810000001	20725	10420	10	0	\N
13902	1448	10836810000001	20726	10420	10	0	\N
13903	1448	10836810000001	20901	10506	2	0	\N
13905	1448	10836821000001	20901	10506	3	0	\N
13907	1448	10836822000001	20041	10088	4	0	\N
13908	1448	10836822000001	20660	10394	4	0	\N
13909	1448	10836835000001	20289	10216	8	0	\N
13910	1448	10836847000001	20725	10420	11	0	\N
13911	1448	10836847000001	20726	10420	11	0	\N
13912	1448	11479865000001	26910	13308	3	0	\N
13913	1448	11479865000001	26933	13321	6	0	\N
13915	1448	11479877000001	26910	13308	4	0	\N
13917	1448	11479889000001	26933	13321	7	0	\N
13918	1448	11520301000000	6167	3194	1	0	\N
13919	1448	11520301000000	6389	3311	2	0	\N
13920	1448	11520301000000	6480	3359	2	0	\N
13921	1448	11520301000000	6555	3397	2	0	\N
13923	1448	11520311000000	6167	3194	2	0	\N
13924	1448	11520321000000	6389	3311	3	0	\N
13925	1448	11520321000000	6480	3359	3	0	\N
13926	1448	11520321000000	6555	3397	3	0	\N
13928	1448	11556821000001	21066	10585	2	0	\N
13929	1448	11556821000001	21068	10585	3	0	\N
13931	1448	11556832000001	21066	10585	3	0	\N
13932	1448	11556833000001	21068	10585	4	0	\N
13938	1448	12276833000001	21841	10931	3	0	\N
13939	1448	12276833000001	21938	10975	3	0	\N
13940	1448	12276833000001	22018	11009	4	0	\N
13941	1448	12276833000001	22397	11214	6	0	\N
13942	1448	12276833000001	22711	11354	6	0	\N
13944	1448	12276845000001	21841	10931	4	0	\N
13945	1448	12276845000001	21938	10975	4	0	\N
13946	1448	12276846000001	22018	11009	5	0	\N
13948	1448	12276857000001	22397	11214	7	0	\N
13949	1448	12276857000001	22711	11354	7	0	\N
13950	1448	12919889000001	27413	13555	3	0	\N
13951	1448	12919889000001	27421	13557	9	0	\N
13953	1448	12919901000001	27413	13555	4	0	\N
13955	1448	12919925000001	27421	13557	10	0	\N
13956	1448	12960391000000	7094	3663	1	0	\N
13958	1448	12960401000000	7094	3663	2	0	\N
13960	1448	12996846000001	23515	11721	4	0	\N
13961	1448	12996859000001	23515	11721	5	0	\N
13962	1448	13639913000001	27591	13637	6	0	\N
13963	1448	13639913000001	28089	13886	4	0	\N
13964	1448	13639913000001	28457	14063	2	0	\N
13965	1448	13639913000001	28962	14283	3	0	\N
13967	1448	13639924000001	28457	14063	3	0	\N
13968	1448	13639925000001	28962	14283	4	0	\N
13969	1448	13639926000001	28089	13886	5	0	\N
13970	1448	13639928000001	27591	13637	7	0	\N
13974	1448	14359937000001	29111	14351	4	0	\N
13975	1448	14359937000001	29355	14468	4	0	\N
13976	1448	14359937000001	29577	14584	2	0	\N
13978	1448	14359948000001	29577	14584	3	0	\N
13979	1448	14359950000001	29111	14351	5	0	\N
13980	1448	14359950000001	29355	14468	5	0	\N
13982	1448	14400621000000	7823	4056	1	0	\N
13984	1448	14400631000000	7823	4056	2	0	\N
13988	1448	15840652000000	8454	4380	1	0	\N
13989	1448	15840652000000	9101	4717	2	0	\N
13990	1448	15840652000000	10086	5233	22	0	\N
13991	1448	15840662000000	8454	4380	2	0	\N
13992	1448	15840672000000	9101	4717	3	0	\N
13993	1448	15840863000000	10086	5233	23	0	\N
13995	1449	264005058	1868	935	81	0	\N
13996	1449	264005058	2252	973	0	0	\N
13997	1449	287999962	14021	7185	12	0	\N
13998	1449	287999962	14022	7185	12	0	\N
14001	1449	8053016461	29159	14093	47	1	\N
14002	1449	8055416459	27225	13463	5	0	\N
14003	1449	8063016459	30223	14735	104	0	\N
13886	1448	10080261000000	5930	3071	2	0	0
13887	1448	10080281000000	5930	3071	3	0	0
13896	1448	10800281000000	5971	3097	2	0	0
13897	1448	10800301000000	5971	3097	3	0	0
13922	1448	11520301000000	6585	3407	5	0	0
13936	1448	12240351000000	6945	3584	4	0	0
13937	1448	12240391000000	6945	3584	5	0	0
13957	1448	12960391000000	7095	3663	2	0	0
13959	1448	12960411000000	7095	3663	3	0	0
13972	1448	13680411000000	7789	4039	3	0	0
13983	1448	14400621000000	7903	4094	2	0	0
13985	1448	14400632000000	7903	4094	3	0	0
13986	1448	15120632000000	8260	4277	2	0	0
13987	1448	15120652000000	8260	4277	3	0	0
14006	1449	723043000459	10560	5453	2	0	4
14007	1449	723063000459	10560	5453	3	0	4
13999	1449	8053010459	10988	5662	5	1	5
14000	1449	8053016459	10992	5663	5	1	5
13873	1448	9396798000001	18961	9564	4	0	8
13889	1448	10116810000001	19703	9920	4	0	8
13904	1448	10836810000001	20926	10521	2	0	8
13906	1448	10836821000001	20926	10521	3	0	8
13930	1448	11556821000001	21104	10600	3	0	8
13933	1448	11556833000001	21104	10600	4	0	8
13947	1448	12276846000001	22861	11429	5	0	8
13878	1448	10039840000001	26471	13093	3	0	16
13882	1448	10039852000001	26471	13093	4	0	16
13894	1448	10759852000001	26637	13178	4	0	16
13914	1448	11479865000001	27369	13533	3	0	16
13916	1448	11479877000001	27369	13533	4	0	16
13934	1448	12199877000001	27407	13553	3	0	16
13935	1448	12199889000001	27407	13553	4	0	16
13952	1448	12919889000001	27448	13566	6	0	16
13966	1448	13639913000001	29046	14325	6	0	16
13971	1448	13639937000001	29046	14325	7	0	16
13977	1448	14359937000001	30075	14808	19	0	16
13981	1448	14359974000001	30075	14808	20	0	16
14010	1449	14860960668970	27283	13433	11	1	\N
14011	1449	76492684937283	11057	5687	5	0	\N
14012	1450	10000000	15700	7985	4	0	\N
14013	1450	30000000	2254	1184	4	0	\N
14014	1450	200100000	4874	2326	114	1	\N
14015	1450	2160040000000	2255	1184	4	1	\N
14016	1450	23047923099999	10618	5297	37	1	\N
14021	1451	2058697000000	12398	6396	2	0	\N
14023	1451	2058699000000	12398	6396	3	0	\N
14025	1451	2160120000000	1285	709	1	0	\N
14027	1451	2160130000000	1285	709	2	0	\N
14037	1451	3600140000000	2183	1151	1	0	\N
14038	1451	3600140000000	2439	1276	1	0	\N
14039	1451	3600140000000	2626	1381	1	0	\N
14041	1451	3600150000000	2183	1151	2	0	\N
14042	1451	3600150000000	2439	1276	2	0	\N
14043	1451	3600150000000	2626	1381	2	0	\N
14045	1451	4027759000000	24822	12326	3	0	\N
14046	1451	4027759000000	25039	12422	2	0	\N
14048	1451	4027770000000	25039	12422	3	0	\N
14049	1451	4027771000000	24822	12326	4	0	\N
14051	1451	4218781000000	13257	6829	2	0	\N
14053	1451	4218801000000	13257	6829	3	0	\N
14055	1451	4219637000000	14140	7110	83	0	\N
14056	1451	4320150000000	3381	1759	1	0	\N
14058	1451	4320160000000	3381	1759	2	0	\N
14061	1451	4747771000000	25789	12754	4	0	\N
14062	1451	4747771000000	25791	12754	2	0	\N
14063	1451	4747773000000	25791	12754	3	0	\N
14065	1451	4747784000000	25789	12754	5	0	\N
14067	1451	4938803000000	14155	7199	0	0	\N
14068	1451	4938803000000	14156	7209	0	0	\N
14069	1451	4938803000000	14158	7219	0	0	\N
14071	1451	4939637000000	14140	7110	126	0	\N
14072	1451	4940057000000	14140	7110	127	0	\N
14073	1451	5040170000000	4079	2120	2	0	\N
14074	1451	5040170000000	4230	2197	1	0	\N
14075	1451	5040170000000	4775	2467	2	0	\N
14076	1451	5040170000000	4776	2466	3	0	\N
14077	1451	5040170000000	4925	2548	1	0	\N
14078	1451	5040170000000	5057	2620	0	0	\N
14079	1451	5040170000000	5058	2625	1	0	\N
14081	1451	5040180000000	4230	2197	2	0	\N
14082	1451	5040180000000	4925	2548	2	0	\N
14083	1451	5040180000000	5058	2625	2	0	\N
14084	1451	5040190000000	4079	2120	3	0	\N
14085	1451	5040190000000	4775	2467	3	0	\N
14086	1451	5040200000000	4776	2466	4	0	\N
14088	1451	5467783000000	26521	13121	2	0	\N
14089	1451	5467783000000	27470	13568	0	0	\N
14092	1451	5467794000000	26521	13121	3	0	\N
14093	1451	5472155151752	22592	11271	18	0	\N
14096	1451	5760210000000	5229	2719	2	0	\N
14098	1451	5760230000000	5229	2719	3	0	\N
14099	1451	6378839000000	14672	7476	3	0	\N
14100	1451	6378839000000	14676	7476	24	0	\N
14103	1451	6378869000000	14672	7476	4	0	\N
14104	1451	6379052000000	14676	7476	25	0	\N
14105	1451	6480210000000	5691	2950	0	0	\N
14113	1451	7200220000000	5933	3055	28	0	\N
14115	1451	7200500000000	5933	3055	29	0	\N
14122	1451	8347812000000	28051	13872	1	0	\N
14123	1451	8347812000000	28053	13872	2	0	\N
14124	1451	8347812000000	28054	13872	3	0	\N
14126	1451	8347822000000	28051	13872	2	0	\N
14127	1451	8347823000000	28053	13872	3	0	\N
14128	1451	8347824000000	28054	13872	4	0	\N
14132	1451	8640240000000	6223	3221	1	0	\N
14134	1451	8640240000000	6332	3278	1	0	\N
14135	1451	8640240000000	6333	3278	1	0	\N
14136	1451	8640250000000	6223	3221	2	0	\N
14138	1451	8640250000000	6332	3278	2	0	\N
14139	1451	8640250000000	6333	3278	2	0	\N
14140	1451	8640270000000	6569	3402	2	0	\N
14141	1451	8640270000000	6570	3402	2	0	\N
14143	1451	9067824000000	28324	14004	2	0	\N
14144	1451	9067824000000	28325	14004	2	0	\N
14019	1451	1440010000000	865	479	2	0	0
14020	1451	1440120000000	865	479	3	0	0
14026	1451	2160120000000	1694	911	1	0	0
14028	1451	2160130000000	1694	911	2	0	0
14031	1451	2880130000000	2039	1076	1	0	0
14040	1451	3600140000000	3153	1639	1	0	0
14044	1451	3600150000000	3153	1639	2	0	0
14057	1451	4320150000000	3850	1999	2	0	0
14059	1451	4320170000000	3850	1999	3	0	0
14080	1451	5040170000000	5075	2633	4	0	0
14097	1451	5760210000000	5469	2849	0	0	0
14106	1451	6480210000000	5831	3026	1	0	0
14107	1451	6480220000000	5831	3026	2	0	0
14112	1451	7200220000000	5932	3073	1	0	0
14120	1451	7920230000000	6069	3153	1	0	0
14121	1451	7920240000000	6069	3153	2	0	0
14133	1451	8640240000000	6331	3278	1	0	0
14137	1451	8640250000000	6331	3278	2	0	0
14142	1451	8640270000000	6571	3402	2	0	0
14022	1451	2058697000000	12764	6582	6	0	9
14024	1451	2058730000000	12764	6582	7	0	9
14029	1451	2778730000000	12815	6608	2	0	9
14030	1451	2778750000000	12815	6608	3	0	9
14035	1451	3498750000000	12840	6622	4	0	9
14052	1451	4218781000000	13258	6829	4	0	9
14054	1451	4218803000000	13258	6829	5	0	9
14066	1451	4938803000000	14139	7222	6	0	9
14070	1451	4938827000000	14139	7222	7	0	9
14095	1451	5658839000000	14154	7226	4	0	9
14101	1451	6378839000000	14698	7485	2	0	9
14102	1451	6378850000000	14698	7485	3	0	9
14110	1451	7098850000000	15245	7766	5	0	9
14111	1451	7098873000000	15245	7766	6	0	9
14119	1451	7818884000000	15295	7795	3	0	9
14130	1451	8538884000000	15540	7910	3	0	9
14131	1451	8538896000000	15540	7910	4	0	9
14033	1451	3307737000000	24457	12163	4	0	13
14034	1451	3307759000000	24457	12163	5	0	13
14050	1451	4027771000000	25689	12711	4	0	13
14060	1451	4747771000000	25788	12754	3	0	13
14064	1451	4747783000000	25788	12754	4	0	13
14090	1451	5467783000000	27473	13577	7	0	13
14108	1451	6907790000000	27551	13619	2	0	13
14109	1451	6907801000000	27551	13619	3	0	13
14116	1451	7627801000000	27721	13696	2	0	13
14117	1451	7627812000000	27721	13696	3	0	13
14125	1451	8347812000000	28304	13992	3	0	13
14146	1451	9067824000000	28720	14174	4	0	\N
14147	1451	9067835000000	28324	14004	3	0	\N
14148	1451	9067835000000	28325	14004	3	0	\N
14150	1451	9067837000000	28720	14174	5	0	\N
14153	1451	9360250000000	6510	3375	2	0	\N
14154	1451	9360270000000	6510	3375	3	0	\N
14155	1451	9360270000000	6569	3402	3	0	\N
14156	1451	9360270000000	6570	3402	3	0	\N
14162	1451	10080270000000	6684	3455	4	0	\N
14163	1451	10080270000000	7197	3721	2	0	\N
14164	1451	10080270000000	7198	3720	4	0	\N
14165	1451	10080270000000	7306	3775	2	0	\N
14166	1451	10080270000000	7366	3805	7	0	\N
14167	1451	10080270000000	7746	4015	3	0	\N
14170	1451	10080290000000	7197	3721	3	0	\N
14171	1451	10080290000000	7306	3775	3	0	\N
14172	1451	10080300000000	7746	4015	4	0	\N
14173	1451	10080310000000	6684	3455	5	0	\N
14174	1451	10080310000000	7198	3720	5	0	\N
14175	1451	10080340000000	7366	3805	8	0	\N
14176	1451	10507848000000	29366	14473	3	0	\N
14178	1451	10507860000000	29366	14473	4	0	\N
14180	1451	10698944000000	16008	8141	16	0	\N
14183	1451	10699005000000	16008	8141	17	0	\N
14186	1451	11227885000000	29908	14736	1	0	\N
14187	1451	11227885000000	29909	14736	4	0	\N
14189	1451	11227886000000	29908	14736	2	0	\N
14190	1451	11227889000000	29909	14736	5	0	\N
14192	1451	11418957000000	16543	8410	0	0	\N
14193	1451	11418957000000	16545	8410	14	0	\N
14194	1451	11418957000000	16548	8313	0	0	\N
14197	1451	11418988000000	17230	8730	2	0	\N
14198	1451	11418988000000	17232	8730	2	0	\N
14199	1451	11418988000000	17233	8730	2	0	\N
14200	1451	11419016000000	16545	8410	15	0	\N
14201	1451	11520320000000	8743	4537	2	0	\N
14203	1451	11520340000000	8743	4537	3	0	\N
14205	1451	11947903000000	30307	14897	2	0	\N
14206	1451	11947914000000	30307	14897	3	0	\N
14209	1451	12138988000000	17230	8730	8	0	\N
14210	1451	12138988000000	17232	8730	8	0	\N
14211	1451	12138988000000	17233	8730	8	0	\N
14212	1451	12138993000000	17230	8730	9	0	\N
14213	1451	12138993000000	17232	8730	9	0	\N
14214	1451	12138993000000	17233	8730	9	0	\N
14217	1451	12858980000000	17753	8969	3	0	\N
14219	1451	12858992000000	17753	8969	4	0	\N
14223	1451	13578992000000	18017	9089	3	0	\N
14225	1451	13579004000000	18017	9089	4	0	\N
14227	1451	13680421000000	9340	4846	2	0	\N
14228	1451	13680421000000	9451	4902	5	0	\N
14229	1451	13680421000000	9531	4943	5	0	\N
14230	1451	13680421000000	9611	4987	2	0	\N
14231	1451	13680421000000	9662	5015	3	0	\N
14233	1451	13680441000000	9340	4846	3	0	\N
14234	1451	13680441000000	9611	4987	3	0	\N
14235	1451	13680451000000	9662	5015	4	0	\N
14237	1451	13680462000000	9451	4902	6	0	\N
14238	1451	13680561000000	9531	4943	6	0	\N
14243	1451	14400503000000	10582	5466	2	0	\N
14246	1451	15019984000000	19568	9790	86	0	\N
14248	1451	15120483000000	10892	5616	5	0	\N
14249	1451	15120503000000	10582	5466	3	0	\N
14251	1451	15120533000000	10892	5616	6	0	\N
14252	1451	15739034000000	19340	9752	10	0	\N
14254	1451	15739034000000	19570	9857	1	0	\N
14255	1451	15739035000000	19570	9857	2	0	\N
14257	1451	15739062000000	19340	9752	11	0	\N
14258	1451	15739984000000	19568	9790	126	0	\N
14259	1451	15740077000000	19568	9790	127	0	\N
14262	1451	16459046000000	20484	10315	5	0	\N
14263	1451	16459046000000	20486	10313	30	0	\N
14264	1451	16459046000000	20569	10351	8	0	\N
14267	1451	16459068000000	20889	10500	2	0	\N
14268	1451	16459069000000	20484	10315	6	0	\N
14269	1451	16459081000000	20569	10351	9	0	\N
14270	1451	16459224000000	20486	10313	31	0	\N
14271	1451	16460001000000	20573	10314	89	0	\N
14273	1451	16560553000000	11050	5685	2	0	\N
14274	1451	16560553000000	11051	5684	2	0	\N
14276	1451	16560573000000	11050	5685	3	0	\N
14277	1451	16560573000000	11051	5684	3	0	\N
14278	1451	17179057000000	21031	10571	3	0	\N
14280	1451	17179057000000	21033	10570	4	0	\N
14169	1451	10080280000000	7764	4025	2	0	0
14184	1451	10800280000000	8723	4523	4	0	0
14185	1451	10800320000000	8723	4523	5	0	0
14202	1451	11520320000000	9100	4716	2	0	0
14204	1451	11520340000000	9100	4716	3	0	0
14216	1451	12240381000000	9195	4766	6	0	0
14221	1451	12960381000000	9212	4778	4	0	0
14222	1451	12960421000000	9212	4778	5	0	0
14232	1451	13680421000000	9713	5037	4	0	0
14236	1451	13680461000000	9713	5037	5	0	0
14242	1451	14400483000000	10530	5437	5	0	0
14247	1451	15120483000000	10891	5616	5	0	0
14250	1451	15120533000000	10891	5616	6	0	0
14260	1451	15840533000000	10941	5640	2	0	0
14272	1451	16560553000000	11049	5685	2	0	0
14275	1451	16560573000000	11049	5685	3	0	0
14151	1451	9258896000000	15720	7993	3	0	9
14152	1451	9258908000000	15720	7993	4	0	9
14160	1451	9978908000000	16000	8136	9	0	9
14181	1451	10698944000000	16116	8193	4	0	9
14182	1451	10698957000000	16116	8193	5	0	9
14195	1451	11418957000000	16935	8584	2	0	9
14196	1451	11418968000000	16935	8584	3	0	9
14207	1451	12138968000000	17642	8919	3	0	9
14218	1451	12858980000000	17765	8974	3	0	9
14220	1451	12858992000000	17765	8974	4	0	9
14224	1451	13578992000000	18395	9271	3	0	9
14226	1451	13579004000000	18395	9271	4	0	9
14240	1451	14299024000000	18918	9543	3	0	9
14244	1451	15019024000000	19040	9603	1	0	9
14245	1451	15019034000000	19040	9603	2	0	9
14253	1451	15739034000000	19569	9857	3	0	9
14256	1451	15739046000000	19569	9857	4	0	9
14266	1451	16459057000000	20798	10454	3	0	9
14279	1451	17179057000000	21032	10571	3	0	9
14145	1451	9067824000000	28719	14174	3	0	13
14149	1451	9067836000000	28719	14174	4	0	13
14158	1451	9787836000000	28748	14183	3	0	13
14177	1451	10507848000000	29853	14713	19	0	13
14179	1451	10507885000000	29853	14713	20	0	13
14188	1451	11227885000000	29910	14736	9	0	13
14191	1451	11227903000000	29910	14736	10	0	13
14281	1451	17179068000000	20889	10500	3	0	\N
14282	1451	17179069000000	21031	10571	4	0	\N
14284	1451	17179079000000	21033	10570	5	0	\N
14285	1451	17180001000000	20573	10314	99	0	\N
14286	1451	17180010000000	20573	10314	100	0	\N
14289	1451	17899069000000	21092	10579	6	0	\N
14290	1451	17899069000000	21095	10596	4	0	\N
14291	1451	17899069000000	21276	10599	0	0	\N
14292	1451	17899069000000	21278	10684	4	0	\N
14293	1451	17899069000000	21279	10603	0	0	\N
14294	1451	17899069000000	21280	10678	56	0	\N
14295	1451	17899069000000	21281	10604	0	0	\N
14297	1451	17899082000000	21278	10684	5	0	\N
14298	1451	17899091000000	21095	10596	5	0	\N
14300	1451	17899219000000	21092	10579	7	0	\N
14301	1451	17899269000000	21280	10678	57	0	\N
14302	1451	18000583000000	11170	5741	4	0	\N
14303	1451	18000583000000	11171	5741	4	0	\N
14304	1451	18000583000000	11175	5741	4	0	\N
14307	1451	18000623000000	11170	5741	5	0	\N
14308	1451	18000623000000	11171	5741	5	0	\N
14309	1451	18000623000000	11175	5741	5	0	\N
14310	1451	18619102000000	21552	10807	2	0	\N
14312	1451	18619104000000	21552	10807	3	0	\N
14314	1451	18619317000000	22592	11271	14	0	\N
14317	1451	19339114000000	21604	10828	3	0	\N
14318	1451	19339114000000	22594	11304	4	0	\N
14321	1451	19339126000000	21604	10828	4	0	\N
14322	1451	19339136000000	22594	11304	5	0	\N
14323	1451	19339317000000	22592	11271	17	0	\N
14324	1451	19440595000000	11642	5987	0	0	\N
14325	1451	19440595000000	11644	5992	1	0	\N
14327	1451	19440596000000	11644	5992	2	0	\N
14333	1451	20779137000000	23781	11842	2	0	\N
14334	1451	20779137000000	23782	11842	6	0	\N
14335	1451	20779137000000	23834	11863	4	0	\N
14336	1451	20779137000000	23835	11863	6	0	\N
14337	1451	20779139000000	23781	11842	3	0	\N
14338	1451	20779150000000	23834	11863	5	0	\N
14339	1451	20779152000000	23835	11863	7	0	\N
14340	1451	20779161000000	23782	11842	7	0	\N
14341	1455	10000008	6768	3504	5	1	\N
14342	1455	720000000000	280	162	0	0	\N
14343	1455	720000000000	363	207	1	0	\N
14345	1455	720010000000	363	207	2	0	\N
14347	1455	751517000000	20575	10353	4	0	\N
14350	1455	751629000000	20575	10353	5	0	\N
14351	1455	753831000000	10663	5507	2	0	\N
14352	1455	753831000000	10755	5551	0	0	\N
14354	1455	753851000000	10663	5507	3	0	\N
14361	1455	1473851000000	11077	5699	3	0	\N
14363	1455	1473881000000	11077	5699	4	0	\N
14367	1455	2191539000000	22358	11190	3	0	\N
14368	1455	2191551000000	22358	11190	4	0	\N
14371	1455	2192723000000	23733	11753	80	0	\N
14372	1455	2193911000000	11246	5778	4	0	\N
14375	1455	2193933000000	11246	5778	5	0	\N
14376	1455	2880040000000	1459	795	4	0	\N
14377	1455	2880040000000	2288	1200	1	0	\N
14378	1455	2880040000000	2665	1400	1	0	\N
14380	1455	2880050000000	2288	1200	2	0	\N
14381	1455	2880050000000	2665	1400	2	0	\N
14383	1455	2880080000000	1459	795	5	0	\N
14384	1455	2911563000000	23252	11601	2	0	\N
14386	1455	2911574000000	23252	11601	3	0	\N
14388	1455	2912723000000	23733	11753	126	0	\N
14389	1455	2913067000000	23733	11753	127	0	\N
14390	1455	2913282000000	23759	11754	80	0	\N
14391	1455	2913915000000	12102	6232	2	0	\N
14394	1455	2913917000000	12102	6232	3	0	\N
14397	1455	3631575000000	24793	12310	4	0	\N
14399	1455	3631579000000	24793	12310	5	0	\N
14401	1455	3633282000000	23759	11754	126	0	\N
14402	1455	3633327000000	23759	11754	127	0	\N
14403	1455	3633916000000	12462	6421	0	0	\N
14404	1455	3633916000000	12513	6449	2	0	\N
14405	1455	3633916000000	12516	6451	2	0	\N
14406	1455	3633916000000	12541	6463	4	0	\N
14408	1455	3633927000000	12513	6449	3	0	\N
14409	1455	3633927000000	12516	6451	3	0	\N
14411	1455	3633938000000	12541	6463	5	0	\N
14412	1455	3634047000000	13034	6643	3	0	\N
14413	1455	3634367000000	23916	11755	80	0	\N
14416	1455	4351588000000	25327	12563	4	0	\N
14356	1455	1440010000000	1221	673	2	0	0
14357	1455	1440030000000	1221	673	3	0	0
14365	1455	2160030000000	1401	767	1	0	0
14366	1455	2160040000000	1401	767	2	0	0
14379	1455	2880040000000	2856	1496	3	0	0
14395	1455	3600061000000	3016	1566	1	0	0
14396	1455	3600071000000	3016	1566	2	0	0
14414	1455	4320071000000	3132	1629	1	0	0
14415	1455	4320081000000	3132	1629	2	0	0
14353	1455	753831000000	11059	5689	2	0	5
14287	1451	17280573000000	11089	5706	1	0	0
14288	1451	17280583000000	11089	5706	2	0	0
14362	1455	1473851000000	11163	5737	6	0	5
14364	1455	1473911000000	11163	5737	7	0	5
14306	1451	18000594000000	11304	5805	3	0	0
14315	1451	18720594000000	11557	5939	1	0	0
14316	1451	18720595000000	11557	5939	2	0	0
14373	1455	2193911000000	11884	6106	4	0	5
14374	1455	2193915000000	11884	6106	5	0	5
14328	1451	19440596000000	12097	6229	2	0	0
14331	1451	20160596000000	12136	6250	1	0	0
14332	1451	20160597000000	12136	6250	2	0	0
14392	1455	2913915000000	12380	6384	1	0	5
14393	1455	2913916000000	12380	6384	2	0	5
14410	1455	3633927000000	12700	6550	3	0	5
14283	1451	17179069000000	21032	10571	4	0	9
14348	1455	751517000000	21110	10602	1	0	10
14349	1455	751527000000	21110	10602	2	0	10
14299	1451	17899102000000	21440	10754	7	0	9
14311	1451	18619102000000	21575	10817	3	0	9
14313	1451	18619114000000	21575	10817	4	0	9
14358	1455	1471527000000	22176	11095	3	0	10
14359	1455	1471539000000	22176	11095	4	0	10
14320	1451	19339125000000	22767	11384	3	0	9
14360	1455	1471559000000	22884	11440	2	0	10
14369	1455	2191559000000	22884	11440	7	0	10
14370	1455	2191563000000	22884	11440	8	0	10
14329	1451	20059125000000	23080	11523	3	0	9
14385	1455	2911563000000	24754	12293	3	0	10
14387	1455	2911575000000	24754	12293	4	0	10
14398	1455	3631575000000	25286	12543	4	0	10
14400	1455	3631588000000	25286	12543	5	0	10
14417	1455	4351588000000	25380	12582	3	0	\N
14420	1455	4351600000000	25380	12582	4	0	\N
14421	1455	4351700000000	25327	12563	5	0	\N
14422	1455	4353927000000	13894	7129	14	0	\N
14423	1455	4353927000000	14444	7289	10	0	\N
14426	1455	4353946000000	14444	7289	11	0	\N
14427	1455	4353959000000	13894	7129	15	0	\N
14428	1455	4354047000000	13034	6643	4	0	\N
14429	1455	4354367000000	23916	11755	98	0	\N
14430	1455	4354396000000	14712	7290	36	0	\N
14431	1455	4574047000000	13106	6645	0	0	\N
14432	1455	4940555124162	23916	11755	100	0	\N
14433	1455	5040081000000	3675	1908	1	0	\N
14435	1455	5040091000000	3675	1908	2	0	\N
14437	1455	5071599000000	25905	12803	2	0	\N
14439	1455	5071610000000	25905	12803	3	0	\N
14444	1455	5074146000000	14712	7290	37	0	\N
14451	1455	5794046000000	14734	7291	0	0	\N
14452	1455	6480111000000	4529	2343	1	0	\N
14454	1455	6480121000000	4529	2343	2	0	\N
14456	1455	6511624000000	27594	13638	3	0	\N
14459	1455	6511636000000	27594	13638	4	0	\N
14460	1455	6513946000000	14794	7292	0	0	\N
14461	1455	6513964000000	15099	7694	2	0	\N
14462	1455	6513964000000	15167	7731	4	0	\N
14464	1455	6513975000000	15099	7694	3	0	\N
14465	1455	6513977000000	15167	7731	5	0	\N
14476	1455	7951647000000	28080	13882	19	0	\N
14477	1455	7951647000000	28532	14098	2	0	\N
14479	1455	7951658000000	28532	14098	3	0	\N
14481	1455	7951738000000	28080	13882	20	0	\N
14482	1455	7951840000000	28901	14245	29	0	\N
14483	1455	7954024000000	15757	8013	3	0	\N
14484	1455	7954024000000	16235	8210	14	0	\N
14485	1455	7954024000000	17156	8696	10	0	\N
14486	1455	7954024000000	17171	8704	3	0	\N
14487	1455	7954024000000	17295	8760	9	0	\N
14489	1455	7954036000000	15757	8013	4	0	\N
14490	1455	7954036000000	17171	8704	4	0	\N
14492	1455	7954060000000	17295	8760	10	0	\N
14493	1455	7954061000000	17156	8696	11	0	\N
14494	1455	7954088000000	16235	8210	15	0	\N
14496	1455	8671658000000	30296	14893	7	0	\N
14497	1455	8671674000000	30296	14893	8	0	\N
14498	1455	8671840000000	28901	14245	52	0	\N
14499	1455	8671862000000	28901	14245	53	0	\N
14500	1455	8673132000000	29128	14246	103	0	\N
14503	1455	8674088000000	16576	8211	28	0	\N
14504	1455	8674994000000	16576	8211	29	0	\N
14506	1455	9393132000000	29128	14246	126	0	\N
14507	1455	9393352000000	29128	14246	127	0	\N
14508	1455	9393845000000	29162	14247	103	0	\N
14509	1455	9394061000000	18096	9125	2	0	\N
14510	1455	9394061000000	18778	9463	3	0	\N
14513	1455	9394072000000	18096	9125	3	0	\N
14514	1455	9394073000000	18778	9463	4	0	\N
14515	1455	9394994000000	16595	8212	4	0	\N
14516	1455	9395074000000	16595	8212	5	0	\N
14518	1455	10113845000000	29162	14247	126	0	\N
14519	1455	10113867000000	29162	14247	127	0	\N
14523	1455	10833867000000	29271	14248	20	0	\N
14524	1455	10834067000000	29271	14248	21	0	\N
14527	1455	11520141000000	6070	3153	1	0	\N
14528	1455	11520141000000	6321	3272	1	0	\N
14530	1455	11520151000000	6070	3153	2	0	\N
14531	1455	11520151000000	6321	3272	2	0	\N
14533	1455	11554105000000	19318	9741	8	0	\N
14534	1455	11554105000000	19388	9773	5	0	\N
14537	1455	11554128000000	19388	9773	6	0	\N
14538	1455	11554167000000	19318	9741	9	0	\N
14543	1455	13680210999999	6768	3504	4	0	\N
14550	1455	15840271000000	7454	3856	1	0	\N
14552	1455	15840281000000	7454	3856	2	0	\N
14445	1455	5760091000000	4435	2299	2	0	0
14446	1455	5760111000000	4435	2299	3	0	0
14453	1455	6480111000000	4750	2455	1	0	0
14455	1455	6480121000000	4750	2455	2	0	0
14468	1455	7200121000000	5024	2609	1	0	0
14474	1455	7920131000000	5332	2767	1	0	0
14475	1455	7920141000000	5332	2767	2	0	0
14495	1455	8640141000000	5433	2827	0	0	0
14505	1455	9360141000000	5576	2900	0	0	0
14517	1455	10080141000000	5648	2931	0	0	0
14529	1455	11520141000000	6513	3376	2	0	0
14532	1455	11520161000000	6513	3376	3	0	0
14539	1455	12240161000000	6660	3443	1	0	0
14540	1455	12240171000000	6660	3443	2	0	0
14542	1455	12960211000000	6703	3465	5	0	0
14544	1455	13680211000000	6784	3513	2	0	0
14545	1455	13680231000000	6784	3513	3	0	0
14546	1455	14400231000000	7037	3631	2	0	0
14547	1455	14400251000000	7037	3631	3	0	0
14549	1455	15120271000000	7038	3632	3	0	0
14551	1455	15840271000000	7672	3971	1	0	0
14424	1455	4353927000000	14886	7584	12	0	5
14425	1455	4353939000000	14886	7584	13	0	5
14441	1455	5073939000000	14903	7593	4	0	5
14443	1455	5073962000000	15040	7663	1	0	5
14449	1455	5793962000000	15040	7663	4	0	5
14450	1455	5793964000000	15040	7663	5	0	5
14463	1455	6513964000000	15253	7771	4	0	5
14467	1455	6514021000000	15736	8003	8	0	5
14472	1455	7234021000000	15736	8003	12	0	5
14473	1455	7234024000000	15736	8003	13	0	5
14488	1455	7954024000000	17766	8975	7	0	5
14491	1455	7954049000000	17766	8975	8	0	5
14502	1455	8674061000000	17858	9013	4	0	5
14511	1455	9394061000000	18927	9548	1	0	5
14512	1455	9394071000000	18927	9548	2	0	5
14520	1455	10114071000000	19028	9594	1	0	5
14521	1455	10114081000000	19028	9594	2	0	5
14526	1455	10834105000000	19204	9688	7	0	5
14535	1455	11554105000000	19658	9902	3	0	5
14536	1455	11554117000000	19658	9902	4	0	5
14418	1455	4351588000000	25883	12792	2	0	10
14438	1455	5071599000000	26073	12886	2	0	10
14440	1455	5071610000000	26073	12886	3	0	10
14447	1455	5791610000000	26180	12943	5	0	10
14448	1455	5791624000000	26180	12943	6	0	10
14457	1455	6511624000000	28011	13852	2	0	10
14470	1455	7231635000000	28060	13874	3	0	10
14471	1455	7231647000000	28060	13874	4	0	10
14478	1455	7951647000000	28689	14163	2	0	10
14480	1455	7951658000000	28689	14163	3	0	10
14556	1455	17280291000000	7994	4145	2	0	\N
14559	1455	17280311000000	7994	4145	3	0	\N
14562	1455	18720311000000	8372	4338	1	0	\N
14564	1455	18720321000000	8372	4338	2	0	\N
14566	1455	19440331000000	9001	4667	2	0	\N
14567	1455	19440351000000	9001	4667	3	0	\N
14572	1456	2160140000000	2097	1106	2	0	\N
14573	1456	2160160000000	2097	1106	3	0	\N
14574	1457	200000004	27216	13419	71	1	\N
14579	1457	2160060000000	442	249	3	0	\N
14580	1457	2160060000000	543	307	1	0	\N
14582	1457	2160070000000	543	307	2	0	\N
14584	1457	2160090000000	442	249	4	0	\N
14587	1457	3600080000000	635	356	1	0	\N
14589	1457	3600090000000	635	356	2	0	\N
14591	1457	4320100000000	843	465	1	0	\N
14593	1457	4320110000000	843	465	2	0	\N
14597	1457	5040110000000	1006	556	1	0	\N
14598	1457	5040110000000	1046	581	1	0	\N
14599	1457	5040110000000	1775	952	1	0	\N
14601	1457	5040120000000	1006	556	2	0	\N
14602	1457	5040120000000	1046	581	2	0	\N
14603	1457	5040120000000	1775	952	2	0	\N
14611	1457	6480130000000	2409	1260	1	0	\N
14613	1457	6480140000000	2409	1260	2	0	\N
14616	1457	6480180000000	3345	1738	4	0	\N
14619	1457	7200140000000	2891	1510	1	0	\N
14620	1457	7200140000000	3740	1940	1	0	\N
14621	1457	7200140000000	3968	2062	1	0	\N
14622	1457	7200150000000	2891	1510	2	0	\N
14623	1457	7200150000000	3740	1940	2	0	\N
14624	1457	7200150000000	3968	2062	2	0	\N
14626	1457	7200180000000	3345	1738	7	0	\N
14627	1457	7200200000000	3345	1738	8	0	\N
14628	1457	7824177040000	13228	6816	6	0	\N
14631	1457	7824201040000	13228	6816	7	0	\N
14640	1457	9360170000000	4177	2174	3	0	\N
14641	1457	9360170000000	4856	2516	1	0	\N
14643	1457	9360180000000	4856	2516	2	0	\N
14645	1457	9360200000000	4177	2174	4	0	\N
14650	1457	10704266040000	13692	7035	4	0	\N
14653	1457	10704288040000	13692	7035	5	0	\N
14654	1457	10800197800000	23209	11585	2	0	\N
14657	1457	10800200000000	4981	2582	4	0	\N
14658	1457	10800200000000	4985	2584	3	0	\N
14659	1457	10800200000000	5138	2663	2	0	\N
14660	1457	10800200000000	5152	2671	1	0	\N
14662	1457	10800208800000	23209	11585	3	0	\N
14663	1457	10800210000000	5152	2671	2	0	\N
14665	1457	10800230000000	4985	2584	4	0	\N
14666	1457	10800240000000	4981	2582	5	0	\N
14667	1457	10800310000000	5138	2663	3	0	\N
14670	1457	11520198800000	23416	11672	32	0	\N
14671	1457	11520198800000	24702	12269	27	0	\N
14672	1457	11520198800000	24859	12344	8	0	\N
14675	1457	11520220000000	5980	3102	1	0	\N
14677	1457	11520224800000	24859	12344	9	0	\N
14678	1457	11520374800000	23416	11672	33	0	\N
14679	1457	11520405800000	24702	12269	28	0	\N
14680	1457	11521084800000	23847	11673	11	0	\N
14681	1457	12144280040000	14636	7460	6	0	\N
14684	1457	12144304040000	14636	7460	7	0	\N
14685	1457	12240210000000	5832	3026	1	0	\N
14687	1457	12240220000000	5832	3026	2	0	\N
14688	1457	12240220000000	5980	3102	2	0	\N
14568	1456	720000000000	247	145	4	0	0
14569	1456	720130000000	247	145	5	0	0
14577	1457	1440030000000	296	171	3	0	0
14578	1457	1440060000000	296	171	4	0	0
14570	1456	1440130000000	460	258	1	0	0
14581	1457	2160060000000	583	330	1	0	0
14583	1457	2160070000000	583	330	2	0	0
14585	1457	2880070000000	599	340	1	0	0
14586	1457	2880080000000	599	340	2	0	0
14588	1457	3600080000000	794	440	2	0	0
14592	1457	4320100000000	925	516	1	0	0
14594	1457	4320110000000	925	516	2	0	0
14600	1457	5040110000000	1971	1042	1	0	0
14604	1457	5040120000000	1971	1042	2	0	0
14608	1457	5760130000000	2323	1216	2	0	0
14612	1457	6480130000000	2582	1361	1	0	0
14614	1457	6480140000000	2582	1361	2	0	0
14615	1457	6480150000000	4060	2109	1	0	0
14625	1457	7200150000000	4060	2109	2	0	0
14633	1457	7920160000000	4082	2121	2	0	0
14636	1457	8640160000000	4172	2171	1	0	0
14637	1457	8640170000000	4172	2171	2	0	0
14642	1457	9360170000000	4878	2527	1	0	0
14644	1457	9360180000000	4878	2527	2	0	0
14649	1457	10080200000000	4887	2531	3	0	0
14661	1457	10800200000000	5297	2752	1	0	0
14664	1457	10800210000000	5297	2752	2	0	0
14674	1457	11520210000000	5659	2935	0	0	0
14553	1455	15840281000000	7672	3971	2	0	0
14554	1455	16560281000000	7945	4116	1	0	0
14555	1455	16560291000000	7945	4116	2	0	0
14557	1455	17280291000000	8042	4168	1	0	0
14558	1455	17280301000000	8042	4168	2	0	0
14561	1455	18000311000000	8156	4228	2	0	0
14563	1455	18720311000000	8906	4613	2	0	0
14565	1455	18720331000000	8906	4613	3	0	0
14595	1457	4944170040000	11553	5936	1	0	4
14596	1457	4944171040000	11553	5936	2	0	4
14606	1457	5664172040000	11840	6087	2	0	4
14609	1457	6384172040000	12218	6294	2	0	4
14610	1457	6384174040000	12218	6294	3	0	4
14617	1457	7104174040000	12260	6313	3	0	4
14629	1457	7824177040000	13241	6820	4	0	4
14630	1457	7824190040000	13241	6820	5	0	4
14634	1457	8544190040000	13381	6896	15	0	4
14635	1457	8544241040000	13381	6896	16	0	4
14638	1457	9264241040000	13569	6979	3	0	4
14646	1457	9984253040000	13631	7007	4	0	4
14647	1457	9984266040000	13631	7007	5	0	4
14651	1457	10704266040000	14407	7350	2	0	4
14652	1457	10704268040000	14407	7350	3	0	4
14668	1457	11424268040000	14630	7458	3	0	4
14682	1457	12144280040000	15050	7667	1	0	4
14683	1457	12144290040000	15050	7667	2	0	4
14655	1457	10800197800000	23347	11650	1	0	8
14656	1457	10800198800000	23347	11650	2	0	8
14676	1457	11520221800000	25043	12424	6	0	8
14690	1457	12240221800000	25156	12481	6	0	\N
14693	1457	12240246800000	25156	12481	7	0	\N
14694	1457	12241084800000	23847	11673	126	0	\N
14695	1457	12242224800000	23847	11673	127	0	\N
14696	1457	12864290040000	15197	7744	2	0	\N
14697	1457	12864290040000	15479	7881	4	0	\N
14698	1457	12864290040000	15590	7936	6	0	\N
14700	1457	12864301040000	15197	7744	3	0	\N
14702	1457	12864312040000	15479	7881	5	0	\N
14703	1457	12864323040000	15590	7936	7	0	\N
14707	1457	12960243800000	25340	12566	3	0	\N
14708	1457	12960243800000	25410	12593	4	0	\N
14709	1457	12960243800000	25926	12812	2	0	\N
14711	1457	12960254800000	25926	12812	3	0	\N
14712	1457	12960255800000	25340	12566	4	0	\N
14713	1457	12960256800000	25410	12593	5	0	\N
14715	1457	13584303040000	15792	8035	4	0	\N
14717	1457	13584316040000	15792	8035	5	0	\N
14723	1457	13680674800000	27195	13418	36	0	\N
14724	1457	14304316040000	16317	8291	5	0	\N
14727	1457	14304429040000	16317	8291	6	0	\N
14728	1457	14400240000000	6313	3268	1	0	\N
14730	1457	14400250000000	6313	3268	2	0	\N
14732	1457	14400314800000	28669	14155	3	0	\N
14734	1457	14400326800000	28669	14155	4	0	\N
14736	1457	14400674800000	27195	13418	126	0	\N
14737	1457	14400844800000	27195	13418	127	0	\N
14738	1457	14401060800000	27216	13419	36	0	\N
14745	1457	15121060800000	27216	13419	70	0	\N
14746	1457	15744354040000	16896	8569	7	0	\N
14747	1457	15744354040000	17358	8794	3	0	\N
14749	1457	15744366040000	17358	8794	4	0	\N
14751	1457	15744388040000	16896	8569	8	0	\N
14756	1457	16464366040000	17646	8921	7	0	\N
14759	1457	16464418040000	17646	8921	8	0	\N
14760	1457	16560350000000	7027	3623	2	0	\N
14761	1457	16560350000000	7108	3670	4	0	\N
14764	1457	16560363800000	29422	14506	4	0	\N
14766	1457	16560370000000	7027	3623	3	0	\N
14767	1457	16560385800000	29422	14506	5	0	\N
14769	1457	16560390000000	7108	3670	5	0	\N
14772	1457	17280360000000	7347	3797	7	0	\N
14773	1457	17280360000000	7541	3904	1	0	\N
14774	1457	17280360000000	7870	4079	2	0	\N
14776	1457	17280370000000	7541	3904	2	0	\N
14778	1457	17280380000000	7870	4079	3	0	\N
14779	1457	17280387800000	30147	14833	8	0	\N
14781	1457	17280404800000	30147	14833	9	0	\N
14783	1457	17280421000000	7347	3797	8	0	\N
14785	1457	17904388040000	18291	9217	3	0	\N
14787	1457	17904400040000	18291	9217	4	0	\N
14788	1457	18000370000000	7936	4113	1	0	\N
14790	1457	18000380000000	7936	4113	2	0	\N
14804	1457	20160411000000	8647	4480	2	0	\N
14806	1457	20160431000000	8647	4480	3	0	\N
14810	1457	20880461000000	9084	4711	2	0	\N
14811	1457	20880461000000	9385	4868	2	0	\N
14812	1457	20880461000000	9388	4869	2	0	\N
14814	1457	20880472000000	9084	4711	3	0	\N
14815	1457	20880481000000	9385	4868	3	0	\N
14816	1457	20880481000000	9388	4869	3	0	\N
14820	1457	21600501000000	10261	5308	4	0	\N
14822	1457	21600541000000	10261	5308	5	0	\N
14824	1457	21620541000000	10457	5406	6	0	\N
14705	1457	12960230000000	6166	3193	2	0	0
14706	1457	12960240000000	6259	3241	1	0	0
14720	1457	13680240000000	6259	3241	2	0	0
14729	1457	14400240000000	6378	3303	1	0	0
14731	1457	14400250000000	6378	3303	2	0	0
14742	1457	15120310000000	6654	3441	7	0	0
14752	1457	15840310000000	6895	3562	4	0	0
14753	1457	15840350000000	6895	3562	5	0	0
14762	1457	16560350000000	7301	3772	1	0	0
14763	1457	16560360000000	7301	3772	2	0	0
14777	1457	17280370000000	7934	4112	2	0	0
14789	1457	18000370000000	8036	4165	1	0	0
14791	1457	18000380000000	8036	4165	2	0	0
14796	1457	18720380000000	8321	4307	1	0	0
14800	1457	19440381000000	8491	4398	3	0	0
14801	1457	19440411000000	8491	4398	4	0	0
14805	1457	20160411000000	9067	4700	5	0	0
14807	1457	20160461000000	9067	4700	6	0	0
14813	1457	20880461000000	9794	5078	4	0	0
14821	1457	21600501000000	10287	5323	4	0	0
14823	1457	21600541000000	10287	5323	5	0	0
14699	1457	12864290040000	15716	7991	4	0	4
14701	1457	12864303040000	15716	7991	5	0	4
14716	1457	13584303040000	16061	8168	4	0	4
14719	1457	13584339040000	16683	8474	5	0	4
14725	1457	14304339040000	16683	8474	8	0	4
14726	1457	14304341040000	16683	8474	9	0	4
14739	1457	15024341040000	16884	8564	4	0	4
14748	1457	15744354040000	17412	8820	3	0	4
14750	1457	15744366040000	17412	8820	4	0	4
14757	1457	16464366040000	17696	8945	2	0	4
14758	1457	16464377040000	17696	8945	3	0	4
14770	1457	17184377040000	18280	9210	2	0	4
14786	1457	17904388040000	18730	9438	0	0	4
14794	1457	18624388040000	18754	9453	4	0	4
14795	1457	18624410040000	18754	9453	5	0	4
14798	1457	19344410040000	18783	9465	3	0	4
14799	1457	19344422040000	18783	9465	4	0	4
14803	1457	20064433040000	18792	9469	3	0	4
14808	1457	20784433040000	18824	9486	2	0	4
14809	1457	20784444040000	18824	9486	3	0	4
14818	1457	21504444040000	19104	9635	2	0	4
14691	1457	12240221800000	25172	12487	4	0	8
14692	1457	12240243800000	25172	12487	5	0	8
14710	1457	12960243800000	26283	12999	7	0	8
14714	1457	12960277800000	26283	12999	8	0	8
14721	1457	13680277800000	26857	13284	10	0	8
14733	1457	14400314800000	28860	14234	3	0	8
14735	1457	14400326800000	28860	14234	4	0	8
14743	1457	15120326800000	28975	14289	6	0	8
14744	1457	15120350800000	28975	14289	7	0	8
14754	1457	15840350800000	29197	14393	4	0	8
14765	1457	16560363800000	29592	14591	6	0	8
14768	1457	16560387800000	29592	14591	7	0	8
14780	1457	17280387800000	30161	14840	8	0	8
14782	1457	17280404800000	30161	14840	9	0	8
14792	1457	18000421800000	30254	14875	10	0	8
14793	1457	18000422774789	30254	14875	12	1	8
14825	1457	21620691000000	10457	5406	7	0	\N
14828	1457	22320516000000	10638	5495	2	0	\N
14829	1457	22320536000000	10638	5495	3	0	\N
14830	1457	22320541000000	10691	5520	2	0	\N
14832	1457	22320561000000	10691	5520	3	0	\N
14834	1457	22944459040000	19493	9825	4	0	\N
14835	1457	22944459040000	19573	9858	2	0	\N
14837	1457	22944470040000	19573	9858	3	0	\N
14839	1457	22944472040000	19493	9825	5	0	\N
14846	1457	25104522040000	20233	10188	4	0	\N
14848	1457	25104535040000	20233	10188	5	0	\N
14850	1457	25824558040000	20476	10312	4	0	\N
14852	1457	25824580040000	20476	10312	5	0	\N
14856	1457	27264605040000	20964	10504	16	0	\N
14859	1457	27264935040000	20964	10504	17	0	\N
14864	1457	29424653040000	22125	11065	3	0	\N
14865	1457	29424653040000	22168	11088	5	0	\N
14867	1457	29424665040000	22125	11065	4	0	\N
14868	1457	29424866040000	22168	11088	6	0	\N
14875	1458	3400000	3704	1923	2	0	\N
14876	1458	25000000	11951	5910	17	0	\N
14877	1458	200000002	11894	5909	94	0	\N
14886	1458	3600070000000	508	285	1	0	\N
14887	1458	3600070000000	534	303	1	0	\N
14889	1458	3600080000000	508	285	2	0	\N
14890	1458	3600080000000	534	303	2	0	\N
14898	1458	5760110000000	1630	879	1	0	\N
14900	1458	5760120000000	1630	879	2	0	\N
14906	1458	6573506908540	11312	5810	2	0	\N
14908	1458	6573506908540	11520	5906	28	0	\N
14909	1458	6573517908540	11312	5810	3	0	\N
14910	1458	6573634908540	11520	5906	29	0	\N
14911	1458	6573969908540	11634	5907	83	0	\N
14913	1458	7145072908540	21414	10739	3	0	\N
14915	1458	7145084908540	21414	10739	4	0	\N
14916	1458	7200140000000	2134	1127	1	0	\N
14917	1458	7200140000000	2136	1125	3	0	\N
14918	1458	7200140000000	2137	1127	1	0	\N
14920	1458	7200150000000	2134	1127	2	0	\N
14921	1458	7200150000000	2137	1127	2	0	\N
14923	1458	7200170000000	2136	1125	4	0	\N
14926	1458	7293969908540	11634	5907	113	0	\N
14927	1458	7865084908540	21582	10820	11	0	\N
14928	1458	7865113908540	21582	10820	12	0	\N
14931	1458	7975998908532	11661	5908	0	0	\N
14932	1458	8013507908540	11660	5997	1	0	\N
14934	1458	8013508908540	11660	5997	2	0	\N
14939	1458	8585116908540	21916	10967	2	0	\N
14940	1458	8640170000000	2511	1318	2	0	\N
14942	1458	8640170000000	2535	1333	2	0	\N
14944	1458	8640190000000	2511	1318	3	0	\N
14945	1458	8640190000000	2535	1333	3	0	\N
14946	1458	8641012798540	3356	1648	48	0	\N
14947	1458	8696452908523	11894	5909	126	0	\N
14948	1458	8696491908523	11894	5909	127	0	\N
14949	1458	8733509908540	11947	6138	5	0	\N
14952	1458	8753514908540	11947	6138	6	0	\N
14953	1458	8753774908540	12290	6139	13	0	\N
14954	1458	8795473944000	12459	6140	11	0	\N
14956	1458	9305116908540	21916	10967	7	0	\N
14958	1458	9305121908540	21916	10967	8	0	\N
14959	1458	9360172798540	2672	1404	1	0	\N
14960	1458	9360172798540	2879	1505	1	0	\N
14880	1458	1440020000000	165	99	3	0	0
14881	1458	1440050000000	165	99	4	0	0
14882	1458	2160050000000	179	106	1	0	0
14883	1458	2160060000000	179	106	2	0	0
14884	1458	2880060000000	447	251	1	0	0
14888	1458	3600070000000	627	352	2	0	0
14891	1458	3600090000000	627	352	3	0	0
14892	1458	4320090000000	820	454	1	0	0
14893	1458	4320100000000	820	454	2	0	0
14894	1458	5040100000000	1077	597	1	0	0
14899	1458	5760110000000	1826	976	1	0	0
14901	1458	5760120000000	1826	976	2	0	0
14904	1458	6480120000000	2117	1116	2	0	0
14905	1458	6480140000000	2117	1116	3	0	0
14922	1458	7200150000000	2219	1168	2	0	0
14929	1458	7920150000000	2397	1254	2	0	0
14930	1458	7920170000000	2397	1254	3	0	0
14941	1458	8640170000000	2534	1333	2	0	0
14943	1458	8640172798540	2534	1333	3	1	0
14833	1457	22320591000000	10776	5562	6	0	0
14840	1457	23040591000000	10842	5596	4	0	0
14841	1457	23040631000000	10842	5596	5	0	0
14896	1458	5133336908540	11012	5669	6	0	4
14897	1458	5133486908540	11012	5669	7	0	4
14903	1458	5853506908540	11152	5732	3	0	4
14907	1458	6573506908540	11519	5916	0	0	4
14924	1458	7293506908540	11633	5987	1	0	4
14925	1458	7293507908540	11633	5987	2	0	4
14935	1458	8013509908540	11893	6113	3	0	4
14950	1458	8733509908540	12641	6521	2	0	4
14951	1458	8733520908540	12641	6521	3	0	4
14826	1457	22224446040000	19407	9780	4	0	4
14827	1457	22224459040000	19407	9780	5	0	4
14838	1457	22944471040000	19834	9991	4	0	4
14842	1457	23664471040000	19916	10030	5	0	4
14843	1457	23664494040000	19916	10030	6	0	4
14844	1457	24384494040000	20022	10079	10	0	4
14845	1457	24384522040000	20022	10079	11	0	4
14849	1457	25104558040000	20347	10248	10	0	4
14851	1457	25824558040000	20732	10422	7	0	4
14853	1457	25824583040000	20732	10422	8	0	4
14854	1457	26544583040000	20834	10471	4	0	4
14912	1458	7145072908540	21412	10739	3	0	8
14914	1458	7145084908540	21412	10739	4	0	8
14857	1457	27264605040000	21612	10831	3	0	4
14858	1457	27264617040000	21612	10831	4	0	4
14936	1458	8585084908540	21757	10894	3	0	8
14860	1457	27984617040000	21898	10958	6	0	4
14861	1457	27984641040000	21898	10958	7	0	4
14938	1458	8585116908540	21915	10967	2	0	8
14955	1458	9305116908540	21915	10967	7	0	8
14957	1458	9305121908540	21915	10967	8	0	8
14863	1457	28704653040000	22000	11001	4	0	4
14866	1457	29424653040000	22292	11158	0	0	4
14869	1457	30144653040000	22332	11177	7	0	4
14870	1457	30144687040000	22332	11177	8	0	4
14872	1457	30864712040000	22375	11201	8	0	4
14873	1457	31584712040000	22629	11318	3	0	4
14874	1457	31584724040000	22629	11318	4	0	4
14961	1458	9360172798540	3358	1744	1	0	\N
14963	1458	9360182798540	2672	1404	2	0	\N
14964	1458	9360182798540	2879	1505	2	0	\N
14965	1458	9360182798540	3358	1744	2	0	\N
14966	1458	9361012798532	3356	1648	49	0	\N
14967	1458	9416491908523	11951	5910	16	0	\N
14968	1458	9453520908540	12703	6552	2	0	\N
14969	1458	9453520908540	12812	6607	3	0	\N
14972	1458	9453531908540	12703	6552	3	0	\N
14973	1458	9453550908540	12812	6607	4	0	\N
14974	1458	9473774908540	12290	6139	22	0	\N
14975	1458	9473854908540	12290	6139	23	0	\N
14980	1458	10081012798524	3477	1649	0	0	\N
14983	1458	10173605908540	13301	6830	7	0	\N
14984	1458	10193854908540	12459	6140	10	0	\N
14987	1458	10800173798540	3508	1821	1	0	\N
14989	1458	10800183798540	3508	1821	2	0	\N
14991	1458	10893535908540	13852	7108	7	0	\N
14993	1458	10893551908540	13852	7108	8	0	\N
14994	1458	10893605908540	13301	6830	95	0	\N
14995	1458	10893944908540	13301	6830	96	0	\N
14998	1458	11520173298540	3704	1923	1	0	\N
14999	1458	11520173798540	3706	1923	1	0	\N
15000	1458	11520173798540	3766	1954	2	0	\N
15001	1458	11520173798540	4011	2082	2	0	\N
15003	1458	11520183798540	3706	1923	2	0	\N
15005	1458	11520193798540	3766	1954	3	0	\N
15006	1458	11520193798540	4011	2082	3	0	\N
15009	1458	11613944908540	13305	6831	6	0	\N
15010	1458	11613968908540	13305	6831	7	0	\N
15017	1458	12905170908540	22693	11347	6	0	\N
15018	1458	12905170908540	22910	11451	3	0	\N
15020	1458	12905182908540	22910	11451	4	0	\N
15022	1458	12905185908540	22693	11347	7	0	\N
15023	1458	12906133908540	23332	11521	86	0	\N
15028	1458	13625183908540	23330	11642	2	0	\N
15029	1458	13625183908540	23457	11697	3	0	\N
15031	1458	13625194908540	23330	11642	3	0	\N
15032	1458	13625195908540	23457	11697	4	0	\N
15034	1458	13626133908540	23332	11521	99	0	\N
15035	1458	13626253908540	23332	11521	100	0	\N
15036	1458	13680213798540	4326	2242	1	0	\N
15037	1458	13680213798540	4508	2333	1	0	\N
15039	1458	13680223798540	4326	2242	2	0	\N
15040	1458	13680223798540	4508	2333	2	0	\N
15048	1458	14493629908540	15984	8126	3	0	\N
15049	1458	14493629908540	16114	8191	3	0	\N
15051	1458	14493641908540	15984	8126	4	0	\N
15052	1458	14493641908540	16114	8191	4	0	\N
15056	1458	15120254908540	4777	2468	1	0	\N
15058	1458	15120264908540	4777	2468	2	0	\N
15059	1458	15213642908540	16256	8262	3	0	\N
15061	1458	15213654908540	16256	8262	4	0	\N
15063	1458	15785308908540	23814	11853	3	0	\N
15064	1458	15785308908540	23871	11881	3	0	\N
15065	1458	15785308908540	24141	12018	2	0	\N
15066	1458	15785308908540	24143	12018	4	0	\N
15068	1458	15785310908540	24141	12018	3	0	\N
15070	1458	15785320908540	23814	11853	4	0	\N
15071	1458	15785320908540	23871	11881	4	0	\N
15072	1458	15785330908540	24143	12018	5	0	\N
15075	1458	15840301001008	11634	5907	114	0	\N
15078	1458	15933713908540	17015	8620	2	0	\N
15081	1458	16560264908540	6019	3122	1	0	\N
15083	1458	16560274908540	6019	3122	2	0	\N
15086	1458	16653713908540	17015	8620	4	0	\N
15087	1458	16653714908540	17015	8620	5	0	\N
15089	1458	17225344908540	24520	12193	2	0	\N
15090	1458	17225344908540	24527	12156	79	0	\N
15092	1458	17225355908540	24520	12193	3	0	\N
15094	1458	17225513908540	24527	12156	80	0	\N
15095	1458	17226373908540	24781	12157	23	0	\N
14979	1458	10080173798540	3495	1814	2	0	0
14988	1458	10800173798540	3583	1861	0	0	0
15002	1458	11520173798540	4015	2083	1	0	0
15004	1458	11520183798540	4015	2083	2	0	0
15013	1458	12240183798540	4038	2096	1	0	0
15024	1458	12960193798540	4192	2182	2	0	0
15025	1458	12960213798540	4192	2182	3	0	0
15038	1458	13680213798540	4731	2446	3	0	0
15041	1458	13680244908540	4731	2446	4	0	0
15046	1458	14400244908540	4753	2456	1	0	0
15057	1458	15120254908540	5429	2825	0	0	0
15073	1458	15840254908540	6004	3115	1	0	0
15074	1458	15840264908540	6004	3115	2	0	0
15082	1458	16560264908540	6047	3142	1	0	0
15096	1458	17280274908540	6094	3163	3	0	0
14970	1458	9453520908540	12910	6654	1	0	4
14971	1458	9453521908540	12910	6654	2	0	4
14981	1458	10173521908540	13165	6783	5	0	4
14982	1458	10173535908540	13165	6783	6	0	4
14992	1458	10893545908540	13850	7108	2	0	4
15007	1458	11613545908540	13949	7148	4	0	4
15008	1458	11613558908540	13949	7148	5	0	4
15015	1458	12333558908540	14609	7448	11	0	4
15016	1458	12333605908540	14609	7448	12	0	4
15027	1458	13053617908540	14906	7594	4	0	4
15042	1458	13773617908540	15972	8118	3	0	4
15043	1458	13773629908540	15972	8118	4	0	4
15050	1458	14493629908540	16120	8195	4	0	4
15060	1458	15213642908540	16805	8529	3	0	4
15062	1458	15213654908540	16805	8529	4	0	4
15076	1458	15933654908540	16925	8578	12	0	4
15077	1458	15933702908540	16925	8578	13	0	4
15085	1458	16653702908540	17144	8689	3	0	4
14976	1458	10025121908540	22023	11010	3	0	8
14977	1458	10025133908540	22023	11010	4	0	8
14985	1458	10745133908540	22097	11049	3	0	8
14986	1458	10745145908540	22097	11049	4	0	8
14996	1458	11465145908540	22395	11212	3	0	8
15011	1458	12185157908540	22675	11337	4	0	8
15012	1458	12185170908540	22675	11337	5	0	8
15019	1458	12905170908540	23072	11519	4	0	8
15021	1458	12905183908540	23072	11519	5	0	8
15033	1458	13625196908540	23498	11714	5	0	8
15044	1458	14345196908540	23682	11792	8	0	8
15045	1458	14345222908540	23682	11792	9	0	8
15054	1458	15065222908540	23746	11827	23	0	8
15055	1458	15065308908540	23746	11827	24	0	8
15069	1458	15785319908540	24165	12028	3	0	8
15079	1458	16505319908540	24315	12091	7	0	8
15080	1458	16505344908540	24315	12091	8	0	8
15091	1458	17225344908540	24780	12304	4	0	8
15093	1458	17225357908540	24780	12304	5	0	8
15102	1458	17946373908540	24781	12157	56	0	\N
15103	1458	17946693908540	24781	12157	57	0	\N
15104	1458	18000304908540	6352	3287	2	0	\N
15106	1458	18000324908540	6352	3287	3	0	\N
15109	1458	18093726908540	17291	8758	2	0	\N
15111	1458	18093737908540	17291	8758	3	0	\N
15114	1458	18720325908540	6730	3483	2	0	\N
15117	1458	18720345908540	6730	3483	3	0	\N
15118	1458	18813736908540	17494	8856	2	0	\N
15119	1458	18813736908540	17869	9010	1	0	\N
15121	1458	18813737908540	17869	9010	2	0	\N
15122	1458	18813747908540	17494	8856	3	0	\N
15128	1458	19533749908540	18463	9304	2	0	\N
15129	1458	19533749908540	18492	9314	4	0	\N
15130	1458	19533749908540	18520	9328	0	0	\N
15132	1458	19533760908540	18463	9304	3	0	\N
15134	1458	19533762908540	18492	9314	5	0	\N
15141	1458	20253805908540	19706	9923	5	0	\N
15147	1458	20973773908540	19640	9892	3	0	\N
15148	1458	20973785908540	19640	9892	4	0	\N
15149	1458	20973805908540	19706	9923	6	0	\N
15151	1458	20973818908540	19898	10022	4	0	\N
15154	1458	21545502908540	26929	13320	8	0	\N
15157	1458	21693805908540	19787	9964	7	0	\N
15158	1458	21693805908540	20328	10237	5	0	\N
15160	1458	21693805908540	20594	10359	4	0	\N
15161	1458	21693818908540	19898	10022	5	0	\N
15162	1458	21693827908540	20594	10359	5	0	\N
15163	1458	21693828908540	20328	10237	6	0	\N
15164	1458	21693830908540	19787	9964	8	0	\N
15167	1458	22265467908540	26985	13345	2	0	\N
15168	1458	22265469908540	26985	13345	3	0	\N
15170	1458	22265502908540	26929	13320	10	0	\N
15171	1458	22265503908540	26929	13320	11	0	\N
15176	1458	22414826908540	20721	10382	95	0	\N
15177	1458	22985479908540	27746	13707	4	0	\N
15180	1458	22985501908540	27746	13707	5	0	\N
15181	1458	23040405908540	9059	4696	2	0	\N
15182	1458	23040405908540	9172	4753	3	0	\N
15184	1458	23040425908540	9059	4696	3	0	\N
15186	1458	23040426908540	9172	4753	4	0	\N
15191	1458	23760475908540	10277	5319	2	0	\N
15194	1458	23854826908540	20721	10382	126	0	\N
15195	1458	23854856908540	20721	10382	127	0	\N
15196	1458	23856346908540	21011	10383	95	0	\N
15197	1458	24425501908540	28903	14256	9	0	\N
15200	1458	24425537908540	28903	14256	10	0	\N
15201	1458	24480445908540	10154	5263	2	0	\N
15203	1458	24480465908540	10154	5263	3	0	\N
15204	1458	24480475908540	10277	5319	8	0	\N
15206	1458	24480525908540	10277	5319	9	0	\N
15209	1458	24576346908540	21011	10383	126	0	\N
15210	1458	24576646908540	21011	10383	127	0	\N
15215	1458	26640536908540	10851	5601	2	0	\N
15216	1458	26640556908540	10851	5601	3	0	\N
15217	1460	1700000	4262	2210	5	0	\N
15218	1460	155000000	17919	8766	0	0	\N
15219	1460	155000000	24768	12297	2	0	\N
15220	1460	200000013	6399	3316	5	1	\N
15221	1460	11520179398540	3704	1923	2	1	\N
15222	1460	66001000000002	12263	6036	17	0	\N
15223	1462	720000000000	2948	1533	1	0	\N
15224	1462	720000000000	18055	9107	3	0	\N
15225	1462	720000000000	19148	9660	4	0	\N
15227	1462	720010000000	2948	1533	2	0	\N
15228	1462	720013000000	19148	9660	5	0	\N
15230	1462	720021000000	18055	9107	4	0	\N
15231	1462	1440013000000	28513	14089	5	0	\N
15232	1462	1440027000000	28513	14089	6	0	\N
15107	1458	18000325908540	6553	3396	4	0	0
15115	1458	18720325908540	7523	3895	1	0	0
15116	1458	18720335908540	7523	3895	2	0	0
15126	1458	19440335908540	7555	3912	1	0	0
15127	1458	19440345908540	7555	3912	2	0	0
15138	1458	20160355908540	7828	4059	2	0	0
15145	1458	20880355908540	8059	4176	2	0	0
15146	1458	20880375908540	8059	4176	3	0	0
15155	1458	21600375908540	8185	4242	1	0	0
15156	1458	21600385908540	8185	4242	2	0	0
15173	1458	22320405908540	8265	4280	3	0	0
15183	1458	23040405908540	9331	4840	2	0	0
15185	1458	23040425908540	9331	4840	3	0	0
15189	1458	23760425908540	9850	5106	2	0	0
15202	1458	24480445908540	10311	5334	4	0	0
15205	1458	24480476908540	10311	5334	5	0	0
15211	1458	25200476908540	10734	5540	2	0	0
15212	1458	25200496908540	10734	5540	3	0	0
15213	1458	25920496908540	10828	5587	4	0	0
15098	1458	17373714908540	17225	8726	3	0	4
15099	1458	17373726908540	17225	8726	4	0	4
15108	1458	18093726908540	17290	8758	1	0	4
15110	1458	18093736908540	17290	8758	2	0	4
15120	1458	18813736908540	17871	9019	4	0	4
15131	1458	19533749908540	19247	9704	3	0	4
15133	1458	19533761908540	19247	9704	4	0	4
15139	1458	20253761908540	19263	9711	3	0	4
15140	1458	20253773908540	19263	9711	4	0	4
15150	1458	20973805908540	19709	9923	6	0	4
15159	1458	21693805908540	20593	10359	6	0	4
15165	1458	21693838908540	20593	10359	7	0	4
15174	1458	22413838908540	20601	10363	3	0	4
15175	1458	22413850908540	20601	10363	4	0	4
15193	1458	23853861908540	20720	10418	3	0	4
15207	1458	24573861908540	21010	10564	2	0	4
15208	1458	24573872908540	21010	10564	3	0	4
15100	1458	17945357908540	24782	12305	3	0	8
15101	1458	17945369908540	24782	12305	4	0	8
15113	1458	18665393908540	24786	12308	7	0	8
15124	1458	19385393908540	24794	12310	10	0	8
15125	1458	19385430908540	24794	12310	11	0	8
15135	1458	20105430908540	25274	12538	4	0	8
15226	1462	720000000000	25592	12667	4	0	0
15229	1462	720013000000	25592	12667	5	0	0
15143	1458	20825443908540	26520	13121	3	0	8
15144	1458	20825455908540	26520	13121	4	0	8
15152	1458	21545455908540	26796	13249	3	0	8
15166	1458	22265467908540	26984	13345	3	0	8
15169	1458	22265479908540	26984	13345	4	0	8
15178	1458	22985479908540	28362	14021	2	0	8
15179	1458	22985490908540	28362	14021	3	0	8
15187	1458	23705490908540	28547	14104	2	0	8
15198	1458	24425501908540	29030	14316	6	0	8
15199	1458	24425525908540	29030	14316	7	0	8
15233	1463	720000000000	352	201	0	0	\N
15234	1463	720000000000	353	201	1	0	\N
15235	1463	720000000000	4963	2572	2	0	\N
15236	1463	720000000000	15096	7691	1	0	\N
15237	1463	720000000000	18623	9384	3	0	\N
15238	1463	720001000000	15096	7691	2	0	\N
15239	1463	720010000000	353	201	2	0	\N
15240	1463	720012000000	18623	9384	4	0	\N
15241	1463	720020000000	4963	2572	3	0	\N
15253	1467	10000000	10618	5297	37	0	\N
15254	1467	13042122	9723	4882	44	1	\N
15255	1467	200000003	10387	5295	127	0	\N
15256	1467	720000000000	181	108	1	0	\N
15258	1467	720010000000	181	108	2	0	\N
15262	1467	2161360000000	1425	775	3	0	\N
15263	1467	2161360000000	1742	935	1	0	\N
15264	1467	2161360000000	2201	1159	1	0	\N
15266	1467	2161370000000	1742	935	2	0	\N
15267	1467	2161370000000	2201	1159	2	0	\N
15269	1467	2161390000000	1425	775	4	0	\N
15274	1467	3566554100039	14731	7500	8	0	\N
15276	1467	3566598100039	14731	7500	9	0	\N
15280	1467	3760241272869	24825	12327	8	0	\N
15281	1467	3760241272869	24958	12386	3	0	\N
15282	1467	3760253272869	24958	12386	4	0	\N
15283	1467	3760276272869	24825	12327	9	0	\N
15287	1467	4321410000000	3289	1451	0	0	\N
15288	1467	4321410000000	3290	1469	0	0	\N
15290	1467	4321480000000	2905	1517	4	0	\N
15293	1467	5006628100039	15088	7687	1	0	\N
15294	1467	5006628100039	15135	7715	3	0	\N
15295	1467	5006628100039	15564	7921	1	0	\N
15297	1467	5006638100039	15088	7687	2	0	\N
15298	1467	5006638100039	15564	7921	2	0	\N
15300	1467	5006649100039	15135	7715	4	0	\N
15302	1467	5041440000000	3292	1486	0	0	\N
15303	1467	5041440000000	3294	1503	0	0	\N
15304	1467	5041440000000	3295	1519	0	0	\N
15305	1467	5041480000000	2905	1517	5	0	\N
15307	1467	5200266272869	25453	12609	3	0	\N
15308	1467	5200266272869	25786	12753	3	0	\N
15309	1467	5200266272869	26196	12950	5	0	\N
15311	1467	5200278272869	25453	12609	4	0	\N
15312	1467	5200278272869	25786	12753	4	0	\N
15313	1467	5200280272869	26196	12950	6	0	\N
15319	1467	5920292272869	26450	13083	3	0	\N
15321	1467	5920304272869	26450	13083	4	0	\N
15323	1467	5920314272869	27014	13361	1	0	\N
15328	1467	6640304272869	26837	13272	3	0	\N
15330	1467	6640314272869	27014	13361	4	0	\N
15332	1467	6640316272869	26837	13272	4	0	\N
15333	1467	6640316272869	27014	13361	5	0	\N
15335	1467	7166677100039	16032	8152	0	0	\N
15343	1467	7921590000000	5330	2767	1	0	\N
15345	1467	7921600000000	5330	2767	2	0	\N
15346	1467	8080326272869	28007	13851	3	0	\N
15349	1467	8080338272869	28007	13851	4	0	\N
15350	1467	8606714100039	16466	8376	4	0	\N
15351	1467	8606714100039	16934	8583	3	0	\N
15353	1467	8606726100039	16934	8583	4	0	\N
15355	1467	8606727100039	16466	8376	5	0	\N
15358	1467	8800327272869	28243	13964	2	0	\N
15360	1467	8800338272869	28243	13964	3	0	\N
15364	1467	9361610000000	5984	3105	2	0	\N
15367	1467	9361630000000	5984	3105	3	0	\N
15260	1467	1441350000000	1150	633	1	0	0
15261	1467	1441360000000	1150	633	2	0	0
15247	1466	720000000000	2112	1113	1	0	0
15248	1466	720010000000	2112	1113	2	0	0
15265	1467	2161360000000	2452	1283	2	0	0
15270	1467	2881380000000	2567	1353	1	0	0
15271	1467	2881390000000	2567	1353	2	0	0
15278	1467	3601390000000	2572	1355	2	0	0
15279	1467	3601410000000	2572	1355	3	0	0
15286	1467	4321410000000	2838	1484	3	0	0
15301	1467	5041440000000	3094	1606	8	0	0
15306	1467	5041520000000	3094	1606	9	0	0
15317	1467	5761520000000	3293	1709	5	0	0
15318	1467	5761570000000	3293	1709	6	0	0
15327	1467	6481580000000	3870	2010	2	0	0
15337	1467	7201580000000	4026	2091	1	0	0
15338	1467	7201590000000	4026	2091	2	0	0
15344	1467	7921590000000	5562	2892	0	0	0
15242	1464	720000000000	5738	2973	0	0	0
15357	1467	8641610000000	5870	3042	3	0	0
15365	1467	9361610000000	6251	3234	1	0	0
15366	1467	9361620000000	6251	3234	2	0	0
15249	1466	1440010000000	7466	3863	1	0	0
15250	1466	1440020000000	7466	3863	2	0	0
15244	1464	1440022000000	12512	6448	5	0	0
15251	1466	2160020000000	13677	7028	3	0	0
15252	1466	2160032000000	13677	7028	4	0	0
15275	1467	3566554100039	14870	7576	7	0	4
15284	1467	4286607100039	15080	7681	3	0	4
15285	1467	4286628100039	15080	7681	4	0	4
15296	1467	5006628100039	15677	7978	4	0	4
15299	1467	5006641100039	15677	7978	5	0	4
15315	1467	5726641100039	15729	7998	3	0	4
15324	1467	6446653100039	15854	8063	6	0	4
15325	1467	6446677100039	15854	8063	7	0	4
15334	1467	7166677100039	16031	8152	7	0	4
15336	1467	7166702100039	16031	8152	8	0	4
15341	1467	7886702100039	16121	8196	3	0	4
15352	1467	8606714100039	17089	8659	3	0	4
15354	1467	8606726100039	17089	8659	4	0	4
15362	1467	9326726100039	17383	8805	3	0	4
15363	1467	9326738100039	17383	8805	4	0	4
15273	1467	3040241272869	24769	12298	4	0	9
15291	1467	4480241272869	25068	12442	7	0	9
15292	1467	4480266272869	25068	12442	8	0	9
15245	1464	2160022000000	25305	12555	3	0	0
15246	1464	2160034000000	25305	12555	4	0	0
15314	1467	5200292272869	26375	13046	9	0	9
15320	1467	5920292272869	26514	13118	3	0	9
15322	1467	5920304272869	26514	13118	4	0	9
15329	1467	6640304272869	27739	13704	2	0	9
15331	1467	6640315272869	27739	13704	3	0	9
15340	1467	7360326272869	27765	13717	3	0	9
15347	1467	8080326272869	28201	13943	1	0	9
15348	1467	8080327272869	28201	13943	2	0	9
15359	1467	8800327272869	28328	14005	2	0	9
15368	1467	9520338272869	28485	14077	2	0	9
15372	1467	10046761100039	17880	9025	2	0	\N
15374	1467	10081620000000	6479	3359	2	0	\N
15376	1467	10081640000000	6479	3359	3	0	\N
15378	1467	10240349272869	28649	14144	1	0	\N
15380	1467	10240359272869	28649	14144	2	0	\N
15382	1467	10766761100039	17880	9025	4	0	\N
15384	1467	10766762100039	17880	9025	5	0	\N
15386	1467	10801640000000	6662	3444	3	0	\N
15387	1467	10801640000000	7136	3688	2	0	\N
15388	1467	10801640000000	7268	3758	1	0	\N
15390	1467	10801650000000	7268	3758	2	0	\N
15391	1467	10801660000000	7136	3688	3	0	\N
15393	1467	10801670000000	6662	3444	4	0	\N
15399	1467	11521660000000	7663	3966	2	0	\N
15401	1467	11521680000000	7663	3966	3	0	\N
15403	1467	11680363272869	28977	14290	3	0	\N
15404	1467	11680363272869	29566	14578	6	0	\N
15406	1467	11680375272869	28977	14290	4	0	\N
15407	1467	11680387272869	29566	14578	7	0	\N
15426	1467	14401730000000	8048	4170	1	0	\N
15427	1467	14401730000000	8106	4202	1	0	\N
15429	1467	14401740000000	8048	4170	2	0	\N
15430	1467	14401740000000	8106	4202	2	0	\N
15433	1467	14401750000000	9038	4686	1	0	\N
15436	1467	15121740000000	8519	4413	2	0	\N
15437	1467	15121740000000	8588	4453	1	0	\N
15438	1467	15121750000000	8588	4453	2	0	\N
15440	1467	15121750000000	9038	4686	3	0	\N
15442	1467	15121760000000	8519	4413	3	0	\N
15443	1467	15121760000000	9038	4686	4	0	\N
15448	1467	16526902100039	19969	10057	3	0	\N
15450	1467	16526914100039	19969	10057	4	0	\N
15454	1467	17246915100039	20188	10166	3	0	\N
15455	1467	17246915100039	20882	10498	4	0	\N
15456	1467	17246915100039	20913	10513	4	0	\N
15457	1467	17246915100039	21292	10692	4	0	\N
15458	1467	17246915100039	21372	10725	4	0	\N
15459	1467	17246915100039	21378	10441	0	0	\N
15460	1467	17246915100039	21379	10445	0	0	\N
15462	1467	17246927100039	20188	10166	4	0	\N
15463	1467	17246928100039	21292	10692	5	0	\N
15464	1467	17246928100039	21372	10725	5	0	\N
15465	1467	17246937100039	20882	10498	5	0	\N
15466	1467	17246937100039	20913	10513	5	0	\N
15468	1467	17246973100039	22562	11288	2	0	\N
15470	1467	17281981100000	9081	4710	4	0	\N
15471	1467	17281981100000	9082	4710	3	0	\N
15472	1467	17281981100000	9205	4773	8	0	\N
15473	1467	17281981100000	9436	4880	2	0	\N
15475	1467	17282001100000	9436	4880	3	0	\N
15476	1467	17282011100000	9082	4710	4	0	\N
15478	1467	17282021100000	9081	4710	5	0	\N
15479	1467	17282061100000	9205	4773	9	0	\N
15480	1467	17966962100039	22305	11166	3	0	\N
15481	1467	17966973100039	22562	11288	4	0	\N
15483	1467	17966974100039	22305	11166	4	0	\N
15484	1467	17966974100039	22562	11288	5	0	\N
15486	1467	18002001100000	9464	4881	2	0	\N
15487	1467	18002003100000	9464	4881	3	0	\N
15490	1467	18004113100000	9723	4882	40	0	\N
15491	1467	18686974100039	22570	11292	3	0	\N
15493	1467	18686986100039	22570	11292	4	0	\N
15497	1467	18724113099999	9723	4882	43	0	\N
15498	1467	19407027100039	22989	11483	5	0	\N
15501	1467	19407059100039	22989	11483	6	0	\N
15504	1467	19443117057977	9774	4883	0	0	\N
15389	1467	10801640000000	7316	3781	2	0	0
15392	1467	10801660000000	7316	3781	3	0	0
15394	1467	10801670000000	7677	3975	1	0	0
15400	1467	11521670000000	7677	3975	5	0	0
15402	1467	11521700000000	7677	3975	6	0	0
15413	1467	12241710000000	7713	3995	2	0	0
15418	1467	12961710000000	7853	4071	1	0	0
15419	1467	12961720000000	7853	4071	2	0	0
15422	1467	13681720000000	7859	4075	1	0	0
15423	1467	13681730000000	7859	4075	2	0	0
15431	1467	14401740000000	8473	4389	2	0	0
15432	1467	14401750000000	9037	4686	1	0	0
15439	1467	15121750000000	9037	4686	3	0	0
15441	1467	15121750100000	9037	4686	4	0	0
15447	1467	15841871100000	9048	4691	14	0	0
15452	1467	16561871100000	9070	4702	11	0	0
15453	1467	16561981100000	9070	4702	12	0	0
15474	1467	17281981100000	9437	4894	3	0	0
15477	1467	17282011100000	9437	4894	4	0	0
15489	1467	18002041100000	9465	4907	4	0	0
15495	1467	18722041100000	9726	5040	9	0	0
15496	1467	18722203100000	9726	5040	10	0	0
15502	1467	19442203100000	9776	5065	2	0	0
15503	1467	19442223100000	9776	5065	3	0	0
15371	1467	10046750100039	17429	8829	4	0	4
15373	1467	10046761100039	17882	9025	2	0	4
15383	1467	10766761100039	17882	9025	4	0	4
15385	1467	10766762100039	17882	9025	5	0	4
15398	1467	11486774100039	18511	9323	4	0	4
15410	1467	12206774100039	18857	9508	1	0	4
15411	1467	12206784100039	18857	9508	2	0	4
15416	1467	12926784100039	19293	9727	3	0	4
15417	1467	12926796100039	19293	9727	4	0	4
15421	1467	13646808100039	19598	9871	4	0	4
15424	1467	14366808100039	19648	9895	7	0	4
15425	1467	14366833100039	19648	9895	8	0	4
15434	1467	15086833100039	19803	9973	10	0	4
15435	1467	15086879100039	19803	9973	11	0	4
15445	1467	15806902100039	19930	10038	6	0	4
15449	1467	16526902100039	20171	10155	4	0	4
15451	1467	16526915100039	20171	10155	5	0	4
15461	1467	17246915100039	22304	11165	11	0	4
15469	1467	17246973100039	22563	11288	2	0	4
15482	1467	17966973100039	22563	11288	4	0	4
15485	1467	17966974100039	22563	11288	5	0	4
15492	1467	18686974100039	22690	11345	8	0	4
15494	1467	18687027100039	22690	11345	9	0	4
15500	1467	19407039100039	23978	11933	4	0	4
15369	1467	9520349272869	28485	14077	3	0	9
15379	1467	10240349272869	28758	14186	4	0	9
15381	1467	10240362272869	28758	14186	5	0	9
15395	1467	10960362272869	28912	14261	1	0	9
15405	1467	11680363272869	29772	14674	31	0	9
15408	1467	11680412272861	29772	14674	32	0	9
15409	1467	11680453272861	30266	14881	14	0	9
15414	1467	12400453272861	30266	14881	34	0	9
15505	1467	20127039100039	24289	12081	4	0	\N
15506	1467	20127052100039	24289	12081	5	0	\N
15508	1467	20162223100000	10126	5252	2	0	\N
15510	1467	20162243100000	10126	5252	3	0	\N
15512	1467	20882243100000	10238	5294	14	0	\N
15514	1467	20882473100000	10238	5294	15	0	\N
15515	1467	20884413100000	10387	5295	10	0	\N
15518	1467	21604413100000	10387	5295	126	0	\N
15519	1467	21606433099999	10558	5296	10	0	\N
15522	1467	22326433099999	10558	5296	126	0	\N
15523	1467	22327583099999	10558	5296	127	0	\N
15524	1467	22327683099999	10618	5297	10	0	\N
15525	1467	23042323100000	10617	5484	2	0	\N
15526	1467	23042323100000	11098	5710	2	0	\N
15528	1467	23042343100000	10617	5484	3	0	\N
15529	1467	23042343100000	11098	5710	3	0	\N
15531	1467	23047683099999	10618	5297	36	0	\N
15532	1467	23762343100000	11300	5804	1	0	\N
15534	1467	23762353100000	11300	5804	2	0	\N
15536	1467	24482354100000	11381	5847	2	0	\N
15537	1467	24482354100000	11643	5992	1	0	\N
15538	1467	24482354100000	11726	6027	1	0	\N
15539	1467	24482354100000	11729	6029	1	0	\N
15540	1467	24482354100000	11833	6082	5	0	\N
15542	1467	24482355100000	11643	5992	2	0	\N
15543	1467	24482355100000	11726	6027	2	0	\N
15544	1467	24482355100000	11729	6029	2	0	\N
15546	1467	24482359100000	11833	6082	6	0	\N
15547	1467	24482365100000	11381	5847	3	0	\N
15548	1467	25202355100000	12299	6335	1	0	\N
15550	1467	25202356100000	12299	6335	2	0	\N
15554	1467	26642357100000	12411	6402	1	0	\N
15555	1467	26642357100000	12448	6416	0	0	\N
15556	1467	26642357100000	12544	6464	5	0	\N
15558	1467	26642358100000	12411	6402	2	0	\N
15560	1467	26642380100000	12544	6464	6	0	\N
15561	1467	27362368100000	12831	6619	1	0	\N
15563	1467	27362378100000	12831	6619	2	0	\N
15567	1467	28802455100000	13559	6974	3	0	\N
15568	1467	28802455100000	13596	6992	3	0	\N
15570	1467	28802467100000	13559	6974	4	0	\N
15571	1467	28802467100000	13596	6992	4	0	\N
15573	1467	29522581100000	13725	7054	5	0	\N
15576	1467	29522595100000	13725	7054	6	0	\N
15577	1468	290999959	26459	13060	119	0	\N
15578	1468	457000000	26459	13060	115	0	\N
15579	1468	720457000000	26459	13060	118	0	\N
15581	1470	720000000000	2275	1193	1	0	\N
15583	1470	720010000000	2275	1193	2	0	\N
15585	1471	20500	16871	8556	14	0	\N
15588	1471	1440010000000	695	387	1	0	\N
15590	1471	1440020000000	695	387	2	0	\N
15592	1471	2160040000000	1391	762	1	0	\N
15593	1471	2160040000000	1428	776	1	0	\N
15595	1471	2160050000000	1391	762	2	0	\N
15596	1471	2160050000000	1428	776	2	0	\N
15598	1471	2880050000000	2217	1167	1	0	\N
15599	1471	2880050000000	2650	1394	1	0	\N
15601	1471	2880060000000	2217	1167	2	0	\N
15602	1471	2880060000000	2650	1394	2	0	\N
15604	1471	3600060000000	3078	1600	1	0	\N
15606	1471	3600070000000	3078	1600	2	0	\N
15612	1471	4985167900000	21400	10735	11	0	\N
15614	1471	4985167900000	21874	10945	8	0	\N
15616	1471	4985202900000	21874	10945	9	0	\N
15617	1471	4985224900000	21400	10735	12	0	\N
15627	1471	6480100000000	4072	2117	1	0	\N
15628	1471	6480100000000	4400	2281	10	0	\N
15629	1471	6480100000000	4402	2281	10	0	\N
15631	1471	6480110000000	4072	2117	2	0	\N
15633	1471	6480200000000	4400	2281	11	0	\N
15634	1471	6480200000000	4402	2281	11	0	\N
15589	1471	1440010000000	1224	674	3	0	0
15591	1471	1440040000000	1224	674	4	0	0
15594	1471	2160040000000	1995	1054	1	0	0
15597	1471	2160050000000	1995	1054	2	0	0
15600	1471	2880050000000	2810	1469	1	0	0
15605	1471	3600060000000	3102	1610	1	0	0
15607	1471	3600070000000	3102	1610	2	0	0
15610	1471	4320070000000	3214	1671	1	0	0
15611	1471	4320080000000	3214	1671	2	0	0
15618	1471	5040080000000	3374	1756	2	0	0
15622	1471	5760100000000	3500	1817	0	0	0
15630	1471	6480100000000	4521	2339	1	0	0
15632	1471	6480110000000	4521	2339	2	0	0
15639	1471	7200110000000	4540	2348	1	0	0
15580	1470	4200000	5774	2994	3	1	0
15582	1470	720004200000	6672	3448	2	0	0
15584	1470	720024200000	6672	3448	3	0	0
15507	1467	20162223100000	10124	5252	2	0	0
15509	1467	20162243100000	10124	5252	3	0	0
15513	1467	20882263100000	10237	5297	3	0	0
15516	1467	21602263100000	10386	5370	2	0	0
15517	1467	21602283100000	10386	5370	3	0	0
15520	1467	22322283100000	10557	5451	4	0	0
15521	1467	22322323100000	10557	5451	5	0	0
15530	1467	23042343100000	11099	5710	3	0	0
15533	1467	23762343100000	11305	5806	2	0	0
15535	1467	23762354100000	11305	5806	3	0	0
15623	1471	6379493000000	12286	6326	1	0	4
15541	1467	24482354100000	12289	6328	1	0	0
15545	1467	24482355100000	12289	6328	2	0	0
15549	1467	25202355100000	12359	6373	1	0	0
15551	1467	25202356100000	12359	6373	2	0	0
15552	1467	25922356100000	12360	6374	1	0	0
15635	1471	7099494000000	12667	6534	3	0	4
15636	1471	7099506000000	12667	6534	4	0	4
15557	1467	26642357100000	12771	6586	2	0	0
15559	1467	26642368100000	12771	6586	3	0	0
15562	1467	27362368100000	12867	6635	8	0	0
15565	1467	28082412100000	13031	6718	7	0	0
15566	1467	28082455100000	13031	6718	8	0	0
15569	1467	28802455100000	13715	7048	9	0	0
15572	1467	28802581100000	13715	7048	10	0	0
15575	1467	29522594100000	13765	7072	5	0	0
15608	1471	4265155900000	21356	10719	3	0	8
15609	1471	4265167900000	21356	10719	4	0	8
15613	1471	4985167900000	21873	10945	8	0	8
15615	1471	4985202900000	21873	10945	9	0	8
15621	1471	5705215900000	22172	11092	5	0	8
15625	1471	6425215900000	22221	11123	5	0	8
15626	1471	6425220900000	22221	11123	6	0	8
15637	1471	7145220900000	22275	11150	6	0	8
15638	1471	7145244900000	22275	11150	7	0	8
15642	1471	7819506000000	12836	6620	1	0	\N
15643	1471	7819506000000	12838	6620	1	0	\N
15644	1471	7819516000000	12836	6620	2	0	\N
15647	1471	7920120000000	4871	2523	1	0	\N
15649	1471	7920130000000	4871	2523	2	0	\N
15653	1471	8585269900000	22653	11327	4	0	\N
15656	1471	8585282900000	22653	11327	5	0	\N
15659	1471	9259551900000	13242	6787	4	0	\N
15660	1471	9259551900000	13243	6821	4	0	\N
15662	1471	9259564900000	13243	6821	5	0	\N
15664	1471	9259591900000	13242	6787	5	0	\N
15667	1471	9305313900000	23695	11801	4	0	\N
15668	1471	9305313900000	23697	11801	4	0	\N
15669	1471	9360150000000	5501	2861	0	0	\N
15671	1471	9979575900000	13515	6906	3	0	\N
15672	1471	9979575900000	13516	6959	1	0	\N
15674	1471	9979575900000	14177	6948	0	0	\N
15675	1471	9979578900000	13515	6906	4	0	\N
15676	1471	9979585900000	13516	6959	2	0	\N
15678	1471	9979591900000	13253	6788	0	0	\N
15679	1471	10025291900000	23408	11679	2	0	\N
15680	1471	10025291900000	23717	11812	8	0	\N
15681	1471	10025291900000	23828	11847	1	0	\N
15682	1471	10025291900000	23829	11862	7	0	\N
15683	1471	10025291900000	23937	11913	4	0	\N
15684	1471	10025291900000	23939	11913	5	0	\N
15686	1471	10025302900000	23408	11679	3	0	\N
15688	1471	10025304900000	23937	11913	5	0	\N
15689	1471	10025305900000	23939	11913	6	0	\N
15690	1471	10025313900000	23695	11801	8	0	\N
15691	1471	10025313900000	23697	11801	8	0	\N
15692	1471	10025316900000	23695	11801	9	0	\N
15693	1471	10025316900000	23697	11801	9	0	\N
15694	1471	10025316900000	23829	11862	8	0	\N
15695	1471	10025317900000	23717	11812	9	0	\N
15696	1471	10025541900000	23828	11847	2	0	\N
15698	1471	10699578900000	13704	6907	15	0	\N
15701	1471	10699712900000	13704	6907	16	0	\N
15706	1471	11419598900000	14111	7213	4	0	\N
15709	1471	11419611900000	14111	7213	5	0	\N
15714	1471	12139608900000	14180	7238	6	0	\N
15717	1471	12139632900000	14180	7238	7	0	\N
15726	1471	12960310000000	6224	3221	1	0	\N
15728	1471	12960320000000	6224	3221	2	0	\N
15730	1471	13579641900000	14417	7355	3	0	\N
15733	1471	13579653900000	14417	7355	4	0	\N
15734	1471	13625410900000	25252	12526	10	0	\N
15737	1471	13625447900000	25252	12526	11	0	\N
15742	1471	14345423900000	25381	12583	3	0	\N
15744	1471	14345435900000	25381	12583	4	0	\N
15748	1471	15019664900000	14858	7572	2	0	\N
15749	1471	15019664900000	14923	7603	1	0	\N
15751	1471	15019674900000	14923	7603	2	0	\N
15752	1471	15019675900000	14858	7572	3	0	\N
15754	1471	15020396900000	16709	8426	63	0	\N
15759	1471	15739686900000	15962	8114	6	0	\N
15760	1471	15739686900000	16143	8206	3	0	\N
15761	1471	15739686900000	16530	8407	3	0	\N
15763	1471	15739698900000	16143	8206	4	0	\N
15764	1471	15739698900000	16530	8407	4	0	\N
15766	1471	15739710900000	15962	8114	7	0	\N
15767	1471	15740396900000	16709	8426	126	0	\N
15768	1471	15740708900000	17151	8601	101	0	\N
15769	1471	15740773900000	16709	8426	127	0	\N
15770	1471	15741493900000	16868	8427	63	0	\N
15775	1471	16459698900000	16870	8556	13	0	\N
15776	1471	16459698900000	16871	8556	13	0	\N
15657	1471	8640130000000	5273	2739	2	0	0
15658	1471	8640150000000	5273	2739	3	0	0
15670	1471	9360150000000	5574	2898	0	0	0
15697	1471	10080150000000	5722	2966	0	0	0
15704	1471	10800150000000	5954	3086	2	0	0
15712	1471	11520170000000	6064	3149	1	0	0
15713	1471	11520180000000	6064	3149	2	0	0
15720	1471	12240180000000	6107	3168	4	0	0
15721	1471	12240310000000	6107	3168	5	0	0
15727	1471	12960310000000	6329	3276	1	0	0
15738	1471	13680320000000	6504	3371	2	0	0
15739	1471	13680340000000	6504	3371	3	0	0
15746	1471	14400340000000	6799	3521	2	0	0
15747	1471	14400360000000	6799	3521	3	0	0
15758	1471	15120370000000	7783	4035	2	0	0
15773	1471	15840370000000	7924	4108	1	0	0
15774	1471	15840380000000	7924	4108	2	0	0
15641	1471	7819505900000	12837	6620	1	0	4
15651	1471	8539505900000	13162	6781	10	0	4
15661	1471	9259551900000	13254	6827	6	0	4
15663	1471	9259575900000	13254	6827	7	0	4
15673	1471	9979575900000	13517	6959	3	0	4
15677	1471	9979587900000	13517	6959	4	0	4
15699	1471	10699587900000	13705	7042	2	0	4
15707	1471	11419598900000	14113	7213	1	0	4
15708	1471	11419608900000	14113	7213	2	0	4
15715	1471	12139608900000	14185	7238	2	0	4
15716	1471	12139628900000	14185	7238	3	0	4
15723	1471	12859641900000	14264	7283	5	0	4
15731	1471	13579641900000	14748	7508	2	0	4
15732	1471	13579652900000	14748	7508	3	0	4
15740	1471	14299652900000	14809	7545	3	0	4
15741	1471	14299664900000	14809	7545	4	0	4
15753	1471	15019686900000	15209	7748	5	0	4
15762	1471	15739686900000	16708	8489	3	0	4
15765	1471	15739698900000	16708	8489	4	0	4
15645	1471	7865244900000	22471	11244	7	0	8
15646	1471	7865269900000	22471	11244	8	0	8
15655	1471	8585280900000	22715	11356	3	0	8
15665	1471	9305280900000	23348	11651	2	0	8
15666	1471	9305291900000	23348	11651	3	0	8
15685	1471	10025291900000	24094	11995	2	0	8
15702	1471	10745302900000	24213	12051	3	0	8
15703	1471	10745314900000	24213	12051	4	0	8
15710	1471	11465314900000	24677	12256	4	0	8
15711	1471	11465327900000	24677	12256	5	0	8
15718	1471	12185327900000	24744	12287	8	0	8
15724	1471	12905389900000	25035	12421	3	0	8
15725	1471	12905410900000	25035	12421	4	0	8
15735	1471	13625410900000	25292	12546	4	0	8
15736	1471	13625423900000	25292	12546	5	0	8
15743	1471	14345423900000	25611	12675	5	0	8
15755	1471	15065437900000	25720	12723	3	0	8
15756	1471	15065449900000	25720	12723	4	0	8
15771	1471	15785449900000	25897	12800	2	0	8
15772	1471	15785460900000	25897	12800	3	0	8
15779	1471	16459747900000	16870	8556	14	0	\N
15780	1471	16460708900000	17151	8601	126	0	\N
15781	1471	16460903900000	17151	8601	127	0	\N
15782	1471	16461493900000	16868	8427	126	0	\N
15783	1471	16461834900000	16868	8427	127	0	\N
15785	1471	16505460900000	25999	12849	5	0	\N
15786	1471	16505483900000	25999	12849	6	0	\N
15797	1471	17899778900000	17467	8845	2	0	\N
15798	1471	17899778900000	17468	8845	2	0	\N
15800	1471	17945484900000	26422	13072	3	0	\N
15802	1471	17945496900000	26422	13072	4	0	\N
15804	1471	18000400000000	8093	4196	1	0	\N
15806	1471	18000410000000	8093	4196	2	0	\N
15808	1471	18619778900000	17467	8845	13	0	\N
15809	1471	18619778900000	17468	8845	27	0	\N
15812	1471	18619860900000	17467	8845	14	0	\N
15813	1471	18619982900000	17468	8845	28	0	\N
15816	1471	18720410000000	8226	4264	1	0	\N
15817	1471	18720410000000	8511	4409	1	0	\N
15819	1471	18720420000000	8226	4264	2	0	\N
15820	1471	18720420000000	8511	4409	2	0	\N
15826	1471	19440430000000	8622	4470	1	0	\N
15828	1471	19440440000000	8622	4470	2	0	\N
15837	1471	20825531900000	28504	14086	3	0	\N
15839	1471	20825543900000	28504	14086	4	0	\N
15841	1471	20880450000000	9637	4997	4	0	\N
15842	1471	20880450000000	9640	5002	2	0	\N
15843	1471	20880450000000	9644	5002	0	0	\N
15845	1471	20880470000000	9640	5002	3	0	\N
15847	1471	20880490000000	9637	4997	5	0	\N
15850	1471	21499875900000	18594	9370	3	0	\N
15851	1471	21545543900000	28984	14243	60	0	\N
15852	1471	21545543900000	28985	14293	3	0	\N
15853	1471	21545543900000	28987	14293	3	0	\N
15854	1471	21545543900000	29219	14400	2	0	\N
15856	1471	21545554900000	29219	14400	3	0	\N
15857	1471	21545555899991	28987	14293	4	0	\N
15858	1471	21545555900000	28985	14293	4	0	\N
15860	1471	21545565900000	29292	14435	1	0	\N
15861	1471	21545565900000	29293	14435	1	0	\N
15862	1471	21545565900000	29295	14435	1	0	\N
15863	1471	21546224900000	28984	14243	61	0	\N
15864	1471	21600470000000	9841	5101	2	0	\N
15866	1471	21600490000000	9841	5101	3	0	\N
15868	1471	22219854900000	18403	9277	3	0	\N
15869	1471	22219854900000	18753	9453	4	0	\N
15872	1471	22219866900000	18403	9277	4	0	\N
15873	1471	22219875900000	18594	9370	6	0	\N
15874	1471	22219876900000	18753	9453	5	0	\N
15875	1471	22219877900000	18594	9370	7	0	\N
15876	1471	22265555900000	29721	14654	9	0	\N
15878	1471	22265565899999	29293	14435	4	0	\N
15879	1471	22265565900000	29292	14435	4	0	\N
15880	1471	22265565900000	29295	14435	4	0	\N
15881	1471	22265567899829	29293	14435	5	0	\N
15882	1471	22265567899879	29292	14435	5	1	\N
15883	1471	22265567900000	29295	14435	5	0	\N
15885	1471	22265622900000	29721	14654	10	0	\N
15886	1471	22320490000000	10065	5220	10	0	\N
15889	1471	22320590000000	10065	5220	11	0	\N
15890	1471	22939865900000	18928	9548	1	0	\N
15891	1471	22939865900000	19666	9907	10	0	\N
15893	1471	22939875900000	18928	9548	2	0	\N
15894	1471	22939947900000	19666	9907	11	0	\N
15896	1471	22985573900000	30068	14805	6	0	\N
15897	1471	22985573900000	30071	14805	11	0	\N
15898	1471	22985573900000	30291	14892	13	0	\N
15899	1471	22985588900000	30068	14805	7	0	\N
15900	1471	22985593900000	30071	14805	12	0	\N
15901	1471	22985604900000	30291	14892	14	0	\N
15902	1471	23040510000000	10667	5508	5	0	\N
15903	1471	23040510000000	10996	5666	2	0	\N
15906	1471	23040530000000	10996	5666	3	0	\N
15907	1471	23040560000000	10667	5508	6	0	\N
15910	1471	23760521000000	11303	5805	2	0	\N
15912	1471	23760532000000	11303	5805	3	0	\N
15793	1471	17280390000000	8087	4194	1	0	0
15794	1471	17280400000000	8087	4194	2	0	0
15805	1471	18000400000000	8201	4251	1	0	0
15807	1471	18000410000000	8201	4251	2	0	0
15818	1471	18720410000000	8571	4442	2	0	0
15827	1471	19440430000000	8623	4470	0	0	0
15833	1471	20160430000000	9208	4775	2	0	0
15834	1471	20160450000000	9208	4775	3	0	0
15844	1471	20880450000000	9792	5077	2	0	0
15846	1471	20880470000000	9792	5077	3	0	0
15867	1471	21600490000000	9991	5180	3	0	0
15887	1471	22320490000000	10397	5375	2	0	0
15888	1471	22320510000000	10397	5375	3	0	0
15904	1471	23040510000000	11291	5800	2	0	0
15911	1471	23760521000000	11517	5915	2	0	0
15777	1471	16459698900000	17149	8694	4	0	4
15778	1471	16459711900000	17149	8694	5	0	4
15789	1471	17179711900000	17305	8766	6	0	4
15790	1471	17179735900000	17305	8766	7	0	4
15796	1471	17899758900000	17409	8819	6	0	4
15799	1471	17899778900000	17469	8845	2	0	4
15810	1471	18619778900000	17469	8845	5	0	4
15811	1471	18619798900000	17469	8845	6	0	4
15822	1471	19339798900000	17661	8928	4	0	4
15829	1471	20059820900000	17679	8936	2	0	4
15830	1471	20059831900000	17679	8936	3	0	4
15835	1471	20779831900000	18239	9187	2	0	4
15836	1471	20779842900000	18239	9187	3	0	4
15849	1471	21499854900000	18398	9274	4	0	4
15870	1471	22219854900000	18770	9459	2	0	4
15871	1471	22219865900000	18770	9459	3	0	4
15892	1471	22939865900000	19866	10008	20	0	4
15895	1471	22939957900000	19866	10008	21	0	4
15909	1471	23660170900000	19912	10027	7	0	4
15784	1471	16505460900000	25998	12849	0	0	8
15791	1471	17225460900000	26151	12928	6	0	8
15792	1471	17225484900000	26151	12928	7	0	8
15801	1471	17945484900000	26552	13137	3	0	8
15814	1471	18665496900000	27593	13638	3	0	8
15815	1471	18665508900000	27593	13638	4	0	8
15824	1471	19385508900000	27786	13730	2	0	8
15825	1471	19385519900000	27786	13730	3	0	8
15832	1471	20105531900000	28198	13941	4	0	8
15838	1471	20825531900000	28688	14162	3	0	8
15840	1471	20825543900000	28688	14162	4	0	8
15855	1471	21545543900000	29220	14400	3	0	8
15859	1471	21545555900000	29220	14400	4	0	8
15884	1471	22265573900000	29854	14714	10	0	8
15914	1471	24380170900000	19973	10058	7	0	\N
15915	1471	24380170900000	20209	10178	3	0	\N
15917	1471	24380182900000	20209	10178	4	0	\N
15918	1471	24380195900000	19973	10058	8	0	\N
15922	1471	25100195900000	21168	10632	2	0	\N
15923	1471	25100206900000	21168	10632	3	0	\N
15924	1471	25200533000000	12018	6186	1	0	\N
15925	1471	25200534000000	12018	6186	2	0	\N
15926	1471	66001000000002	12838	6620	2	0	\N
15927	1472	720000000000	10729	5538	2	0	\N
15930	1472	720020000000	10729	5538	3	0	\N
15931	1472	1275011000000	12578	6303	0	0	\N
15932	1472	1440011000000	16758	8507	3	0	\N
15933	1472	1440014000000	16758	8507	4	0	\N
15934	1474	200000004	8785	4556	3	1	\N
15935	1474	200100034	5837	3029	7	0	\N
15936	1474	205000000	8786	4556	3	0	\N
15941	1474	2160020000000	98	60	1	0	\N
15943	1474	2160030000000	98	60	2	0	\N
15947	1474	2880030000000	139	82	2	0	\N
15948	1474	2880030000000	253	148	0	0	\N
15951	1474	2880050000000	139	82	3	0	\N
15952	1474	3070325000043	20563	10350	3	0	\N
15953	1474	3070325000043	20702	10411	8	0	\N
15954	1474	3070325000043	20774	10439	12	0	\N
15955	1474	3070325000043	20933	10525	2	0	\N
15957	1474	3070336000043	20933	10525	3	0	\N
15959	1474	3070337000043	20563	10350	4	0	\N
15960	1474	3070358000043	21592	10824	4	0	\N
15961	1474	3070360000043	20702	10411	9	0	\N
15962	1474	3070508000043	20774	10439	13	0	\N
15963	1474	3264354000023	11121	5718	2	0	\N
15966	1474	3264374000023	11121	5718	3	0	\N
15969	1474	3790336000043	21304	10696	3	0	\N
15970	1474	3790336000043	21750	10891	3	0	\N
15972	1474	3790348000043	21304	10696	4	0	\N
15973	1474	3790348000043	21750	10891	4	0	\N
15974	1474	3790358000043	21592	10824	8	0	\N
15975	1474	3790361000043	21592	10824	9	0	\N
15977	1474	3984365000023	11310	5809	3	0	\N
15978	1474	3984365000023	11766	6050	2	0	\N
15981	1474	3984376000023	11766	6050	3	0	\N
15982	1474	3984386000023	11310	5809	4	0	\N
15989	1474	5040060000000	1441	785	2	0	\N
15992	1474	5040080000000	1441	785	3	0	\N
16001	1474	6480080000000	2631	1384	2	0	\N
16004	1474	6480100000000	2631	1384	3	0	\N
16007	1474	6754358000023	12692	6545	2	0	\N
16008	1474	6754358000023	13064	6735	4	0	\N
16009	1474	6754358000023	13269	6835	3	0	\N
16011	1474	6754369000023	12692	6545	3	0	\N
16012	1474	6754370000023	13269	6835	4	0	\N
16013	1474	6754371000023	13064	6735	5	0	\N
16017	1474	7190463000043	23509	11718	3	0	\N
16018	1474	7190463000043	23573	11747	3	0	\N
16020	1474	7190475000043	23509	11718	4	0	\N
16021	1474	7190475000043	23573	11747	4	0	\N
16025	1474	7200090000000	2710	1424	1	0	\N
16026	1474	7200090000000	2713	1424	0	0	\N
16027	1474	7200100000000	2710	1424	2	0	\N
16028	1474	7385473000043	23097	11533	3	0	\N
16029	1474	7385473000043	23105	11539	3	0	\N
16030	1474	7385485000043	23097	11533	4	0	\N
16031	1474	7385485000043	23105	11539	4	0	\N
16032	1474	7390483000043	22652	11326	3	0	\N
16033	1474	7390483000043	22826	11415	7	0	\N
16034	1474	7390483000043	22916	11455	2	0	\N
16035	1474	7390485000043	22916	11455	3	0	\N
16036	1474	7390495000043	22652	11326	4	0	\N
16037	1474	7390517000043	22826	11415	8	0	\N
16039	1474	7474394000023	13838	7102	20	0	\N
16041	1474	7474432000023	13838	7102	21	0	\N
16042	1474	7830476000043	25104	12448	46	0	\N
16045	1474	7830648000043	25104	12448	47	0	\N
16046	1474	7830678000043	25109	12449	3	0	\N
16047	1474	7910475000043	24664	12250	4	0	\N
16048	1474	7910488000043	24664	12250	5	0	\N
15939	1474	1440010000000	35	21	1	0	0
15940	1474	1440020000000	35	21	2	0	0
15942	1474	2160020000000	122	72	1	0	0
15944	1474	2160030000000	122	72	2	0	0
15949	1474	2880030000000	480	268	1	0	0
15967	1474	3600040000000	1081	600	1	0	0
15968	1474	3600050000000	1081	600	2	0	0
15983	1474	4320050000000	1390	762	1	0	0
15984	1474	4320060000000	1390	762	2	0	0
15990	1474	5040060000000	1524	834	1	0	0
15997	1474	5760070000000	2129	1124	1	0	0
15998	1474	5760080000000	2129	1124	2	0	0
16002	1474	6480080000000	2632	1385	1	0	0
16003	1474	6480090000000	2632	1385	2	0	0
16024	1474	7194092000000	2895	1511	4	0	3
15945	1474	2544334000023	10977	5656	2	0	12
15946	1474	2544354000023	10977	5656	3	0	12
15964	1474	3264354000023	11298	5803	2	0	12
15965	1474	3264365000023	11298	5803	3	0	12
15929	1472	720011000000	11386	5848	3	0	0
15913	1471	23760532000000	11517	5915	3	0	0
15920	1471	24480532000000	11585	5958	1	0	0
15921	1471	24480533000000	11585	5958	2	0	0
15979	1474	3984365000023	11777	6055	1	0	12
15987	1474	4704366000023	12049	6202	1	0	12
15988	1474	4704367000023	12049	6202	2	0	12
15995	1474	5534357000023	12366	6377	1	0	13
15996	1474	5534358000023	12366	6377	2	0	13
16014	1474	6754394000023	13493	6948	10	0	13
16038	1474	7474394000023	13836	7103	3	0	13
16040	1474	7474406000023	13836	7103	4	0	13
15916	1471	24380170900000	20274	10210	7	0	4
15919	1471	24380195900000	20274	10210	8	0	4
15958	1474	3070336000043	21006	10562	3	0	26
15971	1474	3790336000043	21831	10926	9	0	26
15976	1474	3790372000043	21831	10926	10	0	26
15985	1474	4510372000043	22087	11042	7	0	26
15986	1474	4510397000043	22087	11042	8	0	26
15994	1474	5230434000043	22117	11061	11	0	26
15999	1474	5950434000043	22138	11073	6	0	26
16000	1474	5950458000043	22138	11073	7	0	26
16005	1474	6670458000043	22148	11079	7	0	26
16019	1474	7190463000043	23619	11766	3	0	28
16022	1474	7190475000043	23619	11766	4	0	28
16015	1474	7110465000043	25054	12431	2	0	29
16016	1474	7110476000043	25054	12431	3	0	29
16043	1474	7830476000043	25304	12554	3	0	29
16052	1474	7914213000000	4481	2321	1	0	\N
16057	1474	8550678000043	25109	12449	14	0	\N
16058	1474	8550697000043	25109	12449	15	0	\N
16059	1474	8634112000000	3034	1576	1	0	\N
16060	1474	8634112000000	3158	1641	1	0	\N
16061	1474	8634112000000	4111	2137	1	0	\N
16062	1474	8634113000000	4331	2244	1	0	\N
16063	1474	8634122000000	3034	1576	2	0	\N
16064	1474	8634122000000	3158	1641	2	0	\N
16065	1474	8634122000000	4111	2137	2	0	\N
16066	1474	8634123000000	4331	2244	2	0	\N
16068	1474	8634213000000	4481	2321	3	0	\N
16069	1474	8634223000000	4481	2321	4	0	\N
16073	1474	8915445000023	14263	7205	109	0	\N
16076	1474	9354233000000	4516	2336	1	0	\N
16078	1474	9354243000000	4516	2336	2	0	\N
16080	1474	9354253000000	5034	2612	1	0	\N
16081	1474	9354253000000	5036	2612	1	0	\N
16082	1474	9354343000000	5837	3029	1	0	\N
16083	1474	9354343000000	5839	3029	1	0	\N
16084	1474	9354343000000	5840	3029	1	0	\N
16088	1474	9635445000023	14263	7205	126	0	\N
16089	1474	9635461000023	14263	7205	127	0	\N
16090	1474	9635858000023	14304	7206	109	0	\N
16093	1474	10074243000000	5219	2714	2	0	\N
16094	1474	10074243000000	5444	2832	0	0	\N
16096	1474	10074253000000	5034	2612	2	0	\N
16097	1474	10074253000000	5036	2612	2	0	\N
16098	1474	10074263000000	5219	2714	3	0	\N
16100	1474	10074343000000	5837	3029	5	0	\N
16101	1474	10074343000000	5839	3029	5	0	\N
16102	1474	10074343000000	5840	3029	5	0	\N
16103	1474	10074463000000	5839	3029	6	0	\N
16104	1474	10074463000000	5840	3029	6	0	\N
16105	1474	10075283000000	7230	3616	93	0	\N
16106	1474	10075483000000	7078	3614	104	0	\N
16109	1474	10355858000023	14304	7206	126	0	\N
16110	1474	10355883000023	14304	7206	127	0	\N
16111	1474	10710536000043	25809	12761	4	0	\N
16114	1474	10710549000043	25809	12761	5	0	\N
16115	1474	10794263000000	6552	3395	2	0	\N
16116	1474	10794263000000	7077	3652	13	0	\N
16119	1474	10794283000000	6552	3395	3	0	\N
16120	1474	10794393000000	7077	3652	14	0	\N
16121	1474	10795283000000	7230	3616	116	0	\N
16122	1474	10795483000000	7078	3614	123	0	\N
16123	1474	10795683000000	7230	3616	117	0	\N
16124	1474	10795744000000	7078	3614	124	0	\N
16131	1474	11794422000023	16075	8172	7	0	\N
16132	1474	11794422000023	16469	8376	4	0	\N
16133	1474	11794435000023	16469	8376	5	0	\N
16134	1474	11794447000023	16075	8172	8	0	\N
16139	1474	12514422000023	16967	8598	6	0	\N
16140	1474	12514455000023	16967	8598	7	0	\N
16143	1474	13233412000023	17206	8718	3	0	\N
16145	1474	13233424000023	17206	8718	4	0	\N
16149	1474	13943374000023	18799	9472	3	0	\N
16150	1474	13943374000023	18933	9550	2	0	\N
16151	1474	13943385000023	18933	9550	3	0	\N
16152	1474	13943386000023	18799	9472	4	0	\N
16153	1474	13953424000023	17655	8924	4	0	\N
16154	1474	13953424000023	18115	9122	35	0	\N
16155	1474	13953424000023	18471	9307	3	0	\N
16156	1474	13953424000023	18646	9395	2	0	\N
16157	1474	13953435000023	18646	9395	3	0	\N
16158	1474	13953436000023	18471	9307	4	0	\N
16159	1474	13953446000023	17655	8924	5	0	\N
16160	1474	13953603000023	18115	9122	36	0	\N
16165	1474	14574303000000	8827	4577	6	0	\N
16168	1474	14574363000000	8827	4577	7	0	\N
16169	1474	14675313000000	8279	4288	2	0	\N
16170	1474	14675313000000	8785	4556	2	0	\N
16171	1474	14675313000000	8786	4556	2	0	\N
16172	1474	14675324000000	8279	4288	3	0	\N
16173	1474	15030619000043	26849	13280	3	0	\N
16174	1474	15030631000043	26849	13280	4	0	\N
16175	1474	15030631000043	27274	13480	6	0	\N
16178	1474	15030655000043	27274	13480	7	0	\N
16181	1474	15750643000043	27457	13570	3	0	\N
16182	1474	15750643000043	27547	13616	9	0	\N
16183	1474	15750643000043	27585	13633	4	0	\N
16184	1474	15750655000043	27457	13570	4	0	\N
16051	1474	7914213000000	4480	2321	1	0	3
16067	1474	8634213000000	4480	2321	4	0	3
16070	1474	8634233000000	4480	2321	5	0	3
16077	1474	9354233000000	4665	2412	1	0	3
16079	1474	9354243000000	4665	2412	2	0	3
16099	1474	10074263000000	6023	3125	3	0	3
16117	1474	10794263000000	7229	3737	1	0	3
16118	1474	10794273000000	7229	3737	2	0	3
16129	1474	11514273000000	7319	3783	1	0	3
16130	1474	11514283000000	7319	3783	2	0	3
16138	1474	12234293000000	7868	4078	2	0	3
16161	1474	13955293000000	8110	4205	2	0	3
16162	1474	13955313000000	8110	4205	3	0	3
16166	1474	14574303000000	8867	4595	2	0	4
16179	1474	15394323000000	9055	4694	5	0	4
16180	1474	15394364000000	9055	4694	6	0	4
16053	1474	8194406000023	13979	7162	4	0	13
16054	1474	8194437000023	13979	7162	5	0	13
16071	1474	8914437000023	14054	7195	8	0	13
16085	1474	9634463000023	14943	7611	2	0	13
16086	1474	9634474000023	14943	7611	3	0	13
16087	1474	9634497000023	15151	7723	5	0	13
16107	1474	10354497000023	15151	7723	7	0	13
16108	1474	10354498000023	15151	7723	8	0	13
16126	1474	11074532000023	15339	7817	8	0	13
16144	1474	13233412000023	17262	8743	3	0	15
16146	1474	13233424000023	17262	8743	4	0	15
16055	1474	8550488000043	25645	12691	6	0	29
16074	1474	9270512000043	25716	12721	3	0	29
16075	1474	9270524000043	25716	12721	4	0	29
16091	1474	9990524000043	25733	12732	3	0	29
16092	1474	9990536000043	25733	12732	4	0	29
16112	1474	10710536000043	26111	12904	2	0	29
16127	1474	11430547000043	26374	13045	6	0	29
16128	1474	11430571000043	26374	13045	7	0	29
16135	1474	12150571000043	26505	13112	3	0	29
16136	1474	12150583000043	26505	13112	4	0	29
16141	1474	12870583000043	26714	13213	6	0	29
16147	1474	13590607000043	26718	13215	3	0	29
16148	1474	13590619000043	26718	13215	4	0	29
16163	1474	14310619000043	26917	13312	3	0	29
16164	1474	14310631000043	26917	13312	4	0	29
16177	1474	15030643000043	27348	13521	4	0	29
16185	1474	15750665000043	27585	13633	5	0	\N
16186	1474	15750679000043	27547	13616	10	0	\N
16191	1474	16751365000023	19192	9683	7	0	\N
16192	1474	16751365000023	19642	9892	3	0	\N
16193	1474	16751365000023	20377	10265	3	0	\N
16194	1474	16751365000023	20421	10287	6	0	\N
16195	1474	16751377000023	19642	9892	4	0	\N
16196	1474	16751377000023	20377	10265	4	0	\N
16197	1474	16751389000023	20421	10287	7	0	\N
16198	1474	16751390000023	19192	9683	8	0	\N
16201	1474	17554304000000	9521	4937	6	0	\N
16202	1474	17554454000000	9521	4937	7	0	\N
16205	1474	18276394000000	9664	5015	3	0	\N
16206	1474	18276424000000	9664	5015	4	0	\N
16209	1474	25110643000043	27795	13736	3	0	\N
16210	1474	25110655000043	27795	13736	4	0	\N
16211	1474	25730643000043	28300	13989	2	0	\N
16213	1474	25730654000043	28300	13989	3	0	\N
16215	1474	25730701000043	28805	14209	5	0	\N
16216	1474	26450678000043	28923	14264	5	0	\N
16218	1474	26450701000043	28805	14209	7	0	\N
16219	1474	26450701000043	28923	14264	6	0	\N
16221	1474	26450702000043	28805	14209	8	0	\N
16224	1474	27890713000043	29272	14426	12	0	\N
16226	1474	27890761000043	29272	14426	13	0	\N
16228	1474	28610762000043	29644	14618	3	0	\N
16229	1474	28610762000043	29857	14715	7	0	\N
16230	1474	28610762000043	30027	14783	4	0	\N
16232	1474	28610774000043	29644	14618	4	0	\N
16233	1474	28610775000043	30027	14783	5	0	\N
16235	1474	28610778000043	29857	14715	8	0	\N
16237	1476	720000000000	10106	5243	2	0	\N
16239	1476	720000000000	20415	10285	10	0	\N
16240	1476	720000000000	20487	10316	6	0	\N
16241	1476	720000000000	20489	10316	4	0	\N
16242	1476	720000000000	20549	10345	0	0	\N
16244	1476	720004000000	20489	10316	5	0	\N
16248	1476	720020000000	10106	5243	3	0	\N
16249	1476	720024000000	20487	10316	7	0	\N
16250	1476	720028000000	20415	10285	11	0	\N
16252	1476	1440012000000	20825	10467	2	0	\N
16253	1476	1440012000000	20826	10467	3	0	\N
16255	1476	1440020000000	398	226	2	0	\N
16257	1476	1440023000000	20825	10467	3	0	\N
16258	1476	1440024000000	20826	10467	4	0	\N
16262	1476	1440040000000	398	226	3	0	\N
16263	1476	1441045000000	21836	10868	112	0	\N
16264	1476	2160024000000	21155	10624	2	0	\N
16265	1476	2160024000000	21215	10652	2	0	\N
16266	1476	2160024000000	21266	10679	4	0	\N
16267	1476	2160024000000	21267	10679	4	0	\N
16270	1476	2160030000000	10920	5633	1	0	\N
16271	1476	2160030000000	10922	5633	2	0	\N
16273	1476	2160035000000	21155	10624	3	0	\N
16274	1476	2160035000000	21215	10652	3	0	\N
16277	1476	2160040000000	10920	5633	2	0	\N
16278	1476	2160046000000	21266	10679	5	0	\N
16279	1476	2160046000000	21267	10679	5	0	\N
16280	1476	2160050000000	10922	5633	3	0	\N
16282	1476	2161045000000	21836	10868	119	0	\N
16283	1476	2880036000000	22368	11196	7	0	\N
16290	1476	2880061000000	22368	11196	8	0	\N
16292	1476	3600050000000	856	475	3	0	\N
16294	1476	3600052000000	11589	5961	1	0	\N
16295	1476	3600052000000	11650	5993	2	0	\N
16297	1476	3600053000000	11589	5961	2	0	\N
16299	1476	3600054000000	11650	5993	3	0	\N
16302	1476	3600080000000	856	475	4	0	\N
16303	1476	4320053000000	11757	6044	1	0	\N
16304	1476	4320053000000	11846	6091	1	0	\N
16306	1476	4320054000000	11757	6044	2	0	\N
16307	1476	4320054000000	11846	6091	2	0	\N
16310	1476	4320062000000	22976	11477	2	0	\N
16312	1476	4320073000000	22976	11477	3	0	\N
16320	1476	5760055000000	12524	6454	6	0	\N
16256	1476	1440020000000	556	314	1	0	0
16260	1476	1440030000000	556	314	2	0	0
16269	1476	2160030000000	597	339	1	0	0
16276	1476	2160040000000	597	339	2	0	0
16285	1476	2880040000000	643	360	1	0	0
16293	1476	3600050000000	1135	627	2	0	0
16301	1476	3600070000000	1135	627	3	0	0
16311	1476	4320070000000	1437	783	2	0	0
16314	1476	4320090000000	1437	783	3	0	0
16317	1476	5040090000000	1598	866	1	0	0
16189	1474	16114364000000	9073	4705	2	0	4
16190	1474	16114384000000	9073	4705	3	0	4
16199	1474	16834384000000	9230	4783	3	0	4
16200	1474	16834414000000	9230	4783	4	0	4
16204	1474	17556394000000	9620	4990	10	0	6
16238	1476	720000000000	10402	5378	1	0	5
16245	1476	720010000000	10402	5378	2	0	5
16251	1476	1440010000000	10619	5484	2	0	5
16261	1476	1440030000000	10619	5484	3	0	5
16281	1476	2160050000000	11134	5723	3	0	5
16288	1476	2880050000000	11576	5952	2	0	5
16289	1476	2880052000000	11576	5952	3	0	5
16296	1476	3600052000000	11672	5999	1	0	5
16298	1476	3600053000000	11672	5999	2	0	5
16308	1476	4320055000000	11956	6154	3	0	5
16315	1476	5040055000000	12473	6427	0	0	5
16187	1474	16031354000023	19129	9648	2	0	22
16188	1474	16031365000023	19129	9648	3	0	22
16246	1476	720012000000	20715	10416	4	0	11
16254	1476	1440012000000	20985	10555	3	0	11
16259	1476	1440024000000	20985	10555	4	0	11
16268	1476	2160024000000	21837	10929	3	0	11
16275	1476	2160036000000	21837	10929	4	0	11
16286	1476	2880049000000	22413	11219	5	0	11
16291	1476	3600049000000	22741	11371	4	0	11
16300	1476	3600062000000	22741	11371	5	0	11
16309	1476	4320062000000	22975	11477	3	0	11
16313	1476	4320074000000	22975	11477	4	0	11
16318	1476	5040098000000	23062	11515	7	0	11
16207	1474	25010633000043	28129	13904	1	0	30
16208	1474	25010643000043	28129	13904	2	0	30
16212	1474	25730643000043	28777	14195	8	0	30
16217	1474	26450678000043	28967	14285	5	0	30
16220	1474	26450701000043	28967	14285	6	0	30
16222	1474	27170701000043	29178	14385	3	0	30
16223	1474	27170713000043	29178	14385	4	0	30
16225	1474	27890713000043	29626	14610	13	0	30
16231	1474	28610762000043	30275	14886	4	0	30
16234	1474	28610775000043	30275	14886	5	0	30
16323	1476	5760088000000	12524	6454	7	0	\N
16325	1476	5760100000000	1754	939	1	0	\N
16326	1476	5760100000000	1830	978	1	0	\N
16328	1476	5760110000000	1754	939	2	0	\N
16329	1476	5760110000000	1830	978	2	0	\N
16335	1476	6480120000000	1997	1055	2	0	\N
16338	1476	6480140000000	1997	1055	3	0	\N
16340	1476	6481000000000	3369	1703	59	0	\N
16342	1476	7200088000000	13548	6971	3	0	\N
16344	1476	7200100000000	13548	6971	4	0	\N
16346	1476	7200140000000	2451	1282	1	0	\N
16347	1476	7200140000000	3055	1588	1	0	\N
16350	1476	7200150000000	2451	1282	2	0	\N
16351	1476	7200150000000	3055	1588	2	0	\N
16353	1476	7201000000000	3369	1703	61	0	\N
16354	1476	7201010000000	3369	1703	62	0	\N
16356	1476	7920098000000	14013	7182	2	0	\N
16357	1476	7920109000000	14013	7182	3	0	\N
16361	1476	7920160000000	3540	1838	0	0	\N
16365	1476	7920190000000	23818	11856	2	0	\N
16368	1476	8640160000000	3584	1862	0	0	\N
16369	1476	8640160000000	3597	1869	0	0	\N
16373	1476	8640190000000	23818	11856	7	0	\N
16375	1476	8640194000000	23818	11856	8	0	\N
16384	1476	10080190000000	4388	2223	77	0	\N
16386	1476	10080207000000	24376	12123	3	0	\N
16387	1476	10080207000000	24378	12116	30	0	\N
16388	1476	10080207000000	24468	12168	3	0	\N
16389	1476	10080207000000	24469	12168	2	0	\N
16391	1476	10080218000000	24469	12168	3	0	\N
16393	1476	10080219000000	24468	12168	4	0	\N
16394	1476	10080318000000	24376	12123	4	0	\N
16395	1476	10080642000000	24378	12116	31	0	\N
16396	1476	10081410000000	4388	2223	78	0	\N
16399	1476	10800200000000	4497	2328	5	0	\N
16402	1476	10800218000000	24714	12274	7	0	\N
16403	1476	10800218000000	24934	12377	3	0	\N
16405	1476	10800230000000	24934	12377	4	0	\N
16407	1476	10800270000000	24714	12274	8	0	\N
16408	1476	10800340000000	4497	2328	6	0	\N
16415	1476	12240179000000	15407	7849	4	0	\N
16416	1476	12240179000000	15589	7936	6	0	\N
16417	1476	12240179000000	16153	8211	3	0	\N
16418	1476	12240179000000	16159	8213	3	0	\N
16420	1476	12240191000000	16153	8211	4	0	\N
16421	1476	12240191000000	16159	8213	4	0	\N
16423	1476	12240210000000	15407	7849	5	0	\N
16424	1476	12240212000000	15589	7936	7	0	\N
16425	1476	12240230000000	5302	2755	1	0	\N
16426	1476	12240230000000	5887	3052	0	0	\N
16428	1476	12240230000000	6228	3213	20	0	\N
16429	1476	12240240000000	5302	2755	2	0	\N
16430	1476	12240243000000	25519	12635	3	0	\N
16434	1476	12240255000000	25519	12635	4	0	\N
16435	1476	12240261000000	16240	8244	7	0	\N
16436	1476	12240790000000	6228	3213	21	0	\N
16437	1476	12960191000000	16237	8254	5	0	\N
16440	1476	12960210000000	16237	8254	6	0	\N
16441	1476	12960244000000	26017	12859	0	0	\N
16442	1476	12960244000000	26018	12859	3	0	\N
16443	1476	12960244000000	26019	12859	1	0	\N
16444	1476	12960244000000	26138	12921	2	0	\N
16446	1476	12960245000000	26019	12859	2	0	\N
16448	1476	12960255000000	26138	12921	3	0	\N
16449	1476	12960256000000	26018	12859	4	0	\N
16451	1476	12960261000000	16240	8244	29	0	\N
16453	1476	12960346000000	16240	8244	30	0	\N
16454	1476	13680203000000	16803	8528	3	0	\N
16455	1476	13680203000000	17018	8621	3	0	\N
16336	1476	6480120000000	2233	1177	2	0	0
16339	1476	6480140000000	2233	1177	3	0	0
16348	1476	7200140000000	3370	1753	2	0	0
16352	1476	7200160000000	3370	1753	3	0	0
16362	1476	7920160000000	3548	1841	0	0	0
16371	1476	8640180000000	3978	2066	3	0	0
16377	1476	9360180000000	4077	2119	1	0	0
16378	1476	9360190000000	4077	2119	2	0	0
16383	1476	10080190000000	4387	2275	1	0	0
16385	1476	10080200000000	4387	2275	2	0	0
16401	1476	10800210000000	5151	2671	2	0	0
16411	1476	11520210000000	5263	2732	2	0	0
16412	1476	11520230000000	5263	2732	3	0	0
16427	1476	12240230000000	6227	3222	2	0	0
16447	1476	12960250000000	6356	3289	2	0	0
16452	1476	12960270000000	6356	3289	3	0	0
16321	1476	5760055000000	12977	6691	3	0	5
16322	1476	5760076000000	12977	6691	4	0	5
16332	1476	6480076000000	13013	6708	3	0	5
16341	1476	7200088000000	13547	6971	1	0	5
16343	1476	7200098000000	13547	6971	2	0	5
16355	1476	7920098000000	14012	7182	5	0	5
16358	1476	7920112000000	14012	7182	6	0	5
16359	1476	7920129000000	14186	7239	8	0	5
16367	1476	8640155000000	14356	7329	8	0	5
16376	1476	9360155000000	14356	7329	9	0	5
16381	1476	10080155000000	14953	7616	3	0	5
16382	1476	10080167000000	14953	7616	4	0	5
16398	1476	10800168000000	15094	7691	2	0	5
16409	1476	11520168000000	15400	7844	2	0	5
16410	1476	11520179000000	15400	7844	3	0	5
16419	1476	12240179000000	16167	8219	3	0	5
16422	1476	12240191000000	16167	8219	4	0	5
16439	1476	12960203000000	16285	8275	4	0	5
16456	1476	13680203000000	17120	8674	2	0	5
16324	1476	5760098000000	23143	11556	3	0	11
16330	1476	5760110000000	23143	11556	4	0	11
16334	1476	6480110000000	23283	11617	2	0	11
16345	1476	7200121000000	23568	11745	6	0	11
16349	1476	7200145000000	23568	11745	7	0	11
16360	1476	7920145000000	23773	11838	7	0	11
16363	1476	7920170000000	23773	11838	8	0	11
16372	1476	8640190000000	23817	11856	7	0	11
16374	1476	8640194000000	23817	11856	8	0	11
16379	1476	9360194000000	24270	12075	4	0	11
16380	1476	9360207000000	24270	12075	5	0	11
16390	1476	10080207000000	24605	12230	2	0	11
16404	1476	10800218000000	25222	12512	4	0	11
16406	1476	10800231000000	25222	12512	5	0	11
16413	1476	11520231000000	25326	12562	3	0	11
16414	1476	11520243000000	25326	12562	4	0	11
16431	1476	12240243000000	25522	12635	1	0	11
16445	1476	12960244000000	26188	12946	4	0	11
16450	1476	12960257000000	26188	12946	5	0	11
16458	1476	13680215000000	16803	8528	4	0	\N
16459	1476	13680215000000	17018	8621	4	0	\N
16466	1476	14400280000000	6519	3379	2	0	\N
16469	1476	14400300000000	6519	3379	3	0	\N
16472	1476	15120239000000	17255	8740	3	0	\N
16475	1476	15120251000000	17255	8740	4	0	\N
16480	1476	15120938000000	26709	13163	58	0	\N
16487	1476	15840938000000	26709	13163	126	0	\N
16488	1476	15841096000000	26709	13163	127	0	\N
16493	1476	16560383000000	26908	13308	3	0	\N
16494	1476	16560383000000	26962	13335	5	0	\N
16496	1476	16560395000000	26908	13308	4	0	\N
16498	1476	16560406000000	26962	13335	6	0	\N
16499	1476	17280304000000	17813	8997	3	0	\N
16500	1476	17280304000000	18058	9108	6	0	\N
16502	1476	17280307000000	17813	8997	4	0	\N
16504	1476	17280330000000	7643	3954	9	0	\N
16505	1476	17280330000000	7931	4111	1	0	\N
16506	1476	17280330000000	7933	4109	4	0	\N
16507	1476	17280330000000	8261	4277	2	0	\N
16509	1476	17280337000000	18058	9108	7	0	\N
16510	1476	17280340000000	7931	4111	2	0	\N
16511	1476	17280350000000	8261	4277	3	0	\N
16513	1476	17280370000000	7933	4109	5	0	\N
16514	1476	17280395000000	27809	13740	6	0	\N
16515	1476	17280395000000	27874	13781	3	0	\N
16516	1476	17280395000000	27935	13818	7	0	\N
16517	1476	17280395000000	28097	13889	4	0	\N
16519	1476	17280407000000	27874	13781	4	0	\N
16520	1476	17280408000000	28097	13889	5	0	\N
16522	1476	17280419000000	27809	13740	7	0	\N
16523	1476	17280420000000	7643	3954	10	0	\N
16524	1476	17280420000000	27935	13818	8	0	\N
16525	1476	18000327000000	18438	9294	2	0	\N
16526	1476	18000327000000	18440	9294	3	0	\N
16528	1476	18000329000000	18438	9294	3	0	\N
16529	1476	18000339000000	18440	9294	4	0	\N
16531	1476	18000350000000	8715	4520	2	0	\N
16533	1476	18000370000000	8715	4520	3	0	\N
16535	1476	18000416000000	28227	13956	2	0	\N
16537	1476	18000427000000	28227	13956	3	0	\N
16539	1476	18000524000000	18699	9410	32	0	\N
16540	1476	18720339000000	18647	9396	5	0	\N
16543	1476	18720362000000	18647	9396	6	0	\N
16548	1476	18720524000000	18699	9410	38	0	\N
16549	1476	18720529000000	18699	9410	39	0	\N
16554	1476	20160361000000	19385	9770	4	0	\N
16555	1476	20160361000000	19439	9797	18	0	\N
16557	1476	20160361000000	19782	9957	0	0	\N
16558	1476	20160374000000	19385	9770	5	0	\N
16560	1476	20160424000000	19439	9797	19	0	\N
16563	1476	20880397000000	19829	9989	3	0	\N
16564	1476	20880397000000	20095	10115	17	0	\N
16565	1476	20880400000000	19829	9989	4	0	\N
16566	1476	20880474000000	29256	14419	3	0	\N
16568	1476	20880486000000	29256	14419	4	0	\N
16570	1476	20880531000000	20095	10115	18	0	\N
16571	1476	21600492175114	29981	14764	9	0	\N
16573	1476	21600510175105	29981	14764	10	0	\N
16575	1476	21600549175105	30112	14820	11	0	\N
16576	1476	21600549175105	30115	14820	11	0	\N
16577	1476	22320549175105	30112	14820	31	0	\N
16578	1476	22320549175105	30115	14820	53	0	\N
16579	1476	22320568175105	30112	14820	32	0	\N
16580	1476	22320590175105	30115	14820	54	0	\N
16581	1476	66000007920000	21836	10868	120	1	\N
16582	1479	720000000000	11172	5741	4	0	\N
16583	1479	720040000000	11172	5741	5	0	\N
16587	1480	2140909000000	20708	10144	0	0	\N
16588	1480	2140909000000	20709	10160	0	0	\N
16590	1480	2860920000000	23631	11773	2	0	\N
16591	1480	2860920000000	23632	11773	3	0	\N
16592	1480	2860931000000	23631	11773	3	0	\N
16467	1476	14400280000000	7234	3739	1	0	0
16468	1476	14400290000000	7234	3739	2	0	0
16476	1476	15120290000000	7249	3748	2	0	0
16477	1476	15120310000000	7249	3748	3	0	0
16483	1476	15840310000000	7399	3822	1	0	0
16584	1480	720000000000	7480	3869	0	0	0
16491	1476	16560320000000	7635	3952	1	0	0
16492	1476	16560330000000	7635	3952	2	0	0
16508	1476	17280330000000	8295	4295	2	0	0
16512	1476	17280350000000	8295	4295	3	0	0
16534	1476	18000370000000	9002	4667	3	0	0
16544	1476	18720370000000	9303	4827	2	0	0
16545	1476	18720390000000	9303	4827	3	0	0
16585	1480	1420909000000	12434	6410	0	0	19
16464	1476	14400214000000	17240	8734	7	0	5
16465	1476	14400239000000	17240	8734	8	0	5
16473	1476	15120239000000	17257	8740	1	0	5
16474	1476	15120240000000	17257	8740	2	0	5
16481	1476	15840240000000	17419	8824	2	0	5
16489	1476	16560242000000	17455	8840	8	0	5
16490	1476	16560304000000	17455	8840	9	0	5
16501	1476	17280304000000	18352	9247	5	0	5
16503	1476	17280327000000	18352	9247	6	0	5
16527	1476	18000327000000	18624	9384	3	0	5
16541	1476	18720339000000	18698	9418	3	0	5
16542	1476	18720351000000	18698	9418	4	0	5
16550	1476	19440351000000	18924	9546	1	0	5
16551	1476	19440361000000	18924	9546	2	0	5
16559	1476	20160397000000	19781	9961	10	0	5
16586	1480	2140909000000	20706	10414	2	0	19
16589	1480	2140920000000	20706	10414	3	0	19
16460	1476	13680257000000	26414	13068	18	0	11
16463	1476	13680320000000	26414	13068	19	0	11
16471	1476	14400345000000	26499	13108	8	0	11
16478	1476	15120345000000	26592	13157	4	0	11
16479	1476	15120358000000	26592	13157	5	0	11
16485	1476	15840358000000	26708	13210	7	0	11
16486	1476	15840383000000	26708	13210	8	0	11
16497	1476	16560395000000	27277	13482	4	0	11
16518	1476	17280395000000	28215	13951	3	0	11
16521	1476	17280416000000	28215	13951	4	0	11
16536	1476	18000416000000	28288	13984	2	0	11
16546	1476	18720427000000	28634	14139	6	0	11
16547	1476	18720451000000	28634	14139	7	0	11
16552	1476	19440451000000	28938	14272	3	0	11
16553	1476	19440463000000	28938	14272	4	0	11
16561	1476	20160463000000	29087	14339	2	0	11
16567	1476	20880474000000	29818	14692	10	0	11
16569	1476	20880492175114	29818	14692	12	0	11
16572	1476	21600492175114	29982	14764	10	0	11
16574	1476	21600511175105	29982	14764	11	0	11
16593	1480	2860932000000	23632	11773	4	0	\N
16600	1485	38000000000	11661	5908	0	0	\N
16601	1485	2494640999000	11279	5652	47	0	\N
16602	1485	78486131570430	11033	5607	100	0	\N
16603	1486	720000000000	1445	785	2	0	\N
16604	1486	720020000000	1445	785	3	0	\N
16605	1489	175000	26129	12917	3	1	\N
16608	1489	1440010000000	191	113	1	0	\N
16609	1489	1440010000000	1090	604	9	0	\N
16610	1489	1440010000000	1091	604	8	0	\N
16611	1489	1440010000000	1321	727	5	0	\N
16613	1489	1440020000000	191	113	2	0	\N
16615	1489	1440060000000	1321	727	6	0	\N
16616	1489	1440090000000	1091	604	9	0	\N
16617	1489	1440100000000	1090	604	10	0	\N
16618	1489	2160030000000	1622	876	1	0	\N
16619	1489	2160030000000	1847	986	1	0	\N
16620	1489	2160030000000	1853	988	1	0	\N
16622	1489	2160040000000	1622	876	2	0	\N
16623	1489	2160040000000	1847	986	2	0	\N
16624	1489	2160040000000	1853	988	2	0	\N
16626	1489	2880040000000	1932	1028	1	0	\N
16627	1489	2880040000000	1935	1027	3	0	\N
16629	1489	2880050000000	1932	1028	2	0	\N
16631	1489	2880070000000	1935	1027	4	0	\N
16632	1489	3600050000000	2091	1105	1	0	\N
16634	1489	3600060000000	2091	1105	2	0	\N
16640	1489	5040121000000	3702	1922	3	0	\N
16642	1489	5760100000000	3242	1683	3	0	\N
16643	1489	5760100000000	3255	1691	2	0	\N
16644	1489	5760100000000	3313	1719	2	0	\N
16645	1489	5760100000000	3611	1873	0	0	\N
16646	1489	5760100000000	3654	1897	0	0	\N
16647	1489	5760120000000	3255	1691	3	0	\N
16648	1489	5760121000000	3702	1922	4	0	\N
16650	1489	5760130000000	3242	1683	4	0	\N
16651	1489	5760210000000	3313	1719	3	0	\N
16652	1489	6480121000000	4157	2162	2	0	\N
16653	1489	6480121000000	4382	2273	1	0	\N
16655	1489	6480131000000	4382	2273	2	0	\N
16657	1489	6480231000000	4157	2162	3	0	\N
16660	1489	7200161000000	4740	2452	2	0	\N
16661	1489	7200161000000	4742	2438	23	0	\N
16664	1489	7200181000000	4740	2452	3	0	\N
16665	1489	7200391000000	4742	2438	24	0	\N
16666	1489	7584336040000	24643	12115	65	0	\N
16667	1489	7823899000000	14554	7423	3	0	\N
16668	1489	7823899000000	14563	7427	2	0	\N
16669	1489	7823899000000	15071	7674	1	0	\N
16671	1489	7823909000000	15071	7674	2	0	\N
16672	1489	7823910000000	14563	7427	3	0	\N
16673	1489	7823911000000	14554	7423	4	0	\N
16677	1489	8303053450000	24642	12242	8	0	\N
16678	1489	8303056040000	24349	12110	6	0	\N
16679	1489	8303056040000	24641	12242	8	0	\N
16681	1489	8303056040000	25445	12605	3	0	\N
16683	1489	8303068040000	25445	12605	4	0	\N
16684	1489	8303080040000	24349	12110	7	0	\N
16685	1489	8303118040000	24641	12242	9	0	\N
16686	1489	8304336040000	24643	12115	126	0	\N
16687	1489	8304936040000	24643	12115	127	0	\N
16688	1489	8543931000000	15226	7756	3	0	\N
16690	1489	8543943000000	15226	7756	4	0	\N
16694	1489	9023067040000	25450	12608	3	0	\N
16696	1489	9023079040000	25450	12608	4	0	\N
16700	1489	9263965000000	15864	8068	4	0	\N
16704	1489	9983955000000	15838	8058	2	0	\N
16705	1489	9983955000000	15840	8058	3	0	\N
16707	1489	9983966000000	15838	8058	3	0	\N
16708	1489	9983967000000	15840	8058	4	0	\N
16710	1489	10080191000000	5577	2900	0	0	\N
16715	1489	10703979000000	16206	8235	6	0	\N
16716	1489	10703979000000	16207	8235	3	0	\N
16719	1489	10704000000000	16207	8235	4	0	\N
16720	1489	10704012000000	16206	8235	7	0	\N
16721	1489	10800201000000	6598	3413	4	0	\N
16722	1489	10800201000000	6601	3328	2	0	\N
16724	1489	10800203000000	6601	3328	3	0	\N
16726	1489	10800241000000	6598	3413	5	0	\N
16727	1489	11183105040000	26128	12917	2	0	\N
16728	1489	11183105040000	26129	12917	2	0	\N
16594	1482	720000000000	502	281	2	0	0
16595	1482	720020000000	502	281	3	0	0
16612	1489	1440010000000	1466	799	2	0	0
16614	1489	1440030000000	1466	799	3	0	0
16621	1489	2160030000000	1854	988	1	0	0
16628	1489	2880040000000	1978	1045	1	0	0
16630	1489	2880050000000	1978	1045	2	0	0
16633	1489	3600050000000	2147	1134	2	0	0
16635	1489	3600070000000	2147	1134	3	0	0
16636	1489	4320070000000	2348	1228	1	0	0
16638	1489	5040080000000	2668	1402	2	0	0
16639	1489	5040100000000	2668	1402	3	0	0
16596	1482	1440020000000	2769	1447	1	0	0
16597	1482	1440030000000	2769	1447	2	0	0
16649	1489	5760121000000	3703	1922	4	0	0
16654	1489	6480121000000	4590	2373	4	0	0
16656	1489	6480161000000	4590	2373	5	0	0
16662	1489	7200161000000	4943	2560	1	0	0
16663	1489	7200171000000	4943	2560	2	0	0
16676	1489	7920181000000	5029	2610	2	0	0
16692	1489	8640181000000	5356	2780	1	0	0
16693	1489	8640191000000	5356	2780	2	0	0
16701	1489	9360191000000	5468	2848	0	0	0
16711	1489	10080191000000	6286	3256	1	0	0
16723	1489	10800201000000	6610	3419	2	0	0
16725	1489	10800221000000	6610	3419	3	0	0
16658	1489	7103887000000	14443	7371	3	0	4
16659	1489	7103899000000	14443	7371	4	0	4
16674	1489	7823931000000	15129	7711	6	0	4
16689	1489	8543931000000	15385	7837	3	0	4
16691	1489	8543943000000	15385	7837	4	0	4
16698	1489	9263943000000	15728	7997	3	0	4
16699	1489	9263955000000	15728	7997	4	0	4
16709	1489	9983979000000	15943	8105	7	0	4
16717	1489	10703979000000	16495	8389	4	0	4
16718	1489	10703992000000	16495	8389	5	0	4
16680	1489	8303056040000	25444	12605	2	0	10
16682	1489	8303067040000	25444	12605	3	0	10
16697	1489	9023080040000	25451	12608	5	0	10
16702	1489	9743080040000	25557	12654	3	0	10
16703	1489	9743092040000	25557	12654	4	0	10
16713	1489	10463092040000	25832	12774	4	0	10
16598	1482	2160030000000	28851	14229	6	0	0
16599	1482	2160054000000	28851	14229	7	0	0
16730	1489	11183116040000	26128	12917	3	0	\N
16734	1489	11424235000000	17027	8592	23	0	\N
16735	1489	11520203000000	6613	3329	0	0	\N
16737	1489	11520221000000	6771	3485	0	0	\N
16743	1489	12144235000000	17027	8592	110	0	\N
16744	1489	12144528000000	17027	8592	111	0	\N
16745	1489	12144918000000	17086	8593	39	0	\N
16752	1489	12864918000000	17086	8593	126	0	\N
16753	1489	12865040000000	17086	8593	127	0	\N
16754	1489	12960261000000	7061	3646	0	0	\N
16757	1489	13343155040000	26913	13310	3	0	\N
16759	1489	13343167040000	26913	13310	4	0	\N
16762	1489	13584041000000	17096	8663	5	0	\N
16766	1489	13584064000000	17096	8663	6	0	\N
16767	1489	13585040000000	17098	8594	30	0	\N
16768	1489	13585142000000	17098	8594	31	0	\N
16769	1489	13585212000000	17127	8595	7	0	\N
16772	1489	14063179040000	27278	13482	3	0	\N
16773	1489	14063191040000	27278	13482	4	0	\N
16778	1489	14305212000000	17127	8595	36	0	\N
16779	1489	14305312000000	17127	8595	37	0	\N
16780	1489	14400531000000	7617	3941	0	0	\N
16783	1489	14783233040000	27544	13615	4	0	\N
16784	1489	14783233040000	27612	13647	3	0	\N
16785	1489	14783233040000	27802	13738	3	0	\N
16787	1489	14783245040000	27612	13647	4	0	\N
16788	1489	14783245040000	27802	13738	4	0	\N
16789	1489	14783255040000	27544	13615	5	0	\N
16798	1489	15506290040000	28696	14167	3	0	\N
16799	1489	15506302040000	28696	14167	4	0	\N
16800	1489	15744398000000	18132	9143	3	0	\N
16803	1489	15744410000000	18132	9143	4	0	\N
16806	1489	16223290040000	28697	14167	3	0	\N
16808	1489	16223302040000	28697	14167	4	0	\N
16811	1489	16464409000000	18439	9294	2	0	\N
16812	1489	16464411000000	18439	9294	3	0	\N
16816	1489	16943302040000	28798	14207	3	0	\N
16818	1489	16943305040000	28798	14207	4	0	\N
16820	1489	17184421000000	18535	9338	3	0	\N
16822	1489	17184433000000	18535	9338	4	0	\N
16828	1489	17663346040000	30223	14735	105	1	\N
16830	1489	17904441000000	19207	9690	2	0	\N
16831	1489	17904452000000	19207	9690	3	0	\N
16835	1489	18624453000000	19214	9694	20	0	\N
16836	1489	18624453000000	19215	9694	14	0	\N
16839	1489	18624521000000	19215	9694	15	0	\N
16840	1489	18624527000000	19214	9694	21	0	\N
16841	1489	18720611000000	9053	4693	2	0	\N
16843	1489	18720631000000	9053	4693	3	0	\N
16845	1489	19344477000000	19375	9768	3	0	\N
16847	1489	19344489000000	19375	9768	4	0	\N
16851	1489	19440711000000	9180	4757	4	0	\N
16852	1489	20064493000000	19615	9880	9	0	\N
16853	1489	20064493000000	19668	9907	10	0	\N
16854	1489	20064493000000	20063	10101	3	0	\N
16855	1489	20064493000000	20085	10110	8	0	\N
16857	1489	20064505000000	20063	10101	4	0	\N
16858	1489	20064529000000	19615	9880	10	0	\N
16860	1489	20064556000000	20085	10110	9	0	\N
16861	1489	20064575000000	19668	9907	11	0	\N
16864	1489	20160711000000	9180	4757	7	0	\N
16746	1489	12240241000000	7013	3616	2	0	0
16747	1489	12240261000000	7013	3616	3	0	0
16755	1489	12960261000000	7062	3646	2	0	0
16756	1489	12960281000000	7062	3646	3	0	0
16770	1489	13680281000000	7593	3927	7	0	0
16781	1489	14400531000000	7618	3941	1	0	0
16782	1489	14400541000000	7618	3941	2	0	0
16794	1489	15120541000000	8115	4208	1	0	0
16795	1489	15120551000000	8115	4208	2	0	0
16804	1489	15840551000000	8142	4222	1	0	0
16814	1489	16560561000000	8475	4390	1	0	0
16815	1489	16560571000000	8475	4390	2	0	0
16824	1489	17280571000000	8833	4580	2	0	0
16825	1489	17280591000000	8833	4580	3	0	0
16834	1489	18000611000000	9035	4685	3	0	0
16842	1489	18720611000000	9124	4726	4	0	0
16844	1489	18720651000000	9124	4726	5	0	0
16849	1489	19440651000000	9127	4727	2	0	0
16850	1489	19440671000000	9127	4727	3	0	0
16863	1489	20160691000000	9684	5024	3	0	0
16732	1489	11423992000000	16801	8527	4	0	4
16733	1489	11424005000000	16801	8527	5	0	4
16741	1489	12144005000000	17026	8623	3	0	4
16742	1489	12144017000000	17026	8623	4	0	4
16751	1489	12864041000000	17085	8656	7	0	4
16763	1489	13584041000000	17126	8678	3	0	4
16764	1489	13584053000000	17126	8678	4	0	4
16765	1489	13584063000000	17188	8710	12	1	4
16777	1489	14304387000000	17426	8827	9	0	4
16792	1489	15024387000000	17665	8930	2	0	4
16793	1489	15024398000000	17665	8930	3	0	4
16801	1489	15744398000000	18408	9280	2	0	4
16802	1489	15744409000000	18408	9280	3	0	4
16813	1489	16464421000000	18436	9294	4	0	4
16821	1489	17184421000000	18952	9560	2	0	4
16823	1489	17184441000000	18952	9560	3	0	4
16829	1489	17904441000000	19206	9690	3	0	4
16832	1489	17904453000000	19206	9690	4	0	4
16838	1489	18624477000000	19278	9719	7	0	4
16846	1489	19344477000000	19474	9818	7	0	4
16848	1489	19344493000000	19474	9818	8	0	4
16856	1489	20064493000000	20232	10187	6	0	4
16729	1489	11183105040000	26197	12950	5	0	10
16731	1489	11183119040000	26197	12950	6	0	10
16739	1489	11903119040000	26219	12963	4	0	10
16740	1489	11903132040000	26219	12963	5	0	10
16748	1489	12623132040000	26320	13017	5	0	10
16758	1489	13343155040000	27121	13410	6	0	10
16760	1489	13343179040000	27121	13410	7	0	10
16761	1489	13343220040000	27486	13586	14	0	10
16774	1489	14063220040000	27486	13586	28	0	10
16775	1489	14063233040000	27486	13586	29	0	10
16790	1489	14783269040000	27884	13786	10	0	10
16791	1489	14783279040000	27889	13789	4	1	10
16796	1489	15503279040000	28244	13964	2	0	10
16797	1489	15503290040000	28244	13964	3	0	10
16809	1489	16223302040000	28698	14167	4	0	10
16817	1489	16943302040000	29040	14321	3	0	10
16819	1489	16943314040000	29040	14321	4	0	10
16826	1489	17663314040000	29107	14349	3	0	10
16827	1489	17663326040000	29107	14349	4	0	10
16865	1489	20160731000000	9180	4757	8	0	\N
16866	1489	20165031000000	10447	5243	74	0	\N
16869	1489	20880691000000	10446	5404	10	0	\N
16872	1489	20880881000000	10446	5404	11	0	\N
16873	1489	20885031000000	10447	5243	126	0	\N
16874	1489	20885541000000	10447	5243	127	0	\N
16875	1489	21504545000000	20893	10502	3	0	\N
16876	1489	21504545000000	20959	10542	3	0	\N
16877	1489	21504545000000	21007	10563	5	0	\N
16878	1489	21504545000000	21009	10563	3	0	\N
16881	1489	21504557000000	20893	10502	4	0	\N
16882	1489	21504566000000	21009	10563	4	0	\N
16883	1489	21504568000000	21007	10563	6	0	\N
16884	1489	21504586000000	20959	10542	4	0	\N
16891	1489	22944580000000	21306	10697	3	0	\N
16892	1489	22944580000000	21308	10697	1	0	\N
16893	1489	22944580000000	21312	10697	3	0	\N
16894	1489	22944580000000	21598	10826	3	0	\N
16895	1489	22944580000000	22720	11358	2	0	\N
16896	1489	22944580000000	23065	11516	4	0	\N
16898	1489	22944581000000	21308	10697	2	0	\N
16899	1489	22944591000000	22720	11358	3	0	\N
16900	1489	22944592000000	21306	10697	4	0	\N
16901	1489	22944592000000	21312	10697	4	0	\N
16902	1489	22944592000000	21598	10826	4	0	\N
16903	1489	22944593000000	23065	11516	5	0	\N
16907	1489	23664602000000	23605	11761	3	0	\N
16909	1489	23664614000000	23605	11761	4	0	\N
16911	1489	23760743000000	11847	6091	1	0	\N
16912	1489	23760743000000	11920	6132	1	0	\N
16913	1489	23760743000000	12171	6266	1	0	\N
16915	1489	23760744000000	11847	6091	2	0	\N
16916	1489	23760744000000	11920	6132	2	0	\N
16917	1489	23760744000000	12171	6266	2	0	\N
16919	1489	24384626000000	23905	11897	4	0	\N
16920	1489	24384626000000	23906	11897	1	0	\N
16922	1489	24384627000000	23906	11897	2	0	\N
16924	1489	24384639000000	23905	11897	5	0	\N
16929	1489	66000009999990	24642	12242	9	1	\N
16932	1492	720390000000	2760	1231	120	0	\N
16935	1493	1440010000000	5907	3061	1	0	\N
16936	1493	1440020000000	5907	3061	2	0	\N
16939	1495	720000000000	1085	601	1	0	\N
16940	1495	720010000000	1085	601	2	0	\N
16941	1496	720000000000	2986	1552	1	0	\N
16942	1496	720010000000	2986	1552	2	0	\N
16943	1499	200000010	27534	13412	75	1	\N
16948	1499	2160032000000	27750	13709	2	0	\N
16950	1499	2160043000000	27750	13709	3	0	\N
16952	1500	1000000000	9774	4883	0	0	\N
16954	1501	100000009	22931	11460	2	0	\N
16959	1501	118200000	28414	14022	43	0	\N
16960	1501	118200000	30223	14735	99	1	\N
16961	1501	200000000	8789	4423	0	0	\N
16962	1501	203000000	22933	11460	4	0	\N
16963	1501	300000000	8790	4424	0	0	\N
16964	1501	400000000	8816	4425	0	0	\N
16965	1501	900000000	9066	4430	0	0	\N
16966	1501	398117200000	24591	12153	0	0	\N
16967	1501	62639702999959	9045	4429	4	0	\N
16968	1501	71133879800000	22325	11174	8	0	\N
16969	1501	87598569000000	11789	5945	127	0	\N
16972	1502	1440010000000	6209	3214	1	0	\N
16974	1502	1440020000000	6209	3214	2	0	\N
16979	1504	1157235000000	15960	8113	3	0	\N
16981	1504	1157247000000	15960	8113	4	0	\N
16983	1505	50000000	1793	914	27	0	\N
16984	1505	100000000	1823	915	0	0	\N
16985	1506	200000030	23654	11783	4	1	\N
16986	1506	290999959	27069	13248	127	0	\N
16991	1506	1440891967172	10948	5643	6	0	\N
16993	1506	1440951967172	10948	5643	7	0	\N
16995	1506	2160020000000	485	271	1	0	\N
16996	1506	2160020000000	1113	614	2	0	\N
16997	1506	2160020000000	1417	771	1	0	\N
16998	1506	2160020000000	1472	803	1	0	\N
17000	1506	2160030000000	485	271	2	0	\N
16987	1506	720000000000	204	120	1	0	0
16988	1506	720010000000	204	120	2	0	0
16989	1506	1440010000000	410	233	1	0	0
16990	1506	1440020000000	410	233	2	0	0
16970	1502	720000000000	430	245	1	0	0
16999	1506	2160020000000	1713	920	0	0	0
16930	1492	12600000	2534	1333	5	1	0
16931	1492	21000000	2604	1370	4	1	0
16977	1504	1036967000000	3353	1742	3	0	7
16978	1504	1037237000000	3353	1742	4	0	7
16934	1493	720010000000	4562	2358	2	0	0
16944	1499	720000000000	6776	3507	2	0	0
16945	1499	720020000000	6776	3507	3	0	0
16870	1489	20880691000000	10538	5443	2	0	0
16885	1489	21600711000000	10814	5580	2	0	0
16886	1489	21600731000000	10814	5580	3	0	0
16992	1506	1440891967172	10951	5643	6	0	17
16994	1506	1440951967172	10951	5643	7	0	17
16889	1489	22320731000000	11376	5844	2	0	0
16905	1489	23040742000000	11594	5964	1	0	0
16906	1489	23040743000000	11594	5964	2	0	0
16914	1489	23760743000000	12187	6275	1	0	0
16918	1489	23760744000000	12187	6275	2	0	0
16925	1489	24480744000000	12565	6475	2	0	0
16927	1489	25200755000000	13061	6733	3	0	0
16928	1489	25200767000000	13061	6733	4	0	0
16973	1502	1440010000000	14999	7641	0	0	0
16937	1494	720000000000	17456	8841	19	0	0
16980	1504	1157235000000	19369	9765	3	0	9
16982	1504	1157247000000	19369	9765	4	0	9
16946	1499	1440020000000	20154	10145	3	0	0
16947	1499	1440032000000	20154	10145	4	0	0
16867	1489	20784535000000	20881	10497	1	0	4
16879	1489	21504545000000	21141	10616	2	0	4
16880	1489	21504556000000	21141	10616	3	0	4
16887	1489	22224556000000	21290	10691	6	0	4
16888	1489	22224580000000	21290	10691	7	0	4
16955	1501	100800000	22289	11157	9	1	0
16957	1501	111200000	22323	11174	6	0	0
16958	1501	117200000	22930	11460	4	0	0
16897	1489	22944580000000	23246	11600	4	0	4
16904	1489	22944602000000	23246	11600	5	0	4
16910	1489	23664626000000	23731	11821	7	0	4
16921	1489	24384626000000	24114	12003	1	0	4
16923	1489	24384627000000	24114	12003	2	0	4
16949	1499	2160032000000	27868	13779	3	0	0
16951	1499	2160044000000	27868	13779	4	0	0
17001	1506	2160030000000	1417	771	2	0	\N
17002	1506	2160030000000	1472	803	2	0	\N
17003	1506	2160040000000	1113	614	3	0	\N
17004	1506	2160951967172	11027	5676	10	0	\N
17007	1506	2161051967172	11027	5676	11	0	\N
17010	1506	2453308967172	21310	10516	46	0	\N
17013	1506	2880971967172	11719	6025	1	0	\N
17014	1506	2880971967172	11783	6057	1	0	\N
17016	1506	2880972967172	11719	6025	2	0	\N
17017	1506	2880972967172	11783	6057	2	0	\N
17019	1506	3172588967172	20749	10431	6	0	\N
17022	1506	3172630967172	20749	10431	7	0	\N
17023	1506	3173308967172	21310	10516	126	0	\N
17024	1506	3174098967172	21310	10516	127	0	\N
17025	1506	3175378967172	21518	10517	46	0	\N
17026	1506	3600080000000	2142	1129	1	0	\N
17028	1506	3600090000000	2142	1129	2	0	\N
17030	1506	3600972967172	11930	6141	3	0	\N
17031	1506	3600972967172	12109	6236	1	0	\N
17032	1506	3600972967172	12154	6260	1	0	\N
17034	1506	3600973967172	12109	6236	2	0	\N
17035	1506	3600973967172	12154	6260	2	0	\N
17036	1506	3600975967172	11930	6141	4	0	\N
17040	1506	3894272967172	22284	10919	45	0	\N
17041	1506	3895378967172	21518	10517	126	0	\N
17042	1506	3896168967172	21518	10517	127	0	\N
17047	1506	4612612967172	21732	10885	0	0	\N
17048	1506	4612612967172	22283	11154	4	0	\N
17049	1506	4612612967172	22438	11230	8	0	\N
17052	1506	4612625967172	22283	11154	5	0	\N
17053	1506	4612638967172	22438	11230	9	0	\N
17054	1506	4614272967172	22284	10919	126	0	\N
17055	1506	4615072967172	22284	10919	127	0	\N
17058	1506	5041040967172	13245	6822	2	0	\N
17060	1506	5041051967172	13245	6822	3	0	\N
17062	1506	5332624967172	22670	11333	3	0	\N
17065	1506	5332636967172	22670	11333	4	0	\N
17067	1506	5760130000000	2652	1395	2	0	\N
17070	1506	5760150000000	2652	1395	3	0	\N
17074	1506	6052635967172	22798	11401	6	0	\N
17075	1506	6052635967172	22864	11430	5	0	\N
17077	1506	6052649967172	22864	11430	6	0	\N
17079	1506	6052659967172	22798	11401	7	0	\N
17080	1506	6480140000000	2718	1428	1	0	\N
17082	1506	6480150000000	2718	1428	2	0	\N
17084	1506	6480160000000	3759	1713	3	0	\N
17085	1506	6480192967172	24876	12351	3	0	\N
17087	1506	6480204967172	24876	12351	4	0	\N
17089	1506	6481076967172	13435	6923	4	0	\N
17090	1506	6481076967172	13484	6943	9	0	\N
17091	1506	6481076967172	13711	7046	4	0	\N
17092	1506	6481076967172	13734	7059	4	0	\N
17093	1506	6481076967172	13735	7059	3	0	\N
17094	1506	6481076967172	13992	7169	4	0	\N
17097	1506	6481088967172	13735	7059	4	0	\N
17098	1506	6481089967172	13435	6923	5	0	\N
17099	1506	6481089967172	13711	7046	5	0	\N
17100	1506	6481089967172	13734	7059	5	0	\N
17101	1506	6481089967172	13992	7169	5	0	\N
17102	1506	6481112967172	13484	6943	10	0	\N
17103	1506	6481210000000	3376	1611	70	0	\N
17106	1506	7200150000000	4002	2077	1	0	\N
17108	1506	7200160000000	4002	2077	2	0	\N
17110	1506	7200204967172	25058	12435	4	0	\N
17111	1506	7200204967172	25777	12625	5	0	\N
17112	1506	7200204967172	25779	12749	3	0	\N
17113	1506	7200204967172	26112	12904	2	0	\N
17115	1506	7200209967172	25777	12625	6	0	\N
17116	1506	7200215967172	26112	12904	3	0	\N
17118	1506	7200216967172	25779	12749	4	0	\N
17119	1506	7200217967172	25058	12435	5	0	\N
17120	1506	7200225967172	27067	13382	1	0	\N
17121	1506	7201086967172	14042	7192	8	0	\N
17124	1506	7201112967172	14042	7192	9	0	\N
17125	1506	7201210000000	3376	1611	126	0	\N
17126	1506	7201760000000	3376	1611	127	0	\N
17127	1506	7202460000000	3395	1612	70	0	\N
17128	1506	7492690967172	23430	11689	2	0	\N
17129	1506	7492690967172	23550	11738	0	0	\N
17130	1506	7492690967172	23654	11783	3	0	\N
17131	1506	7492690967172	24132	12012	8	0	\N
17132	1506	7492701967172	23430	11689	3	0	\N
17133	1506	7492725967172	24132	12012	9	0	\N
17136	1506	7920209967172	26107	12626	58	0	\N
17027	1506	3600080000000	2199	1158	3	0	0
17029	1506	3600110000000	2199	1158	4	0	0
17043	1506	4320110000000	2280	1195	1	0	0
17044	1506	4320120000000	2280	1195	2	0	0
17056	1506	5040120000000	2523	1325	1	0	0
17068	1506	5760130000000	2667	1401	1	0	0
17069	1506	5760140000000	2667	1401	2	0	0
17081	1506	6480140000000	2965	1540	1	0	0
17083	1506	6480150000000	2965	1540	2	0	0
17107	1506	7200150000000	4429	2297	1	0	0
17134	1506	7920160000000	4687	2423	1	0	0
17135	1506	7920170000000	4687	2423	2	0	0
17005	1506	2160951967172	11120	5717	2	0	17
17006	1506	2160971967172	11120	5717	3	0	17
17018	1506	2880972967172	11890	6110	2	0	17
17033	1506	3600972967172	12596	6494	8	0	17
17037	1506	3601016967172	12596	6494	9	0	17
17045	1506	4321016967172	13159	6780	6	0	17
17046	1506	4321040967172	13159	6780	7	0	17
17061	1506	5041064967172	13284	6842	7	0	17
17072	1506	5761064967172	13287	6844	3	0	17
17073	1506	5761076967172	13287	6844	4	0	17
17095	1506	6481076967172	13993	7169	1	0	17
17096	1506	6481086967172	13993	7169	2	0	17
17123	1506	7201106967172	14043	7192	3	0	17
17008	1506	2452576967172	20668	10397	3	0	22
17009	1506	2452588967172	20668	10397	4	0	22
17020	1506	3172588967172	21307	10697	3	0	22
17038	1506	3892600967172	21519	10795	3	0	22
17039	1506	3892612967172	21519	10795	4	0	22
17050	1506	4612612967172	22463	11241	3	0	22
17051	1506	4612624967172	22463	11241	4	0	22
17063	1506	5332624967172	22719	11358	2	0	22
17076	1506	6052635967172	23165	11567	4	0	22
17078	1506	6052657967172	23165	11567	5	0	22
17104	1506	6772657967172	23273	11611	6	0	22
17105	1506	6772690967172	23273	11611	7	0	22
17066	1506	5760080967172	24652	12245	4	0	23
17086	1506	6480192967172	24905	12366	3	0	23
17088	1506	6480204967172	24905	12366	4	0	23
17114	1506	7200204967172	26353	13031	2	0	23
17117	1506	7200215967172	26353	13031	3	0	23
17137	1506	7920215967172	26483	13099	3	0	\N
17138	1506	7920215967172	26750	13231	3	0	\N
17139	1506	7920215967172	26752	13231	2	0	\N
17140	1506	7920215967172	26787	13246	4	0	\N
17141	1506	7920215967172	26968	13338	3	0	\N
17142	1506	7920215967172	27439	13564	7	0	\N
17143	1506	7920215967172	27554	13620	4	0	\N
17145	1506	7920215967172	27643	13660	12	0	\N
17146	1506	7920217967172	26752	13231	3	0	\N
17147	1506	7920225967172	27067	13382	7	0	\N
17148	1506	7920227967172	26483	13099	4	0	\N
17149	1506	7920227967172	26750	13231	4	0	\N
17150	1506	7920227967172	26968	13338	4	0	\N
17151	1506	7920228967172	26787	13246	5	0	\N
17152	1506	7920228967172	27554	13620	5	0	\N
17153	1506	7920239967172	27067	13382	8	0	\N
17154	1506	7920240967172	27439	13564	8	0	\N
17156	1506	7920263967172	27643	13660	13	0	\N
17157	1506	7920339967172	26970	13247	101	0	\N
17158	1506	7920690967172	26107	12626	59	0	\N
17159	1506	7921106967172	14238	7268	1	0	\N
17160	1506	7921106967172	14239	7268	7	0	\N
17161	1506	7921106967172	14408	7350	2	0	\N
17162	1506	7921106967172	14409	7350	2	0	\N
17164	1506	7921108967172	14408	7350	3	0	\N
17165	1506	7921108967172	14409	7350	3	0	\N
17166	1506	7921116967172	14238	7268	2	0	\N
17168	1506	7921122967172	14239	7268	8	0	\N
17169	1506	7922460000000	3395	1612	126	0	\N
17170	1506	7923010000000	3395	1612	127	0	\N
17171	1506	7923710000000	3493	1613	70	0	\N
17173	1506	8640263967172	27763	13715	2	0	\N
17175	1506	8640274967172	27763	13715	3	0	\N
17177	1506	8640339967172	26970	13247	126	0	\N
17178	1506	8640464967164	27069	13248	101	0	\N
17181	1506	8643710000000	3493	1613	96	0	\N
17182	1506	8643960000000	3493	1613	97	0	\N
17183	1506	9260664124170	26970	13247	127	0	\N
17186	1506	9360275967172	28048	13871	3	0	\N
17189	1506	9360287967172	28048	13871	4	0	\N
17190	1506	9360464967164	27069	13248	126	0	\N
17191	1506	9361152967172	14724	7497	2	0	\N
17193	1506	9361163967172	14724	7497	3	0	\N
17197	1506	10080286967172	28393	14033	3	0	\N
17198	1506	10080286967172	28492	14080	7	0	\N
17199	1506	10080286967172	28742	14182	2	0	\N
17201	1506	10080297967172	28742	14182	3	0	\N
17203	1506	10080307967172	28393	14033	4	0	\N
17204	1506	10080323633842	28492	14080	8	0	\N
17213	1506	10801278967172	15822	8052	7	0	\N
17214	1506	10801278967172	15824	8052	7	0	\N
17217	1506	11520321967172	29619	14607	9	0	\N
17218	1506	11520366967172	29619	14607	10	0	\N
17221	1506	11521278967172	15822	8052	20	0	\N
17222	1506	11521278967172	15824	8052	20	0	\N
17223	1506	11521335967172	15822	8052	21	0	\N
17224	1506	11521335967172	15824	8052	21	0	\N
17225	1506	12240270000000	6588	3408	9	0	\N
17228	1506	12240351000000	6588	3408	10	0	\N
17231	1506	12960290000000	6979	3601	2	0	\N
17234	1506	12960310000000	6979	3601	3	0	\N
17235	1506	12961232967172	16838	8544	2	0	\N
17236	1506	12961232967172	17202	8717	3	0	\N
17238	1506	12961243967172	16838	8544	3	0	\N
17239	1506	12961244967172	17202	8717	4	0	\N
17243	1506	13680330000000	7891	4090	1	0	\N
17244	1506	13681245967172	17819	8998	3	0	\N
17247	1506	13681257967172	17819	8998	4	0	\N
17248	1506	13683136967172	18673	9276	67	0	\N
17249	1506	14400320000000	7876	4081	2	0	\N
17250	1506	14400320000000	8496	4401	1	0	\N
17251	1506	14400320000000	8517	4413	2	0	\N
17253	1506	14400330000000	7891	4090	2	0	\N
17254	1506	14400330000000	8496	4401	2	0	\N
17256	1506	14400340000000	7876	4081	3	0	\N
17257	1506	14400340000000	8517	4413	3	0	\N
17258	1506	14401256967172	18671	9407	4	0	\N
17259	1506	14401256967172	19556	9849	4	0	\N
17260	1506	14401256967172	19759	9947	3	0	\N
17261	1506	14401256967172	20120	10129	7	0	\N
17262	1506	14401268967172	19759	9947	4	0	\N
17263	1506	14401269967172	19556	9849	5	0	\N
17264	1506	14401278967172	18671	9407	5	0	\N
17265	1506	14401300967172	20120	10129	8	0	\N
17266	1506	14403136967172	18673	9276	114	0	\N
17267	1506	14403596967172	18673	9276	115	0	\N
17185	1506	9360190000000	5800	3009	3	0	0
17195	1506	10080190000000	5878	3047	1	0	0
17196	1506	10080200000000	5878	3047	2	0	0
17207	1506	10800200000000	6457	3345	4	0	0
17208	1506	10800240000000	6457	3345	5	0	0
17216	1506	11520270000000	6583	3406	4	0	0
17226	1506	12240270000000	6738	3486	2	0	0
17227	1506	12240290000000	6738	3486	3	0	0
17232	1506	12960290000000	7313	3779	1	0	0
17233	1506	12960300000000	7313	3779	2	0	0
17242	1506	13680320000000	7421	3834	3	0	0
17252	1506	14400320000000	8548	4429	1	0	0
17255	1506	14400330000000	8548	4429	2	0	0
17268	1506	15120330000000	8671	4491	1	0	0
17270	1506	15840340000000	8858	4590	2	0	0
17271	1506	15840360000000	8858	4590	3	0	0
17272	1506	16560360000000	9920	5148	2	0	0
17163	1506	7921106967172	14484	7391	4	0	17
17167	1506	7921119967172	14484	7391	5	0	17
17180	1506	8641152967172	14567	7428	7	0	17
17192	1506	9361152967172	15344	7820	2	0	17
17194	1506	9361163967172	15344	7820	3	0	17
17205	1506	10081163967172	15592	7937	4	0	17
17206	1506	10081185967172	15592	7937	5	0	17
17212	1506	10801208967172	15617	7950	6	0	17
17219	1506	11521208967172	16489	8385	3	0	17
17220	1506	11521220967172	16489	8385	4	0	17
17229	1506	12241220967172	16657	8462	3	0	17
17237	1506	12961232967172	17612	8907	4	0	17
17240	1506	12961245967172	17612	8907	5	0	17
17245	1506	13681245967172	17920	9039	2	0	17
17246	1506	13681256967172	17920	9039	3	0	17
17144	1506	7920215967172	27641	13660	12	0	23
17174	1506	8640263967172	27796	13736	3	0	23
17176	1506	8640275967172	27796	13736	4	0	23
17187	1506	9360275967172	28381	14029	2	0	23
17188	1506	9360286967172	28381	14029	3	0	23
17200	1506	10080286967172	28785	14199	3	0	23
17209	1506	10800298967172	28921	14264	5	0	23
17210	1506	10800321967172	28921	14264	6	0	23
17274	1506	17280380000000	10018	5195	2	0	\N
17276	1506	17280400000000	10018	5195	3	0	\N
17280	1506	18720540000000	10679	5513	2	0	\N
17281	1506	18720560000000	10679	5513	3	0	\N
17282	1508	200010000	17063	8411	26	1	\N
17283	1508	200100000	10184	5275	4	1	\N
17288	1508	2160020000000	538	305	2	0	\N
17289	1508	2160020000000	732	410	1	0	\N
17290	1508	2160020000000	777	432	1	0	\N
17292	1508	2160030000000	732	410	2	0	\N
17293	1508	2160030000000	777	432	2	0	\N
17295	1508	2160031000000	538	305	3	0	\N
17296	1508	2880030000000	2026	1068	2	0	\N
17298	1508	2880050000000	2026	1068	3	0	\N
17306	1508	5760080000000	3019	1567	1	0	\N
17308	1508	5760090000000	3019	1567	2	0	\N
17310	1508	6480090000000	3726	1933	1	0	\N
17311	1508	6480090000000	3848	1998	1	0	\N
17312	1508	6480090000000	3941	2046	1	0	\N
17313	1508	6480090000000	4136	2151	1	0	\N
17315	1508	6480100000000	3726	1933	2	0	\N
17316	1508	6480100000000	3848	1998	2	0	\N
17317	1508	6480100000000	3941	2046	2	0	\N
17318	1508	6480100000000	4136	2151	2	0	\N
17324	1508	7400255156616	21743	10888	3	0	\N
17326	1508	7400267156616	21743	10888	4	0	\N
17328	1508	7920110000000	5044	2614	3	0	\N
17330	1508	7920140000000	5044	2614	4	0	\N
17335	1508	8120819156616	22950	11334	48	0	\N
17336	1508	8640110000000	5278	2742	2	0	\N
17338	1508	8640130000000	5278	2742	3	0	\N
17339	1508	8676206500009	12723	6561	4	0	\N
17340	1508	8676206500009	12929	6664	2	0	\N
17342	1508	8676217500009	12929	6664	3	0	\N
17344	1508	8676228500009	12723	6561	5	0	\N
17347	1508	8840819156616	22950	11334	126	0	\N
17348	1508	8841589156616	22950	11334	127	0	\N
17355	1508	10080120000000	6009	3118	1	0	\N
17356	1508	10080120000000	6010	3010	10	0	\N
17358	1508	10080130000000	6009	3118	2	0	\N
17360	1508	10080760000000	6010	3010	11	0	\N
17368	1508	10800760000000	6105	3011	5	0	\N
17369	1508	10800810000000	6105	3011	6	0	\N
17370	1508	10836241500009	13585	6987	5	0	\N
17372	1508	10836241500009	13938	7142	1	0	\N
17373	1508	10836251500009	13938	7142	2	0	\N
17375	1508	10836265500009	13585	6987	6	0	\N
17377	1508	11520160000000	6302	3262	1	0	\N
17379	1508	11520170000000	6302	3262	2	0	\N
17381	1508	11520810000000	6232	3012	11	0	\N
17382	1508	11521820000000	6232	3012	12	0	\N
17383	1508	11556254500009	14142	7222	6	0	\N
17384	1508	11556254500009	14144	7222	6	0	\N
17385	1508	11556254500009	14145	7221	9	0	\N
17386	1508	11556254500009	14259	7280	4	0	\N
17388	1508	11556254500009	14326	7309	3	0	\N
17389	1508	11556266500009	14326	7309	4	0	\N
17390	1508	11556267500009	14259	7280	5	0	\N
17392	1508	11556278500009	14142	7222	7	0	\N
17393	1508	11556278500009	14144	7222	7	0	\N
17394	1508	11556290500009	14145	7221	10	0	\N
17395	1508	11720387156616	24277	12078	4	0	\N
17396	1508	11720387156616	24385	12127	7	0	\N
17399	1508	11720400156616	24277	12078	5	0	\N
17400	1508	11720421156616	24385	12127	8	0	\N
17401	1508	11721659156616	24930	12298	117	0	\N
17404	1508	12241820000000	6303	3013	1	0	\N
17405	1508	12241821000000	6303	3013	2	0	\N
17407	1508	12276267500009	14846	7430	76	0	\N
17286	1508	1440010000000	453	255	1	0	0
17287	1508	1440020000000	453	255	2	0	0
17291	1508	2160020000000	1164	641	1	0	0
17294	1508	2160030000000	1164	641	2	0	0
17297	1508	2880030000000	2266	1189	2	0	0
17300	1508	3600050000000	2461	1288	1	0	0
17301	1508	3600060000000	2461	1288	2	0	0
17302	1508	4320060000000	2770	1448	1	0	0
17303	1508	4320070000000	2770	1448	2	0	0
17304	1508	5040070000000	2840	1485	1	0	0
17307	1508	5760080000000	3107	1613	1	0	0
17309	1508	5760090000000	3107	1613	2	0	0
17314	1508	6480090000000	4608	2385	1	0	0
17319	1508	6480100000000	4608	2385	2	0	0
17321	1508	7200110000000	4820	2496	2	0	0
17329	1508	7920110000000	5045	2615	0	0	0
17337	1508	8640110000000	5479	2852	0	0	0
17349	1508	9360110000000	5631	2925	1	0	0
17350	1508	9360120000000	5631	2925	2	0	0
17359	1508	10080130000000	6104	3167	2	0	0
17366	1508	10800130000000	6231	3224	3	0	0
17367	1508	10800160000000	6231	3224	4	0	0
17378	1508	11520160000000	6336	3279	1	0	0
17380	1508	11520170000000	6336	3279	2	0	0
17403	1508	12240190000000	6537	3387	3	0	0
17273	1506	16560380000000	9920	5148	3	0	0
17275	1506	17280380000000	10164	5267	12	0	0
17277	1506	17280500000000	10164	5267	13	0	0
17279	1506	18000540000000	10658	5504	5	0	0
17322	1508	7236183500009	12652	6526	2	0	6
17323	1508	7236194500009	12652	6526	3	0	6
17331	1508	7956194500009	12659	6530	3	0	6
17332	1508	7956206500009	12659	6530	4	0	6
17343	1508	8676217500009	13009	6706	3	0	6
17351	1508	9396217500009	13015	6709	2	0	6
17352	1508	9396228500009	13015	6709	3	0	6
17361	1508	10116228500009	13108	6755	4	0	6
17362	1508	10116241500009	13108	6755	5	0	6
17374	1508	10836254500009	13935	7142	5	0	6
17387	1508	11556254500009	14325	7309	4	0	6
17391	1508	11556267500009	14325	7309	5	0	6
17406	1508	12276267500009	14582	7435	1	0	6
17325	1508	7400255156616	21843	10932	3	0	10
17327	1508	7400267156616	21843	10932	4	0	10
17333	1508	8120267156616	22518	11264	9	0	10
17334	1508	8120339156616	22518	11264	10	0	10
17345	1508	8840339156616	22948	11466	3	0	10
17353	1508	9560351156616	23642	11777	3	0	10
17354	1508	9560363156616	23642	11777	4	0	10
17363	1508	10280363156616	23770	11836	2	0	10
17364	1508	10280365156616	23770	11836	3	0	10
17365	1508	10280387156616	24021	11953	4	0	10
17397	1508	11720387156616	24657	12247	3	0	10
17398	1508	11720399156616	24657	12247	4	0	10
17409	1508	12277027500009	14846	7430	77	0	\N
17410	1508	12440399156616	24928	12375	7	0	\N
17413	1508	12440433156616	24928	12375	8	0	\N
17414	1508	12441659156616	24930	12298	126	0	\N
17415	1508	12441668156616	24930	12298	127	0	\N
17418	1508	12961821000000	6334	3014	2	0	\N
17419	1508	12962021000000	6334	3014	3	0	\N
17420	1508	12996268500009	14847	7566	2	0	\N
17422	1508	12996279500009	14847	7566	3	0	\N
17424	1508	12996349500009	15826	8052	7	0	\N
17429	1508	13716279500009	15612	7946	3	0	\N
17430	1508	13716279500009	15763	8016	3	0	\N
17432	1508	13716291500009	15612	7946	4	0	\N
17433	1508	13716291500009	15763	8016	4	0	\N
17435	1508	13716349500009	15826	8052	20	0	\N
17436	1508	13716406500009	15826	8052	21	0	\N
17437	1508	13716555500009	16564	8408	65	0	\N
17442	1508	14436292500009	16771	8513	7	0	\N
17445	1508	14436317500009	16771	8513	8	0	\N
17446	1508	14436555500009	16564	8408	70	0	\N
17447	1508	14436559500009	16564	8408	71	0	\N
17448	1508	14437098500009	16629	8409	121	0	\N
17451	1508	15120270000000	7236	3740	2	0	\N
17452	1508	15120270000000	7323	3785	1	0	\N
17453	1508	15120270000000	7791	4040	1	0	\N
17454	1508	15120270000000	7832	4060	1	0	\N
17455	1508	15120270000000	8035	4164	12	0	\N
17456	1508	15120270000000	8302	4298	2	0	\N
17457	1508	15120270000000	8438	4373	0	0	\N
17458	1508	15120270000000	8652	4482	1	0	\N
17459	1508	15120270000000	9057	4694	5	0	\N
17461	1508	15120280000000	7323	3785	2	0	\N
17462	1508	15120280000000	7791	4040	2	0	\N
17463	1508	15120280000000	7832	4060	2	0	\N
17464	1508	15120280000000	8652	4482	2	0	\N
17465	1508	15120281000000	8302	4298	3	0	\N
17466	1508	15120290000000	7236	3740	3	0	\N
17468	1508	15120311000000	9057	4694	6	0	\N
17469	1508	15120930000000	8035	4164	13	0	\N
17470	1508	15156305500009	17425	8826	4	0	\N
17472	1508	15156516500009	17425	8826	5	0	\N
17474	1508	15157098500009	16629	8409	122	0	\N
17475	1508	15158164500009	16772	8410	126	0	\N
17478	1508	15840310000000	9633	4999	1	0	\N
17479	1508	15840310000000	9969	5079	61	0	\N
17480	1508	15840310000000	9970	5172	4	0	\N
17482	1508	15840320000000	9633	4999	2	0	\N
17483	1508	15840350000000	9970	5172	5	0	\N
17485	1508	15841645000000	9969	5079	62	0	\N
17486	1508	15841794000000	10031	5080	23	0	\N
17489	1508	15878164500009	16772	8410	127	0	\N
17492	1508	16560351000000	10179	5275	4	0	\N
17493	1508	16560351000000	10180	5275	4	0	\N
17494	1508	16560351000000	10184	5275	3	0	\N
17496	1508	16560351573896	10179	5275	7	0	\N
17498	1508	16561793000000	10031	5080	24	0	\N
17501	1508	16598164500009	17063	8411	25	0	\N
17502	1508	16759471156616	27326	13508	3	0	\N
17503	1508	16759483156616	27326	13508	4	0	\N
17504	1508	16760471156616	27329	13508	3	0	\N
17505	1508	16760471156616	27562	13623	4	0	\N
17507	1508	16760483156616	27329	13508	4	0	\N
17508	1508	16760484156616	27562	13623	5	0	\N
17510	1508	17280371000000	10699	5524	8	0	\N
17511	1508	17280371000000	10700	5524	8	0	\N
17512	1508	17280371000000	10701	5524	8	0	\N
17514	1508	17280443000000	10699	5524	9	0	\N
17515	1508	17280443000000	10700	5524	9	0	\N
17521	1508	17480584156616	28377	13824	24	0	\N
17526	1508	18200515156616	28378	14028	2	0	\N
17528	1508	18200526156616	28378	14028	3	0	\N
17530	1508	18200584156608	28377	13824	25	0	\N
17537	1508	19440512000000	11635	5988	4	0	\N
17539	1508	19440516000000	11635	5988	5	0	\N
17543	1508	19640537156616	28870	14240	3	0	\N
17427	1508	13680210000000	6748	3493	4	0	0
17428	1508	13680250000000	6748	3493	5	0	0
17440	1508	14400250000000	6807	3523	2	0	0
17441	1508	14400270000000	6807	3523	3	0	0
17460	1508	15120270000000	9237	4789	4	0	0
17481	1508	15840310000000	10032	5205	5	0	0
17484	1508	15840351000000	10032	5205	6	0	0
17495	1508	16560351000000	10501	5425	2	0	0
17497	1508	16560371000000	10501	5425	3	0	0
17513	1508	17280371000000	10705	5527	9	0	0
17522	1508	18000452000000	10994	5664	4	0	0
17523	1508	18000492000000	10994	5664	5	0	0
17531	1508	18720492000000	11076	5698	2	0	0
17532	1508	18720512000000	11076	5698	3	0	0
17540	1508	19440526000000	11663	5998	6	0	0
17421	1508	12996268500009	15236	7760	2	0	6
17423	1508	12996279500009	15236	7760	3	0	6
17431	1508	13716279500009	16336	8304	4	0	6
17434	1508	13716292500009	16336	8304	5	0	6
17444	1508	14436305500009	17062	8642	5	0	6
17471	1508	15156305500009	17472	8846	29	0	6
17473	1508	15156541500009	17472	8846	30	0	6
17487	1508	15876541500009	18170	9162	3	0	6
17488	1508	15876553500009	18170	9162	4	0	6
17500	1508	16596576500009	18383	9265	6	0	6
17517	1508	17316576500009	18472	9307	3	0	6
17518	1508	17316588500009	18472	9307	4	0	6
17524	1508	18036588500009	18838	9495	3	0	6
17533	1508	18756609500009	19150	9661	19	0	6
17534	1508	18756673500009	19150	9661	20	0	6
17541	1508	19476673500009	19597	9870	10	0	6
17542	1508	19476710500009	19597	9870	11	0	6
17411	1508	12440399156616	26364	13038	2	0	10
17425	1508	13160410156616	26506	13113	4	0	10
17426	1508	13160423156616	26506	13113	5	0	10
17438	1508	13880423156616	26518	13119	3	0	10
17439	1508	13880435156616	26518	13119	4	0	10
17449	1508	14600435156616	26914	13310	3	0	10
17476	1508	15320447156616	27126	13414	3	0	10
17477	1508	15320459156616	27126	13414	4	0	10
17490	1508	16040459156616	27301	13494	3	0	10
17491	1508	16040471156616	27301	13494	4	0	10
17509	1508	16760493156616	27728	13698	5	0	10
17519	1508	17480493156616	27772	13721	4	0	10
17520	1508	17480515156616	27772	13721	5	0	10
17527	1508	18200515156616	28475	14073	2	0	10
17529	1508	18200526156616	28475	14073	3	0	10
17536	1508	18920537156616	28681	14159	3	0	10
17544	1508	19640537156616	28956	14281	3	0	10
17545	1508	19640549156616	28870	14240	4	0	\N
17551	1508	20360549156616	29063	14330	9	0	\N
17552	1508	20360549156616	29167	14380	2	0	\N
17554	1508	20360551156616	29167	14380	3	0	\N
17555	1508	20360585156616	29063	14330	10	0	\N
17561	1508	21600538000000	12139	6253	0	0	\N
17562	1508	21636734500009	20016	10075	3	0	\N
17563	1508	21636734500009	20210	10178	3	0	\N
17565	1508	21636746500009	20016	10075	4	0	\N
17566	1508	21636746500009	20210	10178	4	0	\N
17567	1508	21637834500009	20646	10357	38	0	\N
17568	1508	22356734500009	20644	10389	3	0	\N
17569	1508	22356734500009	20784	10438	0	0	\N
17571	1508	22356734500009	21157	10625	2	0	\N
17573	1508	22356745500009	21157	10625	3	0	\N
17574	1508	22356746500009	20644	10389	4	0	\N
17575	1508	22357834500009	20646	10357	123	0	\N
17576	1508	22357990500010	20646	10357	127	0	\N
17577	1508	22359080500010	20786	10358	38	0	\N
17580	1508	23078080500010	20786	10358	39	0	\N
17587	1508	66000000030000	10701	5524	10	1	\N
17588	1508	66000025000000	10180	5275	5	1	\N
17589	1509	100000005	20559	10228	65	1	\N
17590	1509	200100000	15302	7798	5	1	\N
17591	1509	901001000	2915	1519	2	1	\N
17592	1509	2600000002	9723	4882	45	1	\N
17595	1509	1440020000000	369	210	2	0	\N
17597	1509	1440040000000	369	210	3	0	\N
17599	1509	1440190000000	10930	5636	3	0	\N
17604	1509	2880070000000	1022	566	1	0	\N
17606	1509	2880080000000	1022	566	2	0	\N
17611	1509	3600080000000	1565	852	1	0	\N
17612	1509	3600080000000	1631	879	1	0	\N
17613	1509	3600090000000	1565	852	2	0	\N
17614	1509	3600090000000	1631	879	2	0	\N
17617	1509	4271723851155	11494	5905	5	0	\N
17620	1509	4271746851155	11494	5905	6	0	\N
17621	1509	4320100000000	2247	1183	0	0	\N
17622	1509	4320100000000	2592	1366	1	0	\N
17623	1509	4320100000000	2627	1381	1	0	\N
17625	1509	4320110000000	2592	1366	2	0	\N
17626	1509	4320110000000	2627	1381	2	0	\N
17632	1509	5059232999970	6574	3403	5	1	\N
17633	1509	5711727851155	12084	6222	2	0	\N
17636	1509	5711729851155	12084	6222	3	0	\N
17643	1509	7151729851155	12603	6500	6	0	\N
17646	1509	7151762851155	12603	6500	7	0	\N
17647	1509	7200149999500	2915	1519	1	0	\N
17648	1509	7200150000000	3008	1562	0	0	\N
17653	1509	7920190000000	3267	1698	1	0	\N
17655	1509	7920200000000	3267	1698	2	0	\N
17657	1509	8303931503835	22296	11092	63	0	\N
17660	1509	8592143851155	13170	6752	37	0	\N
17665	1509	9023931503835	22296	11092	126	0	\N
17666	1509	9024614503835	22296	11092	127	0	\N
17667	1509	9025244503835	22467	11093	63	0	\N
17668	1509	9311773851155	14036	7189	3	0	\N
17669	1509	9311773851155	14091	7206	4	0	\N
17670	1509	9311773851155	14308	7301	7	0	\N
17673	1509	9311785851155	14036	7189	4	0	\N
17674	1509	9311786851155	14091	7206	5	0	\N
17675	1509	9311798851155	14308	7301	8	0	\N
17676	1509	9312143851155	13170	6752	126	0	\N
17677	1509	9312817851147	13466	6753	37	0	\N
17680	1509	9546973900000	15821	8052	21	1	\N
17596	1509	1440020000000	896	498	2	0	0
17598	1509	1440040000000	896	498	3	0	0
17600	1509	2160040000000	956	533	3	0	0
17601	1509	2160070000000	956	533	4	0	0
17605	1509	2880070000000	1034	574	1	0	0
17608	1509	2880090000000	1873	997	1	0	0
17615	1509	3600090000000	1873	997	3	0	0
17616	1509	3600100000000	1873	997	4	0	0
17624	1509	4320100000000	2649	1394	1	0	0
17627	1509	4320110000000	2649	1394	2	0	0
17631	1509	5040130000000	2704	1420	3	0	0
17637	1509	5760130000000	2717	1428	1	0	0
17638	1509	5760140000000	2717	1428	2	0	0
17641	1509	6480140000000	2850	1493	1	0	0
17649	1509	7200150000000	3231	1677	4	0	0
17650	1509	7200190000000	3231	1677	5	0	0
17654	1509	7920190000000	3344	1737	1	0	0
17656	1509	7920200000000	3344	1737	2	0	0
17661	1509	8640200000000	3384	1760	1	0	0
17678	1509	9360210000000	3694	1918	1	0	0
17679	1509	9360220000000	3694	1918	2	0	0
17602	1509	2831359851155	11052	5686	4	0	5
17603	1509	2831399851155	11052	5686	5	0	5
17609	1509	3551399851155	11266	5788	36	0	5
17618	1509	4271723851155	11581	5956	1	0	5
17619	1509	4271724851155	11581	5956	2	0	5
17628	1509	4991724851155	11611	5974	3	0	5
17629	1509	4991727851155	11611	5974	4	0	5
17548	1508	20160537000000	11837	6085	3	0	0
17557	1508	20880537000000	12087	6223	1	0	0
17558	1508	20880538000000	12087	6223	2	0	0
17634	1509	5711727851155	12331	6355	1	0	5
17635	1509	5711728851155	12331	6355	2	0	5
17640	1509	6431729851155	12384	6388	2	0	5
17644	1509	7151729851155	12635	6518	2	0	5
17645	1509	7151740851155	12635	6518	3	0	5
17651	1509	7871740851155	12893	6645	2	0	5
17652	1509	7871751851155	12893	6645	3	0	5
17659	1509	8591773851155	12903	6650	5	0	5
17671	1509	9311773851155	14534	7412	2	0	5
17672	1509	9311784851155	14534	7412	3	0	5
17549	1508	20196710500009	19712	9924	3	0	6
17559	1508	20916722500009	19878	10013	3	0	6
17560	1508	20916734500009	19878	10013	4	0	6
17564	1508	21636734500009	20550	10345	0	0	6
17570	1508	22356734500009	21156	10625	2	0	6
17572	1508	22356745500009	21156	10625	3	0	6
17579	1508	23076757500009	21286	10688	4	0	6
17581	1508	23796757500009	21316	10700	3	0	6
17582	1508	23796769500009	21316	10700	4	0	6
17583	1508	24516769500009	21350	10715	4	0	6
17584	1508	24516782500009	21350	10715	5	0	6
17586	1508	25236794500009	21454	10763	4	0	6
17663	1509	9023211503835	22294	11160	6	0	9
17664	1509	9023235503835	22294	11160	7	0	9
17546	1508	19640549156616	28956	14281	4	0	10
17556	1508	20360643132611	30154	14837	51	1	10
17681	1509	9743235503835	22466	11242	4	0	\N
17683	1509	9743235503835	22841	11393	0	0	\N
17684	1509	9743235503835	22842	11404	0	0	\N
17685	1509	9743235503835	22843	11382	0	0	\N
17686	1509	9743235503835	22852	11421	0	0	\N
17688	1509	9743248503835	22466	11242	5	0	\N
17689	1509	9745244503835	22467	11093	126	0	\N
17690	1509	9745783503835	22467	11093	127	0	\N
17693	1509	10032817851147	13466	6753	76	0	\N
17696	1509	10463235503835	22853	11422	1	0	\N
17697	1509	10463236503835	22853	11422	2	0	\N
17700	1509	10552599887768	24810	12261	113	1	\N
17701	1509	10751795851155	15172	7731	4	0	\N
17702	1509	10751795851155	15194	7742	3	0	\N
17703	1509	10751795851155	15302	7798	4	0	\N
17704	1509	10751795851155	15304	7784	47	0	\N
17705	1509	10751795851155	15305	7798	8	0	\N
17706	1509	10751795851155	15459	7873	2	0	\N
17707	1509	10751795851155	16190	8224	2	0	\N
17709	1509	10751797851155	16190	8224	3	0	\N
17710	1509	10751806851155	15459	7873	3	0	\N
17711	1509	10751807851155	15194	7742	4	0	\N
17712	1509	10751808851155	15172	7731	5	0	\N
17714	1509	10751830851155	15305	7798	9	0	\N
17715	1509	10752022851155	15304	7784	48	0	\N
17716	1509	10752182851155	15461	7785	16	0	\N
17719	1509	11183259503835	23245	11600	4	0	\N
17722	1509	11183281503835	23245	11600	5	0	\N
17723	1509	11471797851155	16210	8225	10	0	\N
17726	1509	11471852851155	16210	8225	11	0	\N
17727	1509	11472182851155	15461	7785	126	0	\N
17728	1509	11473101851155	15461	7785	127	0	\N
17733	1509	11903409503835	25296	12473	18	0	\N
17738	1509	12623281503835	23370	11663	0	0	\N
17739	1509	12623281503835	23371	11663	2	0	\N
17741	1509	12623281503835	25482	12475	1	0	\N
17742	1509	12623281503835	25696	12480	1	0	\N
17743	1509	12623292503835	23371	11663	3	0	\N
17745	1509	12623303503835	25697	12715	1	0	\N
17747	1509	12623381503835	25482	12475	2	0	\N
17748	1509	12623381503835	25696	12480	2	0	\N
17749	1509	12623409503835	25296	12473	19	0	\N
17752	1509	12960281000000	4760	2460	1	0	\N
17754	1509	12960291000000	4760	2460	2	0	\N
17756	1509	13343293503835	25483	12620	3	0	\N
17757	1509	13343303503835	25697	12715	4	0	\N
17759	1509	13343305503835	25483	12620	4	0	\N
17761	1509	13631869851155	16740	8501	8	0	\N
17764	1509	13631904851155	16740	8501	9	0	\N
17769	1509	14351880851155	16957	8594	6	0	\N
17772	1509	14351913851155	16957	8594	7	0	\N
17773	1509	14400301000000	5011	2598	1	0	\N
17774	1509	14400301000000	5218	2714	2	0	\N
17776	1509	14400311000000	5011	2598	2	0	\N
17777	1509	14400321000000	5218	2714	3	0	\N
17784	1509	15503417503835	26078	12888	2	0	\N
17785	1509	15503417503835	26321	13017	5	0	\N
17787	1509	15503428503835	26078	12888	3	0	\N
17789	1509	15503440503835	26321	13017	6	0	\N
17790	1509	15791929851155	17512	8866	9	0	\N
17793	1509	15791965851155	17512	8866	10	0	\N
17794	1509	15840301001008	13170	6752	127	0	\N
17795	1509	15840401000000	5894	3055	1	0	\N
17796	1509	15840401000000	5941	3078	3	0	\N
17797	1509	15840401000000	6078	3156	2	0	\N
17799	1509	15840411000000	5894	3055	2	0	\N
17801	1509	15840411000010	6574	3403	4	0	\N
17802	1509	15840421000000	6078	3156	3	0	\N
17803	1509	15840431000000	5941	3078	4	0	\N
17806	1509	16511942851155	18613	9378	17	0	\N
17807	1509	16511942851155	18643	9395	2	0	\N
17809	1509	16511953851155	18643	9395	3	0	\N
17811	1509	16512031851155	18613	9378	18	0	\N
17815	1509	16943442503835	28045	13864	0	0	\N
17816	1509	16943442503835	28046	13868	0	0	\N
17717	1509	10800230000000	4168	2168	4	0	0
17718	1509	10800261000000	4168	2168	5	0	0
17729	1509	11520261000000	4369	2266	1	0	0
17730	1509	11520271000000	4369	2266	2	0	0
17736	1509	12240271000000	4706	2432	1	0	0
17753	1509	12960281000000	4792	2478	1	0	0
17755	1509	12960291000000	4792	2478	2	0	0
17765	1509	13680291000000	4918	2545	1	0	0
17766	1509	13680301000000	4918	2545	2	0	0
17775	1509	14400301000000	5710	2961	1	0	0
17783	1509	15120401000000	5730	2969	0	0	0
17798	1509	15840401000000	6135	3181	1	0	0
17800	1509	15840411000000	6135	3181	2	0	0
17812	1509	16560411000000	7449	3852	2	0	0
17691	1509	10031784851155	14788	7531	2	0	5
17692	1509	10031795851155	14788	7531	3	0	5
17708	1509	10751795851155	16191	8228	7	0	5
17713	1509	10751820851155	16191	8228	8	0	5
17724	1509	11471820851155	16211	8238	7	0	5
17734	1509	12191845851155	16528	8407	3	0	5
17735	1509	12191857851155	16528	8407	4	0	5
17750	1509	12911857851155	16667	8467	3	0	5
17751	1509	12911869851155	16667	8467	4	0	5
17762	1509	13631869851155	16765	8510	2	0	5
17770	1509	14351880851155	17220	8724	6	0	5
17771	1509	14351904851155	17220	8724	7	0	5
17781	1509	15071904851155	17234	8731	7	0	5
17782	1509	15071929851155	17234	8731	8	0	5
17792	1509	15791942851155	17755	8971	5	0	5
17808	1509	16511942851155	18738	9442	4	0	5
17810	1509	16511955851155	18738	9442	5	0	5
17682	1509	9743235503835	22839	11422	3	0	9
17687	1509	9743247503835	22839	11422	4	0	9
17699	1509	10463259503835	22850	11426	4	0	9
17720	1509	11183259503835	23258	11605	2	0	9
17721	1509	11183270503835	23258	11605	3	0	9
17731	1509	11903270503835	23287	11619	2	0	9
17732	1509	11903281503835	23287	11619	3	0	9
17744	1509	12623293503835	25298	12550	4	0	9
17746	1509	12623303503835	25698	12715	1	0	9
17758	1509	13343303503835	25698	12715	4	0	9
17760	1509	13343305503835	25698	12715	5	0	9
17768	1509	14063316503835	25960	12828	3	0	9
17779	1509	14783316503835	26061	12879	11	0	9
17780	1509	14783417503835	26061	12879	12	0	9
17786	1509	15503417503835	26578	13151	4	0	9
17788	1509	15503430503835	26578	13151	5	0	9
17805	1509	16223442503835	26958	13333	4	0	9
17814	1509	16943442503835	28044	13870	6	0	9
17822	1509	17663466503835	28165	13927	2	0	\N
17823	1509	17663466503835	28166	13927	2	0	\N
17825	1509	17663477503735	28166	13927	3	1	\N
17826	1509	17663477503835	28165	13927	3	0	\N
17828	1509	17951966851155	18850	9505	1	0	\N
17830	1509	17951976851155	18850	9505	2	0	\N
17832	1509	18000441000000	8024	4161	2	0	\N
17833	1509	18000441000000	8145	4223	2	0	\N
17836	1509	18000461000000	8024	4161	3	0	\N
17837	1509	18000461000000	8145	4223	3	0	\N
17838	1509	18383477503835	28294	13986	2	0	\N
17839	1509	18383477503835	28336	14008	8	0	\N
17840	1509	18383488503835	28294	13986	3	0	\N
17841	1509	18383521503835	28336	14008	9	0	\N
17847	1509	19103477503835	28364	14021	6	0	\N
17849	1509	19103510503835	28364	14021	7	0	\N
17850	1509	19103700503835	28414	14022	19	0	\N
17851	1509	19392091851155	19504	9831	6	0	\N
17852	1509	19392091851155	19924	10034	1	0	\N
17853	1509	19392091851155	19987	10065	5	0	\N
17855	1509	19392092851155	19924	10034	2	0	\N
17858	1509	19392114851155	19987	10065	6	0	\N
17859	1509	19392115851155	19504	9831	7	0	\N
17862	1509	19823499503835	28412	14041	2	0	\N
17864	1509	19823510503835	28412	14041	3	0	\N
17866	1509	19823700503835	28414	14022	42	0	\N
17867	1509	19823748503835	28414	14022	43	1	\N
17868	1509	20112104851155	20385	10227	28	0	\N
17871	1509	20112157851155	20385	10227	29	0	\N
17872	1509	20112377851155	20559	10228	14	0	\N
17873	1509	20160502000000	8943	4638	2	0	\N
17875	1509	20160522000000	8943	4638	3	0	\N
17882	1509	20832253851155	20763	10416	40	0	\N
17883	1509	20832377851155	20559	10228	62	0	\N
17884	1509	20880542000000	9453	4902	5	0	\N
17886	1509	20880583000000	9453	4902	6	0	\N
17888	1509	20880643000000	10031	5080	24	0	\N
17891	1509	20880713000000	10928	5635	10	0	\N
17893	1509	21263534503835	29704	14648	6	0	\N
17894	1509	21263549503835	29704	14648	7	0	\N
17896	1509	21263618503835	30163	14842	30	0	\N
17897	1509	21263618503835	30164	14842	30	0	\N
17898	1509	21552238851155	20899	10506	2	0	\N
17899	1509	21552238851155	20903	10506	2	0	\N
17900	1509	21552238851155	21002	10561	5	0	\N
17901	1509	21552238851155	21021	10569	6	0	\N
17902	1509	21552238851155	21022	10569	6	0	\N
17903	1509	21552238851155	21024	10569	6	0	\N
17905	1509	21552238851155	21386	10729	3	0	\N
17906	1509	21552238851155	21387	10729	3	0	\N
17907	1509	21552249851155	20899	10506	3	0	\N
17908	1509	21552249851155	20903	10506	3	0	\N
17910	1509	21552250851155	21386	10729	4	0	\N
17911	1509	21552250851155	21387	10729	4	0	\N
17912	1509	21552261851155	21002	10561	6	0	\N
17913	1509	21552271851155	21021	10569	7	0	\N
17914	1509	21552271851155	21022	10569	7	0	\N
17915	1509	21552271851155	21024	10569	7	0	\N
17916	1509	21600642000000	10342	5353	2	0	\N
17917	1509	21600643000000	10472	5412	2	0	\N
17918	1509	21600643000000	10831	5589	2	0	\N
17919	1509	21600643000000	10858	5605	2	0	\N
17921	1509	21600662000000	10342	5353	3	0	\N
17922	1509	21600663000000	10472	5412	3	0	\N
17923	1509	21600663000000	10831	5589	3	0	\N
17924	1509	21600663000000	10858	5605	3	0	\N
17928	1509	21983552503835	30146	14833	8	0	\N
17930	1509	21983552503835	30315	14898	5	0	\N
17931	1509	21983569503835	30146	14833	9	0	\N
17933	1509	21983569503835	30315	14898	6	0	\N
17934	1509	21983618503835	30163	14842	40	0	\N
17935	1509	21983618503835	30164	14842	40	0	\N
17936	1509	21983625578631	30163	14842	44	1	\N
17937	1509	21983626578530	30164	14842	44	0	\N
17947	1509	66000000001350	25697	12715	5	1	\N
17948	1509	66000000500000	10701	5524	9	0	\N
17949	1509	66000050000000	13466	6753	77	1	\N
17950	1509	71027303539245	21532	10801	5	0	\N
17951	1509	99362028471430	15827	8052	21	1	\N
17952	1510	720000000000	12657	6529	3	0	\N
17834	1509	18000441000000	8253	4273	1	0	0
17835	1509	18000451000000	8253	4273	2	0	0
17844	1509	18720451000000	8597	4457	1	0	0
17845	1509	18720461000000	8597	4457	2	0	0
17860	1509	19440461000000	8916	4620	5	0	0
17874	1509	20160502000000	9080	4710	4	0	0
17876	1509	20160542000000	9080	4710	5	0	0
17885	1509	20880542000000	9691	5028	10	0	0
17887	1509	20880642000000	9691	5028	11	0	0
17889	1509	20880643000000	10412	5386	4	1	0
17920	1509	21600651000000	10981	5658	2	0	0
17925	1509	21600671000000	10981	5658	3	0	0
17926	1509	21600710000000	10988	5662	6	0	0
17927	1509	21600749000000	10992	5663	6	0	0
17819	1509	17231966851155	18745	9446	3	0	5
17829	1509	17951966851155	19182	9678	4	0	5
17831	1509	17952078851155	19182	9678	5	0	5
17842	1509	18672078851155	19441	9798	4	0	5
17843	1509	18672091851155	19441	9798	5	0	5
17856	1509	19392104851155	20192	10169	5	0	5
17857	1509	19392106351155	20355	10252	6	0	5
17869	1509	20112106351155	20386	10271	3	0	5
17870	1509	20112118351155	20386	10271	4	0	5
17879	1509	20832118351155	20558	10349	14	0	5
17881	1509	20832238851155	20761	10436	15	1	5
17904	1509	21552238851155	21385	10729	3	0	5
17909	1509	21552250851155	21385	10729	4	0	5
17938	1509	22272250851155	21573	10816	3	0	5
17940	1509	22272264351155	21590	10824	10	0	5
17941	1509	22992264351155	21829	10925	6	0	5
17942	1509	22992288351155	21829	10925	7	0	5
17943	1509	23712288351155	22103	11053	10	0	5
17944	1509	23712325351155	22103	11053	11	0	5
17946	1509	24432347351155	22106	11055	5	0	5
17817	1509	16943466503835	28044	13870	7	0	9
17824	1509	17663466503835	28269	13976	2	0	9
17827	1509	17663477503835	28269	13976	3	0	9
17846	1509	19103477503835	28363	14022	4	0	9
17863	1509	19823499503835	28751	14184	2	0	9
17865	1509	19823510503835	28751	14184	3	0	9
17877	1509	20543510503835	29349	14465	6	0	9
17878	1509	20543534503835	29349	14465	7	0	9
17895	1509	21263552503835	29703	14648	10	0	9
17929	1509	21983552503835	30313	14898	5	0	9
17932	1509	21983569503835	30313	14898	6	0	9
17953	1510	720012000000	12657	6529	4	0	\N
17954	1511	720000000000	5053	2623	1	0	\N
17956	1511	720000000000	16234	8252	3	0	\N
17957	1511	720000000000	16360	8321	4	0	\N
17958	1511	720000000000	27691	13683	3	0	\N
17959	1511	720010000000	5053	2623	2	0	\N
17961	1511	720012000000	16234	8252	4	0	\N
17962	1511	720012000000	27691	13683	4	0	\N
17963	1511	720013000000	16360	8321	5	0	\N
17964	1513	200000023	17100	8664	3	0	\N
17965	1513	720000000000	23	13	2	0	\N
17968	1513	720020000000	23	13	3	0	\N
17969	1513	1440010000000	888	493	2	0	\N
17972	1513	1440030000000	888	493	3	0	\N
17973	1513	2160020000000	1149	632	1	0	\N
17974	1513	2160020000000	1196	659	1	0	\N
17976	1513	2160030000000	1149	632	2	0	\N
17977	1513	2160030000000	1196	659	2	0	\N
17979	1513	2880030000000	2230	1175	1	0	\N
17980	1513	2880030000000	2343	1224	2	0	\N
17981	1513	2880030000000	2463	1289	2	0	\N
17982	1513	2880030000000	2862	1405	1	0	\N
17983	1513	2880030000000	3331	1709	5	0	\N
17985	1513	2880040000000	2230	1175	2	0	\N
17986	1513	2880040000000	2862	1405	2	0	\N
17988	1513	2880050000000	2343	1224	3	0	\N
17989	1513	2880050000000	2463	1289	3	0	\N
17990	1513	2880350000000	3331	1709	6	0	\N
17993	1513	3600350000000	3543	1710	9	0	\N
17994	1513	3600503000000	3543	1710	10	0	\N
17997	1513	4320503000000	3570	1711	0	0	\N
18000	1513	5040503000000	3640	1712	5	0	\N
18001	1513	5040517000000	3640	1712	6	0	\N
18002	1513	5040528000000	3759	1713	2	0	\N
18003	1513	5760090000000	4752	2455	1	0	\N
18004	1513	5760090000000	4801	2484	1	0	\N
18005	1513	5760090000000	4966	2574	2	0	\N
18007	1513	5760100000000	4752	2455	2	0	\N
18008	1513	5760100000000	4801	2484	2	0	\N
18009	1513	5760110000000	4966	2574	3	0	\N
18010	1513	5760518000000	3759	1713	3	0	\N
18011	1513	6480090000000	5268	2735	2	0	\N
18014	1513	6480110000000	5268	2735	3	0	\N
18015	1513	7200100000000	5899	3058	1	0	\N
18016	1513	7200100000000	5903	3060	1	0	\N
18018	1513	7200110000000	5899	3058	2	0	\N
18019	1513	7200110000000	5903	3060	2	0	\N
18023	1513	8640120000000	6392	3313	1	0	\N
18025	1513	8640130000000	6392	3313	2	0	\N
18027	1513	9360140000000	6558	3397	2	0	\N
18029	1513	9360160000000	6558	3397	3	0	\N
18034	1513	10800210000000	6814	3527	4	0	\N
18037	1513	10800430000000	6814	3527	5	0	\N
18040	1513	12240360000000	7295	3770	2	0	\N
18041	1513	12240360000000	7567	3917	1	0	\N
18042	1513	12240360000000	7774	4031	1	0	\N
18043	1513	12240360000000	8045	4168	1	0	\N
18045	1513	12240370000000	7567	3917	2	0	\N
18046	1513	12240370000000	7774	4031	2	0	\N
18047	1513	12240370000000	8045	4168	2	0	\N
18049	1513	12240380000000	7295	3770	3	0	\N
18050	1513	12960370000000	8351	4325	3	0	\N
18051	1513	12960370000000	8358	4328	2	0	\N
18054	1513	12960381000000	8358	4328	3	0	\N
18055	1513	12960391000000	8351	4325	4	0	\N
18062	1513	15121440000000	9473	4719	67	0	\N
18065	1513	15841440000000	9473	4719	126	0	\N
18066	1513	15842020000000	9473	4719	127	0	\N
18069	1513	17280540000000	11234	5772	6	0	\N
18072	1513	17280573000000	11234	5772	7	0	\N
18075	1513	18720575000000	11728	6028	2	0	\N
18077	1513	18720577000000	11728	6028	3	0	\N
18082	1513	20160607000000	12226	6297	3	0	\N
18084	1513	20160610000000	12226	6297	4	0	\N
18088	1513	21600690000000	13289	6845	3	0	\N
17970	1513	1440010000000	1075	595	1	0	0
17971	1513	1440020000000	1075	595	2	0	0
17975	1513	2160020000000	2130	1125	1	0	0
17978	1513	2160030000000	2130	1125	2	0	0
17984	1513	2880030000000	3963	2060	1	0	0
17991	1513	3600040000000	4428	2296	1	0	0
17992	1513	3600050000000	4428	2296	2	0	0
17995	1513	4320050000000	4520	2338	1	0	0
17996	1513	4320060000000	4520	2338	2	0	0
17998	1513	5040060000000	4696	2428	3	0	0
18006	1513	5760090000000	5258	2729	0	0	0
18012	1513	6480090000000	5293	2749	1	0	0
18013	1513	6480100000000	5293	2749	2	0	0
18017	1513	7200100000000	6181	3200	1	0	0
18021	1513	7920110000000	6279	3252	1	0	0
18022	1513	7920120000000	6279	3252	2	0	0
18024	1513	8640120000000	6544	3391	2	0	0
18026	1513	8640140000000	6544	3391	3	0	0
18028	1513	9360140000000	6605	3416	2	0	0
18031	1513	9360180000000	6680	3453	2	0	0
18032	1513	10080180000000	6680	3453	6	0	0
18033	1513	10080210000000	6680	3453	7	0	0
18035	1513	10800210000000	7121	3679	5	0	0
18036	1513	10800350000000	7121	3679	6	0	0
18039	1513	11520360000000	7239	3741	2	0	0
18044	1513	12240360000000	8331	4313	1	0	0
18048	1513	12240370000000	8331	4313	2	0	0
17955	1511	720000000000	8357	4328	2	0	0
18052	1513	12960370000000	8521	4414	1	0	0
18053	1513	12960380000000	8521	4414	2	0	0
18056	1513	13680380000000	8543	4426	2	0	0
18057	1513	13680400000000	8543	4426	3	0	0
18058	1513	14400400000000	8613	4465	2	0	0
18060	1513	15120420000000	9016	4674	2	0	0
18061	1513	15120440000000	9016	4674	3	0	0
18063	1513	15840440000000	10919	5632	8	0	0
18064	1513	15840520000000	10919	5632	9	0	0
18067	1513	16560520000000	11031	5679	2	0	0
18070	1513	17280540000000	11273	5791	2	0	0
18071	1513	17280551000000	11273	5791	3	0	0
18073	1513	18000551000000	11625	5983	5	0	0
18074	1513	18000575000000	11625	5983	6	0	0
18078	1513	18720586000000	11768	6050	3	0	0
18079	1513	18720606000000	12203	6286	1	0	0
18080	1513	19440606000000	12203	6286	3	0	0
18081	1513	19440607000000	12203	6286	4	0	0
18083	1513	20160607000000	12809	6605	3	0	0
18086	1513	20880628000000	13132	6769	17	0	0
18087	1513	20880690000000	13132	6769	18	0	0
18091	1513	21600702000000	13289	6845	4	0	\N
18092	1513	22320700000000	13848	7107	16	0	\N
18093	1513	22320700000000	13928	7139	3	0	\N
18095	1513	22320712000000	13928	7139	4	0	\N
18096	1513	22320725000000	13848	7107	17	0	\N
18110	1513	27360832000000	15244	7765	2	0	\N
18112	1513	27360843000000	15244	7765	3	0	\N
18116	1513	28081396000000	17592	8765	35	0	\N
18117	1513	28800866000000	15377	7824	31	0	\N
18118	1513	28800866000000	16374	8233	17	0	\N
18119	1513	28800866000000	16924	8578	12	0	\N
18120	1513	28800866000000	17100	8664	2	0	\N
18121	1513	28800866000000	17133	8682	4	0	\N
18122	1513	28800866000000	18071	9113	2	0	\N
18124	1513	28800877000000	18071	9113	3	0	\N
18125	1513	28800888000000	17133	8682	5	0	\N
18127	1513	28800914000000	16924	8578	13	0	\N
18128	1513	28801014000000	15377	7824	32	0	\N
18129	1513	28801396000000	17592	8765	36	0	\N
18130	1513	28801586000000	16374	8233	18	0	\N
18131	1513	29520899000000	18459	9302	4	0	\N
18132	1513	29520899000000	18721	9433	3	0	\N
18133	1513	29520899000000	18935	9552	1	0	\N
18134	1513	29520899000000	19050	9608	5	0	\N
18136	1513	29520909000000	18935	9552	2	0	\N
18137	1513	29520911000000	18721	9433	4	0	\N
18139	1513	29520912000000	18459	9302	5	0	\N
18140	1513	29520940000000	19050	9608	6	0	\N
18142	1513	29521241000000	17919	8766	0	0	\N
18143	1513	29521586000000	16523	8234	9	0	\N
18144	1513	29521613000000	16523	8234	10	0	\N
18147	1513	30241613000000	16786	8235	18	0	\N
18148	1513	30241837000000	16786	8235	19	0	\N
18155	1513	33121021000000	19998	10069	5	0	\N
18158	1513	33121143000000	19998	10069	6	0	\N
18162	1513	33842837000000	23853	11634	106	0	\N
18163	1513	34561177000000	22737	11368	14	0	\N
18164	1513	34561177000000	22949	11466	3	0	\N
18165	1513	34561177000000	23163	11566	5	0	\N
18167	1513	34561189000000	22949	11466	4	0	\N
18168	1513	34561200000000	23163	11566	6	0	\N
18170	1513	34561227000000	22737	11368	15	0	\N
18171	1513	34562837000000	23853	11634	126	0	\N
18172	1513	34563027000000	23853	11634	127	0	\N
18173	1513	35281203000000	25317	12558	5	0	\N
18174	1513	35281203000000	25703	12668	2	0	\N
18175	1513	35281203000000	26333	13021	5	0	\N
18176	1513	35281203000000	27325	13508	3	0	\N
18177	1513	35281203000000	27567	13625	3	0	\N
18179	1513	35281205000000	25703	12668	3	0	\N
18180	1513	35281215000000	27325	13508	4	0	\N
18181	1513	35281215000000	27567	13625	4	0	\N
18183	1513	35281217000000	25317	12558	6	0	\N
18184	1513	35281226000000	26333	13021	6	0	\N
18185	1513	36001205000000	25835	12669	8	0	\N
18186	1513	36001213000000	25835	12669	9	0	\N
18191	1513	37441252999900	28169	13846	27	0	\N
18194	1513	37441306399900	28169	13846	28	0	\N
18195	1513	37441820000000	29208	14361	83	0	\N
18196	1513	38161278000000	28862	14234	3	0	\N
18197	1513	38161278000000	29048	14325	6	0	\N
18198	1513	38161290000000	28862	14234	4	0	\N
18199	1513	38161302000000	29048	14325	7	0	\N
18200	1513	38161306399900	28436	13847	41	0	\N
18201	1513	38161392399900	28436	13847	42	0	\N
18202	1513	38161820000000	29208	14361	126	0	\N
18203	1513	38161862000000	29208	14361	127	0	\N
18204	1513	38163202000000	29555	14362	83	0	\N
18205	1513	38881392399900	28542	13848	17	0	\N
18206	1513	38881425566570	28542	13848	18	0	\N
18207	1513	38883202000000	29555	14362	126	0	\N
18208	1513	38883622000000	29555	14362	127	0	\N
18209	1513	38884542000000	29589	14363	83	0	\N
18210	1513	39604542000000	29589	14363	97	0	\N
18211	1513	39604672000000	29589	14363	98	0	\N
18217	1514	9040300	23462	11539	109	0	\N
18219	1514	10079700	27224	13463	3	0	\N
18220	1514	10079700	27225	13463	3	0	\N
18221	1514	290999959	27270	13432	43	0	\N
18222	1514	291999958	23353	11407	105	0	\N
18223	1514	660030400	20912	10467	61	0	\N
18224	1514	1400000001	21870	10799	125	1	\N
18089	1513	21600690000000	13380	6895	1	0	0
18090	1513	21600700000000	13380	6895	2	0	0
18094	1513	22320700000000	13981	7163	16	0	0
18097	1513	22320734000000	13981	7163	17	0	0
18098	1513	23040734000000	14007	7178	13	0	0
18100	1513	23760756000000	14041	7191	8	0	0
18101	1513	23760782000000	14041	7191	9	0	0
18102	1513	24480782000000	14211	7254	4	0	0
18103	1513	24480795000000	14211	7254	5	0	0
18104	1513	25200795000000	14227	7264	4	0	0
18106	1513	25920808000000	14311	7303	4	0	0
18107	1513	25920821000000	14311	7303	5	0	0
18108	1513	26640821000000	14697	7484	2	0	0
18109	1513	26640832000000	14697	7484	3	0	0
18113	1513	27360854000000	15271	7778	5	0	0
18114	1513	28080854000000	15294	7794	3	0	0
18115	1513	28080866000000	15294	7794	4	0	0
18214	1514	10600	15349	7822	2	1	0
18215	1514	20500	18005	9083	7	1	0
18126	1513	28800899000000	18289	9216	7	0	0
18216	1514	30400	18342	9241	11	0	0
18135	1513	29520899000000	19629	9887	3	0	0
18138	1513	29520911000000	19629	9887	4	0	0
18141	1513	29520971000000	19678	9911	6	0	0
18146	1513	30240973000000	19678	9911	10	0	0
18149	1513	30960973000000	19784	9962	3	0	0
18150	1513	30960985000000	19784	9962	4	0	0
18151	1513	31680985000000	19791	9967	3	0	0
18153	1513	32400997000000	19981	10062	6	0	0
18154	1513	32401021000000	19981	10062	7	0	0
18156	1513	33121021000000	22303	11164	3	0	0
18157	1513	33121033000000	22303	11164	4	0	0
18159	1513	33121153000000	22482	11249	12	0	0
18161	1513	33841177000000	22482	11249	20	0	0
18218	1514	9099700	24967	12391	6	1	2
18166	1513	34561177000000	25081	12449	8	0	0
18169	1513	34561203000000	25081	12449	9	0	0
18178	1513	35281203000000	27660	13669	3	0	0
18187	1513	36001215000000	27881	13784	8	0	0
18188	1513	36001241000000	27881	13784	9	0	0
18189	1513	36721241000000	27924	13812	3	0	0
18190	1513	36721253000000	27924	13812	4	0	0
18193	1513	37441278000000	28840	14225	8	0	0
18226	1514	720009099700	26101	12901	4	0	\N
18228	1514	720031099700	26101	12901	5	0	\N
18229	1514	720660030400	20912	10467	126	0	\N
18230	1514	720850030400	20912	10467	127	0	\N
18231	1514	5409212990100	21737	10717	127	1	\N
18232	1514	9000300000000	16707	8428	127	0	\N
18233	1514	9000450000000	16784	8429	19	0	\N
18234	1514	16459747890100	16871	8556	14	1	\N
18235	1514	70320159995100	2174	1147	2	1	\N
18236	1514	75791445890100	23290	11485	81	1	\N
18237	1514	228965194998092	8731	4528	3	1	\N
18241	1515	100000005	8988	4661	8	1	\N
18246	1515	7922074999999	3499	1677	63	0	\N
18247	1515	66000007920000	8986	4661	8	0	\N
18248	1516	720000000000	329	189	1	0	\N
18251	1516	720010000000	329	189	2	0	\N
18256	1516	1440020000000	1831	979	1	0	\N
18258	1516	1440030000000	1831	979	2	0	\N
18260	1516	2160020000000	660	368	4	0	\N
18262	1516	2160060000000	660	368	5	0	\N
18266	1516	3600150000000	887	493	2	0	\N
18269	1516	3600170000000	887	493	3	0	\N
18278	1517	100000000	15520	7799	0	0	\N
18279	1517	200000000	15535	7800	0	0	\N
18280	1517	720000000000	511	286	1	0	\N
18281	1517	720010000000	511	286	2	0	\N
18282	1518	720000000000	162	96	2	0	\N
18285	1518	720020000000	162	96	3	0	\N
18288	1518	1440400000000	2569	1144	11	0	\N
18289	1518	2160020000000	2013	1062	1	0	\N
18290	1518	2160020000000	4798	2483	7	0	\N
18291	1518	2160020000000	5323	2765	1	0	\N
18292	1518	2160020000000	5325	2656	105	0	\N
18294	1518	2160030000000	2013	1062	2	0	\N
18295	1518	2160030000000	5323	2765	2	0	\N
18297	1518	2160399999990	2569	1144	13	0	\N
18298	1518	2160630000000	4798	2483	8	0	\N
18299	1518	2161250000000	5325	2656	106	0	\N
18300	1518	2879409999946	2586	1145	0	0	\N
18301	1518	2880040000000	7238	3741	1	0	\N
18302	1518	2880040000000	7621	3943	3	0	\N
18304	1518	2880050000000	7238	3741	2	0	\N
18305	1518	2880061000000	7621	3943	4	0	\N
18311	1518	5040291000000	10721	5534	6	0	\N
18312	1518	5040291000000	11539	5928	7	0	\N
18313	1518	5040291000000	11541	5928	7	0	\N
18316	1518	5040334000000	11539	5928	8	0	\N
18317	1518	5040334000000	11541	5928	8	0	\N
18318	1518	5040352000000	10721	5534	7	0	\N
18319	1518	5760292000000	12190	6276	3	0	\N
18320	1518	5760292000000	12192	6264	28	0	\N
18322	1518	5760295000000	12190	6276	4	0	\N
18323	1518	5760329000000	12192	6264	29	0	\N
18326	1518	6480329000000	12445	6265	58	0	\N
18327	1518	6483728000000	12445	6265	59	0	\N
18336	1518	10080381000000	15747	8008	7	0	\N
18339	1518	10080415000000	15747	8008	8	0	\N
18340	1518	10080963000000	23179	11538	98	0	\N
18341	1518	10800406000000	17844	9008	4	0	\N
18342	1518	10800406000000	21193	10641	3	0	\N
18343	1518	10800406000000	22085	11042	7	0	\N
18346	1518	10800419000000	17844	9008	5	0	\N
18347	1518	10800419000000	21193	10641	4	0	\N
18348	1518	10800431000000	22085	11042	8	0	\N
18349	1518	10800963000000	23179	11538	126	0	\N
18350	1518	10800990000000	23179	11538	127	0	\N
18351	1518	66000000000030	2569	1144	14	1	\N
18352	1519	720000000000	616	346	1	0	\N
18354	1519	720010000000	616	346	2	0	\N
18360	1519	2879020000000	5542	2881	0	0	\N
18254	1516	1440010000000	603	342	1	0	0
18255	1516	1440020000000	603	342	2	0	0
18261	1516	2160020000000	721	403	3	0	0
18263	1516	2160140000000	721	403	4	0	0
18264	1516	2880140000000	850	471	1	0	0
18283	1518	720000000000	868	481	1	0	0
18284	1518	720010000000	868	481	2	0	0
18267	1516	3600150000000	1032	572	1	0	0
18268	1516	3600160000000	1032	572	2	0	0
18353	1519	720000000000	1040	578	1	0	0
18286	1518	1440010000000	1176	648	1	0	0
18287	1518	1440020000000	1176	648	2	0	0
18270	1516	4320160000000	1320	727	5	0	0
18271	1516	4320210000000	1320	727	6	0	0
18273	1516	5040220000000	1636	882	2	0	0
18274	1516	5760220000000	1639	884	1	0	0
18275	1516	5760230000000	1639	884	2	0	0
18276	1516	6480230000000	1769	948	1	0	0
18277	1516	6480240000000	1769	948	2	0	0
18253	1516	720020000000	1819	974	3	0	1
18257	1516	1440020000000	2209	1162	2	0	1
18259	1516	1440040000000	2209	1162	3	0	1
18238	1515	4200600	2534	1333	4	1	0
18239	1515	12603400	2604	1370	4	0	0
18357	1519	1439010000000	4046	2101	2	0	1
18358	1519	2159010000000	4957	2569	1	0	1
18359	1519	2159020000000	4957	2569	2	0	1
18293	1518	2160020000000	7007	3614	2	0	0
18303	1518	2880040000000	7622	3943	3	0	0
18306	1518	2880061000000	7622	3943	4	0	0
18307	1518	3600061000000	9232	4785	2	0	0
18308	1518	3600081000000	9232	4785	3	0	0
18309	1518	4320081000000	10091	5235	12	0	0
18314	1518	5040291000000	11565	5945	1	0	0
18315	1518	5040292000000	11565	5945	2	0	0
18321	1518	5760292000000	12443	6414	0	0	0
18324	1518	6480292000000	13123	6765	4	0	0
18325	1518	6480305000000	13123	6765	5	0	0
18329	1518	7200317000000	13385	6898	4	0	0
18330	1518	7920317000000	13396	6903	7	0	0
18331	1518	7920342000000	13396	6903	8	0	0
18332	1518	8640342000000	14247	7273	8	0	0
18334	1518	9360368000000	14403	7349	4	0	0
18335	1518	9360381000000	14403	7349	5	0	0
18337	1518	10080381000000	16263	8265	7	0	0
18338	1518	10080406000000	16263	8265	8	0	0
18242	1515	720015603400	16482	8382	4	0	1
18244	1515	1440028603400	19806	9975	4	0	1
18245	1515	1440050603400	19806	9975	5	0	1
18225	1514	720000030400	20911	10512	2	0	0
18227	1514	720011030400	20911	10512	3	0	0
18344	1518	10800406000000	28082	13883	3	0	0
18361	1519	2879020000000	6192	3205	1	0	\N
18363	1519	2879030000000	6192	3205	2	0	\N
18367	1519	5039091000000	26888	13296	4	0	\N
18368	1519	5039104000000	26888	13296	5	0	\N
18369	1520	175000	27041	13249	42	1	\N
18370	1520	100000000	8728	4527	2	0	\N
18373	1520	100000002	20399	10186	90	0	\N
18375	1520	100000007	22931	11460	1	0	\N
18376	1520	100000007	22932	11460	0	0	\N
18379	1520	100000017	24204	12048	7	0	\N
18381	1520	112200000	22931	11460	2	1	\N
18382	1520	200000001	25120	12288	127	0	\N
18383	1520	1614000000	23130	11433	121	0	\N
18384	1520	1614100000	23130	11433	126	0	\N
18385	1520	720000000000	12288	6327	1	0	\N
18386	1520	720001000000	12288	6327	2	0	\N
18387	1520	720100000016	23167	11568	2	0	\N
18388	1520	720100000026	25722	12725	6	0	\N
18389	1520	720100000026	28074	13881	15	0	\N
18392	1520	720111000016	23167	11568	3	0	\N
18393	1520	720124000026	25722	12725	7	0	\N
18394	1520	720160000026	28074	13881	16	0	\N
18395	1520	720848999989	22933	11460	5	0	\N
18396	1520	8730129320098	23462	11539	108	1	\N
18397	1520	9376770469664	23353	11407	104	1	\N
18398	1520	9430151550053	23757	11774	126	1	\N
18399	1520	9791358999998	24586	12222	9	1	\N
18400	1520	17021063668958	27423	13436	43	0	\N
18401	1520	20832527756151	20559	10228	65	0	\N
18402	1520	71039729999999	3004	1359	70	1	\N
18403	1520	76805536999997	25120	12288	82	1	\N
18404	1520	1350607588999983	27284	13408	126	0	\N
18415	1521	2160047000000	25946	12822	5	0	\N
18418	1521	2160079000000	25946	12822	6	0	\N
18421	1521	2878069000000	27887	13789	3	0	\N
18422	1521	2878081000000	27887	13789	4	0	\N
18424	1521	2880069000000	27888	13789	3	0	\N
18425	1521	2880081000000	27888	13789	4	0	\N
18426	1522	1000000	26705	13209	12	0	\N
18427	1522	200004080	25038	12366	33	0	\N
18428	1522	720000000000	120	71	1	0	\N
18429	1522	720000000000	691	385	1	0	\N
18431	1522	720010000000	120	71	2	0	\N
18432	1522	720010000000	691	385	2	0	\N
18434	1522	1440010000000	1560	849	2	0	\N
18435	1522	1440010000000	1595	866	1	0	\N
18437	1522	1440020000000	1595	866	2	0	\N
18439	1522	1440030000000	1560	849	3	0	\N
18442	1522	2160020000000	1944	1032	1	0	\N
18443	1522	2160020000000	1946	998	47	0	\N
18444	1522	2160020000000	2279	1195	1	0	\N
18446	1522	2160030000000	1944	1032	2	0	\N
18447	1522	2160030000000	2279	1195	2	0	\N
18449	1522	2160490000000	1946	998	48	0	\N
18452	1522	2880030000000	2924	1522	2	0	\N
18453	1522	2880030000000	3342	1736	3	0	\N
18456	1522	2880050000000	2924	1522	3	0	\N
18457	1522	2880051000000	3342	1736	4	0	\N
18458	1522	2923261000000	21234	10664	2	0	\N
18378	1520	100000016	22973	11476	5	0	0
18460	1522	2923272000000	21234	10664	3	0	\N
18466	1522	3643305000000	21333	10708	3	0	\N
18467	1522	3643308000000	21333	10708	4	0	\N
18469	1522	3644258000000	21981	10813	64	0	\N
18472	1522	4320040000000	3558	1846	0	0	\N
18473	1522	4320040000000	3805	1972	3	0	\N
18476	1522	4320070000000	3805	1972	4	0	\N
18477	1522	4363518000000	21978	10989	3	0	\N
18479	1522	4363530000000	21978	10989	4	0	\N
18481	1522	4364258000000	21981	10813	126	0	\N
18482	1522	4364868000000	21981	10813	127	0	\N
18487	1522	5083531000000	22252	11136	7	0	\N
18488	1522	5083531000000	22263	11141	3	0	\N
18490	1522	5083543000000	22263	11141	4	0	\N
18492	1522	5083556000000	22252	11136	8	0	\N
18493	1522	5374010000000	12000	6176	2	0	\N
18494	1522	5374010000000	12045	6200	1	0	\N
18495	1522	5374010000000	12124	6245	1	0	\N
18496	1522	5374010000000	12305	6338	4	0	\N
18436	1522	1440010000000	1676	900	1	0	0
18438	1522	1440020000000	1676	900	2	0	0
18405	1521	720000000000	2149	1136	1	0	0
18407	1521	720010000000	2149	1136	2	0	0
18409	1521	1440010000000	2262	1188	4	0	0
18445	1522	2160020000000	2377	1243	1	0	0
18448	1522	2160030000000	2377	1243	2	0	0
18454	1522	2880030000000	3394	1766	1	0	0
18455	1522	2880040000000	3394	1766	2	0	0
18464	1522	3600040000000	3449	1790	0	0	0
18475	1522	4320050000000	4094	2128	2	0	0
18485	1522	5040050000000	4156	2162	2	0	0
18486	1522	5040160000000	4156	2162	3	0	0
18413	1521	2157080000000	5272	2738	2	0	1
18419	1521	2877100000000	8214	4258	1	0	1
18420	1521	2877110000000	8214	4258	2	0	1
18362	1519	2879020000000	8970	4652	5	0	1
18364	1519	2879065000000	8970	4652	6	0	1
18440	1522	1773890000000	9871	5120	2	0	10
18450	1522	2493910000000	10438	5399	4	0	10
18451	1522	2493950000000	10438	5399	5	0	10
18462	1522	3213950000000	10939	5639	2	0	10
18463	1522	3213970000000	10939	5639	3	0	10
18470	1522	3933970000000	11044	5683	2	0	10
18483	1522	4653990000000	11123	5718	2	0	10
18484	1522	4654010000000	11123	5718	3	0	10
18365	1519	3599065000000	16272	8271	8	0	1
18366	1519	3599091000000	16272	8271	9	0	1
18374	1520	100000006	20355	10252	5	1	0
18406	1521	720001000000	20461	10303	3	0	7
18408	1521	720013000000	20461	10303	4	0	7
18459	1522	2923261000000	21262	10678	8	0	14
18461	1522	2923305000000	21262	10678	9	0	14
18468	1522	3643518000000	21332	10708	6	0	14
18478	1522	4363518000000	22181	11099	4	0	14
18480	1522	4363531000000	22181	11099	5	0	14
18489	1522	5083531000000	22374	11200	3	0	14
18491	1522	5083543000000	22374	11200	4	0	14
18411	1521	1440047000000	22704	11351	8	0	7
18377	1520	100000015	22930	11460	5	0	0
18380	1520	100000026	25658	12697	8	0	0
18416	1521	2160047000000	25948	12823	4	0	7
18423	1521	2880068000000	27889	13789	3	0	7
18390	1520	720100000026	28077	13881	5	0	0
18391	1520	720105000026	28077	13881	6	0	0
18498	1522	5374011000000	12045	6200	2	0	\N
18499	1522	5374011000000	12124	6245	2	0	\N
18500	1522	5374012000000	12000	6176	3	0	\N
18503	1522	5374122000000	12305	6338	5	0	\N
18506	1522	5803543000000	23047	11424	23	0	\N
18509	1522	5803580000000	23059	11514	3	0	\N
18510	1522	5803584000000	23047	11424	24	0	\N
18511	1522	6094012000000	12990	6696	4	0	\N
18512	1522	6094012000000	13526	6961	0	0	\N
18513	1522	6094034000000	12990	6696	5	0	\N
18516	1522	6480170000000	4344	2251	1	0	\N
18518	1522	6480180000000	4344	2251	2	0	\N
18520	1522	6523568000000	23071	11518	3	0	\N
18521	1522	6523568000000	23988	11939	3	0	\N
18524	1522	6523580000000	23059	11514	5	0	\N
18525	1522	6523580000000	23071	11518	4	0	\N
18526	1522	6523580000000	23988	11939	4	0	\N
18527	1522	6523581000000	23059	11514	6	0	\N
18528	1522	6523584000000	23057	11425	0	0	\N
18529	1522	6814036000000	13775	7017	0	0	\N
18530	1522	6814036000000	13777	7027	0	0	\N
18532	1522	6814036000000	13779	7036	0	0	\N
18533	1522	6814036000000	13780	7046	0	0	\N
18535	1522	7200180000000	4462	2313	1	0	\N
18537	1522	7200190000000	4462	2313	2	0	\N
18540	1522	7243584000000	23069	11426	0	0	\N
18548	1522	8254101000000	14060	7197	8	0	\N
18549	1522	8254101000000	14379	7337	11	0	\N
18550	1522	8254101000000	14462	7383	4	0	\N
18553	1522	8254114000000	14462	7383	5	0	\N
18554	1522	8254118000000	14060	7197	9	0	\N
18555	1522	8254121000000	14379	7337	12	0	\N
18560	1522	8683722000000	25038	12366	24	0	\N
18565	1522	9403677000000	25036	12422	2	0	\N
18566	1522	9403677000000	25217	12510	4	0	\N
18567	1522	9403677000000	25355	12572	3	0	\N
18568	1522	9403677000000	25356	12572	2	0	\N
18569	1522	9403677000000	25377	12582	2	0	\N
18570	1522	9403677000000	25378	12582	3	0	\N
18571	1522	9403677000000	26042	12868	2	0	\N
18573	1522	9403688000000	25036	12422	3	0	\N
18574	1522	9403688000000	25356	12572	3	0	\N
18575	1522	9403688000000	25377	12582	3	0	\N
18576	1522	9403688000000	26042	12868	3	0	\N
18578	1522	9403689000000	25355	12572	4	0	\N
18579	1522	9403689000000	25378	12582	4	0	\N
18580	1522	9403690000000	25217	12510	5	0	\N
18581	1522	9403721999900	25038	12366	32	0	\N
18582	1522	9404068000000	26706	13053	38	0	\N
18583	1522	9694125000000	14946	7614	2	0	\N
18585	1522	9694136000000	14946	7614	3	0	\N
18589	1522	10123688000000	26705	13209	11	0	\N
18592	1522	10124068000000	26706	13053	126	0	\N
18593	1522	10124938000000	26706	13053	127	0	\N
18596	1522	10800230000000	5928	3071	2	0	\N
18597	1522	10800230000000	6141	3184	1	0	\N
18599	1522	10800240000000	6141	3184	2	0	\N
18600	1522	10800250000000	5928	3071	3	0	\N
18604	1522	11134147000000	15277	7753	1	0	\N
18605	1522	11134147000000	15278	7782	3	0	\N
18606	1522	11134147000000	15322	7809	1	0	\N
18608	1522	11134148000000	15277	7753	2	0	\N
18609	1522	11134157000000	15322	7809	2	0	\N
18610	1522	11134159000000	15278	7782	4	0	\N
18612	1522	11134170000000	16599	8434	1	0	\N
18616	1522	11563751000000	27019	13363	2	0	\N
18618	1522	11563762000000	27019	13363	3	0	\N
18620	1522	11563804000000	27487	13586	14	0	\N
18621	1522	11563804000000	27489	13586	14	0	\N
18622	1522	11854160000000	16087	8176	3	0	\N
18623	1522	11854170000000	16599	8434	4	0	\N
18625	1522	11854172000000	16087	8176	4	0	\N
18626	1522	11854172000000	16599	8434	5	0	\N
18630	1522	12241070000000	6563	3399	2	0	\N
18631	1522	12241090000000	6563	3399	3	0	\N
18632	1522	12283763000000	27095	13397	3	0	\N
18517	1522	6480170000000	4439	2301	1	0	0
18519	1522	6480180000000	4439	2301	2	0	0
18536	1522	7200180000000	4550	2355	1	0	0
18538	1522	7200190000000	4550	2355	2	0	0
18544	1522	7920190000000	4583	2370	1	0	0
18556	1522	8640200000000	4890	2534	1	0	0
18557	1522	8640210000000	4890	2534	2	0	0
18563	1522	9360210000000	5068	2629	1	0	0
18564	1522	9360220000000	5068	2629	2	0	0
18587	1522	10080220000000	5825	3022	1	0	0
18598	1522	10800230000000	6203	3210	10	0	0
18601	1522	10801050000000	6203	3210	11	0	0
18614	1522	11521050000000	6239	3227	2	0	0
18615	1522	11521070000000	6239	3227	3	0	0
18629	1522	12239980000000	7185	3713	2	0	1
18497	1522	5374010000000	12364	6375	2	0	10
18501	1522	5374012000000	12364	6375	3	0	10
18502	1522	5374035000000	13529	6964	5	0	10
18514	1522	6094035000000	13529	6964	7	0	10
18531	1522	6814036000000	13778	7078	16	0	10
18534	1522	6814088000000	13778	7078	17	0	10
18542	1522	7534088000000	13865	7116	4	0	10
18543	1522	7534101000000	13865	7116	5	0	10
18551	1522	8254101000000	14540	7417	3	0	10
18561	1522	8974113000000	14920	7602	3	0	10
18562	1522	8974125000000	14920	7602	4	0	10
18584	1522	9694125000000	15012	7648	2	0	10
18586	1522	9694136000000	15012	7648	3	0	10
18607	1522	11134147000000	16011	8142	4	0	10
18611	1522	11134160000000	16011	8142	5	0	10
18613	1522	11134170000000	16600	8434	1	0	10
18624	1522	11854170000000	16600	8434	4	0	10
18627	1522	11854172000000	16600	8434	5	0	10
18507	1522	5803543000000	23049	11508	7	0	14
18508	1522	5803568000000	23049	11508	8	0	14
18522	1522	6523568000000	24039	11962	2	0	14
18523	1522	6523579000000	24039	11962	3	0	14
18539	1522	7243579000000	24265	12073	15	0	14
18546	1522	7963639000000	24322	12097	7	0	14
18547	1522	7963665000000	24322	12097	8	0	14
18558	1522	8683665000000	24729	12281	3	0	14
18559	1522	8683677000000	24729	12281	4	0	14
18577	1522	9403688000000	26292	13005	3	0	14
18590	1522	10123688000000	26707	13209	11	0	14
18591	1522	10123726000000	26707	13209	12	0	14
18602	1522	10843726000000	26812	13259	7	0	14
18603	1522	10843751000000	26812	13259	8	0	14
18619	1522	11563763000000	27020	13363	4	0	14
18633	1522	12283763000000	27131	13417	9	0	\N
18635	1522	12283775000000	27095	13397	4	0	\N
18636	1522	12283799000000	27131	13417	10	0	\N
18637	1522	12283804000000	27487	13586	28	0	\N
18638	1522	12283804000000	27489	13586	28	0	\N
18639	1522	12283817000000	27487	13586	29	0	\N
18640	1522	12283817000000	27489	13586	29	0	\N
18642	1522	12574172000000	16607	8436	3	0	\N
18644	1522	12574184000000	16607	8436	4	0	\N
18646	1522	12959940000000	8224	4263	1	0	\N
18647	1522	12959940000000	8530	4419	2	0	\N
18649	1522	12959950000000	8224	4263	2	0	\N
18651	1522	12959960000000	8530	4419	3	0	\N
18652	1522	13003823000000	27570	13627	3	0	\N
18654	1522	13003835000000	27570	13627	4	0	\N
18656	1522	13294184000000	16905	8572	3	0	\N
18657	1522	13294184000000	16927	8580	3	0	\N
18658	1522	13294184000000	17122	8676	2	0	\N
18660	1522	13294195000000	17122	8676	3	0	\N
18661	1522	13294196000000	16905	8572	4	0	\N
18662	1522	13294196000000	16927	8580	4	0	\N
18666	1522	13723835000000	28121	13903	2	0	\N
18667	1522	13723835000000	28122	13903	2	0	\N
18668	1522	13723835000000	28126	13903	2	0	\N
18669	1522	13723835000000	28133	13906	3	0	\N
18671	1522	13723846000000	28121	13903	3	0	\N
18672	1522	13723846000000	28122	13903	3	0	\N
18673	1522	13723846000000	28126	13903	3	0	\N
18675	1522	13723856000000	28133	13906	4	0	\N
18676	1522	14014196000000	17956	9057	3	0	\N
18677	1522	14014196000000	18124	9140	5	0	\N
18680	1522	14014208000000	17956	9057	4	0	\N
18681	1522	14014219000000	18124	9140	6	0	\N
18689	1522	15163857000000	28775	14194	3	0	\N
18691	1522	15163869000000	28775	14194	4	0	\N
18705	1522	17323915000000	29433	14510	3	0	\N
18706	1522	17323915000000	29434	14510	3	0	\N
18708	1522	17323927000000	29433	14510	4	0	\N
18709	1522	17323927000000	29434	14510	4	0	\N
18712	1522	17323978000000	30113	14820	11	0	\N
18713	1522	17614262000000	19376	9768	3	0	\N
18715	1522	17614274000000	19376	9768	4	0	\N
18717	1522	18043940000000	29961	14757	5	0	\N
18718	1522	18043954000000	29961	14757	6	0	\N
18720	1522	18043978000000	30113	14820	53	0	\N
18722	1522	18044019000000	30113	14820	54	0	\N
18723	1522	18334288000000	19469	9815	1	0	\N
18724	1522	18334288000000	19470	9815	3	0	\N
18725	1522	18334288000000	19776	9958	3	0	\N
18727	1522	18334298000000	19469	9815	2	0	\N
18728	1522	18334300000000	19470	9815	4	0	\N
18729	1522	18334300000000	19776	9958	4	0	\N
18731	1524	720000000000	373	213	1	0	\N
18732	1524	720000000000	14172	7235	4	0	\N
18733	1524	720000000000	18791	9469	2	0	\N
18734	1524	720010000000	373	213	2	0	\N
18735	1524	720011000000	18791	9469	3	0	\N
18736	1524	720013000000	14172	7235	5	0	\N
18742	1527	9050200	23353	11407	105	1	\N
18743	1527	9099714	27270	13432	43	1	\N
18744	1527	200000012	27423	13436	44	1	\N
18747	1527	261999988	12503	6442	2	0	\N
18749	1527	263999986	14859	7572	2	0	\N
18750	1527	263999986	14896	7420	0	0	\N
18753	1527	265999984	14859	7572	4	0	\N
18754	1527	269999980	14854	7571	11	0	\N
18756	1527	272999977	18367	9112	127	0	\N
18758	1527	273999976	21328	10707	3	0	\N
18751	1527	263999986	15516	7895	3	0	0
18762	1527	287999962	24025	11956	6	0	0
18764	1527	290999959	26974	13340	4	0	\N
18765	1527	290999959	27030	13356	34	0	\N
18766	1527	290999959	28569	13882	26	0	\N
18767	1527	291999958	25191	12497	7	0	\N
18768	1527	294999955	23017	11497	15	0	\N
18664	1522	13679950000000	8583	4450	1	0	3
18665	1522	13679960000000	8583	4450	2	0	3
18682	1522	14399960000000	8634	4474	0	0	3
18687	1522	15119960000000	8679	4498	1	0	3
18688	1522	15119970000000	8679	4498	2	0	3
18696	1522	15839930000000	9772	5064	3	0	6
18737	1525	720000000000	11563	5944	2	0	0
18738	1525	720002000000	11563	5944	3	0	0
18746	1527	260999989	12501	6441	3	1	0
18748	1527	262999987	14257	7279	6	1	0
18752	1527	264999985	15516	7895	4	1	0
18755	1527	271999978	15551	7916	11	0	0
18643	1522	12574172000000	16790	8521	3	0	10
18645	1522	12574184000000	16790	8521	4	0	10
18663	1522	13294196000000	17597	8902	4	0	10
18678	1522	14014196000000	18230	9183	2	0	10
18679	1522	14014207000000	18230	9183	3	0	10
18685	1522	14734207000000	18296	9219	2	0	10
18686	1522	14734218000000	18296	9219	3	0	10
18694	1522	15454229000000	18371	9258	3	0	10
18699	1522	16174229000000	18401	9276	2	0	10
18700	1522	16174240000000	18401	9276	3	0	10
18703	1522	16894240000000	18719	9431	4	0	10
18704	1522	16894262000000	18719	9431	5	0	10
18716	1522	17614288000000	19433	9795	9	0	10
18726	1522	18334288000000	19965	10054	4	0	10
18730	1522	18334301000000	19965	10054	5	0	10
18757	1527	272999977	20761	10436	16	0	0
18760	1527	277999972	21651	10846	4	1	0
18761	1527	286999963	22153	11083	12	1	0
18763	1527	289999960	25145	12476	5	1	0
18634	1522	12283763000000	27507	13599	15	0	14
18641	1522	12283823000000	27507	13599	16	0	14
18655	1522	13003835000000	27822	13750	4	0	14
18740	1526	1440000000000	28194	13937	2	0	0
18741	1526	1440011000000	28194	13937	3	0	0
18670	1522	13723835000000	28338	14009	2	0	14
18674	1522	13723846000000	28338	14009	3	0	14
18684	1522	14443857000000	28481	14076	3	0	14
18690	1522	15163857000000	29028	14315	7	0	14
18692	1522	15163891000000	29028	14315	8	0	14
18697	1522	15883891000000	29092	14343	3	0	14
18701	1522	16603903000000	29373	14478	3	0	14
18702	1522	16603915000000	29373	14478	4	0	14
18707	1522	17323915000000	29510	14555	7	0	14
18710	1522	17323940000000	29510	14555	8	0	14
18711	1522	17323978000000	30111	14820	11	0	14
18721	1522	18044019000000	30111	14820	54	0	14
18769	1527	297999952	25146	12477	5	0	\N
18770	1527	298999951	28626	13884	18	0	\N
18773	1527	306999943	29783	14666	77	1	\N
18774	1527	306999943	29876	14690	126	0	\N
18775	1527	306999943	30191	14852	13	1	\N
18779	1527	314999935	30223	14735	54	0	\N
18780	1527	323999926	30223	14735	106	0	\N
18781	1527	8053021459	14021	7185	12	1	\N
18782	1527	8053021459	14022	7185	12	1	\N
18783	1527	720458000001	26459	13060	119	1	\N
18784	1527	3312042151232	20966	10546	5	0	\N
18785	1527	3735107000002	21365	10722	8	1	\N
18786	1527	4752105151480	21532	10801	6	0	\N
18787	1527	5352355998478	12015	6134	81	1	\N
18788	1527	6210656000002	21328	10707	4	1	\N
18789	1527	6671590641005	12595	6493	3	1	\N
18790	1527	9360487967165	27069	13248	127	1	\N
18791	1527	9380427000001	15258	7772	12	1	\N
18792	1527	9450132320099	23462	11539	115	1	\N
18793	1527	15840301001016	13466	6753	78	0	\N
18794	1527	60121328904003	12503	6442	3	1	\N
18795	1527	66720002000000	20646	10357	125	1	\N
18796	1527	66720002000000	21871	10800	12	1	\N
18797	1527	77232242880091	23397	11486	99	1	\N
18798	1527	187926787000001	26894	13247	32	1	\N
18799	1527	1350606478700002	23366	11487	3	0	\N
18800	1527	58047024472007707	16682	8474	9	1	\N
18801	1528	720000000000	5718	2964	2	0	\N
18804	1528	720200000000	5718	2964	3	0	\N
18805	1531	8400000	2760	1231	120	1	\N
18818	1534	200000004	14811	7547	3	1	\N
18821	1534	1440060000000	14292	7294	0	0	\N
18824	1534	2160072000000	14583	7436	1	0	\N
18826	1534	2160073000000	14583	7436	2	0	\N
18828	1534	2880093999999	14811	7547	2	0	\N
18830	1534	2880094000000	14813	7547	9	0	\N
18832	1534	2880148000000	14813	7547	10	0	\N
18837	1534	5040181000000	15203	7747	3	0	\N
18838	1534	5040193000000	15203	7747	4	0	\N
18843	1536	200000002	21392	10709	126	0	\N
18845	1536	720000000000	9853	5108	3	0	\N
18846	1536	720000000000	10385	5370	2	0	\N
18851	1536	720020000000	10385	5370	3	0	\N
18852	1536	720030000000	9853	5108	4	0	\N
18854	1536	721071000000	21392	10709	111	0	\N
18856	1536	1440012000000	20754	10433	5	0	\N
18860	1536	1440026000000	20754	10433	6	0	\N
18862	1536	1440040000000	10649	5500	2	0	\N
18864	1536	1440060000000	10649	5500	3	0	\N
18865	1536	1441071000000	21392	10709	125	0	\N
18867	1536	2160024000000	21546	10804	3	0	\N
18871	1536	2160054000000	21546	10804	4	0	\N
18874	1536	2161083999989	21547	10710	0	0	\N
18875	1536	2783683999989	21606	10711	0	0	\N
18876	1536	2880036000000	21632	10838	3	0	\N
18877	1536	2880036000000	21634	10838	4	0	\N
18879	1536	2880036000000	21711	10875	3	0	\N
18880	1536	2880050000000	737	414	1	0	\N
18881	1536	2880050000000	750	420	1	0	\N
18883	1536	2880057000000	21632	10838	4	0	\N
18884	1536	2880057000000	21711	10875	4	0	\N
18885	1536	2880058000000	21634	10838	5	0	\N
18887	1536	2880060000000	737	414	2	0	\N
18888	1536	2880060000000	750	420	2	0	\N
18890	1536	2880070000000	10952	5644	1	0	\N
18891	1536	2880070000000	11014	5671	6	0	\N
18893	1536	2880080000000	10952	5644	2	0	\N
18894	1536	2880490000000	11014	5671	7	0	\N
18896	1536	3600059000000	21723	10882	3	0	\N
18898	1536	3600060000000	891	495	3	0	\N
18899	1536	3600060000000	1082	601	1	0	\N
18901	1536	3600070000000	1082	601	2	0	\N
18902	1536	3600071000000	21723	10882	4	0	\N
18904	1536	3600081000000	891	495	4	0	\N
18855	1536	1440010000000	378	214	1	0	0
18858	1536	1440020000000	378	214	2	0	0
18866	1536	2160020000000	490	272	3	0	0
18870	1536	2160050000000	490	272	4	0	0
18882	1536	2880050000000	873	483	1	0	0
18806	1531	720000000000	1092	604	9	0	0
18807	1531	720090000000	1092	604	10	0	0
18900	1536	3600060000000	1166	642	2	0	0
18903	1536	3600080000000	1166	642	3	0	0
18808	1532	720000000000	9018	4676	5	0	0
18847	1536	720000000000	10391	5372	4	0	6
18853	1536	720040000000	10391	5372	5	0	6
18861	1536	1440040000000	10647	5500	2	0	6
18863	1536	1440060000000	10647	5500	3	0	6
18873	1536	2160070000000	10709	5529	2	0	6
18892	1536	2880070000000	11015	5671	6	0	6
18895	1536	2880490000000	11015	5671	7	0	6
18819	1534	720000000000	14276	7288	6	0	0
18820	1534	720060000000	14276	7288	7	0	0
18823	1534	1440072000000	14416	7355	4	0	0
18839	1535	720000000000	14690	7481	6	0	0
18840	1535	720051000000	14690	7481	7	0	0
18825	1534	2160072000000	14741	7504	4	0	0
18827	1534	2160094000000	14741	7504	5	0	0
18831	1534	2880148000000	14812	7547	10	0	0
18833	1534	3600148000000	15111	7700	4	0	0
18834	1534	3600170000000	15111	7700	5	0	0
18835	1534	4320170000000	15157	7726	2	0	0
18841	1535	1440051000000	17727	8959	7	0	0
18842	1535	1440076000000	17727	8959	8	0	0
18848	1536	720000000000	20463	10304	3	0	11
18850	1536	720012000000	20463	10304	4	0	11
18857	1536	1440012000000	21391	10732	3	0	11
18868	1536	2160024000000	21607	10828	3	0	11
18869	1536	2160036000000	21607	10828	4	0	11
18878	1536	2880036000000	21710	10875	5	0	11
18886	1536	2880059000000	21710	10875	6	0	11
18897	1536	3600059000000	22335	11179	7	0	11
18817	1533	720010000000	24100	11997	2	0	0
18802	1528	720000000000	28015	13855	3	0	0
18803	1528	720012000000	28015	13855	4	0	0
18810	1532	1440045000000	28283	13982	3	0	0
18771	1527	300999949	28691	14165	5	0	0
18772	1527	305999944	28694	14166	3	1	0
18812	1532	2160057000000	28856	14233	17	0	0
18813	1532	2160124538460	28856	14233	18	0	0
18814	1532	2880124538460	29775	14675	28	0	0
18776	1527	306999943	30192	14852	13	1	0
18777	1527	308999941	30238	14866	28	0	0
18778	1527	309999940	30277	14888	16	0	0
18914	1536	5040090000000	1657	893	1	0	\N
18917	1536	5040100000000	1657	893	2	0	\N
18920	1536	5040550000000	11236	5773	2	0	\N
18922	1536	5040561000000	11236	5773	3	0	\N
18926	1536	5760130000000	1733	931	1	0	\N
18927	1536	5760130000000	2012	1062	1	0	\N
18929	1536	5760140000000	1733	931	2	0	\N
18930	1536	5760140000000	2012	1062	2	0	\N
18936	1536	6480140000000	2264	1189	2	0	\N
18937	1536	6480140000000	2385	1247	1	0	\N
18939	1536	6480150000000	2385	1247	2	0	\N
18940	1536	6480160000000	2264	1189	3	0	\N
18942	1536	6480583000000	11458	5888	2	0	\N
18943	1536	6480583000000	11657	5995	1	0	\N
18945	1536	6480584000000	11657	5995	2	0	\N
18947	1536	6480594000000	11458	5888	3	0	\N
18958	1536	7920585000000	12164	6263	0	0	\N
18965	1536	8640586000000	12216	6293	2	0	\N
18967	1536	8640588000000	12216	6293	3	0	\N
18977	1536	10080220000000	3278	1702	4	0	\N
18978	1536	10080220000000	3425	1780	3	0	\N
18979	1536	10080220000000	3592	1866	0	0	\N
18981	1536	10080220000000	3910	1864	0	0	\N
18982	1536	10080220000000	3913	1882	0	0	\N
18983	1536	10080220000000	3914	1899	0	0	\N
18984	1536	10080220000000	3915	1914	0	0	\N
18985	1536	10080220000000	3916	1930	0	0	\N
18987	1536	10080250000000	3425	1780	4	0	\N
18988	1536	10080260000000	3278	1702	5	0	\N
18990	1536	10080619000000	12956	6680	1	0	\N
18991	1536	10080619000000	12957	6680	2	0	\N
18992	1536	10080619000000	12995	6700	4	0	\N
18993	1536	10080620000000	12956	6680	2	0	\N
18994	1536	10080630000000	12957	6680	3	0	\N
18996	1536	10080641000000	12995	6700	5	0	\N
19001	1536	10800640999959	13022	6713	2	0	\N
19003	1536	10800651999959	13022	6713	3	0	\N
19005	1536	11520220000000	23891	11893	3	0	\N
19006	1536	11520220000000	23892	11893	3	0	\N
19008	1536	11520232000000	23891	11893	4	0	\N
19009	1536	11520232000000	23892	11893	4	0	\N
19011	1536	11520250000000	4119	2141	2	0	\N
19014	1536	11520270000000	4119	2141	3	0	\N
19015	1536	11520652999959	13675	7027	3	0	\N
19016	1536	11520652999959	14075	7202	0	0	\N
19018	1536	11520664999959	13675	7027	4	0	\N
19022	1536	12240260000000	4363	2263	2	0	\N
19025	1536	12240280000000	4363	2263	3	0	\N
19026	1536	12240678999959	14405	7350	2	0	\N
19028	1536	12240680999959	14405	7350	3	0	\N
19032	1536	12960270000000	4735	2448	1	0	\N
19034	1536	12960280000000	4735	2448	2	0	\N
18915	1536	5040090000000	1709	918	4	0	0
18919	1536	5040130000000	1709	918	5	0	0
18928	1536	5760130000000	2043	1079	1	0	0
18931	1536	5760140000000	2043	1079	2	0	0
18938	1536	6480140000000	2595	1367	2	0	0
18950	1536	7200160000000	2797	1463	1	0	0
18951	1536	7200170000000	2797	1463	2	0	0
18956	1536	7920170000000	3010	1563	2	0	0
18957	1536	7920190000000	3010	1563	3	0	0
18963	1536	8640190000000	3028	1572	1	0	0
18971	1536	9360200000000	3036	1577	2	0	0
18972	1536	9360220000000	3036	1577	3	0	0
18980	1536	10080220000000	3873	2011	1	0	0
18986	1536	10080230000000	3873	2011	2	0	0
19000	1536	10800250000000	3912	2031	3	0	0
19012	1536	11520250000000	4272	2216	1	0	0
19013	1536	11520260000000	4272	2216	2	0	0
19023	1536	12240260000000	4700	2430	1	0	0
19024	1536	12240270000000	4700	2430	2	0	0
19035	1536	12960280000000	5113	2654	2	0	0
19039	1536	13680280000000	5377	2797	0	0	0
18906	1536	3600490000000	11088	5705	2	0	6
18907	1536	3600510000000	11088	5705	3	0	6
18912	1536	4320510000000	11151	5731	4	0	6
18921	1536	5040550000000	11294	5802	4	0	6
18923	1536	5040572000000	11294	5802	5	0	6
18932	1536	5760572000000	11313	5810	2	0	6
18933	1536	5760583000000	11313	5810	3	0	6
18946	1536	6480584000000	11674	6001	2	0	6
18952	1536	7200584000000	11985	6169	1	0	6
18953	1536	7200585000000	11985	6169	2	0	6
18959	1536	7920585000000	12170	6266	1	0	6
18960	1536	7920586000000	12170	6266	2	0	6
18968	1536	8640597000000	12615	6508	3	0	6
18973	1536	9360597000000	12917	6657	4	0	6
18974	1536	9360619000000	12917	6657	5	0	6
18989	1536	10080618999999	12994	6700	4	0	6
18995	1536	10080640999959	12994	6700	5	0	6
19004	1536	10800652999959	13277	6838	4	0	6
19017	1536	11520652999959	14345	7322	8	0	6
19019	1536	11520678999959	14345	7322	9	0	6
19027	1536	12240678999959	14558	7424	3	0	6
19036	1536	12960690999959	15234	7759	3	0	6
19037	1536	12960702999959	15234	7759	4	0	6
18905	1536	3600084000000	22335	11179	8	0	11
18909	1536	4320084000000	22381	11205	4	0	11
18911	1536	4320097000000	22381	11205	5	0	11
18918	1536	5040109000000	22571	11292	4	0	11
18924	1536	5760109000000	22586	11300	4	0	11
18925	1536	5760122000000	22586	11300	5	0	11
18934	1536	6480122000000	22708	11352	2	0	11
18935	1536	6480133000000	22708	11352	3	0	11
18949	1536	7200145000000	23455	11696	4	0	11
18954	1536	7920145000000	23473	11704	3	0	11
18955	1536	7920157000000	23473	11704	4	0	11
18961	1536	8640157000000	23645	11779	3	0	11
18969	1536	9360169000000	23684	11793	9	0	11
18970	1536	9360196000000	23684	11793	10	0	11
18975	1536	10080196000000	23838	11864	3	0	11
18976	1536	10080208000000	23838	11864	4	0	11
18997	1536	10800208000000	23849	11871	3	0	11
19007	1536	11520220000000	24316	12092	3	0	11
19010	1536	11520232000000	24316	12092	4	0	11
19020	1536	12240232000000	24350	12110	6	0	11
19021	1536	12240256000000	24350	12110	7	0	11
19030	1536	12960256000000	24398	12131	2	0	11
19038	1536	13680267000000	24448	12159	4	0	11
19040	1536	13680289000000	24448	12159	5	0	11
19041	1536	13680702999959	15238	7760	2	0	\N
19042	1536	13680702999959	15643	7960	2	0	\N
19044	1536	13680713999959	15238	7760	3	0	\N
19045	1536	13680713999959	15643	7960	3	0	\N
19047	1536	14400280000000	5485	2855	0	0	\N
19049	1536	14400289000000	24721	12277	8	0	\N
19052	1536	14400351000000	24721	12277	9	0	\N
19053	1536	14400713999959	16348	8313	3	0	\N
19055	1536	14400725999959	16348	8313	4	0	\N
19057	1536	14400785999959	19218	9695	7	0	\N
19058	1536	15120280000000	5846	3033	1	0	\N
19059	1536	15120280000000	6287	3257	1	0	\N
19061	1536	15120290000000	5846	3033	2	0	\N
19062	1536	15120290000000	6287	3257	2	0	\N
19066	1536	15120751999959	17082	8653	4	0	\N
19067	1536	15120751999959	18547	9345	4	0	\N
19070	1536	15120773999959	17082	8653	5	0	\N
19071	1536	15120785999959	19218	9695	11	0	\N
19072	1536	15120788999959	19218	9695	12	0	\N
19073	1536	15120863999959	18547	9345	5	0	\N
19075	1536	15840314000000	25080	12449	8	0	\N
19076	1536	15840314000000	25245	12521	7	0	\N
19079	1536	15840339000000	25245	12521	8	0	\N
19080	1536	15840340000000	25080	12449	9	0	\N
19082	1536	15840763999959	19662	9905	5	0	\N
19083	1536	15840763999959	19663	9905	3	0	\N
19085	1536	15840763999959	19755	9945	2	0	\N
19086	1536	15840765999959	19755	9945	3	0	\N
19088	1536	15840793999959	19663	9905	4	0	\N
19089	1536	15840804999959	19662	9905	6	0	\N
19090	1536	16560326000000	25665	12702	2	0	\N
19092	1536	16560337000000	25665	12702	3	0	\N
19095	1536	16560390000000	7376	3808	1	0	\N
19097	1536	16560400000000	7376	3808	2	0	\N
19100	1536	17280338000000	25738	12734	5	0	\N
19103	1536	17280352000000	25738	12734	6	0	\N
19104	1536	17280400000000	7429	3839	1	0	\N
19105	1536	17280400000000	7444	3848	1	0	\N
19106	1536	17280400000000	7908	4097	1	0	\N
19107	1536	17280400000000	8278	4288	2	0	\N
19108	1536	17280400000000	8422	4364	0	0	\N
19110	1536	17280410000000	7429	3839	2	0	\N
19111	1536	17280410000000	7444	3848	2	0	\N
19112	1536	17280410000000	7908	4097	2	0	\N
19113	1536	17280411000000	8278	4288	3	0	\N
19119	1536	18000420000000	9089	4713	11	0	\N
19122	1536	18000512000000	9089	4713	12	0	\N
19123	1536	18720360000000	26405	13064	4	0	\N
19125	1536	18720373000000	26405	13064	5	0	\N
19127	1536	18720440000000	9419	4841	0	0	\N
19129	1536	18720440000000	9421	4843	0	0	\N
19130	1536	18720440000000	9422	4845	0	0	\N
19131	1536	18720440000000	9423	4847	0	0	\N
19135	1536	20160387000000	27877	13783	3	0	\N
19137	1536	20160399000000	27877	13783	4	0	\N
19139	1536	20880399000000	28330	14006	6	0	\N
19142	1536	20880432000000	28330	14006	7	0	\N
19143	1536	21600422000000	28584	14116	4	0	\N
19146	1536	21600435000000	28584	14116	5	0	\N
19147	1536	22320433000000	28893	14253	4	0	\N
19150	1536	22320446000000	28893	14253	5	0	\N
19155	1537	10000000	2173	1147	0	0	\N
19156	1537	10000000	2318	936	0	0	\N
19157	1538	200000001	23877	11814	127	0	\N
19159	1539	2000000	12725	6431	36	0	\N
19160	1539	720001000000	14143	7222	6	0	\N
19163	1539	720025000000	14143	7222	7	0	\N
19165	1540	720000000000	14351	7325	7	0	\N
19167	1540	720000000000	20435	10293	10	0	\N
19168	1540	720000000000	20437	10293	11	0	\N
19169	1540	720000000000	24927	12375	7	0	\N
19170	1540	720000000000	24931	12375	0	0	\N
19171	1540	720000000000	28854	14231	6	0	\N
19174	1540	720019000000	20435	10293	11	0	\N
19175	1540	720020000000	20437	10293	12	0	\N
19176	1540	720024000000	28854	14231	7	0	\N
19048	1536	14400280000000	5566	2894	0	0	0
19060	1536	15120280000000	6745	3490	2	0	0
19063	1536	15120300000000	6745	3490	3	0	0
19074	1536	15840300000000	7360	3803	9	0	0
19081	1536	15840390000000	7360	3803	10	0	0
19096	1536	16560400000000	7374	3808	2	0	0
19109	1536	17280400000000	8913	4618	2	0	0
19114	1536	17280420000000	8913	4618	3	0	0
19120	1536	18000420000000	9140	4735	2	0	0
19121	1536	18000440000000	9140	4735	3	0	0
19132	1536	18720460000000	9420	4888	3	0	0
19043	1536	13680702999959	16247	8258	2	0	6
19046	1536	13680713999959	16247	8258	3	0	6
19054	1536	14400713999959	16389	8337	11	0	6
19166	1540	720000000000	17789	8987	3	0	4
19173	1540	720012000000	17789	8987	4	0	4
19068	1536	15120751999959	19250	9706	3	0	6
19069	1536	15120763999959	19250	9706	4	0	6
19084	1536	15840763999959	19754	9945	3	0	6
19098	1536	16560775999959	19909	10026	4	0	6
19099	1536	16560887999959	19909	10026	5	0	6
19115	1536	17280887999959	20113	10125	4	0	6
19116	1536	17280900999959	20113	10125	5	0	6
19050	1536	14400289000000	24872	12349	3	0	11
19064	1536	15120301000000	25076	12447	4	0	11
19065	1536	15120314000000	25076	12447	5	0	11
19161	1539	720001000000	25086	12453	4	0	0
19162	1539	720014000000	25086	12453	5	0	0
19078	1536	15840326000000	25478	12618	4	0	11
19091	1536	16560326000000	25666	12702	3	0	11
19093	1536	16560338000000	25666	12702	4	0	11
19101	1536	17280338000000	25934	12817	2	0	11
19102	1536	17280349000000	25934	12817	3	0	11
19118	1536	18000360000000	26135	12919	3	0	11
19124	1536	18720360000000	27790	13733	3	0	11
19126	1536	18720375000000	27790	13733	4	0	11
19133	1536	19440375000000	27867	13778	3	0	11
19134	1536	19440387000000	27867	13778	4	0	11
19138	1536	20160399000000	28229	13957	4	0	11
19140	1536	20880399000000	28580	14115	5	0	11
19141	1536	20880422000000	28580	14115	6	0	11
19144	1536	21600422000000	28739	14181	2	0	11
19148	1536	22320433000000	28998	14297	3	0	11
19149	1536	22320445000000	28998	14297	4	0	11
19151	1536	23040445000000	29556	14571	3	0	11
19152	1536	23040460000000	29556	14571	4	0	11
19153	1536	23760460000000	29590	14590	5	0	11
19177	1540	720025000000	14351	7325	8	0	\N
19178	1540	720034000000	24927	12375	8	0	\N
19181	1541	722036000000	15249	7769	3	0	\N
19182	1541	722036000000	15393	7840	2	0	\N
19183	1541	722036000000	16249	8258	2	0	\N
19184	1541	722036000000	16660	8464	9	0	\N
19185	1541	722036000000	16684	8475	2	0	\N
19186	1541	722036000000	17423	8825	6	0	\N
19187	1541	722036000000	17541	8883	5	0	\N
19188	1541	722036000000	17624	8912	3	0	\N
19189	1541	722036000000	18313	9225	3	0	\N
19190	1541	722036000000	18456	9302	3	0	\N
19192	1541	722047000000	15393	7840	3	0	\N
19193	1541	722047000000	16249	8258	3	0	\N
19194	1541	722047000000	16684	8475	3	0	\N
19195	1541	722048000000	15249	7769	4	0	\N
19196	1541	722048000000	17624	8912	4	0	\N
19197	1541	722048000000	18313	9225	4	0	\N
19198	1541	722048000000	18456	9302	4	0	\N
19200	1541	722059000000	17541	8883	6	0	\N
19201	1541	722060000000	17423	8825	7	0	\N
19202	1541	722072000000	16660	8464	10	0	\N
19203	1541	1440010000000	234	138	1	0	\N
19204	1541	1440010000000	854	474	4	0	\N
19206	1541	1440020000000	234	138	2	0	\N
19208	1541	1440030000000	1788	957	1	0	\N
19209	1541	1440050000000	854	474	5	0	\N
19210	1541	1442049000000	21715	10877	6	0	\N
19211	1541	1442049000000	21827	10924	6	0	\N
19212	1541	1442049000000	21856	10937	9	0	\N
19213	1541	1442049000000	21880	10948	6	0	\N
19214	1541	1442049000000	21909	10962	6	0	\N
19215	1541	1442049000000	21982	10989	3	0	\N
19216	1541	1442049000000	22021	11009	4	0	\N
19218	1541	1442061000000	21982	10989	4	0	\N
19219	1541	1442062000000	22021	11009	5	0	\N
19220	1541	1442073000000	21715	10877	7	0	\N
19221	1541	1442073000000	21827	10924	7	0	\N
19222	1541	1442073000000	21880	10948	7	0	\N
19223	1541	1442073000000	21909	10962	7	0	\N
19224	1541	1442085000000	21856	10937	10	0	\N
19226	1541	2160020000000	1111	613	1	0	\N
19227	1541	2160020000000	1155	636	1	0	\N
19228	1541	2160020000000	1580	860	3	0	\N
19229	1541	2160020000000	1596	866	1	0	\N
19230	1541	2160020000000	1909	1016	1	0	\N
19232	1541	2160030000000	1111	613	2	0	\N
19233	1541	2160030000000	1155	636	2	0	\N
19234	1541	2160030000000	1596	866	2	0	\N
19235	1541	2160030000000	1788	957	2	0	\N
19236	1541	2160030000000	1909	1016	2	0	\N
19237	1541	2160050000000	1580	860	4	0	\N
19241	1541	2880060000000	2470	1294	1	0	\N
19243	1541	2880070000000	2470	1294	2	0	\N
19245	1541	2881380000000	2804	1334	121	0	\N
19246	1541	2882265000000	22632	11319	4	0	\N
19247	1541	2882265000000	22815	11409	3	0	\N
19249	1541	2882277000000	22815	11409	4	0	\N
19251	1541	2882278000000	22632	11319	5	0	\N
19252	1541	3600080000000	2803	1465	3	0	\N
19255	1541	3600110000000	2803	1465	4	0	\N
19256	1541	3601380000000	2804	1334	126	0	\N
19257	1541	3601420000000	2804	1334	127	0	\N
19258	1541	3602277000000	22971	11475	2	0	\N
19259	1541	3602277000000	23279	11615	2	0	\N
19260	1541	3602277000000	23435	11690	2	0	\N
19262	1541	3602288000000	22971	11475	3	0	\N
19263	1541	3602288000000	23279	11615	3	0	\N
19264	1541	3602288000000	23435	11690	3	0	\N
19270	1541	4322324000000	26083	12889	1	0	\N
19273	1541	5042314000000	24319	12095	13	0	\N
19274	1541	5042314000000	24539	12200	6	0	\N
19275	1541	5042314000000	24572	12215	9	0	\N
19276	1541	5042314000000	25095	12456	3	0	\N
19277	1541	5042314000000	25209	12505	3	0	\N
19278	1541	5042314000000	25439	12604	3	0	\N
19279	1541	5042314000000	25706	12718	3	0	\N
19280	1541	5042314000000	25783	12752	6	0	\N
19281	1541	5042314000000	26596	13158	6	0	\N
19282	1541	5042314000000	27086	13392	6	0	\N
19283	1541	5042314000000	27960	13832	5	0	\N
19284	1541	5042314000000	28446	14059	4	0	\N
19285	1541	5042314000000	28500	14085	3	0	\N
19286	1541	5042314000000	28594	14121	9	0	\N
19287	1541	5042324000000	26083	12889	3	0	\N
19288	1541	5042325000000	26083	12889	4	0	\N
19289	1541	5042326000000	25095	12456	4	0	\N
19290	1541	5042326000000	25209	12505	4	0	\N
19291	1541	5042326000000	25439	12604	4	0	\N
19292	1541	5042326000000	25706	12718	4	0	\N
19293	1541	5042326000000	28500	14085	4	0	\N
19294	1541	5042336000000	28446	14059	5	0	\N
19295	1541	5042338000000	25783	12752	7	0	\N
19296	1541	5042338000000	26596	13158	7	0	\N
19297	1541	5042338000000	27086	13392	7	0	\N
19298	1541	5042346000000	27960	13832	6	0	\N
19299	1541	5042347000000	24539	12200	7	0	\N
19300	1541	5042359000000	24572	12215	10	0	\N
19301	1541	5042363000000	24319	12095	14	0	\N
19302	1541	5042368000000	28594	14121	10	0	\N
19303	1541	5757128000000	4455	2309	1	0	\N
19305	1541	5757138000000	4455	2309	2	0	\N
19307	1541	6477248000000	5147	2669	1	0	\N
19308	1541	6477248000000	5159	2678	1	0	\N
19310	1541	6477258000000	5147	2669	2	0	\N
19311	1541	6477258000000	5159	2678	2	0	\N
19205	1541	1440010000000	864	478	1	0	0
19207	1541	1440020000000	864	478	2	0	0
19231	1541	2160020000000	2456	1285	4	0	0
19238	1541	2160060000000	2456	1285	5	0	0
19242	1541	2880060000000	2507	1315	2	0	0
19253	1541	3600080000000	3284	1707	2	0	0
19254	1541	3600100000000	3284	1707	3	0	0
19266	1541	4317098000000	4093	2127	1	0	2
19267	1541	4317108000000	4093	2127	2	0	2
19271	1541	5037108000000	4097	2130	2	0	2
19304	1541	5757128000000	4615	2390	3	0	2
19306	1541	5757248000000	4615	2390	4	0	2
19309	1541	6477248000000	5383	2802	0	0	2
19312	1541	7197248000000	5554	2888	0	0	2
19199	1541	722049000000	21507	10788	5	0	4
19217	1541	1442049000000	22486	11251	18	0	4
19225	1541	1442193000000	22486	11251	19	0	4
19239	1541	2162193000000	22501	11256	9	0	4
19240	1541	2162265000000	22501	11256	10	0	4
19250	1541	2882277000000	22892	11443	4	0	4
19261	1541	3602277000000	23581	11751	3	0	4
19265	1541	3602289000000	23581	11751	4	0	4
19268	1541	4322289000000	23820	11857	7	0	4
19269	1541	4322314000000	23820	11857	8	0	4
19314	1541	8637248000000	5997	3111	5	0	\N
19315	1541	8637248000000	6134	3180	1	0	\N
19316	1541	8637248000000	6594	3411	2	0	\N
19317	1541	8637248000000	6789	3515	2	0	\N
19318	1541	8637248000000	6832	3536	2	0	\N
19319	1541	8637248000000	6833	3536	1	0	\N
19320	1541	8637248000000	6942	3583	2	0	\N
19321	1541	8637248000000	6953	3587	7	0	\N
19322	1541	8637258000000	6134	3180	2	0	\N
19323	1541	8637258000000	6833	3536	2	0	\N
19324	1541	8637268000000	6594	3411	3	0	\N
19325	1541	8637268000000	6789	3515	3	0	\N
19326	1541	8637268000000	6832	3536	3	0	\N
19327	1541	8637268000000	6942	3583	3	0	\N
19328	1541	8637298000000	5997	3111	6	0	\N
19329	1541	8637318000000	6953	3587	8	0	\N
19330	1542	16558806000000	10094	5236	23	0	\N
19332	1543	720000000000	10760	5554	4	0	\N
19333	1543	720000000000	22583	11299	9	0	\N
19335	1543	720040000000	10760	5554	5	0	\N
19336	1543	720612000000	22583	11299	10	0	\N
19337	1543	3454950160000	10322	5340	5	1	\N
19338	1543	17985559959999	8986	4661	9	1	\N
19339	1544	720000000000	3649	1894	0	0	\N
19344	1546	200004002	19618	9881	11	0	\N
19345	1546	200100000	19557	9835	39	0	\N
19346	1546	206000000	27225	13463	4	0	\N
19347	1546	720000000000	49	28	1	0	\N
19349	1546	720010000000	49	28	2	0	\N
19353	1546	2160020000000	149	89	2	0	\N
19355	1546	2160040000000	149	89	3	0	\N
19359	1546	3600060000000	683	382	1	0	\N
19360	1546	3600060000000	1023	567	1	0	\N
19362	1546	3600070000000	683	382	2	0	\N
19363	1546	3600070000000	1023	567	2	0	\N
19366	1546	4032316000000	21767	10899	6	0	\N
19369	1546	4032340000000	21767	10899	7	0	\N
19370	1546	4320070000000	1314	724	1	0	\N
19371	1546	4320070000000	1480	807	3	0	\N
19373	1546	4320080000000	1314	724	2	0	\N
19375	1546	4320091000000	1480	807	4	0	\N
19378	1546	5040080000000	1977	1045	1	0	\N
19380	1546	5040090000000	1977	1045	2	0	\N
19384	1546	5041130000000	2301	1082	85	0	\N
19385	1546	5760100000000	2299	1206	1	0	\N
19386	1546	5760100000000	2381	1246	1	0	\N
19388	1546	5760110000000	2299	1206	2	0	\N
19389	1546	5760110000000	2381	1246	2	0	\N
19393	1546	5760634000000	12472	6389	7	0	\N
19394	1546	5761130000000	2301	1082	126	0	\N
19395	1546	5761530000000	2301	1082	127	0	\N
19397	1546	5997318000000	22834	11419	3	0	\N
19398	1546	5997318000000	22835	11419	3	0	\N
19400	1546	5997330000000	22834	11419	4	0	\N
19403	1546	6480618000000	12471	6427	0	0	\N
19406	1546	6480634000000	12472	6389	27	0	\N
19407	1546	6480653000000	12472	6389	28	0	\N
19408	1546	6717327800000	23604	11761	2	0	\N
19409	1546	6717327800000	23610	11761	3	0	\N
19411	1546	6717327800000	23624	11768	11	0	\N
19412	1546	6717338800000	23604	11761	3	0	\N
19413	1546	6717339800000	23610	11761	4	0	\N
19415	1546	6717366800000	23624	11768	12	0	\N
19418	1546	7200628000000	12911	6655	8	0	\N
19419	1546	7200628000000	13040	6723	8	0	\N
19420	1546	7200628000000	13042	6723	8	0	\N
19423	1546	7200672000000	12911	6655	9	0	\N
19424	1546	7200681000000	13040	6723	9	0	\N
19425	1546	7200681000000	13042	6723	9	0	\N
19429	1546	7920640000000	13763	7071	4	0	\N
19430	1546	7920640000000	14164	7230	3	0	\N
19431	1546	7920640000000	14550	7422	10	0	\N
19433	1546	7920652000000	14164	7230	4	0	\N
19434	1546	7920653000000	13763	7071	5	0	\N
19435	1546	7920776000000	14550	7422	11	0	\N
19437	1546	8157375800000	24081	11987	2	0	\N
19438	1546	8157375800000	24101	11998	2	0	\N
19440	1546	8157386800000	24081	11987	3	0	\N
19441	1546	8157386800000	24101	11998	3	0	\N
19448	1546	9360130000000	3648	1893	0	0	\N
19351	1546	1440010000000	144	85	1	0	0
19352	1546	1440020000000	144	85	2	0	0
19354	1546	2160020000000	413	235	2	0	0
19356	1546	2160040000000	413	235	3	0	0
19357	1546	2880040000000	454	256	2	0	0
19361	1546	3600060000000	1172	645	1	0	0
19364	1546	3600070000000	1172	645	2	0	0
19372	1546	4320070000000	1800	963	1	0	0
19374	1546	4320080000000	1800	963	2	0	0
19379	1546	5040080000000	2005	1059	2	0	0
19387	1546	5760100000000	2515	1321	1	0	0
19390	1546	5760110000000	2515	1321	2	0	0
19401	1546	6480110000000	2522	1324	1	0	0
19402	1546	6480120000000	2522	1324	2	0	0
19417	1546	7200130000000	3509	1821	2	0	0
19428	1546	7920130000000	3562	1848	0	0	0
19443	1546	8640130000000	3567	1851	0	0	0
19313	1541	7917248000000	5605	2912	0	0	2
19331	1543	720000000000	7603	3934	1	0	0
19365	1546	3600591000000	11150	5730	0	0	6
19376	1546	4320591000000	11333	5821	4	0	6
19377	1546	4320613000000	11333	5821	5	0	6
19382	1546	5040613000000	11895	6114	2	0	6
19383	1546	5040615000000	11895	6114	3	0	6
19392	1546	5760618000000	12176	6269	4	0	6
19404	1546	6480618000000	12825	6616	1	0	6
19405	1546	6480628000000	12825	6616	2	0	6
19421	1546	7200628000000	13198	6800	3	0	6
19432	1546	7920640000000	14552	7422	10	0	6
19436	1546	7920776000000	14552	7422	11	0	6
19444	1546	8640776000000	15391	7839	3	0	6
19445	1546	8640788000000	15391	7839	4	0	6
19340	1544	720000000000	21499	10783	2	0	0
19367	1546	4032316000000	22101	11051	3	0	10
19368	1546	4032328000000	22101	11051	4	0	10
19396	1546	5997318000000	22833	11419	3	0	10
19399	1546	5997327800000	22833	11419	4	0	10
19410	1546	6717327800000	23622	11768	8	0	10
19426	1546	7437363800000	23922	11905	3	0	10
19427	1546	7437375800000	23922	11905	4	0	10
19439	1546	8157375800000	24133	12013	6	0	10
19442	1546	8157399800000	24133	12013	7	0	10
19447	1546	8877411800000	24455	12162	4	0	10
19342	1544	1440011000000	24752	12292	4	0	0
19343	1544	1440024000000	24752	12292	5	0	0
19454	1546	9597411800000	24474	12169	0	0	\N
19456	1546	9597469800000	24836	12332	9	0	\N
19459	1546	10080799000000	15740	8005	7	0	\N
19462	1546	10080824000000	15740	8005	8	0	\N
19463	1546	10317433800000	24991	12401	3	0	\N
19464	1546	10317433800000	25007	12406	3	0	\N
19467	1546	10317445800000	24991	12401	4	0	\N
19468	1546	10317445800000	25007	12406	4	0	\N
19469	1546	10317454800000	26396	13058	1	0	\N
19471	1546	10317469800000	24836	12332	11	0	\N
19472	1546	10317470800000	24836	12332	12	0	\N
19473	1546	10318204800000	25556	12601	94	0	\N
19474	1546	10800160000000	4196	2185	2	0	\N
19475	1546	10800160000000	4604	2383	1	0	\N
19477	1546	10800170000000	4604	2383	2	0	\N
19479	1546	10800180000000	4196	2185	3	0	\N
19482	1546	11037444800000	25554	12653	6	0	\N
19483	1546	11037444800000	25901	12802	2	0	\N
19484	1546	11037454800000	26396	13058	8	0	\N
19486	1546	11037455800000	25901	12802	3	0	\N
19487	1546	11037468800000	25554	12653	7	0	\N
19488	1546	11037469800000	26396	13058	9	0	\N
19490	1546	11038204800000	25556	12601	126	0	\N
19491	1546	11038235800000	25556	12601	127	0	\N
19492	1546	11520170000000	5161	2678	1	0	\N
19494	1546	11520180000000	5161	2678	2	0	\N
19495	1546	11520836000000	16633	8450	4	0	\N
19496	1546	11520836000000	17073	8648	2	0	\N
19499	1546	11520847000000	17073	8648	3	0	\N
19500	1546	11520849000000	16633	8450	5	0	\N
19501	1546	11757469800000	26739	13227	4	0	\N
19502	1546	11757469800000	26743	13227	4	0	\N
19505	1546	11757482800000	26739	13227	5	0	\N
19506	1546	11757482800000	26743	13227	5	0	\N
19507	1546	12240170000000	5726	2967	1	0	\N
19508	1546	12240170000000	5820	3021	1	0	\N
19510	1546	12240180000000	5820	3021	2	0	\N
19512	1546	12240270000000	5726	2967	2	0	\N
19513	1546	12240846000000	17204	8718	3	0	\N
19515	1546	12240858000000	17204	8718	4	0	\N
19517	1546	12240880000000	17313	8771	4	0	\N
19521	1546	12960200000000	6014	3120	1	0	\N
19523	1546	12960210000000	6014	3120	2	0	\N
19525	1546	12960880000000	17313	8771	6	0	\N
19527	1546	12960881000000	17313	8771	7	0	\N
19531	1546	13680210000000	6580	3405	2	0	\N
19532	1546	13680210000000	6715	3473	2	0	\N
19534	1546	13680230000000	6580	3405	3	0	\N
19535	1546	13680230000000	6715	3473	3	0	\N
19539	1546	13917552820000	27225	13463	3	0	\N
19542	1546	14400250000000	7170	3703	1	0	\N
19544	1546	14400260000000	7170	3703	2	0	\N
19546	1546	14400942000000	17546	8885	3	0	\N
19548	1546	14400942000000	17568	8885	0	0	\N
19549	1546	14400954000000	17546	8885	4	0	\N
19551	1546	14637565800000	27535	13613	7	0	\N
19552	1546	14637565800000	27624	13653	6	0	\N
19554	1546	14637589800000	27624	13653	7	0	\N
19556	1546	14637599800000	27535	13613	8	0	\N
19560	1546	15120954000000	17845	9008	3	0	\N
19561	1546	15120966000000	17845	9008	4	0	\N
19563	1546	15357598800000	27767	13718	2	0	\N
19564	1546	15357598800000	27984	13841	6	0	\N
19566	1546	15357609800000	27767	13718	3	0	\N
19568	1546	15357622800000	27984	13841	7	0	\N
19569	1546	15840280000000	7810	4049	2	0	\N
19570	1546	15840280000000	7896	4092	1	0	\N
19571	1546	15840280000000	8027	4162	1	0	\N
19573	1546	15840290000000	7896	4092	2	0	\N
19574	1546	15840290000000	8027	4162	2	0	\N
19575	1546	15840300000000	7810	4049	3	0	\N
19577	1546	15840310000000	8728	4527	1	0	\N
19581	1546	16077598800000	28019	13859	1	0	\N
19582	1546	16077598800000	28020	13859	2	0	\N
19583	1546	16077608800000	28019	13859	2	0	\N
19584	1546	16077609800000	28020	13859	3	0	\N
19457	1546	10080150000000	3807	1973	1	0	0
19458	1546	10080160000000	3807	1973	2	0	0
19476	1546	10800160000000	5146	2668	1	0	0
19478	1546	10800170000000	5146	2668	2	0	0
19493	1546	11520170000000	5505	2864	0	0	0
19511	1546	12240200000000	5940	3078	4	0	0
19522	1546	12960200000000	6139	3183	1	0	0
19524	1546	12960210000000	6139	3183	2	0	0
19533	1546	13680210000000	6904	3567	4	0	0
19536	1546	13680250000000	6904	3567	5	0	0
19545	1546	14400260000000	7701	3990	2	0	0
19557	1546	15120260000000	7727	4003	2	0	0
19558	1546	15120280000000	7727	4003	3	0	0
19572	1546	15840280000000	8370	4337	2	0	0
19578	1546	15840310000000	8730	4527	1	0	0
19451	1546	9360788000000	15458	7872	2	0	6
19452	1546	9360799000000	15458	7872	3	0	6
19460	1546	10080799000000	15913	8091	3	0	6
19461	1546	10080811000000	15913	8091	4	0	6
19481	1546	10800836000000	16057	8167	8	0	6
19497	1546	11520836000000	17075	8648	1	0	6
19498	1546	11520846000000	17075	8648	2	0	6
19514	1546	12240846000000	17243	8735	3	0	6
19516	1546	12240858000000	17243	8735	4	0	6
19526	1546	12960880000000	17314	8771	6	0	6
19528	1546	12960881000000	17314	8771	7	0	6
19537	1546	13680881000000	17453	8839	7	0	6
19538	1546	13680942000000	17453	8839	8	0	6
19550	1546	14400954000000	17566	8892	4	0	6
19559	1546	15120954000000	17843	9008	4	0	6
19562	1546	15120967000000	17843	9008	5	0	6
19579	1546	15840967000000	18100	9129	2	0	6
19580	1546	15840978000000	18100	9129	3	0	6
19455	1546	9597433800000	24472	12170	5	0	10
19465	1546	10317433800000	25011	12409	2	0	10
19466	1546	10317444800000	25011	12409	3	0	10
19470	1546	10317454800000	26397	13058	1	0	10
19485	1546	11037454800000	26397	13058	8	0	10
19503	1546	11757469800000	26802	13253	3	0	10
19504	1546	11757481800000	26802	13253	4	0	10
19519	1546	12477481800000	26806	13256	10	0	10
19520	1546	12477518800000	26806	13256	11	0	10
19530	1546	13197553800000	26996	13353	9	0	10
19540	1546	13917553800000	27227	13463	3	0	10
19541	1546	13917565800000	27227	13463	4	0	10
19553	1546	14637565800000	27708	13691	6	0	10
19555	1546	14637598800000	27708	13691	7	0	10
19567	1546	15357609800000	28270	13977	3	0	10
19585	1546	16077609800000	28576	14114	7	0	\N
19586	1546	16077609800000	28818	14214	3	0	\N
19587	1546	16077609800000	29152	14376	3	0	\N
19589	1546	16077609800000	29170	14381	5	0	\N
19590	1546	16077609800000	29171	14381	3	0	\N
19591	1546	16077621800000	28818	14214	4	0	\N
19592	1546	16077621800000	29152	14376	4	0	\N
19593	1546	16077634800000	28576	14114	8	0	\N
19594	1546	16077639800000	29171	14381	4	0	\N
19595	1546	16077641800000	29170	14381	6	0	\N
19597	1546	16560210000000	8728	4527	2	0	\N
19600	1546	16560978000000	18197	9171	2	0	\N
19601	1546	16560978000000	18198	9171	2	0	\N
19602	1546	16560978000000	18299	9219	2	0	\N
19603	1546	16560978000000	18300	9219	1	0	\N
19604	1546	16560978000000	18634	9390	5	0	\N
19606	1546	16560988000000	18300	9219	2	0	\N
19607	1546	16560989000000	18197	9171	3	0	\N
19608	1546	16560989000000	18198	9171	3	0	\N
19609	1546	16560989000000	18299	9219	3	0	\N
19610	1546	16561001000000	18634	9390	6	0	\N
19616	1546	17281019000000	19117	9645	2	0	\N
19617	1546	17281019000000	19227	9697	5	0	\N
19618	1546	17281019000000	19232	9697	1	0	\N
19619	1546	17281019000000	19535	9839	0	0	\N
19620	1546	17281019000000	19536	9842	3	0	\N
19621	1546	17281019000000	19538	9834	36	0	\N
19623	1546	17281019000000	19554	9849	4	0	\N
19624	1546	17281020000000	19232	9697	2	0	\N
19625	1546	17281030000000	19117	9645	3	0	\N
19626	1546	17281031000000	19536	9842	4	0	\N
19628	1546	17281032000000	19554	9849	5	0	\N
19629	1546	17281042000000	19227	9697	6	0	\N
19630	1546	17281061000000	19618	9881	3	0	\N
19631	1546	17281061000000	19619	9881	3	0	\N
19632	1546	17281154000000	19538	9834	37	0	\N
19633	1546	17281224000000	19557	9835	7	0	\N
19634	1546	17517655800000	29785	14679	29	0	\N
19635	1546	17517655800000	29786	14679	29	0	\N
19636	1546	17517702800000	29785	14679	30	0	\N
19637	1546	17517702800000	29786	14679	30	0	\N
19642	1546	18001060999998	19618	9881	10	0	\N
19643	1546	18001061000000	19619	9881	10	0	\N
19644	1546	18001067000000	19619	9881	11	0	\N
19645	1546	18001224000000	19557	9835	38	0	\N
19646	1546	18001762900000	19620	9836	95	0	\N
19651	1546	18721762900000	19620	9836	126	0	\N
19652	1546	18721792900000	19620	9836	127	0	\N
19659	1546	20161106000000	20955	10540	2	0	\N
19660	1546	20161106000000	21086	10594	2	0	\N
19661	1546	20161106000000	21576	10817	3	0	\N
19662	1546	20161106000000	21577	10817	3	0	\N
19663	1546	20161106000000	21674	10858	3	0	\N
19664	1546	20161117000000	20955	10540	3	0	\N
19665	1546	20161117000000	21086	10594	3	0	\N
19666	1546	20161118000000	21576	10817	4	0	\N
19667	1546	20161118000000	21577	10817	4	0	\N
19668	1546	20161118000000	21674	10858	4	0	\N
19672	1546	21600551000000	10909	5627	3	0	\N
19674	1546	21600671000000	10909	5627	4	0	\N
19675	1546	66000000001310	22835	11419	4	1	\N
19676	1547	720000000000	50	28	1	0	\N
19678	1547	720010000000	50	28	2	0	\N
19680	1547	1434963970000	27611	13576	81	1	\N
19681	1547	1440010000000	753	421	1	0	\N
19682	1547	1440010000000	822	454	1	0	\N
19683	1547	1440010000000	1667	895	2	0	\N
19684	1547	1440010000000	1938	1029	1	0	\N
19685	1547	1440010000000	2119	1117	1	0	\N
19687	1547	1440020000000	753	421	2	0	\N
19688	1547	1440020000000	822	454	2	0	\N
19689	1547	1440020000000	1938	1029	2	0	\N
19690	1547	1440020000000	2119	1117	2	0	\N
19692	1547	1440030000000	1667	895	3	0	\N
19695	1547	2880030000000	3162	1642	1	0	\N
19697	1547	2880040000000	3162	1642	2	0	\N
19698	1547	3453183000000	10712	5531	2	0	\N
19699	1547	3453183000000	10713	5531	2	0	\N
19701	1547	3453203000000	10712	5531	3	0	\N
19702	1547	3453203000000	10713	5531	3	0	\N
19707	1547	4320030000000	3926	2036	2	0	\N
19708	1547	4320030000000	4666	2413	1	0	\N
19710	1547	4320040000000	4666	2413	2	0	\N
19712	1547	4320050000000	3926	2036	3	0	\N
19715	1547	5040040000000	5062	2627	1	0	\N
19716	1547	5040040000000	5355	2780	1	0	\N
19718	1547	5040050000000	5062	2627	2	0	\N
19719	1547	5040050000000	5355	2780	2	0	\N
19720	1547	5613225000000	12392	6392	1	0	\N
19686	1547	1440010000000	2865	1499	1	0	0
19691	1547	1440020000000	2865	1499	2	0	0
19693	1547	2160020000000	3067	1593	1	0	0
19694	1547	2160030000000	3067	1593	2	0	0
19696	1547	2880030000000	3507	1820	0	0	0
19709	1547	4320030000000	4781	2470	1	0	0
19711	1547	4320040000000	4781	2470	2	0	0
19717	1547	5040040000000	5597	2909	0	0	0
19598	1546	16560310000000	8730	4527	3	0	0
19599	1546	16560320000000	8730	4527	4	0	0
19615	1546	17280360000000	9013	4672	5	0	0
19638	1546	18000360000000	9017	4675	4	0	0
19639	1546	18000400000000	9017	4675	5	0	0
19647	1546	18720400000000	9679	5022	4	0	0
19653	1546	19440440000000	9937	5158	7	0	0
19654	1546	19440510000000	9937	5158	8	0	0
19657	1546	20160510000000	10565	5457	2	0	0
19658	1546	20160530000000	10565	5457	3	0	0
19669	1546	20880530000000	10811	5579	3	0	0
19671	1546	21600551000000	10908	5627	1	0	0
19673	1546	21600651000000	10908	5627	2	0	0
19700	1547	3453183000000	11189	5745	3	0	6
19703	1547	3453213000000	11189	5745	4	0	6
19705	1547	4173213000000	11362	5835	2	0	6
19713	1547	4893224000000	12077	6219	1	0	6
19714	1547	4893225000000	12077	6219	2	0	6
19605	1546	16560978000000	18907	9537	5	0	6
19611	1546	16561019000000	18907	9537	6	0	6
19627	1546	17281031000000	19553	9849	4	0	6
19640	1546	18001031000000	20554	10347	3	0	6
19641	1546	18001043000000	20554	10347	4	0	6
19649	1546	18721043000000	20789	10447	5	0	6
19650	1546	18721084000000	20789	10447	6	0	6
19656	1546	19441106000000	20852	10480	5	0	6
19588	1546	16077609800000	29169	14381	8	0	10
19596	1546	16077644800000	29169	14381	9	0	10
19612	1546	16797644800000	29561	14574	2	0	10
19613	1546	16797655800000	29561	14574	3	0	10
19722	1547	5613226000000	12392	6392	2	0	\N
19724	1547	5760040000000	5624	2921	0	0	\N
19725	1547	5760040000000	5693	2952	0	0	\N
19728	1547	6333226000000	12412	6402	1	0	\N
19729	1547	6333226000000	12668	6534	3	0	\N
19730	1547	6333226000000	13051	6728	5	0	\N
19732	1547	6333227000000	12412	6402	2	0	\N
19733	1547	6333238000000	12668	6534	4	0	\N
19734	1547	6333258000000	13051	6728	6	0	\N
19736	1547	6475904000000	23228	11515	124	0	\N
19737	1547	6480050000000	6240	3227	2	0	\N
19739	1547	6480070000000	6240	3227	3	0	\N
19743	1547	7194709000000	21566	10813	4	0	\N
19744	1547	7194709000000	22130	11070	6	0	\N
19745	1547	7194709000000	22415	11221	2	0	\N
19746	1547	7194709000000	22416	11221	3	0	\N
19747	1547	7194709000000	22477	11247	8	0	\N
19748	1547	7194709000000	22478	11247	9	0	\N
19749	1547	7194709000000	23224	11301	0	0	\N
19750	1547	7194709000000	23226	11591	5	0	\N
19751	1547	7194709000000	23229	11309	0	0	\N
19753	1547	7194720000000	22415	11221	3	0	\N
19754	1547	7194721000000	22416	11221	4	0	\N
19755	1547	7194722000000	21566	10813	5	0	\N
19757	1547	7194733000000	22130	11070	7	0	\N
19758	1547	7194780000000	22477	11247	9	0	\N
19759	1547	7194781000000	22478	11247	10	0	\N
19760	1547	7194831000000	23226	11591	6	0	\N
19761	1547	7195904000000	23228	11515	126	0	\N
19762	1547	7195905000000	23228	11515	127	0	\N
19765	1547	7773285000000	14261	7281	4	0	\N
19768	1547	7773298000000	14261	7281	5	0	\N
19771	1547	7920200000000	7751	4019	1	0	\N
19772	1547	7920200000000	7895	4091	1	0	\N
19775	1547	7920210000000	7751	4019	2	0	\N
19776	1547	7920210000000	7895	4091	2	0	\N
19777	1547	8493297000000	14452	7377	3	0	\N
19779	1547	8493309000000	14452	7377	4	0	\N
19781	1547	8634755000000	24169	12030	2	0	\N
19782	1547	8634755000000	24415	12143	2	0	\N
19783	1547	8634755000000	24430	12149	3	0	\N
19785	1547	8634766000000	24169	12030	3	0	\N
19786	1547	8634766000000	24415	12143	3	0	\N
19787	1547	8634767000000	24430	12149	4	0	\N
19789	1547	8640202000000	8439	4374	0	0	\N
19790	1547	8640202000000	8703	4511	5	0	\N
19793	1547	8640243000000	8703	4511	6	0	\N
19794	1547	9213309000000	14715	7491	10	0	\N
19797	1547	9213364000000	14715	7491	11	0	\N
19798	1547	9354778000000	24759	12294	7	0	\N
19800	1547	9354778000000	24998	12402	5	0	\N
19801	1547	9354802000000	24998	12402	6	0	\N
19802	1547	9354803000000	24759	12294	8	0	\N
19806	1547	9933332000000	15212	7751	2	0	\N
19807	1547	9933332000000	15375	7832	1	0	\N
19808	1547	9933332000000	15685	7980	3	0	\N
19809	1547	9933332000000	16122	8196	3	0	\N
19811	1547	9933332000000	16239	8228	61	0	\N
19812	1547	9933342000000	15375	7832	2	0	\N
19813	1547	9933343000000	15212	7751	3	0	\N
19814	1547	9933344000000	15685	7980	4	0	\N
19815	1547	9933344000000	16122	8196	4	0	\N
19817	1547	9933763000000	16239	8228	62	0	\N
19818	1547	10074804000000	25098	12457	3	0	\N
19820	1547	10074816000000	25098	12457	4	0	\N
19824	1547	10653351000000	16261	8264	5	0	\N
19826	1547	10653374000000	16261	8264	6	0	\N
19828	1547	10794816000000	26438	13079	4	0	\N
19831	1547	10794829000000	26438	13079	5	0	\N
19834	1547	11373376000000	16264	8266	3	0	\N
19835	1547	11373376000000	16408	8347	3	0	\N
19836	1547	11373376000000	16620	8443	3	0	\N
19838	1547	11373388000000	16264	8266	4	0	\N
19839	1547	11373388000000	16408	8347	4	0	\N
19840	1547	11373388000000	16620	8443	4	0	\N
19842	1547	11514828000000	26955	13332	4	0	\N
19843	1547	11514828000000	26957	13332	3	0	\N
19845	1547	11514831000000	26957	13332	4	0	\N
19847	1547	11514841000000	26955	13332	5	0	\N
19848	1547	11515030000000	27611	13576	19	0	\N
19849	1547	11515390000000	27610	13574	55	0	\N
19856	1547	12235030000000	27611	13576	80	0	\N
19738	1547	6480050000000	6379	3304	2	0	0
19740	1547	6480160000000	6379	3304	3	0	0
19763	1547	7200160000000	6670	3447	4	0	0
19764	1547	7200200000000	6670	3447	5	0	0
19773	1547	7920200000000	8102	4199	2	0	0
19791	1547	8640202000000	9149	4740	4	0	0
19792	1547	8640242000000	9149	4740	5	0	0
19804	1547	9360242000000	9277	4810	2	0	0
19805	1547	9360262000000	9277	4810	3	0	0
19822	1547	10080262000000	9408	4882	2	0	0
19832	1547	10800282000000	9450	4901	2	0	0
19833	1547	10800293000000	9450	4901	3	0	0
19850	1547	11520293000000	9586	4973	2	0	0
19851	1547	11520313000000	9586	4973	3	0	0
19723	1547	5613226000000	12393	6392	2	0	6
19731	1547	6333226000000	13507	6954	10	0	6
19735	1547	6333272000000	13507	6954	11	0	6
19741	1547	7053272000000	14121	7218	4	0	6
19742	1547	7053285000000	14121	7218	5	0	6
19767	1547	7773297000000	14437	7366	4	0	6
19778	1547	8493297000000	14591	7440	3	0	6
19780	1547	8493309000000	14591	7440	4	0	6
19795	1547	9213309000000	14960	7619	5	0	6
19796	1547	9213332000000	14960	7619	6	0	6
19816	1547	9933351000000	16238	8254	6	0	6
19825	1547	10653351000000	16262	8264	7	0	6
19827	1547	10653376000000	16262	8264	8	0	6
19837	1547	11373376000000	16681	8473	10	0	6
19852	1547	12093413000000	16998	8609	5	0	6
19853	1547	12093436000000	16998	8609	6	0	6
19752	1547	7194709000000	23368	11662	4	0	12
19756	1547	7194731000000	23368	11662	5	0	12
19769	1547	7914731000000	23872	11882	6	0	12
19784	1547	8634755000000	24555	12206	5	0	12
19788	1547	8634778000000	24555	12206	6	0	12
19799	1547	9354778000000	24997	12402	7	0	12
19803	1547	9354804000000	24997	12402	8	0	12
19819	1547	10074804000000	25465	12613	3	0	12
19829	1547	10794816000000	26836	13271	3	0	12
19830	1547	10794828000000	26836	13271	4	0	12
19844	1547	11514828000000	27330	13509	3	0	12
19846	1547	11514840000000	27330	13509	4	0	12
19855	1547	12234852000000	27609	13646	4	0	12
19857	1547	12235390000000	27610	13574	126	0	\N
19858	1547	12236063000000	27610	13574	127	0	\N
19859	1547	12240313000000	9908	5138	0	0	\N
19862	1547	12813436000000	17242	8734	7	0	\N
19863	1547	12813436000000	17946	9052	7	0	\N
19865	1547	12813436000000	18085	9084	19	0	\N
19866	1547	12813461000000	17242	8734	8	0	\N
19867	1547	12813461000000	17946	9052	8	0	\N
19869	1547	12813491000000	18085	9084	20	0	\N
19872	1547	12960353000000	9929	5153	0	0	\N
19874	1547	13533470000000	18559	9353	3	0	\N
19875	1547	13533470000000	18665	9406	2	0	\N
19876	1547	13533470000000	18669	9403	0	0	\N
19877	1547	13533470000000	18674	9408	3	0	\N
19878	1547	13533470000000	18677	9408	2	0	\N
19880	1547	13533481000000	18665	9406	3	0	\N
19881	1547	13533481000000	18677	9408	3	0	\N
19882	1547	13533482000000	18559	9353	4	0	\N
19883	1547	13533491000000	18674	9408	4	0	\N
19885	1547	13674852000000	28024	13861	6	0	\N
19886	1547	13674852000000	28320	13976	3	0	\N
19888	1547	13674855000000	28320	13976	4	0	\N
19890	1547	13674876000000	28024	13861	7	0	\N
19895	1547	14394863000000	28937	14272	3	0	\N
19897	1547	14394875000000	28937	14272	4	0	\N
19899	1547	14400383000000	10259	5307	5	0	\N
19900	1547	14400433000000	10259	5307	6	0	\N
19901	1547	14973511000000	18905	9536	1	0	\N
19903	1547	14973521000000	18905	9536	2	0	\N
19907	1547	15693522000000	18943	9557	2	0	\N
19908	1547	15693522000000	19011	9586	2	0	\N
19909	1547	15693522000000	19016	9587	2	0	\N
19911	1547	15693533000000	19011	9586	3	0	\N
19912	1547	15693533000000	19016	9587	3	0	\N
19914	1547	15693542000000	18943	9557	3	0	\N
19915	1547	15834999000000	29096	14344	4	0	\N
19916	1547	15834999000000	29254	14418	3	0	\N
19917	1547	15834999000000	29524	14560	6	0	\N
19919	1547	15835011000000	29254	14418	4	0	\N
19920	1547	15835012000000	29096	14344	5	0	\N
19922	1547	15835023000000	29524	14560	7	0	\N
19925	1547	16414666000000	19958	9961	22	0	\N
19928	1547	17133546000000	19521	9835	3	0	\N
19930	1547	17133558000000	19521	9835	4	0	\N
19932	1547	17134666000000	19958	9961	126	0	\N
19933	1547	17135696000000	19958	9961	127	0	\N
19934	1547	17275053000000	29937	14745	10	0	\N
19937	1547	17275081000000	29937	14745	11	0	\N
19938	1547	17853559000000	19960	10052	3	0	\N
19940	1547	17853559000000	20094	10110	17	0	\N
19941	1547	17853571000000	19960	10052	4	0	\N
19943	1547	17853739000000	20094	10110	18	0	\N
19951	1547	19293718000000	20263	10205	4	0	\N
19953	1547	19293731000000	20263	10205	5	0	\N
19955	1547	19435142000000	30117	14821	11	0	\N
19956	1547	19435142000000	30118	14821	10	0	\N
19958	1547	19435152000000	30118	14821	11	0	\N
19959	1547	19435162000000	30117	14821	12	0	\N
19967	1547	21454295000000	21000	10518	36	0	\N
19968	1547	22173765000000	20997	10560	13	0	\N
19971	1547	22173850000000	20997	10560	14	0	\N
19972	1547	22174295000000	21000	10518	126	0	\N
19973	1547	22174780000000	21000	10518	127	0	\N
19976	1547	23613829000000	21373	10725	4	0	\N
19977	1547	23613829000000	21374	10725	4	0	\N
19978	1547	23613842000000	21373	10725	5	0	\N
19979	1547	23613842000000	21374	10725	5	0	\N
19982	1549	100000018	24586	12222	9	0	\N
19985	1549	1440010000000	287	164	1	0	\N
19987	1549	1440020000000	287	164	2	0	\N
19986	1549	1440010000000	708	396	1	0	0
19988	1549	1440020000000	708	396	2	0	0
19989	1549	2160020000000	922	513	2	0	0
19990	1549	2160031000000	922	513	3	0	0
19991	1549	2880031000000	1229	678	1	0	0
19860	1547	12240313000000	9915	5144	4	0	0
19861	1547	12240353000000	9915	5144	5	0	0
19871	1547	12960353000000	9928	5153	1	0	0
19873	1547	12960363000000	9928	5153	2	0	0
19891	1547	13680363000000	10008	5188	2	0	0
19864	1547	12813436000000	18084	9120	7	0	6
19868	1547	12813470000000	18084	9120	8	0	6
19980	1548	720000000000	18443	9296	3	0	0
19981	1548	720012000000	18443	9296	4	0	0
19884	1547	13533491000000	18860	9510	4	0	6
19893	1547	14253491000000	18864	9512	2	0	6
19894	1547	14253511000000	18864	9512	3	0	6
19902	1547	14973511000000	18911	9539	2	0	6
19904	1547	14973522000000	18911	9539	3	0	6
19913	1547	15693534000000	19473	9817	4	0	6
19923	1547	16413534000000	19496	9828	3	0	6
19924	1547	16413546000000	19496	9828	4	0	6
19929	1547	17133546000000	19957	10050	4	0	6
19931	1547	17133559000000	19957	10050	5	0	6
19942	1547	17853693000000	20093	10115	18	0	6
19946	1547	18573693000000	20167	10152	6	0	6
19947	1547	18573718000000	20167	10152	7	0	6
19950	1547	19293718000000	20260	10205	3	0	6
19960	1547	20013730000000	20332	10239	3	0	6
19961	1547	20013742000000	20332	10239	4	0	6
19962	1547	20733742000000	20354	10251	2	0	6
19963	1547	20733753000000	20354	10251	3	0	6
19964	1547	20733763000000	20670	10398	1	0	6
19966	1547	21453765000000	20670	10398	5	0	6
19969	1547	22173765000000	21248	10670	6	0	6
19970	1547	22173816000000	21248	10670	7	0	6
19974	1547	22893816000000	21300	10695	4	0	6
19975	1547	22893829000000	21300	10695	5	0	6
19887	1547	13674852000000	28321	14002	2	0	12
19889	1547	13674863000000	28321	14002	3	0	12
19896	1547	14394863000000	28979	14290	3	0	12
19898	1547	14394875000000	28979	14290	4	0	12
19906	1547	15114999000000	29017	14309	8	0	12
19918	1547	15834999000000	29732	14657	7	0	12
19921	1547	15835015000000	29732	14657	8	0	12
19926	1547	16555015000000	29882	14727	20	0	12
19927	1547	16555053000000	29882	14727	21	0	12
19936	1547	17275067000000	29939	14746	6	0	12
19944	1547	17995067000000	30020	14782	30	0	12
19945	1547	17995124000000	30020	14782	31	0	12
19948	1547	18715124000000	30077	14809	9	0	12
19949	1547	18715142000000	30077	14809	10	0	12
19957	1547	19435149000000	30116	14821	8	0	12
20006	1549	8640111000000	3727	1933	1	0	\N
20007	1549	8640111000000	3818	1978	1	0	\N
20009	1549	8640121000000	3727	1933	2	0	\N
20010	1549	8640121000000	3818	1978	2	0	\N
20012	1549	9071347000000	23693	11801	4	0	\N
20013	1549	9071347000000	23696	11801	4	0	\N
20015	1549	9071357000000	24586	12222	5	0	\N
20018	1549	9791325000000	23638	11776	9	0	\N
20019	1549	9791325000000	24387	12128	2	0	\N
20020	1549	9791325000000	24428	12149	3	0	\N
20021	1549	9791336000000	24387	12128	3	0	\N
20022	1549	9791337000000	24428	12149	4	0	\N
20023	1549	9791347000000	23693	11801	8	0	\N
20024	1549	9791347000000	23696	11801	8	0	\N
20025	1549	9791350000000	23693	11801	9	0	\N
20026	1549	9791350000000	23696	11801	9	0	\N
20027	1549	9791352000000	23638	11776	10	0	\N
20029	1549	9791357000000	24586	12222	8	0	\N
20036	1549	10415714000000	13703	7041	4	0	\N
20037	1549	10511359000000	24639	12242	8	0	\N
20038	1549	10511359000000	24646	12243	4	0	\N
20039	1549	10511359000000	24909	12368	3	0	\N
20040	1549	10511359000000	24911	12368	3	0	\N
20041	1549	10511359000000	24933	12377	3	0	\N
20043	1549	10511371000000	24909	12368	4	0	\N
20044	1549	10511371000000	24911	12368	4	0	\N
20045	1549	10511371000000	24933	12377	4	0	\N
20047	1549	10511421000000	24639	12242	9	0	\N
20048	1549	10511451000000	24936	12369	8	0	\N
20049	1549	10511471000000	24646	12243	5	0	\N
20050	1549	10800251000000	4211	2191	1	0	\N
20052	1549	10800261000000	4211	2191	2	0	\N
20055	1549	11135714000000	13703	7041	5	0	\N
20058	1549	11231451000000	24936	12369	31	0	\N
20059	1549	11231482000000	24936	12369	32	0	\N
20062	1549	11855714000000	13821	7096	7	0	\N
20064	1549	11855714000000	14095	7207	7	0	\N
20066	1549	11855730000000	13821	7096	8	0	\N
20067	1549	11855730000000	14095	7207	8	0	\N
20068	1549	11951383000000	25418	12596	5	0	\N
20070	1549	11951397000000	25418	12596	6	0	\N
20072	1549	11951482000000	24953	12370	26	0	\N
20073	1549	11951580000000	24953	12370	27	0	\N
20074	1549	12240391000000	5065	2627	1	0	\N
20075	1549	12240391000000	5409	2814	0	0	\N
20076	1549	12240391000000	5421	2819	0	0	\N
20078	1549	12240401000000	5065	2627	2	0	\N
20081	1549	12575868000000	14362	7238	12	0	\N
20085	1549	13295748000000	14359	7330	4	0	\N
20086	1549	13295748000000	14490	7394	17	0	\N
20087	1549	13295748000000	14518	7404	2	0	\N
20089	1549	13295759000000	14518	7404	3	0	\N
20091	1549	13295761000000	14359	7330	5	0	\N
20092	1549	13295774000000	14490	7394	18	0	\N
20093	1549	13295868000000	14362	7238	126	0	\N
20094	1549	13296998000000	14362	7238	127	0	\N
20095	1549	13297208000000	14492	7239	12	0	\N
20096	1549	13391420000000	26496	13107	3	0	\N
20097	1549	13391420000000	27023	13365	3	0	\N
20099	1549	13391432000000	26496	13107	4	0	\N
20100	1549	13391432000000	27023	13365	4	0	\N
20102	1549	13680391000000	5682	2945	1	0	\N
20104	1549	13680401000000	5682	2945	2	0	\N
20108	1549	14017208000000	14492	7239	46	0	\N
20109	1549	14017538000000	14492	7239	47	0	\N
20112	1549	14400401000000	6293	3260	1	0	\N
20114	1549	14400411000000	6293	3260	2	0	\N
20120	1549	15120411000000	6466	3350	1	0	\N
20122	1549	15120421000000	6466	3350	2	0	\N
20126	1549	15551205000000	27991	13845	3	0	\N
20127	1549	15551217000000	27991	13845	4	0	\N
20128	1549	15551455000000	27994	13845	3	0	\N
19995	1549	4320051000000	1280	707	1	0	0
19996	1549	4320061000000	1280	707	2	0	0
19997	1549	5040061000000	1352	742	1	0	0
19998	1549	5040071000000	1352	742	2	0	0
19999	1549	5760071000000	2023	1066	2	0	0
20001	1549	6480091000000	2887	1508	1	0	0
20002	1549	6480101000000	2887	1508	2	0	0
20003	1549	7200101000000	3038	1578	1	0	0
20004	1549	7200111000000	3038	1578	2	0	0
20005	1549	7920111000000	3576	1856	0	0	0
20011	1549	8640221000000	3825	1984	3	0	0
20016	1549	9360221000000	3836	1993	2	0	0
20017	1549	9360241000000	3836	1993	3	0	0
20031	1549	10080241000000	4009	2081	1	0	0
20051	1549	10800251000000	4881	2528	3	0	0
20053	1549	10800281000000	4881	2528	4	0	0
20060	1549	11520281000000	4933	2554	2	0	0
20061	1549	11520391000000	4933	2554	3	0	0
20077	1549	12240391000000	5481	2853	0	0	0
20103	1549	13680391000000	6074	3155	1	0	0
20105	1549	13680401000000	6074	3155	2	0	0
20113	1549	14400401000000	6371	3300	1	0	0
20115	1549	14400411000000	6371	3300	2	0	0
20121	1549	15120411000000	6477	3357	2	0	0
20033	1549	10415676000000	13221	6814	7	0	5
20034	1549	10415692000000	13221	6814	8	0	5
20035	1549	10415714000000	13702	7041	4	0	5
20054	1549	11135714000000	13702	7041	5	0	5
20065	1549	11855725000000	14094	7207	3	0	5
20079	1549	12575725000000	14173	7236	5	0	5
20080	1549	12575748000000	14173	7236	6	0	5
20088	1549	13295748000000	14559	7425	3	0	5
20090	1549	13295760000000	14559	7425	4	0	5
20107	1549	14015772000000	14900	7591	4	0	5
20116	1549	14735772000000	15471	7878	3	0	5
20117	1549	14735784000000	15471	7878	4	0	5
20124	1549	15455784000000	15525	7901	2	0	5
20125	1549	15455795000000	15525	7901	3	0	5
20028	1549	9791357000000	24582	12222	8	0	10
20030	1549	9791359000000	24582	12222	9	0	10
20042	1549	10511359000000	24952	12383	3	0	10
20046	1549	10511371000000	24952	12383	4	0	10
20057	1549	11231383000000	25083	12451	4	0	10
20069	1549	11951383000000	26176	12941	7	0	10
20071	1549	11951408000000	26176	12941	8	0	10
20082	1549	12671408000000	26206	12956	3	0	10
20083	1549	12671420000000	26206	12956	4	0	10
20101	1549	13391432000000	27173	13438	4	0	10
20110	1549	14111432000000	27363	13529	3	0	10
20111	1549	14111444000000	27363	13529	4	0	10
20118	1549	14831444000000	27779	13725	2	0	10
20119	1549	14831455000000	27779	13725	3	0	10
20129	1549	15551455000000	28222	13953	2	0	\N
20130	1549	15551455000000	28329	14005	2	0	\N
20132	1549	15551466000000	28222	13953	3	0	\N
20133	1549	15551466000000	28329	14005	3	0	\N
20134	1549	15551467000000	27994	13845	4	0	\N
20136	1549	15840431000000	6736	3486	2	0	\N
20138	1549	15840451000000	6736	3486	3	0	\N
20144	1549	16560451000000	6823	3533	2	0	\N
20145	1549	16560451000000	6838	3538	2	0	\N
20146	1549	16560451000000	7146	3693	1	0	\N
20148	1549	16560461000000	7146	3693	2	0	\N
20150	1549	16560471000000	6823	3533	3	0	\N
20151	1549	16560471000000	6838	3538	3	0	\N
20156	1549	16991515000000	29681	14641	5	0	\N
20158	1549	17615820000000	16199	8233	3	0	\N
20159	1549	17615820000000	16387	8335	3	0	\N
20161	1549	17615832000000	16199	8233	4	0	\N
20162	1549	17615832000000	16387	8335	4	0	\N
20164	1549	17711492000000	29751	14664	2	0	\N
20166	1549	17711503000000	29751	14664	3	0	\N
20168	1549	17711515000000	29681	14641	18	0	\N
20169	1549	17711527000000	29681	14641	19	0	\N
20184	1549	19775882000000	16880	8562	3	0	\N
20186	1549	19775894000000	16880	8562	4	0	\N
20189	1549	20160491000000	7952	4120	1	0	\N
20190	1549	20160491000000	8058	4176	2	0	\N
20192	1549	20160501000000	7952	4120	2	0	\N
20194	1549	20160511000000	8058	4176	3	0	\N
20197	1549	20591618854742	30078	14810	10	0	\N
20199	1549	20591637854742	30078	14810	11	0	\N
20201	1549	20880501000000	8170	4234	1	0	\N
20203	1549	20880511000000	8170	4234	2	0	\N
20211	1549	21935916000000	17433	8831	3	0	\N
20213	1549	21935916000000	17784	8845	0	0	\N
20214	1549	21935916000000	17787	8857	0	0	\N
20215	1549	21935916000000	17790	8870	0	0	\N
20216	1549	21935916000000	17791	8882	0	0	\N
20217	1549	21935916000000	17792	8895	0	0	\N
20218	1549	21935928000000	17433	8831	4	0	\N
20221	1549	22320556000000	8492	4399	1	0	\N
20223	1549	22320566000000	8492	4399	2	0	\N
20225	1549	22655968000000	17785	8987	3	0	\N
20226	1549	22655968000000	18432	9293	7	0	\N
20227	1549	22655980000000	17785	8987	4	0	\N
20228	1549	22655993000000	18432	9293	8	0	\N
20231	1549	23376003000000	18953	9560	2	0	\N
20234	1549	23376023000000	18953	9560	3	0	\N
20240	1549	24816037000000	19482	9821	3	0	\N
20241	1549	24816037000000	19483	9821	3	0	\N
20242	1549	24816037000000	19506	9831	6	0	\N
20244	1549	24816049000000	19482	9821	4	0	\N
20245	1549	24816049000000	19483	9821	4	0	\N
20247	1549	24816061000000	19506	9831	7	0	\N
20252	1549	25920616000000	9133	4730	2	0	\N
20254	1549	25920636000000	9133	4730	3	0	\N
20256	1549	25920666000000	9381	4866	3	0	\N
20257	1549	26256111000000	20195	10171	6	0	\N
20259	1549	26256144000000	20195	10171	7	0	\N
20263	1549	26640666000000	9381	4866	5	0	\N
20264	1549	26640676000000	9381	4866	6	0	\N
20147	1549	16560451000000	7201	3722	1	0	0
20149	1549	16560461000000	7201	3722	2	0	0
20157	1549	17280461000000	7662	3966	0	0	0
20170	1549	18000461000000	7793	4041	1	0	0
20171	1549	18000471000000	7793	4041	2	0	0
20177	1549	18720481000000	7814	4051	2	0	0
20182	1549	19440481000000	7906	4095	1	0	0
20183	1549	19440491000000	7906	4095	2	0	0
20191	1549	20160491000000	8135	4218	1	0	0
20193	1549	20160501000000	8135	4218	2	0	0
20204	1549	20880511000000	8374	4340	2	0	0
20209	1549	21600511000000	8383	4344	5	0	0
20210	1549	21600556000000	8383	4344	6	0	0
20222	1549	22320556000000	8526	4418	1	0	0
20230	1549	23040566000000	8674	4494	0	0	0
20235	1549	23760566000000	8925	4626	2	0	0
20236	1549	23760586000000	8925	4626	3	0	0
20239	1549	24480586000000	8938	4635	0	0	0
20248	1549	25200586000000	9032	4683	3	0	0
20253	1549	25920616000000	9284	4814	2	0	0
20255	1549	25920636000000	9284	4814	3	0	0
20261	1549	26640636000000	9582	4971	2	0	0
20262	1549	26640656000000	9582	4971	3	0	0
20140	1549	16175795000000	15655	7967	3	0	5
20152	1549	16895807000000	16165	8217	4	0	5
20153	1549	16895820000000	16165	8217	5	0	5
20160	1549	17615820000000	16445	8364	10	0	5
20163	1549	17615857000000	16445	8364	11	0	5
20173	1549	18335869000000	16474	8378	4	0	5
20178	1549	19055869000000	16635	8450	4	0	5
20179	1549	19055882000000	16635	8450	5	0	5
20185	1549	19775882000000	17186	8709	0	0	5
20195	1549	20495882000000	17304	8765	4	0	5
20205	1549	21215904000000	17372	8799	3	0	5
20206	1549	21215916000000	17372	8799	4	0	5
20212	1549	21935916000000	17647	8921	7	0	5
20219	1549	21935968000000	17647	8921	8	0	5
20220	1549	21936003000000	18637	9392	8	0	5
20232	1549	23376003000000	19064	9614	1	0	5
20233	1549	23376013000000	19064	9614	2	0	5
20237	1549	24096013000000	19133	9650	6	0	5
20238	1549	24096037000000	19133	9650	7	0	5
20246	1549	24816051000000	20026	10082	6	0	5
20250	1549	25536051000000	20159	10148	15	0	5
20251	1549	25536111000000	20159	10148	16	0	5
20258	1549	26256111000000	20782	10445	6	0	5
20260	1549	26256153000000	20782	10445	7	0	5
20135	1549	15551467000000	28732	14178	4	0	10
20142	1549	16271467000000	28974	14288	3	0	10
20143	1549	16271479000000	28974	14288	4	0	10
20154	1549	16991479000000	29533	14563	4	0	10
20155	1549	16991492000000	29533	14563	5	0	10
20167	1549	17711509000000	29752	14664	9	0	10
20174	1549	18431509000000	29803	14685	19	0	10
20175	1549	18431546000000	29803	14685	20	0	10
20180	1549	19151546000000	30052	14795	17	0	10
20187	1549	19871580854742	30056	14797	20	0	10
20188	1549	19871618854742	30056	14797	21	0	10
20198	1549	20591618854742	30079	14810	11	0	10
20200	1549	20591638854742	30079	14810	12	0	10
20207	1549	21311638854742	30120	14822	23	0	10
20266	1549	26976153000000	21098	10597	3	0	\N
20268	1549	26976165000000	21098	10597	4	0	\N
20270	1549	27360656000000	9781	5068	3	0	\N
20271	1549	27360686000000	9781	5068	4	0	\N
20276	1549	27696262000000	21418	10740	8	0	\N
20277	1549	28080716000000	9994	5183	2	0	\N
20278	1549	28080716000000	10198	5280	2	0	\N
20280	1549	28080736000000	9994	5183	3	0	\N
20281	1549	28080736000000	10198	5280	3	0	\N
20283	1549	28416198000000	21342	10712	3	0	\N
20284	1549	28416210000000	21342	10712	4	0	\N
20286	1549	28416262000000	21418	10740	12	0	\N
20288	1549	28416265000000	21418	10740	13	0	\N
20289	1549	28800756000000	10552	5449	7	0	\N
20292	1549	28800786000000	11109	5713	1	0	\N
20293	1549	28800826000000	10552	5449	8	0	\N
20296	1549	29520776000000	10942	5640	2	0	\N
20297	1549	29520776000000	10997	5666	2	0	\N
20300	1549	29520786000000	11109	5713	3	0	\N
20301	1549	29520796000000	10942	5640	3	0	\N
20302	1549	29520796000000	10997	5666	3	0	\N
20303	1549	29520796000000	11109	5713	4	0	\N
20312	1549	31296313000000	22762	11382	0	0	\N
20319	1549	33840793000000	12212	6291	1	0	\N
20321	1549	33840794000000	12212	6291	2	0	\N
20323	1549	33840807000000	12499	6440	2	0	\N
20325	1549	34560807000000	12499	6440	3	0	\N
20328	1550	10000000	3233	1551	11	0	\N
20330	1550	1440010000000	22060	11030	3	0	\N
20331	1550	1440022000000	22060	11030	4	0	\N
20334	1551	1440012000000	27848	13765	3	0	\N
20335	1551	1440024000000	27848	13765	4	0	\N
20346	1552	4320064000000	23637	11775	7	0	\N
20347	1552	4320089000000	23637	11775	8	0	\N
20348	1555	100001000	25477	12617	6	1	\N
20350	1555	1440000000000	315	181	2	0	\N
20353	1555	1440020000000	315	181	3	0	\N
20354	1555	2160010000000	567	320	1	0	\N
20355	1555	2160010000000	761	424	1	0	\N
20356	1555	2160010000000	968	539	1	0	\N
20357	1555	2160010000000	1218	670	1	0	\N
20358	1555	2160010000000	1457	793	2	0	\N
20359	1555	2160010000000	1675	899	4	0	\N
20360	1555	2160010000000	2281	1016	10	0	\N
20362	1555	2160020000000	567	320	2	0	\N
20363	1555	2160020000000	761	424	2	0	\N
20364	1555	2160020000000	968	539	2	0	\N
20365	1555	2160020000000	1218	670	2	0	\N
20366	1555	2160021000000	1457	793	3	0	\N
20367	1555	2160050000000	1675	899	5	0	\N
20368	1555	2160290000000	2281	1016	11	0	\N
20380	1555	5760060000000	2777	1453	2	0	\N
20381	1555	5760060000000	2974	1546	1	0	\N
20382	1555	5760060000000	3215	1671	1	0	\N
20383	1555	5760060000000	3291	1708	13	0	\N
20384	1555	5760060000000	4106	2133	2	0	\N
20386	1555	5760070000000	2974	1546	2	0	\N
20387	1555	5760070000000	3215	1671	2	0	\N
20389	1555	5760080000000	2777	1453	3	0	\N
20390	1555	5760170000000	4106	2133	3	0	\N
20391	1555	5760190000000	3291	1708	14	0	\N
20392	1555	5955138979096	12085	6222	2	0	\N
20394	1555	5955140979096	12085	6222	3	0	\N
20397	1555	6480190000000	3297	1709	2	0	\N
20398	1555	6480210000000	3297	1709	3	0	\N
20399	1555	6675138979096	12907	6652	4	0	\N
20400	1555	6675138979096	13240	6819	3	0	\N
20352	1555	1440010000000	407	231	2	0	0
20336	1552	720000000000	1177	649	1	0	0
20337	1552	720010000000	1177	649	2	0	0
20338	1552	1440010000000	1720	923	1	0	0
20339	1552	1440020000000	1720	923	2	0	0
20369	1555	2880010000000	2484	1301	0	0	0
20370	1555	3600010000000	2557	1347	2	0	0
20371	1555	3600030000000	2557	1347	3	0	0
20372	1555	4320030000000	2574	1357	2	0	0
20373	1555	4320050000000	2574	1357	3	0	0
20341	1552	2160030000000	2593	1366	2	0	0
20376	1555	5040050000000	2714	1425	1	0	0
20377	1555	5040060000000	2714	1425	2	0	0
20329	1550	720010000000	3572	1854	0	0	0
20388	1555	5760070000000	4384	2273	2	0	0
20395	1555	6480070000000	4769	2464	1	0	0
20396	1555	6480080000000	4769	2464	2	0	0
20265	1549	26640716000000	9946	5163	6	0	0
20272	1549	27360716000000	9946	5163	7	0	0
20282	1549	28080756000000	10351	5357	5	0	0
20290	1549	28800756000000	10639	5495	2	0	0
20291	1549	28800776000000	10639	5495	3	0	0
20298	1549	29520776000000	11450	5881	1	0	0
20299	1549	29520777000000	11450	5881	2	0	0
20307	1549	30240788000000	11512	5913	3	0	0
20310	1549	30960788000000	11746	6037	1	0	0
20311	1549	30960789000000	11746	6037	2	0	0
20313	1549	31680789000000	11908	6125	1	0	0
20315	1549	32400790000000	11960	6157	2	0	0
20316	1549	32400792000000	11960	6157	3	0	0
20374	1555	4515135979096	11992	6172	1	0	4
20375	1555	4515136979096	11992	6172	2	0	4
20378	1555	5235136979096	12026	6190	2	0	4
20317	1549	33120792000000	12116	6240	1	0	0
20318	1549	33120793000000	12116	6240	2	0	0
20320	1549	33840793000000	12225	6297	3	0	0
20322	1549	33840796000000	12225	6297	4	0	0
20393	1555	5955138979096	12440	6413	0	0	4
20326	1549	34560818000000	12509	6445	5	0	0
20342	1552	2880030000000	16142	8206	3	0	0
20343	1552	2880042000000	16142	8206	4	0	0
20267	1549	26976153000000	21100	10597	3	0	5
20273	1549	27696165000000	21159	10627	6	0	5
20274	1549	27696198000000	21159	10627	7	0	5
20344	1552	3600042000000	21218	10654	4	0	0
20345	1552	3600064000000	21218	10654	5	0	0
20275	1549	27696262000000	21415	10740	8	0	5
20287	1549	28416265000000	21415	10740	13	0	5
20294	1549	29136265000000	21771	10900	3	0	5
20295	1549	29136277000000	21771	10900	4	0	5
20304	1549	29856277000000	21882	10949	6	0	5
20305	1549	29856301000000	21882	10949	7	0	5
20309	1549	30576313000000	22110	11057	4	0	5
20332	1551	720000000000	22731	11365	3	0	0
20333	1551	720012000000	22731	11365	4	0	0
20401	1555	6675138979096	13275	6836	2	0	\N
20402	1555	6675138979096	13634	7010	14	0	\N
20403	1555	6675138979096	14380	7337	1	0	\N
20405	1555	6675148979096	14380	7337	2	0	\N
20406	1555	6675149979096	13275	6836	3	0	\N
20407	1555	6675150979096	13240	6819	4	0	\N
20408	1555	6675160979096	12907	6652	5	0	\N
20410	1555	6675170979096	13634	7010	15	0	\N
20412	1555	6725756540449	22509	11259	20	0	\N
20414	1555	6725893540449	22509	11259	21	0	\N
20417	1555	7395164979096	14551	7422	10	0	\N
20421	1555	7395300979096	14551	7422	11	0	\N
20422	1555	7445893540449	22574	11293	10	0	\N
20425	1555	7445966540449	22574	11293	11	0	\N
20426	1555	7920090000000	4919	2545	1	0	\N
20428	1555	7920100000000	4919	2545	2	0	\N
20430	1555	8115206979096	15638	7958	4	0	\N
20431	1555	8115219979096	15638	7958	5	0	\N
20434	1555	8165905540449	23191	11578	2	0	\N
20436	1555	8165916540449	23191	11578	3	0	\N
20440	1555	8835230979096	15783	8028	4	0	\N
20441	1555	8835230979096	16453	8368	8	0	\N
20443	1555	8835243979096	15783	8028	5	0	\N
20445	1555	8835265979096	16453	8368	9	0	\N
20448	1555	9260664124170	25643	12633	124	0	\N
20451	1555	9555257979096	16702	8486	4	0	\N
20454	1555	9555270979096	16702	8486	5	0	\N
20459	1555	10275269979096	16911	8574	7	0	\N
20460	1555	10275269979096	16977	8600	0	0	\N
20461	1555	10275269979096	17808	8994	1	0	\N
20463	1555	10275279979096	17808	8994	2	0	\N
20465	1555	10275294979096	16911	8574	8	0	\N
20468	1555	10800170000000	7393	3818	1	0	\N
20469	1555	10800170000000	7569	3918	1	0	\N
20471	1555	10800180000000	7393	3818	2	0	\N
20472	1555	10800180000000	7569	3918	2	0	\N
20474	1555	10995291979096	18126	9111	58	0	\N
20475	1555	10995291979096	19291	9726	7	0	\N
20476	1555	10995291979096	19315	9739	3	0	\N
20477	1555	10995291979096	19434	9674	0	0	\N
20478	1555	10995291979096	19435	9795	8	0	\N
20480	1555	10995303979096	19315	9739	4	0	\N
20481	1555	10995316979096	19291	9726	8	0	\N
20482	1555	10995317979096	19435	9795	9	0	\N
20484	1555	10995745979096	18126	9111	59	0	\N
20485	1555	10996895979096	18367	9112	43	0	\N
20491	1555	11715327979096	19622	9882	7	0	\N
20493	1555	11715352979096	19622	9882	8	0	\N
20494	1555	11716895979096	18367	9112	125	0	\N
20497	1555	12240220000000	9050	4691	13	0	\N
20498	1555	12240220000000	9167	4751	2	0	\N
20500	1555	12240240000000	9167	4751	3	0	\N
20502	1555	12240341000000	9050	4691	14	0	\N
20503	1555	12435352979096	19821	9955	5	0	\N
20506	1555	12435753979096	19821	9955	6	0	\N
20509	1555	12486135540449	25477	12617	1	0	\N
20510	1555	12486408540449	25551	12632	49	0	\N
20513	1555	13155363979096	19894	10021	4	0	\N
20515	1555	13155376979096	19894	10021	5	0	\N
20518	1555	13206135540449	25477	12617	5	0	\N
20520	1555	13206408540449	25551	12632	79	0	\N
20521	1555	13206437540449	25551	12632	80	0	\N
20522	1555	13207127540449	25643	12633	96	0	\N
20523	1555	13680262000000	9325	4836	1	0	\N
20525	1555	13680272000000	9325	4836	2	0	\N
20527	1555	13875379979096	20638	10384	4	0	\N
20529	1555	13875392979096	20638	10384	5	0	\N
20534	1555	13927127540449	25643	12633	123	0	\N
20427	1555	7920090000000	5847	3033	1	0	0
20429	1555	7920100000000	5847	3033	2	0	0
20438	1555	8640100000000	6311	3267	2	0	0
20439	1555	8640120000000	6311	3267	3	0	0
20449	1555	9360120000000	6430	3328	4	0	0
20457	1555	10080160000000	7273	3760	1	0	0
20458	1555	10080170000000	7273	3760	2	0	0
20470	1555	10800170000000	7735	4008	1	0	0
20473	1555	10800180000000	7735	4008	2	0	0
20488	1555	11520180000000	8706	4514	4	0	0
20499	1555	12240220000000	9173	4754	4	0	0
20501	1555	12240242000000	9173	4754	5	0	0
20511	1555	12960242000000	9280	4812	2	0	0
20512	1555	12960262000000	9280	4812	3	0	0
20526	1555	13680282000000	9447	4899	3	0	0
20535	1555	14400282000000	10077	5227	5	0	0
20536	1555	14400332000000	10077	5227	6	0	0
20404	1555	6675138979096	14491	7394	17	0	4
20409	1555	6675164979096	14491	7394	18	0	4
20419	1555	7395206979096	15558	7919	7	0	4
20420	1555	7395229979096	15650	7964	5	0	4
20432	1555	8115229979096	15650	7964	7	0	4
20433	1555	8115230979096	15650	7964	8	0	4
20442	1555	8835230979096	16696	8481	9	0	4
20452	1555	9555257979096	16794	8523	3	0	4
20453	1555	9555269979096	16794	8523	4	0	4
20462	1555	10275269979096	17986	9073	4	0	4
20464	1555	10275291979096	17986	9073	5	0	4
20483	1555	10995327979096	19614	9880	10	0	4
20490	1555	11715327979096	19621	9882	7	0	4
20492	1555	11715352979096	19621	9882	8	0	4
20504	1555	12435352979096	19822	9985	2	0	4
20505	1555	12435363979096	19822	9985	3	0	4
20516	1555	13155379979096	20618	10371	8	0	4
20528	1555	13875379979096	21008	10563	5	0	4
20530	1555	13875402979096	21008	10563	6	0	4
20411	1555	6725756540449	22508	11259	20	0	8
20413	1555	6725893540449	22508	11259	21	0	8
20424	1555	7445905540449	23121	11548	4	0	8
20435	1555	8165905540449	23481	11708	3	0	8
20437	1555	8165917540449	23481	11708	4	0	8
20446	1555	8885917540449	23492	11712	3	0	8
20455	1555	9605929540449	24627	12237	4	0	8
20456	1555	9605942540449	24627	12237	5	0	8
20466	1555	10325942540449	24742	12286	18	0	8
20467	1555	10326077540449	24742	12286	19	0	8
20486	1555	11046077540449	24775	12301	2	0	8
20495	1555	11766088540449	25249	12523	6	0	8
20496	1555	11766112540449	25249	12523	7	0	8
20507	1555	12486112540449	25263	12531	4	0	8
20508	1555	12486125540449	25263	12531	5	0	8
20517	1555	13206125540449	25550	12651	3	0	8
20531	1555	13926137540449	25641	12690	3	0	8
20532	1555	13926149540449	25641	12690	4	0	8
20533	1555	13926159540449	26050	12873	1	0	8
20537	1555	14554586940000	18367	9112	126	1	\N
20538	1555	14595402979096	21078	10590	3	0	\N
20539	1555	14595402979096	21217	10651	0	0	\N
20540	1555	14595402979096	21219	10654	2	0	\N
20541	1555	14595402979096	21220	10653	0	0	\N
20543	1555	14595402979096	21540	10802	2	0	\N
20544	1555	14595413979096	21540	10802	3	0	\N
20545	1555	14595414979096	21078	10590	4	0	\N
20547	1555	14595422979096	21219	10654	3	0	\N
20548	1555	14646149540449	25816	12765	6	0	\N
20549	1555	14646149540449	26039	12866	4	0	\N
20551	1555	14646171540449	26039	12866	5	0	\N
20552	1555	14646173540449	25816	12765	7	0	\N
20557	1555	15315414979096	21845	10933	6	0	\N
20560	1555	15315438979096	21845	10933	7	0	\N
20561	1555	15366240540449	26309	12929	39	0	\N
20563	1555	15366279540449	26309	12929	40	0	\N
20564	1555	15840352000000	10706	5527	9	0	\N
20566	1555	15840433000000	10706	5527	10	0	\N
20567	1555	16035426979096	22090	11044	2	0	\N
20570	1555	16035437979096	22090	11044	3	0	\N
20571	1555	16086240540449	27055	13375	8	0	\N
20572	1555	16086240540449	27288	13487	2	0	\N
20574	1555	16086251540449	27288	13487	3	0	\N
20576	1555	16086275540449	27055	13375	9	0	\N
20578	1555	16560372000000	10821	5583	2	0	\N
20579	1555	16560372000000	10936	5636	4	0	\N
20580	1555	16560372000000	11292	5800	2	0	\N
20583	1555	16560383000000	11292	5800	3	0	\N
20584	1555	16560392000000	10821	5583	3	0	\N
20585	1555	16560412000000	10936	5636	5	0	\N
20587	1555	16755428979096	22157	11083	10	0	\N
20589	1555	16755465979096	22157	11083	11	0	\N
20591	1555	16806384540449	27528	13533	87	0	\N
20592	1555	17280374000000	11762	6047	2	0	\N
20593	1555	17280376000000	11762	6047	3	0	\N
20594	1555	17475436979105	22178	11097	6	0	\N
20595	1555	17475460979105	22178	11097	7	0	\N
20596	1555	17526288540449	27529	13610	6	0	\N
20597	1555	17526288540449	27821	13750	3	0	\N
20598	1555	17526288540449	27951	13828	6	0	\N
20600	1555	17526300540449	27821	13750	4	0	\N
20601	1555	17526312540449	27529	13610	7	0	\N
20602	1555	17526312540449	27951	13828	7	0	\N
20604	1555	17526384540449	27528	13533	89	0	\N
20605	1555	17526385540449	27528	13533	90	0	\N
20606	1555	18246312540449	28203	13943	1	0	\N
20607	1555	18246312540449	28456	14062	2	0	\N
20608	1555	18246312540449	28933	14269	3	0	\N
20610	1555	18246313540449	28203	13943	2	0	\N
20611	1555	18246323540449	28456	14062	3	0	\N
20613	1555	18246324540449	28933	14269	4	0	\N
20616	1556	20256000000	12091	6029	31	0	\N
20617	1556	720000000000	10523	5434	4	0	\N
20619	1556	720000000000	12093	6199	43	0	\N
20621	1556	720040000000	10523	5434	5	0	\N
20622	1556	720052000000	12093	6199	44	0	\N
20623	1556	740255999999	12091	6029	32	0	\N
20624	1556	1440002000000	19607	9772	11	0	\N
20626	1556	1440002000000	19609	9770	19	0	\N
20628	1556	1440139000000	19607	9772	12	0	\N
20629	1556	1440156000000	19609	9770	20	0	\N
20630	1559	10000001	4262	2210	4	0	\N
20631	1559	200000001	10923	5634	6	0	\N
20632	1559	720000000000	53	30	1	0	\N
20634	1559	720010000000	53	30	2	0	\N
20640	1559	2880060000000	307	176	2	0	\N
20643	1559	2880071000000	307	176	3	0	\N
20644	1559	3599070000000	11796	5819	126	1	\N
20647	1559	4282602000000	10923	5634	2	0	\N
20648	1559	4282992000000	11796	5819	32	0	\N
20649	1559	4320110000000	1105	611	1	0	\N
20650	1559	4320110000000	1170	643	1	0	\N
20652	1559	4320120000000	1105	611	2	0	\N
20653	1559	4320120000000	1170	643	2	0	\N
20655	1559	5002582000000	10926	5634	1	0	\N
20656	1559	5002582000000	11793	6061	1	0	\N
20657	1559	5002582000000	12416	6403	1	0	\N
20659	1559	5002583000000	11793	6061	2	0	\N
20660	1559	5002583000000	12416	6403	2	0	\N
20661	1559	5002592000000	10926	5634	2	0	\N
20663	1559	5002602000000	10923	5634	5	0	\N
20664	1559	5002992000000	11796	5819	125	0	\N
20665	1559	5040120000000	1526	835	4	0	\N
20666	1559	5040120000000	1549	844	1	0	\N
20668	1559	5040130000000	1549	844	2	0	\N
20670	1559	5040160000000	1526	835	5	0	\N
20672	1559	5722593000000	14114	6960	0	0	\N
20636	1559	1440030000000	140	82	2	0	0
20637	1559	1440050000000	140	82	3	0	0
20638	1559	2160050000000	208	122	1	0	0
20639	1559	2160060000000	208	122	2	0	0
20641	1559	2880060000000	755	422	1	0	0
20645	1559	3600070000000	853	474	4	0	0
20646	1559	3600110000000	853	474	5	0	0
20651	1559	4320110000000	1327	730	1	0	0
20654	1559	4320120000000	1327	730	2	0	0
20667	1559	5040120000000	1771	950	2	0	0
20554	1555	15120332000000	10599	5475	2	0	0
20555	1555	15120352000000	10599	5475	3	0	0
20556	1555	15120372000000	10789	5569	2	0	0
20565	1555	15840372000000	10789	5569	3	0	0
20582	1555	16560374000000	11612	5975	3	0	0
20618	1556	720000000000	12092	6225	2	0	0
20620	1556	720002000000	12092	6225	3	0	0
20658	1559	5002582000000	12979	6692	2	0	4
20662	1559	5002593000000	12979	6692	3	0	4
20625	1556	1440002000000	19608	9876	7	0	0
20627	1556	1440027000000	19608	9876	8	0	0
20542	1555	14595402979096	21539	10802	3	0	4
20546	1555	14595414979096	21539	10802	4	0	4
20558	1555	15315414979096	22008	11005	3	0	4
20568	1555	16035426979096	22091	11044	2	0	4
20569	1555	16035428979096	22091	11044	3	0	4
20586	1555	16755428979096	22153	11083	10	0	4
20588	1555	16755436979105	22153	11083	12	0	4
20553	1555	14646240540449	26050	12873	12	0	8
20562	1555	15366240540449	26310	13014	0	0	8
20573	1555	16086240540449	27298	13492	6	0	8
20575	1555	16086264540449	27298	13492	7	0	8
20577	1555	16086288540449	27321	13507	6	0	8
20599	1555	17526288540449	27952	13828	6	0	8
20603	1555	17526312540449	27952	13828	7	0	8
20609	1555	18246312540449	28934	14269	2	0	8
20612	1555	18246323540449	28934	14269	3	0	8
20614	1555	18966323540449	29316	14446	3	0	8
20676	1559	6442604000000	13794	7084	1	0	\N
20678	1559	6442614000000	13794	7084	2	0	\N
20682	1559	6786035000000	22365	11194	4	0	\N
20684	1559	6786048000000	22365	11194	5	0	\N
20689	1559	7200170000000	2207	1162	2	0	\N
20691	1559	7200190000000	2207	1162	3	0	\N
20693	1559	7506060000000	22646	11324	7	0	\N
20694	1559	7506060000000	22974	11476	3	0	\N
20695	1559	7506072000000	22974	11476	4	0	\N
20697	1559	7506085000000	22646	11324	8	0	\N
20698	1559	7882659000000	14310	7303	4	0	\N
20701	1559	7882672000000	14310	7303	5	0	\N
20702	1559	7920190000000	2519	1322	3	0	\N
20703	1559	7920190000000	2528	1328	1	0	\N
20705	1559	7920200000000	2528	1328	2	0	\N
20707	1559	7920220000000	2519	1322	4	0	\N
20708	1559	8226072999999	23014	11495	3	0	\N
20709	1559	8226072999999	23015	11495	1	0	\N
20710	1559	8226072999999	23406	11677	8	0	\N
20711	1559	8226072999999	23598	11751	32	0	\N
20713	1559	8226082999999	23015	11495	2	0	\N
20715	1559	8226084999999	23014	11495	4	0	\N
20716	1559	8226116999999	23406	11677	9	0	\N
20717	1559	8226194999999	23598	11751	33	0	\N
20718	1559	8602671000000	14596	7442	3	0	\N
20719	1559	8602671000000	15120	7706	2	0	\N
20722	1559	8602682000000	15120	7706	3	0	\N
20723	1559	8602683000000	14596	7442	4	0	\N
20724	1559	8640200000000	2985	1552	1	0	\N
20726	1559	8640210000000	2985	1552	2	0	\N
20727	1559	8946083999999	23894	11893	1	0	\N
20728	1559	8946083999999	23895	11893	3	0	\N
20730	1559	8946084999999	23894	11893	2	0	\N
20731	1559	8946095999999	23895	11893	4	0	\N
20733	1559	8946205999999	24420	12114	11	0	\N
20734	1559	8947285999999	24421	12075	79	0	\N
20737	1559	9360200000000	3095	1606	8	0	\N
20740	1559	9360280000000	3095	1606	9	0	\N
20741	1559	9666095999999	25364	12576	6	0	\N
20742	1559	9666095999999	25480	12619	3	0	\N
20744	1559	9666107999999	25480	12619	4	0	\N
20745	1559	9666119999999	25364	12576	7	0	\N
20747	1559	9666205999999	24420	12114	48	0	\N
20748	1559	9666313999999	24420	12114	49	0	\N
20749	1559	9667285999999	24421	12075	126	0	\N
20750	1559	9667566999999	24421	12075	127	0	\N
20765	1559	11826164999999	26875	13292	3	0	\N
20767	1559	11826176999999	26875	13292	4	0	\N
20773	1559	12240260000000	4262	2210	1	0	\N
20774	1559	12240260000000	4263	2210	1	0	\N
20779	1559	12960250000000	3980	2067	1	0	\N
20780	1559	12960250000000	4264	2211	2	0	\N
20781	1559	12960250000000	4337	2248	0	0	\N
20783	1559	12960260000000	3980	2067	2	0	\N
20784	1559	12960260000000	4262	2210	3	0	\N
20785	1559	12960260000000	4263	2210	3	0	\N
20786	1559	12960270000000	4263	2210	4	0	\N
20787	1559	12960270000000	4264	2211	3	0	\N
20791	1559	13642742000000	17420	8824	2	0	\N
20793	1559	13642744000000	17420	8824	3	0	\N
20797	1559	13986224999999	27571	13627	3	0	\N
20798	1559	13986224999999	27667	13673	3	0	\N
20799	1559	13986224999999	27706	13689	10	0	\N
20800	1559	13986224999999	27999	13833	0	0	\N
20801	1559	13986224999999	28000	13847	3	0	\N
20802	1559	13986224999999	28001	13845	0	0	\N
20803	1559	13986224999999	28090	13886	4	0	\N
20805	1559	13986236999999	27571	13627	4	0	\N
20806	1559	13986236999999	27667	13673	4	0	\N
20807	1559	13986236999999	28000	13847	4	0	\N
20680	1559	6480150000000	1886	1003	2	0	0
20681	1559	6480170000000	1886	1003	3	0	0
20690	1559	7200170000000	2512	1318	2	0	0
20692	1559	7200190000000	2512	1318	3	0	0
20704	1559	7920190000000	2542	1337	1	0	0
20725	1559	8640200000000	3001	1559	0	0	0
20738	1559	9360200000000	3164	1644	1	0	0
20739	1559	9360210000000	3164	1644	2	0	0
20753	1559	10080210000000	3421	1778	2	0	0
20754	1559	10080230000000	3421	1778	3	0	0
20763	1559	11520230000000	3933	2040	1	0	0
20764	1559	11520240000000	3933	2040	2	0	0
20771	1559	12240240000000	3975	2064	1	0	0
20772	1559	12240250000000	3975	2064	2	0	0
20788	1559	12960270000000	4386	2274	3	0	0
20795	1559	13680270000000	5245	2722	1	0	0
20796	1559	13680280000000	5245	2722	2	0	0
20673	1559	5722604000000	13691	7034	3	0	4
20677	1559	6442604000000	13795	7084	4	0	4
20687	1559	7162617000000	14115	7214	15	0	4
20688	1559	7162659000000	14115	7214	16	0	4
20699	1559	7882659000000	14453	7377	3	0	4
20700	1559	7882671000000	14453	7377	4	0	4
20720	1559	8602671000000	15323	7809	1	0	4
20735	1559	9322681000000	16047	8161	3	0	4
20736	1559	9322693000000	16047	8161	4	0	4
20751	1559	10042693000000	16252	8259	3	0	4
20752	1559	10042705000000	16252	8259	4	0	4
20761	1559	11482705000000	16327	8298	4	0	4
20762	1559	11482718000000	16327	8298	5	0	4
20769	1559	12202718000000	16415	8349	4	0	4
20770	1559	12202731000000	16415	8349	5	0	4
20777	1559	12922731000000	17008	8615	2	0	4
20792	1559	13642742000000	17533	8879	3	0	4
20794	1559	13642754000000	17533	8879	4	0	4
20683	1559	6786035000000	22424	11223	7	0	8
20685	1559	6786060000000	22424	11223	8	0	8
20686	1559	6786073000000	22973	11476	4	0	8
20712	1559	8226072999999	23599	11758	2	0	8
20714	1559	8226083999999	23599	11758	3	0	8
20729	1559	8946083999999	23956	11919	3	0	8
20732	1559	8946095999999	23956	11919	4	0	8
20746	1559	9666139999999	26084	12890	9	0	8
20755	1559	10386139999999	26268	12990	3	0	8
20756	1559	10386151999999	26268	12990	4	0	8
20759	1559	11106151999999	26400	13061	4	0	8
20760	1559	11106164999999	26400	13061	5	0	8
20768	1559	11826200999999	26982	13343	10	0	8
20775	1559	12546200999999	27305	13497	3	0	8
20776	1559	12546212999999	27305	13497	4	0	8
20789	1559	13266212999999	27565	13624	3	0	8
20790	1559	13266224999999	27565	13624	4	0	8
20808	1559	13986236999999	28291	13985	4	0	8
20809	1559	13986237999999	28090	13886	5	0	\N
20810	1559	13986297999999	27706	13689	11	0	\N
20811	1559	14362754000000	17564	8891	6	0	\N
20812	1559	14362754000000	17764	8974	3	0	\N
20814	1559	14362766000000	17764	8974	4	0	\N
20815	1559	14362778000000	17564	8891	7	0	\N
20817	1559	14400280000000	5450	2836	1	0	\N
20819	1559	14400281000000	5450	2836	2	0	\N
20825	1559	15082833000000	19651	9897	3	0	\N
20828	1559	15426247999999	28359	14019	2	0	\N
20830	1559	15426258999999	28359	14019	3	0	\N
20832	1559	15802821000000	18980	9572	1	0	\N
20833	1559	15802821000000	18981	9572	0	0	\N
20834	1559	15802831000000	18980	9572	2	0	\N
20836	1559	15802833000000	19651	9897	4	0	\N
20839	1559	16146275499999	28420	14046	4	0	\N
20840	1559	16146275499999	28445	14058	5	0	\N
20843	1559	16146297499999	28420	14046	5	0	\N
20844	1559	16146302999999	28445	14058	6	0	\N
20847	1559	16560320000000	7250	3749	1	0	\N
20849	1559	16560330000000	7250	3749	2	0	\N
20857	1559	17586309499999	29008	14304	5	0	\N
20858	1559	17586309499999	29725	14654	9	0	\N
20861	1559	17586332499999	29008	14304	6	0	\N
20863	1559	17586376499999	29725	14654	10	0	\N
20866	1559	18000410000000	7648	3958	2	0	\N
20867	1559	18000410000000	7897	4092	1	0	\N
20868	1559	18000410000000	7969	4129	5	0	\N
20869	1559	18000410000000	7970	4129	1	0	\N
20871	1559	18000420000000	7897	4092	2	0	\N
20872	1559	18000420000000	7970	4129	2	0	\N
20873	1559	18000430000000	7648	3958	3	0	\N
20875	1559	18000460000000	7969	4129	6	0	\N
20880	1559	18720440000000	8317	4305	5	0	\N
20881	1559	18720440000000	8318	4305	5	0	\N
20884	1559	18720571000000	8317	4305	6	0	\N
20885	1559	18720571000000	8318	4305	6	0	\N
20888	1559	19402870000000	20307	10227	3	0	\N
20891	1559	19402882000000	20307	10227	4	0	\N
20892	1559	19440540000000	9056	4694	5	0	\N
20894	1559	19440540000000	9578	4968	1	0	\N
20895	1559	19440550000000	9578	4968	2	0	\N
20897	1559	19440581000000	9056	4694	6	0	\N
20898	1559	20122881000000	21175	10633	2	0	\N
20900	1559	20122892000000	21175	10633	3	0	\N
20902	1559	20160560000000	9719	5038	5	0	\N
20904	1559	20160601000000	9719	5038	6	0	\N
20906	1559	20842905000000	21770	10900	3	0	\N
20907	1559	20842905000000	22002	11001	3	0	\N
20908	1559	20842905000000	22019	11009	4	0	\N
20910	1559	20842917000000	21770	10900	4	0	\N
20911	1559	20842917000000	22002	11001	4	0	\N
20912	1559	20842918000000	22019	11009	5	0	\N
20924	1560	200000014	11281	5795	7	0	\N
20927	1560	1440010000000	228	135	2	0	\N
20929	1560	1440030000000	228	135	3	0	\N
20932	1560	2033957277002	10323	5340	4	0	\N
20934	1560	2033997277002	10323	5340	5	0	\N
20935	1560	2160040000000	360	205	2	0	\N
20936	1560	2160040000000	916	509	2	0	\N
20938	1560	2160040000000	1188	625	0	0	\N
20939	1560	2160040000000	1189	605	0	0	\N
20940	1560	2160060000000	360	205	3	0	\N
20942	1560	2160130000000	1600	843	6	0	\N
20943	1560	2160150000000	916	509	3	0	\N
20928	1560	1440010000000	357	203	3	0	0
20930	1560	1440040000000	357	203	4	0	0
20937	1560	2160040000000	1187	656	3	0	0
20941	1560	2160070000000	1187	656	4	0	0
20818	1559	14400280000000	5692	2951	0	0	0
20827	1559	15120290000000	5900	3058	2	0	0
20837	1559	15840290000000	6315	3269	3	0	0
20838	1559	15840320000000	6315	3269	4	0	0
20848	1559	16560320000000	7322	3785	1	0	0
20850	1559	16560330000000	7322	3785	2	0	0
20856	1559	17280410000000	7365	3804	9	0	0
20870	1559	18000410000000	8052	4171	3	0	0
20874	1559	18000440000000	8052	4171	4	0	0
20882	1559	18720440000000	8941	4637	10	0	0
20893	1559	19440540000000	9577	4968	2	0	0
20896	1559	19440560000000	9577	4968	3	0	0
20903	1559	20160560000000	9720	5038	6	0	0
20905	1559	20160611000000	9720	5038	7	0	0
20914	1559	20880611000000	9750	5051	4	0	0
20918	1559	21600651000000	10256	5306	2	0	0
20919	1559	21600671000000	10256	5306	3	0	0
20920	1559	22320671000000	10275	5318	8	0	0
20921	1559	22320841000000	10275	5318	9	0	0
20931	1560	2033957277002	10321	5340	4	0	15
20922	1559	23040841000000	10328	5344	5	0	0
20923	1559	23041161000000	10328	5344	6	0	0
20944	1560	2753997277001	10636	5493	3	0	15
20916	1559	21118311000000	10790	5570	5	0	1
20813	1559	14362754000000	17948	9052	7	0	4
20816	1559	14362779000000	17948	9052	8	0	4
20822	1559	15082779000000	18723	9434	6	0	4
20823	1559	15082821000000	18723	9434	7	0	4
20824	1559	15082833000000	19650	9897	3	0	4
20845	1559	16522833000000	19841	9996	4	0	4
20846	1559	16522846000000	19841	9996	5	0	4
20854	1559	17242846000000	19977	10059	0	0	4
20864	1559	17962846000000	20238	10190	3	0	4
20865	1559	17962858000000	20238	10190	4	0	4
20879	1559	18682870000000	20269	10208	4	0	4
20889	1559	19402870000000	21166	10631	2	0	4
20890	1559	19402881000000	21166	10631	3	0	4
20899	1559	20122881000000	21381	10727	6	0	4
20909	1559	20842905000000	22131	11070	6	0	4
20913	1559	20842929000000	22131	11070	7	0	4
20820	1559	14706236999999	28354	14016	2	0	8
20821	1559	14706247999999	28354	14016	3	0	8
20829	1559	15426247999999	28418	14045	5	0	8
20841	1559	16146275499999	28499	14084	2	0	8
20842	1559	16146286499999	28499	14084	3	0	8
20851	1559	16866286499999	28794	14205	5	0	8
20852	1559	16866309499999	28794	14205	6	0	8
20853	1559	16866320499999	29880	14725	2	0	8
20860	1559	17586328104999	29880	14725	13	1	8
20862	1559	17586339104999	29956	14754	2	0	8
20876	1559	18306339104999	29956	14754	11	0	8
20877	1559	18306346897799	29956	14754	13	0	8
20887	1559	19026364897799	30174	14845	10	0	8
20946	1560	2880070000000	1511	827	2	0	\N
20947	1560	2880070000000	1540	662	0	0	\N
20948	1560	2880070000000	1541	841	1	0	\N
20949	1560	2880070000000	1543	680	0	0	\N
20950	1560	2880070000000	1544	696	0	0	\N
20951	1560	2880070000000	1601	867	2	0	\N
20953	1560	2880080000000	1541	841	2	0	\N
20955	1560	2880090000000	1511	827	3	0	\N
20956	1560	2880090000000	1601	867	3	0	\N
20957	1560	2880120000000	1600	843	7	0	\N
20960	1560	3474077277001	11280	5795	1	0	\N
20961	1560	3474077277001	11281	5795	1	0	\N
20964	1560	3600110000000	1646	844	0	0	\N
20965	1560	3609580131803	20450	10298	3	0	\N
20967	1560	3609592131803	20450	10298	4	0	\N
20969	1560	3611312131803	21666	10626	89	0	\N
20970	1560	4194067277001	11182	5743	4	0	\N
20971	1560	4194067277001	11183	5742	0	0	\N
20973	1560	4194077277001	11280	5795	5	0	\N
20974	1560	4194077277001	11281	5795	5	0	\N
20976	1560	4194098277001	11280	5795	6	0	\N
20977	1560	4194107277001	11182	5743	5	0	\N
20979	1560	4320100000000	1680	845	0	0	\N
20982	1560	4329602131803	21665	10854	3	0	\N
20984	1560	4329614131803	21665	10854	4	0	\N
20985	1560	4331312131803	21666	10626	126	0	\N
20986	1560	4331672131803	21666	10626	127	0	\N
20989	1560	5040100000000	1828	978	1	0	\N
20990	1560	5040100000000	1919	1023	1	0	\N
20992	1560	5040110000000	1828	978	2	0	\N
20993	1560	5040110000000	1919	1023	2	0	\N
20996	1560	5049612131803	21806	10859	12	0	\N
20998	1560	5049787131803	21806	10859	13	0	\N
20999	1560	5634099277001	11961	6157	2	0	\N
21002	1560	5634101277001	11961	6157	3	0	\N
21003	1560	5760110000000	2346	1226	1	0	\N
21005	1560	5760120000000	2346	1226	2	0	\N
21011	1560	6480140000000	2491	1305	1	0	\N
21012	1560	6480140000000	2560	1350	2	0	\N
21014	1560	6480150000000	2491	1305	2	0	\N
21016	1560	6480160000000	2560	1350	3	0	\N
21020	1560	7074201277001	12338	6359	1	0	\N
21022	1560	7074202277001	12338	6359	2	0	\N
21025	1560	7208599131803	22801	11402	4	0	\N
21027	1560	7208612131803	22801	11402	5	0	\N
21029	1560	7794202277001	12675	6537	2	0	\N
21030	1560	7794202277001	12773	6585	3	0	\N
21031	1560	7794202277001	12775	6586	2	0	\N
21034	1560	7794213277001	12675	6537	3	0	\N
21035	1560	7794213277001	12775	6586	3	0	\N
21036	1560	7794214277001	12773	6585	4	0	\N
21037	1560	7794362277001	12916	6640	15	0	\N
21040	1560	7928660131803	22964	11472	3	0	\N
21043	1560	7928672131803	22964	11472	4	0	\N
21046	1560	8514362277001	12916	6640	44	0	\N
21047	1560	8514444277001	12916	6640	45	0	\N
21048	1560	8640200000000	3743	1941	2	0	\N
21049	1560	8640200000000	4049	2103	1	0	\N
21051	1560	8640210000000	4049	2103	2	0	\N
21052	1560	8640211000000	3743	1941	3	0	\N
21056	1560	9234223277001	13195	6799	2	0	\N
21057	1560	9234223277001	13196	6799	6	0	\N
21060	1560	9234243277001	13195	6799	3	0	\N
21061	1560	9234247277001	13196	6799	7	0	\N
21064	1560	9368682131803	23507	11717	3	0	\N
21066	1560	9368694131803	23507	11717	4	0	\N
21068	1560	9954235277001	13759	7069	8	0	\N
21069	1560	9954235277001	13760	7069	3	0	\N
21070	1560	9954235277001	13843	7106	16	0	\N
21071	1560	9954235277001	13845	7106	5	0	\N
21072	1560	9954235277001	14029	7188	1	0	\N
21073	1560	9954235277001	14032	7188	6	0	\N
21074	1560	9954235277001	14338	7318	4	0	\N
21077	1560	9954245277001	14029	7188	2	0	\N
21078	1560	9954248277001	14338	7318	5	0	\N
21079	1560	9954250277001	14032	7188	7	0	\N
21080	1560	9954256277001	13760	7069	4	0	\N
20962	1560	3600080000000	1681	902	1	0	0
20963	1560	3600090000000	1681	902	2	0	0
20978	1560	4320090000000	1726	927	1	0	0
20980	1560	4320100000000	1726	927	2	0	0
20991	1560	5040100000000	1982	1047	1	0	0
21004	1560	5760110000000	2419	1266	3	0	0
21006	1560	5760140000000	2419	1266	4	0	0
21013	1560	6480140000000	2958	1538	1	0	0
21015	1560	6480150000000	2958	1538	2	0	0
21023	1560	7200150000000	3087	1602	2	0	0
21038	1560	7920170000000	3282	1706	3	0	0
21039	1560	7920200000000	3282	1706	4	0	0
21050	1560	8640200000000	4052	2105	2	0	0
21053	1560	8640220000000	4052	2105	3	0	0
21063	1560	9360230000000	4155	2161	2	0	0
20945	1560	2754027277001	10636	5493	4	0	15
20958	1560	3474027277001	10653	5501	4	0	15
20959	1560	3474067277001	10653	5501	5	0	15
20972	1560	4194067277001	11309	5809	3	0	15
20987	1560	4914088277001	11402	5856	2	0	15
20988	1560	4914099277001	11402	5856	3	0	15
21000	1560	5634099277001	11981	6166	1	0	15
21001	1560	5634100277001	11981	6166	2	0	15
21009	1560	6354100277001	12312	6344	2	0	15
21019	1560	7074201277001	12337	6359	1	0	15
21021	1560	7074202277001	12337	6359	2	0	15
21032	1560	7794202277001	12823	6614	1	0	15
21033	1560	7794212277001	12823	6614	2	0	15
21045	1560	8514223277001	12915	6656	3	0	15
21058	1560	9234223277001	13392	6901	3	0	15
21059	1560	9234235277001	13392	6901	4	0	15
21075	1560	9954235277001	14450	7375	2	0	15
21076	1560	9954237277001	14450	7375	3	0	15
20968	1560	3609602131803	20871	10491	5	0	29
20981	1560	4329602131803	21664	10854	1	0	29
20983	1560	4329612131803	21664	10854	2	0	29
20995	1560	5049612131803	21805	10914	6	0	29
20997	1560	5049636131803	21805	10914	7	0	29
21008	1560	5769688131803	22240	11131	8	0	29
21017	1560	6488587131803	22391	11209	3	0	30
21018	1560	6488599131803	22391	11209	4	0	30
21026	1560	7208599131803	22945	11465	16	0	30
21041	1560	7928660131803	23199	11581	2	0	30
21042	1560	7928671131803	23199	11581	3	0	30
21054	1560	8648671131803	23200	11582	2	0	30
21055	1560	8648682131803	23200	11582	3	0	30
21065	1560	9368682131803	23545	11737	4	0	30
21081	1560	9954261277001	13759	7069	9	0	\N
21082	1560	9954276277001	13845	7106	6	0	\N
21083	1560	9954287277001	13843	7106	17	0	\N
21084	1560	10080230000000	4256	2209	1	0	\N
21086	1560	10080240000000	4256	2209	2	0	\N
21089	1560	10088695131803	23668	11787	3	0	\N
21091	1560	10088707131803	23668	11787	4	0	\N
21096	1560	10808706131803	23676	11790	2	0	\N
21097	1560	10808706131803	23677	11790	3	0	\N
21099	1560	10808717131803	23676	11790	3	0	\N
21100	1560	10808718131803	23677	11790	4	0	\N
21102	1560	11394249277001	14727	7498	4	0	\N
21103	1560	11394249277001	14730	7499	2	0	\N
21104	1560	11394249277001	15183	7736	3	0	\N
21106	1560	11394260277001	14730	7499	3	0	\N
21108	1560	11394270277001	15183	7736	4	0	\N
21109	1560	11394271277001	14727	7498	5	0	\N
21110	1560	11520260000000	4419	2290	9	0	\N
21113	1560	11520323000000	4419	2290	10	0	\N
21114	1560	11528731131803	23883	11888	3	0	\N
21116	1560	11528743131803	23883	11888	4	0	\N
21123	1560	12248755131803	23959	11920	2	0	\N
21124	1560	12248757131803	23959	11920	3	0	\N
21130	1560	12968767131803	24036	11961	3	0	\N
21131	1560	12968767131803	24099	11996	2	0	\N
21132	1560	12968767131803	24192	12041	2	0	\N
21134	1560	12968778131803	24099	11996	3	0	\N
21135	1560	12968778131803	24192	12041	3	0	\N
21136	1560	12968779131803	24036	11961	4	0	\N
21138	1560	13554286277001	15844	8059	4	0	\N
21140	1560	13554299277001	15844	8059	5	0	\N
21144	1560	13688779131803	24304	12086	3	0	\N
21145	1560	13688779131803	24613	12233	3	0	\N
21146	1560	13688779131803	24616	12233	2	0	\N
21147	1560	13688779131803	24922	12374	3	0	\N
21148	1560	13688779131803	24923	12373	7	0	\N
21150	1560	13688781131803	24616	12233	3	0	\N
21151	1560	13688791131803	24304	12086	4	0	\N
21152	1560	13688791131803	24613	12233	4	0	\N
21153	1560	13688791131803	24922	12374	4	0	\N
21154	1560	13688804131803	24923	12373	8	0	\N
21156	1560	14274310277001	16282	8275	3	0	\N
21158	1560	14274322277001	16282	8275	4	0	\N
21162	1560	14408806131803	25020	12413	9	0	\N
21163	1560	14408806131803	25021	12413	7	0	\N
21164	1560	14408806131803	25143	12474	3	0	\N
21166	1560	14408806131803	25148	12477	3	0	\N
21167	1560	14408818131803	25143	12474	4	0	\N
21169	1560	14408818131803	25148	12477	4	0	\N
21170	1560	14408840131803	25021	12413	8	0	\N
21171	1560	14408851131803	25020	12413	10	0	\N
21172	1560	14994322277001	16377	8330	3	0	\N
21173	1560	14994322277001	16529	8407	3	0	\N
21174	1560	14994322277001	16615	8338	0	0	\N
21176	1560	14994322277001	16617	8353	0	0	\N
21177	1560	14994322277001	16618	8366	0	0	\N
21178	1560	14994322277001	16950	8380	0	0	\N
21179	1560	14994322277001	16952	8388	0	0	\N
21180	1560	14994334277001	16377	8330	4	0	\N
21181	1560	14994334277001	16529	8407	4	0	\N
21183	1560	14994344277001	16713	8492	1	0	\N
21184	1560	14994344277001	16715	8492	1	0	\N
21185	1560	14994344277001	16719	8492	1	0	\N
21191	1560	15714343277003	16713	8492	2	0	\N
21192	1560	15714344277001	16715	8492	4	0	\N
21193	1560	15714344277001	16719	8492	4	0	\N
21194	1560	15714346277001	16715	8492	5	0	\N
21195	1560	15714346277001	16719	8492	5	0	\N
21197	1560	15714436277001	18109	9128	16	0	\N
21200	1560	15848831131803	25488	12623	3	0	\N
21201	1560	15848831131803	25489	12623	1	0	\N
21202	1560	15848831131803	25757	12740	6	0	\N
21203	1560	15848831131803	25758	12741	3	0	\N
21204	1560	15848831131803	25822	12768	7	0	\N
21205	1560	15848831131803	26055	12876	0	0	\N
21206	1560	15848831131803	26057	12876	2	0	\N
21208	1560	15848832131803	25489	12623	2	0	\N
21209	1560	15848842131803	26057	12876	3	0	\N
21210	1560	15848843131803	25488	12623	4	0	\N
21211	1560	15848843131803	25758	12741	4	0	\N
21213	1560	15848855131803	25757	12740	7	0	\N
21214	1560	15848856131803	25822	12768	8	0	\N
21215	1560	16434357277001	17359	8794	3	0	\N
21216	1560	16434357277001	17361	8794	3	0	\N
21094	1560	10800240000000	4364	2263	2	0	0
21095	1560	10800260000000	4364	2263	3	0	0
21111	1560	11520260000000	4729	2445	2	0	0
21112	1560	11520280000000	4729	2445	3	0	0
21120	1560	12240280000000	4783	2472	2	0	0
21128	1560	12960300000000	4807	2488	1	0	0
21129	1560	12960310000000	4807	2488	2	0	0
21142	1560	13680310000000	5107	2651	1	0	0
21143	1560	13680320000000	5107	2651	2	0	0
21160	1560	14400320000000	5150	2670	2	0	0
21186	1560	15120340000000	5215	2711	3	0	0
21187	1560	15120460000000	5215	2711	4	0	0
21198	1560	15840460000000	5277	2742	2	0	0
21199	1560	15840480000000	5277	2742	3	0	0
21093	1560	10674249277001	14451	7376	4	0	15
21105	1560	11394249277001	15509	7892	2	0	15
21107	1560	11394260277001	15509	7892	3	0	15
21118	1560	12114260277001	15770	8021	5	0	15
21119	1560	12114274277001	15770	8021	6	0	15
21127	1560	12834286277001	15771	8022	4	0	15
21139	1560	13554286277001	16194	8231	6	0	15
21141	1560	13554310277001	16194	8231	7	0	15
21157	1560	14274310277001	16341	8309	3	0	15
21159	1560	14274322277001	16341	8309	4	0	15
21182	1560	14994334277001	16616	8441	4	0	15
21190	1560	15714334277001	16951	8592	5	0	15
21196	1560	15714357277001	16951	8592	6	0	15
21088	1560	10088695131803	23667	11787	2	0	30
21098	1560	10808706131803	23832	11862	7	0	30
21101	1560	10808731131803	23832	11862	8	0	30
21115	1560	11528731131803	23942	11914	6	0	30
21117	1560	11528755131803	23942	11914	7	0	30
21122	1560	12248755131803	23958	11920	3	0	30
21133	1560	12968767131803	24218	12053	3	0	30
21137	1560	12968779131803	24218	12053	4	0	30
21149	1560	13688779131803	25006	12405	7	0	30
21155	1560	13688806131803	25006	12405	8	0	30
21165	1560	14408806131803	25147	12477	3	0	30
21188	1560	15128818131803	25295	12549	4	0	30
21189	1560	15128831131803	25295	12549	5	0	30
21207	1560	15848831131803	26213	12960	3	0	30
21212	1560	15848843131803	26213	12960	4	0	30
21217	1560	16434357277001	17362	8794	3	0	\N
21218	1560	16434357277001	17682	8938	2	0	\N
21219	1560	16434357277001	18002	9082	3	0	\N
21220	1560	16434357277001	18004	9082	3	0	\N
21222	1560	16434368277001	17682	8938	3	0	\N
21223	1560	16434369277001	17359	8794	4	0	\N
21224	1560	16434369277001	17361	8794	4	0	\N
21225	1560	16434369277001	17362	8794	4	0	\N
21226	1560	16434369277001	18002	9082	4	0	\N
21227	1560	16434369277001	18004	9082	4	0	\N
21229	1560	16434436277001	18109	9128	17	0	\N
21231	1560	16568843131803	26608	13165	3	0	\N
21233	1560	16568843131803	26740	13227	3	0	\N
21234	1560	16568843131803	26742	13227	4	0	\N
21235	1560	16568855131803	26608	13165	4	0	\N
21236	1560	16568855131803	26740	13227	4	0	\N
21237	1560	16568856131803	26742	13227	5	0	\N
21238	1560	16569303131803	27871	13740	46	0	\N
21239	1560	17154378277001	18220	9178	2	0	\N
21241	1560	17154389277001	18220	9178	3	0	\N
21243	1560	17154436277001	18223	9129	60	0	\N
21244	1560	17154741277001	18876	9478	35	0	\N
21245	1560	17155036277001	18223	9129	61	0	\N
21248	1560	17288843131803	26869	13289	3	0	\N
21249	1560	17288843131803	27576	13629	3	0	\N
21250	1560	17288843131803	27870	13779	3	0	\N
21252	1560	17288855131803	26869	13289	4	0	\N
21253	1560	17288855131803	27576	13629	4	0	\N
21254	1560	17288855131803	27870	13779	4	0	\N
21256	1560	17289303131803	27871	13740	126	0	\N
21257	1560	17289454131803	27871	13740	127	0	\N
21258	1560	17289914131803	27977	13741	46	0	\N
21259	1560	17874391277001	18683	9413	2	0	\N
21260	1560	17874391277001	18684	9413	3	0	\N
21261	1560	17874391277001	18874	9518	1	0	\N
21263	1560	17874401277001	18874	9518	2	0	\N
21264	1560	17874402277001	18683	9413	3	0	\N
21266	1560	17874412277001	18684	9413	4	0	\N
21267	1560	17874741277001	18876	9478	72	0	\N
21268	1560	17874930277001	18876	9478	73	0	\N
21273	1560	18009914131803	27977	13741	126	0	\N
21274	1560	18010371131803	27977	13741	127	0	\N
21275	1560	18010606131803	28009	13742	46	0	\N
21278	1560	18594930277001	18920	9479	46	0	\N
21279	1560	18595291277001	18920	9479	47	0	\N
21280	1560	18720530000000	5890	3054	0	0	\N
21281	1560	18720530000000	5892	3054	5	0	\N
21282	1560	18720530000000	5965	3093	1	0	\N
21284	1560	18720540000000	5965	3093	2	0	\N
21286	1560	18720580000000	5892	3054	6	0	\N
21289	1560	18730606131803	28009	13742	85	0	\N
21290	1560	18730644131803	28009	13742	86	0	\N
21291	1560	19314426277001	19183	9678	4	0	\N
21294	1560	19314538277001	19183	9678	5	0	\N
21295	1560	19440540000000	6573	3403	4	0	\N
21298	1560	19440580000000	6573	3403	5	0	\N
21300	1560	19448880131803	29976	14761	9	0	\N
21301	1560	19448907131803	29976	14761	10	0	\N
21303	1560	20034451277001	19675	9910	18	0	\N
21304	1560	20034451277001	19763	9934	0	0	\N
21307	1560	20034595277001	19675	9910	19	0	\N
21308	1560	20160560000000	6691	3458	4	0	\N
21309	1560	20160560000000	7022	3621	6	0	\N
21312	1560	20160600000000	6691	3458	5	0	\N
21313	1560	20160620000000	7022	3621	7	0	\N
21314	1560	20168916131803	30100	14818	9	0	\N
21315	1560	20168916131803	30105	14818	5	0	\N
21316	1560	20168930131803	30105	14818	6	0	\N
21317	1560	20168934131803	30100	14818	10	0	\N
21318	1560	20754451277001	19880	9935	51	0	\N
21321	1560	20755006277001	19880	9935	52	0	\N
21322	1560	20755556277001	19964	9936	10	0	\N
21325	1560	21474475277001	19966	10054	4	0	\N
21328	1560	21474488277001	19966	10054	5	0	\N
21329	1560	21475556277001	19964	9936	11	0	\N
21330	1560	21529556277001	20047	9937	0	0	\N
21333	1560	22194487277001	20221	10182	10	0	\N
21336	1560	22194524277001	20221	10182	11	0	\N
21338	1560	22320610000000	7533	3898	3	0	\N
21339	1560	22320610000000	7534	3898	4	0	\N
21341	1560	22320631000000	7533	3898	4	0	\N
21342	1560	22320641000000	7534	3898	5	0	\N
21343	1560	23040620000000	7627	3945	2	0	\N
21344	1560	23040620000000	7628	3945	0	0	\N
21346	1560	23040640000000	7627	3945	3	0	\N
21352	1560	25200660000000	8238	4269	1	0	\N
21247	1560	17280500000000	5766	2991	3	0	0
21269	1560	18000500000000	5869	3041	3	0	0
21270	1560	18000530000000	5869	3041	4	0	0
21283	1560	18720530000000	5966	3094	1	0	0
21285	1560	18720540000000	5966	3094	2	0	0
21297	1560	19440560000000	6595	3412	3	0	0
21310	1560	20160560000000	7222	3733	1	0	0
21311	1560	20160570000000	7222	3733	2	0	0
21323	1560	20880570000000	7339	3793	1	0	0
21324	1560	20880580000000	7339	3793	2	0	0
21332	1560	21600610000000	7403	3825	4	0	0
21337	1560	22320610000000	7532	3899	1	0	0
21340	1560	22320620000000	7532	3899	2	0	0
21345	1560	23040620000000	7875	4081	2	0	0
21348	1560	23760640000000	7884	4085	1	0	0
21349	1560	23760650000000	7884	4085	2	0	0
21350	1560	24480650000000	8017	4155	1	0	0
21351	1560	24480660000000	8017	4155	2	0	0
21221	1560	16434357277001	18108	9134	3	0	15
21240	1560	17154378277001	18457	9302	4	0	15
21242	1560	17154391277001	18457	9302	5	0	15
21262	1560	17874391277001	18919	9544	2	0	15
21265	1560	17874402277001	18919	9544	3	0	15
21276	1560	18594402277001	19131	9649	6	0	15
21292	1560	19314426277001	19635	9891	7	0	15
21293	1560	19314451277001	19635	9891	8	0	15
21305	1560	20034451277001	19764	9951	3	0	15
21306	1560	20034463277001	19764	9951	4	0	15
21320	1560	20754475277001	19881	10015	4	0	15
21326	1560	21474475277001	20048	10092	3	0	15
21327	1560	21474487277001	20048	10092	4	0	15
21334	1560	22194487277001	20362	10257	6	0	15
21335	1560	22194514277001	20362	10257	7	0	15
21251	1560	17288843131803	27976	13837	3	0	30
21255	1560	17288855131803	27976	13837	4	0	30
21271	1560	18008855131803	28010	13851	3	0	30
21272	1560	18008867131803	28010	13851	4	0	30
21287	1560	18728867131803	28224	13954	3	0	30
21299	1560	19448880131803	29975	14761	18	0	30
21302	1560	19448916131803	29975	14761	19	0	30
21354	1560	25200670000000	8238	4269	2	0	\N
21369	1560	30960879000000	9546	4950	2	0	\N
21371	1560	30960899000000	9546	4950	3	0	\N
21373	1560	31680919000000	9550	4953	2	0	\N
21374	1560	31680919000000	9551	4953	1	0	\N
21375	1560	31680919000000	9643	5002	2	0	\N
21376	1560	31680919000000	10046	5211	2	0	\N
21377	1560	31680929000000	9551	4953	2	0	\N
21378	1560	31680939000000	9550	4953	3	0	\N
21379	1560	31680939000000	9643	5002	3	0	\N
21380	1560	31680939000000	10046	5211	3	0	\N
21384	1563	1440020000000	18695	9418	3	0	\N
21385	1563	1440032000000	18695	9418	4	0	\N
21386	1564	10000000	2255	1184	4	0	\N
21387	1564	700010040300	21737	10717	127	0	\N
21394	1564	1985133000000	9938	5159	2	0	\N
21396	1564	1985153000000	9938	5159	3	0	\N
21398	1564	2160020000000	1914	1020	2	0	\N
21399	1564	2160020000000	2255	1184	3	0	\N
21400	1564	2160020000000	3179	1651	2	0	\N
21401	1564	2160020000000	3480	1807	0	0	\N
21404	1564	2160040000000	1914	1020	3	0	\N
21405	1564	2160040000000	3179	1651	3	0	\N
21406	1564	2706173000000	10795	5572	5	0	\N
21409	1564	2706313000000	10795	5572	6	0	\N
21415	1564	4146234000000	11260	5785	24	0	\N
21416	1564	4146234000000	11367	5838	2	0	\N
21418	1564	4146245000000	11367	5838	3	0	\N
21420	1564	4146447000000	11260	5785	25	0	\N
21421	1564	4320042000000	4357	2258	1	0	\N
21423	1564	4320052000000	4357	2258	2	0	\N
21427	1564	4688583000000	21737	10717	62	0	\N
21430	1564	4747253000000	21618	10716	62	0	\N
21437	1564	5408583000000	21737	10717	126	0	\N
21438	1564	5467253000000	21618	10716	126	0	\N
21439	1564	5467883000000	21618	10716	127	0	\N
21442	1564	5760062000000	4748	2454	3	0	\N
21443	1564	5760062000000	4754	2457	1	0	\N
21444	1564	5760062000000	4845	2510	1	0	\N
21445	1564	5760062000000	4920	2545	1	0	\N
21446	1564	5760062000000	5110	2653	1	0	\N
21448	1564	5760072000000	4754	2457	2	0	\N
21449	1564	5760072000000	4845	2510	2	0	\N
21450	1564	5760072000000	4920	2545	2	0	\N
21451	1564	5760072000000	5110	2653	2	0	\N
21453	1564	5760092000000	4748	2454	4	0	\N
21456	1564	6306290000000	11889	6109	1	0	\N
21457	1564	6306290000000	12125	6245	1	0	\N
21458	1564	6306290000000	12438	6412	0	0	\N
21460	1564	6306291000000	11889	6109	2	0	\N
21461	1564	6306291000000	12125	6245	2	0	\N
21463	1564	6480072000000	5324	2765	1	0	\N
21465	1564	6480082000000	5324	2765	2	0	\N
21466	1564	6480082000000	5977	3102	1	0	\N
21469	1564	7026323000000	13011	6706	2	0	\N
21471	1564	7026334000000	13011	6706	3	0	\N
21473	1564	7200072000000	5647	2931	0	0	\N
21474	1564	7200072000000	5681	2945	1	0	\N
21475	1564	7200072000000	5694	2952	0	0	\N
21476	1564	7200072000000	5929	3071	2	0	\N
21478	1564	7200082000000	5681	2945	2	0	\N
21479	1564	7200082000000	5977	3102	2	0	\N
21481	1564	7200092000000	5929	3071	3	0	\N
21484	1564	7746353000000	13568	6951	40	0	\N
21487	1564	7746735000000	13568	6951	41	0	\N
21488	1564	7747237000000	13694	6952	41	0	\N
21392	1564	1440010000000	965	538	1	0	0
21393	1564	1440020000000	965	538	2	0	0
21402	1564	2160020000000	3635	1885	3	0	0
21403	1564	2160032000000	3635	1885	4	0	0
21410	1564	2880032000000	3664	1902	0	0	0
21414	1564	3600042000000	4071	2116	2	0	0
21422	1564	4320042000000	4541	2349	1	0	0
21424	1564	4320052000000	4541	2349	2	0	0
21433	1564	5040052000000	4686	2422	1	0	0
21434	1564	5040062000000	4686	2422	2	0	0
21452	1564	5760072000000	5274	2740	2	0	0
21381	1562	720000000000	5586	2905	0	0	0
21464	1564	6480072000000	5615	2917	0	0	0
21382	1563	720000000000	5995	3110	2	0	0
21477	1564	7200072000000	6034	3131	1	0	0
21480	1564	7200082000000	6034	3131	2	0	0
21353	1560	25200660000000	8241	4269	0	0	0
21355	1560	25920660000000	8705	4513	1	0	0
21356	1560	25920670000000	8705	4513	2	0	0
21358	1560	26640740000000	8724	4524	8	0	0
21359	1560	27360740000000	8776	4552	2	0	0
21360	1560	27360760000000	8776	4552	3	0	0
21361	1560	28080760000000	8779	4554	2	0	0
21362	1560	28080780000000	8779	4554	3	0	0
21364	1560	28800840000000	8842	4583	7	0	0
21365	1560	29520839000000	9175	4756	2	0	1
21366	1560	29520859000000	9175	4756	3	0	1
21367	1560	30240859000000	9371	4862	2	0	1
21370	1560	30960879000000	9547	4951	4	0	1
21372	1560	30960919000000	9547	4951	5	0	1
21390	1564	1265112000000	9918	5146	3	0	5
21391	1564	1265133000000	9918	5146	4	0	5
21395	1564	1985133000000	10376	5364	5	0	5
21407	1564	2706173000000	10893	5617	2	0	5
21408	1564	2706193000000	10893	5617	3	0	5
21411	1564	3426193000000	11227	5770	5	0	5
21412	1564	3426234000000	11227	5770	6	0	5
21417	1564	4146234000000	11476	5898	2	0	5
21431	1564	4866245000000	11540	5928	7	0	5
21432	1564	4866288000000	11540	5928	8	0	5
21440	1564	5586288000000	11761	6046	2	0	5
21441	1564	5586290000000	11761	6046	3	0	5
21462	1564	6306323000000	12604	6500	7	0	5
21470	1564	7026323000000	13190	6797	3	0	5
21472	1564	7026353000000	13190	6797	4	0	5
21485	1564	7746353000000	14704	7487	2	0	5
21486	1564	7746364000000	14704	7487	3	0	5
21429	1564	4746573000000	21150	10621	7	0	9
21425	1564	4686553000000	23262	11607	2	0	10
21426	1564	4686564000000	23262	11607	3	0	10
21435	1564	5406564000000	23362	11658	2	0	10
21436	1564	5406575000000	23362	11658	3	0	10
21455	1564	6126597000000	23800	11846	5	0	10
21467	1564	6846597000000	24078	11986	6	0	10
21468	1564	6846630000000	24078	11986	7	0	10
21482	1564	7566630000000	24090	11991	2	0	10
21495	1564	8466387000000	16024	8148	2	0	\N
21496	1564	8467237000000	13694	6952	89	0	\N
21497	1564	8467707000000	13694	6952	90	0	\N
21503	1564	9186387000000	16024	8148	5	0	\N
21504	1564	9186389000000	16024	8148	6	0	\N
21506	1564	9360162000000	6893	3561	4	0	\N
21509	1564	9360202000000	6893	3561	5	0	\N
21510	1564	9726664000000	24747	12288	8	0	\N
21513	1564	9726717000000	24747	12288	9	0	\N
21516	1564	9906473000000	16687	8383	3	0	\N
21517	1564	10080182000000	7488	3873	2	0	\N
21519	1564	10080202000000	7488	3873	3	0	\N
21525	1564	10626473000000	16687	8383	126	0	\N
21526	1564	10627743000000	16687	8383	127	0	\N
21527	1564	10627773000000	16756	8384	3	0	\N
21530	1564	11166689000000	25198	12500	3	0	\N
21532	1564	11166701000000	25198	12500	4	0	\N
21534	1564	11346435000000	17153	8696	10	0	\N
21536	1564	11346472000000	17153	8696	11	0	\N
21538	1564	11347773000000	16756	8384	126	0	\N
21539	1564	11348552000000	16756	8384	127	0	\N
21540	1564	11348582000000	16767	8385	3	0	\N
21543	1564	11886713000000	25887	12795	4	0	\N
21544	1564	11886713000000	25995	12847	4	0	\N
21546	1564	11886735000000	25887	12795	5	0	\N
21547	1564	11886735000000	25995	12847	5	0	\N
21549	1564	12066523000000	18142	9148	5	0	\N
21550	1564	12066523000000	18178	9167	2	0	\N
21551	1564	12066523000000	18203	9173	6	0	\N
21553	1564	12066534000000	18178	9167	3	0	\N
21555	1564	12066541000000	18203	9173	7	0	\N
21556	1564	12066546000000	18142	9148	6	0	\N
21557	1564	12068582000000	16767	8385	64	0	\N
21558	1564	12068651000000	16767	8385	65	0	\N
21563	1564	12606859000000	26979	13340	3	0	\N
21569	1564	13326859000000	26979	13340	4	0	\N
21571	1564	13327101000000	28036	13638	23	0	\N
21572	1564	13506545000000	19163	9667	3	0	\N
21574	1564	13506557000000	19163	9667	4	0	\N
21580	1564	14047101000000	28036	13638	126	0	\N
21581	1564	14048121000000	28036	13638	127	0	\N
21582	1564	14048351000000	28073	13639	23	0	\N
21585	1564	14400272000000	9229	4783	3	0	\N
21586	1564	14400272000000	9279	4812	2	0	\N
21587	1564	14400272000000	9670	5019	2	0	\N
21588	1564	14400272000000	9734	5043	13	0	\N
21589	1564	14400292000000	9279	4812	3	0	\N
21590	1564	14400292000000	9670	5019	3	0	\N
21591	1564	14400302000000	9229	4783	4	0	\N
21592	1564	14400393000000	9734	5043	14	0	\N
21595	1564	14768351000000	28073	13639	126	0	\N
21596	1564	14769371000000	28073	13639	127	0	\N
21601	1564	15666584000000	19693	9915	8	0	\N
21602	1564	15666584000000	20059	10098	3	0	\N
21604	1564	15666596000000	20059	10098	4	0	\N
21606	1564	15666646000000	19693	9915	9	0	\N
21607	1564	16207179000000	29522	14559	2	0	\N
21608	1564	16207179000000	29546	14568	7	0	\N
21609	1564	16207179000000	30256	14876	18	0	\N
21610	1564	16207181000000	29522	14559	3	0	\N
21611	1564	16207204000000	29546	14568	8	0	\N
21612	1564	16207214504653	30256	14876	20	0	\N
21615	1564	17106609000000	20742	10427	7	0	\N
21618	1564	17106652000000	20742	10427	8	0	\N
21489	1564	7920082000000	6037	3134	2	0	0
21490	1564	7920102000000	6037	3134	3	0	0
21498	1564	8640102000000	6638	3430	6	0	0
21499	1564	8640162000000	6638	3430	7	0	0
21619	1565	720000000000	6692	3458	4	0	0
21507	1564	9360162000000	7173	3705	2	0	0
21508	1564	9360182000000	7173	3705	3	0	0
21518	1564	10080182000000	7745	4015	3	0	0
21520	1564	10080212000000	7745	4015	4	0	0
21528	1564	10800212000000	7825	4057	1	0	0
21541	1564	11520222000000	8070	4183	2	0	0
21542	1564	11520242000000	8070	4183	3	0	0
21559	1564	12240242000000	8272	4284	1	0	0
21560	1564	12240252000000	8272	4284	2	0	0
21567	1564	12960262000000	8585	4451	2	0	0
21576	1564	13680262000000	8586	4452	1	0	0
21577	1564	13680272000000	8586	4452	2	0	0
21493	1564	8466364000000	15735	8002	3	0	5
21494	1564	8466376000000	15735	8002	4	0	5
21505	1564	9186401000000	16105	8186	8	0	5
21514	1564	9906401000000	16400	8342	3	0	5
21515	1564	9906413000000	16400	8342	4	0	5
21523	1564	10626413000000	17081	8653	4	0	5
21524	1564	10626435000000	17081	8653	5	0	5
21537	1564	11346523000000	17689	8941	17	0	5
21552	1564	12066523000000	18744	9445	3	0	5
21554	1564	12066535000000	18744	9445	4	0	5
21564	1564	12786535000000	18884	9524	1	0	5
21573	1564	13506545000000	19272	9716	4	0	5
21575	1564	13506558000000	19272	9716	5	0	5
21583	1564	14226558000000	19464	9811	4	0	5
21584	1564	14226571000000	19464	9811	5	0	5
21597	1564	14946571000000	19472	9816	4	0	5
21603	1564	15666584000000	20302	10223	3	0	5
21605	1564	15666596000000	20302	10223	4	0	5
21613	1564	16386596000000	20711	10415	4	0	5
21614	1564	16386609000000	20711	10415	5	0	5
21616	1564	17106609000000	20892	10501	2	0	5
21491	1564	8286641000000	24198	12045	3	0	10
21492	1564	8286653000000	24198	12045	4	0	10
21500	1564	9006653000000	24395	12130	2	0	10
21501	1564	9006664000000	24395	12130	3	0	10
21512	1564	9726677000000	24873	12350	5	0	10
21521	1564	10446677000000	24964	12388	3	0	10
21522	1564	10446689000000	24964	12388	4	0	10
21531	1564	11166689000000	25555	12653	6	0	10
21533	1564	11166713000000	25555	12653	7	0	10
21548	1564	11886836000000	26064	12881	16	0	10
21561	1564	12606836000000	26141	12922	2	0	10
21562	1564	12606847000000	26141	12922	3	0	10
21621	1565	1440040000000	26528	13124	3	0	0
21622	1565	1440052000000	26528	13124	4	0	0
21570	1564	13326871000000	27100	13398	7	0	10
21578	1564	14046871000000	29115	14354	8	0	10
21579	1564	14046906000000	29115	14354	9	0	10
21593	1564	14766906000000	29255	14418	2	0	10
21599	1564	15486917000000	29452	14523	4	0	10
21600	1564	15487179000000	29452	14523	5	0	10
21628	1567	10000042	10179	5275	6	0	\N
21629	1567	130000000101	21872	10801	0	0	\N
21630	1567	130000000101	22051	11026	0	0	\N
21631	1567	713000000101	10991	5663	4	0	\N
21632	1567	720000000101	5609	2915	0	0	\N
21633	1567	720000000101	7220	3733	1	0	\N
21634	1567	720000000101	16172	8220	4	0	\N
21635	1567	720010000101	7220	3733	2	0	\N
21636	1567	720013000101	16172	8220	5	0	\N
21637	1567	14404851899898	4874	2326	112	1	\N
21638	1567	18724117057977	9723	4882	44	0	\N
21641	1568	175000	26127	12917	2	0	\N
21643	1568	250000	29563	14576	2	0	\N
21645	1568	250000	29784	14678	15	0	\N
21646	1568	350000	29798	14683	10	1	\N
21648	1568	475000	29876	14690	122	1	\N
21652	1568	650000	29848	14710	39	1	\N
21654	1568	875000	29879	14725	12	1	\N
21656	1568	925000	29930	14727	97	1	\N
21658	1568	975000	29905	14734	10	1	\N
21659	1568	1000000	29920	14733	79	1	\N
21660	1568	1025000	30001	14734	54	0	\N
21661	1568	1100000	29938	14742	56	1	\N
21663	1568	1150000	29933	14744	16	1	\N
21664	1568	1225000	29986	14751	123	1	\N
21665	1568	1225000	30001	14734	122	1	\N
21667	1568	1275000	29957	14754	12	0	\N
21670	1568	1450000	29999	14771	21	1	\N
21672	1568	1475000	30223	14735	50	1	\N
21673	1568	1500000	30099	14773	124	1	\N
21674	1568	1550000	30223	14735	99	0	\N
21677	1568	1750000	30051	14795	18	1	\N
21680	1568	1775000	30064	14801	11	0	\N
21682	1568	1900000	30081	14811	11	1	\N
21683	1568	1900000	30082	14811	11	1	\N
21684	1568	1900000	30083	14811	11	1	\N
21685	1568	1900000	30084	14811	9	1	\N
21686	1568	1925000	30267	14812	125	0	\N
21688	1568	2000000	30126	14825	20	1	\N
21689	1568	2025000	30163	14842	41	1	\N
21690	1568	2025000	30164	14842	41	0	\N
21692	1568	2025000	30166	14842	41	0	\N
21693	1568	2025000	30207	14832	122	1	\N
21694	1568	2075000	30167	14843	10	1	\N
21695	1568	2075000	30168	14843	9	1	\N
21697	1568	2100000	30188	14851	22	1	\N
21699	1568	2125000	30191	14852	11	0	\N
21701	1568	2200000	30210	14858	35	1	\N
21702	1568	2200000	30211	14858	34	1	\N
21703	1568	2200000	30213	14858	35	1	\N
21705	1568	2275000	30215	14859	11	1	\N
21706	1568	2275000	30216	14859	11	1	\N
21707	1568	2275000	30217	14859	11	1	\N
21708	1568	2275000	30218	14859	12	1	\N
21709	1568	2275000	30219	14859	11	1	\N
21712	1568	2425000	30255	14876	19	1	\N
21713	1568	2425000	30256	14876	19	1	\N
21718	1568	2650000	30317	14900	5	1	\N
21719	1568	2650000	30318	14900	5	1	\N
21720	1568	100000027	27041	13249	42	0	\N
21721	1568	200263992	21532	10801	4	0	\N
21722	1568	720000000000	3112	1615	2	0	\N
21723	1568	720020000000	3112	1615	3	0	\N
21724	1568	898700000001	5837	3029	6	1	\N
21725	1568	1434965950000	20559	10228	63	0	\N
21726	1568	2880627700023	26127	12917	3	0	\N
21727	1568	7583944194587	21871	10800	11	1	\N
21728	1568	11183116015000	26129	12917	3	0	\N
21729	1568	13681174900000	5656	2814	14	0	\N
21730	1568	14399300900000	4910	2541	4	1	\N
21731	1568	18000159900000	6702	3402	127	0	\N
21732	1568	66000000001360	26392	12900	117	1	\N
21733	1568	66000000001420	26174	12940	15	1	\N
21734	1569	100000017	22933	11460	5	1	\N
21735	1569	720000000000	712	332	5	0	\N
21736	1569	720000000000	713	334	3	0	\N
21739	1569	720510000000	713	334	4	0	\N
21740	1569	720710000000	712	332	6	0	\N
21741	1569	720834000000	15627	7926	0	0	\N
21743	1569	720844999999	22931	11460	1	0	\N
21744	1569	720844999999	22932	11460	0	0	\N
21745	1569	720845000000	22928	11402	20	0	\N
21746	1569	720845000000	22929	11447	63	0	\N
21748	1569	720845000000	22933	11460	3	0	\N
21750	1569	720847999991	29313	14433	0	0	\N
21751	1569	720847999991	29314	14432	0	0	\N
21752	1569	720847999991	29315	14446	3	0	\N
21754	1569	720853999997	22931	11460	3	0	\N
21755	1569	720859999991	29315	14446	4	0	\N
21756	1569	720892000000	22928	11402	21	0	\N
21757	1569	721061000000	22929	11447	64	0	\N
21758	1569	721810000000	13366	6781	13	0	\N
21627	1567	101	4553	2356	16	0	0
21639	1568	100000	5253	2726	3	1	0
21759	1569	721810000000	13368	6888	7	0	1
21760	1569	721835000000	13368	6888	8	0	1
21742	1569	720834000000	15628	7956	3	0	2
21640	1568	150000	21590	10824	9	0	0
21747	1569	720845000000	22930	11460	3	0	3
21753	1569	720848999991	22930	11460	5	1	3
21625	1566	1440010000000	22978	11478	2	0	0
21626	1566	1440021000000	22978	11478	3	0	0
21644	1568	250000	29782	14678	14	1	0
21647	1568	350000	29799	14683	9	1	0
21649	1568	550000	29818	14692	11	1	0
21650	1568	625000	29837	14703	9	1	0
21653	1568	700000	29859	14717	13	0	0
21655	1568	875000	29880	14725	12	1	0
21657	1568	975000	29904	14734	10	1	0
21662	1568	1150000	29932	14744	16	1	0
21666	1568	1275000	29956	14754	12	0	0
21669	1568	1450000	29998	14771	21	1	0
21671	1568	1475000	30000	14772	11	0	0
21675	1568	1650000	30012	14779	10	1	0
21676	1568	1675000	30033	14787	20	1	0
21678	1568	1750000	30052	14795	18	1	0
21681	1568	1900000	30080	14811	11	1	0
21687	1568	2000000	30125	14825	20	1	0
21691	1568	2025000	30165	14842	41	0	0
21696	1568	2075000	30169	14843	10	1	0
21700	1568	2125000	30192	14852	11	0	0
21704	1568	2200000	30214	14858	35	1	0
21710	1568	2275000	30220	14859	11	1	0
21711	1568	2300000	30254	14875	11	0	0
21714	1568	2425000	30257	14876	19	1	0
21716	1568	2550000	30276	14887	34	0	0
21717	1568	2600000	30277	14888	12	1	0
21761	1569	721895000000	13366	6781	14	0	\N
21763	1571	10100002	12781	6589	10	1	\N
21764	1571	200000001	14213	7239	17	1	\N
21765	1571	200000004	18185	9170	7	1	\N
21766	1571	261999988	13466	6753	78	1	\N
21767	1571	274999975	21532	10801	6	1	\N
21768	1571	277999972	20966	10546	5	1	\N
21769	1571	720000000000	124	73	3	0	\N
21771	1571	720030000000	124	73	4	0	\N
21772	1571	1151617151064	20162	10084	127	0	\N
21775	1571	1441822045788	21515	10527	127	1	\N
21776	1571	1869432914692	20329	10185	127	1	\N
21779	1571	1872029151056	20356	10252	1	0	\N
21782	1571	2380465313992	20185	9927	127	0	\N
21784	1571	2592029151056	20356	10252	4	0	\N
21785	1571	2592031151056	20356	10252	5	0	\N
21789	1571	2880095999992	20969	10546	3	1	\N
21790	1571	3312031151056	20568	10351	8	0	\N
21791	1571	3312031151056	20603	10364	2	0	\N
21792	1571	3312031151056	20663	10395	2	0	\N
21793	1571	3312031151056	20922	10517	2	0	\N
21795	1571	3312042151056	20603	10364	3	0	\N
21796	1571	3312042151056	20663	10395	3	0	\N
21797	1571	3312042151056	20922	10517	3	0	\N
21799	1571	3312066151056	20568	10351	9	0	\N
21804	1571	4032094151064	21547	10710	0	0	\N
21807	1571	4354535999991	23916	11755	100	1	\N
21808	1571	4607734601052	19795	9969	3	0	\N
21809	1571	4607746601052	19795	9969	4	0	\N
21810	1571	4752094151056	21314	10699	4	0	\N
21811	1571	4752094151056	21469	10770	3	0	\N
21812	1571	4752094151056	21487	10776	3	0	\N
21815	1571	4752105151072	21870	10799	127	0	\N
21817	1571	4752105151512	21690	10865	14	0	\N
21818	1571	4752106151056	21469	10770	4	0	\N
21819	1571	4752106151056	21487	10776	4	0	\N
21820	1571	4752116151056	21314	10699	5	0	\N
21821	1571	4940555124162	23757	11774	127	0	\N
21822	1571	5032539524788	13489	6947	3	1	\N
21823	1571	5039178500095	21905	10896	127	1	\N
21826	1571	5360846387203	28377	13824	25	0	\N
21827	1571	5360846387203	28569	13882	26	1	\N
21828	1571	5360846387219	28665	13945	71	0	\N
21829	1571	5360846387379	28639	13934	87	1	\N
21830	1571	5472105151480	21698	10869	3	0	\N
21831	1571	5472105151480	21889	10954	3	0	\N
21833	1571	5472117151480	21698	10869	4	0	\N
21834	1571	5472117151480	21889	10954	4	0	\N
21836	1571	5660555124154	23681	11792	8	0	\N
21839	1571	5660581124154	23681	11792	9	0	\N
21840	1571	5759845500087	21999	10897	127	1	\N
21841	1571	5760070000000	2460	1288	1	0	\N
21842	1571	5760070000000	2482	1301	2	0	\N
21843	1571	5760070000000	2495	1306	2	0	\N
21845	1571	5760080000000	2460	1288	2	0	\N
21846	1571	5760090000000	2482	1301	3	0	\N
21847	1571	5760090000000	2495	1306	3	0	\N
21849	1571	6072598998459	12013	6072	121	1	\N
21850	1571	6080846387195	27894	13792	3	0	\N
21853	1571	6080857387203	28823	14162	15	0	\N
21854	1571	6080858387195	27894	13792	4	0	\N
21862	1571	6480100000008	3350	1532	80	0	\N
21863	1571	6480100000008	3356	1648	49	0	\N
21864	1571	6480100000016	3443	1533	0	0	\N
21865	1571	6480100000016	3477	1649	0	0	\N
21868	1571	6800869387203	29684	14641	19	1	\N
21869	1571	6800869387267	29758	14666	28	0	\N
21870	1571	6800869387267	29813	14666	127	0	\N
21873	1571	6800869387307	29800	14667	104	0	\N
21874	1571	6800869387331	29783	14666	78	0	\N
21875	1571	6800869387355	29756	14666	23	1	\N
21877	1571	6800869387443	29771	14673	19	1	\N
21879	1571	6800869387451	29773	14674	32	1	\N
21880	1571	6800869387451	29774	14674	32	1	\N
21882	1571	6800869387587	29784	14678	19	0	\N
21885	1571	6800869387715	29876	14690	127	1	\N
21888	1571	6800869387851	29848	14710	43	1	\N
21890	1571	6800869388043	29879	14725	16	1	\N
21892	1571	6800869388075	29930	14727	101	1	\N
21893	1571	6800869388123	29920	14733	83	1	\N
21895	1571	6800869388131	29905	14734	14	1	\N
21896	1571	6800869388187	29938	14742	60	1	\N
21773	1571	1440000000000	271	158	1	0	1
21774	1571	1440010000000	271	158	2	0	1
21780	1571	2160010000000	403	229	2	0	1
21781	1571	2160030000000	403	229	3	0	1
21787	1571	2880030000000	493	274	1	0	1
21800	1571	3600040000000	1029	570	1	0	1
21801	1571	3600050000000	1029	570	2	0	1
21805	1571	4320050000000	1484	810	1	0	1
21806	1571	4320060000000	1484	810	2	0	1
21824	1571	5040060000000	1875	998	1	0	1
21844	1571	5760070000000	2630	1384	2	0	1
21848	1571	5760090000000	2630	1384	3	0	1
21859	1571	6480090000000	2811	1470	1	0	1
21860	1571	6480100000000	2811	1470	2	0	1
21778	1571	1872019151056	20089	10113	14	0	41
21783	1571	2592019151056	20471	10309	3	0	41
21786	1571	2592031151056	20471	10309	4	0	41
21794	1571	3312031151056	20963	10544	2	0	41
21798	1571	3312042151056	20963	10544	3	0	41
21803	1571	4032094151056	21014	10566	8	0	41
21813	1571	4752094151056	21504	10786	2	0	41
21814	1571	4752105151056	21504	10786	3	0	41
21816	1571	4752105151480	21590	10824	11	0	41
21832	1571	5472105151480	22299	11162	14	0	41
21855	1571	6192155151480	22830	11417	4	0	41
21856	1571	6192168151480	22830	11417	5	0	41
21837	1571	5660555124154	23711	11809	6	0	47
21838	1571	5660579124154	23711	11809	7	0	47
21858	1571	6380604124154	23726	11816	8	0	47
21851	1571	6080846387195	28368	14025	2	0	59
21852	1571	6080857387195	28368	14025	3	0	59
21866	1571	6800857387195	28811	14211	3	0	59
21867	1571	6800869387195	28811	14211	4	0	59
21872	1571	6800869387307	29759	14667	25	0	59
21876	1571	6800869387443	29770	14673	31	0	59
21878	1571	6800869387451	29772	14674	32	1	59
21881	1571	6800869387587	29782	14678	19	0	59
21883	1571	6800869387611	29797	14682	66	0	59
21886	1571	6800869387755	29837	14703	14	1	59
21887	1571	6800869387843	29847	14710	48	1	59
21889	1571	6800869387963	29859	14717	17	1	59
21891	1571	6800869388043	29880	14725	16	1	59
21898	1571	6800869388195	29933	14744	20	1	\N
21899	1571	6800869388243	29986	14751	127	0	\N
21901	1571	6800869388251	29957	14754	16	0	\N
21904	1571	7100604124154	23943	11915	3	0	\N
21906	1571	7100616124154	23943	11915	4	0	\N
21908	1571	7197600999992	3489	1701	86	1	\N
21909	1571	7200100000008	3340	1735	1	0	\N
21911	1571	7200110000008	3340	1735	2	0	\N
21913	1571	7293998908532	11634	5907	114	1	\N
21914	1571	7520869387195	29009	14305	4	0	\N
21916	1571	7520882387195	29009	14305	5	0	\N
21920	1571	7520895388379	29999	14771	25	1	\N
21922	1571	7520895388435	30084	14811	13	0	\N
21924	1571	7520895388443	30081	14811	15	0	\N
21925	1571	7520895388443	30082	14811	15	0	\N
21926	1571	7520895388443	30083	14811	15	0	\N
21928	1571	7520895388459	30268	14882	23	1	\N
21931	1571	7520895388475	30317	14900	8	0	\N
21932	1571	7520895388475	30318	14900	8	0	\N
21936	1571	7820616124154	24543	12060	0	0	\N
21937	1571	7820616124154	24545	12080	0	0	\N
21938	1571	7820616124154	24546	12090	0	0	\N
21939	1571	7820616124154	24912	12369	3	0	\N
21941	1571	7820628124154	24912	12369	4	0	\N
21943	1571	7919195974016	26174	12940	16	1	\N
21944	1571	7920111000008	3710	1927	2	0	\N
21947	1571	7920131000008	3710	1927	3	0	\N
21948	1571	8304154194579	21871	10800	35	1	\N
21949	1571	8352193151808	23204	11584	4	0	\N
21952	1571	8352215151808	23204	11584	5	0	\N
21955	1571	8635412999222	23248	11601	4	1	\N
21958	1571	8640363967164	26970	13247	127	1	\N
21962	1571	9260664124170	26392	12900	116	0	\N
21963	1571	9260664124170	26436	13078	6	0	\N
21965	1571	9312447851147	13170	6752	127	1	\N
21968	1571	9831536999960	24638	12241	6	1	\N
21969	1571	9980664124162	26429	13075	4	0	\N
21971	1571	9980677124162	26429	13075	5	0	\N
21974	1571	9980688124178	27284	13408	127	0	\N
21975	1571	9980688124186	27423	13436	45	0	\N
21980	1571	10800151000008	5104	2650	1	0	\N
21982	1571	10800161000008	5104	2650	2	0	\N
21985	1571	11475991999984	24144	11787	105	1	\N
21986	1571	11520151000008	5508	2866	0	0	\N
21990	1571	12196021999960	24144	11787	110	1	\N
21991	1571	12240151000008	5732	2970	0	0	\N
21994	1571	12240161000016	8688	4421	14	0	\N
21995	1571	12240161000016	8731	4528	2	0	\N
21997	1571	12240161000024	8725	4422	0	0	\N
21998	1571	12240161000696	8785	4556	4	0	\N
22000	1571	12240161001000	8786	4556	4	0	\N
22001	1571	12242181000008	6339	3048	58	0	\N
22002	1571	12327866329975	26436	13078	7	1	\N
22003	1571	12816795318124	26392	12900	119	1	\N
22006	1571	12960161000008	5873	3045	2	0	\N
21996	1571	12240161000016	8784	4556	2	0	1
21961	1571	9260664124162	25308	12557	4	0	47
22008	1571	12960181000008	5873	3045	3	0	\N
22010	1571	12962181000008	6339	3048	126	0	\N
22011	1571	12962851000008	6339	3048	127	0	\N
22012	1571	12963431000008	6346	3049	58	0	\N
22015	1571	13683431000008	6346	3049	126	0	\N
22016	1571	13684101000008	6346	3049	127	0	\N
22017	1571	13684861000008	6422	3050	58	0	\N
22018	1571	13927153540441	25643	12633	124	1	\N
22021	1571	14400241001120	10278	5319	10	0	\N
22022	1571	14400241001120	10279	5319	11	0	\N
22023	1571	14404861000008	6422	3050	90	0	\N
22026	1571	15121853999873	25313	12558	7	1	\N
22029	1571	15840301001008	13370	6791	10	0	\N
22030	1571	15840301001016	11894	5909	95	0	\N
22031	1571	15840301001024	11796	5819	127	0	\N
22032	1571	15840301001024	11951	5910	18	0	\N
21945	1571	7920111000008	4229	2197	1	0	1
21946	1571	7920121000008	4229	2197	2	0	1
21956	1571	8640121000008	4361	2261	1	0	1
21957	1571	8640131000008	4361	2261	2	0	1
21966	1571	9360131000008	4814	2493	1	0	1
21976	1571	10080141000008	4991	2587	1	0	1
21977	1571	10080151000008	4991	2587	2	0	1
21981	1571	10800151000008	5476	2851	0	0	1
21987	1571	11520151000008	5625	2921	0	0	1
21992	1571	12240151000008	5849	3034	1	0	1
21999	1571	12240161001000	8784	4556	4	1	1
22007	1571	12960161001000	9906	5137	2	0	1
22009	1571	12960181001000	9906	5137	3	0	1
22013	1571	13680181001000	9911	5141	4	0	1
22019	1571	14400221001000	9914	5143	2	0	1
22020	1571	14400241001000	9914	5143	3	0	1
22024	1571	15120241001000	10381	5367	4	0	1
22025	1571	15120281001000	10381	5367	5	0	1
22027	1571	15840281001000	10764	5556	2	0	1
21902	1571	6912168151480	22899	11446	3	0	41
21903	1571	6912180151480	22899	11446	4	0	41
21933	1571	7632180151480	22926	11458	4	0	41
21934	1571	7632193151480	22926	11458	5	0	41
21935	1571	7632193151808	23180	11574	10	0	41
21951	1571	8352206151808	23465	11700	5	0	41
21905	1571	7100604124154	24017	11951	3	0	47
21907	1571	7100616124154	24017	11951	4	0	47
21940	1571	7820616124154	25002	12404	3	0	47
21953	1571	8540628124154	25112	12461	3	0	47
21954	1571	8540640124154	25112	12461	4	0	47
21959	1571	9260640124154	25116	12464	6	0	47
21960	1571	9260664124154	25116	12464	7	0	47
21964	1571	9260674124162	27066	13382	1	0	47
21972	1571	9980688124162	27066	13382	8	0	47
21973	1571	9980688124178	27149	13424	8	0	47
21978	1571	10700688124178	27203	13455	7	0	47
21979	1571	10700713124178	27203	13455	8	0	47
21983	1571	11420713124178	27281	13484	9	0	47
21988	1571	12140749124178	27332	13510	3	0	47
21989	1571	12140761124178	27332	13510	4	0	47
22004	1571	12860761124178	27504	13596	3	0	47
22005	1571	12860773124178	27504	13596	4	0	47
21900	1571	6800869388251	29956	14754	16	0	59
21915	1571	7520869388251	29965	14758	17	0	59
21917	1571	7520895388251	29965	14758	18	0	59
21918	1571	7520895388323	29979	14763	25	1	59
21919	1571	7520895388379	29998	14771	25	1	59
21923	1571	7520895388443	30080	14811	15	0	59
21927	1571	7520895388451	30266	14881	38	1	59
21929	1571	7520895388459	30269	14882	14	1	59
21930	1571	7520895388467	30276	14887	38	1	59
22034	1571	15840301001032	13489	6947	2	0	\N
22035	1571	16558697999992	26586	13153	9	1	\N
22036	1571	16560301001000	10950	5636	19	0	\N
22037	1571	16560301001024	13718	7051	4	0	\N
22039	1571	16560314001024	13718	7051	5	0	\N
22041	1571	16560491001000	10950	5636	20	0	\N
22042	1571	16563261001000	11525	5637	98	0	\N
22045	1571	17283261001000	11525	5637	126	0	\N
22046	1571	17283531001000	11525	5637	127	0	\N
22051	1571	18285571999790	18284	9187	81	1	\N
22054	1571	19339318999728	22592	11271	18	1	\N
22055	1571	19440355001024	16531	8408	7	0	\N
22057	1571	19440380001024	16531	8408	8	0	\N
22059	1571	20160427001024	16703	8487	3	0	\N
22061	1571	20160439001024	16703	8487	4	0	\N
22063	1571	20880462001024	16966	8598	6	0	\N
22064	1571	20880462001024	17116	8643	0	0	\N
22065	1571	20880462001024	17538	8852	3	0	\N
22067	1571	20880465001024	17538	8852	4	0	\N
22069	1571	20880486001032	18187	9170	7	0	\N
22070	1571	20880486001032	18193	9170	7	0	\N
22071	1571	20880486001032	18249	9193	2	0	\N
22072	1571	20880486001040	18249	9193	4	0	\N
22073	1571	20880486001200	18192	9170	9	0	\N
22074	1571	20880495001024	16966	8598	7	0	\N
22075	1571	21600462001024	17166	8644	126	0	\N
22076	1571	21600465001024	17582	8853	0	0	\N
22079	1571	21601326001024	17166	8644	127	0	\N
22080	1571	22320465001024	17688	8854	8	0	\N
22081	1571	22320499001024	18638	9393	4	0	\N
22082	1571	22320499001024	19130	9591	53	0	\N
22085	1571	22320536001024	17688	8854	9	0	\N
22086	1571	22320608001024	17866	8855	36	0	\N
22087	1571	22320642001024	19130	9591	54	0	\N
22088	1571	22320710001024	18638	9393	5	0	\N
22089	1571	23039608001000	17866	8855	37	0	\N
22090	1571	50403662899882	14745	7253	102	1	\N
22091	1571	66000000100000	12838	6620	3	1	\N
22092	1571	66000010000000	6422	3050	91	1	\N
22101	1573	2138807000000	12078	6219	1	0	\N
22102	1573	2138807000000	12429	6408	0	0	\N
22103	1573	2138807000000	12982	6693	2	0	\N
22105	1573	2138808000000	12078	6219	2	0	\N
22106	1573	2138818000000	12982	6693	3	0	\N
22108	1573	2160040000000	539	305	2	0	\N
22111	1573	2160051000000	539	305	3	0	\N
22114	1573	2858818000000	13229	6816	6	0	\N
22116	1573	2858842000000	13229	6816	7	0	\N
22122	1573	3459327000000	22641	11322	3	0	\N
22127	1573	4179315000000	22429	11225	3	0	\N
22129	1573	4179327000000	22429	11225	4	0	\N
22130	1573	4179327000000	22641	11322	4	0	\N
22132	1573	4298855000000	14166	7230	3	0	\N
22134	1573	4298867000000	14166	7230	4	0	\N
22136	1573	4320070000000	1206	664	1	0	\N
22137	1573	4320070000000	1353	742	1	0	\N
22139	1573	4320080000000	1206	664	2	0	\N
22140	1573	4320080000000	1353	742	2	0	\N
22142	1573	4899327000000	24012	11949	3	0	\N
22143	1573	4899327000000	24085	11989	2	0	\N
22145	1573	4899338000000	24085	11989	3	0	\N
22146	1573	4899339000000	24012	11949	4	0	\N
22148	1573	5018881000000	15463	7874	3	0	\N
22150	1573	5018893000000	15463	7874	4	0	\N
22152	1573	5040080000000	1989	1051	1	0	\N
22153	1573	5040080000000	2102	1109	1	0	\N
22155	1573	5040090000000	1989	1051	2	0	\N
22156	1573	5040090000000	2102	1109	2	0	\N
22158	1573	5619363000000	24396	12113	61	0	\N
22159	1573	5619363000000	24811	12320	4	0	\N
22161	1573	5619376000000	24811	12320	5	0	\N
22163	1573	5620045000000	24396	12113	62	0	\N
22166	1573	5760090000000	3172	1648	1	0	\N
22167	1573	5760090000000	3424	1779	1	0	\N
22097	1573	1440020000000	230	136	2	0	0
22098	1573	1440040000000	230	136	3	0	0
22109	1573	2160040000000	789	436	1	0	0
22110	1573	2160050000000	789	436	2	0	0
22118	1573	2880050000000	833	459	1	0	0
22125	1573	3600060000000	859	476	1	0	0
22126	1573	3600070000000	859	476	2	0	0
22138	1573	4320070000000	1890	1005	1	0	0
22141	1573	4320080000000	1890	1005	2	0	0
22154	1573	5040080000000	2671	1403	1	0	0
22168	1573	5760090000000	3527	1831	0	0	0
22095	1573	1418806000000	12071	6214	1	0	5
22096	1573	1418807000000	12071	6214	2	0	5
22104	1573	2138807000000	13008	6705	2	0	5
22115	1573	2858818000000	13230	6817	7	0	5
22117	1573	2858843000000	13230	6817	8	0	5
22123	1573	3578843000000	13467	6937	3	0	5
22124	1573	3578855000000	13467	6937	4	0	5
22033	1571	15840301001024	13488	6946	6	0	1
22040	1571	16560317001024	13954	7151	8	0	1
22133	1573	4298855000000	14335	7316	8	0	5
22135	1573	4298881000000	14335	7316	9	0	5
22043	1571	17280317001024	14337	7318	4	0	1
22044	1571	17280330001024	14337	7318	5	0	1
22048	1571	18000341001024	14783	7528	3	0	1
22052	1571	18720341001024	14862	7572	5	0	1
22053	1571	18720355001024	14862	7572	6	0	1
22149	1573	5018881000000	15691	7981	7	0	5
22164	1573	5738906000000	15769	8020	3	0	5
22165	1573	5738918000000	15769	8020	4	0	5
22056	1571	19440355001024	16636	8451	6	0	1
22058	1571	19440427001024	16636	8451	7	0	1
22060	1571	20160427001024	16742	8501	8	0	1
22066	1571	20880462001024	18160	9155	6	0	1
22068	1571	20880486001024	18160	9155	7	0	1
22077	1571	21600486001024	18498	9317	4	0	1
22078	1571	21600499001024	18498	9317	5	0	1
22083	1571	22320499001024	19277	9718	4	0	1
22049	1571	18252395001031	19299	9730	3	0	6
22050	1571	18252407001031	19299	9730	4	0	6
22099	1573	2019267000000	21887	10953	3	0	10
22100	1573	2019279000000	21887	10953	4	0	10
22113	1573	2739291000000	21996	10999	4	0	10
22120	1573	3459291000000	22401	11214	6	0	10
22121	1573	3459315000000	22401	11214	7	0	10
22128	1573	4179315000000	23813	11853	3	0	10
22131	1573	4179327000000	23813	11853	4	0	10
22147	1573	4899363000000	24313	12090	10	0	10
22160	1573	5619363000000	24862	12345	7	0	10
22162	1573	5619388000000	24862	12345	8	0	10
22169	1573	5760100000000	3172	1648	2	0	\N
22170	1573	5760100000000	3424	1779	2	0	\N
22171	1573	6339388000000	25933	12816	4	0	\N
22174	1573	6339410000000	25933	12816	5	0	\N
22187	1573	7898991000000	16609	8436	3	0	\N
22189	1573	7899003000000	16609	8436	4	0	\N
22191	1573	7920110000000	4239	2201	1	0	\N
22193	1573	7920120000000	4239	2201	2	0	\N
22195	1573	8499423000000	27635	13658	3	0	\N
22198	1573	8499435000000	27635	13658	4	0	\N
22203	1573	9219434000000	28511	14088	3	0	\N
22205	1573	9219446000000	28511	14088	4	0	\N
22207	1573	9339014000000	16938	8585	7	0	\N
22210	1573	9339039000000	16938	8585	8	0	\N
22217	1573	10080350000000	4712	2436	1	0	\N
22219	1573	10080360000000	4712	2436	2	0	\N
22221	1573	10659459000000	29354	14467	3	0	\N
22223	1573	10659471000000	29354	14467	4	0	\N
22240	1573	12240380000000	5340	2770	1	0	\N
22241	1573	12240380000000	5917	3067	3	0	\N
22243	1573	12240390000000	5340	2770	2	0	\N
22245	1573	12240410000000	5917	3067	4	0	\N
22248	1573	12960390000000	5349	2771	0	0	\N
22251	1573	13659145000000	18392	9269	2	0	\N
22253	1573	13659156000000	18392	9269	3	0	\N
22255	1573	13659197000000	19331	9747	4	0	\N
22258	1573	14379157000000	18658	9401	6	0	\N
22260	1573	14379181000000	18658	9401	7	0	\N
22261	1573	14379197000000	19331	9747	11	0	\N
22262	1573	14379230000000	19331	9747	12	0	\N
22268	1573	15120550000000	6775	3506	2	0	\N
22270	1573	15120570000000	6775	3506	3	0	\N
22276	1573	17280660000000	7513	3888	4	0	\N
22277	1573	17280660000000	7518	3892	1	0	\N
22279	1573	17280670000000	7518	3892	2	0	\N
22281	1573	17280695000000	7513	3888	5	0	\N
22298	1573	23041130000000	11604	5818	32	0	\N
22299	1573	23760810000000	10195	5279	4	0	\N
22300	1573	23760810000000	10291	5324	3	0	\N
22301	1573	23760810000000	10905	5625	4	0	\N
22302	1573	23760810000000	11195	5747	2	0	\N
22183	1573	7200100000000	3803	1971	1	0	0
22184	1573	7200110000000	3803	1971	2	0	0
22192	1573	7920110000000	4251	2206	1	0	0
22194	1573	7920120000000	4251	2206	2	0	0
22201	1573	8640120000000	4280	2219	1	0	0
22211	1573	9360130000000	4444	2303	4	0	0
22212	1573	9360350000000	4444	2303	5	0	0
22218	1573	10080350000000	5015	2601	1	0	0
22220	1573	10080360000000	5015	2601	2	0	0
22228	1573	10800360000000	5148	2669	1	0	0
22234	1573	11520370000000	5301	2754	1	0	0
22235	1573	11520380000000	5301	2754	2	0	0
22242	1573	12240380000000	5958	3089	2	0	0
22244	1573	12240400000000	5958	3089	3	0	0
22250	1573	12960410000000	5998	3112	2	0	0
22256	1573	13680410000000	6193	3206	3	0	0
22257	1573	13680530000000	6193	3206	4	0	0
22264	1573	14400530000000	6222	3220	2	0	0
22265	1573	14400550000000	6222	3220	3	0	0
22271	1573	15120570000000	7041	3633	3	0	0
22272	1573	15840570000000	7368	3805	7	0	0
22273	1573	15840640000000	7368	3805	8	0	0
22274	1573	16560640000000	7505	3884	2	0	0
22275	1573	16560660000000	7505	3884	3	0	0
22280	1573	17280670000000	7561	3915	2	0	0
22282	1573	18000670000000	7632	3949	2	0	0
22283	1573	18000690000000	7632	3949	3	0	0
22284	1573	18720690000000	7697	3988	1	0	0
22286	1573	19440700000000	7912	4100	1	0	0
22287	1573	19440710000000	7912	4100	2	0	0
22288	1573	20160710000000	8200	4250	1	0	0
22289	1573	20160720000000	8200	4250	2	0	0
22290	1573	20880720000000	8678	4497	2	0	0
22292	1573	21600740000000	8746	4538	2	0	0
22293	1573	21600760000000	8746	4538	3	0	0
22294	1573	22320760000000	9747	5049	3	0	0
22295	1573	22320790000000	9747	5049	4	0	0
22296	1573	23040790000000	9900	5132	2	0	0
22303	1573	23760810000000	11898	6117	1	0	0
22304	1573	23760811000000	11898	6117	2	0	0
22175	1573	6458918000000	15936	8101	3	0	5
22176	1573	6458930000000	15936	8101	4	0	5
22182	1573	7178991000000	15977	8121	17	0	5
22188	1573	7898991000000	16680	8472	3	0	5
22190	1573	7899003000000	16680	8472	4	0	5
22199	1573	8619003000000	16807	8530	2	0	5
22200	1573	8619014000000	16807	8530	3	0	5
22209	1573	9339036000000	17004	8613	5	0	5
22215	1573	10059036000000	17480	8850	8	0	5
22216	1573	10059098000000	17480	8850	9	0	5
22226	1573	10779098000000	17558	8888	3	0	5
22227	1573	10779110000000	17558	8888	4	0	5
22233	1573	11499123000000	17863	9015	5	0	5
22238	1573	12219123000000	18254	9194	2	0	5
22239	1573	12219134000000	18254	9194	3	0	5
22246	1573	12939134000000	18261	9197	2	0	5
22252	1573	13659145000000	18407	9279	3	0	5
22254	1573	13659157000000	18407	9279	4	0	5
22259	1573	14379157000000	20088	10112	13	0	5
22263	1573	14379269000000	20088	10112	14	0	5
22266	1573	15099269000000	20305	10225	3	0	5
22172	1573	6339388000000	25956	12826	3	0	10
22173	1573	6339409000000	25956	12826	4	0	10
22179	1573	7059409000000	27059	13377	3	0	10
22180	1573	7059421000000	27059	13377	4	0	10
22185	1573	7779421000000	27558	13622	2	0	10
22196	1573	8499423000000	28422	14047	2	0	10
22197	1573	8499434000000	28422	14047	3	0	10
22204	1573	9219434000000	28802	14208	4	0	10
22206	1573	9219447000000	28802	14208	5	0	10
22214	1573	9939459000000	29018	14310	4	0	10
22222	1573	10659459000000	29588	14589	8	0	10
22224	1573	10659485000000	29588	14589	9	0	10
22225	1573	10659632000000	29655	14625	12	0	10
22230	1573	11379632000000	29655	14625	31	0	10
22236	1573	12099650000000	30253	14874	10	0	10
22237	1573	12099669000000	30253	14874	11	0	10
22305	1573	23760830000000	11195	5747	3	0	\N
22306	1573	23760850000000	10195	5279	5	0	\N
22307	1573	23760850000000	10291	5324	4	0	\N
22308	1573	23760850000000	10905	5625	5	0	\N
22309	1573	23761130000000	11604	5818	125	0	\N
22310	1573	66000004950000	11604	5818	126	1	\N
22311	1574	720000000000	20817	10464	2	0	\N
22312	1574	720011000000	20817	10464	3	0	\N
22313	1575	720000000000	10862	5606	4	0	\N
22314	1575	720040000000	10862	5606	5	0	\N
22315	1576	720000000000	275	159	1	0	\N
22316	1576	720000000000	29182	14277	6	0	\N
22318	1576	720000000000	29184	14373	54	0	\N
22319	1576	720010000000	275	159	2	0	\N
22321	1576	720216000000	29184	14373	55	0	\N
22322	1576	720285000000	29182	14277	7	0	\N
22323	1577	720000000000	17	10	0	0	\N
22329	1580	1440020000000	16472	8331	10	0	\N
22330	1580	1440020000000	16475	8378	3	0	\N
22332	1580	1440032000000	16475	8378	4	0	\N
22334	1580	1440057000000	16472	8331	11	0	\N
22335	1580	2160032000000	20283	10214	6	0	\N
22338	1580	2160056000000	20283	10214	7	0	\N
22339	1580	2880044000000	22685	11342	3	0	\N
22340	1580	2880056000000	22685	11342	4	0	\N
22341	1580	66000000000400	2760	1231	118	1	\N
22344	1583	720000000000	13793	7084	4	0	\N
22345	1583	720013000000	13793	7084	5	0	\N
22346	1584	500000000	4902	2249	0	0	\N
22349	1587	720000000000	61	35	1	0	\N
22351	1587	720000000000	10241	5233	0	0	\N
22352	1587	720000000000	10243	5246	0	0	\N
22353	1587	720000000000	10244	5259	0	0	\N
22354	1587	720000000000	10245	5299	4	0	\N
22355	1587	720000000000	10246	5271	0	0	\N
22356	1587	720000000000	10527	5428	39	0	\N
22359	1587	720010000000	61	35	2	0	\N
22362	1587	720040000000	10245	5299	5	0	\N
22364	1587	720390000000	10527	5428	40	0	\N
22365	1587	720710000000	10551	5429	32	0	\N
22369	1587	1440024000000	20768	10437	5	0	\N
22372	1587	1440065000000	20768	10437	6	0	\N
22374	1587	1440710000000	10551	5429	43	0	\N
22375	1587	1440756000000	10551	5429	44	0	\N
22376	1587	2160020000000	686	383	1	0	\N
22377	1587	2160020000000	765	426	3	0	\N
22379	1587	2160030000000	686	383	2	0	\N
22381	1587	2160065000000	20863	10487	5	0	\N
22384	1587	2160107000000	20863	10487	6	0	\N
22385	1587	2160110000000	11250	5780	15	0	\N
22387	1587	2160140000000	765	426	4	0	\N
22388	1587	2160242000000	11250	5780	16	0	\N
22391	1587	2880030000000	1551	845	0	0	\N
22396	1587	2880242000000	11324	5815	2	0	\N
22398	1587	2880253000000	11324	5815	3	0	\N
22402	1587	3600110000000	21120	10608	3	0	\N
22404	1587	3600122000000	21120	10608	4	0	\N
22408	1587	4320060000000	1943	1031	2	0	\N
22411	1587	4320080000000	1943	1031	3	0	\N
22412	1587	4320122000000	21742	10888	3	0	\N
22414	1587	4320134000000	21742	10888	4	0	\N
22416	1587	4320264000000	11443	5878	4	0	\N
22417	1587	4320264000000	11862	6097	3	0	\N
22419	1587	4320276000000	11862	6097	4	0	\N
22421	1587	4320286000000	11443	5878	5	0	\N
22425	1587	5040146000000	22067	11034	3	0	\N
22426	1587	5040158000000	22067	11034	4	0	\N
22428	1587	5040276000000	12395	6394	2	0	\N
22431	1587	5040278000000	12395	6394	3	0	\N
22432	1587	5760080000000	2546	1340	1	0	\N
22433	1587	5760080000000	2547	1340	0	0	\N
22435	1587	5760090000000	2546	1340	2	0	\N
22324	1577	720000000000	281	162	1	0	0
22325	1577	720010000000	281	162	2	0	0
22366	1587	1440010000000	675	376	1	0	0
22367	1587	1440020000000	675	376	2	0	0
22378	1587	2160020000000	1227	676	1	0	0
22392	1587	2880030000000	1746	937	2	0	0
22393	1587	2880050000000	1746	937	3	0	0
22400	1587	3600050000000	1838	982	1	0	0
22401	1587	3600060000000	1838	982	2	0	0
22409	1587	4320060000000	2357	1232	1	0	0
22422	1587	5040070000000	2379	1245	1	0	0
22423	1587	5040080000000	2379	1245	2	0	0
22434	1587	5760080000000	2616	1377	1	0	0
22436	1587	5760090000000	2616	1377	2	0	0
22328	1580	720020000000	4684	2421	2	0	0
22347	1584	720000000000	9953	5168	1	0	0
22348	1584	720010000000	9953	5168	2	0	0
22357	1587	720000000000	10528	5436	4	0	7
22363	1587	720040000000	10528	5436	5	0	7
22373	1587	1440110000000	10553	5449	8	0	7
22386	1587	2160110000000	11251	5780	15	0	7
22389	1587	2160242000000	11251	5780	16	0	7
22390	1587	2160252000000	11340	5824	1	0	7
22397	1587	2880252000000	11340	5824	3	0	7
22406	1587	3600253000000	11356	5832	2	0	7
22407	1587	3600264000000	11356	5832	3	0	7
22418	1587	4320264000000	12112	6238	3	0	7
22420	1587	4320276000000	12112	6238	4	0	7
22430	1587	5040277000000	12493	6438	2	0	7
22439	1587	5760277000000	12622	6514	4	0	7
22440	1587	5760299000000	12622	6514	5	0	7
22331	1580	1440020000000	17164	8700	3	0	0
22333	1580	1440032000000	17164	8700	4	0	0
22361	1587	720024000000	20276	10212	7	0	14
22368	1587	1440024000000	20766	10437	5	0	14
22371	1587	1440065000000	20766	10437	6	0	14
22382	1587	2160065000000	20939	10528	6	0	14
22383	1587	2160098000000	20939	10528	7	0	14
22395	1587	2880110000000	20977	10551	4	0	14
22336	1580	2160032000000	20992	10558	3	0	0
22337	1580	2160044000000	20992	10558	4	0	0
22403	1587	3600110000000	21433	10749	3	0	14
22413	1587	4320122000000	21918	10968	6	0	14
22415	1587	4320146000000	21918	10968	7	0	14
22424	1587	5040146000000	22066	11034	4	0	14
22427	1587	5040159000000	22066	11034	5	0	14
22437	1587	5760159000000	22128	11068	3	0	14
22342	1582	720000000000	24426	12148	2	0	0
22343	1582	720011000000	24426	12148	3	0	0
22317	1576	720000000000	29183	14387	2	0	0
22320	1576	720011000000	29183	14387	3	0	0
22443	1587	6480155000000	23413	11682	4	0	\N
22444	1587	6480177000000	23413	11682	5	0	\N
22445	1587	6480180000000	22229	11126	5	0	\N
22446	1587	6480180000000	22230	11126	4	0	\N
22447	1587	6480180000000	22682	11341	7	0	\N
22449	1587	6480193000000	22230	11126	5	0	\N
22450	1587	6480194000000	22229	11126	6	0	\N
22452	1587	6480205000000	22682	11341	8	0	\N
22455	1587	7200100000000	2807	1467	2	0	\N
22457	1587	7200120000000	2807	1467	3	0	\N
22459	1587	7200202000000	23553	11740	6	0	\N
22461	1587	7200226000000	23553	11740	7	0	\N
22472	1587	7920640000000	4555	2356	5	0	\N
22473	1587	8640140000000	3207	1666	1	0	\N
22474	1587	8640140000000	3314	1719	2	0	\N
22475	1587	8640140000000	3447	1789	1	0	\N
22476	1587	8640140000000	3672	1907	0	0	\N
22477	1587	8640140000000	3673	1907	1	0	\N
22478	1587	8640140000000	3851	1999	2	0	\N
22479	1587	8640140000000	4234	2200	1	0	\N
22480	1587	8640140000000	4558	2357	1	0	\N
22481	1587	8640140000000	4559	2357	1	0	\N
22482	1587	8640140000000	4627	2394	3	0	\N
22484	1587	8640150000000	3207	1666	2	0	\N
22485	1587	8640150000000	3447	1789	2	0	\N
22486	1587	8640150000000	3673	1907	2	0	\N
22487	1587	8640150000000	4234	2200	2	0	\N
22488	1587	8640150000000	4558	2357	2	0	\N
22489	1587	8640150000000	4559	2357	2	0	\N
22491	1587	8640160000000	3851	1999	3	0	\N
22492	1587	8640170000000	4627	2394	4	0	\N
22493	1587	8640250000000	3314	1719	3	0	\N
22494	1587	8640313000000	23775	11839	3	0	\N
22495	1587	8640313000000	24028	11958	3	0	\N
22496	1587	8640313000000	24037	11962	2	0	\N
22498	1587	8640324000000	24037	11962	3	0	\N
22500	1587	8640325000000	23775	11839	4	0	\N
22501	1587	8640325000000	24028	11958	4	0	\N
22504	1587	8640640000000	4555	2356	15	0	\N
22505	1587	8641270000000	4555	2356	16	0	\N
22508	1587	9360324000000	24614	12233	3	0	\N
22510	1587	9360336000000	24614	12233	4	0	\N
22514	1587	10080160000000	4853	2515	2	0	\N
22517	1587	10080270000000	4853	2515	3	0	\N
22520	1587	10080372000000	13756	7069	8	0	\N
22523	1587	10080398000000	13756	7069	9	0	\N
22524	1587	10800170000000	5173	2686	0	0	\N
22527	1587	10800348000000	25030	12418	5	0	\N
22528	1587	10800348000000	25276	12539	6	0	\N
22531	1587	10800371000000	25030	12418	6	0	\N
22532	1587	10800372000000	25276	12539	7	0	\N
22534	1587	10800385000000	14058	7196	3	0	\N
22535	1587	10800388000000	14058	7196	4	0	\N
22538	1587	11520361000000	25435	12603	3	0	\N
22540	1587	11520373000000	25435	12603	4	0	\N
22543	1587	11520398000000	14330	7312	2	0	\N
22544	1587	11520409000000	14330	7312	3	0	\N
22546	1587	12240190000000	5666	2939	0	0	\N
22549	1587	12240384000000	25631	12685	6	0	\N
22552	1587	12240408000000	25631	12685	7	0	\N
22555	1587	12960200000000	6158	3190	1	0	\N
22556	1587	12960200000000	6191	3205	1	0	\N
22558	1587	12960210000000	6158	3190	2	0	\N
22559	1587	12960210000000	6191	3205	2	0	\N
22569	1587	13680450000000	14625	7455	3	0	\N
22571	1587	13680462000000	14625	7455	4	0	\N
22456	1587	7200100000000	3125	1625	3	0	0
22458	1587	7200130000000	3125	1625	4	0	0
22465	1587	7920130000000	3186	1654	1	0	0
22466	1587	7920140000000	3186	1654	2	0	0
22483	1587	8640140000000	4659	2409	1	0	0
22506	1587	9360150000000	4812	2491	1	0	0
22507	1587	9360160000000	4812	2491	2	0	0
22515	1587	10080160000000	4949	2562	1	0	0
22516	1587	10080170000000	4949	2562	2	0	0
22525	1587	10800170000000	5357	2781	2	0	0
22537	1587	11520190000000	5537	2879	0	0	0
22547	1587	12240190000000	5748	2980	1	0	0
22548	1587	12240200000000	5748	2980	2	0	0
22557	1587	12960200000000	6491	3364	2	0	0
22565	1587	13680220000000	6528	3384	2	0	0
22566	1587	13680240000000	6528	3384	3	0	0
22573	1587	14400240000000	6981	3602	4	0	0
22574	1587	14400280000000	6981	3602	5	0	0
22453	1587	6480299000000	12984	6694	2	0	7
22463	1587	7200310000000	13136	6771	4	0	7
22464	1587	7200323000000	13136	6771	5	0	7
22469	1587	7920323000000	13150	6777	2	0	7
22470	1587	7920334000000	13150	6777	3	0	7
22471	1587	7920344000000	13340	6875	1	0	7
22503	1587	8640360000000	13340	6875	10	0	7
22512	1587	9360360000000	13576	6981	3	0	7
22513	1587	9360372000000	13576	6981	4	0	7
22521	1587	10080372000000	13772	7076	4	0	7
22533	1587	10800385000000	14055	7196	4	0	7
22536	1587	10800398000000	14055	7196	5	0	7
22542	1587	11520398000000	14329	7312	3	0	7
22545	1587	11520410000000	14329	7312	4	0	7
22553	1587	12240410000000	14344	7321	7	0	7
22563	1587	12960426000000	14543	7418	6	0	7
22564	1587	12960450000000	14543	7418	7	0	7
22570	1587	13680450000000	14789	7532	4	0	7
22572	1587	13680472000000	14789	7532	5	0	7
22448	1587	6480180000000	23414	11682	4	0	14
22460	1587	7200202000000	23600	11759	14	0	14
22462	1587	7200288000000	23600	11759	15	0	14
22467	1587	7920288000000	23643	11778	7	0	14
22468	1587	7920313000000	23643	11778	8	0	14
22499	1587	8640324000000	24185	12039	3	0	14
22509	1587	9360324000000	24879	12352	3	0	14
22511	1587	9360336000000	24879	12352	4	0	14
22518	1587	10080336000000	24889	12357	3	0	14
22519	1587	10080348000000	24889	12357	4	0	14
22530	1587	10800361000000	25280	12540	5	0	14
22539	1587	11520361000000	25629	12683	5	0	14
22541	1587	11520384000000	25629	12683	6	0	14
22550	1587	12240384000000	25751	12738	4	0	14
22551	1587	12240397000000	25751	12738	5	0	14
22562	1587	12960409000000	25867	12788	4	0	14
22567	1587	13680409000000	25877	12789	6	0	14
22568	1587	13680433000000	25877	12789	7	0	14
22575	1587	14400433000000	25952	12824	4	0	14
22579	1587	15120280000000	7157	3698	3	0	\N
22580	1587	15120280000000	7395	3820	2	0	\N
22583	1587	15120300000000	7395	3820	3	0	\N
22584	1587	15120400000000	7157	3698	4	0	\N
22587	1587	15120483000000	14972	7628	2	0	\N
22589	1587	15120494000000	14972	7628	3	0	\N
22599	1587	16560479000000	26559	13141	4	0	\N
22600	1587	16560479000000	26921	13315	3	0	\N
22603	1587	16560491000000	26921	13315	4	0	\N
22604	1587	16560492000000	26559	13141	5	0	\N
22607	1587	17280331000000	9225	4782	2	0	\N
22608	1587	17280331000000	9378	4865	2	0	\N
22609	1587	17280331000000	9616	4989	2	0	\N
22612	1587	17280351000000	9225	4782	3	0	\N
22613	1587	17280351000000	9378	4865	3	0	\N
22614	1587	17280351000000	9616	4989	3	0	\N
22615	1587	17280490000000	27366	13531	3	0	\N
22618	1587	17280502000000	27366	13531	4	0	\N
22623	1587	18000565000000	15932	8100	3	0	\N
22625	1587	18000577000000	15932	8100	4	0	\N
22637	1587	20160611000000	16823	8539	2	0	\N
22638	1587	20160611000000	16971	8599	3	0	\N
22640	1587	20160622000000	16823	8539	3	0	\N
22641	1587	20160623000000	16971	8599	4	0	\N
22643	1587	20880559000000	28476	14074	2	0	\N
22644	1587	20880559000000	29194	14392	5	0	\N
22645	1587	20880559000000	29408	14500	4	0	\N
22647	1587	20880570000000	28476	14074	3	0	\N
22648	1587	20880572000000	29408	14500	5	0	\N
22650	1587	20880582000000	29194	14392	6	0	\N
22659	1587	22320629199717	30318	14900	2	0	\N
22661	1587	22320704000000	18019	9089	2	0	\N
22662	1587	22320715000000	18019	9089	3	0	\N
22664	1587	23040629199717	30318	14900	4	0	\N
22665	1587	23040630139684	30318	14900	6	0	\N
22666	1587	23040716000000	18106	9133	2	0	\N
22668	1587	23040727000000	18106	9133	3	0	\N
22671	1587	24480727000000	18360	9253	2	0	\N
22673	1587	24480738000000	18360	9253	3	0	\N
22677	1587	25920772000000	19005	9566	30	0	\N
22680	1587	25920991000000	19005	9566	31	0	\N
22683	1587	27360845000000	20013	10075	3	0	\N
22684	1587	27360857000000	20013	10075	4	0	\N
22687	1588	1440030000000	440	249	3	0	\N
22688	1588	1440030000000	466	262	1	0	\N
22690	1588	1440040000000	466	262	2	0	\N
22692	1588	1440060000000	440	249	4	0	\N
22693	1588	2160040000000	830	458	1	0	\N
22694	1588	2160040000000	1128	622	1	0	\N
22695	1588	2160040000000	1277	705	1	0	\N
22697	1588	2160050000000	830	458	2	0	\N
22698	1588	2160050000000	1128	622	2	0	\N
22699	1588	2160050000000	1277	705	2	0	\N
22703	1588	3600060000000	2004	1059	2	0	\N
22704	1588	3600060000000	2018	1065	1	0	\N
22706	1588	3600070000000	2018	1065	2	0	\N
22708	1588	3600080000000	2004	1059	3	0	\N
22709	1588	4320070000000	2961	1538	1	0	\N
22711	1588	4320080000000	2961	1538	2	0	\N
22689	1588	1440030000000	552	313	1	0	0
22691	1588	1440040000000	552	313	2	0	0
22696	1588	2160040000000	1649	888	1	0	0
22700	1588	2160050000000	1649	888	2	0	0
22701	1588	2880050000000	1939	1030	1	0	0
22705	1588	3600060000000	2530	1330	1	0	0
22707	1588	3600070000000	2530	1330	2	0	0
22710	1588	4320070000000	3118	1620	1	0	0
22712	1588	4320080000000	3118	1620	2	0	0
22581	1587	15120280000000	8307	4299	1	0	0
22591	1587	15840290000000	8360	4330	2	0	0
22592	1587	15840310000000	8360	4330	3	0	0
22597	1587	16560310000000	8522	4415	3	0	0
22598	1587	16560331000000	8522	4415	4	0	0
22611	1587	17280344000000	9779	5067	5	0	0
22577	1587	14400472000000	14817	7551	2	0	7
22578	1587	14400483000000	14817	7551	3	0	7
22588	1587	15120483000000	15178	7734	3	0	7
22590	1587	15120495000000	15178	7734	4	0	7
22596	1587	15840505000000	15577	7929	2	0	7
22605	1587	16560505000000	15623	7953	6	0	7
22606	1587	16560529000000	15623	7953	7	0	7
22619	1587	17280529000000	15761	8015	9	0	7
22620	1587	17280565000000	15761	8015	10	0	7
22626	1587	18000577000000	15958	8113	4	0	7
22629	1587	18720577000000	16700	8485	2	0	7
22630	1587	18720588000000	16700	8485	3	0	7
22633	1587	19440588000000	16738	8500	5	0	7
22639	1587	20160611000000	17007	8614	5	0	7
22642	1587	20160634000000	17007	8614	6	0	7
22651	1587	20880634000000	17368	8797	7	0	7
22652	1587	20880668000000	17368	8797	8	0	7
22655	1587	21600668000000	17868	9018	9	0	7
22660	1587	22320704000000	18018	9089	3	0	7
22663	1587	22320716000000	18018	9089	4	0	7
22667	1587	23040716000000	18107	9133	0	0	7
22669	1587	23760716000000	18234	9185	2	0	7
22670	1587	23760727000000	18234	9185	3	0	7
22674	1587	24480738000000	18567	9357	3	0	7
22675	1587	25200738000000	18707	9423	7	0	7
22676	1587	25200772000000	18707	9423	8	0	7
22678	1587	25920772000000	19006	9583	2	0	7
22681	1587	26640783000000	19205	9689	17	0	7
22682	1587	26640845000000	19205	9689	18	0	7
22585	1587	15120455000000	25994	12847	4	0	14
22586	1587	15120477000000	25994	12847	5	0	14
22593	1587	15840477000000	26544	13132	2	0	14
22601	1587	16560479000000	27287	13487	2	0	14
22602	1587	16560490000000	27287	13487	3	0	14
22616	1587	17280490000000	27756	13711	2	0	14
22617	1587	17280501000000	27756	13711	3	0	14
22621	1587	18000501000000	27800	13737	4	0	14
22627	1587	18720514000000	27817	13747	3	0	14
22628	1587	18720526000000	27817	13747	4	0	14
22631	1587	19440526000000	28023	13860	3	0	14
22632	1587	19440538000000	28023	13860	4	0	14
22636	1587	20160559000000	28383	14031	4	0	14
22646	1587	20880559000000	29427	14509	4	0	14
22649	1587	20880578750000	29427	14509	5	0	14
22653	1587	21600578750000	29967	14759	13	0	14
22654	1587	21600600750000	29967	14759	14	0	14
22658	1587	22320618199717	30169	14843	11	0	14
22713	1588	5040080000000	3382	1760	1	0	\N
22715	1588	5040090000000	3382	1760	2	0	\N
22741	1588	10294821000000	13016	6710	5	0	\N
22744	1588	10294943000000	13016	6710	6	0	\N
22745	1588	10800150000000	5446	2834	0	0	\N
22746	1588	10800150000000	5455	2839	0	0	\N
22748	1588	11014887000000	13367	6888	7	0	\N
22749	1588	11014887000000	13458	6933	3	0	\N
22750	1588	11014887000000	13459	6895	0	0	\N
22751	1588	11014887000000	13460	6891	0	0	\N
22753	1588	11014887000000	13553	6910	0	0	\N
22754	1588	11014887000000	13554	6912	0	0	\N
22755	1588	11014887000000	13555	6914	0	0	\N
22757	1588	11014908000000	13458	6933	4	0	\N
22758	1588	11014912000000	13367	6888	8	0	\N
22761	1588	11734897000000	13665	7019	0	0	\N
22764	1588	12240160000000	6216	3217	3	0	\N
22768	1588	12240370000000	6216	3217	4	0	\N
22775	1588	13174922000000	13933	7142	0	0	\N
22776	1588	13174922000000	13934	7142	4	0	\N
22777	1588	13174922000000	14569	7429	6	0	\N
22778	1588	13174922000000	15296	7530	10	0	\N
22779	1588	13174922000000	15297	7796	2	0	\N
22781	1588	13174922000000	15709	7988	0	0	\N
22782	1588	13174933000000	15297	7796	3	0	\N
22784	1588	13174935000000	13934	7142	5	0	\N
22785	1588	13174955000000	14569	7429	7	0	\N
22786	1588	13175086000000	15296	7530	11	0	\N
22793	1588	14400230000000	7199	3722	1	0	\N
22795	1588	14400240000000	7199	3722	2	0	\N
22797	1588	14401787000000	24974	12394	8	0	\N
22799	1588	14401813000000	24974	12394	9	0	\N
22801	1588	14614946000000	16399	8342	3	0	\N
22802	1588	14614946000000	16435	8358	4	0	\N
22803	1588	14614946000000	16653	8461	7	0	\N
22805	1588	14614958000000	16399	8342	4	0	\N
22806	1588	14614959000000	16435	8358	5	0	\N
22808	1588	14614971000000	16653	8461	8	0	\N
22811	1588	15121821500001	25146	12477	3	0	\N
22812	1588	15121822000000	25662	12701	3	0	\N
22814	1588	15121834000000	25662	12701	4	0	\N
22816	1588	15334959000000	16913	8575	3	0	\N
22818	1588	15334971000000	16913	8575	4	0	\N
22822	1588	15841857000000	25917	12808	2	0	\N
22824	1588	15841868000000	25917	12808	3	0	\N
22826	1588	16054971000000	16984	8604	5	0	\N
22828	1588	16054971000000	17264	8643	0	0	\N
22830	1588	16054994000000	16984	8604	6	0	\N
22831	1588	16055663000000	17388	8772	124	0	\N
22837	1588	16561907000000	26548	13134	1	0	\N
22838	1588	16774971000000	17391	8644	9	0	\N
22841	1588	16775151000000	17391	8644	10	0	\N
22842	1588	16775663000000	17388	8772	126	0	\N
22843	1588	16775664000000	17388	8772	127	0	\N
22844	1588	16944799000000	27968	13835	11	0	\N
22847	1588	16944837000000	27968	13835	12	0	\N
22848	1588	17280520000000	8299	4297	1	0	\N
22717	1588	5760090000000	4018	2084	2	0	0
22718	1588	6480090000000	4484	2322	1	0	0
22719	1588	6480100000000	4484	2322	2	0	0
22722	1588	7200100000000	4607	2384	1	0	0
22723	1588	7200110000000	4607	2384	2	0	0
22727	1588	7920120000000	4999	2592	2	0	0
22730	1588	8640120000000	5047	2617	1	0	0
22731	1588	8640130000000	5047	2617	2	0	0
22734	1588	9360130000000	5050	2620	1	0	0
22735	1588	9360140000000	5050	2620	2	0	0
22740	1588	10080150000000	5061	2626	2	0	0
22747	1588	10800150000000	5583	2904	0	0	0
22759	1588	11520150000000	5797	3007	1	0	0
22760	1588	11520160000000	5797	3007	2	0	0
22766	1588	12240170000000	6253	3236	2	0	0
22767	1588	12240180000000	6631	3427	1	0	0
22771	1588	12960180000000	6631	3427	5	0	0
22772	1588	12960210000000	6631	3427	6	0	0
22787	1588	13680210000000	6714	3473	2	0	0
22794	1588	14400230000000	7263	3757	1	0	0
22796	1588	14400240000000	7263	3757	2	0	0
22809	1588	15120240000000	7400	3823	8	0	0
22810	1588	15120500000000	7400	3823	9	0	0
22820	1588	15840500000000	8205	4253	1	0	0
22832	1588	16560510000000	8211	4256	1	0	0
22833	1588	16560520000000	8211	4256	2	0	0
22720	1588	6694754000000	12653	6527	2	0	6
22721	1588	6694765000000	12653	6527	3	0	6
22725	1588	7414776000000	12721	6560	3	0	6
22728	1588	8134776000000	12757	6577	4	0	6
22729	1588	8134798000000	12757	6577	5	0	6
22732	1588	8854798000000	12801	6601	3	0	6
22733	1588	8854810000000	12801	6601	4	0	6
22737	1588	9574821000000	12934	6666	3	0	6
22738	1588	9574851000000	13177	6789	3	0	6
22742	1588	10294851000000	13177	6789	13	0	6
22743	1588	10294887000000	13177	6789	14	0	6
22752	1588	11014887000000	13551	6972	1	0	6
22762	1588	11734897000000	13666	7023	3	0	6
22763	1588	11734909000000	13666	7023	4	0	6
22769	1588	12454909000000	13857	7111	4	0	6
22770	1588	12454922000000	13857	7111	5	0	6
22783	1588	13174934000000	15708	7988	4	0	6
22791	1588	13894934000000	16033	8153	3	0	6
22792	1588	13894946000000	16033	8153	4	0	6
22804	1588	14614946000000	16893	8568	4	0	6
22807	1588	14614959000000	16893	8568	5	0	6
22819	1588	15334971000000	16916	8575	4	0	6
22827	1588	16054971000000	17263	8744	3	0	6
22829	1588	16054983000000	17263	8744	4	0	6
22839	1588	16774983000000	17390	8808	12	0	6
22840	1588	16775038000000	17390	8808	13	0	6
22774	1588	12961775000000	24766	12297	4	0	12
22789	1588	13681775000000	24910	12368	3	0	12
22790	1588	13681787000000	24910	12368	4	0	12
22798	1588	14401787000000	24999	12403	8	0	12
22813	1588	15121822000000	25861	12785	8	0	12
22815	1588	15121857000000	25861	12785	9	0	12
22823	1588	15841857000000	26446	13082	4	0	12
22825	1588	15841870000000	26446	13082	5	0	12
22834	1588	16561870000000	26540	13130	9	0	12
22836	1588	16561907000000	26547	13134	1	0	12
22845	1588	16944799000000	28017	13857	3	0	13
22846	1588	16944811000000	28017	13857	4	0	13
22850	1588	17280530000000	8299	4297	2	0	\N
22853	1588	17281907000000	26548	13134	4	0	\N
22855	1588	17281909000000	26548	13134	5	0	\N
22864	1588	18001909000000	26863	13286	7	0	\N
22865	1588	18001934000000	26863	13286	8	0	\N
22866	1588	18215049000000	18231	9184	2	0	\N
22867	1588	18215049000000	18238	9187	2	0	\N
22869	1588	18215060000000	18231	9184	3	0	\N
22870	1588	18215060000000	18238	9187	3	0	\N
22872	1588	18420793975000	29563	14576	2	0	\N
22873	1588	18420794000000	28692	14165	3	0	\N
22874	1588	18420794000000	29214	14398	4	0	\N
22876	1588	18420804975000	29563	14576	3	0	\N
22878	1588	18420806000000	28692	14165	4	0	\N
22879	1588	18420807000000	29214	14398	5	0	\N
22886	1588	19440570000000	9782	5069	4	0	\N
22887	1588	19440570000000	10356	5288	0	0	\N
22888	1588	19440570000000	10357	5359	2	0	\N
22889	1588	19440570000000	10358	5300	0	0	\N
22890	1588	19440570000000	10361	5313	0	0	\N
22891	1588	19440570000000	10362	5327	0	0	\N
22892	1588	19440570000000	10363	5340	0	0	\N
22893	1588	19440570000000	10508	5429	1	0	\N
22895	1588	19440580000000	10508	5429	2	0	\N
22896	1588	19440590000000	10357	5359	3	0	\N
22898	1588	19440610000000	9782	5069	5	0	\N
22899	1588	19655072000000	18731	9439	5	0	\N
22900	1588	19655072000000	18768	9459	2	0	\N
22901	1588	19655072000000	18978	9572	1	0	\N
22903	1588	19655082000000	18978	9572	2	0	\N
22905	1588	19655083000000	18768	9459	3	0	\N
22906	1588	19655095000000	18731	9439	6	0	\N
22908	1588	19860916000000	29643	14618	3	0	\N
22910	1588	19860928000000	29643	14618	4	0	\N
22911	1588	20160590000000	11111	5714	5	0	\N
22912	1588	20160590000000	11223	5767	4	0	\N
22914	1588	20160630000000	11223	5767	5	0	\N
22915	1588	20160640000000	11111	5714	6	0	\N
22919	1588	20580927000000	29754	14665	8	0	\N
22921	1588	20580944000000	29754	14665	9	0	\N
22925	1588	21095095000000	19294	9727	3	0	\N
22926	1588	21095095000000	19339	9752	10	0	\N
22927	1588	21095095000000	19757	9915	0	0	\N
22929	1588	21095107000000	19294	9727	4	0	\N
22931	1588	21095123000000	19339	9752	11	0	\N
22932	1588	21301063000000	29969	14760	9	0	\N
22933	1588	21301063000000	30225	14863	11	0	\N
22934	1588	21301081000000	29969	14760	10	0	\N
22935	1588	21301085000000	30225	14863	12	0	\N
22944	1588	23040737000000	12043	6200	1	0	\N
22945	1588	23040737000000	12211	6291	1	0	\N
22947	1588	23040738000000	12043	6200	2	0	\N
22948	1588	23040738000000	12211	6291	2	0	\N
22954	1588	23975553000000	21130	10613	3	0	\N
22957	1588	23975565000000	21130	10613	4	0	\N
22958	1588	24695564000000	21405	10737	4	0	\N
22960	1588	24695577000000	21405	10737	5	0	\N
22963	1588	26135600000000	22344	11184	9	0	\N
22964	1588	26135600000000	22389	11209	3	0	\N
22966	1588	26135600000000	22639	11321	4	0	\N
22967	1588	26135612000000	22389	11209	4	0	\N
22969	1588	26135613000000	22639	11321	5	0	\N
22970	1588	26135627000000	22344	11184	10	0	\N
22972	1588	26855613000000	22645	11323	2	0	\N
22973	1588	26855624000000	22645	11323	3	0	\N
22975	1588	27575625000000	22744	11373	7	0	\N
22978	1588	27575650000000	22744	11373	8	0	\N
22979	1588	27576307000000	23174	11429	67	0	\N
22982	1588	28296307000000	23174	11429	126	0	\N
22983	1588	28296887000000	23174	11429	127	0	\N
22984	1588	29015648000000	23349	11652	4	0	\N
22862	1588	18000530000000	9581	4970	2	0	0
22863	1588	18000550000000	9581	4970	3	0	0
22880	1588	18720550000000	9645	5003	2	0	0
22881	1588	18720570000000	9645	5003	3	0	0
22894	1588	19440570000000	10510	5429	2	0	0
22913	1588	20160590000000	11682	6007	9	0	0
22916	1588	20160734000000	11682	6007	10	0	0
22923	1588	20880734000000	11694	6012	1	0	0
22924	1588	20880735000000	11694	6012	2	0	0
22936	1588	21600735000000	11906	6123	1	0	0
22940	1588	22320736000000	11982	6167	1	0	0
22941	1588	22320737000000	11982	6167	2	0	0
22946	1588	23040737000000	12272	6319	1	0	0
22949	1588	23040738000000	12272	6319	2	0	0
22953	1588	23759760000000	12543	6464	6	0	1
22856	1588	17495038000000	18040	9101	2	0	6
22857	1588	17495049000000	18040	9101	3	0	6
22868	1588	18215049000000	18462	9303	3	0	6
22871	1588	18215061000000	18462	9303	4	0	6
22883	1588	18935072000000	18727	9436	3	0	6
22902	1588	19655072000000	19007	9584	1	0	6
22904	1588	19655082000000	19007	9584	2	0	6
22917	1588	20375082000000	19245	9703	4	0	6
22918	1588	20375095000000	19245	9703	5	0	6
22930	1588	21095107000000	19758	9947	4	0	6
22938	1588	21815107000000	20037	10087	5	0	6
22939	1588	21815329000000	20037	10087	6	0	6
22942	1588	22535329000000	20943	10532	5	0	6
22950	1588	23255541000000	21067	10585	3	0	6
22951	1588	23255553000000	21067	10585	4	0	6
22955	1588	23975553000000	21153	10623	2	0	6
22956	1588	23975564000000	21153	10623	3	0	6
22959	1588	24695564000000	21954	10984	0	0	6
22962	1588	25415600000000	22213	11120	10	0	6
22965	1588	26135600000000	22638	11321	4	0	6
22968	1588	26135613000000	22638	11321	5	0	6
22971	1588	26855613000000	22643	11323	3	0	6
22974	1588	26855625000000	22643	11323	4	0	6
22977	1588	27575637000000	22820	11412	4	0	6
22980	1588	28295637000000	23173	11570	2	0	6
22981	1588	28295648000000	23173	11570	3	0	6
22852	1588	17281907000000	26547	13134	4	0	12
22858	1588	17664811000000	28062	13876	3	0	13
22859	1588	17664823000000	28062	13876	4	0	13
22860	1588	17700782000000	28663	14151	3	0	17
22861	1588	17700794000000	28663	14151	4	0	17
22875	1588	18420794000000	29564	14576	2	0	17
22884	1588	19140805000000	29609	14602	3	0	17
22885	1588	19140916000000	29609	14602	4	0	17
22907	1588	19860916000000	29642	14618	2	0	17
22909	1588	19860927000000	29642	14618	3	0	17
22920	1588	20580927000000	29877	14724	19	0	17
22986	1588	29015670000000	23349	11652	5	0	\N
22999	1588	33335770000000	24564	12212	2	0	\N
23000	1588	33335781000000	24564	12212	3	0	\N
23001	1588	66000003999992	25146	12477	4	0	\N
23004	1592	66000000	29198	14394	6	0	\N
23005	1592	66000000	29200	14394	6	0	\N
23006	1592	66000000	29201	14394	6	0	\N
23007	1592	66000000	29202	14394	6	0	\N
23010	1592	720009000000	18507	9037	0	0	\N
23011	1592	720009000000	18508	9042	0	0	\N
23014	1592	720066000000	29198	14394	9	0	\N
23015	1592	720066000000	29200	14394	9	0	\N
23016	1592	720066000000	29201	14394	9	0	\N
23017	1592	720066000000	29202	14394	9	0	\N
23018	1592	720068000000	29198	14394	10	0	\N
23019	1592	720068000000	29200	14394	10	0	\N
23020	1592	720068000000	29201	14394	10	0	\N
23021	1592	720068000000	29202	14394	10	0	\N
23022	1593	10000004	10725	5418	127	0	\N
23023	1593	200000002	21690	10865	13	0	\N
23028	1593	2160040000000	966	538	1	0	\N
23030	1593	2160050000000	966	538	2	0	\N
23034	1593	3600070000000	1774	952	1	0	\N
23035	1593	3600070000000	1855	989	1	0	\N
23037	1593	3600080000000	1774	952	2	0	\N
23038	1593	3600080000000	1855	989	2	0	\N
23040	1593	4320100000000	2882	1506	2	0	\N
23041	1593	4320100000000	2954	1537	1	0	\N
23043	1593	4320110000000	2954	1537	2	0	\N
23045	1593	4320120000000	2882	1506	3	0	\N
23046	1593	4940555124170	24144	11787	105	0	\N
23047	1593	4940555124194	24144	11787	110	0	\N
23052	1593	6480200000000	3311	1718	1	0	\N
23053	1593	6480200000000	3420	1778	2	0	\N
23055	1593	6480210000000	3311	1718	2	0	\N
23056	1593	6480220000000	3420	1778	3	0	\N
23059	1593	7749839000000	13220	6814	7	0	\N
23060	1593	7749839000000	13589	6989	5	0	\N
23063	1593	7749855000000	13220	6814	8	0	\N
23064	1593	7749862000000	13589	6989	6	0	\N
23067	1593	8469854000000	14065	7199	0	0	\N
23072	1593	9189867000000	14237	7268	7	0	\N
23075	1593	9189883000000	14237	7268	8	0	\N
23082	1593	10033432000000	23762	11785	105	0	\N
23087	1593	10752660000000	23354	11653	2	0	\N
23088	1593	10752660000000	23760	11832	6	0	\N
23090	1593	10752671000000	23354	11653	3	0	\N
23092	1593	10752684000000	23760	11832	7	0	\N
23093	1593	10753432000000	23762	11785	126	0	\N
23094	1593	10753452000000	23762	11785	127	0	\N
23095	1593	10754742000000	23964	11786	105	0	\N
23096	1593	10800260000000	5078	2636	2	0	\N
23097	1593	10800260000000	5314	2763	1	0	\N
23098	1593	10800260000000	5407	2814	0	0	\N
23099	1593	10800260000000	5630	2925	1	0	\N
23101	1593	10800270000000	5314	2763	2	0	\N
23102	1593	10800270000000	5630	2925	2	0	\N
23103	1593	10800271000000	5078	2636	3	0	\N
23104	1593	11349897000000	14668	7474	8	0	\N
23107	1593	11349968000000	14668	7474	9	0	\N
23110	1593	11474742000000	23964	11786	126	0	\N
23111	1593	11474942000000	23964	11786	127	0	\N
23114	1593	12069967000000	15031	7556	4	0	\N
23115	1593	12069967000000	15033	7646	44	0	\N
23118	1593	12069990000000	15031	7556	5	0	\N
23119	1593	12070182000000	15033	7646	45	0	\N
23120	1593	12192694000000	24209	12050	7	0	\N
23026	1593	1440030000000	869	482	1	0	0
23027	1593	1440040000000	869	482	2	0	0
23029	1593	2160040000000	1021	566	1	0	0
23031	1593	2160050000000	1021	566	2	0	0
23032	1593	2880050000000	1715	921	2	0	0
23036	1593	3600070000000	2089	1103	3	0	0
23039	1593	3600100000000	2089	1103	4	0	0
23042	1593	4320100000000	3196	1659	1	0	0
23044	1593	4320110000000	3196	1659	2	0	0
23048	1593	5040110000000	3203	1663	7	0	0
23050	1593	5760180000000	3213	1670	2	0	0
23051	1593	5760200000000	3213	1670	3	0	0
23054	1593	6480200000000	3580	1858	0	0	0
23057	1593	7200200000000	3769	1955	2	0	0
23065	1593	7920220000000	4036	2095	1	0	0
23066	1593	7920230000000	4036	2095	2	0	0
23070	1593	8640230000000	4454	2308	1	0	0
23071	1593	8640240000000	4454	2308	2	0	0
23076	1593	9360240000000	4650	2402	1	0	0
23083	1593	10080250000000	4720	2441	1	0	0
23084	1593	10080260000000	4720	2441	2	0	0
23100	1593	10800260000000	5662	2936	0	0	0
23112	1593	11520260000000	5765	2990	3	0	0
23113	1593	11520290000000	5765	2990	4	0	0
23012	1592	720010000000	8366	4335	2	0	0
23002	1591	720400000000	13731	7058	4	0	0
23003	1591	720413000000	13731	7058	5	0	0
23061	1593	7749839000000	14010	7180	6	0	4
23068	1593	8469854000000	14066	7199	4	0	4
23069	1593	8469867000000	14066	7199	5	0	4
23073	1593	9189867000000	14240	7268	6	0	4
23074	1593	9189873000000	14240	7268	7	0	4
23078	1593	9909873000000	14390	7343	3	0	4
23085	1593	10629885000000	14401	7348	3	0	4
23086	1593	10629897000000	14401	7348	4	0	4
23105	1593	11349897000000	14669	7474	7	0	4
23106	1593	11349967000000	14669	7474	8	0	4
23116	1593	12069967000000	15191	7740	2	0	4
23009	1592	720009000000	18506	9322	7	0	1
23013	1592	720034000000	18506	9322	8	0	1
23080	1593	10032638000000	23308	11631	4	0	8
23081	1593	10032660000000	23308	11631	5	0	8
22987	1588	29015672000000	23732	11822	6	0	6
22988	1588	29735672000000	23914	11900	3	0	6
22989	1588	29735684000000	23914	11900	4	0	6
22990	1588	30455684000000	23948	11916	0	0	6
23089	1593	10752660000000	23963	11924	3	0	8
22991	1588	31175684000000	24046	11966	3	0	6
22992	1588	31175696000000	24046	11966	4	0	6
23108	1593	11472672000000	24142	12018	4	0	8
23109	1593	11472694000000	24142	12018	5	0	8
22993	1588	31895696000000	24215	12052	3	0	6
22997	1588	32615708000000	24465	12167	8	0	6
22998	1588	32615770000000	24465	12167	9	0	6
22995	1588	32401760000000	24746	12288	8	0	7
22996	1588	32401813000000	24746	12288	9	0	7
23123	1593	12192719000000	24209	12050	8	0	\N
23124	1593	12195991999984	24144	11787	109	0	\N
23125	1593	12240290000000	5810	3014	1	0	\N
23126	1593	12240290000000	6169	3194	1	0	\N
23128	1593	12240300000000	5810	3014	2	0	\N
23129	1593	12240300000000	6169	3194	2	0	\N
23131	1593	12789978000000	15267	7777	5	0	\N
23134	1593	12790001000000	15267	7777	6	0	\N
23135	1593	12912715000000	24789	12309	4	0	\N
23136	1593	12912715000000	24805	12319	4	0	\N
23138	1593	12912728000000	24789	12309	5	0	\N
23139	1593	12912737000000	24805	12319	5	0	\N
23143	1593	13509989000000	15692	7956	0	0	\N
23150	1593	14229989000000	15808	7957	9	0	\N
23153	1593	14230133000000	15808	7957	10	0	\N
23159	1593	14950014000000	16146	8208	6	0	\N
23162	1593	14950038000000	16146	8208	7	0	\N
23166	1593	15670026000000	17028	8624	2	0	\N
23167	1593	15670026000000	17031	8624	2	0	\N
23169	1593	15670028000000	17028	8624	3	0	\N
23170	1593	15670028000000	17031	8624	3	0	\N
23172	1593	15792789000000	26715	13214	4	0	\N
23175	1593	15792802000000	26715	13214	5	0	\N
23176	1593	15792813000000	26976	13340	3	0	\N
23177	1593	15840510000000	7224	3734	2	0	\N
23178	1593	15840510000000	7440	3845	1	0	\N
23179	1593	15840510000000	7492	3874	1	0	\N
23180	1593	15840510000000	7559	3914	1	0	\N
23182	1593	15840520000000	7440	3845	2	0	\N
23183	1593	15840520000000	7492	3874	2	0	\N
23184	1593	15840520000000	7559	3914	2	0	\N
23186	1593	15840620000000	7224	3734	3	0	\N
23190	1593	16512813000000	26976	13340	4	0	\N
23194	1593	17110163000000	17342	8787	3	0	\N
23196	1593	17110175000000	17342	8787	4	0	\N
23200	1593	17280540000000	7979	4135	1	0	\N
23202	1593	17280550000000	7979	4135	2	0	\N
23206	1593	17952825000000	27740	13704	2	0	\N
23207	1593	17952825000000	28213	13949	2	0	\N
23208	1593	17952825000000	28367	14024	2	0	\N
23209	1593	17952825000000	28390	14033	3	0	\N
23211	1593	17952836000000	27740	13704	3	0	\N
23212	1593	17952836000000	28213	13949	3	0	\N
23213	1593	17952836000000	28367	14024	3	0	\N
23214	1593	17952846000000	28390	14033	4	0	\N
23216	1593	18000551000000	8627	4472	2	0	\N
23218	1593	18000571000000	8627	4472	3	0	\N
23225	1593	18720571000000	9591	4975	2	0	\N
23227	1593	18720591000000	9591	4975	3	0	\N
23229	1593	19270238000000	17794	8988	7	0	\N
23232	1593	19270263000000	17794	8988	8	0	\N
23236	1593	19440591000000	9967	5170	8	0	\N
23238	1593	19440662000000	9967	5170	9	0	\N
23243	1593	20160652000000	10067	5219	17	0	\N
23244	1593	20160652000000	10068	5221	3	0	\N
23246	1593	20160673000000	10068	5221	4	0	\N
23248	1593	20160822000000	10067	5219	18	0	\N
23253	1593	20832987000000	29920	14733	11	0	\N
23254	1593	20833874000000	29714	14572	25	0	\N
23141	1593	12960300000000	6330	3277	3	0	0
23142	1593	12960330000000	6330	3277	4	0	0
23148	1593	13680330000000	6566	3399	2	0	0
23149	1593	13680350000000	6566	3399	3	0	0
23157	1593	14400350000000	6808	3524	4	0	0
23164	1593	15120390000000	7160	3698	3	0	0
23165	1593	15120510000000	7160	3698	4	0	0
23181	1593	15840510000000	7600	3931	2	0	0
23185	1593	15840530000000	7600	3931	3	0	0
23192	1593	16560530000000	7855	4072	1	0	0
23201	1593	17280540000000	8086	4193	2	0	0
23203	1593	17280551000000	8086	4193	3	0	0
23217	1593	18000551000000	9004	4668	2	0	0
23219	1593	18000571000000	9004	4668	3	0	0
23228	1593	18720591000000	9602	4981	3	0	0
23235	1593	19440591000000	9966	5171	7	0	0
23237	1593	19440652000000	9966	5171	8	0	0
23245	1593	20160652000000	10113	5246	11	0	0
23247	1593	20160726000000	10113	5246	12	0	0
23256	1593	20880746000000	10161	5266	3	0	0
23132	1593	12789978000000	15460	7873	2	0	4
23133	1593	12789989000000	15460	7873	3	0	4
23144	1593	13509989000000	15693	7982	3	0	4
23145	1593	13510001000000	15693	7982	4	0	4
23152	1593	14230014000000	15809	8047	5	0	4
23160	1593	14950014000000	16775	8515	3	0	4
23161	1593	14950026000000	16775	8515	4	0	4
23168	1593	15670026000000	17158	8697	7	0	4
23187	1593	16390150000000	17294	8759	4	0	4
23188	1593	16390163000000	17294	8759	5	0	4
23195	1593	17110163000000	17452	8838	6	0	4
23197	1593	17110214000000	17452	8838	7	0	4
23204	1593	17830214000000	17681	8938	2	0	4
23220	1593	18550225000000	17749	8968	4	0	4
23221	1593	18550238000000	17749	8968	5	0	4
23230	1593	19270238000000	18143	9148	5	0	4
23231	1593	19270261000000	18143	9148	6	0	4
23239	1593	19990261000000	18158	9154	7	0	4
23249	1593	20710286000000	18242	9188	5	0	4
23250	1593	20710309000000	18242	9188	6	0	4
23121	1593	12192694000000	24454	12161	3	0	8
23122	1593	12192715000000	24454	12161	4	0	8
23140	1593	12912740000000	25207	12504	8	0	8
23146	1593	13632740000000	26156	12929	5	0	8
23147	1593	13632754000000	26156	12929	6	0	8
23154	1593	14352754000000	26355	13032	2	0	8
23155	1593	14352765000000	26355	13032	3	0	8
23163	1593	15072789000000	26704	13208	7	0	8
23173	1593	15792789000000	26947	13329	3	0	8
23174	1593	15792801000000	26947	13329	4	0	8
23189	1593	16512801000000	27162	13431	3	0	8
23191	1593	16512813000000	27162	13431	4	0	8
23199	1593	17232825000000	27618	13650	4	0	8
23210	1593	17952825000000	28655	14148	6	0	8
23215	1593	17952858000000	28655	14148	7	0	8
23222	1593	18672858000000	28953	14279	2	0	8
23224	1593	18672880000000	29073	14334	2	0	8
23233	1593	19392880000000	29073	14334	4	0	8
23234	1593	19392881000000	29073	14334	5	0	8
23241	1593	20112881000000	29189	14390	2	0	8
23242	1593	20112892000000	29189	14390	3	0	8
23252	1593	20832904000000	29369	14475	4	0	8
23259	1593	21552904000000	29423	14506	4	0	\N
23260	1593	21552904000000	29713	14650	30	0	\N
23261	1593	21552904000000	29918	14740	4	0	\N
23263	1593	21552917000000	29918	14740	5	0	\N
23265	1593	21552926000000	29423	14506	5	0	\N
23266	1593	21552961000000	29713	14650	31	0	\N
23267	1593	21552987000000	29920	14733	78	0	\N
23268	1593	21553052307906	29920	14733	80	1	\N
23269	1593	21553484282802	30001	14734	55	0	\N
23270	1593	21553874000000	29714	14572	126	0	\N
23271	1593	21554874000000	29714	14572	127	0	\N
23272	1593	21600746000000	10188	5277	5	0	\N
23274	1593	21600796000000	10188	5277	6	0	\N
23276	1593	21601066000000	10725	5418	23	0	\N
23281	1593	22273484282802	30001	14734	121	0	\N
23282	1593	22273546812190	30001	14734	123	1	\N
23283	1593	22274117027394	30223	14735	51	1	\N
23284	1593	22320826000000	10723	5535	2	0	\N
23286	1593	22320846000000	10723	5535	3	0	\N
23288	1593	22321066000000	10725	5418	126	0	\N
23289	1593	22322435999998	10809	5419	23	0	\N
23292	1593	22870462000000	18941	9556	4	0	\N
23293	1593	22994117027394	30223	14735	97	0	\N
23294	1593	22994439081402	30223	14735	101	0	\N
23297	1593	23042435999998	10809	5419	126	0	\N
23298	1593	23043455999998	10809	5419	127	0	\N
23301	1593	23590462000000	18941	9556	5	0	\N
23304	1593	24310453000000	19798	9971	8	0	\N
23307	1593	24310866000000	19798	9971	9	0	\N
23308	1593	24480878000000	11683	6007	9	0	\N
23311	1593	24480890000000	11880	6105	2	0	\N
23312	1593	24481022000000	11683	6007	10	0	\N
23315	1593	25031195000000	20596	10332	85	0	\N
23316	1593	25200879000000	11934	6118	32	0	\N
23317	1593	25200890000000	11880	6105	3	0	\N
23318	1593	25200911000000	11934	6118	33	0	\N
23321	1593	25751195000000	20596	10332	126	0	\N
23322	1593	25751235000000	20596	10332	127	0	\N
23323	1593	25920911000000	11952	6119	20	0	\N
23324	1593	25940931000000	11952	6119	21	0	\N
23325	1593	25940968000000	12067	6120	28	0	\N
23326	1593	26470487000000	21061	10507	67	0	\N
23327	1593	26470487000000	21063	10583	10	0	\N
23328	1593	26470487000000	21297	10694	3	0	\N
23330	1593	26470499000000	21297	10694	4	0	\N
23332	1593	26470553000000	21690	10865	9	0	\N
23334	1593	26470659000000	21063	10583	11	0	\N
23335	1593	26471129000000	21061	10507	68	0	\N
23336	1593	26660968000000	12067	6120	88	0	\N
23337	1593	26661036000000	12067	6120	89	0	\N
23338	1593	26661120000000	12185	6121	66	0	\N
23339	1593	27190499000000	21635	10839	5	0	\N
23340	1593	27190499000000	21636	10839	6	0	\N
23341	1593	27190540000000	21635	10839	6	0	\N
23342	1593	27190541000000	21636	10839	7	0	\N
23343	1593	27190553000000	21690	10865	12	0	\N
23346	1593	27381120000000	12185	6121	103	0	\N
23347	1593	27381165000000	12185	6121	104	0	\N
23355	1593	30070617000000	22919	11452	29	0	\N
23358	1593	30070718000000	22919	11452	30	0	\N
23359	1593	30790630000000	22925	11458	4	0	\N
23362	1593	30790643000000	22925	11458	5	0	\N
23363	1593	30790718000000	22922	11453	4	0	\N
23364	1593	30790731000000	22922	11453	5	0	\N
23365	1593	30790871000000	22953	11454	14	0	\N
23366	1593	31510642000000	23026	11498	3	0	\N
23367	1593	31510642000000	23066	11516	4	0	\N
23368	1593	31510654000000	23026	11498	4	0	\N
23369	1593	31510655000000	23066	11516	5	0	\N
23370	1593	31510871000000	22953	11454	53	0	\N
23371	1593	31510909000000	22953	11454	54	0	\N
23372	1593	32230909000000	23020	11455	58	0	\N
23373	1593	32231408000000	23020	11455	59	0	\N
23376	1594	721497000000	20178	10161	4	0	\N
23378	1594	721510000000	20178	10161	5	0	\N
23384	1594	1441521000000	20690	10407	2	0	\N
23385	1594	1441521000000	20691	10407	3	0	\N
23387	1594	1441532000000	20690	10407	3	0	\N
23389	1594	1441533000000	20691	10407	4	0	\N
23382	1594	1440020000000	294	169	1	0	0
23383	1594	1440030000000	294	169	2	0	0
23380	1594	721710000000	9927	5152	5	0	5
23381	1594	722030000000	9927	5152	6	0	5
23390	1594	1442030000000	9944	5161	2	0	5
23392	1594	2064650000000	10096	5237	4	0	5
23273	1593	21600746000000	10299	5328	7	0	0
23275	1593	21600826000000	10299	5328	8	0	0
23285	1593	22320826000000	10808	5578	3	0	0
23287	1593	22320856000000	10808	5578	4	0	0
23296	1593	23040867000000	11307	5807	3	0	0
23302	1593	23760867000000	11319	5812	2	0	0
23303	1593	23760878000000	11319	5812	3	0	0
23309	1593	24480878000000	11741	6034	1	0	0
23257	1593	21430309000000	18358	9252	2	0	4
23258	1593	21430320000000	18358	9252	3	0	4
23277	1593	22150320000000	18614	9378	17	0	4
23278	1593	22150409000000	18614	9378	18	0	4
23290	1593	22870409000000	18733	9440	4	0	4
23299	1593	23590431000000	19021	9589	4	0	4
23300	1593	23590453000000	19021	9589	5	0	4
23305	1593	24310453000000	19888	10018	3	0	4
23306	1593	24310465000000	19888	10018	4	0	4
23313	1593	25030465000000	20481	10314	2	0	4
23377	1594	721497000000	20520	10329	6	0	10
23379	1594	721521000000	20520	10329	7	0	10
23319	1593	25750476000000	20597	10360	2	0	4
23320	1593	25750487000000	20597	10360	3	0	4
23388	1594	1441532000000	20858	10483	3	0	10
23329	1593	26470487000000	21299	10694	3	0	4
23331	1593	26470499000000	21299	10694	4	0	4
23333	1593	26470553000000	21692	10865	9	0	4
23344	1593	27190553000000	21692	10865	12	0	4
23348	1593	27910555000000	21814	10918	6	0	4
23349	1593	27910579000000	21814	10918	7	0	4
23350	1593	28630579000000	22104	11054	7	0	4
23351	1593	28630604000000	22104	11054	8	0	4
23352	1593	28630615000000	22362	11192	2	0	4
23354	1593	29350617000000	22362	11192	6	0	4
23356	1593	30070617000000	22921	11457	4	0	4
23357	1593	30070630000000	22921	11457	5	0	4
23360	1593	30790630000000	22954	11468	3	0	4
23262	1593	21552904000000	30000	14772	10	0	8
23264	1593	21552922925000	30000	14772	11	1	8
23279	1593	22272922925000	30222	14861	8	0	8
23280	1593	22272939925000	30222	14861	9	0	8
23394	1594	2160030000000	426	242	1	0	\N
23395	1594	2160030000000	751	420	1	0	\N
23396	1594	2160030000000	1652	890	1	0	\N
23398	1594	2160040000000	426	242	2	0	\N
23399	1594	2160040000000	751	420	2	0	\N
23400	1594	2160040000000	1652	890	2	0	\N
23404	1594	2162050000000	10097	5237	4	0	\N
23405	1594	2162360000000	10097	5237	5	0	\N
23406	1594	2784960000000	10498	5424	11	0	\N
23407	1594	2784960000000	10499	5424	11	0	\N
23408	1594	2784960000000	10589	5470	0	0	\N
23409	1594	2784960000000	10590	5470	4	0	\N
23411	1594	2784960000000	10688	5518	2	0	\N
23412	1594	2784980000000	10688	5518	3	0	\N
23413	1594	2785000000000	10590	5470	5	0	\N
23414	1594	2785070000000	10498	5424	12	0	\N
23415	1594	2785070000000	10499	5424	12	0	\N
23418	1594	2881566000000	21041	10574	3	0	\N
23419	1594	2881566000000	21133	10613	3	0	\N
23421	1594	2881566000000	21335	10709	4	0	\N
23423	1594	2881578000000	21041	10574	4	0	\N
23424	1594	2881578000000	21133	10613	4	0	\N
23425	1594	2881778000000	21335	10709	5	0	\N
23430	1594	3601568000000	21376	10725	4	0	\N
23432	1594	3601568000000	21570	10814	3	0	\N
23434	1594	3601580000000	21570	10814	4	0	\N
23435	1594	3601581000000	21376	10725	5	0	\N
23438	1594	4320170000000	3082	1600	1	0	\N
23440	1594	4320180000000	3082	1600	2	0	\N
23442	1594	4321579000000	21735	10886	9	0	\N
23444	1594	4321588000000	21735	10886	10	0	\N
23446	1594	4945000000000	10982	5658	2	0	\N
23448	1594	4945020000000	10982	5658	3	0	\N
23450	1594	5040180000000	3375	1756	2	0	\N
23452	1594	5040200000000	3375	1756	3	0	\N
23456	1594	5665020000000	11215	5760	3	0	\N
23459	1594	5665050000000	11215	5760	4	0	\N
23466	1594	6480210000000	4194	2183	6	0	\N
23469	1594	6480360000000	4194	2183	7	0	\N
23472	1594	7105032000000	11659	5996	1	0	\N
23474	1594	7105033000000	11659	5996	2	0	\N
23484	1594	7921639000000	22288	11156	3	0	\N
23486	1594	7921651000000	22288	11156	4	0	\N
23488	1594	8545037000000	12379	6383	1	0	\N
23489	1594	8545037000000	12436	6411	0	0	\N
23490	1594	8545037000000	12878	6640	2	0	\N
23492	1594	8545038000000	12379	6383	2	0	\N
23493	1594	8545048000000	12878	6640	3	0	\N
23499	1594	9260664124250	25313	12558	7	0	\N
23504	1594	9361663000000	22476	11246	6	0	\N
23507	1594	9361705000000	22476	11246	7	0	\N
23510	1594	10080270000000	5639	2928	0	0	\N
23511	1594	10080270000000	5640	2928	0	0	\N
23516	1594	10705120000000	13357	6883	4	0	\N
23517	1594	10705120000000	13358	6883	2	0	\N
23518	1594	10705120000000	13387	6899	3	0	\N
23520	1594	10705131000000	13358	6883	3	0	\N
23521	1594	10705132000000	13387	6899	4	0	\N
23522	1594	10705133000000	13357	6883	5	0	\N
23524	1594	10800290000000	6335	3279	1	0	\N
23525	1594	10800290000000	6486	3361	2	0	\N
23527	1594	10800300000000	6335	3279	2	0	\N
23528	1594	10800310000000	6486	3361	3	0	\N
23416	1594	2880040000000	1898	1011	1	0	0
23417	1594	2880050000000	1898	1011	2	0	0
23428	1594	3600050000000	3058	1589	3	0	0
23429	1594	3600170000000	3058	1589	4	0	0
23439	1594	4320170000000	3363	1749	1	0	0
23451	1594	5040180000000	3379	1758	2	0	0
23453	1594	5040200000000	3379	1758	3	0	0
23460	1594	5760200000000	3969	2062	1	0	0
23461	1594	5760210000000	3969	2062	2	0	0
23467	1594	6480210000000	4197	2185	2	0	0
23476	1594	7200230000000	4605	2383	1	0	0
23477	1594	7200240000000	4605	2383	2	0	0
23482	1594	7920240000000	4620	2392	1	0	0
23483	1594	7920250000000	4620	2392	2	0	0
23496	1594	8640260000000	4681	2419	2	0	0
23502	1594	9360260000000	5222	2715	1	0	0
23503	1594	9360270000000	5222	2715	2	0	0
23512	1594	10080270000000	5780	2999	2	0	0
23513	1594	10080290000000	5780	2999	3	0	0
23393	1594	2064960000000	10096	5237	5	0	5
23410	1594	2784960000000	10687	5518	0	0	5
23426	1594	3504960000000	10756	5552	2	0	5
23427	1594	3504980000000	10756	5552	3	0	5
23436	1594	4224980000000	10872	5610	2	0	5
23447	1594	4945000000000	11132	5722	2	0	5
23449	1594	4945020000000	11132	5722	3	0	5
23457	1594	5665020000000	11346	5827	2	0	5
23458	1594	5665031000000	11346	5827	3	0	5
23465	1594	6385032000000	11639	5990	2	0	5
23473	1594	7105032000000	11829	6080	2	0	5
23475	1594	7105034000000	11829	6080	3	0	5
23480	1594	7825034000000	12367	6378	3	0	5
23481	1594	7825037000000	12367	6378	4	0	5
23494	1594	8545092000000	13176	6788	11	0	5
23500	1594	9265092000000	13187	6795	7	0	5
23501	1594	9265108000000	13187	6795	8	0	5
23508	1594	9985108000000	13270	6835	3	0	5
23509	1594	9985120000000	13270	6835	4	0	5
23523	1594	10705149000000	13960	7154	12	0	5
23402	1594	2161532000000	20946	10534	7	0	10
23403	1594	2161566000000	20946	10534	8	0	10
23420	1594	2881566000000	21334	10709	2	0	10
23431	1594	3601568000000	21567	10814	2	0	10
23433	1594	3601579000000	21567	10814	3	0	10
23443	1594	4321579000000	21772	10901	3	0	10
23445	1594	4321591000000	21772	10901	4	0	10
23454	1594	5041591000000	21838	10930	3	0	10
23462	1594	5761603000000	21987	10993	3	0	10
23463	1594	5761615000000	21987	10993	4	0	10
23470	1594	6481615000000	22059	11030	3	0	10
23471	1594	6481627000000	22059	11030	4	0	10
23478	1594	7201627000000	22190	11106	3	0	10
23485	1594	7921639000000	22351	11188	3	0	10
23487	1594	7921651000000	22351	11188	4	0	10
23497	1594	8641651000000	22394	11211	3	0	10
23498	1594	8641663000000	22394	11211	4	0	10
23506	1594	9361687000000	22874	11435	7	0	10
23514	1594	10081687000000	23355	11653	2	0	10
23515	1594	10081698000000	23355	11653	3	0	10
23534	1594	11520310000000	7209	3726	1	0	\N
23535	1594	11520310000000	7299	3771	0	0	\N
23536	1594	11520310000000	7300	3771	3	0	\N
23538	1594	11520320000000	7209	3726	2	0	\N
23540	1594	11520340000000	7300	3771	4	0	\N
23543	1594	12145164000000	14123	7218	4	0	\N
23545	1594	12145164000000	14634	7276	0	0	\N
23546	1594	12145164000000	14635	7290	0	0	\N
23548	1594	12145177000000	14123	7218	5	0	\N
23551	1594	12241732000000	24297	12053	8	0	\N
23554	1594	12241843000000	24297	12053	9	0	\N
23559	1594	12961756000000	24324	12097	5	0	\N
23560	1594	12961756000000	24560	12209	1	0	\N
23562	1594	12961766000000	24560	12209	2	0	\N
23564	1594	12961780000000	24324	12097	6	0	\N
23566	1594	13585197000000	14556	7423	3	0	\N
23567	1594	13585197000000	14557	7423	3	0	\N
23568	1594	13585197000000	14573	7430	2	0	\N
23569	1594	13585197000000	14610	7448	11	0	\N
23570	1594	13585197000000	14967	7624	1	0	\N
23572	1594	13585207000000	14967	7624	2	0	\N
23573	1594	13585208000000	14573	7430	3	0	\N
23575	1594	13585209000000	14556	7423	4	0	\N
23576	1594	13585209000000	14557	7423	4	0	\N
23578	1594	13585244000000	14610	7448	12	0	\N
23581	1594	13681767000000	24724	12278	44	0	\N
23582	1594	13681767000000	24797	12313	4	0	\N
23583	1594	13681780000000	24797	12313	5	0	\N
23586	1594	13682108000000	24724	12278	45	0	\N
23591	1594	14401828000000	25005	12405	7	0	\N
23594	1594	14401855000000	25005	12405	8	0	\N
23595	1594	15025219000000	15260	7773	2	0	\N
23597	1594	15025230000000	15260	7773	3	0	\N
23601	1594	15121840000000	25313	12558	5	0	\N
23602	1594	15121840000000	25318	12558	5	0	\N
23604	1594	15121854000000	25318	12558	6	0	\N
23608	1594	15840420000000	9214	4778	4	0	\N
23609	1594	15840420000000	9272	4807	3	0	\N
23611	1594	15840450000000	9272	4807	4	0	\N
23613	1594	15840460000000	9214	4778	5	0	\N
23614	1594	15841874000000	26234	12971	7	0	\N
23615	1594	15841874000000	26619	13168	8	0	\N
23617	1594	15841891000000	26619	13168	9	0	\N
23618	1594	15841899000000	26234	12971	8	0	\N
23624	1594	16561899000000	27033	13368	3	0	\N
23627	1594	16561911000000	27033	13368	4	0	\N
23628	1594	17185303000000	15876	8075	4	0	\N
23629	1594	17185303000000	17470	8831	0	0	\N
23630	1594	17185303000000	17471	8842	0	0	\N
23631	1594	17185303000000	17473	8844	0	0	\N
23632	1594	17185303000000	17474	8846	29	0	\N
23633	1594	17185303000000	17567	8892	3	0	\N
23634	1594	17185303000000	17666	8930	2	0	\N
23635	1594	17185303000000	17800	8992	3	0	\N
23636	1594	17185303000000	17803	8992	1	0	\N
23637	1594	17185303000000	17924	9042	3	0	\N
23638	1594	17185303000000	18081	9118	3	0	\N
23639	1594	17185303000000	18259	9196	3	0	\N
23640	1594	17185303000000	18656	9401	6	0	\N
23642	1594	17185313000000	17803	8992	2	0	\N
23644	1594	17185314000000	17666	8930	3	0	\N
23645	1594	17185315000000	17567	8892	4	0	\N
23646	1594	17185315000000	17800	8992	4	0	\N
23647	1594	17185315000000	17924	9042	4	0	\N
23648	1594	17185315000000	18081	9118	4	0	\N
23649	1594	17185315000000	18259	9196	4	0	\N
23650	1594	17185316000000	15876	8075	5	0	\N
23651	1594	17185327000000	18656	9401	7	0	\N
23652	1594	17185539000000	17474	8846	30	0	\N
23655	1594	17281901000000	27331	13509	3	0	\N
23657	1594	17281913000000	27331	13509	4	0	\N
23659	1594	17905313000000	18755	9454	2	0	\N
23660	1594	17905313000000	19510	9832	4	0	\N
23662	1594	17905324000000	18755	9454	3	0	\N
23663	1594	17905326000000	19510	9832	5	0	\N
23539	1594	11520330000000	7427	3838	3	0	0
23549	1594	12240330000000	7582	3921	1	0	0
23550	1594	12240340000000	7582	3921	2	0	0
23557	1594	12960340000000	8531	4419	2	0	0
23558	1594	12960360000000	8531	4419	3	0	0
23580	1594	13680380000000	8732	4528	3	0	0
23589	1594	14400380000000	8856	4588	2	0	0
23590	1594	14400400000000	8856	4588	3	0	0
23599	1594	15120400000000	9135	4732	2	0	0
23600	1594	15120420000000	9135	4732	3	0	0
23612	1594	15840450000000	9390	4871	4	0	0
23622	1594	16560450000000	9534	4944	2	0	0
23623	1594	16560470000000	9534	4944	3	0	0
23653	1594	17280470000000	9559	4956	4	0	0
23532	1594	11425149000000	14102	7210	6	0	5
23533	1594	11425164000000	14102	7210	7	0	5
23544	1594	12145164000000	14520	7404	2	0	5
23547	1594	12145175000000	14520	7404	3	0	5
23555	1594	12865175000000	14537	7414	4	0	5
23571	1594	13585197000000	14973	7628	2	0	5
23574	1594	13585208000000	14973	7628	3	0	5
23577	1594	13585218000000	14992	7637	1	0	5
23587	1594	14305218000000	14992	7637	3	0	5
23588	1594	14305219000000	14992	7637	4	0	5
23598	1594	15025249000000	15569	7924	4	0	5
23606	1594	15745249000000	15687	7980	3	0	5
23607	1594	15745261000000	15687	7980	4	0	5
23620	1594	16465261000000	15835	8056	6	0	5
23641	1594	17185303000000	18709	9425	1	0	5
23643	1594	17185313000000	18709	9425	2	0	5
23661	1594	17905313000000	19980	10061	6	0	5
23664	1594	17905337000000	19980	10061	7	0	5
23530	1594	10801698000000	23385	11669	2	0	10
23541	1594	11521709000000	24172	12031	5	0	10
23542	1594	11521732000000	24172	12031	6	0	10
23552	1594	12241732000000	24299	12084	6	0	10
23553	1594	12241756000000	24299	12084	7	0	10
23561	1594	12961756000000	24561	12209	2	0	10
23565	1594	12961827000000	24871	12348	15	0	10
23584	1594	13681827000000	24871	12348	17	0	10
23585	1594	13681828000000	24871	12348	18	0	10
23592	1594	14401828000000	25044	12425	3	0	10
23603	1594	15121840000000	26001	12850	7	0	10
23605	1594	15121874000000	26001	12850	8	0	10
23616	1594	15841874000000	26897	13301	7	0	10
23619	1594	15841899000000	26897	13301	8	0	10
23625	1594	16561899000000	27282	13485	2	0	10
23656	1594	17281901000000	27458	13571	14	0	10
23658	1594	17281933000000	27458	13571	15	0	10
23669	1594	18720550000000	9729	5041	13	0	\N
23670	1594	18720950000000	9729	5041	14	0	\N
23673	1594	19441967000000	28160	13925	7	0	\N
23676	1594	19442001000000	28160	13925	8	0	\N
23683	1596	720000000000	71	41	1	0	\N
23685	1596	720010000000	71	41	2	0	\N
23691	1596	1440020000000	10642	5497	2	0	\N
23694	1596	1440040000000	10642	5497	3	0	\N
23704	1596	2880050000000	1328	731	1	0	\N
23706	1596	2880060000000	1328	731	2	0	\N
23712	1596	3600070000000	1562	850	1	0	\N
23713	1596	3600070000000	1766	947	0	0	\N
23715	1596	3600080000000	1562	850	2	0	\N
23717	1596	3600084000000	21700	10869	2	0	\N
23720	1596	3600095000000	21700	10869	3	0	\N
23723	1596	3600196000000	23819	11857	7	0	\N
23725	1596	4320096000000	22576	11293	17	0	\N
23726	1596	4320096000000	22878	11436	4	0	\N
23729	1596	4320109000000	22878	11436	5	0	\N
23733	1596	4320203000000	22576	11293	18	0	\N
23734	1596	5040107000000	24406	12136	2	0	\N
23737	1596	5040118000000	24406	12136	3	0	\N
23740	1596	5040144000000	25088	12454	6	0	\N
23743	1596	5760110000000	2683	1410	1	0	\N
23745	1596	5760120000000	2683	1410	2	0	\N
23747	1596	5760120000000	25062	12437	3	0	\N
23750	1596	5760132000000	25062	12437	4	0	\N
23751	1596	5760144000000	25088	12454	7	0	\N
23752	1596	5760172000000	12050	6202	1	0	\N
23754	1596	5760173000000	12050	6202	2	0	\N
23757	1596	6480120000000	2893	1510	1	0	\N
23759	1596	6480130000000	2893	1510	2	0	\N
23766	1596	7200255000002	25893	12797	2	0	\N
23768	1596	7200266000002	25893	12797	3	0	\N
23780	1596	8640317000002	27221	13462	3	0	\N
23782	1596	9360120000000	3864	2006	3	0	\N
23783	1596	9360120000000	3876	2013	1	0	\N
23784	1596	9360120000000	4000	2076	1	0	\N
23785	1596	9360120000000	4019	2084	1	0	\N
23787	1596	9360130000000	3876	2013	2	0	\N
23788	1596	9360130000000	4000	2076	2	0	\N
23789	1596	9360130000000	4019	2084	2	0	\N
23791	1596	9360150000000	3864	2006	4	0	\N
23794	1596	9360317000002	27221	13462	4	0	\N
23690	1596	1440020000000	709	397	1	0	0
23693	1596	1440030000000	709	397	2	0	0
23697	1596	2160030000000	1184	654	2	0	0
23699	1596	2160050000000	1184	654	3	0	0
23705	1596	2880050000000	1442	785	2	0	0
23714	1596	3600070000000	2010	1062	1	0	0
23716	1596	3600080000000	2010	1062	2	0	0
23724	1596	4320080000000	2312	1210	3	0	0
23730	1596	4320110000000	2312	1210	4	0	0
23736	1596	5040110000000	2601	1369	0	0	0
23746	1596	5760120000000	2783	1456	2	0	0
23758	1596	6480120000000	3535	1834	0	0	0
23764	1596	7200120000000	3604	1871	0	0	0
23771	1596	7920120000000	3645	1892	0	0	0
23786	1596	9360120000000	4024	2089	1	0	0
23790	1596	9360130000000	4024	2089	2	0	0
23797	1596	10080130000000	4794	2480	1	0	0
23798	1596	10080140000000	4794	2480	2	0	0
23665	1594	18000510000000	9665	5016	4	0	0
23687	1596	1308879152658	10207	5286	2	0	10
23688	1596	1308899152658	10207	5286	3	0	10
23692	1596	1440020000000	10822	5584	3	0	11
23696	1596	1440050000000	10822	5584	4	0	11
23700	1596	2160050000000	10823	5585	3	0	11
23708	1596	2880080000000	10829	5588	1	0	11
23711	1596	2880090000000	10829	5588	2	0	11
23719	1596	3600090000000	11149	5729	2	0	11
23722	1596	3600110000000	11149	5729	3	0	11
23732	1596	4320171000000	11267	5789	8	0	11
23741	1596	5040171000000	11654	5994	1	0	11
23742	1596	5040172000000	11654	5994	2	0	11
23753	1596	5760172000000	12058	6206	1	0	11
23755	1596	5760173000000	12058	6206	2	0	11
23761	1596	6480177000000	12166	6264	5	0	11
23765	1596	7200177000000	12308	6340	2	0	11
23770	1596	7200278000000	12308	6340	3	0	11
23773	1596	7920278000000	12787	6592	6	0	11
23775	1596	7920311000000	12787	6592	7	0	11
23781	1596	8640322000000	12802	6602	3	0	11
23795	1596	9360322000000	12861	6632	8	0	11
23796	1596	9360366000000	12861	6632	9	0	11
23689	1596	1440000000000	20405	10280	12	0	16
23698	1596	2160048000000	21214	10652	2	0	16
23701	1596	2160059000000	21214	10652	3	0	16
23703	1596	2160082000000	21447	10758	5	0	16
23709	1596	2880082000000	21447	10758	8	0	16
23710	1596	2880084000000	21447	10758	9	0	16
23721	1596	3600096000000	22549	11281	4	0	16
23727	1596	4320096000000	24069	11979	2	0	16
23728	1596	4320107000000	24069	11979	3	0	16
23735	1596	5040107000000	24921	12373	4	0	16
23738	1596	5040120000000	24921	12373	5	0	16
23748	1596	5760130000000	25145	12476	4	0	16
23749	1596	5760130000002	25145	12476	5	0	16
23762	1596	6480230000002	25429	12600	7	0	16
23763	1596	6480255000002	25429	12600	8	0	16
23769	1596	7200267000002	26561	13142	4	0	16
23772	1596	7920267000002	26687	13199	8	0	16
23774	1596	7920293000002	26687	13199	9	0	16
23777	1596	8640293000002	27175	13440	3	0	16
23778	1596	8640305000002	27175	13440	4	0	16
23668	1594	18001944000000	27769	13718	3	0	10
23671	1594	18721944000000	28152	13920	5	0	10
23672	1594	18721967000000	28152	13920	6	0	10
23792	1596	9360305000002	28211	13948	2	0	16
23793	1596	9360316000002	28211	13948	3	0	16
23800	1596	10080329000002	28528	14095	5	0	16
23674	1594	19441967000000	29359	14469	2	0	10
23675	1594	19441978000000	29359	14469	3	0	10
23677	1594	20161978000000	29435	14511	3	0	10
23679	1594	20881990000000	29659	14628	15	0	10
23680	1594	20882023000000	29659	14628	16	0	10
23681	1594	21602023000000	30145	14832	10	0	10
23682	1594	21602042000000	30145	14832	11	0	10
23802	1596	10080366000000	12876	6639	4	0	\N
23803	1596	10080366000000	13001	6701	2	0	\N
23805	1596	10080377000000	13001	6701	3	0	\N
23807	1596	10080388000000	12876	6639	5	0	\N
23815	1596	10800495000000	14734	7291	0	0	\N
23818	1596	11520341000002	28657	14148	6	0	\N
23819	1596	11520341000002	28771	14192	3	0	\N
23820	1596	11520341000002	29458	14527	7	0	\N
23821	1596	11520341000002	29475	14536	7	0	\N
23822	1596	11520341000002	29828	14697	9	0	\N
23823	1596	11520341000002	30010	14777	9	0	\N
23824	1596	11520341000002	30205	14857	12	0	\N
23825	1596	11520359000002	29828	14697	10	0	\N
23826	1596	11520359000002	30010	14777	10	0	\N
23827	1596	11520362000002	28771	14192	4	0	\N
23828	1596	11520370500002	29458	14527	8	0	\N
23829	1596	11520374000002	28657	14148	7	0	\N
23830	1596	11520375000002	29475	14536	8	0	\N
23831	1596	11520386000002	30205	14857	13	0	\N
23836	1596	12240517000000	14979	7632	2	0	\N
23838	1596	12240528000000	14979	7632	3	0	\N
23840	1596	12849160000000	6277	3251	1	0	\N
23842	1596	12849170000000	6277	3251	2	0	\N
23846	1596	13139140000000	7641	3953	1	0	\N
23848	1596	13139150000000	7641	3953	2	0	\N
23853	1596	14400551000000	15526	7901	2	0	\N
23854	1596	14400551000000	15976	8047	2	0	\N
23857	1596	14400562000000	15526	7901	3	0	\N
23858	1596	14400652000000	15976	8047	3	0	\N
23861	1596	15120553000000	16284	8275	3	0	\N
23863	1596	15120565000000	16284	8275	4	0	\N
23865	1596	15277555000000	8968	4651	4	0	\N
23866	1596	15277555000000	9154	4743	2	0	\N
23868	1596	15277575000000	9154	4743	3	0	\N
23870	1596	15277595000000	8968	4651	5	0	\N
23871	1596	15840565000000	16846	8548	3	0	\N
23872	1596	15840565000000	17095	8663	5	0	\N
23874	1596	15840577000000	16846	8548	4	0	\N
23875	1596	15840588000000	17095	8663	6	0	\N
23881	1596	16717615000000	9605	4983	6	0	\N
23884	1596	16717657000000	9605	4983	7	0	\N
23885	1596	17280726000000	17560	8889	3	0	\N
23886	1596	17280726000000	18163	9156	4	0	\N
23888	1596	17280738000000	17560	8889	4	0	\N
23890	1596	17280739000000	18163	9156	5	0	\N
23891	1596	17437635000000	9926	5152	5	0	\N
23892	1596	17437955000000	9926	5152	6	0	\N
23893	1596	18000738000000	18347	9244	4	0	\N
23896	1596	18000769000000	18347	9244	5	0	\N
23897	1596	18000770000000	18595	9370	3	0	\N
23899	1596	18720770000000	18595	9370	6	0	\N
23900	1596	18720772000000	18595	9370	7	0	\N
23910	1597	727012000000	25018	12412	0	0	\N
23913	1597	1440035000000	13443	6927	6	0	\N
23915	1597	2160035000000	13443	6927	7	0	\N
23917	1598	720000000000	2813	1471	1	0	\N
23918	1598	720000000000	4032	2093	1	0	\N
23920	1598	720000000000	23527	11727	0	0	\N
23922	1598	720010000000	2813	1471	2	0	\N
23923	1598	720010000000	4032	2093	2	0	\N
23926	1598	1440020000000	6957	3589	2	0	\N
23928	1598	1440040000000	6957	3589	3	0	\N
23911	1597	1440010000000	1632	879	1	0	0
23912	1597	1440020000000	1632	879	2	0	0
23919	1598	720000000000	4593	2375	2	0	0
23924	1598	720020000000	4593	2375	3	0	0
23808	1596	10800140000000	4806	2487	1	0	0
23816	1596	11520150000000	6043	3139	1	0	0
23817	1596	11520160000000	6043	3139	2	0	0
23834	1596	12129150000000	6264	3244	1	0	1
23835	1596	12129160000000	6264	3244	2	0	1
23927	1598	1440020000000	7075	3651	0	0	0
23843	1596	12849170000000	7144	3692	2	0	1
23847	1596	13139140000000	7665	3968	3	0	5
23849	1596	13139440000000	7665	3968	4	0	5
23852	1596	13859440000000	7676	3974	0	0	5
23860	1596	14557555000000	8449	4378	4	0	6
23931	1598	2160020000000	8735	4530	6	0	0
23933	1598	2160080000000	8735	4530	7	0	0
23867	1596	15277555000000	9287	4816	2	0	6
23869	1596	15277575000000	9287	4816	3	0	6
23878	1596	15997615000000	9597	4979	5	0	6
23882	1596	16717615000000	9642	5002	2	0	6
23883	1596	16717635000000	9642	5002	3	0	6
23935	1598	2880080000000	12118	6242	0	0	0
23804	1596	10080366000000	13094	6748	4	0	11
23812	1596	10800379000000	13751	7065	7	0	11
23813	1596	10800395000000	13751	7065	8	0	11
23814	1596	10800495000000	14679	7478	26	0	11
23832	1596	11520495000000	14728	7498	4	0	11
23837	1596	12240517000000	15281	7783	2	0	11
23839	1596	12240528000000	15281	7783	3	0	11
23844	1596	12960528000000	15319	7806	2	0	11
23845	1596	12960539000000	15319	7806	3	0	11
23850	1596	13680539000000	15331	7814	3	0	11
23936	1598	3299980000000	16185	8226	11	0	1
23855	1596	14400551000000	16202	8234	2	0	11
23856	1596	14400553000000	16202	8234	3	0	11
23914	1597	2160020000000	16411	8348	6	0	0
23916	1597	2160044000000	16411	8348	7	0	0
23864	1596	15120565000000	16780	8518	4	0	11
23873	1596	15840565000000	17167	8702	10	0	11
23876	1596	15840602000000	17167	8702	11	0	11
23879	1596	16560602000000	17324	8777	7	0	11
23887	1596	17280726000000	18266	9201	3	0	11
23889	1596	17280738000000	18266	9201	4	0	11
23894	1596	18000738000000	18385	9266	2	0	11
23895	1596	18000749000000	18385	9266	3	0	11
23898	1596	18720749000000	18640	9394	7	0	11
23902	1596	19440972000000	18703	9421	2	0	11
23903	1596	19440983000000	18703	9421	3	0	11
23904	1596	20160983000000	19988	10065	5	0	11
23905	1596	20161006000000	19988	10065	6	0	11
23906	1596	20881006000000	20309	10228	3	0	11
23921	1598	720000000000	25819	12766	12	0	3
23925	1598	720048000000	25819	12766	13	0	3
23929	1598	1440048000000	26102	12901	4	0	3
23930	1598	1440070000000	26102	12901	5	0	3
23934	1598	2160082000000	27832	13756	4	0	3
23801	1596	10080339000002	28591	14119	1	0	16
23810	1596	10800339000002	28591	14119	4	0	16
23811	1596	10800341000002	28591	14119	5	0	16
23944	1599	2880030000000	576	325	3	0	\N
23946	1599	2880030000000	1322	438	0	0	\N
23947	1599	2880030000000	1323	447	0	0	\N
23949	1599	2880060000000	576	325	4	0	\N
23950	1599	3600050000000	958	534	1	0	\N
23951	1599	3600050000000	1036	576	1	0	\N
23953	1599	3600060000000	958	534	2	0	\N
23954	1599	3600060000000	1036	576	2	0	\N
23958	1599	5040070000000	1861	992	1	0	\N
23960	1599	5040080000000	1861	992	2	0	\N
23962	1599	5760080000000	2428	1271	1	0	\N
23964	1599	5760090000000	2428	1271	2	0	\N
23971	1599	6819728393047	13000	6701	2	0	\N
23973	1599	6819739393047	13000	6701	3	0	\N
23974	1599	6819748503047	13234	6760	58	0	\N
23977	1599	7496737097983	22702	11350	6	0	\N
23978	1599	7496737097983	22961	11472	3	0	\N
23981	1599	7496749097983	22961	11472	4	0	\N
23982	1599	7496752097983	22702	11350	7	0	\N
23983	1599	7539739393047	13621	7003	4	0	\N
23985	1599	7539752393047	13621	7003	5	0	\N
23987	1599	7920160000000	2988	1553	1	0	\N
23989	1599	7920170000000	2988	1553	2	0	\N
23993	1599	8259755393047	14181	7238	2	0	\N
23994	1599	8259755393047	14183	7238	6	0	\N
23996	1599	8259755393047	14280	7290	8	0	\N
23997	1599	8259775393047	14181	7238	3	0	\N
23999	1599	8259779393047	14183	7238	7	0	\N
24000	1599	8259781393047	14280	7290	9	0	\N
24003	1599	8936770097983	23714	11811	2	0	\N
24004	1599	8936770097983	23716	11811	3	0	\N
24005	1599	8936770097983	23855	11875	0	0	\N
24006	1599	8936770097983	23917	11902	11	0	\N
24007	1599	8936770097983	24269	12075	4	0	\N
24009	1599	8936781097983	23714	11811	3	0	\N
24010	1599	8936782097983	23716	11811	4	0	\N
24012	1599	8936783097983	24269	12075	5	0	\N
24013	1599	8936808097983	23917	11902	12	0	\N
24016	1599	9360180000000	3127	1626	0	0	\N
24021	1599	9699787393047	15106	7697	8	0	\N
24023	1599	9699787393047	15109	7698	6	0	\N
24025	1599	9699829393047	15109	7698	7	0	\N
24026	1599	9699840393047	15106	7697	9	0	\N
24027	1599	10080200000000	3188	1655	1	0	\N
24028	1599	10080200000000	3258	1692	1	0	\N
24029	1599	10080200000000	3320	1721	2	0	\N
24031	1599	10080210000000	3188	1655	2	0	\N
24032	1599	10080210000000	3258	1692	2	0	\N
24034	1599	10080220000000	3320	1721	3	0	\N
24037	1599	10419829393047	15624	7954	4	0	\N
24038	1599	10419829393047	15766	8019	7	0	\N
24039	1599	10419829393047	15841	8059	4	0	\N
24041	1599	10419829393047	16054	8089	117	0	\N
24042	1599	10419842393047	15624	7954	5	0	\N
24043	1599	10419842393047	15841	8059	5	0	\N
24045	1599	10419863393047	15766	8019	8	0	\N
24046	1599	10420927393047	16054	8089	118	0	\N
24055	1599	11521340000000	4245	2163	65	0	\N
24060	1599	12240240000000	4472	2317	3	0	\N
24061	1599	12240240000000	4578	2369	1	0	\N
24063	1599	12240250000000	4578	2369	2	0	\N
24064	1599	12240360000000	4472	2317	4	0	\N
24065	1599	12241340000000	4245	2163	81	0	\N
24066	1599	12241445000000	4245	2163	82	0	\N
24071	1599	12960240000000	6325	3273	1	0	\N
24072	1599	12960240000000	6344	3284	1	0	\N
23940	1599	1440010000000	331	191	1	0	0
23941	1599	1440020000000	331	191	2	0	0
23942	1599	2160020000000	457	257	1	0	0
23943	1599	2160030000000	457	257	2	0	0
23945	1599	2880030000000	847	468	2	0	0
23952	1599	3600050000000	1275	703	1	0	0
23955	1599	3600060000000	1275	703	2	0	0
23956	1599	4320060000000	1342	738	1	0	0
23957	1599	4320070000000	1342	738	2	0	0
23959	1599	5040070000000	2228	1174	1	0	0
23963	1599	5760080000000	2540	1336	1	0	0
23965	1599	5760090000000	2540	1336	2	0	0
23966	1599	6480090000000	2613	1375	5	0	0
23967	1599	6480140000000	2613	1375	6	0	0
23976	1599	7200160000000	2930	1524	3	0	0
23988	1599	7920160000000	3032	1575	1	0	0
23990	1599	7920170000000	3032	1575	2	0	0
24001	1599	8640170000000	3113	1616	1	0	0
24002	1599	8640180000000	3113	1616	2	0	0
24018	1599	9360200000000	3178	1650	3	0	0
24030	1599	10080200000000	3419	1777	1	0	0
24033	1599	10080210000000	3419	1777	2	0	0
24047	1599	10800210000000	3747	1942	2	0	0
24048	1599	10800230000000	3747	1942	3	0	0
24054	1599	11520240000000	3837	1994	2	0	0
24062	1599	12240240000000	5388	2804	0	0	0
23970	1599	6819728393047	12999	6701	2	0	4
23972	1599	6819739393047	12999	6701	3	0	4
23986	1599	7539755393047	13728	7056	8	0	4
23995	1599	8259755393047	14279	7290	2	0	4
23998	1599	8259775393047	14279	7290	3	0	4
24014	1599	8979775393047	14314	7304	3	0	4
24015	1599	8979787393047	14314	7304	4	0	4
24024	1599	9699829393047	15108	7698	7	0	4
24040	1599	10419829393047	16052	8165	6	0	4
24044	1599	10419853393047	16052	8165	7	0	4
23937	1598	3300018000000	16185	8226	12	0	1
24051	1599	11139853393047	16366	8324	11	0	4
24058	1599	11860179393047	16376	8330	3	0	4
24059	1599	11860191393047	16376	8330	4	0	4
24069	1599	12580191393047	16808	8531	3	0	4
24070	1599	12580203393047	16808	8531	4	0	4
23969	1599	6776737097983	22605	11309	3	0	8
23979	1599	7496737097983	23357	11655	2	0	8
23980	1599	7496748097983	23357	11655	3	0	8
23991	1599	8216748097983	23384	11668	4	0	8
23992	1599	8216770097983	23384	11668	5	0	8
24011	1599	8936782097983	24619	12235	4	0	8
24019	1599	9656782097983	24658	12248	3	0	8
24020	1599	9656794097983	24658	12248	4	0	8
24035	1599	10376794097983	24763	12295	10	0	8
24036	1599	10376858097983	24763	12295	11	0	8
24050	1599	11096870097983	25129	12470	4	0	8
24056	1599	11816870097983	25315	12558	5	0	8
24057	1599	11816884097983	25315	12558	6	0	8
24067	1599	12536884097983	25368	12577	4	0	8
24074	1599	12960250000000	6325	3273	2	0	\N
24075	1599	12960250000000	6344	3284	2	0	\N
24081	1599	13680260000000	6787	3514	4	0	\N
24082	1599	13680260000000	7122	3680	6	0	\N
24085	1599	13680300000000	6787	3514	5	0	\N
24086	1599	13680320000000	7122	3680	7	0	\N
24089	1599	13977021097983	27322	13507	6	0	\N
24090	1599	14020226393047	17035	8626	3	0	\N
24092	1599	14020226393047	17183	8685	1	0	\N
24093	1599	14020226393047	17184	8696	1	0	\N
24094	1599	14020226393047	17185	8706	1	0	\N
24095	1599	14020227393047	17183	8685	2	0	\N
24096	1599	14020227393047	17184	8696	2	0	\N
24097	1599	14020227393047	17185	8706	2	0	\N
24098	1599	14020238393047	17035	8626	4	0	\N
24100	1599	14400270000000	7966	4128	0	0	\N
24101	1599	14400270000000	8451	4379	1	0	\N
24102	1599	14400270000000	8772	4550	6	0	\N
24103	1599	14400270000000	8889	4607	2	0	\N
24105	1599	14400280000000	8451	4379	2	0	\N
24106	1599	14400290000000	8889	4607	3	0	\N
24108	1599	14400330000000	8772	4550	7	0	\N
24109	1599	14696997097983	26803	13253	3	0	\N
24110	1599	14696997097983	27430	13560	3	0	\N
24112	1599	14696997097983	27463	13573	6	0	\N
24113	1599	14697003097983	27463	13573	7	0	\N
24114	1599	14697009097983	26803	13253	4	0	\N
24115	1599	14697009097983	27430	13560	4	0	\N
24117	1599	14697021097983	27322	13507	7	0	\N
24118	1599	14740241393047	17778	8983	0	0	\N
24121	1599	15120290000000	8996	4664	5	0	\N
24123	1599	15120335000000	8996	4664	6	0	\N
24125	1599	15417015097983	27690	13683	3	0	\N
24127	1599	15417027097983	27690	13683	4	0	\N
24130	1599	15417049097983	27854	13768	1	0	\N
24133	1599	15840350000000	9599	4980	3	0	\N
24135	1599	15840380000000	9599	4980	4	0	\N
24138	1599	16137049097983	27854	13768	4	0	\N
24140	1599	16137051097983	27854	13768	5	0	\N
24141	1599	16180267393047	18029	9096	3	0	\N
24143	1599	16180279393047	18029	9096	4	0	\N
24145	1599	16560400000000	9800	5082	2	0	\N
24147	1599	16560420000000	9800	5082	3	0	\N
24151	1599	16900318393047	18174	9165	5	0	\N
24152	1599	16900318393047	18250	9185	27	0	\N
24156	1599	16900341393047	18174	9165	6	0	\N
24157	1599	16900453393047	18250	9185	28	0	\N
24158	1599	16901273393047	18370	9186	10	0	\N
24163	1599	17620329393047	18368	9257	5	0	\N
24165	1599	17620352393047	18368	9257	6	0	\N
24167	1599	17621273393047	18370	9186	126	0	\N
24168	1599	17622180393047	18370	9186	127	0	\N
24169	1599	17622262393047	18381	9187	10	0	\N
24170	1599	18000440000000	10060	5218	14	0	\N
24173	1599	18000580000000	10060	5218	15	0	\N
24174	1599	18297083097983	28289	13984	2	0	\N
24176	1599	18297094097983	28289	13984	3	0	\N
24178	1599	18340352393047	18944	9557	2	0	\N
24179	1599	18340352393047	18946	9557	1	0	\N
24181	1599	18340362393047	18946	9557	2	0	\N
24183	1599	18340372393047	18944	9557	3	0	\N
24184	1599	18342262393047	18381	9187	118	0	\N
24185	1599	18342369393047	18381	9187	119	0	\N
24186	1599	18720500000000	10286	5323	4	0	\N
24189	1599	18720540000000	10286	5323	5	0	\N
24190	1599	19017095097983	28497	14082	2	0	\N
24192	1599	19017106097983	28497	14082	3	0	\N
24194	1599	19060363393047	19285	9723	8	0	\N
24197	1599	19060425393047	19285	9723	9	0	\N
24199	1599	19440520000000	10670	5509	6	0	\N
24200	1599	19440520000000	11083	5702	2	0	\N
24201	1599	19440520000000	11118	5716	4	0	\N
24202	1599	19440520000000	11368	5839	6	0	\N
24203	1599	19440520000000	11485	5903	1	0	\N
24204	1599	19440520000000	11599	5966	2	0	\N
24206	1599	19440522000000	11599	5966	3	0	\N
24207	1599	19440530000000	11485	5903	2	0	\N
24208	1599	19440540000000	11083	5702	3	0	\N
24083	1599	13680260000000	7776	4032	1	0	0
24084	1599	13680270000000	7776	4032	2	0	0
24104	1599	14400270000000	8950	4641	2	0	0
24107	1599	14400290000000	8950	4641	3	0	0
24122	1599	15120290000000	9301	4826	6	0	0
24134	1599	15840350000000	9688	5026	5	0	0
24136	1599	15840400000000	9688	5026	6	0	0
24146	1599	16560400000000	9873	5121	2	0	0
24148	1599	16560420000000	9873	5121	3	0	0
24159	1599	17280420000000	10017	5195	2	0	0
24171	1599	18000440000000	10248	5301	6	0	0
24172	1599	18000500000000	10248	5301	7	0	0
24187	1599	18720500000000	10661	5506	2	0	0
24188	1599	18720520000000	10661	5506	3	0	0
24205	1599	19440521996199	11600	5966	3	0	0
24079	1599	13300203393047	16985	8604	5	0	4
24080	1599	13300226393047	16985	8604	6	0	4
24091	1599	14020226393047	17180	8708	6	0	4
24099	1599	14020241393047	17180	8708	7	0	4
24120	1599	14740254393047	17951	9055	5	0	4
24131	1599	15460254393047	17978	9067	4	0	4
24132	1599	15460267393047	17978	9067	5	0	4
24142	1599	16180267393047	18164	9157	6	0	4
24144	1599	16180318393047	18164	9157	7	0	4
24154	1599	16900329393047	18252	9193	3	0	4
24155	1599	16900339393047	18382	9264	1	0	4
24164	1599	17620339393047	18382	9264	6	0	4
24166	1599	17620352393047	18382	9264	7	0	4
24182	1599	18340363393047	18998	9580	3	0	4
24195	1599	19060363393047	19338	9751	4	0	4
24196	1599	19060376393047	19338	9751	5	0	4
24077	1599	13256897097983	25409	12593	4	0	8
24078	1599	13256910097983	25409	12593	5	0	8
24088	1599	13976997097983	26226	12966	25	0	8
24111	1599	14696997097983	27461	13573	9	0	8
24116	1599	14697015097983	27461	13573	10	0	8
24126	1599	15417015097983	27814	13745	6	0	8
24128	1599	15417039097983	27814	13745	7	0	8
24137	1599	16137049097983	27853	13768	4	0	8
24139	1599	16137051097983	27853	13768	5	0	8
24149	1599	16857051097983	28135	13906	3	0	8
24150	1599	16857072097983	28135	13906	4	0	8
24162	1599	17577083097983	28228	13956	3	0	8
24175	1599	18297083097983	28441	14056	3	0	8
24177	1599	18297095097983	28441	14056	4	0	8
24191	1599	19017095097983	28522	14092	3	0	8
24193	1599	19017107097983	28522	14092	4	0	8
24209	1599	19440553000000	11368	5839	7	0	\N
24210	1599	19440560000000	11118	5716	5	0	\N
24211	1599	19440580000000	10670	5509	7	0	\N
24218	1599	20457120097983	28847	14227	4	0	\N
24219	1599	20457120097983	28917	14262	2	0	\N
24221	1599	20457120097983	28969	14286	4	0	\N
24222	1599	20457122097983	28917	14262	3	0	\N
24224	1599	20457133097983	28847	14227	5	0	\N
24225	1599	20457133097983	28969	14286	5	0	\N
24234	1599	21600523996199	12228	6299	1	0	\N
24235	1599	21600523996199	12229	6299	2	0	\N
24236	1599	21600533996199	12228	6299	2	0	\N
24237	1599	21600534996199	12229	6299	3	0	\N
24244	1599	22660427393047	20635	10382	3	0	\N
24247	1599	22660439393047	20635	10382	4	0	\N
24249	1599	22660448393047	21326	10706	1	0	\N
24253	1599	23380448393047	21326	10706	4	0	\N
24255	1599	23380450393047	21326	10706	5	0	\N
24258	1599	24100450393047	21393	10733	4	0	\N
24259	1599	24100450393047	21467	10769	10	0	\N
24261	1599	24100463393047	21393	10733	5	0	\N
24263	1599	24100487393047	21467	10769	11	0	\N
24267	1599	24820463393047	21736	10886	9	0	\N
24269	1599	24820472393047	21736	10886	10	0	\N
24273	1599	25497367097983	30166	14842	30	0	\N
24277	1599	26217367097983	30166	14842	40	0	\N
24279	1599	26217375172678	30166	14842	42	0	\N
24280	1601	720000000000	207	121	1	0	\N
24282	1601	720010000000	207	121	2	0	\N
24288	1601	2880060000000	605	342	1	0	\N
24290	1601	2880070000000	605	342	2	0	\N
24294	1601	3530957600000	14642	7361	63	0	\N
24299	1601	4250147600000	14046	7193	11	0	\N
24300	1601	4250147600000	14049	7193	2	0	\N
24301	1601	4250147600000	14641	7461	2	0	\N
24303	1601	4250149600000	14641	7461	3	0	\N
24305	1601	4250168600000	14049	7193	3	0	\N
24306	1601	4250177600000	14046	7193	12	0	\N
24307	1601	4250957600000	14642	7361	126	0	\N
24308	1601	4251577600000	14642	7361	127	0	\N
24309	1601	4251838600000	14648	7362	63	0	\N
24312	1601	4538430600000	10263	5308	4	0	\N
24313	1601	4538430600000	10517	5432	2	0	\N
24314	1601	4538430600000	10518	5432	2	0	\N
24316	1601	4538450600000	10517	5432	3	0	\N
24317	1601	4538450600000	10518	5432	3	0	\N
24319	1601	4538470600000	10263	5308	5	0	\N
24320	1601	4705813620000	24740	12286	18	0	\N
24323	1601	4705948620000	24740	12286	19	0	\N
24325	1601	4970159600000	15154	7724	1	0	\N
24326	1601	4970160600000	15154	7724	2	0	\N
24328	1601	4971838600000	14648	7362	126	0	\N
24329	1601	4971900600000	14648	7362	127	0	\N
24332	1601	5258450600000	11393	5851	2	0	\N
24333	1601	5258450600000	11394	5851	2	0	\N
24335	1601	5258461600000	11393	5851	3	0	\N
24336	1601	5258461600000	11394	5851	3	0	\N
24338	1601	5400894600000	4450	2304	2	0	\N
24339	1601	5400894600000	4621	2392	1	0	\N
24341	1601	5400904600000	4621	2392	2	0	\N
24342	1601	5400905600000	4450	2304	3	0	\N
24284	1601	1440020000000	269	156	1	0	0
24285	1601	1440030000000	269	156	2	0	0
24286	1601	2160030000000	401	227	3	0	0
24287	1601	2160060000000	401	227	4	0	0
24289	1601	2880060000000	1498	818	4	0	0
24295	1601	3600100000000	1655	891	1	0	0
24296	1601	3600110000000	1655	891	2	0	0
24310	1601	4320110000000	2509	1316	3	0	0
24311	1601	4320140000000	2509	1316	4	0	0
24330	1601	5040140000000	2784	1457	1	0	0
24340	1601	5400894600000	4737	2449	2	0	5
24343	1601	5400914600000	4737	2449	3	0	5
24292	1601	3098370600000	9984	5177	5	0	9
24293	1601	3098420600000	9984	5177	6	0	9
24298	1601	3818430600000	10101	5240	2	0	9
24315	1601	4538430600000	10602	5476	2	0	9
24318	1601	4538450600000	10602	5476	3	0	9
24334	1601	5258450600000	11526	5920	6	0	9
24337	1601	5258483600000	11526	5920	7	0	9
24217	1599	20160522996199	11927	6139	2	0	0
24228	1599	20880522996199	12128	6247	1	0	0
24229	1599	20880523996199	12128	6247	2	0	0
24302	1601	4250147600000	14647	7465	3	0	13
24304	1601	4250159600000	14647	7465	4	0	13
24327	1601	4970167620000	15153	7724	3	0	13
24214	1599	19780376393047	19431	9794	3	0	4
24215	1599	19780388393047	19431	9794	4	0	4
24226	1599	20500388393047	19641	9892	3	0	4
24232	1599	21220400393047	19742	9937	3	0	4
24233	1599	21220412393047	19742	9937	4	0	4
24240	1599	21940412393047	19772	9955	6	0	4
24241	1599	21940427393047	19772	9955	7	0	4
24245	1599	22660427393047	20801	10456	2	0	4
24248	1599	22660448393047	21325	10706	1	0	4
24252	1599	23380448393047	21325	10706	4	0	4
24254	1599	23380450393047	21325	10706	5	0	4
24260	1599	24100450393047	21481	10772	4	0	4
24262	1599	24100463393047	21481	10772	5	0	4
24268	1599	24820472393047	21734	10886	10	0	4
24274	1599	25540472393047	22217	11122	8	0	4
24275	1599	25540489393047	22217	11122	9	0	4
24321	1601	4705813620000	25022	12414	4	0	21
24344	1601	5425835620000	25179	12494	3	0	21
24212	1599	19737107097983	28764	14189	4	0	8
24213	1599	19737120097983	28764	14189	5	0	8
24220	1599	20457120097983	28968	14286	3	0	8
24223	1599	20457132097983	28968	14286	4	0	8
24231	1599	21177145097983	28972	14287	5	0	8
24238	1599	21897145097983	29081	14336	2	0	8
24239	1599	21897156097983	29081	14336	3	0	8
24242	1599	22617156097983	29109	14350	5	0	8
24243	1599	22617179097983	29109	14350	6	0	8
24251	1599	23337203097983	29273	14427	7	0	8
24256	1599	24057203097983	29582	14587	11	0	8
24257	1599	24057259097983	29582	14587	12	0	8
24264	1599	24777259097983	29792	14680	13	0	8
24270	1599	25497281097983	30070	14805	11	0	8
24271	1599	25497301097983	30070	14805	12	0	8
24272	1599	25497367097983	30165	14842	30	0	8
24276	1599	26217367097983	30165	14842	40	0	8
24278	1599	26217375172678	30165	14842	42	0	8
24350	1601	5760150000000	3137	1631	1	0	\N
24352	1601	5760160000000	3137	1631	2	0	\N
24356	1601	6120914600000	5069	2629	1	0	\N
24357	1601	6120914600000	5070	2628	3	0	\N
24360	1601	6120924600000	5069	2629	2	0	\N
24361	1601	6120944600000	5070	2628	4	0	\N
24365	1601	6373455620000	19679	9912	9	0	\N
24372	1601	6698485600000	12066	6210	1	0	\N
24374	1601	6698486600000	12066	6210	2	0	\N
24378	1601	6865859620000	25614	12676	3	0	\N
24379	1601	6865871620000	25614	12676	4	0	\N
24388	1601	7418487600000	12377	6383	1	0	\N
24390	1601	7418488600000	12377	6383	2	0	\N
24392	1601	7560925600000	5328	2766	1	0	\N
24393	1601	7560925600000	5664	2937	0	0	\N
24395	1601	7560935600000	5328	2766	2	0	\N
24396	1601	7585921620000	25831	12773	3	0	\N
24398	1601	7585933620000	25831	12773	4	0	\N
24400	1601	7813608620000	19830	9989	3	0	\N
24401	1601	7813608620000	20205	10176	3	0	\N
24402	1601	7813608620000	20292	10216	7	0	\N
24404	1601	7813611620000	19830	9989	4	0	\N
24405	1601	7813620620000	20205	10176	4	0	\N
24407	1601	7813633620000	20292	10216	8	0	\N
24412	1601	8138498600000	12710	6554	4	0	\N
24415	1601	8138520600000	12710	6554	5	0	\N
24432	1601	9253653620000	21482	10772	4	0	\N
24433	1601	9253653620000	21731	10885	0	0	\N
24434	1601	9253653620000	21934	10974	2	0	\N
24435	1601	9253653620000	22033	11016	3	0	\N
24436	1601	9253653620000	22048	11025	3	0	\N
24438	1601	9253664620000	21934	10974	3	0	\N
24439	1601	9253665620000	22033	11016	4	0	\N
24440	1601	9253665620000	22048	11025	4	0	\N
24441	1601	9253666620000	21482	10772	5	0	\N
24443	1601	9253878620000	22440	11209	20	0	\N
24444	1601	9290230620000	16839	8544	2	0	\N
24445	1601	9290230620000	16929	8578	21	0	\N
24448	1601	9290241620000	16839	8544	3	0	\N
24449	1601	9290314620000	16929	8578	22	0	\N
24454	1601	9720965600000	6155	3188	1	0	\N
24456	1601	9720975600000	6155	3188	2	0	\N
24458	1601	9745982620000	27805	13739	6	0	\N
24459	1601	9745982620000	27975	13837	3	0	\N
24461	1601	9745994620000	27975	13837	4	0	\N
24462	1601	9746006620000	27805	13739	7	0	\N
24466	1601	9973878620000	22440	11209	97	0	\N
24467	1601	9974035620000	22440	11209	98	0	\N
24468	1601	9974615620000	22581	11210	49	0	\N
24469	1601	10010233620000	17072	8647	3	0	\N
24470	1601	10010233620000	17269	8591	0	0	\N
24472	1601	10010233620000	17271	8608	0	0	\N
24473	1601	10010233620000	17273	8713	0	0	\N
24474	1601	10010233620000	17276	8728	0	0	\N
24476	1601	10010245620000	17072	8647	4	0	\N
24370	1601	6480160000000	3669	1905	3	0	0
24371	1601	6480181000000	3669	1905	4	0	0
24386	1601	7200181000000	3728	1934	1	0	0
24387	1601	7200191000000	3728	1934	2	0	0
24410	1601	7920191000000	3854	2001	1	0	0
24424	1601	8640201000000	3929	2038	2	0	0
24425	1601	8640221000000	3929	2038	3	0	0
24450	1601	9360221000000	3986	2070	1	0	0
24451	1601	9360231000000	3986	2070	2	0	0
24477	1601	10080231000000	4003	2077	1	0	0
24358	1601	6120914600000	5081	2636	1	0	5
24359	1601	6120915600000	5081	2636	2	0	5
24376	1601	6840915600000	5266	2734	1	0	5
24377	1601	6840925600000	5266	2734	2	0	5
24416	1601	8280925600000	5916	3067	3	0	5
24417	1601	8280955600000	5916	3067	4	0	5
24428	1601	9000955600000	5974	3099	1	0	5
24429	1601	9000965600000	5974	3099	2	0	5
24455	1601	9720965600000	6308	3265	5	0	5
24354	1601	5978483600000	11727	6028	2	0	9
24355	1601	5978485600000	11727	6028	3	0	9
24373	1601	6698485600000	12323	6351	2	0	9
24375	1601	6698487600000	12323	6351	3	0	9
24389	1601	7418487600000	12620	6512	2	0	9
24413	1601	8138498600000	12799	6600	2	0	9
24414	1601	8138509600000	12799	6600	3	0	9
24426	1601	8858509600000	12896	6646	2	0	9
24427	1601	8858520600000	12896	6646	3	0	9
24453	1601	9578643600000	13018	6711	7	0	9
24479	1601	10298643600000	13079	6740	3	0	9
24480	1601	10298655600000	13079	6740	4	0	9
24348	1601	5690167620000	15888	8077	6	0	13
24349	1601	5690191620000	15888	8077	7	0	13
24369	1601	6410203620000	16109	8187	4	0	13
24384	1601	7130203620000	16181	8225	2	0	13
24385	1601	7130205620000	16181	8225	3	0	13
24408	1601	7850205620000	16301	8283	3	0	13
24409	1601	7850217620000	16301	8283	4	0	13
24423	1601	8570230620000	16421	8352	5	0	13
24446	1601	9290230620000	16930	8581	3	0	13
24447	1601	9290233620000	16930	8581	4	0	13
24471	1601	10010233620000	17270	8748	2	0	13
24346	1601	5653405620000	19387	9772	14	0	17
24347	1601	5653455620000	19387	9772	15	0	17
24366	1601	6373455620000	19680	9912	8	0	17
24367	1601	6373526620000	19680	9912	9	0	17
24382	1601	7093526620000	19689	9914	10	0	17
24403	1601	7813608620000	20653	10391	3	0	17
24406	1601	7813620620000	20653	10391	4	0	17
24420	1601	8533620620000	21203	10646	6	0	17
24421	1601	8533653620000	21203	10646	7	0	17
24437	1601	9253653620000	22253	11136	7	0	17
24464	1601	9973678620000	22439	11230	8	0	17
24465	1601	9973704620000	22439	11230	9	0	17
24345	1601	5425847620000	25179	12494	4	0	21
24362	1601	6145847620000	25371	12579	3	0	21
24364	1601	6145918620000	25795	12756	14	0	21
24380	1601	6865918620000	25795	12756	18	0	21
24381	1601	6865921620000	25795	12756	19	0	21
24397	1601	7585921620000	26729	13221	7	0	21
24399	1601	7585946620000	26729	13221	8	0	21
24419	1601	8305958620000	26782	13244	4	0	21
24430	1601	9025958620000	27794	13735	6	0	21
24431	1601	9025982620000	27794	13735	7	0	21
24460	1601	9745982620000	28034	13864	15	0	21
24463	1601	9746042620000	28034	13864	16	0	21
24481	1601	10441195600000	6524	3380	2	0	\N
24482	1601	10441195600000	7566	3917	1	0	\N
24483	1601	10441195600000	7864	4076	0	0	\N
24484	1601	10441195600000	7865	4076	1	0	\N
24485	1601	10441195600000	8028	4162	1	0	\N
24487	1601	10441205600000	7566	3917	2	0	\N
24488	1601	10441205600000	7865	4076	2	0	\N
24489	1601	10441205600000	8028	4162	2	0	\N
24490	1601	10441215600000	6524	3380	3	0	\N
24496	1601	10694615620000	22581	11210	126	0	\N
24497	1601	10695375620000	22581	11210	127	0	\N
24506	1601	11186054620000	28437	14054	2	0	\N
24507	1601	11186054620000	28486	14077	2	0	\N
24509	1601	11186065620000	28437	14054	3	0	\N
24510	1601	11186065620000	28486	14077	3	0	\N
24512	1601	11413816620000	22673	11335	3	0	\N
24514	1601	11413828620000	22673	11335	4	0	\N
24525	1601	11906066620000	29143	14369	9	0	\N
24528	1601	11906102620000	29143	14369	10	0	\N
24529	1601	11906130620000	29813	14666	4	0	\N
24530	1601	12133829620000	23485	11710	6	0	\N
24533	1601	12133853620000	23485	11710	7	0	\N
24536	1601	12601276600000	9119	4724	4	0	\N
24539	1601	12601316600000	9119	4724	5	0	\N
24540	1601	12626090620000	29593	14591	6	0	\N
24541	1601	12626090620000	29622	14608	6	0	\N
24543	1601	12626114620000	29593	14591	7	0	\N
24544	1601	12626114620000	29622	14608	7	0	\N
24546	1601	12626130620000	29813	14666	124	0	\N
24547	1601	12626519619919	29813	14666	125	1	\N
24548	1601	12853841620000	24175	12033	2	0	\N
24550	1601	12853852620000	24175	12033	3	0	\N
24554	1601	13321296600000	9217	4779	6	0	\N
24557	1601	13321356600000	9217	4779	7	0	\N
24558	1601	13610303620000	17827	9003	4	0	\N
24560	1601	13610316620000	17827	9003	5	0	\N
24574	1601	18650445620000	19078	9622	2	0	\N
24575	1601	18650456620000	19078	9622	3	0	\N
24576	1601	66000004010000	19679	9912	10	1	\N
24578	1602	720000000000	10171	5270	2	0	\N
24582	1602	720020000000	10171	5270	3	0	\N
24584	1602	1440010000000	10209	5287	3	0	\N
24585	1602	1440010000000	10307	5332	6	0	\N
24586	1602	1440010000000	10308	5332	5	0	\N
24588	1602	1440040000000	10209	5287	4	0	\N
24589	1602	1440060000000	10308	5332	6	0	\N
24590	1602	1440070000000	10307	5332	7	0	\N
24594	1602	2160200000000	10486	5420	2	0	\N
24595	1602	2160200000000	10490	5419	11	0	\N
24596	1602	2160200000000	10775	5562	5	0	\N
24598	1602	2160220000000	10486	5420	3	0	\N
24600	1602	2160250000000	10775	5562	6	0	\N
24601	1602	2160310000000	10490	5419	12	0	\N
24604	1602	2880030000000	1009	559	1	0	\N
24606	1602	2880040000000	1009	559	2	0	\N
24608	1602	2880240000000	10786	5567	3	0	\N
24609	1602	2880240000000	10966	5651	2	0	\N
24610	1602	2880240000000	10967	5651	2	0	\N
24612	1602	2880260000000	10966	5651	3	0	\N
24613	1602	2880260000000	10967	5651	3	0	\N
24615	1602	2880270000000	10786	5567	4	0	\N
24583	1602	1440010000000	852	473	0	0	0
24592	1602	2160010000000	876	486	2	0	0
24593	1602	2160030000000	876	486	3	0	0
24605	1602	2880030000000	1025	568	2	0	0
24607	1602	2880050000000	1025	568	3	0	0
24501	1601	10800251000000	4084	2122	2	0	0
24519	1601	11520251000000	4088	2124	1	0	0
24520	1601	11520261000000	4088	2124	2	0	0
24486	1601	10441195600000	8132	4216	2	0	5
24491	1601	10441215600000	8132	4216	3	0	5
24505	1601	11161236600000	8291	4294	4	0	5
24523	1601	11881236600000	8880	4600	4	0	5
24524	1601	11881276600000	8880	4600	5	0	5
24537	1601	12601276600000	9141	4736	2	0	5
24555	1601	13321296600000	9295	4821	2	0	5
24556	1601	13321316600000	9295	4821	3	0	5
24579	1602	720000000000	10172	5270	1	0	5
24581	1602	720010000000	10172	5270	2	0	5
24587	1602	1440010000000	10445	5404	10	0	5
24597	1602	2160200000000	10781	5565	4	0	5
24599	1602	2160240000000	10781	5565	5	0	5
24611	1602	2880240000000	11066	5693	2	0	5
24614	1602	2880260000000	11066	5693	3	0	5
24502	1601	11018655600000	13424	6917	10	0	9
24521	1601	11738674600000	13587	6988	4	0	9
24522	1601	11738687600000	13587	6988	5	0	9
24498	1601	10730244620000	17274	8750	3	0	13
24499	1601	10730256620000	17274	8750	4	0	13
24518	1601	11450268620000	17306	8767	4	0	13
24534	1601	12170268620000	17587	8898	6	0	13
24535	1601	12170292620000	17587	8898	7	0	13
24552	1601	12890292620000	17695	8944	2	0	13
24553	1601	12890303620000	17695	8944	3	0	13
24561	1601	13610325620000	18200	9171	5	0	13
24562	1601	14330325620000	18736	9441	7	0	13
24563	1601	14330359620000	18736	9441	8	0	13
24564	1601	15050359620000	18742	9444	4	0	13
24565	1601	15050372620000	18742	9444	5	0	13
24567	1601	15770382620000	18815	9481	2	0	13
24568	1601	16490382620000	18818	9483	2	0	13
24569	1601	16490393620000	18818	9483	3	0	13
24570	1601	17210393620000	18900	9533	2	0	13
24572	1601	17930404620000	18977	9571	5	0	13
24573	1601	17930445620000	18977	9571	6	0	13
24602	1602	2736189170000	20736	10424	3	0	9
24603	1602	2736201170000	20736	10424	4	0	9
24616	1602	3456201170000	21131	10613	3	0	9
24495	1601	10693816620000	22580	11297	5	0	17
24513	1601	11413816620000	23102	11537	4	0	17
24515	1601	11413829620000	23102	11537	5	0	17
24516	1601	11413839620000	23890	11892	1	0	17
24531	1601	12133839620000	23890	11892	4	0	17
24549	1601	12853841620000	24238	12062	3	0	17
24551	1601	12853853620000	24238	12062	4	0	17
24492	1601	10466042620000	28109	13894	3	0	21
24493	1601	10466054620000	28109	13894	4	0	21
24511	1601	11186066620000	29070	14333	4	0	21
24526	1601	11906066620000	29279	14429	6	0	21
24527	1601	11906090620000	29279	14429	7	0	21
24542	1601	12626090620000	29814	14689	11	0	21
24545	1601	12626119620000	29814	14689	12	0	21
24618	1602	3457363170000	21554	10725	109	0	\N
24619	1602	3600050000000	1083	601	1	0	\N
24621	1602	3600060000000	1083	601	2	0	\N
24625	1602	4176213170000	21553	10807	2	0	\N
24627	1602	4176213170000	21579	10818	3	0	\N
24628	1602	4176215170000	21553	10807	3	0	\N
24630	1602	4176225170000	21579	10818	4	0	\N
24631	1602	4177363170000	21554	10725	126	0	\N
24632	1602	4177523170000	21554	10725	127	0	\N
24636	1602	4896223170000	21667	10855	4	0	\N
24637	1602	4896223170000	21668	10855	6	0	\N
24638	1602	4896223170000	22449	11234	3	0	\N
24639	1602	4896223170000	22541	11278	1	0	\N
24640	1602	4896223170000	22542	11278	3	0	\N
24642	1602	4896233170000	22541	11278	2	0	\N
24643	1602	4896235170000	22449	11234	4	0	\N
24644	1602	4896235170000	22542	11278	4	0	\N
24646	1602	4896245170000	21667	10855	5	0	\N
24647	1602	4896247170000	21668	10855	7	0	\N
24648	1602	5040100000000	2465	1290	1	0	\N
24650	1602	5040110000000	2465	1290	2	0	\N
24654	1602	5616236170000	22728	11363	2	0	\N
24656	1602	5616236170000	23438	11449	0	0	\N
24657	1602	5616236170000	23443	11464	0	0	\N
24658	1602	5616236170000	23445	11478	0	0	\N
24659	1602	5616236170000	23446	11493	0	0	\N
24660	1602	5616247170000	22728	11363	3	0	\N
24662	1602	5760120000000	2648	1393	1	0	\N
24663	1602	5760120000000	2726	1431	2	0	\N
24664	1602	5760120000000	3725	1933	1	0	\N
24665	1602	5760120000000	3772	1957	1	0	\N
24666	1602	5760120000000	3773	1793	0	0	\N
24667	1602	5760120000000	3774	1813	0	0	\N
24668	1602	5760120000000	3776	1832	0	0	\N
24669	1602	5760120000000	3777	1850	0	0	\N
24670	1602	5760120000000	3804	1972	3	0	\N
24671	1602	5760120000000	3842	1997	2	0	\N
24672	1602	5760120000000	3843	1997	2	0	\N
24674	1602	5760130000000	2648	1393	2	0	\N
24675	1602	5760130000000	3725	1933	2	0	\N
24676	1602	5760130000000	3772	1957	2	0	\N
24677	1602	5760140000000	2726	1431	3	0	\N
24678	1602	5760140000000	3842	1997	3	0	\N
24679	1602	5760140000000	3843	1997	3	0	\N
24680	1602	5760150000000	3804	1972	4	0	\N
24684	1602	6336250170000	23440	11691	2	0	\N
24685	1602	6336250170000	23537	11733	10	0	\N
24687	1602	6336261170000	23440	11691	3	0	\N
24689	1602	6336287170000	23537	11733	11	0	\N
24692	1602	6480354000000	12689	6544	2	0	\N
24693	1602	6480354000000	12941	6670	2	0	\N
24696	1602	6480365000000	12689	6544	3	0	\N
24697	1602	6480365000000	12941	6670	3	0	\N
24700	1602	7200240000000	4213	2192	1	0	\N
24702	1602	7200250000000	4213	2192	2	0	\N
24704	1602	7200364000000	13172	6787	4	0	\N
24706	1602	7200364000000	13336	6872	10	0	\N
24708	1602	7200386000000	13172	6787	5	0	\N
24709	1602	7200401000000	13336	6872	11	0	\N
24710	1602	7776303170000	23796	11846	4	0	\N
24712	1602	7776325170000	23796	11846	5	0	\N
24714	1602	7920250000000	4330	2243	1	0	\N
24716	1602	7920260000000	4330	2243	2	0	\N
24718	1602	7920385000000	13399	6904	7	0	\N
24719	1602	7920385000000	14067	7200	1	0	\N
24720	1602	7920385000000	14068	7200	4	0	\N
24721	1602	7920385000000	14178	7238	2	0	\N
24722	1602	7920385000000	14179	7238	6	0	\N
24723	1602	7920385000000	14472	7387	1	0	\N
24725	1602	7920395000000	14067	7200	2	0	\N
24726	1602	7920395000000	14472	7387	2	0	\N
24727	1602	7920398000000	14068	7200	5	0	\N
24729	1602	7920405000000	14178	7238	3	0	\N
24730	1602	7920409000000	14179	7238	7	0	\N
24731	1602	7920410000000	13399	6904	8	0	\N
24736	1602	8640398000000	14831	7523	58	0	\N
24738	1602	8640398000000	14834	7560	0	0	\N
24740	1602	8640492000000	14831	7523	59	0	\N
24741	1602	9216578170000	23955	11919	3	0	\N
24743	1602	9216590170000	23955	11919	4	0	\N
24745	1602	9260664124178	26392	12900	119	0	\N
24746	1602	9360280000000	5594	2907	0	0	\N
24633	1602	4320070000000	1267	699	3	0	0
24634	1602	4320100000000	1267	699	4	0	0
24649	1602	5040100000000	2589	1364	2	0	0
24651	1602	5040120000000	2589	1364	3	0	0
24673	1602	5760120000000	4022	2087	2	0	0
24690	1602	6480230000000	4057	2108	1	0	0
24691	1602	6480240000000	4057	2108	2	0	0
24701	1602	7200240000000	4237	2201	1	0	0
24703	1602	7200250000000	4237	2201	2	0	0
24715	1602	7920250000000	4947	2561	1	0	0
24734	1602	8640260000000	5142	2664	2	0	0
24735	1602	8640280000000	5142	2664	3	0	0
24747	1602	9360280000000	5671	2940	0	0	0
24623	1602	3600260000000	11101	5711	9	0	5
24635	1602	4320350000000	11549	5933	0	0	5
24652	1602	5040350000000	11608	5971	2	0	5
24653	1602	5040352000000	11608	5971	3	0	5
24682	1602	5760352000000	11959	6156	2	0	5
24683	1602	5760354000000	11959	6156	3	0	5
24695	1602	6480364000000	12942	6670	2	0	5
24705	1602	7200364000000	13332	6872	3	0	5
24707	1602	7200385000000	13332	6872	4	0	5
24724	1602	7920385000000	14473	7387	4	0	5
24728	1602	7920398000000	14473	7387	5	0	5
24739	1602	8640409000000	14833	7560	3	0	5
24748	1602	9360409000000	14963	7621	2	0	5
24749	1602	9360420000000	14963	7621	3	0	5
24750	1602	9360430000000	15346	7821	1	0	5
24626	1602	4176213170000	21578	10818	1	0	9
24629	1602	4176223170000	21578	10818	2	0	9
24641	1602	4896223170000	22697	11349	4	0	9
24645	1602	4896236170000	22697	11349	5	0	9
24655	1602	5616236170000	23127	11552	5	0	9
24686	1602	6336250170000	23630	11772	7	0	9
24688	1602	6336275170000	23630	11772	8	0	9
24698	1602	7056275170000	23701	11803	10	0	9
24699	1602	7056303170000	23701	11803	11	0	9
24711	1602	7776303170000	23807	11851	5	0	9
24732	1602	8496566170000	23946	11915	3	0	9
24733	1602	8496578170000	23946	11915	4	0	9
24742	1602	9216578170000	24140	12017	6	0	9
24744	1602	9216611170000	24140	12017	7	0	9
24752	1602	9936623170000	24310	12089	4	0	9
24753	1602	10080280000000	5994	3110	2	0	\N
24756	1602	10080300000000	5994	3110	3	0	\N
24757	1602	10080420000000	15161	7693	1	0	\N
24758	1602	10080420000000	15162	7729	1	0	\N
24759	1602	10080430000000	15162	7729	2	0	\N
24762	1602	10080520000000	15161	7693	2	0	\N
24763	1602	10656623170000	24371	12097	0	0	\N
24765	1602	10656623170000	24373	12112	0	0	\N
24767	1602	10800290000000	6079	3157	2	0	\N
24768	1602	10800290000000	6836	3538	2	0	\N
24770	1602	10800310000000	6079	3157	3	0	\N
24771	1602	10800310000000	6836	3538	3	0	\N
24775	1602	11376634170000	24510	12190	2	0	\N
24776	1602	11376634170000	24687	12263	4	0	\N
24777	1602	11376634170000	25132	12471	7	0	\N
24778	1602	11376634170000	25402	12589	7	0	\N
24780	1602	11376645170000	24510	12190	3	0	\N
24781	1602	11376647170000	24687	12263	5	0	\N
24782	1602	11376659170000	25132	12471	8	0	\N
24784	1602	11376749170000	25402	12589	8	0	\N
24787	1602	11520455000000	15423	7856	3	0	\N
24790	1602	11520467000000	15423	7856	4	0	\N
24791	1602	12096670170000	25792	12754	4	0	\N
24794	1602	12096683170000	25792	12754	5	0	\N
24795	1602	12096758170000	26392	12900	77	0	\N
24800	1602	12816681170000	26012	12857	4	0	\N
24801	1602	12816681170000	26391	13054	7	0	\N
24804	1602	12816694170000	26012	12857	5	0	\N
24805	1602	12816706170000	26391	13054	8	0	\N
24806	1602	12816758169992	26392	12900	116	0	\N
24807	1602	12960370000000	8292	4295	0	0	\N
24808	1602	12960370000000	8294	4295	2	0	\N
24809	1602	12960370000000	8524	4417	1	0	\N
24810	1602	12960370000000	8824	4575	2	0	\N
24811	1602	12960370000000	8844	4584	2	0	\N
24812	1602	12960370000000	8845	4584	1	0	\N
24813	1602	12960370000000	8933	4632	4	0	\N
24814	1602	12960370000000	9040	4688	2	0	\N
24816	1602	12960380000000	8524	4417	2	0	\N
24817	1602	12960380000000	8845	4584	2	0	\N
24818	1602	12960390000000	8294	4295	3	0	\N
24819	1602	12960390000000	8824	4575	3	0	\N
24820	1602	12960390000000	8844	4584	3	0	\N
24821	1602	12960390000000	9040	4688	3	0	\N
24823	1602	12960410000000	8933	4632	5	0	\N
24824	1602	12960478000000	15994	8131	3	0	\N
24826	1602	12960490000000	15994	8131	4	0	\N
24830	1602	13680490000000	16587	8429	6	0	\N
24831	1602	13680490000000	16766	8510	2	0	\N
24833	1602	13680501000000	16766	8510	3	0	\N
24835	1602	13680514000000	16587	8429	7	0	\N
24838	1602	14400502000000	17143	8689	3	0	\N
24839	1602	14400502000000	17371	8799	3	0	\N
24840	1602	14400502000000	17375	8799	2	0	\N
24841	1602	14400502000000	17758	8972	12	0	\N
24842	1602	14400502000000	17973	9065	8	0	\N
24843	1602	14400502000000	17975	9065	8	0	\N
24845	1602	14400502000000	18123	9132	0	0	\N
24846	1602	14400504000000	17375	8799	3	0	\N
24847	1602	14400514000000	17143	8689	4	0	\N
24848	1602	14400514000000	17371	8799	4	0	\N
24849	1602	14400519000000	17973	9065	9	0	\N
24851	1602	14400550000000	17758	8972	13	0	\N
24853	1602	14976730170000	26686	13199	8	0	\N
24854	1602	14976730170000	26772	13240	6	0	\N
24855	1602	14976730170000	27524	13609	3	0	\N
24856	1602	14976730170000	27893	13792	3	0	\N
24857	1602	14976730170000	28516	14090	4	0	\N
24858	1602	14976730170000	28517	14047	2	0	\N
24859	1602	14976730170000	28695	14166	2	0	\N
24860	1602	14976730170000	28844	14157	0	0	\N
24861	1602	14976732170000	28517	14047	3	0	\N
24863	1602	14976741170000	28695	14166	3	0	\N
24864	1602	14976742170000	27524	13609	4	0	\N
24865	1602	14976742170000	27893	13792	4	0	\N
24866	1602	14976743170000	28516	14090	5	0	\N
24867	1602	14976754170000	26772	13240	7	0	\N
24868	1602	14976756170000	26686	13199	9	0	\N
24871	1602	15696736169996	28845	14227	4	0	\N
24872	1602	15696736169996	28848	14173	0	0	\N
24873	1602	15696736169996	28849	14189	0	0	\N
24874	1602	15696736169996	28859	14234	3	0	\N
24875	1602	15696736169996	28970	14287	4	0	\N
24876	1602	15696736169996	28971	14287	3	0	\N
24877	1602	15696736169996	29542	14566	6	0	\N
24879	1602	15696748169996	28859	14234	4	0	\N
24880	1602	15696748169996	28971	14287	4	0	\N
24882	1602	15696749169996	28845	14227	5	0	\N
24883	1602	15696749169996	28970	14287	5	0	\N
24884	1602	15696760169996	29542	14566	7	0	\N
24769	1602	10800290000000	7083	3655	4	0	0
24772	1602	10800330000000	7083	3655	5	0	0
24785	1602	11520330000000	7134	3687	3	0	0
24786	1602	11520360000000	7134	3687	4	0	0
24796	1602	12240360000000	7604	3935	1	0	0
24815	1602	12960370000000	9345	4849	2	0	0
24822	1602	12960390000000	9345	4849	3	0	0
24760	1602	10080430000000	15346	7821	4	0	5
24761	1602	10080432000000	15346	7821	5	0	5
24773	1602	10800432000000	15401	7845	5	0	5
24788	1602	11520455000000	15605	7944	2	0	5
24789	1602	11520466000000	15605	7944	3	0	5
24798	1602	12240466000000	15800	8041	3	0	5
24799	1602	12240478000000	15800	8041	4	0	5
24827	1602	12960490000000	16043	8158	4	0	5
24832	1602	13680490000000	17042	8631	3	0	5
24834	1602	13680502000000	17042	8631	4	0	5
24844	1602	14400502000000	18122	9139	4	0	5
24850	1602	14400524000000	18122	9139	5	0	5
24870	1602	15120535000000	18311	9224	3	0	5
24885	1602	15840535000000	18817	9482	1	0	5
24886	1602	15840545000000	18817	9482	2	0	5
24764	1602	10656623170000	24372	12121	2	0	9
24766	1602	10656634170000	24372	12121	3	0	9
24783	1602	11376670170000	25565	12657	10	0	9
24792	1602	12096670170000	25986	12842	2	0	9
24793	1602	12096681170000	25986	12842	3	0	9
24802	1602	12816681170000	26526	13122	3	0	9
24828	1602	13536693170000	26627	13173	7	0	9
24829	1602	13536718170000	26627	13173	8	0	9
24836	1602	14256718170000	26672	13192	3	0	9
24837	1602	14256730170000	26672	13192	4	0	9
24852	1602	14976730169991	28694	14166	2	0	9
24878	1602	15696736169996	29640	14617	3	0	9
24881	1602	15696748169996	29640	14617	4	0	9
24887	1602	16416748169996	29663	14630	9	0	9
24888	1602	16416766169996	29663	14630	10	0	9
24891	1602	17136766169996	29896	14731	10	0	\N
24892	1602	17136785169996	29896	14731	11	0	\N
24898	1602	18000575000000	18951	9559	0	0	\N
24900	1602	18576804169996	30059	14798	19	0	\N
24901	1602	18576804169996	30102	14818	9	0	\N
24902	1602	18576804169996	30103	14818	8	0	\N
24903	1602	18576804169996	30126	14825	19	0	\N
24905	1602	18576804169996	30274	14885	39	0	\N
24906	1602	18576821169996	30103	14818	9	0	\N
24907	1602	18576822169996	30102	14818	10	0	\N
24908	1602	18576831869560	30126	14825	23	0	\N
24909	1602	18576841169996	30059	14798	20	0	\N
24911	1602	18576880857496	30274	14885	40	0	\N
24918	1602	66000000080000	17975	9065	9	1	\N
24919	1603	10000000	3890	1854	0	0	\N
24920	1603	720000000000	9428	4879	2	0	\N
24922	1603	720020000000	9428	4879	3	0	\N
24924	1603	1440050000000	12267	6316	1	0	\N
24926	1603	1440051000000	12267	6316	2	0	\N
24928	1603	2160062000000	18902	9287	6	0	\N
24929	1603	2160662000000	18902	9287	7	0	\N
24933	1604	3600000	28086	13885	7	0	\N
24935	1604	3800000	30255	14876	20	1	\N
24936	1604	3800000	30256	14876	21	0	\N
24939	1604	4100000	28169	13846	28	1	\N
24940	1604	4700000	28569	13882	23	1	\N
24941	1604	7100000	28626	13884	15	1	\N
24942	1604	720000616000	11281	5795	6	1	\N
24943	1604	15017592089008	10413	5386	4	0	\N
24945	1605	40000000	13841	7105	2	0	\N
24946	1605	40000000	13842	7105	2	0	\N
24947	1605	720020000000	3887	2020	2	0	\N
24948	1605	720020000000	5475	2851	0	0	\N
24949	1605	720020000000	12531	6459	1	0	\N
24950	1605	720021000000	12531	6459	2	0	\N
24951	1605	720040000000	3887	2020	3	0	\N
24953	1605	720040000000	13841	7105	9	0	\N
24954	1605	720040000000	13842	7105	9	0	\N
24956	1605	720046000000	13841	7105	10	0	\N
24957	1605	720046000000	13842	7105	10	0	\N
24958	1605	1440046000000	19793	9969	2	0	\N
24960	1605	1440057000000	19793	9969	3	0	\N
24964	1607	101	4874	2326	112	0	\N
24967	1607	1440010000000	397	226	2	0	\N
24970	1607	1440030000000	397	226	3	0	\N
24977	1607	3600040000000	813	450	1	0	\N
24979	1607	3600050000000	813	450	2	0	\N
24987	1607	5040070000000	1730	930	2	0	\N
24990	1607	5040090000000	1730	930	3	0	\N
24995	1607	6018204644388	11607	5971	2	0	\N
24996	1607	6018204644388	11860	6096	1	0	\N
24997	1607	6018204644388	11932	6142	1	0	\N
24999	1607	6018205644388	11860	6096	2	0	\N
25000	1607	6018205644388	11932	6142	2	0	\N
25001	1607	6018206644388	11607	5971	3	0	\N
25007	1607	7200200000000	2830	1479	0	0	\N
25012	1607	7920210000000	2978	1549	1	0	\N
25014	1607	7920220000000	2978	1549	2	0	\N
25016	1607	8178221644388	13472	6940	4	0	\N
25017	1607	8178221644388	13474	6940	1	0	\N
25019	1607	8178221644388	13966	7157	1	0	\N
25020	1607	8178231644388	13474	6940	2	0	\N
25021	1607	8178231644388	13966	7157	2	0	\N
25022	1607	8178234644388	13472	6940	5	0	\N
24968	1607	1440010000000	563	318	1	0	0
24969	1607	1440020000000	563	318	2	0	0
24971	1607	2160020000000	610	344	1	0	0
24972	1607	2160030000000	610	344	2	0	0
24973	1607	2880030000000	805	445	1	0	0
24978	1607	3600040000000	817	452	2	0	0
24980	1607	3600060000000	817	452	3	0	0
24983	1607	4320060000000	1566	852	1	0	0
24984	1607	4320070000000	1566	852	2	0	0
24988	1607	5040070000000	1767	947	1	0	0
24993	1607	5760080000000	1785	955	1	0	0
24994	1607	5760090000000	1785	955	2	0	0
25003	1607	6480090000000	2235	1178	2	0	0
25004	1607	6480200000000	2235	1178	3	0	0
24963	1606	720010000000	2378	1244	2	0	0
25008	1607	7200200000000	2962	1539	1	0	0
25009	1607	7200210000000	2962	1539	2	0	0
25013	1607	7920210000000	3281	1705	2	0	0
25015	1607	7920230000000	3281	1705	3	0	0
24975	1607	3137963644388	10253	5304	18	0	9
24976	1607	3138143644388	10253	5304	19	0	9
24981	1607	3858143644388	10390	5371	3	0	9
24982	1607	3858164644388	10390	5371	4	0	9
24985	1607	4578164644388	10559	5452	2	0	9
24991	1607	5298184644388	10609	5479	2	0	9
24992	1607	5298204644388	10609	5479	3	0	9
24921	1603	720000000000	10848	5599	5	0	0
24923	1603	720050000000	10848	5599	6	0	0
25002	1607	6018208644388	12179	6271	5	0	9
25005	1607	6738208644388	12239	6302	1	0	9
25006	1607	6738209644388	12239	6302	2	0	9
25010	1607	7458209644388	13300	6853	3	0	9
25011	1607	7458221644388	13300	6853	4	0	9
24952	1605	720040000000	13840	7105	9	0	0
24955	1605	720046000000	13840	7105	10	0	0
25018	1607	8178221644388	13965	7157	4	0	9
25023	1607	8178234644388	13965	7157	5	0	9
24925	1603	1440050000000	16016	8143	3	0	0
24889	1602	16560545000000	18821	9484	1	0	5
24890	1602	16560555000000	18821	9484	2	0	5
24893	1602	17280555000000	18855	9506	2	0	5
24894	1602	17280575000000	18855	9506	3	0	5
24899	1602	18000585000000	18950	9559	2	0	5
24959	1605	1440046000000	19796	9969	3	0	0
24961	1605	1440058000000	19796	9969	4	0	0
24912	1602	18720585000000	19933	10039	4	0	5
24913	1602	18720598000000	19933	10039	5	0	5
24915	1602	19440945000000	20099	10117	13	0	5
24916	1602	20160945000000	20164	10150	13	0	5
24917	1602	20161021000000	20164	10150	14	0	5
24931	1604	3200000	22289	11157	10	0	0
24932	1604	3500000	27149	13424	7	0	0
24895	1602	17856766169996	30005	14775	20	0	9
24896	1602	17856804169996	30005	14775	21	0	9
24937	1604	3800000	30257	14876	20	1	0
24904	1602	18576804169996	30273	14885	22	0	9
24938	1604	4000000	30276	14887	35	0	0
25028	1607	9360330000000	3434	1783	0	0	\N
25030	1607	9618251644388	14038	7190	2	0	\N
25031	1607	9618251644388	14136	7221	3	0	\N
25033	1607	9618263644388	14136	7221	4	0	\N
25035	1607	9618271644388	14038	7190	3	0	\N
25038	1607	10284263644388	20047	9937	0	0	\N
25039	1607	10338263644388	14495	7395	4	0	\N
25040	1607	10338276644388	14495	7395	5	0	\N
25050	1607	13683242000000	4674	2325	114	0	\N
25051	1607	14400392000000	4317	2238	1	0	\N
25053	1607	14400402000000	4317	2238	2	0	\N
25055	1607	14403242000000	4674	2325	126	0	\N
25056	1607	14403352000000	4674	2325	127	0	\N
25057	1607	15120402000000	4873	2523	1	0	\N
25058	1607	15120402000000	5112	2654	1	0	\N
25059	1607	15120402000000	5114	2654	1	0	\N
25061	1607	15120412000000	4873	2523	2	0	\N
25062	1607	15120412000000	5112	2654	2	0	\N
25063	1607	15120412000000	5114	2654	2	0	\N
25065	1607	15124851899898	4874	2326	126	0	\N
25066	1607	15124961899898	4874	2326	127	0	\N
25067	1607	15840412000000	5457	2840	7	0	\N
25069	1607	15841112000000	5457	2840	8	0	\N
25073	1607	18000422000000	6604	3415	4	0	\N
25076	1607	18000462000000	6604	3415	5	0	\N
25083	1607	20880502000000	7223	3734	2	0	\N
25086	1607	20880612000000	7223	3734	3	0	\N
25087	1607	20881302000000	7511	3818	57	0	\N
25088	1607	21600552000000	7509	3888	4	0	\N
25091	1607	21600587000000	7509	3888	5	0	\N
25092	1607	21601302000000	7511	3818	117	0	\N
25093	1607	21601864000000	7511	3818	118	0	\N
25094	1607	22320562000000	7642	3954	9	0	\N
25097	1607	22320652000000	7642	3954	10	0	\N
25098	1607	22321864000000	7598	3819	57	0	\N
25099	1607	22322596000000	7598	3819	58	0	\N
25100	1607	22322786000000	7644	3820	7	0	\N
25103	1607	23042786000000	7644	3820	44	0	\N
25104	1607	23043137000000	7644	3820	45	0	\N
25105	1607	23760602000000	8290	4294	3	0	\N
25108	1607	23760623000000	8290	4294	4	0	\N
25109	1607	23763137000000	7651	3821	8	0	\N
25110	1607	23763217000000	7651	3821	9	0	\N
25115	1607	25920662000000	9125	4726	4	0	\N
25118	1607	25920702000000	9125	4726	5	0	\N
25119	1607	26640693000000	9635	5001	4	0	\N
25120	1607	26640693000000	9861	5116	2	0	\N
25122	1607	26640713000000	9861	5116	3	0	\N
25124	1607	26640733000000	9635	5001	5	0	\N
25125	1608	720000000000	614	346	1	0	\N
25126	1608	720000000000	674	376	1	0	\N
25127	1608	720000000000	739	414	1	0	\N
25129	1608	720010000000	614	346	2	0	\N
25130	1608	720010000000	674	376	2	0	\N
25131	1608	720010000000	739	414	2	0	\N
25133	1608	1440010000000	1110	613	1	0	\N
25134	1608	1440010000000	1191	658	2	0	\N
25136	1608	1440020000000	1110	613	2	0	\N
25137	1608	1440030000000	1191	658	3	0	\N
25141	1608	2880040000000	1893	1008	1	0	\N
25143	1608	2880050000000	1893	1008	2	0	\N
25145	1608	3600050000000	2236	1179	1	0	\N
25147	1608	3600060000000	2236	1179	2	0	\N
25135	1608	1440010000000	1207	665	2	0	0
25138	1608	1440030000000	1207	665	3	0	0
25139	1608	2160030000000	1242	687	1	0	0
25140	1608	2160040000000	1242	687	2	0	0
25142	1608	2880040000000	2063	1090	1	0	0
25146	1608	3600050000000	2287	1200	1	0	0
25148	1608	3600060000000	2287	1200	2	0	0
25153	1608	4320060000000	2467	1292	2	0	0
25154	1608	4320080000000	2467	1292	3	0	0
25159	1608	5040080000000	2636	1387	1	0	0
25025	1607	8640330000000	3347	1739	11	0	0
25029	1607	9360330000000	3497	1815	0	0	0
25036	1607	10080330000000	3504	1819	1	0	0
25037	1607	10080331000000	3504	1819	2	0	0
25042	1607	11520331000000	4086	2123	1	0	0
25043	1607	11520341000000	4086	2123	2	0	0
25044	1607	12240341000000	4098	2131	2	0	0
25045	1607	12240361000000	4098	2131	3	0	0
25046	1607	12960361000000	4118	2140	2	0	0
25048	1607	13680381000000	4179	2176	2	0	0
25049	1607	13680392000000	4179	2176	3	0	0
25052	1607	14400392000000	4673	2416	1	0	0
25054	1607	14400402000000	4673	2416	2	0	0
25060	1607	15120402000000	5339	2770	1	0	0
25068	1607	15840412000000	5708	2960	0	0	0
25070	1607	16560412000000	5728	2968	0	0	0
25071	1607	17280412000000	5950	3084	1	0	0
25072	1607	17280422000000	5950	3084	2	0	0
25075	1607	18000442000000	6983	3603	3	0	0
25077	1607	18720442000000	7130	3685	2	0	0
25078	1607	18720462000000	7130	3685	3	0	0
25079	1607	19440462000000	7154	3697	1	0	0
25080	1607	19440472000000	7154	3697	2	0	0
25082	1607	20160502000000	7175	3706	4	0	0
25084	1607	20880502000000	7390	3817	5	0	0
25085	1607	20880552000000	7390	3817	6	0	0
25089	1607	21600552000000	7597	3929	1	0	0
25090	1607	21600562000000	7597	3929	2	0	0
25096	1607	22320592000000	7652	3960	4	0	0
25101	1607	23040592000000	7803	4046	1	0	0
25102	1607	23040602000000	7803	4046	2	0	0
25106	1607	23760602000000	8573	4443	2	0	0
25111	1607	24480622000000	8574	4444	1	0	0
25112	1607	24480632000000	8574	4444	2	0	0
25113	1607	25200632000000	8848	4585	3	0	0
25114	1607	25200662000000	8848	4585	4	0	0
25116	1607	25920662000000	9306	4829	4	0	0
25121	1607	26640693000000	10030	5204	2	0	0
25123	1607	26640713000000	10030	5204	3	0	0
25151	1608	3885440000000	11400	5855	4	0	4
25152	1608	3885462000000	11400	5855	5	0	4
25157	1608	4605462000000	11479	5900	4	0	4
25026	1607	8898234644388	13994	7170	8	0	9
25027	1607	8898251644388	13994	7170	9	0	9
25032	1607	9618251644388	14138	7221	3	0	9
25034	1607	9618263644388	14138	7221	4	0	9
25150	1608	3738336000000	21506	10787	7	0	8
25155	1608	4458336000000	21549	10805	2	0	8
25156	1608	4458338000000	21549	10805	3	0	8
25166	1608	5480542000000	21224	10657	2	0	\N
25168	1608	5480553000000	21224	10657	3	0	\N
25169	1608	5760090000000	2645	1392	1	0	\N
25170	1608	5760090000000	2878	1505	1	0	\N
25171	1608	5760090000000	2883	1506	2	0	\N
25172	1608	5760090000000	2900	1514	1	0	\N
25174	1608	5760100000000	2645	1392	2	0	\N
25175	1608	5760100000000	2878	1505	2	0	\N
25176	1608	5760100000000	2900	1514	2	0	\N
25178	1608	5760110000000	2883	1506	3	0	\N
25181	1608	6045498000000	11691	6010	1	0	\N
25183	1608	6045499000000	11691	6010	2	0	\N
25189	1608	6618507000000	22388	11190	12	0	\N
25196	1608	7338507000000	22388	11190	82	0	\N
25197	1608	7338693000000	22388	11190	83	0	\N
25200	1608	7920120000000	4466	2314	1	0	\N
25202	1608	7920130000000	4466	2314	2	0	\N
25203	1608	7922130000000	4860	2431	116	0	\N
25204	1608	8058399000000	22402	11215	7	0	\N
25207	1608	8058424000000	22402	11215	8	0	\N
25208	1608	8058693000000	22404	11191	26	0	\N
25209	1608	8058791000000	22404	11191	27	0	\N
25214	1608	8642130000000	4860	2431	122	0	\N
25215	1608	8642180000000	4860	2431	123	0	\N
25216	1608	8778422000000	23230	11592	2	0	\N
25217	1608	8778422000000	23432	11690	2	0	\N
25218	1608	8778422000000	23466	11700	4	0	\N
25220	1608	8778433000000	23230	11592	3	0	\N
25221	1608	8778433000000	23432	11690	3	0	\N
25223	1608	8778435000000	23466	11700	5	0	\N
25224	1608	8778444000000	24338	12103	1	0	\N
25225	1608	8925535000000	12932	6665	2	0	\N
25227	1608	8925546000000	12932	6665	3	0	\N
25232	1608	9498444000000	24338	12103	4	0	\N
25233	1608	9498446000000	24338	12103	5	0	\N
25235	1608	9645547000000	13390	6901	3	0	\N
25237	1608	9645547000000	13601	6992	1	0	\N
25238	1608	9645557000000	13601	6992	2	0	\N
25239	1608	9645559000000	13390	6901	4	0	\N
25245	1608	10365559000000	13907	7133	8	0	\N
25247	1608	10365585000000	13907	7133	9	0	\N
25248	1608	10800270000000	5393	2807	0	0	\N
25249	1608	10800270000000	5673	2942	0	0	\N
25250	1608	10800270000000	6809	3524	4	0	\N
25252	1608	10800310000000	6809	3524	5	0	\N
25262	1608	11658502000000	25475	12617	1	0	\N
25263	1608	11805571000000	14694	7483	4	0	\N
25266	1608	11805593000000	14694	7483	5	0	\N
25267	1608	12240320000000	7638	3953	1	0	\N
25269	1608	12240330000000	7638	3953	2	0	\N
25271	1608	12378492000000	25226	12514	5	0	\N
25272	1608	12378492000000	25314	12558	5	0	\N
25274	1608	12378502000000	25475	12617	5	0	\N
25275	1608	12378505000000	25475	12617	6	0	\N
25276	1608	12378506000000	25226	12514	6	0	\N
25277	1608	12378506000000	25314	12558	6	0	\N
25279	1608	12378575000000	25794	12756	14	0	\N
25285	1608	13098575000000	25794	12756	18	0	\N
25286	1608	13098578000000	25794	12756	19	0	\N
25289	1608	13680340000000	8818	4572	3	0	\N
25290	1608	13680340000000	8953	4644	4	0	\N
25293	1608	13680370000000	8818	4572	4	0	\N
25294	1608	13680380000000	8953	4644	5	0	\N
25295	1608	13680420000000	9250	4799	6	0	\N
25185	1608	6480100000000	3920	2034	1	0	0
25186	1608	6480110000000	3920	2034	2	0	0
25192	1608	7200110000000	4123	2144	1	0	0
25193	1608	7200120000000	4123	2144	2	0	0
25201	1608	7920120000000	4468	2314	0	0	0
25213	1608	8640130000000	4859	2516	2	0	0
25229	1608	9360130000000	4994	2589	4	0	0
25230	1608	9360260000000	4994	2589	5	0	0
25241	1608	10080260000000	5031	2611	1	0	0
25242	1608	10080270000000	5031	2611	2	0	0
25253	1608	10800310000000	7021	3620	5	0	0
25258	1608	11520310000000	7434	3841	1	0	0
25259	1608	11520320000000	7434	3841	2	0	0
25268	1608	12240320000000	7646	3956	2	0	0
25282	1608	12960340000000	8008	4150	0	0	0
25291	1608	13680340000000	9012	4671	2	0	0
25292	1608	13680360000000	9012	4671	3	0	0
25163	1608	5325484000000	11533	5926	5	0	4
25164	1608	5325498000000	11533	5926	6	0	4
25184	1608	6045500000000	11758	6045	3	0	4
25190	1608	6765500000000	11914	6129	1	0	4
25191	1608	6765501000000	11914	6129	2	0	4
25198	1608	7485501000000	12671	6536	5	0	4
25199	1608	7485524000000	12671	6536	6	0	4
25211	1608	8205535000000	12742	6570	3	0	4
25226	1608	8925535000000	13215	6811	3	0	4
25228	1608	8925547000000	13215	6811	4	0	4
25236	1608	9645547000000	13599	6992	3	0	4
25246	1608	10365559000000	14074	7202	0	0	4
25256	1608	11085559000000	14592	7441	3	0	4
25257	1608	11085571000000	14592	7441	4	0	4
25264	1608	11805571000000	14729	7499	2	0	4
25265	1608	11805582000000	14729	7499	3	0	4
25281	1608	12525594000000	15321	7808	4	0	4
25287	1608	13245594000000	15327	7812	2	0	4
25288	1608	13245605000000	15327	7812	3	0	4
25165	1608	5480542000000	21223	10657	2	0	7
25167	1608	5480553000000	21223	10657	3	0	7
25162	1608	5178350000000	21712	10876	4	0	8
25179	1608	5898350000000	21885	10951	3	0	8
25180	1608	5898362000000	21885	10951	4	0	8
25187	1608	6618362000000	22193	11108	7	0	8
25194	1608	7338387000000	22386	11208	3	0	8
25195	1608	7338399000000	22386	11208	4	0	8
25205	1608	8058399000000	23186	11576	5	0	8
25206	1608	8058422000000	23186	11576	6	0	8
25219	1608	8778422000000	23985	11937	3	0	8
25231	1608	9498434000000	24382	12126	4	0	8
25234	1608	9498456000000	24382	12126	5	0	8
25243	1608	10218456000000	24391	12129	3	0	8
25244	1608	10218468000000	24391	12129	4	0	8
25254	1608	10938468000000	24847	12336	4	0	8
25260	1608	11658481000000	24970	12393	2	0	8
25261	1608	11658492000000	24970	12393	3	0	8
25273	1608	12378492000000	25782	12752	6	0	8
25278	1608	12378516000000	25782	12752	7	0	8
25284	1608	13098527000000	26115	12907	3	0	8
25296	1608	13818527000000	26137	12920	4	0	8
25298	1608	13965605000000	15523	7900	6	0	\N
25301	1608	13965639000000	15523	7900	7	0	\N
25303	1608	14400420000000	9250	4799	25	0	\N
25304	1608	14400600000000	9250	4799	26	0	\N
25313	1608	15405630000000	17047	8633	4	0	\N
25315	1608	15405643000000	17047	8633	5	0	\N
25317	1608	15840380000000	9765	5061	11	0	\N
25319	1608	15840380000000	10183	5275	4	0	\N
25321	1608	15840420000000	10183	5275	5	0	\N
25322	1608	15840445000000	9765	5061	12	0	\N
25331	1608	16845677000000	17479	8850	8	0	\N
25334	1608	16845739000000	17479	8850	9	0	\N
25345	1608	18858621000000	27749	13709	2	0	\N
25347	1608	18858632000000	27749	13709	3	0	\N
25349	1608	18860095000000	29529	14341	94	0	\N
25350	1608	19005726000000	18590	9369	2	0	\N
25351	1608	19005726000000	18784	9465	3	0	\N
25353	1608	19005726000000	18959	9563	0	0	\N
25355	1608	19005737000000	18590	9369	3	0	\N
25356	1608	19005738000000	18784	9465	4	0	\N
25357	1608	19578645000000	28331	14006	6	0	\N
25358	1608	19578645000000	28411	14040	3	0	\N
25361	1608	19578666000000	28411	14040	4	0	\N
25362	1608	19578678000000	28331	14006	7	0	\N
25363	1608	19580095000000	29529	14341	98	0	\N
25364	1608	19580125000000	29529	14341	99	0	\N
25368	1608	20298656000000	30029	14784	5	0	\N
25369	1608	20298670000000	30029	14784	6	0	\N
25374	1608	21018671000000	30143	14831	4	0	\N
25375	1608	21018684000000	30143	14831	5	0	\N
25377	1608	21165762000000	19655	9900	3	0	\N
25378	1608	21165762000000	19741	9937	3	0	\N
25379	1608	21165762000000	20149	10141	3	0	\N
25380	1608	21165774000000	19655	9900	4	0	\N
25381	1608	21165774000000	19741	9937	4	0	\N
25382	1608	21165774000000	20149	10141	4	0	\N
25383	1608	21738689000000	30295	14893	7	0	\N
25384	1608	21738689000000	30304	14896	7	0	\N
25385	1608	21738689000000	30306	14895	8	0	\N
25386	1608	21738705000000	30295	14893	8	0	\N
25387	1608	21738714000000	30304	14896	8	0	\N
25388	1608	21738724000000	30306	14895	9	0	\N
25404	1610	2160061000000	10783	5565	4	0	\N
25407	1610	2160101000000	10783	5565	5	0	\N
25412	1610	2880081000000	11413	5863	1	0	\N
25414	1610	2880082000000	11413	5863	2	0	\N
25417	1610	3600070999950	20587	10357	4	0	\N
25418	1610	3600070999950	20590	10357	3	0	\N
25419	1610	3600070999950	20602	10364	2	0	\N
25420	1610	3600070999950	20606	10364	2	0	\N
25421	1610	3600070999950	20746	10430	7	0	\N
25424	1610	3600081999950	20602	10364	3	0	\N
25425	1610	3600081999950	20606	10364	3	0	\N
25426	1610	3600082999950	20590	10357	4	0	\N
25428	1610	3600092999950	20587	10357	5	0	\N
25429	1610	3600113999950	20746	10430	8	0	\N
25432	1610	4320080000000	1070	593	1	0	\N
25393	1610	1440010000000	361	206	1	0	0
25395	1610	1440020000000	361	206	2	0	0
25400	1610	2160020000000	523	294	3	0	0
25402	1610	2160050000000	523	294	4	0	0
25408	1610	2880050000000	906	503	2	0	0
25416	1610	3600070000000	937	521	1	0	0
25423	1610	3600080000000	937	521	2	0	0
25302	1608	14400360000000	9528	4941	0	0	0
25309	1608	15120360000000	9549	4953	2	0	0
25310	1608	15120380000000	9549	4953	3	0	0
25392	1610	720040000000	10156	5264	5	0	6
25318	1608	15840380000000	10181	5275	4	0	0
25320	1608	15840420000000	10181	5275	5	0	0
25327	1608	16560420000000	10249	5302	2	0	0
25335	1608	17280440000000	10502	5426	4	0	0
25336	1608	17280480000000	10502	5426	5	0	0
25397	1610	1440040000000	10539	5444	3	0	6
25399	1610	1440061000000	10539	5444	4	0	6
25405	1610	2160061000000	11165	5739	2	0	6
25413	1610	2880081000000	11826	6078	11	0	6
25415	1610	2880173000000	11826	6078	12	0	6
25430	1610	3600173000000	11871	6101	3	0	6
25431	1610	3600176000000	11871	6101	4	0	6
25299	1608	13965605000000	16520	8402	4	0	4
25307	1608	14685618000000	16601	8435	3	0	4
25308	1608	14685630000000	16601	8435	4	0	4
25314	1608	15405630000000	17142	8688	9	0	4
25316	1608	15405666000000	17142	8688	10	0	4
25326	1608	16125677000000	17353	8792	3	0	4
25332	1608	16845677000000	17780	8984	6	0	4
25333	1608	16845701000000	17780	8984	7	0	4
25339	1608	17565701000000	18404	9277	3	0	4
25340	1608	17565713000000	18404	9277	4	0	4
25344	1608	18285726000000	18526	9331	5	0	4
25352	1608	19005726000000	18957	9563	1	0	4
25354	1608	19005736000000	18957	9563	2	0	4
25365	1608	19725736000000	19561	9852	4	0	4
25366	1608	19725749000000	19561	9852	5	0	4
25372	1608	20445762000000	19576	9860	5	0	4
25394	1610	1440011999950	20246	10196	7	0	11
25396	1610	1440036999950	20246	10196	8	0	11
25398	1610	1440046999950	20320	10234	1	0	11
25403	1610	2160057999950	20320	10234	14	0	11
25409	1610	2880057999950	20493	10319	4	0	11
25411	1610	2880070999950	20493	10319	5	0	11
25422	1610	3600070999950	21801	10913	3	0	11
25427	1610	3600082999950	21801	10913	4	0	11
25305	1608	14538549000000	26168	12936	3	0	8
25306	1608	14538561000000	26168	12936	4	0	8
25311	1608	15258561000000	26279	12998	3	0	8
25312	1608	15258573000000	26279	12998	4	0	8
25323	1608	15978573000000	26902	13304	3	0	8
25329	1608	16698585000000	27108	13402	3	0	8
25330	1608	16698597000000	27108	13402	4	0	8
25337	1608	17418597000000	27371	13534	3	0	8
25338	1608	17418609000000	27371	13534	4	0	8
25342	1608	18138621000000	27569	13627	4	0	8
25346	1608	18858621000000	28013	13854	6	0	8
25348	1608	18858645000000	28013	13854	7	0	8
25359	1608	19578645000000	29528	14562	2	0	8
25360	1608	19578656000000	29528	14562	3	0	8
25370	1608	20298671000000	30028	14784	7	0	8
25373	1608	21018671000000	30142	14831	9	0	8
25376	1608	21018689000000	30142	14831	10	0	8
25434	1610	4320082999950	21963	10987	3	0	\N
25436	1610	4320090000000	1070	593	2	0	\N
25437	1610	4320094999950	21963	10987	4	0	\N
25440	1610	4320176000000	11955	6154	2	0	\N
25441	1610	4320176000000	12114	6239	1	0	\N
25443	1610	4320176000000	12157	6261	1	0	\N
25444	1610	4320177000000	12114	6239	2	0	\N
25445	1610	4320178000000	11955	6154	3	0	\N
25446	1610	4320186000000	12157	6261	2	0	\N
25448	1610	5040094999950	22098	11050	7	0	\N
25451	1610	5040110000000	1302	717	1	0	\N
25452	1610	5040110000000	1331	732	1	0	\N
25453	1610	5040110000000	1432	780	3	0	\N
25454	1610	5040110000000	1633	880	2	0	\N
25455	1610	5040110000000	2124	1120	2	0	\N
25457	1610	5040119999950	22098	11050	8	0	\N
25458	1610	5040120000000	1302	717	2	0	\N
25459	1610	5040120000000	1331	732	2	0	\N
25461	1610	5040130000000	1633	880	3	0	\N
25462	1610	5040130000000	2124	1120	3	0	\N
25463	1610	5040140000000	1432	780	4	0	\N
25464	1610	5040187000000	12408	6401	1	0	\N
25466	1610	5040188000000	12408	6401	2	0	\N
25468	1610	5760106999950	22322	11174	7	0	\N
25469	1610	5760106999950	22469	11243	3	0	\N
25471	1610	5760118999950	22469	11243	4	0	\N
25474	1610	5760131999950	22322	11174	8	0	\N
25482	1610	6480220000000	13119	6761	8	0	\N
25483	1610	6480220000000	13224	6815	3	0	\N
25484	1610	6480220000000	13226	6778	69	0	\N
25485	1610	6480220000000	13586	6988	4	0	\N
25486	1610	6480220000000	13854	7109	10	0	\N
25488	1610	6480232000000	13224	6815	4	0	\N
25489	1610	6480233000000	13586	6988	5	0	\N
25491	1610	6480239000000	13854	7109	11	0	\N
25492	1610	6480246000000	13119	6761	9	0	\N
25493	1610	6480910000000	13226	6778	70	0	\N
25494	1610	7200140999950	23315	11635	4	0	\N
25498	1610	7200162999950	23315	11635	5	0	\N
25502	1610	7920152999950	23830	11862	7	0	\N
25505	1610	7920177999950	23830	11862	8	0	\N
25506	1610	7920180000000	3890	1854	0	0	\N
25508	1610	7920190000000	3888	1840	0	0	\N
25509	1610	7920190000000	3891	1872	0	0	\N
25510	1610	7920190000000	3892	1889	0	0	\N
25520	1610	9360187999950	25316	12558	5	0	\N
25522	1610	9360201999950	25316	12558	6	0	\N
25523	1610	9360220000000	4053	2106	2	0	\N
25524	1610	9360220000000	4087	2124	1	0	\N
25527	1610	9360230000000	4087	2124	2	0	\N
25529	1610	9360240000000	4053	2106	3	0	\N
25530	1610	9360279000000	14948	7615	5	0	\N
25533	1610	9360302000000	14948	7615	6	0	\N
25534	1610	10080224999950	26025	12862	2	0	\N
25535	1610	10080224999950	26208	12957	4	0	\N
25537	1610	10080230000000	4565	2361	3	0	\N
25539	1610	10080235999950	26025	12862	3	0	\N
25540	1610	10080237999950	26208	12957	5	0	\N
25542	1610	10080290000000	15170	7731	4	0	\N
25544	1610	10080290000000	15534	7905	5	0	\N
25545	1610	10080303000000	15170	7731	5	0	\N
25546	1610	10080313000000	15534	7905	6	0	\N
25548	1610	10080440000000	4565	2361	4	0	\N
25549	1610	10800237999950	26415	13068	18	0	\N
25551	1610	10800237999950	27116	13406	3	0	\N
25552	1610	10800249999950	27116	13406	4	0	\N
25554	1610	10800290000000	15560	7920	6	0	\N
25555	1610	10800290000000	15630	7957	3	0	\N
25556	1610	10800290000000	16304	8285	3	0	\N
25558	1610	10800300999950	26415	13068	19	0	\N
25559	1610	10800302000000	15630	7957	4	0	\N
25560	1610	10800302000000	16304	8285	4	0	\N
25562	1610	10800340000000	4642	2400	1	0	\N
25564	1610	10800350000000	4642	2400	2	0	\N
25566	1610	10800350000000	15560	7920	7	0	\N
25456	1610	5040110000000	2277	1194	1	0	0
25460	1610	5040120000000	2277	1194	2	0	0
25473	1610	5760120000000	2623	1379	2	0	0
25475	1610	5760140000000	2623	1379	3	0	0
25479	1610	6480140000000	3114	1617	1	0	0
25496	1610	7200150000000	3128	1627	4	0	0
25499	1610	7200190000000	3128	1627	5	0	0
25507	1610	7920190000000	3847	1998	1	0	0
25511	1610	7920200000000	3847	1998	2	0	0
25516	1610	8640200000000	3889	2020	2	0	0
25525	1610	9360220000000	4209	2190	1	0	0
25528	1610	9360230000000	4209	2190	2	0	0
25538	1610	10080230000000	4566	2361	2	0	0
25547	1610	10080340000000	4566	2361	3	0	0
25565	1610	10800350000000	4864	2518	2	0	0
25442	1610	4320176000000	12156	6261	2	0	6
25447	1610	4320187000000	12156	6261	3	0	6
25465	1610	5040187000000	12536	6461	4	0	6
25467	1610	5040209000000	12536	6461	5	0	6
25477	1610	5760220000000	12933	6665	3	0	6
25487	1610	6480220000000	14207	7251	4	0	6
25490	1610	6480233000000	14207	7251	5	0	6
25500	1610	7200233000000	14324	7308	4	0	6
25501	1610	7200246000000	14324	7308	5	0	6
25513	1610	7920268000000	14784	7529	5	0	6
25518	1610	8640268000000	14786	7530	2	0	6
25519	1610	8640279000000	14786	7530	3	0	6
25531	1610	9360279000000	15090	7688	2	0	6
25543	1610	10080290000000	15533	7905	0	0	6
25557	1610	10800290000000	16496	8390	13	0	6
25561	1610	10800339000000	16496	8390	14	0	6
25435	1610	4320082999950	22026	11012	3	0	11
25438	1610	4320094999950	22026	11012	4	0	11
25450	1610	5040106999950	22139	11074	4	0	11
25470	1610	5760106999950	23091	11530	3	0	11
25472	1610	5760118999950	23091	11530	4	0	11
25478	1610	6480118999950	23291	11621	4	0	11
25480	1610	6480140999950	23291	11621	5	0	11
25497	1610	7200152999950	23588	11754	4	0	11
25503	1610	7920152999950	24499	12184	2	0	11
25504	1610	7920163999950	24499	12184	3	0	11
25514	1610	8640163999950	24902	12365	6	0	11
25521	1610	9360187999950	25692	12713	10	0	11
25526	1610	9360224999950	25692	12713	11	0	11
25536	1610	10080224999950	26210	12957	4	0	11
25541	1610	10080237999950	26210	12957	5	0	11
25550	1610	10800237999950	27115	13406	4	0	11
25567	1610	11520259999950	27176	13441	3	0	11
25568	1610	11520271999950	27176	13441	4	0	11
25570	1610	11520350000000	5001	2593	1	0	\N
25573	1610	11520360000000	5001	2593	2	0	\N
25575	1610	12240271999950	27186	13447	2	0	\N
25576	1610	12240271999950	27190	13447	3	0	\N
25577	1610	12240271999950	27232	13466	3	0	\N
25579	1610	12240282999950	27186	13447	3	0	\N
25580	1610	12240283999950	27190	13447	4	0	\N
25581	1610	12240283999950	27232	13466	4	0	\N
25589	1610	12960373000000	16973	8600	2	0	\N
25591	1610	12960384000000	16973	8600	3	0	\N
25597	1610	13680398000000	17112	8671	2	0	\N
25598	1610	13680398000000	17115	8648	84	0	\N
25600	1610	13680409000000	17112	8671	3	0	\N
25604	1610	13680433000000	17927	9043	4	0	\N
25605	1610	13680761000000	17115	8648	85	0	\N
25608	1610	14400420000000	6307	3265	5	0	\N
25609	1610	14400420000000	7014	3616	2	0	\N
25611	1610	14400420000000	17691	8942	2	0	\N
25612	1610	14400420000000	18078	9117	2	0	\N
25614	1610	14400431000000	17691	8942	3	0	\N
25615	1610	14400431000000	18078	9117	3	0	\N
25616	1610	14400433000000	17927	9043	5	0	\N
25617	1610	14400440000000	7014	3616	3	0	\N
25620	1610	14400650000000	6307	3265	6	0	\N
25626	1610	15120532000000	18692	9416	7	0	\N
25628	1610	15120566000000	18692	9416	8	0	\N
25631	1610	15840490000000	7624	3874	6	0	\N
25634	1610	15840536000000	7624	3874	7	0	\N
25637	1610	15840952999950	28573	14093	51	0	\N
25640	1610	16560510000000	7981	4136	3	0	\N
25641	1610	16560510000000	7987	4141	3	0	\N
25644	1610	16560540000000	7981	4136	4	0	\N
25645	1610	16560540000000	7987	4141	4	0	\N
25646	1610	16560585019950	19008	9585	1	0	\N
25647	1610	16560585019950	19080	9624	1	0	\N
25649	1610	16560595019950	19008	9585	2	0	\N
25650	1610	16560595019950	19080	9624	2	0	\N
25652	1610	16560952999950	28573	14093	98	0	\N
25653	1610	16561247999950	28573	14093	99	0	\N
25654	1610	16561893999950	28672	14094	79	0	\N
25661	1610	17281893999950	28672	14094	119	0	\N
25662	1610	17281932999950	28672	14094	120	0	\N
25663	1610	18000427999950	28909	14259	3	0	\N
25664	1610	18000427999950	28964	14285	1	0	\N
25665	1610	18000427999950	28966	14285	5	0	\N
25667	1610	18000428999950	28964	14285	2	0	\N
25668	1610	18000439999950	28909	14259	4	0	\N
25669	1610	18000450999950	28966	14285	6	0	\N
25675	1610	18720451999950	29137	14367	6	0	\N
25677	1610	18720451999950	29535	14441	0	0	\N
25678	1610	18720451999950	29539	14458	0	0	\N
25679	1610	18720451999950	29540	14475	0	0	\N
25681	1610	18720475999950	29137	14367	7	0	\N
25684	1610	18720680000000	8293	4295	2	0	\N
25685	1610	18720680000000	8546	4428	2	0	\N
25687	1610	18720700000000	8293	4295	3	0	\N
25688	1610	18720700000000	8546	4428	3	0	\N
25697	1610	20160485999950	29536	14564	3	0	\N
25699	1610	20160497999950	29536	14564	4	0	\N
25585	1610	12240380000000	5781	3000	1	0	0
25586	1610	12240390000000	5781	3000	2	0	0
25592	1610	12960390000000	6077	3156	2	0	0
25594	1610	12960410000000	6077	3156	3	0	0
25601	1610	13680410000000	6257	3239	1	0	0
25610	1610	14400420000000	7023	3621	6	0	0
25618	1610	14400480000000	7023	3621	7	0	0
25623	1610	15120480000000	7139	3689	1	0	0
25624	1610	15120490000000	7139	3689	2	0	0
25632	1610	15840490000000	7626	3945	2	0	0
25642	1610	16560510000000	8056	4174	1	0	0
25643	1610	16560520000000	8056	4174	2	0	0
25657	1610	17280520000000	8076	4187	2	0	0
25658	1610	17280540000000	8076	4187	3	0	0
25674	1610	18000680000000	8124	4212	6	0	0
25686	1610	18720680000000	8590	4454	2	0	0
25689	1610	18720700000000	8590	4454	3	0	0
25694	1610	19440700000000	8666	4487	1	0	0
25695	1610	19440710000000	8666	4487	2	0	0
25702	1610	20160750000000	8883	4602	5	0	0
25569	1610	11520339000000	16849	8550	3	0	6
25572	1610	11520351000000	16849	8550	4	0	6
25583	1610	12240351000000	16926	8579	4	0	6
25584	1610	12240373000000	16926	8579	5	0	6
25593	1610	12960398000000	17014	8619	8	0	6
25599	1610	13680398000000	17430	8830	4	0	6
25603	1610	13680420000000	17430	8830	5	0	6
25613	1610	14400420000000	18557	9352	4	0	6
25625	1610	15120532000000	18691	9416	7	0	6
25627	1610	15120539019950	18691	9416	8	1	6
25635	1610	15840539019950	18712	9426	10	0	6
25636	1610	15840585019950	18712	9426	11	0	6
25648	1610	16560585019950	19146	9658	3	0	6
25659	1610	17280597019950	19149	9660	4	0	6
25660	1610	17280610019950	19149	9660	5	0	6
25672	1610	18000610019950	19457	9807	4	0	6
25673	1610	18000623019950	19457	9807	5	0	6
25682	1610	18720623019950	19509	9832	4	0	6
25692	1610	19440636019950	19566	9856	4	0	6
25693	1610	19440649019950	19566	9856	5	0	6
25696	1610	19440789019950	20052	10094	14	0	6
25703	1610	20160789019950	20052	10094	32	0	6
25578	1610	12240271999950	27319	13505	6	0	11
25582	1610	12240295999950	27319	13505	7	0	11
25587	1610	12960295999950	27364	13530	4	0	11
25588	1610	12960308999950	27364	13530	5	0	11
25595	1610	13680308999950	27481	13581	18	0	11
25606	1610	14400344999950	27503	13595	6	0	11
25607	1610	14400368999950	27503	13595	7	0	11
25621	1610	15120368999950	27861	13773	3	0	11
25622	1610	15120380999950	27861	13773	4	0	11
25629	1610	15840380999950	28365	14023	2	0	11
25638	1610	16560391999950	28572	14113	6	0	11
25639	1610	16560415999950	28572	14113	7	0	11
25655	1610	17280415999950	28671	14155	3	0	11
25656	1610	17280427999950	28671	14155	4	0	11
25670	1610	18000451999950	29125	14359	7	0	11
25676	1610	18720451999950	29374	14479	5	0	11
25680	1610	18720474999950	29374	14479	6	0	11
25690	1610	19440474999950	29503	14549	2	0	11
25691	1610	19440485999950	29503	14549	3	0	11
25700	1610	20160503999950	29676	14638	10	0	11
25705	1610	20880503999950	29829	14698	6	0	\N
25707	1610	20880518999950	29829	14698	7	0	\N
25714	1610	21600521999950	30184	14849	8	0	\N
25715	1610	21600538999950	30184	14849	9	0	\N
25717	1610	21600790000000	9440	4895	2	0	\N
25718	1610	21600790000000	9683	5024	2	0	\N
25719	1610	21600810000000	9440	4895	3	0	\N
25720	1610	21600810000000	9683	5024	3	0	\N
25721	1610	22320539999950	30288	14892	5	0	\N
25722	1610	22320539999950	30290	14892	13	0	\N
25723	1610	22320562999950	30288	14892	6	0	\N
25724	1610	22320570999950	30290	14892	14	0	\N
25725	1611	274999975	21365	10722	8	0	\N
25726	1611	720000000000	199	117	1	0	\N
25728	1611	720010000000	199	117	2	0	\N
25730	1611	1440010000000	821	454	1	0	\N
25732	1611	1440020000000	821	454	2	0	\N
25734	1611	2160020000000	1247	690	1	0	\N
25735	1611	2160020000000	1572	856	1	0	\N
25737	1611	2160030000000	1247	690	2	0	\N
25738	1611	2160030000000	1572	856	2	0	\N
25742	1611	2880030000000	1707	917	2	0	\N
25744	1611	2880050000000	1707	917	3	0	\N
25746	1611	3015107000000	21365	10722	4	0	\N
25747	1611	3593499402899	27237	13467	2	0	\N
25749	1611	3593510402899	27237	13467	3	0	\N
25751	1611	3600050000000	2641	1388	1	0	\N
25752	1611	3600050000000	2712	1424	1	0	\N
25753	1611	3600050000000	2951	1530	0	0	\N
25754	1611	3600050000000	3630	1881	0	0	\N
25755	1611	3600050000000	3677	1908	1	0	\N
25757	1611	3600060000000	2641	1388	2	0	\N
25758	1611	3600060000000	2712	1424	2	0	\N
25759	1611	3600060000000	3677	1908	2	0	\N
25763	1611	3735107000000	21365	10722	7	0	\N
25766	1611	4313511402899	27702	13687	6	0	\N
25767	1611	4313511402899	27801	13737	4	0	\N
25770	1611	4313524402899	27801	13737	5	0	\N
25771	1611	4313544402899	27702	13687	7	0	\N
25772	1611	4314271402899	29105	14302	73	0	\N
25773	1611	4320050000000	3176	1531	2	0	\N
25774	1611	4320070000000	3961	2059	1	0	\N
25776	1611	4320080000000	3961	2059	2	0	\N
25778	1611	4320250000000	3176	1531	3	0	\N
25779	1611	4321400000000	3350	1532	79	0	\N
25786	1611	5033523402899	28371	14025	2	0	\N
25787	1611	5033523402899	28973	14287	4	0	\N
25788	1611	5033534402899	28371	14025	3	0	\N
25789	1611	5033536402899	28973	14287	5	0	\N
25790	1611	5034271402899	29105	14302	126	0	\N
25791	1611	5034323402899	29105	14302	127	0	\N
25794	1611	5041399999992	3350	1532	80	0	\N
25804	1611	5761399999984	3443	1533	0	0	\N
25807	1611	6242386241757	25805	12759	3	0	\N
25808	1611	6242386241757	25959	12827	4	0	\N
25810	1611	6242398241757	25805	12759	4	0	\N
25811	1611	6242408241757	25959	12827	5	0	\N
25821	1611	7335660000000	22333	11177	11	0	\N
25822	1611	7335660000000	22587	11300	4	0	\N
25824	1611	7335673000000	22587	11300	5	0	\N
25826	1611	7335698000000	22333	11177	12	0	\N
25828	1611	8055697000000	23114	11479	0	0	\N
25829	1611	8055697000000	23491	11712	3	0	\N
25831	1611	8055709000000	23491	11712	4	0	\N
25834	1611	8775697000000	23250	11480	7	0	\N
25835	1611	8775709000000	23666	11786	4	0	\N
25838	1611	8775722000000	23666	11786	5	0	\N
25839	1611	8775812000000	23250	11480	8	0	\N
25731	1611	1440010000000	1228	677	1	0	0
25733	1611	1440020000000	1228	677	2	0	0
25736	1611	2160020000000	1679	901	1	0	0
25739	1611	2160030000000	1679	901	2	0	0
25743	1611	2880030000000	2435	1274	2	0	0
25756	1611	3600050000000	3925	2036	2	0	0
25760	1611	3600070000000	3925	2036	3	0	0
25775	1611	4320070000000	3983	2068	1	0	0
25777	1611	4320080000000	3983	2068	2	0	0
25792	1611	5040080000000	4577	2368	2	0	0
25802	1611	5760100000000	5217	2713	1	0	0
25803	1611	5760110000000	5217	2713	2	0	0
25815	1611	6480110000000	5462	2842	0	0	0
25820	1611	7200110000000	5465	2845	0	0	0
25833	1611	8640110000000	5561	2891	0	0	0
25840	1611	9360110000000	5575	2899	0	0	0
25709	1610	20880750000000	9163	4748	4	0	0
25710	1610	20880790000000	9163	4748	5	0	0
25711	1610	20880941019950	20138	10137	3	0	6
25761	1611	3735085000000	21859	10938	3	0	9
25762	1611	3735097000000	21859	10938	4	0	9
25780	1611	4455097000000	22041	11022	4	0	9
25781	1611	4455110000000	22041	11022	5	0	9
25795	1611	5175110000000	22169	11089	6	0	9
25797	1611	5175543000000	22185	11101	2	0	9
25805	1611	5895543000000	22185	11101	8	0	9
25806	1611	5895548000000	22185	11101	9	0	9
25816	1611	6615548000000	22222	11124	4	0	9
25823	1611	7335660000000	22662	11330	10	0	9
25825	1611	7335697000000	22662	11330	11	0	9
25830	1611	8055697000000	23501	11715	3	0	9
25832	1611	8055709000000	23501	11715	4	0	9
25836	1611	8775709000000	23979	11934	3	0	9
25764	1611	4082354241757	24433	12150	2	0	13
25765	1611	4082365241757	24433	12150	3	0	13
25782	1611	4802365241757	24438	12153	2	0	13
25783	1611	4802376241757	24438	12153	3	0	13
25798	1611	5522376241757	25225	12513	1	0	13
25809	1611	6242386241757	25966	12829	5	0	13
25812	1611	6242409241757	25966	12829	6	0	13
25740	1611	2873488402899	27112	13404	2	0	18
25741	1611	2873499402899	27112	13404	3	0	18
25750	1611	3593511402899	27522	13607	4	0	18
25768	1611	4313511402899	27876	13782	3	0	18
25769	1611	4313523402899	27876	13782	4	0	18
25784	1611	5032523402899	29209	14396	3	0	18
25785	1611	5032535402899	29209	14396	4	0	18
25801	1611	5752560402899	29490	14541	8	0	18
25813	1611	6472560402899	29629	14611	3	0	18
25814	1611	6472572402899	29629	14611	4	0	18
25706	1610	20880503999950	30013	14780	9	0	11
25708	1610	20880521999950	30013	14780	10	0	11
25819	1611	7192590392899	30085	14812	10	0	18
25713	1610	21600521999950	30183	14849	9	0	11
25716	1610	21600539999950	30183	14849	10	0	11
25843	1611	10080110000000	5893	3054	5	0	\N
25844	1611	10080110000000	5918	3067	3	0	\N
25846	1611	10080140000000	5918	3067	4	0	\N
25847	1611	10080160000000	5893	3054	6	0	\N
25849	1611	10215732000000	24271	12075	4	0	\N
25850	1611	10215745000000	24271	12075	5	0	\N
25853	1611	11520200000000	7147	3693	1	0	\N
25855	1611	11520210000000	7147	3693	2	0	\N
25859	1611	12950210000000	8116	4208	1	0	\N
25861	1611	12950220000000	8116	4208	2	0	\N
25863	1611	13670230000000	8285	4290	1	0	\N
25864	1611	13670230000000	8474	4389	1	0	\N
25865	1611	13670230000000	8500	4402	1	0	\N
25867	1611	13670240000000	8285	4290	2	0	\N
25868	1611	13670240000000	8474	4389	2	0	\N
25869	1611	13670240000000	8500	4402	2	0	\N
25880	1611	15830310000000	8946	4640	2	0	\N
25881	1611	15830310000000	9086	4687	35	0	\N
25883	1611	15830330000000	8946	4640	3	0	\N
25885	1611	15830660000000	10006	5187	6	0	\N
25886	1611	15830750000000	9086	4687	36	0	\N
25889	1611	16550600000000	9570	4962	9	0	\N
25890	1611	16550600000000	9612	4987	2	0	\N
25892	1611	16550620000000	9612	4987	3	0	\N
25894	1611	16550660000000	10006	5187	17	0	\N
25895	1611	16550670000000	10006	5187	18	0	\N
25896	1611	16550681000000	9570	4962	10	0	\N
25901	1611	17343067000000	19937	10040	2	0	\N
25903	1611	17343078000000	19937	10040	3	0	\N
25904	1611	17990840000000	10567	5457	2	0	\N
25905	1611	17990840000000	11166	5739	2	0	\N
25906	1611	17990840000000	11271	5790	3	0	\N
25909	1611	17990860000000	10567	5457	3	0	\N
25910	1611	17990860000000	11166	5739	3	0	\N
25911	1611	17990861000000	11271	5790	4	0	\N
25914	1611	18710851000000	11359	5833	1	0	\N
25917	1611	18710861000000	11359	5833	2	0	\N
25918	1611	19430852000000	11632	5986	1	0	\N
25920	1611	19430853000000	11632	5986	2	0	\N
25928	1611	23030876000000	12743	6570	2	0	\N
25929	1611	23030876000000	13098	6751	4	0	\N
25930	1611	23030876000000	14392	7343	1	0	\N
25931	1611	23030876000000	14549	7419	0	0	\N
25933	1611	23030886000000	14392	7343	2	0	\N
25934	1611	23030887000000	12743	6570	3	0	\N
25935	1611	23030889000000	13098	6751	5	0	\N
25943	1611	25910967000000	15722	7994	3	0	\N
25944	1611	25910967000000	15883	8076	3	0	\N
25945	1611	25910967000000	16395	8339	10	0	\N
25946	1611	25910967000000	16547	8410	6	0	\N
25948	1611	25910979000000	15722	7994	4	0	\N
25949	1611	25910979000000	15883	8076	4	0	\N
25951	1611	25911004000000	16395	8339	11	0	\N
25952	1611	25911018000000	16547	8410	7	0	\N
25955	1611	27350990000000	16829	8541	3	0	\N
25956	1611	27350990000000	17049	8634	2	0	\N
25957	1611	27350990000000	17139	8685	2	0	\N
25959	1611	27350992000000	17049	8634	3	0	\N
25960	1611	27351001000000	17139	8685	3	0	\N
25961	1611	27351002000000	16829	8541	4	0	\N
25963	1611	28071002000000	17628	8913	6	0	\N
25966	1611	28071026000000	17628	8913	7	0	\N
25967	1611	28791014000000	17864	9015	4	0	\N
25968	1611	28791027000000	17864	9015	5	0	\N
25969	1613	200000003	21788	10908	4	0	\N
25972	1613	1438000000000	435	247	1	0	\N
25973	1613	1438000000000	470	263	4	0	\N
25974	1613	1438000000000	710	397	1	0	\N
25975	1613	1438000000000	803	444	2	0	\N
25976	1613	1438000000000	1702	916	1	0	\N
25845	1611	10080110000000	6626	3426	7	0	0
25848	1611	10080180000000	6626	3426	8	0	0
25851	1611	10800180000000	6834	3537	2	0	0
25852	1611	10800200000000	6834	3537	3	0	0
25854	1611	11520200000000	7327	3787	1	0	0
25857	1611	12230200000000	7507	3886	1	0	1
25858	1611	12230210000000	7507	3886	2	0	1
25860	1611	12950210000000	8147	4223	2	0	1
25862	1611	12950230000000	8147	4223	3	0	1
25866	1611	13670230000000	8676	4495	0	0	1
25873	1611	14390250000000	8736	4531	3	0	1
25876	1611	15110250000000	8832	4579	6	0	1
25877	1611	15110310000000	8832	4579	7	0	1
25882	1611	15830310000000	9494	4925	5	0	1
25891	1611	16550600000000	10219	5291	2	0	1
25893	1611	16550620000000	10219	5291	3	0	1
25899	1611	17270620000000	10494	5422	22	0	1
25900	1611	17270840000000	10494	5422	23	0	1
25907	1611	17990840000000	11336	5822	2	0	1
25915	1611	18710851000000	11575	5951	1	0	1
25916	1611	18710852000000	11575	5951	2	0	1
25919	1611	19430852000000	11913	6128	1	0	1
25921	1611	19430853000000	11913	6128	2	0	1
25922	1611	20150853000000	12456	6418	0	0	1
25924	1611	20870854000000	12483	6434	2	0	1
25925	1611	21590854000000	12549	6466	0	0	1
25926	1611	22310854000000	12677	6538	4	0	1
25927	1611	22310876000000	12677	6538	5	0	1
25936	1611	23030934000000	14945	7613	14	0	1
25937	1611	23750934000000	15045	7664	2	0	1
25938	1611	23750945000000	15045	7664	3	0	1
25939	1611	24470945000000	15175	7732	1	0	1
25940	1611	24470955000000	15175	7732	2	0	1
25942	1611	25190967000000	15641	7959	4	0	1
25947	1611	25910967000000	16561	8417	3	0	1
25950	1611	25910979000000	16561	8417	4	0	1
25953	1611	26630979000000	16816	8534	2	0	1
25954	1611	26630990000000	16816	8534	3	0	1
25962	1611	27351002000000	17179	8707	4	0	1
25964	1611	28071002000000	17777	8982	3	0	1
25965	1611	28071014000000	17777	8982	4	0	1
25870	1611	13743010000000	18994	9577	2	0	5
25874	1611	14463021000000	19069	9617	1	0	5
25875	1611	14463031000000	19069	9617	2	0	5
25878	1611	15183031000000	19378	9768	3	0	5
25879	1611	15183043000000	19378	9768	4	0	5
25887	1611	15903043000000	19770	9953	3	0	5
25897	1611	16623055000000	19870	10009	3	0	5
25898	1611	16623067000000	19870	10009	4	0	5
25902	1611	17343067000000	21136	10614	0	0	5
25912	1611	18063067000000	21226	10659	4	0	5
25913	1611	18063089000000	21226	10659	5	0	5
25842	1611	9495732000000	24161	12025	3	0	9
25977	1613	1438000000000	1815	971	2	0	\N
25979	1613	1438010000000	435	247	2	0	\N
25980	1613	1438010000000	710	397	2	0	\N
25981	1613	1438010000000	1702	916	2	0	\N
25982	1613	1438020000000	803	444	3	0	\N
25983	1613	1438020000000	1815	971	3	0	\N
25984	1613	1438040000000	470	263	5	0	\N
25987	1613	2158000000000	1833	979	1	0	\N
25989	1613	2158010000000	1833	979	2	0	\N
25990	1613	2807681600000	11857	6094	2	0	\N
25992	1613	2807683600000	11857	6094	3	0	\N
25994	1613	2809183600000	12552	6352	3	0	\N
25995	1613	2878000000000	2413	1263	1	0	\N
25997	1613	2878010000000	2413	1263	2	0	\N
26001	1613	3529183600000	12552	6352	126	0	\N
26002	1613	3530200600000	12552	6352	127	0	\N
26003	1613	3598010000000	2459	1287	1	0	\N
26005	1613	3598020000000	2459	1287	2	0	\N
26015	1613	5038100000000	2908	1517	4	0	\N
26018	1613	5758060000000	2867	1500	3	0	\N
26020	1613	5758090000000	2867	1500	4	0	\N
26022	1613	5758100000000	2908	1517	5	0	\N
26025	1613	6478090000000	3219	1673	1	0	\N
26027	1613	6478100000000	3219	1673	2	0	\N
26031	1613	7198110000000	4510	2333	1	0	\N
26032	1613	7198110000000	4511	2305	54	0	\N
26034	1613	7198120000000	4510	2333	2	0	\N
26036	1613	7199091000000	4511	2305	55	0	\N
26037	1613	7199141000000	4533	2306	5	0	\N
26038	1613	7847812600000	14048	7193	11	0	\N
26041	1613	7847842600000	14048	7193	12	0	\N
26045	1613	7919141000000	4533	2306	14	0	\N
26046	1613	7919221000000	4533	2306	15	0	\N
26047	1613	8497232200000	24097	11996	2	0	\N
26048	1613	8497243200000	24097	11996	3	0	\N
26049	1613	8567824600000	14254	7277	8	0	\N
26052	1613	8567850600000	14254	7277	9	0	\N
26055	1613	9217232200000	24163	12027	8	0	\N
26057	1613	9217276200000	24163	12027	9	0	\N
26059	1613	9217308200000	24584	12222	5	0	\N
26060	1613	9217308200000	24587	12222	5	0	\N
26062	1613	9287844600000	14470	7383	16	0	\N
26064	1613	9287896600000	14470	7383	17	0	\N
26065	1613	9288236600000	14562	7384	25	0	\N
26066	1613	9358410000000	5419	2819	0	0	\N
26068	1613	9937276200000	24431	12149	3	0	\N
26070	1613	9937288200000	24431	12149	4	0	\N
26071	1613	9937308200000	24584	12222	8	0	\N
26072	1613	9937308200000	24587	12222	8	0	\N
26073	1613	9937310200000	24584	12222	9	0	\N
26074	1613	9937310200000	24587	12222	9	0	\N
26078	1613	10008236600000	14562	7384	126	0	\N
26079	1613	10008759600000	14562	7384	127	0	\N
26085	1613	10798410000000	6024	3125	2	0	\N
26088	1613	10798430000000	6024	3125	3	0	\N
26089	1613	11377350200000	24959	12386	2	0	\N
26090	1613	11377350200000	24960	12386	3	0	\N
26092	1613	11377361200000	24959	12386	3	0	\N
26094	1613	11377362200000	24960	12386	4	0	\N
26096	1613	11377391200000	25571	12660	3	0	\N
26097	1613	11447901600000	15180	7735	6	0	\N
26099	1613	11447901600000	15223	7755	2	0	\N
26101	1613	11447912600000	15223	7755	3	0	\N
26102	1613	11447952600000	15180	7735	7	0	\N
26106	1613	12097391190000	25571	12660	4	0	\N
26109	1613	12238440000000	6612	3419	2	0	\N
26110	1613	12238440000000	6671	3447	4	0	\N
26112	1613	12238460000000	6612	3419	3	0	\N
25996	1613	2878000000000	2432	1273	1	0	2
25998	1613	2878010000000	2432	1273	2	0	2
26004	1613	3598010000000	2506	1314	1	0	2
26006	1613	3598020000000	2506	1314	2	0	2
26009	1613	4318020000000	2580	1360	3	0	2
26013	1613	5038050000000	2615	1376	1	0	2
26014	1613	5038060000000	2615	1376	2	0	2
26019	1613	5758060000000	2969	1543	3	0	2
26021	1613	5758090000000	2969	1543	4	0	2
26026	1613	6478090000000	3361	1747	2	0	2
26033	1613	7198110000000	4532	2344	1	0	2
26035	1613	7198120000000	4532	2344	2	0	2
26042	1613	7918120000000	4929	2551	3	0	2
26043	1613	7918150000000	4929	2551	4	0	2
26054	1613	8638410000000	5196	2702	2	0	2
26067	1613	9358410000000	5447	2834	0	0	2
26080	1613	10078410000000	5720	2965	0	0	2
26086	1613	10798410000000	6278	3251	1	0	2
26087	1613	10798420000000	6278	3251	2	0	2
26104	1613	11518440000000	6534	3386	3	0	2
26111	1613	12238440000000	6682	3454	3	0	2
25985	1613	2087680600000	11570	5948	1	0	6
25986	1613	2087681600000	11570	5948	2	0	6
25991	1613	2807681600000	12062	6208	2	0	6
25999	1613	3527683600000	12553	6468	6	0	6
26000	1613	3527716600000	12553	6468	7	0	6
26007	1613	4247716600000	12753	6574	10	0	6
26008	1613	4247753600000	12753	6574	11	0	6
26012	1613	4967775600000	12925	6662	5	0	6
26016	1613	5687775600000	12952	6677	2	0	6
26017	1613	5687786600000	12952	6677	3	0	6
26023	1613	6407786600000	13434	6923	4	0	6
26024	1613	6407799600000	13434	6923	5	0	6
26030	1613	7127812600000	13944	7145	5	0	6
26039	1613	7847812600000	14147	7223	3	0	6
26040	1613	7847824600000	14147	7223	4	0	6
26050	1613	8567824600000	14255	7277	2	0	6
26051	1613	8567844600000	14255	7277	3	0	6
26063	1613	9287857600000	14469	7385	5	0	6
26076	1613	10007857600000	14561	7426	2	0	6
26077	1613	10007868600000	14561	7426	3	0	6
26083	1613	10727868600000	14970	7626	6	0	6
26098	1613	11447901600000	15222	7755	2	0	6
26100	1613	11447912600000	15222	7755	3	0	6
26107	1613	12167912600000	15265	7776	1	0	6
26108	1613	12167922600000	15265	7776	2	0	6
26056	1613	9217232200000	24164	12027	8	0	10
26069	1613	9937276200000	24738	12284	8	0	10
26075	1613	9937338200000	24738	12284	9	0	10
26081	1613	10657338200000	24854	12341	3	0	10
26082	1613	10657350200000	24854	12341	4	0	10
26091	1613	11377350200000	25010	12408	2	0	10
26095	1613	11377391200000	25570	12660	3	0	10
26105	1613	12097381400000	25570	12660	4	0	10
26114	1613	12238480000000	6671	3447	5	0	\N
26119	1613	12958470000000	7048	3637	4	0	\N
26122	1613	12958510000000	7048	3637	5	0	\N
26125	1613	13537437400000	26510	13116	5	0	\N
26130	1613	14257405400000	26569	13146	3	0	\N
26132	1613	14257417400000	26569	13146	4	0	\N
26134	1613	14257437400000	26510	13116	11	0	\N
26135	1613	14257442400000	26510	13116	12	0	\N
26136	1613	14258117400000	27720	13610	70	0	\N
26139	1613	14328196600000	16306	8264	23	0	\N
26140	1613	14398610000000	7753	4019	1	0	\N
26142	1613	14398620000000	7753	4019	2	0	\N
26144	1613	14977417400000	26758	13233	6	0	\N
26145	1613	14977417400000	27354	13524	6	0	\N
26146	1613	14977417400000	27718	13695	2	0	\N
26148	1613	14977428400000	27718	13695	3	0	\N
26149	1613	14977441400000	26758	13233	7	0	\N
26150	1613	14977441400000	27354	13524	7	0	\N
26152	1613	14978117400000	27720	13610	126	0	\N
26153	1613	14978667400000	27720	13610	127	0	\N
26156	1613	15048196600000	16306	8264	96	0	\N
26157	1613	15048322600000	16306	8264	97	0	\N
26158	1613	15118620000000	8387	4346	1	0	\N
26159	1613	15118620000000	8388	4232	126	0	\N
26160	1613	15118620000000	8490	4398	3	0	\N
26162	1613	15118630000000	8387	4346	2	0	\N
26164	1613	15118650000000	8490	4398	4	0	\N
26165	1613	15120600000000	8388	4232	127	0	\N
26170	1613	15768191600000	17639	8843	20	0	\N
26173	1613	16417493400000	28275	13979	2	0	\N
26174	1613	16417493400000	28554	14105	4	0	\N
26176	1613	16417504400000	28275	13979	3	0	\N
26177	1613	16417506400000	28554	14105	5	0	\N
26179	1613	16487991600000	16509	8398	7	0	\N
26180	1613	16487991600000	16844	8547	3	0	\N
26181	1613	16487991600000	16961	8597	3	0	\N
26184	1613	16488003600000	16844	8547	4	0	\N
26185	1613	16488003600000	16961	8597	4	0	\N
26186	1613	16488016600000	16509	8398	8	0	\N
26187	1613	16488191600000	17639	8843	126	0	\N
26188	1613	16489052600000	19322	9684	105	0	\N
26189	1613	16489241600000	17639	8843	127	0	\N
26190	1613	16558650000000	9412	4884	2	0	\N
26192	1613	16558670000000	9412	4884	3	0	\N
26194	1613	17137518400000	29210	14396	3	0	\N
26195	1613	17137518400000	29211	14396	3	0	\N
26197	1613	17137530399972	29210	14396	4	0	\N
26198	1613	17137530400000	29211	14396	4	0	\N
26200	1613	17208002600000	18235	9186	1	0	\N
26201	1613	17208002600000	18236	9186	2	0	\N
26203	1613	17208003600000	18235	9186	2	0	\N
26204	1613	17208013600000	18236	9186	3	0	\N
26206	1613	17209052600000	19322	9684	126	0	\N
26207	1613	17209167600000	19322	9684	127	0	\N
26208	1613	17278680000000	10546	5446	2	0	\N
26209	1613	17278680000000	10707	5528	2	0	\N
26210	1613	17278680000000	10876	5611	5	0	\N
26211	1613	17278680000000	10894	5617	2	0	\N
26212	1613	17278700000000	10546	5446	3	0	\N
26213	1613	17278700000000	10707	5528	3	0	\N
26214	1613	17278700000000	10894	5617	3	0	\N
26215	1613	17278730000000	10876	5611	6	0	\N
26224	1613	19297601400000	29915	14738	7	0	\N
26226	1613	19297617400000	29915	14738	8	0	\N
26228	1613	19368099600000	20459	10302	3	0	\N
26229	1613	19368099600000	20460	10302	2	0	\N
26230	1613	19368099600000	20605	10364	1	0	\N
26231	1613	19368099600000	20607	10364	2	0	\N
26232	1613	19368099600000	20712	10415	4	0	\N
26234	1613	19368100600000	20605	10364	2	0	\N
26235	1613	19368110600000	20460	10302	3	0	\N
26236	1613	19368110600000	20607	10364	3	0	\N
26237	1613	19368111600000	20459	10302	4	0	\N
26238	1613	19368112600000	20712	10415	5	0	\N
26244	1613	20809449600000	21541	10622	108	0	\N
26245	1613	21528195599999	21788	10908	3	0	\N
26246	1613	21528195600000	21088	10594	2	0	\N
26247	1613	21528195600000	21571	10814	2	0	\N
26121	1613	12958490000000	7669	3969	3	0	2
26128	1613	13678490000000	7729	4004	3	0	2
26129	1613	13678610000000	7729	4004	4	0	2
26141	1613	14398610000000	8010	4151	1	0	2
26143	1613	14398620000000	8010	4151	2	0	2
26163	1613	15118630000000	8534	4421	2	0	2
26171	1613	15838630000000	9367	4859	2	0	2
26172	1613	15838650000000	9367	4859	3	0	2
26191	1613	16558650000000	9600	4980	3	0	2
26193	1613	16558680000000	9600	4980	4	0	2
26118	1613	12887934600000	15316	7804	4	0	6
26126	1613	13607934600000	15424	7856	3	0	6
26127	1613	13607946600000	15424	7856	4	0	6
26137	1613	14327946600000	15567	7923	2	0	6
26154	1613	15047966600000	16305	8285	3	0	6
26155	1613	15047978600000	16305	8285	4	0	6
26168	1613	15767978600000	16459	8372	4	0	6
26169	1613	15767991600000	16459	8372	5	0	6
26182	1613	16487991600000	18141	9147	2	0	6
26202	1613	17208002600000	19323	9744	9	0	6
26205	1613	17208038600000	19323	9744	10	0	6
26218	1613	17928038600000	19625	9885	13	0	6
26219	1613	17928087600000	19625	9885	14	0	6
26222	1613	18648087600000	20237	10189	3	0	6
26233	1613	19368099600000	20740	10426	10	0	6
26239	1613	19368163600000	20740	10426	11	0	6
26240	1613	20088163600000	20788	10446	1	0	6
26241	1613	20088173600000	20788	10446	2	0	6
26243	1613	20808195600000	20920	10516	5	0	6
26248	1613	21528195600000	21787	10908	3	0	6
26115	1613	12817381400000	26386	13050	3	0	10
26116	1613	12817393400000	26386	13050	4	0	10
26123	1613	13537393400000	26441	13080	3	0	10
26131	1613	14257405400000	26711	13211	3	0	10
26133	1613	14257417400000	26711	13211	4	0	10
26147	1613	14977417400000	27905	13800	19	0	10
26151	1613	14977481400000	27905	13800	20	0	10
26166	1613	15697481400000	28103	13892	3	0	10
26175	1613	16417493400000	28831	14220	7	0	10
26178	1613	16417518400000	28831	14220	8	0	10
26196	1613	17137518400000	29601	14597	5	0	10
26199	1613	17137532400000	29601	14597	6	0	10
26217	1613	17857586400000	29726	14655	18	0	10
26220	1613	18577586400000	29833	14700	6	0	10
26221	1613	18577601400000	29833	14700	7	0	10
26225	1613	19297601400000	29916	14738	10	0	10
26227	1613	19297620400000	29916	14738	11	0	10
26249	1613	21528197600000	21571	10814	3	0	\N
26250	1613	21528206600000	21088	10594	3	0	\N
26252	1613	21529449600000	21541	10622	126	0	\N
26253	1613	21529466600000	21541	10622	127	0	\N
26256	1613	22968219600000	22083	11042	5	0	\N
26257	1613	22968219600000	22084	11042	7	0	\N
26258	1613	22968219600000	22192	11107	4	0	\N
26259	1613	22968219600000	22602	11308	6	0	\N
26260	1613	22968219600000	22867	11431	4	0	\N
26263	1613	22968232600000	22192	11107	5	0	\N
26264	1613	22968232600000	22867	11431	5	0	\N
26265	1613	22968234600000	22602	11308	7	0	\N
26266	1613	22968242600000	22083	11042	6	0	\N
26267	1613	22968244600000	22084	11042	8	0	\N
26268	1613	66720950000000	3826	1793	113	0	\N
26269	1614	720000000000	3627	1710	0	0	\N
26270	1614	720000000000	25637	12688	3	0	\N
26271	1614	720000000000	26946	13328	3	0	\N
26272	1614	720012000000	25637	12688	4	0	\N
26273	1614	720012000000	26946	13328	4	0	\N
26274	1615	720000000000	4092	2126	5	0	\N
26277	1615	720140000000	4092	2126	6	0	\N
26278	1615	1440020000000	12540	6463	4	0	\N
26279	1615	1440020000000	22154	11083	10	0	\N
26280	1615	1440020000000	24522	12193	2	0	\N
26281	1615	1440031000000	24522	12193	3	0	\N
26282	1615	1440042000000	12540	6463	5	0	\N
26283	1615	1440057000000	22154	11083	11	0	\N
26284	1616	720000000000	439	248	1	0	\N
26286	1616	720010000000	439	248	2	0	\N
26290	1616	2160030000000	4773	2465	0	0	\N
26291	1616	2160030000000	5668	2939	0	0	\N
26294	1616	2880050000000	8919	4621	2	0	\N
26296	1616	2880070000000	8919	4621	3	0	\N
26304	1616	5760144410000	28529	14095	4	0	\N
26306	1616	5760157410000	28529	14095	5	0	\N
26312	1618	1440010000000	3996	2074	1	0	\N
26314	1618	1440020000000	3996	2074	2	0	\N
26318	1618	2880048000000	29790	14672	0	0	\N
26319	1618	2880048000000	29791	14680	13	0	\N
26320	1618	2880070000000	29791	14680	14	0	\N
26327	1619	2160337000000	22231	11113	47	0	\N
26330	1619	2880337000000	22231	11113	70	0	\N
26331	1619	2880359000000	22231	11113	71	0	\N
26332	1619	3600052000000	22584	11299	9	0	\N
26333	1619	3600052000000	22634	11320	6	0	\N
26334	1619	3600052000000	23539	11734	3	0	\N
26336	1619	3600064000000	23539	11734	4	0	\N
26338	1619	3600076000000	22634	11320	7	0	\N
26339	1619	3600664000000	22584	11299	10	0	\N
26340	1619	4320075000000	24866	12347	2	0	\N
26341	1619	4320075000000	24867	12347	3	0	\N
26342	1619	4320075000000	24870	12347	1	0	\N
26344	1619	4320076000000	24870	12347	2	0	\N
26345	1619	4320086000000	24866	12347	3	0	\N
26346	1619	4320087000000	24867	12347	4	0	\N
26348	1619	5040087000000	25693	12714	3	0	\N
26350	1619	5040087000000	26332	13021	5	0	\N
26351	1619	5040099000000	25693	12714	4	0	\N
26353	1619	5040110000000	26332	13021	6	0	\N
26355	1619	5760108000000	26369	13042	5	0	\N
26357	1619	5760131000000	26369	13042	6	0	\N
26362	1619	7920159000000	26653	13184	3	0	\N
26364	1619	7920171000000	26653	13184	4	0	\N
26368	1619	9360221000000	26937	13324	3	0	\N
26369	1619	9360221000000	27357	13525	9	0	\N
26371	1619	9360233000000	26937	13324	4	0	\N
26373	1619	9360257000000	27357	13525	10	0	\N
26376	1619	10800257000000	28361	14020	2	0	\N
26378	1619	10800268000000	28361	14020	3	0	\N
26310	1618	720000000000	2212	1164	1	0	0
26311	1618	720010000000	2212	1164	2	0	0
26288	1616	1440010000000	4055	2106	2	0	0
26289	1616	1440030000000	4055	2106	3	0	0
26292	1616	2160030000000	8821	4573	2	0	0
26275	1615	720000000000	10404	5380	2	0	0
26276	1615	720020000000	10404	5380	3	0	0
26295	1616	2880050000000	13661	7021	14	0	0
26297	1616	2880096410000	13661	7021	15	1	0
26298	1616	3600096410000	16225	8247	3	0	0
26313	1618	1440010000000	16498	8392	4	0	0
26315	1618	1440023000000	16498	8392	5	0	0
26300	1616	4320108410000	16566	8421	6	0	0
26301	1616	4320132410000	16566	8421	7	0	0
26303	1616	5040144410000	17418	8823	4	0	0
26316	1618	2160023000000	18516	9326	7	0	0
26317	1618	2160048000000	18516	9326	8	0	0
26321	1619	720000000000	21459	10767	3	0	0
26322	1619	720012000000	21459	10767	4	0	0
26324	1619	1440014000000	21726	10883	3	0	0
26251	1613	21528207600000	21787	10908	4	0	6
26325	1619	2160014000000	21983	10990	6	0	0
26326	1619	2160038000000	21983	10990	7	0	0
26254	1613	22248207600000	21984	10991	3	0	6
26328	1619	2880038000000	22232	11126	5	0	0
26329	1619	2880052000000	22232	11126	6	0	0
26261	1613	22968219600000	23043	11505	3	0	6
26262	1613	22968231600000	23043	11505	4	0	6
26337	1619	3600075000000	24152	12021	6	0	0
26343	1619	4320075000000	25484	12621	3	0	0
26347	1619	4320087000000	25484	12621	4	0	0
26349	1619	5040087000000	26330	13021	3	0	0
26352	1619	5040108000000	26330	13021	4	0	0
26356	1619	5760129000000	26368	13042	4	0	0
26358	1619	6480129000000	26381	13049	4	0	0
26359	1619	6480142000000	26381	13049	5	0	0
26360	1619	7200142000000	26617	13168	8	0	0
26361	1619	7200159000000	26617	13168	9	0	0
26365	1619	7920184000000	26712	13212	8	0	0
26366	1619	8640184000000	26835	13270	10	0	0
26367	1619	8640221000000	26835	13270	11	0	0
26370	1619	9360221000000	27568	13626	6	0	0
26374	1619	10080245000000	27906	13801	3	0	0
26375	1619	10080257000000	27906	13801	4	0	0
26305	1616	5760144410000	28543	14102	5	0	0
26307	1616	5760158410000	28543	14102	6	0	0
26377	1619	10800257000000	28629	14137	12	0	0
26380	1619	11520305000000	28960	14283	3	0	0
26381	1619	11520317000000	28960	14283	4	0	0
26382	1619	12240317000000	29188	14389	3	0	0
26383	1619	12240329000000	29188	14389	4	0	0
26384	1619	12960329000000	29353	14467	3	0	0
26309	1616	6480207410000	29611	14603	14	0	0
26385	1619	12960329000000	29812	14403	0	0	\N
26389	1619	14400353000000	29599	14596	4	0	\N
26392	1619	14400366000000	29599	14596	5	0	\N
26393	1619	15120365000000	29811	14688	5	0	\N
26394	1619	15120365000000	30135	14829	10	0	\N
26396	1619	15120379000000	29811	14688	6	0	\N
26398	1619	15120384000000	30135	14829	11	0	\N
26399	1619	15840379000000	30232	14865	10	0	\N
26400	1619	15840379000000	30235	14865	6	0	\N
26401	1619	15840394000000	30235	14865	7	0	\N
26402	1619	15840398000000	30232	14865	11	0	\N
26405	1622	1440010000000	911	507	2	0	\N
26406	1622	1440010000000	1054	585	36	0	\N
26407	1622	1440010000000	1199	661	1	0	\N
26409	1622	1440020000000	1199	661	2	0	\N
26411	1622	1440030000000	911	507	3	0	\N
26412	1622	1441360000000	1054	585	37	0	\N
26415	1622	2160830000000	1868	935	80	0	\N
26416	1622	2880030000000	1869	996	1	0	\N
26417	1622	2880030000000	2319	1214	1	0	\N
26418	1622	2880030000000	3000	1559	0	0	\N
26419	1622	2880030000000	3436	1785	0	0	\N
26420	1622	2880030000000	4694	2419	0	0	\N
26422	1622	2880040000000	1869	996	2	0	\N
26423	1622	2880040000000	2319	1214	2	0	\N
26424	1622	2880589995401	1868	935	81	0	\N
26427	1622	3600030000000	4939	2420	17	0	\N
26431	1622	3600050000000	5035	2612	1	0	\N
26432	1622	3600579995401	2318	936	0	0	\N
26433	1622	3601231110000	4939	2420	18	0	\N
26434	1622	3923911800048	25151	12479	3	0	\N
26436	1622	3923915800048	25151	12479	4	0	\N
26439	1622	4320050000000	5035	2612	2	0	\N
26446	1622	5759069999976	5287	2747	2	0	\N
26447	1622	5759069999976	5315	2763	1	0	\N
26448	1622	5759069999976	5580	2902	0	0	\N
26449	1622	5759069999976	5790	3004	1	0	\N
26451	1622	5759079999976	5315	2763	2	0	\N
26452	1622	5759079999976	5790	3004	2	0	\N
26453	1622	5759089999976	5287	2747	3	0	\N
26456	1622	6479069999976	6294	3260	1	0	\N
26458	1622	6479079999976	6294	3260	2	0	\N
26463	1622	7199079999976	6599	3413	4	0	\N
26464	1622	7199119999976	6599	3413	5	0	\N
26469	1622	8243989800048	25811	12762	3	0	\N
26470	1622	8243989800048	26291	13005	2	0	\N
26471	1622	8243989800048	26376	13046	8	0	\N
26473	1622	8244000800048	26291	13005	3	0	\N
26474	1622	8244001800048	25811	12762	4	0	\N
26475	1622	8244015800048	26376	13046	9	0	\N
26483	1622	9684040800048	27111	13404	2	0	\N
26484	1622	9684040800048	27468	13575	24	0	\N
26485	1622	9684040800048	27787	13731	5	0	\N
26487	1622	9684051800048	27111	13404	3	0	\N
26489	1622	9684063800048	27787	13731	6	0	\N
26490	1622	9684091800048	27468	13575	25	0	\N
26491	1622	10079139999976	7596	3929	1	0	\N
26493	1622	10079149999976	7596	3929	2	0	\N
26495	1622	10404052800048	28075	13881	10	0	\N
26496	1622	10404052800048	28076	13881	15	0	\N
26499	1622	10404107800048	28075	13881	11	0	\N
26500	1622	10404112800048	28076	13881	16	0	\N
26509	1622	12060263000014	13616	7001	2	0	\N
26510	1622	12060263000014	13617	7001	2	0	\N
26511	1622	12239169999976	9872	5120	2	0	\N
26513	1622	12239189999976	9872	5120	3	0	\N
26515	1622	12564109800048	29323	14451	3	0	\N
26517	1622	12564121800048	29323	14451	4	0	\N
26519	1622	12564145800048	29682	14641	5	0	\N
26408	1622	1440010000000	1414	771	1	0	0
26410	1622	1440020000000	1414	771	2	0	0
26413	1622	2160020000000	1651	889	1	0	0
26414	1622	2160030000000	1651	889	2	0	0
26421	1622	2880030000000	4695	2427	0	0	0
26429	1622	3600040000000	4940	2558	2	0	0
26430	1622	3600050000000	5033	2612	1	0	0
26438	1622	4319049999976	5033	2612	2	0	0
26442	1622	5039049999976	5209	2710	2	0	0
26443	1622	5039069999976	5209	2710	3	0	0
26457	1622	6479069999976	6559	3398	1	0	0
26459	1622	6479079999976	6559	3398	2	0	0
26462	1622	7199079999976	6596	3413	0	0	0
26467	1622	7919079999976	6837	3538	2	0	0
26477	1622	8639099999976	6939	3581	2	0	0
26478	1622	8639119999976	6939	3581	3	0	0
26481	1622	9359119999976	7088	3658	2	0	0
26482	1622	9359139999976	7088	3658	3	0	0
26492	1622	10079139999976	7992	4144	1	0	0
26501	1622	10799149999976	9632	4999	1	0	0
26502	1622	10799159999976	9632	4999	2	0	0
26505	1622	11519159999976	9854	5109	1	0	0
26506	1622	11519169999976	9854	5109	2	0	0
26512	1622	12239169999976	10099	5239	10	0	0
26425	1622	3203900800048	24666	12251	2	0	10
26426	1622	3203911800048	24666	12251	3	0	10
26435	1622	3923911800048	25153	12479	4	0	10
26437	1622	3923925800048	25153	12479	5	0	10
26441	1622	4643938800048	25161	12483	5	0	10
26444	1622	5363938800048	25232	12515	5	0	10
26445	1622	5363952800048	25232	12515	6	0	10
26454	1622	6083952800048	25501	12628	3	0	10
26455	1622	6083964800048	25501	12628	4	0	10
26461	1622	6803965800048	25549	12650	2	0	10
26465	1622	7523965800048	25661	12700	6	0	10
26466	1622	7523989800048	25661	12700	7	0	10
26472	1622	8243989800048	26576	13150	12	0	10
26476	1622	8244028800048	26576	13150	13	0	10
26480	1622	8964040800048	26924	13317	4	0	10
26486	1622	9684040800048	27872	13780	3	0	10
26488	1622	9684052800048	27872	13780	4	0	10
26497	1622	10404052800048	28864	14236	3	0	10
26503	1622	11124073800048	29149	14373	6	0	10
26504	1622	11124097800048	29149	14373	7	0	10
26507	1622	11844097800048	29151	14375	3	0	10
26508	1622	11844109800048	29151	14375	4	0	10
26386	1619	12960341000000	29353	14467	4	0	0
26388	1619	13680353000000	29367	14474	4	0	0
26516	1622	12564109800048	29409	14500	4	0	10
26518	1622	12564122800048	29409	14500	5	0	10
26390	1619	14400353000000	29600	14596	3	0	0
26391	1619	14400365000000	29600	14596	4	0	0
26395	1619	15120365000000	30136	14829	5	0	0
26397	1619	15120379000000	30136	14829	6	0	0
26521	1622	12564169800048	29476	14537	11	0	\N
26522	1622	12564169800048	29478	14537	11	0	\N
26523	1622	12780252000014	13788	7082	8	0	\N
26525	1622	12780252000014	14100	7209	4	0	\N
26527	1622	12780263000014	13616	7001	5	0	\N
26528	1622	12780263000014	13617	7001	5	0	\N
26529	1622	12780265000014	13616	7001	6	0	\N
26530	1622	12780265000014	13617	7001	6	0	\N
26531	1622	12780265000014	14100	7209	5	0	\N
26532	1622	12780278000014	13788	7082	9	0	\N
26533	1622	12959359999976	10415	5388	5	0	\N
26534	1622	12959359999976	10544	5446	2	0	\N
26535	1622	12959359999976	10545	5445	4	0	\N
26536	1622	12959359999976	10686	5517	3	0	\N
26538	1622	12959379999976	10544	5446	3	0	\N
26539	1622	12959381999976	10686	5517	4	0	\N
26541	1622	12959399999976	10545	5445	5	0	\N
26542	1622	12959409999976	10415	5388	6	0	\N
26543	1622	13284122800048	29647	14620	5	0	\N
26544	1622	13284136800048	29647	14620	6	0	\N
26545	1622	13284145800048	29682	14641	18	0	\N
26547	1622	13284157800048	29682	14641	19	0	\N
26549	1622	13284169800048	29476	14537	12	0	\N
26550	1622	13284169800048	29478	14537	12	0	\N
26551	1622	13500262000014	14192	7242	1	0	\N
26553	1622	13500272000014	14192	7242	2	0	\N
26555	1622	13679389999976	10779	5564	3	0	\N
26558	1622	13679419999976	10779	5564	4	0	\N
26559	1622	14004157800048	29804	14686	6	0	\N
26561	1622	14004172800048	29804	14686	7	0	\N
26575	1622	15660266000014	14508	7402	0	0	\N
26588	1622	17100319000005	15487	7884	3	0	\N
26590	1622	17100331000005	15487	7884	4	0	\N
26592	1622	17279433999976	11782	6057	1	0	\N
26594	1622	17279434999976	11782	6057	2	0	\N
26596	1622	17820341000005	16295	8280	4	0	\N
26598	1622	17820354000005	16295	8280	5	0	\N
26604	1622	18719435999976	12175	6269	3	0	\N
26606	1622	18719438999976	12175	6269	4	0	\N
26609	1622	19439435999976	12624	6346	0	0	\N
26611	1622	19439435999976	12627	6358	0	0	\N
26612	1622	19439435999976	12628	6371	0	0	\N
26613	1622	19439435999976	12629	6382	0	0	\N
26614	1622	19439435999976	12630	6393	0	0	\N
26616	1622	19980415000005	17427	8828	2	0	\N
26617	1622	19980415000005	17874	9022	4	0	\N
26618	1622	19980415000005	18278	9209	2	0	\N
26620	1622	19980426000005	17427	8828	3	0	\N
26621	1622	19980426000005	18278	9209	3	0	\N
26623	1622	19980428000005	17874	9022	5	0	\N
26628	1622	20700460000005	18592	9370	3	0	\N
26629	1622	20879468999976	12822	6614	1	0	\N
26631	1622	20879478999976	12822	6614	2	0	\N
26633	1622	20879509999976	13178	6789	3	0	\N
26634	1622	21420439000005	19524	9837	2	0	\N
26636	1622	21420450000005	19524	9837	3	0	\N
26638	1622	21420460000005	18592	9370	6	0	\N
26639	1622	21420462000005	18592	9370	7	0	\N
26640	1622	21599479999976	13014	6709	2	0	\N
26642	1622	21599490999976	13014	6709	3	0	\N
26644	1622	21599509999976	13178	6789	13	0	\N
26645	1622	21599545999976	13178	6789	14	0	\N
26652	1622	23580488000005	19885	10017	2	0	\N
26653	1622	23580488000005	19886	10017	3	0	\N
26655	1622	23580499000005	19885	10017	3	0	\N
26656	1622	23580500000005	19886	10017	4	0	\N
26556	1622	13679389999976	10820	5583	2	0	0
26557	1622	13679409999976	10820	5583	3	0	0
26565	1622	14399409999976	11093	5709	2	0	0
26566	1622	14399429999976	11093	5709	3	0	0
26571	1622	15119429999976	11558	5940	2	0	0
26578	1622	15839431999976	11689	6010	1	0	0
26579	1622	15839432999976	11689	6010	2	0	0
26584	1622	16559432999976	11752	6041	1	0	0
26585	1622	16559433999976	11752	6041	2	0	0
26593	1622	17279433999976	12012	6183	1	0	0
26600	1622	17999434999976	12052	6203	1	0	0
26601	1622	17999435999976	12052	6203	2	0	0
26605	1622	18719435999976	12311	6343	0	0	0
26610	1622	19439435999976	12625	6516	2	0	0
26624	1622	20159446999976	12696	6547	4	0	0
26625	1622	20159468999976	12696	6547	5	0	0
26630	1622	20879468999976	12886	6643	2	0	0
26632	1622	20879479999976	12886	6643	3	0	0
26641	1622	21599479999976	13461	6934	3	0	0
26648	1622	22319491999976	13522	6962	3	0	0
26649	1622	22319503999976	13522	6962	4	0	0
26524	1622	12780252000014	14099	7209	1	0	5
26526	1622	12780262000014	14099	7209	2	0	5
26552	1622	13500262000014	14194	7242	4	0	5
26563	1622	14220275000014	14258	7280	4	0	5
26564	1622	14220288000014	14258	7280	5	0	5
26569	1622	14940288000014	14447	7373	3	0	5
26570	1622	14940291000014	14447	7373	4	0	5
26577	1622	15660307000005	14510	7402	8	0	5
26582	1622	16380307000005	15341	7819	3	0	5
26583	1622	16380319000005	15341	7819	4	0	5
26589	1622	17100319000005	15543	7911	4	0	5
26591	1622	17100341000005	15543	7911	5	0	5
26599	1622	17820390000005	16555	8414	14	0	5
26602	1622	18540390000005	16614	8440	4	0	5
26603	1622	18540403000005	16614	8440	5	0	5
26607	1622	19260403000005	17203	8718	3	0	5
26608	1622	19260415000005	17203	8718	4	0	5
26622	1622	19980427000005	18307	9222	4	0	5
26626	1622	20700427000005	18501	9319	3	0	5
26627	1622	20700439000005	18501	9319	4	0	5
26635	1622	21420439000005	19525	9837	3	0	5
26646	1622	22140451000005	19654	9899	3	0	5
26647	1622	22140463000005	19654	9899	4	0	5
26650	1622	22860463000005	19786	9964	7	0	5
26651	1622	22860488000005	19786	9964	8	0	5
26654	1622	23580488000005	19915	10029	3	0	5
26548	1622	13284157800048	29683	14641	19	0	10
26560	1622	14004157800048	29805	14686	9	0	10
26562	1622	14004175800048	29805	14686	10	0	10
26567	1622	14724175800048	29841	14706	9	0	10
26568	1622	14724184800048	29841	14706	10	0	10
26574	1622	15444202800048	29858	14716	10	0	10
26580	1622	16164202800048	29950	14751	19	0	10
26581	1622	16164239800048	29950	14751	20	0	10
26586	1622	16884239800048	30034	14788	11	0	10
26662	1622	25740524000005	21264	10679	4	0	\N
26663	1622	25740524000005	23232	11593	2	0	\N
26665	1622	25740535000005	23232	11593	3	0	\N
26667	1622	25740546000005	21264	10679	5	0	\N
26668	1623	200000000	23214	11516	127	1	\N
26669	1623	720000000000	78	46	2	0	\N
26672	1623	720020000000	78	46	3	0	\N
26675	1623	2160020000000	461	258	1	0	\N
26676	1623	2160020000000	506	284	3	0	\N
26678	1623	2160030000000	461	258	2	0	\N
26680	1623	2160050000000	506	284	4	0	\N
26681	1623	2880030000000	666	370	1	0	\N
26683	1623	2880040000000	666	370	2	0	\N
26685	1623	3600040000000	1026	568	2	0	\N
26687	1623	3600060000000	1026	568	3	0	\N
26689	1623	4320060000000	1408	768	2	0	\N
26691	1623	4320080000000	1408	768	3	0	\N
26693	1623	4320211000000	2045	1031	13	0	\N
26694	1623	5040081000000	1860	991	2	0	\N
26695	1623	5040081000000	2270	1192	1	0	\N
26696	1623	5040081000000	2383	1246	1	0	\N
26698	1623	5040091000000	2270	1192	2	0	\N
26699	1623	5040091000000	2383	1246	2	0	\N
26701	1623	5040101000000	1860	991	3	0	\N
26702	1623	5040211000000	2045	1031	49	0	\N
26703	1623	5040561000000	2045	1031	50	0	\N
26708	1623	7200111000000	2596	1367	2	0	\N
26709	1623	7200111000000	2746	1440	1	0	\N
26711	1623	7200121000000	2746	1440	2	0	\N
26712	1623	7200131000000	2596	1367	3	0	\N
26716	1623	8640151000000	3014	1565	1	0	\N
26718	1623	8640161000000	3014	1565	2	0	\N
26724	1623	11520181000000	3786	1960	2	0	\N
26727	1623	12240181000000	3786	1960	3	0	\N
26730	1623	13680181000000	4240	2201	1	0	\N
26732	1623	13680191000000	4240	2201	2	0	\N
26741	1623	16560317001040	14745	7253	102	0	\N
26748	1623	18721480899898	5397	2808	0	0	\N
26750	1623	19441480899898	5617	2918	0	0	\N
26751	1623	19441480899898	5683	2945	1	0	\N
26752	1623	19441480899898	5749	2980	1	0	\N
26754	1623	19441490899898	5683	2945	2	0	\N
26755	1623	19441490899898	5749	2980	2	0	\N
26759	1623	20881500899898	6080	3157	1	0	\N
26761	1623	20881510899898	6080	3157	2	0	\N
26763	1623	21601530899898	6283	3254	1	0	\N
26764	1623	21601530899898	6405	3281	2	0	\N
26766	1623	21601540899898	6283	3254	2	0	\N
26768	1623	21601730899898	6405	3281	3	0	\N
26769	1623	22321540899898	7019	3619	4	0	\N
26772	1623	22321580899898	7019	3619	5	0	\N
26773	1623	22321730899898	6426	3282	8	0	\N
26774	1623	22321810899898	6426	3282	9	0	\N
26775	1623	22324130899898	6689	3283	104	0	\N
26778	1623	23044130899898	6689	3283	125	0	\N
26779	1623	23044330899593	6689	3283	127	0	\N
26782	1623	23764330899593	6728	3284	0	0	\N
26783	1623	24474330899593	6785	3285	0	0	\N
26788	1623	25921670899898	7885	4085	1	0	\N
26789	1623	25921670899898	8079	4188	1	0	\N
26790	1623	25921670899898	8216	4259	1	0	\N
26791	1623	25921670899898	8228	4264	1	0	\N
26792	1623	25921670899898	8248	4271	1	0	\N
26673	1623	1440010000000	213	124	1	0	0
26674	1623	1440020000000	213	124	2	0	0
26677	1623	2160020000000	545	308	1	0	0
26679	1623	2160030000000	545	308	2	0	0
26682	1623	2880030000000	944	525	1	0	0
26686	1623	3600040000000	1121	617	2	0	0
26688	1623	3600060000000	1121	617	3	0	0
26690	1623	4320060000000	1450	789	3	0	0
26692	1623	4320081000000	1450	789	4	0	0
26697	1623	5040081000000	2440	1276	1	0	0
26704	1623	5760091000000	2443	1277	1	0	0
26705	1623	5760101000000	2443	1277	2	0	0
26706	1623	6480101000000	2457	1286	1	0	0
26707	1623	6480111000000	2457	1286	2	0	0
26713	1623	7200131000000	2787	1459	3	0	0
26714	1623	7920131000000	2842	1487	2	0	0
26715	1623	7920151000000	2842	1487	3	0	0
26717	1623	8640151000000	3099	1608	1	0	0
26719	1623	8640161000000	3099	1608	2	0	0
26721	1623	10080161000000	3511	1822	0	0	0
26722	1623	10800161000000	3547	1840	0	0	0
26723	1623	11520161000000	3655	1897	0	0	0
26725	1623	12240161000000	4121	2142	1	0	0
26726	1623	12240171000000	4121	2142	2	0	0
26729	1623	12960181000000	4195	2184	2	0	0
26731	1623	13680181000000	4548	2354	2	0	0
26733	1623	13680291000000	4548	2354	3	0	0
26734	1623	13680791000000	4553	2356	5	0	0
26736	1623	14401420899898	4553	2356	17	1	0
26737	1623	15121420899898	4613	2388	1	0	0
26738	1623	15121430899898	4613	2388	2	0	0
26739	1623	15841430899898	5010	2597	1	0	0
26740	1623	15841440899898	5010	2597	2	0	0
26743	1623	16561460899898	5143	2665	3	0	0
26744	1623	17281460899898	5193	2700	1	0	0
26745	1623	17281470899898	5193	2700	2	0	0
26746	1623	18001470899898	5316	2763	1	0	0
26747	1623	18001480899898	5316	2763	2	0	0
26753	1623	19441480899898	5875	3046	1	0	0
26756	1623	19441490899898	5875	3046	2	0	0
26757	1623	20161490899898	5955	3087	1	0	0
26758	1623	20161500899898	5955	3087	2	0	0
26762	1623	20881530899898	6125	3177	4	0	0
26765	1623	21601530899898	6949	3586	1	0	0
26767	1623	21601540899898	6949	3586	2	0	0
26770	1623	22321540899898	7049	3638	2	0	0
26771	1623	22321560899898	7049	3638	3	0	0
26777	1623	23041600899898	7081	3654	5	0	0
26780	1623	23761600899898	7303	3773	5	0	0
26781	1623	23761650899898	7303	3773	6	0	0
26784	1623	24481650899898	7398	3821	1	0	0
26785	1623	24481660899898	7398	3821	2	0	0
26787	1623	25201670899898	7494	3876	3	0	1
26657	1622	23580500000005	19915	10029	4	0	5
26658	1622	24300500000005	19962	10053	3	0	5
26659	1622	24300512000005	19962	10053	4	0	5
26661	1622	25020524000005	20053	10095	4	0	5
26664	1622	25740524000005	23996	11942	3	0	5
26666	1622	25740536000005	23996	11942	4	0	5
26794	1623	25921680899898	7885	4085	2	0	\N
26795	1623	25921680899898	8079	4188	2	0	\N
26796	1623	25921680899898	8216	4259	2	0	\N
26797	1623	25921680899898	8228	4264	2	0	\N
26798	1623	25921680899898	8248	4271	2	0	\N
26800	1623	26641680899898	8593	4455	1	0	\N
26801	1623	26641680899898	8602	4460	1	0	\N
26802	1623	26641680899898	8639	4476	1	0	\N
26803	1623	26641680899898	8830	4577	6	0	\N
26804	1623	26641680899898	8876	4595	9	0	\N
26806	1623	26641690899898	8593	4455	2	0	\N
26807	1623	26641690899898	8602	4460	2	0	\N
26808	1623	26641690899898	8639	4476	2	0	\N
26809	1623	26641740899898	8830	4577	7	0	\N
26810	1623	26641770899898	8876	4595	10	0	\N
26812	1623	27361770899898	8923	4596	2	0	\N
26813	1623	27361772899898	8923	4596	3	0	\N
26816	1623	28081772899898	8945	4597	2	0	\N
26817	1623	28081850899898	9365	4858	2	0	\N
26818	1623	28081850899898	9374	4864	3	0	\N
26819	1623	28081850899898	9405	4880	2	0	\N
26820	1623	28081850899898	9433	4893	2	0	\N
26822	1623	28081870899898	9365	4858	3	0	\N
26823	1623	28081870899898	9405	4880	3	0	\N
26824	1623	28081870899898	9433	4893	3	0	\N
26825	1623	28081880899898	9374	4864	4	0	\N
26827	1623	28082122899898	8945	4597	3	0	\N
26830	1623	28802122899898	8955	4598	2	0	\N
26831	1623	28803222899898	8955	4598	3	0	\N
26834	1623	29523222899898	8966	4599	1	0	\N
26835	1623	29523223899898	8966	4599	2	0	\N
26836	1623	30241970899898	9956	5169	5	0	\N
26837	1623	30241970899898	10187	5276	2	0	\N
26838	1623	30241970899898	10221	5291	2	0	\N
26840	1623	30241990899898	10187	5276	3	0	\N
26841	1623	30241990899898	10221	5291	3	0	\N
26843	1623	30242011899898	9956	5169	6	0	\N
26844	1623	30243223899898	9128	4600	18	0	\N
26845	1623	30243429899898	9128	4600	19	0	\N
26848	1623	30963429899898	9192	4601	3	0	\N
26849	1623	30963432899898	9192	4601	4	0	\N
26852	1623	32402070899898	10616	5483	2	0	\N
26854	1623	32402090899898	10616	5483	3	0	\N
26858	1623	33842221899898	10943	5640	2	0	\N
26860	1623	33842241899898	10943	5640	3	0	\N
26864	1623	35282281899898	11371	5840	2	0	\N
26865	1623	35282281899898	11449	5880	1	0	\N
26867	1623	35282291899898	11449	5880	2	0	\N
26868	1623	35282292899898	11371	5840	3	0	\N
26880	1623	39602298899898	12064	6209	4	0	\N
26882	1623	39602302899898	12064	6209	5	0	\N
26890	1623	42482407899898	12525	6454	6	0	\N
26894	1623	42482440899898	12525	6454	7	0	\N
26895	1623	43202418899898	12708	6553	2	0	\N
26897	1623	43202429899898	12708	6553	3	0	\N
26901	1623	44642441899898	13125	6766	3	0	\N
26904	1623	44642453899898	13125	6766	4	0	\N
26914	1623	48962519899898	14220	7251	0	0	\N
26915	1623	48962519899898	15345	7820	2	0	\N
26917	1623	48962530899898	15345	7820	3	0	\N
26919	1623	49682519899898	14488	7252	8	0	\N
26920	1623	49682542899898	15568	7924	3	0	\N
26922	1623	49682572899898	14488	7252	9	0	\N
26923	1623	49682572899898	15568	7924	4	0	\N
26925	1623	49683112899898	14745	7253	45	0	\N
26928	1623	50403112899898	14745	7253	101	0	\N
26805	1623	26641680899898	9349	4851	6	0	1
26811	1623	26641830899898	9349	4851	7	0	1
26814	1623	27361830899898	9363	4857	2	0	1
26815	1623	27361850899898	9363	4857	3	0	1
26821	1623	28081850899898	9608	4985	4	0	1
26828	1623	28801890899898	9623	4992	7	0	1
26829	1623	28801960899898	9623	4992	8	0	1
26832	1623	29521960899898	9692	5029	1	0	1
26833	1623	29521970899898	9692	5029	2	0	1
26839	1623	30241970899898	10319	5339	2	0	1
26846	1623	30961990899898	10482	5418	6	0	1
26847	1623	30962050899898	10482	5418	7	0	1
26850	1623	31682050899898	10598	5474	2	0	1
26851	1623	31682070899898	10598	5474	3	0	1
26855	1623	32402090899898	10666	5507	3	0	1
26856	1623	33122090899898	10849	5600	6	0	1
26857	1623	33122221899898	10849	5600	7	0	1
26859	1623	33842221899898	11113	5715	4	0	1
26861	1623	33842261899898	11113	5715	5	0	1
26863	1623	34562281899898	11141	5726	3	0	1
26866	1623	35282281899898	11505	5910	3	0	1
26869	1623	35282293899898	11505	5910	4	0	1
26870	1623	36002293899898	11662	5997	1	0	1
26871	1623	36002294899898	11662	5997	2	0	1
26873	1623	36722295899898	11869	6099	2	0	1
26874	1623	37442295899898	11928	6140	1	0	1
26875	1623	37442296899898	11928	6140	2	0	1
26876	1623	38162296899898	11989	6170	1	0	1
26878	1623	38882297899898	12056	6205	1	0	1
26879	1623	38882298899898	12056	6205	2	0	1
26881	1623	39602298899898	12162	6262	5	0	1
26883	1623	39602303899898	12162	6262	6	0	1
26884	1623	40322303899898	12178	6270	1	0	1
26886	1623	41042304899898	12184	6273	1	0	1
26887	1623	41042305899898	12184	6273	2	0	1
26888	1623	41762305899898	12292	6330	3	0	1
26889	1623	41762407899898	12292	6330	4	0	1
26891	1623	42482407899898	12528	6456	2	0	1
26893	1623	42482428899898	12944	6671	1	0	1
26896	1623	43202428899898	12944	6671	4	0	1
26898	1623	43202430899898	12944	6671	5	0	1
26899	1623	43922430899898	13053	6729	2	0	1
26902	1623	44642441899898	13246	6822	1	0	1
26903	1623	44642451899898	13246	6822	2	0	1
26905	1623	45362451899898	13259	6830	1	0	1
26906	1623	45362461899898	13259	6830	2	0	1
26907	1623	46082461899898	13329	6869	3	0	1
26909	1623	46802473899898	13369	6889	8	0	1
26910	1623	46802499899898	13369	6889	9	0	1
26911	1623	47522499899898	13633	7009	2	0	1
26912	1623	47522519899898	13633	7009	3	0	1
26913	1623	48242519899898	13919	7136	0	0	1
26918	1623	48962542899898	15477	7880	6	0	1
26921	1623	49682542899898	15831	8054	5	0	1
26924	1623	49682574899898	15831	8054	6	0	1
26926	1623	50402574899898	15866	8068	4	0	1
26929	1623	51122587899898	15963	8114	6	0	\N
26932	1623	51122611899898	15963	8114	7	0	\N
26935	1623	52562611899898	16303	8284	3	0	\N
26936	1623	52562611899898	16622	8443	3	0	\N
26937	1623	52562611899898	16904	8571	3	0	\N
26938	1623	52562611899898	16922	8577	4	0	\N
26939	1623	52562611899898	17023	8622	7	0	\N
26941	1623	52562623899898	16303	8284	4	0	\N
26942	1623	52562623899898	16622	8443	4	0	\N
26943	1623	52562623899898	16904	8571	4	0	\N
26944	1623	52562624899898	16922	8577	5	0	\N
26946	1623	52562636899898	17023	8622	8	0	\N
26949	1623	54002634899898	17914	9035	6	0	\N
26951	1623	54002649899898	17914	9035	7	0	\N
26953	1623	54722669899898	17996	9079	3	0	\N
26955	1623	54722681899898	17996	9079	4	0	\N
26957	1623	55442692899898	18240	9187	2	0	\N
26959	1623	55442703899898	18240	9187	3	0	\N
26965	1623	57602826899898	18629	9387	5	0	\N
26968	1623	57602849899898	18629	9387	6	0	\N
26973	1623	59762930899898	19043	9604	6	0	\N
26974	1623	59762930899898	19060	9612	2	0	\N
26976	1623	59762941899898	19060	9612	3	0	\N
26978	1623	59762953899898	20671	10398	1	0	\N
26979	1623	59762972899898	19043	9604	7	0	\N
26980	1623	60482943899898	19284	9722	7	0	\N
26981	1623	60482943899898	19594	9867	3	0	\N
26982	1623	60482943899898	19809	9976	3	0	\N
26983	1623	60482943899898	19983	10063	3	0	\N
26984	1623	60482943899898	20141	10137	3	0	\N
26985	1623	60482943899898	20570	10351	8	0	\N
26986	1623	60482943899898	20887	10499	2	0	\N
26988	1623	60482946899898	19983	10063	4	0	\N
26989	1623	60482953899898	20671	10398	4	0	\N
26990	1623	60482954899898	20887	10499	3	0	\N
26991	1623	60482955899898	19594	9867	4	0	\N
26992	1623	60482955899898	19809	9976	4	0	\N
26993	1623	60482955899898	20141	10137	4	0	\N
26994	1623	60482955899898	20671	10398	5	0	\N
26996	1623	60482977899898	19284	9722	8	0	\N
26997	1623	60482978899898	20570	10351	9	0	\N
27000	1623	61922979899898	21769	10899	6	0	\N
27003	1623	61923003899898	21769	10899	7	0	\N
27012	1623	65523055899898	22317	11171	8	0	\N
27013	1623	65523055899898	22387	11208	3	0	\N
27015	1623	65523067899898	22387	11208	4	0	\N
27017	1623	65523090899898	22317	11171	9	0	\N
27018	1623	66243077899898	22863	11429	4	0	\N
27019	1623	66243077899898	23089	11515	72	0	\N
27021	1623	66243090899898	22863	11429	5	0	\N
27023	1623	66243347899898	23089	11515	73	0	\N
27024	1623	66243847899898	23214	11516	50	0	\N
27025	1623	66963099899898	23494	11713	6	0	\N
27026	1623	66963099899898	23506	11717	3	0	\N
27028	1623	66963111899898	23506	11717	4	0	\N
27030	1623	66963123899898	23494	11713	7	0	\N
27031	1623	66963847899898	23214	11516	126	0	\N
27032	1623	66964556899898	23284	11517	50	0	\N
27035	1623	67684556899898	23284	11517	111	0	\N
27036	1623	67684616899898	23284	11517	112	0	\N
27039	1623	69123136899898	23969	11927	14	0	\N
27042	1623	69123258899898	23969	11927	15	0	\N
27045	1623	70563158899898	24153	12021	5	0	\N
27046	1623	70563158899898	24258	12070	13	0	\N
27047	1623	70563158899898	24311	12089	3	0	\N
27048	1623	70563158899898	24478	12172	2	0	\N
27050	1623	70563169899898	24478	12172	3	0	\N
27052	1623	70563170899898	24311	12089	4	0	\N
27054	1623	70563181899898	24153	12021	6	0	\N
27055	1623	70563207899898	24258	12070	14	0	\N
27056	1623	71283158899898	24370	12120	8	0	\N
27057	1623	71283169899898	24792	12310	10	0	\N
27058	1623	71283169899898	24890	12358	3	0	\N
27059	1623	71283169899898	24972	12393	1	0	\N
27061	1623	71283179899898	24972	12393	2	0	\N
27063	1623	71283181899898	24890	12358	4	0	\N
27064	1623	71283206899898	24792	12310	11	0	\N
26933	1623	51842599899898	16297	8281	3	0	1
26934	1623	51842611899898	16297	8281	4	0	1
26940	1623	52562611899898	17684	8939	3	0	1
26945	1623	52562632899898	17684	8939	4	0	1
26947	1623	53282632899898	17810	8995	2	0	1
26950	1623	54002634899898	17983	9070	8	0	1
26952	1623	54002669899898	17983	9070	9	0	1
26954	1623	54722669899898	18076	9116	5	0	1
26956	1623	54722692899898	18076	9116	6	0	1
26958	1623	55442692899898	18279	9209	2	0	1
26961	1623	56162703899898	18332	9234	2	0	1
26962	1623	56162714899898	18332	9234	3	0	1
26963	1623	56882714899898	18552	9348	4	0	1
26964	1623	56882826899898	18552	9348	5	0	1
26967	1623	57602837899898	18715	9428	3	0	1
26969	1623	58322837899898	18794	9470	6	0	1
26970	1623	58322910899898	18794	9470	7	0	1
26971	1623	59042910899898	19018	9588	2	0	1
26972	1623	59042930899898	19018	9588	3	0	1
26977	1623	59762943899898	19159	9665	5	0	1
26987	1623	60482943899898	21434	10750	6	0	1
26995	1623	60482967899898	21434	10750	7	0	1
26998	1623	61202967899898	21560	10811	3	0	1
26999	1623	61202979899898	21560	10811	4	0	1
27002	1623	61922995899898	21793	10910	8	0	1
27004	1623	62642995899898	21807	10915	6	0	1
27005	1623	62643019899898	21807	10915	7	0	1
27006	1623	63363019899898	21986	10992	3	0	1
27008	1623	64083031899898	22003	11002	3	0	1
27009	1623	64083043899898	22003	11002	4	0	1
27010	1623	64803043899898	22053	11027	3	0	1
27011	1623	64803055899898	22053	11027	4	0	1
27014	1623	65523055899898	22730	11364	4	0	1
27020	1623	66243077899898	23367	11661	4	0	1
27022	1623	66243099899898	23367	11661	5	0	1
27027	1623	66963099899898	23576	11748	4	0	1
27029	1623	66963112899898	23576	11748	5	0	1
27033	1623	67683112899898	23706	11806	3	0	1
27037	1623	68403124899898	23960	11921	3	0	1
27038	1623	68403136899898	23960	11921	4	0	1
27040	1623	69123136899898	24008	11947	2	0	1
27041	1623	69123147899898	24008	11947	3	0	1
27044	1623	69843158899898	24057	11972	3	0	1
27049	1623	70563158899898	24511	12190	2	0	1
27051	1623	70563169899898	24511	12190	3	0	1
27053	1623	70563179899898	25012	12410	1	0	1
27060	1623	71283179899798	25012	12410	4	0	1
27065	1623	71283292899898	24370	12120	9	0	\N
27083	1623	78483289898598	26063	12880	4	0	\N
27084	1623	78483289898598	26134	12918	2	0	\N
27085	1623	78483289898598	26158	12929	5	0	\N
27087	1623	78483300898598	26134	12918	3	0	\N
27088	1623	78483303898598	26158	12929	6	0	\N
27089	1623	78483311898598	26063	12880	5	0	\N
27093	1623	79923325898598	26463	13089	6	0	\N
27096	1623	79923349898598	26463	13089	7	0	\N
27101	1623	81363479898598	27080	13339	8	0	\N
27104	1623	82083479898598	27080	13339	45	0	\N
27105	1623	82083839898598	27080	13339	46	0	\N
27116	1623	86403573898598	28238	13943	4	0	\N
27117	1623	86403573898598	28900	14255	2	0	\N
27119	1623	86403584898598	28900	14255	3	0	\N
27120	1623	86403595898598	28238	13943	5	0	\N
27122	1623	87123595898598	28322	13944	5	0	\N
27123	1623	87123600898598	28322	13944	6	0	\N
27126	1623	87123719065268	28665	13945	30	0	\N
27129	1623	87843719065268	28665	13945	68	0	\N
27130	1623	87844001765143	28665	13945	70	1	\N
27135	1623	90003648898598	29239	14408	4	0	\N
27136	1623	90003648898598	29264	14423	12	0	\N
27137	1623	90003648898598	29464	14529	3	0	\N
27139	1623	90003660898598	29464	14529	4	0	\N
27140	1623	90003661898598	29239	14408	5	0	\N
27142	1623	90003696898598	29264	14423	13	0	\N
27145	1623	91443676898598	29746	14662	18	0	\N
27146	1623	91443676898598	29774	14674	31	0	\N
27147	1623	91443676898598	29991	14767	14	0	\N
27148	1623	91443676898598	30272	14884	11	0	\N
27149	1623	91443697541458	30272	14884	12	0	\N
27150	1623	91443699898598	29991	14767	15	0	\N
27151	1623	91443712898598	29746	14662	19	0	\N
27152	1623	91443725898590	29774	14674	32	0	\N
27157	1624	1440010000000	154	91	1	0	\N
27158	1624	1440020000000	154	91	2	0	\N
27159	1625	720000000000	9427	4890	1	0	\N
27160	1625	720000000000	9429	4892	1	0	\N
27162	1625	720010000000	9427	4890	2	0	\N
27163	1625	720010000000	9429	4892	2	0	\N
27167	1625	2160051000000	18585	9366	4	0	\N
27168	1625	2160073000000	18585	9366	5	0	\N
27173	1629	2160030000000	12160	6262	5	0	\N
27174	1629	2160035000000	12160	6262	6	0	\N
27181	1633	200000100	17701	8947	3	1	\N
27182	1633	200014017	20763	10416	39	0	\N
27183	1633	201000000	20836	10417	38	1	\N
27184	1633	720000000000	260	152	1	0	\N
27186	1633	720010000000	260	152	2	0	\N
27188	1633	1440010000000	696	387	1	0	\N
27190	1633	1440020000000	696	387	2	0	\N
27194	1633	2160030000000	1463	794	0	0	\N
27199	1633	2880040000000	1852	987	1	0	\N
27185	1633	720000000000	279	161	1	0	0
27187	1633	720010000000	279	161	2	0	0
27189	1633	1440010000000	699	389	2	0	0
27191	1633	1440030000000	699	389	3	0	0
27195	1633	2160030000000	1659	893	1	0	0
27200	1633	2880040000000	1894	1008	1	0	0
27175	1630	720000000000	3819	1979	1	0	0
27176	1630	720010000000	3819	1979	2	0	0
27179	1632	720000000000	4826	2500	1	0	0
27180	1632	720010000000	4826	2500	2	0	0
27170	1629	720010000000	4975	2580	2	0	0
27161	1625	720000000000	9430	4892	4	0	0
27164	1625	720040000000	9430	4892	5	0	0
27192	1633	1476189985638	9942	5159	2	0	8
27197	1633	2196209985638	9950	5166	2	0	8
27198	1633	2196229985638	9950	5166	3	0	8
27171	1629	1440010000000	11164	5738	2	0	0
27172	1629	1440030000000	11164	5738	3	0	0
27165	1625	1440040000000	18201	9172	2	0	0
27155	1624	722000000000	22616	11313	2	0	1
27156	1624	722002000000	22616	11313	3	0	1
27066	1623	72003180898598	25229	12514	5	0	1
27067	1623	72003194898598	25229	12514	6	0	1
27068	1623	72723194898598	25273	12537	3	0	1
27070	1623	73443206898598	25486	12622	3	0	1
27071	1623	73443218898598	25486	12622	4	0	1
27072	1623	74163218898598	25659	12698	7	0	1
27073	1623	74163243898598	25659	12698	8	0	1
27075	1623	74883255898598	25774	12747	4	0	1
27076	1623	75603255898598	25813	12763	3	0	1
27077	1623	75603267898598	25813	12763	4	0	1
27078	1623	76323267898598	25817	12765	0	0	1
27079	1623	77043267898598	25924	12810	2	0	1
27081	1623	77763278898598	25974	12834	2	0	1
27082	1623	77763289898598	25974	12834	3	0	1
27086	1623	78483289898598	26408	13065	6	0	1
27090	1623	78483313898598	26408	13065	7	0	1
27091	1623	79203313898598	26413	13067	3	0	1
27094	1623	79923325898598	26657	13186	3	0	1
27095	1623	79923337898598	26657	13186	4	0	1
27097	1623	80643337898598	26725	13219	4	0	1
27098	1623	80643350898598	26725	13219	5	0	1
27100	1623	81363399898598	26845	13277	14	0	1
27102	1623	82083399898598	27819	13748	3	0	1
27103	1623	82083411898598	27819	13748	4	0	1
27106	1623	82803411898598	27837	13759	3	0	1
27107	1623	82803423898598	27837	13759	4	0	1
27109	1623	83523435898598	27864	13775	4	0	1
27177	1630	1440010000000	27941	13822	4	0	0
27178	1630	1440023000000	27941	13822	5	0	0
27110	1623	84243435898598	28032	13863	4	0	1
27111	1623	84243448898598	28032	13863	5	0	1
27113	1623	84963539898598	28081	13882	20	0	1
27114	1623	85683539898598	28161	13925	7	0	1
27115	1623	85683573898598	28161	13925	8	0	1
27118	1623	86403573898598	28904	14256	6	0	1
27124	1623	87123606898598	28911	14260	5	0	1
27125	1623	87123611898598	28911	14260	6	0	1
27127	1623	87843611898598	29015	14307	6	0	1
27128	1623	87843635898598	29015	14307	7	0	1
27131	1623	88563635898598	29020	14312	2	0	1
27133	1623	89283646898598	29161	14379	2	0	1
27134	1623	89283648898598	29161	14379	3	0	1
27138	1623	90003648898598	29527	14561	4	0	1
27141	1623	90003661898598	29527	14561	5	0	1
27143	1623	90723661898598	29688	14643	6	0	1
27201	1633	2880050000000	1852	987	2	0	\N
27205	1633	2917429985638	10784	5443	112	0	\N
27206	1633	3600050000000	2184	1151	1	0	\N
27207	1633	3600050000000	2335	1220	3	0	\N
27208	1633	3600050000000	2690	1412	1	0	\N
27210	1633	3600060000000	2184	1151	2	0	\N
27211	1633	3600060000000	2690	1412	2	0	\N
27213	1633	3600080000000	2335	1220	4	0	\N
27214	1633	3636269985638	10526	5435	8	0	\N
27215	1633	3636269985638	11671	5999	1	0	\N
27217	1633	3636270985638	11671	5999	2	0	\N
27218	1633	3636349985638	10526	5435	9	0	\N
27219	1633	3637429985638	10784	5443	126	0	\N
27220	1633	3637559985638	10784	5443	127	0	\N
27221	1633	3638769985638	10802	5444	112	0	\N
27225	1633	4358769985638	10802	5444	126	0	\N
27226	1633	4358899985638	10802	5444	127	0	\N
27227	1633	4360109985638	10854	5445	112	0	\N
27228	1633	5040060000000	3566	1850	0	0	\N
27232	1633	5080109985638	10854	5445	116	0	\N
27233	1633	5080139985638	10854	5445	117	0	\N
27234	1633	5088537125277	22712	11354	6	0	\N
27235	1633	5088537125277	23119	11547	6	0	\N
27238	1633	5088561125277	22712	11354	7	0	\N
27239	1633	5088561125277	23119	11547	7	0	\N
27240	1633	5760060000000	3779	1959	1	0	\N
27242	1633	5760070000000	3779	1959	2	0	\N
27246	1633	5808549125277	23155	11563	2	0	\N
27247	1633	5808549125277	23157	11563	1	0	\N
27249	1633	5808559125277	23157	11563	2	0	\N
27250	1633	5808560125277	23155	11563	3	0	\N
27254	1633	6516323985638	13032	6719	2	0	\N
27256	1633	6516334985638	13032	6719	3	0	\N
27260	1633	7200090000000	4622	2392	1	0	\N
27261	1633	7200090000000	5261	2730	1	0	\N
27263	1633	7200100000000	4622	2392	2	0	\N
27264	1633	7200100000000	5261	2730	2	0	\N
27268	1633	7248598125277	23810	11852	3	0	\N
27270	1633	7248610125277	23810	11852	4	0	\N
27273	1633	7956362985638	13811	7091	5	0	\N
27274	1633	7956362985638	14150	7223	3	0	\N
27275	1633	7956362985638	14455	7378	4	0	\N
27276	1633	7956362985638	14872	7576	7	0	\N
27279	1633	7956374985638	14150	7223	4	0	\N
27280	1633	7956375985638	14455	7378	5	0	\N
27281	1633	7956385985638	13811	7091	6	0	\N
27282	1633	7956415985638	14872	7576	8	0	\N
27283	1633	7968623125277	24009	11947	2	0	\N
27284	1633	7968623125277	24550	12204	2	0	\N
27285	1633	7968623125277	24774	12301	2	0	\N
27287	1633	7968634125277	24009	11947	3	0	\N
27288	1633	7968634125277	24550	12204	3	0	\N
27289	1633	7968634125277	24774	12301	3	0	\N
27292	1633	8676372985638	15024	7655	10	0	\N
27293	1633	8676372985638	15224	7755	2	0	\N
27295	1633	8676383985638	15224	7755	3	0	\N
27297	1633	8676418985638	15024	7655	11	0	\N
27298	1633	8688635125277	25694	12714	3	0	\N
27300	1633	8688635125277	26721	13216	2	0	\N
27301	1633	8688646125277	26721	13216	3	0	\N
27302	1633	8688647125277	25694	12714	4	0	\N
27307	1633	9408647125277	27001	13355	2	0	\N
27308	1633	9408647125277	27199	13453	5	0	\N
27309	1633	9408647125277	27201	13399	2	0	\N
27311	1633	9408647125277	27405	13551	3	0	\N
27312	1633	9408649125277	27201	13399	3	0	\N
27313	1633	9408658125277	27001	13355	3	0	\N
27315	1633	9408659125277	27405	13551	4	0	\N
27316	1633	9408661125277	27199	13453	6	0	\N
27318	1633	10116546985638	16019	8144	3	0	\N
27319	1633	10116546985638	16169	8219	3	0	\N
27320	1633	10116546985638	16379	8330	3	0	\N
27322	1633	10116558985638	16019	8144	4	0	\N
27323	1633	10116558985638	16169	8219	4	0	\N
27324	1633	10116558985638	16379	8330	4	0	\N
27326	1633	10128659125277	27723	13696	2	0	\N
27327	1633	10128659125277	27964	13827	0	0	\N
27329	1633	10128670125277	27723	13696	3	0	\N
27331	1633	10800110000000	5848	3033	1	0	\N
27333	1633	10800120000000	5848	3033	2	0	\N
27212	1633	3600060000000	2903	1515	2	0	0
27222	1633	4320060000000	3485	1810	0	0	0
27229	1633	5040060000000	3658	1899	0	0	0
27241	1633	5760060000000	4258	2209	1	0	0
27243	1633	5760070000000	4258	2209	2	0	0
27253	1633	6480090000000	4334	2246	3	0	0
27262	1633	7200090000000	5267	2735	2	0	0
27265	1633	7200110000000	5267	2735	3	0	0
27272	1633	7920110000000	5371	2792	0	0	0
27291	1633	8640110000000	5374	2795	0	0	0
27317	1633	10080110000000	5688	2948	0	0	0
27332	1633	10800110000000	6006	3116	1	0	0
27334	1633	10800120000000	6006	3116	2	0	0
27203	1633	2916229985638	10408	5383	4	0	8
27216	1633	3636269985638	12470	6426	0	0	8
27223	1633	4356269985638	12530	6458	3	0	8
27224	1633	4356290985638	12530	6458	4	0	8
27230	1633	5076290985638	12590	6490	2	0	8
27231	1633	5076301985638	12590	6490	3	0	8
27245	1633	5796323985638	12992	6698	5	0	8
27255	1633	6516323985638	13521	6961	4	0	8
27257	1633	6516336985638	13521	6961	5	0	8
27266	1633	7236336985638	13789	7082	8	0	8
27267	1633	7236362985638	13789	7082	9	0	8
27278	1633	7956372985638	14986	7634	2	0	8
27294	1633	8676372985638	15731	7999	7	0	8
27296	1633	8676397985638	15731	7999	8	0	8
27305	1633	9396397985638	15750	8009	14	0	8
27321	1633	10116546985638	16440	8360	3	0	8
27325	1633	10116558985638	16440	8360	4	0	8
27335	1633	10836558985638	16507	8397	11	0	8
27336	1633	10836605985638	16507	8397	12	0	8
27236	1633	5088537125277	23122	11549	3	0	12
27248	1633	5808549125277	23277	11613	4	0	12
27251	1633	5808571125277	23277	11613	5	0	12
27258	1633	6528571125277	23640	11776	9	0	12
27259	1633	6528598125277	23640	11776	10	0	12
27269	1633	7248598125277	23885	11889	7	0	12
27286	1633	7968623125277	25082	12450	3	0	12
27290	1633	7968635125277	25082	12450	4	0	12
27299	1633	8688635125277	26719	13216	3	0	12
27303	1633	8688647125277	26719	13216	4	0	12
27314	1633	9408659125277	27404	13551	4	0	12
27328	1633	10128659125277	27965	13833	11	0	12
27330	1633	10128697125277	27965	13833	12	0	12
27337	1633	10848697125277	28373	14026	2	0	\N
27339	1633	10848708125277	28373	14026	3	0	\N
27341	1633	11520120000000	6156	3189	1	0	\N
27343	1633	11520130000000	6156	3189	2	0	\N
27345	1633	11556605985638	16788	8520	3	0	\N
27346	1633	11556605985638	16865	8553	3	0	\N
27347	1633	11556605985638	16923	8577	4	0	\N
27350	1633	11556617985638	16788	8520	4	0	\N
27351	1633	11556617985638	16865	8553	4	0	\N
27352	1633	11556618985638	16923	8577	5	0	\N
27353	1633	11568713625277	28534	14098	2	0	\N
27355	1633	11568724625277	28534	14098	3	0	\N
27357	1633	11568736625277	29075	14334	2	0	\N
27360	1633	12240860000000	7260	3677	43	0	\N
27361	1633	12276616985638	17110	8669	3	0	\N
27363	1633	12276619985638	17110	8669	4	0	\N
27366	1633	12288736625277	29075	14334	4	0	\N
27367	1633	12288737625277	29075	14334	5	0	\N
27369	1633	12960160000000	6819	3530	2	0	\N
27372	1633	12960180000000	6819	3530	3	0	\N
27373	1633	12960860000000	7260	3677	126	0	\N
27374	1633	12961770000000	7260	3677	127	0	\N
27375	1633	12962215000000	7528	3678	43	0	\N
27378	1633	12996670985638	17738	8966	6	0	\N
27379	1633	12996671985638	17282	8752	2	0	\N
27384	1633	13682215000000	7528	3678	126	0	\N
27385	1633	13683035000000	7528	3678	127	0	\N
27386	1633	13716660985638	17701	8947	2	0	\N
27389	1633	13716671985638	17282	8752	4	0	\N
27390	1633	13716672985638	17282	8752	5	0	\N
27394	1633	14400180000000	8657	4484	1	0	\N
27396	1633	14400190000000	8657	4484	2	0	\N
27398	1633	14436670985638	18379	9251	0	0	\N
27401	1633	14448822625277	29231	14404	4	0	\N
27402	1633	14448822625277	29259	14420	3	0	\N
27404	1633	14448834625277	29259	14420	4	0	\N
27406	1633	14448835625277	29231	14404	5	0	\N
27407	1633	15120200000000	8843	4583	6	0	\N
27409	1633	15120260000000	8843	4583	7	0	\N
27411	1633	15156716975638	18969	9567	2	0	\N
27414	1633	15156727975638	18969	9567	3	0	\N
27415	1633	15157037975638	20763	10416	14	0	\N
27418	1633	15840270000000	9413	4884	2	0	\N
27419	1633	15840290000000	9413	4884	3	0	\N
27420	1633	15876717975638	20767	10436	14	0	\N
27421	1633	15876717975638	20837	10472	2	0	\N
27423	1633	15876728975638	20837	10472	3	0	\N
27425	1633	15877001975638	20767	10436	15	0	\N
27426	1633	15877037975638	20763	10416	38	0	\N
27428	1633	15888844625277	29679	14639	12	0	\N
27430	1633	15888973625277	29679	14639	13	0	\N
27432	1633	16596749975638	21309	10697	3	0	\N
27433	1633	16596749975638	21311	10697	3	0	\N
27434	1633	16596749975638	21808	10915	6	0	\N
27436	1633	16596761975638	21309	10697	4	0	\N
27437	1633	16596761975638	21311	10697	4	0	\N
27439	1633	16596773975638	21808	10915	7	0	\N
27440	1633	16597227465639	20836	10417	37	0	\N
27444	1633	17317502435642	20848	10418	4	0	\N
27445	1633	17317542435642	20848	10418	5	0	\N
27446	1633	76800395000000	15514	7894	7	1	\N
27447	1634	125000	21871	10800	11	0	\N
27448	1634	200000001	21870	10799	124	0	\N
27449	1634	261999988	12595	6493	3	0	\N
27456	1634	2160060000000	1208	666	1	0	\N
27458	1634	2880060000000	1208	666	2	0	\N
27464	1634	4752105151080	21871	10800	35	0	\N
27452	1634	1440010000000	481	269	1	0	0
27453	1634	1440020000000	481	269	2	0	0
27454	1634	2160020000000	707	395	3	0	0
27455	1634	2160050000000	707	395	4	0	0
27457	1634	2880050000000	1240	685	1	0	0
27460	1634	3600060000000	1311	722	1	0	0
27461	1634	3600070000000	1311	722	2	0	0
27462	1634	4320070000000	1663	895	2	0	0
27463	1634	4320090000000	1663	895	3	0	0
27465	1634	5040090000000	1865	994	1	0	0
27469	1634	5760100000000	2098	1107	2	0	0
27470	1634	5760120000000	2098	1107	3	0	0
27342	1633	11520120000000	6518	3378	2	0	0
27344	1633	11520140000000	6518	3378	3	0	0
27359	1633	12240160000000	6635	3428	3	0	0
27370	1633	12960160000000	8180	4238	1	0	0
27371	1633	12960170000000	8180	4238	2	0	0
27382	1633	13680170000000	8283	4290	1	0	0
27383	1633	13680180000000	8283	4290	2	0	0
27397	1633	14400200000000	8798	4561	3	0	0
27408	1633	15120200000000	9396	4875	7	0	0
27410	1633	15120270000000	9396	4875	8	0	0
27348	1633	11556605985638	17034	8625	2	0	8
27349	1633	11556616985638	17034	8625	3	0	8
27364	1633	12276638985638	17134	8682	5	0	8
27376	1633	12996638985638	17268	8747	4	0	8
27377	1633	12996660985638	17268	8747	5	0	8
27387	1633	13716660985638	18269	9203	1	0	8
27399	1633	14436670985638	18484	9309	10	0	8
27400	1633	14436716975638	18484	9309	11	0	8
27412	1633	15156716975638	20281	10213	1	0	8
27413	1633	15156717975638	20281	10213	2	0	8
27467	1634	5422871259504	20802	10457	7	0	18
27422	1633	15876717975638	20849	10478	5	0	8
27424	1633	15876749975638	20849	10478	6	0	8
27471	1634	6142905259504	20900	10506	2	0	18
27472	1634	6142916259504	20900	10506	3	0	18
27435	1633	16596749975638	22396	11213	4	0	8
27442	1633	17316762975638	22556	11285	4	0	8
27443	1633	17316775975638	22556	11285	5	0	8
27338	1633	10848697125277	28488	14078	3	0	12
27340	1633	10848713625277	28488	14078	4	0	12
27356	1633	11568725625277	29054	14327	4	0	12
27365	1633	12288725625277	29127	14360	12	0	12
27368	1633	12288773625277	29127	14360	13	0	12
27380	1633	13008773625277	29132	14363	10	0	12
27381	1633	13008810625277	29132	14363	11	0	12
27392	1633	13728822625277	29227	14402	4	0	12
27393	1633	13728832625277	29294	14435	1	0	12
27403	1633	14448832625277	29294	14435	4	0	12
27405	1633	14448834625277	29294	14435	5	0	12
27416	1633	15168834625277	29308	14442	1	0	12
27427	1633	15888844625277	29678	14639	9	0	12
27429	1633	15888970625277	29678	14639	10	0	12
27431	1633	15889008625277	30124	14824	20	0	12
27441	1633	16609008625277	30124	14824	21	0	12
27475	1634	6671580641004	12177	6270	1	0	\N
27477	1634	6671580641004	12595	6493	2	0	\N
27478	1634	6671581641004	12177	6270	2	0	\N
27482	1634	6862981259504	21691	10865	9	0	\N
27483	1634	6863057259504	21870	10799	12	0	\N
27488	1634	7391612641004	12943	6671	1	0	\N
27491	1634	7582981259504	21691	10865	12	0	\N
27492	1634	7582983259504	21691	10865	13	0	\N
27493	1634	7583057259504	21870	10799	123	0	\N
27494	1634	7920140000000	2721	1429	2	0	\N
27495	1634	7920140000000	2993	1555	1	0	\N
27496	1634	7920140000000	3227	1675	13	0	\N
27497	1634	7920140000000	3229	1675	4	0	\N
27499	1634	7920150000000	2993	1555	2	0	\N
27500	1634	7920160000000	2721	1429	3	0	\N
27502	1634	7920270000000	3229	1675	5	0	\N
27503	1634	7920360000000	3227	1675	14	0	\N
27505	1634	8111612641004	12943	6671	4	0	\N
27506	1634	8111614641004	12943	6671	5	0	\N
27509	1634	8303944194587	21871	10800	34	0	\N
27511	1634	8640160000000	3526	1793	6	0	\N
27512	1634	8640184000000	3526	1793	7	0	\N
27515	1634	8894154194579	21872	10801	0	0	\N
27516	1634	9022951259504	22132	11070	6	0	\N
27518	1634	9022975259504	22132	11070	7	0	\N
27520	1634	9360160000000	3625	1880	0	0	\N
27521	1634	9360160000000	4298	1940	0	0	\N
27522	1634	9360160000000	4300	1948	0	0	\N
27523	1634	9360160000000	4301	1966	0	0	\N
27524	1634	9360160000000	4302	1984	0	0	\N
27525	1634	9360160000000	4434	2299	2	0	\N
27526	1634	9360160000000	5086	2639	2	0	\N
27528	1634	9360180000000	4434	2299	3	0	\N
27529	1634	9360180000000	5086	2639	3	0	\N
27531	1634	9360184000000	3628	1794	1	0	\N
27532	1634	9360284000000	3628	1794	2	0	\N
27535	1634	9614154194579	22133	10802	0	0	\N
27538	1634	10080180000000	5252	2726	2	0	\N
27541	1634	10080200000000	5252	2726	3	0	\N
27548	1634	10991711641004	13766	7072	4	0	\N
27550	1634	10991711641004	13889	7126	1	0	\N
27551	1634	10991721641004	13889	7126	2	0	\N
27552	1634	10991724641004	13766	7072	5	0	\N
27554	1634	10992044641004	14711	7419	23	0	\N
27555	1634	11183001259504	23035	11501	10	0	\N
27558	1634	11183038259504	23035	11501	11	0	\N
27560	1634	11710724641004	14019	7185	0	0	\N
27561	1634	11711724641004	14026	7185	10	0	\N
27562	1634	11711724641004	14044	7193	8	0	\N
27563	1634	11711724641004	14050	7193	11	0	\N
27564	1634	11711724641004	14710	7490	6	0	\N
27565	1634	11711724641004	15048	7666	2	0	\N
27568	1634	11711735641004	15048	7666	3	0	\N
27569	1634	11711751641004	14044	7193	9	0	\N
27570	1634	11711752641004	14026	7185	11	0	\N
27571	1634	11711754641004	14050	7193	12	0	\N
27572	1634	11711757641004	14710	7490	7	0	\N
27573	1634	11712044641004	14711	7419	126	0	\N
27574	1634	11713064641004	14711	7419	127	0	\N
27575	1634	11903012259504	23373	11663	2	0	\N
27577	1634	11903023259504	23373	11663	3	0	\N
27583	1634	12623037259504	23577	11748	3	0	\N
27584	1634	12623037259504	24266	12073	15	0	\N
27585	1634	12623037259504	24354	12111	2	0	\N
27586	1634	12623037259504	24824	12326	3	0	\N
27588	1634	12623048259504	24354	12111	3	0	\N
27589	1634	12623049259504	23577	11748	4	0	\N
27590	1634	12623049259504	24824	12326	4	0	\N
27592	1634	12623097259504	24266	12073	16	0	\N
27593	1634	12960219899999	5910	3064	1	0	\N
27595	1634	12960229899999	5910	3064	2	0	\N
27597	1634	13151744641004	15496	7887	6	0	\N
27600	1634	13151777641004	15496	7887	7	0	\N
27601	1634	13343051259504	25046	12427	1	0	\N
27602	1634	13343051259504	25236	12516	5	0	\N
27603	1634	13343051259504	25719	12722	3	0	\N
27604	1634	13343051259504	25754	12739	3	0	\N
27606	1634	13343061259504	25046	12427	2	0	\N
27608	1634	13343063259504	25719	12722	4	0	\N
27484	1634	7200130000000	2634	1386	1	0	0
27485	1634	7200140000000	2634	1386	2	0	0
27498	1634	7920140000000	3298	1711	2	0	0
27501	1634	7920160000000	3298	1711	3	0	0
27510	1634	8640160000000	3523	1830	0	0	0
27530	1634	9360180000000	5094	2644	3	0	0
27539	1634	10080180000000	5253	2726	2	0	0
27540	1634	10080189899999	5253	2726	3	0	0
27546	1634	10800189899999	5310	2761	2	0	0
27547	1634	10800209899999	5310	2761	3	0	0
27579	1634	12240209899999	5818	3020	1	0	0
27580	1634	12240219899999	5818	3020	2	0	0
27594	1634	12960219899999	5987	3106	1	0	0
27596	1634	12960229899999	5987	3106	2	0	0
27479	1634	6671591641004	12594	6493	3	0	9
27486	1634	7391591641004	12704	6552	2	0	9
27487	1634	7391602641004	12704	6552	3	0	9
27504	1634	8111602641004	12951	6676	4	0	9
27507	1634	8111624641004	12951	6676	5	0	9
27514	1634	8831636641004	13299	6852	4	0	9
27533	1634	9551636641004	13481	6942	18	0	9
27534	1634	9551699641004	13481	6942	19	0	9
27542	1634	10271699641004	13508	6955	3	0	9
27543	1634	10271711641004	13508	6955	4	0	9
27553	1634	10991724641004	13886	7126	5	0	9
27566	1634	11711724641004	15308	7799	1	0	9
27567	1634	11711734641004	15308	7799	2	0	9
27581	1634	12431734641004	15373	7832	1	0	9
27598	1634	13151744641004	15503	7890	1	0	9
27599	1634	13151754641004	15503	7890	2	0	9
27480	1634	6862916259504	21211	10651	2	0	18
27481	1634	6862927259504	21211	10651	3	0	18
27489	1634	7582927259504	21768	10899	6	0	18
27508	1634	8302951259504	21869	10944	0	0	18
27517	1634	9022951259504	22233	11127	6	0	18
27519	1634	9022975259504	22233	11127	7	0	18
27536	1634	9742975259504	22314	11170	4	0	18
27537	1634	9742988259504	22314	11170	5	0	18
27556	1634	11183001259504	23076	11521	2	0	18
27557	1634	11183012259504	23076	11521	3	0	18
27576	1634	11903012259504	23503	11716	7	0	18
27578	1634	11903037259504	23503	11716	8	0	18
27587	1634	12623037259504	24863	12346	5	0	18
27591	1634	12623051259504	24863	12346	6	0	18
27605	1634	13343051259504	25891	12796	2	0	18
27607	1634	13343062259504	25891	12796	3	0	18
27609	1634	13343063259504	25754	12739	4	0	\N
27610	1634	13343065259504	25236	12516	6	0	\N
27611	1634	13680229899999	6164	3193	1	0	\N
27613	1634	13680239899999	6164	3193	2	0	\N
27620	1634	14400239899999	6804	3522	1	0	\N
27621	1634	14400249899999	6804	3522	2	0	\N
27629	1634	15311786641004	15665	7975	6	0	\N
27630	1634	15311786641004	15674	7977	3	0	\N
27631	1634	15311786641004	16145	8207	3	0	\N
27633	1634	15311798641004	15674	7977	4	0	\N
27634	1634	15311798641004	16145	8207	4	0	\N
27635	1634	15311810641004	15665	7975	7	0	\N
27637	1634	15503095259504	26350	13029	1	0	\N
27638	1634	15503095259504	26502	13110	7	0	\N
27640	1634	15503096259504	26350	13029	2	0	\N
27642	1634	15503120259504	26502	13110	8	0	\N
27647	1634	16223107259504	26656	13185	4	0	\N
27648	1634	16223107259504	26865	13286	7	0	\N
27650	1634	16223120259504	26656	13185	5	0	\N
27651	1634	16223132259504	26865	13286	8	0	\N
27653	1634	16560289899999	7873	4080	1	0	\N
27654	1634	16560289899999	8144	4223	2	0	\N
27655	1634	16560289899999	8231	4266	3	0	\N
27657	1634	16560299899999	7873	4080	2	0	\N
27659	1634	16560309899999	8144	4223	3	0	\N
27660	1634	16560319899999	8231	4266	4	0	\N
27661	1634	16751833641004	16649	8459	3	0	\N
27663	1634	16751845641004	16649	8459	4	0	\N
27665	1634	16943144259504	27200	13453	5	0	\N
27666	1634	16943144259504	27234	13466	3	0	\N
27668	1634	16943156259504	27234	13466	4	0	\N
27669	1634	16943158259504	27200	13453	6	0	\N
27674	1634	17471845641004	17077	8649	4	0	\N
27677	1634	17471858641004	17077	8649	5	0	\N
27678	1634	17663180259504	27502	13594	3	0	\N
27679	1634	17663180259504	27546	13616	9	0	\N
27680	1634	17663180259504	27729	13698	4	0	\N
27681	1634	17663192259504	27502	13594	4	0	\N
27683	1634	17663202259504	27729	13698	5	0	\N
27685	1634	17663216259504	27546	13616	10	0	\N
27688	1634	18191857641004	17325	8777	7	0	\N
27689	1634	18191857641004	17889	9028	6	0	\N
27692	1634	18191872641004	17889	9028	7	0	\N
27693	1634	18191981641004	17325	8777	8	0	\N
27696	1634	18384382416084	30185	14587	63	0	\N
27700	1634	18911869641004	18068	9113	2	0	\N
27702	1634	18911880641004	18068	9113	3	0	\N
27704	1634	19104382416084	30185	14587	75	0	\N
27705	1634	19104395716084	30185	14587	76	0	\N
27706	1634	19440364899999	9218	4780	4	0	\N
27707	1634	19440404899999	9218	4780	5	0	\N
27711	1634	19632362641004	19533	9841	1	0	\N
27712	1634	19823395716060	30209	14588	0	0	\N
27713	1634	20160443899999	9714	5037	4	0	\N
27716	1634	20160483899999	9714	5037	5	0	\N
27717	1634	20352352641004	18536	9299	7	0	\N
27718	1634	20352352641004	19303	9734	20	0	\N
27719	1634	20352352641004	19700	9920	3	0	\N
27720	1634	20352352641004	20226	10183	3	0	\N
27722	1634	20352352641004	20256	10202	2	0	\N
27723	1634	20352362641004	19533	9841	4	0	\N
27724	1634	20352363641004	20256	10202	3	0	\N
27725	1634	20352364641004	19533	9841	5	0	\N
27726	1634	20352364641004	19700	9920	4	0	\N
27727	1634	20352364641004	20226	10183	4	0	\N
27729	1634	20352458641004	19303	9734	21	0	\N
27730	1634	20352633641004	18536	9299	8	0	\N
27735	1634	21072633641004	18711	9300	27	0	\N
27736	1634	21073839641004	18711	9300	28	0	\N
27740	1634	21792388641004	20465	10305	3	0	\N
27742	1634	21792400641004	20465	10305	4	0	\N
27744	1634	22320523899999	11323	5814	1	0	\N
27619	1634	14400239899999	6800	3522	2	0	0
27622	1634	14400259899999	6800	3522	3	0	0
27627	1634	15120259899999	7290	3768	1	0	0
27628	1634	15120269899999	7290	3768	2	0	0
27643	1634	15840269899999	7653	3961	2	0	0
27656	1634	16560289899999	8389	4347	2	0	0
27658	1634	16560304899999	8389	4347	3	0	0
27672	1634	17280304899999	8477	4392	2	0	0
27673	1634	17280324899999	8477	4392	3	0	0
27686	1634	18000324899999	8628	4472	2	0	0
27697	1634	18720344899999	8927	4627	2	0	0
27698	1634	18720364899999	8927	4627	3	0	0
27699	1634	18720444899999	9701	5032	8	0	0
27708	1634	19440443899999	9701	5032	9	0	0
27715	1634	20160463899999	10406	5382	3	0	0
27731	1634	20880463899999	10554	5450	2	0	0
27732	1634	20880483899999	10554	5450	3	0	0
27737	1634	21600483899999	10674	5510	4	0	0
27738	1634	21600523899999	10674	5510	5	0	0
27615	1634	13871754641004	15545	7912	3	0	9
27616	1634	13871766641004	15545	7912	4	0	9
27623	1634	14591766641004	15566	7922	2	0	9
27624	1634	14591786641004	15566	7922	3	0	9
27632	1634	15311786641004	16294	8279	6	0	9
27645	1634	16031810641004	16526	8405	5	0	9
27646	1634	16031833641004	16526	8405	6	0	9
27662	1634	16751833641004	16847	8548	3	0	9
27664	1634	16751845641004	16847	8548	4	0	9
27676	1634	17471857641004	17235	8732	4	0	9
27690	1634	18191857641004	18028	9096	3	0	9
27691	1634	18191869641004	18028	9096	4	0	9
27701	1634	18911869641004	18224	9179	5	0	9
27703	1634	18911892641004	18224	9179	6	0	9
27710	1634	19632352641004	18310	9223	20	0	9
27721	1634	20352352641004	20255	10202	3	0	9
27728	1634	20352364641004	20255	10202	4	0	9
27733	1634	21072364641004	20321	10235	6	0	9
27734	1634	21072388641004	20321	10235	7	0	9
27741	1634	21792399641004	20464	10305	3	0	9
27617	1634	14063062259504	26046	12870	4	0	18
27618	1634	14063084259504	26046	12870	5	0	18
27625	1634	14783084259504	26286	13000	2	0	18
27639	1634	15503095259504	26606	13163	3	0	18
27641	1634	15503107259504	26606	13163	4	0	18
27649	1634	16223107259504	27083	13391	10	0	18
27652	1634	16223144259504	27083	13391	11	0	18
27667	1634	16943144259504	27361	13527	9	0	18
27671	1634	16943201259504	27915	13807	3	0	18
27682	1634	17663201259504	27915	13807	7	0	18
27684	1634	17663204259504	27915	13807	8	0	18
27694	1634	18383204259504	28003	13849	1	0	18
27695	1634	18383214259504	28003	13849	2	0	18
27746	1634	22320533899999	11323	5814	2	0	\N
27755	1637	200000001	14221	7259	6	1	\N
27760	1637	2160020000000	43	26	1	0	\N
27761	1637	2160020000000	130	76	2	0	\N
27763	1637	2160030000000	43	26	2	0	\N
27765	1637	2160040000000	130	76	3	0	\N
27770	1637	4320070000000	283	163	1	0	\N
27772	1637	4320080000000	283	163	2	0	\N
27780	1637	7200140000000	476	265	3	0	\N
27782	1637	7200170000000	476	265	4	0	\N
27788	1637	9360201000000	575	324	1	0	\N
27789	1637	9360201000000	584	330	1	0	\N
27791	1637	9360211000000	575	324	2	0	\N
27792	1637	9360211000000	584	330	2	0	\N
27796	1637	10800421000000	626	351	2	0	\N
27798	1637	10800441000000	626	351	3	0	\N
27802	1637	12240451000000	720	402	2	0	\N
27803	1637	12240451000000	727	406	1	0	\N
27804	1637	12240451000000	781	433	3	0	\N
27806	1637	12240461000000	727	406	2	0	\N
27808	1637	12240481000000	781	433	4	0	\N
27809	1637	12240561000000	720	402	3	0	\N
27810	1637	12960461000000	801	443	1	0	\N
27811	1637	12960461000000	811	449	1	0	\N
27813	1637	12960471000000	801	443	2	0	\N
27814	1637	12960471000000	811	449	2	0	\N
27816	1637	13680471000000	870	482	1	0	\N
27818	1637	13680481000000	870	482	2	0	\N
27820	1637	14400481000000	886	493	2	0	\N
27821	1637	14400481000000	899	500	1	0	\N
27822	1637	14400481000000	901	501	1	0	\N
27823	1637	14400481000000	909	505	1	0	\N
27824	1637	14400481000000	977	542	1	0	\N
27825	1637	14400481000000	988	546	1	0	\N
27827	1637	14400491000000	899	500	2	0	\N
27828	1637	14400491000000	901	501	2	0	\N
27829	1637	14400491000000	909	505	2	0	\N
27830	1637	14400491000000	977	542	2	0	\N
27831	1637	14400491000000	988	546	2	0	\N
27833	1637	14400501000000	886	493	3	0	\N
27836	1637	15840501000000	1072	593	1	0	\N
27837	1637	15840501000000	1120	617	2	0	\N
27839	1637	15840511000000	1072	593	2	0	\N
27840	1637	15840521000000	1120	617	3	0	\N
27842	1637	16560521000000	1266	699	3	0	\N
27845	1637	16560551000000	1266	699	4	0	\N
27850	1637	18720551000000	1456	793	2	0	\N
27852	1637	18720562000000	1456	793	3	0	\N
27856	1637	20160611000000	1508	826	1	0	\N
27858	1637	20160621000000	1508	826	2	0	\N
27863	1637	21600631000000	1576	858	1	0	\N
27864	1637	21600641000000	1576	858	2	0	\N
27870	1637	23760661000000	1724	925	2	0	\N
27872	1637	23760681000000	1724	925	3	0	\N
27878	1637	25920751000000	1877	998	1	0	\N
27879	1637	25920751000000	1924	1024	1	0	\N
27880	1637	25920751000000	1984	1049	2	0	\N
27758	1637	1440010000000	27	16	1	0	0
27759	1637	1440020000000	27	16	2	0	0
27762	1637	2160020000000	141	83	1	0	0
27764	1637	2160030000000	141	83	2	0	0
27766	1637	2880030000000	156	93	2	0	0
27768	1637	3600050000000	202	119	2	0	0
27769	1637	3600070000000	202	119	3	0	0
27771	1637	4320070000000	295	170	2	0	0
27773	1637	4320090000000	295	170	3	0	0
27774	1637	5040090000000	342	195	2	0	0
27776	1637	5760110000000	381	217	1	0	0
27777	1637	5760120000000	381	217	2	0	0
27778	1637	6480120000000	402	228	2	0	0
27779	1637	6480140000000	402	228	3	0	0
27783	1637	7200180000000	513	287	5	0	0
27784	1637	7920180000000	527	297	2	0	0
27785	1637	7920191000000	527	297	3	0	0
27786	1637	8640191000000	536	304	1	0	0
27787	1637	8640201000000	536	304	2	0	0
27793	1637	9360411000000	591	335	4	0	0
27794	1637	10080411000000	601	341	1	0	0
27795	1637	10080421000000	601	341	2	0	0
27797	1637	10800421000000	655	366	2	0	0
27799	1637	10800441000000	655	366	3	0	0
27801	1637	11520451000000	705	393	2	0	0
27805	1637	12240451000000	799	442	1	0	0
27807	1637	12240461000000	799	442	2	0	0
27812	1637	12960461000000	832	458	1	0	0
27817	1637	13680471000000	883	491	1	0	0
27819	1637	13680481000000	883	491	2	0	0
27826	1637	14400481000000	1024	567	1	0	0
27832	1637	14400491000000	1024	567	2	0	0
27834	1637	15120491000000	1067	591	1	0	0
27838	1637	15840501000000	1132	625	2	0	0
27841	1637	15840521000000	1132	625	3	0	0
27843	1637	16560521000000	1281	708	1	0	0
27844	1637	16560531000000	1281	708	2	0	0
27846	1637	17280531000000	1319	726	1	0	0
27848	1637	18000541000000	1332	733	1	0	0
27849	1637	18000551000000	1332	733	2	0	0
27851	1637	18720551000000	1460	795	4	0	0
27853	1637	18720591000000	1460	795	5	0	0
27855	1637	19440611000000	1482	808	3	0	0
27857	1637	20160611000000	1569	855	1	0	0
27859	1637	20160621000000	1569	855	2	0	0
27860	1637	20880621000000	1571	856	1	0	0
27861	1637	20880631000000	1571	856	2	0	0
27865	1637	21600641000000	1638	883	2	0	0
27866	1637	22320641000000	1644	886	1	0	0
27867	1637	22320651000000	1644	886	2	0	0
27868	1637	23040651000000	1696	913	1	0	0
27869	1637	23040661000000	1696	913	2	0	0
27873	1637	23760691000000	1770	949	4	0	0
27874	1637	24480691000000	1787	956	5	0	0
27875	1637	24480741000000	1787	956	6	0	0
27876	1637	24480751000000	1790	957	1	0	0
27745	1634	22320533899999	11322	5814	2	0	0
27749	1634	23040533899999	11431	5872	4	0	0
27750	1634	23040555899999	11431	5872	5	0	0
27751	1634	23760555899999	11436	5874	1	0	0
27752	1634	23760556899999	11436	5874	2	0	0
27754	1635	720012000000	16665	8465	4	0	0
27747	1634	22512399641004	20527	10333	4	0	9
27748	1634	22512431641004	20527	10333	5	0	9
27882	1637	25920761000000	1877	998	2	0	\N
27883	1637	25920761000000	1924	1024	2	0	\N
27885	1637	25920771000000	1984	1049	3	0	\N
27888	1637	27360771000000	2041	1077	2	0	\N
27889	1637	27360771000000	2073	1095	2	0	\N
27890	1637	27360771000000	2108	1111	1	0	\N
27892	1637	27360781000000	2108	1111	2	0	\N
27893	1637	27360791000000	2041	1077	3	0	\N
27894	1637	27360791000000	2073	1095	3	0	\N
27898	1637	28800801000000	2191	1155	1	0	\N
27899	1637	28800801000000	2203	1159	1	0	\N
27901	1637	28800811000000	2191	1155	2	0	\N
27902	1637	28800811000000	2203	1159	2	0	\N
27904	1637	29520811000000	2433	1273	1	0	\N
27906	1637	29520821000000	2433	1273	2	0	\N
27908	1637	30240821000000	2493	1305	1	0	\N
27910	1637	30240831000000	2493	1305	2	0	\N
27912	1637	30960831000000	2590	1364	2	0	\N
27913	1637	30960831000000	2606	1371	2	0	\N
27916	1637	30960851000000	2590	1364	3	0	\N
27917	1637	30960851000000	2606	1371	3	0	\N
27918	1637	31680841000000	2637	1387	1	0	\N
27919	1637	31680841000000	2653	1395	2	0	\N
27921	1637	31680851000000	2637	1387	2	0	\N
27923	1637	31680861000000	2653	1395	3	0	\N
27928	1637	33840871000000	2738	1437	1	0	\N
27930	1637	33840881000000	2738	1437	2	0	\N
27932	1637	34560881000000	2780	1454	2	0	\N
27935	1637	34560901000000	2780	1454	3	0	\N
27936	1637	35280891000000	2889	1509	1	0	\N
27938	1637	35280901000000	2889	1509	2	0	\N
27940	1637	36000901000000	2934	1526	1	0	\N
27942	1637	36000911000000	2934	1526	2	0	\N
27952	1637	39600971000000	3151	1637	3	0	\N
27953	1637	39600971000000	3152	1638	1	0	\N
27955	1637	39600981000000	3152	1638	2	0	\N
27957	1637	39601001000000	3151	1637	4	0	\N
27958	1637	40320981000000	3192	1657	1	0	\N
27960	1637	40320991000000	3192	1657	2	0	\N
27964	1637	41761051000000	3240	1682	18	0	\N
27967	1637	41761231000000	3240	1682	19	0	\N
27974	1637	44641312000000	3364	1749	1	0	\N
27975	1637	44641312000000	3450	1790	0	0	\N
27977	1637	44641322000000	3364	1749	2	0	\N
27978	1637	45361312000000	3461	1797	0	0	\N
27979	1637	45361312000000	3483	1808	0	0	\N
27980	1637	45361312000000	3505	1819	1	0	\N
27982	1637	45361313000000	3505	1819	2	0	\N
27983	1637	46081312000000	3606	1871	0	0	\N
27986	1637	46801322000000	3688	1915	2	0	\N
27987	1637	46801322000000	4474	2319	1	0	\N
27989	1637	46801332000000	4474	2319	2	0	\N
27991	1637	46801342000000	3688	1915	3	0	\N
27992	1637	47521332000000	4575	2367	1	0	\N
27993	1637	47521332000000	4671	2415	2	0	\N
27995	1637	47521342000000	4575	2367	2	0	\N
27997	1637	47521442000000	4671	2415	3	0	\N
27998	1637	48241352000000	4689	2424	1	0	\N
27999	1637	48241352000000	4713	2437	1	0	\N
28001	1637	48241362000000	4689	2424	2	0	\N
28002	1637	48241362000000	4713	2437	2	0	\N
28006	1637	49681372000000	4892	2535	1	0	\N
28008	1637	49681382000000	4892	2535	2	0	\N
28010	1637	50401382000000	4987	2584	3	0	\N
28011	1637	50401382000000	5008	2595	2	0	\N
28014	1637	50401412000000	4987	2584	4	0	\N
28015	1637	50401492000000	5008	2595	3	0	\N
28016	1637	51121392000000	5063	2627	1	0	\N
27886	1637	26640761000000	2035	1073	1	0	0
27887	1637	26640771000000	2035	1073	2	0	0
27891	1637	27360771000000	2152	1137	2	0	0
27895	1637	27360791000000	2152	1137	3	0	0
27896	1637	28080791000000	2171	1145	1	0	0
27900	1637	28800801000000	2426	1270	1	0	0
27903	1637	28800811000000	2426	1270	2	0	0
27905	1637	29520811000000	2466	1291	1	0	0
27907	1637	29520821000000	2466	1291	2	0	0
27909	1637	30240821000000	2529	1329	1	0	0
27914	1637	30960831000000	2608	1372	1	0	0
27915	1637	30960841000000	2608	1372	2	0	0
27920	1637	31680841000000	2658	1397	1	0	0
27922	1637	31680851000000	2658	1397	2	0	0
27925	1637	32400861000000	2666	1400	2	0	0
27926	1637	33120861000000	2722	1430	1	0	0
27927	1637	33120871000000	2722	1430	2	0	0
27929	1637	33840871000000	2774	1452	1	0	0
27931	1637	33840881000000	2774	1452	2	0	0
27934	1637	34560891000000	2846	1490	2	0	0
27937	1637	35280891000000	2898	1513	1	0	0
27939	1637	35280901000000	2898	1513	2	0	0
27941	1637	36000901000000	2946	1531	1	0	0
27943	1637	36000911000000	2946	1531	2	0	0
27945	1637	36720921000000	2949	1533	2	0	0
27946	1637	37440921000000	3035	1576	1	0	0
27947	1637	37440931000000	3035	1576	2	0	0
27948	1637	38160931000000	3091	1605	1	0	0
27950	1637	38880941000000	3123	1623	3	0	0
27951	1637	38880971000000	3123	1623	4	0	0
27954	1637	39600971000000	3175	1649	1	0	0
27956	1637	39600981000000	3175	1649	2	0	0
27959	1637	40320981000000	3205	1665	1	0	0
27962	1637	41040991000000	3230	1676	6	0	0
27963	1637	41041051000000	3230	1676	7	0	0
27965	1637	41761051000000	3280	1704	2	0	0
27966	1637	41761071000000	3280	1704	3	0	0
27968	1637	42481071000000	3323	1723	19	0	0
27970	1637	43201261000000	3343	1736	3	0	0
27971	1637	43201282000000	3343	1736	4	0	0
27972	1637	43921282000000	3352	1741	3	0	0
27973	1637	43921312000000	3352	1741	4	0	0
27981	1637	45361312000000	3538	1836	0	0	0
27984	1637	46081312000000	3679	1910	1	0	0
27985	1637	46081322000000	3679	1910	2	0	0
27988	1637	46801322000000	4501	2330	1	0	0
27990	1637	46801332000000	4501	2330	2	0	0
27996	1637	47521352000000	4677	2418	3	0	0
28000	1637	48241352000000	4784	2473	1	0	0
28003	1637	48241362000000	4784	2473	2	0	0
28004	1637	48961362000000	4850	2513	1	0	0
28005	1637	48961372000000	4850	2513	2	0	0
28009	1637	49681382000000	4938	2557	2	0	0
28012	1637	50401382000000	5013	2599	1	0	0
28013	1637	50401392000000	5013	2599	2	0	0
28018	1637	51121402000000	5063	2627	2	0	\N
28022	1637	52561412000000	5164	2679	1	0	\N
28023	1637	52561412000000	5187	2695	1	0	\N
28025	1637	52561422000000	5164	2679	2	0	\N
28026	1637	52561422000000	5187	2695	2	0	\N
28028	1637	53281432000000	5223	2715	1	0	\N
28029	1637	53281432000000	5226	2716	1	0	\N
28031	1637	53281442000000	5223	2715	2	0	\N
28032	1637	53281442000000	5226	2716	2	0	\N
28038	1637	55441462000000	5338	2769	1	0	\N
28039	1637	55441462000000	5346	2774	1	0	\N
28041	1637	55441472000000	5338	2769	2	0	\N
28042	1637	55441472000000	5346	2774	2	0	\N
28045	1637	56881472000000	5380	2799	1	0	\N
28046	1637	56881472000000	5398	2809	0	0	\N
28048	1637	56881473000000	5380	2799	2	0	\N
28050	1637	57601473000000	5470	2849	0	0	\N
28051	1637	57601473000000	5495	2858	0	0	\N
28053	1637	58321473000000	5540	2880	1	0	\N
28054	1637	58321473000000	5602	2910	0	0	\N
28056	1637	58321573000000	5540	2880	2	0	\N
28062	1637	61921673000000	5739	2974	1	0	\N
28064	1637	61921683000000	5739	2974	2	0	\N
28072	1637	64801733799997	5898	3058	1	0	\N
28074	1637	64801743799997	5898	3058	2	0	\N
28076	1637	65521743799997	5926	3070	1	0	\N
28078	1637	65521753799997	5926	3070	2	0	\N
28082	1637	66720044900000	25375	12473	14	1	\N
28087	1637	68401783799997	6180	3200	1	0	\N
28089	1637	68401793799997	6180	3200	2	0	\N
28090	1637	69121783799997	6219	3218	1	0	\N
28092	1637	69121793799997	6219	3218	2	0	\N
28094	1637	69841814799997	6255	3237	2	0	\N
28095	1637	69841814799997	6276	3251	1	0	\N
28097	1637	69841824799997	6276	3251	2	0	\N
28099	1637	69841834799997	6255	3237	3	0	\N
28100	1637	70561824799997	6353	3287	2	0	\N
28101	1637	70561824799997	6442	3334	2	0	\N
28103	1637	70561844799997	6353	3287	3	0	\N
28104	1637	70561844799997	6442	3334	3	0	\N
28115	1637	74881934799997	6496	3367	4	0	\N
28118	1637	74881974799997	6496	3367	5	0	\N
28121	1637	76321974799997	6622	3424	2	0	\N
28122	1637	76321974799997	6645	3436	2	0	\N
28123	1637	76321974799997	6698	3462	4	0	\N
28125	1637	76321994799997	6622	3424	3	0	\N
28126	1637	76321994799997	6645	3436	3	0	\N
28127	1637	76322014799997	6698	3462	5	0	\N
28131	1637	77762034799997	6805	3523	1	0	\N
28132	1637	77762034799997	6900	3565	2	0	\N
28133	1637	77762034799997	6908	3569	2	0	\N
28135	1637	77762044799997	6805	3523	2	0	\N
28136	1637	77762054799997	6900	3565	3	0	\N
28137	1637	77762054799997	6908	3569	3	0	\N
28141	1637	79202094799997	6946	3585	3	0	\N
28142	1637	79202094799997	6967	3594	2	0	\N
28144	1637	79202114799997	6967	3594	3	0	\N
28146	1637	79202214799997	6946	3585	4	0	\N
28020	1637	51841402000000	5158	2677	1	0	0
28021	1637	51841412000000	5158	2677	2	0	0
28024	1637	52561412000000	5188	2696	2	0	0
28027	1637	52561432000000	5188	2696	3	0	0
28030	1637	53281432000000	5303	2755	1	0	0
28034	1637	54001442000000	5304	2756	1	0	0
28035	1637	54001452000000	5304	2756	2	0	0
28036	1637	54721452000000	5309	2760	1	0	0
28037	1637	54721462000000	5309	2760	2	0	0
28040	1637	55441462000000	5352	2778	1	0	0
28044	1637	56161472000000	5373	2794	0	0	0
28047	1637	56881472000000	5449	2836	1	0	0
28049	1637	56881473000000	5449	2836	2	0	0
28052	1637	57601473000000	5528	2875	0	0	0
28057	1637	59041473000000	5629	2924	0	0	0
28058	1637	59761473000000	5657	2934	0	0	0
28059	1637	60481473000000	5675	2942	0	0	0
28060	1637	61201473000000	5717	2964	2	0	0
28061	1637	61201673000000	5717	2964	3	0	0
28065	1637	61921683799997	5774	2994	4	1	0
28066	1637	62641683799997	5853	3037	2	0	0
28067	1637	62641703799997	5853	3037	3	0	0
28068	1637	63361703799997	5879	3048	2	0	0
28069	1637	63361723799997	5879	3048	3	0	0
28071	1637	64081733799997	5895	3055	2	0	0
28073	1637	64801733799997	5901	3059	1	0	0
28075	1637	64801743799997	5901	3059	2	0	0
28077	1637	65521743799997	5953	3085	1	0	0
28080	1637	66241753799997	6052	3144	1	0	0
28081	1637	66241763799997	6052	3144	2	0	0
28083	1637	66961763799997	6054	3145	1	0	0
28084	1637	66961773799997	6054	3145	2	0	0
28085	1637	67681773799997	6162	3191	1	0	0
28088	1637	68401783799997	6201	3209	0	0	0
28091	1637	69121783799997	6252	3235	4	0	0
28093	1637	69121814799997	6252	3235	5	0	0
28096	1637	69841814799997	6312	3268	1	0	0
28098	1637	69841824799997	6312	3268	2	0	0
28105	1637	70561844799997	6447	3337	3	0	0
28106	1637	71281844799997	6452	3341	3	0	0
28107	1637	71281874799997	6452	3341	4	0	0
28108	1637	72001874799997	6454	3342	2	0	0
28110	1637	72721894799997	6455	3343	0	0	0
28111	1637	73441894799997	6473	3355	2	0	0
28112	1637	73441914799997	6473	3355	3	0	0
28113	1637	74161914799997	6482	3359	2	0	0
28114	1637	74161934799997	6482	3359	3	0	0
28117	1637	74881954799997	6501	3369	3	0	0
28119	1637	75601954799997	6617	3421	2	0	0
28120	1637	75601974799997	6617	3421	3	0	0
28124	1637	76321974799997	6716	3474	4	0	0
28128	1637	76322014799997	6716	3474	5	0	0
28130	1637	77042034799997	6797	3519	3	0	0
28134	1637	77762034799997	6922	3573	4	0	0
28138	1637	77762074799997	6922	3573	5	0	0
28139	1637	78482074799997	6938	3580	2	0	0
28143	1637	79202094799997	6978	3600	2	0	0
28145	1637	79202114799997	6978	3600	3	0	0
28147	1637	79922114799997	6999	3613	2	0	0
28148	1637	79922134799997	6999	3613	3	0	0
28149	1637	80642134799997	7053	3640	2	0	0
28151	1637	81362154799997	7127	3683	2	0	0
28152	1637	81362174799997	7127	3683	3	0	0
28153	1637	82082174799997	7135	3687	3	0	\N
28155	1637	82082204799997	7135	3687	4	0	\N
28161	1637	84242224799997	7288	3767	2	0	\N
28164	1637	84242244799997	7288	3767	3	0	\N
28171	1637	87122264799997	7411	3831	1	0	\N
28173	1637	87122274799997	7411	3831	2	0	\N
28177	1637	88562294799997	7458	3857	1	0	\N
28179	1637	88562304799997	7458	3857	2	0	\N
28189	1637	92162354799997	7615	3940	2	0	\N
28192	1637	92162374799997	7615	3940	3	0	\N
28193	1637	92882364799997	7639	3953	1	0	\N
28194	1637	92882364799997	7679	3977	1	0	\N
28195	1637	92882364799997	7684	3979	3	0	\N
28197	1637	92882374799997	7639	3953	2	0	\N
28198	1637	92882374799997	7679	3977	2	0	\N
28200	1637	92882394799997	7684	3979	4	0	\N
28215	1637	98642454799997	7941	4115	1	0	\N
28216	1637	98642454799997	7957	4124	1	0	\N
28218	1637	98642464799997	7941	4115	2	0	\N
28219	1637	98642464799997	7957	4124	2	0	\N
28225	1637	100802494799997	8143	4222	1	0	\N
28226	1637	100802494799997	8183	4240	4	0	\N
28228	1637	100802504799997	8143	4222	2	0	\N
28230	1637	100802534799997	8183	4240	5	0	\N
28231	1637	101522504799997	8263	4278	6	0	\N
28234	1637	101522654799997	8263	4278	7	0	\N
28241	1637	104402565799997	8340	4319	1	0	\N
28243	1637	104402575799997	8340	4319	2	0	\N
28245	1637	105122586799997	8430	4369	0	0	\N
28248	1637	105842596799997	8471	4388	1	0	\N
28249	1637	105842596799997	8508	4407	1	0	\N
28250	1637	105842596799997	8535	4422	1	0	\N
28252	1637	105842606799997	8471	4388	2	0	\N
28253	1637	105842606799997	8508	4407	2	0	\N
28254	1637	105842606799997	8535	4422	2	0	\N
28258	1637	107282646799997	8745	4537	2	0	\N
28259	1637	107282646799997	8759	4545	2	0	\N
28261	1637	107282666799997	8745	4537	3	0	\N
28262	1637	107282666799997	8759	4545	3	0	\N
28266	1637	108722684819997	9092	4713	11	0	\N
28269	1637	108722776819997	9092	4713	12	0	\N
28270	1637	109442704819997	9113	4722	4	0	\N
28271	1637	109442704819997	9138	4734	2	0	\N
28273	1637	109442724819997	9138	4734	3	0	\N
28275	1637	109442744819997	9113	4722	5	0	\N
28286	1637	113762854819997	9512	4932	3	0	\N
28288	1637	113762884819997	9512	4932	4	0	\N
28157	1637	82802204799997	7181	3709	1	0	0
28158	1637	82802214799997	7181	3709	2	0	0
28159	1637	83522214799997	7183	3711	1	0	0
28160	1637	83522224799997	7183	3711	2	0	0
28162	1637	84242224799997	7332	3789	1	0	0
28165	1637	84962234799997	7381	3811	1	0	0
28166	1637	84962244799997	7381	3811	2	0	0
28167	1637	85682244799997	7404	3826	1	0	0
28168	1637	85682254799997	7404	3826	2	0	0
28169	1637	86402254799997	7407	3828	1	0	0
28172	1637	87122264799997	7436	3843	1	0	0
28174	1637	87122274799997	7436	3843	2	0	0
28175	1637	87842274799997	7452	3854	2	0	0
28176	1637	87842294799997	7452	3854	3	0	0
28180	1637	88562304799997	7463	3860	2	0	0
28181	1637	89282304799997	7503	3883	2	0	0
28182	1637	89282324799997	7503	3883	3	0	0
28183	1637	90002324799997	7508	3887	1	0	0
28184	1637	90002334799997	7508	3887	2	0	0
28186	1637	90722344799997	7558	3914	2	0	0
28187	1637	91442344799997	7584	3923	1	0	0
28188	1637	91442354799997	7584	3923	2	0	0
28190	1637	92162354799997	7633	3950	1	0	0
28191	1637	92162364799997	7633	3950	2	0	0
28199	1637	92882384799997	7709	3993	3	0	0
28201	1637	93602384799997	7737	4009	1	0	0
28202	1637	93602394799997	7737	4009	2	0	0
28203	1637	94322394799997	7749	4017	1	0	0
28205	1637	95042404799997	7813	4050	1	0	0
28206	1637	95042414799997	7813	4050	2	0	0
28207	1637	95762414799997	7839	4063	1	0	0
28208	1637	95762424799997	7839	4063	2	0	0
28209	1637	96482424799997	7850	4069	1	0	0
28211	1637	97202434799997	7909	4097	1	0	0
28212	1637	97202444799997	7909	4097	2	0	0
28213	1637	97922444799997	7915	4102	1	0	0
28214	1637	97922454799997	7915	4102	2	0	0
28217	1637	98642454799997	8000	4147	1	0	0
28221	1637	99362464799997	8026	4161	2	0	0
28222	1637	99362484799997	8026	4161	3	0	0
28223	1637	100082484799997	8109	4204	1	0	0
28224	1637	100082494799997	8109	4204	2	0	0
28229	1637	100802504799997	8227	4264	2	0	0
28232	1637	101522504799997	8280	4288	2	0	0
28233	1637	101522515799997	8280	4288	3	0	0
28235	1637	102242515799997	8286	4291	2	0	0
28236	1637	102242535799997	8286	4291	3	0	0
28238	1637	102962555799997	8325	4309	3	0	0
28239	1637	103682555799997	8330	4312	1	0	0
28240	1637	103682565799997	8330	4312	2	0	0
28242	1637	104402565799997	8352	4325	3	0	0
28244	1637	104402586799997	8352	4325	4	0	0
28247	1637	105122596799997	8462	4383	2	0	0
28251	1637	105842596799997	8537	4423	4	0	0
28255	1637	105842636799997	8537	4423	5	0	0
28256	1637	106562636799997	8698	4509	1	0	0
28260	1637	107282646799997	8888	4606	2	0	0
28263	1637	107282666799997	8888	4606	3	0	0
28264	1637	108002665809997	8992	4662	2	0	0
28265	1637	108002684819997	8992	4662	3	1	0
28267	1637	108722684819997	9111	4721	2	0	0
28272	1637	109442704819997	9210	4777	3	0	0
28274	1637	109442734819997	9210	4777	4	0	0
28276	1637	110162734819997	9344	4848	2	0	0
28277	1637	110162754819997	9344	4848	3	0	0
28278	1637	110882754819997	9441	4896	4	0	0
28280	1637	111602794819997	9459	4904	2	0	0
28281	1637	111602814819997	9459	4904	3	0	0
28282	1637	112322814819997	9487	4920	2	0	0
28283	1637	112322834819997	9487	4920	3	0	0
28285	1637	113042854819997	9508	4930	3	0	0
28287	1637	113762854819997	9523	4937	6	0	0
28290	1637	114483004819997	9538	4945	2	0	\N
28291	1637	114483004819997	9598	4979	4	0	\N
28292	1637	114483004819997	9601	4980	3	0	\N
28295	1637	114483034819997	9601	4980	4	0	\N
28296	1637	114483044819997	9598	4979	5	0	\N
28297	1637	114483114819997	9538	4945	3	0	\N
28300	1637	115923034819997	9676	5021	3	0	\N
28301	1637	115923034819997	9686	5024	2	0	\N
28302	1637	115923034819997	9716	5037	4	0	\N
28304	1637	115923054819997	9686	5024	3	0	\N
28306	1637	115923064819997	9676	5021	4	0	\N
28307	1637	115923074819997	9716	5037	5	0	\N
28308	1637	116643054819997	9769	5061	11	0	\N
28310	1637	116643119819997	9769	5061	12	0	\N
28314	1637	118083664819997	9894	5127	5	0	\N
28317	1637	118083714819997	9894	5127	6	0	\N
28319	1637	119523584819997	9964	5167	13	0	\N
28322	1637	119523705819997	9964	5167	14	0	\N
28323	1637	120243604819997	10348	5356	2	0	\N
28324	1637	120243604819997	10435	5397	2	0	\N
28326	1637	120243624819997	10348	5356	3	0	\N
28327	1637	120243624819997	10435	5397	3	0	\N
28329	1637	120243705819997	9985	5168	28	0	\N
28330	1637	120243967819997	9985	5168	29	0	\N
28331	1637	120963624819997	10576	5462	2	0	\N
28333	1637	120963644819997	10576	5462	3	0	\N
28336	1637	120963967819997	10019	5169	53	0	\N
28337	1637	120964461819997	10019	5169	54	0	\N
28338	1637	121683644819997	10620	5485	4	0	\N
28340	1637	121683684819997	10620	5485	5	0	\N
28342	1637	121684461819997	10070	5170	10	0	\N
28343	1637	121684561819997	10070	5170	11	0	\N
28344	1637	122403705819997	10657	5504	4	0	\N
28347	1637	122403745819997	10657	5504	5	0	\N
28354	1637	124563817819997	10743	5545	2	0	\N
28356	1637	125283817819997	10743	5545	4	0	\N
28358	1637	125283827819997	10743	5545	5	0	\N
28367	1637	128883887819997	11092	5708	3	0	\N
28369	1637	128883917819997	11092	5708	4	0	\N
28377	1637	131764088819997	11306	5807	1	0	\N
28379	1637	131764089819997	11306	5807	2	0	\N
28381	1637	132484089819997	11316	5811	1	0	\N
28382	1637	132484089819997	11357	5833	1	0	\N
28384	1637	132484090819997	11316	5811	2	0	\N
28385	1637	132484099819997	11357	5833	2	0	\N
28389	1637	133924111819997	11475	5898	2	0	\N
28391	1637	133924122819997	11475	5898	3	0	\N
28395	1637	135364123819997	11602	5968	0	0	\N
28402	1637	137524129819997	11806	6067	1	0	\N
28404	1637	137524130819997	11806	6067	2	0	\N
28406	1637	138244130819997	11834	6082	5	0	\N
28407	1637	138244130819997	11912	6128	1	0	\N
28409	1637	138244131819997	11912	6128	2	0	\N
28411	1637	138244135819997	11834	6082	6	0	\N
28412	1637	138964131819997	11973	6162	1	0	\N
28413	1637	138964131819997	11980	6166	1	0	\N
28415	1637	138964132819997	11973	6162	2	0	\N
28416	1637	138964132819997	11980	6166	2	0	\N
28422	1637	141124138819997	12100	6231	2	0	\N
28294	1637	114483024819997	9613	4987	3	0	0
28298	1637	115203024819997	9618	4989	1	0	0
28299	1637	115203034819997	9618	4989	2	0	0
28303	1637	115923034819997	9759	5056	2	0	0
28305	1637	115923054819997	9759	5056	3	0	0
28311	1637	116643644819997	9799	5081	12	0	0
28312	1637	117363644819997	9845	5103	2	0	0
28313	1637	117363664819997	9845	5103	3	0	0
28315	1637	118083664819997	9916	5145	2	0	0
28316	1637	118083684819997	9916	5145	3	0	0
28320	1637	119523584819997	10331	5346	2	0	0
28321	1637	119523604819997	10331	5346	3	0	0
28325	1637	120243604819997	10542	5446	2	0	0
28328	1637	120243624819997	10542	5446	3	0	0
28334	1637	120963644819997	10612	5481	3	0	0
28335	1637	120963674819997	10637	5494	3	0	0
28339	1637	121683674819997	10637	5494	8	0	0
28341	1637	121683705819997	10637	5494	9	0	0
28345	1637	122403705819997	10684	5516	2	0	0
28348	1637	123123725819997	10685	5517	3	0	0
28349	1637	123123747819997	10685	5517	4	0	0
28350	1637	123843747819997	10720	5533	2	0	0
28351	1637	123843767819997	10720	5533	3	0	0
28352	1637	124563767819997	10733	5539	3	0	0
28355	1637	125283797819997	10900	5620	2	0	0
28357	1637	125283817819997	10900	5620	3	0	0
28359	1637	126003817819997	10946	5641	2	0	0
28360	1637	126003837819997	10946	5641	3	0	0
28362	1637	126723857819997	10998	5666	3	0	0
28363	1637	127443857819997	11002	5667	1	0	0
28364	1637	127443867819997	11002	5667	2	0	0
28365	1637	128163867819997	11020	5673	2	0	0
28366	1637	128163887819997	11020	5673	3	0	0
28370	1637	128883927819997	11130	5721	5	0	0
28371	1637	129603927819997	11191	5746	2	0	0
28372	1637	129603947819997	11191	5746	3	0	0
28373	1637	130323947819997	11210	5757	3	0	0
28374	1637	130324067819997	11210	5757	4	0	0
28376	1637	131044088819997	11240	5774	4	0	0
28378	1637	131764088819997	11308	5808	1	0	0
28380	1637	131764089819997	11308	5808	2	0	0
28383	1637	132484089819997	11370	5840	2	0	0
28387	1637	133204100819997	11392	5851	2	0	0
28388	1637	133204111819997	11392	5851	3	0	0
28390	1637	133924111819997	11481	5901	2	0	0
28392	1637	133924122819997	11481	5901	3	0	0
28393	1637	134644122819997	11568	5946	1	0	0
28396	1637	135364123819997	11609	5972	3	0	0
28397	1637	135364126819997	11609	5972	4	0	0
28398	1637	136084126819997	11702	6017	1	0	0
28399	1637	136084127819997	11702	6017	2	0	0
28400	1637	136804127819997	11711	6022	2	0	0
28403	1637	137524129819997	11827	6079	1	0	0
28405	1637	137524130819997	11827	6079	2	0	0
28408	1637	138244130819997	11923	6135	1	0	0
28410	1637	138244131819997	11923	6135	2	0	0
28417	1637	138964132819997	11993	6173	2	0	0
28418	1637	139684132819997	12036	6196	2	0	0
28419	1637	139684134819997	12036	6196	3	0	0
28420	1637	140404134819997	12053	6204	4	0	0
28421	1637	140404138819997	12053	6204	5	0	0
28424	1637	141124139819997	12122	6244	2	0	0
28425	1637	141124140819997	12100	6231	3	0	\N
28432	1637	144004143819997	12327	6353	4	0	\N
28434	1637	144004147819997	12327	6353	5	0	\N
28435	1637	144724143819997	12335	6358	0	0	\N
28436	1637	144724143819997	12362	6374	1	0	\N
28438	1637	144724144819997	12362	6374	2	0	\N
28443	1637	146884145819997	12468	6424	0	0	\N
28452	1637	149764179819997	12642	6521	2	0	\N
28454	1637	149764190819997	12642	6521	3	0	\N
28456	1637	150484190819997	12707	6553	2	0	\N
28458	1637	150484201819997	12707	6553	3	0	\N
28466	1637	153364300819997	12854	6628	2	0	\N
28468	1637	153364311819997	12854	6628	3	0	\N
28470	1637	154084311819997	12873	6638	2	0	\N
28472	1637	154084322819997	12873	6638	3	0	\N
28474	1637	154804322819997	12924	6661	2	0	\N
28476	1637	154804333819997	12924	6661	3	0	\N
28478	1637	155524333819997	12978	6691	3	0	\N
28479	1637	155524333819997	13006	6703	5	0	\N
28481	1637	155524354819997	12978	6691	4	0	\N
28482	1637	155524365819997	13006	6703	6	0	\N
28483	1637	156244333819997	13052	6728	5	0	\N
28485	1637	156244365819997	13052	6728	6	0	\N
28506	1637	163444614819997	13463	6935	3	0	\N
28507	1637	163444614819997	13532	6967	3	0	\N
28508	1637	163444614819997	13595	6991	4	0	\N
28510	1637	163444626819997	13463	6935	4	0	\N
28511	1637	163444626819997	13532	6967	4	0	\N
28512	1637	163444627819997	13595	6991	5	0	\N
28516	1637	164884649819997	13747	7063	1	0	\N
28518	1637	164884659819997	13747	7063	2	0	\N
28526	1637	167764682819997	14076	7202	0	0	\N
28527	1637	167764682819997	14128	7219	3	0	\N
28530	1637	167764694819997	14128	7219	4	0	\N
28533	1637	168484712819997	14221	7259	1	0	\N
28534	1637	169204702819997	14184	7238	2	0	\N
28536	1637	169204712819997	14221	7259	5	0	\N
28537	1637	169204722819997	14184	7238	3	0	\N
28540	1637	169924726819997	14243	7270	2	0	\N
28541	1637	169924726819997	14281	7290	8	0	\N
28542	1637	169924726819997	14396	7346	0	0	\N
28543	1637	169924726819997	14420	7356	1	0	\N
28544	1637	169924728819997	14243	7270	3	0	\N
28545	1637	169924736819997	14420	7356	2	0	\N
28547	1637	169924752819997	14281	7290	9	0	\N
28550	1637	171364750819988	14590	7439	3	0	\N
28552	1637	171364762819988	14590	7439	4	0	\N
28556	1637	172804786819988	14663	7470	3	0	\N
28559	1637	172804798819988	14663	7470	4	0	\N
28560	1637	173524797819988	14787	7530	2	0	\N
28428	1637	142564141819997	12265	6315	1	0	0
28429	1637	142564142819997	12265	6315	2	0	0
28430	1637	143284142819997	12268	6316	1	0	0
28431	1637	143284143819997	12268	6316	2	0	0
28433	1637	144004143819997	12330	6354	0	0	0
28439	1637	144724144819997	12374	6382	2	0	0
28440	1637	145444144819997	12386	6389	1	0	0
28441	1637	145444145819997	12386	6389	2	0	0
28442	1637	146164145819997	12447	6415	0	0	0
28444	1637	146884145819997	12490	6437	1	0	0
28446	1637	147604146819997	12497	6439	2	0	0
28447	1637	147604157819997	12497	6439	3	0	0
28448	1637	148324157819997	12517	6451	2	0	0
28449	1637	148324168819997	12517	6451	3	0	0
28451	1637	149044179819997	12609	6504	3	0	0
28453	1637	149764179819997	12678	6539	2	0	0
28455	1637	149764190819997	12678	6539	3	0	0
28457	1637	150484190819997	12736	6567	6	0	0
28459	1637	150484214819997	12736	6567	7	0	0
28461	1637	151204279819997	12755	6575	12	0	0
28462	1637	151924279819997	12798	6599	2	0	0
28463	1637	151924290819997	12798	6599	3	0	0
28464	1637	152644290819997	12824	6615	1	0	0
28465	1637	152644300819997	12824	6615	2	0	0
28469	1637	153364311819997	12855	6629	3	0	0
28471	1637	154084311819997	12919	6658	2	0	0
28473	1637	154084322819997	12919	6658	3	0	0
28475	1637	154804322819997	12969	6688	2	0	0
28480	1637	155524333819997	13025	6714	0	0	0
28484	1637	156244333819997	13060	6732	16	0	0
28486	1637	156244457819997	13060	6732	17	0	0
28487	1637	156964457819997	13140	6772	4	0	0
28488	1637	156964470819997	13140	6772	5	0	0
28490	1637	157684492819997	13260	6831	6	0	0
28491	1637	157684493819997	13260	6831	7	0	0
28492	1637	158404493819997	13276	6837	3	0	0
28493	1637	158404505819997	13276	6837	4	0	0
28494	1637	159124505819997	13279	6840	9	0	0
28496	1637	159844541819997	13294	6848	6	0	0
28497	1637	159844565819997	13294	6848	7	0	0
28498	1637	160564565819997	13377	6893	4	0	0
28499	1637	160564578819997	13377	6893	5	0	0
28501	1637	161284590819997	13386	6899	4	0	0
28502	1637	162004590819997	13388	6900	3	0	0
28503	1637	162004602819997	13388	6900	4	0	0
28504	1637	162724602819997	13418	6913	3	0	0
28505	1637	162724614819997	13418	6913	4	0	0
28513	1637	163444627819997	13602	6993	5	0	0
28514	1637	164164627819997	13693	7035	4	0	0
28515	1637	164164649819997	13693	7035	5	0	0
28517	1637	164884649819997	13892	7128	1	0	0
28519	1637	164884659819997	13892	7128	2	0	0
28521	1637	165604662819997	13953	7150	4	0	0
28522	1637	166324662819997	14003	7175	1	0	0
28523	1637	166324672819997	14003	7175	2	0	0
28524	1637	167044672819997	14028	7187	1	0	0
28528	1637	167764682819997	14152	7224	1	0	0
28529	1637	167764692819997	14152	7224	2	0	0
28531	1637	168484692819997	14169	7233	1	0	0
28532	1637	168484702819997	14169	7233	2	0	0
28535	1637	169204702819997	14223	7261	6	0	0
28539	1637	169204749819997	14507	7401	5	0	0
28546	1637	169924749819988	14507	7401	6	0	0
28548	1637	170644749819988	14584	7436	1	0	0
28549	1637	170644750819988	14584	7436	2	0	0
28551	1637	171364750819988	14605	7446	3	0	0
28554	1637	172084762819988	14637	7460	6	0	0
28555	1637	172084786819988	14637	7460	7	0	0
28557	1637	172804786819988	14746	7506	2	0	0
28558	1637	172804797819988	14746	7506	3	0	0
28562	1637	173524808819988	14787	7530	3	0	\N
28566	1637	174964829819988	14835	7560	2	0	\N
28567	1637	174964829819988	14840	7563	8	0	\N
28569	1637	174964840819988	14835	7560	3	0	\N
28571	1637	174964873819988	14840	7563	9	0	\N
28572	1637	175684842819988	14918	7601	3	0	\N
28573	1637	175684842819988	14941	7610	2	0	\N
28575	1637	175684853819988	14941	7610	3	0	\N
28576	1637	175684854819988	14918	7601	4	0	\N
28584	1637	178564886819988	15324	7810	3	0	\N
28586	1637	178564898819988	15324	7810	4	0	\N
28608	1637	186485150819988	15898	8083	3	0	\N
28610	1637	186485162819988	15898	8083	4	0	\N
28612	1637	187205174819988	15908	8088	2	0	\N
28614	1637	187205185819988	15908	8088	3	0	\N
28620	1637	189365222819988	15961	8113	3	0	\N
28622	1637	189365234819988	15961	8113	4	0	\N
28624	1637	190085234819988	16074	8172	7	0	\N
28625	1637	190085234819988	16108	8187	3	0	\N
28628	1637	190085246819988	16108	8187	4	0	\N
28629	1637	190085259819988	16074	8172	8	0	\N
28630	1637	190805245819988	16151	8210	4	0	\N
28631	1637	190805245819988	16156	8212	3	0	\N
28632	1637	190805245819988	16219	8242	4	0	\N
28634	1637	190805257819988	16156	8212	4	0	\N
28636	1637	190805258819988	16151	8210	5	0	\N
28637	1637	190805258819988	16219	8242	5	0	\N
28644	1637	193685306819988	16425	8353	6	0	\N
28647	1637	193685330819988	16425	8353	7	0	\N
28650	1637	195125355819988	16460	8372	4	0	\N
28652	1637	195125368819988	16460	8372	5	0	\N
28658	1637	197285429819988	16809	8532	0	0	\N
28661	1637	198005441819988	17017	8621	3	0	\N
28663	1637	198005453819988	17017	8621	4	0	\N
28671	1637	200885503819988	17090	8659	3	0	\N
28672	1637	200885503819988	17104	8666	3	0	\N
28675	1637	200885515819988	17090	8659	4	0	\N
28676	1637	200885515819988	17104	8666	4	0	\N
28677	1637	201605514819988	17113	8671	2	0	\N
28679	1637	201605525819988	17113	8671	3	0	\N
28683	1637	203045538819988	17285	8754	6	0	\N
28686	1637	203045562819988	17285	8754	7	0	\N
28691	1637	205205573819988	17445	8835	6	0	\N
28692	1637	205205573819988	17449	8836	2	0	\N
28693	1637	205205573819988	17521	8871	2	0	\N
28694	1637	205205573819988	17530	8876	5	0	\N
28696	1637	205205584819988	17449	8836	3	0	\N
28564	1637	174244818819988	14816	7550	2	0	0
28565	1637	174244829819988	14816	7550	3	0	0
28568	1637	174964829819988	14897	7590	4	0	0
28570	1637	174964842819988	14897	7590	5	0	0
28574	1637	175684842819988	14997	7640	3	0	0
28578	1637	176404854819988	15121	7707	2	0	0
28579	1637	176404865819988	15121	7707	3	0	0
28580	1637	177124865819988	15188	7738	1	0	0
28581	1637	177124875819988	15188	7738	2	0	0
28582	1637	177844875819988	15259	7773	2	0	0
28585	1637	178564886819988	15329	7813	7	0	0
28587	1637	178564920819988	15329	7813	8	0	0
28588	1637	179284920819988	15358	7826	2	0	0
28589	1637	179284931819988	15358	7826	3	0	0
28591	1637	180004942819988	15425	7857	3	0	0
28592	1637	180724942819988	15500	7888	3	0	0
28593	1637	180724954819988	15500	7888	4	0	0
28594	1637	181444954819988	15659	7969	3	0	0
28595	1637	181444966819988	15659	7969	4	0	0
28597	1637	182164990819988	15662	7972	7	0	0
28598	1637	182884990819988	15705	7986	6	0	0
28599	1637	182885005819988	15705	7986	7	0	0
28600	1637	183605005819988	15779	8026	3	0	0
28601	1637	183605017819988	15779	8026	4	0	0
28603	1637	184325049819988	15830	8053	6	0	0
28604	1637	185045049819988	15836	8057	17	0	0
28605	1637	185045138819988	15836	8057	18	0	0
28606	1637	185765138819988	15868	8070	3	0	0
28609	1637	186485150819988	15903	8086	6	0	0
28611	1637	186485174819988	15903	8086	7	0	0
28613	1637	187205174819988	15919	8093	6	0	0
28615	1637	187205198819988	15919	8093	7	0	0
28616	1637	187925198819988	15945	8106	3	0	0
28618	1637	188645210819988	15951	8109	3	0	0
28619	1637	188645222819988	15951	8109	4	0	0
28621	1637	189365222819988	16030	8151	3	0	0
28623	1637	189365234819988	16030	8151	4	0	0
28626	1637	190085234819988	16133	8202	2	0	0
28633	1637	190805245819988	16269	8269	3	0	0
28635	1637	190805257819988	16269	8269	4	0	0
28638	1637	191525257819988	16324	8296	3	0	0
28639	1637	191525269819988	16324	8296	4	0	0
28641	1637	192245281819988	16325	8297	4	0	0
28642	1637	192965281819988	16388	8336	7	0	0
28643	1637	192965306819988	16388	8336	8	0	0
28645	1637	193685306819988	16442	8361	3	0	0
28646	1637	193685318819988	16442	8361	4	0	0
28649	1637	194405355819988	16458	8371	11	0	0
28651	1637	195125355819988	16532	8408	7	0	0
28653	1637	195125380819988	16532	8408	8	0	0
28654	1637	195845380819988	16553	8412	1	0	0
28655	1637	195845381819988	16553	8412	2	0	0
28657	1637	196565429819988	16644	8457	13	0	0
28659	1637	197285429819988	16933	8583	3	0	0
28660	1637	197285441819988	16933	8583	4	0	0
28662	1637	198005441819988	17022	8622	7	0	0
28665	1637	198725466819988	17037	8627	3	0	0
28666	1637	198725478819988	17037	8627	4	0	0
28667	1637	199445478819988	17046	8633	4	0	0
28668	1637	199445491819988	17046	8633	5	0	0
28669	1637	200165491819988	17078	8650	3	0	0
28673	1637	200885503819988	17106	8667	2	0	0
28674	1637	200885514819988	17106	8667	3	0	0
28678	1637	201605514819988	17200	8717	3	0	0
28680	1637	201605526819988	17200	8717	4	0	0
28681	1637	202325526819988	17215	8722	3	0	0
28684	1637	203045538819988	17360	8794	3	0	0
28685	1637	203045550819988	17360	8794	4	0	0
28687	1637	203765550819988	17406	8817	3	0	0
28688	1637	203765562819988	17406	8817	4	0	0
28690	1637	204485573819988	17444	8834	3	0	0
28695	1637	205205573819988	17728	8960	3	0	0
28697	1637	205205584819988	17521	8871	3	0	\N
28699	1637	205205587819988	17530	8876	6	0	\N
28700	1637	205205597819988	17445	8835	7	0	\N
28707	1637	208085644819988	17972	9064	7	0	\N
28710	1637	208085669819988	17972	9064	8	0	\N
28711	1637	208805666819988	18010	9084	4	0	\N
28713	1637	208805679819988	18010	9084	5	0	\N
28717	1637	210245693819988	18031	9096	3	0	\N
28720	1637	210245705819988	18031	9096	4	0	\N
28721	1637	210965704819988	18049	9104	2	0	\N
28723	1637	210965715819988	18049	9104	3	0	\N
28729	1637	213124760819988	18251	9193	2	0	\N
28730	1637	213124760819988	18364	9254	2	0	\N
28731	1637	213124760819988	18466	9304	2	0	\N
28732	1637	213124760819988	18496	9315	4	0	\N
28734	1637	213124771819988	18251	9193	3	0	\N
28735	1637	213124771819988	18364	9254	3	0	\N
28736	1637	213124771819988	18466	9304	3	0	\N
28737	1637	213124782819988	18496	9315	5	0	\N
28745	1637	216005008819988	18600	9371	2	0	\N
28747	1637	216005019819988	18600	9371	3	0	\N
28753	1637	218165063819988	18793	9470	6	0	\N
28756	1637	218165136819988	18793	9470	7	0	\N
28757	1637	218885095819988	18829	9488	1	0	\N
28759	1637	218885105819988	18829	9488	2	0	\N
28761	1637	219605105819988	18865	9512	2	0	\N
28764	1637	219605125819988	18865	9512	3	0	\N
28765	1637	220325115819988	18956	9562	1	0	\N
28766	1637	220325115819988	18985	9574	1	0	\N
28767	1637	220325115819988	19033	9597	1	0	\N
28769	1637	220325125819988	18956	9562	2	0	\N
28770	1637	220325125819988	18985	9574	2	0	\N
28771	1637	220325125819988	19033	9597	2	0	\N
28774	1637	221765138819988	19241	9700	3	0	\N
28776	1637	221765150819988	19241	9700	4	0	\N
28784	1637	224645257819988	19342	9752	10	0	\N
28787	1637	224645285819988	19342	9752	11	0	\N
28788	1637	225365280819988	19398	9776	4	0	\N
28789	1637	225365280819988	19423	9788	7	0	\N
28791	1637	225365293819988	19398	9776	5	0	\N
28792	1637	225365305819988	19423	9788	8	0	\N
28796	1637	226805341819988	19565	9856	3	0	\N
28798	1637	226805353819988	19565	9856	4	0	\N
28804	1637	228965397819988	19729	9932	2	0	\N
28805	1637	228965397819988	19753	9944	3	0	\N
28807	1637	228965408819988	19729	9932	3	0	\N
28809	1637	228965409819988	19753	9944	4	0	\N
28810	1637	229685408819988	19817	9982	2	0	\N
28812	1637	229685419819988	19817	9982	3	0	\N
28814	1637	230405420819988	19895	10021	4	0	\N
28816	1637	230405433819988	19895	10021	5	0	\N
28818	1637	231125445819988	19910	10026	4	0	\N
28821	1637	231125557819988	19910	10026	5	0	\N
28822	1637	231845457819988	19934	10039	4	0	\N
28824	1637	231845470819988	19934	10039	5	0	\N
28828	1637	233285507819988	20015	10075	3	0	\N
28830	1637	233285519819988	20015	10075	4	0	\N
28702	1637	205925620819988	17733	8963	9	0	0
28703	1637	206645620819988	17798	8991	3	0	0
28704	1637	206645632819988	17798	8991	4	0	0
28705	1637	207365632819988	17818	8998	3	0	0
28706	1637	207365644819988	17818	8998	4	0	0
28709	1637	208085666819988	17977	9066	5	0	0
28712	1637	208805666819988	18011	9085	5	0	0
28714	1637	208805680819988	18011	9085	6	0	0
28715	1637	209525680819988	18021	9090	4	0	0
28716	1637	209525693819988	18021	9090	5	0	0
28719	1637	210245704819988	18032	9097	3	0	0
28722	1637	210965704819988	18098	9127	2	0	0
28724	1637	210965715819988	18098	9127	3	0	0
28725	1637	210965726819988	18102	9131	2	0	0
28727	1637	212404726819988	18127	9141	7	0	0
28728	1637	212404760819988	18127	9141	8	0	0
28733	1637	213124760819988	18523	9330	4	0	0
28738	1637	213124872819988	18523	9330	5	0	0
28739	1637	213844872819988	18528	9333	3	0	0
28741	1637	214564884819988	18542	9342	4	0	0
28742	1637	214564897819988	18542	9342	5	0	0
28743	1637	215284897819988	18569	9358	3	0	0
28744	1637	215285008819988	18569	9358	4	0	0
28746	1637	216005008819988	18675	9408	3	0	0
28749	1637	216725029819988	18708	9424	5	0	0
28750	1637	216725052819988	18708	9424	6	0	0
28751	1637	217445052819988	18787	9467	2	0	0
28752	1637	217445063819988	18787	9467	3	0	0
28755	1637	218165095819988	18814	9480	6	0	0
28758	1637	218885095819988	18859	9509	1	0	0
28760	1637	218885105819988	18859	9509	2	0	0
28762	1637	219605105819988	18898	9532	1	0	0
28763	1637	219605115819988	18898	9532	2	0	0
28772	1637	221045115819988	19179	9677	5	0	0
28773	1637	221045138819988	19179	9677	6	0	0
28775	1637	221765138819988	19265	9713	3	0	0
28777	1637	221765150819988	19265	9713	4	0	0
28778	1637	222485150819988	19289	9725	14	0	0
28780	1637	223205182819988	19310	9737	3	0	0
28781	1637	223205194819988	19310	9737	4	0	0
28782	1637	223925194819988	19324	9745	9	0	0
28783	1637	223925257819988	19324	9745	10	0	0
28786	1637	224645280819988	19391	9773	6	0	0
28790	1637	225365280819988	19495	9827	10	0	0
28793	1637	225365317819988	19495	9827	11	0	0
28794	1637	226085317819988	19507	9831	6	0	0
28795	1637	226085341819988	19507	9831	7	0	0
28799	1637	226805363819988	19577	9861	5	0	0
28800	1637	227525363819988	19603	9874	3	0	0
28801	1637	227525375819988	19603	9874	4	0	0
28802	1637	228245375819988	19727	9931	4	0	0
28803	1637	228245397819988	19727	9931	5	0	0
28808	1637	228965408819988	19760	9948	3	0	0
28811	1637	229685408819988	19832	9990	3	0	0
28813	1637	229685420819988	19832	9990	4	0	0
28815	1637	230405420819988	19901	10023	7	0	0
28819	1637	231125445819988	19926	10035	3	0	0
28820	1637	231125457819988	19926	10035	4	0	0
28823	1637	231845457819988	19947	10044	7	0	0
28825	1637	231845482819988	19947	10044	8	0	0
28826	1637	232565482819988	19968	10056	7	0	0
28829	1637	233285507819988	20035	10086	3	0	0
28831	1637	233285519819988	20035	10086	4	0	0
28832	1637	234005519819988	20040	10088	3	0	0
28838	1637	236165566819988	20133	10134	6	0	\N
28840	1637	236165608819988	20133	10134	7	0	\N
28846	1637	238325648819988	20352	10250	3	0	\N
28848	1637	238325660819988	20352	10250	4	0	\N
28860	1637	242645750819988	20669	10397	3	0	\N
28862	1637	242645762819988	20669	10397	4	0	\N
28866	1637	244085805819988	20785	10445	6	0	\N
28869	1637	244085847819988	20785	10445	7	0	\N
28870	1637	244805816819988	20833	10471	3	0	\N
28872	1637	244805837819988	20833	10471	4	0	\N
28890	1637	251285991819988	21142	10616	2	0	\N
28892	1637	251286002819988	21142	10616	3	0	\N
28894	1637	252006002819988	21212	10651	2	0	\N
28896	1637	252006013819988	21212	10651	3	0	\N
28900	1637	252726048819988	21364	10722	4	0	\N
28901	1637	253446026819988	21322	10704	3	0	\N
28902	1637	253446026819988	21327	10707	3	0	\N
28903	1637	253446026819988	21359	10721	19	0	\N
28905	1637	253446038819988	21322	10704	4	0	\N
28906	1637	253446038819988	21327	10707	4	0	\N
28908	1637	253446048819988	21364	10722	7	0	\N
28909	1637	253446050819988	21364	10722	8	0	\N
28910	1637	253446099819988	21359	10721	20	0	\N
28915	1637	255606073819988	21537	10802	3	0	\N
28917	1637	255606085819988	21537	10802	4	0	\N
28919	1637	256326085819988	21655	10847	9	0	\N
28920	1637	256326085819988	21714	10877	6	0	\N
28922	1637	256326109819988	21714	10877	7	0	\N
28923	1637	256326121819988	21655	10847	10	0	\N
28925	1637	257046133819988	21721	10881	3	0	\N
28926	1637	257046133819988	21739	10887	6	0	\N
28927	1637	257046133819988	21748	10890	3	0	\N
28929	1637	257046145819988	21721	10881	4	0	\N
28930	1637	257046145819988	21748	10890	4	0	\N
28932	1637	257046157819988	21739	10887	7	0	\N
28935	1637	258486182819988	21828	10925	2	0	\N
28937	1637	258486184819988	21828	10925	3	0	\N
28941	1637	259926206819988	21894	10955	3	0	\N
28943	1637	259926218819988	21894	10955	4	0	\N
28949	1637	262086255819988	21947	10979	3	0	\N
28950	1637	262086255819988	22064	11032	3	0	\N
28952	1637	262086267819988	21947	10979	4	0	\N
28953	1637	262086267819988	22064	11032	4	0	\N
28955	1637	262806279819988	22094	11046	3	0	\N
28957	1637	262806291819988	22094	11046	4	0	\N
28961	1637	264246314819988	22160	11085	5	0	\N
28962	1637	264246314819988	22162	11086	3	0	\N
28964	1637	264246314819988	22664	11088	0	0	\N
28965	1637	264246326819988	22162	11086	4	0	\N
28966	1637	264246328819988	22160	11085	6	0	\N
28835	1637	234725543819988	20077	10105	4	0	0
28836	1637	235445543819988	20079	10107	5	0	0
28837	1637	235445566819988	20079	10107	6	0	0
28839	1637	236165566819988	20136	10135	10	0	0
28841	1637	236165612819988	20136	10135	11	0	0
28843	1637	236885625819988	20331	10238	5	0	0
28844	1637	237605625819988	20343	10245	5	0	0
28845	1637	237605648819988	20343	10245	6	0	0
28847	1637	238325648819988	20364	10258	3	0	0
28849	1637	238325660819988	20364	10258	4	0	0
28851	1637	239045680819988	20436	10293	12	0	0
28852	1637	239765680819988	20466	10306	5	0	0
28853	1637	239765703819988	20466	10306	6	0	0
28854	1637	240485703819988	20491	10317	3	0	0
28856	1637	241205715819988	20604	10364	2	0	0
28857	1637	241205726819988	20604	10364	3	0	0
28858	1637	241925726819988	20641	10387	6	0	0
28859	1637	241925750819988	20641	10387	7	0	0
28861	1637	242645750819988	20688	10405	4	0	0
28864	1637	243365763819988	20750	10431	6	0	0
28865	1637	243365805819988	20750	10431	7	0	0
28867	1637	244085805819988	20793	10450	2	0	0
28868	1637	244085816819988	20793	10450	3	0	0
28871	1637	244805816819988	20876	10494	4	0	0
28874	1637	245525838819988	20923	10518	3	0	0
28875	1637	245525859819988	20923	10518	4	0	0
28876	1637	246245859819988	20944	10533	4	0	0
28877	1637	246245881819988	20944	10533	5	0	0
28879	1637	246965903819988	20962	10543	5	0	0
28880	1637	247685903819988	21051	10578	2	0	0
28881	1637	247685914819988	21051	10578	3	0	0
28882	1637	248405914819988	21058	10581	2	0	0
28883	1637	248405925819988	21058	10581	3	0	0
28885	1637	249125948819988	21059	10582	6	0	0
28886	1637	249845948819988	21070	10586	6	0	0
28887	1637	249845981819988	21070	10586	7	0	0
28888	1637	250565981819988	21101	10598	1	0	0
28889	1637	250565991819988	21101	10598	2	0	0
28893	1637	251286002819988	21174	10633	3	0	0
28895	1637	252006002819988	21222	10656	2	0	0
28897	1637	252006013819988	21222	10656	3	0	0
28898	1637	252726013819988	21293	10692	4	0	0
28904	1637	253446026819988	21380	10726	4	0	0
28907	1637	253446039819988	21380	10726	5	0	0
28911	1637	254166039819988	21431	10748	3	0	0
28912	1637	254166051819988	21431	10748	4	0	0
28913	1637	254166073819988	21489	10777	4	0	0
28916	1637	255606073819988	21616	10833	3	0	0
28918	1637	255606085819988	21616	10833	4	0	0
28921	1637	256326085819988	21717	10878	12	0	0
28924	1637	256326133819988	21717	10878	13	0	0
28928	1637	257046133819988	21763	10897	4	0	0
28933	1637	257766146819988	21775	10903	9	0	0
28934	1637	257766182819988	21775	10903	10	0	0
28936	1637	258486182819988	21840	10931	3	0	0
28938	1637	258486194819988	21840	10931	4	0	0
28940	1637	259206206819988	21884	10950	4	0	0
28942	1637	259926206819988	21897	10957	3	0	0
28944	1637	259926218819988	21897	10957	4	0	0
28945	1637	260646218819988	21933	10974	2	0	0
28946	1637	260646229819988	21933	10974	3	0	0
28948	1637	261366255819988	21943	10977	8	0	0
28951	1637	262086255819988	22077	11038	6	0	0
28954	1637	262086279819988	22077	11038	7	0	0
28956	1637	262806279819988	22102	11052	3	0	0
28958	1637	262806291819988	22102	11052	4	0	0
28960	1637	263526314819988	22121	11063	6	0	0
28963	1637	264246314819988	22179	11097	6	0	0
28967	1637	264246338819988	22179	11097	7	0	0
28968	1637	264966338819988	22180	11098	3	0	0
28970	1637	265686350819988	22195	11109	4	0	\N
28971	1637	265686350819988	22256	11138	3	0	\N
28973	1637	265686350819988	22665	11105	0	0	\N
28974	1637	265686350819988	22666	11121	0	0	\N
28975	1637	265686362819988	22256	11138	4	0	\N
28976	1637	265686363819988	22195	11109	5	0	\N
28983	1637	267846403819988	22447	11233	4	0	\N
28984	1637	267846403819988	22450	11234	3	0	\N
28985	1637	267846403819988	22472	11244	7	0	\N
28986	1637	267846403819988	22522	11266	13	0	\N
28987	1637	267846403819988	22558	11286	3	0	\N
28988	1637	267846403819988	22628	11317	6	0	\N
28989	1637	267846415819988	22450	11234	4	0	\N
28990	1637	267846415819988	22558	11286	4	0	\N
28992	1637	267846416819988	22447	11233	5	0	\N
28993	1637	267846427819988	22628	11317	7	0	\N
28994	1637	267846428819988	22472	11244	8	0	\N
28995	1637	267846506819988	22522	11266	14	0	\N
28998	1637	269286440819988	22658	11328	3	0	\N
28999	1637	269286440819988	22706	11352	2	0	\N
29001	1637	269286451819988	22706	11352	3	0	\N
29002	1637	269286452819988	22658	11328	4	0	\N
29008	1637	270726510819988	22760	11381	4	0	\N
29009	1637	271446488819988	22814	11409	3	0	\N
29010	1637	271446488819988	22827	11416	3	0	\N
29012	1637	271446500819988	22814	11409	4	0	\N
29013	1637	271446500819988	22827	11416	4	0	\N
29015	1637	271446510819988	22760	11381	7	0	\N
29016	1637	271446512119985	22760	11381	9	0	\N
29021	1637	273606538819988	22848	11426	3	0	\N
29023	1637	273606550819988	22848	11426	4	0	\N
29025	1637	274326550819988	22894	11444	3	0	\N
29027	1637	274326562819988	22894	11444	4	0	\N
29033	1637	276486587819988	22920	11457	4	0	\N
29036	1637	276486600819988	22920	11457	5	0	\N
29045	1637	280086709819988	23109	11541	4	0	\N
29046	1637	280086709819988	23137	11554	9	0	\N
29047	1637	280086709819988	23247	11600	4	0	\N
29050	1637	280086722819988	23109	11541	5	0	\N
29051	1637	280086731819988	23247	11600	5	0	\N
29052	1637	280086736819988	23137	11554	10	0	\N
29053	1637	280806709819988	23254	11602	2	0	\N
29054	1637	280806720819988	23254	11602	3	0	\N
29057	1637	281526742819988	23317	11635	4	0	\N
29058	1637	281526742819988	23342	11647	4	0	\N
29059	1637	281526742819988	23351	11652	4	0	\N
29062	1637	281526764819988	23317	11635	5	0	\N
29063	1637	281526764819988	23342	11647	5	0	\N
29064	1637	281526764819988	23351	11652	5	0	\N
29067	1637	282966777819988	23608	11761	3	0	\N
29068	1637	282966777819988	23621	11767	4	0	\N
29070	1637	282966789819988	23608	11761	4	0	\N
29071	1637	282966790819988	23621	11767	5	0	\N
29075	1637	284406813819988	23833	11862	7	0	\N
29077	1637	284406838819988	23833	11862	8	0	\N
29081	1637	285846875819988	24030	11958	3	0	\N
29082	1637	285846875819988	24065	11976	0	0	\N
29085	1637	285846887819988	24030	11958	4	0	\N
29086	1637	286566886819988	24160	12025	2	0	\N
29088	1637	286566897819988	24160	12025	3	0	\N
29097	1637	289446948819988	24329	12099	3	0	\N
29100	1637	289446960819988	24329	12099	4	0	\N
29103	1637	290886970819988	24380	12124	1	0	\N
29104	1637	290886970819988	24390	12128	2	0	\N
28977	1637	265686364819988	22264	11142	6	0	0
28978	1637	266406364819988	22345	11185	5	0	0
28979	1637	266406378819988	22345	11185	6	0	0
28980	1637	267126378819988	22403	11215	7	0	0
28981	1637	267126403819988	22403	11215	8	0	0
28991	1637	267846415819988	22640	11322	4	0	0
28996	1637	268566415819988	22647	11324	7	0	0
28997	1637	268566440819988	22647	11324	8	0	0
29000	1637	269286440819988	22733	11367	3	0	0
29003	1637	269286452819988	22733	11367	4	0	0
29005	1637	270006476819988	22742	11372	7	0	0
29006	1637	270726476819988	22758	11379	3	0	0
29007	1637	270726488819988	22758	11379	4	0	0
29011	1637	271446488819988	22831	11418	4	0	0
29017	1637	272166501819988	22838	11421	7	0	0
29018	1637	272166526819988	22838	11421	8	0	0
29019	1637	272886526819988	22844	11423	3	0	0
29020	1637	272886538819988	22844	11423	4	0	0
29022	1637	273606538819988	22886	11441	3	0	0
29026	1637	274326550819988	22906	11449	3	0	0
29028	1637	274326562819988	22906	11449	4	0	0
29029	1637	275046562819988	22909	11451	3	0	0
29030	1637	275046574819988	22909	11451	4	0	0
29031	1637	275766574819988	22914	11454	4	0	0
29034	1637	276486587819988	23055	11512	3	0	0
29035	1637	276486599819988	23055	11512	4	0	0
29037	1637	277206599819988	23075	11520	3	0	0
29038	1637	277206611819988	23075	11520	4	0	0
29040	1637	277926623819988	23083	11526	4	0	0
29041	1637	278646623819988	23090	11529	17	0	0
29042	1637	278646685819988	23090	11529	18	0	0
29043	1637	279366685819988	23098	11534	6	0	0
29044	1637	279366709819988	23098	11534	7	0	0
29049	1637	280086720819988	23256	11603	3	0	0
29055	1637	280806720819988	23298	11625	4	0	0
29056	1637	280806742819988	23298	11625	5	0	0
29060	1637	281526742819988	23403	11676	2	0	0
29061	1637	281526753819988	23403	11676	3	0	0
29066	1637	282246777819988	23560	11742	7	0	0
29069	1637	282966777819988	23783	11842	6	0	0
29072	1637	282966801819988	23783	11842	7	0	0
29073	1637	283686801819988	23811	11852	3	0	0
29076	1637	284406813819988	23880	11885	14	0	0
29078	1637	284406863819988	23880	11885	15	0	0
29079	1637	285126863819988	24013	11949	3	0	0
29080	1637	285126875819988	24013	11949	4	0	0
29083	1637	285846875819988	24091	11992	2	0	0
29087	1637	286566886819988	24180	12036	2	0	0
29089	1637	286566897819988	24180	12036	3	0	0
29090	1637	287286897819988	24222	12055	4	0	0
29091	1637	287286910819988	24222	12055	5	0	0
29092	1637	288006910819988	24280	12078	4	0	0
29094	1637	288006944819988	24307	12087	3	0	0
29095	1637	288726944819988	24307	12087	8	0	0
29096	1637	288726948819988	24307	12087	9	0	0
29098	1637	289446948819988	24340	12104	2	0	0
29101	1637	290166959819988	24362	12115	2	0	0
29102	1637	290166970819988	24362	12115	3	0	0
29105	1637	290886970819988	24476	12170	4	0	\N
29107	1637	290886980819988	24380	12124	2	0	\N
29108	1637	290886981819988	24390	12128	3	0	\N
29109	1637	290886992819988	24476	12170	5	0	\N
29113	1637	292327004819988	24654	12245	4	0	\N
29116	1637	292327116819988	24654	12245	5	0	\N
29136	1637	299527186819988	25061	12436	3	0	\N
29137	1637	299527186819988	25150	12468	42	0	\N
29139	1637	299527186819988	25903	12515	0	0	\N
29141	1637	299527198819988	25061	12436	4	0	\N
29142	1637	299527336819988	25150	12468	43	0	\N
29143	1637	299527376819988	25160	12469	4	0	\N
29144	1637	300247197819988	25596	12669	2	0	\N
29146	1637	300247208819988	25596	12669	3	0	\N
29148	1637	300247376819988	25160	12469	15	0	\N
29149	1637	300247397819988	25160	12469	16	0	\N
29152	1637	300967397819988	25166	12470	8	0	\N
29153	1637	300967423819988	25166	12470	9	0	\N
29154	1637	300968014819988	25243	12471	105	0	\N
29155	1637	301687267819988	25702	12717	4	0	\N
29158	1637	301687280819988	25702	12717	5	0	\N
29159	1637	301688014819988	25243	12471	126	0	\N
29160	1637	301688034819988	25243	12471	127	0	\N
29161	1637	301688463819988	25291	12472	105	0	\N
29162	1637	302407279819988	25846	12778	2	0	\N
29163	1637	302407279819988	25868	12788	3	0	\N
29164	1637	302407279819988	25954	12804	3	0	\N
29165	1637	302407279819988	26038	12866	4	0	\N
29166	1637	302407290819988	25846	12778	3	0	\N
29167	1637	302407291819988	25868	12788	4	0	\N
29168	1637	302407300819988	25954	12804	4	0	\N
29169	1637	302407301819988	26038	12866	5	0	\N
29170	1637	302408463819988	25291	12472	126	0	\N
29171	1637	302408483819988	25291	12472	127	0	\N
29172	1637	303127300819988	25975	12805	1	0	\N
29173	1637	303127301819988	25975	12805	2	0	\N
29174	1637	303128483819988	25375	12473	13	0	\N
29175	1638	720000000000	10897	5618	7	0	\N
29176	1638	720000000000	13010	6706	2	0	\N
29177	1638	720000000000	20760	10422	60	0	\N
29178	1638	720000000000	20764	10436	12	0	\N
29180	1638	720011000000	13010	6706	3	0	\N
29182	1638	720070000000	10897	5618	8	0	\N
29183	1638	720174000000	20764	10436	13	0	\N
29184	1638	720717000000	20760	10422	61	0	\N
29186	1639	720000000000	6977	3599	3	0	\N
29187	1639	720000000000	22599	11306	15	0	\N
29188	1639	720000000000	22600	11306	11	0	\N
29192	1639	720030000000	6977	3599	4	0	\N
29193	1639	720056000000	22600	11306	12	0	\N
29194	1639	720060000000	22599	11306	16	0	\N
29197	1640	1440010000000	3791	1947	0	0	\N
29200	1643	200000001	20399	10186	89	1	\N
29201	1643	200000001	20716	10188	80	0	\N
29202	1643	200000002	20716	10188	66	1	\N
29203	1643	900500000	3840	1891	127	0	\N
29204	1643	1000001300	2186	972	14	1	\N
29205	1643	1000001700	2261	974	3	1	\N
29206	1643	720000000000	389	221	2	0	\N
29209	1643	720020000000	389	221	3	0	\N
29212	1643	1148535914700	20096	10116	2	0	\N
29213	1643	1149397914700	20329	10185	90	0	\N
29216	1643	1296377114700	15498	7884	0	0	\N
29219	1643	1440010000000	585	330	1	0	\N
29220	1643	1440010000000	835	460	1	0	\N
29222	1643	1440010000000	1254	677	0	0	\N
29223	1643	1440020000000	585	330	2	0	\N
29224	1643	1440020000000	835	460	2	0	\N
29228	1643	1764233113700	5006	2594	1	0	\N
29229	1643	1764233113700	5059	2625	1	0	\N
29231	1643	1764243113700	5006	2594	2	0	\N
29232	1643	1764243113700	5059	2625	2	0	\N
29234	1643	1868524914700	20123	10130	8	0	\N
29236	1643	1868535914700	20096	10116	4	0	\N
29237	1643	1868536914700	20096	10116	5	0	\N
29239	1643	1868649914700	20123	10130	9	0	\N
29240	1643	1869397914700	20329	10185	126	0	\N
29195	1640	720000000000	970	540	1	0	0
29196	1640	720010000000	970	540	2	0	0
29221	1643	1440010000000	1231	679	2	0	0
29225	1643	1440030000000	1231	679	3	0	0
29185	1639	720000000000	2735	1436	2	0	0
29198	1640	1440010000000	3792	1964	1	0	0
29199	1640	1440020000000	3792	1964	2	0	0
29210	1643	1044213113700	4254	2207	2	0	5
29211	1643	1044233113700	4254	2207	3	0	5
29230	1643	1764233113700	5271	2737	1	0	5
29214	1643	1296213113700	8375	4341	2	0	9
29215	1643	1296224113700	8375	4341	3	0	9
29217	1643	1296377114700	16230	8250	4	0	13
29218	1643	1296390114700	16230	8250	5	0	13
29227	1643	1760542914700	18837	9494	2	0	21
29179	1638	720000000000	22038	11019	4	0	0
29181	1638	720013000000	22038	11019	5	0	0
29106	1637	290886970819988	24487	12177	4	0	0
29110	1637	290886992819988	24487	12177	5	0	0
29112	1637	291607004819988	24615	12233	4	0	0
29114	1637	292327004819988	24686	12262	10	0	0
29115	1637	292327041819988	24686	12262	11	0	0
29117	1637	293047041819988	24717	12275	6	0	0
29118	1637	293047092819988	24717	12275	7	0	0
29120	1637	293767104819988	24796	12312	4	0	0
29121	1637	293767114819988	24799	12314	1	0	0
29122	1637	294487114819988	24799	12314	4	0	0
29123	1637	294487116819988	24799	12314	5	0	0
29125	1637	295207128819988	24816	12322	4	0	0
29126	1637	295927128819988	24843	12334	3	0	0
29127	1637	295927140819988	24843	12334	4	0	0
29128	1637	296647140819988	24894	12360	3	0	0
29129	1637	296647152819988	24894	12360	4	0	0
29131	1637	297367164819988	24919	12371	4	0	0
29132	1637	298087164819988	25045	12426	2	0	0
29133	1637	298087175819988	25045	12426	3	0	0
29134	1637	298807175819988	25047	12427	2	0	0
29135	1637	298807186819988	25047	12427	3	0	0
29238	1643	1868647914700	25348	12569	7	0	25
29138	1637	299527186819988	25591	12666	2	0	0
29140	1637	299527197819988	25591	12666	3	0	0
29145	1637	300247197819988	25625	12681	10	0	0
29150	1637	300967243819988	25686	12709	6	0	0
29151	1637	300967267819988	25686	12709	7	0	0
29156	1637	301687267819988	25836	12775	3	0	0
29157	1637	301687279819988	25836	12775	4	0	0
29189	1639	720000000000	26867	13288	4	0	3
29241	1643	1872019151064	20329	10185	127	0	\N
29248	1643	2160850000000	2011	971	81	0	\N
29255	1643	2588647914700	25627	12681	10	0	\N
29256	1643	2588647914700	26067	12883	6	0	\N
29259	1643	2588689914700	26067	12883	7	0	\N
29260	1643	2588693914700	25627	12681	11	0	\N
29261	1643	2590005914690	20399	10186	126	0	\N
29262	1643	2590040914690	20399	10186	127	0	\N
29263	1643	2736235113700	8600	4459	1	0	\N
29264	1643	2736235113700	8928	4627	2	0	\N
29266	1643	2736245113700	8600	4459	2	0	\N
29267	1643	2736255113700	8928	4627	3	0	\N
29271	1643	2880040000000	2014	1062	1	0	\N
29273	1643	2880050000000	2014	1062	2	0	\N
29275	1643	2880849999900	2011	971	82	0	\N
29276	1643	3128436114700	17621	8910	1	0	\N
29277	1643	3128436114700	17908	9033	2	0	\N
29278	1643	3128436114700	17979	9067	3	0	\N
29279	1643	3128436114700	18233	9155	84	0	\N
29280	1643	3128437114700	17621	8910	2	0	\N
29281	1643	3128438114700	17908	9033	3	0	\N
29282	1643	3128448114700	17979	9067	4	0	\N
29283	1643	3128955114700	18233	9155	85	0	\N
29289	1643	3310040914690	20536	10187	21	0	\N
29290	1643	3310330914690	20536	10187	22	0	\N
29295	1643	3600060000000	2256	1184	3	0	\N
29296	1643	3600060000000	2263	1188	4	0	\N
29299	1643	3600090000000	2256	1184	4	0	\N
29300	1643	3600100000000	2263	1188	5	0	\N
29301	1643	3600849999800	2186	972	13	0	\N
29302	1643	3920564914700	19255	9708	8	0	\N
29303	1643	3920564914700	19292	9726	7	0	\N
29304	1643	3920589914700	19292	9726	8	0	\N
29305	1643	3920590914700	19255	9708	9	0	\N
29307	1643	4028670914700	26417	13069	4	0	\N
29310	1643	4028683914700	26417	13069	5	0	\N
29311	1643	4031150914689	20716	10188	79	0	\N
29312	1643	4176365113700	9696	5026	23	0	\N
29313	1643	4176365113700	11190	5745	3	0	\N
29316	1643	4176395113700	11190	5745	4	0	\N
29317	1643	4176685113700	9696	5026	24	0	\N
29318	1643	4178395113700	9998	5027	22	0	\N
29319	1643	4320080000000	2682	1269	94	0	\N
29322	1643	4320729994101	2252	973	0	0	\N
29323	1643	4321140000000	2682	1269	95	0	\N
29324	1643	4644253113700	5472	2850	0	0	\N
29326	1643	4748682914700	26525	13121	3	0	\N
29327	1643	4748682914700	26767	13236	10	0	\N
29328	1643	4748682914700	26903	13304	3	0	\N
29330	1643	4748694914700	26525	13121	4	0	\N
29331	1643	4748694914700	26903	13304	4	0	\N
29333	1643	4748719914700	26767	13236	11	0	\N
29336	1643	4898395113700	9998	5027	126	0	\N
29337	1643	4899425113700	9998	5027	127	0	\N
29338	1643	4900905113700	10137	5028	22	0	\N
29341	1643	5040729994001	2261	974	2	0	\N
29343	1643	5468694914700	27189	13447	2	0	\N
29344	1643	5468696914700	27189	13447	3	0	\N
29345	1643	5616367113700	12255	6310	0	0	\N
29347	1643	5620905113700	10137	5028	126	0	\N
29348	1643	5621935113700	10137	5028	127	0	\N
29349	1643	5622245113700	10223	5029	22	0	\N
29350	1643	5760120000000	3062	1566	1	0	\N
29353	1643	5760220000000	3062	1566	2	0	\N
29354	1643	6336367113700	12587	6488	4	0	\N
29355	1643	6336367113700	12765	6370	0	0	\N
29356	1643	6336367113700	12766	6386	0	0	\N
29359	1643	6336389113700	12587	6488	5	0	\N
29360	1643	6342245113700	10223	5029	61	0	\N
29361	1643	6480130000000	3133	1629	1	0	\N
29363	1643	6480140000000	3133	1629	2	0	\N
29365	1643	6480220000000	3131	1567	13	0	\N
29366	1643	6480350000000	3131	1567	14	0	\N
29367	1643	6481050000000	3840	1891	81	0	\N
29368	1643	7056380113700	13890	7127	7	0	\N
29371	1643	7056396113700	13890	7127	8	0	\N
29372	1643	7200150000000	3839	1995	1	0	\N
29373	1643	7200150000000	3924	2036	2	0	\N
29374	1643	7200160000000	3839	1995	2	0	\N
29375	1643	7200170000000	3924	2036	3	0	\N
29376	1643	7200350000000	3270	1568	50	0	\N
29272	1643	2880040000000	2187	1152	2	0	0
29274	1643	2880060000000	2187	1152	3	0	0
29297	1643	3600060000000	2356	1231	2	0	0
29298	1643	3600080000000	2356	1231	3	0	0
29320	1643	4320080000000	2684	1410	1	0	0
29339	1643	5040090000000	2918	1520	3	0	0
29340	1643	5040120000000	2918	1520	4	0	0
29351	1643	5760120000000	3063	1590	1	0	0
29352	1643	5760130000000	3063	1590	2	0	0
29362	1643	6480130000000	3272	1699	2	0	0
29253	1643	2484243113700	5366	2787	1	0	5
29254	1643	2484253113700	5366	2787	2	0	5
29286	1643	3204253113700	5395	2807	0	0	5
29306	1643	3924253113700	5463	2843	0	0	5
29342	1643	5364253113700	5525	2873	0	0	5
29242	1643	2016224113700	8595	4456	2	0	9
29243	1643	2016235113700	8595	4456	3	0	9
29265	1643	2736235113700	9142	4737	5	0	9
29268	1643	2736285113700	9142	4737	6	0	9
29292	1643	3456365113700	9305	4828	9	0	9
29314	1643	4176365113700	11885	6107	1	0	9
29315	1643	4176366113700	11885	6107	2	0	9
29334	1643	4896366113700	12108	6235	1	0	9
29335	1643	4896367113700	12108	6235	2	0	9
29357	1643	6336367113700	13623	7003	4	0	9
29358	1643	6336380113700	13623	7003	5	0	9
29369	1643	7056380113700	13930	7140	6	0	9
29370	1643	7056395113700	13930	7140	7	0	9
29245	1643	2016402114700	16406	8346	4	0	13
29269	1643	2736402114700	16433	8356	7	0	13
29270	1643	2736427114700	16433	8356	8	0	13
29293	1643	3456427114700	16661	8464	9	0	13
29294	1643	3456463114700	16661	8464	10	0	13
29250	1643	2408436114700	16826	8540	5	0	17
29251	1643	2480542914700	18968	9567	2	0	21
29252	1643	2480553914700	18968	9567	3	0	21
29284	1643	3200553914700	19073	9619	2	0	21
29285	1643	3200564914700	19073	9619	3	0	21
29258	1643	2588658914700	26100	12900	3	0	25
29287	1643	3308658914700	26252	12980	3	0	25
29288	1643	3308670914700	26252	12980	4	0	25
29308	1643	4028670914700	26503	13111	3	0	25
29329	1643	4748682914700	27168	13434	3	0	25
29332	1643	4748694914700	27168	13434	4	0	25
29377	1643	7200940000000	3270	1568	51	0	\N
29378	1643	7201050000000	3840	1891	126	0	\N
29379	1643	7776395113700	14820	7554	2	0	\N
29381	1643	7776406113700	14820	7554	3	0	\N
29383	1643	7921489500000	3927	1892	62	0	\N
29384	1643	7922073500000	3927	1892	63	0	\N
29387	1643	8496427113700	15404	7846	1	0	\N
29388	1643	9216417113700	15388	7838	2	0	\N
29389	1643	9216427113700	15404	7846	4	0	\N
29390	1643	9216428113700	15388	7838	3	0	\N
29391	1643	9216429113700	15404	7846	5	0	\N
29392	1643	66000025000000	10223	5029	62	0	\N
29393	1644	200100000	6992	3610	10	1	\N
29396	1644	721199000000	14661	7469	5	0	\N
29397	1644	721222000000	14661	7469	6	0	\N
29398	1644	1440020000000	6992	3610	9	0	\N
29399	1644	1440020000000	6993	3610	9	0	\N
29401	1644	1440200000000	6993	3610	10	0	\N
29403	1645	1000000	3499	1677	64	0	\N
29404	1646	18500000	5176	2687	4	0	\N
29405	1646	720000000000	13658	7020	0	0	\N
29406	1646	720000000000	13745	7062	5	0	\N
29409	1646	720050000000	13745	7062	6	0	\N
29412	1646	2160013000000	15673	7976	7	0	\N
29413	1646	2160038000000	15673	7976	8	0	\N
29414	1646	68401193750000	5102	2649	2	1	\N
29416	1647	4405003726450	6681	3453	7	0	\N
29419	1649	1440010000000	206	121	1	0	\N
29421	1649	1440020000000	206	121	2	0	\N
29423	1649	2160020000000	594	336	1	0	\N
29425	1649	2160030000000	594	336	2	0	\N
29433	1649	5040091000000	2104	1110	1	0	\N
29435	1649	5040101000000	2104	1110	2	0	\N
29438	1649	5512449999992	21904	10960	3	0	\N
29440	1649	5512461999992	21904	10960	4	0	\N
29441	1649	5760101000000	2420	1266	3	0	\N
29443	1649	5760131000000	2420	1266	4	0	\N
29447	1649	6232461999992	22164	11087	3	0	\N
29448	1649	6232461999992	22330	11175	6	0	\N
29449	1649	6232473999992	22164	11087	4	0	\N
29450	1649	6232476999992	22330	11175	7	0	\N
29451	1649	6480131000000	2744	1440	1	0	\N
29452	1649	6480131000000	2828	1478	8	0	\N
29454	1649	6480141000000	2744	1440	2	0	\N
29456	1649	6480211000000	2828	1478	9	0	\N
29459	1649	7100616124162	24638	12241	6	0	\N
29463	1649	7200161000000	3244	1684	1	0	\N
29464	1649	7483830999992	12744	6571	2	0	\N
29466	1649	7483841999992	12744	6571	3	0	\N
29468	1649	7671485999968	22511	11260	4	0	\N
29469	1649	7671485999968	22661	11330	10	0	\N
29470	1649	7671485999968	22924	11458	4	0	\N
29472	1649	7671498999968	22924	11458	5	0	\N
29473	1649	7671507999968	22511	11260	5	0	\N
29475	1649	7671522999968	22661	11330	11	0	\N
29477	1649	7920161000000	3244	1684	2	0	\N
29483	1649	8391523999968	24112	12002	1	0	\N
29484	1649	8391523999968	24113	12002	1	0	\N
29485	1649	8640160999992	4443	2303	4	0	\N
29488	1649	8640380999992	4443	2303	5	0	\N
29491	1649	9111522999968	23158	11564	7	0	\N
29493	1649	9111523999968	24112	12002	2	0	\N
29494	1649	9111523999968	24113	12002	2	0	\N
29496	1649	9111533999968	24638	12241	1	0	\N
29497	1649	9111556999968	23158	11564	8	0	\N
29498	1649	9360280999992	4698	2429	1	0	\N
29499	1649	9360280999992	4948	2562	1	0	\N
29501	1649	9360290999992	4698	2429	2	0	\N
29502	1649	9360290999992	4948	2562	2	0	\N
29507	1649	9831533999968	24638	12241	5	0	\N
29509	1649	10080290999992	5334	2769	1	0	\N
29510	1649	10080290999992	5406	2814	0	0	\N
29511	1649	10080290999992	5735	2971	0	0	\N
29420	1649	1440010000000	581	328	1	0	0
29422	1649	1440020000000	581	328	2	0	0
29424	1649	2160020000000	825	455	2	0	0
29426	1649	2160040000000	825	455	3	0	0
29427	1649	2880040000000	1306	721	3	0	0
29429	1649	3600061000000	1609	870	2	0	0
29430	1649	3600081000000	1609	870	3	0	0
29431	1649	4320081000000	1626	877	1	0	0
29432	1649	4320091000000	1626	877	2	0	0
29434	1649	5040091000000	2106	1110	1	0	0
29442	1649	5760101000000	2486	1302	3	0	0
29444	1649	5760131000000	2486	1302	4	0	0
29453	1649	6480131000000	2873	1503	1	0	0
29455	1649	6480141000000	2873	1503	2	0	0
29461	1649	7200151000000	3079	1600	2	0	0
29462	1649	7200161000000	3243	1684	1	0	0
29476	1649	7920160999992	3243	1684	2	0	0
29486	1649	8640160999992	4458	2310	3	0	0
29487	1649	8640280999992	4458	2310	4	0	0
29503	1649	9360290999992	5181	2690	2	0	0
29512	1649	10080290999992	5842	3031	3	0	0
29394	1644	720000000000	6751	3495	2	0	0
29395	1644	720020000000	6751	3495	3	0	0
29400	1644	1440020000000	6994	3610	9	0	0
29465	1649	7483830999992	13104	6754	4	0	4
29467	1649	7483843999992	13104	6754	5	0	4
29478	1649	8203843999992	13288	6845	3	0	4
29479	1649	8203855999992	13288	6845	4	0	4
29490	1649	8923868999992	13373	6891	5	0	4
29504	1649	9643868999992	13378	6894	5	0	4
29505	1649	9643883999992	13378	6894	6	0	4
29415	1647	20000000	13488	6946	5	0	0
29407	1646	720000000000	14574	7430	2	0	0
29380	1643	7776395113700	14927	7606	2	0	9
29382	1643	7776406113700	14927	7606	3	0	9
29385	1643	8496406113700	15084	7684	2	0	9
29386	1643	8496417113700	15084	7684	3	0	9
29410	1646	1440011000000	15596	7938	2	0	0
29437	1649	5512449999992	21903	10960	3	0	8
29439	1649	5512461999992	21903	10960	4	0	8
29445	1649	6231461999968	22329	11175	3	0	8
29446	1649	6231473999968	22329	11175	4	0	8
29458	1649	6951485999968	22384	11207	4	0	8
29471	1649	7671485999968	23038	11503	7	0	8
29474	1649	7671510999968	23038	11503	8	0	8
29480	1649	8391510999968	23056	11513	3	0	8
29481	1649	8391522999968	23056	11513	4	0	8
29492	1649	9111523999968	24111	12002	2	0	8
29495	1649	9111533999968	24634	12241	1	0	8
29506	1649	9831533999968	24634	12241	5	0	8
29508	1649	9831536999968	24634	12241	6	0	8
29513	1649	10080290999992	6143	2924	0	0	\N
29514	1649	10080290999992	6146	2945	0	0	\N
29515	1649	10080290999992	6147	2965	0	0	\N
29516	1649	10080290999992	6148	2983	0	0	\N
29517	1649	10080290999992	6149	3000	0	0	\N
29518	1649	10080300999992	5334	2769	2	0	\N
29522	1649	10551536887768	24810	12261	112	0	\N
29523	1649	10551536999968	24808	12320	4	0	\N
29524	1649	10551536999968	24995	12399	25	0	\N
29525	1649	10551536999968	24996	12402	5	0	\N
29527	1649	10551536999968	25079	12448	3	0	\N
29529	1649	10551548999968	25079	12448	4	0	\N
29530	1649	10551549999968	24808	12320	5	0	\N
29531	1649	10551560999968	24996	12402	6	0	\N
29532	1649	10551633999968	24995	12399	26	0	\N
29533	1649	10800320999992	6145	3185	1	0	\N
29534	1649	10800320999992	6306	3265	5	0	\N
29536	1649	10800330999992	6145	3185	2	0	\N
29538	1649	10800550999992	6306	3265	6	0	\N
29542	1649	11271547999968	25168	12485	4	0	\N
29543	1649	11271547999968	25962	12829	5	0	\N
29545	1649	11271560999968	25168	12485	5	0	\N
29546	1649	11271570999968	25962	12829	6	0	\N
29548	1649	11272599887768	24994	12262	2	0	\N
29549	1649	11272709887768	24994	12262	3	0	\N
29554	1649	11903338503835	24810	12261	113	0	\N
29557	1649	12240350999992	6829	3536	2	0	\N
29559	1649	12240370999992	6829	3536	3	0	\N
29565	1649	12960530999992	7008	3615	5	0	\N
29566	1649	12960530999992	7215	3731	3	0	\N
29569	1649	12960560999992	7215	3731	4	0	\N
29570	1649	12960571999992	7008	3615	6	0	\N
29571	1649	13244086999992	13770	7075	1	0	\N
29573	1649	13244096999992	13770	7075	2	0	\N
29575	1649	13431609999968	26907	13307	6	0	\N
29578	1649	13431633999968	26907	13307	7	0	\N
29579	1649	13680540999992	8379	4342	4	0	\N
29580	1649	13680540999992	8479	4393	1	0	\N
29582	1649	13680550999992	8479	4393	2	0	\N
29584	1649	13680769999992	8379	4342	5	0	\N
29585	1649	13964099999992	13806	7090	1	0	\N
29586	1649	13964099999992	13807	7090	7	0	\N
29588	1649	13964109999992	13806	7090	2	0	\N
29589	1649	13964115999992	13807	7090	8	0	\N
29597	1649	14871649999968	27616	13648	12	0	\N
29598	1649	14871649999968	27646	13661	4	0	\N
29601	1649	14871671999968	27646	13661	5	0	\N
29602	1649	14871697999968	27616	13648	13	0	\N
29603	1649	15120600999992	9320	4833	2	0	\N
29604	1649	15120600999992	9321	4833	1	0	\N
29605	1649	15120600999992	9648	5006	3	0	\N
29607	1649	15120610999992	9321	4833	2	0	\N
29608	1649	15120620999992	9320	4833	3	0	\N
29609	1649	15120630999992	9648	5006	4	0	\N
29613	1649	15591660999968	28271	13977	2	0	\N
29615	1649	15591671999968	28271	13977	3	0	\N
29617	1649	15840740999992	9999	5184	2	0	\N
29619	1649	15840751999992	9999	5184	3	0	\N
29623	1649	16560781999992	10806	5578	3	0	\N
29624	1649	16560781999992	10807	5578	3	0	\N
29625	1649	16560781999992	10860	5606	4	0	\N
29626	1649	16560781999992	10889	5615	2	0	\N
29627	1649	16560781999992	10944	5641	2	0	\N
29628	1649	16560781999992	10945	5641	2	0	\N
29630	1649	16560801999992	10889	5615	3	0	\N
29631	1649	16560801999992	10944	5641	3	0	\N
29632	1649	16560801999992	10945	5641	3	0	\N
29633	1649	16560811999992	10806	5578	4	0	\N
29634	1649	16560811999992	10807	5578	4	0	\N
29635	1649	16560821999992	10860	5606	5	0	\N
29639	1649	17031672999968	28701	14166	0	0	\N
29644	1649	17280861999992	11390	5850	1	0	\N
29645	1649	17280861999992	11391	5850	1	0	\N
29646	1649	17564222999982	15653	7965	3	0	\N
29647	1649	17564222999992	15651	7965	3	0	\N
29537	1649	10800330999992	6348	3285	2	0	0
29550	1649	11520330999992	6591	3410	2	0	0
29551	1649	11520350999992	6591	3410	3	0	0
29558	1649	12240350999992	6856	3546	9	0	0
29560	1649	12240530999992	6856	3546	10	0	0
29568	1649	12960540999992	7548	3908	2	0	0
29581	1649	13680540999992	8720	4522	2	0	0
29583	1649	13680560999992	8720	4522	3	0	0
29593	1649	14400560999992	8967	4651	4	0	0
29594	1649	14400600999992	8967	4651	5	0	0
29610	1649	15120740999992	9689	5027	6	0	0
29618	1649	15840740999992	10025	5199	5	0	0
29620	1649	15840781999992	10025	5199	6	0	0
29629	1649	16560781999992	11018	5672	4	0	0
29642	1649	17280821999992	11022	5674	3	0	0
29643	1649	17280851999992	11022	5674	4	0	0
29520	1649	10363883999992	13437	6924	4	0	4
29521	1649	10363896999992	13437	6924	5	0	4
29539	1649	11083896999992	13471	6939	7	0	4
29541	1649	11083953999992	13580	6985	5	0	4
29552	1649	11803953999992	13580	6985	13	0	4
29553	1649	11803960999992	13580	6985	14	0	4
29561	1649	12523960999992	13713	7047	9	0	4
29562	1649	12524086999992	13713	7047	10	0	4
29574	1649	13244099999992	13771	7075	5	0	4
29587	1649	13964099999992	14059	7197	8	0	4
29590	1649	13964116999992	14059	7197	9	0	4
29595	1649	14684116999992	14575	7431	2	0	4
29611	1649	15404127999992	14671	7475	9	0	4
29612	1649	15404199999992	14671	7475	10	0	4
29621	1649	16124199999992	14957	7618	3	0	4
29622	1649	16124211999992	14957	7618	4	0	4
29637	1649	16844211999992	15132	7713	2	0	4
29648	1649	17564222999992	15899	8084	3	0	4
29526	1649	10551536999968	25078	12448	2	0	8
29528	1649	10551547999968	25078	12448	3	0	8
29544	1649	11271547999968	26339	13026	5	0	8
29547	1649	11271570999968	26339	13026	6	0	8
29556	1649	11991572999968	26613	13167	3	0	8
29563	1649	12711572999968	26766	13236	10	0	8
29564	1649	12711609999968	26766	13236	11	0	8
29576	1649	13431609999968	27391	13544	3	0	8
29591	1649	14151621999968	27490	13587	10	0	8
29592	1649	14151649999968	27490	13587	11	0	8
29599	1649	14871649999968	27770	13719	2	0	8
29600	1649	14871660999968	27770	13719	3	0	8
29614	1649	15591660999968	28602	14124	3	0	8
29640	1649	17031672999968	28702	14170	2	0	8
29641	1649	17031683999968	28702	14170	3	0	8
29649	1649	17564234999982	15653	7965	4	0	\N
29650	1649	17564234999992	15651	7965	4	0	\N
29654	1649	18000851999992	11272	5791	2	0	\N
29657	1649	18000861999992	11390	5850	5	0	\N
29658	1649	18000861999992	11391	5850	5	0	\N
29659	1649	18000862999992	11272	5791	3	0	\N
29660	1649	18000873999992	11390	5850	6	0	\N
29661	1649	18000873999992	11391	5850	6	0	\N
29666	1649	18720852999992	11590	5962	1	0	\N
29668	1649	18720853999992	11590	5962	2	0	\N
29674	1649	19440854999992	11867	6099	1	0	\N
29676	1649	19440855999992	11867	6099	2	0	\N
29680	1649	20160856999992	11953	6153	4	0	\N
29683	1649	20160860999992	11953	6153	5	0	\N
29684	1649	20444270999992	16597	8433	5	0	\N
29686	1649	20444270999992	17032	8624	1	0	\N
29687	1649	20444271999992	17032	8624	2	0	\N
29689	1649	20444303999992	16597	8433	6	0	\N
29690	1649	20880859999992	12132	6248	3	0	\N
29691	1649	20880859999992	12153	6260	1	0	\N
29693	1649	20880860999992	12153	6260	2	0	\N
29694	1649	20880862999992	12132	6248	4	0	\N
29696	1649	21164272999992	17181	8708	6	0	\N
29697	1649	21164272999992	17207	8719	2	0	\N
29698	1649	21164272999992	17210	8719	3	0	\N
29700	1649	21164283999992	17207	8719	3	0	\N
29701	1649	21164284999992	17210	8719	4	0	\N
29702	1649	21164287999992	17181	8708	7	0	\N
29704	1649	21884296999992	17507	8864	3	0	\N
29707	1649	21884308999992	17507	8864	4	0	\N
29708	1649	22604297999992	17757	8972	12	0	\N
29709	1649	22604297999992	17912	9035	6	0	\N
29712	1649	22604312999992	17912	9035	7	0	\N
29713	1649	22604345999992	17757	8972	13	0	\N
29716	1649	23324382999992	18474	9308	8	0	\N
29717	1649	23324382999992	18477	9308	8	0	\N
29718	1649	23324382999992	18478	9308	8	0	\N
29720	1649	24044356999992	18748	9437	3	0	\N
29721	1649	24044368999992	18748	9437	4	0	\N
29723	1649	24044382999992	18474	9308	9	0	\N
29724	1649	24044382999992	18477	9308	9	0	\N
29725	1649	24044382999992	18478	9308	9	0	\N
29726	1649	24764368999992	19019	9439	0	0	\N
29727	1649	24764379999992	18820	9484	1	0	\N
29728	1649	24764379999992	19020	9589	4	0	\N
29729	1649	24764379999992	19579	9863	1	0	\N
29731	1649	24764380999992	19579	9863	2	0	\N
29733	1649	24764389999992	18820	9484	2	0	\N
29734	1649	24764401999992	19020	9589	5	0	\N
29737	1649	26204406999992	20432	10292	6	0	\N
29740	1649	26204421999992	20432	10292	7	0	\N
29741	1649	26924417999992	21177	10634	5	0	\N
29743	1649	26924417999992	21200	10596	1	0	\N
29744	1649	26924417999992	21201	10587	1	0	\N
29745	1649	26924418999992	21200	10596	2	0	\N
29746	1649	26924418999992	21201	10587	2	0	\N
29747	1649	26924449999992	21177	10634	6	0	\N
29751	1650	200000010	6690	3419	127	0	\N
29762	1650	2880040000000	1292	713	1	0	\N
29764	1650	2880050000000	1292	713	2	0	\N
29770	1650	3600050000000	1462	796	1	0	\N
29771	1650	3600050000000	1490	813	2	0	\N
29773	1650	3600060000000	1462	796	2	0	\N
29775	1650	3600061000000	1490	813	3	0	\N
29776	1650	3600160000000	2186	972	15	0	\N
29777	1650	3600185000000	2261	974	4	0	\N
29780	1650	3712863000000	20961	10542	3	0	\N
29781	1650	3712863000000	21291	10691	6	0	\N
29784	1650	3712887000000	21291	10691	7	0	\N
29754	1650	1440010000000	1100	608	1	0	0
29755	1650	1440020000000	1100	608	2	0	0
29756	1650	2160020000000	1193	658	2	0	0
29757	1650	2160040000000	1193	658	3	0	0
29763	1650	2880040000000	1449	788	1	0	0
29772	1650	3600050000000	1505	825	1	0	0
29774	1650	3600060000000	1505	825	2	0	0
29758	1650	2194000000000	10475	5415	3	0	5
29759	1650	2194021000000	10475	5415	4	0	5
29766	1650	2914021000000	10550	5448	2	0	5
29778	1650	3634041000000	10984	5659	2	0	5
29779	1650	3634061000000	10984	5659	3	0	5
29655	1649	18000851999992	11573	5950	1	0	0
29656	1649	18000852999992	11573	5950	2	0	0
29669	1649	18720854999992	11640	5991	3	0	0
29675	1649	19440854999992	11899	6118	2	0	0
29677	1649	19440856999992	11899	6118	3	0	0
29681	1649	20160856999992	12081	6221	3	0	0
29682	1649	20160859999992	12081	6221	4	0	0
29695	1649	20880870999992	12182	6272	3	0	0
29651	1649	17564234999992	15899	8084	4	0	4
29662	1649	18284234999992	15934	8100	3	0	4
29663	1649	18284246999992	15934	8100	4	0	4
29670	1649	19004246999992	16337	8305	3	0	4
29678	1649	19724258999992	16456	8370	3	0	4
29679	1649	19724270999992	16456	8370	4	0	4
29685	1649	20444270999992	17029	8624	2	0	4
29688	1649	20444272999992	17029	8624	3	0	4
29703	1649	21164296999992	17284	8754	7	0	4
29705	1649	21884296999992	17508	8864	1	0	4
29706	1649	21884297999992	17508	8864	2	0	4
29710	1649	22604297999992	18180	9168	3	0	4
29711	1649	22604309999992	18180	9168	4	0	4
29715	1649	23324356999992	18469	9306	12	0	4
29719	1649	24044356999992	18747	9448	5	0	4
29722	1649	24044379999992	18747	9448	6	0	4
29730	1649	24764379999992	19580	9863	2	0	4
29732	1649	24764381999992	19580	9863	3	0	4
29736	1649	25484406999992	19884	10016	8	0	4
29760	1650	2272806000000	20412	10284	6	0	9
29761	1650	2272821000000	20412	10284	7	0	9
29768	1650	2992821000000	20756	10434	6	0	9
29738	1649	26204406999992	20843	10475	2	0	4
29739	1649	26204417999992	20843	10475	3	0	4
29742	1649	26924417999992	21178	10634	5	0	4
29748	1649	26924449999992	21178	10634	6	0	4
29749	1649	27644449999992	21199	10645	10	0	4
29782	1650	3712863000000	21860	10939	3	0	9
29783	1650	3712875000000	21860	10939	4	0	9
29652	1649	17751683999968	29570	14579	6	0	8
29653	1649	17751707999968	29570	14579	7	0	8
29664	1649	18471707999968	29623	14609	6	0	8
29672	1649	19191734249968	29951	14752	9	0	8
29673	1649	19191752249968	29951	14752	10	0	8
29785	1650	3712904000000	20961	10542	4	0	\N
29786	1650	4320060000000	1682	903	1	0	\N
29787	1650	4320060000000	1839	983	1	0	\N
29788	1650	4320060000000	1963	1039	1	0	\N
29790	1650	4320070000000	1682	903	2	0	\N
29791	1650	4320070000000	1839	983	2	0	\N
29792	1650	4320070000000	1963	1039	2	0	\N
29794	1650	4354061000000	11097	5709	2	0	\N
29795	1650	4354061000000	11262	5786	7	0	\N
29798	1650	4354081000000	11097	5709	3	0	\N
29799	1650	4354122000000	11262	5786	8	0	\N
29802	1650	5040080000000	3283	1706	3	0	\N
29803	1650	5040080000000	3496	1814	1	0	\N
29805	1650	5040081000000	3496	1814	2	0	\N
29806	1650	5040110000000	3283	1706	4	0	\N
29807	1650	5074072000000	12733	6565	2	0	\N
29809	1650	5074083000000	12733	6565	3	0	\N
29812	1650	5760080000000	3561	1847	0	0	\N
29813	1650	5760080000000	3758	1949	2	0	\N
29816	1650	5760100000000	3758	1949	3	0	\N
29817	1650	5794072000000	13310	6858	2	0	\N
29818	1650	5794072000000	13931	7130	0	0	\N
29820	1650	5794083000000	13310	6858	3	0	\N
29826	1650	6514072000000	14018	7131	17	0	\N
29829	1650	6514128000000	14018	7131	18	0	\N
29830	1650	6592910000000	22875	11435	6	0	\N
29832	1650	6592934000000	22875	11435	7	0	\N
29836	1650	7234110000000	16349	8313	3	0	\N
29838	1650	7234122000000	16349	8313	4	0	\N
29839	1650	7234128000000	14103	7132	5	0	\N
29841	1650	7234143000000	14103	7132	6	0	\N
29842	1650	7312944000000	23123	11549	3	0	\N
29844	1650	7312956000000	23123	11549	4	0	\N
29846	1650	7920210000000	4834	2504	2	0	\N
29849	1650	7920230000000	4834	2504	3	0	\N
29850	1650	7954135000000	16943	8588	1	0	\N
29852	1650	7954143000000	14388	7133	6	0	\N
29853	1650	7954145000000	16943	8588	2	0	\N
29855	1650	7954194000000	14388	7133	7	0	\N
29856	1650	8032978000000	24895	12360	3	0	\N
29857	1650	8032978000000	25032	12419	2	0	\N
29859	1650	8032989000000	25032	12419	3	0	\N
29860	1650	8032990000000	24895	12360	4	0	\N
29862	1650	8640220000000	5524	2873	0	0	\N
29865	1650	8674147000000	17506	8863	6	0	\N
29866	1650	8674147000000	17591	8899	4	0	\N
29869	1650	8674169000000	17591	8899	5	0	\N
29870	1650	8674171000000	17506	8863	7	0	\N
29871	1650	8674194000000	14410	7134	1	0	\N
29872	1650	8674195000000	14410	7134	2	0	\N
29877	1650	9394159000000	17943	9050	3	0	\N
29878	1650	9394159000000	18149	9057	0	0	\N
29880	1650	9394171000000	17943	9050	4	0	\N
29882	1650	9473032000000	26664	13189	3	0	\N
29883	1650	9473032000000	26720	13216	3	0	\N
29885	1650	9473044000000	26664	13189	4	0	\N
29886	1650	9473044000000	26720	13216	4	0	\N
29890	1650	10080690000000	6690	3419	40	0	\N
29897	1650	10800690000000	6690	3419	126	0	\N
29898	1650	10801903999990	6878	3420	40	0	\N
29899	1650	10834185000000	18641	9394	7	0	\N
29902	1650	10834408000000	18641	9394	8	0	\N
29905	1650	10913080000000	29784	14678	2	0	\N
29906	1650	10913302000000	28905	14242	44	0	\N
29907	1650	11520300000000	8778	4553	2	0	\N
29909	1650	11520320000000	8778	4553	3	0	\N
29911	1650	11521903999990	6878	3420	126	0	\N
29912	1650	11523473999990	6878	3420	127	0	\N
29915	1650	11633069000000	27652	13664	10	0	\N
29916	1650	11633069000000	27719	13695	2	0	\N
29917	1650	11633069000000	27824	13751	3	0	\N
29918	1650	11633069000000	28598	14122	3	0	\N
29919	1650	11633069000000	28778	14195	8	0	\N
29920	1650	11633080000000	27719	13695	3	0	\N
29804	1650	5040080000000	3550	1842	0	0	0
29814	1650	5760080000000	4610	2387	1	0	0
29815	1650	5760090000000	4610	2387	2	0	0
29824	1650	6480090000000	4667	2413	1	0	0
29825	1650	6480100000000	4667	2413	2	0	0
29835	1650	7200210000000	4802	2485	3	0	0
29847	1650	7920210000000	5341	2771	1	0	0
29848	1650	7920220000000	5341	2771	2	0	0
29863	1650	8640220000000	5793	3005	1	0	0
29864	1650	8640230000000	5793	3005	2	0	0
29876	1650	9360250000000	6268	3247	3	0	0
29888	1650	10080250000000	6497	3367	4	0	0
29889	1650	10080290000000	6497	3367	5	0	0
29895	1650	10800290000000	8701	4510	1	0	0
29908	1650	11520300000000	9206	4773	8	0	0
29910	1650	11520380000000	9206	4773	9	0	0
29796	1650	4354061000000	12612	6506	2	0	5
29797	1650	4354072000000	12612	6506	3	0	5
29808	1650	5074072000000	12786	6591	0	0	5
29821	1650	5794084000000	16220	8243	4	0	5
29827	1650	6514084000000	16224	8246	8	0	5
29828	1650	6514110000000	16224	8246	9	0	5
29837	1650	7234110000000	16656	8461	7	0	5
29840	1650	7234135000000	16656	8461	8	0	5
29854	1650	7954147000000	17341	8786	4	0	5
29867	1650	8674147000000	17937	9047	3	0	5
29868	1650	8674159000000	17937	9047	4	0	5
29879	1650	9394159000000	18166	9159	4	0	5
29891	1650	10114172000000	18488	9311	4	0	5
29892	1650	10114185000000	18488	9311	5	0	5
29900	1650	10834185000000	18660	9402	3	0	5
29901	1650	10834197000000	18660	9402	4	0	5
29913	1650	11554197000000	19017	9587	2	0	5
29800	1650	4432875000000	22462	11240	3	0	9
29801	1650	4432887000000	22462	11240	4	0	9
29810	1650	5152887000000	22575	11294	3	0	9
29811	1650	5152899000000	22575	11294	4	0	9
29822	1650	5872899000000	22724	11361	2	0	9
29831	1650	6592910000000	22983	11480	7	0	9
29833	1650	6592944000000	22983	11480	8	0	9
29843	1650	7312944000000	24424	12147	7	0	9
29845	1650	7312978000000	24424	12147	8	0	9
29861	1650	8032990000000	25826	12770	4	0	9
29873	1650	8752990000000	26068	12883	6	0	9
29874	1650	8753032000000	26068	12883	7	0	9
29884	1650	9473032000000	26799	13251	4	0	9
29887	1650	9473045000000	26799	13251	5	0	9
29894	1650	10193057000000	26841	13274	4	0	9
29903	1650	10913057000000	26999	13354	3	0	9
29904	1650	10913069000000	26999	13354	4	0	9
29921	1650	11633080000000	29784	14678	13	0	\N
29922	1650	11633081000000	27824	13751	4	0	\N
29923	1650	11633081000000	28598	14122	4	0	\N
29924	1650	11633089864941	29784	14678	14	1	\N
29925	1650	11633104000000	28778	14195	9	0	\N
29926	1650	11633133000000	27652	13664	11	0	\N
29927	1650	11633302000000	28905	14242	64	0	\N
29928	1650	11633321000000	28905	14242	65	0	\N
29933	1650	12960420000000	9630	4997	7	0	\N
29936	1650	12960490000000	9630	4997	8	0	\N
29937	1650	12994220000000	19857	10002	6	0	\N
29940	1650	12994235000000	19857	10002	7	0	\N
29941	1650	13680440000000	10347	5355	2	0	\N
29942	1650	13680460000000	10347	5355	3	0	\N
29945	1652	720000000000	15	9	0	0	\N
29952	1654	720000000000	45	27	1	0	\N
29954	1654	720010000000	45	27	2	0	\N
29956	1654	1440010000000	242	143	1	0	\N
29958	1654	1440020000000	242	143	2	0	\N
29960	1654	2160020000000	784	435	3	0	\N
29963	1654	2160050000000	784	435	4	0	\N
29968	1654	4320080000000	1375	754	1	0	\N
29970	1654	4320090000000	1375	754	2	0	\N
29973	1654	5760090000000	1582	861	1	0	\N
29975	1654	5760100000000	1582	861	2	0	\N
29979	1654	6480100000000	1846	986	1	0	\N
29981	1654	6480110000000	1846	986	2	0	\N
29983	1654	6480530000000	3076	1473	24	0	\N
29987	1654	6767875000000	11524	5917	14	0	\N
29989	1654	6767952000000	11524	5917	15	0	\N
29990	1654	6768493000000	11864	5918	46	0	\N
29991	1654	7200110000000	2021	1066	2	0	\N
29992	1654	7200110000000	2079	1098	1	0	\N
29993	1654	7200110000000	2418	1265	2	0	\N
29994	1654	7200110000000	2453	1284	1	0	\N
29995	1654	7200110000000	2600	1369	0	0	\N
29996	1654	7200110000000	3074	1598	1	0	\N
29997	1654	7200110000000	3737	1939	1	0	\N
29999	1654	7200120000000	2079	1098	2	0	\N
30000	1654	7200120000000	2453	1284	2	0	\N
30001	1654	7200120000000	3074	1598	2	0	\N
30002	1654	7200120000000	3737	1939	2	0	\N
30003	1654	7200130000000	2021	1066	3	0	\N
30004	1654	7200130000000	2418	1265	3	0	\N
30006	1654	7200530000000	3076	1473	126	0	\N
30007	1654	7201540000000	3076	1473	127	0	\N
30012	1654	7488493000000	11864	5918	126	0	\N
30013	1654	7488590000000	11864	5918	127	0	\N
30020	1654	8640150000000	4338	2249	3	0	\N
30021	1654	8640150000000	4359	2259	1	0	\N
30022	1654	8640150000000	4676	2417	1	0	\N
30024	1654	8640160000000	4359	2259	2	0	\N
30025	1654	8640160000000	4676	2417	2	0	\N
30027	1654	8640180000000	4338	2249	4	0	\N
30032	1654	9079341999798	22152	11083	10	0	\N
30033	1654	9079341999798	22155	11083	10	0	\N
30034	1654	9079378999798	22152	11083	11	0	\N
30035	1654	9079378999798	22155	11083	11	0	\N
30040	1654	9647933000000	12426	6407	0	0	\N
30041	1654	9647933000000	12463	6421	0	0	\N
30042	1654	9647933000000	12691	6545	2	0	\N
30043	1654	9647933000000	12697	6548	2	0	\N
30044	1654	9647933000000	13063	6734	19	0	\N
30045	1654	9647933000000	13070	6736	8	0	\N
30047	1654	9647944000000	12691	6545	3	0	\N
30048	1654	9647944000000	12697	6548	3	0	\N
30050	1654	9648058000000	13070	6736	9	0	\N
30051	1654	9648078000000	13063	6734	20	0	\N
30052	1654	10080170000000	5115	2654	2	0	\N
30053	1654	10080170000000	5116	2655	1	0	\N
30054	1654	10080170000000	5119	2655	2	0	\N
30055	1654	10080170000000	5265	2734	1	0	\N
29946	1652	720000000000	161	96	2	0	0
29947	1652	720020000000	161	96	3	0	0
29957	1654	1440010000000	311	179	1	0	0
29959	1654	1440020000000	311	179	2	0	0
29961	1654	2160020000000	837	461	2	0	0
29964	1654	2880040000000	877	487	3	0	0
29965	1654	2880070000000	877	487	4	0	0
29966	1654	3600070000000	1272	702	1	0	0
29967	1654	3600080000000	1272	702	2	0	0
29969	1654	4320080000000	1471	803	1	0	0
29972	1654	5040090000000	1550	845	0	0	0
29974	1654	5760090000000	1836	981	1	0	0
29976	1654	5760100000000	1836	981	2	0	0
29980	1654	6480100000000	1905	1015	1	0	0
29948	1653	720000000000	3367	1752	1	0	0
29949	1653	720010000000	3367	1752	2	0	0
29998	1654	7200110000000	4255	2208	3	0	0
30005	1654	7200140000000	4255	2208	4	0	0
30014	1654	7920140000000	4307	2233	1	0	0
30023	1654	8640150000000	4714	2437	1	0	0
30026	1654	8640160000000	4714	2437	2	0	0
30036	1654	9360160000000	4973	2578	1	0	0
30037	1654	9360170000000	4973	2578	2	0	0
30056	1654	10080170000000	5295	2751	1	0	0
29951	1653	1440020000000	7928	4110	2	0	0
29929	1650	12240380000000	9292	4819	4	0	0
29930	1650	12240420000000	9292	4819	5	0	0
29934	1650	12960420000000	9903	5135	2	0	0
29977	1654	6047853000000	11378	5845	4	0	4
29978	1654	6047875000000	11378	5845	5	0	4
29986	1654	6767875000000	11523	5919	8	0	4
29988	1654	6767919000000	11523	5919	9	0	4
30010	1654	7487919000000	11863	6097	3	0	4
30018	1654	8207931000000	12117	6241	1	0	4
30019	1654	8207932000000	12117	6241	2	0	4
30030	1654	8927932000000	12357	6372	1	0	4
30031	1654	8927933000000	12357	6372	2	0	4
30046	1654	9647933000000	13092	6746	6	0	4
29931	1650	12274208000000	19386	9771	3	0	5
29932	1650	12274220000000	19386	9771	4	0	5
29938	1650	12994220000000	19922	10033	4	0	5
29939	1650	12994233000000	19922	10033	5	0	5
29944	1650	13714246000000	20024	10081	5	0	5
29984	1654	6617241999798	22430	11226	3	0	11
29985	1654	6617253999798	22430	11226	4	0	11
30008	1654	7337253999798	22431	11227	4	0	11
30009	1654	7337266999798	22431	11227	5	0	11
30017	1654	8057279999798	22446	11233	5	0	11
30028	1654	8777279999798	23036	11502	10	0	11
30029	1654	8777316999798	23036	11502	11	0	11
30038	1654	9497316999798	23092	11531	3	0	11
30039	1654	9497328999798	23092	11531	4	0	11
30057	1654	10080180000000	5116	2655	2	0	\N
30058	1654	10080180000000	5265	2734	2	0	\N
30060	1654	10080190000000	5115	2654	3	0	\N
30061	1654	10080190000000	5119	2655	3	0	\N
30062	1654	10217328999798	23496	11714	4	0	\N
30064	1654	10217341999798	23496	11714	5	0	\N
30077	1654	11657377999798	23795	11845	3	0	\N
30079	1654	11657389999798	23795	11845	4	0	\N
30082	1654	12240200000000	6095	3163	3	0	\N
30083	1654	12240200000000	6142	3184	1	0	\N
30084	1654	12240200000000	6340	3282	1	0	\N
30086	1654	12240210000000	6142	3184	2	0	\N
30087	1654	12240210000000	6340	3282	2	0	\N
30088	1654	12240230000000	6095	3163	4	0	\N
30094	1654	12960240000000	6879	3557	3	0	\N
30095	1654	12960240000000	6880	3557	5	0	\N
30096	1654	12960240000000	7040	3633	2	0	\N
30097	1654	12960240000000	7137	3688	2	0	\N
30099	1654	12960260000000	7040	3633	3	0	\N
30100	1654	12960260000000	7137	3688	3	0	\N
30102	1654	12960261000000	6879	3557	4	0	\N
30103	1654	12960281000000	6880	3557	6	0	\N
30106	1654	13247997000000	13550	6972	5	0	\N
30107	1654	13247997000000	13964	7156	13	0	\N
30110	1654	13248011000000	13550	6972	6	0	\N
30111	1654	13248082000000	13964	7156	14	0	\N
30112	1654	13680260000000	7579	3881	54	0	\N
30113	1654	13680260000000	7581	3921	1	0	\N
30114	1654	13680260000000	7658	3959	0	0	\N
30116	1654	13680270000000	7581	3921	2	0	\N
30118	1654	13680777000000	7579	3881	55	0	\N
30121	1654	13819007999798	24502	12028	117	0	\N
30123	1654	13968009000000	14681	7478	24	0	\N
30125	1654	13968222000000	14681	7478	25	0	\N
30126	1654	14400270000000	8202	4252	3	0	\N
30127	1654	14400270000000	8348	4324	3	0	\N
30128	1654	14400270000000	8399	4353	1	0	\N
30129	1654	14400270000000	8870	4597	2	0	\N
30131	1654	14400270000000	9088	4488	1	0	\N
30132	1654	14400270000000	9093	4501	1	0	\N
30133	1654	14400270000000	9094	4515	1	0	\N
30134	1654	14400270000000	9095	4528	1	0	\N
30135	1654	14400280000000	8399	4353	2	0	\N
30137	1654	14400280000000	9088	4488	2	0	\N
30138	1654	14400280000000	9093	4501	2	0	\N
30139	1654	14400280000000	9094	4515	2	0	\N
30140	1654	14400280000000	9095	4528	2	0	\N
30141	1654	14400290000000	8870	4597	3	0	\N
30142	1654	14400300000000	8348	4324	4	0	\N
30143	1654	14400480000000	8202	4252	4	0	\N
30146	1654	14539007999798	24502	12028	126	0	\N
30147	1654	14539087999798	24502	12028	127	0	\N
30148	1654	14540257999798	24557	12029	117	0	\N
30149	1654	14688121999798	15095	7691	1	0	\N
30150	1654	14688121999798	15420	7855	2	0	\N
30152	1654	14688122999798	15095	7691	2	0	\N
30153	1654	14688132999798	15420	7855	3	0	\N
30155	1654	14688773999798	16721	8355	56	0	\N
30156	1654	15120280000000	9091	4713	11	0	\N
30159	1654	15120372000000	9091	4713	12	0	\N
30160	1654	15257449999798	24556	12206	5	0	\N
30163	1654	15257472999798	24556	12206	6	0	\N
30164	1654	15260257999798	24557	12029	126	0	\N
30165	1654	15260337999798	24557	12029	127	0	\N
30166	1654	15408133999798	15940	8103	3	0	\N
30167	1654	15408133999798	16046	8160	4	0	\N
30169	1654	15408145999798	15940	8103	4	0	\N
30170	1654	15408146999798	16046	8160	5	0	\N
30172	1654	15408773999798	16721	8355	126	0	\N
30173	1654	15409463999798	16721	8355	127	0	\N
30174	1654	15840360000000	9552	4850	0	0	\N
30175	1654	15840360000000	9554	4863	0	0	\N
30176	1654	15840360000000	9555	4954	1	0	\N
30177	1654	15840360000000	9556	4877	0	0	\N
30178	1654	15840360000000	9557	4879	0	0	\N
30179	1654	15840360000000	9638	5002	2	0	\N
30180	1654	15840360000000	9862	5116	2	0	\N
30182	1654	15840370000000	9555	4954	2	0	\N
30183	1654	15840380000000	9638	5002	3	0	\N
30184	1654	15840380000000	9862	5116	3	0	\N
30186	1654	15977471999798	25139	12473	3	0	\N
30187	1654	15977471999798	25520	12635	3	0	\N
30188	1654	15977471999798	26187	12945	4	0	\N
30189	1654	15977471999798	26198	12950	5	0	\N
30191	1654	15977483999798	25139	12473	4	0	\N
30192	1654	15977483999798	25520	12635	4	0	\N
30069	1654	10800190000000	5308	2759	2	0	0
30074	1654	11520190000000	5924	3069	1	0	0
30075	1654	11520200000000	5924	3069	2	0	0
30085	1654	12240200000000	6649	3438	4	0	0
30089	1654	12240240000000	6649	3438	5	0	0
30101	1654	12960260000000	7409	3830	3	0	0
30115	1654	13680260000000	7659	3964	1	0	0
30117	1654	13680270000000	7659	3964	2	0	0
30130	1654	14400270000000	9079	4709	1	0	0
30136	1654	14400280000000	9079	4709	2	0	0
30158	1654	15120360000000	9257	4801	9	0	0
30181	1654	15840360000000	9993	5182	6	0	0
30185	1654	15840411000000	9993	5182	7	0	0
30066	1654	10367948000000	13360	6884	4	0	4
30072	1654	11087961000000	13419	6914	3	0	4
30073	1654	11087973000000	13419	6914	4	0	4
30080	1654	11807973000000	13469	6938	3	0	4
30081	1654	11807985000000	13469	6938	4	0	4
30092	1654	12527985000000	13536	6968	3	0	4
30108	1654	13247997000000	14199	7245	3	0	4
30109	1654	13248009000000	14199	7245	4	0	4
30122	1654	13968009000000	14679	7478	24	0	4
30124	1654	13968121999798	14679	7478	25	1	4
30151	1654	14688121999798	15758	8013	3	0	4
30168	1654	15408133999798	16720	8493	7	0	4
30171	1654	15408158999798	16720	8493	8	0	4
30063	1654	10217328999798	23658	11784	10	0	11
30065	1654	10217365999798	23658	11784	11	0	11
30071	1654	10937377999798	23675	11790	4	0	11
30076	1654	11657377999798	23792	11845	2	0	11
30078	1654	11657379999798	23792	11845	3	0	11
30090	1654	12377379999798	23868	11880	6	0	11
30091	1654	12377403999798	23868	11880	7	0	11
30105	1654	13097415999798	23991	11940	4	0	11
30119	1654	13817415999798	24093	11994	4	0	11
30120	1654	13817437999798	24093	11994	5	0	11
30144	1654	14537437999798	24501	12186	3	0	11
30145	1654	14537449999798	24501	12186	4	0	11
30162	1654	15257471999798	24806	12319	5	0	11
30190	1654	15977471999798	26469	13092	8	0	11
30193	1654	15977484999798	26187	12945	5	0	\N
30194	1654	15977485999798	26198	12950	6	0	\N
30196	1654	16125128999798	16863	8553	3	0	\N
30198	1654	16125140999798	16863	8553	4	0	\N
30200	1654	16560411000000	10037	5207	2	0	\N
30202	1654	16560431000000	10037	5207	3	0	\N
30204	1654	16697497999798	26532	13124	0	0	\N
30211	1654	17417497999798	26747	13125	18	0	\N
30212	1654	17417525999798	26747	13125	19	0	\N
30213	1654	17417533999798	26748	13230	3	0	\N
30215	1654	17417545999798	26748	13230	4	0	\N
30217	1654	17565164999798	17837	9007	6	0	\N
30220	1654	17565188999798	17837	9007	7	0	\N
30221	1654	17565487999798	18284	9187	31	0	\N
30224	1654	18137525999798	26823	13126	3	0	\N
30225	1654	18137537999798	26823	13126	4	0	\N
30228	1654	18285177999798	18060	9109	6	0	\N
30231	1654	18285210999798	18060	9109	7	0	\N
30232	1654	18285487999798	18284	9187	80	0	\N
30233	1654	18720481000000	10478	5412	2	0	\N
30236	1654	18720582000000	10478	5412	3	0	\N
30237	1654	18857582999798	27882	13626	31	0	\N
30240	1654	18857829999798	27882	13626	32	0	\N
30243	1654	19005571999790	18315	9188	56	0	\N
30244	1654	19006212999790	18315	9188	57	0	\N
30247	1654	19440582000000	10643	5413	30	0	\N
30248	1654	19440784000000	10643	5413	31	0	\N
30249	1654	19577594999798	28055	13872	3	0	\N
30250	1654	19577594999798	28421	14047	2	0	\N
30252	1654	19577605999798	28421	14047	3	0	\N
30253	1654	19577606999798	28055	13872	4	0	\N
30255	1654	19577829999798	28050	13627	8	0	\N
30256	1654	19577855999798	28050	13627	9	0	\N
30259	1654	20160523000000	10664	5507	2	0	\N
30260	1654	20160543000000	10664	5507	3	0	\N
30261	1654	20160784000000	10662	5414	0	0	\N
30266	1654	20880486001032	18284	9187	81	0	\N
30275	1654	22457708999798	28632	14138	2	0	\N
30276	1654	22457708999798	28722	14175	7	0	\N
30277	1654	22457708999798	28792	14205	5	0	\N
30279	1654	22457719999798	28632	14138	3	0	\N
30280	1654	22457731999798	28792	14205	6	0	\N
30282	1654	22457733999798	28722	14175	8	0	\N
30285	1654	22606752999798	20695	10325	27	0	\N
30286	1654	23177732999798	28891	14252	6	0	\N
30289	1654	23177756999798	28891	14252	7	0	\N
30290	1654	23325282999798	20697	10409	6	0	\N
30291	1654	23325282999798	21018	10568	2	0	\N
30292	1654	23325282999798	21603	10828	2	0	\N
30293	1654	23325282999798	21605	10828	3	0	\N
30295	1654	23325293999798	21018	10568	3	0	\N
30296	1654	23325293999798	21603	10828	3	0	\N
30297	1654	23325294999798	21605	10828	4	0	\N
30299	1654	23325654999798	20697	10409	7	0	\N
30300	1654	23326752999798	20695	10325	29	0	\N
30301	1654	23897744999798	29095	14344	4	0	\N
30303	1654	23897757999798	29095	14344	5	0	\N
30311	1654	26057814999798	29728	14656	6	0	\N
30313	1654	26057829999798	29728	14656	7	0	\N
30315	1654	66000007920000	20695	10325	30	1	\N
30316	1655	1000000	28569	13882	23	0	\N
30317	1655	1000000	30223	14735	101	1	\N
30318	1655	2000000	28626	13884	14	1	\N
30319	1655	25000000	10638	5495	2	0	\N
30320	1655	25000000	14508	7402	0	0	\N
30321	1655	205000000	27270	13432	41	1	\N
30322	1655	9436482908515	11951	5910	17	1	\N
30323	1655	10123723000000	26705	13209	12	1	\N
30324	1655	66000200000000	20836	10417	39	1	\N
30328	1656	2160030000000	121	72	1	0	\N
30327	1656	1440030000000	24	14	4	0	0
30201	1654	16560411000000	10255	5305	2	0	0
30203	1654	16560431000000	10255	5305	3	0	0
30209	1654	17280431000000	10359	5359	2	0	0
30210	1654	17280451000000	10359	5359	3	0	0
30223	1654	18000481000000	10439	5400	4	0	0
30234	1654	18720481000000	10479	5417	2	0	0
30235	1654	18720501000000	10479	5417	3	0	0
30245	1654	19440501000000	10644	5498	4	0	0
30246	1654	19440523000000	10644	5498	5	0	0
30199	1654	16125140999798	16886	8565	4	0	7
30207	1654	16845140999798	17626	8913	6	0	7
30208	1654	16845164999798	17626	8913	7	0	7
30218	1654	17565164999798	17957	9058	4	0	7
30229	1654	18285177999798	18283	9213	2	0	7
30230	1654	18285188999798	18283	9213	3	0	7
30241	1654	19005188999798	18314	9225	3	0	7
30242	1654	19005200999798	18314	9225	4	0	7
30257	1654	19725200999798	18863	9511	2	0	7
30264	1654	20445211999798	18915	9541	2	0	7
30265	1654	20445222999798	18915	9541	3	0	7
30269	1654	21165222999798	20155	10146	3	0	7
30270	1654	21165234999798	20155	10146	4	0	7
30273	1654	21885234999798	20191	10168	9	0	7
30283	1654	22605270999798	20390	10274	3	0	7
30284	1654	22605282999798	20390	10274	4	0	7
30294	1654	23325282999798	21990	10996	3	0	7
30298	1654	23325294999798	21990	10996	4	0	7
30306	1654	24045371999798	22031	11015	15	0	7
30195	1654	15977497999798	26469	13092	9	0	11
30205	1654	16697497999798	26533	13127	9	0	11
30206	1654	16697533999798	26533	13127	10	0	11
30214	1654	17417533999798	26827	13265	4	0	11
30226	1654	18137546999798	27352	13523	9	0	11
30227	1654	18137582999798	27352	13523	10	0	11
30238	1654	18857582999798	27883	13785	3	0	11
30239	1654	18857594999798	27883	13785	4	0	11
30251	1654	19577594999798	28424	14048	14	0	11
30262	1654	20297671999798	28503	14086	3	0	11
30263	1654	20297683999798	28503	14086	4	0	11
30267	1654	21017683999798	28563	14110	3	0	11
30268	1654	21017695999798	28563	14110	4	0	11
30272	1654	21737708999798	28592	14120	5	0	11
30278	1654	22457708999798	28850	14228	6	0	11
30281	1654	22457732999798	28850	14228	7	0	11
30287	1654	23177732999798	28910	14259	3	0	11
30288	1654	23177744999798	28910	14259	4	0	11
30304	1654	23897757999798	29253	14417	5	0	11
30307	1654	24617757999798	29286	14432	3	0	11
30308	1654	24617769999798	29286	14432	4	0	11
30309	1654	25337769999798	29618	14607	9	0	11
30310	1654	25337814999798	29618	14607	10	0	11
30314	1654	26057832999798	29729	14656	10	0	11
30329	1656	2160030000000	471	264	1	0	\N
30331	1656	2160040000000	121	72	2	0	\N
30332	1656	2160040000000	471	264	2	0	\N
30336	1656	3600051000000	701	390	1	0	\N
30338	1656	3600061000000	701	390	2	0	\N
30342	1656	4461274000000	11042	5683	2	0	\N
30344	1656	4461294000000	11042	5683	3	0	\N
30352	1656	5755295999990	21099	10597	3	0	\N
30353	1656	5755295999990	21206	10629	2	0	\N
30355	1656	5755298999990	21206	10629	3	0	\N
30357	1656	5755307999990	21099	10597	4	0	\N
30358	1656	5760081000000	1402	767	1	0	\N
30359	1656	5760081000000	1674	899	4	0	\N
30361	1656	5760091000000	1402	767	2	0	\N
30363	1656	5760121000000	1674	899	5	0	\N
30364	1656	5901318000000	11713	6024	0	0	\N
30368	1656	5901322000000	11819	6073	3	0	\N
30369	1656	6475306999990	21430	10748	3	0	\N
30370	1656	6475306999990	21615	10833	3	0	\N
30371	1656	6475306999990	21727	10883	2	0	\N
30373	1656	6475308999990	21727	10883	3	0	\N
30374	1656	6475318999990	21430	10748	4	0	\N
30375	1656	6475318999990	21615	10833	4	0	\N
30380	1656	6621322000000	11819	6073	4	0	\N
30385	1656	7341321999990	11845	6091	1	0	\N
30387	1656	7341322999990	11845	6091	2	0	\N
30389	1656	7632193152544	23248	11601	4	0	\N
30390	1656	7915378999990	22551	11283	6	0	\N
30391	1656	7915378999990	22620	11314	3	0	\N
30393	1656	7915390999990	22620	11314	4	0	\N
30395	1656	7915402999990	22551	11283	7	0	\N
30401	1656	8635401999990	22946	11466	3	0	\N
30402	1656	8635401999990	23187	11577	2	0	\N
30403	1656	8635401999990	23248	11601	2	0	\N
30404	1656	8635401999990	23251	11601	2	0	\N
30406	1656	8635412999990	23187	11577	3	0	\N
30407	1656	8635412999990	23251	11601	3	0	\N
30408	1656	8635413999990	22946	11466	4	0	\N
30419	1656	10075438999990	23670	11789	7	0	\N
30422	1656	10075463999990	23670	11789	8	0	\N
30437	1656	11661474999990	13878	7122	8	0	\N
30438	1656	11661474999990	13987	7167	4	0	\N
30441	1656	11661487999990	13987	7167	5	0	\N
30442	1656	11661500999990	13878	7122	9	0	\N
30445	1656	12235496999990	24917	12370	3	0	\N
30447	1656	12240291000000	4189	2181	2	0	\N
30450	1656	12240302000000	4189	2181	3	0	\N
30453	1656	12955484999990	24676	12256	4	0	\N
30454	1656	12955496999990	24917	12370	5	0	\N
30456	1656	12955497999990	24676	12256	5	0	\N
30457	1656	12955497999990	24917	12370	6	0	\N
30463	1656	13675497999990	25517	12634	3	0	\N
30464	1656	13675497999990	25601	12670	6	0	\N
30334	1656	2880041000000	618	347	1	0	0
30335	1656	2880051000000	618	347	2	0	0
30337	1656	3600051000000	849	470	1	0	0
30339	1656	3600061000000	849	470	2	0	0
30340	1656	4320061000000	949	529	1	0	0
30348	1656	5040071000000	998	551	1	0	0
30349	1656	5040081000000	998	551	2	0	0
30360	1656	5760081000000	1740	934	2	0	0
30362	1656	5760101000000	1740	934	3	0	0
30377	1656	6480101000000	2042	1078	1	0	0
30383	1656	7200111000000	2404	1257	1	0	0
30384	1656	7200121000000	2404	1257	2	0	0
30396	1656	7920121000000	2829	1478	8	0	0
30397	1656	7920201000000	2829	1478	9	0	0
30410	1656	8640211000000	2990	1554	4	0	0
30411	1656	8640231000000	2990	1554	5	0	0
30415	1656	9360231000000	3022	1569	1	0	0
30416	1656	9360241000000	3022	1569	2	0	0
30423	1656	10080241000000	3330	1728	2	0	0
30429	1656	10800261000000	3365	1750	2	0	0
30430	1656	10800281000000	3365	1750	3	0	0
30435	1656	11520281000000	3877	2014	1	0	0
30436	1656	11520291000000	3877	2014	2	0	0
30448	1656	12240291000000	4459	2311	1	0	0
30459	1656	12960301000000	4711	2436	1	0	0
30460	1656	12960311000000	4711	2436	2	0	0
30343	1656	4461274000000	11429	5870	5	0	4
30345	1656	4461306000000	11429	5870	6	0	4
30351	1656	5181318000000	11483	5902	4	0	4
30365	1656	5901318000000	11715	6024	1	0	4
30366	1656	5901319000000	11715	6024	2	0	4
30367	1656	5901322000000	11818	6073	3	0	4
30379	1656	6621321999990	11818	6073	4	0	4
30388	1656	7341324999990	12004	6178	4	0	4
30399	1656	8061324999990	12023	6187	2	0	4
30400	1656	8061326999990	12023	6187	3	0	4
30412	1656	8781326999990	12469	6425	0	0	4
30417	1656	9501326999990	12908	6653	2	0	4
30425	1656	10221337999990	12938	6668	2	0	4
30426	1656	10221348999990	12938	6668	3	0	4
30431	1656	10941348999990	13610	6997	9	0	4
30432	1656	10941474999990	13610	6997	10	0	4
30440	1656	11661485999990	14753	7512	3	0	4
30451	1656	12381485999990	14804	7543	2	0	4
30452	1656	12381496999990	14804	7543	3	0	4
30461	1656	13101496999990	15098	7693	1	0	4
30462	1656	13101497999990	15098	7693	2	0	4
30347	1656	5035295999990	21012	10565	4	0	8
30354	1656	5755295999990	21207	10648	2	0	8
30356	1656	5755306999990	21207	10648	3	0	8
30372	1656	6475306999990	22061	11031	10	0	8
30376	1656	6475343999990	22061	11031	11	0	8
30382	1656	7195378999990	22534	11274	9	0	8
30392	1656	7915378999990	22621	11314	5	0	8
30394	1656	7915401999990	22621	11314	6	0	8
30405	1656	8635401999990	23533	11731	3	0	8
30413	1656	9355413999990	23636	11775	7	0	8
30414	1656	9355438999990	23636	11775	8	0	8
30420	1656	10075438999990	23751	11829	3	0	8
30421	1656	10075450999990	23751	11829	4	0	8
30427	1656	10795450999990	24129	12011	2	0	8
30433	1656	11515461999990	24381	12125	3	0	8
30434	1656	11515473999990	24381	12125	4	0	8
30443	1656	12235473999990	24484	12174	2	0	8
30444	1656	12235484999990	24484	12174	3	0	8
30446	1656	12235496999990	24918	12370	3	0	8
30458	1656	12955497999990	24918	12370	6	0	8
30465	1656	13675497999990	25772	12746	3	0	\N
30466	1656	13675497999990	25929	12814	2	0	\N
30468	1656	13675497999990	26105	12902	2	0	\N
30469	1656	13675508999990	25929	12814	3	0	\N
30471	1656	13675508999990	26105	12902	3	0	\N
30472	1656	13675509999990	25517	12634	4	0	\N
30473	1656	13675509999990	25772	12746	4	0	\N
30474	1656	13675521999990	25601	12670	7	0	\N
30476	1656	13680311000000	5210	2661	0	0	\N
30477	1656	13680311000000	5211	2672	0	0	\N
30478	1656	13680311000000	5212	2682	0	0	\N
30483	1656	14400311000000	5213	2692	0	0	\N
30484	1656	14400311000000	5214	2703	0	0	\N
30489	1656	15115520999990	26555	13140	3	0	\N
30491	1656	15115532999990	26555	13140	4	0	\N
30495	1656	15261521999990	16034	8154	7	0	\N
30498	1656	15261544999990	17278	8752	2	0	\N
30499	1656	15261544999990	17279	8752	2	0	\N
30500	1656	15261546999990	16034	8154	8	0	\N
30503	1656	15840331000000	6178	3199	5	0	\N
30506	1656	15840381000000	6178	3199	6	0	\N
30507	1656	15981533999990	17174	8706	4	0	\N
30509	1656	15981544999990	17278	8752	4	0	\N
30510	1656	15981544999990	17279	8752	4	0	\N
30511	1656	15981545999990	17278	8752	5	0	\N
30512	1656	15981545999990	17279	8752	5	0	\N
30514	1656	15981546999990	17174	8706	5	0	\N
30515	1656	16555569999990	27257	13398	0	0	\N
30516	1656	16555569999990	27258	13477	3	0	\N
30517	1656	16555569999990	27260	13413	0	0	\N
30518	1656	16555569999990	27261	13426	0	0	\N
30519	1656	16555569999990	27262	13439	0	0	\N
30521	1656	16555581999990	27258	13477	4	0	\N
30523	1656	16560351000000	6561	3399	2	0	\N
30525	1656	16560371000000	6561	3399	3	0	\N
30529	1656	17275581999990	28182	13932	3	0	\N
30530	1656	17275581999990	28206	13945	2	0	\N
30532	1656	17275592999990	28206	13945	3	0	\N
30533	1656	17275593999990	28182	13932	4	0	\N
30535	1656	17280371000000	7148	3694	2	0	\N
30536	1656	17280371000000	7269	3758	1	0	\N
30538	1656	17280381000000	7269	3758	2	0	\N
30540	1656	17280481000000	7148	3694	3	0	\N
30548	1656	18715872499990	28807	14210	3	0	\N
30549	1656	18715872499990	28836	14224	3	0	\N
30550	1656	18715872499990	29025	14314	5	0	\N
30552	1656	18715884499990	28807	14210	4	0	\N
30553	1656	18715884499990	28836	14224	4	0	\N
30554	1656	18715895499990	29025	14314	6	0	\N
30556	1656	18720401000000	8128	4214	0	0	\N
30557	1656	18720401000000	8129	4214	1	0	\N
30559	1656	18720411000000	8129	4214	2	0	\N
30563	1656	19435895499990	29228	14403	5	0	\N
30564	1656	19435895499990	29284	14431	3	0	\N
30566	1656	19435907499990	29284	14431	4	0	\N
30568	1656	19435918499990	29228	14403	6	0	\N
30572	1656	19581681999990	18694	9417	4	0	\N
30574	1656	19581703999990	18694	9417	5	0	\N
30575	1656	20155908499990	29668	14634	9	0	\N
30576	1656	20155908499990	29669	14634	9	0	\N
30577	1656	20155908499990	29793	14681	12	0	\N
30578	1656	20155908499990	29993	14769	7	0	\N
30580	1656	20155924499990	29993	14769	8	0	\N
30581	1656	20155926499990	29668	14634	10	0	\N
30582	1656	20155926499990	29669	14634	10	0	\N
30584	1656	20155929499990	29793	14681	13	0	\N
30585	1656	20160421000000	8350	4325	3	0	\N
30587	1656	20160442000000	8350	4325	4	0	\N
30588	1656	20301703999990	18769	9459	2	0	\N
30589	1656	20301703999990	18813	9480	5	0	\N
30591	1656	20301714999990	18769	9459	3	0	\N
30593	1656	20301735999990	18813	9480	6	0	\N
30594	1656	20880421000000	8494	4400	1	0	\N
30596	1656	20880431000000	8494	4400	2	0	\N
30486	1656	14400321000000	5828	3023	2	0	0
30493	1656	15120321000000	6168	3194	1	0	0
30494	1656	15120331000000	6168	3194	2	0	0
30504	1656	15840331000000	6484	3360	2	0	0
30505	1656	15840351000000	6484	3360	3	0	0
30526	1656	16560371000000	6668	3446	3	0	0
30537	1656	17280371000000	7287	3767	2	0	0
30539	1656	17280391000000	7287	3767	3	0	0
30545	1656	18000391000000	7479	3868	1	0	0
30546	1656	18000401000000	7479	3868	2	0	0
30560	1656	18720411000000	8136	4219	2	0	0
30569	1656	19440411000000	8179	4237	1	0	0
30570	1656	19440421000000	8179	4237	2	0	0
30586	1656	20160421000000	8436	4373	0	0	0
30597	1656	20880441000000	8823	4575	3	0	0
30600	1656	21600441000000	8924	4625	2	0	0
30479	1656	13821497999990	15263	7775	3	0	4
30480	1656	13821509999990	15263	7775	4	0	4
30487	1656	14541509999990	16022	8147	3	0	4
30496	1656	15261521999990	16892	8567	3	0	4
30497	1656	15261533999990	16892	8567	4	0	4
30508	1656	15981533999990	17377	8801	3	0	4
30513	1656	15981545999990	17377	8801	4	0	4
30527	1656	16701545999990	17436	8832	3	0	4
30541	1656	17421656999990	17514	8868	3	0	4
30542	1656	17421668999990	17514	8868	4	0	4
30547	1656	18141668999990	17832	9005	0	0	4
30561	1656	18861668999990	18493	9314	4	0	4
30571	1656	19581681999990	18693	9417	4	0	4
30573	1656	19581703999990	18693	9417	5	0	4
30590	1656	20301703999990	19421	9788	7	0	4
30592	1656	20301728999990	19421	9788	8	0	4
30598	1656	21021728999990	19837	9994	3	0	4
30467	1656	13675497999990	26104	12902	2	0	8
30470	1656	13675508999990	26104	12902	3	0	8
30481	1656	14395508999990	26460	13088	3	0	8
30482	1656	14395520999990	26460	13088	4	0	8
30490	1656	15115520999990	26604	13162	10	0	8
30501	1656	15835557999990	26994	13351	3	0	8
30502	1656	15835569999990	26994	13351	4	0	8
30520	1656	16555569999990	28101	13891	3	0	8
30522	1656	16555581999990	28101	13891	4	0	8
30534	1656	17275609499990	28444	14058	6	0	8
30543	1656	17995609499990	28523	14093	5	0	8
30544	1656	17995872499990	28523	14093	6	0	8
30551	1656	18715872499990	29027	14314	5	0	8
30555	1656	18715895499990	29027	14314	6	0	8
30567	1656	19435908499990	29502	14548	5	0	8
30579	1656	20155908499990	29994	14769	9	0	8
30583	1656	20155926499990	29994	14769	10	0	8
30602	1656	21741740999990	20227	10184	6	0	\N
30605	1656	21741764999990	20227	10184	7	0	\N
30615	1656	24480643000000	9808	5085	4	0	\N
30616	1656	24480643000000	10005	5187	5	0	\N
30617	1656	24480665000000	9808	5085	5	0	\N
30618	1656	24480693000000	10005	5187	6	0	\N
30623	1656	25920733000000	10232	5296	3	0	\N
30624	1656	25920733000000	10503	5427	2	0	\N
30626	1656	25920753000000	10503	5427	3	0	\N
30628	1656	25920853000000	10232	5296	4	0	\N
30633	1657	2160040000000	535	304	1	0	\N
30634	1657	2160040000000	800	443	1	0	\N
30635	1657	2160040000000	926	516	1	0	\N
30636	1657	2160040000000	1174	647	2	0	\N
30638	1657	2160050000000	535	304	2	0	\N
30639	1657	2160050000000	800	443	2	0	\N
30640	1657	2160050000000	926	516	2	0	\N
30642	1657	2160060000000	1174	647	3	0	\N
30649	1657	3600070000000	1412	770	3	0	\N
30652	1657	3600100000000	1412	770	4	0	\N
30655	1657	4320080000000	1994	1054	1	0	\N
30657	1657	4320090000000	1994	1054	2	0	\N
30661	1657	4322145990100	23993	11894	118	0	\N
30662	1657	5040090000000	2436	1275	3	0	\N
30663	1657	5040090000000	2723	1431	2	0	\N
30664	1657	5040090000000	3027	1572	1	0	\N
30665	1657	5040090000000	3923	2036	2	0	\N
30667	1657	5040100000000	3027	1572	2	0	\N
30669	1657	5040110000000	2723	1431	3	0	\N
30670	1657	5040110000000	3923	2036	3	0	\N
30671	1657	5040120000000	2436	1275	4	0	\N
30672	1657	5041253990100	23990	11940	3	0	\N
30673	1657	5041253990100	24062	11975	2	0	\N
30674	1657	5041253990100	24146	11966	0	0	\N
30675	1657	5041253990100	24149	11978	0	0	\N
30676	1657	5041253990100	24225	12057	4	0	\N
30678	1657	5041264990100	24062	11975	3	0	\N
30679	1657	5041265990100	23990	11940	4	0	\N
30681	1657	5041266990100	24225	12057	5	0	\N
30682	1657	5042145990100	23993	11894	126	0	\N
30683	1657	5042152990100	23993	11894	127	0	\N
30684	1657	5042720990100	24063	11895	118	0	\N
30685	1657	5760100000000	4114	2138	1	0	\N
30687	1657	5760110000000	4114	2138	2	0	\N
30689	1657	5761265990100	24519	12193	2	0	\N
30690	1657	5761265990100	25004	12404	3	0	\N
30691	1657	5761265990100	25234	12516	5	0	\N
30692	1657	5761265990100	25255	12527	4	0	\N
30694	1657	5761276990100	24519	12193	3	0	\N
30695	1657	5761277990100	25004	12404	4	0	\N
30696	1657	5761278990100	25255	12527	5	0	\N
30697	1657	5761279990100	25234	12516	6	0	\N
30699	1657	5762720990100	24063	11895	126	0	\N
30700	1657	5762727990100	24063	11895	127	0	\N
30701	1657	6480110000000	4886	2531	2	0	\N
30702	1657	6480110000000	5022	2608	2	0	\N
30703	1657	6480110000000	5521	2872	0	0	\N
30706	1657	6480130000000	4886	2531	3	0	\N
30707	1657	6480220000000	5022	2608	3	0	\N
30708	1657	6481290990100	25735	12733	6	0	\N
30710	1657	6481314990100	25735	12733	7	0	\N
30712	1657	6482727990100	24148	11896	52	0	\N
30713	1657	6483247990100	24148	11896	53	0	\N
30714	1657	7200120000000	5921	3068	1	0	\N
30715	1657	7200120000000	6092	3162	3	0	\N
30716	1657	7200120000000	6175	3197	4	0	\N
30718	1657	7200130000000	5921	3068	2	0	\N
30720	1657	7200150000000	6092	3162	4	0	\N
30721	1657	7200160000000	6175	3197	5	0	\N
30722	1657	7201282000000	12807	6604	3	0	\N
30723	1657	7201282000000	12845	6624	2	0	\N
30724	1657	7201282000000	13083	6741	4	0	\N
30726	1657	7201293000000	12845	6624	3	0	\N
30728	1657	7201295000000	13083	6741	5	0	\N
30729	1657	7201303000000	12807	6604	4	0	\N
30734	1657	7921294000000	13201	6802	6	0	\N
30631	1657	1440030000000	351	201	1	0	0
30632	1657	1440040000000	351	201	2	0	0
30637	1657	2160040000000	1291	713	1	0	0
30641	1657	2160050000000	1291	713	2	0	0
30645	1657	2880050000000	1397	764	2	0	0
30650	1657	3600070000000	1916	1021	1	0	0
30651	1657	3600080000000	1916	1021	2	0	0
30656	1657	4320080000000	2368	1237	1	0	0
30658	1657	4320090000000	2368	1237	2	0	0
30666	1657	5040090000000	4031	2093	1	0	0
30686	1657	5760100000000	4505	2332	1	0	0
30688	1657	5760110000000	4505	2332	2	0	0
30704	1657	6480110000000	5802	3010	1	0	0
30705	1657	6480120000000	5802	3010	2	0	0
30719	1657	7200130000000	6233	3225	2	0	0
30732	1657	7920130000000	6250	3233	2	0	0
30733	1657	7920150000000	6250	3233	3	0	0
30601	1656	21600461000000	8924	4625	3	0	0
30606	1656	22320461000000	9475	4913	4	0	0
30610	1656	23040501000000	9565	4960	3	0	0
30611	1656	23040522000000	9565	4960	4	0	0
30612	1656	23760522000000	9733	5043	13	0	0
30613	1656	23760643000000	9733	5043	14	0	0
30614	1656	23760703000000	10007	5187	6	0	0
30620	1656	24480713000000	10007	5187	18	0	0
30621	1656	25200713000000	10215	5289	2	0	0
30622	1656	25200733000000	10215	5289	3	0	0
30625	1656	25920733000000	10614	5482	3	0	0
30725	1657	7201282000000	13093	6747	3	0	6
30727	1657	7201294000000	13093	6747	4	0	6
30735	1657	7921294000000	14546	7420	4	0	6
30736	1657	7921316000000	14546	7420	5	0	6
30603	1656	21741740999990	20495	10321	2	0	4
30608	1656	22461751999990	20612	10367	3	0	4
30609	1656	22461763999990	20612	10367	4	0	4
30643	1657	2161167990100	22517	11263	6	0	11
30644	1657	2161218990100	22517	11263	7	0	11
30647	1657	2881218990100	22828	11416	3	0	11
30653	1657	3601230990100	23242	11598	2	0	11
30654	1657	3601241990100	23242	11598	3	0	11
30659	1657	4321241990100	23707	11807	3	0	11
30660	1657	4321253990100	23707	11807	4	0	11
30680	1657	5041265990100	24301	12086	4	0	11
30693	1657	5761265990100	25269	12535	7	0	11
30698	1657	5761290990100	25269	12535	8	0	11
30709	1657	6481290990100	25879	12790	6	0	11
30711	1657	6481323990100	25879	12790	7	0	11
30731	1657	7201334990100	26021	12860	3	0	11
30737	1657	7921318000000	13201	6802	7	0	\N
30738	1657	7921334990100	26136	12919	2	0	\N
30739	1657	7921334990100	26144	12923	2	0	\N
30741	1657	7921345990100	26136	12919	3	0	\N
30742	1657	7921345990100	26144	12923	3	0	\N
30750	1657	9360160000000	6472	3355	2	0	\N
30751	1657	9360160000000	6562	3399	2	0	\N
30753	1657	9360180000000	6472	3355	3	0	\N
30754	1657	9360180000000	6562	3399	3	0	\N
30758	1657	9361396990100	27307	13498	3	0	\N
30760	1657	9361408990100	27307	13498	4	0	\N
30762	1657	10080180000000	7328	3788	1	0	\N
30764	1657	10080190000000	7328	3788	2	0	\N
30766	1657	10081339000000	15857	8065	3	0	\N
30768	1657	10081351000000	15857	8065	4	0	\N
30770	1657	10081408990100	27699	13687	6	0	\N
30771	1657	10081408990100	28070	13880	4	0	\N
30773	1657	10081430990100	28070	13880	5	0	\N
30775	1657	10081441990100	27699	13687	7	0	\N
30780	1657	10801432990100	28131	13905	2	0	\N
30782	1657	10801434990100	28131	13905	3	0	\N
30786	1657	11521364000000	16593	8432	3	0	\N
30788	1657	11521376000000	16593	8432	4	0	\N
30792	1657	12240210000000	7788	4038	1	0	\N
30794	1657	12240220000000	7788	4038	2	0	\N
30800	1657	12960220000000	8075	4186	4	0	\N
30802	1657	12960220000000	8153	4201	44	0	\N
30804	1657	12960242000000	8075	4186	5	0	\N
30805	1657	12960831000000	8153	4201	45	0	\N
30806	1657	12961399000000	17201	8717	3	0	\N
30807	1657	12961399000000	17657	8926	2	0	\N
30809	1657	12961410000000	17657	8926	3	0	\N
30810	1657	12961411000000	17201	8717	4	0	\N
30816	1657	13680831000000	8162	4202	4	0	\N
30817	1657	13680871000000	8162	4202	5	0	\N
30818	1657	13681412000000	17887	9027	6	0	\N
30821	1657	13681436000000	17887	9027	7	0	\N
30822	1657	13681503990100	29310	14443	3	0	\N
30823	1657	13681503990100	30061	14800	9	0	\N
30825	1657	13681515990100	29310	14443	4	0	\N
30826	1657	13681539990100	30061	14800	10	0	\N
30828	1657	14400240000000	8251	4273	1	0	\N
30830	1657	14400250000000	8251	4273	2	0	\N
30834	1657	14401562990100	30088	14814	9	0	\N
30835	1657	14401562990100	30089	14814	5	0	\N
30836	1657	14401562990100	30153	14837	49	0	\N
30837	1657	14401576990100	30089	14814	6	0	\N
30838	1657	14401580990100	30088	14814	10	0	\N
30839	1657	14401656966095	30153	14837	50	1	\N
30843	1657	15121446000000	18006	9083	6	0	\N
30846	1657	15840290000000	9021	4677	1	0	\N
30847	1657	15840300000000	9021	4677	2	0	\N
30849	1657	15841469990100	18836	9494	1	0	\N
30851	1657	15841479990100	18836	9494	2	0	\N
30855	1657	16561493990100	20533	10336	5	0	\N
30858	1657	16561545990100	20533	10336	6	0	\N
30860	1657	17280320000000	9905	5135	4	0	\N
30862	1657	17280360000000	9905	5135	5	0	\N
30865	1657	17281596990100	21416	10740	8	0	\N
30866	1657	17281605990100	21417	10740	8	0	\N
30869	1657	18001532990100	21730	10885	0	0	\N
30870	1657	18001596890100	21416	10740	12	0	\N
30871	1657	18001605990100	21417	10740	13	0	\N
30872	1657	18001609990100	21417	10740	14	0	\N
30752	1657	9360160000000	6710	3471	2	0	0
30755	1657	9360180000000	6710	3471	3	0	0
30763	1657	10080180000000	7377	3809	1	0	0
30765	1657	10080190000000	7377	3809	2	0	0
30776	1657	10800190000000	7687	3982	1	0	0
30784	1657	11520200000000	7726	4002	1	0	0
30785	1657	11520210000000	7726	4002	2	0	0
30793	1657	12240210000000	8055	4173	1	0	0
30795	1657	12240220000000	8055	4173	2	0	0
30801	1657	12960220000000	8152	4226	1	0	0
30814	1657	13680230000000	8161	4230	1	0	0
30815	1657	13680240000000	8161	4230	2	0	0
30829	1657	14400240000000	8683	4500	1	0	0
30831	1657	14400250000000	8683	4500	2	0	0
30841	1657	15120290000000	8739	4534	5	0	0
30845	1657	15840290000000	9020	4677	2	0	0
30848	1657	15840310000000	9020	4677	3	0	0
30853	1657	16560310000000	9553	4954	1	0	0
30854	1657	16560320000000	9553	4954	2	0	0
30861	1657	17280340000000	9904	5136	3	0	0
30867	1657	18000340000000	10071	5222	14	0	0
30868	1657	18000552000000	10071	5222	15	0	0
30746	1657	8641316000000	14719	7494	2	0	6
30747	1657	8641327000000	14719	7494	3	0	6
30757	1657	9361339000000	15114	7702	4	0	6
30767	1657	10081339000000	16198	8233	3	0	6
30769	1657	10081351000000	16198	8233	4	0	6
30778	1657	10801351000000	16391	8338	4	0	6
30787	1657	11521364000000	16612	8438	3	0	6
30789	1657	11521376000000	16612	8438	4	0	6
30796	1657	12241376000000	17097	8663	5	0	6
30797	1657	12241399000000	17097	8663	6	0	6
30808	1657	12961399000000	17853	9011	4	0	6
30819	1657	13681412000000	17888	9027	4	0	6
30820	1657	13681434000000	17888	9027	5	0	6
30832	1657	14401434000000	17950	9054	3	0	6
30833	1657	14401446000000	17950	9054	4	0	6
30842	1657	15121446000000	18005	9083	6	0	6
30850	1657	15841469990100	19853	10001	6	0	6
30852	1657	15841493990100	19853	10001	7	0	6
30856	1657	16561493990100	20621	10373	5	0	6
30857	1657	16561498990100	20621	10373	6	0	6
30864	1657	17281532990100	20957	10541	8	0	6
30740	1657	7921334990100	26458	13087	7	0	11
30743	1657	7921359990100	26458	13087	8	0	11
30748	1657	8641359990100	26883	13294	10	0	11
30749	1657	8641396990100	26883	13294	11	0	11
30761	1657	9361408990100	27658	13668	4	0	11
30772	1657	10081408990100	28071	13880	6	0	11
30774	1657	10081432990100	28071	13880	7	0	11
30781	1657	10801432990100	28132	13905	3	0	11
30783	1657	10801444990100	28132	13905	4	0	11
30791	1657	11521467990100	28150	13918	6	0	11
30798	1657	12241467990100	28153	13921	2	0	11
30799	1657	12241478990100	28153	13921	3	0	11
30812	1657	12961478990100	28614	14129	7	0	11
30824	1657	13681503990100	30062	14800	32	0	11
30827	1657	13681562990100	30062	14800	33	0	11
30877	1657	20161062000000	10651	5501	4	0	\N
30878	1657	20161062000000	10749	5548	3	0	\N
30880	1657	20161092000000	10749	5548	4	0	\N
30881	1657	20161102000000	10651	5501	5	0	\N
30883	1657	20161890000000	11441	5831	93	0	\N
30884	1657	20881212000000	11100	5697	10	0	\N
30885	1657	20881212000000	11102	5711	9	0	\N
30888	1657	20881302000000	11102	5711	10	0	\N
30889	1657	20881312000000	11100	5697	11	0	\N
30890	1657	20881890000000	11441	5831	126	0	\N
30891	1657	20881931000000	11441	5831	127	0	\N
30892	1657	21601234000000	11497	5906	2	0	\N
30894	1657	21601245000000	11497	5906	3	0	\N
30896	1657	21601931000000	11498	5832	89	0	\N
30897	1657	21602409000000	11498	5832	90	0	\N
30900	1657	23041247000000	12442	6414	0	0	\N
30903	1657	66000001100200	18006	9083	7	1	\N
30911	1660	1914030000000	17539	8882	3	0	0
30912	1662	720000000000	1658	893	1	0	\N
30914	1662	720010000000	1658	893	2	0	\N
30916	1662	1440020000000	17840	8894	0	0	\N
30919	1662	2160032000000	27510	13601	3	0	\N
30921	1662	2160044000000	27510	13601	4	0	\N
30924	1663	720000000000	7129	3684	2	0	\N
30926	1663	720020000000	7129	3684	3	0	\N
30927	1663	1440020000000	19833	9991	3	0	\N
30928	1663	1440032000000	19833	9991	4	0	\N
30930	1664	720010000000	29571	14580	3	0	\N
30931	1664	720022000000	29571	14580	4	0	\N
30934	1666	720000000000	3960	2059	1	0	\N
30936	1666	720010000000	3960	2059	2	0	\N
30938	1666	1440011000000	21877	10946	3	0	\N
30939	1666	1440011000000	26773	13240	6	0	\N
30940	1666	1440023000000	21877	10946	4	0	\N
30941	1666	1440035000000	26773	13240	7	0	\N
30942	1667	10000000	1552	846	0	0	\N
30943	1667	10000000	1594	785	89	0	\N
30944	1667	720000000000	6674	3310	16	0	\N
30945	1667	720160000000	6674	3310	17	0	\N
30946	1668	202100000	26665	13190	9	1	\N
30953	1668	2846441000000	10058	5217	2	0	\N
30956	1668	2846461000000	10058	5217	3	0	\N
30963	1668	3600040000000	795	441	1	0	\N
30964	1668	3600040000000	980	544	1	0	\N
30966	1668	3600050000000	795	441	2	0	\N
30967	1668	3600050000000	980	544	2	0	\N
30969	1668	4113479000000	20483	10315	5	0	\N
30970	1668	4113479000000	20897	10505	3	0	\N
30972	1668	4113491000000	20897	10505	4	0	\N
30973	1668	4113502000000	20483	10315	6	0	\N
30975	1668	4286471000000	10772	5560	4	0	\N
30977	1668	4286511000000	10772	5560	5	0	\N
30979	1668	4320050000000	1597	866	1	0	\N
30981	1668	4320060000000	1597	866	2	0	\N
30983	1668	4833502000000	21255	10673	2	0	\N
30985	1668	4833513000000	21255	10673	3	0	\N
30987	1668	5006511000000	10819	5583	2	0	\N
30988	1668	5006511000000	11318	5812	2	0	\N
30991	1668	5006522000000	11318	5812	3	0	\N
30992	1668	5006531000000	10819	5583	3	0	\N
30993	1668	5040060000000	2305	1083	0	0	\N
30995	1668	5040060000000	2307	1094	0	0	\N
30996	1668	5040060000000	2309	1106	0	0	\N
30997	1668	5040060000000	2310	1118	0	0	\N
30999	1668	5553513000000	21854	10937	9	0	\N
31002	1668	5553549000000	21854	10937	10	0	\N
31005	1668	5760070000000	2327	1219	2	0	\N
31008	1668	5760090000000	2327	1219	3	0	\N
30949	1668	1440010000000	221	131	1	0	0
30950	1668	1440020000000	221	131	2	0	0
30951	1668	2160020000000	667	371	1	0	0
30952	1668	2160030000000	667	371	2	0	0
30957	1668	2880030000000	744	418	1	0	0
30965	1668	3600040000000	1102	610	1	0	0
30968	1668	3600050000000	1102	610	2	0	0
30980	1668	4320050000000	1986	1050	1	0	0
30982	1668	4320060000000	1986	1050	2	0	0
30994	1668	5040060000000	2306	1209	1	0	0
31006	1668	5760070000000	2429	1272	1	0	0
31007	1668	5760080000000	2429	1272	2	0	0
30932	1665	720000000000	4618	2391	1	0	0
30933	1665	720010000000	4618	2391	2	0	0
30915	1662	720020000000	6049	3143	3	0	0
30923	1663	720000000000	7128	3684	2	0	0
30925	1663	720020000000	7128	3684	3	0	0
30954	1668	2846441000000	10059	5217	1	0	5
30955	1668	2846451000000	10059	5217	2	0	5
30909	1660	720030000000	10117	5249	4	0	0
30961	1668	3566451000000	10341	5353	2	0	5
30962	1668	3566471000000	10341	5353	3	0	5
30873	1657	18720552000000	10378	5366	6	0	0
30874	1657	18721012000000	10378	5366	7	0	0
30876	1657	19441062000000	10440	5401	6	0	0
30976	1668	4286471000000	10773	5560	4	0	5
30978	1668	4286511000000	10773	5560	5	0	5
30879	1657	20161062000000	10903	5623	11	0	0
30886	1657	20881212000000	11442	5878	4	0	0
30887	1657	20881234000000	11442	5878	5	0	0
30989	1668	5006511000000	11627	5985	1	0	5
30990	1668	5006512000000	11627	5985	2	0	5
31003	1668	5726512000000	11712	6023	1	0	5
30893	1657	21601234000000	11873	6102	3	0	0
30895	1657	21601246000000	11873	6102	4	0	0
30898	1657	22321246000000	11935	6143	1	0	0
30899	1657	22321247000000	11935	6143	2	0	0
30901	1657	23041247000000	12608	6503	2	0	0
30935	1666	720000000000	12897	6647	2	0	0
30937	1666	720011000000	12897	6647	3	0	0
30904	1659	720000000000	20125	10132	8	0	0
30906	1659	720083999990	20125	10132	10	1	0
30960	1668	3393479000000	20229	10185	5	0	9
30971	1668	4113479000000	20906	10508	5	0	9
30974	1668	4113502000000	20906	10508	6	0	9
30984	1668	4833502000000	21256	10673	2	0	9
30986	1668	4833513000000	21256	10673	3	0	9
31000	1668	5553513000000	22627	11317	6	0	9
31001	1668	5553537000000	22627	11317	7	0	9
30917	1662	1440020000000	27365	13531	3	0	0
30918	1662	1440032000000	27365	13531	4	0	0
30920	1662	2160032000000	28209	13947	3	0	0
30905	1659	720082999990	29010	14305	4	0	1
30907	1659	720095999990	29010	14305	5	0	1
31009	1668	6273537000000	22935	11461	4	0	\N
31010	1668	6273537000000	23557	11741	6	0	\N
31011	1668	6273537000000	23754	11830	3	0	\N
31013	1668	6273549000000	23754	11830	4	0	\N
31015	1668	6273550000000	22935	11461	5	0	\N
31016	1668	6273552000000	23557	11741	7	0	\N
31017	1668	6273570000000	24305	12087	3	0	\N
31018	1668	6273570000000	24306	12087	3	0	\N
31019	1668	6273570000000	24308	12087	3	0	\N
31020	1668	6446513000000	11781	6057	1	0	\N
31022	1668	6446514000000	11781	6057	2	0	\N
31027	1668	6993549000000	24674	11973	0	0	\N
31028	1668	6993570000000	24305	12087	8	0	\N
31029	1668	6993570000000	24306	12087	8	0	\N
31030	1668	6993570000000	24308	12087	8	0	\N
31031	1668	6993574000000	24305	12087	9	0	\N
31032	1668	6993574000000	24308	12087	9	0	\N
31034	1668	7166514000000	12183	6273	1	0	\N
31036	1668	7166515000000	12183	6273	2	0	\N
31047	1668	8433596000000	24589	12223	2	0	\N
31049	1668	8433607000000	24589	12223	3	0	\N
31054	1668	9153596000000	24509	12190	2	0	\N
31055	1668	9153607000000	24509	12190	3	0	\N
31060	1668	9360120000000	3097	1607	3	0	\N
31061	1668	9360120000000	3486	1810	0	0	\N
31062	1668	9360120000000	3506	1820	0	0	\N
31065	1668	9360150000000	3097	1607	4	0	\N
31070	1668	10080130000000	3733	1936	1	0	\N
31072	1668	10080140000000	3733	1936	2	0	\N
31084	1668	11520180000000	4008	2081	1	0	\N
31086	1668	11520190000000	4008	2081	2	0	\N
31090	1668	12033767000000	26665	13190	2	0	\N
31091	1668	12033767000000	26666	13190	2	0	\N
31092	1668	12033767000000	26667	13190	2	0	\N
31099	1668	12753767000000	26665	13190	8	0	\N
31100	1668	12753767000000	26666	13190	8	0	\N
31101	1668	12753767000000	26667	13190	8	0	\N
31102	1668	12753772000000	26666	13190	9	0	\N
31103	1668	12753772000000	26667	13190	9	0	\N
31108	1668	13473759000000	26808	13258	3	0	\N
31109	1668	13473759000000	26871	13290	3	0	\N
31110	1668	13473759000000	27147	13423	3	0	\N
31112	1668	13473771000000	26808	13258	4	0	\N
31113	1668	13473771000000	26871	13290	4	0	\N
31114	1668	13473771000000	27147	13423	4	0	\N
31116	1668	13646666000000	15142	7719	1	0	\N
31117	1668	13646666000000	15408	7849	4	0	\N
31118	1668	13646666000000	15452	7870	7	0	\N
31119	1668	13646666000000	15454	7870	7	0	\N
31120	1668	13646666000000	15455	7870	7	0	\N
31122	1668	13646676000000	15142	7719	2	0	\N
31124	1668	13646697000000	15408	7849	5	0	\N
31125	1668	13646700000000	15452	7870	8	0	\N
31126	1668	13646700000000	15454	7870	8	0	\N
31127	1668	13646700000000	15455	7870	8	0	\N
31130	1668	14193783000000	27659	13668	3	0	\N
31132	1668	14193795000000	27659	13668	4	0	\N
31142	1668	15120250000000	4986	2584	3	0	\N
31143	1668	15120250000000	5140	2663	2	0	\N
31038	1668	7200090000000	2943	1530	1	0	0
31039	1668	7200100000000	2943	1530	2	0	0
31044	1668	7920100000000	2980	1549	1	0	0
31045	1668	7920110000000	2980	1549	2	0	0
31052	1668	8640110000000	2994	1556	1	0	0
31063	1668	9360120000000	3644	1891	1	0	0
31064	1668	9360130000000	3644	1891	2	0	0
31071	1668	10080130000000	3856	2002	4	0	0
31073	1668	10080170000000	3856	2002	5	0	0
31078	1668	10800170000000	3893	2021	1	0	0
31085	1668	11520180000000	4115	2138	1	0	0
31087	1668	11520190000000	4115	2138	2	0	0
31095	1668	12240190000000	4175	2173	1	0	0
31096	1668	12240200000000	4175	2173	2	0	0
31107	1668	12960230000000	4284	2222	4	0	0
31128	1668	13680230000000	4352	2255	1	0	0
31129	1668	13680240000000	4352	2255	2	0	0
31136	1668	14400240000000	4831	2503	1	0	0
31137	1668	14400250000000	4831	2503	2	0	0
31021	1668	6446513000000	11812	6070	1	0	5
31023	1668	6446514000000	11812	6070	2	0	5
31035	1668	7166514000000	12572	6479	2	0	5
31037	1668	7166525000000	12572	6479	3	0	5
31042	1668	7886525000000	12905	6651	2	0	5
31050	1668	8606536000000	12980	6693	2	0	5
31051	1668	8606547000000	12980	6693	3	0	5
31058	1668	9326547000000	13338	6874	4	0	5
31059	1668	9326560000000	13338	6874	5	0	5
31069	1668	10046596000000	13577	6982	10	0	5
31076	1668	10766596000000	13803	7088	4	0	5
31077	1668	10766609000000	13803	7088	5	0	5
31082	1668	11486609000000	14168	7232	6	0	5
31083	1668	11486633000000	14168	7232	7	0	5
31094	1668	12206655000000	14770	7522	5	0	5
31104	1668	12926655000000	14792	7535	2	0	5
31105	1668	12926666000000	14792	7535	3	0	5
31121	1668	13646666000000	15732	8000	8	0	5
31123	1668	13646692000000	15732	8000	9	0	5
31135	1668	14366705000000	15793	8035	5	0	5
31140	1668	15086705000000	15892	8079	4	0	5
31141	1668	15086718000000	15892	8079	5	0	5
31012	1668	6273537000000	23931	11910	3	0	9
31026	1668	6993549000000	24346	12108	7	0	9
31033	1668	6993574000000	24346	12108	8	0	9
31040	1668	7713574000000	24489	12179	4	0	9
31041	1668	7713596000000	24489	12179	5	0	9
31046	1668	8433596000000	24588	12223	2	0	9
31056	1668	9153607000000	24673	12254	12	0	9
31057	1668	9153646000000	24673	12254	13	0	9
31066	1668	9873646000000	24803	12318	6	0	9
31067	1668	9873688000000	24803	12318	7	0	9
31074	1668	10593688000000	25523	12636	7	0	9
31080	1668	11313722000000	25534	12641	3	0	9
31081	1668	11313734000000	25534	12641	4	0	9
31088	1668	12033734000000	25808	12761	4	0	9
31089	1668	12033747000000	25808	12761	5	0	9
31098	1668	12753759000000	26730	13222	4	0	9
31111	1668	13473759000000	27314	13502	6	0	9
31115	1668	13473783000000	27314	13502	7	0	9
31131	1668	14193783000000	27902	13797	3	0	9
31133	1668	14193795000000	27902	13797	4	0	9
31139	1668	14913807000000	28012	13853	4	0	9
31146	1668	15120280000000	4986	2584	4	0	\N
31147	1668	15120360000000	5140	2663	3	0	\N
31148	1668	15633807000000	28085	13885	6	0	\N
31150	1668	15633831000000	28085	13885	7	0	\N
31154	1668	15840260000000	6523	3380	2	0	\N
31156	1668	15840280000000	6523	3380	3	0	\N
31160	1668	16526731000000	16516	8401	3	0	\N
31163	1668	16526743000000	16516	8401	4	0	\N
31166	1668	17073846500000	28292	13986	2	0	\N
31168	1668	17073857500000	28292	13986	3	0	\N
31170	1668	17246742000000	16674	8470	7	0	\N
31173	1668	17246767000000	16674	8470	8	0	\N
31180	1668	18000320000000	6859	3547	2	0	\N
31181	1668	18000320000000	7291	3769	1	0	\N
31183	1668	18000320000000	7707	3990	3	0	\N
31184	1668	18000330000000	7291	3769	2	0	\N
31186	1668	18000340000000	6859	3547	3	0	\N
31187	1668	18000350000000	7707	3990	4	0	\N
31188	1668	18513868500000	28509	14088	3	0	\N
31191	1668	18513880500000	28509	14088	4	0	\N
31192	1668	18686768000000	17421	8825	6	0	\N
31195	1668	18686792000000	17421	8825	7	0	\N
31203	1668	19953915500000	29172	14381	8	0	\N
31204	1668	19953915500000	29179	14386	3	0	\N
31205	1668	19953915500000	29225	14402	3	0	\N
31207	1668	19953927500000	29179	14386	4	0	\N
31208	1668	19953927500000	29225	14402	4	0	\N
31210	1668	19953950500000	29172	14381	9	0	\N
31211	1668	20126851000000	17954	9057	3	0	\N
31212	1668	20126851000000	18241	9188	5	0	\N
31213	1668	20126851000000	18244	9189	2	0	\N
31214	1668	20126851000000	18655	9401	6	0	\N
31215	1668	20126851000000	18986	9575	4	0	\N
31216	1668	20126851000000	19160	9666	6	0	\N
31218	1668	20126862000000	18244	9189	3	0	\N
31219	1668	20126863000000	17954	9057	4	0	\N
31220	1668	20126864000000	18986	9575	5	0	\N
31221	1668	20126874000000	18241	9188	6	0	\N
31222	1668	20126875000000	18655	9401	7	0	\N
31223	1668	20126875000000	19160	9666	7	0	\N
31225	1668	20160340000000	8472	4389	1	0	\N
31227	1668	20160350000000	8472	4389	2	0	\N
31235	1668	21393940500000	29429	14510	3	0	\N
31236	1668	21393940500000	29432	14510	3	0	\N
31238	1668	21393952500000	29429	14510	4	0	\N
31239	1668	21393952500000	29432	14510	4	0	\N
31241	1668	21566899000000	19582	9864	3	0	\N
31242	1668	21566899000000	19931	10038	5	0	\N
31243	1668	21566899000000	19938	10041	3	0	\N
31244	1668	21566911000000	19582	9864	4	0	\N
31245	1668	21566911000000	19938	10041	4	0	\N
31246	1668	21566922000000	19931	10038	6	0	\N
31249	1668	22113952500000	29610	14602	3	0	\N
31250	1668	22113952500000	30092	14815	9	0	\N
31251	1668	22113952500000	30093	14815	8	0	\N
31253	1668	22113969500000	30093	14815	9	0	\N
31254	1668	22113970500000	30092	14815	10	0	\N
31256	1668	22114063500000	29610	14602	4	0	\N
31257	1668	22319130000000	9801	5082	2	0	\N
31260	1668	22319150000000	9801	5082	3	0	\N
31261	1668	23039140000000	9809	5085	4	0	\N
31262	1668	23039162000000	9809	5085	5	0	\N
31263	1668	66720045890000	24306	12087	9	1	\N
31264	1669	720000000000	22572	11292	3	0	\N
31265	1669	720012000000	22572	11292	4	0	\N
31266	1670	207000000	27224	13463	4	1	\N
31269	1670	720610000000	9936	5158	7	0	\N
31272	1670	720680000000	9936	5158	8	0	\N
31275	1670	721462000000	21626	10782	107	0	\N
31278	1670	1440630000000	10509	5429	2	0	\N
31279	1670	1440630000000	10511	5429	2	0	\N
31276	1670	1440110000000	770	428	4	0	0
31277	1670	1440240000000	770	428	5	0	0
31145	1668	15120260000000	5939	3077	2	0	0
31155	1668	15840260000000	6547	3393	2	0	0
31157	1668	15840280000000	6547	3393	3	0	0
31165	1668	16560300000000	6568	3401	3	0	0
31174	1668	17280300000000	6824	3533	2	0	0
31175	1668	17280320000000	6824	3533	3	0	0
31182	1668	18000320000000	7706	3992	1	0	0
31185	1668	18000330000000	7706	3992	2	0	0
31197	1668	18720340000000	7973	4131	2	0	0
31202	1668	19440340000000	8434	4372	0	0	0
31226	1668	20160340000000	8495	4400	1	0	0
31228	1668	20160350000000	8495	4400	2	0	0
31234	1668	20880620000000	8930	4629	4	0	0
31247	1668	21600620000000	9333	4842	2	0	0
31248	1668	21600640000000	9333	4842	3	0	0
31258	1668	22319130000000	9803	5082	1	0	1
31259	1668	22319140000000	9803	5082	2	0	1
31271	1670	720630000000	10197	5280	3	0	6
31280	1670	1440630000000	10579	5464	2	0	6
31152	1668	15806718000000	16385	8334	4	0	5
31153	1668	15806731000000	16385	8334	5	0	5
31161	1668	16526731000000	16518	8401	2	0	5
31171	1668	17246742000000	16834	8543	4	0	5
31172	1668	17246755000000	16834	8543	5	0	5
31178	1668	17966755000000	17076	8649	4	0	5
31179	1668	17966768000000	17076	8649	5	0	5
31194	1668	18686780000000	17754	8970	4	0	5
31200	1668	19406780000000	17897	9030	17	0	5
31201	1668	19406851000000	17897	9030	18	0	5
31217	1668	20126851000000	19161	9666	8	0	5
31224	1668	20126877000000	19161	9666	9	0	5
31232	1668	20846899000000	19488	9824	5	0	5
31273	1670	720793000000	20337	10243	4	0	11
31274	1670	720806000000	20337	10243	5	0	11
31149	1668	15633807000000	28143	13912	6	0	9
31151	1668	15633835500000	28143	13912	7	0	9
31159	1668	16353846500000	28254	13970	3	0	9
31167	1668	17073846500000	28356	14018	2	0	9
31169	1668	17073857500000	28356	14018	3	0	9
31176	1668	17793857500000	28454	14062	2	0	9
31189	1668	18513868500000	29069	14332	2	0	9
31190	1668	18513879500000	29069	14332	3	0	9
31198	1668	19233879500000	29155	14377	9	0	9
31199	1668	19233915500000	29155	14377	10	0	9
31206	1668	19953915500000	29281	14431	3	0	9
31229	1668	20673927500000	29380	14483	4	0	9
31230	1668	20673940500000	29380	14483	5	0	9
31237	1668	21393940500000	29594	14592	3	0	9
31240	1668	21393952500000	29594	14592	4	0	9
31252	1668	22113952500000	30123	14823	28	0	9
31281	1670	1440650000000	10509	5429	3	0	\N
31282	1670	1440650000000	10511	5429	3	0	\N
31284	1670	1440806000000	20674	10400	9	0	\N
31285	1670	1440806000000	21261	10678	8	0	\N
31286	1670	1440806000000	21263	10678	8	0	\N
31287	1670	1440806000000	21623	10834	4	0	\N
31288	1670	1440806000000	21625	10834	6	0	\N
31291	1670	1440828000000	21623	10834	5	0	\N
31292	1670	1440830000000	21625	10834	7	0	\N
31293	1670	1440842000000	20674	10400	10	0	\N
31294	1670	1440850000000	21261	10678	9	0	\N
31295	1670	1440850000000	21263	10678	9	0	\N
31296	1670	1441462000000	21626	10782	126	0	\N
31297	1670	1441480000000	21626	10782	127	0	\N
31298	1670	1442650000000	22036	10783	107	0	\N
31302	1670	2160650000000	10870	5599	41	0	\N
31306	1670	2161131000000	10870	5599	42	0	\N
31307	1670	2162650000000	22036	10783	126	0	\N
31308	1670	2162830000000	22036	10783	127	0	\N
31311	1670	2880700000000	11326	5816	2	0	\N
31312	1670	2880700000000	11384	5848	2	0	\N
31314	1670	2880711000000	11326	5816	3	0	\N
31315	1670	2880711000000	11384	5848	3	0	\N
31323	1670	3600843000000	22489	11253	8	0	\N
31325	1670	3600878000000	22489	11253	9	0	\N
31327	1670	4320290000000	1108	613	1	0	\N
31328	1670	4320290000000	1165	642	2	0	\N
31329	1670	4320290000000	1532	839	1	0	\N
31331	1670	4320300000000	1108	613	2	0	\N
31332	1670	4320300000000	1532	839	2	0	\N
31333	1670	4320310000000	1165	642	3	0	\N
31337	1670	4320892000000	22699	11349	4	0	\N
31338	1670	4320892000000	23477	11705	3	0	\N
31339	1670	4320892000000	23548	11738	3	0	\N
31340	1670	4320892000000	23616	11765	6	0	\N
31342	1670	4320904000000	23477	11705	4	0	\N
31343	1670	4320904000000	23548	11738	4	0	\N
31344	1670	4320905000000	22699	11349	5	0	\N
31345	1670	4320916000000	23616	11765	7	0	\N
31349	1670	5040722000000	11641	5991	2	0	\N
31351	1670	5040724000000	11641	5991	3	0	\N
31353	1670	5040916000000	23660	11785	3	0	\N
31355	1670	5040928000000	23660	11785	4	0	\N
31357	1670	5760320000000	1918	1023	1	0	\N
31359	1670	5760330000000	1918	1023	2	0	\N
31361	1670	5760733000000	11963	6158	1	0	\N
31363	1670	5760734000000	11963	6158	2	0	\N
31369	1670	6480734000000	12402	6398	2	0	\N
31370	1670	6480734000000	12685	6542	2	0	\N
31371	1670	6480734000000	12971	6689	2	0	\N
31372	1670	6480734000000	13100	6752	4	0	\N
31374	1670	6480736000000	12402	6398	3	0	\N
31375	1670	6480745000000	12685	6542	3	0	\N
31376	1670	6480745000000	12971	6689	3	0	\N
31377	1670	6480747000000	13100	6752	5	0	\N
31385	1670	7200976000000	23998	11943	9	0	\N
31388	1670	7201012000000	23998	11943	10	0	\N
31391	1670	7920769000000	13425	6918	4	0	\N
31393	1670	7920782000000	13425	6918	5	0	\N
31397	1670	7921011000000	25191	12497	1	0	\N
31398	1670	7921011000000	25193	12497	1	0	\N
31401	1670	8640792000000	13662	7022	17	0	\N
31404	1670	8640881000000	13662	7022	18	0	\N
31405	1670	8641001000000	24302	12086	3	0	\N
31406	1670	8641001000000	24838	12333	7	0	\N
31407	1670	8641001000000	25090	12455	3	0	\N
31408	1670	8641001000000	25092	12455	4	0	\N
31410	1670	8641011000000	25191	12497	5	0	\N
31411	1670	8641011000000	25193	12497	5	0	\N
31412	1670	8641013000000	24302	12086	4	0	\N
31413	1670	8641013000000	25090	12455	4	0	\N
31415	1670	8641014000000	25092	12455	5	0	\N
31416	1670	8641014000000	25193	12497	6	0	\N
31309	1670	2880250000000	912	507	2	0	0
31310	1670	2880270000000	912	507	3	0	0
31319	1670	3600270000000	961	536	2	0	0
31320	1670	3600290000000	961	536	3	0	0
31330	1670	4320290000000	1669	896	2	0	0
31347	1670	5040310000000	1841	984	1	0	0
31348	1670	5040320000000	1841	984	2	0	0
31358	1670	5760320000000	2300	1206	1	0	0
31360	1670	5760330000000	2300	1206	2	0	0
31367	1670	6480330000000	2347	1227	1	0	0
31381	1670	7200340000000	2359	1234	1	0	0
31382	1670	7200350000000	2359	1234	2	0	0
31389	1670	7920350000000	2416	1265	2	0	0
31390	1670	7920370000000	2416	1265	3	0	0
31400	1670	8640390000000	2423	1268	3	0	0
31283	1670	1440650000000	10579	5464	3	0	6
31301	1670	2160650000000	10868	5609	5	0	6
31303	1670	2160700000000	10868	5609	6	0	6
31313	1670	2880700000000	11465	5893	2	0	6
31321	1670	3600711000000	11488	5903	1	0	6
31322	1670	3600721000000	11488	5903	2	0	6
31335	1670	4320721000000	11551	5935	1	0	6
31336	1670	4320722000000	11551	5935	2	0	6
31350	1670	5040722000000	11765	6049	2	0	6
31362	1670	5760733000000	12135	6249	1	0	6
31364	1670	5760734000000	12135	6249	2	0	6
31373	1670	6480734000000	13199	6801	5	0	6
31378	1670	6480757000000	13199	6801	6	0	6
31384	1670	7200769000000	13222	6815	4	0	6
31392	1670	7920769000000	13588	6989	5	0	6
31394	1670	7920792000000	13588	6989	6	0	6
31402	1670	8640792000000	13664	7022	16	0	6
31403	1670	8640880000000	13664	7022	17	0	6
31290	1670	1440819000000	22035	11017	5	0	11
31304	1670	2160819000000	22262	11141	3	0	11
31305	1670	2160831000000	22262	11141	4	0	11
31317	1670	2880831000000	22285	11155	3	0	11
31318	1670	2880843000000	22285	11155	4	0	11
31326	1670	3600892000000	22547	11280	14	0	11
31341	1670	4320892000000	23617	11765	6	0	11
31346	1670	4320916000000	23617	11765	7	0	11
31354	1670	5040916000000	23724	11814	6	0	11
31365	1670	5760940000000	23901	11896	3	0	11
31366	1670	5760952000000	23901	11896	4	0	11
31379	1670	6480952000000	23961	11922	6	0	11
31380	1670	6480976000000	23961	11922	7	0	11
31386	1670	7200976000000	24196	12043	4	0	11
31395	1670	7920989000000	24282	12079	3	0	11
31396	1670	7921001000000	24282	12079	4	0	11
31409	1670	8641001000000	25258	12530	3	0	11
31414	1670	8641013000000	25258	12530	4	0	11
31417	1670	8641026000000	24838	12333	8	0	\N
31424	1670	10080400000000	2927	1523	1	0	\N
31426	1670	10080410000000	2927	1523	2	0	\N
31430	1670	10081050000000	25357	12572	3	0	\N
31431	1670	10081050000000	25951	12824	4	0	\N
31433	1670	10081062000000	25357	12572	4	0	\N
31435	1670	10081072000000	25951	12824	5	0	\N
31436	1670	10800410000000	3183	1652	1	0	\N
31437	1670	10800410000000	3199	1661	1	0	\N
31439	1670	10800420000000	3183	1652	2	0	\N
31440	1670	10800420000000	3199	1661	2	0	\N
31444	1670	10801062000000	26329	13021	3	0	\N
31445	1670	10801062000000	26331	13021	5	0	\N
31447	1670	10801062000000	26818	13262	4	0	\N
31449	1670	10801083000000	26329	13021	4	0	\N
31450	1670	10801084000000	26818	13262	5	0	\N
31451	1670	10801085000000	26331	13021	6	0	\N
31452	1670	11520420000000	3355	1743	2	0	\N
31455	1670	11520440000000	3355	1743	3	0	\N
31456	1670	11520973000000	13947	7147	1	0	\N
31458	1670	11520983000000	13947	7147	2	0	\N
31460	1670	11521074000000	27053	13318	17	0	\N
31463	1670	11521244000000	27053	13318	18	0	\N
31464	1670	12240430000000	3601	1870	0	0	\N
31465	1670	12240430000000	3674	1908	1	0	\N
31466	1670	12240430000000	4128	2147	2	0	\N
31467	1670	12240430000000	4164	2166	2	0	\N
31468	1670	12240430000000	4181	2177	0	0	\N
31470	1670	12240440000000	3674	1908	2	0	\N
31472	1670	12240450000000	4128	2147	3	0	\N
31473	1670	12240540000000	4164	2166	3	0	\N
31474	1670	12240886000000	13990	7169	4	0	\N
31475	1670	12240899000000	13990	7169	5	0	\N
31476	1670	12240986000000	13991	7169	4	0	\N
31477	1670	12240986000000	14197	7244	1	0	\N
31479	1670	12240996000000	14197	7244	2	0	\N
31480	1670	12240999000000	13991	7169	5	0	\N
31482	1670	12241108020000	27224	13463	3	0	\N
31483	1670	12241109000000	27140	13420	3	0	\N
31484	1670	12241109000000	27226	13463	3	0	\N
31487	1670	12241121000000	27140	13420	4	0	\N
31488	1670	12241121000000	27226	13463	4	0	\N
31489	1670	12241243900000	27138	13319	0	0	\N
31492	1670	12960899000000	15520	7799	0	0	\N
31493	1670	12960999000000	14353	7327	4	0	\N
31494	1670	12960999000000	14701	7486	4	0	\N
31495	1670	12960999000000	15359	7797	0	0	\N
31498	1670	12961012000000	14353	7327	5	0	\N
31499	1670	12961021000000	14701	7486	5	0	\N
31502	1670	13680450000000	4679	2419	1	0	\N
31504	1670	13680460000000	4679	2419	2	0	\N
31506	1670	13680799000000	15535	7800	0	0	\N
31509	1670	13681131000000	28559	14106	13	0	\N
31512	1670	13681180000000	28559	14106	14	0	\N
31517	1670	14401143000000	28645	14143	2	0	\N
31518	1670	14401143000000	28646	14143	3	0	\N
31519	1670	14401143000000	29045	14324	3	0	\N
31521	1670	14401145000000	28645	14143	3	0	\N
31522	1670	14401155000000	28646	14143	4	0	\N
31523	1670	14401155000000	29045	14324	4	0	\N
31525	1670	15120490000000	5298	2752	1	0	\N
31526	1670	15120490000000	5658	2935	0	0	\N
31528	1670	15120490000000	5742	2975	1	0	\N
31529	1670	15120500000000	5298	2752	2	0	\N
31531	1670	15120500000000	5742	2975	2	0	\N
31532	1670	15121065000000	15780	8027	3	0	\N
31534	1670	15121077000000	15780	8027	4	0	\N
31540	1670	15841077000000	16201	8234	3	0	\N
31542	1670	15841089000000	16201	8234	4	0	\N
31552	1670	17280520000000	5999	3113	4	0	\N
31425	1670	10080400000000	3021	1568	1	0	0
31427	1670	10080410000000	3021	1568	2	0	0
31438	1670	10800410000000	3212	1669	1	0	0
31441	1670	10800420000000	3212	1669	2	0	0
31453	1670	11520420000000	3387	1762	1	0	0
31469	1670	12240430000000	4182	2177	1	0	0
31471	1670	12240440000000	4182	2177	2	0	0
31490	1670	12960440000000	4514	2335	1	0	0
31491	1670	12960450000000	4514	2335	2	0	0
31503	1670	13680450000000	4908	2541	3	0	0
31513	1670	14400480000000	5020	2606	1	0	0
31514	1670	14400490000000	5020	2606	2	0	0
31527	1670	15120490000000	5741	2975	1	0	0
31530	1670	15120500000000	5741	2975	2	0	0
31539	1670	15840510000000	5751	2981	2	0	0
31546	1670	16560510000000	5961	3092	1	0	0
31547	1670	16560520000000	5961	3092	2	0	0
31420	1670	9360880000000	13724	7054	5	0	6
31421	1670	9360894000000	13724	7054	6	0	6
31429	1670	10080959000000	13741	7062	21	0	6
31442	1670	10800959000000	13785	7081	5	0	6
31443	1670	10800973000000	13785	7081	6	0	6
31457	1670	11520973000000	13948	7147	4	0	6
31459	1670	11520986000000	13948	7147	5	0	6
31481	1670	12240999000000	14198	7244	5	0	6
31496	1670	12960999000000	15360	7827	2	0	6
31497	1670	12961010000000	15360	7827	3	0	6
31507	1670	13681010000000	15521	7899	4	0	6
31515	1670	14401032000000	15536	7906	6	0	6
31516	1670	14401065000000	15536	7906	7	0	6
31533	1670	15121065000000	16089	8177	3	0	6
31535	1670	15121077000000	16089	8177	4	0	6
31541	1670	15841077000000	16350	8314	3	0	6
31548	1670	16561089000000	16640	8454	3	0	6
31549	1670	16561101000000	16640	8454	4	0	6
31422	1670	9361013000000	25324	12561	10	0	11
31423	1670	9361050000000	25324	12561	11	0	11
31432	1670	10081050000000	26165	12934	3	0	11
31446	1670	10801062000000	26817	13262	3	0	11
31448	1670	10801074000000	26817	13262	4	0	11
31461	1670	11521074000000	27054	13375	8	0	11
31462	1670	11521109000000	27054	13375	9	0	11
31486	1670	12241120000000	28240	13962	3	0	11
31500	1670	12961120000000	28340	14010	2	0	11
31501	1670	12961131000000	28340	14010	3	0	11
31510	1670	13681131000000	28560	14108	3	0	11
31511	1670	13681143000000	28560	14108	4	0	11
31524	1670	14401156000000	29148	14372	5	0	11
31536	1670	15121156000000	29364	14472	3	0	11
31537	1670	15121168000000	29364	14472	4	0	11
31544	1670	15841168000000	29509	14554	4	0	11
31545	1670	15841181000000	29509	14554	5	0	11
31551	1670	16561206000000	29547	14568	8	0	11
31555	1670	17280650000000	5999	3113	5	0	\N
31560	1670	18000560000000	6961	3591	1	0	\N
31562	1670	18000570000000	6961	3591	2	0	\N
31566	1670	18001223474693	29946	14749	11	0	\N
31567	1670	18001223474693	29947	14749	10	0	\N
31568	1670	18001223474693	30156	14838	10	0	\N
31569	1670	18001223474693	30157	14838	8	0	\N
31571	1670	18001223474693	30240	14867	4	0	\N
31572	1670	18001223474693	30241	14867	2	0	\N
31573	1670	18001233474382	30241	14867	4	0	\N
31574	1670	18001235474382	30240	14867	6	0	\N
31576	1670	18001249474693	30157	14838	9	0	\N
31577	1670	18001251474693	29947	14749	11	0	\N
31578	1670	18001251474693	30156	14838	11	0	\N
31579	1670	18001252474693	29946	14749	12	0	\N
31582	1670	18720610000000	7192	3719	1	0	\N
31583	1670	18720610000000	7193	3719	1	0	\N
31586	1670	19440600000000	7092	3662	3	0	\N
31587	1670	19440600000000	7797	4043	1	0	\N
31588	1670	19440600000000	8089	4195	1	0	\N
31589	1670	19440600000000	8138	4220	0	0	\N
31591	1670	19440610000000	7192	3719	3	0	\N
31592	1670	19440610000000	7193	3719	3	0	\N
31593	1670	19440610000000	7797	4043	2	0	\N
31594	1670	19440610000000	8089	4195	2	0	\N
31595	1670	19440620000000	7192	3719	4	0	\N
31596	1670	19440620000000	7193	3719	4	0	\N
31598	1670	19440630000000	7092	3662	4	0	\N
31599	1670	19441149000000	17630	8914	3	0	\N
31601	1670	19441161000000	17630	8914	4	0	\N
31607	1670	20880630000000	8757	4545	2	0	\N
31608	1670	20880630000000	9024	4679	4	0	\N
31610	1670	20880650000000	8757	4545	3	0	\N
31611	1670	20880670000000	9024	4679	5	0	\N
31613	1670	20881173000000	17890	9028	6	0	\N
31614	1670	20881173000000	17892	9028	4	0	\N
31615	1670	20881173000000	18073	9114	4	0	\N
31617	1670	20881173000000	18570	9200	0	0	\N
31618	1670	20881173000000	18573	9216	0	0	\N
31619	1670	20881173000000	18574	9233	0	0	\N
31620	1670	20881173000000	18575	9248	0	0	\N
31621	1670	20881186000000	17892	9028	5	0	\N
31622	1670	20881188000000	17890	9028	7	0	\N
31623	1670	20881195000000	18073	9114	5	0	\N
31627	1670	21601234000000	18540	9341	3	0	\N
31628	1670	21601234000000	18571	9359	4	0	\N
31629	1670	21601234000000	19118	9645	2	0	\N
31630	1670	21601234000000	19252	9707	3	0	\N
31632	1670	21601245000000	19118	9645	3	0	\N
31633	1670	21601246000000	18540	9341	4	0	\N
31634	1670	21601246000000	19252	9707	4	0	\N
31636	1670	21601346000000	18571	9359	5	0	\N
31639	1670	22321259000000	19852	10001	6	0	\N
31641	1670	22321283000000	19852	10001	7	0	\N
31643	1670	66000000499999	25191	12497	6	0	\N
31648	1671	2160040000000	142	84	1	0	\N
31649	1671	2160040000000	177	105	1	0	\N
31650	1671	2160040000000	428	244	1	0	\N
31651	1671	2160040000000	639	359	1	0	\N
31653	1671	2160050000000	142	84	2	0	\N
31654	1671	2160050000000	177	105	2	0	\N
31655	1671	2160050000000	428	244	2	0	\N
31656	1671	2160050000000	639	359	2	0	\N
31658	1671	2208129530515	9888	5126	2	0	\N
31660	1671	2208149530515	9888	5126	3	0	\N
31662	1671	2544375003785	20877	10470	48	0	\N
31667	1671	3263845003785	20134	10135	10	0	\N
31668	1671	3263845003785	20410	10283	6	0	\N
31669	1671	3263845003785	20632	10381	11	0	\N
31670	1671	3263845003785	20875	10494	4	0	\N
31673	1671	3263860003785	20410	10283	7	0	\N
31674	1671	3263867003785	20875	10494	5	0	\N
31675	1671	3263891003785	20134	10135	11	0	\N
31676	1671	3264198003785	20632	10381	12	0	\N
31677	1671	3264375003785	20877	10470	102	0	\N
31678	1671	3264428003785	20877	10470	103	0	\N
31679	1671	3265408003785	21169	10471	72	0	\N
31682	1671	3648219530515	11434	5873	2	0	\N
31683	1671	3648219530515	12057	6205	1	0	\N
31684	1671	3648219530515	12148	6258	0	0	\N
31686	1671	3648220530515	12057	6205	2	0	\N
31688	1671	3648230530515	11434	5873	3	0	\N
31646	1671	1440020000000	86	53	2	0	0
31647	1671	1440040000000	86	53	3	0	0
31652	1671	2160040000000	724	405	4	0	0
31657	1671	2160080000000	724	405	5	0	0
31663	1671	2880080000000	947	528	1	0	0
31680	1671	3600090000000	1008	558	5	0	0
31681	1671	3600140000000	1008	558	6	0	0
31553	1670	17280520000000	6685	3455	4	0	0
31554	1670	17280560000000	6685	3455	5	0	0
31561	1670	18000560000000	6962	3591	2	0	0
31580	1670	18720580000000	6997	3612	2	0	0
31581	1670	18720600000000	6997	3612	3	0	0
31590	1670	19440600000000	8140	4221	2	0	0
31597	1670	19440620000000	8140	4221	3	0	0
31604	1670	20160630000000	8333	4315	2	0	0
31609	1670	20880630000000	9034	4684	4	0	0
31612	1670	20880670000000	9034	4684	5	0	0
31625	1670	21600670000000	9204	4772	2	0	0
31626	1670	21600690000000	9204	4772	3	0	0
31638	1670	22320710000000	9298	4824	3	0	0
31659	1671	2208129530515	10270	5313	2	0	4
31661	1671	2208149530515	10270	5313	3	0	4
31665	1671	2928149530515	10333	5348	7	0	4
31666	1671	2928219530515	10333	5348	8	0	4
31687	1671	3648220530515	12149	6258	2	0	4
31556	1670	17281101000000	16799	8526	3	0	6
31557	1670	17281113000000	16799	8526	4	0	6
31564	1670	18001113000000	16843	8546	7	0	6
31584	1670	18721138000000	17123	8676	2	0	6
31585	1670	18721149000000	17123	8676	3	0	6
31600	1670	19441149000000	17752	8969	3	0	6
31602	1670	19441161000000	17752	8969	4	0	6
31605	1670	20161161000000	17851	9010	3	0	6
31616	1670	20881173000000	18512	9324	3	0	6
31624	1670	20881234000000	18512	9324	4	0	6
31631	1670	21601234000000	19296	9728	7	0	6
31635	1670	21601259000000	19296	9728	8	0	6
31640	1670	22321259000000	19918	10032	7	0	6
31671	1671	3263845003785	21167	10632	2	0	8
31672	1671	3263856003785	21167	10632	3	0	8
31558	1670	17281206000000	29904	14734	9	0	11
31559	1670	17281223474693	29904	14734	13	0	11
31575	1670	18001239474382	30239	14867	10	0	11
31689	1671	3983856003785	21660	10852	2	0	\N
31690	1671	3983856003785	21661	10852	3	0	\N
31692	1671	3983867003785	21660	10852	3	0	\N
31693	1671	3983868003785	21661	10852	4	0	\N
31695	1671	3985408003785	21169	10471	126	0	\N
31696	1671	3985938003785	21169	10471	127	0	\N
31697	1671	4320140000000	1167	643	1	0	\N
31699	1671	4320150000000	1167	643	2	0	\N
31703	1671	4368261530515	12563	6465	4	0	\N
31704	1671	4703868003785	21781	10906	3	0	\N
31706	1671	4703868003785	21892	10955	3	0	\N
31708	1671	4703880003785	21781	10906	4	0	\N
31709	1671	4703880003785	21892	10955	4	0	\N
31712	1671	5088221530515	12441	6414	0	0	\N
31713	1671	5088221530515	12491	6438	1	0	\N
31715	1671	5088222530515	12491	6438	2	0	\N
31717	1671	5088261530515	12563	6465	9	0	\N
31718	1671	5088301530515	12563	6465	10	0	\N
31719	1671	5423870003785	22631	11319	4	0	\N
31720	1671	5423870003785	22810	11408	3	0	\N
31722	1671	5423882003785	22810	11408	4	0	\N
31723	1671	5423883003785	22631	11319	5	0	\N
31725	1671	5760180000000	1842	984	1	0	\N
31727	1671	5760190000000	1842	984	2	0	\N
31729	1671	5808232530515	12666	6534	3	0	\N
31732	1671	5808244530515	12666	6534	4	0	\N
31733	1671	6143895003785	23206	11585	2	0	\N
31734	1671	6143895003785	23274	11612	2	0	\N
31736	1671	6143906003785	23206	11585	3	0	\N
31737	1671	6143906003785	23274	11612	3	0	\N
31741	1671	6528243530515	12963	6685	6	0	\N
31742	1671	6528243530515	13166	6783	5	0	\N
31744	1671	6528257530515	13166	6783	6	0	\N
31746	1671	6528276530515	12963	6685	7	0	\N
31755	1671	7920220000000	3474	1804	0	0	\N
31771	1671	9408388530515	14765	7520	1	0	\N
31773	1671	9743979003785	24336	12102	3	0	\N
31775	1671	9743991003785	24336	12102	4	0	\N
31779	1671	10128388530515	14765	7520	5	0	\N
31781	1671	10128400530515	14765	7520	6	0	\N
31783	1671	10464013003785	24749	12290	8	0	\N
31785	1671	10464048003785	24749	12290	9	0	\N
31791	1671	11184125003785	25024	12415	1	0	\N
31793	1671	11184135003785	25024	12415	2	0	\N
31795	1671	11184160003785	25473	12617	1	0	\N
31796	1671	11184160003785	25474	12617	1	0	\N
31799	1671	11568411530515	15062	7671	4	0	\N
31802	1671	11568442530515	15062	7671	5	0	\N
31804	1671	11904150003785	25580	12590	0	0	\N
31805	1671	11904150003785	25582	12600	0	0	\N
31806	1671	11904150003785	25584	12610	0	0	\N
31807	1671	11904150003785	25585	12619	0	0	\N
31808	1671	11904160003785	25473	12617	5	0	\N
31809	1671	11904160003785	25474	12617	5	0	\N
31810	1671	11904163003785	25473	12617	6	0	\N
31811	1671	11904163003785	25474	12617	6	0	\N
31813	1671	12240880000000	5041	2615	1	0	\N
31814	1671	12240890000000	4883	2528	3	0	\N
31815	1671	12240890000000	5043	2615	1	0	\N
31817	1671	12240900000000	5043	2615	2	0	\N
31819	1671	12240920000000	4883	2528	4	0	\N
31824	1671	12960900000000	5354	2780	1	0	\N
31710	1671	5040160000000	1522	833	2	0	0
31711	1671	5040180000000	1522	833	3	0	0
31726	1671	5760180000000	2182	1151	1	0	0
31728	1671	5760190000000	2182	1151	2	0	0
31739	1671	6480190000000	2504	1312	1	0	0
31749	1671	7200200000000	2678	1407	2	0	0
31750	1671	7200220000000	2678	1407	3	0	0
31756	1671	7920220000000	3484	1809	0	0	0
31761	1671	8640220000000	4139	2153	9	0	0
31762	1671	8640850000000	4139	2153	10	0	0
31768	1671	9360860000000	4268	2213	2	0	0
31777	1671	10080860000000	4633	2396	1	0	0
31778	1671	10080870000000	4633	2396	2	0	0
31787	1671	10800870000000	4721	2442	1	0	0
31797	1671	11520880000000	4865	2519	1	0	0
31798	1671	11520890000000	4865	2519	2	0	0
31816	1671	12240890000000	5167	2682	1	0	0
31818	1671	12240900000000	5167	2682	2	0	0
31701	1671	4368220530515	12373	6381	1	0	4
31714	1671	5088221530515	12562	6473	2	0	4
31716	1671	5088232530515	12562	6473	3	0	4
31730	1671	5808232530515	12882	6642	2	0	4
31731	1671	5808243530515	12882	6642	3	0	4
31743	1671	6528243530515	13607	6996	8	0	4
31751	1671	7248269530515	14448	7374	6	0	4
31752	1671	7248275530515	14448	7374	7	0	4
31757	1671	7968275530515	14478	7389	8	0	4
31758	1671	7968301530515	14478	7389	9	0	4
31764	1671	8688334530515	14568	7429	7	0	4
31769	1671	9408334530515	14732	7500	8	0	4
31770	1671	9408378530515	14732	7500	9	0	4
31772	1671	9408388530515	14766	7520	1	0	4
31780	1671	10128388530515	14766	7520	5	0	4
31789	1671	10848400530515	14819	7553	2	0	4
31790	1671	10848411530515	14819	7553	3	0	4
31800	1671	11568411530515	15268	7777	5	0	4
31801	1671	11568434530515	15268	7777	6	0	4
31820	1671	12288434530515	15791	8034	3	0	4
31691	1671	3983856003785	21662	10852	3	0	8
31694	1671	3983868003785	21662	10852	4	0	8
31705	1671	4703868003785	21891	10955	2	0	8
31707	1671	4703870003785	21891	10955	3	0	8
31724	1671	5423895003785	23033	11500	8	0	8
31735	1671	6143895003785	23297	11624	2	0	8
31738	1671	6143906003785	23297	11624	3	0	8
31747	1671	6863906003785	23758	11831	4	0	8
31748	1671	6863919003785	23758	11831	5	0	8
31754	1671	7583956003785	23930	11909	11	0	8
31759	1671	8303956003785	24018	11952	3	0	8
31760	1671	8303968003785	24018	11952	4	0	8
31765	1671	9023968003785	24076	11984	2	0	8
31766	1671	9023979003785	24076	11984	3	0	8
31776	1671	9744013003785	24417	12144	8	0	8
31784	1671	10464013003785	24852	12340	4	0	8
31786	1671	10464125003785	24852	12340	5	0	8
31792	1671	11184125003785	25155	12481	6	0	8
31803	1671	11904150003785	25568	12658	6	0	8
31812	1671	11904174003785	25568	12658	7	0	8
31822	1671	12624174003785	25583	12663	3	0	8
31823	1671	12624186003785	25583	12663	4	0	8
31826	1671	12960910000000	5354	2780	2	0	\N
31835	1671	13728851530515	17432	8766	29	0	\N
31840	1671	14448471530515	17431	8830	4	0	\N
31842	1671	14448493530515	17431	8830	5	0	\N
31844	1671	14448851530515	17432	8766	126	0	\N
31845	1671	14449476530515	17432	8766	127	0	\N
31847	1671	14784223003785	26027	12710	0	0	\N
31848	1671	14784223003785	26032	12722	0	0	\N
31849	1671	14784223003785	26034	12733	0	0	\N
31851	1671	14784887003785	26033	12748	64	0	\N
31854	1671	15168493530515	17945	9052	7	0	\N
31856	1671	15168493530515	18104	9132	4	0	\N
31857	1671	15168493530515	18105	9132	4	0	\N
31859	1671	15168506530515	18104	9132	5	0	\N
31860	1671	15168506530515	18105	9132	5	0	\N
31861	1671	15168518530515	17945	9052	8	0	\N
31862	1671	15504247003785	26029	12864	2	0	\N
31863	1671	15504247003785	26035	12745	0	0	\N
31864	1671	15504247003785	26150	12928	6	0	\N
31865	1671	15504247003785	26482	13099	3	0	\N
31867	1671	15504258003785	26029	12864	3	0	\N
31869	1671	15504259003785	26482	13099	4	0	\N
31870	1671	15504271003785	26150	12928	7	0	\N
31871	1671	15504887003785	26033	12748	126	0	\N
31872	1671	15505497003785	26033	12748	127	0	\N
31879	1671	16560970000000	6205	3211	3	0	\N
31880	1671	16560970000000	6207	3212	2	0	\N
31883	1671	16560990000000	6207	3212	3	0	\N
31884	1671	16561000000000	6205	3211	4	0	\N
31885	1671	16608517530515	18321	9228	2	0	\N
31886	1671	16608517530515	18724	9435	3	0	\N
31888	1671	16608528530515	18321	9228	3	0	\N
31889	1671	16608529530515	18724	9435	4	0	\N
31891	1671	16944282003785	27058	13377	3	0	\N
31893	1671	16944294003785	27058	13377	4	0	\N
31895	1671	16944306003785	27220	13462	3	0	\N
31899	1671	17328537530515	19094	9632	3	0	\N
31901	1671	17328549530515	19094	9632	4	0	\N
31903	1671	17664306003785	27220	13462	4	0	\N
31908	1671	18384306003785	28026	13667	0	0	\N
31912	1671	19104318003785	28027	13862	3	0	\N
31913	1671	19104318003785	28029	13679	0	0	\N
31914	1671	19104318003785	28030	13692	0	0	\N
31915	1671	19104318003785	28031	13704	0	0	\N
31918	1671	19104330003785	28027	13862	4	0	\N
31919	1671	19441040000000	6845	3542	6	0	\N
31920	1671	19441040000000	7017	3618	4	0	\N
31923	1671	19441080000000	7017	3618	5	0	\N
31924	1671	19441100000000	6845	3542	7	0	\N
31925	1671	19824329003785	28370	14025	2	0	\N
31927	1671	19824340003785	28370	14025	3	0	\N
31929	1671	20161060000000	7335	3791	5	0	\N
31932	1671	20161110000000	7335	3791	6	0	\N
31933	1671	20544352003785	28814	14212	1	0	\N
31934	1671	20544352003785	28815	14212	3	0	\N
31936	1671	20544353003785	28814	14212	2	0	\N
31937	1671	20544364003785	28815	14212	4	0	\N
31939	1671	20881070000000	8199	4250	1	0	\N
31941	1671	20881080000000	8199	4250	2	0	\N
31942	1671	21264374003785	28908	14259	3	0	\N
31945	1671	21264386003785	28908	14259	4	0	\N
31950	1671	22321080000000	8542	4426	2	0	\N
31951	1671	22321080000000	8762	4547	2	0	\N
31952	1671	22321080000000	8799	4562	2	0	\N
31954	1671	22321100000000	8542	4426	3	0	\N
31955	1671	22321100000000	8762	4547	3	0	\N
31956	1671	22321100000000	8799	4562	3	0	\N
31958	1671	22704409003785	29671	14635	18	0	\N
31959	1671	22704409003785	29996	14770	6	0	\N
31960	1671	22704409003785	29997	14770	8	0	\N
31832	1671	13680910000000	5745	2977	2	0	0
31838	1671	14400910000000	5759	2986	2	0	0
31839	1671	14400930000000	5759	2986	3	0	0
31852	1671	15120930000000	6055	3146	1	0	0
31853	1671	15120940000000	6055	3146	2	0	0
31874	1671	15840970000000	6091	3162	4	0	0
31881	1671	16560970000000	6290	3259	1	0	0
31882	1671	16560980000000	6290	3259	2	0	0
31897	1671	17280980000000	6446	3336	2	0	0
31898	1671	17281000000000	6446	3336	3	0	0
31906	1671	18001020000000	6448	3338	3	0	0
31910	1671	18721020000000	6727	3481	2	0	0
31911	1671	18721040000000	6727	3481	3	0	0
31921	1671	19441040000000	7271	3759	2	0	0
31930	1671	20161060000000	8011	4152	1	0	0
31931	1671	20161070000000	8011	4152	2	0	0
31940	1671	20881070000000	8427	4367	0	0	0
31946	1671	21601070000000	8514	4411	1	0	0
31947	1671	21601080000000	8514	4411	2	0	0
31957	1671	22321120000000	9061	4697	5	0	0
31827	1671	13008446530515	16344	8311	4	0	4
31828	1671	13008459530515	16344	8311	5	0	4
31833	1671	13728459530515	17251	8738	3	0	4
31834	1671	13728471530515	17251	8738	4	0	4
31843	1671	14448493530515	17713	8952	5	0	4
31855	1671	15168493530515	18103	9132	4	0	4
31858	1671	15168506530515	18103	9132	5	0	4
31875	1671	15888506530515	18281	9211	2	0	4
31887	1671	16608517530515	18912	9540	2	0	4
31890	1671	16608537530515	18912	9540	3	0	4
31900	1671	17328537530515	19427	9791	4	0	4
31902	1671	17328559530515	19427	9791	5	0	4
31829	1671	13344186003785	25615	12677	3	0	8
31836	1671	14064198003785	25619	12678	7	0	8
31837	1671	14064223003785	25619	12678	8	0	8
31846	1671	14784223003785	25734	12733	6	0	8
31850	1671	14784247003785	25734	12733	7	0	8
31866	1671	15504247003785	26915	13311	2	0	8
31877	1671	16224258003785	26989	13349	6	0	8
31878	1671	16224282003785	26989	13349	7	0	8
31892	1671	16944282003785	27132	13418	3	0	8
31894	1671	16944294003785	27132	13418	4	0	8
31904	1671	17664306003785	27222	13462	4	0	8
31907	1671	18384306003785	27664	13672	3	0	8
31909	1671	18384318003785	27664	13672	4	0	8
31916	1671	19104318003785	28174	13929	2	0	8
31917	1671	19104329003785	28174	13929	3	0	8
31928	1671	19824352003785	28784	14198	6	0	8
31935	1671	20544352003785	28871	14241	4	0	8
31938	1671	20544374003785	28871	14241	5	0	8
31943	1671	21264374003785	29157	14378	2	0	8
31944	1671	21264385003785	29157	14378	3	0	8
31949	1671	21984409003785	29185	14388	7	0	8
31961	1671	22704424003785	29996	14770	7	0	\N
31962	1671	22704426003785	29997	14770	9	0	\N
31963	1671	22704544003785	29671	14635	19	0	\N
31964	1671	23041120000000	9346	4850	2	0	\N
31965	1671	23041140000000	9346	4850	3	0	\N
31966	1672	200100000	12781	6589	9	1	\N
31967	1672	200100000	19364	9763	4	0	\N
31968	1672	720000000000	238	141	2	0	\N
31971	1672	720020000000	238	141	3	0	\N
31978	1672	2160020000000	1144	631	1	0	\N
31980	1672	2160030000000	1144	631	2	0	\N
31982	1672	2161225000000	21250	10671	8	0	\N
31983	1672	2161225000000	21336	10710	3	0	\N
31984	1672	2161225000000	21338	10710	3	0	\N
31986	1672	2161225000000	21639	10840	5	0	\N
31987	1672	2161237000000	21336	10710	4	0	\N
31988	1672	2161237000000	21338	10710	4	0	\N
31990	1672	2161239000000	21639	10840	6	0	\N
31991	1672	2161287000000	21250	10671	9	0	\N
31992	1672	2445724000000	9897	5130	2	0	\N
31995	1672	2445744000000	9897	5130	3	0	\N
31996	1672	2880040000000	2245	1183	0	0	\N
32000	1672	2880774000000	10794	5572	5	0	\N
32002	1672	2880914000000	10794	5572	6	0	\N
32003	1672	2881238000000	22028	11013	3	0	\N
32005	1672	2881250000000	22028	11013	4	0	\N
32009	1672	3600050000000	2579	1360	3	0	\N
32012	1672	3600080000000	2579	1360	4	0	\N
32013	1672	3600914000000	11041	5683	2	0	\N
32014	1672	3600914000000	11043	5683	2	0	\N
32016	1672	3600934000000	11041	5683	3	0	\N
32017	1672	3600934000000	11043	5683	3	0	\N
32019	1672	3601250000000	22210	11118	10	0	\N
32022	1672	3601287000000	22210	11118	11	0	\N
32025	1672	4320934000000	11792	6060	2	0	\N
32026	1672	4320934000000	11965	6158	1	0	\N
32027	1672	4320934000000	11983	6168	1	0	\N
32029	1672	4320935000000	11965	6158	2	0	\N
32030	1672	4320935000000	11983	6168	2	0	\N
32031	1672	4320936000000	11792	6060	3	0	\N
32042	1672	5761309000000	23294	11623	4	0	\N
32044	1672	5761331000000	23294	11623	5	0	\N
32045	1672	5761737000000	12588	6486	16	0	\N
32048	1672	5761825000000	12588	6486	17	0	\N
32051	1672	6481309000000	23495	11714	4	0	\N
32054	1672	6481322000000	23495	11714	5	0	\N
32057	1672	6481779000000	12781	6589	2	0	\N
32063	1672	7201363000000	24734	12283	3	0	\N
32065	1672	7201779000000	12781	6589	8	0	\N
32068	1672	7920130000000	4285	2222	3	0	\N
32071	1672	7920160000000	4285	2222	4	0	\N
32072	1672	7921333000000	24323	12097	7	0	\N
32073	1672	7921333000000	24939	12117	0	0	\N
32074	1672	7921333000000	24942	12132	0	0	\N
32075	1672	7921333000000	24943	12147	0	0	\N
32076	1672	7921333000000	24944	12162	0	0	\N
32077	1672	7921359000000	24323	12097	8	0	\N
32078	1672	7921363000000	24734	12283	9	0	\N
32081	1672	7921395000000	24734	12283	10	0	\N
32090	1672	9360250000000	4707	2432	1	0	\N
32092	1672	9360260000000	4707	2432	2	0	\N
32094	1672	9361397000000	24941	12380	6	0	\N
32095	1672	9361397000000	25136	12472	3	0	\N
31972	1672	1440010000000	501	280	1	0	0
31973	1672	1440020000000	501	280	2	0	0
31979	1672	2160020000000	1812	969	2	0	0
31981	1672	2160040000000	1812	969	3	0	0
31997	1672	2880040000000	2303	1207	1	0	0
32010	1672	3600050000000	2659	1398	1	0	0
32011	1672	3600060000000	2659	1398	2	0	0
32023	1672	4320060000000	2762	1444	1	0	0
32024	1672	4320070000000	2762	1444	2	0	0
32035	1672	5040070000000	3064	1591	1	0	0
32041	1672	5760080000000	3650	1894	0	0	0
32049	1672	6480080000000	3709	1926	4	0	0
32050	1672	6480120000000	3709	1926	5	0	0
32059	1672	7200120000000	3917	2032	1	0	0
32069	1672	7920130000000	4312	2236	2	0	0
32070	1672	7920150000000	4312	2236	3	0	0
32084	1672	8640150000000	4403	2282	10	0	0
32085	1672	8640250000000	4403	2282	11	0	0
32091	1672	9360250000000	5216	2712	1	0	0
31976	1672	1725703000000	9806	5084	3	0	4
31977	1672	1725724000000	9806	5084	4	0	4
31993	1672	2445724000000	9973	5173	1	0	4
31994	1672	2445734000000	9973	5173	2	0	4
32007	1672	3165734000000	10258	5307	5	0	4
31999	1672	2880774000000	10793	5572	5	0	5
32001	1672	2880914000000	10793	5572	6	0	5
32015	1672	3600914000000	11124	5719	2	0	5
32018	1672	3600934000000	11124	5719	3	0	5
32034	1672	4321736000000	12295	6332	11	0	5
32039	1672	5041736000000	12484	6435	1	0	5
32040	1672	5041737000000	12484	6435	2	0	5
32046	1672	5761737000000	12589	6489	2	0	5
32047	1672	5761748000000	12589	6489	3	0	5
32056	1672	6481759000000	12684	6542	3	0	5
32058	1672	6481779000000	12782	6589	2	0	5
32066	1672	7201779000000	12782	6589	8	0	5
32067	1672	7201793000000	12782	6589	9	0	5
32082	1672	7921793000000	12851	6627	2	0	5
32088	1672	8641804000000	12898	6648	2	0	5
32089	1672	8641815000000	12898	6648	3	0	5
31974	1672	1441214000000	21208	10649	2	0	10
31975	1672	1441225000000	21208	10649	3	0	10
31989	1672	2161238000000	21638	10840	5	0	10
32004	1672	2881238000000	22046	11025	3	0	10
32006	1672	2881250000000	22046	11025	4	0	10
32020	1672	3601250000000	22784	11394	7	0	10
32021	1672	3601284000000	22784	11394	8	0	10
32033	1672	4321297000000	23108	11541	5	0	10
32037	1672	5041297000000	23149	11561	3	0	10
32038	1672	5041309000000	23149	11561	4	0	10
32043	1672	5761309000000	23478	11706	0	0	10
32052	1672	6481309000000	23977	11932	3	0	10
32061	1672	7201321000000	24156	12024	3	0	10
32062	1672	7201333000000	24156	12024	4	0	10
32064	1672	7201363000000	24736	12283	3	0	10
32079	1672	7921363000000	24736	12283	8	0	10
32086	1672	8641385000000	24935	12377	3	0	10
32087	1672	8641397000000	24935	12377	4	0	10
32096	1672	9361397000000	25541	12645	5	0	10
32097	1672	9361409000000	25136	12472	4	0	\N
32099	1672	9361421000000	24941	12380	7	0	\N
32100	1672	9361815000000	13868	7118	2	0	\N
32102	1672	9361835000000	13868	7118	3	0	\N
32104	1672	10080260000000	5307	2759	1	0	\N
32106	1672	10080270000000	5307	2759	2	0	\N
32114	1672	10801854000000	13893	7129	14	0	\N
32116	1672	10801854000000	13941	7143	7	0	\N
32118	1672	10801870000000	13941	7143	8	0	\N
32119	1672	10801886000000	13893	7129	15	0	\N
32120	1672	11520260000000	5645	2930	0	0	\N
32126	1672	12240260000000	6296	3261	1	0	\N
32128	1672	12240270000000	6296	3261	2	0	\N
32130	1672	12241459000000	26786	13246	4	0	\N
32132	1672	12241472000000	26786	13246	5	0	\N
32136	1672	12960280000000	6760	3499	8	0	\N
32137	1672	12960280000000	6906	3568	2	0	\N
32139	1672	12960300000000	6906	3568	3	0	\N
32141	1672	12960360000000	6760	3499	9	0	\N
32142	1672	12961482000000	27166	13434	3	0	\N
32144	1672	12961494000000	27166	13434	4	0	\N
32152	1672	13681906000000	14384	7340	6	0	\N
32154	1672	13681930000000	14384	7340	7	0	\N
32162	1672	15120392000000	7591	3926	2	0	\N
32163	1672	15120392000000	7704	3991	1	0	\N
32164	1672	15120392000000	8259	4277	2	0	\N
32165	1672	15120392000000	8518	4413	2	0	\N
32167	1672	15120402000000	7704	3991	2	0	\N
32169	1672	15120412000000	7591	3926	3	0	\N
32170	1672	15120412000000	8259	4277	3	0	\N
32171	1672	15120412000000	8518	4413	3	0	\N
32180	1672	15841591000000	28589	14119	1	0	\N
32185	1672	16561581000000	28495	14082	2	0	\N
32186	1672	16561581000000	28588	14116	0	0	\N
32187	1672	16561581000000	28608	14127	2	0	\N
32189	1672	16561591000000	28589	14119	4	0	\N
32190	1672	16561592000000	28495	14082	3	0	\N
32191	1672	16561592000000	28608	14127	3	0	\N
32192	1672	16561593000000	28589	14119	5	0	\N
32194	1672	16561987000000	14989	7636	3	0	\N
32196	1672	16561999000000	14989	7636	4	0	\N
32200	1672	17281581000000	28607	14117	5	0	\N
32201	1672	17281593000000	28674	14156	4	0	\N
32202	1672	17281593000000	28813	14212	3	0	\N
32204	1672	17281605000000	28813	14212	4	0	\N
32205	1672	17281615000000	28674	14156	5	0	\N
32207	1672	17281622000000	28607	14117	6	0	\N
32210	1672	18000542000000	9342	4848	2	0	\N
32212	1672	18000562000000	9342	4848	3	0	\N
32214	1672	18001617000000	29283	14431	3	0	\N
32216	1672	18001622000000	28612	14118	0	0	\N
32217	1672	18001629000000	29283	14431	4	0	\N
32219	1672	18001686000000	29517	14557	3	0	\N
32220	1672	18002031000000	15632	7957	3	0	\N
32222	1672	18002043000000	15632	7957	4	0	\N
32228	1672	18721686000000	29517	14557	8	0	\N
32229	1672	18721690000000	29517	14557	9	0	\N
32230	1672	18722043000000	16157	8213	3	0	\N
32232	1672	18722055000000	16157	8213	4	0	\N
32121	1672	11520260000000	5888	3053	0	0	0
32127	1672	12240260000000	6487	3362	2	0	0
32129	1672	12240280000000	6487	3362	3	0	0
32138	1672	12960280000000	7009	3615	5	0	0
32140	1672	12960321000000	7009	3615	6	0	0
32149	1672	13680382000000	7346	3797	8	0	0
32156	1672	14400382000000	7471	3865	1	0	0
32157	1672	14400392000000	7471	3865	2	0	0
32166	1672	15120392000000	8619	4468	1	0	0
32168	1672	15120402000000	8619	4468	2	0	0
32177	1672	15840422000000	8936	4633	3	0	0
32183	1672	16560422000000	9052	4692	2	0	0
32184	1672	16560442000000	9052	4692	3	0	0
32198	1672	17280442000000	9246	4795	10	0	0
32211	1672	18000542000000	9432	4893	2	0	0
32213	1672	18000562000000	9432	4893	3	0	0
32224	1672	18720562000000	9526	4939	5	0	0
32225	1672	18720693000000	9526	4939	6	0	0
32101	1672	9361815000000	13869	7118	8	0	5
32109	1672	10081841000000	13872	7119	4	0	5
32110	1672	10081854000000	13872	7119	5	0	5
32115	1672	10801854000000	13940	7143	4	0	5
32117	1672	10801867000000	13940	7143	5	0	5
32124	1672	11521867000000	13988	7167	4	0	5
32134	1672	12241880000000	14027	7186	5	0	5
32135	1672	12241894000000	14027	7186	6	0	5
32146	1672	12961894000000	14383	7339	3	0	5
32147	1672	12961906000000	14383	7339	4	0	5
32155	1672	13681954000000	14547	7421	13	0	5
32160	1672	14401954000000	14798	7539	2	0	5
32161	1672	14401965000000	14798	7539	3	0	5
32174	1672	15121965000000	14955	7617	1	0	5
32175	1672	15121975000000	14955	7617	2	0	5
32182	1672	15841987000000	14987	7635	4	0	5
32195	1672	16561987000000	15495	7887	6	0	5
32197	1672	16562020000000	15495	7887	7	0	5
32208	1672	17282020000000	15518	7897	2	0	5
32209	1672	17282031000000	15518	7897	3	0	5
32223	1672	18002043000000	15900	8085	4	0	5
32231	1672	18722043000000	16845	8547	3	0	5
32098	1672	9361411000000	25541	12645	6	0	10
32107	1672	10081411000000	25691	12712	6	0	10
32112	1672	10801435000000	25991	12845	2	0	10
32113	1672	10801446000000	25991	12845	3	0	10
32122	1672	11521446000000	26558	13141	4	0	10
32123	1672	11521459000000	26558	13141	5	0	10
32131	1672	12241459000000	27076	13386	5	0	10
32143	1672	12961482000000	27520	13605	14	0	10
32145	1672	12961523000000	27520	13605	15	0	10
32150	1672	13681523000000	27852	13767	3	0	10
32151	1672	13681535000000	27852	13767	4	0	10
32158	1672	14401535000000	27903	13798	3	0	10
32172	1672	15121547000000	27927	13814	3	0	10
32173	1672	15121559000000	27927	13814	4	0	10
32178	1672	15841559000000	28419	14046	4	0	10
32179	1672	15841581000000	28419	14046	5	0	10
32193	1672	16561593000000	28613	14128	4	0	10
32203	1672	17281593000000	29043	14323	6	0	10
32206	1672	17281617000000	29043	14323	7	0	10
32215	1672	18001617000000	29491	14542	12	0	10
32218	1672	18001665000000	29491	14542	13	0	10
32227	1672	18721676000000	29604	14599	3	0	10
32237	1672	19441676000000	29941	14714	0	0	\N
32238	1672	19441676000000	29942	14725	0	0	\N
32239	1672	19441676000000	29943	14736	0	0	\N
32240	1672	19441676000000	29952	14745	0	0	\N
32242	1672	19442055000000	16963	8598	6	0	\N
32243	1672	19442055000000	16968	8598	6	0	\N
32245	1672	19442055000000	17045	8596	0	0	\N
32247	1672	19442088000000	16963	8598	7	0	\N
32248	1672	19442088000000	16968	8598	7	0	\N
32251	1672	20161676000000	29953	14746	0	0	\N
32254	1672	20162079000000	17335	8777	1	0	\N
32257	1672	20162149000000	17534	8880	7	0	\N
32259	1672	20162179000000	17335	8777	2	0	\N
32260	1672	20881710000000	30016	14782	30	0	\N
32262	1672	20881767000000	30016	14782	31	0	\N
32264	1672	20882106000000	17401	8814	2	0	\N
32265	1672	20882108000000	17401	8814	3	0	\N
32266	1672	20882149000000	17534	8880	13	0	\N
32268	1672	20882154000000	17534	8880	14	0	\N
32270	1672	21601828000000	30268	14882	20	0	\N
32273	1672	21601868899790	30268	14882	21	1	\N
32274	1672	21602154000000	17718	8955	7	0	\N
32277	1672	21602188000000	17718	8955	8	0	\N
32278	1672	22322156000000	17947	9052	7	0	\N
32281	1672	22322181000000	17947	9052	8	0	\N
32282	1672	23042168000000	18069	9113	2	0	\N
32284	1672	23042179000000	18069	9113	3	0	\N
32288	1672	24482189000000	18873	9518	1	0	\N
32289	1672	24482189000000	19364	9763	3	0	\N
32290	1672	24482189000000	19365	9763	3	0	\N
32292	1672	24482199000000	18873	9518	2	0	\N
32293	1672	24482201000000	19365	9763	4	0	\N
32294	1672	25202189000000	19447	9802	7	0	\N
32296	1672	25202189000000	19540	9843	3	0	\N
32297	1672	25202201000000	19540	9843	4	0	\N
32299	1672	25202214000000	19447	9802	8	0	\N
32300	1672	25922202000000	19543	9845	7	0	\N
32301	1672	25922202000000	19544	9845	10	0	\N
32302	1672	25922202000000	19639	9892	3	0	\N
32304	1672	25922214000000	19639	9892	4	0	\N
32305	1672	25922236000000	19543	9845	8	0	\N
32306	1672	25922239000000	19544	9845	11	0	\N
32310	1672	27362252000000	20194	10171	6	0	\N
32313	1672	27362285000000	20194	10171	7	0	\N
32314	1672	28082264000000	20577	10354	3	0	\N
32315	1672	28082276000000	20577	10354	4	0	\N
32322	1673	2880280000000	1564	851	1	0	\N
32323	1673	2880280000000	2382	1246	1	0	\N
32325	1673	2880290000000	1564	851	2	0	\N
32326	1673	2880290000000	2382	1246	2	0	\N
32328	1673	3600300000000	2766	1332	0	0	\N
32329	1673	3600300000000	3155	1641	1	0	\N
32331	1673	3600310000000	3155	1641	2	0	\N
32333	1673	4320300000000	2788	1333	126	0	\N
32334	1673	4320320000000	3637	1885	3	0	\N
32337	1673	4320332000000	3637	1885	4	0	\N
32338	1673	4321650000000	2788	1333	127	0	\N
32341	1673	5041650000000	3092	1334	126	0	\N
32342	1673	5043090000000	3092	1334	127	0	\N
32349	1673	7920500000000	5178	2688	3	0	\N
32350	1673	7920500000000	5545	2883	0	0	\N
32351	1673	7920500000000	5697	2953	0	0	\N
32354	1673	7920530000000	5178	2688	4	0	\N
32356	1673	9360510000000	5970	3097	2	0	\N
32359	1673	9360530000000	5970	3097	3	0	\N
32360	1673	9575435000000	24761	12294	7	0	\N
32361	1673	9575435000000	24771	12299	4	0	\N
32362	1673	9575435000000	24893	12359	9	0	\N
32363	1673	9575435000000	25411	12593	4	0	\N
32366	1673	9575448000000	24771	12299	5	0	\N
32367	1673	9575448000000	25411	12593	5	0	\N
32368	1673	9575460000000	24761	12294	8	0	\N
32318	1673	1440010000000	681	380	2	0	0
32319	1673	1440270000000	681	380	3	0	0
32320	1673	2160270000000	1468	801	1	0	0
32321	1673	2160280000000	1468	801	2	0	0
32324	1673	2880280000000	2412	1262	2	0	0
32330	1673	3600300000000	3216	1672	2	0	0
32332	1673	3600320000000	3216	1672	3	0	0
32335	1673	4320320000000	4029	2092	1	0	0
32336	1673	4320330000000	4029	2092	2	0	0
32339	1673	5040330000000	4091	2126	5	0	0
32343	1673	5760470000000	4485	2323	1	0	0
32344	1673	5760480000000	4485	2323	2	0	0
32345	1673	6480480000000	4763	2461	1	0	0
32346	1673	6480490000000	4763	2461	2	0	0
32348	1673	7200500000000	4872	2523	2	0	0
32352	1673	7920500000000	5715	2963	0	0	0
32353	1673	7920510000000	5913	3065	1	0	0
32355	1673	8640510000000	5913	3065	2	0	0
32357	1673	9360510000000	6008	3118	1	0	0
32234	1672	19440693000000	9653	5008	2	0	0
32235	1672	19440713000000	9653	5008	3	0	0
32249	1672	20160713000000	9785	5071	3	0	0
32250	1672	20160743000000	9785	5071	4	0	0
32233	1672	18722055000000	16845	8547	4	0	5
32246	1672	19442079000000	17043	8632	7	0	5
32255	1672	20162079000000	17336	8782	9	0	5
32256	1672	20162106000000	17336	8782	10	0	5
32258	1672	20162149000000	17535	8880	7	0	5
32269	1672	20882154000000	17535	8880	14	0	5
32275	1672	21602154000000	17811	8996	2	0	5
32276	1672	21602156000000	17811	8996	3	0	5
32279	1672	22322156000000	17963	9061	3	0	5
32280	1672	22322168000000	17963	9061	4	0	5
32285	1672	23042179000000	18245	9189	3	0	5
32286	1672	23762179000000	18603	9373	1	0	5
32287	1672	23762189000000	18603	9373	2	0	5
32291	1672	24482189000000	19444	9801	0	0	5
32295	1672	25202189000000	19539	9843	4	0	5
32303	1672	25922202000000	19906	10025	10	0	5
32307	1672	25922239000000	19906	10025	11	0	5
32308	1672	26642239000000	20032	10084	4	0	5
32309	1672	26642252000000	20032	10084	5	0	5
32312	1672	27362264000000	20442	10295	4	0	5
32364	1673	9575435000000	26565	13144	3	0	18
32365	1673	9575447000000	26565	13144	4	0	18
32236	1672	19441676000000	29940	14747	6	0	10
32241	1672	19441691000000	29940	14747	7	0	10
32253	1672	20161710000000	29954	14753	11	0	10
32261	1672	20881710000000	30073	14807	11	0	10
32263	1672	20881828000000	30073	14807	12	0	10
32271	1672	21601828000000	30269	14882	11	0	10
32272	1672	21601859899790	30269	14882	12	1	10
32369	1673	9575471000000	24893	12359	10	0	\N
32370	1673	10080520000000	6199	3208	1	0	\N
32371	1673	10080520000000	6396	3315	0	0	\N
32372	1673	10080520000000	6683	3455	4	0	\N
32374	1673	10080530000000	6199	3208	2	0	\N
32375	1673	10080560000000	6683	3455	5	0	\N
32377	1673	10295447000000	26797	13250	2	0	\N
32378	1673	10295447000000	27249	13473	3	0	\N
32380	1673	10295458000000	26797	13250	3	0	\N
32381	1673	10295459000000	27249	13473	4	0	\N
32385	1673	11015459000000	27341	13516	3	0	\N
32386	1673	11015459000000	27722	13696	2	0	\N
32388	1673	11015470000000	27722	13696	3	0	\N
32389	1673	11015471000000	27341	13516	4	0	\N
32393	1673	11735484000000	27948	13826	6	0	\N
32396	1673	11735508000000	27948	13826	7	0	\N
32413	1673	13680955000000	7473	3787	20	0	\N
32421	1673	14400955000000	7473	3787	22	0	\N
32422	1673	14400965000000	7473	3787	23	0	\N
32425	1673	14726218000000	14159	7227	3	0	\N
32426	1673	14726230000000	14159	7227	4	0	\N
32429	1673	15120750000000	8012	4153	2	0	\N
32432	1673	15120761000000	8012	4153	3	0	\N
32439	1673	16055546000000	29861	14718	10	0	\N
32440	1673	16055546000000	29972	14760	9	0	\N
32441	1673	16055546000000	30255	14876	18	0	\N
32442	1673	16055546000000	30292	14892	13	0	\N
32443	1673	16055564000000	29972	14760	10	0	\N
32444	1673	16055564998999	29861	14718	12	0	\N
32445	1673	16055577000000	30292	14892	14	0	\N
32446	1673	16055581504653	30255	14876	22	0	\N
32453	1673	17280780000000	8834	4580	2	0	\N
32455	1673	17280800000000	8834	4580	3	0	\N
32458	1673	18000780000000	8974	4655	2	0	\N
32459	1673	18000780000000	8994	4663	2	0	\N
32461	1673	18000800000000	8974	4655	3	0	\N
32462	1673	18000800000000	8994	4663	3	0	\N
32483	1673	21601010000000	9753	5053	2	0	\N
32484	1673	21601010000000	9939	5159	2	0	\N
32486	1673	21601030000000	9753	5053	3	0	\N
32487	1673	21601030000000	9939	5159	3	0	\N
32491	1673	22321061000000	10224	5292	6	0	\N
32494	1673	22321121000000	10224	5292	7	0	\N
32501	1673	23365484000000	17600	8897	21	0	\N
32504	1673	23365604000000	17600	8897	22	0	\N
32383	1673	10800580000000	6821	3532	6	0	0
32384	1673	10800640000000	6821	3532	7	0	0
32391	1673	11520640000000	6990	3609	4	0	0
32392	1673	11520680000000	6990	3609	5	0	0
32399	1673	12240680000000	7036	3630	2	0	0
32405	1673	12960700000000	7120	3678	2	0	0
32406	1673	12960720000000	7120	3678	3	0	0
32411	1673	13680720000000	7132	3686	2	0	0
32412	1673	13680740000000	7132	3686	3	0	0
32419	1673	14400740000000	7947	4117	1	0	0
32430	1673	15120750000000	8189	4245	1	0	0
32431	1673	15120760000000	8189	4245	2	0	0
32437	1673	15840760000000	8345	4322	1	0	0
32438	1673	15840770000000	8345	4322	2	0	0
32450	1673	16560780000000	8550	4430	2	0	0
32454	1673	17280780000000	8894	4608	0	0	0
32460	1673	18000780000000	9039	4687	2	0	0
32463	1673	18000800000000	9039	4687	3	0	0
32466	1673	18720800000000	9439	4895	2	0	0
32470	1673	19440820000000	9519	4936	2	0	0
32471	1673	19440840000000	9519	4936	3	0	0
32474	1673	20160840000000	9530	4942	5	0	0
32475	1673	20160980000000	9530	4942	6	0	0
32476	1673	20161000000000	9655	5010	2	0	0
32480	1673	20881010000000	9655	5010	5	0	0
32485	1673	21601010000000	10079	5228	6	0	0
32488	1673	21601061000000	10079	5228	7	0	0
32492	1673	22321061000000	10240	5298	2	0	0
32497	1673	23041081000000	10264	5309	2	0	0
32498	1673	23041101000000	10264	5309	3	0	0
32499	1673	23086541000000	10704	5526	4	0	2
32500	1673	23086581000000	10704	5526	5	0	2
32397	1673	11846092000000	13296	6850	4	0	8
32403	1673	12566114000000	13483	6943	9	0	8
32404	1673	12566150000000	13483	6943	10	0	8
32409	1673	13286150000000	13808	7090	7	0	8
32410	1673	13286166000000	13808	7090	8	0	8
32416	1673	14006166000000	13817	7094	16	0	8
32418	1673	14006234000000	14256	7278	7	0	8
32427	1673	14726234000000	14256	7278	11	0	8
32428	1673	14726237000000	14256	7278	12	0	8
32435	1673	15446237000000	14297	7296	9	0	8
32447	1673	16166264000000	14389	7342	14	0	8
32448	1673	16166323000000	14389	7342	15	0	8
32451	1673	16886323000000	14913	7598	4	0	8
32452	1673	16886345000000	14913	7598	5	0	8
32456	1673	17606345000000	14993	7638	5	0	8
32464	1673	18326377000000	15131	7712	1	0	8
32465	1673	18326387000000	15131	7712	2	0	8
32468	1673	19046387000000	15206	7747	3	0	8
32469	1673	19046399000000	15206	7747	4	0	8
32472	1673	19766399000000	15241	7763	7	0	8
32477	1673	20486433000000	15529	7903	7	0	8
32478	1673	20486467000000	15529	7903	8	0	8
32481	1673	21206467000000	15591	7936	6	0	8
32482	1673	21206500000000	15591	7936	7	0	8
32490	1673	21926512000000	16275	8273	4	0	8
32495	1673	22646512000000	17117	8672	3	0	8
32496	1673	22646524000000	17117	8672	4	0	8
32502	1673	23365484000000	18353	9248	2	0	10
32503	1673	23365495000000	18353	9248	3	0	10
32382	1673	10295459000000	27303	13496	4	0	18
32387	1673	11015459000000	27896	13793	7	0	18
32390	1673	11015484000000	27896	13793	8	0	18
32394	1673	11735484000000	28477	14074	2	0	18
32395	1673	11735495000000	28477	14074	3	0	18
32402	1673	12455507000000	28954	14280	4	0	18
32407	1673	13175507000000	28999	14298	3	0	18
32408	1673	13175519000000	28999	14298	4	0	18
32414	1673	13895519000000	29260	14421	3	0	18
32423	1673	14615522000000	29438	14514	3	0	18
32424	1673	14615534000000	29438	14514	4	0	18
32433	1673	15335534000000	29447	14519	3	0	18
32434	1673	15335546000000	29447	14519	4	0	18
32505	1673	23365694000000	17751	8898	9	0	\N
32508	1673	24085495000000	18525	9331	4	0	\N
32509	1673	24085495000000	18611	9377	3	0	\N
32512	1673	24085507000000	18611	9377	4	0	\N
32513	1673	24085508000000	18525	9331	5	0	\N
32514	1673	24085694000000	17751	8898	70	0	\N
32523	1673	25966631000000	10978	5657	3	0	\N
32525	1673	25966652000000	10978	5657	4	0	\N
32536	1673	28126675000000	11500	5908	6	0	\N
32539	1673	28126700000000	11500	5908	7	0	\N
32542	1673	28846677000000	11690	6010	1	0	\N
32543	1673	28846677000000	11810	6069	1	0	\N
32545	1673	28846678000000	11690	6010	2	0	\N
32546	1673	28846678000000	11810	6069	2	0	\N
32552	1673	29845607000000	20611	10366	10	0	\N
32555	1673	29845644000000	20611	10366	11	0	\N
32556	1673	30286691000000	12686	6542	1	0	\N
32557	1673	30286691000000	12827	6617	1	0	\N
32558	1673	30286691000000	12904	6650	4	0	\N
32560	1673	30286701000000	12686	6542	2	0	\N
32561	1673	30286701000000	12827	6617	2	0	\N
32563	1673	30286713000000	12904	6650	5	0	\N
32564	1673	30565620000000	20682	10402	3	0	\N
32566	1673	30565632000000	20682	10402	4	0	\N
32568	1673	31006702000000	13002	6702	1	0	\N
32569	1673	31006703000000	13002	6702	2	0	\N
32570	1673	31285632000000	21227	10660	4	0	\N
32571	1673	31285632000000	21413	10739	3	0	\N
32573	1673	31285644000000	21413	10739	4	0	\N
32574	1673	31285654000000	21227	10660	5	0	\N
32576	1673	32005656000000	21628	10835	3	0	\N
32577	1673	32005656000000	21724	10882	3	0	\N
32579	1673	32005668000000	21628	10835	4	0	\N
32580	1673	32005668000000	21724	10882	4	0	\N
32584	1673	32580929000000	23626	11702	21	0	\N
32585	1673	32725668000000	21998	11000	3	0	\N
32587	1673	32725680000000	21998	11000	4	0	\N
32589	1673	33300719000000	23210	11585	1	0	\N
32590	1673	33300719000000	23259	11605	2	0	\N
32592	1673	33300720000000	23210	11585	2	0	\N
32593	1673	33300730000000	23259	11605	3	0	\N
32595	1673	33300929000000	23626	11702	126	0	\N
32596	1673	33301772000000	23626	11702	127	0	\N
32597	1673	34020731000000	23899	11896	3	0	\N
32598	1673	34020731000000	24367	12119	2	0	\N
32599	1673	34020742000000	24367	12119	3	0	\N
32600	1673	34020743000000	23899	11896	4	0	\N
32601	1673	67440013050000	17751	8898	71	1	\N
32602	1675	720000000000	733	411	1	0	\N
32603	1675	720000000000	984	545	1	0	\N
32605	1675	720010000000	733	411	2	0	\N
32606	1675	720010000000	984	545	2	0	\N
32608	1675	861752999977	10033	5206	5	0	\N
32609	1675	861752999977	10034	5206	5	0	\N
32612	1675	1581729999977	10464	5309	0	0	\N
32614	1675	1581752999977	10033	5206	6	0	\N
32615	1675	1581752999977	10034	5206	6	0	\N
32617	1675	2160020000000	1395	763	1	0	\N
32619	1675	2160030000000	1395	763	2	0	\N
32625	1675	2444344999977	20508	10231	20	0	\N
32629	1675	3021819999977	10837	5593	9	0	\N
32630	1675	3021909999977	10837	5593	10	0	\N
32633	1675	3164104999977	20509	10325	2	0	\N
32634	1675	3164106999977	20509	10325	3	0	\N
32636	1675	3164344999977	20508	10231	126	0	\N
32637	1675	3165394999977	20508	10231	127	0	\N
32638	1675	3600070000000	2657	1397	1	0	\N
32639	1675	3600070000000	2681	1409	1	0	\N
32610	1675	1440010000000	1385	760	1	0	0
32611	1675	1440020000000	1385	760	2	0	0
32618	1675	2160020000000	1568	854	1	0	0
32620	1675	2160030000000	1568	854	2	0	0
32626	1675	2880030000000	2259	1186	4	0	0
32640	1675	3600070000000	2695	1416	2	0	0
32613	1675	1581729999977	10465	5408	7	0	4
32616	1675	1581799999977	10465	5408	8	0	4
32621	1675	2301799999977	10504	5427	2	0	4
32622	1675	2301819999977	10504	5427	3	0	4
32631	1675	3021919999977	10836	5593	11	0	4
32506	1673	23806581000000	10850	5601	2	0	2
32507	1673	23806601000000	10850	5601	3	0	2
32515	1673	24526601000000	10916	5631	1	0	2
32519	1673	25246611000000	10937	5638	2	0	2
32520	1673	25246631000000	10937	5638	3	0	2
32524	1673	25966631000000	11058	5688	0	0	2
32528	1673	26686631000000	11369	5839	6	0	2
32529	1673	26686664000000	11369	5839	7	0	2
32533	1673	27406675000000	11419	5865	3	0	2
32537	1673	28126675000000	11559	5941	2	0	2
32538	1673	28126677000000	11559	5941	3	0	2
32544	1673	28846677000000	11931	6141	3	0	2
32547	1673	28846680000000	11931	6141	4	0	2
32551	1673	29566691000000	12601	6499	3	0	2
32559	1673	30286691000000	12954	6679	2	0	2
32562	1673	30286702000000	12954	6679	3	0	2
32510	1673	24085495000000	19113	9642	1	0	10
32517	1673	24805496000000	19176	9675	3	0	10
32518	1673	24805508000000	19176	9675	4	0	10
32521	1673	25525508000000	19178	9676	3	0	10
32522	1673	25525520000000	19178	9676	4	0	10
32526	1673	26245520000000	19254	9708	8	0	10
32530	1673	26965546000000	19282	9721	4	0	10
32531	1673	26965559000000	19282	9721	5	0	10
32534	1673	27685559000000	19360	9760	3	0	10
32535	1673	27685571000000	19360	9760	4	0	10
32623	1675	2443396999977	20165	10151	26	0	8
32540	1673	28405571000000	20485	10315	5	0	10
32541	1673	28405594000000	20485	10315	6	0	10
32632	1675	3164104999977	20507	10325	4	0	8
32635	1675	3164117999977	20507	10325	5	0	8
32549	1673	29125607000000	20522	10330	5	0	10
32553	1673	29845607000000	20659	10393	4	0	10
32554	1673	29845620000000	20659	10393	5	0	10
32565	1673	30565620000000	20686	10404	3	0	10
32567	1673	30565632000000	20686	10404	4	0	10
32575	1673	31285656000000	21511	10791	7	0	10
32578	1673	32005656000000	21746	10889	3	0	10
32581	1673	32005668000000	21746	10889	4	0	10
32586	1673	32725668000000	22076	11037	6	0	10
32588	1673	32725710000000	22076	11037	7	0	10
32583	1673	32580719000000	22990	11483	5	0	12
32591	1673	33300719000000	23869	11881	3	0	12
32594	1673	33300731000000	23869	11881	4	0	12
32641	1675	3600080000000	2657	1397	2	0	\N
32642	1675	3600080000000	2681	1409	2	0	\N
32644	1675	3741919999977	11068	5693	2	0	\N
32645	1675	3741919999977	11469	5895	3	0	\N
32646	1675	3741919999977	11486	5903	0	0	\N
32647	1675	3741919999977	11491	5903	1	0	\N
32648	1675	3741919999977	11995	6173	1	0	\N
32649	1675	3741919999977	12007	6180	1	0	\N
32650	1675	3741919999977	12083	6222	2	0	\N
32651	1675	3741919999977	12240	6302	1	0	\N
32653	1675	3741920999977	11995	6173	2	0	\N
32654	1675	3741920999977	12007	6180	2	0	\N
32655	1675	3741920999977	12240	6302	2	0	\N
32656	1675	3741921999977	12083	6222	3	0	\N
32657	1675	3741929999977	11491	5903	2	0	\N
32658	1675	3741931999977	11469	5895	4	0	\N
32659	1675	3741939999977	11068	5693	3	0	\N
32661	1675	3884117999977	21186	10639	2	0	\N
32663	1675	3884129999977	21186	10639	3	0	\N
32669	1675	4462399999977	12716	6480	61	0	\N
32670	1675	4604129999977	21428	10747	10	0	\N
32673	1675	4604166999977	21428	10747	11	0	\N
32674	1675	5040100000000	3039	1579	1	0	\N
32675	1675	5040100000000	3416	1776	1	0	\N
32677	1675	5040100000000	4499	2326	2	0	\N
32678	1675	5040110000000	3039	1579	2	0	\N
32679	1675	5040110000000	3416	1776	2	0	\N
32680	1675	5040120000000	4499	2326	3	0	\N
32682	1675	5181960999977	12560	6472	4	0	\N
32684	1675	5181982999977	12560	6472	5	0	\N
32686	1675	5182399999977	12716	6480	126	0	\N
32687	1675	5182463999977	12716	6480	127	0	\N
32688	1675	5324140999977	21601	10827	3	0	\N
32689	1675	5324140999977	21670	10855	6	0	\N
32691	1675	5324152999977	21601	10827	4	0	\N
32692	1675	5324164999977	21670	10855	7	0	\N
32696	1675	5901993999977	12728	6564	2	0	\N
32699	1675	5902004999977	12728	6564	3	0	\N
32700	1675	5902463999977	12729	6481	59	0	\N
32701	1675	5902549999977	12729	6481	60	0	\N
32706	1675	6622003999977	12987	6695	2	0	\N
32708	1675	6622014999977	12987	6695	3	0	\N
32710	1675	6622549999977	12817	6482	0	0	\N
32711	1675	6764184999977	21979	10989	3	0	\N
32712	1675	6764184999977	22433	11228	4	0	\N
32713	1675	6764184999977	22635	11320	6	0	\N
32714	1675	6764184999977	22787	11396	4	0	\N
32715	1675	6764184999977	22788	11396	3	0	\N
32717	1675	6764184999977	22941	11441	97	0	\N
32718	1675	6764187999977	22788	11396	4	0	\N
32719	1675	6764196999977	21979	10989	4	0	\N
32721	1675	6764197999977	22433	11228	5	0	\N
32722	1675	6764197999977	22787	11396	5	0	\N
32723	1675	6764208999977	22635	11320	7	0	\N
32724	1675	6764524999977	22941	11441	98	0	\N
32725	1675	6764636999977	22956	11442	22	0	\N
32726	1675	7200270000000	5179	2689	5	0	\N
32729	1675	7200320000000	5179	2689	6	0	\N
32732	1675	7342549999977	12985	6483	1	0	\N
32733	1675	7342559999977	12985	6483	2	0	\N
32736	1675	7484636999977	22956	11442	40	0	\N
32737	1675	7484653999977	22956	11442	41	0	\N
32738	1675	7920319999977	5489	2856	0	0	\N
32741	1675	8062040999977	14398	7347	3	0	\N
32742	1675	8062040999977	14680	7441	33	0	\N
32743	1675	8062040999977	14682	7478	24	0	\N
32745	1675	8062052999977	14398	7347	4	0	\N
32747	1675	8062253999977	14682	7478	25	0	\N
32748	1675	8062370999977	14680	7441	34	0	\N
32751	1675	8640419999977	5877	3047	1	0	\N
32752	1675	8640419999977	6067	3151	3	0	\N
32754	1675	8640429999977	5877	3047	2	0	\N
32756	1675	8640449999977	6067	3151	4	0	\N
32761	1675	9360429999977	6245	3230	1	0	\N
32763	1675	9360439999977	6245	3230	2	0	\N
32765	1675	9502139999977	15047	7666	2	0	\N
32768	1675	9502150999977	15047	7666	3	0	\N
32770	1675	9644245999977	23787	11843	4	0	\N
32772	1675	9644258999977	23787	11843	5	0	\N
32666	1675	4320100000000	2793	1462	2	0	0
32676	1675	5040100000000	4498	2328	5	0	0
32681	1675	5040240000000	4498	2328	6	0	0
32694	1675	5760240000000	4716	2438	1	0	0
32695	1675	5760250000000	4716	2438	2	0	0
32705	1675	6480270000000	4970	2577	3	0	0
32727	1675	7200270000000	5180	2689	5	0	0
32728	1675	7200319999977	5180	2689	7	1	0
32739	1675	7920319999977	5727	2967	1	0	0
32740	1675	7920419999977	5727	2967	2	0	0
32755	1675	8640429999977	6241	3228	2	0	0
32762	1675	9360429999977	6640	3432	2	0	0
32764	1675	9360449999977	6640	3432	3	0	0
32773	1675	10080449999977	6818	3530	2	0	0
32652	1675	3741919999977	12285	6325	4	0	4
32660	1675	3741959999977	12285	6325	5	0	4
32667	1675	4461959999977	12475	6428	1	0	4
32668	1675	4461960999977	12475	6428	2	0	4
32683	1675	5181960999977	12715	6556	6	0	4
32697	1675	5901993999977	12818	6610	1	0	4
32698	1675	5902003999977	12818	6610	2	0	4
32707	1675	6622003999977	14196	7243	6	0	4
32709	1675	6622027999977	14196	7243	7	0	4
32730	1675	7342027999977	14242	7270	4	0	4
32744	1675	8062040999977	14714	7491	10	0	4
32746	1675	8062095999977	14714	7491	11	0	4
32757	1675	8782095999977	14736	7501	8	0	4
32758	1675	8782139999977	14736	7501	9	0	4
32767	1675	9502149999977	15163	7729	2	0	4
32775	1675	10222149999977	15410	7849	4	0	4
32776	1675	10222180999977	15410	7849	5	0	4
32662	1675	3884117999977	21187	10639	2	0	8
32664	1675	3884129999977	21187	10639	3	0	8
32672	1675	4604140999977	21498	10782	3	0	8
32690	1675	5324140999977	21689	10864	5	0	8
32693	1675	5324172999977	21689	10864	6	0	8
32702	1675	6044172999977	21862	10941	3	0	8
32703	1675	6044184999977	21862	10941	4	0	8
32720	1675	6764196999977	22940	11463	4	0	8
32734	1675	7484196999977	22955	11469	3	0	8
32735	1675	7484208999977	22955	11469	4	0	8
32749	1675	8204208999977	23530	11729	3	0	8
32759	1675	8924220999977	23728	11818	7	0	8
32760	1675	8924245999977	23728	11818	8	0	8
32769	1675	9644245999977	23784	11843	2	0	8
32771	1675	9644247999977	23784	11843	3	0	8
32777	1675	10364247999977	23845	11869	3	0	\N
32779	1675	10364259999977	23845	11869	4	0	\N
32782	1675	10800469999977	6866	3546	0	0	\N
32784	1675	10942180999977	15648	7963	4	0	\N
32785	1675	10942180999977	15667	7975	6	0	\N
32786	1675	10942180999977	15670	7975	6	0	\N
32789	1675	10942193999977	15648	7963	5	0	\N
32790	1675	10942204999977	15667	7975	7	0	\N
32791	1675	10942204999977	15670	7975	7	0	\N
32794	1675	11520609999977	6991	3609	4	0	\N
32795	1675	11520609999977	7131	3685	2	0	\N
32797	1675	11520629999977	7131	3685	3	0	\N
32799	1675	11520649999977	6991	3609	5	0	\N
32801	1675	11662192999977	16371	8326	2	0	\N
32802	1675	11662203999977	16371	8326	3	0	\N
32806	1675	11805044999977	24525	12082	39	0	\N
32807	1675	12240639999977	7293	3770	2	0	\N
32810	1675	12240659999977	7293	3770	3	0	\N
32814	1675	12524294999977	24526	12193	2	0	\N
32816	1675	12524305999977	24526	12193	3	0	\N
32817	1675	12525044999977	24525	12082	126	0	\N
32818	1675	12525904999977	24525	12082	127	0	\N
32819	1675	12960649999977	7563	3916	1	0	\N
32820	1675	12960649999977	7772	4030	1	0	\N
32821	1675	12960649999977	7837	4062	1	0	\N
32822	1675	12960649999977	7880	4083	1	0	\N
32824	1675	12960659999977	7563	3916	2	0	\N
32825	1675	12960659999977	7772	4030	2	0	\N
32826	1675	12960659999977	7837	4062	2	0	\N
32827	1675	12960659999977	7880	4083	2	0	\N
32833	1675	13680669999977	8233	4266	3	0	\N
32836	1675	13680699999977	8233	4266	4	0	\N
32837	1675	13822228999977	17389	8808	12	0	\N
32838	1675	13822228999977	18007	9083	10	0	\N
32841	1675	13822265999977	18007	9083	11	0	\N
32842	1675	13822283999977	17389	8808	13	0	\N
32843	1675	13822308999977	18150	9152	13	0	\N
32844	1675	13822308999977	18151	9152	13	0	\N
32845	1675	13822308999977	18152	9152	13	0	\N
32846	1675	13964328999977	24842	12334	3	0	\N
32848	1675	13964340999977	24842	12334	4	0	\N
32852	1675	14401309999977	8975	4488	20	0	\N
32853	1675	14542241999977	18091	9123	3	0	\N
32856	1675	14542253999977	18091	9123	4	0	\N
32857	1675	14542308999977	18150	9152	16	0	\N
32858	1675	14542308999977	18151	9152	16	0	\N
32859	1675	14542308999977	18152	9152	16	0	\N
32860	1675	14542310999977	18150	9152	17	0	\N
32861	1675	14542310999977	18151	9152	17	0	\N
32862	1675	14542310999977	18152	9152	17	0	\N
32867	1675	15121309999977	8975	4488	63	0	\N
32868	1675	15121729999977	8975	4488	64	0	\N
32869	1675	15262252999977	18418	9270	7	0	\N
32871	1675	15262259999977	18418	9270	8	0	\N
32877	1675	15982259999977	18514	9271	56	0	\N
32880	1675	15982391999977	18514	9271	57	0	\N
32885	1675	16702287999977	18519	9327	3	0	\N
32886	1675	16702287999977	18773	9461	2	0	\N
32888	1675	16702298999977	18773	9461	3	0	\N
32889	1675	16702299999977	18519	9327	4	0	\N
32891	1675	16702391999977	18517	9272	4	0	\N
32892	1675	16702395999977	18517	9272	5	0	\N
32893	1675	16844402999977	25699	12716	3	0	\N
32894	1675	16844402999977	25700	12716	3	0	\N
32897	1675	16844414999977	25699	12716	4	0	\N
32898	1675	16844414999977	25700	12716	4	0	\N
32899	1675	16845333999977	26096	12855	92	0	\N
32902	1675	17422299999977	19652	9898	6	0	\N
32904	1675	17422323999977	19652	9898	7	0	\N
32906	1675	17422914999977	20000	10048	78	0	\N
32909	1675	17565333999977	26096	12855	126	0	\N
32910	1675	17565492999977	26096	12855	127	0	\N
32911	1675	18142323999977	19903	10024	3	0	\N
32796	1675	11520609999977	7207	3725	3	0	0
32798	1675	11520639999977	7207	3725	4	0	0
32808	1675	12240639999977	7329	3788	1	0	0
32809	1675	12240649999977	7329	3788	2	0	0
32823	1675	12960649999977	8021	4158	2	0	0
32834	1675	13680669999977	8398	4352	1	0	0
32835	1675	13680679999977	8398	4352	2	0	0
32850	1675	14400679999977	8504	4405	1	0	0
32851	1675	14400689999977	8504	4405	2	0	0
32865	1675	15120689999977	8973	4655	2	0	0
32875	1675	15840709999977	9006	4669	2	0	0
32876	1675	15840729999977	9006	4669	3	0	0
32883	1675	16560729999977	9223	4782	2	0	0
32884	1675	16560749999977	9223	4782	3	0	0
32901	1675	17280769999977	9784	5070	3	0	0
32787	1675	10942180999977	15996	8133	3	0	4
32788	1675	10942192999977	15996	8133	4	0	4
32800	1675	11662192999977	16370	8326	3	0	4
32803	1675	11662204999977	16370	8326	4	0	4
32812	1675	12382216999977	16697	8482	4	0	4
32829	1675	13102216999977	17339	8785	3	0	4
32830	1675	13102228999977	17339	8785	4	0	4
32839	1675	13822228999977	18008	9084	4	0	4
32840	1675	13822241999977	18008	9084	5	0	4
32855	1675	14542252999977	18306	9221	3	0	4
32870	1675	15262252999977	18420	9286	3	0	4
32872	1675	15262264999977	18420	9286	4	0	4
32878	1675	15982264999977	18515	9325	5	0	4
32887	1675	16702287999977	19169	9670	3	0	4
32890	1675	16702299999977	19169	9670	4	0	4
32903	1675	17422299999977	19653	9898	6	0	4
32905	1675	17422323999977	19653	9898	7	0	4
32912	1675	18142323999977	19999	10070	5	0	4
32780	1675	10364260999977	23920	11904	5	0	8
32792	1675	11084260999977	24033	11959	3	0	8
32793	1675	11084272999977	24033	11959	4	0	8
32804	1675	11804272999977	24123	12007	4	0	8
32805	1675	11804294999977	24123	12007	5	0	8
32815	1675	12524305999977	24524	12193	3	0	8
32831	1675	13244305999977	24813	12321	5	0	8
32832	1675	13244328999977	24813	12321	6	0	8
32847	1675	13964328999977	25008	12406	3	0	8
32863	1675	14684340999977	25253	12526	10	0	8
32864	1675	14684377999977	25253	12526	11	0	8
32873	1675	15404377999977	25390	12585	3	0	8
32874	1675	15404389999977	25390	12585	4	0	8
32881	1675	16124389999977	25433	12602	4	0	8
32895	1675	16844402999977	25701	12716	2	0	8
32896	1675	16844413999977	25701	12716	3	0	8
32907	1675	17564413999977	26095	12897	2	0	8
32908	1675	17564424999977	26095	12897	3	0	8
32913	1675	18142335999977	19903	10024	4	0	\N
32915	1675	18142914999977	20000	10048	113	0	\N
32916	1675	18142948999977	20000	10048	114	0	\N
32917	1675	18284424999977	26245	12975	3	0	\N
32919	1675	18284436999977	26245	12975	4	0	\N
32927	1675	21164531999977	27085	13392	6	0	\N
32930	1675	21164555999977	27085	13392	7	0	\N
32931	1675	21884543999977	27340	13516	3	0	\N
32933	1675	21884555999977	27340	13516	4	0	\N
32935	1675	22604567999977	27517	13603	3	0	\N
32938	1675	22604579999977	27517	13603	4	0	\N
32939	1675	22605098999977	27651	13633	52	0	\N
32942	1675	23325098999977	27651	13633	126	0	\N
32943	1675	23325306999977	27651	13633	127	0	\N
32944	1675	23325502999977	27683	13634	52	0	\N
32947	1675	24045502999977	27683	13634	78	0	\N
32948	1675	24045527999977	27683	13634	79	0	\N
32949	1675	24764654999977	27798	13737	4	0	\N
32951	1675	24764667999977	27798	13737	5	0	\N
32955	1675	26204702999977	28072	13880	6	0	\N
32956	1675	26204702999977	28123	13903	2	0	\N
32957	1675	26204702999977	28124	13903	2	0	\N
32959	1675	26204713999977	28123	13903	3	0	\N
32960	1675	26204713999977	28124	13903	3	0	\N
32962	1675	26204726999977	28072	13880	7	0	\N
32965	1675	27644724999977	28158	13925	7	0	\N
32966	1675	27644724999977	28357	14019	2	0	\N
32967	1675	27644724999977	28620	14132	4	0	\N
32969	1675	27644735999977	28357	14019	3	0	\N
32971	1675	27644737999977	28620	14132	5	0	\N
32972	1675	27644758999977	28158	13925	8	0	\N
32975	1675	29084748999977	29905	14734	9	0	\N
32976	1675	29084766474670	29905	14734	12	0	\N
32977	1677	1900	8731	4528	3	0	\N
32978	1677	200000038	13653	7019	5	0	\N
32985	1677	2879040000000	64	36	1	0	\N
32986	1677	2879050000000	64	36	2	0	\N
32988	1677	3599050000000	84	52	3	0	\N
32989	1677	3599050000000	91	57	2	0	\N
32990	1677	3599050000000	107	66	2	0	\N
32993	1677	3599070000000	91	57	3	0	\N
32994	1677	3599070000000	107	66	3	0	\N
32995	1677	3599080000000	84	52	4	0	\N
33000	1677	5759090000000	189	113	1	0	\N
33002	1677	5759100000000	189	113	2	0	\N
33006	1677	7199110000000	226	134	1	0	\N
33008	1677	7199120000000	226	134	2	0	\N
33014	1677	9359160000000	297	171	3	0	\N
33015	1677	9359160000000	310	179	1	0	\N
33017	1677	9359170000000	310	179	2	0	\N
33019	1677	9359190000000	297	171	4	0	\N
33026	1677	12239211000000	354	202	3	0	\N
33027	1677	12239211000000	364	208	1	0	\N
33029	1677	12239221000000	364	208	2	0	\N
33031	1677	12239241000000	354	202	4	0	\N
33036	1677	14399241000000	391	223	1	0	\N
33037	1677	14399241000000	404	230	2	0	\N
33039	1677	14399251000000	391	223	2	0	\N
33041	1677	14399261000000	404	230	3	0	\N
33044	1677	15839271000000	456	257	1	0	\N
33046	1677	15839281000000	456	257	2	0	\N
32981	1677	1439030000000	38	24	4	0	0
32982	1677	2159030000000	44	27	1	0	0
32983	1677	2159040000000	44	27	2	0	0
32984	1677	2159050000000	70	40	1	0	0
32987	1677	2879050000000	70	40	2	0	0
32992	1677	3599060000000	111	67	2	0	0
32996	1677	4319060000000	166	100	1	0	0
32997	1677	4319070000000	166	100	2	0	0
32998	1677	5039070000000	172	103	2	0	0
32999	1677	5039090000000	172	103	3	0	0
33003	1677	5759100000000	205	121	2	0	0
33004	1677	6479100000000	218	129	1	0	0
33005	1677	6479110000000	218	129	2	0	0
33007	1677	7199110000000	250	147	3	0	0
33010	1677	7919140000000	270	157	1	0	0
33011	1677	7919150000000	270	157	2	0	0
33012	1677	8639150000000	274	159	1	0	0
33013	1677	8639160000000	274	159	2	0	0
33016	1677	9359160000000	316	182	1	0	0
33020	1677	10079170000000	318	183	2	0	0
33021	1677	10079181000000	318	183	3	0	0
33022	1677	10799181000000	327	188	2	0	0
33023	1677	10799201000000	327	188	3	0	0
33024	1677	11519201000000	347	198	1	0	0
33028	1677	12239211000000	376	213	1	0	0
33030	1677	12239221000000	376	213	2	0	0
33032	1677	12959221000000	382	218	1	0	0
33033	1677	12959231000000	382	218	2	0	0
33035	1677	13679241000000	386	220	2	0	0
33038	1677	14399241000000	408	232	1	0	0
33040	1677	14399251000000	408	232	2	0	0
33042	1677	15119251000000	417	238	2	0	0
33043	1677	15119271000000	417	238	3	0	0
33047	1677	15839281000000	462	259	2	0	0
33048	1677	16559281000000	472	264	1	0	0
32914	1675	18142436999977	19999	10070	6	0	4
32918	1675	18284424999977	26478	13097	4	0	8
32920	1675	18284437999977	26478	13097	5	0	8
32922	1675	19004461999977	26768	13237	7	0	8
32923	1675	19724461999977	26941	13326	9	0	8
32924	1675	19724497999977	26941	13326	10	0	8
32925	1675	20444497999977	26981	13342	7	0	8
32928	1675	21164531999977	27172	13437	3	0	8
32929	1675	21164543999977	27172	13437	4	0	8
32932	1675	21884543999977	27389	13542	6	0	8
32934	1675	21884567999977	27389	13542	7	0	8
32936	1675	22604567999977	27518	13603	2	0	8
32940	1675	23324578999977	27650	13664	10	0	8
32941	1675	23324642999977	27650	13664	11	0	8
32945	1675	24044642999977	27682	13679	3	0	8
32946	1675	24044654999977	27682	13679	4	0	8
32950	1675	24764654999977	27925	13813	4	0	8
32953	1675	25484676999977	27978	13838	8	0	8
32954	1675	25484702999977	27978	13838	9	0	8
32958	1675	26204702999977	28125	13903	2	0	8
32961	1675	26204713999977	28125	13903	3	0	8
32964	1675	26924724999977	28151	13919	3	0	8
32968	1675	27644724999977	28725	14176	2	0	8
32970	1675	27644735999977	28725	14176	3	0	8
32973	1675	28364735999977	29455	14525	4	0	8
32974	1675	28364748999977	29455	14525	5	0	8
33050	1677	17279291000000	473	265	3	0	\N
33053	1677	17279321000000	473	265	4	0	\N
33058	1677	19439341000000	593	336	1	0	\N
33060	1677	19439351000000	593	336	2	0	\N
33062	1677	20159361000000	600	341	1	0	\N
33063	1677	20159361000000	609	344	1	0	\N
33064	1677	20159361000000	611	345	1	0	\N
33066	1677	20159371000000	600	341	2	0	\N
33067	1677	20159371000000	609	344	2	0	\N
33068	1677	20159371000000	611	345	2	0	\N
33070	1677	20879371000000	625	351	2	0	\N
33071	1677	20879371000000	632	354	1	0	\N
33073	1677	20879381000000	632	354	2	0	\N
33075	1677	20879391000000	625	351	3	0	\N
33080	1677	22319431000000	652	365	2	0	\N
33081	1677	23039411000000	661	368	4	0	\N
33082	1677	23039411000000	668	371	1	0	\N
33084	1677	23039421000000	668	371	2	0	\N
33086	1677	23039431000000	652	365	5	0	\N
33087	1677	23039451000000	652	365	6	0	\N
33088	1677	23039451000000	661	368	5	0	\N
33089	1677	23759421000000	678	378	1	0	\N
33091	1677	23759431000000	678	378	2	0	\N
33093	1677	24479441000000	716	399	0	0	\N
33100	1677	26639571000000	785	435	3	0	\N
33103	1677	26639601000000	785	435	4	0	\N
33104	1677	27359581000000	824	455	2	0	\N
33105	1677	27359581000000	828	456	1	0	\N
33107	1677	27359591000000	828	456	2	0	\N
33109	1677	27359601000000	824	455	3	0	\N
33118	1677	29519621000000	894	496	1	0	\N
33120	1677	29519631000000	894	496	2	0	\N
33129	1677	30959671000000	929	517	1	0	\N
33130	1677	30959671000000	931	518	2	0	\N
33132	1677	30959681000000	929	517	2	0	\N
33133	1677	30959691000000	931	518	3	0	\N
33135	1677	31608241325000	10541	5446	2	0	\N
33136	1677	31608241325000	10547	5447	5	0	\N
33137	1677	31608261325000	10541	5446	3	0	\N
33139	1677	31608282325000	10547	5447	6	0	\N
33140	1677	31679691000000	935	520	1	0	\N
33141	1677	31679691000000	943	525	1	0	\N
33142	1677	31679691000000	948	528	1	0	\N
33143	1677	31679691000000	960	535	6	0	\N
33144	1677	31679691000000	962	536	2	0	\N
33146	1677	31679701000000	935	520	2	0	\N
33147	1677	31679701000000	943	525	2	0	\N
33148	1677	31679701000000	948	528	2	0	\N
33149	1677	31679711000000	962	536	3	0	\N
33151	1677	31679751000000	960	535	7	0	\N
33152	1677	32328261325000	10593	5471	2	0	\N
33153	1677	32328261325000	10601	5476	2	0	\N
33154	1677	32328261325000	10607	5479	2	0	\N
33156	1677	32328281325000	10593	5471	3	0	\N
33157	1677	32328281325000	10601	5476	3	0	\N
33158	1677	32328281325000	10607	5479	3	0	\N
33160	1677	32399711000000	981	544	1	0	\N
33162	1677	32399721000000	981	544	2	0	\N
33166	1677	33119721000000	1003	555	1	0	\N
33168	1677	33119731000000	1003	555	2	0	\N
33172	1677	33839731000000	1044	580	1	0	\N
33173	1677	33839731000000	1057	586	17	0	\N
33175	1677	33839741000000	1044	580	2	0	\N
33177	1677	33839901000000	1057	586	18	0	\N
33178	1677	34488321325000	10656	5504	4	0	\N
33180	1677	34488361325000	10656	5504	5	0	\N
33184	1677	35208381325000	10676	5511	2	0	\N
33052	1677	17279301000000	525	296	2	0	0
33054	1677	17999301000000	533	303	1	0	0
33055	1677	17999311000000	533	303	2	0	0
33056	1677	18719311000000	579	327	3	0	0
33057	1677	18719341000000	579	327	4	0	0
33061	1677	19439361000000	596	338	3	0	0
33065	1677	20159361000000	615	346	1	0	0
33069	1677	20159371000000	615	346	2	0	0
33072	1677	20879371000000	634	356	1	0	0
33074	1677	20879381000000	634	356	2	0	0
33077	1677	21599391000000	638	358	2	0	0
33078	1677	22319391000000	646	362	2	0	0
33079	1677	22319411000000	646	362	3	0	0
33083	1677	23039411000000	673	375	1	0	0
33090	1677	23759421000000	698	388	2	0	0
33092	1677	23759441000000	698	388	3	0	0
33094	1677	24479441000000	719	402	2	0	0
33095	1677	24479551000000	719	402	3	0	0
33096	1677	25199551000000	749	420	1	0	0
33098	1677	25919561000000	769	427	1	0	0
33099	1677	25919571000000	769	427	2	0	0
33101	1677	26639571000000	808	447	1	0	0
33102	1677	26639581000000	808	447	2	0	0
33106	1677	27359581000000	846	467	1	0	0
33110	1677	28079591000000	875	485	2	0	0
33111	1677	28079611000000	875	485	3	0	0
33114	1677	28799611000000	878	488	1	0	0
33115	1677	28799621000000	878	488	2	0	0
33121	1677	29519631000000	914	508	2	0	0
33124	1677	30239631000000	917	510	4	0	0
33125	1677	30239671000000	917	510	5	0	0
33131	1677	30959671000000	933	519	2	0	0
33134	1677	30959691000000	933	519	3	0	0
33150	1677	31679711000000	964	537	3	0	0
33161	1677	32399711000000	983	545	1	0	0
33163	1677	32399721000000	983	545	2	0	0
33167	1677	33119721000000	1019	564	1	0	0
33169	1677	33119731000000	1019	564	2	0	0
33176	1677	33839761000000	1061	588	4	0	0
33182	1677	34559761000000	1069	593	1	0	0
33183	1677	34559771000000	1069	593	2	0	0
33112	1677	28728051325000	10461	5407	5	0	1
33116	1677	29448101325000	10469	5410	4	0	1
33117	1677	29448141325000	10469	5410	5	0	1
33122	1677	30168141325000	10525	5435	8	0	1
33123	1677	30168221325000	10525	5435	9	0	1
33126	1677	30888221325000	10537	5442	2	0	1
33128	1677	30888261325000	10583	5466	2	0	1
33138	1677	31608261325000	10583	5466	3	0	1
33155	1677	32328261325000	10615	5483	2	0	1
33159	1677	32328281325000	10615	5483	3	0	1
33164	1677	33048281325000	10624	5487	2	0	1
33170	1677	33768301325000	10641	5497	2	0	1
33171	1677	33768321325000	10641	5497	3	0	1
33179	1677	34488321325000	10671	5509	6	0	1
33181	1677	34488381325000	10671	5509	7	0	1
33186	1677	35208401325000	10676	5511	3	0	\N
33190	1677	35928401325000	10681	5514	2	0	\N
33192	1677	35928421325000	10681	5514	3	0	\N
33194	1677	35999811000000	1097	607	1	0	\N
33196	1677	35999821000000	1097	607	2	0	\N
33198	1677	36648464325000	10738	5543	2	0	\N
33200	1677	36648484325000	10738	5543	3	0	\N
33212	1677	38808535325000	10782	5565	4	0	\N
33215	1677	38808575325000	10782	5565	5	0	\N
33227	1677	41039881000000	1222	674	3	0	\N
33230	1677	41039911000000	1222	674	4	0	\N
33233	1677	41759891000000	1251	692	1	0	\N
33235	1677	41759901000000	1251	692	2	0	\N
33237	1677	42408645325000	10914	5630	8	0	\N
33238	1677	42408645325000	10949	5643	6	0	\N
33241	1677	42408705325000	10949	5643	7	0	\N
33242	1677	42408725325000	10914	5630	9	0	\N
33247	1677	43199921000000	1260	697	1	0	\N
33248	1677	43199921000000	1282	709	1	0	\N
33250	1677	43199931000000	1260	697	2	0	\N
33251	1677	43199931000000	1282	709	2	0	\N
33253	1677	43848676325000	11001	5667	1	0	\N
33254	1677	43848676325000	11007	5668	4	0	\N
33255	1677	43848676325000	11024	5675	1	0	\N
33256	1677	43848676325000	11054	5687	4	0	\N
33257	1677	43848676325000	11063	5691	4	0	\N
33258	1677	43848676325000	11071	5695	2	0	\N
33259	1677	43848676325000	11080	5700	2	0	\N
33260	1677	43848676325000	11122	5718	2	0	\N
33262	1677	43848686325000	11001	5667	2	0	\N
33263	1677	43848686325000	11024	5675	2	0	\N
33264	1677	43848696325000	11071	5695	3	0	\N
33265	1677	43848696325000	11080	5700	3	0	\N
33266	1677	43848696325000	11122	5718	3	0	\N
33268	1677	43848716325000	11007	5668	5	0	\N
33269	1677	43848716325000	11054	5687	5	0	\N
33270	1677	43848716325000	11063	5691	5	0	\N
33273	1677	44568696325000	11146	5728	4	0	\N
33274	1677	44568696325000	11148	5729	2	0	\N
33276	1677	44568716325000	11148	5729	3	0	\N
33278	1677	44568736325000	11146	5728	5	0	\N
33287	1677	46080001000000	1360	746	1	0	\N
33289	1677	46080011000000	1360	746	2	0	\N
33291	1677	46728766325000	11228	5770	5	0	\N
33294	1677	46728807325000	11228	5770	6	0	\N
33295	1677	46800011000000	1376	754	1	0	\N
33296	1677	46800011000000	1407	768	2	0	\N
33298	1677	46800021000000	1376	754	2	0	\N
33299	1677	46800031000000	1407	768	3	0	\N
33305	1677	47520061000000	1481	808	2	0	\N
33306	1677	48168870325000	11256	5784	0	0	\N
33309	1677	48240041000000	1485	811	2	0	\N
33311	1677	48240052000000	1485	811	3	0	\N
33312	1677	48240061000000	1481	808	3	0	\N
33314	1677	48888932325000	11297	5803	2	0	\N
33316	1677	48888943325000	11297	5803	3	0	\N
33195	1677	35999811000000	1101	609	1	0	0
33197	1677	35999821000000	1101	609	2	0	0
33202	1677	36719821000000	1147	632	1	0	0
33203	1677	36719831000000	1147	632	2	0	0
33206	1677	37439831000000	1159	639	1	0	0
33210	1677	38159841000000	1169	643	1	0	0
33211	1677	38159851000000	1169	643	2	0	0
33216	1677	38879851000000	1173	646	1	0	0
33217	1677	38879861000000	1173	646	2	0	0
33219	1677	39599861000000	1204	664	1	0	0
33223	1677	40319871000000	1214	668	1	0	0
33224	1677	40319881000000	1214	668	2	0	0
33228	1677	41039881000000	1244	689	1	0	0
33229	1677	41039891000000	1244	689	2	0	0
33236	1677	41759911000000	1252	693	3	0	0
33243	1677	42479911000000	1257	695	1	0	0
33244	1677	42479921000000	1257	695	2	0	0
33249	1677	43199921000000	1289	712	1	0	0
33252	1677	43199931000000	1289	712	2	0	0
33272	1677	43919971000000	1299	716	5	0	0
33280	1677	44639971000000	1355	743	2	0	0
33281	1677	44639991000000	1355	743	3	0	0
33283	1677	45359991000000	1358	745	1	0	0
33284	1677	45360001000000	1358	745	2	0	0
33290	1677	46080011000000	1365	748	2	0	0
33297	1677	46800011000000	1436	782	2	0	0
33300	1677	46800031000000	1436	782	3	0	0
33303	1677	47520031000000	1470	802	1	0	0
33310	1677	48240041000000	1487	812	2	0	0
33313	1677	48240061000000	1487	812	3	0	0
33318	1677	48960061000000	1504	824	1	0	0
33319	1677	48960071000000	1504	824	2	0	0
33185	1677	35208381325000	10678	5512	2	0	1
33191	1677	35928401325000	10726	5536	7	0	1
33193	1677	35928464325000	10726	5536	8	0	1
33199	1677	36648464325000	10763	5555	2	0	1
33201	1677	36648484325000	10763	5555	3	0	1
33204	1677	37368484325000	10768	5558	2	0	1
33208	1677	38088495325000	10774	5561	4	0	1
33209	1677	38088535325000	10774	5561	5	0	1
33213	1677	38808535325000	10818	5582	3	0	1
33214	1677	38808565325000	10818	5582	4	0	1
33221	1677	40248565325000	10846	5598	2	0	1
33222	1677	40248585325000	10846	5598	3	0	1
33225	1677	40968585325000	10852	5602	4	0	1
33226	1677	40968625325000	10852	5602	5	0	1
33231	1677	41688625325000	10864	5607	2	0	1
33239	1677	42408645325000	10953	5644	1	0	1
33240	1677	42408655325000	10953	5644	2	0	1
33245	1677	43128655325000	10980	5657	3	0	1
33246	1677	43128676325000	10980	5657	4	0	1
33261	1677	43848676325000	11139	5725	2	0	1
33275	1677	44568696325000	11214	5760	3	0	1
33277	1677	44568726325000	11214	5760	4	0	1
33279	1677	44568746325000	11221	5765	2	0	1
33282	1677	45288746325000	11221	5765	3	0	1
33286	1677	46008766325000	11225	5768	3	0	1
33292	1677	46728766325000	11241	5775	6	0	1
33293	1677	46728799325000	11241	5775	7	0	1
33301	1677	47448799325000	11254	5783	8	0	1
33302	1677	47448870325000	11254	5783	9	0	1
33308	1677	48168932325000	11276	5793	9	0	1
33315	1677	48888932325000	11325	5815	2	0	1
33317	1677	48888943325000	11325	5815	3	0	1
33320	1677	49608943325000	11331	5819	2	0	1
33328	1677	51048965325000	11397	5852	2	0	\N
33331	1677	51048976325000	11397	5852	3	0	\N
33338	1677	52488997325000	11425	5869	2	0	\N
33339	1677	52488997325000	11448	5880	1	0	\N
33341	1677	52489007325000	11448	5880	2	0	\N
33342	1677	52489008325000	11425	5869	3	0	\N
33350	1677	53929029325000	11487	5903	1	0	\N
33352	1677	53929039325000	11487	5903	2	0	\N
33358	1677	54649093325000	11534	5927	4	0	\N
33361	1677	55369062325000	11528	5921	5	0	\N
33362	1677	55369062325000	11538	5928	7	0	\N
33365	1677	55369085325000	11528	5921	6	0	\N
33366	1677	55369093325000	11534	5927	5	0	\N
33367	1677	55369105325000	11538	5928	8	0	\N
33370	1677	56089073325000	11552	5935	1	0	\N
33372	1677	56089074325000	11552	5935	2	0	\N
33374	1677	56160231000000	1621	875	1	0	\N
33375	1677	56160231000000	1662	894	4	0	\N
33376	1677	56160231000000	1722	924	4	0	\N
33377	1677	56160231000000	1741	934	2	0	\N
33378	1677	56160231000000	1748	937	2	0	\N
33379	1677	56160231000000	1758	941	2	0	\N
33380	1677	56160231000000	1760	942	1	0	\N
33382	1677	56160241000000	1621	875	2	0	\N
33383	1677	56160241000000	1760	942	2	0	\N
33384	1677	56160251000000	1741	934	3	0	\N
33385	1677	56160251000000	1748	937	3	0	\N
33386	1677	56160251000000	1758	941	3	0	\N
33387	1677	56160271000000	1662	894	5	0	\N
33388	1677	56160271000000	1722	924	5	0	\N
33392	1677	56880351000000	1832	979	1	0	\N
33394	1677	56880361000000	1832	979	2	0	\N
33398	1677	57600361000000	1866	994	1	0	\N
33400	1677	57600371000000	1866	994	2	0	\N
33402	1677	58249076325000	11623	5982	3	0	\N
33404	1677	58249079325000	11623	5982	4	0	\N
33407	1677	58969076325000	11652	5993	2	0	\N
33408	1677	58969076325000	11670	5999	1	0	\N
33410	1677	58969077325000	11670	5999	2	0	\N
33412	1677	58969078325000	11652	5993	3	0	\N
33419	1677	60409079325000	11685	6007	9	0	\N
33422	1677	60409223325000	11685	6007	10	0	\N
33423	1677	60480421000000	1933	1028	1	0	\N
33424	1677	60480421000000	1937	1029	1	0	\N
33425	1677	60480421000000	1981	1047	1	0	\N
33427	1677	60480431000000	1933	1028	2	0	\N
33428	1677	60480431000000	1937	1029	2	0	\N
33429	1677	60480431000000	1981	1047	2	0	\N
33435	1677	61849081325000	11736	6031	7	0	\N
33438	1677	61849124325000	11736	6031	8	0	\N
33443	1677	62640471000000	2016	1063	3	0	\N
33446	1677	62640501000000	2016	1063	4	0	\N
33447	1677	63289083325000	11767	6050	2	0	\N
33448	1677	63289083325000	11769	6051	3	0	\N
33451	1677	63289094325000	11767	6050	3	0	\N
33452	1677	63289104325000	11769	6051	4	0	\N
33455	1677	64009084325000	11814	6070	1	0	\N
33326	1677	50400111000000	1542	842	1	0	0
33327	1677	50400121000000	1542	842	2	0	0
33332	1677	51120121000000	1546	843	1	0	0
33333	1677	51120131000000	1546	843	2	0	0
33336	1677	51840131000000	1559	849	2	0	0
33344	1677	52560151000000	1563	851	1	0	0
33345	1677	52560161000000	1563	851	2	0	0
33348	1677	53280161000000	1581	860	3	0	0
33349	1677	53280191000000	1581	860	4	0	0
33354	1677	54000191000000	1589	863	1	0	0
33359	1677	54720201000000	1591	865	2	0	0
33360	1677	54720221000000	1591	865	3	0	0
33368	1677	55440221000000	1610	871	1	0	0
33369	1677	55440231000000	1610	871	2	0	0
33389	1677	56160351000000	1798	962	4	0	0
33393	1677	56880351000000	1851	987	1	0	0
33395	1677	56880361000000	1851	987	2	0	0
33399	1677	57600361000000	1867	995	1	0	0
33401	1677	57600371000000	1867	995	2	0	0
33406	1677	58320401000000	1896	1010	4	0	0
33413	1677	59040401000000	1917	1022	1	0	0
33414	1677	59040411000000	1917	1022	2	0	0
33417	1677	59760411000000	1920	1023	1	0	0
33418	1677	59760421000000	1920	1023	2	0	0
33430	1677	60480431000000	1993	1053	2	0	0
33433	1677	61200431000000	2003	1058	1	0	0
33434	1677	61200441000000	2003	1058	2	0	0
33439	1677	61920441000000	2008	1060	3	0	0
33444	1677	62640471000000	2038	1075	2	0	0
33445	1677	62640491000000	2038	1075	3	0	0
33453	1677	63360491000000	2040	1077	2	0	0
33454	1677	63360511000000	2040	1077	3	0	0
33321	1677	49608954325000	11331	5819	3	0	1
33325	1677	50328965325000	11351	5829	3	0	1
33329	1677	51048965325000	11398	5853	1	0	1
33330	1677	51048975325000	11398	5853	2	0	1
33334	1677	51768975325000	11421	5867	4	0	1
33335	1677	51768997325000	11421	5867	5	0	1
33343	1677	52489008325000	11467	5894	3	0	1
33346	1677	53209008325000	11473	5897	3	0	1
33347	1677	53209029325000	11473	5897	4	0	1
33351	1677	53929029325000	11521	5917	4	0	1
33356	1677	54649051325000	11522	5918	2	0	1
33357	1677	54649062325000	11522	5918	3	0	1
33363	1677	55369062325000	11543	5929	2	0	1
33364	1677	55369073325000	11543	5929	3	0	1
33371	1677	56089073325000	11579	5955	1	0	1
33390	1677	56809074325000	11614	5976	1	0	1
33391	1677	56809075325000	11614	5976	2	0	1
33396	1677	57529075325000	11620	5980	1	0	1
33397	1677	57529076325000	11620	5980	2	0	1
33403	1677	58249076325000	11638	5989	0	0	1
33411	1677	58969077325000	11675	6002	2	0	1
33415	1677	59689077325000	11681	6006	2	0	1
33416	1677	59689079325000	11681	6006	3	0	1
33420	1677	60409079325000	11698	6015	1	0	1
33431	1677	61129080325000	11707	6020	1	0	1
33432	1677	61129081325000	11707	6020	2	0	1
33436	1677	61849081325000	11740	6033	1	0	1
33437	1677	61849082325000	11740	6033	2	0	1
33441	1677	62569082325000	11751	6040	1	0	1
33449	1677	63289083325000	11794	6061	1	0	1
33450	1677	63289084325000	11794	6061	2	0	1
33456	1677	64009084325000	11876	6103	1	0	1
33457	1677	64009085325000	11814	6070	2	0	\N
33467	1677	65520541000000	2069	1093	1	0	\N
33469	1677	65520551000000	2069	1093	2	0	\N
33475	1677	66889090325000	12020	6186	1	0	\N
33477	1677	66889091325000	12020	6186	2	0	\N
33480	1677	66960561000000	2116	1116	2	0	\N
33483	1677	66960581000000	2116	1116	3	0	\N
33486	1677	67680571000000	2198	1157	1	0	\N
33487	1677	67680571000000	2238	1179	1	0	\N
33489	1677	67680581000000	2198	1157	2	0	\N
33490	1677	67680581000000	2238	1179	2	0	\N
33494	1677	68400681000000	2289	1201	0	0	\N
33497	1677	69049096325000	12089	6224	2	0	\N
33499	1677	69049098325000	12089	6224	3	0	\N
33504	1677	69840721000000	2332	1220	3	0	\N
33505	1677	69840721000000	2375	1242	1	0	\N
33507	1677	69840731000000	2375	1242	2	0	\N
33509	1677	69840751000000	2332	1220	4	0	\N
33519	1677	72000751000000	2473	1295	1	0	\N
33520	1677	72000751000000	2477	1298	1	0	\N
33522	1677	72000761000000	2473	1295	2	0	\N
33523	1677	72000761000000	2477	1298	2	0	\N
33529	1677	73369104325000	12163	6262	5	0	\N
33530	1677	73369104325000	12174	6268	3	0	\N
33532	1677	73369107325000	12174	6268	4	0	\N
33533	1677	73369109325000	12163	6262	6	0	\N
33543	1677	74880821000000	2568	1353	1	0	\N
33545	1677	74880831000000	2568	1353	2	0	\N
33553	1677	76320851000000	2583	1362	1	0	\N
33554	1677	76320851000000	2603	1370	2	0	\N
33556	1677	76320861000000	2583	1362	2	0	\N
33558	1677	76320871000000	2603	1370	3	0	\N
33561	1677	77040861000000	2638	1388	1	0	\N
33562	1677	77040861000000	2692	1414	2	0	\N
33564	1677	77040871000000	2638	1388	2	0	\N
33566	1677	77040881000000	2692	1414	3	0	\N
33571	1677	78409132325000	12264	6314	1	0	\N
33573	1677	78409133325000	12264	6314	2	0	\N
33577	1677	79129133325000	12296	6332	4	0	\N
33580	1677	79129335325000	12296	6332	5	0	\N
33585	1677	79920921000000	2719	1429	2	0	\N
33586	1677	79920921000000	2724	1431	2	0	\N
33589	1677	79920941000000	2719	1429	3	0	\N
33590	1677	79920941000000	2724	1431	3	0	\N
33591	1677	80569136325000	12363	6374	1	0	\N
33463	1677	64800531000000	2060	1088	1	0	0
33464	1677	64800541000000	2060	1088	2	0	0
33468	1677	65520541000000	2093	1105	1	0	0
33470	1677	65520551000000	2093	1105	2	0	0
33473	1677	66240551000000	2101	1109	1	0	0
33481	1677	66960561000000	2141	1129	1	0	0
33482	1677	66960571000000	2141	1129	2	0	0
33488	1677	67680571000000	2243	1182	2	0	0
33491	1677	67680681000000	2243	1182	3	0	0
33495	1677	68400681000000	2296	1204	2	0	0
33501	1677	69120701000000	2326	1219	2	0	0
33502	1677	69120721000000	2326	1219	3	0	0
33506	1677	69840721000000	2396	1253	1	0	0
33508	1677	69840731000000	2396	1253	2	0	0
33513	1677	70560741000000	2398	1255	2	0	0
33516	1677	71280741000000	2464	1290	1	0	0
33517	1677	71280751000000	2464	1290	2	0	0
33521	1677	72000751000000	2494	1306	2	0	0
33524	1677	72000771000000	2494	1306	3	0	0
33528	1677	72720781000000	2513	1319	2	0	0
33535	1677	73440781000000	2517	1322	3	0	0
33536	1677	73440811000000	2517	1322	4	0	0
33539	1677	74160811000000	2550	1342	1	0	0
33540	1677	74160821000000	2550	1342	2	0	0
33546	1677	74880841000000	2571	1354	3	0	0
33549	1677	75600841000000	2576	1359	1	0	0
33550	1677	75600851000000	2576	1359	2	0	0
33555	1677	76320851000000	2625	1381	1	0	0
33563	1677	77040861000000	2697	1418	1	0	0
33565	1677	77040871000000	2697	1418	2	0	0
33569	1677	77760871000000	2700	1419	1	0	0
33570	1677	77760881000000	2700	1419	2	0	0
33575	1677	78480881000000	2705	1421	1	0	0
33581	1677	79200891000000	2715	1426	3	0	0
33582	1677	79200921000000	2715	1426	4	0	0
33587	1677	79920921000000	2730	1433	1	0	0
33588	1677	79920931000000	2730	1433	2	0	0
33458	1677	64009085325000	11876	6103	2	0	1
33462	1677	64729086325000	11922	6134	2	0	1
33465	1677	65449086325000	11925	6137	2	0	1
33466	1677	65449088325000	11925	6137	3	0	1
33471	1677	66169088325000	11946	6151	2	0	1
33476	1677	66889090325000	12070	6213	2	0	1
33478	1677	66889092325000	12070	6213	3	0	1
33479	1677	66889093325000	12073	6216	1	0	1
33484	1677	67609093325000	12073	6216	3	0	1
33485	1677	67609094325000	12073	6216	4	0	1
33493	1677	68329096325000	12086	6222	3	0	1
33498	1677	69049096325000	12095	6227	3	0	1
33500	1677	69049099325000	12095	6227	4	0	1
33503	1677	69769099325000	12107	6234	0	0	1
33510	1677	70489099325000	12126	6245	1	0	1
33514	1677	71209100325000	12134	6248	3	0	1
33515	1677	71209103325000	12134	6248	4	0	1
33518	1677	71929103325000	12140	6253	0	0	1
33525	1677	72649103325000	12152	6259	1	0	1
33531	1677	73369104325000	12199	6282	3	0	1
33534	1677	73369126325000	12199	6282	4	0	1
33537	1677	74089126325000	12214	6292	1	0	1
33538	1677	74089127325000	12214	6292	2	0	1
33541	1677	74809127325000	12223	6296	1	0	1
33547	1677	75529128325000	12227	6298	1	0	1
33548	1677	75529129325000	12227	6298	2	0	1
33551	1677	76249129325000	12243	6304	1	0	1
33552	1677	76249130325000	12243	6304	2	0	1
33559	1677	76969130325000	12253	6309	1	0	1
33567	1677	77689131325000	12258	6312	1	0	1
33568	1677	77689132325000	12258	6312	2	0	1
33572	1677	78409132325000	12283	6323	1	0	1
33574	1677	78409133325000	12283	6323	2	0	1
33579	1677	79129134325000	12334	6357	2	0	1
33583	1677	79849134325000	12342	6361	2	0	1
33584	1677	79849136325000	12342	6361	3	0	1
33592	1677	80569136325000	12365	6376	2	0	1
33593	1677	80569137325000	12363	6374	2	0	\N
33596	1677	80640931000000	2745	1440	1	0	\N
33597	1677	80640931000000	2755	1442	2	0	\N
33599	1677	80640941000000	2745	1440	2	0	\N
33601	1677	80640951000000	2755	1442	3	0	\N
33602	1677	81289138325000	12375	6382	1	0	\N
33603	1677	81289138325000	12388	6390	1	0	\N
33604	1677	81289139325000	12375	6382	2	0	\N
33605	1677	81289139325000	12388	6390	2	0	\N
33608	1677	81360941000000	2795	1463	1	0	\N
33610	1677	81360951000000	2795	1463	2	0	\N
33612	1677	82009140325000	12421	6399	1	0	\N
33614	1677	82009141325000	12421	6399	2	0	\N
33617	1677	82729140325000	12444	6414	0	0	\N
33619	1677	82729141325000	12422	6400	0	0	\N
33621	1677	83449140325000	12461	6420	1	0	\N
33623	1677	83449141325000	12423	6401	0	0	\N
33624	1677	83449141325000	12461	6420	2	0	\N
33632	1677	84960992000000	2848	1492	0	0	\N
33639	1677	86400992000000	2901	1515	0	0	\N
33658	1677	89281082000000	2983	1552	1	0	\N
33659	1677	89281092000000	2983	1552	2	0	\N
33662	1677	90000992000000	2997	1558	1	0	\N
33664	1677	90001092000000	2997	1558	2	0	\N
33670	1677	91440992000000	3020	1568	1	0	\N
33672	1677	91441002000000	3020	1568	2	0	\N
33674	1677	92089242325000	12647	6523	2	0	\N
33676	1677	92089253325000	12647	6523	3	0	\N
33681	1677	92809276325000	12680	6539	2	0	\N
33682	1677	92809287325000	12680	6539	3	0	\N
33691	1677	94249308323100	12713	6555	2	0	\N
33692	1677	94249308323100	12734	6565	2	0	\N
33693	1677	94249308323100	12748	6572	5	0	\N
33694	1677	94249308323100	12754	6575	11	0	\N
33696	1677	94249319323100	12713	6555	3	0	\N
33697	1677	94249319323100	12734	6565	3	0	\N
33699	1677	94249331323100	12748	6572	6	0	\N
33700	1677	94249373323100	12754	6575	12	0	\N
33701	1677	94321072000000	3098	1608	1	0	\N
33703	1677	94321082000000	3098	1608	2	0	\N
33707	1677	95041082000000	3115	1618	3	0	\N
33709	1677	95041112000000	3115	1618	4	0	\N
33713	1677	95761122000000	3146	1636	1	0	\N
33715	1677	95761132000000	3146	1636	2	0	\N
33719	1677	96481132000000	3177	1650	2	0	\N
33722	1677	96481152000000	3177	1650	3	0	\N
33723	1677	97129343323100	12800	6600	2	0	\N
33724	1677	97129343323100	12805	6603	2	0	\N
33726	1677	97129354323100	12800	6600	3	0	\N
33727	1677	97129354323100	12805	6603	3	0	\N
33609	1677	81360941000000	2799	1464	4	0	0
33611	1677	81360981000000	2799	1464	5	0	0
33615	1677	82080981000000	2825	1475	2	0	0
33616	1677	82080992000000	2825	1475	3	0	0
33620	1677	82800992000000	2826	1476	0	0	0
33629	1677	84240992000000	2837	1483	0	0	0
33633	1677	84960992000000	2853	1494	0	0	0
33636	1677	85680992000000	2868	1501	0	0	0
33640	1677	86400992000000	2952	1535	4	0	0
33641	1677	86401032000000	2952	1535	5	0	0
33645	1677	87121042000000	2968	1542	2	0	0
33648	1677	87841042000000	2970	1544	1	0	0
33649	1677	87841052000000	2970	1544	2	0	0
33652	1677	88561052000000	2971	1545	3	0	0
33656	1677	89280982000000	2992	1555	1	0	0
33657	1677	89280992000000	2992	1555	2	0	0
33663	1677	90000992000000	3002	1560	0	0	0
33667	1677	90720992000000	3009	1562	0	0	0
33671	1677	91440992000000	3047	1583	2	0	0
33679	1677	92161012000000	3052	1587	2	0	0
33680	1677	92161032000000	3052	1587	3	0	0
33685	1677	92881032000000	3077	1599	1	0	0
33686	1677	92881042000000	3077	1599	2	0	0
33689	1677	93601042000000	3096	1607	3	0	0
33702	1677	94321072000000	3100	1609	1	0	0
33704	1677	94321082000000	3100	1609	2	0	0
33708	1677	95041082000000	3124	1624	4	0	0
33710	1677	95041122000000	3124	1624	5	0	0
33716	1677	95761132000000	3156	1641	2	0	0
33720	1677	96481132000000	3182	1652	1	0	0
33721	1677	96481142000000	3182	1652	2	0	0
33594	1677	80569138325000	12365	6376	3	0	1
33595	1677	80569139325000	12391	6391	1	0	1
33607	1677	81289140325000	12391	6391	4	0	1
33613	1677	82009140325000	12430	6408	0	0	1
33618	1677	82729140325000	12451	6417	0	0	1
33622	1677	83449140325000	12481	6432	1	0	1
33625	1677	83449141325000	12481	6432	2	0	1
33628	1677	84169152325000	12500	6440	3	0	1
33630	1677	84889152325000	12507	6443	1	0	1
33631	1677	84889153325000	12507	6443	2	0	1
33634	1677	85609153325000	12514	6449	2	0	1
33637	1677	86329164325000	12515	6450	2	0	1
33638	1677	86329175325000	12515	6450	3	0	1
33642	1677	87049175325000	12519	6452	2	0	1
33643	1677	87049186325000	12519	6452	3	0	1
33646	1677	87769186325000	12529	6457	1	0	1
33650	1677	88489187325000	12566	6476	2	0	1
33651	1677	88489198325000	12566	6476	3	0	1
33654	1677	89209198325000	12571	6478	2	0	1
33655	1677	89209209325000	12571	6478	3	0	1
33660	1677	89929209325000	12597	6495	2	0	1
33665	1677	90649220325000	12600	6498	2	0	1
33666	1677	90649231325000	12600	6498	3	0	1
33668	1677	91369231325000	12611	6505	2	0	1
33669	1677	91369242325000	12611	6505	3	0	1
33677	1677	92089276325000	12650	6525	8	0	1
33678	1677	92089296325000	12681	6540	2	0	1
33683	1677	92809296325000	12681	6540	5	0	1
33684	1677	92809298323100	12681	6540	6	0	1
33687	1677	93529298323100	12693	6545	1	0	1
33695	1677	94249308323100	12767	6583	2	0	1
33698	1677	94249319323100	12767	6583	3	0	1
33705	1677	94969319323100	12778	6587	2	0	1
33706	1677	94969330323100	12778	6587	3	0	1
33711	1677	95689330323100	12780	6588	1	0	1
33717	1677	96409331323100	12788	6593	3	0	1
33718	1677	96409343323100	12788	6593	4	0	1
33725	1677	97129343323100	12821	6613	2	0	1
33728	1677	97129363323100	12821	6613	3	0	1
33731	1677	97849363323100	12833	6619	1	0	\N
33732	1677	97849363323100	12844	6623	2	0	\N
33734	1677	97849373323100	12833	6619	2	0	\N
33735	1677	97849374323100	12844	6623	3	0	\N
33739	1677	98569374323100	12899	6648	2	0	\N
33741	1677	98569385323100	12899	6648	3	0	\N
33743	1677	98641172000000	3217	1672	2	0	\N
33744	1677	98641172000000	3220	1674	1	0	\N
33746	1677	98641182000000	3220	1674	2	0	\N
33747	1677	98641192000000	3217	1672	3	0	\N
33749	1677	99289418323100	12921	6659	2	0	\N
33751	1677	99289429323100	12921	6659	3	0	\N
33753	1677	99361352000000	3263	1696	1	0	\N
33755	1677	99361362000000	3263	1696	2	0	\N
33779	1677	103681513000000	3393	1766	1	0	\N
33781	1677	103681523000000	3393	1766	2	0	\N
33786	1677	105049582323100	13111	6757	2	0	\N
33787	1677	105049582323100	13137	6771	3	0	\N
33788	1677	105049582323100	13146	6775	7	0	\N
33789	1677	105049582323100	13155	6778	5	0	\N
33792	1677	105049594323100	13137	6771	4	0	\N
33793	1677	105049602323100	13111	6757	3	0	\N
33794	1677	105049632323100	13155	6778	6	0	\N
33795	1677	105049652323100	13146	6775	8	0	\N
33801	1677	106489602323100	13185	6793	2	0	\N
33803	1677	106489622323100	13185	6793	3	0	\N
33812	1677	108001563000000	3503	1819	1	0	\N
33814	1677	108001564000000	3503	1819	2	0	\N
33821	1677	110089667324100	13255	6827	0	0	\N
33824	1677	110809667324100	13266	6833	0	0	\N
33828	1677	111601564000000	3605	1871	0	0	\N
33829	1677	111601564000000	3629	1881	0	0	\N
33833	1677	112321564000000	3665	1903	1	0	\N
33835	1677	112321574000000	3665	1903	2	0	\N
33840	1677	113689687324100	13372	6890	3	0	\N
33843	1677	113689717324100	13372	6890	4	0	\N
33846	1677	113761605000000	3701	1922	3	0	\N
33847	1677	114409707324100	13428	6918	1	0	\N
33849	1677	114409717324100	13428	6918	2	0	\N
33851	1677	114481584000000	3699	1921	1	0	\N
33852	1677	114481584000000	3721	1931	1	0	\N
33854	1677	114481594000000	3699	1921	2	0	\N
33855	1677	114481594000000	3721	1931	2	0	\N
33857	1677	114481605000000	3701	1922	4	0	\N
33860	1677	115129717324100	13478	6941	1	0	\N
33861	1677	115129717324100	13498	6950	1	0	\N
33862	1677	115129717324100	13552	6971	1	0	\N
33863	1677	115129727324100	13478	6941	2	0	\N
33864	1677	115129727324100	13498	6950	2	0	\N
33737	1677	97921152000000	3198	1660	2	0	0
33738	1677	97921172000000	3198	1660	3	0	0
33745	1677	98641172000000	3239	1682	18	0	0
33748	1677	98641352000000	3239	1682	19	0	0
33754	1677	99361352000000	3266	1697	1	0	0
33759	1677	100081362000000	3279	1703	2	0	0
33760	1677	100081382000000	3279	1703	3	0	0
33763	1677	100801382000000	3310	1718	1	0	0
33764	1677	100801392000000	3310	1718	2	0	0
33767	1677	101521392000000	3317	1720	2	0	0
33771	1677	102241412000000	3321	1722	9	0	0
33772	1677	102241502000000	3321	1722	10	0	0
33776	1677	102961502000000	3338	1733	2	0	0
33777	1677	102961513000000	3338	1733	3	0	0
33782	1677	103681543000000	3413	1774	4	0	0
33785	1677	104401543000000	3440	1786	0	0	0
33796	1677	105121543000000	3441	1787	0	0	0
33799	1677	105841543000000	3444	1788	2	0	0
33800	1677	105841563000000	3444	1788	3	0	0
33809	1677	107281563000000	3501	1818	0	0	0
33813	1677	108001563000000	3512	1823	0	0	0
33817	1677	108721563000000	3529	1832	1	0	0
33818	1677	108721564000000	3529	1832	2	0	0
33820	1677	109441564000000	3541	1838	0	0	0
33826	1677	110881564000000	3599	1869	0	0	0
33830	1677	111601564000000	3639	1887	0	0	0
33834	1677	112321564000000	3668	1904	0	0	0
33838	1677	113041564000000	3676	1908	1	0	0
33844	1677	113761574000000	3681	1911	1	0	0
33845	1677	113761584000000	3681	1911	2	0	0
33853	1677	114481584000000	3744	1941	2	0	0
33856	1677	114481595000000	3744	1941	3	0	0
33733	1677	97849363323100	12870	6637	2	0	1
33740	1677	98569374323100	12912	6655	8	0	1
33742	1677	98569418323100	12912	6655	9	0	1
33750	1677	99289418323100	12936	6667	8	0	1
33752	1677	99289462323100	12936	6667	9	0	1
33757	1677	100009462323100	12965	6686	2	0	1
33761	1677	100729473323100	13033	6719	2	0	1
33762	1677	100729484323100	13033	6719	3	0	1
33765	1677	101449484323100	13041	6723	8	0	1
33766	1677	101449537323100	13041	6723	9	0	1
33770	1677	102169539323100	13054	6730	3	0	1
33773	1677	102889539323100	13055	6731	5	0	1
33774	1677	102889562323100	13055	6731	6	0	1
33775	1677	102889572323100	13073	6737	1	0	1
33778	1677	103609572323100	13073	6737	2	0	1
33784	1677	104329582323100	13091	6745	2	0	1
33790	1677	105049582323100	13163	6782	1	0	1
33791	1677	105049592323100	13163	6782	2	0	1
33797	1677	105769592323100	13181	6791	1	0	1
33798	1677	105769602323100	13181	6791	2	0	1
33804	1677	106489622323100	13186	6794	3	0	1
33806	1677	107209622323100	13194	6798	6	0	1
33807	1677	107209628323100	13194	6798	7	0	1
33808	1677	107209638323100	13211	6808	1	0	1
33811	1677	107929647324100	13211	6808	4	1	1
33815	1677	108649647324100	13219	6813	2	0	1
33816	1677	108649667324100	13219	6813	3	0	1
33819	1677	109369667324100	13227	6816	0	0	1
33822	1677	110089667324100	13262	6832	0	0	1
33827	1677	111529667324100	13302	6854	0	0	1
33831	1677	112249667324100	13325	6867	1	0	1
33832	1677	112249677324100	13325	6867	2	0	1
33836	1677	112969677324100	13363	6885	1	0	1
33837	1677	112969687324100	13363	6885	2	0	1
33842	1677	113689707324100	13415	6911	3	0	1
33848	1677	114409707324100	13475	6940	1	0	1
33850	1677	114409717324100	13475	6940	2	0	1
33858	1677	115129692324100	13619	7002	4	0	1
33865	1677	115129727324100	13552	6971	2	0	\N
33866	1677	115201595000000	3750	1944	2	0	\N
33867	1677	115201595000000	3763	1952	1	0	\N
33869	1677	115201605000000	3763	1952	2	0	\N
33871	1677	115201615000000	3750	1944	3	0	\N
33874	1677	115849767324100	13653	7019	1	0	\N
33877	1677	116569757324100	13643	7014	3	0	\N
33879	1677	116569767324099	13653	7019	4	0	\N
33881	1677	116569769324100	13643	7014	4	0	\N
33884	1677	117289768324100	13696	7037	2	0	\N
33886	1677	117289779324100	13696	7037	3	0	\N
33896	1677	118801645000000	3812	1977	2	0	\N
33899	1677	118801665000000	3812	1977	3	0	\N
33900	1677	119449814324100	13721	7052	4	0	\N
33902	1677	119449827324100	13721	7052	5	0	\N
33906	1677	120169860324100	13802	7088	4	0	\N
33908	1677	120169873324100	13802	7088	5	0	\N
33914	1677	120961675000000	3858	2003	1	0	\N
33916	1677	120961685000000	3858	2003	2	0	\N
33922	1677	122329915324100	13867	7118	8	0	\N
33923	1677	122329915324100	13898	7130	31	0	\N
33926	1677	122329941324100	13867	7118	9	0	\N
33927	1677	122329991324100	13898	7130	32	0	\N
33928	1677	122401715000000	3871	2010	1	0	\N
33930	1677	122401725000000	3871	2010	2	0	\N
33932	1677	123049928324100	13946	7146	4	0	\N
33933	1677	123049928324100	13956	7153	4	0	\N
33934	1677	123049928324100	13980	7163	16	0	\N
33935	1677	123049928324100	14014	7183	5	0	\N
33937	1677	123049941324100	13946	7146	5	0	\N
33938	1677	123049941324100	13956	7153	5	0	\N
33939	1677	123049942324100	14014	7183	6	0	\N
33941	1677	123049962324100	13980	7163	17	0	\N
33946	1677	123841735000000	3894	2022	2	0	\N
33947	1677	123841735000000	3899	2024	1	0	\N
33948	1677	123841735000000	3901	2026	1	0	\N
33949	1677	123841735000000	3908	2029	2	0	\N
33951	1677	123841745000000	3899	2024	2	0	\N
33952	1677	123841745000000	3901	2026	2	0	\N
33954	1677	123841755000000	3894	2022	3	0	\N
33955	1677	123841755000000	3908	2029	3	0	\N
33958	1677	124490026324100	14132	7220	7	0	\N
33963	1677	125210026324100	14132	7220	12	0	\N
33964	1677	125210030324100	14132	7220	13	0	\N
33981	1677	128161810000000	3973	2064	1	0	\N
33982	1677	128161810000000	4010	2082	0	0	\N
33983	1677	128161810000000	4037	2096	0	0	\N
33985	1677	128161820000000	3973	2064	2	0	\N
33987	1677	128810069324100	14231	7266	4	0	\N
33989	1677	128810082324100	14231	7266	5	0	\N
33993	1677	129530082324100	14251	7277	8	0	\N
33994	1677	129530082324100	14267	7284	12	0	\N
33995	1677	129530082324100	14284	7292	4	0	\N
33996	1677	129530082324100	14289	7293	7	0	\N
33999	1677	129530095324100	14284	7292	5	0	\N
34000	1677	129530107324100	14289	7293	8	0	\N
33875	1677	115921605000000	3796	1967	1	0	0
33876	1677	115921615000000	3796	1967	2	0	0
33882	1677	116641615000000	3798	1968	1	0	0
33883	1677	116641625000000	3798	1968	2	0	0
33888	1677	117361625000000	3809	1975	1	0	0
33892	1677	118081635000000	3811	1976	1	0	0
33893	1677	118081645000000	3811	1976	2	0	0
33897	1677	118801645000000	3822	1981	1	0	0
33898	1677	118801655000000	3822	1981	2	0	0
33904	1677	119521655000000	3838	1995	1	0	0
33910	1677	120241665000000	3841	1996	1	0	0
33911	1677	120241675000000	3841	1996	2	0	0
33915	1677	120961675000000	3862	2005	1	0	0
33917	1677	120961685000000	3862	2005	2	0	0
33921	1677	121681715000000	3863	2006	4	0	0
33929	1677	122401715000000	3874	2012	1	0	0
33931	1677	122401725000000	3874	2012	2	0	0
33942	1677	123121725000000	3886	2019	1	0	0
33943	1677	123121735000000	3886	2019	2	0	0
33953	1677	123841745000000	3919	2033	2	0	0
33959	1677	124561745000000	3922	2035	1	0	0
33960	1677	124561755000000	3922	2035	2	0	0
33965	1677	125281755000000	3945	2048	3	0	0
33966	1677	125281776000000	3945	2048	4	0	0
33970	1677	126001790000000	3946	2049	6	0	0
33973	1677	126721790000000	3953	2055	1	0	0
33974	1677	126721800000000	3953	2055	2	0	0
33977	1677	127441800000000	3971	2063	1	0	0
33984	1677	128161810000000	4042	2099	2	0	0
33986	1677	128161830000000	4042	2099	3	0	0
33991	1677	128881830000000	4043	2100	1	0	0
33992	1677	128881840000000	4043	2100	2	0	0
33872	1677	115849705324100	13640	7011	16	0	1
33878	1677	116569757324100	13680	7030	2	0	1
33880	1677	116569768324100	13680	7030	3	0	1
33885	1677	117289768324100	13698	7038	2	0	1
33887	1677	117289779324100	13698	7038	3	0	1
33890	1677	118009779324100	13706	7043	4	0	1
33894	1677	118729801324100	13719	7051	4	0	1
33895	1677	118729814324100	13719	7051	5	0	1
33901	1677	119449814324100	13801	7087	10	0	1
33903	1677	119449860324100	13801	7087	11	0	1
33909	1677	120169886324100	13856	7110	9	0	1
33912	1677	120889886324100	13858	7112	4	0	1
33913	1677	120889899324100	13858	7112	5	0	1
33918	1677	121609899324100	13866	7117	7	0	1
33919	1677	121609915324100	13866	7117	8	0	1
33925	1677	122329928324100	13904	7131	5	0	1
33936	1677	123049928324100	14083	7204	6	0	1
33940	1677	123049961324100	14083	7204	7	0	1
33944	1677	123769961324100	14097	7208	9	0	1
33945	1677	123769979324100	14097	7208	10	0	1
33957	1677	124489992324100	14117	7216	5	0	1
33961	1677	125209992324100	14165	7230	3	0	1
33962	1677	125210004324100	14165	7230	4	0	1
33967	1677	125930004324100	14189	7241	4	0	1
33971	1677	126650017324100	14200	7246	8	0	1
33972	1677	126650043324100	14200	7246	9	0	1
33975	1677	127370043324100	14208	7252	4	0	1
33976	1677	127370056324100	14208	7252	5	0	1
33979	1677	128090056324100	14226	7263	4	0	1
33988	1677	128810069324100	14248	7274	4	0	1
33990	1677	128810082324100	14248	7274	5	0	1
33997	1677	129530082324100	14296	7295	2	0	1
33998	1677	129530084324100	14296	7295	3	0	1
34001	1677	129530108324100	14251	7277	9	0	\N
34002	1677	129530121324100	14267	7284	13	0	\N
34009	1677	130321870000000	4059	2109	1	0	\N
34010	1677	130970110324100	14312	7304	3	0	\N
34012	1677	130970122324100	14312	7304	4	0	\N
34015	1677	131041870000000	4059	2109	2	0	\N
34023	1677	132481880000000	4070	2116	1	0	\N
34024	1677	132481880000000	4075	2118	1	0	\N
34025	1677	132481880000000	4085	2123	1	0	\N
34027	1677	132481890000000	4070	2116	2	0	\N
34028	1677	132481890000000	4075	2118	2	0	\N
34029	1677	132481890000000	4085	2123	2	0	\N
34033	1677	133921900000000	4150	2160	1	0	\N
34035	1677	133921910000000	4150	2160	2	0	\N
34039	1677	135361920000000	4171	2171	1	0	\N
34040	1677	135361920000000	4198	2186	4	0	\N
34041	1677	135361920000000	4200	2187	1	0	\N
34042	1677	135361920000000	4208	2190	1	0	\N
34044	1677	135361930000000	4171	2171	2	0	\N
34045	1677	135361930000000	4200	2187	2	0	\N
34046	1677	135361930000000	4208	2190	2	0	\N
34048	1677	135362050000000	4198	2186	5	0	\N
34049	1677	136081960000000	4252	2207	2	0	\N
34052	1677	136081980000000	4252	2207	3	0	\N
34053	1677	136801970000000	4273	2217	2	0	\N
34056	1677	136802080000000	4273	2217	3	0	\N
34057	1677	137521980000000	4296	2229	1	0	\N
34059	1677	137521990000000	4296	2229	2	0	\N
34063	1677	138962110000000	4309	2235	1	0	\N
34065	1677	138962120000000	4309	2235	2	0	\N
34074	1677	141842170000000	4375	2269	1	0	\N
34076	1677	141842180000000	4375	2269	2	0	\N
34078	1677	142562180000000	4389	2276	3	0	\N
34079	1677	142562210000000	4389	2276	4	0	\N
34084	1677	144002390000000	4405	2283	9	0	\N
34086	1677	144002480000000	4405	2283	10	0	\N
34094	1677	146882593000000	4442	2303	4	0	\N
34095	1677	146882593000000	4445	2304	2	0	\N
34098	1677	146882604000000	4445	2304	3	0	\N
34099	1677	146882813000000	4442	2303	5	0	\N
34104	1677	149042643000000	4507	2333	1	0	\N
34106	1677	149042653000000	4507	2333	2	0	\N
34108	1677	149762653000000	4536	2346	1	0	\N
34110	1677	149762663000000	4536	2346	2	0	\N
34112	1677	150482763000000	4576	2368	2	0	\N
34113	1677	150482763000000	4595	2377	3	0	\N
34115	1677	150482783000000	4576	2368	3	0	\N
34116	1677	150482793000000	4595	2377	4	0	\N
34119	1677	151922793000000	4630	2396	1	0	\N
34121	1677	151922803000000	4630	2396	2	0	\N
34131	1677	155522853000000	4768	2464	1	0	\N
34132	1677	155522853000000	4770	2465	4	0	\N
34134	1677	155522863000000	4768	2464	2	0	\N
34136	1677	155522893000000	4770	2465	5	0	\N
34007	1677	130321850000000	4051	2104	1	0	0
34008	1677	130321860000000	4051	2104	2	0	0
34014	1677	131041860000000	4064	2112	1	0	0
34016	1677	131041870000000	4064	2112	2	0	0
34019	1677	131761870000000	4067	2114	1	0	0
34026	1677	132481880000000	4142	2155	1	0	0
34030	1677	132481890000000	4142	2155	2	0	0
34031	1677	133201890000000	4148	2159	1	0	0
34032	1677	133201900000000	4148	2159	2	0	0
34034	1677	133921900000000	4158	2163	1	0	0
34037	1677	134641910000000	4167	2167	1	0	0
34038	1677	134641920000000	4167	2167	2	0	0
34043	1677	135361920000000	4231	2198	4	0	0
34047	1677	135361960000000	4231	2198	5	0	0
34051	1677	136081970000000	4271	2215	2	0	0
34054	1677	136801970000000	4281	2220	1	0	0
34055	1677	136801980000000	4281	2220	2	0	0
34058	1677	137521980000000	4299	2230	2	0	0
34060	1677	137522090000000	4299	2230	3	0	0
34062	1677	138242110000000	4308	2234	3	0	0
34064	1677	138962110000000	4315	2237	3	0	0
34066	1677	138962140000000	4315	2237	4	0	0
34067	1677	139682140000000	4328	2243	1	0	0
34068	1677	139682150000000	4328	2243	2	0	0
34070	1677	140402160000000	4341	2250	2	0	0
34071	1677	141122160000000	4356	2258	1	0	0
34072	1677	141122170000000	4356	2258	2	0	0
34073	1677	141842170000000	4372	2268	1	0	0
34077	1677	141842240000000	4394	2279	6	0	0
34080	1677	142562240000000	4394	2279	12	0	0
34081	1677	142562290000000	4394	2279	13	0	0
34082	1677	143282290000000	4399	2281	10	0	0
34083	1677	143282390000000	4399	2281	11	0	0
34087	1677	144002490000000	4408	2284	11	0	0
34088	1677	144722490000000	4417	2290	9	0	0
34089	1677	144722553000000	4417	2290	10	0	0
34090	1677	145442553000000	4421	2292	2	0	0
34091	1677	145442573000000	4421	2292	3	0	0
34093	1677	146162593000000	4437	2300	3	0	0
34096	1677	146882593000000	4452	2306	1	0	0
34097	1677	146882603000000	4452	2306	2	0	0
34100	1677	147602603000000	4469	2315	3	0	0
34102	1677	148322633000000	4488	2325	1	0	0
34103	1677	148322643000000	4488	2325	2	0	0
34105	1677	149042643000000	4534	2345	1	0	0
34107	1677	149042653000000	4534	2345	2	0	0
34109	1677	149762653000000	4573	2366	2	0	0
34114	1677	150482763000000	4614	2389	0	0	0
34117	1677	151202763000000	4628	2394	3	0	0
34118	1677	151202793000000	4628	2394	4	0	0
34120	1677	151922793000000	4634	2397	1	0	0
34122	1677	151922803000000	4634	2397	2	0	0
34124	1677	152642813000000	4645	2401	2	0	0
34125	1677	153362813000000	4657	2407	1	0	0
34126	1677	153362823000000	4657	2407	2	0	0
34127	1677	154082823000000	4668	2414	1	0	0
34129	1677	154802833000000	4718	2439	2	0	0
34130	1677	154802853000000	4718	2439	3	0	0
34133	1677	155522853000000	4774	2467	2	0	0
34135	1677	155522873000000	4774	2467	3	0	0
34005	1677	130250084324100	14299	7298	8	0	1
34011	1677	130970110324100	14322	7307	7	0	1
34013	1677	130970135324100	14322	7307	8	0	1
34017	1677	131690135324100	14336	7317	4	0	1
34018	1677	131690148324100	14336	7317	5	0	1
34021	1677	132410148324100	14350	7325	7	0	1
34149	1677	160563013000000	4937	2557	1	0	\N
34150	1677	160563013000000	4941	2559	1	0	\N
34151	1677	160563013000000	4954	2567	1	0	\N
34153	1677	160563023000000	4937	2557	2	0	\N
34154	1677	160563023000000	4941	2559	2	0	\N
34155	1677	160563023000000	4954	2567	2	0	\N
34159	1677	162003043000000	4976	2581	3	0	\N
34160	1677	162003043000000	4990	2587	1	0	\N
34161	1677	162003043000000	5453	2713	39	0	\N
34162	1677	162003043000000	5856	2810	0	0	\N
34163	1677	162003043000000	5858	2828	0	0	\N
34164	1677	162003043000000	5859	2849	0	0	\N
34165	1677	162003043000000	5860	2867	0	0	\N
34166	1677	162003043000000	5861	2885	0	0	\N
34167	1677	162003043000000	5862	3040	0	0	\N
34168	1677	162003043000000	5876	3047	1	0	\N
34169	1677	162003043000000	5883	3050	0	0	\N
34171	1677	162003053000000	4990	2587	2	0	\N
34172	1677	162003053000000	5876	3047	2	0	\N
34173	1677	162003073000000	4976	2581	4	0	\N
34175	1677	162003433000000	5453	2713	40	0	\N
34176	1677	162723343000000	5904	3061	1	0	\N
34178	1677	162723353000000	5904	3061	2	0	\N
34184	1677	164883413000000	5993	3110	2	0	\N
34186	1677	164883433000000	5993	3110	3	0	\N
34188	1677	165603433000000	6013	3120	1	0	\N
34190	1677	165603443000000	6013	3120	2	0	\N
34192	1677	166323483000000	6028	3128	3	0	\N
34195	1677	166323513000000	6028	3128	4	0	\N
34198	1677	167763503000000	6108	3168	4	0	\N
34199	1677	167763503000000	6116	3171	1	0	\N
34201	1677	167763513000000	6116	3171	2	0	\N
34203	1677	167763633000000	6108	3168	5	0	\N
34206	1677	169203523000000	6153	3188	1	0	\N
34207	1677	169203523000000	6212	3215	4	0	\N
34208	1677	169203523000000	6236	3226	2	0	\N
34209	1677	169203523000000	6243	3229	2	0	\N
34211	1677	169203533000000	6153	3188	2	0	\N
34212	1677	169203543000000	6236	3226	3	0	\N
34213	1677	169203543000000	6243	3229	3	0	\N
34215	1677	169203653000000	6212	3215	5	0	\N
34222	1677	172083573000000	6319	3271	1	0	\N
34224	1677	172083583000000	6319	3271	2	0	\N
34230	1677	174243603000000	6375	3302	1	0	\N
34232	1677	174243613000000	6375	3302	2	0	\N
34238	1677	176403683000000	6418	3325	2	0	\N
34240	1677	176403703000000	6418	3325	3	0	\N
34246	1677	178563743000000	6520	3379	2	0	\N
34247	1677	178563743000000	6529	3384	2	0	\N
34249	1677	178563763000000	6520	3379	3	0	\N
34250	1677	178563763000000	6529	3384	3	0	\N
34252	1677	179283763000000	6586	3407	5	0	\N
34253	1677	179283763000000	6593	3411	2	0	\N
34255	1677	179283783000000	6593	3411	3	0	\N
34257	1677	179283813000000	6586	3407	6	0	\N
34258	1677	180003803000000	6661	3443	2	0	\N
34260	1677	180003823000000	6661	3443	3	0	\N
34139	1677	156962883000000	4810	2490	1	0	0
34140	1677	156962893000000	4810	2490	2	0	0
34141	1677	157682893000000	4821	2497	3	0	0
34142	1677	157682963000000	4821	2497	4	0	0
34143	1677	158402963000000	4824	2499	2	0	0
34145	1677	159122983000000	4916	2544	2	0	0
34146	1677	159123003000000	4916	2544	3	0	0
34147	1677	159843003000000	4922	2547	1	0	0
34148	1677	159843013000000	4922	2547	2	0	0
34152	1677	160563013000000	4959	2570	1	0	0
34157	1677	161283023000000	4965	2574	2	0	0
34158	1677	161283043000000	4965	2574	3	0	0
34170	1677	162003043000000	5884	3051	3	0	0
34174	1677	162003343000000	5884	3051	4	0	0
34179	1677	162723393000000	5959	3090	6	0	0
34180	1677	163443393000000	5962	3093	1	0	0
34181	1677	163443403000000	5962	3093	2	0	0
34182	1677	164163403000000	5992	3109	1	0	0
34183	1677	164163413000000	5992	3109	2	0	0
34187	1677	164883433000000	6007	3117	3	0	0
34189	1677	165603433000000	6025	3126	5	0	0
34191	1677	165603483000000	6025	3126	6	0	0
34193	1677	166323483000000	6072	3154	1	0	0
34194	1677	166323493000000	6072	3154	2	0	0
34197	1677	167043503000000	6088	3160	2	0	0
34200	1677	167763503000000	6126	3178	1	0	0
34202	1677	167763513000000	6126	3178	2	0	0
34204	1677	168483513000000	6140	3184	1	0	0
34210	1677	169203523000000	6254	3237	2	0	0
34214	1677	169203543000000	6254	3237	3	0	0
34216	1677	169923543000000	6258	3240	1	0	0
34217	1677	169923553000000	6258	3240	2	0	0
34218	1677	170643553000000	6267	3246	1	0	0
34220	1677	171363563000000	6317	3270	1	0	0
34221	1677	171363573000000	6317	3270	2	0	0
34223	1677	172083573000000	6324	3273	1	0	0
34225	1677	172083583000000	6324	3273	2	0	0
34226	1677	172803583000000	6362	3294	1	0	0
34228	1677	173523593000000	6366	3296	1	0	0
34229	1677	173523603000000	6366	3296	2	0	0
34231	1677	174243603000000	6402	3317	1	0	0
34233	1677	174243613000000	6402	3317	2	0	0
34235	1677	174963653000000	6404	3318	5	0	0
34236	1677	175683653000000	6407	3319	3	0	0
34237	1677	175683683000000	6407	3319	4	0	0
34239	1677	176403683000000	6474	3356	2	0	0
34241	1677	176403703000000	6474	3356	3	0	0
34243	1677	177123723000000	6485	3361	3	0	0
34244	1677	177843723000000	6509	3375	2	0	0
34245	1677	177843743000000	6509	3375	3	0	0
34248	1677	178563743000000	6532	3385	2	0	0
34251	1677	178563763000000	6532	3385	3	0	0
34256	1677	179283803000000	6641	3433	5	0	0
34259	1677	180003803000000	6667	3445	2	0	0
34261	1677	180003823000000	6667	3445	3	0	0
34262	1677	180723823000000	6697	3462	4	0	0
34264	1677	181443863000000	6707	3468	6	0	0
34265	1677	181443923000000	6707	3468	7	0	0
34266	1677	181443943000000	6717	3475	2	0	0
34267	1677	182163943000000	6717	3475	3	0	0
34268	1677	182883943000000	6718	3476	4	0	0
34270	1677	183603983000000	6721	3478	4	0	0
34271	1677	183604023000000	6721	3478	5	0	0
34272	1677	184324023000000	6741	3488	2	0	0
34281	1677	187204143000000	6861	3548	2	0	\N
34282	1677	187204163000000	6861	3548	3	0	\N
34284	1677	187924163000000	6952	3587	7	0	\N
34287	1677	187924233000000	6952	3587	8	0	\N
34288	1677	188644223000000	6974	3598	2	0	\N
34290	1677	188644243000000	6974	3598	3	0	\N
34292	1677	189364243000000	7030	3624	4	0	\N
34294	1677	189364283000000	7030	3624	5	0	\N
34296	1677	190084283000000	7039	3632	2	0	\N
34297	1677	190084283000000	7047	3637	4	0	\N
34298	1677	190084283000000	7086	3656	2	0	\N
34300	1677	190084303000000	7039	3632	3	0	\N
34301	1677	190084303000000	7086	3656	3	0	\N
34303	1677	190084323000000	7047	3637	5	0	\N
34306	1677	191524323000000	7105	3668	2	0	\N
34308	1677	191524343000000	7105	3668	3	0	\N
34310	1677	192244383000000	7155	3697	1	0	\N
34311	1677	192244383000000	7158	3698	3	0	\N
34313	1677	192244393000000	7155	3697	2	0	\N
34316	1677	192244503000000	7158	3698	4	0	\N
34319	1677	193684413000000	7200	3722	1	0	\N
34320	1677	193684413000000	7204	3723	2	0	\N
34322	1677	193684423000000	7200	3722	2	0	\N
34324	1677	193684433000000	7204	3723	3	0	\N
34325	1677	194404423000000	7218	3732	1	0	\N
34327	1677	194404433000000	7218	3732	2	0	\N
34329	1677	195124533000000	7243	3744	3	0	\N
34332	1677	195124563000000	7243	3744	4	0	\N
34333	1677	195844543000000	7265	3757	1	0	\N
34335	1677	195844553000000	7265	3757	2	0	\N
34337	1677	196564553000000	7272	3760	1	0	\N
34339	1677	196564563000000	7272	3760	2	0	\N
34341	1677	197284573000000	7285	3766	1	0	\N
34342	1677	197284573000000	7320	3783	1	0	\N
34343	1677	197284573000000	7324	3785	1	0	\N
34344	1677	197284573000000	7326	3787	1	0	\N
34345	1677	197284573000000	7337	3791	5	0	\N
34347	1677	197284583000000	7285	3766	2	0	\N
34348	1677	197284583000000	7320	3783	2	0	\N
34349	1677	197284583000000	7324	3785	2	0	\N
34350	1677	197284583000000	7326	3787	2	0	\N
34352	1677	197284623000000	7337	3791	6	0	\N
34353	1677	198004593000000	7391	3817	5	0	\N
34356	1677	198004643000000	7391	3817	6	0	\N
34357	1677	198724613000000	7405	3826	1	0	\N
34359	1677	198724623000000	7405	3826	2	0	\N
34363	1677	200164653000000	7451	3853	2	0	\N
34366	1677	200164673000000	7451	3853	3	0	\N
34369	1677	201604693000000	7469	3863	1	0	\N
34370	1677	201604693000000	7477	3867	2	0	\N
34371	1677	201604693000000	7489	3873	2	0	\N
34373	1677	201604703000000	7469	3863	2	0	\N
34375	1677	201604713000000	7477	3867	3	0	\N
34376	1677	201604713000000	7489	3873	3	0	\N
34377	1677	202324703000000	7504	3883	2	0	\N
34379	1677	202324723000000	7504	3883	3	0	\N
34394	1677	208804798000000	7806	4048	1	0	\N
34396	1677	208804808000000	7806	4048	2	0	\N
34400	1677	210244818000000	7834	4062	1	0	\N
34401	1677	210244818000000	7844	4066	2	0	\N
34403	1677	210244828000000	7834	4062	2	0	\N
34405	1677	210244838000000	7844	4066	3	0	\N
34275	1677	185044063000000	6773	3506	3	0	0
34276	1677	185764063000000	6831	3536	2	0	0
34277	1677	185764083000000	6831	3536	3	0	0
34278	1677	186484083000000	6847	3542	6	0	0
34279	1677	186484143000000	6847	3542	7	0	0
34283	1677	187204163000000	6940	3582	3	0	0
34285	1677	187924163000000	6955	3588	6	0	0
34286	1677	187924223000000	6955	3588	7	0	0
34289	1677	188644223000000	6989	3608	2	0	0
34291	1677	188644243000000	6989	3608	3	0	0
34295	1677	189364283000000	7032	3626	5	0	0
34299	1677	190084283000000	7101	3665	2	0	0
34302	1677	190084303000000	7101	3665	3	0	0
34304	1677	190804303000000	7103	3666	2	0	0
34307	1677	191524323000000	7113	3673	6	0	0
34309	1677	191524383000000	7113	3673	7	0	0
34312	1677	192244383000000	7177	3707	1	0	0
34314	1677	192244393000000	7177	3707	2	0	0
34315	1677	192244403000000	7194	3719	1	0	0
34318	1677	192964413000000	7194	3719	4	0	0
34321	1677	193684413000000	7206	3724	1	0	0
34323	1677	193684423000000	7206	3724	2	0	0
34326	1677	194404423000000	7225	3734	2	0	0
34328	1677	194404533000000	7225	3734	3	0	0
34331	1677	195124543000000	7252	3750	2	0	0
34334	1677	195844543000000	7270	3758	1	0	0
34336	1677	195844553000000	7270	3758	2	0	0
34338	1677	196564553000000	7274	3761	2	0	0
34346	1677	197284573000000	7385	3813	2	0	0
34351	1677	197284593000000	7385	3813	3	0	0
34354	1677	198004593000000	7394	3819	2	0	0
34355	1677	198004613000000	7394	3819	3	0	0
34358	1677	198724613000000	7408	3829	3	0	0
34361	1677	199444643000000	7423	3836	1	0	0
34362	1677	199444653000000	7423	3836	2	0	0
34364	1677	200164653000000	7459	3858	1	0	0
34365	1677	200164663000000	7459	3858	2	0	0
34367	1677	200884663000000	7462	3859	3	0	0
34372	1677	201604693000000	7497	3879	1	0	0
34374	1677	201604703000000	7497	3879	2	0	0
34378	1677	202324703000000	7512	3888	4	0	0
34380	1677	202324738000000	7512	3888	5	0	0
34382	1677	203044748000000	7514	3889	2	0	0
34383	1677	203764748000000	7574	3919	1	0	0
34384	1677	203764758000000	7574	3919	2	0	0
34385	1677	204484758000000	7599	3930	1	0	0
34386	1677	204484768000000	7599	3930	2	0	0
34388	1677	205204788000000	7616	3940	3	0	0
34389	1677	205924788000000	7681	3978	0	0	0
34390	1677	206644788000000	7741	4012	1	0	0
34391	1677	206644798000000	7741	4012	2	0	0
34392	1677	207364798000000	7743	4013	0	0	0
34395	1677	208804798000000	7817	4052	1	0	0
34397	1677	208804808000000	7817	4052	2	0	0
34398	1677	209524808000000	7830	4060	1	0	0
34399	1677	209524818000000	7830	4060	2	0	0
34404	1677	210244828000000	7894	4091	2	0	0
34406	1677	210964828000000	7907	4096	1	0	0
34407	1677	210964838000000	7907	4096	2	0	0
34408	1677	211684838000000	7916	4103	1	0	0
34420	1677	216004918000000	7980	4136	3	0	\N
34423	1677	216004948000000	7980	4136	4	0	\N
34424	1677	216724938000000	7998	4147	1	0	\N
34425	1677	216724938000000	8033	4164	12	0	\N
34427	1677	216724948000000	7998	4147	2	0	\N
34429	1677	216725598000000	8033	4164	13	0	\N
34430	1677	217444948000000	8077	4188	1	0	\N
34432	1677	217444958000000	8077	4188	2	0	\N
34434	1677	218164959000000	8159	4230	1	0	\N
34435	1677	218164959000000	8175	4236	2	0	\N
34436	1677	218164959000000	8186	4243	1	0	\N
34438	1677	218164969000000	8159	4230	2	0	\N
34439	1677	218164969000000	8186	4243	2	0	\N
34441	1677	218164979000000	8175	4236	3	0	\N
34444	1677	219604979000000	8213	4258	1	0	\N
34445	1677	219604979000000	8218	4260	2	0	\N
34447	1677	219604989000000	8213	4258	2	0	\N
34449	1677	219605089000000	8218	4260	3	0	\N
34452	1677	221045009000000	8282	4290	1	0	\N
34454	1677	221045019000000	8282	4290	2	0	\N
34460	1677	223205070000000	8367	4336	1	0	\N
34461	1677	223205070000000	8380	4342	4	0	\N
34463	1677	223205080000000	8367	4336	2	0	\N
34465	1677	223205299000000	8380	4342	5	0	\N
34468	1677	224645095000000	8421	4363	0	0	\N
34469	1677	224645095000000	8423	4364	0	0	\N
34470	1677	224645095000000	8429	4369	0	0	\N
34471	1677	224645095000000	8440	4374	0	0	\N
34472	1677	224645095000000	8450	4378	3	0	\N
34473	1677	224645095000000	8456	4382	1	0	\N
34475	1677	224645105000000	8456	4382	2	0	\N
34477	1677	224645215000000	8450	4378	4	0	\N
34478	1677	225365105000000	8484	4395	2	0	\N
34480	1677	225365125000000	8484	4395	3	0	\N
34482	1677	226085125000000	8527	4418	1	0	\N
34483	1677	226085125000000	8552	4430	0	0	\N
34484	1677	226085125000000	8559	4436	1	0	\N
34486	1677	226085135000000	8527	4418	2	0	\N
34487	1677	226085135000000	8559	4436	2	0	\N
34489	1677	226805135000000	8565	4440	1	0	\N
34490	1677	226805135000000	8570	4442	2	0	\N
34491	1677	226805135000000	8608	4463	1	0	\N
34493	1677	226805145000000	8565	4440	2	0	\N
34494	1677	226805145000000	8608	4463	2	0	\N
34496	1677	226805155000000	8570	4442	3	0	\N
34497	1677	227525145000000	8615	4466	1	0	\N
34499	1677	227525155000000	8615	4466	2	0	\N
34503	1677	228965174999992	8731	4528	2	0	\N
34504	1677	228965175000000	8710	4518	8	0	\N
34505	1677	228965175000000	8733	4529	2	0	\N
34507	1677	228965195000000	8733	4529	3	0	\N
34509	1677	228965255000000	8710	4518	9	0	\N
34510	1677	229685195000000	8752	4542	2	0	\N
34512	1677	229685215000000	8752	4542	3	0	\N
34518	1677	231845540000000	8854	4587	2	0	\N
34520	1677	231845560000000	8854	4587	3	0	\N
34524	1677	233285660000000	8908	4615	2	0	\N
34525	1677	233285660000000	8935	4633	2	0	\N
34527	1677	233285680000000	8908	4615	3	0	\N
34528	1677	233285680000000	8935	4633	3	0	\N
34530	1677	234005700000000	8956	4645	4	0	\N
34531	1677	234005700000000	8959	4646	5	0	\N
34532	1677	234005700000000	8961	4647	2	0	\N
34534	1677	234005720000000	8961	4647	3	0	\N
34536	1677	234005740000000	8956	4645	5	0	\N
34537	1677	234005741000000	8959	4646	6	0	\N
34540	1677	235445740000000	8977	4656	2	0	\N
34542	1677	235445760000000	8977	4656	3	0	\N
34411	1677	212404878000000	7918	4104	4	0	0
34412	1677	213124878000000	7935	4113	1	0	0
34413	1677	213124888000000	7935	4113	2	0	0
34414	1677	213844888000000	7939	4115	1	0	0
34415	1677	213844898000000	7939	4115	2	0	0
34417	1677	214564908000000	7976	4134	2	0	0
34418	1677	215284908000000	7978	4135	1	0	0
34419	1677	215284918000000	7978	4135	2	0	0
34421	1677	216004918000000	7989	4142	2	0	0
34422	1677	216004938000000	7989	4142	3	0	0
34428	1677	216724948000000	8053	4172	2	0	0
34431	1677	217444948000000	8080	4189	2	0	0
34433	1677	217444959000000	8080	4189	3	0	0
34437	1677	218164959000000	8190	4246	1	0	0
34442	1677	218884969000000	8197	4249	1	0	0
34443	1677	218884979000000	8197	4249	2	0	0
34446	1677	219604979000000	8235	4267	2	0	0
34448	1677	219604999000000	8235	4267	3	0	0
34450	1677	220324999000000	8249	4272	1	0	0
34453	1677	221045009000000	8319	4306	1	0	0
34455	1677	221045019000000	8319	4306	2	0	0
34456	1677	221765019000000	8354	4326	4	0	0
34457	1677	221765050000000	8354	4326	5	0	0
34458	1677	222485050000000	8363	4333	2	0	0
34462	1677	223205070000000	8396	4350	2	0	0
34464	1677	223205085000000	8396	4350	3	0	0
34466	1677	223925085000000	8408	4357	1	0	0
34467	1677	223925095000000	8408	4357	2	0	0
34476	1677	224645105000000	8463	4384	2	0	0
34479	1677	225365105000000	8520	4413	2	0	0
34481	1677	225365125000000	8520	4413	3	0	0
34485	1677	226085125000000	8561	4437	1	0	0
34488	1677	226085135000000	8561	4437	2	0	0
34495	1677	226805145000000	8611	4464	2	0	0
34498	1677	227525145000000	8636	4475	2	0	0
34500	1677	227525165000000	8636	4475	3	0	0
34501	1677	228245165000000	8696	4508	1	0	0
34502	1677	228245175000000	8696	4508	2	0	0
34508	1677	228965195000000	8749	4541	3	0	0
34511	1677	229685195000000	8764	4547	2	0	0
34513	1677	229685215000000	8764	4547	3	0	0
34514	1677	230405215000000	8791	4558	4	0	0
34516	1677	231125255000000	8835	4581	3	0	0
34517	1677	231125540000000	8835	4581	4	0	0
34519	1677	231845540000000	8869	4596	4	0	0
34521	1677	231845580000000	8869	4596	5	0	0
34522	1677	232565580000000	8886	4605	8	0	0
34526	1677	233285660000000	8954	4644	4	0	0
34529	1677	233285700000000	8954	4644	5	0	0
34533	1677	234005700000000	8963	4648	2	0	0
34535	1677	234005720000000	8963	4648	3	0	0
34538	1677	234725720000000	8965	4650	2	0	0
34541	1677	235445740000000	8993	4663	2	0	0
34543	1677	235445760000000	8993	4663	3	0	0
34544	1677	236165760000000	8997	4665	6	0	0
34546	1677	236885820000000	9005	4668	2	0	\N
34548	1677	236885840000000	9005	4668	3	0	\N
34552	1677	238325860000000	9036	4685	2	0	\N
34553	1677	238325860000000	9049	4691	13	0	\N
34554	1677	238325860000000	9107	4719	2	0	\N
34555	1677	238325860000000	9108	4720	2	0	\N
34557	1677	238325880000000	9036	4685	3	0	\N
34558	1677	238325880000000	9107	4719	3	0	\N
34559	1677	238325880000000	9108	4720	3	0	\N
34561	1677	238325981000000	9049	4691	14	0	\N
34564	1677	239765920000000	9145	4739	4	0	\N
34565	1677	239765920000000	9150	4740	4	0	\N
34568	1677	239765960000000	9145	4739	5	0	\N
34569	1677	239765960000000	9150	4740	5	0	\N
34572	1677	241205991000000	9186	4762	4	0	\N
34573	1677	241205991000000	9228	4783	3	0	\N
34576	1677	241206021000000	9228	4783	4	0	\N
34577	1677	241206031000000	9186	4762	5	0	\N
34579	1677	241926011000000	9265	4796	0	0	\N
34581	1677	242646211000000	9266	4798	0	0	\N
34582	1677	242646211000000	9267	4802	1	0	\N
34584	1677	242646221000000	9267	4802	2	0	\N
34586	1677	243366261000000	9351	4853	2	0	\N
34588	1677	243366281000000	9351	4853	3	0	\N
34594	1677	245526341000000	9397	4876	2	0	\N
34596	1677	245526361000000	9397	4876	3	0	\N
34601	1677	246966421000000	9416	4887	4	0	\N
34603	1677	246966461000000	9416	4887	5	0	\N
34605	1677	247686441000000	9458	4904	2	0	\N
34606	1677	247686461000000	9458	4904	3	0	\N
34613	1677	249846641000000	9504	4929	3	0	\N
34614	1677	249846641000000	9507	4930	2	0	\N
34616	1677	249846661000000	9507	4930	3	0	\N
34618	1677	249846911000000	9504	4929	4	0	\N
34621	1677	251286702000000	9533	4944	2	0	\N
34623	1677	251286702000000	9957	4950	0	0	\N
34624	1677	251286722000000	9533	4944	3	0	\N
34627	1677	252006742000000	9958	4962	0	0	\N
34630	1677	252726782000000	9959	4974	0	0	\N
34633	1677	253446802000000	9614	4988	2	0	\N
34634	1677	253446802000000	9960	4986	0	0	\N
34635	1677	253446822000000	9614	4988	3	0	\N
34637	1677	254166862000000	9658	5013	2	0	\N
34639	1677	254166862000000	9962	4994	0	0	\N
34640	1677	254166882000000	9658	5013	3	0	\N
34642	1677	254886862000000	9963	4995	0	0	\N
34643	1677	254886892000000	9718	5038	6	0	\N
34644	1677	254886892000000	9725	5040	9	0	\N
34645	1677	254886892000000	9727	5041	13	0	\N
34648	1677	254886943000000	9718	5038	7	0	\N
34649	1677	254887054000000	9725	5040	10	0	\N
34650	1677	254887292000000	9727	5041	14	0	\N
34653	1677	256327033000000	9757	5056	2	0	\N
34655	1677	256327053000000	9757	5056	3	0	\N
34657	1677	257047093000000	9802	5082	1	0	\N
34659	1677	257047103000000	9802	5082	2	0	\N
34664	1677	259207164000000	9879	5124	2	0	\N
34666	1677	259207184000000	9879	5124	3	0	\N
34676	1677	262807334000000	9941	5159	2	0	\N
34677	1677	262807334000000	9974	5163	3	0	\N
34678	1677	262807334000000	9975	5154	3	0	\N
34679	1677	262807334000000	9976	5171	7	0	\N
34680	1677	262807334000000	9981	5176	6	0	\N
34549	1677	236885840000000	9022	4678	3	0	0
34550	1677	237605840000000	9026	4680	2	0	0
34551	1677	237605860000000	9026	4680	3	0	0
34556	1677	238325860000000	9118	4724	4	0	0
34560	1677	238325900000000	9118	4724	5	0	0
34563	1677	239045920000000	9139	4734	3	0	0
34566	1677	239765920000000	9171	4753	3	0	0
34567	1677	239765941000000	9171	4753	4	0	0
34570	1677	240485941000000	9184	4760	5	0	0
34571	1677	240485991000000	9184	4760	6	0	0
34575	1677	241206011000000	9235	4788	3	0	0
34578	1677	241926011000000	9247	4796	20	0	0
34580	1677	241926211000000	9247	4796	21	0	0
34583	1677	242646211000000	9326	4837	5	0	0
34587	1677	243366261000000	9377	4865	2	0	0
34589	1677	243366281000000	9377	4865	3	0	0
34590	1677	244086281000000	9383	4867	2	0	0
34591	1677	244086301000000	9383	4867	3	0	0
34592	1677	244806301000000	9395	4874	4	0	0
34595	1677	245526341000000	9401	4877	4	0	0
34597	1677	245526381000000	9401	4877	5	0	0
34598	1677	246246381000000	9415	4886	4	0	0
34599	1677	246246421000000	9415	4886	5	0	0
34600	1677	246246441000000	9424	4889	2	0	0
34604	1677	246966461000000	9478	4915	2	0	0
34607	1677	247686461000000	9478	4915	5	0	0
34608	1677	247686481000000	9478	4915	6	0	0
34609	1677	248406481000000	9492	4924	3	0	0
34611	1677	249126601000000	9499	4927	4	0	0
34612	1677	249126641000000	9499	4927	5	0	0
34615	1677	249846641000000	9518	4935	2	0	0
34617	1677	249846661000000	9518	4935	3	0	0
34619	1677	250566661000000	9525	4938	5	0	0
34622	1677	251286702000000	9558	4955	4	0	0
34625	1677	251286742000000	9558	4955	5	0	0
34626	1677	252006742000000	9584	4972	4	0	0
34628	1677	252006782000000	9584	4972	5	0	0
34629	1677	252726782000000	9603	4982	2	0	0
34632	1677	252726862000000	9622	4991	6	0	0
34636	1677	253446862000000	9622	4991	7	0	0
34638	1677	254166862000000	9682	5023	3	0	0
34641	1677	254166892000000	9682	5023	4	0	0
34647	1677	254886912000000	9731	5042	3	0	0
34651	1677	255606912000000	9756	5055	4	0	0
34652	1677	255607033000000	9756	5055	5	0	0
34654	1677	256327033000000	9777	5066	6	0	0
34656	1677	256327093000000	9777	5066	7	0	0
34660	1677	257047144000000	9815	5087	7	0	0
34661	1677	257767144000000	9843	5102	2	0	0
34662	1677	257767164000000	9843	5102	3	0	0
34663	1677	258487164000000	9855	5110	0	0	0
34665	1677	259207164000000	9885	5125	2	0	0
34668	1677	259927184000000	9901	5133	2	0	0
34669	1677	259927204000000	9901	5133	3	0	0
34670	1677	260647204000000	9902	5134	2	0	0
34671	1677	260647224000000	9902	5134	3	0	0
34673	1677	261367304000000	9909	5139	9	0	0
34674	1677	262087304000000	9923	5150	3	0	0
34675	1677	262087334000000	9923	5150	4	0	0
34682	1677	262807354000000	9941	5159	3	0	\N
34684	1677	262807364000000	9974	5163	4	0	\N
34685	1677	262807364000000	9975	5154	4	0	\N
34686	1677	262807394000000	9981	5176	7	0	\N
34687	1677	262807404000000	9976	5171	8	0	\N
34688	1677	263527354000000	10022	5197	12	0	\N
34691	1677	263527411000000	10022	5197	13	0	\N
34711	1677	271447603000000	10087	5233	22	0	\N
34712	1677	271447603000000	10107	5244	3	0	\N
34713	1677	271447603000000	10144	5260	2	0	\N
34714	1677	271447603000000	10147	5261	2	0	\N
34716	1677	271447623000000	10144	5260	3	0	\N
34717	1677	271447623000000	10147	5261	3	0	\N
34719	1677	271447633000000	10107	5244	4	0	\N
34720	1677	271447814000000	10087	5233	23	0	\N
34723	1677	272887643000000	10227	5293	1	0	\N
34725	1677	272887653000000	10227	5293	2	0	\N
34729	1677	274327803000000	10254	5305	2	0	\N
34731	1677	274327823000000	10254	5305	3	0	\N
34735	1677	275767863000000	10288	5323	4	0	\N
34738	1677	275767903000000	10288	5323	5	0	\N
34739	1677	276487893000000	10296	5327	2	0	\N
34741	1677	276487913000000	10296	5327	3	0	\N
34744	1677	277207913000000	10366	5361	4	0	\N
34745	1677	277207913000000	10409	5384	5	0	\N
34748	1677	277207953000000	10366	5361	5	0	\N
34749	1677	277207963000000	10409	5384	6	0	\N
34750	1677	277927932000000	10423	5391	2	0	\N
34752	1677	277927952000000	10423	5391	3	0	\N
34760	1678	2161006173000	1608	783	95	0	\N
34763	1678	2881006203000	1608	783	126	0	\N
34764	1678	2881306203000	1608	783	127	0	\N
34767	1678	3601306273000	1708	784	73	0	\N
34768	1678	3602027273000	1708	784	74	0	\N
34773	1678	5040174624000	6870	3554	2	0	\N
34774	1678	5760154466000	6659	3443	2	0	\N
34776	1678	5760174466000	6659	3443	3	0	\N
34777	1678	5760174624000	6870	3554	3	0	\N
34783	1678	7920224813000	8364	4334	1	0	\N
34785	1678	7920234813000	8364	4334	2	0	\N
34791	1678	10080265874000	10139	5257	4	0	\N
34794	1678	10080575874000	10139	5257	5	0	\N
34797	1678	11520326168000	10548	5447	5	0	\N
34800	1678	11520367168000	10548	5447	6	0	\N
34803	1678	12960386673000	11334	5822	2	0	\N
34806	1678	12960397673000	11334	5822	3	0	\N
34807	1678	13680388822000	11996	6174	1	0	\N
34809	1678	13680389822000	11996	6174	2	0	\N
34813	1678	15120545319000	13173	6787	4	0	\N
34814	1678	15120545766000	13834	7103	3	0	\N
34816	1678	15120557766000	13834	7103	4	0	\N
34756	1678	1440010768000	1007	557	2	0	0
34757	1678	1440030768000	1007	557	3	0	0
34758	1678	2160031076000	1431	779	1	0	0
34759	1678	2160041076000	1431	779	2	0	0
34761	1678	2880042421000	3301	1713	4	0	0
34765	1678	3600083318000	4697	2429	1	0	0
34766	1678	3600093318000	4697	2429	2	0	0
34769	1678	4320093919000	5896	3056	5	0	0
34770	1678	4320143919000	5896	3056	6	0	0
34771	1678	5040144127000	6186	3203	1	0	0
34775	1678	5760154813000	7309	3777	3	0	0
34778	1678	5760184813000	7309	3777	4	0	0
34779	1678	6480184813000	7517	3892	1	0	0
34780	1678	6480194813000	7517	3892	2	0	0
34782	1678	7200224813000	7689	3983	4	0	0
34784	1678	7920224813000	8452	4379	1	0	0
34786	1678	7920234813000	8452	4379	2	0	0
34787	1678	8640234813000	8640	4477	1	0	0
34788	1678	8640244813000	8640	4477	2	0	0
34790	1678	9360265741000	9951	5167	3	0	0
34681	1677	262807334000000	10009	5189	2	0	0
34683	1677	262807354000000	10009	5189	3	0	0
34689	1677	263527354000000	10024	5198	3	0	0
34690	1677	263527384000000	10024	5198	4	0	0
34693	1677	264247405000000	10027	5201	4	0	0
34694	1677	264967405000000	10028	5202	4	0	0
34695	1677	264967445000000	10028	5202	5	0	0
34696	1677	265687445000000	10036	5207	2	0	0
34698	1677	266407465000000	10040	5209	4	0	0
34699	1677	266407505000000	10040	5209	5	0	0
34700	1677	267127505000000	10047	5211	2	0	0
34701	1677	267127525000000	10047	5211	3	0	0
34702	1677	267847525000000	10050	5212	2	0	0
34704	1677	268567545000000	10052	5213	2	0	0
34705	1677	268567565000000	10052	5213	3	0	0
34706	1677	269287560000000	10074	5225	0	0	0
34707	1677	270007560000000	10082	5230	5	0	0
34708	1677	270007583000000	10082	5230	6	0	0
34710	1677	270727603000000	10083	5231	3	0	0
34792	1678	10080265889000	10168	5269	2	0	0
34793	1678	10080285889000	10168	5269	3	0	0
34715	1677	271447603000000	10199	5281	2	0	0
34721	1677	272167623000000	10203	5284	2	0	0
34722	1677	272167643000000	10203	5284	3	0	0
34724	1677	272887643000000	10233	5296	3	0	0
34726	1677	272887763000000	10233	5296	4	0	0
34727	1677	273607763000000	10242	5299	4	0	0
34730	1677	274327803000000	10262	5308	4	0	0
34732	1677	274327843000000	10262	5308	5	0	0
34733	1677	275047843000000	10281	5320	2	0	0
34734	1677	275047863000000	10281	5320	3	0	0
34736	1677	275767863000000	10292	5325	3	0	0
34740	1677	276487893000000	10349	5356	2	0	0
34742	1677	276487913000000	10349	5356	3	0	0
34743	1677	276487923000000	10412	5386	1	0	0
34746	1677	277207923000000	10412	5386	3	0	0
34751	1677	277927932000000	10429	5395	2	0	0
34753	1677	277927952000000	10429	5395	3	0	0
34795	1678	10800286148000	10524	5434	4	0	0
34796	1678	10800326148000	10524	5434	5	0	0
34798	1678	11520326317000	10765	5557	4	0	0
34801	1678	12240366486000	11036	5681	2	0	0
34802	1678	12240386486000	11036	5681	3	0	0
34804	1678	12960386822000	11626	5984	2	0	0
34805	1678	12960388822000	11626	5984	3	0	0
34808	1678	13680388906000	12599	6497	2	0	0
34811	1678	14400400243000	13062	6734	19	0	0
34812	1678	14400545243000	13062	6734	20	0	0
34815	1678	15120545850000	13970	7159	12	0	0
34817	1678	15120567319000	13173	6787	5	0	\N
34832	1678	20160671986000	17214	8722	3	0	\N
34833	1678	20160683986000	17214	8722	4	0	\N
34836	1678	20880708159000	17478	8850	8	0	\N
34837	1678	20880708770000	18445	9298	3	0	\N
34839	1678	20880720770000	18445	9298	4	0	\N
34841	1678	20880770159000	17478	8850	9	0	\N
34860	1678	27360840137000	25189	12496	6	0	\N
34861	1678	27360855137000	25189	12496	7	0	\N
34863	1678	28080856211000	26819	13263	4	0	\N
34864	1678	28080856259000	26893	13299	4	0	\N
34865	1678	28080856651000	27472	13577	7	0	\N
34866	1678	28080856720000	27560	13623	4	0	\N
34868	1678	28080863651000	27472	13577	8	0	\N
34870	1678	28080869259000	26893	13299	5	0	\N
34871	1678	28080869720000	27560	13623	5	0	\N
34872	1678	28080878211000	26819	13263	5	0	\N
34875	1678	29520894913000	29394	14492	5	0	\N
34877	1678	29520908913000	29394	14492	6	0	\N
34879	1678	30240912397000	30167	14843	9	0	\N
34880	1678	30240929846717	30167	14843	12	0	\N
34883	1679	1439120000000	20	12	1	0	\N
34885	1679	1439130000000	20	12	2	0	\N
34889	1679	2879150000000	137	81	1	0	\N
34891	1679	2879160000000	137	81	2	0	\N
34895	1679	4318081657000	26091	12894	2	0	\N
34897	1679	4318092657000	26091	12894	3	0	\N
34907	1679	5039180000000	248	146	2	0	\N
34908	1679	5039180000000	341	195	2	0	\N
34910	1679	5039200000000	248	146	3	0	\N
34911	1679	5039200000000	341	195	3	0	\N
34913	1679	5758103657000	26154	12928	6	0	\N
34914	1679	5758103657000	26231	12969	7	0	\N
34918	1679	5758127657000	26154	12928	7	0	\N
34919	1679	5758128657000	26231	12969	8	0	\N
34922	1679	5759201000000	350	201	1	0	\N
34923	1679	5759201000000	374	213	1	0	\N
34925	1679	5759211000000	350	201	2	0	\N
34926	1679	5759211000000	374	213	2	0	\N
34932	1679	6479241000000	412	234	1	0	\N
34934	1679	6479251000000	412	234	2	0	\N
34942	1679	7918162656999	26407	13065	6	0	\N
34944	1679	7918162656999	26753	13138	15	0	\N
34945	1679	7918186656999	26407	13065	7	0	\N
34947	1679	7918187656999	26753	13138	16	0	\N
34950	1679	7919261000000	510	286	1	0	\N
34951	1679	7919261000000	542	307	1	0	\N
34952	1679	7919261000000	629	353	1	0	\N
34884	1679	1439120000000	106	65	2	0	0
34886	1679	1439140000000	106	65	3	0	0
34887	1679	2159140000000	132	78	1	0	0
34888	1679	2159150000000	132	78	2	0	0
34890	1679	2879150000000	152	90	1	0	0
34893	1679	3599160000000	153	91	1	0	0
34894	1679	3599170000000	153	91	2	0	0
34901	1679	4319170000000	178	105	1	0	0
34902	1679	4319180000000	178	105	2	0	0
34909	1679	5039180000000	345	197	3	0	0
34924	1679	5759201000000	379	215	4	0	0
34927	1679	5759241000000	379	215	5	0	0
34933	1679	6479241000000	427	243	1	0	0
34935	1679	6479251000000	427	243	2	0	0
34941	1679	7199261000000	467	262	2	0	0
34818	1678	15120584850000	13970	7159	13	0	0
34819	1678	15840584968000	14202	7248	6	0	0
34820	1678	15840599968000	14202	7248	7	0	0
34821	1678	16560600473000	14932	7609	5	0	0
34823	1678	17280624293000	16127	8200	3	0	0
34824	1678	17280636293000	16127	8200	4	0	0
34825	1678	18000636510000	16447	8365	2	0	0
34826	1678	18000647510000	16447	8365	3	0	0
34827	1678	18720647678000	16693	8479	3	0	0
34829	1678	19440659966000	17172	8704	3	0	0
34830	1678	19440671966000	17172	8704	4	0	0
34831	1678	19440703112000	17397	8812	4	0	0
34834	1678	20160703112000	17397	8812	10	0	0
34838	1678	20880708918000	18664	9405	3	0	0
34840	1678	20880720918000	18664	9405	4	0	0
34842	1678	21600721283000	19171	9671	3	0	0
34843	1678	21600733283000	19171	9671	4	0	0
34844	1678	22320733723000	19825	9988	2	0	0
34846	1678	23040744768000	19904	10024	3	0	0
34847	1678	23040756768000	19904	10024	4	0	0
34899	1679	4318437654000	20804	10458	2	0	75
34900	1679	4318448654000	20804	10458	3	0	75
34905	1679	5038448654000	20835	10472	2	0	75
34920	1679	5758459654000	20954	10539	3	0	75
34921	1679	5758471654000	20954	10539	4	0	75
34930	1679	6478471654000	21048	10577	3	0	75
34931	1679	6478483654000	21048	10577	4	0	75
34939	1679	7198494654000	21128	10612	3	0	75
34948	1679	7918494654000	21236	10665	2	0	75
34949	1679	7918505654000	21236	10665	3	0	75
34848	1678	23760757837000	21581	10819	1	0	0
34849	1678	23760767837000	21581	10819	2	0	0
34851	1678	24480780299000	22297	11161	4	0	0
34852	1678	25200780686000	22881	11437	2	0	0
34853	1678	25200791686000	22881	11437	3	0	0
34854	1678	25920791959000	23316	11635	4	0	0
34855	1678	25920813959000	23316	11635	5	0	0
34857	1678	26640836183000	23694	11801	8	0	0
34858	1678	26640839183000	23694	11801	9	0	0
34896	1679	4318081657000	26113	12905	2	0	100
34898	1679	4318092657000	26113	12905	3	0	100
34904	1679	5038103657000	26133	12918	3	0	100
34915	1679	5758103657000	26269	12991	3	0	100
34916	1679	5758115657000	26269	12991	4	0	100
34917	1679	5758126657000	26271	12992	2	0	100
34928	1679	6478126657000	26271	12992	5	0	100
34936	1679	7198128656999	26356	13033	7	0	100
34937	1679	7198162656999	26356	13033	8	0	100
34859	1678	27360830979000	26490	13103	7	0	1
34862	1678	27360855979000	26490	13103	8	0	1
34943	1679	7918162656999	26553	13138	7	0	100
34867	1678	28080857051000	27993	13845	3	0	1
34869	1678	28080869051000	27993	13845	4	0	1
34873	1678	28800869420000	28578	14114	7	0	1
34874	1678	28800894420000	28578	14114	8	0	1
34878	1678	29520912293000	29995	14770	9	0	1
34953	1679	7919261000000	641	360	1	0	\N
34955	1679	7919271000000	510	286	2	0	\N
34956	1679	7919271000000	542	307	2	0	\N
34957	1679	7919271000000	629	353	2	0	\N
34958	1679	7919271000000	641	360	2	0	\N
34961	1679	8638187656999	26754	13148	15	0	\N
34963	1679	8638212656999	26754	13148	16	0	\N
34964	1679	8638505654000	21294	10693	6	0	\N
34965	1679	8638505654000	21344	10713	6	0	\N
34966	1679	8638505654000	21478	10772	4	0	\N
34968	1679	8638518654000	21478	10772	5	0	\N
34970	1679	8638529654000	21294	10693	7	0	\N
34971	1679	8638529654000	21344	10713	7	0	\N
34973	1679	8639271000000	711	398	1	0	\N
34975	1679	8639281000000	711	398	2	0	\N
34977	1679	8854741853000	15910	8089	3	0	\N
34978	1679	8854741853000	15926	8097	3	0	\N
34979	1679	8854741853000	15959	8113	3	0	\N
34981	1679	8854753853000	15910	8089	4	0	\N
34982	1679	8854753853000	15926	8097	4	0	\N
34983	1679	8854753853000	15959	8113	4	0	\N
34986	1679	9358211656999	26756	13157	12	0	\N
34988	1679	9358233656999	26756	13157	13	0	\N
34989	1679	9358519654000	21819	10921	6	0	\N
34990	1679	9358519654000	21962	10987	3	0	\N
34991	1679	9358519654000	21977	10989	3	0	\N
34993	1679	9358531654000	21962	10987	4	0	\N
34994	1679	9358531654000	21977	10989	4	0	\N
34996	1679	9358543654000	21819	10921	7	0	\N
34997	1679	9359291000000	775	431	2	0	\N
34998	1679	9359291000000	863	478	1	0	\N
34999	1679	9359291000000	903	502	3	0	\N
35001	1679	9359301000000	863	478	2	0	\N
35002	1679	9359401000000	775	431	3	0	\N
35004	1679	9359411000000	903	502	4	0	\N
35007	1679	10078223656999	26674	13193	4	0	\N
35009	1679	10078223656999	26757	13185	5	0	\N
35010	1679	10078228656999	26757	13185	6	0	\N
35011	1679	10078236656999	26674	13193	5	0	\N
35015	1679	10079401000000	1000	553	1	0	\N
35016	1679	10079401000000	1039	578	1	0	\N
35018	1679	10079411000000	1000	553	2	0	\N
35019	1679	10079411000000	1039	578	2	0	\N
35031	1679	11518248656999	26759	13229	0	0	\N
35032	1679	11518248656999	26761	13232	0	0	\N
35045	1679	12238786653000	18041	9101	2	0	\N
35047	1679	12238797653000	18041	9101	3	0	\N
35049	1679	12239661000000	1153	635	3	0	\N
35052	1679	12239691000000	1153	635	4	0	\N
35055	1679	12958272656999	27263	13478	2	0	\N
35057	1679	12958283656999	27263	13478	3	0	\N
35065	1679	13174850853000	16428	8355	4	0	\N
35068	1679	13174863853000	16428	8355	5	0	\N
35071	1679	13678829652992	18249	9193	2	0	\N
35072	1679	13678829653000	18169	9162	3	0	\N
35074	1679	13678841653000	18169	9162	4	0	\N
35078	1679	13679681000000	1392	762	1	0	\N
35079	1679	13679681000000	1497	818	4	0	\N
35081	1679	13679691000000	1392	762	2	0	\N
35083	1679	13679721000000	1497	818	5	0	\N
35084	1679	13894862853000	16931	8582	3	0	\N
35085	1679	13894862853000	17118	8673	2	0	\N
35087	1679	13894873853000	17118	8673	3	0	\N
35088	1679	13894874853000	16931	8582	4	0	\N
34974	1679	8639271000000	741	415	2	0	0
34976	1679	8639291000000	741	415	3	0	0
35000	1679	9359291000000	915	509	2	0	0
35003	1679	9359401000000	915	509	3	0	0
35017	1679	10079401000000	1051	584	9	0	0
35027	1679	10799491000000	1068	592	1	0	0
35028	1679	10799501000000	1068	592	2	0	0
35037	1679	11519501000000	1089	603	16	0	0
35038	1679	11519661000000	1089	603	17	0	0
35050	1679	12239661000000	1181	652	1	0	0
35063	1679	12959671000000	1295	715	1	0	0
35064	1679	12959681000000	1295	715	2	0	0
35080	1679	13679681000000	1688	907	1	0	0
35082	1679	13679691000000	1688	907	2	0	0
34984	1679	8854753853000	16021	8146	4	0	48
35005	1679	9574753853000	16027	8149	9	0	48
35006	1679	9574789853000	16027	8149	10	0	48
35021	1679	10294789853000	16051	8164	3	0	48
35022	1679	10294801853000	16051	8164	4	0	48
35030	1679	11014813853000	16161	8213	4	0	48
35039	1679	11734813853000	16193	8230	4	0	48
35040	1679	11734826853000	16193	8230	5	0	48
35053	1679	12454826853000	16424	8353	6	0	48
35054	1679	12454850853000	16424	8353	7	0	48
35067	1679	13174862853000	16592	8432	4	0	48
35086	1679	13894862853000	17173	8705	3	0	48
35046	1679	12238786653000	18062	9109	6	0	50
35048	1679	12238819653000	18062	9109	7	0	50
35061	1679	12958829653000	18066	9111	2	0	50
35073	1679	13678829653000	18405	9278	3	0	50
35075	1679	13678850653000	18405	9278	4	0	50
34967	1679	8638505654000	21697	10868	5	0	75
34969	1679	8638519654000	21697	10868	6	0	75
34992	1679	9358529654000	22009	11006	4	0	75
34995	1679	9358531654000	22009	11006	5	0	75
35013	1679	10078531654000	22065	11033	3	0	75
35014	1679	10078543654000	22065	11033	4	0	75
35025	1679	10798543654000	22068	11035	6	0	75
35035	1679	11518567654000	22111	11058	5	0	75
35036	1679	11518689654000	22111	11058	6	0	75
35043	1679	12238689654000	22161	11086	3	0	75
35044	1679	12238701654000	22161	11086	4	0	75
35062	1679	12958914654000	22166	11088	6	0	75
35076	1679	13678914654000	22200	11112	6	0	75
35077	1679	13678938654000	22200	11112	7	0	75
34960	1679	8638187656999	26588	13154	6	0	100
34962	1679	8638211656999	26588	13154	7	0	100
34987	1679	9358223656999	26633	13176	4	0	100
35008	1679	10078223656999	26694	13202	4	0	100
35012	1679	10078236656999	26694	13202	5	0	100
35023	1679	10798236656999	26701	13206	3	0	100
35024	1679	10798248656999	26701	13206	4	0	100
35034	1679	11518260656999	26822	13264	4	0	100
35041	1679	12238260656999	27032	13368	3	0	100
35042	1679	12238272656999	27032	13368	4	0	100
35056	1679	12958272656999	27311	13500	3	0	100
35069	1679	13678284656999	27312	13501	3	0	100
35070	1679	13678296656999	27312	13501	4	0	100
35094	1679	14398938654000	22286	11156	3	0	\N
35096	1679	14398950654000	22286	11156	4	0	\N
35098	1679	14398961654000	22360	11192	2	0	\N
35099	1679	14399691000000	1736	932	1	0	\N
35101	1679	14399701000000	1736	932	2	0	\N
35103	1679	14614874853000	17315	8772	2	0	\N
35104	1679	14614874853000	17333	8780	6	0	\N
35105	1679	14614874853000	17458	8841	36	0	\N
35107	1679	14614885853000	17315	8772	3	0	\N
35109	1679	14614898853000	17333	8780	7	0	\N
35110	1679	14615162853000	17458	8841	37	0	\N
35116	1679	15118961654000	22360	11192	5	0	\N
35118	1679	15118963654000	22360	11192	6	0	\N
35125	1679	15677342711000	11110	5713	1	0	\N
35126	1679	15838320656999	27346	13521	3	0	\N
35128	1679	15838332656999	27346	13521	4	0	\N
35134	1679	15839751000000	1969	1041	2	0	\N
35135	1679	15839751000000	1973	1043	1	0	\N
35136	1679	15839751000000	2007	1059	2	0	\N
35137	1679	15839751000000	2022	1066	2	0	\N
35139	1679	15839761000000	1973	1043	2	0	\N
35141	1679	15839771000000	1969	1041	3	0	\N
35142	1679	15839771000000	2007	1059	3	0	\N
35143	1679	15839771000000	2022	1066	3	0	\N
35146	1679	16397332711000	10791	5571	6	0	\N
35147	1679	16397332711000	10961	5649	7	0	\N
35148	1679	16397332711000	11096	5709	2	0	\N
35149	1679	16397332711000	11192	5746	2	0	\N
35151	1679	16397342711000	11110	5713	3	0	\N
35153	1679	16397352711000	11096	5709	3	0	\N
35154	1679	16397352711000	11110	5713	4	0	\N
35155	1679	16397352711000	11192	5746	3	0	\N
35156	1679	16397392711000	10791	5571	7	0	\N
35157	1679	16397982711000	10961	5649	8	0	\N
35160	1679	16558997653000	18566	9356	7	0	\N
35163	1679	16559046654000	22567	11290	12	0	\N
35164	1679	16559046654000	22604	11309	2	0	\N
35166	1679	16559057654000	22604	11309	3	0	\N
35168	1679	16559085654000	22567	11290	13	0	\N
35169	1679	16559112653000	18566	9356	8	0	\N
35171	1679	16774951853000	17620	8910	3	0	\N
35172	1679	16774951853000	17825	9002	6	0	\N
35174	1679	16774963853000	17620	8910	4	0	\N
35176	1679	16774975853000	17825	9002	7	0	\N
35177	1679	17117343711000	11411	5861	3	0	\N
35180	1679	17117364711000	11411	5861	4	0	\N
35181	1679	17278416656999	27387	13542	6	0	\N
35183	1679	17278440656999	27387	13542	7	0	\N
35191	1679	17494963853000	17935	9047	3	0	\N
35192	1679	17494963853000	17965	9062	10	0	\N
35193	1679	17494975853000	17935	9047	4	0	\N
35194	1679	17495000853000	17965	9062	11	0	\N
35203	1679	17999771000000	2367	1237	1	0	\N
35204	1679	17999771000000	2441	1277	1	0	\N
35206	1679	17999781000000	2367	1237	2	0	\N
35207	1679	17999781000000	2441	1277	2	0	\N
35211	1679	18718462656999	27673	13675	3	0	\N
35212	1679	18718462656999	27700	13687	6	0	\N
35213	1679	18718462656999	27714	13694	2	0	\N
35214	1679	18718462656999	28296	13987	5	0	\N
35215	1679	18718462656999	28453	14062	2	0	\N
35217	1679	18718473656999	27714	13694	3	0	\N
35218	1679	18718473656999	28453	14062	3	0	\N
35220	1679	18718474656999	27673	13675	4	0	\N
35221	1679	18718485656999	28296	13987	6	0	\N
35222	1679	18718495656999	27700	13687	7	0	\N
35223	1679	18719077653000	18960	9564	3	0	\N
35224	1679	18719077653000	19010	9585	1	0	\N
35119	1679	15119731000000	1858	991	2	0	0
35120	1679	15119751000000	1858	991	3	0	0
35138	1679	15839751000000	2214	1166	1	0	0
35140	1679	15839761000000	2214	1166	2	0	0
35170	1679	16559751000000	2337	1222	0	0	0
35190	1679	17279771000000	2349	1229	3	0	0
35205	1679	17999771000000	2445	1279	1	0	0
35208	1679	17999781000000	2445	1279	2	0	0
35123	1679	15677292711000	10611	5480	4	0	22
35124	1679	15677332711000	10611	5480	5	0	22
35152	1679	16397343711000	11363	5836	3	0	22
35178	1679	17117343711000	11415	5863	1	0	22
35179	1679	17117344711000	11415	5863	2	0	22
35195	1679	17837344711000	11452	5883	4	0	22
35209	1679	18557366711000	11462	5890	2	0	22
35210	1679	18557377711000	11462	5890	3	0	22
35089	1679	13894874853000	17173	8705	4	0	48
35106	1679	14614874853000	17476	8848	3	0	48
35108	1679	14614886853000	17476	8848	4	0	48
35122	1679	15334940853000	17477	8849	10	0	48
35144	1679	16054940853000	17516	8869	2	0	48
35145	1679	16054951853000	17516	8869	3	0	48
35173	1679	16774951853000	17922	9041	3	0	48
35175	1679	16774963853000	17922	9041	4	0	48
35093	1679	14398862653000	18454	9301	4	0	50
35113	1679	15118862653000	18489	9312	2	0	50
35114	1679	15118873653000	18489	9312	3	0	50
35130	1679	15838873653000	18531	9336	7	0	50
35161	1679	16558997653000	18582	9365	7	0	50
35162	1679	16559031653000	18582	9365	8	0	50
35185	1679	17279031653000	18788	9468	5	0	50
35186	1679	17279054653000	18788	9468	6	0	50
35199	1679	17999054653000	18802	9475	5	0	50
35095	1679	14398938654000	22338	11181	3	0	75
35097	1679	14398950654000	22338	11181	4	0	75
35115	1679	15118950654000	22405	11216	2	0	75
35117	1679	15118961654000	22405	11216	3	0	75
35131	1679	15838961654000	22533	11273	13	0	75
35165	1679	16559046654000	22689	11344	2	0	75
35167	1679	16559057654000	22689	11344	3	0	75
35187	1679	17279057654000	22723	11360	4	0	75
35188	1679	17279070654000	22723	11360	5	0	75
35202	1679	17999094654000	22738	11369	7	0	75
35090	1679	14398296656999	27316	13504	3	0	100
35091	1679	14398308656999	27316	13504	4	0	100
35111	1679	15118308656999	27344	13519	3	0	100
35112	1679	15118320656999	27344	13519	4	0	100
35129	1679	15838356656999	27355	13525	10	0	100
35158	1679	16558356656999	27374	13536	15	0	100
35159	1679	16558416656999	27374	13536	16	0	100
35182	1679	17278416656999	27536	13613	7	0	100
35184	1679	17278450656999	27536	13613	8	0	100
35198	1679	17998462656999	27656	13667	4	0	100
35216	1679	18718462656999	28489	14079	2	0	100
35219	1679	18718473656999	28489	14079	3	0	100
35226	1679	18719087653000	19010	9585	2	0	\N
35227	1679	18719089653000	18960	9564	4	0	\N
35231	1679	18719781000000	2539	1336	1	0	\N
35233	1679	18719791000000	2539	1336	2	0	\N
35240	1679	19439118654000	22876	11436	4	0	\N
35244	1679	19439131654000	22876	11436	5	0	\N
35247	1679	19997402711000	11692	6011	1	0	\N
35249	1679	19997403711000	11692	6011	2	0	\N
35250	1679	20158487656999	28538	14100	2	0	\N
35251	1679	20158487656999	28631	14138	2	0	\N
35253	1679	20158498656999	28538	14100	3	0	\N
35254	1679	20158498656999	28631	14138	3	0	\N
35260	1679	20159154654000	23060	11514	3	0	\N
35261	1679	20159801000000	2584	1362	1	0	\N
35263	1679	20159811000000	2584	1362	2	0	\N
35270	1679	20879142654000	23000	11490	3	0	\N
35271	1679	20879142654000	23094	11532	7	0	\N
35274	1679	20879154654000	23000	11490	4	0	\N
35275	1679	20879154654000	23060	11514	5	0	\N
35277	1679	20879155654000	23060	11514	6	0	\N
35278	1679	20879167654000	23094	11532	8	0	\N
35281	1679	21437442711000	11760	6046	2	0	\N
35283	1679	21437444711000	11760	6046	3	0	\N
35291	1679	21599842000000	2845	1490	1	0	\N
35293	1679	21599852000000	2845	1490	2	0	\N
35297	1679	22318535656999	28808	14210	3	0	\N
35299	1679	22318547656999	28808	14210	4	0	\N
35308	1679	23038547656999	29011	14305	4	0	\N
35310	1679	23038560656999	29011	14305	5	0	\N
35320	1679	23758569656999	29100	14345	2	0	\N
35321	1679	23758569656999	29187	14388	6	0	\N
35322	1679	23758569656999	29263	14423	12	0	\N
35324	1679	23758580656999	29100	14345	3	0	\N
35325	1679	23758593656999	29187	14388	7	0	\N
35327	1679	23758617656999	29263	14423	13	0	\N
35331	1679	23759902000000	3122	1623	3	0	\N
35333	1679	23759932000000	3122	1623	4	0	\N
35334	1679	24317449711000	12074	6217	3	0	\N
35335	1679	24317449711000	12119	6243	2	0	\N
35337	1679	24317451711000	12119	6243	3	0	\N
35338	1679	24317452711000	12074	6217	4	0	\N
35340	1679	24478594656999	29333	14455	3	0	\N
35342	1679	24478606656999	29333	14455	4	0	\N
35344	1679	24478654656999	29480	14537	11	0	\N
35345	1679	24479214653000	19807	9976	3	0	\N
35347	1679	24479226653000	19807	9976	4	0	\N
35351	1679	24479902000000	3169	1647	1	0	\N
35353	1679	24479912000000	3169	1647	2	0	\N
35357	1679	25198607656999	29393	14491	2	0	\N
35359	1679	25198618656999	29393	14491	3	0	\N
35245	1679	19439791000000	2565	1351	1	0	0
35246	1679	19439801000000	2565	1351	2	0	0
35262	1679	20159801000000	2696	1417	1	0	0
35264	1679	20159811000000	2696	1417	2	0	0
35279	1679	20879811000000	2836	1482	4	0	0
35292	1679	21599842000000	2881	1506	2	0	0
35294	1679	21599862000000	2881	1506	3	0	0
35305	1679	22319862000000	3108	1614	3	0	0
35306	1679	22319892000000	3108	1614	4	0	0
35317	1679	23039892000000	3119	1621	1	0	0
35332	1679	23759902000000	3126	1626	0	0	0
35352	1679	24479902000000	3328	1727	7	0	0
35354	1679	24479972000000	3328	1727	8	0	0
35235	1679	19277377711000	11501	5908	6	0	22
35248	1679	19997402711000	11725	6027	0	0	22
35265	1679	20717402711000	11734	6031	4	0	22
35266	1679	20717442711000	11734	6031	5	0	22
35282	1679	21437442711000	11785	6058	2	0	22
35284	1679	21437444711000	11785	6058	3	0	22
35296	1679	22157449711000	11832	6082	6	0	22
35307	1679	22877449711000	11937	6144	0	0	22
35319	1679	23597449711000	11939	6146	0	0	22
35336	1679	24317449711000	12173	6268	3	0	22
35339	1679	24317452711000	12173	6268	4	0	22
35356	1679	25037453711000	12205	6288	2	0	22
35225	1679	18719077653000	19026	9592	5	0	50
35229	1679	18719118653000	19026	9592	6	0	50
35239	1679	19439118653000	19164	9667	3	0	50
35256	1679	20159130653000	19262	9710	3	0	50
35258	1679	20159142653000	19262	9710	4	0	50
35269	1679	20879142653000	19350	9756	3	0	50
35273	1679	20879154653000	19350	9756	4	0	50
35287	1679	21599154653000	19372	9767	3	0	50
35301	1679	22319166653000	19560	9851	2	0	50
35303	1679	22319177653000	19560	9851	3	0	50
35312	1679	23039177653000	19746	9941	3	0	50
35313	1679	23039189653000	19746	9941	4	0	50
35328	1679	23759189653000	19773	9956	7	0	50
35346	1679	24479214653000	20002	10071	5	0	50
35348	1679	24479246653000	20002	10071	6	0	50
35228	1679	18719094654000	22771	11387	6	0	75
35230	1679	18719118654000	22771	11387	7	0	75
35243	1679	19439130654000	22938	11462	4	0	75
35257	1679	20159130654000	22998	11489	3	0	75
35259	1679	20159142654000	22998	11489	4	0	75
35272	1679	20879142654000	23146	11559	3	0	75
35276	1679	20879154654000	23146	11559	4	0	75
35290	1679	21599170654000	23185	11575	8	0	75
35302	1679	22319170654000	23225	11591	5	0	75
35304	1679	22319292654000	23225	11591	6	0	75
35314	1679	23039292654000	23243	11599	2	0	75
35315	1679	23039303654000	23243	11599	3	0	75
35330	1679	23759313653000	23358	11656	2	0	75
35349	1679	24479313653000	23400	11673	2	0	75
35350	1679	24479324653000	23400	11673	3	0	75
35237	1679	19438473656999	28512	14089	5	0	100
35252	1679	20158487656999	28642	14142	4	0	100
35255	1679	20158509656999	28642	14142	5	0	100
35267	1679	20878509656999	28699	14168	4	0	100
35268	1679	20878522656999	28699	14168	5	0	100
35285	1679	21598522656999	28783	14197	4	0	100
35298	1679	22318535656999	28986	14293	3	0	100
35300	1679	22318547656999	28986	14293	4	0	100
35309	1679	23038547656999	29035	14318	4	0	100
35311	1679	23038569656999	29035	14318	5	0	100
35323	1679	23758569656999	29280	14430	7	0	100
35341	1679	24478594656999	29338	14458	4	0	100
35343	1679	24478607656999	29338	14458	5	0	100
35358	1679	25198607656999	29568	14578	6	0	100
35360	1679	25198631656999	29568	14578	7	0	100
35361	1679	25198654656999	29480	14537	12	0	\N
35362	1679	25199246653000	20034	10086	3	0	\N
35364	1679	25199258653000	20034	10086	4	0	\N
35366	1679	25199324653000	23428	11689	2	0	\N
35367	1679	25199324653000	23437	11691	2	0	\N
35369	1679	25199324653000	24281	11792	0	0	\N
35370	1679	25199324653000	24283	11793	0	0	\N
35371	1679	25199335653000	23428	11689	3	0	\N
35372	1679	25199335653000	23437	11691	3	0	\N
35378	1679	25918631656999	29613	14604	7	0	\N
35380	1679	25918656656999	29613	14604	8	0	\N
35382	1679	25919296653000	20156	10146	3	0	\N
35384	1679	25919308653000	20156	10146	4	0	\N
35386	1679	25919336653000	23785	11843	4	0	\N
35387	1679	25919336653000	23809	11852	3	0	\N
35388	1679	25919336653000	23945	11915	3	0	\N
35390	1679	25919336653000	24285	11805	0	0	\N
35391	1679	25919336653000	24286	11817	0	0	\N
35392	1679	25919339653000	20284	10215	3	0	\N
35394	1679	25919348653000	23809	11852	4	0	\N
35395	1679	25919348653000	23945	11915	4	0	\N
35396	1679	25919349653000	23785	11843	5	0	\N
35399	1679	26477457711000	12784	6590	4	0	\N
35402	1679	26477479711000	12784	6590	5	0	\N
35405	1679	26639318653000	20279	10213	4	0	\N
35407	1679	26639331653000	20279	10213	5	0	\N
35408	1679	26639339653000	20284	10215	7	0	\N
35409	1679	26639342653000	20284	10215	8	0	\N
35417	1679	27197467711000	12918	6657	4	0	\N
35418	1679	27197467711000	12968	6688	2	0	\N
35419	1679	27197467711000	13097	6750	4	0	\N
35420	1679	27197467711000	13128	6767	12	0	\N
35421	1679	27197467711000	13143	6774	3	0	\N
35423	1679	27197478711000	12968	6688	3	0	\N
35424	1679	27197479711000	13143	6774	4	0	\N
35426	1679	27197480711000	13097	6750	5	0	\N
35427	1679	27197489711000	12918	6657	5	0	\N
35428	1679	27197506711000	13128	6767	13	0	\N
35429	1679	27358884656999	29685	14642	10	0	\N
35430	1679	27358884656999	29809	14688	5	0	\N
35432	1679	27358898656999	29809	14688	6	0	\N
35433	1679	27358903656999	29685	14642	11	0	\N
35435	1679	27358952656999	29848	14710	9	0	\N
35437	1679	27359358653000	24145	12019	2	0	\N
35438	1679	27359358653000	24458	12163	4	0	\N
35440	1679	27359369653000	24145	12019	3	0	\N
35443	1679	27359380653000	24458	12163	5	0	\N
35444	1679	27360042000000	3528	1832	1	0	\N
35445	1679	27360042000000	3546	1840	0	0	\N
35447	1679	27360043000000	3528	1832	2	0	\N
35450	1679	27917479711000	13232	6817	2	0	\N
35451	1679	27917479711000	13261	6832	5	0	\N
35453	1679	27917481711000	13232	6817	3	0	\N
35455	1679	27917502711000	13261	6832	6	0	\N
35456	1679	28078925656999	29872	14722	14	0	\N
35459	1679	28078952656999	29848	14710	38	0	\N
35460	1679	28078957656999	29872	14722	15	0	\N
35461	1679	28078980604685	29848	14710	40	1	\N
35462	1679	28079369653000	24518	12193	2	0	\N
35465	1679	28079380653000	24518	12193	3	0	\N
35469	1679	28187902652000	13800	7083	5	0	\N
35470	1679	28187902652000	13849	7107	1	0	\N
35472	1679	28187912652000	13849	7107	2	0	\N
35474	1679	28187943652000	13800	7083	6	0	\N
35475	1679	28637491711000	13298	6852	3	0	\N
35477	1679	28637503711000	13298	6852	4	0	\N
35481	1679	28799000656999	30110	14820	11	0	\N
35483	1679	28799391653000	24720	12277	8	0	\N
35484	1679	28799391653000	24817	12323	5	0	\N
35487	1679	28799414653000	24817	12323	6	0	\N
35488	1679	28799453653000	24720	12277	9	0	\N
35492	1679	28907912652000	14078	7160	0	0	\N
35493	1679	28907912652000	14079	7172	0	0	\N
35494	1679	28907912652000	14080	7184	0	0	\N
35495	1679	28907912652000	14081	7197	0	0	\N
35496	1679	28907912652000	14082	7202	0	0	\N
35397	1679	25920022000000	3380	1759	1	0	0
35398	1679	25920032000000	3380	1759	2	0	0
35413	1679	26640032000000	3430	1781	1	0	0
35414	1679	26640042000000	3430	1781	2	0	0
35446	1679	27360042000000	3573	1855	0	0	0
35490	1679	28800042000000	3708	1925	1	0	0
35491	1679	28800052000000	3708	1925	2	0	0
35376	1679	25757453711000	12325	6353	4	0	22
35377	1679	25757457711000	12325	6353	5	0	22
35400	1679	26477457711000	12839	6621	1	0	22
35422	1679	27197467711000	13207	6805	3	0	22
35425	1679	27197479711000	13207	6805	4	0	22
35452	1679	27917479711000	13295	6849	3	0	22
35454	1679	27917491711000	13295	6849	4	0	22
35478	1679	28637527711000	13304	6855	10	0	22
35415	1679	26747876652000	13712	7046	4	0	24
35416	1679	26747889652000	13712	7046	5	0	24
35448	1679	27467889652000	13764	7071	4	0	24
35449	1679	27467902652000	13764	7071	5	0	24
35473	1679	28187912652000	13913	7135	2	0	24
35363	1679	25199246653000	20060	10099	14	0	50
35365	1679	25199296653000	20060	10099	15	0	50
35383	1679	25919296653000	20197	10172	4	0	50
35385	1679	25919318653000	20197	10172	5	0	50
35410	1679	26639342653000	20368	10261	7	0	50
35436	1679	27359342653000	20414	10285	10	0	50
35442	1679	27359370653000	20414	10285	11	0	50
35464	1679	28079370653000	20444	10296	2	0	50
35482	1679	28799381653000	20584	10356	10	0	50
35489	1679	28799463653000	20584	10356	11	0	50
35368	1679	25199324653000	23690	11799	3	0	75
35373	1679	25199336653000	23690	11799	4	0	75
35389	1679	25919336653000	24072	11981	2	0	75
35411	1679	26639347653000	24139	12016	2	0	75
35412	1679	26639358653000	24139	12016	3	0	75
35439	1679	27359358653000	24460	12164	2	0	75
35441	1679	27359369653000	24460	12164	3	0	75
35463	1679	28079369653000	24567	12213	4	0	75
35485	1679	28799391653000	24945	12381	3	0	75
35486	1679	28799403653000	24945	12381	4	0	75
35379	1679	25918631656999	29654	14624	20	0	100
35381	1679	25918867656999	29654	14624	21	0	100
35404	1679	26638884656999	29660	14629	9	0	100
35431	1679	27358884656999	29838	14704	23	0	100
35434	1679	27358925656999	29838	14704	24	0	100
35457	1679	28078925656999	29971	14760	9	0	100
35458	1679	28078943656999	29971	14760	10	0	100
35480	1679	28798962656999	30007	14776	11	0	100
35497	1679	28907912652000	14233	7267	4	0	\N
35499	1679	28907925652000	14233	7267	5	0	\N
35501	1679	29357527711000	13430	6919	4	0	\N
35502	1679	29357540711000	13430	6919	5	0	\N
35505	1679	29519000656999	30110	14820	53	0	\N
35506	1679	29519041656999	30110	14820	54	0	\N
35509	1679	29520052000000	3800	1970	2	0	\N
35512	1679	29520072000000	3800	1970	3	0	\N
35528	1679	31067947652000	14481	7391	4	0	\N
35529	1679	31067947652000	14629	7458	3	0	\N
35530	1679	31067947652000	14675	7476	24	0	\N
35532	1679	31067947652000	14773	7495	0	0	\N
35533	1679	31067947652000	14774	7483	0	0	\N
35534	1679	31067947652000	14775	7508	0	0	\N
35536	1679	31067959652000	14629	7458	4	0	\N
35537	1679	31067960652000	14481	7391	5	0	\N
35538	1679	31068160652000	14675	7476	25	0	\N
35539	1679	31679044746974	30294	14893	7	0	\N
35540	1679	31679060746974	30294	14893	8	0	\N
35545	1679	31787958652000	14776	7519	0	0	\N
35546	1679	31787958652000	14912	7597	4	0	\N
35549	1679	31787971652000	14912	7597	5	0	\N
35550	1679	32399488653000	25337	12566	3	0	\N
35552	1679	32399500653000	25337	12566	4	0	\N
35554	1679	32400212000000	4483	2322	1	0	\N
35555	1679	32400212000000	4653	2404	2	0	\N
35556	1679	32400212000000	4699	2430	1	0	\N
35558	1679	32400222000000	4483	2322	2	0	\N
35559	1679	32400222000000	4699	2430	2	0	\N
35560	1679	32400232000000	4653	2404	3	0	\N
35562	1679	32507969652000	15021	7654	2	0	\N
35564	1679	32507980652000	15021	7654	3	0	\N
35566	1679	33119500653000	25679	12707	6	0	\N
35569	1679	33119533653000	25679	12707	7	0	\N
35574	1679	33839512653000	25690	12711	3	0	\N
35576	1679	33839524653000	25690	12711	4	0	\N
35582	1679	34559524653000	25807	12760	6	0	\N
35583	1679	34559524653000	25825	12770	3	0	\N
35584	1679	34559524653000	25834	12774	4	0	\N
35586	1679	34559536653000	25825	12770	4	0	\N
35587	1679	34559537653000	25834	12774	5	0	\N
35589	1679	34559548653000	25807	12760	7	0	\N
35594	1679	34668034652000	15347	7821	1	0	\N
35599	1679	35388024652000	15307	7799	1	0	\N
35600	1679	35388024652000	15474	7879	2	0	\N
35601	1679	35388024652000	15497	7887	6	0	\N
35603	1679	35388034652000	15307	7799	2	0	\N
35604	1679	35388034652000	15347	7821	4	0	\N
35605	1679	35388035652000	15474	7879	3	0	\N
35606	1679	35388036652000	15347	7821	5	0	\N
35608	1679	35388057652000	15497	7887	7	0	\N
35609	1679	35999549653000	25977	12835	2	0	\N
35610	1679	35999560653000	25977	12835	3	0	\N
35615	1679	36720292000000	5025	2609	1	0	\N
35616	1679	36720292000000	5032	2611	1	0	\N
35618	1679	36720302000000	5025	2609	2	0	\N
35619	1679	36720302000000	5032	2611	2	0	\N
35629	1679	38268068652000	15715	7991	4	0	\N
35630	1679	38268081652000	15715	7991	5	0	\N
35519	1679	30240062000000	4069	2115	2	0	0
35520	1679	30240082000000	4069	2115	3	0	0
35526	1679	30960082000000	4090	2125	2	0	0
35527	1679	30960192000000	4090	2125	3	0	0
35543	1679	31680192000000	4453	2307	2	0	0
35557	1679	32400212000000	4747	2454	3	0	0
35561	1679	32400242000000	4747	2454	4	0	0
35570	1679	33120242000000	4787	2475	1	0	0
35571	1679	33120252000000	4787	2475	2	0	0
35578	1679	33840252000000	4808	2489	1	0	0
35590	1679	34560262000000	4955	2567	1	0	0
35591	1679	34560272000000	4955	2567	2	0	0
35597	1679	35280272000000	4956	2568	1	0	0
35598	1679	35280282000000	4956	2568	2	0	0
35612	1679	36000292000000	5003	2594	2	0	0
35617	1679	36720292000000	5071	2630	1	0	0
35620	1679	36720302000000	5071	2630	2	0	0
35623	1679	37440302000000	5093	2643	1	0	0
35624	1679	37440312000000	5093	2643	2	0	0
35628	1679	38160332000000	5145	2667	3	0	0
35631	1679	38880332000000	5198	2703	1	0	0
35632	1679	38880342000000	5198	2703	2	0	0
35498	1679	28907912652000	14305	7300	7	0	24
35500	1679	28907937652000	14305	7300	8	0	24
35514	1679	29627947652000	14355	7328	2	0	24
35521	1679	30347947652000	14372	7334	0	0	24
35531	1679	31067947652000	14749	7509	2	0	24
35535	1679	31067958652000	14749	7509	3	0	24
35548	1679	31787969652000	14915	7600	3	0	24
35563	1679	32507969652000	15103	7695	3	0	24
35565	1679	32507990652000	15103	7695	4	0	24
35572	1679	33227990652000	15110	7699	2	0	24
35573	1679	33228001652000	15110	7699	3	0	24
35581	1679	33948013652000	15116	7704	4	0	24
35592	1679	34668013652000	15198	7744	2	0	24
35593	1679	34668024652000	15198	7744	3	0	24
35602	1679	35388024652000	15501	7889	3	0	24
35607	1679	35388036652000	15501	7889	4	0	24
35614	1679	36108047652000	15528	7902	3	0	24
35621	1679	36828047652000	15581	7932	1	0	24
35622	1679	36828057652000	15581	7932	2	0	24
35625	1679	37548057652000	15604	7943	2	0	24
35507	1679	29519403653000	24982	12398	5	0	75
35508	1679	29519417653000	24982	12398	6	0	75
35517	1679	30239417653000	24986	12399	11	0	75
35518	1679	30239464653000	24986	12399	12	0	75
35524	1679	30959464653000	25287	12544	3	0	75
35541	1679	31679476653000	25294	12548	3	0	75
35542	1679	31679488653000	25294	12548	4	0	75
35551	1679	32399488653000	25606	12673	3	0	75
35553	1679	32399500653000	25606	12673	4	0	75
35567	1679	33119500653000	25684	12708	3	0	75
35575	1679	33839512653000	25764	12743	3	0	75
35577	1679	33839524653000	25764	12743	4	0	75
35585	1679	34559524653000	25840	12776	4	0	75
35588	1679	34559537653000	25840	12776	5	0	75
35596	1679	35279549653000	25864	12786	4	0	75
35503	1679	29518962656999	30155	14838	10	0	100
35504	1679	29518990656999	30155	14838	11	0	100
35515	1679	30238990656999	30245	14871	19	0	100
35516	1679	30239027656999	30245	14871	20	0	100
35523	1679	30959044746974	30277	14888	13	1	100
35633	1679	39600342000000	5201	2705	2	0	\N
35636	1679	39600362000000	5201	2705	3	0	\N
35644	1679	43920363000000	5785	3003	3	0	\N
35647	1679	43920573000000	5785	3003	4	0	\N
35650	1679	45360393000000	6136	3182	1	0	\N
35652	1679	45360403000000	6136	3182	2	0	\N
35658	1679	47520483000000	6437	3331	2	0	\N
35660	1679	47520503000000	6437	3331	3	0	\N
35662	1679	48240543000000	6467	3351	2	0	\N
35664	1679	48240563000000	6467	3351	3	0	\N
35672	1679	51120643000000	6752	3495	2	0	\N
35673	1679	51120643000000	6758	3498	2	0	\N
35675	1679	51120663000000	6752	3495	3	0	\N
35676	1679	51120663000000	6758	3498	3	0	\N
35678	1679	51840683000000	6842	3540	2	0	\N
35679	1679	51840683000000	6857	3546	9	0	\N
35681	1679	51840703000000	6842	3540	3	0	\N
35683	1679	51840863000000	6857	3546	10	0	\N
35692	1679	55440863000000	7221	3733	1	0	\N
35693	1679	55440863000000	7228	3737	1	0	\N
35695	1679	55440873000000	7221	3733	2	0	\N
35696	1679	55440873000000	7228	3737	2	0	\N
35702	1679	57600953000000	7367	3805	7	0	\N
35705	1679	57601023000000	7367	3805	8	0	\N
35706	1679	58320993000000	7606	3937	1	0	\N
35708	1679	58321003000000	7606	3937	2	0	\N
35716	1679	61201033000000	7815	4051	1	0	\N
35718	1679	61201043000000	7815	4051	2	0	\N
35722	1679	61921063000000	7892	4090	1	0	\N
35723	1679	62641053000000	7871	4079	2	0	\N
35724	1679	62641053000000	7877	4081	2	0	\N
35726	1679	62641063000000	7892	4090	2	0	\N
35727	1679	62641073000000	7871	4079	3	0	\N
35728	1679	62641073000000	7877	4081	3	0	\N
35734	1679	64801103000000	8288	4293	2	0	\N
35736	1679	64801118000000	8288	4293	3	0	\N
35738	1679	65521123000000	8390	4347	2	0	\N
35741	1679	65521138000000	8390	4347	3	0	\N
35742	1679	66000005000000	18249	9193	3	1	\N
35743	1679	66241133000000	8656	4484	1	0	\N
35745	1679	66241143000000	8656	4484	2	0	\N
35747	1679	66961153000000	8766	4547	2	0	\N
35749	1679	66961173000000	8766	4547	3	0	\N
35753	1679	68401233000000	8868	4595	2	0	\N
35754	1679	68401233000000	8904	4611	2	0	\N
35755	1679	68401233000000	8915	4619	1	0	\N
35757	1679	68401243000000	8915	4619	2	0	\N
35759	1679	68401253000000	8868	4595	3	0	\N
35760	1679	68401253000000	8904	4611	3	0	\N
35762	1679	69121243000000	9003	4667	1	0	\N
35763	1679	69121253000000	9003	4667	2	0	\N
35766	1679	69841261980000	9157	4745	2	0	\N
35767	1679	69841261980000	9200	4769	2	0	\N
35637	1679	40320352000000	5284	2744	1	0	0
35638	1679	40320362000000	5284	2744	2	0	0
35639	1679	41040362000000	5416	2818	1	0	0
35640	1679	41040363000000	5416	2818	2	0	0
35641	1679	41760363000000	5466	2846	0	0	0
35643	1679	43200363000000	5705	2959	0	0	0
35645	1679	43920363000000	5815	3018	2	0	0
35646	1679	43920383000000	5815	3018	3	0	0
35648	1679	44640383000000	6113	3170	1	0	0
35649	1679	44640393000000	6113	3170	2	0	0
35653	1679	45360433000000	6273	3250	5	0	0
35654	1679	46080433000000	6337	3280	1	0	0
35655	1679	46080443000000	6337	3280	2	0	0
35656	1679	46800443000000	6408	3320	4	0	0
35659	1679	47520483000000	6439	3332	6	0	0
35661	1679	47520543000000	6439	3332	7	0	0
35663	1679	48240543000000	6490	3363	4	0	0
35665	1679	48240583000000	6490	3363	5	0	0
35666	1679	48960583000000	6525	3381	2	0	0
35668	1679	49680603000000	6608	3418	2	0	0
35669	1679	49680623000000	6608	3418	3	0	0
35670	1679	50400623000000	6673	3449	2	0	0
35671	1679	50400643000000	6673	3449	3	0	0
35674	1679	51120643000000	6816	3528	4	0	0
35680	1679	51840683000000	6868	3553	6	0	0
35682	1679	51840743000000	6868	3553	7	0	0
35684	1679	52560743000000	6892	3561	4	0	0
35685	1679	52560783000000	6892	3561	5	0	0
35687	1679	53280803000000	6903	3566	3	0	0
35688	1679	54000803000000	7035	3629	4	0	0
35689	1679	54000843000000	7035	3629	5	0	0
35690	1679	54720843000000	7125	3681	2	0	0
35691	1679	54720863000000	7125	3681	3	0	0
35697	1679	55440873000000	7283	3764	2	0	0
35698	1679	56160873000000	7317	3782	3	0	0
35699	1679	56160903000000	7317	3782	4	0	0
35700	1679	56880903000000	7336	3791	5	0	0
35701	1679	56880953000000	7336	3791	6	0	0
35704	1679	57600993000000	7585	3924	5	0	0
35707	1679	58320993000000	7711	3994	1	0	0
35709	1679	58321003000000	7711	3994	2	0	0
35710	1679	59041003000000	7722	3999	1	0	0
35712	1679	59761013000000	7781	4034	1	0	0
35713	1679	59761023000000	7781	4034	2	0	0
35714	1679	60481023000000	7809	4048	1	0	0
35715	1679	60481033000000	7809	4048	2	0	0
35717	1679	61201033000000	7824	4056	1	0	0
35720	1679	61921043000000	7867	4077	1	0	0
35721	1679	61921053000000	7867	4077	2	0	0
35725	1679	62641053000000	7961	4125	3	0	0
35729	1679	62641083000000	7961	4125	4	0	0
35730	1679	63361083000000	8038	4166	1	0	0
35732	1679	64081093000000	8209	4255	1	0	0
35733	1679	64081103000000	8209	4255	2	0	0
35735	1679	64801103000000	8323	4308	2	0	0
35737	1679	64801123000000	8323	4308	3	0	0
35740	1679	65521133000000	8402	4354	2	0	0
35744	1679	66241133000000	8693	4506	2	0	0
35746	1679	66241153000000	8693	4506	3	0	0
35748	1679	66961153000000	8813	4569	2	0	0
35750	1679	66961173000000	8813	4569	3	0	0
35752	1679	67681233000000	8829	4577	7	0	0
35756	1679	68401233000000	8985	4660	1	0	0
35758	1679	68401243000000	8985	4660	2	0	0
35761	1679	68401253000000	9137	4733	1	0	0
35764	1679	69121253000000	9137	4733	3	0	0
35768	1679	69841261980000	9233	4786	2	0	0
35769	1679	69841281980000	9157	4745	3	0	\N
35770	1679	69841281980000	9200	4769	3	0	\N
35772	1679	70561281980000	9242	4794	3	0	\N
35773	1679	70561281980000	9256	4801	8	0	\N
35774	1679	70561281980000	9270	4807	3	0	\N
35775	1679	70561281980000	9289	4818	2	0	\N
35778	1679	70561301980000	9289	4818	3	0	\N
35779	1679	70561311980000	9242	4794	4	0	\N
35780	1679	70561311980000	9270	4807	4	0	\N
35781	1679	70561361980000	9256	4801	9	0	\N
35782	1679	71281291980000	9364	4858	2	0	\N
35783	1679	71281291980000	9393	4873	4	0	\N
35784	1679	71281291980000	9501	4928	2	0	\N
35786	1679	71281311980000	9364	4858	3	0	\N
35787	1679	71281311980000	9501	4928	3	0	\N
35789	1679	71281331980000	9393	4873	5	0	\N
35798	1679	74881412980000	9814	5087	6	0	\N
35801	1679	74881463980000	9814	5087	7	0	\N
35806	1679	77041492980000	9893	5128	1	0	\N
35808	1679	77041502980000	9893	5128	2	0	\N
35823	1679	82802133980000	10343	5353	2	0	\N
35825	1679	82802153980000	10343	5353	3	0	\N
35827	1680	100000106	23353	11407	104	0	\N
35828	1680	1405180000	14854	7571	10	1	\N
35841	1680	2173073499559	20677	10400	9	0	\N
35844	1680	2173109499559	20677	10400	10	0	\N
35853	1680	3609259500034	11284	5796	2	0	\N
35855	1680	3609259500035	11285	5796	2	0	\N
35856	1680	3609270500034	11284	5796	3	0	\N
35858	1680	3609270500035	11285	5796	3	0	\N
35859	1680	3613188499559	21170	10633	2	0	\N
35860	1680	3613188499559	21171	10575	8	0	\N
35861	1680	3613188499559	21238	10666	10	0	\N
35863	1680	3613199499559	21170	10633	3	0	\N
35865	1680	3613243499559	21238	10666	11	0	\N
35866	1680	3613350499559	21171	10575	9	0	\N
35867	1680	4319100000000	284	164	1	0	\N
35868	1680	4319100000000	544	308	1	0	\N
35870	1680	4319110000000	284	164	2	0	\N
35871	1680	4319110000000	544	308	2	0	\N
35873	1680	4319390000000	1125	591	28	0	\N
35874	1680	4329270500035	12028	6191	1	0	\N
35876	1680	4329271500035	12028	6191	2	0	\N
35880	1680	4333350499559	21237	10576	10	0	\N
35881	1680	4333397499559	21237	10576	11	0	\N
35882	1680	5039110000000	1123	619	1	0	\N
35883	1680	5039110000000	1178	650	2	0	\N
35885	1680	5039120000000	1123	619	2	0	\N
35887	1680	5039130000000	1178	650	3	0	\N
35888	1680	5039390000000	1125	591	71	0	\N
35889	1680	5039810000000	1125	591	72	0	\N
35890	1680	5049271500035	12634	6518	2	0	\N
35891	1680	5049271500035	12636	6518	2	0	\N
35892	1680	5049271500035	12793	6596	7	0	\N
35894	1680	5049282500035	12634	6518	3	0	\N
35895	1680	5049282500035	12636	6518	3	0	\N
35897	1680	5049287500035	12793	6596	8	0	\N
35900	1680	5053397499559	21277	10577	32	0	\N
35901	1680	5053510499559	21277	10577	33	0	\N
35902	1680	5054552499559	21456	10578	42	0	\N
35831	1680	1439060000000	19	12	1	0	0
35832	1680	1439070000000	19	12	2	0	0
35837	1680	2159070000000	41	26	1	0	0
35838	1680	2159080000000	41	26	2	0	0
35845	1680	2879080000000	180	107	1	0	0
35851	1680	3599090000000	196	116	1	0	0
35852	1680	3599100000000	196	116	2	0	0
35869	1680	4319100000000	908	505	1	0	0
35872	1680	4319110000000	908	505	2	0	0
35884	1680	5039110000000	1200	661	1	0	0
35903	1680	5759120000000	1241	686	1	0	0
35904	1680	5759130000000	1241	686	2	0	0
35771	1679	69841281980000	9233	4786	3	0	0
35776	1679	70561281980000	9358	4856	1	0	0
35785	1679	71281291980000	9561	4958	2	0	0
35788	1679	71281311980000	9561	4958	3	0	0
35790	1679	72001311980000	9574	4965	2	0	0
35791	1679	72001331980000	9574	4965	3	0	0
35792	1679	72721331980000	9650	5007	2	0	0
35794	1679	73441351980000	9722	5039	4	0	0
35795	1679	73441382980000	9722	5039	5	0	0
35796	1679	74161382980000	9763	5060	3	0	0
35797	1679	74161412980000	9763	5060	4	0	0
35799	1679	74881412980000	9851	5107	4	0	0
35802	1679	75601452980000	9864	5116	2	0	0
35803	1679	75601472980000	9864	5116	3	0	0
35804	1679	76321472980000	9890	5126	2	0	0
35805	1679	76321492980000	9890	5126	3	0	0
35809	1679	77041532980000	10055	5215	5	0	0
35810	1679	77761532980000	10066	5220	10	0	0
35811	1679	77761632980000	10066	5220	11	0	0
35812	1679	78481632980000	10085	5232	26	0	0
35813	1679	78481892980000	10085	5232	27	0	0
35815	1679	79201912980000	10165	5268	3	0	0
35816	1679	79921912980000	10177	5274	0	0	0
35817	1679	80641912980000	10202	5283	2	0	0
35818	1679	80641932980000	10202	5283	3	0	0
35819	1679	81361932980000	10225	5292	8	0	0
35821	1679	82082012980000	10327	5343	4	0	0
35822	1679	82082133980000	10327	5343	5	0	0
35824	1679	82802133980000	10437	5398	4	0	0
35826	1679	82802173980000	10437	5398	5	0	0
35834	1680	1449179500035	10443	5403	4	0	6
35839	1680	2169179500035	10769	5559	4	0	6
35840	1680	2169219500035	10769	5559	5	0	6
35847	1680	2889219500035	11145	5728	4	0	6
35848	1680	2889259500035	11145	5728	5	0	6
35857	1680	3609270500035	11283	5796	3	0	6
35875	1680	4329270500035	12069	6212	1	0	6
35877	1680	4329271500035	12069	6212	2	0	6
35893	1680	5049271500035	12794	6596	2	0	6
35896	1680	5049282500035	12794	6596	3	0	6
35836	1680	1453073499559	20642	10388	4	0	12
35842	1680	2173073499559	20685	10403	3	0	12
35843	1680	2173085499559	20685	10403	4	0	12
35849	1680	2893085499559	20934	10526	9	0	12
35862	1680	3613188499559	21275	10684	4	0	12
35864	1680	3613201499559	21275	10684	5	0	12
35878	1680	4333201499559	21455	10764	3	0	12
35879	1680	4333213499559	21455	10764	4	0	12
35898	1680	5053213499559	21658	10850	4	0	12
35909	1680	5774552499549	21456	10578	43	0	\N
35912	1680	6489293500035	13169	6785	2	0	\N
35913	1680	6489293500035	13645	7014	3	0	\N
35915	1680	6489304500035	13169	6785	3	0	\N
35916	1680	6489305500035	13645	7014	4	0	\N
35918	1680	6493247499559	22346	11186	4	0	\N
35919	1680	6493247499559	22398	11214	6	0	\N
35921	1680	6493260499559	22346	11186	5	0	\N
35923	1680	6493271499559	22398	11214	7	0	\N
35924	1680	7199150000000	1440	784	1	0	\N
35926	1680	7199160000000	1440	784	2	0	\N
35930	1680	7209380500035	14854	7571	3	0	\N
35931	1680	7209380500035	14857	7571	3	0	\N
35933	1680	7213260499559	22667	11332	4	0	\N
35935	1680	7213273499559	22667	11332	5	0	\N
35937	1680	7213313499559	23183	11574	4	0	\N
35938	1680	7214153499559	23184	11405	88	0	\N
35941	1680	7929380500035	14854	7571	9	0	\N
35942	1680	7929380500035	14857	7571	9	0	\N
35945	1680	7929394500035	14857	7571	10	0	\N
35948	1680	7933313499559	23183	11574	13	0	\N
35949	1680	7933330499559	23183	11574	14	0	\N
35950	1680	7934153499559	23184	11405	126	0	\N
35951	1680	7934523499559	23184	11405	127	0	\N
35952	1680	7935493499559	23302	11406	88	0	\N
35954	1680	8639200000000	1739	933	1	0	\N
35955	1680	8639210000000	1739	933	2	0	\N
35958	1680	8653284499559	23350	11652	4	0	\N
35961	1680	8653306499559	23350	11652	5	0	\N
35962	1680	8655493499559	23302	11406	126	0	\N
35963	1680	8655863499559	23302	11406	127	0	\N
35964	1680	8656743499559	23353	11407	88	0	\N
35968	1680	9369404500035	15380	7652	2	0	\N
35970	1680	9369505500035	15380	7652	3	0	\N
35971	1680	9373296499559	23540	11734	3	0	\N
35972	1680	9373296499559	23575	11748	4	0	\N
35974	1680	9373308499559	23540	11734	4	0	\N
35976	1680	9373309499559	23575	11748	5	0	\N
35977	1680	9376743499559	23353	11407	103	0	\N
35982	1680	10089505500035	15395	7653	1	0	\N
35983	1680	10089506500035	15395	7653	2	0	\N
35984	1680	10093308499559	24187	11936	34	0	\N
35985	1680	10093308499559	24188	12041	0	0	\N
35988	1680	10093468499559	24187	11936	35	0	\N
35991	1680	10809449500035	15412	7851	4	0	\N
35992	1680	10809449500035	16012	8142	4	0	\N
35993	1680	10809449500035	16058	8167	7	0	\N
35994	1680	10809449500035	16080	8174	3	0	\N
35995	1680	10809449500035	16356	8319	4	0	\N
35997	1680	10809461500035	16080	8174	4	0	\N
35998	1680	10809462500035	16012	8142	5	0	\N
35999	1680	10809462500035	16356	8319	5	0	\N
36000	1680	10809474500035	16058	8167	8	0	\N
36001	1680	10809480500035	15412	7851	5	0	\N
36002	1680	10809506500035	15414	7654	2	0	\N
36003	1680	10809526500035	15414	7654	3	0	\N
36007	1680	11519230000000	2922	1522	2	0	\N
36008	1680	11519230000000	3072	1598	1	0	\N
36010	1680	11519230000000	3398	1764	4	0	\N
36011	1680	11519240000000	3072	1598	2	0	\N
36013	1680	11519250000000	2922	1522	3	0	\N
36014	1680	11519270000000	3398	1764	5	0	\N
36017	1680	11533322499559	25437	12529	0	0	\N
36018	1680	11533322499559	25438	12604	3	0	\N
36019	1680	11533322499559	25737	12734	5	0	\N
36021	1680	11533334499559	25438	12604	4	0	\N
36023	1680	11533336499559	25737	12734	6	0	\N
36024	1680	12239240000000	3410	1773	2	0	\N
36026	1680	12239260000000	3410	1773	3	0	\N
36027	1680	12249573500035	16390	8338	4	0	\N
36028	1680	12249573500035	16796	8525	11	0	\N
36029	1680	12249573500035	16804	8529	3	0	\N
36032	1680	12249585500035	16804	8529	4	0	\N
36033	1680	12249586500035	16390	8338	5	0	\N
36034	1680	12249737500035	16796	8525	12	0	\N
36035	1680	12253334499559	26380	13048	3	0	\N
36037	1680	12253346499559	26380	13048	4	0	\N
35925	1680	7199150000000	1643	885	1	0	0
35927	1680	7199160000000	1643	885	2	0	0
35939	1680	7919160000000	1673	899	4	0	0
35940	1680	7919200000000	1673	899	5	0	0
35953	1680	8639200000000	1738	933	0	0	0
35966	1680	9359210000000	2468	1293	2	0	0
35978	1680	10079210000000	2556	1346	1	0	0
35979	1680	10079220000000	2556	1346	2	0	0
35989	1680	10799220000000	2781	1455	1	0	0
35990	1680	10799230000000	2781	1455	2	0	0
36012	1680	11519240000000	3396	1767	2	0	0
36025	1680	12239240000000	3412	1773	0	0	0
36039	1680	12959240000000	3984	2069	2	0	0
36040	1680	12959260000000	3984	2069	3	0	0
35906	1680	5769293500035	12955	6680	3	0	6
35914	1680	6489293500035	14260	7281	4	0	6
35917	1680	6489306500035	14260	7281	5	0	6
35928	1680	7209306500035	14838	7563	8	0	6
35929	1680	7209350500035	14838	7563	9	0	6
35943	1680	7929380500035	14861	7571	6	0	6
35944	1680	7929391500035	14861	7571	7	0	6
35956	1680	8649391500035	14878	7579	4	0	6
35957	1680	8649404500035	14878	7579	5	0	6
35967	1680	9369404500035	15379	7834	7	0	6
35980	1680	10089438500035	15392	7840	2	0	6
35981	1680	10089449500035	15392	7840	3	0	6
35996	1680	10809449500035	16364	8323	4	0	6
36004	1680	10809561500035	16364	8323	5	0	6
36016	1680	11529573500035	16386	8335	4	0	6
36030	1680	12249573500035	16837	8544	2	0	6
36031	1680	12249584500035	16837	8544	3	0	6
35907	1680	5773235499559	22254	11137	3	0	12
35908	1680	5773247499559	22254	11137	4	0	12
35922	1680	6493260499559	22624	11316	5	0	12
35934	1680	7213260499559	22786	11396	4	0	12
35936	1680	7213273499559	22786	11396	5	0	12
35946	1680	7933273499559	23301	11628	2	0	12
35947	1680	7933284499559	23301	11628	3	0	12
35960	1680	8653296499559	23456	11697	4	0	12
35973	1680	9373296499559	23774	11839	3	0	12
35975	1680	9373308499559	23774	11839	4	0	12
35986	1680	10093308499559	24190	12041	2	0	12
36005	1680	10813319499559	25115	12463	3	0	12
36006	1680	10813322499559	25115	12463	4	0	12
36020	1680	11533322499559	26363	13037	3	0	12
36022	1680	11533334499559	26363	13037	4	0	12
36036	1680	12253334499559	26550	13136	4	0	12
36041	1680	12969584500035	17213	8722	3	0	\N
36042	1680	12969584500035	17216	8722	1	0	\N
36043	1680	12969584500035	17250	8738	3	0	\N
36045	1680	12969585500035	17216	8722	2	0	\N
36046	1680	12969596500035	17213	8722	4	0	\N
36047	1680	12969596500035	17250	8738	4	0	\N
36049	1680	12973347499559	26628	13173	7	0	\N
36052	1680	12973372499559	26628	13173	8	0	\N
36053	1680	13679260000000	4078	2120	2	0	\N
36056	1680	13679280000000	4078	2120	3	0	\N
36061	1680	14399270000000	4385	2274	2	0	\N
36064	1680	14399290000000	4385	2274	3	0	\N
36067	1680	14409630500035	18686	9414	1	0	\N
36068	1680	14413377499559	26916	13312	3	0	\N
36070	1680	14413377499559	27208	13280	0	0	\N
36071	1680	14413389499559	26916	13312	4	0	\N
36075	1680	15129630500035	18686	9414	3	0	\N
36076	1680	15129631500035	18686	9414	4	0	\N
36077	1680	15133389499559	27210	13458	3	0	\N
36079	1680	15133401499559	27210	13458	4	0	\N
36081	1680	15839280000000	5750	2981	1	0	\N
36083	1680	15839290000000	5750	2981	2	0	\N
36085	1680	15849620500035	18852	9505	1	0	\N
36087	1680	15849630500035	18852	9505	2	0	\N
36095	1680	16573414499559	28168	13925	0	0	\N
36098	1680	17279300000000	6061	3148	2	0	\N
36099	1680	17279300000000	6314	3269	3	0	\N
36101	1680	17279320000000	6061	3148	3	0	\N
36102	1680	17279330000000	6314	3269	4	0	\N
36104	1680	17289703500035	19599	9871	3	0	\N
36105	1680	17289703500035	19685	9914	10	0	\N
36106	1680	17289703500035	19688	9914	9	0	\N
36107	1680	17289703500035	19690	9914	7	0	\N
36108	1680	17289703500035	19721	9930	3	0	\N
36109	1680	17289703500035	19725	9930	2	0	\N
36110	1680	17289703500035	19978	10060	9	0	\N
36112	1680	17289714500035	19725	9930	3	0	\N
36113	1680	17289715500035	19599	9871	4	0	\N
36114	1680	17289715500035	19721	9930	4	0	\N
36116	1680	17289739500035	19978	10060	10	0	\N
36117	1680	17289764500035	19690	9914	8	0	\N
36118	1680	17289775500035	19688	9914	10	0	\N
36119	1680	17289785500035	19685	9914	11	0	\N
36120	1680	17293425499559	28210	13947	3	0	\N
36121	1680	17293425499559	28266	13974	2	0	\N
36123	1680	17293436499559	28266	13974	3	0	\N
36124	1680	17293437499559	28210	13947	4	0	\N
36130	1680	18013438499559	28601	14124	3	0	\N
36131	1680	18013438499559	29013	14306	3	0	\N
36132	1680	18013438499559	29222	14401	2	0	\N
36134	1680	18013449499559	29222	14401	3	0	\N
36135	1680	18013450499559	28601	14124	4	0	\N
36136	1680	18013450499559	29013	14306	4	0	\N
36149	1680	20879420000000	7779	4033	1	0	\N
36150	1680	20879420000000	7780	4027	0	0	\N
36152	1680	20879430000000	7779	4033	2	0	\N
36154	1680	20892518499559	30055	14797	20	0	\N
36155	1680	20892518499559	30128	14827	6	0	\N
36156	1680	20892518499559	30129	14827	9	0	\N
36157	1680	20892518499559	30130	14827	11	0	\N
36158	1680	20892518499559	30202	14856	21	0	\N
36159	1680	20892533499559	30128	14827	7	0	\N
36160	1680	20892536499559	30129	14827	10	0	\N
36161	1680	20892538499559	30130	14827	12	0	\N
36162	1680	20892556499559	30055	14797	21	0	\N
36163	1680	20892581499559	30202	14856	22	0	\N
36170	1680	23759460000000	8157	4228	1	0	\N
36171	1680	23759460000000	8308	4300	3	0	\N
36173	1680	23759470000000	8157	4228	2	0	\N
36175	1680	23759560000000	8310	4229	9	0	\N
36176	1680	23759571000000	8308	4300	4	0	\N
36062	1680	14399270000000	4509	2333	1	0	0
36063	1680	14399280000000	4509	2333	2	0	0
36073	1680	15119280000000	5405	2814	0	0	0
36082	1680	15839280000000	5830	3025	1	0	0
36084	1680	15839290000000	5830	3025	2	0	0
36092	1680	16559300000000	5902	3060	2	0	0
36100	1680	17279300000000	6970	3597	9	0	0
36103	1680	17279390000000	6970	3597	10	0	0
36126	1680	17999390000000	7251	3749	1	0	0
36127	1680	17999400000000	7251	3749	2	0	0
36139	1680	18719410000000	7439	3845	2	0	0
36142	1680	19439410000000	7650	3959	0	0	0
36145	1680	20159410000000	7730	4005	1	0	0
36146	1680	20159420000000	7730	4005	2	0	0
36153	1680	20879430000000	7911	4099	2	0	0
36164	1680	21599430000000	8018	4156	1	0	0
36165	1680	21599440000000	8018	4156	2	0	0
36166	1680	22319440000000	8040	4167	1	0	0
36167	1680	22319450000000	8040	4167	2	0	0
36169	1680	23039460000000	8120	4210	2	0	0
36172	1680	23759460000000	8346	4323	1	0	0
36174	1680	23759470000000	8346	4323	2	0	0
36044	1680	12969584500035	17636	8917	3	0	6
36048	1680	12969596500035	17636	8917	4	0	6
36058	1680	13689608500035	18043	9102	4	0	6
36065	1680	14409608500035	18527	9332	3	0	6
36066	1680	14409620500035	18527	9332	4	0	6
36074	1680	15129620500035	18689	9414	0	0	6
36088	1680	15849641500035	18954	9561	4	0	6
36093	1680	16569641500035	19085	9627	8	0	6
36094	1680	16569703500035	19085	9627	9	0	6
36111	1680	17289703500035	19979	10060	9	0	6
36115	1680	17289739490035	19979	10060	10	0	6
36129	1680	18009751490035	20348	10249	4	0	6
36050	1680	12973347499559	26630	13174	4	0	12
36051	1680	12973365499559	26630	13174	5	0	12
36059	1680	13693365499559	26676	13194	3	0	12
36060	1680	13693377499559	26676	13194	4	0	12
36072	1680	14413389499559	26938	13324	4	0	12
36078	1680	15133389499559	27899	13794	3	0	12
36080	1680	15133401499559	27899	13794	4	0	12
36089	1680	15853401499559	28069	13879	4	0	12
36096	1680	16573414499559	28170	13927	2	0	12
36097	1680	16573425499559	28170	13927	3	0	12
36122	1680	17293425499559	28583	14116	4	0	12
36125	1680	17293438499559	28583	14116	5	0	12
36133	1680	18013438499559	29223	14401	3	0	12
36140	1680	18733450499559	29330	14454	5	0	12
36141	1680	18733464499559	29330	14454	6	0	12
36143	1680	19452463499559	29454	14524	2	0	13
36144	1680	19452474499559	29454	14524	3	0	13
36147	1680	20172474499559	29465	14530	8	0	13
36177	1680	24479470000000	8751	4542	1	0	\N
36179	1680	24479480000000	8751	4542	2	0	\N
36181	1680	24479560000000	8310	4229	105	0	\N
36182	1680	24480730000000	8310	4229	106	0	\N
36185	1680	25919510000000	9503	4929	3	0	\N
36186	1680	25919510000000	9585	4973	2	0	\N
36187	1680	25919510000000	9775	5065	2	0	\N
36189	1680	25919530000000	9585	4973	3	0	\N
36190	1680	25919530000000	9775	5065	3	0	\N
36192	1680	25919780000000	9503	4929	4	0	\N
36197	1681	1942968759830	10206	5285	2	0	\N
36198	1681	1942968759830	10326	5342	4	0	\N
36200	1681	1942988759830	10206	5285	3	0	\N
36202	1681	1943008759830	10326	5342	5	0	\N
36217	1681	4211034109853	20449	10298	3	0	\N
36219	1681	4211034109853	20647	10313	0	0	\N
36220	1681	4211046109853	20449	10298	4	0	\N
36227	1681	4931070109853	20650	10326	0	0	\N
36228	1681	4931070109853	20652	10339	0	0	\N
36230	1681	5039150000000	659	367	1	0	\N
36232	1681	5039160000000	659	367	2	0	\N
36244	1681	6371171109853	21865	10943	3	0	\N
36247	1681	6983114759830	11748	6038	1	0	\N
36249	1681	6983115759830	11748	6038	2	0	\N
36253	1681	7091171109853	21865	10943	4	0	\N
36254	1681	7199200000000	1509	826	1	0	\N
36256	1681	7199210000000	1509	826	2	0	\N
36258	1681	7703115759830	12454	6410	0	0	\N
36262	1681	7811160109853	22326	11174	7	0	\N
36264	1681	7811185109853	22326	11174	8	0	\N
36269	1681	8531175909853	22385	11208	3	0	\N
36271	1681	8531187909853	22385	11208	4	0	\N
36273	1681	8639250000000	1958	1037	1	0	\N
36274	1681	8639250000000	2054	1085	1	0	\N
36275	1681	8639250000000	2111	1112	1	0	\N
36276	1681	8639250000000	2140	1128	1	0	\N
36279	1681	8639260000000	1958	1037	2	0	\N
36280	1681	8639260000000	2054	1085	2	0	\N
36281	1681	8639260000000	2111	1112	2	0	\N
36282	1681	8639260000000	2140	1128	2	0	\N
36289	1681	9863184759830	13880	7122	2	0	\N
36292	1681	9863204759830	13880	7122	3	0	\N
36304	1681	11303205759830	15312	7801	2	0	\N
36305	1681	11303205759830	16273	8271	8	0	\N
36307	1681	11303216759830	15312	7801	3	0	\N
36309	1681	11303231759830	16273	8271	9	0	\N
36195	1681	1439070000000	163	97	2	0	0
36196	1681	1439090000000	163	97	3	0	0
36203	1681	2159090000000	183	109	1	0	0
36204	1681	2159100000000	183	109	2	0	0
36207	1681	2879100000000	220	130	1	0	0
36212	1681	3599110000000	365	208	1	0	0
36213	1681	3599120000000	365	208	2	0	0
36214	1681	3599130000000	654	365	2	0	1
36222	1681	4319130000000	654	365	5	0	1
36223	1681	4319150000000	654	365	6	0	1
36233	1681	5039170000000	809	448	3	0	1
36238	1681	5759170000000	1037	576	1	0	1
36239	1681	5759180000000	1037	576	2	0	1
36245	1681	6479180000000	1114	614	2	0	1
36255	1681	7199200000000	1613	872	4	0	1
36257	1681	7199240000000	1613	872	5	0	1
36265	1681	7919240000000	1913	1019	1	0	1
36266	1681	7919250000000	1913	1019	2	0	1
36277	1681	8639250000000	2604	1370	2	0	1
36287	1681	9359253195920	2640	1388	1	0	1
36288	1681	9359263195920	2640	1388	2	0	1
36295	1681	10079263195920	2651	1395	2	0	1
36296	1681	10079283195920	2651	1395	3	0	1
36302	1681	10799283195920	2662	1399	2	0	1
36311	1681	11519303195920	2844	1489	1	0	1
36312	1681	11519313195920	2844	1489	2	0	1
36178	1680	24479470000000	8754	4542	2	0	0
36180	1680	24479490000000	8754	4542	3	0	0
36184	1680	25199510000000	8942	4638	3	0	0
36188	1680	25919510000000	9834	5097	13	0	0
36191	1680	25919640000000	9834	5097	14	0	0
36199	1681	1942968759830	10426	5393	2	0	6
36201	1681	1942988759830	10426	5393	3	0	6
36206	1681	2663008759830	10634	5492	3	0	6
36209	1681	3383008759830	10867	5608	3	0	6
36210	1681	3383038759830	10867	5608	4	0	6
36211	1681	3383048759830	11282	5795	1	0	6
36215	1681	4103048759830	11282	5795	5	0	6
36224	1681	4823069759830	11399	5854	2	0	6
36225	1681	4823080759830	11399	5854	3	0	6
36234	1681	5543080759830	11416	5864	2	0	6
36235	1681	5543091759830	11416	5864	3	0	6
36241	1681	6263114759830	11495	5905	6	0	6
36248	1681	6983114759830	11807	6067	1	0	6
36250	1681	6983115759830	11807	6067	2	0	6
36259	1681	7703115759830	12621	6513	6	0	6
36260	1681	7703148759830	12621	6513	7	0	6
36268	1681	8423171759830	13030	6717	6	0	6
36283	1681	9143171759830	13066	6735	4	0	6
36284	1681	9143184759830	13066	6735	5	0	6
36290	1681	9863184759830	15025	7656	1	0	6
36291	1681	9863194759830	15025	7656	2	0	6
36298	1681	10583205759830	15118	7706	3	0	6
36306	1681	11303205759830	16314	8289	4	0	6
36308	1681	11303218759830	16314	8289	5	0	6
36218	1681	4211034109853	20492	10318	9	0	11
36226	1681	4931070109853	20648	10390	4	0	11
36229	1681	4931083109853	20648	10390	5	0	11
36236	1681	5651083109853	21119	10607	4	0	11
36237	1681	5651105109853	21119	10607	5	0	11
36242	1681	6371105109853	21274	10683	27	0	11
36251	1681	7091159109853	21866	10943	1	0	11
36252	1681	7091160109853	21866	10943	2	0	11
36261	1681	7811160109853	22323	11174	5	0	11
36263	1681	7811175909853	22323	11174	6	1	11
36270	1681	8531175909853	22488	11252	9	0	11
36285	1681	9251247909853	22703	11350	6	0	11
36286	1681	9251262909853	22703	11350	7	0	11
36293	1681	9971262909853	23289	11620	2	0	11
36294	1681	9971273909853	23289	11620	3	0	11
36300	1681	10691317909853	23404	11677	9	0	11
36301	1681	10691329909853	23933	11911	3	0	11
36310	1681	11411329909853	23933	11911	4	0	11
36313	1681	12023218759830	16418	8350	3	0	\N
36316	1681	12023230759830	16418	8350	4	0	\N
36318	1681	12131329909853	24535	12193	20	0	\N
36320	1681	12131430909853	24535	12193	21	0	\N
36325	1681	12743262759830	18424	9288	1	0	\N
36330	1681	13463252759830	18064	9110	1	0	\N
36331	1681	13463262759830	18064	9110	2	0	\N
36333	1681	13463262759830	18424	9288	4	0	\N
36335	1681	13463264759830	18424	9288	5	0	\N
36338	1681	13679315195920	3935	2041	1	0	\N
36340	1681	13679325195920	3935	2041	2	0	\N
36342	1681	14183264759830	18827	9488	1	0	\N
36343	1681	14183264759830	19126	9648	2	0	\N
36345	1681	14183274759830	18827	9488	2	0	\N
36346	1681	14183275759830	19126	9648	3	0	\N
36350	1681	14399325195920	4162	2165	1	0	\N
36352	1681	14399335195920	4162	2165	2	0	\N
36354	1681	14903289759830	19304	9734	20	0	\N
36356	1681	14903395759830	19304	9734	21	0	\N
36372	1681	17063431759830	20055	10043	28	0	\N
36373	1681	17063431759830	20057	10052	28	0	\N
36375	1681	17063711759830	20055	10043	29	0	\N
36376	1681	17063711759830	20057	10052	29	0	\N
36379	1681	17279365195920	5515	2869	0	0	\N
36383	1681	17854792358535	27170	13435	5	0	\N
36385	1681	17854815358535	27170	13435	6	0	\N
36387	1681	17999365195920	5669	2939	0	0	\N
36391	1681	18503455759830	20317	10232	4	0	\N
36393	1681	18503468759830	20317	10232	5	0	\N
36394	1681	18503504759830	20319	10233	11	0	\N
36395	1681	18574825358535	28258	13971	2	0	\N
36396	1681	18574825358535	29032	14317	3	0	\N
36397	1681	18574825358535	29298	14438	5	0	\N
36399	1681	18574836358535	28258	13971	3	0	\N
36400	1681	18574837358535	29032	14317	4	0	\N
36402	1681	18574848358535	29298	14438	6	0	\N
36407	1681	19223504759830	20319	10233	13	0	\N
36408	1681	19223505759830	20319	10233	14	0	\N
36409	1681	19439385195920	6062	3148	2	0	\N
36412	1681	19439405195920	6062	3148	3	0	\N
36413	1681	20159395195920	6127	3178	1	0	\N
36415	1681	20159405195920	6127	3178	2	0	\N
36421	1681	22319495195920	7728	4004	0	0	\N
36426	1681	23759515195920	8506	4406	1	0	\N
36428	1681	23759525195920	8506	4406	2	0	\N
36432	1681	24479566195920	9723	4882	46	0	\N
36433	1681	25199565195920	9285	4814	1	0	\N
36434	1681	25199575195920	9285	4814	2	0	\N
36435	1682	719000000000	6	6	1	0	\N
36436	1682	719000000000	13	9	0	0	\N
36437	1682	719000000000	28	17	2	0	\N
36439	1682	719010000000	6	6	2	0	\N
36441	1682	719020000000	28	17	3	0	\N
36446	1682	2867100000000	1216	670	1	0	\N
36447	1682	2867100000000	1343	739	1	0	\N
36442	1682	1430010000000	312	180	2	0	1
36443	1682	1430120000000	312	180	3	0	1
36444	1682	2147090000000	482	270	1	0	4
36445	1682	2147100000000	482	270	2	0	4
36448	1682	2867100000000	1617	874	1	0	4
36328	1681	12959313195920	3632	1882	2	0	1
36329	1681	12959315195920	3632	1882	3	0	1
36339	1681	13679315195920	3988	2071	1	0	1
36341	1681	13679325195920	3988	2071	2	0	1
36351	1681	14399325195920	4236	2200	1	0	1
36358	1681	15119335195920	5186	2695	1	0	1
36359	1681	15119345195920	5186	2695	2	0	1
36364	1681	15839345195920	5190	2698	2	0	1
36365	1681	15839365195920	5190	2698	3	0	1
36380	1681	17279365195920	5613	2915	0	0	1
36388	1681	17999365195920	5814	3017	1	0	1
36389	1681	17999375195920	5814	3017	2	0	1
36403	1681	18719375195920	5914	3066	1	0	1
36404	1681	18719385195920	5914	3066	2	0	1
36411	1681	19439395195920	6101	3166	2	0	1
36414	1681	20159395195920	6450	3339	2	0	1
36416	1681	20159415195920	6450	3339	3	0	1
36417	1681	20879415195920	6639	3431	4	0	1
36418	1681	20879455195920	6639	3431	5	0	1
36420	1681	21599495195920	7112	3672	5	0	1
36422	1681	22319495195920	7972	4130	1	0	1
36423	1681	22319505195920	7972	4130	2	0	1
36424	1681	23039505195920	8107	4202	1	0	1
36427	1681	23759515195920	8665	4486	2	0	1
36429	1681	23759535195920	8665	4486	3	0	1
36430	1681	24479535195920	9245	4794	3	0	1
36431	1681	24479565195920	9245	4794	4	0	1
36314	1681	12023218759830	16979	8601	1	0	6
36322	1681	12743228759830	17229	8729	6	0	6
36323	1681	12743252759830	17229	8729	7	0	6
36324	1681	12743262759830	18423	9288	1	0	6
36332	1681	13463262759830	18423	9288	4	0	6
36334	1681	13463264759830	18423	9288	5	0	6
36347	1681	14183289759830	19249	9705	8	0	6
36355	1681	14903289759830	19305	9734	20	0	6
36357	1681	14903395759830	19305	9734	21	0	6
36360	1681	15623395759830	19307	9735	7	0	6
36366	1681	16343420759830	19812	9978	2	0	6
36367	1681	16343431759830	19812	9978	3	0	6
36371	1681	17063431759830	19996	10068	3	0	6
36374	1681	17063443759830	19996	10068	4	0	6
36381	1681	17783443759830	20056	10097	3	0	6
36390	1681	18503455759830	20316	10232	2	0	6
36392	1681	18503457759830	20316	10232	3	0	6
36405	1681	19223457759830	20318	10233	8	0	6
36406	1681	19223501759830	20318	10233	9	0	6
36317	1681	12131329909853	24534	12198	4	0	11
36326	1681	12851351909853	25190	12496	6	0	11
36327	1681	12851366909853	25190	12496	7	0	11
36336	1681	13571366909853	25195	12498	4	0	11
36337	1681	13571478909853	25195	12498	5	0	11
36349	1681	14291490909853	26146	12925	4	0	11
36362	1681	15694751358535	26304	13012	2	0	11
36363	1681	15694762358535	26304	13012	3	0	11
36368	1681	16414762358535	26643	13180	4	0	11
36369	1681	16414780358535	26643	13180	5	0	11
36378	1681	17134792358535	26988	13348	4	0	11
36384	1681	17854792358535	27701	13687	6	0	11
36386	1681	17854825358535	27701	13687	7	0	11
36398	1681	18574825358535	30091	14814	9	0	11
36401	1681	18574843358535	30091	14814	10	0	11
36449	1682	2867110000000	1216	670	2	0	\N
36450	1682	2867110000000	1343	739	2	0	\N
36454	1682	4307130000000	1883	1002	1	0	\N
36455	1682	4307130000000	1908	1016	1	0	\N
36457	1682	4307140000000	1883	1002	2	0	\N
36458	1682	4307140000000	1908	1016	2	0	\N
36462	1682	5747170000000	2314	1211	1	0	\N
36463	1682	5747170000000	2599	1369	0	0	\N
36465	1682	5747180000000	2314	1211	2	0	\N
36471	1682	7907291000000	3636	1885	3	0	\N
36472	1682	7907291000000	3830	1988	2	0	\N
36474	1682	7907303000000	3636	1885	4	0	\N
36476	1682	7907401000000	3830	1988	3	0	\N
36477	1682	7907821000000	4561	2356	5	0	\N
36478	1682	8627318577778	4556	2357	0	0	\N
36479	1682	8627321000000	4174	2172	1	0	\N
36480	1682	8627321000000	4554	2357	0	0	\N
36482	1682	8627331000000	4174	2172	2	0	\N
36484	1682	8627821000000	4561	2356	15	0	\N
36485	1682	8628451000000	4561	2356	16	0	\N
36486	1682	9347461000000	4611	2388	1	0	\N
36487	1682	9347461000000	5603	2911	0	0	\N
36488	1682	9347471000000	4611	2388	2	0	\N
36491	1683	2879010000000	10	7	1	0	\N
36493	1683	2879020000000	10	7	2	0	\N
36498	1683	7199040000000	33	20	1	0	\N
36499	1683	7199040000000	42	26	1	0	\N
36500	1683	7199040000000	46	27	1	0	\N
36502	1683	7199050000000	33	20	2	0	\N
36503	1683	7199050000000	42	26	2	0	\N
36504	1683	7199050000000	46	27	2	0	\N
36508	1683	10079060000000	60	35	1	0	\N
36510	1683	10079070000000	60	35	2	0	\N
36514	1683	12959100000000	108	66	2	0	\N
36517	1683	12959120000000	108	66	3	0	\N
36526	1683	18719170000000	185	111	1	0	\N
36527	1683	20159160000000	175	104	1	0	\N
36528	1683	20159160000000	200	118	1	0	\N
36530	1683	20159170000000	175	104	2	0	\N
36531	1683	20159170000000	185	111	4	0	\N
36532	1683	20159170000000	200	118	2	0	\N
36534	1683	20159190000000	185	111	5	0	\N
36537	1683	23039200000000	244	144	1	0	\N
36539	1683	23039210000000	244	144	2	0	\N
36543	1683	25919230000000	262	153	1	0	\N
36544	1683	25919230000000	273	159	1	0	\N
36546	1683	25919240000000	262	153	2	0	\N
36547	1683	25919240000000	273	159	2	0	\N
36549	1683	27359240000000	285	164	1	0	\N
36551	1683	27359250000000	285	164	2	0	\N
36559	1683	33119291000000	324	187	2	0	\N
36560	1683	33119291000000	336	193	2	0	\N
36563	1683	33119311000000	324	187	3	0	\N
36564	1683	33119311000000	336	193	3	0	\N
36565	1683	34559301000000	344	197	3	0	\N
36568	1683	34559322000000	344	197	4	0	\N
36573	1683	38879351000000	366	209	2	0	\N
36576	1683	38879371000000	366	209	3	0	\N
36579	1683	41759381000000	405	230	2	0	\N
36582	1683	41759401000000	405	230	3	0	\N
36584	1683	43199391000000	415	237	2	0	\N
36492	1683	2879010000000	16	10	0	0	0
36494	1683	4319010000000	22	13	2	0	0
36495	1683	4319030000000	22	13	3	0	0
36496	1683	5759030000000	32	19	1	0	0
36497	1683	5759040000000	32	19	2	0	0
36505	1683	7199050000000	52	30	2	0	0
36506	1683	8639050000000	59	34	1	0	0
36507	1683	8639060000000	59	34	2	0	0
36509	1683	10079060000000	67	38	2	0	0
36511	1683	10079080000000	67	38	3	0	0
36513	1683	11519100000000	90	57	3	0	0
36515	1683	12959100000000	119	71	1	0	0
36516	1683	12959110000000	119	71	2	0	0
36518	1683	14399110000000	131	77	2	0	0
36520	1683	15839130000000	148	88	1	0	0
36521	1683	15839140000000	148	88	2	0	0
36522	1683	17279140000000	155	92	1	0	0
36523	1683	17279150000000	155	92	2	0	0
36524	1683	18719150000000	164	98	1	0	0
36529	1683	20159160000000	236	140	2	0	0
36533	1683	20159180000000	236	140	3	0	0
36535	1683	21599180000000	237	141	2	0	0
36536	1683	21599200000000	237	141	3	0	0
36538	1683	23039200000000	249	146	2	0	0
36541	1683	24479220000000	256	150	1	0	0
36542	1683	24479230000000	256	150	2	0	0
36545	1683	25919230000000	282	163	1	0	0
36548	1683	25919240000000	282	163	2	0	0
36552	1683	27359250000000	288	165	2	0	0
36553	1683	28799250000000	305	176	2	0	0
36554	1683	28799261000000	305	176	3	0	0
36555	1683	30239261000000	313	181	2	0	0
36556	1683	30239281000000	313	181	3	0	0
36558	1683	31679291000000	320	184	2	0	0
36561	1683	33119291000000	339	194	1	0	0
36562	1683	33119301000000	339	194	2	0	0
36566	1683	34559301000000	348	199	1	0	0
36567	1683	34559311000000	348	199	2	0	0
36570	1683	35999331000000	359	205	3	0	0
36571	1683	37439331000000	362	207	2	0	0
36572	1683	37439351000000	362	207	3	0	0
36574	1683	38879351000000	372	212	1	0	0
36577	1683	40319361000000	388	221	2	0	0
36578	1683	40319381000000	388	221	3	0	0
36580	1683	41759381000000	411	234	1	0	0
36581	1683	41759391000000	411	234	2	0	0
36583	1683	41759401000000	450	254	1	0	0
36452	1682	3587110000000	1690	909	2	0	4
36453	1682	3587130000000	1690	909	3	0	4
36456	1682	4307130000000	1979	1046	3	0	4
36459	1682	4307160000000	1979	1046	4	0	4
36460	1682	5027160000000	2304	1208	1	0	4
36464	1682	5747170000000	2628	1382	1	0	4
36466	1682	5747180000000	2628	1382	2	0	4
36467	1682	6467180000000	3024	1571	1	0	4
36468	1682	6467190000000	3024	1571	2	0	4
36470	1682	7187291000000	3532	1833	3	0	4
36473	1682	7907291000000	4040	2098	3	0	4
36475	1682	7907321000000	4040	2098	4	0	4
36481	1682	8627321000000	4585	2372	5	0	4
36483	1682	8627461000000	4585	2372	6	0	4
36585	1683	43199391000000	441	249	3	0	\N
36587	1683	43199411000000	415	237	3	0	\N
36589	1683	43199421000000	441	249	4	0	\N
36590	1683	44639411000000	451	255	1	0	\N
36591	1683	44639411000000	474	265	3	0	\N
36592	1683	44639411000000	484	271	1	0	\N
36593	1683	44639411000000	494	274	1	0	\N
36595	1683	44639421000000	451	255	2	0	\N
36596	1683	44639421000000	484	271	2	0	\N
36597	1683	44639421000000	494	274	2	0	\N
36599	1683	44639441000000	474	265	4	0	\N
36608	1683	51839482000000	549	311	1	0	\N
36610	1683	51839492000000	549	311	2	0	\N
36614	1683	54719502000000	572	324	1	0	\N
36616	1683	54719512000000	572	324	2	0	\N
36622	1683	59039532000000	606	343	1	0	\N
36624	1683	59039542000000	606	343	2	0	\N
36628	1683	60912751149541	10451	5405	1	0	\N
36629	1683	61919552000000	636	356	1	0	\N
36630	1683	61919552000000	642	360	1	0	\N
36632	1683	61919562000000	636	356	2	0	\N
36633	1683	61919562000000	642	360	2	0	\N
36635	1683	62352741149541	10444	5403	3	0	\N
36636	1683	62352741149541	10462	5406	5	0	\N
36637	1683	62352741149541	10468	5409	9	0	\N
36639	1683	62352751149541	10451	5405	14	0	\N
36640	1683	62352771149541	10444	5403	4	0	\N
36641	1683	62352831149541	10468	5409	10	0	\N
36643	1683	62352871149541	10451	5405	15	0	\N
36644	1683	62352881149541	10462	5406	6	0	\N
36646	1683	63359572000000	663	369	1	0	\N
36648	1683	63359582000000	663	369	2	0	\N
36650	1683	63792861149541	10476	5415	5	0	\N
36651	1683	63792861149541	10489	5420	2	0	\N
36652	1683	63792881149541	10463	5407	5	0	\N
36653	1683	63792881149541	10489	5420	3	0	\N
36655	1683	63792902149541	10476	5415	6	0	\N
36657	1683	63792931149541	10463	5407	6	0	\N
36668	1683	68112942149541	10569	5457	2	0	\N
36670	1683	68112962149541	10569	5457	3	0	\N
36672	1683	69119672000000	689	385	1	0	\N
36674	1683	69119682000000	689	385	2	0	\N
36680	1683	70993032149541	10581	5465	2	0	\N
36682	1683	70993052149541	10581	5465	3	0	\N
36690	1683	73873092149541	10596	5472	4	0	\N
36692	1683	73873132149541	10596	5472	5	0	\N
36694	1683	74879762000000	745	418	1	0	\N
36696	1683	74879772000000	745	418	2	0	\N
36704	1683	77759892000000	823	455	2	0	\N
36707	1683	77759912000000	823	455	3	0	\N
36708	1683	78193195149541	10646	5499	2	0	\N
36710	1683	78193215149541	10646	5499	3	0	\N
36713	1683	79633195149541	10677	5511	2	0	\N
36715	1683	79633215149541	10677	5511	3	0	\N
36717	1683	80639912000000	841	464	1	0	\N
36719	1683	80639922000000	841	464	2	0	\N
36594	1683	44639411000000	524	295	1	0	0
36598	1683	44639421000000	524	295	2	0	0
36600	1683	46079421000000	537	305	2	0	0
36601	1683	46079432000000	537	305	3	0	0
36602	1683	47519432000000	541	307	1	0	0
36604	1683	48959442000000	547	309	3	0	0
36605	1683	48959472000000	547	309	4	0	0
36606	1683	50399472000000	548	310	1	0	0
36607	1683	50399482000000	548	310	2	0	0
36609	1683	51839482000000	558	315	1	0	0
36612	1683	53279492000000	566	320	1	0	0
36613	1683	53279502000000	566	320	2	0	0
36615	1683	54719502000000	588	332	1	0	0
36617	1683	54719512000000	588	332	2	0	0
36619	1683	56159522000000	590	334	2	0	0
36620	1683	57599522000000	595	337	1	0	0
36621	1683	57599532000000	595	337	2	0	0
36623	1683	59039532000000	623	350	1	0	0
36625	1683	59039542000000	623	350	2	0	0
36627	1683	60479552000000	633	355	2	0	0
36631	1683	61919552000000	647	363	2	0	0
36634	1683	61919572000000	647	363	3	0	0
36647	1683	63359572000000	669	372	2	0	0
36649	1683	63359592000000	669	372	3	0	0
36659	1683	64799652000000	670	373	7	0	0
36662	1683	66239652000000	677	378	1	0	0
36663	1683	66239662000000	677	378	2	0	0
36666	1683	67679662000000	684	382	1	0	0
36673	1683	69119672000000	704	392	2	0	0
36675	1683	69119692000000	704	392	3	0	0
36678	1683	70559692000000	717	400	3	0	0
36679	1683	70559722000000	717	400	4	0	0
36684	1683	71999722000000	718	401	3	0	0
36688	1683	73439752000000	729	408	1	0	0
36689	1683	73439762000000	729	408	2	0	0
36695	1683	74879762000000	766	426	3	0	0
36697	1683	74879882000000	766	426	4	0	0
36700	1683	76319882000000	796	441	1	0	0
36705	1683	77759892000000	827	456	1	0	0
36706	1683	77759902000000	827	456	2	0	0
36711	1683	79199902000000	829	457	1	0	0
36712	1683	79199912000000	829	457	2	0	0
36720	1683	80639922000000	848	469	2	0	0
36638	1683	62352741149541	10473	5413	3	0	1
36642	1683	62352861149541	10473	5413	4	0	1
36645	1683	62352901149541	10533	5439	4	0	1
36654	1683	63792901149541	10533	5439	6	0	1
36660	1683	65232902149541	10536	5441	2	0	1
36661	1683	65232922149541	10536	5441	3	0	1
36664	1683	66672922149541	10561	5454	2	0	1
36665	1683	66672942149541	10561	5454	3	0	1
36669	1683	68112942149541	10575	5461	3	0	1
36676	1683	69552972149541	10578	5463	6	0	1
36677	1683	69553032149541	10578	5463	7	0	1
36681	1683	70993032149541	10591	5470	4	0	1
36683	1683	70993072149541	10591	5470	5	0	1
36687	1683	72433092149541	10594	5471	3	0	1
36691	1683	73873092149541	10622	5486	6	0	1
36693	1683	73873152149541	10622	5486	7	0	1
36698	1683	75313152149541	10632	5491	3	0	1
36699	1683	75313173149541	10632	5491	4	0	1
36703	1683	76753195149541	10640	5496	4	0	1
36709	1683	78193195149541	10654	5502	0	0	1
36714	1683	79633195149541	10680	5513	2	0	1
36716	1683	79633215149541	10680	5513	3	0	1
36723	1683	82079922000000	871	483	1	0	\N
36725	1683	82079932000000	871	483	2	0	\N
36735	1683	85393307149541	10727	5535	9	0	\N
36736	1683	85393307149541	10735	5540	2	0	\N
36738	1683	85393327149541	10735	5540	3	0	\N
36740	1683	85393390149541	10727	5535	10	0	\N
36745	1683	87839972000000	904	502	3	0	\N
36748	1683	87840092000000	904	502	4	0	\N
36749	1683	88273387149541	10766	5557	4	0	\N
36750	1683	88273387149541	10780	5564	3	0	\N
36752	1683	88273417149541	10780	5564	4	0	\N
36754	1683	88273427149541	10766	5557	5	0	\N
36755	1683	89279982000000	934	520	1	0	\N
36756	1683	89279982000000	940	523	1	0	\N
36758	1683	89279992000000	934	520	2	0	\N
36759	1683	89279992000000	940	523	2	0	\N
36767	1683	92160012000000	971	540	1	0	\N
36769	1683	92160022000000	971	540	2	0	\N
36771	1683	92593497149541	10832	5587	4	0	\N
36774	1683	92593537149541	10832	5587	5	0	\N
36775	1683	93600022000000	986	546	1	0	\N
36776	1683	93600022000000	990	547	1	0	\N
36778	1683	93600032000000	986	546	2	0	\N
36779	1683	93600032000000	990	547	2	0	\N
36785	1683	95473537149541	10877	5611	5	0	\N
36788	1683	95473587149541	10877	5611	6	0	\N
36790	1683	96480032000000	1041	579	1	0	\N
36791	1683	96480042000000	1041	579	2	0	\N
36792	1683	96913567149541	10898	5618	7	0	\N
36795	1683	96913637149541	10898	5618	8	0	\N
36800	1683	99360047999541	1066	591	1	0	\N
36802	1683	99360057999541	1066	591	2	0	\N
36816	1683	104113787149541	10918	5631	2	0	\N
36818	1683	104113807149541	10918	5631	3	0	\N
36822	1683	105553828149541	10935	5636	4	0	\N
36825	1683	105553868149541	10935	5636	5	0	\N
36826	1683	106560117999541	1152	635	3	0	\N
36829	1683	106560147999541	1152	635	4	0	\N
36830	1683	106993838149541	10965	5650	2	0	\N
36831	1683	106993838149541	11006	5667	3	0	\N
36832	1683	106993838149541	11016	5669	13	0	\N
36833	1683	106993838149541	11038	5682	2	0	\N
36835	1683	106993858149541	10965	5650	3	0	\N
36836	1683	106993858149541	11038	5682	3	0	\N
36837	1683	106993868149541	11006	5667	4	0	\N
36839	1683	106994418149541	11016	5669	14	0	\N
36840	1683	108000137999541	1182	653	1	0	\N
36842	1683	108000147999541	1182	653	2	0	\N
36844	1683	108433878149541	11075	5698	2	0	\N
36846	1683	108433898149541	11075	5698	3	0	\N
36848	1683	108434418149541	11017	5670	2	0	\N
36849	1683	108434438149541	11017	5670	3	0	\N
36854	1683	109874438149541	11021	5671	4	0	\N
36855	1683	109874478149541	11021	5671	5	0	\N
36856	1683	110880157999541	1203	664	1	0	\N
36729	1683	83519942000000	897	499	1	0	0
36730	1683	83519952000000	897	499	2	0	0
36733	1683	84959952000000	898	500	1	0	0
36734	1683	84959962000000	898	500	2	0	0
36741	1683	86399962000000	900	501	1	0	0
36746	1683	87839972000000	907	504	1	0	0
36747	1683	87839982000000	907	504	2	0	0
36757	1683	89279982000000	945	526	1	0	0
36760	1683	89279992000000	945	526	2	0	0
36763	1683	90719992000000	946	527	2	0	0
36768	1683	92160012000000	973	541	1	0	0
36770	1683	92160022000000	973	541	2	0	0
36777	1683	93600022000000	1005	556	0	0	0
36782	1683	95040022000000	1035	575	1	0	0
36784	1683	95040052000000	1050	583	2	0	0
36789	1683	96480027999541	1050	583	3	0	0
36796	1683	97920027999541	1064	589	2	0	0
36797	1683	97920047999541	1064	589	3	0	0
36801	1683	99360047999541	1073	594	2	0	0
36806	1683	100800067999541	1106	612	1	0	0
36807	1683	100800077999541	1106	612	2	0	0
36810	1683	102240077999541	1109	613	1	0	0
36811	1683	102240087999541	1109	613	2	0	0
36814	1683	103680087999541	1122	618	2	0	0
36820	1683	105120107999541	1130	623	1	0	0
36821	1683	105120117999541	1130	623	2	0	0
36827	1683	106560117999541	1161	640	2	0	0
36828	1683	106560137999541	1161	640	3	0	0
36843	1683	108000147999541	1195	659	2	0	0
36850	1683	109440147999541	1202	663	1	0	0
36851	1683	109440157999541	1202	663	2	0	0
36721	1683	81073215149541	10695	5522	5	0	1
36722	1683	81073257149541	10695	5522	6	0	1
36728	1683	82513287149541	10696	5523	4	0	1
36731	1683	83953287149541	10708	5528	2	0	1
36732	1683	83953307149541	10708	5528	3	0	1
36737	1683	85393307149541	10736	5541	4	0	1
36739	1683	85393347149541	10736	5541	5	0	1
36744	1683	86833387149541	10737	5542	5	0	1
36751	1683	88273387149541	10787	5567	3	0	1
36753	1683	88273417149541	10787	5567	4	0	1
36761	1683	89713417149541	10792	5571	6	0	1
36765	1683	91153477149541	10805	5577	2	0	1
36766	1683	91153497149541	10805	5577	3	0	1
36772	1683	92593497149541	10840	5594	2	0	1
36773	1683	92593517149541	10840	5594	3	0	1
36780	1683	94033517149541	10855	5604	2	0	1
36786	1683	95473537149541	10890	5615	3	0	1
36787	1683	95473567149541	10890	5615	4	0	1
36793	1683	96913567149541	10899	5619	1	0	1
36794	1683	96913577149541	10899	5619	2	0	1
36798	1683	98353577149541	10901	5621	5	0	1
36804	1683	99793627149541	10906	5625	4	0	1
36805	1683	99793667149541	10906	5625	5	0	1
36808	1683	101233667149541	10910	5628	4	0	1
36809	1683	101233707149541	10910	5628	5	0	1
36813	1683	102673787149541	10915	5630	9	0	1
36817	1683	104113787149541	10927	5635	5	0	1
36819	1683	104113828149541	10927	5635	6	0	1
36823	1683	105553828149541	10956	5646	1	0	1
36824	1683	105553838149541	10956	5646	2	0	1
36838	1683	106993878149541	11062	5691	5	0	1
36845	1683	108433878149541	11085	5703	3	0	1
36847	1683	108433908149541	11085	5703	4	0	1
36852	1683	109873908149541	11091	5708	3	0	1
36853	1683	109873938149541	11091	5708	4	0	1
36858	1683	110880167999541	1203	664	2	0	\N
36860	1683	111313938149541	11137	5724	6	0	\N
36861	1683	111313938149541	11144	5728	4	0	\N
36862	1683	111313938149541	11168	5740	0	0	\N
36863	1683	111313938149541	11178	5742	4	0	\N
36864	1683	111313938149541	11185	5744	2	0	\N
36866	1683	111313958149541	11185	5744	3	0	\N
36868	1683	111313978149541	11144	5728	5	0	\N
36869	1683	111313978149541	11178	5742	5	0	\N
36870	1683	111313998149541	11137	5724	7	0	\N
36871	1683	112320187999541	1226	676	1	0	\N
36873	1683	112320197999541	1226	676	2	0	\N
36875	1683	112753958149541	11200	5751	2	0	\N
36876	1683	112753958149541	11211	5758	3	0	\N
36878	1683	112753978149541	11200	5751	3	0	\N
36880	1683	112754078149541	11211	5758	4	0	\N
36881	1683	113760197999541	1239	685	1	0	\N
36883	1683	113760197999541	1308	687	0	0	\N
36884	1683	113760207999541	1239	685	2	0	\N
36886	1683	114193978149541	11233	5772	6	0	\N
36888	1683	114194011149541	11233	5772	7	0	\N
36890	1683	115200207999541	1307	701	0	0	\N
36894	1683	116640217999541	1284	709	1	0	\N
36895	1683	116640217999541	1296	716	4	0	\N
36896	1683	116640217999541	1309	718	0	0	\N
36897	1683	116640217999541	1316	725	1	0	\N
36899	1683	116640227999541	1284	709	2	0	\N
36900	1683	116640227999541	1316	725	2	0	\N
36902	1683	116640257999541	1296	716	5	0	\N
36905	1683	118080227999541	1338	736	1	0	\N
36906	1683	118080227999541	1357	745	1	0	\N
36908	1683	118080237999541	1338	736	2	0	\N
36909	1683	118080237999541	1357	745	2	0	\N
36911	1683	118514252149541	11315	5811	2	0	\N
36913	1683	118514263149541	11315	5811	3	0	\N
36919	1683	120960248999541	1368	750	1	0	\N
36921	1683	120960258999541	1368	750	2	0	\N
36923	1683	121394286149541	11350	5829	2	0	\N
36924	1683	121394286149541	11364	5837	4	0	\N
36926	1683	121394297149541	11350	5829	3	0	\N
36928	1683	121394308149541	11364	5837	5	0	\N
36931	1683	122834297149541	11375	5844	2	0	\N
36932	1683	122834297149541	11387	5849	1	0	\N
36934	1683	122834298149541	11387	5849	2	0	\N
36935	1683	122834308149541	11375	5844	3	0	\N
36939	1683	124274319149541	11418	5865	2	0	\N
36941	1683	124274330149541	11418	5865	3	0	\N
36945	1683	125714330149541	11432	5873	2	0	\N
36946	1683	125714330149541	11439	5876	2	0	\N
36949	1683	125714341149541	11432	5873	3	0	\N
36950	1683	125714341149541	11439	5876	3	0	\N
36960	1683	130034362149541	11460	5888	2	0	\N
36961	1683	130034362149541	11482	5901	2	0	\N
36962	1683	130034362149541	11542	5929	2	0	\N
36965	1683	130034373149541	11460	5888	3	0	\N
36966	1683	130034373149541	11482	5901	3	0	\N
36967	1683	130034373149541	11542	5929	3	0	\N
36974	1683	132914366149541	11564	5945	1	0	\N
36976	1683	132914367149541	11564	5945	2	0	\N
36983	1683	135794368149541	11584	5958	1	0	\N
36985	1683	135794369149541	11584	5958	2	0	\N
36987	1683	135794371149541	11595	5965	2	0	\N
36988	1683	136800418999541	1521	833	2	0	\N
36991	1683	136800438999541	1521	833	3	0	\N
36872	1683	112320187999541	1235	683	1	0	0
36874	1683	112320197999541	1235	683	2	0	0
36882	1683	113760197999541	1243	688	1	0	0
36885	1683	113760207999541	1243	688	2	0	0
36889	1683	115200207999541	1276	704	1	0	0
36898	1683	116640217999541	1336	735	1	0	0
36901	1683	116640227999541	1336	735	2	0	0
36907	1683	118080227999541	1362	747	2	0	0
36910	1683	118080238999541	1362	747	3	0	0
36915	1683	119520238999541	1366	749	1	0	0
36920	1683	120960248999541	1372	752	1	0	0
36922	1683	120960258999541	1372	752	2	0	0
36929	1683	122400258999541	1383	758	6	0	0
36930	1683	122400318999541	1383	758	7	0	0
36938	1683	123840328999541	1384	759	2	0	0
36943	1683	125280328999541	1394	763	1	0	0
36944	1683	125280338999541	1394	763	2	0	0
36951	1683	126720338999541	1405	768	2	0	0
36952	1683	126720358999541	1405	768	3	0	0
36958	1683	129600358999541	1429	777	1	0	0
36959	1683	129600368999541	1429	777	2	0	0
36968	1683	131040368999541	1465	798	1	0	0
36969	1683	131040378999541	1465	798	2	0	0
36972	1683	132480378999541	1494	817	1	0	0
36978	1683	133920388999541	1499	819	1	0	0
36979	1683	133920398999541	1499	819	2	0	0
36981	1683	135360398999541	1500	820	2	0	0
36982	1683	135360418999541	1500	820	3	0	0
36990	1683	136800428999541	1527	836	2	0	0
36865	1683	111313938149541	11197	5749	2	0	1
36867	1683	111313958149541	11197	5749	3	0	1
36877	1683	112753958149541	11226	5769	2	0	1
36879	1683	112753978149541	11226	5769	3	0	1
36892	1683	115633978149541	11259	5785	24	0	1
36893	1683	115634191149541	11259	5785	25	0	1
36903	1683	117074191149541	11261	5786	7	0	1
36904	1683	117074252149541	11261	5786	8	0	1
36912	1683	118514252149541	11329	5818	2	0	1
36917	1683	119954263149541	11332	5820	5	0	1
36918	1683	119954286149541	11332	5820	6	0	1
36925	1683	121394286149541	11374	5843	2	0	1
36927	1683	121394297149541	11374	5843	3	0	1
36936	1683	122834319149541	11405	5858	5	0	1
36940	1683	124274319149541	11430	5871	2	0	1
36942	1683	124274330149541	11430	5871	3	0	1
36947	1683	125714330149541	11446	5880	1	0	1
36948	1683	125714340149541	11446	5880	2	0	1
36954	1683	127154351149541	11453	5884	3	0	1
36956	1683	128594351149541	11457	5887	2	0	1
36957	1683	128594362149541	11457	5887	3	0	1
36963	1683	130034362149541	11554	5937	2	0	1
36964	1683	130034364149541	11554	5937	3	0	1
36971	1683	131474366149541	11560	5942	3	0	1
36975	1683	132914366149541	11578	5954	2	0	1
36977	1683	132914368149541	11578	5954	3	0	1
36980	1683	134354368149541	11582	5957	0	0	1
36986	1683	135794369149541	11586	5959	2	0	1
36992	1683	137234369149541	11605	5969	3	0	1
36993	1683	137234371149541	11595	5965	3	0	\N
36999	1683	139680438999541	1535	840	1	0	\N
37000	1683	139680438999541	1539	842	1	0	\N
37001	1683	139680438999541	1545	843	1	0	\N
37003	1683	139680448999541	1535	840	2	0	\N
37004	1683	139680448999541	1539	842	2	0	\N
37005	1683	139680448999541	1545	843	2	0	\N
37007	1683	140114375149541	11637	5989	0	0	\N
37013	1683	141554377149541	11653	5994	1	0	\N
37014	1683	141554378149541	11653	5994	2	0	\N
37018	1683	142994378149541	11678	6004	1	0	\N
37020	1683	142994379149541	11678	6004	2	0	\N
37022	1683	144000468999541	1592	866	1	0	\N
37023	1683	144000468999541	1605	868	2	0	\N
37025	1683	144000478999541	1592	866	2	0	\N
37027	1683	144000488999541	1605	868	3	0	\N
37028	1683	144434380149541	11705	6020	1	0	\N
37029	1683	144434380149541	11710	6021	0	0	\N
37030	1683	144434380149541	11732	6030	1	0	\N
37031	1683	144434380149541	11742	6034	1	0	\N
37033	1683	144434381149541	11705	6020	2	0	\N
37034	1683	144434381149541	11732	6030	2	0	\N
37035	1683	144434381149541	11742	6034	2	0	\N
37040	1683	146880498999541	1661	894	4	0	\N
37041	1683	146880498999541	1672	898	1	0	\N
37043	1683	146880508999541	1672	898	2	0	\N
37045	1683	146880538999541	1661	894	5	0	\N
37048	1683	148320508999541	1717	923	1	0	\N
37050	1683	148320518999541	1717	923	2	0	\N
37058	1683	151200528999541	1732	931	1	0	\N
37060	1683	151200538999541	1732	931	2	0	\N
37064	1683	152640538999541	1745	936	1	0	\N
37066	1683	152640548999541	1745	936	2	0	\N
37070	1683	154080548999541	1778	953	1	0	\N
37072	1683	154080558999541	1778	953	2	0	\N
37076	1683	155520568999541	1804	965	3	0	\N
37079	1683	155520589999541	1804	965	4	0	\N
37086	1683	158400598999541	1863	993	1	0	\N
37088	1683	158400608999541	1863	993	2	0	\N
37092	1683	159840608999541	1884	1002	1	0	\N
37093	1683	159840608999541	1901	1013	1	0	\N
37094	1683	159840608999541	1906	1015	1	0	\N
37096	1683	159840618999541	1884	1002	2	0	\N
37097	1683	159840618999541	1901	1013	2	0	\N
37098	1683	159840618999541	1906	1015	2	0	\N
37100	1683	160274435149541	11872	6101	3	0	\N
37103	1683	160274438149541	11872	6101	4	0	\N
37105	1683	161280618999541	1929	1026	1	0	\N
37106	1683	161280618999541	1945	1032	1	0	\N
37107	1683	161280618999541	1950	1034	1	0	\N
37109	1683	161280628999541	1929	1026	2	0	\N
37110	1683	161280628999541	1945	1032	2	0	\N
37111	1683	161280628999541	1950	1034	2	0	\N
37114	1683	162720628999541	1960	1038	2	0	\N
37117	1683	162720648999541	1960	1038	3	0	\N
37128	1683	167040658999541	1992	1052	1	0	\N
37002	1683	139680438999541	1573	857	1	0	0
37006	1683	139680448999541	1573	857	2	0	0
37011	1683	141120448999541	1577	859	1	0	0
37012	1683	141120458999541	1577	859	2	0	0
37016	1683	142560458999541	1586	862	1	0	0
37024	1683	144000468999541	1607	869	1	0	0
37026	1683	144000478999541	1607	869	2	0	0
37036	1683	145440478999541	1656	892	2	0	0
37037	1683	145440498999541	1656	892	3	0	0
37042	1683	146880498999541	1689	908	1	0	0
37049	1683	148320508999541	1725	926	1	0	0
37051	1683	148320518999541	1725	926	2	0	0
37054	1683	149760518999541	1729	929	1	0	0
37055	1683	149760528999541	1729	929	2	0	0
37061	1683	151200538999541	1743	935	2	0	0
37065	1683	152640538999541	1755	940	1	0	0
37067	1683	152640548999541	1755	940	2	0	0
37071	1683	154080548999541	1791	958	2	0	0
37073	1683	154080568999541	1791	958	3	0	0
37078	1683	155520578999541	1808	967	2	0	0
37082	1683	156960578999541	1835	980	2	0	0
37083	1683	156960598999541	1835	980	3	0	0
37087	1683	158400598999541	1882	1001	1	0	0
37089	1683	158400608999541	1882	1001	2	0	0
37099	1683	159840618999541	1923	1024	2	0	0
37108	1683	161280618999541	1957	1037	1	0	0
37112	1683	161280628999541	1957	1037	2	0	0
37115	1683	162720628999541	1972	1043	1	0	0
37120	1683	164160638999541	1983	1048	1	0	0
37121	1683	164160648999541	1983	1048	2	0	0
37124	1683	165600648999541	1988	1051	1	0	0
37125	1683	165600658999541	1988	1051	2	0	0
36994	1683	137234372149541	11605	5969	4	0	1
36998	1683	138674375149541	11624	5982	4	0	1
37008	1683	140114375149541	11651	5993	2	0	1
37009	1683	140114377149541	11651	5993	3	0	1
37010	1683	140114378149541	11673	6000	1	0	1
37015	1683	141554378149541	11673	6000	2	0	1
37021	1683	142994380149541	11695	6013	3	0	1
37032	1683	144434380149541	11754	6042	0	0	1
37038	1683	145874380149541	11756	6044	1	0	1
37039	1683	145874381149541	11756	6044	2	0	1
37047	1683	147314402149541	11770	6051	4	0	1
37052	1683	148754402149541	11771	6052	2	0	1
37053	1683	148754413149541	11771	6052	3	0	1
37056	1683	150194413149541	11816	6071	1	0	1
37057	1683	150194414149541	11816	6071	2	0	1
37063	1683	151634416149541	11817	6072	3	0	1
37068	1683	153074416149541	11821	6075	2	0	1
37069	1683	153074418149541	11821	6075	3	0	1
37074	1683	154514418149541	11835	6083	4	0	1
37075	1683	154514422149541	11835	6083	5	0	1
37081	1683	155954423149541	11839	6086	2	0	1
37084	1683	157394423149541	11865	6098	1	0	1
37085	1683	157394424149541	11865	6098	2	0	1
37090	1683	158834424149541	11870	6100	2	0	1
37101	1683	160274435149541	11877	6104	1	0	1
37102	1683	160274436149541	11877	6104	2	0	1
37104	1683	160274447149541	11881	6105	2	0	1
37113	1683	161714447149541	11881	6105	3	0	1
37118	1683	163154447149541	11891	6111	1	0	1
37122	1683	164594448149541	11901	6119	1	0	1
37123	1683	164594449149541	11901	6119	2	0	1
37126	1683	166034449149541	11924	6136	1	0	1
37127	1683	166034450149541	11924	6136	2	0	1
37130	1683	167040668999541	1992	1052	2	0	\N
37134	1683	168480668999541	2006	1059	2	0	\N
37136	1683	168480688999541	2006	1059	3	0	\N
37144	1683	171360698999541	2029	1071	1	0	\N
37146	1683	171360708999541	2029	1071	2	0	\N
37148	1683	171794455149541	11958	6155	1	0	\N
37150	1683	171794456149541	11958	6155	2	0	\N
37156	1683	174240718999541	2058	1087	1	0	\N
37157	1683	174240718999541	2064	1090	1	0	\N
37159	1683	174240728999541	2058	1087	2	0	\N
37160	1683	174240728999541	2064	1090	2	0	\N
37162	1683	174674457149541	11988	6170	1	0	\N
37163	1683	174674457149541	11994	6173	1	0	\N
37165	1683	174674458149541	11988	6170	2	0	\N
37166	1683	174674458149541	11994	6173	2	0	\N
37168	1683	175680728999541	2070	1093	1	0	\N
37169	1683	175680728999541	2082	1099	1	0	\N
37171	1683	175680738999541	2070	1093	2	0	\N
37172	1683	175680738999541	2082	1099	2	0	\N
37180	1683	178560758999541	2105	1110	1	0	\N
37181	1683	178560758999541	2122	1118	1	0	\N
37183	1683	178560768999541	2105	1110	2	0	\N
37184	1683	178560768999541	2122	1118	2	0	\N
37188	1683	180000768999541	2139	1128	1	0	\N
37190	1683	180000778999541	2139	1128	2	0	\N
37192	1683	180434463149541	12079	6220	1	0	\N
37193	1683	180434463149541	12104	6233	1	0	\N
37195	1683	180434464149541	12079	6220	2	0	\N
37196	1683	180434464149541	12104	6233	2	0	\N
37198	1683	181440778999541	2165	1143	1	0	\N
37200	1683	181440788999541	2165	1143	2	0	\N
37210	1683	184754470149541	12151	6259	1	0	\N
37212	1683	184754471149541	12151	6259	2	0	\N
37213	1683	185760808999541	2232	1177	2	0	\N
37214	1683	185760808999541	2242	1182	2	0	\N
37215	1683	185760808999541	2265	1189	2	0	\N
37218	1683	185760828999541	2232	1177	3	0	\N
37219	1683	185760828999541	2265	1189	3	0	\N
37220	1683	185760918999541	2242	1182	3	0	\N
37225	1683	187634471149541	12191	6276	3	0	\N
37228	1683	187634474149541	12191	6276	4	0	\N
37229	1683	188640838999541	2293	1203	3	0	\N
37232	1683	188640868999541	2293	1203	4	0	\N
37239	1683	191520858999541	2360	1234	1	0	\N
37241	1683	191520868999541	2360	1234	2	0	\N
37247	1683	193394586149541	12220	6294	2	0	\N
37250	1683	193394588149541	12220	6294	3	0	\N
37257	1683	196274588149541	12266	6315	1	0	\N
37259	1683	196274589149541	12266	6315	2	0	\N
37260	1683	197280908999541	2431	1273	1	0	\N
37262	1683	197280918999541	2431	1273	2	0	\N
37264	1683	197714588149541	12275	6319	1	0	\N
37135	1683	168480668999541	2025	1068	2	0	0
37137	1683	168480688999541	2025	1068	3	0	0
37140	1683	169920688999541	2028	1070	1	0	0
37141	1683	169920698999541	2028	1070	2	0	0
37145	1683	171360698999541	2048	1082	1	0	0
37152	1683	172800708999541	2055	1086	1	0	0
37153	1683	172800718999541	2055	1086	2	0	0
37158	1683	174240718999541	2067	1092	1	0	0
37161	1683	174240728999541	2067	1092	2	0	0
37170	1683	175680728999541	2096	1106	2	0	0
37176	1683	177120748999541	2099	1108	1	0	0
37177	1683	177120758999541	2099	1108	2	0	0
37182	1683	178560758999541	2123	1119	1	0	0
37185	1683	178560768999541	2123	1119	2	0	0
37191	1683	180000778999541	2160	1141	2	0	0
37199	1683	181440778999541	2178	1148	1	0	0
37201	1683	181440788999541	2178	1148	2	0	0
37204	1683	182880788999541	2188	1153	1	0	0
37205	1683	182880798999541	2188	1153	2	0	0
37209	1683	184320808999541	2202	1159	2	0	0
37216	1683	185760808999541	2285	1198	1	0	0
37217	1683	185760818999541	2285	1198	2	0	0
37223	1683	187200818999541	2286	1199	2	0	0
37224	1683	187200838999541	2286	1199	3	0	0
37231	1683	188640848999541	2322	1215	2	0	0
37235	1683	190080848999541	2324	1217	1	0	0
37236	1683	190080858999541	2324	1217	2	0	0
37240	1683	191520858999541	2389	1248	1	0	0
37245	1683	192960868999541	2407	1259	2	0	0
37246	1683	192960888999541	2407	1259	3	0	0
37251	1683	194400888999541	2414	1263	1	0	0
37252	1683	194400898999541	2414	1263	2	0	0
37255	1683	195840898999541	2422	1267	1	0	0
37261	1683	197280908999541	2438	1275	3	0	0
37263	1683	197280938999541	2438	1275	4	0	0
37132	1683	167474450149541	11933	6142	1	0	1
37133	1683	167474451149541	11933	6142	2	0	1
37138	1683	168914451149541	11938	6145	3	0	1
37142	1683	170354454149541	11944	6149	1	0	1
37143	1683	170354455149541	11944	6149	2	0	1
37149	1683	171794455149541	11967	6158	1	0	1
37151	1683	171794456149541	11967	6158	2	0	1
37155	1683	173234457149541	11984	6168	2	0	1
37164	1683	174674457149541	12010	6181	1	0	1
37167	1683	174674458149541	12010	6181	2	0	1
37174	1683	176114458149541	12031	6191	1	0	1
37175	1683	176114459149541	12031	6191	2	0	1
37179	1683	177554460149541	12042	6199	2	0	1
37186	1683	178994460149541	12075	6217	3	0	1
37187	1683	178994463149541	12075	6217	4	0	1
37194	1683	180434463149541	12111	6237	1	0	1
37197	1683	180434464149541	12111	6237	2	0	1
37203	1683	181874469149541	12145	6255	6	0	1
37206	1683	183314469149541	12147	6257	1	0	1
37207	1683	183314470149541	12147	6257	2	0	1
37211	1683	184754470149541	12165	6263	0	0	1
37222	1683	186194471149541	12168	6265	2	0	1
37226	1683	187634471149541	12193	6277	1	0	1
37227	1683	187634472149541	12193	6277	2	0	1
37233	1683	189074472149541	12198	6281	2	0	1
37234	1683	189074573149541	12198	6281	3	0	1
37238	1683	190514574149541	12201	6284	2	0	1
37243	1683	191954574149541	12210	6290	3	0	1
37244	1683	191954586149541	12210	6290	4	0	1
37248	1683	193394586149541	12222	6295	1	0	1
37249	1683	193394587149541	12222	6295	2	0	1
37254	1683	194834588149541	12234	6301	2	0	1
37258	1683	196274588149541	12269	6317	0	0	1
37265	1683	197714588149541	12280	6321	1	0	\N
37267	1683	197714589149541	12275	6319	2	0	\N
37268	1683	197714589149541	12280	6321	2	0	\N
37276	1683	200594700149541	12303	6336	2	0	\N
37278	1683	200594801149541	12303	6336	3	0	\N
37286	1683	203474902149541	12316	6347	1	0	\N
37287	1683	203474902149541	12329	6354	0	0	\N
37289	1683	203474903149541	12316	6347	2	0	\N
37291	1683	204480978999541	2541	1336	1	0	\N
37293	1683	204480978999541	2816	1322	0	0	\N
37294	1683	204480988999541	2541	1336	2	0	\N
37302	1683	207360998999541	2597	1367	2	0	\N
37304	1683	207360998999541	2819	1344	0	0	\N
37305	1683	207360998999541	2820	1355	0	0	\N
37306	1683	207360998999541	2821	1366	0	0	\N
37308	1683	207361018999541	2597	1367	3	0	\N
37309	1683	207794906149541	12427	6407	0	0	\N
37310	1683	207794906149541	12452	6414	0	0	\N
37311	1683	207794906149541	12453	6415	0	0	\N
37313	1683	208801008999541	2619	1378	1	0	\N
37314	1683	208801008999541	2633	1385	1	0	\N
37316	1683	208801018999541	2619	1378	2	0	\N
37317	1683	208801018999541	2633	1385	2	0	\N
37324	1683	211681028999541	2689	1412	1	0	\N
37326	1683	211681038999541	2689	1412	2	0	\N
37328	1683	212114910149541	12494	6438	1	0	\N
37330	1683	212114911149541	12494	6438	2	0	\N
37334	1683	213554921149541	12518	6452	2	0	\N
37336	1683	213554932149541	12518	6452	3	0	\N
37338	1683	214561058999541	2763	1444	1	0	\N
37340	1683	214561068999541	2763	1444	2	0	\N
37342	1683	214994943149541	12527	6456	2	0	\N
37343	1683	214994943149541	12533	6459	1	0	\N
37345	1683	214994944149541	12533	6459	2	0	\N
37346	1683	214994954149541	12527	6456	3	0	\N
37348	1683	216001078999541	2786	1458	1	0	\N
37349	1683	216001078999541	2839	1485	0	0	\N
37350	1683	216001078999541	2874	1504	0	0	\N
37351	1683	216001078999541	2920	1521	0	0	\N
37353	1683	216001088999541	2786	1458	2	0	\N
37359	1683	218881078999541	2944	1531	0	0	\N
37362	1683	219314998149541	12556	6471	2	0	\N
37364	1683	219315009149541	12556	6471	3	0	\N
37369	1683	221761088999541	3026	1572	1	0	\N
37371	1683	221761098999541	3026	1572	2	0	\N
37386	1683	227521128999541	3080	1600	1	0	\N
37387	1683	227521128999541	3109	1614	3	0	\N
37389	1683	227521138999541	3080	1600	2	0	\N
37390	1683	227521158999541	3109	1614	4	0	\N
37396	1683	229395119149541	12614	6507	8	0	\N
37399	1683	229395154149541	12614	6507	9	0	\N
37274	1683	200160948999541	2447	1280	1	0	0
37275	1683	200160958999541	2447	1280	2	0	0
37280	1683	201600958999541	2498	1308	1	0	0
37281	1683	201600968999541	2498	1308	2	0	0
37284	1683	203040968999541	2514	1320	1	0	0
37292	1683	204480978999541	2543	1338	1	0	0
37295	1683	204480988999541	2543	1338	2	0	0
37298	1683	205920988999541	2544	1339	1	0	0
37299	1683	205920998999541	2544	1339	2	0	0
37303	1683	207360998999541	2612	1374	1	0	0
37315	1683	208801008999541	2642	1389	1	0	0
37318	1683	208801018999541	2642	1389	2	0	0
37320	1683	210241018999541	2673	1404	1	0	0
37321	1683	210241028999541	2673	1404	2	0	0
37327	1683	211681038999541	2716	1427	2	0	0
37332	1683	213121038999541	2727	1431	2	0	0
37333	1683	213121058999541	2727	1431	3	0	0
37339	1683	214561058999541	2779	1454	2	0	0
37341	1683	214561078999541	2779	1454	3	0	0
37356	1683	217441078999541	2933	1526	0	0	0
37360	1683	218881078999541	2987	1553	1	0	0
37361	1683	218881088999541	2987	1553	2	0	0
37366	1683	220321088999541	3005	1561	0	0	0
37370	1683	221761088999541	3029	1573	1	0	0
37375	1683	223201098999541	3051	1586	1	0	0
37376	1683	223201108999541	3051	1586	2	0	0
37379	1683	224641108999541	3065	1592	1	0	0
37380	1683	224641118999541	3065	1592	2	0	0
37383	1683	226081128999541	3071	1597	2	0	0
37388	1683	227521128999541	3116	1618	3	0	0
37391	1683	227521158999541	3116	1618	4	0	0
37394	1683	228961158999541	3134	1630	1	0	0
37395	1683	228961168999541	3134	1630	2	0	0
37266	1683	197714588149541	12282	6322	2	0	1
37269	1683	197714599149541	12282	6322	3	0	1
37272	1683	199154599149541	12293	6331	2	0	1
37273	1683	199154700149541	12293	6331	3	0	1
37277	1683	200594700149541	12304	6337	2	0	1
37282	1683	202034801149541	12310	6342	2	0	1
37283	1683	202034902149541	12310	6342	3	0	1
37288	1683	203474902149541	12378	6383	1	0	1
37290	1683	203474903149541	12378	6383	2	0	1
37297	1683	204914905149541	12400	6396	3	0	1
37300	1683	206354905149541	12410	6401	1	0	1
37301	1683	206354906149541	12410	6401	2	0	1
37312	1683	207794906149541	12458	6419	0	0	1
37319	1683	209234906149541	12476	6429	0	0	1
37323	1683	210674910149541	12487	6436	5	0	1
37329	1683	212114910149541	12510	6446	2	0	1
37331	1683	212114921149541	12510	6446	3	0	1
37335	1683	213554921149541	12521	6453	4	0	1
37337	1683	213554943149541	12521	6453	5	0	1
37347	1683	214994954149541	12538	6462	3	0	1
37354	1683	216434954149541	12554	6469	2	0	1
37355	1683	216434965149541	12554	6469	3	0	1
37357	1683	217874965149541	12555	6470	6	0	1
37363	1683	219314998149541	12561	6472	4	0	1
37365	1683	219315020149541	12561	6472	5	0	1
37367	1683	220755020149541	12568	6477	9	0	1
37368	1683	220755065149541	12568	6477	10	0	1
37373	1683	222195065149541	12574	6481	2	0	1
37377	1683	223635076149541	12583	6485	1	0	1
37378	1683	223635086149541	12583	6485	2	0	1
37381	1683	225075086149541	12591	6491	0	0	1
37384	1683	226515086149541	12592	6492	4	0	1
37385	1683	226515108149541	12592	6492	5	0	1
37393	1683	227955119149541	12607	6502	3	0	1
37397	1683	229395119149541	12623	6515	2	0	1
37398	1683	229395130149541	12623	6515	3	0	1
37406	1683	232275141149541	12656	6528	7	0	\N
37407	1683	232275141149541	12660	6530	3	0	\N
37409	1683	232275153149541	12660	6530	4	0	\N
37410	1683	232275175149541	12656	6528	8	0	\N
37414	1683	233715183149541	12679	6539	2	0	\N
37416	1683	233715194149541	12679	6539	3	0	\N
37430	1683	239041308999541	3181	1652	1	0	\N
37431	1683	239041308999541	3197	1660	2	0	\N
37433	1683	239041318999541	3181	1652	2	0	\N
37435	1683	239041328999541	3197	1660	3	0	\N
37442	1683	241921378999541	3249	1687	1	0	\N
37444	1683	241921388999541	3249	1687	2	0	\N
37447	1683	243361398999541	3254	1691	2	0	\N
37450	1683	243361418999541	3254	1691	3	0	\N
37455	1683	245235282149541	12777	6587	1	0	\N
37456	1683	245235282149541	12810	6606	0	0	\N
37458	1683	245235283149541	12777	6587	2	0	\N
37472	1683	250561748999541	3315	1720	2	0	\N
37475	1683	250561768999541	3315	1720	3	0	\N
37476	1683	250995324149541	12856	6630	4	0	\N
37477	1683	250995324149541	12871	6638	2	0	\N
37478	1683	250995324149541	12885	6643	2	0	\N
37479	1683	250995324149541	12894	6646	2	0	\N
37480	1683	250995324149541	12900	6649	2	0	\N
37481	1683	250995324149541	12914	6656	2	0	\N
37483	1683	250995335149541	12871	6638	3	0	\N
37484	1683	250995335149541	12885	6643	3	0	\N
37485	1683	250995335149541	12894	6646	3	0	\N
37486	1683	250995335149541	12900	6649	3	0	\N
37487	1683	250995335149541	12914	6656	3	0	\N
37489	1683	250995346149541	12856	6630	5	0	\N
37500	1683	255315357149541	12950	6676	4	0	\N
37502	1683	255315379149541	12950	6676	5	0	\N
37506	1683	256755390149541	12967	6688	2	0	\N
37507	1683	256755390149541	12972	6689	2	0	\N
37509	1683	256755401149541	12967	6688	3	0	\N
37510	1683	256755401149541	12972	6689	3	0	\N
37512	1683	257761828999541	3371	1754	1	0	\N
37514	1683	257761838999541	3371	1754	2	0	\N
37519	1683	259635423149541	13050	6728	5	0	\N
37521	1683	259635455149541	13050	6728	6	0	\N
37531	1683	263955576149541	13090	6744	3	0	\N
37532	1683	263955576149541	13101	6752	4	0	\N
37534	1683	263955588149541	13090	6744	4	0	\N
37536	1683	263955589149541	13101	6752	5	0	\N
37405	1683	231841218999541	3163	1643	2	0	0
37412	1683	233281218999541	3165	1645	5	0	0
37413	1683	233281268999541	3165	1645	6	0	0
37418	1683	234721268999541	3166	1646	1	0	0
37419	1683	234721278999541	3166	1646	2	0	0
37423	1683	236161288999541	3168	1647	2	0	0
37426	1683	237601288999541	3180	1651	2	0	0
37427	1683	237601308999541	3180	1651	3	0	0
37432	1683	239041308999541	3204	1664	1	0	0
37434	1683	239041318999541	3204	1664	2	0	0
37439	1683	240481378999541	3232	1678	7	0	0
37443	1683	241921378999541	3252	1689	2	0	0
37445	1683	241921398999541	3252	1689	3	0	0
37448	1683	243361398999541	3259	1693	1	0	0
37453	1683	244801408999541	3262	1695	5	0	0
37454	1683	244801458999541	3262	1695	6	0	0
37460	1683	246241458999541	3273	1700	2	0	0
37461	1683	246241478999541	3273	1700	3	0	0
37464	1683	247681478999541	3276	1702	4	0	0
37468	1683	249121518999541	3305	1716	5	0	0
37469	1683	249121748999541	3305	1716	6	0	0
37473	1683	250561748999541	3326	1725	1	0	0
37474	1683	250561758999541	3326	1725	2	0	0
37490	1683	252001758999541	3335	1731	1	0	0
37494	1683	253441768999541	3339	1734	3	0	0
37495	1683	253441798999541	3339	1734	4	0	0
37498	1683	254881798999541	3354	1743	2	0	0
37499	1683	254881818999541	3354	1743	3	0	0
37505	1683	256321828999541	3362	1748	2	0	0
37513	1683	257761828999541	3386	1761	1	0	0
37515	1683	257761838999541	3386	1761	2	0	0
37518	1683	259201838999541	3405	1771	0	0	0
37523	1683	260641838999541	3415	1776	1	0	0
37527	1683	262081848999541	3432	1783	0	0	0
37530	1683	263521848999541	3459	1796	0	0	0
37402	1683	230835130149541	12649	6524	2	0	1
37403	1683	230835141149541	12649	6524	3	0	1
37408	1683	232275141149541	12661	6531	6	0	1
37415	1683	233715183149541	12688	6543	2	0	1
37417	1683	233715194149541	12688	6543	3	0	1
37420	1683	235155194149541	12690	6544	2	0	1
37421	1683	235155205149541	12690	6544	3	0	1
37425	1683	236595216149541	12698	6548	3	0	1
37428	1683	238035216149541	12699	6549	2	0	1
37429	1683	238035227149541	12699	6549	3	0	1
37436	1683	239475227149541	12719	6558	4	0	1
37437	1683	239475249149541	12719	6558	5	0	1
37441	1683	240915271149541	12724	6561	5	0	1
37446	1683	242355271149541	12735	6566	0	0	1
37451	1683	243795271149541	12746	6571	2	0	1
37452	1683	243795282149541	12746	6571	3	0	1
37457	1683	245235282149541	12816	6609	1	0	1
37462	1683	246675292149541	12828	6618	1	0	1
37463	1683	246675302149541	12828	6618	2	0	1
37466	1683	248115302149541	12842	6623	2	0	1
37467	1683	248115313149541	12842	6623	3	0	1
37471	1683	249555324149541	12853	6628	3	0	1
37482	1683	250995324149541	12920	6659	2	0	1
37488	1683	250995335149541	12920	6659	3	0	1
37492	1683	252435335149541	12922	6660	2	0	1
37493	1683	252435346149541	12922	6660	3	0	1
37497	1683	253875357149541	12923	6661	3	0	1
37501	1683	255315357149541	12961	6683	6	0	1
37503	1683	255315390149541	12961	6683	7	0	1
37508	1683	256755390149541	12975	6690	2	0	1
37511	1683	256755401149541	12975	6690	3	0	1
37517	1683	258195423149541	12988	6696	5	0	1
37520	1683	259635423149541	13069	6736	8	0	1
37522	1683	259635548149541	13069	6736	9	0	1
37525	1683	261075548149541	13075	6738	6	0	1
37528	1683	262515563149541	13076	6739	4	0	1
37529	1683	262515576149541	13076	6739	5	0	1
37533	1683	263955576149541	13117	6760	3	0	1
37535	1683	263955588149541	13117	6760	4	0	1
37537	1683	264961848999541	3467	1800	0	0	\N
37538	1683	264961848999541	3491	1813	0	0	\N
37542	1683	266401848999541	3524	1830	0	0	\N
37543	1683	266401848999541	3534	1834	0	0	\N
37544	1683	266401848999541	3549	1841	0	0	\N
37545	1683	266401848999541	3551	1843	0	0	\N
37546	1683	266401848999541	3553	1844	0	0	\N
37548	1683	266835600149541	13138	6772	4	0	\N
37549	1683	266835600149541	13189	6797	9	0	\N
37552	1683	266835613149541	13138	6772	5	0	\N
37553	1683	266835622149541	13210	6808	1	0	\N
37554	1683	266835636149541	13189	6797	10	0	\N
37556	1683	268275612149541	13218	6813	6	0	\N
37558	1683	268275622149541	13210	6808	7	0	\N
37560	1683	268275636149541	13210	6808	8	0	\N
37561	1683	268275636149541	13218	6813	7	0	\N
37562	1683	268275643149541	13341	6875	1	0	\N
37564	1683	269715633149541	13273	6836	2	0	\N
37565	1683	269715633149541	13286	6843	3	0	\N
37568	1683	269715643149541	13341	6875	9	0	\N
37569	1683	269715644149541	13273	6836	3	0	\N
37570	1683	269715645149541	13286	6843	4	0	\N
37571	1683	269715659149541	13341	6875	10	0	\N
37578	1683	273601848999541	3600	1869	0	0	\N
37579	1683	273601848999541	3609	1872	0	0	\N
37580	1683	273601848999541	3612	1874	0	0	\N
37583	1683	274035662149541	13379	6895	4	0	\N
37584	1683	274035662149541	13393	6902	7	0	\N
37586	1683	274035675149541	13379	6895	5	0	\N
37587	1683	274035687149541	13393	6902	8	0	\N
37590	1683	275041858999541	3667	1904	0	0	\N
37591	1683	275041858999541	3686	1915	2	0	\N
37594	1683	275041878999541	3686	1915	3	0	\N
37600	1683	277921878999541	3712	1927	2	0	\N
37603	1683	277921898999541	3712	1927	3	0	\N
37613	1683	281235812149541	13473	6940	4	0	\N
37614	1683	281235825149541	13473	6940	5	0	\N
37621	1683	283681918999541	3771	1956	1	0	\N
37623	1683	283681928999541	3771	1956	2	0	\N
37635	1683	288001948999541	3820	1979	1	0	\N
37637	1683	288001958999541	3820	1979	2	0	\N
37641	1683	289441968999541	3844	1997	2	0	\N
37643	1683	289441988999541	3844	1997	3	0	\N
37651	1683	292321998999541	3884	2018	2	0	\N
37652	1683	292321998999541	3885	2019	1	0	\N
37654	1683	292322008999541	3885	2019	2	0	\N
37655	1683	292322018999541	3884	2018	3	0	\N
37657	1683	292756024149541	13575	6981	3	0	\N
37658	1683	292756024149541	13598	6992	3	0	\N
37660	1683	292756036149541	13575	6981	4	0	\N
37661	1683	292756036149541	13598	6992	4	0	\N
37671	1683	296642038999541	3976	2065	1	0	\N
37555	1683	267841848999541	3565	1850	0	0	0
37563	1683	269281848999541	3581	1859	0	0	0
37572	1683	270721848999541	3586	1863	0	0	0
37575	1683	272161848999541	3591	1866	0	0	0
37581	1683	273601848999541	3666	1903	1	0	0
37592	1683	275041858999541	3697	1920	1	0	0
37593	1683	275041868999541	3697	1920	2	0	0
37596	1683	276481868999541	3700	1921	1	0	0
37597	1683	276481878999541	3700	1921	2	0	0
37601	1683	277921878999541	3729	1935	1	0	0
37606	1683	279361888999541	3732	1936	1	0	0
37607	1683	279361898999541	3732	1936	2	0	0
37611	1683	280801898999541	3741	1940	1	0	0
37612	1683	280801908999541	3741	1940	2	0	0
37618	1683	282241918999541	3762	1952	2	0	0
37622	1683	283681918999541	3778	1958	1	0	0
37624	1683	283681928999541	3778	1958	2	0	0
37627	1683	285121928999541	3808	1974	1	0	0
37628	1683	285121938999541	3808	1974	2	0	0
37632	1683	286561948999541	3817	1978	2	0	0
37636	1683	288001948999541	3824	1983	2	0	0
37638	1683	288001968999541	3824	1983	3	0	0
37642	1683	289441968999541	3867	2008	2	0	0
37644	1683	289441988999541	3867	2008	3	0	0
37648	1683	290881998999541	3881	2016	2	0	0
37653	1683	292321998999541	3895	2022	2	0	0
37656	1683	292322018999541	3895	2022	3	0	0
37663	1683	293762018999541	3928	2037	1	0	0
37667	1683	295202028999541	3936	2042	1	0	0
37668	1683	295202038999541	3936	2042	2	0	0
37672	1683	296642038999541	3979	2067	1	0	0
37540	1683	265395588149541	13122	6764	3	0	1
37541	1683	265395600149541	13122	6764	4	0	1
37551	1683	266835612149541	13202	6803	4	0	1
37557	1683	268275612149541	13267	6834	3	0	1
37559	1683	268275633149541	13267	6834	4	0	1
37566	1683	269715633149541	13345	6878	3	0	1
37567	1683	269715636149541	13345	6878	4	0	1
37574	1683	271155649149541	13346	6879	5	0	1
37576	1683	272595649149541	13376	6892	4	0	1
37577	1683	272595662149541	13376	6892	5	0	1
37585	1683	274035662149541	13400	6904	7	0	1
37589	1683	274035710149541	13414	6910	5	0	1
37595	1683	275475710149541	13414	6910	6	0	1
37598	1683	276915710149541	13432	6921	12	0	1
37599	1683	276915749149541	13432	6921	13	0	1
37604	1683	278355749149541	13441	6925	15	0	1
37608	1683	279795800149541	13464	6936	3	0	1
37609	1683	279795812149541	13464	6936	4	0	1
37610	1683	279795845149541	13486	6945	6	0	1
37615	1683	281235845149541	13486	6945	12	0	1
37616	1683	281235868149541	13486	6945	13	0	1
37620	1683	282675880149541	13505	6953	4	0	1
37625	1683	284115880149541	13512	6957	3	0	1
37626	1683	284115892149541	13512	6957	4	0	1
37629	1683	285555892149541	13513	6958	6	0	1
37633	1683	286995916149541	13524	6963	4	0	1
37634	1683	286995938149541	13524	6963	5	0	1
37639	1683	288435938149541	13531	6966	3	0	1
37640	1683	288435950149541	13531	6966	4	0	1
37645	1683	289875950149541	13564	6977	3	0	1
37649	1683	291315962149541	13565	6978	8	0	1
37650	1683	291316024149541	13565	6978	9	0	1
37659	1683	292756024149541	13613	6999	4	0	1
37662	1683	292756037149541	13613	6999	5	0	1
37665	1683	294196037149541	13615	7000	4	0	1
37669	1683	295636050149541	13632	7008	3	0	1
37670	1683	295636062149541	13632	7008	4	0	1
37673	1683	296642048999541	3976	2065	2	0	\N
37677	1683	298082048999541	3987	2071	1	0	\N
37678	1683	298082048999541	3995	2074	1	0	\N
37679	1683	298082048999541	3999	2076	1	0	\N
37681	1683	298082058999541	3987	2071	2	0	\N
37682	1683	298082058999541	3995	2074	2	0	\N
37683	1683	298082058999541	3999	2076	2	0	\N
37685	1683	298516075149541	13646	7014	3	0	\N
37686	1683	298516075149541	13659	7021	14	0	\N
37688	1683	298516087149541	13646	7014	4	0	\N
37690	1683	298516134149541	13659	7021	15	0	\N
37697	1683	301396131149541	13709	7046	4	0	\N
37699	1683	301396144149541	13709	7046	5	0	\N
37701	1683	302402088999541	4030	2093	1	0	\N
37702	1683	302402088999541	4044	2100	1	0	\N
37703	1683	302402088999541	4062	2111	3	0	\N
37705	1683	302402098999541	4030	2093	2	0	\N
37706	1683	302402098999541	4044	2100	2	0	\N
37708	1683	302402118999541	4062	2111	4	0	\N
37711	1683	302836169149541	13736	7060	3	0	\N
37712	1683	303842098999541	4101	2132	1	0	\N
37713	1683	303842098999541	4102	2133	2	0	\N
37715	1683	303842108999541	4101	2132	2	0	\N
37717	1683	303842208999541	4102	2133	3	0	\N
37718	1683	304276157149541	13732	7059	4	0	\N
37719	1683	304276157149541	13743	7062	20	0	\N
37721	1683	304276169149541	13736	7060	4	0	\N
37722	1683	304276170149541	13732	7059	5	0	\N
37724	1683	304276222149541	13743	7062	21	0	\N
37733	1683	308162139999541	4140	2154	2	0	\N
37734	1683	308162139999541	4166	2166	2	0	\N
37737	1683	308162159999541	4140	2154	3	0	\N
37738	1683	308162249999541	4166	2166	3	0	\N
37739	1683	308596222149541	13773	7076	4	0	\N
37740	1683	308596222149541	13776	7078	16	0	\N
37742	1683	308596235149541	13773	7076	5	0	\N
37744	1683	308596274149541	13776	7078	17	0	\N
37751	1683	311476245149541	13824	7098	3	0	\N
37754	1683	311476275149541	13824	7098	4	0	\N
37761	1683	314356277149541	13876	7122	8	0	\N
37764	1683	314356303149541	13876	7122	9	0	\N
37767	1683	315796290149541	13918	7136	0	0	\N
37773	1683	317236319149541	13959	7154	11	0	\N
37774	1683	317236319149541	13969	7159	12	0	\N
37775	1683	317236319149541	13978	7162	12	0	\N
37778	1683	317236348149541	13959	7154	12	0	\N
37779	1683	317236358149541	13969	7159	13	0	\N
37780	1683	317236358149541	13978	7162	13	0	\N
37787	1683	320116372149541	13998	7172	4	0	\N
37788	1683	320116372149541	14015	7183	5	0	\N
37789	1683	320116372149541	14040	7191	8	0	\N
37791	1683	320116385149541	13998	7172	5	0	\N
37793	1683	320116386149541	14015	7183	6	0	\N
37794	1683	320116398149541	14040	7191	9	0	\N
37799	1683	322563029999541	4316	2238	1	0	\N
37800	1683	322563029999541	4320	2239	1	0	\N
37801	1683	322563029999541	4329	2243	1	0	\N
37802	1683	322563029999541	4353	2255	1	0	\N
37804	1683	322563039999541	4316	2238	2	0	\N
37805	1683	322563039999541	4320	2239	2	0	\N
37806	1683	322563039999541	4329	2243	2	0	\N
37807	1683	322563039999541	4353	2255	2	0	\N
37684	1683	298082068999541	4006	2079	3	0	0
37691	1683	299522068999541	4007	2080	1	0	0
37692	1683	299522078999541	4007	2080	2	0	0
37695	1683	300962078999541	4025	2090	1	0	0
37696	1683	300962088999541	4025	2090	2	0	0
37707	1683	302402098999541	4066	2113	2	0	0
37714	1683	303842098999541	4109	2136	2	0	0
37716	1683	303842109999541	4109	2136	3	0	0
37725	1683	305282109999541	4122	2143	2	0	0
37726	1683	305282129999541	4122	2143	3	0	0
37730	1683	306722139999541	4132	2150	2	0	0
37735	1683	308162139999541	4169	2169	1	0	0
37736	1683	308162149999541	4169	2169	2	0	0
37745	1683	309602149999541	4176	2174	3	0	0
37747	1683	309602399999541	4188	2180	4	0	0
37750	1683	311042399999541	4188	2180	5	0	0
37755	1683	312482399999541	4221	2193	1	0	0
37756	1683	312482409999541	4221	2193	2	0	0
37759	1683	313922409999541	4227	2196	9	0	0
37765	1683	315362859999541	4250	2205	2	0	0
37766	1683	315362879999541	4250	2205	3	0	0
37771	1683	316802879999541	4266	2212	1	0	0
37772	1683	316802889999541	4266	2212	2	0	0
37781	1683	318242889999541	4278	2218	2	0	0
37785	1683	319682909999541	4292	2226	1	0	0
37786	1683	319682919999541	4292	2226	2	0	0
37795	1683	321122919999541	4305	2232	2	0	0
37796	1683	321123029999541	4305	2232	3	0	0
37808	1683	322563039999541	4358	2259	2	0	0
37675	1683	297076062149541	13641	7012	4	0	1
37676	1683	297076075149541	13641	7012	5	0	1
37687	1683	298516075149541	13683	7031	7	0	1
37689	1683	298516118149541	13683	7031	8	0	1
37694	1683	299956131149541	13708	7045	5	0	1
37698	1683	301396131149541	13722	7052	4	0	1
37700	1683	301396144149541	13722	7052	5	0	1
37709	1683	302836144149541	13730	7057	4	0	1
37710	1683	302836157149541	13730	7057	5	0	1
37723	1683	304276170149541	13746	7063	5	0	1
37727	1683	305716170149541	13757	7069	8	0	1
37728	1683	305716196149541	13757	7069	9	0	1
37731	1683	307156196149541	13768	7074	8	0	1
37741	1683	308596222149541	13799	7086	4	0	1
37743	1683	308596235149541	13799	7086	5	0	1
37748	1683	310036235149541	13819	7095	1	0	1
37749	1683	310036245149541	13819	7095	2	0	1
37752	1683	311476245149541	13828	7100	1	0	1
37757	1683	312916255149541	13847	7107	13	0	1
37758	1683	312916277149541	13847	7107	14	0	1
37762	1683	314356277149541	13906	7132	4	0	1
37763	1683	314356290149541	13906	7132	5	0	1
37768	1683	315796290149541	13920	7137	11	0	1
37770	1683	315796344149541	13989	7168	7	0	1
37776	1683	317236344149541	13989	7168	9	0	1
37777	1683	317236345149541	13989	7168	10	0	1
37783	1683	318676345149541	13996	7171	9	0	1
37790	1683	320116372149541	14073	7201	4	0	1
37792	1683	320116385149541	14073	7201	5	0	1
37797	1683	321556385149541	14077	7203	8	0	1
37798	1683	321556411149541	14077	7203	9	0	1
37809	1683	322996411149541	14086	7205	9	0	\N
37810	1683	322996411149541	14098	7208	9	0	\N
37813	1683	322996429149541	14098	7208	10	0	\N
37814	1683	322996447149541	14086	7205	10	0	\N
37817	1683	324436424149541	14129	7214	34	0	\N
37820	1683	324436530149541	14129	7214	35	0	\N
37825	1683	325876530149541	14137	7215	15	0	\N
37826	1683	325876581149541	14137	7215	16	0	\N
37827	1683	326883059999541	4381	2273	1	0	\N
37828	1683	326883059999541	4401	2281	10	0	\N
37830	1683	326883069999541	4381	2273	2	0	\N
37831	1683	326883159999541	4401	2281	11	0	\N
37835	1683	328323159999541	4411	2287	10	0	\N
37836	1683	328323159999541	4427	2296	1	0	\N
37837	1683	328323159999541	4438	2300	2	0	\N
37838	1683	328323159999541	4440	2302	1	0	\N
37839	1683	328323159999541	4456	2309	1	0	\N
37841	1683	328323169999541	4427	2296	2	0	\N
37842	1683	328323169999541	4440	2302	2	0	\N
37843	1683	328323169999541	4456	2309	2	0	\N
37845	1683	328323179999541	4438	2300	3	0	\N
37846	1683	328323259999541	4411	2287	11	0	\N
37849	1683	329763169999541	4492	2327	3	0	\N
37851	1683	329763199999541	4492	2327	4	0	\N
37853	1683	330196477149541	14217	7257	4	0	\N
37855	1683	330196490149541	14217	7257	5	0	\N
37861	1683	332643229999541	4515	2336	1	0	\N
37863	1683	332643239999541	4515	2336	2	0	\N
37865	1683	333076528149541	14235	7267	4	0	\N
37868	1683	333076541149541	14235	7267	5	0	\N
37878	1683	336963369999541	4581	2370	1	0	\N
37879	1683	336963369999541	4586	2372	5	0	\N
37881	1683	336963379999541	4581	2370	2	0	\N
37883	1683	336963509999541	4586	2372	6	0	\N
37888	1683	338836578149541	14318	7305	3	0	\N
37890	1683	338836590149541	14318	7305	4	0	\N
37892	1683	339843399999541	4612	2388	1	0	\N
37894	1683	339843409999541	4612	2388	2	0	\N
37896	1683	340276591149541	14340	7320	4	0	\N
37898	1683	340276604149541	14340	7320	5	0	\N
37900	1683	341283409999541	4631	2396	1	0	\N
37901	1683	341283409999541	4636	2397	1	0	\N
37902	1683	341283409999541	4646	2401	1	0	\N
37903	1683	341283409999541	4685	2422	1	0	\N
37905	1683	341283419999541	4631	2396	2	0	\N
37906	1683	341283419999541	4636	2397	2	0	\N
37907	1683	341283419999541	4646	2401	2	0	\N
37908	1683	341283419999541	4685	2422	2	0	\N
37914	1683	344163429999541	4717	2439	1	0	\N
37915	1683	344163429999541	4728	2445	2	0	\N
37917	1683	344163439999541	4717	2439	2	0	\N
37918	1683	344163449999541	4728	2445	3	0	\N
37920	1683	345603449999541	4761	2460	1	0	\N
37921	1683	345603449999541	4765	2462	1	0	\N
37922	1683	345603449999541	4785	2474	1	0	\N
37924	1683	345603459999541	4761	2460	2	0	\N
37925	1683	345603459999541	4765	2462	2	0	\N
37926	1683	345603459999541	4785	2474	2	0	\N
37930	1683	348483479999541	4805	2487	1	0	\N
37932	1683	348483489999541	4805	2487	2	0	\N
37938	1683	352803599999541	5232	2517	0	0	\N
37944	1683	357123629999541	4879	2528	3	0	\N
37821	1683	325443049999541	4366	2264	1	0	0
37822	1683	325443059999541	4366	2264	2	0	0
37829	1683	326883059999541	4410	2286	10	0	0
37832	1683	326883159999541	4410	2286	11	0	0
37840	1683	328323159999541	4470	2316	1	0	0
37850	1683	329763169999541	4500	2329	4	0	0
37852	1683	329763209999541	4500	2329	5	0	0
37857	1683	331203209999541	4502	2331	2	0	0
37858	1683	331203229999541	4502	2331	3	0	0
37862	1683	332643229999541	4538	2346	1	0	0
37869	1683	334083239999541	4567	2362	2	0	0
37870	1683	334083349999541	4567	2362	3	0	0
37874	1683	335523349999541	4572	2365	2	0	0
37875	1683	335523369999541	4572	2365	3	0	0
37882	1683	336963379999541	4602	2382	2	0	0
37886	1683	338403379999541	4609	2386	2	0	0
37887	1683	338403399999541	4609	2386	3	0	0
37893	1683	339843399999541	4629	2395	1	0	0
37895	1683	339843409999541	4629	2395	2	0	0
37909	1683	341283419999541	4702	2431	2	0	0
37912	1683	342723419999541	4708	2433	1	0	0
37913	1683	342723429999541	4708	2433	2	0	0
37916	1683	344163429999541	4743	2453	2	0	0
37919	1683	344163449999541	4743	2453	3	0	0
37927	1683	345603469999541	4790	2477	3	0	0
37928	1683	347043469999541	4796	2482	1	0	0
37929	1683	347043479999541	4796	2482	2	0	0
37931	1683	348483479999541	4828	2501	0	0	0
37934	1683	349923489999541	4841	2508	2	0	0
37935	1683	351363489999541	4851	2514	2	0	0
37936	1683	351363599999541	4851	2514	3	0	0
37937	1683	352803599999541	4866	2520	1	0	0
37939	1683	352803609999541	4866	2520	2	0	0
37941	1683	354243619999541	4875	2524	2	0	0
37942	1683	355683619999541	4877	2526	1	0	0
37943	1683	355683629999541	4877	2526	2	0	0
37811	1683	322996411149541	14104	7211	4	0	1
37812	1683	322996424149541	14104	7211	5	0	1
37819	1683	324436434149541	14187	7240	2	0	1
37823	1683	325876434149541	14201	7247	1	0	1
37824	1683	325876444149541	14201	7247	2	0	1
37833	1683	327316444149541	14203	7249	2	0	1
37847	1683	328756464149541	14210	7253	4	0	1
37848	1683	328756477149541	14210	7253	5	0	1
37854	1683	330196477149541	14218	7258	11	0	1
37856	1683	330196515149541	14218	7258	12	0	1
37859	1683	331636515149541	14232	7266	4	0	1
37866	1683	333076528149541	14275	7287	3	0	1
37867	1683	333076540149541	14275	7287	4	0	1
37871	1683	334516540149541	14286	7292	4	0	1
37872	1683	334516553149541	14286	7292	5	0	1
37873	1683	334516563149541	14294	7294	1	0	1
37877	1683	335956566149541	14294	7294	6	0	1
37884	1683	337396566149541	14309	7302	3	0	1
37885	1683	337396578149541	14309	7302	4	0	1
37889	1683	338836578149541	14331	7313	4	0	1
37897	1683	340276591149541	14354	7327	4	0	1
37899	1683	340276604149541	14354	7327	5	0	1
37910	1683	341716604149541	14358	7330	4	0	1
37911	1683	341716617149541	14358	7330	5	0	1
37946	1683	357123629999541	5233	2530	0	0	\N
37948	1683	357123659999541	4879	2528	4	0	\N
37949	1683	358563639999541	4912	2542	1	0	\N
37951	1683	358563639999541	5234	2542	0	0	\N
37952	1683	358563639999541	5235	2556	0	0	\N
37953	1683	358563649999541	4912	2542	2	0	\N
37957	1683	361443659999541	4969	2577	2	0	\N
37958	1683	361443659999541	4971	2578	1	0	\N
37960	1683	361443669999541	4971	2578	2	0	\N
37961	1683	361443679999541	4969	2577	3	0	\N
37963	1683	362883769999541	4983	2583	1	0	\N
37965	1683	362883779999541	4983	2583	2	0	\N
37977	1683	371523969999541	5030	2610	1	0	\N
37978	1683	371523969999541	5042	2615	1	0	\N
37980	1683	371523979999541	5030	2610	2	0	\N
37981	1683	371523979999541	5042	2615	2	0	\N
37985	1683	374403999999541	5085	2639	2	0	\N
37988	1683	374404019999541	5085	2639	3	0	\N
37989	1683	375844009999541	5089	2641	2	0	\N
37992	1683	375844029999541	5089	2641	3	0	\N
37993	1683	377284019999541	5109	2653	1	0	\N
37995	1683	377284029999541	5109	2653	2	0	\N
37997	1683	378724039999541	5122	2657	2	0	\N
37998	1683	378724039999541	5127	2659	2	0	\N
37999	1683	378724039999541	5139	2663	2	0	\N
38001	1683	378724039999541	5236	2661	0	0	\N
38002	1683	378724039999541	5240	2672	0	0	\N
38003	1683	378724059999541	5122	2657	3	0	\N
38004	1683	378724059999541	5127	2659	3	0	\N
38006	1683	378724149999541	5139	2663	3	0	\N
38008	1683	380164059999541	5242	2682	0	0	\N
38011	1683	381604069999541	5243	2692	0	0	\N
38013	1683	383044089999541	5204	2707	1	0	\N
38015	1683	383044099999541	5204	2707	2	0	\N
38017	1683	384484109999541	5224	2716	1	0	\N
38019	1683	384484119999541	5224	2716	2	0	\N
38023	1683	387364129999541	5276	2742	2	0	\N
38024	1683	387364129999541	5280	2743	1	0	\N
38026	1683	387364139999541	5280	2743	2	0	\N
38028	1683	387364149999541	5276	2742	3	0	\N
38031	1683	388804169999541	5317	2764	1	0	\N
38033	1683	390244169999541	5317	2764	2	0	\N
38035	1683	391684169999541	5329	2767	1	0	\N
38037	1683	391684179999541	5329	2767	2	0	\N
38041	1683	394564189999541	5358	2782	1	0	\N
38042	1683	394564189999541	5365	2787	1	0	\N
38044	1683	394564199999541	5358	2782	2	0	\N
38045	1683	394564199999541	5365	2787	2	0	\N
38053	1683	403204200999541	5424	2822	0	0	\N
38060	1683	411844200999541	5478	2852	0	0	\N
38063	1683	414724200999541	5496	2859	0	0	\N
38066	1683	417604200999541	5511	2867	0	0	\N
38067	1683	417604200999541	5522	2873	0	0	\N
38071	1683	420484300999541	5544	2883	0	0	\N
38074	1683	423364300999541	5582	2904	0	0	\N
38075	1683	423364300999541	5588	2905	0	0	\N
38077	1683	424804300999541	5611	2915	0	0	\N
37950	1683	358563639999541	4936	2556	1	0	0
37954	1683	358563649999541	4936	2556	2	0	0
37955	1683	360003649999541	4964	2573	1	0	0
37956	1683	360003659999541	4964	2573	2	0	0
37959	1683	361443659999541	4974	2579	2	0	0
37964	1683	362883769999541	4984	2584	3	0	0
37966	1683	362883799999541	4984	2584	4	0	0
37967	1683	364323799999541	5007	2595	2	0	0
37968	1683	364323909999541	5007	2595	3	0	0
37969	1683	365763909999541	5012	2598	1	0	0
37971	1683	367203919999541	5014	2600	1	0	0
37972	1683	367203929999541	5014	2600	2	0	0
37973	1683	368643929999541	5019	2605	2	0	0
37974	1683	368643949999541	5019	2605	3	0	0
37976	1683	370083969999541	5021	2607	3	0	0
37979	1683	371523969999541	5056	2624	1	0	0
37982	1683	371523979999541	5056	2624	2	0	0
37983	1683	372963979999541	5076	2634	2	0	0
37984	1683	372963999999541	5076	2634	3	0	0
37987	1683	374404009999541	5088	2640	2	0	0
37990	1683	375844009999541	5092	2642	1	0	0
37991	1683	375844019999541	5092	2642	2	0	0
37994	1683	377284019999541	5121	2656	2	0	0
37996	1683	377284039999541	5121	2656	3	0	0
38005	1683	378724059999541	5157	2676	3	0	0
38007	1683	380164059999541	5171	2685	1	0	0
38009	1683	380164069999541	5171	2685	2	0	0
38010	1683	381604069999541	5200	2705	2	0	0
38014	1683	383044089999541	5221	2714	2	0	0
38016	1683	383044109999541	5221	2714	3	0	0
38018	1683	384484109999541	5247	2723	1	0	0
38020	1683	384484119999541	5247	2723	2	0	0
38021	1683	385924119999541	5248	2724	1	0	0
38025	1683	387364129999541	5285	2745	1	0	0
38027	1683	387364139999541	5285	2745	2	0	0
38029	1683	388804139999541	5288	2747	2	0	0
38030	1683	388804159999541	5288	2747	3	0	0
38032	1683	390244159999541	5326	2766	1	0	0
38036	1683	391684169999541	5342	2772	1	0	0
38038	1683	391684179999541	5342	2772	2	0	0
38039	1683	393124179999541	5345	2774	1	0	0
38040	1683	393124189999541	5345	2774	2	0	0
38046	1683	394564199999541	5368	2789	2	0	0
38047	1683	396004199999541	5379	2799	1	0	0
38048	1683	396004200999541	5379	2799	2	0	0
38049	1683	397444200999541	5385	2803	0	0	0
38050	1683	398884200999541	5391	2806	0	0	0
38052	1683	401764200999541	5411	2816	0	0	0
38054	1683	403204200999541	5428	2824	0	0	0
38055	1683	404644200999541	5435	2828	0	0	0
38056	1683	406084200999541	5437	2829	0	0	0
38057	1683	407524200999541	5438	2830	0	0	0
38059	1683	410404200999541	5454	2839	0	0	0
38061	1683	411844200999541	5487	2856	0	0	0
38062	1683	413284200999541	5494	2858	0	0	0
38064	1683	414724200999541	5502	2861	0	0	0
38068	1683	417604200999541	5526	2874	0	0	0
38069	1683	419044200999541	5539	2880	1	0	0
38070	1683	419044300999541	5539	2880	2	0	0
38072	1683	420484300999541	5569	2895	0	0	0
38073	1683	421924300999541	5579	2902	0	0	0
38078	1683	424804300999541	5628	2923	0	0	0
38079	1683	426244300999541	5633	2926	0	0	0
38080	1683	427684300999541	5634	2927	0	0	0
38086	1683	434884310999541	5753	2983	3	0	\N
38089	1683	434884340999541	5753	2983	4	0	\N
38090	1683	436324320999541	5763	2989	3	0	\N
38093	1683	436324350999541	5763	2989	4	0	\N
38094	1683	437764340999541	5811	3015	2	0	\N
38096	1683	437764360999541	5811	3015	3	0	\N
38105	1683	443524610999541	5864	3040	2	0	\N
38106	1683	443524610999541	5889	3053	0	0	\N
38109	1683	443524630999541	5864	3040	3	0	\N
38114	1683	447844650999541	5973	3099	1	0	\N
38116	1683	447844660999541	5973	3099	2	0	\N
38122	1683	452164690999541	6002	3114	1	0	\N
38124	1683	452164700999541	6002	3114	2	0	\N
38128	1683	455044710999541	6045	3141	1	0	\N
38129	1683	455044710999541	6063	3149	1	0	\N
38131	1683	455044720999541	6045	3141	2	0	\N
38132	1683	455044720999541	6063	3149	2	0	\N
38136	1683	457924750999541	6098	3165	2	0	\N
38137	1683	457924750999541	6100	3166	1	0	\N
38138	1683	457924750999541	6110	3169	1	0	\N
38139	1683	457924750999541	6114	3170	1	0	\N
38141	1683	457924760999541	6100	3166	2	0	\N
38142	1683	457924760999541	6110	3169	2	0	\N
38143	1683	457924760999541	6114	3170	2	0	\N
38145	1683	457924770999541	6098	3165	3	0	\N
38150	1683	462244880999541	6137	3182	1	0	\N
38152	1683	462244890999541	6137	3182	2	0	\N
38154	1683	463684900999541	6151	3187	1	0	\N
38156	1683	463684910999541	6151	3187	2	0	\N
38164	1683	469445190999541	6202	3210	10	0	\N
38167	1683	469445960999541	6202	3210	12	0	\N
38168	1683	470885210999541	6214	3215	4	0	\N
38170	1683	470885340999541	6214	3215	5	0	\N
38176	1683	475205450999541	6265	3245	2	0	\N
38177	1683	475205450999541	6291	3260	1	0	\N
38178	1683	475205450999541	6327	3275	1	0	\N
38180	1683	475205460999541	6291	3260	2	0	\N
38181	1683	475205460999541	6327	3275	2	0	\N
38182	1683	475205470999541	6265	3245	3	0	\N
38186	1683	478085480999541	6355	3288	3	0	\N
38189	1683	478085510999541	6355	3288	4	0	\N
38194	1683	482405530999541	6382	3307	1	0	\N
38196	1683	482405540999541	6382	3307	2	0	\N
38198	1683	483845540999541	6393	3314	2	0	\N
38199	1683	483845540999541	6403	3318	4	0	\N
38200	1683	483845540999541	6424	3326	2	0	\N
38202	1683	483845560999541	6393	3314	3	0	\N
38203	1683	483845560999541	6424	3326	3	0	\N
38205	1683	483845580999541	6403	3318	5	0	\N
38206	1683	485285560999541	6433	3330	2	0	\N
38208	1683	485285580999541	6433	3330	3	0	\N
38212	1683	488165600999541	6449	3338	2	0	\N
38213	1683	488165600999541	6489	3363	4	0	\N
38215	1683	488165620999541	6449	3338	3	0	\N
38083	1683	432004300999541	5702	2957	0	0	0
38084	1683	433444300999541	5747	2979	1	0	0
38085	1683	433444310999541	5747	2979	2	0	0
38087	1683	434884310999541	5757	2985	1	0	0
38088	1683	434884320999541	5757	2985	2	0	0
38092	1683	436324340999541	5799	3008	3	0	0
38095	1683	437764340999541	5829	3024	2	0	0
38097	1683	437764360999541	5829	3024	3	0	0
38098	1683	439204360999541	5833	3027	1	0	0
38099	1683	439204370999541	5833	3027	2	0	0
38101	1683	440644470999541	5838	3029	5	0	0
38102	1683	440644590999541	5838	3029	6	0	0
38103	1683	442084590999541	5857	3039	2	0	0
38104	1683	442084610999541	5857	3039	3	0	0
38108	1683	443524620999541	5925	3070	2	0	0
38110	1683	444964620999541	5931	3072	2	0	0
38111	1683	444964640999541	5931	3072	3	0	0
38112	1683	446404640999541	5937	3075	1	0	0
38113	1683	446404650999541	5937	3075	2	0	0
38117	1683	447844660999541	5975	3100	2	0	0
38118	1683	449284660999541	5985	3105	2	0	0
38119	1683	449284680999541	5985	3105	3	0	0
38120	1683	450724680999541	5990	3107	1	0	0
38121	1683	450724690999541	5990	3107	2	0	0
38125	1683	452164700999541	6011	3119	2	0	0
38126	1683	453604700999541	6044	3140	1	0	0
38127	1683	453604710999541	6044	3140	2	0	0
38130	1683	455044710999541	6066	3151	3	0	0
38134	1683	456484740999541	6089	3161	1	0	0
38135	1683	456484750999541	6089	3161	2	0	0
38140	1683	457924750999541	6115	3171	1	0	0
38144	1683	457924760999541	6115	3171	2	0	0
38146	1683	459364760999541	6122	3174	1	0	0
38148	1683	460804770999541	6123	3175	2	0	0
38149	1683	460804880999541	6123	3175	3	0	0
38151	1683	462244880999541	6150	3186	2	0	0
38153	1683	462244900999541	6150	3186	3	0	0
38155	1683	463684900999541	6173	3197	4	0	0
38158	1683	465124940999541	6176	3198	1	0	0
38159	1683	465124950999541	6176	3198	2	0	0
38160	1683	466564950999541	6183	3201	2	0	0
38161	1683	466564970999541	6183	3201	3	0	0
38163	1683	468005190999541	6185	3202	5	0	0
38165	1683	469445190999541	6206	3212	2	0	0
38166	1683	469445210999541	6206	3212	3	0	0
38169	1683	470885210999541	6217	3217	3	0	0
38171	1683	470885420999541	6217	3217	4	0	0
38173	1683	472325430999541	6229	3223	2	0	0
38174	1683	473765430999541	6242	3229	2	0	0
38175	1683	473765450999541	6242	3229	3	0	0
38179	1683	475205450999541	6338	3281	2	0	0
38183	1683	475205470999541	6338	3281	3	0	0
38185	1683	476645480999541	6350	3286	2	0	0
38187	1683	478085480999541	6357	3290	1	0	0
38188	1683	478085490999541	6357	3290	2	0	0
38190	1683	479525490999541	6359	3292	1	0	0
38192	1683	480965500999541	6370	3299	3	0	0
38193	1683	480965530999541	6370	3299	4	0	0
38195	1683	482405530999541	6384	3308	1	0	0
38197	1683	482405540999541	6384	3308	2	0	0
38201	1683	483845540999541	6425	3327	2	0	0
38207	1683	485285560999541	6441	3334	2	0	0
38209	1683	485285580999541	6441	3334	3	0	0
38210	1683	486725580999541	6444	3335	2	0	0
38211	1683	486725600999541	6444	3335	3	0	0
38214	1683	488165600999541	6492	3365	2	0	0
38217	1683	488165640999541	6489	3363	5	0	\N
38218	1683	489605620999541	6494	3366	2	0	\N
38220	1683	489605640999541	6494	3366	3	0	\N
38224	1683	492485680999541	6535	3387	2	0	\N
38226	1683	492485700999541	6535	3387	3	0	\N
38228	1683	493925700999541	6560	3399	2	0	\N
38230	1683	493925720999541	6560	3399	3	0	\N
38232	1683	495365740999541	6578	3405	2	0	\N
38234	1683	495365760999541	6578	3405	3	0	\N
38238	1683	498245780999541	6597	3413	4	0	\N
38240	1683	498245820999541	6597	3413	5	0	\N
38250	1683	505445900999541	6666	3445	2	0	\N
38252	1683	505445920999541	6666	3445	3	0	\N
38260	1683	511206045999541	6711	3471	2	0	\N
38261	1683	511206045999541	6735	3485	2	0	\N
38262	1683	511206045999541	6737	3486	2	0	\N
38263	1683	511206045999541	6742	3489	2	0	\N
38265	1683	511206045999541	6932	3468	0	0	\N
38266	1683	511206045999541	6933	3478	0	0	\N
38267	1683	511206045999541	6935	3489	0	0	\N
38268	1683	511206065999541	6711	3471	3	0	\N
38269	1683	511206065999541	6735	3485	3	0	\N
38270	1683	511206065999541	6737	3486	3	0	\N
38271	1683	511206065999541	6742	3489	3	0	\N
38275	1683	514086085999541	6762	3500	5	0	\N
38276	1683	514086085999541	6764	3501	3	0	\N
38278	1683	514086085999541	6936	3499	0	0	\N
38280	1683	514086205999541	6764	3501	4	0	\N
38281	1683	514086405999541	6762	3500	6	0	\N
38293	1683	522726385999541	6865	3551	5	0	\N
38296	1683	522726525999541	6865	3551	6	0	\N
38307	1683	531366515999541	6950	3587	3	0	\N
38310	1683	531366545999541	6950	3587	4	0	\N
38319	1683	538566615999541	7024	3622	4	0	\N
38322	1683	538566655999541	7024	3622	5	0	\N
38323	1683	540006635999541	7051	3640	2	0	\N
38324	1683	540006635999541	7082	3655	4	0	\N
38325	1683	540006635999541	7096	3664	2	0	\N
38327	1683	540006655999541	7051	3640	3	0	\N
38328	1683	540006655999541	7096	3664	3	0	\N
38329	1683	540006675999541	7082	3655	5	0	\N
38341	1683	548646735999541	7203	3723	2	0	\N
38342	1683	548646735999541	7219	3733	1	0	\N
38344	1683	548646745999541	7219	3733	2	0	\N
38346	1683	548646755999541	7203	3723	3	0	\N
38347	1683	550086745999541	7233	3739	1	0	\N
38348	1683	550086745999541	7253	3751	1	0	\N
38349	1683	550086745999541	7276	3762	1	0	\N
38351	1683	550086755999541	7233	3739	2	0	\N
38352	1683	550086755999541	7253	3751	2	0	\N
38222	1683	491045660999541	6507	3374	2	0	0
38223	1683	491045680999541	6507	3374	3	0	0
38225	1683	492485680999541	6548	3394	2	0	0
38227	1683	492485700999541	6548	3394	3	0	0
38229	1683	493925700999541	6572	3403	4	0	0
38233	1683	495365740999541	6590	3409	2	0	0
38235	1683	495365760999541	6590	3409	3	0	0
38236	1683	496805760999541	6592	3411	2	0	0
38237	1683	496805780999541	6592	3411	3	0	0
38239	1683	498245780999541	6603	3415	4	0	0
38242	1683	499685820999541	6616	3420	2	0	0
38243	1683	499685840999541	6616	3420	3	0	0
38244	1683	501125840999541	6618	3422	2	0	0
38245	1683	501125860999541	6618	3422	3	0	0
38247	1683	502565880999541	6636	3429	3	0	0
38248	1683	504005880999541	6643	3435	2	0	0
38249	1683	504005900999541	6643	3435	3	0	0
38251	1683	505445900999541	6677	3451	2	0	0
38253	1683	505445920999541	6677	3451	3	0	0
38255	1683	506885985999541	6687	3456	12	0	0
38256	1683	508325985999541	6696	3461	4	0	0
38257	1683	508326025999541	6696	3461	5	0	0
38258	1683	509766025999541	6705	3467	2	0	0
38259	1683	509766045999541	6705	3467	3	0	0
38272	1683	511206065999541	6746	3491	3	0	0
38273	1683	512646065999541	6756	3497	2	0	0
38274	1683	512646085999541	6756	3497	3	0	0
38277	1683	514086085999541	6769	3504	4	0	0
38282	1683	515526125999541	6777	3508	2	0	0
38283	1683	515526145999541	6777	3508	3	0	0
38284	1683	516966145999541	6798	3520	6	0	0
38285	1683	516966295999541	6798	3520	7	0	0
38286	1683	516966305999541	6820	3531	1	0	0
38288	1683	518406315999541	6820	3531	4	0	0
38289	1683	519846315999541	6844	3541	3	0	0
38290	1683	519846345999541	6844	3541	4	0	0
38291	1683	521286345999541	6862	3549	4	0	0
38292	1683	521286385999541	6862	3549	5	0	0
38295	1683	522726405999541	6867	3552	3	0	0
38297	1683	524166405999541	6877	3556	2	0	0
38298	1683	524166425999541	6877	3556	3	0	0
38299	1683	525606425999541	6890	3559	3	0	0
38301	1683	527046455999541	6891	3560	2	0	0
38302	1683	527046475999541	6891	3560	3	0	0
38303	1683	528486475999541	6914	3571	2	0	0
38304	1683	528486495999541	6914	3571	3	0	0
38305	1683	529926495999541	6924	3574	2	0	0
38308	1683	531366515999541	6969	3596	1	0	0
38309	1683	531366525999541	6969	3596	2	0	0
38311	1683	532806525999541	6971	3598	1	0	0
38312	1683	532806535999541	6971	3598	2	0	0
38313	1683	534246535999541	6987	3607	2	0	0
38315	1683	535686555999541	7015	3617	2	0	0
38316	1683	535686575999541	7015	3617	3	0	0
38317	1683	537126575999541	7016	3618	4	0	0
38318	1683	537126615999541	7016	3618	5	0	0
38321	1683	538566635999541	7034	3628	3	0	0
38326	1683	540006635999541	7115	3675	4	0	0
38330	1683	540006675999541	7115	3675	5	0	0
38331	1683	541446675999541	7152	3696	2	0	0
38332	1683	541446695999541	7152	3696	3	0	0
38334	1683	542886705999541	7163	3700	2	0	0
38335	1683	544326705999541	7165	3701	1	0	0
38336	1683	544326715999541	7165	3701	2	0	0
38337	1683	545766715999541	7180	3708	1	0	0
38338	1683	545766725999541	7180	3708	2	0	0
38340	1683	547206735999541	7187	3715	2	0	0
38343	1683	548646735999541	7226	3735	1	0	0
38345	1683	548646745999541	7226	3735	2	0	0
38350	1683	550086745999541	7284	3765	2	0	0
38353	1683	550086755999541	7276	3762	2	0	\N
38357	1683	552966785999541	7304	3774	1	0	\N
38359	1683	552966795999541	7304	3774	2	0	\N
38366	1683	555846935999541	7369	3806	7	0	\N
38367	1683	557286865999541	7363	3804	8	0	\N
38368	1683	557286865999541	7378	3809	1	0	\N
38370	1683	557286875999541	7378	3809	2	0	\N
38372	1683	557286935999541	7369	3806	8	0	\N
38373	1683	557286945999541	7363	3804	9	0	\N
38376	1683	560166895999541	7402	3825	3	0	\N
38379	1683	560166925999541	7402	3825	4	0	\N
38382	1683	563046925999541	7456	3857	1	0	\N
38383	1683	563046925999541	7460	3859	3	0	\N
38385	1683	563046935999541	7456	3857	2	0	\N
38387	1683	563046955999541	7460	3859	4	0	\N
38388	1683	564486945999541	7475	3867	2	0	\N
38390	1683	564486965999541	7475	3867	3	0	\N
38396	1683	568807016999541	7510	3888	4	0	\N
38399	1683	568807051999541	7510	3888	5	0	\N
38404	1683	573127047999541	7545	3905	2	0	\N
38407	1683	573127067999541	7545	3905	3	0	\N
38410	1683	576007077999541	7553	3912	1	0	\N
38411	1683	576007077999541	7556	3913	1	0	\N
38412	1683	576007077999541	7580	3921	1	0	\N
38414	1683	576007087999541	7553	3912	2	0	\N
38415	1683	576007087999541	7556	3913	2	0	\N
38416	1683	576007087999541	7580	3921	2	0	\N
38418	1683	577447087999541	7586	3924	4	0	\N
38419	1683	577447087999541	7588	3925	1	0	\N
38421	1683	577447097999541	7588	3925	2	0	\N
38422	1683	577447127999541	7586	3924	5	0	\N
38428	1683	581767307999541	7657	3963	1	0	\N
38430	1683	581767317999541	7657	3963	2	0	\N
38436	1683	586087367999541	7682	3978	1	0	\N
38437	1683	586087367999541	7696	3988	1	0	\N
38438	1683	586087367999541	7700	3989	1	0	\N
38439	1683	586087367999541	7715	3996	1	0	\N
38440	1683	586087367999541	7731	4005	1	0	\N
38442	1683	586087377999541	7682	3978	2	0	\N
38443	1683	586087377999541	7696	3988	2	0	\N
38444	1683	586087377999541	7700	3989	2	0	\N
38445	1683	586087377999541	7715	3996	2	0	\N
38446	1683	586087377999541	7731	4005	2	0	\N
38448	1683	587527377999541	7739	4010	0	0	\N
38453	1683	591847387999541	7775	4032	1	0	\N
38455	1683	591847397999541	7775	4032	2	0	\N
38457	1683	593287397999541	7784	4036	2	0	\N
38458	1683	593287397999541	7808	4048	1	0	\N
38459	1683	593287397999541	7821	4055	2	0	\N
38460	1683	593287397999541	7836	4062	1	0	\N
38461	1683	593287397999541	7846	4067	1	0	\N
38463	1683	593287407999541	7808	4048	2	0	\N
38464	1683	593287407999541	7836	4062	2	0	\N
38465	1683	593287407999541	7846	4067	2	0	\N
38466	1683	593287417999541	7784	4036	3	0	\N
38467	1683	593287417999541	7821	4055	3	0	\N
38471	1683	596167447999541	7854	4072	1	0	\N
38472	1683	596167447999541	7861	4076	1	0	\N
38474	1683	596167457999541	7854	4072	2	0	\N
38475	1683	596167457999541	7861	4076	2	0	\N
38477	1683	597607467999541	7883	4085	1	0	\N
38479	1683	597607477999541	7883	4085	2	0	\N
38481	1683	599047477999541	7902	4094	2	0	\N
38482	1683	599047477999541	7921	4106	2	0	\N
38483	1683	599047477999541	7948	4118	1	0	\N
38485	1683	599047487999541	7948	4118	2	0	\N
38487	1683	599047488999541	7902	4094	3	0	\N
38488	1683	599047497999541	7921	4106	3	0	\N
38356	1683	551526785999541	7294	3770	3	0	0
38358	1683	552966785999541	7307	3775	2	0	0
38360	1683	552966805999541	7307	3775	3	0	0
38361	1683	552966815999541	7338	3792	1	0	0
38362	1683	554406815999541	7338	3792	4	0	0
38364	1683	555846835999541	7342	3794	3	0	0
38365	1683	555846865999541	7342	3794	4	0	0
38369	1683	557286865999541	7387	3815	1	0	0
38371	1683	557286875999541	7387	3815	2	0	0
38374	1683	558726875999541	7396	3820	2	0	0
38377	1683	560166895999541	7422	3835	1	0	0
38378	1683	560166905999541	7422	3835	2	0	0
38380	1683	561606905999541	7441	3846	2	0	0
38381	1683	561606925999541	7441	3846	3	0	0
38386	1683	563046945999541	7474	3866	3	0	0
38389	1683	564486945999541	7481	3870	3	0	0
38391	1683	564486966999541	7481	3870	4	0	0
38392	1683	565926966999541	7487	3873	2	0	0
38393	1683	565926986999541	7487	3873	3	0	0
38395	1683	567367016999541	7498	3880	4	0	0
38397	1683	568807016999541	7531	3898	2	0	0
38398	1683	568807027999541	7531	3898	3	0	0
38400	1683	570247027999541	7536	3901	1	0	0
38401	1683	570247037999541	7536	3901	2	0	0
38403	1683	571687047999541	7542	3904	2	0	0
38405	1683	573127047999541	7550	3910	1	0	0
38406	1683	573127057999541	7550	3910	2	0	0
38408	1683	574567057999541	7552	3911	2	0	0
38413	1683	576007077999541	7583	3922	1	0	0
38417	1683	576007087999541	7583	3922	2	0	0
38420	1683	577447087999541	7601	3932	5	0	0
38423	1683	577447257999541	7601	3932	6	0	0
38424	1683	578887257999541	7623	3944	4	0	0
38426	1683	580327297999541	7645	3955	1	0	0
38427	1683	580327307999541	7645	3955	2	0	0
38429	1683	581767307999541	7664	3967	4	0	0
38431	1683	581767347999541	7664	3967	5	0	0
38432	1683	583207347999541	7671	3970	1	0	0
38434	1683	584647357999541	7678	3976	1	0	0
38435	1683	584647367999541	7678	3976	2	0	0
38441	1683	586087367999541	7732	4006	1	0	0
38447	1683	586087377999541	7732	4006	2	0	0
38450	1683	588967377999541	7766	4026	0	0	0
38451	1683	590407377999541	7770	4030	1	0	0
38452	1683	590407387999541	7770	4030	2	0	0
38454	1683	591847387999541	7778	4033	1	0	0
38456	1683	591847397999541	7778	4033	2	0	0
38468	1683	593287417999541	7849	4068	3	0	0
38469	1683	594727417999541	7852	4070	3	0	0
38470	1683	594727447999541	7852	4070	4	0	0
38473	1683	596167447999541	7869	4079	2	0	0
38476	1683	596167467999541	7869	4079	3	0	0
38480	1683	597607477999541	7888	4088	2	0	0
38484	1683	599047477999541	7953	4120	1	0	0
38486	1683	599047487999541	7953	4120	2	0	0
38491	1683	601927517999541	7963	4127	1	0	\N
38493	1683	601927527999541	7963	4127	2	0	\N
38501	1683	607687587999541	7997	4147	1	0	\N
38503	1683	607687597999541	7997	4147	2	0	\N
38505	1683	609127597999541	8039	4167	1	0	\N
38506	1683	609127597999541	8041	4168	1	0	\N
38507	1683	609127597999541	8046	4169	1	0	\N
38509	1683	609127607999541	8039	4167	2	0	\N
38510	1683	609127607999541	8041	4168	2	0	\N
38511	1683	609127607999541	8046	4169	2	0	\N
38520	1683	616327738999541	8091	4196	1	0	\N
38522	1683	616327748999541	8091	4196	2	0	\N
38524	1683	617767749999541	8103	4200	4	0	\N
38527	1683	617767870999541	8103	4200	5	0	\N
38528	1683	619207759999541	8119	4210	1	0	\N
38530	1683	619207769999541	8119	4210	2	0	\N
38532	1683	620647769999541	8133	4217	2	0	\N
38533	1683	620647769999541	8155	4228	1	0	\N
38535	1683	620647779999541	8155	4228	2	0	\N
38536	1683	620647789999541	8133	4217	3	0	\N
38544	1683	626407819999541	8198	4249	1	0	\N
38545	1683	626407819999541	8207	4255	1	0	\N
38547	1683	626407829999541	8198	4249	2	0	\N
38548	1683	626407829999541	8207	4255	2	0	\N
38559	1683	633607889999541	8250	4273	1	0	\N
38561	1683	633607899999541	8250	4273	2	0	\N
38566	1683	637927920999541	8311	4301	1	0	\N
38567	1683	637927920999541	8324	4309	2	0	\N
38568	1683	637927920999541	8326	4310	1	0	\N
38569	1683	637927920999541	8347	4324	3	0	\N
38570	1683	637927920999541	8355	4327	2	0	\N
38572	1683	637927930999541	8311	4301	2	0	\N
38573	1683	637927930999541	8326	4310	2	0	\N
38575	1683	637927940999541	8324	4309	3	0	\N
38576	1683	637927940999541	8355	4327	3	0	\N
38577	1683	637927950999541	8347	4324	4	0	\N
38580	1683	640808159999541	8394	4350	2	0	\N
38581	1683	640808159999541	8411	4359	3	0	\N
38583	1683	640808174999541	8394	4350	3	0	\N
38584	1683	640808279999541	8411	4359	4	0	\N
38587	1683	645128159999541	8444	4375	0	0	\N
38590	1683	646568169999541	8461	4383	1	0	\N
38592	1683	646568179999541	8461	4383	2	0	\N
38598	1683	650888199999541	8515	4412	1	0	\N
38599	1683	650888199999541	8532	4420	1	0	\N
38600	1683	650888199999541	8538	4424	1	0	\N
38602	1683	650888209999541	8515	4412	2	0	\N
38603	1683	650888209999541	8532	4420	2	0	\N
38604	1683	650888209999541	8538	4424	2	0	\N
38606	1683	652328219999541	8549	4429	1	0	\N
38608	1683	652328229999541	8549	4429	2	0	\N
38612	1683	655208249999541	8572	4443	2	0	\N
38614	1683	655208269999541	8572	4443	3	0	\N
38620	1683	659528289999541	8596	4457	1	0	\N
38622	1683	659528299999541	8596	4457	2	0	\N
38624	1683	660968329999541	8612	4465	2	0	\N
38492	1683	601927517999541	7974	4132	2	0	0
38494	1683	601927537999541	7974	4132	3	0	0
38495	1683	603367537999541	7991	4143	1	0	0
38496	1683	603367547999541	7991	4143	2	0	0
38497	1683	604807547999541	7993	4145	2	0	0
38499	1683	606247567999541	7995	4146	2	0	0
38500	1683	606247587999541	7995	4146	3	0	0
38502	1683	607687587999541	8019	4157	1	0	0
38504	1683	607687597999541	8019	4157	2	0	0
38508	1683	609127597999541	8049	4170	1	0	0
38513	1683	610567607999541	8062	4178	2	0	0
38514	1683	610567717999541	8062	4178	3	0	0
38515	1683	612007717999541	8064	4179	1	0	0
38516	1683	612007727999541	8064	4179	2	0	0
38518	1683	613447738999541	8065	4180	3	0	0
38519	1683	614887738999541	8068	4181	0	0	0
38521	1683	616327738999541	8095	4197	2	0	0
38523	1683	616327749999541	8095	4197	3	0	0
38525	1683	617767749999541	8108	4203	1	0	0
38529	1683	619207759999541	8125	4213	1	0	0
38531	1683	619207769999541	8125	4213	2	0	0
38534	1683	620647769999541	8163	4231	2	0	0
38537	1683	620647789999541	8163	4231	3	0	0
38538	1683	622087789999541	8174	4235	1	0	0
38540	1683	623527799999541	8184	4241	1	0	0
38541	1683	623527809999541	8184	4241	2	0	0
38542	1683	624967809999541	8187	4243	1	0	0
38543	1683	624967819999541	8187	4243	2	0	0
38549	1683	626407829999541	8215	4259	2	0	0
38550	1683	627847829999541	8222	4262	1	0	0
38551	1683	627847839999541	8222	4262	2	0	0
38552	1683	629287839999541	8229	4265	1	0	0
38553	1683	629287849999541	8229	4265	2	0	0
38555	1683	630727869999541	8243	4270	4	0	0
38556	1683	630727879999541	8243	4270	5	0	0
38557	1683	632167879999541	8247	4271	1	0	0
38558	1683	632167889999541	8247	4271	2	0	0
38560	1683	633607889999541	8257	4275	0	0	0
38563	1683	635047910999541	8266	4281	4	0	0
38564	1683	636487910999541	8276	4287	1	0	0
38565	1683	636487920999541	8276	4287	2	0	0
38571	1683	637927920999541	8362	4332	1	0	0
38578	1683	639367930999541	8376	4342	4	0	0
38579	1683	639368159999541	8376	4342	5	0	0
38582	1683	640808159999541	8425	4365	0	0	0
38585	1683	642248159999541	8426	4366	0	0	0
38586	1683	643688159999541	8432	4370	0	0	0
38589	1683	645128169999541	8453	4380	2	0	0
38591	1683	646568169999541	8493	4399	1	0	0
38593	1683	646568179999541	8493	4399	2	0	0
38594	1683	648008179999541	8507	4407	1	0	0
38595	1683	648008189999541	8507	4407	2	0	0
38597	1683	649448199999541	8510	4408	2	0	0
38601	1683	650888199999541	8547	4428	2	0	0
38605	1683	650888219999541	8547	4428	3	0	0
38607	1683	652328219999541	8560	4436	1	0	0
38610	1683	653768229999541	8564	4439	2	0	0
38611	1683	653768249999541	8564	4439	3	0	0
38613	1683	655208249999541	8576	4445	2	0	0
38615	1683	655208269999541	8576	4445	3	0	0
38616	1683	656648269999541	8579	4448	1	0	0
38618	1683	658088279999541	8591	4455	1	0	0
38619	1683	658088289999541	8591	4455	2	0	0
38621	1683	659528289999541	8607	4462	4	0	0
38623	1683	659528329999541	8607	4462	5	0	0
38626	1683	660968349999541	8612	4465	3	0	\N
38628	1683	662408349999541	8651	4482	1	0	\N
38630	1683	662408359999541	8651	4482	2	0	\N
38634	1683	665288379999541	8721	4523	4	0	\N
38637	1683	665288419999541	8721	4523	5	0	\N
38644	1683	671048479999541	8742	4536	2	0	\N
38646	1683	671048499999541	8742	4536	3	0	\N
38648	1683	672488499999541	8753	4542	2	0	\N
38649	1683	672488499999541	8758	4545	2	0	\N
38650	1683	672488499999541	8765	4547	2	0	\N
38652	1683	672488519999541	8753	4542	3	0	\N
38653	1683	672488519999541	8758	4545	3	0	\N
38654	1683	672488519999541	8765	4547	3	0	\N
38662	1683	678248569999541	8812	4569	2	0	\N
38664	1683	678248589999541	8812	4569	3	0	\N
38676	1683	686888719999541	8887	4606	2	0	\N
38678	1683	686888739999541	8887	4606	3	0	\N
38686	1683	692648880999541	8926	4627	2	0	\N
38688	1683	692648900999541	8926	4627	3	0	\N
38698	1683	699850140999541	8969	4652	5	0	\N
38699	1683	699850140999541	8984	4660	2	0	\N
38700	1683	699850140999541	8998	4665	6	0	\N
38701	1683	699850140999541	9015	4674	2	0	\N
38703	1683	699850160999541	8984	4660	3	0	\N
38704	1683	699850160999541	9015	4674	3	0	\N
38706	1683	699850185999541	8969	4652	6	0	\N
38707	1683	699850200999541	8998	4665	7	0	\N
38708	1683	701290181999541	9046	4690	4	0	\N
38710	1683	701290221999541	9046	4690	5	0	\N
38714	1683	704170341999541	9078	4709	2	0	\N
38716	1683	704170361999541	9078	4709	3	0	\N
38720	1683	707050473999541	9117	4724	4	0	\N
38722	1683	707050513999541	9117	4724	5	0	\N
38728	1683	711370573999541	9160	4746	2	0	\N
38730	1683	711370593999541	9160	4746	3	0	\N
38732	1683	712810593999541	9177	4756	2	0	\N
38734	1683	712810613999541	9177	4756	3	0	\N
38740	1683	717130703999541	9216	4779	6	0	\N
38741	1683	717130703999541	9220	4781	2	0	\N
38742	1683	717130703999541	9224	4782	2	0	\N
38743	1683	717130703999541	9236	4788	2	0	\N
38745	1683	717130723999541	9220	4781	3	0	\N
38746	1683	717130723999541	9224	4782	3	0	\N
38747	1683	717130723999541	9236	4788	3	0	\N
38749	1683	717130763999541	9216	4779	7	0	\N
38750	1683	718570723999541	9243	4794	3	0	\N
38752	1683	718570753999541	9243	4794	4	0	\N
38757	1683	721451043999541	9263	4804	15	0	\N
38760	1683	721451193999541	9263	4804	16	0	\N
38629	1683	662408349999541	8653	4483	2	0	0
38631	1683	662408369999541	8653	4483	3	0	0
38632	1683	663848369999541	8689	4503	1	0	0
38633	1683	663848379999541	8689	4503	2	0	0
38635	1683	665288379999541	8726	4525	2	0	0
38638	1683	666728399999541	8734	4529	2	0	0
38639	1683	666728419999541	8734	4529	3	0	0
38640	1683	668168419999541	8737	4532	2	0	0
38641	1683	668168439999541	8737	4532	3	0	0
38642	1683	669608439999541	8738	4533	4	0	0
38645	1683	671048479999541	8747	4539	2	0	0
38647	1683	671048499999541	8747	4539	3	0	0
38651	1683	672488499999541	8769	4548	2	0	0
38655	1683	672488519999541	8769	4548	3	0	0
38657	1683	673928539999541	8771	4549	3	0	0
38658	1683	675368539999541	8774	4551	2	0	0
38659	1683	675368559999541	8774	4551	3	0	0
38660	1683	676808559999541	8800	4562	1	0	0
38661	1683	676808569999541	8800	4562	2	0	0
38665	1683	678248599999541	8819	4572	4	0	0
38666	1683	679688599999541	8822	4574	4	0	0
38667	1683	679688639999541	8822	4574	5	0	0
38668	1683	681128639999541	8853	4587	2	0	0
38669	1683	681128659999541	8853	4587	3	0	0
38671	1683	682568679999541	8859	4591	3	0	0
38672	1683	684008679999541	8863	4593	2	0	0
38673	1683	684008699999541	8863	4593	3	0	0
38674	1683	685448699999541	8885	4604	2	0	0
38677	1683	686888719999541	8905	4612	2	0	0
38679	1683	686888739999541	8905	4612	3	0	0
38680	1683	688328739999541	8907	4614	4	0	0
38681	1683	688328779999541	8907	4614	5	0	0
38682	1683	689768779999541	8910	4616	6	0	0
38684	1683	691208839999541	8921	4623	5	0	0
38685	1683	691208880999541	8921	4623	6	0	0
38687	1683	692648880999541	8931	4630	4	0	0
38689	1683	692648920999541	8931	4630	5	0	0
38690	1683	694088920999541	8947	4640	5	0	0
38692	1683	695529060999541	8951	4642	3	0	0
38693	1683	695530080999541	8951	4642	4	0	0
38694	1683	696970080999541	8952	4643	2	0	0
38695	1683	696970100999541	8952	4643	3	0	0
38697	1683	698410140999541	8964	4649	5	0	0
38702	1683	699850140999541	9044	4689	5	0	0
38705	1683	699850181999541	9044	4689	6	0	0
38709	1683	701290181999541	9072	4704	5	0	0
38711	1683	701290321999541	9072	4704	6	0	0
38713	1683	702730341999541	9074	4706	3	0	0
38715	1683	704170341999541	9090	4713	11	0	0
38717	1683	704170433999541	9090	4713	12	0	0
38718	1683	705610433999541	9112	4722	4	0	0
38719	1683	705610473999541	9112	4722	5	0	0
38723	1683	707050513999541	9129	4728	5	0	0
38724	1683	708490513999541	9132	4730	2	0	0
38725	1683	708490533999541	9132	4730	3	0	0
38726	1683	709930533999541	9148	4739	4	0	0
38729	1683	711370573999541	9164	4749	2	0	0
38731	1683	711370593999541	9164	4749	3	0	0
38733	1683	712810593999541	9183	4759	2	0	0
38735	1683	712810613999541	9183	4759	3	0	0
38736	1683	714250613999541	9193	4764	3	0	0
38738	1683	715690643999541	9194	4765	6	0	0
38739	1683	715690703999541	9194	4765	7	0	0
38744	1683	717130703999541	9240	4792	2	0	0
38748	1683	717130723999541	9240	4792	3	0	0
38751	1683	718570723999541	9248	4797	8	0	0
38754	1683	718570863999541	9251	4799	6	0	0
38755	1683	720010863999541	9251	4799	25	0	0
38756	1683	720011043999541	9251	4799	26	0	0
38758	1683	721451043999541	9286	4815	3	0	0
38771	1683	728651273999541	9380	4866	3	0	\N
38772	1683	730091243999541	9353	4853	2	0	\N
38773	1683	730091243999541	9368	4859	2	0	\N
38775	1683	730091263999541	9353	4853	3	0	\N
38776	1683	730091263999541	9368	4859	3	0	\N
38777	1683	730091273999541	9380	4866	5	0	\N
38778	1683	730091283999541	9380	4866	6	0	\N
38798	1683	744491703999541	9497	4926	2	0	\N
38800	1683	744491723999541	9497	4926	3	0	\N
38802	1683	745931733999541	9516	4934	2	0	\N
38804	1683	745931753999541	9516	4934	3	0	\N
38806	1683	747371853999541	9563	4959	4	0	\N
38808	1683	747371893999541	9563	4959	5	0	\N
38822	1683	757452153999541	9659	5013	2	0	\N
38824	1683	757452173999541	9659	5013	3	0	\N
38826	1683	758892173999541	9673	5020	5	0	\N
38827	1683	758892173999541	9685	5024	2	0	\N
38828	1683	758892173999541	9693	5029	1	0	\N
38830	1683	758892183999541	9693	5029	2	0	\N
38831	1683	758892193999541	9685	5024	3	0	\N
38833	1683	758892214999541	9673	5020	6	0	\N
38836	1683	761772323999541	9735	5043	13	0	\N
38839	1683	761772444999541	9735	5043	14	0	\N
38844	1683	766092445999541	9758	5056	2	0	\N
38845	1683	766092445999541	9773	5064	2	0	\N
38847	1683	766092465999541	9758	5056	3	0	\N
38848	1683	766092465999541	9773	5064	3	0	\N
38854	1683	768972622999541	9822	5090	9	0	\N
38855	1683	770412595999541	9818	5089	12	0	\N
38858	1683	770412622999541	9822	5090	11	0	\N
38859	1683	770412623999541	9822	5090	12	0	\N
38860	1683	770412625999541	9818	5089	13	0	\N
38871	1683	779052735999541	9899	5132	2	0	\N
38872	1683	779052735999541	9912	5141	4	0	\N
38875	1683	779052755999541	9899	5132	3	0	\N
38876	1683	779052775999541	9912	5141	5	0	\N
38877	1683	780492745999541	9924	5151	2	0	\N
38878	1683	780492745999541	9934	5156	4	0	\N
38879	1683	780492745999541	9940	5159	2	0	\N
38880	1683	780492745999541	9965	5171	7	0	\N
38881	1683	780492745999541	9971	5172	4	0	\N
38883	1683	780492765999541	9924	5151	3	0	\N
38884	1683	780492765999541	9940	5159	3	0	\N
38886	1683	780492785999541	9934	5156	5	0	\N
38887	1683	780492785999541	9971	5172	5	0	\N
38888	1683	780492806999541	9965	5171	8	0	\N
38889	1683	781932765999541	10011	5190	3	0	\N
38891	1683	781932795999541	10011	5190	4	0	\N
38895	1683	784812846999541	10043	5210	2	0	\N
38896	1683	784812846999541	10049	5211	2	0	\N
38763	1683	724331133999541	9336	4844	5	0	0
38764	1683	724331183999541	9336	4844	6	0	0
38765	1683	725771183999541	9337	4845	2	0	0
38766	1683	725771203999541	9337	4845	3	0	0
38767	1683	727211203999541	9347	4850	2	0	0
38769	1683	728651223999541	9350	4852	2	0	0
38770	1683	728651243999541	9350	4852	3	0	0
38774	1683	730091243999541	9389	4870	4	0	0
38779	1683	730091283999541	9389	4870	5	0	0
38780	1683	731531283999541	9407	4881	2	0	0
38782	1683	732971303999541	9409	4883	8	0	0
38783	1683	732971383999541	9409	4883	9	0	0
38784	1683	734411383999541	9425	4890	4	0	0
38785	1683	734411423999541	9425	4890	5	0	0
38787	1683	735851443999541	9442	4897	3	0	0
38788	1683	737291443999541	9461	4905	2	0	0
38789	1683	737291463999541	9461	4905	3	0	0
38790	1683	738731463999541	9466	4908	4	0	0
38791	1683	738731503999541	9466	4908	5	0	0
38793	1683	740171523999541	9477	4914	3	0	0
38794	1683	741611523999541	9482	4917	2	0	0
38795	1683	741611543999541	9482	4917	3	0	0
38796	1683	743051543999541	9485	4918	7	0	0
38797	1683	743051703999541	9485	4918	8	0	0
38801	1683	744491733999541	9511	4932	4	0	0
38803	1683	745931733999541	9537	4945	3	0	0
38805	1683	745931853999541	9537	4945	4	0	0
38807	1683	747371853999541	9571	4963	3	0	0
38810	1683	748811973999541	9573	4964	2	0	0
38811	1683	748811993999541	9573	4964	3	0	0
38812	1683	750251993999541	9579	4969	3	0	0
38813	1683	750252023999541	9579	4969	4	0	0
38814	1683	751692023999541	9590	4975	2	0	0
38816	1683	753132043999541	9646	5004	2	0	0
38817	1683	753132063999541	9646	5004	3	0	0
38818	1683	754572063999541	9654	5009	3	0	0
38819	1683	754572093999541	9654	5009	4	0	0
38820	1683	756012093999541	9657	5012	6	0	0
38823	1683	757452153999541	9667	5017	2	0	0
38825	1683	757452173999541	9667	5017	3	0	0
38829	1683	758892173999541	9695	5030	3	0	0
38832	1683	758892203999541	9695	5030	4	0	0
38835	1683	760332323999541	9700	5031	4	0	0
38837	1683	761772323999541	9741	5046	7	0	0
38838	1683	761772384999541	9741	5046	8	0	0
38840	1683	763212384999541	9745	5048	5	0	0
38841	1683	763212425999541	9745	5048	6	0	0
38843	1683	764652445999541	9754	5053	3	0	0
38846	1683	766092445999541	9786	5072	4	0	0
38849	1683	766092485999541	9786	5072	5	0	0
38850	1683	767532485999541	9790	5075	8	0	0
38851	1683	767532565999541	9790	5075	9	0	0
38853	1683	768972595999541	9791	5076	4	0	0
38856	1683	770412595999541	9835	5098	2	0	0
38857	1683	770412615999541	9835	5098	3	0	0
38861	1683	771852615999541	9860	5115	2	0	0
38863	1683	773292635999541	9866	5117	1	0	0
38864	1683	773292645999541	9866	5117	2	0	0
38865	1683	774732645999541	9875	5122	2	0	0
38866	1683	774732665999541	9875	5122	3	0	0
38867	1683	776172665999541	9876	5123	5	0	0
38869	1683	777612715999541	9882	5124	2	0	0
38870	1683	777612735999541	9882	5124	3	0	0
38873	1683	779052735999541	9913	5142	1	0	0
38874	1683	779052745999541	9913	5142	2	0	0
38882	1683	780492745999541	10002	5185	2	0	0
38890	1683	781932765999541	10013	5191	4	0	0
38892	1683	781932805999541	10013	5191	5	0	0
38893	1683	783372805999541	10016	5194	5	0	0
38894	1683	783372846999541	10016	5194	6	0	0
38898	1683	784812866999541	10043	5210	3	0	\N
38899	1683	784812866999541	10049	5211	3	0	\N
38905	1683	789132958999541	10075	5225	3	0	\N
38907	1683	789132979999541	10075	5225	4	0	\N
38909	1683	790573019999541	10078	5227	7	0	\N
38912	1683	790573089999541	10078	5227	8	0	\N
38915	1683	793453059999541	10114	5246	11	0	\N
38916	1683	793453059999541	10119	5250	3	0	\N
38918	1683	793453089999541	10119	5250	4	0	\N
38919	1683	793453133999541	10114	5246	12	0	\N
38921	1683	794893549999541	10146	5260	2	0	\N
38923	1683	794893569999541	10146	5260	3	0	\N
38925	1683	796333569999541	10162	5266	2	0	\N
38926	1683	796333569999541	10260	5307	5	0	\N
38928	1683	796333589999541	10162	5266	3	0	\N
38929	1683	796333619999541	10260	5307	6	0	\N
38931	1683	797773689999541	10298	5327	2	0	\N
38933	1683	797773709999541	10298	5327	3	0	\N
38935	1683	799213719999541	10314	5335	3	0	\N
38938	1683	799213740999541	10314	5335	4	0	\N
38939	1683	800653739999541	10329	5344	5	0	\N
38942	1683	800654059999541	10329	5344	6	0	\N
38943	1683	802093799999541	10352	5357	4	0	\N
38944	1683	802093799999541	10383	5368	2	0	\N
38947	1683	802093839999541	10352	5357	5	0	\N
38948	1683	802093909999541	10383	5368	3	0	\N
38957	1684	1400010000	25575	12660	11	1	\N
38958	1684	719000000000	9	6	1	0	\N
38960	1684	719010000000	9	6	2	0	\N
38964	1684	1439010000000	356	203	3	0	\N
38965	1684	1439010000000	383	218	1	0	\N
38966	1684	1439010000000	399	227	3	0	\N
38967	1684	1439010000000	505	284	3	0	\N
38969	1684	1439020000000	383	218	2	0	\N
38971	1684	1439040000000	356	203	4	0	\N
38972	1684	1439040000000	399	227	4	0	\N
38973	1684	1439040000000	505	284	4	0	\N
38974	1684	1442745219748	20548	10345	0	0	\N
38975	1684	1442745219748	20684	10403	3	0	\N
38977	1684	1442757219748	20684	10403	4	0	\N
38980	1684	2162745219748	20846	10476	2	0	\N
38982	1684	2162756219748	20846	10476	3	0	\N
38983	1684	2879020000000	518	291	2	0	\N
38986	1684	2879040000000	518	291	3	0	\N
38987	1684	2882755219748	20869	10490	3	0	\N
38990	1684	2882767219748	20869	10490	4	0	\N
38993	1684	3602766219748	20905	10508	5	0	\N
38996	1684	3602789219748	20905	10508	6	0	\N
38997	1684	4291154880623	10118	5250	3	0	\N
38998	1684	4291154880623	10155	5264	4	0	\N
39000	1684	4291184880623	10118	5250	4	0	\N
39002	1684	4291194880623	10155	5264	5	0	\N
39003	1684	4319040000000	1141	630	1	0	\N
39005	1684	4319050000000	1141	630	2	0	\N
39009	1684	5011184880623	10497	5424	11	0	\N
39010	1684	5011184880623	10843	5596	6	0	\N
39011	1684	5011184880623	11019	5673	2	0	\N
39012	1684	5011184880623	11105	5712	5	0	\N
39014	1684	5011204880623	11019	5673	3	0	\N
39016	1684	5011234880623	11105	5712	6	0	\N
39017	1684	5011244880623	10843	5596	7	0	\N
39018	1684	5011294880623	10497	5424	12	0	\N
39021	1684	5042790219748	21054	10579	4	0	\N
39022	1684	5042790219748	21351	10716	6	0	\N
39024	1684	5042812219748	21054	10579	5	0	\N
39025	1684	5042814219748	21351	10716	7	0	\N
39027	1684	5731217880623	11245	5778	4	0	\N
39028	1684	5731217880623	11330	5819	2	0	\N
39030	1684	5731228880623	11330	5819	3	0	\N
39032	1684	5731239880623	11245	5778	5	0	\N
38968	1684	1439010000000	514	288	1	0	0
38970	1684	1439020000000	514	288	2	0	0
38978	1684	2159020000000	516	289	0	0	0
38984	1684	2879020000000	589	333	1	0	0
38985	1684	2879030000000	589	333	2	0	0
38992	1684	3599040000000	867	480	2	0	0
39004	1684	4319040000000	1217	670	1	0	0
39006	1684	4319050000000	1217	670	2	0	0
39019	1684	5039050000000	1258	696	4	0	0
39020	1684	5039090000000	1258	696	5	0	0
38900	1683	784812876999541	10057	5216	4	0	0
38901	1683	786252876999541	10069	5221	3	0	0
38902	1683	786252897999541	10069	5221	4	0	0
38903	1683	787692897999541	10072	5223	7	0	0
38906	1683	789132958999541	10076	5226	7	0	0
38908	1683	789133019999541	10076	5226	8	0	0
38910	1683	790573019999541	10102	5241	1	0	0
38911	1683	790573029999541	10102	5241	2	0	0
38913	1683	792013029999541	10109	5244	3	0	0
38917	1683	793453059999541	10122	5251	13	0	0
38920	1683	793453549999541	10122	5251	14	0	0
38922	1683	794893549999541	10150	5261	2	0	0
38924	1683	794893569999541	10150	5261	3	0	0
38927	1683	796333569999541	10282	5321	11	0	0
38999	1684	4291154880623	10300	5329	3	0	66
39001	1684	4291184880623	10300	5329	4	0	66
38932	1683	797773689999541	10310	5333	3	0	0
38934	1683	797773719999541	10310	5333	4	0	0
38937	1683	799213739999541	10324	5341	3	0	0
38940	1683	800653739999541	10345	5354	6	0	0
38941	1683	800653799999541	10345	5354	7	0	0
38945	1683	802093799999541	10395	5374	2	0	0
38946	1683	802093819999541	10395	5374	3	0	0
38950	1683	803533839999541	10403	5379	3	0	0
38951	1683	804973839999541	10411	5385	2	0	0
38952	1683	804973859999541	10411	5385	3	0	0
38953	1683	806413859999541	10419	5389	2	0	0
38954	1683	806413879999541	10419	5389	3	0	0
38956	1683	807853899999541	10436	5397	3	0	0
39013	1684	5011184880623	11235	5772	6	0	66
39015	1684	5011217880623	11235	5772	7	0	66
39029	1684	5731217880623	11395	5852	2	0	66
38962	1684	722724219748	20367	10260	3	0	136
38963	1684	722745219748	20367	10260	4	0	136
38976	1684	1442745219748	20722	10419	0	0	136
38979	1684	2162745219748	20844	10476	1	0	136
38981	1684	2162755219748	20844	10476	2	0	136
38989	1684	2882766219748	20904	10507	3	0	136
38994	1684	3602766219748	20948	10535	3	0	136
38995	1684	3602778219748	20948	10535	4	0	136
39007	1684	4322778219748	21040	10574	3	0	136
39008	1684	4322790219748	21040	10574	4	0	136
39026	1684	5042814219748	21352	10716	7	0	136
39033	1684	5759090000000	1603	859	11	0	\N
39036	1684	5759200000000	1603	859	12	0	\N
39039	1684	6451228880623	11447	5880	1	0	\N
39042	1684	6451238880623	11447	5880	2	0	\N
39051	1684	7202851219748	21556	10809	3	0	\N
39053	1684	7202851219748	21644	10843	5	0	\N
39054	1684	7202863219748	21556	10809	4	0	\N
39056	1684	7202865219748	21644	10843	6	0	\N
39057	1684	7202875219748	21864	10943	3	0	\N
39058	1684	7202875219748	21867	10943	3	0	\N
39059	1684	7202875219748	21868	10943	3	0	\N
39064	1684	7922775219749	21864	10943	4	0	\N
39066	1684	7922875219748	21867	10943	4	0	\N
39067	1684	7922875219748	21868	10943	4	0	\N
39069	1684	8611231880623	11779	6056	1	0	\N
39071	1684	8611231880623	12271	6142	0	0	\N
39072	1684	8611232880623	11779	6056	2	0	\N
39078	1684	9331235880623	11987	6170	1	0	\N
39079	1684	9331235880623	12048	6202	1	0	\N
39080	1684	9331235880623	12273	6319	1	0	\N
39081	1684	9331235880623	12274	6159	0	0	\N
39082	1684	9331235880623	12276	6175	0	0	\N
39083	1684	9331235880623	12277	6192	0	0	\N
39085	1684	9331236880623	11987	6170	2	0	\N
39086	1684	9331236880623	12048	6202	2	0	\N
39087	1684	9331236880623	12273	6319	2	0	\N
39089	1684	9359170000000	2292	1203	3	0	\N
39092	1684	9359200000000	2292	1203	4	0	\N
39096	1684	10051236880623	12404	6399	1	0	\N
39098	1684	10051237880623	12404	6399	2	0	\N
39102	1684	10082897219748	22380	11204	3	0	\N
39103	1684	10082897219748	22490	11253	6	0	\N
39105	1684	10082909219748	22380	11204	4	0	\N
39106	1684	10082930219748	22490	11253	7	0	\N
39108	1684	10771247880623	13068	6736	8	0	\N
39109	1684	10771247880623	13082	6741	4	0	\N
39110	1684	10771247880623	13135	6771	4	0	\N
39113	1684	10771260880623	13082	6741	5	0	\N
39114	1684	10771260880623	13135	6771	5	0	\N
39115	1684	10771372880623	13068	6736	9	0	\N
39116	1684	10799220000000	3037	1578	1	0	\N
39117	1684	10799220000000	3174	1649	1	0	\N
39119	1684	10799230000000	3037	1578	2	0	\N
39120	1684	10799230000000	3174	1649	2	0	\N
39123	1684	10802932219748	22497	11254	4	0	\N
39125	1684	10802954219748	22497	11254	5	0	\N
39127	1684	10802975219748	23133	11553	4	0	\N
39128	1684	10802975219748	23134	11553	4	0	\N
39129	1684	11491258880623	13748	7064	7	0	\N
39131	1684	11491258880623	13900	7130	17	0	\N
39132	1684	11491283880623	13748	7064	8	0	\N
39133	1684	11491320880623	13900	7130	18	0	\N
39138	1684	11522953219748	22566	11289	3	0	\N
39139	1684	11522965219748	22566	11289	4	0	\N
39141	1684	11522975219748	23133	11553	10	0	\N
39142	1684	11522975219748	23134	11553	10	0	\N
39144	1684	11522980219748	23133	11553	11	0	\N
39145	1684	11522980219748	23134	11553	11	0	\N
39148	1684	12239280000000	3307	1717	1	0	\N
39150	1684	12239290000000	3307	1717	2	0	\N
39153	1684	12242976819748	23176	11571	5	0	\N
39155	1684	12242999819748	23176	11571	6	0	\N
39157	1684	12243037819748	23181	11574	4	0	\N
39158	1684	12931347880623	14594	7442	3	0	\N
39159	1684	12931347880623	14657	7468	3	0	\N
39161	1684	12931359880623	14594	7442	4	0	\N
39162	1684	12931359880623	14657	7468	4	0	\N
39166	1684	12963037819748	23181	11574	13	0	\N
39168	1684	12963054819748	23181	11574	14	0	\N
39043	1684	6479110000000	1796	960	3	0	0
39044	1684	6479140000000	1796	960	4	0	0
39049	1684	7199140000000	1818	973	1	0	0
39050	1684	7199150000000	1818	973	2	0	0
39062	1684	7919150000000	1949	1034	1	0	0
39074	1684	8639160000000	2017	1064	1	0	0
39075	1684	8639170000000	2017	1064	2	0	0
39090	1684	9359170000000	2552	1344	1	0	0
39091	1684	9359180000000	2552	1344	2	0	0
39093	1684	9359200000000	2761	1443	2	0	0
39101	1684	10079220000000	2761	1443	6	0	0
39118	1684	10799220000000	3190	1656	4	0	0
39121	1684	10799260000000	3190	1656	5	0	0
39136	1684	11519260000000	3303	1714	2	0	0
39149	1684	12239280000000	3337	1732	3	0	0
39151	1684	12239310000000	3337	1732	4	0	0
39164	1684	12959310000000	3481	1807	0	0	0
39040	1684	6451228880623	11592	5963	1	0	66
39041	1684	6451229880623	11592	5963	2	0	66
39048	1684	7171230880623	11658	5996	2	0	66
39060	1684	7891230880623	11676	6003	1	0	66
39061	1684	7891231880623	11676	6003	2	0	66
39070	1684	8611231880623	11954	6153	4	0	66
39073	1684	8611235880623	11954	6153	5	0	66
39088	1684	9331236880623	12297	6333	2	0	66
39097	1684	10051236880623	12901	6649	2	0	66
39099	1684	10051247880623	12901	6649	3	0	66
39111	1684	10771247880623	13168	6785	2	0	66
39130	1684	11491258880623	13899	7130	31	0	66
39134	1684	11491334880623	13899	7130	32	0	66
39135	1684	11491345880623	14440	7369	2	0	66
39146	1684	12211345880623	14440	7369	5	0	66
39147	1684	12211347880623	14440	7369	6	0	66
39163	1684	12931380880623	14709	7490	7	0	66
39037	1684	5762814219748	21457	10765	7	0	136
39038	1684	5762839219748	21457	10765	8	0	136
39045	1684	6482839219748	21471	10770	3	0	136
39046	1684	6482851219748	21471	10770	4	0	136
39055	1684	7202863219748	21643	10843	4	0	136
39065	1684	7922863219748	21913	10965	3	0	136
39068	1684	7922875219748	21913	10965	4	0	136
39076	1684	8642875219748	22150	11081	3	0	136
39094	1684	9362887219748	22371	11197	1	0	136
39095	1684	9362897219748	22371	11197	2	0	136
39104	1684	10082897219748	22494	11253	8	0	136
39107	1684	10082932219748	22494	11253	9	0	136
39122	1684	10802932219748	22496	11254	3	0	136
39126	1684	10802975219748	23132	11553	4	0	136
39140	1684	11522975119748	23132	11553	7	0	136
39143	1684	11522976819748	23132	11553	8	1	136
39152	1684	12242976819748	23175	11571	3	0	136
39154	1684	12242997819748	23175	11571	4	0	136
39165	1684	12963037819748	23180	11574	8	0	136
39167	1684	12963049819412	23180	11574	9	1	136
39169	1684	13651380880623	14754	7513	2	0	\N
39170	1684	13651380880623	14904	7593	4	0	\N
39171	1684	13651380880623	14930	7608	1	0	\N
39172	1684	13651380880623	15352	7824	2	0	\N
39173	1684	13651380880623	15556	7919	6	0	\N
39175	1684	13651390880623	14930	7608	2	0	\N
39176	1684	13651391880623	14754	7513	3	0	\N
39177	1684	13651391880623	15352	7824	3	0	\N
39179	1684	13651393880623	14904	7593	5	0	\N
39180	1684	13651422880623	15556	7919	7	0	\N
39184	1684	14371392880623	15713	7990	3	0	\N
39186	1684	14371404880623	15713	7990	4	0	\N
39190	1684	14399340000000	3782	1960	2	0	\N
39191	1684	14399340000000	3783	1960	2	0	\N
39192	1684	14399340000000	3785	1960	2	0	\N
39193	1684	14400425880623	16308	8287	7	0	\N
39196	1684	14400450880623	16308	8287	8	0	\N
39197	1684	14403060819412	23303	11629	2	0	\N
39198	1684	14403060819412	23305	11629	2	0	\N
39200	1684	14403071819412	23303	11629	3	0	\N
39201	1684	14403071819412	23305	11629	3	0	\N
39203	1684	15091404880623	15837	8058	3	0	\N
39205	1684	15091416880623	15837	8058	4	0	\N
39209	1684	15119340000000	3782	1960	3	0	\N
39210	1684	15119340000000	3783	1960	3	0	\N
39211	1684	15119340000000	3785	1960	3	0	\N
39212	1684	15120436880623	16500	8394	3	0	\N
39214	1684	15120448880623	16500	8394	4	0	\N
39218	1684	15123609819412	23454	11663	95	0	\N
39221	1684	15839330000000	3921	2034	1	0	\N
39223	1684	15839340000000	3921	2034	2	0	\N
39227	1684	15843082819412	23452	11695	2	0	\N
39228	1684	15843082819412	23486	11677	0	0	\N
39230	1684	15843082819412	23488	11679	0	0	\N
39231	1684	15843082819412	23489	11681	0	0	\N
39232	1684	15843093819412	23452	11695	3	0	\N
39234	1684	15843609819412	23454	11663	96	0	\N
39237	1684	16559340000000	3982	2068	1	0	\N
39239	1684	16559350000000	3982	2068	2	0	\N
39241	1684	16560494880623	16732	8498	3	0	\N
39242	1684	16560494880623	16750	8503	4	0	\N
39244	1684	16560506880623	16732	8498	4	0	\N
39246	1684	16560516880623	16750	8503	5	0	\N
39247	1684	16563095819412	23709	11808	4	0	\N
39248	1684	16563095819412	23710	11808	3	0	\N
39250	1684	16563107819412	23710	11808	4	0	\N
39251	1684	16563108819412	23709	11808	5	0	\N
39253	1684	17279350000000	4113	2138	1	0	\N
39255	1684	17279360000000	4113	2138	2	0	\N
39265	1684	18003119819412	24124	12007	4	0	\N
39267	1684	18003141819412	24124	12007	5	0	\N
39273	1684	18723153819412	24542	12202	4	0	\N
39274	1684	18723153819412	24569	12213	4	0	\N
39276	1684	18723175819412	24542	12202	5	0	\N
39277	1684	18723175819412	24569	12213	5	0	\N
39281	1684	19440565880623	17667	8930	2	0	\N
39282	1684	19440565880623	17830	9004	3	0	\N
39283	1684	19440565880623	17848	9009	3	0	\N
39284	1684	19440565880623	18429	9292	3	0	\N
39285	1684	19440565880623	18442	9296	3	0	\N
39287	1684	19440576880623	17667	8930	3	0	\N
39288	1684	19440577880623	17830	9004	4	0	\N
39289	1684	19440577880623	17848	9009	4	0	\N
39290	1684	19440577880623	18429	9292	4	0	\N
39291	1684	19440577880623	18442	9296	4	0	\N
39293	1684	19443287819412	24743	12287	8	0	\N
39294	1684	19443287819412	24745	12287	8	0	\N
39297	1684	19443349819412	24743	12287	9	0	\N
39298	1684	19443349819412	24745	12287	9	0	\N
39299	1684	20159580000000	4496	2328	5	0	\N
39300	1684	20159580000000	4504	2332	1	0	\N
39301	1684	20159580000000	4580	2370	1	0	\N
39303	1684	20159590000000	4504	2332	2	0	\N
39304	1684	20159590000000	4580	2370	2	0	\N
39189	1684	14399320000000	3678	1909	2	0	0
39207	1684	15119320000000	3882	2017	1	0	0
39208	1684	15119330000000	3882	2017	2	0	0
39222	1684	15839330000000	3950	2053	1	0	0
39224	1684	15839340000000	3950	2053	2	0	0
39240	1684	16559350000000	4001	2076	2	0	0
39254	1684	17279350000000	4207	2189	1	0	0
39256	1684	17279360000000	4207	2189	2	0	0
39261	1684	17999360000000	4232	2199	5	0	0
39262	1684	17999500000000	4232	2199	6	0	0
39270	1684	18719520000000	4270	2214	3	0	0
39279	1684	19439520000000	4473	2318	6	0	0
39280	1684	19439580000000	4473	2318	7	0	0
39302	1684	20159580000000	4600	2380	1	0	0
39178	1684	13651392880623	15626	7955	4	0	66
39185	1684	14371392880623	15742	8006	3	0	66
39187	1684	14371404880623	15742	8006	4	0	66
39204	1684	15091404880623	15870	8072	4	0	66
39206	1684	15091417880623	15870	8072	5	0	66
39220	1684	15811429880623	15894	8081	4	0	66
39235	1684	16531429880623	16149	8209	3	0	66
39236	1684	16531441880623	16149	8209	4	0	66
39194	1684	14400425880623	16321	8293	2	0	70
39195	1684	14400436880623	16321	8293	3	0	70
39215	1684	15120469880623	16596	8433	6	0	70
39225	1684	15840469880623	16627	8446	7	0	70
39226	1684	15840494880623	16627	8446	8	0	70
39243	1684	16560494880623	17209	8719	3	0	70
39257	1684	17280506880623	17277	8751	3	0	70
39258	1684	17280518880623	17277	8751	4	0	70
39263	1684	18000518880623	17296	8760	9	0	70
39264	1684	18000554880623	17296	8760	10	0	70
39271	1684	18720554880623	17523	8872	2	0	70
39286	1684	19440565880623	18533	9338	3	0	70
39292	1684	19440577880623	18533	9338	4	0	70
39182	1684	13683049819412	23270	11610	2	0	136
39183	1684	13683060819412	23270	11610	3	0	136
39199	1684	14403060819412	23323	11640	2	0	136
39216	1684	15123071819412	23339	11646	2	0	136
39217	1684	15123082819412	23339	11646	3	0	136
39229	1684	15843082819412	23487	11711	4	0	136
39233	1684	15843095819412	23487	11711	5	0	136
39252	1684	16563108819412	23805	11849	5	0	136
39259	1684	17283108819412	24075	11983	2	0	136
39260	1684	17283119819412	24075	11983	3	0	136
39266	1684	18003119819412	24384	12127	7	0	136
39268	1684	18003153819412	24384	12127	8	0	136
39278	1684	18723287819412	24580	12220	9	0	136
39295	1684	19443287819412	24938	12379	4	0	136
39296	1684	19443300819412	24938	12379	5	0	136
39306	1684	20159720000000	4496	2328	6	0	\N
39309	1684	20163300819412	25330	12564	3	0	\N
39310	1684	20163300819412	25332	12564	3	0	\N
39311	1684	20163300819412	25338	12566	3	0	\N
39312	1684	20163300819412	25343	12566	5	0	\N
39314	1684	20163312819412	25330	12564	4	0	\N
39315	1684	20163312819412	25332	12564	4	0	\N
39316	1684	20163312819412	25338	12566	4	0	\N
39318	1684	20163314819412	25343	12566	6	0	\N
39319	1684	20163343819412	25572	12660	3	0	\N
39320	1684	20163343819412	25575	12660	3	0	\N
39324	1684	20883313819412	25492	12625	6	0	\N
39326	1684	20883313819412	25623	12680	6	0	\N
39328	1684	20883337819412	25492	12625	7	0	\N
39329	1684	20883337819412	25623	12680	7	0	\N
39330	1684	20883343819412	25572	12660	10	0	\N
39331	1684	20883343819412	25575	12660	10	0	\N
39332	1684	20883349819412	25572	12660	11	0	\N
39333	1684	21599600000000	4945	2561	1	0	\N
39335	1684	21599610000000	4945	2561	2	0	\N
39337	1684	21600599880623	18713	9426	10	0	\N
39338	1684	21600599880623	18728	9436	2	0	\N
39340	1684	21600610880623	18728	9436	3	0	\N
39342	1684	21600645880623	18713	9426	11	0	\N
39343	1684	21603315819412	25653	12695	1	0	\N
39345	1684	21603316819412	25653	12695	2	0	\N
39347	1684	22319610000000	4972	2578	1	0	\N
39349	1684	22319620000000	4972	2578	2	0	\N
39353	1684	22323317819412	25790	12754	4	0	\N
39354	1684	22323317819412	25802	12759	3	0	\N
39357	1684	22323329819412	25802	12759	4	0	\N
39358	1684	22323330819412	25790	12754	5	0	\N
39359	1684	23039650000000	4995	2589	4	0	\N
39362	1684	23039780000000	4995	2589	5	0	\N
39372	1684	23763350819412	26109	12904	2	0	\N
39373	1684	23763350819412	26246	12975	3	0	\N
39375	1684	23763361819412	26109	12904	3	0	\N
39376	1684	23763362819412	26246	12975	4	0	\N
39377	1684	24479670000000	5291	2749	1	0	\N
39379	1684	24479670000000	5418	2805	2	0	\N
39380	1684	24479672000000	5418	2805	3	0	\N
39381	1684	24479680000000	5291	2749	2	0	\N
39382	1684	24480663880623	19417	9786	4	0	\N
39383	1684	24480663880623	19490	9825	4	0	\N
39384	1684	24480663880623	19491	9825	5	0	\N
39387	1684	24480676880623	19417	9786	5	0	\N
39388	1684	24480685880623	19490	9825	5	0	\N
39389	1684	24480686880623	19491	9825	6	0	\N
39392	1684	25199670000000	5816	3019	2	0	\N
39393	1684	25199670000000	5821	3021	1	0	\N
39395	1684	25199680000000	5821	3021	2	0	\N
39397	1684	25199690000000	5816	3019	3	0	\N
39400	1684	25203369819412	26317	13017	5	0	\N
39403	1684	25203392819412	26317	13017	6	0	\N
39406	1684	25920687880623	20003	10071	5	0	\N
39407	1684	25920719880623	20003	10071	6	0	\N
39408	1684	25923380819412	26372	13044	6	0	\N
39410	1684	25923395819412	26372	13044	7	0	\N
39414	1684	26643405819412	26493	13105	3	0	\N
39416	1684	26643417819412	26493	13105	4	0	\N
39428	1684	28803458819412	26885	13295	3	0	\N
39430	1684	28803470819412	26885	13295	4	0	\N
39432	1684	29519740000000	7262	3757	1	0	\N
39433	1684	29519740000000	7264	3757	1	0	\N
39434	1684	29519740000000	7267	3757	1	0	\N
39435	1684	29519740000000	7359	3803	9	0	\N
39436	1684	29519740000000	7418	3833	2	0	\N
39438	1684	29519750000000	7262	3757	2	0	\N
39439	1684	29519750000000	7264	3757	2	0	\N
39440	1684	29519750000000	7267	3757	2	0	\N
39322	1684	20879600000000	4942	2559	2	0	0
39334	1684	21599600000000	4951	2564	1	0	0
39336	1684	21599610000000	4951	2564	2	0	0
39348	1684	22319610000000	4980	2582	4	0	0
39350	1684	22319650000000	4980	2582	5	0	0
39361	1684	23039660000000	5077	2635	2	0	0
39367	1684	23759660000000	5182	2691	1	0	0
39368	1684	23759670000000	5182	2691	2	0	0
39378	1684	24479670000000	5417	2819	0	0	0
39394	1684	25199670000000	5881	3049	1	0	0
39404	1684	25919680000000	5943	3079	1	0	0
39405	1684	25919690000000	5943	3079	2	0	0
39412	1684	26639690000000	6138	3182	1	0	0
39413	1684	26639700000000	6138	3182	2	0	0
39419	1684	27359710000000	6261	3243	2	0	0
39422	1684	28079710000000	6876	3555	2	0	0
39423	1684	28079730000000	6876	3555	3	0	0
39426	1684	28799730000000	7190	3717	1	0	0
39427	1684	28799740000000	7190	3717	2	0	0
39307	1684	20160577880623	18670	9407	4	0	70
39308	1684	20160599880623	18670	9407	5	0	70
39323	1684	20880599880623	18690	9415	0	0	70
39339	1684	21600599880623	18842	9498	2	0	70
39341	1684	21600619880623	18842	9498	3	0	70
39352	1684	22320630880623	18856	9507	3	0	70
39363	1684	23040630880623	19076	9621	1	0	70
39364	1684	23040640880623	19076	9621	2	0	70
39369	1684	23760640880623	19363	9762	5	0	70
39385	1684	24480663880623	19595	9868	3	0	70
39386	1684	24480675880623	19595	9868	4	0	70
39398	1684	25200675880623	19990	10066	3	0	70
39399	1684	25200687880623	19990	10066	4	0	70
39313	1684	20163300819412	25461	12611	4	0	136
39325	1684	20883313819412	25622	12680	2	0	136
39327	1684	20883315819412	25622	12680	3	0	136
39344	1684	21603315819412	25654	12695	2	0	136
39346	1684	21603317819412	25654	12695	3	0	136
39355	1684	22323317819412	25892	12797	2	0	136
39365	1684	23043328819412	26037	12866	4	0	136
39366	1684	23043350819412	26037	12866	5	0	136
39371	1684	23763349819412	26244	12975	3	0	136
39374	1684	23763358819412	26244	12975	5	0	136
39391	1684	24483369819412	26287	13001	3	0	136
39401	1684	25203369819412	26325	13019	2	0	136
39402	1684	25203380819412	26325	13019	3	0	136
39409	1684	25923380819412	26473	13094	7	0	136
39411	1684	25923405819412	26473	13094	8	0	136
39417	1684	26643420819412	26612	13166	7	0	136
39420	1684	27363420819412	26804	13254	4	0	136
39421	1684	27363433819412	26804	13254	5	0	136
39424	1684	28083433819412	26864	13286	7	0	136
39425	1684	28083458819412	26864	13286	8	0	136
39431	1684	28803482819412	26918	13313	7	0	136
39441	1684	29519751000000	7418	3833	3	0	\N
39443	1684	29519830000000	7359	3803	10	0	\N
39446	1684	30239761000000	7560	3915	1	0	\N
39447	1684	30239761000000	7851	4069	1	0	\N
39449	1684	30239771000000	7560	3915	2	0	\N
39450	1684	30239771000000	7851	4069	2	0	\N
39456	1684	30963544819412	27574	13629	3	0	\N
39458	1684	30963556819412	27574	13629	4	0	\N
39460	1684	31679891000000	8013	4153	2	0	\N
39463	1684	31679902000000	8013	4153	3	0	\N
39464	1684	31680731000000	8210	4216	56	0	\N
39465	1684	31683556819412	27855	13769	6	0	\N
39466	1684	31683556819412	27908	13803	3	0	\N
39468	1684	31683568819412	27908	13803	4	0	\N
39469	1684	31683580819412	27855	13769	7	0	\N
39471	1684	32399901000000	8208	4255	1	0	\N
39473	1684	32399911000000	8208	4255	2	0	\N
39475	1684	32400731000000	8210	4216	59	0	\N
39476	1684	32400751000000	8210	4216	60	0	\N
39477	1684	32403580819412	28140	13911	2	0	\N
39479	1684	32403591819412	28140	13911	3	0	\N
39481	1684	33120051000000	8320	4307	1	0	\N
39483	1684	33120052000000	8320	4307	2	0	\N
39485	1684	33123591819412	28442	14057	2	0	\N
39486	1684	33123591819412	28464	14066	2	0	\N
39487	1684	33123591819412	28548	14104	2	0	\N
39489	1684	33123602819412	28442	14057	3	0	\N
39490	1684	33123602819412	28464	14066	3	0	\N
39491	1684	33123602819412	28548	14104	3	0	\N
39493	1684	33840061000000	8381	4343	2	0	\N
39495	1684	33840081000000	8381	4343	3	0	\N
39498	1684	33844597819412	29118	14294	116	0	\N
39500	1684	34563626819412	29114	14354	8	0	\N
39501	1684	34563626819412	29319	14448	3	0	\N
39503	1684	34563638819412	29319	14448	4	0	\N
39505	1684	34563661819412	29114	14354	9	0	\N
39506	1684	34564597819412	29118	14294	126	0	\N
39507	1684	34564606819412	29118	14294	127	0	\N
39509	1684	35280061000000	8692	4506	2	0	\N
39510	1684	35280061000000	8718	4521	4	0	\N
39511	1684	35280081000000	8692	4506	3	0	\N
39513	1684	35280101000000	8718	4521	5	0	\N
39514	1684	35283638819412	29387	14488	12	0	\N
39515	1684	35283638819412	29388	14488	8	0	\N
39516	1684	35283673819412	29388	14488	9	0	\N
39517	1684	35283677819412	29387	14488	13	0	\N
39518	1684	35283738819412	29416	14503	3	0	\N
39521	1684	35283750819412	29416	14503	4	0	\N
39524	1684	36003748819412	29627	14611	3	0	\N
39527	1684	36003760819412	29627	14611	4	0	\N
39532	1684	37440166000000	9030	4682	2	0	\N
39534	1684	37440186000000	9030	4682	3	0	\N
39537	1684	37443777819412	29927	14742	19	0	\N
39539	1684	37443814819412	29927	14742	20	0	\N
39544	1684	38880256000000	9168	4752	0	0	\N
39545	1684	38880256000000	9169	4752	2	0	\N
39546	1684	38880256000000	9176	4756	2	0	\N
39548	1684	38880276000000	9169	4752	3	0	\N
39549	1684	38880276000000	9176	4756	3	0	\N
39551	1684	38883833494436	30009	14777	9	0	\N
39552	1684	38883833494436	30042	14791	21	0	\N
39554	1684	38883851494436	30009	14777	10	0	\N
39556	1684	38883872494436	30042	14791	22	0	\N
39557	1684	38883883494436	30081	14811	3	0	\N
39558	1684	38883883494436	30082	14811	3	0	\N
39559	1684	38883883494436	30084	14811	3	0	\N
39563	1684	39603883494436	30081	14811	10	0	\N
39564	1684	39603883494436	30082	14811	10	0	\N
39565	1684	39603883494436	30084	14811	8	0	\N
39566	1684	39603887219081	30084	14811	11	1	\N
39567	1684	39603889244075	30081	14811	13	1	\N
39568	1684	39603889244075	30082	14811	13	1	\N
39570	1684	40320296000000	9318	4833	2	0	\N
39572	1684	40320316000000	9318	4833	3	0	\N
39574	1684	41040336000000	9444	4898	4	0	\N
39575	1684	41040336000000	9697	5031	3	0	\N
39576	1684	41040336000000	9751	5052	3	0	\N
39451	1684	30239771000000	7955	4122	2	0	0
39454	1684	30959771000000	7984	4138	3	0	0
39455	1684	30959891000000	7984	4138	4	0	0
39461	1684	31679891000000	8088	4195	1	0	0
39462	1684	31679901000000	8088	4195	2	0	0
39474	1684	32400051000000	8262	4278	7	0	0
39482	1684	33120051000000	8332	4314	1	0	0
39484	1684	33120061000000	8332	4314	2	0	0
39494	1684	33840061000000	8420	4363	0	0	0
39499	1684	34560061000000	8673	4493	0	0	0
39512	1684	35280081000000	8882	4601	5	0	1
39522	1684	36000081000000	8995	4664	5	0	1
39523	1684	36000126000000	8995	4664	6	0	1
39528	1684	36720126000000	9023	4679	4	0	1
39533	1684	37440166000000	9068	4701	2	0	1
39535	1684	37440186000000	9068	4701	3	0	1
39540	1684	38160186000000	9144	4738	7	0	1
39541	1684	38160256000000	9144	4738	8	0	1
39547	1684	38880256000000	9209	4776	2	0	1
39560	1684	39600276000000	9300	4825	2	0	1
39561	1684	39600296000000	9300	4825	3	0	1
39571	1684	40320296000000	9417	4887	4	0	1
39573	1684	40320336000000	9417	4887	5	0	1
39444	1684	29523482819412	27469	13576	8	0	136
39452	1684	30243508819412	27509	13600	9	0	136
39453	1684	30243544819412	27509	13600	10	0	136
39457	1684	30963544819412	27632	13657	3	0	136
39459	1684	30963556819412	27632	13657	4	0	136
39470	1684	31683580819412	28025	13861	7	0	136
39478	1684	32403580819412	28253	13969	2	0	136
39480	1684	32403591819412	28253	13969	3	0	136
39488	1684	33123591819412	28675	14156	4	0	136
39492	1684	33123613819412	28675	14156	5	0	136
39497	1684	33843626819412	28846	14227	5	0	136
39502	1684	34563626819412	29365	14473	3	0	136
39504	1684	34563638819412	29365	14473	4	0	136
39519	1684	35283738819412	29417	14503	1	0	136
39520	1684	35283748819412	29417	14503	2	0	136
39526	1684	36003759819412	29764	14669	12	0	136
39530	1684	36723759819412	29823	14695	9	0	136
39531	1684	36723777819412	29823	14695	10	0	136
39536	1684	37443777819412	29925	14742	5	0	136
39542	1684	38163800819412	29932	14744	15	0	136
39543	1684	38163833494436	29932	14744	19	0	136
39553	1684	38883833494436	30045	14792	20	0	136
39555	1684	38883871494436	30045	14792	21	0	136
39562	1684	39603871494436	30199	14855	20	0	136
39578	1684	41040357000000	9751	5052	4	0	\N
39580	1684	41040376000000	9444	4898	5	0	\N
39581	1684	41040456000000	9697	5031	4	0	\N
39582	1685	1000	11033	5607	100	1	\N
39585	1685	1439010000000	101	62	3	0	\N
39586	1685	1439010000000	118	70	1	0	\N
39587	1685	1439010000000	123	72	1	0	\N
39589	1685	1439020000000	118	70	2	0	\N
39590	1685	1439020000000	123	72	2	0	\N
39592	1685	1439040000000	101	62	4	0	\N
39597	1685	3599050000000	333	191	1	0	\N
39598	1685	3599050000000	377	213	1	0	\N
39600	1685	3599060000000	333	191	2	0	\N
39601	1685	3599060000000	377	213	2	0	\N
39603	1685	4319060000000	395	225	1	0	\N
39604	1685	4319060000000	432	245	1	0	\N
39605	1685	4319060000000	434	246	2	0	\N
39607	1685	4319070000000	395	225	2	0	\N
39608	1685	4319070000000	432	245	2	0	\N
39609	1685	4319080000000	434	246	3	0	\N
39617	1685	7199140000000	767	426	3	0	\N
39620	1685	7199260000000	767	426	4	0	\N
39625	1685	9359200000000	955	532	1	0	\N
39626	1685	9359200000000	969	539	1	0	\N
39628	1685	9359210000000	955	532	2	0	\N
39629	1685	9359210000000	969	539	2	0	\N
39631	1685	10031839951155	15827	8052	21	0	\N
39632	1685	10079210000000	1052	584	9	0	\N
39635	1685	10079300000000	1052	584	10	0	\N
39638	1685	11519240000000	1194	658	2	0	\N
39640	1685	11519260000000	1194	658	3	0	\N
39642	1685	12239280000000	1325	728	3	0	\N
39645	1685	12239301000000	1325	728	4	0	\N
39646	1685	12959290000000	1333	733	1	0	\N
39648	1685	12959300000000	1333	733	2	0	\N
39650	1685	13679300000000	1424	774	2	0	\N
39653	1685	13679320000000	1424	774	3	0	\N
39668	1685	19439420000000	1749	937	2	0	\N
39669	1685	19439420000000	1783	954	2	0	\N
39670	1685	19439420000000	1824	975	1	0	\N
39671	1685	19439420000000	1902	1013	1	0	\N
39673	1685	19439430000000	1824	975	2	0	\N
39674	1685	19439430000000	1902	1013	2	0	\N
39676	1685	19439440000000	1749	937	3	0	\N
39677	1685	19439440000000	1783	954	3	0	\N
39678	1685	20159430000000	1959	1037	1	0	\N
39679	1685	20159430000000	1965	1039	1	0	\N
39680	1685	20159430000000	2001	1057	1	0	\N
39682	1685	20159440000000	1959	1037	2	0	\N
39683	1685	20159440000000	1965	1039	2	0	\N
39684	1685	20159440000000	2001	1057	2	0	\N
39688	1685	21599450000000	2176	1147	1	0	\N
39690	1685	21599460000000	2176	1147	2	0	\N
39700	1685	25199630000000	2800	1464	4	0	\N
39703	1685	25199670000000	2800	1464	5	0	\N
39710	1685	28079670000000	3368	1753	2	0	\N
39588	1685	1439010000000	143	84	1	0	0
39591	1685	1439020000000	143	84	2	0	0
39593	1685	2159020000000	215	126	2	0	0
39594	1685	2159040000000	215	126	3	0	0
39595	1685	2879040000000	308	177	1	0	0
39599	1685	3599050000000	393	224	1	0	0
39602	1685	3599060000000	393	224	2	0	0
39606	1685	4319060000000	507	284	3	0	0
39610	1685	4319090000000	507	284	4	0	0
39611	1685	5039090000000	570	322	1	0	0
39613	1685	5759100000000	703	391	3	0	0
39614	1685	5759130000000	703	391	4	0	0
39615	1685	6479130000000	742	416	1	0	0
39616	1685	6479140000000	742	416	2	0	0
39619	1685	7199150000000	836	460	2	0	0
39621	1685	7919150000000	874	484	2	0	0
39622	1685	7919170000000	874	484	3	0	0
39623	1685	8639170000000	942	524	3	0	0
39624	1685	8639200000000	942	524	4	0	0
39630	1685	9359210000000	1038	577	2	0	0
39633	1685	10079210000000	1133	626	1	0	0
39634	1685	10079220000000	1133	626	2	0	0
39636	1685	10799220000000	1175	647	2	0	0
39637	1685	10799240000000	1175	647	3	0	0
39641	1685	11519280000000	1263	698	5	0	0
39643	1685	12239280000000	1329	731	1	0	0
39644	1685	12239290000000	1329	731	2	0	0
39647	1685	12959290000000	1345	739	1	0	0
39651	1685	13679300000000	1451	790	1	0	0
39652	1685	13679310000000	1451	790	2	0	0
39654	1685	14399310000000	1458	794	1	0	0
39655	1685	14399320000000	1458	794	2	0	0
39656	1685	15119320000000	1534	839	1	0	0
39658	1685	15839330000000	1653	890	1	0	0
39659	1685	15839340000000	1653	890	2	0	0
39660	1685	16559340000000	1693	910	2	0	0
39661	1685	16559360000000	1693	910	3	0	0
39662	1685	17279360000000	1697	914	4	0	0
39664	1685	17999400000000	1735	931	1	0	0
39665	1685	17999410000000	1735	931	2	0	0
39666	1685	18719410000000	1737	932	1	0	0
39667	1685	18719420000000	1737	932	2	0	0
39675	1685	19439430000000	1910	1016	2	0	0
39681	1685	20159430000000	2027	1069	1	0	0
39685	1685	20159440000000	2027	1069	2	0	0
39686	1685	20879440000000	2078	1097	1	0	0
39687	1685	20879450000000	2078	1097	2	0	0
39691	1685	21599460000000	2223	1170	2	0	0
39692	1685	22319460000000	2224	1171	5	0	0
39693	1685	22319600000000	2224	1171	6	0	0
39694	1685	23039600000000	2403	1256	1	0	0
39695	1685	23039610000000	2403	1256	2	0	0
39697	1685	23759620000000	2455	1284	2	0	0
39698	1685	24479620000000	2621	1378	1	0	0
39699	1685	24479630000000	2621	1378	2	0	0
39701	1685	25199630000000	3012	1564	1	0	0
39704	1685	25919640000000	3040	1579	1	0	0
39705	1685	25919650000000	3040	1579	2	0	0
39706	1685	26639650000000	3147	1636	1	0	0
39707	1685	26639660000000	3147	1636	2	0	0
39708	1685	27359660000000	3200	1661	1	0	0
39711	1685	28079670000000	3372	1754	1	0	0
39712	1685	28079680000000	3372	1754	2	0	0
39577	1684	41040336000000	9807	5085	4	0	1
39579	1684	41040358000000	9807	5085	5	0	1
39713	1685	28079690000000	3368	1753	3	0	\N
39714	1685	28799680000000	3397	1767	1	0	\N
39716	1685	28799690000000	3397	1767	2	0	\N
39718	1685	29519690000000	3510	1821	1	0	\N
39719	1685	29519690000000	3556	1845	0	0	\N
39720	1685	29519690000000	3574	1855	0	0	\N
39722	1685	29519700000000	3510	1821	2	0	\N
39726	1685	31679700000000	3719	1930	1	0	\N
39727	1685	31679700000000	3793	1964	1	0	\N
39729	1685	31679710000000	3719	1930	2	0	\N
39730	1685	31679710000000	3793	1964	2	0	\N
39732	1685	32399710000000	4105	2057	3	0	\N
39735	1685	32399911000000	4105	2057	4	0	\N
39738	1685	33119911000000	4184	2058	10	0	\N
39739	1685	33120326000000	4184	2058	11	0	\N
39740	1685	33839810000000	4641	2399	1	0	\N
39742	1685	33839820000000	4641	2399	2	0	\N
39744	1685	33840326000000	4226	2059	3	0	\N
39745	1685	33840347000000	4226	2059	4	0	\N
39748	1685	34560347000000	4238	2060	5	0	\N
39749	1685	34560757000000	4238	2060	6	0	\N
39752	1685	35280757000000	4324	2061	2	0	\N
39753	1685	35280867000000	4324	2061	3	0	\N
39756	1685	36000867000000	4350	2062	0	0	\N
39757	1685	36719950000000	4901	2537	1	0	\N
39759	1685	36719960000000	4901	2537	2	0	\N
39763	1685	38159970000000	5169	2683	1	0	\N
39764	1685	38159970000000	5337	2769	1	0	\N
39766	1685	38159980000000	5169	2683	2	0	\N
39767	1685	38159980000000	5337	2769	2	0	\N
39770	1685	40319970000000	5441	2831	1	0	\N
39772	1685	40319971000000	5441	2831	2	0	\N
39774	1685	41759970000000	5571	2895	0	0	\N
39775	1685	41759970000000	5612	2915	0	0	\N
39780	1685	43919990000000	5927	3070	1	0	\N
39782	1685	43920000000000	5927	3070	2	0	\N
39790	1685	46800050000000	6093	3162	3	0	\N
39793	1685	46800080000000	6093	3162	4	0	\N
39802	1685	50400140000000	6435	3330	2	0	\N
39803	1685	50400140000000	6582	3365	1	0	\N
39805	1685	50400141000000	6582	3365	2	0	\N
39806	1685	50400160000000	6435	3330	3	0	\N
39808	1685	51120141000000	6587	3366	1	0	\N
39809	1685	51120142000000	6587	3366	2	0	\N
39812	1685	51840142000000	6675	3367	1	0	\N
39813	1685	51840152000000	6675	3367	2	0	\N
39816	1685	52560152000000	6686	3368	7	0	\N
39817	1685	52560177000000	6686	3368	8	0	\N
39819	1685	53280177000000	6706	3369	0	0	\N
39822	1685	54000177000000	6889	3370	2	0	\N
39823	1685	54000188000000	6889	3370	3	0	\N
39826	1685	54720188000000	6894	3371	0	0	\N
39829	1685	55440188000000	6897	3372	0	0	\N
39830	1685	55440270000000	7490	3873	2	0	\N
39833	1685	55440290000000	7490	3873	3	0	\N
39834	1685	56160188000000	6944	3373	0	0	\N
39835	1685	56160280000000	7636	3952	1	0	\N
39837	1685	56160290000000	7636	3952	2	0	\N
39839	1685	56880188000000	6948	3374	0	0	\N
39842	1685	57600188000000	7063	3375	0	0	\N
39843	1685	57600310000000	7914	4101	2	0	\N
39844	1685	57600310000000	7927	4109	2	0	\N
39845	1685	57600310000000	7942	4115	1	0	\N
39846	1685	57600310000000	7990	4142	2	0	\N
39848	1685	57600320000000	7942	4115	2	0	\N
39721	1685	29519690000000	3579	1857	0	0	0
39723	1685	30239690000000	3631	1881	0	0	0
39724	1685	30959690000000	3693	1917	1	0	0
39725	1685	30959700000000	3693	1917	2	0	0
39728	1685	31679700000000	3902	2026	1	0	0
39733	1685	32399710000000	4414	2289	9	0	0
39734	1685	32399800000000	4414	2289	10	0	0
39736	1685	33119800000000	4563	2359	1	0	0
39737	1685	33119810000000	4563	2359	2	0	0
39741	1685	33839810000000	4658	2408	1	0	0
39746	1685	34559820000000	4786	2474	1	0	0
39747	1685	34559830000000	4786	2474	2	0	0
39750	1685	35279830000000	4813	2492	2	0	0
39751	1685	35279940000000	4813	2492	3	0	0
39755	1685	35999950000000	4847	2511	2	0	0
39758	1685	36719950000000	5049	2619	1	0	0
39760	1685	36719960000000	5049	2619	2	0	0
39761	1685	37439960000000	5108	2652	1	0	0
39762	1685	37439970000000	5108	2652	2	0	0
39768	1685	38879970000000	5402	2812	0	0	0
39769	1685	39599970000000	5431	2826	0	0	0
39771	1685	40319970000000	5499	2860	0	0	0
39773	1685	41039970000000	5550	2886	0	0	0
39776	1685	41759970000000	5667	2939	0	0	0
39778	1685	43199970000000	5794	3006	2	0	0
39779	1685	43199990000000	5794	3006	3	0	0
39781	1685	43919990000000	5949	3083	1	0	0
39783	1685	43920000000000	5949	3083	2	0	0
39785	1685	44640010000000	5960	3091	2	0	0
39786	1685	45360010000000	6031	3129	3	0	0
39787	1685	45360040000000	6031	3129	4	0	0
39788	1685	46080040000000	6046	3141	1	0	0
39789	1685	46080050000000	6046	3141	2	0	0
39792	1685	46800060000000	6171	3195	2	0	0
39794	1685	47520060000000	6179	3199	5	0	0
39795	1685	47520110000000	6179	3199	6	0	0
39796	1685	48240110000000	6284	3254	1	0	0
39797	1685	48240120000000	6284	3254	2	0	0
39799	1685	48960130000000	6285	3255	2	0	0
39800	1685	49680130000000	6326	3274	1	0	0
39801	1685	49680140000000	6326	3274	2	0	0
39804	1685	50400140000000	7172	3704	5	0	0
39810	1685	51120190000000	7217	3732	1	0	0
39811	1685	51120200000000	7217	3732	2	0	0
39814	1685	51840200000000	7232	3738	2	0	0
39815	1685	51840220000000	7232	3738	3	0	0
39818	1685	52560220000000	7242	3743	0	0	0
39821	1685	53280230000000	7325	3786	2	0	0
39824	1685	54000230000000	7380	3810	1	0	0
39825	1685	54000240000000	7380	3810	2	0	0
39827	1685	54720240000000	7426	3837	3	0	0
39828	1685	54720270000000	7426	3837	4	0	0
39832	1685	55440280000000	7564	3916	2	0	0
39836	1685	56160280000000	7757	4021	1	0	0
39838	1685	56160290000000	7757	4021	2	0	0
39840	1685	56880290000000	7785	4036	2	0	0
39847	1685	57600310000000	8029	4162	1	0	0
39850	1685	57600330000000	7914	4101	3	0	\N
39851	1685	57600330000000	7927	4109	3	0	\N
39852	1685	57600330000000	7990	4142	3	0	\N
39855	1685	58320350000000	8244	4270	2	0	\N
39856	1685	59040330000000	8100	4198	2	0	\N
39858	1685	59040341000000	8100	4198	3	0	\N
39859	1685	59040350000000	8244	4270	3	0	\N
39861	1685	59760350000000	8341	4319	1	0	\N
39862	1685	59760350000000	8353	4325	3	0	\N
39863	1685	59760350000000	8413	4359	3	0	\N
39865	1685	59760360000000	8341	4319	2	0	\N
39866	1685	59760371000000	8353	4325	4	0	\N
39867	1685	59760470000000	8413	4359	4	0	\N
39871	1685	61920360000000	8557	4435	1	0	\N
39873	1685	61920370000000	8557	4435	2	0	\N
39875	1685	62640370000000	8797	4561	2	0	\N
39876	1685	62640370000000	8820	4572	3	0	\N
39878	1685	62640390000000	8797	4561	3	0	\N
39880	1685	62640400000000	8820	4572	4	0	\N
39881	1685	62640400000000	8989	4661	1	0	\N
39883	1685	63360400000000	8989	4661	7	0	\N
39885	1685	63360441000000	8989	4661	8	0	\N
39886	1685	64080410000000	9098	4714	2	0	\N
39888	1685	64080430000000	9098	4714	3	0	\N
39892	1685	65520550000000	9178	4756	2	0	\N
39893	1685	65520550000000	9259	4801	8	0	\N
39895	1685	65520570000000	9178	4756	3	0	\N
39896	1685	65520630000000	9259	4801	9	0	\N
39902	1685	67680778571430	9418	4887	4	0	\N
39903	1685	67680778571430	9457	4903	2	0	\N
39904	1685	67680778571430	9498	4926	2	0	\N
39905	1685	67680778571430	9568	4961	2	0	\N
39907	1685	67680798571430	9457	4903	3	0	\N
39908	1685	67680798571430	9498	4926	3	0	\N
39909	1685	67680798571430	9568	4961	3	0	\N
39911	1685	67680818571430	9418	4887	5	0	\N
39912	1685	68400798571430	9580	4969	3	0	\N
39915	1685	68400828571430	9580	4969	4	0	\N
39920	1685	69840905571430	9823	5090	9	0	\N
39921	1685	70560878571430	9798	5080	3	0	\N
39922	1685	70560878571430	9837	5099	2	0	\N
39924	1685	70560898571430	9837	5099	3	0	\N
39926	1685	70560905571430	9823	5090	23	0	\N
39927	1685	70560908571430	9798	5080	4	0	\N
39928	1685	70560918571430	9823	5090	24	0	\N
39933	1685	72720968571430	10044	5210	2	0	\N
39934	1685	72720968571430	10080	5228	6	0	\N
39936	1685	72720988571430	10044	5210	3	0	\N
39937	1685	72721019571430	10080	5228	7	0	\N
39939	1685	73441179571430	10138	5256	6	0	\N
39940	1685	73441179571430	10194	5279	4	0	\N
39941	1685	73441179571430	10220	5291	2	0	\N
39943	1685	73441199571430	10220	5291	3	0	\N
39944	1685	73441219571430	10194	5279	5	0	\N
39946	1685	73441329571430	10138	5256	7	0	\N
39947	1685	74161239571430	10375	5363	1	0	\N
39948	1685	74161239571430	10398	5375	2	0	\N
39950	1685	74161249571430	10375	5363	2	0	\N
39951	1685	74161259571430	10398	5375	3	0	\N
39953	1685	74161329571430	10585	5466	2	0	\N
39955	1685	74881329571430	10585	5466	3	0	\N
39957	1685	75601349571430	10815	5580	1	0	\N
39959	1685	75601359571430	10815	5580	2	0	\N
39961	1685	76321409571430	10895	5604	46	0	\N
39962	1685	76321409571430	13065	6735	4	0	\N
39964	1685	76321422571430	13065	6735	5	0	\N
39966	1685	76321869571430	10895	5604	47	0	\N
39967	1685	76322109571430	10913	5605	2	0	\N
39968	1685	77041422571430	13148	6776	5	0	\N
39970	1685	77041445571430	13148	6776	6	0	\N
39972	1685	77042109571430	10913	5605	53	0	\N
39973	1685	77042959571430	10913	5605	54	0	\N
39976	1685	77762959571430	10958	5606	51	0	\N
39977	1685	77763741571430	10958	5606	52	0	\N
39978	1685	77765371571430	11033	5607	22	0	\N
39979	1685	78481457571430	13274	6836	2	0	\N
39980	1685	78481457571430	13282	6841	3	0	\N
39982	1685	78481468571430	13274	6836	3	0	\N
39983	1685	78481469571430	13282	6841	4	0	\N
39854	1685	58320330000000	8047	4169	2	0	0
39857	1685	59040330000000	8335	4317	2	0	0
39860	1685	59040350000000	8335	4317	3	0	0
39864	1685	59760350000000	8433	4371	0	0	0
39868	1685	60480350000000	8441	4374	0	0	0
39870	1685	61200360000000	8502	4403	2	0	0
39872	1685	61920360000000	8691	4505	1	0	0
39874	1685	61920370000000	8691	4505	2	0	0
39877	1685	62640370000000	8857	4589	2	0	0
39879	1685	62640390000000	8857	4589	3	0	0
39884	1685	63360410000000	9041	4688	3	0	0
39887	1685	64080410000000	9099	4715	3	0	0
39889	1685	64080530000000	9099	4715	4	0	0
39890	1685	64800530000000	9170	4752	2	0	0
39894	1685	65520550000000	9269	4806	11	0	0
39897	1685	65520658571430	9269	4806	12	0	0
39898	1685	66240658571430	9354	4854	2	0	0
39899	1685	66240678571430	9354	4854	3	0	0
39900	1685	66960678571430	9404	4879	10	0	0
39906	1685	67680778571430	9576	4967	2	0	0
39910	1685	67680798571430	9576	4967	3	0	0
39913	1685	68400798571430	9588	4974	2	0	0
39914	1685	68400818571430	9588	4974	3	0	0
39916	1685	69120818571430	9607	4984	4	0	0
39918	1685	69840858571430	9660	5013	2	0	0
39919	1685	69840878571430	9660	5013	3	0	0
39923	1685	70560878571430	9945	5162	2	0	0
39925	1685	70560898571430	9945	5162	3	0	0
39930	1685	71280908571430	9961	5170	2	0	0
39931	1685	72000908571430	9989	5178	6	0	0
39932	1685	72000968571430	9989	5178	7	0	0
39935	1685	72720968571430	10088	5233	22	0	0
39938	1685	72721179571430	10088	5233	23	0	0
39945	1685	73441239571430	10295	5326	6	0	0
39949	1685	74161239571430	10414	5387	7	0	0
39952	1685	74161309571430	10414	5387	8	0	0
39954	1685	74881309571430	10762	5554	4	0	0
39956	1685	74881349571430	10762	5554	5	0	0
39960	1685	75601409571430	10853	5603	7	0	0
39963	1685	76321409571430	13134	6770	4	0	0
39965	1685	76321422571430	13134	6770	5	0	0
39969	1685	77041422571430	13214	6810	5	0	0
39974	1685	77761445571430	13252	6826	3	0	0
39975	1685	77761457571430	13252	6826	4	0	0
39981	1685	78481457571430	13455	6931	3	0	0
39984	1685	78481469571430	13455	6931	4	0	0
39985	1685	78485371571430	11033	5607	99	0	\N
39986	1685	78486621570430	11104	5608	49	0	\N
39987	1685	79201469571430	13470	6938	3	0	\N
39988	1685	79201469571430	13525	6963	4	0	\N
39991	1685	79201481571430	13470	6938	4	0	\N
39993	1685	79201491571430	13525	6963	5	0	\N
39994	1685	79206621570430	11104	5608	79	0	\N
39995	1685	79206911570430	11104	5608	80	0	\N
39998	1685	80641483571430	13628	7005	12	0	\N
40001	1685	80641505571430	13655	7019	1	0	\N
40002	1685	80641522571430	13628	7005	13	0	\N
40004	1685	81361505571430	13655	7019	4	0	\N
40005	1685	81361507571430	13655	7019	5	0	\N
40007	1685	82081508571430	13754	7067	4	0	\N
40009	1685	82081521571430	13754	7067	5	0	\N
40011	1685	82801534571430	13846	7106	16	0	\N
40012	1685	82801534571430	13860	7113	4	0	\N
40013	1685	82801534571430	13896	7129	14	0	\N
40014	1685	82801534571430	13997	7171	9	0	\N
40016	1685	82801547571430	13860	7113	5	0	\N
40018	1685	82801561571430	13997	7171	10	0	\N
40019	1685	82801566571430	13896	7129	15	0	\N
40020	1685	82801586571430	13846	7106	17	0	\N
40021	1685	83521548571430	14088	7205	9	0	\N
40022	1685	83521548571430	14157	7226	3	0	\N
40024	1685	83521560571430	14157	7226	4	0	\N
40026	1685	83521584571430	14088	7205	10	0	\N
40043	1685	90001670571430	14622	7453	3	0	\N
40044	1685	90001670571430	14631	7458	3	0	\N
40045	1685	90001670571430	14740	7503	2	0	\N
40047	1685	90001681571430	14740	7503	3	0	\N
40049	1685	90001682571430	14622	7453	4	0	\N
40050	1685	90001682571430	14631	7458	4	0	\N
40052	1685	90721681571430	14823	7555	1	0	\N
40053	1685	90721681571430	14868	7575	2	0	\N
40054	1685	90721682571430	14823	7555	2	0	\N
40055	1685	90721692571430	14868	7575	3	0	\N
40064	1685	93601788571430	15051	7667	1	0	\N
40066	1685	93601798571430	15051	7667	2	0	\N
40072	1685	95761875571430	15361	7827	2	0	\N
40073	1685	95761875571430	15433	7860	7	0	\N
40075	1685	95761886571430	15361	7827	3	0	\N
40077	1685	95761909571430	15433	7860	8	0	\N
40080	1685	97201898571430	15553	7917	1	0	\N
40081	1685	97201898571430	15555	7918	5	0	\N
40082	1685	97201898571430	15557	7919	6	0	\N
40084	1685	97201908571430	15553	7917	2	0	\N
40086	1685	97201921571430	15555	7918	6	0	\N
40087	1685	97201940571430	15557	7919	7	0	\N
40093	1685	98642015571430	15827	8052	7	0	\N
40094	1685	99361945571430	15832	8054	5	0	\N
40097	1685	99361977571430	15832	8054	6	0	\N
40098	1685	99362015571430	15827	8052	20	0	\N
40103	1685	101521993571430	15914	8092	6	0	\N
40104	1685	101521993571430	16002	8137	3	0	\N
40105	1685	101521993571430	16063	8168	4	0	\N
40107	1685	101522005571430	16002	8137	4	0	\N
40108	1685	101522006571430	16063	8168	5	0	\N
40109	1685	101522017571430	15914	8092	7	0	\N
40115	1685	103682078571430	16178	8223	3	0	\N
40118	1685	103682090571430	16178	8223	4	0	\N
39992	1685	79201481571430	13618	7001	2	0	0
39996	1685	79921481571430	13618	7001	5	0	0
39997	1685	79921483571430	13618	7001	6	0	0
39999	1685	80641483571430	13652	7018	3	0	0
40000	1685	80641495571430	13652	7018	4	0	0
40006	1685	81361508571430	13752	7066	5	0	0
40008	1685	82081508571430	13839	7104	8	0	0
40010	1685	82081534571430	13839	7104	9	0	0
40015	1685	82801534571430	14016	7183	5	0	0
40017	1685	82801548571430	14016	7183	6	0	0
40025	1685	83521560571430	14160	7227	4	0	0
40027	1685	84241560571430	14249	7275	4	0	0
40028	1685	84241573571430	14249	7275	5	0	0
40029	1685	84961573571430	14271	7285	4	0	0
40031	1685	85681586571430	14327	7310	4	0	0
40032	1685	85681599571430	14327	7310	5	0	0
40033	1685	86401599571430	14328	7311	4	0	0
40034	1685	86401612571430	14328	7311	5	0	0
40035	1685	87121612571430	14381	7337	11	0	0
40037	1685	87841632571430	14382	7338	6	0	0
40038	1685	87841656571430	14382	7338	7	0	0
40039	1685	88561656571430	14393	7344	3	0	0
40040	1685	88561668571430	14393	7344	4	0	0
40041	1685	89281668571430	14585	7437	2	0	0
40046	1685	90001670571430	14755	7513	2	0	0
40048	1685	90001681571430	14755	7513	3	0	0
40051	1685	90001701571430	14893	7589	2	0	0
40056	1685	90721701571430	14893	7589	9	0	0
40058	1685	91441707571430	14925	7604	3	0	0
40059	1685	91441719571430	14925	7604	4	0	0
40060	1685	92161719571430	15015	7650	5	0	0
40061	1685	92161742571430	15015	7650	6	0	0
40062	1685	92881742571430	15023	7655	10	0	0
40065	1685	93601788571430	15079	7680	5	0	0
40067	1685	93601820571430	15079	7680	6	0	0
40068	1685	94321820571430	15147	7721	7	0	0
40070	1685	95041863571430	15227	7756	3	0	0
40071	1685	95041875571430	15227	7756	4	0	0
40074	1685	95761875571430	15469	7876	3	0	0
40076	1685	95761887571430	15469	7876	4	0	0
40078	1685	96481887571430	15483	7883	2	0	0
40079	1685	96481898571430	15483	7883	3	0	0
40085	1685	97201910571430	15633	7957	4	0	0
40088	1685	97921910571430	15663	7973	3	0	0
40089	1685	97921922571430	15663	7973	4	0	0
40090	1685	98641922571430	15788	8032	5	0	0
40091	1685	98641945571430	15788	8032	6	0	0
40095	1685	99361956571430	15863	8067	4	0	0
40096	1685	99361957571430	15863	8067	5	0	0
40099	1685	100081957571430	15881	8076	3	0	0
40100	1685	100081969571430	15881	8076	4	0	0
40101	1685	100081993571430	15906	8087	6	0	0
40106	1685	101521993571430	16112	8190	13	0	0
40110	1685	101522042571430	16112	8190	14	0	0
40111	1685	102242042571430	16141	8205	6	0	0
40112	1685	102242066571430	16141	8205	7	0	0
40114	1685	102962078571430	16176	8222	4	0	0
40116	1685	103682078571430	16221	8244	2	0	0
40117	1685	103682089571430	16221	8244	3	0	0
40119	1685	104402089571430	16245	8257	4	0	0
40120	1685	104402102571430	16245	8257	5	0	0
40133	1685	109442175571430	16449	8366	7	0	\N
40134	1685	109442175571430	16473	8378	3	0	\N
40136	1685	109442187571430	16473	8378	4	0	\N
40138	1685	109442200571430	16449	8366	8	0	\N
40139	1685	110162187571430	16583	8427	6	0	\N
40141	1685	110162211571430	16583	8427	7	0	\N
40149	1685	113042284571430	16793	8523	3	0	\N
40151	1685	113042296571430	16793	8523	4	0	\N
40155	1685	114482346571430	16895	8568	4	0	\N
40156	1685	114482346571430	16918	8576	3	0	\N
40157	1685	114482346571430	16941	8587	3	0	\N
40158	1685	114482346571430	16978	8601	1	0	\N
40160	1685	114482356571430	16978	8601	2	0	\N
40162	1685	114482358571430	16918	8576	4	0	\N
40163	1685	114482358571430	16941	8587	4	0	\N
40164	1685	114482359571430	16895	8568	5	0	\N
40165	1685	115202357571430	17178	8707	3	0	\N
40166	1685	115202357571430	17197	8714	4	0	\N
40168	1685	115202369571430	17178	8707	4	0	\N
40170	1685	115202370571430	17197	8714	5	0	\N
40171	1685	115922369571430	17340	8785	3	0	\N
40173	1685	115922381571430	17340	8785	4	0	\N
40183	1685	118802441571430	17577	8868	0	0	\N
40184	1685	118802441571430	17578	8884	0	0	\N
40188	1685	120242463571430	17617	8909	3	0	\N
40189	1685	120242463571430	17637	8917	3	0	\N
40190	1685	120242463571430	17719	8955	7	0	\N
40192	1685	120242475571430	17617	8909	4	0	\N
40193	1685	120242475571430	17637	8917	4	0	\N
40195	1685	120242497571430	17719	8955	8	0	\N
40198	1685	121682499571430	17902	9032	7	0	\N
40199	1685	121682499571430	18061	9109	6	0	\N
40202	1685	121682524571430	17902	9032	8	0	\N
40203	1685	121682532571430	18061	9109	7	0	\N
40206	1685	123122545571430	18140	9146	2	0	\N
40208	1685	123122556571430	18140	9146	3	0	\N
40212	1685	124562567571430	18337	9238	5	0	\N
40215	1685	124562590571430	18337	9238	6	0	\N
40218	1685	126002591571430	18586	9366	4	0	\N
40221	1685	126002613571430	18586	9366	5	0	\N
40226	1685	128162637571430	18632	9388	5	0	\N
40227	1685	128162637571430	18659	9401	6	0	\N
40228	1685	128162637571430	18668	9406	2	0	\N
40230	1685	128162648571430	18668	9406	3	0	\N
40232	1685	128162660571430	18632	9388	6	0	\N
40233	1685	128162661571430	18659	9401	7	0	\N
40234	1685	128882648571430	18786	9466	5	0	\N
40235	1685	128882648571430	18803	9475	5	0	\N
40238	1685	128882671571430	18786	9466	6	0	\N
40239	1685	128882671571430	18803	9475	6	0	\N
40243	1685	130322668571430	18908	9509	0	0	\N
40245	1685	131042678571430	18909	9527	0	0	\N
40246	1685	131042678571430	18958	9563	1	0	\N
40248	1685	131042688571430	18958	9563	2	0	\N
40254	1685	133202722571430	19260	9709	10	0	\N
40123	1685	105842114571430	16300	8282	3	0	0
40124	1685	105842126571430	16300	8282	4	0	0
40125	1685	106562126571430	16322	8294	3	0	0
40126	1685	106562138571430	16322	8294	4	0	0
40127	1685	107282138571430	16362	8322	3	0	0
40129	1685	108002150571430	16397	8340	3	0	0
40130	1685	108002162571430	16397	8340	4	0	0
40131	1685	108722162571430	16443	8362	4	0	0
40132	1685	108722175571430	16443	8362	5	0	0
40135	1685	109442175571430	16506	8396	3	0	0
40140	1685	110162187571430	16588	8429	6	0	0
40142	1685	110162211571430	16588	8429	7	0	0
40143	1685	110882211571430	16626	8445	3	0	0
40144	1685	110882223571430	16626	8445	4	0	0
40146	1685	111602247571430	16650	8460	7	0	0
40147	1685	112322247571430	16710	8490	10	0	0
40148	1685	112322284571430	16710	8490	11	0	0
40150	1685	113042284571430	16848	8549	4	0	0
40152	1685	113042297571430	16848	8549	5	0	0
40154	1685	113762346571430	16869	8556	14	0	0
40159	1685	114482346571430	17012	8618	2	0	0
40161	1685	114482357571430	17012	8618	3	0	0
40167	1685	115202357571430	17317	8773	3	0	0
40169	1685	115202369571430	17317	8773	4	0	0
40174	1685	115922381571430	17346	8788	4	0	0
40175	1685	116642381571430	17404	8816	3	0	0
40176	1685	116642393571430	17404	8816	4	0	0
40177	1685	116642415571430	17441	8833	4	0	0
40179	1685	117362417571430	17441	8833	8	0	0
40180	1685	118082417571430	17505	8863	6	0	0
40181	1685	118082441571430	17505	8863	7	0	0
40182	1685	118802441571430	17545	8884	2	0	0
40185	1685	118802452571430	17545	8884	3	0	0
40187	1685	119522463571430	17602	8903	3	0	0
40191	1685	120242463571430	17802	8992	3	0	0
40194	1685	120242475571430	17802	8992	4	0	0
40196	1685	120962475571430	17842	9007	6	0	0
40197	1685	120962499571430	17842	9007	7	0	0
40201	1685	121682511571430	18093	9123	4	0	0
40204	1685	122402511571430	18137	9145	7	0	0
40205	1685	122402545571430	18137	9145	8	0	0
40207	1685	123122545571430	18255	9195	2	0	0
40210	1685	123842556571430	18322	9228	2	0	0
40211	1685	123842567571430	18322	9228	3	0	0
40213	1685	124562567571430	18490	9313	3	0	0
40214	1685	124562579571430	18490	9313	4	0	0
40216	1685	125282579571430	18529	9334	3	0	0
40219	1685	126002591571430	18612	9377	3	0	0
40220	1685	126002603571430	18612	9377	4	0	0
40222	1685	126722603571430	18615	9379	2	0	0
40223	1685	126722614571430	18615	9379	3	0	0
40224	1685	127442614571430	18628	9387	5	0	0
40229	1685	128162637571430	18756	9454	2	0	0
40231	1685	128162648571430	18756	9454	3	0	0
40236	1685	128882648571430	18833	9491	1	0	0
40237	1685	128882658571430	18833	9491	2	0	0
40241	1685	129602668571430	18844	9500	2	0	0
40242	1685	130322668571430	18879	9520	1	0	0
40244	1685	130322678571430	18879	9520	2	0	0
40247	1685	131042678571430	19053	9610	3	0	0
40249	1685	131042699571430	19053	9610	4	0	0
40251	1685	131762710571430	19111	9641	3	0	0
40252	1685	132482710571430	19157	9664	3	0	0
40253	1685	132482722571430	19157	9664	4	0	0
40255	1685	133202722571430	19426	9790	4	0	0
40256	1685	133202735571430	19426	9790	5	0	0
40257	1685	133202759571430	19260	9709	11	0	\N
40264	1685	135362774571430	19659	9902	3	0	\N
40265	1685	135362786571430	19659	9902	4	0	\N
40270	1685	136802824571430	19943	10041	3	0	\N
40271	1685	136802824571430	20074	10103	4	0	\N
40273	1685	136802836571430	19943	10041	4	0	\N
40275	1685	136802837571430	20074	10103	5	0	\N
40276	1685	136802857571430	20286	10215	3	0	\N
40277	1685	137522836571430	20257	10202	3	0	\N
40279	1685	137522848571430	20257	10202	4	0	\N
40280	1685	137522857571430	20286	10215	7	0	\N
40281	1685	137522860571430	20286	10215	8	0	\N
40283	1685	138242861571430	20303	10223	3	0	\N
40285	1685	138242873571430	20303	10223	4	0	\N
40287	1685	138962873571430	20418	10286	5	0	\N
40289	1685	138962887571430	20418	10286	6	0	\N
40293	1685	140403082571430	20728	10420	10	0	\N
40295	1685	140403119571430	20728	10420	11	0	\N
40301	1685	142563158571430	21020	10568	2	0	\N
40302	1685	142563158571430	21049	10577	3	0	\N
40304	1685	142563169571430	21020	10568	3	0	\N
40305	1685	142563170571430	21049	10577	4	0	\N
40317	1685	146883300571430	21358	10700	7	0	\N
40320	1685	146884103571430	21358	10700	8	0	\N
40321	1685	147603350571430	22183	11100	6	0	\N
40323	1685	147603350571430	22734	11080	0	0	\N
40324	1685	147603350571430	22735	11097	0	0	\N
40326	1685	147603374571430	22183	11100	7	0	\N
40327	1685	147604103571430	21397	10701	2	0	\N
40328	1685	147604114571430	21397	10701	3	0	\N
40331	1685	148324114571430	21453	10702	18	0	\N
40332	1685	148324327571430	21453	10702	19	0	\N
40333	1685	149043374571430	22370	11196	7	0	\N
40334	1685	149043374571430	22393	11210	4	0	\N
40336	1685	149043387571430	22393	11210	5	0	\N
40338	1685	149043399571430	22370	11196	8	0	\N
40339	1685	149044327571430	21493	10703	1	0	\N
40340	1685	149044337571430	21493	10703	2	0	\N
40342	1685	149763387571430	23118	11257	0	0	\N
40344	1685	149764337571430	21526	10704	1	0	\N
40345	1685	149764347571430	21526	10704	2	0	\N
40346	1685	150483459571430	22537	11276	12	0	\N
40347	1685	150483459571430	22614	11312	7	0	\N
40348	1685	150483459571430	22619	11313	4	0	\N
40349	1685	150483459571430	22695	11347	6	0	\N
40350	1685	150483459571430	22701	11349	4	0	\N
40352	1685	150483472571430	22619	11313	5	0	\N
40353	1685	150483472571430	22701	11349	5	0	\N
40354	1685	150483474571430	22695	11347	7	0	\N
40355	1685	150483475571430	22614	11312	8	0	\N
40358	1685	150483516571430	22537	11276	13	0	\N
40359	1685	150484347571430	21594	10705	2	0	\N
40360	1685	150484349571430	21594	10705	3	0	\N
40362	1685	151204349571430	21619	10706	0	0	\N
40365	1685	151924349571430	21676	10707	0	0	\N
40368	1685	152644349571430	21764	10708	0	0	\N
40371	1685	153364349571430	21800	10709	0	0	\N
40372	1685	154083614571430	23024	11498	3	0	\N
40373	1685	154083614571430	23032	11499	3	0	\N
40374	1685	154083614571430	23100	11536	1	0	\N
40375	1685	154083614571430	23244	11547	6	0	\N
40376	1685	154083614571430	23934	11912	4	0	\N
40377	1685	154083614571430	24096	11995	2	0	\N
40379	1685	154083615571430	23100	11536	2	0	\N
40380	1685	154083625571430	24096	11995	3	0	\N
40381	1685	154083626571430	23024	11498	4	0	\N
40382	1685	154083626571430	23032	11499	4	0	\N
40383	1685	154083627571430	23934	11912	5	0	\N
40385	1685	154083728571430	23244	11547	7	0	\N
40386	1685	154803636571430	24158	12024	3	0	\N
40389	1685	154803648571430	24158	12024	4	0	\N
40391	1685	154803728571430	23324	11548	1	0	\N
40392	1685	154803729571430	23324	11548	2	0	\N
40260	1685	133922761571430	19479	9820	10	0	0
40261	1685	134642761571430	19517	9834	4	0	0
40262	1685	134642774571430	19517	9834	5	0	0
40263	1685	134642798571430	19785	9963	6	0	0
40266	1685	135362798571430	19785	9963	8	0	0
40268	1685	136082799571430	19879	10014	7	0	0
40269	1685	136082824571430	19879	10014	8	0	0
40272	1685	136802824571430	20184	10164	3	0	0
40274	1685	136802836571430	20184	10164	4	0	0
40278	1685	137522836571430	20300	10221	7	0	0
40284	1685	138242861571430	20308	10227	3	0	0
40286	1685	138242873571430	20308	10227	4	0	0
40288	1685	138962873571430	20526	10332	8	0	0
40290	1685	138962908571430	20526	10332	9	0	0
40292	1685	139683082571430	20631	10380	13	0	0
40294	1685	140403082571430	20744	10428	6	0	0
40296	1685	140403124571430	20744	10428	7	0	0
40297	1685	141123124571430	20864	10488	5	0	0
40298	1685	141123147571430	20864	10488	6	0	0
40300	1685	141843158571430	20951	10537	3	0	0
40303	1685	142563158571430	21064	10584	6	0	0
40306	1685	142563209571430	21064	10584	7	0	0
40307	1685	143283209571430	21183	10637	2	0	0
40308	1685	143283220571430	21183	10637	3	0	0
40310	1685	144003264571430	21191	10640	9	0	0
40311	1685	144723264571430	21260	10677	2	0	0
40312	1685	144723275571430	21260	10677	3	0	0
40313	1685	145443275571430	21285	10687	4	0	0
40315	1685	146163288571430	21305	10696	3	0	0
40316	1685	146163300571430	21305	10696	4	0	0
40318	1685	146883300571430	22045	11024	14	0	0
40319	1685	146883350571430	22045	11024	15	0	0
40322	1685	147603350571430	22188	11104	3	0	0
40329	1685	148323362571430	22301	11163	3	0	0
40330	1685	148323374571430	22301	11163	4	0	0
40335	1685	149043374571430	22461	11239	4	0	0
40337	1685	149043387571430	22461	11239	5	0	0
40341	1685	149763387571430	22523	11267	9	0	0
40351	1685	150483459571430	22743	11373	5	0	0
40356	1685	150483482571430	22743	11373	6	0	0
40357	1685	150483504571430	22761	11381	4	0	0
40361	1685	151203504571430	22761	11381	5	0	0
40364	1685	151923579571430	22774	11388	22	0	0
40366	1685	152643579571430	22779	11392	3	0	0
40367	1685	152643591571430	22779	11392	4	0	0
40369	1685	153363591571430	22992	11484	5	0	0
40370	1685	153363614571430	22992	11484	6	0	0
40384	1685	154083636571430	24155	12023	5	0	0
40387	1685	154803636571430	24176	12033	2	0	0
40388	1685	154803647571430	24176	12033	3	0	0
40390	1685	154803671571430	24207	12048	6	0	0
40394	1685	155523729571430	23327	11549	0	0	\N
40397	1685	156243729571430	23388	11550	1	0	\N
40398	1685	156243739571430	23388	11550	2	0	\N
40399	1685	156963683571430	24249	12066	13	0	\N
40400	1685	156963683571430	24361	12115	2	0	\N
40402	1685	156963694571430	24361	12115	3	0	\N
40403	1685	156963732571430	24249	12066	14	0	\N
40404	1685	156963739571430	23389	11551	0	0	\N
40406	1685	157683739571430	23479	11552	1	0	\N
40407	1685	157683749571430	23479	11552	2	0	\N
40408	1685	157683805571430	24404	12135	3	0	\N
40409	1685	157683805571430	24419	12145	2	0	\N
40410	1685	157683805571430	24451	12159	4	0	\N
40412	1685	157683816571430	24419	12145	3	0	\N
40413	1685	157683817571430	24404	12135	4	0	\N
40414	1685	157683827571430	24451	12159	5	0	\N
40416	1685	158403749571430	23535	11553	7	0	\N
40417	1685	158403819571430	23535	11553	8	0	\N
40418	1685	158403829571430	24554	12205	2	0	\N
40420	1685	158403840571430	24554	12205	3	0	\N
40422	1685	159123819571430	23607	11554	7	0	\N
40425	1685	159123889571430	23607	11554	8	0	\N
40426	1685	159843853571430	24672	12253	4	0	\N
40428	1685	159843866571430	24672	12253	5	0	\N
40429	1685	159843889571430	23657	11555	5	0	\N
40431	1685	159844291571430	23657	11555	6	0	\N
40434	1685	160564291571430	23680	11556	0	0	\N
40437	1685	161284291571430	23700	11557	0	0	\N
40450	1685	166324079571430	25279	12539	6	0	\N
40453	1685	166324103571430	25279	12539	7	0	\N
40459	1685	168484217571430	25440	12604	3	0	\N
40461	1685	168484229571430	25440	12604	4	0	\N
40467	1685	170644254571430	25539	12644	2	0	\N
40469	1685	170644265571430	25539	12644	3	0	\N
40471	1685	170644296571430	25574	12660	3	0	\N
40473	1685	171364296571430	25574	12660	10	0	\N
40474	1685	171364302571430	25574	12660	11	0	\N
40476	1685	172084308571430	25579	12662	3	0	\N
40477	1685	172084308571430	25650	12694	4	0	\N
40479	1685	172084320571430	25579	12662	4	0	\N
40481	1685	172084321571430	25650	12694	5	0	\N
40486	1685	174244342571430	25965	12829	5	0	\N
40489	1685	174244365571430	25965	12829	6	0	\N
40496	1685	177124441571430	26163	12932	3	0	\N
40497	1685	177124441571430	26173	12939	0	0	\N
40499	1685	177124453571430	26163	12932	4	0	\N
40502	1685	177844453571430	26340	13026	5	0	\N
40503	1685	177844476571430	26340	13026	6	0	\N
40506	1685	178564490571430	26517	13119	3	0	\N
40508	1685	178564502571430	26517	13119	4	0	\N
40510	1685	179284515571430	26557	13140	3	0	\N
40511	1685	179284515571430	26602	13160	5	0	\N
40513	1685	179284527571430	26557	13140	4	0	\N
40515	1685	179284529571430	26602	13160	6	0	\N
40519	1685	180724563571430	26934	13321	6	0	\N
40522	1685	180724587571430	26934	13321	7	0	\N
40527	1685	182884611571430	27135	13418	3	0	\N
40528	1685	182884611571430	27145	13422	8	0	\N
40396	1685	156243683571430	24232	12058	4	0	0
40401	1685	156963683571430	24365	12117	5	0	0
40405	1685	156963805571430	24365	12117	6	0	0
40411	1685	157683805571430	24498	12183	6	0	0
40415	1685	157683829571430	24498	12183	7	0	0
40421	1685	158403841571430	24563	12211	4	0	0
40423	1685	159123841571430	24626	12236	3	0	0
40424	1685	159123853571430	24626	12236	4	0	0
40427	1685	159843853571430	24700	12267	8	0	0
40430	1685	159843915571430	24700	12267	9	0	0
40433	1685	160563950571430	24718	12276	9	0	0
40435	1685	161283950571430	24732	12282	7	0	0
40436	1685	161283993571430	24732	12282	8	0	0
40438	1685	162003993571430	24969	12392	4	0	0
40440	1685	162724006571430	25063	12437	3	0	0
40441	1685	162724018571430	25063	12437	4	0	0
40442	1685	163444018571430	25196	12499	8	0	0
40443	1685	163444044571430	25196	12499	9	0	0
40444	1685	164164044571430	25220	12511	3	0	0
40446	1685	164884056571430	25264	12532	2	0	0
40447	1685	164884067571430	25264	12532	3	0	0
40448	1685	165604067571430	25272	12536	3	0	0
40449	1685	165604079571430	25272	12536	4	0	0
40451	1685	166324079571430	25358	12572	3	0	0
40454	1685	167044091571430	25359	12573	4	0	0
40455	1685	167044203571430	25359	12573	5	0	0
40456	1685	167764203571430	25420	12596	5	0	0
40457	1685	167764217571430	25420	12596	6	0	0
40460	1685	168484227571430	25476	12617	5	0	0
40462	1685	168484230571430	25476	12617	6	0	0
40463	1685	169204230571430	25509	12632	3	0	0
40464	1685	169204242571430	25509	12632	4	0	0
40465	1685	169924242571430	25518	12634	3	0	0
40468	1685	170644254571430	25562	12656	3	0	0
40470	1685	170644266571430	25562	12656	4	0	0
40472	1685	171364266571430	25576	12661	15	0	0
40475	1685	171364308571430	25576	12661	16	0	0
40478	1685	172084308571430	25725	12727	3	0	0
40482	1685	172804320571430	25911	12805	2	0	0
40483	1685	172804331571430	25911	12805	3	0	0
40484	1685	173524331571430	25930	12814	2	0	0
40485	1685	173524342571430	25930	12814	3	0	0
40488	1685	174244353571430	25979	12837	3	0	0
40490	1685	174964353571430	26020	12859	3	0	0
40491	1685	174964365571430	26020	12859	4	0	0
40492	1685	175684365571430	26049	12872	11	0	0
40493	1685	175684430571430	26049	12872	12	0	0
40495	1685	176404441571430	26058	12877	3	0	0
40498	1685	177124441571430	26260	12984	3	0	0
40500	1685	177124453571430	26260	12984	4	0	0
40501	1685	177124485571430	26511	13116	5	0	0
40504	1685	177844485571430	26511	13116	11	0	0
40507	1685	178564490571430	26542	13131	7	0	0
40509	1685	178564515571430	26542	13131	8	0	0
40512	1685	179284515571430	26624	13170	3	0	0
40514	1685	179284527571430	26624	13170	4	0	0
40517	1685	180004562571430	26930	13320	10	0	0
40518	1685	180004563571430	26930	13320	11	0	0
40520	1685	180724563571430	27081	13389	3	0	0
40521	1685	180724575571430	27081	13389	4	0	0
40523	1685	181444575571430	27091	13394	3	0	0
40525	1685	182164587571430	27093	13396	6	0	0
40526	1685	182164611571430	27093	13396	7	0	0
40530	1685	182884623571430	27135	13418	4	0	\N
40532	1685	182884646571430	27145	13422	9	0	\N
40543	1685	187204761571430	27580	13630	6	0	\N
40546	1685	187204785571430	27580	13630	7	0	\N
40547	1685	187924773571430	27628	13654	4	0	\N
40550	1685	187924786571430	27628	13654	5	0	\N
40553	1685	189364796571430	27792	13733	3	0	\N
40556	1685	189364811571430	27792	13733	4	0	\N
40565	1685	192964880571430	27963	13832	7	0	\N
40568	1685	192964914571430	27963	13832	8	0	\N
40570	1685	193684892571430	28006	13849	6	0	\N
40571	1685	193684892571430	28094	13887	3	0	\N
40572	1685	193684892571430	28265	13974	2	0	\N
40573	1685	193684903571430	28265	13974	3	0	\N
40574	1685	193684904571430	28094	13887	4	0	\N
40575	1685	193684916571430	28006	13849	7	0	\N
40578	1685	194404926571430	28514	14089	5	0	\N
40580	1685	194404940571430	28514	14089	6	0	\N
40586	1685	196564986571430	28686	14161	4	0	\N
40589	1685	196564999571430	28686	14161	5	0	\N
40592	1685	198004998571430	29156	14377	9	0	\N
40595	1685	198005034571430	29156	14377	10	0	\N
40598	1685	199445022571430	29538	14564	3	0	\N
40599	1685	199445022571430	29549	14568	7	0	\N
40602	1685	199445034571430	29538	14564	4	0	\N
40603	1685	199445047571430	29549	14568	8	0	\N
40606	1685	200885045571430	29749	14663	24	0	\N
40607	1685	200885045571430	29913	14737	10	0	\N
40610	1685	200885064571430	29913	14737	11	0	\N
40611	1685	200885096571430	29749	14663	25	0	\N
40612	1685	201605063571430	29933	14744	15	0	\N
40615	1685	201605092571430	29957	14754	2	0	\N
40616	1685	201605096246454	29933	14744	17	0	\N
40618	1685	202325092571430	29957	14754	11	0	\N
40620	1685	202325100364230	29957	14754	12	1	\N
40621	1685	203045099571430	30054	14796	10	0	\N
40624	1685	203045118571430	30054	14796	11	0	\N
40627	1685	204485130571430	30251	14873	11	0	\N
40628	1685	204485130571430	30314	14898	5	0	\N
40629	1685	204485147571430	30314	14898	6	0	\N
40630	1685	204485150571430	30251	14873	12	0	\N
40631	1686	1602800000	22903	11432	10	1	\N
40636	1686	1651815500013	3093	1606	8	0	\N
40637	1686	1651815500013	3171	1648	1	0	\N
40639	1686	1651825500013	3171	1648	2	0	\N
40641	1686	1651895500013	3093	1606	9	0	\N
40644	1686	2159030000000	444	249	3	0	\N
40645	1686	2159060000000	444	249	4	0	\N
40646	1686	2371781550062	12249	6308	4	0	\N
40647	1686	2371781550062	12250	6301	17	0	\N
40650	1686	2371794550062	12249	6308	5	0	\N
40653	1686	2371852550062	12250	6301	18	0	\N
40654	1686	2372984550062	12321	6302	52	0	\N
40658	1686	3091826500013	3730	1936	1	0	\N
40659	1686	3091826500013	3852	2000	1	0	\N
40660	1686	3091826500013	3985	2069	2	0	\N
40663	1686	3091836500013	3730	1936	2	0	\N
40664	1686	3091836500013	3852	2000	2	0	\N
40634	1686	1439020000000	214	125	1	0	0
40635	1686	1439030000000	214	125	2	0	0
40642	1686	2157930000000	740	414	1	0	1
40643	1686	2157940000000	740	414	2	0	1
40655	1686	2877940000000	747	419	1	0	1
40638	1686	1651815500013	3446	1789	1	0	2
40640	1686	1651825500013	3446	1789	2	0	2
40651	1686	2371825500013	3521	1829	1	0	2
40652	1686	2371826500013	3521	1829	2	0	2
40661	1686	3091826500013	4130	2148	2	0	2
40649	1686	2371782550062	12320	6349	2	0	9
40657	1686	3091782550062	12577	6483	6	0	9
40662	1686	3091833550062	12577	6483	7	0	9
40529	1685	182884611571430	27196	13451	6	0	0
40533	1685	183604635571430	27320	13506	3	0	0
40534	1685	183604647571430	27320	13506	4	0	0
40535	1685	184324647571430	27382	13540	9	0	0
40536	1685	184324683571430	27382	13540	10	0	0
40537	1685	185044683571430	27459	13572	9	0	0
40539	1685	185764701571430	27530	13610	6	0	0
40540	1685	185764725571430	27530	13610	7	0	0
40541	1685	186484725571430	27545	13616	9	0	0
40542	1685	186484761571430	27545	13616	10	0	0
40544	1685	187204761571430	27586	13634	3	0	0
40548	1685	187924773571430	27692	13683	3	0	0
40549	1685	187924785571430	27692	13683	4	0	0
40551	1685	188644785571430	27752	13709	2	0	0
40552	1685	188644796571430	27752	13709	3	0	0
40555	1685	189364808571430	27813	13744	4	0	0
40557	1685	190084808571430	27844	13763	6	0	0
40558	1685	190084832571430	27844	13763	7	0	0
40559	1685	190804832571430	27913	13805	3	0	0
40560	1685	190804844571430	27913	13805	4	0	0
40562	1685	191524856571430	27921	13810	4	0	0
40563	1685	192244856571430	27949	13826	6	0	0
40564	1685	192244880571430	27949	13826	7	0	0
40566	1685	192964880571430	28002	13848	3	0	0
40567	1685	192964892571430	28002	13848	4	0	0
40576	1685	193684923571430	28323	14003	8	0	0
40577	1685	193684926571430	28323	14003	9	0	0
40579	1685	194404926571430	28565	14111	7	0	0
40581	1685	194404951571430	28565	14111	8	0	0
40583	1685	195124963571430	28628	14136	4	0	0
40584	1685	195844963571430	28652	14146	5	0	0
40585	1685	195844986571430	28652	14146	6	0	0
40587	1685	196564986571430	28788	14201	2	0	0
40588	1685	196564997571430	28788	14201	3	0	0
40591	1685	197284998571430	28874	14243	2	0	0
40593	1685	198004998571430	29251	14415	2	0	0
40594	1685	198005009571430	29251	14415	3	0	0
40596	1685	198725009571430	29498	14545	4	0	0
40597	1685	198725022571430	29498	14545	5	0	0
40601	1685	199445033571430	29598	14595	3	0	0
40604	1685	200165033571430	29614	14605	3	0	0
40605	1685	200165045571430	29614	14605	4	0	0
40608	1685	200885045571430	29921	14740	9	0	0
40613	1685	201605063571430	29949	14750	9	0	0
40614	1685	201605081571430	29949	14750	10	0	0
40617	1685	202325081571430	30002	14773	9	0	0
40619	1685	202325099571430	30002	14773	10	0	0
40622	1685	203045099571430	30131	14827	3	0	0
40625	1685	203765111571430	30175	14846	10	0	0
40626	1685	203765130571430	30175	14846	11	0	0
40665	1686	3091846500013	3985	2069	3	0	\N
40667	1686	3092984550062	12321	6302	58	0	\N
40668	1686	3092989550062	12321	6302	59	0	\N
40669	1686	3257989550062	12578	6303	0	0	\N
40676	1686	3812016500013	4396	2279	6	0	\N
40677	1686	4317960000000	1055	585	36	0	\N
40680	1686	4318490000000	2743	1392	48	0	\N
40681	1686	4319310000000	1055	585	37	0	\N
40682	1686	4531844550062	13024	6714	2	0	\N
40683	1686	4531844550062	13081	6740	3	0	\N
40685	1686	4531855550062	13024	6714	3	0	\N
40686	1686	4531856550062	13081	6740	4	0	\N
40688	1686	4531956500013	4395	2279	5	0	\N
40691	1686	4532006500013	4395	2279	6	0	\N
40692	1686	4532016500013	4396	2279	12	0	\N
40693	1686	4532066500013	4396	2279	13	0	\N
40694	1686	5038010000000	1870	996	1	0	\N
40695	1686	5038010000000	1990	1052	1	0	\N
40696	1686	5038010000000	2095	1106	2	0	\N
40697	1686	5038010000000	2369	1237	1	0	\N
40698	1686	5038010000000	2548	1341	4	0	\N
40699	1686	5038010000000	2741	1439	2	0	\N
40700	1686	5038010000000	2929	1524	2	0	\N
40702	1686	5038020000000	1870	996	2	0	\N
40703	1686	5038020000000	1990	1052	2	0	\N
40704	1686	5038020000000	2369	1237	2	0	\N
40706	1686	5038030000000	2095	1106	3	0	\N
40707	1686	5038030000000	2741	1439	3	0	\N
40708	1686	5038030000000	2929	1524	3	0	\N
40709	1686	5038050000000	2548	1341	5	0	\N
40710	1686	5038490000000	2743	1392	71	0	\N
40711	1686	5038710000000	2743	1392	72	0	\N
40714	1686	5251966500013	4930	2552	2	0	\N
40716	1686	5251986500013	4930	2552	3	0	\N
40724	1686	6151789700122	21684	10863	4	0	\N
40727	1686	6151821700122	21684	10863	5	0	\N
40730	1686	6692026500013	6606	3417	8	0	\N
40731	1686	6692026500013	6609	3419	2	0	\N
40732	1686	6692026500013	6614	3414	0	0	\N
40733	1686	6692026500013	6615	3418	0	0	\N
40734	1686	6692026500013	6918	3572	2	0	\N
40736	1686	6692046500013	6609	3419	3	0	\N
40737	1686	6692046500013	6918	3572	3	0	\N
40739	1686	6692106500013	6606	3417	9	0	\N
40742	1686	7411907550062	15152	7724	0	0	\N
40746	1686	7411940550062	15600	7941	1	0	\N
40747	1686	7412056500013	7612	3939	3	0	\N
40748	1686	7412056500013	7625	3945	2	0	\N
40751	1686	7412076500013	7625	3945	3	0	\N
40752	1686	7412086500013	7612	3939	4	0	\N
40753	1686	7591885700122	21948	10980	0	0	\N
40758	1686	8131940550062	15600	7941	3	0	\N
40760	1686	8131941550062	15600	7941	4	0	\N
40767	1686	8852076500013	8239	4269	1	0	\N
40768	1686	8852076500013	8482	4394	2	0	\N
40769	1686	8852076500013	8580	4449	1	0	\N
40771	1686	8852086500013	8239	4269	2	0	\N
40772	1686	8852086500013	8580	4449	2	0	\N
40774	1686	8852286500013	8482	4394	3	0	\N
40783	1686	9752002700122	22903	11432	5	0	\N
40786	1686	10292116500013	9019	4677	2	0	\N
40788	1686	10292136500013	9019	4677	3	0	\N
40790	1686	10471997700122	22557	11286	3	0	\N
40791	1686	10471997700122	22749	11376	3	0	\N
40792	1686	10471997700122	22753	11376	2	0	\N
40794	1686	10472002600122	22903	11432	9	0	\N
40795	1686	10472008700122	22753	11376	3	0	\N
40796	1686	10472009700122	22557	11286	4	0	\N
40797	1686	10472009700122	22749	11376	4	0	\N
40799	1686	10472123300118	23130	11433	122	0	\N
40800	1686	11012010550062	16486	8384	3	0	\N
40678	1686	4317960000000	1516	830	5	0	1
40679	1686	4318010000000	1516	830	6	0	1
40701	1686	5038010000000	3018	1567	1	0	1
40705	1686	5038020000000	3018	1567	2	0	1
40666	1686	3091846500013	4130	2148	3	0	2
40675	1686	3811956500013	4293	2227	3	0	2
40689	1686	4531956500013	4904	2538	1	0	2
40690	1686	4531966500013	4904	2538	2	0	2
40715	1686	5251966500013	6041	3137	2	0	2
40717	1686	5251986500013	6041	3137	3	0	2
40723	1686	5972026500013	6461	3347	5	0	2
40735	1686	6692026500013	7093	3662	3	0	2
40738	1686	6692056500013	7093	3662	4	0	2
40749	1686	7412056500013	7631	3948	1	0	2
40761	1686	8132066500013	8158	4229	1	0	2
40762	1686	8132076500013	8158	4229	2	0	2
40770	1686	8852076500013	8707	4515	2	0	2
40773	1686	8852096500013	8707	4515	3	0	2
40779	1686	9572096500013	8755	4543	2	0	2
40787	1686	10292116500013	9027	4681	2	0	2
40789	1686	10292136500013	9027	4681	3	0	2
40672	1686	3811833550062	12962	6684	2	0	9
40673	1686	3811844550062	12962	6684	3	0	9
40684	1686	4531844550062	13116	6759	3	0	9
40712	1686	5251856550062	13244	6821	4	0	9
40713	1686	5251869550062	13244	6821	5	0	9
40720	1686	5971869550062	14224	7262	4	0	9
40721	1686	5971882550062	14224	7262	5	0	9
40729	1686	6691907550062	14307	7301	8	0	9
40743	1686	7411907550062	15554	7918	5	0	9
40744	1686	7411930550062	15554	7918	6	0	9
40745	1686	7411940550062	15599	7941	1	0	9
40757	1686	8131940550062	15599	7941	3	0	9
40765	1686	8851941550062	15767	8019	7	0	9
40766	1686	8851975550062	15767	8019	8	0	9
40777	1686	9571975550062	15787	8031	6	0	9
40778	1686	9571999550062	15787	8031	7	0	9
40784	1686	10291999550062	16076	8173	2	0	9
40718	1686	5431765700122	21527	10799	6	0	17
40719	1686	5431789700122	21527	10799	7	0	17
40725	1686	6151789700122	21745	10888	3	0	17
40726	1686	6151801700122	21745	10888	4	0	17
40741	1686	6871885700122	21923	10970	22	0	17
40754	1686	7591885700122	21949	10980	3	0	17
40755	1686	7591897700122	21949	10980	4	0	17
40756	1686	7591942700122	22092	11045	9	0	17
40763	1686	8311942700122	22092	11045	15	0	17
40775	1686	9031947700122	22238	11130	3	0	17
40776	1686	9031959700122	22238	11130	4	0	17
40781	1686	9751959700122	22265	11143	11	0	17
40782	1686	9751997700122	22265	11143	12	0	17
40793	1686	10471997700122	22904	11448	4	0	17
40802	1686	11012022550062	16486	8384	4	0	\N
40806	1686	11192010700122	23128	11552	5	0	\N
40809	1686	11192024700122	23128	11552	6	0	\N
40810	1686	11192123300118	23130	11433	125	0	\N
40811	1686	11192125200116	23130	11433	127	0	\N
40812	1686	11732034550062	16535	8409	3	0	\N
40814	1686	11732046550062	16535	8409	4	0	\N
40825	1686	12632035700122	23580	11750	4	0	\N
40826	1686	12632035700122	23720	11813	3	0	\N
40827	1686	12632035700122	24026	11956	6	0	\N
40828	1686	12632047700122	23720	11813	4	0	\N
40829	1686	12632057700122	23580	11750	5	0	\N
40831	1686	12632077700122	24026	11956	7	0	\N
40833	1686	13172058550062	16909	8574	7	0	\N
40835	1686	13172083550062	16909	8574	8	0	\N
40844	1686	14072088700123	25680	12707	6	0	\N
40845	1686	14072088700123	25682	12707	10	0	\N
40846	1686	14072088700123	25756	12741	3	0	\N
40847	1686	14072088700123	25858	12784	3	0	\N
40850	1686	14072100700123	25756	12741	4	0	\N
40851	1686	14072100700123	25858	12784	4	0	\N
40852	1686	14072121700123	25680	12707	7	0	\N
40853	1686	14072125700123	25682	12707	11	0	\N
40858	1686	14792089700123	25997	12848	0	0	\N
40863	1686	15332326500013	9817	5089	12	0	\N
40864	1686	15332326500013	10467	5409	9	0	\N
40867	1686	15332356500013	9817	5089	13	0	\N
40868	1686	15332416500013	10467	5409	10	0	\N
40869	1686	15512127700123	26217	12961	4	0	\N
40871	1686	15512140700123	26217	12961	5	0	\N
40873	1686	15512176700123	26896	13300	9	0	\N
40876	1686	16052346500013	11574	5950	1	0	\N
40877	1686	16052347500013	11574	5950	2	0	\N
40880	1686	16232176700123	26896	13300	10	0	\N
40881	1686	16772158550062	17773	8979	4	0	\N
40882	1686	16772158550062	17898	9030	17	0	\N
40883	1686	16772158550062	17934	9047	2	0	\N
40884	1686	16772158550062	17936	9047	3	0	\N
40886	1686	16772169550062	17934	9047	3	0	\N
40888	1686	16772170550062	17936	9047	4	0	\N
40889	1686	16772171550062	17773	8979	5	0	\N
40890	1686	16772229550062	17898	9030	18	0	\N
40893	1686	17492169550062	18654	9400	4	0	\N
40896	1686	17492191550062	18654	9400	5	0	\N
40899	1686	18212180550062	19390	9773	5	0	\N
40902	1686	18212203550062	19390	9773	6	0	\N
40903	1686	18392176700123	27760	13713	10	0	\N
40906	1686	18392231700123	27760	13713	11	0	\N
40913	1686	19832211700123	28774	14194	3	0	\N
40916	1686	19832223700123	28774	14194	4	0	\N
40919	1686	20552212700123	28894	14253	4	0	\N
40922	1686	20552225700123	28894	14253	5	0	\N
40923	1686	21092228550062	21112	10603	3	0	\N
40925	1686	21092240550062	21112	10603	4	0	\N
40927	1686	21272224700123	29139	14368	3	0	\N
40929	1686	21272236700123	29139	14368	4	0	\N
40935	1686	22712286700123	29970	14760	9	0	\N
40936	1686	22712286700123	29973	14760	5	0	\N
40816	1686	11732226500013	9288	4817	2	0	2
40817	1686	11732246500013	9288	4817	3	0	2
40822	1686	12452246500013	9324	4836	2	0	2
40823	1686	12452266500013	9324	4836	3	0	2
40836	1686	13172266500013	9403	4878	2	0	2
40842	1686	13892286500013	9596	4978	2	0	2
40843	1686	13892306500013	9596	4978	3	0	2
40856	1686	14612306500013	9760	5057	2	0	2
40857	1686	14612326500013	9760	5057	3	0	2
40865	1686	15332326500013	10724	5535	2	0	2
40801	1686	11012010550062	16493	8388	6	0	9
40803	1686	11012034550062	16493	8388	7	0	9
40813	1686	11732034550062	16711	8491	3	0	9
40815	1686	11732046550062	16711	8491	4	0	9
40821	1686	12452058550062	16778	8517	4	0	9
40832	1686	13172058550062	16908	8574	7	0	9
40834	1686	13172083550062	16908	8574	8	0	9
40840	1686	13892083550062	17162	8698	4	0	9
40841	1686	13892096550062	17162	8698	5	0	9
40855	1686	14612120550062	17199	8716	7	0	9
40861	1686	15332120550062	17525	8873	8	0	9
40862	1686	15332146550062	17525	8873	9	0	9
40874	1686	16052146550062	17532	8878	3	0	9
40875	1686	16052158550062	17532	8878	4	0	9
40887	1686	16772169550062	18095	9125	3	0	9
40894	1686	17492169550062	18800	9473	2	0	9
40895	1686	17492180550062	18800	9473	3	0	9
40900	1686	18212180550062	19494	9826	3	0	9
40907	1686	18932192550062	19824	9987	3	0	9
40908	1686	18932204550062	19824	9987	4	0	9
40911	1686	19652204550062	20230	10186	3	0	9
40912	1686	19652216550062	20230	10186	4	0	9
40917	1686	20372216550062	20423	10289	3	0	9
40924	1686	21092228550062	21324	10705	4	0	9
40926	1686	21092241550062	21324	10705	5	0	9
40931	1686	21812241550062	21382	10728	7	0	9
40932	1686	21812266550062	21382	10728	8	0	9
40807	1686	11192010700122	23561	11743	4	0	17
40818	1686	11912023700122	23571	11747	3	0	17
40819	1686	11912035700122	23571	11747	4	0	17
40824	1686	12632034700123	24025	11956	6	0	17
40830	1686	12632076700123	24025	11956	7	0	17
40839	1686	13352088700123	24186	12040	4	0	17
40848	1686	14072088700123	25859	12784	1	0	17
40849	1686	14072089700123	25859	12784	2	0	17
40859	1686	14792089700123	26191	12947	11	0	17
40860	1686	14792127700123	26191	12947	12	0	17
40872	1686	15512140700123	26649	13182	5	0	17
40878	1686	16232140700123	27309	13498	3	0	17
40879	1686	16232152700123	27309	13498	4	0	17
40891	1686	16952152700123	27497	13592	3	0	17
40892	1686	16952164700123	27497	13592	4	0	17
40898	1686	17672176700123	27550	13618	4	0	17
40904	1686	18392176700123	28016	13856	3	0	17
40905	1686	18392188700123	28016	13856	4	0	17
40909	1686	19112188700123	28310	13996	5	0	17
40914	1686	19832211700123	28776	14194	1	0	17
40915	1686	19832212700123	28776	14194	2	0	17
40920	1686	20552212700123	28895	14253	3	0	17
40921	1686	20552224700123	28895	14253	4	0	17
40928	1686	21272224700123	29620	14608	6	0	17
40933	1686	21992248700123	29781	14677	20	0	17
40934	1686	21992286700123	29781	14677	21	0	17
40938	1686	22712300700123	29973	14760	6	0	\N
40940	1686	22712304700123	29970	14760	10	0	\N
40941	1687	20000000	6681	3453	7	1	\N
40942	1687	201000000	27534	13412	76	1	\N
40943	1687	201200000	6679	3453	7	1	\N
40944	1687	719000000000	21	12	1	0	\N
40945	1687	719000000000	171	102	1	0	\N
40947	1687	719010000000	21	12	2	0	\N
40948	1687	719010000000	171	102	2	0	\N
40956	1687	2159020000000	1043	579	1	0	\N
40957	1687	2159020000000	1381	757	2	0	\N
40959	1687	2159030000000	1043	579	2	0	\N
40961	1687	2159040000000	1381	757	3	0	\N
40964	1687	2288819848312	23255	11602	2	0	\N
40966	1687	2288830848312	23255	11602	3	0	\N
40972	1687	3008830848312	23472	11703	4	0	\N
40974	1687	3008843848312	23472	11703	5	0	\N
40976	1687	3592460524804	12579	6484	6	0	\N
40977	1687	3592460524804	12687	6543	2	0	\N
40978	1687	3592460524804	12758	6577	4	0	\N
40980	1687	3592471524804	12687	6543	3	0	\N
40981	1687	3592475524804	12579	6484	7	0	\N
40982	1687	3592482524804	12758	6577	5	0	\N
40984	1687	3599041000000	1751	938	1	0	\N
40986	1687	3599051000000	1751	938	2	0	\N
40988	1687	3684943726450	6462	3347	4	0	\N
40989	1687	3684943726450	6517	3377	4	0	\N
40990	1687	3684943726450	6551	3395	2	0	\N
40992	1687	3684943726450	6664	3443	4	0	\N
40993	1687	3684963726450	6551	3395	3	0	\N
40995	1687	3684983726450	6462	3347	5	0	\N
40996	1687	3684983726450	6517	3377	5	0	\N
40997	1687	3684983726450	6664	3443	5	0	\N
40998	1687	3684993726450	6679	3453	2	0	\N
40999	1687	3684993726450	6681	3453	2	0	\N
41000	1687	3728852848312	23947	11915	3	0	\N
41002	1687	3728852848312	24107	11883	0	0	\N
41003	1687	3728852848312	24109	11894	0	0	\N
41004	1687	3728852848312	24110	11905	0	0	\N
41005	1687	3728864848312	23947	11915	4	0	\N
41009	1687	4220704223172	17953	8995	62	0	\N
41015	1687	4404993626450	6679	3453	6	0	\N
41016	1687	4404993726450	6681	3453	6	0	\N
41020	1687	4940084223172	17491	8854	8	0	\N
41021	1687	4940084223172	17548	8885	3	0	\N
41023	1687	4940096223172	17548	8885	4	0	\N
41025	1687	4940146223172	17491	8854	9	0	\N
41026	1687	4940704223172	17953	8995	126	0	\N
41027	1687	4940911223172	17953	8995	127	0	\N
41028	1687	4941531223172	18089	8996	62	0	\N
41029	1687	5032528524796	13489	6947	2	0	\N
41030	1687	5032528524804	13403	6905	3	0	\N
41031	1687	5032528524804	13404	6905	6	0	\N
41032	1687	5032528524804	13406	6906	1	0	\N
41033	1687	5032528524804	13408	6906	4	0	\N
41035	1687	5032538524804	13406	6906	2	0	\N
41036	1687	5032541524804	13408	6906	5	0	\N
41038	1687	5032549524804	13403	6905	4	0	\N
41039	1687	5032552524804	13404	6905	7	0	\N
41041	1687	5039061000000	2208	1162	2	0	\N
41042	1687	5039061000000	2258	1185	1	0	\N
41043	1687	5039061000000	2302	1207	1	0	\N
41044	1687	5039071000000	2258	1185	2	0	\N
41045	1687	5039071000000	2302	1207	2	0	\N
41047	1687	5039081000000	2208	1162	3	0	\N
41048	1687	5124993726450	7074	3651	2	0	\N
41049	1687	5124993726450	7111	3672	4	0	\N
41050	1687	5124993726450	7318	3782	3	0	\N
41051	1687	5124993726450	7330	3788	1	0	\N
41052	1687	5124993726450	7331	3788	0	0	\N
41053	1687	5124993726450	7364	3804	8	0	\N
41055	1687	5125003726450	7330	3788	2	0	\N
41057	1687	5125013726450	7074	3651	3	0	\N
41058	1687	5125023726450	7318	3782	4	0	\N
41059	1687	5125033726450	7111	3672	5	0	\N
41060	1687	5125073726450	7364	3804	9	0	\N
41061	1687	5168877848312	24171	12031	5	0	\N
41062	1687	5168877848312	24456	12162	3	0	\N
41064	1687	5168889848312	24456	12162	4	0	\N
41065	1687	5168900848312	24171	12031	6	0	\N
41067	1687	5660096223172	18087	9121	2	0	\N
41069	1687	5660107223172	18087	9121	3	0	\N
41072	1687	5661531223172	18089	8996	126	0	\N
40950	1687	1439010000000	496	276	1	0	0
40951	1687	1439020000000	496	276	2	0	0
40958	1687	2159020000000	1489	813	2	0	0
40960	1687	2159031000000	1489	813	3	0	0
40968	1687	2879031000000	1584	861	1	0	0
40985	1687	3599041000000	1864	993	1	0	0
40987	1687	3599051000000	1864	993	2	0	0
41012	1687	4319051000000	2163	1142	1	0	0
41013	1687	4319061000000	2163	1142	2	0	0
41040	1687	5039051000000	2551	1343	2	0	1
40952	1687	1524883726450	6220	3218	1	0	4
40953	1687	1524893726450	6220	3218	2	0	4
40962	1687	2244893726450	6256	3238	4	0	4
40963	1687	2244933726450	6256	3238	5	0	4
40971	1687	2964943726450	6320	3271	2	0	4
40991	1687	3684943726450	6663	3444	3	0	4
40994	1687	3684973726450	6663	3444	4	0	4
41014	1687	4404973726450	6826	3534	2	0	4
41017	1687	4404993726450	6826	3534	3	0	4
41056	1687	5125003726450	7491	3874	2	0	4
40979	1687	3592460524804	13337	6873	12	0	5
40983	1687	3592490524804	13337	6873	13	0	5
41010	1687	4312490524804	13371	6890	11	0	5
41011	1687	4312528524804	13371	6890	12	0	5
41037	1687	5032543524804	13490	6947	7	0	5
41007	1687	4220031223172	17488	8852	8	0	6
41008	1687	4220084223172	17488	8852	9	0	6
41022	1687	4940084223172	17952	9056	3	0	6
41068	1687	5660096223172	18580	9363	2	0	6
41070	1687	5660107223172	18580	9363	3	0	6
41071	1687	5660148223172	18776	9462	5	0	6
40954	1687	1568806848312	22821	11413	4	0	7
40955	1687	1568819848312	22821	11413	5	0	7
40967	1687	2288830848312	23402	11675	3	0	7
40973	1687	3008830848312	23565	11744	4	0	7
40975	1687	3008852848312	23565	11744	5	0	7
41001	1687	3728852848312	24034	11960	6	0	7
41006	1687	3728876848312	24034	11960	7	0	7
41019	1687	4448877848312	24108	12001	2	0	7
41063	1687	5168877848312	24750	12290	8	0	7
41066	1687	5168912848312	24750	12290	9	0	7
40937	1686	22712286700123	30278	14889	8	0	17
41073	1687	5661945223172	18089	8996	127	0	\N
41076	1687	5759071000000	2790	1460	1	0	\N
41078	1687	5759081000000	2790	1460	2	0	\N
41080	1687	5759131000000	2909	1517	4	0	\N
41083	1687	5845033726450	8988	4661	1	0	\N
41091	1687	6479091000000	3088	1602	2	0	\N
41092	1687	6479091000000	3101	1609	1	0	\N
41093	1687	6479091000000	3285	1707	2	0	\N
41094	1687	6479091000000	3308	1717	1	0	\N
41096	1687	6479101000000	3101	1609	2	0	\N
41097	1687	6479101000000	3308	1717	2	0	\N
41099	1687	6479111000000	3088	1602	3	0	\N
41100	1687	6479111000000	3285	1707	3	0	\N
41101	1687	6479131000000	2909	1517	5	0	\N
41102	1687	6565033726450	8988	4661	7	0	\N
41104	1687	6565034036440	8988	4661	10	0	\N
41107	1687	6565184726450	10369	5362	2	0	\N
41112	1687	7192567524804	14253	7277	8	0	\N
41115	1687	7192593524804	14253	7277	9	0	\N
41117	1687	7285074726450	9147	4739	4	0	\N
41118	1687	7285074726450	9865	5117	1	0	\N
41119	1687	7285074726450	9932	5155	2	0	\N
41120	1687	7285084726450	9865	5117	2	0	\N
41121	1687	7285094726450	9932	5155	3	0	\N
41122	1687	7285114726450	9147	4739	5	0	\N
41124	1687	7285184726450	10369	5362	6	0	\N
41126	1687	7285214726450	10369	5362	7	0	\N
41127	1687	7328936848312	25412	12593	4	0	\N
41128	1687	7328936848312	25448	12606	5	0	\N
41129	1687	7328936848312	25462	12611	4	0	\N
41131	1687	7328949848312	25412	12593	5	0	\N
41132	1687	7328949848312	25462	12611	5	0	\N
41133	1687	7328950848312	25448	12606	6	0	\N
41137	1687	7912581524804	14433	7364	5	0	\N
41140	1687	7912694524804	14433	7364	6	0	\N
41141	1687	7919101000000	3515	1824	0	0	\N
41143	1687	8005214726450	10826	5586	3	0	\N
41145	1687	8005244726450	10826	5586	4	0	\N
41147	1687	8048972848312	25663	12701	2	0	\N
41149	1687	8048983848312	25663	12701	3	0	\N
41153	1687	8632693524804	14576	7431	2	0	\N
41155	1687	8632704524804	14576	7431	3	0	\N
41161	1687	8768984848312	25847	12778	2	0	\N
41163	1687	8768995848312	25847	12778	3	0	\N
41165	1687	8769786848312	27251	13411	79	0	\N
41168	1687	9352704524804	15054	7640	76	0	\N
41171	1687	9353086524804	15054	7640	77	0	\N
41174	1687	9445364726450	11060	5690	6	0	\N
41177	1687	9445424726450	11060	5690	7	0	\N
41178	1687	9488996848312	26247	12975	3	0	\N
41179	1687	9488996848312	26257	12983	3	0	\N
41180	1687	9488996848312	26263	12986	7	0	\N
41181	1687	9488996848312	27250	13473	3	0	\N
41182	1687	9488996848312	27533	13612	3	0	\N
41184	1687	9489008848312	26247	12975	4	0	\N
41185	1687	9489008848312	26257	12983	4	0	\N
41186	1687	9489008848312	27250	13473	4	0	\N
41187	1687	9489008848312	27533	13612	4	0	\N
41189	1687	9489021848312	26263	12986	8	0	\N
41190	1687	9489786848312	27251	13411	126	0	\N
41191	1687	9489931848312	27251	13411	127	0	\N
41195	1687	10072725524804	15402	7846	1	0	\N
41196	1687	10079121000000	4014	2082	2	0	\N
41197	1687	10079121000000	4217	2192	1	0	\N
41198	1687	10079121000000	4249	2204	4	0	\N
41200	1687	10079131000000	4217	2192	2	0	\N
41202	1687	10079141000000	4014	2082	3	0	\N
41203	1687	10079251000000	4249	2204	5	0	\N
41095	1687	6479091000000	3404	1770	1	0	1
41098	1687	6479101000000	3404	1770	2	0	1
41116	1687	7199101000000	3453	1792	0	0	1
41142	1687	7919101000000	3536	1835	0	0	1
41157	1687	8639101000000	3860	2004	1	0	1
41172	1687	9359111000000	3997	2074	1	0	1
41173	1687	9359121000000	3997	2074	2	0	1
41199	1687	10079121000000	4487	2324	1	0	1
41201	1687	10079131000000	4487	2324	2	0	1
41081	1687	5845003726450	7738	4010	2	0	4
41084	1687	5845033726450	8990	4661	1	0	4
41103	1687	6565033726450	8990	4661	7	0	4
41105	1687	6565074726450	8990	4661	8	0	4
41106	1687	6565184726450	10368	5362	2	0	4
41125	1687	7285214726450	10368	5362	7	0	4
41144	1687	8005214726450	10827	5586	3	0	4
41146	1687	8005244726450	10827	5586	4	0	4
41159	1687	8725244726450	10959	5648	3	0	4
41160	1687	8725364726450	10959	5648	4	0	4
41176	1687	9445384726450	11072	5696	3	0	4
41204	1687	10165384726450	11219	5764	2	0	4
41205	1687	10165404726450	11219	5764	3	0	4
41074	1687	5752543524804	13707	7044	2	0	5
41075	1687	5752554524804	13707	7044	3	0	5
41090	1687	6472567524804	13986	7166	5	0	5
41113	1687	7192567524804	14422	7357	5	0	5
41114	1687	7192581524804	14422	7357	6	0	5
41138	1687	7912581524804	14434	7364	4	0	5
41154	1687	8632693524804	14850	7568	2	0	5
41156	1687	8632704524804	14850	7568	3	0	5
41169	1687	9352704524804	15055	7668	2	0	5
41170	1687	9352715524804	15055	7668	3	0	5
41194	1687	10072715524804	15301	7797	0	0	5
41088	1687	6380153223172	18776	9462	12	0	6
41110	1687	7100153223172	18888	9528	1	0	6
41111	1687	7100163223172	18888	9528	2	0	6
41135	1687	7820163223172	19065	9615	4	0	6
41136	1687	7820176223172	19065	9615	5	0	6
41152	1687	8540189223172	19174	9674	5	0	6
41166	1687	9260189223172	19481	9821	2	0	6
41167	1687	9260200223172	19481	9821	3	0	6
41192	1687	9980200223172	19532	9840	7	0	6
41085	1687	5888912848312	24961	12386	3	0	7
41086	1687	5888924848312	24961	12386	4	0	7
41108	1687	6608924848312	25408	12592	3	0	7
41109	1687	6608936848312	25408	12592	4	0	7
41130	1687	7328936848312	25530	12638	9	0	7
41148	1687	8048972848312	25664	12701	3	0	7
41150	1687	8048984848312	25664	12701	4	0	7
41162	1687	8768984848312	26232	12970	3	0	7
41164	1687	8768996848312	26232	12970	4	0	7
41183	1687	9488996848312	27648	13663	6	0	7
41206	1687	10209020848312	27816	13746	3	0	7
41207	1687	10209032848312	27816	13746	4	0	7
41208	1687	10209042848312	28432	14052	1	0	7
41209	1687	10209042848312	28433	14052	1	0	\N
41210	1687	10209931848312	27534	13412	74	0	\N
41211	1687	10700225223172	19616	9880	9	0	\N
41214	1687	10700261223172	19616	9880	10	0	\N
41216	1687	10792715524804	15804	8044	3	0	\N
41217	1687	10792725524804	15402	7846	4	0	\N
41219	1687	10792727524804	15402	7846	5	0	\N
41220	1687	10792727524804	15804	8044	4	0	\N
41223	1687	10885404726450	11321	5813	2	0	\N
41226	1687	10885415726450	11321	5813	3	0	\N
41227	1687	10929032848312	27869	13779	3	0	\N
41228	1687	10929032848312	28037	13866	3	0	\N
41230	1687	10929042848312	28433	14052	3	0	\N
41232	1687	10929043848312	28433	14052	4	0	\N
41233	1687	10929044848312	27869	13779	4	0	\N
41234	1687	10929044848312	28037	13866	4	0	\N
41235	1687	10929570848311	27649	13413	0	0	\N
41239	1687	11512726524804	15807	8046	4	0	\N
41241	1687	11512739524804	15807	8046	5	0	\N
41242	1687	11519161000000	4535	2345	1	0	\N
41244	1687	11519171000000	4535	2345	2	0	\N
41246	1687	11605405726450	11669	5999	1	0	\N
41247	1687	11605405726450	12055	6205	1	0	\N
41249	1687	11605406726450	11669	5999	2	0	\N
41250	1687	11605406726450	12055	6205	2	0	\N
41256	1687	12232738524804	16015	8143	3	0	\N
41257	1687	12232738524804	16446	8364	10	0	\N
41259	1687	12232750524804	16015	8143	4	0	\N
41261	1687	12232775524804	16446	8364	11	0	\N
41270	1687	12952750524804	17061	8642	4	0	\N
41271	1687	12952750524804	17125	8677	2	0	\N
41273	1687	12952761524804	17125	8677	3	0	\N
41275	1687	12952763524804	17061	8642	5	0	\N
41278	1687	12959381000000	6051	3100	7	0	\N
41279	1687	13089065648287	29117	14354	8	0	\N
41281	1687	13089100648287	29117	14354	9	0	\N
41285	1687	13580911223172	20867	10461	87	0	\N
41286	1687	13672762524804	17286	8754	6	0	\N
41287	1687	13672786524804	17286	8754	7	0	\N
41288	1687	13679221000000	5946	3082	2	0	\N
41289	1687	13679221000000	6050	3143	2	0	\N
41290	1687	13679221000000	6516	3092	0	0	\N
41291	1687	13679241000000	5946	3082	3	0	\N
41292	1687	13679241000000	6050	3143	3	0	\N
41293	1687	13679381000000	6051	3100	8	0	\N
41294	1687	13809101648287	29698	14647	6	0	\N
41295	1687	13809101648287	29768	14672	19	0	\N
41297	1687	13809101648287	29890	14729	6	0	\N
41298	1687	13809116648287	29698	14647	7	0	\N
41299	1687	13809116648287	29890	14729	7	0	\N
41301	1687	13809138648287	29768	14672	20	0	\N
41302	1687	14300324223172	20731	10421	10	0	\N
41305	1687	14300361223172	20731	10421	11	0	\N
41306	1687	14300911223172	20867	10461	107	0	\N
41307	1687	14300930223172	20867	10461	108	0	\N
41308	1687	14302250223172	21205	10462	106	0	\N
41311	1687	15022250223172	21205	10462	126	0	\N
41312	1687	15022440223172	21205	10462	127	0	\N
41313	1687	15024300223172	21411	10463	106	0	\N
41314	1687	15744300223172	21411	10463	123	0	\N
41315	1687	15744460223172	21411	10463	124	0	\N
41316	1687	15840301001040	13489	6947	3	0	\N
41317	1688	9250000	5102	2649	2	0	\N
41318	1688	263999986	12503	6442	3	0	\N
41319	1688	719000000000	30	18	1	0	\N
41320	1688	719000000000	54	31	2	0	\N
41321	1688	719000000000	102	63	3	0	\N
41322	1688	719000000000	110	67	1	0	\N
41323	1688	719000000000	174	104	1	0	\N
41325	1688	719010000000	30	18	2	0	\N
41326	1688	719010000000	110	67	2	0	\N
41327	1688	719010000000	174	104	2	0	\N
41329	1688	719020000000	54	31	3	0	\N
41330	1688	719030000000	102	63	4	0	\N
41331	1688	898700000006	5836	3029	6	1	\N
41332	1688	1439010000000	212	124	1	0	\N
41333	1688	1439010000000	231	137	1	0	\N
41335	1688	1439020000000	212	124	2	0	\N
41336	1688	1439020000000	231	137	2	0	\N
41338	1688	2159020000000	317	183	2	0	\N
41340	1688	2159031000000	317	183	3	0	\N
41342	1688	2879040000000	409	233	1	0	\N
41343	1688	2879040000000	418	239	3	0	\N
41334	1688	1439010000000	292	168	1	0	0
41337	1688	1439020000000	292	168	2	0	0
41339	1688	2159020000000	396	226	2	0	0
41341	1688	2159040000000	396	226	3	0	0
41344	1688	2879040000000	449	253	1	0	0
41222	1687	10799161000000	4494	2327	4	0	1
41243	1687	11519161000000	4545	2352	2	0	1
41245	1687	11519181000000	4545	2352	3	0	1
41262	1687	12239181000000	4977	2581	3	0	1
41263	1687	12239211000000	4977	2581	4	0	1
41277	1687	12959221000000	5009	2596	2	0	1
41224	1687	10885404726450	11548	5932	1	0	4
41225	1687	10885405726450	11548	5932	2	0	4
41248	1687	11605405726450	12186	6274	2	0	4
41264	1687	12325407726450	12257	6311	1	0	4
41265	1687	12325408726450	12257	6311	2	0	4
41215	1687	10792715524804	15803	8044	2	0	5
41218	1687	10792726524804	15803	8044	3	0	5
41238	1687	11512726524804	15806	8046	3	0	5
41258	1687	12232738524804	16948	8590	3	0	5
41260	1687	12232750524804	16948	8590	4	0	5
41272	1687	12952750524804	17145	8690	3	0	5
41274	1687	12952762524804	17145	8690	4	0	5
41212	1687	10700225223172	20376	10265	3	0	6
41236	1687	11420237223172	20488	10316	6	0	6
41237	1687	11420261223172	20488	10316	7	0	6
41254	1687	12140261223172	20494	10320	3	0	6
41255	1687	12140273223172	20494	10320	4	0	6
41269	1687	12860285223172	20592	10358	4	0	6
41283	1687	13580285223172	20628	10377	12	0	6
41284	1687	13580324223172	20628	10377	13	0	6
41303	1687	14300324223172	22331	11176	2	0	6
41304	1687	14300326223172	22331	11176	3	0	6
41310	1687	15020365223172	22568	11290	13	0	6
41229	1687	10929042848312	28432	14052	3	0	7
41231	1687	10929043848312	28432	14052	4	0	7
41252	1687	11649043848303	28691	14165	3	0	7
41253	1687	11649044648287	28691	14165	4	1	7
41267	1687	12369065648287	28770	14192	4	0	7
41280	1687	13089065648287	29486	14539	9	0	7
41282	1687	13089101648287	29486	14539	10	0	7
41296	1687	13809101648287	29889	14729	10	0	7
41345	1688	2879050000000	409	233	2	0	\N
41347	1688	2879070000000	418	239	4	0	\N
41348	1688	3599050000000	489	272	3	0	\N
41351	1688	3599080000000	489	272	4	0	\N
41354	1688	5039112000000	526	297	2	0	\N
41357	1688	5039123000000	526	297	3	0	\N
41358	1688	5758675910100	20832	10470	3	0	\N
41359	1688	5758675910100	20839	10473	5	0	\N
41361	1688	5758687910100	20832	10470	4	0	\N
41363	1688	5758707910100	20839	10473	6	0	\N
41368	1688	6478710910100	20891	10500	2	0	\N
41369	1688	6479142000000	564	319	1	0	\N
41370	1688	6479142000000	568	321	1	0	\N
41371	1688	6479142000000	671	374	1	0	\N
41373	1688	6479152000000	564	319	2	0	\N
41374	1688	6479152000000	568	321	2	0	\N
41375	1688	6479152000000	671	374	2	0	\N
41376	1688	7198699910100	20907	10508	5	0	\N
41378	1688	7198710910100	20891	10500	3	0	\N
41380	1688	7198722910100	20907	10508	6	0	\N
41381	1688	7199142000000	797	442	1	0	\N
41382	1688	7199142000000	918	511	1	0	\N
41384	1688	7199152000000	797	442	2	0	\N
41385	1688	7199152000000	918	511	2	0	\N
41396	1688	9358743910100	20975	10550	3	0	\N
41399	1688	9358764910100	20975	10550	4	0	\N
41403	1688	10079232000000	993	548	1	0	\N
41405	1688	10079242000000	993	548	2	0	\N
41407	1688	10798765910100	21030	10570	2	0	\N
41408	1688	10798765910100	21042	10574	3	0	\N
41410	1688	10798776910100	21030	10570	3	0	\N
41411	1688	10798777910100	21042	10574	4	0	\N
41415	1688	10870586113020	26072	12885	4	0	\N
41416	1688	10870586113020	26074	12886	2	0	\N
41418	1688	10870597113020	26074	12886	3	0	\N
41420	1688	10870608113020	26072	12885	5	0	\N
41429	1688	12238908910100	21106	10599	7	0	\N
41430	1688	12238908910100	21107	10600	5	0	\N
41433	1688	12238931910100	21107	10600	6	0	\N
41434	1688	12238942910100	21106	10599	8	0	\N
41435	1688	12239262000000	1094	606	4	0	\N
41438	1688	12239302000000	1094	606	5	0	\N
41439	1688	12310609113020	26131	12917	2	0	\N
41441	1688	12310620113020	26131	12917	3	0	\N
41457	1688	14399392000000	1146	632	1	0	\N
41458	1688	14399392000000	1168	643	1	0	\N
41460	1688	14399402000000	1146	632	2	0	\N
41461	1688	14399402000000	1168	643	2	0	\N
41463	1688	14470655113020	26284	12999	7	0	\N
41464	1688	14470655113020	26296	13007	11	0	\N
41465	1688	14470655113020	26298	13008	2	0	\N
41467	1688	14470666113020	26298	13008	3	0	\N
41469	1688	14470689113020	26284	12999	8	0	\N
41470	1688	14470702113020	26296	13007	12	0	\N
41471	1688	15118942910100	21152	10623	2	0	\N
41472	1688	15118942910100	21176	10634	5	0	\N
41475	1688	15118953910100	21152	10623	3	0	\N
41476	1688	15118974910100	21176	10634	6	0	\N
41480	1688	15190677113020	26341	13026	5	0	\N
41350	1688	3599062000000	503	282	4	0	0
41352	1688	4319062000000	520	292	5	0	0
41353	1688	4319112000000	520	292	6	0	0
41355	1688	5039112000000	559	316	1	0	0
41356	1688	5039122000000	559	316	2	0	0
41365	1688	5759142000000	560	317	3	0	0
41372	1688	6479142000000	715	399	0	0	0
41383	1688	7199142000000	939	523	1	0	0
41386	1688	7199152000000	939	523	2	0	0
41389	1688	7919152000000	959	535	6	0	0
41393	1688	8639212000000	967	539	1	0	0
41394	1688	8639222000000	967	539	2	0	0
41395	1688	8639232000000	978	543	1	0	0
41400	1688	9359232000000	978	543	2	0	0
41406	1688	10079242000000	995	549	2	0	0
41413	1688	10799242000000	997	550	1	0	0
41414	1688	10799252000000	997	550	2	0	0
41423	1688	11519252000000	1017	563	1	0	0
41424	1688	11519262000000	1017	563	2	0	0
41437	1688	12239272000000	1117	616	2	0	0
41445	1688	12959272000000	1124	619	1	0	0
41446	1688	12959282000000	1124	619	2	0	0
41451	1688	13679282000000	1126	620	2	0	0
41452	1688	13679392000000	1126	620	3	0	0
41462	1688	14399402000000	1180	651	2	0	0
41478	1688	15119402000000	1232	680	1	0	0
41479	1688	15119412000000	1232	680	2	0	0
41427	1688	12022842210200	20780	10443	8	0	56
41360	1688	5758675910100	20847	10477	4	0	57
41362	1688	5758688910100	20847	10477	5	0	57
41366	1688	6478688910100	20865	10489	2	0	57
41367	1688	6478699910100	20865	10489	3	0	57
41377	1688	7198699910100	20914	10513	4	0	57
41387	1688	7918721910100	20941	10530	2	0	57
41388	1688	7918732910100	20941	10530	3	0	57
41391	1688	8638732910100	20956	10540	2	0	57
41392	1688	8638743910100	20956	10540	3	0	57
41397	1688	9358743910100	20988	10556	2	0	57
41401	1688	10078754910100	21019	10568	2	0	57
41402	1688	10078765910100	21019	10568	3	0	57
41409	1688	10798765910100	21055	10579	4	0	57
41412	1688	10798787910100	21055	10579	5	0	57
41422	1688	11518908910100	21060	10583	5	0	57
41431	1688	12238908910100	21116	10604	2	0	57
41432	1688	12238919910100	21116	10604	3	0	57
41443	1688	12958919910100	21117	10605	2	0	57
41444	1688	12958930910100	21117	10605	3	0	57
41450	1688	13678942910100	21121	10608	4	0	57
41455	1688	14398942910100	21147	10620	0	0	57
41456	1688	14398952910100	21240	10667	1	0	57
41473	1688	15118952910090	21240	10667	3	0	57
41474	1688	15118953910040	21240	10667	4	0	57
41417	1688	10870586113020	26099	12899	3	0	77
41419	1688	10870598113020	26099	12899	4	0	77
41425	1688	11590598113020	26121	12912	2	0	77
41426	1688	11590609113020	26121	12912	3	0	77
41442	1688	12310620113020	26179	12942	3	0	77
41447	1688	13030620113020	26218	12962	6	0	77
41448	1688	13030644113020	26218	12962	7	0	77
41453	1688	13750644113020	26272	12993	2	0	77
41454	1688	13750655113020	26272	12993	3	0	77
41468	1688	14470677113020	26336	13024	5	0	77
41481	1688	15190677113020	26534	13127	9	0	\N
41484	1688	15190700113020	26341	13026	6	0	\N
41485	1688	15190713113020	26534	13127	10	0	\N
41488	1688	15838999910040	21361	10722	4	0	\N
41489	1688	15839412000000	1238	685	1	0	\N
41490	1688	15839412000000	1283	709	1	0	\N
41492	1688	15839422000000	1238	685	2	0	\N
41493	1688	15839422000000	1283	709	2	0	\N
41499	1688	16558999910040	21361	10722	7	0	\N
41500	1688	16559001910040	21361	10722	8	0	\N
41501	1688	16559422000000	1398	764	2	0	\N
41502	1688	16559422000000	1403	767	1	0	\N
41504	1688	16559432000000	1403	767	2	0	\N
41505	1688	16559442000000	1398	764	3	0	\N
41507	1688	16630701113020	26589	13154	6	0	\N
41508	1688	16630701113020	26597	13158	6	0	\N
41511	1688	16630725113020	26589	13154	7	0	\N
41512	1688	16630725113020	26597	13158	7	0	\N
41519	1688	17999000910040	21501	10784	2	0	\N
41521	1688	17999011910040	21501	10784	3	0	\N
41523	1688	17999462000000	1510	827	2	0	\N
41526	1688	17999482000000	1510	827	3	0	\N
41531	1688	18719472000000	1650	888	1	0	\N
41533	1688	18719482000000	1650	888	2	0	\N
41537	1688	19439025910040	21650	10846	3	0	\N
41539	1688	19439037910040	21650	10846	4	0	\N
41547	1688	20159502000000	1712	920	0	0	\N
41548	1688	20159502000000	1747	937	2	0	\N
41549	1688	20159502000000	1782	954	2	0	\N
41552	1688	20159522000000	1747	937	3	0	\N
41553	1688	20159522000000	1782	954	3	0	\N
41554	1688	20230777113020	26800	13252	3	0	\N
41555	1688	20230777113020	26824	13265	4	0	\N
41557	1688	20230789113020	26800	13252	4	0	\N
41559	1688	20230790113020	26824	13265	5	0	\N
41564	1688	20950789113020	26839	13273	4	0	\N
41565	1688	20950789113020	26842	13275	3	0	\N
41567	1688	20950801113020	26842	13275	4	0	\N
41568	1688	20950802113020	26839	13273	5	0	\N
41574	1688	21670814113019	26858	13285	3	0	\N
41575	1688	21670814113019	26870	13290	3	0	\N
41577	1688	21670826113019	26858	13285	4	0	\N
41578	1688	21670826113019	26870	13290	4	0	\N
41580	1688	22319108910040	21803	10914	6	0	\N
41581	1688	22319108910040	21847	10934	9	0	\N
41582	1688	22319108910040	21900	10959	3	0	\N
41584	1688	22319108910040	22216	10910	0	0	\N
41585	1688	22319108910040	22219	10937	0	0	\N
41586	1688	22319108910040	22220	10950	0	0	\N
41587	1688	22319120910040	21900	10959	4	0	\N
41588	1688	22319132910040	21803	10914	7	0	\N
41590	1688	22319144910040	21847	10934	10	0	\N
41593	1688	22390826113019	26931	13321	6	0	\N
41596	1688	22390850113019	26931	13321	7	0	\N
41601	1688	23110838113019	26950	13331	3	0	\N
41602	1688	23110838113019	26953	13332	4	0	\N
41604	1688	23110850113019	26950	13331	4	0	\N
41605	1688	23110851113019	26953	13332	5	0	\N
41503	1688	16559422000000	1430	778	3	0	0
41506	1688	16559452000000	1430	778	4	0	0
41515	1688	17279452000000	1447	787	1	0	0
41516	1688	17279462000000	1447	787	2	0	0
41524	1688	17999462000000	1620	875	1	0	0
41532	1688	18719472000000	1698	915	1	0	0
41534	1688	18719482000000	1698	915	2	0	0
41541	1688	19439482000000	1711	919	2	0	0
41542	1688	19439502000000	1711	919	3	0	0
41550	1688	20159502000000	1844	985	1	0	0
41562	1688	20879512000000	1879	999	2	0	0
41563	1688	20879532000000	1879	999	3	0	0
41572	1688	21599532000000	1880	1000	1	0	0
41573	1688	21599542000000	1880	1000	2	0	0
41592	1688	22319552000000	2068	1093	2	0	0
41599	1688	23039552000000	2071	1094	1	0	0
41600	1688	23039562000000	2071	1094	2	0	0
41609	1688	23759562000000	2072	1095	2	0	0
41610	1688	23759582000000	2072	1095	3	0	0
41616	1688	24479592000000	2084	1100	2	0	0
41486	1688	15838976910040	21282	10685	7	0	57
41487	1688	15838977910040	21282	10685	8	0	57
41497	1688	16558977910040	21490	10778	2	0	57
41498	1688	16558988910040	21490	10778	3	0	57
41514	1688	17279000910040	21495	10780	4	0	57
41520	1688	17999000910040	21513	10792	4	0	57
41522	1688	17999013910040	21513	10792	5	0	57
41529	1688	18719013910040	21614	10832	3	0	57
41538	1688	19439025910040	21703	10871	12	0	57
41540	1688	19439073910040	21703	10871	13	0	57
41545	1688	20159073910040	21719	10880	3	0	57
41546	1688	20159085910040	21719	10880	4	0	57
41560	1688	20879085910040	21747	10890	3	0	57
41570	1688	21599097910040	21760	10896	2	0	57
41571	1688	21599108910040	21760	10896	3	0	57
41583	1688	22319108910040	21920	10969	6	0	57
41589	1688	22319132910040	21920	10969	7	0	57
41597	1688	23039132910040	21952	10982	6	0	57
41607	1688	23759156910040	21960	10986	3	0	57
41608	1688	23759168910040	21960	10986	4	0	57
41613	1688	24479168910040	21964	10987	3	0	57
41614	1688	24479180910040	21964	10987	4	0	57
41483	1688	15190688113020	26549	13135	3	0	77
41495	1688	15910688113020	26566	13145	4	0	77
41496	1688	15910701113020	26566	13145	5	0	77
41509	1688	16630701113020	26632	13175	4	0	77
41510	1688	16630714113020	26632	13175	5	0	77
41518	1688	17350726113020	26688	13200	4	0	77
41527	1688	18070726113020	26703	13207	7	0	77
41528	1688	18070751113020	26703	13207	8	0	77
41535	1688	18790751113020	26734	13223	5	0	77
41536	1688	18790765113020	26734	13223	6	0	77
41544	1688	19510777113020	26737	13226	4	0	77
41556	1688	20230777113020	26838	13272	3	0	77
41558	1688	20230789113020	26838	13272	4	0	77
41566	1688	20950789113020	26851	13282	7	0	77
41576	1688	21670814113019	26884	13295	3	0	77
41579	1688	21670826113019	26884	13295	4	0	77
41594	1688	22390826113019	26936	13323	3	0	77
41595	1688	22390838113019	26936	13323	4	0	77
41603	1688	23110838113019	27002	13356	4	0	77
41611	1688	23830851113019	27035	13369	4	0	77
41612	1688	23830864113019	27035	13369	5	0	77
41617	1688	24550864113019	27050	13374	3	0	\N
41618	1688	24550864113019	27113	13405	3	0	\N
41620	1688	24550876113019	27050	13374	4	0	\N
41621	1688	24550876113019	27113	13405	4	0	\N
41627	1688	25270876113019	27158	13428	6	0	\N
41629	1688	25270900113019	27158	13428	7	0	\N
41631	1688	25919191910040	22006	11005	3	0	\N
41632	1688	25919191910040	22047	11025	3	0	\N
41634	1688	25919203910040	22006	11005	4	0	\N
41635	1688	25919203910040	22047	11025	4	0	\N
41645	1688	26710912113019	27187	13447	3	0	\N
41648	1688	26710924113019	27187	13447	4	0	\N
41649	1688	27359215910040	22105	11055	4	0	\N
41651	1688	27359237910040	22105	11055	5	0	\N
41659	1688	28079662000000	2162	1141	1	0	\N
41661	1688	28079672000000	2162	1141	2	0	\N
41663	1688	28150946113019	27228	13464	6	0	\N
41664	1688	28150946113019	27253	13474	3	0	\N
41665	1688	28150946113019	27255	13476	3	0	\N
41666	1688	28150946113019	27293	13489	2	0	\N
41668	1688	28150957113019	27293	13489	3	0	\N
41669	1688	28150958113019	27253	13474	4	0	\N
41670	1688	28150958113019	27255	13476	4	0	\N
41672	1688	28150970113019	27228	13464	7	0	\N
41673	1688	28151659708000	15823	8052	7	0	\N
41674	1688	28440427904000	10480	5418	6	0	\N
41675	1688	28440427904000	10500	5424	11	0	\N
41676	1688	28440427904000	10513	5429	4	0	\N
41677	1688	28440427904000	10515	5430	6	0	\N
41679	1688	28440467904000	10513	5429	5	0	\N
41681	1688	28440487904000	10480	5418	7	0	\N
41682	1688	28440487904000	10515	5430	7	0	\N
41683	1688	28440488904000	10584	5466	2	0	\N
41684	1688	28440537904000	10500	5424	12	0	\N
41691	1688	28871589708000	15833	8055	7	0	\N
41694	1688	28871632708000	15833	8055	8	0	\N
41695	1688	28871659708000	15823	8052	20	0	\N
41696	1688	28871716708000	15823	8052	21	0	\N
41697	1688	29160468904000	10555	5449	9	0	\N
41698	1688	29160468904000	10556	5450	3	0	\N
41700	1688	29160488904000	10584	5466	3	0	\N
41702	1688	29160498904000	10556	5450	4	0	\N
41703	1688	29160558904000	10555	5449	10	0	\N
41706	1688	29519692000000	2222	1169	1	0	\N
41708	1688	29519702000000	2222	1169	2	0	\N
41720	1688	30310983113019	27334	13512	3	0	\N
41722	1688	30310995113019	27334	13512	4	0	\N
41724	1688	30311036113019	27488	13586	14	0	\N
41727	1688	30600508904000	10613	5481	2	0	\N
41728	1688	30600508904000	10626	5487	2	0	\N
41730	1688	30600528904000	10613	5481	3	0	\N
41731	1688	30600528904000	10626	5487	3	0	\N
41737	1688	31030995113019	27451	13567	3	0	\N
41738	1688	31030995113019	27455	13569	3	0	\N
41739	1688	31030995113019	27508	13599	15	0	\N
41740	1688	31030995113019	27538	13614	3	0	\N
41742	1688	31031007113019	27451	13567	4	0	\N
41743	1688	31031007113019	27455	13569	4	0	\N
41744	1688	31031007113019	27538	13614	4	0	\N
41746	1688	31031036113019	27488	13586	28	0	\N
41747	1688	31031049113019	27488	13586	29	0	\N
41748	1688	31031055113019	27508	13599	16	0	\N
41749	1688	31031626708000	15971	8117	6	0	\N
41750	1688	31031626708000	16026	8149	9	0	\N
41751	1688	31031626708000	16049	8162	3	0	\N
41752	1688	31031626708000	16068	8170	6	0	\N
41637	1688	25919602000000	2087	1102	3	0	0
41638	1688	25919632000000	2087	1102	4	0	0
41643	1688	26639632000000	2118	1117	1	0	0
41644	1688	26639642000000	2118	1117	2	0	0
41653	1688	27359642000000	2125	1120	2	0	0
41660	1688	28079662000000	2197	1157	1	0	0
41662	1688	28079672000000	2197	1157	2	0	0
41687	1688	28799672000000	2205	1160	2	0	0
41688	1688	28799692000000	2205	1160	3	0	0
41707	1688	29519692000000	2237	1179	1	0	0
41719	1688	30239702000000	2271	1192	0	0	0
41735	1688	30959702000000	2274	1193	2	0	0
41736	1688	30959722000000	2274	1193	3	0	0
41678	1688	28440427904000	10549	5447	5	0	18
41699	1688	29160468904000	10587	5468	2	0	18
41701	1688	29160488904000	10587	5468	3	0	18
41714	1688	29880488904000	10597	5473	2	0	18
41715	1688	29880508904000	10597	5473	3	0	18
41729	1688	30600508904000	10628	5489	2	0	18
41692	1688	28871589708000	15872	8073	3	0	36
41693	1688	28871601708000	15872	8073	4	0	36
41712	1688	29591601708000	15874	8074	4	0	36
41713	1688	29591614708000	15874	8074	5	0	36
41725	1688	30311614708000	15941	8103	3	0	36
41623	1688	25199180910040	21988	10994	2	0	57
41624	1688	25199191910040	21988	10994	3	0	57
41633	1688	25919191910040	22063	11032	3	0	57
41636	1688	25919203910040	22063	11032	4	0	57
41642	1688	26639215910040	22081	11041	4	0	57
41650	1688	27359215910040	22182	11100	6	0	57
41652	1688	27359239910040	22182	11100	7	0	57
41657	1688	28079239910040	22191	11107	4	0	57
41658	1688	28079252910040	22191	11107	5	0	57
41686	1688	28799265910040	22207	11117	5	0	57
41704	1688	29519265910040	22255	11138	3	0	57
41705	1688	29519277910040	22255	11138	4	0	57
41716	1688	30239277910040	22312	11169	3	0	57
41717	1688	30239289910040	22312	11169	4	0	57
41733	1688	30959323910040	22320	11173	12	0	57
41734	1688	30959324710020	22320	11173	14	0	57
41619	1688	24550864113019	27124	13412	3	0	77
41622	1688	24550876113019	27124	13412	4	0	77
41630	1688	25270900113019	27177	13442	7	0	77
41639	1688	25990900113019	27185	13446	3	0	77
41640	1688	25990912113019	27185	13446	4	0	77
41646	1688	26710912113019	27194	13450	2	0	77
41647	1688	26710923113019	27194	13450	3	0	77
41656	1688	27430946113019	27207	13457	6	0	77
41667	1688	28150946113019	27299	13493	3	0	77
41671	1688	28150958113019	27299	13493	4	0	77
41689	1688	28870958113019	27310	13499	3	0	77
41690	1688	28870970113019	27310	13499	4	0	77
41711	1688	29590983113019	27333	13511	5	0	77
41721	1688	30310983113019	27368	13532	3	0	77
41723	1688	30310995113019	27368	13532	4	0	77
41741	1688	31030995113019	27575	13629	3	0	77
41754	1688	31031638708000	16049	8162	4	0	\N
41755	1688	31031641708000	16068	8170	7	0	\N
41756	1688	31031650708000	15971	8117	7	0	\N
41758	1688	31031662708000	16026	8149	10	0	\N
41759	1688	31320528904000	10630	5490	2	0	\N
41760	1688	31320528904000	10659	5504	4	0	\N
41762	1688	31320548904000	10630	5490	3	0	\N
41764	1688	31320568904000	10659	5504	5	0	\N
41770	1688	31679722000000	2308	1209	1	0	\N
41772	1688	31679732000000	2308	1209	2	0	\N
41775	1688	31751007113019	27642	13660	12	0	\N
41778	1688	31751055113019	27642	13660	13	0	\N
41779	1688	31751651708000	16095	8180	3	0	\N
41780	1688	31751651708000	16106	8186	7	0	\N
41782	1688	31751663708000	16095	8180	4	0	\N
41784	1688	31751676708000	16106	8186	8	0	\N
41785	1688	32040548904000	10716	5531	2	0	\N
41786	1688	32040548904000	10917	5631	2	0	\N
41787	1688	32040548904000	11157	5538	0	0	\N
41788	1688	32040548904000	11159	5551	0	0	\N
41789	1688	32040548904000	11160	5564	0	0	\N
41790	1688	32040548904000	11161	5577	0	0	\N
41791	1688	32040548904000	11162	5589	0	0	\N
41792	1688	32040568904000	10716	5531	3	0	\N
41793	1688	32040568904000	10917	5631	3	0	\N
41804	1688	32760568904000	10963	5650	2	0	\N
41806	1688	32760588904000	10963	5650	3	0	\N
41808	1688	33118361710020	22484	11250	9	0	\N
41809	1688	33118433710020	22484	11250	10	0	\N
41810	1688	33119361710020	22460	11239	3	0	\N
41812	1688	33119373710020	22460	11239	4	0	\N
41813	1688	33119408908000	18014	9085	7	0	\N
41814	1688	33119408908000	18045	9102	3	0	\N
41817	1688	33119420908000	18045	9102	4	0	\N
41818	1688	33119433908000	18014	9085	8	0	\N
41829	1688	33839419908000	18159	9154	7	0	\N
41830	1688	33839419908000	18187	9170	5	0	\N
41831	1688	33839419908000	18210	9174	3	0	\N
41834	1688	33839440908000	18210	9174	4	0	\N
41835	1688	33839444908000	18159	9154	8	0	\N
41840	1688	33911689708000	16279	8274	4	0	\N
41843	1688	33911702708000	16279	8274	5	0	\N
41844	1688	34200908904000	11010	5669	6	0	\N
41845	1688	34200908904000	11034	5681	2	0	\N
41847	1688	34200928904000	11034	5681	3	0	\N
41849	1688	34201058904000	11010	5669	7	0	\N
41853	1688	34559441907992	18202	9171	6	0	\N
41855	1688	34559474907992	18202	9171	7	0	\N
41858	1688	34560632000000	2553	1277	68	0	\N
41867	1688	35279441908000	18256	9194	4	0	\N
41868	1688	35279441908000	18272	9206	5	0	\N
41869	1688	35279441908000	18301	9220	3	0	\N
41870	1688	35279441908000	18308	9223	19	0	\N
41873	1688	35279453908000	18301	9220	4	0	\N
41874	1688	35279463908000	18256	9194	5	0	\N
41875	1688	35279464908000	18272	9206	6	0	\N
41877	1688	35279832000000	2384	1246	1	0	\N
41878	1688	35279832000000	2392	1250	1	0	\N
41879	1688	35279832000000	3056	1429	0	0	\N
41880	1688	35279832000000	3057	1442	0	0	\N
41881	1688	35279832000000	3059	1456	0	0	\N
41882	1688	35279832000000	3060	1467	0	0	\N
41883	1688	35279832000000	3061	1473	0	0	\N
41884	1688	35279842000000	2384	1246	2	0	\N
41885	1688	35279842000000	2392	1250	2	0	\N
41886	1688	35279901908000	18308	9223	20	0	\N
41887	1688	35280632000000	2553	1277	81	0	\N
41888	1688	35280752000000	2553	1277	82	0	\N
41774	1688	31679782000000	2336	1221	4	0	0
41799	1688	32399782000000	2336	1221	5	0	0
41819	1688	33119782000000	2344	1225	3	0	0
41820	1688	33119812000000	2344	1225	4	0	0
41836	1688	33839812000000	2372	1239	1	0	0
41856	1688	34559822000000	2373	1240	1	0	0
41857	1688	34559832000000	2373	1240	2	0	0
41876	1688	35279822000000	3069	1595	0	0	0
41761	1688	31320528904000	10683	5515	2	0	18
41763	1688	31320548904000	10683	5515	3	0	18
41794	1688	32040568904000	10925	5634	3	0	18
41805	1688	32760568904000	10976	5655	3	0	18
41807	1688	32760888904000	10976	5655	4	0	18
41825	1688	33480888904000	10995	5665	2	0	18
41846	1688	34200908904000	11079	5700	2	0	18
41848	1688	34200928904000	11079	5700	3	0	18
41863	1688	34920928904000	11087	5704	4	0	18
41864	1688	34920968904000	11087	5704	5	0	18
41753	1688	31031626708000	16069	8171	7	0	36
41781	1688	31751651708000	16111	8189	4	0	36
41783	1688	31751664708000	16111	8189	5	0	36
41802	1688	32471664708000	16196	8232	4	0	36
41803	1688	32471677708000	16196	8232	5	0	36
41823	1688	33191677708000	16260	8263	3	0	36
41841	1688	33911689708000	16302	8284	3	0	36
41842	1688	33911701708000	16302	8284	4	0	36
41861	1688	34631701708000	16358	8319	4	0	36
41862	1688	34631714708000	16358	8319	5	0	36
41769	1688	31679408908000	18001	9081	6	0	38
41798	1688	32399408908000	18003	9082	0	0	38
41815	1688	33119408908000	18088	9121	2	0	38
41816	1688	33119419908000	18088	9121	3	0	38
41832	1688	33839419908000	18232	9184	2	0	38
41852	1688	34559430908000	18237	9186	2	0	38
41854	1688	34559441908000	18237	9186	3	0	38
41871	1688	35279441908000	18334	9236	2	0	38
41872	1688	35279452908000	18334	9236	3	0	38
41766	1688	31679324710020	22366	11195	3	0	57
41795	1688	32399336710020	22367	11196	7	0	57
41796	1688	32399361710020	22367	11196	8	0	57
41797	1688	32399371710020	22506	11258	1	0	57
41811	1688	33119370720020	22506	11258	2	0	57
41828	1688	33839391720020	22589	11302	4	0	57
41850	1688	34559391720020	22601	11307	4	0	57
41851	1688	34559413720020	22601	11307	5	0	57
41865	1688	35279413720020	22610	11311	2	0	57
41866	1688	35279424720020	22610	11311	3	0	57
41777	1688	31751033113019	27662	13671	9	0	77
41800	1688	32471033113019	27715	13694	2	0	77
41801	1688	32471044113019	27715	13694	3	0	77
41821	1688	33191044113019	27810	13741	6	0	77
41822	1688	33191068113019	27810	13741	7	0	77
41839	1688	33911080113019	27835	13757	4	0	77
41859	1688	34631080113019	27856	13769	6	0	77
41860	1688	34631104113019	27856	13769	7	0	77
41891	1688	35351714708000	16363	8322	2	0	\N
41892	1688	35351714708000	16365	8323	11	0	\N
41894	1688	35351725708000	16363	8322	3	0	\N
41896	1688	35352040708000	16365	8323	12	0	\N
41897	1688	35640968904000	11095	5709	2	0	\N
41899	1688	35640988904000	11095	5709	3	0	\N
41905	1688	35999822000000	3138	1632	4	0	\N
41908	1688	35999862000000	3138	1632	5	0	\N
41911	1688	36071726708000	16492	8387	4	0	\N
41912	1688	36071726708000	16504	8395	8	0	\N
41913	1688	36071726708000	16524	8403	4	0	\N
41914	1688	36071726708000	16557	8415	3	0	\N
41915	1688	36071726708000	16570	8421	14	0	\N
41917	1688	36071738708000	16557	8415	4	0	\N
41918	1688	36071739708000	16524	8403	5	0	\N
41919	1688	36071748708000	16492	8387	5	0	\N
41921	1688	36071761708000	16504	8395	9	0	\N
41922	1688	36071785708000	16570	8421	15	0	\N
41926	1688	36719462908000	18394	9270	2	0	\N
41927	1688	36719462908000	18414	9284	10	0	\N
41929	1688	36719473908000	18394	9270	3	0	\N
41931	1688	36719499908000	18414	9284	11	0	\N
41934	1688	36791129113019	27946	13825	3	0	\N
41935	1688	36791129113019	28091	13887	3	0	\N
41937	1688	36791141113019	27946	13825	4	0	\N
41938	1688	36791141113019	28091	13887	4	0	\N
41944	1688	37439449720020	22678	11339	3	0	\N
41945	1688	37439449720020	22686	11343	4	0	\N
41946	1688	37439449720020	22772	11388	21	0	\N
41948	1688	37439461720020	22678	11339	4	0	\N
41950	1688	37439471720020	22686	11343	5	0	\N
41951	1688	37439473908000	18431	9293	7	0	\N
41954	1688	37439498908000	18431	9293	8	0	\N
41955	1688	37439524720020	22772	11388	22	0	\N
41964	1688	38159461720020	22793	11401	6	0	\N
41965	1688	38159461720020	22836	11420	2	0	\N
41966	1688	38159461720020	22845	11424	4	0	\N
41967	1688	38159461720020	22898	11446	3	0	\N
41969	1688	38159472720020	22836	11420	3	0	\N
41970	1688	38159473720020	22898	11446	4	0	\N
41972	1688	38159483720020	22845	11424	5	0	\N
41973	1688	38159485720020	22793	11401	7	0	\N
41976	1688	38159852000000	3236	1681	1	0	\N
41977	1688	38159852000000	3260	1694	1	0	\N
41978	1688	38159852000000	3299	1712	2	0	\N
41980	1688	38159862000000	3236	1681	2	0	\N
41981	1688	38159862000000	3260	1694	2	0	\N
41982	1688	38159872000000	3299	1712	3	0	\N
41990	1688	38879473720020	22997	11489	3	0	\N
41991	1688	38879473720020	23009	11494	8	0	\N
41993	1688	38879485720020	22997	11489	4	0	\N
41995	1688	38879499720020	23009	11494	9	0	\N
41998	1688	38879962000000	3316	1720	2	0	\N
41999	1688	38879962000000	3324	1724	5	0	\N
42001	1688	38879982000000	3316	1720	3	0	\N
42003	1688	38880012000000	3324	1724	6	0	\N
42006	1688	38951798708000	16647	8458	3	0	\N
42007	1688	38951798708000	16668	8466	7	0	\N
42009	1688	38951810708000	16647	8458	4	0	\N
42011	1688	38951823708000	16668	8466	8	0	\N
42018	1688	39599982000000	3417	1777	1	0	\N
42020	1688	39599992000000	3417	1777	2	0	\N
41932	1688	36719832000000	3160	1642	1	0	0
41933	1688	36719842000000	3160	1642	2	0	0
41956	1688	37439842000000	3218	1673	1	0	0
41957	1688	37439852000000	3218	1673	2	0	0
41979	1688	38159852000000	3312	1719	2	0	0
42000	1688	38879962000000	3327	1726	2	0	0
42002	1688	38879982000000	3327	1726	3	0	0
42019	1688	39599982000000	3439	1785	0	0	0
41898	1688	35640968904000	11143	5727	3	0	18
41900	1688	35640998904000	11143	5727	4	0	18
41942	1688	37080998904000	11199	5751	2	0	18
41943	1688	37081018904000	11199	5751	3	0	18
41962	1688	37801018904000	11209	5756	2	0	18
41963	1688	37801038904000	11209	5756	3	0	18
41989	1688	38521061904000	11229	5771	6	0	18
42012	1688	39241061904000	11253	5782	8	0	18
42013	1688	39241132904000	11253	5782	9	0	18
41893	1688	35351714708000	16462	8373	3	0	36
41895	1688	35351726708000	16462	8373	4	0	36
41920	1688	36071750708000	16573	8423	7	0	36
41940	1688	36791750708000	16574	8424	5	0	36
41941	1688	36791773708000	16574	8424	6	0	36
41960	1688	37511773708000	16575	8425	4	0	36
41961	1688	37511786708000	16575	8425	5	0	36
41987	1688	38231798708000	16630	8448	4	0	36
42008	1688	38951798708000	16679	8471	3	0	36
42010	1688	38951810708000	16679	8471	4	0	36
42023	1688	39671810708000	16695	8480	2	0	36
41903	1688	35999452908000	18335	9237	1	0	38
41904	1688	35999462908000	18335	9237	2	0	38
41928	1688	36719462908000	18425	9289	2	0	38
41930	1688	36719473908000	18425	9289	3	0	38
41952	1688	37439473908000	18441	9295	6	0	38
41974	1688	38159497908000	18467	9305	7	0	38
41975	1688	38159522908000	18467	9305	8	0	38
41996	1688	38879522908000	18551	9347	10	0	38
41997	1688	38879559908000	18551	9347	11	0	38
42016	1688	39599559908000	18554	9350	13	0	38
41901	1688	35999424720020	22668	11332	4	0	57
41902	1688	35999437720020	22668	11332	5	0	57
41924	1688	36719437720020	22669	11333	3	0	57
41925	1688	36719449720020	22669	11333	4	0	57
41949	1688	37439461720020	22792	11400	4	0	57
41968	1688	38159461720020	22911	11452	3	0	57
41971	1688	38159473720020	22911	11452	4	0	57
41992	1688	38879473720020	23013	11495	3	0	57
41994	1688	38879485720020	23013	11495	4	0	57
42015	1688	39599522720020	23084	11527	11	0	57
41889	1688	35351104113019	27858	13770	3	0	77
41890	1688	35351116113019	27858	13770	4	0	77
41909	1688	36071116113019	27865	13776	4	0	77
41910	1688	36071129113019	27865	13776	5	0	77
41939	1688	36791166113019	28099	13890	11	0	77
41958	1688	37511166113019	28112	13896	4	0	77
41959	1688	37511188113019	28112	13896	5	0	77
41984	1688	38231188113019	28155	13922	3	0	77
42004	1688	38951200113019	28157	13924	4	0	77
42005	1688	38951222113019	28157	13924	5	0	77
42021	1688	39671222113019	28181	13931	2	0	77
42022	1688	39671233113019	28181	13931	3	0	77
42029	1688	40319608908000	18607	9376	2	0	\N
42031	1688	40319619908000	18607	9376	3	0	\N
42033	1688	40319982000000	3445	1789	1	0	\N
42034	1688	40319982000000	3513	1823	0	0	\N
42036	1688	40319992000000	3445	1789	2	0	\N
42041	1688	40681143904000	11295	5803	2	0	\N
42043	1688	40681154904000	11295	5803	3	0	\N
42045	1688	41039534720020	23152	11562	4	0	\N
42046	1688	41039534720020	23170	11569	3	0	\N
42047	1688	41039534720020	23215	11587	3	0	\N
42050	1688	41039546720020	23170	11569	4	0	\N
42051	1688	41039547720020	23152	11562	5	0	\N
42052	1688	41039555720020	23215	11587	4	0	\N
42055	1688	41039982000000	3542	1838	0	0	\N
42056	1688	41039982000000	3589	1865	0	0	\N
42058	1688	41111244113019	28221	13953	2	0	\N
42059	1688	41111244113019	28239	13961	2	0	\N
42061	1688	41111255113019	28221	13953	3	0	\N
42062	1688	41111255113019	28239	13961	3	0	\N
42066	1688	41401154904000	11343	5826	6	0	\N
42070	1688	41401187904000	11343	5826	7	0	\N
42071	1688	41759545720020	23235	11595	2	0	\N
42072	1688	41759545720020	23275	11612	2	0	\N
42074	1688	41759556720020	23235	11595	3	0	\N
42075	1688	41759556720020	23275	11612	3	0	\N
42081	1688	41831268113019	28301	13990	6	0	\N
42083	1688	41831292113019	28301	13990	7	0	\N
42085	1688	41831855708000	16955	8594	6	0	\N
42088	1688	41831888708000	16955	8594	7	0	\N
42091	1688	42479556720020	23326	11641	4	0	\N
42094	1688	42479578720020	23326	11641	5	0	\N
42097	1688	42479992000000	3731	1936	1	0	\N
42099	1688	42480002000000	3731	1936	2	0	\N
42104	1688	42551867708000	17021	8622	7	0	\N
42107	1688	42551892708000	17021	8622	8	0	\N
42110	1688	43199568720020	23379	11666	2	0	\N
42111	1688	43199568720020	23391	11670	10	0	\N
42113	1688	43199579720020	23379	11666	3	0	\N
42115	1688	43199623720020	23391	11670	11	0	\N
42122	1688	43271879708000	17070	8647	4	0	\N
42123	1688	43271879708000	17136	8683	2	0	\N
42125	1688	43271890708000	17136	8683	3	0	\N
42126	1688	43271892708000	17070	8647	5	0	\N
42128	1688	43561220904000	11414	5863	1	0	\N
42129	1688	43561220904000	11445	5880	1	0	\N
42131	1688	43561221904000	11414	5863	2	0	\N
42132	1688	43561230904000	11445	5880	2	0	\N
42134	1688	43919579720020	23490	11712	3	0	\N
42136	1688	43919591720020	23490	11712	4	0	\N
42155	1688	44711377113019	28410	14040	3	0	\N
42158	1688	44711398113019	28410	14040	4	0	\N
42079	1688	41759982000000	3715	1929	1	0	0
42080	1688	41759992000000	3715	1929	2	0	0
42098	1688	42479992000000	3749	1944	2	0	0
42100	1688	42480012000000	3749	1944	3	0	0
42118	1688	43200012000000	3751	1945	1	0	0
42140	1688	43920022000000	3755	1947	1	0	0
42141	1688	43920032000000	3755	1947	2	0	0
42142	1688	43920052000000	3784	1960	2	0	0
42154	1688	44640052000000	3784	1960	3	0	0
42025	1688	39961132904000	11286	5797	2	0	18
42042	1688	40681143904000	11314	5811	2	0	18
42044	1688	40681154904000	11314	5811	3	0	18
42067	1688	41401154904000	11373	5842	4	0	18
42068	1688	41401176904000	11373	5842	5	0	18
42089	1688	42121186904000	11389	5850	5	0	18
42090	1688	42121198904000	11389	5850	6	0	18
42108	1688	42841198904000	11408	5860	4	0	18
42109	1688	42841220904000	11408	5860	5	0	18
42130	1688	43561220904000	11451	5882	4	0	18
42149	1688	44281242904000	11464	5892	2	0	18
42150	1688	44281253904000	11464	5892	3	0	18
42039	1688	40391821708000	16704	8487	3	0	36
42040	1688	40391833708000	16704	8487	4	0	36
42064	1688	41111833708000	16953	8593	4	0	36
42086	1688	41831855708000	16980	8602	3	0	36
42087	1688	41831867708000	16980	8602	4	0	36
42105	1688	42551867708000	17059	8640	3	0	36
42106	1688	42551879708000	17059	8640	4	0	36
42127	1688	43271916708000	17154	8696	11	0	36
42145	1688	43991916708000	17195	8714	4	0	36
42146	1688	43991929708000	17195	8714	5	0	36
42159	1688	44711929708000	17289	8757	3	0	36
42160	1688	44711941708000	17289	8757	4	0	36
42148	1688	44279795908000	17981	9068	7	0	37
42030	1688	40319608908000	18622	9383	2	0	38
42032	1688	40319619908000	18622	9383	3	0	38
42053	1688	41039619908000	18630	9388	5	0	38
42054	1688	41039642908000	18630	9388	6	0	38
42078	1688	41759653908000	18636	9391	3	0	38
42095	1688	42479653908000	18666	9406	2	0	38
42096	1688	42479664908000	18666	9406	3	0	38
42116	1688	43199664908000	18679	9410	3	0	38
42138	1688	43919676908000	18701	9419	4	0	38
42139	1688	43919698908000	18701	9419	5	0	38
42152	1688	44639698908000	18716	9429	2	0	38
42153	1688	44639709908000	18716	9429	3	0	38
42027	1688	40319522720020	23106	11540	3	0	57
42048	1688	41039534720020	23231	11592	2	0	57
42049	1688	41039545720020	23231	11592	3	0	57
42073	1688	41759545720020	23319	11637	2	0	57
42076	1688	41759556720020	23319	11637	3	0	57
42092	1688	42479556720020	23361	11657	3	0	57
42112	1688	43199568720020	23398	11672	2	0	57
42114	1688	43199579720020	23398	11672	3	0	57
42135	1688	43919579720020	23504	11717	3	0	57
42137	1688	43919591720020	23504	11717	4	0	57
42037	1688	40391233113019	28196	13939	2	0	77
42038	1688	40391244113019	28196	13939	3	0	77
42060	1688	41111244113019	28252	13968	6	0	77
42063	1688	41111268113019	28252	13968	7	0	77
42082	1688	41831268113019	28343	14011	8	0	77
42101	1688	42551312113019	28355	14017	5	0	77
42102	1688	42551344113019	28355	14017	6	0	77
42103	1688	42551354113019	28375	14027	1	0	77
42120	1688	43271354113019	28375	14027	3	0	77
42121	1688	43271355113019	28375	14027	4	0	77
42144	1688	43991377113019	28402	14038	5	0	77
42156	1688	44711377113019	28467	14067	2	0	77
42157	1688	44711388113019	28467	14067	3	0	77
42161	1688	45001253904000	11466	5894	2	0	\N
42162	1688	45001253904000	11474	5898	2	0	\N
42163	1688	45001253904000	11507	5912	2	0	\N
42164	1688	45001253904000	11516	5915	2	0	\N
42166	1688	45001264904000	11466	5894	3	0	\N
42167	1688	45001264904000	11474	5898	3	0	\N
42168	1688	45001264904000	11507	5912	3	0	\N
42169	1688	45001264904000	11516	5915	3	0	\N
42177	1688	45431388113019	28484	14076	2	0	\N
42179	1688	45431399113019	28484	14076	3	0	\N
42185	1688	46079628720020	23564	11744	4	0	\N
42186	1688	46079628720020	23587	11753	3	0	\N
42188	1688	46079640720020	23587	11753	4	0	\N
42190	1688	46079650720020	23564	11744	5	0	\N
42195	1688	46151403113019	28606	14126	4	0	\N
42197	1688	46151416113019	28606	14126	5	0	\N
42199	1688	46151952708000	17320	8776	3	0	\N
42201	1688	46151964708000	17320	8776	4	0	\N
42207	1688	46799832908000	18779	9463	3	0	\N
42208	1688	46799832908000	18851	9505	1	0	\N
42210	1688	46799842908000	18851	9505	2	0	\N
42212	1688	46799844908000	18779	9463	4	0	\N
42217	1688	46871964708000	17345	8788	3	0	\N
42219	1688	46871976708000	17345	8788	4	0	\N
42232	1688	47591976708000	17435	8831	3	0	\N
42233	1688	47591976708000	17490	8854	8	0	\N
42235	1688	47591988708000	17435	8831	4	0	\N
42237	1688	47592038708000	17490	8854	9	0	\N
42238	1688	47881289904000	11583	5957	0	0	\N
42241	1688	48239665720020	23659	11784	10	0	\N
42244	1688	48239702720020	23659	11784	11	0	\N
42245	1688	48239854908000	18963	9565	1	0	\N
42246	1688	48239854908000	18996	9578	1	0	\N
42248	1688	48239864908000	18963	9565	2	0	\N
42249	1688	48239864908000	18996	9578	2	0	\N
42251	1688	48240092000000	3981	2068	1	0	\N
42252	1688	48240092000000	4068	2114	1	0	\N
42253	1688	48240092000000	4095	2129	1	0	\N
42255	1688	48240102000000	3981	2068	2	0	\N
42256	1688	48240102000000	4068	2114	2	0	\N
42257	1688	48240102000000	4095	2129	2	0	\N
42259	1688	48311439113019	28687	14161	4	0	\N
42260	1688	48311439113019	28727	14163	0	0	\N
42261	1688	48311439113019	28728	14149	0	0	\N
42262	1688	48311439113019	28729	14174	0	0	\N
42263	1688	48311439113019	28734	14177	5	0	\N
42264	1688	48311439113019	28757	14186	4	0	\N
42265	1688	48311439113019	28765	14186	0	0	\N
42266	1688	48311439113019	28773	14194	1	0	\N
42267	1688	48311439113019	28795	14206	3	0	\N
42268	1688	48311439113019	28828	14220	7	0	\N
42269	1688	48311439113019	28876	14244	3	0	\N
42270	1688	48311439113019	28881	14246	3	0	\N
42272	1688	48311440113019	28773	14194	2	0	\N
42273	1688	48311451113019	28795	14206	4	0	\N
42274	1688	48311451113019	28876	14244	4	0	\N
42275	1688	48311451113019	28881	14246	4	0	\N
42277	1688	48311452113019	28687	14161	5	0	\N
42278	1688	48311452113019	28757	14186	5	0	\N
42279	1688	48311464113019	28828	14220	8	0	\N
42280	1688	48311480113019	28734	14177	6	0	\N
42281	1688	48311988708000	17559	8889	3	0	\N
42283	1688	48312000708000	17559	8889	4	0	\N
42285	1688	48601290904000	11631	5986	1	0	\N
42287	1688	48601291904000	11631	5986	2	0	\N
42289	1688	48959678720020	23769	11836	3	0	\N
42291	1688	48959690720020	23769	11836	4	0	\N
42193	1688	46080062000000	3821	1980	1	0	0
42194	1688	46080072000000	3821	1980	2	0	0
42213	1688	46800072000000	3869	2009	1	0	0
42214	1688	46800082000000	3869	2009	2	0	0
42228	1688	47520082000000	3909	2030	1	0	0
42254	1688	48240092000000	4100	2132	1	0	0
42258	1688	48240102000000	4100	2132	2	0	0
42295	1688	48960102000000	4107	2134	2	0	0
42296	1688	48960212000000	4107	2134	3	0	0
42165	1688	45001253904000	11527	5921	5	0	18
42183	1688	45721276904000	11530	5923	2	0	18
42184	1688	45721287904000	11530	5923	3	0	18
42203	1688	46441287904000	11550	5934	1	0	18
42204	1688	46441288904000	11550	5934	2	0	18
42222	1688	47161289904000	11556	5938	2	0	18
42239	1688	47881289904000	11591	5962	1	0	18
42240	1688	47881290904000	11591	5962	2	0	18
42286	1688	48601290904000	11703	6018	1	0	18
42288	1688	48601291904000	11703	6018	2	0	18
42182	1688	45431952708000	17319	8775	3	0	36
42200	1688	46151952708000	17338	8784	3	0	36
42202	1688	46151964708000	17338	8784	4	0	36
42218	1688	46871964708000	17376	8800	3	0	36
42220	1688	46871976708000	17376	8800	4	0	36
42236	1688	47591988708000	17547	8885	4	0	36
42282	1688	48311988708000	17565	8891	6	0	36
42284	1688	48312012708000	17565	8891	7	0	36
42173	1688	45359709908000	18766	9458	3	0	38
42191	1688	46079820908000	18772	9460	3	0	38
42192	1688	46079832908000	18772	9460	4	0	38
42209	1688	46799832908000	18867	9514	2	0	38
42211	1688	46799843908000	18867	9514	3	0	38
42226	1688	47519843908000	18885	9525	2	0	38
42247	1688	48239854908000	19031	9597	1	0	38
42250	1688	48239864908000	19031	9597	2	0	38
42293	1688	48959864908000	19063	9613	10	0	38
42294	1688	48959959908000	19063	9613	11	0	38
42171	1688	45359591720020	23538	11733	10	0	57
42187	1688	46079628720020	23633	11773	3	0	57
42189	1688	46079640720020	23633	11773	4	0	57
42205	1688	46799640720020	23648	11781	4	0	57
42206	1688	46799653720020	23648	11781	5	0	57
42224	1688	47519665720020	23653	11783	4	0	57
42225	1688	47519675720020	23767	11835	1	0	57
42242	1688	48239675720020	23767	11835	5	0	57
42243	1688	48239678720020	23767	11835	6	0	57
42290	1688	48959678720020	23815	11854	3	0	57
42178	1688	45431388113019	28526	14094	6	0	77
42180	1688	45431403113019	28526	14094	7	0	77
42196	1688	46151403113019	28621	14132	4	0	77
42198	1688	46151416113019	28621	14132	5	0	77
42215	1688	46871416113019	28622	14133	3	0	77
42230	1688	47591428113019	28641	14141	2	0	77
42231	1688	47591439113019	28641	14141	3	0	77
42271	1688	48311439113019	28883	14247	3	0	77
42276	1688	48311451113019	28883	14247	4	0	77
42297	1688	49031451113019	28902	14256	9	0	\N
42300	1688	49031487113019	28902	14256	10	0	\N
42303	1688	49321291904000	11730	6029	1	0	\N
42304	1688	49321291904000	11753	6042	0	0	\N
42306	1688	49321292904000	11730	6029	2	0	\N
42314	1688	49751464113019	28955	14281	3	0	\N
42316	1688	49751476113019	28955	14281	4	0	\N
42330	1688	50472047708000	17615	8908	3	0	\N
42331	1688	50472047708000	17627	8913	6	0	\N
42333	1688	50472059708000	17615	8908	4	0	\N
42334	1688	50472071708000	17627	8913	7	0	\N
42338	1688	51119715720020	23859	11876	7	0	\N
42339	1688	51119715720020	23863	11877	10	0	\N
42341	1688	51119740720020	23859	11876	8	0	\N
42342	1688	51119752720020	23863	11877	11	0	\N
42348	1688	51191490113019	29042	14323	6	0	\N
42349	1688	51191490113019	29053	14327	3	0	\N
42350	1688	51191490113019	29131	14362	8	0	\N
42352	1688	51191502113019	29053	14327	4	0	\N
42354	1688	51191514113019	29042	14323	7	0	\N
42355	1688	51191516113019	29131	14362	9	0	\N
42356	1688	51192072708000	17829	9004	3	0	\N
42357	1688	51192072708000	17846	9007	9	0	\N
42358	1688	51192072708000	17847	9008	4	0	\N
42360	1688	51192084708000	17829	9004	4	0	\N
42362	1688	51192085708000	17847	9008	5	0	\N
42363	1688	51192095708000	17883	9025	2	0	\N
42364	1688	51192108708000	17846	9007	10	0	\N
42367	1688	51839777720020	23986	11937	3	0	\N
42368	1688	51839777720020	23992	11940	3	0	\N
42369	1688	51839777720020	24045	11965	2	0	\N
42372	1688	51839779720020	24045	11965	3	0	\N
42373	1688	51839789720020	23986	11937	4	0	\N
42374	1688	51839789720020	23992	11940	4	0	\N
42375	1688	51840013908000	19125	9647	2	0	\N
42377	1688	51840024908000	19125	9647	3	0	\N
42381	1688	51911513113019	29186	14388	6	0	\N
42384	1688	51911537113019	29186	14388	7	0	\N
42385	1688	51912084708000	17970	9063	2	0	\N
42387	1688	51912095708000	17883	9025	4	0	\N
42388	1688	51912095708000	17970	9063	3	0	\N
42389	1688	51912096708000	17883	9025	5	0	\N
42391	1688	52201296904000	11868	6099	1	0	\N
42393	1688	52201297904000	11868	6099	2	0	\N
42395	1688	52559778720020	24119	12005	10	0	\N
42398	1688	52559824720020	24119	12005	11	0	\N
42401	1688	52560262000000	4143	2155	1	0	\N
42403	1688	52560272000000	4143	2155	2	0	\N
42405	1688	52631525113019	29242	14411	3	0	\N
42407	1688	52631537113019	29242	14411	4	0	\N
42411	1688	53279800720020	24130	12011	2	0	\N
42412	1688	53279800720020	24166	12028	2	0	\N
42413	1688	53279800720020	24193	12041	2	0	\N
42414	1688	53279800720020	24216	12052	3	0	\N
42416	1688	53279811720020	24130	12011	3	0	\N
42417	1688	53279811720020	24166	12028	3	0	\N
42418	1688	53279811720020	24193	12041	3	0	\N
42419	1688	53279812720020	24216	12052	4	0	\N
42423	1688	53280188908000	19187	9680	8	0	\N
42430	1688	53999813720020	24279	12078	2	0	\N
42432	1688	53999824720020	24279	12078	3	0	\N
42326	1688	50400222000000	4120	2141	2	0	0
42327	1688	50400242000000	4120	2141	3	0	0
42346	1688	51120242000000	4131	2149	1	0	0
42347	1688	51120252000000	4131	2149	2	0	0
42379	1688	51840252000000	4134	2151	1	0	0
42402	1688	52560262000000	4161	2164	1	0	0
42404	1688	52560272000000	4161	2164	2	0	0
42424	1688	53280272000000	4165	2166	2	0	0
42425	1688	53280382000000	4165	2166	3	0	0
42305	1688	49321291904000	11797	6062	1	0	18
42320	1688	50041292904000	11798	6063	1	0	18
42321	1688	50041293904000	11798	6063	2	0	18
42336	1688	50761293904000	11841	6088	2	0	18
42337	1688	50761295904000	11841	6088	3	0	18
42366	1688	51481296904000	11844	6090	2	0	18
42392	1688	52201296904000	11886	6108	1	0	18
42394	1688	52201297904000	11886	6108	2	0	18
42409	1688	52921297904000	11902	6120	2	0	18
42410	1688	52921299904000	11902	6120	3	0	18
42429	1688	53641300904000	11919	6132	2	0	18
42301	1688	49032012708000	17579	8895	3	0	36
42302	1688	49032024708000	17579	8895	4	0	36
42318	1688	49752024708000	17594	8900	5	0	36
42319	1688	49752047708000	17594	8900	6	0	36
42335	1688	50472072708000	17795	8988	8	0	36
42359	1688	51192072708000	17873	9021	3	0	36
42361	1688	51192084708000	17873	9021	4	0	36
42386	1688	51912084708000	17971	9064	2	0	36
42310	1688	49679959908000	19079	9623	1	0	38
42311	1688	49679969908000	19079	9623	2	0	38
42324	1688	50399969908000	19082	9625	2	0	38
42325	1688	50399980908000	19082	9625	3	0	38
42344	1688	51119980908000	19116	9644	6	0	38
42376	1688	51840013908000	19139	9654	4	0	38
42378	1688	51840026908000	19139	9654	5	0	38
42399	1688	52560026908000	19145	9657	3	0	38
42400	1688	52560038908000	19145	9657	4	0	38
42421	1688	53280038908000	19167	9668	7	0	38
42308	1688	49679690720020	23826	11860	3	0	57
42309	1688	49679702720020	23826	11860	4	0	57
42322	1688	50399702720020	23850	11872	4	0	57
42323	1688	50399715720020	23850	11872	5	0	57
42343	1688	51119777720020	23973	11929	9	0	57
42370	1688	51839777720020	24117	12004	1	0	57
42371	1688	51839778720020	24117	12004	2	0	57
42396	1688	52559778720020	24126	12009	4	0	57
42397	1688	52559800720020	24126	12009	5	0	57
42420	1688	53279813720020	24236	12060	5	0	57
42431	1688	53999813720020	24291	12081	4	0	57
42298	1688	49031451113019	28928	14266	4	0	77
42299	1688	49031464113019	28928	14266	5	0	77
42315	1688	49751464113019	29002	14300	4	0	77
42328	1688	50471477113019	29038	14320	4	0	77
42329	1688	50471490113019	29038	14320	5	0	77
42351	1688	51191490113019	29150	14374	5	0	77
42353	1688	51191513113019	29150	14374	6	0	77
42383	1688	51911525113019	29241	14410	4	0	77
42406	1688	52631525113019	29296	14436	4	0	77
42408	1688	52631538113019	29296	14436	5	0	77
42426	1688	53351538113019	29324	14451	3	0	77
42427	1688	53351550113019	29324	14451	4	0	77
42436	1688	54000188908000	19187	9680	10	0	\N
42437	1688	54000189908000	19187	9680	11	0	\N
42440	1688	54000612000000	4187	2180	4	0	\N
42443	1688	54361300904000	11941	6148	8	0	\N
42446	1688	54366308904000	11941	6148	9	0	\N
42453	1688	54720612000000	4187	2180	5	0	\N
42456	1688	55081301904000	11969	6160	2	0	\N
42459	1688	55081303904000	11969	6160	3	0	\N
42460	1688	55439839720020	24392	12128	5	0	\N
42461	1688	55439839720020	24393	12129	3	0	\N
42462	1688	55439839720020	24427	12148	2	0	\N
42463	1688	55439839720020	24442	12154	8	0	\N
42464	1688	55439839720020	24443	12155	4	0	\N
42465	1688	55439839720020	24473	12170	2	0	\N
42467	1688	55439850720020	24427	12148	3	0	\N
42469	1688	55439851720020	24393	12129	4	0	\N
42470	1688	55439859720020	24473	12170	3	0	\N
42471	1688	55439861720020	24443	12155	5	0	\N
42472	1688	55439862720020	24392	12128	6	0	\N
42473	1688	55439883720020	24442	12154	9	0	\N
42474	1688	55440160908000	19239	9700	3	0	\N
42476	1688	55440172908000	19239	9700	4	0	\N
42480	1688	55511587113019	29344	14461	6	0	\N
42482	1688	55511611113019	29344	14461	7	0	\N
42483	1688	55801302904000	11997	6174	1	0	\N
42484	1688	55801302904000	12006	6180	1	0	\N
42485	1688	55801302904000	12030	6191	1	0	\N
42487	1688	55801303904000	11997	6174	2	0	\N
42488	1688	55801303904000	12006	6180	2	0	\N
42489	1688	55801303904000	12030	6191	2	0	\N
42499	1688	56521313904000	12046	6201	1	0	\N
42501	1688	56521314904000	12046	6201	2	0	\N
42512	1688	57598861720020	24574	12216	2	0	\N
42513	1688	57598861720020	24595	12226	2	0	\N
42514	1688	57598861720020	24629	12239	3	0	\N
42516	1688	57598872720020	24574	12216	3	0	\N
42517	1688	57598872720020	24595	12226	3	0	\N
42518	1688	57598873720020	24629	12239	4	0	\N
42524	1688	57671646113019	29488	14541	7	0	\N
42526	1688	57671671113019	29488	14541	8	0	\N
42530	1688	58318923720020	24644	12243	4	0	\N
42531	1688	58318923720020	24694	12266	5	0	\N
42532	1688	58318923720020	24719	12277	8	0	\N
42534	1688	58318955720020	24694	12266	6	0	\N
42536	1688	58318985720020	24719	12277	9	0	\N
42537	1688	58319035720020	24644	12243	5	0	\N
42543	1688	58681316904000	12251	6309	1	0	\N
42545	1688	58681317904000	12251	6309	2	0	\N
42549	1688	59040329908000	19389	9773	5	0	\N
42550	1688	59040329908000	19404	9778	4	0	\N
42553	1688	59040342908000	19404	9778	5	0	\N
42554	1688	59040352908000	19389	9773	6	0	\N
42555	1688	59040832000000	4343	2251	1	0	\N
42557	1688	59040842000000	4343	2251	2	0	\N
42560	1688	59111682113019	30212	14632	0	0	\N
42562	1688	59401317904000	12399	6396	2	0	\N
42564	1688	59401319904000	12399	6396	3	0	\N
42566	1688	59401331904000	12498	6440	2	0	\N
42451	1688	54720392000000	4193	2183	6	0	0
42452	1688	54720542000000	4193	2183	7	0	0
42478	1688	55440542000000	4199	2186	4	0	0
42479	1688	55440672000000	4199	2186	5	0	0
42495	1688	56160672000000	4203	2187	1	0	0
42506	1688	56880682000000	4204	2188	5	0	0
42507	1688	56880822000000	4204	2188	6	0	0
42522	1688	57600822000000	4290	2224	1	0	0
42523	1688	57600832000000	4290	2224	2	0	0
42540	1688	58320832000000	4336	2248	0	0	0
42558	1688	59040932000000	4409	2285	11	0	0
42444	1688	54361300904000	11957	6155	1	0	18
42445	1688	54361301904000	11957	6155	2	0	18
42457	1688	55081301904000	11974	6162	1	0	18
42486	1688	55801302904000	12034	6194	2	0	18
42490	1688	55801313904000	12034	6194	3	0	18
42500	1688	56521313904000	12065	6210	1	0	18
42502	1688	56521314904000	12065	6210	2	0	18
42510	1688	57241314904000	12113	6239	1	0	18
42528	1688	57961315904000	12197	6280	1	0	18
42529	1688	57961316904000	12197	6280	2	0	18
42544	1688	58681316904000	12369	6379	1	0	18
42546	1688	58681317904000	12369	6379	2	0	18
42563	1688	59401317904000	12420	6404	3	0	18
42434	1688	54000063908000	19216	9694	20	0	38
42435	1688	54000137908000	19216	9694	21	0	38
42449	1688	54720137908000	19231	9697	5	0	38
42450	1688	54720160908000	19231	9697	6	0	38
42477	1688	55440172908000	19271	9715	4	0	38
42493	1688	56160172908000	19283	9722	7	0	38
42494	1688	56160206908000	19283	9722	8	0	38
42504	1688	56880206908000	19286	9723	8	0	38
42505	1688	56880268908000	19286	9723	9	0	38
42521	1688	57600316908000	19354	9758	13	0	38
42538	1688	58320316908000	19384	9770	4	0	38
42539	1688	58320329908000	19384	9770	5	0	38
42551	1688	59040329908000	19414	9785	3	0	38
42552	1688	59040341908000	19414	9785	4	0	38
42447	1688	54719826720020	24321	12096	4	0	57
42448	1688	54719839720020	24321	12096	5	0	57
42466	1688	55439839720020	24491	12180	2	0	57
42468	1688	55439850720020	24491	12180	3	0	57
42492	1688	56159861720020	24503	12187	3	0	57
42503	1688	56878861720020	24537	12200	0	0	57
42515	1688	57598861720020	24640	12242	8	0	57
42519	1688	57598923720020	24640	12242	9	0	57
42533	1688	58318923720020	24751	12291	8	0	57
42547	1688	59038958720020	24801	12316	5	0	57
42548	1688	59038981720020	24801	12316	6	0	57
42567	1688	59758981720020	24849	12337	10	0	57
42568	1688	59759027720020	24849	12337	11	0	57
42441	1688	54071550113019	29329	14453	7	0	77
42454	1688	54791575113019	29340	14459	3	0	77
42455	1688	54791587113019	29340	14459	4	0	77
42481	1688	55511587113019	29375	14480	0	0	77
42497	1688	56231587113019	29384	14486	7	0	77
42508	1688	56951612113019	29474	14536	7	0	77
42509	1688	56951646113019	29474	14536	8	0	77
42525	1688	57671646113019	29541	14565	7	0	77
42527	1688	57671671113019	29541	14565	8	0	77
42541	1688	58391671113019	29550	14569	2	0	77
42559	1688	59111682113019	29665	14632	29	0	77
42561	1688	59111936113019	29665	14632	30	0	77
42569	1688	59760341908000	19460	9809	2	0	\N
42571	1688	59760352908000	19460	9809	3	0	\N
42575	1688	59761053000000	4477	2320	2	0	\N
42576	1688	59831936113019	29677	14639	12	0	\N
42577	1688	59831936113019	29733	14657	7	0	\N
42578	1688	59831936113019	29741	14660	9	0	\N
42580	1688	59831952113019	29733	14657	8	0	\N
42582	1688	59831954113019	29741	14660	10	0	\N
42584	1688	59832065113019	29677	14639	13	0	\N
42585	1688	60121319904001	12503	6442	2	0	\N
42586	1688	60121320904000	12474	6428	1	0	\N
42588	1688	60121321904000	12474	6428	2	0	\N
42589	1688	60121331904000	12498	6440	3	0	\N
42593	1688	60480353908000	19480	9821	1	0	\N
42594	1688	60480353908000	19487	9823	4	0	\N
42596	1688	60480354908000	19480	9821	2	0	\N
42597	1688	60480375908000	19487	9823	5	0	\N
42599	1688	60480943000000	4491	2327	3	0	\N
42602	1688	60480973000000	4491	2327	4	0	\N
42603	1688	60481053000000	4477	2320	3	0	\N
42606	1688	60841353904000	12706	6553	2	0	\N
42608	1688	60841364904000	12706	6553	3	0	\N
42610	1688	61199039720020	25026	12416	2	0	\N
42612	1688	61199050720020	25026	12416	3	0	\N
42620	1688	61561364904000	12745	6571	2	0	\N
42622	1688	61561375904000	12745	6571	3	0	\N
42633	1688	62281377904000	12772	6586	2	0	\N
42636	1688	62281388904000	12772	6586	3	0	\N
42644	1688	62712063650513	29966	14758	19	0	\N
42645	1688	62712063650513	30006	14775	20	0	\N
42647	1688	62712091650513	29966	14758	20	0	\N
42649	1688	62712101650513	30006	14775	21	0	\N
42650	1688	62712111545072	30083	14811	3	0	\N
42653	1688	63359098720020	25199	12500	3	0	\N
42654	1688	63359098720020	25219	12511	3	0	\N
42656	1688	63359110720020	25199	12500	4	0	\N
42657	1688	63359110720020	25219	12511	4	0	\N
42659	1688	63360439908000	19600	9872	7	0	\N
42660	1688	63360464908000	19600	9872	8	0	\N
42666	1688	63432099545072	30037	14789	10	0	\N
42667	1688	63432099545072	30046	14792	20	0	\N
42669	1688	63432111545072	30083	14811	10	0	\N
42670	1688	63432117294711	30083	14811	12	1	\N
42672	1688	63432118545072	30037	14789	11	0	\N
42673	1688	63432137545072	30046	14792	21	0	\N
42674	1688	63721397904000	12843	6623	2	0	\N
42676	1688	63721408904000	12843	6623	3	0	\N
42678	1688	64079124720020	25288	12544	3	0	\N
42680	1688	64079136720020	25288	12544	4	0	\N
42682	1688	64080475905200	19669	9908	8	0	\N
42683	1688	64080475905200	19794	9969	3	0	\N
42684	1688	64080487905200	19794	9969	4	0	\N
42687	1688	64080537905200	19669	9908	9	0	\N
42690	1688	64152117545072	30119	14821	11	0	\N
42693	1688	64152137545072	30119	14821	12	0	\N
42700	1688	64801033000000	4838	2506	0	0	\N
42600	1688	60480943000000	4539	2347	1	0	0
42601	1688	60480953000000	4539	2347	2	0	0
42616	1688	61200953000000	4601	2381	2	0	0
42617	1688	61200973000000	4601	2381	3	0	0
42628	1688	61920973000000	4652	2404	2	0	0
42642	1688	62640993000000	4719	2440	2	0	0
42643	1688	62641013000000	4719	2440	3	0	0
42664	1688	63361013000000	4779	2469	1	0	0
42665	1688	63361023000000	4779	2469	2	0	0
42688	1688	64081023000000	4800	2484	1	0	0
42701	1688	64801033000000	4844	2510	1	0	0
42702	1688	64801043000000	4844	2510	2	0	0
42587	1688	60121320904000	12523	6454	6	0	18
42590	1688	60121353904000	12523	6454	7	0	18
42609	1688	60841364904000	12737	6568	3	0	18
42621	1688	61561364904000	12762	6580	4	0	18
42623	1688	61561377904000	12762	6580	5	0	18
42634	1688	62281377904000	12811	6606	1	0	18
42635	1688	62281387904000	12811	6606	2	0	18
42652	1688	63001397904000	12826	6617	2	0	18
42675	1688	63721397904000	12846	6624	2	0	18
42677	1688	63721408904000	12846	6624	3	0	18
42694	1688	64441408904000	12857	6630	4	0	18
42695	1688	64441430904000	12857	6630	5	0	18
42572	1688	59760353908000	19468	9814	4	0	38
42595	1688	60480353908000	19515	9833	6	0	38
42598	1688	60480377908000	19515	9833	7	0	38
42614	1688	61200377908000	19530	9838	4	0	38
42626	1688	61920390908000	19545	9845	10	0	38
42627	1688	61920427908000	19545	9845	11	0	38
42639	1688	62640427908000	19591	9867	3	0	38
42640	1688	62640439908000	19591	9867	4	0	38
42641	1688	62640469908000	19617	9881	3	0	38
42662	1688	63360475905200	19617	9881	11	0	38
42663	1688	63360495905200	19820	9984	2	0	38
42685	1688	64080495905200	19820	9984	7	0	38
42686	1688	64080517905200	19820	9984	8	0	38
42698	1688	64800517905200	19823	9986	5	0	38
42591	1688	60479027720020	24965	12389	3	0	57
42592	1688	60479039720020	24965	12389	4	0	57
42611	1688	61199039720020	25056	12433	8	0	57
42613	1688	61199074720020	25056	12433	9	0	57
42625	1688	61919086720020	25142	12474	4	0	57
42637	1688	62639086720020	25174	12489	3	0	57
42638	1688	62639098720020	25174	12489	4	0	57
42655	1688	63359098720020	25240	12518	8	0	57
42658	1688	63359124720020	25240	12518	9	0	57
42681	1688	64079237720020	25374	12581	6	0	57
42696	1688	64799237720020	25384	12584	4	0	57
42697	1688	64799250720020	25384	12584	5	0	57
42579	1688	59831936113019	29837	14703	8	0	77
42581	1688	59831952702819	29837	14703	11	1	77
42604	1688	60551979702819	29847	14710	43	0	77
42605	1688	60552012650513	29847	14710	45	1	77
42618	1688	61272012650513	29862	14719	19	0	77
42619	1688	61272049650513	29862	14719	20	0	77
42631	1688	61992063650513	29962	14757	6	0	77
42632	1688	61992085650513	30033	14787	4	0	77
42646	1688	62712085650513	30033	14787	19	0	77
42648	1688	62712099545072	30033	14787	22	0	77
42668	1688	63432099545072	30094	14815	9	0	77
42691	1688	64152117545072	30196	14854	5	0	77
42692	1688	64152124545072	30196	14854	6	0	77
42703	1688	64872124545072	30244	14870	1	0	77
42704	1688	64872224545072	30244	14870	2	0	77
42705	1688	65161430904000	12935	6667	8	0	\N
42708	1688	65161474904000	12935	6667	9	0	\N
42709	1688	65519250720020	25388	12585	3	0	\N
42710	1688	65519250720020	25400	12588	8	0	\N
42712	1688	65519262720020	25388	12585	4	0	\N
42714	1688	65519276720020	25400	12588	9	0	\N
42717	1688	65520567905200	19861	10005	3	0	\N
42718	1688	65521043000000	4855	2516	1	0	\N
42719	1688	65521043000000	4861	2517	4	0	\N
42721	1688	65521053000000	4855	2516	2	0	\N
42723	1688	65521083000000	4861	2517	5	0	\N
42724	1688	65592224545072	30284	14891	2	0	\N
42725	1688	65592235545072	30284	14891	3	0	\N
42728	1688	66239262720020	25446	12606	5	0	\N
42731	1688	66239276720020	25446	12606	6	0	\N
42732	1688	66239284720020	25533	12640	1	0	\N
42734	1688	66240567905200	19861	10005	6	0	\N
42736	1688	66240569905200	19861	10005	7	0	\N
42737	1688	66241053000000	4917	2544	2	0	\N
42738	1688	66241053000000	4923	2547	1	0	\N
42740	1688	66241063000000	4923	2547	2	0	\N
42742	1688	66241073000000	4917	2544	3	0	\N
42745	1688	66720002000000	18187	9170	6	1	\N
42746	1688	66959274720020	25521	12635	3	0	\N
42748	1688	66959284720020	25533	12640	4	0	\N
42749	1688	66959286720020	25521	12635	4	0	\N
42750	1688	66959286720020	25533	12640	5	0	\N
42754	1688	66961063000000	4946	2561	1	0	\N
42755	1688	66961063000000	4978	2581	3	0	\N
42757	1688	66961073000000	4946	2561	2	0	\N
42758	1688	66961093000000	4978	2581	4	0	\N
42760	1688	67321507904000	13029	6717	5	0	\N
42762	1688	67321530904000	13029	6717	6	0	\N
42764	1688	67679286720020	25561	12656	3	0	\N
42765	1688	67679286720020	25618	12677	3	0	\N
42767	1688	67679298720020	25561	12656	4	0	\N
42768	1688	67679298720020	25618	12677	4	0	\N
42772	1688	67681183000000	4998	2592	1	0	\N
42774	1688	67681193000000	4998	2592	2	0	\N
42780	1688	68400643905200	19893	10021	4	0	\N
42782	1688	68400656905200	19893	10021	5	0	\N
42784	1688	68401193000000	5027	2609	1	0	\N
42785	1688	68401193000000	5082	2636	1	0	\N
42786	1688	68401193000000	5102	2649	1	0	\N
42787	1688	68401193000000	5129	2659	2	0	\N
42789	1688	68401194000000	5082	2636	2	0	\N
42790	1688	68401203000000	5027	2609	2	0	\N
42792	1688	68401213000000	5129	2659	3	0	\N
42800	1688	69121213000000	5132	2660	3	0	\N
42802	1688	69121243000000	5132	2660	4	0	\N
42805	1688	69839322720020	25839	12775	3	0	\N
42806	1688	69839322720020	25853	12782	3	0	\N
42807	1688	69839322720020	25857	12783	3	0	\N
42808	1688	69839322720020	25862	12785	8	0	\N
42809	1688	69839322720020	25885	12793	2	0	\N
42810	1688	69839322720020	25919	12808	2	0	\N
42812	1688	69839333720020	25885	12793	3	0	\N
42813	1688	69839333720020	25919	12808	3	0	\N
42815	1688	69839334720020	25839	12775	4	0	\N
42816	1688	69839334720020	25853	12782	4	0	\N
42817	1688	69839334720020	25857	12783	4	0	\N
42818	1688	69839357720020	25862	12785	9	0	\N
42819	1688	69840676905200	19939	10041	3	0	\N
42820	1688	69840676905200	20043	10090	4	0	\N
42822	1688	69840688905200	19939	10041	4	0	\N
42823	1688	69840689905200	20043	10090	5	0	\N
42839	1688	71280741905200	20140	10137	3	0	\N
42840	1688	71280741905200	20166	10152	6	0	\N
42739	1688	66241053000000	4924	2548	1	0	0
42741	1688	66241063000000	4924	2548	2	0	0
42756	1688	66961063000000	4997	2591	3	0	0
42759	1688	66961183000000	4997	2591	4	0	0
42773	1688	67681183000000	5016	2602	1	0	0
42788	1688	68401193000000	5144	2666	1	0	0
42791	1688	68401203000000	5144	2666	2	0	0
42799	1688	69121203000000	5153	2672	1	0	0
42801	1688	69121213000000	5153	2672	2	0	0
42825	1688	69841213000000	5203	2706	1	0	0
42833	1688	70561223000000	5207	2708	1	0	0
42834	1688	70561233000000	5207	2708	2	0	0
42706	1688	65161430904000	12959	6682	2	0	18
42707	1688	65161441904000	12959	6682	3	0	18
42727	1688	65881474904000	12964	6685	7	0	18
42743	1688	66601474904000	13007	6704	6	0	18
42744	1688	66601507904000	13007	6704	7	0	18
42761	1688	67321507904000	13035	6720	18	0	18
42763	1688	67321588904000	13035	6720	19	0	18
42777	1688	68041600904000	13038	6722	4	0	18
42793	1688	68761600904000	13043	6724	6	0	18
42794	1688	68761723904000	13043	6724	7	0	18
42803	1688	69481723904000	13087	6742	8	0	18
42804	1688	69481758904000	13087	6742	9	0	18
42828	1688	70201771904000	13096	6750	5	0	18
42835	1688	70921771904000	13102	6752	4	0	18
42836	1688	70921784904000	13102	6752	5	0	18
42715	1688	65520540905200	19856	10002	6	0	38
42733	1688	66240555905200	19872	10010	3	0	38
42735	1688	66240567905200	19872	10010	4	0	38
42752	1688	66960567905200	19877	10012	2	0	38
42753	1688	66960578905200	19877	10012	3	0	38
42770	1688	67680578905200	19890	10020	11	0	38
42781	1688	68400643905200	19917	10031	5	0	38
42783	1688	68400675905200	19917	10031	6	0	38
42797	1688	69120675905200	19923	10034	1	0	38
42798	1688	69120676905200	19923	10034	2	0	38
42821	1688	69840676905200	20071	10103	4	0	38
42831	1688	70560689905200	20081	10108	7	0	38
42832	1688	70560741905200	20081	10108	8	0	38
42711	1688	65519250720020	25424	12598	3	0	57
42713	1688	65519262720020	25424	12598	4	0	57
42730	1688	66239274720020	25468	12615	4	0	57
42747	1688	66959274720020	25545	12647	3	0	57
42751	1688	66959286720020	25545	12647	4	0	57
42766	1688	67679286720020	25630	12684	3	0	57
42769	1688	67679298720020	25630	12684	4	0	57
42779	1688	68399310720020	25787	12753	4	0	57
42795	1688	69119310720020	25830	12773	3	0	57
42796	1688	69119322720020	25830	12773	4	0	57
42811	1688	69839322720020	25923	12809	2	0	57
42814	1688	69839333720020	25923	12809	3	0	57
42830	1688	70559365720020	25931	12815	6	0	57
42837	1688	71279365720020	25937	12820	1	0	57
42838	1688	71279375720020	25937	12820	2	0	57
42841	1688	71280741905200	20208	10178	3	0	\N
42842	1688	71280741905200	20262	10205	4	0	\N
42844	1688	71280753905200	20140	10137	4	0	\N
42845	1688	71280753905200	20208	10178	4	0	\N
42846	1688	71280754905200	20262	10205	5	0	\N
42847	1688	71280766905200	20166	10152	7	0	\N
42851	1688	71641784904000	13175	6788	10	0	\N
42854	1688	71641839904000	13175	6788	11	0	\N
42859	1688	72001243000000	5299	2753	2	0	\N
42860	1688	72001243000000	5343	2771	4	0	\N
42861	1688	72001243000000	5394	2807	0	0	\N
42862	1688	72001243000000	5403	2812	0	0	\N
42863	1688	72001243000000	5430	2825	0	0	\N
42865	1688	72001263000000	5299	2753	3	0	\N
42866	1688	72001283000000	5343	2771	5	0	\N
42871	1688	72720779905200	20340	10244	6	0	\N
42872	1688	72720779905200	20351	10250	3	0	\N
42874	1688	72720791905200	20351	10250	4	0	\N
42875	1688	72720794905200	20340	10244	7	0	\N
42877	1688	72721243000000	5483	2854	0	0	\N
42878	1688	72721243000000	5500	2860	0	0	\N
42879	1688	72721243000000	5527	2874	0	0	\N
42880	1688	72721243000000	5570	2877	1	0	\N
42881	1688	72721243000000	5610	2915	0	0	\N
42884	1688	72721343000000	5570	2877	2	0	\N
42892	1688	73801845904000	13361	6884	4	0	\N
42895	1688	73801858904000	13361	6884	5	0	\N
42896	1688	74160813905200	20531	10335	3	0	\N
42897	1688	74160813905200	20613	10367	3	0	\N
42898	1688	74160813905200	20615	10368	3	0	\N
42899	1688	74160813905200	20662	10394	1	0	\N
42901	1688	74160814905200	20662	10394	2	0	\N
42903	1688	74160825905200	20531	10335	4	0	\N
42904	1688	74160825905200	20613	10367	4	0	\N
42905	1688	74160825905200	20615	10368	4	0	\N
42907	1688	74161263000000	5770	2993	1	0	\N
42910	1688	74880824905200	20734	10423	3	0	\N
42911	1688	74880836905200	20734	10423	4	0	\N
42913	1688	74881263000000	5770	2993	2	0	\N
42915	1688	74881373000000	5836	3029	1	0	\N
42918	1688	75601273000000	5787	3003	3	0	\N
42919	1688	75601273000000	5801	3010	1	0	\N
42920	1688	75601273000000	5845	3032	1	0	\N
42921	1688	75601273000000	5855	3038	1	0	\N
42922	1688	75601273000000	5886	3052	0	0	\N
42924	1688	75601283000000	5801	3010	2	0	\N
42925	1688	75601283000000	5845	3032	2	0	\N
42926	1688	75601283000000	5855	3038	2	0	\N
42928	1688	75601373000000	5836	3029	5	0	\N
42929	1688	75601483000000	5787	3003	4	0	\N
42936	1688	77041303000000	5989	3107	1	0	\N
42938	1688	77041313000000	5989	3107	2	0	\N
42944	1688	78121929904000	13501	6951	1	0	\N
42945	1688	78121929904000	13506	6953	1	0	\N
42947	1688	78121939904000	13501	6951	2	0	\N
42948	1688	78121939904000	13506	6953	2	0	\N
42954	1688	79201383000000	6170	3195	1	0	\N
42955	1688	79201383000000	6182	3201	2	0	\N
42957	1688	79201393000000	6170	3195	2	0	\N
42959	1688	79201403000000	6182	3201	3	0	\N
42969	1688	81002019904000	13816	7093	1	0	\N
42970	1688	81361413000000	6271	3250	4	0	\N
42971	1688	81361413000000	6349	3285	1	0	\N
42972	1688	81361413000000	6363	3295	1	0	\N
42974	1688	81361423000000	6349	3285	2	0	\N
42975	1688	81361423000000	6363	3295	2	0	\N
42864	1688	72001243000000	5474	2850	0	0	0
42882	1688	72721243000000	5680	2945	1	0	0
42883	1688	72721253000000	5680	2945	2	0	0
42891	1688	73441253000000	5731	2970	0	0	0
42906	1688	74161253000000	5734	2971	0	0	0
42914	1688	74881273000000	5778	2997	3	0	0
42923	1688	75601273000000	5938	3076	1	0	0
42927	1688	75601283000000	5938	3076	2	0	0
42932	1688	76321283000000	5969	3096	2	0	0
42933	1688	76321303000000	5969	3096	3	0	0
42939	1688	77041353000000	5996	3111	6	0	0
42942	1688	77761353000000	6026	3127	1	0	0
42943	1688	77761363000000	6026	3127	2	0	0
42950	1688	78481363000000	6097	3165	2	0	0
42956	1688	79201383000000	6189	3205	1	0	0
42958	1688	79201393000000	6189	3205	2	0	0
42961	1688	79921393000000	6208	3213	1	0	0
42962	1688	79921403000000	6208	3213	2	0	0
42966	1688	80641403000000	6244	3230	1	0	0
42973	1688	81361413000000	6381	3306	1	0	0
42976	1688	81361423000000	6381	3306	2	0	0
42852	1688	71641784904000	13212	6809	7	0	18
42853	1688	71641800904000	13212	6809	8	0	18
42867	1688	72361800904000	13297	6851	6	0	18
42885	1688	73081833904000	13324	6866	3	0	18
42886	1688	73081845904000	13324	6866	4	0	18
42893	1688	73801845904000	13365	6887	3	0	18
42894	1688	73801857904000	13365	6887	4	0	18
42909	1688	74521883904000	13409	6907	9	0	18
42916	1688	75241883904000	13411	6908	4	0	18
42917	1688	75241896904000	13411	6908	5	0	18
42930	1688	75961896904000	13433	6922	4	0	18
42931	1688	75961909904000	13433	6922	5	0	18
42935	1688	76681919904000	13442	6926	2	0	18
42940	1688	77401919904000	13444	6927	1	0	18
42941	1688	77401929904000	13444	6927	2	0	18
42946	1688	78121929904000	13578	6983	4	0	18
42949	1688	78121952904000	13578	6983	5	0	18
42953	1688	78841964904000	13647	7014	4	0	18
42960	1688	79561964904000	13654	7019	0	0	18
42963	1688	80281964904000	13695	7036	6	0	18
42964	1688	80281997904000	13695	7036	7	0	18
42968	1688	81002009904000	13737	7060	4	0	18
42843	1688	71280741905200	20306	10226	7	0	38
42848	1688	71280766905200	20306	10226	8	0	38
42857	1688	72000766905200	20326	10236	4	0	38
42858	1688	72000779905200	20326	10236	5	0	38
42876	1688	72720801905200	20372	10263	5	0	38
42889	1688	73440801905200	20458	10302	3	0	38
42890	1688	73440813905200	20458	10302	4	0	38
42900	1688	74160813905200	20664	10395	2	0	38
42902	1688	74160824905200	20664	10395	3	0	38
42856	1688	71999386720020	25993	12846	3	0	57
42869	1688	72719386720020	26023	12861	2	0	57
42870	1688	72719397720020	26023	12861	3	0	57
42887	1688	73439397720020	26044	12868	2	0	57
42977	1688	81361453000000	6271	3250	5	0	\N
42978	1688	81722009904000	13758	7069	8	0	\N
42979	1688	81722009904000	13769	7074	8	0	\N
42981	1688	81722019904000	13816	7093	5	0	\N
42982	1688	81722035904000	13758	7069	9	0	\N
42983	1688	81722035904000	13769	7074	9	0	\N
42984	1688	81722049904000	13816	7093	6	0	\N
42990	1688	82801433000000	6406	3319	3	0	\N
42992	1688	82801463000000	6406	3319	4	0	\N
42996	1688	83521463000000	6427	3328	4	0	\N
42998	1688	83521503000000	6427	3328	5	0	\N
43003	1688	84241583000000	6503	3371	2	0	\N
43004	1688	84241603000000	6503	3371	3	0	\N
43008	1688	84961603000000	6542	3390	2	0	\N
43010	1688	84961623000000	6542	3390	3	0	\N
43012	1688	85322099904000	13952	7149	1	0	\N
43014	1688	85322109904000	13952	7149	2	0	\N
43016	1688	85681623000000	6584	3407	5	0	\N
43019	1688	85681673000000	6584	3407	6	0	\N
43020	1688	86042109904000	13995	7170	5	0	\N
43023	1688	86042123904000	13995	7170	6	0	\N
43032	1688	87482194904000	14188	7239	4	0	\N
43033	1688	87841683000000	6665	3445	2	0	\N
43034	1688	87841683000000	6669	3447	4	0	\N
43036	1688	87841703000000	6665	3445	3	0	\N
43038	1688	87841723000000	6669	3447	5	0	\N
43039	1688	88202172904000	14031	7187	2	0	\N
43040	1688	88202172904000	14033	7188	1	0	\N
43043	1688	88202182904000	14033	7188	2	0	\N
43044	1688	88202192904000	14031	7187	3	0	\N
43045	1688	88202194904000	14188	7239	7	0	\N
43046	1688	88202196904000	14188	7239	8	0	\N
43049	1688	88922174904000	14225	7261	10	0	\N
43051	1688	88922211904000	14225	7261	11	0	\N
43054	1688	89642174904000	14449	7375	2	0	\N
43055	1688	89642174904000	14467	7385	4	0	\N
43057	1688	89642176904000	14449	7375	3	0	\N
43058	1688	89642187904000	14467	7385	5	0	\N
43061	1688	90001743000000	6755	3497	2	0	\N
43062	1688	90001763000000	6755	3497	3	0	\N
43063	1688	90362213904000	14486	7392	4	0	\N
43064	1688	90362213904000	14516	7404	2	0	\N
43065	1688	90362213904000	14541	7418	6	0	\N
43066	1688	90362213904000	14553	7423	3	0	\N
43068	1688	90362224904000	14516	7404	3	0	\N
43070	1688	90362225904000	14553	7423	4	0	\N
43071	1688	90362226904000	14486	7392	5	0	\N
43072	1688	90362237904000	14541	7418	7	0	\N
43073	1688	90721733000000	6782	3512	2	0	\N
43074	1688	90721733000000	6815	3528	4	0	\N
43075	1688	90721733000000	6839	3539	4	0	\N
43077	1688	90721753000000	6782	3512	3	0	\N
43079	1688	90721773000000	6815	3528	5	0	\N
43080	1688	90721773000000	6839	3539	5	0	\N
43083	1688	91441753000000	6886	3558	2	0	\N
43084	1688	91441753000000	6910	3570	2	0	\N
43086	1688	91441773000000	6886	3558	3	0	\N
43087	1688	91441773000000	6910	3570	3	0	\N
43092	1688	92161773000000	6930	3577	4	0	\N
43095	1688	92161813000000	6930	3577	5	0	\N
43096	1688	92522248904000	14624	7455	3	0	\N
43097	1688	92522260904000	14624	7455	4	0	\N
43100	1688	92881793000000	6995	3611	2	0	\N
43102	1688	92881813000000	6995	3611	3	0	\N
43104	1688	93242390904000	14757	7515	1	0	\N
43106	1688	93242391904000	14757	7515	2	0	\N
43108	1688	93601833000000	7067	3648	3	0	\N
43109	1688	93601833000000	7124	3681	2	0	\N
43110	1688	93601833000000	7140	3690	0	0	\N
42991	1688	82801433000000	6410	3322	3	0	0
42993	1688	82801463000000	6410	3322	4	0	0
42997	1688	83521463000000	6471	3354	3	0	0
42999	1688	83521583000000	6471	3354	4	0	0
43000	1688	83521603000000	6505	3372	2	0	0
43009	1688	84961603000000	6576	3404	2	0	0
43011	1688	84961623000000	6576	3404	3	0	0
43017	1688	85681623000000	6644	3436	2	0	0
43018	1688	85681643000000	6644	3436	3	0	0
43024	1688	86401643000000	6647	3437	2	0	0
43028	1688	87121663000000	6652	3440	2	0	0
43029	1688	87121683000000	6652	3440	3	0	0
43035	1688	87841683000000	6708	3469	2	0	0
43037	1688	87841703000000	6708	3469	3	0	0
43048	1688	88561723000000	6726	3480	3	0	0
43052	1688	89281723000000	6753	3496	2	0	0
43053	1688	89281743000000	6753	3496	3	0	0
43060	1688	90001733000000	6767	3503	0	0	0
43076	1688	90721733000000	6863	3550	2	0	0
43085	1688	91441753000000	6928	3576	2	0	0
43088	1688	91441773000000	6928	3576	3	0	0
43093	1688	92161773000000	6986	3606	2	0	0
43094	1688	92161793000000	6986	3606	3	0	0
43101	1688	92881793000000	7029	3624	4	0	0
43111	1688	93601833000000	7162	3699	1	0	0
43112	1688	93601843000000	7162	3699	2	0	0
42980	1688	81722009904000	13844	7106	4	0	18
42985	1688	81722049904000	13844	7106	5	0	18
42989	1688	82442059904000	13861	7113	2	0	18
42994	1688	83162059904000	13863	7114	1	0	18
42995	1688	83162069904000	13863	7114	2	0	18
43001	1688	83882069904000	13891	7127	1	0	18
43002	1688	83882079904000	13891	7127	2	0	18
43007	1688	84602099904000	13897	7129	3	0	18
43013	1688	85322099904000	13957	7153	1	0	18
43015	1688	85322109904000	13957	7153	2	0	18
43021	1688	86042109904000	13999	7172	1	0	18
43022	1688	86042119904000	13999	7172	2	0	18
43027	1688	86762161904000	14006	7177	5	0	18
43030	1688	87482161904000	14009	7179	2	0	18
43031	1688	87482172904000	14009	7179	3	0	18
43041	1688	88202172904000	14222	7260	2	0	18
43050	1688	88922174904000	14375	7335	0	0	18
43056	1688	89642174904000	14480	7390	12	0	18
43059	1688	89642213904000	14480	7390	13	0	18
43067	1688	90362213904000	14577	7432	2	0	18
43069	1688	90362224904000	14577	7432	3	0	18
43082	1688	91082236904000	14588	7439	4	0	18
43089	1688	91802236904000	14616	7451	3	0	18
43090	1688	91802248904000	14616	7451	4	0	18
43091	1688	91802368904000	14678	7477	12	0	18
43098	1688	92522368904000	14678	7477	17	0	18
43105	1688	93242390904000	14759	7516	2	0	18
43107	1688	93242401904000	14759	7516	3	0	18
43113	1688	93601853000000	7124	3681	3	0	\N
43114	1688	93601953000000	7067	3648	4	0	\N
43115	1688	93962401904000	14779	7526	2	0	\N
43116	1688	93962401904000	14799	7540	2	0	\N
43118	1688	93962412904000	14779	7526	3	0	\N
43119	1688	93962412904000	14799	7540	3	0	\N
43123	1688	94682412904000	14871	7576	7	0	\N
43124	1688	94682412904000	14880	7581	9	0	\N
43126	1688	94682465904000	14871	7576	8	0	\N
43127	1688	94682466904000	14880	7581	10	0	\N
43135	1688	96122491904000	14910	7597	4	0	\N
43138	1688	96122504904000	14910	7597	5	0	\N
43139	1688	96481883000000	7289	3768	1	0	\N
43140	1688	96481883000000	7425	3837	3	0	\N
43142	1688	96481893000000	7289	3768	2	0	\N
43144	1688	96481913000000	7425	3837	4	0	\N
43145	1688	96842502904000	15026	7657	3	0	\N
43146	1688	96842502904000	15065	7672	2	0	\N
43147	1688	96842502904000	15169	7731	4	0	\N
43149	1688	96842513904000	15065	7672	3	0	\N
43150	1688	96842514904000	15026	7657	4	0	\N
43152	1688	96842515904000	15169	7731	5	0	\N
43157	1688	97921903000000	7570	3919	1	0	\N
43159	1688	97921913000000	7570	3919	2	0	\N
43165	1688	99002535904000	15247	7768	7	0	\N
43167	1688	99002535904000	15464	7774	0	0	\N
43168	1688	99002535904000	15465	7801	0	0	\N
43169	1688	99002535904000	15466	7788	0	0	\N
43171	1688	99002569904000	15247	7768	8	0	\N
43172	1688	99361973000000	7661	3966	2	0	\N
43173	1688	99361973000000	7710	3994	1	0	\N
43175	1688	99361983000000	7710	3994	2	0	\N
43177	1688	99361993000000	7661	3966	3	0	\N
43184	1688	100801993000000	7763	4025	1	0	\N
43186	1688	100802003000000	7763	4025	2	0	\N
43188	1688	101162594904000	15426	7858	2	0	\N
43190	1688	101162605904000	15426	7858	3	0	\N
43194	1688	101882616904000	15541	7911	4	0	\N
43197	1688	101882638904000	15541	7911	5	0	\N
43200	1688	102602637904000	15609	7946	3	0	\N
43201	1688	102602637904000	15614	7948	2	0	\N
43202	1688	102602637904000	15696	7984	4	0	\N
43203	1688	102602637904000	15734	8002	3	0	\N
43205	1688	102602648904000	15614	7948	3	0	\N
43206	1688	102602649904000	15609	7946	4	0	\N
43207	1688	102602649904000	15734	8002	4	0	\N
43208	1688	102602650904000	15696	7984	5	0	\N
43210	1688	102962043000000	7812	4050	1	0	\N
43212	1688	102962053000000	7812	4050	2	0	\N
43218	1688	104402063000000	7900	4093	2	0	\N
43220	1688	104402083000000	7900	4093	3	0	\N
43224	1688	105842103000000	8051	4171	3	0	\N
43227	1688	105842133000000	8051	4171	4	0	\N
43228	1688	106562113000000	8072	4184	2	0	\N
43231	1688	106562133000000	8072	4184	3	0	\N
43232	1688	107282123000000	8122	4211	2	0	\N
43233	1688	107282123000000	8130	4214	1	0	\N
43235	1688	107282133000000	8130	4214	2	0	\N
43237	1688	107282143000000	8122	4211	3	0	\N
43238	1688	108002133000000	8191	4246	1	0	\N
43239	1688	108002133000000	8196	4248	3	0	\N
43240	1688	108002133000000	8274	4285	3	0	\N
43242	1688	108002143000000	8191	4246	2	0	\N
43244	1688	108002163000000	8196	4248	4	0	\N
43245	1688	108002163000000	8274	4285	4	0	\N
43129	1688	95041853000000	7196	3721	2	0	0
43130	1688	95041873000000	7196	3721	3	0	0
43133	1688	95761873000000	7256	3753	1	0	0
43134	1688	95761883000000	7256	3753	2	0	0
43141	1688	96481883000000	7524	3896	1	0	0
43153	1688	97201893000000	7549	3909	1	0	0
43154	1688	97201903000000	7549	3909	2	0	0
43158	1688	97921903000000	7629	3946	6	0	0
43160	1688	97921963000000	7629	3946	7	0	0
43163	1688	98641963000000	7634	3951	1	0	0
43174	1688	99361973000000	7725	4001	1	0	0
43176	1688	99361983000000	7725	4001	2	0	0
43180	1688	100081983000000	7758	4022	1	0	0
43181	1688	100081993000000	7758	4022	2	0	0
43187	1688	100802023000000	7768	4028	4	0	0
43192	1688	101522023000000	7773	4031	1	0	0
43193	1688	101522033000000	7773	4031	2	0	0
43198	1688	102242033000000	7798	4043	1	0	0
43199	1688	102242043000000	7798	4043	2	0	0
43213	1688	102962053000000	7886	4086	2	0	0
43216	1688	103682053000000	7889	4089	1	0	0
43217	1688	103682063000000	7889	4089	2	0	0
43219	1688	104402063000000	7913	4101	2	0	0
43221	1688	104402083000000	7913	4101	3	0	0
43223	1688	105122103000000	7920	4105	3	0	0
43225	1688	105842103000000	8057	4175	1	0	0
43226	1688	105842113000000	8057	4175	2	0	0
43229	1688	106562113000000	8111	4206	1	0	0
43234	1688	107282123000000	8148	4224	1	0	0
43236	1688	107282133000000	8148	4224	2	0	0
43241	1688	108002133000000	8303	4298	2	0	0
43243	1688	108002144000000	8303	4298	3	0	0
43246	1688	108722144000000	8313	4302	3	0	0
43248	1688	109442165000000	8327	4310	1	0	0
43117	1688	93962401904000	14866	7575	2	0	18
43120	1688	93962412904000	14866	7575	3	0	18
43125	1688	94682412904000	14887	7585	12	0	18
43128	1688	94682478904000	14887	7585	13	0	18
43132	1688	95402491904000	14908	7596	5	0	18
43136	1688	96122491904000	15011	7647	2	0	18
43137	1688	96122502904000	15011	7647	3	0	18
43148	1688	96842502904000	15210	7749	3	0	18
43155	1688	97562514904000	15228	7757	1	0	18
43156	1688	97562524904000	15228	7757	2	0	18
43161	1688	98282524904000	15240	7762	2	0	18
43162	1688	98282535904000	15240	7762	3	0	18
43166	1688	99002535904000	15318	7805	2	0	18
43178	1688	99722546904000	15381	7835	6	0	18
43179	1688	99722570904000	15381	7835	7	0	18
43182	1688	100442570904000	15406	7848	6	0	18
43183	1688	100442594904000	15406	7848	7	0	18
43189	1688	101162594904000	15435	7862	4	0	18
43195	1688	101882616904000	15578	7930	3	0	18
43196	1688	101882637904000	15578	7930	4	0	18
43204	1688	102602637904000	15782	8028	4	0	18
43209	1688	102602650904000	15782	8028	5	0	18
43215	1688	103322674904000	15794	8036	7	0	18
43252	1688	110882205000000	8369	4336	1	0	\N
43253	1688	110882205000000	8405	4356	1	0	\N
43254	1688	110882205000000	8435	4372	0	0	\N
43255	1688	110882205000000	8457	4382	1	0	\N
43257	1688	110882215000000	8369	4336	2	0	\N
43258	1688	110882215000000	8405	4356	2	0	\N
43259	1688	110882215000000	8457	4382	2	0	\N
43261	1688	111602215000000	8509	4407	1	0	\N
43263	1688	111602225000000	8509	4407	2	0	\N
43265	1688	112322225000000	8544	4426	2	0	\N
43268	1688	112322245000000	8544	4426	3	0	\N
43269	1688	113042235000000	8592	4455	1	0	\N
43270	1688	113042235000000	8614	4465	2	0	\N
43272	1688	113042245000000	8592	4455	2	0	\N
43274	1688	113042255000000	8614	4465	3	0	\N
43277	1688	113762295000000	8729	4527	1	0	\N
43279	1688	114482295000000	8729	4527	2	0	\N
43283	1688	115922325000000	8862	4593	2	0	\N
43285	1688	115922345000000	8862	4593	3	0	\N
43290	1688	117362375000000	9357	4653	0	0	\N
43292	1688	118082435000000	9009	4670	4	0	\N
43293	1688	118082435000000	9025	4680	2	0	\N
43295	1688	118082435000000	9359	4666	0	0	\N
43296	1688	118082435000000	9360	4678	0	0	\N
43297	1688	118082435000000	9361	4689	0	0	\N
43298	1688	118082455000000	9025	4680	3	0	\N
43300	1688	118082475000000	9009	4670	5	0	\N
43301	1688	118802455000000	9063	4698	3	0	\N
43303	1688	118802455000000	9362	4701	0	0	\N
43305	1688	118802485000000	9063	4698	4	0	\N
43308	1688	120242495000000	9211	4778	4	0	\N
43310	1688	120242535000000	9211	4778	5	0	\N
43320	1688	123842775000000	9315	4832	4	0	\N
43323	1688	123842806000000	9315	4832	5	0	\N
43324	1688	124562795000000	9335	4843	7	0	\N
43327	1688	124562856000000	9335	4843	8	0	\N
43328	1688	125282815000000	9372	4863	2	0	\N
43329	1688	125282815000000	9382	4867	1	0	\N
43330	1688	125282815000000	9400	4877	4	0	\N
43332	1688	125282825000000	9382	4867	2	0	\N
43333	1688	125282826000000	9372	4863	3	0	\N
43334	1688	125282855000000	9400	4877	5	0	\N
43338	1688	126722917000000	9484	4918	7	0	\N
43341	1688	126723077000000	9484	4918	8	0	\N
43342	1688	127442937000000	9495	4926	2	0	\N
43344	1688	127442957000000	9495	4926	3	0	\N
43348	1688	128882977000000	9529	4942	5	0	\N
43350	1688	128883117000000	9529	4942	6	0	\N
43352	1688	129603207000000	9572	4964	2	0	\N
43354	1688	129603227000000	9572	4964	3	0	\N
43356	1688	130323249000000	9606	4984	4	0	\N
43358	1688	130323289000000	9606	4984	5	0	\N
43360	1688	130445092671000	10422	5390	12	0	\N
43361	1688	130445212671000	10422	5390	13	0	\N
43366	1688	132483609000000	9694	5030	3	0	\N
43367	1688	132483609000000	9703	5033	6	0	\N
43368	1688	132483609000000	9724	5040	9	0	\N
43369	1688	132483609000000	9744	5048	5	0	\N
43370	1688	132483609000000	9746	5049	3	0	\N
43373	1688	132483639000000	9694	5030	4	0	\N
43374	1688	132483639000000	9746	5049	4	0	\N
43375	1688	132483650000000	9744	5048	6	0	\N
43376	1688	132483669000000	9703	5033	7	0	\N
43377	1688	132483771000000	9724	5040	10	0	\N
43382	1688	134643699000000	9812	5087	6	0	\N
43384	1688	134643750000000	9812	5087	7	0	\N
43251	1688	110162205000000	8349	4324	4	0	0
43256	1688	110882205000000	8499	4402	1	0	0
43260	1688	110882215000000	8499	4402	2	0	0
43262	1688	111602215000000	8536	4422	1	0	0
43264	1688	111602225000000	8536	4422	2	0	0
43267	1688	112322235000000	8555	4433	2	0	0
43271	1688	113042235000000	8638	4476	1	0	0
43273	1688	113042245000000	8638	4476	2	0	0
43275	1688	113762245000000	8649	4481	4	0	0
43276	1688	113762285000000	8649	4481	5	0	0
43280	1688	114482305000000	8748	4540	3	0	0
43281	1688	115202305000000	8756	4544	2	0	0
43282	1688	115202325000000	8756	4544	3	0	0
43284	1688	115922325000000	8901	4611	3	0	0
43287	1688	116642355000000	8911	4617	2	0	0
43288	1688	116642375000000	8911	4617	3	0	0
43289	1688	117362375000000	8972	4654	6	0	0
43291	1688	117362435000000	8972	4654	7	0	0
43294	1688	118082435000000	9058	4695	2	0	0
43302	1688	118802455000000	9159	4746	2	0	0
43304	1688	118802475000000	9159	4746	3	0	0
43306	1688	119522475000000	9201	4769	2	0	0
43307	1688	119522495000000	9201	4769	3	0	0
43309	1688	120242495000000	9215	4779	6	0	0
43312	1688	120962555000000	9239	4791	2	0	0
43313	1688	120962575000000	9239	4791	3	0	0
43314	1688	121682575000000	9264	4804	15	0	0
43315	1688	121682725000000	9264	4804	16	0	0
43317	1688	122402755000000	9271	4807	4	0	0
43318	1688	123122755000000	9278	4811	2	0	0
43319	1688	123122775000000	9278	4811	3	0	0
43321	1688	123842775000000	9319	4833	2	0	0
43322	1688	123842795000000	9319	4833	3	0	0
43326	1688	124562815000000	9339	4846	3	0	0
43331	1688	125282815000000	9452	4902	5	0	0
43335	1688	125282856000000	9452	4902	6	0	0
43336	1688	126002856000000	9469	4910	7	0	0
43337	1688	126002917000000	9469	4910	8	0	0
43340	1688	126722937000000	9488	4921	3	0	0
43343	1688	127442937000000	9500	4928	2	0	0
43345	1688	127442957000000	9500	4928	3	0	0
43346	1688	128162957000000	9527	4940	2	0	0
43349	1688	128882977000000	9539	4946	5	0	0
43351	1688	128883207000000	9539	4946	6	0	0
43353	1688	129603207000000	9604	4983	6	0	0
43355	1688	129603249000000	9604	4983	7	0	0
43357	1688	130323249000000	9626	4995	31	0	0
43362	1688	131043559000000	9649	5006	3	0	0
43363	1688	131043589000000	9649	5006	4	0	0
43364	1688	131763589000000	9687	5025	2	0	0
43365	1688	131763609000000	9687	5025	3	0	0
43371	1688	132483609000000	9770	5062	2	0	0
43378	1688	133203629000000	9783	5069	4	0	0
43379	1688	133203669000000	9783	5069	5	0	0
43380	1688	133923669000000	9796	5080	3	0	0
43381	1688	133923699000000	9796	5080	4	0	0
43398	1688	139684058000000	10056	5216	3	0	\N
43400	1688	139684088000000	10056	5216	4	0	\N
43406	1688	141844389000000	10189	5277	5	0	\N
43408	1688	141844439000000	10189	5277	6	0	\N
43412	1688	143284589000000	10266	5310	8	0	\N
43415	1688	143285029000000	10266	5310	9	0	\N
43420	1688	145444669000000	10293	5326	5	0	\N
43423	1688	145444729000000	10293	5326	6	0	\N
43424	1688	146164689000000	10309	5332	5	0	\N
43426	1688	146164739000000	10309	5332	6	0	\N
43430	1688	147604790000000	10335	5349	3	0	\N
43431	1688	147604790000000	10344	5354	6	0	\N
43432	1688	147604790000000	10394	5373	2	0	\N
43434	1688	147604810000000	10394	5373	3	0	\N
43436	1688	147604820000000	10335	5349	4	0	\N
43437	1688	147604850000000	10344	5354	7	0	\N
43438	1689	1402590000	14859	7572	3	1	\N
43439	1689	719000000000	40	25	1	0	\N
43440	1689	719000000000	65	36	1	0	\N
43441	1689	719000000000	146	87	1	0	\N
43443	1689	719010000000	40	25	2	0	\N
43444	1689	719010000000	65	36	2	0	\N
43445	1689	719010000000	146	87	2	0	\N
43447	1689	720023287617	20157	10147	6	0	\N
43448	1689	720023287617	20987	10556	2	0	\N
43449	1689	720028287614	9952	5168	1	0	\N
43451	1689	720034287617	20987	10556	3	0	\N
43452	1689	720038287614	9952	5168	2	0	\N
43453	1689	720047287617	20157	10147	7	0	\N
43457	1689	1440050287614	10968	5651	2	0	\N
43458	1689	1440050287614	10969	5651	2	0	\N
43461	1689	1440070287614	10968	5651	3	0	\N
43462	1689	1440070287614	10969	5651	3	0	\N
43463	1689	2159060000000	400	227	3	0	\N
43464	1689	2159060000000	554	313	1	0	\N
43466	1689	2159070000000	554	313	2	0	\N
43468	1689	2159090000000	400	227	4	0	\N
43469	1689	2160061287613	11882	6106	4	0	\N
43470	1689	2160061287614	11883	6106	4	0	\N
43473	1689	2160065287613	11882	6106	5	0	\N
43474	1689	2160065287614	11883	6106	5	0	\N
43475	1689	2879070000000	941	523	1	0	\N
43477	1689	2879080000000	941	523	2	0	\N
43479	1689	2880062287614	11911	6128	1	0	\N
43481	1689	2880063287614	11911	6128	2	0	\N
43483	1689	3599080000000	963	536	2	0	\N
43484	1689	3599080000000	1496	818	4	0	\N
43485	1689	3599080000000	1529	837	1	0	\N
43486	1689	3599080000000	1889	1005	1	0	\N
43488	1689	3599090000000	1529	837	2	0	\N
43489	1689	3599090000000	1889	1005	2	0	\N
43491	1689	3599100000000	963	536	3	0	\N
43492	1689	3599120000000	1496	818	5	0	\N
43493	1689	3600064287614	11943	6149	1	0	\N
43495	1689	3600064287614	12502	6441	2	0	\N
43497	1689	3600065287614	11943	6149	2	0	\N
43498	1689	3600075287614	12502	6441	3	0	\N
43499	1689	4319090000000	2135	1127	1	0	\N
43501	1689	4319100000000	2135	1127	2	0	\N
43503	1689	4320064287625	12548	6466	0	0	\N
43506	1689	5039100000000	2328	1219	2	0	\N
43507	1689	5039100000000	2425	1270	1	0	\N
43509	1689	5039110000000	2425	1270	2	0	\N
43510	1689	5039120000000	2328	1219	3	0	\N
43514	1689	5759086287601	13114	6759	3	0	\N
43515	1689	5759098287601	13114	6759	4	0	\N
43516	1689	5759120000000	2796	1463	1	0	\N
43518	1689	5759130000000	2796	1463	2	0	\N
43520	1689	5760086287625	13026	6715	4	0	\N
43455	1689	1439010000000	358	204	4	0	0
43456	1689	1439060000000	358	204	5	0	0
43465	1689	2159060000000	573	324	1	0	0
43467	1689	2159070000000	573	324	2	0	0
43476	1689	2879070000000	953	532	1	0	0
43487	1689	3599080000000	1895	1009	1	0	0
43490	1689	3599090000000	1895	1009	2	0	0
43500	1689	4319090000000	2144	1131	1	0	0
43502	1689	4319100000000	2144	1131	2	0	0
43508	1689	5039100000000	2758	1442	2	0	0
43517	1689	5759120000000	2876	1504	1	0	0
43519	1689	5759130000000	2876	1504	2	0	0
43385	1688	134643848000000	9826	5092	27	0	0
43386	1688	135363848000000	9858	5113	7	0	0
43388	1688	136083918000000	9892	5128	1	0	0
43389	1688	136083928000000	9892	5128	2	0	0
43390	1688	136803928000000	9896	5130	2	0	0
43391	1688	136803948000000	9896	5130	3	0	0
43392	1688	137523948000000	9898	5131	2	0	0
43394	1688	138243968000000	9933	5156	4	0	0
43395	1688	138244008000000	9933	5156	5	0	0
43396	1688	138964008000000	10015	5193	5	0	0
43397	1688	138964058000000	10015	5193	6	0	0
43450	1689	720028287614	10026	5200	4	0	7
43399	1688	139684058000000	10116	5248	10	0	0
43401	1688	139684329000000	10116	5248	11	0	0
43402	1688	140404329000000	10127	5253	4	0	0
43403	1688	140404369000000	10127	5253	5	0	0
43405	1688	141124389000000	10174	5272	3	0	0
43407	1688	141844389000000	10192	5278	7	0	0
43409	1688	141844549000000	10192	5278	8	0	0
43410	1688	142564549000000	10193	5279	4	0	0
43411	1688	142564589000000	10193	5279	5	0	0
43414	1688	143284609000000	10269	5312	3	0	0
43416	1688	144004609000000	10271	5314	2	0	0
43417	1688	144004629000000	10271	5314	3	0	0
43418	1688	144724629000000	10290	5324	3	0	0
43419	1688	144724669000000	10290	5324	4	0	0
43422	1688	145444689000000	10297	5327	3	0	0
43425	1688	146164689000000	10315	5336	6	0	0
43427	1688	146164749000000	10315	5336	7	0	0
43428	1688	146884749000000	10330	5345	5	0	0
43433	1688	147604790000000	10399	5376	2	0	0
43435	1688	147604810000000	10399	5376	3	0	0
43459	1689	1440050287614	11420	5866	2	0	7
43460	1689	1440061287614	11420	5866	3	0	7
43471	1689	2160061287614	11892	6112	1	0	7
43480	1689	2880062287614	11940	6147	2	0	7
43482	1689	2880064287614	11940	6147	3	0	7
43494	1689	3600064287614	12501	6441	2	0	7
43496	1689	3600064287625	12501	6441	3	0	7
43504	1689	4320064287625	12584	6486	2	0	7
43512	1689	5040075287625	12695	6546	2	0	7
43513	1689	5040086287625	12695	6546	3	0	7
43521	1689	5760086287625	13115	6759	3	0	\N
43523	1689	5760098287625	13115	6759	4	0	\N
43524	1689	5760108287625	13026	6715	5	0	\N
43528	1689	6480118287625	13573	6980	3	0	\N
43529	1689	6480118287625	13923	7138	4	0	\N
43531	1689	6480130287625	13573	6980	4	0	\N
43532	1689	6480131287625	13923	7138	5	0	\N
43538	1689	7919170000000	4012	2082	2	0	\N
43539	1689	7919170000000	4201	2187	1	0	\N
43540	1689	7919170000000	4223	2195	2	0	\N
43542	1689	7919180000000	4201	2187	2	0	\N
43544	1689	7919190000000	4012	2082	3	0	\N
43545	1689	7919190000000	4223	2195	3	0	\N
43548	1689	8639181000000	4531	2344	1	0	\N
43549	1689	8639181000000	5292	2749	1	0	\N
43551	1689	8639191000000	4531	2344	2	0	\N
43552	1689	8639191000000	5292	2749	2	0	\N
43555	1689	9359181000000	5490	2856	0	0	\N
43558	1689	9360180287626	14859	7572	2	0	\N
43559	1689	9360181287625	14860	7572	2	0	\N
43560	1689	9360181287625	14863	7572	5	0	\N
43561	1689	9360181287625	15058	7670	2	0	\N
43563	1689	9360192287625	14860	7572	3	0	\N
43564	1689	9360192287625	15058	7670	3	0	\N
43566	1689	9360195287625	14863	7572	6	0	\N
43569	1689	10080192287625	15847	8061	10	0	\N
43572	1689	10080229287625	15847	8061	11	0	\N
43573	1689	10799211000000	6417	3325	2	0	\N
43575	1689	10799231000000	6417	3325	3	0	\N
43577	1689	10800204287625	16135	8203	7	0	\N
43580	1689	10800229287625	16135	8203	8	0	\N
43591	1689	12960267287625	16725	8495	5	0	\N
43594	1689	12960290287625	16725	8495	6	0	\N
43601	1689	14400499287625	17704	8948	2	0	\N
43602	1689	14400499287625	17705	8948	3	0	\N
43605	1689	14400519287625	17704	8948	3	0	\N
43606	1689	14400520287625	17705	8948	4	0	\N
43607	1689	15119331000000	7752	4019	1	0	\N
43609	1689	15119341000000	7752	4019	2	0	\N
43611	1689	15120511287625	18828	9488	1	0	\N
43612	1689	15120511287625	18862	9511	2	0	\N
43614	1689	15120521287625	18828	9488	2	0	\N
43615	1689	15120522287625	18862	9511	3	0	\N
43617	1689	15839341000000	7965	4128	0	0	\N
43618	1689	15839341000000	8160	4230	1	0	\N
43619	1689	15839341000000	8219	4260	2	0	\N
43622	1689	15839351000000	8160	4230	2	0	\N
43623	1689	15839451000000	8219	4260	3	0	\N
43624	1689	15840523287625	19428	9792	3	0	\N
43625	1689	15840523287625	19604	9875	3	0	\N
43626	1689	15840523287625	19843	9997	3	0	\N
43627	1689	15840523287625	19845	9997	3	0	\N
43628	1689	15840523287625	20011	10075	3	0	\N
43629	1689	15840523287625	20025	9998	0	0	\N
43630	1689	15840523287625	20027	10082	5	0	\N
43631	1689	15840523287625	20028	10013	0	0	\N
43632	1689	15840523287625	20029	10028	0	0	\N
43633	1689	15840523287625	20030	10042	0	0	\N
43634	1689	15840535287625	19428	9792	4	0	\N
43635	1689	15840535287625	19604	9875	4	0	\N
43636	1689	15840535287625	19843	9997	4	0	\N
43637	1689	15840535287625	19845	9997	4	0	\N
43638	1689	15840535287625	20011	10075	4	0	\N
43639	1689	15840537287625	20027	10082	6	0	\N
43640	1689	16559342000000	8478	4392	2	0	\N
43642	1689	16559362000000	8478	4392	3	0	\N
43647	1689	17999432000000	8875	4598	0	0	\N
43649	1689	17999472000000	9281	4813	2	0	\N
43650	1689	17999472000000	9282	4813	2	0	\N
43652	1689	18719452000000	8917	4620	5	0	\N
43653	1689	18719452000000	9146	4739	4	0	\N
43654	1689	18719471999999	9281	4813	3	0	\N
43655	1689	18719472000000	9282	4813	3	0	\N
43534	1689	7199140000000	3241	1683	3	0	0
43535	1689	7199170000000	3241	1683	4	0	0
43541	1689	7919170000000	4451	2305	2	0	0
43543	1689	7919181000000	4451	2305	3	0	0
43550	1689	8639181000000	5452	2838	0	0	0
43557	1689	9359201000000	5775	2995	3	0	0
43567	1689	10079201000000	6385	3309	1	0	0
43568	1689	10079211000000	6385	3309	2	0	0
43574	1689	10799211000000	6434	3330	2	0	0
43576	1689	10799231000000	6434	3330	3	0	0
43582	1689	11519251000000	6526	3382	3	0	0
43585	1689	12239251000000	7110	3671	4	0	0
43586	1689	12239291000000	7110	3671	5	0	0
43589	1689	12959291000000	7211	3728	1	0	0
43595	1689	13679301000000	7386	3814	2	0	0
43596	1689	13679321000000	7386	3814	3	0	0
43599	1689	14399321000000	7716	3997	1	0	0
43600	1689	14399331000000	7716	3997	2	0	0
43608	1689	15119331000000	7937	4114	1	0	0
43620	1689	15839341000000	8269	4282	1	0	0
43621	1689	15839342000000	8269	4282	2	0	0
43641	1689	16559342000000	8773	4550	6	0	0
43643	1689	16559402000000	8773	4550	7	0	0
43644	1689	17279402000000	8817	4571	3	0	0
43646	1689	17999432000000	8874	4598	2	0	0
43648	1689	17999452000000	8874	4598	3	0	0
43651	1689	17999472000000	9283	4813	2	0	0
43656	1689	18719472000000	9283	4813	3	0	0
43525	1689	5760118287625	13331	6871	6	0	7
43530	1689	6480118287625	14170	7234	10	0	7
43533	1689	6480146287625	14170	7234	11	0	7
43536	1689	7200146287625	14245	7272	3	0	7
43537	1689	7200158287625	14245	7272	4	0	7
43547	1689	7920170287625	14471	7386	4	0	7
43553	1689	8640170287625	14851	7569	2	0	7
43554	1689	8640181287625	14851	7569	3	0	7
43562	1689	9360181287625	15642	7960	2	0	7
43565	1689	9360192287625	15642	7960	3	0	7
43571	1689	10080204287625	15985	8126	4	0	7
43578	1689	10800204287625	16372	8327	4	0	7
43579	1689	10800217287625	16372	8327	5	0	7
43583	1689	11520217287625	16436	8358	4	0	7
43587	1689	12240230287625	16577	8426	10	0	7
43588	1689	12240267287625	16577	8426	11	0	7
43592	1689	12960267287625	17140	8686	3	0	7
43593	1689	12960288287625	17140	8686	4	0	7
43597	1689	13680288287625	17424	8826	4	0	7
43603	1689	14400499287625	17856	9012	3	0	7
43604	1689	14400511287625	17856	9012	4	0	7
43613	1689	15120511287625	19093	9631	3	0	7
43616	1689	15120523287625	19093	9631	4	0	7
43657	1689	18719492000000	9146	4739	5	0	\N
43658	1689	18719493000000	8917	4620	6	0	\N
43659	1689	19439472000000	9476	4914	2	0	\N
43660	1689	19439472000000	9705	5034	4	0	\N
43661	1689	19439492000000	9476	4914	3	0	\N
43662	1689	19439512000000	9705	5034	5	0	\N
43663	1690	290999959	26894	13247	32	0	\N
43664	1690	800000000	9045	4429	4	1	\N
43665	1690	719000000000	47	27	1	0	\N
43667	1690	719010000000	47	27	2	0	\N
43669	1690	1439010000000	151	89	2	0	\N
43670	1690	1439010000000	169	101	4	0	\N
43671	1690	1439010000000	251	148	0	0	\N
43673	1690	1439030000000	151	89	3	0	\N
43675	1690	1439140000000	169	101	5	0	\N
43678	1690	2879050000000	608	343	1	0	\N
43680	1690	2879060000000	608	343	2	0	\N
43682	1690	3599060000000	771	428	4	0	\N
43685	1690	3599190000000	771	428	5	0	\N
43688	1690	5039120000000	807	446	3	0	\N
43689	1690	5039120000000	816	451	1	0	\N
43690	1690	5039120000000	831	458	1	0	\N
43692	1690	5039130000000	816	451	2	0	\N
43693	1690	5039130000000	831	458	2	0	\N
43695	1690	5039150000000	807	446	4	0	\N
43700	1690	7199310000000	1265	688	19	0	\N
43701	1690	7199310000000	1786	956	5	0	\N
43702	1690	7199310000000	1850	987	1	0	\N
43703	1690	7199310000000	1926	1025	3	0	\N
43704	1690	7199310000000	1941	1030	1	0	\N
43706	1690	7199320000000	1850	987	2	0	\N
43707	1690	7199320000000	1941	1030	2	0	\N
43709	1690	7199340000000	1926	1025	4	0	\N
43710	1690	7199360000000	1786	956	6	0	\N
43711	1690	7199500000000	1265	688	20	0	\N
43712	1690	7199850000000	1334	689	35	0	\N
43713	1690	7919330000000	2092	1105	1	0	\N
43714	1690	7919330000000	2113	1113	1	0	\N
43715	1690	7919330000000	2121	1118	1	0	\N
43717	1690	7919340000000	2092	1105	2	0	\N
43718	1690	7919340000000	2113	1113	2	0	\N
43719	1690	7919340000000	2121	1118	2	0	\N
43721	1690	7919850000000	1334	689	55	0	\N
43722	1690	7920013000000	1334	689	56	0	\N
43725	1690	8640013000000	1339	690	3	0	\N
43726	1690	8640043000000	1339	690	4	0	\N
43729	1690	9360043000000	1344	691	3	0	\N
43730	1690	9360073000000	1344	691	4	0	\N
43731	1690	10079370000000	2248	1183	0	0	\N
43733	1690	10080073000000	1380	692	26	0	\N
43734	1690	10080414000000	1380	692	27	0	\N
43737	1690	10800414000000	1444	693	55	0	\N
43738	1690	10800955000000	1444	693	56	0	\N
43739	1690	10801080000000	1469	694	11	0	\N
43740	1690	10954478942000	13370	6791	9	1	\N
43743	1690	11521080000000	1469	694	25	0	\N
43744	1690	11521201000000	1469	694	26	0	\N
43745	1690	12239410000000	2329	1219	2	0	\N
43748	1690	12239430000000	2329	1219	3	0	\N
43749	1690	12241201000000	1495	695	25	0	\N
43750	1690	12241451000000	1495	695	26	0	\N
43751	1690	12959420000000	2370	1238	2	0	\N
43754	1690	12959440000000	2370	1238	3	0	\N
43755	1690	12961451000000	1547	696	40	0	\N
43756	1690	12961851000000	1547	696	41	0	\N
43757	1690	12962281000000	1624	697	43	0	\N
43760	1690	13682281000000	1624	697	46	0	\N
43761	1690	13682301000000	1624	697	47	0	\N
43762	1690	14399440000000	2588	1363	1	0	\N
43764	1690	14399450000000	2588	1363	2	0	\N
43766	1690	14402301000000	1647	698	12	0	\N
43767	1690	14402421000000	1647	698	13	0	\N
43770	1690	15122421000000	1654	699	5	0	\N
43771	1690	15122471000000	1654	699	6	0	\N
43772	1690	15839470000000	2759	1442	2	0	\N
43773	1690	15839470000000	2778	1453	2	0	\N
43774	1690	15839470000000	2872	1502	2	0	\N
43775	1690	15839470000000	2897	1513	1	0	\N
43777	1690	15839480000000	2897	1513	2	0	\N
43778	1690	15839490000000	2759	1442	3	0	\N
43779	1690	15839490000000	2778	1453	3	0	\N
43780	1690	15839490000000	2872	1502	3	0	\N
43782	1690	15842471000000	1691	700	8	0	\N
43783	1690	15842551000000	1691	700	9	0	\N
43786	1690	17279500000000	3075	1598	1	0	\N
43788	1690	17279510000000	3075	1598	2	0	\N
43792	1690	18719530000000	3161	1642	1	0	\N
43672	1690	1439010000000	322	185	2	0	0
43674	1690	1439030000000	322	185	3	0	0
43676	1690	2159030000000	446	250	2	0	0
43677	1690	2159050000000	446	250	3	0	0
43679	1690	2879050000000	682	381	1	0	0
43683	1690	3599060000000	782	433	3	0	0
43684	1690	3599090000000	782	433	4	0	0
43686	1690	4319090000000	786	435	3	0	0
43687	1690	4319120000000	786	435	4	0	0
43691	1690	5039120000000	920	511	1	0	0
43696	1690	5759130000000	1060	587	16	0	0
43697	1690	5759290000000	1060	587	17	0	0
43698	1690	6479290000000	1179	650	2	0	0
43699	1690	6479310000000	1179	650	3	0	0
43708	1690	7199330000000	1942	1031	3	0	0
43716	1690	7919330000000	2143	1130	1	0	0
43720	1690	7919340000000	2143	1130	2	0	0
43723	1690	8639340000000	2146	1133	2	0	0
43724	1690	8639360000000	2146	1133	3	0	0
43728	1690	9359370000000	2190	1154	2	0	0
43732	1690	10079370000000	2290	1201	0	0	0
43735	1690	10799370000000	2294	1203	3	0	0
43736	1690	10799400000000	2294	1203	4	0	0
43741	1690	11519400000000	2320	1214	1	0	0
43746	1690	12239410000000	2366	1236	1	0	0
43747	1690	12239420000000	2366	1236	2	0	0
43752	1690	12959420000000	2499	1309	1	0	0
43753	1690	12959430000000	2499	1309	2	0	0
43759	1690	13679440000000	2575	1358	2	0	0
43763	1690	14399440000000	2693	1414	2	0	0
43765	1690	14399460000000	2693	1414	3	0	0
43768	1690	15119460000000	2694	1415	1	0	0
43769	1690	15119470000000	2694	1415	2	0	0
43781	1690	15839490000000	2932	1525	3	0	0
43784	1690	16559490000000	2953	1536	1	0	0
43785	1690	16559500000000	2953	1536	2	0	0
43787	1690	17279500000000	3090	1604	1	0	0
43789	1690	17279510000000	3090	1604	2	0	0
43791	1690	17999530000000	3149	1637	3	0	0
43793	1690	18719530000000	3173	1648	1	0	\N
43795	1690	18719540000000	3161	1642	2	0	\N
43796	1690	18719540000000	3173	1648	2	0	\N
43798	1690	19439540000000	3516	1824	0	0	\N
43802	1690	20879541000000	3698	1920	1	0	\N
43803	1690	20879541000000	3718	1930	1	0	\N
43805	1690	20879551000000	3698	1920	2	0	\N
43806	1690	20879551000000	3718	1930	2	0	\N
43819	1690	25199671000000	4373	2109	0	0	\N
43823	1690	26639701000000	4144	2155	1	0	\N
43824	1690	26639701000000	4186	2179	3	0	\N
43825	1690	26639701000000	4216	2192	1	0	\N
43827	1690	26639711000000	4144	2155	2	0	\N
43828	1690	26639711000000	4216	2192	2	0	\N
43830	1690	26639722000000	4186	2179	4	0	\N
43835	1690	28799951000000	4503	2331	2	0	\N
43838	1690	28799971000000	4503	2331	3	0	\N
43843	1690	30960001000000	4863	2517	4	0	\N
43846	1690	30960041000000	4863	2517	5	0	\N
43851	1690	33120051000000	5389	2804	0	0	\N
43859	1690	38160051000000	5687	2948	0	0	\N
43862	1690	38880061000000	5789	3003	3	0	\N
43863	1690	38880061000000	5863	3040	2	0	\N
43865	1690	38880081000000	5863	3040	3	0	\N
43867	1690	38880271000000	5789	3003	4	0	\N
43868	1690	39600191000000	6005	3116	1	0	\N
43869	1690	39600191000000	6053	3144	1	0	\N
43870	1690	39600191000000	6057	3146	1	0	\N
43871	1690	39600191000000	6225	3221	1	0	\N
43872	1690	39600191000000	6248	3232	1	0	\N
43874	1690	39600201000000	6005	3116	2	0	\N
43875	1690	39600201000000	6053	3144	2	0	\N
43876	1690	39600201000000	6057	3146	2	0	\N
43877	1690	39600201000000	6225	3221	2	0	\N
43878	1690	39600201000000	6248	3232	2	0	\N
43882	1690	41040221000000	6515	3377	4	0	\N
43883	1690	41040221000000	6530	3384	2	0	\N
43884	1690	41040221000000	6620	3424	2	0	\N
43885	1690	41040221000000	6637	3429	2	0	\N
43886	1690	41040221000000	6650	3439	2	0	\N
43888	1690	41040241000000	6530	3384	3	0	\N
43889	1690	41040241000000	6620	3424	3	0	\N
43890	1690	41040241000000	6637	3429	3	0	\N
43891	1690	41040241000000	6650	3439	3	0	\N
43893	1690	41040261000000	6515	3377	5	0	\N
43896	1690	42480261000000	6806	3523	2	0	\N
43897	1690	42480261000000	6810	3524	4	0	\N
43899	1690	42480281000000	6806	3523	3	0	\N
43901	1690	42480301000000	6810	3524	5	0	\N
43902	1690	43200281000000	6855	3545	4	0	\N
43905	1690	43200321000000	6855	3545	5	0	\N
43906	1690	43920301000000	6988	3607	2	0	\N
43908	1690	43920321000000	6988	3607	3	0	\N
43916	1690	46800631000000	7169	3702	1	0	\N
43917	1690	46800631000000	7178	3707	1	0	\N
43918	1690	46800631000000	7333	3789	1	0	\N
43920	1690	46800641000000	7169	3702	2	0	\N
43921	1690	46800641000000	7178	3707	2	0	\N
43922	1690	46800641000000	7333	3789	2	0	\N
43928	1690	48960661000000	7573	3919	1	0	\N
43799	1690	19439540000000	3519	1827	1	0	0
43800	1690	19439541000000	3519	1827	2	0	0
43801	1690	20159541000000	3552	1843	0	0	0
43804	1690	20879541000000	3832	1989	4	0	0
43807	1690	20879581000000	3832	1989	5	0	0
43809	1690	21599591000000	3937	2043	2	0	0
43810	1690	22319591000000	3939	2045	2	0	0
43811	1690	22319611000000	3939	2045	3	0	0
43812	1690	23039611000000	3949	2052	3	0	0
43813	1690	23039641000000	3949	2052	4	0	0
43815	1690	23759661000000	4013	2082	3	0	0
43816	1690	24479661000000	4039	2097	1	0	0
43817	1690	24479671000000	4039	2097	2	0	0
43818	1690	25199671000000	4096	2129	1	0	0
43821	1690	25919681000000	4129	2147	2	0	0
43822	1690	25919701000000	4129	2147	3	0	0
43826	1690	26639701000000	4283	2221	1	0	0
43829	1690	26639711000000	4283	2221	2	0	0
43831	1690	27359711000000	4393	2278	12	0	0
43833	1690	28079831000000	4420	2291	3	0	0
43834	1690	28079951000000	4420	2291	4	0	0
43836	1690	28799951000000	4527	2342	1	0	0
43837	1690	28799961000000	4527	2342	2	0	0
43839	1690	29519961000000	4568	2363	1	0	0
43841	1690	30239971000000	4651	2403	3	0	0
43842	1690	30240001000000	4651	2403	4	0	0
43844	1690	30960001000000	4953	2566	1	0	0
43845	1690	30960011000000	4953	2566	2	0	0
43848	1690	31680031000000	5046	2616	3	0	0
43849	1690	32400031000000	5369	2790	2	0	0
43850	1690	32400051000000	5369	2790	3	0	0
43852	1690	33120051000000	5464	2844	0	0	0
43853	1690	33840051000000	5493	2857	0	0	0
43855	1690	35280051000000	5556	2889	0	0	0
43856	1690	36000051000000	5572	2896	0	0	0
43857	1690	36720051000000	5618	2918	0	0	0
43858	1690	37440051000000	5620	2919	0	0	0
43860	1690	38160051000000	5761	2987	1	0	0
43864	1690	38880061000000	6000	3113	4	0	0
43866	1690	38880191000000	6000	3113	5	0	0
43873	1690	39600191000000	6343	3283	1	0	0
43879	1690	39600201000000	6343	3283	2	0	0
43881	1690	40320221000000	6394	3314	3	0	0
43887	1690	41040221000000	6729	3482	2	0	0
43892	1690	41040241000000	6729	3482	3	0	0
43894	1690	41760241000000	6795	3518	2	0	0
43895	1690	41760261000000	6795	3518	3	0	0
43900	1690	42480281000000	6812	3526	3	0	0
43903	1690	43200281000000	6968	3595	2	0	0
43904	1690	43200301000000	6968	3595	3	0	0
43907	1690	43920301000000	7065	3647	4	0	0
43909	1690	43920341000000	7065	3647	5	0	0
43911	1690	44640581000000	7071	3649	7	0	0
43912	1690	45360581000000	7072	3650	1	0	0
43913	1690	45360591000000	7072	3650	2	0	0
43914	1690	46080591000000	7080	3653	4	0	0
43919	1690	46800631000000	7493	3875	1	0	0
43923	1690	46800641000000	7493	3875	2	0	0
43924	1690	47520641000000	7522	3894	1	0	0
43925	1690	47520651000000	7522	3894	2	0	0
43926	1690	48240651000000	7546	3906	1	0	0
43930	1690	48960671000000	7573	3919	2	0	\N
43932	1690	49680671000000	7742	4012	1	0	\N
43934	1690	49680681000000	7742	4012	2	0	\N
43938	1690	51120711000000	7794	4041	1	0	\N
43939	1690	51120711000000	7872	4079	2	0	\N
43941	1690	51120721000000	7794	4041	2	0	\N
43943	1690	51120731000000	7872	4079	3	0	\N
43948	1690	53280781000000	8060	4176	2	0	\N
43949	1690	53280781000000	8173	4234	1	0	\N
43951	1690	53280791000000	8173	4234	2	0	\N
43953	1690	53280801000000	8060	4176	3	0	\N
43958	1690	54720841000000	8246	4270	2	0	\N
43959	1690	55440821000000	8242	4269	1	0	\N
43961	1690	55440831000000	8242	4269	2	0	\N
43962	1690	55440841000000	8246	4270	4	0	\N
43965	1690	56880831000000	8483	4394	2	0	\N
43968	1690	56881041000000	8483	4394	3	0	\N
43969	1690	57600841000000	8551	4420	0	0	\N
43970	1690	57600841000000	9115	4511	0	0	\N
43971	1690	57600841000000	9120	4530	0	0	\N
43974	1690	57600953000000	8688	4421	13	0	\N
43977	1690	58320952999992	8688	4421	14	0	\N
43979	1690	59040952999984	8725	4422	0	0	\N
43981	1690	59760852999984	8789	4423	0	0	\N
43984	1690	60480752999984	8790	4424	0	0	\N
43985	1690	60481021000000	9244	4794	3	0	\N
43988	1690	60481051000000	9244	4794	4	0	\N
43990	1690	61200652999984	8816	4425	0	0	\N
43993	1690	61919652999960	9043	4428	0	0	\N
43994	1690	61921091000000	9411	4884	2	0	\N
43995	1690	61921091000000	9587	4974	2	0	\N
43997	1690	61921111000000	9411	4884	3	0	\N
43998	1690	61921111000000	9587	4974	3	0	\N
44000	1690	62639652999959	9045	4429	3	0	\N
44003	1690	63359602999959	9066	4430	0	0	\N
44010	1690	65521311000000	10048	5211	2	0	\N
44012	1690	65521331000000	10048	5211	3	0	\N
44014	1690	66000000499999	27041	13249	43	1	\N
44015	1690	66000000600200	20162	10084	126	1	\N
44020	1690	67681502000000	10149	5261	2	0	\N
44021	1690	67681502000000	10151	5262	2	0	\N
44023	1690	67681522000000	10149	5261	3	0	\N
44024	1690	67681522000000	10151	5262	3	0	\N
44026	1690	68401546000000	10289	5323	3	0	\N
44028	1690	68401576000000	10289	5323	4	0	\N
44036	1690	71281807000000	10418	5389	3	0	\N
44037	1690	71281807000000	10432	5396	3	0	\N
44040	1690	71281837000000	10418	5389	4	0	\N
44041	1690	71281837000000	10432	5396	4	0	\N
44044	1690	72721917000000	10571	5458	2	0	\N
44046	1690	72721937000000	10571	5458	3	0	\N
44048	1690	73441967000000	10714	5531	2	0	\N
44050	1690	73441987000000	10714	5531	3	0	\N
44056	1690	75602118000000	10761	5554	4	0	\N
44059	1690	75602158000000	10761	5554	5	0	\N
44062	1690	76322439000000	10924	5634	2	0	\N
44063	1690	77042419000000	11004	5667	1	0	\N
43933	1690	49680671000000	7756	4020	1	0	0
43935	1690	49680681000000	7756	4020	2	0	0
43936	1690	50400681000000	7762	4024	3	0	0
43937	1690	50400711000000	7762	4024	4	0	0
43940	1690	51120711000000	7874	4080	1	0	0
43944	1690	51840721000000	7960	4124	1	0	0
43945	1690	51840731000000	7960	4124	2	0	0
43946	1690	52560731000000	7971	4129	5	0	0
43947	1690	52560781000000	7971	4129	6	0	0
43950	1690	53280781000000	8206	4254	1	0	0
43954	1690	54000791000000	8212	4257	2	0	0
43955	1690	54000811000000	8212	4257	3	0	0
43956	1690	54720811000000	8225	4263	1	0	0
43957	1690	54720821000000	8225	4263	2	0	0
43963	1690	56160821000000	8409	4358	1	0	0
43964	1690	56160831000000	8409	4358	2	0	0
43966	1690	56880831000000	8498	4401	1	0	0
43967	1690	56880841000000	8498	4401	2	0	0
43972	1690	57600841000000	9174	4755	6	0	0
43975	1690	58320901000000	9190	4763	4	0	0
43976	1690	58320941000000	9190	4763	5	0	0
43978	1690	59040941000000	9207	4774	4	0	0
43980	1690	59041001000000	9207	4774	5	0	0
43982	1690	59761001000000	9238	4790	2	0	0
43986	1690	60481021000000	9274	4808	2	0	0
43987	1690	60481041000000	9274	4808	3	0	0
43989	1690	60481061000000	9327	4838	2	0	0
43991	1690	61201061000000	9327	4838	6	0	0
43996	1690	61921091000000	9629	4997	7	0	0
43999	1690	61921161000000	9629	4997	8	0	0
44001	1690	62641161000000	9647	5005	2	0	0
44002	1690	62641181000000	9647	5005	3	0	0
44004	1690	63361181000000	9706	5034	4	0	0
44006	1690	64081221000000	9848	5105	1	0	0
44007	1690	64081231000000	9848	5105	2	0	0
44008	1690	64801231000000	9949	5165	8	0	0
44009	1690	64801311000000	9949	5165	9	0	0
44011	1690	65521311000000	10098	5238	3	0	0
44016	1690	66241431000000	10115	5247	5	0	0
44017	1690	66241481000000	10115	5247	6	0	0
44018	1690	66961481000000	10142	5258	3	0	0
44019	1690	66961502000000	10142	5258	4	0	0
44025	1690	67681546000000	10173	5271	18	0	0
44027	1690	68401546000000	10304	5331	4	0	0
44029	1690	68401586000000	10304	5331	5	0	0
44030	1690	69121586000000	10346	5355	2	0	0
44031	1690	69121606000000	10346	5355	3	0	0
44033	1690	69841687000000	10377	5365	10	0	0
44034	1690	70561687000000	10382	5368	3	0	0
44035	1690	70561807000000	10382	5368	4	0	0
44038	1690	71281807000000	10474	5414	2	0	0
44039	1690	71281827000000	10474	5414	3	0	0
44043	1690	72001917000000	10507	5428	10	0	0
44045	1690	72721917000000	10669	5508	5	0	0
44047	1690	72721967000000	10669	5508	6	0	0
44049	1690	73441967000000	10722	5534	6	0	0
44052	1690	74162028000000	10744	5546	2	0	0
44053	1690	74162048000000	10744	5546	3	0	0
44054	1690	74882048000000	10752	5549	7	0	0
44055	1690	74882118000000	10752	5549	8	0	0
44057	1690	75602118000000	10785	5566	4	0	0
44060	1690	76322149000000	10904	5624	7	0	0
44061	1690	76322419000000	10904	5624	8	0	0
44064	1690	77042419000000	11025	5675	1	0	0
44065	1690	77042429000000	11004	5667	2	0	\N
44067	1690	77042439000000	10924	5634	5	0	\N
44068	1690	77042459000000	10924	5634	6	0	\N
44077	1690	80642549000000	11114	5715	4	0	\N
44078	1690	80642549000000	11169	5740	0	0	\N
44081	1690	80642589000000	11114	5715	5	0	\N
44082	1690	81362569000000	11249	5779	5	0	\N
44085	1690	81362610000000	11249	5779	6	0	\N
44100	1690	87122599000000	12051	6202	1	0	\N
44102	1690	87122600000000	12051	6202	2	0	\N
44104	1690	87842612000000	12256	6310	1	0	\N
44106	1690	87842613000000	12256	6310	2	0	\N
44110	1690	89282825000000	12376	6382	1	0	\N
44111	1690	89282825000000	12385	6388	1	0	\N
44112	1690	89282825000000	12390	6391	0	0	\N
44114	1690	89282826000000	12376	6382	2	0	\N
44115	1690	89282826000000	12385	6388	2	0	\N
44118	1690	90722846000000	12486	6436	4	0	\N
44120	1690	90722850000000	12486	6436	5	0	\N
44124	1690	92162889000000	12796	6597	6	0	\N
44126	1690	92162904000000	12796	6597	7	0	\N
44128	1690	92882909000000	12862	6631	1	0	\N
44130	1690	92882919000000	12862	6631	2	0	\N
44132	1690	93602919000000	12863	6632	9	0	\N
44133	1690	93602942000000	12913	6655	8	0	\N
44134	1690	93602942000000	13129	6767	10	0	\N
44137	1690	93602964000000	12863	6632	10	0	\N
44138	1690	93602970000000	13129	6767	11	0	\N
44139	1690	93602986000000	12913	6655	9	0	\N
44144	1690	95763065000000	13161	6780	4	0	\N
44145	1690	95763065000000	13327	6790	110	0	\N
44146	1690	95763065000000	13681	7030	2	0	\N
44147	1690	95763065000000	13729	7056	7	0	\N
44149	1690	95763076000000	13681	7030	3	0	\N
44151	1690	95763081000000	13729	7056	8	0	\N
44152	1690	95763087000000	13161	6780	5	0	\N
44153	1690	95764128800000	13327	6790	112	0	\N
44154	1690	95764158800000	13370	6791	3	0	\N
44158	1690	96484158800000	13370	6791	8	0	\N
44161	1690	97923143000000	14246	7272	3	0	\N
44163	1690	97923155000000	14246	7272	4	0	\N
44167	1690	99363191000000	14406	7350	2	0	\N
44169	1690	99363193000000	14406	7350	3	0	\N
44171	1690	100083201000000	14548	7421	12	0	\N
44174	1690	100083249000000	14548	7421	13	0	\N
44179	1690	102243235000000	14885	7583	3	0	\N
44180	1690	102243235000000	14921	7602	3	0	\N
44183	1690	102243247000000	14885	7583	4	0	\N
44184	1690	102243247000000	14921	7602	4	0	\N
44185	1690	102243256000000	15041	7663	1	0	\N
44186	1690	102963246000000	14968	7624	1	0	\N
44187	1690	102963246000000	14991	7636	3	0	\N
44188	1690	102963246000000	14996	7639	3	0	\N
44189	1690	102963246000000	15000	7642	4	0	\N
44190	1690	102963246000000	15127	7704	3	0	\N
44192	1690	102963256000000	14968	7624	2	0	\N
44193	1690	102963256000000	15041	7663	4	0	\N
44195	1690	102963258000000	14991	7636	4	0	\N
44196	1690	102963258000000	14996	7639	4	0	\N
44197	1690	102963258000000	15041	7663	5	0	\N
44198	1690	102963258000000	15127	7704	4	0	\N
44199	1690	102963268000000	15000	7642	5	0	\N
44070	1690	77762459000000	11069	5694	4	0	0
44071	1690	78482459000000	11078	5699	3	0	0
44072	1690	78482489000000	11078	5699	4	0	0
44073	1690	79202489000000	11082	5701	4	0	0
44074	1690	79202529000000	11082	5701	5	0	0
44076	1690	79922549000000	11090	5707	3	0	0
44079	1690	80642549000000	11218	5763	2	0	0
44080	1690	80642569000000	11218	5763	3	0	0
44083	1690	81362569000000	11372	5841	2	0	0
44084	1690	81362580000000	11372	5841	3	0	0
44087	1690	82082591000000	11532	5925	3	0	0
44088	1690	82802591000000	11601	5967	2	0	0
44089	1690	82802593000000	11601	5967	3	0	0
44090	1690	83522593000000	11693	6011	1	0	0
44092	1690	84242594000000	11750	6039	2	0	0
44093	1690	84242596000000	11750	6039	3	0	0
44094	1690	84962596000000	11861	6096	1	0	0
44095	1690	84962597000000	11861	6096	2	0	0
44096	1690	85682597000000	12033	6193	1	0	0
44098	1690	86402598000000	12035	6195	1	0	0
44099	1690	86402599000000	12035	6195	2	0	0
44101	1690	87122599000000	12068	6211	4	0	0
44103	1690	87122612000000	12068	6211	5	0	0
44105	1690	87842612000000	12298	6334	2	0	0
44108	1690	88562713000000	12306	6338	4	0	0
44109	1690	88562825000000	12306	6338	5	0	0
44113	1690	89282825000000	12464	6421	0	0	0
44116	1690	90002825000000	12479	6430	3	0	0
44119	1690	90722846000000	12598	6496	2	0	0
44121	1690	90722857000000	12598	6496	3	0	0
44122	1690	91442857000000	12750	6573	5	0	0
44123	1690	91442889000000	12750	6573	6	0	0
44125	1690	92162889000000	12808	6604	2	0	0
44129	1690	92882909000000	12866	6634	6	0	0
44131	1690	92882942000000	12866	6634	7	0	0
44135	1690	93602942000000	13130	6768	7	0	0
44136	1690	93602958000000	13130	6768	8	0	0
44140	1690	94322958000000	13147	6775	21	0	0
44142	1690	95043042000000	13149	6776	5	0	0
44143	1690	95043065000000	13149	6776	6	0	0
44148	1690	95763065000000	13733	7059	4	0	0
44150	1690	95763078000000	13733	7059	5	0	0
44156	1690	96483130000000	13827	7099	17	0	0
44157	1690	96483140000000	14219	7259	1	0	0
44159	1690	97203140000000	14219	7259	5	0	0
44160	1690	97203143000000	14219	7259	6	0	0
44162	1690	97923143000000	14333	7314	8	0	0
44165	1690	98643178000000	14341	7320	4	0	0
44166	1690	98643191000000	14341	7320	5	0	0
44168	1690	99363191000000	14503	7398	1	0	0
44170	1690	99363201000000	14503	7398	2	0	0
44172	1690	100083201000000	14645	7464	3	0	0
44175	1690	100803213000000	14800	7540	2	0	0
44176	1690	100803224000000	14800	7540	3	0	0
44177	1690	101523224000000	14865	7574	2	0	0
44178	1690	101523235000000	14865	7574	3	0	0
44182	1690	102243246000000	14926	7605	3	0	0
44191	1690	102963246000000	15243	7765	2	0	0
44194	1690	102963257000000	15243	7765	3	0	0
44200	1690	103683257000000	15315	7803	4	0	0
44202	1690	104403279000000	15335	7816	2	0	\N
44204	1690	104403290000000	15335	7816	3	0	\N
44206	1690	105123313000000	15502	7889	3	0	\N
44207	1690	105123313000000	15583	7932	1	0	\N
44208	1690	105123313000000	15611	7946	3	0	\N
44210	1690	105123323000000	15583	7932	2	0	\N
44211	1690	105123325000000	15502	7889	4	0	\N
44212	1690	105123325000000	15611	7946	4	0	\N
44218	1690	106563411000000	15737	8003	8	0	\N
44219	1690	107283376000000	15842	8059	4	0	\N
44222	1690	107283389000000	15842	8059	5	0	\N
44223	1690	107283411000000	15737	8003	12	0	\N
44224	1690	107283414000000	15737	8003	13	0	\N
44234	1690	110883448000000	16009	8141	16	0	\N
44237	1690	110883509000000	16009	8141	17	0	\N
44238	1690	111603461000000	16094	8180	3	0	\N
44239	1690	111603461000000	16137	8203	0	0	\N
44241	1690	111603473000000	16094	8180	4	0	\N
44243	1690	112323473000000	16309	8287	7	0	\N
44246	1690	112323498000000	16309	8287	8	0	\N
44247	1690	113043486000000	16608	8436	3	0	\N
44249	1690	113043498000000	16608	8436	4	0	\N
44251	1690	113763518000000	16639	8453	7	0	\N
44252	1690	113763518000000	16651	8460	6	0	\N
44253	1690	113763518000000	16672	8469	6	0	\N
44256	1690	113763542000000	16651	8460	7	0	\N
44257	1690	113763542000000	16672	8469	7	0	\N
44258	1690	113763543000000	16639	8453	8	0	\N
44259	1690	114483530000000	16776	8515	3	0	\N
44261	1690	114483542000000	16776	8515	4	0	\N
44263	1690	115203694000000	16882	8562	3	0	\N
44265	1690	115203706000000	16882	8562	4	0	\N
44275	1690	118803754000000	17219	8723	7	0	\N
44276	1690	118803754000000	17310	8769	3	0	\N
44277	1690	118803754000000	17447	8835	6	0	\N
44279	1690	118803766000000	17310	8769	4	0	\N
44280	1690	118803778000000	17447	8835	7	0	\N
44281	1690	118803779000000	17219	8723	8	0	\N
44286	1690	120243802000000	17634	8916	3	0	\N
44287	1690	120243814000000	17634	8916	4	0	\N
44292	1690	121683864000000	17788	8987	3	0	\N
44293	1690	121683864000000	17815	8997	3	0	\N
44295	1690	121683867000000	17815	8997	4	0	\N
44296	1690	121683876000000	17788	8987	4	0	\N
44298	1690	122403876000000	17876	9022	4	0	\N
44299	1690	122403876000000	17958	9058	4	0	\N
44300	1690	122403876000000	17980	9068	6	0	\N
44302	1690	122403889000000	17876	9022	5	0	\N
44303	1690	122403889000000	17958	9058	5	0	\N
44305	1690	122403900000000	17980	9068	7	0	\N
44306	1690	123123899000000	18009	9084	4	0	\N
44308	1690	123123912000000	18009	9084	5	0	\N
44314	1690	125283989000000	18133	9144	2	0	\N
44316	1690	125284000000000	18133	9144	3	0	\N
44322	1690	127444060000000	18199	9171	4	0	\N
44325	1690	127444082000000	18199	9171	5	0	\N
44330	1690	129604115000000	18609	9376	2	0	\N
44332	1690	129604126000000	18609	9376	3	0	\N
44205	1690	104403313000000	15340	7818	8	0	0
44209	1690	105123313000000	15654	7966	4	0	0
44213	1690	105123326000000	15654	7966	5	0	0
44214	1690	105843326000000	15697	7984	4	0	0
44215	1690	105843339000000	15697	7984	5	0	0
44217	1690	106563376000000	15710	7989	11	0	0
44220	1690	107283376000000	15856	8064	3	0	0
44221	1690	107283388000000	15856	8064	4	0	0
44225	1690	108003388000000	15925	8097	3	0	0
44226	1690	108003400000000	15925	8097	4	0	0
44228	1690	108723412000000	15974	8120	4	0	0
44229	1690	109443412000000	15987	8127	6	0	0
44230	1690	109443436000000	15987	8127	7	0	0
44231	1690	109443446000000	15992	8130	1	0	0
44233	1690	110163448000000	15992	8130	5	0	0
44235	1690	110883448000000	16028	8150	4	0	0
44236	1690	110883461000000	16028	8150	5	0	0
44240	1690	111603461000000	16164	8216	3	0	0
44242	1690	111603473000000	16164	8216	4	0	0
44245	1690	112323486000000	16468	8376	5	0	0
44248	1690	113043486000000	16619	8442	4	0	0
44250	1690	113043518000000	16619	8442	5	0	0
44254	1690	113763518000000	16728	8496	3	0	0
44255	1690	113763530000000	16728	8496	4	0	0
44262	1690	114483694000000	16798	8525	12	0	0
44264	1690	115203694000000	16921	8577	4	0	0
44266	1690	115203707000000	16921	8577	5	0	0
44267	1690	115923707000000	16928	8580	3	0	0
44269	1690	116643719000000	16994	8608	2	0	0
44270	1690	116643730000000	16994	8608	3	0	0
44271	1690	117363730000000	17105	8666	3	0	0
44272	1690	117363742000000	17105	8666	4	0	0
44273	1690	118083742000000	17152	8695	3	0	0
44278	1690	118803754000000	17526	8874	9	0	0
44282	1690	118803790000000	17526	8874	10	0	0
44283	1690	119523790000000	17563	8890	3	0	0
44284	1690	119523802000000	17563	8890	4	0	0
44285	1690	119523825000000	17737	8966	5	0	0
44289	1690	120243827000000	17737	8966	9	0	0
44290	1690	120963827000000	17774	8980	10	0	0
44291	1690	120963864000000	17774	8980	11	0	0
44294	1690	121683864000000	17820	8999	3	0	0
44301	1690	122403876000000	17991	9076	5	0	0
44304	1690	122403899000000	17991	9076	6	0	0
44307	1690	123123899000000	18101	9130	4	0	0
44309	1690	123123921000000	18101	9130	5	0	0
44310	1690	123843921000000	18110	9135	3	0	0
44312	1690	124563933000000	18117	9137	11	0	0
44313	1690	124563989000000	18117	9137	12	0	0
44315	1690	125283989000000	18148	9151	3	0	0
44317	1690	125284001000000	18148	9151	4	0	0
44318	1690	126004001000000	18168	9161	10	0	0
44320	1690	126724038000000	18173	9164	4	0	0
44321	1690	126724060000000	18173	9164	5	0	0
44323	1690	127444060000000	18293	9218	3	0	0
44324	1690	127444072000000	18293	9218	4	0	0
44327	1690	128164104000000	18329	9232	6	0	0
44328	1690	128884104000000	18377	9262	2	0	0
44329	1690	128884115000000	18377	9262	3	0	0
44331	1690	129604115000000	18782	9464	2	0	0
44333	1690	129604126000000	18782	9464	3	0	0
44335	1690	130324182000000	18795	9471	12	0	0
44336	1690	131044182000000	18841	9497	2	0	0
44338	1690	131764193000000	18869	9516	3	0	\N
44341	1690	131764214000000	18869	9516	4	0	\N
44352	1690	135364308000000	19270	9714	3	0	\N
44353	1690	136084296000000	19306	9734	20	0	\N
44354	1690	136084296000000	19308	9735	7	0	\N
44355	1690	136084296000000	19406	9779	3	0	\N
44357	1690	136084308000000	19270	9714	4	0	\N
44358	1690	136084308000000	19406	9779	4	0	\N
44360	1690	136084321000000	19308	9735	8	0	\N
44361	1690	136084402000000	19306	9734	21	0	\N
44364	1690	137524333000000	19671	9908	8	0	\N
44365	1690	137524333000000	19683	9913	9	0	\N
44368	1690	137524395000000	19671	9908	9	0	\N
44369	1690	137524405000000	19683	9913	10	0	\N
44370	1690	138244344000000	19871	10009	3	0	\N
44371	1690	138244344000000	19914	10028	4	0	\N
44373	1690	138244356000000	19871	10009	4	0	\N
44375	1690	138244456000000	19914	10028	5	0	\N
44376	1690	138244979000000	20067	10083	79	0	\N
44377	1690	138964431000000	19976	10058	7	0	\N
44380	1690	138964456000000	19976	10058	8	0	\N
44381	1690	138964979000000	20067	10083	96	0	\N
44382	1690	138964995000000	20067	10083	97	0	\N
44383	1690	138967475000000	20162	10084	109	0	\N
44386	1690	139687475000000	20162	10084	125	0	\N
44389	1690	140407624499992	20182	10085	43	0	\N
44390	1690	140408387499992	20182	10085	44	0	\N
44393	1690	141844526000000	20325	10236	4	0	\N
44396	1690	141844539000000	20325	10236	5	0	\N
44399	1690	143284549000000	20411	10283	6	0	\N
44400	1690	143284549000000	20469	10307	4	0	\N
44402	1690	143284562000000	20469	10307	5	0	\N
44403	1690	143284564000000	20411	10283	7	0	\N
44407	1690	144724614000000	20600	10363	3	0	\N
44408	1690	144724614000000	20694	10408	8	0	\N
44411	1690	144724626000000	20600	10363	4	0	\N
44412	1690	144724759000000	20694	10408	9	0	\N
44419	1690	147604702000000	20978	10551	3	0	\N
44420	1690	147604702000000	21016	10567	5	0	\N
44423	1690	147604714000000	20978	10551	4	0	\N
44424	1690	147604725000000	21016	10567	6	0	\N
44443	1690	154805305000000	21834	10927	2	0	\N
44446	1690	154805309000000	21917	10967	2	0	\N
44447	1690	154805316000000	21834	10927	3	0	\N
44448	1690	155525306000000	21993	10996	3	0	\N
44450	1690	155525309000000	21917	10967	3	0	\N
44451	1690	155525318000000	21993	10996	4	0	\N
44453	1690	156245318000000	22042	11022	4	0	\N
44454	1690	156245318000000	22082	11027	69	0	\N
44455	1690	156245318000000	22952	11467	8	0	\N
44456	1690	156245318000000	22959	11471	4	0	\N
44457	1690	156245318000000	22977	11478	2	0	\N
44459	1690	156245329000000	22977	11478	3	0	\N
44460	1690	156245331000000	22042	11022	5	0	\N
44461	1690	156245331000000	22959	11471	5	0	\N
44462	1690	156245344000000	22952	11467	9	0	\N
44464	1690	156245603000000	22082	11027	70	0	\N
44467	1690	156965603000000	22086	11028	3	0	\N
44468	1690	156965615000000	22086	11028	4	0	\N
44469	1690	156965993000000	22112	11029	45	0	\N
44470	1690	157685365000000	23031	11499	3	0	\N
44471	1690	157685365000000	23110	11542	3	0	\N
44340	1690	131764213000000	18945	9557	3	0	0
44342	1690	132484213000000	18964	9565	1	0	0
44343	1690	132484223000000	18964	9565	2	0	0
44344	1690	133204223000000	18990	9576	1	0	0
44345	1690	133204233000000	18990	9576	2	0	0
44347	1690	133924243000000	19037	9601	2	0	0
44348	1690	134644243000000	19042	9604	6	0	0
44349	1690	134644285000000	19042	9604	7	0	0
44350	1690	135364285000000	19077	9622	2	0	0
44351	1690	135364296000000	19077	9622	3	0	0
44359	1690	136084308000000	19548	9846	4	0	0
44362	1690	136804308000000	19644	9893	7	0	0
44363	1690	136804333000000	19644	9893	8	0	0
44366	1690	137524333000000	19743	9938	2	0	0
44372	1690	138244344000000	19949	10045	15	0	0
44374	1690	138244431000000	19949	10045	16	0	0
44378	1690	138964431000000	20193	10170	5	0	0
44379	1690	138964454000000	20193	10170	6	0	0
44384	1690	139684454000000	20239	10191	4	0	0
44387	1690	140404476000000	20252	10200	7	0	0
44388	1690	140404501000000	20252	10200	8	0	0
44391	1690	141124501000000	20310	10229	7	0	0
44392	1690	141124526000000	20310	10229	8	0	0
44394	1690	141844526000000	20382	10268	3	0	0
44397	1690	142564538000000	20383	10269	2	0	0
44398	1690	142564549000000	20383	10269	3	0	0
44401	1690	143284549000000	20535	10336	5	0	0
44404	1690	143284601000000	20535	10336	6	0	0
44406	1690	144004614000000	20574	10352	5	0	0
44409	1690	144724614000000	20828	10469	2	0	0
44410	1690	144724625000000	20828	10469	3	0	0
44413	1690	145444625000000	20909	10510	7	0	0
44414	1690	145444659000000	20909	10510	8	0	0
44416	1690	146164691000000	20917	10514	6	0	0
44417	1690	146884691000000	20921	10517	2	0	0
44418	1690	146884702000000	20921	10517	3	0	0
44421	1690	147604702000000	21081	10591	2	0	0
44422	1690	147604713000000	21081	10591	3	0	0
44426	1690	148324737000000	21151	10622	6	0	0
44427	1690	149044737000000	21235	10664	2	0	0
44428	1690	149044748000000	21235	10664	3	0	0
44429	1690	149764748000000	21320	10702	4	0	0
44431	1690	150484752000000	21340	10711	5	0	0
44432	1690	150485164000000	21340	10711	6	0	0
44433	1690	151205164000000	21357	10720	10	0	0
44434	1690	151205201000000	21357	10720	11	0	0
44435	1690	151925201000000	21443	10755	8	0	0
44437	1690	152645245000000	21544	10803	9	0	0
44438	1690	152645281000000	21544	10803	10	0	0
44439	1690	153365281000000	21678	10860	3	0	0
44440	1690	153365293000000	21678	10860	4	0	0
44441	1690	154085293000000	21682	10862	3	0	0
44444	1690	154805305000000	21914	10966	1	0	0
44445	1690	154805306000000	21914	10966	2	0	0
44449	1690	155525306000000	22004	11003	3	0	0
44452	1690	155525318000000	22004	11003	4	0	0
44463	1690	156245353000000	22981	11479	9	0	0
44465	1690	156965353000000	22993	11485	3	0	0
44466	1690	156965365000000	22993	11485	4	0	0
44472	1690	157685365000000	23203	11584	4	0	0
44473	1690	157685377000000	23031	11499	4	0	\N
44474	1690	157685377000000	23110	11542	4	0	\N
44476	1690	157685993000000	22112	11029	60	0	\N
44477	1690	157686007000000	22112	11029	61	0	\N
44484	1690	160565430000000	23340	11647	4	0	\N
44485	1690	160565430000000	23415	11682	4	0	\N
44488	1690	160565452000000	23340	11647	5	0	\N
44489	1690	160565452000000	23415	11682	5	0	\N
44490	1690	161285451000000	23471	11703	4	0	\N
44492	1690	161285464000000	23471	11703	5	0	\N
44496	1690	162725476000000	23635	11774	3	0	\N
44498	1690	162725488000000	23635	11774	4	0	\N
44500	1690	163445488000000	23755	11830	3	0	\N
44502	1690	163445500000000	23755	11830	4	0	\N
44506	1690	164885524000000	23852	11873	3	0	\N
44507	1690	164885524000000	23860	11876	7	0	\N
44509	1690	164885536000000	23852	11873	4	0	\N
44511	1690	164885549000000	23860	11876	8	0	\N
44520	1690	168485572000000	24434	12151	0	0	\N
44521	1690	168485572000000	24497	12183	6	0	\N
44522	1690	168485572000000	24549	12204	2	0	\N
44523	1690	168485572000000	24667	12251	2	0	\N
44525	1690	168485583000000	24549	12204	3	0	\N
44526	1690	168485583000000	24667	12251	3	0	\N
44527	1690	168485596000000	24497	12183	7	0	\N
44528	1690	169205572000000	24760	12294	5	0	\N
44531	1690	169205595000000	24760	12294	6	0	\N
44532	1690	169925585000000	24826	12327	8	0	\N
44533	1690	169925585000000	24853	12341	3	0	\N
44534	1690	169925585000000	24869	12347	3	0	\N
44536	1690	169925597000000	24853	12341	4	0	\N
44537	1690	169925597000000	24869	12347	4	0	\N
44539	1690	169925620000000	24826	12327	9	0	\N
44541	1690	170645598000000	25180	12393	0	0	\N
44542	1690	170645598000000	25181	12409	0	0	\N
44543	1690	170645598000000	25182	12426	0	0	\N
44547	1690	172085623000000	25124	12466	4	0	\N
44548	1690	172085623000000	25130	12470	3	0	\N
44550	1690	172085635000000	25130	12470	4	0	\N
44551	1690	172085636000000	25124	12466	5	0	\N
44555	1690	173525650000000	25202	12501	7	0	\N
44558	1690	173525675000000	25202	12501	8	0	\N
44565	1690	176405748000000	25370	12579	3	0	\N
44567	1690	176405760000000	25370	12579	4	0	\N
44569	1690	177125760000000	25527	12637	3	0	\N
44571	1690	177125772000000	25527	12637	4	0	\N
44577	1690	178565784000000	25739	12734	3	0	\N
44578	1690	178565787000000	25739	12734	4	0	\N
44587	1690	182165760000000	26216	12961	4	0	\N
44590	1690	182165773000000	26216	12961	5	0	\N
44591	1690	182885772000000	26403	13063	3	0	\N
44593	1690	182885784000000	26403	13063	4	0	\N
44600	1690	185045821000000	26481	13098	5	0	\N
44601	1690	185045821000000	26515	13118	3	0	\N
44603	1690	185045833000000	26515	13118	4	0	\N
44605	1690	185045835000000	26481	13098	6	0	\N
44608	1690	185766453000000	26856	13245	112	0	\N
44479	1690	158405408000000	23216	11587	4	0	0
44480	1690	159125408000000	23292	11622	2	0	0
44481	1690	159125419000000	23292	11622	3	0	0
44482	1690	159845419000000	23307	11630	2	0	0
44483	1690	159845430000000	23307	11630	3	0	0
44487	1690	160565451000000	23419	11684	4	0	0
44491	1690	161285451000000	23590	11755	4	0	0
44493	1690	161285464000000	23590	11755	5	0	0
44494	1690	162005464000000	23602	11760	3	0	0
44495	1690	162005476000000	23602	11760	4	0	0
44499	1690	162725488000000	23685	11794	4	0	0
44501	1690	163445488000000	23761	11832	6	0	0
44503	1690	163445512000000	23761	11832	7	0	0
44504	1690	164165512000000	23842	11867	3	0	0
44508	1690	164885524000000	23884	11888	3	0	0
44510	1690	164885536000000	23884	11888	4	0	0
44512	1690	165605536000000	24147	12019	2	0	0
44513	1690	165605547000000	24147	12019	3	0	0
44514	1690	166325547000000	24261	12072	3	0	0
44516	1690	167045559000000	24363	12116	3	0	0
44517	1690	167045571000000	24363	12116	4	0	0
44518	1690	167765571000000	24409	12139	1	0	0
44519	1690	167765572000000	24409	12139	2	0	0
44524	1690	168485572000000	24722	12277	0	0	0
44530	1690	169205585000000	24798	12313	5	0	0
44535	1690	169925585000000	24901	12364	4	0	0
44538	1690	169925598000000	24901	12364	5	0	0
44540	1690	170645598000000	25065	12439	4	0	0
44545	1690	171365611000000	25066	12440	3	0	0
44546	1690	171365623000000	25066	12440	4	0	0
44549	1690	172085623000000	25149	12478	5	0	0
44552	1690	172085637000000	25149	12478	6	0	0
44553	1690	172805637000000	25154	12480	4	0	0
44556	1690	173525650000000	25215	12508	3	0	0
44557	1690	173525662000000	25215	12508	4	0	0
44559	1690	174245662000000	25266	12533	17	0	0
44560	1690	174245724000000	25266	12533	18	0	0
44561	1690	174965724000000	25282	12541	3	0	0
44563	1690	175685736000000	25331	12564	3	0	0
44564	1690	175685748000000	25331	12564	4	0	0
44566	1690	176405748000000	25382	12583	3	0	0
44568	1690	176405760000000	25382	12583	4	0	0
44572	1690	177125772000000	25599	12669	4	0	0
44573	1690	177845772000000	25670	12704	3	0	0
44574	1690	177845784000000	25670	12704	4	0	0
44575	1690	177845785000000	25743	12735	1	0	0
44576	1690	178565685000000	25743	12735	2	0	0
44580	1690	179285707000000	25889	12795	5	0	0
44581	1690	180005707000000	25958	12827	4	0	0
44582	1690	180005729000000	25958	12827	5	0	0
44583	1690	180725729000000	25989	12844	2	0	0
44584	1690	180725740000000	25989	12844	3	0	0
44586	1690	181445760000000	26048	12871	3	0	0
44588	1690	182165760000000	26254	12982	3	0	0
44589	1690	182165772000000	26254	12982	4	0	0
44592	1690	182885772000000	26443	13081	6	0	0
44595	1690	183605796000000	26457	13086	3	0	0
44596	1690	183605808000000	26457	13086	4	0	0
44597	1690	183605820000000	26477	13096	3	0	0
44598	1690	184325820000000	26477	13096	5	0	0
44599	1690	184325821000000	26477	13096	6	0	0
44604	1690	185045834000000	26539	13129	5	0	0
44606	1690	185765834000000	26611	13165	3	0	0
44607	1690	185765846000000	26611	13165	4	0	0
44609	1690	186485846000000	28078	13872	1	0	\N
44610	1690	186485846000000	28746	13893	0	0	\N
44611	1690	186485846000000	28747	13906	1	0	\N
44612	1690	186485846000000	28752	13973	1	0	\N
44613	1690	186485846000000	28753	13979	1	0	\N
44614	1690	186485846000000	28754	13995	1	0	\N
44615	1690	186485846000000	28763	14189	2	0	\N
44617	1690	186485847000000	28078	13872	2	0	\N
44619	1690	186485856000000	28747	13906	2	0	\N
44620	1690	186485856000000	28752	13973	2	0	\N
44621	1690	186485856000000	28753	13979	2	0	\N
44622	1690	186485856000000	28754	13995	2	0	\N
44623	1690	186485857000000	28763	14189	3	0	\N
44624	1690	186486453000000	26856	13245	126	0	\N
44625	1690	186486466000000	26856	13245	127	0	\N
44626	1690	187205847000000	28146	13873	18	0	\N
44627	1690	187205848000000	28812	14211	2	0	\N
44629	1690	187205859000000	28812	14211	3	0	\N
44631	1690	187205892000000	28146	13873	19	0	\N
44632	1690	187206466000000	26882	13246	94	0	\N
44633	1690	187206677000000	26882	13246	95	0	\N
44634	1690	187206774000000	26894	13247	16	0	\N
44635	1690	187925860000000	29022	14313	4	0	\N
44638	1690	187925873000000	29022	14313	5	0	\N
44639	1690	187925882000000	29410	14501	1	0	\N
44640	1690	187925892000000	28154	13874	3	0	\N
44641	1690	187925895000000	28154	13874	4	0	\N
44642	1690	187926774000000	26894	13247	31	0	\N
44644	1690	188645882000000	29410	14501	10	0	\N
44646	1690	188645895000000	28171	13875	4	0	\N
44647	1690	188645899000000	28171	13875	5	0	\N
44648	1690	188645908000000	29410	14501	11	0	\N
44649	1690	188646787000001	26920	13248	71	0	\N
44650	1690	188647074000001	26920	13248	72	0	\N
44651	1690	188647454000001	27041	13249	38	0	\N
44652	1690	189365884000000	29544	14566	6	0	\N
44655	1690	189365899000000	28191	13876	4	0	\N
44656	1690	189365903000000	28191	13876	5	0	\N
44657	1690	189365908000000	29544	14566	7	0	\N
44658	1690	189367454000001	27041	13249	41	0	\N
44659	1690	190085896000000	29591	14590	5	0	\N
44660	1690	190085896000000	29633	14613	11	0	\N
44662	1690	190085903000000	28193	13877	0	0	\N
44663	1690	190085919000000	29591	14590	6	0	\N
44665	1690	190085934000000	29633	14613	12	0	\N
44666	1690	190805903000000	28268	13878	17	0	\N
44667	1690	190805920000000	28268	13878	18	0	\N
44670	1690	191525920000000	28348	13879	16	0	\N
44672	1690	191525945000000	28348	13879	17	0	\N
44674	1690	192245945000000	28423	13880	5	0	\N
44675	1690	192245959000000	29865	14720	9	0	\N
44677	1690	192245977000000	29865	14720	10	0	\N
44679	1690	192245986000000	28423	13880	6	0	\N
44680	1690	192246002000000	29999	14771	7	0	\N
44681	1690	192965977000000	29955	14753	10	0	\N
44683	1690	192965986000000	28468	13881	2	0	\N
44684	1690	192965988000000	28468	13881	3	0	\N
44685	1690	192965988000000	30317	14900	2	0	\N
44686	1690	192965996000000	29955	14753	11	0	\N
44687	1690	192966002000000	29999	14771	20	0	\N
44688	1690	192966004666670	28569	13882	5	0	\N
44689	1690	192966013739338	29999	14771	24	0	\N
44690	1690	193685977000000	30189	14851	11	0	\N
44691	1690	193685988000000	30317	14900	4	0	\N
44692	1690	193685988939967	30317	14900	6	1	\N
44693	1690	193686004666670	28569	13882	22	0	\N
44694	1690	193686006000000	30189	14851	12	0	\N
44695	1690	193686006466662	28569	13882	25	1	\N
44696	1690	194405996466662	28579	13883	2	0	\N
44697	1690	194405998466662	28579	13883	3	0	\N
44698	1690	195125998466662	28626	13884	13	0	\N
44699	1690	195126000566578	28626	13884	17	1	\N
44700	1690	195846000566578	28630	13885	1	0	\N
44701	1690	195846001566578	28630	13885	2	0	\N
44702	1690	196566001566578	28677	13886	11	0	\N
44703	1690	196566012566578	28677	13886	12	0	\N
44704	1690	197286012566578	28682	13887	1	0	\N
44705	1690	197286013566578	28682	13887	2	0	\N
44708	1691	1439010000000	546	309	3	0	\N
44709	1691	1439010000000	561	317	2	0	\N
44712	1691	1439030000000	561	317	3	0	\N
44713	1691	1439040000000	546	309	4	0	\N
44718	1691	2159040000000	1789	957	1	0	\N
44719	1691	2589946300028	22328	11175	3	0	\N
44720	1691	2589958300028	22328	11175	4	0	\N
44725	1691	2879030000000	2204	1160	2	0	\N
44727	1691	2879040000000	1789	957	2	0	\N
44729	1691	2879050000000	2204	1160	3	0	\N
44740	1691	4319060000000	2577	1359	1	0	\N
44742	1691	4319070000000	2577	1359	2	0	\N
44710	1691	1439010000000	1233	681	1	0	0
44711	1691	1439020000000	1233	681	2	0	0
44716	1691	2159020000000	1517	831	1	0	0
44717	1691	2159030000000	1517	831	2	0	0
44726	1691	2879030000000	2221	1169	1	0	0
44734	1691	3599040000000	2240	1181	2	0	0
44735	1691	3599060000000	2240	1181	3	0	0
44741	1691	4319060000000	2808	1467	2	0	0
44743	1691	4319080000000	2808	1467	3	0	0
44714	1691	2122980100019	11342	5825	4	0	5
44723	1691	2843002100019	11380	5846	2	0	5
44724	1691	2843013100019	11380	5846	3	0	5
44732	1691	3563013100019	11848	6091	1	0	5
44733	1691	3563014100019	11848	6091	2	0	5
44739	1691	4283015100019	12138	6252	2	0	5
44721	1691	2590946300052	22524	11268	3	0	10
44722	1691	2590958300052	22524	11268	4	0	10
44730	1691	3310958300052	22591	11303	16	0	10
44731	1691	3311001300052	22591	11303	17	0	10
44737	1691	4031013300052	22679	11339	4	0	10
44744	1691	4751013300052	22687	11343	4	0	10
44616	1690	186485846000000	28799	14207	2	0	0
44618	1690	186485848000000	28799	14207	3	0	0
44628	1690	187205848000000	28869	14240	3	0	0
44636	1690	187925860000000	29243	14411	3	0	0
44637	1690	187925872000000	29243	14411	4	0	0
44643	1690	188645872000000	29456	14526	3	0	0
44645	1690	188645884000000	29456	14526	4	0	0
44654	1690	189365896000000	29574	14581	4	0	0
44661	1690	190085896000000	29674	14636	15	0	0
44664	1690	190085929000000	29674	14636	16	0	0
44668	1690	190805929000000	29697	14647	6	0	0
44669	1690	190805944000000	29697	14647	7	0	0
44673	1690	191525959000000	29843	14708	7	0	0
44676	1690	192245959000000	29887	14728	9	0	0
44678	1690	192245977000000	29887	14728	10	0	0
44682	1690	192965977000000	30151	14835	0	0	0
44753	1691	5759090000000	3048	1583	2	0	\N
44754	1691	5759090000000	3470	1801	0	0	\N
44755	1691	5759090000000	3745	1941	2	0	\N
44756	1691	5759090000000	3865	2006	3	0	\N
44757	1691	5759090000000	4080	2120	2	0	\N
44760	1691	5759101000000	3745	1941	3	0	\N
44761	1691	5759110000000	3048	1583	3	0	\N
44762	1691	5759110000000	4080	2120	3	0	\N
44763	1691	5759120000000	3865	2006	4	0	\N
44768	1691	6479100000000	5480	2853	0	0	\N
44769	1691	6479100000000	5712	2962	0	0	\N
44774	1691	7163026100019	13236	6818	2	0	\N
44775	1691	7163026100019	13500	6951	3	0	\N
44776	1691	7163026100019	13523	6963	4	0	\N
44778	1691	7163037100019	13236	6818	3	0	\N
44779	1691	7163038100019	13500	6951	4	0	\N
44781	1691	7163048100019	13523	6963	5	0	\N
44784	1691	7631072300052	23873	11882	6	0	\N
44785	1691	7631072300052	23902	11896	3	0	\N
44788	1691	7631084300052	23902	11896	4	0	\N
44789	1691	7631096300052	23873	11882	7	0	\N
44794	1691	8351083300052	24223	12056	3	0	\N
44795	1691	8351083300052	24296	12083	10	0	\N
44797	1691	8351095300052	24223	12056	4	0	\N
44799	1691	8351120300052	24296	12083	11	0	\N
44803	1691	8639130000000	6071	3153	1	0	\N
44804	1691	8639130000000	6073	3154	1	0	\N
44806	1691	8639140000000	6071	3153	2	0	\N
44807	1691	8639140000000	6073	3154	2	0	\N
44809	1691	9071095300052	24600	12228	3	0	\N
44810	1691	9071095300052	24695	12266	5	0	\N
44813	1691	9071107300052	24600	12228	4	0	\N
44814	1691	9071127300052	24695	12266	6	0	\N
44823	1691	10079150000000	7670	3970	1	0	\N
44824	1691	10079150000000	7782	4035	1	0	\N
44826	1691	10079160000000	7670	3970	2	0	\N
44827	1691	10079160000000	7782	4035	2	0	\N
44829	1691	10511108300052	25350	12570	4	0	\N
44830	1691	10511108300052	25668	12703	3	0	\N
44832	1691	10511120300052	25668	12703	4	0	\N
44834	1691	10511121300052	25350	12570	5	0	\N
44839	1691	11231120300052	26406	13059	21	0	\N
44840	1691	11231120300052	26652	13184	3	0	\N
44841	1691	11231120300052	26956	13332	4	0	\N
44843	1691	11231132300052	26652	13184	4	0	\N
44845	1691	11231133300052	26956	13332	5	0	\N
44846	1691	11231204300052	26406	13059	22	0	\N
44847	1691	11231795300052	26494	13060	96	0	\N
44848	1691	11483124100019	15336	7817	7	0	\N
44849	1691	11483124100019	15760	8014	4	0	\N
44852	1691	11483137100019	15760	8014	5	0	\N
44853	1691	11483158100019	15336	7817	8	0	\N
44854	1691	11519291000000	8467	4386	1	0	\N
44855	1691	11519291000000	8485	4395	2	0	\N
44857	1691	11519301000000	8467	4386	2	0	\N
44859	1691	11519311000000	8485	4395	3	0	\N
44860	1691	11951132300052	27358	13525	9	0	\N
44863	1691	11951168300052	27358	13525	10	0	\N
44864	1691	11951795300052	26494	13060	126	0	\N
44865	1691	11951824300052	26494	13060	127	0	\N
44866	1691	11952028300052	26509	13061	96	0	\N
44869	1691	12239301000000	8828	4577	6	0	\N
44872	1691	12239361000000	8828	4577	7	0	\N
44875	1691	12672028300052	26509	13061	105	0	\N
44876	1691	12672036300052	26509	13061	106	0	\N
44877	1691	12923149100019	16128	8200	3	0	\N
44879	1691	12923161100019	16128	8200	4	0	\N
44758	1691	5759090000000	5322	2765	1	0	0
44759	1691	5759100000000	5322	2765	2	0	0
44770	1691	6479100000000	5909	3063	1	0	0
44771	1691	6479110000000	5909	3063	2	0	0
44782	1691	7199110000000	6015	3120	1	0	0
44792	1691	7919120000000	6020	3123	1	0	0
44793	1691	7919130000000	6020	3123	2	0	0
44805	1691	8639130000000	7446	3849	1	0	0
44808	1691	8639140000000	7446	3849	2	0	0
44817	1691	9359140000000	7630	3947	1	0	0
44825	1691	10079150000000	8301	4297	1	0	0
44828	1691	10079160000000	8301	4297	2	0	0
44837	1691	10799160000000	8316	4305	5	0	0
44838	1691	10799291000000	8316	4305	6	0	0
44858	1691	11519301000000	8599	4459	2	0	0
44870	1691	12239301000000	8937	4634	2	0	0
44871	1691	12239321000000	8937	4634	3	0	0
44746	1691	5003015100019	12291	6329	1	0	5
44747	1691	5003016100019	12291	6329	2	0	5
44766	1691	6443016100019	12820	6612	1	0	5
44767	1691	6443026100019	12820	6612	2	0	5
44777	1691	7163026100019	13755	7068	4	0	5
44780	1691	7163039100019	13755	7068	5	0	5
44790	1691	7883039100019	14051	7194	5	0	5
44800	1691	8603053100019	14454	7378	4	0	5
44801	1691	8603066100019	14454	7378	5	0	5
44802	1691	8603089100019	14649	7466	5	0	5
44815	1691	9323089100019	14649	7466	7	0	5
44821	1691	10043090100019	14824	7556	4	0	5
44822	1691	10043112100019	14824	7556	5	0	5
44835	1691	10763112100019	15314	7802	3	0	5
44836	1691	10763124100019	15314	7802	4	0	5
44850	1691	11483124100019	15797	8039	3	0	5
44867	1691	12203136100019	16067	8170	4	0	5
44868	1691	12203149100019	16067	8170	5	0	5
44878	1691	12923149100019	16147	8208	6	0	5
44880	1691	12923173100019	16147	8208	7	0	5
44745	1691	4751035300052	22687	11343	5	0	10
44751	1691	5471047300052	22716	11357	4	0	10
44764	1691	6191047300052	22813	11409	3	0	10
44765	1691	6191059300052	22813	11409	4	0	10
44772	1691	6911059300052	22918	11456	4	0	10
44786	1691	7631072300052	24077	11985	2	0	10
44787	1691	7631083300052	24077	11985	3	0	10
44796	1691	8351083300052	24467	12168	3	0	10
44798	1691	8351095300052	24467	12168	4	0	10
44811	1691	9071095300052	24868	12347	1	0	10
44819	1691	9791096300052	25178	12493	3	0	10
44820	1691	9791108300052	25178	12493	4	0	10
44831	1691	10511108300052	25801	12758	3	0	10
44833	1691	10511120300052	25801	12758	4	0	10
44842	1691	11231120300052	27079	13388	3	0	10
44861	1691	11951132300052	27452	13567	3	0	10
44862	1691	11951144300052	27452	13567	4	0	10
44873	1691	12671144300052	27456	13570	3	0	10
44874	1691	12671156300052	27456	13570	4	0	10
44883	1691	13391156300052	27475	13578	0	0	\N
44884	1691	13391156300052	27768	13718	2	0	\N
44885	1691	13391156300052	28128	13904	1	0	\N
44887	1691	13391166300052	28128	13904	2	0	\N
44888	1691	13391167300052	27768	13718	3	0	\N
44890	1691	13643173100019	16311	8287	7	0	\N
44893	1691	13643198100019	16311	8287	8	0	\N
44898	1691	14111922300052	29274	14303	64	0	\N
44899	1691	14363186100019	16806	8530	2	0	\N
44901	1691	14363197100019	16806	8530	3	0	\N
44903	1691	14399402000000	10430	5396	3	0	\N
44904	1691	14399402000000	10505	5428	9	0	\N
44907	1691	14399432000000	10430	5396	4	0	\N
44908	1691	14399492000000	10505	5428	10	0	\N
44909	1691	14831192300052	28635	14139	6	0	\N
44912	1691	14831216300052	28635	14139	7	0	\N
44913	1691	14831922300052	29274	14303	126	0	\N
44914	1691	14832532300052	29274	14303	127	0	\N
44915	1691	14833172300052	29331	14304	64	0	\N
44916	1691	15083198100019	17706	8948	2	0	\N
44917	1691	15083198100019	17806	8993	5	0	\N
44918	1691	15083198100019	17850	9009	2	0	\N
44919	1691	15083198100019	17904	9032	7	0	\N
44921	1691	15083209100019	17706	8948	3	0	\N
44922	1691	15083209100019	17850	9009	3	0	\N
44924	1691	15083212100019	17806	8993	6	0	\N
44925	1691	15083223100019	17904	9032	8	0	\N
44926	1691	15553172300052	29331	14304	126	0	\N
44927	1691	15553467300052	29331	14304	127	0	\N
44932	1691	17243254100019	18839	9496	1	0	\N
44934	1691	17243264100019	18839	9496	2	0	\N
44943	1691	20123370100019	20090	10113	4	0	\N
44946	1691	20123682100019	20090	10113	5	0	\N
44951	1691	22283435100019	20699	10411	8	0	\N
44952	1691	22283435100019	20952	10538	2	0	\N
44953	1691	22283435100019	21056	10580	2	0	\N
44955	1691	22283446100019	20952	10538	3	0	\N
44956	1691	22283446100019	21056	10580	3	0	\N
44958	1691	22283470100019	20699	10411	9	0	\N
44963	1691	24443480100019	21642	10842	3	0	\N
44965	1691	24443492100019	21642	10842	4	0	\N
44967	1691	25163494100019	21744	10888	3	0	\N
44968	1691	25163494100019	21899	10958	6	0	\N
44969	1691	25163506100019	21744	10888	4	0	\N
44970	1691	25163518100019	21899	10958	7	0	\N
44971	1692	1	8840	4582	5	0	\N
44972	1692	100000028	27423	13436	43	1	\N
44973	1692	200500000	27270	13432	42	0	\N
44974	1692	8053067459	27283	13433	11	0	\N
44981	1692	1459103000000	6106	3167	1	0	\N
44982	1692	1459103000000	6184	3201	2	0	\N
44984	1692	1459113000000	6106	3167	2	0	\N
44986	1692	1459123000000	6184	3201	3	0	\N
44996	1692	2899133000000	6323	3272	1	0	\N
44997	1692	2899133000000	6342	3282	1	0	\N
44999	1692	2899143000000	6323	3272	2	0	\N
45000	1692	2899143000000	6342	3282	2	0	\N
45004	1692	3599070000000	195	115	1	0	\N
45005	1692	3599070000000	209	122	1	0	\N
45007	1692	3599080000000	195	115	2	0	\N
45008	1692	3599080000000	209	122	2	0	\N
45014	1692	4319080000000	319	183	2	0	\N
45016	1692	4319091000000	319	183	3	0	\N
44979	1692	1439010000000	135	80	2	0	0
44980	1692	1439030000000	135	80	3	0	0
44989	1692	2159030000000	158	94	4	0	0
44990	1692	2159070000000	158	94	5	0	0
44995	1692	2879070000000	192	114	0	0	0
45009	1692	3599080000000	277	160	2	0	0
45015	1692	4319080000000	338	193	2	0	0
44977	1692	739083000000	6081	3157	2	0	4
44978	1692	739103000000	6081	3157	3	0	4
44983	1692	1459103000000	6204	3211	1	0	4
44991	1692	2179113000000	6260	3242	2	0	4
44992	1692	2179133000000	6260	3242	3	0	4
44998	1692	2899133000000	6361	3293	2	0	4
45001	1692	2899153000000	6361	3293	3	0	4
45011	1692	3619183000000	6401	3316	4	0	4
44881	1691	12959321000000	8960	4646	5	0	0
44882	1691	12959362000000	8960	4646	6	0	0
44894	1691	13679362000000	9188	4762	4	0	0
44895	1691	13679402000000	9188	4762	5	0	0
44906	1691	14399412000000	10660	5505	2	0	0
44891	1691	13643173100019	16476	8379	4	0	5
44892	1691	13643186100019	16476	8379	5	0	5
44900	1691	14363186100019	16906	8572	3	0	5
44902	1691	14363198100019	16906	8572	4	0	5
44923	1691	15083210100019	18051	9105	4	0	5
44928	1691	15803210100019	18504	9321	3	0	5
44929	1691	15803222100019	18504	9321	4	0	5
44930	1691	16523222100019	18741	9443	5	0	5
44933	1691	17243254100019	18979	9572	1	0	5
44935	1691	17243264100019	18979	9572	2	0	5
44936	1691	17963264100019	19563	9854	3	0	5
44937	1691	17963276100019	19563	9854	4	0	5
44938	1691	18683276100019	19667	9907	10	0	5
44940	1691	19403358100019	19961	10052	3	0	5
44941	1691	19403370100019	19961	10052	4	0	5
44942	1691	19403390100019	20097	10116	2	0	5
44944	1691	20123390100019	20097	10116	8	0	5
44945	1691	20123395100019	20097	10116	9	0	5
44948	1691	20843412100019	20361	10256	5	0	5
44949	1691	21563412100019	20617	10370	5	0	5
44950	1691	21563435100019	20617	10370	6	0	5
44954	1691	22283435100019	21073	10588	2	0	5
44959	1691	23003446100019	21228	10660	4	0	5
44960	1691	23003468100019	21228	10660	5	0	5
44961	1691	23723468100019	21390	10731	3	0	5
44962	1691	23723480100019	21390	10731	4	0	5
44964	1691	24443480100019	21645	10844	5	0	5
44987	1692	1900542619999	25031	12419	2	0	6
44988	1692	1900553619999	25031	12419	3	0	6
44993	1692	2620553619999	25329	12563	4	0	6
44994	1692	2620665619999	25329	12563	5	0	6
45002	1692	3340665619999	25425	12599	3	0	6
45012	1692	4060677619999	25466	12614	4	0	6
45013	1692	4060690619999	25466	12614	5	0	6
44886	1691	13391156300052	28180	13930	6	0	10
44889	1691	13391180300052	28180	13930	7	0	10
44897	1691	14111192300052	28510	14088	4	0	10
44910	1691	14831192300052	29579	14585	4	0	10
44911	1691	14831205300052	29579	14585	5	0	10
45022	1692	5039100000000	340	194	1	0	\N
45024	1692	5039110000000	340	194	2	0	\N
45026	1692	5059192999990	6574	3403	4	0	\N
45027	1692	5059193000000	6533	3385	2	0	\N
45028	1692	5059193000000	6565	3399	2	0	\N
45030	1692	5059213000000	6533	3385	3	0	\N
45031	1692	5059213000000	6565	3399	3	0	\N
45037	1692	5779233000000	6790	3515	2	0	\N
45039	1692	5779253000000	6790	3515	3	0	\N
45041	1692	6220714619999	25642	12690	3	0	\N
45043	1692	6220726619999	25642	12690	4	0	\N
45047	1692	6499253000000	6915	3571	2	0	\N
45048	1692	6499253000000	6982	3602	4	0	\N
45049	1692	6499253000000	7011	3615	5	0	\N
45051	1692	6499273000000	6915	3571	3	0	\N
45053	1692	6499293000000	6982	3602	5	0	\N
45054	1692	6499294000000	7011	3615	6	0	\N
45055	1692	6940726619999	25717	12721	3	0	\N
45057	1692	6940738619999	25717	12721	4	0	\N
45059	1692	7199131000000	555	313	1	0	\N
45060	1692	7199131000000	650	364	1	0	\N
45061	1692	7199131000000	657	366	2	0	\N
45063	1692	7199141000000	555	313	2	0	\N
45064	1692	7199141000000	650	364	2	0	\N
45065	1692	7199151000000	657	366	3	0	\N
45073	1692	7939313000000	7084	3655	4	0	\N
45076	1692	7939353000000	7084	3655	5	0	\N
45077	1692	8380762619999	25736	12733	6	0	\N
45078	1692	8380762619999	25741	12734	5	0	\N
45081	1692	8380776619999	25741	12734	6	0	\N
45082	1692	8380786619999	25736	12733	7	0	\N
45083	1692	8639401000000	723	404	1	0	\N
45085	1692	8639411000000	723	404	2	0	\N
45090	1692	9359401000000	810	448	2	0	\N
45093	1692	9359421000000	810	448	3	0	\N
45098	1692	10079411000000	974	541	1	0	\N
45099	1692	10079411000000	1074	594	2	0	\N
45100	1692	10079411000000	1103	610	1	0	\N
45101	1692	10079411000000	1145	631	1	0	\N
45103	1692	10079421000000	974	541	2	0	\N
45104	1692	10079421000000	1103	610	2	0	\N
45105	1692	10079421000000	1145	631	2	0	\N
45107	1692	10079431000000	1074	594	3	0	\N
45109	1692	10540816619999	25990	12844	2	0	\N
45110	1692	10540816619999	26066	12882	9	0	\N
45114	1692	10540827619999	25990	12844	3	0	\N
45115	1692	10540870619999	26066	12882	10	0	\N
45116	1692	10799421000000	1213	667	1	0	\N
45117	1692	10799421000000	1261	697	1	0	\N
45118	1692	10799421000000	1579	859	1	0	\N
45119	1692	10799421000000	1599	866	1	0	\N
45120	1692	10799421000000	1619	874	1	0	\N
45122	1692	10799431000000	1213	667	2	0	\N
45123	1692	10799431000000	1261	697	2	0	\N
45124	1692	10799431000000	1579	859	2	0	\N
45125	1692	10799431000000	1599	866	2	0	\N
45126	1692	10799431000000	1619	874	2	0	\N
45130	1692	11260819619999	26178	12941	7	0	\N
45131	1692	11260819619999	26373	13044	6	0	\N
45132	1692	11260819619999	26378	13047	3	0	\N
45133	1692	11260819619999	26428	13074	3	0	\N
45134	1692	11260819619999	26498	13107	1	0	\N
45135	1692	11260819619999	26512	13117	4	0	\N
45136	1692	11260819619999	26780	13243	3	0	\N
45137	1692	11260819619999	26834	13269	2	0	\N
45138	1692	11260819619999	27047	13372	6	0	\N
45139	1692	11260820619999	26498	13107	2	0	\N
45141	1692	11260822619999	26780	13243	4	0	\N
45143	1692	11260830619999	26834	13269	3	0	\N
45144	1692	11260831619999	26378	13047	4	0	\N
45145	1692	11260831619999	26428	13074	4	0	\N
45146	1692	11260832619999	26512	13117	5	0	\N
45147	1692	11260834619999	26373	13044	7	0	\N
45148	1692	11260843619999	27047	13372	7	0	\N
45149	1692	11260844619999	26178	12941	8	0	\N
45150	1692	11519441000000	1637	882	1	0	\N
45151	1692	11519441000000	1666	895	2	0	\N
45025	1692	5039110000000	436	247	2	0	0
45035	1692	5759110000000	477	266	2	0	0
45036	1692	5759121000000	477	266	3	0	0
45045	1692	6479121000000	531	301	1	0	0
45046	1692	6479131000000	531	301	2	0	0
45066	1692	7199391000000	680	379	3	0	0
45071	1692	7919391000000	693	386	1	0	0
45072	1692	7919401000000	693	386	2	0	0
45084	1692	8639401000000	783	434	0	0	0
45091	1692	9359401000000	819	453	1	0	0
45102	1692	10079411000000	1156	636	1	0	0
45106	1692	10079421000000	1156	636	2	0	0
45121	1692	10799421000000	1634	880	2	0	0
45127	1692	10799441000000	1634	880	3	0	0
45018	1692	4339183000000	6451	3340	1	0	4
45019	1692	4339193000000	6451	3340	2	0	4
45029	1692	5059193000000	6733	3484	4	0	4
45032	1692	5059233000000	6733	3484	5	0	4
45038	1692	5779233000000	6901	3565	2	0	4
45050	1692	6499253000000	7033	3627	2	0	4
45052	1692	6499273000000	7033	3627	3	0	4
45067	1692	7219273000000	7060	3645	4	0	4
45068	1692	7219313000000	7060	3645	5	0	4
45074	1692	7939313000000	7090	3660	2	0	4
45086	1692	8659333000000	7195	3720	2	0	4
45087	1692	8659353000000	7195	3720	3	0	4
45094	1692	9379353000000	7247	3747	1	0	4
45095	1692	9379363000000	7247	3747	2	0	4
45128	1692	10819363000000	7345	3796	1	0	4
45129	1692	10819373000000	7345	3796	2	0	4
45020	1692	4780690619999	25507	12631	3	0	6
45021	1692	4780702619999	25507	12631	4	0	6
45033	1692	5500702619999	25638	12688	3	0	6
45042	1692	6220714619999	25669	12703	3	0	6
45044	1692	6220726619999	25669	12703	4	0	6
45056	1692	6940726619999	25723	12725	6	0	6
45058	1692	6940750619999	25723	12725	7	0	6
45069	1692	7660750619999	25728	12729	3	0	6
45079	1692	8380762619999	25820	12767	2	0	6
45080	1692	8380773619999	25820	12767	3	0	6
45088	1692	9100773619999	25936	12819	6	0	6
45089	1692	9100806619999	25936	12819	7	0	6
45097	1692	9820816619999	25943	12822	2	0	6
45111	1692	10540816619999	26169	12937	3	0	6
45112	1692	10540819619999	26169	12937	4	0	6
45113	1692	10540820619999	27149	13424	1	0	6
45140	1692	11260820619999	27149	13424	5	0	6
45153	1692	11519451000000	1637	882	2	0	\N
45155	1692	11519461000000	1666	895	3	0	\N
45160	1692	12239451000000	1714	920	0	0	\N
45165	1692	12700824819983	27267	13430	0	0	\N
45166	1692	12700824819983	28111	13895	7	0	\N
45169	1692	12700849819983	28111	13895	8	0	\N
45174	1692	13420824819983	27269	13431	63	0	\N
45177	1692	13420914819983	27269	13431	64	0	\N
45178	1692	13420938819983	27270	13432	24	0	\N
45181	1692	13699413000000	7539	3902	1	0	\N
45183	1692	13699423000000	7539	3902	2	0	\N
45185	1692	14140881819983	28162	13925	7	0	\N
45186	1692	14140881819983	28317	13999	5	0	\N
45187	1692	14140881819983	28397	14035	1	0	\N
45189	1692	14140882819983	28397	14035	2	0	\N
45191	1692	14140904819983	28317	13999	6	0	\N
45192	1692	14140915819983	28162	13925	8	0	\N
45193	1692	14140938819983	27270	13432	40	0	\N
45194	1692	14179946719999	16471	8377	3	0	\N
45195	1692	14179946719999	16558	8415	3	0	\N
45197	1692	14179958719999	16471	8377	4	0	\N
45198	1692	14179958719999	16558	8415	4	0	\N
45200	1692	14399492000000	1849	986	1	0	\N
45201	1692	14399492000000	1925	1024	1	0	\N
45203	1692	14399502000000	1849	986	2	0	\N
45204	1692	14399502000000	1925	1024	2	0	\N
45210	1692	14860950719970	27283	13433	10	0	\N
45211	1692	14899959719999	16579	8426	10	0	\N
45212	1692	14899959719999	16677	8470	7	0	\N
45215	1692	14899984719999	16677	8470	8	0	\N
45216	1692	14899996719999	16579	8426	11	0	\N
45217	1692	15119502000000	1952	1034	1	0	\N
45218	1692	15119502000000	2031	1072	1	0	\N
45219	1692	15119502000000	2044	1079	1	0	\N
45221	1692	15119512000000	1952	1034	2	0	\N
45222	1692	15119512000000	2031	1072	2	0	\N
45223	1692	15119512000000	2044	1079	2	0	\N
45225	1692	15139553000000	7712	3994	1	0	\N
45227	1692	15139563000000	7712	3994	2	0	\N
45229	1692	15580893819983	28480	14075	2	0	\N
45231	1692	15580904819983	28480	14075	3	0	\N
45233	1692	15580960668970	27289	13434	1	0	\N
45234	1692	15580961668970	27289	13434	2	0	\N
45238	1692	15840411000030	6574	3403	5	0	\N
45243	1692	16300961668970	27367	13435	62	0	\N
45244	1692	16301023668970	27367	13435	63	0	\N
45245	1692	16301052668970	27423	13436	29	0	\N
45254	1692	17021052668970	27423	13436	42	0	\N
45259	1692	17299613000000	7802	4045	1	0	\N
45261	1692	17299623000000	7802	4045	2	0	\N
45263	1692	17299643000000	7893	4090	1	0	\N
45264	1692	17740942819983	28566	14111	7	0	\N
45267	1692	17740967819983	28566	14111	8	0	\N
45268	1692	17741063668958	27577	13437	23	0	\N
45269	1692	17741095668958	27577	13437	24	0	\N
45272	1692	17999562000000	2406	1258	1	0	\N
45274	1692	17999572000000	2406	1258	2	0	\N
45275	1692	18019633000000	7816	4051	1	0	\N
45277	1692	18019643000000	7816	4051	2	0	\N
45278	1692	18019643000000	7893	4090	2	0	\N
45288	1692	19180975819983	28693	14165	3	0	\N
45162	1692	12239461000000	1776	952	2	0	0
45170	1692	12959461000000	1805	965	3	0	0
45171	1692	12959482000000	1805	965	4	0	0
45179	1692	13679482000000	1806	966	1	0	0
45180	1692	13679492000000	1806	966	2	0	0
45205	1692	14399502000000	1930	1026	2	0	0
45220	1692	15119502000000	2132	1126	1	0	0
45224	1692	15119512000000	2132	1126	2	0	0
45236	1692	15839512000000	2181	1150	2	0	0
45237	1692	15839532000000	2181	1150	3	0	0
45249	1692	16559542000000	2213	1165	2	0	0
45257	1692	17279542000000	2282	1196	2	0	0
45258	1692	17279562000000	2282	1196	3	0	0
45273	1692	17999562000000	2481	1300	0	0	0
45285	1692	18719572000000	2492	1305	2	0	0
45156	1692	11539373000000	7437	3844	1	0	4
45157	1692	11539383000000	7437	3844	2	0	4
45163	1692	12259383000000	7442	3847	1	0	4
45164	1692	12259393000000	7442	3847	2	0	4
45173	1692	12979413000000	7478	3867	3	0	4
45182	1692	13699413000000	7649	3958	2	0	4
45184	1692	13699433000000	7649	3958	3	0	4
45206	1692	14419433000000	7693	3986	3	0	4
45207	1692	14419553000000	7693	3986	4	0	4
45228	1692	15139573000000	7724	4000	3	0	4
45239	1692	15859573000000	7767	4027	3	0	4
45240	1692	15859603000000	7767	4027	4	0	4
45250	1692	16579603000000	7769	4029	1	0	4
45260	1692	17299613000000	7811	4049	2	0	4
45262	1692	17299633000000	7811	4049	3	0	4
45276	1692	18019633000000	7901	4093	2	0	4
45279	1692	18019653000000	7901	4093	3	0	4
45286	1692	18739653000000	7950	4118	1	0	4
45196	1692	14179946719999	16565	8420	4	0	5
45199	1692	14179959719999	16565	8420	5	0	5
45213	1692	14899959719999	16822	8538	3	0	5
45214	1692	14899971719999	16822	8538	4	0	5
45235	1692	15619971719999	16867	8555	0	0	5
45247	1692	16339983719999	16891	8566	4	0	5
45255	1692	17059983719999	16902	8570	7	0	5
45256	1692	17060017719999	16902	8570	8	0	5
45270	1692	17780017719999	16962	8597	3	0	5
45282	1692	18500029719999	17002	8611	2	0	5
45283	1692	18500040719999	17002	8611	3	0	5
45158	1692	11980822819983	27151	13425	2	0	6
45159	1692	11980824819983	27151	13425	3	0	6
45167	1692	12700824819983	28147	13915	2	0	6
45175	1692	13420835819983	28156	13923	10	0	6
45176	1692	13420881819983	28156	13923	11	0	6
45188	1692	14140881819983	28413	14041	1	0	6
45190	1692	14140882819983	28413	14041	2	0	6
45208	1692	14860882819983	28431	14051	2	0	6
45230	1692	15580893819983	28519	14091	3	0	6
45232	1692	15580905819983	28519	14091	4	0	6
45241	1692	16300905819983	28557	14106	3	0	6
45242	1692	16300917819983	28557	14106	4	0	6
45253	1692	17020942819983	28558	14107	8	0	6
45265	1692	17740942819983	28651	14145	4	0	6
45266	1692	17740964819983	28651	14145	5	0	6
45280	1692	18460964819983	28667	14153	2	0	6
45281	1692	18460975819983	28667	14153	3	0	6
45289	1692	19180975819983	28721	14174	4	0	\N
45291	1692	19180987819983	28693	14165	4	0	\N
45292	1692	19180988819983	28721	14174	5	0	\N
45294	1692	19220040719999	17010	8616	5	0	\N
45295	1692	19220040719999	17013	8618	2	0	\N
45297	1692	19220051719999	17013	8618	3	0	\N
45299	1692	19220063719999	17010	8616	6	0	\N
45319	1692	20899693000000	8098	4197	2	0	\N
45321	1692	20899704000000	8098	4197	3	0	\N
45323	1692	21341124819983	28858	14233	17	0	\N
45324	1692	21341124819983	28882	14246	3	0	\N
45325	1692	21341124819983	28939	14272	3	0	\N
45326	1692	21341124819983	29000	14298	3	0	\N
45328	1692	21341136819983	28882	14246	4	0	\N
45329	1692	21341136819983	28939	14272	4	0	\N
45330	1692	21341136819983	29000	14298	4	0	\N
45332	1692	21341192358443	28858	14233	18	0	\N
45338	1692	21619814000000	8117	4208	1	0	\N
45340	1692	21619824000000	8117	4208	2	0	\N
45348	1692	22339834000000	8146	4223	2	0	\N
45349	1692	22339834000000	8256	4274	2	0	\N
45352	1692	22339845000000	8256	4274	3	0	\N
45353	1692	22339854000000	8146	4223	3	0	\N
45360	1692	23059844000000	8284	4290	1	0	\N
45361	1692	23059844000000	8328	4310	1	0	\N
45362	1692	23059844000000	8337	4318	1	0	\N
45363	1692	23059844000000	8407	4356	1	0	\N
45364	1692	23059844000000	8415	4360	0	0	\N
45366	1692	23059854000000	8284	4290	2	0	\N
45367	1692	23059854000000	8328	4310	2	0	\N
45368	1692	23059854000000	8337	4318	2	0	\N
45369	1692	23059854000000	8407	4356	2	0	\N
45371	1692	23501192819983	29428	14509	4	0	\N
45373	1692	23501212569983	29428	14509	5	0	\N
45375	1692	23540125619999	17522	8871	2	0	\N
45377	1692	23540136619999	17522	8871	3	0	\N
45380	1692	23759662000000	2805	1465	3	0	\N
45383	1692	23759692000000	2805	1465	4	0	\N
45384	1692	23779854000000	8567	4440	1	0	\N
45386	1692	23779864000000	8567	4440	2	0	\N
45390	1692	24260137619999	17638	8917	3	0	\N
45393	1692	24260149619999	17638	8917	4	0	\N
45394	1692	24479682000000	2855	1495	2	0	\N
45395	1692	24479682000000	2860	1496	3	0	\N
45396	1692	24479682000000	2894	1510	1	0	\N
45397	1692	24479682000000	2931	1524	2	0	\N
45399	1692	24479692000000	2894	1510	2	0	\N
45400	1692	24479702000000	2855	1495	3	0	\N
45401	1692	24479702000000	2931	1524	3	0	\N
45402	1692	24479703000000	2860	1496	4	0	\N
45404	1692	24499864000000	8750	4541	2	0	\N
45406	1692	24499884000000	8750	4541	3	0	\N
45408	1692	24941226819983	29624	14609	6	0	\N
45409	1692	24941226819983	30159	14839	6	0	\N
45411	1692	24941241819983	30159	14839	7	0	\N
45412	1692	24941253069983	29624	14609	7	0	\N
45418	1692	25219884000000	8770	4548	2	0	\N
45419	1692	25219884000000	8775	4551	2	0	\N
45421	1692	25219904000000	8770	4548	3	0	\N
45422	1692	25219904000000	8775	4551	3	0	\N
45309	1692	20159602000000	2573	1356	2	0	0
45310	1692	20159622000000	2573	1356	3	0	0
45317	1692	20879622000000	2585	1362	1	0	0
45318	1692	20879632000000	2585	1362	2	0	0
45336	1692	21599632000000	2629	1383	1	0	0
45346	1692	22319642000000	2691	1413	1	0	0
45347	1692	22319652000000	2691	1413	2	0	0
45358	1692	23039652000000	2747	1440	1	0	0
45359	1692	23039662000000	2747	1440	2	0	0
45381	1692	23759662000000	2822	1474	2	0	0
45398	1692	24479682000000	2950	1534	4	0	0
45403	1692	24479722000000	2950	1534	5	0	0
45416	1692	25199722000000	2982	1551	1	0	0
45417	1692	25199732000000	2982	1551	2	0	0
45303	1692	19459673000000	7983	4137	2	0	4
45311	1692	20179673000000	8007	4149	2	0	4
45312	1692	20179693000000	8007	4149	3	0	4
45320	1692	20899693000000	8104	4200	4	0	4
45322	1692	20899814000000	8104	4200	5	0	4
45341	1692	21619834000000	8134	4217	3	0	4
45350	1692	22339834000000	8271	4283	1	0	4
45351	1692	22339844000000	8271	4283	2	0	4
45365	1692	23059844000000	8558	4435	1	0	4
45370	1692	23059854000000	8558	4435	2	0	4
45387	1692	23779864000000	8621	4469	2	0	4
45405	1692	24499864000000	8760	4545	2	0	4
45407	1692	24499884000000	8760	4545	3	0	4
45420	1692	25219884000000	8803	4564	2	0	4
45296	1692	19220040719999	17041	8630	3	0	5
45298	1692	19220052719999	17041	8630	4	0	5
45307	1692	19940052719999	17212	8721	3	0	5
45308	1692	19940064719999	17212	8721	4	0	5
45315	1692	20660064719999	17363	8795	3	0	5
45333	1692	21380076719999	17495	8856	2	0	5
45334	1692	21380087719999	17495	8856	3	0	5
45335	1692	21380097719999	17501	8860	1	0	5
45344	1692	22100097719999	17501	8860	7	0	5
45345	1692	22100102619999	17501	8860	8	0	5
45357	1692	22820125619999	17509	8865	6	0	5
45376	1692	23540125619999	17635	8916	3	0	5
45378	1692	23540137619999	17635	8916	4	0	5
45379	1692	23540147619999	17650	8923	1	0	5
45392	1692	24260148619999	17650	8923	4	0	5
45414	1692	24980148619999	17736	8965	11	0	5
45415	1692	24980195619999	17736	8965	12	0	5
45290	1692	19180975819983	28762	14188	4	0	6
45293	1692	19181087819983	28762	14188	5	0	6
45305	1692	19901100819983	28787	14200	5	0	6
45306	1692	19901123819983	28806	14209	5	0	6
45313	1692	20621123819983	28806	14209	7	0	6
45314	1692	20621124819983	28806	14209	8	0	6
45327	1692	21341124819983	29058	14329	3	0	6
45342	1692	22061136819983	29091	14342	6	0	6
45343	1692	22061169819983	29091	14342	7	0	6
45354	1692	22781169819983	29406	14498	5	0	6
45355	1692	22781192819983	29406	14498	6	0	6
45374	1692	23501214819983	29470	14533	5	0	6
45388	1692	24221214819983	29602	14598	3	0	6
45389	1692	24221226819983	29602	14598	4	0	6
45410	1692	24941226819983	30195	14853	24	0	6
45413	1692	24941529819983	30195	14853	25	0	6
45428	1692	25919732000000	3085	1600	1	0	\N
45429	1692	25919732000000	3195	1658	1	0	\N
45431	1692	25919742000000	3085	1600	2	0	\N
45432	1692	25919742000000	3195	1658	2	0	\N
45434	1692	25939904000000	8840	4582	4	0	\N
45439	1692	26639742000000	3309	1717	1	0	\N
45440	1692	26639742000000	3351	1741	1	0	\N
45442	1692	26639752000000	3309	1717	2	0	\N
45443	1692	26639752000000	3351	1741	2	0	\N
45450	1692	27379962020000	8948	4640	5	0	\N
45451	1692	27379962020000	8981	4658	2	0	\N
45453	1692	27379982020000	8981	4658	3	0	\N
45455	1692	27380102020000	8948	4640	6	0	\N
45458	1692	28079752000000	3575	1855	0	0	\N
45459	1692	28079752000000	3622	1878	0	0	\N
45462	1692	28099982020000	9136	4732	2	0	\N
45464	1692	28100002020000	9136	4732	3	0	\N
45466	1692	28580304619999	18253	9193	2	0	\N
45467	1692	28580304619999	18260	9196	3	0	\N
45468	1692	28580304619999	18473	9307	3	0	\N
45469	1692	28580304619999	18663	9379	43	0	\N
45471	1692	28580315619999	18253	9193	3	0	\N
45472	1692	28580316619999	18260	9196	4	0	\N
45473	1692	28580316619999	18473	9307	4	0	\N
45475	1692	28580743619999	18663	9379	44	0	\N
45476	1692	28799762000000	3754	1946	1	0	\N
45477	1692	28799762000000	3802	1970	2	0	\N
45479	1692	28799772000000	3754	1946	2	0	\N
45480	1692	28799782000000	3802	1970	3	0	\N
45482	1692	28820002020000	9313	4831	3	0	\N
45483	1692	28820002020000	9348	4850	2	0	\N
45485	1692	28820022020000	9348	4850	3	0	\N
45487	1692	28820023020000	9313	4831	4	0	\N
45492	1692	29540022020000	9535	4944	2	0	\N
45494	1692	29540042020000	9535	4944	3	0	\N
45496	1692	30020328619999	18808	9478	3	0	\N
45498	1692	30020340619999	18808	9478	4	0	\N
45500	1692	30239792000000	3965	2060	1	0	\N
45502	1692	30239802000000	3965	2060	2	0	\N
45504	1692	30260042020000	9589	4974	2	0	\N
45506	1692	30260062020000	9589	4974	3	0	\N
45510	1692	30959812000000	4041	2098	3	0	\N
45512	1692	30959842000000	4041	2098	4	0	\N
45521	1692	32180369619999	19013	9586	2	0	\N
45522	1692	32180369619999	19061	9612	2	0	\N
45525	1692	32180380619999	19013	9586	3	0	\N
45526	1692	32180380619999	19061	9612	3	0	\N
45529	1692	32420133020000	9811	5086	9	0	\N
45532	1692	32420160020000	9811	5086	10	0	\N
45535	1692	33119832000000	4367	2264	1	0	\N
45537	1692	33119842000000	4367	2264	2	0	\N
45541	1692	33620391619999	19165	9667	3	0	\N
45543	1692	33620403619999	19165	9667	4	0	\N
45545	1692	33839932000000	4436	2299	2	0	\N
45546	1692	33839932000000	4464	2313	1	0	\N
45548	1692	33839942000000	4464	2313	2	0	\N
45550	1692	33839952000000	4436	2299	3	0	\N
45553	1692	34340403619999	19329	9746	11	0	\N
45556	1692	34340540619999	19329	9746	12	0	\N
45557	1692	34559942000000	4490	2326	1	0	\N
45558	1692	34559942000000	4506	2332	1	0	\N
45560	1692	34559952000000	4490	2326	2	0	\N
45441	1692	26639742000000	3359	1745	1	0	0
45444	1692	26639752000000	3359	1745	2	0	0
45449	1692	27359752000000	3539	1837	0	0	0
45460	1692	28079752000000	3670	1906	1	0	0
45461	1692	28079762000000	3670	1906	2	0	0
45481	1692	28799782000000	3932	2039	3	0	0
45490	1692	29519782000000	3947	2050	1	0	0
45491	1692	29519792000000	3947	2050	2	0	0
45501	1692	30239792000000	3998	2075	2	0	0
45503	1692	30239812000000	3998	2075	3	0	0
45517	1692	31679812000000	4318	2238	1	0	0
45518	1692	31679822000000	4318	2238	2	0	0
45527	1692	32399822000000	4322	2239	1	0	0
45528	1692	32399832000000	4322	2239	2	0	0
45538	1692	33119932000000	4412	2287	11	0	0
45547	1692	33839932000000	4476	2319	1	0	0
45549	1692	33839942000000	4476	2319	2	0	0
45559	1692	34559942000000	4518	2336	1	0	0
45435	1692	25939904000000	8893	4607	2	0	4
45445	1692	26659924000000	8895	4609	4	0	4
45446	1692	26659962020000	8895	4609	5	1	4
45452	1692	27379962020000	9134	4731	2	0	4
45454	1692	27379982020000	9134	4731	3	0	4
45463	1692	28099982020000	9199	4768	2	0	4
45484	1692	28820002020000	9414	4885	2	0	4
45486	1692	28820022020000	9414	4885	3	0	4
45493	1692	29540022020000	9560	4957	2	0	4
45495	1692	29540042020000	9560	4957	3	0	4
45507	1692	30260072020000	9631	4998	4	0	4
45513	1692	30980072020000	9661	5014	2	0	4
45514	1692	30980092020000	9661	5014	3	0	4
45519	1692	31700092020000	9674	5020	5	0	4
45520	1692	31700133020000	9674	5020	6	0	4
45531	1692	32420148019999	9825	5091	2	0	4
45539	1692	33140148019999	9831	5095	7	0	4
45540	1692	33140218019999	9831	5095	8	0	4
45551	1692	33860218019999	10021	5196	4	0	4
45552	1692	33860240019999	10021	5196	5	0	4
45427	1692	25700207619999	17769	8977	4	0	5
45437	1692	26420207619999	17771	8978	15	0	5
45438	1692	26420258619999	17771	8978	16	0	5
45447	1692	27140258619999	17982	9069	8	0	5
45456	1692	27860293619999	18144	9149	2	0	5
45457	1692	27860304619999	18144	9149	3	0	5
45470	1692	28580304619999	18722	9433	3	0	5
45474	1692	28580316619999	18722	9433	4	0	5
45488	1692	29300316619999	18765	9457	3	0	5
45497	1692	30020328619999	18845	9501	3	0	5
45499	1692	30020349619999	18845	9501	4	0	5
45508	1692	30740349619999	18848	9503	1	0	5
45509	1692	30740359619999	18848	9503	2	0	5
45515	1692	31460359619999	18936	9552	1	0	5
45523	1692	32180369619999	19075	9620	1	0	5
45524	1692	32180379619999	19075	9620	2	0	5
45533	1692	32900379619999	19136	9653	3	0	5
45534	1692	32900391619999	19136	9653	4	0	5
45544	1692	33620403619999	19253	9707	4	0	5
45554	1692	34340403619999	19335	9749	15	0	5
45555	1692	34340490619999	19335	9749	16	0	5
45425	1692	25661540819983	30316	14899	3	0	6
45561	1692	34559952000000	4506	2332	2	0	\N
45563	1692	34580240019999	10051	5212	2	0	\N
45564	1692	34580240019999	10064	5219	4	0	\N
45565	1692	34580240019999	10170	5269	2	0	\N
45566	1692	34580240019999	10214	5288	6	0	\N
45567	1692	34580240019999	10350	5356	4	0	\N
45568	1692	34580240019999	10396	5373	3	0	\N
45570	1692	34580260019999	10051	5212	3	0	\N
45571	1692	34580260019999	10170	5269	3	0	\N
45572	1692	34580270019999	10396	5373	4	0	\N
45573	1692	34580280019999	10064	5219	5	0	\N
45574	1692	34580280019999	10350	5356	5	0	\N
45575	1692	34580300019999	10214	5288	7	0	\N
45579	1692	35279952000000	4525	2341	1	0	\N
45581	1692	35279962000000	4525	2341	2	0	\N
45585	1692	35780527619999	19465	9811	4	0	\N
45586	1692	35780527619999	19513	9832	4	0	\N
45588	1692	35780540619999	19465	9811	5	0	\N
45589	1692	35780540619999	19513	9832	5	0	\N
45591	1692	35999982000000	4649	2401	1	0	\N
45592	1692	35999982000000	4701	2430	1	0	\N
45593	1692	35999982000000	4730	2445	2	0	\N
45595	1692	35999992000000	4649	2401	2	0	\N
45596	1692	35999992000000	4701	2430	2	0	\N
45598	1692	36000002000000	4730	2445	3	0	\N
45599	1692	36020400019999	10568	5457	2	0	\N
45600	1692	36020400019999	10603	5476	2	0	\N
45601	1692	36020400019999	10604	5477	2	0	\N
45602	1692	36020400019999	10703	5525	2	0	\N
45603	1692	36020400019999	10732	5538	2	0	\N
45604	1692	36020400019999	10767	5557	4	0	\N
45605	1692	36020400019999	10824	5585	3	0	\N
45606	1692	36020400019999	10838	5593	9	0	\N
45607	1692	36020400019999	11081	5700	2	0	\N
45609	1692	36020420019999	10568	5457	3	0	\N
45610	1692	36020420019999	10603	5476	3	0	\N
45611	1692	36020420019999	10604	5477	3	0	\N
45612	1692	36020420019999	10703	5525	3	0	\N
45613	1692	36020420019999	10732	5538	3	0	\N
45614	1692	36020420019999	11081	5700	3	0	\N
45616	1692	36020430019999	10824	5585	4	0	\N
45617	1692	36020440019999	10767	5557	5	0	\N
45618	1692	36020490019999	10838	5593	10	0	\N
45623	1692	36740420019999	11103	5711	9	0	\N
45626	1692	36740510019999	11103	5711	10	0	\N
45629	1692	37440032000000	4797	2482	1	0	\N
45630	1692	37440032000000	4818	2495	2	0	\N
45631	1692	37440032000000	4894	2535	1	0	\N
45633	1692	37440042000000	4797	2482	2	0	\N
45634	1692	37440042000000	4894	2535	2	0	\N
45636	1692	37440142000000	4818	2495	3	0	\N
45645	1692	38660601619999	19728	9931	6	0	\N
45648	1692	38660625619999	19728	9931	7	0	\N
45649	1692	38880072000000	5103	2649	1	0	\N
45651	1692	38880082000000	5103	2649	2	0	\N
45653	1692	38900521019999	11335	5822	2	0	\N
45655	1692	38900532019999	11335	5822	3	0	\N
45657	1692	39380623619999	19826	9988	2	0	\N
45659	1692	39380634619999	19826	9988	3	0	\N
45665	1692	40100636619999	19989	10065	5	0	\N
45666	1692	40100636619999	20001	10070	5	0	\N
45668	1692	40100659619999	19989	10065	6	0	\N
45670	1692	40100698619999	20098	10116	2	0	\N
45671	1692	40100749619999	20001	10070	6	0	\N
45672	1692	40320102000000	5283	2743	1	0	\N
45673	1692	40320102000000	5376	2796	0	0	\N
45675	1692	40320112000000	5283	2743	2	0	\N
45676	1692	40340543019999	11502	5908	6	0	\N
45679	1692	40340568019999	11502	5908	7	0	\N
45680	1692	40820678619999	20086	10111	12	0	\N
45681	1692	40820678619999	20092	10114	19	0	\N
45684	1692	40820698619999	20098	10116	8	0	\N
45685	1692	40820703619999	20098	10116	9	0	\N
45686	1692	40820780619999	20086	10111	13	0	\N
45687	1692	40820841619999	20092	10114	20	0	\N
45690	1692	41060544019999	11566	5945	1	0	\N
45691	1692	41060544019999	11571	5948	1	0	\N
45692	1692	41060544019999	11655	5994	1	0	\N
45693	1692	41060544019999	11679	6004	1	0	\N
45695	1692	41060545019999	11566	5945	2	0	\N
45696	1692	41060545019999	11571	5948	2	0	\N
45582	1692	35279982000000	4599	2379	4	0	0
45594	1692	35999982000000	4767	2463	1	0	0
45597	1692	35999992000000	4767	2463	2	0	0
45621	1692	36719992000000	4771	2465	4	0	0
45622	1692	36720032000000	4771	2465	5	0	0
45635	1692	37440052000000	4989	2586	3	0	0
45641	1692	38160052000000	5017	2603	2	0	0
45642	1692	38160072000000	5017	2603	3	0	0
45650	1692	38880072000000	5130	2659	2	0	0
45652	1692	38880092000000	5130	2659	3	0	0
45662	1692	39600102000000	5192	2699	2	0	0
45674	1692	40320102000000	5423	2821	0	0	0
45688	1692	41040102000000	5442	2831	1	0	0
45689	1692	41040103000000	5442	2831	2	0	0
45576	1692	34580380019999	10477	5416	6	0	4
45583	1692	35300380019999	10540	5445	2	0	4
45584	1692	35300400019999	10540	5445	3	0	4
45608	1692	36020400019999	11084	5702	2	0	4
45615	1692	36020420019999	11084	5702	3	0	4
45625	1692	36740470019999	11106	5712	6	0	4
45637	1692	37460470019999	11176	5741	4	0	4
45638	1692	37460510019999	11176	5741	5	0	4
45643	1692	38180510019999	11288	5798	2	0	4
45644	1692	38180521019999	11288	5798	3	0	4
45656	1692	38900532019999	11412	5862	3	0	4
45663	1692	39620532019999	11435	5873	2	0	4
45664	1692	39620543019999	11435	5873	3	0	4
45677	1692	40340543019999	11562	5943	1	0	4
45694	1692	41060544019999	11733	6030	1	0	4
45577	1692	35060490619999	19458	9808	10	0	5
45578	1692	35060527619999	19458	9808	11	0	5
45587	1692	35780527619999	19562	9853	4	0	5
45590	1692	35780540619999	19562	9853	5	0	5
45620	1692	36500564619999	19646	9894	7	0	5
45627	1692	37220564619999	19657	9901	7	0	5
45628	1692	37220589619999	19657	9901	8	0	5
45639	1692	37940589619999	19661	9904	3	0	5
45640	1692	37940601619999	19661	9904	4	0	5
45647	1692	38660623619999	19819	9983	5	0	5
45658	1692	39380623619999	19984	10063	4	0	5
45660	1692	39380636619999	19984	10063	5	0	5
45667	1692	40100636619999	20061	10100	15	0	5
45682	1692	40820678619999	20109	10121	2	0	5
45683	1692	40820689619999	20109	10121	3	0	5
45697	1692	41060545019999	11655	5994	2	0	\N
45698	1692	41060545019999	11679	6004	2	0	\N
45705	1692	42260733619999	20176	10159	5	0	\N
45706	1692	42260733619999	20293	10216	7	0	\N
45707	1692	42260733619999	20353	10250	3	0	\N
45708	1692	42260733619999	20438	10293	10	0	\N
45709	1692	42260733619999	20723	10419	0	0	\N
45711	1692	42260745619999	20353	10250	4	0	\N
45712	1692	42260747619999	20176	10159	6	0	\N
45713	1692	42260752619999	20438	10293	11	0	\N
45714	1692	42260758619999	20293	10216	8	0	\N
45716	1692	42480103000000	5471	2849	0	0	\N
45717	1692	42480103000000	5523	2873	0	0	\N
45718	1692	42480103000000	5538	2879	0	0	\N
45719	1692	42480103000000	5558	2890	0	0	\N
45721	1692	42500546019999	11759	6045	2	0	\N
45723	1692	42500548019999	11759	6045	3	0	\N
45735	1692	43940550019999	11795	6061	1	0	\N
45736	1692	43940550019999	11855	6093	1	0	\N
45737	1692	43940550019999	11900	6118	2	0	\N
45739	1692	43940551019999	11795	6061	2	0	\N
45740	1692	43940551019999	11855	6093	2	0	\N
45742	1692	43940552019999	11900	6118	3	0	\N
45745	1692	44640143000000	6012	3119	1	0	\N
45746	1692	44640153000000	6012	3119	2	0	\N
45749	1692	45140813619999	21028	10569	6	0	\N
45750	1692	45140813619999	21038	10572	2	0	\N
45751	1692	45140813619999	21046	10576	2	0	\N
45752	1692	45140813619999	21102	10598	1	0	\N
45754	1692	45140813619999	21620	10563	0	0	\N
45755	1692	45140823619999	21102	10598	2	0	\N
45756	1692	45140824619999	21038	10572	3	0	\N
45757	1692	45140824619999	21046	10576	3	0	\N
45759	1692	45140846619999	21028	10569	7	0	\N
45760	1692	45380552019999	11929	6140	1	0	\N
45761	1692	45380552019999	12003	6177	1	0	\N
45763	1692	45380553019999	11929	6140	2	0	\N
45764	1692	45380553019999	12003	6177	2	0	\N
45768	1692	46100555019999	12123	6244	1	0	\N
45769	1692	46100555019999	12221	6294	2	0	\N
45770	1692	46100555019999	12224	6296	1	0	\N
45772	1692	46100556019999	12123	6244	2	0	\N
45773	1692	46100556019999	12224	6296	2	0	\N
45774	1692	46100557019999	12221	6294	3	0	\N
45776	1692	46580837619999	21129	10612	2	0	\N
45777	1692	46580837619999	21139	10614	4	0	\N
45779	1692	46580848619999	21129	10612	3	0	\N
45780	1692	46580859619999	21139	10614	5	0	\N
45796	1692	49460949619999	21460	10767	3	0	\N
45797	1692	49460949619999	21494	10779	2	0	\N
45798	1692	49460949619999	21589	10823	3	0	\N
45800	1692	49460960619999	21494	10779	3	0	\N
45801	1692	49460961619999	21460	10767	4	0	\N
45802	1692	49460961619999	21589	10823	4	0	\N
45805	1692	50180989619999	21713	10876	2	0	\N
45806	1692	50180989619999	21762	10896	3	0	\N
45808	1692	50181000619999	21713	10876	3	0	\N
45809	1692	50181001619999	21762	10896	4	0	\N
45815	1692	51142302019999	12539	6462	2	0	\N
45817	1692	51142313019999	12539	6462	3	0	\N
45821	1692	51862317019999	12633	6517	2	0	\N
45822	1692	51862317019999	12648	6523	2	0	\N
45823	1692	51862317019999	12651	6525	7	0	\N
45824	1692	51862317019999	12717	6556	6	0	\N
45826	1692	51862328019999	12633	6517	3	0	\N
45827	1692	51862328019999	12648	6523	3	0	\N
45828	1692	51862350019999	12717	6556	7	0	\N
45830	1692	51862351019999	12651	6525	8	0	\N
45727	1692	43200103000000	5740	2974	1	0	0
45728	1692	43200113000000	5740	2974	2	0	0
45733	1692	43920113000000	5754	2983	3	0	0
45734	1692	43920143000000	5754	2983	4	0	0
45699	1692	41060545019999	11733	6030	2	0	4
45704	1692	41780546019999	11755	6043	2	0	4
45722	1692	42500546019999	11763	6047	2	0	4
45724	1692	42500548019999	11763	6047	3	0	4
45729	1692	43220548019999	11776	6054	2	0	4
45730	1692	43220550019999	11776	6054	3	0	4
45741	1692	43940551019999	11905	6122	2	0	4
45747	1692	44660551019999	11909	6126	1	0	4
45748	1692	44660552019999	11909	6126	2	0	4
45762	1692	45380552019999	12094	6226	3	0	4
45771	1692	46100555019999	12245	6306	4	0	4
45775	1692	46100586019999	12245	6306	5	0	4
45782	1692	46820586019999	12270	6318	7	0	4
45783	1692	46820728019999	12270	6318	8	0	4
45786	1692	47540728019999	12307	6339	1	0	4
45790	1692	48260729019999	12347	6365	4	0	4
45791	1692	48262230019999	12347	6365	5	0	4
45794	1692	48982230019999	12394	6393	2	0	4
45795	1692	48982241019999	12394	6393	3	0	4
45804	1692	49702241019999	12432	6409	0	0	4
45812	1692	50422302019999	12465	6422	8	0	4
45816	1692	51142302019999	12580	6484	6	0	4
45818	1692	51142317019999	12580	6484	7	0	4
45825	1692	51862317019999	12720	6559	6	0	4
45700	1692	41540689619999	20121	10129	7	0	5
45701	1692	41540733619999	20121	10129	8	0	5
45710	1692	42260733619999	20729	10420	10	0	5
45715	1692	42260770619999	20729	10420	11	0	5
45725	1692	42980770619999	20779	10442	2	0	5
45731	1692	43700781619999	20842	10474	3	0	5
45732	1692	43700802619999	20842	10474	4	0	5
45743	1692	44420802619999	20879	10496	2	0	5
45744	1692	44420813619999	20879	10496	3	0	5
45753	1692	45140813619999	21109	10601	4	0	5
45766	1692	45860835619999	21125	10610	2	0	5
45767	1692	45860837619999	21125	10610	3	0	5
45778	1692	46580837619999	21140	10615	7	0	5
45781	1692	46580871619999	21140	10615	8	0	5
45785	1692	47300893619999	21268	10679	5	0	5
45788	1692	48020893619999	21404	10736	7	0	5
45789	1692	48020937619999	21404	10736	8	0	5
45792	1692	48740937619999	21420	10742	3	0	5
45793	1692	48740949619999	21420	10742	4	0	5
45803	1692	49460989619999	21637	10839	5	0	5
45807	1692	50180989619999	21849	10934	9	0	5
45810	1692	50181025619999	21849	10934	10	0	5
45813	1692	50901025619999	21910	10963	3	0	5
45814	1692	50901037619999	21910	10963	4	0	5
45820	1692	51621049619999	21944	10978	4	0	5
45831	1692	52341049619999	21958	10985	9	0	5
45832	1692	52341085619999	21958	10985	10	0	5
45835	1692	53061085619999	21961	10986	3	0	\N
45837	1692	53061097619999	21961	10986	4	0	\N
45839	1692	53302360019999	13622	7003	1	0	\N
45840	1692	53302361019999	12779	6587	2	0	\N
45841	1692	53302361019999	12931	6664	2	0	\N
45842	1692	53302361019999	12937	6667	8	0	\N
45843	1692	53302361019999	12976	6689	3	0	\N
45844	1692	53302361019999	12998	6700	4	0	\N
45845	1692	53302361019999	13609	6996	0	0	\N
45847	1692	53302370019999	13622	7003	2	0	\N
45848	1692	53302372019999	12779	6587	3	0	\N
45849	1692	53302372019999	12931	6664	3	0	\N
45851	1692	53302382019999	12976	6689	4	0	\N
45852	1692	53302383019999	12998	6700	5	0	\N
45853	1692	53302405019999	12937	6667	9	0	\N
45858	1692	54501110619999	22089	11043	3	0	\N
45860	1692	54501122619999	22089	11043	4	0	\N
45873	1692	56661150619999	22204	11114	4	0	\N
45875	1692	56661163619999	22204	11114	5	0	\N
45879	1692	57381174619999	22308	11166	3	0	\N
45881	1692	57381186619999	22308	11166	4	0	\N
45883	1692	57622485019999	13888	7126	4	0	\N
45884	1692	57622485019999	13905	7131	4	0	\N
45886	1692	57622498019999	13888	7126	5	0	\N
45887	1692	57622498019999	13905	7131	5	0	\N
45889	1692	58101187619999	22560	11286	3	0	\N
45891	1692	58101199619999	22560	11286	4	0	\N
45895	1692	58821211619999	22648	11324	7	0	\N
45898	1692	58821236619999	22648	11324	8	0	\N
45899	1692	59062536019999	14052	7194	5	0	\N
45902	1692	59062550019999	14052	7194	6	0	\N
45905	1692	59782549019999	14096	7207	7	0	\N
45908	1692	59782565019999	14096	7207	8	0	\N
45909	1692	60261249619999	22812	11408	3	0	\N
45910	1692	60261249619999	22880	11436	4	0	\N
45912	1692	60261261619999	22812	11408	4	0	\N
45914	1692	60261262619999	22880	11436	5	0	\N
45915	1692	60502561019999	14265	7283	4	0	\N
45916	1692	60502561019999	14270	7285	4	0	\N
45918	1692	60502574019999	14265	7283	5	0	\N
45919	1692	60502574019999	14270	7285	5	0	\N
45925	1692	61701286619999	23260	11605	2	0	\N
45926	1692	61701286619999	23264	11608	3	0	\N
45927	1692	61701286619999	23325	11640	2	0	\N
45929	1692	61701297619999	23260	11605	3	0	\N
45930	1692	61701297619999	23325	11640	3	0	\N
45931	1692	61701298619999	23264	11608	4	0	\N
45941	1692	63382621019999	14427	7360	4	0	\N
45943	1692	63382634019999	14427	7360	5	0	\N
45949	1692	64581392619999	23776	11839	3	0	\N
45951	1692	64581404619999	23776	11839	4	0	\N
45953	1692	64822675019999	14479	7389	8	0	\N
45956	1692	64822701019999	14479	7389	9	0	\N
45959	1692	65542686019999	14571	7429	6	0	\N
45960	1692	65542686019999	14603	7444	3	0	\N
45961	1692	65542686019999	14654	7467	3	0	\N
45964	1692	65542698019999	14603	7444	4	0	\N
45965	1692	65542698019999	14654	7467	4	0	\N
45966	1692	65542719019999	14571	7429	7	0	\N
45967	1692	66021441619999	23879	11884	7	0	\N
45968	1692	66021441619999	24011	11948	4	0	\N
45846	1692	53302361019999	13679	7029	3	0	4
45850	1692	53302373019999	13679	7029	4	0	4
45856	1692	54022373019999	13822	7096	7	0	4
45857	1692	54022389019999	13822	7096	8	0	4
45862	1692	54742389019999	13855	7109	10	0	4
45866	1692	55462408019999	13873	7120	7	0	4
45867	1692	55462433019999	13873	7120	8	0	4
45868	1692	55462463019999	13875	7121	3	0	4
45871	1692	56182463019999	13875	7121	14	0	4
45872	1692	56182473019999	13875	7121	15	0	4
45878	1692	56902485019999	13885	7125	4	0	4
45885	1692	57622485019999	13955	7152	7	0	4
45888	1692	57622510019999	13955	7152	8	0	4
45893	1692	58342510019999	14039	7190	8	0	4
45900	1692	59062536019999	14064	7198	4	0	4
45901	1692	59062549019999	14064	7198	5	0	4
45906	1692	59782549019999	14250	7276	3	0	4
45907	1692	59782561019999	14250	7276	4	0	4
45917	1692	60502561019999	14291	7293	7	0	4
45923	1692	61222586019999	14371	7333	3	0	4
45924	1692	61222598019999	14371	7333	4	0	4
45933	1692	61942598019999	14394	7345	3	0	4
45934	1692	61942610019999	14394	7345	4	0	4
45937	1692	62662610019999	14423	7358	2	0	4
45942	1692	63382621019999	14432	7363	11	0	4
45944	1692	63382650019999	14432	7363	12	0	4
45947	1692	64102650019999	14458	7381	7	0	4
45948	1692	64102675019999	14458	7381	8	0	4
45955	1692	64822686019999	14529	7410	3	0	4
45962	1692	65542686019999	14762	7518	2	0	4
45963	1692	65542697019999	14762	7518	3	0	4
45836	1692	53061085619999	22034	11016	3	0	5
45838	1692	53061097619999	22034	11016	4	0	5
45855	1692	53781110619999	22057	11029	5	0	5
45859	1692	54501110619999	22127	11067	3	0	5
45861	1692	54501122619999	22127	11067	4	0	5
45864	1692	55221122619999	22129	11069	7	0	5
45865	1692	55221147619999	22129	11069	8	0	5
45870	1692	55941150619999	22198	11111	4	0	5
45874	1692	56661150619999	22251	11135	6	0	5
45876	1692	56661174619999	22251	11135	7	0	5
45880	1692	57381174619999	22378	11203	4	0	5
45890	1692	58101187619999	22636	11320	6	0	5
45892	1692	58101211619999	22636	11320	7	0	5
45896	1692	58821211619999	22746	11375	4	0	5
45897	1692	58821224619999	22746	11375	5	0	5
45903	1692	59541224619999	22790	11398	7	0	5
45911	1692	60261249619999	23046	11507	3	0	5
45913	1692	60261261619999	23046	11507	4	0	5
45921	1692	60981261619999	23124	11550	7	0	5
45922	1692	60981286619999	23124	11550	8	0	5
45928	1692	61701286619999	23422	11686	6	0	5
45935	1692	62421319619999	23463	11698	9	0	5
45936	1692	62421355619999	23463	11698	10	0	5
45939	1692	63141355619999	23596	11757	7	0	5
45940	1692	63141380619999	23596	11757	8	0	5
45946	1692	63861392619999	23736	11823	4	0	5
45950	1692	64581392619999	23840	11865	3	0	5
45952	1692	64581404619999	23840	11865	4	0	5
45957	1692	65301404619999	23875	11883	10	0	5
45958	1692	65301441619999	23875	11883	11	0	5
45971	1692	66021463619999	24011	11948	5	0	\N
45972	1692	66021466619999	23879	11884	8	0	\N
45975	1692	66741453619999	24212	12050	7	0	\N
45977	1692	66741478619999	24212	12050	8	0	\N
45981	1692	66982730019999	15043	7663	1	0	\N
45984	1692	67461572619999	24682	12260	5	0	\N
45985	1692	67702720019999	14977	7631	3	0	\N
45987	1692	67702730019999	15043	7663	4	0	\N
45989	1692	67702732019999	14977	7631	4	0	\N
45990	1692	67702732019999	15043	7663	5	0	\N
45991	1692	68181540619999	24515	12192	7	0	\N
45992	1692	68181540619999	24551	12204	2	0	\N
45993	1692	68181540619999	24758	12293	3	0	\N
45995	1692	68181551619999	24551	12204	3	0	\N
45996	1692	68181552619999	24758	12293	4	0	\N
45998	1692	68181572619999	24682	12260	12	0	\N
45999	1692	68181574619999	24515	12192	8	0	\N
46000	1692	68181578619999	24682	12260	13	0	\N
46005	1692	69862752019999	15164	7729	1	0	\N
46006	1692	69862752019999	15221	7754	5	0	\N
46007	1692	69862752019999	15270	7778	4	0	\N
46009	1692	69862762019999	15164	7729	2	0	\N
46011	1692	69862774019999	15270	7778	5	0	\N
46012	1692	69862775019999	15221	7754	6	0	\N
46015	1692	71302774019999	15527	7901	2	0	\N
46018	1692	71302785019999	15527	7901	3	0	\N
46019	1692	72022784019999	15669	7974	4	0	\N
46020	1692	72022784019999	15699	7984	4	0	\N
46022	1692	72022797019999	15669	7974	5	0	\N
46023	1692	72022797019999	15699	7984	5	0	\N
46025	1692	72742830019999	15784	8028	3	0	\N
46026	1692	72742830019999	15819	8050	5	0	\N
46028	1692	72742842019999	15784	8028	4	0	\N
46029	1692	72742862019999	15819	8050	6	0	\N
46031	1692	73462866019999	15927	8097	3	0	\N
46033	1692	73462878019999	15927	8097	4	0	\N
46039	1692	75622915019999	16041	8157	4	0	\N
46041	1692	75622928019999	16041	8157	5	0	\N
46047	1692	77782989019999	16203	8234	3	0	\N
46048	1692	77782989019999	16242	8255	3	0	\N
46049	1692	77782989019999	16378	8330	3	0	\N
46050	1692	77782989019999	16422	8352	4	0	\N
46051	1692	77782989019999	16427	8354	4	0	\N
46052	1692	77783001019999	16203	8234	4	0	\N
46053	1692	77783001019999	16242	8255	4	0	\N
46054	1692	77783001019999	16378	8330	4	0	\N
46055	1692	77783002019999	16422	8352	5	0	\N
46056	1692	77783002019999	16427	8354	5	0	\N
46057	1693	200000001	18193	9170	6	0	\N
46058	1693	200000003	17930	9044	5	0	\N
46059	1693	200002000	23450	11674	12	0	\N
46060	1693	719000000000	68	38	2	0	\N
46063	1693	719020000000	68	38	3	0	\N
46064	1693	742449053757	9302	4827	2	0	\N
46065	1693	742449053757	9310	4831	3	0	\N
46066	1693	742449053757	9328	4839	2	0	\N
46067	1693	742449053757	9329	4839	2	0	\N
46069	1693	742469053757	9302	4827	3	0	\N
46070	1693	742469053757	9328	4839	3	0	\N
46071	1693	742469053757	9329	4839	3	0	\N
46072	1693	742470053757	9310	4831	4	0	\N
46075	1693	765773623117	27493	13589	4	0	\N
46077	1693	859221758018	17741	8966	5	0	\N
46078	1693	859221758018	17742	8966	5	0	\N
46079	1693	859221758018	17743	8966	5	0	\N
46080	1693	902166908632	19726	9931	6	0	\N
46081	1693	902166908632	19739	9936	3	0	\N
46083	1693	902178908632	19739	9936	4	0	\N
46085	1693	902190908632	19726	9931	7	0	\N
46090	1693	1439010000000	113	68	1	0	\N
46092	1693	1439020000000	113	68	2	0	\N
46096	1693	1467946500877	3383	1760	1	0	\N
46097	1693	1467946500877	3385	1760	0	0	\N
46099	1693	1467956500877	3383	1760	2	0	\N
46100	1693	1485777623117	27663	13671	8	0	\N
46103	1693	1485803623117	27663	13671	9	0	\N
46104	1693	1494413003699	11269	5790	8	0	\N
46091	1693	1439010000000	235	139	2	0	0
46093	1693	1439030000000	235	139	3	0	0
46086	1693	1038357500454	1127	621	1	0	115
46087	1693	1038367500454	1127	621	2	0	115
46098	1693	1467946500877	3406	1772	0	0	227
46089	1693	1041421551364	4423	2293	2	0	341
46068	1693	742449053757	9373	4863	4	0	562
46073	1693	742480053757	9373	4863	5	0	562
46094	1693	1462480053757	9513	4933	2	0	562
46095	1693	1462500053757	9513	4933	3	0	562
45974	1692	66262708019999	14790	7533	3	0	4
45979	1692	66982708019999	14969	7625	3	0	4
45980	1692	66982720019999	14969	7625	4	0	4
45986	1692	67702720019999	15073	7676	1	0	4
46001	1692	68422730019999	15105	7697	2	0	4
46002	1692	68422741019999	15105	7697	3	0	4
46003	1692	69142741019999	15128	7710	2	0	4
46004	1692	69142752019999	15128	7710	3	0	4
46008	1692	69862752019999	15370	7830	2	0	4
46013	1692	70582763019999	15422	7855	2	0	4
46014	1692	70582774019999	15422	7855	3	0	4
46016	1692	71302774019999	15576	7928	1	0	4
46017	1692	71302784019999	15576	7928	2	0	4
46021	1692	72022784019999	15773	8023	10	0	4
46027	1692	72742830019999	15895	8082	9	0	4
46030	1692	72742866019999	15895	8082	10	0	4
46032	1692	73462866019999	15949	8108	6	0	4
46034	1692	73462890019999	15949	8108	7	0	4
46036	1692	74182902019999	15991	8129	4	0	4
46037	1692	74902902019999	16003	8138	4	0	4
46038	1692	74902915019999	16003	8138	5	0	4
46040	1692	75622915019999	16097	8182	6	0	4
46042	1692	75622939019999	16097	8182	7	0	4
46044	1692	76342964019999	16125	8198	8	0	4
46045	1692	77062964019999	16136	8203	7	0	4
46046	1692	77062989019999	16136	8203	8	0	4
46082	1693	902166908632	19775	9958	3	0	979
46084	1693	902178908632	19775	9958	4	0	979
45970	1692	66021453619999	24106	12000	4	0	5
45976	1692	66741453619999	24275	12077	4	0	5
45978	1692	66741515619999	24275	12077	5	0	5
45982	1692	67461515619999	24317	12093	7	0	5
45994	1692	68181540619999	24773	12300	3	0	5
45997	1692	68181552619999	24773	12300	4	0	5
46074	1693	765753623117	27572	13628	6	0	1383
46076	1693	765777623117	27572	13628	7	0	1383
46101	1693	1485777623117	27693	13684	3	0	1383
46107	1693	1494484003699	11269	5790	9	0	\N
46108	1693	1579198758018	17553	8887	3	0	\N
46109	1693	1579198758018	17656	8926	2	0	\N
46110	1693	1579198758018	17760	8973	3	0	\N
46112	1693	1579209758018	17656	8926	3	0	\N
46113	1693	1579210758018	17553	8887	4	0	\N
46114	1693	1579210758018	17760	8973	4	0	\N
46116	1693	1579221758018	17741	8966	8	0	\N
46117	1693	1579221758018	17742	8966	8	0	\N
46118	1693	1579221758018	17743	8966	8	0	\N
46119	1693	1579223758018	17741	8966	9	0	\N
46120	1693	1579223758018	17742	8966	9	0	\N
46121	1693	1579223758018	17743	8966	9	0	\N
46124	1693	1622178908632	19804	9973	10	0	\N
46125	1693	1622178908632	20049	10092	3	0	\N
46127	1693	1622190908632	20049	10092	4	0	\N
46129	1693	1622224908632	19804	9973	11	0	\N
46132	1693	1646217293536	22527	11270	6	0	\N
46135	1693	1646241293536	22527	11270	7	0	\N
46138	1693	1759821551364	4560	2356	5	0	\N
46145	1693	2159030000000	276	160	1	0	\N
46147	1693	2159040000000	276	160	2	0	\N
46149	1693	2182500053757	9564	4960	3	0	\N
46150	1693	2182500053757	9641	5002	2	0	\N
46152	1693	2182520053757	9641	5002	3	0	\N
46153	1693	2182521053757	9564	4960	4	0	\N
46155	1693	2187946500877	3422	1779	1	0	\N
46157	1693	2187956500877	3422	1779	2	0	\N
46160	1693	2299210758018	17925	9042	3	0	\N
46161	1693	2299210758018	17929	9044	4	0	\N
46162	1693	2299210758018	17930	9044	4	0	\N
46163	1693	2299210758018	17931	9044	4	0	\N
46164	1693	2299210758018	18138	9145	7	0	\N
46167	1693	2299222758018	17925	9042	4	0	\N
46168	1693	2299223758018	17929	9044	5	0	\N
46169	1693	2299223758018	17931	9044	5	0	\N
46170	1693	2299244758018	18138	9145	8	0	\N
46171	1693	2300239406843	14933	7609	5	0	\N
46174	1693	2300262406843	14933	7609	6	0	\N
46175	1693	2342202908632	20163	10150	13	0	\N
46176	1693	2342202908632	20203	10176	3	0	\N
46177	1693	2342202908632	20215	10181	7	0	\N
46179	1693	2342214908632	20203	10176	4	0	\N
46181	1693	2342227908632	20215	10181	8	0	\N
46182	1693	2342278908632	20163	10150	14	0	\N
46183	1693	2349655825590	30057	14797	20	0	\N
46184	1693	2349655825590	30177	14847	19	0	\N
46185	1693	2349655825590	30178	14847	10	0	\N
46186	1693	2349655825590	30231	14865	10	0	\N
46189	1693	2349674825590	30231	14865	11	0	\N
46190	1693	2349683825590	30178	14847	11	0	\N
46191	1693	2349692825590	30177	14847	20	0	\N
46192	1693	2349693825590	30057	14797	21	0	\N
46193	1693	2478267500454	1364	747	2	0	\N
46194	1693	2478267500454	1438	783	2	0	\N
46195	1693	2478267500454	1443	785	2	0	\N
46196	1693	2478267500454	1455	793	2	0	\N
46198	1693	2478278500454	1364	747	3	0	\N
46199	1693	2478278500454	1455	793	3	0	\N
46200	1693	2478287500454	1438	783	3	0	\N
46201	1693	2478287500454	1443	785	3	0	\N
46203	1693	2478377500454	1192	658	2	0	\N
46204	1693	2478377500454	1262	698	4	0	\N
46205	1693	2478397500454	1192	658	3	0	\N
46206	1693	2478417500454	1262	698	5	0	\N
46208	1693	2479821551364	4560	2356	15	0	\N
46209	1693	2480451551364	4560	2356	16	0	\N
46210	1693	2765785623117	27493	13589	5	0	\N
46211	1693	2793369155041	11338	5823	4	0	\N
46212	1693	2793369155041	11355	5832	2	0	\N
46214	1693	2793380155041	11355	5832	3	0	\N
46216	1693	2793391155041	11338	5823	5	0	\N
46217	1693	2836684292484	22615	11313	4	0	\N
46218	1693	2836684292484	22623	11316	4	0	\N
46221	1693	2836697292484	22615	11313	5	0	\N
46222	1693	2836697292484	22623	11316	5	0	\N
46223	1693	2870765570272	24768	12297	2	0	\N
46224	1693	2870776570272	24768	12297	3	0	\N
46225	1693	2870920570272	24767	12297	3	0	\N
46228	1693	2870932570272	24767	12297	4	0	\N
46229	1693	2873597553123	7432	3840	1	0	\N
46231	1693	2873607553123	7432	3840	2	0	\N
46233	1693	2879060000000	326	187	2	0	\N
46235	1693	2879080000000	326	187	3	0	\N
46237	1693	2902530053757	9804	5083	2	0	\N
46239	1693	2902550053757	9804	5083	3	0	\N
46234	1693	2879060000000	370	210	2	0	0
46236	1693	2879080000000	370	210	3	0	0
46136	1693	1758367500454	1140	629	1	0	115
46137	1693	1758377500454	1140	629	2	0	115
46197	1693	2478267500454	1475	805	5	0	116
46156	1693	2187946500877	3423	1779	0	0	227
46139	1693	1760311551364	4471	2317	3	0	342
46140	1693	1760431551364	4471	2317	4	0	342
46207	1693	2479321551364	4557	2357	0	0	343
46230	1693	2873597553123	7464	3861	1	0	457
46151	1693	2182500053757	9736	5044	3	0	562
46154	1693	2182530053757	9736	5044	4	0	562
46238	1693	2902530053757	9805	5083	2	0	562
46240	1693	2902550053757	9805	5083	3	0	562
46106	1693	1494414003699	11275	5792	2	0	664
46141	1693	2073347155041	11293	5801	4	0	666
46142	1693	2073369155041	11293	5801	5	0	666
46213	1693	2793369155041	11423	5868	2	0	666
46215	1693	2793380155041	11423	5868	3	0	666
46123	1693	1580239406843	14815	7549	3	0	772
46172	1693	2300239406843	14966	7624	1	0	772
46173	1693	2300249406843	14966	7624	2	0	772
46111	1693	1579198758018	17915	9036	3	0	875
46115	1693	1579210758018	17915	9036	4	0	875
46166	1693	2299221758018	18179	9167	3	0	875
46126	1693	1622178908632	20158	10147	6	0	979
46128	1693	1622202908632	20158	10147	7	0	979
46178	1693	2342202908632	20250	10199	3	0	979
46133	1693	1646217293536	22528	11270	4	0	1108
46134	1693	1646239293536	22528	11270	5	0	1108
46143	1693	2116072292484	22585	11299	9	0	1117
46144	1693	2116684292484	22585	11299	10	0	1117
46219	1693	2836684292484	22680	11340	3	0	1117
46226	1693	2870920570272	25009	12407	2	0	1248
46227	1693	2870931570272	25009	12407	3	0	1248
46158	1693	2205789623117	27695	13685	2	0	1383
46159	1693	2205800623117	27695	13685	3	0	1383
46130	1693	1629642825590	29960	14756	4	0	1514
46187	1693	2349655825590	30237	14865	5	0	1514
46188	1693	2349660825590	30237	14865	6	0	1514
46242	1693	2925800623117	27713	13693	4	0	\N
46245	1693	2925822623117	27713	13693	5	0	\N
46247	1693	3019221758018	18193	9170	5	0	\N
46248	1693	3019221758018	18196	9170	5	0	\N
46254	1693	3069660825590	30308	14897	2	0	\N
46255	1693	3069660825590	30312	14897	1	0	\N
46256	1693	3069670825590	30312	14897	2	0	\N
46257	1693	3069671825590	30308	14897	3	0	\N
46264	1693	3556696292484	22795	11401	6	0	\N
46265	1693	3556696292484	23129	11552	5	0	\N
46266	1693	3556696292484	23196	11579	3	0	\N
46267	1693	3556696292484	23197	11579	1	0	\N
46269	1693	3556696292484	23338	11453	0	0	\N
46270	1693	3556697292484	23197	11579	2	0	\N
46272	1693	3556708292484	23196	11579	4	0	\N
46273	1693	3556710292484	23129	11552	6	0	\N
46274	1693	3556720292484	22795	11401	7	0	\N
46275	1693	3589931570248	25238	12518	0	0	\N
46276	1693	3590931570272	25122	12465	3	0	\N
46277	1693	3590931570272	25239	12518	8	0	\N
46278	1693	3590931570272	25366	12577	4	0	\N
46279	1693	3590931570272	25387	12585	3	0	\N
46280	1693	3590931570272	25620	12576	0	0	\N
46282	1693	3590943570272	25122	12465	4	0	\N
46283	1693	3590943570272	25387	12585	4	0	\N
46284	1693	3590944570272	25366	12577	5	0	\N
46286	1693	3590957570272	25239	12518	9	0	\N
46295	1693	3645812623117	27923	13811	2	0	\N
46296	1693	3645823623117	27923	13811	3	0	\N
46298	1693	3739244758018	18243	9188	5	0	\N
46300	1693	3739267758018	18243	9188	6	0	\N
46306	1693	3918327500454	1585	861	1	0	\N
46307	1693	3918327500454	1677	900	1	0	\N
46309	1693	3918337500454	1585	861	2	0	\N
46310	1693	3918337500454	1677	900	2	0	\N
46312	1693	3919111551364	4727	2445	2	0	\N
46313	1693	3919111551364	4852	2515	2	0	\N
46314	1693	3919111551364	4868	2522	1	0	\N
46315	1693	3919111551364	4927	2550	1	0	\N
46317	1693	3919121551364	4868	2522	2	0	\N
46318	1693	3919121551364	4927	2550	2	0	\N
46319	1693	3919131551364	4727	2445	3	0	\N
46321	1693	3919221551364	4852	2515	3	0	\N
46322	1693	4233391155041	11561	5943	1	0	\N
46324	1693	4233391155041	11716	5913	0	0	\N
46325	1693	4233391155041	11717	5923	0	0	\N
46326	1693	4233392155041	11561	5943	2	0	\N
46332	1693	4313617553123	7519	3893	3	0	\N
46335	1693	4313647553123	7519	3893	4	0	\N
46336	1693	4316560000000	483	270	1	0	\N
46337	1693	4316560000000	515	288	1	0	\N
46339	1693	4316570000000	483	270	2	0	\N
46340	1693	4316570000000	515	288	2	0	\N
46342	1693	4342570053757	9827	5093	8	0	\N
46345	1693	4342731053757	9827	5093	9	0	\N
46347	1693	4365824623117	27957	13831	3	0	\N
46350	1693	4365836623117	27957	13831	4	0	\N
46351	1693	4459267758018	18343	9242	2	0	\N
46354	1693	4459278758018	18343	9242	3	0	\N
46355	1693	4460281406843	15235	7760	2	0	\N
46356	1693	4460281406843	15264	7776	1	0	\N
46358	1693	4460291406843	15264	7776	2	0	\N
46359	1693	4460292406843	15235	7760	3	0	\N
46361	1693	4502250908632	20433	10292	6	0	\N
46364	1693	4502265908632	20433	10292	7	0	\N
46365	1693	4638337500454	1734	931	1	0	\N
46367	1693	4638347500454	1734	931	2	0	\N
46371	1693	4953392155041	11668	5999	1	0	\N
46373	1693	4953392155041	11721	6001	5	0	\N
46374	1693	4953393155041	11668	5999	2	0	\N
46376	1693	4953532155041	11721	6001	6	0	\N
46338	1693	4316560000000	613	345	1	0	5
46341	1693	4316570000000	613	345	2	0	5
46258	1693	3198317500454	1506	826	1	0	116
46259	1693	3198327500454	1506	826	2	0	116
46308	1693	3918327500454	1687	906	1	0	116
46366	1693	4638337500454	1797	961	1	0	116
46368	1693	4638347500454	1797	961	2	0	116
46241	1693	2907946500877	3454	1793	0	0	227
46293	1693	3627946500877	3482	1808	0	0	227
46346	1693	4347946500877	3585	1862	0	0	227
46261	1693	3199331551364	4574	2367	2	0	343
46316	1693	3919111551364	5048	2618	4	0	345
46320	1693	3919151551364	5048	2618	5	0	345
46369	1693	4639041551364	5163	2679	1	0	346
46287	1693	3593607553123	7515	3890	1	0	457
46288	1693	3593617553123	7515	3890	2	0	457
46333	1693	4313617553123	7637	3953	1	0	457
46334	1693	4313627553123	7637	3953	2	0	457
46291	1693	3622550053757	9816	5088	2	0	562
46343	1693	4342570053757	9828	5093	1	0	562
46344	1693	4342670053757	9828	5093	2	0	562
46262	1693	3513380155041	11461	5889	2	0	666
46263	1693	3513391155041	11461	5889	3	0	666
46323	1693	4233391155041	11656	5995	1	0	666
46372	1693	4953392155041	11688	6009	1	0	666
46375	1693	4953393155041	11688	6009	2	0	666
46250	1693	3020249406843	15182	7736	3	0	772
46251	1693	3020270406843	15182	7736	4	0	772
46303	1693	3740281406843	15215	7752	3	0	772
46357	1693	4460281406843	15434	7861	5	0	772
46360	1693	4460304406843	15434	7861	6	0	772
46246	1693	3019221758018	18189	9170	5	0	875
46249	1693	3019244758018	18189	9170	6	0	875
46301	1693	3739267758018	18274	9206	6	0	875
46352	1693	4459267758018	18344	9242	2	0	875
46353	1693	4459278757818	18344	9242	3	0	875
46252	1693	3062214908632	20299	10220	3	0	979
46253	1693	3062226908632	20299	10220	4	0	979
46305	1693	3782250908632	20407	10282	7	0	979
46362	1693	4502250908632	20434	10292	5	0	979
46363	1693	4502264908632	20434	10292	6	0	979
46268	1693	3556696292484	23208	11585	2	0	1117
46328	1693	4276707292484	23337	11645	2	0	1117
46329	1693	4276718292484	23337	11645	3	0	1117
46281	1693	3590931570272	25621	12679	6	0	1248
46285	1693	3590955570272	25621	12679	7	0	1248
46330	1693	4310955570272	25688	12710	2	0	1248
46243	1693	2925800623117	27828	13754	3	0	1383
46244	1693	2925812623117	27828	13754	4	0	1383
46294	1693	3645812623117	27922	13811	3	0	1383
46297	1693	3645824623117	27922	13811	4	0	1383
46348	1693	4365824623117	27958	13831	2	0	1383
46377	1693	4970623377293	3318	1720	2	0	\N
46378	1693	4970643377293	3318	1720	3	0	\N
46379	1693	4996718292484	23395	11671	2	0	\N
46380	1693	4996718292484	23396	11671	4	0	\N
46382	1693	4996718292484	23421	11673	37	0	\N
46383	1693	4996720292484	23395	11671	3	0	\N
46385	1693	4996740292484	23396	11671	5	0	\N
46386	1693	4996926292484	23421	11673	38	0	\N
46387	1693	4996946292484	23450	11674	2	0	\N
46396	1693	5067946500877	3594	1868	0	0	\N
46397	1693	5067946500877	3598	1869	0	0	\N
46399	1693	5085826623117	28039	13867	2	0	\N
46401	1693	5085837623117	28039	13867	3	0	\N
46407	1693	5180359406843	15512	7894	1	0	\N
46409	1693	5222264908632	20457	10302	3	0	\N
46410	1693	5222264908632	20512	10327	2	0	\N
46411	1693	5222264908632	20513	10327	3	0	\N
46412	1693	5222264908632	20537	10337	6	0	\N
46414	1693	5222275908632	20512	10327	3	0	\N
46415	1693	5222276908632	20457	10302	4	0	\N
46416	1693	5222276908632	20513	10327	4	0	\N
46417	1693	5222288908632	20537	10337	7	0	\N
46423	1693	5673393155041	11714	6024	1	0	\N
46425	1693	5673393155041	11722	6011	0	0	\N
46426	1693	5673393155041	11723	6021	0	0	\N
46427	1693	5673393155041	11724	6023	0	0	\N
46428	1693	5673394155041	11714	6024	2	0	\N
46432	1693	5716946292484	23450	11674	11	0	\N
46444	1693	5826643081103	24728	12281	3	0	\N
46445	1693	5826655081103	24728	12281	4	0	\N
46446	1693	5899289757818	18399	9275	4	0	\N
46448	1693	5899311757818	18399	9275	5	0	\N
46450	1693	5900359406843	15512	7894	6	0	\N
46453	1693	5900381406843	15512	7894	7	0	\N
46454	1693	5942636908632	21123	10610	2	0	\N
46456	1693	5942636908632	21347	10549	0	0	\N
46457	1693	5942638908632	21123	10610	3	0	\N
46459	1693	6078257500454	2075	1096	1	0	\N
46460	1693	6078257500454	2185	1152	2	0	\N
46461	1693	6078257500454	2189	1154	1	0	\N
46462	1693	6078257500454	2298	1206	1	0	\N
46464	1693	6078267500454	2075	1096	2	0	\N
46465	1693	6078267500454	2189	1154	2	0	\N
46466	1693	6078267500454	2298	1206	2	0	\N
46468	1693	6078277500454	2185	1152	3	0	\N
46471	1693	6393393155041	11915	6024	25	0	\N
46474	1693	6393634155041	11915	6024	26	0	\N
46475	1693	6436740292484	23698	11802	11	0	\N
46478	1693	6436778292484	23698	11802	12	0	\N
46481	1693	6471002570272	25815	12765	6	0	\N
46482	1693	6471002570272	26214	12961	4	0	\N
46483	1693	6471002570272	26223	12965	7	0	\N
46486	1693	6471015570272	26214	12961	5	0	\N
46487	1693	6471026570272	25815	12765	7	0	\N
46488	1693	6471027570272	26223	12965	8	0	\N
46489	1693	6473577553123	8004	4148	2	0	\N
46492	1693	6473597553123	8004	4148	3	0	\N
46493	1693	6475580000000	776	431	2	0	\N
46494	1693	6475580000000	840	463	2	0	\N
46497	1693	6475600000000	840	463	3	0	\N
46498	1693	6475690000000	776	431	3	0	\N
46499	1693	6502730053757	9987	5178	6	0	\N
46500	1693	6502730053757	10104	5243	2	0	\N
46502	1693	6502750053757	10104	5243	3	0	\N
46504	1693	6502790053757	9987	5178	7	0	\N
46506	1693	6525850623117	28251	13968	6	0	\N
46507	1693	6525850623117	28260	13972	3	0	\N
46509	1693	6525862623117	28260	13972	4	0	\N
46511	1693	6525874623117	28251	13968	7	0	\N
46512	1693	6619312757818	19014	9587	2	0	\N
46437	1693	5756580000000	760	424	1	0	5
46438	1693	5756590000000	760	424	2	0	5
46495	1693	6475580000000	842	464	1	0	6
46496	1693	6475590000000	842	464	2	0	6
46419	1693	5358237500454	2024	1067	2	0	117
46463	1693	6078257500454	2376	1242	1	0	117
46467	1693	6078267500454	2376	1242	2	0	117
46398	1693	5067946500877	3610	1873	0	0	227
46441	1693	5787946500877	3623	1879	0	0	227
46505	1693	6507946500877	3659	1900	0	0	227
46422	1693	5359061551364	5185	2694	2	0	346
46469	1693	6079061551364	5244	2721	1	0	346
46470	1693	6079071551364	5244	2721	2	0	346
46390	1693	5033627553123	7786	4037	3	0	457
46435	1693	5753547553123	7982	4136	3	0	458
46436	1693	5753577553123	7982	4136	4	0	458
46490	1693	6473577553123	8023	4160	1	0	458
46491	1693	6473587553123	8023	4160	2	0	458
46394	1693	5062670053757	9895	5129	4	0	562
46439	1693	5782710053757	9935	5157	2	0	562
46440	1693	5782730053757	9935	5157	3	0	562
46501	1693	6502730053757	10218	5290	4	0	562
46503	1693	6502770053757	10218	5290	5	0	562
46424	1693	5673393155041	11720	6026	1	0	666
46472	1693	6393394155041	11917	6130	1	0	666
46473	1693	6393395155041	11917	6130	2	0	666
46405	1693	5180304406843	15504	7891	8	0	772
46406	1693	5180339406843	15504	7891	9	0	772
46451	1693	5900359406843	15515	7894	5	0	772
46452	1693	5900371406843	15515	7894	6	0	772
46403	1693	5179278757818	18396	9272	2	0	875
46404	1693	5179289757818	18396	9272	3	0	875
46447	1693	5899289757818	18625	9385	5	0	875
46413	1693	5222264908632	20696	10409	6	0	979
46418	1693	5222636908632	20696	10409	7	0	979
46455	1693	5942636908632	21257	10674	2	0	979
46458	1693	5942647908632	21257	10674	3	0	979
46381	1693	4996718292484	23420	11685	2	0	1117
46430	1693	5716729292484	23449	11693	2	0	1117
46431	1693	5716740292484	23449	11693	3	0	1117
46476	1693	6436740292484	23699	11802	8	0	1117
46477	1693	6436755292484	23699	11802	9	0	1117
46480	1693	6453639746011	24723	12278	45	0	1197
46388	1693	5030966570272	25752	12739	3	0	1248
46389	1693	5030978570272	25752	12739	4	0	1248
46433	1693	5750978570272	25781	12751	6	0	1248
46434	1693	5751002570272	25781	12751	7	0	1248
46485	1693	6471014570272	26249	12977	4	0	1248
46400	1693	5085826623117	28040	13867	3	0	1383
46402	1693	5085838623117	28040	13867	4	0	1383
46442	1693	5805838623117	28116	13899	3	0	1383
46443	1693	5805850623117	28116	13899	4	0	1383
46510	1693	6525873623117	28297	13987	6	0	1383
46513	1693	6619312757818	19551	9681	79	0	\N
46515	1693	6619323757818	19014	9587	3	0	\N
46517	1693	6619909757818	19551	9681	80	0	\N
46518	1693	6620371406843	15562	7905	0	0	\N
46519	1693	6620371406843	15563	7921	1	0	\N
46521	1693	6620381406843	15563	7921	2	0	\N
46523	1693	6662647908632	21345	10713	6	0	\N
46524	1693	6662647908632	21423	10744	3	0	\N
46526	1693	6662659908632	21423	10744	4	0	\N
46527	1693	6662671908632	21345	10713	7	0	\N
46529	1693	6797157500454	2526	1328	1	0	\N
46531	1693	6797167500454	2526	1328	2	0	\N
46533	1693	6798267500454	2401	1256	1	0	\N
46534	1693	6798277500454	2401	1256	2	0	\N
46541	1693	7191014570272	26315	13016	3	0	\N
46543	1693	7191026570272	26315	13016	4	0	\N
46545	1693	7193587553123	8067	4180	2	0	\N
46546	1693	7193587553123	8164	4232	0	0	\N
46549	1693	7193598553123	8067	4180	3	0	\N
46554	1693	7226836500877	3680	1911	1	0	\N
46555	1693	7226836500877	3752	1919	1	0	\N
46556	1693	7226837500877	3752	1919	2	0	\N
46557	1693	7226846500877	3680	1911	2	0	\N
46559	1693	7245873623117	28428	14041	37	0	\N
46561	1693	7246077123117	28428	14041	38	0	\N
46562	1693	7339336757818	19585	9865	4	0	\N
46564	1693	7339349757818	19585	9865	5	0	\N
46566	1693	7340383406843	15901	8086	6	0	\N
46567	1693	7340383406843	15979	8122	3	0	\N
46568	1693	7340383406843	16005	8139	10	0	\N
46569	1693	7340383406843	16060	8168	4	0	\N
46570	1693	7340383406843	16062	8168	4	0	\N
46571	1693	7340383406843	16248	8258	2	0	\N
46573	1693	7340394406843	16248	8258	3	0	\N
46574	1693	7340395406843	15979	8122	4	0	\N
46575	1693	7340396406843	16060	8168	5	0	\N
46576	1693	7340396406843	16062	8168	5	0	\N
46578	1693	7340407406843	15901	8086	7	0	\N
46579	1693	7340420406843	16005	8139	11	0	\N
46582	1693	7517167500454	2656	1397	1	0	\N
46583	1693	7517167500454	2734	1436	2	0	\N
46585	1693	7517177500454	2656	1397	2	0	\N
46587	1693	7517187500454	2734	1436	3	0	\N
46588	1693	7519101551364	5384	2803	0	0	\N
46594	1693	7876781292484	23772	11837	4	0	\N
46596	1693	7876803292484	23772	11837	5	0	\N
46599	1693	7913597553123	8223	4262	1	0	\N
46601	1693	7913607553123	8223	4262	2	0	\N
46605	1693	7946736500877	3767	1954	2	0	\N
46608	1693	7946756500877	3767	1954	3	0	\N
46609	1693	7965884623117	28493	14081	2	0	\N
46610	1693	7965884623117	28520	14092	3	0	\N
46612	1693	7965895623117	28493	14081	3	0	\N
46613	1693	7965896623117	28520	14092	4	0	\N
46615	1693	8060396406843	16288	8276	3	0	\N
46617	1693	8060408406843	16288	8276	4	0	\N
46619	1693	8101573908632	21706	10873	5	0	\N
46621	1693	8101695908632	21706	10873	6	0	\N
46623	1693	8102683908632	21542	10803	10	0	\N
46624	1693	8102720908632	21542	10803	11	0	\N
46627	1693	8239201551364	5529	2876	0	0	\N
46629	1693	8553397155041	12219	6294	2	0	\N
46630	1693	8553397155041	12341	6361	2	0	\N
46631	1693	8553397155041	12407	6401	1	0	\N
46633	1693	8553398155041	12407	6401	2	0	\N
46634	1693	8553399155041	12219	6294	3	0	\N
46635	1693	8553399155041	12341	6361	3	0	\N
46637	1693	8596803092484	23786	11843	4	0	\N
46638	1693	8596803092484	23932	11910	3	0	\N
46640	1693	8596815092484	23932	11910	4	0	\N
46641	1693	8596816092484	23786	11843	5	0	\N
46584	1693	7517167500454	2812	1471	1	0	118
46586	1693	7517177500454	2812	1471	2	0	118
46625	1693	8237177500454	2975	1547	2	0	118
46626	1693	8237197500454	2975	1547	3	0	118
46552	1693	7226726500877	3753	1946	1	0	229
46606	1693	7946736500877	3959	2059	1	0	229
46607	1693	7946746500877	3959	2059	2	0	229
46535	1693	6799071551364	5344	2773	3	0	346
46536	1693	6799101551364	5344	2773	4	0	346
46589	1693	7519101551364	5504	2863	1	0	346
46628	1693	8239201551364	5581	2903	0	0	346
46547	1693	7193587553123	8165	4232	1	0	458
46548	1693	7193597553123	8165	4232	2	0	458
46600	1693	7913597553123	8505	4406	1	0	458
46645	1693	8633607553123	8525	4417	1	0	458
46646	1693	8633617553123	8525	4417	2	0	458
46550	1693	7222660053757	10312	5335	3	0	563
46551	1693	7222681053757	10312	5335	4	0	563
46603	1693	7942681053757	10332	5347	6	0	563
46647	1693	8662741053757	10393	5373	2	0	563
46648	1693	8662761053757	10393	5373	3	0	563
46537	1693	7113395155041	12005	6179	1	0	666
46538	1693	7113396155041	12005	6179	2	0	666
46591	1693	7833396155041	12017	6185	1	0	666
46632	1693	8553397155041	12586	6488	4	0	666
46636	1693	8553419155041	12586	6488	5	0	666
46520	1693	6620371406843	15869	8071	3	0	772
46522	1693	6620383406843	15869	8071	4	0	772
46577	1693	7340396406843	16253	8260	5	0	772
46616	1693	8060396406843	16405	8345	3	0	772
46618	1693	8060408406843	16405	8345	4	0	772
46514	1693	6619312757818	19552	9848	6	0	875
46516	1693	6619336757818	19552	9848	7	0	875
46565	1693	7339361757818	19624	9884	8	0	875
46525	1693	6662647908632	21427	10746	6	0	979
46528	1693	6662671908632	21427	10746	7	0	979
46580	1693	7382671908632	21525	10798	3	0	979
46581	1693	7382683908632	21525	10798	4	0	979
46622	1693	8101698908632	21707	10873	9	0	980
46539	1693	7156755292484	23725	11815	8	0	1117
46540	1693	7156781292484	23725	11815	9	0	1117
46593	1693	7876781192484	23771	11837	4	0	1117
46639	1693	8596803092484	24005	11945	5	0	1117
46642	1693	8596817092484	24005	11945	6	0	1117
46542	1693	7191014570272	26507	13114	3	0	1248
46544	1693	7191026570272	26507	13114	4	0	1248
46597	1693	7911026570272	26530	13125	3	0	1248
46643	1693	8631038570272	26601	13160	5	0	1248
46644	1693	8631052570272	26601	13160	6	0	1248
46558	1693	7245873623117	28425	14049	2	0	1383
46560	1693	7245884623117	28425	14049	3	0	1383
46611	1693	7965884623117	28553	14105	4	0	1383
46651	1693	8685897623117	28586	14118	3	0	\N
46653	1693	8685909623117	28586	14118	4	0	\N
46655	1693	8780408406843	16416	8350	3	0	\N
46658	1693	8780420406843	16416	8350	4	0	\N
46664	1693	9273419155041	12606	6502	2	0	\N
46666	1693	9273430155041	12606	6502	3	0	\N
46669	1693	9316817092484	24054	11969	4	0	\N
46671	1693	9316839092484	24054	11969	5	0	\N
46672	1693	9351052570272	26605	13163	4	0	\N
46675	1693	9351065570272	26605	13163	5	0	\N
46679	1693	9382761053757	11000	5381	0	0	\N
46680	1693	9382761053757	11003	5386	0	0	\N
46681	1693	9382761053757	11005	5387	0	0	\N
46685	1693	9405910623117	28736	14180	2	0	\N
46687	1693	9405921623117	28736	14180	3	0	\N
46689	1693	9500410406743	16511	8400	4	0	\N
46691	1693	9500423406743	16511	8400	5	0	\N
46699	1693	10036837092484	24079	11986	6	0	\N
46700	1693	10036837092484	24137	12015	2	0	\N
46702	1693	10036839092484	24137	12015	3	0	\N
46704	1693	10036870092484	24079	11986	7	0	\N
46707	1693	10070979570272	26974	13340	3	0	\N
46710	1693	10102951053757	10512	5429	2	0	\N
46711	1693	10102951053757	10543	5446	2	0	\N
46712	1693	10102951053757	10748	5548	3	0	\N
46713	1693	10102951053757	10803	5576	4	0	\N
46715	1693	10102971053757	10512	5429	3	0	\N
46716	1693	10102971053757	10543	5446	3	0	\N
46717	1693	10102981053757	10748	5548	4	0	\N
46718	1693	10102991053757	10803	5576	5	0	\N
46720	1693	10106777500877	4104	2133	2	0	\N
46723	1693	10106887500877	4104	2133	3	0	\N
46725	1693	10125922623117	28898	14254	3	0	\N
46726	1693	10125934623117	28898	14254	4	0	\N
46728	1693	10220423406843	16519	8402	4	0	\N
46730	1693	10220436406843	16519	8402	5	0	\N
46737	1693	10713453155041	12849	6626	2	0	\N
46738	1693	10713453155041	12989	6696	4	0	\N
46739	1693	10713464155041	12849	6626	3	0	\N
46741	1693	10713475155041	12989	6696	5	0	\N
46744	1693	10790978570273	26974	13340	4	0	\N
46756	1693	10981746908632	21956	10985	9	0	\N
46757	1693	10981746908632	21957	10985	9	0	\N
46758	1693	10981746908632	22302	11164	3	0	\N
46759	1693	10981758908632	22302	11164	4	0	\N
46760	1693	10981782908632	21956	10985	10	0	\N
46761	1693	10981782908632	21957	10985	10	0	\N
46764	1693	11433464155041	13156	6779	4	0	\N
46767	1693	11433486155041	13156	6779	5	0	\N
46768	1693	11476883092484	24251	12067	7	0	\N
46771	1693	11476908092484	24251	12067	8	0	\N
46772	1693	11510979570272	27004	13357	3	0	\N
46774	1693	11510991570272	27004	13357	4	0	\N
46776	1693	11511001570272	27182	13445	1	0	\N
46780	1693	11543011053757	10960	5649	7	0	\N
46781	1693	11543011053757	10999	5667	1	0	\N
46783	1693	11543021053757	10999	5667	2	0	\N
46649	1693	8666746500877	3994	2073	1	0	229
46650	1693	8666756500877	3994	2073	2	0	229
46683	1693	9386756500877	4056	2107	3	0	229
46684	1693	9386777500877	4056	2107	4	0	229
46721	1693	10106777500877	4137	2152	1	0	229
46750	1693	10826787500877	4222	2194	1	0	229
46751	1693	10826797500877	4222	2194	2	0	229
46663	1693	8959201551364	5665	2938	0	0	346
46695	1693	9679201551364	5782	3001	2	0	346
46696	1693	9679221551364	5782	3001	3	0	346
46735	1693	10399231551364	5807	3013	2	0	346
46762	1693	11119231551364	5850	3035	1	0	346
46763	1693	11119241551364	5850	3035	2	0	346
46676	1693	9353617553123	8630	4473	2	0	458
46709	1693	10073637553123	8672	4492	0	0	458
46746	1693	10793637553123	8709	4517	1	0	458
46747	1693	10793647553123	8709	4517	2	0	458
46778	1693	11513647553123	8865	4594	2	0	458
46779	1693	11513667553123	8865	4594	3	0	458
46682	1693	9382951053757	10470	5411	20	0	563
46714	1693	10102951053757	10804	5576	4	0	563
46719	1693	10102991053757	10804	5576	5	0	563
46748	1693	10822991053757	10856	5605	2	0	563
46749	1693	10823011053757	10856	5605	3	0	563
46784	1693	11543041053757	11156	5735	4	0	563
46665	1693	9273419155041	12665	6533	5	0	666
46667	1693	9273442155041	12665	6533	6	0	666
46697	1693	9993442155041	12712	6555	2	0	666
46736	1693	10713443155041	13020	6712	3	0	667
46740	1693	10713464155041	13020	6712	4	0	667
46765	1693	11433464155041	13158	6779	2	0	667
46766	1693	11433484155041	13158	6779	3	0	667
46656	1693	8780408406843	16417	8350	2	0	772
46690	1693	9500410406843	16513	8400	4	0	772
46692	1693	9500423406843	16513	8400	5	0	772
46729	1693	10220423406843	16521	8403	4	0	772
46731	1693	10220436406843	16521	8403	5	0	772
46754	1693	10940436406843	16527	8406	7	0	772
46659	1693	8821698908632	21835	10928	6	0	980
46660	1693	8821722908632	21835	10928	7	0	980
46693	1693	9541722908632	21863	10942	3	0	980
46694	1693	9541734908632	21863	10942	4	0	980
46733	1693	10261746908632	21906	10961	4	0	980
46668	1693	9316817092484	24052	11969	2	0	1117
46670	1693	9316837092484	24052	11969	3	0	1117
46701	1693	10036837092484	24138	12015	4	0	1117
46703	1693	10036859092484	24138	12015	5	0	1117
46743	1693	10756883092484	24167	12029	7	0	1117
46769	1693	11476883092484	24272	12076	4	0	1117
46770	1693	11476905092484	24272	12076	5	0	1117
46673	1693	9351052570272	26607	13164	3	0	1248
46674	1693	9351064570272	26607	13164	4	0	1248
46706	1693	10070967570272	26954	13332	5	0	1249
46708	1693	10070979570272	26975	13340	3	0	1249
46745	1693	10790979570272	26975	13340	4	0	1249
46773	1693	11510979570272	27159	13429	3	0	1249
46777	1693	11511001570272	27184	13445	1	0	1249
46652	1693	8685897623117	28605	14126	4	0	1383
46654	1693	8685910623117	28605	14126	5	0	1383
46686	1693	9405910623117	28797	14206	3	0	1383
46688	1693	9405922623117	28797	14206	4	0	1383
46727	1693	10125935623117	28897	14254	5	0	1383
46752	1693	10845935623117	28925	14265	7	0	1383
46753	1693	10845960623117	28925	14265	8	0	1383
46785	1693	11543661053757	10960	5649	8	0	\N
46790	1693	11660470406843	16694	8480	2	0	\N
46792	1693	11660481406843	16694	8480	3	0	\N
46794	1693	11839241551364	5935	3074	1	0	\N
46796	1693	11839251551364	5935	3074	2	0	\N
46798	1693	12153484155041	13307	6857	3	0	\N
46800	1693	12153496155041	13307	6857	4	0	\N
46804	1693	12231001570272	27182	13445	7	0	\N
46806	1693	12231015570272	27182	13445	8	0	\N
46812	1693	12266697500877	4313	2236	2	0	\N
46814	1693	12266717500877	4313	2236	3	0	\N
46816	1693	12285972623117	29029	14316	6	0	\N
46817	1693	12285972623117	29062	14330	9	0	\N
46818	1693	12285972623117	29084	14337	3	0	\N
46819	1693	12285972623117	29116	14354	8	0	\N
46822	1693	12285984623117	29084	14337	4	0	\N
46823	1693	12285996623117	29029	14316	7	0	\N
46824	1693	12286007623117	29116	14354	9	0	\N
46825	1693	12286008623117	29062	14330	10	0	\N
46831	1693	12873497155041	13353	6882	3	0	\N
46832	1693	12873509155041	13353	6882	4	0	\N
46838	1693	12953707553123	9011	4670	4	0	\N
46839	1693	12953707553123	9191	4763	4	0	\N
46840	1693	12953747553123	9011	4670	5	0	\N
46841	1693	12953747553123	9191	4763	5	0	\N
46842	1693	13005983623117	29282	14431	3	0	\N
46843	1693	13005983623117	29320	14449	3	0	\N
46845	1693	13005995623117	29282	14431	4	0	\N
46846	1693	13005995623117	29320	14449	4	0	\N
46850	1693	13279281551364	6083	3158	0	0	\N
46861	1693	13820626406843	17236	8732	3	0	\N
46864	1693	13820638406843	17236	8732	4	0	\N
46875	1693	14540637406843	17275	8750	3	0	\N
46876	1693	14540637406843	17307	8767	3	0	\N
46878	1693	14540649406843	17275	8750	4	0	\N
46879	1693	14540649406843	17307	8767	4	0	\N
46881	1693	14540694406843	17439	8833	4	0	\N
46882	1693	14540694406843	17442	8833	4	0	\N
46883	1693	14540694406843	17443	8833	4	0	\N
46884	1693	14554584942000	18196	9170	6	0	\N
46888	1693	15033575155041	13561	6974	2	0	\N
46889	1693	15033586155041	13561	6974	3	0	\N
46891	1693	15076974092484	24470	12169	2	0	\N
46893	1693	15076985092484	24470	12169	3	0	\N
46897	1693	15166019623117	29371	14476	3	0	\N
46900	1693	15166031623117	29371	14476	4	0	\N
46901	1693	15260694406843	17439	8833	7	0	\N
46902	1693	15260694406843	17442	8833	7	0	\N
46903	1693	15260694406843	17443	8833	7	0	\N
46904	1693	15260696406843	17439	8833	8	0	\N
46905	1693	15260696406843	17442	8833	8	0	\N
46906	1693	15260696406843	17443	8833	8	0	\N
46907	1693	15439331551364	6445	3335	2	0	\N
46909	1693	15439351551364	6445	3335	3	0	\N
46911	1693	15753587155041	13786	7082	8	0	\N
46912	1693	15753587155041	13851	7108	7	0	\N
46913	1693	15753587155041	13853	7108	1	0	\N
46915	1693	15753597155041	13853	7108	2	0	\N
46916	1693	15753603155041	13851	7108	8	0	\N
46917	1693	15753613155041	13786	7082	9	0	\N
46918	1693	15796986092484	24492	12180	3	0	\N
46920	1693	15796998092484	24492	12180	4	0	\N
46813	1693	12266697500877	4323	2240	2	0	230
46815	1693	12266717500877	4323	2240	3	0	230
46795	1693	11839241551364	5945	3081	2	0	346
46797	1693	11839261551364	5945	3081	3	0	346
46828	1693	12559261551364	5967	3095	2	0	346
46851	1693	13279281551364	6304	3263	2	0	346
46852	1693	13279301551364	6304	3263	3	0	346
46865	1693	13999301551364	6351	3287	2	0	346
46866	1693	13999321551364	6351	3287	3	0	346
46885	1693	14719321551364	6369	3298	1	0	346
46908	1693	15439331551364	6458	3346	4	0	346
46910	1693	15439371551364	6458	3346	5	0	346
46808	1693	12233667553123	8999	4666	4	0	458
46809	1693	12233707553123	8999	4666	5	0	458
46811	1693	12263081053757	11181	5743	5	0	563
46799	1693	12153484155041	13343	6877	4	0	667
46801	1693	12153497155041	13343	6877	5	0	667
46830	1693	12873497155041	13352	6882	7	0	667
46833	1693	12873513155041	13352	6882	8	0	667
46854	1693	13593539155041	13383	6897	9	0	667
46867	1693	14313539155041	13485	6944	9	0	667
46868	1693	14313575155041	13485	6944	10	0	667
46887	1693	15033575155041	13560	6974	3	0	667
46890	1693	15033587155041	13560	6974	4	0	667
46791	1693	11660470406843	16795	8524	4	0	772
46793	1693	11660582406843	16795	8524	5	0	772
46826	1693	12380582406843	16965	8598	6	0	772
46827	1693	12380615406843	16965	8598	7	0	772
46849	1693	13100626406843	16999	8610	3	0	772
46862	1693	13820626406843	17238	8733	2	0	772
46863	1693	13820637406843	17238	8733	3	0	772
46877	1693	14540637406843	17380	8803	8	0	772
46880	1693	14540672406843	17380	8803	9	0	772
46803	1693	12196918092484	24330	12100	5	0	1117
46834	1693	12916918092484	24356	12113	3	0	1117
46835	1693	12916930092484	24356	12113	4	0	1117
46855	1693	13636930092484	24379	12124	1	0	1117
46856	1693	13636940092484	24379	12124	2	0	1117
46870	1693	14356974092484	24436	12152	8	0	1117
46892	1693	15076974092484	24477	12171	3	0	1117
46894	1693	15076986092484	24477	12171	4	0	1117
46919	1693	15796986092484	24547	12203	5	0	1117
46807	1693	12231015570272	27184	13445	8	0	1249
46836	1693	12951015570272	27205	13456	3	0	1249
46837	1693	12951027570272	27205	13456	4	0	1249
46857	1693	13671027570272	27256	13476	3	0	1249
46858	1693	13671039570272	27256	13476	4	0	1249
46872	1693	14391075570272	27336	13513	10	0	1249
46895	1693	15111075570272	27342	13517	6	0	1249
46896	1693	15111099570272	27342	13517	7	0	1249
46788	1693	11565960623117	28992	14294	3	0	1383
46789	1693	11565972623117	28992	14294	4	0	1383
46821	1693	12285983623117	29136	14366	3	0	1383
46844	1693	13005983623117	29348	14464	3	0	1383
46847	1693	13005995623117	29348	14464	4	0	1383
46859	1693	13725995623117	29362	14470	3	0	1383
46873	1693	14446007623117	29363	14471	3	0	1383
46874	1693	14446019623117	29363	14471	4	0	1383
46898	1693	15166019623117	29392	14491	2	0	1383
46899	1693	15166030623117	29392	14491	3	0	1383
46922	1693	15797019092484	24635	12241	1	0	\N
46923	1693	15797019092484	24636	12241	1	0	\N
46924	1693	15797019092484	24637	12241	1	0	\N
46925	1693	15831099570272	27449	13566	6	0	\N
46926	1693	15831123570272	27449	13566	7	0	\N
46933	1693	16473634155041	14131	7220	7	0	\N
46934	1693	16473634155041	14133	7220	7	0	\N
46935	1693	16517009092484	24604	12230	2	0	\N
46936	1693	16517019092484	24635	12241	5	0	\N
46937	1693	16517019092484	24636	12241	5	0	\N
46938	1693	16517019092484	24637	12241	5	0	\N
46939	1693	16517020092484	24604	12230	3	0	\N
46940	1693	16517022092484	24635	12241	6	0	\N
46941	1693	16517022092484	24636	12241	6	0	\N
46942	1693	16517022092484	24637	12241	6	0	\N
46943	1693	16606048623117	29484	14538	3	0	\N
46945	1693	16606060623117	29484	14538	4	0	\N
46951	1693	17193634155041	14131	7220	12	0	\N
46952	1693	17193634155041	14133	7220	12	0	\N
46953	1693	17193638155041	14131	7220	13	0	\N
46954	1693	17193638155041	14133	7220	13	0	\N
46955	1693	17326060623117	29572	14580	3	0	\N
46958	1693	17326072623117	29572	14580	4	0	\N
46963	1693	18046071623117	29595	14593	12	0	\N
46964	1693	18046071623117	29731	14657	7	0	\N
46965	1693	18046071623117	29736	14657	5	0	\N
46966	1693	18046085623117	29736	14657	6	0	\N
46967	1693	18046087623117	29731	14657	8	0	\N
46968	1693	18046119623117	29595	14593	13	0	\N
46975	1693	19353541155041	14500	7397	3	0	\N
46977	1693	19353571155041	14500	7397	4	0	\N
46979	1693	19759511551364	6841	3540	2	0	\N
46982	1693	19759531551364	6841	3540	3	0	\N
46983	1693	20073576155041	14509	7402	1	0	\N
46984	1693	20073576155041	14511	7402	7	0	\N
46986	1693	20073586155041	14509	7402	2	0	\N
46987	1693	20073592155041	14511	7402	8	0	\N
46989	1693	20479521551364	6921	3573	4	0	\N
46990	1693	20479521551364	6923	3573	2	0	\N
46992	1693	20479541551364	6923	3573	3	0	\N
46994	1693	20479561551364	6921	3573	5	0	\N
46999	1693	21199541551364	7058	3644	2	0	\N
47000	1693	21199561551364	7058	3644	3	0	\N
47017	1694	2879020000000	651	365	2	0	\N
47018	1694	2892274127629	9986	5178	6	0	\N
47019	1694	2892274127629	10166	5269	2	0	\N
47021	1694	2892294127629	10166	5269	3	0	\N
47023	1694	2892334127629	9986	5178	7	0	\N
47024	1694	3599000000000	468	262	1	0	\N
47026	1694	3599010000000	468	262	2	0	\N
47028	1694	3599020000000	651	365	5	0	\N
47029	1694	3599040000000	651	365	6	0	\N
47030	1694	3612294127629	10204	5284	2	0	\N
47031	1694	3612294127629	10360	5359	2	0	\N
47032	1694	3612294127629	10798	5573	2	0	\N
47034	1694	3612294127629	11188	5744	2	0	\N
47035	1694	3612314127629	10204	5284	3	0	\N
47036	1694	3612314127629	10360	5359	3	0	\N
47037	1694	3612314127629	10798	5573	3	0	\N
47039	1694	3612314127629	11188	5744	3	0	\N
47040	1694	4138747197225	20271	10209	3	0	\N
47041	1694	4138747197225	20272	10209	5	0	\N
47042	1694	4138747197225	20445	10296	2	0	\N
47043	1694	4138747197225	20482	10314	2	0	\N
47044	1694	4138747197225	20505	10324	3	0	\N
47046	1694	4138758197225	20445	10296	3	0	\N
47047	1694	4138758197225	20482	10314	3	0	\N
47048	1694	4138759197225	20271	10209	4	0	\N
47049	1694	4138759197225	20505	10324	4	0	\N
47051	1694	4138761197225	20272	10209	6	0	\N
47056	1694	4858760197225	21528	10800	2	0	\N
47011	1694	1439010000000	129	76	2	0	0
47012	1694	1439030000000	129	76	3	0	0
47013	1694	2159030000000	255	149	5	0	0
47014	1694	2159080000000	255	149	6	0	0
47015	1694	2878979000000	266	155	3	0	1
47025	1694	3599000000000	752	421	1	0	1
47027	1694	3599010000000	752	421	2	0	1
47052	1694	4319010000000	885	493	2	0	1
47053	1694	4319030000000	885	493	3	0	1
46929	1693	16159371551364	6478	3358	4	0	346
46947	1693	16879411551364	6619	3423	2	0	346
46948	1693	16879431551364	6619	3423	3	0	346
46959	1693	17599431551364	6623	3425	4	0	346
46960	1693	17599471551364	6623	3425	5	0	346
46970	1693	18319491551364	6781	3511	3	0	346
46973	1693	19039491551364	6793	3517	2	0	346
46974	1693	19039511551364	6793	3517	3	0	346
46980	1693	19759511551364	6843	3540	1	0	346
46981	1693	19759521551364	6843	3540	2	0	346
46993	1693	20479541551364	7056	3642	3	0	346
46997	1693	21199431551364	7087	3657	2	0	347
46998	1693	21199451551364	7087	3657	3	0	347
47003	1693	21919341551364	7141	3690	1	0	348
47004	1693	21919351551364	7141	3690	2	0	348
47006	1693	22639361551364	7213	3729	2	0	348
47007	1693	23359361551364	7343	3795	1	0	348
47008	1693	23359371551364	7343	3795	2	0	348
47020	1694	2892274127629	10175	5273	2	0	34
47033	1694	3612294127629	11187	5744	2	0	34
47038	1694	3612314127629	11187	5744	3	0	34
47054	1694	4332314127629	11202	5753	3	0	34
47055	1694	4332344127629	11202	5753	4	0	34
46931	1693	16473587155041	14069	7200	4	0	667
46949	1693	17193600155041	14216	7257	4	0	667
46950	1693	17193613155041	14216	7257	5	0	667
46961	1693	17913613155041	14272	7286	8	0	667
46962	1693	17913639155041	14272	7286	9	0	667
46971	1693	18633529155041	14399	7347	3	0	668
46976	1693	19353541155041	14502	7397	8	0	668
46978	1693	19353576155041	14502	7397	9	0	668
46985	1693	20073576155041	14539	7416	6	0	668
46988	1693	20073600155041	14539	7416	7	0	668
46996	1693	20793611155041	14611	7449	3	0	668
47001	1693	21513611155041	14662	7469	5	0	668
47002	1693	21513634155041	14662	7469	6	0	668
47045	1694	4138747197225	20738	10425	4	0	62
47050	1694	4138760197225	20738	10425	5	0	62
46927	1693	15886030623117	29467	14531	4	0	1383
46928	1693	15886048623117	29467	14531	5	0	1383
46944	1693	16606048623117	29485	14538	3	0	1383
46946	1693	16606060623117	29485	14538	4	0	1383
46956	1693	17326060623117	29573	14580	2	0	1383
47057	1694	4858760197225	21529	10800	3	0	\N
47059	1694	4858771197225	21528	10800	3	0	\N
47060	1694	4858772197225	21529	10800	4	0	\N
47062	1694	5039030000000	919	511	1	0	\N
47064	1694	5039040000000	919	511	2	0	\N
47066	1694	5052344127629	11360	5834	10	0	\N
47067	1694	5052344127629	11382	5847	2	0	\N
47068	1694	5052344127629	11417	5865	2	0	\N
47071	1694	5052355127629	11382	5847	3	0	\N
47072	1694	5052355127629	11417	5865	3	0	\N
47073	1694	5052399127629	11360	5834	11	0	\N
47074	1694	5578772197225	21565	10813	4	0	\N
47077	1694	5578785197225	21565	10813	5	0	\N
47080	1694	5772345127629	11778	6056	1	0	\N
47081	1694	5772345127629	11800	6065	2	0	\N
47083	1694	5772346127629	11778	6056	2	0	\N
47085	1694	5772347127629	11800	6065	3	0	\N
47088	1694	6479050000000	1115	615	1	0	\N
47090	1694	6479060000000	1115	615	2	0	\N
47092	1694	6492346127629	12246	6307	2	0	\N
47093	1694	6492346127629	12945	6672	2	0	\N
47095	1694	6492357127629	12246	6307	3	0	\N
47096	1694	6492357127629	12945	6672	3	0	\N
47100	1694	7199080000000	1248	691	1	0	\N
47101	1694	7199080000000	1297	716	4	0	\N
47103	1694	7199090000000	1248	691	2	0	\N
47105	1694	7199120000000	1297	716	5	0	\N
47106	1694	7212357127629	13313	6859	3	0	\N
47108	1694	7212369127629	13313	6859	4	0	\N
47110	1694	7738832197225	22069	11035	6	0	\N
47113	1694	7738856197225	22069	11035	7	0	\N
47118	1694	8458844197225	22888	11442	4	0	\N
47120	1694	8458857197225	22888	11442	5	0	\N
47127	1694	9178866197225	24015	11680	0	0	\N
47128	1694	9178866197225	24016	11687	0	0	\N
47130	1694	9359160000000	1393	762	1	0	\N
47132	1694	9359170000000	1393	762	2	0	\N
47134	1694	9372433127629	13790	7083	5	0	\N
47135	1694	9372433127629	13791	7083	4	0	\N
47136	1694	9372433127629	13943	7144	4	0	\N
47138	1694	9372433127629	14047	7193	10	0	\N
47139	1694	9372446127629	13791	7083	5	0	\N
47140	1694	9372446127629	13943	7144	5	0	\N
47141	1694	9372453127629	14047	7193	11	0	\N
47142	1694	9372456127629	13790	7083	6	0	\N
47144	1694	9372464127629	14295	7294	1	0	\N
47145	1694	9372473127629	14293	7294	1	0	\N
47148	1694	10079205000000	1474	805	5	0	\N
47151	1694	10079255000000	1474	805	6	0	\N
47152	1694	10092463127629	14277	7288	12	0	\N
47153	1694	10092464127629	14295	7294	4	0	\N
47154	1694	10092466127629	14295	7294	5	0	\N
47155	1694	10092473127629	14293	7294	5	0	\N
47156	1694	10092476127629	14293	7294	6	0	\N
47157	1694	10092529127629	14277	7288	13	0	\N
47159	1694	10618903197225	23910	11898	3	0	\N
47160	1694	10618915197225	23910	11898	4	0	\N
47180	1694	14218998197225	24971	12393	3	0	\N
47182	1694	14218998197225	25093	12455	4	0	\N
47183	1694	14219010197225	24971	12393	4	0	\N
47185	1694	14219011197225	25093	12455	5	0	\N
47186	1694	14399295000000	1955	1036	2	0	\N
47187	1694	14399295000000	2421	1267	1	0	\N
47189	1694	14399305000000	2421	1267	2	0	\N
47191	1694	14399315000000	1955	1036	3	0	\N
47192	1694	14412463127629	15299	7796	2	0	\N
47078	1694	5759040000000	999	552	1	0	1
47079	1694	5759050000000	999	552	2	0	1
47089	1694	6479050000000	1185	655	3	0	1
47091	1694	6479080000000	1185	655	4	0	1
47102	1694	7199080000000	1304	719	1	0	1
47114	1694	7919090000000	1340	736	1	0	1
47115	1694	7919100000000	1340	736	2	0	1
47122	1694	8639100000000	1388	761	6	0	1
47123	1694	8639160000000	1388	761	7	0	1
47131	1694	9359160000000	1453	792	3	0	1
47149	1694	10079205000000	1491	814	1	0	1
47150	1694	10079215000000	1491	814	2	0	1
47162	1694	10799215000000	1503	823	1	0	1
47163	1694	10799225000000	1503	823	2	0	1
47167	1694	11519245000000	1706	917	3	0	1
47170	1694	12239245000000	1762	943	3	0	1
47171	1694	12239275000000	1762	943	4	0	1
47174	1694	12959275000000	1765	946	1	0	1
47175	1694	12959285000000	1765	946	2	0	1
47179	1694	13679295000000	1814	970	2	0	1
47188	1694	14399295000000	2469	1294	1	0	1
47190	1694	14399305000000	2469	1294	2	0	1
47069	1694	5052344127629	11569	5947	1	0	34
47070	1694	5052345127629	11569	5947	2	0	34
47084	1694	5772346127629	12137	6251	2	0	34
47094	1694	6492346127629	12946	6672	2	0	34
47097	1694	6492357127629	12946	6672	3	0	34
47107	1694	7212357127629	13593	6991	4	0	34
47116	1694	7932370127629	13630	7006	16	0	34
47117	1694	7932422127629	13630	7006	17	0	34
47124	1694	8652422127629	13672	7025	2	0	34
47125	1694	8652433127629	13672	7025	3	0	34
47137	1694	9372433127629	14045	7193	11	0	34
47058	1694	4858760197225	21530	10800	3	0	62
47061	1694	4858772197225	21530	10800	4	0	62
47075	1694	5578772197225	21693	10866	3	0	62
47076	1694	5578784197225	21693	10866	4	0	62
47086	1694	6298784197225	21749	10891	3	0	62
47098	1694	7018796197225	22037	11018	9	0	62
47099	1694	7018832197225	22037	11018	10	0	62
47111	1694	7738832197225	22414	11220	3	0	62
47112	1694	7738844197225	22414	11220	4	0	62
47121	1694	8458866197225	23318	11636	5	0	62
47126	1694	9178866197225	23493	11713	6	0	62
47129	1694	9178890197225	23493	11713	7	0	62
47146	1694	9898890197225	23583	11752	4	0	62
47147	1694	9898903197225	23583	11752	5	0	62
47161	1694	10618916197225	23908	11898	5	0	62
47164	1694	11338916197225	24014	11950	3	0	62
47165	1694	11338928197225	24014	11950	4	0	62
47168	1694	12058928197225	24464	12166	7	0	62
47169	1694	12058962197225	24464	12166	8	0	62
47173	1694	12778974197225	24571	12214	4	0	62
47176	1694	13498974197225	24940	12380	6	0	62
47177	1694	13498998197225	24940	12380	7	0	62
47181	1694	14218998197225	25091	12455	4	0	62
47193	1694	14412463127629	15371	7831	3	0	\N
47194	1694	14412463127629	15550	7915	2	0	\N
47195	1694	14412463127629	15636	7958	4	0	\N
47197	1694	14412474127629	15299	7796	3	0	\N
47198	1694	14412474127629	15550	7915	3	0	\N
47199	1694	14412475127629	15371	7831	4	0	\N
47201	1694	14412476127629	15636	7958	5	0	\N
47208	1694	15659023197225	25228	12514	5	0	\N
47209	1694	15659023197225	25230	12514	4	0	\N
47210	1694	15659023197225	25506	12631	3	0	\N
47211	1694	15659023197225	25578	12662	3	0	\N
47213	1694	15659035197225	25506	12631	4	0	\N
47214	1694	15659035197225	25578	12662	4	0	\N
47215	1694	15659036197225	25230	12514	5	0	\N
47216	1694	15659037197225	25228	12514	6	0	\N
47218	1694	15659817197225	26358	12927	77	0	\N
47221	1694	15852511127629	16287	8276	2	0	\N
47222	1694	15852511127629	16289	8276	2	0	\N
47224	1694	15852522127629	16287	8276	3	0	\N
47225	1694	15852522127629	16289	8276	3	0	\N
47227	1694	16379047197225	25871	12788	3	0	\N
47228	1694	16379047197225	25872	12788	1	0	\N
47229	1694	16379047197225	26357	13033	7	0	\N
47231	1694	16379048197225	25872	12788	2	0	\N
47232	1694	16379059197225	25871	12788	4	0	\N
47234	1694	16379081197225	26357	13033	8	0	\N
47235	1694	16379817197225	26358	12927	126	0	\N
47236	1694	16380297197225	26358	12927	127	0	\N
47237	1694	16381067197225	26424	12928	77	0	\N
47238	1694	16559335000000	2877	1505	1	0	\N
47240	1694	16559345000000	2877	1505	2	0	\N
47244	1694	17099059197225	26645	13181	6	0	\N
47245	1694	17099059197225	26646	13181	4	0	\N
47247	1694	17099063197225	26646	13181	5	0	\N
47248	1694	17099083197225	26645	13181	7	0	\N
47250	1694	17101067197225	26424	12928	89	0	\N
47251	1694	17101150197225	26424	12928	90	0	\N
47252	1694	17279335000000	2907	1517	0	0	\N
47254	1694	17292571127629	16534	8409	3	0	\N
47256	1694	17292583127629	16534	8409	4	0	\N
47258	1694	17819083197225	26881	13293	3	0	\N
47259	1694	17819083197225	27025	13366	3	0	\N
47262	1694	17819095197225	26881	13293	4	0	\N
47263	1694	17819095197225	27025	13366	4	0	\N
47266	1694	18012620127629	16781	8519	7	0	\N
47269	1694	18012645127629	16781	8519	8	0	\N
47272	1694	18719385000000	3144	1635	1	0	\N
47273	1694	18719385000000	3202	1663	7	0	\N
47275	1694	18719395000000	3144	1635	2	0	\N
47277	1694	18719455000000	3202	1663	8	0	\N
47280	1694	19259097197225	27204	13455	7	0	\N
47281	1694	19259097197225	27590	13636	5	0	\N
47284	1694	19259111197225	27590	13636	6	0	\N
47285	1694	19259122197225	27204	13455	8	0	\N
47292	1694	20159415000000	3746	1942	2	0	\N
47293	1694	20159415000000	4045	2101	1	0	\N
47294	1694	20159415000000	4202	2187	1	0	\N
47296	1694	20159425000000	4045	2101	2	0	\N
47297	1694	20159425000000	4202	2187	2	0	\N
47299	1694	20159435000000	3746	1942	3	0	\N
47302	1694	20699133197225	28231	13958	6	0	\N
47303	1694	20699133197225	28505	14086	3	0	\N
47304	1694	20699133197225	28564	14111	7	0	\N
47305	1694	20699133197225	29453	14523	4	0	\N
47307	1694	20699145197225	28505	14086	4	0	\N
47308	1694	20699157197225	28231	13958	7	0	\N
47309	1694	20699158197225	28564	14111	8	0	\N
47311	1694	20699395197225	29453	14523	5	0	\N
47312	1694	20879425000000	4528	2343	1	0	\N
47313	1694	20879425000000	4582	2370	1	0	\N
47315	1694	20879435000000	4528	2343	2	0	\N
47316	1694	20879435000000	4582	2370	2	0	\N
47318	1694	20892680127629	17836	9007	4	0	\N
47319	1694	20892680127629	17839	9007	6	0	\N
47320	1694	20892680127629	18044	9102	3	0	\N
47321	1694	20892680127629	18086	9120	7	0	\N
47323	1694	20892692127629	18044	9102	4	0	\N
47324	1694	20892702127629	17836	9007	5	0	\N
47326	1694	20892704127629	17839	9007	7	0	\N
47327	1694	20892714127629	18086	9120	8	0	\N
47328	1694	21419172197225	30090	14814	9	0	\N
47219	1694	15839325000000	2680	1409	1	0	1
47220	1694	15839335000000	2680	1409	2	0	1
47239	1694	16559335000000	2880	1505	0	0	1
47241	1694	16559375000000	2906	1517	4	0	1
47253	1694	17279375000000	2906	1517	5	0	1
47265	1694	17999385000000	3073	1598	2	0	1
47274	1694	18719385000000	3256	1691	2	0	1
47276	1694	18719405000000	3256	1691	3	0	1
47286	1694	19439405000000	3722	1931	1	0	1
47287	1694	19439415000000	3722	1931	2	0	1
47298	1694	20159425000000	4378	2270	2	0	1
47314	1694	20879425000000	4736	2448	1	0	1
47317	1694	20879435000000	4736	2448	2	0	1
47196	1694	14412463127629	15911	8089	3	0	34
47206	1694	15132475127629	15930	8099	9	0	34
47207	1694	15132511127629	15930	8099	10	0	34
47223	1694	15852511127629	16290	8276	3	0	34
47226	1694	15852523127629	16290	8276	4	0	34
47242	1694	16572523127629	16434	8357	12	0	34
47255	1694	17292571127629	16774	8514	13	0	34
47257	1694	17292620127629	16774	8514	14	0	34
47267	1694	18012620127629	16883	8563	3	0	34
47268	1694	18012632127629	16883	8563	4	0	34
47278	1694	18732632127629	16936	8585	7	0	34
47288	1694	19452657127629	17309	8769	3	0	34
47289	1694	19452669127629	17309	8769	4	0	34
47300	1694	20172669127629	17448	8836	2	0	34
47301	1694	20172680127629	17448	8836	3	0	34
47325	1694	20892703127629	18331	9233	6	0	34
47202	1694	14939011197225	25204	12502	3	0	62
47203	1694	14939023197225	25204	12502	4	0	62
47212	1694	15659023197225	25633	12686	6	0	62
47217	1694	15659047197225	25633	12686	7	0	62
47233	1694	16379059197225	26420	13072	4	0	62
47246	1694	17099059197225	26760	13233	6	0	62
47249	1694	17099083197225	26760	13233	7	0	62
47260	1694	17819083197225	27026	13366	2	0	62
47261	1694	17819085197225	27026	13366	3	0	62
47271	1694	18539097197225	27094	13397	4	0	62
47282	1694	19259097197225	27803	13738	3	0	62
47283	1694	19259109197225	27803	13738	4	0	62
47290	1694	19979109197225	27812	13743	6	0	62
47306	1694	20699133197225	30044	14791	21	0	62
47310	1694	20699172197225	30044	14791	22	0	62
47330	1694	21419190197225	30090	14814	10	0	\N
47332	1694	21599435000000	4749	2454	3	0	\N
47333	1694	21599435000000	4817	2495	2	0	\N
47335	1694	21599465000000	4749	2454	4	0	\N
47337	1694	21599545000000	4817	2495	3	0	\N
47338	1694	21612703127629	18717	9429	2	0	\N
47339	1694	21612703127629	18870	9516	3	0	\N
47342	1694	21612714127629	18717	9429	3	0	\N
47343	1694	21612724127629	18870	9516	4	0	\N
47348	1694	23039485000000	5026	2609	1	0	\N
47349	1694	23039485000000	5028	2609	0	0	\N
47350	1694	23039485000000	5090	2641	2	0	\N
47352	1694	23039495000000	5026	2609	2	0	\N
47353	1694	23039505000000	5090	2641	3	0	\N
47357	1694	23053053127629	19647	9878	32	0	\N
47358	1694	23053903127629	19408	9627	98	0	\N
47359	1694	23759505000000	5191	2699	1	0	\N
47361	1694	23759515000000	5191	2699	2	0	\N
47363	1694	23772733127629	19410	9781	3	0	\N
47364	1694	23772733127629	19645	9894	6	0	\N
47365	1694	23772733127629	19692	9915	8	0	\N
47367	1694	23772733127629	19737	9935	2	0	\N
47368	1694	23772735127629	19737	9935	3	0	\N
47369	1694	23772745127629	19410	9781	4	0	\N
47371	1694	23772757127629	19645	9894	7	0	\N
47372	1694	23772795127629	19692	9915	9	0	\N
47373	1694	23773053127629	19647	9878	109	0	\N
47374	1694	23773628077629	19694	9879	49	0	\N
47375	1694	23773903127629	19408	9627	126	0	\N
47376	1694	23774173127629	19408	9627	127	0	\N
47378	1694	24479515000000	5361	2766	22	0	\N
47380	1694	24479735000000	5361	2766	23	0	\N
47383	1694	24493628077629	19694	9879	126	0	\N
47384	1694	24494109077629	19694	9879	127	0	\N
47385	1694	24494419077629	19738	9880	49	0	\N
47387	1694	25199735000000	5414	2767	13	0	\N
47388	1694	25199847000000	5414	2767	14	0	\N
47389	1694	25212757127629	19891	10020	11	0	\N
47390	1694	25212822127629	19891	10020	12	0	\N
47391	1694	25214419077629	19738	9880	95	0	\N
47392	1694	25214464077629	19738	9880	96	0	\N
47397	1694	28799535000000	6249	3233	2	0	\N
47398	1694	28799535000000	6345	3284	1	0	\N
47400	1694	28799545000000	6345	3284	2	0	\N
47401	1694	28799555000000	6249	3233	3	0	\N
47409	1694	31679645000000	7248	3748	2	0	\N
47412	1694	31679665000000	7248	3748	3	0	\N
47416	1694	32399765000000	7414	3832	1	0	\N
47417	1694	32399765000000	7416	3832	1	0	\N
47419	1694	33119765000000	7414	3832	3	0	\N
47420	1694	33119765000000	7416	3832	3	0	\N
47421	1694	33119770000000	7414	3832	4	0	\N
47422	1694	33119770000000	7416	3832	4	0	\N
47423	1694	33839760000000	7977	4134	1	0	\N
47424	1694	33839760000000	8043	4168	1	0	\N
47426	1694	33839770000000	7977	4134	2	0	\N
47427	1694	33839770000000	8043	4168	2	0	\N
47440	1694	38880330000000	8637	4476	1	0	\N
47441	1694	38880330000000	8871	4597	2	0	\N
47442	1694	38880330000000	9273	4807	3	0	\N
47444	1694	38880340000000	8637	4476	2	0	\N
47445	1694	38880350000000	8871	4597	3	0	\N
47446	1694	38880360000000	9273	4807	4	0	\N
47448	1694	67440013050000	19647	9878	110	1	\N
47449	1695	1000	11279	5652	47	1	\N
47452	1695	1439020000000	138	81	1	0	\N
47454	1695	1439030000000	138	81	2	0	\N
47458	1695	1773301000000	11074	5651	47	0	\N
47459	1695	2158970000000	653	365	2	0	\N
47460	1695	2159040000000	222	131	1	0	\N
47462	1695	2159050000000	222	131	2	0	\N
47464	1695	2492091000000	10208	5286	2	0	\N
47453	1695	1439020000000	184	110	2	0	0
47455	1695	1439040000000	184	110	3	0	0
47461	1695	2159040000000	227	134	1	0	0
47463	1695	2159050000000	227	134	2	0	0
47334	1694	21599435000000	4836	2505	3	0	1
47344	1694	22319465000000	4931	2552	2	0	1
47345	1694	22319485000000	4931	2552	3	0	1
47351	1694	23039485000000	5100	2648	2	0	1
47354	1694	23039505000000	5100	2648	3	0	1
47360	1694	23759505000000	5286	2746	1	0	1
47377	1694	24479515000000	5360	2783	2	0	1
47379	1694	24479535000000	5360	2783	3	0	1
47386	1694	25199535000000	5412	2817	0	0	1
47393	1694	25919535000000	5541	2881	0	0	1
47395	1694	27359535000000	5622	2920	0	0	1
47396	1694	28079535000000	5696	2953	0	0	1
47399	1694	28799535000000	6373	3301	3	0	1
47402	1694	28799565000000	6373	3301	4	0	1
47403	1694	29519565000000	7018	3619	4	0	1
47405	1694	30239605000000	7028	3623	2	0	1
47406	1694	30239625000000	7028	3623	3	0	1
47407	1694	30959625000000	7057	3643	2	0	1
47408	1694	30959645000000	7057	3643	3	0	1
47410	1694	31679645000000	7308	3776	1	0	1
47413	1694	32399655000000	7348	3798	10	0	1
47414	1694	32399755000000	7348	3798	11	0	1
47415	1694	32399760000000	7417	3832	1	0	1
47418	1694	33119760000000	7417	3832	2	0	1
47428	1694	33839770000000	8078	4188	2	0	1
47429	1694	34559770000000	8336	4318	1	0	1
47430	1694	34559780000000	8336	4318	2	0	1
47431	1694	35279780000000	8344	4321	6	0	1
47432	1694	35280290000000	8344	4321	7	0	1
47434	1694	36000310000000	8361	4331	3	0	1
47435	1694	36720310000000	8406	4356	1	0	1
47436	1694	36720320000000	8406	4356	2	0	1
47437	1694	37440320000000	8428	4368	0	0	1
47438	1694	38160320000000	8487	4396	1	0	1
47443	1694	38880330000000	9309	4830	4	0	1
47447	1694	38880370000000	9309	4830	5	0	1
47456	1695	1772041000000	10110	5245	7	0	5
47457	1695	1772091000000	10110	5245	8	0	5
47341	1694	21612713127629	18901	9534	2	0	34
47346	1694	22332713127629	18910	9538	1	0	34
47347	1694	22332723127629	18910	9538	2	0	34
47355	1694	23052723127629	19035	9599	1	0	34
47356	1694	23052733127629	19035	9599	2	0	34
47370	1694	23772745127629	19734	9935	4	0	34
47381	1694	24492745127629	19836	9993	3	0	34
47382	1694	24492757127629	19836	9993	4	0	34
47329	1694	21419172197225	30305	14896	7	0	62
47331	1694	21419197197225	30305	14896	8	0	62
47465	1695	2492091000000	10268	5311	2	0	\N
47467	1695	2492111000000	10208	5286	3	0	\N
47468	1695	2492111000000	10268	5311	3	0	\N
47470	1695	2493301000000	11074	5651	126	0	\N
47471	1695	2494081000000	11074	5651	127	0	\N
47472	1695	2824930999000	19850	10000	6	0	\N
47474	1695	2824945999000	19850	10000	7	0	\N
47476	1695	2825421999000	20467	10276	100	0	\N
47477	1695	2878950000000	553	313	1	0	\N
47478	1695	2878950000000	725	405	4	0	\N
47479	1695	2878950000000	757	423	2	0	\N
47480	1695	2878950000000	862	478	1	0	\N
47481	1695	2878950000000	1027	569	1	0	\N
47483	1695	2878960000000	553	313	2	0	\N
47484	1695	2878960000000	862	478	2	0	\N
47485	1695	2878960000000	1027	569	2	0	\N
47486	1695	2878970000000	653	365	5	0	\N
47487	1695	2878970000000	757	423	3	0	\N
47489	1695	2878990000000	653	365	6	0	\N
47490	1695	2878990000000	725	405	5	0	\N
47491	1695	2879050000000	267	155	3	0	\N
47492	1695	2879071000000	267	155	4	0	\N
47495	1695	3214640999000	11279	5652	84	0	\N
47496	1695	3215000999000	11279	5652	85	0	\N
47499	1695	3545421999000	20467	10276	126	0	\N
47500	1695	3545446999000	20467	10276	127	0	\N
47501	1695	3598970000000	1337	735	1	0	\N
47503	1695	3598980000000	1337	735	2	0	\N
47505	1695	3598991000000	1872	997	1	0	\N
47506	1695	3598991000000	1874	997	1	0	\N
47507	1695	3932122000000	11296	5803	2	0	\N
47508	1695	3932122000000	11567	5946	1	0	\N
47510	1695	3932123000000	11567	5946	2	0	\N
47512	1695	3932133000000	11296	5803	3	0	\N
47515	1695	4265154999000	21796	10882	13	0	\N
47516	1695	4265514999000	21795	10839	39	0	\N
47518	1695	4318991000000	1872	997	3	0	\N
47519	1695	4318991000000	1874	997	3	0	\N
47520	1695	4319001000000	1872	997	4	0	\N
47521	1695	4319001000000	1874	997	4	0	\N
47528	1695	4985154999000	21796	10882	121	0	\N
47529	1695	4985450999000	21796	10882	122	0	\N
47530	1695	4985514999000	21795	10839	126	0	\N
47531	1695	4986221999000	21795	10839	127	0	\N
47532	1695	5039001000000	2019	1065	1	0	\N
47533	1695	5039001000000	2399	1255	1	0	\N
47535	1695	5039011000000	2019	1065	2	0	\N
47536	1695	5039011000000	2399	1255	2	0	\N
47539	1695	5705035999000	23405	11677	8	0	\N
47542	1695	5705079999000	23405	11677	9	0	\N
47551	1695	6812138000000	13519	6961	4	0	\N
47552	1695	6812138000000	13566	6978	8	0	\N
47553	1695	6812138000000	13644	7014	3	0	\N
47555	1695	6812150000000	13644	7014	4	0	\N
47556	1695	6812151000000	13519	6961	5	0	\N
47558	1695	6812200000000	13566	6978	9	0	\N
47561	1695	7199021000000	3845	1997	2	0	\N
47563	1695	7199041000000	3845	1997	3	0	\N
47567	1695	7865081999000	24607	12232	3	0	\N
47569	1695	7865093999000	24607	12232	4	0	\N
47571	1695	7919041000000	3855	2002	4	0	\N
47572	1695	7919041000000	3907	2029	2	0	\N
47573	1695	7919041000000	4265	2211	1	0	\N
47574	1695	7919041000000	4267	2212	1	0	\N
47576	1695	7919051000000	4265	2211	2	0	\N
47577	1695	7919051000000	4267	2212	2	0	\N
47578	1695	7919061000000	3907	2029	3	0	\N
47579	1695	7919081000000	3855	2002	5	0	\N
47583	1695	8585093999000	24737	12284	8	0	\N
47584	1695	8585093999000	24946	12310	0	0	\N
47586	1695	8585093999000	24949	12326	0	0	\N
47587	1695	8585093999000	24950	12340	0	0	\N
47588	1695	8585093999000	24951	12355	0	0	\N
47590	1695	8585155999000	24737	12284	9	0	\N
47591	1695	8639151000000	4376	2269	1	0	\N
47593	1695	8639161000000	4376	2269	2	0	\N
47595	1695	8640441000000	4764	2278	20	0	\N
47596	1695	8972189000000	14586	7438	3	0	\N
47597	1695	8972189000000	14842	7565	2	0	\N
47599	1695	8972200000000	14842	7565	3	0	\N
47600	1695	8972201000000	14586	7438	4	0	\N
47502	1695	3598970000000	1454	793	2	0	1
47504	1695	3598981000000	1454	793	3	0	1
47517	1695	4318981000000	1996	1055	2	0	1
47522	1695	4319001000000	1996	1055	3	0	1
47534	1695	5039001000000	2831	1479	0	0	1
47544	1695	5759011000000	3049	1584	2	0	1
47549	1695	6479011000000	3724	1933	1	0	1
47550	1695	6479021000000	3724	1933	2	0	1
47562	1695	7199021000000	3846	1997	2	0	1
47564	1695	7199041000000	3846	1997	3	0	1
47580	1695	7919151000000	4360	2260	3	0	1
47592	1695	8639151000000	4377	2269	1	0	1
47594	1695	8639161000000	4377	2269	2	0	1
47466	1695	2492091000000	11073	5697	2	0	5
47493	1695	3212111000000	11277	5794	2	0	5
47494	1695	3212122000000	11277	5794	3	0	5
47509	1695	3932122000000	11606	5970	2	0	5
47511	1695	3932124000000	11606	5970	3	0	5
47523	1695	4652124000000	11686	6008	2	0	5
47537	1695	5372126000000	11697	6014	1	0	5
47538	1695	5372127000000	11697	6014	2	0	5
47545	1695	6092127000000	12877	6640	2	0	5
47546	1695	6092138000000	12877	6640	3	0	5
47554	1695	6812138000000	13945	7146	4	0	5
47565	1695	7532151000000	14167	7231	3	0	5
47566	1695	7532163000000	14167	7231	4	0	5
47581	1695	8252163000000	14466	7384	8	0	5
47582	1695	8252189000000	14466	7384	9	0	5
47473	1695	2824930999000	20254	10201	13	0	9
47475	1695	2824979999000	20254	10201	14	0	9
47497	1695	3544979999000	20598	10361	3	0	9
47498	1695	3544991999000	20598	10361	4	0	9
47513	1695	4264991999000	21444	10756	6	0	9
47525	1695	4985024999000	23257	11604	2	0	9
47526	1695	4985035999000	23257	11604	3	0	9
47527	1695	4985045999000	23412	11681	1	0	9
47540	1695	5705045999000	23412	11681	3	0	9
47541	1695	5705046999000	23412	11681	4	0	9
47548	1695	6425069999000	24486	12176	6	0	9
47559	1695	7145069999000	24488	12178	3	0	9
47560	1695	7145081999000	24488	12178	4	0	9
47568	1695	7865081999000	24678	12257	3	0	9
47585	1695	8585093999000	24947	12382	4	0	9
47589	1695	8585106999000	24947	12382	5	0	9
47607	1695	9360441000000	4764	2278	30	0	\N
47608	1695	9360531000000	4764	2278	31	0	\N
47609	1695	9692203000000	15081	7682	3	0	\N
47610	1695	9692203000000	15579	7930	3	0	\N
47611	1695	9692203000000	15595	7938	2	0	\N
47613	1695	9692205000000	15595	7938	3	0	\N
47615	1695	9692224000000	15081	7682	4	0	\N
47616	1695	9692224000000	15579	7930	4	0	\N
47617	1695	10025130999000	25964	12829	5	0	\N
47620	1695	10025153999000	25964	12829	6	0	\N
47622	1695	10412214000000	15656	7967	3	0	\N
47623	1695	10412214000000	15891	8079	4	0	\N
47625	1695	10412226000000	15656	7967	4	0	\N
47627	1695	10412227000000	15891	8079	5	0	\N
47628	1695	10412796000000	16100	8140	57	0	\N
47632	1695	11132226000000	16099	8183	3	0	\N
47635	1695	11132238000000	16099	8183	4	0	\N
47636	1695	11132796000000	16100	8140	126	0	\N
47637	1695	11132936000000	16100	8140	127	0	\N
47638	1695	11133416000000	16175	8141	57	0	\N
47639	1695	11465165999000	26207	12957	4	0	\N
47640	1695	11465165999000	26209	12957	4	0	\N
47643	1695	11465178999000	26207	12957	5	0	\N
47644	1695	11465178999000	26209	12957	5	0	\N
47647	1695	11852237000000	16351	8314	3	0	\N
47648	1695	11852237000000	16431	8356	7	0	\N
47650	1695	11852249000000	16351	8314	4	0	\N
47651	1695	11852262000000	16431	8356	8	0	\N
47653	1695	11853416000000	16175	8141	126	0	\N
47654	1695	11853484000000	16175	8141	127	0	\N
47655	1695	12185177999000	27381	13540	9	0	\N
47657	1695	12185213999000	27381	13540	10	0	\N
47658	1695	12239191000000	6129	3179	1	0	\N
47660	1695	12239201000000	6129	3179	2	0	\N
47662	1695	12572262000000	16800	8527	4	0	\N
47663	1695	12572262000000	16841	8545	3	0	\N
47665	1695	12572274000000	16841	8545	4	0	\N
47666	1695	12572275000000	16800	8527	5	0	\N
47674	1695	13292815000000	17601	8745	35	0	\N
47675	1695	13625228999000	27496	13592	3	0	\N
47677	1695	13625228999000	27527	13609	2	0	\N
47678	1695	13625239999000	27527	13609	3	0	\N
47679	1695	13625240999000	27496	13592	4	0	\N
47681	1695	13679341000000	6309	3266	1	0	\N
47683	1695	13679351000000	6309	3266	2	0	\N
47685	1695	14012285000000	17101	8618	4	0	\N
47686	1695	14012285000000	17103	8665	4	0	\N
47689	1695	14012307000000	17103	8665	5	0	\N
47690	1695	14012316000000	17101	8618	5	0	\N
47691	1695	14012586000000	17599	8619	9	0	\N
47692	1695	14012815000000	17601	8745	126	0	\N
47693	1695	14013715000000	17601	8745	127	0	\N
47694	1695	14014065000000	17670	8746	35	0	\N
47697	1695	14399351000000	6754	3496	2	0	\N
47699	1695	14399371000000	6754	3496	3	0	\N
47703	1695	14732586000000	17599	8619	13	0	\N
47704	1695	14732616000000	17599	8619	14	0	\N
47705	1695	14734065000000	17670	8746	126	0	\N
47706	1695	14734965000000	17670	8746	127	0	\N
47709	1695	15119391000000	7275	3762	1	0	\N
47710	1695	15119391000000	7831	4060	1	0	\N
47711	1695	15119391000000	8063	4178	2	0	\N
47712	1695	15119391000000	8305	4299	1	0	\N
47713	1695	15119391000000	8417	4361	0	0	\N
47715	1695	15119401000000	7275	3762	2	0	\N
47716	1695	15119401000000	7831	4060	2	0	\N
47717	1695	15119401000000	8305	4299	2	0	\N
47719	1695	15119501000000	8063	4178	3	0	\N
47720	1695	15452308000000	18356	9250	3	0	\N
47721	1695	15452308000000	18486	9310	8	0	\N
47724	1695	15452320000000	18356	9250	4	0	\N
47725	1695	15452325000000	18486	9310	9	0	\N
47726	1695	15785276999000	28142	13911	2	0	\N
47728	1695	15785287999000	28142	13911	3	0	\N
47730	1695	15839441000000	9398	4876	2	0	\N
47731	1695	15839441000000	9889	5126	2	0	\N
47732	1695	15839461000000	9398	4876	3	0	\N
47733	1695	15839461000000	9889	5126	3	0	\N
47734	1695	16172318999000	19497	9828	3	0	\N
47736	1695	16172330999000	19497	9828	4	0	\N
47606	1695	9359181000000	4968	2576	1	0	1
47621	1695	10079181000000	4968	2576	2	0	1
47631	1695	10799181000000	5672	2941	0	0	1
47645	1695	11519181000000	6065	3150	1	0	1
47646	1695	11519191000000	6065	3150	2	0	1
47661	1695	12239321000000	6221	3219	5	0	1
47670	1695	12959321000000	6235	3226	2	0	1
47671	1695	12959341000000	6235	3226	3	0	1
47682	1695	13679341000000	6341	3282	1	0	1
47684	1695	13679351000000	6341	3282	2	0	1
47700	1695	14399391000000	7025	3622	5	0	1
47714	1695	15119391000000	8877	4599	5	0	1
47718	1695	15119441000000	8877	4599	6	0	1
47601	1695	8972203000000	14883	7582	6	0	5
47614	1695	9692214000000	15615	7948	3	0	5
47624	1695	10412214000000	16001	8137	3	0	5
47626	1695	10412226000000	16001	8137	4	0	5
47633	1695	11132226000000	16174	8221	2	0	5
47634	1695	11132237000000	16174	8221	3	0	5
47652	1695	11852262000000	16676	8470	8	0	5
47664	1695	12572262000000	16875	8558	4	0	5
47667	1695	12572275000000	16875	8558	5	0	5
47672	1695	13292275000000	16960	8596	1	0	5
47673	1695	13292285000000	16960	8596	2	0	5
47688	1695	14012296000000	17669	8932	3	0	5
47701	1695	14732296000000	17923	9042	3	0	5
47702	1695	14732308000000	17923	9042	4	0	5
47722	1695	15452308000000	18881	9522	2	0	5
47735	1695	16172318999000	19602	9873	3	0	5
47602	1695	9305106999000	25042	12423	6	0	9
47603	1695	9305130999000	25042	12423	7	0	9
47618	1695	10025130999000	25973	12833	2	0	9
47619	1695	10025141999000	25973	12833	3	0	9
47630	1695	10745165999000	26164	12933	7	0	9
47641	1695	11465165999000	26677	13195	3	0	9
47642	1695	11465177999000	26677	13195	4	0	9
47656	1695	12185177999000	27474	13578	0	0	9
47668	1695	12905177999000	27484	13584	24	0	9
47676	1695	13625228999000	27525	13609	3	0	9
47680	1695	13625240999000	27525	13609	4	0	9
47695	1695	14345240999000	27979	13839	3	0	9
47696	1695	14345252999000	27979	13839	4	0	9
47708	1695	15065276999000	28115	13898	7	0	9
47727	1695	15785276999000	28316	13999	5	0	9
47729	1695	15785299999000	28316	13999	6	0	9
47740	1695	17225310999000	28710	14075	0	0	\N
47741	1695	17225310999000	28715	14092	0	0	\N
47743	1695	17225310999000	28717	14107	0	0	\N
47744	1695	17225310999000	28718	14121	0	0	\N
47750	1695	19385346999000	29014	14307	6	0	\N
47752	1695	19385370999000	29014	14307	7	0	\N
47756	1695	20825408999000	29521	14559	2	0	\N
47758	1695	20825410999000	29521	14559	3	0	\N
47760	1696	19800000	10452	5405	15	0	\N
47761	1696	100000000	10094	5236	23	1	\N
47762	1696	200000001	10453	5405	15	1	\N
47765	1696	1439010000000	95	60	1	0	\N
47766	1696	1439010000000	134	80	2	0	\N
47768	1696	1439020000000	95	60	2	0	\N
47770	1696	1439030000000	134	80	3	0	\N
47775	1696	3598061000000	2244	1183	0	0	\N
47776	1696	3598061000000	2430	1272	1	0	\N
47777	1696	3598061000000	2660	1398	1	0	\N
47778	1696	3598061000000	2661	1398	1	0	\N
47780	1696	3598071000000	2430	1272	2	0	\N
47781	1696	3598071000000	2660	1398	2	0	\N
47782	1696	3598071000000	2661	1398	2	0	\N
47784	1696	4318071000000	3142	1635	1	0	\N
47785	1696	4318071000000	3159	1642	1	0	\N
47787	1696	4318081000000	3142	1635	2	0	\N
47788	1696	4318081000000	3159	1642	2	0	\N
47790	1696	4817597840000	12725	6431	35	0	\N
47795	1696	5537596840000	12725	6431	36	0	\N
47796	1696	5538038840000	13183	6758	123	0	\N
47801	1696	6258038840000	13183	6758	126	0	\N
47802	1696	6258040840000	13183	6758	127	0	\N
47803	1696	6258424840000	13217	6759	123	0	\N
47808	1696	6978424840000	13217	6759	126	0	\N
47809	1696	6978426840000	13217	6759	127	0	\N
47813	1696	7697283840000	13233	6817	2	0	\N
47815	1696	7697285840000	13233	6817	3	0	\N
47816	1696	7698426840000	13234	6760	56	0	\N
47819	1696	8417284840000	13535	6968	5	0	\N
47820	1696	8417284840000	13538	6968	3	0	\N
47821	1696	8417284840000	13626	7005	12	0	\N
47823	1696	8417296840000	13538	6968	4	0	\N
47824	1696	8417298840000	13535	6968	6	0	\N
47825	1696	8417323840000	13626	7005	13	0	\N
47828	1696	8803473944000	12263	6036	15	1	\N
47829	1696	9137284840000	13750	7065	7	0	\N
47830	1696	9137284840000	13901	7130	31	0	\N
47831	1696	9137284840000	14061	7198	4	0	\N
47832	1696	9137284840000	14062	7198	1	0	\N
47833	1696	9137284840000	14459	7382	4	0	\N
47835	1696	9137294840000	14062	7198	2	0	\N
47837	1696	9137297840000	14061	7198	5	0	\N
47838	1696	9137297840000	14459	7382	5	0	\N
47839	1696	9137300840000	13750	7065	8	0	\N
47840	1696	9137360840000	13901	7130	32	0	\N
47841	1696	9358271000000	5327	2766	1	0	\N
47843	1696	9358271000000	5636	2928	0	0	\N
47844	1696	9358271000000	5637	2928	0	0	\N
47845	1696	9358271000000	5638	2928	0	0	\N
47846	1696	9358281000000	5327	2766	2	0	\N
47849	1696	10078271000000	6082	3157	2	0	\N
47851	1696	10078291000000	6082	3157	3	0	\N
47856	1696	11297328840000	15348	7822	1	0	\N
47859	1696	11297338840000	15348	7822	2	0	\N
47861	1696	11297349835100	16103	8185	2	0	\N
47862	1696	11297349835100	16104	8185	2	0	\N
47863	1696	11518291000000	6633	3428	2	0	\N
47865	1696	11518311000000	6633	3428	3	0	\N
47867	1696	12017338835100	15704	7986	6	0	\N
47868	1696	12017338835100	15706	7986	9	0	\N
47869	1696	12017338835100	15749	8009	14	0	\N
47871	1696	12017349835100	16103	8185	4	0	\N
47872	1696	12017349835100	16104	8185	4	0	\N
47767	1696	1439010000000	299	172	1	0	0
47769	1696	1439020000000	299	172	2	0	0
47771	1696	2158020000000	1324	728	3	0	1
47772	1696	2158041000000	1324	728	4	0	1
47773	1696	2878041000000	1967	1041	2	0	1
47779	1696	3598061000000	2736	1437	1	0	1
47783	1696	3598071000000	2736	1437	2	0	1
47786	1696	4318071000000	3834	1991	2	0	1
47789	1696	4318091000000	3834	1991	3	0	1
47791	1696	5038091000000	4242	2202	1	0	1
47797	1696	5758101000000	4294	2228	1	0	1
47798	1696	5758111000000	4294	2228	2	0	1
47804	1696	6478111000000	4370	2267	1	0	1
47805	1696	6478121000000	4370	2267	2	0	1
47811	1696	7198131000000	5099	2647	2	0	1
47817	1696	7918131000000	5124	2658	3	0	1
47818	1696	7918161000000	5124	2658	4	0	1
47826	1696	8638161000000	5137	2663	2	0	1
47827	1696	8638271000000	5137	2663	3	0	1
47850	1696	10078271000000	6084	3158	0	0	1
47854	1696	10798271000000	6358	3291	2	0	1
47855	1696	10798291000000	6358	3291	3	0	1
47864	1696	11518291000000	6827	3535	8	0	1
47866	1696	11518371000000	6827	3535	9	0	1
47794	1696	5537258840000	12726	6562	3	0	5
47799	1696	6257258840000	13182	6792	4	0	5
47800	1696	6257271840000	13182	6792	5	0	5
47806	1696	6977271840000	13216	6812	3	0	5
47812	1696	7697283840000	13231	6818	1	0	5
47814	1696	7697284840000	13231	6818	2	0	5
47822	1696	8417284840000	13629	7005	0	0	5
47834	1696	9137284840000	15074	7677	2	0	5
47836	1696	9137295840000	15074	7677	3	0	5
47852	1696	10577305840000	15217	7753	5	0	5
47853	1696	10577328840000	15217	7753	6	0	5
47857	1696	11297328840000	15349	7822	1	0	5
47858	1696	11297338835100	15349	7822	2	0	5
47860	1696	11297349835100	16102	8185	2	0	5
47870	1696	12017349835100	16102	8185	4	0	5
47737	1695	16172330999000	19602	9873	4	0	5
47738	1695	16505299999000	28360	14020	2	0	9
47739	1695	16505310999000	28360	14020	3	0	9
47745	1695	17225311999000	28716	14173	2	0	9
47746	1695	17945311999000	28867	14238	5	0	9
47747	1695	17945334999000	28867	14238	6	0	9
47748	1695	18665334999000	28980	14291	3	0	9
47749	1695	18665346999000	28980	14291	4	0	9
47753	1695	19385370999000	29487	14540	7	0	9
47754	1695	20105370999000	29518	14558	11	0	9
47755	1695	20105408999000	29518	14558	12	0	9
47757	1695	20825408999000	29689	14644	8	0	9
47759	1695	20825425999000	29689	14644	9	0	9
47874	1696	12017350835100	16103	8185	5	0	\N
47875	1696	12017350835100	16104	8185	5	0	\N
47876	1696	12017353835100	15704	7986	7	0	\N
47877	1696	12017356835100	15706	7986	10	0	\N
47878	1696	12017487835100	15749	8009	15	0	\N
47881	1696	12737350835100	16346	8312	3	0	\N
47882	1696	12737350835100	16437	8359	3	0	\N
47885	1696	12737362835100	16346	8312	4	0	\N
47886	1696	12737362835100	16437	8359	4	0	\N
47889	1696	13403606335104	22411	11218	10	0	\N
47890	1696	13403606335104	22866	11431	4	0	\N
47891	1696	13403606335104	23549	11739	7	0	\N
47892	1696	13403606335104	24284	12079	3	0	\N
47894	1696	13403618335104	24284	12079	4	0	\N
47896	1696	13403619335104	22866	11431	5	0	\N
47897	1696	13403631335104	23549	11739	8	0	\N
47898	1696	13403643335104	22411	11218	11	0	\N
47899	1696	13457352835100	16457	8370	3	0	\N
47900	1696	13457352835100	16878	8537	0	0	\N
47902	1696	13457364835100	16457	8370	4	0	\N
47904	1696	13678401000000	7302	3773	5	0	\N
47905	1696	13678401000000	7312	3779	1	0	\N
47906	1696	13678401000000	7862	4076	1	0	\N
47907	1696	13678401000000	7866	3793	16	0	\N
47908	1696	13678401000000	8401	4354	1	0	\N
47909	1696	13678401000000	8416	4361	0	0	\N
47911	1696	13678411000000	7312	3779	2	0	\N
47912	1696	13678411000000	7862	4076	2	0	\N
47913	1696	13678411000000	8401	4354	2	0	\N
47914	1696	13678451000000	7302	3773	6	0	\N
47915	1696	13678917000000	7866	3793	17	0	\N
47916	1696	14123618335104	24508	12190	2	0	\N
47918	1696	14123629335104	24508	12190	3	0	\N
47920	1696	14177352835100	16969	8538	3	0	\N
47921	1696	14177382835100	16969	8538	4	0	\N
47924	1696	14398401000000	8617	4467	1	0	\N
47925	1696	14398401000000	8687	4502	2	0	\N
47926	1696	14398401000000	9042	4689	5	0	\N
47927	1696	14398401000000	9226	4783	3	0	\N
47928	1696	14398401000000	9227	4775	1	0	\N
47929	1696	14398401000000	9317	4833	2	0	\N
47931	1696	14398411000000	8617	4467	2	0	\N
47932	1696	14398411000000	9227	4775	2	0	\N
47933	1696	14398421000000	8687	4502	3	0	\N
47934	1696	14398421000000	9317	4833	3	0	\N
47936	1696	14398431000000	9226	4783	4	0	\N
47937	1696	14398442000000	9042	4689	6	0	\N
47938	1696	14843691335104	24753	12292	4	0	\N
47940	1696	14843704335104	24753	12292	5	0	\N
47942	1696	14897382835100	17053	8539	2	0	\N
47943	1696	14897402835100	17053	8539	3	0	\N
47944	1696	14897402835100	17054	8637	4	0	\N
47945	1696	14897402835100	17055	8637	5	0	\N
47946	1696	14897402835100	17303	8764	6	0	\N
47949	1696	14897424835100	17054	8637	5	0	\N
47950	1696	14897425835100	17055	8637	6	0	\N
47951	1696	14897426835100	17303	8764	7	0	\N
47954	1696	15563716335104	24864	12347	3	0	\N
47956	1696	15563728335104	24864	12347	4	0	\N
47958	1696	15563752335104	25087	12454	6	0	\N
47960	1696	15617402835100	17301	8540	9	0	\N
47961	1696	15617414835100	17683	8939	3	0	\N
47963	1696	15617414835100	18013	9085	7	0	\N
47965	1696	15617435835100	17683	8939	4	0	\N
47966	1696	15617439835100	18013	9085	8	0	\N
47967	1696	15617465835100	17301	8540	10	0	\N
47971	1696	15838802000000	10093	5236	7	0	\N
47972	1696	15838802000000	10094	5236	7	0	\N
47973	1696	15838802000000	10095	5236	7	0	\N
47974	1696	16283752335104	25087	12454	7	0	\N
47979	1696	16558802000000	10093	5236	22	0	\N
47980	1696	16558802000000	10094	5236	22	0	\N
47981	1696	16558802000000	10095	5236	22	0	\N
47983	1696	16558906000000	10093	5236	23	0	\N
47984	1696	16558906000000	10095	5236	23	0	\N
47985	1696	16558916000000	10448	5405	1	0	\N
47986	1696	16558916000000	10452	5405	1	0	\N
47987	1696	16558916000000	10453	5405	1	0	\N
47988	1696	16558916000000	10454	5405	1	0	\N
47989	1696	17003752335104	25224	12513	3	0	\N
47990	1696	17003752335104	25912	12806	2	0	\N
47991	1696	17003752335104	25914	12806	1	0	\N
47993	1696	17003762335104	25914	12806	2	0	\N
47994	1696	17003763335104	25912	12806	3	0	\N
47996	1696	17003764335104	25224	12513	4	0	\N
47999	1696	17278906000000	10196	5280	2	0	\N
48001	1696	17278916000000	10448	5405	14	0	\N
48002	1696	17278916000000	10452	5405	14	0	\N
48003	1696	17278916000000	10453	5405	14	0	\N
48004	1696	17278916000000	10454	5405	14	0	\N
48005	1696	17278926000000	10196	5280	3	0	\N
48007	1696	17279036000000	10448	5405	15	0	\N
48008	1696	17279036000000	10454	5405	15	0	\N
47887	1696	12958391000000	7255	3752	1	0	1
47888	1696	12958401000000	7255	3752	2	0	1
47910	1696	13678401000000	8442	4375	0	0	1
47930	1696	14398401000000	9544	4949	2	0	1
47935	1696	14398421000000	9544	4949	3	0	1
47953	1696	15118442000000	9752	5052	4	0	1
47968	1696	15838442000000	9771	5063	2	0	1
47969	1696	15838462000000	9771	5063	3	0	1
47970	1696	15838802000000	10092	5236	7	0	1
47978	1696	16558802000000	10092	5236	22	0	1
48000	1696	17278906000000	10487	5420	2	0	1
48006	1696	17278926000000	10487	5420	3	0	1
47873	1696	12017350835100	16102	8185	5	0	5
47883	1696	12737350835100	16438	8359	2	0	5
47901	1696	13457352835100	16879	8561	11	0	5
47903	1696	13457390835100	16879	8561	12	0	5
47922	1696	14177390835100	16970	8599	3	0	5
47923	1696	14177402835100	16970	8599	4	0	5
47947	1696	14897402835100	17618	8910	3	0	5
47962	1696	15617414835100	18012	9086	2	0	5
47964	1696	15617425835100	18012	9086	3	0	5
47976	1696	16337425835100	18359	9253	2	0	5
47977	1696	16337436835100	18359	9253	3	0	5
47997	1696	17057436835100	18393	9270	2	0	5
47893	1696	13403606335104	24412	12141	3	0	9
47895	1696	13403618335104	24412	12141	4	0	9
47917	1696	14123618335104	24707	12271	10	0	9
47919	1696	14123691335104	24707	12271	11	0	9
47941	1696	14843716335104	24855	12342	8	0	9
47955	1696	15563716335104	24896	12361	3	0	9
47957	1696	15563728335104	24896	12361	4	0	9
47959	1696	15563752335104	25089	12454	6	0	9
47975	1696	16283752335104	25089	12454	7	0	9
47995	1696	17003763335104	25935	12818	3	0	9
48011	1696	17777447835100	19221	9696	4	0	\N
48012	1696	17777447835100	19222	9696	6	0	\N
48014	1696	17777469835100	19221	9696	5	0	\N
48015	1696	17777471835100	19222	9696	7	0	\N
48023	1696	18718957000000	10633	5492	3	0	\N
48024	1696	18718957000000	10635	5492	2	0	\N
48025	1696	18718957000000	10690	5520	2	0	\N
48026	1696	18718957000000	10986	5661	0	0	\N
48028	1696	18718968000000	11879	6105	2	0	\N
48029	1696	18718977000000	10635	5492	3	0	\N
48030	1696	18718977000000	10690	5520	3	0	\N
48031	1696	18718987000000	10633	5492	4	0	\N
48032	1696	18719017000000	11878	6035	6	0	\N
48039	1696	19438967999999	11879	6105	3	0	\N
48040	1696	19439016999999	11878	6035	7	0	\N
48041	1696	19883799335104	26285	13000	2	0	\N
48043	1696	19883810335104	26285	13000	3	0	\N
48045	1696	19883822335104	27013	13361	1	0	\N
48047	1696	19937546835100	19827	9989	3	0	\N
48048	1696	19937546835100	20336	10242	6	0	\N
48049	1696	19937546835100	20580	10354	3	0	\N
48051	1696	19937546835100	20719	10417	0	0	\N
48052	1696	19937549835100	19827	9989	4	0	\N
48053	1696	19937558835100	20580	10354	4	0	\N
48055	1696	19937570835100	20336	10242	7	0	\N
48056	1696	20159016999999	12263	6036	13	0	\N
48057	1696	20603812335104	26998	13354	3	0	\N
48058	1696	20603822335104	27013	13361	4	0	\N
48060	1696	20603824335104	26998	13354	4	0	\N
48061	1696	20603824335104	27013	13361	5	0	\N
48064	1696	20657558835100	20735	10422	4	0	\N
48066	1696	20657589835100	20735	10422	5	0	\N
48067	1696	20658879835100	20818	10423	97	0	\N
48068	1696	21323824335104	27304	13497	3	0	\N
48069	1696	21323824335104	27561	13623	4	0	\N
48070	1696	21323824335104	28014	13855	3	0	\N
48071	1696	21323824335104	28259	13971	2	0	\N
48072	1696	21323824335104	28273	13979	2	0	\N
48074	1696	21323835335104	28259	13971	3	0	\N
48075	1696	21323835335104	28273	13979	3	0	\N
48076	1696	21323836335104	27304	13497	4	0	\N
48077	1696	21323836335104	28014	13855	4	0	\N
48078	1696	21323837335104	27561	13623	5	0	\N
48082	1696	21378879835100	20818	10423	126	0	\N
48083	1696	21379096835100	20818	10423	127	0	\N
48088	1696	22099096835100	20972	10424	4	0	\N
48089	1696	22099256835100	20972	10424	5	0	\N
48092	1696	22817592835100	21160	10628	2	0	\N
48094	1696	22817603835100	21160	10628	3	0	\N
48096	1696	23483871335104	28405	14039	2	0	\N
48097	1696	23483882335104	28405	14039	3	0	\N
48098	1696	23483883335104	29039	14320	4	0	\N
48100	1696	23483883335104	29450	14521	3	0	\N
48102	1696	23483895335104	29450	14521	4	0	\N
48103	1696	23483896335104	29039	14320	5	0	\N
48104	1696	23537603835100	21249	10671	8	0	\N
48108	1696	23537637835100	21363	10722	4	0	\N
48109	1696	23537665835100	21249	10671	9	0	\N
48110	1696	24203894335104	29511	14555	7	0	\N
48111	1696	24203894335104	29710	14650	22	0	\N
48112	1696	24203894335104	29712	14650	30	0	\N
48113	1696	24203894335104	29777	14676	15	0	\N
48116	1696	24203918335104	29777	14676	16	0	\N
48117	1696	24203919335104	29511	14555	8	0	\N
48118	1696	24203943335104	29710	14650	23	0	\N
48119	1696	24203951335104	29712	14650	31	0	\N
48121	1696	24257637835100	21363	10722	7	0	\N
48123	1696	24257639835100	21363	10722	8	0	\N
48124	1696	24923916335104	30096	14816	9	0	\N
48127	1696	24923934335104	30096	14816	10	0	\N
48128	1696	24977639835100	21505	10787	6	0	\N
48131	1696	24977672835100	21505	10787	7	0	\N
48134	1696	25697651835100	21649	10846	3	0	\N
48136	1696	25697663835100	21649	10846	4	0	\N
48138	1696	26417659335104	21672	10848	0	0	\N
48027	1696	18718957000000	10987	5661	0	0	1
48037	1696	19438957000000	12262	6314	1	0	1
48038	1696	19438958000000	12262	6314	2	0	1
48013	1696	17777447835100	19223	9696	6	0	5
48016	1696	17777471835100	19223	9696	7	0	5
48022	1696	18497484835100	19300	9731	5	0	5
48035	1696	19217484835100	19317	9741	8	0	5
48036	1696	19217546835100	19317	9741	9	0	5
48050	1696	19937546835100	20718	10417	3	0	5
48054	1696	19937558835100	20718	10417	4	0	5
48065	1696	20657570835100	20733	10423	4	0	5
48080	1696	21377570835100	20814	10464	2	0	5
48081	1696	21377581835100	20814	10464	3	0	5
48086	1696	22097581835100	20971	10547	2	0	5
48093	1696	22817592835100	21161	10628	2	0	5
48095	1696	22817603835100	21161	10628	3	0	5
48105	1696	23537603835100	21341	10712	3	0	5
48106	1696	23537615835100	21341	10712	4	0	5
48107	1696	23537637835100	21362	10722	4	0	5
48122	1696	24257639835100	21362	10722	8	0	5
48129	1696	24977639835100	21584	10821	3	0	5
48130	1696	24977651835100	21584	10821	4	0	5
48133	1696	25697651335100	21651	10846	3	0	5
48135	1696	25697659335104	21651	10846	4	0	5
48139	1696	26417671335104	21659	10851	4	0	5
48140	1696	27137671335104	21671	10856	6	0	5
48141	1696	27137695335104	21671	10856	7	0	5
48142	1696	27857695335104	21728	10884	2	0	5
48144	1696	28577697335104	22096	11048	4	0	5
48009	1696	17723763335104	26036	12865	2	0	9
48010	1696	17723774335104	26036	12865	3	0	9
48019	1696	18443774335104	26186	12945	4	0	9
48020	1696	18443787335104	26186	12945	5	0	9
48034	1696	19163799335104	26248	12976	4	0	9
48042	1696	19883799335104	26892	13299	4	0	9
48044	1696	19883812335104	26892	13299	5	0	9
48046	1696	19883822335104	27016	13361	1	0	9
48059	1696	20603822335104	27016	13361	4	0	9
48073	1696	21323824335104	28346	14013	8	0	9
48079	1696	21323859335104	28346	14013	9	0	9
48084	1696	22043859335104	28400	14037	3	0	9
48085	1696	22043871335104	28400	14037	4	0	9
48091	1696	22763883335104	28599	14123	4	0	9
48099	1696	23483883335104	29449	14521	2	0	9
48101	1696	23483894335104	29449	14521	3	0	9
48114	1696	24203894335104	29779	14676	13	0	9
48115	1696	24203916335104	29779	14676	14	0	9
48126	1696	24923927335104	30097	14816	3	0	9
48132	1696	25643927335104	30152	14836	0	0	9
48147	1696	29297710335104	22114	11059	4	0	\N
48149	1696	29297723335104	22114	11059	5	0	\N
48150	1696	66000004950000	13234	6760	57	1	\N
48151	1698	100000	4910	2541	4	0	\N
48152	1698	100000017	23757	11774	126	0	\N
48153	1698	719000000000	92	57	2	0	\N
48156	1698	719020000000	92	57	3	0	\N
48157	1698	1438910000000	1139	629	1	0	\N
48159	1698	1438920000000	1139	629	2	0	\N
48161	1698	1439010000000	881	490	1	0	\N
48162	1698	1439020000000	881	490	2	0	\N
48164	1698	1976783550035	10975	5654	2	0	\N
48166	1698	1976803550035	10975	5654	3	0	\N
48176	1698	3598940000000	1530	837	1	0	\N
48178	1698	3598950000000	1530	837	2	0	\N
48184	1698	4388771550062	20991	10557	2	0	\N
48185	1698	4388771550062	21496	10781	5	0	\N
48186	1698	4388771550062	21850	10935	3	0	\N
48188	1698	4388782550062	20991	10557	3	0	\N
48189	1698	4388783550062	21850	10935	4	0	\N
48191	1698	4388803550062	21496	10781	6	0	\N
48192	1698	4856864550035	11701	6016	1	0	\N
48194	1698	4856865550035	11701	6016	2	0	\N
48196	1698	5038990000000	2077	1097	1	0	\N
48197	1698	5038990000000	2161	1141	1	0	\N
48199	1698	5039000000000	2077	1097	2	0	\N
48200	1698	5039000000000	2161	1141	2	0	\N
48204	1698	5576865550035	12131	6248	0	0	\N
48205	1698	5576865550035	12133	6248	3	0	\N
48207	1698	5576868550035	12133	6248	4	0	\N
48215	1698	6479030000000	2341	1223	3	0	\N
48217	1698	6479060000000	2341	1223	4	0	\N
48218	1698	6479560000000	2561	1321	41	0	\N
48219	1698	6548808550062	22212	11120	9	0	\N
48220	1698	6548808550062	22214	11120	9	0	\N
48221	1698	6548808550062	22307	11166	3	0	\N
48223	1698	6548820550062	22307	11166	4	0	\N
48225	1698	6548844550062	22212	11120	10	0	\N
48226	1698	6548844550062	22214	11120	10	0	\N
48231	1698	7199560000000	2561	1321	47	0	\N
48232	1698	7199610000000	2561	1321	48	0	\N
48237	1698	7919080000000	2611	1373	2	0	\N
48238	1698	7919080000000	3167	1646	1	0	\N
48240	1698	7919090000000	3167	1646	2	0	\N
48242	1698	7919100000000	2611	1373	3	0	\N
48243	1698	7919610000000	2609	1322	31	0	\N
48244	1698	7919920000000	2609	1322	32	0	\N
48249	1698	8639090000000	3322	1723	19	0	\N
48251	1698	8639280000000	3322	1723	20	0	\N
48252	1698	8708846550062	22891	11443	3	0	\N
48255	1698	8708858550062	22891	11443	4	0	\N
48256	1698	8709808550062	23757	11774	60	0	\N
48257	1698	9176956550035	13549	6972	5	0	\N
48258	1698	9176956550035	13937	7142	4	0	\N
48261	1698	9176969550035	13937	7142	5	0	\N
48262	1698	9176970550035	13549	6972	6	0	\N
48263	1698	9359090000000	3607	1872	0	0	\N
48268	1698	9429808550062	23757	11774	125	0	\N
48271	1698	10079091000000	3646	1893	0	0	\N
48275	1698	10148859550062	24105	11999	2	0	\N
48277	1698	10148870550062	24105	11999	3	0	\N
48278	1698	10616977550035	15174	7732	1	0	\N
48280	1698	10616987550035	15174	7732	2	0	\N
48158	1698	1438910000000	1268	700	1	0	1
48160	1698	1438920000000	1268	700	2	0	1
48168	1698	2158920000000	1464	797	1	0	1
48169	1698	2158930000000	1464	797	2	0	1
48172	1698	2878930000000	1515	829	1	0	1
48177	1698	3598940000000	1721	924	4	0	1
48179	1698	3598980000000	1721	924	5	0	1
48182	1698	4318980000000	2050	1083	1	0	1
48183	1698	4318990000000	2050	1083	2	0	1
48198	1698	5038990000000	2179	1149	3	0	1
48209	1698	5759020000000	2297	1205	1	0	1
48210	1698	5759030000000	2297	1205	2	0	1
48214	1698	6479030000000	2340	1223	3	0	1
48216	1698	6479060000000	2340	1223	4	0	1
48230	1698	7199080000000	2563	1350	3	0	1
48239	1698	7919080000000	3238	1681	1	0	1
48241	1698	7919090000000	3238	1681	2	0	1
48250	1698	8639090000000	3473	1803	0	0	1
48264	1698	9359090000000	3633	1883	1	0	1
48272	1698	10079091000000	3761	1951	1	0	1
48273	1698	10079101000000	3761	1951	2	0	1
48163	1698	1976783550035	10974	5654	2	0	7
48165	1698	1976803550035	10974	5654	3	0	7
48167	1698	1976813550035	11107	5713	1	0	7
48171	1698	2696823550035	11107	5713	4	0	7
48174	1698	3416823550035	11217	5762	4	0	7
48175	1698	3416863550035	11217	5762	5	0	7
48180	1698	4136863550035	11352	5830	1	0	7
48193	1698	4856864550035	11910	6127	1	0	7
48195	1698	4856865550035	11910	6127	2	0	7
48206	1698	5576865550035	12202	6285	4	0	7
48208	1698	5576907550035	12202	6285	5	0	7
48213	1698	6296907550035	12467	6424	0	0	7
48228	1698	7016931550035	13200	6802	7	0	7
48235	1698	7736931550035	13251	6825	3	0	7
48236	1698	7736943550035	13251	6825	4	0	7
48247	1698	8456943550035	13342	6876	4	0	7
48248	1698	8456956550035	13342	6876	5	0	7
48260	1698	9176966550035	14485	7392	2	0	7
48269	1698	9896966550035	15003	7643	2	0	7
48270	1698	9896977550035	15003	7643	3	0	7
48279	1698	10616977550035	15231	7758	3	0	7
48190	1698	4388783550062	21852	10936	4	0	12
48202	1698	5108783550062	22040	11021	4	0	12
48203	1698	5108796550062	22040	11021	5	0	12
48145	1696	28577710335104	22096	11048	5	0	5
48146	1696	29297710335104	22113	11059	3	0	5
48211	1698	5828796550062	22186	11102	3	0	12
48212	1698	5828808550062	22186	11102	4	0	12
48222	1698	6548808550062	22554	11284	3	0	12
48224	1698	6548820550062	22554	11284	4	0	12
48233	1698	7268820550062	22745	11374	5	0	12
48245	1698	7988834550062	22847	11425	3	0	12
48246	1698	7988846550062	22847	11425	4	0	12
48253	1698	8708846550062	23513	11720	1	0	12
48254	1698	8708847550062	23513	11720	2	0	12
48267	1698	9428859550062	23756	11830	4	0	12
48274	1698	10148859550062	24104	11999	2	0	12
48276	1698	10148870550062	24104	11999	3	0	12
48284	1698	10868870550062	24566	12213	4	0	\N
48286	1698	10868892550062	24566	12213	5	0	\N
48288	1698	11336989550035	15317	7805	2	0	\N
48290	1698	11337000550035	15317	7805	3	0	\N
48292	1698	11519111000000	3954	2056	1	0	\N
48294	1698	11519121000000	3954	2056	2	0	\N
48296	1698	11588932550062	24904	12366	3	0	\N
48297	1698	11588932550062	25040	12422	2	0	\N
48298	1698	11588932550062	25041	12422	1	0	\N
48299	1698	11588932550062	25328	12563	4	0	\N
48301	1698	11588932550062	25398	12587	3	0	\N
48302	1698	11588933550062	25041	12422	2	0	\N
48303	1698	11588943550062	25040	12422	3	0	\N
48304	1698	11588944550062	24904	12366	4	0	\N
48305	1698	11588944550062	25398	12587	4	0	\N
48307	1698	11589044550062	25328	12563	5	0	\N
48312	1698	12308966550062	25915	12807	4	0	\N
48313	1698	12308966550062	26000	12850	7	0	\N
48314	1698	12308966550062	26002	12731	9	0	\N
48317	1698	12308984550062	26002	12731	10	0	\N
48318	1698	12308988550062	25915	12807	5	0	\N
48319	1698	12309000550062	26000	12850	8	0	\N
48325	1698	13028984550062	26003	12732	4	0	\N
48327	1698	13029006550062	26003	12732	5	0	\N
48333	1698	13748992550062	27512	13601	2	0	\N
48334	1698	13749003550062	27512	13601	3	0	\N
48338	1698	14399271000000	4910	2541	3	0	\N
48339	1698	14399271000000	4911	2541	3	0	\N
48342	1698	14399301000000	4911	2541	4	0	\N
48343	1698	14469004550062	27614	13647	3	0	\N
48345	1698	14469016550062	27614	13647	4	0	\N
48353	1698	15657063550035	16691	8478	7	0	\N
48355	1698	15657088550035	16691	8478	8	0	\N
48361	1698	16377088550035	16785	8520	3	0	\N
48362	1698	16377088550035	16874	8558	4	0	\N
48363	1698	16377088550035	17182	8708	6	0	\N
48364	1698	16377088550035	17969	9063	2	0	\N
48366	1698	16377099550035	17969	9063	3	0	\N
48367	1698	16377100550035	16785	8520	4	0	\N
48368	1698	16377101550035	16874	8558	5	0	\N
48369	1698	16377103550035	17182	8708	7	0	\N
48371	1698	16559301000000	6022	3125	2	0	\N
48373	1698	16559321000000	6022	3125	3	0	\N
48379	1698	17279321000000	6830	3536	2	0	\N
48382	1698	17279341000000	6830	3536	3	0	\N
48383	1698	17349052550062	28314	13985	54	0	\N
48384	1698	17349052550062	28315	13998	2	0	\N
48385	1698	17349052550062	28673	14156	4	0	\N
48387	1698	17349063550062	28315	13998	3	0	\N
48388	1698	17349074550062	28673	14156	5	0	\N
48390	1698	17349313550062	28314	13985	55	0	\N
48391	1698	17817118550035	18092	9123	3	0	\N
48392	1698	17817118550035	18204	9173	6	0	\N
48394	1698	17817130550035	18092	9123	4	0	\N
48396	1698	17817136550035	18204	9173	7	0	\N
48397	1698	17999331000000	7277	3762	1	0	\N
48399	1698	17999341000000	7277	3762	2	0	\N
48402	1698	18537131550035	18327	9231	3	0	\N
48403	1698	18537131550035	19059	9612	2	0	\N
48404	1698	18537131550035	19097	9632	3	0	\N
48405	1698	18537131550035	19115	9643	0	0	\N
48407	1698	18537142550035	19059	9612	3	0	\N
48408	1698	18537143550035	18327	9231	4	0	\N
48409	1698	18537143550035	19097	9632	4	0	\N
48411	1698	18719331000000	7388	3815	1	0	\N
48413	1698	18719341000000	7388	3815	2	0	\N
48293	1698	11519111000000	4544	2351	2	0	1
48295	1698	11519221000000	4544	2351	3	0	1
48310	1698	12239221000000	4594	2376	2	0	1
48311	1698	12239241000000	4594	2376	3	0	1
48322	1698	12959241000000	4637	2398	2	0	1
48330	1698	13679261000000	4885	2530	1	0	1
48331	1698	13679271000000	4885	2530	2	0	1
48340	1698	14399271000000	5162	2678	1	0	1
48341	1698	14399281000000	5162	2678	2	0	1
48349	1698	15119281000000	5956	3088	1	0	1
48357	1698	15839291000000	5983	3104	1	0	1
48358	1698	15839301000000	5983	3104	2	0	1
48372	1698	16559301000000	6778	3509	2	0	1
48374	1698	16559321000000	6778	3509	3	0	1
48381	1698	17279331000000	7091	3661	2	0	1
48398	1698	17999331000000	7278	3762	0	0	1
48412	1698	18719331000000	7389	3816	3	0	1
48414	1698	18719361000000	7389	3816	4	0	1
48281	1698	10616989550035	15231	7758	4	0	7
48291	1698	11337001550035	15610	7946	4	0	7
48308	1698	12057001550035	15744	8007	4	0	7
48309	1698	12057014550035	15744	8007	5	0	7
48320	1698	12777014550035	15912	8090	3	0	7
48321	1698	12777026550035	15912	8090	4	0	7
48329	1698	13497039550035	16040	8157	5	0	7
48336	1698	14217039550035	16340	8308	4	0	7
48337	1698	14217052550035	16340	8308	5	0	7
48347	1698	14937052550035	16624	8444	2	0	7
48354	1698	15657063550035	16777	8516	7	0	7
48356	1698	15657088550035	16777	8516	8	0	7
48365	1698	16377088550035	17974	9065	8	0	7
48370	1698	16377105550035	17974	9065	9	0	7
48377	1698	17097105550035	18024	9093	4	0	7
48393	1698	17817118550035	18228	9181	4	0	7
48395	1698	17817131550035	18228	9181	5	0	7
48406	1698	18537131550035	19362	9761	4	0	7
48410	1698	18537144550035	19362	9761	5	0	7
48285	1698	10868870550062	24784	12306	17	0	12
48300	1698	11588932550062	25395	12587	7	0	12
48306	1698	11588966550062	25395	12587	8	0	12
48315	1698	12308966550062	26371	13044	6	0	12
48316	1698	12308981550062	26371	13044	7	0	12
48326	1698	13028992550062	27000	13355	3	0	12
48332	1698	13748992550062	27511	13601	3	0	12
48335	1698	13749004550062	27511	13601	4	0	12
48344	1698	14469004550062	27661	13670	3	0	12
48346	1698	14469016550062	27661	13670	4	0	12
48352	1698	15189028550062	27933	13817	4	0	12
48359	1698	15909028550062	27985	13842	3	0	12
48360	1698	15909040550062	27985	13842	4	0	12
48375	1698	16629040550062	28056	13873	3	0	12
48376	1698	16629052550062	28056	13873	4	0	12
48389	1698	17349076550062	28853	14231	7	0	12
48400	1698	18069076550062	29144	14370	3	0	12
48401	1698	18069088550062	29144	14370	4	0	12
48415	1698	18789088550062	29145	14371	2	0	12
48421	1698	19509099550062	29248	14414	4	0	\N
48422	1698	19509099550062	29249	14414	3	0	\N
48424	1698	19509111550062	29249	14414	4	0	\N
48425	1698	19509112550062	29248	14414	5	0	\N
48427	1698	19977156550035	19636	9892	3	0	\N
48429	1698	19977168550035	19636	9892	4	0	\N
48431	1698	20159371000000	7461	3859	3	0	\N
48432	1698	20159371000000	7587	3925	1	0	\N
48434	1698	20159381000000	7587	3925	2	0	\N
48436	1698	20159401000000	7461	3859	4	0	\N
48441	1698	20879381000000	7805	4047	1	0	\N
48443	1698	20879391000000	7805	4047	2	0	\N
48446	1698	20949340550062	29846	14708	0	0	\N
48448	1698	21417203550035	20198	10172	4	0	\N
48451	1698	21417225550035	20198	10172	5	0	\N
48453	1698	21599401000000	8123	4211	2	0	\N
48454	1698	21599421000000	8123	4211	3	0	\N
48456	1698	22137215550035	20404	10280	12	0	\N
48457	1698	22137215550035	20440	10294	3	0	\N
48459	1698	22137215550035	20620	10341	23	0	\N
48461	1698	22137227550035	20440	10294	4	0	\N
48462	1698	22137263550035	20404	10280	13	0	\N
48463	1698	22137373550035	20620	10341	24	0	\N
48466	1698	23039431000000	8254	4274	2	0	\N
48468	1698	23039442000000	8254	4274	3	0	\N
48470	1698	23759451000000	8437	4373	0	0	\N
48473	1698	24479461000000	8680	4498	1	0	\N
48475	1698	24479471000000	8680	4498	2	0	\N
48479	1698	25200421000000	10090	5172	85	0	\N
48480	1698	25201271000000	10140	5029	21	0	\N
48481	1698	25919571000000	10250	5176	28	0	\N
48482	1698	25919571000000	10392	5373	2	0	\N
48483	1698	25919591000000	10392	5373	3	0	\N
48484	1698	25920421000000	10090	5172	114	0	\N
48485	1698	25920701000000	10090	5172	115	0	\N
48486	1698	25921271000000	10140	5029	22	0	\N
48487	1698	25921291000000	10250	5176	29	0	\N
48488	1698	26641271000000	10141	5030	0	0	\N
48489	1699	306750126	20515	10328	11	0	\N
48492	1699	720250750126	20665	10396	13	0	\N
48495	1699	720299750126	20665	10396	14	0	\N
48496	1699	720306750126	20515	10328	23	0	\N
48497	1699	720317750126	20515	10328	24	0	\N
48498	1699	1439010000000	103	63	3	0	\N
48499	1699	1439010000000	224	132	1	0	\N
48501	1699	1439020000000	224	132	2	0	\N
48502	1699	1439040000000	103	63	4	0	\N
48508	1699	2160296750126	21562	10812	3	0	\N
48509	1699	2160296750126	21686	10863	1	0	\N
48510	1699	2160296750126	21687	10863	1	0	\N
48512	1699	2160308750126	21562	10812	4	0	\N
48513	1699	2160316750126	21686	10863	2	0	\N
48514	1699	2160316750126	21687	10863	2	0	\N
48518	1699	2625970500039	3377	1757	1	0	\N
48520	1699	2625980500039	3377	1757	2	0	\N
48521	1699	2879049000000	500	280	1	0	\N
48523	1699	2879059000000	500	280	2	0	\N
48525	1699	2880318750126	21973	10988	4	0	\N
48526	1699	2880318750126	22258	11139	4	0	\N
48527	1699	2880318750126	22456	11237	4	0	\N
48528	1699	2880318750126	22902	11447	3	0	\N
48529	1699	2880318750126	23266	11609	2	0	\N
48530	1699	2880318750126	23584	11752	4	0	\N
48531	1699	2880318750126	23793	11845	3	0	\N
48532	1699	2880318750126	24120	12006	2	0	\N
48533	1699	2880318750126	24623	12236	3	0	\N
48534	1699	2880318750126	24830	12328	3	0	\N
48535	1699	2880318750126	24980	12397	3	0	\N
48536	1699	2880318750126	24983	12398	5	0	\N
48537	1699	2880318750126	25165	12484	3	0	\N
48539	1699	2880329750126	23266	11609	3	0	\N
48540	1699	2880329750126	24120	12006	3	0	\N
48541	1699	2880330750126	22902	11447	4	0	\N
48542	1699	2880330750126	23793	11845	4	0	\N
48543	1699	2880330750126	24623	12236	4	0	\N
48544	1699	2880330750126	24830	12328	4	0	\N
48545	1699	2880330750126	24980	12397	4	0	\N
48546	1699	2880330750126	25165	12484	4	0	\N
48547	1699	2880331750126	22258	11139	5	0	\N
48548	1699	2880331750126	22456	11237	5	0	\N
48549	1699	2880331750126	23584	11752	5	0	\N
48550	1699	2880332750126	24983	12398	6	0	\N
48551	1699	2880340750126	21973	10988	5	0	\N
48500	1699	1439010000000	265	154	3	0	0
48503	1699	1439040000000	265	154	4	0	0
48506	1699	2159040000000	343	196	1	0	0
48507	1699	2159050000000	343	196	2	0	0
48522	1699	2879049000000	662	368	4	0	1
48519	1699	2625970500039	3614	1875	0	0	2
48419	1698	19439361000000	7406	3827	1	0	1
48420	1698	19439371000000	7406	3827	2	0	1
48433	1698	20159371000000	7787	4038	1	0	1
48435	1698	20159381000000	7787	4038	2	0	1
48517	1699	2373839000078	7790	4040	2	0	4
48442	1698	20879381000000	7926	4109	2	0	1
48444	1698	20879401000000	7926	4109	3	0	1
48452	1698	21599401000000	8121	4211	0	0	1
48465	1698	22319431000000	8194	4248	4	0	1
48467	1698	23039431000000	8373	4339	2	0	1
48469	1698	23039451000000	8373	4339	3	0	1
48471	1698	23759451000000	8455	4381	1	0	1
48472	1698	23759461000000	8455	4381	2	0	1
48476	1698	24479491000000	8801	4563	4	0	1
48477	1698	25199491000000	9262	4803	8	0	1
48478	1698	25199571000000	9262	4803	9	0	1
48417	1698	19257144550035	19498	9829	3	0	7
48418	1698	19257156550035	19498	9829	4	0	7
48430	1698	19977190550035	19815	9980	8	0	7
48439	1698	20697190550035	20021	10078	4	0	7
48440	1698	20697203550035	20021	10078	5	0	7
48449	1698	21417203550035	20266	10207	3	0	7
48458	1698	22137215550035	20619	10372	5	0	7
48460	1698	22137220550035	20619	10372	6	0	7
48493	1699	720250750126	20752	10433	5	0	7
48494	1699	720264750126	20752	10433	6	0	7
48504	1699	1440264750126	20856	10482	4	0	7
48511	1699	2160296750126	21695	10867	4	0	7
48515	1699	2160318750126	21695	10867	5	0	7
48538	1699	2880318750126	25285	12542	6	0	7
48552	1699	2880342750126	25285	12542	7	0	7
48423	1698	19509099550062	29446	14518	6	0	12
48437	1698	20229312550062	29820	14693	19	0	12
48438	1698	20229340550062	29820	14693	20	0	12
48445	1698	20949340550062	29844	14709	5	0	12
48447	1698	20949354550062	29844	14709	6	0	12
48553	1699	2880362750126	26668	13190	2	0	\N
48555	1699	2949722750126	12616	6509	2	0	\N
48556	1699	2949722750126	12654	6528	7	0	\N
48557	1699	2949722750126	13105	6755	1	0	\N
48558	1699	2949722750126	13107	6755	4	0	\N
48559	1699	2949722750126	13133	6770	4	0	\N
48560	1699	2949722750126	13264	6833	8	0	\N
48561	1699	2949722750126	13293	6847	6	0	\N
48562	1699	2949722750126	13334	6872	10	0	\N
48563	1699	2949722750126	13543	6970	3	0	\N
48565	1699	2949732750126	13105	6755	2	0	\N
48566	1699	2949733750126	12616	6509	3	0	\N
48567	1699	2949734750126	13543	6970	4	0	\N
48568	1699	2949735750126	13107	6755	5	0	\N
48569	1699	2949735750126	13133	6770	5	0	\N
48571	1699	2949746750126	13293	6847	7	0	\N
48572	1699	2949756750126	12654	6528	8	0	\N
48573	1699	2949757750126	13264	6833	9	0	\N
48574	1699	2949759750126	13334	6872	11	0	\N
48575	1699	3093839000078	8096	4197	2	0	\N
48576	1699	3093839000078	8097	4197	2	0	\N
48578	1699	3093850000078	8096	4197	3	0	\N
48579	1699	3093850000078	8097	4197	3	0	\N
48585	1699	3489912500051	5335	2769	1	0	\N
48587	1699	3489922500051	5335	2769	2	0	\N
48588	1699	3599089000000	987	546	1	0	\N
48590	1699	3599099000000	987	546	2	0	\N
48592	1699	3600342750126	25512	12633	3	0	\N
48593	1699	3600342750126	25922	12809	2	0	\N
48594	1699	3600342750126	26182	12944	3	0	\N
48595	1699	3600342750126	26384	13049	4	0	\N
48596	1699	3600342750126	26852	13283	3	0	\N
48597	1699	3600342750126	26972	13339	3	0	\N
48598	1699	3600353750126	25922	12809	3	0	\N
48599	1699	3600354750126	25512	12633	4	0	\N
48600	1699	3600354750126	26182	12944	4	0	\N
48601	1699	3600354750126	26852	13283	4	0	\N
48602	1699	3600354750126	26972	13339	4	0	\N
48603	1699	3600355750126	26384	13049	5	0	\N
48604	1699	3600362750126	26668	13190	8	0	\N
48607	1699	3600367750126	26668	13190	9	0	\N
48612	1699	4065980500039	3955	2056	1	0	\N
48614	1699	4065990500039	3955	2056	2	0	\N
48618	1699	4174067050108	11426	5792	18	0	\N
48623	1699	4320364750126	28084	13885	6	0	\N
48624	1699	4320364750126	28175	13929	2	0	\N
48625	1699	4320364750126	28549	14104	2	0	\N
48626	1699	4320364750126	28711	14173	1	0	\N
48627	1699	4320364750126	29050	14326	3	0	\N
48628	1699	4320364750126	29166	14374	0	0	\N
48629	1699	4320364750126	29327	14452	2	0	\N
48630	1699	4320364750126	29531	14563	4	0	\N
48631	1699	4320364750126	29825	14696	11	0	\N
48632	1699	4320364750126	29867	14721	10	0	\N
48633	1699	4320364750126	29894	14731	10	0	\N
48634	1699	4320364750126	29936	14745	10	0	\N
48635	1699	4320365750126	28711	14173	2	0	\N
48636	1699	4320375750126	28175	13929	3	0	\N
48637	1699	4320375750126	28549	14104	3	0	\N
48638	1699	4320375750126	29327	14452	3	0	\N
48639	1699	4320376750126	29050	14326	4	0	\N
48640	1699	4320377750126	29531	14563	5	0	\N
48641	1699	4320383750126	29894	14731	11	0	\N
48642	1699	4320388750126	28084	13885	7	0	\N
48643	1699	4320392750126	29867	14721	11	0	\N
48644	1699	4320392750126	29936	14745	11	0	\N
48645	1699	4320393750126	29825	14696	12	0	\N
48652	1699	4893887050108	11194	5747	2	0	\N
48655	1699	4893907050108	11194	5747	3	0	\N
48656	1699	4894067050108	11426	5792	126	0	\N
48657	1699	4895137060108	11504	5793	18	0	\N
48660	1699	5039109000000	1396	763	1	0	\N
48662	1699	5039119000000	1396	763	2	0	\N
48666	1699	5254100000078	8270	4283	1	0	\N
48667	1699	5254100000078	8378	4342	4	0	\N
48669	1699	5254110000078	8270	4283	2	0	\N
48671	1699	5254329000078	8378	4342	5	0	\N
48672	1699	5506010500039	4269	2213	1	0	\N
48674	1699	5506020500039	4269	2213	2	0	\N
48678	1699	5615137060108	11504	5793	39	0	\N
48679	1699	5649942500051	6498	3349	0	0	\N
48681	1699	5649942500051	6536	3350	0	0	\N
48682	1699	5649942500051	6556	3364	0	0	\N
48684	1699	5759159000000	1416	771	1	0	\N
48686	1699	5759169000000	1416	771	2	0	\N
48688	1699	5829779750126	15018	7653	3	0	\N
48621	1699	4319099000000	1330	732	1	0	1
48622	1699	4319109000000	1330	732	2	0	1
48661	1699	5039109000000	1399	765	5	0	1
48663	1699	5039159000000	1399	765	6	0	1
48685	1699	5759159000000	1452	791	1	0	1
48581	1699	3345970500039	3898	2024	1	0	2
48582	1699	3345980500039	3898	2024	2	0	2
48613	1699	4065980500039	4126	2145	1	0	2
48615	1699	4065990500039	4126	2145	2	0	2
48650	1699	4785990500039	4141	2154	2	0	2
48673	1699	5506010500039	4426	2295	1	0	2
48675	1699	5506020500039	4426	2295	2	0	2
48586	1699	3489912500051	5627	2922	0	0	3
48619	1699	4209912500051	6289	3258	2	0	3
48658	1699	4929932500051	6347	3284	1	0	3
48659	1699	4929942500051	6347	3284	2	0	3
48680	1699	5649942500051	6500	3368	2	0	3
48683	1699	5649962500051	6500	3368	3	0	3
48577	1699	3093839000078	8182	4240	4	0	4
48610	1699	3813879000078	8203	4252	3	0	4
48611	1699	3814089000078	8203	4252	4	0	4
48648	1699	4534089000078	8264	4279	2	0	4
48649	1699	4534100000078	8264	4279	3	0	4
48668	1699	5254100000078	8598	4458	1	0	4
48583	1699	3453836050108	10316	5337	5	0	5
48584	1699	3453877050108	10316	5337	6	0	5
48616	1699	4173877050108	10777	5563	1	0	5
48617	1699	4173887050108	10777	5563	2	0	5
48654	1699	4893898050108	11424	5869	3	0	5
48676	1699	5613898050108	11503	5909	3	0	5
48677	1699	5613910050108	11503	5909	4	0	5
48564	1699	2949722750126	13582	6986	4	0	6
48570	1699	2949735750126	13582	6986	5	0	6
48609	1699	3669746750126	14768	7521	3	0	6
48646	1699	4389746750126	14828	7559	4	0	6
48647	1699	4389768750126	14828	7559	5	0	6
48664	1699	5109768750126	14873	7577	2	0	6
48665	1699	5109779750126	14873	7577	3	0	6
48605	1699	3600363750126	27780	13726	5	0	7
48606	1699	3600364750126	27780	13726	6	0	7
48689	1699	5829779750126	15036	7662	1	0	\N
48690	1699	5829779750126	15060	7671	4	0	\N
48691	1699	5829779750126	15123	7708	1	0	\N
48692	1699	5829779750126	15219	7754	5	0	\N
48694	1699	5829789750126	15036	7662	2	0	\N
48695	1699	5829789750126	15123	7708	2	0	\N
48697	1699	5829791750126	15018	7653	4	0	\N
48698	1699	5829802750126	15219	7754	6	0	\N
48699	1699	5829810750126	15060	7671	5	0	\N
48704	1699	6369962500051	6538	3387	2	0	\N
48706	1699	6369982500051	6538	3387	3	0	\N
48710	1699	6549790750126	15507	7892	2	0	\N
48711	1699	6549790750126	15574	7928	1	0	\N
48712	1699	6549790750126	15955	8112	3	0	\N
48713	1699	6549790750126	15989	8128	3	0	\N
48714	1699	6549790750126	16654	8461	7	0	\N
48716	1699	6549800750126	15574	7928	2	0	\N
48717	1699	6549801750126	15507	7892	3	0	\N
48718	1699	6549802750126	15955	8112	4	0	\N
48719	1699	6549802750126	15989	8128	4	0	\N
48720	1699	6549815750126	16654	8461	8	0	\N
48726	1699	7199179000000	1813	970	1	0	\N
48728	1699	7199189000000	1813	970	2	0	\N
48730	1699	7269827750126	16852	8551	3	0	\N
48733	1699	7269839750126	16852	8551	4	0	\N
48734	1699	7269864750126	18475	9308	8	0	\N
48741	1699	7989838750126	18892	9530	2	0	\N
48742	1699	7989838750126	19002	9582	0	0	\N
48743	1699	7989838750126	19071	9619	2	0	\N
48744	1699	7989838750126	19631	9889	7	0	\N
48745	1699	7989838750126	19682	9913	9	0	\N
48747	1699	7989849750126	18892	9530	3	0	\N
48748	1699	7989849750126	19071	9619	3	0	\N
48749	1699	7989863750126	19631	9889	8	0	\N
48750	1699	7989864750126	18475	9308	9	0	\N
48751	1699	7989910750126	19682	9913	10	0	\N
48753	1699	8134160000078	9116	4724	4	0	\N
48756	1699	8134200000078	9116	4724	5	0	\N
48759	1699	8854180000078	9583	4972	4	0	\N
48760	1699	8854180000078	9677	5022	4	0	\N
48763	1699	8854220000078	9583	4972	5	0	\N
48764	1699	8854220000078	9677	5022	5	0	\N
48765	1699	9359209000000	2607	1372	1	0	\N
48767	1699	9359219000000	2607	1372	2	0	\N
48769	1699	9574210000078	10212	5288	6	0	\N
48770	1699	9574210000078	10283	5322	2	0	\N
48772	1699	9574230000078	10283	5322	3	0	\N
48774	1699	9574270000078	10212	5288	7	0	\N
48775	1699	10079229000000	2639	1388	1	0	\N
48776	1699	10079229000000	2669	1402	2	0	\N
48778	1699	10079239000000	2639	1388	2	0	\N
48779	1699	10079249000000	2669	1402	3	0	\N
48783	1699	66000004950000	11426	5792	127	1	\N
48784	1699	66000100000000	11504	5793	40	1	\N
48785	1700	719000000000	97	60	1	0	\N
48787	1700	719010000000	97	60	2	0	\N
48793	1700	2159110000000	1148	632	1	0	\N
48795	1700	2159120000000	1148	632	2	0	\N
48800	1700	2465770276737	10318	5338	9	0	\N
48801	1700	2879110000000	1406	768	2	0	\N
48804	1700	2879130000000	1406	768	3	0	\N
48806	1700	3185770276737	10318	5338	11	0	\N
48807	1700	3185780276737	10318	5338	12	0	\N
48810	1700	3834155979053	20571	10351	6	0	\N
48811	1700	3834155979053	20572	10351	8	0	\N
48812	1700	3834155979053	21050	10578	2	0	\N
48813	1700	3834155979053	21053	10578	2	0	\N
48814	1700	3834155979053	21134	10614	4	0	\N
48815	1700	3834155979053	21137	10614	2	0	\N
48816	1700	3834155979053	21783	10906	3	0	\N
48817	1700	3834155979053	21785	10906	3	0	\N
48818	1700	3834155979053	22341	11183	10	0	\N
48820	1700	3834166979053	21050	10578	3	0	\N
48821	1700	3834166979053	21053	10578	3	0	\N
48822	1700	3834167979053	21783	10906	4	0	\N
48823	1700	3834167979053	21785	10906	4	0	\N
48824	1700	3834170979053	20571	10351	7	0	\N
48789	1700	1439010000000	1093	605	10	0	0
48790	1700	1439110000000	1093	605	11	0	0
48794	1700	2159110000000	1158	638	1	0	0
48796	1700	2159120000000	1158	638	2	0	0
48802	1700	2879110000000	1439	784	1	0	1
48808	1700	3599120000000	1606	868	2	0	1
48809	1700	3599140000000	1606	868	3	0	1
48708	1699	6479169000000	1744	936	1	0	1
48709	1699	6479179000000	1744	936	2	0	1
48727	1699	7199179000000	1900	1013	1	0	1
48739	1699	7919189000000	2126	1121	1	0	1
48740	1699	7919199000000	2126	1121	2	0	1
48757	1699	8639199000000	2587	1363	1	0	1
48758	1699	8639209000000	2587	1363	2	0	1
48768	1699	9359229000000	2624	1380	3	0	1
48777	1699	10079229000000	2817	1473	2	0	1
48780	1699	10079249000000	2817	1473	3	0	1
48781	1699	10799249000000	2861	1497	1	0	1
48782	1699	10799259000000	2861	1497	2	0	1
48707	1699	6369982500051	6557	3397	3	0	3
48724	1699	7089982500051	6642	3434	4	0	3
48725	1699	7090022500051	6642	3434	5	0	3
48737	1699	7810022500051	7447	3850	1	0	3
48738	1699	7810032500051	7447	3850	2	0	3
48701	1699	5974120000078	8650	4482	2	0	4
48722	1699	6694120000078	8668	4489	2	0	4
48723	1699	6694140000078	8668	4489	3	0	4
48735	1699	7414140000078	8976	4656	2	0	4
48754	1699	8134160000078	9151	4741	2	0	4
48755	1699	8134180000078	9151	4741	3	0	4
48761	1699	8854180000078	9780	5068	3	0	4
48762	1699	8854210000078	9780	5068	4	0	4
48791	1700	1745640276737	9990	5179	2	0	6
48797	1700	2465660276737	10272	5315	2	0	6
48798	1700	2465680276737	10272	5315	3	0	6
48771	1699	9574210000078	10285	5322	3	0	4
48773	1699	9574240000078	10285	5322	4	0	4
48799	1700	2465770276737	10317	5338	9	0	6
48702	1699	6333910050108	12072	6215	1	0	5
48703	1699	6333911050108	12072	6215	2	0	5
48693	1699	5829779750126	15472	7879	2	0	6
48696	1699	5829790750126	15472	7879	3	0	6
48721	1699	6549827750126	16748	8502	11	0	6
48731	1699	7269827750126	16983	8603	2	0	6
48732	1699	7269838750126	16983	8603	3	0	6
48746	1699	7989838750126	19800	9971	8	0	6
48752	1699	7990251750126	19800	9971	9	0	6
48825	1700	3834175979053	21137	10614	3	0	\N
48826	1700	3834177979053	21134	10614	5	0	\N
48828	1700	3834190979053	20572	10351	9	0	\N
48829	1700	3834192979053	22341	11183	11	0	\N
48832	1700	4319140000000	1614	873	1	0	\N
48833	1700	4319140000000	1897	1011	1	0	\N
48834	1700	4319140000000	2100	1109	1	0	\N
48835	1700	4319140000000	2103	1109	1	0	\N
48837	1700	4319150000000	1614	873	2	0	\N
48838	1700	4319150000000	1897	1011	2	0	\N
48839	1700	4319150000000	2100	1109	2	0	\N
48840	1700	4319150000000	2103	1109	2	0	\N
48842	1700	4554189979053	22453	11236	3	0	\N
48845	1700	4554201979053	22453	11236	4	0	\N
48846	1700	4625800276737	10388	5371	3	0	\N
48847	1700	4625800276737	10389	5371	2	0	\N
48848	1700	4625800276737	10532	5438	4	0	\N
48849	1700	4625800276737	10886	5614	4	0	\N
48850	1700	4625800276737	10887	5614	4	0	\N
48852	1700	4625811276737	10389	5371	3	0	\N
48853	1700	4625821276737	10388	5371	4	0	\N
48854	1700	4625831276737	10532	5438	5	0	\N
48855	1700	4625840276737	10886	5614	5	0	\N
48856	1700	4625840276737	10887	5614	5	0	\N
48858	1700	5039150000000	2350	1229	2	0	\N
48860	1700	5039170000000	2350	1229	3	0	\N
48862	1700	5274200979053	22657	11328	3	0	\N
48863	1700	5274200979053	22659	11328	2	0	\N
48865	1700	5274211979053	22659	11328	3	0	\N
48866	1700	5274212979053	22657	11328	4	0	\N
48872	1700	5994212979053	23559	11741	6	0	\N
48874	1700	5994212979053	23663	11785	2	0	\N
48875	1700	5994223979053	23663	11785	3	0	\N
48877	1700	5994227979053	23559	11741	7	0	\N
48878	1700	6065860276737	11237	5773	2	0	\N
48879	1700	6065860276737	11509	5912	2	0	\N
48880	1700	6065860276737	11510	5912	0	0	\N
48883	1700	6065871276737	11237	5773	3	0	\N
48884	1700	6065871276737	11509	5912	3	0	\N
48885	1700	6065906276737	12505	6438	9	0	\N
48886	1700	6479300000000	2748	1436	0	0	\N
48887	1700	6479300000000	2749	1441	1	0	\N
48888	1700	6479300000000	2752	1440	0	0	\N
48889	1700	6479300000000	2756	1442	1	0	\N
48890	1700	6479300000000	2757	1442	2	0	\N
48891	1700	6479300000000	2902	1515	1	0	\N
48893	1700	6479310000000	2749	1441	2	0	\N
48894	1700	6479310000000	2756	1442	2	0	\N
48895	1700	6479310000000	2902	1515	2	0	\N
48896	1700	6479320000000	2757	1442	3	0	\N
48900	1700	6741861276737	12504	6442	2	0	\N
48901	1700	6741872276737	12504	6442	3	0	\N
48902	1700	6785861276737	12314	6346	1	0	\N
48904	1700	6785862276737	12314	6346	2	0	\N
48906	1700	6785906276737	12505	6438	10	0	\N
48907	1700	7199420000000	3502	1818	0	0	\N
48908	1700	7199420000000	4205	2188	5	0	\N
48909	1700	7199420000000	4206	2188	2	0	\N
48912	1700	7199440000000	4206	2188	3	0	\N
48913	1700	7199560000000	4205	2188	6	0	\N
48914	1700	7434236979053	24273	12076	4	0	\N
48916	1700	7434258979053	24273	12076	5	0	\N
48917	1700	7505872276737	12738	6568	1	0	\N
48918	1700	7505872276737	12739	6568	2	0	\N
48920	1700	7505882276737	12738	6568	2	0	\N
48921	1700	7505883276737	12739	6568	3	0	\N
48923	1700	7919430000000	4744	2453	2	0	\N
48926	1700	7919450000000	4744	2453	3	0	\N
48927	1700	8154236979053	24461	12164	2	0	\N
48929	1700	8154247979053	24461	12164	3	0	\N
48931	1700	8225885276737	14528	7410	2	0	\N
48934	1700	8225896276737	14528	7410	3	0	\N
48935	1700	8639440000000	4880	2528	3	0	\N
48938	1700	8639470000000	4880	2528	4	0	\N
48939	1700	8874247979053	25247	12521	7	0	\N
48941	1700	8874247979053	25341	12566	2	0	\N
48942	1700	8874258979053	25341	12566	3	0	\N
48944	1700	8874272979053	25247	12521	8	0	\N
48947	1700	9359450000000	5296	2752	1	0	\N
48949	1700	9359460000000	5296	2752	2	0	\N
48955	1700	10079470000000	5684	2946	0	0	\N
48859	1700	5039150000000	2390	1249	2	0	1
48861	1700	5039260000000	2390	1249	3	0	1
48870	1700	5759260000000	2496	1307	4	0	1
48871	1700	5759300000000	2496	1307	5	0	1
48892	1700	6479300000000	3121	1622	12	0	1
48910	1700	7199420000000	4291	2225	1	0	1
48911	1700	7199430000000	4291	2225	2	0	1
48924	1700	7919430000000	4755	2457	1	0	1
48925	1700	7919440000000	4755	2457	2	0	1
48936	1700	8639440000000	5155	2674	1	0	1
48948	1700	9359450000000	5362	2784	2	0	1
48950	1700	9359470000000	5362	2784	3	0	1
48956	1700	10079470000000	5744	2976	2	0	1
48957	1700	10079490000000	5744	2976	3	0	1
48831	1700	3905800276737	10334	5349	4	0	6
48851	1700	4625800276737	10888	5614	4	0	6
48857	1700	4625840276737	10888	5614	5	0	6
48868	1700	5345840276737	10902	5622	2	0	6
48869	1700	5345860276737	10902	5622	3	0	6
48882	1700	6065861276737	11999	6175	2	0	6
48903	1700	6785861276737	12506	6442	2	0	6
48905	1700	6785872276737	12506	6442	3	0	6
48919	1700	7505872276737	14214	7256	4	0	6
48922	1700	7505885276737	14214	7256	5	0	6
48933	1700	8225886276737	14579	7433	2	0	6
48945	1700	8945886276737	14747	7507	4	0	6
48946	1700	8945908276737	14747	7507	5	0	6
48953	1700	9665908276737	15006	7644	5	0	6
48960	1700	10385931276737	15176	7733	3	0	6
48827	1700	3834189979053	22342	11183	8	0	10
48843	1700	4554189979053	22454	11236	2	0	10
48844	1700	4554200979053	22454	11236	3	0	10
48864	1700	5274200979053	23051	11509	3	0	10
48873	1700	5994212979053	23661	11785	3	0	10
48876	1700	5994224979053	23661	11785	4	0	10
48898	1700	6714224979053	23727	11817	3	0	10
48899	1700	6714236979053	23727	11817	4	0	10
48915	1700	7434236979053	24435	12151	0	0	10
48930	1700	8154247979053	24532	12196	3	0	10
48940	1700	8874247979053	25339	12566	3	0	10
48943	1700	8874259979053	25339	12566	4	0	10
48951	1700	9594259979053	25980	12838	2	0	10
48958	1700	10314270979053	26088	12893	2	0	10
48959	1700	10314281979053	26088	12893	3	0	10
48962	1700	10799490000000	5951	3084	1	0	\N
48964	1700	10799500000000	5951	3084	2	0	\N
48966	1700	11034281979053	26152	12928	6	0	\N
48967	1700	11034281979053	26327	13020	1	0	\N
48969	1700	11034291979053	26327	13020	2	0	\N
48971	1700	11034305979053	26152	12928	7	0	\N
48979	1700	11825980276737	15904	8087	6	0	\N
48980	1700	11825980276737	15905	8087	6	0	\N
48981	1700	11825980276737	15907	8087	6	0	\N
48982	1700	12239530000000	6581	3405	2	0	\N
48983	1700	12239530000000	6959	3590	2	0	\N
48984	1700	12239530000000	7167	3701	1	0	\N
48985	1700	12239530000000	7443	3848	1	0	\N
48987	1700	12239540000000	7167	3701	2	0	\N
48988	1700	12239540000000	7443	3848	2	0	\N
48989	1700	12239550000000	6581	3405	3	0	\N
48990	1700	12239550000000	6959	3590	3	0	\N
48992	1700	12474304979053	27010	13359	1	0	\N
48993	1700	12474304979053	27011	13359	3	0	\N
48994	1700	12474304979053	27161	13431	3	0	\N
48996	1700	12474305979053	27010	13359	2	0	\N
48997	1700	12474316979053	27011	13359	4	0	\N
48998	1700	12474316979053	27161	13431	4	0	\N
49002	1700	12545980276737	15904	8087	7	0	\N
49003	1700	12545980276737	15905	8087	7	0	\N
49004	1700	12545980276737	15907	8087	7	0	\N
49005	1700	12959550000000	8141	4222	1	0	\N
49007	1700	12959560000000	8141	4222	2	0	\N
49009	1700	13194316979053	27696	13686	2	0	\N
49010	1700	13194316979053	27698	13513	99	0	\N
49011	1700	13194316979053	28293	13978	0	0	\N
49013	1700	13194327979053	27696	13686	3	0	\N
49015	1700	13194550979053	27698	13513	100	0	\N
49016	1700	13265968276737	16367	8325	2	0	\N
49018	1700	13265968276737	16369	8325	2	0	\N
49019	1700	13265970276737	16367	8325	3	0	\N
49021	1700	13265970276737	16369	8325	3	0	\N
49024	1700	13914327979053	28389	13989	7	0	\N
49025	1700	13914327979053	28392	14033	3	0	\N
49027	1700	13914348979053	28392	14033	4	0	\N
49029	1700	13914370979053	28389	13989	8	0	\N
49030	1700	13985970276737	16594	8432	3	0	\N
49033	1700	13985982276737	16594	8432	4	0	\N
49034	1700	14399570000000	8575	4444	1	0	\N
49036	1700	14399580000000	8575	4444	2	0	\N
49042	1700	15119590000000	8896	4610	2	0	\N
49043	1700	15119590000000	8897	4609	8	0	\N
49044	1700	15119590000000	8898	4610	4	0	\N
49046	1700	15119590000000	9255	4800	7	0	\N
49047	1700	15119610000000	8896	4610	3	0	\N
49048	1700	15119630000000	8898	4610	5	0	\N
49050	1700	15119660000000	9255	4800	8	0	\N
49051	1700	15119670000000	8897	4609	9	0	\N
49056	1700	15839660000000	9258	4801	8	0	\N
49057	1700	15839660000000	9517	4935	2	0	\N
49058	1700	15839660000000	9917	5146	3	0	\N
49059	1700	15839680000000	9517	4935	3	0	\N
49060	1700	15839681000000	9917	5146	4	0	\N
49061	1700	15839740000000	9258	4801	9	0	\N
49062	1700	16074386979053	28780	14196	6	0	\N
49065	1700	16074410979053	28780	14196	7	0	\N
49068	1700	16794392979053	28976	14289	6	0	\N
49069	1700	16794392979053	29101	14346	10	0	\N
49070	1700	16794392979053	29177	14385	3	0	\N
49072	1700	16794404979053	29177	14385	4	0	\N
49074	1700	16794416979053	28976	14289	7	0	\N
49075	1700	16794429979053	29101	14346	11	0	\N
49081	1700	17586027276737	18217	9171	0	0	\N
49083	1700	17586061276737	18596	9370	3	0	\N
49084	1700	17586061276737	18597	9370	3	0	\N
49087	1700	18306040276737	18672	9407	4	0	\N
49089	1700	18306061276737	18596	9370	6	0	\N
49090	1700	18306061276737	18597	9370	6	0	\N
49091	1700	18306062276737	18672	9407	5	0	\N
49092	1700	18306063276737	18596	9370	7	0	\N
49093	1700	18306063276737	18597	9370	7	0	\N
49095	1700	19026081276737	18710	9425	1	0	\N
48973	1700	11519510000000	6468	3351	2	0	1
48974	1700	11519530000000	6468	3351	3	0	1
48986	1700	12239530000000	7470	3864	2	0	1
48991	1700	12239550000000	7470	3864	3	0	1
49006	1700	12959550000000	8368	4336	1	0	1
49022	1700	13679560000000	8391	4348	1	0	1
49023	1700	13679570000000	8391	4348	2	0	1
49035	1700	14399570000000	8704	4512	2	0	1
49037	1700	14399590000000	8704	4512	3	0	1
49045	1700	15119590000000	9254	4800	7	0	1
48961	1700	10385943276737	15176	7733	4	0	6
48972	1700	11105943276737	15450	7869	0	0	6
48977	1700	11825943276737	15517	7896	4	0	6
48978	1700	11825956276737	15517	7896	5	0	6
49001	1700	12545968276737	16048	8162	4	0	6
49017	1700	13265968276737	16368	8325	2	0	6
49020	1700	13265970276737	16368	8325	3	0	6
49031	1700	13985970276737	17124	8677	2	0	6
49032	1700	13985981276737	17124	8677	3	0	6
49041	1700	14705993276737	17318	8774	4	0	6
49054	1700	15425993276737	17322	8776	3	0	6
49055	1700	15426005276737	17322	8776	4	0	6
49066	1700	16146005276737	17520	8871	2	0	6
49067	1700	16146016276737	17520	8871	3	0	6
49077	1700	16866027276737	18111	9136	3	0	6
49080	1700	17586027276737	18215	9176	4	0	6
49082	1700	17586040276737	18215	9176	5	0	6
49088	1700	18306040276737	18678	9409	5	0	6
49096	1700	19026081276737	18726	9435	3	0	6
48968	1700	11034281979053	26328	13020	2	0	10
48970	1700	11034292979053	26328	13020	3	0	10
48975	1700	11754292979053	26945	13328	3	0	10
48976	1700	11754304979053	26945	13328	4	0	10
48999	1700	12474316979053	27171	13436	4	0	10
49012	1700	13194316979053	28295	13986	2	0	10
49014	1700	13194327979053	28295	13986	3	0	10
49026	1700	13914327979053	28561	14109	9	0	10
49028	1700	13914363979053	28561	14109	10	0	10
49039	1700	14634375979053	28647	14143	4	0	10
49052	1700	15354375979053	28743	14182	2	0	10
49053	1700	15354386979053	28743	14182	3	0	10
49063	1700	16074386979053	28906	14257	6	0	10
49071	1700	16794392979053	29195	14392	5	0	10
49073	1700	16794415979053	29195	14392	6	0	10
49078	1700	17514415979053	29289	14433	7	0	10
49079	1700	17514440979053	29289	14433	8	0	10
49085	1700	18234440979053	29297	14437	3	0	10
49097	1700	19026091276737	18710	9425	2	0	\N
49101	1700	20466104276737	19175	9675	3	0	\N
49103	1700	20466104276737	19212	9692	3	0	\N
49104	1700	20466116276737	19175	9675	4	0	\N
49105	1700	20466116276737	19212	9692	4	0	\N
49107	1700	21186117276737	19358	9759	15	0	\N
49108	1700	21186117276737	19511	9832	4	0	\N
49110	1700	21186117276737	19559	9850	2	0	\N
49111	1700	21186128276737	19559	9850	3	0	\N
49112	1700	21186130276737	19511	9832	5	0	\N
49114	1700	21186195276737	19358	9759	16	0	\N
49116	1700	21906130276737	20181	9899	99	0	\N
49118	1700	21907732276737	20181	9899	100	0	\N
49122	1701	1439030000000	173	103	2	0	\N
49124	1701	1439050000000	173	103	3	0	\N
49126	1701	1510063600056	9988	5178	6	0	\N
49127	1701	1510063600056	9997	5183	2	0	\N
49129	1701	1510083600056	9997	5183	3	0	\N
49130	1701	1510123600056	9988	5178	7	0	\N
49135	1701	2159060000000	211	123	2	0	\N
49136	1701	2159080000000	211	123	3	0	\N
49140	1701	2878096500103	20392	10275	9	0	\N
49141	1701	2878096500103	20401	10278	3	0	\N
49143	1701	2878108500103	20401	10278	4	0	\N
49145	1701	2878132500103	20392	10275	10	0	\N
49152	1701	3598131500103	20851	10479	1	0	\N
49153	1701	3598180000000	574	324	1	0	\N
49154	1701	3598180000000	759	424	1	0	\N
49156	1701	3598190000000	574	324	2	0	\N
49157	1701	3598190000000	759	424	2	0	\N
49159	1701	3670193600056	10844	5596	6	0	\N
49160	1701	3670193600056	11207	5754	6	0	\N
49161	1701	3670193600056	11301	5804	1	0	\N
49164	1701	3670203600056	11301	5804	2	0	\N
49166	1701	3670253600056	10844	5596	7	0	\N
49167	1701	3670334600056	11207	5754	7	0	\N
49168	1701	4318121500103	20841	10474	3	0	\N
49169	1701	4318121500103	21792	10895	68	0	\N
49171	1701	4318131500103	20851	10479	4	0	\N
49172	1701	4318133500103	20851	10479	5	0	\N
49174	1701	4318142500103	20841	10474	4	0	\N
49175	1701	4318190000000	1253	693	2	0	\N
49178	1701	4318210000000	1253	693	3	0	\N
49179	1701	4318378500103	21792	10895	69	0	\N
49180	1701	4318408500103	21905	10896	3	0	\N
49183	1701	4752105151488	21905	10896	127	0	\N
49184	1701	4752105151496	21999	10897	127	0	\N
49185	1701	5038133500103	22235	11129	8	0	\N
49188	1701	5038177500103	22235	11129	9	0	\N
49189	1701	5038200000000	1373	752	1	0	\N
49191	1701	5038210000000	1373	752	2	0	\N
49193	1701	5038408500103	21905	10896	126	0	\N
49194	1701	5039208500095	21999	10897	3	0	\N
49201	1701	5759208500095	21999	10897	126	0	\N
49206	1701	6478220000000	2801	1465	3	0	\N
49207	1701	6478220000000	2892	1510	1	0	\N
49209	1701	6478230000000	2892	1510	2	0	\N
49211	1701	6478250000000	2801	1465	4	0	\N
49212	1701	6550241600056	11696	6013	2	0	\N
49214	1701	6550243600056	11696	6013	3	0	\N
49218	1701	7198230000000	3224	1674	1	0	\N
49220	1701	7198240000000	3224	1674	2	0	\N
49222	1701	7270252600056	12711	6554	4	0	\N
49223	1701	7270252600056	12909	6653	1	0	\N
49224	1701	7270252600056	13056	6731	5	0	\N
49225	1701	7270252600056	13714	7047	9	0	\N
49227	1701	7270253600056	12909	6653	2	0	\N
49228	1701	7270274600056	12711	6554	5	0	\N
49229	1701	7270275600056	13056	6731	6	0	\N
49230	1701	7270378600056	13714	7047	10	0	\N
49121	1701	719040000000	186	111	1	0	0
49123	1701	1439040000000	186	111	4	0	0
49125	1701	1439060000000	186	111	5	0	0
49134	1701	2159050000000	419	239	3	0	1
49137	1701	2159080000000	419	239	4	0	1
49147	1701	2878800000000	495	275	4	0	2
49155	1701	3598180000000	815	451	1	0	4
49158	1701	3598190000000	815	451	2	0	4
49176	1701	4318190000000	1279	706	1	0	4
49177	1701	4318200000000	1279	706	2	0	4
49192	1701	5038210000000	2065	1091	2	0	4
49199	1701	5758210000000	2688	1412	1	0	4
49200	1701	5758220000000	2688	1412	2	0	4
49208	1701	6478220000000	3030	1574	1	0	4
49219	1701	7198230000000	3349	1740	5	0	4
49221	1701	7198271000000	3349	1740	6	0	4
49128	1701	1510063600056	10466	5409	9	0	9
49131	1701	1510153600056	10466	5409	10	0	9
49138	1701	2230153600056	10675	5511	2	0	9
49148	1701	2950173600056	10754	5551	2	0	9
49149	1701	2950193600056	10754	5551	3	0	9
49162	1701	3670193600056	11388	5849	1	0	9
49163	1701	3670194600056	11388	5849	2	0	9
49165	1701	3670215600056	11492	5904	2	0	9
49182	1701	4390238600056	11492	5904	9	0	9
49195	1701	5110238600056	11577	5953	2	0	9
49196	1701	5110240600056	11577	5953	3	0	9
49202	1701	5830240600056	11587	5960	1	0	9
49213	1701	6550241600056	12573	6480	2	0	9
49215	1701	6550252600056	12573	6480	3	0	9
49226	1701	7270252600056	13774	7077	0	0	9
49098	1700	19026093276737	18726	9435	4	0	6
49099	1700	19746093276737	19012	9586	2	0	6
49102	1700	20466104276737	19210	9692	4	0	6
49106	1700	20466117276737	19210	9692	5	0	6
49109	1700	21186117276737	19558	9850	4	0	6
49113	1700	21186130276737	19558	9850	5	0	6
49132	1701	2158084500103	20148	10140	3	0	14
49115	1700	21906130276737	20180	10162	3	0	6
49117	1700	21906142276737	20180	10162	4	0	6
49142	1701	2878096500103	20417	10286	5	0	14
49144	1701	2878110500103	20417	10286	6	0	14
49151	1701	3598121500103	20827	10468	3	0	14
49170	1701	4318121500103	22215	11121	3	0	14
49173	1701	4318133500103	22215	11121	4	0	14
49186	1701	5038133500103	22334	11178	10	0	14
49187	1701	5038161500103	22334	11178	11	0	14
49198	1701	5758172500103	22420	11222	3	0	14
49204	1701	6478172500103	22684	11342	3	0	14
49205	1701	6478184500103	22684	11342	4	0	14
49216	1701	7198184500103	22748	11376	3	0	14
49217	1701	7198196500103	22748	11376	4	0	14
49232	1701	7918233500103	23034	11501	11	0	14
49235	1701	7990252600056	14112	7213	4	0	\N
49238	1701	7990265600056	14112	7213	5	0	\N
49242	1701	8638265500103	23360	11656	1	0	\N
49248	1701	9358265500103	23360	11656	3	0	\N
49249	1701	9358266500103	23360	11656	4	0	\N
49255	1701	10078266500103	23950	11916	6	0	\N
49258	1701	10078290500103	23950	11916	7	0	\N
49259	1701	10078302000000	4371	2267	1	0	\N
49260	1701	10078302000000	4422	2292	2	0	\N
49261	1701	10078302000000	4569	2363	1	0	\N
49262	1701	10078302000000	4791	2477	2	0	\N
49263	1701	10078302000000	5105	2650	1	0	\N
49265	1701	10078312000000	4371	2267	2	0	\N
49266	1701	10078312000000	4569	2363	2	0	\N
49267	1701	10078312000000	5105	2650	2	0	\N
49269	1701	10078322000000	4422	2292	3	0	\N
49270	1701	10078322000000	4791	2477	3	0	\N
49281	1701	11590348600056	16070	8172	7	0	\N
49283	1701	11590373600056	16070	8172	8	0	\N
49285	1701	12238312000000	5986	3105	2	0	\N
49286	1701	12238312000000	6058	3146	1	0	\N
49289	1701	12238322000000	6058	3146	2	0	\N
49291	1701	12238332000000	5986	3105	3	0	\N
49293	1701	12310398600056	16560	8416	3	0	\N
49294	1701	12310398600056	17716	8953	4	0	\N
49295	1701	12310398600056	18226	9180	3	0	\N
49298	1701	12310410600056	16560	8416	4	0	\N
49299	1701	12310410600056	18226	9180	4	0	\N
49300	1701	12310420600056	17716	8953	5	0	\N
49302	1701	12958332000000	6975	3598	2	0	\N
49303	1701	12958332000000	7159	3698	3	0	\N
49306	1701	12958352000000	6975	3598	3	0	\N
49308	1701	12958452000000	7159	3698	4	0	\N
49309	1701	13030409600056	18816	9482	1	0	\N
49310	1701	13030409600056	19455	9806	3	0	\N
49312	1701	13030419600056	18816	9482	2	0	\N
49313	1701	13030421600056	19455	9806	4	0	\N
49315	1701	13678349500103	25184	12495	11	0	\N
49316	1701	13678349500103	25290	12545	2	0	\N
49318	1701	13678351500103	25290	12545	3	0	\N
49322	1701	13678387500103	25184	12495	12	0	\N
49323	1701	13679530500103	26190	12851	117	0	\N
49326	1701	14398360500103	25776	12748	6	0	\N
49330	1701	14398384500103	25776	12748	7	0	\N
49332	1701	14399530500103	26190	12851	126	0	\N
49333	1701	14399610500103	26190	12851	127	0	\N
49334	1701	14400429500103	26225	12852	117	0	\N
49335	1701	15118382000000	7720	3998	1	0	\N
49337	1701	15118384500103	27403	13550	3	0	\N
49338	1701	15118384500103	27606	13643	3	0	\N
49340	1701	15118392000000	7720	3998	2	0	\N
49342	1701	15118396500103	27403	13550	4	0	\N
49343	1701	15118396500103	27606	13643	4	0	\N
49345	1701	15120429500103	26225	12852	126	0	\N
49346	1701	15120437500103	26225	12852	127	0	\N
49347	1701	15121607500103	26409	12853	117	0	\N
49348	1701	15838392000000	8697	4508	1	0	\N
49349	1701	15838392000000	9083	4710	2	0	\N
49351	1701	15838402000000	8697	4508	2	0	\N
49353	1701	15838412000000	9083	4710	3	0	\N
49356	1701	15841607500103	26409	12853	118	0	\N
49357	1701	16558461500103	27926	13813	4	0	\N
49360	1701	16558483500103	27926	13813	5	0	\N
49363	1701	17998516500103	28345	14012	2	0	\N
49364	1701	17998516500103	28396	14035	2	0	\N
49366	1701	17998527500103	28345	14012	3	0	\N
49367	1701	17998527500103	28396	14035	3	0	\N
49243	1701	8638281000000	4081	2120	2	0	4
49244	1701	8638301000000	4081	2120	3	0	4
49251	1701	9358301000000	4183	2178	1	0	4
49252	1701	9358302000000	4183	2178	2	0	4
49264	1701	10078302000000	5363	2785	1	0	4
49275	1701	10798312000000	5497	2859	0	0	4
49279	1701	11518312000000	5736	2972	0	0	4
49287	1701	12238312000000	6621	3424	2	0	4
49292	1701	12238332000000	6621	3424	3	0	4
49304	1701	12958332000000	7453	3855	3	0	4
49320	1701	13678362000000	7656	3963	1	0	4
49321	1701	13678372000000	7656	3963	2	0	4
49328	1701	14398372000000	7686	3981	1	0	4
49329	1701	14398382000000	7686	3981	2	0	4
49341	1701	15118392000000	8397	4351	2	0	4
49350	1701	15838392000000	9341	4847	2	0	4
49354	1701	15838412000000	9341	4847	3	0	4
49236	1701	7990252600056	14366	7332	3	0	9
49237	1701	7990264600056	14366	7332	4	0	9
49245	1701	8710310600056	14474	7388	16	0	9
49246	1701	8710315600056	14474	7388	17	0	9
49253	1701	9430315600056	14721	7496	1	0	9
49254	1701	9430325600056	14721	7496	2	0	9
49271	1701	10150325600056	15428	7858	2	0	9
49276	1701	10870336600056	15953	8111	3	0	9
49277	1701	10870348600056	15953	8111	4	0	9
49282	1701	11590348600056	16352	8315	14	0	9
49284	1701	11590398600056	16352	8315	15	0	9
49297	1701	12310409600056	18591	9369	3	0	9
49311	1701	13030409600056	19467	9813	11	0	9
49314	1701	13030447600056	19467	9813	12	0	9
49324	1701	13750447600056	19697	9917	17	0	9
49325	1701	13750581600056	19697	9917	18	0	9
49241	1701	8638255500103	23356	11654	5	0	14
49247	1701	9358255500103	23380	11666	2	0	14
49250	1701	9358266500103	23380	11666	3	0	14
49256	1701	10078266500103	24203	12047	3	0	14
49257	1701	10078278500103	24203	12047	4	0	14
49274	1701	10798290500103	24233	12059	4	0	14
49278	1701	11518290500103	24507	12189	5	0	14
49280	1701	11518313500103	24507	12189	6	0	14
49288	1701	12238313500103	24558	12207	2	0	14
49301	1701	12958324500103	24795	12311	7	0	14
49305	1701	12958349500103	24795	12311	8	0	14
49317	1701	13678349500103	25749	12737	2	0	14
49319	1701	13678360500103	25749	12737	3	0	14
49327	1701	14398360500103	27376	13537	6	0	14
49339	1701	15118384500103	27747	13707	4	0	14
49344	1701	15118406500103	27747	13707	5	0	14
49352	1701	15838406500103	27759	13713	10	0	14
49355	1701	15838461500103	27759	13713	11	0	14
49358	1701	16558461500103	28144	13913	2	0	14
49361	1701	17278472500103	28337	14008	8	0	14
49362	1701	17278516500103	28337	14008	9	0	14
49365	1701	17998516500103	28888	14251	4	0	14
49368	1701	17998529500103	28888	14251	5	0	14
49372	1701	19438542500103	29347	14463	3	0	\N
49373	1701	19438554500103	29347	14463	4	0	\N
49375	1701	20158579500103	29652	14623	7	0	\N
49377	1701	20158595500103	29652	14623	8	0	\N
49381	1701	21598630500094	30168	14843	8	0	\N
49382	1701	21598646949811	30168	14843	10	0	\N
49383	1702	181000000	10279	5319	2	0	\N
49384	1702	33202999985	10279	5319	10	1	\N
49385	1702	719000000000	114	68	1	0	\N
49386	1702	719000000000	187	112	2	0	\N
49387	1702	719000000000	258	152	1	0	\N
49388	1702	719000000000	458	257	1	0	\N
49389	1702	719000000000	486	271	1	0	\N
49390	1702	719000000000	857	476	1	0	\N
49392	1702	719010000000	114	68	2	0	\N
49393	1702	719010000000	258	152	2	0	\N
49394	1702	719010000000	458	257	2	0	\N
49395	1702	719010000000	486	271	2	0	\N
49396	1702	719010000000	857	476	2	0	\N
49398	1702	719020000000	187	112	3	0	\N
49401	1702	720181000000	10279	5319	8	0	\N
49402	1702	1439010000000	1536	840	1	0	\N
49404	1702	1439020000000	1536	840	2	0	\N
49406	1702	1440171000000	10930	5636	2	0	\N
49409	1702	1440354000000	20812	10462	2	0	\N
49411	1702	1440365000000	20812	10462	3	0	\N
49413	1702	1440461000000	21085	10593	4	0	\N
49418	1702	2160182000000	11257	5784	0	0	\N
49421	1702	2160439000000	21076	10588	2	0	\N
49423	1702	2160450000000	21076	10588	3	0	\N
49424	1702	2160461000000	21085	10593	6	0	\N
49425	1702	2160462000000	21085	10593	7	0	\N
49427	1702	2879030000000	2537	1335	2	0	\N
49428	1702	2879030000000	2562	1350	2	0	\N
49429	1702	2879030000000	2698	1418	1	0	\N
49430	1702	2879030000000	2764	1445	1	0	\N
49431	1702	2879030000000	3081	1600	1	0	\N
49433	1702	2879040000000	2698	1418	2	0	\N
49434	1702	2879040000000	2764	1445	2	0	\N
49435	1702	2879040000000	3081	1600	2	0	\N
49437	1702	2879050000000	2562	1350	3	0	\N
49438	1702	2879140000000	2537	1335	3	0	\N
49439	1702	2880215000000	11970	6160	2	0	\N
49440	1702	2880215000000	11977	6164	2	0	\N
49441	1702	2880215000000	12099	6230	2	0	\N
49442	1702	2880215000000	12496	6438	1	0	\N
49443	1702	2880215000000	12673	6536	5	0	\N
49445	1702	2880216000000	12496	6438	2	0	\N
49446	1702	2880217000000	11970	6160	3	0	\N
49447	1702	2880217000000	11977	6164	3	0	\N
49448	1702	2880217000000	12099	6230	3	0	\N
49450	1702	2880238000000	12673	6536	6	0	\N
49451	1702	2880238000000	13447	6928	3	0	\N
49452	1702	2880462000000	21741	10887	6	0	\N
49453	1702	2880462000000	21928	10972	3	0	\N
49454	1702	2880462000000	21939	10975	3	0	\N
49456	1702	2880474000000	21928	10972	4	0	\N
49457	1702	2880474000000	21939	10975	4	0	\N
49459	1702	2880486000000	21741	10887	7	0	\N
49462	1702	3600226000000	13268	6835	3	0	\N
49463	1702	3600226000000	13374	6891	4	0	\N
49465	1702	3600238000000	13268	6835	4	0	\N
49466	1702	3600238000000	13447	6928	10	0	\N
49468	1702	3600239000000	13374	6891	5	0	\N
49469	1702	3600244000000	13447	6928	11	0	\N
49470	1702	3600474000000	22530	11271	7	0	\N
49471	1702	3600474000000	22721	11359	2	0	\N
49473	1702	3600485000000	22721	11359	3	0	\N
49475	1702	3600499000000	22530	11271	8	0	\N
49480	1702	4320487000000	23025	11498	3	0	\N
49482	1702	4320499000000	23025	11498	4	0	\N
49484	1702	5034071000000	3781	1959	1	0	\N
49485	1702	5034071000000	3815	1977	2	0	\N
49487	1702	5034081000000	3781	1959	2	0	\N
49489	1702	5034091000000	3815	1977	3	0	\N
49492	1702	5040499000000	23141	11555	7	0	\N
49493	1702	5040499000000	23328	11636	0	0	\N
49496	1702	5040524000000	23141	11555	8	0	\N
49497	1702	5754081000000	4028	2091	1	0	\N
49498	1702	5754081000000	4303	2231	1	0	\N
49500	1702	5754091000000	4028	2091	2	0	\N
49501	1702	5754091000000	4303	2231	2	0	\N
49403	1702	1439010000000	2388	1247	1	0	0
49405	1702	1439020000000	2388	1247	2	0	0
49416	1702	2159020000000	2449	1281	1	0	0
49417	1702	2159030000000	2449	1281	2	0	0
49432	1702	2879030000000	3208	1666	1	0	0
49460	1702	3594030000000	3696	1919	3	0	1
49461	1702	3594051000000	3696	1919	4	0	1
49476	1702	4314051000000	3736	1938	2	0	1
49477	1702	4314071000000	3736	1938	3	0	1
49486	1702	5034071000000	3952	2054	1	0	1
49499	1702	5754081000000	4523	2340	1	0	1
49502	1702	5754091000000	4523	2340	2	0	1
49399	1702	720151000000	10912	5629	2	0	3
49400	1702	720171000000	10912	5629	3	0	3
49408	1702	1440182000000	11239	5773	3	0	3
49419	1702	2160182000000	11344	5826	6	0	3
49420	1702	2160215000000	11344	5826	7	0	3
49444	1702	2880215000000	12940	6669	2	0	3
49449	1702	2880226000000	12940	6669	3	0	3
49467	1702	3600238000000	13539	6969	4	0	3
49478	1702	4320238000000	13624	7004	4	0	3
49479	1702	4320251000000	13624	7004	5	0	3
49490	1702	5040251000000	13649	7016	2	0	3
49491	1702	5040262000000	13649	7016	3	0	3
49504	1702	5760273000000	13686	7032	3	0	3
49414	1702	1764352000000	20546	10344	3	0	4
49415	1702	1764364000000	20546	10344	4	0	4
49410	1702	1440354000000	20999	10560	13	0	5
49422	1702	2160439000000	21439	10753	5	0	5
49426	1702	2160462000000	21439	10753	6	0	5
49455	1702	2880462000000	22337	11180	3	0	5
49458	1702	2880474000000	22337	11180	4	0	5
49472	1702	3600474000000	22769	11385	4	0	5
49481	1702	4320487000000	23087	11528	3	0	5
49483	1702	4320499000000	23087	11528	4	0	5
49494	1702	5040499000000	23511	11719	4	0	5
49495	1702	5040512000000	23511	11719	5	0	5
49369	1701	18718529500103	28952	14278	4	0	14
49371	1701	18718579500103	29562	14575	10	0	14
49374	1701	19438579500103	29562	14575	11	0	14
49376	1701	20158579500103	29759	14667	23	0	14
49378	1701	20158611500094	29759	14667	24	0	14
49380	1701	20878630500094	29821	14694	11	0	14
49505	1702	5760512000000	23673	11789	7	0	\N
49508	1702	5760537000000	23673	11789	8	0	\N
49509	1702	6474091000000	4662	2410	1	0	\N
49511	1702	6474101000000	4662	2410	2	0	\N
49515	1702	6480523000000	24359	12114	2	0	\N
49516	1702	6480523000000	24631	12239	3	0	\N
49517	1702	6480523000000	25001	12403	8	0	\N
49518	1702	6480523000000	25504	12630	3	0	\N
49519	1702	6480523000000	25563	12656	3	0	\N
49520	1702	6480523000000	25710	12719	7	0	\N
49521	1702	6480523000000	25731	12731	3	0	\N
49522	1702	6480523000000	25842	12776	4	0	\N
49523	1702	6480523000000	26005	12851	2	0	\N
49524	1702	6480523000000	26536	13127	9	0	\N
49526	1702	6480534000000	24359	12114	3	0	\N
49527	1702	6480534000000	26005	12851	3	0	\N
49528	1702	6480535000000	24631	12239	4	0	\N
49529	1702	6480535000000	25504	12630	4	0	\N
49530	1702	6480535000000	25563	12656	4	0	\N
49531	1702	6480535000000	25731	12731	4	0	\N
49532	1702	6480536000000	25842	12776	5	0	\N
49534	1702	6480548000000	25710	12719	8	0	\N
49535	1702	6480558000000	25001	12403	9	0	\N
49536	1702	6480559000000	26536	13127	10	0	\N
49537	1702	7194091000000	5795	3006	2	0	\N
49539	1702	7194101000000	5517	2869	0	0	\N
49540	1702	7194101000000	5600	2909	0	0	\N
49541	1702	7194101000000	5653	2933	0	0	\N
49543	1702	7194111000000	5795	3006	3	0	\N
49544	1702	7200284000000	13830	7101	23	0	\N
49545	1702	7200284000000	13902	7130	31	0	\N
49546	1702	7200284000000	14120	7217	1	0	\N
49547	1702	7200284000000	14230	7265	4	0	\N
49548	1702	7200284000000	14369	7332	3	0	\N
49549	1702	7200284000000	14566	7427	2	0	\N
49550	1702	7200284000000	14615	7450	3	0	\N
49551	1702	7200284000000	14743	7504	4	0	\N
49552	1702	7200284000000	15695	7983	3	0	\N
49553	1702	7200284000000	15851	8062	4	0	\N
49554	1702	7200284000000	15999	8135	10	0	\N
49555	1702	7200284000000	16072	8172	7	0	\N
49556	1702	7200284000000	16551	8411	4	0	\N
49557	1702	7200284000000	16569	8422	4	0	\N
49559	1702	7200294000000	14120	7217	2	0	\N
49560	1702	7200295000000	14566	7427	3	0	\N
49561	1702	7200296000000	14369	7332	4	0	\N
49562	1702	7200296000000	14615	7450	4	0	\N
49563	1702	7200296000000	15695	7983	4	0	\N
49565	1702	7200297000000	14230	7265	5	0	\N
49566	1702	7200297000000	16551	8411	5	0	\N
49567	1702	7200306000000	14743	7504	5	0	\N
49568	1702	7200306000000	16569	8422	5	0	\N
49569	1702	7200309000000	16072	8172	8	0	\N
49570	1702	7200330000000	15999	8135	11	0	\N
49571	1702	7200352000000	13830	7101	24	0	\N
49572	1702	7200360000000	13902	7130	32	0	\N
49573	1702	7200396000000	15851	8062	5	0	\N
49574	1702	7200545000000	27385	13541	3	0	\N
49576	1702	7200557000000	27385	13541	4	0	\N
49578	1702	7914101000000	6188	3204	3	0	\N
49579	1702	7914101000000	6300	3261	1	0	\N
49580	1702	7914101000000	6512	3375	2	0	\N
49581	1702	7914101000000	6739	3487	2	0	\N
49583	1702	7914111000000	6300	3261	2	0	\N
49584	1702	7914121000000	6512	3375	3	0	\N
49585	1702	7914121000000	6739	3487	3	0	\N
49587	1702	7914311000000	6188	3204	4	0	\N
49588	1702	7920296000000	17000	8610	2	0	\N
49589	1702	7920296000000	17005	8613	4	0	\N
49590	1702	7920296000000	17239	8733	0	0	\N
49591	1702	7920296000000	17584	8897	9	0	\N
49593	1702	7920307000000	17000	8610	3	0	\N
49595	1702	7920318000000	17005	8613	5	0	\N
49596	1702	7920332000000	17584	8897	10	0	\N
49597	1702	7920581000000	27711	13692	2	0	\N
49598	1702	7920581000000	28277	13979	2	0	\N
49599	1702	7920581000000	28306	13993	4	0	\N
49600	1702	7920581000000	28439	14054	2	0	\N
49601	1702	7920581000000	28525	14093	5	0	\N
49602	1702	7920581000000	28575	14113	6	0	\N
49604	1702	7920592000000	27711	13692	3	0	\N
49605	1702	7920592000000	28277	13979	3	0	\N
49606	1702	7920592000000	28439	14054	3	0	\N
49608	1702	7920603000000	28306	13993	5	0	\N
49609	1702	7920605000000	28575	14113	7	0	\N
49611	1702	7920844000000	28525	14093	6	0	\N
49616	1702	8640592000000	28841	14225	7	0	\N
49618	1702	8640617000000	28841	14225	8	0	\N
49620	1702	9354141000000	7841	4064	6	0	\N
49621	1702	9354141000000	8767	4547	2	0	\N
49622	1702	9354141000000	8872	4597	2	0	\N
49623	1702	9354141000000	8979	4658	2	0	\N
49625	1702	9354161000000	8767	4547	3	0	\N
49626	1702	9354161000000	8872	4597	3	0	\N
49627	1702	9354161000000	8979	4658	3	0	\N
49629	1702	9354201000000	7841	4064	7	0	\N
49630	1702	9360330000000	18267	9202	2	0	\N
49632	1702	9360341000000	18267	9202	3	0	\N
49636	1702	10074161000000	9869	5118	4	0	\N
49637	1702	10074201000000	9869	5118	5	0	\N
49638	1702	10080341000000	18448	9299	4	0	\N
49639	1702	10080341000000	18696	9418	3	0	\N
49538	1702	7194091000000	6017	3121	1	0	2
49542	1702	7194101000000	6017	3121	2	0	2
49582	1702	7914101000000	7613	3939	3	0	2
49586	1702	7914131000000	7613	3939	4	0	2
49612	1702	8634131000000	7754	4019	1	0	2
49624	1702	9354141000000	9356	4855	2	0	2
49628	1702	9354161000000	9356	4855	3	0	2
49513	1702	6480273000000	13700	7040	2	0	3
49514	1702	6480284000000	13700	7040	3	0	3
49558	1702	7200284000000	16787	8520	3	0	3
49592	1702	7920296000000	17989	9075	3	0	3
49594	1702	7920308000000	17989	9075	4	0	3
49614	1702	8640308000000	18074	9114	4	0	3
49615	1702	8640330000000	18074	9114	5	0	3
49633	1702	9360341000000	18319	9227	3	0	3
49640	1702	10080341000000	18810	9479	2	0	3
49506	1702	5760512000000	24103	11998	2	0	5
49507	1702	5760523000000	24103	11998	3	0	5
49525	1702	6480523000000	27029	13367	4	0	5
49575	1702	7200545000000	27424	13558	9	0	5
49577	1702	7200581000000	27424	13558	10	0	5
49603	1702	7920581000000	28611	14127	2	0	5
49607	1702	7920592000000	28611	14127	3	0	5
49610	1702	7920615000000	28886	14249	5	0	5
49619	1702	8640617000000	28886	14249	9	0	5
49634	1702	9360617000000	28950	14276	1	0	5
49635	1702	9360627000000	28950	14276	2	0	5
49642	1702	10080353000000	18696	9418	4	0	\N
49643	1702	10080354000000	18448	9299	5	0	\N
49644	1702	10080627000000	28995	14295	3	0	\N
49645	1702	10080627000000	29288	14432	3	0	\N
49646	1702	10080627000000	29883	14727	20	0	\N
49647	1702	10080627000000	30104	14818	9	0	\N
49648	1702	10080639000000	28995	14295	4	0	\N
49649	1702	10080639000000	29288	14432	4	0	\N
49650	1702	10080645000000	30104	14818	10	0	\N
49651	1702	10080665000000	29883	14727	21	0	\N
49654	1702	20880644000000	10930	5636	3	1	\N
49655	1703	829000000	21084	10593	4	0	\N
49656	1703	719000000000	115	68	1	0	\N
49658	1703	719010000000	115	68	2	0	\N
49660	1703	720600000000	10280	5319	2	0	\N
49661	1703	720807000000	20547	10344	3	0	\N
49662	1703	720807000000	20811	10462	2	0	\N
49663	1703	720807000000	20998	10560	13	0	\N
49664	1703	720807000000	21075	10588	2	0	\N
49665	1703	720807000000	21740	10887	6	0	\N
49666	1703	720807000000	21930	10972	3	0	\N
49668	1703	720818000000	20811	10462	3	0	\N
49669	1703	720818000000	21075	10588	3	0	\N
49670	1703	720819000000	20547	10344	4	0	\N
49671	1703	720819000000	21930	10972	4	0	\N
49673	1703	720829000000	21084	10593	6	0	\N
49674	1703	720830000000	21084	10593	7	0	\N
49675	1703	720831000000	21740	10887	7	0	\N
49676	1703	720892000000	20998	10560	14	0	\N
49679	1703	1439030000000	1137	628	1	0	\N
49680	1703	1440570000000	10932	5636	1	0	\N
49681	1703	1440570000000	11238	5773	2	0	\N
49682	1703	1440570000000	11258	5784	0	0	\N
49683	1703	1440570000000	11345	5826	6	0	\N
49686	1703	1440580000000	10932	5636	2	0	\N
49687	1703	1440581000000	11238	5773	3	0	\N
49688	1703	1440600000000	10280	5319	8	0	\N
49689	1703	1440603000000	11345	5826	7	0	\N
49690	1703	1440650000000	10280	5319	9	0	\N
49691	1703	1440819000000	22336	11180	3	0	\N
49692	1703	1440819000000	22531	11271	9	0	\N
49695	1703	1440831000000	22336	11180	4	0	\N
49696	1703	1440846000000	22531	11271	10	0	\N
49697	1703	2159020000000	459	257	1	0	\N
49698	1703	2159020000000	487	271	1	0	\N
49699	1703	2159020000000	858	476	1	0	\N
49700	1703	2159020000000	1237	684	1	0	\N
49702	1703	2159030000000	459	257	2	0	\N
49703	1703	2159030000000	487	271	2	0	\N
49704	1703	2159030000000	858	476	2	0	\N
49705	1703	2159030000000	1137	628	2	0	\N
49706	1703	2159030000000	1237	684	2	0	\N
49708	1703	2160572000000	11978	6164	2	0	\N
49710	1703	2160574000000	11978	6164	3	0	\N
49712	1703	2160577000000	13448	6928	3	0	\N
49713	1703	2160829000000	22768	11385	4	0	\N
49714	1703	2160829000000	23027	11498	1	0	\N
49715	1703	2160829000000	23088	11528	3	0	\N
49716	1703	2160829000000	23142	11555	7	0	\N
49718	1703	2160839000000	23027	11498	2	0	\N
49719	1703	2160841000000	23088	11528	4	0	\N
49720	1703	2160842000000	22768	11385	5	0	\N
49722	1703	2160854000000	23142	11555	8	0	\N
49723	1703	2879030000000	2386	1247	1	0	\N
49724	1703	2879030000000	2448	1281	1	0	\N
49726	1703	2879040000000	2386	1247	2	0	\N
49727	1703	2879040000000	2448	1281	2	0	\N
49729	1703	2880574000000	12495	6438	1	0	\N
49730	1703	2880574000000	12672	6536	5	0	\N
49731	1703	2880574000000	12939	6669	2	0	\N
49732	1703	2880574000000	13271	6835	3	0	\N
49733	1703	2880574000000	13375	6891	4	0	\N
49734	1703	2880574000000	13540	6969	3	0	\N
49735	1703	2880574000000	13625	7004	1	0	\N
49736	1703	2880574000000	13650	7016	1	0	\N
49737	1703	2880574000000	13687	7032	2	0	\N
49738	1703	2880574000000	13701	7040	2	0	\N
49740	1703	2880575000000	12495	6438	2	0	\N
49741	1703	2880577000000	13448	6928	9	0	\N
49742	1703	2880584000000	13625	7004	2	0	\N
49743	1703	2880584000000	13650	7016	2	0	\N
49744	1703	2880585000000	12939	6669	3	0	\N
49745	1703	2880585000000	13687	7032	3	0	\N
49746	1703	2880585000000	13701	7040	3	0	\N
49747	1703	2880586000000	13271	6835	4	0	\N
49748	1703	2880586000000	13540	6969	4	0	\N
49749	1703	2880587000000	13375	6891	5	0	\N
49750	1703	2880597000000	12672	6536	6	0	\N
49752	1703	2880851000000	23512	11719	4	0	\N
49753	1703	2880851000000	23674	11789	5	0	\N
49754	1703	2880851000000	24102	11998	2	0	\N
49756	1703	2880862000000	24102	11998	3	0	\N
49758	1703	2880864000000	23512	11719	5	0	\N
49759	1703	2880874000000	23674	11789	6	0	\N
49760	1703	3599140000000	2564	1350	2	0	\N
49761	1703	3599140000000	2699	1418	1	0	\N
49763	1703	3599150000000	2699	1418	2	0	\N
49765	1703	3599160000000	2564	1350	3	0	\N
49766	1703	3599310000000	3046	1552	7	0	\N
49767	1703	3600625000000	13903	7130	17	0	\N
49770	1703	3600687000000	13903	7130	18	0	\N
49773	1703	4319150000000	3695	1919	3	0	\N
49774	1703	4319150000000	3735	1938	2	0	\N
49677	1703	1439010000000	259	152	1	0	1
49678	1703	1439020000000	259	152	2	0	1
49701	1703	2159020000000	1537	840	1	0	1
49707	1703	2159030000000	1537	840	2	0	1
49725	1703	2879030000000	2538	1335	2	0	1
49762	1703	3599140000000	2765	1445	1	0	1
49764	1703	3599150000000	2765	1445	2	0	1
49775	1703	4319150000000	3780	1959	1	0	1
49776	1703	4319160000000	3780	1959	2	0	1
49684	1703	1440570000000	11971	6160	2	0	3
49709	1703	2160572000000	12098	6230	2	0	3
49711	1703	2160574000000	12098	6230	3	0	3
49739	1703	2880574000000	13831	7101	6	0	3
49751	1703	2880625000000	13831	7101	7	0	3
49769	1703	3600638000000	14119	7217	5	0	3
49641	1702	10080352000000	18810	9479	3	0	3
49652	1702	10800352000000	19001	9581	1	0	3
49653	1702	10800362000000	19001	9581	2	0	3
49667	1703	720807000000	21940	10975	3	0	5
49693	1703	1440819000000	22722	11359	1	0	5
49694	1703	1440829000000	22722	11359	2	0	5
49717	1703	2160829000000	23329	11641	4	0	5
49721	1703	2160851000000	23329	11641	5	0	5
49755	1703	2880851000000	24360	12114	2	0	5
49771	1703	3600862000000	24632	12239	3	0	5
49772	1703	3600874000000	24632	12239	4	0	5
49777	1703	4319170000000	3735	1938	3	0	\N
49778	1703	4319171000000	3695	1919	4	0	\N
49779	1703	4319310000000	3046	1552	35	0	\N
49780	1703	4319580000000	3046	1552	36	0	\N
49781	1703	4320638000000	14229	7265	4	0	\N
49782	1703	4320638000000	14368	7332	3	0	\N
49783	1703	4320638000000	14564	7427	2	0	\N
49785	1703	4320649000000	14564	7427	3	0	\N
49786	1703	4320650000000	14368	7332	4	0	\N
49788	1703	4320651000000	14229	7265	5	0	\N
49789	1703	4320874000000	25000	12403	7	0	\N
49792	1703	4320908000000	25000	12403	8	0	\N
49795	1703	5039580000000	3084	1553	24	0	\N
49796	1703	5039910000000	3084	1553	25	0	\N
49797	1703	5040630000000	3209	1554	72	0	\N
49798	1703	5040650000000	14742	7504	4	0	\N
49801	1703	5040672000000	14742	7504	5	0	\N
49802	1703	5040886000000	25564	12656	3	0	\N
49803	1703	5040886000000	25711	12719	7	0	\N
49805	1703	5040898000000	25564	12656	4	0	\N
49807	1703	5040911000000	25711	12719	8	0	\N
49808	1703	5759180000000	3951	2054	1	0	\N
49809	1703	5759180000000	4027	2091	1	0	\N
49811	1703	5759190000000	3951	2054	2	0	\N
49812	1703	5759190000000	4027	2091	2	0	\N
49814	1703	5760630000000	3209	1554	126	0	\N
49815	1703	5760662000000	15853	8062	4	0	\N
49818	1703	5760774000000	15853	8062	5	0	\N
49819	1703	5760898000000	25841	12776	4	0	\N
49822	1703	5760911000000	25841	12776	5	0	\N
49823	1703	5761160000000	3209	1554	127	0	\N
49824	1703	6479190000000	4522	2340	1	0	\N
49826	1703	6479200000000	4522	2340	2	0	\N
49830	1703	6480908000000	26535	13127	9	0	\N
49831	1703	6480908000000	27028	13367	4	0	\N
49834	1703	6480930000000	27028	13367	5	0	\N
49835	1703	6480944000000	26535	13127	10	0	\N
49836	1703	7199200000000	4682	2420	1	0	\N
49838	1703	7199210000000	4682	2420	2	0	\N
49841	1703	7200920000000	27425	13558	9	0	\N
49842	1703	7200920000000	27710	13692	2	0	\N
49843	1703	7200920000000	28276	13979	2	0	\N
49845	1703	7200931000000	27710	13692	3	0	\N
49846	1703	7200931000000	28276	13979	3	0	\N
49848	1703	7200956000000	27425	13558	10	0	\N
49849	1703	7200965000000	28885	14249	5	0	\N
49850	1703	7919200000000	5599	2909	0	0	\N
49851	1703	7919200000000	5655	2933	0	0	\N
49852	1703	7919200000000	5796	3006	2	0	\N
49854	1703	7919220000000	5796	3006	3	0	\N
49856	1703	7920746000000	16568	8422	4	0	\N
49857	1703	7920746000000	16789	8520	3	0	\N
49858	1703	7920746000000	17001	8610	2	0	\N
49859	1703	7920746000000	17006	8613	4	0	\N
49860	1703	7920746000000	17237	8733	2	0	\N
49862	1703	7920757000000	17001	8610	3	0	\N
49863	1703	7920757000000	17237	8733	3	0	\N
49864	1703	7920758000000	16789	8520	4	0	\N
49865	1703	7920768000000	16568	8422	5	0	\N
49866	1703	7920768000000	17006	8613	5	0	\N
49868	1703	7920942000000	28438	14054	2	0	\N
49869	1703	7920942000000	28524	14093	5	0	\N
49870	1703	7920942000000	28574	14113	6	0	\N
49871	1703	7920942000000	28610	14127	2	0	\N
49872	1703	7920942000000	28842	14225	7	0	\N
49873	1703	7920942000000	28949	14276	2	0	\N
49875	1703	7920953000000	28438	14054	3	0	\N
49876	1703	7920953000000	28610	14127	3	0	\N
49877	1703	7920953000000	28949	14276	3	0	\N
49879	1703	7920965000000	28885	14249	8	0	\N
49880	1703	7920966000000	28574	14113	7	0	\N
49881	1703	7920967000000	28842	14225	8	0	\N
49882	1703	7920967000000	28885	14249	9	0	\N
49883	1703	7921205000000	28524	14093	6	0	\N
49884	1703	8639410000000	6299	3261	1	0	\N
49885	1703	8639410000000	6511	3375	2	0	\N
49887	1703	8639420000000	6299	3261	2	0	\N
49888	1703	8639430000000	6511	3375	3	0	\N
49890	1703	8640782000000	17988	9075	3	0	\N
49893	1703	8640794000000	17988	9075	4	0	\N
49894	1703	8640954000000	29287	14432	3	0	\N
49896	1703	8640966000000	29287	14432	4	0	\N
49898	1703	9359430000000	7311	3778	4	0	\N
49899	1703	9359430000000	7614	3939	3	0	\N
49900	1703	9359430000000	7755	4019	1	0	\N
49902	1703	9359440000000	7755	4019	2	0	\N
49903	1703	9359460000000	7614	3939	4	0	\N
49904	1703	9359470000000	7311	3778	5	0	\N
49906	1703	9360793000000	18320	9227	2	0	\N
49908	1703	9360804000000	18320	9227	3	0	\N
49910	1703	9360968000000	29884	14727	20	0	\N
49810	1703	5759180000000	4304	2231	1	0	1
49813	1703	5759190000000	4304	2231	2	0	1
49825	1703	6479190000000	4661	2410	1	0	1
49827	1703	6479200000000	4661	2410	2	0	1
49837	1703	7199200000000	5516	2869	0	0	1
49855	1703	7919410000000	6187	3204	4	0	1
49886	1703	8639410000000	6740	3487	2	0	1
49889	1703	8639430000000	6740	3487	3	0	1
49901	1703	9359430000000	7842	4064	6	0	1
49905	1703	9359490000000	7842	4064	7	0	1
49787	1703	4320650000000	14614	7450	4	0	3
49799	1703	5040650000000	15694	7983	3	0	3
49800	1703	5040662000000	15694	7983	4	0	3
49816	1703	5760662000000	15998	8135	10	0	3
49828	1703	6480708000000	16073	8172	7	0	3
49829	1703	6480733000000	16073	8172	8	0	3
49839	1703	7200733000000	16552	8411	4	0	3
49840	1703	7200746000000	16552	8411	5	0	3
49861	1703	7920746000000	17586	8897	9	0	3
49891	1703	8640782000000	18268	9202	2	0	3
49892	1703	8640793000000	18268	9202	3	0	3
49907	1703	9360793000000	18400	9275	4	0	3
49909	1703	9360815000000	18400	9275	5	0	3
49790	1703	4320874000000	25503	12630	3	0	5
49804	1703	5040886000000	25732	12731	3	0	5
49806	1703	5040898000000	25732	12731	4	0	5
49820	1703	5760898000000	26004	12851	1	0	5
49821	1703	5760908000000	26004	12851	2	0	5
49833	1703	6480920000000	27386	13541	4	0	5
49844	1703	7200920000000	28305	13993	4	0	5
49847	1703	7200942000000	28305	13993	5	0	5
49874	1703	7920942000000	28994	14295	3	0	5
49878	1703	7920954000000	28994	14295	4	0	5
49897	1703	8640968000000	29755	14665	6	0	5
49911	1703	9360968000000	30101	14818	2	0	5
49912	1703	9360979000000	30101	14818	3	0	5
49913	1703	9361006000000	29884	14727	21	0	\N
49914	1703	10079490000000	8768	4547	2	0	\N
49916	1703	10079510000000	8768	4547	3	0	\N
49918	1703	10080815000000	18449	9299	4	0	\N
49919	1703	10080815000000	18697	9418	3	0	\N
49920	1703	10080815000000	18811	9479	2	0	\N
49921	1703	10080815000000	19000	9581	1	0	\N
49923	1703	10080825000000	19000	9581	2	0	\N
49924	1703	10080826000000	18811	9479	3	0	\N
49925	1703	10080827000000	18697	9418	4	0	\N
49927	1703	10080828000000	18449	9299	5	0	\N
49930	1703	11519530000000	9355	4855	2	0	\N
49932	1703	11519550000000	9355	4855	3	0	\N
49934	1703	11674502942000	13448	6928	10	0	\N
49937	1704	370000000	1059	572	38	0	\N
49938	1704	719000000000	125	73	3	0	\N
49939	1704	719000000000	932	519	2	0	\N
49940	1704	719000000000	1056	586	17	0	\N
49941	1704	719000000000	1112	614	2	0	\N
49944	1704	719020000000	932	519	3	0	\N
49945	1704	719020000000	1112	614	3	0	\N
49946	1704	719030000000	125	73	4	0	\N
49947	1704	719170000000	1056	586	18	0	\N
49948	1704	720370000000	1059	572	43	0	\N
49949	1704	720410000000	1059	572	44	0	\N
49950	1704	786194000000	11648	5993	2	0	\N
49951	1704	786194000000	11665	5999	1	0	\N
49952	1704	786194000000	11805	6067	1	0	\N
49954	1704	786195000000	11665	5999	2	0	\N
49955	1704	786195000000	11805	6067	2	0	\N
49957	1704	786196000000	11648	5993	3	0	\N
49958	1704	1439010000000	1411	769	1	0	\N
49959	1704	1439010000000	1642	885	1	0	\N
49960	1704	1439010000000	2156	1140	2	0	\N
49961	1704	1439010000000	2167	1144	2	0	\N
49962	1704	1439010000000	2331	1220	3	0	\N
49963	1704	1439010000000	2886	1507	1	0	\N
49964	1704	1439010000000	3225	1674	1	0	\N
49965	1704	1439010000000	3389	1744	30	0	\N
49966	1704	1439010000000	3618	1878	0	0	\N
49967	1704	1439010000000	4640	2399	1	0	\N
49969	1704	1439020000000	1411	769	2	0	\N
49970	1704	1439020000000	1642	885	2	0	\N
49971	1704	1439020000000	2886	1507	2	0	\N
49972	1704	1439020000000	3225	1674	2	0	\N
49973	1704	1439020000000	4640	2399	2	0	\N
49974	1704	1439030000000	2156	1140	3	0	\N
49976	1704	1439040000000	2331	1220	4	0	\N
49977	1704	1439120000000	2167	1144	3	0	\N
49978	1704	1439310000000	3389	1744	31	0	\N
49979	1704	1506195000000	12547	6465	2	0	\N
49980	1704	1506195000000	12973	6689	2	0	\N
49981	1704	1506195000000	13059	6732	16	0	\N
49983	1704	1506206000000	12547	6465	3	0	\N
49984	1704	1506206000000	12973	6689	3	0	\N
49986	1704	1506319000000	13059	6732	17	0	\N
49987	1704	2159030000000	4898	2536	1	0	\N
49988	1704	2159030000000	5128	2659	2	0	\N
49989	1704	2159030000000	5241	2720	3	0	\N
49990	1704	2159030000000	5251	2725	0	0	\N
49991	1704	2159030000000	5568	2894	0	0	\N
49992	1704	2159030000000	5591	2905	0	0	\N
49993	1704	2159030000000	5826	3022	1	0	\N
49994	1704	2159030000000	6200	3208	1	0	\N
49995	1704	2159030000000	6275	3250	4	0	\N
49997	1704	2159040000000	4898	2536	2	0	\N
49998	1704	2159040000000	5826	3022	2	0	\N
49999	1704	2159040000000	6200	3208	2	0	\N
50000	1704	2159050000000	5128	2659	3	0	\N
50001	1704	2159060000000	5241	2720	4	0	\N
50002	1704	2159070000000	6275	3250	5	0	\N
50005	1704	2159310000000	3408	1745	8	0	\N
50006	1704	2159390000000	3408	1745	9	0	\N
50007	1704	2226207000000	13436	6924	1	0	\N
50008	1704	2226207000000	13556	6973	7	0	\N
50009	1704	2226207000000	13738	7061	4	0	\N
50010	1704	2226207000000	13924	7138	4	0	\N
50011	1704	2226207000000	13976	7161	4	0	\N
50012	1704	2226207000000	14316	7305	3	0	\N
50013	1704	2226207000000	14319	7306	4	0	\N
50014	1704	2226207000000	15680	7978	4	0	\N
50015	1704	2226207000000	15815	8048	14	0	\N
50016	1704	2226207000000	15970	8117	6	0	\N
50017	1704	2226207000000	16184	8226	11	0	\N
50018	1704	2226207000000	16280	8274	4	0	\N
50019	1704	2226207000000	16407	8347	2	0	\N
50020	1704	2226207000000	16478	8381	3	0	\N
50021	1704	2226207000000	16739	8500	5	0	\N
50022	1704	2226207000000	16972	8600	2	0	\N
50024	1704	2226217000000	13436	6924	2	0	\N
50025	1704	2226218000000	16407	8347	3	0	\N
50026	1704	2226218000000	16972	8600	3	0	\N
50028	1704	2226219000000	14316	7305	4	0	\N
50029	1704	2226219000000	16478	8381	4	0	\N
50030	1704	2226220000000	13738	7061	5	0	\N
50031	1704	2226220000000	13924	7138	5	0	\N
50032	1704	2226220000000	13976	7161	5	0	\N
50033	1704	2226220000000	14319	7306	5	0	\N
50034	1704	2226220000000	15680	7978	5	0	\N
50035	1704	2226220000000	16280	8274	5	0	\N
50036	1704	2226223000000	13556	6973	8	0	\N
50037	1704	2226230000000	16739	8500	6	0	\N
50038	1704	2226231000000	15970	8117	7	0	\N
50039	1704	2226245000000	16184	8226	12	0	\N
50040	1704	2226284000000	15815	8048	15	0	\N
50041	1704	2879090000000	6657	3442	2	0	\N
50042	1704	2879090000000	6725	3479	2	0	\N
50043	1704	2879110000000	6657	3442	3	0	\N
50044	1704	2879110000000	6725	3479	3	0	\N
50048	1704	3599110000000	6882	3557	5	0	\N
49968	1704	1439010000000	4725	2444	2	0	0
49975	1704	1439030000000	4725	2444	3	0	0
49996	1704	2159030000000	6414	3324	6	0	0
50003	1704	2159090000000	6414	3324	7	0	0
50004	1704	2159110000000	6872	3554	2	0	0
49915	1703	10079490000000	8873	4597	2	0	1
49917	1703	10079510000000	8873	4597	3	0	1
49928	1703	10799510000000	8980	4658	2	0	1
49929	1703	10799530000000	8980	4658	3	0	1
49931	1703	11519530000000	9615	4988	2	0	1
49935	1703	12239550000000	9868	5118	4	0	1
49936	1703	12239590000000	9868	5118	5	0	1
49953	1704	786194000000	12353	6369	1	0	1
49956	1704	786195000000	12353	6369	2	0	1
49985	1704	1506207000000	13316	6859	4	0	1
50023	1704	2226207000000	16987	8605	2	0	1
50027	1704	2226218000000	16987	8605	3	0	1
50046	1704	2946218000000	17253	8739	6	0	1
50047	1704	2946242000000	17253	8739	7	0	1
49926	1703	10080827000000	19461	9809	4	0	3
50049	1704	3599110000000	6919	3572	2	0	\N
50050	1704	3599110000000	7384	3812	1	0	\N
50051	1704	3599110000000	7668	3969	2	0	\N
50052	1704	3599110000000	7705	3991	1	0	\N
50053	1704	3599110000000	7721	3998	1	0	\N
50054	1704	3599110000000	7946	4116	1	0	\N
50055	1704	3599110000000	8001	4147	1	0	\N
50056	1704	3599110000000	8032	4163	3	0	\N
50057	1704	3599110000000	8085	4192	1	0	\N
50058	1704	3599110000000	8234	4266	3	0	\N
50059	1704	3599110000000	8662	4485	1	0	\N
50060	1704	3599110000000	8852	4587	2	0	\N
50061	1704	3599110000000	8902	4611	3	0	\N
50062	1704	3599110000000	9481	4916	2	0	\N
50063	1704	3599110000000	9505	4929	3	0	\N
50064	1704	3599110000000	9541	4947	4	0	\N
50066	1704	3599120000000	7384	3812	2	0	\N
50067	1704	3599120000000	7705	3991	2	0	\N
50068	1704	3599120000000	7721	3998	2	0	\N
50069	1704	3599120000000	7946	4116	2	0	\N
50070	1704	3599120000000	8001	4147	2	0	\N
50071	1704	3599120000000	8085	4192	2	0	\N
50072	1704	3599120000000	8662	4485	2	0	\N
50073	1704	3599130000000	6919	3572	3	0	\N
50074	1704	3599130000000	7668	3969	3	0	\N
50075	1704	3599130000000	8852	4587	3	0	\N
50076	1704	3599130000000	9481	4916	3	0	\N
50078	1704	3599140000000	8032	4163	4	0	\N
50079	1704	3599140000000	8234	4266	4	0	\N
50080	1704	3599140000000	8902	4611	4	0	\N
50081	1704	3599150000000	9541	4947	5	0	\N
50082	1704	3599151000000	6882	3557	6	0	\N
50083	1704	3599380000000	9505	4929	4	0	\N
50086	1704	3666493000000	17855	8921	19	0	\N
50087	1704	3725320000000	21197	10643	1	0	\N
50090	1704	4386303000000	17485	8852	6	0	\N
50091	1704	4386303000000	17554	8888	3	0	\N
50092	1704	4386303000000	17610	8907	4	0	\N
50093	1704	4386303000000	18974	9570	2	0	\N
50094	1704	4386303000000	18993	9577	2	0	\N
50097	1704	4386314000000	18974	9570	3	0	\N
50098	1704	4386314000000	18993	9577	3	0	\N
50099	1704	4386315000000	17554	8888	4	0	\N
50100	1704	4386316000000	17610	8907	5	0	\N
50101	1704	4386354000000	17485	8852	7	0	\N
50102	1704	4386493000000	17855	8921	126	0	\N
50103	1704	4387553000000	17855	8921	127	0	\N
50104	1704	4445310000000	20395	10276	3	0	\N
50105	1704	4445310000000	20500	10322	4	0	\N
50106	1704	4445310000000	21096	10596	4	0	\N
50107	1704	4445310000000	21477	10772	4	0	\N
50108	1704	4445310000000	21533	10801	3	0	\N
50109	1704	4445320000000	21197	10643	3	0	\N
50110	1704	4445321000000	21197	10643	4	0	\N
50111	1704	4445322000000	20395	10276	4	0	\N
50112	1704	4445322000000	21533	10801	4	0	\N
50113	1704	4445323000000	20500	10322	5	0	\N
50114	1704	4445323000000	21477	10772	5	0	\N
50115	1704	4445332000000	21096	10596	5	0	\N
50116	1704	5039195000000	9983	5176	6	0	\N
50117	1704	5039195000000	10353	5358	2	0	\N
50118	1704	5039195000000	10717	5532	2	0	\N
50119	1704	5039195000000	11047	5684	2	0	\N
50120	1704	5039195000000	11136	5723	2	0	\N
50121	1704	5039195000000	11205	5754	6	0	\N
50122	1704	5039215000000	10353	5358	3	0	\N
50123	1704	5039215000000	10717	5532	3	0	\N
50124	1704	5039215000000	11047	5684	3	0	\N
50125	1704	5039215000000	11136	5723	3	0	\N
50126	1704	5039255000000	9983	5176	7	0	\N
50127	1704	5039336000000	11205	5754	7	0	\N
50128	1704	5106313000000	19055	9612	2	0	\N
50129	1704	5106313000000	19226	9697	5	0	\N
50130	1704	5106313000000	19274	9717	3	0	\N
50131	1704	5106313000000	19313	9739	3	0	\N
50132	1704	5106313000000	19499	9830	4	0	\N
50133	1704	5106313000000	19527	9838	4	0	\N
50134	1704	5106313000000	19974	10058	7	0	\N
50135	1704	5106324000000	19055	9612	3	0	\N
50136	1704	5106325000000	19274	9717	4	0	\N
50137	1704	5106325000000	19313	9739	4	0	\N
50138	1704	5106326000000	19499	9830	5	0	\N
50139	1704	5106326000000	19527	9838	5	0	\N
50140	1704	5106336000000	19226	9697	6	0	\N
50141	1704	5106338000000	19974	10058	8	0	\N
50144	1705	747424971000	10278	5319	9	1	\N
50147	1705	1436910000000	580	327	3	0	\N
50148	1705	1436940000000	580	327	4	0	\N
50151	1705	2478799500145	10488	5420	2	0	\N
50152	1705	2478799500145	10522	5434	4	0	\N
50153	1705	2478799500145	10710	5530	2	0	\N
50154	1705	2478799500145	10746	5547	2	0	\N
50156	1705	2478819500145	10488	5420	3	0	\N
50157	1705	2478819500145	10710	5530	3	0	\N
50158	1705	2478819500145	10746	5547	3	0	\N
50159	1705	2478839500145	10522	5434	5	0	\N
50161	1705	2874840000000	1519	832	2	0	\N
50163	1705	2874860000000	1519	832	3	0	\N
50169	1705	3918870500145	10979	5657	3	0	\N
50172	1705	3918891500145	10979	5657	4	0	\N
50173	1705	4314880000000	1623	876	1	0	\N
50175	1705	4314890000000	1623	876	2	0	\N
50177	1705	4638890500145	11478	5900	4	0	\N
50179	1705	4638912500145	11478	5900	5	0	\N
50182	1705	5035280000000	2921	1432	37	0	\N
50183	1705	5358890500145	11684	6007	9	0	\N
50145	1705	1434810000000	1129	622	1	0	2
50146	1705	1434820000000	1129	622	2	0	2
50149	1705	2154820000000	1151	634	2	0	2
50150	1705	2154840000000	1151	634	3	0	2
50162	1705	2874840000000	1555	846	3	0	2
50167	1705	3594870000000	1561	850	1	0	2
50168	1705	3594880000000	1561	850	2	0	2
50174	1705	4314880000000	1723	925	2	0	2
50176	1705	4314900000000	1723	925	3	0	2
50180	1705	5034900000000	1936	1029	1	0	2
50065	1704	3599110000000	9594	4976	2	0	0
50077	1704	3599130000000	9594	4976	3	0	0
50088	1704	4319130000000	9768	5061	11	0	0
50089	1704	4319195000000	9768	5061	12	0	0
50160	1705	2478839500145	10788	5568	5	0	14
50165	1705	3198839500145	10957	5647	4	0	14
50166	1705	3198870500145	10957	5647	5	0	14
50170	1705	3918870500145	11029	5677	2	0	14
50171	1705	3918890500145	11029	5677	3	0	14
50184	1705	5358890500145	11802	6066	1	0	14
50084	1704	3666242000000	17482	8851	7	0	1
50085	1704	3666303000000	17482	8851	8	0	1
50095	1704	4386303000000	19047	9606	1	0	1
50096	1704	4386313000000	19047	9606	2	0	1
50186	1705	5359034500145	11684	6007	10	0	\N
50191	1705	5754910000000	1987	1051	1	0	\N
50192	1705	5754910000000	2094	1105	1	0	\N
50193	1705	5754910000000	2273	1193	2	0	\N
50195	1705	5754920000000	1987	1051	2	0	\N
50196	1705	5754920000000	2094	1105	2	0	\N
50198	1705	5754930000000	2273	1193	3	0	\N
50199	1705	5755280000000	2921	1432	126	0	\N
50200	1705	5756160000000	2921	1432	127	0	\N
50201	1705	6078891500145	11990	6171	2	0	\N
50202	1705	6078891500145	12161	6262	5	0	\N
50203	1705	6078893500145	11990	6171	3	0	\N
50204	1705	6078896500145	12161	6262	6	0	\N
50207	1705	6400453500145	12368	6379	1	0	\N
50208	1705	6400453500145	12449	6416	0	0	\N
50210	1705	6400454500145	12368	6379	2	0	\N
50218	1705	7194930000000	3970	2063	1	0	\N
50220	1705	7194940000000	3970	2063	2	0	\N
50226	1705	7840493500145	14660	7469	5	0	\N
50227	1705	7840516500145	14660	7469	6	0	\N
50234	1705	8635010000000	4992	2587	1	0	\N
50236	1705	8635020000000	4992	2587	2	0	\N
50242	1705	9278494500145	15421	7855	2	0	\N
50243	1705	9278505500145	15421	7855	3	0	\N
50246	1705	9920582580140	21766	10898	3	0	\N
50248	1705	9920582580140	22242	10935	4	0	\N
50249	1705	9920594580140	21766	10898	4	0	\N
50251	1705	9920622580140	22242	10935	5	0	\N
50257	1705	10640594580140	22243	10948	4	0	\N
50259	1705	10640634580140	22243	10948	5	0	\N
50262	1705	10795060000000	5408	2814	0	0	\N
50263	1705	10795060000000	5723	2966	0	0	\N
50267	1705	11360617580140	22245	10990	9	0	\N
50268	1705	11360617580140	22246	11003	9	0	\N
50270	1705	11360707580140	22245	10990	10	0	\N
50271	1705	11360707580140	22246	11003	10	0	\N
50277	1705	11983094500065	10278	5319	2	0	\N
50278	1705	12080652580140	22109	11057	3	0	\N
50280	1705	12080664580140	22109	11057	4	0	\N
50282	1705	12155535500145	17369	8798	2	0	\N
50283	1705	12155535500145	17690	8941	16	0	\N
50285	1705	12155546500145	17369	8798	3	0	\N
50287	1705	12155623500145	17690	8941	17	0	\N
50291	1705	12703094500065	10278	5319	8	0	\N
50297	1705	12955110000000	6367	3297	1	0	\N
50299	1705	12955120000000	6367	3297	2	0	\N
50303	1705	13595592500145	18644	9395	2	0	\N
50305	1705	13595603500145	18644	9395	3	0	\N
50313	1705	14395250000000	6822	3533	2	0	\N
50315	1705	14395270000000	6822	3533	3	0	\N
50212	1705	6474920000000	3794	1965	1	0	2
50213	1705	6474930000000	3794	1965	2	0	2
50219	1705	7194930000000	4033	2094	1	0	2
50221	1705	7194940000000	4033	2094	2	0	2
50228	1705	7914940000000	4656	2406	7	0	2
50235	1705	8635010000000	5091	2641	2	0	2
50237	1705	8635030000000	5091	2641	3	0	2
50244	1705	9355030000000	5262	2731	2	0	2
50245	1705	9355050000000	5262	2731	3	0	2
50254	1705	10075050000000	5336	2769	1	0	2
50264	1705	10795060000000	5817	3019	2	0	2
50265	1705	10795080000000	5817	3019	3	0	2
50274	1705	11515080000000	5865	3040	2	0	2
50275	1705	11515100000000	5865	3040	3	0	2
50289	1705	12235110000000	6305	3264	2	0	2
50298	1705	12955110000000	6380	3305	3	0	2
50300	1705	12955230000000	6380	3305	4	0	2
50307	1705	13675230000000	6423	3326	2	0	2
50308	1705	13675250000000	6423	3326	3	0	2
50316	1705	14395280000000	7520	3893	4	0	2
50276	1705	11983094500065	10276	5319	2	0	8
50290	1705	12703094500065	10276	5319	8	0	8
50292	1705	12703144500065	10276	5319	9	0	8
50185	1705	5358891500145	11802	6066	2	0	14
50190	1705	5680453500145	12319	6348	3	0	18
50209	1705	6400453500145	12813	6607	3	0	18
50211	1705	6400483500145	12813	6607	4	0	18
50216	1705	7120483500145	13562	6975	1	0	18
50224	1705	7838473500145	15085	7685	1	0	19
50225	1705	7838483500145	15085	7685	2	0	19
50232	1705	8558483500145	15239	7761	2	0	19
50233	1705	8558494500145	15239	7761	3	0	19
50240	1705	9275474500145	15675	7977	3	0	20
50252	1705	9995486500145	15860	8066	7	0	20
50253	1705	9995511500145	15860	8066	8	0	20
50260	1705	10715511500145	16559	8416	3	0	20
50261	1705	10715523500145	16559	8416	4	0	20
50272	1705	11435523500145	16881	8562	3	0	20
50284	1705	12155535500145	18247	9191	7	0	20
50286	1705	12155569500145	18247	9191	8	0	20
50295	1705	12875569500145	18282	9212	5	0	20
50296	1705	12875592500145	18282	9212	6	0	20
50306	1705	13595604500145	18796	9472	4	0	20
50311	1705	14315604500145	18925	9547	2	0	20
50312	1705	14315615500145	18925	9547	3	0	20
50319	1705	15035615500145	19660	9903	3	0	20
50320	1705	15035627500145	19660	9903	4	0	20
50188	1705	5600501580140	20870	10490	4	0	25
50205	1705	6320501580140	21122	10609	6	0	25
50206	1705	6320534580140	21122	10609	7	0	25
50214	1705	7040534580140	21158	10626	2	0	25
50215	1705	7040545580140	21158	10626	3	0	25
50223	1705	7760558580140	21353	10717	5	0	25
50230	1705	8480558580140	21422	10743	3	0	25
50231	1705	8480570580140	21422	10743	4	0	25
50238	1705	9200570580140	21588	10823	3	0	25
50247	1705	9920582580140	21851	10935	3	0	25
50250	1705	9920594580140	21851	10935	4	0	25
50256	1705	10640594580140	21931	10973	5	0	25
50258	1705	10640617580140	21931	10973	6	0	25
50266	1705	11360617580140	22107	11056	8	0	25
50279	1705	12080652580140	22147	11078	3	0	25
50281	1705	12080664580140	22147	11078	4	0	25
50293	1705	12800664580140	22234	11128	6	0	25
50294	1705	12800688580140	22234	11128	7	0	25
50301	1705	13520688580140	22241	11132	3	0	25
50309	1705	14240700580140	22244	11133	8	0	25
50310	1705	14240762580140	22244	11133	9	0	25
50317	1705	14960762580140	22359	11191	3	0	25
50318	1705	14960774580140	22359	11191	4	0	25
50323	1705	15680774580140	22803	11403	3	0	\N
50326	1705	15680786580140	22803	11403	4	0	\N
50327	1705	15755627500145	19732	9933	3	0	\N
50328	1705	15755627500145	20231	10186	3	0	\N
50330	1705	15755639500145	19732	9933	4	0	\N
50331	1705	15755639500145	20231	10186	4	0	\N
50335	1705	16400785580140	23514	11721	4	0	\N
50336	1705	16400785580140	23763	11833	7	0	\N
50339	1705	16400798580140	23514	11721	5	0	\N
50340	1705	16400810580140	23763	11833	8	0	\N
50345	1705	17120790580140	24032	11959	3	0	\N
50346	1705	17120790580140	24071	11981	2	0	\N
50347	1705	17120790580140	24303	12086	3	0	\N
50349	1705	17120801580140	24071	11981	3	0	\N
50350	1705	17120802580140	24032	11959	4	0	\N
50351	1705	17120802580140	24303	12086	4	0	\N
50363	1705	18560871580140	24612	12232	3	0	\N
50365	1705	18560883580140	24612	12232	4	0	\N
50371	1705	19435530000000	9051	4692	2	0	\N
50373	1705	19435550000000	9051	4692	3	0	\N
50375	1705	20000896580140	25085	12452	13	0	\N
50376	1705	20000896580140	25414	12594	3	0	\N
50377	1705	20000896580140	25415	12594	1	0	\N
50378	1705	20000896580140	25514	12633	3	0	\N
50380	1705	20000897580140	25415	12594	2	0	\N
50381	1705	20000908580140	25414	12594	4	0	\N
50382	1705	20000908580140	25514	12633	4	0	\N
50384	1705	20000945580140	25085	12452	14	0	\N
50389	1705	20875570000000	9304	4828	8	0	\N
50390	1705	20875570000000	9460	4905	2	0	\N
50391	1705	20875570000000	9619	4990	9	0	\N
50392	1705	20875570000000	9710	5036	1	0	\N
50393	1705	20875570000000	9712	5036	1	0	\N
50395	1705	20875580000000	9710	5036	2	0	\N
50396	1705	20875580000000	9712	5036	2	0	\N
50397	1705	20875590000000	9460	4905	3	0	\N
50399	1705	20875650000000	9304	4828	9	0	\N
50400	1705	20875660000000	9619	4990	10	0	\N
50401	1705	21440932580140	25687	12709	6	0	\N
50404	1705	21440956580140	25687	12709	7	0	\N
50405	1705	21595590000000	10148	5261	2	0	\N
50406	1705	21595610000000	10148	5261	3	0	\N
50409	1705	22880955580140	26089	12893	2	0	\N
50411	1705	22880966580140	26089	12893	3	0	\N
50417	1705	25041004580140	26543	13132	2	0	\N
50418	1705	25041004580140	26872	13290	3	0	\N
50420	1705	25041006580140	26543	13132	3	0	\N
50421	1705	25041016580140	26872	13290	4	0	\N
50423	1705	25041028580140	26977	13340	3	0	\N
50425	1705	25761028580140	26977	13340	4	0	\N
50433	1705	28641065580140	27676	13674	4	0	\N
50436	1705	28641087580140	27676	13674	5	0	\N
50440	1705	30081089580140	28005	13849	6	0	\N
50442	1705	30081113580140	28005	13849	7	0	\N
50445	1705	31521127580140	28326	14004	2	0	\N
50446	1705	31521127580140	28369	14025	2	0	\N
50448	1705	31521138580140	28326	14004	3	0	\N
50449	1705	31521138580140	28369	14025	3	0	\N
50455	1705	33681191580140	29466	14530	8	0	\N
50456	1705	33681191580140	29778	14676	15	0	\N
50333	1705	15835330000000	7683	3979	3	0	2
50334	1705	15835360000000	7683	3979	4	0	2
50343	1705	16555360000000	8412	4359	3	0	2
50344	1705	16555480000000	8412	4359	4	0	2
50355	1705	17275480000000	8694	4507	1	0	2
50361	1705	17995490000000	8712	4519	2	0	2
50362	1705	17995510000000	8712	4519	3	0	2
50367	1705	18715510000000	8849	4586	2	0	2
50368	1705	18715530000000	8849	4586	3	0	2
50372	1705	19435530000000	9166	4751	2	0	2
50385	1705	20155550000000	9185	4761	2	0	2
50386	1705	20155570000000	9185	4761	3	0	2
50394	1705	20875570000000	9840	5101	2	0	2
50398	1705	20875590000000	9840	5101	3	0	2
50332	1705	15755640500145	20234	10188	5	0	20
50341	1705	16475640500145	20470	10308	3	0	20
50342	1705	16475652500145	20470	10308	4	0	20
50353	1705	17195652500145	20705	10413	8	0	20
50354	1705	17195678500145	20705	10413	9	0	20
50360	1705	17915721500145	20741	10427	8	0	20
50324	1705	15680774580140	23188	11577	2	0	25
50325	1705	15680785580140	23188	11577	3	0	25
50337	1705	16400785580140	23764	11833	5	0	25
50338	1705	16400790580140	23764	11833	6	0	25
50352	1705	17120837580140	24335	12101	12	0	25
50357	1705	17840837580140	24423	12146	7	0	25
50358	1705	17840871580140	24423	12146	8	0	25
50364	1705	18560871580140	24777	12302	4	0	25
50369	1705	19280884580140	25064	12438	3	0	25
50370	1705	19280896580140	25064	12438	4	0	25
50379	1705	20000896580140	25552	12652	3	0	25
50383	1705	20000908580140	25552	12652	4	0	25
50387	1705	20720908580140	25632	12685	6	0	25
50402	1705	21440932580140	25902	12802	2	0	25
50403	1705	21440943580140	25902	12802	3	0	25
50407	1705	22160943580140	26009	12855	3	0	25
50408	1705	22160955580140	26009	12855	4	0	25
50410	1705	22880955580140	26393	13055	7	0	25
50413	1705	23600980580140	26426	13074	3	0	25
50414	1705	23600992580140	26426	13074	4	0	25
50415	1705	24320992580140	26508	13115	3	0	25
50416	1705	24321004580140	26508	13115	4	0	25
50422	1705	25041016580140	26951	13331	4	0	25
50424	1705	25761016580140	27092	13395	3	0	25
50426	1705	25761028580140	27092	13395	4	0	25
50427	1705	26481028580140	27181	13444	3	0	25
50428	1705	26481040580140	27181	13444	4	0	25
50430	1705	27201052580140	27406	13552	4	0	25
50431	1705	27921052580140	27499	13593	4	0	25
50432	1705	27921065580140	27499	13593	5	0	25
50434	1705	28641065580140	27677	13675	3	0	25
50435	1705	28641077580140	27677	13675	4	0	25
50438	1705	29361089580140	27793	13734	4	0	25
50439	1705	30081089580140	28004	13850	5	0	25
50441	1705	30081103580140	28004	13850	6	0	25
50443	1705	30801103580140	28230	13958	6	0	25
50447	1705	31521127580140	29023	14313	4	0	25
50450	1705	31521140580140	29023	14313	5	0	25
50451	1705	32241140580140	29031	14317	3	0	25
50452	1705	32241152580140	29031	14317	4	0	25
50453	1705	32961152580140	29386	14488	12	0	25
50457	1705	33681191580140	29834	14701	5	0	\N
50459	1705	33681205580140	29834	14701	6	0	\N
50461	1705	33681215580140	29778	14676	16	0	\N
50462	1705	33681235580140	29466	14530	9	0	\N
50466	1706	200000001	5176	2687	3	1	\N
50467	1706	200000022	10125	5252	4	0	\N
50468	1706	719000000000	157	94	4	0	\N
50471	1706	719040000000	157	94	5	0	\N
50474	1706	1437910000000	788	436	1	0	\N
50475	1706	1437920000000	788	436	2	0	\N
50480	1706	3596851000000	1015	561	1	0	\N
50481	1706	3596851000000	1315	724	1	0	\N
50482	1706	3596851000000	1371	751	1	0	\N
50483	1706	3596851000000	1859	991	2	0	\N
50484	1706	3596851000000	1921	1023	1	0	\N
50485	1706	3596851000000	2049	1082	1	0	\N
50487	1706	3596861000000	1015	561	2	0	\N
50488	1706	3596861000000	1315	724	2	0	\N
50489	1706	3596861000000	1371	751	2	0	\N
50490	1706	3596861000000	1921	1023	2	0	\N
50491	1706	3596861000000	2049	1082	2	0	\N
50493	1706	3596871000000	1859	991	3	0	\N
50494	1706	3812050600135	10648	5500	2	0	\N
50496	1706	3812070600135	10648	5500	3	0	\N
50498	1706	3881939450256	20819	10455	0	0	\N
50503	1706	4532090600135	11142	5726	2	0	\N
50506	1706	4532110600135	11142	5726	3	0	\N
50509	1706	5036771000000	2555	1345	2	0	\N
50512	1706	5036791000000	2555	1345	3	0	\N
50513	1706	5036871000000	2387	1247	1	0	\N
50514	1706	5036881000000	2387	1247	2	0	\N
50527	1706	6477441000000	3489	1701	68	0	\N
50528	1706	6480100000016	3489	1701	86	0	\N
50529	1706	6692094600135	12370	6379	1	0	\N
50531	1706	6692095600135	12370	6379	2	0	\N
50533	1706	6762016450256	22078	11039	3	0	\N
50536	1706	6762028450256	22078	11039	4	0	\N
50537	1706	7196491000000	3228	1675	13	0	\N
50540	1706	7196522000000	3720	1922	3	0	\N
50541	1706	7196711000000	3228	1675	14	0	\N
50542	1706	7197441000000	3489	1701	85	0	\N
50543	1706	7412105600135	12859	6631	2	0	\N
50545	1706	7412116600135	12859	6631	3	0	\N
50547	1706	7412888600135	13657	6731	68	0	\N
50552	1706	7916522000000	3720	1922	12	0	\N
50553	1706	7916602000000	3720	1922	13	0	\N
50555	1706	8132888600135	13657	6731	126	0	\N
50556	1706	8133458600135	13657	6731	127	0	\N
50557	1706	8202066450256	22376	11201	7	0	\N
50559	1706	8202066450256	22608	11310	10	0	\N
50560	1706	8202091450256	22376	11201	8	0	\N
50562	1706	8202103450256	22608	11310	11	0	\N
50563	1706	8636302000000	4247	2204	4	0	\N
50566	1706	8636412000000	4415	2289	10	0	\N
50567	1706	8636412000000	4416	2289	10	0	\N
50568	1706	8636432000000	4247	2204	5	0	\N
50569	1706	8636502000000	4004	2078	1	0	\N
50570	1706	8636512000000	4004	2078	2	0	\N
50571	1706	8852116600135	13742	7062	20	0	\N
50572	1706	8852116600135	13744	7062	20	0	\N
50573	1706	8852116600135	13787	7082	8	0	\N
50574	1706	8852116600135	14313	7304	3	0	\N
50576	1706	8852128600135	14313	7304	4	0	\N
50577	1706	8852142600135	13787	7082	9	0	\N
50579	1706	8852181600135	13742	7062	21	0	\N
50580	1706	8852181600135	13744	7062	21	0	\N
50583	1706	8923114450256	22980	11402	102	0	\N
50586	1706	9356412000000	4415	2289	13	0	\N
50587	1706	9356412000000	4416	2289	13	0	\N
50588	1706	9356432000000	4415	2289	14	0	\N
50589	1706	9356432000000	4416	2289	14	0	\N
50590	1706	9572142600135	14572	7430	2	0	\N
50591	1706	9572142600135	15593	7938	2	0	\N
50472	1706	1436810000000	882	490	1	0	2
50473	1706	1436820000000	882	490	2	0	2
50476	1706	2156820000000	895	497	3	0	2
50477	1706	2156841000000	895	497	4	0	2
50478	1706	2876841000000	1001	553	1	0	2
50486	1706	3596851000000	2083	1099	1	0	2
50492	1706	3596861000000	2083	1099	2	0	2
50501	1706	4316861000000	2138	1128	1	0	2
50502	1706	4316871000000	2138	1128	2	0	2
50510	1706	5036771000000	2711	1424	1	0	3
50519	1706	5756781000000	2843	1488	1	0	3
50520	1706	5756791000000	2843	1488	2	0	3
50525	1706	6476591000000	2999	1558	1	0	4
50526	1706	6476691000000	2999	1558	2	0	4
50539	1706	7196492000000	3488	1812	2	0	5
50550	1706	7916492000000	3716	1930	1	0	5
50551	1706	7916502000000	3716	1930	2	0	5
50564	1706	8636302000000	4379	2271	1	0	6
50565	1706	8636312000000	4379	2271	2	0	6
50585	1706	9356322000000	4710	2435	2	0	6
50495	1706	3812050600135	11008	5668	4	0	20
50497	1706	3812090600135	11008	5668	5	0	20
50504	1706	4532090600135	11744	6036	2	0	20
50505	1706	4532092600135	11744	6036	3	0	20
50516	1706	5252093600135	12032	6192	2	0	20
50521	1706	5972093600135	12080	6220	1	0	20
50522	1706	5972094600135	12080	6220	2	0	20
50530	1706	6692094600135	12645	6522	2	0	20
50544	1706	7412105600135	12872	6638	2	0	20
50546	1706	7412116600135	12872	6638	3	0	20
50554	1706	8132116600135	13656	7020	0	0	20
50575	1706	8852116600135	14428	7361	8	0	20
50578	1706	8852142600135	14428	7361	9	0	20
50499	1706	3881939450256	20820	10465	2	0	27
50500	1706	3881950450256	20820	10465	3	0	27
50507	1706	4601950450256	20973	10548	6	0	27
50508	1706	4601992450256	20973	10548	7	0	27
50517	1706	5321992450256	21079	10590	3	0	27
50523	1706	6042004450256	22055	11028	3	0	27
50524	1706	6042016450256	22055	11028	4	0	27
50534	1706	6762016450256	22079	11039	2	0	27
50535	1706	6762018450256	22079	11039	3	0	27
50549	1706	7482066450256	22318	11172	13	0	27
50558	1706	8202066450256	22607	11310	7	0	27
50561	1706	8202100450256	22607	11310	8	0	27
50581	1706	8922100450256	22674	11336	3	0	27
50582	1706	8922112450256	22674	11336	4	0	27
50460	1705	33681210580140	29992	14768	11	0	25
50463	1705	33681243580140	30276	14887	24	0	25
50464	1705	34401243580140	30276	14887	33	0	25
50465	1705	34401250950973	30276	14887	37	0	25
50593	1706	9572144600135	15593	7938	3	0	\N
50594	1706	9572153600135	14572	7430	3	0	\N
50596	1706	9642112450256	22979	11478	2	0	\N
50597	1706	9642112450256	23556	11741	6	0	\N
50598	1706	9642112450256	23804	11848	3	0	\N
50600	1706	9642123450256	22979	11478	3	0	\N
50601	1706	9642124450256	23804	11848	4	0	\N
50603	1706	9642127450256	23556	11741	7	0	\N
50604	1706	9643114450256	22980	11402	121	0	\N
50605	1706	9643132450256	22980	11402	122	0	\N
50606	1706	10076322000000	4732	2446	3	0	\N
50609	1706	10076353110000	4732	2446	4	0	\N
50612	1706	10292610600135	16836	8413	26	0	\N
50613	1706	10362124450256	23938	11913	5	0	\N
50616	1706	10362138450256	23938	11913	6	0	\N
50617	1706	10796332000000	5079	2636	2	0	\N
50619	1706	10796343000000	5079	2636	3	0	\N
50621	1706	11012180600135	16066	8170	4	0	\N
50622	1706	11012180600135	16833	8259	45	0	\N
50623	1706	11012180600135	16856	8324	0	0	\N
50624	1706	11012180600135	16858	8337	0	0	\N
50625	1706	11012180600135	16859	8349	0	0	\N
50626	1706	11012180600135	16861	8360	0	0	\N
50627	1706	11012180600135	16862	8372	0	0	\N
50628	1706	11012180600135	17365	8796	5	0	\N
50631	1706	11012193600135	16066	8170	5	0	\N
50632	1706	11012203600135	17365	8796	6	0	\N
50633	1706	11012610600135	16836	8413	70	0	\N
50634	1706	11013040600135	16836	8413	71	0	\N
50635	1706	11013394600135	16833	8259	46	0	\N
50637	1706	11516352000000	5175	2687	2	0	\N
50638	1706	11516352000000	5176	2687	2	0	\N
50639	1706	11516352000000	5230	2719	2	0	\N
50641	1706	11516352000000	5906	3012	0	0	\N
50643	1706	11516372000000	5175	2687	3	0	\N
50644	1706	11516372000000	5230	2719	3	0	\N
50647	1706	11802136450256	24620	12235	3	0	\N
50649	1706	11802136450256	24846	12335	2	0	\N
50650	1706	11802147450256	24846	12335	3	0	\N
50651	1706	11802148450256	24620	12235	4	0	\N
50659	1706	12956382000000	6374	3302	1	0	\N
50660	1706	12956382000000	6419	3325	2	0	\N
50661	1706	12956382000000	6428	3328	4	0	\N
50663	1706	12956392000000	6374	3302	2	0	\N
50664	1706	12956402000000	6419	3325	3	0	\N
50666	1706	12956422000000	6428	3328	5	0	\N
50667	1706	13172268600135	18619	9381	2	0	\N
50670	1706	13172279600135	18619	9381	3	0	\N
50675	1706	13892278600135	18883	9524	1	0	\N
50677	1706	13892288600135	18883	9524	2	0	\N
50679	1706	13892758600135	19180	9610	47	0	\N
50680	1706	13962172450256	25138	12472	3	0	\N
50681	1706	13962172450256	25470	12615	3	0	\N
50682	1706	13962172450256	25471	12615	2	0	\N
50684	1706	13962174450256	25471	12615	3	0	\N
50685	1706	13962184450256	25138	12472	4	0	\N
50686	1706	13962184450256	25470	12615	4	0	\N
50688	1706	13962830450256	25865	12745	79	0	\N
50691	1706	14612288600135	19181	9677	5	0	\N
50693	1706	14612288600135	19382	9769	2	0	\N
50695	1706	14612299600135	19382	9769	3	0	\N
50696	1706	14612311600135	19181	9677	6	0	\N
50697	1706	14612758600135	19180	9610	126	0	\N
50698	1706	14613425600135	19180	9610	127	0	\N
50699	1706	14682184450256	25626	12681	10	0	\N
50702	1706	14682230450256	25626	12681	11	0	\N
50703	1706	14682830450256	25865	12745	126	0	\N
50704	1706	14682876450256	25865	12745	127	0	\N
50713	1706	16052344600135	19874	10011	4	0	\N
50716	1706	16052357600135	19874	10011	5	0	\N
50721	1706	16772356600135	20490	10317	3	0	\N
50722	1706	16772356600135	20496	10321	2	0	\N
50723	1706	16772356600135	20737	10424	3	0	\N
50724	1706	16772367600135	20496	10321	3	0	\N
50725	1706	16772368600135	20490	10317	4	0	\N
50726	1706	16772368600135	20737	10424	4	0	\N
50727	1706	16842246450256	26421	13072	3	0	\N
50618	1706	10796332000000	5084	2638	2	0	6
50620	1706	10796352000000	5084	2638	3	0	6
50640	1706	11516352000000	5905	3061	1	0	6
50642	1706	11516362000000	5905	3061	2	0	6
50653	1706	12236362000000	6096	3164	2	0	6
50662	1706	12956382000000	6734	3485	2	0	6
50665	1706	12956402000000	6734	3485	3	0	6
50673	1706	13676402000000	6896	3563	2	0	6
50674	1706	13676422000000	6896	3563	3	0	6
50689	1706	14396422000000	7392	3818	1	0	6
50705	1706	15116432000000	7465	3862	1	0	6
50706	1706	15116442000000	7465	3862	2	0	6
50711	1706	15836442000000	7602	3933	1	0	6
50712	1706	15836452000000	7602	3933	2	0	6
50720	1706	16556462000000	7804	4047	2	0	6
50595	1706	9572167600135	15671	7976	8	0	20
50610	1706	10292167600135	15875	8075	4	0	20
50611	1706	10292180600135	15875	8075	5	0	20
50629	1706	11012180600135	17949	9053	3	0	20
50645	1706	11732192600135	18077	9117	2	0	20
50646	1706	11732203600135	18077	9117	3	0	20
50655	1706	12452203600135	18176	9166	11	0	20
50656	1706	12452268600135	18176	9166	12	0	20
50668	1706	13172268600135	18830	9488	1	0	20
50676	1706	13892278600135	18886	9526	1	0	20
50678	1706	13892288600135	18886	9526	2	0	20
50692	1706	14612288600135	19381	9769	2	0	20
50694	1706	14612299600135	19381	9769	3	0	20
50708	1706	15332344600135	19716	9926	10	0	20
50714	1706	16052344600135	20150	10141	3	0	20
50715	1706	16052356600135	20150	10141	4	0	20
50599	1706	9642112450256	23919	11903	3	0	27
50602	1706	9642124450256	23919	11903	4	0	27
50615	1706	10362136450256	24347	12109	4	0	27
50636	1706	11082136450256	24536	12199	0	0	27
50648	1706	11802136450256	24845	12335	3	0	27
50652	1706	11802148450256	24845	12335	4	0	27
50657	1706	12522148450256	24883	12354	3	0	27
50671	1706	13242160450256	24937	12378	3	0	27
50672	1706	13242172450256	24937	12378	4	0	27
50683	1706	13962172450256	25531	12639	3	0	27
50687	1706	13962184450256	25531	12639	4	0	27
50701	1706	14682208450256	25866	12787	7	0	27
50709	1706	15402208450256	26160	12930	8	0	27
50710	1706	15402234450256	26160	12930	9	0	27
50717	1706	16122234450256	26199	12951	3	0	27
50718	1706	16122246450256	26199	12951	4	0	27
50729	1706	16842258450256	26421	13072	4	0	\N
50731	1706	17276462000000	8167	4233	2	0	\N
50732	1706	17276462000000	8304	4299	1	0	\N
50734	1706	17276472000000	8304	4299	2	0	\N
50736	1706	17276482000000	8167	4233	3	0	\N
50737	1706	17562258450256	26648	13182	4	0	\N
50740	1706	17562271450256	26648	13182	5	0	\N
50741	1706	17562282450256	27106	13401	3	0	\N
50742	1706	17562282450256	27107	13401	3	0	\N
50743	1706	17996472000000	8465	4386	1	0	\N
50745	1706	17996482000000	8465	4386	2	0	\N
50750	1706	18282270450256	27438	13406	1	0	\N
50751	1706	18282271450256	27438	13406	2	0	\N
50752	1706	18282282450255	27107	13401	4	0	\N
50753	1706	18282282450256	27106	13401	4	0	\N
50755	1706	18716482000000	8633	4474	0	0	\N
50759	1706	19002282450256	27441	13421	1	0	\N
50760	1706	19002282450256	27443	13435	1	0	\N
50761	1706	19002283450256	27441	13421	2	0	\N
50762	1706	19002283450256	27443	13435	2	0	\N
50764	1706	19436512000000	9483	4917	2	0	\N
50765	1706	19436512000000	9730	5042	2	0	\N
50766	1706	19436512000000	9732	5042	2	0	\N
50767	1706	19436512000000	9921	5149	2	0	\N
50770	1706	19436532000000	9483	4917	3	0	\N
50771	1706	19436532000000	9730	5042	3	0	\N
50772	1706	19436532000000	9732	5042	3	0	\N
50773	1706	19436532000000	9921	5149	3	0	\N
50774	1706	19438292000000	10112	5209	114	0	\N
50776	1706	19722294450256	27444	13448	1	0	\N
50777	1706	19722295450256	27444	13448	2	0	\N
50779	1706	20156522000000	10111	5245	7	0	\N
50780	1706	20156522000000	10125	5252	2	0	\N
50783	1706	20156572000000	10111	5245	8	0	\N
50784	1706	20156572000000	10449	5405	1	0	\N
50785	1706	20156572000000	10450	5405	1	0	\N
50786	1706	20158292000000	10112	5209	126	0	\N
50787	1706	20158402000000	10112	5209	127	0	\N
50788	1706	20160082000000	10123	5210	114	0	\N
50789	1706	20442305450256	27442	13564	7	0	\N
50791	1706	20442330450256	27442	13564	8	0	\N
50793	1706	20876562000000	10421	5390	12	0	\N
50795	1706	20876572000000	10449	5405	14	0	\N
50796	1706	20876572000000	10450	5405	14	0	\N
50798	1706	20876682000000	10421	5390	13	0	\N
50799	1706	20876692000000	10449	5405	15	0	\N
50800	1706	20876692000000	10450	5405	15	0	\N
50801	1706	20880082000000	10123	5210	126	0	\N
50802	1706	20880182000000	10123	5210	127	0	\N
50803	1706	21162339450256	27840	13761	3	0	\N
50805	1706	21162351450256	27840	13761	4	0	\N
50807	1706	21882352450256	28172	13928	7	0	\N
50810	1706	21882386450256	28172	13928	8	0	\N
50815	1706	24042409450256	28931	14268	7	0	\N
50818	1706	24042434450256	28931	14268	8	0	\N
50819	1706	24762421450256	28997	14296	3	0	\N
50820	1706	24762421450256	29339	14458	4	0	\N
50821	1706	24762421450256	29358	14469	2	0	\N
50822	1706	24762421450256	29360	14469	0	0	\N
50824	1706	24762432450256	29358	14469	3	0	\N
50825	1706	24762433450256	28997	14296	4	0	\N
50826	1706	24762434450256	29339	14458	5	0	\N
50828	1706	25482456450256	29928	14742	19	0	\N
50829	1706	25482493450256	29928	14742	20	0	\N
50832	1708	1439130000000	996	549	1	0	\N
50833	1708	1439130000000	1118	616	1	0	\N
50834	1708	1439130000000	1318	726	1	0	\N
50835	1708	1439130000000	1756	940	1	0	\N
50837	1708	1439140000000	996	549	2	0	\N
50838	1708	1439140000000	1118	616	2	0	\N
50839	1708	1439140000000	1318	726	2	0	\N
50840	1708	1439140000000	1756	940	2	0	\N
50842	1708	2159160000000	2159	1140	2	0	\N
50843	1708	2159160000000	2180	1150	2	0	\N
50846	1708	2159180000000	2159	1140	3	0	\N
50847	1708	2159180000000	2180	1150	3	0	\N
50848	1708	2879170000000	2521	1323	4	0	\N
50849	1708	2879170000000	2702	1419	1	0	\N
50851	1708	2879180000000	2702	1419	2	0	\N
50853	1708	2879210000000	2521	1323	5	0	\N
50856	1708	4319190000000	2869	1501	1	0	\N
50857	1708	4319190000000	2945	1531	1	0	\N
50858	1708	4319190000000	2998	1558	1	0	\N
50859	1708	4319190000000	3271	1699	2	0	\N
50861	1708	4319200000000	2869	1501	2	0	\N
50862	1708	4319200000000	2945	1531	2	0	\N
50863	1708	4319210000000	3271	1699	3	0	\N
50864	1708	4319290000000	2998	1558	2	0	\N
50836	1708	1439130000000	1899	1012	3	0	0
50841	1708	1439160000000	1899	1012	4	0	0
50844	1708	2159160000000	2257	1185	1	0	0
50845	1708	2159170000000	2257	1185	2	0	0
50850	1708	2879170000000	2773	1451	1	0	0
50854	1708	3599180000000	2849	1492	1	0	0
50855	1708	3599190000000	2849	1492	2	0	0
50860	1708	4319190000000	3596	1868	0	0	0
50733	1706	17276462000000	8334	4316	1	0	6
50735	1706	17276472000000	8334	4316	2	0	6
50746	1706	17996482000000	8601	4460	2	0	6
50756	1706	18716482000000	9375	4864	3	0	6
50757	1706	18716512000000	9375	4864	4	0	6
50768	1706	19436512000000	9922	5149	1	0	6
50781	1706	20156522000000	10325	5342	4	0	6
50782	1706	20156562000000	10325	5342	5	0	6
50794	1706	20876562000000	10471	5412	2	0	6
50797	1706	20876582000000	10471	5412	3	0	6
50747	1706	18210356600135	20781	10444	2	0	20
50730	1706	16842258450256	26451	13083	4	0	27
50738	1706	17562258450256	27060	13378	3	0	27
50739	1706	17562270450256	27060	13378	4	0	27
50749	1706	18282270450256	27117	13407	3	0	27
50754	1706	18282282450256	27117	13407	4	0	27
50763	1706	19002294450256	27188	13447	4	0	27
50775	1706	19722294450256	27240	13469	2	0	27
50778	1706	19722305450256	27240	13469	3	0	27
50790	1706	20442305450256	27773	13722	7	0	27
50804	1706	21162339450256	28096	13889	4	0	27
50806	1706	21162352450256	28096	13889	5	0	27
50808	1706	21882352450256	28188	13934	2	0	27
50809	1706	21882363450256	28188	13934	3	0	27
50811	1706	22602363450256	28272	13978	3	0	27
50813	1706	23322375450256	28498	14083	7	0	27
50814	1706	23322409450256	28498	14083	8	0	27
50816	1706	24042409450256	28936	14271	3	0	27
50817	1706	24042421450256	28936	14271	4	0	27
50823	1706	24762421450256	29832	14699	17	0	27
50865	1708	4356611000021	13362	6743	91	0	\N
50867	1708	5041740000000	4461	2193	75	0	\N
50868	1708	5075701000021	12892	6644	0	0	\N
50869	1708	5075701000021	13413	6910	2	0	\N
50871	1708	5075721000021	13413	6910	3	0	\N
50872	1708	5076611000021	13362	6743	126	0	\N
50873	1708	5076951000021	13362	6743	127	0	\N
50878	1708	5761740000000	4461	2193	126	0	\N
50879	1708	5762240000000	4461	2193	127	0	\N
50880	1708	5795701000021	13639	7011	16	0	\N
50881	1708	5795701000021	14118	7217	4	0	\N
50882	1708	5795701000021	14290	7293	7	0	\N
50885	1708	5795714000021	14118	7217	5	0	\N
50886	1708	5795726000021	14290	7293	8	0	\N
50887	1708	5795753000021	13639	7011	17	0	\N
50888	1708	6120468500051	24358	12114	2	0	\N
50890	1708	6120479500051	24358	12114	3	0	\N
50894	1708	6482240000000	4591	2194	26	0	\N
50895	1708	6484183000000	4591	2194	27	0	\N
50903	1708	7204183000000	4693	2195	5	0	\N
50904	1708	7204413000000	4693	2195	6	0	\N
50905	1708	7235732000021	14542	7418	6	0	\N
50906	1708	7235732000021	14959	7618	3	0	\N
50909	1708	7235744000021	14959	7618	4	0	\N
50910	1708	7235756000021	14542	7418	7	0	\N
50913	1708	7919230000000	5387	2804	0	0	\N
50914	1708	7919230000000	5434	2828	0	0	\N
50918	1708	8280538500051	24877	12351	3	0	\N
50920	1708	8280550500051	24877	12351	4	0	\N
50924	1708	8675755000021	15698	7984	4	0	\N
50927	1708	8675768000021	15698	7984	5	0	\N
50928	1708	9000550500051	25223	12513	3	0	\N
50929	1708	9000550500051	25508	12632	3	0	\N
50931	1708	9000562500051	25223	12513	4	0	\N
50932	1708	9000562500051	25508	12632	4	0	\N
50934	1708	9359280000000	6420	3325	2	0	\N
50935	1708	9359280000000	7119	3678	2	0	\N
50936	1708	9359280000000	7257	3753	1	0	\N
50938	1708	9359290000000	7257	3753	2	0	\N
50940	1708	9359300000000	6420	3325	3	0	\N
50941	1708	9359300000000	7119	3678	3	0	\N
50942	1708	9395767000021	16392	8338	7	0	\N
50945	1708	9395792000021	16392	8338	8	0	\N
50946	1708	9396102000021	16454	8339	31	0	\N
50947	1708	9720574500051	25671	12705	3	0	\N
50949	1708	9720586500051	25671	12705	4	0	\N
50953	1708	10115779000021	16887	8565	3	0	\N
50955	1708	10115791000021	16887	8565	4	0	\N
50957	1708	10116102000021	16454	8339	126	0	\N
50958	1708	10116313000021	16454	8339	127	0	\N
50963	1708	10800280000000	8584	4367	43	0	\N
50966	1708	11160598500051	25900	12801	3	0	\N
50969	1708	11160619500051	25900	12801	4	0	\N
50970	1708	11519480000000	8866	4594	2	0	\N
50972	1708	11519500000000	8866	4594	3	0	\N
50974	1708	11520280000000	8584	4367	102	0	\N
50975	1708	11520842000000	8584	4367	103	0	\N
50984	1708	12240842000000	8606	4368	33	0	\N
50985	1708	12241073000000	8606	4368	34	0	\N
50986	1708	12275815000021	17562	8890	3	0	\N
50987	1708	12275815000021	17761	8974	3	0	\N
50988	1708	12275815000021	17814	8997	3	0	\N
50990	1708	12275818000021	17814	8997	4	0	\N
50991	1708	12275827000021	17562	8890	4	0	\N
50992	1708	12275827000021	17761	8974	4	0	\N
50994	1708	12308114115923	22340	11183	10	0	\N
50995	1708	12308114115923	22717	11357	3	0	\N
50996	1708	12308114115923	23030	11499	3	0	\N
50997	1708	12308114115923	23044	11506	4	0	\N
50999	1708	12308126115923	22717	11357	4	0	\N
51000	1708	12308126115923	23030	11499	4	0	\N
50877	1708	5759200000000	4921	2546	2	0	0
50892	1708	6479200000000	5018	2604	1	0	0
50893	1708	6479210000000	5018	2604	2	0	0
50901	1708	7199210000000	5123	2657	2	0	0
50902	1708	7199230000000	5123	2657	3	0	0
50922	1708	8639230000000	5891	3054	5	0	0
50923	1708	8639280000000	5891	3054	6	0	0
50937	1708	9359280000000	7258	3754	1	0	0
50939	1708	9359290000000	7258	3754	2	0	0
50951	1708	10079290000000	7357	3802	18	0	0
50961	1708	10799470000000	7484	3871	1	0	0
50962	1708	10799480000000	7484	3871	2	0	0
50971	1708	11519480000000	9102	4717	2	0	0
50973	1708	11519500000000	9102	4717	3	0	0
50983	1708	12239520000000	9202	4770	3	0	0
50870	1708	5075701000021	13456	6932	0	0	4
50883	1708	5795701000021	14386	7341	3	0	4
50884	1708	5795713000021	14386	7341	4	0	4
50896	1708	6515713000021	14415	7354	10	0	4
50907	1708	7235732000021	15133	7714	2	0	4
50908	1708	7235743000021	15133	7714	3	0	4
50916	1708	7955743000021	15325	7810	3	0	4
50917	1708	7955755000021	15325	7810	4	0	4
50925	1708	8675755000021	16123	8197	3	0	4
50943	1708	9395767000021	16828	8541	3	0	4
50944	1708	9395779000021	16828	8541	4	0	4
50954	1708	10115779000021	17003	8612	3	0	4
50956	1708	10115791000021	17003	8612	4	0	4
50965	1708	10835802000021	17094	8662	3	0	4
50976	1708	11555802000021	17175	8706	4	0	4
50977	1708	11555815000021	17175	8706	5	0	4
50989	1708	12275815000021	17826	9003	4	0	4
50993	1708	12275828000021	17826	9003	5	0	4
50979	1708	11588114115923	22272	11148	9	0	7
50998	1708	12308114115923	23070	11518	3	0	7
50874	1708	5400419500051	24248	12066	13	0	8
50875	1708	5400468500051	24248	12066	14	0	8
50889	1708	6120468500051	24650	12244	4	0	8
50898	1708	6840481500051	24697	12266	5	0	8
50899	1708	6840513500051	24697	12266	6	0	8
50900	1708	6840535500051	24765	12296	4	0	8
50911	1708	7560535500051	24765	12296	8	0	8
50919	1708	8280538500051	25114	12462	3	0	8
50921	1708	8280550500051	25114	12462	4	0	8
50930	1708	9000550500051	25537	12643	6	0	8
50933	1708	9000574500051	25537	12643	7	0	8
50948	1708	9720574500051	25707	12718	3	0	8
50959	1708	10440586500051	25827	12771	3	0	8
50960	1708	10440598500051	25827	12771	4	0	8
50967	1708	11160598500051	26334	13022	4	0	8
50968	1708	11160611500051	26334	13022	5	0	8
50980	1708	11880611500051	26497	13107	3	0	8
51002	1708	12308127115923	23044	11506	5	0	\N
51003	1708	12308151115923	22340	11183	11	0	\N
51009	1708	12995828000021	18039	9100	2	0	\N
51011	1708	12995839000021	18039	9100	3	0	\N
51015	1708	13320646500051	27297	13492	6	0	\N
51018	1708	13320670500051	27297	13492	7	0	\N
51019	1708	13679551000000	9524	4938	5	0	\N
51020	1708	13679551000000	9678	5022	6	0	\N
51021	1708	13679551000000	9690	5028	10	0	\N
51023	1708	13679592000000	9524	4938	6	0	\N
51025	1708	13679611000000	9678	5022	7	0	\N
51026	1708	13679651000000	9690	5028	11	0	\N
51033	1708	14399592000000	10020	5196	4	0	\N
51035	1708	14399614000000	10020	5196	5	0	\N
51039	1708	14435911000021	18476	9308	8	0	\N
51040	1708	14468183115923	23615	11765	6	0	\N
51041	1708	14468183115923	23734	11823	5	0	\N
51042	1708	14468197115923	23734	11823	6	0	\N
51043	1708	14468207115923	23615	11765	7	0	\N
51044	1708	14760681324650	27672	13675	2	0	\N
51046	1708	14760683324650	27672	13675	3	0	\N
51048	1708	15119632000000	10521	5434	4	0	\N
51050	1708	15119672000000	10521	5434	5	0	\N
51052	1708	15155885000021	18468	9305	7	0	\N
51053	1708	15155885000021	18568	9357	2	0	\N
51056	1708	15155896000021	18568	9357	3	0	\N
51057	1708	15155910000021	18468	9305	8	0	\N
51058	1708	15155911000021	18476	9308	9	0	\N
51061	1708	15839672000000	10859	5605	2	0	\N
51063	1708	15839692000000	10859	5605	3	0	\N
51067	1708	16200716324650	28615	14130	2	0	\N
51069	1708	16200727324650	28615	14130	3	0	\N
51073	1708	16595906000021	18999	9580	2	0	\N
51075	1708	16595917000021	18999	9580	3	0	\N
51077	1708	16920727324650	28782	14196	6	0	\N
51080	1708	16920751324650	28782	14196	7	0	\N
51089	1708	18035995000021	19567	9857	3	0	\N
51090	1708	18035995000021	19583	9865	4	0	\N
51092	1708	18036007000021	19567	9857	4	0	\N
51094	1708	18036008000021	19583	9865	5	0	\N
51095	1708	18036241000021	20623	10359	27	0	\N
51096	1708	18360740324650	28926	14265	7	0	\N
51099	1708	18360765324650	28926	14265	8	0	\N
51100	1708	18719719000000	12602	6499	2	0	\N
51102	1708	18719730000000	12602	6499	3	0	\N
51104	1708	18756007000021	20553	10347	3	0	\N
51105	1708	18756007000021	20622	10374	7	0	\N
51107	1708	18756019000021	20553	10347	4	0	\N
51109	1708	18756023000021	20622	10374	8	0	\N
51110	1708	18756241000021	20623	10359	80	0	\N
51111	1708	18756293000021	20623	10359	81	0	\N
51112	1708	18757572000021	20683	10360	73	0	\N
51117	1708	19477572000021	20683	10360	126	0	\N
51118	1708	19477624000021	20683	10360	127	0	\N
51119	1708	19478794000021	20762	10361	73	0	\N
51124	1708	20198794000021	20762	10361	119	0	\N
51125	1708	20198893000021	20762	10361	120	0	\N
51126	1708	20520793181790	29718	14652	27	0	\N
51127	1708	20520793181790	30043	14791	21	0	\N
51128	1708	20520829181790	29718	14652	28	0	\N
51129	1708	20520832181790	30043	14791	22	0	\N
51130	1708	20916316500022	21303	10696	3	0	\N
51132	1708	20916328500022	21303	10696	4	0	\N
51134	1708	21636328500022	21613	10832	3	0	\N
51136	1708	21636340500022	21613	10832	4	0	\N
51022	1708	13679551000000	9977	5174	5	0	0
51024	1708	13679592000000	9977	5174	6	0	0
51034	1708	14399592000000	10338	5351	4	0	0
51036	1708	14399632000000	10338	5351	5	0	0
51049	1708	15119632000000	10621	5485	4	0	0
51062	1708	15839672000000	11247	5778	4	0	0
51064	1708	15839694000000	11247	5778	5	0	0
51071	1708	16559694000000	11339	5823	4	0	0
51072	1708	16559716000000	11339	5823	5	0	0
51081	1708	17279716000000	11572	5949	1	0	0
51087	1708	17999717000000	12406	6400	2	0	0
51088	1708	17999719000000	12406	6400	3	0	0
51101	1708	18719719000000	12618	6510	4	0	0
51103	1708	18719741000000	12618	6510	5	0	0
51012	1708	12995839000021	18070	9113	3	0	4
51027	1708	13715839000021	18348	9244	7	0	4
51028	1708	13715873000021	18348	9244	8	0	4
51037	1708	14435873000021	18452	9300	3	0	4
51038	1708	14435885000021	18452	9300	4	0	4
51055	1708	15155895000021	18906	9536	2	0	4
51065	1708	15875895000021	18975	9570	2	0	4
51066	1708	15875906000021	18975	9570	3	0	4
51074	1708	16595906000021	19173	9673	14	0	4
51076	1708	16595983000021	19173	9673	15	0	4
51084	1708	17315995000021	19454	9805	4	0	4
51091	1708	18035995000021	19649	9896	3	0	4
51093	1708	18036007000021	19649	9896	4	0	4
51106	1708	18756007000021	20681	10402	3	0	4
51115	1708	19476019000021	20761	10436	14	0	4
51116	1708	19476294500022	20761	10436	15	0	4
51122	1708	20196294500022	20884	10498	4	0	4
51123	1708	20196316500022	20884	10498	5	0	4
51131	1708	20916316500022	21600	10827	3	0	4
51135	1708	21636328500022	21654	10847	9	0	4
51001	1708	12308126115923	23070	11518	4	0	7
51013	1708	13028126115923	23536	11732	9	0	7
51014	1708	13028171115923	23536	11732	10	0	7
51029	1708	13748171115923	23606	11761	3	0	7
51004	1708	12600623500051	26963	13335	5	0	8
51005	1708	12600646500051	26963	13335	6	0	8
51006	1708	12600656500051	27445	13565	1	0	8
51016	1708	13320656500051	27445	13565	4	0	8
51031	1708	14040657324650	27519	13604	6	0	8
51032	1708	14040681324650	27519	13604	7	0	8
51045	1708	14760681324650	27942	13823	6	0	8
51047	1708	14760705324650	27942	13823	7	0	8
51059	1708	15480705324650	28344	14012	2	0	8
51068	1708	16200716324650	28633	14138	2	0	8
51070	1708	16200727324650	28633	14138	3	0	8
51078	1708	16920727324650	28833	14221	1	0	8
51079	1708	16920728324650	28833	14221	2	0	8
51085	1708	17640728324650	28838	14224	3	0	8
51097	1708	18360740324650	28951	14277	5	0	8
51098	1708	18360758181790	28951	14277	6	0	8
51113	1708	19080758181790	29304	14440	5	0	8
51114	1708	19080781181790	29304	14440	6	0	8
51121	1708	19800793181790	29431	14510	4	0	8
51138	1709	12603401	3499	1677	63	1	\N
51141	1709	720000000000	10216	5289	2	0	\N
51142	1709	720000000000	10217	5289	0	0	\N
51144	1709	720009000000	20387	10271	3	0	\N
51146	1709	720020000000	10216	5289	3	0	\N
51148	1709	720021000000	20387	10271	4	0	\N
51150	1709	720210070000	8958	4569	127	1	\N
51155	1709	1440035000000	20474	10311	1	0	\N
51157	1709	1440036000000	20474	10311	2	0	\N
51161	1709	2160022000000	12188	6275	1	0	\N
51163	1709	2160023000000	12188	6275	2	0	\N
51165	1709	2160046000000	20497	10321	1	0	\N
51166	1709	2160046000000	20498	10321	2	0	\N
51168	1709	2160047000000	20497	10321	2	0	\N
51169	1709	2160057000000	20498	10321	3	0	\N
51175	1709	2880057000000	21585	10821	3	0	\N
51176	1709	2880057000000	21946	10979	3	0	\N
51177	1709	2880057000000	22751	11376	2	0	\N
51178	1709	2880057000000	22752	11376	3	0	\N
51179	1709	2880057000000	22851	11426	3	0	\N
51180	1709	2880057000000	22991	11484	5	0	\N
51182	1709	2880068000000	22751	11376	3	0	\N
51184	1709	2880069000000	21585	10821	4	0	\N
51185	1709	2880069000000	21946	10979	4	0	\N
51186	1709	2880069000000	22752	11376	4	0	\N
51187	1709	2880069000000	22851	11426	4	0	\N
51188	1709	2880080000000	22991	11484	6	0	\N
51189	1709	3599040000000	972	541	1	0	\N
51191	1709	3599050000000	972	541	2	0	\N
51193	1709	3600025000000	12417	6403	1	0	\N
51194	1709	3600025000000	12418	6403	0	0	\N
51195	1709	3600025000000	12532	6457	5	0	\N
51197	1709	3600026000000	12417	6403	2	0	\N
51199	1709	3600048000000	12532	6457	6	0	\N
51202	1709	4319210000000	1107	612	1	0	\N
51203	1709	4319210000000	1386	761	6	0	\N
51205	1709	4319220000000	1107	612	2	0	\N
51207	1709	4319270000000	1386	761	7	0	\N
51211	1709	4320090000000	23837	11863	2	0	\N
51212	1709	4320092000000	23837	11863	3	0	\N
51214	1709	5039220000000	1710	919	2	0	\N
51215	1709	5039220000000	1750	938	1	0	\N
51216	1709	5039220000000	1792	959	1	0	\N
51217	1709	5039220000000	2402	1256	1	0	\N
51219	1709	5039230000000	1750	938	2	0	\N
51220	1709	5039230000000	1792	959	2	0	\N
51221	1709	5039230000000	2402	1256	2	0	\N
51223	1709	5039240000000	1710	919	3	0	\N
51225	1709	5040037000000	13423	6916	9	0	\N
51227	1709	5040064000000	13423	6916	10	0	\N
51228	1709	5040105000000	23980	11916	29	0	\N
51230	1709	5040105000000	23982	11935	1	0	\N
51231	1709	5040115000000	23982	11935	2	0	\N
51233	1709	5040395000000	23980	11916	30	0	\N
51236	1709	5760058000000	13487	6946	6	0	\N
51239	1709	5760082000000	13487	6946	7	0	\N
51240	1709	5760117000000	24202	12047	3	0	\N
51241	1709	5760117000000	24246	12065	3	0	\N
51242	1709	5760117000000	24523	12193	2	0	\N
51243	1709	5760117000000	25070	12444	7	0	\N
51246	1709	5760128000000	24523	12193	3	0	\N
51247	1709	5760129000000	24202	12047	4	0	\N
51248	1709	5760129000000	24246	12065	4	0	\N
51249	1709	5760142000000	25070	12444	8	0	\N
51250	1709	5760395000000	24201	11917	31	0	\N
51251	1709	5760507000000	24201	11917	32	0	\N
51252	1709	6479250000000	3245	1685	2	0	\N
51253	1709	6479250000000	3247	1675	66	0	\N
51254	1709	6479250000000	3455	1793	0	0	\N
51257	1709	6479270000000	3245	1685	3	0	\N
51258	1709	6480000000000	3247	1675	67	0	\N
51259	1709	6480059999976	14008	7179	5	0	\N
51262	1709	6480073999976	14008	7179	6	0	\N
51265	1709	6480410000000	3456	1676	14	0	\N
51266	1709	6480507000000	24245	11918	6	0	\N
51267	1709	6480513000000	24245	11918	7	0	\N
51268	1709	6481097000000	24517	11919	30	0	\N
51269	1709	7197211000000	3661	1901	0	0	\N
51271	1709	7199231000000	3660	1885	0	0	\N
51272	1709	7200071999976	14998	7641	1	0	\N
51151	1709	1439010000000	529	299	1	0	0
51152	1709	1439020000000	529	299	2	0	0
51159	1709	2159020000000	592	336	1	0	0
51160	1709	2159030000000	592	336	2	0	0
51171	1709	2879030000000	923	514	1	0	0
51190	1709	3599040000000	1058	586	17	0	0
51192	1709	3599210000000	1058	586	18	0	0
51204	1709	4319210000000	1501	821	1	0	0
51206	1709	4319220000000	1501	821	2	0	0
51218	1709	5039220000000	2427	1271	1	0	0
51234	1709	5759230000000	3117	1619	2	0	0
51235	1709	5759250000000	3117	1619	3	0	0
51255	1709	6479250000000	3498	1816	1	0	0
51256	1709	6479251000000	3498	1816	2	0	0
51143	1709	720000000000	10934	5637	2	0	7
51147	1709	720020000000	10934	5637	3	0	7
51153	1709	1440020000000	11921	6133	2	0	7
51154	1709	1440022000000	11921	6133	3	0	7
51162	1709	2160022000000	12382	6386	1	0	7
51173	1709	2880023000000	12396	6394	2	0	7
51174	1709	2880025000000	12396	6394	3	0	7
51196	1709	3600025000000	12534	6459	1	0	7
51198	1709	3600026000000	12534	6459	2	0	7
51208	1709	4320026000000	12662	6532	2	0	7
51224	1709	5040037000000	13421	6916	3	0	7
51226	1709	5040058000000	13421	6916	4	0	7
51237	1709	5760058000000	13488	6946	4	0	7
51238	1709	5760059999976	13488	6946	5	1	7
51261	1709	6480071999976	14659	7468	4	0	7
51145	1709	720009000000	20431	10291	8	0	8
51149	1709	720035000000	20431	10291	9	0	8
51156	1709	1440035000000	20475	10311	2	0	8
51158	1709	1440046000000	20475	10311	3	0	8
51170	1709	2160057000000	20918	10515	3	0	8
51137	1708	21636364500022	21654	10847	10	0	4
51181	1709	2880057000000	23363	11659	2	0	8
51183	1709	2880068000000	23363	11659	3	0	8
51200	1709	3600068000000	23579	11750	4	0	8
51210	1709	4320090000000	23836	11863	6	0	8
51213	1709	4320105000000	23836	11863	7	0	8
51229	1709	5040105000000	23981	11935	3	0	8
51232	1709	5040117000000	23981	11935	4	0	8
51245	1709	5760120000000	25071	12444	4	0	8
51263	1709	6480120000000	25213	12506	4	0	8
51264	1709	6480133000000	25213	12506	5	0	8
51274	1709	7200081999976	14998	7641	2	0	\N
51276	1709	7200120000000	25194	12498	4	0	\N
51277	1709	7200133000000	25496	12626	3	0	\N
51279	1709	7200145000000	25496	12626	4	0	\N
51281	1709	7200232000000	25194	12498	5	0	\N
51282	1709	7200410000000	3456	1676	126	0	\N
51283	1709	7201097000000	24517	11919	31	0	\N
51284	1709	7201520000000	3456	1676	127	0	\N
51285	1709	7201660000000	3499	1677	14	0	\N
51292	1709	7921660000000	3499	1677	62	0	\N
51297	1709	8640188000000	26108	12904	2	0	\N
51299	1709	8640199000000	26108	12904	3	0	\N
51301	1709	9357241000000	4340	2250	1	0	\N
51303	1709	9357251000000	4340	2250	2	0	\N
51307	1709	9360199000000	26157	12929	5	0	\N
51309	1709	9360213000000	26157	12929	6	0	\N
51311	1709	10077251000000	4958	2570	1	0	\N
51312	1709	10077251000000	4979	2582	4	0	\N
51314	1709	10077261000000	4958	2570	2	0	\N
51316	1709	10077291000000	4979	2582	5	0	\N
51317	1709	10080115999976	15689	7981	5	0	\N
51318	1709	10080115999976	15690	7981	7	0	\N
51319	1709	10080115999976	16129	8113	35	0	\N
51322	1709	10080138999976	15689	7981	6	0	\N
51323	1709	10080138999976	16712	8492	1	0	\N
51324	1709	10080138999976	16716	8492	1	0	\N
51325	1709	10080138999976	16717	8492	1	0	\N
51326	1709	10080140999976	15690	7981	8	0	\N
51327	1709	10080159999976	16129	8113	36	0	\N
51328	1709	10080232000000	26570	13147	7	0	\N
51329	1709	10080232000000	26647	13182	4	0	\N
51330	1709	10080232000000	26899	13302	11	0	\N
51331	1709	10080232000000	27090	13393	3	0	\N
51333	1709	10080244000000	27090	13393	4	0	\N
51335	1709	10080245000000	26647	13182	5	0	\N
51336	1709	10080257000000	26570	13147	8	0	\N
51337	1709	10080279000000	26899	13302	12	0	\N
51338	1709	10797271000000	5067	2629	1	0	\N
51339	1709	10797271000000	5488	2856	0	0	\N
51341	1709	10797281000000	5067	2629	2	0	\N
51344	1709	10800138999976	16712	8492	4	0	\N
51345	1709	10800138999976	16716	8492	4	0	\N
51346	1709	10800138999976	16717	8492	4	0	\N
51347	1709	10800140999976	16712	8492	5	0	\N
51348	1709	10800140999976	16716	8492	5	0	\N
51349	1709	10800140999976	16717	8492	5	0	\N
51351	1709	10800244000000	27271	13479	3	0	\N
51352	1709	10800244000000	27375	13536	15	0	\N
51354	1709	10800256000000	27271	13479	4	0	\N
51356	1709	10800304000000	27375	13536	16	0	\N
51357	1709	10800378000000	28823	14162	14	0	\N
51364	1709	11520377999992	28823	14162	15	0	\N
51367	1709	12240177999976	17130	8681	3	0	\N
51368	1709	12240177999976	17292	8758	2	0	\N
51369	1709	12240177999976	17293	8758	0	0	\N
51370	1709	12240177999976	17676	8935	2	0	\N
51371	1709	12240177999976	17678	8915	6	0	\N
51373	1709	12240188999976	17292	8758	3	0	\N
51374	1709	12240188999976	17676	8935	3	0	\N
51375	1709	12240189999976	17130	8681	4	0	\N
51377	1709	12240228999976	17678	8915	7	0	\N
51378	1709	12240282000000	29196	14392	3	0	\N
51379	1709	12240282000000	29615	14606	3	0	\N
51382	1709	12240294000000	29615	14606	4	0	\N
51383	1709	12240303000000	29196	14392	4	0	\N
51384	1709	12240377999992	29193	14163	0	0	\N
51385	1709	12240644000000	29930	14727	91	0	\N
51386	1709	12957371000000	7279	3758	0	0	\N
51391	1709	12960228999976	17703	8916	1	0	\N
51392	1709	12960238999976	17703	8916	2	0	\N
51395	1709	12960458999976	18135	8917	40	0	\N
51396	1709	12960644000000	29930	14727	96	0	\N
51397	1709	12960647670962	29930	14727	100	0	\N
51398	1709	13677391000000	7349	3799	8	0	\N
51401	1709	13677471000000	7349	3799	9	0	\N
51406	1709	13680458999976	18135	8917	112	0	\N
51407	1709	13680529999976	18135	8917	113	0	\N
51293	1709	8637231000000	3880	2015	1	0	4
51294	1709	8637241000000	3880	2015	2	0	4
51302	1709	9357241000000	4722	2443	1	0	4
51304	1709	9357251000000	4722	2443	2	0	4
51313	1709	10077251000000	5066	2628	2	0	4
51340	1709	10797271000000	6411	3323	2	0	4
51342	1709	10797291000000	6411	3323	3	0	4
51358	1709	11517291000000	6860	3548	2	0	4
51359	1709	11517311000000	6860	3548	3	0	4
51365	1709	12237311000000	7123	3680	6	0	4
51387	1709	12957371000000	7281	3763	2	0	4
51388	1709	12957391000000	7281	3763	3	0	4
51399	1709	13677391000000	7401	3824	1	0	4
51400	1709	13677401000000	7401	3824	2	0	4
51273	1709	7200071999976	15091	7689	2	0	7
51275	1709	7200082999976	15091	7689	3	0	7
51288	1709	7920082999976	15287	7788	2	0	7
51289	1709	7920093999976	15287	7788	3	0	7
51295	1709	8640093999976	15549	7915	2	0	7
51305	1709	9360104999976	15616	7949	2	0	7
51306	1709	9360115999976	15616	7949	3	0	7
51320	1709	10080115999976	16130	8201	4	0	7
51321	1709	10080128999976	16130	8201	5	0	7
51343	1709	10800128999976	16907	8573	10	0	7
51360	1709	11520165999976	16939	8586	3	0	7
51361	1709	11520177999976	16939	8586	4	0	7
51372	1709	12240177999976	17702	8948	3	0	7
51376	1709	12240198999976	17702	8948	4	0	7
51390	1709	12960209999976	18134	9144	3	0	7
51402	1709	13680209999976	18543	9343	3	0	7
51403	1709	13680221999976	18543	9343	4	0	7
51278	1709	7200133000000	25916	12807	4	0	8
51280	1709	7200155000000	25916	12807	5	0	8
51291	1709	7920188000000	25985	12841	7	0	8
51298	1709	8640188000000	26123	12914	2	0	8
51300	1709	8640199000000	26123	12914	3	0	8
51308	1709	9360199000000	26302	13010	6	0	8
51310	1709	9360232000000	26302	13010	7	0	8
51334	1709	10080244000000	27212	13459	4	0	8
51353	1709	10800244000000	28234	13959	3	0	8
51355	1709	10800256000000	28234	13959	4	0	8
51362	1709	11520256000000	28826	14218	8	0	8
51380	1709	12240282000000	29616	14606	1	0	8
51381	1709	12240283000000	29616	14606	2	0	8
51393	1709	12960283000000	29929	14743	24	0	8
51394	1709	12960316000000	29929	14743	25	0	8
51404	1709	13680316000000	30008	14777	9	0	8
51410	1709	14400221999976	18704	9422	2	0	\N
51412	1709	14400232999976	18704	9422	3	0	\N
51413	1709	14400334000000	30087	14814	9	0	\N
51414	1709	14400352000000	30087	14814	10	0	\N
51415	1709	15117421000000	7525	3896	1	0	\N
51417	1709	15117431000000	7525	3896	2	0	\N
51419	1709	15837451000000	7904	4094	2	0	\N
51420	1709	15837451000000	8582	4449	1	0	\N
51422	1709	15837461000000	8582	4449	2	0	\N
51423	1709	15837462000000	7904	4094	3	0	\N
51425	1709	15838601000000	8958	4569	67	0	\N
51426	1709	16557471000000	8794	4558	4	0	\N
51428	1709	16557511000000	8794	4558	5	0	\N
51430	1709	16558601000000	8958	4569	126	0	\N
51431	1709	16559940930000	9197	4570	67	0	\N
51432	1709	17277511000000	9196	4766	5	0	\N
51433	1709	17277552000000	9196	4766	6	0	\N
51434	1709	17279940930000	9197	4570	125	0	\N
51435	1709	17280451930000	9197	4570	127	0	\N
51436	1710	719000000000	194	115	1	0	\N
51438	1710	719010000000	194	115	2	0	\N
51440	1710	1438930000000	1809	968	1	0	\N
51442	1710	1438940000000	1809	968	2	0	\N
51444	1710	1439030000000	306	176	2	0	\N
51445	1710	1439041000000	306	176	3	0	\N
51452	1710	3113862664140	20261	10205	4	0	\N
51453	1710	3113862664140	20454	10300	6	0	\N
51456	1710	3113875664140	20261	10205	5	0	\N
51457	1710	3113886664140	20454	10300	7	0	\N
51458	1710	3214345473290	10239	5298	2	0	\N
51460	1710	3214365473290	10239	5298	3	0	\N
51464	1710	3833874664140	20717	10417	3	0	\N
51466	1710	3833886664140	20717	10417	4	0	\N
51472	1710	4553896664140	21609	10829	3	0	\N
51473	1710	4553896664140	22250	11135	6	0	\N
51475	1710	4553908664140	21609	10829	4	0	\N
51477	1710	4553920664140	22250	11135	7	0	\N
51480	1710	5039010000000	2675	1406	4	0	\N
51482	1710	5039050000000	2675	1406	5	0	\N
51486	1710	5374466473290	10857	5605	2	0	\N
51488	1710	5374486473290	10857	5605	3	0	\N
51490	1710	5759050000000	2955	1537	1	0	\N
51492	1710	5759060000000	2955	1537	2	0	\N
51496	1710	6094486473290	11353	5830	1	0	\N
51498	1710	6094487473290	11353	5830	2	0	\N
51502	1710	6480570000000	4117	2039	113	0	\N
51505	1710	6814508473290	11515	5914	2	0	\N
51506	1710	6814508473290	11706	6020	1	0	\N
51507	1710	6814508473290	11887	6108	1	0	\N
51509	1710	6814509473290	11706	6020	2	0	\N
51510	1710	6814509473290	11887	6108	2	0	\N
51512	1710	6814519473290	11515	5914	3	0	\N
51515	1710	7200570000000	4117	2039	126	0	\N
51516	1710	7200690000000	4117	2039	127	0	\N
51517	1710	7433948664140	22691	11345	8	0	\N
51518	1710	7433948664140	22823	11400	1	0	\N
51519	1710	7433948664140	22824	11402	0	0	\N
51521	1710	7433958664140	22823	11400	2	0	\N
51523	1710	7434001664140	22691	11345	9	0	\N
51526	1710	7919090000000	4588	2372	5	0	\N
51529	1710	7919230000000	4588	2372	6	0	\N
51530	1710	7920690000000	4180	2040	74	0	\N
51531	1710	7921529000000	4180	2040	75	0	\N
51532	1710	7922349000000	4276	2041	37	0	\N
51539	1710	8642349000000	4276	2041	80	0	\N
51540	1710	8642742000000	4276	2041	81	0	\N
51543	1710	8974512473290	12361	6374	1	0	\N
51441	1710	1438930000000	1820	975	1	0	1
51443	1710	1438940000000	1820	975	2	0	1
51446	1710	2158940000000	1857	990	1	0	1
51447	1710	2158950000000	1857	990	2	0	1
51450	1710	2878950000000	1891	1006	1	0	1
51462	1710	3598960000000	2251	1184	3	0	1
51463	1710	3598990000000	2251	1184	4	0	1
51470	1710	4318990000000	2605	1371	2	0	1
51471	1710	4319010000000	2605	1371	3	0	1
51481	1710	5039010000000	2767	1446	4	0	1
51491	1710	5759050000000	3768	1954	2	0	1
51493	1710	5759070000000	3768	1954	3	0	1
51500	1710	6479070000000	3905	2028	1	0	1
51501	1710	6479080000000	3905	2028	2	0	1
51514	1710	7199090000000	4530	2343	2	0	1
51527	1710	7919090000000	4789	2476	2	0	1
51528	1710	7919110000000	4789	2476	3	0	1
51537	1710	8639110000000	4816	2495	2	0	1
51538	1710	8639220000000	4816	2495	3	0	1
51416	1709	15117421000000	7733	4007	3	0	4
51418	1709	15117451000000	7733	4007	4	0	4
51421	1709	15837451000000	8761	4546	2	0	4
51424	1709	15837471000000	8761	4546	3	0	4
51427	1709	16557471000000	8957	4645	4	0	4
51448	1710	2494335473290	10226	5293	1	0	5
51449	1710	2494345473290	10226	5293	2	0	5
51459	1710	3214345473290	10252	5303	7	0	5
51461	1710	3214415473290	10252	5303	8	0	5
51469	1710	3934445473290	10431	5396	4	0	5
51478	1710	4654445473290	10627	5488	3	0	5
51479	1710	4654466473290	10627	5488	4	0	5
51487	1710	5374466473290	11222	5766	2	0	5
51489	1710	5374486473290	11222	5766	3	0	5
51499	1710	6094508473290	11407	5859	5	0	5
51508	1710	6814508473290	11918	6131	1	0	5
51511	1710	6814509473290	11918	6131	2	0	5
51524	1710	7534509473290	12016	6184	2	0	5
51525	1710	7534511473290	12016	6184	3	0	5
51536	1710	8254512473290	12204	6287	2	0	5
51544	1710	8974512473290	12658	6529	3	0	5
51411	1709	14400221999976	19412	9783	0	0	7
51454	1710	3113862664140	20544	10343	3	0	10
51465	1710	3833874664140	20792	10449	4	0	10
51467	1710	3833896664140	20792	10449	5	0	10
51474	1710	4553896664140	22276	11151	3	0	10
51476	1710	4553908664140	22276	11151	4	0	10
51484	1710	5273908664140	22348	11186	4	0	10
51494	1710	5993921664140	22545	11279	5	0	10
51495	1710	5993935664140	22545	11279	6	0	10
51503	1710	6713935664140	22550	11282	4	0	10
51504	1710	6713948664140	22550	11282	5	0	10
51520	1710	7433948664140	23053	11511	7	0	10
51533	1710	8153973664140	23451	11694	2	0	10
51534	1710	8153984664140	23451	11694	3	0	10
51541	1710	8873984664140	23898	11895	3	0	10
51542	1710	8873996664140	23898	11895	4	0	10
51545	1710	8974513473290	12361	6374	2	0	\N
51547	1710	9359220000000	4869	2522	1	0	\N
51549	1710	9359230000000	4869	2522	2	0	\N
51551	1710	9593996664140	24274	12077	4	0	\N
51552	1710	9593996664140	24466	12168	3	0	\N
51554	1710	9594008664140	24466	12168	4	0	\N
51556	1710	9594058664140	24274	12077	5	0	\N
51557	1710	9694524473290	12722	6561	4	0	\N
51560	1710	9694546473290	12722	6561	5	0	\N
51569	1710	11034010664140	24954	12384	3	0	\N
51571	1710	11034022664140	24954	12384	4	0	\N
51583	1710	12474034664140	25394	12586	7	0	\N
51584	1710	12474034664140	25730	12731	3	0	\N
51585	1710	12474034664140	25812	12763	3	0	\N
51586	1710	12474034664140	25882	12792	2	0	\N
51588	1710	12474045664140	25882	12792	3	0	\N
51589	1710	12474046664140	25730	12731	4	0	\N
51590	1710	12474046664140	25812	12763	4	0	\N
51592	1710	12474059664140	25394	12586	8	0	\N
51593	1710	12474546473290	13157	6779	4	0	\N
51595	1710	12474568473290	13157	6779	5	0	\N
51601	1710	13194568473290	14367	7332	3	0	\N
51602	1710	13194568473290	14717	7493	2	0	\N
51603	1710	13194568473290	14844	7565	2	0	\N
51604	1710	13194568473290	15027	7657	3	0	\N
51607	1710	13194579473290	14717	7493	3	0	\N
51608	1710	13194579473290	14844	7565	3	0	\N
51609	1710	13194580473290	14367	7332	4	0	\N
51610	1710	13194580473290	15027	7657	4	0	\N
51613	1710	13914058664140	26529	13124	3	0	\N
51615	1710	13914070664140	26529	13124	4	0	\N
51619	1710	13914759473290	15559	7843	16	0	\N
51626	1710	14634589473290	15778	8026	1	0	\N
51628	1710	14634599473290	15778	8026	2	0	\N
51630	1710	14634759473290	15559	7843	126	0	\N
51631	1710	14635813473290	15559	7843	127	0	\N
51632	1710	14635973473290	15717	7844	16	0	\N
51633	1710	15119370000000	7476	3867	2	0	\N
51636	1710	15119390000000	7476	3867	3	0	\N
51637	1710	15354084664140	27075	13385	3	0	\N
51638	1710	15354084664140	27097	13238	0	0	\N
51639	1710	15354084664140	27098	13252	0	0	\N
51640	1710	15354084664140	27099	13266	0	0	\N
51642	1710	15354096664140	27075	13385	4	0	\N
51644	1710	15354610473290	15890	8079	4	0	\N
51646	1710	15354623473290	15890	8079	5	0	\N
51648	1710	15355973473290	15717	7844	126	0	\N
51649	1710	15356811473290	15717	7844	127	0	\N
51656	1710	16794108664140	27557	13622	2	0	\N
51658	1710	16794110664140	27557	13622	3	0	\N
51662	1710	17514119664140	28450	14060	2	0	\N
51664	1710	17514130664140	28450	14060	3	0	\N
51666	1710	17514485414140	29560	14550	46	0	\N
51671	1710	18234485414140	29560	14550	110	0	\N
51672	1710	18234548414140	29560	14550	111	0	\N
51675	1710	18235087414140	29603	14551	62	0	\N
51676	1710	18954146414140	30032	14786	19	0	\N
51677	1710	18954183414140	30032	14786	20	0	\N
51680	1710	18955087414140	29603	14551	123	0	\N
51561	1710	10079230000000	5791	3004	1	0	1
51562	1710	10079240000000	5791	3004	2	0	1
51567	1710	10799240000000	6085	3159	1	0	1
51568	1710	10799250000000	6085	3159	2	0	1
51575	1710	11519250000000	6514	3377	4	0	1
51581	1710	12239290000000	6747	3492	2	0	1
51582	1710	12239310000000	6747	3492	3	0	1
51597	1710	12959310000000	6766	3502	1	0	1
51598	1710	12959320000000	6766	3502	2	0	1
51611	1710	13679320000000	6984	3604	4	0	1
51620	1710	14399360000000	7208	3726	1	0	1
51621	1710	14399370000000	7208	3726	2	0	1
51634	1710	15119370000000	7592	3926	1	0	1
51635	1710	15119380000000	7592	3926	2	0	1
51651	1710	15839390000000	7796	4042	2	0	1
51622	1710	14553317340144	9925	5151	2	0	2
51623	1710	14553337340144	9925	5151	3	0	2
51546	1710	8974524473290	12658	6529	4	0	5
51558	1710	9694524473290	12819	6611	1	0	5
51565	1710	10414534473290	12958	6681	2	0	5
51566	1710	10414545473290	12958	6681	3	0	5
51573	1710	11034445473290	13045	6726	8	0	6
51574	1710	11034507473290	13045	6726	9	0	6
51579	1710	11754507473290	13127	6767	12	0	6
51594	1710	12474546473290	13174	6787	4	0	6
51596	1710	12474568473290	13174	6787	5	0	6
51605	1710	13194568473290	15076	7679	1	0	6
51606	1710	13194578473290	15076	7679	2	0	6
51618	1710	13914589473290	15211	7750	3	0	6
51627	1710	14634589473290	15801	8042	3	0	6
51629	1710	14634610473290	15801	8042	4	0	6
51645	1710	15354610473290	15982	8124	6	0	6
51647	1710	15354634473290	15982	8124	7	0	6
51655	1710	16074635473290	17267	8746	2	0	6
51660	1710	16794635473290	17428	8828	2	0	6
51661	1710	16794646473290	17428	8828	3	0	6
51667	1710	17514646473290	17502	8861	3	0	6
51668	1710	17514658473290	17502	8861	4	0	6
51674	1710	18234670473290	17549	8886	4	0	6
51678	1710	18954670473290	17607	8905	10	0	6
51679	1710	18954716473290	17607	8905	11	0	6
51553	1710	9593996664140	24660	12249	3	0	10
51563	1710	10314008664140	24809	12320	2	0	10
51564	1710	10314010664140	24809	12320	3	0	10
51570	1710	11034010664140	25051	12430	3	0	10
51572	1710	11034022664140	25051	12430	4	0	10
51577	1710	11754022664140	25137	12472	3	0	10
51587	1710	12474034664140	26010	12856	3	0	10
51591	1710	12474046664140	26010	12856	4	0	10
51599	1710	13194046664140	26264	12987	3	0	10
51600	1710	13194058664140	26264	12987	4	0	10
51614	1710	13914058664140	26590	13155	4	0	10
51624	1710	14634071664140	26655	13185	4	0	10
51625	1710	14634084664140	26655	13185	5	0	10
51641	1710	15354084664140	27275	13481	3	0	10
51643	1710	15354096664140	27275	13481	4	0	10
51653	1710	16074108664140	27437	13563	4	0	10
51657	1710	16794108664140	28148	13916	2	0	10
51659	1710	16794119664140	28148	13916	3	0	10
51663	1710	17514119664140	29436	14512	4	0	10
51665	1710	17514139414140	29436	14512	5	0	10
51670	1710	18234146414140	29944	14748	8	0	10
51681	1710	18955147414140	29603	14551	124	0	\N
51682	1710	19674716473290	17693	8943	4	0	\N
51684	1710	19674738473290	17693	8943	5	0	\N
51688	1710	21114784473290	18545	9344	3	0	\N
51689	1710	21114784473290	18608	9376	2	0	\N
51691	1710	21114795473290	18608	9376	3	0	\N
51692	1710	21114796473290	18545	9344	4	0	\N
51699	1710	23274832473290	20220	10182	10	0	\N
51700	1710	23274869473290	20220	10182	11	0	\N
51701	1711	719000000000	203	120	1	0	\N
51703	1711	719010000000	203	120	2	0	\N
51708	1711	1964355000000	9884	5071	0	0	\N
51712	1711	2684385000000	9881	5124	2	0	\N
51714	1711	2684405000000	9881	5124	3	0	\N
51716	1711	2879040000000	1096	606	4	0	\N
51719	1711	2879080000000	1096	606	5	0	\N
51720	1711	3306324000000	20251	10200	7	0	\N
51721	1711	3306324000000	20447	10298	3	0	\N
51722	1711	3306324000000	20528	10334	4	0	\N
51724	1711	3306336000000	20447	10298	4	0	\N
51725	1711	3306347000000	20528	10334	5	0	\N
51727	1711	3306349000000	20251	10200	8	0	\N
51728	1711	3404454999999	11536	5928	7	0	\N
51729	1711	3404455000000	11026	5676	10	0	\N
51730	1711	3404455000000	11094	5709	2	0	\N
51731	1711	3404455000000	11537	5928	7	0	\N
51734	1711	3404475000000	11094	5709	3	0	\N
51735	1711	3404498000000	11537	5928	8	0	\N
51736	1711	3404555000000	11026	5676	11	0	\N
51737	1711	3599050000000	1387	761	6	0	\N
51738	1711	3599050000000	1554	846	3	0	\N
51739	1711	3599050000000	1583	861	1	0	\N
51741	1711	3599060000000	1583	861	2	0	\N
51743	1711	3599080000000	1554	846	4	0	\N
51744	1711	3599110000000	1387	761	7	0	\N
51747	1711	4026742000000	20930	10524	6	0	\N
51751	1711	4319060000000	1773	952	1	0	\N
51753	1711	4319070000000	1773	952	2	0	\N
51755	1711	4746742000000	20930	10524	9	0	\N
51757	1711	4746744000000	20930	10524	10	0	\N
51763	1711	5466744000000	21113	10603	3	0	\N
51765	1711	5466756000000	21113	10603	4	0	\N
51775	1711	6479090000000	2964	1540	1	0	\N
51777	1711	6479100000000	2964	1540	2	0	\N
51782	1711	7199100000000	3286	1708	8	0	\N
51785	1711	7199180000000	3286	1708	9	0	\N
51788	1711	7724460000000	13019	6712	3	0	\N
51791	1711	7724481000000	13019	6712	4	0	\N
51797	1711	8639140000000	3690	1916	1	0	\N
51798	1711	8639140000000	3816	1978	1	0	\N
51800	1711	8639150000000	3690	1916	2	0	\N
51801	1711	8639150000000	3816	1978	2	0	\N
51803	1711	9066840000000	23048	11508	7	0	\N
51806	1711	9066865000000	23048	11508	8	0	\N
51815	1711	10079270000000	4549	2355	1	0	\N
51705	1711	1439010000000	756	423	2	0	0
51706	1711	1439030000000	756	423	3	0	0
51710	1711	2159030000000	764	425	1	0	0
51711	1711	2159040000000	764	425	2	0	0
51717	1711	2879040000000	1370	751	1	0	0
51740	1711	3599050000000	1671	898	1	0	0
51742	1711	3599060000000	1671	898	2	0	0
51752	1711	4319060000000	2474	1295	1	0	0
51754	1711	4319070000000	2474	1295	2	0	0
51761	1711	5039070000000	2545	1340	1	0	0
51769	1711	5759080000000	2919	1521	1	0	0
51770	1711	5759090000000	2919	1521	2	0	0
51776	1711	6479090000000	3129	1628	1	0	0
51778	1711	6479100000000	3129	1628	2	0	0
51784	1711	7199140000000	3332	1729	5	0	0
51792	1711	7919140000000	3588	1864	0	0	0
51799	1711	8639140000000	4020	2085	2	0	0
51802	1711	8639160000000	4020	2085	3	0	0
51809	1711	9359160000000	4103	2133	2	0	0
51816	1711	10079270000000	4592	2374	1	0	0
51707	1711	1964355000000	9819	5089	12	0	9
51709	1711	1964385000000	9819	5089	13	0	9
51713	1711	2684385000000	10845	5597	7	0	9
51715	1711	2684455000000	10845	5597	8	0	9
51733	1711	3404456000000	11617	5978	2	0	9
51749	1711	4124456000000	12241	6303	1	0	9
51750	1711	4124457000000	12241	6303	2	0	9
51759	1711	4844457000000	12300	6335	1	0	9
51767	1711	5564458000000	12339	6360	1	0	9
51768	1711	5564459000000	12339	6360	2	0	9
51773	1711	6284459000000	12405	6399	1	0	9
51774	1711	6284460000000	12405	6399	2	0	9
51781	1711	7004460000000	12993	6699	0	0	9
51790	1711	7724473000000	13120	6762	5	0	9
51795	1711	8444473000000	13124	6766	3	0	9
51796	1711	8444485000000	13124	6766	4	0	9
51807	1711	9164485000000	13309	6858	3	0	9
51808	1711	9164497000000	13309	6858	4	0	9
51814	1711	9884521000000	13420	6915	7	0	9
51683	1710	19674716473290	18288	9215	7	0	6
51685	1710	19674759473290	18288	9215	8	0	6
51686	1710	20394759473290	18522	9329	7	0	6
51690	1710	21114784473290	18657	9401	6	0	6
51693	1710	21114808473290	18657	9401	7	0	6
51694	1710	21834808473290	19124	9647	2	0	6
51695	1710	21834819473290	19124	9647	3	0	6
51696	1710	21834829473290	19152	9662	1	0	6
51698	1710	22554832473290	19152	9662	6	0	6
51723	1711	3306324000000	20540	10339	5	0	13
51726	1711	3306347000000	20540	10339	6	0	13
51745	1711	4026347000000	20633	10381	11	0	13
51746	1711	4026700000000	20633	10381	12	0	13
51756	1711	4746742000000	20931	10524	9	0	13
51758	1711	4746744000000	20931	10524	10	0	13
51764	1711	5466744000000	22316	11171	8	0	13
51766	1711	5466779000000	22316	11171	9	0	13
51772	1711	6186791000000	22512	11261	4	0	13
51779	1711	6906791000000	22822	11414	3	0	13
51780	1711	6906803000000	22822	11414	4	0	13
51786	1711	7626803000000	22897	11445	4	0	13
51787	1711	7626816000000	22897	11445	5	0	13
51794	1711	8346840000000	22995	11487	7	0	13
51804	1711	9066840000000	23171	11569	3	0	13
51805	1711	9066852000000	23171	11569	4	0	13
51811	1711	9786852000000	23806	11850	6	0	13
51812	1711	9786876000000	23806	11850	7	0	13
51817	1711	10079280000000	4549	2355	2	0	\N
51821	1711	10604521000000	13594	6991	4	0	\N
51822	1711	10604521000000	13600	6992	3	0	\N
51823	1711	10604521000000	13667	7023	3	0	\N
51824	1711	10604521000000	13668	7023	1	0	\N
51825	1711	10604521000000	13690	7034	2	0	\N
51826	1711	10604521000000	13925	7138	4	0	\N
51827	1711	10604521000000	13926	7138	1	0	\N
51828	1711	10604521000000	14141	7222	6	0	\N
51829	1711	10604521000000	14273	7286	8	0	\N
51830	1711	10604521000000	14274	7286	2	0	\N
51832	1711	10604522000000	13668	7023	2	0	\N
51833	1711	10604531000000	13926	7138	2	0	\N
51834	1711	10604532000000	13690	7034	3	0	\N
51835	1711	10604533000000	13600	6992	4	0	\N
51836	1711	10604533000000	13667	7023	4	0	\N
51837	1711	10604534000000	13594	6991	5	0	\N
51838	1711	10604534000000	13925	7138	5	0	\N
51840	1711	10604541000000	14274	7286	3	0	\N
51841	1711	10604545000000	14141	7222	7	0	\N
51842	1711	10604547000000	14273	7286	9	0	\N
51844	1711	10799280000000	4830	2502	2	0	\N
51846	1711	10799300000000	4830	2502	3	0	\N
51849	1711	11324534000000	14446	7373	3	0	\N
51850	1711	11324534000000	14589	7439	3	0	\N
51852	1711	11324537000000	14446	7373	4	0	\N
51854	1711	11324546000000	14589	7439	4	0	\N
51859	1711	12044545000000	14934	7609	5	0	\N
51862	1711	12044568000000	14934	7609	6	0	\N
51863	1711	12239410000000	5037	2613	2	0	\N
51865	1711	12239430000000	5037	2613	3	0	\N
51867	1711	12666938000000	24031	11959	3	0	\N
51868	1711	12666938000000	24255	12069	0	0	\N
51870	1711	12666950000000	24031	11959	4	0	\N
51872	1711	12764555000000	15119	7706	2	0	\N
51873	1711	12764555000000	15444	7864	2	0	\N
51875	1711	12764566000000	15119	7706	3	0	\N
51876	1711	12764566000000	15444	7864	3	0	\N
51880	1711	12959430000000	5039	2614	2	0	\N
51881	1711	12959450000000	5039	2614	3	0	\N
51882	1711	13386951000000	24926	12375	7	0	\N
51885	1711	13386985000000	24926	12375	8	0	\N
51890	1711	14106964000000	25301	12552	3	0	\N
51891	1711	14106964000000	25349	12570	4	0	\N
51893	1711	14106976000000	25301	12552	4	0	\N
51894	1711	14106977000000	25349	12570	5	0	\N
51896	1711	14204599000000	15603	7943	2	0	\N
51898	1711	14204599000000	15739	8004	2	0	\N
51899	1711	14204610000000	15603	7943	3	0	\N
51900	1711	14204709000000	15739	8004	3	0	\N
51902	1711	14399210000000	5551	2887	0	0	\N
51903	1711	14399210000000	5808	3014	1	0	\N
51904	1711	14399210000000	5827	3023	1	0	\N
51905	1711	14399210000000	6086	3159	1	0	\N
51907	1711	14399220000000	5808	3014	2	0	\N
51908	1711	14399220000000	5827	3023	2	0	\N
51909	1711	14399220000000	6086	3159	2	0	\N
51915	1711	14925843000000	16889	8460	103	0	\N
51916	1711	15119230000000	7212	3728	1	0	\N
51917	1711	15119230000000	7353	3800	8	0	\N
51918	1711	15119230000000	7361	3803	9	0	\N
51919	1711	15119230000000	7881	4083	1	0	\N
51920	1711	15119230000000	7938	4114	1	0	\N
51921	1711	15119230000000	8066	4180	2	0	\N
51922	1711	15119230000000	8099	4198	2	0	\N
51924	1711	15119240000000	7212	3728	2	0	\N
51925	1711	15119240000000	7881	4083	2	0	\N
51926	1711	15119240000000	7938	4114	2	0	\N
51928	1711	15119241000000	8066	4180	3	0	\N
51929	1711	15119241000000	8099	4198	3	0	\N
51930	1711	15119310000000	7353	3800	9	0	\N
51931	1711	15119320000000	7361	3803	10	0	\N
51932	1711	15547000000000	26172	12939	0	0	\N
51933	1711	15547000000000	26220	12963	4	0	\N
51935	1711	15547013000000	26220	12963	5	0	\N
51937	1711	15644723000000	16888	8566	3	0	\N
51940	1711	15644735000000	16888	8566	4	0	\N
51941	1711	15645843000000	16889	8460	126	0	\N
51942	1711	15646063000000	16889	8460	127	0	\N
51943	1711	15646724000000	16947	8461	103	0	\N
51944	1711	15839240000000	8377	4342	4	0	\N
51945	1711	15839240000000	8645	4479	0	0	\N
51948	1711	15839469000000	8377	4342	5	0	\N
51951	1711	16364734000000	17159	8697	7	0	\N
51952	1711	16364734000000	17256	8740	3	0	\N
51845	1711	10799300000000	4829	2502	3	0	0
51855	1711	11519300000000	4854	2515	2	0	0
51856	1711	11519410000000	4854	2515	3	0	0
51864	1711	12239410000000	5038	2613	2	0	0
51866	1711	12239430000000	5038	2613	3	0	0
51879	1711	12959200000000	5040	2614	3	0	0
51888	1711	13679200000000	5168	2683	1	0	0
51889	1711	13679210000000	5168	2683	2	0	0
51906	1711	14399210000000	6965	3593	2	0	0
51910	1711	14399230000000	6965	3593	3	0	0
51927	1711	15119240000000	8101	4198	2	0	0
51946	1711	15839240000000	8646	4479	6	0	0
51947	1711	15839300000000	8646	4479	7	0	0
51831	1711	10604521000000	14442	7370	4	0	9
51851	1711	11324534000000	14782	7527	2	0	9
51853	1711	11324545000000	14782	7527	3	0	9
51860	1711	12044545000000	15070	7674	1	0	9
51861	1711	12044555000000	15070	7674	2	0	9
51874	1711	12764555000000	15524	7900	6	0	9
51886	1711	13484589000000	15552	7917	1	0	9
51887	1711	13484599000000	15552	7917	2	0	9
51897	1711	14204599000000	15738	8004	3	0	9
51901	1711	14204710000000	15738	8004	4	0	9
51913	1711	14924710000000	15765	8018	4	0	9
51938	1711	15644723000000	16944	8589	2	0	9
51939	1711	15644734000000	16944	8589	3	0	9
51819	1711	10506876000000	23841	11866	7	0	13
51820	1711	10506901000000	23841	11866	8	0	13
51848	1711	11226926000000	23843	11868	8	0	13
51857	1711	11946926000000	23989	11939	3	0	13
51858	1711	11946938000000	23989	11939	4	0	13
51869	1711	12666938000000	24670	12253	4	0	13
51871	1711	12666951000000	24670	12253	5	0	13
51884	1711	13386964000000	25167	12485	5	0	13
51892	1711	14106964000000	25602	12671	6	0	13
51895	1711	14106988000000	25602	12671	7	0	13
51911	1711	14826988000000	25852	12782	3	0	13
51912	1711	14827000000000	25852	12782	4	0	13
51936	1711	15547013000000	26278	12997	5	0	13
51949	1711	16267013000000	26387	13051	3	0	13
51950	1711	16267025000000	26387	13051	4	0	13
51953	1711	16364734000000	17457	8841	36	0	\N
51955	1711	16364746000000	17256	8740	4	0	\N
51956	1711	16364858000000	17159	8697	8	0	\N
51958	1711	16365022000000	17457	8841	37	0	\N
51959	1711	16366724000000	16947	8461	126	0	\N
51960	1711	16366746000000	16947	8461	127	0	\N
51969	1711	17707049000000	26623	13170	3	0	\N
51971	1711	17707061000000	26623	13170	4	0	\N
51973	1711	17804892000000	18172	9163	6	0	\N
51975	1711	17804916000000	18172	9163	7	0	\N
51985	1711	19147073000000	28205	13945	2	0	\N
51986	1711	19147073000000	28459	14064	2	0	\N
51987	1711	19147073000000	28562	14109	9	0	\N
51988	1711	19147073000000	28914	14262	1	0	\N
51989	1711	19147073000000	28915	14262	2	0	\N
51990	1711	19147073000000	28947	14275	10	0	\N
51991	1711	19147073000000	28948	14275	0	0	\N
51993	1711	19147074000000	28914	14262	2	0	\N
51994	1711	19147075000000	28915	14262	3	0	\N
51995	1711	19147084000000	28205	13945	3	0	\N
51996	1711	19147084000000	28459	14064	3	0	\N
51998	1711	19147109000000	28562	14109	10	0	\N
51999	1711	19147110000000	28947	14275	11	0	\N
52002	1711	19439395000000	9883	5063	0	0	\N
52003	1711	19439400000000	9261	4802	8	0	\N
52004	1711	19439400000000	9392	4873	4	0	\N
52005	1711	19439400000000	9877	5046	0	0	\N
52006	1711	19439400000000	9880	5055	0	0	\N
52007	1711	19439440000000	9392	4873	5	0	\N
52008	1711	19439480000000	9261	4802	9	0	\N
52010	1711	19867098000000	29077	14335	4	0	\N
52012	1711	19867111000000	29077	14335	5	0	\N
52013	1711	19965339000000	19571	9858	4	0	\N
52016	1711	19965361000000	19571	9858	5	0	\N
52017	1711	20587111000000	29190	14391	4	0	\N
52018	1711	20587111000000	29567	14578	6	0	\N
52020	1711	20587124000000	29190	14391	5	0	\N
52022	1711	20587135000000	29567	14578	7	0	\N
52027	1711	66000004950000	11536	5928	8	1	\N
52028	1714	719000000000	254	148	0	0	\N
52029	1714	719000000000	272	158	1	0	\N
52031	1714	719010000000	272	158	2	0	\N
52043	1714	4605466171760	21138	10614	4	0	\N
52046	1714	4605488171760	21138	10614	5	0	\N
52047	1714	5038970000000	1628	878	1	0	\N
52048	1714	5038970000000	1907	1015	1	0	\N
52050	1714	5038980000000	1628	878	2	0	\N
52051	1714	5038980000000	1907	1015	2	0	\N
52053	1714	5205513103056	10623	5486	6	0	\N
52054	1714	5205513103056	10874	5610	2	0	\N
52056	1714	5205533103056	10874	5610	3	0	\N
52057	1714	5205573103056	10623	5486	7	0	\N
52059	1714	5325480171760	21701	10869	3	0	\N
52061	1714	5325492171760	21701	10869	4	0	\N
52067	1714	5926873103056	11131	5673	65	0	\N
52068	1714	6045492171760	21959	10985	9	0	\N
52070	1714	6045492171760	22418	11218	16	0	\N
52072	1714	6045528171760	21959	10985	10	0	\N
52073	1714	6045562171760	22418	11218	17	0	\N
52077	1714	6646873103056	11131	5673	126	0	\N
52078	1714	6647473103056	11131	5673	127	0	\N
52083	1714	7189030000000	2991	1554	1	0	\N
52088	1714	7909020000000	2686	1411	1	0	\N
52033	1714	1438910000000	814	450	1	0	1
52034	1714	1438920000000	814	450	2	0	1
52035	1714	2158920000000	1142	630	1	0	1
52036	1714	2158930000000	1142	630	2	0	1
52037	1714	2878930000000	1382	757	2	0	1
52039	1714	3598950000000	1478	806	1	0	1
52040	1714	3598960000000	1478	806	2	0	1
52041	1714	4318960000000	1557	847	1	0	1
52042	1714	4318970000000	1557	847	2	0	1
52049	1714	5038970000000	1915	1020	2	0	1
52063	1714	5758990000000	1947	1032	1	0	1
52064	1714	5759000000000	1947	1032	2	0	1
52074	1714	6469000000000	2231	1176	0	0	2
52081	1714	7189000000000	2525	1327	2	0	2
51961	1711	16559300000000	8914	4619	2	0	0
51962	1711	16559320000000	8914	4619	3	0	0
51967	1711	17279320000000	8918	4621	2	0	0
51968	1711	17279340000000	8918	4621	3	0	0
51977	1711	17999340000000	9010	4670	4	0	0
51983	1711	18719380000000	9234	4787	2	0	0
51984	1711	18719400000000	9234	4787	3	0	0
52055	1714	5205513103056	10962	5649	7	0	7
52058	1714	5206163103056	10962	5649	8	0	7
52065	1714	5926163103056	10985	5660	6	0	7
52075	1714	6646223103056	11327	5816	1	0	7
52076	1714	6646224103056	11327	5816	2	0	7
52084	1714	7366224103056	11470	5895	3	0	7
52085	1714	7366236103056	11470	5895	4	0	7
51957	1711	16364868000000	17459	8842	18	0	9
51965	1711	17084868000000	17542	8883	6	0	9
51966	1711	17084892000000	17542	8883	7	0	9
51974	1711	17804892000000	18317	9226	9	0	9
51976	1711	17805315000000	18317	9226	10	0	9
51982	1711	18525327000000	19172	9672	4	0	9
52000	1711	19245327000000	19531	9839	3	0	9
52001	1711	19245339000000	19531	9839	4	0	9
52014	1711	19965339000000	19574	9858	1	0	9
52015	1711	19965340000000	19574	9858	2	0	9
52024	1711	20685352000000	19610	9877	4	0	9
52025	1711	21405352000000	19717	9927	3	0	9
52026	1711	21405364000000	19717	9927	4	0	9
52044	1714	4605466171760	21610	10830	5	0	11
52060	1714	5325480171760	21779	10905	3	0	11
52062	1714	5325492171760	21779	10905	4	0	11
52069	1714	6045492171760	22417	11221	3	0	11
52071	1714	6045504171760	22417	11221	4	0	11
52079	1714	6765504171760	22578	11295	11	0	11
52086	1714	7485542171760	22588	11301	3	0	11
52087	1714	7485554171760	22588	11301	4	0	11
51963	1711	16987025000000	26389	13053	6	0	13
51964	1711	16987049000000	26389	13053	7	0	13
51970	1711	17707049000000	26905	13306	3	0	13
51979	1711	18427061000000	27127	13415	3	0	13
51980	1711	18427073000000	27127	13415	4	0	13
51992	1711	19147073000000	29004	14302	7	0	13
51997	1711	19147098000000	29004	14302	8	0	13
52011	1711	19867111000000	29076	14335	5	0	13
52019	1711	20587111000000	30271	14884	11	0	13
52021	1711	20587131642860	30271	14884	12	0	13
52089	1714	7909020000000	2794	1462	1	0	\N
52090	1714	7909020000000	2996	1557	2	0	\N
52092	1714	7909030000000	2686	1411	2	0	\N
52093	1714	7909030000000	2794	1462	2	0	\N
52094	1714	7909030000000	2991	1554	4	0	\N
52096	1714	7909040000000	2996	1557	3	0	\N
52097	1714	7909050000000	2991	1554	5	0	\N
52098	1714	8086236103056	12039	6197	1	0	\N
52099	1714	8086236103056	12194	6277	1	0	\N
52101	1714	8086237103056	12039	6197	2	0	\N
52102	1714	8086237103056	12194	6277	2	0	\N
52104	1714	8205554171760	23765	11833	7	0	\N
52106	1714	8205554171760	23936	11912	3	0	\N
52108	1714	8205566171760	23936	11912	4	0	\N
52109	1714	8205579171760	23765	11833	8	0	\N
52110	1714	8629030000000	3568	1851	0	0	\N
52112	1714	8806256103056	12883	6642	2	0	\N
52113	1714	8806256103056	13080	6740	3	0	\N
52115	1714	8806267103056	12883	6642	3	0	\N
52116	1714	8806268103056	13080	6740	4	0	\N
52119	1714	8925565171760	23965	11925	3	0	\N
52121	1714	8925586171760	23965	11925	4	0	\N
52123	1714	9349030000000	3663	1901	0	0	\N
52132	1714	10246282103056	13939	7131	0	0	\N
52133	1714	10246282103056	14785	7529	4	0	\N
52134	1714	10246282103056	15230	7757	1	0	\N
52135	1714	10246282103056	15510	7893	2	0	\N
52136	1714	10246282103056	15548	7914	5	0	\N
52139	1714	10246292103056	15230	7757	2	0	\N
52140	1714	10246293103056	15510	7893	3	0	\N
52141	1714	10246304103056	14785	7529	5	0	\N
52142	1714	10246305103056	15548	7914	6	0	\N
52144	1714	10365624171760	25050	12429	2	0	\N
52146	1714	10365635171760	25050	12429	3	0	\N
52151	1714	11085634171760	25169	12486	3	0	\N
52154	1714	11085646171760	25169	12486	4	0	\N
52155	1714	11509100000000	3944	2047	2	0	\N
52158	1714	11509120000000	3944	2047	3	0	\N
52163	1714	11805636171760	25188	12495	8	0	\N
52164	1714	11805644171760	25188	12495	9	0	\N
52167	1714	12406308103056	15672	7976	7	0	\N
52169	1714	12406333103056	15672	7976	8	0	\N
52171	1714	12525674171760	25259	12531	4	0	\N
52172	1714	12525674171760	25595	12668	0	0	\N
52173	1714	12525674171760	25651	12694	3	0	\N
52175	1714	12525686171760	25651	12694	4	0	\N
52176	1714	12525687171760	25259	12531	5	0	\N
52179	1714	13126420103056	16539	8120	0	0	\N
52180	1714	13126420103056	16540	8401	0	0	\N
52181	1714	13126420103056	16541	8122	0	0	\N
52182	1714	13126420103056	16671	8468	3	0	\N
52185	1714	13126432103056	16671	8468	4	0	\N
52186	1714	13245687171760	25672	12705	2	0	\N
52188	1714	13245698171760	25672	12705	3	0	\N
52198	1714	14389150000000	5318	2764	1	0	\N
52204	1714	15109150000000	5318	2764	2	0	\N
52207	1714	15405747171760	26301	13009	5	0	\N
52209	1714	15405747171760	26348	13028	2	0	\N
52210	1714	15405758171760	26348	13028	3	0	\N
52212	1714	15405770171760	26301	13009	6	0	\N
52216	1714	16125759171760	26574	13138	0	0	\N
52219	1714	16549140000000	5461	2842	0	0	\N
52111	1714	8629030000000	3643	1890	0	0	2
52124	1714	9349030000000	3806	1972	3	0	2
52125	1714	9349060000000	3806	1972	4	0	2
52130	1714	10069060000000	3904	2027	2	0	2
52131	1714	10069080000000	3904	2027	3	0	2
52148	1714	10789100000000	3938	2044	3	0	2
52156	1714	11509100000000	4163	2165	1	0	2
52157	1714	11509110000000	4163	2165	2	0	2
52159	1714	11509120000000	4260	2210	1	0	2
52166	1714	12229120000000	4260	2210	2	0	2
52190	1714	13669120000000	4626	2393	1	0	2
52191	1714	13669130000000	4626	2393	2	0	2
52196	1714	14389130000000	5294	2750	1	0	2
52197	1714	14389140000000	5294	2750	2	0	2
52213	1714	15829140000000	5400	2810	0	0	2
52220	1714	16549140000000	5513	2868	1	0	2
52221	1714	16549150000000	5513	2868	2	0	2
52100	1714	8086236103056	12761	6579	2	0	7
52103	1714	8086256103056	12761	6579	3	0	7
52117	1714	8806269103056	13099	6751	5	0	7
52118	1714	8806279103056	13815	7093	1	0	7
52126	1714	9526279103056	13815	7093	5	0	7
52127	1714	9526282103056	13815	7093	6	0	7
52137	1714	10246282103056	15597	7939	2	0	7
52149	1714	10966284103056	15598	7940	2	0	7
52150	1714	10966295103056	15598	7940	3	0	7
52160	1714	11686295103056	15649	7963	4	0	7
52161	1714	11686308103056	15649	7963	5	0	7
52170	1714	12406420103056	15852	8062	5	0	7
52183	1714	13126420103056	17108	8668	2	0	7
52184	1714	13126431103056	17108	8668	3	0	7
52192	1714	13846431103056	17797	8990	5	0	7
52193	1714	13846454103056	17797	8990	6	0	7
52200	1714	14566479103056	17916	9037	8	0	7
52205	1714	15286479103056	18015	9087	4	0	7
52206	1714	15286492103056	18015	9087	5	0	7
52214	1714	16006492103056	18648	9396	5	0	7
52215	1714	16006515103056	18648	9396	6	0	7
52223	1714	16726527103056	18714	9427	4	0	7
52105	1714	8205554171760	23935	11912	2	0	11
52107	1714	8205565171760	23935	11912	3	0	11
52120	1714	8925565171760	23966	11925	4	0	11
52128	1714	9645587171760	24966	12390	10	0	11
52129	1714	9645624171760	24966	12390	11	0	11
52143	1714	10365624171760	25049	12429	1	0	11
52145	1714	10365634171760	25049	12429	2	0	11
52152	1714	11085634171760	25171	12486	2	0	11
52162	1714	11805636171760	25185	12495	11	0	11
52165	1714	11805674171760	25185	12495	12	0	11
52174	1714	12525674171760	25652	12694	4	0	11
52177	1714	12525687171760	25652	12694	5	0	11
52187	1714	13245687171760	25673	12705	3	0	11
52194	1714	13965699171760	25755	12740	3	0	11
52195	1714	13965711171760	25755	12740	4	0	11
52201	1714	14685711171760	25824	12769	9	0	11
52202	1714	14685747171760	25824	12769	10	0	11
52211	1714	15405759171760	26346	13028	4	0	11
52217	1714	16125759171760	26575	13149	3	0	11
52218	1714	16125771171760	26575	13149	4	0	11
52224	1714	16845771171760	27335	13512	3	0	11
52227	1714	17446527103056	18846	9501	3	0	\N
52230	1714	17446548103056	18846	9501	4	0	\N
52231	1714	17565783171760	27578	13620	1	0	\N
52233	1714	17565784171760	27578	13620	2	0	\N
52238	1714	18167884103056	20147	10123	68	0	\N
52239	1714	18285784171760	27582	13621	0	0	\N
52242	1714	18709150000000	5590	2905	0	0	\N
52243	1714	18709150000000	5923	3068	1	0	\N
52244	1714	18709150000000	5952	3084	1	0	\N
52245	1714	18709150000000	6540	3388	2	0	\N
52247	1714	18709160000000	5923	3068	2	0	\N
52248	1714	18709160000000	5952	3084	2	0	\N
52249	1714	18709170000000	6540	3388	3	0	\N
52251	1714	18886584103056	19128	9648	2	0	\N
52252	1714	18886584103056	19902	10023	7	0	\N
52253	1714	18886584103056	19919	10032	7	0	\N
52254	1714	18886584103056	20146	10139	5	0	\N
52255	1714	18886595103056	19128	9648	3	0	\N
52256	1714	18886609103056	19902	10023	8	0	\N
52257	1714	18886618103056	19919	10032	8	0	\N
52258	1714	18886716103056	20146	10139	6	0	\N
52259	1714	18887884103056	20147	10123	99	0	\N
52260	1714	18887914103056	20147	10123	100	0	\N
52261	1714	19005818171760	27754	13710	2	0	\N
52262	1714	19005818171760	27755	13710	1	0	\N
52264	1714	19005818171760	28042	13868	2	0	\N
52265	1714	19005819171760	27755	13710	2	0	\N
52266	1714	19005820171760	28042	13868	3	0	\N
52267	1714	19005829171760	27754	13710	3	0	\N
52269	1714	19429210000000	6792	3516	4	0	\N
52271	1714	19429250000000	6792	3516	5	0	\N
52273	1714	19725830171760	28105	13893	7	0	\N
52274	1714	19725830171760	28134	13906	3	0	\N
52275	1714	19725830171760	28351	14015	2	0	\N
52276	1714	19725830171760	28353	14015	0	0	\N
52278	1714	19725841171760	28351	14015	3	0	\N
52280	1714	19725851171760	28134	13906	4	0	\N
52281	1714	19725852171760	29074	14334	2	0	\N
52282	1714	19725855171760	28105	13893	8	0	\N
52283	1714	20149330000000	6963	3592	2	0	\N
52285	1714	20149350000000	6963	3592	3	0	\N
52286	1714	20445841171760	29226	14402	3	0	\N
52287	1714	20445841171760	29357	14468	4	0	\N
52288	1714	20445841171760	29705	14648	9	0	\N
52290	1714	20445852171760	29074	14334	4	0	\N
52291	1714	20445853171760	29074	14334	5	0	\N
52292	1714	20445853171760	29226	14402	4	0	\N
52293	1714	20445854171760	29357	14468	5	0	\N
52294	1714	20445859171760	29705	14648	10	0	\N
52305	1714	22309360000000	8166	4232	1	0	\N
52307	1714	22309370000000	8166	4232	2	0	\N
52309	1714	22605980897123	29852	14712	15	0	\N
52310	1714	22605980897123	30197	14854	9	0	\N
52311	1714	22605980897123	30198	14838	7	0	\N
52312	1714	22605980897123	30200	14855	20	0	\N
52313	1714	22605991897123	30197	14854	10	0	\N
52314	1714	22606002897123	30198	14838	8	0	\N
52315	1714	22606009897123	30200	14855	21	0	\N
52316	1714	22606040897123	29852	14712	16	0	\N
52319	1714	23326002897123	30201	14839	0	0	\N
52326	1714	25909480000000	9968	5171	7	0	\N
52329	1714	25909541000000	9968	5171	8	0	\N
52330	1714	26629540000000	10284	5322	3	0	\N
52331	1714	26629570000000	10284	5322	4	0	\N
52334	1715	1439010000000	298	171	3	0	\N
52337	1715	1439040000000	298	171	4	0	\N
52338	1715	2159020000000	645	362	2	0	\N
52339	1715	2159020000000	754	422	1	0	\N
52341	1715	2159030000000	754	422	2	0	\N
52343	1715	2159040000000	645	362	3	0	\N
52348	1715	4319061000000	975	542	1	0	\N
52349	1715	4319061000000	1048	582	4	0	\N
52351	1715	4319071000000	975	542	2	0	\N
52353	1715	4319101000000	1048	582	5	0	\N
52354	1715	5039091000000	1940	1030	1	0	\N
52355	1715	5039091000000	2062	1090	1	0	\N
52357	1715	5039101000000	1940	1030	2	0	\N
52358	1715	5039101000000	2062	1090	2	0	\N
52335	1715	1439010000000	424	242	1	0	0
52336	1715	1439020000000	424	242	2	0	0
52340	1715	2159020000000	792	438	1	0	0
52342	1715	2159030000000	792	438	2	0	0
52344	1715	2879030000000	884	492	1	0	0
52346	1715	3599040000000	892	495	3	0	0
52347	1715	3599061000000	892	495	4	0	0
52350	1715	4319061000000	1433	780	3	0	0
52352	1715	4319091000000	1433	780	4	0	0
52356	1715	5039091000000	2225	1172	2	0	0
52360	1715	5759111000000	2269	1191	2	0	0
52226	1714	17269150000000	5532	2876	0	0	2
52235	1714	17989150000000	5543	2882	0	0	2
52246	1714	18709150000000	6694	3460	6	0	2
52270	1714	19429210000000	6817	3529	3	0	2
52272	1714	19429330000000	6817	3529	4	0	2
52284	1714	20149330000000	7069	3648	0	0	2
52297	1714	20869330000000	7557	3913	1	0	2
52298	1714	20869340000000	7557	3913	2	0	2
52302	1714	21589360000000	7956	4123	3	0	2
52306	1714	22309360000000	8400	4353	1	0	2
52308	1714	22309370000000	8400	4353	2	0	2
52317	1714	23029370000000	8795	4559	4	0	2
52318	1714	23029410000000	8795	4559	5	0	2
52321	1714	23749430000000	9297	4823	3	0	2
52322	1714	24469430000000	9857	5112	2	0	2
52323	1714	24469450000000	9857	5112	3	0	2
52324	1714	25189450000000	9943	5160	3	0	2
52327	1714	25909480000000	10231	5295	6	0	2
52328	1714	25909540000000	10231	5295	7	0	2
52228	1714	17446527103056	18988	9575	4	0	7
52229	1714	17446540103056	18988	9575	5	0	7
52236	1714	18166540103056	19106	9637	8	0	7
52225	1714	16845783171760	27335	13512	4	0	11
52232	1714	17565783171760	27583	13632	6	0	11
52234	1714	17565807171760	27583	13632	7	0	11
52240	1714	18285807171760	27738	13703	2	0	11
52241	1714	18285818171760	27738	13703	3	0	11
52268	1714	19005830171760	28041	13868	4	0	11
52277	1714	19725830171760	28474	14072	2	0	11
52279	1714	19725841171760	28474	14072	3	0	11
52289	1714	20445841171760	29795	14681	12	0	11
52296	1714	20445957171760	29797	14682	50	0	11
52299	1714	21165957171760	29797	14682	61	0	11
52300	1714	21165966897123	29797	14682	64	0	11
52303	1714	21885966897123	29835	14701	5	0	11
52304	1714	21885980897123	29835	14701	6	0	11
52366	1715	7223518663945	24665	12251	1	0	\N
52367	1715	7223518663945	25077	12447	4	0	\N
52369	1715	7223519663945	24665	12251	2	0	\N
52370	1715	7223531663945	25077	12447	5	0	\N
52378	1715	8663546663945	25581	12663	3	0	\N
52380	1715	8663558663945	25581	12663	4	0	\N
52382	1715	9359211000000	2798	1464	4	0	\N
52383	1715	9359211000000	2959	1538	1	0	\N
52384	1715	9359211000000	3013	1565	1	0	\N
52385	1715	9359211000000	3274	1700	2	0	\N
52387	1715	9359221000000	2959	1538	2	0	\N
52388	1715	9359221000000	3013	1565	2	0	\N
52389	1715	9359231000000	3274	1700	3	0	\N
52391	1715	9359251000000	2798	1464	5	0	\N
52395	1715	10103579663945	26031	12864	2	0	\N
52396	1715	10103579663945	26276	12995	4	0	\N
52398	1715	10103590663945	26031	12864	3	0	\N
52400	1715	10103592663945	26276	12995	5	0	\N
52403	1715	10823591663945	26886	13296	4	0	\N
52406	1715	10823604663945	26886	13296	5	0	\N
52407	1715	11519241000000	4159	2163	1	0	\N
52409	1715	11519251000000	4159	2163	2	0	\N
52411	1715	11543602663945	27825	13752	3	0	\N
52413	1715	11543614663945	27825	13752	4	0	\N
52415	1715	12239261000000	4475	2319	1	0	\N
52417	1715	12239271000000	4475	2319	2	0	\N
52419	1715	12263634663945	28829	14220	7	0	\N
52422	1715	12263659663945	28829	14220	8	0	\N
52425	1715	12983646663945	29141	14368	3	0	\N
52428	1715	12983658663945	29141	14368	4	0	\N
52431	1715	13703657663945	29864	14720	9	0	\N
52432	1715	13703657663945	30246	14872	19	0	\N
52434	1715	13703675663945	29864	14720	10	0	\N
52436	1715	13703694663945	30246	14872	20	0	\N
52441	1715	15120031000000	5510	2867	0	0	\N
52444	1715	15840041000000	5713	2962	0	0	\N
52445	1715	15840041000000	6056	3146	1	0	\N
52446	1715	15840041000000	6099	3165	2	0	\N
52448	1715	15840051000000	6056	3146	2	0	\N
52449	1715	15840061000000	6099	3165	3	0	\N
52451	1715	15866801436096	18854	9505	1	0	\N
52452	1715	15866801436096	19503	9830	4	0	\N
52454	1715	15866811436096	18854	9505	2	0	\N
52455	1715	15866814436096	19503	9830	5	0	\N
52465	1715	18000131000000	6653	3440	2	0	\N
52467	1715	18000151000000	6653	3440	3	0	\N
52469	1715	18026849436096	20787	10446	2	0	\N
52470	1715	18026849436096	20815	10464	2	0	\N
52471	1715	18026849436096	21343	10713	6	0	\N
52473	1715	18026860436096	20787	10446	3	0	\N
52474	1715	18026860436096	20815	10464	3	0	\N
52475	1715	18026873436096	21343	10713	7	0	\N
52477	1715	18026894436096	22885	11440	2	0	\N
52478	1715	18720151000000	7266	3757	1	0	\N
52479	1715	18720151000000	7792	4041	1	0	\N
52481	1715	18720161000000	7266	3757	2	0	\N
52482	1715	18720161000000	7792	4041	2	0	\N
52484	1715	18746874436096	23364	11659	2	0	\N
52486	1715	18746885436096	23364	11659	3	0	\N
52488	1715	18746894436096	22885	11440	7	0	\N
52489	1715	18746898436096	22885	11440	8	0	\N
52492	1715	19466885436096	23641	11777	3	0	\N
52494	1715	19466897436096	23641	11777	4	0	\N
52363	1715	6479181000000	2475	1296	6	0	0
52364	1715	7199181000000	2531	1331	1	0	0
52365	1715	7199191000000	2531	1331	2	0	0
52372	1715	7919191000000	2709	1423	1	0	0
52373	1715	7919201000000	2709	1423	2	0	0
52377	1715	8639211000000	2789	1460	2	0	0
52386	1715	9359211000000	3300	1712	2	0	0
52390	1715	9359231000000	3300	1712	3	0	0
52394	1715	10079231000000	3466	1800	0	0	0
52401	1715	10799231000000	4061	2110	1	0	0
52408	1715	11519241000000	4325	2241	2	0	0
52410	1715	11519261000000	4325	2241	3	0	0
52416	1715	12239261000000	4709	2434	2	0	0
52418	1715	12239281000000	4709	2434	3	0	0
52424	1715	12959311000000	4932	2553	4	0	0
52429	1715	13679311000000	5087	2639	2	0	0
52430	1715	13679331000000	5087	2639	3	0	0
52437	1715	14399331000000	5458	2840	7	0	0
52438	1715	14400031000000	5458	2840	8	0	0
52443	1715	15120041000000	5699	2955	2	0	0
52447	1715	15840041000000	6266	3245	2	0	0
52450	1715	15840061000000	6266	3245	3	0	0
52457	1715	16560061000000	6270	3249	3	0	0
52458	1715	16560091000000	6270	3249	4	0	0
52462	1715	17280131000000	6456	3344	5	0	0
52466	1715	18000131000000	7151	3695	2	0	0
52468	1715	18000151000000	7151	3695	3	0	0
52480	1715	18720151000000	7843	4065	1	0	0
52490	1715	19440161000000	8114	4207	7	0	0
52491	1715	19440222000000	8114	4207	8	0	0
52496	1715	20160222000000	8131	4215	1	0	0
52453	1715	15866801436096	19596	9869	4	0	9
52456	1715	15866814436096	19596	9869	5	0	9
52460	1715	16586838436096	19733	9934	7	0	9
52463	1715	17306838436096	20398	10277	2	0	9
52464	1715	17306849436096	20398	10277	3	0	9
52472	1715	18026849436096	22671	11334	7	0	9
52476	1715	18026874436096	22671	11334	8	0	9
52487	1715	18746885436096	23401	11674	3	0	9
52493	1715	19466885436096	23928	11908	4	0	9
52495	1715	19466898436096	23928	11908	5	0	9
52368	1715	7223518663945	25216	12509	6	0	16
52374	1715	7943533663945	25218	12510	4	0	16
52375	1715	7943546663945	25218	12510	5	0	16
52379	1715	8663546663945	25928	12813	4	0	16
52381	1715	8663568663945	25928	12813	5	0	16
52392	1715	9383568663945	25976	12835	2	0	16
52397	1715	10103579663945	26868	13289	3	0	16
52399	1715	10103591663945	26868	13289	4	0	16
52404	1715	10823591663945	27748	13708	2	0	16
52405	1715	10823602663945	27748	13708	3	0	16
52412	1715	11543602663945	27959	13832	5	0	16
52420	1715	12263634663945	29006	14303	3	0	16
52421	1715	12263646663945	29006	14303	4	0	16
52426	1715	12983646663945	29493	14543	2	0	16
52427	1715	12983657663945	29493	14543	3	0	16
52435	1715	13703675663945	30250	14873	10	0	16
52439	1715	14423675663945	30283	14890	6	0	16
52440	1715	14423690663945	30283	14890	7	0	16
52500	1715	20880232000000	8268	4282	1	0	\N
52502	1715	20880233000000	8268	4282	2	0	\N
52508	1715	22320262000000	9213	4778	4	0	\N
52511	1715	22320302000000	9213	4778	5	0	\N
52512	1715	23040282000000	9435	4893	2	0	\N
52514	1715	23040302000000	9435	4893	3	0	\N
52516	1715	23760322000000	9472	4911	3	0	\N
52519	1715	23760592000000	9472	4911	4	0	\N
52523	1715	25200362000000	9947	5164	6	0	\N
52525	1715	25200422000000	9947	5164	7	0	\N
52528	1715	26640425000000	11966	6158	1	0	\N
52530	1715	26640426000000	11966	6158	2	0	\N
52542	1715	30960509000000	13303	6855	9	0	\N
52545	1715	30960545000000	13303	6855	10	0	\N
52546	1715	31680522000000	13503	6953	3	0	\N
52547	1715	31680522000000	13597	6992	3	0	\N
52548	1715	31680522000000	13620	7003	4	0	\N
52550	1715	31680534000000	13503	6953	4	0	\N
52551	1715	31680534000000	13597	6992	4	0	\N
52552	1715	31680535000000	13620	7003	5	0	\N
52554	1715	32400535000000	14414	7353	13	0	\N
52557	1715	32400566000000	14414	7353	14	0	\N
52558	1715	33120548000000	14595	7442	3	0	\N
52559	1715	33120548000000	14905	7593	4	0	\N
52560	1715	33120548000000	15077	7680	5	0	\N
52563	1715	33120560000000	14595	7442	4	0	\N
52564	1715	33120561000000	14905	7593	5	0	\N
52565	1715	33120580000000	15077	7680	6	0	\N
52576	1715	37440638000002	16232	8252	3	0	\N
52577	1715	37440638000002	16461	8373	3	0	\N
52578	1715	37440638000002	16741	8501	8	0	\N
52581	1715	37440650000002	16232	8252	4	0	\N
52582	1715	37440650000002	16461	8373	4	0	\N
52583	1715	37440673000002	16741	8501	9	0	\N
52588	1715	39600672000002	17331	8779	9	0	\N
52591	1715	39601284000002	17331	8779	10	0	\N
52605	1716	124180000	2760	1231	119	0	\N
52606	1716	125000000	26311	13015	7	0	\N
52607	1716	719000000000	293	168	1	0	\N
52609	1716	719010000000	293	168	2	0	\N
52612	1716	720000000000	22783	11394	7	0	\N
52613	1716	720000000000	22858	11428	5	0	\N
52615	1716	720000418000	12141	6254	3	1	\N
52617	1716	720023000000	22858	11428	6	0	\N
52618	1716	720034000000	22783	11394	8	0	\N
52619	1716	1439010000000	334	192	1	0	\N
52620	1716	1439020000000	334	192	2	0	\N
52623	1716	1440012000000	23286	11618	6	0	\N
52626	1716	1440045000000	23286	11618	7	0	\N
52627	1716	1440045000000	24019	11953	4	0	\N
52628	1716	2159060000000	598	339	1	0	\N
52630	1716	2159070000000	598	339	2	0	\N
52632	1716	2160023000000	23442	11691	2	0	\N
52611	1716	719020000000	385	219	1	0	0
52621	1716	1439020000000	385	219	6	0	0
52622	1716	1439060000000	385	219	7	0	0
52629	1716	2159060000000	1002	554	1	0	0
52631	1716	2159070000000	1002	554	2	0	0
52501	1715	20880232000000	8464	4385	1	0	0
52503	1715	20880242000000	8464	4385	2	0	0
52506	1715	21600242000000	8648	4480	2	0	0
52507	1715	21600262000000	8648	4480	3	0	0
52509	1715	22320262000000	9406	4880	2	0	0
52513	1715	23040282000000	9445	4898	4	0	0
52515	1715	23040322000000	9445	4898	5	0	0
52517	1715	23760322000000	9490	4922	2	0	0
52518	1715	23760342000000	9490	4922	3	0	0
52521	1715	24480362000000	9836	5099	3	0	0
52522	1715	24480385000000	10035	5206	5	0	0
52524	1715	25200385000000	10035	5206	6	0	0
52526	1715	25920385000000	10655	5503	4	0	0
52527	1715	25920425000000	10655	5503	5	0	0
52531	1715	26640436000000	12230	6299	3	0	0
52532	1715	27360436000000	12718	6557	5	0	0
52533	1715	27360459000000	12718	6557	6	0	0
52534	1715	28080459000000	12795	6597	7	0	0
52535	1715	28080475000000	12795	6597	8	0	0
52537	1715	28800487000000	12797	6598	4	0	0
52538	1715	29520487000000	13167	6784	2	0	0
52539	1715	29520498000000	13167	6784	3	0	0
52540	1715	30240498000000	13272	6836	2	0	0
52543	1715	30960509000000	13429	6919	4	0	0
52544	1715	30960522000000	13429	6919	5	0	0
52549	1715	31680522000000	14107	7212	4	0	0
52553	1715	31680535000000	14107	7212	5	0	0
52555	1715	32400535000000	14463	7383	4	0	0
52561	1715	33120548000000	15311	7801	2	0	0
52562	1715	33120559000000	15311	7801	3	0	0
52566	1715	33840559000000	15353	7824	2	0	0
52567	1715	33840570000000	15353	7824	3	0	0
52568	1715	34560569000001	15516	7895	3	0	0
52570	1715	35280589000002	15657	7968	7	0	0
52571	1715	35280614000002	15657	7968	8	0	0
52572	1715	36000614000002	15845	8060	3	0	0
52573	1715	36000626000002	15845	8060	4	0	0
52575	1715	36720638000002	15920	8094	4	0	0
52579	1715	37440638000002	17093	8661	2	0	0
52580	1715	37440649000002	17093	8661	3	0	0
52584	1715	38160649000002	17138	8685	2	0	0
52585	1715	38160660000002	17138	8685	3	0	0
52587	1715	38880672000002	17297	8761	4	0	0
52589	1715	39600672000002	17387	8807	5	0	0
52590	1715	39600695000002	17387	8807	6	0	0
52592	1715	40320695000002	17879	9024	10	0	0
52593	1715	40320732000002	17879	9024	11	0	0
52595	1715	41040744000002	17985	9072	4	0	0
52596	1715	41760744000002	18022	9091	6	0	0
52597	1715	41760768000002	18022	9091	7	0	0
52598	1715	42480768000002	18342	9241	9	0	0
52600	1715	43200803990002	18446	9298	3	0	0
52601	1715	43200815990002	18446	9298	4	0	0
52603	1715	43919515990002	18532	9337	7	0	2
52604	1715	43919540990002	18532	9337	8	0	2
52602	1715	43591425602430	18553	9349	0	0	4
52616	1716	720012000000	23195	11579	4	0	9
52624	1716	1440012000000	23418	11683	2	0	9
52625	1716	1440023000000	23418	11683	3	0	9
52498	1715	20186898436096	24418	12145	2	0	9
52499	1715	20186909436096	24418	12145	3	0	9
52505	1715	20906920436096	24553	12205	3	0	9
52633	1716	2160023000000	24048	11968	5	0	\N
52634	1716	2160023000000	24449	12159	4	0	\N
52635	1716	2160023000000	24699	12266	5	0	\N
52636	1716	2160023000000	24705	12269	27	0	\N
52637	1716	2160023000000	25140	12473	3	0	\N
52638	1716	2160023000000	25183	12489	30	0	\N
52639	1716	2160023000000	25187	12495	11	0	\N
52640	1716	2160023000000	25386	12585	3	0	\N
52641	1716	2160023000000	26311	13015	6	0	\N
52643	1716	2160034000000	23442	11691	3	0	\N
52644	1716	2160035000000	25140	12473	4	0	\N
52645	1716	2160035000000	25386	12585	4	0	\N
52646	1716	2160045000000	24019	11953	5	0	\N
52647	1716	2160045000000	24449	12159	5	0	\N
52648	1716	2160046000000	24048	11968	6	0	\N
52649	1716	2160055000000	24699	12266	6	0	\N
52651	1716	2160061000000	25187	12495	12	0	\N
52652	1716	2160092000000	27989	13844	9	0	\N
52654	1716	2160134000000	25183	12489	31	0	\N
52655	1716	2160230000000	24705	12269	28	0	\N
52658	1716	2879090000000	1209	666	1	0	\N
52659	1716	2880056000000	26523	13121	3	0	\N
52660	1716	2880056000000	26618	13168	8	0	\N
52661	1716	2880056000000	27006	13358	6	0	\N
52662	1716	2880056000000	27209	13458	3	0	\N
52663	1716	2880056000000	27264	13478	3	0	\N
52664	1716	2880056000000	27384	13541	3	0	\N
52665	1716	2880056000000	27427	13559	3	0	\N
52666	1716	2880056000000	27973	13835	11	0	\N
52667	1716	2880068000000	26523	13121	4	0	\N
52668	1716	2880068000000	27209	13458	4	0	\N
52669	1716	2880068000000	27264	13478	4	0	\N
52670	1716	2880068000000	27384	13541	4	0	\N
52671	1716	2880068000000	27427	13559	4	0	\N
52672	1716	2880073000000	26618	13168	9	0	\N
52673	1716	2880080000000	27006	13358	7	0	\N
52674	1716	2880092000000	27989	13844	10	0	\N
52676	1716	2880094000000	27973	13835	12	0	\N
52678	1716	3599090000000	1209	666	2	0	\N
52680	1716	3600092000000	28463	14065	2	0	\N
52681	1716	3600092000000	28568	14112	9	0	\N
52683	1716	3600092000000	28706	14172	2	0	\N
52684	1716	3600094000000	28706	14172	3	0	\N
52685	1716	3600103000000	28463	14065	3	0	\N
52687	1716	3600128000000	28568	14112	10	0	\N
52690	1716	4319110000000	1476	805	5	0	\N
52693	1716	4319160000000	1476	805	6	0	\N
52694	1716	4320104000000	29061	14330	9	0	\N
52697	1716	4320140000000	29061	14330	10	0	\N
52700	1716	5039120000000	1810	968	1	0	\N
52702	1716	5039130000000	1810	968	2	0	\N
52706	1716	5040400330360	30280	14866	11	0	\N
52709	1716	5759130000000	2076	1096	1	0	\N
52711	1716	5759140000000	2076	1096	2	0	\N
52713	1716	5760134000000	30227	14861	9	0	\N
52714	1716	5760134000000	30229	14863	11	0	\N
52715	1716	5760134000000	30281	14889	8	0	\N
52716	1716	5760151000000	30281	14889	9	0	\N
52717	1716	5760152000000	30227	14861	10	0	\N
52718	1716	5760156000000	30229	14863	12	0	\N
52719	1716	5760400330360	30280	14866	12	0	\N
52724	1716	6480220000000	2485	1230	98	0	\N
52725	1716	6526640000000	12115	6240	1	0	\N
52726	1716	6526640000000	12141	6254	2	0	\N
52727	1716	6526640000000	12143	6254	2	0	\N
52729	1716	6526641000000	12115	6240	2	0	\N
52731	1716	7198149999976	2823	1222	0	0	\N
52732	1716	7199150000000	2220	1169	1	0	\N
52733	1716	7199150000000	3130	1628	1	0	\N
52734	1716	7199150000000	3143	1635	1	0	\N
52736	1716	7199160000000	2220	1169	2	0	\N
52737	1716	7199160000000	3130	1628	2	0	\N
52738	1716	7199160000000	3143	1635	2	0	\N
52740	1716	7200219999990	2485	1230	103	0	\N
52745	1716	7920731396390	2760	1231	126	0	\N
52746	1716	7966678000000	12626	6516	2	0	\N
52748	1716	7966689000000	12626	6516	3	0	\N
52755	1716	9406703000000	14301	7299	3	0	\N
52756	1716	9406703000000	14302	7299	12	0	\N
52757	1716	9406703000000	14323	7308	4	0	\N
52760	1716	9406716000000	14323	7308	5	0	\N
52761	1716	9406733000000	14301	7299	4	0	\N
52762	1716	9406742000000	14302	7299	13	0	\N
52763	1716	10079180000000	3990	2072	1	0	\N
52764	1716	10079180000000	3991	2072	1	0	\N
52766	1716	10079190000000	3990	2072	2	0	\N
52767	1716	10079190000000	3991	2072	2	0	\N
52677	1716	3599080000000	1326	729	3	0	0
52679	1716	3599110000000	1326	729	4	0	0
52691	1716	4319110000000	1802	964	1	0	0
52692	1716	4319120000000	1802	964	2	0	0
52701	1716	5039120000000	1856	989	1	0	0
52710	1716	5759130000000	2090	1104	1	0	0
52712	1716	5759140000000	2090	1104	2	0	0
52722	1716	6479140000000	2114	1114	1	0	0
52723	1716	6479150000000	2114	1114	2	0	0
52735	1716	7199150000000	3170	1648	1	0	0
52743	1716	7919160000000	3211	1668	1	0	0
52744	1716	7919170000000	3211	1668	2	0	0
52750	1716	8639170000000	3582	1860	0	0	0
52753	1716	9359170000000	3828	1986	1	0	0
52765	1716	10079180000000	4110	2137	1	0	0
52768	1716	10079190000000	4110	2137	2	0	0
52688	1716	3646577000000	11112	5714	5	0	4
52689	1716	3646627000000	11112	5714	6	0	4
52698	1716	4366627000000	11383	5847	2	0	4
52707	1716	5086638000000	11610	5973	1	0	4
52708	1716	5086639000000	11610	5973	2	0	4
52720	1716	5806639000000	11836	6084	1	0	4
52721	1716	5806640000000	11836	6084	2	0	4
52728	1716	6526640000000	12189	6276	3	0	4
52741	1716	7246643000000	12613	6507	8	0	4
52742	1716	7246678000000	12613	6507	9	0	4
52747	1716	7966678000000	13611	6998	3	0	4
52749	1716	7966690000000	13611	6998	4	0	4
52752	1716	8686703000000	13767	7073	5	0	4
52758	1716	9406703000000	14628	7457	3	0	4
52759	1716	9406715000000	14628	7457	4	0	4
52642	1716	2160023000000	26313	13015	6	0	9
52650	1716	2160056000000	26313	13015	7	0	9
52675	1716	2880092000000	27990	13844	10	0	9
52682	1716	3600092000000	28705	14172	3	0	9
52686	1716	3600104000000	28705	14172	4	0	9
52695	1716	4320104000000	29461	14528	3	0	9
52696	1716	4320116000000	29461	14528	4	0	9
52705	1716	5040134000000	29649	14621	10	0	9
52769	1716	10126715000000	14696	7484	2	0	\N
52770	1716	10126715000000	14726	7498	4	0	\N
52772	1716	10126726000000	14696	7484	3	0	\N
52774	1716	10126737000000	14726	7498	5	0	\N
52775	1716	10799190000000	4248	2204	4	0	\N
52776	1716	10799190000000	4467	2314	1	0	\N
52777	1716	10799190000000	4517	2336	1	0	\N
52778	1716	10799190000000	4690	2421	5	0	\N
52780	1716	10799200000000	4467	2314	2	0	\N
52781	1716	10799200000000	4517	2336	2	0	\N
52783	1716	10799240000000	4690	2421	6	0	\N
52784	1716	10799320000000	4248	2204	5	0	\N
52787	1716	11519200000000	5120	2656	2	0	\N
52789	1716	11519220000000	5120	2656	3	0	\N
52797	1716	12959221000000	5534	2877	0	0	\N
52800	1716	13006804000000	15443	7864	2	0	\N
52802	1716	13006815000000	15443	7864	3	0	\N
52808	1716	14399241000000	6102	3167	1	0	\N
52809	1716	14399241000000	6117	3172	0	0	\N
52811	1716	14399251000000	6102	3167	2	0	\N
52813	1716	14446829000000	16187	8227	4	0	\N
52815	1716	14446829000000	16189	8227	4	0	\N
52816	1716	14446842000000	16187	8227	5	0	\N
52818	1716	14446842000000	16189	8227	5	0	\N
52822	1716	15839271000000	6165	3193	1	0	\N
52824	1716	15839281000000	6165	3193	2	0	\N
52832	1716	17279311000000	6972	3598	2	0	\N
52834	1716	17279331000000	6972	3598	3	0	\N
52838	1716	17999341000000	7097	3664	2	0	\N
52841	1716	17999361000000	7097	3664	3	0	\N
52848	1716	19439361000000	7438	3845	1	0	\N
52849	1716	19439361000000	7537	3902	1	0	\N
52850	1716	19439361000000	7594	3927	7	0	\N
52851	1716	19439361000000	7847	4067	1	0	\N
52853	1716	19439371000000	7438	3845	2	0	\N
52854	1716	19439371000000	7537	3902	2	0	\N
52855	1716	19439371000000	7847	4067	2	0	\N
52857	1716	19439611000000	7594	3927	8	0	\N
52858	1716	19486925000000	17793	8988	7	0	\N
52860	1716	19486925000000	18422	9278	34	0	\N
52862	1716	19486950000000	17793	8988	8	0	\N
52863	1716	19487067000000	18422	9278	35	0	\N
52868	1716	20879401000000	8814	4548	4	0	\N
52871	1716	20879441000000	8814	4548	5	0	\N
52872	1716	20926948000000	19166	9668	7	0	\N
52875	1716	20926973000000	19166	9668	8	0	\N
52876	1716	21599431000000	8878	4599	5	0	\N
52878	1716	21599441000000	8879	4549	2	0	\N
52879	1716	21599461000000	8879	4549	3	0	\N
52881	1716	21599481000000	8878	4599	6	0	\N
52882	1716	21646961000000	19813	9979	2	0	\N
52883	1716	21646972000000	19813	9979	3	0	\N
52886	1716	23039491000000	9793	5077	2	0	\N
52888	1716	23039511000000	9793	5077	3	0	\N
52892	1716	66000000000290	2485	1230	104	1	\N
52893	1716	66000000000460	2760	1231	127	1	\N
52894	1716	66000000030000	12143	6254	3	0	\N
52897	1717	1439050000000	612	345	1	0	\N
52898	1717	1439050000000	1223	674	3	0	\N
52899	1717	1439050000000	1255	694	1	0	\N
52900	1717	1439050000000	1477	806	1	0	\N
52901	1717	1439050000000	1801	964	1	0	\N
52903	1717	1439060000000	612	345	2	0	\N
52904	1717	1439060000000	1255	694	2	0	\N
52902	1717	1439050000000	2015	1063	3	0	0
52779	1716	10799190000000	4691	2425	1	0	0
52782	1716	10799200000000	4691	2425	2	0	0
52788	1716	11519200000000	5269	2736	2	0	0
52790	1716	11519220000000	5269	2736	3	0	0
52794	1716	12239221000000	5422	2820	2	0	0
52798	1716	12959221000000	5679	2944	1	0	0
52799	1716	12959231000000	5679	2944	2	0	0
52804	1716	13679231000000	5936	3074	1	0	0
52805	1716	13679241000000	5936	3074	2	0	0
52812	1716	14399271000000	6118	3172	4	0	0
52819	1716	15119271000000	6124	3176	0	0	0
52823	1716	15839271000000	6678	3452	2	0	0
52825	1716	15839291000000	6678	3452	3	0	0
52829	1716	16559311000000	6811	3525	3	0	0
52833	1716	17279311000000	6976	3599	3	0	0
52835	1716	17279341000000	6976	3599	4	0	0
52839	1716	17999341000000	7254	3751	1	0	0
52840	1716	17999351000000	7254	3751	2	0	0
52845	1716	18719361000000	7433	3840	2	0	0
52852	1716	19439361000000	7922	4106	2	0	0
52856	1716	19439381000000	7922	4106	3	0	0
52864	1716	20159381000000	8744	4537	2	0	0
52865	1716	20159401000000	8744	4537	3	0	0
52870	1716	20879431000000	8815	4570	4	0	0
52877	1716	21599431000000	9391	4872	4	0	0
52880	1716	21599471000000	9391	4872	5	0	0
52884	1716	22319471000000	9545	4950	2	0	0
52887	1716	23039491000000	9852	5108	3	0	0
52889	1716	23039521000000	9852	5108	4	0	0
52890	1716	23759521000000	9931	5155	2	0	0
52891	1716	23759541000000	9931	5155	3	0	0
52771	1716	10126715000000	14739	7503	2	0	4
52785	1716	10846726000000	15126	7709	3	0	4
52786	1716	10846747000000	15126	7709	4	0	4
52791	1716	11566747000000	15272	7779	2	0	4
52792	1716	11566758000000	15272	7779	3	0	4
52795	1716	12286758000000	15286	7787	10	0	4
52801	1716	13006804000000	15759	8014	4	0	4
52803	1716	13006817000000	15759	8014	5	0	4
52806	1716	13726817000000	15946	8107	3	0	4
52807	1716	13726829000000	15946	8107	4	0	4
52817	1716	14446842000000	16188	8227	5	0	4
52820	1716	15166842000000	16216	8241	3	0	4
52821	1716	15166854000000	16216	8241	4	0	4
52826	1716	15886854000000	16328	8299	6	0	4
52827	1716	15886878000000	16328	8299	7	0	4
52831	1716	16606890000000	16347	8313	4	0	4
52836	1716	17326890000000	17040	8629	3	0	4
52837	1716	17326902000000	17040	8629	4	0	4
52842	1716	18046902000000	17135	8683	2	0	4
52843	1716	18046913000000	17135	8683	3	0	4
52847	1716	18766925000000	17265	8745	4	0	4
52859	1716	19486925000000	18421	9287	4	0	4
52861	1716	19486938000000	18421	9287	5	0	4
52866	1716	20206938000000	18971	9569	1	0	4
52873	1716	20926948000000	19264	9712	4	0	4
52874	1716	20926961000000	19264	9712	5	0	4
52905	1717	1439060000000	1477	806	2	0	\N
52906	1717	1439060000000	1801	964	2	0	\N
52907	1717	1439080000000	1223	674	4	0	\N
52911	1717	2879090000000	2446	1279	1	0	\N
52913	1717	2879100000000	2446	1279	2	0	\N
52915	1717	2987753000023	11811	6069	1	0	\N
52917	1717	2987754000023	11811	6069	2	0	\N
52927	1717	4319140000000	3120	1622	12	0	\N
52930	1717	4319260000000	3120	1622	13	0	\N
52933	1717	4860995000055	22597	11305	3	0	\N
52935	1717	4861007000055	22597	11305	4	0	\N
52939	1717	5147860000023	12852	6627	2	0	\N
52941	1717	5147871000023	12852	6627	3	0	\N
52946	1717	5867872000023	13354	6883	3	0	\N
52948	1717	5867884000023	13354	6883	4	0	\N
52952	1717	6479200000000	3810	1976	1	0	\N
52954	1717	6479210000000	3810	1976	2	0	\N
52956	1717	6587884000023	13520	6961	4	0	\N
52957	1717	6587884000023	13570	6979	3	0	\N
52958	1717	6587884000023	13833	7103	1	0	\N
52959	1717	6587884000023	13911	7134	4	0	\N
52960	1717	6587884000023	14090	7206	4	0	\N
52961	1717	6587884000023	14122	7218	4	0	\N
52963	1717	6587894000023	13833	7103	2	0	\N
52964	1717	6587896000023	13570	6979	4	0	\N
52965	1717	6587897000023	13520	6961	5	0	\N
52966	1717	6587897000023	13911	7134	5	0	\N
52967	1717	6587897000023	14090	7206	5	0	\N
52968	1717	6587897000023	14122	7218	5	0	\N
52972	1717	7199210000000	3911	2031	2	0	\N
52975	1717	7199230000000	3911	2031	3	0	\N
52980	1717	7919220000000	4282	2221	1	0	\N
52981	1717	7919220000000	4623	2393	1	0	\N
52983	1717	7919230000000	4282	2221	2	0	\N
52984	1717	7919230000000	4623	2393	2	0	\N
52986	1717	8027932000023	14805	7544	3	0	\N
52989	1717	8027953000023	14805	7544	4	0	\N
52994	1717	8747943000023	15252	7771	4	0	\N
52996	1717	8747965000023	15252	7771	5	0	\N
53009	1717	10621174000055	24115	12004	1	0	\N
53011	1717	10621175000055	24115	12004	2	0	\N
53017	1717	10908182000023	16722	8486	43	0	\N
53020	1717	11519262000000	5948	3083	1	0	\N
53022	1717	11519272000000	5948	3083	2	0	\N
53024	1717	11519282000000	7415	3832	1	0	\N
53025	1717	11628022000023	16179	8224	4	0	\N
53026	1717	11628022000023	16494	8389	4	0	\N
53027	1717	11628022000023	16995	8597	0	0	\N
53028	1717	11628022000023	16996	8606	0	0	\N
53029	1717	11628022000023	16997	8607	0	0	\N
53031	1717	11628035000023	16179	8224	5	0	\N
53032	1717	11628035000023	16494	8389	5	0	\N
53034	1717	11628182000023	16722	8486	44	0	\N
53035	1717	11629280000023	16885	8487	126	0	\N
53038	1717	12239272000000	6611	3419	2	0	\N
53040	1717	12239282000000	7415	3832	3	0	\N
52910	1717	2159090000000	2133	1127	2	0	0
52912	1717	2879090000000	2520	1323	4	0	0
52914	1717	2879130000000	2520	1323	5	0	0
52921	1717	3599130000000	2904	1516	1	0	0
52922	1717	3599140000000	2904	1516	2	0	0
52929	1717	4319190000000	3141	1634	6	0	0
52937	1717	5039190000000	3275	1701	1	0	0
52938	1717	5039200000000	3275	1701	2	0	0
52945	1717	5759200000000	3569	1852	0	0	0
52953	1717	6479200000000	3875	2013	1	0	0
52973	1717	7199210000000	3956	2056	1	0	0
52974	1717	7199220000000	3956	2056	2	0	0
52982	1717	7919220000000	4888	2532	1	0	0
52985	1717	7919230000000	4888	2532	2	0	0
52993	1717	8639241000000	5306	2758	3	0	0
53000	1717	9359241000000	5404	2813	1	0	0
53001	1717	9359242000000	5404	2813	2	0	0
53006	1717	10079242000000	5690	2950	0	0	0
53013	1717	10799242000000	5908	3062	2	0	0
53021	1717	11519262000000	6032	3130	1	0	0
53023	1717	11519272000000	6032	3130	2	0	0
53039	1717	12239272000000	7543	3905	2	0	0
52916	1717	2987753000023	12508	6444	12	0	4
52918	1717	2987828000023	12508	6444	13	0	4
52924	1717	3707850000023	12783	6590	5	0	4
52931	1717	4427850000023	12832	6619	1	0	4
52932	1717	4427860000023	12832	6619	2	0	4
52940	1717	5147860000023	13285	6843	3	0	4
52947	1717	5867872000023	13502	6952	3	0	4
52949	1717	5867884000023	13502	6952	4	0	4
52962	1717	6587884000023	14439	7368	6	0	4
52969	1717	6587908000023	14439	7368	7	0	4
52976	1717	7307908000023	14524	7408	6	0	4
52987	1717	8027932000023	15067	7673	2	0	4
52988	1717	8027943000023	15067	7673	3	0	4
52995	1717	8747943000023	15320	7807	5	0	4
52997	1717	8747966000023	15320	7807	6	0	4
53002	1717	9467966000023	15364	7828	5	0	4
53007	1717	10187989000023	15399	7843	2	0	4
53008	1717	10188000000023	15399	7843	3	0	4
53015	1717	10908000000023	15467	7875	4	0	4
53016	1717	10908022000023	15467	7875	5	0	4
53033	1717	11628035000023	17039	8628	5	0	4
52919	1717	3420960000055	22432	11228	4	0	8
52920	1717	3420973000055	22432	11228	5	0	8
52925	1717	4140973000055	22510	11260	4	0	8
52926	1717	4140995000055	22510	11260	5	0	8
52936	1717	4861045000055	22736	11368	15	0	8
52943	1717	5581045000055	22777	11390	4	0	8
52944	1717	5581058000055	22777	11390	5	0	8
52950	1717	6301058000055	23201	11583	3	0	8
52951	1717	6301070000055	23201	11583	4	0	8
52971	1717	7021082000055	23686	11795	4	0	8
52978	1717	7741082000055	23691	11800	3	0	8
52979	1717	7741094000055	23691	11800	4	0	8
52990	1717	8461094000055	23766	11834	5	0	8
52998	1717	9181126000055	23803	11848	3	0	8
52999	1717	9181138000055	23803	11848	4	0	8
53004	1717	9901138000055	23999	11943	9	0	8
53005	1717	9901174000055	23999	11943	10	0	8
53010	1717	10621174000055	24403	12135	3	0	8
53018	1717	11341186000055	24413	12142	2	0	8
53019	1717	11341197000055	24413	12142	3	0	8
53036	1717	12061197000055	24444	12157	2	0	8
53037	1717	12061208000055	24444	12157	3	0	8
53041	1717	12239287000000	7415	3832	4	0	\N
53042	1717	12239292000000	6611	3419	3	0	\N
53046	1717	12349280000023	16885	8487	127	0	\N
53051	1717	13068046000023	17629	8914	3	0	\N
53053	1717	13068058000023	17629	8914	4	0	\N
53060	1717	14221264000055	24865	12347	3	0	\N
53062	1717	14221276000055	24865	12347	4	0	\N
53065	1717	14399302000000	7698	3989	1	0	\N
53067	1717	14399312000000	7698	3989	2	0	\N
53071	1717	14941277000055	25464	12613	3	0	\N
53073	1717	14941289000055	25464	12613	4	0	\N
53079	1717	15661289000055	26103	12901	4	0	\N
53082	1717	15661311000055	26103	12901	5	0	\N
53084	1717	15839333000000	9000	4667	2	0	\N
53086	1717	15839353000000	9000	4667	3	0	\N
53088	1717	15948116000023	18218	9177	5	0	\N
53091	1717	15948130000023	18218	9177	6	0	\N
53099	1717	17279753000000	9978	5175	2	0	\N
53100	1717	17279753000000	10506	5428	9	0	\N
53102	1717	17279773000000	9978	5175	3	0	\N
53104	1717	17279843000000	10506	5428	10	0	\N
53105	1717	17388168000023	19236	9699	3	0	\N
53108	1717	17388180000023	19236	9699	4	0	\N
53109	1717	17821354000055	27308	13498	3	0	\N
53110	1717	17821354000055	27324	13508	3	0	\N
53112	1717	17821366000055	27308	13498	4	0	\N
53113	1717	17821366000055	27324	13508	4	0	\N
53118	1717	18541354000055	27435	13562	3	0	\N
53120	1717	18541366000055	27435	13562	4	0	\N
53122	1717	18719793000000	11274	5791	2	0	\N
53123	1717	18719793000000	11615	5976	1	0	\N
53124	1717	18719794000000	11615	5976	2	0	\N
53125	1717	18719804000000	11274	5791	3	0	\N
53128	1717	19261366000055	27799	13737	4	0	\N
53131	1717	19261379000055	27799	13737	5	0	\N
53132	1717	19548195000023	19948	10045	15	0	\N
53135	1717	19548282000023	19948	10045	16	0	\N
53154	1717	22862251000055	30099	14773	96	0	\N
53157	1717	23582251000055	30099	14773	123	0	\N
53158	1717	23582276824406	30099	14773	125	1	\N
53161	1717	24588388000023	21817	10919	6	0	\N
53163	1717	24588412000023	21817	10919	7	0	\N
53165	1718	900000	10413	5386	4	1	\N
53166	1718	719000000000	314	181	2	0	\N
53167	1718	719000000000	778	432	1	0	\N
53168	1718	719010000000	778	432	2	0	\N
53169	1718	719020000000	314	181	3	0	\N
53172	1718	1440210000000	7858	4074	1	0	\N
53174	1718	1440220000000	7858	4074	2	0	\N
53050	1717	12959302000000	7595	3928	2	0	0
53057	1717	13679302000000	7620	3942	0	0	0
53170	1718	720200000000	7740	4011	1	0	0
53171	1718	720210000000	7740	4011	2	0	0
53066	1717	14399302000000	7856	4073	1	0	0
53173	1718	1440210000000	8105	4201	1	0	0
53175	1718	1440220000000	8105	4201	2	0	0
53075	1717	15119312000000	8275	4286	3	0	0
53076	1717	15119333000000	8275	4286	4	0	0
53085	1717	15839333000000	9029	4682	2	0	0
53093	1717	16559353000000	9728	5041	13	0	0
53094	1717	16559753000000	9728	5041	14	0	0
53101	1717	17279753000000	10715	5531	2	0	0
53103	1717	17279773000000	10715	5531	3	0	0
53115	1717	17999793000000	11065	5692	3	0	0
53044	1717	12348035000023	17498	8859	2	0	4
53045	1717	12348046000023	17498	8859	3	0	4
53052	1717	13068046000023	17726	8958	3	0	4
53054	1717	13068058000023	17726	8958	4	0	4
53059	1717	13788070000023	17781	8985	4	0	4
53069	1717	14508070000023	17824	9002	6	0	4
53070	1717	14508094000023	17824	9002	7	0	4
53077	1717	15228094000023	17987	9074	4	0	4
53078	1717	15228116000023	17987	9074	5	0	4
53090	1717	15948127000023	18751	9451	3	0	4
53095	1717	16668127000023	19049	9608	5	0	4
53096	1717	16668168000023	19049	9608	6	0	4
53106	1717	17388168000023	19392	9774	2	0	4
53116	1717	18108170000023	19584	9865	4	0	4
53117	1717	18108183000023	19584	9865	5	0	4
53126	1717	18828183000023	19940	10041	3	0	4
53127	1717	18828195000023	19940	10041	4	0	4
53133	1717	19548195000023	20010	10074	6	0	4
53138	1717	20268210000023	20160	10149	9	0	4
53139	1717	20268264000023	20160	10149	10	0	4
53142	1717	20988264000023	20223	10182	10	0	4
53143	1717	20988301000023	20223	10182	11	0	4
53146	1717	21708301000023	20838	10473	5	0	4
53148	1717	21708344000023	20888	10500	2	0	4
53151	1717	22428344000023	20888	10500	3	0	4
53176	1718	1698396519070	21323	10704	3	0	13
53155	1717	23148344000023	21503	10785	4	0	4
53159	1717	23868366000023	21677	10859	4	0	4
53160	1717	23868388000023	21677	10859	5	0	4
53162	1717	24588388000023	22170	11090	8	0	4
53164	1717	24589000000023	22170	11090	9	0	4
53047	1717	12781208000055	24594	12225	7	0	8
53055	1717	13501242000055	24800	12315	4	0	8
53056	1717	13501264000055	24800	12315	5	0	8
53061	1717	14221264000055	25111	12460	4	0	8
53063	1717	14221277000055	25111	12460	5	0	8
53064	1717	14221287000055	25532	12640	1	0	8
53074	1717	14941289000055	25532	12640	5	0	8
53080	1717	15661289000055	26567	13146	3	0	8
53081	1717	15661301000055	26567	13146	4	0	8
53083	1717	15661337000055	26895	13300	9	0	8
53097	1717	17101337000055	27062	13380	8	0	8
53098	1717	17101354000055	27062	13380	9	0	8
53111	1717	17821354000055	27394	13545	0	0	8
53119	1717	18541354000055	27495	13591	3	0	8
53121	1717	18541366000055	27495	13591	4	0	8
53130	1717	19261378000055	27904	13799	4	0	8
53136	1717	19981378000055	28212	13949	2	0	8
53137	1717	19981389000055	28212	13949	3	0	8
53140	1717	20701389000055	28366	14024	2	0	8
53141	1717	20701400000055	28366	14024	3	0	8
53145	1717	21421448000055	29270	14426	13	0	8
53149	1717	22141448000055	29370	14476	3	0	8
53150	1717	22141460000055	29370	14476	4	0	8
53152	1717	22861460000055	29680	14640	12	0	8
53178	1718	2160220000000	8236	4268	0	0	\N
53181	1718	2418408519070	21398	10734	2	0	\N
53182	1718	2418408519070	21435	10750	6	0	\N
53183	1718	2418408519070	21508	10788	4	0	\N
53185	1718	2418419519070	21398	10734	3	0	\N
53186	1718	2418421519070	21508	10788	5	0	\N
53187	1718	2418432519070	21435	10750	7	0	\N
53191	1718	3138432519070	21826	10924	6	0	\N
53192	1718	3138432519070	21855	10937	9	0	\N
53194	1718	3138456519070	21826	10924	7	0	\N
53196	1718	3138468519070	21855	10937	10	0	\N
53199	1718	3858456519070	21908	10962	6	0	\N
53202	1718	3858480519070	21908	10962	7	0	\N
53205	1718	4578468519070	22020	11009	4	0	\N
53206	1718	4578468519070	22487	11251	18	0	\N
53207	1718	4578468519070	22502	11256	9	0	\N
53208	1718	4578468519070	22633	11319	4	0	\N
53209	1718	4578468519070	22816	11409	2	0	\N
53210	1718	4578468519070	22893	11443	2	0	\N
53212	1718	4578470519070	22816	11409	3	0	\N
53213	1718	4578479519070	22893	11443	3	0	\N
53215	1718	4578481519070	22020	11009	5	0	\N
53216	1718	4578481519070	22633	11319	5	0	\N
53217	1718	4578540519070	22502	11256	10	0	\N
53218	1718	4578612519070	22487	11251	19	0	\N
53225	1718	6018390519070	23819	11857	7	0	\N
53226	1718	6018415519070	23819	11857	8	0	\N
53227	1718	6018490519070	23436	11690	2	0	\N
53229	1718	6018501519070	23436	11690	3	0	\N
53231	1718	6066726763340	13395	6902	7	0	\N
53232	1718	6066726763340	13674	7026	3	0	\N
53233	1718	6066726763340	14149	7223	3	0	\N
53235	1718	6066738763340	13674	7026	4	0	\N
53236	1718	6066738763340	14149	7223	4	0	\N
53238	1718	6066751763340	13395	6902	8	0	\N
53239	1718	6738539519070	24538	12200	6	0	\N
53241	1718	6738572519070	24538	12200	7	0	\N
53247	1718	7506761763340	15394	7840	2	0	\N
53248	1718	7506761763340	16251	8258	2	0	\N
53249	1718	7506761763340	16659	8464	9	0	\N
53251	1718	7506772763340	15394	7840	3	0	\N
53252	1718	7506772763340	16251	8258	3	0	\N
53254	1718	7506797763340	16659	8464	10	0	\N
53255	1718	8178596519070	25212	12505	3	0	\N
53256	1718	8178596519070	25442	12604	3	0	\N
53257	1718	8178596519070	25708	12718	3	0	\N
53258	1718	8178596519070	25785	12752	6	0	\N
53259	1718	8178608519070	25212	12505	4	0	\N
53260	1718	8178608519070	25442	12604	4	0	\N
53261	1718	8178608519070	25708	12718	4	0	\N
53262	1718	8178620519070	25785	12752	7	0	\N
53265	1718	8896606519070	26081	12889	1	0	\N
53266	1718	8946796763340	17543	8883	5	0	\N
53267	1718	8946796763340	17625	8912	3	0	\N
53268	1718	8946796763340	18316	9225	3	0	\N
53269	1718	8946796763340	18460	9302	4	0	\N
53270	1718	8946796763340	18487	9310	8	0	\N
53272	1718	8946808763340	17625	8912	4	0	\N
53273	1718	8946808763340	18316	9225	4	0	\N
53275	1718	8946809763340	18460	9302	5	0	\N
53276	1718	8946813763340	18487	9310	9	0	\N
53277	1718	8946819763340	17543	8883	6	0	\N
53278	1718	9616596519070	26594	13158	6	0	\N
53279	1718	9616596519070	27088	13392	6	0	\N
53281	1718	9616606519070	26081	12889	3	0	\N
53282	1718	9616607519070	26081	12889	4	0	\N
53283	1718	9616620519070	26594	13158	7	0	\N
53284	1718	9616620519070	27088	13392	7	0	\N
53286	1718	9666808763340	18771	9459	2	0	\N
53289	1718	9666819763340	18771	9459	3	0	\N
53290	1718	10336630519070	27833	13756	3	0	\N
53291	1718	10336630519070	27930	13815	3	0	\N
53292	1718	10336630519070	27961	13832	7	0	\N
53293	1718	10336630519070	28407	14039	2	0	\N
53295	1718	10336641519070	28407	14039	3	0	\N
53296	1718	10336642519070	27833	13756	4	0	\N
53297	1718	10336642519070	27930	13815	4	0	\N
53299	1718	10336664519070	27961	13832	8	0	\N
53304	1718	11056652519070	28502	14085	3	0	\N
53305	1718	11056652519070	28596	14121	9	0	\N
53306	1718	11056652519070	29459	14527	7	0	\N
53308	1718	11056664519070	28502	14085	4	0	\N
53310	1718	11056682019070	29459	14527	8	0	\N
53311	1718	11056706519070	28596	14121	10	0	\N
53312	1718	11106829763340	19238	9699	2	0	\N
53302	1718	10797439000000	8329	4311	1	0	1
53303	1718	10797449000000	8329	4311	2	0	1
53189	1718	2966675763340	11636	5988	4	0	8
53190	1718	2966679763340	11636	5988	5	0	8
53197	1718	3686679763340	12022	6186	1	0	8
53203	1718	3906679763340	12906	6652	4	0	9
53204	1718	3906701763340	12906	6652	5	0	9
53219	1718	4626701763340	13086	6741	4	0	9
53220	1718	4626714763340	13086	6741	5	0	9
53223	1718	5346714763340	13290	6846	3	0	9
53234	1718	6066726763340	14951	7615	5	0	9
53237	1718	6066749763340	14951	7615	6	0	9
53243	1718	6786749763340	15250	7769	3	0	9
53244	1718	6786761763340	15250	7769	4	0	9
53253	1718	7506772763340	16685	8475	3	0	9
53263	1718	8226772763340	17422	8825	6	0	9
53264	1718	8226796763340	17422	8825	7	0	9
53271	1718	8946796763340	18759	9456	3	0	9
53274	1718	8946808763340	18759	9456	4	0	9
53288	1718	9666818763340	18934	9551	2	0	9
53300	1718	10386818763340	19120	9645	2	0	9
53301	1718	10386829763340	19120	9645	3	0	9
53177	1718	1698408519070	21323	10704	4	0	13
53184	1718	2418408519070	21716	10877	6	0	13
53193	1718	3138432519070	21879	10948	6	0	13
53195	1718	3138456519070	21879	10948	7	0	13
53200	1718	3858456519070	21980	10989	3	0	13
53201	1718	3858468519070	21980	10989	4	0	13
53214	1718	4578479519070	22972	11475	3	0	13
53221	1718	5298479519070	23280	11615	2	0	13
53222	1718	5298490519070	23280	11615	3	0	13
53228	1718	6018490519070	24320	12095	13	0	13
53230	1718	6018539519070	24320	12095	14	0	13
53242	1718	6738584519070	24573	12215	10	0	13
53245	1718	7458584519070	25097	12456	3	0	13
53246	1718	7458596519070	25097	12456	4	0	13
53280	1718	9616596519070	27686	13681	7	0	13
53285	1718	9616630519070	27686	13681	8	0	13
53298	1718	10336652519070	28449	14059	5	0	13
53307	1718	11056652519070	29496	14544	3	0	13
53309	1718	11056664519070	29496	14544	4	0	13
53313	1718	11106829763340	19526	9837	3	0	\N
53314	1718	11106831763340	19238	9699	3	0	\N
53315	1718	11106841763340	19526	9837	4	0	\N
53318	1718	11776664519070	30233	14865	10	0	\N
53319	1718	11776664519070	30248	14873	11	0	\N
53320	1718	11776664519070	30286	14891	6	0	\N
53321	1718	11776679519070	30286	14891	7	0	\N
53322	1718	11776683519070	30233	14865	11	0	\N
53323	1718	11776684519070	30248	14873	12	0	\N
53325	1718	12237469000000	8787	4556	2	0	\N
53327	1718	12237489000000	8787	4556	3	0	\N
53328	1718	12957483889008	8793	4558	4	0	\N
53330	1718	12957523889008	8793	4558	5	0	\N
53332	1718	13577522889008	9187	4762	4	0	\N
53335	1718	13577562889008	9187	4762	5	0	\N
53338	1718	14297582889008	10413	5386	1	0	\N
53339	1718	15017572889008	10294	5326	5	0	\N
53341	1718	15017582889008	10413	5386	3	0	\N
53342	1718	15017632889008	10294	5326	6	0	\N
53344	1719	200000001	9384	4750	127	0	\N
53345	1719	200004800	20966	10546	4	1	\N
53346	1719	263999986	15258	7772	12	0	\N
53349	1719	719000000000	321	184	1	0	\N
53350	1719	719000000000	437	248	1	0	\N
53351	1719	719000000000	586	331	1	0	\N
53352	1719	719000000000	954	532	1	0	\N
53353	1719	719000000000	991	547	1	0	\N
53355	1719	719010000000	321	184	2	0	\N
53356	1719	719010000000	437	248	2	0	\N
53357	1719	719010000000	586	331	2	0	\N
53358	1719	719010000000	954	532	2	0	\N
53359	1719	719010000000	991	547	2	0	\N
53361	1719	720000000000	10460	5406	5	0	\N
53364	1719	720140000000	10460	5406	6	0	\N
53375	1719	2160061000000	20264	10206	7	0	\N
53376	1719	2160061000000	20455	10300	6	0	\N
53378	1719	2160085000000	20455	10300	7	0	\N
53380	1719	2160086000000	20264	10206	8	0	\N
53383	1719	2879110000000	2664	1400	1	0	\N
53385	1719	2879120000000	2664	1400	2	0	\N
53387	1719	2880085000000	20556	10348	4	0	\N
53388	1719	2880085000000	20557	10348	3	0	\N
53389	1719	2880085000000	20866	10489	2	0	\N
53390	1719	2880085000000	20966	10546	2	0	\N
53391	1719	2880085000000	20969	10546	2	0	\N
53392	1719	2880085000000	20970	10546	2	0	\N
53394	1719	2880096000000	20866	10489	3	0	\N
53395	1719	2880096000000	20970	10546	3	0	\N
53396	1719	2880097000000	20557	10348	4	0	\N
53397	1719	2880098000000	20556	10348	5	0	\N
53401	1719	3312042151064	20969	10546	3	0	\N
53405	1719	3600108000000	21437	10741	1	0	\N
53406	1719	3600109000000	21437	10741	2	0	\N
53408	1719	3620253000000	12235	6301	1	0	\N
53410	1719	3620254000000	12235	6301	2	0	\N
53412	1719	4319130000000	3577	1857	0	0	\N
53415	1719	4320109000000	21450	10742	11	0	\N
53418	1719	4320201000000	21450	10742	12	0	\N
53419	1719	4340264000000	12317	6347	1	0	\N
53420	1719	4340264000000	12409	6401	1	0	\N
53421	1719	4340264000000	12593	6492	4	0	\N
53422	1719	4340264000000	12858	6631	2	0	\N
53424	1719	4340265000000	12317	6347	2	0	\N
53425	1719	4340265000000	12409	6401	2	0	\N
53426	1719	4340275000000	12858	6631	3	0	\N
53428	1719	5039140000000	4235	2200	1	0	\N
53430	1719	5039150000000	4235	2200	2	0	\N
53432	1719	5040155000000	21780	10906	3	0	\N
53433	1719	5040155000000	21797	10912	6	0	\N
53434	1719	5040155000000	22829	11417	4	0	\N
53436	1719	5040167000000	21780	10906	4	0	\N
53437	1719	5040168000000	22829	11417	5	0	\N
53438	1719	5040179000000	21797	10912	7	0	\N
53440	1719	5040940000000	4825	2397	102	0	\N
53443	1719	5759160000000	4823	2499	2	0	\N
53445	1719	5759180000000	4823	2499	3	0	\N
53447	1719	5760205000000	23067	11517	6	0	\N
53367	1719	1439030000000	1991	1052	1	0	0
53368	1719	1439040000000	1991	1052	2	0	0
53373	1719	2159040000000	2502	1311	4	0	0
53374	1719	2159110000000	2502	1311	5	0	0
53384	1719	2879110000000	3089	1603	1	0	0
53402	1719	3599120000000	3306	1717	1	0	0
53403	1719	3599130000000	3306	1717	2	0	0
53413	1719	4319130000000	3900	2025	1	0	0
53414	1719	4319140000000	3900	2025	2	0	0
53429	1719	5039140000000	4543	2350	2	0	0
53444	1719	5759160000000	4832	2504	2	0	0
53446	1719	5759180000000	4832	2504	3	0	0
53316	1718	11517449000000	8486	4395	2	0	1
53317	1718	11517469000000	8486	4395	3	0	1
53326	1718	12237483889008	8784	4556	4	0	1
53329	1718	12957483889008	8934	4632	4	0	1
53331	1718	12957523889008	8934	4632	5	0	1
53333	1718	13577522889008	9474	4912	3	0	2
53334	1718	13577552889008	9474	4912	4	0	2
53337	1718	14297572889008	9979	5175	3	0	2
53347	1719	20000000000	10458	5406	5	0	5
53348	1719	20140000000	10458	5406	6	0	5
53340	1718	15017572889008	10753	5550	6	0	2
53343	1718	15017632889008	10753	5550	7	0	2
53366	1719	740240000000	11213	5759	11	0	5
53371	1719	1460240000000	11851	6092	2	0	5
53372	1719	1460251000000	11851	6092	3	0	5
53381	1719	2180251000000	12025	6189	1	0	5
53399	1719	2900252000000	12076	6218	1	0	5
53400	1719	2900253000000	12076	6218	2	0	5
53409	1719	3620253000000	12247	6307	2	0	5
53411	1719	3620264000000	12247	6307	3	0	5
53423	1719	4340264000000	12869	6636	9	0	5
53441	1719	5060309000000	12966	6687	2	0	5
53442	1719	5060320000000	12966	6687	3	0	5
53362	1719	720000000000	20153	10144	6	0	10
53363	1719	720024000000	20153	10144	7	0	10
53369	1719	1440024000000	20186	10165	10	0	10
53377	1719	2160061000000	20538	10337	6	0	10
53379	1719	2160085000000	20538	10337	7	0	10
53393	1719	2880085000000	21001	10561	5	0	10
53398	1719	2880108000000	21001	10561	6	0	10
53407	1719	3600133000000	21436	10751	8	0	10
53416	1719	4320133000000	21449	10760	4	0	10
53417	1719	4320155000000	21449	10760	5	0	10
53435	1719	5040155000000	22996	11488	14	0	10
53439	1719	5040205000000	22996	11488	15	0	10
53449	1719	5760229000000	23067	11517	7	0	\N
53451	1719	5760940000000	4825	2397	126	0	\N
53452	1719	5761170000000	4825	2397	127	0	\N
53453	1719	5780320000000	13339	6874	4	0	\N
53455	1719	5780333000000	13339	6874	5	0	\N
53461	1719	6481170000000	4833	2398	21	0	\N
53462	1719	6481380000000	4833	2398	22	0	\N
53463	1719	6500333000000	13783	7080	6	0	\N
53465	1719	6500333000000	13798	7085	4	0	\N
53466	1719	6500346000000	13798	7085	5	0	\N
53468	1719	6500357000000	13783	7080	7	0	\N
53470	1719	7200253000000	23189	11578	2	0	\N
53471	1719	7200253000000	23296	11624	2	0	\N
53473	1719	7200264000000	23189	11578	3	0	\N
53474	1719	7200264000000	23296	11624	3	0	\N
53476	1719	7220347000000	13895	7129	14	0	\N
53477	1719	7220347000000	14056	7196	4	0	\N
53478	1719	7220347000000	14057	7196	3	0	\N
53479	1719	7220347000000	14342	7321	7	0	\N
53480	1719	7220347000000	14639	7461	2	0	\N
53482	1719	7220349000000	14639	7461	3	0	\N
53483	1719	7220350000000	14057	7196	4	0	\N
53484	1719	7220360000000	14056	7196	5	0	\N
53486	1719	7220363000000	14342	7321	8	0	\N
53487	1719	7220379000000	13895	7129	15	0	\N
53488	1719	7919190000000	5565	2894	0	0	\N
53489	1719	7919190000000	5598	2909	0	0	\N
53490	1719	7919190000000	5642	2929	0	0	\N
53492	1719	7920276000000	23482	11709	3	0	\N
53494	1719	7920288000000	23482	11709	4	0	\N
53505	1719	8660427000000	15257	7772	9	0	\N
53506	1719	8660427000000	15258	7772	9	0	\N
53507	1719	9260664124170	26586	13153	9	0	\N
53513	1719	9380427000000	15257	7772	11	0	\N
53514	1719	9380427000000	15258	7772	11	0	\N
53516	1719	9380428000000	15257	7772	12	0	\N
53521	1719	10100428000000	15293	7794	3	0	\N
53523	1719	10100440000000	15293	7794	4	0	\N
53525	1719	10799230000000	7043	3635	4	0	\N
53528	1719	10799270000000	7043	3635	5	0	\N
53531	1719	10820441000000	15810	8048	0	0	\N
53532	1719	10820441000000	15814	8048	14	0	\N
53533	1719	10820441000000	15816	8048	11	0	\N
53534	1719	10820441000000	16010	8142	4	0	\N
53536	1719	10820454000000	16010	8142	5	0	\N
53538	1719	10820515000000	15816	8048	12	0	\N
53539	1719	10820518000000	15814	8048	15	0	\N
53542	1719	11520387000000	23799	11846	4	0	\N
53544	1719	11520409000000	23799	11846	5	0	\N
53547	1719	11540497000000	16591	8431	2	0	\N
53548	1719	11540537000000	16591	8431	3	0	\N
53552	1719	12239250000000	7397	3821	1	0	\N
53553	1719	12239250000000	7694	3987	1	0	\N
53554	1719	12239250000000	7860	4075	1	0	\N
53556	1719	12239260000000	7397	3821	2	0	\N
53557	1719	12239260000000	7694	3987	2	0	\N
53558	1719	12239260000000	7860	4075	2	0	\N
53560	1719	12240435000000	23921	11905	3	0	\N
53561	1719	12240435000000	24024	11955	6	0	\N
53562	1719	12240447000000	23921	11905	4	0	\N
53563	1719	12240477000000	24024	11955	7	0	\N
53565	1719	12260549000000	16603	8436	3	0	\N
53567	1719	12260561000000	16603	8436	4	0	\N
53572	1719	12980550000000	16919	8577	4	0	\N
53575	1719	12980563000000	16919	8577	5	0	\N
53576	1719	13678581000000	24189	12041	2	0	\N
53577	1719	13678581000000	24357	12113	3	0	\N
53579	1719	13678592000000	24189	12041	3	0	\N
53580	1719	13678593000000	24357	12113	4	0	\N
53582	1719	13679270000000	8240	4269	1	0	\N
53583	1719	13679270000000	8296	4295	2	0	\N
53469	1719	7199190000000	5557	2890	0	0	0
53491	1719	7919190000000	5643	2929	0	0	0
53498	1719	8639190000000	5944	3080	1	0	0
53499	1719	8639200000000	5944	3080	2	0	0
53508	1719	9359200000000	6301	3262	1	0	0
53517	1719	10079210000000	6966	3594	2	0	0
53518	1719	10079230000000	6966	3594	3	0	0
53526	1719	10799230000000	7171	3703	1	0	0
53527	1719	10799240000000	7171	3703	2	0	0
53540	1719	11519240000000	7184	3712	1	0	0
53555	1719	12239250000000	7879	4083	1	0	0
53559	1719	12239260000000	7879	4083	2	0	0
53570	1719	12959260000000	7951	4119	1	0	0
53571	1719	12959270000000	7951	4119	2	0	0
53454	1719	5780320000000	13427	6918	4	0	5
53456	1719	5780333000000	13427	6918	5	0	5
53464	1719	6500333000000	13796	7085	5	0	5
53467	1719	6500347000000	13796	7085	6	0	5
53481	1719	7220347000000	14911	7597	4	0	5
53496	1719	7940360000000	14939	7610	2	0	5
53497	1719	7940371000000	14939	7610	3	0	5
53502	1719	8660371000000	15186	7737	2	0	5
53503	1719	8660382000000	15186	7737	3	0	5
53504	1719	8660427000000	15256	7772	9	0	5
53515	1719	9380428000000	15256	7772	12	0	5
53522	1719	10100428000000	15664	7974	4	0	5
53524	1719	10100441000000	15664	7974	5	0	5
53535	1719	10820441000000	16208	8236	11	0	5
53546	1719	11540497000000	16590	8431	5	0	5
53549	1719	11540549000000	16590	8431	6	0	5
53564	1719	12260549000000	16602	8436	1	0	5
53566	1719	12260550000000	16602	8436	2	0	5
53573	1719	12980550000000	17060	8641	3	0	5
53450	1719	5760230000000	23139	11555	8	0	10
53459	1719	6480230000000	23162	11566	5	0	10
53460	1719	6480253000000	23162	11566	6	0	10
53472	1719	7200253000000	23313	11634	5	0	10
53475	1719	7200276000000	23313	11634	6	0	10
53495	1719	7920288000000	23525	11726	4	0	10
53500	1719	8640288000000	23612	11763	10	0	10
53501	1719	8640325000000	23612	11763	11	0	10
53510	1719	9360325000000	23620	11767	4	0	10
53519	1719	10080338000000	23628	11771	3	0	10
53520	1719	10080350000000	23628	11771	4	0	10
53529	1719	10800350000000	23730	11820	10	0	10
53530	1719	10800387000000	23730	11820	11	0	10
53543	1719	11520387000000	23915	11901	12	0	10
53550	1719	12238528000000	24023	11955	6	0	10
53551	1719	12238570000000	24023	11955	7	0	10
53568	1719	12958570000000	24059	11973	2	0	10
53569	1719	12958581000000	24059	11973	3	0	10
53578	1719	13678581000000	24540	12201	9	0	10
53585	1719	13679280000000	8240	4269	2	0	\N
53587	1719	13679290000000	8296	4295	3	0	\N
53590	1719	14398626000000	24778	12303	6	0	\N
53593	1719	14398650000000	24778	12303	7	0	\N
53596	1719	14420584000000	17366	8796	5	0	\N
53597	1719	14420584000000	17604	8904	5	0	\N
53598	1719	14420584000000	17605	8904	9	0	\N
53601	1719	14420607000000	17366	8796	6	0	\N
53602	1719	14420616000000	17604	8904	6	0	\N
53603	1719	14420620000000	17605	8904	10	0	\N
53604	1719	15118638000000	25644	12691	6	0	\N
53605	1719	15118638000000	26051	12874	10	0	\N
53608	1719	15118662000000	25644	12691	7	0	\N
53609	1719	15118729000000	26051	12874	11	0	\N
53614	1719	15838649000000	26282	12999	7	0	\N
53615	1719	15838649000000	26445	13075	0	0	\N
53616	1719	15838649000000	26448	13082	4	0	\N
53617	1719	15838649000000	26449	13082	2	0	\N
53619	1719	15838651000000	26449	13082	3	0	\N
53620	1719	15838662000000	26448	13082	5	0	\N
53622	1719	15838683000000	26282	12999	8	0	\N
53623	1719	15838697000000	26581	13153	6	0	\N
53624	1719	15838697000000	26585	13153	6	0	\N
53625	1719	15838697000000	26586	13153	6	0	\N
53628	1719	15839380000000	9253	4799	6	0	\N
53629	1719	15839750000000	9252	4749	43	0	\N
53630	1719	15860608000000	17662	8929	4	0	\N
53631	1719	15860608000000	18000	9081	5	0	\N
53633	1719	15860630000000	17662	8929	5	0	\N
53634	1719	15860631000000	18000	9081	6	0	\N
53636	1719	16558649000000	26461	13076	0	0	\N
53637	1719	16558673000000	26961	13334	7	0	\N
53640	1719	16558696900000	26581	13153	8	0	\N
53641	1719	16558697000000	26585	13153	8	0	\N
53642	1719	16558697000000	26586	13153	8	0	\N
53643	1719	16558698000000	26585	13153	9	0	\N
53644	1719	16558699000000	26961	13334	8	0	\N
53645	1719	16559320000000	9143	4737	5	0	\N
53648	1719	16559370000000	9143	4737	6	0	\N
53649	1719	16559380000000	9253	4799	25	0	\N
53650	1719	16559560000000	9253	4799	26	0	\N
53651	1719	16559750000000	9252	4749	126	0	\N
53652	1719	16560570000000	9252	4749	127	0	\N
53653	1719	16561090000000	9384	4750	43	0	\N
53654	1719	16580663000000	18450	9300	3	0	\N
53655	1719	16580663000000	18453	9265	118	0	\N
53657	1719	16580663000000	18563	9355	5	0	\N
53658	1719	16580675000000	18450	9300	4	0	\N
53660	1719	16580686000000	18563	9355	6	0	\N
53661	1719	16581177000000	18453	9265	119	0	\N
53664	1719	17279360000000	9639	5002	2	0	\N
53665	1719	17279360000000	9717	5038	6	0	\N
53666	1719	17279380000000	9639	5002	3	0	\N
53667	1719	17279411000000	9717	5038	7	0	\N
53668	1719	17281090000000	9384	4750	126	0	\N
53669	1719	17300683000000	18564	9356	3	0	\N
53671	1719	17300794000000	18564	9356	4	0	\N
53685	1719	19461920000000	19715	9824	109	0	\N
53686	1719	20158764000000	27727	13698	4	0	\N
53687	1719	20158764000000	27879	13783	3	0	\N
53690	1719	20158776000000	27879	13783	4	0	\N
53691	1719	20158786000000	27727	13698	5	0	\N
53692	1719	20180830000000	19092	9631	3	0	\N
53693	1719	20180830000000	19297	9729	3	0	\N
53694	1719	20180830000000	19327	9746	11	0	\N
53695	1719	20180830000000	19713	9925	2	0	\N
53697	1719	20180841000000	19713	9925	3	0	\N
53698	1719	20180842000000	19092	9631	4	0	\N
53699	1719	20180842000000	19297	9729	4	0	\N
53702	1719	20180967000000	19327	9746	12	0	\N
53703	1719	20181920000000	19715	9824	126	0	\N
53704	1719	20182080000000	19715	9824	127	0	\N
53705	1719	20878774000000	28656	14148	6	0	\N
53708	1719	20878807000000	28656	14148	7	0	\N
53710	1719	21598786000000	29121	14357	4	0	\N
53711	1719	21598786000000	29404	14498	5	0	\N
53712	1719	21598786000000	29405	14490	33	0	\N
53714	1719	21598799000000	29121	14357	5	0	\N
53716	1719	21598809000000	29404	14498	6	0	\N
53717	1719	21598909000000	29405	14490	34	0	\N
53595	1719	14399290000000	8480	4393	2	0	0
53610	1719	15119290000000	8577	4446	1	0	0
53611	1719	15119300000000	8577	4446	2	0	0
53626	1719	15839300000000	8920	4622	2	0	0
53627	1719	15839320000000	8920	4622	3	0	0
53647	1719	16559360000000	9595	4977	5	0	0
53588	1719	13700562000000	17102	8665	4	0	5
53589	1719	13700584000000	17102	8665	5	0	5
53599	1719	14420584000000	17613	8908	3	0	5
53600	1719	14420596000000	17613	8908	4	0	5
53613	1719	15140608000000	17633	8915	4	0	5
53632	1719	15860608000000	18211	9175	10	0	5
53635	1719	15860663000000	18211	9175	11	0	5
53656	1719	16580663000000	18562	9355	2	0	5
53670	1719	17300683000000	18565	9356	7	0	5
53672	1719	17300798000000	18565	9356	8	0	5
53675	1719	18020798000000	18777	9463	3	0	5
53676	1719	18020810000000	18777	9463	4	0	5
53679	1719	18740810000000	18872	9517	1	0	5
53683	1719	19460820000000	18984	9574	1	0	5
53684	1719	19460830000000	18984	9574	2	0	5
53696	1719	20180830000000	19714	9925	3	0	5
53700	1719	20180842000000	19714	9925	4	0	5
53701	1719	20180867000000	19945	10042	7	0	5
53718	1719	21620867000000	20031	10083	4	0	5
53719	1719	21620880000000	20031	10083	5	0	5
53591	1719	14398626000000	25546	12648	3	0	10
53592	1719	14398638000000	25546	12648	4	0	10
53607	1719	15118649000000	26052	12874	3	0	10
53618	1719	15838649000000	26462	13089	6	0	10
53621	1719	15838673000000	26462	13089	7	0	10
53638	1719	16558673000000	27129	13416	3	0	10
53639	1719	16558685000000	27129	13416	4	0	10
53663	1719	17278697000000	27252	13474	4	0	10
53673	1719	17998697000000	27290	13488	2	0	10
53674	1719	17998708000000	27290	13488	3	0	10
53677	1719	18718708000000	27337	13514	3	0	10
53678	1719	18718720000000	27337	13514	4	0	10
53682	1719	19438764000000	27617	13649	18	0	10
53688	1719	20158764000000	28650	14144	1	0	10
53689	1719	20158774000000	28650	14144	2	0	10
53706	1719	20878774000000	29016	14308	3	0	10
53713	1719	21598786000000	29924	14741	8	0	10
53715	1719	21598803000000	29924	14741	9	0	10
53720	1719	22318803000000	29984	14765	19	0	10
53728	1719	23758954000000	30211	14858	19	0	\N
53729	1719	23758954000000	30213	14858	19	0	\N
53731	1719	24478908000000	30138	14830	14	0	\N
53732	1719	24478908000000	30139	14830	12	0	\N
53733	1719	24478929000000	30139	14830	13	0	\N
53734	1719	24478931000000	30138	14830	15	0	\N
53735	1719	24478954000000	30211	14858	33	0	\N
53736	1719	24478954000000	30213	14858	34	0	\N
53738	1719	24478965624587	30211	14858	37	1	\N
53739	1719	24478966624587	30213	14858	38	1	\N
53741	1719	66000004950000	12593	6492	5	1	\N
53742	1721	94222222	2655	1267	88	0	\N
53743	1722	88000000	5978	3102	1	0	\N
53746	1722	720088000000	5978	3102	2	0	\N
53748	1722	1440070000000	3691	1916	1	0	\N
53750	1722	1440080000000	3691	1916	2	0	\N
53752	1722	1440088000000	6048	3142	1	0	\N
53754	1722	1440098000000	6048	3142	2	0	\N
53756	1722	2873990000000	421	240	3	0	\N
53757	1722	2873990000000	604	342	1	0	\N
53759	1722	2873990000000	621	338	0	0	\N
53760	1722	2874000000000	604	342	2	0	\N
53762	1722	2874020000000	421	240	4	0	\N
53763	1722	3594000000000	620	349	0	0	\N
53776	1722	6493081000000	1518	831	1	0	\N
53778	1722	6493091000000	1518	831	2	0	\N
53780	1722	6493351000000	1793	914	26	0	\N
53781	1722	7194090000000	1245	690	1	0	\N
53782	1722	7194100000000	1245	690	2	0	\N
53785	1722	7213091000000	1780	953	1	0	\N
53787	1722	7213091000000	1795	959	1	0	\N
53788	1722	7213101000000	1780	953	2	0	\N
53789	1722	7213101000000	1795	959	2	0	\N
53790	1722	7213301000000	1793	914	27	0	\N
53791	1722	7933091000000	1822	975	0	0	\N
53792	1722	7933091000000	1825	975	1	0	\N
53794	1722	7933101000000	1825	975	2	0	\N
53796	1722	7933251000000	1823	915	0	0	\N
53803	1722	10813141000000	2066	1092	1	0	\N
53805	1722	10813151000000	2066	1092	2	0	\N
53807	1722	11533161000000	2234	1178	2	0	\N
53808	1722	11533161000000	2250	1183	0	0	\N
53809	1722	11533161000000	2272	1193	2	0	\N
53810	1722	11533161000000	2276	1193	1	0	\N
53811	1722	11533161000000	2489	1304	1	0	\N
53812	1722	11533161000000	2516	1321	1	0	\N
53813	1722	11533161000000	2618	1378	1	0	\N
53814	1722	11533161000000	2620	1378	0	0	\N
53815	1722	11533161000000	2635	1386	1	0	\N
53816	1722	11533161000000	2663	1399	2	0	\N
53817	1722	11533161000000	2670	1402	2	0	\N
53819	1722	11533171000000	2276	1193	2	0	\N
53820	1722	11533171000000	2489	1304	2	0	\N
53821	1722	11533171000000	2516	1321	2	0	\N
53822	1722	11533171000000	2618	1378	2	0	\N
53823	1722	11533171000000	2635	1386	2	0	\N
53825	1722	11533181000000	2272	1193	3	0	\N
53826	1722	11533181000000	2663	1399	3	0	\N
53827	1722	11533181000000	2670	1402	3	0	\N
53828	1722	11533271000000	2234	1178	3	0	\N
53833	1722	13693191000000	2942	1529	1	0	\N
53834	1722	13693191000000	3007	1561	0	0	\N
53835	1722	13693191000000	3033	1575	1	0	\N
53837	1722	13693201000000	2942	1529	2	0	\N
53838	1722	13693201000000	3033	1575	2	0	\N
53840	1722	14413201000000	3428	1780	3	0	\N
53841	1722	14413231000000	3428	1780	4	0	\N
53842	1723	200000001	11493	5904	9	0	\N
53847	1723	2159030000000	738	414	1	0	\N
53849	1723	2159040000000	738	414	2	0	\N
53853	1723	2879050000000	768	427	1	0	\N
53855	1723	2879060000000	768	427	2	0	\N
53845	1723	1439010000000	406	230	2	0	0
53846	1723	1439030000000	406	230	3	0	0
53758	1722	2873990000000	619	348	1	0	1
53761	1722	2874000000000	619	348	2	0	1
53764	1722	3594000000000	622	349	2	0	1
53766	1722	4314020000000	706	394	1	0	1
53767	1722	4314030000000	706	394	2	0	1
53848	1723	2159030000000	743	417	2	0	0
53850	1723	2159050000000	743	417	3	0	0
53768	1722	5034030000000	806	446	3	0	1
53770	1722	5754060000000	839	463	2	0	1
53771	1722	5754080000000	839	463	3	0	1
53854	1723	2879050000000	845	466	1	0	0
53856	1723	2879060000000	845	466	2	0	0
53773	1722	6474090000000	924	515	2	0	1
53774	1722	6476080000000	1435	781	1	0	2
53775	1722	6476090000000	1435	781	2	0	2
53783	1722	7196090000000	1486	811	2	0	2
53784	1722	7196101000000	1486	811	3	0	2
53779	1722	6493091000000	1695	912	2	0	4
53786	1722	7213091000000	1794	959	0	0	4
53793	1722	7933091000000	1961	1038	2	0	4
53795	1722	7933111000000	1961	1038	3	0	4
53797	1722	8653111000000	1964	1039	1	0	4
53799	1722	9373121000000	2020	1065	1	0	4
53800	1722	9373131000000	2020	1065	2	0	4
53801	1722	10093131000000	2047	1081	1	0	4
53802	1722	10093141000000	2047	1081	2	0	4
53806	1722	10813161000000	2115	1115	3	0	4
53818	1722	11533161000000	2708	1422	1	0	4
53824	1722	11533171000000	2708	1422	2	0	4
53829	1722	12253171000000	2740	1438	1	0	4
53830	1722	12253181000000	2740	1438	2	0	4
53832	1722	12973191000000	2785	1458	2	0	4
53836	1722	13693191000000	3189	1655	1	0	4
53839	1722	13693201000000	3189	1655	2	0	4
53745	1722	720070000000	3656	1898	0	0	8
53749	1722	1440070000000	3713	1928	1	0	8
53744	1722	88000000	5979	3102	1	0	10
53747	1722	720088000000	5979	3102	2	0	10
53753	1722	1440088000000	6951	3587	3	0	10
53755	1722	1440118000000	6951	3587	4	0	10
53852	1723	2518937085979	10947	5642	2	0	6
53722	1719	22340880000000	20069	10102	4	0	5
53723	1719	22340893000000	20069	10102	5	0	5
53721	1719	22318840000000	29984	14765	20	0	10
53724	1719	23038840000000	30038	14789	10	0	10
53726	1719	23758859000000	30040	14790	22	0	10
53727	1719	23758908000000	30040	14790	23	0	10
53730	1719	23758954000000	30214	14858	19	0	10
53737	1719	24478954000000	30214	14858	34	0	10
53740	1719	24478966624587	30214	14858	38	1	10
53857	1723	3238937085979	10983	5658	2	0	\N
53859	1723	3238957085979	10983	5658	3	0	\N
53861	1723	3599060000000	860	477	4	0	\N
53864	1723	3599290000000	860	477	5	0	\N
53873	1723	4679090085979	11493	5904	2	0	\N
53874	1723	5039080000000	1078	598	3	0	\N
53877	1723	5039110000000	1078	598	4	0	\N
53878	1723	5041644085979	22516	11262	4	0	\N
53881	1723	5041657085979	22516	11262	5	0	\N
53882	1723	5399069085979	11613	5928	73	0	\N
53885	1723	5399090085979	11493	5904	8	0	\N
53886	1723	5399205085979	11613	5928	74	0	\N
53887	1723	5399499085979	11773	5929	51	0	\N
53892	1723	6119070085979	12082	6222	2	0	\N
53893	1723	6119070085979	12344	6362	4	0	\N
53894	1723	6119070085979	12455	6418	0	0	\N
53896	1723	6119072085979	12082	6222	3	0	\N
53898	1723	6119499085979	11773	5929	125	0	\N
53899	1723	6119573085979	12344	6362	5	0	\N
53900	1723	6119581085979	11773	5929	126	0	\N
53915	1723	7921681085979	24128	12010	2	0	\N
53917	1723	7921692085979	24128	12010	3	0	\N
53921	1723	8639150000000	2707	1422	1	0	\N
53923	1723	8639160000000	2707	1422	2	0	\N
53929	1723	9359160000000	3277	1702	4	0	\N
53930	1723	9359160000000	3442	1787	0	0	\N
53932	1723	9359200000000	3277	1702	5	0	\N
53939	1723	10082045085979	24804	12318	6	0	\N
53942	1723	10082087085979	24804	12318	7	0	\N
53945	1723	10799190000000	3742	1940	1	0	\N
53946	1723	10799190000000	3872	2010	1	0	\N
53947	1723	10799190000000	4050	2103	1	0	\N
53949	1723	10799200000000	3742	1940	2	0	\N
53950	1723	10799200000000	3872	2010	2	0	\N
53951	1723	10799200000000	4050	2103	2	0	\N
53961	1723	11522104085979	26080	12889	1	0	\N
53964	1723	12239810000000	4905	2539	1	0	\N
53966	1723	12239820000000	4905	2539	2	0	\N
53968	1723	12242094085979	25567	12657	9	0	\N
53969	1723	12242094085979	25988	12843	2	0	\N
53970	1723	12242094085979	26022	12861	2	0	\N
53971	1723	12242094085979	26189	12946	4	0	\N
53973	1723	12242104085979	26080	12889	3	0	\N
53974	1723	12242105085979	25988	12843	3	0	\N
53975	1723	12242105085979	26022	12861	3	0	\N
53976	1723	12242105085979	26080	12889	4	0	\N
53977	1723	12242107085979	26189	12946	5	0	\N
53979	1723	12242130085979	25567	12657	10	0	\N
53982	1723	12959820000000	5700	2955	1	0	\N
53983	1723	12959820000000	5769	2992	1	0	\N
53984	1723	12959820000000	5963	3093	1	0	\N
53985	1723	12959820000000	5988	3106	1	0	\N
53987	1723	12959830000000	5700	2955	2	0	\N
53988	1723	12959830000000	5769	2992	2	0	\N
53989	1723	12959830000000	5963	3093	2	0	\N
53990	1723	12959830000000	5988	3106	2	0	\N
53867	1723	4319070000000	1033	573	1	0	0
53868	1723	4319080000000	1033	573	2	0	0
53875	1723	5039080000000	1249	691	1	0	0
53876	1723	5039090000000	1249	691	2	0	0
53888	1723	5759090000000	1911	1017	3	0	0
53901	1723	6479120000000	2127	1122	1	0	0
53902	1723	6479130000000	2127	1122	2	0	0
53907	1723	7199130000000	2566	1352	1	0	0
53908	1723	7199140000000	2566	1352	2	0	0
53913	1723	7919140000000	2685	1411	1	0	0
53922	1723	8639150000000	2976	1548	1	0	0
53924	1723	8639160000000	2976	1548	2	0	0
53931	1723	9359160000000	3554	1844	0	0	0
53937	1723	10079160000000	3685	1914	3	0	0
53948	1723	10799190000000	4457	2309	1	0	0
53952	1723	10799200000000	4457	2309	2	0	0
53957	1723	11519200000000	4799	2483	7	0	0
53958	1723	11519810000000	4799	2483	8	0	0
53965	1723	12239810000000	5333	2768	1	0	0
53986	1723	12959820000000	6368	3297	1	0	0
53991	1723	12959830000000	6368	3297	2	0	0
53858	1723	3238937085979	11028	5676	10	0	6
53860	1723	3239037085979	11028	5676	11	0	6
53865	1723	3959037085979	11302	5804	1	0	6
53871	1723	4679047085979	11365	5837	4	0	6
53872	1723	4679069085979	11365	5837	5	0	6
53883	1723	5399069085979	12038	6197	1	0	6
53884	1723	5399070085979	12038	6197	2	0	6
53897	1723	6119114085979	12585	6487	9	0	6
53905	1723	6839114085979	12865	6633	7	0	6
53906	1723	6839157085979	12865	6633	8	0	6
53911	1723	7559157085979	12986	6695	2	0	6
53912	1723	7559168085979	12986	6695	3	0	6
53920	1723	8279192085979	13256	6828	7	0	6
53927	1723	8999192085979	13604	6994	27	0	6
53928	1723	8999282085979	13604	6994	28	0	6
53935	1723	9719282085979	13717	7050	7	0	6
53936	1723	9719307085979	13717	7050	8	0	6
53944	1723	10439326085979	13864	7115	11	0	6
53955	1723	11159326085979	14017	7184	1	0	6
53956	1723	11159336085979	14017	7184	2	0	6
53962	1723	11879336085979	14206	7250	9	0	6
53980	1723	12599354085979	14522	7406	3	0	6
53981	1723	12599366085979	14522	7406	4	0	6
53869	1723	4321572085979	22479	11247	9	0	12
53870	1723	4321644085979	22479	11247	10	0	12
53879	1723	5041644085979	22649	11325	3	0	12
53890	1723	5761656085979	23647	11780	3	0	12
53891	1723	5761668085979	23647	11780	4	0	12
53903	1723	6481668085979	23846	11869	3	0	12
53904	1723	6481680085979	23846	11869	4	0	12
53909	1723	7201680085979	23907	11897	1	0	12
53916	1723	7921681085979	24608	12232	3	0	12
53918	1723	7921693085979	24608	12232	4	0	12
53925	1723	8641693085979	24628	12238	10	0	12
53926	1723	8641820085979	24628	12238	11	0	12
53934	1723	9362045085979	24655	12246	10	0	12
53940	1723	10082045085979	24834	12330	7	0	12
53941	1723	10082070085979	24834	12330	8	0	12
53953	1723	10802070085979	24920	12372	3	0	12
53954	1723	10802082085979	24920	12372	4	0	12
53960	1723	11522094085979	24976	12395	4	0	12
53972	1723	12242094085979	26531	13126	4	0	12
53978	1723	12242107085979	26531	13126	5	0	12
53992	1723	12962107085979	26833	13269	3	0	12
53996	1723	13679830000000	6732	3484	4	0	\N
53998	1723	13679870000000	6732	3484	5	0	\N
54002	1723	14039402085979	14803	7543	2	0	\N
54005	1723	14039413085979	14803	7543	3	0	\N
54006	1723	14400050000000	6888	3558	2	0	\N
54007	1723	14400050000000	7020	3619	4	0	\N
54010	1723	14400070000000	6888	3558	3	0	\N
54011	1723	14400090000000	7020	3619	5	0	\N
54012	1723	14402131085979	27619	13651	3	0	\N
54014	1723	14402143085979	27619	13651	4	0	\N
54020	1723	15122167085979	28220	13953	2	0	\N
54022	1723	15122178085979	28220	13953	3	0	\N
54024	1723	15479423085979	15409	7849	4	0	\N
54026	1723	15479454085979	15409	7849	5	0	\N
54028	1723	15840070000000	8009	4151	1	0	\N
54030	1723	15840080000000	8009	4151	2	0	\N
54034	1723	16199468085979	15640	7959	3	0	\N
54035	1723	16199468085979	15931	8099	9	0	\N
54037	1723	16199480085979	15640	7959	4	0	\N
54039	1723	16199504085979	15931	8099	10	0	\N
54040	1723	16560081000000	8446	4375	0	0	\N
54050	1723	17282231085979	29361	14470	3	0	\N
54052	1723	17282243085979	29361	14470	4	0	\N
54054	1723	17639492085979	16404	8344	3	0	\N
54056	1723	17639504085979	16404	8344	4	0	\N
54062	1723	18359504085979	17671	8933	2	0	\N
54064	1723	18359515085979	17671	8933	3	0	\N
54068	1723	18722270085979	29945	14748	8	0	\N
54070	1723	18722270085979	30004	14774	8	0	\N
54071	1723	18722287085979	29945	14748	9	0	\N
54072	1723	18722287085979	30004	14774	9	0	\N
54079	1723	19442288085979	30047	14792	20	0	\N
54081	1723	19442326085979	30047	14792	21	0	\N
54086	1723	20519538085979	19032	9597	1	0	\N
54087	1723	20519538085979	19086	9627	8	0	\N
54089	1723	20519548085979	19032	9597	2	0	\N
54091	1723	20519600085979	19086	9627	9	0	\N
54092	1723	20880400999760	9449	4900	2	0	\N
54094	1723	20880420999760	9449	4900	3	0	\N
54100	1723	21959573085979	20312	10230	3	0	\N
54101	1723	21959573085979	20714	10416	3	0	\N
54102	1723	21959573085979	21461	10768	3	0	\N
54104	1723	21959585085979	20312	10230	4	0	\N
54105	1723	21959585085979	20714	10416	4	0	\N
54106	1723	21959585085979	21461	10768	4	0	\N
54116	1724	200000	6702	3402	127	1	\N
54123	1724	2158550000000	1347	740	1	0	\N
54124	1724	2158550000000	1349	740	1	0	\N
54125	1724	2158550000000	1350	740	1	0	\N
54126	1724	2829261000000	10871	5609	0	0	\N
54127	1724	2829261000000	10873	5610	2	0	\N
54119	1724	1438510000000	838	462	2	0	2
54120	1724	1438530000000	838	462	3	0	2
54121	1724	2158530000000	1011	559	1	0	2
54122	1724	2158540000000	1011	559	2	0	2
53997	1723	13679830000000	6813	3527	4	0	0
54008	1723	14400050000000	7699	3989	1	0	0
54009	1723	14400060000000	7699	3989	2	0	0
54018	1723	15120060000000	7714	3996	1	0	0
54019	1723	15120070000000	7714	3996	2	0	0
54029	1723	15840070000000	8255	4274	2	0	0
54041	1723	16560081000000	8719	4521	4	0	0
54042	1723	16560121000000	8719	4521	5	0	0
54047	1723	17280121000000	9161	4747	8	0	0
54048	1723	17280201000000	9161	4747	9	0	0
54058	1723	18000240999990	9179	4757	7	0	0
54059	1723	18000260999760	9179	4757	8	1	0
54066	1723	18720260999760	9260	4802	8	0	0
54067	1723	18720340999760	9260	4802	9	0	0
54076	1723	19440340999760	9387	4869	2	0	0
54084	1723	20160360999760	9426	4891	4	0	0
54085	1723	20160400999760	9426	4891	5	0	0
54093	1723	20880400999760	9708	5035	3	0	0
54095	1723	20880430999760	9708	5035	4	0	0
54098	1723	21600430999760	9711	5036	1	0	0
54108	1723	22320440999760	10120	5250	3	0	0
54109	1723	22320470999760	10120	5250	4	0	0
54128	1724	2829261000000	11201	5752	2	0	7
53994	1723	13319366085979	14617	7452	9	0	6
54003	1723	14039402085979	14922	7603	1	0	6
54004	1723	14039412085979	14922	7603	2	0	6
54016	1723	14759412085979	15086	7686	2	0	6
54017	1723	14759423085979	15086	7686	3	0	6
54025	1723	15479423085979	15546	7913	9	0	6
54036	1723	16199468085979	16006	8140	3	0	6
54038	1723	16199480085979	16006	8140	4	0	6
54045	1723	16919480085979	16241	8255	3	0	6
54046	1723	16919492085979	16241	8255	4	0	6
54055	1723	17639492085979	17051	8636	3	0	6
54063	1723	18359504085979	17677	8935	2	0	6
54065	1723	18359515085979	17677	8935	3	0	6
54074	1723	19079515085979	18503	9320	4	0	6
54075	1723	19079528085979	18503	9320	5	0	6
54083	1723	19799538085979	18847	9502	2	0	6
54088	1723	20519538085979	19209	9691	3	0	6
54090	1723	20519550085979	19209	9691	4	0	6
54096	1723	21239550085979	20217	10181	5	0	6
54097	1723	21239573085979	20217	10181	6	0	6
54107	1723	21959586085979	21520	10796	5	0	6
54110	1723	22679586085979	21633	10838	4	0	6
54111	1723	22679608085979	21633	10838	5	0	6
54112	1723	23399608085979	21699	10869	3	0	6
54113	1723	23399620085979	21699	10869	4	0	6
54115	1723	24119632085979	21902	10959	4	0	6
53993	1723	12962119085979	26833	13269	4	0	12
54000	1723	13682119085979	27409	13554	3	0	12
54001	1723	13682131085979	27409	13554	4	0	12
54015	1723	14402167085979	28018	13858	10	0	12
54021	1723	15122167085979	28312	13997	2	0	12
54023	1723	15122178085979	28312	13997	3	0	12
54032	1723	15842178085979	28349	14014	4	0	12
54033	1723	15842200085979	28349	14014	5	0	12
54044	1723	16562231085979	29261	14422	5	0	12
54051	1723	17282231085979	29551	14570	8	0	12
54053	1723	17282257085979	29551	14570	9	0	12
54060	1723	18002257085979	29645	14619	4	0	12
54061	1723	18002270085979	29645	14619	5	0	12
54073	1723	18722288085979	30003	14774	10	0	12
54078	1723	19442288085978	30065	14802	9	0	12
54080	1723	19442306085766	30065	14802	10	1	12
54129	1724	2829281000000	10873	5610	3	0	\N
54131	1724	2878540000000	1300	716	4	0	\N
54133	1724	2878550000000	1347	740	2	0	\N
54134	1724	2878550000000	1349	740	2	0	\N
54135	1724	2878550000000	1350	740	2	0	\N
54136	1724	2878580000000	1300	716	5	0	\N
54142	1724	3600070000000	1975	892	127	1	\N
54143	1724	4269292000000	11735	6031	7	0	\N
54144	1724	4269292000000	11786	6058	0	0	\N
54145	1724	4269292000000	11788	6058	2	0	\N
54146	1724	4269292000000	11813	6070	1	0	\N
54147	1724	4269292000000	11948	6152	2	0	\N
54149	1724	4269293000000	11813	6070	2	0	\N
54150	1724	4269294000000	11788	6058	3	0	\N
54151	1724	4269294000000	11948	6152	3	0	\N
54152	1724	4269335000000	11735	6031	8	0	\N
54157	1724	5038680000000	1523	833	2	0	\N
54158	1724	5038680000000	1664	888	13	0	\N
54159	1724	5038680000000	1665	895	2	0	\N
54160	1724	5038680000000	1700	913	0	0	\N
54161	1724	5038680000000	1703	916	1	0	\N
54163	1724	5038680000000	2151	855	0	0	\N
54164	1724	5038690000000	1703	916	2	0	\N
54165	1724	5038700000000	1523	833	3	0	\N
54166	1724	5038700000000	1665	895	3	0	\N
54167	1724	5038810000000	1664	888	14	0	\N
54169	1724	5709294000000	12207	6289	0	0	\N
54171	1724	5758680000000	1719	923	1	0	\N
54173	1724	5758690000000	1719	923	2	0	\N
54175	1724	5758810000000	1701	889	31	0	\N
54176	1724	5759120000000	1701	889	32	0	\N
54177	1724	6429295000000	12233	6301	1	0	\N
54178	1724	6429295000000	12236	6301	0	0	\N
54179	1724	6429295000000	12387	6390	1	0	\N
54180	1724	6429295000000	12768	6584	2	0	\N
54181	1724	6429295000000	12774	6586	2	0	\N
54182	1724	6429295000000	13084	6741	4	0	\N
54183	1724	6429295000000	13347	6880	5	0	\N
54184	1724	6429295000000	13477	6941	7	0	\N
54186	1724	6429296000000	12233	6301	2	0	\N
54187	1724	6429296000000	12387	6390	2	0	\N
54188	1724	6429306000000	12768	6584	3	0	\N
54189	1724	6429306000000	12774	6586	3	0	\N
54190	1724	6429308000000	13084	6741	5	0	\N
54192	1724	6429309000000	13347	6880	6	0	\N
54193	1724	6429311000000	13477	6941	8	0	\N
54194	1724	6429318000000	15700	7985	1	0	\N
54196	1724	6429318000000	15703	7985	1	0	\N
54197	1724	6478690000000	1974	1043	1	0	\N
54198	1724	6478690000000	2000	1057	1	0	\N
54199	1724	6478690000000	2150	1137	2	0	\N
54200	1724	6478690000000	2750	1441	1	0	\N
54202	1724	6478700000000	1974	1043	2	0	\N
54203	1724	6478700000000	2000	1057	2	0	\N
54204	1724	6478700000000	2750	1441	2	0	\N
54205	1724	6478710000000	2150	1137	3	0	\N
54206	1724	6479120000000	1718	890	11	0	\N
54207	1724	6479230000000	1718	890	12	0	\N
54208	1724	6894655500000	22054	11028	3	0	\N
54209	1724	6894655500000	22644	11323	3	0	\N
54212	1724	6894667500000	22054	11028	4	0	\N
54213	1724	6894667500000	22644	11323	4	0	\N
54214	1724	7149308000000	13635	7010	14	0	\N
54215	1724	7149308000000	13638	7010	2	0	\N
54216	1724	7149308000000	13688	7033	2	0	\N
54217	1724	7149308000000	15350	7823	3	0	\N
54218	1724	7149308000000	15365	7828	5	0	\N
54219	1724	7149318000000	15700	7985	3	0	\N
54221	1724	7149318000000	15703	7985	8	0	\N
54222	1724	7149319000000	13688	7033	3	0	\N
54223	1724	7149320000000	15350	7823	4	0	\N
54224	1724	7149328000000	13638	7010	3	0	\N
54225	1724	7149331000000	15365	7828	6	0	\N
54227	1724	7149333000000	15703	7985	9	0	\N
54228	1724	7149340000000	13635	7010	15	0	\N
54229	1724	7198690000000	2857	1496	3	0	\N
54230	1724	7198690000000	2859	1496	1	0	\N
54231	1724	7198690000000	2864	1499	1	0	\N
54232	1724	7198690000000	2928	1523	1	0	\N
54234	1724	7198691000000	2859	1496	2	0	\N
54235	1724	7198700000000	2864	1499	2	0	\N
54236	1724	7198700000000	2928	1523	2	0	\N
54238	1724	7198711000000	2857	1496	4	0	\N
54239	1724	7199230000000	1728	891	9	0	\N
54240	1724	7199320000000	1728	891	10	0	\N
54241	1724	7199740000000	1975	892	42	0	\N
54246	1724	7918700000000	3333	1729	4	0	\N
54248	1724	7918740000000	3333	1729	5	0	\N
54249	1724	7919740000000	1975	892	126	0	\N
54250	1724	7920980000000	2002	893	42	0	\N
54251	1724	8334677500000	23346	11650	1	0	\N
54253	1724	8334678500000	23346	11650	2	0	\N
54255	1724	8587330000000	17414	8821	2	0	\N
54257	1724	8587332000000	17414	8821	3	0	\N
54259	1724	8587364000000	17740	8966	5	0	\N
54260	1724	8587364000000	17744	8966	5	0	\N
54263	1724	8640980000000	2002	893	54	0	\N
54264	1724	8641090000000	2002	893	55	0	\N
54140	1724	3598660000000	1492	815	1	0	2
54141	1724	3598670000000	1492	815	2	0	2
54153	1724	4318670000000	1493	816	1	0	2
54154	1724	4318680000000	1493	816	2	0	2
54162	1724	5038680000000	1705	916	0	0	2
54174	1724	5758690000000	1727	928	2	0	2
54201	1724	6478690000000	2751	1441	0	0	2
54233	1724	7198690000000	3269	1698	1	0	2
54237	1724	7198700000000	3269	1698	2	0	2
54247	1724	7918700000000	3457	1794	0	0	2
54262	1724	8638720000000	3711	1927	3	0	2
54130	1724	2829281000000	11201	5752	3	0	7
54138	1724	3549281000000	11403	5857	2	0	7
54139	1724	3549292000000	11403	5857	3	0	7
54155	1724	4989292000000	12142	6254	2	0	7
54156	1724	4989294000000	12142	6254	3	0	7
54168	1724	5709294000000	12206	6289	1	0	7
54170	1724	5709295000000	12206	6289	2	0	7
54185	1724	6429295000000	13480	6941	4	0	7
54195	1724	6429318000000	15701	7985	1	0	7
54220	1724	7149318000000	15701	7985	6	0	7
54226	1724	7149331000000	15701	7985	7	0	7
54244	1724	7867319000000	16463	8374	2	0	9
54245	1724	7867330000000	16463	8374	3	0	9
54258	1724	8587341000000	17497	8858	3	0	9
54210	1724	6894655500000	23198	11580	2	0	13
54211	1724	6894666500000	23198	11580	3	0	13
54242	1724	7614666500000	23276	11612	2	0	13
54252	1724	8334677500000	23578	11749	3	0	13
54254	1724	8334689500000	23578	11749	4	0	13
54268	1724	9307341000000	17748	8967	6	0	\N
54269	1724	9307364000000	17740	8966	8	0	\N
54270	1724	9307364000000	17744	8966	8	0	\N
54272	1724	9307365000000	17748	8967	7	0	\N
54273	1724	9307366000000	17744	8966	9	0	\N
54277	1724	9774701500000	24496	12182	2	0	\N
54279	1724	9774712500000	24496	12182	3	0	\N
54288	1724	10747424500000	18480	9308	8	0	\N
54289	1724	10747424500000	18481	9308	8	0	\N
54290	1724	10747424500000	18482	9308	8	0	\N
54291	1724	10798760000000	4124	2144	1	0	\N
54292	1724	10798760000000	4463	2313	1	0	\N
54294	1724	10798770000000	4124	2144	2	0	\N
54295	1724	10798770000000	4463	2313	2	0	\N
54301	1724	11467424500000	18480	9308	9	0	\N
54302	1724	11467424500000	18481	9308	9	0	\N
54303	1724	11467424500000	18482	9308	9	0	\N
54304	1724	11518770000000	4726	2444	2	0	\N
54305	1724	11518770000000	4734	2447	1	0	\N
54306	1724	11518770000000	5073	2631	1	0	\N
54308	1724	11518780000000	4734	2447	2	0	\N
54309	1724	11518780000000	5073	2631	2	0	\N
54310	1724	11518790000000	4726	2444	3	0	\N
54317	1724	12187454500000	19220	9695	7	0	\N
54320	1724	12654760500000	25404	12589	7	0	\N
54321	1724	12654760500000	25405	12547	11	0	\N
54324	1724	12654875500000	25404	12589	8	0	\N
54325	1724	12655662500000	25405	12547	12	0	\N
54326	1724	12907420500000	19211	9692	4	0	\N
54327	1724	12907433500000	19211	9692	5	0	\N
54329	1724	12907454500000	19220	9695	11	0	\N
54331	1724	12907457500000	19220	9695	12	0	\N
54334	1724	13372760500000	26699	13205	3	0	\N
54336	1724	13372772500000	26699	13205	4	0	\N
54338	1724	13678840000000	5197	2702	1	0	\N
54339	1724	13678840000000	5660	2935	0	0	\N
54340	1724	13678840000000	5783	2945	54	0	\N
54342	1724	13678850000000	5197	2702	2	0	\N
54344	1724	13679740000000	5783	2945	55	0	\N
54345	1724	13680620000000	5866	2946	52	0	\N
54348	1724	14398860000000	5867	3040	2	0	\N
54351	1724	14398880000000	5867	3040	3	0	\N
54352	1724	14400620000000	5866	2946	56	0	\N
54353	1724	14400650000000	5866	2946	57	0	\N
54364	1724	16558890000000	6298	3261	1	0	\N
54366	1724	16558900000000	6298	3261	2	0	\N
54368	1724	16972928500000	27674	13675	3	0	\N
54370	1724	16972940500000	27674	13675	4	0	\N
54376	1724	17278930000000	6702	3402	2	0	\N
54377	1724	17692952500000	27920	13809	3	0	\N
54378	1724	17692952500000	28347	14013	8	0	\N
54381	1724	17692964500000	27920	13809	4	0	\N
54382	1724	17692987500000	28347	14013	9	0	\N
54383	1724	17693483500000	28741	14044	52	0	\N
54384	1724	17937471500000	19393	9774	2	0	\N
54385	1724	17937471500000	19394	9774	0	0	\N
54386	1724	17937471500000	19402	9778	4	0	\N
54388	1724	17937473500000	19393	9774	3	0	\N
54390	1724	17937484500000	19402	9778	5	0	\N
54392	1724	17998910000000	6803	3462	0	0	\N
54394	1724	17998930000000	6702	3402	126	0	\N
54395	1724	18412963500000	28738	14181	2	0	\N
54396	1724	18412963500000	29090	14342	6	0	\N
54397	1724	18412963500000	29093	14343	3	0	\N
54398	1724	18412963500000	29146	14371	2	0	\N
54400	1724	18412974500000	28738	14181	3	0	\N
54282	1724	10078740000000	3967	2061	2	0	2
54283	1724	10078760000000	3967	2061	3	0	2
54293	1724	10798760000000	4579	2369	1	0	2
54296	1724	10798770000000	4579	2369	2	0	2
54307	1724	11518770000000	5098	2646	3	0	2
54318	1724	12238800000000	5111	2653	1	0	2
54319	1724	12238810000000	5111	2653	2	0	2
54332	1724	12958810000000	5170	2684	3	0	2
54333	1724	12958840000000	5170	2684	4	0	2
54341	1724	13678840000000	5784	3002	2	0	2
54349	1724	14398860000000	5991	3108	1	0	2
54350	1724	14398870000000	5991	3108	2	0	2
54356	1724	15118870000000	6172	3196	1	0	2
54357	1724	15118880000000	6172	3196	2	0	2
54361	1724	15838890000000	6226	3221	2	0	2
54365	1724	16558890000000	6328	3275	1	0	2
54367	1724	16558900000000	6328	3275	2	0	2
54374	1724	17278900000000	6409	3321	1	0	2
54375	1724	17278910000000	6409	3321	2	0	2
54393	1724	17998930000000	6701	3464	3	0	2
54267	1724	9307341000000	17747	8967	6	0	9
54271	1724	9307364500000	17747	8967	7	1	9
54280	1724	10027364500000	18094	9124	2	0	9
54281	1724	10027375500000	18094	9124	3	0	9
54287	1724	10747398500000	18369	9257	6	0	9
54299	1724	11467398500000	18801	9474	2	0	9
54300	1724	11467409500000	18801	9474	3	0	9
54314	1724	12187409500000	18849	9504	2	0	9
54316	1724	12187454500000	19219	9695	7	0	9
54328	1724	12907454500000	19219	9695	11	0	9
54330	1724	12907457500000	19219	9695	12	0	9
54372	1724	17217457500000	19370	9766	5	0	9
54373	1724	17217471500000	19370	9766	6	0	9
54389	1724	17937482500000	19403	9778	3	0	9
54265	1724	9054689500000	23927	11907	3	0	13
54266	1724	9054701500000	23927	11907	4	0	13
54276	1724	9774701500000	24495	12182	1	0	13
54278	1724	9774711500000	24495	12182	2	0	13
54285	1724	10494723500000	24914	12369	4	0	13
54297	1724	11214723500000	25069	12443	3	0	13
54298	1724	11214735500000	25069	12443	4	0	13
54312	1724	11934735500000	25206	12503	7	0	13
54322	1724	12654760500000	26377	13047	3	0	13
54323	1724	12654772500000	26377	13047	4	0	13
54335	1724	13372760500000	27078	13387	3	0	15
54337	1724	13372772500000	27078	13387	4	0	15
54346	1724	14092772500000	27229	13464	6	0	15
54354	1724	14812796500000	27596	13639	9	0	15
54355	1724	14812868500000	27596	13639	10	0	15
54358	1724	15532868500000	27608	13645	12	0	15
54359	1724	15532916500000	27608	13645	13	0	15
54362	1724	16252916500000	27630	13656	3	0	15
54369	1724	16972928500000	27838	13760	6	0	15
54371	1724	16972952500000	27838	13760	7	0	15
54379	1724	17692952500000	28395	14035	2	0	15
54380	1724	17692963500000	28395	14035	3	0	15
54401	1724	18412974500000	29146	14371	3	0	\N
54402	1724	18412975500000	29093	14343	4	0	\N
54404	1724	18412996500000	29090	14342	7	0	\N
54405	1724	18413483500000	28741	14044	126	0	\N
54406	1724	18414213500000	28741	14044	127	0	\N
54407	1724	18657482500000	19587	9866	3	0	\N
54408	1724	18657482500000	19589	9837	0	0	\N
54410	1724	18657482500000	20116	9969	5	0	\N
54411	1724	18657494500000	19587	9866	4	0	\N
54413	1724	18657572500000	20116	9969	6	0	\N
54414	1724	18658092500000	19847	9838	25	0	\N
54415	1724	18718930000000	6801	3522	2	0	\N
54416	1724	18718930000000	6802	3522	1	0	\N
54418	1724	18718940000000	6802	3522	2	0	\N
54419	1724	18718950000000	6801	3522	3	0	\N
54421	1724	18738950000000	7840	4014	0	0	\N
54422	1724	19133975500000	29552	14570	6	0	\N
54423	1724	19133975500000	29553	14570	8	0	\N
54426	1724	19133999500000	29552	14570	7	0	\N
54427	1724	19134001500000	29553	14570	9	0	\N
54428	1724	19377507500000	19854	10001	6	0	\N
54430	1724	19377531500000	19854	10001	7	0	\N
54432	1724	19378092500000	19847	9838	26	0	\N
54433	1724	19438950000000	7482	3870	3	0	\N
54434	1724	19438950000000	7483	3870	3	0	\N
54435	1724	19438950000000	7838	4063	1	0	\N
54436	1724	19438950000000	7940	4115	1	0	\N
54438	1724	19438960000000	7838	4063	2	0	\N
54439	1724	19438960000000	7940	4115	2	0	\N
54441	1724	19438971000000	7482	3870	4	0	\N
54442	1724	19438971000000	7483	3870	4	0	\N
54443	1724	20097550500000	20429	10286	1	0	\N
54444	1724	20097550500000	20430	10291	8	0	\N
54446	1724	20097551500000	20429	10286	2	0	\N
54448	1724	20097576500000	20430	10291	9	0	\N
54449	1724	20098092500000	19855	9839	0	0	\N
54452	1724	20418092500000	20115	9840	0	0	\N
54453	1724	20817551500000	20608	10287	23	0	\N
54454	1724	20817574500000	21087	10594	2	0	\N
54456	1724	20817574500000	21090	10594	2	0	\N
54457	1724	20817585500000	21087	10594	3	0	\N
54459	1724	20817585500000	21090	10594	3	0	\N
54460	1724	20817861500000	20608	10287	24	0	\N
54463	1724	20879376000000	9829	5041	75	0	\N
54468	1724	21599100000000	9104	4717	2	0	\N
54469	1724	21599100000000	9343	4848	2	0	\N
54470	1724	21599120000000	9104	4717	3	0	\N
54471	1724	21599120000000	9343	4848	3	0	\N
54472	1724	21599376000000	9829	5041	76	0	\N
54475	1724	22977671500000	21349	10715	4	0	\N
54476	1724	22977671500000	21401	10735	11	0	\N
54477	1724	22977671500000	21462	10768	3	0	\N
54479	1724	22977683500000	21462	10768	4	0	\N
54480	1724	22977684500000	21349	10715	5	0	\N
54482	1724	22977728500000	21401	10735	12	0	\N
54483	1724	23697695500000	21966	10987	3	0	\N
54484	1724	23697695500000	21967	10912	2	0	\N
54485	1724	23697695500000	22056	11010	0	0	\N
54486	1724	23697699500000	21967	10912	3	0	\N
54487	1724	23697707500000	21966	10987	4	0	\N
54488	1724	66000000600200	17740	8966	9	1	\N
54489	1725	7200731396400	2760	1231	119	1	\N
54490	1726	200000	5837	3029	6	0	\N
54491	1726	200000001	10279	5319	9	0	\N
54493	1726	12703131909945	10278	5319	9	0	\N
54494	1726	13682901410000	10045	5015	61	0	\N
54495	1726	75601401099986	5836	3029	6	0	\N
54496	1727	200100000	16707	8428	124	1	\N
54499	1727	1434961990000	16784	8429	18	0	\N
54500	1727	1439010000000	1071	593	1	0	\N
54501	1727	1439010000000	1099	607	1	0	\N
54503	1727	1439020000000	1071	593	2	0	\N
54504	1727	1439020000000	1099	607	2	0	\N
54507	1727	1626685000000	9996	5175	33	0	\N
54509	1727	1627006000000	9996	5175	34	0	\N
54510	1727	2159020000000	1803	964	1	0	\N
54511	1727	2159020000000	1962	1039	1	0	\N
54512	1727	2159020000000	2052	1084	2	0	\N
54513	1727	2159020000000	2085	1100	1	0	\N
54514	1727	2159020000000	2365	1236	1	0	\N
54516	1727	2159030000000	1803	964	2	0	\N
54517	1727	2159030000000	1962	1039	2	0	\N
54518	1727	2159030000000	2085	1100	2	0	\N
54519	1727	2159030000000	2365	1236	2	0	\N
54521	1727	2159040000000	2052	1084	3	0	\N
54526	1727	3066636000000	10427	5394	15	0	\N
54529	1727	3066786000000	10427	5394	16	0	\N
54530	1727	3599040000000	2417	1265	2	0	\N
54533	1727	3599060000000	2417	1265	3	0	\N
54534	1727	3786656000000	10610	5480	4	0	\N
54535	1727	3786656000000	10810	5579	3	0	\N
54536	1727	3786656000000	10812	5579	2	0	\N
54502	1727	1439010000000	1615	873	1	0	0
54505	1727	1439020000000	1615	873	2	0	0
54515	1727	2159020000000	2408	1260	1	0	0
54520	1727	2159030000000	2408	1260	2	0	0
54524	1727	2879030000000	2415	1264	1	0	0
54531	1727	3599040000000	3054	1588	1	0	0
54532	1727	3599050000000	3054	1588	2	0	0
54417	1724	18718930000000	7126	3682	2	0	2
54420	1724	18718950000000	7126	3682	3	0	2
54437	1724	19438950000000	8569	4441	1	0	2
54450	1724	20158960000000	8909	4615	2	0	2
54451	1724	20158980000000	8909	4615	3	0	2
54461	1724	20878980000000	8944	4639	3	0	2
54462	1724	20879100000000	8944	4639	4	0	2
54467	1724	21598171000000	9830	5094	10	0	3
54506	1727	1626685000000	9995	5183	2	0	5
54508	1727	1626705000000	9995	5183	3	0	5
54522	1727	2346486000000	10134	5256	6	0	7
54523	1727	2346636000000	10134	5256	7	0	7
54528	1727	3066656000000	10580	5465	3	0	7
54492	1726	674918185000	13661	7021	15	0	5749
54409	1724	18657482500000	19846	9998	7	0	9
54412	1724	18657507500000	19846	9998	8	0	9
54429	1724	19377507500000	20117	10126	7	0	9
54445	1724	20097550500000	20609	10365	6	0	9
54447	1724	20097574500000	20609	10365	7	0	9
54455	1724	20817574500000	21089	10594	2	0	9
54458	1724	20817585500000	21089	10594	3	0	9
54465	1724	21537647500000	21251	10671	9	0	9
54473	1724	22257647500000	21346	10713	6	0	9
54474	1724	22257671500000	21346	10713	7	0	9
54478	1724	22977671500000	21777	10904	6	0	9
54481	1724	22977695500000	21777	10904	7	0	9
54424	1724	19133975500000	29863	14720	9	0	15
54425	1724	19133993500000	29863	14720	10	0	15
54537	1727	3786656000000	11140	5726	2	0	\N
54539	1727	3786676000000	10812	5579	3	0	\N
54540	1727	3786676000000	11140	5726	3	0	\N
54541	1727	3786677000000	10810	5579	4	0	\N
54543	1727	3786696000000	10610	5480	5	0	\N
54556	1727	6479090000000	3438	1785	0	0	\N
54557	1727	6479090000000	3530	1832	1	0	\N
54558	1727	6479090000000	3557	1846	0	0	\N
54560	1727	6479091000000	3530	1832	2	0	\N
54562	1727	6479200000000	4479	2321	1	0	\N
54563	1727	6479200000000	4482	2321	1	0	\N
54564	1727	6666691000000	12088	6224	2	0	\N
54565	1727	6666691000000	12569	6478	2	0	\N
54566	1727	6666691000000	13494	6949	3	0	\N
54568	1727	6666693000000	12088	6224	3	0	\N
54570	1727	6666702000000	12569	6478	3	0	\N
54571	1727	6666703000000	13494	6949	4	0	\N
54574	1727	7199200000000	4479	2321	4	0	\N
54575	1727	7199200000000	4482	2321	4	0	\N
54576	1727	7199220000000	4479	2321	5	0	\N
54577	1727	7199220000000	4482	2321	5	0	\N
54578	1727	7386701000000	13660	7021	13	0	\N
54579	1727	7386701000000	13685	7032	2	0	\N
54580	1727	7386701000000	13813	7092	8	0	\N
54581	1727	7386701000000	13814	7092	2	0	\N
54582	1727	7386701000000	14252	7277	8	0	\N
54584	1727	7386712000000	13685	7032	3	0	\N
54585	1727	7386721000000	13814	7092	3	0	\N
54586	1727	7386727000000	13813	7092	9	0	\N
54587	1727	7386727000000	14252	7277	9	0	\N
54589	1727	7386759000000	13660	7021	14	0	\N
54590	1727	7919110000000	5005	2594	1	0	\N
54591	1727	7919110000000	5195	2701	1	0	\N
54593	1727	7919110000000	5596	2837	11	0	\N
54594	1727	7919120000000	5005	2594	2	0	\N
54595	1727	7919120000000	5195	2701	2	0	\N
54596	1727	7920021000000	5596	2837	12	0	\N
54598	1727	8106759000000	13663	7022	17	0	\N
54600	1727	8106848000000	13663	7022	18	0	\N
54602	1727	8640021000000	5714	2838	4	0	\N
54603	1727	8640151000000	5714	2838	5	0	\N
54604	1727	8826814000000	14689	7481	6	0	\N
54605	1727	8826814000000	14723	7497	2	0	\N
54606	1727	8826814000000	14882	7581	9	0	\N
54607	1727	8826814000000	14937	7609	5	0	\N
54608	1727	8826814000000	15007	7645	2	0	\N
54609	1727	8826814000000	15069	7674	1	0	\N
54610	1727	8826814000000	15456	7871	2	0	\N
54612	1727	8826824000000	15069	7674	2	0	\N
54613	1727	8826825000000	14723	7497	3	0	\N
54614	1727	8826825000000	15007	7645	3	0	\N
54615	1727	8826825000000	15456	7871	3	0	\N
54616	1727	8826837000000	14937	7609	6	0	\N
54617	1727	8826865000000	14689	7481	7	0	\N
54618	1727	8826868000000	14882	7581	10	0	\N
54620	1727	8826961000000	15821	8052	7	0	\N
54622	1727	8826961000000	15828	8052	7	0	\N
54623	1727	9359110000000	6218	3218	1	0	\N
54624	1727	9359110000000	6230	3224	3	0	\N
54625	1727	9359110000000	6460	3346	4	0	\N
54627	1727	9359120000000	6218	3218	2	0	\N
54629	1727	9359140000000	6230	3224	4	0	\N
54630	1727	9359150000000	6460	3346	5	0	\N
54631	1727	9546961000000	15821	8052	20	0	\N
54633	1727	9546961000000	15828	8052	20	0	\N
54635	1727	9547018000000	15828	8052	21	0	\N
54636	1727	10031839951155	15821	8052	21	0	\N
54637	1727	10079130000000	6712	3471	2	0	\N
54639	1727	10079150000000	6712	3471	3	0	\N
54641	1727	10267018000000	16086	8176	3	0	\N
54642	1727	10267018000000	16088	8175	4	0	\N
54644	1727	10267030000000	16086	8176	4	0	\N
54645	1727	10267031000000	16088	8175	5	0	\N
54647	1727	10799150000000	7153	3696	2	0	\N
54648	1727	10799150000000	7485	3871	1	0	\N
54650	1727	10799160000000	7485	3871	2	0	\N
54651	1727	10799170000000	7153	3696	3	0	\N
54655	1727	11519171000000	8094	4196	1	0	\N
54657	1727	11519181000000	8094	4196	2	0	\N
54659	1727	11707064000000	16439	8360	3	0	\N
54660	1727	11707064000000	16441	8360	2	0	\N
54661	1727	11707064000000	16582	8427	6	0	\N
54662	1727	11707064000000	16584	8426	12	0	\N
54663	1727	11707064000000	16604	8436	3	0	\N
54665	1727	11707066000000	16441	8360	3	0	\N
54666	1727	11707076000000	16439	8360	4	0	\N
54667	1727	11707076000000	16604	8436	4	0	\N
54668	1727	11707088000000	16582	8427	7	0	\N
54670	1727	11707121000000	16584	8426	13	0	\N
54548	1727	5039060000000	3210	1667	2	0	0
54549	1727	5039080000000	3210	1667	3	0	0
54552	1727	5759080000000	3296	1710	1	0	0
54553	1727	5759090000000	3296	1710	2	0	0
54559	1727	6479090000000	4005	2078	1	0	0
54572	1727	7199100000000	4795	2481	1	0	0
54573	1727	7199110000000	4795	2481	2	0	0
54592	1727	7919110000000	5595	2908	0	0	0
54601	1727	8639110000000	5711	2962	0	0	0
54626	1727	9359110000000	6651	3439	2	0	0
54638	1727	10079130000000	6980	3601	2	0	0
54640	1727	10079150000000	6980	3601	3	0	0
54649	1727	10799150000000	7923	4107	3	0	0
54652	1727	10799171000000	7923	4107	4	0	0
54658	1727	11519282000000	8309	4300	4	0	0
54671	1727	12239282000000	8365	4334	1	0	0
54672	1727	12239292000000	8365	4334	2	0	0
54538	1727	3786656000000	11244	5777	4	0	7
54542	1727	3786678000000	11244	5777	5	0	7
54547	1727	4506689000000	11544	5930	3	0	7
54550	1727	5226689000000	11743	6035	1	0	7
54551	1727	5226690000000	11743	6035	2	0	7
54554	1727	5946690000000	11842	6089	1	0	7
54555	1727	5946691000000	11842	6089	2	0	7
54569	1727	6666701000000	13495	6949	2	0	7
54583	1727	7386701000000	14489	7393	7	0	7
54588	1727	7386753000000	14489	7393	8	0	7
54597	1727	8106753000000	14688	7480	7	0	7
54611	1727	8826814000000	15813	8048	14	0	7
54619	1727	8826891000000	15813	8048	15	0	7
54621	1727	8826961000000	15825	8052	7	0	7
54632	1727	9546961000000	15825	8052	20	0	7
54634	1727	9547018000000	15825	8052	21	0	7
54646	1727	10267051000000	16204	8235	7	0	7
54653	1727	10987051000000	16334	8302	4	0	7
54654	1727	10987064000000	16334	8302	5	0	7
54664	1727	11707064000000	16705	8488	7	0	7
54669	1727	11707089000000	16705	8488	8	0	7
54675	1727	12427121000000	16610	8427	28	0	\N
54676	1727	12427324000000	16610	8427	29	0	\N
54677	1727	12427554000000	16707	8428	19	0	\N
54678	1727	12959292000000	8528	4418	1	0	\N
54679	1727	12959292000000	8529	4418	0	0	\N
54680	1727	12959292000000	8810	4568	3	0	\N
54682	1727	12959302000000	8528	4418	2	0	\N
54684	1727	12959322000000	8810	4568	4	0	\N
54687	1727	13147554000000	16707	8428	123	0	\N
54688	1727	13679302000000	9308	4830	4	0	\N
54689	1727	13679302000000	9514	4933	2	0	\N
54691	1727	13679322000000	9514	4933	3	0	\N
54693	1727	13679342000000	9308	4830	5	0	\N
54694	1727	13834565936000	16784	8429	67	0	\N
54696	1727	13867152000000	17399	8813	9	0	\N
54697	1727	13867152000000	17400	8813	9	0	\N
54699	1727	13867188000000	17400	8813	10	0	\N
54700	1727	13868008075300	16784	8429	66	0	\N
54701	1727	14554587939000	17399	8813	10	0	\N
54706	1727	16027202000000	17673	8934	10	0	\N
54707	1727	16027202000000	18631	9388	5	0	\N
54708	1727	16027202000000	18705	9422	2	0	\N
54711	1727	16027213000000	18705	9422	3	0	\N
54712	1727	16027225000000	18631	9388	6	0	\N
54713	1727	16027257000000	17673	8934	11	0	\N
54715	1727	16747212000000	19448	9802	7	0	\N
54717	1727	16747237000000	19448	9802	8	0	\N
54720	1727	18187246999999	19719	9929	4	0	\N
54722	1727	18187268999999	19719	9929	5	0	\N
54726	1727	19627282999999	19778	9960	7	0	\N
54727	1727	19627307999999	19778	9960	8	0	\N
54729	1728	200000001	10453	5405	16	0	\N
54730	1728	17279026100000	10452	5405	15	1	\N
54731	1729	719000000000	479	267	2	0	\N
54734	1729	719110000000	479	267	3	0	\N
54735	1729	1439010000000	656	366	2	0	\N
54736	1729	1439010000000	818	453	1	0	\N
54738	1729	1439020000000	818	453	2	0	\N
54740	1729	1439030000000	656	366	3	0	\N
54741	1729	2159020000000	1031	571	1	0	\N
54743	1729	2159030000000	1031	571	2	0	\N
54745	1729	2446706000000	10191	5278	7	0	\N
54748	1729	2446866000000	10191	5278	8	0	\N
54753	1729	3599040000000	1488	812	2	0	\N
54754	1729	3599040000000	1887	1004	1	0	\N
54755	1729	3599040000000	1922	1024	1	0	\N
54757	1729	3599050000000	1887	1004	2	0	\N
54758	1729	3599050000000	1922	1024	2	0	\N
54760	1729	3599060000000	1488	812	3	0	\N
54761	1729	3886756000000	11067	5693	2	0	\N
54763	1729	3886776000000	11067	5693	3	0	\N
54771	1729	5326886000000	11401	5855	4	0	\N
54774	1729	5326908000000	11401	5855	5	0	\N
54783	1729	7199100000000	3462	1798	0	0	\N
54784	1729	7199100000000	3472	1803	0	0	\N
54789	1729	7919120000000	4034	2095	1	0	\N
54790	1729	7919120000000	4138	2153	9	0	\N
54791	1729	7919120000000	4432	2298	4	0	\N
54793	1729	7919130000000	4034	2095	2	0	\N
54795	1729	7919250000000	4432	2298	5	0	\N
54796	1729	7919750000000	4138	2153	10	0	\N
54801	1729	8926901000000	12180	6271	4	0	\N
54804	1729	8926905000000	12180	6271	5	0	\N
54737	1729	1439010000000	1013	560	1	0	0
54739	1729	1439020000000	1013	560	2	0	0
54742	1729	2159020000000	1312	723	1	0	0
54744	1729	2159030000000	1312	723	2	0	0
54749	1729	2879030000000	1377	754	1	0	0
54756	1729	3599040000000	2128	1123	1	0	0
54759	1729	3599050000000	2128	1123	2	0	0
54765	1729	4319050000000	2947	1532	1	0	0
54766	1729	4319060000000	2947	1532	2	0	0
54769	1729	5039060000000	3023	1570	1	0	0
54775	1729	5759070000000	3103	1611	2	0	0
54776	1729	5759090000000	3103	1611	3	0	0
54779	1729	6479090000000	3248	1686	1	0	0
54780	1729	6479100000000	3248	1686	2	0	0
54786	1729	7199120000000	3764	1953	3	0	0
54792	1729	7919120000000	4962	2572	2	0	0
54794	1729	7919140000000	4962	2572	3	0	0
54799	1729	8639140000000	5359	2782	1	0	0
54800	1729	8639150000000	5359	2782	2	0	0
54808	1729	10079150000000	5872	3044	2	0	0
54681	1727	12959292000000	8811	4568	1	0	0
54683	1727	12959302000000	8811	4568	2	0	0
54728	1728	9900000	9076	4708	9	0	0
54690	1727	13679302000000	9609	4986	5	0	0
54746	1729	2446706000000	10210	5287	3	0	4
54747	1729	2446736000000	10210	5287	4	0	4
54751	1729	3166736000000	10728	5537	2	0	4
54752	1729	3166756000000	10728	5537	3	0	4
54764	1729	3886876000000	11212	5758	4	0	4
54767	1729	4606876000000	11358	5833	1	0	4
54768	1729	4606886000000	11358	5833	2	0	4
54772	1729	5326886000000	11531	5924	2	0	4
54773	1729	5326897000000	11531	5924	3	0	4
54778	1729	6046898000000	11646	5992	2	0	4
54781	1729	6766898000000	11780	6056	1	0	4
54782	1729	6766899000000	11780	6056	2	0	4
54787	1729	7486899000000	11907	6124	1	0	4
54788	1729	7486900000000	11907	6124	2	0	4
54798	1729	8206901000000	11945	6150	2	0	4
54802	1729	8926901000000	12381	6385	1	0	4
54803	1729	8926902000000	12381	6385	2	0	4
54806	1729	9646902000000	12415	6403	1	0	4
54673	1727	12427089000000	16783	8519	7	0	7
54674	1727	12427114000000	16783	8519	8	0	7
54685	1727	13147114000000	17080	8652	11	0	7
54686	1727	13147152000000	17080	8652	12	0	7
54695	1727	13867152000000	17398	8813	9	0	7
54702	1727	14587188000000	17417	8822	2	0	7
54703	1727	14587190000000	17417	8822	3	0	7
54704	1727	15307190000000	17434	8831	3	0	7
54705	1727	15307202000000	17434	8831	4	0	7
54709	1727	16027202000000	18835	9493	1	0	7
54714	1727	16747212000000	19446	9802	5	0	7
54716	1727	16747234999999	19446	9802	6	0	7
54718	1727	17467234999999	19586	9866	3	0	7
54719	1727	17467246999999	19586	9866	4	0	7
54723	1727	18187270999999	19720	9929	7	0	7
54724	1727	18907270999999	19771	9954	3	0	7
54725	1727	18907282999999	19771	9954	4	0	7
54810	1729	10366903000000	12537	6462	2	0	\N
54812	1729	10366914000000	12537	6462	3	0	\N
54814	1729	10799170000000	5964	3093	1	0	\N
54816	1729	10799180000000	5964	3093	2	0	\N
54818	1729	11086936000000	12747	6572	5	0	\N
54821	1729	11086959000000	12747	6572	6	0	\N
54822	1729	11519180000000	6772	3506	2	0	\N
54823	1729	11519180000000	6794	3518	2	0	\N
54825	1729	11519200000000	6772	3506	3	0	\N
54826	1729	11519200000000	6794	3518	3	0	\N
54832	1729	12526981000000	13213	6810	5	0	\N
54835	1729	12527004000000	13213	6810	6	0	\N
54837	1729	12527005000000	13446	6928	3	0	\N
54838	1729	12959230000000	8168	4233	2	0	\N
54840	1729	12959250000000	8168	4233	3	0	\N
54842	1729	12960290000000	8632	4355	67	0	\N
54844	1729	13247005000000	13446	6928	10	0	\N
54846	1729	13247011000000	13446	6928	11	0	\N
54847	1729	13679250000000	8631	4473	2	0	\N
54848	1729	13679250000000	9028	4681	2	0	\N
54850	1729	13679270000000	8631	4473	3	0	\N
54851	1729	13679270000000	9028	4681	3	0	\N
54853	1729	13680290000000	8632	4355	95	0	\N
54854	1729	13680560000000	8632	4355	96	0	\N
54859	1729	14687023000000	13882	7123	23	0	\N
54862	1729	14687056000000	13916	7135	3	0	\N
54863	1729	14687064000000	13882	7123	24	0	\N
54866	1729	15407044000000	13914	7135	1	0	\N
54868	1729	15407054000000	13914	7135	2	0	\N
54869	1729	15407056000000	13916	7135	5	0	\N
54870	1729	15407057000000	13916	7135	6	0	\N
54872	1729	15839450000000	9489	4922	2	0	\N
54873	1729	15839450000000	9566	4961	2	0	\N
54874	1729	15839450000000	9737	5045	7	0	\N
54875	1729	15839450000000	10038	5208	6	0	\N
54877	1729	15839470000000	9489	4922	3	0	\N
54878	1729	15839470000000	9566	4961	3	0	\N
54880	1729	15839510000000	10038	5208	7	0	\N
54881	1729	15839511000000	9737	5045	8	0	\N
54882	1729	16127076000000	14343	7321	7	0	\N
54883	1729	16127076000000	14482	7390	0	0	\N
54884	1729	16127076000000	14483	7391	1	0	\N
54886	1729	16127086000000	14483	7391	2	0	\N
54887	1729	16127092000000	14343	7321	8	0	\N
54889	1729	16847148000000	14796	7538	3	0	\N
54892	1729	16847169000000	14796	7538	4	0	\N
54895	1729	18287171000000	15171	7731	4	0	\N
54896	1729	18287171000000	15229	7757	1	0	\N
54898	1729	18287181000000	15229	7757	2	0	\N
54900	1729	18287184000000	15171	7731	5	0	\N
54901	1729	19007182000000	15606	7944	2	0	\N
54902	1729	19007182000000	16107	8187	3	0	\N
54903	1729	19007193000000	15606	7944	3	0	\N
54904	1729	19007194000000	16107	8187	4	0	\N
54909	1733	2159010000000	8014	4153	2	0	\N
54910	1733	2159010000000	25392	12585	3	0	\N
54911	1733	2159010000000	29760	14668	14	0	\N
54912	1733	2159010000000	29761	14668	12	0	\N
54913	1733	2159010000000	29763	14668	11	0	\N
54914	1733	2159021000000	8014	4153	3	0	\N
54915	1733	2159022000000	25392	12585	4	0	\N
54916	1733	2159022000000	29761	14668	13	0	\N
54917	1733	2159030000000	29763	14668	12	0	\N
54918	1733	2159033000000	29760	14668	15	0	\N
54919	1734	66964074899898	23214	11516	127	0	\N
54929	1735	4300020000000	4058	2108	1	0	\N
54930	1735	4300020000000	4663	2410	1	0	\N
54931	1735	4300020000000	5678	2830	13	0	\N
54932	1735	4300020000000	11427	5862	0	0	\N
54933	1735	4300020000000	22327	11174	7	0	\N
54934	1735	4300030000000	4058	2108	2	0	\N
54935	1735	4300030000000	4663	2410	2	0	\N
54936	1735	4300045000000	22327	11174	8	0	\N
54937	1735	4300933000000	5678	2830	14	0	\N
54938	1737	1000000100	2011	971	82	0	\N
54939	1737	1000000200	2186	972	13	0	\N
54942	1737	1000001400	2261	974	2	0	\N
54943	1737	1399001100	27072	13384	2	0	\N
54944	1737	3600969998700	2186	972	14	0	\N
54920	1735	719000000000	530	300	1	0	0
54921	1735	719010000000	530	300	2	0	0
54922	1735	1439009000000	992	547	1	0	1
54923	1735	1439019000000	992	547	2	0	1
54924	1735	2139970000000	1731	930	2	0	7
54940	1737	1000000200	2534	1333	3	0	0
54941	1737	1000001100	2604	1370	3	0	0
54926	1735	2859990000000	3304	1715	0	0	7
54927	1735	3579990000000	3427	1780	3	0	7
54928	1735	3580020000000	3427	1780	4	0	7
54815	1729	10799170000000	5976	3101	1	0	0
54817	1729	10799180000000	5976	3101	2	0	0
54824	1729	11519180000000	6937	3579	4	0	0
54827	1729	11519220000000	6937	3579	5	0	0
54831	1729	12239230000000	7538	3902	2	0	0
54907	1733	1439000000000	7848	4067	1	0	1
54908	1733	1439010000000	7848	4067	2	0	1
54839	1729	12959230000000	8169	4233	2	0	0
54841	1729	12959250000000	8169	4233	3	0	0
54852	1729	13679270000000	9065	4699	3	0	0
54857	1729	14399270000000	9249	4798	16	0	0
54858	1729	14399430000000	9249	4798	17	0	0
54864	1729	15119430000000	9366	4858	2	0	0
54865	1729	15119450000000	9366	4858	3	0	0
54879	1729	15839480000000	10039	5208	4	0	0
54811	1729	10366903000000	12727	6563	6	0	4
54813	1729	10366936000000	12727	6563	7	0	4
54819	1729	11086936000000	12749	6572	3	0	4
54828	1729	11806957000000	13188	6796	6	0	4
54829	1729	11806981000000	13188	6796	7	0	4
54833	1729	12526981000000	13317	6860	3	0	4
54834	1729	12526993000000	13317	6860	4	0	4
54836	1729	12527005000000	13445	6928	3	0	4
54845	1729	13247011000000	13445	6928	11	0	4
54855	1729	13967011000000	13544	6970	3	0	4
54856	1729	13967023000000	13544	6970	4	0	4
54860	1729	14687023000000	13883	7123	3	0	4
54861	1729	14687044000000	13883	7123	4	0	4
54871	1729	15407076000000	14283	7291	15	0	4
54885	1729	16127076000000	14684	7479	9	0	4
54888	1729	16127148000000	14684	7479	10	0	4
54890	1729	16847148000000	14901	7592	2	0	4
54893	1729	17567159000000	14982	7633	3	0	4
54894	1729	17567171000000	14982	7633	4	0	4
54897	1729	18287171000000	15334	7816	2	0	4
54899	1729	18287182000000	15334	7816	3	0	4
54945	1737	5040814993701	2261	974	3	0	\N
54946	1737	66000090023000	2760	1231	117	0	\N
54949	1738	1438910000000	7237	3741	1	0	\N
54951	1738	1438920000000	7237	3741	2	0	\N
54957	1739	719000000000	692	385	1	0	\N
54959	1739	719010000000	692	385	2	0	\N
54963	1739	2159030000000	1198	660	1	0	\N
54965	1739	2159040000000	1198	660	2	0	\N
54971	1739	4319270000000	3578	1857	0	0	\N
54977	1739	6479290000000	4314	2236	2	0	\N
54980	1739	6479310000000	4314	2236	3	0	\N
54987	1739	9359340000000	5202	2705	2	0	\N
54989	1739	9359360000000	5202	2705	3	0	\N
54995	1739	11519390000000	6295	3260	1	0	\N
54996	1739	11519390000000	6387	3310	1	0	\N
54998	1739	11519400000000	6295	3260	2	0	\N
54999	1739	11519400000000	6387	3310	2	0	\N
55001	1739	12239400000000	6545	3388	0	0	\N
55004	1739	12959400000000	6564	3389	1	0	\N
55005	1739	12959401000000	6564	3389	2	0	\N
55006	1739	12959480000000	7358	3802	18	0	\N
55007	1739	12959480000000	7688	3982	1	0	\N
55009	1739	12959490000000	7688	3982	2	0	\N
55011	1739	12959660000000	7358	3802	19	0	\N
55012	1739	13679401000000	6720	3390	12	0	\N
55013	1739	13679467000000	6720	3390	13	0	\N
55014	1739	13679490000000	8172	4234	1	0	\N
55015	1739	13679490000000	8459	4382	1	0	\N
55017	1739	13679500000000	8172	4234	2	0	\N
55018	1739	13679500000000	8459	4382	2	0	\N
55020	1739	14399467000000	6780	3391	0	0	\N
55021	1739	14399500000000	8654	4483	2	0	\N
55023	1739	14399520000000	8654	4483	3	0	\N
55027	1739	15839560000000	9402	4877	4	0	\N
55028	1739	15839560000000	9849	5105	1	0	\N
55030	1739	15839570000000	9849	5105	2	0	\N
55032	1739	15839600000000	9402	4877	5	0	\N
55033	1739	16559583000000	10529	5436	4	0	\N
55034	1739	16559583000000	10535	5440	2	0	\N
55036	1739	16559603000000	10535	5440	3	0	\N
55038	1739	16559623000000	10529	5436	5	0	\N
55039	1739	17279613000000	10668	5508	5	0	\N
55040	1739	17279613000000	11406	5858	4	0	\N
55043	1739	17279635000000	11406	5858	5	0	\N
55044	1739	17279663000000	10668	5508	6	0	\N
55051	1739	20159619000000	12413	6402	1	0	\N
55052	1739	20159619000000	12522	6453	4	0	\N
55053	1739	20159619000000	12759	6577	4	0	\N
55055	1739	20159620000000	12413	6402	2	0	\N
55057	1739	20159641000000	12522	6453	5	0	\N
55058	1739	20159641000000	12759	6577	5	0	\N
55069	1739	23759735000000	13874	7121	3	0	\N
55070	1739	24479705000000	14332	7313	4	0	\N
55071	1739	24479705000000	14653	7467	3	0	\N
55072	1739	24479705000000	14691	7481	6	0	\N
55075	1739	24479717000000	14653	7467	4	0	\N
55076	1739	24479718000000	14332	7313	5	0	\N
55077	1739	24479735000000	13874	7121	5	0	\N
55078	1739	24479736000000	13874	7121	6	0	\N
55079	1739	24479756000000	14691	7481	7	0	\N
55080	1739	25199716000000	14962	7620	2	0	\N
54958	1739	719000000000	804	444	2	0	0
54960	1739	719020000000	804	444	3	0	0
54961	1739	1439020000000	844	465	1	0	0
54962	1739	1439030000000	844	465	2	0	0
54964	1739	2159030000000	1219	671	1	0	0
54967	1739	2879040000000	2487	1303	1	0	0
54968	1739	2879050000000	2487	1303	2	0	0
54969	1739	3599050000000	3226	1675	13	0	0
54970	1739	3599270000000	3226	1675	14	0	0
54972	1739	4319270000000	3638	1886	0	0	0
54974	1739	5039280000000	3683	1913	2	0	0
54975	1739	5759280000000	3835	1992	1	0	0
54976	1739	5759290000000	3835	1992	2	0	0
54978	1739	6479290000000	4465	2313	1	0	0
54981	1739	7199300000000	4519	2337	2	0	0
54982	1739	7199320000000	4519	2337	3	0	0
54983	1739	7919320000000	4739	2451	1	0	0
54984	1739	7919330000000	4739	2451	2	0	0
54985	1739	8639330000000	4849	2512	1	0	0
54988	1739	9359340000000	5764	2989	3	0	0
54990	1739	9359370000000	5764	2989	4	0	0
54991	1739	9359380000000	5771	2993	1	0	0
54992	1739	10079370000000	5771	2993	2	0	0
54993	1739	10799370000000	6042	3138	2	0	0
54997	1739	11519390000000	6469	3352	1	0	0
55000	1739	11519400000000	6469	3352	2	0	0
55002	1739	12239400000000	7350	3799	8	0	0
55003	1739	12239480000000	7350	3799	9	0	0
55010	1739	12959490000000	8061	4177	2	0	0
55016	1739	13679490000000	8589	4453	1	0	0
55019	1739	13679500000000	8589	4453	2	0	0
55022	1739	14399500000000	8740	4535	2	0	0
55024	1739	14399520000000	8740	4535	3	0	0
55026	1739	15119560000000	9394	4873	5	0	0
55029	1739	15839560000000	10014	5192	5	0	0
55031	1739	15839583000000	10014	5192	6	0	0
55035	1739	16559583000000	10574	5460	3	0	0
55037	1739	16559613000000	10574	5460	4	0	0
55042	1739	17279614000000	11888	6109	2	0	0
55045	1739	17999614000000	11968	6159	1	0	0
55046	1739	17999615000000	11968	6159	2	0	0
55047	1739	18719615000000	12172	6267	2	0	0
55049	1739	19439617000000	12284	6324	2	0	0
55050	1739	19439619000000	12284	6324	3	0	0
55054	1739	20159619000000	12850	6626	2	0	0
55056	1739	20159630000000	12850	6626	3	0	0
55059	1739	20879630000000	13088	6743	3	0	0
55061	1739	21599641000000	13113	6758	4	0	0
55062	1739	21599654000000	13113	6758	5	0	0
55063	1739	22319654000000	13197	6799	6	0	0
55064	1739	22319678000000	13197	6799	7	0	0
55065	1739	23039678000000	13208	6806	3	0	0
55067	1739	23759690000000	13364	6886	6	0	0
55068	1739	23759705000000	13364	6886	7	0	0
55073	1739	24479705000000	14738	7502	2	0	0
55074	1739	24479716000000	14738	7502	3	0	0
54952	1738	1438922000000	14964	7622	4	0	1
54953	1738	2158922000000	21555	10808	3	0	1
54954	1738	2158934000000	21555	10808	4	0	1
54955	1738	2878934000000	25027	12416	2	0	1
54956	1738	2878945000000	25027	12416	3	0	1
55083	1739	25199727000000	14962	7620	3	0	\N
55084	1739	25919726000000	15214	7751	2	0	\N
55085	1739	25919726000000	15274	7780	8	0	\N
55087	1739	25919737000000	15214	7751	3	0	\N
55089	1739	25919761000000	15274	7780	9	0	\N
55090	1739	26639738000000	15948	7890	0	0	\N
55092	1739	27359738000000	17247	8703	1	0	\N
55093	1739	27359738000000	18042	8999	19	0	\N
55095	1739	27359739000000	17247	8703	2	0	\N
55097	1739	27359856000000	18042	8999	20	0	\N
55098	1739	27359927000000	18222	9000	14	0	\N
55099	1739	28079761000000	18976	9570	2	0	\N
55101	1739	28079772000000	18976	9570	3	0	\N
55103	1739	28079927000000	18222	9000	15	0	\N
55104	1739	28355927000000	18384	9001	0	0	\N
55108	1739	29519815000000	19572	9858	4	0	\N
55110	1739	29519837000000	19572	9858	5	0	\N
55111	1739	29521558000000	21653	10674	91	0	\N
55112	1739	30238828000000	23333	11457	0	0	\N
55113	1739	30239828000000	20363	10257	6	0	\N
55116	1739	30239855000000	20363	10257	7	0	\N
55117	1739	30241558000000	21653	10674	126	0	\N
55118	1739	30241898000000	21653	10674	127	0	\N
55119	1739	30242908000000	21846	10675	91	0	\N
55120	1739	30959840000000	24217	12053	3	0	\N
55121	1739	30959840000000	24416	12143	2	0	\N
55122	1739	30959840000000	24772	12300	3	0	\N
55123	1739	30959840000000	25431	12599	7	0	\N
55125	1739	30959851000000	24416	12143	3	0	\N
55127	1739	30959852000000	24217	12053	4	0	\N
55128	1739	30959852000000	24772	12300	4	0	\N
55129	1739	30959874000000	25431	12599	8	0	\N
55130	1739	30960611000000	26280	12831	76	0	\N
55131	1739	30962908000000	21846	10675	126	0	\N
55132	1739	30963248000000	21846	10675	127	0	\N
55135	1739	31680611000000	26280	12831	126	0	\N
55136	1739	31681101000000	26280	12831	127	0	\N
55137	1739	32399862000000	28262	13972	3	0	\N
55140	1739	32399874000000	28262	13972	4	0	\N
55143	1739	33839896000000	29266	14309	5	0	\N
55146	1739	33839937000000	29266	14309	6	0	\N
55147	1739	34559937000000	29413	14310	9	0	\N
55148	1739	34560045000000	29413	14310	10	0	\N
55149	1740	10000003	8603	4461	20	0	\N
55150	1740	274999975	21328	10707	4	0	\N
55154	1740	1439020000000	866	479	2	0	\N
55156	1740	1439130000000	866	479	3	0	\N
55161	1740	4770615000000	21243	10571	18	0	\N
55162	1740	4770615000000	21244	10668	2	0	\N
55163	1740	4770615000000	21245	10668	2	0	\N
55165	1740	4770626000000	21244	10668	3	0	\N
55166	1740	4770626000000	21245	10668	3	0	\N
55168	1740	4770824000000	21243	10571	19	0	\N
55169	1740	4841190000000	11115	5715	4	0	\N
55170	1740	4841190000000	11116	5715	4	0	\N
55171	1740	4841190000000	11173	5741	4	0	\N
55172	1740	4841190000000	11174	5741	4	0	\N
55173	1740	4841190000000	12489	6437	1	0	\N
55174	1740	4841190000000	12610	6504	2	0	\N
55175	1740	4841190000000	12785	6591	4	0	\N
55177	1740	4841190000000	12889	6644	2	0	\N
55178	1740	4841190000000	12890	6644	2	0	\N
55179	1740	4841191000000	12489	6437	2	0	\N
55180	1740	4841201000000	12610	6504	3	0	\N
55182	1740	4841201000000	12889	6644	3	0	\N
55183	1740	4841201000000	12890	6644	3	0	\N
55184	1740	4841212000000	12785	6591	5	0	\N
55185	1740	4841230000000	11115	5715	5	0	\N
55186	1740	4841230000000	11116	5715	5	0	\N
55187	1740	4841230000000	11173	5741	5	0	\N
55188	1740	4841230000000	11174	5741	5	0	\N
55191	1740	5490626000000	21272	10682	10	0	\N
55194	1740	5490654000000	21272	10682	11	0	\N
55199	1740	5757543000000	2107	1005	101	0	\N
55200	1740	6210645000001	21328	10707	3	0	\N
55202	1740	6210646000000	21330	10707	2	0	\N
55203	1740	6210648000000	21330	10707	3	0	\N
55207	1740	6476533000000	1645	886	1	0	\N
55209	1740	6476543000000	1645	886	2	0	\N
55211	1740	6477543000000	2107	1005	126	0	\N
55212	1740	6477783000000	2107	1005	127	0	\N
55215	1740	7001238000000	13453	6930	5	0	\N
55216	1740	7001238000000	13454	6930	4	0	\N
55153	1740	719030000000	1210	666	1	0	0
55155	1740	1439030000000	1210	666	2	0	0
55157	1740	2159030000000	1220	672	1	0	0
55158	1740	2159040000000	1220	672	2	0	0
55189	1740	5037539000000	1341	737	1	0	1
55197	1740	5756523000000	1483	809	1	0	3
55198	1740	5756533000000	1483	809	2	0	3
55208	1740	6476533000000	2109	1111	1	0	3
55210	1740	6476543000000	2109	1111	2	0	3
55159	1740	4121170000000	10758	5553	2	0	11
55176	1740	4841190000000	12888	6644	2	0	11
55181	1740	4841201000000	12888	6644	3	0	11
55195	1740	5561201000000	13109	6756	6	0	11
55196	1740	5561225000000	13109	6756	7	0	11
55206	1740	6281238000000	13330	6870	5	0	11
55081	1739	25199716000000	15125	7708	1	0	0
55082	1739	25199726000000	15125	7708	2	0	0
55086	1739	25919726000000	15418	7853	3	0	0
55088	1739	25919738000000	15418	7853	4	0	0
55094	1739	27359738000000	18702	9420	5	0	0
55096	1739	27359761000000	18702	9420	6	0	0
55100	1739	28079761000000	19044	9605	4	0	0
55102	1739	28079792000000	19044	9605	5	0	0
55105	1739	28799792000000	19492	9825	5	0	0
55107	1739	28799828000000	19900	10022	4	0	0
55109	1739	29519828000000	19900	10022	5	0	0
55164	1740	4770615000000	21246	10668	2	0	13
55167	1740	4770626000000	21246	10668	3	0	13
55193	1740	5490646000000	21273	10682	3	0	13
55201	1740	6210646000000	21329	10707	3	0	13
55204	1740	6210658000000	21329	10707	4	0	13
55213	1740	6930658000000	21451	10761	4	0	13
55214	1740	6930671000000	21451	10761	5	0	13
55115	1739	30239840000000	23665	11786	4	0	0
55124	1739	30959840000000	25927	12812	2	0	0
55126	1739	30959851000000	25927	12812	3	0	0
55133	1739	31679851000000	28139	13910	2	0	0
55134	1739	31679862000000	28139	13910	3	0	0
55139	1739	32399873000000	28352	14015	3	0	0
55141	1739	33119873000000	28873	14242	5	0	0
55142	1739	33119896000000	28873	14242	6	0	0
55144	1739	33839896000000	29907	14735	11	0	0
55217	1740	7001238000000	13682	7030	2	0	\N
55218	1740	7001238000000	13825	7077	0	0	\N
55220	1740	7001249000000	13682	7030	3	0	\N
55221	1740	7001251000000	13454	6930	5	0	\N
55222	1740	7001261000000	13453	6930	6	0	\N
55228	1740	7721238000000	13837	7078	126	0	\N
55229	1740	7721277000000	13835	7103	3	0	\N
55230	1740	7721277000000	14464	7383	4	0	\N
55231	1740	7721277000000	14465	7383	1	0	\N
55232	1740	7721277000000	14621	7453	3	0	\N
55234	1740	7721287000000	14465	7383	2	0	\N
55235	1740	7721289000000	13835	7103	4	0	\N
55236	1740	7721289000000	14621	7453	4	0	\N
55237	1740	7721290000000	14464	7383	5	0	\N
55239	1740	7721805000000	13837	7078	127	0	\N
55244	1740	8441313000000	14725	7497	2	0	\N
55246	1740	8441313000000	15002	7547	126	0	\N
55247	1740	8441324000000	14725	7497	3	0	\N
55249	1740	8442583000000	15002	7547	127	0	\N
55252	1740	9090695000000	22115	11059	4	0	\N
55255	1740	9090708000000	22115	11059	5	0	\N
55258	1740	9161892000000	16258	8159	54	0	\N
55261	1740	9810705000000	22281	11153	2	0	\N
55262	1740	9810705000000	22764	11382	5	0	\N
55263	1740	9810705000000	22765	11382	5	0	\N
55264	1740	9810705000000	23085	11528	2	0	\N
55265	1740	9810705000000	23086	11528	3	0	\N
55266	1740	9810705000000	23207	11585	2	0	\N
55267	1740	9810705000000	23211	11585	1	0	\N
55268	1740	9810705000000	23394	11671	4	0	\N
55270	1740	9810705000000	23570	11746	4	0	\N
55271	1740	9810706000000	23211	11585	2	0	\N
55272	1740	9810707000000	22281	11153	3	0	\N
55273	1740	9810716000000	23085	11528	3	0	\N
55274	1740	9810716000000	23207	11585	3	0	\N
55275	1740	9810717000000	23086	11528	4	0	\N
55276	1740	9810719000000	22764	11382	6	0	\N
55277	1740	9810719000000	22765	11382	6	0	\N
55278	1740	9810727000000	23394	11671	5	0	\N
55280	1740	9810727000000	23570	11746	5	0	\N
55283	1740	9881892000000	16258	8159	126	0	\N
55284	1740	9882602000000	16258	8159	127	0	\N
55285	1740	9882990000000	16293	8160	54	0	\N
55286	1740	10076603000000	3348	1740	5	0	\N
55287	1740	10076603000000	3684	1914	3	0	\N
55290	1740	10076633000000	3684	1914	4	0	\N
55291	1740	10076644000000	3348	1740	6	0	\N
55296	1740	10602990000000	16293	8160	126	0	\N
55297	1740	10603061000000	16293	8160	127	0	\N
55298	1740	10796123000000	4902	2249	0	0	\N
55299	1740	10796623000000	4672	2415	2	0	\N
55301	1740	10796623000000	4899	2247	0	0	\N
55303	1740	10796733000000	4672	2415	3	0	\N
55304	1740	11250764000000	24179	12036	1	0	\N
55305	1740	11250764000000	24181	12036	2	0	\N
55306	1740	11250764000000	24446	12109	9	0	\N
55308	1740	11250774000000	24179	12036	2	0	\N
55309	1740	11250775000000	24181	12036	3	0	\N
55311	1740	11251178000000	24446	12109	10	0	\N
55312	1740	11251306000000	24988	12360	62	0	\N
55315	1740	11516633000000	4848	2512	1	0	\N
55317	1740	11516643000000	4848	2512	2	0	\N
55319	1740	11970776000000	24625	12236	3	0	\N
55320	1740	11970776000000	24987	12399	11	0	\N
55322	1740	11970788000000	24625	12236	4	0	\N
55324	1740	11970823000000	24987	12399	12	0	\N
55325	1740	11971178000000	24622	12110	6	0	\N
55326	1740	11971306000000	24988	12360	126	0	\N
55327	1740	11971328000000	24622	12110	7	0	\N
55328	1740	11971369000000	24988	12360	127	0	\N
55333	1740	12690788000000	25373	12580	3	0	\N
55334	1740	12690800000000	25373	12580	4	0	\N
55335	1740	12761439000000	16625	8445	3	0	\N
55336	1740	12761439000000	17024	8623	3	0	\N
55337	1740	12761439000000	17025	8623	2	0	\N
55339	1740	12761441000000	17025	8623	3	0	\N
55340	1740	12761451000000	16625	8445	4	0	\N
55341	1740	12761451000000	17024	8623	4	0	\N
55343	1740	12956653000000	4913	2542	1	0	\N
55344	1740	12956653000000	5220	2714	2	0	\N
55346	1740	12956663000000	4913	2542	2	0	\N
55348	1740	12956673000000	5220	2714	3	0	\N
55350	1740	12956673000000	5320	2764	1	0	\N
55351	1740	12956673000000	5321	2764	1	0	\N
55240	1740	7916553000000	2363	1235	3	0	3
55241	1740	7916583000000	2363	1235	4	0	3
55250	1740	8636583000000	2888	1509	1	0	3
55251	1740	8636593000000	2888	1509	2	0	3
55259	1740	9356593000000	2890	1510	1	0	3
55288	1740	10076603000000	3756	1948	2	0	3
55289	1740	10076623000000	3756	1948	3	0	3
55300	1740	10796623000000	4733	2447	1	0	3
55302	1740	10796633000000	4733	2447	2	0	3
55316	1740	11516633000000	4876	2525	1	0	3
55331	1740	12236643000000	4900	2537	1	0	3
55332	1740	12236653000000	4900	2537	2	0	3
55345	1740	12956653000000	5275	2741	1	0	3
55347	1740	12956663000000	5275	2741	2	0	3
55219	1740	7001238000000	13826	7098	12	0	11
55223	1740	7001277000000	13826	7098	13	0	11
55233	1740	7721277000000	14633	7459	9	0	11
55238	1740	7721313000000	14633	7459	10	0	11
55245	1740	8441313000000	15001	7642	4	0	11
55256	1740	9161335000000	15777	8025	8	0	11
55257	1740	9161352000000	15777	8025	9	0	11
55281	1740	9881352000000	16255	8262	3	0	11
55282	1740	9881364000000	16255	8262	4	0	11
55294	1740	10601364000000	16292	8278	4	0	11
55313	1740	11321377000000	16312	8287	7	0	11
55314	1740	11321402000000	16312	8287	8	0	11
55329	1740	12041402000000	16353	8316	10	0	11
55330	1740	12041439000000	16353	8316	11	0	11
55342	1740	12761464000000	17058	8639	8	0	11
55226	1740	7650671000000	21488	10776	3	0	13
55227	1740	7650683000000	21488	10776	4	0	13
55242	1740	8370683000000	21886	10952	3	0	13
55243	1740	8370695000000	21886	10952	4	0	13
55254	1740	9090707000000	22171	11091	4	0	13
55269	1740	9810705000000	23569	11746	4	0	14
55279	1740	9810727000000	23569	11746	5	0	14
55292	1740	10530727000000	23848	11870	10	0	14
55293	1740	10530764000000	23848	11870	11	0	14
55310	1740	11250776000000	24447	12158	4	0	14
55321	1740	11970776000000	25075	12446	3	0	14
55323	1740	11970788000000	25075	12446	4	0	14
55352	1740	13410788000000	25695	12714	3	0	14
55356	1740	13676663000000	5282	2743	1	0	\N
55357	1740	13676673000000	5282	2743	2	0	\N
55359	1740	13676673000000	5320	2764	2	0	\N
55360	1740	13676673000000	5321	2764	2	0	\N
55366	1740	14850847000000	27295	13488	1	0	\N
55368	1740	14850848000000	27295	13488	2	0	\N
55370	1740	14921488000000	17208	8719	3	0	\N
55372	1740	14921500000000	17208	8719	4	0	\N
55376	1740	15045875000000	17896	8988	104	0	\N
55377	1740	15116673000000	5531	2876	0	0	\N
55382	1740	15642300000000	17540	8882	3	0	\N
55383	1740	15642312000000	17540	8882	4	0	\N
55384	1740	15765312000000	17895	9029	3	0	\N
55385	1740	15765312000000	18034	9044	15	0	\N
55387	1740	15765324000000	17895	9029	4	0	\N
55389	1740	15765417000000	18034	9044	16	0	\N
55390	1740	15765875000000	17896	8988	126	0	\N
55391	1740	15765896000000	17896	8988	127	0	\N
55394	1740	15837923000000	6873	3554	2	0	\N
55395	1740	15837923000000	6874	3554	2	0	\N
55396	1740	15837923000000	6875	3554	2	0	\N
55399	1740	16485332000000	18212	9175	3	0	\N
55400	1740	16485332000000	18213	9175	10	0	\N
55401	1740	16485332000000	18427	9276	54	0	\N
55404	1740	16485353000000	18212	9175	4	0	\N
55405	1740	16485387000000	18213	9175	11	0	\N
55406	1740	16485557000000	18427	9276	55	0	\N
55408	1740	16557922999990	6873	3554	3	0	\N
55409	1740	16557923000000	6874	3554	3	0	\N
55410	1740	16557923000000	6875	3554	3	0	\N
55414	1740	17205345000000	18649	9397	2	0	\N
55417	1740	17205356000000	18649	9397	3	0	\N
55418	1740	17277888000000	7468	3863	1	0	\N
55420	1740	17277898000000	7468	3863	2	0	\N
55422	1740	17277923000000	7174	3705	2	0	\N
55423	1740	17277943000000	7174	3705	3	0	\N
55424	1740	17277988000000	8603	4461	7	0	\N
55426	1740	17277988000000	8605	4461	7	0	\N
55431	1740	17997988000000	8603	4461	19	0	\N
55433	1740	17997988000000	8605	4461	19	0	\N
55435	1740	17998008000000	8605	4461	20	0	\N
55436	1740	18450977000000	28623	14089	26	0	\N
55439	1740	18451039000000	28623	14089	27	0	\N
55440	1740	18645356000000	19095	9632	3	0	\N
55441	1740	18645356000000	19096	9565	24	0	\N
55442	1740	18645356000000	19445	9801	0	0	\N
55444	1740	18645368000000	19095	9632	4	0	\N
55446	1740	18645479000000	19096	9565	25	0	\N
55448	1740	18715036000000	10456	5405	1	0	\N
55449	1740	18715036000000	10459	5405	1	0	\N
55450	1740	18718008000000	8890	4607	0	0	\N
55451	1740	18718008000000	8892	4607	2	0	\N
55453	1740	18718028000000	8892	4607	3	0	\N
55455	1740	19170987000000	28644	14142	4	0	\N
55458	1740	19171009000000	28644	14142	5	0	\N
55459	1740	19171039000000	28643	14090	4	0	\N
55460	1740	19171043000000	28643	14090	5	0	\N
55463	1740	19435026000000	9443	4897	2	0	\N
55464	1740	19435027000000	9307	4829	4	0	\N
55466	1740	19435036000000	10456	5405	14	0	\N
55467	1740	19435036000000	10459	5405	14	0	\N
55468	1740	19435046000000	9443	4897	3	0	\N
55469	1740	19435058000000	9307	4829	5	0	\N
55471	1740	19435156000000	10456	5405	15	0	\N
55472	1740	19435156000000	10459	5405	15	0	\N
55473	1740	19890998000000	28662	14150	1	0	\N
55474	1740	19890998000000	29160	14378	2	0	\N
55475	1740	19890998000000	29653	14623	7	0	\N
55477	1740	19891008000000	28662	14150	2	0	\N
55478	1740	19891009000000	29160	14378	3	0	\N
55479	1740	19891014000000	29653	14623	8	0	\N
55481	1740	19891043000000	28658	14091	5	0	\N
55482	1740	19891048000000	28658	14091	6	0	\N
55483	1740	20085541000000	20045	10090	4	0	\N
55484	1740	20085541000000	20050	10092	3	0	\N
55486	1740	20085553000000	20050	10092	4	0	\N
55487	1740	20085554000000	20045	10090	5	0	\N
55378	1740	15116673000000	6288	3257	1	0	3
55379	1740	15116683000000	6288	3257	2	0	3
55392	1740	15836683000000	6464	3349	3	0	3
55393	1740	15837903000000	6464	3349	4	0	3
55407	1740	16557903000000	7059	3644	2	0	3
55419	1740	17277888000000	8016	4154	3	0	5
55421	1740	17277918000000	8016	4154	4	0	5
55425	1740	17277988000000	8604	4461	7	0	5
55432	1740	17997988000000	8604	4461	19	0	5
55434	1740	17998008000000	8604	4461	20	0	5
55454	1740	18718028000000	9182	4758	3	0	5
55447	1740	18715036000000	10455	5405	1	0	7
55465	1740	19435036000000	10455	5405	14	0	7
55470	1740	19435146000000	10455	5405	15	0	7
55355	1740	13481475000000	17119	8673	3	0	11
55363	1740	14201475000000	17141	8687	4	0	11
55364	1740	14201488000000	17141	8687	5	0	11
55371	1740	14921488000000	17330	8779	11	0	11
55373	1740	14922300000000	17330	8779	12	0	11
55375	1740	15045312000000	17539	8882	4	0	11
55386	1740	15765312000000	18035	9098	4	0	11
55388	1740	15765334000000	18035	9098	5	0	11
55402	1740	16485332000000	18428	9291	4	0	12
55403	1740	16485345000000	18428	9291	5	0	12
55416	1740	17205346000000	18650	9397	2	0	12
55429	1740	17925346000000	18937	9553	1	0	12
55430	1740	17925356000000	18937	9553	2	0	12
55443	1740	18645356000000	19664	9905	3	0	12
55461	1740	19365386000000	20009	10073	11	0	12
55462	1740	19365541000000	20009	10073	12	0	12
55485	1740	20085541000000	20747	10430	7	0	12
55488	1740	20085584000000	20747	10430	8	0	12
55353	1740	13410800000000	25695	12714	4	0	14
55362	1740	14130847000000	26295	13007	12	0	14
55367	1740	14850847000000	27296	13491	3	0	14
55369	1740	14850859000000	27296	13491	4	0	14
55380	1740	15570859000000	27362	13528	3	0	14
55381	1740	15570871000000	27362	13528	4	0	14
55398	1740	16290883000000	27431	13560	4	0	14
55412	1740	17010883000000	27603	13642	9	0	14
55413	1740	17010955000000	27603	13642	10	0	14
55427	1740	17730955000000	27776	13724	4	0	14
55437	1740	18450977000000	28624	14134	1	0	14
55438	1740	18450987000000	28624	14134	2	0	14
55456	1740	19170987000000	28659	14149	2	0	14
55457	1740	19170998000000	28659	14149	3	0	14
55476	1740	19890998000000	29762	14668	14	0	14
55491	1740	20611021000000	30132	14827	11	0	\N
55492	1740	20611021000000	30133	14827	5	0	\N
55493	1740	20611035000000	30133	14827	6	0	\N
55494	1740	20611041000000	30132	14827	12	0	\N
55495	1740	20611048000000	28660	14092	0	0	\N
55496	1740	20611494000000	29159	14093	32	0	\N
55500	1740	20875165000000	10631	5490	2	0	\N
55502	1740	20875185000000	10631	5490	3	0	\N
55503	1740	21331494000000	29159	14093	46	0	\N
55504	1740	21331506999998	29159	14093	47	0	\N
55507	1740	22245617000000	21034	10572	2	0	\N
55508	1740	22245617000000	21036	10535	0	0	\N
55509	1740	22245617000000	21037	10554	0	0	\N
55510	1740	22245628000000	21034	10572	3	0	\N
55511	1741	719000000000	834	459	1	0	\N
55512	1741	719000000000	11866	6098	1	0	\N
55513	1741	719000000000	13720	7051	4	0	\N
55515	1741	719001000000	11866	6098	2	0	\N
55516	1741	719010000000	834	459	2	0	\N
55518	1741	719013000000	13720	7051	5	0	\N
55521	1744	200000020	7819	4054	6	1	\N
55522	1744	900000500	2911	1518	5	0	\N
55523	1744	900000500	2915	1519	1	0	\N
55524	1744	900500000	2910	1518	0	0	\N
55525	1744	900500000	3704	1923	1	0	\N
55526	1744	901000000	3704	1923	3	0	\N
55527	1744	905000000	27065	13382	2	0	\N
55528	1744	905000000	28639	13934	87	0	\N
55529	1744	1600500000	6992	3610	11	1	\N
55530	1744	7200158999000	2915	1519	2	0	\N
55531	1744	7201489500000	3840	1891	127	1	\N
55532	1744	66720048499000	2911	1518	6	1	\N
55533	1746	719000000000	1269	701	1	0	\N
55535	1746	719010000000	1269	701	2	0	\N
55537	1746	1439010000000	1641	885	1	0	\N
55538	1746	1439010000000	2158	1140	2	0	\N
55539	1746	1439010000000	2169	1144	2	0	\N
55540	1746	1439010000000	2333	1220	3	0	\N
55541	1746	1439010000000	2884	1507	1	0	\N
55543	1746	1439020000000	1641	885	2	0	\N
55544	1746	1439020000000	2884	1507	2	0	\N
55546	1746	1439030000000	2158	1140	3	0	\N
55547	1746	1439040000000	2333	1220	4	0	\N
55548	1746	1439120000000	2169	1144	3	0	\N
55549	1746	1968843000000	23866	11879	3	0	\N
55551	1746	1968855000000	23866	11879	4	0	\N
55555	1746	2688887000000	24332	12101	11	0	\N
55556	1746	2688887000000	24352	12111	2	0	\N
55557	1746	2688887000000	24908	12367	4	0	\N
55558	1746	2688887000000	25134	12471	7	0	\N
55559	1746	2688887000000	25270	12535	7	0	\N
55561	1746	2688887000000	25309	12532	0	0	\N
55562	1746	2688898000000	24352	12111	3	0	\N
55563	1746	2688900000000	24908	12367	5	0	\N
55565	1746	2688912000000	25134	12471	8	0	\N
55566	1746	2688912000000	25270	12535	8	0	\N
55568	1746	2688934000000	24332	12101	12	0	\N
55569	1746	2879030000000	3409	1773	2	0	\N
55570	1746	2879030000000	3620	1878	0	0	\N
55571	1746	2879030000000	4639	2399	1	0	\N
55572	1746	2879030000000	4724	2444	2	0	\N
55574	1746	2879040000000	4639	2399	2	0	\N
55576	1746	2879050000000	3409	1773	3	0	\N
55577	1746	2879050000000	4724	2444	3	0	\N
55578	1746	2879060000000	6869	3554	2	0	\N
55579	1746	3408911000000	25311	12546	0	0	\N
55580	1746	3408911000000	25499	12626	3	0	\N
55581	1746	3408911000000	25604	12672	6	0	\N
55582	1746	3408911000000	25648	12693	3	0	\N
55583	1746	3408923000000	25499	12626	4	0	\N
55584	1746	3408923000000	25648	12693	4	0	\N
55587	1746	3408935000000	25604	12672	7	0	\N
55588	1746	3599040000000	5125	2659	2	0	\N
55589	1746	3599040000000	5237	2720	3	0	\N
55590	1746	3599040000000	5249	2725	0	0	\N
55591	1746	3599040000000	5567	2894	0	0	\N
55592	1746	3599040000000	5587	2905	0	0	\N
55593	1746	3599040000000	5824	3022	1	0	\N
55594	1746	3599040000000	6196	3208	1	0	\N
55595	1746	3599040000000	6272	3250	4	0	\N
55596	1746	3599040000000	6413	3324	6	0	\N
55597	1746	3599040000000	6655	3442	2	0	\N
55598	1746	3599040000000	6723	3479	2	0	\N
55600	1746	3599050000000	5824	3022	2	0	\N
55601	1746	3599050000000	6196	3208	2	0	\N
55602	1746	3599060000000	5125	2659	3	0	\N
55603	1746	3599060000000	6655	3442	3	0	\N
55604	1746	3599060000000	6723	3479	3	0	\N
55605	1746	3599060000000	6869	3554	3	0	\N
55606	1746	3599070000000	5237	2720	4	0	\N
55607	1746	3599080000000	6272	3250	5	0	\N
55609	1746	3599100000000	6413	3324	7	0	\N
55612	1746	4319081000000	6916	3572	2	0	\N
55613	1746	4319081000000	7382	3812	1	0	\N
55614	1746	4319081000000	7667	3969	2	0	\N
55615	1746	4319081000000	7702	3991	1	0	\N
55617	1746	4319091000000	7382	3812	2	0	\N
55618	1746	4319091000000	7702	3991	2	0	\N
55620	1746	4319101000000	6916	3572	3	0	\N
55621	1746	4319101000000	7667	3969	3	0	\N
55622	1746	4834299000000	11649	5993	2	0	\N
55623	1746	4834299000000	11666	5999	1	0	\N
55624	1746	4834299000000	11803	6067	1	0	\N
55542	1746	1439010000000	3221	1674	1	0	0
55545	1746	1439020000000	3221	1674	2	0	0
55553	1746	2159020000000	3390	1764	1	0	0
55554	1746	2159030000000	3390	1764	2	0	0
55573	1746	2879030000000	4896	2536	1	0	0
55599	1746	3599040000000	6883	3557	5	0	0
55608	1746	3599081000000	6883	3557	6	0	0
55616	1746	4319081000000	7717	3998	1	0	0
55619	1746	4319091000000	7717	3998	2	0	0
55489	1740	20155145000000	10606	5478	2	0	8
55499	1740	20875165000000	10629	5490	1	0	8
55501	1740	20875175000000	10629	5490	2	0	8
55497	1740	20805584000000	20861	10486	3	0	12
55498	1740	20805605000000	20861	10486	4	0	12
55506	1740	21525617000000	20874	10493	4	0	12
55550	1746	1968843000000	24086	11990	8	0	7
55552	1746	1968887000000	24086	11990	9	0	7
55560	1746	2688887000000	25278	12539	6	0	7
55564	1746	2688911000000	25278	12539	7	0	7
55517	1741	719011000000	25540	12644	3	0	0
55567	1746	2688931000000	25658	12697	2	0	7
55585	1746	3408931000000	25658	12697	7	0	7
55586	1746	3408934999989	25658	12697	8	1	7
55610	1746	4128934999989	25762	12742	3	0	7
55519	1741	1439011000000	25972	12832	2	0	0
55520	1741	1439022000000	25972	12832	3	0	0
55625	1746	4834299000000	12352	6369	1	0	\N
55626	1746	4834299000000	12545	6465	2	0	\N
55628	1746	4834300000000	11666	5999	2	0	\N
55629	1746	4834300000000	11803	6067	2	0	\N
55630	1746	4834300000000	12352	6369	2	0	\N
55631	1746	4834301000000	11649	5993	3	0	\N
55632	1746	4834310000000	12545	6465	3	0	\N
55634	1746	4848946999989	25796	12757	2	0	\N
55635	1746	4848946999989	25854	12783	3	0	\N
55636	1746	4848946999989	25873	12789	6	0	\N
55638	1746	4848957999989	25796	12757	3	0	\N
55640	1746	4848958999989	25854	12783	4	0	\N
55641	1746	4848970999989	25873	12789	7	0	\N
55642	1746	5039091000000	7943	4116	1	0	\N
55643	1746	5039091000000	7996	4147	1	0	\N
55644	1746	5039091000000	8030	4163	3	0	\N
55645	1746	5039091000000	8083	4192	1	0	\N
55647	1746	5039101000000	7943	4116	2	0	\N
55648	1746	5039101000000	7996	4147	2	0	\N
55649	1746	5039101000000	8083	4192	2	0	\N
55650	1746	5039121000000	8030	4163	4	0	\N
55652	1746	5554310000000	13057	6732	16	0	\N
55653	1746	5554310000000	13312	6859	3	0	\N
55654	1746	5554310000000	13438	6924	1	0	\N
55655	1746	5554310000000	13557	6973	1	0	\N
55656	1746	5554310000000	13740	7061	4	0	\N
55658	1746	5554320000000	13438	6924	2	0	\N
55659	1746	5554320000000	13557	6973	2	0	\N
55660	1746	5554322000000	13312	6859	4	0	\N
55661	1746	5554323000000	13740	7061	5	0	\N
55663	1746	5554434000000	13057	6732	17	0	\N
55664	1746	5568957999989	26639	13179	9	0	\N
55665	1746	5568957999989	26793	13249	3	0	\N
55666	1746	5568957999989	26877	13293	3	0	\N
55667	1746	5568957999989	26991	13350	3	0	\N
55668	1746	5568957999989	27637	13659	0	0	\N
55669	1746	5568957999989	27744	13706	2	0	\N
55670	1746	5568957999989	27807	13740	6	0	\N
55672	1746	5568968999989	27744	13706	3	0	\N
55673	1746	5568969999989	26793	13249	4	0	\N
55674	1746	5568969999989	26877	13293	4	0	\N
55675	1746	5568969999989	26991	13350	4	0	\N
55677	1746	5568981999989	27807	13740	7	0	\N
55678	1746	5568993999989	26639	13179	10	0	\N
55679	1746	5759121000000	8661	4485	1	0	\N
55680	1746	5759121000000	8851	4587	2	0	\N
55681	1746	5759121000000	8900	4611	3	0	\N
55683	1746	5759131000000	8661	4485	2	0	\N
55684	1746	5759141000000	8851	4587	3	0	\N
55686	1746	5759151000000	8900	4611	4	0	\N
55687	1746	6274323000000	13977	7161	4	0	\N
55688	1746	6274323000000	14315	7305	3	0	\N
55690	1746	6274335000000	14315	7305	4	0	\N
55691	1746	6274336000000	13977	7161	5	0	\N
55693	1746	6288969999989	27996	13846	3	0	\N
55694	1746	6288969999989	28059	13874	3	0	\N
55695	1746	6288969999989	28184	13932	3	0	\N
55698	1746	6288981999989	27996	13846	4	0	\N
55699	1746	6288981999989	28059	13874	4	0	\N
55700	1746	6288981999989	28184	13932	4	0	\N
55701	1746	6288990999989	28768	14190	1	0	\N
55702	1746	6479141000000	9502	4929	3	0	\N
55705	1746	6479411000000	9502	4929	4	0	\N
55706	1746	6994336000000	15676	7978	4	0	\N
55707	1746	6994336000000	15812	8048	14	0	\N
55709	1746	6994349000000	15676	7978	5	0	\N
55711	1746	6994413000000	15812	8048	15	0	\N
55712	1746	7008980999989	28540	14100	2	0	\N
55713	1746	7008980999989	29068	14331	4	0	\N
55714	1746	7008980999989	29205	14395	6	0	\N
55715	1746	7008980999989	29235	14408	4	0	\N
55716	1746	7008980999989	29418	14504	4	0	\N
55717	1746	7008980999989	29584	14588	3	0	\N
55718	1746	7008980999989	30015	14710	0	0	\N
55719	1746	7008980999989	30018	14721	0	0	\N
55720	1746	7008980999989	30021	14732	0	0	\N
55721	1746	7008980999989	30023	14755	0	0	\N
55722	1746	7008980999989	30171	14844	8	0	\N
55723	1746	7008980999989	30215	14859	10	0	\N
55724	1746	7008980999989	30298	14894	5	0	\N
55725	1746	7008990999989	28768	14190	9	0	\N
55726	1746	7008991999989	28540	14100	3	0	\N
55727	1746	7008992999989	29584	14588	4	0	\N
55728	1746	7008993999989	29068	14331	5	0	\N
55729	1746	7008993999989	29235	14408	5	0	\N
55730	1746	7008993999989	29418	14504	5	0	\N
55731	1746	7008995999989	29205	14395	7	0	\N
55732	1746	7008997999989	30171	14844	9	0	\N
55733	1746	7009006999989	28768	14190	10	0	\N
55734	1746	7009007934858	30215	14859	13	0	\N
55735	1746	7009093999989	30298	14894	6	0	\N
55736	1746	7199181000000	9593	4976	2	0	\N
55737	1746	7199181000000	9767	5061	11	0	\N
55739	1746	7199201000000	9593	4976	3	0	\N
55741	1746	7199246000000	9767	5061	12	0	\N
55742	1746	7714360000000	16183	8226	11	0	\N
55743	1746	7714360000000	16278	8274	4	0	\N
55744	1746	7714360000000	16410	8347	3	0	\N
55745	1746	7714360000000	16480	8381	3	0	\N
55746	1746	7714360000000	16737	8500	5	0	\N
55749	1746	7714372000000	16410	8347	4	0	\N
55750	1746	7714372000000	16480	8381	4	0	\N
55751	1746	7714373000000	16278	8274	5	0	\N
55752	1746	7714383000000	16737	8500	6	0	\N
55753	1746	7714398000000	16183	8226	12	0	\N
55756	1746	8434371000000	16988	8605	2	0	\N
55757	1746	8434371000000	17254	8739	6	0	\N
55758	1746	8434371000000	17481	8851	8	0	\N
55759	1746	8434371000000	17484	8852	8	0	\N
55760	1746	8434371000000	17555	8888	3	0	\N
55682	1746	5759121000000	9479	4916	2	0	0
55685	1746	5759141000000	9479	4916	3	0	0
55703	1746	6479141000000	9540	4947	4	0	0
55704	1746	6479181000000	9540	4947	5	0	0
55738	1746	7199181000000	9982	5176	6	0	0
55754	1746	7919241000000	10355	5358	2	0	0
55755	1746	7919261000000	10355	5358	3	0	0
55627	1746	4834299000000	12970	6689	2	0	2
55633	1746	4834310000000	12970	6689	3	0	2
55657	1746	5554310000000	13922	7138	4	0	2
55689	1746	6274323000000	14320	7306	4	0	2
55692	1746	6274336000000	14320	7306	5	0	2
55708	1746	6994336000000	15969	8117	6	0	2
55710	1746	6994360000000	15969	8117	7	0	2
55748	1746	7714371000000	16975	8600	3	0	2
55637	1746	4848946999989	26075	12887	2	0	7
55639	1746	4848957999989	26075	12887	3	0	7
55671	1746	5568957999989	27851	13766	3	0	7
55676	1746	5568969999989	27851	13766	4	0	7
55697	1746	6288980999989	28335	14007	3	0	7
55761	1746	8434371000000	17609	8907	4	0	\N
55762	1746	8434371000000	17854	9012	3	0	\N
55763	1746	8434371000000	18292	9217	3	0	\N
55764	1746	8434371000000	18295	9218	3	0	\N
55765	1746	8434371000000	18341	9240	0	0	\N
55766	1746	8434371000000	18349	9244	7	0	\N
55767	1746	8434371000000	18973	9570	2	0	\N
55768	1746	8434371000000	18992	9577	2	0	\N
55769	1746	8434371000000	19046	9606	1	0	\N
55770	1746	8434371000000	19057	9612	2	0	\N
55771	1746	8434371000000	19225	9697	5	0	\N
55773	1746	8434381000000	19046	9606	2	0	\N
55774	1746	8434382000000	16988	8605	3	0	\N
55775	1746	8434382000000	18973	9570	3	0	\N
55776	1746	8434382000000	18992	9577	3	0	\N
55777	1746	8434382000000	19057	9612	3	0	\N
55778	1746	8434383000000	17555	8888	4	0	\N
55779	1746	8434383000000	17854	9012	4	0	\N
55780	1746	8434383000000	18292	9217	4	0	\N
55781	1746	8434383000000	18295	9218	4	0	\N
55783	1746	8434384000000	17609	8907	5	0	\N
55784	1746	8434394000000	19225	9697	6	0	\N
55785	1746	8434395000000	17254	8739	7	0	\N
55786	1746	8434405000000	18349	9244	8	0	\N
55787	1746	8434424000000	17484	8852	9	0	\N
55788	1746	8434433000000	17481	8851	9	0	\N
55795	1746	9874395000000	19500	9830	4	0	\N
55796	1746	9874395000000	19528	9838	4	0	\N
55798	1746	9874408000000	19500	9830	5	0	\N
55799	1746	9874408000000	19528	9838	5	0	\N
55801	1746	10079301000000	11135	5723	2	0	\N
55802	1746	10079301000000	11206	5754	6	0	\N
55803	1746	10079321000000	11135	5723	3	0	\N
55804	1746	10079442000000	11206	5754	7	0	\N
55805	1746	10594420000000	20393	10276	3	0	\N
55807	1746	10594432000000	20393	10276	4	0	\N
55810	1746	11314433000000	21094	10596	4	0	\N
55813	1746	11314455000000	21094	10596	5	0	\N
55814	1746	12034444000000	21480	10772	4	0	\N
55817	1746	12034457000000	21480	10772	5	0	\N
55818	1746	12754456000000	22073	11037	6	0	\N
55821	1746	12754498000000	22073	11037	7	0	\N
55826	1747	719000000000	1270	701	1	0	\N
55827	1747	719000000000	1410	769	1	0	\N
55828	1747	719000000000	1640	885	1	0	\N
55830	1747	719010000000	1270	701	2	0	\N
55831	1747	719010000000	1410	769	2	0	\N
55832	1747	719010000000	1640	885	2	0	\N
55838	1747	1456806000000	11647	5993	2	0	\N
55839	1747	1456806000000	11664	5999	1	0	\N
55840	1747	1456806000000	11804	6067	1	0	\N
55841	1747	1456806000000	12354	6369	1	0	\N
55843	1747	1456807000000	11664	5999	2	0	\N
55844	1747	1456807000000	11804	6067	2	0	\N
55845	1747	1456807000000	12354	6369	2	0	\N
55846	1747	1456808000000	11647	5993	3	0	\N
55848	1747	1505943000000	24087	11990	8	0	\N
55849	1747	1505943000000	24333	12101	11	0	\N
55853	1747	1505987000000	24087	11990	9	0	\N
55854	1747	1505990000000	24333	12101	12	0	\N
55855	1747	1506084000000	25271	12515	13	0	\N
55857	1747	2176817000000	12974	6689	2	0	\N
55858	1747	2176817000000	13058	6732	16	0	\N
55859	1747	2176817000000	13314	6859	3	0	\N
55860	1747	2176817000000	13439	6924	4	0	\N
55862	1747	2176828000000	12974	6689	3	0	\N
55863	1747	2176829000000	13314	6859	4	0	\N
55864	1747	2176830000000	13439	6924	5	0	\N
55866	1747	2176941000000	13058	6732	17	0	\N
55867	1747	2225954000000	24907	12367	4	0	\N
55868	1747	2225954000000	25135	12471	7	0	\N
55869	1747	2225954000000	25275	12539	4	0	\N
55870	1747	2225967000000	24907	12367	5	0	\N
55872	1747	2225976000000	25275	12539	5	0	\N
55873	1747	2225979000000	25135	12471	8	0	\N
55874	1747	2226084000000	25271	12515	110	0	\N
55875	1747	2226351000000	25271	12515	111	0	\N
55880	1747	2945974999992	25497	12626	3	0	\N
55882	1747	2945986999992	25497	12626	4	0	\N
55884	1747	3599140000000	3223	1674	1	0	\N
55885	1747	3599140000000	3391	1764	1	0	\N
55886	1747	3599140000000	3411	1773	2	0	\N
55887	1747	3599140000000	3621	1878	0	0	\N
55889	1747	3599150000000	3223	1674	2	0	\N
55890	1747	3599150000000	3391	1764	2	0	\N
55892	1747	3599160000000	3411	1773	3	0	\N
55893	1747	3616846000000	13921	7138	4	0	\N
55895	1747	3616859000000	13921	7138	5	0	\N
55836	1747	1439020000000	2168	1144	2	0	0
55837	1747	1439130000000	2168	1144	3	0	0
55856	1747	2159130000000	2330	1220	0	0	0
55876	1747	2879130000000	2885	1507	1	0	0
55877	1747	2879140000000	2885	1507	2	0	0
55891	1747	3599150000000	4638	2399	2	0	0
55789	1746	8639261000000	10718	5532	2	0	0
55790	1746	8639281000000	10718	5532	3	0	0
55793	1746	9359281000000	11048	5684	2	0	0
55794	1746	9359301000000	11048	5684	3	0	0
55847	1747	1456817000000	12546	6465	3	0	5
55861	1747	2176817000000	13558	6973	7	0	5
55865	1747	2176833000000	13558	6973	8	0	5
55878	1747	2896833000000	13739	7061	4	0	5
55894	1747	3616846000000	13975	7161	4	0	5
55896	1747	3616859000000	13975	7161	5	0	5
55772	1746	8434371000000	19273	9717	3	0	2
55782	1746	8434383000000	19273	9717	4	0	2
55791	1746	9154383000000	19312	9739	3	0	2
55797	1746	9874395000000	19972	10058	7	0	2
55800	1746	9874420000000	19972	10058	8	0	2
55806	1746	10594420000000	20499	10322	4	0	2
55808	1746	10594433000000	20499	10322	5	0	2
55809	1746	10594443000000	21196	10643	1	0	2
55812	1746	11314444000000	21196	10643	4	0	2
55815	1746	12034444000000	21534	10801	3	0	2
55816	1746	12034456000000	21534	10801	4	0	2
55819	1746	12754456000000	22134	11071	4	0	2
55822	1746	13474469000000	23376	11664	2	0	2
55823	1746	13474480000000	23376	11664	3	0	2
55824	1746	14194480000000	23474	11705	3	0	2
55825	1746	14194492000000	23474	11705	4	0	2
55834	1747	785931000000	23865	11879	3	0	6
55850	1747	1505943000000	24353	12111	2	0	6
55851	1747	1505954000000	24353	12111	3	0	6
55852	1747	1505975000000	25308	12557	3	0	6
55871	1747	2225974999992	25308	12557	4	0	6
55881	1747	2945974999992	25605	12672	6	0	6
55899	1747	3666030999992	25657	12697	2	0	\N
55900	1747	4319150000000	4723	2444	2	0	\N
55901	1747	4319150000000	4897	2536	0	0	\N
55902	1747	4319150000000	5126	2659	2	0	\N
55903	1747	4319150000000	5238	2720	3	0	\N
55905	1747	4319170000000	4723	2444	3	0	\N
55906	1747	4319170000000	5126	2659	3	0	\N
55907	1747	4319180000000	5238	2720	4	0	\N
55910	1747	4386010999992	25763	12742	3	0	\N
55911	1747	4386010999992	25798	12757	2	0	\N
55912	1747	4386010999992	25855	12783	3	0	\N
55913	1747	4386010999992	25875	12789	6	0	\N
55914	1747	4386010999992	26076	12887	2	0	\N
55915	1747	4386010999992	26641	13179	9	0	\N
55916	1747	4386010999992	26795	13249	3	0	\N
55917	1747	4386010999992	26880	13293	3	0	\N
55919	1747	4386021999992	25798	12757	3	0	\N
55920	1747	4386021999992	26076	12887	3	0	\N
55921	1747	4386022999992	25763	12742	4	0	\N
55922	1747	4386022999992	25855	12783	4	0	\N
55923	1747	4386022999992	26795	13249	4	0	\N
55924	1747	4386022999992	26880	13293	4	0	\N
55926	1747	4386030999992	25657	12697	7	0	\N
55927	1747	4386034999992	25657	12697	8	0	\N
55928	1747	4386034999992	25875	12789	7	0	\N
55929	1747	4386046999992	26641	13179	10	0	\N
55930	1747	5039150000000	5564	2894	0	0	\N
55931	1747	5039150000000	5584	2905	0	0	\N
55932	1747	5039150000000	5823	3022	1	0	\N
55933	1747	5039150000000	6198	3208	1	0	\N
55934	1747	5039150000000	6274	3250	4	0	\N
55935	1747	5039150000000	6416	3324	6	0	\N
55936	1747	5039150000000	6656	3442	2	0	\N
55938	1747	5039160000000	5823	3022	2	0	\N
55939	1747	5039160000000	6198	3208	2	0	\N
55940	1747	5039170000000	6656	3442	3	0	\N
55942	1747	5039190000000	6274	3250	5	0	\N
55943	1747	5039190000000	6871	3554	2	0	\N
55944	1747	5039210000000	6416	3324	7	0	\N
55945	1747	5056871000000	14321	7306	4	0	\N
55946	1747	5056871000000	15678	7978	4	0	\N
55947	1747	5056871000000	15811	8048	11	0	\N
55948	1747	5056871000000	15967	8117	6	0	\N
55949	1747	5056871000000	16182	8226	11	0	\N
55951	1747	5056884000000	14321	7306	5	0	\N
55952	1747	5056884000000	15678	7978	5	0	\N
55954	1747	5056895000000	15967	8117	7	0	\N
55955	1747	5056909000000	16182	8226	12	0	\N
55956	1747	5056945000000	15811	8048	12	0	\N
55957	1747	5106022999992	27639	13659	0	0	\N
55958	1747	5106022999992	27743	13706	2	0	\N
55960	1747	5106033999992	27743	13706	3	0	\N
55962	1747	5759170000000	6881	3557	5	0	\N
55963	1747	5759170000000	6917	3572	2	0	\N
55966	1747	5759190000000	6871	3554	3	0	\N
55967	1747	5759190000000	6917	3572	3	0	\N
55968	1747	5759211000000	6881	3557	6	0	\N
55971	1747	5826046999992	27849	13766	3	0	\N
55973	1747	5826058999992	27849	13766	4	0	\N
55975	1747	6479180000000	7666	3969	2	0	\N
55978	1747	6479200000000	7666	3969	3	0	\N
55981	1747	6546058999992	28058	13874	3	0	\N
55983	1747	6546070999992	28058	13874	4	0	\N
55986	1747	7199190000000	7718	3998	1	0	\N
55987	1747	7199190000000	7944	4116	1	0	\N
55988	1747	7199190000000	7999	4000	0	0	\N
55989	1747	7199190000000	8003	4028	0	0	\N
55990	1747	7199200000000	7718	3998	2	0	\N
55991	1747	7199200000000	7944	4116	2	0	\N
55992	1747	7216908000000	16736	8500	5	0	\N
55993	1747	7216908000000	16974	8600	2	0	\N
55994	1747	7216908000000	16989	8605	2	0	\N
55995	1747	7216908000000	17252	8739	6	0	\N
55996	1747	7216908000000	17483	8851	8	0	\N
55997	1747	7216908000000	17486	8852	8	0	\N
55998	1747	7216908000000	17556	8888	3	0	\N
55999	1747	7216908000000	17611	8907	4	0	\N
56000	1747	7216908000000	17857	9012	3	0	\N
56002	1747	7216919000000	16974	8600	3	0	\N
56003	1747	7216919000000	16989	8605	3	0	\N
56004	1747	7216920000000	17556	8888	4	0	\N
56005	1747	7216920000000	17857	9012	4	0	\N
56007	1747	7216921000000	17611	8907	5	0	\N
56008	1747	7216931000000	16736	8500	6	0	\N
56009	1747	7216932000000	17252	8739	7	0	\N
56010	1747	7216961000000	17486	8852	9	0	\N
56011	1747	7216970000000	17483	8851	9	0	\N
56012	1747	7266070999992	28334	14007	2	0	\N
56014	1747	7266081999992	28334	14007	3	0	\N
56016	1747	7266091999992	28767	14190	1	0	\N
56019	1747	7936920000000	18294	9218	3	0	\N
56021	1747	7936932000000	18294	9218	4	0	\N
56023	1747	7986081999992	29067	14331	4	0	\N
56024	1747	7986091999992	28767	14190	9	0	\N
56025	1747	7986094999992	29067	14331	5	0	\N
56027	1747	7986107999992	28767	14190	10	0	\N
56028	1747	8638700000000	8232	4266	3	0	\N
56029	1747	8638700000000	8664	4485	1	0	\N
56030	1747	8638700000000	8855	4587	2	0	\N
56031	1747	8638700000000	8903	4610	3	0	\N
56032	1747	8638700000000	9480	4916	2	0	\N
55941	1747	5039170000000	6724	3479	3	0	0
55964	1747	5759170000000	7383	3812	1	0	0
55965	1747	5759180000000	7383	3812	2	0	0
55976	1747	6479180000000	7703	3991	1	0	0
55977	1747	6479190000000	7703	3991	2	0	0
56017	1747	7918690000000	8084	4192	1	0	0
56018	1747	7918700000000	8084	4192	2	0	0
55908	1747	4336859000000	14317	7305	3	0	5
55909	1747	4336871000000	14317	7305	4	0	5
55950	1747	5056871000000	16277	8274	4	0	5
55969	1747	5776884000000	16409	8347	3	0	5
55970	1747	5776896000000	16409	8347	4	0	5
55979	1747	6496896000000	16479	8381	3	0	5
55980	1747	6496908000000	16479	8381	4	0	5
56006	1747	7216920000000	18290	9217	4	0	5
56020	1747	7936920000000	18339	9240	0	0	5
55897	1747	3665998999992	25647	12693	3	0	6
55898	1747	3666010999992	25647	12693	4	0	6
55918	1747	4386010999992	26990	13350	3	0	6
55959	1747	5106022999992	27808	13740	6	0	6
55961	1747	5106046999992	27808	13740	7	0	6
55972	1747	5826046999992	27997	13846	3	0	6
55974	1747	5826058999992	27997	13846	4	0	6
55982	1747	6546058999992	28185	13932	3	0	6
56013	1747	7266070999992	28539	14100	2	0	6
56015	1747	7266081999992	28539	14100	3	0	6
56022	1747	7986081999991	29206	14395	6	0	6
56026	1747	7986096599975	29206	14395	7	1	6
56034	1747	8638710000000	8664	4485	2	0	\N
56035	1747	8638720000000	8855	4587	3	0	\N
56036	1747	8638720000000	9480	4916	3	0	\N
56037	1747	8638730000000	8232	4266	4	0	\N
56038	1747	8638730000000	8903	4610	4	0	\N
56040	1747	8656920000000	18346	9244	7	0	\N
56041	1747	8656920000000	18972	9570	2	0	\N
56042	1747	8656920000000	18991	9577	2	0	\N
56043	1747	8656920000000	19045	9606	1	0	\N
56044	1747	8656920000000	19056	9612	2	0	\N
56045	1747	8656920000000	19230	9697	5	0	\N
56046	1747	8656920000000	19276	9717	3	0	\N
56047	1747	8656920000000	19314	9739	3	0	\N
56048	1747	8656920000000	19501	9830	4	0	\N
56049	1747	8656920000000	19529	9838	4	0	\N
56050	1747	8656920000000	19971	10058	7	0	\N
56052	1747	8656930000000	19045	9606	2	0	\N
56053	1747	8656931000000	18972	9570	3	0	\N
56054	1747	8656931000000	18991	9577	3	0	\N
56055	1747	8656931000000	19056	9612	3	0	\N
56056	1747	8656932000000	19276	9717	4	0	\N
56057	1747	8656932000000	19314	9739	4	0	\N
56059	1747	8656933000000	19501	9830	5	0	\N
56060	1747	8656933000000	19529	9838	5	0	\N
56061	1747	8656942000000	21195	10643	1	0	\N
56062	1747	8656943000000	19230	9697	6	0	\N
56063	1747	8656945000000	19971	10058	8	0	\N
56064	1747	8656954000000	18346	9244	8	0	\N
56067	1747	8735667000000	9980	5176	6	0	\N
56068	1747	8735667000000	10354	5358	2	0	\N
56069	1747	8735667000000	10719	5532	2	0	\N
56070	1747	8735667000000	11046	5684	2	0	\N
56071	1747	8735667000000	11133	5723	2	0	\N
56073	1747	8735687000000	10354	5358	3	0	\N
56074	1747	8735687000000	10719	5532	3	0	\N
56075	1747	8735687000000	11046	5684	3	0	\N
56076	1747	8735687000000	11133	5723	3	0	\N
56077	1747	8735727000000	9980	5176	7	0	\N
56079	1747	9358970000000	9542	4947	4	0	\N
56080	1747	9358970000000	9592	4976	2	0	\N
56081	1747	9358970000000	9766	5061	11	0	\N
56082	1747	9358990000000	9592	4976	3	0	\N
56083	1747	9359010000000	9542	4947	5	0	\N
56084	1747	9359035000000	9766	5061	12	0	\N
56085	1747	9376932000000	20501	10322	4	0	\N
56086	1747	9376932000000	21093	10596	4	0	\N
56087	1747	9376932000000	21479	10772	4	0	\N
56088	1747	9376932000000	22075	11037	6	0	\N
56089	1747	9376932000000	22135	11071	4	0	\N
56090	1747	9376932000000	23375	11664	2	0	\N
56091	1747	9376932000000	23475	11705	3	0	\N
56092	1747	9376942000000	21195	10643	3	0	\N
56093	1747	9376943000000	21195	10643	4	0	\N
56094	1747	9376943000000	23375	11664	3	0	\N
56095	1747	9376944000000	23475	11705	4	0	\N
56096	1747	9376945000000	20501	10322	5	0	\N
56097	1747	9376945000000	21479	10772	5	0	\N
56098	1747	9376945000000	22135	11071	5	0	\N
56099	1747	9376954000000	21093	10596	5	0	\N
56100	1747	9376974000000	22075	11037	7	0	\N
56103	1747	10146122599975	29585	14588	3	0	\N
56104	1747	10146122599975	30019	14782	30	0	\N
56106	1747	10146134599975	29585	14588	4	0	\N
56108	1747	10146179599975	30019	14782	31	0	\N
56109	1747	10866139599975	30217	14859	10	0	\N
56110	1747	10866139599975	30300	14894	10	0	\N
56111	1747	10866166534844	30217	14859	13	0	\N
56112	1747	10866275599975	30300	14894	11	0	\N
56113	1749	229700000	16812	8533	13	0	\N
56114	1749	722584529980	26054	12875	10	0	\N
56117	1749	722675529980	26054	12875	11	0	\N
56118	1749	1442598529980	27133	13418	3	0	\N
56119	1749	1442598529980	27134	13418	2	0	\N
56120	1749	1442598529980	27167	13434	3	0	\N
56121	1749	1442598529980	27476	13578	0	0	\N
56122	1749	1442598529980	27815	13745	6	0	\N
56123	1749	1442598529980	28233	13958	6	0	\N
56124	1749	1442598529980	28555	14105	4	0	\N
56125	1749	1442598529980	28556	14015	0	0	\N
56126	1749	1442598529980	28723	14175	7	0	\N
56128	1749	1442600529980	27134	13418	3	0	\N
56130	1749	1442610529980	27133	13418	4	0	\N
56131	1749	1442610529980	27167	13434	4	0	\N
56132	1749	1442611529980	28555	14105	5	0	\N
56133	1749	1442622529980	27815	13745	7	0	\N
56134	1749	1442622529980	28233	13958	7	0	\N
56135	1749	1442623529980	28723	14175	8	0	\N
56136	1749	2000391000000	10313	5335	3	0	\N
56138	1749	2000412000000	10313	5335	4	0	\N
56140	1749	2162609529980	29383	14485	3	0	\N
56142	1749	2162621529980	29383	14485	4	0	\N
56147	1749	2685102000000	14135	7220	7	0	\N
56148	1749	2720451000000	10625	5487	2	0	\N
56149	1749	2720451000000	11404	5857	2	0	\N
56151	1749	2720462000000	11404	5857	3	0	\N
56152	1749	2720471000000	10625	5487	3	0	\N
56156	1749	2882626529980	30265	14880	9	0	\N
56158	1749	2882644529980	30265	14880	10	0	\N
56162	1749	3405102000000	14135	7220	12	0	\N
56164	1749	3405106000000	14135	7220	13	0	\N
56168	1749	4125106000000	14306	7300	7	0	\N
56137	1749	2000391000000	10514	5430	6	0	11
56139	1749	2000451000000	10514	5430	7	0	11
56072	1747	8735667000000	11204	5754	6	0	3
56078	1747	8735808000000	11204	5754	7	0	3
56150	1749	2720451000000	11410	5861	3	0	11
56154	1749	2720503000000	11535	5927	4	0	11
56165	1749	3440503000000	11535	5927	5	0	11
56144	1749	2685026000000	14004	7176	14	0	14
56145	1749	2685068000000	14004	7176	15	0	14
56146	1749	2685102000000	14134	7220	7	0	14
56163	1749	3405106000000	14134	7220	13	0	14
56159	1749	3125105000000	15166	7730	3	0	15
56160	1749	3125117000000	15166	7730	4	0	15
56166	1749	3845117000000	15284	7786	2	0	15
56051	1747	8656920000000	20396	10276	3	0	5
56058	1747	8656932000000	20396	10276	4	0	5
56115	1749	722584529980	26874	13291	5	0	23
56116	1749	722598529980	26874	13291	6	0	23
56127	1749	1442598529980	28756	14185	2	0	23
56065	1747	8706096599975	29238	14408	4	0	6
56066	1747	8706109599975	29238	14408	5	0	6
56101	1747	9426109599975	29419	14504	4	0	6
56102	1747	9426122599975	29419	14504	5	0	6
56105	1747	10146122599975	30172	14844	8	0	6
56141	1749	2162609529980	30181	14848	8	0	23
56143	1749	2162626529980	30181	14848	9	0	23
56155	1749	2882626529980	30264	14880	5	0	23
56157	1749	2882640529980	30264	14880	6	0	23
56169	1749	4125131000000	14306	7300	8	0	\N
56170	1749	4160503000000	11547	5931	2	0	\N
56173	1749	4160514000000	11547	5931	3	0	\N
56174	1749	4185028000000	13614	6999	4	0	\N
56175	1749	4185041000000	13614	6999	5	0	\N
56178	1749	4880506000000	11699	6015	1	0	\N
56180	1749	4880507000000	11699	6015	2	0	\N
56182	1749	5035089000000	3657	1898	0	0	\N
56183	1749	5035089000000	3692	1916	1	0	\N
56184	1749	5035089000000	3714	1928	1	0	\N
56185	1749	5035099000000	3692	1916	2	0	\N
56186	1749	5035099000000	3714	1928	2	0	\N
56187	1749	5165221000000	16168	8219	3	0	\N
56188	1749	5165221000000	16173	8220	4	0	\N
56189	1749	5165221000000	16812	8533	11	0	\N
56191	1749	5165221000000	16814	8533	11	0	\N
56192	1749	5165233000000	16168	8219	4	0	\N
56193	1749	5165234000000	16173	8220	5	0	\N
56195	1749	5165259000000	16814	8533	12	0	\N
56198	1749	5600517000000	12960	6677	0	0	\N
56199	1749	5600517000000	13078	6740	3	0	\N
56200	1749	5600517000000	13144	6774	3	0	\N
56202	1749	5600529000000	13078	6740	4	0	\N
56203	1749	5600529000000	13144	6774	4	0	\N
56211	1749	6320529000000	13191	6798	7	0	\N
56212	1749	6320529000000	13192	6798	9	0	\N
56213	1749	6320545000000	13191	6798	8	0	\N
56214	1749	6320547000000	13192	6798	10	0	\N
56215	1749	6325292930000	17326	8777	7	0	\N
56218	1749	6325416930000	17326	8777	8	0	\N
56219	1749	6475088000000	4154	2160	1	0	\N
56221	1749	6475088000000	4311	2235	0	0	\N
56222	1749	6475098000000	4154	2160	2	0	\N
56228	1749	7195098000000	4383	2273	1	0	\N
56229	1749	7195098000000	4857	2516	0	0	\N
56230	1749	7195098000000	5117	2655	1	0	\N
56232	1749	7195108000000	4383	2273	2	0	\N
56233	1749	7195108000000	5117	2655	2	0	\N
56248	1749	9365381930000	19352	9757	3	0	\N
56251	1749	9365393930000	19352	9757	4	0	\N
56255	1749	9925382930000	19268	9714	3	0	\N
56256	1749	9925382930000	19269	9714	3	0	\N
56257	1749	10075168000000	5536	2878	0	0	\N
56258	1749	10075168000000	6648	3437	2	0	\N
56259	1749	10075168000000	6884	3557	3	0	\N
56260	1749	10075168000000	6885	3557	5	0	\N
56262	1749	10075188000000	6648	3437	3	0	\N
56263	1749	10075189000000	6884	3557	4	0	\N
56265	1749	10075209000000	6885	3557	6	0	\N
56266	1749	10085382930000	19831	9989	3	0	\N
56267	1749	10085382930000	20219	10181	7	0	\N
56269	1749	10085385930000	19831	9989	4	0	\N
56270	1749	10085407930000	20219	10181	8	0	\N
56271	1749	10645370930000	19266	9710	16	0	\N
56273	1749	10645382930000	19268	9714	4	0	\N
56274	1749	10645382930000	19269	9714	4	0	\N
56275	1749	10645431930000	19266	9710	17	0	\N
56280	1749	11515228000000	7179	3707	1	0	\N
56282	1749	11515238000000	7179	3707	2	0	\N
56286	1749	11525479930000	21875	10940	18	0	\N
56287	1749	12235258000000	7351	3799	8	0	\N
56288	1749	12235258000000	7428	3838	2	0	\N
56289	1749	12235258000000	7521	3893	3	0	\N
56292	1749	12235278000000	7428	3838	3	0	\N
56293	1749	12235288000000	7521	3893	4	0	\N
56294	1749	12235338000000	7351	3799	9	0	\N
56295	1749	12245407930000	20759	10435	0	0	\N
56296	1749	12245407930000	21395	10733	4	0	\N
56297	1749	12245407930000	22226	11125	2	0	\N
56298	1749	12245407930000	22227	11125	3	0	\N
56300	1749	12245418930000	22226	11125	3	0	\N
56302	1749	12245419930000	22227	11125	4	0	\N
56303	1749	12245420930000	21395	10733	5	0	\N
56304	1749	12245479930000	21875	10940	19	0	\N
56231	1749	7195098000000	5118	2655	0	0	3
56238	1749	7915098000000	5134	2661	4	0	3
56239	1749	7915138000000	5134	2661	5	0	3
56242	1749	8635138000000	5184	2693	1	0	3
56243	1749	8635148000000	5184	2693	2	0	3
56247	1749	9355168000000	5305	2757	3	0	3
56261	1749	10075168000000	7055	3641	4	0	3
56264	1749	10075208000000	7055	3641	5	0	3
56276	1749	10795208000000	7106	3668	2	0	3
56277	1749	10795228000000	7106	3668	3	0	3
56283	1749	11515258000000	7244	3744	4	0	3
56290	1749	12235258000000	7887	4087	1	0	3
56291	1749	12235268000000	7887	4087	2	0	3
56171	1749	4160503000000	11680	6005	3	0	11
56179	1749	4880506000000	12741	6569	2	0	11
56181	1749	4880517000000	12741	6569	3	0	11
56201	1749	5600517000000	13145	6774	3	0	11
56204	1749	5600529000000	13145	6774	4	0	11
56176	1749	4565128000000	15372	7831	3	0	15
56196	1749	5285140000000	15419	7854	4	0	15
56197	1749	5285162000000	15419	7854	5	0	15
56209	1749	6005162000000	15494	7886	6	0	15
56210	1749	6005186000000	15494	7886	7	0	15
56224	1749	6725186000000	15714	7990	3	0	15
56234	1749	7445198000000	15751	8010	7	0	15
56235	1749	7445223000000	15751	8010	8	0	15
56190	1749	5165221000000	16813	8533	11	0	17
56194	1749	5165258930000	16813	8533	12	1	17
56208	1749	5885270930000	16917	8576	4	0	17
56205	1749	5605269930000	17148	8693	5	0	18
56206	1749	5605292930000	17148	8693	6	0	18
56216	1749	6325292930000	17658	8926	2	0	18
56217	1749	6325303930000	17658	8926	3	0	18
56227	1749	7045325930000	18275	9207	5	0	18
56236	1749	7765325930000	18323	9229	2	0	18
56237	1749	7765336930000	18323	9229	3	0	18
56240	1749	8485336930000	18366	9256	2	0	18
56241	1749	8485347930000	18366	9256	3	0	18
56245	1749	9205359930000	18546	9344	4	0	18
56252	1749	9925359930000	18610	9376	2	0	18
56253	1749	9925370930000	18610	9376	3	0	18
56254	1749	9925382930000	19267	9714	3	0	18
56249	1749	9365381930000	19353	9757	1	0	19
56250	1749	9365382930000	19353	9757	2	0	19
56268	1749	10085382930000	20388	10272	0	0	19
56278	1749	10805382930000	20542	10341	4	0	19
56279	1749	10805395930000	20542	10341	5	0	19
56285	1749	11525407930000	20645	10389	4	0	19
56299	1749	12245407930000	22544	11278	2	0	19
56301	1749	12245418930000	22544	11278	3	0	19
56307	1749	12965418930000	22688	11343	4	0	\N
56309	1749	12965440930000	22688	11343	5	0	\N
56313	1749	13685441930000	23054	11511	7	0	\N
56314	1749	13685441930000	23117	11525	1	0	\N
56316	1749	13685442930000	23117	11525	2	0	\N
56318	1749	13685466930000	23054	11511	8	0	\N
56321	1749	14405442930000	23219	11526	5	0	\N
56322	1749	14405456930000	23219	11526	6	0	\N
56325	1749	15115328000000	8594	4455	1	0	\N
56326	1749	15115328000000	8700	4510	1	0	\N
56328	1749	15115338000000	8594	4455	2	0	\N
56329	1749	15115338000000	8700	4510	2	0	\N
56332	1749	15125476930000	23529	11728	15	0	\N
56334	1749	15125563930000	23529	11728	16	0	\N
56338	1749	15835348000000	9463	4906	2	0	\N
56340	1749	15835368000000	9463	4906	3	0	\N
56341	1749	15845563529980	23788	11843	4	0	\N
56343	1749	15845576529980	23788	11843	5	0	\N
56345	1749	16555358000000	9621	4990	9	0	\N
56346	1749	16555358000000	9680	5022	6	0	\N
56347	1749	16555358000000	9681	5022	4	0	\N
56348	1749	16555398000000	9681	5022	5	0	\N
56349	1749	16555418000000	9680	5022	7	0	\N
56350	1749	16555448000000	9621	4990	10	0	\N
56351	1749	16565576529980	23857	11875	0	0	\N
56354	1749	17285588529980	24874	12350	4	0	\N
56355	1749	17285588529980	25157	12481	6	0	\N
56356	1749	17285601529980	24874	12350	5	0	\N
56357	1749	17285613529980	25157	12481	7	0	\N
56364	1751	2879022000000	28581	14115	5	0	\N
56365	1751	2879045000000	28581	14115	6	0	\N
56372	1755	2159780000000	8713	4374	36	0	\N
56375	1755	2879050000000	8714	4519	2	0	\N
56376	1755	2879070000000	8714	4519	3	0	\N
56377	1755	2879780000000	8713	4374	119	0	\N
56378	1755	2880600000000	8713	4374	120	0	\N
56379	1756	200000010	27213	13313	91	1	\N
56380	1756	2556499808900	8891	4607	2	0	\N
56382	1756	2556519808900	8891	4607	3	0	\N
56388	1756	3351105575609	11177	5617	108	0	\N
56389	1756	4067755575609	9839	5100	2	0	\N
56390	1756	4067755575609	10481	5418	6	0	\N
56391	1756	4067755575609	10757	5552	2	0	\N
56392	1756	4067755575609	10863	5606	4	0	\N
56394	1756	4067775575609	9839	5100	3	0	\N
56395	1756	4067775575609	10757	5552	3	0	\N
56397	1756	4067795575609	10863	5606	5	0	\N
56398	1756	4067815575609	10481	5418	7	0	\N
56399	1756	4071105575609	11177	5617	126	0	\N
56400	1756	4071275575609	11177	5617	127	0	\N
56403	1756	4787788575609	14839	7563	8	0	\N
56404	1756	4787788575609	14848	7567	6	0	\N
56407	1756	4787821575609	14848	7567	7	0	\N
56408	1756	4787832575609	14839	7563	9	0	\N
56411	1756	5507799575609	15078	7680	5	0	\N
56412	1756	5507799575609	15499	7888	3	0	\N
56413	1756	5507799575609	15629	7956	3	0	\N
56414	1756	5507799575609	15730	7998	3	0	\N
56415	1756	5507799575609	15923	8096	6	0	\N
56417	1756	5507811575609	15499	7888	4	0	\N
56418	1756	5507811575609	15629	7956	4	0	\N
56419	1756	5507811575609	15730	7998	4	0	\N
56421	1756	5507823575609	15923	8096	7	0	\N
56422	1756	5507831575609	15078	7680	6	0	\N
56423	1756	5600742195609	21432	10748	3	0	\N
56424	1756	5600742195609	21568	10814	3	0	\N
56426	1756	5600754195609	21432	10748	4	0	\N
56427	1756	5600754195609	21568	10814	4	0	\N
56429	1756	5601764195609	22184	11005	6	0	\N
56430	1756	6227811575609	16195	8232	4	0	\N
56432	1756	6227824575609	16195	8232	5	0	\N
56435	1756	6320764195609	21951	10981	9	0	\N
56437	1756	6320800195609	21951	10981	10	0	\N
56439	1756	6321764195609	22184	11005	126	0	\N
56440	1756	6323224195609	22184	11005	127	0	\N
56366	1755	719000000000	1777	953	1	0	0
56367	1755	719010000000	1777	953	2	0	0
56368	1755	1439010000000	7104	3667	3	0	0
56369	1755	1439040000000	7104	3667	4	0	0
56370	1755	2159040000000	7833	4061	1	0	0
56305	1749	12955268000000	7988	4141	3	0	3
56306	1749	12955298000000	7988	4141	4	0	3
56311	1749	13675298000000	8489	4397	1	0	3
56312	1749	13675308000000	8489	4397	2	0	3
56319	1749	14395308000000	8523	4416	2	0	3
56381	1756	2556499808900	8922	4624	2	0	2
56383	1756	2556519808900	8922	4624	3	0	2
56327	1749	15115328000000	9370	4861	2	0	3
56330	1749	15115348000000	9370	4861	3	0	3
56339	1749	15835358000000	9462	4906	2	0	3
56384	1756	2627615575609	9634	5000	10	0	3
56385	1756	2627715575609	9634	5000	11	0	3
56386	1756	3347715575609	9636	5001	4	0	3
56387	1756	3347755575609	9636	5001	5	0	3
56336	1749	15555398000000	9955	5169	6	0	4
56373	1755	2876950000000	11896	6115	1	0	1
56374	1755	2876951000000	11896	6115	2	0	1
56393	1756	4067755575609	14763	7519	6	0	3
56396	1756	4067788575609	14763	7519	7	0	3
56406	1756	4787799575609	15022	7654	3	0	3
56416	1756	5507799575609	16082	8175	3	0	3
56420	1756	5507811575609	16082	8175	4	0	3
56431	1756	6227811575609	16323	8295	4	0	3
56434	1756	6227835575609	16959	8595	2	0	3
56401	1756	4160720195609	20953	10538	2	0	6
56402	1756	4160731195609	20953	10538	3	0	6
56409	1756	4880731195609	21082	10592	2	0	6
56410	1756	4880742195609	21082	10592	3	0	6
56428	1756	5600764195609	21657	10849	5	0	6
56308	1749	12965418930000	22710	11353	5	0	19
56310	1749	12965441930000	22710	11353	6	0	19
56360	1751	1439010000000	23052	11510	2	0	0
56361	1751	1439012000000	23052	11510	3	0	0
56317	1749	13685465930000	23120	11547	7	0	19
56323	1749	14405465930000	23220	11589	2	0	19
56324	1749	14405476930000	23220	11589	3	0	19
56331	1749	15125476930000	23528	11728	15	0	19
56342	1749	15845563529980	23816	11855	4	0	19
56344	1749	15845576529980	23816	11855	5	0	19
56352	1749	16565576529980	23893	11893	3	0	19
56353	1749	16565588529980	23893	11893	4	0	19
56436	1756	6320764195609	23970	11928	10	0	6
56362	1751	2159011000000	28141	13911	2	0	1
56363	1751	2159022000000	28141	13911	3	0	1
56441	1756	6323284195609	22199	11006	6	0	\N
56442	1756	6913109545609	17653	8911	6	0	\N
56443	1756	6913109545609	18387	9268	3	0	\N
56445	1756	6913121545609	18387	9268	4	0	\N
56447	1756	6913160545609	17653	8911	7	0	\N
56448	1756	6947824575609	16914	8575	3	0	\N
56450	1756	6947836575609	16914	8575	4	0	\N
56452	1756	7043284195609	22199	11006	126	0	\N
56453	1756	7043988195609	22199	11006	127	0	\N
56454	1756	7044048195609	22208	11007	6	0	\N
56457	1756	7633160545609	17712	8912	1	0	\N
56458	1756	7633170545609	17712	8912	2	0	\N
56459	1756	7667835575609	17033	8625	4	0	\N
56461	1756	7667848575609	17033	8625	5	0	\N
56463	1756	7760837195609	24174	12033	2	0	\N
56464	1756	7760837195609	24264	12045	7	0	\N
56466	1756	7760848195609	24174	12033	3	0	\N
56468	1756	7760898195609	24264	12045	8	0	\N
56469	1756	7764048195609	22208	11007	61	0	\N
56470	1756	7764102195609	22208	11007	62	0	\N
56473	1756	8353170545609	17959	8913	59	0	\N
56474	1756	8353283545609	17959	8913	60	0	\N
56475	1756	8353303545609	18057	8914	2	0	\N
56476	1756	8480871195609	25074	12446	3	0	\N
56477	1756	8480871195609	26270	12991	3	0	\N
56478	1756	8480871195609	26343	13027	2	0	\N
56480	1756	8480882195609	26343	13027	3	0	\N
56482	1756	8480883195609	25074	12446	4	0	\N
56483	1756	8480883195609	26270	12991	4	0	\N
56484	1756	8480898195609	24268	12046	0	0	\N
56490	1756	9073303545609	18057	8914	4	0	\N
56491	1756	9073313545609	18057	8914	5	0	\N
56494	1756	9201475195609	27027	13311	58	0	\N
56497	1756	9793159545609	19240	9700	3	0	\N
56499	1756	9793171545609	19240	9700	4	0	\N
56501	1756	9793213545609	18177	8915	0	0	\N
56504	1756	9921299195609	29278	14405	69	0	\N
56505	1756	9921475195609	27027	13311	126	0	\N
56506	1756	9921705195609	27027	13311	127	0	\N
56507	1756	9921843570609	29878	14592	20	0	\N
56508	1756	9922222195609	27110	13312	58	0	\N
56512	1756	10640906195609	28600	14124	3	0	\N
56513	1756	10640906195609	28978	14290	3	0	\N
56514	1756	10640918195609	28600	14124	4	0	\N
56515	1756	10640918195609	28978	14290	4	0	\N
56516	1756	10641299195609	29278	14405	109	0	\N
56517	1756	10641338195609	29278	14405	110	0	\N
56518	1756	10641843570609	29878	14592	21	0	\N
56519	1756	10642126195609	29391	14406	86	0	\N
56520	1756	10642222195609	27110	13312	126	0	\N
56521	1756	10642289195609	27110	13312	127	0	\N
56522	1756	10642869195609	27213	13313	58	0	\N
56525	1756	11233192545609	20345	10247	3	0	\N
56526	1756	11233192545609	20369	10262	16	0	\N
56527	1756	11233192545609	20532	10336	5	0	\N
56529	1756	11233204545609	20345	10247	4	0	\N
56531	1756	11233217545609	20369	10262	17	0	\N
56532	1756	11233244545609	20532	10336	6	0	\N
56533	1756	11360843570609	30160	14593	0	0	\N
56534	1756	11362126195609	29391	14406	126	0	\N
56535	1756	11362165195609	29391	14406	127	0	\N
56536	1756	11362869195609	27213	13313	90	0	\N
56537	1756	11519229000000	3974	2064	1	0	\N
56539	1756	11519239000000	3974	2064	2	0	\N
56541	1756	12080843470609	30176	14594	9	0	\N
56542	1756	12081054002189	30176	14594	11	0	\N
56543	1756	12239719000000	4603	2382	1	0	\N
56544	1756	12239719000000	5160	2678	1	0	\N
56545	1756	12239719000000	5246	2722	1	0	\N
56546	1756	12239719000000	5279	2742	2	0	\N
56547	1756	12239719000000	5456	2839	0	0	\N
56548	1756	12239719000000	5649	2931	0	0	\N
56550	1756	12239729000000	4603	2382	2	0	\N
56551	1756	12239729000000	5160	2678	2	0	\N
56552	1756	12239729000000	5246	2722	2	0	\N
56553	1756	12239739000000	5279	2742	3	0	\N
56557	1756	13679769000000	6415	3324	6	0	\N
56560	1756	13679829000000	6415	3324	7	0	\N
56561	1756	14399789000000	7079	3653	4	0	\N
56564	1756	14399829000000	7079	3653	5	0	\N
56571	1756	17279859000000	7949	4118	1	0	\N
56573	1756	17279869000000	7949	4118	2	0	\N
56575	1756	17279999000000	8245	4270	2	0	\N
56487	1756	8639189000000	3346	1738	4	0	1
56495	1756	9359189000000	3346	1738	7	0	1
56496	1756	9359209000000	3346	1738	8	0	1
56509	1756	10079209000000	3487	1811	0	0	1
56523	1756	10799209000000	3827	1985	2	0	1
56538	1756	11519229000000	4413	2288	13	0	1
56540	1756	11519719000000	4413	2288	14	0	1
56549	1756	12239719000000	5762	2988	2	0	1
56554	1756	12239739000000	5762	2988	3	0	1
56555	1756	12959739000000	6354	3288	3	0	1
56558	1756	13679769000000	6527	3383	2	0	1
56559	1756	13679789000000	6527	3383	3	0	1
56562	1756	14399789000000	7298	3771	3	0	1
56563	1756	14399819000000	7298	3771	4	0	1
56566	1756	15119839000000	7435	3842	3	0	1
56567	1756	15839839000000	7565	3917	1	0	1
56568	1756	15839849000000	7565	3917	2	0	1
56569	1756	16559849000000	7568	3918	1	0	1
56570	1756	16559859000000	7568	3918	2	0	1
56574	1756	17279979000000	7985	4139	4	0	1
56576	1756	17999979000000	8513	4410	1	0	1
56449	1756	6947835575609	16959	8595	3	0	3
56460	1756	7667835575609	17083	8654	4	0	3
56462	1756	7667848575609	17083	8654	5	0	3
56446	1756	6913126545609	18485	9310	9	0	5
56455	1756	7633126545609	18620	9382	3	0	5
56456	1756	7633138545609	18620	9382	4	0	5
56471	1756	8353138545609	18746	9447	2	0	5
56488	1756	9073149545609	19036	9600	1	0	5
56489	1756	9073159545609	19036	9600	2	0	5
56498	1756	9793159545609	19731	9933	3	0	5
56500	1756	9793171545609	19731	9933	4	0	5
56510	1756	10513171545609	20078	10106	3	0	5
56528	1756	11233192545609	20640	10386	3	0	5
56530	1756	11233204545609	20640	10386	4	0	5
56451	1756	7040837195609	24064	11976	0	0	6
56465	1756	7760837195609	25073	12445	7	0	6
56467	1756	7760871195609	25073	12445	8	0	6
56481	1756	8480882195609	26398	13059	3	0	6
56492	1756	9200882195609	26456	13085	4	0	6
56493	1756	9200895195609	26456	13085	5	0	6
56502	1756	9920895195609	28472	14070	2	0	6
56578	1756	17999999000000	8245	4270	4	0	\N
56579	1756	18000009000000	8245	4270	5	0	\N
56582	1757	719000000000	2056	1086	1	0	\N
56583	1757	719000000000	5919	3067	3	0	\N
56585	1757	719010000000	2056	1086	2	0	\N
56586	1757	719030000000	5919	3067	4	0	\N
56588	1758	100000010	23130	11433	121	1	\N
56589	1758	100000012	23130	11433	126	1	\N
56590	1758	200000006	22760	11381	8	1	\N
56591	1758	200002020	19364	9763	5	0	\N
56592	1758	200006780	26392	12900	118	0	\N
56593	1758	201700002	5836	3029	7	0	\N
56595	1758	903500000	6992	3610	11	0	\N
56596	1758	1600500000	19356	9731	12	0	\N
56597	1758	1600500000	21416	10740	12	0	\N
56599	1758	1601700000	22903	11432	9	0	\N
56600	1758	1601700000	23499	11571	18	0	\N
56602	1758	1602800000	22835	11419	5	0	\N
56603	1758	1603500000	21416	10740	13	0	\N
56604	1758	10472004500122	22903	11432	10	0	\N
56605	1758	77315743038283	14898	7590	5	0	\N
56606	1759	200000001	10928	5635	9	0	\N
56610	1759	1440513999999	10235	5296	3	0	\N
56611	1759	1440513999999	10928	5635	8	0	\N
56614	1759	1440633999999	10235	5296	4	0	\N
56615	1759	2160525999999	11179	5742	4	0	\N
56617	1759	2160565999999	11179	5742	5	0	\N
56623	1759	4320567999999	11843	6089	1	0	\N
56625	1759	4320568999999	11843	6089	2	0	\N
56627	1759	5040569999999	12358	6372	1	0	\N
56629	1759	5040570999999	12358	6372	2	0	\N
56633	1759	5760601999999	13141	6773	1	0	\N
56635	1759	6480601999999	13141	6773	9	0	\N
56637	1759	6480617999999	13141	6773	10	0	\N
56639	1759	7200000000000	3469	1801	0	0	\N
56641	1759	7200617999999	13249	6823	4	0	\N
56644	1759	7200630999999	13249	6823	5	0	\N
56645	1759	7920000000000	3813	1977	2	0	\N
56647	1759	7920020000000	3813	1977	3	0	\N
56649	1759	7920629999999	13356	6883	3	0	\N
56650	1759	7920629999999	13359	6883	3	0	\N
56652	1759	7920641999999	13356	6883	4	0	\N
56653	1759	7920641999999	13359	6883	4	0	\N
56663	1759	9360665999999	14105	7211	1	0	\N
56664	1759	9360665999999	14106	7211	4	0	\N
56666	1759	9360675999999	14105	7211	2	0	\N
56667	1759	9360678999999	14106	7211	5	0	\N
56669	1759	9577269139889	26258	12983	3	0	\N
56670	1759	9577269139889	26324	13018	5	0	\N
56671	1759	9577269139889	26563	13143	3	0	\N
56673	1759	9577281139889	26258	12983	4	0	\N
56674	1759	9577281139889	26563	13143	4	0	\N
56676	1759	9577292139889	26324	13018	6	0	\N
56677	1759	10080059000000	4153	2160	1	0	\N
56678	1759	10080059000000	4218	2192	1	0	\N
56679	1759	10080059000000	4288	2222	3	0	\N
56680	1759	10080059000000	4424	2241	22	0	\N
56682	1759	10080069000000	4153	2160	2	0	\N
56683	1759	10080069000000	4218	2192	2	0	\N
56684	1759	10080089000000	4288	2222	4	0	\N
56686	1759	10080691999999	14400	7347	3	0	\N
56687	1759	10080691999999	14780	7526	0	0	\N
56690	1759	10080703999999	14400	7347	4	0	\N
56691	1759	10080999000000	4424	2241	23	0	\N
56694	1759	10800169000000	4495	2327	3	0	\N
56697	1759	10800199000000	4495	2327	4	0	\N
56700	1759	11016294139889	27327	13508	3	0	\N
56701	1759	11016306139889	27327	13508	4	0	\N
56702	1759	11017294139889	27036	13369	4	0	\N
56703	1759	11017294139889	27037	13369	3	0	\N
56704	1759	11017294139889	27328	13508	3	0	\N
56706	1759	11017306139889	27037	13369	4	0	\N
56707	1759	11017306139889	27328	13508	4	0	\N
56709	1759	11017307139889	27036	13369	5	0	\N
56710	1759	11520179000000	4647	2401	1	0	\N
56712	1759	11520189000000	4647	2401	2	0	\N
56640	1759	7200000000000	3475	1804	0	0	0
56646	1759	7920000000000	3833	1990	2	0	0
56648	1759	7920020000000	3833	1990	3	0	0
56655	1759	8640020000000	3866	2007	1	0	0
56656	1759	8640030000000	3866	2007	2	0	0
56662	1759	9360059000000	4063	2111	4	0	1
56681	1759	10080059000000	4425	2294	2	0	1
56685	1759	10080169000000	4425	2294	3	0	1
56695	1759	10800169000000	4547	2353	1	0	1
56696	1759	10800179000000	4547	2353	2	0	1
56577	1756	17999989000000	8513	4410	2	0	1
56580	1756	18719989000000	8533	4420	1	0	1
56581	1756	18719999000000	8533	4420	2	0	1
56584	1757	719000000000	9064	4698	3	0	0
56608	1759	720493999999	10105	5243	2	0	7
56609	1759	720513999999	10105	5243	3	0	7
56612	1759	1440513999999	10931	5636	2	0	7
56613	1759	1440525999999	10931	5636	3	0	7
56616	1759	2160525999999	11180	5742	4	0	7
56619	1759	2880565999999	11704	6019	1	0	7
56620	1759	2880566999999	11704	6019	2	0	7
56621	1759	3600566999999	11731	6029	1	0	7
56622	1759	3600567999999	11731	6029	2	0	7
56624	1759	4320567999999	12356	6371	2	0	7
56628	1759	5040569999999	12397	6395	1	0	7
56630	1759	5040570999999	12397	6395	2	0	7
56631	1759	5760570999999	12480	6431	3	0	7
56632	1759	5760591999999	12480	6431	4	0	7
56636	1759	6480601999999	13142	6773	9	0	7
56638	1759	6480617999999	13142	6773	10	0	7
56642	1759	7200617999999	13308	6857	3	0	7
56643	1759	7200629999999	13308	6857	4	0	7
56651	1759	7920629999999	13412	6909	6	0	7
56657	1759	8640653999999	13670	7024	3	0	7
56658	1759	8640665999999	13670	7024	4	0	7
56665	1759	9360665999999	14153	7225	8	0	7
56668	1759	9360691999999	14153	7225	9	0	7
56688	1759	10080691999999	14781	7526	2	0	7
56698	1759	10800702999999	14965	7623	3	0	7
56699	1759	10800714999999	14965	7623	4	0	7
56598	1758	1601600000	22833	11419	5	0	1
56601	1758	1602000000	23528	11728	17	0	1
56660	1759	8857269139889	26195	12949	7	0	11
56672	1759	9577269139889	26763	13235	4	0	11
56675	1759	9577282139889	26763	13235	5	0	11
56692	1759	10297282139889	26873	13290	3	0	11
56693	1759	10297294139889	26873	13290	4	0	11
56708	1759	11017306139889	27399	13548	4	0	11
56713	1759	11520714999999	15107	7698	6	0	\N
56716	1759	11520756999999	15107	7698	7	0	\N
56717	1759	11737306139889	27666	13673	3	0	\N
56720	1759	11737318139889	27666	13673	4	0	\N
56721	1759	12240179000000	4858	2516	1	0	\N
56723	1759	12240189000000	4858	2516	2	0	\N
56725	1759	12240725999999	15280	7782	3	0	\N
56726	1759	12240725999999	15417	7853	3	0	\N
56727	1759	12240725999999	15584	7933	2	0	\N
56728	1759	12240725999999	15658	7968	7	0	\N
56730	1759	12240736999999	15584	7933	3	0	\N
56731	1759	12240737999999	15280	7782	4	0	\N
56732	1759	12240737999999	15417	7853	4	0	\N
56734	1759	12240750999999	15658	7968	8	0	\N
56747	1759	13680875999999	17464	8844	9	0	\N
56748	1759	13681315999999	17466	8745	35	0	\N
56749	1759	13897341139889	28832	14220	7	0	\N
56752	1759	13897366139889	28832	14220	8	0	\N
56753	1759	14400219000000	5674	2942	0	0	\N
56754	1759	14400219000000	6029	3128	3	0	\N
56757	1759	14400249000000	6029	3128	4	0	\N
56760	1759	14400875999999	17464	8844	14	0	\N
56761	1759	14400888999999	17464	8844	15	0	\N
56762	1759	14401315999999	17466	8745	126	0	\N
56763	1759	14402215999999	17466	8745	127	0	\N
56766	1759	14617385139889	29758	14666	1	0	\N
56767	1759	14617397139889	29756	14666	4	0	\N
56769	1759	15120239000000	6398	3315	0	0	\N
56772	1759	15120808999999	17698	8947	2	0	\N
56774	1759	15120808999999	17700	8947	2	0	\N
56776	1759	15120819999999	17700	8947	3	0	\N
56777	1759	15337385139889	29758	14666	25	0	\N
56778	1759	15337397139889	29756	14666	19	0	\N
56780	1759	15337411039513	29756	14666	20	0	\N
56782	1759	15337417139808	29758	14666	26	0	\N
56788	1759	16560340000000	6926	3575	1	0	\N
56789	1759	16560340000000	6927	3575	2	0	\N
56791	1759	16560350000000	6926	3575	2	0	\N
56793	1759	16560360000000	6927	3575	3	0	\N
56794	1759	16560843999889	18072	9113	2	0	\N
56795	1759	16560854999889	18072	9113	3	0	\N
56798	1759	17280855999889	18789	9468	5	0	\N
56799	1759	17280855999889	18790	9468	3	0	\N
56801	1759	17280858999889	18790	9468	4	0	\N
56803	1759	17280878999889	18789	9468	6	0	\N
56804	1759	18000350000000	8025	4161	2	0	\N
56805	1759	18000350000000	8195	4248	3	0	\N
56808	1759	18000370000000	8025	4161	3	0	\N
56809	1759	18000380000000	8195	4248	4	0	\N
56810	1759	18000877999889	19677	9910	18	0	\N
56811	1759	18000877999889	19867	10008	20	0	\N
56812	1759	18000877999889	19951	10046	3	0	\N
56813	1759	18000877999889	20065	10101	2	0	\N
56814	1759	18000877999889	20066	10101	3	0	\N
56815	1759	18000877999889	20068	10101	2	0	\N
56817	1759	18000888999889	20065	10101	3	0	\N
56818	1759	18000888999889	20068	10101	3	0	\N
56819	1759	18000889999889	19951	10046	4	0	\N
56820	1759	18000889999889	20066	10101	4	0	\N
56822	1759	18000969999889	19867	10008	21	0	\N
56823	1759	18001021999889	19677	9910	19	0	\N
56826	1759	18720950999889	20129	10133	7	0	\N
56828	1759	18720975999889	20129	10133	8	0	\N
56830	1759	18720986999889	20427	10290	2	0	\N
56831	1759	19440370000000	8722	4523	4	0	\N
56834	1759	19440410000000	8722	4523	5	0	\N
56835	1759	19440975999889	21463	10768	3	0	\N
56837	1759	19440986999889	20427	10290	4	0	\N
56838	1759	19440987999889	20427	10290	5	0	\N
56839	1759	19440987999889	21463	10768	4	0	\N
56841	1759	20160390000000	9276	4809	2	0	\N
56844	1759	20160410000000	9276	4809	3	0	\N
56845	1759	20160987999889	21617	10833	3	0	\N
56847	1759	20160999999889	21617	10833	4	0	\N
56737	1759	12960189000000	5183	2692	2	0	1
56738	1759	12960209000000	5183	2692	3	0	1
56743	1759	13680209000000	5347	2775	1	0	1
56744	1759	13680219000000	5347	2775	2	0	1
56755	1759	14400219000000	6059	3147	2	0	1
56770	1759	15120239000000	6589	3408	9	0	1
56771	1759	15120320000000	6589	3408	10	0	1
56783	1759	15840320000000	6853	3544	2	0	1
56784	1759	15840340000000	6853	3544	3	0	1
56790	1759	16560340000000	7898	4092	1	0	1
56797	1759	17280350000000	7968	4128	0	0	1
56806	1759	18000350000000	8221	4261	1	0	1
56807	1759	18000360000000	8221	4261	2	0	1
56824	1759	18720360000000	8385	4345	1	0	1
56832	1759	19440370000000	9155	4743	2	0	1
56833	1759	19440390000000	9155	4743	3	0	1
56842	1759	20160390000000	9330	4839	2	0	1
56843	1759	20160409999999	9330	4839	3	0	1
56714	1759	11520714999999	15140	7718	2	0	7
56729	1759	12240725999999	15964	8114	6	0	7
56733	1759	12240749999999	15964	8114	7	0	7
56739	1759	12960749999999	16673	8469	6	0	7
56740	1759	12960773999999	16673	8469	7	0	7
56745	1759	13680773999999	17192	8713	3	0	7
56758	1759	14400785999999	17465	8844	5	0	7
56759	1759	14400808999999	17465	8844	6	0	7
56773	1759	15120808999999	17699	8947	1	0	7
56775	1759	15120809999889	17699	8947	2	0	7
56786	1759	15840843999889	17720	8955	8	0	7
56787	1759	15840855999889	18248	9192	3	0	7
56796	1759	16560855999889	18248	9192	4	0	7
56800	1759	17280855999889	19575	9859	4	0	7
56802	1759	17280877999889	19575	9859	5	0	7
56821	1759	18000950999889	20111	10123	8	0	7
56827	1759	18720950999889	20131	10133	7	0	7
56829	1759	18720975999889	20131	10133	8	0	7
56836	1759	19440975999889	21464	10768	3	0	7
56840	1759	19440987999889	21464	10768	4	0	7
56848	1759	20161011999889	21820	10921	7	0	7
56718	1759	11737306139889	28149	13917	2	0	11
56719	1759	11737317139889	28149	13917	3	0	11
56735	1759	12457317139889	28461	14064	2	0	11
56741	1759	13177328139889	28690	14164	4	0	11
56742	1759	13177341139889	28690	14164	5	0	11
56750	1759	13897341139889	29670	14634	9	0	11
56751	1759	13897359139889	29670	14634	10	0	11
56764	1759	14617359139889	29738	14658	7	0	11
56768	1759	14617397139889	29757	14666	4	0	11
56779	1759	15337397139889	29757	14666	19	0	11
56781	1759	15337411139668	29757	14666	20	0	11
56849	1759	20880409999999	9651	5007	2	0	\N
56851	1759	20880429999999	9651	5007	3	0	\N
56855	1759	21600459999999	9842	5101	2	0	\N
56857	1759	21600479999999	9842	5101	3	0	\N
56861	1759	22320499999999	9886	5125	2	0	\N
56862	1759	22320499999999	9887	5125	2	0	\N
56863	1759	22320519999999	9886	5125	3	0	\N
56864	1759	22320519999999	9887	5125	3	0	\N
56865	1759	22321080999889	23131	11552	5	0	\N
56868	1759	22321094999889	23131	11552	6	0	\N
56869	1759	23041091999889	23656	11783	3	0	\N
56871	1759	23041103999889	23656	11783	4	0	\N
56881	1759	26641248999889	24399	12132	3	0	\N
56882	1759	26641248999889	24688	12254	3	0	\N
56883	1759	26641248999889	24690	12263	4	0	\N
56884	1759	26641251999889	24688	12254	4	0	\N
56885	1759	26641260999889	24399	12132	4	0	\N
56886	1759	26641261999889	24690	12263	5	0	\N
56887	1759	66000000001310	17698	8947	3	0	\N
56890	1761	10000003	6768	3504	4	0	\N
56891	1761	10000003	9281	4813	3	0	\N
56894	1761	39126164	10179	5275	6	1	\N
56895	1761	200100000	10125	5252	3	1	\N
56896	1761	8640140000000	4874	2326	113	1	\N
56897	1761	12960268299999	4262	2210	4	1	\N
56898	1761	13680250999994	6768	3504	5	0	\N
56899	1761	15840301001040	12781	6589	10	0	\N
56900	1761	17998007999999	8603	4461	20	1	\N
56901	1761	22322085999998	10725	5418	127	1	\N
56902	1761	66000000990000	8626	4336	126	1	\N
56903	1761	66720000100000	13327	6790	111	1	\N
56906	1762	1439010000000	2676	1406	4	0	\N
56908	1762	1439050000000	2676	1406	5	0	\N
56912	1762	2805282994000	20783	10445	6	0	\N
56915	1762	2805324994000	20783	10445	7	0	\N
56916	1762	2879060000000	3448	1789	1	0	\N
56918	1762	2879070000000	3448	1789	2	0	\N
56921	1762	3208700000000	10991	5663	4	0	\N
56922	1762	3208740000000	10991	5663	5	0	\N
56923	1762	3525294994000	20915	10513	4	0	\N
56925	1762	3525316994000	20915	10513	5	0	\N
56927	1762	3599060000000	3931	2039	2	0	\N
56928	1762	3599060000000	4035	2095	1	0	\N
56930	1762	3599070000000	4035	2095	2	0	\N
56931	1762	3599080000000	3931	2039	3	0	\N
56934	1762	3921700000000	10993	5663	4	0	\N
56936	1762	3921740000000	10993	5663	5	0	\N
56937	1762	4245326994000	21799	10912	6	0	\N
56938	1762	4245326994000	21919	10969	6	0	\N
56939	1762	4245326994000	21921	10969	4	0	\N
56940	1762	4245326994000	22565	11289	3	0	\N
56942	1762	4245330994000	21921	10969	5	0	\N
56943	1762	4245338994000	22565	11289	4	0	\N
56945	1762	4245350994000	21799	10912	7	0	\N
56946	1762	4245350994000	21919	10969	7	0	\N
56947	1762	4319100000000	4542	2349	1	0	\N
56948	1762	4319100000000	4703	2431	1	0	\N
56949	1762	4319100000000	4705	2411	24	0	\N
56951	1762	4319100000000	5206	2595	0	0	\N
56952	1762	4319110000000	4542	2349	2	0	\N
56953	1762	4319110000000	4703	2431	2	0	\N
56955	1762	4319430000000	4705	2411	25	0	\N
56956	1762	4641700994000	11086	5703	3	0	\N
56957	1762	4641700994000	11129	5721	4	0	\N
56958	1762	4641700994000	11186	5744	2	0	\N
56960	1762	4641720994000	11186	5744	3	0	\N
56962	1762	4641730994000	11086	5703	4	0	\N
56963	1762	4641740994000	11129	5721	5	0	\N
56964	1762	4965338994000	23386	11669	2	0	\N
56966	1762	4965338994000	23748	11821	55	0	\N
56967	1762	4965349994000	23386	11669	3	0	\N
56969	1762	4965547994000	23748	11821	56	0	\N
56972	1762	5361720994000	11337	5823	4	0	\N
56973	1762	5361720994000	11593	5964	1	0	\N
56975	1762	5361721994000	11593	5964	2	0	\N
56977	1762	5361742994000	11337	5823	5	0	\N
56978	1762	5685363994000	23752	11829	3	0	\N
56980	1762	5685375994000	23752	11829	4	0	\N
56982	1762	5685547994000	23753	11822	3	0	\N
56983	1762	5685559994000	23753	11822	4	0	\N
56984	1762	5759120000000	5559	2891	0	0	\N
56907	1762	1439010000000	2677	1406	4	0	0
56909	1762	1439050000000	2677	1406	5	0	0
56910	1762	2159050000000	2956	1537	1	0	0
56911	1762	2159060000000	2956	1537	2	0	0
56917	1762	2879060000000	3555	1845	0	0	0
56932	1762	3599100000000	4351	2254	5	0	0
56888	1761	10000001	4553	2356	16	1	0
56889	1761	10000002	5180	2689	7	0	0
56950	1762	4319100000000	5205	2707	1	0	0
56954	1762	4319110000000	5205	2707	2	0	0
56971	1762	5039120000000	5348	2776	2	0	0
56850	1759	20880409999999	9675	5021	5	0	1
56852	1759	20880459999999	9675	5021	6	0	1
56856	1759	21600459999999	9859	5114	4	0	1
56919	1762	3201680000000	10384	5369	2	0	4
56920	1762	3201700000000	10384	5369	3	0	4
56933	1762	3921700000000	10992	5663	4	0	4
56935	1762	3921700994000	10992	5663	5	0	4
56959	1762	4641700994000	11193	5747	2	0	4
56974	1762	5361720994000	12346	6364	1	0	4
56976	1762	5361721994000	12346	6364	2	0	4
56893	1761	18200002	12837	6620	2	1	0
56913	1762	2805282994000	20813	10463	3	0	8
56914	1762	2805294994000	20813	10463	4	0	8
56926	1762	3525326994000	20924	10519	6	0	8
56853	1759	20881011999889	22443	11231	3	0	7
56854	1759	20881023999889	22443	11231	4	0	7
56859	1759	21601023999889	22538	11276	12	0	7
56941	1762	4245326994000	22656	11328	3	0	8
56944	1762	4245338994000	22656	11328	4	0	8
56866	1759	22321080999889	23334	11643	2	0	7
56867	1759	22321091999889	23334	11643	3	0	7
56965	1762	4965338994000	23747	11828	7	0	8
56979	1762	5685363994000	23824	11859	8	0	8
56981	1762	5685389994000	23824	11859	9	0	8
56870	1759	23041091999889	24070	11980	4	0	7
56872	1759	23041113999889	24070	11980	5	0	7
56873	1759	23761113999889	24073	11982	2	0	7
56875	1759	24481124999889	24084	11989	1	0	7
56876	1759	24481125999889	24084	11989	2	0	7
56877	1759	25201125999889	24374	12122	3	0	7
56878	1759	25201137999889	24374	12122	4	0	7
56880	1759	25921248999889	24377	12123	4	0	7
56985	1762	5759120000000	5560	2869	1	0	\N
56988	1762	5759220000000	5560	2869	2	0	\N
56995	1762	6801732994000	12714	6556	6	0	\N
56997	1762	6801732994000	12792	6595	9	0	\N
56998	1762	6801765994000	12714	6556	7	0	\N
57000	1762	6801777994000	12792	6595	10	0	\N
57003	1762	7199140000000	6160	3191	1	0	\N
57005	1762	7199150000000	6160	3191	2	0	\N
57007	1762	7521773994000	13223	6815	1	0	\N
57008	1762	7521773994000	13225	6815	3	0	\N
57010	1762	7521783994000	13223	6815	2	0	\N
57011	1762	7521785994000	13225	6815	4	0	\N
57015	1762	7845595994000	24968	12391	1	0	\N
57016	1762	7845628994000	25938	12821	7	0	\N
57017	1762	7845628994000	25941	12821	7	0	\N
57018	1762	7919150000000	6493	3365	2	0	\N
57019	1762	7919150000000	6579	3405	2	0	\N
57021	1762	7919170000000	6493	3365	3	0	\N
57022	1762	7919170000000	6579	3405	3	0	\N
57026	1762	8565528994000	25938	12821	8	0	\N
57027	1762	8565585994000	24756	12293	3	0	\N
57028	1762	8565585994000	25201	12501	7	0	\N
57029	1762	8565585994000	26011	12856	3	0	\N
57031	1762	8565595994000	24968	12391	4	0	\N
57032	1762	8565597994000	24756	12293	4	0	\N
57033	1762	8565597994000	24968	12391	5	0	\N
57034	1762	8565597994000	26011	12856	4	0	\N
57036	1762	8565610994000	25201	12501	8	0	\N
57037	1762	8565628994000	25941	12821	10	0	\N
57038	1762	8565630994000	25941	12821	11	0	\N
57039	1762	8639210000000	6911	3570	2	0	\N
57040	1762	8639210000000	6913	3570	1	0	\N
57041	1762	8639210000000	6998	3454	0	0	\N
57042	1762	8639210000000	7000	3613	2	0	\N
57043	1762	8639210000000	7001	3470	0	0	\N
57044	1762	8639210000000	7002	3485	0	0	\N
57045	1762	8639210000000	7003	3499	0	0	\N
57046	1762	8639210000000	7004	3514	0	0	\N
57048	1762	8639220000000	6913	3570	2	0	\N
57050	1762	8639230000000	6911	3570	3	0	\N
57051	1762	8639230000000	7000	3613	3	0	\N
57056	1762	9359220000000	7282	3764	1	0	\N
57057	1762	9359220000000	7654	3961	2	0	\N
57059	1762	9359230000000	7282	3764	2	0	\N
57061	1762	9359240000000	7654	3961	3	0	\N
57074	1762	11121857994000	13912	7134	3	0	\N
57075	1762	11121869994000	13912	7134	4	0	\N
57079	1762	11519240000000	8641	4477	1	0	\N
57080	1762	11519240000000	9031	4683	3	0	\N
57082	1762	11519250000000	8641	4477	2	0	\N
57083	1762	11519270000000	9031	4683	4	0	\N
57087	1762	12165659994000	27939	13820	3	0	\N
57088	1762	12165659994000	28108	13894	3	0	\N
57090	1762	12165671994000	27939	13820	4	0	\N
57091	1762	12165671994000	28108	13894	4	0	\N
57097	1762	12885693994000	28307	13994	3	0	\N
57100	1762	12885705994000	28307	13994	4	0	\N
57101	1762	12959330000000	9627	4996	2	0	\N
57103	1762	12959350000000	9627	4996	3	0	\N
57113	1762	14325717994000	28666	14153	2	0	\N
57115	1762	14325717994000	29892	14730	8	0	\N
57116	1762	14325728994000	28666	14153	3	0	\N
57117	1762	14325734994000	29892	14730	9	0	\N
56993	1762	6479130000000	5972	3098	1	0	0
56994	1762	6479140000000	5972	3098	2	0	0
57004	1762	7199140000000	6297	3261	1	0	0
57006	1762	7199150000000	6297	3261	2	0	0
57020	1762	7919150000000	6602	3414	6	0	0
57047	1762	8639210000000	7145	3693	1	0	0
57049	1762	8639220000000	7145	3693	2	0	0
57058	1762	9359220000000	7690	3984	1	0	0
57060	1762	9359230000000	7690	3984	2	0	0
57066	1762	10079230000000	7910	4098	1	0	0
57072	1762	10799240000000	8414	4360	0	0	0
57081	1762	11519240000000	9087	4712	5	0	0
57084	1762	11519310000000	9087	4712	6	0	0
57093	1762	12239310000000	9410	4884	2	0	0
57102	1762	12959330000000	9919	5147	7	0	0
57104	1762	12959490000000	9919	5147	8	0	0
57109	1762	13679490000000	10041	5210	2	0	0
57110	1762	13679510000000	10041	5210	3	0	0
56989	1762	6081721994000	12605	6501	2	0	4
56996	1762	6801732994000	12791	6595	5	0	4
56999	1762	6801773994000	12791	6595	6	0	4
57009	1762	7521773994000	13306	6856	3	0	4
57012	1762	7521785994000	13306	6856	4	0	4
57024	1762	8241785994000	13452	6930	5	0	4
57052	1762	8961808994000	13497	6950	6	0	4
57053	1762	8961832994000	13497	6950	7	0	4
57062	1762	9681832994000	13676	7027	3	0	4
57063	1762	9681844994000	13676	7027	4	0	4
57069	1762	10401857994000	13753	7067	5	0	4
57073	1762	11121857994000	13910	7134	4	0	4
57076	1762	11121870994000	13910	7134	5	0	4
57085	1762	11841870994000	14171	7235	4	0	4
57086	1762	11841883994000	14171	7235	5	0	4
57096	1762	12561896994000	14298	7297	5	0	4
57105	1762	13281896994000	15248	7768	7	0	4
57106	1762	13281930994000	15248	7768	8	0	4
57111	1762	14001930994000	15251	7770	2	0	4
57112	1762	14001941994000	15251	7770	3	0	4
57120	1762	14721953994000	15839	8058	4	0	4
56991	1762	6405389994000	24080	11987	2	0	8
56992	1762	6405400994000	24080	11987	3	0	8
57001	1762	7125400994000	24252	12068	8	0	8
57013	1762	7845462994000	24366	12118	6	0	8
57014	1762	7845585994000	24366	12118	7	0	8
57030	1762	8565585994000	26399	13060	4	0	8
57035	1762	8565598994000	26399	13060	5	0	8
57054	1762	9285598994000	26425	13073	3	0	8
57064	1762	10005610994000	26487	13101	4	0	8
57065	1762	10005623994000	26487	13101	5	0	8
57070	1762	10725623994000	27007	13358	6	0	8
57071	1762	10725647994000	27007	13358	7	0	8
57077	1762	11445647994000	27248	13473	3	0	8
57089	1762	12165659994000	28173	13928	7	0	8
57092	1762	12165693994000	28173	13928	8	0	8
57098	1762	12885693994000	28308	13994	2	0	8
57099	1762	12885704994000	28308	13994	3	0	8
57108	1762	13605717994000	28627	14135	5	0	8
57114	1762	14325717994000	29891	14730	9	0	8
57118	1762	14325735994000	29891	14730	10	0	8
57121	1762	15441953994000	16117	8193	4	0	\N
57122	1762	15441953994000	16197	8233	3	0	\N
57123	1762	15441953994000	16200	8233	3	0	\N
57124	1762	15441953994000	16281	8275	2	0	\N
57125	1762	15441953994000	16283	8275	3	0	\N
57127	1762	15441964994000	16281	8275	3	0	\N
57128	1762	15441965994000	16197	8233	4	0	\N
57129	1762	15441965994000	16200	8233	4	0	\N
57130	1762	15441965994000	16283	8275	4	0	\N
57132	1762	15441966994000	16117	8193	5	0	\N
57139	1762	18322013994000	17750	8968	4	0	\N
57141	1762	18322026994000	17750	8968	5	0	\N
57145	1762	19762038994000	18119	9138	3	0	\N
57146	1762	19762038994000	18277	9209	2	0	\N
57148	1762	19762049994000	18277	9209	3	0	\N
57149	1762	19762050994000	18119	9138	4	0	\N
57153	1762	21202071994000	18858	9509	1	0	\N
57155	1762	21202081994000	18858	9509	2	0	\N
57159	1762	21922256994000	19121	9549	27	0	\N
57160	1762	22642112994000	19123	9646	4	0	\N
57161	1762	22642112994000	19420	9788	7	0	\N
57162	1762	22642112994000	19422	9788	3	0	\N
57163	1762	22642112994000	20017	10076	4	0	\N
57164	1762	22642112994000	20338	10244	6	0	\N
57165	1762	22642115994000	19422	9788	4	0	\N
57166	1762	22642125994000	20017	10076	5	0	\N
57167	1762	22642127994000	20338	10244	7	0	\N
57168	1762	22642134994000	19123	9646	5	0	\N
57169	1762	22642137994000	19420	9788	8	0	\N
57170	1762	22642256994000	19121	9549	29	0	\N
57171	1762	22642257994000	19121	9549	30	0	\N
57172	1762	23362257894000	19419	9550	3	0	\N
57173	1762	66000200000000	19419	9550	4	0	\N
57174	1764	719000000000	2503	1311	4	0	\N
57175	1764	719000000000	2739	1438	1	0	\N
57177	1764	719010000000	2739	1438	2	0	\N
57179	1764	719070000000	2503	1311	5	0	\N
57180	1764	721673100000	10121	5251	13	0	\N
57183	1764	722163100000	10121	5251	14	0	\N
57184	1764	1439010000000	3006	1561	0	0	\N
57185	1764	1439010000000	3031	1575	1	0	\N
57186	1764	1439010000000	3187	1655	1	0	\N
57187	1764	1439010000000	3426	1780	3	0	\N
57188	1764	1439020000000	3031	1575	2	0	\N
57189	1764	1439020000000	3187	1655	2	0	\N
57190	1764	1439040000000	3426	1780	4	0	\N
57193	1764	2161723100000	10600	5475	2	0	\N
57196	1764	2161743100000	10600	5475	3	0	\N
57197	1764	2881734100000	11645	5992	1	0	\N
57199	1764	2881735100000	11645	5992	2	0	\N
57203	1764	4326743100000	12021	6186	1	0	\N
57205	1764	4326744100000	12021	6186	2	0	\N
57207	1764	5046744100000	12242	6303	1	0	\N
57208	1764	5046744100000	12520	6452	2	0	\N
57210	1764	5046745100000	12242	6303	2	0	\N
57211	1764	5046755100000	12520	6452	3	0	\N
57214	1764	5766766100000	12829	6595	2	0	\N
57215	1764	5766766100000	12830	6618	1	0	\N
57216	1764	5766766100000	13238	6819	3	0	\N
57218	1764	5766776100000	12830	6618	2	0	\N
57220	1764	5766778100000	13238	6819	4	0	\N
57221	1764	5766786100000	12829	6595	3	0	\N
57222	1764	6480009000000	3603	1870	0	0	\N
57223	1764	6480009000000	3940	2045	0	0	\N
57230	1764	7206801100000	14084	7204	6	0	\N
57232	1764	7206834100000	14084	7204	7	0	\N
57234	1764	7920028000000	4152	2160	1	0	\N
57235	1764	7920028000000	4215	2192	1	0	\N
57236	1764	7920028000000	4287	2222	3	0	\N
57237	1764	7920028000000	4619	2391	1	0	\N
57238	1764	7920028000000	4704	2431	1	0	\N
57240	1764	7920038000000	4152	2160	2	0	\N
57241	1764	7920038000000	4215	2192	2	0	\N
57242	1764	7920038000000	4619	2391	2	0	\N
57243	1764	7920038000000	4704	2431	2	0	\N
57245	1764	7920058000000	4287	2222	4	0	\N
57246	1764	7926837100000	14357	7227	6	0	\N
57247	1764	7926837100000	14360	7330	4	0	\N
57248	1764	7926837100000	14497	7396	3	0	\N
57249	1764	7926837100000	14498	7396	1	0	\N
57252	1764	7926847100000	14498	7396	2	0	\N
57253	1764	7926849100000	14497	7396	4	0	\N
57254	1764	7926850100000	14360	7330	5	0	\N
57255	1764	7926888100000	14357	7227	7	0	\N
57213	1764	5760009000000	3559	1846	0	0	1
57224	1764	6480009000000	3942	2046	1	0	1
57225	1764	6480019000000	3942	2046	2	0	1
57228	1764	7200018000000	4076	2118	1	0	2
57229	1764	7200028000000	4076	2118	2	0	2
57244	1764	7920048000000	4756	2458	3	0	2
57256	1764	8640048000000	4822	2498	1	0	2
57181	1764	721673100000	10401	5377	3	0	8
57182	1764	721703100000	10401	5377	4	0	8
57191	1764	1441703100000	10577	5462	2	0	8
57194	1764	2161723100000	11529	5922	2	0	8
57195	1764	2161734100000	11529	5922	3	0	8
57198	1764	2881734100000	11942	6148	8	0	8
57200	1764	2886742100000	11942	6148	9	0	8
57202	1764	3606743100000	11975	6163	2	0	8
57204	1764	4326743100000	12110	6236	1	0	8
57206	1764	4326744100000	12110	6236	2	0	8
57209	1764	5046744100000	12619	6511	4	0	8
57212	1764	5046766100000	12619	6511	5	0	8
57219	1764	5766776100000	13239	6819	2	0	8
57226	1764	6486776100000	13579	6984	7	0	8
57227	1764	6486801100000	13579	6984	8	0	8
57231	1764	7206801100000	14087	7205	9	0	8
57233	1764	7206837100000	14087	7205	10	0	8
57251	1764	7926839100000	14499	7396	3	0	8
57126	1762	15441953994000	16752	8504	3	0	4
57131	1762	15441965994000	16752	8504	4	0	4
57133	1762	16161965994000	16864	8553	3	0	4
57135	1762	16881977994000	17114	8671	2	0	4
57136	1762	16881988994000	17114	8671	3	0	4
57137	1762	17601988994000	17218	8723	7	0	4
57138	1762	17602013994000	17218	8723	8	0	4
57140	1762	18322013994000	17776	8981	4	0	4
57143	1762	19042026994000	17849	9009	3	0	4
57144	1762	19042038994000	17849	9009	4	0	4
57147	1762	19762038994000	18357	9251	4	0	4
57150	1762	19762060994000	18357	9251	5	0	4
57151	1762	20482060994000	18602	9372	2	0	4
57154	1762	21202071994000	18878	9519	3	0	4
57156	1762	21202092994000	18878	9519	4	0	4
57157	1762	21922092994000	18890	9529	2	0	4
57158	1762	21922112994000	18890	9529	3	0	4
57260	1764	8646888100000	14496	7228	3	0	\N
57261	1764	8646990100000	14496	7228	4	0	\N
57264	1764	9366851100000	14699	7485	2	0	\N
57265	1764	9366851100000	14806	7544	2	0	\N
57266	1764	9366851100000	14808	7544	1	0	\N
57268	1764	9366861100000	14808	7544	2	0	\N
57269	1764	9366862100000	14699	7485	3	0	\N
57271	1764	9366871100000	14806	7544	3	0	\N
57272	1764	9366990100000	14606	7229	2	0	\N
57273	1764	9367091100000	14606	7229	3	0	\N
57274	1764	9367771100000	14700	7230	68	0	\N
57277	1764	10086862100000	14949	7615	5	0	\N
57278	1764	10086862100000	14950	7611	0	0	\N
57279	1764	10086862100000	14952	7614	0	0	\N
57280	1764	10086862100000	15112	7688	0	0	\N
57283	1764	10086885100000	14949	7615	6	0	\N
57284	1764	10087770100000	14700	7230	69	0	\N
57286	1764	10806862100000	15136	7689	0	0	\N
57293	1764	11526945100000	17354	8793	8	0	\N
57294	1764	11526945100000	17355	8793	8	0	\N
57298	1764	12246945100000	17354	8793	10	0	\N
57299	1764	12246945100000	17355	8793	10	0	\N
57301	1764	12246946100000	17354	8793	11	0	\N
57302	1764	12246946100000	17355	8793	11	0	\N
57306	1764	12960128000000	5942	3078	3	0	\N
57307	1764	12960128000000	5957	3088	1	0	\N
57308	1764	12960128000000	6263	3243	1	0	\N
57309	1764	12960128000000	6453	3341	3	0	\N
57310	1764	12960128000000	6499	3368	2	0	\N
57311	1764	12960128000000	6761	3499	8	0	\N
57313	1764	12960138000000	5957	3088	2	0	\N
57314	1764	12960138000000	6263	3243	2	0	\N
57315	1764	12960148000000	6499	3368	3	0	\N
57316	1764	12960158000000	5942	3078	4	0	\N
57317	1764	12960158000000	6453	3341	4	0	\N
57318	1764	12960208000000	6761	3499	9	0	\N
57320	1764	12966946100000	17588	8899	4	0	\N
57323	1764	12966968100000	17588	8899	5	0	\N
57324	1764	12966980100000	17738	8966	5	0	\N
57325	1764	12966980100000	17745	8966	5	0	\N
57328	1764	13686957100000	17739	8966	2	0	\N
57329	1764	13686957100000	18207	9172	0	0	\N
57331	1764	13686957100000	18209	9174	3	0	\N
57333	1764	13686959100000	17739	8966	3	0	\N
57334	1764	13686970100000	17738	8966	6	0	\N
57335	1764	13686978100000	18209	9174	4	0	\N
57336	1764	13686980100000	17745	8966	6	0	\N
57341	1764	14406958100000	18621	9382	3	0	\N
57342	1764	14406958100000	18923	9545	1	0	\N
57344	1764	14406968100000	18923	9545	2	0	\N
57345	1764	14406970100000	18621	9382	4	0	\N
57347	1764	14483516100000	26345	13028	3	0	\N
57348	1764	14483516100000	26347	13028	2	0	\N
57349	1764	14483516100000	26662	13188	8	0	\N
57351	1764	14483518100000	26347	13028	3	0	\N
57352	1764	14483528100000	26345	13028	4	0	\N
57354	1764	14483542100000	26662	13188	9	0	\N
57357	1764	15126970100000	19868	10008	20	0	\N
57358	1764	15126970100000	19952	10046	3	0	\N
57360	1764	15126970100000	20008	10072	5	0	\N
57361	1764	15126982100000	19952	10046	4	0	\N
57362	1764	15127062100000	19868	10008	21	0	\N
57364	1764	15127092100000	20008	10072	6	0	\N
57367	1764	15203549100000	27015	13361	1	0	\N
57368	1764	15203551100000	26978	13340	3	0	\N
57373	1764	15923539100000	27621	13651	1	0	\N
57375	1764	15923549100000	27015	13361	4	0	\N
57376	1764	15923549100000	27621	13651	2	0	\N
57377	1764	15923551100000	26978	13340	4	0	\N
57378	1764	15923551100000	27015	13361	5	0	\N
57382	1764	16567095100000	20126	10132	11	0	\N
57383	1764	16567095100000	20127	10132	11	0	\N
57387	1764	16567232100000	20126	10132	12	0	\N
57388	1764	16567232100000	20127	10132	12	0	\N
57389	1764	16643551100000	27716	13694	2	0	\N
57391	1764	16643562100000	27716	13694	3	0	\N
57263	1764	9360088000000	5051	2621	4	0	2
57275	1764	10080088000000	5231	2719	2	0	2
57276	1764	10080108000000	5231	2719	3	0	2
57285	1764	10800108000000	5578	2901	0	0	2
57289	1764	11520108000000	5752	2982	1	0	2
57296	1764	12240118000000	5768	2992	1	0	2
57297	1764	12240128000000	5768	2992	2	0	2
57312	1764	12960128000000	6765	3501	3	0	2
57319	1764	12960248000000	6765	3501	4	0	2
57326	1764	13680248000000	6920	3572	2	0	2
57339	1764	14400268000000	7116	3676	4	0	2
57340	1764	14400308000000	7116	3676	5	0	2
57355	1764	15120308000000	7680	3977	1	0	2
57356	1764	15120318000000	7680	3977	2	0	2
57370	1764	15840328000000	7827	4058	2	0	2
57380	1764	16560328000000	7878	4082	3	0	2
57381	1764	16560349000000	7878	4082	4	0	2
57258	1764	8646839100000	14608	7447	3	0	8
57259	1764	8646851100000	14608	7447	4	0	8
57270	1764	9366862100000	14822	7555	3	0	8
57281	1764	10086862100000	15113	7701	3	0	8
57282	1764	10086874100000	15113	7701	4	0	8
57287	1764	10806874100000	15915	8092	6	0	8
57288	1764	10806898100000	15915	8092	7	0	8
57292	1764	11526910100000	16163	8215	4	0	8
57295	1764	11526945100000	17356	8793	8	0	8
57300	1764	12246945100000	17356	8793	10	0	8
57303	1764	12246946100000	17356	8793	11	0	8
57322	1764	12966957100000	17590	8899	3	0	8
57330	1764	13686957100000	18208	9174	1	0	8
57332	1764	13686958100000	18208	9174	2	0	8
57343	1764	14406958100000	19762	9950	3	0	8
57346	1764	14406970100000	19762	9950	4	0	8
57363	1764	15127082100000	20007	10072	5	0	8
57371	1764	15847082100000	20020	10077	4	0	8
57372	1764	15847095100000	20020	10077	5	0	8
57384	1764	16567095100000	20334	10241	7	0	8
57385	1764	16567120100000	20334	10241	8	0	8
57304	1764	12322456100000	25635	12687	12	0	12
57305	1764	12322504100000	25635	12687	13	0	12
57337	1764	13763504100000	25769	12744	3	0	12
57338	1764	13763516100000	25769	12744	4	0	12
57353	1764	14483528100000	26749	13230	4	0	12
57365	1764	15203528100000	26798	13250	2	0	12
57366	1764	15203539100000	26798	13250	3	0	12
57374	1764	15923539100000	27622	13651	3	0	12
57379	1764	15923551100000	27622	13651	4	0	12
57392	1764	16643562100000	27733	13700	3	0	12
57396	1764	17280389000000	9077	4708	3	0	\N
57399	1764	17288632100000	20651	10317	74	0	\N
57400	1764	17363562100000	27831	13755	12	0	\N
57403	1764	17363610100000	27831	13755	13	0	\N
57404	1764	18000359000000	8204	4252	3	0	\N
57405	1764	18000359000000	8403	4354	1	0	\N
57406	1764	18000359000000	8699	4510	1	0	\N
57407	1764	18000369000000	8403	4354	2	0	\N
57408	1764	18000369000000	8699	4510	2	0	\N
57410	1764	18000389000000	9077	4708	8	0	\N
57412	1764	18000429000000	9077	4708	9	0	\N
57413	1764	18000569000000	8204	4252	4	0	\N
57414	1764	18007132100000	20649	10390	4	0	\N
57416	1764	18007145100000	20649	10390	5	0	\N
57418	1764	18008632100000	20651	10317	126	0	\N
57419	1764	18009142100000	20651	10317	127	0	\N
57422	1764	18720419100000	9470	4911	3	0	\N
57425	1764	18720689100000	9470	4911	4	0	\N
57428	1764	18803586100000	28064	13876	3	0	\N
57429	1764	18803586100000	28879	14245	5	0	\N
57431	1764	18803598100000	28064	13876	4	0	\N
57433	1764	18803609100000	28879	14245	6	0	\N
57448	1764	21683634100000	29734	14657	7	0	\N
57449	1764	21683634100000	29735	14657	9	0	\N
57450	1764	21683634100000	29737	14657	6	0	\N
57451	1764	21683634100000	29794	14681	12	0	\N
57452	1764	21683634100000	29796	14681	9	0	\N
57454	1764	21683634100000	29831	14698	4	0	\N
57455	1764	21683647100000	29831	14698	5	0	\N
57456	1764	21683649100000	29737	14657	7	0	\N
57457	1764	21683650100000	29734	14657	8	0	\N
57458	1764	21683652100000	29735	14657	10	0	\N
57459	1764	21683652100000	29796	14681	10	0	\N
57460	1764	21683655100000	29794	14681	13	0	\N
57462	1764	22327332100000	22350	11175	64	0	\N
57464	1764	22327567100000	22350	11175	65	0	\N
57465	1764	22403634100000	29901	14732	10	0	\N
57466	1764	22403634100000	29902	14732	8	0	\N
57467	1764	22403750100000	29902	14732	9	0	\N
57468	1764	22403752100000	29901	14732	11	0	\N
57469	1764	23047343100000	22434	11228	4	0	\N
57470	1764	23047343100000	22617	11313	4	0	\N
57471	1764	23047343100000	22618	11313	3	0	\N
57472	1764	23047343100000	22832	11418	4	0	\N
57474	1764	23047355100000	22618	11313	4	0	\N
57475	1764	23047356100000	22434	11228	5	0	\N
57476	1764	23047356100000	22617	11313	5	0	\N
57477	1764	23047356100000	22832	11418	5	0	\N
57479	1764	23047567100000	22435	11176	12	0	\N
57480	1764	23047687100000	22435	11176	13	0	\N
57485	1764	25207402100000	23555	11740	6	0	\N
57486	1764	25207402100000	23951	11917	9	0	\N
57488	1764	25207426100000	23555	11740	7	0	\N
57490	1764	25207438100000	23951	11917	10	0	\N
57491	1764	25927435100000	23997	11942	3	0	\N
57493	1764	25927447100000	23997	11942	4	0	\N
57497	1764	27367460100000	24603	12229	3	0	\N
57498	1764	27367481100000	24603	12229	4	0	\N
57500	1765	720040001000	26352	13030	7	0	\N
57501	1765	720040001000	26452	13083	3	0	\N
57502	1765	720052001000	26452	13083	4	0	\N
57503	1765	720074001000	26352	13030	8	0	\N
57504	1766	24	2586	1145	0	0	\N
57505	1766	24	2823	1222	0	0	\N
57506	1767	719000000000	2594	1366	1	0	\N
57509	1767	719010000000	2594	1366	2	0	\N
57510	1767	1439001000000	14581	7435	1	0	\N
57511	1767	1439002000000	14581	7435	2	0	\N
57516	1768	2031261110000	11456	5777	65	0	\N
57521	1768	2751011110000	11456	5777	66	0	\N
57522	1768	2879030000000	3111	1615	2	0	\N
57524	1768	2879050000000	3111	1615	3	0	\N
57526	1768	3470622110000	11828	6080	2	0	\N
57514	1768	1439010000000	2806	1466	1	0	0
57515	1768	1439020000000	2806	1466	2	0	0
57517	1768	2159020000000	2899	1514	1	0	0
57518	1768	2159030000000	2899	1514	2	0	0
57523	1768	2879030000000	3140	1633	2	0	0
57393	1764	17280349000000	8188	4244	1	0	2
57394	1764	17280359000000	8188	4244	2	0	2
57395	1764	17280389000000	9076	4708	3	0	2
57409	1764	18000389000000	9076	4708	8	0	2
57411	1764	18000419100000	9076	4708	9	1	2
57424	1764	18720679100000	9471	4911	3	0	2
57519	1768	2750611110000	11455	5886	2	0	6
57520	1768	2750622110000	11455	5886	3	0	6
57507	1767	719000000000	11588	5961	1	0	0
57527	1768	3470622110000	12146	6256	1	0	6
57528	1768	3470623110000	12146	6256	2	0	6
57499	1765	40001000	18881	9522	3	0	2
57397	1764	17287131100000	20428	10290	4	0	8
57398	1764	17287132100000	20428	10290	5	0	8
57417	1764	18007173100000	20960	10542	4	0	8
57426	1764	18727173100000	20965	10545	5	0	8
57427	1764	18727196100000	20965	10545	6	0	8
57434	1764	19447196100000	21239	10666	10	0	8
57435	1764	19447251100000	21239	10666	11	0	8
57439	1764	20167264100000	21572	10815	5	0	8
57442	1764	20887264100000	22211	11119	6	0	8
57443	1764	20887288100000	22211	11119	7	0	8
57446	1764	21607288100000	22237	11129	8	0	8
57461	1764	22327332100000	22349	11187	2	0	8
57463	1764	22327343100000	22349	11187	3	0	8
57473	1764	23047343100000	23115	11545	10	0	8
57478	1764	23047380100000	23115	11545	11	0	8
57481	1764	23767380100000	23218	11588	2	0	8
57483	1764	24487391100000	23427	11688	2	0	8
57484	1764	24487402100000	23427	11688	3	0	8
57487	1764	25207402100000	23952	11917	6	0	8
57489	1764	25207435100000	23952	11917	7	0	8
57492	1764	25927435100000	24200	12046	4	0	8
57495	1764	26647448100000	24293	12082	3	0	8
57496	1764	26647460100000	24293	12082	4	0	8
57401	1764	17363562100000	27845	13764	3	0	12
57402	1764	17363574100000	27845	13764	4	0	12
57421	1764	18083586100000	28038	13866	4	0	12
57430	1764	18803586100000	29382	14485	3	0	12
57432	1764	18803598100000	29382	14485	4	0	12
57436	1764	19523598100000	29444	14517	2	0	12
57437	1764	19523609100000	29444	14517	3	0	12
57441	1764	20243622100000	29575	14582	5	0	12
57444	1764	20963622100000	29634	14614	3	0	12
57445	1764	20963634100000	29634	14614	4	0	12
57453	1764	21683634100000	29830	14698	0	0	12
57529	1768	3470624110000	11828	6080	3	0	\N
57530	1768	3599050000000	3268	1698	1	0	\N
57532	1768	3599060000000	3268	1698	2	0	\N
57534	1768	4190623110000	12326	6353	4	0	\N
57535	1768	4190623110000	12328	6353	4	0	\N
57538	1768	4190627110000	12326	6353	5	0	\N
57539	1768	4190627110000	12328	6353	5	0	\N
57540	1768	4319130000000	3302	1713	4	0	\N
57541	1768	4319130000000	3407	1772	0	0	\N
57542	1768	4319130000000	3533	1833	2	0	\N
57544	1768	4319170000000	3302	1713	5	0	\N
57545	1768	4319231000000	3533	1833	3	0	\N
57548	1768	5039130000000	3903	2027	2	0	\N
57549	1768	5039130000000	4083	2121	1	0	\N
57550	1768	5039130000000	4259	2209	1	0	\N
57552	1768	5039140000000	4083	2121	2	0	\N
57553	1768	5039140000000	4259	2209	2	0	\N
57555	1768	5039150000000	3903	2027	3	0	\N
57556	1768	5506500110000	20678	10401	3	0	\N
57558	1768	5506512110000	20678	10401	4	0	\N
57562	1768	5759140000000	4809	2490	1	0	\N
57563	1768	5759140000000	4811	2395	107	0	\N
57565	1768	5759150000000	4809	2490	2	0	\N
57567	1768	5760930000000	4811	2395	108	0	\N
57568	1768	6226532110000	20958	10542	3	0	\N
57570	1768	6226532110000	21976	10988	6	0	\N
57572	1768	6226556110000	21976	10988	7	0	\N
57573	1768	6226573110000	20958	10542	4	0	\N
57574	1768	6350637110000	13067	6735	4	0	\N
57576	1768	6350650110000	13067	6735	5	0	\N
57578	1768	6479161110000	5095	2645	2	0	\N
57579	1768	6479161110000	5650	2932	0	0	\N
57580	1768	6479161110000	5760	2986	2	0	\N
57581	1768	6479161110000	5798	3008	2	0	\N
57584	1768	6479181110000	5095	2645	3	0	\N
57585	1768	6479181110000	5760	2986	3	0	\N
57586	1768	6479181110000	5798	3008	3	0	\N
57589	1768	7070663110000	13151	6776	7	0	\N
57590	1768	7070663110000	13152	6777	2	0	\N
57591	1768	7070663110000	13153	6777	2	0	\N
57592	1768	7070663110000	13160	6780	6	0	\N
57594	1768	7070674110000	13152	6777	3	0	\N
57595	1768	7070674110000	13153	6777	3	0	\N
57597	1768	7070687110000	13160	6780	7	0	\N
57598	1768	7070697110000	13151	6776	8	0	\N
57603	1768	7790675110000	13349	6881	4	0	\N
57604	1768	7790675110000	13350	6881	4	0	\N
57607	1768	7790688110000	13349	6881	5	0	\N
57608	1768	7790688110000	13350	6881	5	0	\N
57609	1768	7919181110000	6161	3191	1	0	\N
57610	1768	7919181110000	6475	3356	2	0	\N
57612	1768	7919191110000	6161	3191	2	0	\N
57613	1768	7919201110000	6475	3356	3	0	\N
57618	1768	8510685110000	13450	6929	1	0	\N
57619	1768	8510685110000	13451	6929	3	0	\N
57621	1768	8510688110000	13451	6929	4	0	\N
57622	1768	8510695110000	13450	6929	2	0	\N
57625	1768	9106593110000	22855	11427	5	0	\N
57628	1768	9106616110000	22855	11427	6	0	\N
57629	1768	9230688110000	13509	6954	16	0	\N
57630	1768	9230688110000	13510	6931	44	0	\N
57633	1768	9230758110000	13509	6954	17	0	\N
57634	1768	9231119110000	13510	6931	45	0	\N
57635	1768	9359221110000	7054	3641	4	0	\N
57638	1768	9359261110000	7054	3641	5	0	\N
57640	1768	9826615110000	22890	11431	47	0	\N
57642	1768	9826788110000	22890	11431	48	0	\N
57643	1768	9950700110000	13572	6979	3	0	\N
57645	1768	9950712110000	13572	6979	4	0	\N
57647	1768	9951119110000	13571	6932	33	0	\N
57648	1768	9951431110000	13571	6932	34	0	\N
57655	1768	10799351110000	7362	3804	8	0	\N
57658	1768	10799431110000	7362	3804	9	0	\N
57659	1768	10799781110000	8682	4450	42	0	\N
57662	1768	11390751110000	14597	7443	3	0	\N
57543	1768	4319130000000	3617	1877	0	0	0
57551	1768	5039130000000	4355	2257	1	0	0
57554	1768	5039140000000	4355	2257	2	0	0
57564	1768	5759140000000	4934	2555	2	0	0
57566	1768	5759161110000	4934	2555	3	0	0
57583	1768	6479171110000	5809	3014	2	0	0
57599	1768	7199171110000	5854	3038	1	0	0
57600	1768	7199181110000	5854	3038	2	0	0
57611	1768	7919181110000	6541	3389	2	0	0
57614	1768	7919201110000	6541	3389	3	0	0
57624	1768	8639221110000	6743	3489	3	0	0
57636	1768	9359221110000	7098	3664	2	0	0
57637	1768	9359241110000	7098	3664	3	0	0
57649	1768	10079241110000	7118	3677	11	0	0
57656	1768	10799351110000	7455	3856	1	0	0
57657	1768	10799361110000	7455	3856	2	0	0
57536	1768	4190623110000	12355	6370	2	0	6
57537	1768	4190625110000	12355	6370	3	0	6
57546	1768	4910625110000	12460	6420	1	0	6
57560	1768	5630626110000	12674	6537	2	0	6
57561	1768	5630637110000	12674	6537	3	0	6
57575	1768	6350637110000	13095	6749	8	0	6
57577	1768	6350663110000	13095	6749	9	0	6
57593	1768	7070663110000	13209	6807	3	0	6
57605	1768	7790675110000	13351	6881	1	0	6
57606	1768	7790685110000	13351	6881	2	0	6
57617	1768	8510685110000	13449	6929	3	0	6
57620	1768	8510688110000	13449	6929	4	0	6
57632	1768	9230700110000	13511	6956	4	0	6
57644	1768	9950700110000	14163	7229	7	0	6
57646	1768	9950725110000	14163	7229	8	0	6
57653	1768	10670725110000	14506	7400	8	0	6
57654	1768	10670751110000	14506	7400	9	0	6
57664	1768	11390753110000	14640	7461	3	0	6
57557	1768	5506500110000	20745	10429	5	0	10
57559	1768	5506532110000	20745	10429	6	0	10
57569	1768	6226532110000	21974	10988	6	0	10
57571	1768	6226556110000	21974	10988	7	0	10
57588	1768	6946568110000	21995	10998	4	0	10
57601	1768	7666568110000	22205	11115	4	0	10
57602	1768	7666581110000	22205	11115	5	0	10
57615	1768	8386581110000	22267	11144	3	0	10
57626	1768	9106593110000	22856	11427	4	0	10
57627	1768	9106615110000	22856	11427	5	0	10
57639	1768	9826615110000	22889	11442	4	0	10
57641	1768	9826628110000	22889	11442	5	0	10
57651	1768	10546628110000	23064	11516	4	0	10
57660	1768	11266641110000	23178	11573	2	0	10
57661	1768	11266652110000	23178	11573	3	0	10
57665	1768	11390763110000	14597	7443	4	0	\N
57666	1768	11519361110000	7578	3921	1	0	\N
57668	1768	11519371110000	7578	3921	2	0	\N
57670	1768	11519781110000	8682	4450	88	0	\N
57671	1768	11520132110000	8682	4450	89	0	\N
57677	1768	12239371110000	8983	4659	1	0	\N
57678	1768	12239381110000	8983	4659	2	0	\N
57684	1768	12959391110000	9294	4821	2	0	\N
57685	1768	12959391110000	9522	4937	6	0	\N
57687	1768	12959411110000	9294	4821	3	0	\N
57689	1768	12959541110000	9522	4937	7	0	\N
57690	1768	13426675110000	24136	12014	2	0	\N
57692	1768	13426686110000	24136	12014	3	0	\N
57696	1768	13679411110000	10012	5191	4	0	\N
57697	1768	13679451110000	10012	5191	5	0	\N
57699	1768	14146686110000	24295	12083	1	0	\N
57700	1768	14146687110000	24295	12083	2	0	\N
57702	1768	14270787110000	15681	7979	3	0	\N
57703	1768	14270787110000	16266	8267	0	0	\N
57706	1768	14270799110000	15681	7979	4	0	\N
57709	1768	14990798110000	16357	8319	4	0	\N
57712	1768	14990811110000	16357	8319	5	0	\N
57713	1768	15586734110000	24493	12181	3	0	\N
57715	1768	15586746110000	24493	12181	4	0	\N
57719	1768	16306760110000	25221	12512	4	0	\N
57721	1768	16306773110000	25221	12512	5	0	\N
57723	1768	16430822110000	17258	8741	5	0	\N
57726	1768	16430845110000	17258	8741	6	0	\N
57729	1768	17150833110000	18372	9258	2	0	\N
57730	1768	17150833110000	18734	9441	7	0	\N
57731	1768	17150833110000	18735	9441	3	0	\N
57732	1768	17150833110000	19137	9654	4	0	\N
57733	1768	17150833110000	19138	9654	3	0	\N
57735	1768	17150833110000	19143	9656	5	0	\N
57736	1768	17150844110000	18372	9258	3	0	\N
57737	1768	17150845110000	19138	9654	4	0	\N
57738	1768	17150846110000	19137	9654	5	0	\N
57739	1768	17150856110000	19143	9656	6	0	\N
57741	1768	17150863110000	18735	9441	4	0	\N
57742	1768	17150867110000	18734	9441	8	0	\N
57743	1768	17746997110000	25426	12599	10	0	\N
57744	1768	17746997110000	25427	12600	1	0	\N
57745	1768	17746997110000	25428	12585	4	0	\N
57747	1768	17746998110000	25427	12600	2	0	\N
57749	1768	17747034110000	25426	12599	11	0	\N
57750	1768	17747199110000	25428	12585	5	0	\N
57760	1768	19310945110000	19992	10067	9	0	\N
57761	1768	19311080110000	19992	10067	10	0	\N
57767	1768	20627057110000	25843	12777	4	0	\N
57769	1768	20627070110000	25843	12777	5	0	\N
57787	1768	26387196110000	28676	14156	4	0	\N
57788	1768	26387196110000	28708	14173	0	0	\N
57789	1768	26387196110000	28709	14173	1	0	\N
57791	1768	26387197110000	28709	14173	2	0	\N
57792	1768	26387218110000	28676	14156	5	0	\N
57800	1768	29267293110000	29024	14314	5	0	\N
57676	1768	12239371110000	8982	4659	2	0	0
57679	1768	12239391110000	8982	4659	3	0	0
57686	1768	12959391110000	9567	4961	2	0	0
57688	1768	12959411110000	9567	4961	3	0	0
57674	1768	12110753110000	14843	7565	2	0	6
57682	1768	12830764110000	14917	7601	3	0	6
57683	1768	12830776110000	14917	7601	4	0	6
57694	1768	13550776110000	15066	7672	2	0	6
57695	1768	13550787110000	15066	7672	3	0	6
57704	1768	14270787110000	16291	8277	2	0	6
57710	1768	14990798110000	16563	8419	3	0	6
57711	1768	14990810110000	16563	8419	4	0	6
57717	1768	15710810110000	16903	8571	3	0	6
57718	1768	15710822110000	16903	8571	4	0	6
57725	1768	16430833110000	18363	9254	3	0	6
57734	1768	17150833110000	19142	9656	7	0	6
57740	1768	17150858110000	19142	9656	8	0	6
57751	1768	17870858110000	19691	9915	8	0	6
57752	1768	17870920110000	19691	9915	9	0	6
57756	1768	18590945110000	19889	10019	8	0	6
57759	1768	19310945110000	19991	10067	12	0	6
57762	1768	19311083110000	19991	10067	13	0	6
57765	1768	20031083110000	20012	10075	3	0	6
57766	1768	20031095110000	20012	10075	4	0	6
57773	1768	20751100110000	20174	10158	6	0	6
57672	1768	11986652110000	23320	11638	2	0	10
57673	1768	11986663110000	23320	11638	3	0	10
57680	1768	12706663110000	24029	11958	3	0	10
57691	1768	13426675110000	24170	12030	2	0	10
57693	1768	13426686110000	24170	12030	3	0	10
57698	1768	14146686110000	24294	12083	10	0	10
57701	1768	14146723110000	24294	12083	11	0	10
57707	1768	14866723110000	24414	12143	2	0	10
57714	1768	15586734110000	24973	12394	8	0	10
57716	1768	15586760110000	24973	12394	9	0	10
57720	1768	16306760110000	25344	12567	8	0	10
57722	1768	16306885110000	25344	12567	9	0	10
57727	1768	17026885110000	25369	12578	4	0	10
57746	1768	17746997110000	25472	12616	3	0	10
57748	1768	17747009110000	25472	12616	4	0	10
57753	1768	18467009110000	25500	12627	3	0	10
57754	1768	18467021110000	25500	12627	4	0	10
57758	1768	19187045110000	25806	12760	7	0	10
57763	1768	19907045110000	25814	12764	3	0	10
57764	1768	19907057110000	25814	12764	4	0	10
57768	1768	20627057110000	25844	12777	4	0	10
57770	1768	20627070110000	25844	12777	5	0	10
57774	1768	21347113110000	25940	12821	10	0	10
57775	1768	21347115110000	25940	12821	11	0	10
57776	1768	22067115110000	25996	12848	0	0	10
57777	1768	22787115110000	26846	13278	2	0	10
57778	1768	22787126110000	26846	13278	3	0	10
57780	1768	23507138110000	26939	13325	4	0	10
57781	1768	24227138110000	27323	13508	3	0	10
57782	1768	24227150110000	27323	13508	4	0	10
57783	1768	24947150110000	28113	13897	7	0	10
57785	1768	25667175110000	28408	14040	3	0	10
57786	1768	25667196110000	28408	14040	4	0	10
57790	1768	26387196110000	28789	14202	10	0	10
57793	1768	26387233110000	28789	14202	11	0	10
57794	1768	27107233110000	28929	14267	2	0	10
57796	1768	27827244110000	28957	14282	7	0	10
57797	1768	27827269110000	28957	14282	8	0	10
57798	1768	28547269110000	29001	14299	6	0	10
57799	1768	28547293110000	29001	14299	7	0	10
57801	1768	29267293110000	29026	14314	5	0	\N
57803	1768	29267316110000	29024	14314	6	0	\N
57804	1768	29267316110000	29026	14314	6	0	\N
57808	1768	30707367110000	29606	14601	3	0	\N
57810	1768	30707379110000	29606	14601	4	0	\N
57812	1768	31427392110000	29801	14684	11	0	\N
57814	1768	31427392110000	29807	14687	1	0	\N
57815	1768	31427402110000	29807	14687	2	0	\N
57817	1768	31427412110000	29801	14684	12	0	\N
57820	1768	32867430110000	30048	14793	10	0	\N
57821	1768	32867449110000	30048	14793	11	0	\N
57822	1771	598416214766	27991	13845	3	0	\N
57825	1780	1438910000000	8005	4148	2	0	\N
57826	1780	1438910000000	23041	11504	3	0	\N
57828	1780	1438922000000	23041	11504	4	0	\N
57830	1780	1438930000000	8005	4148	3	0	\N
57833	1786	200000012	15653	7965	3	0	\N
57834	1786	5332470998467	11875	6071	69	0	\N
57835	1786	11516353499999	5176	2687	3	0	\N
57836	1786	21606153099999	10387	5295	127	1	\N
57837	1786	32974031319255	13110	6757	10	1	\N
57838	1788	200400000	24306	12087	10	0	\N
57839	1790	10000016	10125	5252	3	0	\N
57840	1790	200000001	10179	5275	5	0	\N
57843	1790	1440196300000	6992	3610	10	0	\N
57844	1790	7201792799960	12781	6589	9	0	\N
57845	1790	16560380900000	10184	5275	4	0	\N
57846	1791	208010048	25571	12660	4	0	\N
57848	1791	408000048	25938	12821	8	0	\N
57851	1791	1211000024	14700	7230	69	0	\N
57852	1791	2210000048	9043	4428	0	0	\N
57853	1791	2210000048	13114	6759	3	0	\N
57854	1791	2210000048	22328	11175	3	0	\N
57856	1791	3210000072	24530	12152	0	0	\N
57857	1791	3210000072	25238	12518	0	0	\N
57858	1794	10000000	4874	2326	114	0	\N
57861	1794	10074462899968	5837	3029	7	1	\N
57862	1794	66000100000000	5836	3029	8	0	\N
57863	1796	200000001	14021	7185	10	0	\N
57864	1796	200000001	14022	7185	10	0	\N
57867	1796	200000004	23976	11931	3	0	\N
57870	1796	200000006	29292	14435	5	0	\N
57871	1796	200000006	29293	14435	4	0	\N
57872	1796	200000006	29378	14481	10	0	\N
57873	1796	200000006	29758	14666	26	1	\N
57875	1796	200000007	29783	14666	75	0	\N
57876	1796	200000007	29813	14666	125	0	\N
57877	1796	200000008	29756	14666	20	1	\N
57879	1796	200000008	29771	14673	17	0	\N
57881	1796	200000010	29784	14678	14	0	\N
57883	1796	200000016	29798	14683	10	0	\N
57886	1796	200000019	29876	14690	122	0	\N
57889	1796	200000021	29848	14710	39	0	\N
57891	1796	200000022	29850	14711	10	0	\N
57893	1796	200000030	29879	14725	12	0	\N
57896	1796	200000033	29905	14734	10	0	\N
57897	1796	200000033	29920	14733	79	0	\N
57898	1796	200000033	29930	14727	97	0	\N
57899	1796	200000034	29938	14742	56	0	\N
57900	1796	200000034	30001	14734	122	0	\N
57902	1796	200000035	29933	14744	16	0	\N
57903	1796	200000035	30223	14735	50	0	\N
57904	1796	200000036	29958	14755	6	0	\N
57906	1796	200000036	29986	14751	123	0	\N
57907	1796	200000036	30223	14735	98	0	\N
57910	1796	200000041	29999	14771	21	0	\N
57911	1796	200000042	30099	14773	124	0	\N
57912	1796	200000043	25313	12558	6	0	\N
57915	1796	200000046	30051	14795	18	0	\N
57918	1796	200000049	30064	14801	10	0	\N
57921	1796	200000052	30081	14811	11	0	\N
57922	1796	200000052	30082	14811	11	0	\N
57923	1796	200000052	30083	14811	11	0	\N
57924	1796	200000053	30084	14811	9	0	\N
57926	1796	200000054	30126	14825	20	0	\N
57927	1796	200000055	30153	14837	50	0	\N
57929	1796	200000058	30207	14832	122	0	\N
57930	1796	200000059	30167	14843	10	0	\N
57931	1796	200000059	30168	14843	9	0	\N
57933	1796	200000063	30188	14851	22	0	\N
57935	1796	200000064	30210	14858	35	0	\N
57936	1796	200000064	30211	14858	34	0	\N
57859	1794	200100000	4553	2356	17	0	0
57831	1786	200000001	5180	2689	8	0	0
57850	1791	1210000024	5253	2726	4	0	0
57860	1794	200100003	5774	2994	4	0	0
57832	1786	200000002	9825	5091	2	1	0
57865	1796	200000002	14679	7478	25	0	0
57866	1796	200000003	20125	10132	9	0	0
57827	1780	1438910000000	23669	11788	4	0	1
57829	1780	1438923000000	23669	11788	5	0	1
57868	1796	200000004	27149	13424	6	0	0
57802	1768	29267293110000	29441	14516	14	0	10
57805	1768	29267343110000	29441	14516	15	0	10
57806	1768	29987343110000	29525	14560	6	0	10
57807	1768	29987367110000	29525	14560	7	0	10
57811	1768	30707392110000	29612	14604	8	0	10
57874	1796	200000007	29757	14666	20	1	0
57878	1796	200000008	29770	14673	29	0	0
57880	1796	200000010	29782	14678	14	0	0
57882	1796	200000015	29797	14682	62	0	0
57813	1768	31427392110000	29806	14687	6	0	10
57816	1768	31427407110000	29806	14687	7	0	10
57885	1796	200000019	29818	14692	11	0	0
57887	1796	200000020	29837	14703	9	0	0
57888	1796	200000021	29847	14710	44	0	0
57892	1796	200000026	29859	14717	12	1	0
57894	1796	200000030	29880	14725	12	0	0
57895	1796	200000033	29904	14734	10	0	0
57901	1796	200000035	29932	14744	16	0	0
57818	1768	32147407110000	29990	14767	14	0	10
57819	1768	32147430110000	29990	14767	15	0	10
57909	1796	200000041	29998	14771	21	0	0
57913	1796	200000043	30012	14779	10	0	0
57914	1796	200000044	30033	14787	20	0	0
57917	1796	200000049	30063	14801	10	0	0
57920	1796	200000052	30080	14811	11	0	0
57925	1796	200000054	30125	14825	20	0	0
57928	1796	200000055	30154	14837	50	0	0
57932	1796	200000059	30169	14843	10	0	0
57937	1796	200000064	30213	14858	35	0	\N
57939	1796	200000065	30215	14859	11	0	\N
57940	1796	200000065	30216	14859	11	0	\N
57941	1796	200000065	30217	14859	11	0	\N
57942	1796	200000065	30218	14859	12	0	\N
57943	1796	200000065	30219	14859	11	0	\N
57946	1796	200000069	30255	14876	19	0	\N
57947	1796	200000069	30256	14876	19	0	\N
57950	1796	200000073	30268	14882	21	0	\N
57953	1796	200000077	30317	14900	5	0	\N
57954	1796	200000077	30318	14900	5	0	\N
57955	1796	200300000	10179	5275	5	1	\N
57956	1796	204000000	23916	11755	99	0	\N
57957	1796	1601100000	22760	11381	8	0	\N
57958	1796	747424971000	10279	5319	9	1	\N
57959	1796	2299223758017	17930	9044	5	1	\N
57960	1796	13679162995020	14022	7185	11	0	\N
57961	1796	13679162995023	14021	7185	11	0	\N
57962	1796	15121093799999	27216	13419	71	0	\N
57963	1796	17279026099998	10453	5405	15	0	\N
57964	1796	66722760999999	14024	7185	11	0	\N
57965	1796	74638871999998	23877	11814	126	0	\N
57966	1799	720000319000	12261	6241	126	0	\N
57969	1801	719063000000	25939	12821	7	0	\N
57970	1801	719063000000	25942	12821	7	0	\N
57971	1801	1439010000000	15864	8068	4	0	\N
57972	1801	1439020000000	15865	8068	4	0	\N
57973	1801	1439023000000	15864	8068	5	0	\N
57855	1791	2210000048	22329	11175	3	0	0
57847	1791	308000048	25743	12735	2	0	2
57905	1796	200000036	29959	14755	7	0	0
57919	1796	200000050	30065	14802	9	0	0
57974	1801	1439033000000	15865	8068	5	0	\N
57975	1801	1439063000000	25939	12821	10	0	\N
57976	1801	1439063000000	25942	12821	10	0	\N
57977	1801	1439065000000	25942	12821	11	0	\N
57978	1804	200000100	10125	5252	5	1	\N
57982	1807	200000002	11604	5818	127	0	\N
57984	1807	200000004	25313	12558	6	1	\N
57986	1807	200000006	25312	12558	0	0	\N
57990	1807	200000010	28639	13934	85	1	\N
57991	1807	200000010	28665	13945	69	0	\N
57995	1807	200000031	29813	14666	126	0	\N
57996	1807	200000032	29783	14666	75	1	\N
57997	1807	200000033	29758	14666	27	0	\N
57998	1807	200000037	29756	14666	22	0	\N
58001	1807	200000040	29800	14667	103	0	\N
58002	1807	200000055	29210	14396	4	1	\N
58004	1807	200000055	29771	14673	18	0	\N
58006	1807	200000070	29784	14678	17	0	\N
58008	1807	200000082	29798	14683	12	1	\N
58011	1807	200000095	29876	14690	124	1	\N
58014	1807	200000116	29848	14710	41	1	\N
58016	1807	200000121	29850	14711	10	1	\N
58019	1807	200000145	29861	14718	11	1	\N
58020	1807	200000161	29879	14725	14	1	\N
58022	1807	200000164	29930	14727	99	1	\N
58023	1807	200000172	29920	14733	82	0	\N
58024	1807	200000176	30001	14734	55	1	\N
58026	1807	200000177	29905	14734	13	0	\N
58027	1807	200000184	29938	14742	58	1	\N
58029	1807	200000187	29933	14744	19	0	\N
58030	1807	200000187	30001	14734	125	1	\N
58031	1807	200000191	30223	14735	53	0	\N
58032	1807	200000192	30223	14735	103	0	\N
58033	1807	200000195	29986	14751	125	0	\N
58035	1807	200000204	29957	14754	14	1	\N
58038	1807	200000236	29999	14771	23	1	\N
58039	1807	200000239	30099	14773	126	1	\N
58042	1807	200000275	30051	14795	20	1	\N
58045	1807	200000284	30064	14801	12	0	\N
58048	1807	200000295	30081	14811	13	0	\N
58049	1807	200000295	30082	14811	13	0	\N
58050	1807	200000295	30083	14811	13	1	\N
58051	1807	200000296	30084	14811	11	0	\N
58052	1807	200000300	30267	14812	126	0	\N
58054	1807	200000302	30126	14825	22	1	\N
58055	1807	200000306	30153	14837	51	0	\N
58057	1807	200000308	30207	14832	125	1	\N
58058	1807	200000310	30163	14842	43	1	\N
58059	1807	200000311	30164	14842	43	0	\N
58061	1807	200000311	30166	14842	43	1	\N
58062	1807	200000318	30167	14843	11	1	\N
58063	1807	200000318	30168	14843	11	0	\N
58065	1807	200000323	30188	14851	25	0	\N
58067	1807	200000327	30191	14852	12	1	\N
58069	1807	200000332	30210	14858	37	1	\N
58070	1807	200000332	30211	14858	36	1	\N
58071	1807	200000332	30213	14858	37	1	\N
57980	1805	195000000	5774	2994	3	0	1
57979	1804	1401000000	9137	4733	4	1	0
57981	1807	200000001	9330	4839	3	1	0
57983	1807	200000002	20083	10110	10	1	0
57985	1807	200000005	20125	10132	10	0	0
57988	1807	200000008	25658	12697	9	0	0
57989	1807	200000009	26271	12992	6	1	0
57994	1807	200000027	29206	14395	8	0	0
57999	1807	200000039	29757	14666	21	1	0
58000	1807	200000040	29759	14667	24	1	0
58005	1807	200000070	29782	14678	16	1	0
58007	1807	200000075	29797	14682	63	1	0
58009	1807	200000082	29799	14683	11	1	0
58010	1807	200000094	29818	14692	14	1	0
58013	1807	200000116	29847	14710	46	1	0
58015	1807	200000121	29849	14711	11	0	0
58017	1807	200000144	29859	14717	15	0	0
58018	1807	200000145	29860	14718	12	0	0
58021	1807	200000161	29880	14725	15	0	0
58028	1807	200000187	29932	14744	18	1	0
58034	1807	200000204	29956	14754	14	1	0
58036	1807	200000224	29979	14763	24	0	0
58037	1807	200000236	29998	14771	23	1	0
58040	1807	200000260	30012	14779	12	1	0
58043	1807	200000275	30052	14795	21	0	0
58044	1807	200000284	30063	14801	12	0	0
58046	1807	200000287	30065	14802	11	0	0
58047	1807	200000295	30080	14811	13	1	0
58056	1807	200000306	30154	14837	50	1	0
58060	1807	200000311	30165	14842	43	1	0
58064	1807	200000318	30169	14843	12	0	0
58066	1807	200000323	30190	14851	25	0	0
58068	1807	200000327	30192	14852	12	1	0
58072	1807	200000332	30214	14858	37	1	0
57944	1796	200000065	30220	14859	11	0	0
57945	1796	200000066	30238	14866	25	0	0
57948	1796	200000069	30257	14876	19	0	0
57949	1796	200000072	30266	14881	35	0	0
57952	1796	200000074	30277	14888	12	0	0
58073	1807	200000335	30215	14859	13	1	\N
58074	1807	200000335	30216	14859	13	1	\N
58075	1807	200000335	30217	14859	13	1	\N
58076	1807	200000335	30218	14859	14	1	\N
58077	1807	200000335	30219	14859	13	1	\N
58081	1807	200000342	30240	14867	5	1	\N
58082	1807	200000342	30241	14867	3	1	\N
58084	1807	200000352	30255	14876	21	1	\N
58085	1807	200000352	30256	14876	22	0	\N
58088	1807	200000358	30268	14882	22	1	\N
58092	1807	200000375	30317	14900	6	0	\N
58093	1807	200000375	30318	14900	6	1	\N
58094	1807	291999958	27423	13436	44	0	\N
58095	1807	1440132000000	27534	13412	75	0	\N
58096	1807	7976452908523	11894	5909	94	1	\N
58097	1807	11363089195608	27213	13313	91	0	\N
58099	1814	200055000	20966	10546	3	1	\N
58100	1814	66720003000000	20559	10228	64	1	\N
58101	1817	200000010	6873	3554	3	0	\N
58103	1817	200000010	21456	10578	43	0	\N
58105	1817	904500000	7819	4054	6	0	\N
58112	1831	5100000	6399	3316	5	0	\N
58115	1831	200000003	8986	4661	7	0	\N
58116	1831	200000300	6689	3283	126	1	\N
58117	1831	1600600000	5836	3029	7	1	\N
58118	1831	66000042570000	8988	4661	9	1	\N
58120	1849	200000007	6689	3283	126	0	\N
58121	1849	200000100	16511	8400	4	0	\N
58122	1849	200000100	16512	8400	4	0	\N
58126	1849	11438909999900	16484	8384	4	0	\N
58098	1813	220000000	28887	14250	2	0	0
57992	1807	200000010	29203	14394	7	0	0
57993	1807	200000011	29206	14395	6	0	0
58127	1849	11438909999900	16485	8384	4	0	\N
58128	1849	13716666985538	17701	8947	3	0	\N
58129	1849	67444622999500	16512	8400	5	0	\N
58130	1849	67444622999900	16514	8400	5	0	\N
58131	1849	77520234898389	6399	3316	4	0	\N
58132	1850	25000000	8986	4661	9	0	\N
58133	1850	200000100	16484	8384	4	1	\N
58134	1850	200000100	16485	8384	4	1	\N
58141	1850	4238680000000	10796	5573	2	0	\N
58142	1850	4238680000000	10797	5573	2	0	\N
58144	1850	4238700000000	10796	5573	3	0	\N
58145	1850	4238700000000	10797	5573	3	0	\N
58155	1850	6398800000000	11377	5845	4	0	\N
58156	1850	6398800000000	11379	5845	4	0	\N
58158	1850	6398822000000	11377	5845	5	0	\N
58159	1850	6398822000000	11379	5845	5	0	\N
58161	1850	6456200949999	21331	10708	5	0	\N
58164	1850	6456413949999	21331	10708	6	0	\N
58165	1850	7046224949999	22051	11026	0	0	\N
58167	1850	7118833000000	12732	6565	2	0	\N
58169	1850	7118844000000	12732	6565	3	0	\N
58170	1850	7176224949999	22049	11026	4	0	\N
58172	1850	7176237949999	22049	11026	5	0	\N
58174	1850	7176271949999	22118	11062	7	0	\N
58175	1850	7176271949999	22119	11062	7	0	\N
58177	1850	7838843000000	12751	6574	4	0	\N
58178	1850	7838843000000	12752	6574	10	0	\N
58180	1850	7838843000000	12804	6603	2	0	\N
58182	1850	7838854000000	12804	6603	3	0	\N
58183	1850	7838874000000	12751	6574	5	0	\N
58184	1850	7838880000000	12752	6574	11	0	\N
58185	1850	7896271949999	22118	11062	8	0	\N
58186	1850	7896271949999	22119	11062	8	0	\N
58188	1850	8558853000000	12902	6650	4	0	\N
58191	1850	8558875000000	12902	6650	5	0	\N
58192	1850	8616271949999	22140	11075	11	0	\N
58195	1850	8616309949999	22140	11075	12	0	\N
58196	1850	9278864000000	13608	6996	8	0	\N
58199	1850	9278890000000	13608	6996	9	0	\N
58200	1850	9336296949999	22421	11223	7	0	\N
58201	1850	9336296949999	22422	11223	5	0	\N
58202	1850	9336296949999	22609	11311	6	0	\N
58204	1850	9336311949999	22609	11311	7	0	\N
58206	1850	9336319949999	22422	11223	6	0	\N
58207	1850	9336321949999	22421	11223	8	0	\N
58114	1831	200000002	5253	2726	4	1	0
58208	1850	9345000000000	5813	3016	1	0	0
58135	1850	2078510000000	10365	5361	4	0	5
58136	1850	2078550000000	10365	5361	5	0	5
58137	1850	2798550000000	10496	5424	11	0	5
58139	1850	3518660000000	10564	5456	2	0	5
58140	1850	3518680000000	10564	5456	3	0	5
58143	1850	4238680000000	10799	5573	2	0	5
58146	1850	4238700000000	10799	5573	3	0	5
58147	1850	4958700000000	10833	5590	6	0	5
58151	1850	5678760000000	10834	5591	4	0	5
58152	1850	5678800000000	10834	5591	5	0	5
58157	1850	6398800000000	12638	6520	6	0	5
58160	1850	6398833000000	12638	6520	7	0	5
58168	1850	7118843000000	12731	6565	2	0	5
58179	1850	7838843000000	12803	6603	1	0	5
58181	1850	7838853000000	12803	6603	2	0	5
58189	1850	8558853000000	12947	6673	2	0	5
58190	1850	8558864000000	12947	6673	3	0	5
58198	1850	9278876000000	13648	7015	4	0	5
58123	1849	200000100	17699	8947	3	0	0
58124	1849	200000200	18342	9241	10	0	0
58125	1849	200000400	18344	9242	3	1	0
58149	1850	5016178949999	21164	10630	2	0	9
58153	1850	5736189949999	21232	10663	2	0	9
58154	1850	5736200949999	21232	10663	3	0	9
58104	1817	200000060	21240	10667	4	1	0
58162	1850	6456200949999	21824	10923	6	0	9
58171	1850	7176224949999	22052	11026	4	0	9
58173	1850	7176237949999	22052	11026	5	0	9
58176	1850	7176271949999	22120	11062	7	0	9
58187	1850	7896271949999	22120	11062	8	0	9
58193	1850	8616271949999	22144	11076	7	0	9
58203	1850	9336296949999	22622	11315	4	0	9
58205	1850	9336318949999	22622	11315	5	0	9
58106	1818	720088890000	22883	11439	4	0	1
58107	1818	720101890000	22883	11439	5	0	1
58108	1818	1440101890000	24068	11978	10	0	1
58110	1818	2160156890000	25463	12612	6	0	1
58111	1818	2160180890000	25463	12612	7	0	1
58078	1807	200000335	30220	14859	13	0	0
58079	1807	200000338	30238	14866	27	1	0
58083	1807	200000344	30254	14875	12	0	0
58086	1807	200000352	30257	14876	21	1	0
58087	1807	200000357	30266	14881	37	0	0
58089	1807	200000358	30269	14882	13	1	0
58090	1807	200000363	30276	14887	35	1	0
58210	1850	9998876000000	14545	7420	4	0	\N
58213	1850	9998898000000	14545	7420	5	0	\N
58216	1850	10065010000000	6432	3330	2	0	\N
58218	1850	10065030000000	6432	3330	3	0	\N
58220	1850	10718886000000	15631	7957	3	0	\N
58221	1850	10718886000000	16014	8143	3	0	\N
58222	1850	10718886000000	16017	8144	3	0	\N
58224	1850	10718898000000	15631	7957	4	0	\N
58225	1850	10718898000000	16014	8143	4	0	\N
58226	1850	10718898000000	16017	8144	4	0	\N
58230	1850	10785030000000	6476	3357	2	0	\N
58232	1850	10785050000000	6476	3357	3	0	\N
58234	1850	11438898000000	16484	8384	3	0	\N
58235	1850	11438898000000	16485	8384	3	0	\N
58236	1850	11438898000000	16487	8384	3	0	\N
58237	1850	11438898000000	16761	8508	3	0	\N
58238	1850	11438898000000	16827	8541	3	0	\N
58240	1850	11438910000000	16487	8384	4	0	\N
58241	1850	11438910000000	16761	8508	4	0	\N
58242	1850	11438910000000	16827	8541	4	0	\N
58249	1850	12158919000000	17462	8842	24	0	\N
58250	1850	12158919000000	17463	8842	25	0	\N
58252	1850	12159105000000	17462	8842	25	0	\N
58253	1850	12159115000000	17463	8842	26	0	\N
58256	1850	12225070000000	6929	3576	2	0	\N
58257	1850	12225070000000	7133	3687	3	0	\N
58258	1850	12225070000000	7202	3723	2	0	\N
58261	1850	12225090000000	6929	3576	3	0	\N
58262	1850	12225090000000	7202	3723	3	0	\N
58263	1850	12225100000000	7133	3687	4	0	\N
58265	1850	12878991000000	17511	8865	14	0	\N
58267	1850	12879050000000	17511	8865	15	0	\N
58268	1850	12936381949999	23393	11671	4	0	\N
58270	1850	12936403949999	23393	11671	5	0	\N
58276	1850	13656418949999	24314	12091	7	0	\N
58279	1850	13656443949999	24314	12091	8	0	\N
58287	1850	14385190000000	7692	3985	1	0	\N
58288	1850	14385200000000	7692	3985	2	0	\N
58289	1850	15039073000000	17833	9006	7	0	\N
58290	1850	15039073000000	17834	9006	7	0	\N
58292	1850	15039098000000	17833	9006	8	0	\N
58293	1850	15039098000000	17834	9006	8	0	\N
58301	1850	15816465949999	26028	12864	2	0	\N
58302	1850	15816465949999	26299	13009	5	0	\N
58305	1850	15816476949999	26028	12864	3	0	\N
58306	1850	15816488949999	26299	13009	6	0	\N
58309	1850	16479110000000	17967	9063	2	0	\N
58311	1850	16479121000000	17967	9063	3	0	\N
58313	1850	16479251000000	18227	9152	13	0	\N
58316	1850	16545320000000	8384	4345	1	0	\N
58318	1850	16545330000000	8384	4345	2	0	\N
58322	1850	17199251000000	18227	9152	126	0	\N
58323	1850	17199717000000	18227	9152	127	0	\N
58324	1850	17200567000000	18500	9153	13	0	\N
58325	1850	17256479949999	26685	13199	8	0	\N
58326	1850	17256479949999	26690	13201	10	0	\N
58329	1850	17256505949999	26685	13199	9	0	\N
58330	1850	17256516949999	26690	13201	11	0	\N
58333	1850	17265550000000	8986	4661	1	0	\N
58334	1850	17265550000000	8987	4661	1	0	\N
58335	1850	17265550000000	8991	4661	1	0	\N
58338	1850	17920567000000	18500	9153	126	0	\N
58339	1850	17921687000000	18500	9153	127	0	\N
58342	1850	17985540000000	9431	4893	2	0	\N
58344	1850	17985549999999	8986	4661	7	0	\N
58219	1850	10065030000000	6463	3348	3	0	0
58231	1850	10785030000000	6693	3459	2	0	0
58233	1850	10785050000000	6693	3459	3	0	0
58246	1850	11505050000000	6757	3498	2	0	0
58247	1850	11505070000000	6757	3498	3	0	0
58260	1850	12225080000000	7334	3790	2	0	0
58272	1850	12945080000000	7640	3954	9	0	0
58273	1850	12945170000000	7640	3954	10	0	0
58280	1850	13665170000000	7655	3962	2	0	0
58281	1850	13665190000000	7655	3962	3	0	0
58297	1850	15105190000000	8217	4260	2	0	0
58298	1850	15105300000000	8217	4260	3	0	0
58307	1850	15825300000000	8359	4329	2	0	0
58308	1850	15825320000000	8359	4329	3	0	0
58319	1850	16545530000000	8481	4394	3	0	0
58331	1850	17265530000000	8554	4432	1	0	0
58332	1850	17265540000000	8554	4432	2	0	0
58343	1850	17985540000000	9515	4934	2	0	0
58211	1850	9998876000000	15282	7784	1	0	5
58223	1850	10718886000000	16126	8199	3	0	5
58227	1850	10718898000000	16126	8199	4	0	5
58239	1850	11438898000000	17129	8680	3	0	5
58243	1850	11438919000000	17129	8680	4	0	5
58248	1850	12158919000000	17460	8843	9	0	5
58264	1850	12878991000000	17510	8866	9	0	5
58266	1850	12879027000000	17510	8866	10	0	5
58274	1850	13599027000000	17734	8964	7	0	5
58275	1850	13599061000000	17734	8964	8	0	5
58283	1850	14319073000000	17759	8973	4	0	5
58291	1850	15039073000000	17835	9006	7	0	5
58294	1850	15039098000000	17835	9006	8	0	5
58299	1850	15759098000000	17918	9038	3	0	5
58300	1850	15759110000000	17918	9038	4	0	5
58312	1850	16479121000000	18027	9095	3	0	5
58320	1850	17199121000000	18225	9180	3	0	5
58321	1850	17199133000000	18225	9180	4	0	5
58336	1850	17919133000000	18499	9318	7	0	5
58337	1850	17919158000000	18499	9318	8	0	5
58215	1850	10056331949999	22630	11319	5	0	9
58228	1850	10776331949999	22681	11341	7	0	9
58229	1850	10776356949999	22681	11341	8	0	9
58244	1850	11496356949999	22934	11461	4	0	9
58254	1850	12216369949999	22999	11490	3	0	9
58269	1850	12936381949999	23862	11877	10	0	9
58271	1850	12936418949999	23862	11877	11	0	9
58277	1850	13656418949999	24326	12099	3	0	9
58278	1850	13656430949999	24326	12099	4	0	9
58284	1850	14376430949999	24932	12376	4	0	9
58285	1850	14376443949999	24932	12376	5	0	9
58295	1850	15096443949999	25932	12816	4	0	9
58296	1850	15096465949999	25932	12816	5	0	9
58303	1850	15816465949999	26634	13177	2	0	9
58314	1850	16536467949999	26678	13196	3	0	9
58315	1850	16536479949999	26678	13196	4	0	9
58327	1850	17256479949999	27505	13597	6	0	9
58328	1850	17256503949999	27505	13597	7	0	9
58341	1850	17976527949999	27647	13662	7	0	9
58345	1850	17985550000000	8987	4661	7	0	\N
58346	1850	17985550000000	8991	4661	7	0	\N
58347	1850	17985560000000	9431	4893	3	0	\N
58349	1850	17985591000000	8987	4661	8	0	\N
58350	1850	17985591000000	8991	4661	8	0	\N
58353	1850	18696527949999	27725	13698	4	0	\N
58356	1850	18696549949999	27725	13698	5	0	\N
58359	1850	19416548949999	28872	14242	5	0	\N
58362	1850	19416571949999	28872	14242	6	0	\N
58363	1850	20079178000000	19015	9587	2	0	\N
58364	1850	20079178000000	19383	9770	4	0	\N
58365	1850	20079178000000	19911	10027	6	0	\N
58367	1850	20079189000000	19015	9587	3	0	\N
58368	1850	20079191000000	19383	9770	5	0	\N
58370	1850	20079391000000	19911	10027	7	0	\N
58371	1850	20136560949999	29661	14630	6	0	\N
58372	1850	20136560949999	29662	14630	9	0	\N
58374	1850	20136560949999	29816	14689	29	0	\N
58375	1850	20136575949999	29661	14630	7	0	\N
58376	1850	20136578949999	29662	14630	10	0	\N
58378	1850	20136616949999	29816	14689	30	0	\N
58380	1850	20799250000000	20084	10110	8	0	\N
58382	1850	20799313000000	20084	10110	9	0	\N
58383	1850	20799322949999	20424	10290	2	0	\N
58384	1850	20799322949999	20425	10290	2	0	\N
58387	1850	21519311949999	20224	10183	3	0	\N
58389	1850	21519322949999	20424	10290	4	0	\N
58390	1850	21519322949999	20425	10290	4	0	\N
58391	1850	21519323949999	20224	10183	4	0	\N
58392	1850	21519323949999	20424	10290	5	0	\N
58393	1850	21519323949999	20425	10290	5	0	\N
58395	1850	22239356949999	20552	10347	3	0	\N
58397	1850	22239368949999	20552	10347	4	0	\N
58399	1850	22959418949999	20935	10526	9	0	\N
58400	1850	22959418949999	20937	10526	9	0	\N
58401	1850	22959521949999	20935	10526	10	0	\N
58402	1850	22959521949999	20937	10526	10	0	\N
58403	1854	10801503999990	6690	3419	127	1	\N
58404	1855	200000002	19256	9604	85	0	\N
58405	1855	200000002	19618	9881	10	0	\N
58410	1855	200003280	25038	12366	32	0	\N
58409	1855	200003280	24967	12391	4	0	0
58415	1855	200005480	28639	13934	86	0	\N
58416	1855	200005480	28665	13945	69	1	\N
58417	1855	1602600000	26392	12900	118	1	\N
58418	1855	2880090142829	20966	10546	4	0	\N
58419	1855	9403728999100	25038	12366	33	1	\N
58420	1855	18001066995998	19618	9881	11	1	\N
58421	1855	67441599009957	8626	4336	127	0	\N
58422	1867	200100000	6679	3453	6	0	\N
58423	1867	4405022526450	6679	3453	7	0	\N
58424	1870	17281909999999	9384	4750	127	1	\N
58427	1871	1438910000000	11203	5753	3	0	\N
58428	1871	1438910000000	17569	8892	3	0	\N
58429	1871	1438922000000	17569	8892	4	0	\N
58430	1871	1438940000000	11203	5753	4	0	\N
58431	1877	719000000000	6575	3404	2	0	\N
58434	1877	719020000000	6575	3404	3	0	\N
58435	1877	1439010000000	29083	14337	3	0	\N
58436	1877	1439022000000	29083	14337	4	0	\N
58437	1879	719000000000	6646	3436	2	0	\N
58438	1879	719000000000	8113	4206	1	0	\N
58439	1879	719010000000	8113	4206	2	0	\N
58440	1879	719020000000	6646	3436	3	0	\N
58441	1881	17280595496980	7819	4054	5	1	\N
58444	1882	16559180930000	8958	4569	127	0	\N
58445	1884	9000000000	6785	3285	0	0	\N
58446	1886	200000001	14811	7547	2	0	\N
58447	1886	200999998	16713	8492	2	0	\N
58448	1886	400200000000	20115	9840	0	0	\N
58449	1886	2880113999996	14811	7547	3	0	\N
58452	1894	14675327999008	8786	4556	3	1	\N
58453	1895	44200000000	12504	6442	2	0	\N
58456	1895	1440212000000	19090	9623	29	0	\N
58459	1895	1440520000000	19090	9623	30	0	\N
58460	1895	2159936000000	23749	11829	3	0	\N
58461	1895	2159948000000	23749	11829	4	0	\N
58462	1905	200001000	30114	14820	28	0	\N
58465	1918	2159260000000	20680	10396	21	0	\N
58468	1918	2879260000000	20680	10396	33	0	\N
58469	1918	2879271000000	20680	10396	34	0	\N
58470	1918	3599161000000	24254	12069	0	0	\N
58471	1919	150000000	11823	5964	0	0	\N
58472	1919	72100525000000	14377	7164	68	1	\N
58473	1933	719000000000	8297	4296	1	0	\N
58475	1933	719001000000	8297	4296	2	0	\N
58477	1933	720129000000	13280	6841	1	0	\N
58478	1933	720129000000	13281	6837	0	0	\N
58480	1933	720139000000	13280	6841	2	0	\N
58474	1933	719000000000	8298	4296	2	0	0
58476	1933	719011000000	8298	4296	3	0	0
58442	1882	720200000000	8618	4467	1	0	0
58443	1882	720210000000	8618	4467	2	0	0
58451	1894	205000000	8784	4556	3	1	0
58348	1850	17985560000000	9515	4934	3	0	0
58432	1877	719000000000	12770	6585	2	0	0
58433	1877	719011000000	12770	6585	3	0	0
58454	1895	720200000000	13089	6744	3	0	0
58455	1895	720212000000	13089	6744	4	0	0
58463	1918	2159137000000	15867	8069	3	0	1
58464	1918	2159149000000	15867	8069	4	0	1
58351	1850	18639158000000	18868	9515	1	0	5
58352	1850	18639168000000	18868	9515	2	0	5
58358	1850	19359178000000	19009	9585	2	0	5
58457	1895	1440212000000	19091	9630	6	0	0
58458	1895	1440236000000	19091	9630	7	0	0
58407	1855	200002800	19617	9881	11	1	0
58366	1850	20079178000000	20023	10080	9	0	5
58379	1850	20799250000000	20083	10110	8	0	5
58381	1850	20799311949999	20083	10110	10	0	5
58388	1850	21519311949999	20543	10342	9	0	5
58394	1850	21519356949999	20543	10342	10	0	5
58466	1918	2879149000000	20679	10401	3	0	1
58396	1850	22239356949999	20751	10432	8	0	5
58398	1850	22239418949999	20751	10432	9	0	5
58408	1855	200003180	24485	12175	4	0	0
58411	1855	200003680	24967	12391	5	1	0
58414	1855	200005380	27445	13565	6	0	0
58354	1850	18696527949999	28388	14033	3	0	9
58355	1850	18696548949999	28388	14033	4	0	9
58360	1850	19416548949999	29463	14529	3	0	9
58361	1850	19416560949999	29463	14529	4	0	9
58377	1850	20136587949999	29815	14690	19	0	9
58385	1850	20856587949999	29836	14702	5	0	9
58386	1850	20856601949999	29836	14702	6	0	9
58483	1933	1439011000000	8847	4584	2	0	\N
58485	1933	1439031000000	8847	4584	3	0	\N
58487	1933	1439050000000	9788	5073	3	0	\N
58488	1933	1440141000000	16217	8241	3	0	\N
58489	1933	1440141000000	16686	8475	0	0	\N
58491	1933	1440153000000	16217	8241	4	0	\N
58496	1933	2159050000000	9788	5073	8	0	\N
58498	1933	2159090000000	9788	5073	9	0	\N
58499	1933	2160202000000	17537	8881	3	0	\N
58500	1933	2160214000000	17537	8881	4	0	\N
58505	1933	3003269000000	18190	9170	5	0	\N
58506	1933	3003269000000	18195	9170	5	0	\N
58507	1933	3003269000000	19141	9655	3	0	\N
58508	1933	3003281000000	19141	9655	4	0	\N
58509	1933	3003292000000	18190	9170	6	0	\N
58510	1933	3003292000000	18195	9170	6	0	\N
58511	1933	3979268000000	28483	14076	2	0	\N
58512	1933	3979279000000	28483	14076	3	0	\N
58513	1934	25939943999999	8840	4582	5	1	\N
58514	1935	1409000000	10125	5252	5	0	\N
58515	1938	200000004	8837	4582	4	0	\N
58516	1938	14675332999308	8785	4556	3	0	\N
58517	1938	17280642000000	8626	4336	125	0	\N
58518	1938	86880889999960	8837	4582	5	0	\N
58523	1941	2877981000000	27689	13683	3	0	\N
58524	1941	2877993000000	27689	13683	4	0	\N
58535	1943	4318980000000	20778	10441	5	0	\N
58536	1943	4319003000000	20778	10441	6	0	\N
58538	1948	10703400	8988	4661	8	0	\N
58539	1949	2600000001	9723	4882	43	0	\N
58540	1949	20160544000000	9723	4882	45	0	\N
58541	1964	10000000	23877	11814	127	1	\N
58542	1964	19800000	10453	5405	16	1	\N
58543	1964	100000028	25120	12288	127	1	\N
58544	1964	200000001	13110	6757	9	0	\N
58545	1964	200000001	21392	10709	127	0	\N
58546	1964	200000001	21788	10908	3	0	\N
58547	1964	200000002	29758	14666	27	1	\N
58548	1964	200000003	13110	6757	11	0	\N
58549	1964	200000003	28569	13882	25	0	\N
58550	1964	200000003	29756	14666	22	1	\N
58552	1964	200000003	29783	14666	76	1	\N
58553	1964	200000003	29813	14666	126	1	\N
58554	1964	200000006	28626	13884	17	0	\N
58556	1964	200000010	29771	14673	19	0	\N
58558	1964	200000016	29784	14678	17	1	\N
58560	1964	200000021	29798	14683	13	0	\N
58563	1964	200000028	29876	14690	125	1	\N
58564	1964	200000029	18192	9170	8	1	\N
58567	1964	200000040	29848	14710	42	1	\N
58569	1964	3019244758009	18193	9170	6	1	\N
58570	1964	4031260914688	20716	10188	80	1	\N
58571	1964	5002621999999	10923	5634	6	1	\N
58572	1964	20880486001096	18185	9170	7	0	\N
58573	1964	21528207599997	21788	10908	4	1	\N
58574	1964	169204715819996	14221	7259	6	0	\N
58575	1966	200112200	24810	12261	112	0	\N
58576	1980	200000004	14021	7185	11	1	\N
58577	1980	200000007	14022	7185	11	1	\N
58578	1980	7917990000000	10693	5521	0	0	\N
58589	1980	12239919000000	13781	7030	59	0	\N
58590	1980	12959149000000	12895	6646	0	0	\N
58593	1980	12959919000000	13781	7030	126	0	\N
58594	1980	12960111000000	13781	7030	127	0	\N
58595	1980	13679161999999	14021	7185	10	0	\N
58596	1980	13679161999999	14022	7185	10	0	\N
58599	1980	14399175000000	14692	7482	2	0	\N
58600	1980	14399175000000	15013	7649	3	0	\N
58602	1980	14399186000000	14692	7482	3	0	\N
58603	1980	14399187000000	15013	7649	4	0	\N
58609	1980	15839862000000	17052	8567	46	0	\N
58612	1980	16559862000000	17052	8567	126	0	\N
58613	1980	16560364000000	17052	8567	127	0	\N
58614	1980	16561004000000	17451	8568	46	0	\N
58484	1933	1439021000000	8846	4584	2	0	0
58486	1933	1439050000000	9787	5073	3	0	1
58495	1933	2159050000000	9787	5073	8	0	1
58497	1933	2159090000000	9787	5073	9	0	1
58526	1943	1438900000000	9838	5100	2	0	1
58503	1933	2879090000000	9891	5127	4	0	1
58504	1933	2879130000000	9891	5127	5	0	1
58579	1980	7917990000000	10896	5618	7	0	1
58580	1980	7918060000000	10896	5618	8	0	1
58581	1980	10079060000000	11153	5733	2	0	1
58583	1980	10799080000000	11471	5896	10	0	1
58584	1980	10799145000000	11471	5896	11	0	1
58585	1980	11519145000000	12313	6345	2	0	1
58586	1980	11519147000000	12313	6345	3	0	1
58588	1980	12239149000000	12322	6350	3	0	1
58481	1933	720141000000	13283	6841	4	0	2
58591	1980	12959149000000	13782	7079	4	0	1
58592	1980	12959162000000	13782	7079	5	0	1
58597	1980	13679162000000	14352	7326	4	0	1
58528	1943	2158920000000	15387	7838	2	0	1
58529	1943	2158931000000	15387	7838	3	0	1
58601	1980	14399175000000	15817	8049	19	0	1
58604	1980	14399302000000	15817	8049	20	0	1
58605	1980	15119302000000	16091	8178	22	0	1
58519	1941	1437956000000	16233	8252	3	0	3
58520	1941	1437968000000	16233	8252	4	0	3
58607	1980	15839378000000	16315	8290	6	0	1
58608	1980	15839402000000	16315	8290	7	0	1
58522	1941	2157981000000	16361	8321	5	0	3
58490	1933	1440141000000	16688	8476	16	0	2
58492	1933	1440202000000	16688	8476	17	0	2
58493	1933	1563202000000	17536	8881	3	0	2
58494	1933	1563214000000	17536	8881	4	0	2
58502	1933	2283269000000	17674	8934	11	0	2
58610	1980	16559402000000	18618	9381	2	0	1
58611	1980	16559413000000	18618	9381	3	0	1
58615	1980	17279413000000	18840	9496	1	0	1
58616	1980	17279423000000	18840	9496	2	0	1
58531	1943	2878955000000	20245	10195	7	0	1
58532	1943	3598955000000	20629	10378	7	0	1
58533	1943	3598980000000	20629	10378	8	0	1
58534	1943	4318980000000	20777	10441	6	0	1
58551	1964	200000003	29757	14666	22	0	0
58555	1964	200000010	29770	14673	30	1	0
58557	1964	200000016	29782	14678	17	0	0
58559	1964	200000019	29797	14682	64	1	0
58561	1964	200000021	29799	14683	12	0	0
58565	1964	200000035	29837	14703	13	0	0
58566	1964	200000040	29847	14710	47	1	0
58568	1964	200000042	29859	14717	16	0	0
58617	1980	17281004000000	17451	8568	126	0	\N
58618	1980	17281794000000	17451	8568	127	0	\N
58623	1980	19439446000000	21045	10576	2	0	\N
58624	1980	19439446000000	22044	11024	14	0	\N
58626	1980	19439457000000	21045	10576	3	0	\N
58628	1980	19439496000000	22044	11024	15	0	\N
58629	1980	20159471000000	22266	11143	11	0	\N
58630	1980	20159471000000	22797	11401	6	0	\N
58633	1980	20159495000000	22797	11401	7	0	\N
58634	1980	20159509000000	22266	11143	12	0	\N
58637	1980	21599496000000	24475	12170	4	0	\N
58638	1980	21599496000000	25347	12569	6	0	\N
58641	1980	21599518000000	24475	12170	5	0	\N
58642	1980	21599619000000	25347	12569	7	0	\N
58653	1980	25201493000000	29720	14446	65	0	\N
58654	1980	25919613000000	27880	13784	8	0	\N
58656	1980	25919639000000	27880	13784	9	0	\N
58659	1980	25921493000000	29720	14446	126	0	\N
58660	1980	25922093000000	29720	14446	127	0	\N
58661	1980	26639652000000	29968	14759	13	0	\N
58663	1980	26639674000000	29968	14759	14	0	\N
58665	1982	155000000	9715	4969	120	0	\N
58666	1982	719000000000	19248	9704	3	0	\N
58667	1982	719012000000	19248	9704	4	0	\N
58668	1982	720155000000	9715	4969	126	0	\N
58669	1982	720196000000	9715	4969	127	0	\N
58672	1988	66000004950000	12263	6036	14	0	\N
58673	1988	1347006864999928	19256	9604	86	0	\N
58678	1991	3355114441475	11468	5895	3	0	\N
58680	1991	3355114441475	12279	6320	1	0	\N
58682	1991	3355115441475	12279	6320	2	0	\N
58683	1991	3355126441475	11468	5895	4	0	\N
58688	1991	4795618441475	12419	6404	3	0	\N
58689	1991	4795618441475	13037	6722	3	0	\N
58690	1991	4795618441475	13039	6722	3	0	\N
58692	1991	4795621441475	12419	6404	4	0	\N
58693	1991	4795630441475	13037	6722	4	0	\N
58694	1991	4795630441475	13039	6722	4	0	\N
58699	1991	5515650441475	13248	6823	4	0	\N
58701	1991	5515663441475	13248	6823	5	0	\N
58702	1991	5515684441475	13527	6964	5	0	\N
58703	1991	5515684441475	13528	6964	5	0	\N
58706	1991	6235661441475	13382	6897	8	0	\N
58707	1991	6235661441475	13590	6989	5	0	\N
58710	1991	6235684441475	13527	6964	7	0	\N
58711	1991	6235684441475	13528	6964	7	0	\N
58712	1991	6235684441475	13590	6989	6	0	\N
58713	1991	6235685441475	13527	6964	8	0	\N
58714	1991	6235685441475	13528	6964	8	0	\N
58715	1991	6235687441475	13382	6897	9	0	\N
58718	1991	6955673441475	13710	7046	4	0	\N
58719	1991	6955673441475	13950	7149	4	0	\N
58722	1991	6955686441475	13710	7046	5	0	\N
58723	1991	6955686441475	13950	7149	5	0	\N
58724	1991	7101297355805	22175	11094	7	0	\N
58725	1991	7101297355805	22369	11196	7	0	\N
58726	1991	7101297355805	22493	11253	8	0	\N
58727	1991	7101297355805	22611	11311	2	0	\N
58728	1991	7101297355805	22612	11311	6	0	\N
58729	1991	7101297355805	22637	11321	4	0	\N
58730	1991	7101297355805	23107	11541	4	0	\N
58732	1991	7101308355805	22611	11311	3	0	\N
58734	1991	7101310355805	22637	11321	5	0	\N
58735	1991	7101310355805	23107	11541	5	0	\N
58736	1991	7101312355805	22612	11311	7	0	\N
58737	1991	7101322355805	22175	11094	8	0	\N
58738	1991	7101322355805	22369	11196	8	0	\N
58739	1991	7101332355805	22493	11253	9	0	\N
58741	1991	7675683441475	13963	7156	13	0	\N
58742	1991	7675768441475	13963	7156	14	0	\N
58744	1991	7821308355805	23321	11639	2	0	\N
58746	1991	7821319355805	23321	11639	3	0	\N
58748	1991	8395784441475	13967	7158	4	0	\N
58751	1991	8395797441475	13967	7158	5	0	\N
58752	1991	8541319355805	24182	12037	3	0	\N
58676	1991	2635103441475	11459	5888	2	0	12
58677	1991	2635114441475	11459	5888	3	0	12
58679	1991	3355114441475	12278	6320	1	0	12
58681	1991	3355115441475	12278	6320	2	0	12
58684	1991	4075115441475	12343	6362	4	0	12
58671	1988	190000040	12994	6700	5	1	1
58691	1991	4795618441475	13049	6728	5	0	12
58695	1991	4795650441475	13049	6728	6	0	12
58698	1991	5515650441475	13247	6823	2	0	12
58700	1991	5515661441475	13247	6823	3	0	12
58709	1991	6235673441475	13673	7026	4	0	12
58720	1991	6955673441475	13951	7149	1	0	12
58721	1991	6955683441475	13951	7149	2	0	12
58740	1991	7675683441475	13962	7156	29	0	12
58749	1991	8395784441475	13968	7158	1	0	12
58750	1991	8395794441475	13968	7158	2	0	12
58619	1980	17999423000000	19140	9655	3	0	1
58620	1980	17999435000000	19140	9655	4	0	1
58621	1980	18719435000000	20974	10549	2	0	1
58686	1991	4221251355805	21253	10672	1	0	21
58687	1991	4221261355805	21253	10672	2	0	21
58696	1991	4941261355805	21288	10690	4	0	21
58697	1991	4941274355805	21288	10690	5	0	21
58704	1991	5661274355805	21500	10784	2	0	21
58716	1991	6381285355805	21720	10881	3	0	21
58717	1991	6381297355805	21720	10881	4	0	21
58625	1980	19439446000000	22099	11050	7	0	1
58627	1980	19439471000000	22099	11050	8	0	1
58632	1980	20159484000000	22868	11431	5	0	1
58635	1980	20879484000000	23111	11542	3	0	1
58636	1980	20879496000000	23111	11542	4	0	1
58731	1991	7101297355805	23300	11627	2	0	21
58733	1991	7101308355805	23300	11627	3	0	21
58747	1991	7821319355805	23345	11649	3	0	21
58639	1980	21599496000000	25479	12619	3	0	1
58640	1980	21599508000000	25479	12619	4	0	1
58643	1980	22319508000000	25660	12699	12	0	1
58644	1980	22319556000000	25660	12699	13	0	1
58646	1980	23039567000000	26026	12863	3	0	1
58647	1980	23759567000000	26114	12906	2	0	1
58648	1980	23759578000000	26114	12906	3	0	1
58649	1980	24479578000000	26300	13009	5	0	1
58651	1980	24479613000000	26850	13281	3	0	1
58652	1980	25199613000000	26850	13281	4	0	1
58655	1980	25919613000000	29719	14653	21	0	1
58657	1980	25919652000000	29719	14653	22	0	1
58658	1980	25919673000000	29979	14763	3	0	1
58664	1980	26639688764171	29979	14763	22	1	1
58753	1991	8541319355805	24194	12042	3	0	\N
58756	1991	8541331355805	24182	12037	4	0	\N
58757	1991	8541331355805	24194	12042	4	0	\N
58758	1991	9115794441475	14161	7228	3	0	\N
58761	1991	9115806441475	14161	7228	4	0	\N
58764	1991	9835795441475	14532	7411	0	0	\N
58767	1991	9981343355805	24900	12364	4	0	\N
58769	1991	9981356355805	24900	12364	5	0	\N
58771	1991	10555796441475	14737	7502	2	0	\N
58774	1991	10555807441475	14737	7502	3	0	\N
58781	1991	11995809441475	14909	7596	4	0	\N
58782	1991	11995809441475	14956	7618	3	0	\N
58785	1991	11995821441475	14956	7618	4	0	\N
58786	1991	11995822441475	14909	7596	5	0	\N
58787	1991	12141380355805	25617	12677	3	0	\N
58788	1991	12141380355805	25681	12707	10	0	\N
58789	1991	12141380355805	25803	12759	3	0	\N
58790	1991	12141380355805	26043	12868	2	0	\N
58792	1991	12141391355805	26043	12868	3	0	\N
58793	1991	12141392355805	25617	12677	4	0	\N
58794	1991	12141392355805	25803	12759	4	0	\N
58796	1991	12141417355805	25681	12707	11	0	\N
58797	1991	12715820441475	15374	7832	1	0	\N
58798	1991	12715820441475	15376	7832	0	0	\N
58799	1991	12715820441475	15921	8095	3	0	\N
58801	1991	12715830441475	15374	7832	2	0	\N
58802	1991	12715832441475	15921	8095	4	0	\N
58812	1991	14301437355805	26809	13258	3	0	\N
58814	1991	14301449355805	26809	13258	4	0	\N
58816	1991	14875856441475	16840	8545	3	0	\N
58818	1991	14875868441475	16840	8545	4	0	\N
58828	1991	16461497355805	27670	13674	3	0	\N
58829	1991	16461497355805	27675	13675	3	0	\N
58831	1991	16461509355805	27670	13674	4	0	\N
58832	1991	16461509355805	27675	13675	4	0	\N
58834	1991	16461555355805	27988	13844	9	0	\N
58837	1991	17181519355805	27841	13761	3	0	\N
58838	1991	17181519355805	27938	13820	3	0	\N
58841	1991	17181531355805	27841	13761	4	0	\N
58842	1991	17181531355805	27938	13820	4	0	\N
58843	1991	17181555355805	27988	13844	10	0	\N
58846	1991	17901530355805	28426	14049	2	0	\N
58847	1991	17901530355805	28733	14178	3	0	\N
58849	1991	17901541355805	28426	14049	3	0	\N
58850	1991	17901542355805	28733	14178	4	0	\N
58852	1991	18475951441475	17964	9062	10	0	\N
58854	1991	18475951441475	18056	9107	3	0	\N
58856	1991	18475972441475	18056	9107	4	0	\N
58857	1991	18475988441475	17964	9062	11	0	\N
58858	1991	18621542355805	28913	14262	2	0	\N
58859	1991	18621542355805	28919	14254	0	0	\N
58861	1991	18621542355805	28941	14273	2	0	\N
58862	1991	18621544355805	28913	14262	3	0	\N
58863	1991	18621553355805	28941	14273	3	0	\N
58867	1991	19341554355805	29147	14372	4	0	\N
58870	1991	19341567355805	29147	14372	5	0	\N
58875	1991	20061566355805	29414	14502	11	0	\N
58876	1991	20061703355805	29414	14502	12	0	\N
58879	1991	21356005441475	18861	9510	3	0	\N
58880	1991	21356005441475	19112	9642	1	0	\N
58881	1991	21356005441475	19224	9675	4	0	\N
58882	1991	21356005441475	19229	9697	5	0	\N
58884	1991	21356005441475	19337	9750	3	0	\N
58885	1991	21356006441475	19112	9642	2	0	\N
58886	1991	21356017441475	19337	9750	4	0	\N
58888	1991	21356026441475	18861	9510	4	0	\N
58765	1991	9835795441475	14565	7427	1	0	12
58766	1991	9835796441475	14565	7427	2	0	12
58772	1991	10555796441475	14758	7515	1	0	12
58773	1991	10555797441475	14758	7515	2	0	12
58777	1991	11275797441475	14841	7564	3	0	12
58783	1991	11995809441475	15202	7746	2	0	12
58784	1991	11995820441475	15202	7746	3	0	12
58800	1991	12715820441475	16338	8306	3	0	12
58803	1991	12715832441475	16338	8306	4	0	12
58806	1991	13435832441475	16556	8415	3	0	12
58810	1991	14155844441475	16628	8447	3	0	12
58811	1991	14155856441475	16628	8447	4	0	12
58817	1991	14875856441475	17287	8755	9	0	12
58819	1991	14875892441475	17287	8755	10	0	12
58823	1991	15595916441475	17288	8756	7	0	12
58826	1991	16315916441475	17316	8772	2	0	12
58827	1991	16315927441475	17316	8772	3	0	12
58835	1991	17035927441475	17551	8887	3	0	12
58836	1991	17035939441475	17551	8887	4	0	12
58845	1991	17755951441475	17942	9050	4	0	12
58853	1991	18475951441475	18054	9107	3	0	12
58855	1991	18475972441475	18054	9107	4	0	12
58865	1991	19195972441475	18099	9128	2	0	12
58866	1991	19195983441475	18099	9128	3	0	12
58872	1991	19915994441475	18390	9269	3	0	12
58877	1991	20635994441475	18804	9476	2	0	12
58878	1991	20636005441475	18804	9476	3	0	12
58883	1991	21356005441475	19336	9750	4	0	12
58754	1991	8541319355805	24596	12226	2	0	21
58755	1991	8541330355805	24596	12226	3	0	21
58762	1991	9261330355805	24770	12299	4	0	21
58763	1991	9261343355805	24770	12299	5	0	21
58768	1991	9981343355805	24956	12385	4	0	21
58775	1991	10701356355805	25126	12467	3	0	21
58776	1991	10701368355805	25126	12467	4	0	21
58779	1991	11421368355805	25302	12552	3	0	21
58780	1991	11421380355805	25302	12552	4	0	21
58791	1991	12141380355805	26119	12911	4	0	21
58804	1991	12861402355805	26303	13011	5	0	21
58805	1991	12861425355805	26303	13011	6	0	21
58808	1991	13581425355805	26626	13172	3	0	21
58809	1991	13581437355805	26626	13172	4	0	21
58815	1991	14301449355805	27024	13365	4	0	21
58820	1991	15021449355805	27048	13373	6	0	21
58821	1991	15021473355805	27048	13373	7	0	21
58824	1991	15741473355805	27273	13480	6	0	21
58825	1991	15741497355805	27273	13480	7	0	21
58833	1991	16461519355805	27707	13690	5	0	21
58839	1991	17181519355805	28236	13961	2	0	21
58840	1991	17181530355805	28236	13961	3	0	21
58848	1991	17901530355805	28817	14213	3	0	21
58851	1991	17901542355805	28817	14213	4	0	21
58864	1991	18621554355805	28940	14273	4	0	21
58868	1991	19341554355805	29332	14455	3	0	21
58869	1991	19341566355805	29332	14455	4	0	21
58873	1991	20060566355805	29415	14502	11	0	21
58889	1991	21356028441475	19229	9697	6	0	\N
58890	1991	21356216441475	19224	9675	5	0	\N
58891	1991	22076018441475	19347	9755	4	0	\N
58892	1991	22076018441475	19765	9952	10	0	\N
58894	1991	22076031441475	19347	9755	5	0	\N
58895	1991	22076037441475	19765	9952	11	0	\N
58899	1991	23516129441475	20103	10119	9	0	\N
58902	1991	23516192441475	20103	10119	10	0	\N
58915	1992	2879080000000	10911	5629	2	0	\N
58917	1992	2879080000000	10989	5662	4	0	\N
58918	1992	2879080000000	10990	5662	4	0	\N
58920	1992	2879100000000	10911	5629	3	0	\N
58921	1992	2879120000000	10989	5662	5	0	\N
58922	1992	2879120000000	10990	5662	5	0	\N
58923	1992	2881246990000	29977	14762	20	0	\N
58924	1992	2881284990000	29977	14762	21	0	\N
58925	1992	3599080990000	11040	5683	2	0	\N
58926	1992	3599080990000	11154	5734	2	0	\N
58928	1992	3599100990000	11040	5683	3	0	\N
58929	1992	3599100990000	11154	5734	3	0	\N
58933	1992	5039140990000	11287	5798	2	0	\N
58934	1992	5039140990000	11484	5902	3	0	\N
58937	1992	5039151990000	11287	5798	3	0	\N
58938	1992	5039152990000	11484	5902	4	0	\N
58939	1992	5040510990000	20868	10490	3	0	\N
58940	1992	5040510990000	21406	10737	4	0	\N
58942	1992	5040522990000	20868	10490	4	0	\N
58943	1992	5040523990000	21406	10737	5	0	\N
58950	1992	6479142990000	11854	6068	9	0	\N
58952	1992	6479232990000	11854	6068	10	0	\N
58953	1992	6480560990000	21492	10779	2	0	\N
58954	1992	6480560990000	21832	10927	2	0	\N
58956	1992	6480560990000	21912	10955	0	0	\N
58957	1992	6480571990000	21492	10779	3	0	\N
58958	1992	6480571990000	21832	10927	3	0	\N
58962	1992	7200572990000	23269	11610	2	0	\N
58963	1992	7200572990000	23271	11581	1	0	\N
58965	1992	7200573990000	23271	11581	2	0	\N
58966	1992	7200583990000	23269	11610	3	0	\N
58968	1992	7919175990000	12492	6438	1	0	\N
58970	1992	7919176990000	12492	6438	2	0	\N
58973	1992	7920583990000	23595	11754	13	0	\N
58975	1992	7920632990000	23595	11754	14	0	\N
58976	1992	8639197990000	13077	6739	4	0	\N
58979	1992	8639210990000	13077	6739	5	0	\N
58982	1992	8641007990000	23651	11782	4	0	\N
58983	1992	8641007990000	23652	11782	4	0	\N
58987	1992	9361007990000	23651	11782	8	0	\N
58988	1992	9361007990000	23652	11782	7	0	\N
58989	1992	9361018990000	23652	11782	8	0	\N
58991	1992	9361019990000	23651	11782	9	0	\N
58992	1992	10079231990000	14990	7636	3	0	\N
58994	1992	10079243990000	14990	7636	4	0	\N
58997	1992	10079273990000	16025	8148	2	0	\N
58998	1992	10081019990000	24089	11990	8	0	\N
58999	1992	10081019990000	24348	12109	3	0	\N
59001	1992	10081031990000	24348	12109	4	0	\N
59003	1992	10081063990000	24089	11990	9	0	\N
59005	1992	10799273990000	16025	8148	5	0	\N
59007	1992	10799275990000	16025	8148	6	0	\N
59008	1992	10801031990000	25227	12514	5	0	\N
59009	1992	10801031990000	25231	12514	3	0	\N
59011	1992	10801043990000	25231	12514	4	0	\N
59013	1992	10801045990000	25227	12514	6	0	\N
59014	1992	11519275990000	16332	8302	4	0	\N
59015	1992	11519275990000	16382	8333	3	0	\N
59016	1992	11519275990000	16642	8456	0	0	\N
59018	1992	11519275990000	16898	8548	1	0	\N
59019	1992	11519275990000	16899	8557	1	0	\N
59020	1992	11519275990000	16900	8569	7	0	\N
59021	1992	11519275990000	16901	8566	1	0	\N
59022	1992	11519285990000	16898	8548	2	0	\N
59023	1992	11519285990000	16899	8557	2	0	\N
59024	1992	11519285990000	16901	8566	2	0	\N
58907	1992	1439020000000	10145	5260	2	0	0
58908	1992	1439040000000	10145	5260	3	0	0
58911	1992	2159040000000	10645	5499	4	0	0
58912	1992	2159080000000	10645	5499	5	0	0
58916	1992	2879080000000	10988	5662	4	0	0
58927	1992	3599080990000	11198	5750	4	0	0
58930	1992	3599120990000	11198	5750	5	0	0
58931	1992	4319120990000	11216	5761	2	0	0
58932	1992	4319140990000	11216	5761	3	0	0
58935	1992	5039140990000	11616	5977	1	0	0
58945	1992	5759141990000	11700	6016	1	0	0
58946	1992	5759142990000	11700	6016	2	0	0
58949	1992	6479142990000	11853	6093	1	0	0
58951	1992	6479143990000	11853	6093	2	0	0
58961	1992	7199175990000	12232	6300	6	0	0
58969	1992	7919175990000	13027	6715	4	0	0
58971	1992	7919197990000	13027	6715	5	0	0
58977	1992	8639197990000	13499	6951	3	0	0
58978	1992	8639209990000	13499	6951	4	0	0
58985	1992	9359231990000	14720	7495	5	0	0
58993	1992	10079231990000	15413	7851	4	0	0
58995	1992	10079262990000	15413	7851	5	0	0
58996	1992	10079273990000	16023	8148	2	0	0
59004	1992	10799273990000	16023	8148	5	0	0
59017	1992	11519275990000	16897	8569	3	0	0
58893	1991	22076018441475	19953	10047	10	0	12
58896	1991	22076055441475	19953	10047	11	0	12
58897	1991	22796055441475	20101	10118	11	0	12
58900	1991	23516129441475	20389	10273	9	0	12
58901	1991	23516165441475	20389	10273	10	0	12
58941	1992	5040510990000	21407	10737	4	0	5
58944	1992	5040523990000	21407	10737	5	0	5
58947	1992	5760523990000	21466	10769	10	0	5
58955	1992	6480560990000	21911	10964	3	0	5
58959	1992	6480572990000	21911	10964	4	0	5
58964	1992	7200572990000	23429	11689	2	0	5
58967	1992	7200583990000	23429	11689	3	0	5
58972	1992	7920583990000	23592	11756	6	0	5
58980	1992	8640607990000	23614	11764	0	0	5
58981	1992	8641007990000	23650	11782	4	0	5
58986	1992	9361007990000	23650	11782	8	0	5
58990	1992	9361019990000	23650	11782	9	0	5
59002	1992	10081031990000	25057	12434	4	0	5
59010	1992	10801031990000	25254	12527	4	0	5
59012	1992	10801044990000	25254	12527	5	0	5
58905	1992	721107990000	29519	14559	2	0	6
58906	1992	721109990000	29519	14559	3	0	6
58910	1992	1441128990000	29856	14715	11	0	6
58913	1992	2161128990000	29900	14732	10	0	6
58914	1992	2161246990000	29900	14732	11	0	6
59025	1992	11519287990000	16382	8333	4	0	\N
59027	1992	11519288990000	16332	8302	5	0	\N
59028	1992	11519309990000	16900	8569	8	0	\N
59034	1992	12241056990000	26149	12917	30	0	\N
59036	1992	12241203990000	26149	12917	31	0	\N
59040	1992	12960220990000	17596	8819	82	0	\N
59043	1992	12961203990000	26185	12918	82	0	\N
59044	1992	12961483990000	26185	12918	83	0	\N
59045	1992	13679310990000	17344	8788	3	0	\N
59047	1992	13679322990000	17344	8788	4	0	\N
59049	1992	13680220990000	17596	8819	126	0	\N
59050	1992	13680650990000	17596	8819	127	0	\N
59053	1992	14399322990000	17724	8957	3	0	\N
59054	1992	14399322990000	18120	9138	3	0	\N
59056	1992	14399334990000	17724	8957	4	0	\N
59057	1992	14399334990000	18120	9138	4	0	\N
59061	1992	15119334990000	18161	9156	4	0	\N
59062	1992	15119334990000	18761	9457	3	0	\N
59065	1992	15119346990000	18761	9457	4	0	\N
59066	1992	15119347990000	18161	9156	5	0	\N
59068	1992	15119354990000	19023	9590	1	0	\N
59069	1992	15119354990000	19024	9590	1	0	\N
59072	1992	15839344990000	18931	9550	2	0	\N
59074	1992	15839354990000	19023	9590	2	0	\N
59075	1992	15839354990000	19024	9590	2	0	\N
59076	1992	15839355990000	18931	9550	3	0	\N
59079	1992	16559354990000	19257	9709	10	0	\N
59081	1992	16559354990000	19368	9764	7	0	\N
59083	1992	16559379990000	19368	9764	8	0	\N
59084	1992	16559391990000	19257	9709	11	0	\N
59085	1992	16561117990000	28100	13890	10	0	\N
59086	1992	16561117990000	29165	14380	2	0	\N
59087	1992	16561117990000	29180	14386	3	0	\N
59088	1992	16561119990000	29165	14380	3	0	\N
59089	1992	16561129990000	29180	14386	4	0	\N
59090	1992	16561154990000	28100	13890	11	0	\N
59094	1992	17999404990000	19844	9997	3	0	\N
59096	1992	17999416990000	19844	9997	4	0	\N
59106	1992	21599525990000	20511	10326	2	0	\N
59107	1992	21599527990000	20511	10326	3	0	\N
59112	1992	23039549990000	20807	10460	3	0	\N
59114	1992	23039561990000	20807	10460	4	0	\N
59115	1994	1650000000	11456	5777	66	0	\N
59116	1996	200000002	12263	6036	16	0	\N
59117	1996	450000000	14683	7419	31	0	\N
59118	1996	450000000	14712	7290	37	0	\N
59120	2000	200000002	11284	5796	2	0	\N
59121	2000	4194097180988	11281	5795	7	1	\N
59122	2000	20156533899864	10125	5252	4	1	\N
59123	2004	200000009	13653	7019	6	0	\N
59129	2004	200000072	28987	14293	4	1	\N
59131	2004	200004263	29784	14678	18	1	\N
59133	2004	200010563	29798	14683	14	0	\N
59135	2004	200011963	29876	14690	127	0	\N
59139	2004	200021063	29848	14710	43	0	\N
59142	2004	200025963	29861	14718	13	0	\N
59143	2004	200030163	29879	14725	16	0	\N
59145	2004	200033663	29930	14727	101	0	\N
59147	2004	200034363	29905	14734	14	0	\N
59148	2004	200036463	29920	14733	83	0	\N
59150	2004	200038563	29933	14744	20	0	\N
59151	2004	200038563	29938	14742	59	1	\N
59153	2004	200039290	29957	14754	15	1	\N
59155	2004	200039335	29980	14764	11	1	\N
59156	2004	200039335	29981	14764	10	1	\N
59126	2004	200000027	28691	14165	3	0	0
59128	2004	200000063	28694	14166	2	0	0
59159	2004	200039425	29999	14771	25	0	\N
59026	1992	11519287990000	16897	8569	4	0	0
59031	1992	12239287990000	17226	8727	3	0	0
59032	1992	12239299990000	17226	8727	4	0	0
59037	1992	12959299990000	17308	8768	2	0	0
59038	1992	12959310990000	17308	8768	3	0	0
59046	1992	13679321990000	17595	8901	4	0	0
59048	1992	13679322990000	17595	8901	5	0	0
59055	1992	14399322990000	18131	9143	3	0	0
59058	1992	14399334990000	18131	9143	4	0	0
59063	1992	15119334990000	18897	9531	1	0	0
59067	1992	15119354990000	19022	9590	1	0	0
59073	1992	15839354990000	19022	9590	2	0	0
59080	1992	16559354990000	19367	9764	7	0	0
59082	1992	16559379990000	19367	9764	8	0	0
59092	1992	17279404990000	19744	9939	8	0	0
59093	1992	17999404990000	19842	9997	3	0	0
59095	1992	17999416990000	19842	9997	4	0	0
59097	1992	18719416990000	19849	10000	6	0	0
59098	1992	18719431990000	19849	10000	7	0	0
59100	1992	19439477990000	20168	10153	10	0	0
59101	1992	20159477990000	20249	10198	3	0	0
59102	1992	20159489990000	20249	10198	4	0	0
59103	1992	20879489990000	20391	10275	9	0	0
59104	1992	20879525990000	20391	10275	10	0	0
59108	1992	21599537990000	20510	10326	4	0	0
59109	1992	22319537990000	20692	10407	3	0	0
59110	1992	22319549990000	20692	10407	4	0	0
59111	1992	23039549990000	20806	10460	2	0	0
59029	1992	11521044990000	25454	12609	3	0	5
59030	1992	11521056990000	25454	12609	4	0	5
59033	1992	12241056990000	26148	12927	3	0	5
59035	1992	12241068990000	26148	12927	4	0	5
59041	1992	12961068990000	26183	12944	3	0	5
59051	1992	13681080990000	26801	13252	3	0	5
59052	1992	13681092990000	26801	13252	4	0	5
59059	1992	14401092990000	26829	13267	3	0	5
59060	1992	14401104990000	26829	13267	4	0	5
59070	1992	15121104990000	26987	13347	2	0	5
59077	1992	15841106990000	27697	13686	2	0	5
59078	1992	15841117990000	27697	13686	3	0	5
59127	2004	200000054	28691	14165	5	1	0
59130	2004	200004263	29782	14678	18	1	0
59134	2004	200010563	29799	14683	13	0	0
59136	2004	200014763	29818	14692	16	0	0
59137	2004	200018963	29837	14703	14	0	0
59138	2004	200021063	29847	14710	48	0	0
59140	2004	200025263	29859	14717	17	0	0
59144	2004	200030163	29880	14725	16	0	0
59146	2004	200034363	29904	14734	14	0	0
59149	2004	200038563	29932	14744	20	0	0
59152	2004	200039290	29956	14754	15	1	0
59154	2004	200039326	29979	14763	25	0	0
59158	2004	200039425	29998	14771	24	1	0
59160	2004	200039443	30012	14779	14	0	0
59161	2004	200039470	30099	14773	127	1	\N
59163	2004	200039524	30051	14795	21	1	\N
59166	2004	200039533	30064	14801	13	0	\N
59169	2004	200039569	30081	14811	14	1	\N
59170	2004	200039569	30082	14811	14	1	\N
59171	2004	200039569	30083	14811	14	1	\N
59172	2004	200039569	30084	14811	12	1	\N
59173	2004	200039578	30267	14812	127	0	\N
59175	2004	200039596	30126	14825	24	0	\N
59176	2004	200039641	30207	14832	127	0	\N
59177	2004	200039668	30167	14843	13	0	\N
59178	2004	200039668	30168	14843	12	0	\N
59180	2004	200039713	30188	14851	26	0	\N
59182	2004	200039722	30210	14858	39	1	\N
59183	2004	200039722	30211	14858	38	1	\N
59184	2004	200039722	30213	14858	39	1	\N
59186	2004	200039749	30215	14859	14	0	\N
59187	2004	200039749	30216	14859	14	0	\N
59188	2004	200039749	30217	14859	14	0	\N
59189	2004	200039749	30218	14859	15	0	\N
59190	2004	200039749	30219	14859	14	0	\N
59194	2004	200039785	30240	14867	7	1	\N
59195	2004	200039785	30241	14867	5	1	\N
59197	2004	200039830	30255	14876	23	0	\N
59198	2004	200039830	30256	14876	23	0	\N
59203	2004	200039947	30317	14900	7	1	\N
59204	2004	200039947	30318	14900	7	1	\N
59205	2004	200039972	29986	14751	126	1	\N
59206	2004	200041363	30001	14734	127	0	\N
59207	2004	200045563	30223	14735	55	0	\N
59208	2004	200046263	30223	14735	107	1	\N
59209	2004	16560317001040	14213	7239	17	0	\N
59210	2009	719000000000	10157	5265	2	0	\N
59211	2009	719000000000	11230	5771	5	0	\N
59212	2009	719020000000	10157	5265	3	0	\N
59213	2009	719023000000	11230	5771	6	0	\N
59215	2014	1440514999998	10928	5635	9	1	\N
59216	2021	699000000000	10457	5406	6	0	\N
59220	2029	1439010000000	11385	5848	2	0	\N
59221	2029	1439010000000	16757	8507	3	0	\N
59222	2029	1439013000000	16757	8507	4	0	\N
59223	2029	1439021000000	11385	5848	3	0	\N
59226	2039	2779255000000	20993	10559	2	0	\N
59228	2039	2779275000000	20993	10559	3	0	\N
59230	2039	2881002000000	11349	5829	2	0	\N
59231	2039	2881002000000	11480	5901	2	0	\N
59233	2039	2881013000000	11349	5829	3	0	\N
59234	2039	2881013000000	11480	5901	3	0	\N
59238	2039	3601025000000	11667	5999	1	0	\N
59239	2039	3601025000000	11849	6083	0	0	\N
59240	2039	3601025000000	11850	6092	2	0	\N
59241	2039	3601025000000	11852	6086	0	0	\N
59242	2039	3601025000000	11858	6095	0	0	\N
59244	2039	3601026000000	11667	5999	2	0	\N
59246	2039	3601036000000	11850	6092	3	0	\N
59247	2039	4219288000000	21399	10735	11	0	\N
59248	2039	4219288000000	21421	10743	3	0	\N
59250	2039	4219300000000	21421	10743	4	0	\N
59252	2039	4219345000000	21399	10735	12	0	\N
59253	2039	4321026000000	12054	6205	1	0	\N
59255	2039	4321027000000	12054	6205	2	0	\N
59262	2039	5659325000000	21929	10972	2	0	\N
59263	2039	5659336000000	21929	10972	3	0	\N
59267	2039	6379337000000	21965	10987	3	0	\N
59268	2039	6379337000000	21968	10986	6	0	\N
59270	2039	6379337000000	22015	11008	3	0	\N
59272	2039	6379349000000	21965	10987	4	0	\N
59273	2039	6379349000000	22015	11008	4	0	\N
59274	2039	6379361000000	21968	10986	7	0	\N
59279	2039	7201094000000	13726	7055	4	0	\N
59282	2039	7201107000000	13726	7055	5	0	\N
59214	2012	201000000	24027	11957	12	0	0
59283	2039	7201138000000	14130	7220	7	0	\N
59284	2039	7819360000000	22248	11134	4	0	\N
59286	2039	7819373000000	22248	11134	5	0	\N
59290	2039	7921138000000	14130	7220	8	0	\N
59296	2039	9259387000000	23306	11629	2	0	\N
59224	2039	2160980000000	11348	5828	4	0	1
59225	2039	2161002000000	11348	5828	5	0	1
59232	2039	2881002000000	11506	5911	5	0	1
59235	2039	2881025000000	11506	5911	6	0	1
59243	2039	3601025000000	11859	6095	1	0	1
59254	2039	4321026000000	12542	6463	4	0	1
59256	2039	4321048000000	12542	6463	5	0	1
59259	2039	5041048000000	12756	6576	4	0	1
59260	2039	5041070000000	12756	6576	5	0	1
59265	2039	5761070000000	13319	6862	3	0	1
59275	2039	6481082000000	13321	6864	3	0	1
59276	2039	6481094000000	13321	6864	4	0	1
59280	2039	7201094000000	13727	7055	1	0	1
59281	2039	7201104000000	13727	7055	2	0	1
59289	2039	7921117000000	14460	7382	5	0	1
59293	2039	8641117000000	14677	7476	24	0	1
59294	2039	8641330000000	14677	7476	25	0	1
59227	2039	2779255000000	20996	10559	4	0	6
59229	2039	2779277000000	20996	10559	5	0	6
59237	2039	3499288000000	21179	10635	3	0	6
59249	2039	4219288000000	21445	10757	3	0	6
59251	2039	4219300000000	21445	10757	4	0	6
59257	2039	4939300000000	21510	10790	7	0	6
59258	2039	4939325000000	21510	10790	8	0	6
59264	2039	5659337000000	21927	10972	4	0	6
59269	2039	6379337000000	22014	11008	2	0	6
59271	2039	6379348000000	22014	11008	3	0	6
59277	2039	7099348000000	22189	11105	3	0	6
59285	2039	7819360000000	22655	11327	4	0	6
59287	2039	7819373000000	22655	11327	5	0	6
59291	2039	8539373000000	22865	11430	5	0	6
59292	2039	8539387000000	22865	11430	6	0	6
59295	2039	9259387000000	23304	11629	2	0	6
59164	2004	200039524	30052	14795	21	1	0
59165	2004	200039533	30063	14801	13	0	0
59167	2004	200039542	30065	14802	12	0	0
59168	2004	200039569	30080	14811	14	1	0
59174	2004	200039596	30125	14825	24	0	0
59181	2004	200039713	30190	14851	26	0	0
59185	2004	200039722	30214	14858	39	1	0
59191	2004	200039749	30220	14859	14	0	0
59192	2004	200039776	30238	14866	29	0	0
59196	2004	200039794	30254	14875	13	1	0
59199	2004	200039830	30257	14876	23	0	0
59200	2004	200039857	30266	14881	38	0	0
59201	2004	200039911	30276	14887	38	0	0
59202	2004	200039929	30277	14888	17	0	0
59298	2039	9259398000000	23306	11629	3	0	\N
59301	2039	9979398000000	23423	11687	1	0	\N
59302	2039	9979398000000	23424	11686	8	0	\N
59303	2039	9979398000000	23425	11687	2	0	\N
59305	2039	9979408000000	23423	11687	2	0	\N
59306	2039	9979409000000	23425	11687	3	0	\N
59308	2039	9979442000000	23424	11686	9	0	\N
59309	2039	10081341000000	14985	7634	1	0	\N
59311	2039	10081351000000	14985	7634	2	0	\N
59313	2039	10699409000000	23502	11716	7	0	\N
59314	2039	10699409000000	23519	11723	8	0	\N
59315	2039	10699409000000	23591	11756	6	0	\N
59316	2039	10699409000000	23703	11805	2	0	\N
59317	2039	10699409000000	23704	11805	3	0	\N
59319	2039	10699420000000	23703	11805	3	0	\N
59320	2039	10699421000000	23704	11805	4	0	\N
59321	2039	10699426000000	23519	11723	9	0	\N
59322	2039	10699433000000	23591	11756	7	0	\N
59324	2039	10699434000000	23502	11716	8	0	\N
59325	2039	10801351000000	15177	7733	3	0	\N
59327	2039	10801363000000	15177	7733	4	0	\N
59329	2039	11419433000000	24480	11970	0	0	\N
59331	2039	11419433000000	24482	11983	0	0	\N
59332	2039	11419433000000	24483	11995	0	0	\N
59336	2039	12139456000000	24611	12232	3	0	\N
59338	2039	12139468000000	24611	12232	4	0	\N
59342	2039	12859579000000	24725	12278	44	0	\N
59345	2039	12859920000000	24725	12278	45	0	\N
59346	2039	12961383000000	15644	7961	4	0	\N
59347	2039	12961383000000	15684	7980	2	0	\N
59348	2039	12961383000000	15688	7980	3	0	\N
59350	2039	12961394000000	15684	7980	3	0	\N
59351	2039	12961395000000	15688	7980	4	0	\N
59353	2039	12961396000000	15644	7961	5	0	\N
59360	2039	14299645000000	25573	12660	3	0	\N
59365	2039	15019645000000	25573	12660	10	0	\N
59366	2039	15019651000000	25573	12660	11	0	\N
59371	2039	15841432000000	17044	8632	6	0	\N
59374	2039	15841456000000	17044	8632	7	0	\N
59375	2039	16459647000000	26731	13222	3	0	\N
59377	2039	16459659000000	26731	13222	4	0	\N
59379	2039	16561444000000	17454	8839	7	0	\N
59382	2039	16561505000000	17454	8839	8	0	\N
59391	2039	18619708000000	27291	13488	2	0	\N
59392	2039	18619708000000	27600	13641	6	0	\N
59393	2039	18619708000000	27601	13641	0	0	\N
59395	2039	18619719000000	27291	13488	3	0	\N
59397	2039	18619732000000	27600	13641	7	0	\N
59398	2039	18721506000000	18577	9360	1	0	\N
59400	2039	18721516000000	18577	9360	2	0	\N
59404	2039	19441518000000	18875	9518	1	0	\N
59405	2039	19441518000000	19518	9806	8	0	\N
59407	2039	19441528000000	18875	9518	2	0	\N
59409	2039	19441535000000	19518	9806	9	0	\N
59413	2039	20059860000000	28217	13952	2	0	\N
59414	2039	20059860000000	28218	13952	2	0	\N
59418	2039	20779860000000	28217	13952	4	0	\N
59419	2039	20779860000000	28218	13952	4	0	\N
59421	2039	20779861000000	28217	13952	5	0	\N
59422	2039	20779861000000	28218	13952	5	0	\N
59427	2039	21601555000000	20586	10356	10	0	\N
59428	2039	21601637000000	20586	10356	11	0	\N
59299	2039	9361330000000	14971	7627	2	0	1
59300	2039	9361341000000	14971	7627	3	0	1
59310	2039	10081341000000	15039	7662	1	0	1
59312	2039	10081351000000	15039	7662	2	0	1
59326	2039	10801351000000	15200	7745	3	0	1
59334	2039	11521363000000	15291	7792	1	0	1
59335	2039	11521373000000	15291	7792	2	0	1
59340	2039	12241373000000	15565	7921	1	0	1
59341	2039	12241383000000	15565	7921	2	0	1
59349	2039	12961383000000	15973	8119	3	0	1
59356	2039	13681395000000	15981	8123	3	0	1
59357	2039	13681407000000	15981	8123	4	0	1
59361	2039	14401407000000	16177	8223	3	0	1
59362	2039	14401419000000	16177	8223	4	0	1
59432	2041	1439351000000	16254	8261	4	0	1
59367	2039	15121419000000	16666	8466	4	0	1
59368	2039	15121432000000	16666	8466	5	0	1
59372	2039	15841432000000	17057	8638	3	0	1
59373	2039	15841444000000	17057	8638	4	0	1
59381	2039	16561478000000	17648	8922	8	0	1
59385	2039	17281478000000	17913	9035	6	0	1
59386	2039	17281493000000	17913	9035	7	0	1
59389	2039	18001493000000	18497	9316	4	0	1
59390	2039	18001506000000	18497	9316	5	0	1
59401	2039	18721518000000	18661	9403	4	0	1
59406	2039	19441518000000	19519	9835	3	0	1
59408	2039	19441530000000	19519	9835	4	0	1
59415	2039	20161530000000	19950	10046	3	0	1
59423	2039	20881542000000	20473	10310	4	0	1
59424	2039	20881555000000	20473	10310	5	0	1
59297	2039	9259398000000	23304	11629	3	0	6
59304	2039	9979398000000	23426	11687	2	0	6
59307	2039	9979409000000	23426	11687	3	0	6
59323	2039	10699433000000	24047	11967	7	0	6
59330	2039	11419433000000	24481	12173	5	0	6
59333	2039	11419456000000	24481	12173	6	0	6
59337	2039	12139456000000	24633	12240	6	0	6
59339	2039	12139579000000	24633	12240	7	0	6
59344	2039	12859591000000	24955	12384	4	0	6
59354	2039	13579591000000	25123	12465	3	0	6
59355	2039	13579603000000	25123	12465	4	0	6
59358	2039	14299603000000	25502	12629	3	0	6
59363	2039	15019615000000	25880	12791	2	0	6
59364	2039	15019626000000	25880	12791	3	0	6
59369	2039	15739626000000	25898	12801	3	0	6
59370	2039	15739647000000	25898	12801	4	0	6
59376	2039	16459647000000	26792	13248	10	0	6
59383	2039	17179684000000	27119	13409	3	0	6
59384	2039	17179696000000	27119	13409	4	0	6
59387	2039	17899696000000	27279	13483	3	0	6
59388	2039	17899708000000	27279	13483	4	0	6
59394	2039	18619708000000	27668	13674	3	0	6
59402	2039	19339720000000	27741	13705	14	0	6
59403	2039	19339797000000	27741	13705	15	0	6
59410	2039	20059797000000	27783	13727	7	0	6
59411	2039	20059840000000	27783	13727	8	0	6
59417	2039	20779860000000	28216	13952	4	0	6
59420	2039	20779861000000	28216	13952	5	0	6
59425	2039	21499861000000	28327	14004	2	0	6
59426	2039	21499872000000	28327	14004	3	0	6
59437	2044	1199000000	23333	11457	0	0	\N
59438	2048	200000001	11536	5928	7	0	\N
59439	2048	200000004	11536	5928	9	0	\N
59440	2048	5399113085978	11493	5904	9	1	\N
59441	2049	719000000000	11422	5867	4	0	\N
59444	2049	719022000000	11422	5867	5	0	\N
59446	2052	200000001	11878	6035	7	0	\N
59447	2052	200000001	12091	6029	32	0	\N
59451	2052	200000013	13653	7019	4	0	\N
59452	2052	200000013	17065	8644	1	0	\N
59456	2052	220000142	28569	13882	24	0	\N
59457	2052	230000142	28579	13883	2	0	\N
59458	2052	250000142	28626	13884	16	0	\N
59459	2052	700000000	12263	6036	16	1	\N
59460	2052	13679240999995	17065	8644	2	1	\N
59461	2052	81120848889900	18687	9414	4	1	\N
59462	2052	116569769324065	13653	7019	5	1	\N
59465	2055	1439002000000	17859	9014	3	0	\N
59467	2055	1439014000000	17859	9014	4	0	\N
59471	2064	717200000000	28696	14167	3	0	\N
59472	2067	1402590000	24642	12242	8	0	\N
59473	2067	7929382320042	14854	7571	10	0	\N
59474	2067	9360186697628	14859	7572	3	0	\N
59475	2069	201000000	13448	6928	11	0	\N
59476	2069	201000000	13622	7003	1	0	\N
59477	2069	8154614804269	23976	11931	4	1	\N
59478	2069	10210570848311	27534	13412	76	0	\N
59479	2070	10751826751155	15302	7798	5	0	\N
59480	2070	13147997885200	16707	8428	124	0	\N
59482	2076	5717026291484	23450	11674	12	1	\N
59483	2084	499000000000	13106	6645	0	0	\N
59486	2086	720333300069	22900	11447	3	0	\N
59489	2086	720345300069	22900	11447	4	0	\N
59490	2086	1439025000000	13291	6847	6	0	\N
59491	2086	1439025000000	13333	6872	10	0	\N
59492	2086	1439025000000	13541	6970	3	0	\N
59493	2086	1439025000000	13581	6986	4	0	\N
59494	2086	1439025000000	14767	7521	2	0	\N
59495	2086	1439025000000	14829	7559	4	0	\N
59496	2086	1439025000000	14874	7577	2	0	\N
59498	2086	1439036000000	14767	7521	3	0	\N
59499	2086	1439036000000	14874	7577	3	0	\N
59500	2086	1439037000000	13541	6970	4	0	\N
59502	2086	1439038000000	13581	6986	5	0	\N
59503	2086	1439047000000	14829	7559	5	0	\N
59504	2086	1439049000000	13291	6847	7	0	\N
59505	2086	1439062000000	13333	6872	11	0	\N
59506	2086	1440344300069	23582	11752	4	0	\N
59507	2086	1440344300069	23791	11845	3	0	\N
59510	2086	1440356300069	23791	11845	4	0	\N
59511	2086	1440357300069	23582	11752	5	0	\N
59512	2086	2159037000000	15037	7662	1	0	\N
59514	2086	2159047000000	15037	7662	2	0	\N
59516	2086	2160355300069	24621	12236	3	0	\N
59517	2086	2160355300069	24829	12328	3	0	\N
59518	2086	2160355300069	24979	12397	3	0	\N
59519	2086	2160355300069	24984	12398	5	0	\N
59521	2086	2160367300069	24621	12236	4	0	\N
59522	2086	2160367300069	24829	12328	4	0	\N
59523	2086	2160367300069	24979	12397	4	0	\N
59525	2086	2160369300069	24984	12398	6	0	\N
59526	2086	2160387300069	26670	13190	2	0	\N
59528	2086	2879067000000	16652	8461	7	0	\N
59529	2086	2879067000000	16745	8502	10	0	\N
59530	2086	2879067000000	16850	8551	3	0	\N
59531	2086	2879067000000	16981	8603	2	0	\N
59532	2086	2879067000000	17709	8951	2	0	\N
59534	2086	2879068000000	15122	7708	1	0	\N
59535	2086	2879068000000	15218	7754	5	0	\N
59536	2086	2879068000000	15473	7879	2	0	\N
59537	2086	2879068000000	15505	7890	0	0	\N
59538	2086	2879068000000	15506	7892	0	0	\N
59539	2086	2879068000000	15573	7928	1	0	\N
59540	2086	2879068000000	15954	8112	3	0	\N
59541	2086	2879068000000	15988	8128	3	0	\N
59542	2086	2879078000000	15122	7708	2	0	\N
59543	2086	2879078000000	15573	7928	2	0	\N
59544	2086	2879078000000	16981	8603	3	0	\N
59545	2086	2879078000000	17709	8951	3	0	\N
59546	2086	2879079000000	15473	7879	3	0	\N
59547	2086	2879079000000	16850	8551	4	0	\N
59481	2076	200001000	23358	11656	2	0	0
59548	2086	2879080000000	15954	8112	4	0	\N
59549	2086	2879080000000	15988	8128	4	0	\N
59551	2086	2879091000000	15218	7754	6	0	\N
59552	2086	2879092000000	16652	8461	8	0	\N
59553	2086	2879104000000	16745	8502	11	0	\N
59554	2086	2879115000000	18479	9308	8	0	\N
59555	2086	2880367300069	25283	12542	6	0	\N
59556	2086	2880367300069	25510	12633	3	0	\N
59557	2086	2880367300069	25920	12809	2	0	\N
59558	2086	2880367300069	26181	12944	3	0	\N
59559	2086	2880367300069	26383	13049	4	0	\N
59561	2086	2880378300069	25920	12809	3	0	\N
59562	2086	2880379300069	25510	12633	4	0	\N
59563	2086	2880379300069	26181	12944	4	0	\N
59565	2086	2880380300069	26383	13049	5	0	\N
59566	2086	2880387300069	26670	13190	8	0	\N
59567	2086	2880391300069	25283	12542	7	0	\N
59568	2086	2880392300069	26670	13190	9	0	\N
59449	2052	200000011	12994	6700	6	0	0
59484	2086	719000000000	13263	6833	7	0	0
59485	2086	719025000000	13263	6833	8	0	0
59497	2086	1439025000000	15019	7653	3	0	0
59501	2086	1439037000000	15019	7653	4	0	0
59515	2086	2159068000000	15061	7671	5	0	0
59453	2052	200000092	17188	8710	11	1	0
59533	2086	2879067000000	17714	8953	4	0	1
59550	2086	2879089000000	17714	8953	5	0	1
59454	2052	200000142	18691	9416	9	1	0
59442	2049	719000000000	22142	11075	4	0	0
59443	2049	719013000000	22142	11075	5	0	0
59455	2052	210000142	22153	11083	11	1	0
59487	2086	720333300069	23265	11609	2	0	3
59508	2086	1440344300069	24121	12006	2	0	3
59509	2086	1440355300069	24121	12006	3	0	3
59433	2041	2159351000000	24257	12070	13	0	1
59434	2041	2159400000000	24257	12070	14	0	1
59520	2086	2160355300069	25163	12484	3	0	3
59466	2055	1439002000000	25569	12659	3	0	0
59468	2055	1439014000000	25569	12659	4	0	0
59435	2041	2879400000000	25729	12730	9	0	1
59436	2041	2879436000000	25729	12730	10	0	1
59445	2049	1439013000000	26171	12939	0	0	0
59470	2055	2159026000000	26431	13076	4	0	0
59560	2086	2880367300069	26853	13283	3	0	3
59564	2086	2880379300069	26853	13283	4	0	3
59573	2086	3599115000000	18479	9308	9	0	\N
59576	2086	3600412300069	27782	13726	3	0	\N
59577	2086	3775321300069	20667	10396	13	0	\N
59578	2086	3775321300069	20713	10416	3	0	\N
59579	2086	3775321300069	20753	10433	5	0	\N
59580	2086	3775321300069	20855	10482	4	0	\N
59581	2086	3775321300069	21561	10812	3	0	\N
59582	2086	3775321300069	21683	10863	4	0	\N
59583	2086	3775321300069	21694	10867	6	0	\N
59584	2086	3775321300069	21972	10988	6	0	\N
59585	2086	3775321300069	22257	11139	4	0	\N
59587	2086	3775333300069	20713	10416	4	0	\N
59588	2086	3775333300069	21561	10812	4	0	\N
59589	2086	3775334300069	22257	11139	5	0	\N
59591	2086	3775335300069	20753	10433	6	0	\N
59592	2086	3775345300069	21694	10867	7	0	\N
59593	2086	3775345300069	21972	10988	7	0	\N
59594	2086	3775353300069	20855	10482	5	0	\N
59595	2086	3775353300069	21683	10863	5	0	\N
59596	2086	3775370300069	20667	10396	14	0	\N
59598	2086	4319240000000	19633	9880	14	0	\N
59600	2086	4320412300069	27782	13726	5	0	\N
59601	2086	4320413300069	27782	13726	6	0	\N
59603	2086	5039100000000	19074	9619	2	0	\N
59604	2086	5039100000000	19681	9913	10	0	\N
59605	2086	5039100000000	19799	9971	8	0	\N
59606	2086	5039111000000	19074	9619	3	0	\N
59607	2086	5039173000000	19681	9913	11	0	\N
59608	2086	5039240000000	19633	9880	69	0	\N
59609	2086	5039357000000	19633	9880	70	0	\N
59610	2086	5039513000000	19799	9971	9	0	\N
59611	2086	5040415300069	28177	13929	2	0	\N
59612	2086	5040415300069	28551	14104	2	0	\N
59613	2086	5040415300069	28707	14173	1	0	\N
59614	2086	5040415300069	29051	14326	3	0	\N
59615	2086	5040415300069	29163	14380	2	0	\N
59617	2086	5040416300069	28707	14173	2	0	\N
59618	2086	5040417300069	29163	14380	3	0	\N
59619	2086	5040426300069	28177	13929	3	0	\N
59620	2086	5040426300069	28551	14104	3	0	\N
59622	2086	5040427300069	29051	14326	4	0	\N
59623	2086	5760426300069	29530	14563	4	0	\N
59625	2086	5760439300069	29530	14563	5	0	\N
59627	2086	6480455300069	29866	14721	10	0	\N
59628	2086	6480455300069	29893	14731	10	0	\N
59629	2086	6480455300069	29934	14745	10	0	\N
59630	2086	6480474300069	29893	14731	11	0	\N
59631	2086	6480483300069	29866	14721	11	0	\N
59632	2086	6480483300069	29934	14745	11	0	\N
59633	2087	719000000000	13265	6833	7	0	\N
59636	2087	719025000000	13265	6833	8	0	\N
59639	2087	1439024000000	13335	6872	10	0	\N
59640	2087	1439024000000	13542	6970	3	0	\N
59641	2087	1439024000000	13583	6986	4	0	\N
59642	2087	1439024000000	14769	7521	2	0	\N
59643	2087	1439024000000	14830	7559	4	0	\N
59644	2087	1439024000000	14876	7577	2	0	\N
59645	2087	1439024000000	15020	7653	3	0	\N
59646	2087	1439024000000	15038	7662	1	0	\N
59647	2087	1439024000000	15064	7671	4	0	\N
59648	2087	1439024000000	15124	7708	1	0	\N
59650	2087	1439034000000	15038	7662	2	0	\N
59651	2087	1439034000000	15124	7708	2	0	\N
59652	2087	1439035000000	14769	7521	3	0	\N
59653	2087	1439035000000	14876	7577	3	0	\N
59654	2087	1439036000000	13542	6970	4	0	\N
59655	2087	1439036000000	15020	7653	4	0	\N
59656	2087	1439037000000	13583	6986	5	0	\N
59657	2087	1439046000000	14830	7559	5	0	\N
59659	2087	1439055000000	15064	7671	5	0	\N
59660	2087	1439061000000	13335	6872	11	0	\N
59662	2087	1440204000000	21688	10863	7	0	\N
59664	2087	1440248000000	21688	10863	8	0	\N
59667	2087	2159047000000	15475	7879	2	0	\N
59668	2087	2159047000000	15508	7892	2	0	\N
59669	2087	2159047000000	15575	7928	1	0	\N
59671	2087	2159057000000	15575	7928	2	0	\N
59672	2087	2159058000000	15475	7879	3	0	\N
59673	2087	2159058000000	15508	7892	3	0	\N
59675	2087	2160236000000	21696	10867	6	0	\N
59676	2087	2160236000000	21975	10988	6	0	\N
59679	2087	2160260000000	21696	10867	7	0	\N
59680	2087	2160260000000	21975	10988	7	0	\N
59681	2087	2595387147766	23267	11609	2	0	\N
59682	2087	2595387147766	23585	11752	4	0	\N
59683	2087	2595387147766	23794	11845	3	0	\N
59684	2087	2595387147766	24122	12006	2	0	\N
59685	2087	2595387147766	24624	12236	2	0	\N
59686	2087	2595387147766	24831	12328	2	0	\N
59688	2087	2595398147766	23267	11609	3	0	\N
59689	2087	2595398147766	24122	12006	3	0	\N
59690	2087	2595398147766	24624	12236	3	0	\N
59691	2087	2595398147766	24831	12328	3	0	\N
59693	2087	2595399147766	23794	11845	4	0	\N
59694	2087	2595400147766	23585	11752	5	0	\N
59698	2087	2880249000000	22457	11237	4	0	\N
59699	2087	2880262000000	22457	11237	5	0	\N
59700	2087	3315398147766	24985	12398	3	0	\N
59701	2087	3315398147766	25164	12484	3	0	\N
59702	2087	3315398147766	25284	12542	6	0	\N
59703	2087	3315398147766	25513	12633	3	0	\N
59704	2087	3315398147766	25921	12809	2	0	\N
59649	2087	1439024000000	15220	7754	5	0	0
59658	2087	1439047000000	15220	7754	6	0	0
59670	2087	2159047000000	15956	8112	3	0	0
59674	2087	2159059000000	15956	8112	4	0	0
59696	2087	2879059000000	15990	8128	3	0	0
59571	2086	3599089000000	18891	9530	2	0	1
59572	2086	3599100000000	18891	9530	3	0	1
59597	2086	4319100000000	19004	9582	0	0	1
59569	2086	3055310300069	20517	10328	23	0	2
59570	2086	3055321300069	20517	10328	24	0	2
59638	2087	720204000000	21563	10812	3	0	2
59661	2087	1440204000000	21685	10863	4	0	2
59663	2087	1440236000000	21685	10863	5	0	2
59677	2087	2160236000000	22259	11139	4	0	2
59586	2086	3775321300069	22455	11237	4	0	2
59590	2086	3775334300069	22455	11237	5	0	2
59665	2087	1875375147766	22901	11447	3	0	3
59666	2087	1875387147766	22901	11447	4	0	3
59687	2087	2595387147766	24981	12397	2	0	3
59695	2087	2595418147766	26669	13190	2	0	3
59574	2086	3600379300069	26971	13339	3	0	3
59575	2086	3600391300069	26971	13339	4	0	3
59599	2086	4320391300069	28087	13885	6	0	3
59602	2086	4320415300069	28087	13885	7	0	3
59621	2086	5040426300069	29326	14452	3	0	3
59624	2086	5760426300069	29824	14696	11	0	3
59626	2086	5760455300069	29824	14696	12	0	3
59705	2087	3315398147766	26184	12944	3	0	\N
59706	2087	3315398147766	26385	13049	4	0	\N
59707	2087	3315409147766	25921	12809	3	0	\N
59708	2087	3315410147766	24985	12398	4	0	\N
59709	2087	3315410147766	25164	12484	4	0	\N
59710	2087	3315410147766	25513	12633	4	0	\N
59711	2087	3315410147766	26184	12944	4	0	\N
59712	2087	3315411147766	26385	13049	5	0	\N
59714	2087	3315422147766	25284	12542	7	0	\N
59716	2087	3315444147766	27781	13726	3	0	\N
59717	2087	3599070000000	16655	8461	7	0	\N
59718	2087	3599070000000	16747	8502	10	0	\N
59719	2087	3599070000000	16853	8551	3	0	\N
59720	2087	3599070000000	16982	8603	2	0	\N
59722	2087	3599081000000	16982	8603	3	0	\N
59724	2087	3599082000000	16853	8551	4	0	\N
59725	2087	3599095000000	16655	8461	8	0	\N
59726	2087	3599107000000	16747	8502	11	0	\N
59728	2087	4035423147766	26855	13283	3	0	\N
59729	2087	4035423147766	26973	13339	3	0	\N
59730	2087	4035423147766	28086	13885	6	0	\N
59731	2087	4035423147766	28178	13929	2	0	\N
59732	2087	4035423147766	28552	14104	2	0	\N
59733	2087	4035423147766	28712	14173	1	0	\N
59734	2087	4035423147766	29052	14326	3	0	\N
59736	2087	4035424147766	28712	14173	2	0	\N
59738	2087	4035434147766	28178	13929	3	0	\N
59739	2087	4035434147766	28552	14104	3	0	\N
59740	2087	4035435147766	26855	13283	4	0	\N
59741	2087	4035435147766	26973	13339	4	0	\N
59742	2087	4035435147766	29052	14326	4	0	\N
59743	2087	4035444147766	27781	13726	5	0	\N
59744	2087	4035445147766	27781	13726	6	0	\N
59745	2087	4035447047766	28086	13885	7	1	\N
59746	2087	4035520147766	29938	14742	32	0	\N
59747	2087	4319081000000	17715	8953	4	0	\N
59748	2087	4319103000000	17715	8953	5	0	\N
59750	2087	4755425147766	29328	14452	2	0	\N
59751	2087	4755425147766	29534	14563	4	0	\N
59752	2087	4755425147766	29826	14696	6	0	\N
59753	2087	4755425147766	29869	14721	10	0	\N
59754	2087	4755425147766	29897	14731	10	0	\N
59755	2087	4755436147766	29328	14452	3	0	\N
59756	2087	4755438147766	29534	14563	5	0	\N
59757	2087	4755444147766	29897	14731	11	0	\N
59758	2087	4755449147766	29826	14696	7	0	\N
59759	2087	4755453147766	29869	14721	11	0	\N
59760	2087	4755520147766	29938	14742	55	0	\N
59761	2087	4755541823202	29938	14742	60	0	\N
59762	2087	5039107000000	18895	9530	2	0	\N
59763	2087	5039107000000	19003	9582	0	0	\N
59764	2087	5039107000000	19072	9619	2	0	\N
59766	2087	5039118000000	18895	9530	3	0	\N
59767	2087	5039118000000	19072	9619	3	0	\N
59771	2087	6479194000000	19801	9971	8	0	\N
59772	2087	6479607000000	19801	9971	9	0	\N
59776	2095	2913298999985	16707	8428	126	1	\N
59777	2095	16598504490009	17063	8411	26	0	\N
59778	2096	20883349809412	25575	12660	11	0	\N
59779	2097	300000	21532	10801	4	1	\N
59781	2097	200000008	18192	9170	8	0	\N
59785	2097	200000023	15601	7942	2	0	\N
59786	2097	200000023	18196	9170	7	0	\N
59788	2097	200044014	20836	10417	40	0	\N
59790	2097	1600500000	19364	9763	5	1	\N
59791	2097	2159068999923	18185	9170	6	1	\N
59792	2097	15877227465639	20763	10416	39	1	\N
59793	2097	28800876999999	17100	8664	3	1	\N
59794	2097	57900410956533704	15601	7942	3	1	\N
59798	2100	2157880000000	20313	10230	2	0	\N
59799	2100	2157891000000	20313	10230	3	0	\N
59800	2102	300000000	18177	8915	0	0	\N
59801	2106	719000000000	14190	7242	4	0	\N
59802	2106	719000000000	14515	7403	6	0	\N
59803	2106	719000000000	14707	7488	2	0	\N
59805	2106	719011000000	14707	7488	3	0	\N
59807	2106	719013000000	14190	7242	5	0	\N
59808	2106	719024000000	14515	7403	7	0	\N
59809	2106	720088000000	23679	11791	0	0	\N
59810	2106	720088000000	23742	11824	2	0	\N
59812	2106	720099000000	23742	11824	3	0	\N
59814	2106	1439011000000	14981	7632	2	0	\N
59816	2106	1439022000000	14981	7632	3	0	\N
59818	2106	1440113000000	24051	11969	4	0	\N
59819	2106	1440113000000	24240	12063	3	0	\N
59821	2106	1440125000000	24240	12063	4	0	\N
59823	2106	1440135000000	24051	11969	5	0	\N
59824	2106	2159034000000	15332	7814	3	0	\N
59789	2097	200104017	23858	11876	0	0	0
59825	2106	2159034000000	15357	7825	3	0	\N
59826	2106	2159034000000	15429	7858	2	0	\N
59827	2106	2159034000000	15621	7952	4	0	\N
59828	2106	2159034000000	15634	7958	4	0	\N
59829	2106	2159034000000	16316	8291	5	0	\N
59831	2106	2159045000000	15429	7858	3	0	\N
59832	2106	2159046000000	15332	7814	4	0	\N
59833	2106	2159046000000	15357	7825	4	0	\N
59835	2106	2159047000000	15621	7952	5	0	\N
59836	2106	2159047000000	15634	7958	5	0	\N
59837	2106	2159147000000	16316	8291	6	0	\N
59838	2106	2160126000000	24647	12244	4	0	\N
59839	2106	2160126000000	25379	12582	3	0	\N
59804	2106	719000000000	14751	7510	2	0	0
59806	2106	719011000000	14751	7510	3	0	0
59815	2106	1439011000000	15035	7661	5	0	0
59817	2106	1439034000000	15035	7661	6	0	0
59784	2097	200000022	15551	7916	10	1	0
59834	2106	2159046000000	16536	8409	4	0	0
59773	2095	200170000	17188	8710	12	0	0
59721	2087	3599070000000	17710	8951	2	0	1
59723	2087	3599081000000	17710	8951	3	0	1
59727	2087	3599107000000	18483	9308	8	0	1
59774	2095	200180000	18484	9309	11	1	0
59797	2100	1437880000000	19302	9733	0	0	2
59765	2087	5039107000000	19632	9889	7	0	1
59768	2087	5039132000000	19632	9889	8	0	1
59770	2087	5759194000000	19684	9913	9	0	1
59787	2097	200004018	19863	10005	7	1	0
59775	2095	200190000	19979	10060	10	1	0
59795	2100	722930000000	23343	11648	5	0	4
59796	2100	722962000000	23343	11648	6	0	4
59813	2106	720113000000	23912	11899	8	0	2
59820	2106	1440113000000	24259	12071	4	0	2
59822	2106	1440126000000	24259	12071	5	0	2
59840	2106	2160126000000	25493	12625	6	0	2
59713	2087	3315418147766	26669	13190	8	0	3
59735	2087	4035423147766	29164	14380	2	0	3
59737	2087	4035425147766	29164	14380	3	0	3
59841	2106	2160138000000	25379	12582	4	0	\N
59842	2106	2160139000000	24647	12244	5	0	\N
59844	2106	2160160000000	25745	12735	1	0	\N
59845	2106	2879046000000	16832	8542	3	0	\N
59846	2106	2879046000000	17161	8697	7	0	\N
59847	2106	2879046000000	17196	8714	3	0	\N
59848	2106	2879046000000	17224	8725	3	0	\N
59850	2106	2879058000000	16832	8542	4	0	\N
59851	2106	2879058000000	17196	8714	4	0	\N
59852	2106	2879058000000	17224	8725	4	0	\N
59854	2106	2879170000000	17161	8697	8	0	\N
59855	2106	2880150000000	25675	12706	3	0	\N
59856	2106	2880150000000	26472	13093	3	0	\N
59857	2106	2880150000000	26635	13178	4	0	\N
59859	2106	2880160000000	25745	12735	4	0	\N
59860	2106	2880162000000	25675	12706	4	0	\N
59861	2106	2880162000000	25745	12735	5	0	\N
59862	2106	2880162000000	26472	13093	4	0	\N
59864	2106	2880163000000	26635	13178	5	0	\N
59865	2106	3599059000000	17519	8870	3	0	\N
59866	2106	3599059000000	17731	8961	4	0	\N
59868	2106	3599071000000	17519	8870	4	0	\N
59870	2106	3599072000000	17731	8961	5	0	\N
59873	2106	4319071000000	18145	9150	2	0	\N
59874	2106	4319071000000	18214	9176	4	0	\N
59875	2106	4319071000000	18361	9253	2	0	\N
59876	2106	4319071000000	18412	9283	3	0	\N
59877	2106	4319071000000	18962	9564	3	0	\N
59878	2106	4319071000000	19701	9920	3	0	\N
59879	2106	4319071000000	20039	10088	0	0	\N
59880	2106	4319071000000	20288	10216	7	0	\N
59882	2106	4319082000000	18145	9150	3	0	\N
59883	2106	4319082000000	18361	9253	3	0	\N
59884	2106	4319083000000	18412	9283	4	0	\N
59885	2106	4319083000000	18962	9564	4	0	\N
59886	2106	4319083000000	19701	9920	4	0	\N
59888	2106	4319084000000	18214	9176	5	0	\N
59889	2106	4319096000000	20288	10216	8	0	\N
59890	2106	4320186000000	27370	13533	3	0	\N
59891	2106	4320186000000	27408	13553	3	0	\N
59892	2106	4320186000000	27414	13555	3	0	\N
59893	2106	4320186000000	27422	13557	9	0	\N
59894	2106	4320186000000	27450	13566	6	0	\N
59896	2106	4320198000000	27370	13533	4	0	\N
59897	2106	4320198000000	27408	13553	4	0	\N
59898	2106	4320198000000	27414	13555	4	0	\N
59900	2106	4320210000000	27450	13566	7	0	\N
59901	2106	4320222000000	27422	13557	10	0	\N
59902	2106	5039083000000	20727	10420	10	0	\N
59903	2106	5039083000000	20902	10506	2	0	\N
59904	2106	5039083000000	20927	10521	2	0	\N
59905	2106	5039083000000	21069	10585	3	0	\N
59906	2106	5039083000000	21105	10600	3	0	\N
59907	2106	5039083000000	21842	10931	3	0	\N
59908	2106	5039083000000	21936	10975	3	0	\N
59909	2106	5039083000000	22017	11009	4	0	\N
59910	2106	5039083000000	22400	11214	6	0	\N
59912	2106	5039094000000	20902	10506	3	0	\N
59913	2106	5039094000000	20927	10521	3	0	\N
59914	2106	5039095000000	21069	10585	4	0	\N
59915	2106	5039095000000	21105	10600	4	0	\N
59916	2106	5039095000000	21842	10931	4	0	\N
59917	2106	5039095000000	21936	10975	4	0	\N
59918	2106	5039096000000	22017	11009	5	0	\N
59919	2106	5039107000000	22400	11214	7	0	\N
59921	2106	5039120000000	20727	10420	11	0	\N
59924	2106	5759107000000	22862	11429	4	0	\N
59927	2106	5759120000000	22862	11429	5	0	\N
59930	2106	6480225000000	28961	14283	3	0	\N
59931	2106	6480225000000	29047	14325	6	0	\N
59933	2106	6480237000000	28961	14283	4	0	\N
59935	2106	6480249000000	29047	14325	7	0	\N
59940	2106	8640262000000	30076	14808	5	0	\N
59941	2106	8640285000000	30076	14808	6	0	\N
59942	2110	0	14387	7165	0	0	\N
59944	2111	4200000000	27887	13789	3	0	\N
59945	2111	4200000000	27916	13808	3	0	\N
59946	2112	719000000000	14493	7395	4	0	\N
59947	2112	719000000000	14983	7634	1	0	\N
59949	2112	719010000000	14983	7634	2	0	\N
59951	2112	719013000000	14493	7395	5	0	\N
59954	2112	1439012000000	15179	7734	3	0	\N
59955	2112	1439012000000	15368	7829	5	0	\N
59956	2112	1439012000000	15897	8083	3	0	\N
59958	2112	1439024000000	15179	7734	4	0	\N
59959	2112	1439024000000	15897	8083	4	0	\N
59961	2112	1439035000000	15368	7829	6	0	\N
59963	2112	1440011000000	20796	10452	6	0	\N
59964	2112	1440053000000	20796	10452	7	0	\N
59973	2112	2880066000000	21026	10569	6	0	\N
59974	2112	2880066000000	21027	10569	6	0	\N
59976	2112	2880099000000	21026	10569	7	0	\N
59957	2112	1439012000000	16229	8249	3	0	0
59960	2112	1439024000000	16229	8249	4	0	0
59966	2112	2159024000000	16762	8508	3	0	0
59967	2112	2159036000000	16762	8508	4	0	0
59970	2112	2879036000000	17222	8725	3	0	0
59849	2106	2879046000000	17367	8796	4	0	0
59853	2106	2879059000000	17367	8796	5	0	0
59867	2106	3599059000000	17997	9079	3	0	0
59869	2106	3599071000000	17997	9079	4	0	0
59952	2112	720000000000	20541	10340	2	0	6
59881	2106	4319071000000	20661	10394	3	0	0
59887	2106	4319083000000	20661	10394	4	0	0
59962	2112	1440011000000	20795	10452	7	0	6
59965	2112	1440054000000	20795	10452	8	0	6
59969	2112	2160066000000	20860	10485	4	0	6
59972	2112	2880066000000	21023	10569	6	0	6
59975	2112	2880099000000	21023	10569	7	0	6
59911	2106	5039083000000	22713	11354	6	0	0
59920	2106	5039107000000	22713	11354	7	0	0
59926	2106	5759118000000	23516	11721	3	0	0
59843	2106	2160150000000	25493	12625	7	0	2
59858	2106	2880150000000	26909	13308	3	0	2
59863	2106	2880162000000	26909	13308	4	0	2
59871	2106	3600162000000	26932	13321	6	0	2
59895	2106	4320186000000	27592	13637	6	0	2
59899	2106	4320201000000	27592	13637	7	0	2
59922	2106	5040201000000	28088	13886	4	0	2
59923	2106	5040214000000	28088	13886	5	0	2
59929	2106	5760225000000	28458	14063	3	0	2
59932	2106	6480225000000	29110	14351	4	0	2
59934	2106	6480238000000	29110	14351	5	0	2
59936	2106	7200238000000	29356	14468	4	0	2
59937	2106	7200251000000	29356	14468	5	0	2
59939	2106	7920262000000	29578	14584	3	0	2
59977	2112	2880099000000	21027	10569	7	0	\N
59979	2112	3599048000000	17312	8770	3	0	\N
59981	2112	3599060000000	17312	8770	4	0	\N
59983	2112	3600099000000	21355	10718	4	0	\N
59985	2112	3600112000000	21355	10718	5	0	\N
59989	2112	4320112000000	21548	10804	2	0	\N
59990	2112	4320123000000	21548	10804	3	0	\N
59992	2112	5039061000000	17999	9081	5	0	\N
59995	2112	5039084000000	17999	9081	6	0	\N
59996	2112	5040124000000	21587	10823	3	0	\N
59998	2112	5040136000000	21587	10823	4	0	\N
60000	2112	5040608000000	21753	10870	100	0	\N
60001	2112	5759073000000	18889	9529	2	0	\N
60003	2112	5759093000000	18889	9529	3	0	\N
60007	2112	5760608000000	21753	10870	101	0	\N
60008	2112	6479094000000	19184	9679	3	0	\N
60011	2112	6479106000000	19184	9679	4	0	\N
60014	2112	6480608000000	21759	10871	9	0	\N
60015	2112	6480644000000	21759	10871	10	0	\N
60017	2112	7199105000000	19202	9687	5	0	\N
60018	2112	7199128000000	19202	9687	6	0	\N
60022	2112	7919130000000	20070	10102	4	0	\N
60023	2112	7919143000000	20070	10102	5	0	\N
60024	2112	7920184000000	22201	11112	6	0	\N
60027	2112	7920208000000	22201	11112	7	0	\N
60028	2112	7920546000000	22309	11146	71	0	\N
60031	2112	8640546000000	22309	11146	104	0	\N
60032	2112	8640578000000	22309	11146	105	0	\N
60033	2112	8641472000000	22437	11147	93	0	\N
60036	2112	9361472000000	22437	11147	126	0	\N
60037	2112	9361504000000	22437	11147	127	0	\N
60038	2112	10080220000000	22555	11285	4	0	\N
60041	2112	10080233000000	22555	11285	5	0	\N
60042	2112	13486623101924	22942	11464	8	0	\N
60045	2112	13486649101924	22942	11464	9	0	\N
60047	2112	14206629101924	22965	11472	2	0	\N
60048	2112	14206631101924	22965	11472	3	0	\N
60050	2112	14926641101924	22984	11481	3	0	\N
60051	2112	14926641101924	22985	11480	10	0	\N
60054	2112	14926653101924	22984	11481	4	0	\N
60055	2112	14926687101924	22985	11480	11	0	\N
60056	2112	14926793101924	23523	11653	15	0	\N
60059	2112	15646793101924	23523	11653	62	0	\N
60060	2112	15647253101924	23523	11653	63	0	\N
60062	2112	16366680101924	23715	11811	3	0	\N
60064	2112	16366692101924	23715	11811	4	0	\N
60065	2112	17086691101924	23900	11896	3	0	\N
60066	2112	17086691101924	23949	11916	6	0	\N
60067	2112	17086691101924	24001	11944	1	0	\N
60069	2112	17086692101924	24001	11944	2	0	\N
60070	2112	17086703101924	23900	11896	4	0	\N
60072	2112	17086715101924	23949	11916	7	0	\N
60079	2112	19966894101924	24651	12245	4	0	\N
60080	2112	19966894101924	24992	12401	2	0	\N
60082	2112	19966905101924	24992	12401	3	0	\N
60084	2112	19967006101924	24651	12245	5	0	\N
60085	2112	20686906101924	25099	12457	3	0	\N
60086	2112	20686906101924	25102	12457	2	0	\N
60087	2112	20686906101924	25320	12559	4	0	\N
60088	2112	20686906101924	25321	12559	2	0	\N
60089	2112	20686906101924	25322	12559	2	0	\N
60091	2112	20686908101924	25102	12457	3	0	\N
60092	2112	20686917101924	25321	12559	3	0	\N
60093	2112	20686917101924	25322	12559	3	0	\N
60094	2112	20686918101924	25099	12457	4	0	\N
60095	2112	20686919101924	25320	12559	5	0	\N
60097	2112	21406920101924	25593	12668	2	0	\N
60099	2112	21406931101924	25593	12668	3	0	\N
60103	2112	22126955101924	26305	13013	3	0	\N
60104	2112	22846943101924	25992	12846	2	0	\N
60105	2112	22846943101924	26097	12898	2	0	\N
60108	2112	22846954101924	25992	12846	3	0	\N
60109	2112	22846954101924	26097	12898	3	0	\N
60110	2112	22846955101924	26305	13013	4	0	\N
60111	2112	23566944101924	26593	13158	4	0	\N
59986	2112	4319049000000	17623	8912	3	0	0
59987	2112	4319061000000	17623	8912	4	0	0
59993	2112	5039061000000	18016	9088	3	0	0
59994	2112	5039073000000	18016	9088	4	0	0
60002	2112	5759073000000	19029	9595	3	0	0
60009	2112	6479094000000	19185	9679	2	0	0
60010	2112	6479105000000	19185	9679	3	0	0
60016	2112	7199105000000	19201	9687	7	0	0
60019	2112	7199130000000	19201	9687	8	0	0
59982	2112	3600099000000	21354	10718	4	0	6
59988	2112	4320112000000	21545	10804	3	0	6
59991	2112	4320124000000	21545	10804	4	0	6
59997	2112	5040124000000	21669	10855	6	0	6
59999	2112	5040148000000	21669	10855	7	0	6
60006	2112	5760160000000	21751	10892	4	0	6
60012	2112	6480160000000	21758	10895	3	0	6
60013	2112	6480172000000	21758	10895	4	0	6
60020	2112	7200172000000	22093	11046	3	0	6
60021	2112	7200184000000	22093	11046	4	0	6
60026	2112	7920196000000	22206	11116	4	0	6
60029	2112	8640196000000	22306	11166	3	0	6
60030	2112	8640208000000	22306	11166	4	0	6
60034	2112	9360208000000	22436	11229	3	0	6
60035	2112	9360220000000	22436	11229	4	0	6
60040	2112	10080232000000	22569	11291	4	0	6
60043	2112	13486623101924	22943	11464	6	0	7
60044	2112	13486629101924	22943	11464	7	0	7
60046	2112	14206629101924	22963	11472	3	0	7
60052	2112	14926641101924	22986	11481	2	0	7
60053	2112	14926643101924	22986	11481	3	0	7
60057	2112	15646643101924	23521	11724	10	0	7
60058	2112	15646680101924	23521	11724	11	0	7
60061	2112	16366680101924	23713	11811	2	0	7
60068	2112	17086691101924	24002	11944	3	0	7
60071	2112	17086703101924	24002	11944	4	0	7
60073	2112	17806703101924	24118	12005	10	0	7
60074	2112	17806749101924	24118	12005	11	0	7
60075	2112	18526749101924	24237	12061	2	0	7
60077	2112	19246760101924	24369	12120	8	0	7
60078	2112	19246894101924	24369	12120	9	0	7
60081	2112	19966894101924	24993	12401	3	0	7
60083	2112	19966906101924	24993	12401	4	0	7
60096	2112	20686920101924	25447	12606	6	0	7
60098	2112	21406920101924	25594	12668	3	0	7
60100	2112	21406932101924	25594	12668	4	0	7
60101	2112	22126932101924	25953	12825	2	0	7
60102	2112	22126943101924	25953	12825	3	0	7
60107	2112	22846944101924	26306	13013	2	0	7
60112	2112	23566944101924	26595	13158	6	0	7
60113	2112	23566966101924	26593	13158	5	0	\N
60115	2112	23567515101924	26861	13250	79	0	\N
60116	2112	24286968101924	26727	13221	7	0	\N
60117	2112	24286968101924	26783	13245	3	0	\N
60119	2112	24286980101924	26783	13245	4	0	\N
60121	2112	24286993101924	26727	13221	8	0	\N
60122	2112	24287515101924	26861	13250	126	0	\N
60123	2112	24287561101924	26861	13250	127	0	\N
60124	2112	25006980101924	26944	13328	3	0	\N
60126	2112	25006992101924	26944	13328	4	0	\N
60134	2112	27887044101924	28117	13899	3	0	\N
60135	2112	27887044101924	28179	13929	2	0	\N
60137	2112	27887055101924	28179	13929	3	0	\N
60138	2112	27887056101924	28117	13899	4	0	\N
60140	2112	28607056101924	28625	14135	4	0	\N
60141	2112	28607056101924	28670	14155	3	0	\N
60142	2112	28607056101924	28796	14206	3	0	\N
60144	2112	28607068101924	28670	14155	4	0	\N
60145	2112	28607068101924	28796	14206	4	0	\N
60146	2112	28607069101924	28625	14135	5	0	\N
60150	2112	30047081101924	28945	14274	3	0	\N
60151	2112	30047081101924	29005	14302	7	0	\N
60152	2112	30047081101924	29056	14328	6	0	\N
60154	2112	30047081101924	29154	14376	3	0	\N
60156	2112	30047093101924	28945	14274	4	0	\N
60157	2112	30047093101924	29154	14376	4	0	\N
60158	2112	30047105101924	29056	14328	7	0	\N
60159	2112	30047106101924	29005	14302	8	0	\N
60166	2112	31487142101924	30064	14801	6	0	\N
60167	2112	32207127101924	29743	14662	12	0	\N
60168	2112	32207127101924	29744	14662	18	0	\N
60170	2112	32207142101924	30064	14801	9	0	\N
60172	2112	32207144066403	30064	14801	10	1	\N
60173	2112	32207157101924	29743	14662	13	0	\N
60174	2112	32207163101924	29744	14662	19	0	\N
60178	2116	81460207999809	18192	9170	7	1	\N
60181	2126	250000007	20564	10267	0	0	\N
60182	2126	250025006	29771	14673	17	1	\N
60184	2126	250075006	29784	14678	16	1	\N
60186	2126	250550006	29798	14683	12	0	\N
60188	2126	250925006	29876	14690	124	0	\N
60192	2126	251175006	29848	14710	41	0	\N
60194	2126	251550006	29879	14725	14	0	\N
60196	2126	251725006	29930	14727	99	0	\N
60198	2126	251950006	29905	14734	12	1	\N
60200	2126	252075006	29933	14744	18	1	\N
60201	2126	252100006	29920	14733	81	1	\N
60202	2126	252125006	29938	14742	58	0	\N
60204	2126	252125006	29957	14754	14	0	\N
60205	2126	252125006	30001	14734	125	0	\N
60206	2126	252150006	29958	14755	7	1	\N
60209	2126	252250006	29986	14751	124	1	\N
60211	2126	252450006	29999	14771	23	0	\N
60216	2126	252625006	30035	14788	12	1	\N
60217	2126	252650006	30099	14773	126	0	\N
60218	2126	252675006	30051	14795	20	0	\N
60221	2126	252800006	30081	14811	12	1	\N
60222	2126	252800006	30082	14811	12	1	\N
60223	2126	252800006	30083	14811	13	0	\N
60224	2126	252825006	30084	14811	10	1	\N
60225	2126	253300006	30163	14842	43	0	\N
60226	2126	253300006	30164	14842	42	1	\N
60228	2126	253300006	30166	14842	43	0	\N
60229	2126	253800006	30167	14843	11	0	\N
60230	2126	253800006	30168	14843	10	1	\N
60232	2126	254050006	30188	14851	24	1	\N
60235	2126	254800006	30255	14876	21	0	\N
60236	2126	254800006	30256	14876	21	1	\N
60239	2128	200000001	19710	9924	3	0	\N
60240	2128	70323113999991	20185	9927	126	0	\N
60241	2135	719000000000	15718	7992	10	0	\N
60243	2135	719037000000	15718	7992	11	0	\N
60245	2135	719877000000	21189	10557	76	0	\N
60246	2135	1439037000000	15916	8093	5	0	\N
60247	2135	1439037000000	15917	8093	6	0	\N
60248	2135	1439060000000	15916	8093	6	0	\N
60244	2135	719037000000	15719	7992	11	0	0
60180	2126	250000006	20125	10132	9	1	0
60114	2112	23566968101924	26595	13158	7	0	7
60118	2112	24286968101924	26859	13285	3	0	7
60120	2112	24286980101924	26859	13285	4	0	7
60127	2112	25006992101924	26964	13336	4	0	7
60128	2112	25726992101924	27193	13449	6	0	7
60129	2112	25727016101924	27193	13449	7	0	7
60130	2112	26447016101924	27483	13583	6	0	7
60131	2112	26447031101924	27483	13583	7	0	7
60133	2112	27167044101924	27627	13654	5	0	7
60136	2112	27887044101924	28617	14131	3	0	7
60139	2112	27887056101924	28617	14131	4	0	7
60143	2112	28607056101924	28863	14235	4	0	7
60148	2112	29327069101924	28877	14244	3	0	7
60149	2112	29327081101924	28877	14244	4	0	7
60153	2112	30047081101924	29153	14376	2	0	7
60155	2112	30047092101924	29153	14376	3	0	7
60160	2112	30047113101924	29337	14457	3	0	7
60162	2112	30767116101924	29337	14457	8	0	7
60163	2112	31487116101924	29499	14546	2	0	7
60164	2112	31487127101924	29499	14546	3	0	7
60183	2126	250075006	29782	14678	16	0	0
60185	2126	250325006	29797	14682	63	0	0
60189	2126	250950006	29818	14692	14	0	0
60190	2126	251150006	29837	14703	12	0	0
60191	2126	251175006	29847	14710	46	0	0
60193	2126	251375006	29859	14717	14	1	0
60197	2126	251950006	29904	14734	12	0	0
60199	2126	252075006	29932	14744	18	0	0
60203	2126	252125006	29956	14754	14	0	0
60207	2126	252150006	29959	14755	9	0	0
60208	2126	252250006	29979	14763	23	1	0
60212	2126	252500006	30000	14772	12	0	0
60213	2126	252550006	30012	14779	12	0	0
60214	2126	252600006	30033	14787	22	1	0
60215	2126	252625006	30034	14788	13	0	0
60219	2126	252675006	30052	14795	20	1	0
60169	2112	32207142101924	30063	14801	9	0	7
60171	2112	32207144066403	30063	14801	10	1	7
60220	2126	252800006	30080	14811	13	0	0
60227	2126	253300006	30165	14842	43	0	0
60233	2126	254050006	30190	14851	24	1	0
60234	2126	254550006	30238	14866	27	0	0
60175	2112	32927144066403	30243	14869	7	0	7
60176	2112	32927160066403	30243	14869	8	0	7
60237	2126	254800006	30257	14876	21	0	0
60249	2135	1439061000000	15917	8093	7	0	\N
60250	2135	1439877000000	21189	10557	126	0	\N
60251	2135	1440367000000	21189	10557	127	0	\N
60252	2140	719000000000	16170	8220	4	0	\N
60253	2140	719013000000	16170	8220	5	0	\N
60256	2143	200400000	30001	14734	126	0	\N
60257	2143	200600000	30223	14735	53	1	\N
60258	2143	200900000	30223	14735	103	1	\N
60259	2143	5165227590000	16812	8533	13	1	\N
60260	2145	16597502435642	20836	10417	38	0	\N
60261	2145	66000007000000	18192	9170	6	0	\N
60262	2148	200000023	18185	9170	6	0	\N
60263	2148	719000000000	16299	8282	3	0	\N
60265	2148	719012000000	16299	8282	4	0	\N
60268	2148	720004880750	20409	10283	6	0	\N
60270	2148	720019880750	20409	10283	7	0	\N
60271	2148	1439022000000	16606	8436	3	0	\N
60272	2148	1439022000000	17150	8694	4	0	\N
60273	2148	1439022000000	17245	8735	3	0	\N
60275	2148	1439034000000	16606	8436	4	0	\N
60276	2148	1439034000000	17245	8735	4	0	\N
60277	2148	1439035000000	17150	8694	5	0	\N
60279	2148	1440018880750	20857	10482	4	0	\N
60280	2148	1440018880750	20994	10559	4	0	\N
60281	2148	1440018880750	20995	10559	4	0	\N
60282	2148	1440018880750	21071	10587	3	0	\N
60283	2148	1440018880750	21209	10649	2	0	\N
60285	2148	1440029880750	21209	10649	3	0	\N
60286	2148	1440030880750	21071	10587	4	0	\N
60287	2148	1440040880750	20994	10559	5	0	\N
60288	2148	1440040880750	20995	10559	5	0	\N
60290	2148	1440050880750	20857	10482	5	0	\N
60291	2148	2159046000000	17574	8894	3	0	\N
60292	2148	2159046000000	17583	8897	9	0	\N
60293	2148	2159046000000	17812	8996	2	0	\N
60294	2148	2159046000000	18185	9170	5	0	\N
60295	2148	2159046000000	18186	9170	5	0	\N
60296	2148	2159046000000	18188	9170	5	0	\N
60298	2148	2159048000000	17812	8996	3	0	\N
60299	2148	2159058000000	17574	8894	4	0	\N
60301	2148	2159069000000	18186	9170	6	0	\N
60302	2148	2159069000000	18188	9170	6	0	\N
60303	2148	2159082000000	17583	8897	10	0	\N
60304	2148	2160047880750	21652	10846	3	0	\N
60306	2148	2160059880750	21652	10846	4	0	\N
60308	2148	2879068000000	19062	9613	10	0	\N
60309	2148	2879163000000	19062	9613	11	0	\N
60310	2148	2880071880750	22163	11084	13	0	\N
60313	2148	2880120880750	22163	11084	14	0	\N
60316	2148	4320096880750	22805	11404	3	0	\N
60319	2148	4320108880750	22805	11404	4	0	\N
60322	2148	5760109880750	23790	11844	5	0	\N
60325	2148	5760132880750	23790	11844	6	0	\N
60326	2148	6480122880750	24592	12225	7	0	\N
60327	2148	6480122880750	24597	12227	2	0	\N
60328	2148	6480122880750	24599	12227	1	0	\N
60329	2148	6480122880750	24841	12334	3	0	\N
60330	2148	6480122880750	24844	12334	0	0	\N
60331	2148	6480122880750	25015	12412	2	0	\N
60333	2148	6480123880750	24599	12227	2	0	\N
60334	2148	6480133880750	24597	12227	3	0	\N
60335	2148	6480133880750	25015	12412	3	0	\N
60336	2148	6480134880750	24841	12334	4	0	\N
60337	2148	6480156880750	24592	12225	8	0	\N
60338	2148	7200122880750	25265	12533	17	0	\N
60339	2148	7200122880750	25334	12565	6	0	\N
60341	2148	7200184880750	25265	12533	18	0	\N
60342	2148	7200245880750	25334	12565	7	0	\N
60350	2148	10080320880750	26166	12934	3	0	\N
60351	2148	10080320880750	26281	12999	7	0	\N
60353	2148	10080332880750	26166	12934	4	0	\N
60355	2148	10080354880750	26281	12999	8	0	\N
60357	2148	10800332880750	27071	13383	6	0	\N
60359	2148	10800356880750	27071	13383	7	0	\N
60360	2148	11518356880750	27916	13808	3	0	\N
60361	2148	11518368880750	27916	13808	4	0	\N
60364	2148	12240368880750	28286	13984	2	0	\N
60365	2148	12240368880750	28342	14011	8	0	\N
60367	2148	12240379880750	28286	13984	3	0	\N
60369	2148	12240412880750	28342	14011	9	0	\N
60370	2148	12960379880750	28730	14177	4	0	\N
60372	2148	12960392880750	28730	14177	5	0	\N
60374	2148	12960412880750	29072	14334	2	0	\N
60375	2148	13680401880750	28958	14282	7	0	\N
60376	2148	13680401880750	29071	14334	1	0	\N
60378	2148	13680411880750	29071	14334	2	0	\N
60379	2148	13680412880750	29072	14334	4	0	\N
60380	2148	13680413880750	29072	14334	5	0	\N
60381	2148	13680426880750	28958	14282	8	0	\N
60383	2148	14400426880750	29580	14586	3	0	\N
60384	2148	14400426880750	30204	14857	12	0	\N
60264	2148	719000000000	16499	8393	4	0	0
60266	2148	719022000000	16499	8393	5	0	0
60274	2148	1439022000000	17249	8737	6	0	0
60278	2148	1439046000000	17249	8737	7	0	0
60297	2148	2159046000000	18581	9364	4	0	0
60267	2148	720004880750	20408	10283	5	0	2
60269	2148	720018880750	20408	10283	6	0	2
60284	2148	1440018880750	21583	10820	11	0	2
60289	2148	1440047880750	21583	10820	12	0	2
60305	2148	2160047880750	21818	10920	6	0	2
60311	2148	2880071880750	22165	11087	3	0	2
60312	2148	2880083880750	22165	11087	4	0	2
60314	2148	3600083880750	22525	11269	4	0	2
60315	2148	3600096880750	22525	11269	5	0	2
60318	2148	4320097880750	22806	11404	2	0	2
60320	2148	5040097880750	23586	11753	3	0	2
60321	2148	5040109880750	23586	11753	4	0	2
60323	2148	5760109880750	24228	12057	4	0	2
60324	2148	5760122880750	24228	12057	5	0	2
60340	2148	7200122880750	25336	12565	8	0	2
60343	2148	7200247880750	25336	12565	9	0	2
60344	2148	7920247880750	25600	12670	6	0	2
60345	2148	7920271880750	25600	12670	7	0	2
60346	2148	8640271880750	25628	12682	6	0	2
60348	2148	9360295880750	25821	12768	7	0	2
60349	2148	9360320880750	25821	12768	8	0	2
60352	2148	10080320880750	26935	13322	3	0	2
60354	2148	10080332880750	26935	13322	4	0	2
60358	2148	10800356880750	27070	13383	7	0	2
60362	2148	11520356880750	27917	13808	3	0	2
60363	2148	11520368880750	27917	13808	4	0	2
60366	2148	12240368880750	28416	14043	2	0	2
60368	2148	12240379880750	28416	14043	3	0	2
60373	2148	12960401880750	28735	14179	5	0	2
60377	2148	13680401880750	29451	14522	7	0	2
60382	2148	13680426880750	29451	14522	8	0	2
60386	2148	14400438880750	29580	14586	4	0	\N
60388	2148	14400471880750	30204	14857	13	0	\N
60389	2148	15120452880750	30258	14877	41	0	\N
60392	2148	15120631880750	30258	14877	42	0	\N
60394	2148	15840556880750	30263	14879	1	0	\N
60395	2148	15840606880750	30263	14879	2	0	\N
60397	2150	200100000	19419	9550	3	0	\N
60398	2171	1200000024	17866	8855	37	0	\N
60401	2179	66000000030000	20646	10357	126	0	\N
60402	2199	719000000000	18926	9548	1	0	\N
60404	2199	719010000000	18926	9548	2	0	\N
60408	2211	720920000000	29773	14674	31	0	\N
60409	2211	720968999992	29773	14674	32	0	\N
60410	2215	1870005914690	20399	10186	89	0	\N
60411	2215	3311150914689	20716	10188	66	0	\N
60412	2221	200000100	28166	13927	3	0	\N
60413	2221	200000100	28626	13884	15	0	\N
60415	2221	200030000	29784	14678	16	0	\N
60417	2221	200080000	29798	14683	11	1	\N
60420	2221	200100000	29876	14690	123	1	\N
60423	2221	200210000	29879	14725	13	1	\N
60425	2221	200220000	29920	14733	81	0	\N
60427	2221	200230000	29905	14734	11	1	\N
60429	2221	200250000	29933	14744	18	0	\N
60430	2221	200250000	29938	14742	57	1	\N
60431	2221	200260000	30001	14734	124	1	\N
60433	2221	200280000	29957	14754	13	1	\N
60434	2221	200290000	29958	14755	7	0	\N
60436	2221	200290000	30223	14735	52	1	\N
60439	2221	200310000	29999	14771	22	1	\N
60442	2221	200400000	30051	14795	19	1	\N
60445	2221	200410000	30064	14801	11	1	\N
60447	2221	200420000	30267	14812	115	1	\N
60448	2221	200460000	30207	14832	124	0	\N
60449	2221	200550000	30188	14851	24	0	\N
60451	2221	200750000	30210	14858	36	1	\N
60452	2221	200750000	30211	14858	35	1	\N
60453	2221	200750000	30213	14858	36	1	\N
60455	2221	200800000	20966	10546	3	0	\N
60457	2221	1441083999997	21392	10709	126	1	\N
60458	2221	18001289900000	19557	9835	39	1	\N
60459	2221	24482190798002	19364	9763	4	1	\N
60460	2223	200100000	23366	11487	1	0	\N
60461	2223	200900000	23366	11487	2	1	\N
60462	2229	9040300	21870	10799	125	0	\N
60465	2248	1439240000000	20200	10174	3	0	\N
60467	2248	1439252000000	20200	10174	4	0	\N
60469	2248	2159285000000	20294	10217	3	0	\N
60471	2248	2159297000000	20294	10217	4	0	\N
60473	2248	2879297000000	20452	10300	6	0	\N
60476	2248	2879321000000	20452	10300	7	0	\N
60477	2248	3599311000000	20655	10392	3	0	\N
60478	2248	3599311000000	20703	10412	3	0	\N
60479	2248	3599311000000	20830	10470	3	0	\N
60481	2248	3599323000000	20655	10392	4	0	\N
60482	2248	3599323000000	20703	10412	4	0	\N
60483	2248	3599323000000	20830	10470	4	0	\N
60493	2248	7199408000000	22356	11190	3	0	\N
60495	2248	7199420000000	22356	11190	4	0	\N
60497	2248	7919420000000	22782	11394	7	0	\N
60499	2248	7919420000000	22860	11428	4	0	\N
60500	2248	7919442000000	22860	11428	5	0	\N
60502	2248	7919454000000	22782	11394	8	0	\N
60503	2248	8639443000000	23192	11579	3	0	\N
60505	2248	8639455000000	23192	11579	4	0	\N
60507	2248	9359476000000	23417	11683	2	0	\N
60509	2248	9359487000000	23417	11683	3	0	\N
60511	2248	9359509000000	24020	11953	4	0	\N
60513	2248	10079509000000	24020	11953	5	0	\N
60515	2248	10799510000000	24450	12159	4	0	\N
60516	2248	10799510000000	24698	12266	5	0	\N
60517	2248	10799510000000	24704	12269	27	0	\N
60520	2248	10799532000000	24450	12159	5	0	\N
60406	2211	719000000000	19108	9638	6	0	0
60407	2211	719033000000	19108	9638	7	0	0
60463	2248	719000000000	20124	10131	6	0	0
60464	2248	719240000000	20124	10131	7	0	0
60466	2248	1439240000000	20244	10194	8	0	0
60470	2248	2159285000000	20380	10267	3	0	0
60472	2248	2159297000000	20380	10267	4	0	0
60474	2248	2879297000000	20627	10376	5	0	0
60475	2248	2879311000000	20627	10376	6	0	0
60480	2248	3599311000000	21015	10567	5	0	0
60485	2248	4319334000000	21192	10641	3	0	0
60486	2248	4319347000000	21192	10641	4	0	0
60487	2248	5039347000000	21284	10686	3	0	0
60488	2248	5039359000000	21284	10686	4	0	0
60405	2199	719238000000	21348	10714	13	0	0
60489	2248	5759359000000	21825	10924	6	0	0
60490	2248	5759383000000	21825	10924	7	0	0
60491	2248	6479383000000	22005	11004	7	0	0
60492	2248	6479408000000	22005	11004	8	0	0
60496	2248	7199420000000	22540	11277	4	0	0
60498	2248	7919420000000	22857	11428	5	0	0
60501	2248	7919443000000	22857	11428	6	0	0
60504	2248	8639443000000	23285	11618	6	0	0
60506	2248	8639476000000	23285	11618	7	0	0
60510	2248	9359487000000	23439	11691	3	0	0
60512	2248	10079487000000	24049	11968	5	0	0
60514	2248	10079510000000	24049	11968	6	0	0
60518	2248	10799510000000	25141	12473	3	0	0
60414	2221	200030000	29782	14678	15	1	0
60416	2221	200050000	29797	14682	62	1	0
60418	2221	200080000	29799	14683	10	1	0
60419	2221	200100000	29818	14692	13	1	0
60421	2221	200130000	29837	14703	11	0	0
60424	2221	200210000	29880	14725	14	0	0
60426	2221	200230000	29904	14734	11	1	0
60428	2221	200250000	29932	14744	17	1	0
60432	2221	200280000	29956	14754	13	1	0
60435	2221	200290000	29959	14755	8	1	0
60438	2221	200310000	29998	14771	22	1	0
60440	2221	200350000	30012	14779	11	1	0
60441	2221	200380000	30033	14787	21	1	0
60443	2221	200400000	30052	14795	20	0	0
60446	2221	200420000	30085	14812	10	1	0
60450	2221	200550000	30190	14851	24	0	0
60385	2148	14400426880750	30208	14857	2	0	2
60387	2148	14400452880750	30208	14857	3	0	2
60454	2221	200750000	30214	14858	36	1	0
60390	2148	15120452880750	30260	14877	2	0	2
60391	2148	15120556880750	30260	14877	3	0	2
60393	2148	15840556880750	30262	14879	20	0	2
60396	2148	15840643880750	30262	14879	21	0	2
60521	2248	10799542000000	24698	12266	6	0	\N
60522	2248	10799717000000	24704	12269	28	0	\N
60523	2248	11519522000000	25186	12495	11	0	\N
60524	2248	11519522000000	25389	12585	3	0	\N
60525	2248	11519522000000	26312	13015	6	0	\N
60526	2248	11519522000000	26522	13121	3	0	\N
60527	2248	11519522000000	26614	13168	8	0	\N
60528	2248	11519522000000	27008	13358	6	0	\N
60530	2248	11519534000000	25389	12585	4	0	\N
60531	2248	11519534000000	26522	13121	4	0	\N
60533	2248	11519539000000	26614	13168	9	0	\N
60534	2248	11519546000000	27008	13358	7	0	\N
60535	2248	11519555000000	26312	13015	7	0	\N
60536	2248	11519560000000	25186	12495	12	0	\N
60537	2248	12239534000000	27265	13478	3	0	\N
60538	2248	12239534000000	27383	13541	3	0	\N
60540	2248	12239546000000	27265	13478	4	0	\N
60541	2248	12239546000000	27383	13541	4	0	\N
60545	2248	12959620000000	27987	13844	9	0	\N
60548	2248	13679620000000	27987	13844	10	0	\N
60549	2248	14399595000000	28567	14112	9	0	\N
60550	2248	14399595000000	28704	14172	3	0	\N
60551	2248	14399595000000	29059	14330	9	0	\N
60552	2248	14399595000000	29462	14528	3	0	\N
60553	2248	14399595000000	29648	14621	6	0	\N
60554	2248	14399595000000	30226	14863	11	0	\N
60555	2248	14399595000000	30279	14889	8	0	\N
60556	2248	14399607000000	28704	14172	4	0	\N
60557	2248	14399607000000	29462	14528	4	0	\N
60558	2248	14399610000000	29648	14621	7	0	\N
60559	2248	14399612000000	30279	14889	9	0	\N
60560	2248	14399617000000	30226	14863	12	0	\N
60561	2248	14399631000000	28567	14112	10	0	\N
60562	2248	14399631000000	29059	14330	10	0	\N
60563	2250	1000000	27270	13432	41	0	\N
60564	2250	117200000	22933	11460	4	1	\N
60565	2250	200000004	23916	11755	99	1	\N
60570	2250	206000000	25939	12821	11	0	\N
60572	2250	12241117020000	27224	13463	4	0	\N
60573	2250	13917560420000	27225	13463	4	1	\N
60576	2252	200500000	26581	13153	8	0	\N
60577	2252	200500000	27138	13319	0	0	\N
60578	2252	200500000	27246	13382	2	0	\N
60581	2252	200900000	30176	14594	9	0	\N
60582	2252	201000000	30207	14832	126	0	\N
60583	2252	201100000	30163	14842	44	0	\N
60584	2252	201100000	30164	14842	43	1	\N
60586	2252	201100000	30166	14842	44	0	\N
60588	2252	201300000	30268	14882	23	0	\N
60590	2252	201400000	30176	14594	10	1	\N
60591	2252	201500000	26581	13153	9	0	\N
60592	2252	201500000	30185	14587	77	0	\N
60595	2252	203400000	28639	13934	86	1	\N
60596	2252	203700000	28665	13945	70	0	\N
60597	2252	12753770300000	26665	13190	9	0	\N
60598	2252	14140950719970	27270	13432	42	1	\N
60601	2256	720090000000	25430	12600	7	0	\N
60602	2256	720115000000	25430	12600	8	0	\N
60603	2257	7583746219586	21870	10799	124	1	\N
60607	2261	719000000000	20578	10354	3	0	\N
60608	2261	719000000000	20823	10467	1	0	\N
60610	2261	719001000000	20823	10467	2	0	\N
60611	2261	719012000000	20578	10354	4	0	\N
60617	2261	2879035000000	21295	10693	6	0	\N
60620	2261	2879059000000	21295	10693	7	0	\N
60623	2261	4319059000000	22313	11170	4	0	\N
60624	2261	4319059000000	23010	11494	8	0	\N
60626	2261	4319072000000	22313	11170	5	0	\N
60628	2261	4319085000000	23010	11494	9	0	\N
60635	2261	7199133000000	23623	11768	11	0	\N
60637	2261	7199133000000	23897	11894	1	0	\N
60638	2261	7199134000000	23897	11894	2	0	\N
60640	2261	7199172000000	23623	11768	12	0	\N
60641	2261	7919146000000	24150	12020	1	0	\N
60642	2261	7919146000000	24219	12054	4	0	\N
60643	2261	7919146000000	24221	12054	3	0	\N
60644	2261	7919146000000	24287	12080	3	0	\N
60645	2261	7919146000000	24394	12130	2	0	\N
60646	2261	7919146000000	24685	12262	10	0	\N
60647	2261	7919146000000	24903	12365	6	0	\N
60648	2261	7919146000000	25636	12688	3	0	\N
60649	2261	7919146000000	25983	12840	2	0	\N
60650	2261	7919146000000	26174	12940	14	0	\N
60652	2261	7919156000000	24150	12020	2	0	\N
60653	2261	7919157000000	24394	12130	3	0	\N
60654	2261	7919157000000	25983	12840	3	0	\N
60655	2261	7919158000000	24221	12054	4	0	\N
60656	2261	7919158000000	24287	12080	4	0	\N
60613	2261	1439012000000	20949	10536	2	0	0
60614	2261	1439023000000	20949	10536	3	0	0
60615	2261	2159023000000	21145	10618	3	0	0
60616	2261	2159035000000	21145	10618	4	0	0
60618	2261	2879035000000	21452	10762	3	0	0
60621	2261	3599047000000	21630	10837	3	0	0
60622	2261	3599059000000	21630	10837	4	0	0
60605	2260	280000020	22289	11157	9	0	0
60606	2260	280000040	22320	11173	13	0	0
60566	2250	201000000	22833	11419	4	1	0
60625	2261	4319059000000	23012	11494	7	0	0
60627	2261	4319084000000	23012	11494	8	0	0
60575	2252	200400000	23132	11553	8	0	0
60629	2261	5039084000000	23138	11554	9	0	0
60631	2261	5759111000000	23411	11680	2	0	0
60632	2261	5759122000000	23411	11680	3	0	0
60633	2261	6479122000000	23433	11690	2	0	0
60634	2261	6479133000000	23433	11690	3	0	0
60600	2253	200200000	23771	11837	5	1	0
60639	2261	7199146000000	23896	11894	5	0	0
60574	2252	200100000	23132	11553	7	0	0
60599	2253	200100000	23771	11837	4	0	0
60569	2250	205000000	27889	13789	3	0	0
60568	2250	204000000	25012	12410	5	0	0
60651	2261	7919146000000	26175	12940	14	0	0
60529	2248	11519522000000	27211	13458	3	0	0
60532	2248	11519534000000	27211	13458	4	0	0
60542	2248	12239546000000	27426	13559	4	0	0
60571	2250	207000000	27889	13789	4	0	0
60543	2248	12959546000000	27971	13835	11	0	0
60544	2248	12959584000000	27971	13835	12	0	0
60547	2248	13679595000000	28462	14065	3	0	0
60579	2252	200600000	28691	14165	4	0	0
60580	2252	200800000	29206	14395	8	1	0
60585	2252	201100000	30165	14842	44	0	0
60587	2252	201200000	30266	14881	37	1	0
60593	2252	201600000	30276	14887	36	1	0
60594	2252	201700000	30277	14888	15	0	0
60657	2261	7919158000000	25636	12688	4	0	\N
60658	2261	7919159000000	24219	12054	5	0	\N
60659	2261	7919170000000	24903	12365	7	0	\N
60660	2261	7919183000000	24685	12262	11	0	\N
60664	2261	9260664125026	26174	12940	16	0	\N
60669	2261	10799260000000	26691	13201	10	0	\N
60670	2261	10799260000000	26710	13211	3	0	\N
60672	2261	10799272000000	26710	13211	4	0	\N
60673	2261	10799297000000	26691	13201	11	0	\N
60675	2261	10799335000000	27246	13382	1	0	\N
60676	2261	11519334000000	27247	13473	3	0	\N
60677	2261	11519334000000	27356	13525	9	0	\N
60679	2261	11519334900000	27246	13382	2	0	\N
60680	2261	11519346000000	27247	13473	4	0	\N
60682	2261	11519370000000	27356	13525	10	0	\N
60690	2261	14399419000000	28107	13894	3	0	\N
60692	2261	14399419000000	29692	14646	3	0	\N
60693	2261	14399422000000	29692	14646	4	0	\N
60694	2261	14399431000000	28107	13894	4	0	\N
60696	2261	15119438000000	29747	14663	16	0	\N
60698	2261	15119438000000	29750	14663	5	0	\N
60699	2261	15119470000000	29750	14663	6	0	\N
60700	2261	15119481000000	29747	14663	17	0	\N
60702	2261	15839489000000	29798	14683	9	0	\N
60704	2261	15839489000000	29800	14667	102	0	\N
60706	2261	15839506641890	29798	14683	14	1	\N
60708	2261	15839824999991	29800	14667	103	1	\N
60711	2261	16559575381228	30188	14851	15	0	\N
60713	2261	17279542381228	30187	14851	8	0	\N
60714	2261	17279568381228	30187	14851	9	0	\N
60715	2261	17279575381228	30188	14851	21	0	\N
60717	2261	17279578985774	30188	14851	26	1	\N
60719	2261	17999578985774	30193	14853	24	0	\N
60720	2261	17999578985774	30194	14853	12	0	\N
60721	2261	17999578985774	30309	14897	2	0	\N
60722	2261	17999578985774	30311	14897	1	0	\N
60723	2261	17999588985774	30311	14897	2	0	\N
60724	2261	17999589985774	30309	14897	3	0	\N
60725	2261	17999869985774	30194	14853	13	0	\N
60726	2261	17999881985774	30193	14853	25	0	\N
60727	2266	200000010	23248	11601	3	0	\N
60729	2266	7492702967162	23654	11783	4	0	\N
60731	2275	200000030	23248	11601	3	1	\N
60732	2275	200400000	23366	11487	2	0	\N
60733	2275	201000000	23223	11485	0	0	\N
60735	2275	7434592804278	23017	11497	14	1	\N
60736	2275	27190554999966	21690	10865	13	1	\N
60737	2275	77525956999981	25120	12288	126	1	\N
60739	2292	719000000000	22074	11037	6	0	\N
60740	2292	719000000000	22136	11071	4	0	\N
60741	2292	719000000000	23374	11664	2	0	\N
60742	2292	719000000000	23476	11705	3	0	\N
60743	2292	719000000000	23867	11879	3	0	\N
60744	2292	719000000000	24088	11990	8	0	\N
60745	2292	719000000000	24331	12101	11	0	\N
60746	2292	719000000000	24351	12111	2	0	\N
60748	2292	719011000000	23374	11664	3	0	\N
60749	2292	719011000000	24351	12111	3	0	\N
60750	2292	719012000000	23476	11705	4	0	\N
60751	2292	719012000000	23867	11879	4	0	\N
60752	2292	719013000000	22136	11071	5	0	\N
60754	2292	719042000000	22074	11037	7	0	\N
60755	2292	719044000000	24088	11990	9	0	\N
60756	2292	719047000000	24331	12101	12	0	\N
60759	2292	1439058000000	25656	12697	2	0	\N
60760	2292	1439059000000	25310	12557	3	0	\N
60761	2292	2159038000000	25268	12535	7	0	\N
60762	2292	2159038000000	25277	12539	6	0	\N
60763	2292	2159038000000	25495	12626	3	0	\N
60764	2292	2159038000000	25603	12672	6	0	\N
60765	2292	2159038000000	25649	12693	3	0	\N
60766	2292	2159038000000	25761	12742	3	0	\N
60767	2292	2159038000000	25797	12757	2	0	\N
60769	2292	2159049000000	25797	12757	3	0	\N
60770	2292	2159050000000	25495	12626	4	0	\N
60771	2292	2159050000000	25649	12693	4	0	\N
60772	2292	2159050000000	25761	12742	4	0	\N
60774	2292	2159058000000	25656	12697	7	0	\N
60775	2292	2159059000000	25310	12557	6	0	\N
60777	2292	2159061000000	25310	12557	7	0	\N
60778	2292	2159062000000	25277	12539	7	0	\N
60779	2292	2159062000000	25603	12672	7	0	\N
60780	2292	2159062000000	25656	12697	8	0	\N
60781	2292	2159063000000	25268	12535	8	0	\N
60782	2292	2879050000000	25874	12789	6	0	\N
60783	2292	2879050000000	26077	12887	2	0	\N
60784	2292	2879050000000	26642	13179	9	0	\N
60785	2292	2879050000000	26794	13249	3	0	\N
60786	2292	2879050000000	26878	13293	3	0	\N
60787	2292	2879050000000	26992	13350	3	0	\N
60788	2292	2879050000000	27636	13659	0	0	\N
60789	2292	2879050000000	27742	13706	2	0	\N
60790	2292	2879050000000	27806	13740	6	0	\N
60791	2292	2879050000000	27850	13766	3	0	\N
60792	2292	2879050000000	27995	13846	3	0	\N
60747	2292	719000000000	24906	12367	4	0	0
60753	2292	719013000000	24906	12367	5	0	0
60757	2292	1439013000000	25133	12471	7	0	0
60758	2292	1439038000000	25133	12471	8	0	0
60768	2292	2159038000000	25856	12783	3	0	0
60661	2261	7919196000000	26175	12940	15	0	0
60662	2261	8639196000000	26501	13110	7	0	0
60663	2261	8639221000000	26501	13110	8	0	0
60665	2261	9359221000000	26660	13188	8	0	0
60666	2261	9359247000000	26660	13188	9	0	0
60668	2261	10079260000000	26673	13193	5	0	0
60671	2261	10799260000000	26770	13239	20	0	0
60674	2261	10799334000000	26770	13239	21	0	0
60678	2261	11519334000000	27655	13666	3	0	0
60683	2261	12239346000000	27681	13678	3	0	0
60684	2261	12239358000000	27681	13678	4	0	0
60685	2261	12959358000000	28067	13878	6	0	0
60686	2261	12959382000000	28067	13878	7	0	0
60687	2261	12959412000000	28083	13884	3	0	0
60734	2275	209800008	25570	12660	4	0	0
60689	2261	13679419000000	28083	13884	12	0	0
60776	2292	2159060000000	28766	14190	1	0	0
60691	2261	14399419000000	29691	14646	10	0	0
60695	2261	14399438000000	29691	14646	11	0	0
60697	2261	15119438000000	29748	14663	24	0	0
60703	2261	15839489000000	29799	14683	8	0	0
60705	2261	15839505641890	29799	14683	13	1	0
60707	2261	15839530641890	29998	14771	7	0	0
60709	2261	16559530641890	29998	14771	20	0	0
60712	2261	16559575381228	30190	14851	15	0	0
60716	2261	17279575381228	30190	14851	21	0	0
60718	2261	17279578985774	30190	14851	26	1	0
60793	2292	2879050000000	28057	13874	3	0	\N
60794	2292	2879050000000	28183	13932	3	0	\N
60795	2292	2879050000000	28333	14007	2	0	\N
60796	2292	2879050000000	28537	14100	2	0	\N
60798	2292	2879061000000	26077	12887	3	0	\N
60799	2292	2879061000000	27742	13706	3	0	\N
60800	2292	2879061000000	28333	14007	3	0	\N
60801	2292	2879061000000	28537	14100	3	0	\N
60802	2292	2879062000000	26794	13249	4	0	\N
60803	2292	2879062000000	26878	13293	4	0	\N
60804	2292	2879062000000	26992	13350	4	0	\N
60805	2292	2879062000000	27850	13766	4	0	\N
60806	2292	2879062000000	27995	13846	4	0	\N
60807	2292	2879062000000	28057	13874	4	0	\N
60808	2292	2879062000000	28183	13932	4	0	\N
60809	2292	2879074000000	25874	12789	7	0	\N
60810	2292	2879074000000	27806	13740	7	0	\N
60812	2292	2879086000000	26642	13179	10	0	\N
60813	2292	3599076000000	29065	14331	4	0	\N
60814	2292	3599076000000	29207	14395	6	0	\N
60815	2292	3599076000000	29237	14408	4	0	\N
60816	2292	3599076000000	29420	14504	4	0	\N
60817	2292	3599076000000	29586	14588	3	0	\N
60818	2292	3599076000000	30017	14782	30	0	\N
60819	2292	3599076000000	30170	14844	8	0	\N
60820	2292	3599076000000	30216	14859	10	0	\N
60821	2292	3599076000000	30299	14894	10	0	\N
60822	2292	3599088000000	29586	14588	4	0	\N
60823	2292	3599089000000	29065	14331	5	0	\N
60824	2292	3599089000000	29237	14408	5	0	\N
60825	2292	3599089000000	29420	14504	5	0	\N
60826	2292	3599091000000	29207	14395	7	0	\N
60827	2292	3599093000000	30170	14844	9	0	\N
60828	2292	3599102934869	30216	14859	13	0	\N
60829	2292	3599133000000	30017	14782	31	0	\N
60830	2292	3599212000000	30299	14894	11	0	\N
60831	2296	0	22484	11250	9	0	\N
60838	2301	1439000000000	27219	13461	9	0	\N
60841	2301	1439036000000	27219	13461	10	0	\N
60844	2303	1439000000000	24577	12217	3	0	\N
60845	2303	1439012000000	24577	12217	4	0	\N
60846	2306	719000000000	23005	11493	3	0	\N
60847	2306	719000000000	23078	11522	4	0	\N
60850	2306	719012000000	23005	11493	4	0	\N
60851	2306	719013000000	23078	11522	5	0	\N
60852	2306	719043000000	24585	12222	5	0	\N
60853	2306	1439011000000	23240	11597	2	0	\N
60854	2306	1439011000000	23458	11697	3	0	\N
60855	2306	1439011000000	24263	12072	3	0	\N
60856	2306	1439011000000	24327	12099	3	0	\N
60857	2306	1439011000000	24915	12369	3	0	\N
60859	2306	1439022000000	23240	11597	3	0	\N
60860	2306	1439023000000	23458	11697	4	0	\N
60861	2306	1439023000000	24263	12072	4	0	\N
60862	2306	1439023000000	24327	12099	4	0	\N
60863	2306	1439023000000	24915	12369	4	0	\N
60864	2306	1439043000000	24585	12222	8	0	\N
60865	2306	1439045000000	24585	12222	9	0	\N
60869	2306	2159162000000	26621	13169	21	0	\N
60870	2306	2879096000000	25609	12674	6	0	\N
60871	2306	2879096000000	26826	13265	4	0	\N
60874	2306	2879109000000	26826	13265	5	0	\N
60875	2306	2879120000000	25609	12674	7	0	\N
60876	2306	2879162000000	26621	13169	23	0	\N
60877	2306	2879163000000	26621	13169	24	0	\N
60878	2306	3599108000000	27038	13370	5	0	\N
60879	2306	3599108000000	27141	13421	3	0	\N
60881	2306	3599120000000	27141	13421	4	0	\N
60883	2306	3599122000000	27038	13370	6	0	\N
60884	2306	4319121000000	27736	13703	2	0	\N
60885	2306	4319121000000	28248	13967	3	0	\N
60886	2306	4319121000000	28250	13730	53	0	\N
60887	2306	4319121000000	28387	14032	2	0	\N
60888	2306	4319121000000	28761	14187	2	0	\N
60890	2306	4319132000000	27736	13703	3	0	\N
60891	2306	4319132000000	28387	14032	3	0	\N
60892	2306	4319132000000	28761	14187	3	0	\N
60893	2306	4319133000000	28248	13967	4	0	\N
60895	2306	4319219000000	28250	13730	54	0	\N
60896	2306	5039144000000	29398	14494	3	0	\N
60897	2306	5039144000000	29508	14553	3	0	\N
60898	2306	5039144000000	29673	14635	18	0	\N
60899	2306	5039144000000	30122	14822	23	0	\N
60900	2306	5039156000000	29398	14494	4	0	\N
60901	2306	5039156000000	29508	14553	4	0	\N
60902	2306	5039196031580	30122	14822	24	0	\N
60903	2306	5039279000000	29673	14635	19	0	\N
60904	2307	719000000000	23164	11567	4	0	\N
60905	2307	719000000000	23272	11611	6	0	\N
60906	2307	719000000000	23431	11689	2	0	\N
60907	2307	719000000000	23551	11739	7	0	\N
60908	2307	719000000000	23655	11783	3	0	\N
60910	2307	719011000000	23431	11689	3	0	\N
60911	2307	719012000000	23655	11783	4	0	\N
60912	2307	719022000000	23164	11567	5	0	\N
60913	2307	719025000000	23551	11739	8	0	\N
60914	2307	719033000000	23272	11611	7	0	\N
60916	2307	1439035000000	24653	12245	4	0	\N
60917	2307	1439035000000	24878	12351	3	0	\N
60919	2307	1439047000000	24878	12351	4	0	\N
60921	2307	1439147000000	24653	12245	5	0	\N
60924	2307	2879060000000	26110	12904	2	0	\N
60925	2307	2879060000000	26354	13031	2	0	\N
60926	2307	2879060000000	26484	13099	3	0	\N
60928	2307	2879071000000	26110	12904	3	0	\N
60848	2306	719000000000	23161	11565	2	0	0
60849	2306	719011000000	23161	11565	3	0	0
60834	2300	2879000000000	23483	11709	3	0	0
60835	2300	2879012000000	23483	11709	4	0	0
60909	2307	719000000000	24131	12012	8	0	0
60858	2306	1439011000000	24990	12400	10	0	0
60866	2306	1439048000000	24990	12400	11	0	0
60918	2307	1439035000000	25059	12435	4	0	0
60920	2307	1439048000000	25059	12435	5	0	0
60867	2306	2159048000000	25588	12664	12	0	0
60922	2307	2159048000000	25778	12749	3	0	0
60923	2307	2159060000000	25778	12749	4	0	0
60836	2300	3599012000000	26065	12882	9	0	0
60837	2300	3599066000000	26065	12882	10	0	0
60872	2306	2879096000000	26948	13330	3	0	0
60873	2306	2879108000000	26948	13330	4	0	0
60842	2302	2159000000000	27285	13486	5	0	0
60843	2302	2159023000000	27285	13486	6	0	0
60880	2306	3599108000000	27552	13620	4	0	0
60797	2292	2879060000000	28766	14190	9	0	0
60811	2292	2879076000000	28766	14190	10	0	0
60889	2306	4319121000000	29301	14438	5	0	0
60894	2306	4319144000000	29301	14438	6	0	0
60839	2301	1439000000000	29426	14508	5	0	0
60929	2307	2879071000000	26354	13031	3	0	\N
60930	2307	2879072000000	26484	13099	4	0	\N
60934	2307	3599095000000	27065	13382	1	0	\N
60935	2307	4319085000000	26969	13338	3	0	\N
60937	2307	4319090000000	27065	13382	2	0	\N
60938	2307	4319097000000	26969	13338	4	0	\N
60940	2307	5039110000000	27553	13620	4	0	\N
60941	2307	5039110000000	27644	13660	12	0	\N
60944	2307	5039123000000	27553	13620	5	0	\N
60945	2307	5039158000000	27644	13660	13	0	\N
60946	2307	5759121000000	27797	13736	3	0	\N
60948	2307	5759133000000	27797	13736	4	0	\N
60950	2307	6479133000000	28380	14029	2	0	\N
60951	2307	6479133000000	28391	14033	3	0	\N
60952	2307	6479133000000	28491	14080	7	0	\N
60953	2307	6479133000000	28745	14182	2	0	\N
60954	2307	6479133000000	28786	14199	3	0	\N
60955	2307	6479133000000	28922	14264	5	0	\N
60956	2307	6479133000000	29617	14607	9	0	\N
60957	2307	6479144000000	28380	14029	3	0	\N
60958	2307	6479144000000	28745	14182	3	0	\N
60959	2307	6479145000000	28786	14199	4	0	\N
60960	2307	6479154000000	28391	14033	4	0	\N
60961	2307	6479156000000	28922	14264	6	0	\N
60962	2307	6479169666670	28491	14080	8	0	\N
60963	2307	6479178000000	29617	14607	10	0	\N
60964	2311	13206138539449	25477	12617	6	0	\N
60967	2329	719000000000	26047	12871	2	0	\N
60969	2329	719020000000	26047	12871	3	0	\N
60971	2329	1439022000000	26090	12894	2	0	\N
60972	2329	1439022000000	26124	12914	2	0	\N
60974	2329	1439033000000	26090	12894	3	0	\N
60975	2329	1439033000000	26124	12914	3	0	\N
60976	2329	303846199819988	26259	12984	3	0	\N
60977	2329	303846199819988	26308	13014	0	0	\N
60979	2329	303846211819988	26259	12984	4	0	\N
60987	2329	306726258819988	26442	13081	6	0	\N
60988	2329	306726258819988	26447	13082	4	0	\N
60989	2329	306726258819988	26454	13085	4	0	\N
60991	2329	306726271819988	26447	13082	5	0	\N
60992	2329	306726271819988	26454	13085	5	0	\N
60994	2329	306726282819988	26442	13081	7	0	\N
60995	2329	307446272819988	26524	13121	3	0	\N
60996	2329	307446272819988	26541	13131	7	0	\N
60997	2329	307446272819988	26545	13132	2	0	\N
60999	2329	307446274819988	26545	13132	3	0	\N
61000	2329	307446284819988	26524	13121	4	0	\N
61002	2329	307446297819988	26541	13131	8	0	\N
61003	2329	308166296819988	26568	13146	3	0	\N
61005	2329	308166308819988	26568	13146	4	0	\N
61007	2329	308886321819988	26629	13173	7	0	\N
61008	2329	308886321819988	26661	13188	8	0	\N
61011	2329	308886346819988	26629	13173	8	0	\N
61012	2329	308886347819988	26661	13188	9	0	\N
61019	2329	311766394819988	26717	13215	3	0	\N
61021	2329	311766406819988	26717	13215	4	0	\N
61025	2329	313206441819988	26813	13259	7	0	\N
61026	2329	313206441819988	26830	13268	4	0	\N
61029	2329	313206454819988	26830	13268	5	0	\N
61030	2329	313206466819988	26813	13259	8	0	\N
61031	2329	313926453819988	26952	13331	3	0	\N
61033	2329	313926465819988	26952	13331	4	0	\N
61037	2329	314646489819988	27068	13382	1	0	\N
61040	2329	315366489819988	27068	13382	7	0	\N
61041	2329	315366503819988	27068	13382	8	0	\N
61042	2329	316086481819988	27137	13419	3	0	\N
61044	2329	316086493819988	27137	13419	4	0	\N
61054	2329	319686565819988	27447	13566	6	0	\N
61056	2329	319686589819988	27447	13566	7	0	\N
61058	2329	320406590819988	27626	13653	6	0	\N
61060	2329	320406614819988	27626	13653	7	0	\N
61064	2329	321846658819988	27731	13699	2	0	\N
60968	2329	719000000000	26071	12885	4	0	0
60970	2329	719022000000	26071	12885	5	0	0
60973	2329	1439022000000	26170	12938	0	0	0
60978	2329	303846199819988	26323	13018	5	0	0
60980	2329	303846222819988	26323	13018	6	0	0
60982	2329	304566233819988	26361	13036	3	0	0
60983	2329	305286233819988	26401	13062	3	0	0
60984	2329	305286245819988	26401	13062	4	0	0
60985	2329	306006245819988	26411	13066	4	0	0
60986	2329	306006258819988	26411	13066	5	0	0
60993	2329	306726272819988	26480	13098	6	0	0
60998	2329	307446272819988	26554	13139	6	0	0
61001	2329	307446296819988	26554	13139	7	0	0
61004	2329	308166296819988	26571	13147	7	0	0
61009	2329	308886321819988	26671	13191	3	0	0
61010	2329	308886333819988	26671	13191	4	0	0
61013	2329	309606333819988	26692	13201	10	0	0
61014	2329	309606370819988	26692	13201	11	0	0
61015	2329	310326370819988	26695	13203	3	0	0
61017	2329	311046382819988	26698	13205	3	0	0
61018	2329	311046394819988	26698	13205	4	0	0
61020	2329	311766394819988	26745	13228	7	0	0
61022	2329	311766419819988	26745	13228	8	0	0
60931	2307	2879072000000	26751	13231	4	0	0
60933	2307	3599085000000	26788	13246	5	0	0
61023	2329	312486419819988	26805	13255	4	0	0
61024	2329	312486441819988	26805	13255	5	0	0
61027	2329	313206441819988	26876	13292	3	0	0
61032	2329	313926453819988	26965	13337	3	0	0
61034	2329	313926465819988	26965	13337	4	0	0
61035	2329	314646465819988	27043	13370	5	0	0
61036	2329	314646479819988	27043	13370	6	0	0
61038	2329	315366479819988	27114	13405	2	0	0
61043	2329	316086481819988	27143	13421	3	0	0
61045	2329	316086493819988	27143	13421	4	0	0
61046	2329	316806493819988	27148	13423	3	0	0
61047	2329	316806505819988	27148	13423	4	0	0
61048	2329	317526505819988	27179	13443	6	0	0
61050	2329	318246529819988	27373	13535	3	0	0
61051	2329	318246541819988	27373	13535	4	0	0
61052	2329	318966541819988	27390	13543	6	0	0
61053	2329	318966565819988	27390	13543	7	0	0
60939	2307	4319110000000	27440	13564	8	0	0
61055	2329	319686565819988	27523	13608	7	0	0
61057	2329	319686590819988	27523	13608	8	0	0
61059	2329	320406590819988	27688	13682	6	0	0
61061	2329	320406614819988	27688	13682	7	0	0
61063	2329	321126658819988	27703	13688	9	0	0
60942	2307	5039110000000	27762	13715	2	0	0
60943	2307	5039121000000	27762	13715	3	0	0
60947	2307	5759121000000	28049	13871	3	0	0
60949	2307	5759133000000	28049	13871	4	0	0
61066	2329	321846669819988	27731	13699	3	0	\N
61078	2329	325446769819988	27918	13807	3	0	\N
61079	2329	326166739819988	27830	13755	12	0	\N
61082	2329	326166769819988	27918	13807	10	0	\N
61083	2329	326166775819988	27918	13807	11	0	\N
61085	2329	326166787819988	27830	13755	13	0	\N
61089	2329	328326787819988	28102	13891	3	0	\N
61091	2329	328326799819988	28102	13891	4	0	\N
61095	2329	329766821819988	28186	13932	3	0	\N
61097	2329	329766833819988	28186	13932	4	0	\N
61103	2329	331926866819988	28427	14049	2	0	\N
61105	2329	331926877819988	28427	14049	3	0	\N
61110	2329	333366910819988	28487	14077	2	0	\N
61112	2329	333366921819988	28487	14077	3	0	\N
61114	2329	334086921819988	28726	14176	2	0	\N
61116	2329	334086932819988	28726	14176	3	0	\N
61120	2329	335526944819988	28839	14224	3	0	\N
61123	2329	335526956819988	28839	14224	4	0	\N
61127	2329	336966992819988	28989	14248	2	0	\N
61129	2329	336967246819988	28989	14248	3	0	\N
61131	2329	337687004819988	28988	14265	2	0	\N
61132	2329	337687004819988	28990	14282	2	0	\N
61134	2329	337687258819988	28988	14265	3	0	\N
61135	2329	337687258819988	28990	14282	3	0	\N
61140	2329	339847053819988	29276	14428	3	0	\N
61141	2329	339847053819988	29299	14438	5	0	\N
61142	2329	339847053819988	29305	14441	4	0	\N
61143	2329	339847053819988	29307	14442	1	0	\N
61145	2329	339847063819988	29307	14442	2	0	\N
61146	2329	339847065819988	29276	14428	4	0	\N
61148	2329	339847066819988	29305	14441	5	0	\N
61149	2329	339847076819988	29299	14438	6	0	\N
61160	2329	343447197819988	29516	14557	3	0	\N
61163	2329	344167197819988	29516	14557	8	0	\N
61164	2329	344167201819988	29516	14557	9	0	\N
61165	2329	344887188819988	29657	14626	22	0	\N
61168	2329	344887228819988	29657	14626	23	0	\N
61169	2329	345607220819988	29702	14648	9	0	\N
61170	2329	345607220819988	29707	14649	7	0	\N
61172	2329	345607236819988	29707	14649	8	0	\N
61173	2329	345607238819988	29702	14648	10	0	\N
61176	2329	346327256819988	29780	14676	15	0	\N
61177	2329	346327256819988	29810	14688	5	0	\N
61178	2329	346327256819988	29839	14704	23	0	\N
61179	2329	346327256819988	29964	14757	5	0	\N
61180	2329	346327270819988	29810	14688	6	0	\N
61181	2329	346327270819988	29964	14757	6	0	\N
61182	2329	346327280819988	29780	14676	16	0	\N
61183	2329	346327297819988	29839	14704	24	0	\N
61185	2329	347047312819988	30041	14790	22	0	\N
61188	2329	347047361819988	30041	14790	23	0	\N
61193	2329	349207393194886	30206	14857	12	0	\N
61194	2329	349207393194886	30234	14865	10	0	\N
61196	2329	349207412194886	30234	14865	11	0	\N
61198	2329	349207438194886	30206	14857	13	0	\N
61068	2329	322566669819988	27764	13716	2	0	0
61069	2329	322566680819988	27764	13716	3	0	0
61070	2329	323286680819988	27775	13723	2	0	0
61071	2329	323286691819988	27775	13723	3	0	0
61072	2329	324006691819988	27804	13739	6	0	0
61074	2329	324726715819988	27823	13751	3	0	0
61075	2329	324726727819988	27823	13751	4	0	0
61076	2329	325446727819988	27826	13752	3	0	0
61077	2329	325446739819988	27826	13752	4	0	0
61080	2329	326166739819988	27954	13829	6	0	0
61084	2329	326166775819988	28035	13865	3	0	0
61086	2329	326886775819988	28035	13865	4	0	0
61087	2329	327606775819988	28092	13887	3	0	0
61088	2329	327606787819988	28092	13887	4	0	0
61092	2329	328326808819988	28119	13901	4	0	0
61093	2329	329046808819988	28136	13907	4	0	0
61094	2329	329046821819988	28136	13907	5	0	0
61096	2329	329766821819988	28204	13944	5	0	0
61098	2329	329766844819988	28204	13944	6	0	0
61100	2329	330486855819988	28263	13973	3	0	0
61101	2329	331206855819988	28274	13979	2	0	0
61102	2329	331206866819988	28274	13979	3	0	0
61104	2329	331926866819988	28429	14050	4	0	0
61106	2329	331926888819988	28429	14050	5	0	0
61108	2329	332646910819988	28470	14068	5	0	0
61109	2329	332646920819988	28541	14101	1	0	0
61111	2329	333366920819988	28541	14101	3	0	0
61113	2329	333366921819988	28541	14101	4	0	0
61117	2329	334086932819988	28790	14203	3	0	0
61118	2329	334806932819988	28827	14219	3	0	0
61119	2329	334806944819988	28827	14219	4	0	0
61121	2329	335526944819988	28843	14226	2	0	0
61122	2329	335526955819988	28843	14226	3	0	0
61125	2329	336246992819988	28855	14232	11	0	0
61126	2329	336966992819988	28907	14258	3	0	0
61128	2329	336967004819988	28907	14258	4	0	0
61130	2329	337687004819988	28963	14284	4	0	0
61133	2329	337687017819988	28963	14284	5	0	0
61137	2329	338407029819988	29112	14352	4	0	0
61138	2329	339127029819988	29113	14353	6	0	0
61139	2329	339127053819988	29113	14353	7	0	0
61144	2329	339847053819988	29345	14462	3	0	0
61150	2329	340567065819988	29379	14482	3	0	0
61151	2329	340567077819988	29379	14482	4	0	0
61152	2329	341287077819988	29389	14489	4	0	0
61153	2329	341287090819988	29389	14489	5	0	0
61154	2329	342007090819988	29407	14499	3	0	0
61156	2329	342727102819988	29448	14520	9	0	0
61157	2329	342727138819988	29448	14520	10	0	0
61158	2329	343447138819988	29468	14532	8	0	0
61159	2329	343447176819988	29468	14532	9	0	0
61161	2329	344167176819988	29537	14564	3	0	0
61166	2329	344887188819988	29658	14627	14	0	0
61167	2329	344887220819988	29658	14627	15	0	0
61171	2329	345607220819988	29745	14662	18	0	0
61174	2329	345607256819988	29745	14662	19	0	0
61184	2329	346327312819988	30011	14778	30	0	0
61186	2329	347047312819988	30072	14806	8	0	0
61187	2329	347047329819988	30072	14806	9	0	0
61189	2329	347767329819988	30179	14847	19	0	0
61190	2329	347767366819988	30179	14847	20	0	0
61192	2329	348487393194886	30192	14852	11	1	0
61195	2329	349207393194886	30242	14868	10	0	0
61197	2329	349207412194886	30242	14868	11	0	0
61199	2329	349927412194886	30247	14872	19	0	0
61200	2329	349927449194886	30247	14872	20	0	0
61205	2330	105000000	26311	13015	8	0	\N
61207	2330	1104000000	29783	14666	76	0	\N
61208	2330	1105000000	30223	14735	104	1	\N
61209	2332	100000001	27107	13401	4	0	\N
61210	2332	100000100	29756	14666	23	0	\N
61212	2332	100000300	29784	14678	18	0	\N
61214	2332	100001000	29798	14683	13	1	\N
61217	2332	100001300	29876	14690	126	1	\N
61220	2332	100001800	29850	14711	11	1	\N
61223	2332	100002900	29861	14718	12	1	\N
61224	2332	100003100	29879	14725	15	1	\N
61226	2332	100003400	29930	14727	100	1	\N
61228	2332	100003500	29905	14734	13	1	\N
61229	2332	100003500	29920	14733	82	1	\N
61230	2332	100003600	29938	14742	59	0	\N
61232	2332	100003900	29933	14744	19	1	\N
61233	2332	100003900	30001	14734	126	1	\N
61234	2332	100004300	29986	14751	126	0	\N
61235	2332	100004300	30223	14735	54	1	\N
61237	2332	100004400	29957	14754	15	0	\N
61238	2332	100004500	30223	14735	107	0	\N
61241	2332	100005100	29999	14771	24	1	\N
61243	2332	100005500	30099	14773	127	0	\N
61246	2332	100005800	30035	14788	13	1	\N
61248	2332	100006300	30064	14801	12	1	\N
61251	2332	100006600	30081	14811	14	0	\N
61252	2332	100006600	30082	14811	14	0	\N
61253	2332	100006600	30083	14811	14	0	\N
61254	2332	100006600	30084	14811	12	0	\N
61256	2332	100006800	30126	14825	23	1	\N
61257	2332	100006800	30267	14812	126	1	\N
61258	2332	100006900	30163	14842	45	0	\N
61259	2332	100006900	30164	14842	44	1	\N
61261	2332	100006900	30166	14842	44	1	\N
61262	2332	100006900	30207	14832	126	1	\N
61263	2332	100007100	30167	14843	12	1	\N
61264	2332	100007100	30168	14843	11	1	\N
61266	2332	100007300	30188	14851	25	1	\N
61268	2332	100007400	30191	14852	14	0	\N
61270	2332	100007700	30210	14858	39	0	\N
61271	2332	100007700	30211	14858	38	0	\N
61272	2332	100007700	30213	14858	39	0	\N
61276	2332	100008000	30240	14867	7	0	\N
61277	2332	100008000	30241	14867	5	0	\N
61279	2332	100028300	30255	14876	22	1	\N
61280	2332	100028300	30256	14876	22	1	\N
61284	2332	100088300	30317	14900	7	0	\N
61285	2332	100088300	30318	14900	7	0	\N
61286	2332	58293992183957277	27183	13445	8	1	\N
61290	2336	100000002	29848	14710	42	0	\N
61292	2336	100024003	30153	14837	51	1	\N
61295	2336	101000000	26705	13209	13	0	\N
61296	2336	106000000	30176	14594	10	0	\N
61297	2336	106000000	30185	14587	76	1	\N
61298	2336	2160029000000	26311	13015	7	1	\N
61300	2346	390000000	27513	13602	4	0	\N
61301	2348	100000100	28169	13846	27	0	\N
61302	2349	110000000	28626	13884	14	0	\N
61303	2358	50109000000	30223	14735	106	1	\N
61304	2358	51096000000	30160	14593	0	0	\N
61305	2359	101000000	26705	13209	13	1	\N
61306	2359	1100000000	27649	13413	0	0	\N
61308	2367	100000101	29756	14666	21	0	\N
61311	2367	100000501	29784	14678	15	1	\N
61312	2367	100001201	29798	14683	11	0	\N
61314	2367	100001401	29876	14690	123	0	\N
61318	2367	100002201	29848	14710	40	0	\N
61321	2367	100002701	29861	14718	11	0	\N
61322	2367	100003201	29879	14725	13	0	\N
61324	2367	100003401	29930	14727	98	0	\N
61325	2367	100003501	29920	14733	80	0	\N
61326	2367	100003601	30001	14734	54	1	\N
61328	2367	100003801	29905	14734	11	0	\N
61329	2367	100003901	30001	14734	123	0	\N
61330	2367	100004001	29938	14742	57	0	\N
61332	2367	100004101	29933	14744	17	1	\N
61333	2367	100004101	30223	14735	51	0	\N
61334	2367	100004201	30223	14735	100	1	\N
61335	2367	100004601	29986	14751	124	0	\N
61307	2367	100000001	26851	13282	8	0	0
61288	2333	101100000	27445	13565	7	0	0
61299	2346	389000000	27445	13565	7	1	0
61309	2367	100000101	29757	14666	21	0	0
61310	2367	100000501	29782	14678	15	0	0
61213	2332	100000700	29797	14682	65	0	0
61313	2367	100001201	29799	14683	10	0	0
61215	2332	100001000	29799	14683	12	1	0
61315	2367	100001501	29818	14692	12	1	0
61216	2332	100001300	29818	14692	15	1	0
61218	2332	100001600	29837	14703	13	1	0
61317	2367	100002201	29847	14710	45	0	0
61289	2336	100000002	29847	14710	47	0	0
61219	2332	100001800	29849	14711	11	1	0
61291	2336	100000003	29859	14717	15	1	0
61221	2332	100002800	29859	14717	16	1	0
61320	2367	100002701	29860	14718	11	1	0
61222	2332	100002900	29860	14718	12	1	0
61323	2367	100003201	29880	14725	13	0	0
61327	2367	100003801	29904	14734	11	0	0
61227	2332	100003500	29904	14734	13	1	0
61331	2367	100004101	29932	14744	17	0	0
61231	2332	100003900	29932	14744	19	1	0
61336	2367	100005001	29956	14754	12	1	0
61239	2332	100004800	29979	14763	24	1	0
61240	2332	100005100	29998	14771	24	0	0
61242	2332	100005400	30012	14779	13	1	0
61244	2332	100005700	30033	14787	23	1	0
61247	2332	100006300	30063	14801	12	1	0
61249	2332	100006400	30065	14802	11	1	0
61250	2332	100006600	30080	14811	14	0	0
61255	2332	100006800	30125	14825	23	1	0
61293	2336	100024003	30154	14837	51	0	0
61265	2332	100007100	30169	14843	12	1	0
61267	2332	100007300	30190	14851	25	1	0
61269	2332	100007400	30192	14852	14	0	0
61273	2332	100007700	30214	14858	39	0	0
61274	2332	100007800	30238	14866	28	1	0
61278	2332	100008100	30254	14875	13	0	0
61281	2332	100028300	30257	14876	22	1	0
61294	2336	100048003	30276	14887	36	0	0
61282	2332	100058300	30276	14887	37	1	0
61201	2329	350647449194886	30293	14892	13	0	0
61202	2329	350647480194886	30293	14892	14	0	0
61337	2367	100005001	29957	14754	13	0	\N
61340	2367	100005501	29999	14771	22	0	\N
61341	2367	100005701	30099	14773	125	0	\N
61345	2367	100006301	30035	14788	12	0	\N
61346	2367	100006501	30051	14795	19	0	\N
61206	2330	1103000000	29209	14396	3	0	0
61350	2367	100006701	30081	14811	12	0	\N
61351	2367	100006701	30082	14811	12	0	\N
61352	2367	100006701	30083	14811	12	0	\N
61353	2367	100006701	30084	14811	10	0	\N
61355	2367	100006901	30126	14825	21	0	\N
61356	2367	100007001	30163	14842	42	0	\N
61357	2367	100007101	30164	14842	41	1	\N
61359	2367	100007101	30166	14842	41	1	\N
61360	2367	100007101	30207	14832	123	0	\N
61361	2367	100007301	30188	14851	23	1	\N
61363	2367	100007401	30210	14858	36	0	\N
61364	2367	100007401	30211	14858	35	0	\N
61365	2367	100007401	30213	14858	36	0	\N
61367	2367	100007501	30215	14859	12	1	\N
61368	2367	100007501	30216	14859	12	1	\N
61369	2367	100007501	30217	14859	12	1	\N
61370	2367	100007501	30218	14859	13	1	\N
61371	2367	100007501	30219	14859	12	1	\N
61375	2367	100007801	30240	14867	5	0	\N
61376	2367	100007801	30241	14867	3	0	\N
61378	2367	100008001	30255	14876	20	0	\N
61379	2367	100008001	30256	14876	20	1	\N
61382	2367	100008301	30268	14882	22	0	\N
61385	2384	719000000000	27537	13613	7	0	\N
61386	2384	719000000000	29557	14571	3	0	\N
61387	2384	719015000000	29557	14571	4	0	\N
61388	2384	719034000000	27537	13613	8	0	\N
61389	2393	2158033000000	30107	14819	16	0	\N
61390	2393	2158033000000	30108	14819	16	0	\N
61393	2393	2878033000000	30107	14819	23	0	\N
61394	2393	2878033000000	30108	14819	36	0	\N
61395	2393	2878039000000	30107	14819	24	0	\N
61396	2393	2878052000000	30108	14819	37	0	\N
61397	2407	101000000	30163	14842	41	0	\N
61398	2407	103000000	30223	14735	98	1	\N
61400	2430	275707501654	30126	14825	22	0	\N
61401	2430	275707501654	30223	14735	102	0	\N
61402	2430	275707601654	30163	14842	42	1	\N
61403	2430	275707601654	30164	14842	42	0	\N
61405	2430	275707601654	30166	14842	42	1	\N
61406	2430	275707601654	30207	14832	125	0	\N
61407	2430	275707701654	30191	14852	12	0	\N
61409	2430	275707801654	30210	14858	37	0	\N
61410	2430	275707801654	30211	14858	36	0	\N
61411	2430	275707801654	30213	14858	37	0	\N
61413	2443	24	30209	14588	0	0	\N
61423	1397	1439740000000	6	6	0	0	\N
61425	1397	1439740000000	8	6	0	0	\N
61426	1397	1439740000000	9	6	0	0	\N
61427	1397	1439730000000	10	7	0	0	\N
61433	1397	1438690000000	20	12	0	0	\N
61434	1397	1438690000000	21	12	0	0	\N
61437	1397	1438679999000	23	13	0	0	\N
61438	1397	1438669999000	23	13	1	0	\N
61444	1397	1438629996000	26	15	0	0	\N
61445	1397	1438619995000	26	15	1	0	\N
61447	1397	1438599993000	28	17	0	0	\N
61448	1397	1438589992000	28	17	1	0	\N
61451	1397	1438579991000	30	18	0	0	\N
61454	1397	1438559989000	33	20	0	0	\N
61465	1397	1438469980000	40	25	0	0	\N
61467	1397	1438459979000	42	26	0	0	\N
61468	1397	1438459979000	43	26	0	0	\N
61470	1397	1438449978000	45	27	0	0	\N
61471	1397	1438449978000	46	27	0	0	\N
61472	1397	1438449978000	47	27	0	0	\N
61416	1397	1439930000000	3	3	2	0	3
61417	1397	1439880000000	3	3	3	0	4
61418	1397	1439870000000	4	4	0	0	5
61419	1397	1439820000000	4	4	1	0	6
61420	1397	1439810000000	5	5	0	0	7
61422	1397	1439750000000	5	5	2	0	9
61424	1397	1439740000000	7	6	0	0	10
61428	1397	1439730000000	11	7	0	0	11
61429	1397	1439720000000	12	8	0	0	12
61430	1397	1438710000000	18	11	0	0	13
61432	1397	1438690000000	19	12	0	0	15
61435	1397	1438679999000	22	13	0	0	16
61436	1397	1438669999000	22	13	1	0	17
61439	1397	1438659999000	24	14	0	0	18
61441	1397	1438639997000	24	14	2	0	20
61442	1397	1438629996000	25	15	0	0	21
61443	1397	1438619995000	25	15	1	0	22
61446	1397	1438609994000	27	16	0	0	23
61449	1397	1438599993000	29	17	0	0	24
61452	1397	1438579991000	31	18	0	0	26
61453	1397	1438569990000	32	19	0	0	27
61455	1397	1438559989000	34	20	0	0	28
61456	1397	1438549988000	35	21	0	0	29
61457	1397	1438539987000	36	22	0	0	30
61459	1397	1438519985000	37	23	1	0	32
61460	1397	1438509984000	37	23	2	0	33
61461	1397	1438499983000	38	24	0	0	34
61462	1397	1438489982000	38	24	1	0	35
61464	1397	1438469980000	39	25	0	0	37
61466	1397	1438459979000	41	26	0	0	38
61469	1397	1438449978000	44	27	0	0	39
61338	2367	100005301	29979	14763	22	0	0
61339	2367	100005501	29998	14771	22	0	0
61343	2367	100006201	30033	14787	21	0	0
61344	2367	100006301	30034	14788	12	1	0
61347	2367	100006501	30052	14795	19	0	0
61348	2367	100006601	30065	14802	10	0	0
61349	2367	100006701	30080	14811	12	0	0
61392	2393	2878020000000	30106	14819	4	0	1
61354	2367	100006901	30125	14825	21	0	0
61399	2430	275707501654	30125	14825	22	1	1
61358	2367	100007101	30165	14842	41	1	0
61362	2367	100007301	30190	14851	23	1	0
61408	2430	275707701654	30192	14852	12	0	1
61366	2367	100007401	30214	14858	36	0	0
61412	2430	275707801654	30214	14858	37	0	1
61372	2367	100007501	30220	14859	12	1	0
61374	2367	100007801	30239	14867	9	0	0
61377	2367	100007901	30254	14875	11	1	0
61380	2367	100008001	30257	14876	20	0	0
61381	2367	100008101	30266	14881	36	0	0
61383	2367	100008301	30269	14882	13	0	0
61474	1397	1438439977000	49	28	0	0	\N
61475	1397	1438439977000	50	28	0	0	\N
61478	1397	1438419975000	53	30	0	0	\N
61479	1397	1438409974000	54	31	0	0	\N
61480	1397	1438399973000	54	31	1	0	\N
61484	1397	1438379971000	57	33	0	0	\N
61487	1397	1438359969000	60	35	0	0	\N
61488	1397	1438359969000	61	35	0	0	\N
61491	1397	1438349968000	64	36	0	0	\N
61492	1397	1438349968000	65	36	0	0	\N
61496	1397	1438329966000	68	38	0	0	\N
61497	1397	1438319965000	68	38	1	0	\N
61500	1397	1438289962000	71	41	0	0	\N
61509	1397	1438229956000	78	46	0	0	\N
61510	1397	1438219955000	78	46	1	0	\N
61517	1397	1438149948000	84	52	0	0	\N
61518	1397	1438139947000	84	52	1	0	\N
61519	1397	1438129946000	84	52	2	0	\N
61531	1504	719000000000	91	57	0	0	\N
61532	1397	1438059939000	91	57	1	0	\N
61533	1504	719000000000	92	57	0	0	\N
61534	1397	1438059939000	92	57	1	0	\N
61539	1397	1438009934000	95	60	0	0	\N
61541	1397	1438009934000	97	60	0	0	\N
61542	1397	1438009934000	98	60	0	0	\N
61547	1397	1437989932000	101	62	0	0	\N
61548	1397	1437979931000	101	62	1	0	\N
61549	1397	1437969930000	101	62	2	0	\N
61550	1397	1437959929000	102	63	0	0	\N
61551	1397	1437949928000	102	63	1	0	\N
61552	1504	717990000000	102	63	2	0	\N
61553	1397	1437959929000	103	63	0	0	\N
61554	1397	1437949928000	103	63	1	0	\N
61555	1504	717990000000	103	63	2	0	\N
61562	1397	1437909924000	107	66	0	0	\N
61563	1397	1437899923000	107	66	1	0	\N
61564	1397	1437909924000	108	66	0	0	\N
61565	1397	1437899923000	108	66	1	0	\N
61568	1397	1437889922000	110	67	0	0	\N
61571	1397	1437879921000	113	68	0	0	\N
61572	1397	1437879921000	114	68	0	0	\N
61573	1397	1437879921000	115	68	0	0	\N
61579	1397	1437829916000	118	70	0	0	\N
61581	1397	1437819915000	120	71	0	0	\N
61582	1397	1437809914000	121	72	0	0	\N
61584	1397	1437809914000	123	72	0	0	\N
61585	1397	1437799913000	124	73	0	0	\N
61586	1397	1437789912000	124	73	1	0	\N
61587	1397	1437779911000	124	73	2	0	\N
61588	1397	1437799913000	125	73	0	0	\N
61589	1397	1437789912000	125	73	1	0	\N
61590	1397	1437779911000	125	73	2	0	\N
61600	1397	1437729906000	130	76	0	0	\N
61601	1397	1437719905000	130	76	1	0	\N
61606	1397	1437669900000	134	80	0	0	\N
61607	1397	1437659899000	134	80	1	0	\N
61477	1397	1438419975000	52	30	0	0	42
61481	1397	1438409974000	55	31	0	0	43
61482	1397	1438399973000	55	31	1	0	44
61483	1397	1438389972000	56	32	0	0	45
61485	1397	1438379971000	58	33	0	0	46
61489	1397	1438359969000	62	35	0	0	48
61490	1397	1438349968000	63	36	0	0	49
61493	1397	1438339967000	66	37	0	0	50
61494	1397	1438329966000	67	38	0	0	51
61495	1397	1438319965000	67	38	1	0	52
61499	1397	1438299963000	70	40	0	0	54
61501	1397	1438289962000	72	41	0	0	55
61502	1397	1438279961000	73	42	0	0	56
61503	1397	1438269960000	74	43	0	0	57
61505	1397	1438249958000	76	45	0	0	59
61506	1397	1438239957000	76	45	1	0	60
61507	1397	1438229956000	77	46	0	0	61
61508	1397	1438219955000	77	46	1	0	62
61511	1397	1438209954000	79	47	0	0	63
61513	1397	1438189952000	81	49	0	0	65
61514	1397	1438179951000	81	49	1	0	66
61515	1397	1438169950000	82	50	0	0	67
61516	1397	1438159949000	83	51	0	0	68
61520	1397	1438149948000	85	52	0	0	69
61522	1397	1438129946000	85	52	2	0	71
61523	1397	1438119945000	86	53	0	0	72
61524	1397	1438109944000	86	53	1	0	73
61525	1397	1438099943000	87	54	0	0	74
61527	1397	1438079941000	89	56	0	0	76
61528	1397	1438069940000	89	56	1	0	77
61529	1504	719000000000	90	57	0	0	1
61530	1397	1438059939000	90	57	1	0	78
61535	1397	1438049938000	93	58	0	0	79
61537	1397	1438029936000	94	59	1	0	81
61538	1397	1438019935000	94	59	2	0	82
61540	1397	1438009934000	96	60	0	0	83
61543	1397	1437999933000	99	61	0	0	84
61544	1397	1437989932000	100	62	0	0	85
61546	1397	1437969930000	100	62	2	0	87
61556	1397	1437959929000	104	63	0	0	88
61557	1397	1437949928000	104	63	1	0	89
61558	1504	717990000000	104	63	2	0	2
61560	1397	1437929926000	106	65	0	0	91
61561	1397	1437919925000	106	65	1	0	92
61566	1397	1437909924000	109	66	0	0	93
61567	1397	1437899923000	109	66	1	0	94
61569	1397	1437889922000	111	67	0	0	95
61574	1397	1437869920000	116	69	0	0	97
61575	1397	1437859919000	116	69	1	0	98
61576	1397	1437849918000	116	69	2	0	99
61577	1397	1437839917000	116	69	3	0	100
61578	1397	1437829916000	117	70	0	0	101
61583	1397	1437809914000	122	72	0	0	103
61591	1397	1437799913000	126	73	0	0	104
61592	1397	1437789912000	126	73	1	0	105
61593	1397	1437779911000	126	73	2	0	106
61595	1397	1437759909000	127	74	1	0	108
61596	1397	1437749908000	127	74	2	0	109
61597	1397	1437739907000	128	75	0	0	110
61598	1397	1437729906000	129	76	0	0	111
61599	1397	1437719905000	129	76	1	0	112
61603	1397	1437699903000	131	77	1	0	114
61604	1397	1437689902000	132	78	0	0	115
61605	1397	1437679901000	133	79	0	0	116
61608	1397	1437669900000	135	80	0	0	117
61611	1397	1437649898000	137	81	0	0	\N
61612	1397	1437649898000	138	81	0	0	\N
61613	1397	1437639897000	139	82	0	0	\N
61614	1397	1437629896000	139	82	1	0	\N
61618	1397	1437609894000	142	84	0	0	\N
61622	1397	1437579891000	146	87	0	0	\N
61625	1397	1437559889000	149	89	0	0	\N
61626	1397	1437549888000	149	89	1	0	\N
61629	1397	1437559889000	151	89	0	0	\N
61630	1397	1437549888000	151	89	1	0	\N
61633	1397	1437529886000	154	91	0	0	\N
61637	1397	1437489882000	157	94	0	0	\N
61638	1397	1437479881000	157	94	1	0	\N
61639	1397	1437469880000	157	94	2	0	\N
61640	1397	1437459879000	157	94	3	0	\N
61648	1397	1437419875000	160	96	0	0	\N
61649	1397	1437409874000	160	96	1	0	\N
61652	1397	1437419875000	162	96	0	0	\N
61653	1397	1437409874000	162	96	1	0	\N
61665	1705	716910000000	168	101	0	0	\N
61666	1397	1437329866000	168	101	1	0	\N
61667	1397	1437319865000	168	101	2	0	\N
61668	1397	1437309864000	168	101	3	0	\N
61669	1705	716910000000	169	101	0	0	\N
61670	1397	1437329866000	169	101	1	0	\N
61671	1397	1437319865000	169	101	2	0	\N
61672	1397	1437309864000	169	101	3	0	\N
61674	1397	1437299863000	171	102	0	0	\N
61677	1397	1437289862000	173	103	0	0	\N
61678	1397	1437279861000	173	103	1	0	\N
61679	1397	1437269860000	174	104	0	0	\N
61680	1397	1437269860000	175	104	0	0	\N
61682	1397	1437259859000	177	105	0	0	\N
61686	1397	1437229856000	181	108	0	0	\N
61691	1397	1437189852000	185	111	0	0	\N
61692	1397	1437179851000	185	111	2	0	\N
61693	1397	1437169850000	185	111	3	0	\N
61697	1397	1437159849000	187	112	0	0	\N
61698	1397	1437149848000	187	112	1	0	\N
61701	1397	1437139847000	189	113	0	0	\N
61703	1397	1437139847000	191	113	0	0	\N
61705	1397	1437129846000	194	115	0	0	\N
61706	1397	1437129846000	195	115	0	0	\N
61709	1397	1437109844000	198	117	0	0	\N
61710	1397	1437109844000	199	117	0	0	\N
61711	1397	1437099843000	200	118	0	0	\N
61715	1397	1437069840000	203	120	0	0	\N
61718	1397	1437059839000	206	121	0	0	\N
61719	1397	1437059839000	207	121	0	0	\N
61721	1397	1437049838000	209	122	0	0	\N
61724	1397	1437039837000	211	123	0	0	\N
61725	1397	1437029836000	211	123	1	0	\N
61726	1397	1437019835000	212	124	0	0	\N
61736	1397	1436939827000	219	130	0	0	\N
61739	1397	1436929826000	222	131	0	0	\N
61741	1397	1436919825000	224	132	0	0	\N
61743	1397	1436899823000	226	134	0	0	\N
61615	1397	1437639897000	140	82	0	0	120
61616	1397	1437629896000	140	82	1	0	121
61617	1397	1437619895000	141	83	0	0	122
61619	1397	1437609894000	143	84	0	0	123
61620	1397	1437599893000	144	85	0	0	124
61623	1397	1437579891000	147	87	0	0	126
61624	1397	1437569890000	148	88	0	0	127
61627	1397	1437559889000	150	89	0	0	128
61628	1397	1437549888000	150	89	1	0	129
61631	1397	1437539887000	152	90	0	0	130
61634	1397	1437519885000	155	92	0	0	132
61635	1397	1437509884000	156	93	0	0	133
61636	1397	1437499883000	156	93	1	0	134
61641	1397	1437489882000	158	94	0	0	135
61643	1397	1437469880000	158	94	2	0	137
61644	1397	1437459879000	158	94	3	0	138
61645	1397	1437449878000	159	95	0	0	139
61646	1397	1437439877000	159	95	1	0	140
61647	1397	1437429876000	159	95	2	0	141
61651	1397	1437409874000	161	96	1	0	143
61654	1397	1437399873000	163	97	0	0	144
61655	1397	1437389872000	163	97	1	0	145
61656	1397	1437379871000	164	98	0	0	146
61657	1397	1437369870000	165	99	0	0	147
61659	1397	1437349868000	165	99	2	0	149
61660	1397	1437339867000	166	100	0	0	150
61661	1705	716910000000	167	101	0	0	1
61662	1397	1437329866000	167	101	1	0	151
61664	1397	1437309864000	167	101	3	0	153
61673	1397	1437299863000	170	102	0	0	154
61675	1397	1437289862000	172	103	0	0	155
61676	1397	1437279861000	172	103	1	0	156
61681	1397	1437269860000	176	104	0	0	157
61684	1397	1437249858000	179	106	0	0	159
61685	1397	1437239857000	180	107	0	0	160
61687	1397	1437229856000	182	108	0	0	161
61688	1397	1437219855000	183	109	0	0	162
61689	1397	1437209854000	184	110	0	0	163
61694	1397	1437189852000	186	111	0	0	165
61695	1397	1437179851000	186	111	2	0	166
61696	1397	1437169850000	186	111	3	0	167
61699	1397	1437159849000	188	112	0	0	168
61702	1397	1437139847000	190	113	0	0	170
61704	1397	1437129846000	193	115	0	0	171
61707	1397	1437119845000	196	116	0	0	172
61708	1397	1437109844000	197	117	0	0	173
61712	1397	1437099843000	201	118	0	0	174
61714	1397	1437079841000	202	119	1	0	176
61716	1397	1437069840000	204	120	0	0	177
61717	1397	1437059839000	205	121	0	0	178
61720	1397	1437049838000	208	122	0	0	179
61722	1397	1437039837000	210	123	0	0	180
61727	1397	1437019835000	213	124	0	0	182
61728	1397	1437009834000	214	125	0	0	183
61729	1397	1436999833000	215	126	0	0	184
61730	1397	1436989832000	215	126	1	0	185
61732	1397	1436979831000	216	127	1	0	186
61733	1397	1436969830000	216	127	2	0	187
61734	1397	1436959829000	217	128	0	0	188
61735	1397	1436949828000	218	129	0	0	189
61737	1397	1436939827000	220	130	0	0	190
61740	1397	1436919825000	223	132	0	0	192
61742	1397	1436909824000	225	133	0	0	193
61744	1397	1436899823000	227	134	0	0	194
61745	1703	719010000000	228	135	0	0	\N
61746	1397	1436889822000	228	135	1	0	\N
61751	1397	1436869820000	231	137	0	0	\N
61754	1397	1436859819000	234	138	0	0	\N
61761	1397	1436809814000	238	141	0	0	\N
61762	1397	1436799813000	238	141	1	0	\N
61763	1397	1436809814000	239	141	0	0	\N
61764	1397	1436799813000	239	141	1	0	\N
61765	1397	1436789812000	240	142	0	0	\N
61767	1397	1436779811000	242	143	0	0	\N
61769	1397	1436769810000	244	144	0	0	\N
61771	1712	7890000000	246	145	0	0	\N
61772	1397	1436759809000	246	145	1	0	\N
61773	1397	1436749808000	246	145	2	0	\N
61774	1397	1436739807000	246	145	3	0	\N
61779	1397	1436729806000	248	146	0	0	\N
61780	1397	1436719805000	248	146	1	0	\N
61793	1397	1436619795000	258	152	0	0	\N
61795	1397	1436619795000	260	152	0	0	\N
61796	1397	1436619795000	261	152	0	0	\N
61797	1397	1436609794000	262	153	0	0	\N
61798	1397	1436609794000	263	153	0	0	\N
61805	1397	1436579791000	267	155	0	0	\N
61806	1397	1436569790000	267	155	1	0	\N
61807	1694	2158979000000	267	155	2	0	\N
61808	1397	1436559789000	268	156	0	0	\N
61812	1397	1436539787000	272	158	0	0	\N
61813	1397	1436529786000	273	159	0	0	\N
61815	1397	1436529786000	275	159	0	0	\N
61816	1397	1436519785000	276	160	0	0	\N
61818	1397	1436509784000	278	161	0	0	\N
61822	1397	1436489782000	283	163	0	0	\N
61823	1397	1436479781000	284	164	0	0	\N
61824	1397	1436479781000	285	164	0	0	\N
61826	1397	1436479781000	287	164	0	0	\N
61828	1397	1436469780000	289	165	0	0	\N
61833	1397	1436429776000	293	168	0	0	\N
61840	1397	1436389772000	297	171	0	0	\N
61841	1397	1436379771000	297	171	1	0	\N
61842	1397	1436369770000	297	171	2	0	\N
61843	1397	1436389772000	298	171	0	0	\N
61844	1397	1436379771000	298	171	1	0	\N
61845	1397	1436369770000	298	171	2	0	\N
61847	1397	1436349768000	300	173	0	0	\N
61849	1397	1436349768000	302	173	0	0	\N
61860	1397	1436279761000	306	176	0	0	\N
61861	1504	516969000000	306	176	1	0	\N
61862	1397	1436279761000	307	176	0	0	\N
61863	1504	516969000000	307	176	1	0	\N
61866	1397	1436249758000	310	179	0	0	\N
61872	1397	1436229756000	314	181	0	0	\N
61873	1397	1436219755000	314	181	1	0	\N
61874	1397	1436229756000	315	181	0	0	\N
61875	1397	1436219755000	315	181	1	0	\N
61877	1397	1436199753000	317	183	0	0	\N
61878	1504	416968000000	317	183	1	0	\N
61749	1397	1436879821000	230	136	0	0	196
61750	1682	710010000000	230	136	1	0	1
61752	1397	1436869820000	232	137	0	0	197
61753	1397	1436859819000	233	138	0	0	198
61755	1397	1436849818000	235	139	0	0	199
61757	1397	1436829816000	236	140	0	0	201
61758	1397	1436819815000	236	140	1	0	202
61759	1397	1436809814000	237	141	0	0	203
61760	1397	1436799813000	237	141	1	0	204
61766	1397	1436789812000	241	142	0	0	205
61770	1397	1436769810000	245	144	0	0	207
61775	1712	7890000000	247	145	0	0	1
61776	1397	1436759809000	247	145	1	0	208
61777	1397	1436749808000	247	145	2	0	209
61781	1397	1436729806000	249	146	0	0	211
61782	1397	1436719805000	249	146	1	0	212
61783	1397	1436709804000	250	147	0	0	213
61784	1397	1436699803000	250	147	1	0	214
61785	1397	1436689802000	250	147	2	0	215
61787	1397	1436679801000	255	149	1	0	216
61788	1397	1436669800000	255	149	2	0	217
61789	1397	1436659799000	255	149	3	0	218
61790	1397	1436649798000	255	149	4	0	219
61791	1397	1436639797000	256	150	0	0	220
61794	1397	1436619795000	259	152	0	0	222
61799	1397	1436609794000	265	154	0	0	223
61800	1397	1436599793000	265	154	1	0	224
61801	1397	1436589792000	265	154	2	0	225
61803	1397	1436569790000	266	155	1	0	227
61804	1694	2158979000000	266	155	2	0	1
61809	1397	1436559789000	269	156	0	0	228
61810	1397	1436549788000	270	157	0	0	229
61811	1397	1436539787000	271	158	0	0	230
61817	1397	1436519785000	277	160	0	0	232
61819	1397	1436509784000	279	161	0	0	233
61820	1397	1436499783000	281	162	0	0	234
61821	1397	1436489782000	282	163	0	0	235
61825	1397	1436479781000	286	164	0	0	236
61829	1397	1436459779000	290	166	0	0	238
61830	1397	1436449778000	290	166	1	0	239
61831	1397	1436439777000	291	167	0	0	240
61832	1397	1436429776000	292	168	0	0	241
61835	1397	1436409774000	295	170	0	0	243
61836	1397	1436399773000	295	170	1	0	244
61837	1397	1436389772000	296	171	0	0	245
61838	1397	1436379771000	296	171	1	0	246
61839	1397	1436369770000	296	171	2	0	247
61848	1397	1436349768000	301	173	0	0	249
61850	1504	716980000000	303	174	0	0	3
61851	1397	1436339767000	303	174	1	0	250
61852	1397	1436329766000	303	174	2	0	251
61853	1397	1436319765000	304	175	0	0	252
61855	1397	1436309764000	304	175	2	0	253
61856	1397	1436299763000	304	175	3	0	254
61857	1397	1436289762000	304	175	4	0	255
61858	1397	1436279761000	305	176	0	0	256
61864	1397	1436269760000	308	177	0	0	257
61865	1397	1436259759000	309	178	0	0	258
61867	1397	1436249758000	311	179	0	0	259
61868	1695	2158950000000	312	180	0	0	1
61869	1397	1436239757000	312	180	1	0	260
61871	1397	1436219755000	313	181	1	0	262
61876	1397	1436209754000	316	182	0	0	263
61879	1397	1436199753000	318	183	0	0	264
61880	1504	416968000000	318	183	1	0	6
61881	1397	1436199753000	319	183	0	0	\N
61882	1504	416968000000	319	183	1	0	\N
61884	1397	1436189752000	321	184	0	0	\N
61888	1397	1436149748000	324	187	0	0	\N
61889	1397	1436139747000	324	187	1	0	\N
61892	1397	1436149748000	326	187	0	0	\N
61893	1397	1436139747000	326	187	1	0	\N
61897	1397	1436109744000	329	189	0	0	\N
61900	1397	1436089742000	332	191	0	0	\N
61901	1397	1436089742000	333	191	0	0	\N
61902	1397	1436079741000	334	192	0	0	\N
61904	1397	1436069740000	336	193	0	0	\N
61905	1397	1436059739000	336	193	1	0	\N
61906	1397	1436069740000	337	193	0	0	\N
61907	1397	1436059739000	337	193	1	0	\N
61911	1397	1436049738000	340	194	0	0	\N
61912	1397	1436039737000	341	195	0	0	\N
61913	1397	1436029736000	341	195	1	0	\N
61917	1397	1436009734000	344	197	0	0	\N
61918	1397	1435999733000	344	197	1	0	\N
61919	1504	316967000000	344	197	2	0	\N
61923	1397	1436009734000	346	197	0	0	\N
61924	1397	1435999733000	346	197	1	0	\N
61925	1504	316967000000	346	197	2	0	\N
61931	1397	1435959729000	350	201	0	0	\N
61933	1397	1435959729000	353	201	0	0	\N
61934	1682	1430110000000	354	202	0	0	\N
61935	1397	1435949728000	354	202	1	0	\N
61936	1397	1435939727000	354	202	2	0	\N
61940	1682	1428100000000	356	203	0	0	\N
61941	1397	1435929726000	356	203	1	0	\N
61942	1397	1435919725000	356	203	2	0	\N
61952	1397	1435879721000	360	205	0	0	\N
61953	1397	1435869720000	360	205	1	0	\N
61957	1682	1427090000000	363	207	0	0	\N
61958	1397	1435839717000	364	208	0	0	\N
61960	1397	1435829716000	366	209	0	0	\N
61961	1397	1435819715000	366	209	1	0	\N
61964	1397	1435829716000	368	209	0	0	\N
61965	1397	1435819715000	368	209	1	0	\N
61966	1397	1435809714000	369	210	0	0	\N
61967	1397	1435799713000	369	210	1	0	\N
61973	1397	1435769710000	373	213	0	0	\N
61974	1397	1435769710000	374	213	0	0	\N
61975	1397	1435769710000	375	213	0	0	\N
61977	1397	1435769710000	377	213	0	0	\N
61986	1397	1435709704000	383	218	0	0	\N
61987	1397	1435709704000	384	218	0	0	\N
61994	1397	1435669700000	387	221	0	0	\N
61995	1722	2153990000000	387	221	1	0	\N
61998	1397	1435669700000	389	221	0	0	\N
61999	1722	2153990000000	389	221	1	0	\N
62001	1397	1435649698000	391	223	0	0	\N
62005	1397	1435629696000	395	225	0	0	\N
62008	1397	1435619695000	397	226	0	0	\N
62009	1397	1435609694000	397	226	1	0	\N
62010	1397	1435619695000	398	226	0	0	\N
62011	1397	1435609694000	398	226	1	0	\N
62012	1397	1435599693000	399	227	0	0	\N
62013	1397	1435589692000	399	227	1	0	\N
62014	1397	1435579691000	399	227	2	0	\N
62015	1397	1435599693000	400	227	0	0	\N
62016	1397	1435589692000	400	227	1	0	\N
61886	1397	1436169750000	322	185	1	0	267
61887	1397	1436159749000	323	186	0	0	268
61890	1397	1436149748000	325	187	0	0	269
61891	1397	1436139747000	325	187	1	0	270
61894	1397	1436129746000	327	188	0	0	271
61896	1397	1436109744000	328	189	0	0	273
61898	1397	1436099743000	330	190	0	0	274
61899	1397	1436089742000	331	191	0	0	275
61903	1397	1436079741000	335	192	0	0	276
61908	1397	1436069740000	338	193	0	0	277
61910	1397	1436049738000	339	194	0	0	279
61914	1397	1436039737000	342	195	0	0	280
61915	1397	1436029736000	342	195	1	0	281
61916	1397	1436019735000	343	196	0	0	282
61921	1397	1435999733000	345	197	1	0	284
61922	1504	316967000000	345	197	2	0	7
61926	1397	1435989732000	347	198	0	0	285
61927	1397	1435979731000	348	199	0	0	286
61928	1397	1435969730000	349	200	0	0	287
61930	1613	718000000000	349	200	2	0	2
61932	1397	1435959729000	351	201	0	0	288
61937	1682	1430110000000	355	202	0	0	2
61938	1397	1435949728000	355	202	1	0	289
61939	1397	1435939727000	355	202	2	0	290
61944	1397	1435929726000	357	203	1	0	291
61945	1397	1435919725000	357	203	2	0	292
61946	622	66001980000000	358	204	0	0	1
61947	1397	1435909724000	358	204	1	0	293
61949	1397	1435889722000	358	204	3	0	295
61950	1397	1435879721000	359	205	0	0	296
61951	1397	1435869720000	359	205	1	0	297
61954	1397	1435859719000	361	206	0	0	298
61955	1682	1427090000000	362	207	0	0	4
61959	1397	1435839717000	365	208	0	0	300
61962	1397	1435829716000	367	209	0	0	301
61963	1397	1435819715000	367	209	1	0	302
61968	1397	1435809714000	370	210	0	0	303
61969	1397	1435799713000	370	210	1	0	304
61971	1397	1435789712000	371	211	1	0	305
61972	1397	1435779711000	372	212	0	0	306
61976	1397	1435769710000	376	213	0	0	307
61978	1397	1435759709000	378	214	0	0	308
61980	1397	1435739707000	379	215	1	0	310
61981	1652	719010000000	379	215	2	0	1
61982	1652	718500000000	379	215	3	0	2
61983	1397	1435729706000	380	216	0	0	311
61984	1397	1435719705000	381	217	0	0	312
61988	1397	1435699703000	385	219	0	0	314
61989	1397	1435689702000	385	219	2	0	315
61990	1624	2000000000	385	219	3	0	1
61991	1577	2000000000	385	219	4	0	1
61992	1652	490000000	385	219	5	0	3
61996	1397	1435669700000	388	221	0	0	317
61997	1722	2153990000000	388	221	1	0	1
62000	1397	1435659699000	390	222	0	0	318
62002	1397	1435649698000	392	223	0	0	319
62004	1397	1435629696000	394	225	0	0	321
62006	1397	1435619695000	396	226	0	0	322
62007	1397	1435609694000	396	226	1	0	323
62017	1397	1435579691000	400	227	2	0	\N
62025	1397	1435529686000	404	230	0	0	\N
62026	443	66000490000000	404	230	1	0	\N
62027	1397	1435529686000	405	230	0	0	\N
62028	443	66000490000000	405	230	1	0	\N
62033	1397	1435499683000	409	233	0	0	\N
62036	1397	1435489682000	412	234	0	0	\N
62040	1397	1435449678000	415	237	0	0	\N
62041	1397	1435439677000	415	237	1	0	\N
62046	1693	2877970000000	418	239	0	0	\N
62047	1693	2876860000000	418	239	1	0	\N
62048	1397	1435409674000	418	239	2	0	\N
62055	1693	2876750000000	421	240	0	0	\N
62056	1693	2876640000000	421	240	1	0	\N
62057	1397	1435399673000	421	240	2	0	\N
62058	1397	1435389672000	422	241	0	0	\N
62061	1397	1435379671000	425	242	0	0	\N
62062	1397	1435379671000	426	242	0	0	\N
62064	1397	1435359669000	428	244	0	0	\N
62067	1397	1435349668000	431	245	0	0	\N
62068	1397	1435349668000	432	245	0	0	\N
62071	1693	2876530000000	434	246	0	0	\N
62072	1397	1435339667000	434	246	1	0	\N
62073	1397	1435329666000	435	247	0	0	\N
62075	1397	1435319665000	437	248	0	0	\N
62077	1397	1435319665000	439	248	0	0	\N
62078	1397	1435309664000	440	249	0	0	\N
62079	1397	1435299663000	440	249	1	0	\N
62080	1701	2158770000000	440	249	2	0	\N
62081	1397	1435309664000	441	249	0	0	\N
62082	1397	1435299663000	441	249	1	0	\N
62083	1701	2158770000000	441	249	2	0	\N
62084	1397	1435309664000	442	249	0	0	\N
62085	1397	1435299663000	442	249	1	0	\N
62086	1701	2158770000000	442	249	2	0	\N
62090	1397	1435309664000	444	249	0	0	\N
62091	1397	1435299663000	444	249	1	0	\N
62092	1701	2158770000000	444	249	2	0	\N
62093	1397	1435309664000	445	249	0	0	\N
62094	1397	1435299663000	445	249	1	0	\N
62095	1701	2158770000000	445	249	2	0	\N
62103	1397	1435229656000	451	255	0	0	\N
62104	1397	1435229656000	452	255	0	0	\N
62108	1397	1435219655000	455	256	0	0	\N
62109	1397	1435209654000	455	256	1	0	\N
62110	1397	1435199653000	456	257	0	0	\N
62112	1397	1435199653000	458	257	0	0	\N
62113	1397	1435199653000	459	257	0	0	\N
62115	1397	1435189652000	461	258	0	0	\N
62117	1397	1435169650000	463	260	0	0	\N
62120	1397	1435149648000	466	262	0	0	\N
62122	1397	1435149648000	468	262	0	0	\N
62127	1397	1435139647000	470	263	0	0	\N
62128	1397	1435129646000	470	263	1	0	\N
62129	1397	1435119645000	470	263	2	0	\N
62130	1397	1435109644000	470	263	3	0	\N
62131	1397	1435099643000	471	264	0	0	\N
62133	1397	1435089642000	473	265	0	0	\N
62134	1397	1435079641000	473	265	1	0	\N
62135	1397	1435069640000	473	265	2	0	\N
62136	1397	1435089642000	474	265	0	0	\N
62137	1397	1435079641000	474	265	1	0	\N
62138	1397	1435069640000	474	265	2	0	\N
62142	1397	1435089642000	476	265	0	0	\N
62143	1397	1435079641000	476	265	1	0	\N
62144	1397	1435069640000	476	265	2	0	\N
62149	1686	1437930000000	479	267	0	0	\N
62150	1397	1435049638000	479	267	1	0	\N
62020	1397	1435579691000	401	227	2	0	326
62021	1397	1435569690000	402	228	0	0	327
62022	1397	1435559689000	402	228	1	0	328
62023	1397	1435549688000	403	229	0	0	329
62024	1397	1435539687000	403	229	1	0	330
62030	443	66000490000000	406	230	1	0	1
62031	1397	1435519685000	407	231	0	0	332
62032	1397	1435509684000	408	232	0	0	333
62034	1397	1435499683000	410	233	0	0	334
62035	1397	1435489682000	411	234	0	0	335
62038	1397	1435469680000	413	235	1	0	337
62039	1397	1435459679000	414	236	0	0	338
62042	1397	1435449678000	416	237	0	0	339
62043	1397	1435439677000	416	237	1	0	340
62045	1397	1435419675000	417	238	1	0	342
62049	1693	2877970000000	419	239	0	0	1
62050	1693	2876860000000	419	239	1	0	2
62051	1397	1435409674000	419	239	2	0	343
62052	1693	2876750000000	420	240	0	0	3
62054	1397	1435399673000	420	240	2	0	344
62059	1397	1435389672000	423	241	0	0	345
62060	1397	1435379671000	424	242	0	0	346
62063	1397	1435369670000	427	243	0	0	347
62065	1397	1435359669000	429	244	0	0	348
62069	1693	2876530000000	433	246	0	0	5
62070	1397	1435339667000	433	246	1	0	350
62074	1397	1435329666000	436	247	0	0	351
62076	1397	1435319665000	438	248	0	0	352
62088	1397	1435299663000	443	249	1	0	354
62089	1701	2158770000000	443	249	2	0	2
62096	1397	1435289662000	446	250	0	0	355
62097	379	66000090000000	446	250	1	0	1
62098	1397	1435279661000	447	251	0	0	356
62100	1397	1435259659000	449	253	0	0	358
62101	1397	1435249658000	450	254	0	0	359
62102	1397	1435239657000	450	254	2	0	360
62105	1397	1435229656000	453	255	0	0	361
62106	1397	1435219655000	454	256	0	0	362
62111	1397	1435199653000	457	257	0	0	364
62114	1397	1435189652000	460	258	0	0	365
62116	1397	1435179651000	462	259	0	0	366
62118	1397	1435169650000	464	260	0	0	367
62121	1397	1435149648000	467	262	0	0	369
62123	1397	1435139647000	469	263	0	0	370
62124	1397	1435129646000	469	263	1	0	371
62125	1397	1435119645000	469	263	2	0	372
62126	1397	1435109644000	469	263	3	0	373
62139	1397	1435089642000	475	265	0	0	375
62140	1397	1435079641000	475	265	1	0	376
62141	1397	1435069640000	475	265	2	0	377
62145	1397	1435059639000	477	266	0	0	378
62146	1699	2159049000000	477	266	1	0	1
62148	1397	1435049638000	478	267	1	0	379
62151	1397	1435039637000	480	268	0	0	380
62152	1397	1435029636000	481	269	0	0	381
62154	1397	1435019635000	483	270	0	0	\N
62155	1397	1435009634000	484	271	0	0	\N
62156	1397	1435009634000	485	271	0	0	\N
62157	1397	1435009634000	486	271	0	0	\N
62158	1397	1435009634000	487	271	0	0	\N
62160	1397	1434999633000	489	272	0	0	\N
62161	1397	1434989632000	489	272	1	0	\N
62162	1397	1434979631000	489	272	2	0	\N
62167	1397	1434969630000	492	273	0	0	\N
62169	1397	1434959629000	494	274	0	0	\N
62179	1397	1434869620000	500	280	0	0	\N
62187	1397	1434819615000	505	284	0	0	\N
62188	1397	1434809614000	505	284	1	0	\N
62189	1397	1434799613000	505	284	2	0	\N
62190	1397	1434819615000	506	284	0	0	\N
62191	1397	1434809614000	506	284	1	0	\N
62192	1397	1434799613000	506	284	2	0	\N
62196	1397	1434789612000	508	285	0	0	\N
62198	1397	1434779611000	510	286	0	0	\N
62199	1397	1434779611000	511	286	0	0	\N
62206	1397	1434729606000	515	288	0	0	\N
62210	1397	1434689602000	518	291	0	0	\N
62211	1397	1434679601000	518	291	1	0	\N
62219	1701	2878490000000	521	292	0	0	\N
62220	1701	2878180000000	521	292	1	0	\N
62221	1397	1434669600000	521	292	2	0	\N
62222	1397	1434659599000	521	292	3	0	\N
62223	1397	1434649598000	521	292	4	0	\N
62231	1397	1434569590000	526	297	0	0	\N
62232	1712	3486000000	526	297	1	0	\N
62241	1397	1434509584000	534	303	0	0	\N
62242	1397	1434499583000	535	304	0	0	\N
62246	1397	1434489582000	538	305	0	0	\N
62247	1725	99000000	538	305	1	0	\N
62248	1397	1434489582000	539	305	0	0	\N
62249	1725	99000000	539	305	1	0	\N
62252	1397	1434469580000	542	307	0	0	\N
62253	1397	1434469580000	543	307	0	0	\N
62254	1397	1434459579000	544	308	0	0	\N
62256	1397	1434449578000	546	309	0	0	\N
62257	1397	1434439577000	546	309	1	0	\N
62258	1397	1434429576000	546	309	2	0	\N
62263	1397	1434409574000	549	311	0	0	\N
62267	1397	1434389572000	553	313	0	0	\N
62268	1397	1434389572000	554	313	0	0	\N
62269	1397	1434389572000	555	313	0	0	\N
62271	1397	1434379571000	557	314	0	0	\N
62276	1397	1434349568000	561	317	0	0	\N
62277	1397	1434339567000	561	317	1	0	\N
62278	1397	1434349568000	562	317	0	0	\N
62279	1397	1434339567000	562	317	1	0	\N
62281	1397	1434319565000	564	319	0	0	\N
62284	1397	1434309564000	567	320	0	0	\N
62285	1397	1434299563000	568	321	0	0	\N
62163	1397	1434999633000	490	272	0	0	384
62164	1397	1434989632000	490	272	1	0	385
62165	1397	1434979631000	490	272	2	0	386
62166	1397	1434969630000	491	273	0	0	387
62168	1397	1434959629000	493	274	0	0	388
62171	1397	1434939627000	495	275	1	0	390
62172	1397	1434929626000	495	275	2	0	391
62173	1397	1434919625000	496	276	0	0	392
62174	1397	1434909624000	497	277	0	0	393
62175	1397	1434899623000	497	277	1	0	394
62177	1712	6789000000	498	278	1	0	2
62178	1397	1434879621000	499	279	0	0	396
62180	1397	1434869620000	501	280	0	0	397
62181	1397	1434859619000	502	281	0	0	398
62183	1397	1434839617000	503	282	0	0	400
62184	1712	5688000000	503	282	1	0	3
62185	1712	4587000000	503	282	2	0	4
62186	1397	1434829616000	504	283	0	0	401
62193	1397	1434819615000	507	284	0	0	402
62195	1397	1434799613000	507	284	2	0	404
62197	1397	1434789612000	509	285	0	0	405
62200	1397	1434779611000	512	286	0	0	406
62201	1397	1434769610000	513	287	0	0	407
62202	1397	1434759609000	513	287	1	0	408
62204	1397	1434739607000	513	287	3	0	410
62205	1397	1434729606000	514	288	0	0	411
62207	1397	1434719605000	517	290	0	0	412
62208	1397	1434709604000	517	290	1	0	413
62212	1397	1434689602000	519	291	0	0	415
62213	1397	1434679601000	519	291	1	0	416
62214	1701	2878490000000	520	292	0	0	3
62215	1701	2878180000000	520	292	1	0	4
62216	1397	1434669600000	520	292	2	0	417
62218	1397	1434649598000	520	292	4	0	419
62224	1397	1434639597000	522	293	0	0	420
62225	1397	1434629596000	522	293	1	0	421
62226	1397	1434619595000	523	294	0	0	422
62227	1397	1434609594000	523	294	1	0	423
62229	1397	1434589592000	524	295	0	0	425
62230	1397	1434579591000	525	296	0	0	426
62233	1397	1434569590000	527	297	0	0	427
62234	1712	3486000000	527	297	1	0	5
62236	1397	1434549588000	529	299	0	0	429
62237	1397	1434539587000	530	300	0	0	430
62238	1397	1434529586000	531	301	0	0	431
62239	1397	1434519585000	532	302	0	0	432
62240	1397	1434509584000	533	303	0	0	433
62244	1397	1434489582000	537	305	0	0	435
62245	1725	99000000	537	305	1	0	1
62250	1397	1434479581000	540	306	0	0	436
62251	1397	1434469580000	541	307	0	0	437
62255	1397	1434459579000	545	308	0	0	438
62260	1397	1434439577000	547	309	1	0	440
62261	1397	1434429576000	547	309	2	0	441
62262	1397	1434419575000	548	310	0	0	442
62264	1397	1434409574000	550	311	0	0	443
62266	1397	1434389572000	552	313	0	0	445
62270	1397	1434379571000	556	314	0	0	446
62272	1397	1434369570000	558	315	0	0	447
62273	1397	1434359569000	559	316	0	0	448
62274	1397	1434349568000	560	317	0	0	449
62280	1397	1434329566000	563	318	0	0	451
62282	1397	1434319565000	565	319	0	0	452
62283	1397	1434309564000	566	320	0	0	453
62286	1397	1434299563000	569	321	0	0	454
62287	1397	1434289562000	570	322	0	0	455
62289	1397	1434269560000	572	324	0	0	\N
62291	1397	1434269560000	574	324	0	0	\N
62292	1397	1434269560000	575	324	0	0	\N
62293	1397	1434259559000	576	325	0	0	\N
62294	1397	1434249558000	576	325	1	0	\N
62295	1397	1434239557000	576	325	2	0	\N
62304	886	63455151096354	580	327	0	0	\N
62305	1397	1434219555000	580	327	1	0	\N
62306	1397	1434209554000	580	327	2	0	\N
62310	1397	1434179551000	584	330	0	0	\N
62311	1397	1434179551000	585	330	0	0	\N
62312	1397	1434169550000	586	331	0	0	\N
62321	1397	1434119545000	593	336	0	0	\N
62322	1397	1434119545000	594	336	0	0	\N
62327	1397	1434079541000	598	339	0	0	\N
62329	1397	1434059539000	600	341	0	0	\N
62331	1397	1434059539000	602	341	0	0	\N
62333	1397	1434049538000	604	342	0	0	\N
62334	1397	1434049538000	605	342	0	0	\N
62335	1397	1434039537000	606	343	0	0	\N
62337	1397	1434039537000	608	343	0	0	\N
62338	1397	1434029536000	609	344	0	0	\N
62340	1397	1434019535000	611	345	0	0	\N
62341	1397	1434019535000	612	345	0	0	\N
62343	1397	1434009534000	614	346	0	0	\N
62345	1397	1434009534000	616	346	0	0	\N
62346	1397	1433999533000	617	347	0	0	\N
62354	1397	1433949528000	625	351	0	0	\N
62355	1397	1433939527000	625	351	1	0	\N
62356	1397	1433949528000	626	351	0	0	\N
62357	1397	1433939527000	626	351	1	0	\N
62360	1397	1433909524000	628	353	0	0	\N
62361	1397	1433909524000	629	353	0	0	\N
62364	1397	1433899523000	632	354	0	0	\N
62367	1397	1433879521000	635	356	0	0	\N
62368	1397	1433879521000	636	356	0	0	\N
62371	1397	1433849518000	639	359	0	0	\N
62373	1397	1433839517000	641	360	0	0	\N
62374	1397	1433839517000	642	360	0	0	\N
62377	1397	1433819515000	645	362	0	0	\N
62378	1397	1433809514000	645	362	1	0	\N
62383	1397	1433779511000	648	364	0	0	\N
62385	1397	1433779511000	650	364	0	0	\N
62386	1681	3599110000000	651	365	0	0	\N
62387	1397	1433769510000	651	365	1	0	\N
62388	1397	1433759509000	651	365	3	0	\N
62389	1397	1433749508000	651	365	4	0	\N
62390	1681	3599110000000	652	365	0	0	\N
62391	1397	1433769510000	652	365	1	0	\N
62392	1397	1433759509000	652	365	3	0	\N
62393	1397	1433749508000	652	365	4	0	\N
62394	1681	3599110000000	653	365	0	0	\N
62395	1397	1433769510000	653	365	1	0	\N
62396	1397	1433759509000	653	365	3	0	\N
62397	1397	1433749508000	653	365	4	0	\N
62404	1397	1433739507000	656	366	0	0	\N
62405	1397	1433729506000	656	366	1	0	\N
62406	1397	1433739507000	657	366	0	0	\N
62407	1397	1433729506000	657	366	1	0	\N
62409	1397	1433719505000	659	367	0	0	\N
62410	1397	1433709504000	660	368	0	0	\N
62411	1397	1433699503000	660	368	1	0	\N
62412	1397	1433689502000	660	368	2	0	\N
62413	1397	1433679501000	660	368	3	0	\N
62414	1397	1433709504000	661	368	0	0	\N
62415	1397	1433699503000	661	368	1	0	\N
62416	1397	1433689502000	661	368	2	0	\N
62417	1397	1433679501000	661	368	3	0	\N
62422	1397	1433669500000	663	369	0	0	\N
62297	1397	1434249558000	577	325	1	0	459
62298	1397	1434239557000	577	325	2	0	460
62299	1397	1434229556000	578	326	0	0	461
62300	885	63455151096354	578	326	1	0	1
62301	886	63455151096354	579	327	0	0	1
62303	1397	1434209554000	579	327	2	0	463
62307	1397	1434199553000	581	328	0	0	464
62308	1397	1434189552000	582	329	0	0	465
62309	1397	1434179551000	583	330	0	0	466
62313	1397	1434169550000	587	331	0	0	467
62315	1397	1434149548000	589	333	0	0	469
62316	1397	1434139547000	590	334	0	0	470
62317	1714	718910000000	591	335	0	0	1
62318	1706	717910000000	591	335	1	0	1
62320	1397	1434119545000	592	336	0	0	472
62323	1397	1434109544000	595	337	0	0	473
62324	1397	1434099543000	596	338	0	0	474
62325	1397	1434089542000	596	338	1	0	475
62326	1397	1434079541000	597	339	0	0	476
62330	1397	1434059539000	601	341	0	0	478
62332	1397	1434049538000	603	342	0	0	479
62336	1397	1434039537000	607	343	0	0	480
62339	1397	1434029536000	610	344	0	0	481
62342	1397	1434019535000	613	345	0	0	482
62347	1397	1433999533000	618	347	0	0	484
62348	1397	1433989532000	619	348	0	0	485
62349	1397	1433979531000	622	349	0	0	486
62350	1397	1433969530000	622	349	1	0	487
62352	1397	1433949528000	624	351	0	0	489
62353	1397	1433939527000	624	351	1	0	490
62358	1397	1433929526000	627	352	0	0	491
62359	1397	1433919525000	627	352	1	0	492
62362	1397	1433909524000	630	353	0	0	493
62365	1397	1433889522000	633	355	0	0	495
62366	1397	1433879521000	634	356	0	0	496
62369	1397	1433869520000	637	357	0	0	497
62370	1397	1433859519000	638	358	0	0	498
62372	1397	1433849518000	640	359	0	0	499
62376	1397	1433829516000	644	361	0	0	501
62379	1397	1433819515000	646	362	0	0	502
62380	1397	1433809514000	646	362	1	0	503
62381	1397	1433799513000	647	363	0	0	504
62384	1397	1433779511000	649	364	0	0	506
62398	1681	3599110000000	654	365	0	0	1
62399	1397	1433769510000	654	365	1	0	507
62400	1397	1433759509000	654	365	3	0	508
62401	1397	1433749508000	654	365	4	0	509
62403	1397	1433729506000	655	366	1	0	511
62408	1397	1433719505000	658	367	0	0	512
62418	1397	1433709504000	662	368	0	0	513
62419	1397	1433699503000	662	368	1	0	514
62420	1397	1433689502000	662	368	2	0	515
62423	1397	1433669500000	664	369	0	0	517
62424	1397	1433659499000	665	370	0	0	518
62425	1397	1433659499000	666	370	0	0	\N
62427	1397	1433649498000	668	371	0	0	\N
62436	1397	1433559489000	671	374	0	0	\N
62439	1397	1433539487000	674	376	0	0	\N
62447	1397	1433479481000	678	378	0	0	\N
62448	1724	718760000000	679	379	0	0	\N
62449	1397	1433469480000	679	379	1	0	\N
62455	1397	1433439477000	683	382	0	0	\N
62458	1397	1433429476000	686	383	0	0	\N
62459	1397	1433419475000	687	384	0	0	\N
62460	1397	1433409474000	687	384	1	0	\N
62463	1397	1433399473000	689	385	0	0	\N
62465	1397	1433399473000	691	385	0	0	\N
62466	1397	1433399473000	692	385	0	0	\N
62469	1397	1433379471000	695	387	0	0	\N
62470	1397	1433379471000	696	387	0	0	\N
62471	1397	1433369470000	697	388	0	0	\N
62472	1397	1433359469000	697	388	1	0	\N
62478	1397	1433329466000	701	390	0	0	\N
62479	1397	1433319465000	702	391	0	0	\N
62480	1397	1433309464000	702	391	1	0	\N
62481	1397	1433299463000	702	391	2	0	\N
62494	1397	1433209454000	710	397	0	0	\N
62495	1397	1433199453000	711	398	0	0	\N
62496	1724	718760000000	712	332	0	0	\N
62497	1724	718510000000	712	332	1	0	\N
62498	1714	718910000000	712	332	2	0	\N
62499	1706	717910000000	712	332	3	0	\N
62500	1681	3599110000000	712	332	4	0	\N
62501	1724	718760000000	713	334	0	0	\N
62502	1724	718510000000	713	334	1	0	\N
62503	1681	3599110000000	713	334	2	0	\N
62513	886	63455051096354	720	402	0	0	\N
62514	1397	1433129446000	720	402	1	0	\N
62519	1397	1433109444000	723	404	0	0	\N
62524	885	63455041096354	725	405	0	0	\N
62525	1397	1433099443000	725	405	1	0	\N
62526	1397	1433089442000	725	405	2	0	\N
62527	1397	1433079441000	725	405	3	0	\N
62529	1397	1433069440000	727	406	0	0	\N
62535	1397	1433019435000	732	410	0	0	\N
62536	1397	1433009434000	733	411	0	0	\N
62541	1397	1432969430000	737	414	0	0	\N
62542	1397	1432969430000	738	414	0	0	\N
62543	1397	1432969430000	739	414	0	0	\N
62551	1397	1432909424000	745	418	0	0	\N
62552	1397	1432909424000	746	418	0	0	\N
62554	1397	1432899423000	748	419	0	0	\N
62556	1397	1432889422000	750	420	0	0	\N
62557	1397	1432889422000	751	420	0	0	\N
62559	1397	1432879421000	753	421	0	0	\N
62560	1397	1432869420000	754	422	0	0	\N
62429	1397	1433629496000	669	372	1	0	521
62430	1397	1433619495000	670	373	0	0	522
62431	1397	1433609494000	670	373	1	0	523
62432	1397	1433599493000	670	373	2	0	524
62433	1397	1433589492000	670	373	3	0	525
62435	1397	1433569490000	670	373	5	0	527
62437	1397	1433559489000	672	374	0	0	528
62438	1397	1433549488000	673	375	0	0	529
62440	1397	1433539487000	675	376	0	0	530
62441	1397	1433529486000	676	377	0	0	531
62443	1397	1433509484000	676	377	2	0	533
62444	1397	1433499483000	676	377	3	0	534
62445	1397	1433489482000	676	377	4	0	535
62446	1397	1433479481000	677	378	0	0	536
62451	1397	1433469480000	680	379	1	0	537
62452	1724	718510000000	681	380	0	0	2
62453	1397	1433459479000	681	380	1	0	538
62454	1397	1433449478000	682	381	0	0	539
62456	1397	1433439477000	684	382	0	0	540
62461	1397	1433419475000	688	384	0	0	542
62462	1397	1433409474000	688	384	1	0	543
62464	1397	1433399473000	690	385	0	0	544
62467	1397	1433389472000	693	386	0	0	545
62468	1397	1433379471000	694	387	0	0	546
62474	1397	1433359469000	698	388	1	0	548
62475	1397	1433349468000	699	389	0	0	549
62476	1397	1433339467000	699	389	1	0	550
62477	1397	1433329466000	700	390	0	0	551
62483	1397	1433309464000	703	391	1	0	553
62484	1397	1433299463000	703	391	2	0	554
62485	1397	1433289462000	704	392	0	0	555
62486	1397	1433279461000	704	392	1	0	556
62487	1397	1433269460000	705	393	0	0	557
62489	1397	1433249458000	707	395	0	0	559
62490	1397	1433239457000	707	395	1	0	560
62491	1397	1433229456000	707	395	2	0	561
62492	1397	1433219455000	708	396	0	0	562
62493	1397	1433209454000	709	397	0	0	563
62505	1397	1433189452000	717	400	0	0	565
62506	1397	1433179451000	717	400	1	0	566
62507	1397	1433169450000	717	400	2	0	567
62508	1397	1433159449000	718	401	0	0	568
62510	1397	1433139447000	718	401	2	0	570
62511	886	63455051096354	719	402	0	0	2
62512	1397	1433129446000	719	402	1	0	571
62515	885	63455051096354	721	403	0	0	2
62516	1397	1433119445000	721	403	1	0	572
62518	1397	1433109444000	722	404	0	0	573
62520	885	63455041096354	724	405	0	0	3
62521	1397	1433099443000	724	405	1	0	574
62522	1397	1433089442000	724	405	2	0	575
62523	1397	1433079441000	724	405	3	0	576
62530	1397	1433059439000	728	407	0	0	578
62531	1397	1433049438000	728	407	1	0	579
62532	1397	1433039437000	729	408	0	0	580
62533	1397	1433029436000	730	409	0	0	581
62537	1397	1433009434000	734	411	0	0	583
62538	1397	1432999433000	735	412	0	0	584
62539	1397	1432989432000	736	413	0	0	585
62540	1397	1432979431000	736	413	1	0	586
62544	1397	1432969430000	740	414	0	0	587
62546	1397	1432949428000	741	415	1	0	589
62547	1397	1432939427000	742	416	0	0	590
62548	1397	1432929426000	743	417	0	0	591
62549	1397	1432919425000	743	417	1	0	592
62550	1397	1432909424000	744	418	0	0	593
62555	1397	1432889422000	749	420	0	0	595
62558	1397	1432879421000	752	421	0	0	596
62564	1397	1432859419000	757	423	0	0	\N
62565	1397	1432849418000	757	423	1	0	\N
62566	1397	1432839417000	758	424	0	0	\N
62567	1397	1432839417000	759	424	0	0	\N
62569	1397	1432839417000	761	424	0	0	\N
62570	1724	718760000000	762	369	0	0	\N
62571	1724	718510000000	762	369	1	0	\N
62572	885	63455051096354	762	369	2	0	\N
62573	886	63455051096354	762	369	3	0	\N
62574	885	63455041096354	762	369	4	0	\N
62575	578	66000090000000	762	369	5	0	\N
62576	1397	1432839417000	763	424	0	0	\N
62578	298	67439720000000	765	426	0	0	\N
62579	1693	5755580000000	765	426	1	0	\N
62580	1397	1432819415000	765	426	2	0	\N
62584	298	67439720000000	767	426	0	0	\N
62585	1693	5755580000000	767	426	1	0	\N
62586	1397	1432819415000	767	426	2	0	\N
62587	1397	1432809414000	768	427	0	0	\N
62593	298	67439420000000	771	428	0	0	\N
62594	1397	1432799413000	771	428	1	0	\N
62595	1397	1432789412000	771	428	2	0	\N
62596	885	63455031096354	771	428	3	0	\N
62603	14	4884100000000	775	431	0	0	\N
62604	1397	1432749408000	775	431	1	0	\N
62605	14	4884100000000	776	431	0	0	\N
62606	1397	1432749408000	776	431	1	0	\N
62607	1397	1432739407000	777	432	0	0	\N
62608	1397	1432739407000	778	432	0	0	\N
62610	1397	1432729406000	780	433	0	0	\N
62611	1434	719100000000	780	433	1	0	\N
62612	1397	1432719405000	780	433	2	0	\N
62613	1397	1432729406000	781	433	0	0	\N
62614	1434	719100000000	781	433	1	0	\N
62615	1397	1432719405000	781	433	2	0	\N
62619	1397	1432709404000	784	435	0	0	\N
62620	1397	1432699403000	784	435	1	0	\N
62621	1397	1432689402000	784	435	2	0	\N
62622	1397	1432709404000	785	435	0	0	\N
62623	1397	1432699403000	785	435	1	0	\N
62624	1397	1432689402000	785	435	2	0	\N
62628	1397	1432709404000	787	435	0	0	\N
62629	1397	1432699403000	787	435	1	0	\N
62630	1397	1432689402000	787	435	2	0	\N
62631	1397	1432679401000	788	436	0	0	\N
62634	1397	1432659399000	791	438	0	0	\N
62639	1397	1432619395000	795	441	0	0	\N
62641	1397	1432609394000	797	442	0	0	\N
62642	1397	1432609394000	798	442	0	0	\N
62644	1397	1432599393000	800	443	0	0	\N
62645	1397	1432599393000	801	443	0	0	\N
62647	1397	1432589392000	803	444	0	0	\N
62648	1397	1432579391000	803	444	1	0	\N
62655	1397	1432559389000	807	446	0	0	\N
62656	1397	1432549388000	807	446	1	0	\N
62657	1397	1432539387000	807	446	2	0	\N
62661	1397	1432519385000	810	448	0	0	\N
62662	1397	1432509384000	810	448	1	0	\N
62663	1397	1432499383000	811	449	0	0	\N
62665	1397	1432489382000	813	450	0	0	\N
62668	1397	1432479381000	816	451	0	0	\N
62671	1397	1432459379000	818	453	0	0	\N
62674	1397	1432449378000	821	454	0	0	\N
62675	1397	1432449378000	822	454	0	0	\N
62676	1397	1432439377000	823	455	0	0	\N
62677	1397	1432429376000	823	455	1	0	\N
62678	1397	1432439377000	824	455	0	0	\N
62679	1397	1432429376000	824	455	1	0	\N
62682	1397	1432439377000	826	455	0	0	\N
62683	1397	1432429376000	826	455	1	0	\N
62685	1397	1432419375000	828	456	0	0	\N
62687	1397	1432399373000	830	458	0	0	\N
62688	1397	1432399373000	831	458	0	0	\N
62691	1397	1432389372000	834	459	0	0	\N
62692	1397	1432379371000	835	460	0	0	\N
62563	1397	1432849418000	756	423	1	0	599
62568	1397	1432839417000	760	424	0	0	600
62577	1397	1432829416000	764	425	0	0	601
62581	298	67439720000000	766	426	0	0	1
62582	1693	5755580000000	766	426	1	0	6
62588	1397	1432809414000	769	427	0	0	603
62589	298	67439420000000	770	428	0	0	2
62590	1397	1432799413000	770	428	1	0	604
62591	1397	1432789412000	770	428	2	0	605
62592	885	63455031096354	770	428	3	0	4
62598	1397	1432779411000	772	429	1	0	606
62599	1397	1432769410000	772	429	2	0	607
62600	1397	1432759409000	773	430	0	0	608
62601	14	4884100000000	774	431	0	0	1
62609	1397	1432739407000	779	432	0	0	610
62616	1397	1432729406000	782	433	0	0	611
62617	1434	719100000000	782	433	1	0	1
62618	1397	1432719405000	782	433	2	0	612
62625	1397	1432709404000	786	435	0	0	613
62627	1397	1432689402000	786	435	2	0	615
62632	1397	1432679401000	789	436	0	0	616
62633	1397	1432669400000	790	437	0	0	617
62635	1397	1432659399000	792	438	0	0	618
62636	1397	1432649398000	793	439	0	0	619
62638	1397	1432629396000	794	440	1	0	621
62640	1397	1432619395000	796	441	0	0	622
62643	1397	1432609394000	799	442	0	0	623
62646	1397	1432599393000	802	443	0	0	624
62650	1397	1432579391000	804	444	1	0	626
62651	1397	1432569390000	805	445	0	0	627
62652	1397	1432559389000	806	446	0	0	628
62653	1397	1432549388000	806	446	1	0	629
62654	1397	1432539387000	806	446	2	0	630
62659	1397	1432519385000	809	448	0	0	632
62660	1397	1432509384000	809	448	1	0	633
62664	1397	1432499383000	812	449	0	0	634
62666	1397	1432489382000	814	450	0	0	635
62667	1397	1432479381000	815	451	0	0	636
62670	209	66000990000000	817	452	1	0	1
62672	1397	1432459379000	819	453	0	0	638
62673	1397	1432449378000	820	454	0	0	639
62680	1397	1432439377000	825	455	0	0	640
62684	1397	1432419375000	827	456	0	0	642
62686	1397	1432409374000	829	457	0	0	643
62689	1397	1432399373000	832	458	0	0	644
62690	1397	1432389372000	833	459	0	0	645
62693	1397	1432379371000	836	460	0	0	646
62695	1397	1432359369000	837	461	1	0	648
62696	1397	1432349368000	838	462	0	0	649
62700	1397	1432329366000	840	463	0	0	\N
62701	1397	1432319365000	840	463	1	0	\N
62702	1397	1432309364000	841	464	0	0	\N
62704	1397	1432299363000	843	465	0	0	\N
62718	1397	1432209354000	854	474	0	0	\N
62719	1397	1432199353000	854	474	1	0	\N
62720	1397	1432189352000	854	474	2	0	\N
62721	1397	1432179351000	854	474	3	0	\N
62725	1397	1432169350000	856	475	0	0	\N
62726	1397	1432159349000	856	475	1	0	\N
62727	1397	1432149348000	856	475	2	0	\N
62728	1397	1432139347000	857	476	0	0	\N
62729	1397	1432139347000	858	476	0	0	\N
62731	1569	810000000	860	477	0	0	\N
62732	1397	1432129346000	860	477	1	0	\N
62733	1397	1432119345000	860	477	2	0	\N
62734	1397	1432109344000	860	477	3	0	\N
62739	1397	1432099343000	862	478	0	0	\N
62740	1397	1432099343000	863	478	0	0	\N
62744	1706	716810000000	866	479	0	0	\N
62745	1397	1432089342000	866	479	1	0	\N
62749	1397	1432059339000	870	482	0	0	\N
62750	1397	1432049338000	871	483	0	0	\N
62751	1397	1432049338000	872	483	0	0	\N
62765	1397	1431939327000	880	489	0	0	\N
62766	1397	1431929326000	880	489	1	0	\N
62767	1397	1431919325000	881	490	0	0	\N
62773	394	66000090000000	886	493	0	0	\N
62774	1397	1431889322000	886	493	1	0	\N
62775	394	66000090000000	887	493	0	0	\N
62776	1397	1431889322000	887	493	1	0	\N
62777	394	66000090000000	888	493	0	0	\N
62778	1397	1431889322000	888	493	1	0	\N
62780	1397	1431869320000	890	495	0	0	\N
62781	1397	1431859319000	890	495	1	0	\N
62782	1712	2385000000	890	495	2	0	\N
62783	1397	1431869320000	891	495	0	0	\N
62784	1397	1431859319000	891	495	1	0	\N
62785	1712	2385000000	891	495	2	0	\N
62790	1397	1431849318000	894	496	0	0	\N
62798	1397	1431789312000	899	500	0	0	\N
62800	1397	1431779311000	901	501	0	0	\N
62804	1698	718910000000	903	502	0	0	\N
62805	1397	1431769310000	903	502	1	0	\N
62806	1397	1431759309000	903	502	2	0	\N
62807	1698	718910000000	904	502	0	0	\N
62808	1397	1431769310000	904	502	1	0	\N
62809	1397	1431759309000	904	502	2	0	\N
62810	1397	1431749308000	905	503	0	0	\N
62811	1397	1431739307000	905	503	1	0	\N
62816	1397	1431719305000	909	505	0	0	\N
62819	1397	1431689302000	911	507	0	0	\N
62820	1397	1431679301000	911	507	1	0	\N
62823	1397	1431689302000	913	507	0	0	\N
62824	1397	1431679301000	913	507	1	0	\N
62828	1705	714810000000	916	509	0	0	\N
62829	1397	1431659299000	916	509	1	0	\N
62699	1397	1432319365000	839	463	1	0	652
62703	1397	1432309364000	842	464	0	0	653
62705	1397	1432299363000	844	465	0	0	654
62706	1397	1432289362000	845	466	0	0	655
62707	1397	1432279361000	846	467	0	0	656
62709	1397	1432259359000	847	468	1	0	658
62710	1397	1432249358000	848	469	0	0	659
62711	1397	1432239357000	849	470	0	0	660
62712	1397	1432229356000	850	471	0	0	661
62713	1397	1432219355000	851	472	0	0	662
62715	1397	1432199353000	853	474	1	0	664
62716	1397	1432189352000	853	474	2	0	665
62717	1397	1432179351000	853	474	3	0	666
62722	1397	1432169350000	855	475	0	0	667
62724	1397	1432149348000	855	475	2	0	669
62730	1397	1432139347000	859	476	0	0	670
62735	1569	810000000	861	477	0	0	1
62736	1397	1432129346000	861	477	1	0	671
62737	1397	1432119345000	861	477	2	0	672
62741	1397	1432099343000	864	478	0	0	674
62742	1706	716810000000	865	479	0	0	2
62743	1397	1432089342000	865	479	1	0	675
62746	1397	1432079341000	867	480	0	0	676
62747	1397	1432069340000	868	481	0	0	677
62752	1397	1432049338000	873	483	0	0	679
62753	1397	1432039337000	874	484	0	0	680
62754	1397	1432029336000	874	484	1	0	681
62755	1397	1432019335000	875	485	0	0	682
62757	1397	1431999333000	876	486	0	0	684
62758	1397	1431989332000	876	486	1	0	685
62759	1397	1431979331000	877	487	0	0	686
62760	1397	1431969330000	877	487	1	0	687
62761	1397	1431959329000	877	487	2	0	688
62763	1397	1431939327000	879	489	0	0	690
62764	1397	1431929326000	879	489	1	0	691
62768	1397	1431919325000	882	490	0	0	692
62769	1397	1431909324000	883	491	0	0	693
62770	1397	1431899323000	884	492	0	0	694
62772	1397	1431889322000	885	493	1	0	695
62779	1397	1431879321000	889	494	0	0	696
62786	1397	1431869320000	892	495	0	0	697
62787	1397	1431859319000	892	495	1	0	698
62789	1397	1431849318000	893	496	0	0	699
62791	1397	1431839317000	895	497	0	0	700
62792	1397	1431829316000	895	497	1	0	701
62793	1712	1284000000	895	497	2	0	7
62794	1397	1431819315000	896	498	0	0	702
62796	1397	1431799313000	897	499	0	0	704
62797	1397	1431789312000	898	500	0	0	705
62799	1397	1431779311000	900	501	0	0	706
62801	1698	718910000000	902	502	0	0	1
62802	1397	1431769310000	902	502	1	0	707
62812	1397	1431749308000	906	503	0	0	709
62813	1397	1431739307000	906	503	1	0	710
62814	1397	1431729306000	907	504	0	0	711
62815	1397	1431719305000	908	505	0	0	712
62818	1397	1431699303000	910	506	1	0	714
62821	1397	1431689302000	912	507	0	0	715
62822	1397	1431679301000	912	507	1	0	716
62825	1397	1431669300000	914	508	0	0	717
62826	1705	714810000000	915	509	0	0	2
62830	1397	1431649298000	917	510	0	0	719
62831	1397	1431639297000	917	510	1	0	720
62832	1397	1431629296000	917	510	2	0	721
62834	1397	1431609294000	918	511	0	0	\N
62835	1397	1431609294000	919	511	0	0	\N
62843	1397	1431559289000	926	516	0	0	\N
62844	1397	1431559289000	927	516	0	0	\N
62846	1397	1431549288000	929	517	0	0	\N
62849	1397	1431539287000	931	518	0	0	\N
62850	1397	1431529286000	931	518	1	0	\N
62851	1397	1431519285000	932	519	0	0	\N
62852	1397	1431509284000	932	519	1	0	\N
62855	1397	1431499283000	934	520	0	0	\N
62856	1397	1431499283000	935	520	0	0	\N
62861	1397	1431469280000	940	523	0	0	\N
62862	1397	1431469280000	941	523	0	0	\N
62866	1397	1431429276000	943	525	0	0	\N
62872	1397	1431389272000	948	528	0	0	\N
62874	1397	1431369270000	950	530	0	0	\N
62875	1397	1431359269000	950	530	1	0	\N
62881	1397	1431329266000	954	532	0	0	\N
62882	1397	1431329266000	955	532	0	0	\N
62887	1397	1431289262000	958	534	0	0	\N
62894	1397	1431279261000	960	535	0	0	\N
62895	1397	1431269260000	960	535	1	0	\N
62896	1397	1431259259000	960	535	2	0	\N
62897	1397	1431249258000	960	535	3	0	\N
62898	1397	1431239257000	960	535	4	0	\N
62899	1397	1431229256000	960	535	5	0	\N
62902	1397	1431219255000	962	536	0	0	\N
62903	1397	1431209254000	962	536	1	0	\N
62904	1397	1431219255000	963	536	0	0	\N
62905	1397	1431209254000	963	536	1	0	\N
62909	1397	1431179251000	966	538	0	0	\N
62911	1397	1431169250000	968	539	0	0	\N
62912	1397	1431169250000	969	539	0	0	\N
62914	1397	1431159249000	971	540	0	0	\N
62915	1397	1431149248000	972	541	0	0	\N
62917	1397	1431149248000	974	541	0	0	\N
62918	1397	1431139247000	975	542	0	0	\N
62920	1397	1431139247000	977	542	0	0	\N
62923	1397	1431119245000	980	544	0	0	\N
62924	1397	1431119245000	981	544	0	0	\N
62925	1397	1431119245000	982	544	0	0	\N
62927	1397	1431109244000	984	545	0	0	\N
62929	1397	1431099243000	986	546	0	0	\N
62930	1397	1431099243000	987	546	0	0	\N
62931	1397	1431099243000	988	546	0	0	\N
62932	1397	1431089242000	989	547	0	0	\N
62933	1397	1431089242000	990	547	0	0	\N
62934	1397	1431089242000	991	547	0	0	\N
62936	1397	1431079241000	993	548	0	0	\N
62939	1397	1431069240000	996	549	0	0	\N
62943	1397	1431029236000	1000	553	0	0	\N
62946	1397	1431009234000	1003	555	0	0	\N
62948	1397	1430999233000	1006	556	0	0	\N
62956	1397	1430929226000	1009	559	0	0	\N
62957	1397	1430929226000	1010	559	0	0	\N
62959	1397	1430929226000	1012	559	0	0	\N
62960	1397	1430919225000	1012	559	1	0	\N
62963	1397	1430909224000	1015	561	0	0	\N
62966	1397	1430889222000	1018	563	0	0	\N
62837	1397	1431599293000	921	512	0	0	724
62838	1397	1431589292000	922	513	0	0	725
62839	1735	719009000000	922	513	1	0	1
62840	1397	1431579291000	923	514	0	0	726
62841	1397	1431569290000	924	515	0	0	727
62845	1397	1431549288000	928	517	0	0	729
62847	1397	1431539287000	930	518	0	0	730
62848	1397	1431529286000	930	518	1	0	731
62853	1397	1431519285000	933	519	0	0	732
62854	1397	1431509284000	933	519	1	0	733
62858	1397	1431489282000	937	521	0	0	735
62859	1397	1431479281000	938	522	0	0	736
62860	1397	1431469280000	939	523	0	0	737
62863	1397	1431459279000	942	524	0	0	738
62865	1397	1431439277000	942	524	2	0	740
62867	1397	1431429276000	944	525	0	0	741
62868	1397	1431419275000	945	526	0	0	742
62869	1397	1431409274000	946	527	0	0	743
62870	1397	1431399273000	946	527	1	0	744
62873	1397	1431379271000	949	529	0	0	746
62876	1397	1431369270000	951	530	0	0	747
62877	1397	1431359269000	951	530	1	0	748
62878	1397	1431349268000	952	531	0	0	749
62879	1397	1431339267000	952	531	1	0	750
62883	1397	1431319265000	956	533	0	0	752
62884	1397	1431309264000	956	533	1	0	753
62885	1397	1431299263000	956	533	2	0	754
62886	1397	1431289262000	957	534	0	0	755
62889	1397	1431269260000	959	535	1	0	757
62890	1397	1431259259000	959	535	2	0	758
62891	1397	1431249258000	959	535	3	0	759
62892	1397	1431239257000	959	535	4	0	760
62893	1397	1431229256000	959	535	5	0	761
62901	1397	1431209254000	961	536	1	0	763
62906	1397	1431199253000	964	537	0	0	764
62907	1397	1431189252000	964	537	1	0	765
62908	1397	1431179251000	965	538	0	0	766
62910	1397	1431169250000	967	539	0	0	767
62916	1397	1431149248000	973	541	0	0	769
62919	1397	1431139247000	976	542	0	0	770
62921	1397	1431129246000	978	543	0	0	771
62922	1397	1431119245000	979	544	0	0	772
62928	1397	1431099243000	985	546	0	0	774
62935	1397	1431089242000	992	547	0	0	775
62937	1397	1431079241000	994	548	0	0	776
62938	1397	1431069240000	995	549	0	0	777
62940	1397	1431059239000	997	550	0	0	778
62942	1397	1431039237000	999	552	0	0	780
62944	1397	1431029236000	1001	553	0	0	781
62945	1397	1431019235000	1002	554	0	0	782
62947	1397	1431009234000	1004	555	0	0	783
62949	1397	1430999233000	1007	557	0	0	784
62951	1397	1430979231000	1008	558	0	0	786
62952	1397	1430969230000	1008	558	1	0	787
62953	1397	1430959229000	1008	558	2	0	788
62954	1397	1430949228000	1008	558	3	0	789
62958	1397	1430929226000	1011	559	0	0	791
62961	1397	1430919225000	1013	560	0	0	792
62962	1397	1430909224000	1014	561	0	0	793
62964	1397	1430899223000	1016	562	0	0	794
62965	1397	1430889222000	1017	563	0	0	795
62968	1397	1430869220000	1020	565	0	0	797
62970	1397	1430859219000	1022	566	0	0	\N
62971	1397	1430849218000	1023	567	0	0	\N
62975	1397	1430839217000	1026	568	0	0	\N
62976	1397	1430829216000	1026	568	1	0	\N
62977	1397	1430819215000	1027	569	0	0	\N
62981	1397	1430799213000	1031	571	0	0	\N
62986	1397	1430749208000	1036	576	0	0	\N
62989	1397	1430729206000	1039	578	0	0	\N
62991	1397	1430719205000	1041	579	0	0	\N
62993	1397	1430719205000	1043	579	0	0	\N
62994	1397	1430709204000	1044	580	0	0	\N
62996	1397	1430699203000	1046	581	0	0	\N
62998	1397	1430689202000	1048	582	0	0	\N
62999	1397	1430679201000	1048	582	1	0	\N
63000	1397	1430669200000	1048	582	2	0	\N
63001	1397	1430659199000	1048	582	3	0	\N
63017	1693	6400902381354	1052	584	0	0	\N
63018	1693	6363558572031	1052	584	1	0	\N
63019	1693	6326214762708	1052	584	2	0	\N
63020	1693	5816574596483	1052	584	3	0	\N
63021	1693	5779230787160	1052	584	4	0	\N
63022	1693	5741886977837	1052	584	5	0	\N
63023	1693	5704543168514	1052	584	6	0	\N
63024	1693	5667199359191	1052	584	7	0	\N
63025	1397	1430639197000	1052	584	8	0	\N
63062	1696	1438020000000	1054	585	0	0	\N
63063	1693	5629855549868	1054	585	1	0	\N
63064	1693	5592511740545	1054	585	2	0	\N
63065	1693	5555167931222	1054	585	3	0	\N
63066	1693	5517824121899	1054	585	4	0	\N
63067	1693	5516682794349	1054	585	5	0	\N
63068	1693	5401812973049	1054	585	6	0	\N
63069	1693	5364469163726	1054	585	7	0	\N
63070	1693	5327125354403	1054	585	8	0	\N
63071	1693	5323327104091	1054	585	9	0	\N
63072	1693	5285983294768	1054	585	10	0	\N
63073	1693	5248639485445	1054	585	11	0	\N
63074	1693	5211295676122	1054	585	12	0	\N
63075	1693	5173951866799	1054	585	13	0	\N
63076	1693	5136608057476	1054	585	14	0	\N
63077	1693	5099264248153	1054	585	15	0	\N
63078	1693	5061920438830	1054	585	16	0	\N
63079	1693	5024576629507	1054	585	17	0	\N
63080	1693	4987232820184	1054	585	18	0	\N
63081	1693	4813664210109	1054	585	19	0	\N
63082	1693	4776320400786	1054	585	20	0	\N
63083	1693	4738976591463	1054	585	21	0	\N
63084	1693	4701632782140	1054	585	22	0	\N
63085	1693	4664288972817	1054	585	23	0	\N
63086	1693	4660319326376	1054	585	24	0	\N
63087	1693	4622975517053	1054	585	25	0	\N
63088	1693	4585631707730	1054	585	26	0	\N
63089	1693	4548287898407	1054	585	27	0	\N
63090	1693	4510944089084	1054	585	28	0	\N
63091	1693	4473600279761	1054	585	29	0	\N
63092	1693	4436256470438	1054	585	30	0	\N
63093	1693	4433418151552	1054	585	31	0	\N
63094	1693	4396074342229	1054	585	32	0	\N
63095	1693	4358730532906	1054	585	33	0	\N
63096	1397	1430629196000	1054	585	34	0	\N
63097	1397	1430619195000	1054	585	35	0	\N
63098	1696	1438020000000	1055	585	0	0	\N
63099	1693	5629855549868	1055	585	1	0	\N
63100	1693	5592511740545	1055	585	2	0	\N
63101	1693	5555167931222	1055	585	3	0	\N
63102	1693	5517824121899	1055	585	4	0	\N
63103	1693	5516682794349	1055	585	5	0	\N
63104	1693	5401812973049	1055	585	6	0	\N
62973	1397	1430839217000	1025	568	0	0	800
62974	1397	1430829216000	1025	568	1	0	801
62978	1397	1430819215000	1028	569	0	0	802
62979	1397	1430809214000	1029	570	0	0	803
62980	1397	1430799213000	1030	571	0	0	804
62983	1397	1430779211000	1033	573	0	0	806
62984	1397	1430769210000	1034	574	0	0	807
62985	1397	1430759209000	1035	575	0	0	808
62987	1397	1430749208000	1037	576	0	0	809
62988	1397	1430739207000	1038	577	0	0	810
62992	1397	1430719205000	1042	579	0	0	812
62995	1397	1430709204000	1045	580	0	0	813
62997	1397	1430699203000	1047	581	0	0	814
63002	1397	1430689202000	1049	582	0	0	815
63004	1397	1430669200000	1049	582	2	0	817
63005	1397	1430659199000	1049	582	3	0	818
63006	1693	6438246190677	1050	583	0	0	7
63007	1397	1430649198000	1050	583	1	0	819
63008	1693	6400902381354	1051	584	0	0	8
63010	1693	6326214762708	1051	584	2	0	10
63011	1693	5816574596483	1051	584	3	0	11
63012	1693	5779230787160	1051	584	4	0	12
63013	1693	5741886977837	1051	584	5	0	13
63014	1693	5704543168514	1051	584	6	0	14
63016	1397	1430639197000	1051	584	8	0	820
63026	1696	1438020000000	1053	585	0	0	1
63027	1693	5629855549868	1053	585	1	0	16
63028	1693	5592511740545	1053	585	2	0	17
63030	1693	5517824121899	1053	585	4	0	19
63031	1693	5516682794349	1053	585	5	0	20
63032	1693	5401812973049	1053	585	6	0	21
63033	1693	5364469163726	1053	585	7	0	22
63034	1693	5327125354403	1053	585	8	0	23
63036	1693	5285983294768	1053	585	10	0	25
63037	1693	5248639485445	1053	585	11	0	26
63038	1693	5211295676122	1053	585	12	0	27
63039	1693	5173951866799	1053	585	13	0	28
63040	1693	5136608057476	1053	585	14	0	29
63042	1693	5061920438830	1053	585	16	0	31
63043	1693	5024576629507	1053	585	17	0	32
63044	1693	4987232820184	1053	585	18	0	33
63045	1693	4813664210109	1053	585	19	0	34
63047	1693	4738976591463	1053	585	21	0	36
63048	1693	4701632782140	1053	585	22	0	37
63049	1693	4664288972817	1053	585	23	0	38
63050	1693	4660319326376	1053	585	24	0	39
63051	1693	4622975517053	1053	585	25	0	40
63053	1693	4548287898407	1053	585	27	0	42
63054	1693	4510944089084	1053	585	28	0	43
63055	1693	4473600279761	1053	585	29	0	44
63056	1693	4436256470438	1053	585	30	0	45
63057	1693	4433418151552	1053	585	31	0	46
63059	1693	4358730532906	1053	585	33	0	48
63060	1397	1430629196000	1053	585	34	0	821
63061	1397	1430619195000	1053	585	35	0	822
63105	1693	5364469163726	1055	585	7	0	\N
63106	1693	5327125354403	1055	585	8	0	\N
63107	1693	5323327104091	1055	585	9	0	\N
63108	1693	5285983294768	1055	585	10	0	\N
63109	1693	5248639485445	1055	585	11	0	\N
63110	1693	5211295676122	1055	585	12	0	\N
63111	1693	5173951866799	1055	585	13	0	\N
63112	1693	5136608057476	1055	585	14	0	\N
63113	1693	5099264248153	1055	585	15	0	\N
63114	1693	5061920438830	1055	585	16	0	\N
63115	1693	5024576629507	1055	585	17	0	\N
63116	1693	4987232820184	1055	585	18	0	\N
63117	1693	4813664210109	1055	585	19	0	\N
63118	1693	4776320400786	1055	585	20	0	\N
63119	1693	4738976591463	1055	585	21	0	\N
63120	1693	4701632782140	1055	585	22	0	\N
63121	1693	4664288972817	1055	585	23	0	\N
63122	1693	4660319326376	1055	585	24	0	\N
63123	1693	4622975517053	1055	585	25	0	\N
63124	1693	4585631707730	1055	585	26	0	\N
63125	1693	4548287898407	1055	585	27	0	\N
63126	1693	4510944089084	1055	585	28	0	\N
63127	1693	4473600279761	1055	585	29	0	\N
63128	1693	4436256470438	1055	585	30	0	\N
63129	1693	4433418151552	1055	585	31	0	\N
63130	1693	4396074342229	1055	585	32	0	\N
63131	1693	4358730532906	1055	585	33	0	\N
63132	1397	1430629196000	1055	585	34	0	\N
63133	1397	1430619195000	1055	585	35	0	\N
63134	1693	4074327339327	1056	586	0	0	\N
63135	1397	1430609194000	1056	586	1	0	\N
63136	1693	4036983530004	1056	586	2	0	\N
63137	1693	3999639720681	1056	586	3	0	\N
63138	1693	3998498393131	1056	586	4	0	\N
63139	1693	3961154583808	1056	586	5	0	\N
63140	1693	3923810774485	1056	586	6	0	\N
63141	1693	3886466965162	1056	586	7	0	\N
63142	1693	3849123155839	1056	586	8	0	\N
63143	1693	3811779346516	1056	586	9	0	\N
63144	1693	3774435537193	1056	586	10	0	\N
63145	1693	3737091727870	1056	586	11	0	\N
63146	1693	3699747918547	1056	586	12	0	\N
63147	1693	3662404109224	1056	586	13	0	\N
63148	1693	3625440425959	1056	586	14	0	\N
63149	1693	3281572797708	1056	586	15	0	\N
63150	1693	3244228988385	1056	586	16	0	\N
63151	1693	4074327339327	1057	586	0	0	\N
63152	1397	1430609194000	1057	586	1	0	\N
63153	1693	4036983530004	1057	586	2	0	\N
63154	1693	3999639720681	1057	586	3	0	\N
63155	1693	3998498393131	1057	586	4	0	\N
63156	1693	3961154583808	1057	586	5	0	\N
63157	1693	3923810774485	1057	586	6	0	\N
63158	1693	3886466965162	1057	586	7	0	\N
63159	1693	3849123155839	1057	586	8	0	\N
63160	1693	3811779346516	1057	586	9	0	\N
63161	1693	3774435537193	1057	586	10	0	\N
63162	1693	3737091727870	1057	586	11	0	\N
63163	1693	3699747918547	1057	586	12	0	\N
63164	1693	3662404109224	1057	586	13	0	\N
63165	1693	3625440425959	1057	586	14	0	\N
63166	1693	3281572797708	1057	586	15	0	\N
63167	1693	3244228988385	1057	586	16	0	\N
63185	1696	1438020000000	1059	572	0	0	\N
63186	1693	6438246190677	1059	572	1	0	\N
63187	1693	6400902381354	1059	572	2	0	\N
63188	1693	6363558572031	1059	572	3	0	\N
63189	1693	6326214762708	1059	572	4	0	\N
63190	1693	5816574596483	1059	572	5	0	\N
63191	1693	5779230787160	1059	572	6	0	\N
63192	1693	5741886977837	1059	572	7	0	\N
63193	1693	5704543168514	1059	572	8	0	\N
63194	1693	5667199359191	1059	572	9	0	\N
63195	1693	5629855549868	1059	572	10	0	\N
63196	1693	5592511740545	1059	572	11	0	\N
63197	1693	5555167931222	1059	572	12	0	\N
63198	1693	5517824121899	1059	572	13	0	\N
63199	1693	5516682794349	1059	572	14	0	\N
63200	1693	5401812973049	1059	572	15	0	\N
63201	1693	5364469163726	1059	572	16	0	\N
63202	1693	5327125354403	1059	572	17	0	\N
63203	1693	5323327104091	1059	572	18	0	\N
63204	1693	5285983294768	1059	572	19	0	\N
63205	1693	5248639485445	1059	572	20	0	\N
63206	1693	5211295676122	1059	572	21	0	\N
63207	1693	5173951866799	1059	572	22	0	\N
63208	1693	5136608057476	1059	572	23	0	\N
63209	1693	5099264248153	1059	572	24	0	\N
63210	1693	5061920438830	1059	572	25	0	\N
63211	1693	5024576629507	1059	572	26	0	\N
63212	1693	4987232820184	1059	572	27	0	\N
63213	1693	4813664210109	1059	572	28	0	\N
63214	1693	4776320400786	1059	572	29	0	\N
63215	1693	4738976591463	1059	572	30	0	\N
63216	1693	4701632782140	1059	572	31	0	\N
63217	1693	4664288972817	1059	572	32	0	\N
63218	1693	4660319326376	1059	572	33	0	\N
63219	1693	4622975517053	1059	572	34	0	\N
63220	1693	4585631707730	1059	572	35	0	\N
63221	1693	4548287898407	1059	572	36	0	\N
63222	1693	4510944089084	1059	572	37	0	\N
63223	1693	4473600279761	1059	572	39	0	\N
63224	1693	4436256470438	1059	572	40	0	\N
63225	1693	4433418151552	1059	572	41	0	\N
63226	1693	4396074342229	1059	572	42	0	\N
63170	1693	4036983530004	1058	586	2	0	50
63171	1693	3999639720681	1058	586	3	0	51
63172	1693	3998498393131	1058	586	4	0	52
63173	1693	3961154583808	1058	586	5	0	53
63174	1693	3923810774485	1058	586	6	0	54
63176	1693	3849123155839	1058	586	8	0	56
63177	1693	3811779346516	1058	586	9	0	57
63178	1693	3774435537193	1058	586	10	0	58
63179	1693	3737091727870	1058	586	11	0	59
63180	1693	3699747918547	1058	586	12	0	60
63182	1693	3625440425959	1058	586	14	0	62
63183	1693	3281572797708	1058	586	15	0	63
63184	1693	3244228988385	1058	586	16	0	64
63227	1397	1430599193000	1060	587	0	0	824
63229	1693	3201218541290	1060	587	2	0	66
63230	1693	3027649931215	1060	587	3	0	67
63231	1693	2990306121892	1060	587	4	0	68
63232	1693	2952962312569	1060	587	5	0	69
63233	1693	2915618503246	1060	587	6	0	70
63235	1693	2840930884600	1060	587	8	0	72
63236	1693	2803587075277	1060	587	9	0	73
63237	1693	2766243265954	1060	587	10	0	74
63238	1693	2728899456631	1060	587	11	0	75
63239	1693	2691555647308	1060	587	12	0	76
63246	1397	1430589192000	1062	588	0	0	\N
63247	1693	1621324364109	1062	588	1	0	\N
63248	1693	1583980554786	1062	588	2	0	\N
63249	1397	1430589192000	1063	588	0	0	\N
63250	1693	1621324364109	1063	588	1	0	\N
63251	1693	1583980554786	1063	588	2	0	\N
63255	1397	1430549188000	1066	591	0	0	\N
63259	1397	1430529186000	1070	593	0	0	\N
63260	1397	1430529186000	1071	593	0	0	\N
63261	1397	1430529186000	1072	593	0	0	\N
63264	1397	1430519185000	1074	594	0	0	\N
63265	1397	1430509184000	1074	594	1	0	\N
63269	1397	1430469180000	1078	598	0	0	\N
63270	1397	1430459179000	1078	598	1	0	\N
63271	1397	1430449178000	1078	598	2	0	\N
63277	1397	1430419175000	1082	601	0	0	\N
63278	1397	1430419175000	1083	601	0	0	\N
63280	1397	1430419175000	1085	601	0	0	\N
63281	1397	1430409174000	1086	602	0	0	\N
63299	1397	1430379171000	1090	604	0	0	\N
63300	1693	1008972949534	1090	604	1	0	\N
63301	1693	971629140211	1090	604	2	0	\N
63302	1693	934285330888	1090	604	3	0	\N
63303	1693	896941521565	1090	604	4	0	\N
63304	1693	859597712242	1090	604	5	0	\N
63305	1693	822253902919	1090	604	6	0	\N
63306	1693	784910093596	1090	604	7	0	\N
63307	1693	747566284273	1090	604	8	0	\N
63308	1693	1008972949534	1091	604	0	0	\N
63309	1693	971629140211	1091	604	1	0	\N
63310	1693	934285330888	1091	604	2	0	\N
63311	1693	896941521565	1091	604	3	0	\N
63312	1693	859597712242	1091	604	4	0	\N
63313	1693	822253902919	1091	604	5	0	\N
63314	1693	784910093596	1091	604	6	0	\N
63315	1693	747566284273	1091	604	7	0	\N
63335	1397	1430359169000	1094	606	0	0	\N
63336	1693	393045119100	1094	606	1	0	\N
63337	1693	355701309777	1094	606	2	0	\N
63338	1693	318357500454	1094	606	3	0	\N
63343	1397	1430359169000	1096	606	0	0	\N
63344	1693	393045119100	1096	606	1	0	\N
63345	1693	355701309777	1096	606	2	0	\N
63346	1693	318357500454	1096	606	3	0	\N
63347	1397	1430349168000	1097	607	0	0	\N
63349	1397	1430349168000	1099	607	0	0	\N
63353	1397	1430319165000	1103	610	0	0	\N
63355	1397	1430309164000	1105	611	0	0	\N
63357	1397	1430299163000	1107	612	0	0	\N
63358	1397	1430289162000	1108	613	0	0	\N
63360	1397	1430289162000	1110	613	0	0	\N
63361	1397	1430289162000	1111	613	0	0	\N
63362	1397	1430279161000	1112	614	0	0	\N
63363	1397	1430269160000	1112	614	1	0	\N
63364	1397	1430279161000	1113	614	0	0	\N
63365	1397	1430269160000	1113	614	1	0	\N
63368	1397	1430259159000	1115	615	0	0	\N
63371	1397	1430249158000	1118	616	0	0	\N
63372	1397	1430239157000	1119	617	0	0	\N
63373	1397	1430229156000	1119	617	1	0	\N
63374	1397	1430239157000	1120	617	0	0	\N
63375	1397	1430229156000	1120	617	1	0	\N
63243	1397	1430589192000	1061	588	0	0	825
63244	1693	1621324364109	1061	588	1	0	80
63245	1693	1583980554786	1061	588	2	0	81
63252	1397	1430579191000	1064	589	0	0	826
63253	1397	1430569190000	1064	589	1	0	827
63256	1397	1430549188000	1067	591	0	0	829
63257	1397	1430539187000	1068	592	0	0	830
63258	1397	1430529186000	1069	593	0	0	831
63262	1397	1430519185000	1073	594	0	0	832
63263	1397	1430509184000	1073	594	1	0	833
63267	1397	1430489182000	1076	596	0	0	835
63268	1397	1430479181000	1077	597	0	0	836
63272	1397	1430469180000	1079	598	0	0	837
63273	1397	1430459179000	1079	598	1	0	838
63275	1397	1430439177000	1080	599	0	0	840
63276	1397	1430429176000	1081	600	0	0	841
63279	1397	1430419175000	1084	601	0	0	842
63282	1397	1430409174000	1088	602	0	0	843
63283	1693	1546636745463	1089	603	0	0	82
63285	1693	1508151608590	1089	603	2	0	84
63286	1693	1470807799267	1089	603	3	0	85
63287	1693	1355937977967	1089	603	4	0	86
63288	1693	1318594168644	1089	603	5	0	87
63289	1397	1430399173000	1089	603	6	0	844
63291	1693	1281250359321	1089	603	8	0	88
63292	1693	1243906549998	1089	603	9	0	89
63293	1693	1206562740675	1089	603	10	0	90
63294	1693	1169218931352	1089	603	11	0	91
63296	1693	1121004377503	1089	603	13	0	93
63297	1693	1083660568180	1089	603	14	0	94
63298	1693	1046316758857	1089	603	15	0	95
63316	1397	1430379171000	1092	604	0	0	846
63317	1693	1008972949534	1092	604	1	0	96
63319	1693	934285330888	1092	604	3	0	98
63320	1693	896941521565	1092	604	4	0	99
63321	1693	859597712242	1092	604	5	0	100
63322	1693	822253902919	1092	604	6	0	101
63323	1693	784910093596	1092	604	7	0	102
63325	1397	1430369170000	1093	605	0	0	847
63326	1693	710222474950	1093	605	1	0	104
63327	1693	672878665627	1093	605	2	0	105
63328	1693	635534856304	1093	605	3	0	106
63330	1693	560847237658	1093	605	5	0	108
63331	1693	523503428335	1093	605	6	0	109
63332	1693	505076547069	1093	605	7	0	110
63333	1693	467732737746	1093	605	8	0	111
63334	1693	430388928423	1093	605	9	0	112
63340	1693	393045119100	1095	606	1	0	113
63341	1693	355701309777	1095	606	2	0	114
63342	1693	318357500454	1095	606	3	0	115
63348	1397	1430349168000	1098	607	0	0	849
63350	1397	1430339167000	1100	608	0	0	850
63352	1397	1430319165000	1102	610	0	0	852
63354	1397	1430309164000	1104	611	0	0	853
63356	1397	1430299163000	1106	612	0	0	854
63359	1397	1430289162000	1109	613	0	0	855
63367	1397	1430269160000	1114	614	1	0	857
63369	1397	1430259159000	1116	615	0	0	858
63370	1397	1430249158000	1117	616	0	0	859
63376	1397	1430239157000	1121	617	0	0	860
63380	1397	1430199153000	1123	619	0	0	\N
63382	1693	1546636745463	1125	591	0	0	\N
63383	1397	1430549188000	1125	591	1	0	\N
63384	1397	1430539187000	1125	591	2	0	\N
63385	1397	1430529186000	1125	591	3	0	\N
63386	1397	1430519185000	1125	591	4	0	\N
63387	1397	1430509184000	1125	591	5	0	\N
63388	1397	1430499183000	1125	591	6	0	\N
63389	1397	1430489182000	1125	591	7	0	\N
63390	1397	1430479181000	1125	591	8	0	\N
63391	1397	1430469180000	1125	591	9	0	\N
63392	1397	1430459179000	1125	591	10	0	\N
63393	1397	1430449178000	1125	591	11	0	\N
63394	1397	1430439177000	1125	591	12	0	\N
63395	1693	1545495417913	1125	591	13	0	\N
63396	1693	1508151608590	1125	591	14	0	\N
63397	1693	1470807799267	1125	591	15	0	\N
63398	1693	1355937977967	1125	591	16	0	\N
63399	1693	1318594168644	1125	591	17	0	\N
63400	1693	1281250359321	1125	591	18	0	\N
63401	1693	1243906549998	1125	591	19	0	\N
63402	1693	1206562740675	1125	591	20	0	\N
63403	1693	1169218931352	1125	591	21	0	\N
63404	1693	1131875122029	1125	591	22	0	\N
63405	1693	1121004377503	1125	591	23	0	\N
63406	1693	1083660568180	1125	591	24	0	\N
63407	1693	1046316758857	1125	591	25	0	\N
63408	1693	1008972949534	1125	591	26	0	\N
63409	1693	971629140211	1125	591	27	0	\N
63410	1693	934285330888	1125	591	29	0	\N
63411	1693	896941521565	1125	591	30	0	\N
63412	1693	859597712242	1125	591	31	0	\N
63413	1693	822253902919	1125	591	32	0	\N
63414	1693	784910093596	1125	591	33	0	\N
63415	1693	747566284273	1125	591	34	0	\N
63416	1693	710222474950	1125	591	35	0	\N
63417	1693	672878665627	1125	591	36	0	\N
63418	1693	635534856304	1125	591	37	0	\N
63419	1693	598191046981	1125	591	38	0	\N
63420	1693	560847237658	1125	591	39	0	\N
63421	1693	523503428335	1125	591	40	0	\N
63422	1693	505076547069	1125	591	41	0	\N
63423	1693	467732737746	1125	591	42	0	\N
63424	1693	430388928423	1125	591	43	0	\N
63425	1693	393045119100	1125	591	44	0	\N
63426	1693	355701309777	1125	591	45	0	\N
63427	1693	318357500454	1125	591	46	0	\N
63428	1397	1430429176000	1125	591	47	0	\N
63429	1397	1430419175000	1125	591	48	0	\N
63430	1397	1430409174000	1125	591	49	0	\N
63431	1397	1430399173000	1125	591	50	0	\N
63432	1397	1430389172000	1125	591	51	0	\N
63433	1397	1430379171000	1125	591	52	0	\N
63434	1397	1430369170000	1125	591	53	0	\N
63435	1397	1430359169000	1125	591	54	0	\N
63436	1397	1430349168000	1125	591	55	0	\N
63437	1397	1430339167000	1125	591	56	0	\N
63438	1397	1430329166000	1125	591	57	0	\N
63439	1397	1430319165000	1125	591	58	0	\N
63440	1397	1430309164000	1125	591	59	0	\N
63441	1397	1430299163000	1125	591	60	0	\N
63442	1397	1430289162000	1125	591	61	0	\N
63443	1397	1430279161000	1125	591	62	0	\N
63444	1397	1430269160000	1125	591	63	0	\N
63445	1397	1430259159000	1125	591	64	0	\N
63446	1397	1430249158000	1125	591	65	0	\N
63447	1397	1430239157000	1125	591	66	0	\N
63448	1397	1430229156000	1125	591	67	0	\N
63449	1397	1430219155000	1125	591	68	0	\N
63450	1397	1430209154000	1125	591	69	0	\N
63451	1397	1430199153000	1125	591	70	0	\N
63455	1397	1430169150000	1128	622	0	0	\N
63462	1397	1430109144000	1134	627	0	0	\N
63463	1397	1430099143000	1134	627	1	0	\N
63467	1397	1430089142000	1137	628	0	0	\N
63468	1397	1430079141000	1138	629	0	0	\N
63469	1397	1430079141000	1139	629	0	0	\N
63471	1397	1430069140000	1141	630	0	0	\N
63474	1397	1430059139000	1144	631	0	0	\N
63475	1397	1430059139000	1145	631	0	0	\N
63476	1397	1430049138000	1146	632	0	0	\N
63478	1397	1430049138000	1148	632	0	0	\N
63479	1397	1430049138000	1149	632	0	0	\N
63483	1397	1430009134000	1152	635	0	0	\N
63484	1397	1429999133000	1152	635	1	0	\N
63485	1397	1429989132000	1152	635	2	0	\N
63486	1397	1430009134000	1153	635	0	0	\N
63487	1397	1429999133000	1153	635	1	0	\N
63488	1397	1429989132000	1153	635	2	0	\N
63492	1397	1429979131000	1155	636	0	0	\N
63497	1397	1429949128000	1160	639	0	0	\N
63500	1397	1429939127000	1162	640	0	0	\N
63501	1397	1429929126000	1162	640	1	0	\N
63502	1397	1429919125000	1163	641	0	0	\N
63504	1397	1429909124000	1165	642	0	0	\N
63505	1397	1429899123000	1165	642	1	0	\N
63508	1397	1429889122000	1167	643	0	0	\N
63509	1397	1429889122000	1168	643	0	0	\N
63511	1397	1429889122000	1170	643	0	0	\N
63379	1397	1430209154000	1122	618	1	0	863
63381	1397	1430199153000	1124	619	0	0	864
63452	30	6000100000000	1126	620	0	0	1
63453	1397	1430189152000	1126	620	1	0	865
63454	1397	1430179151000	1127	621	0	0	866
63457	1397	1430159149000	1130	623	0	0	868
63458	1397	1430149148000	1131	624	0	0	869
63459	1397	1430139147000	1132	625	0	0	870
63460	1397	1430129146000	1132	625	1	0	871
63461	1397	1430119145000	1133	626	0	0	872
63465	1397	1430099143000	1135	627	1	0	874
63466	1397	1430089142000	1136	628	0	0	875
63470	1397	1430079141000	1140	629	0	0	876
63472	1397	1430069140000	1142	630	0	0	877
63477	1397	1430049138000	1147	632	0	0	879
63480	1397	1430039137000	1150	633	0	0	880
63481	1397	1430029136000	1151	634	0	0	881
63482	1397	1430019135000	1151	634	1	0	882
63489	1397	1430009134000	1154	635	0	0	883
63491	1397	1429989132000	1154	635	2	0	885
63493	1397	1429979131000	1156	636	0	0	886
63494	1397	1429969130000	1157	637	0	0	887
63495	1397	1429959129000	1158	638	0	0	888
63496	1397	1429949128000	1159	639	0	0	889
63499	1397	1429929126000	1161	640	1	0	891
63503	1397	1429919125000	1164	641	0	0	892
63506	1397	1429909124000	1166	642	0	0	893
63507	1397	1429899123000	1166	642	1	0	894
63512	1397	1429879121000	1171	644	0	0	896
63515	1397	1429849118000	1174	647	0	0	\N
63516	1397	1429839117000	1174	647	1	0	\N
63521	1397	1429809114000	1178	650	0	0	\N
63522	1397	1429799113000	1178	650	1	0	\N
63527	1397	1429769110000	1182	653	0	0	\N
63534	1397	1429739107000	1186	655	0	0	\N
63535	1397	1429729106000	1186	655	1	0	\N
63536	1733	719000000000	1186	655	2	0	\N
63541	1397	1429679101000	1191	658	0	0	\N
63542	1397	1429669100000	1191	658	1	0	\N
63543	1397	1429679101000	1192	658	0	0	\N
63544	1397	1429669100000	1192	658	1	0	\N
63547	1397	1429679101000	1194	658	0	0	\N
63548	1397	1429669100000	1194	658	1	0	\N
63550	1397	1429659099000	1196	659	0	0	\N
63552	1397	1429649098000	1198	660	0	0	\N
63553	1397	1429639097000	1199	661	0	0	\N
63557	1397	1429609094000	1203	664	0	0	\N
63559	1397	1429609094000	1205	664	0	0	\N
63560	1397	1429609094000	1206	664	0	0	\N
63563	1397	1429579091000	1208	666	0	0	\N
63564	1397	1429579091000	1209	666	0	0	\N
63567	1397	1429569090000	1212	667	0	0	\N
63568	1397	1429569090000	1213	667	0	0	\N
63573	1397	1429519085000	1216	670	0	0	\N
63575	1397	1429519085000	1218	670	0	0	\N
63580	1397	1429469080000	1222	674	0	0	\N
63581	1397	1429459079000	1222	674	1	0	\N
63582	1397	1429449078000	1222	674	2	0	\N
63583	1397	1429469080000	1223	674	0	0	\N
63584	1397	1429459079000	1223	674	1	0	\N
63585	1397	1429449078000	1223	674	2	0	\N
63590	1397	1429429076000	1226	676	0	0	\N
63594	1397	1429399073000	1230	679	0	0	\N
63595	1397	1429389072000	1230	679	1	0	\N
63604	1397	1429329066000	1237	684	0	0	\N
63605	1397	1429319065000	1238	685	0	0	\N
63606	1397	1429319065000	1239	685	0	0	\N
63612	1397	1429269060000	1245	690	0	0	\N
63614	1397	1429269060000	1247	690	0	0	\N
63615	1397	1429259059000	1248	691	0	0	\N
63618	1397	1429249058000	1251	692	0	0	\N
63621	1397	1429239057000	1253	693	0	0	\N
63622	1397	1429229056000	1253	693	1	0	\N
63623	1397	1429219055000	1255	694	0	0	\N
63631	1397	1429159049000	1260	697	0	0	\N
63632	1397	1429159049000	1261	697	0	0	\N
63633	1397	1429149048000	1262	698	0	0	\N
63634	1397	1429139047000	1262	698	1	0	\N
63635	1397	1429129046000	1262	698	2	0	\N
63636	1397	1429119045000	1262	698	3	0	\N
63641	1397	1429149048000	1264	698	0	0	\N
63642	1397	1429139047000	1264	698	1	0	\N
63643	1397	1429129046000	1264	698	2	0	\N
63644	1397	1429119045000	1264	698	3	0	\N
63645	1397	1429289062000	1265	688	0	0	\N
63646	1397	1429279061000	1265	688	1	0	\N
63647	1397	1429269060000	1265	688	2	0	\N
63648	1397	1429259059000	1265	688	3	0	\N
63517	1397	1429849118000	1175	647	0	0	899
63518	1397	1429839117000	1175	647	1	0	900
63519	1397	1429829116000	1176	648	0	0	901
63520	1397	1429819115000	1177	649	0	0	902
63523	1397	1429809114000	1179	650	0	0	903
63525	1397	1429789112000	1180	651	0	0	905
63526	1397	1429779111000	1181	652	0	0	906
63528	1397	1429769110000	1183	653	0	0	907
63529	1397	1429759109000	1184	654	0	0	908
63530	1397	1429749108000	1184	654	1	0	909
63532	1397	1429729106000	1185	655	1	0	911
63533	1733	719000000000	1185	655	2	0	1
63537	1397	1429719105000	1187	656	0	0	912
63538	1397	1429709104000	1187	656	1	0	913
63540	1397	1429689102000	1190	657	0	0	915
63545	1397	1429679101000	1193	658	0	0	916
63546	1397	1429669100000	1193	658	1	0	917
63549	1397	1429659099000	1195	659	0	0	918
63551	1397	1429649098000	1197	660	0	0	919
63555	1397	1429629096000	1201	662	0	0	921
63556	1397	1429619095000	1202	663	0	0	922
63558	1397	1429609094000	1204	664	0	0	923
63561	1397	1429599093000	1207	665	0	0	924
63562	1397	1429589092000	1207	665	1	0	925
63566	1397	1429569090000	1211	667	0	0	927
63569	1397	1429559089000	1214	668	0	0	928
63570	1397	1429549088000	1215	669	0	0	929
63571	1397	1429539087000	1215	669	1	0	930
63574	1397	1429519085000	1217	670	0	0	932
63576	1397	1429509084000	1219	671	0	0	933
63577	1397	1429499083000	1220	672	0	0	934
63578	1397	1429489082000	1221	673	0	0	935
63579	1397	1429479081000	1221	673	1	0	936
63587	1397	1429459079000	1224	674	1	0	938
63588	1397	1429449078000	1224	674	2	0	939
63589	1397	1429439077000	1225	675	0	0	940
63591	1397	1429429076000	1227	676	0	0	941
63592	1397	1429419075000	1228	677	0	0	942
63596	1397	1429399073000	1231	679	0	0	944
63597	1397	1429389072000	1231	679	1	0	945
63598	1397	1429379071000	1232	680	0	0	946
63599	1397	1429369070000	1233	681	0	0	947
63601	1397	1429349068000	1234	682	1	0	949
63602	1397	1429339067000	1235	683	0	0	950
63603	1397	1429329066000	1236	684	0	0	951
63607	1397	1429319065000	1240	685	0	0	952
63608	1397	1429309064000	1241	686	0	0	953
63610	1397	1429289062000	1243	688	0	0	955
63611	1397	1429279061000	1244	689	0	0	956
63613	1397	1429269060000	1246	690	0	0	957
63616	1397	1429259059000	1249	691	0	0	958
63617	1397	1429249058000	1250	692	0	0	959
63620	1397	1429229056000	1252	693	1	0	961
63624	1397	1429219055000	1256	694	0	0	962
63625	1397	1429209054000	1257	695	0	0	963
63626	1397	1429199053000	1258	696	0	0	964
63628	1397	1429179051000	1258	696	2	0	966
63629	1397	1429169050000	1258	696	3	0	967
63630	1397	1429159049000	1259	697	0	0	968
63637	1397	1429149048000	1263	698	0	0	969
63638	1397	1429139047000	1263	698	1	0	970
63640	1397	1429119045000	1263	698	3	0	972
63649	1397	1429249058000	1265	688	4	0	\N
63650	1397	1429239057000	1265	688	5	0	\N
63651	1397	1429229056000	1265	688	6	0	\N
63652	1397	1429219055000	1265	688	7	0	\N
63653	1397	1429209054000	1265	688	8	0	\N
63654	1397	1429199053000	1265	688	9	0	\N
63655	1397	1429189052000	1265	688	10	0	\N
63656	1397	1429179051000	1265	688	11	0	\N
63657	1397	1429169050000	1265	688	12	0	\N
63658	1397	1429159049000	1265	688	13	0	\N
63659	1397	1429149048000	1265	688	14	0	\N
63660	1397	1429139047000	1265	688	15	0	\N
63661	1397	1429129046000	1265	688	16	0	\N
63662	1397	1429119045000	1265	688	17	0	\N
63663	1397	1429109044000	1265	688	18	0	\N
63664	1397	1429109044000	1266	699	0	0	\N
63665	1397	1429099043000	1266	699	1	0	\N
63666	1397	1429089042000	1266	699	2	0	\N
63671	1397	1429069040000	1269	701	0	0	\N
63672	1397	1429069040000	1270	701	0	0	\N
63675	1397	1429059039000	1273	702	0	0	\N
63676	1397	1429059039000	1274	702	0	0	\N
63679	1397	1429029036000	1277	705	0	0	\N
63684	1397	1428989032000	1282	709	0	0	\N
63685	1397	1428989032000	1283	709	0	0	\N
63686	1397	1428989032000	1284	709	0	0	\N
63687	1397	1428989032000	1285	709	0	0	\N
63693	1397	1428949028000	1290	712	0	0	\N
63695	1397	1428939027000	1292	713	0	0	\N
63698	1397	1428929026000	1294	714	0	0	\N
63699	1693	1758267500454	1294	714	1	0	\N
63701	1397	1428909024000	1296	716	0	0	\N
63702	1397	1428899023000	1296	716	1	0	\N
63703	1397	1428889022000	1296	716	2	0	\N
63704	1397	1428879021000	1296	716	3	0	\N
63705	1397	1428909024000	1297	716	0	0	\N
63706	1397	1428899023000	1297	716	1	0	\N
63707	1397	1428889022000	1297	716	2	0	\N
63708	1397	1428879021000	1297	716	3	0	\N
63709	1397	1428909024000	1298	716	0	0	\N
63710	1397	1428899023000	1298	716	1	0	\N
63711	1397	1428889022000	1298	716	2	0	\N
63712	1397	1428879021000	1298	716	3	0	\N
63717	1397	1428909024000	1300	716	0	0	\N
63718	1397	1428899023000	1300	716	1	0	\N
63719	1397	1428889022000	1300	716	2	0	\N
63720	1397	1428879021000	1300	716	3	0	\N
63722	1397	1428869020000	1302	717	0	0	\N
63731	1397	1428799013000	1310	722	0	0	\N
63735	1397	1428779011000	1314	724	0	0	\N
63736	1397	1428779011000	1315	724	0	0	\N
63737	1397	1428769010000	1316	725	0	0	\N
63739	1397	1428759009000	1318	726	0	0	\N
63746	1397	1428749008000	1321	727	0	0	\N
63747	1397	1428739007000	1321	727	1	0	\N
63748	1397	1428729006000	1321	727	2	0	\N
63749	1397	1428719005000	1321	727	3	0	\N
63750	1397	1428709004000	1321	727	4	0	\N
63754	1397	1428699003000	1325	728	0	0	\N
63755	1397	1428689002000	1325	728	1	0	\N
63756	1740	4317539000000	1325	728	2	0	\N
63761	1397	1428638997000	1328	731	0	0	\N
63764	1397	1428628996000	1331	732	0	0	\N
63766	1397	1428618995000	1333	733	0	0	\N
63767	1397	1429099043000	1334	689	0	0	\N
63768	1397	1429089042000	1334	689	1	0	\N
63769	1397	1429079041000	1334	689	2	0	\N
63770	1397	1429069040000	1334	689	3	0	\N
63771	1397	1429059039000	1334	689	4	0	\N
63772	1397	1429049038000	1334	689	5	0	\N
63773	1397	1429039037000	1334	689	6	0	\N
63774	1397	1429029036000	1334	689	7	0	\N
63775	1397	1429019035000	1334	689	8	0	\N
63776	1397	1429009034000	1334	689	9	0	\N
63777	1397	1428999033000	1334	689	10	0	\N
63778	1397	1428989032000	1334	689	11	0	\N
63779	1397	1428979031000	1334	689	12	0	\N
63780	1693	1758267500454	1334	689	13	0	\N
63781	1397	1428969030000	1334	689	14	0	\N
63782	1397	1428959029000	1334	689	15	0	\N
63783	1397	1428949028000	1334	689	16	0	\N
63784	1397	1428939027000	1334	689	17	0	\N
63669	1397	1429089042000	1267	699	2	0	975
63670	1397	1429079041000	1268	700	0	0	976
63673	1397	1429069040000	1271	701	0	0	977
63674	1397	1429059039000	1272	702	0	0	978
63677	1397	1429049038000	1275	703	0	0	979
63680	1397	1429029036000	1278	705	0	0	981
63681	1397	1429019035000	1279	706	0	0	982
63682	1397	1429009034000	1280	707	0	0	983
63683	1397	1428999033000	1281	708	0	0	984
63688	1397	1428989032000	1286	709	0	0	985
63690	1397	1428969030000	1288	711	0	0	987
63691	1397	1428959029000	1288	711	1	0	988
63692	1397	1428949028000	1289	712	0	0	989
63694	1397	1428939027000	1291	713	0	0	990
63697	1693	1758267500454	1293	714	1	0	116
63700	1397	1428919025000	1295	715	0	0	992
63713	1397	1428909024000	1299	716	0	0	993
63714	1397	1428899023000	1299	716	1	0	994
63715	1397	1428889022000	1299	716	2	0	995
63721	1397	1428869020000	1301	717	0	0	997
63723	1397	1428859019000	1303	718	0	0	998
63724	1397	1428849018000	1303	718	1	0	999
63725	563	68158529000000	1303	718	2	0	1
63726	1397	1428839017000	1304	719	0	0	1000
63728	1397	1428819015000	1306	721	0	0	1002
63729	1397	1428809014000	1306	721	1	0	1003
63730	563	66000528000000	1306	721	2	0	2
63732	1397	1428799013000	1311	722	0	0	1004
63734	1397	1428779011000	1313	724	0	0	1006
63738	1397	1428769010000	1317	725	0	0	1007
63740	1397	1428759009000	1319	726	0	0	1008
63741	1397	1428749008000	1320	727	0	0	1009
63742	1397	1428739007000	1320	727	1	0	1010
63744	1397	1428719005000	1320	727	3	0	1012
63745	1397	1428709004000	1320	727	4	0	1013
63751	1397	1428699003000	1324	728	0	0	1014
63752	1397	1428689002000	1324	728	1	0	1015
63753	1740	4317539000000	1324	728	2	0	1
63758	1397	1428669000000	1326	729	1	0	1017
63759	1397	1428658999000	1326	729	2	0	1018
63760	1397	1428648998000	1327	730	0	0	1019
63762	1397	1428638997000	1329	731	0	0	1020
63765	1397	1428618995000	1332	733	0	0	1022
63785	1397	1428929026000	1334	689	18	0	\N
63786	1397	1428919025000	1334	689	19	0	\N
63787	1397	1428909024000	1334	689	20	0	\N
63788	1397	1428899023000	1334	689	21	0	\N
63789	1397	1428889022000	1334	689	22	0	\N
63790	1397	1428879021000	1334	689	23	0	\N
63791	1397	1428869020000	1334	689	24	0	\N
63792	1397	1428859019000	1334	689	25	0	\N
63793	1397	1428849018000	1334	689	26	0	\N
63794	1397	1428839017000	1334	689	27	0	\N
63795	1397	1428829016000	1334	689	28	0	\N
63796	1397	1428819015000	1334	689	29	0	\N
63797	1397	1428809014000	1334	689	30	0	\N
63798	1397	1428799013000	1334	689	31	0	\N
63799	1397	1428789012000	1334	689	32	0	\N
63800	1397	1428779011000	1334	689	33	0	\N
63801	1397	1428769010000	1334	689	34	0	\N
63802	1397	1428759009000	1334	689	36	0	\N
63803	1397	1428749008000	1334	689	37	0	\N
63804	1397	1428739007000	1334	689	38	0	\N
63805	1397	1428729006000	1334	689	39	0	\N
63806	1397	1428719005000	1334	689	40	0	\N
63807	1397	1428709004000	1334	689	41	0	\N
63808	1397	1428699003000	1334	689	42	0	\N
63809	1397	1428689002000	1334	689	43	0	\N
63810	1397	1428679001000	1334	689	44	0	\N
63811	1397	1428669000000	1334	689	45	0	\N
63812	1397	1428658999000	1334	689	46	0	\N
63813	1397	1428648998000	1334	689	47	0	\N
63814	1397	1428638997000	1334	689	48	0	\N
63815	1397	1428628996000	1334	689	49	0	\N
63816	1397	1428618995000	1334	689	50	0	\N
63817	1397	1428608994000	1334	689	51	0	\N
63818	563	68158529000000	1334	689	52	0	\N
63819	1740	2159539000000	1334	689	53	0	\N
63820	563	66000528000000	1334	689	54	0	\N
63824	1397	1428588992000	1337	735	0	0	\N
63825	1397	1428578991000	1338	736	0	0	\N
63826	1397	1428598993000	1339	690	0	0	\N
63827	1397	1428588992000	1339	690	1	0	\N
63828	1397	1428578991000	1339	690	2	0	\N
63832	1397	1428548988000	1343	739	0	0	\N
63833	1397	1428568990000	1344	691	0	0	\N
63834	1397	1428558989000	1344	691	1	0	\N
63835	1397	1428548988000	1344	691	2	0	\N
63837	1397	1428538987000	1346	740	0	0	\N
63838	1397	1428538987000	1347	740	0	0	\N
63840	1397	1428538987000	1349	740	0	0	\N
63841	1397	1428538987000	1350	740	0	0	\N
63844	1397	1428518985000	1353	742	0	0	\N
63845	1397	1428508984000	1354	743	0	0	\N
63846	1397	1428498983000	1354	743	1	0	\N
63853	1397	1428458979000	1357	745	0	0	\N
63855	1397	1428458979000	1359	745	0	0	\N
63856	1397	1428448978000	1360	746	0	0	\N
63860	1397	1428438977000	1363	747	0	0	\N
63861	1748	999000000	1363	747	1	0	\N
63862	1397	1428438977000	1364	747	0	0	\N
63863	1748	999000000	1364	747	1	0	\N
63866	1397	1428418975000	1367	749	0	0	\N
63867	1397	1428408974000	1368	750	0	0	\N
63870	1397	1428398973000	1371	751	0	0	\N
63872	1397	1428388972000	1373	752	0	0	\N
63875	1397	1428358969000	1375	754	0	0	\N
63876	1397	1428358969000	1376	754	0	0	\N
63882	1744	900000000	1380	692	0	0	\N
63883	1397	1428538987000	1380	692	1	0	\N
63884	1397	1428528986000	1380	692	2	0	\N
63885	1397	1428518985000	1380	692	3	0	\N
63886	1397	1428508984000	1380	692	4	0	\N
63887	1397	1428498983000	1380	692	5	0	\N
63888	1397	1428488982000	1380	692	6	0	\N
63889	1397	1428478981000	1380	692	7	0	\N
63890	1397	1428468980000	1380	692	8	0	\N
63891	1397	1428458979000	1380	692	9	0	\N
63892	1397	1428448978000	1380	692	10	0	\N
63893	1397	1428438977000	1380	692	11	0	\N
63894	1397	1428428976000	1380	692	12	0	\N
63895	1397	1428418975000	1380	692	13	0	\N
63896	1397	1428408974000	1380	692	14	0	\N
63897	1397	1428398973000	1380	692	15	0	\N
63898	1397	1428388972000	1380	692	16	0	\N
63899	1397	1428378971000	1380	692	17	0	\N
63900	1397	1428368970000	1380	692	18	0	\N
63901	1397	1428358969000	1380	692	19	0	\N
63902	1397	1428348968000	1380	692	20	0	\N
63903	1397	1428338967000	1380	692	21	0	\N
63904	1397	1428328966000	1380	692	22	0	\N
63905	1397	1428318965000	1380	692	23	0	\N
63906	1397	1428308964000	1380	692	24	0	\N
63907	1740	4316538000000	1380	692	25	0	\N
63908	1397	1428318965000	1381	757	0	0	\N
63909	1397	1428308964000	1381	757	1	0	\N
63920	1397	1428218955000	1386	761	0	0	\N
63823	1397	1428588992000	1336	735	0	0	1025
63829	1397	1428578991000	1340	736	0	0	1026
63830	1397	1428568990000	1341	737	0	0	1027
63831	1397	1428558989000	1342	738	0	0	1028
63836	1397	1428548988000	1345	739	0	0	1029
63842	1397	1428528986000	1351	741	0	0	1031
63843	1397	1428518985000	1352	742	0	0	1032
63847	1397	1428508984000	1355	743	0	0	1033
63848	1397	1428498983000	1355	743	1	0	1034
63849	1397	1428488982000	1356	744	0	0	1035
63851	1397	1428468980000	1356	744	2	0	1037
63852	1740	5036548000000	1356	744	3	0	2
63854	1397	1428458979000	1358	745	0	0	1038
63857	1397	1428448978000	1361	746	0	0	1039
63859	1748	999000000	1362	747	1	0	1
63864	1397	1428428976000	1365	748	0	0	1041
63865	1397	1428418975000	1366	749	0	0	1042
63868	1397	1428408974000	1369	750	0	0	1043
63869	1397	1428398973000	1370	751	0	0	1044
63873	1397	1428378971000	1374	753	0	0	1046
63874	1397	1428368970000	1374	753	1	0	1047
63877	1397	1428358969000	1377	754	0	0	1048
63878	1397	1428348968000	1378	755	0	0	1049
63879	1744	900000000	1379	756	0	0	1
63881	1397	1428328966000	1379	756	2	0	1051
63910	1397	1428318965000	1382	757	0	0	1052
63911	1397	1428308964000	1382	757	1	0	1053
63912	1397	1428298963000	1383	758	0	0	1054
63914	1397	1428278961000	1383	758	2	0	1056
63915	1397	1428268960000	1383	758	3	0	1057
63916	1397	1428258959000	1383	758	4	0	1058
63917	1397	1428248958000	1383	758	5	0	1059
63918	1397	1428238957000	1384	759	0	0	1060
63921	1397	1428208954000	1386	761	1	0	\N
63922	1397	1428198953000	1386	761	2	0	\N
63923	1397	1428188952000	1386	761	3	0	\N
63924	1700	2159110000000	1386	761	4	0	\N
63925	1397	1428178951000	1386	761	5	0	\N
63926	1397	1428218955000	1387	761	0	0	\N
63927	1397	1428208954000	1387	761	1	0	\N
63928	1397	1428198953000	1387	761	2	0	\N
63929	1397	1428188952000	1387	761	3	0	\N
63930	1700	2159110000000	1387	761	4	0	\N
63931	1397	1428178951000	1387	761	5	0	\N
63938	1397	1428168950000	1389	762	0	0	\N
63940	1397	1428168950000	1391	762	0	0	\N
63941	1397	1428168950000	1392	762	0	0	\N
63942	1397	1428168950000	1393	762	0	0	\N
63944	1397	1428158949000	1395	763	0	0	\N
63945	1397	1428158949000	1396	763	0	0	\N
63948	1397	1428148948000	1398	764	0	0	\N
63949	1397	1428138947000	1398	764	1	0	\N
63957	1397	1428068940000	1402	767	0	0	\N
63958	1397	1428068940000	1403	767	0	0	\N
63959	1397	1428068940000	1404	767	0	0	\N
63962	1397	1428058939000	1406	768	0	0	\N
63963	1722	5756080000000	1406	768	1	0	\N
63964	1397	1428058939000	1407	768	0	0	\N
63965	1722	5756080000000	1407	768	1	0	\N
63966	1397	1428058939000	1408	768	0	0	\N
63967	1722	5756080000000	1408	768	1	0	\N
63969	1397	1428048938000	1410	769	0	0	\N
63970	1397	1428048938000	1411	769	0	0	\N
63971	1735	1439009000000	1412	770	0	0	\N
63972	1397	1428038937000	1412	770	1	0	\N
63973	1397	1428028936000	1412	770	2	0	\N
63978	1397	1428018935000	1415	771	0	0	\N
63979	1397	1428018935000	1416	771	0	0	\N
63980	1397	1428018935000	1417	771	0	0	\N
63981	1397	1428008934000	1418	772	0	0	\N
63984	1397	1428008934000	1420	772	0	0	\N
63986	1397	1427988932000	1423	774	0	0	\N
63987	1397	1427978931000	1423	774	1	0	\N
63988	1397	1427988932000	1424	774	0	0	\N
63989	1397	1427978931000	1424	774	1	0	\N
63990	1397	1427988932000	1425	775	0	0	\N
63991	1397	1427978931000	1425	775	1	0	\N
63992	1397	1427968930000	1425	775	2	0	\N
63997	1397	1427958929000	1428	776	0	0	\N
64003	1397	1427898923000	1432	780	0	0	\N
64004	1397	1427888922000	1432	780	1	0	\N
64005	1397	1427878921000	1432	780	2	0	\N
64009	1397	1427868920000	1434	781	0	0	\N
64015	1397	1427838917000	1438	783	0	0	\N
64016	1397	1427828916000	1438	783	1	0	\N
64018	1397	1427818915000	1440	784	0	0	\N
64019	1397	1427808914000	1441	785	0	0	\N
64020	1397	1427798913000	1441	785	1	0	\N
64023	1397	1427808914000	1443	785	0	0	\N
64024	1397	1427798913000	1443	785	1	0	\N
64025	1722	5756080000000	1444	693	0	0	\N
64026	1735	1439009000000	1444	693	1	0	\N
64027	1397	1428298963000	1444	693	2	0	\N
64028	1397	1428288962000	1444	693	3	0	\N
64029	1397	1428278961000	1444	693	4	0	\N
64030	1397	1428268960000	1444	693	5	0	\N
64031	1397	1428258959000	1444	693	6	0	\N
64032	1397	1428248958000	1444	693	7	0	\N
64033	1397	1428238957000	1444	693	8	0	\N
64034	1397	1428228956000	1444	693	9	0	\N
64035	1397	1428218955000	1444	693	10	0	\N
64036	1397	1428208954000	1444	693	11	0	\N
64037	1397	1428198953000	1444	693	12	0	\N
64038	1397	1428188952000	1444	693	13	0	\N
64039	1700	2159110000000	1444	693	14	0	\N
64040	1397	1428178951000	1444	693	15	0	\N
64041	1397	1428168950000	1444	693	16	0	\N
64042	1397	1428158949000	1444	693	17	0	\N
64043	1397	1428148948000	1444	693	18	0	\N
64044	1397	1428138947000	1444	693	19	0	\N
64045	1397	1428128946000	1444	693	20	0	\N
64046	1397	1428118945000	1444	693	21	0	\N
64047	1397	1428108944000	1444	693	22	0	\N
64048	1397	1428098943000	1444	693	23	0	\N
64049	1397	1428088942000	1444	693	24	0	\N
64050	1397	1428078941000	1444	693	25	0	\N
64051	1397	1428068940000	1444	693	26	0	\N
64052	1397	1428058939000	1444	693	27	0	\N
64053	1397	1428048938000	1444	693	28	0	\N
64054	1397	1428038937000	1444	693	29	0	\N
64055	1397	1428028936000	1444	693	30	0	\N
64056	1397	1428018935000	1444	693	31	0	\N
63934	1397	1428198953000	1388	761	2	0	1064
63935	1397	1428188952000	1388	761	3	0	1065
63936	1700	2159110000000	1388	761	4	0	1
63937	1397	1428178951000	1388	761	5	0	1066
63939	1397	1428168950000	1390	762	0	0	1067
63946	1397	1428148948000	1397	764	0	0	1069
63947	1397	1428138947000	1397	764	1	0	1070
63950	1397	1428128946000	1399	765	0	0	1071
63951	1397	1428118945000	1399	765	1	0	1072
63952	1397	1428108944000	1399	765	2	0	1073
63954	1397	1428088942000	1399	765	4	0	1075
63955	1397	1428078941000	1400	766	0	0	1076
63956	1397	1428068940000	1401	767	0	0	1077
63960	1397	1428058939000	1405	768	0	0	1078
63968	1397	1428048938000	1409	769	0	0	1079
63974	1735	1439009000000	1413	770	0	0	2
63975	1397	1428038937000	1413	770	1	0	1080
63976	1397	1428028936000	1413	770	2	0	1081
63977	1397	1428018935000	1414	771	0	0	1082
63983	1735	1438006000000	1419	772	1	0	3
63985	1397	1427998933000	1421	773	0	0	1084
63993	1397	1427988932000	1426	775	0	0	1085
63994	1397	1427978931000	1426	775	1	0	1086
63995	1397	1427968930000	1426	775	2	0	1087
63998	1397	1427948928000	1429	777	0	0	1089
63999	1397	1427938927000	1430	778	0	0	1090
64000	1397	1427928926000	1430	778	1	0	1091
64001	1397	1427918925000	1430	778	2	0	1092
64006	1397	1427898923000	1433	780	0	0	1094
64007	1397	1427888922000	1433	780	1	0	1095
64008	1397	1427878921000	1433	780	2	0	1096
64010	1397	1427868920000	1435	781	0	0	1097
64011	1397	1427858919000	1436	782	0	0	1098
64013	1397	1427838917000	1437	783	0	0	1100
64014	1397	1427828916000	1437	783	1	0	1101
64017	1397	1427818915000	1439	784	0	0	1102
64021	1397	1427808914000	1442	785	0	0	1103
64022	1397	1427798913000	1442	785	1	0	1104
64057	1397	1428008934000	1444	693	32	0	\N
64058	1397	1427998933000	1444	693	33	0	\N
64059	1397	1427988932000	1444	693	34	0	\N
64060	1397	1427978931000	1444	693	35	0	\N
64061	1397	1427968930000	1444	693	36	0	\N
64062	1397	1427958929000	1444	693	37	0	\N
64063	1397	1427948928000	1444	693	38	0	\N
64064	1397	1427938927000	1444	693	39	0	\N
64065	1397	1427928926000	1444	693	40	0	\N
64066	1397	1427918925000	1444	693	41	0	\N
64067	1397	1427908924000	1444	693	42	0	\N
64068	1397	1427898923000	1444	693	43	0	\N
64069	1397	1427888922000	1444	693	44	0	\N
64070	1397	1427878921000	1444	693	45	0	\N
64071	1397	1427868920000	1444	693	46	0	\N
64072	1397	1427858919000	1444	693	47	0	\N
64073	1397	1427848918000	1444	693	48	0	\N
64074	1397	1427838917000	1444	693	49	0	\N
64075	1397	1427828916000	1444	693	50	0	\N
64076	1397	1427818915000	1444	693	51	0	\N
64077	1397	1427808914000	1444	693	52	0	\N
64078	1397	1427798913000	1444	693	53	0	\N
64079	1735	1438006000000	1444	693	54	0	\N
64080	1397	1427808914000	1445	785	0	0	\N
64081	1397	1427798913000	1445	785	1	0	\N
64084	1397	1427778911000	1448	787	0	0	\N
64096	1397	1427698903000	1455	793	0	0	\N
64097	1745	9506000000	1455	793	1	0	\N
64098	1397	1427698903000	1456	793	0	0	\N
64099	1745	9506000000	1456	793	1	0	\N
64100	1397	1427698903000	1457	793	0	0	\N
64101	1745	9506000000	1457	793	1	0	\N
64103	1397	1427678901000	1459	795	0	0	\N
64104	1397	1427668900000	1459	795	1	0	\N
64105	1397	1427658899000	1459	795	2	0	\N
64106	1397	1427648898000	1459	795	3	0	\N
64112	1397	1427638897000	1462	796	0	0	\N
64119	1740	4316513000000	1469	694	0	0	\N
64120	1397	1427788912000	1469	694	1	0	\N
64121	1397	1427778911000	1469	694	2	0	\N
64122	1397	1427768910000	1469	694	3	0	\N
64123	1397	1427758909000	1469	694	4	0	\N
64124	1397	1427748908000	1469	694	5	0	\N
64125	1397	1427738907000	1469	694	6	0	\N
64126	1397	1427728906000	1469	694	7	0	\N
64127	1397	1427718905000	1469	694	8	0	\N
64128	1397	1427708904000	1469	694	9	0	\N
64129	1397	1427698903000	1469	694	10	0	\N
64130	1397	1427688902000	1469	694	12	0	\N
64131	1397	1427678901000	1469	694	13	0	\N
64132	1397	1427668900000	1469	694	14	0	\N
64133	1397	1427658899000	1469	694	15	0	\N
64134	1397	1427648898000	1469	694	16	0	\N
64135	1397	1427638897000	1469	694	17	0	\N
64136	1397	1427628896000	1469	694	18	0	\N
64137	1397	1427618895000	1469	694	19	0	\N
64138	1397	1427608894000	1469	694	20	0	\N
64139	1397	1427598893000	1469	694	21	0	\N
64140	1397	1427588892000	1469	694	22	0	\N
64141	1397	1427578891000	1469	694	23	0	\N
64142	1735	1420000000000	1469	694	24	0	\N
64145	1397	1427558889000	1472	803	0	0	\N
64148	1397	1427528886000	1474	805	0	0	\N
64149	1397	1427518885000	1474	805	1	0	\N
64150	1397	1427508884000	1474	805	2	0	\N
64151	1397	1427498883000	1474	805	3	0	\N
64152	1397	1427488882000	1474	805	4	0	\N
64158	1397	1427528886000	1476	805	0	0	\N
64159	1397	1427518885000	1476	805	1	0	\N
64160	1397	1427508884000	1476	805	2	0	\N
64161	1397	1427498883000	1476	805	3	0	\N
64162	1397	1427488882000	1476	805	4	0	\N
64163	1397	1427478881000	1477	806	0	0	\N
64168	1397	1427468880000	1480	807	0	0	\N
64169	1397	1427458879000	1480	807	1	0	\N
64170	1745	8405000000	1480	807	2	0	\N
64171	1397	1427448878000	1481	808	0	0	\N
64172	1397	1427438877000	1481	808	1	0	\N
64177	1397	1427408874000	1485	811	0	0	\N
64178	1752	99000000	1485	811	1	0	\N
64183	1397	1427398873000	1488	812	0	0	\N
64184	1397	1427388872000	1488	812	1	0	\N
64187	1397	1427378871000	1490	813	0	0	\N
64188	1752	97000000	1490	813	1	0	\N
64085	1397	1427768910000	1449	788	0	0	1107
64086	1397	1427758909000	1450	789	0	0	1108
64087	1397	1427748908000	1450	789	1	0	1109
64088	1735	1420000000000	1450	789	2	0	4
64089	1397	1427738907000	1451	790	0	0	1110
64091	1740	5036523000000	1453	792	0	0	3
64092	1397	1427718905000	1453	792	1	0	1112
64093	1397	1427708904000	1453	792	2	0	1113
64094	1397	1427698903000	1454	793	0	0	1114
64095	1745	9506000000	1454	793	1	0	1
64107	1397	1427678901000	1460	795	0	0	1116
64108	1397	1427668900000	1460	795	1	0	1117
64109	1397	1427658899000	1460	795	2	0	1118
64110	1397	1427648898000	1460	795	3	0	1119
64113	1397	1427628896000	1464	797	0	0	1121
64114	1397	1427618895000	1465	798	0	0	1122
64115	1397	1427608894000	1466	799	0	0	1123
64116	1397	1427598893000	1466	799	1	0	1124
64117	1397	1427588892000	1467	800	0	0	1125
64143	1397	1427568890000	1470	802	0	0	1127
64144	1397	1427558889000	1471	803	0	0	1128
64146	1397	1427548888000	1473	804	0	0	1129
64147	1397	1427538887000	1473	804	1	0	1130
64153	1397	1427528886000	1475	805	0	0	1131
64155	1397	1427508884000	1475	805	2	0	1133
64156	1397	1427498883000	1475	805	3	0	1134
64157	1397	1427488882000	1475	805	4	0	1135
64164	1397	1427478881000	1478	806	0	0	1136
64166	1397	1427458879000	1479	807	1	0	1138
64167	1745	8405000000	1479	807	2	0	2
64173	1397	1427448878000	1482	808	0	0	1139
64174	1397	1427438877000	1482	808	1	0	1140
64175	1397	1427428876000	1483	809	0	0	1141
64179	1397	1427408874000	1486	811	0	0	1143
64180	1752	99000000	1486	811	1	0	1
64181	1397	1427398873000	1487	812	0	0	1144
64182	1397	1427388872000	1487	812	1	0	1145
64185	1397	1427378871000	1489	813	0	0	1146
64189	1397	1427368870000	1491	814	0	0	1147
64190	1397	1427358869000	1492	815	0	0	1148
64191	1397	1427348868000	1493	816	0	0	1149
64192	1397	1427338867000	1494	817	0	0	1150
64193	1397	1427568890000	1495	695	0	0	\N
64194	1397	1427558889000	1495	695	1	0	\N
64195	1397	1427548888000	1495	695	2	0	\N
64196	1397	1427538887000	1495	695	3	0	\N
64197	1397	1427528886000	1495	695	4	0	\N
64198	1397	1427518885000	1495	695	5	0	\N
64199	1397	1427508884000	1495	695	6	0	\N
64200	1397	1427498883000	1495	695	7	0	\N
64201	1397	1427488882000	1495	695	8	0	\N
64202	1397	1427478881000	1495	695	9	0	\N
64203	1397	1427468880000	1495	695	10	0	\N
64204	1397	1427458879000	1495	695	11	0	\N
64205	1397	1427448878000	1495	695	12	0	\N
64206	1397	1427438877000	1495	695	13	0	\N
64207	1397	1427428876000	1495	695	14	0	\N
64208	1397	1427418875000	1495	695	15	0	\N
64209	1397	1427408874000	1495	695	16	0	\N
64210	1397	1427398873000	1495	695	17	0	\N
64211	1397	1427388872000	1495	695	18	0	\N
64212	1397	1427378871000	1495	695	19	0	\N
64213	1397	1427368870000	1495	695	20	0	\N
64214	1397	1427358869000	1495	695	21	0	\N
64215	1397	1427348868000	1495	695	22	0	\N
64216	1397	1427338867000	1495	695	23	0	\N
64217	1397	1427328866000	1495	695	24	0	\N
64218	1397	1427328866000	1496	818	0	0	\N
64219	1397	1427318865000	1496	818	1	0	\N
64220	1397	1427308864000	1496	818	2	0	\N
64221	1749	703990000000	1496	818	3	0	\N
64222	1397	1427328866000	1497	818	0	0	\N
64223	1397	1427318865000	1497	818	1	0	\N
64224	1397	1427308864000	1497	818	2	0	\N
64225	1749	703990000000	1497	818	3	0	\N
64239	1397	1427228856000	1507	826	0	0	\N
64240	1397	1427228856000	1508	826	0	0	\N
64241	1397	1427228856000	1509	826	0	0	\N
64242	1397	1427218855000	1510	827	0	0	\N
64243	1397	1427208854000	1510	827	1	0	\N
64244	1397	1427218855000	1511	827	0	0	\N
64245	1397	1427208854000	1511	827	1	0	\N
64248	1397	1427198853000	1513	828	0	0	\N
64249	1397	1427188852000	1513	828	1	0	\N
64259	1397	1427128846000	1518	831	0	0	\N
64260	1397	1427118845000	1519	832	0	0	\N
64261	1397	1427108844000	1519	832	1	0	\N
64264	1397	1427098843000	1521	833	0	0	\N
64265	1397	1427088842000	1521	833	1	0	\N
64268	1397	1427098843000	1523	833	0	0	\N
64269	1397	1427088842000	1523	833	1	0	\N
64275	1397	1427068840000	1526	835	0	0	\N
64276	1397	1427058839000	1526	835	1	0	\N
64277	1397	1427048838000	1526	835	2	0	\N
64278	1397	1427038837000	1526	835	3	0	\N
64281	1397	1427018835000	1529	837	0	0	\N
64282	1397	1427018835000	1530	837	0	0	\N
64284	1397	1426998833000	1532	839	0	0	\N
64285	1397	1426998833000	1533	839	0	0	\N
64287	1397	1426988832000	1535	840	0	0	\N
64288	1397	1426988832000	1536	840	0	0	\N
64291	1397	1426968830000	1539	842	0	0	\N
64292	1397	1426978831000	1541	841	0	0	\N
64294	1397	1426958829000	1545	843	0	0	\N
64296	1397	1427318865000	1547	696	0	0	\N
64297	1397	1427308864000	1547	696	1	0	\N
64298	1749	703990000000	1547	696	2	0	\N
64299	1397	1427298863000	1547	696	3	0	\N
64300	1397	1427288862000	1547	696	4	0	\N
64301	1397	1427278861000	1547	696	5	0	\N
64302	1397	1427268860000	1547	696	6	0	\N
64303	1397	1427258859000	1547	696	7	0	\N
64304	1722	4656070000000	1547	696	8	0	\N
64305	1722	4333060000000	1547	696	9	0	\N
64306	1397	1427248858000	1547	696	10	0	\N
64307	1397	1427238857000	1547	696	11	0	\N
64308	1397	1427228856000	1547	696	12	0	\N
64309	1397	1427218855000	1547	696	13	0	\N
64310	1397	1427208854000	1547	696	14	0	\N
64311	1397	1427198853000	1547	696	15	0	\N
64312	1397	1427188852000	1547	696	16	0	\N
64313	1397	1427178851000	1547	696	17	0	\N
64314	1397	1427168850000	1547	696	18	0	\N
64315	1397	1427158849000	1547	696	19	0	\N
64316	1397	1427148848000	1547	696	20	0	\N
64317	1397	1427138847000	1547	696	21	0	\N
64318	1397	1427128846000	1547	696	22	0	\N
64319	1397	1427118845000	1547	696	23	0	\N
64320	1397	1427108844000	1547	696	24	0	\N
64321	1397	1427098843000	1547	696	25	0	\N
64322	1397	1427088842000	1547	696	26	0	\N
64323	1397	1427078841000	1547	696	27	0	\N
64324	1397	1427068840000	1547	696	28	0	\N
64325	1397	1427058839000	1547	696	29	0	\N
64326	1397	1427048838000	1547	696	30	0	\N
64327	1397	1427038837000	1547	696	31	0	\N
64328	1397	1427028836000	1547	696	32	0	\N
64228	1397	1427308864000	1498	818	2	0	1153
64229	1749	703990000000	1498	818	3	0	1
64230	1397	1427298863000	1499	819	0	0	1154
64231	1397	1427288862000	1500	820	0	0	1155
64232	1722	6096091000000	1500	820	1	0	3
64234	1397	1427268860000	1502	822	0	0	1157
64235	1397	1427258859000	1503	823	0	0	1158
64236	1397	1427248858000	1504	824	0	0	1159
64237	1397	1427238857000	1505	825	0	0	1160
64238	1397	1427228856000	1506	826	0	0	1161
64247	1397	1427208854000	1512	827	1	0	1163
64250	1397	1427198853000	1514	828	0	0	1164
64251	1397	1427188852000	1514	828	1	0	1165
64252	1397	1427178851000	1515	829	0	0	1166
64254	1722	5773081000000	1516	830	1	0	4
64255	1397	1427158849000	1516	830	2	0	1168
64256	1397	1427148848000	1516	830	3	0	1169
64257	1397	1427138847000	1516	830	4	0	1170
64258	1397	1427128846000	1517	831	0	0	1171
64263	1397	1427108844000	1520	832	1	0	1173
64266	1397	1427098843000	1522	833	0	0	1174
64267	1397	1427088842000	1522	833	1	0	1175
64270	1397	1427078841000	1524	834	0	0	1176
64271	1397	1427068840000	1525	835	0	0	1177
64273	1397	1427048838000	1525	835	2	0	1179
64274	1397	1427038837000	1525	835	3	0	1180
64279	1397	1427028836000	1527	836	0	0	1181
64280	1397	1427018835000	1528	837	0	0	1182
64286	1397	1426998833000	1534	839	0	0	1184
64289	1397	1426988832000	1537	840	0	0	1185
64290	1397	1426978831000	1538	841	0	0	1186
64293	1397	1426968830000	1542	842	0	0	1187
64295	1397	1426958829000	1546	843	0	0	1188
64329	1397	1427018835000	1547	696	33	0	\N
64330	1397	1427008834000	1547	696	34	0	\N
64331	1397	1426998833000	1547	696	35	0	\N
64332	1397	1426988832000	1547	696	36	0	\N
64333	1397	1426978831000	1547	696	37	0	\N
64334	1397	1426968830000	1547	696	38	0	\N
64335	1397	1426958829000	1547	696	39	0	\N
64337	1397	1426948828000	1549	844	0	0	\N
64338	1397	1426938827000	1553	846	0	0	\N
64339	1397	1426928826000	1553	846	1	0	\N
64340	1397	1426918825000	1553	846	2	0	\N
64341	1397	1426938827000	1554	846	0	0	\N
64342	1397	1426928826000	1554	846	1	0	\N
64343	1397	1426918825000	1554	846	2	0	\N
64347	1397	1426938827000	1556	846	0	0	\N
64348	1397	1426928826000	1556	846	1	0	\N
64349	1397	1426918825000	1556	846	2	0	\N
64354	1397	1426888822000	1560	849	0	0	\N
64355	1397	1426878821000	1560	849	1	0	\N
64357	1397	1426868820000	1562	850	0	0	\N
64359	1397	1426858819000	1564	851	0	0	\N
64360	1397	1426848818000	1565	852	0	0	\N
64366	1397	1426808814000	1570	855	0	0	\N
64368	1397	1426798813000	1572	856	0	0	\N
64370	1397	1426788812000	1574	857	0	0	\N
64372	1397	1426778811000	1576	858	0	0	\N
64374	1397	1426768810000	1578	859	0	0	\N
64375	1397	1426768810000	1579	859	0	0	\N
64376	1397	1426758809000	1580	860	0	0	\N
64377	1397	1426748808000	1580	860	1	0	\N
64378	1397	1426738807000	1580	860	2	0	\N
64382	1397	1426728806000	1582	861	0	0	\N
64383	1397	1426728806000	1583	861	0	0	\N
64385	1397	1426728806000	1585	861	0	0	\N
64387	1397	1426718805000	1587	862	0	0	\N
64388	1397	1426708804000	1588	863	0	0	\N
64393	1397	1426668800000	1592	866	0	0	\N
64394	1397	1426668800000	1593	866	0	0	\N
64395	1740	5036523000000	1594	785	0	0	\N
64396	1397	1427808914000	1594	785	1	0	\N
64397	1749	703990000000	1594	785	2	0	\N
64398	1722	5376080000000	1594	785	3	0	\N
64399	1722	5053070000000	1594	785	4	0	\N
64400	1397	1427798913000	1594	785	5	0	\N
64401	1397	1427788912000	1594	785	6	0	\N
64402	1397	1427778911000	1594	785	7	0	\N
64403	1397	1427768910000	1594	785	8	0	\N
64404	1397	1427758909000	1594	785	9	0	\N
64405	1397	1427748908000	1594	785	10	0	\N
64406	1397	1427738907000	1594	785	11	0	\N
64407	1397	1427728906000	1594	785	12	0	\N
64408	1397	1427718905000	1594	785	13	0	\N
64409	1397	1427708904000	1594	785	14	0	\N
64410	1397	1427698903000	1594	785	15	0	\N
64411	1397	1427688902000	1594	785	16	0	\N
64412	1397	1427678901000	1594	785	17	0	\N
64413	1397	1427668900000	1594	785	18	0	\N
64414	1397	1427658899000	1594	785	19	0	\N
64415	1397	1427648898000	1594	785	20	0	\N
64416	1397	1427638897000	1594	785	21	0	\N
64417	1397	1427628896000	1594	785	22	0	\N
64418	1397	1427618895000	1594	785	23	0	\N
64419	1397	1427608894000	1594	785	24	0	\N
64420	1397	1427598893000	1594	785	25	0	\N
64421	1397	1427588892000	1594	785	26	0	\N
64422	1397	1427578891000	1594	785	27	0	\N
64423	1397	1427568890000	1594	785	28	0	\N
64424	1397	1427558889000	1594	785	29	0	\N
64425	1397	1427548888000	1594	785	30	0	\N
64426	1397	1427538887000	1594	785	31	0	\N
64427	1397	1427528886000	1594	785	32	0	\N
64428	1397	1427518885000	1594	785	33	0	\N
64429	1397	1427508884000	1594	785	34	0	\N
64430	1397	1427498883000	1594	785	35	0	\N
64431	1397	1427488882000	1594	785	36	0	\N
64432	1397	1427478881000	1594	785	37	0	\N
64433	1397	1427468880000	1594	785	38	0	\N
64434	1397	1427458879000	1594	785	39	0	\N
64435	1397	1427448878000	1594	785	40	0	\N
64436	1397	1427438877000	1594	785	41	0	\N
64437	1397	1427428876000	1594	785	42	0	\N
64438	1397	1427418875000	1594	785	43	0	\N
64439	1397	1427408874000	1594	785	44	0	\N
64440	1397	1427398873000	1594	785	45	0	\N
64441	1397	1427388872000	1594	785	46	0	\N
64442	1397	1427378871000	1594	785	47	0	\N
64443	1397	1427368870000	1594	785	48	0	\N
64444	1397	1427358869000	1594	785	49	0	\N
64445	1397	1427348868000	1594	785	50	0	\N
64446	1397	1427338867000	1594	785	51	0	\N
64447	1397	1427328866000	1594	785	52	0	\N
64448	1397	1427318865000	1594	785	53	0	\N
64449	1397	1427308864000	1594	785	54	0	\N
64450	1397	1427298863000	1594	785	55	0	\N
64451	1397	1427288862000	1594	785	56	0	\N
64452	1397	1427278861000	1594	785	57	0	\N
64453	1397	1427268860000	1594	785	58	0	\N
64454	1397	1427258859000	1594	785	59	0	\N
64455	1397	1427248858000	1594	785	60	0	\N
64456	1397	1427238857000	1594	785	61	0	\N
64457	1397	1427228856000	1594	785	62	0	\N
64458	1397	1427218855000	1594	785	63	0	\N
64459	1397	1427208854000	1594	785	64	0	\N
64460	1397	1427198853000	1594	785	65	0	\N
64461	1397	1427188852000	1594	785	66	0	\N
64462	1397	1427178851000	1594	785	67	0	\N
64463	1397	1427168850000	1594	785	68	0	\N
64464	1397	1427158849000	1594	785	69	0	\N
64345	1397	1426928826000	1555	846	1	0	1191
64346	1397	1426918825000	1555	846	2	0	1192
64350	1397	1426908824000	1557	847	0	0	1193
64351	1397	1426898823000	1558	848	0	0	1194
64352	1397	1426888822000	1559	849	0	0	1195
64356	1397	1426868820000	1561	850	0	0	1197
64358	1397	1426858819000	1563	851	0	0	1198
64361	1397	1426848818000	1566	852	0	0	1199
64362	1397	1426838817000	1567	853	0	0	1200
64363	1397	1426828816000	1567	853	1	0	1201
64365	1397	1426808814000	1569	855	0	0	1203
64367	1397	1426798813000	1571	856	0	0	1204
64369	1397	1426788812000	1573	857	0	0	1205
64371	1397	1426778811000	1575	858	0	0	1206
64379	1397	1426758809000	1581	860	0	0	1208
64380	1397	1426748808000	1581	860	1	0	1209
64381	1397	1426738807000	1581	860	2	0	1210
64384	1397	1426728806000	1584	861	0	0	1211
64386	1397	1426718805000	1586	862	0	0	1212
64390	1397	1426698803000	1590	864	0	0	1214
64391	1397	1426688802000	1591	865	0	0	1215
64392	1397	1426678801000	1591	865	1	0	1216
64465	1397	1427148848000	1594	785	70	0	\N
64466	1397	1427138847000	1594	785	71	0	\N
64467	1397	1427128846000	1594	785	72	0	\N
64468	1397	1427118845000	1594	785	73	0	\N
64469	1397	1427108844000	1594	785	74	0	\N
64470	1397	1427098843000	1594	785	75	0	\N
64471	1397	1427088842000	1594	785	76	0	\N
64472	1397	1427078841000	1594	785	77	0	\N
64473	1397	1427068840000	1594	785	78	0	\N
64474	1397	1427058839000	1594	785	79	0	\N
64475	1397	1427048838000	1594	785	80	0	\N
64476	1397	1427038837000	1594	785	81	0	\N
64477	1397	1427028836000	1594	785	82	0	\N
64478	1397	1427018835000	1594	785	83	0	\N
64479	1397	1427008834000	1594	785	84	0	\N
64480	1397	1426998833000	1594	785	85	0	\N
64481	1397	1426988832000	1594	785	86	0	\N
64482	1397	1426978831000	1594	785	87	0	\N
64483	1397	1426668800000	1595	866	0	0	\N
64484	1397	1426668800000	1596	866	0	0	\N
64485	1397	1426668800000	1597	866	0	0	\N
64487	1397	1426668800000	1599	866	0	0	\N
64488	1397	1426958829000	1600	843	0	0	\N
64489	1397	1426948828000	1600	843	1	0	\N
64490	1397	1426938827000	1600	843	2	0	\N
64491	1397	1426928826000	1600	843	3	0	\N
64492	1397	1426918825000	1600	843	4	0	\N
64493	1397	1426908824000	1600	843	5	0	\N
64494	1397	1426658799000	1601	867	0	0	\N
64495	1397	1426648798000	1601	867	1	0	\N
64496	1397	1426658799000	1602	867	0	0	\N
64497	1397	1426648798000	1602	867	1	0	\N
64498	1397	1426768810000	1603	859	0	0	\N
64499	1397	1426758809000	1603	859	1	0	\N
64500	1397	1426748808000	1603	859	2	0	\N
64501	1397	1426738807000	1603	859	3	0	\N
64502	1397	1426728806000	1603	859	4	0	\N
64503	1397	1426718805000	1603	859	5	0	\N
64504	1397	1426708804000	1603	859	6	0	\N
64505	1397	1426698803000	1603	859	7	0	\N
64506	1397	1426688802000	1603	859	8	0	\N
64507	1397	1426678801000	1603	859	9	0	\N
64508	1397	1426668800000	1603	859	10	0	\N
64511	1397	1426638797000	1605	868	0	0	\N
64512	1397	1426628796000	1605	868	1	0	\N
64516	1740	5036523000000	1608	783	0	0	\N
64517	1749	703990000000	1608	783	1	0	\N
64518	1722	5376080000000	1608	783	2	0	\N
64519	1722	5053070000000	1608	783	3	0	\N
64520	1397	1427838917000	1608	783	4	0	\N
64521	1397	1427828916000	1608	783	5	0	\N
64522	1397	1427818915000	1608	783	6	0	\N
64523	1397	1427808914000	1608	783	7	0	\N
64524	1397	1427798913000	1608	783	8	0	\N
64525	1397	1427788912000	1608	783	9	0	\N
64526	1397	1427778911000	1608	783	10	0	\N
64527	1397	1427768910000	1608	783	11	0	\N
64528	1397	1427758909000	1608	783	12	0	\N
64529	1397	1427748908000	1608	783	13	0	\N
64530	1397	1427738907000	1608	783	14	0	\N
64531	1397	1427728906000	1608	783	15	0	\N
64532	1397	1427718905000	1608	783	16	0	\N
64533	1397	1427708904000	1608	783	17	0	\N
64534	1397	1427698903000	1608	783	18	0	\N
64535	1397	1427688902000	1608	783	19	0	\N
64536	1397	1427678901000	1608	783	20	0	\N
64537	1397	1427668900000	1608	783	21	0	\N
64538	1397	1427658899000	1608	783	22	0	\N
64539	1397	1427648898000	1608	783	23	0	\N
64540	1397	1427638897000	1608	783	24	0	\N
64541	1397	1427628896000	1608	783	25	0	\N
64542	1397	1427618895000	1608	783	26	0	\N
64543	1397	1427608894000	1608	783	27	0	\N
64544	1397	1427598893000	1608	783	28	0	\N
64545	1397	1427588892000	1608	783	29	0	\N
64546	1397	1427578891000	1608	783	30	0	\N
64547	1397	1427568890000	1608	783	31	0	\N
64548	1397	1427558889000	1608	783	32	0	\N
64549	1397	1427548888000	1608	783	33	0	\N
64550	1397	1427538887000	1608	783	34	0	\N
64551	1397	1427528886000	1608	783	35	0	\N
64552	1397	1427518885000	1608	783	36	0	\N
64553	1397	1427508884000	1608	783	37	0	\N
64554	1397	1427498883000	1608	783	38	0	\N
64555	1397	1427488882000	1608	783	39	0	\N
64556	1397	1427478881000	1608	783	40	0	\N
64557	1397	1427468880000	1608	783	41	0	\N
64558	1397	1427458879000	1608	783	42	0	\N
64559	1397	1427448878000	1608	783	43	0	\N
64560	1397	1427438877000	1608	783	44	0	\N
64561	1397	1427428876000	1608	783	45	0	\N
64562	1397	1427418875000	1608	783	46	0	\N
64563	1397	1427408874000	1608	783	47	0	\N
64564	1397	1427398873000	1608	783	48	0	\N
64565	1397	1427388872000	1608	783	49	0	\N
64566	1397	1427378871000	1608	783	50	0	\N
64567	1397	1427368870000	1608	783	51	0	\N
64568	1397	1427358869000	1608	783	52	0	\N
64569	1397	1427348868000	1608	783	53	0	\N
64570	1397	1427338867000	1608	783	54	0	\N
64571	1397	1427328866000	1608	783	55	0	\N
64572	1397	1427318865000	1608	783	56	0	\N
64573	1397	1427308864000	1608	783	57	0	\N
64574	1397	1427298863000	1608	783	58	0	\N
64575	1397	1427288862000	1608	783	59	0	\N
64576	1397	1427278861000	1608	783	60	0	\N
64577	1397	1427268860000	1608	783	61	0	\N
64578	1397	1427258859000	1608	783	62	0	\N
64579	1397	1427248858000	1608	783	63	0	\N
64580	1397	1427238857000	1608	783	64	0	\N
64581	1397	1427228856000	1608	783	65	0	\N
64582	1397	1427218855000	1608	783	66	0	\N
64583	1397	1427208854000	1608	783	67	0	\N
64584	1397	1427198853000	1608	783	68	0	\N
64585	1397	1427188852000	1608	783	69	0	\N
64586	1397	1427178851000	1608	783	70	0	\N
64587	1397	1427168850000	1608	783	71	0	\N
64588	1397	1427158849000	1608	783	72	0	\N
64589	1397	1427148848000	1608	783	73	0	\N
64590	1397	1427138847000	1608	783	74	0	\N
64591	1397	1427128846000	1608	783	75	0	\N
64592	1397	1427118845000	1608	783	76	0	\N
64593	1397	1427108844000	1608	783	77	0	\N
64594	1397	1427098843000	1608	783	78	0	\N
64595	1397	1427088842000	1608	783	79	0	\N
64596	1397	1427078841000	1608	783	80	0	\N
64597	1397	1427068840000	1608	783	81	0	\N
64598	1397	1427058839000	1608	783	82	0	\N
64599	1397	1427048838000	1608	783	83	0	\N
64600	1397	1427038837000	1608	783	84	0	\N
64510	1397	1426648798000	1604	867	1	0	1219
64513	1397	1426638797000	1606	868	0	0	1220
64514	1397	1426628796000	1606	868	1	0	1221
64515	1397	1426618795000	1607	869	0	0	1222
64601	1397	1427028836000	1608	783	85	0	\N
64602	1397	1427018835000	1608	783	86	0	\N
64603	1397	1427008834000	1608	783	87	0	\N
64604	1397	1426998833000	1608	783	88	0	\N
64605	1397	1426988832000	1608	783	89	0	\N
64606	1397	1426978831000	1608	783	90	0	\N
64607	1397	1426968830000	1608	783	91	0	\N
64608	1397	1426958829000	1608	783	92	0	\N
64609	1397	1426948828000	1608	783	93	0	\N
64610	1397	1426938827000	1608	783	94	0	\N
64611	1397	1426928826000	1608	783	96	0	\N
64612	1397	1426918825000	1608	783	97	0	\N
64613	1397	1426908824000	1608	783	98	0	\N
64614	1397	1426898823000	1608	783	99	0	\N
64615	1397	1426888822000	1608	783	100	0	\N
64616	1397	1426878821000	1608	783	101	0	\N
64617	1397	1426868820000	1608	783	102	0	\N
64618	1397	1426858819000	1608	783	103	0	\N
64619	1397	1426848818000	1608	783	104	0	\N
64620	1397	1426838817000	1608	783	105	0	\N
64621	1397	1426828816000	1608	783	106	0	\N
64622	1397	1426818815000	1608	783	107	0	\N
64623	1397	1426808814000	1608	783	108	0	\N
64624	1397	1426798813000	1608	783	109	0	\N
64625	1397	1426788812000	1608	783	110	0	\N
64626	1397	1426778811000	1608	783	111	0	\N
64627	1397	1426768810000	1608	783	112	0	\N
64628	1397	1426758809000	1608	783	113	0	\N
64629	1397	1426748808000	1608	783	114	0	\N
64630	1397	1426738807000	1608	783	115	0	\N
64631	1397	1426728806000	1608	783	116	0	\N
64632	1397	1426718805000	1608	783	117	0	\N
64633	1397	1426708804000	1608	783	118	0	\N
64634	1397	1426698803000	1608	783	119	0	\N
64635	1397	1426688802000	1608	783	120	0	\N
64636	1397	1426678801000	1608	783	121	0	\N
64637	1397	1426668800000	1608	783	122	0	\N
64638	1397	1426658799000	1608	783	123	0	\N
64639	1397	1426648798000	1608	783	124	0	\N
64640	1397	1426638797000	1608	783	125	0	\N
64644	1397	1426578791000	1612	872	0	0	\N
64645	1397	1426568790000	1612	872	1	0	\N
64646	1397	1426558789000	1612	872	2	0	\N
64647	1397	1426548788000	1612	872	3	0	\N
64652	1397	1426538787000	1614	873	0	0	\N
64654	1397	1426538787000	1616	873	0	0	\N
64656	1397	1426528786000	1618	874	0	0	\N
64657	1397	1426528786000	1619	874	0	0	\N
64659	1397	1426518785000	1621	875	0	0	\N
64660	1397	1426508784000	1622	876	0	0	\N
64661	1397	1426508784000	1623	876	0	0	\N
64662	1397	1426948828000	1624	697	0	0	\N
64663	1397	1426938827000	1624	697	1	0	\N
64664	1397	1426928826000	1624	697	2	0	\N
64665	1397	1426918825000	1624	697	3	0	\N
64666	1397	1426908824000	1624	697	4	0	\N
64667	1397	1426898823000	1624	697	5	0	\N
64668	1397	1426888822000	1624	697	6	0	\N
64669	1397	1426878821000	1624	697	7	0	\N
64670	1397	1426868820000	1624	697	8	0	\N
64671	1397	1426858819000	1624	697	9	0	\N
64672	1397	1426848818000	1624	697	10	0	\N
64673	1397	1426838817000	1624	697	11	0	\N
64674	1397	1426828816000	1624	697	12	0	\N
64675	1397	1426818815000	1624	697	13	0	\N
64676	1397	1426808814000	1624	697	14	0	\N
64677	1397	1426798813000	1624	697	15	0	\N
64678	1397	1426788812000	1624	697	16	0	\N
64679	1397	1426778811000	1624	697	17	0	\N
64680	1397	1426768810000	1624	697	18	0	\N
64681	1397	1426758809000	1624	697	19	0	\N
64682	1397	1426748808000	1624	697	20	0	\N
64683	1397	1426738807000	1624	697	21	0	\N
64684	1397	1426728806000	1624	697	22	0	\N
64685	1397	1426718805000	1624	697	23	0	\N
64686	1397	1426708804000	1624	697	24	0	\N
64687	1397	1426698803000	1624	697	25	0	\N
64688	1397	1426688802000	1624	697	26	0	\N
64689	1397	1426678801000	1624	697	27	0	\N
64690	1397	1426668800000	1624	697	28	0	\N
64691	1397	1426658799000	1624	697	29	0	\N
64692	1397	1426648798000	1624	697	30	0	\N
64693	1397	1426638797000	1624	697	31	0	\N
64694	1397	1426628796000	1624	697	32	0	\N
64695	1397	1426618795000	1624	697	33	0	\N
64696	1397	1426608794000	1624	697	34	0	\N
64697	1397	1426598793000	1624	697	35	0	\N
64698	1397	1426588792000	1624	697	36	0	\N
64699	1397	1426578791000	1624	697	37	0	\N
64700	1397	1426568790000	1624	697	38	0	\N
64701	1397	1426558789000	1624	697	39	0	\N
64702	1397	1426548788000	1624	697	40	0	\N
64703	1397	1426538787000	1624	697	41	0	\N
64704	1397	1426528786000	1624	697	42	0	\N
64705	1397	1426518785000	1624	697	44	0	\N
64706	1397	1426508784000	1624	697	45	0	\N
64710	1397	1426488782000	1628	878	0	0	\N
64711	1397	1426478781000	1629	879	0	0	\N
64712	1397	1426478781000	1630	879	0	0	\N
64713	1397	1426478781000	1631	879	0	0	\N
64715	1397	1426468780000	1633	880	0	0	\N
64716	1397	1426458779000	1633	880	1	0	\N
64722	1397	1426428776000	1637	882	0	0	\N
64725	1397	1426398773000	1640	885	0	0	\N
64726	1397	1426398773000	1641	885	0	0	\N
64727	1397	1426398773000	1642	885	0	0	\N
64730	1397	1426388772000	1645	886	0	0	\N
64731	1397	1426498783000	1647	698	0	0	\N
64732	1397	1426488782000	1647	698	1	0	\N
64733	1397	1426478781000	1647	698	2	0	\N
64734	1397	1426468780000	1647	698	3	0	\N
64735	1397	1426458779000	1647	698	4	0	\N
64736	1397	1426448778000	1647	698	5	0	\N
64643	1397	1426588792000	1610	871	0	0	1225
64648	1397	1426578791000	1613	872	0	0	1226
64649	1397	1426568790000	1613	872	1	0	1227
64650	1397	1426558789000	1613	872	2	0	1228
64651	1397	1426548788000	1613	872	3	0	1229
64655	1397	1426528786000	1617	874	0	0	1231
64658	1397	1426518785000	1620	875	0	0	1232
64707	1397	1426508784000	1625	876	0	0	1233
64708	1397	1426498783000	1626	877	0	0	1234
64709	1397	1426488782000	1627	878	0	0	1235
64717	1397	1426468780000	1634	880	0	0	1237
64718	1397	1426458779000	1634	880	1	0	1238
64719	1397	1426448778000	1635	881	0	0	1239
64720	1397	1426438777000	1635	881	1	0	1240
64723	1397	1426418775000	1638	883	0	0	1242
64724	1397	1426408774000	1639	884	0	0	1243
64728	1397	1426398773000	1643	885	0	0	1244
64729	1397	1426388772000	1644	886	0	0	1245
64737	1397	1426438777000	1647	698	6	0	\N
64738	1397	1426428776000	1647	698	7	0	\N
64739	1397	1426418775000	1647	698	8	0	\N
64740	1397	1426408774000	1647	698	9	0	\N
64741	1397	1426398773000	1647	698	10	0	\N
64742	1397	1426388772000	1647	698	11	0	\N
64745	1397	1426368770000	1650	888	0	0	\N
64747	1397	1426348768000	1652	890	0	0	\N
64749	1397	1426378771000	1654	699	0	0	\N
64750	1397	1426368770000	1654	699	1	0	\N
64751	1397	1426358769000	1654	699	2	0	\N
64752	1397	1426348768000	1654	699	3	0	\N
64753	1397	1426338767000	1654	699	4	0	\N
64757	1397	1426308764000	1657	893	0	0	\N
64758	1397	1426308764000	1658	893	0	0	\N
64764	1397	1426298763000	1661	894	0	0	\N
64765	1397	1426288762000	1661	894	1	0	\N
64766	1397	1426278761000	1661	894	2	0	\N
64767	1397	1426268760000	1661	894	3	0	\N
64768	1397	1426298763000	1662	894	0	0	\N
64769	1397	1426288762000	1662	894	1	0	\N
64770	1397	1426278761000	1662	894	2	0	\N
64771	1397	1426268760000	1662	894	3	0	\N
64774	1397	1426368770000	1664	888	0	0	\N
64775	1397	1426358769000	1664	888	1	0	\N
64776	1397	1426348768000	1664	888	2	0	\N
64777	1397	1426338767000	1664	888	3	0	\N
64778	1397	1426328766000	1664	888	4	0	\N
64779	1397	1426318765000	1664	888	5	0	\N
64780	1397	1426308764000	1664	888	6	0	\N
64781	1397	1426298763000	1664	888	7	0	\N
64782	1397	1426288762000	1664	888	8	0	\N
64783	1397	1426278761000	1664	888	9	0	\N
64784	1397	1426268760000	1664	888	10	0	\N
64785	1397	1426258759000	1664	888	11	0	\N
64786	1397	1426248758000	1664	888	12	0	\N
64787	1397	1426258759000	1665	895	0	0	\N
64788	1397	1426248758000	1665	895	1	0	\N
64789	1397	1426258759000	1666	895	0	0	\N
64790	1397	1426248758000	1666	895	1	0	\N
64791	1397	1426258759000	1667	895	0	0	\N
64792	1397	1426248758000	1667	895	1	0	\N
64793	1397	1426238757000	1668	896	0	0	\N
64794	1397	1426228756000	1668	896	1	0	\N
64800	1397	1426198753000	1672	898	0	0	\N
64805	1397	1426188752000	1674	899	0	0	\N
64806	1397	1426178751000	1674	899	1	0	\N
64807	1397	1426168750000	1674	899	2	0	\N
64808	1397	1426158749000	1674	899	3	0	\N
64809	1397	1426188752000	1675	899	0	0	\N
64810	1397	1426178751000	1675	899	1	0	\N
64811	1397	1426168750000	1675	899	2	0	\N
64812	1397	1426158749000	1675	899	3	0	\N
64814	1397	1426148748000	1677	900	0	0	\N
64815	1397	1426138747000	1678	901	0	0	\N
64818	1397	1426118745000	1682	903	0	0	\N
64822	1397	1426088742000	1686	906	0	0	\N
64828	1397	1426328766000	1691	700	0	0	\N
64829	1397	1426318765000	1691	700	1	0	\N
64830	1397	1426308764000	1691	700	2	0	\N
64831	1397	1426298763000	1691	700	3	0	\N
64832	1397	1426288762000	1691	700	4	0	\N
64833	1397	1426278761000	1691	700	5	0	\N
64834	1397	1426268760000	1691	700	6	0	\N
64835	1397	1426258759000	1691	700	7	0	\N
64836	1397	1426038737000	1692	910	0	0	\N
64837	1397	1426028736000	1692	910	1	0	\N
64848	1735	1419990000000	1701	889	0	0	\N
64849	1735	1419980000000	1701	889	1	0	\N
64850	1397	1426238757000	1701	889	2	0	\N
64851	1397	1426228756000	1701	889	3	0	\N
64852	1397	1426218755000	1701	889	4	0	\N
64853	1397	1426208754000	1701	889	5	0	\N
64854	1397	1426198753000	1701	889	6	0	\N
64855	1397	1426188752000	1701	889	7	0	\N
64856	1397	1426178751000	1701	889	8	0	\N
64857	1397	1426168750000	1701	889	9	0	\N
64858	1397	1426158749000	1701	889	10	0	\N
64859	1397	1426148748000	1701	889	11	0	\N
64860	1397	1426138747000	1701	889	12	0	\N
64861	1397	1426128746000	1701	889	13	0	\N
64862	1397	1426118745000	1701	889	14	0	\N
64863	1397	1426108744000	1701	889	15	0	\N
64864	1397	1426098743000	1701	889	16	0	\N
64865	1397	1426088742000	1701	889	17	0	\N
64866	1397	1426078741000	1701	889	18	0	\N
64867	1397	1426068740000	1701	889	19	0	\N
64868	1397	1426058739000	1701	889	20	0	\N
64869	1397	1426048738000	1701	889	21	0	\N
64870	1397	1426038737000	1701	889	22	0	\N
64871	1397	1426028736000	1701	889	23	0	\N
64872	1397	1426018735000	1701	889	24	0	\N
64746	1397	1426358769000	1651	889	0	0	1248
64748	1397	1426348768000	1653	890	0	0	1249
64754	1397	1426338767000	1655	891	0	0	1250
64755	1397	1426328766000	1656	892	0	0	1251
64756	1397	1426318765000	1656	892	1	0	1252
64760	1397	1426298763000	1660	894	0	0	1254
64761	1397	1426288762000	1660	894	1	0	1255
64762	1397	1426278761000	1660	894	2	0	1256
64763	1397	1426268760000	1660	894	3	0	1257
64772	1397	1426258759000	1663	895	0	0	1258
64795	1397	1426238757000	1669	896	0	0	1260
64796	1397	1426228756000	1669	896	1	0	1261
64797	1397	1426218755000	1670	897	0	0	1262
64798	1397	1426208754000	1670	897	1	0	1263
64801	1397	1426188752000	1673	899	0	0	1265
64802	1397	1426178751000	1673	899	1	0	1266
64803	1397	1426168750000	1673	899	2	0	1267
64804	1397	1426158749000	1673	899	3	0	1268
64813	1397	1426148748000	1676	900	0	0	1269
64817	1397	1426128746000	1681	902	0	0	1271
64819	1397	1426118745000	1683	903	0	0	1272
64820	1397	1426108744000	1684	904	0	0	1273
64821	1397	1426098743000	1685	905	0	0	1274
64823	1397	1426088742000	1687	906	0	0	1275
64825	1397	1426068740000	1689	908	0	0	1277
64826	1397	1426058739000	1690	909	0	0	1278
64827	1397	1426048738000	1690	909	1	0	1279
64838	1397	1426038737000	1693	910	0	0	1280
64840	1397	1426018735000	1694	911	0	0	1282
64841	1397	1426008734000	1695	912	0	0	1283
64842	1397	1425998733000	1696	913	0	0	1284
64843	1735	1419990000000	1697	914	0	0	5
64844	1735	1419980000000	1697	914	1	0	6
64846	1397	1425978731000	1697	914	3	0	1286
64847	1397	1425968730000	1698	915	0	0	1287
64873	1397	1426008734000	1701	889	25	0	\N
64874	1397	1425998733000	1701	889	26	0	\N
64875	1397	1425988732000	1701	889	27	0	\N
64876	1397	1425978731000	1701	889	28	0	\N
64877	1397	1425968730000	1701	889	29	0	\N
64878	1397	1425958729000	1701	889	30	0	\N
64879	1397	1425958729000	1702	916	0	0	\N
64880	1397	1425958729000	1703	916	0	0	\N
64881	1397	1425958729000	1704	916	0	0	\N
64884	1397	1425958729000	1707	917	0	0	\N
64885	1397	1425948728000	1707	917	1	0	\N
64886	1397	1426628796000	1708	784	0	0	\N
64887	1397	1426618795000	1708	784	1	0	\N
64888	1397	1426608794000	1708	784	2	0	\N
64889	1397	1426598793000	1708	784	3	0	\N
64890	1397	1426588792000	1708	784	4	0	\N
64891	1397	1426578791000	1708	784	5	0	\N
64892	1397	1426568790000	1708	784	6	0	\N
64893	1397	1426558789000	1708	784	7	0	\N
64894	1397	1426548788000	1708	784	8	0	\N
64895	1397	1426538787000	1708	784	9	0	\N
64896	1397	1426528786000	1708	784	10	0	\N
64897	1397	1426518785000	1708	784	11	0	\N
64898	1397	1426508784000	1708	784	12	0	\N
64899	1397	1426498783000	1708	784	13	0	\N
64900	1397	1426488782000	1708	784	14	0	\N
64901	1397	1426478781000	1708	784	15	0	\N
64902	1397	1426468780000	1708	784	16	0	\N
64903	1397	1426458779000	1708	784	17	0	\N
64904	1397	1426448778000	1708	784	18	0	\N
64905	1397	1426438777000	1708	784	19	0	\N
64906	1397	1426428776000	1708	784	20	0	\N
64907	1397	1426418775000	1708	784	21	0	\N
64908	1397	1426408774000	1708	784	22	0	\N
64909	1397	1426398773000	1708	784	23	0	\N
64910	1397	1426388772000	1708	784	24	0	\N
64911	1397	1426378771000	1708	784	25	0	\N
64912	1397	1426368770000	1708	784	26	0	\N
64913	1397	1426358769000	1708	784	27	0	\N
64914	1397	1426348768000	1708	784	28	0	\N
64915	1397	1426338767000	1708	784	29	0	\N
64916	1397	1426328766000	1708	784	30	0	\N
64917	1397	1426318765000	1708	784	31	0	\N
64918	1397	1426308764000	1708	784	32	0	\N
64919	1397	1426298763000	1708	784	33	0	\N
64920	1397	1426288762000	1708	784	34	0	\N
64921	1397	1426278761000	1708	784	35	0	\N
64922	1397	1426268760000	1708	784	36	0	\N
64923	1397	1426258759000	1708	784	37	0	\N
64924	1397	1426248758000	1708	784	38	0	\N
64925	1397	1426238757000	1708	784	39	0	\N
64926	1397	1426228756000	1708	784	40	0	\N
64927	1397	1426218755000	1708	784	41	0	\N
64928	1397	1426208754000	1708	784	42	0	\N
64929	1397	1426198753000	1708	784	43	0	\N
64930	1397	1426188752000	1708	784	44	0	\N
64931	1397	1426178751000	1708	784	45	0	\N
64932	1397	1426168750000	1708	784	46	0	\N
64933	1397	1426158749000	1708	784	47	0	\N
64934	1397	1426148748000	1708	784	48	0	\N
64935	1397	1426138747000	1708	784	49	0	\N
64936	1397	1426128746000	1708	784	50	0	\N
64937	1397	1426118745000	1708	784	51	0	\N
64938	1397	1426108744000	1708	784	52	0	\N
64939	1397	1426098743000	1708	784	53	0	\N
64940	1397	1426088742000	1708	784	54	0	\N
64941	1397	1426078741000	1708	784	55	0	\N
64942	1397	1426068740000	1708	784	56	0	\N
64943	1397	1426058739000	1708	784	57	0	\N
64944	1397	1426048738000	1708	784	58	0	\N
64945	1397	1426038737000	1708	784	59	0	\N
64946	1397	1426028736000	1708	784	60	0	\N
64947	1397	1426018735000	1708	784	61	0	\N
64948	1397	1426008734000	1708	784	62	0	\N
64949	1397	1425998733000	1708	784	63	0	\N
64950	1397	1425988732000	1708	784	64	0	\N
64951	1397	1425978731000	1708	784	65	0	\N
64952	1397	1425968730000	1708	784	66	0	\N
64953	1397	1425958729000	1708	784	67	0	\N
64954	1397	1425948728000	1708	784	68	0	\N
64955	1397	1425938727000	1708	784	69	0	\N
64956	1735	1420000000000	1708	784	70	0	\N
64957	1735	1419990000000	1708	784	71	0	\N
64958	1735	1419980000000	1708	784	72	0	\N
64963	1397	1425908724000	1710	919	0	0	\N
64964	1268	994990000000	1710	919	1	0	\N
64970	1397	1425868720000	1717	923	0	0	\N
64971	1735	1419970000000	1718	890	0	0	\N
64972	1397	1425948728000	1718	890	1	0	\N
64973	1397	1425938727000	1718	890	2	0	\N
64974	1397	1425928726000	1718	890	3	0	\N
64975	1268	994990000000	1718	890	4	0	\N
64976	1397	1425918725000	1718	890	5	0	\N
64977	1397	1425908724000	1718	890	6	0	\N
64978	1397	1425898723000	1718	890	7	0	\N
64979	1397	1425888722000	1718	890	8	0	\N
64980	1397	1425878721000	1718	890	9	0	\N
64981	1397	1425868720000	1718	890	10	0	\N
64982	1397	1425868720000	1719	923	0	0	\N
64988	1397	1425858719000	1722	924	0	0	\N
64989	1397	1425848718000	1722	924	1	0	\N
64990	1397	1425838717000	1722	924	2	0	\N
64991	1397	1425828716000	1722	924	3	0	\N
64994	1397	1425818715000	1724	925	0	0	\N
64995	1397	1425808714000	1724	925	1	0	\N
64999	1397	1425858719000	1728	891	0	0	\N
65000	1397	1425848718000	1728	891	1	0	\N
65001	1397	1425838717000	1728	891	2	0	\N
65002	1397	1425828716000	1728	891	3	0	\N
65003	1397	1425818715000	1728	891	4	0	\N
65004	1397	1425808714000	1728	891	5	0	\N
65005	1397	1425798713000	1728	891	6	0	\N
65006	1397	1425788712000	1728	891	7	0	\N
65007	1397	1425778711000	1728	891	8	0	\N
64959	1397	1425938727000	1709	918	0	0	1290
64960	1735	1419970000000	1709	918	1	0	7
64961	1397	1425928726000	1709	918	2	0	1291
64962	1397	1425918725000	1709	918	3	0	1292
64965	1397	1425908724000	1711	919	0	0	1293
64967	1397	1425898723000	1715	921	0	0	1294
64968	1397	1425888722000	1715	921	1	0	1295
64969	1397	1425878721000	1716	922	0	0	1296
64983	1397	1425868720000	1720	923	0	0	1297
64984	1397	1425858719000	1721	924	0	0	1298
64986	1397	1425838717000	1721	924	2	0	1300
64987	1397	1425828716000	1721	924	3	0	1301
64992	1397	1425818715000	1723	925	0	0	1302
64993	1397	1425808714000	1723	925	1	0	1303
64997	1397	1425788712000	1726	927	0	0	1305
64998	1397	1425778711000	1727	928	0	0	1306
65008	1397	1425768710000	1729	929	0	0	1307
65009	1397	1425758709000	1730	930	0	0	\N
65010	1397	1425748708000	1730	930	1	0	\N
65013	1397	1425738707000	1732	931	0	0	\N
65014	1397	1425738707000	1733	931	0	0	\N
65015	1397	1425738707000	1734	931	0	0	\N
65017	1397	1425728706000	1736	932	0	0	\N
65019	1397	1425718705000	1739	933	0	0	\N
65022	1397	1425718705000	1741	934	0	0	\N
65023	1397	1425708704000	1741	934	1	0	\N
65024	1397	1425698703000	1742	935	0	0	\N
65027	1397	1425688702000	1745	936	0	0	\N
65030	1397	1425678701000	1747	937	0	0	\N
65031	1397	1425668700000	1747	937	1	0	\N
65032	1397	1425678701000	1748	937	0	0	\N
65033	1397	1425668700000	1748	937	1	0	\N
65034	1397	1425678701000	1749	937	0	0	\N
65035	1397	1425668700000	1749	937	1	0	\N
65036	1397	1425658699000	1750	938	0	0	\N
65037	1397	1425658699000	1751	938	0	0	\N
65040	1397	1425648698000	1754	939	0	0	\N
65042	1397	1425638697000	1756	940	0	0	\N
65045	1397	1425628696000	1758	941	0	0	\N
65046	1397	1425618695000	1758	941	1	0	\N
65048	1397	1425608694000	1760	942	0	0	\N
65049	1397	1425608694000	1761	942	0	0	\N
65065	1397	1425448678000	1773	952	0	0	\N
65066	1397	1425448678000	1774	952	0	0	\N
65067	1397	1425448678000	1775	952	0	0	\N
65070	1397	1425438677000	1778	953	0	0	\N
65071	1397	1425438677000	1779	953	0	0	\N
65072	1397	1425438677000	1780	953	0	0	\N
65075	1397	1425428676000	1782	954	0	0	\N
65076	1397	1425418675000	1782	954	1	0	\N
65077	1397	1425428676000	1783	954	0	0	\N
65078	1397	1425418675000	1783	954	1	0	\N
65079	1397	1425408674000	1784	955	0	0	\N
65081	1397	1425398673000	1786	956	0	0	\N
65082	1397	1425388672000	1786	956	1	0	\N
65083	1397	1425378671000	1786	956	2	0	\N
65084	1397	1425368670000	1786	956	3	0	\N
65085	1397	1425358669000	1786	956	4	0	\N
65091	1397	1425348668000	1788	957	0	0	\N
65092	1397	1425348668000	1789	957	0	0	\N
65096	1397	1425318665000	1792	959	0	0	\N
65097	1397	1425998733000	1793	914	0	0	\N
65098	1268	994990000000	1793	914	1	0	\N
65099	1397	1425988732000	1793	914	2	0	\N
65100	1397	1425978731000	1793	914	3	0	\N
65101	1397	1425968730000	1793	914	4	0	\N
65102	1397	1425958729000	1793	914	5	0	\N
65103	1397	1425948728000	1793	914	6	0	\N
65104	1397	1425938727000	1793	914	7	0	\N
65105	1397	1425928726000	1793	914	8	0	\N
65106	1397	1425918725000	1793	914	9	0	\N
65107	1397	1425908724000	1793	914	10	0	\N
65108	1397	1425898723000	1793	914	11	0	\N
65109	1397	1425888722000	1793	914	12	0	\N
65110	1397	1425878721000	1793	914	13	0	\N
65111	1397	1425868720000	1793	914	14	0	\N
65112	1397	1425858719000	1793	914	15	0	\N
65113	1397	1425848718000	1793	914	16	0	\N
65114	1397	1425838717000	1793	914	17	0	\N
65115	1397	1425828716000	1793	914	18	0	\N
65116	1397	1425818715000	1793	914	19	0	\N
65117	1397	1425808714000	1793	914	20	0	\N
65118	1397	1425798713000	1793	914	21	0	\N
65119	1397	1425788712000	1793	914	22	0	\N
65120	1397	1425778711000	1793	914	23	0	\N
65121	1397	1425768710000	1793	914	24	0	\N
65122	1397	1425758709000	1793	914	25	0	\N
65123	1397	1425318665000	1795	959	0	0	\N
65131	1516	0	1799	962	0	0	\N
65132	1397	1425278661000	1799	962	1	0	\N
65133	1397	1425268660000	1799	962	2	0	\N
65135	1397	1425248658000	1801	964	0	0	\N
65137	1397	1425248658000	1803	964	0	0	\N
65138	1397	1425238657000	1804	965	0	0	\N
65139	1397	1425228656000	1804	965	1	0	\N
65140	1756	6479139000000	1804	965	2	0	\N
65016	1397	1425738707000	1735	931	0	0	1310
65018	1397	1425728706000	1737	932	0	0	1311
65020	1397	1425718705000	1740	934	0	0	1312
65021	1397	1425708704000	1740	934	1	0	1313
65025	1397	1425698703000	1743	935	0	0	1314
65028	1397	1425678701000	1746	937	0	0	1316
65029	1397	1425668700000	1746	937	1	0	1317
65038	1397	1425658699000	1752	938	0	0	1318
65039	1397	1425648698000	1753	939	0	0	1319
65041	1397	1425638697000	1755	940	0	0	1320
65044	1397	1425618695000	1757	941	1	0	1322
65047	1397	1425608694000	1759	942	0	0	1323
65050	1397	1425598693000	1762	943	0	0	1324
65051	1397	1425588692000	1762	943	1	0	1325
65053	1397	1425568690000	1763	944	0	0	1327
65054	1397	1425558689000	1764	945	0	0	1328
65055	1397	1425548688000	1765	946	0	0	1329
65056	1397	1425538687000	1767	947	0	0	1330
65057	1397	1425528686000	1769	948	0	0	1331
65059	1397	1425508684000	1770	949	1	0	1333
65060	1397	1425498683000	1770	949	2	0	1334
65061	1397	1425488682000	1771	950	0	0	1335
65062	1397	1425478681000	1771	950	1	0	1336
65063	1397	1425468680000	1772	951	0	0	1337
65068	1397	1425448678000	1776	952	0	0	1339
65069	1397	1425438677000	1777	953	0	0	1340
65073	1397	1425428676000	1781	954	0	0	1341
65074	1397	1425418675000	1781	954	1	0	1342
65086	1397	1425398673000	1787	956	0	0	1344
65087	1397	1425388672000	1787	956	1	0	1345
65088	1397	1425378671000	1787	956	2	0	1346
65089	1397	1425368670000	1787	956	3	0	1347
65090	1397	1425358669000	1787	956	4	0	1348
65094	1397	1425338667000	1791	958	0	0	1350
65095	1397	1425328666000	1791	958	1	0	1351
65124	1397	1425318665000	1796	960	0	0	1352
65125	1397	1425308664000	1796	960	1	0	1353
65126	1397	1425298663000	1796	960	2	0	1354
65128	1516	0	1798	962	0	0	1
65129	1397	1425278661000	1798	962	1	0	1356
65130	1397	1425268660000	1798	962	2	0	1357
65134	1397	1425258659000	1800	963	0	0	1358
65141	1397	1425238657000	1805	965	0	0	1360
65142	1397	1425228656000	1805	965	1	0	1361
65143	1756	6479139000000	1805	965	2	0	1
65144	1397	1425218655000	1806	966	0	0	1362
65145	1397	1425208654000	1807	967	0	0	\N
65147	1397	1425198653000	1809	968	0	0	\N
65148	1397	1425198653000	1810	968	0	0	\N
65152	1397	1425168650000	1813	970	0	0	\N
65154	1397	1425158649000	1815	971	0	0	\N
65155	1397	1425148648000	1815	971	1	0	\N
65164	1397	1425088642000	1821	975	0	0	\N
65165	1397	1425088642000	1824	975	0	0	\N
65166	1397	1425088642000	1825	975	0	0	\N
65169	1397	1425058639000	1828	978	0	0	\N
65171	1397	1425058639000	1830	978	0	0	\N
65172	1397	1425048638000	1831	979	0	0	\N
65173	1397	1425048638000	1832	979	0	0	\N
65174	1397	1425048638000	1833	979	0	0	\N
65178	1397	1425028636000	1837	981	0	0	\N
65180	1397	1425008634000	1839	983	0	0	\N
65183	1397	1424998633000	1842	984	0	0	\N
65184	1397	1424988632000	1843	985	0	0	\N
65186	1397	1424998633000	1845	984	0	0	\N
65187	1397	1424988632000	1845	984	1	0	\N
65188	1397	1424978631000	1846	986	0	0	\N
65189	1397	1424978631000	1847	986	0	0	\N
65191	1397	1424978631000	1849	986	0	0	\N
65192	1397	1424968630000	1850	987	0	0	\N
65194	1397	1424968630000	1852	987	0	0	\N
65195	1397	1424958629000	1853	988	0	0	\N
65197	1397	1424948628000	1855	989	0	0	\N
65202	1397	1424928626000	1859	991	0	0	\N
65203	1397	1424918625000	1859	991	1	0	\N
65204	1397	1424928626000	1860	991	0	0	\N
65205	1397	1424918625000	1860	991	1	0	\N
65206	1397	1424908624000	1861	992	0	0	\N
65208	1397	1424898623000	1863	993	0	0	\N
65211	1397	1424888622000	1866	994	0	0	\N
65213	1397	1425698703000	1868	935	0	0	\N
65214	1397	1425688702000	1868	935	1	0	\N
65215	1397	1425678701000	1868	935	2	0	\N
65216	1397	1425668700000	1868	935	3	0	\N
65217	1397	1425658699000	1868	935	4	0	\N
65218	1397	1425648698000	1868	935	5	0	\N
65219	1397	1425638697000	1868	935	6	0	\N
65220	1397	1425628696000	1868	935	7	0	\N
65221	1397	1425618695000	1868	935	8	0	\N
65222	1397	1425608694000	1868	935	9	0	\N
65223	1397	1425598693000	1868	935	10	0	\N
65224	1397	1425588692000	1868	935	11	0	\N
65225	1397	1425578691000	1868	935	12	0	\N
65226	1397	1425568690000	1868	935	13	0	\N
65227	1397	1425558689000	1868	935	14	0	\N
65228	1397	1425548688000	1868	935	15	0	\N
65229	1397	1425538687000	1868	935	16	0	\N
65230	1397	1425528686000	1868	935	17	0	\N
65231	1397	1425518685000	1868	935	18	0	\N
65232	1397	1425508684000	1868	935	19	0	\N
65233	1397	1425498683000	1868	935	20	0	\N
65234	1397	1425488682000	1868	935	21	0	\N
65235	1397	1425478681000	1868	935	22	0	\N
65236	1397	1425468680000	1868	935	23	0	\N
65237	1397	1425458679000	1868	935	24	0	\N
65238	1397	1425448678000	1868	935	25	0	\N
65239	1397	1425438677000	1868	935	26	0	\N
65240	1397	1425428676000	1868	935	27	0	\N
65241	1397	1425418675000	1868	935	28	0	\N
65242	1397	1425408674000	1868	935	29	0	\N
65243	1397	1425398673000	1868	935	30	0	\N
65244	1397	1425388672000	1868	935	31	0	\N
65245	1397	1425378671000	1868	935	32	0	\N
65246	1397	1425368670000	1868	935	33	0	\N
65247	1397	1425358669000	1868	935	34	0	\N
65248	1397	1425348668000	1868	935	35	0	\N
65249	1397	1425338667000	1868	935	36	0	\N
65250	1397	1425328666000	1868	935	37	0	\N
65251	1397	1425318665000	1868	935	38	0	\N
65252	1397	1425308664000	1868	935	39	0	\N
65253	1397	1425298663000	1868	935	40	0	\N
65254	1397	1425288662000	1868	935	41	0	\N
65255	1397	1425278661000	1868	935	42	0	\N
65256	1397	1425268660000	1868	935	43	0	\N
65257	1397	1425258659000	1868	935	44	0	\N
65258	1397	1425248658000	1868	935	45	0	\N
65259	1397	1425238657000	1868	935	46	0	\N
65260	1397	1425228656000	1868	935	47	0	\N
65261	1397	1425218655000	1868	935	48	0	\N
65262	1397	1425208654000	1868	935	49	0	\N
65263	1397	1425198653000	1868	935	50	0	\N
65264	1397	1425188652000	1868	935	51	0	\N
65265	1397	1425178651000	1868	935	52	0	\N
65266	1397	1425168650000	1868	935	53	0	\N
65267	1397	1425158649000	1868	935	54	0	\N
65268	1397	1425148648000	1868	935	55	0	\N
65269	1397	1425138647000	1868	935	56	0	\N
65270	1397	1425128646000	1868	935	57	0	\N
65271	1397	1425118645000	1868	935	58	0	\N
65272	1397	1425108644000	1868	935	59	0	\N
65273	1397	1425098643000	1868	935	60	0	\N
65274	1397	1425088642000	1868	935	61	0	\N
65275	1397	1425078641000	1868	935	62	0	\N
65276	1397	1425068640000	1868	935	63	0	\N
65277	1397	1425058639000	1868	935	64	0	\N
65278	1397	1425048638000	1868	935	65	0	\N
65279	1397	1425038637000	1868	935	66	0	\N
65280	1397	1425028636000	1868	935	67	0	\N
65150	1397	1425188652000	1812	969	0	0	1365
65151	1397	1425178651000	1812	969	1	0	1366
65153	1397	1425168650000	1814	970	0	0	1367
65156	1397	1425158649000	1817	972	0	0	1368
65157	1397	1425148648000	1817	972	1	0	1369
65159	1397	1425128646000	1817	972	3	0	1371
65160	1397	1425118645000	1818	973	0	0	1372
65161	1397	1425108644000	1819	974	0	0	1373
65162	1397	1425098643000	1819	974	1	0	1374
65163	1397	1425088642000	1820	975	0	0	1375
65168	1397	1425068640000	1827	977	0	0	1377
65170	1397	1425058639000	1829	978	0	0	1378
65175	1397	1425048638000	1835	980	0	0	1379
65176	1397	1425038637000	1835	980	1	0	1380
65179	1397	1425018635000	1838	982	0	0	1382
65181	1397	1425008634000	1840	983	0	0	1383
65182	1397	1424998633000	1841	984	0	0	1384
65185	1397	1424988632000	1844	985	0	0	1385
65190	1397	1424978631000	1848	986	0	0	1386
65196	1397	1424958629000	1854	988	0	0	1388
65198	1397	1424948628000	1856	989	0	0	1389
65199	1397	1424938627000	1857	990	0	0	1390
65200	1397	1424928626000	1858	991	0	0	1391
65201	1397	1424918625000	1858	991	1	0	1392
65209	1397	1424898623000	1864	993	0	0	1394
65210	1397	1424888622000	1865	994	0	0	1395
65212	1397	1424878621000	1867	995	0	0	1396
65281	1397	1425018635000	1868	935	68	0	\N
65282	1397	1425008634000	1868	935	69	0	\N
65283	1397	1424998633000	1868	935	70	0	\N
65284	1397	1424988632000	1868	935	71	0	\N
65285	1397	1424978631000	1868	935	72	0	\N
65286	1397	1424968630000	1868	935	73	0	\N
65287	1397	1424958629000	1868	935	74	0	\N
65288	1397	1424948628000	1868	935	75	0	\N
65289	1397	1424938627000	1868	935	76	0	\N
65290	1397	1424928626000	1868	935	77	0	\N
65291	1397	1424918625000	1868	935	78	0	\N
65292	1397	1424908624000	1868	935	79	0	\N
65293	1397	1424868620000	1869	996	0	0	\N
65294	1397	1424868620000	1870	996	0	0	\N
65296	1397	1424858619000	1872	997	0	0	\N
65297	1397	1424848618000	1872	997	2	0	\N
65300	1397	1424858619000	1874	997	0	0	\N
65301	1397	1424848618000	1874	997	2	0	\N
65303	1397	1424838617000	1876	998	0	0	\N
65304	1397	1424838617000	1877	998	0	0	\N
65305	1397	1424838617000	1878	998	0	0	\N
65309	1397	1424808614000	1881	1000	0	0	\N
65311	1397	1424788612000	1883	1002	0	0	\N
65312	1397	1424788612000	1884	1002	0	0	\N
65316	1397	1424758609000	1887	1004	0	0	\N
65318	1397	1424748608000	1889	1005	0	0	\N
65322	1397	1424718605000	1893	1008	0	0	\N
65328	1397	1424668600000	1897	1011	0	0	\N
65334	1397	1424628596000	1901	1013	0	0	\N
65335	1397	1424628596000	1902	1013	0	0	\N
65336	1397	1424618595000	1903	1014	0	0	\N
65339	1397	1424608594000	1906	1015	0	0	\N
65340	1397	1424608594000	1907	1015	0	0	\N
65341	1397	1424598593000	1908	1016	0	0	\N
65342	1397	1424598593000	1909	1016	0	0	\N
65349	1397	1424548588000	1914	1020	0	0	\N
65350	165	66000090000000	1914	1020	1	0	\N
65355	1397	1424518585000	1918	1023	0	0	\N
65356	1397	1424518585000	1919	1023	0	0	\N
65358	1397	1424518585000	1921	1023	0	0	\N
65359	1397	1424508584000	1922	1024	0	0	\N
65361	1397	1424508584000	1924	1024	0	0	\N
65362	1397	1424508584000	1925	1024	0	0	\N
65363	1397	1424498583000	1926	1025	0	0	\N
65364	1397	1424488582000	1926	1025	1	0	\N
65365	1397	1424478581000	1926	1025	2	0	\N
65369	1397	1424498583000	1928	1025	0	0	\N
65370	1397	1424488582000	1928	1025	1	0	\N
65371	1397	1424478581000	1928	1025	2	0	\N
65372	1397	1424468580000	1929	1026	0	0	\N
65376	1397	1424438577000	1932	1028	0	0	\N
65377	1397	1424438577000	1933	1028	0	0	\N
65379	1397	1424458579000	1935	1027	0	0	\N
65380	1397	1424448578000	1935	1027	1	0	\N
65381	1397	1424438577000	1935	1027	2	0	\N
65383	1397	1424428576000	1937	1029	0	0	\N
65384	1397	1424428576000	1938	1029	0	0	\N
65386	1397	1424418575000	1940	1030	0	0	\N
65387	1397	1424418575000	1941	1030	0	0	\N
65390	1397	1424408574000	1943	1031	0	0	\N
65391	1397	1424398573000	1943	1031	1	0	\N
65392	1397	1424388572000	1944	1032	0	0	\N
65393	1397	1424388572000	1945	1032	0	0	\N
65394	1693	4638237500454	1946	998	0	0	\N
65395	1397	1424838617000	1946	998	1	0	\N
65396	1397	1424828616000	1946	998	2	0	\N
65397	1397	1424818615000	1946	998	3	0	\N
65398	1397	1424808614000	1946	998	4	0	\N
65399	1397	1424798613000	1946	998	5	0	\N
65400	1397	1424788612000	1946	998	6	0	\N
65401	1397	1424778611000	1946	998	7	0	\N
65402	1397	1424768610000	1946	998	8	0	\N
65403	1397	1424758609000	1946	998	9	0	\N
65404	1397	1424748608000	1946	998	10	0	\N
65405	1397	1424738607000	1946	998	11	0	\N
65406	1397	1424728606000	1946	998	12	0	\N
65407	1397	1424718605000	1946	998	13	0	\N
65408	1397	1424708604000	1946	998	14	0	\N
65409	1397	1424698603000	1946	998	15	0	\N
65410	1397	1424688602000	1946	998	16	0	\N
65411	1397	1424678601000	1946	998	17	0	\N
65412	1397	1424668600000	1946	998	18	0	\N
65413	1397	1424658599000	1946	998	19	0	\N
65414	1397	1424648598000	1946	998	20	0	\N
65415	1397	1424638597000	1946	998	21	0	\N
65416	1397	1424628596000	1946	998	22	0	\N
65299	1397	1424848618000	1873	997	2	0	1399
65302	1397	1424838617000	1875	998	0	0	1400
65306	1397	1424828616000	1879	999	0	0	1401
65307	1397	1424818615000	1879	999	1	0	1402
65308	1397	1424808614000	1880	1000	0	0	1403
65313	1397	1424788612000	1885	1002	0	0	1405
65314	1397	1424778611000	1886	1003	0	0	1406
65315	1397	1424768610000	1886	1003	1	0	1407
65317	1397	1424758609000	1888	1004	0	0	1408
65319	1397	1424748608000	1890	1005	0	0	1409
65321	1397	1424728606000	1892	1007	0	0	1411
65323	1397	1424718605000	1894	1008	0	0	1412
65324	1397	1424708604000	1895	1009	0	0	1413
65325	1397	1424698603000	1896	1010	0	0	1414
65327	1397	1424678601000	1896	1010	2	0	1416
65329	1397	1424668600000	1898	1011	0	0	1417
65330	1397	1424658599000	1899	1012	0	0	1418
65331	1397	1424648598000	1899	1012	1	0	1419
65332	1397	1424638597000	1899	1012	2	0	1420
65337	1397	1424618595000	1904	1014	0	0	1422
65338	1397	1424608594000	1905	1015	0	0	1423
65343	1397	1424598593000	1910	1016	0	0	1424
65344	1397	1424588592000	1911	1017	0	0	1425
65345	1693	4638237500454	1911	1017	1	0	117
65347	1397	1424568590000	1912	1018	0	0	1427
65348	1397	1424558589000	1913	1019	0	0	1428
65351	1397	1424548588000	1915	1020	0	0	1429
65352	165	66000090000000	1915	1020	1	0	1
65354	1397	1424528586000	1917	1022	0	0	1431
65357	1397	1424518585000	1920	1023	0	0	1432
65360	1397	1424508584000	1923	1024	0	0	1433
65366	1397	1424498583000	1927	1025	0	0	1434
65367	1397	1424488582000	1927	1025	1	0	1435
65373	1397	1424468580000	1930	1026	0	0	1437
65374	1397	1424458579000	1931	1027	0	0	1438
65375	1397	1424448578000	1931	1027	1	0	1439
65378	1397	1424438577000	1934	1028	0	0	1440
65382	1397	1424428576000	1936	1029	0	0	1441
65388	1397	1424408574000	1942	1031	0	0	1443
65389	1397	1424398573000	1942	1031	1	0	1444
65417	1397	1424618595000	1946	998	23	0	\N
65418	1397	1424608594000	1946	998	24	0	\N
65419	1397	1424598593000	1946	998	25	0	\N
65420	1397	1424588592000	1946	998	26	0	\N
65421	1397	1424578591000	1946	998	27	0	\N
65422	1397	1424568590000	1946	998	28	0	\N
65423	1397	1424558589000	1946	998	29	0	\N
65424	1397	1424548588000	1946	998	30	0	\N
65425	1397	1424538587000	1946	998	31	0	\N
65426	1397	1424528586000	1946	998	32	0	\N
65427	1397	1424518585000	1946	998	33	0	\N
65428	1397	1424508584000	1946	998	34	0	\N
65429	1397	1424498583000	1946	998	35	0	\N
65430	1397	1424488582000	1946	998	36	0	\N
65431	1397	1424478581000	1946	998	37	0	\N
65432	1397	1424468580000	1946	998	38	0	\N
65433	1397	1424458579000	1946	998	39	0	\N
65434	1397	1424448578000	1946	998	40	0	\N
65435	1397	1424438577000	1946	998	41	0	\N
65436	1397	1424428576000	1946	998	42	0	\N
65437	1397	1424418575000	1946	998	43	0	\N
65438	1397	1424408574000	1946	998	44	0	\N
65439	1397	1424398573000	1946	998	45	0	\N
65440	1397	1424388572000	1946	998	46	0	\N
65445	1397	1424358569000	1950	1034	0	0	\N
65446	1397	1424358569000	1951	1034	0	0	\N
65447	1397	1424358569000	1952	1034	0	0	\N
65448	1397	1424348568000	1953	1035	0	0	\N
65450	1397	1424338567000	1955	1036	0	0	\N
65451	1397	1424328566000	1955	1036	1	0	\N
65455	1397	1424318565000	1958	1037	0	0	\N
65456	1397	1424318565000	1959	1037	0	0	\N
65457	1397	1424308564000	1960	1038	0	0	\N
65458	1397	1424298563000	1960	1038	1	0	\N
65461	1397	1424288562000	1962	1039	0	0	\N
65462	1397	1424288562000	1963	1039	0	0	\N
65464	1397	1424288562000	1965	1039	0	0	\N
65473	1397	1424218555000	1968	1041	0	0	\N
65474	1397	1424208554000	1968	1041	1	0	\N
65475	1397	1424218555000	1969	1041	0	0	\N
65476	1397	1424208554000	1969	1041	1	0	\N
65477	1397	1424198553000	1970	1042	0	0	\N
65480	1397	1424188552000	1973	1043	0	0	\N
65481	1397	1424188552000	1974	1043	0	0	\N
65482	1693	3198217500454	1975	892	0	0	\N
65483	1397	1425768710000	1975	892	1	0	\N
65484	1397	1425758709000	1975	892	2	0	\N
65485	1397	1425748708000	1975	892	3	0	\N
65486	1397	1425738707000	1975	892	4	0	\N
65487	1397	1425728706000	1975	892	5	0	\N
65488	1397	1425718705000	1975	892	6	0	\N
65489	1397	1425708704000	1975	892	7	0	\N
65490	1397	1425698703000	1975	892	8	0	\N
65491	1397	1425688702000	1975	892	9	0	\N
65492	1397	1425678701000	1975	892	10	0	\N
65493	1397	1425668700000	1975	892	11	0	\N
65494	1397	1425658699000	1975	892	12	0	\N
65495	1397	1425648698000	1975	892	13	0	\N
65496	1397	1425638697000	1975	892	14	0	\N
65497	1397	1425628696000	1975	892	15	0	\N
65498	1397	1425618695000	1975	892	16	0	\N
65499	1397	1425608694000	1975	892	17	0	\N
65500	1397	1425598693000	1975	892	18	0	\N
65501	1397	1425588692000	1975	892	19	0	\N
65502	1397	1425578691000	1975	892	20	0	\N
65503	1397	1425568690000	1975	892	21	0	\N
65504	1397	1425558689000	1975	892	22	0	\N
65505	1397	1425548688000	1975	892	23	0	\N
65506	1397	1425538687000	1975	892	24	0	\N
65507	1397	1425528686000	1975	892	25	0	\N
65508	1397	1425518685000	1975	892	26	0	\N
65509	1397	1425508684000	1975	892	27	0	\N
65510	1397	1425498683000	1975	892	28	0	\N
65511	1397	1425488682000	1975	892	29	0	\N
65512	1397	1425478681000	1975	892	30	0	\N
65513	1397	1425468680000	1975	892	31	0	\N
65514	1397	1425458679000	1975	892	32	0	\N
65515	1397	1425448678000	1975	892	33	0	\N
65516	1397	1425438677000	1975	892	34	0	\N
65517	1397	1425428676000	1975	892	35	0	\N
65518	1397	1425418675000	1975	892	36	0	\N
65519	1397	1425408674000	1975	892	37	0	\N
65520	1397	1425398673000	1975	892	38	0	\N
65521	1397	1425388672000	1975	892	39	0	\N
65522	1397	1425378671000	1975	892	40	0	\N
65523	1397	1425368670000	1975	892	41	0	\N
65524	1397	1425358669000	1975	892	43	0	\N
65525	1397	1425348668000	1975	892	44	0	\N
65526	1397	1425338667000	1975	892	45	0	\N
65527	1397	1425328666000	1975	892	46	0	\N
65528	1397	1425318665000	1975	892	47	0	\N
65529	1397	1425308664000	1975	892	48	0	\N
65530	1397	1425298663000	1975	892	49	0	\N
65531	1397	1425288662000	1975	892	50	0	\N
65532	1397	1425278661000	1975	892	51	0	\N
65533	1397	1425268660000	1975	892	52	0	\N
65534	1397	1425258659000	1975	892	53	0	\N
65535	1397	1425248658000	1975	892	54	0	\N
65536	1397	1425238657000	1975	892	55	0	\N
65537	1397	1425228656000	1975	892	56	0	\N
65538	1397	1425218655000	1975	892	57	0	\N
65539	1397	1425208654000	1975	892	58	0	\N
65540	1397	1425198653000	1975	892	59	0	\N
65541	1397	1425188652000	1975	892	60	0	\N
65542	1397	1425178651000	1975	892	61	0	\N
65543	1397	1425168650000	1975	892	62	0	\N
65544	1397	1425158649000	1975	892	63	0	\N
65545	1397	1425148648000	1975	892	64	0	\N
65546	1397	1425138647000	1975	892	65	0	\N
65547	1397	1425128646000	1975	892	66	0	\N
65548	1397	1425118645000	1975	892	67	0	\N
65549	1397	1425108644000	1975	892	68	0	\N
65550	1397	1425098643000	1975	892	69	0	\N
65551	1397	1425088642000	1975	892	70	0	\N
65552	1397	1425078641000	1975	892	71	0	\N
65443	1397	1424368570000	1948	1033	1	0	1447
65444	1397	1424358569000	1949	1034	0	0	1448
65449	1397	1424348568000	1954	1035	0	0	1449
65452	1397	1424338567000	1956	1036	0	0	1450
65453	1397	1424328566000	1956	1036	1	0	1451
65459	1397	1424308564000	1961	1038	0	0	1453
65460	1397	1424298563000	1961	1038	1	0	1454
65463	1397	1424288562000	1964	1039	0	0	1455
65465	1397	1424278561000	1966	1040	0	0	1456
65466	1397	1424268560000	1966	1040	1	0	1457
65468	1397	1424248558000	1966	1040	3	0	1459
65469	1397	1424238557000	1966	1040	4	0	1460
65470	1397	1424228556000	1966	1040	5	0	1461
65471	1397	1424218555000	1967	1041	0	0	1462
65478	1397	1424198553000	1971	1042	0	0	1464
65479	1397	1424188552000	1972	1043	0	0	1465
65553	1397	1425068640000	1975	892	72	0	\N
65554	1397	1425058639000	1975	892	73	0	\N
65555	1397	1425048638000	1975	892	74	0	\N
65556	1397	1425038637000	1975	892	75	0	\N
65557	1397	1425028636000	1975	892	76	0	\N
65558	1397	1425018635000	1975	892	77	0	\N
65559	1397	1425008634000	1975	892	78	0	\N
65560	1397	1424998633000	1975	892	79	0	\N
65561	1397	1424988632000	1975	892	80	0	\N
65562	1397	1424978631000	1975	892	81	0	\N
65563	1397	1424968630000	1975	892	82	0	\N
65564	1397	1424958629000	1975	892	83	0	\N
65565	1397	1424948628000	1975	892	84	0	\N
65566	1397	1424938627000	1975	892	85	0	\N
65567	1397	1424928626000	1975	892	86	0	\N
65568	1397	1424918625000	1975	892	87	0	\N
65569	1397	1424908624000	1975	892	88	0	\N
65570	1397	1424898623000	1975	892	89	0	\N
65571	1397	1424888622000	1975	892	90	0	\N
65572	1397	1424878621000	1975	892	91	0	\N
65573	1397	1424868620000	1975	892	92	0	\N
65574	1397	1424858619000	1975	892	93	0	\N
65575	1397	1424848618000	1975	892	94	0	\N
65576	1397	1424838617000	1975	892	95	0	\N
65577	1397	1424828616000	1975	892	96	0	\N
65578	1397	1424818615000	1975	892	97	0	\N
65579	1397	1424808614000	1975	892	98	0	\N
65580	1397	1424798613000	1975	892	99	0	\N
65581	1397	1424788612000	1975	892	100	0	\N
65582	1397	1424778611000	1975	892	101	0	\N
65583	1397	1424768610000	1975	892	102	0	\N
65584	1397	1424758609000	1975	892	103	0	\N
65585	1397	1424748608000	1975	892	104	0	\N
65586	1397	1424738607000	1975	892	105	0	\N
65587	1397	1424728606000	1975	892	106	0	\N
65588	1397	1424718605000	1975	892	107	0	\N
65589	1397	1424708604000	1975	892	108	0	\N
65590	1397	1424698603000	1975	892	109	0	\N
65591	1397	1424688602000	1975	892	110	0	\N
65592	1397	1424678601000	1975	892	111	0	\N
65593	1397	1424668600000	1975	892	112	0	\N
65594	1397	1424658599000	1975	892	113	0	\N
65595	1397	1424648598000	1975	892	114	0	\N
65596	1397	1424638597000	1975	892	115	0	\N
65597	1397	1424628596000	1975	892	116	0	\N
65598	1397	1424618595000	1975	892	117	0	\N
65599	1397	1424608594000	1975	892	118	0	\N
65600	1397	1424598593000	1975	892	119	0	\N
65601	1397	1424588592000	1975	892	120	0	\N
65602	1397	1424578591000	1975	892	121	0	\N
65603	1397	1424568590000	1975	892	122	0	\N
65604	1397	1424558589000	1975	892	123	0	\N
65605	1397	1424548588000	1975	892	124	0	\N
65606	1397	1424538587000	1975	892	125	0	\N
65608	1397	1424168550000	1977	1045	0	0	\N
65613	1397	1424128546000	1980	1047	0	0	\N
65614	1397	1424128546000	1981	1047	0	0	\N
65617	1397	1424108544000	1984	1049	0	0	\N
65618	1397	1424098543000	1984	1049	1	0	\N
65622	1397	1424078541000	1987	1051	0	0	\N
65624	1397	1424078541000	1989	1051	0	0	\N
65625	1397	1424068540000	1990	1052	0	0	\N
65627	1397	1424068540000	1992	1052	0	0	\N
65629	1397	1424048538000	1994	1054	0	0	\N
65633	1397	1424038537000	1997	1055	0	0	\N
65634	1397	1424028536000	1997	1055	1	0	\N
65637	1397	1424008534000	2000	1057	0	0	\N
65638	1397	1424008534000	2001	1057	0	0	\N
65639	1397	1424528586000	2002	893	0	0	\N
65640	1397	1424518585000	2002	893	1	0	\N
65641	1397	1424508584000	2002	893	2	0	\N
65642	1397	1424498583000	2002	893	3	0	\N
65643	1397	1424488582000	2002	893	4	0	\N
65644	1397	1424478581000	2002	893	5	0	\N
65645	1397	1424468580000	2002	893	6	0	\N
65646	1397	1424458579000	2002	893	7	0	\N
65647	1397	1424448578000	2002	893	8	0	\N
65648	1397	1424438577000	2002	893	9	0	\N
65649	1397	1424428576000	2002	893	10	0	\N
65650	1397	1424418575000	2002	893	11	0	\N
65651	1397	1424408574000	2002	893	12	0	\N
65652	1397	1424398573000	2002	893	13	0	\N
65653	1397	1424388572000	2002	893	14	0	\N
65654	1397	1424378571000	2002	893	15	0	\N
65655	1397	1424368570000	2002	893	16	0	\N
65656	1397	1424358569000	2002	893	17	0	\N
65657	1397	1424348568000	2002	893	18	0	\N
65658	1397	1424338567000	2002	893	19	0	\N
65659	1397	1424328566000	2002	893	20	0	\N
65660	1397	1424318565000	2002	893	21	0	\N
65661	1397	1424308564000	2002	893	22	0	\N
65662	1397	1424298563000	2002	893	23	0	\N
65663	1397	1424288562000	2002	893	24	0	\N
65664	1397	1424278561000	2002	893	25	0	\N
65665	1397	1424268560000	2002	893	26	0	\N
65666	1397	1424258559000	2002	893	27	0	\N
65667	1397	1424248558000	2002	893	28	0	\N
65668	1397	1424238557000	2002	893	29	0	\N
65669	1397	1424228556000	2002	893	30	0	\N
65670	1397	1424218555000	2002	893	31	0	\N
65671	1397	1424208554000	2002	893	32	0	\N
65672	1397	1424198553000	2002	893	33	0	\N
65673	1397	1424188552000	2002	893	34	0	\N
65674	1397	1424178551000	2002	893	35	0	\N
65675	1397	1424168550000	2002	893	36	0	\N
65676	1397	1424158549000	2002	893	37	0	\N
65677	1397	1424148548000	2002	893	38	0	\N
65678	1397	1424138547000	2002	893	39	0	\N
65679	1397	1424128546000	2002	893	40	0	\N
65680	1397	1424118545000	2002	893	41	0	\N
65681	1397	1424108544000	2002	893	43	0	\N
65682	1397	1424098543000	2002	893	44	0	\N
65683	1397	1424088542000	2002	893	45	0	\N
65684	1397	1424078541000	2002	893	46	0	\N
65685	1397	1424068540000	2002	893	47	0	\N
65686	1397	1424058539000	2002	893	48	0	\N
65687	1397	1424048538000	2002	893	49	0	\N
65688	1397	1424038537000	2002	893	50	0	\N
65610	1397	1424158549000	1979	1046	0	0	1468
65611	1397	1424148548000	1979	1046	1	0	1469
65612	1397	1424138547000	1979	1046	2	0	1470
65615	1397	1424128546000	1982	1047	0	0	1471
65616	1397	1424118545000	1983	1048	0	0	1472
65620	1397	1424098543000	1985	1049	1	0	1474
65621	1397	1424088542000	1986	1050	0	0	1475
65623	1397	1424078541000	1988	1051	0	0	1476
65626	1397	1424068540000	1991	1052	0	0	1477
65628	1397	1424058539000	1993	1053	0	0	1478
65631	1397	1424038537000	1996	1055	0	0	1480
65632	1397	1424028536000	1996	1055	1	0	1481
65635	1397	1424018535000	1998	1056	0	0	1482
65636	1397	1424008534000	1999	1057	0	0	1483
65689	1397	1424028536000	2002	893	51	0	\N
65690	1397	1424018535000	2002	893	52	0	\N
65691	1397	1424008534000	2002	893	53	0	\N
65693	1397	1423988532000	2004	1059	0	0	\N
65694	1397	1423978531000	2004	1059	1	0	\N
65697	1397	1423988532000	2006	1059	0	0	\N
65698	1397	1423978531000	2006	1059	1	0	\N
65699	1397	1423988532000	2007	1059	0	0	\N
65700	1397	1423978531000	2007	1059	1	0	\N
65706	1397	1425158649000	2011	971	0	0	\N
65707	1693	4638237500454	2011	971	1	0	\N
65708	1397	1425148648000	2011	971	2	0	\N
65709	1397	1425138647000	2011	971	3	0	\N
65710	1397	1425128646000	2011	971	4	0	\N
65711	1397	1425118645000	2011	971	5	0	\N
65712	1397	1425108644000	2011	971	6	0	\N
65713	1397	1425098643000	2011	971	7	0	\N
65714	1397	1425088642000	2011	971	8	0	\N
65715	1397	1425078641000	2011	971	9	0	\N
65716	1397	1425068640000	2011	971	10	0	\N
65717	1397	1425058639000	2011	971	11	0	\N
65718	1397	1425048638000	2011	971	12	0	\N
65719	1397	1425038637000	2011	971	13	0	\N
65720	1397	1425028636000	2011	971	14	0	\N
65721	1397	1425018635000	2011	971	15	0	\N
65722	1397	1425008634000	2011	971	16	0	\N
65723	1397	1424998633000	2011	971	17	0	\N
65724	1397	1424988632000	2011	971	18	0	\N
65725	1397	1424978631000	2011	971	19	0	\N
65726	1397	1424968630000	2011	971	20	0	\N
65727	1397	1424958629000	2011	971	21	0	\N
65728	1397	1424948628000	2011	971	22	0	\N
65729	1397	1424938627000	2011	971	23	0	\N
65730	1397	1424928626000	2011	971	24	0	\N
65731	1397	1424918625000	2011	971	25	0	\N
65732	1397	1424908624000	2011	971	26	0	\N
65733	1397	1424898623000	2011	971	27	0	\N
65734	1397	1424888622000	2011	971	28	0	\N
65735	1397	1424878621000	2011	971	29	0	\N
65736	1397	1424868620000	2011	971	30	0	\N
65737	1397	1424858619000	2011	971	31	0	\N
65738	1397	1424848618000	2011	971	32	0	\N
65739	1397	1424838617000	2011	971	33	0	\N
65740	1397	1424828616000	2011	971	34	0	\N
65741	1397	1424818615000	2011	971	35	0	\N
65742	1397	1424808614000	2011	971	36	0	\N
65743	1397	1424798613000	2011	971	37	0	\N
65744	1397	1424788612000	2011	971	38	0	\N
65745	1397	1424778611000	2011	971	39	0	\N
65746	1397	1424768610000	2011	971	40	0	\N
65747	1397	1424758609000	2011	971	41	0	\N
65748	1397	1424748608000	2011	971	42	0	\N
65749	1397	1424738607000	2011	971	43	0	\N
65750	1397	1424728606000	2011	971	44	0	\N
65751	1397	1424718605000	2011	971	45	0	\N
65752	1397	1424708604000	2011	971	46	0	\N
65753	1397	1424698603000	2011	971	47	0	\N
65754	1397	1424688602000	2011	971	48	0	\N
65755	1397	1424678601000	2011	971	49	0	\N
65756	1397	1424668600000	2011	971	50	0	\N
65757	1397	1424658599000	2011	971	51	0	\N
65758	1397	1424648598000	2011	971	52	0	\N
65759	1397	1424638597000	2011	971	53	0	\N
65760	1397	1424628596000	2011	971	54	0	\N
65761	1397	1424618595000	2011	971	55	0	\N
65762	1397	1424608594000	2011	971	56	0	\N
65763	1397	1424598593000	2011	971	57	0	\N
65764	1397	1424588592000	2011	971	58	0	\N
65765	1397	1424578591000	2011	971	59	0	\N
65766	1397	1424568590000	2011	971	60	0	\N
65767	1397	1424558589000	2011	971	61	0	\N
65768	1397	1424548588000	2011	971	62	0	\N
65769	1397	1424538587000	2011	971	63	0	\N
65770	1397	1424528586000	2011	971	64	0	\N
65771	1397	1424518585000	2011	971	65	0	\N
65772	1397	1424508584000	2011	971	66	0	\N
65773	1397	1424498583000	2011	971	67	0	\N
65774	1397	1424488582000	2011	971	68	0	\N
65775	1397	1424478581000	2011	971	69	0	\N
65776	1397	1424468580000	2011	971	70	0	\N
65777	1397	1424458579000	2011	971	71	0	\N
65778	1397	1424448578000	2011	971	72	0	\N
65779	1397	1424438577000	2011	971	73	0	\N
65780	1397	1424428576000	2011	971	74	0	\N
65781	1397	1424418575000	2011	971	75	0	\N
65782	1397	1424408574000	2011	971	76	0	\N
65783	1397	1424398573000	2011	971	77	0	\N
65784	1397	1424388572000	2011	971	78	0	\N
65785	1397	1424378571000	2011	971	79	0	\N
65786	1397	1424368570000	2011	971	80	0	\N
65787	1397	1423928526000	2012	1062	0	0	\N
65788	1397	1423928526000	2013	1062	0	0	\N
65789	1397	1423928526000	2014	1062	0	0	\N
65793	1397	1423918525000	2016	1063	0	0	\N
65794	1397	1423908524000	2016	1063	1	0	\N
65795	1397	1423898523000	2016	1063	2	0	\N
65797	1397	1423878521000	2018	1065	0	0	\N
65798	1397	1423878521000	2019	1065	0	0	\N
65800	1397	1423868520000	2021	1066	0	0	\N
65801	1397	1423858519000	2021	1066	1	0	\N
65802	1397	1423868520000	2022	1066	0	0	\N
65803	1397	1423858519000	2022	1066	1	0	\N
65810	1397	1423828516000	2026	1068	0	0	\N
65811	1397	1423818515000	2026	1068	1	0	\N
65814	1397	1423788512000	2029	1071	0	0	\N
65816	1397	1423778511000	2031	1072	0	0	\N
65817	1397	1423778511000	2032	1072	0	0	\N
65818	1397	1423768510000	2032	1072	1	0	\N
65819	1397	1423778511000	2033	1072	0	0	\N
65820	1397	1423768510000	2033	1072	1	0	\N
65824	1397	1423748508000	2036	1074	0	0	\N
65696	1397	1423978531000	2005	1059	1	0	1486
65701	1397	1423968530000	2008	1060	0	0	1487
65702	1397	1423958529000	2008	1060	1	0	1488
65703	1397	1423948528000	2008	1060	2	0	1489
65704	1397	1423938527000	2009	1061	0	0	1490
65790	1397	1423918525000	2015	1063	0	0	1492
65791	1397	1423908524000	2015	1063	1	0	1493
65792	1397	1423898523000	2015	1063	2	0	1494
65796	1397	1423888522000	2017	1064	0	0	1495
65799	1397	1423878521000	2020	1065	0	0	1496
65805	1397	1423858519000	2023	1066	1	0	1498
65806	1397	1423848518000	2024	1067	0	0	1499
65807	1397	1423838517000	2024	1067	1	0	1500
65808	1397	1423828516000	2025	1068	0	0	1501
65812	1397	1423808514000	2027	1069	0	0	1503
65813	1397	1423798513000	2028	1070	0	0	1504
65815	1397	1423788512000	2030	1071	0	0	1505
65821	1397	1423778511000	2034	1072	0	0	1506
65822	1397	1423768510000	2034	1072	1	0	1507
65825	1397	1423738507000	2036	1074	1	0	\N
65833	1397	1423698503000	2041	1077	0	0	\N
65834	1397	1423688502000	2041	1077	1	0	\N
65837	1397	1423668500000	2044	1079	0	0	\N
65838	1397	1424408574000	2045	1031	0	0	\N
65839	1397	1424398573000	2045	1031	1	0	\N
65840	1397	1424388572000	2045	1031	2	0	\N
65841	1397	1424378571000	2045	1031	3	0	\N
65842	1397	1424368570000	2045	1031	4	0	\N
65843	1397	1424358569000	2045	1031	5	0	\N
65844	1397	1424348568000	2045	1031	6	0	\N
65845	1397	1424338567000	2045	1031	7	0	\N
65846	1397	1424328566000	2045	1031	8	0	\N
65847	1397	1424318565000	2045	1031	9	0	\N
65848	1397	1424308564000	2045	1031	10	0	\N
65849	1397	1424298563000	2045	1031	11	0	\N
65850	1397	1424288562000	2045	1031	12	0	\N
65851	1397	1424278561000	2045	1031	14	0	\N
65852	1397	1424268560000	2045	1031	15	0	\N
65853	1397	1424258559000	2045	1031	16	0	\N
65854	1397	1424248558000	2045	1031	17	0	\N
65855	1397	1424238557000	2045	1031	18	0	\N
65856	1397	1424228556000	2045	1031	19	0	\N
65857	1397	1424218555000	2045	1031	20	0	\N
65858	1397	1424208554000	2045	1031	21	0	\N
65859	1397	1424198553000	2045	1031	22	0	\N
65860	1397	1424188552000	2045	1031	23	0	\N
65861	1397	1424178551000	2045	1031	24	0	\N
65862	1397	1424168550000	2045	1031	25	0	\N
65863	1397	1424158549000	2045	1031	26	0	\N
65864	1397	1424148548000	2045	1031	27	0	\N
65865	1397	1424138547000	2045	1031	28	0	\N
65866	1397	1424128546000	2045	1031	29	0	\N
65867	1397	1424118545000	2045	1031	30	0	\N
65868	1397	1424108544000	2045	1031	31	0	\N
65869	1397	1424098543000	2045	1031	32	0	\N
65870	1397	1424088542000	2045	1031	33	0	\N
65871	1397	1424078541000	2045	1031	34	0	\N
65872	1397	1424068540000	2045	1031	35	0	\N
65873	1397	1424058539000	2045	1031	36	0	\N
65874	1397	1424048538000	2045	1031	37	0	\N
65875	1397	1424038537000	2045	1031	38	0	\N
65876	1397	1424028536000	2045	1031	39	0	\N
65877	1397	1424018535000	2045	1031	40	0	\N
65878	1397	1424008534000	2045	1031	41	0	\N
65879	1397	1423998533000	2045	1031	42	0	\N
65880	1397	1423988532000	2045	1031	43	0	\N
65881	1397	1423978531000	2045	1031	44	0	\N
65882	1397	1423968530000	2045	1031	45	0	\N
65883	1397	1423958529000	2045	1031	46	0	\N
65884	1397	1423948528000	2045	1031	47	0	\N
65885	1397	1423938527000	2045	1031	48	0	\N
65894	1397	1423588492000	2049	1082	0	0	\N
65898	1397	1423568490000	2052	1084	0	0	\N
65899	1397	1423558489000	2052	1084	1	0	\N
65901	1397	1423548488000	2054	1085	0	0	\N
65903	1397	1423538487000	2056	1086	0	0	\N
65904	1397	1423528486000	2057	1087	0	0	\N
65905	1397	1423528486000	2058	1087	0	0	\N
65909	1397	1423498483000	2062	1090	0	0	\N
65911	1397	1423498483000	2064	1090	0	0	\N
65913	1397	1423478481000	2066	1092	0	0	\N
65916	1397	1423468480000	2069	1093	0	0	\N
65917	1397	1423468480000	2070	1093	0	0	\N
65921	1397	1423448478000	2073	1095	0	0	\N
65922	1397	1423438477000	2073	1095	1	0	\N
65924	1397	1423428476000	2075	1096	0	0	\N
65925	1397	1423428476000	2076	1096	0	0	\N
65926	1397	1423418475000	2077	1097	0	0	\N
65928	1397	1423408474000	2079	1098	0	0	\N
65930	1397	1423398473000	2081	1099	0	0	\N
65931	1397	1423398473000	2082	1099	0	0	\N
65934	1397	1423388472000	2085	1100	0	0	\N
65943	1397	1423298463000	2091	1105	0	0	\N
65944	1397	1423298463000	2092	1105	0	0	\N
65946	1397	1423298463000	2094	1105	0	0	\N
65947	1397	1423288462000	2095	1106	0	0	\N
65948	1397	1423278461000	2095	1106	1	0	\N
65951	1397	1423288462000	2097	1106	0	0	\N
65952	1397	1423278461000	2097	1106	1	0	\N
65956	1397	1423238457000	2100	1109	0	0	\N
65958	1397	1423238457000	2102	1109	0	0	\N
65959	1397	1423238457000	2103	1109	0	0	\N
65960	1397	1423228456000	2104	1110	0	0	\N
65828	1397	1423728506000	2038	1075	0	0	1511
65829	1397	1423718505000	2038	1075	1	0	1512
65830	1397	1423708504000	2039	1076	0	0	1513
65831	1397	1423698503000	2040	1077	0	0	1514
65832	1397	1423688502000	2040	1077	1	0	1515
65836	1397	1423668500000	2043	1079	0	0	1517
65886	1397	1423658499000	2046	1080	0	0	1518
65887	1397	1423648498000	2046	1080	1	0	1519
65888	1397	1423638497000	2046	1080	2	0	1520
65889	1397	1423628496000	2046	1080	3	0	1521
65891	1397	1423608494000	2046	1080	5	0	1523
65892	1397	1423598493000	2047	1081	0	0	1524
65893	1397	1423588492000	2048	1082	0	0	1525
65895	1397	1423578491000	2050	1083	0	0	1526
65897	1397	1423558489000	2051	1084	1	0	1528
65900	1397	1423548488000	2053	1085	0	0	1529
65902	1397	1423538487000	2055	1086	0	0	1530
65906	1397	1423528486000	2059	1087	0	0	1531
65907	1397	1423518485000	2060	1088	0	0	1532
65910	1397	1423498483000	2063	1090	0	0	1534
65912	1397	1423488482000	2065	1091	0	0	1535
65914	1397	1423478481000	2067	1092	0	0	1536
65915	1397	1423468480000	2068	1093	0	0	1537
65918	1397	1423458479000	2071	1094	0	0	1538
65920	1397	1423438477000	2072	1095	1	0	1540
65923	1397	1423428476000	2074	1096	0	0	1541
65927	1397	1423418475000	2078	1097	0	0	1542
65929	1397	1423408474000	2080	1098	0	0	1543
65933	1397	1423388472000	2084	1100	0	0	1545
65935	1397	1423378471000	2086	1101	0	0	1546
65936	1397	1423368470000	2087	1102	0	0	1547
65937	1397	1423358469000	2087	1102	1	0	1548
65938	1397	1423348468000	2087	1102	2	0	1549
65940	1397	1423328466000	2089	1103	1	0	1551
65941	1397	1423318465000	2089	1103	2	0	1552
65942	1397	1423308464000	2090	1104	0	0	1553
65945	1397	1423298463000	2093	1105	0	0	1554
65949	1397	1423288462000	2096	1106	0	0	1555
65953	1397	1423268460000	2098	1107	0	0	1557
65954	1397	1423258459000	2098	1107	1	0	1558
65955	1397	1423248458000	2099	1108	0	0	1559
65957	1397	1423238457000	2101	1109	0	0	1560
65961	1397	1423228456000	2105	1110	0	0	\N
65963	1397	1424748608000	2107	1005	0	0	\N
65964	1397	1424738607000	2107	1005	1	0	\N
65965	1397	1424728606000	2107	1005	2	0	\N
65966	1693	4638237500454	2107	1005	3	0	\N
65967	1397	1424718605000	2107	1005	4	0	\N
65968	1397	1424708604000	2107	1005	5	0	\N
65969	1397	1424698603000	2107	1005	6	0	\N
65970	1397	1424688602000	2107	1005	7	0	\N
65971	1397	1424678601000	2107	1005	8	0	\N
65972	1397	1424668600000	2107	1005	9	0	\N
65973	1397	1424658599000	2107	1005	10	0	\N
65974	1397	1424648598000	2107	1005	11	0	\N
65975	1397	1424638597000	2107	1005	12	0	\N
65976	1397	1424628596000	2107	1005	13	0	\N
65977	1397	1424618595000	2107	1005	14	0	\N
65978	1397	1424608594000	2107	1005	15	0	\N
65979	1397	1424598593000	2107	1005	16	0	\N
65980	1397	1424588592000	2107	1005	17	0	\N
65981	1397	1424578591000	2107	1005	18	0	\N
65982	1397	1424568590000	2107	1005	19	0	\N
65983	1397	1424558589000	2107	1005	20	0	\N
65984	1397	1424548588000	2107	1005	21	0	\N
65985	1397	1424538587000	2107	1005	22	0	\N
65986	1397	1424528586000	2107	1005	23	0	\N
65987	1397	1424518585000	2107	1005	24	0	\N
65988	1397	1424508584000	2107	1005	25	0	\N
65989	1397	1424498583000	2107	1005	26	0	\N
65990	1397	1424488582000	2107	1005	27	0	\N
65991	1397	1424478581000	2107	1005	28	0	\N
65992	1397	1424468580000	2107	1005	29	0	\N
65993	1397	1424458579000	2107	1005	30	0	\N
65994	1397	1424448578000	2107	1005	31	0	\N
65995	1397	1424438577000	2107	1005	32	0	\N
65996	1397	1424428576000	2107	1005	33	0	\N
65997	1397	1424418575000	2107	1005	34	0	\N
65998	1397	1424408574000	2107	1005	35	0	\N
65999	1397	1424398573000	2107	1005	36	0	\N
66000	1397	1424388572000	2107	1005	37	0	\N
66001	1397	1424378571000	2107	1005	38	0	\N
66002	1397	1424368570000	2107	1005	39	0	\N
66003	1397	1424358569000	2107	1005	40	0	\N
66004	1397	1424348568000	2107	1005	41	0	\N
66005	1397	1424338567000	2107	1005	42	0	\N
66006	1397	1424328566000	2107	1005	43	0	\N
66007	1397	1424318565000	2107	1005	44	0	\N
66008	1397	1424308564000	2107	1005	45	0	\N
66009	1397	1424298563000	2107	1005	46	0	\N
66010	1397	1424288562000	2107	1005	47	0	\N
66011	1397	1424278561000	2107	1005	48	0	\N
66012	1397	1424268560000	2107	1005	49	0	\N
66013	1397	1424258559000	2107	1005	50	0	\N
66014	1397	1424248558000	2107	1005	51	0	\N
66015	1397	1424238557000	2107	1005	52	0	\N
66016	1397	1424228556000	2107	1005	53	0	\N
66017	1397	1424218555000	2107	1005	54	0	\N
66018	1397	1424208554000	2107	1005	55	0	\N
66019	1397	1424198553000	2107	1005	56	0	\N
66020	1397	1424188552000	2107	1005	57	0	\N
66021	1397	1424178551000	2107	1005	58	0	\N
66022	1397	1424168550000	2107	1005	59	0	\N
66023	1397	1424158549000	2107	1005	60	0	\N
66024	1397	1424148548000	2107	1005	61	0	\N
66025	1397	1424138547000	2107	1005	62	0	\N
66026	1397	1424128546000	2107	1005	63	0	\N
66027	1397	1424118545000	2107	1005	64	0	\N
66028	1397	1424108544000	2107	1005	65	0	\N
66029	1397	1424098543000	2107	1005	66	0	\N
66030	1397	1424088542000	2107	1005	67	0	\N
66031	1397	1424078541000	2107	1005	68	0	\N
66032	1397	1424068540000	2107	1005	69	0	\N
66033	1397	1424058539000	2107	1005	70	0	\N
66034	1397	1424048538000	2107	1005	71	0	\N
66035	1397	1424038537000	2107	1005	72	0	\N
66036	1397	1424028536000	2107	1005	73	0	\N
66037	1397	1424018535000	2107	1005	74	0	\N
66038	1397	1424008534000	2107	1005	75	0	\N
66039	1397	1423998533000	2107	1005	76	0	\N
66040	1397	1423988532000	2107	1005	77	0	\N
66041	1397	1423978531000	2107	1005	78	0	\N
66042	1397	1423968530000	2107	1005	79	0	\N
66043	1397	1423958529000	2107	1005	80	0	\N
66044	1397	1423948528000	2107	1005	81	0	\N
66045	1397	1423938527000	2107	1005	82	0	\N
66046	1397	1423928526000	2107	1005	83	0	\N
66047	1397	1423918525000	2107	1005	84	0	\N
66048	1397	1423908524000	2107	1005	85	0	\N
66049	1397	1423898523000	2107	1005	86	0	\N
66050	1397	1423888522000	2107	1005	87	0	\N
66051	1397	1423878521000	2107	1005	88	0	\N
66052	1397	1423868520000	2107	1005	89	0	\N
66053	1397	1423858519000	2107	1005	90	0	\N
66054	1397	1423848518000	2107	1005	91	0	\N
66055	1397	1423838517000	2107	1005	92	0	\N
66056	1397	1423828516000	2107	1005	93	0	\N
66057	1397	1423818515000	2107	1005	94	0	\N
66058	1397	1423808514000	2107	1005	95	0	\N
66059	1397	1423798513000	2107	1005	96	0	\N
66060	1397	1423788512000	2107	1005	97	0	\N
66061	1397	1423778511000	2107	1005	98	0	\N
66062	1397	1423768510000	2107	1005	99	0	\N
66063	1397	1423758509000	2107	1005	100	0	\N
66064	1397	1423748508000	2107	1005	102	0	\N
66065	1397	1423738507000	2107	1005	103	0	\N
66066	1397	1423728506000	2107	1005	104	0	\N
66067	1397	1423718505000	2107	1005	105	0	\N
66068	1397	1423708504000	2107	1005	106	0	\N
66069	1397	1423698503000	2107	1005	107	0	\N
66070	1397	1423688502000	2107	1005	108	0	\N
66071	1397	1423678501000	2107	1005	109	0	\N
66072	1397	1423668500000	2107	1005	110	0	\N
66073	1397	1423658499000	2107	1005	111	0	\N
66074	1397	1423648498000	2107	1005	112	0	\N
66075	1397	1423638497000	2107	1005	113	0	\N
66076	1397	1423628496000	2107	1005	114	0	\N
66077	1397	1423618495000	2107	1005	115	0	\N
66078	1397	1423608494000	2107	1005	116	0	\N
66079	1397	1423598493000	2107	1005	117	0	\N
66080	1397	1423588492000	2107	1005	118	0	\N
66081	1397	1423578491000	2107	1005	119	0	\N
66082	1397	1423568490000	2107	1005	120	0	\N
66083	1397	1423558489000	2107	1005	121	0	\N
66084	1397	1423548488000	2107	1005	122	0	\N
66085	1397	1423538487000	2107	1005	123	0	\N
66086	1397	1423528486000	2107	1005	124	0	\N
66087	1397	1423518485000	2107	1005	125	0	\N
66088	1397	1423218455000	2108	1111	0	0	\N
66091	1397	1423208454000	2111	1112	0	0	\N
66093	1397	1423198453000	2113	1113	0	0	\N
66090	1397	1423208454000	2110	1112	0	0	1563
66092	1397	1423198453000	2112	1113	0	0	1564
66094	1397	1423188452000	2114	1114	0	0	1565
66095	1397	1423178451000	2115	1115	0	0	1566
66096	1397	1423168450000	2115	1115	1	0	1567
66097	1397	1423158449000	2116	1116	0	0	\N
66098	1397	1423148448000	2116	1116	1	0	\N
66102	1397	1423138447000	2119	1117	0	0	\N
66104	1397	1423128446000	2121	1118	0	0	\N
66105	1397	1423128446000	2122	1118	0	0	\N
66107	1397	1423108444000	2124	1120	0	0	\N
66108	1397	1423098443000	2124	1120	1	0	\N
66116	1397	1423038437000	2131	1126	0	0	\N
66119	1397	1423028436000	2134	1127	0	0	\N
66120	1397	1423028436000	2135	1127	0	0	\N
66121	1397	1423048438000	2136	1125	0	0	\N
66122	1397	1423038437000	2136	1125	1	0	\N
66123	1397	1423028436000	2136	1125	2	0	\N
66124	1397	1423028436000	2137	1127	0	0	\N
66126	1397	1423018435000	2139	1128	0	0	\N
66127	1397	1423018435000	2140	1128	0	0	\N
66129	1397	1423008434000	2142	1129	0	0	\N
66139	1397	1422908424000	2150	1137	0	0	\N
66140	1397	1422898423000	2150	1137	1	0	\N
66146	1397	1422858419000	2156	1140	0	0	\N
66147	1397	1422848418000	2156	1140	1	0	\N
66150	1397	1422858419000	2158	1140	0	0	\N
66151	1397	1422848418000	2158	1140	1	0	\N
66152	1397	1422858419000	2159	1140	0	0	\N
66153	1397	1422848418000	2159	1140	1	0	\N
66155	1397	1422838417000	2161	1141	0	0	\N
66156	1397	1422838417000	2162	1141	0	0	\N
66158	1397	1422818415000	2164	1143	0	0	\N
66159	1397	1422818415000	2165	1143	0	0	\N
66161	633	69598950000000	2167	1144	0	0	\N
66162	1397	1422808414000	2167	1144	1	0	\N
66165	633	69598950000000	2169	1144	0	0	\N
66166	1397	1422808414000	2169	1144	1	0	\N
66167	1397	1422798413000	2170	1145	0	0	\N
66172	1397	1422758409000	2174	1147	0	0	\N
66174	1397	1422758409000	2176	1147	0	0	\N
66175	1397	1422748408000	2177	1148	0	0	\N
66180	1397	1422708404000	2180	1150	0	0	\N
66181	1397	1422698403000	2180	1150	1	0	\N
66185	1397	1422688402000	2183	1151	0	0	\N
66186	1397	1422688402000	2184	1151	0	0	\N
66187	1397	1422678401000	2185	1152	0	0	\N
66188	1397	1422668400000	2185	1152	1	0	\N
66189	633	68158930000000	2186	972	0	0	\N
66190	1397	1424358569000	2186	972	1	0	\N
66191	1397	1424348568000	2186	972	2	0	\N
66192	1397	1424338567000	2186	972	3	0	\N
66193	1397	1424328566000	2186	972	4	0	\N
66194	1397	1424318565000	2186	972	5	0	\N
66195	1397	1424308564000	2186	972	6	0	\N
66196	1397	1424298563000	2186	972	7	0	\N
66197	1397	1424288562000	2186	972	8	0	\N
66198	1397	1424278561000	2186	972	9	0	\N
66199	1397	1424268560000	2186	972	10	0	\N
66200	1397	1424258559000	2186	972	11	0	\N
66201	1397	1424248558000	2186	972	12	0	\N
66205	1397	1422648398000	2189	1154	0	0	\N
66207	1397	1422638397000	2191	1155	0	0	\N
66209	1397	1422638397000	2193	1155	0	0	\N
66210	1397	1422628396000	2193	1155	1	0	\N
66211	1397	1422618395000	2193	1155	2	0	\N
66212	1397	1422608394000	2193	1155	3	0	\N
66216	633	69598950000000	2195	1112	0	0	\N
66217	1397	1423208454000	2195	1112	1	0	\N
66218	1397	1423198453000	2195	1112	2	0	\N
66219	1397	1423188452000	2195	1112	3	0	\N
66220	1397	1423178451000	2195	1112	4	0	\N
66221	1397	1423168450000	2195	1112	5	0	\N
66222	1397	1423158449000	2195	1112	6	0	\N
66223	1397	1423148448000	2195	1112	7	0	\N
66224	1397	1423138447000	2195	1112	8	0	\N
66225	1397	1423128446000	2195	1112	9	0	\N
66226	1397	1423118445000	2195	1112	10	0	\N
66227	1397	1423108444000	2195	1112	11	0	\N
66228	1397	1423098443000	2195	1112	12	0	\N
66229	1397	1423088442000	2195	1112	13	0	\N
66230	1397	1423078441000	2195	1112	14	0	\N
66231	1397	1423068440000	2195	1112	15	0	\N
66232	1397	1423058439000	2195	1112	16	0	\N
66101	1397	1423138447000	2118	1117	0	0	1570
66103	1397	1423128446000	2120	1118	0	0	1571
66106	1397	1423118445000	2123	1119	0	0	1572
66109	1397	1423108444000	2125	1120	0	0	1573
66110	1397	1423098443000	2125	1120	1	0	1574
66112	1397	1423078441000	2127	1122	0	0	1576
66113	1397	1423068440000	2128	1123	0	0	1577
66114	1397	1423058439000	2129	1124	0	0	1578
66115	1397	1423048438000	2130	1125	0	0	1579
66117	1397	1423038437000	2132	1126	0	0	1580
66125	1397	1423018435000	2138	1128	0	0	1582
66128	1397	1423008434000	2141	1129	0	0	1583
66130	1397	1422998433000	2143	1130	0	0	1584
66131	1397	1422988432000	2144	1131	0	0	1585
66133	1397	1422968430000	2146	1133	0	0	1587
66134	1397	1422958429000	2146	1133	1	0	1588
66135	1397	1422948428000	2147	1134	0	0	1589
66136	1397	1422938427000	2147	1134	1	0	1590
66137	1397	1422928426000	2148	1135	0	0	1591
66141	1397	1422908424000	2152	1137	0	0	1593
66142	1397	1422898423000	2152	1137	1	0	1594
66143	1397	1422888422000	2153	1138	0	0	1595
66144	1397	1422878421000	2154	1139	0	0	1596
66145	1397	1422868420000	2154	1139	1	0	1597
66149	1397	1422848418000	2157	1140	1	0	1599
66154	1397	1422838417000	2160	1141	0	0	1600
66157	1397	1422828416000	2163	1142	0	0	1601
66160	1397	1422818415000	2166	1143	0	0	1602
66164	1397	1422808414000	2168	1144	1	0	1603
66168	1397	1422798413000	2171	1145	0	0	1604
66169	1397	1422788412000	2172	1146	0	0	1605
66170	1397	1422778411000	2172	1146	1	0	1606
66171	1397	1422768410000	2172	1146	2	0	1607
66176	1397	1422748408000	2178	1148	0	0	1609
66177	1397	1422738407000	2179	1149	0	0	1610
66178	1397	1422728406000	2179	1149	1	0	1611
66179	1397	1422718405000	2179	1149	2	0	1612
66182	1397	1422708404000	2181	1150	0	0	1613
66184	1397	1422688402000	2182	1151	0	0	1615
66202	1397	1422678401000	2187	1152	0	0	1616
66203	1397	1422668400000	2187	1152	1	0	1617
66204	1397	1422658399000	2188	1153	0	0	1618
66208	1397	1422638397000	2192	1155	0	0	1620
66213	1397	1422628396000	2194	1156	0	0	1621
66214	1397	1422618395000	2194	1156	1	0	1622
66215	1397	1422608394000	2194	1156	2	0	1623
66233	1397	1423048438000	2195	1112	17	0	\N
66234	1397	1423038437000	2195	1112	18	0	\N
66235	1397	1423028436000	2195	1112	19	0	\N
66236	1397	1423018435000	2195	1112	20	0	\N
66237	1397	1423008434000	2195	1112	21	0	\N
66238	1397	1422998433000	2195	1112	22	0	\N
66239	1397	1422988432000	2195	1112	23	0	\N
66240	1397	1422978431000	2195	1112	24	0	\N
66241	1397	1422968430000	2195	1112	25	0	\N
66242	1397	1422958429000	2195	1112	26	0	\N
66243	1397	1422948428000	2195	1112	27	0	\N
66244	1397	1422938427000	2195	1112	28	0	\N
66245	1397	1422928426000	2195	1112	29	0	\N
66246	1397	1422918425000	2195	1112	30	0	\N
66247	1397	1422908424000	2195	1112	31	0	\N
66248	1397	1422898423000	2195	1112	32	0	\N
66249	1397	1422888422000	2195	1112	33	0	\N
66250	1397	1422878421000	2195	1112	34	0	\N
66251	1397	1422868420000	2195	1112	35	0	\N
66252	1397	1422858419000	2195	1112	36	0	\N
66253	1397	1422848418000	2195	1112	37	0	\N
66254	1397	1422838417000	2195	1112	38	0	\N
66255	1397	1422828416000	2195	1112	39	0	\N
66256	1397	1422818415000	2195	1112	40	0	\N
66257	1397	1422808414000	2195	1112	41	0	\N
66258	1397	1422798413000	2195	1112	42	0	\N
66259	1397	1422788412000	2195	1112	43	0	\N
66260	1397	1422778411000	2195	1112	44	0	\N
66261	1397	1422768410000	2195	1112	45	0	\N
66262	1397	1422758409000	2195	1112	46	0	\N
66263	1397	1422748408000	2195	1112	47	0	\N
66264	1397	1422738407000	2195	1112	48	0	\N
66265	1397	1422728406000	2195	1112	49	0	\N
66266	1397	1422718405000	2195	1112	50	0	\N
66267	1397	1422708404000	2195	1112	51	0	\N
66268	1397	1422698403000	2195	1112	52	0	\N
66269	1397	1422688402000	2195	1112	53	0	\N
66270	1397	1422678401000	2195	1112	54	0	\N
66271	1397	1422668400000	2195	1112	55	0	\N
66272	1397	1422658399000	2195	1112	56	0	\N
66273	1397	1422648398000	2195	1112	57	0	\N
66274	1397	1422638397000	2195	1112	58	0	\N
66275	1397	1422628396000	2195	1112	59	0	\N
66276	1397	1422618395000	2195	1112	60	0	\N
66277	1397	1422608394000	2195	1112	61	0	\N
66278	1397	1422598393000	2196	1157	0	0	\N
66280	1397	1422598393000	2198	1157	0	0	\N
66284	1397	1422558389000	2200	1159	0	0	\N
66285	1397	1422558389000	2201	1159	0	0	\N
66287	1397	1422558389000	2203	1159	0	0	\N
66288	1397	1422548388000	2204	1160	0	0	\N
66289	1397	1422538387000	2204	1160	1	0	\N
66293	1397	1422518385000	2207	1162	0	0	\N
66294	1397	1422508384000	2207	1162	1	0	\N
66295	1397	1422518385000	2208	1162	0	0	\N
66296	1397	1422508384000	2208	1162	1	0	\N
66301	1397	1422528386000	2211	1161	0	0	\N
66305	1397	1422458379000	2215	1166	0	0	\N
66306	1397	1422468380000	2216	1165	0	0	\N
66307	1397	1422458379000	2216	1165	1	0	\N
66308	1397	1422448378000	2216	1165	2	0	\N
66309	1397	1422448378000	2217	1167	0	0	\N
66312	1397	1422428376000	2220	1169	0	0	\N
66314	1397	1422428376000	2222	1169	0	0	\N
66324	1397	1422338367000	2227	1174	0	0	\N
66327	1397	1422328366000	2230	1175	0	0	\N
66328	1397	1422318365000	2232	1177	0	0	\N
66329	1397	1422308364000	2232	1177	1	0	\N
66332	1590	6800000000	2234	1178	0	0	\N
66333	1397	1422298363000	2234	1178	1	0	\N
66336	1397	1422288362000	2236	1179	0	0	\N
66338	1397	1422288362000	2238	1179	0	0	\N
66343	1714	4308970000000	2241	974	0	0	\N
66344	633	68158930000000	2241	974	1	0	\N
66345	1693	4638237500454	2241	974	2	0	\N
66346	1758	400000000	2242	1182	0	0	\N
66347	1397	1422238357000	2242	1182	1	0	\N
66353	1397	1422228356000	2253	1184	0	0	\N
66354	1397	1422218355000	2253	1184	1	0	\N
66355	1397	1422208354000	2253	1184	2	0	\N
66356	1397	1422228356000	2254	1184	0	0	\N
66357	1397	1422218355000	2254	1184	1	0	\N
66358	1397	1422208354000	2254	1184	2	0	\N
66359	1397	1422228356000	2255	1184	0	0	\N
66360	1397	1422218355000	2255	1184	1	0	\N
66361	1397	1422208354000	2255	1184	2	0	\N
66362	1397	1422228356000	2256	1184	0	0	\N
66363	1397	1422218355000	2256	1184	1	0	\N
66364	1397	1422208354000	2256	1184	2	0	\N
66366	1397	1422198353000	2258	1185	0	0	\N
66282	1397	1422578391000	2199	1158	1	0	1626
66283	1397	1422568390000	2199	1158	2	0	1627
66286	1397	1422558389000	2202	1159	0	0	1628
66290	1397	1422548388000	2205	1160	0	0	1629
66291	1397	1422538387000	2205	1160	1	0	1630
66297	1397	1422518385000	2209	1162	0	0	1632
66298	1397	1422508384000	2209	1162	1	0	1633
66299	1397	1422498383000	2210	1163	0	0	1634
66300	1397	1422488382000	2210	1163	1	0	1635
66302	1397	1422478381000	2212	1164	0	0	1636
66304	1397	1422458379000	2214	1166	0	0	1638
66310	1397	1422448378000	2218	1167	0	0	1639
66311	1397	1422438377000	2219	1168	0	0	1640
66313	1397	1422428376000	2221	1169	0	0	1641
66316	1714	5749000000000	2224	1171	0	0	2
66317	1397	1422408374000	2224	1171	1	0	1643
66318	1397	1422398373000	2224	1171	2	0	1644
66319	1397	1422388372000	2224	1171	3	0	1645
66320	1397	1422378371000	2224	1171	4	0	1646
66322	1397	1422358369000	2225	1172	1	0	1648
66323	1397	1422348368000	2226	1173	0	0	1649
66325	1397	1422338367000	2228	1174	0	0	1650
66326	1397	1422328366000	2229	1175	0	0	1651
66330	1397	1422318365000	2233	1177	0	0	1652
66334	1590	6800000000	2235	1178	0	0	1
66335	1397	1422298363000	2235	1178	1	0	1654
66337	1397	1422288362000	2237	1179	0	0	1655
66339	1397	1422278361000	2239	1180	0	0	1656
66341	1397	1422258359000	2240	1181	0	0	1658
66342	1397	1422248358000	2240	1181	1	0	1659
66348	1758	400000000	2243	1182	0	0	1
66349	1397	1422238357000	2243	1182	1	0	1660
66350	1397	1422228356000	2251	1184	0	0	1661
66352	1397	1422208354000	2251	1184	2	0	1663
66365	1397	1422198353000	2257	1185	0	0	1664
66367	1397	1422188352000	2259	1186	0	0	1665
66368	1397	1422178351000	2259	1186	1	0	1666
66373	1714	4308970000000	2261	974	0	0	\N
66374	395	66034303809323	2261	974	1	0	\N
66379	1397	1422148348000	2263	1188	0	0	\N
66380	1760	990000000	2263	1188	1	0	\N
66381	1397	1422138347000	2263	1188	2	0	\N
66382	1397	1422128346000	2263	1188	3	0	\N
66383	1397	1422118345000	2264	1189	0	0	\N
66384	1397	1422108344000	2264	1189	1	0	\N
66385	1397	1422118345000	2265	1189	0	0	\N
66386	1397	1422108344000	2265	1189	1	0	\N
66389	1397	1422098343000	2267	1190	0	0	\N
66392	1397	1422078341000	2270	1192	0	0	\N
66393	1397	1422078341000	2272	1193	0	0	\N
66394	1397	1422068340000	2272	1193	1	0	\N
66395	1397	1422078341000	2273	1193	0	0	\N
66396	1397	1422068340000	2273	1193	1	0	\N
66399	1397	1422078341000	2275	1193	0	0	\N
66400	1397	1422078341000	2276	1193	0	0	\N
66402	1397	1422058339000	2278	1194	0	0	\N
66403	1397	1422048338000	2279	1195	0	0	\N
66405	1714	4308970000000	2281	1016	0	0	\N
66406	633	68158930000000	2281	1016	1	0	\N
66407	1693	4638237500454	2281	1016	2	0	\N
66408	1397	1424598593000	2281	1016	3	0	\N
66409	1397	1424588592000	2281	1016	4	0	\N
66410	395	66034303809323	2281	1016	5	0	\N
66411	1397	1424578591000	2281	1016	6	0	\N
66412	1397	1424568590000	2281	1016	7	0	\N
66413	1397	1424558589000	2281	1016	8	0	\N
66414	1397	1424548588000	2281	1016	9	0	\N
66417	1397	1422018335000	2283	1197	0	0	\N
66422	1397	1421988332000	2288	1200	0	0	\N
66424	1397	1421968330000	2292	1203	0	0	\N
66425	1397	1421958329000	2292	1203	1	0	\N
66426	1397	1421948328000	2292	1203	2	0	\N
66427	1397	1421968330000	2293	1203	0	0	\N
66428	1397	1421958329000	2293	1203	1	0	\N
66429	1397	1421948328000	2293	1203	2	0	\N
66433	1397	1421938327000	2295	1204	0	0	\N
66434	1397	1421928326000	2295	1204	1	0	\N
66438	1397	1421908324000	2298	1206	0	0	\N
66439	1397	1421908324000	2299	1206	0	0	\N
66441	1714	5749000000000	2301	1082	0	0	\N
66442	633	68878940000000	2301	1082	1	0	\N
66443	1397	1423588492000	2301	1082	2	0	\N
66444	1397	1423578491000	2301	1082	3	0	\N
66445	1397	1423568490000	2301	1082	4	0	\N
66446	1397	1423558489000	2301	1082	5	0	\N
66447	1397	1423548488000	2301	1082	6	0	\N
66448	395	66034303809323	2301	1082	7	0	\N
66449	1397	1423538487000	2301	1082	8	0	\N
66450	1397	1423528486000	2301	1082	9	0	\N
66451	1397	1423518485000	2301	1082	10	0	\N
66452	1397	1423508484000	2301	1082	11	0	\N
66453	1397	1423498483000	2301	1082	12	0	\N
66454	1397	1423488482000	2301	1082	13	0	\N
66455	1397	1423478481000	2301	1082	14	0	\N
66456	1397	1423468480000	2301	1082	15	0	\N
66457	1397	1423458479000	2301	1082	16	0	\N
66458	1397	1423448478000	2301	1082	17	0	\N
66459	1397	1423438477000	2301	1082	18	0	\N
66460	1397	1423428476000	2301	1082	19	0	\N
66461	1397	1423418475000	2301	1082	20	0	\N
66462	1397	1423408474000	2301	1082	21	0	\N
66463	1397	1423398473000	2301	1082	22	0	\N
66464	1397	1423388472000	2301	1082	23	0	\N
66465	1397	1423378471000	2301	1082	24	0	\N
66466	1397	1423368470000	2301	1082	25	0	\N
66467	1397	1423358469000	2301	1082	26	0	\N
66468	1397	1423348468000	2301	1082	27	0	\N
66469	1397	1423338467000	2301	1082	28	0	\N
66470	1397	1423328466000	2301	1082	29	0	\N
66471	1397	1423318465000	2301	1082	30	0	\N
66472	1397	1423308464000	2301	1082	31	0	\N
66473	1397	1423298463000	2301	1082	32	0	\N
66474	1397	1423288462000	2301	1082	33	0	\N
66475	1397	1423278461000	2301	1082	34	0	\N
66476	1397	1423268460000	2301	1082	35	0	\N
66477	1397	1423258459000	2301	1082	36	0	\N
66478	1397	1423248458000	2301	1082	37	0	\N
66479	1397	1423238457000	2301	1082	38	0	\N
66480	1397	1423228456000	2301	1082	39	0	\N
66481	1397	1423218455000	2301	1082	40	0	\N
66482	1397	1423208454000	2301	1082	41	0	\N
66483	1397	1423198453000	2301	1082	42	0	\N
66484	1397	1423188452000	2301	1082	43	0	\N
66485	1397	1423178451000	2301	1082	44	0	\N
66486	1397	1423168450000	2301	1082	45	0	\N
66487	1397	1423158449000	2301	1082	46	0	\N
66488	1397	1423148448000	2301	1082	47	0	\N
66489	1397	1423138447000	2301	1082	48	0	\N
66490	1397	1423128446000	2301	1082	49	0	\N
66491	1397	1423118445000	2301	1082	50	0	\N
66492	1397	1423108444000	2301	1082	51	0	\N
66493	1397	1423098443000	2301	1082	52	0	\N
66494	1397	1423088442000	2301	1082	53	0	\N
66495	1397	1423078441000	2301	1082	54	0	\N
66496	1397	1423068440000	2301	1082	55	0	\N
66497	1397	1423058439000	2301	1082	56	0	\N
66498	1397	1423048438000	2301	1082	57	0	\N
66499	1397	1423038437000	2301	1082	58	0	\N
66500	1397	1423028436000	2301	1082	59	0	\N
66501	1397	1423018435000	2301	1082	60	0	\N
66502	1397	1423008434000	2301	1082	61	0	\N
66503	1397	1422998433000	2301	1082	62	0	\N
66504	1397	1422988432000	2301	1082	63	0	\N
66371	1397	1422158349000	2260	1187	0	0	1668
66372	1760	1000000000	2260	1187	1	0	1
66375	1397	1422148348000	2262	1188	0	0	1669
66376	1760	990000000	2262	1188	1	0	2
66377	1397	1422138347000	2262	1188	2	0	1670
66387	1397	1422118345000	2266	1189	0	0	1672
66388	1397	1422108344000	2266	1189	1	0	1673
66390	1397	1422098343000	2269	1191	0	0	1674
66391	1397	1422088342000	2269	1191	1	0	1675
66397	1397	1422078341000	2274	1193	0	0	1676
66401	1397	1422058339000	2277	1194	0	0	1678
66404	1397	1422048338000	2280	1195	0	0	1679
66415	1397	1422038337000	2282	1196	0	0	1680
66416	1397	1422028336000	2282	1196	1	0	1681
66419	1397	1422008334000	2286	1199	0	0	1683
66420	1397	1421998333000	2286	1199	1	0	1684
66421	1397	1421988332000	2287	1200	0	0	1685
66423	1397	1421978331000	2291	1202	0	0	1686
66430	1397	1421968330000	2294	1203	0	0	1687
66432	1397	1421948328000	2294	1203	2	0	1689
66435	1397	1421938327000	2296	1204	0	0	1690
66436	1397	1421928326000	2296	1204	1	0	1691
66437	1397	1421918325000	2297	1205	0	0	1692
66440	1397	1421908324000	2300	1206	0	0	1693
66505	1397	1422978431000	2301	1082	64	0	\N
66506	1397	1422968430000	2301	1082	65	0	\N
66507	1397	1422958429000	2301	1082	66	0	\N
66508	1397	1422948428000	2301	1082	67	0	\N
66509	1397	1422938427000	2301	1082	68	0	\N
66510	1397	1422928426000	2301	1082	69	0	\N
66511	1397	1422918425000	2301	1082	70	0	\N
66512	1397	1422908424000	2301	1082	71	0	\N
66513	1397	1422898423000	2301	1082	72	0	\N
66514	1397	1422888422000	2301	1082	73	0	\N
66515	1397	1422878421000	2301	1082	74	0	\N
66516	1397	1422868420000	2301	1082	75	0	\N
66517	1397	1422858419000	2301	1082	76	0	\N
66518	1397	1422848418000	2301	1082	77	0	\N
66519	1397	1422838417000	2301	1082	78	0	\N
66520	1397	1422828416000	2301	1082	79	0	\N
66521	1397	1422818415000	2301	1082	80	0	\N
66522	1397	1422808414000	2301	1082	81	0	\N
66523	1397	1422798413000	2301	1082	82	0	\N
66524	1397	1422788412000	2301	1082	83	0	\N
66525	1397	1422778411000	2301	1082	84	0	\N
66526	1397	1422768410000	2301	1082	86	0	\N
66527	1397	1422758409000	2301	1082	87	0	\N
66528	1397	1422748408000	2301	1082	88	0	\N
66529	1397	1422738407000	2301	1082	89	0	\N
66530	1397	1422728406000	2301	1082	90	0	\N
66531	1397	1422718405000	2301	1082	91	0	\N
66532	1397	1422708404000	2301	1082	92	0	\N
66533	1397	1422698403000	2301	1082	93	0	\N
66534	1397	1422688402000	2301	1082	94	0	\N
66535	1397	1422678401000	2301	1082	95	0	\N
66536	1397	1422668400000	2301	1082	96	0	\N
66537	1397	1422658399000	2301	1082	97	0	\N
66538	1397	1422648398000	2301	1082	98	0	\N
66539	1397	1422638397000	2301	1082	99	0	\N
66540	1397	1422628396000	2301	1082	100	0	\N
66541	1397	1422618395000	2301	1082	101	0	\N
66542	1397	1422608394000	2301	1082	102	0	\N
66543	1397	1422598393000	2301	1082	103	0	\N
66544	1397	1422588392000	2301	1082	104	0	\N
66545	1397	1422578391000	2301	1082	105	0	\N
66546	1397	1422568390000	2301	1082	106	0	\N
66547	1397	1422558389000	2301	1082	107	0	\N
66548	1397	1422548388000	2301	1082	108	0	\N
66549	1397	1422538387000	2301	1082	109	0	\N
66550	1397	1422528386000	2301	1082	110	0	\N
66551	1397	1422518385000	2301	1082	111	0	\N
66552	1397	1422508384000	2301	1082	112	0	\N
66553	1397	1422498383000	2301	1082	113	0	\N
66554	1397	1422488382000	2301	1082	114	0	\N
66555	1397	1422478381000	2301	1082	115	0	\N
66556	1397	1422468380000	2301	1082	116	0	\N
66557	1397	1422458379000	2301	1082	117	0	\N
66558	1397	1422448378000	2301	1082	118	0	\N
66559	1397	1422438377000	2301	1082	119	0	\N
66560	1397	1422428376000	2301	1082	120	0	\N
66561	1397	1422418375000	2301	1082	121	0	\N
66562	1397	1422408374000	2301	1082	122	0	\N
66563	1397	1422398373000	2301	1082	123	0	\N
66564	1397	1422388372000	2301	1082	124	0	\N
66565	1397	1422378371000	2301	1082	125	0	\N
66566	1397	1421898323000	2302	1207	0	0	\N
66570	1397	1421878321000	2308	1209	0	0	\N
66571	1397	1421868320000	2311	1210	0	0	\N
66572	1397	1421858319000	2311	1210	1	0	\N
66573	1397	1421848318000	2311	1210	2	0	\N
66577	1397	1421968330000	2313	1203	0	0	\N
66578	1397	1421958329000	2313	1203	1	0	\N
66579	1397	1421948328000	2313	1203	2	0	\N
66580	1397	1421938327000	2313	1203	3	0	\N
66581	1397	1421928326000	2313	1203	4	0	\N
66582	1397	1421918325000	2313	1203	5	0	\N
66583	1397	1421908324000	2313	1203	6	0	\N
66584	1397	1421898323000	2313	1203	7	0	\N
66585	1397	1421888322000	2313	1203	8	0	\N
66586	1397	1421878321000	2313	1203	9	0	\N
66587	1397	1421868320000	2313	1203	10	0	\N
66588	1397	1421858319000	2313	1203	11	0	\N
66589	1397	1421848318000	2313	1203	12	0	\N
66590	1397	1421838317000	2314	1211	0	0	\N
66596	1397	1421788312000	2319	1214	0	0	\N
66598	1397	1421778311000	2321	1215	0	0	\N
66605	1397	1421738307000	2327	1219	0	0	\N
66606	1397	1421728306000	2327	1219	1	0	\N
66607	1397	1421738307000	2328	1219	0	0	\N
66608	1397	1421728306000	2328	1219	1	0	\N
66609	1397	1421738307000	2329	1219	0	0	\N
66610	1397	1421728306000	2329	1219	1	0	\N
66611	1397	1421718305000	2331	1220	0	0	\N
66612	1397	1421708304000	2331	1220	1	0	\N
66613	1397	1421698303000	2331	1220	2	0	\N
66614	1397	1421718305000	2332	1220	0	0	\N
66615	1397	1421708304000	2332	1220	1	0	\N
66616	1397	1421698303000	2332	1220	2	0	\N
66617	1397	1421718305000	2333	1220	0	0	\N
66618	1397	1421708304000	2333	1220	1	0	\N
66619	1397	1421698303000	2333	1220	2	0	\N
66620	1397	1421718305000	2334	1220	0	0	\N
66621	1397	1421708304000	2334	1220	1	0	\N
66622	1397	1421698303000	2334	1220	2	0	\N
66623	1397	1421718305000	2335	1220	0	0	\N
66624	1397	1421708304000	2335	1220	1	0	\N
66625	1397	1421698303000	2335	1220	2	0	\N
66630	1397	1421678301000	2338	1222	0	0	\N
66631	1397	1421678301000	2339	1222	0	0	\N
66635	1397	1421678301000	2341	1223	0	0	\N
66636	1397	1421668300000	2341	1223	1	0	\N
66637	1397	1421658299000	2341	1223	2	0	\N
66640	1397	1421648298000	2343	1224	0	0	\N
66569	1397	1421878321000	2306	1209	0	0	1696
66574	1397	1421868320000	2312	1210	0	0	1697
66575	1397	1421858319000	2312	1210	1	0	1698
66576	1397	1421848318000	2312	1210	2	0	1699
66591	1397	1421838317000	2315	1211	0	0	1700
66593	1397	1421818315000	2316	1212	1	0	1702
66594	1397	1421808314000	2317	1213	0	0	1703
66595	1397	1421798313000	2317	1213	1	0	1704
66597	1397	1421788312000	2320	1214	0	0	1705
66599	1397	1421778311000	2322	1215	0	0	1706
66601	1397	1421758309000	2324	1217	0	0	1708
66602	1397	1421748308000	2325	1218	0	0	1709
66603	1397	1421738307000	2326	1219	0	0	1710
66604	1397	1421728306000	2326	1219	1	0	1711
66627	1397	1421708304000	2336	1221	1	0	1713
66628	1397	1421698303000	2336	1221	2	0	1714
66629	1397	1421688302000	2336	1221	3	0	1715
66632	1397	1421678301000	2340	1223	0	0	1716
66633	1397	1421668300000	2340	1223	1	0	1717
66638	1397	1421648298000	2342	1224	0	0	1719
66639	1397	1421638297000	2342	1224	1	0	1720
66641	1397	1421638297000	2343	1224	1	0	\N
66646	1397	1421598293000	2346	1226	0	0	\N
66651	1397	1421568290000	2350	1229	0	0	\N
66652	1397	1421558289000	2350	1229	1	0	\N
66653	1397	1421568290000	2351	1229	0	0	\N
66654	1397	1421558289000	2351	1229	1	0	\N
66655	1397	1421568290000	2352	1229	0	0	\N
66656	1397	1421558289000	2352	1229	1	0	\N
66658	1397	1421538287000	2355	1231	0	0	\N
66659	1397	1421528286000	2355	1231	1	0	\N
66665	1397	1421498283000	2360	1234	0	0	\N
66666	1397	1421498283000	2361	1234	0	0	\N
66667	1714	5749000000000	2362	1062	0	0	\N
66668	633	68878940000000	2362	1062	1	0	\N
66669	1397	1423928526000	2362	1062	2	0	\N
66670	1397	1423918525000	2362	1062	3	0	\N
66671	1397	1423908524000	2362	1062	4	0	\N
66672	395	66034303809323	2362	1062	5	0	\N
66673	1397	1423898523000	2362	1062	6	0	\N
66674	1397	1423888522000	2362	1062	7	0	\N
66675	1397	1423878521000	2362	1062	8	0	\N
66676	1397	1423868520000	2362	1062	9	0	\N
66677	1397	1423858519000	2362	1062	10	0	\N
66678	1397	1423848518000	2362	1062	11	0	\N
66679	1397	1423838517000	2362	1062	12	0	\N
66680	1397	1423828516000	2362	1062	13	0	\N
66681	1397	1423818515000	2362	1062	14	0	\N
66682	1397	1423808514000	2362	1062	15	0	\N
66683	1397	1423798513000	2362	1062	16	0	\N
66684	1397	1423788512000	2362	1062	17	0	\N
66685	1397	1423778511000	2362	1062	18	0	\N
66686	1397	1423768510000	2362	1062	19	0	\N
66687	1397	1423758509000	2362	1062	20	0	\N
66688	1397	1423748508000	2362	1062	21	0	\N
66689	1397	1423738507000	2362	1062	22	0	\N
66690	1397	1423728506000	2362	1062	23	0	\N
66691	1397	1423718505000	2362	1062	24	0	\N
66692	1397	1423708504000	2362	1062	25	0	\N
66693	1397	1423698503000	2362	1062	26	0	\N
66694	1397	1423688502000	2362	1062	27	0	\N
66695	1397	1423678501000	2362	1062	28	0	\N
66696	1397	1423668500000	2362	1062	29	0	\N
66697	1397	1423658499000	2362	1062	30	0	\N
66698	1397	1423648498000	2362	1062	32	0	\N
66699	1397	1423638497000	2362	1062	33	0	\N
66700	1397	1423628496000	2362	1062	34	0	\N
66701	1397	1423618495000	2362	1062	35	0	\N
66702	1397	1423608494000	2362	1062	36	0	\N
66703	1397	1423598493000	2362	1062	37	0	\N
66704	1397	1423588492000	2362	1062	38	0	\N
66705	1397	1423578491000	2362	1062	39	0	\N
66706	1397	1423568490000	2362	1062	40	0	\N
66707	1397	1423558489000	2362	1062	41	0	\N
66708	1397	1423548488000	2362	1062	42	0	\N
66709	1397	1423538487000	2362	1062	43	0	\N
66710	1397	1423528486000	2362	1062	44	0	\N
66711	1397	1423518485000	2362	1062	45	0	\N
66712	1397	1423508484000	2362	1062	46	0	\N
66713	1397	1423498483000	2362	1062	47	0	\N
66714	1397	1423488482000	2362	1062	48	0	\N
66715	1397	1423478481000	2362	1062	49	0	\N
66716	1397	1423468480000	2362	1062	50	0	\N
66717	1397	1423458479000	2362	1062	51	0	\N
66718	1397	1423448478000	2362	1062	52	0	\N
66719	1397	1423438477000	2362	1062	53	0	\N
66720	1397	1423428476000	2362	1062	54	0	\N
66721	1397	1423418475000	2362	1062	55	0	\N
66722	1397	1423408474000	2362	1062	56	0	\N
66723	1397	1423398473000	2362	1062	57	0	\N
66724	1397	1423388472000	2362	1062	58	0	\N
66725	1397	1423378471000	2362	1062	59	0	\N
66726	1397	1423368470000	2362	1062	60	0	\N
66727	1397	1423358469000	2362	1062	61	0	\N
66728	1397	1423348468000	2362	1062	62	0	\N
66729	1397	1423338467000	2362	1062	63	0	\N
66730	1397	1423328466000	2362	1062	64	0	\N
66731	1397	1423318465000	2362	1062	65	0	\N
66732	1397	1423308464000	2362	1062	66	0	\N
66733	1397	1423298463000	2362	1062	67	0	\N
66734	1397	1423288462000	2362	1062	68	0	\N
66735	1397	1423278461000	2362	1062	69	0	\N
66736	1397	1423268460000	2362	1062	70	0	\N
66737	1397	1423258459000	2362	1062	71	0	\N
66738	1397	1423248458000	2362	1062	72	0	\N
66739	1397	1423238457000	2362	1062	73	0	\N
66740	1397	1423228456000	2362	1062	74	0	\N
66741	1397	1423218455000	2362	1062	75	0	\N
66742	1397	1423208454000	2362	1062	76	0	\N
66743	1397	1423198453000	2362	1062	77	0	\N
66744	1397	1423188452000	2362	1062	78	0	\N
66745	1397	1423178451000	2362	1062	79	0	\N
66746	1397	1423168450000	2362	1062	80	0	\N
66747	1397	1423158449000	2362	1062	81	0	\N
66748	1397	1423148448000	2362	1062	82	0	\N
66749	1397	1423138447000	2362	1062	83	0	\N
66750	1397	1423128446000	2362	1062	84	0	\N
66751	1397	1423118445000	2362	1062	85	0	\N
66752	1397	1423108444000	2362	1062	86	0	\N
66753	1397	1423098443000	2362	1062	87	0	\N
66754	1397	1423088442000	2362	1062	88	0	\N
66755	1397	1423078441000	2362	1062	89	0	\N
66756	1397	1423068440000	2362	1062	90	0	\N
66757	1397	1423058439000	2362	1062	91	0	\N
66758	1397	1423048438000	2362	1062	92	0	\N
66759	1397	1423038437000	2362	1062	93	0	\N
66760	1397	1423028436000	2362	1062	94	0	\N
66761	1397	1423018435000	2362	1062	95	0	\N
66762	1397	1423008434000	2362	1062	96	0	\N
66763	1397	1422998433000	2362	1062	97	0	\N
66764	1397	1422988432000	2362	1062	98	0	\N
66765	1397	1422978431000	2362	1062	99	0	\N
66766	1397	1422968430000	2362	1062	100	0	\N
66767	1397	1422958429000	2362	1062	101	0	\N
66768	1397	1422948428000	2362	1062	102	0	\N
66769	1397	1422938427000	2362	1062	103	0	\N
66770	1397	1422928426000	2362	1062	104	0	\N
66771	1397	1422918425000	2362	1062	105	0	\N
66772	1397	1422908424000	2362	1062	106	0	\N
66773	1397	1422898423000	2362	1062	107	0	\N
66774	1397	1422888422000	2362	1062	108	0	\N
66775	1397	1422878421000	2362	1062	109	0	\N
66776	1397	1422868420000	2362	1062	110	0	\N
66644	1397	1421608294000	2344	1225	2	0	1723
66645	1397	1421598293000	2345	1226	0	0	1724
66647	1397	1421588292000	2347	1227	0	0	1725
66648	1397	1421578291000	2348	1228	0	0	1726
66649	1397	1421568290000	2349	1229	0	0	1727
66657	1397	1421548288000	2353	1230	0	0	1729
66660	1397	1421538287000	2356	1231	0	0	1730
66661	1397	1421528286000	2356	1231	1	0	1731
66662	1397	1421518285000	2357	1232	0	0	1732
66663	1397	1421508284000	2358	1233	0	0	1733
66777	1397	1422858419000	2362	1062	111	0	\N
66778	1397	1422848418000	2362	1062	112	0	\N
66779	1397	1422838417000	2362	1062	113	0	\N
66780	1397	1422828416000	2362	1062	114	0	\N
66781	1397	1422818415000	2362	1062	115	0	\N
66782	1397	1422808414000	2362	1062	116	0	\N
66783	1397	1422798413000	2362	1062	117	0	\N
66784	1397	1422788412000	2362	1062	118	0	\N
66785	1397	1422778411000	2362	1062	119	0	\N
66786	1397	1422768410000	2362	1062	120	0	\N
66787	1397	1422758409000	2362	1062	121	0	\N
66788	1397	1422748408000	2362	1062	122	0	\N
66789	1397	1422738407000	2362	1062	123	0	\N
66790	1397	1422728406000	2362	1062	124	0	\N
66791	1397	1422718405000	2362	1062	125	0	\N
66795	1397	1421488282000	2364	1235	0	0	\N
66796	1397	1421478281000	2364	1235	1	0	\N
66797	1429	0	2364	1235	2	0	\N
66798	1397	1421468280000	2365	1236	0	0	\N
66800	1397	1421458279000	2367	1237	0	0	\N
66802	1397	1421458279000	2369	1237	0	0	\N
66803	1397	1421448278000	2370	1238	0	0	\N
66804	1397	1421438277000	2370	1238	1	0	\N
66810	1397	1421398273000	2375	1242	0	0	\N
66816	1397	1421358269000	2381	1246	0	0	\N
66817	1397	1421358269000	2382	1246	0	0	\N
66818	1397	1421358269000	2383	1246	0	0	\N
66819	1397	1421358269000	2384	1246	0	0	\N
66820	1397	1421348268000	2385	1247	0	0	\N
66821	1397	1421348268000	2386	1247	0	0	\N
66822	1397	1421348268000	2387	1247	0	0	\N
66827	1397	1421318265000	2392	1250	0	0	\N
66828	1397	1421318265000	2393	1250	0	0	\N
66839	1397	1421228256000	2399	1255	0	0	\N
66840	1397	1421228256000	2400	1255	0	0	\N
66841	1397	1421218255000	2401	1256	0	0	\N
66842	1397	1421218255000	2402	1256	0	0	\N
66846	1397	1421198253000	2406	1258	0	0	\N
66850	1397	1421168250000	2409	1260	0	0	\N
66851	1397	1421158249000	2410	1261	0	0	\N
66855	1397	1421128246000	2413	1263	0	0	\N
66860	1397	1421108244000	2417	1265	0	0	\N
66861	1397	1421098243000	2417	1265	1	0	\N
66862	1397	1421108244000	2418	1265	0	0	\N
66863	1397	1421098243000	2418	1265	1	0	\N
66867	1687	4319051000000	2420	1266	0	0	\N
66868	1397	1421088242000	2420	1266	1	0	\N
66869	1397	1421078241000	2420	1266	2	0	\N
66870	1397	1421068240000	2421	1267	0	0	\N
66875	1397	1421028236000	2425	1270	0	0	\N
66878	1397	1421018235000	2428	1271	0	0	\N
66880	1397	1421008234000	2430	1272	0	0	\N
66881	1397	1420998233000	2431	1273	0	0	\N
66883	1397	1420998233000	2433	1273	0	0	\N
66884	1397	1420988232000	2434	1274	0	0	\N
66885	1397	1420978231000	2434	1274	1	0	\N
66888	1397	1420968230000	2436	1275	0	0	\N
66889	1397	1420958229000	2436	1275	1	0	\N
66890	1397	1420948228000	2436	1275	2	0	\N
66891	1397	1420968230000	2437	1275	0	0	\N
66892	1397	1420958229000	2437	1275	1	0	\N
66893	1397	1420948228000	2437	1275	2	0	\N
66897	1397	1420938227000	2439	1276	0	0	\N
66899	1397	1420928226000	2441	1277	0	0	\N
66900	1397	1420928226000	2442	1277	0	0	\N
66904	1397	1420908224000	2446	1279	0	0	\N
66906	1397	1420888222000	2448	1281	0	0	\N
66909	1397	1420878221000	2451	1282	0	0	\N
66912	1397	1420848218000	2453	1284	0	0	\N
66794	1429	0	2363	1235	2	0	1
66799	1397	1421468280000	2366	1236	0	0	1737
66801	1397	1421458279000	2368	1237	0	0	1738
66805	1397	1421448278000	2371	1238	0	0	1739
66806	1397	1421438277000	2371	1238	1	0	1740
66808	1397	1421418275000	2373	1240	0	0	1742
66809	1397	1421408274000	2374	1241	0	0	1743
66811	1397	1421398273000	2376	1242	0	0	1744
66812	1397	1421388272000	2377	1243	0	0	1745
66813	1397	1421378271000	2378	1244	0	0	1746
66815	1397	1421358269000	2380	1246	0	0	1748
66823	1397	1421348268000	2388	1247	0	0	1749
66824	1397	1421338267000	2389	1248	0	0	1750
66825	120	66000900000000	2390	1249	0	0	1
66829	1397	1421318265000	2394	1251	0	0	1752
66830	1397	1421308264000	2394	1251	1	0	1753
66831	1397	1421298263000	2395	1252	0	0	1754
66832	1397	1421288262000	2395	1252	1	0	1755
66833	1397	1421278261000	2395	1252	2	0	1756
66835	1397	1421258259000	2396	1253	0	0	1758
66836	1397	1421248258000	2397	1254	0	0	1759
66837	1397	1421238257000	2397	1254	1	0	1760
66838	1397	1421228256000	2398	1255	0	0	1761
66843	1397	1421218255000	2403	1256	0	0	1762
66845	1397	1421198253000	2405	1258	0	0	1764
66847	1397	1421188252000	2407	1259	0	0	1765
66848	1397	1421178251000	2407	1259	1	0	1766
66849	1397	1421168250000	2408	1260	0	0	1767
66853	1397	1421148248000	2412	1262	0	0	1769
66854	1397	1421138247000	2412	1262	1	0	1770
66856	1397	1421128246000	2414	1263	0	0	1771
66857	1397	1421118245000	2415	1264	0	0	1772
66858	1397	1421108244000	2416	1265	0	0	1773
66864	1687	4319051000000	2419	1266	0	0	1
66865	1397	1421088242000	2419	1266	1	0	1775
66866	1397	1421078241000	2419	1266	2	0	1776
66871	1397	1421068240000	2422	1267	0	0	1777
66872	1397	1421058239000	2423	1268	0	0	1778
66874	1397	1421038237000	2424	1269	0	0	1780
66876	1397	1421028236000	2426	1270	0	0	1781
66877	1397	1421018235000	2427	1271	0	0	1782
66879	1397	1421008234000	2429	1272	0	0	1783
66886	1397	1420988232000	2435	1274	0	0	1785
66887	1397	1420978231000	2435	1274	1	0	1786
66894	1397	1420968230000	2438	1275	0	0	1787
66895	1397	1420958229000	2438	1275	1	0	1788
66896	1397	1420948228000	2438	1275	2	0	1789
66901	1397	1420928226000	2443	1277	0	0	1791
66902	1397	1420918225000	2444	1278	0	0	1792
66903	1397	1420908224000	2445	1279	0	0	1793
66905	1397	1420898223000	2447	1280	0	0	1794
66907	1397	1420888222000	2449	1281	0	0	1795
66910	1397	1420868220000	2452	1283	0	0	1797
66911	1397	1420858219000	2452	1283	1	0	1798
66913	1397	1420848218000	2454	1284	0	0	\N
66921	1397	1420788212000	2459	1287	0	0	\N
66922	1397	1420778211000	2460	1288	0	0	\N
66926	1397	1420768210000	2463	1289	0	0	\N
66927	1397	1420758209000	2463	1289	1	0	\N
66929	1397	1420748208000	2465	1290	0	0	\N
66935	1397	1420698203000	2470	1294	0	0	\N
66936	1397	1420698203000	2471	1294	0	0	\N
66937	1397	1420688202000	2472	1295	0	0	\N
66938	1397	1420688202000	2473	1295	0	0	\N
66946	1397	1420618195000	2477	1298	0	0	\N
66947	1397	1420618195000	2478	1298	0	0	\N
66951	1397	1420588192000	2482	1301	0	0	\N
66952	1397	1420578191000	2482	1301	1	0	\N
66953	1397	1420588192000	2483	1301	0	0	\N
66954	1397	1420578191000	2483	1301	1	0	\N
66955	120	66000900000000	2485	1230	0	0	\N
66956	1687	4319051000000	2485	1230	1	0	\N
66957	1397	1421548288000	2485	1230	2	0	\N
66958	1397	1421538287000	2485	1230	3	0	\N
66959	1397	1421528286000	2485	1230	4	0	\N
66960	1429	0	2485	1230	5	0	\N
66961	1397	1421518285000	2485	1230	6	0	\N
66962	1397	1421508284000	2485	1230	7	0	\N
66963	1397	1421498283000	2485	1230	8	0	\N
66964	1397	1421488282000	2485	1230	9	0	\N
66965	1397	1421478281000	2485	1230	10	0	\N
66966	1397	1421468280000	2485	1230	11	0	\N
66967	1397	1421458279000	2485	1230	12	0	\N
66968	1397	1421448278000	2485	1230	13	0	\N
66969	1397	1421438277000	2485	1230	14	0	\N
66970	1397	1421428276000	2485	1230	15	0	\N
66971	1397	1421418275000	2485	1230	16	0	\N
66972	1397	1421408274000	2485	1230	17	0	\N
66973	1397	1421398273000	2485	1230	18	0	\N
66974	1397	1421388272000	2485	1230	19	0	\N
66975	1397	1421378271000	2485	1230	20	0	\N
66976	1397	1421368270000	2485	1230	21	0	\N
66977	1397	1421358269000	2485	1230	22	0	\N
66978	1397	1421348268000	2485	1230	23	0	\N
66979	1397	1421338267000	2485	1230	24	0	\N
66980	1397	1421328266000	2485	1230	25	0	\N
66981	1397	1421318265000	2485	1230	26	0	\N
66982	1397	1421308264000	2485	1230	27	0	\N
66983	1397	1421298263000	2485	1230	28	0	\N
66984	1397	1421288262000	2485	1230	29	0	\N
66985	1397	1421278261000	2485	1230	30	0	\N
66986	1397	1421268260000	2485	1230	31	0	\N
66987	1397	1421258259000	2485	1230	32	0	\N
66988	1397	1421248258000	2485	1230	33	0	\N
66989	1397	1421238257000	2485	1230	34	0	\N
66990	1397	1421228256000	2485	1230	35	0	\N
66991	1397	1421218255000	2485	1230	36	0	\N
66992	1397	1421208254000	2485	1230	37	0	\N
66993	1397	1421198253000	2485	1230	38	0	\N
66994	1397	1421188252000	2485	1230	39	0	\N
66995	1397	1421178251000	2485	1230	40	0	\N
66996	1397	1421168250000	2485	1230	41	0	\N
66997	1397	1421158249000	2485	1230	42	0	\N
66998	1397	1421148248000	2485	1230	43	0	\N
66999	1397	1421138247000	2485	1230	44	0	\N
67000	1397	1421128246000	2485	1230	45	0	\N
67001	1397	1421118245000	2485	1230	46	0	\N
67002	1397	1421108244000	2485	1230	47	0	\N
67003	1397	1421098243000	2485	1230	48	0	\N
67004	1397	1421088242000	2485	1230	49	0	\N
67005	1397	1421078241000	2485	1230	50	0	\N
67006	1397	1421068240000	2485	1230	51	0	\N
67007	1397	1421058239000	2485	1230	52	0	\N
67008	1397	1421048238000	2485	1230	53	0	\N
67009	1397	1421038237000	2485	1230	54	0	\N
67010	1397	1421028236000	2485	1230	55	0	\N
67011	1397	1421018235000	2485	1230	56	0	\N
67012	1397	1421008234000	2485	1230	57	0	\N
67013	1397	1420998233000	2485	1230	58	0	\N
67014	1397	1420988232000	2485	1230	59	0	\N
67015	1397	1420978231000	2485	1230	60	0	\N
67016	1397	1420968230000	2485	1230	61	0	\N
67017	1397	1420958229000	2485	1230	62	0	\N
67018	1397	1420948228000	2485	1230	63	0	\N
67019	1397	1420938227000	2485	1230	64	0	\N
67020	1397	1420928226000	2485	1230	65	0	\N
67021	1397	1420918225000	2485	1230	66	0	\N
67022	1397	1420908224000	2485	1230	67	0	\N
67023	1397	1420898223000	2485	1230	68	0	\N
67024	1397	1420888222000	2485	1230	69	0	\N
67025	1397	1420878221000	2485	1230	70	0	\N
67026	1397	1420868220000	2485	1230	71	0	\N
67027	1397	1420858219000	2485	1230	72	0	\N
67028	1397	1420848218000	2485	1230	73	0	\N
67029	1397	1420838217000	2485	1230	74	0	\N
67030	1397	1420828216000	2485	1230	75	0	\N
67031	1397	1420818215000	2485	1230	76	0	\N
67032	1397	1420808214000	2485	1230	77	0	\N
67033	1397	1420798213000	2485	1230	78	0	\N
67034	1397	1420788212000	2485	1230	79	0	\N
67035	1397	1420778211000	2485	1230	80	0	\N
67036	1397	1420768210000	2485	1230	81	0	\N
67037	1397	1420758209000	2485	1230	82	0	\N
67038	1397	1420748208000	2485	1230	83	0	\N
67039	1397	1420738207000	2485	1230	84	0	\N
67040	1397	1420728206000	2485	1230	85	0	\N
67041	1397	1420718205000	2485	1230	86	0	\N
67042	1397	1420708204000	2485	1230	87	0	\N
67043	1397	1420698203000	2485	1230	88	0	\N
67044	1397	1420688202000	2485	1230	89	0	\N
67045	1397	1420678201000	2485	1230	90	0	\N
67046	1397	1420668200000	2485	1230	91	0	\N
67047	1397	1420658199000	2485	1230	92	0	\N
67048	1397	1420648198000	2485	1230	93	0	\N
66916	1397	1420828216000	2456	1285	1	0	1801
66917	1397	1420818215000	2456	1285	2	0	1802
66918	1397	1420808214000	2456	1285	3	0	1803
66919	1397	1420798213000	2457	1286	0	0	1804
66920	1397	1420788212000	2458	1287	0	0	1805
66924	1397	1420768210000	2462	1289	0	0	1807
66925	1397	1420758209000	2462	1289	1	0	1808
66928	1397	1420748208000	2464	1290	0	0	1809
66930	1397	1420738207000	2466	1291	0	0	1810
66931	1397	1420728206000	2467	1292	0	0	1811
66933	1397	1420708204000	2468	1293	0	0	1813
66934	1397	1420698203000	2469	1294	0	0	1814
66939	1397	1420688202000	2474	1295	0	0	1815
66940	1397	1420678201000	2475	1296	0	0	1816
66942	1397	1420658199000	2475	1296	2	0	1818
66943	1397	1420648198000	2475	1296	3	0	1819
66944	1397	1420638197000	2475	1296	4	0	1820
66945	1397	1420628196000	2476	1297	0	0	1821
66948	1397	1420618195000	2479	1298	0	0	1822
66950	1397	1420598193000	2480	1299	1	0	1824
67049	1397	1420638197000	2485	1230	94	0	\N
67050	1397	1420628196000	2485	1230	95	0	\N
67051	1397	1420618195000	2485	1230	96	0	\N
67052	1397	1420608194000	2485	1230	97	0	\N
67053	1397	1420598193000	2485	1230	99	0	\N
67054	1397	1420588192000	2485	1230	100	0	\N
67055	1397	1420578191000	2485	1230	101	0	\N
67056	1397	1420568190000	2485	1230	102	0	\N
67061	1397	1420558189000	2488	1303	0	0	\N
67062	1397	1420548188000	2489	1304	0	0	\N
67064	1397	1420538187000	2491	1305	0	0	\N
67066	1397	1420538187000	2493	1305	0	0	\N
67069	1397	1420528186000	2495	1306	0	0	\N
67070	1519	719000000000	2495	1306	1	0	\N
67075	1397	1420478181000	2497	1308	0	0	\N
67082	1687	4319051000000	2501	1266	0	0	\N
67083	1519	719000000000	2501	1266	1	0	\N
67084	1397	1421088242000	2501	1266	2	0	\N
67085	1397	1421078241000	2501	1266	3	0	\N
67086	1397	1421068240000	2501	1266	4	0	\N
67087	1397	1421058239000	2501	1266	5	0	\N
67088	1397	1421048238000	2501	1266	6	0	\N
67089	1397	1421038237000	2501	1266	7	0	\N
67090	1397	1421028236000	2501	1266	8	0	\N
67091	1397	1421018235000	2501	1266	9	0	\N
67092	1397	1421008234000	2501	1266	10	0	\N
67093	1397	1420998233000	2501	1266	11	0	\N
67094	1397	1420988232000	2501	1266	12	0	\N
67095	1397	1420978231000	2501	1266	13	0	\N
67096	1397	1420968230000	2501	1266	14	0	\N
67097	1397	1420958229000	2501	1266	15	0	\N
67098	1397	1420948228000	2501	1266	16	0	\N
67099	1397	1420938227000	2501	1266	17	0	\N
67100	1397	1420928226000	2501	1266	18	0	\N
67101	1397	1420918225000	2501	1266	19	0	\N
67102	1397	1420908224000	2501	1266	20	0	\N
67103	1397	1420898223000	2501	1266	21	0	\N
67104	1397	1420888222000	2501	1266	22	0	\N
67105	1397	1420878221000	2501	1266	23	0	\N
67106	1397	1420868220000	2501	1266	24	0	\N
67107	1397	1420858219000	2501	1266	25	0	\N
67108	1397	1420848218000	2501	1266	26	0	\N
67109	1397	1420838217000	2501	1266	27	0	\N
67110	1397	1420828216000	2501	1266	28	0	\N
67111	1397	1420818215000	2501	1266	29	0	\N
67112	1397	1420808214000	2501	1266	30	0	\N
67113	1397	1420798213000	2501	1266	31	0	\N
67114	1397	1420788212000	2501	1266	32	0	\N
67115	1397	1420778211000	2501	1266	33	0	\N
67116	1397	1420768210000	2501	1266	34	0	\N
67117	1397	1420758209000	2501	1266	35	0	\N
67118	1397	1420748208000	2501	1266	36	0	\N
67119	1397	1420738207000	2501	1266	37	0	\N
67120	1397	1420728206000	2501	1266	38	0	\N
67121	1397	1420718205000	2501	1266	39	0	\N
67122	1397	1420708204000	2501	1266	40	0	\N
67123	1397	1420698203000	2501	1266	41	0	\N
67124	1397	1420688202000	2501	1266	42	0	\N
67125	1397	1420678201000	2501	1266	43	0	\N
67126	1397	1420668200000	2501	1266	44	0	\N
67127	1397	1420658199000	2501	1266	45	0	\N
67128	1397	1420648198000	2501	1266	46	0	\N
67129	1397	1420638197000	2501	1266	47	0	\N
67130	1397	1420628196000	2501	1266	48	0	\N
67131	1397	1420618195000	2501	1266	49	0	\N
67132	1397	1420608194000	2501	1266	50	0	\N
67133	1397	1420598193000	2501	1266	51	0	\N
67134	1397	1420588192000	2501	1266	52	0	\N
67135	1397	1420578191000	2501	1266	53	0	\N
67136	1397	1420568190000	2501	1266	54	0	\N
67137	1397	1420558189000	2501	1266	55	0	\N
67138	1397	1420548188000	2501	1266	56	0	\N
67139	1397	1420538187000	2501	1266	57	0	\N
67140	1397	1420528186000	2501	1266	58	0	\N
67141	1397	1420518185000	2501	1266	59	0	\N
67142	1397	1420508184000	2501	1266	60	0	\N
67143	1397	1420498183000	2501	1266	61	0	\N
67144	1397	1420488182000	2501	1266	62	0	\N
67145	1397	1420478181000	2501	1266	63	0	\N
67146	1397	1420468180000	2501	1266	64	0	\N
67147	1397	1420458179000	2501	1266	65	0	\N
67148	1397	1420448178000	2501	1266	66	0	\N
67149	1397	1420438177000	2501	1266	67	0	\N
67150	1397	1420428176000	2501	1266	68	0	\N
67155	1516	0	2503	1311	0	0	\N
67156	1397	1420418175000	2503	1311	1	0	\N
67157	1397	1420408174000	2503	1311	2	0	\N
67158	1397	1420398173000	2503	1311	3	0	\N
67164	1397	1420338167000	2508	1316	0	0	\N
67165	1397	1420328166000	2508	1316	1	0	\N
67166	1397	1420318165000	2508	1316	2	0	\N
67171	1397	1420298163000	2511	1318	0	0	\N
67172	1397	1420288162000	2511	1318	1	0	\N
67178	1397	1420258159000	2516	1321	0	0	\N
67182	1397	1420248158000	2518	1322	0	0	\N
67183	1397	1420238157000	2518	1322	1	0	\N
67184	1397	1420228156000	2518	1322	2	0	\N
67059	1397	1420568190000	2486	1302	2	0	1827
67060	1397	1420558189000	2487	1303	0	0	1828
67063	1397	1420548188000	2490	1304	0	0	1829
67065	1397	1420538187000	2492	1305	0	0	1830
67067	1397	1420528186000	2494	1306	0	0	1831
67071	1397	1420518185000	2496	1307	0	0	1832
67072	1397	1420508184000	2496	1307	1	0	1833
67073	1397	1420498183000	2496	1307	2	0	1834
67074	1397	1420488182000	2496	1307	3	0	1835
67076	1397	1420478181000	2498	1308	0	0	1836
67078	1397	1420458179000	2500	1310	0	0	1838
67079	1397	1420448178000	2500	1310	1	0	1839
67080	1397	1420438177000	2500	1310	2	0	1840
67081	1397	1420428176000	2500	1310	3	0	1841
67152	1397	1420418175000	2502	1311	1	0	1842
67153	1397	1420408174000	2502	1311	2	0	1843
67154	1397	1420398173000	2502	1311	3	0	1844
67159	1397	1420388172000	2504	1312	0	0	1845
67160	1397	1420378171000	2505	1313	0	0	1846
67162	1397	1420358169000	2507	1315	0	0	1848
67163	1397	1420348168000	2507	1315	1	0	1849
67167	1397	1420338167000	2509	1316	0	0	1850
67168	1397	1420328166000	2509	1316	1	0	1851
67169	1397	1420318165000	2509	1316	2	0	1852
67173	1397	1420298163000	2512	1318	0	0	1854
67174	1397	1420288162000	2512	1318	1	0	1855
67175	1397	1420278161000	2513	1319	0	0	1856
67176	1397	1420268160000	2514	1320	0	0	1857
67179	1397	1420248158000	2517	1322	0	0	1859
67180	1397	1420238157000	2517	1322	1	0	1860
67181	1397	1420228156000	2517	1322	2	0	1861
67185	1397	1420248158000	2519	1322	0	0	\N
67186	1397	1420238157000	2519	1322	1	0	\N
67187	1397	1420228156000	2519	1322	2	0	\N
67192	1397	1420218155000	2521	1323	0	0	\N
67193	1397	1420208154000	2521	1323	1	0	\N
67194	1397	1420198153000	2521	1323	2	0	\N
67195	1693	6077157500454	2521	1323	3	0	\N
67203	1397	1420118145000	2526	1328	0	0	\N
67205	1397	1420118145000	2528	1328	0	0	\N
67209	1516	0	2532	1304	0	0	\N
67210	1519	719000000000	2532	1304	1	0	\N
67211	1693	6077157500454	2532	1304	2	0	\N
67212	1397	1420548188000	2532	1304	3	0	\N
67213	1397	1420538187000	2532	1304	4	0	\N
67214	1397	1420528186000	2532	1304	5	0	\N
67215	1397	1420518185000	2532	1304	6	0	\N
67216	1397	1420508184000	2532	1304	7	0	\N
67217	1397	1420498183000	2532	1304	8	0	\N
67218	1397	1420488182000	2532	1304	9	0	\N
67219	1397	1420478181000	2532	1304	10	0	\N
67220	1397	1420468180000	2532	1304	11	0	\N
67221	1397	1420458179000	2532	1304	12	0	\N
67222	1397	1420448178000	2532	1304	13	0	\N
67223	1397	1420438177000	2532	1304	14	0	\N
67224	1397	1420428176000	2532	1304	15	0	\N
67225	1397	1420418175000	2532	1304	16	0	\N
67226	1397	1420408174000	2532	1304	17	0	\N
67227	1397	1420398173000	2532	1304	18	0	\N
67228	1397	1420388172000	2532	1304	19	0	\N
67229	1397	1420378171000	2532	1304	20	0	\N
67230	1397	1420368170000	2532	1304	21	0	\N
67231	1397	1420358169000	2532	1304	22	0	\N
67232	1397	1420348168000	2532	1304	23	0	\N
67233	1397	1420338167000	2532	1304	24	0	\N
67234	1397	1420328166000	2532	1304	25	0	\N
67235	1397	1420318165000	2532	1304	26	0	\N
67236	1397	1420308164000	2532	1304	27	0	\N
67237	1397	1420298163000	2532	1304	28	0	\N
67238	1397	1420288162000	2532	1304	29	0	\N
67239	1397	1420278161000	2532	1304	30	0	\N
67240	1397	1420268160000	2532	1304	31	0	\N
67241	1397	1420258159000	2532	1304	32	0	\N
67242	1397	1420248158000	2532	1304	33	0	\N
67243	1397	1420238157000	2532	1304	34	0	\N
67244	1397	1420228156000	2532	1304	35	0	\N
67245	1397	1420218155000	2532	1304	36	0	\N
67246	1397	1420208154000	2532	1304	37	0	\N
67247	1397	1420198153000	2532	1304	38	0	\N
67248	1397	1420188152000	2532	1304	39	0	\N
67249	1397	1420178151000	2532	1304	40	0	\N
67250	1397	1420168150000	2532	1304	41	0	\N
67251	1397	1420158149000	2532	1304	42	0	\N
67252	1397	1420148148000	2532	1304	43	0	\N
67253	1397	1420138147000	2532	1304	44	0	\N
67254	1397	1420128146000	2532	1304	45	0	\N
67255	1397	1420118145000	2532	1304	46	0	\N
67256	1397	1420108144000	2532	1304	47	0	\N
67257	1397	1420098143000	2532	1304	48	0	\N
67258	1397	1420088142000	2532	1304	49	0	\N
67259	1397	1420078141000	2532	1304	50	0	\N
67262	1397	1420078141000	2535	1333	0	0	\N
67263	1397	1420068140000	2535	1333	1	0	\N
67265	1706	4316771000000	2537	1335	0	0	\N
67266	1397	1420048138000	2537	1335	1	0	\N
67269	1397	1420038137000	2539	1336	0	0	\N
67271	1397	1420038137000	2541	1336	0	0	\N
67276	1397	1419998133000	2546	1340	0	0	\N
67277	1397	1419988132000	2548	1341	0	0	\N
67278	1397	1419978131000	2548	1341	1	0	\N
67279	1397	1419968130000	2548	1341	2	0	\N
67280	1397	1419958129000	2548	1341	3	0	\N
67289	1706	4316771000000	2553	1277	0	0	\N
67290	1516	0	2553	1277	1	0	\N
67291	1519	719000000000	2553	1277	2	0	\N
67292	1397	1420928226000	2553	1277	3	0	\N
67293	1397	1420918225000	2553	1277	4	0	\N
67294	1397	1420908224000	2553	1277	5	0	\N
67295	1397	1420898223000	2553	1277	6	0	\N
67296	1397	1420888222000	2553	1277	7	0	\N
67297	1397	1420878221000	2553	1277	8	0	\N
67298	1397	1420868220000	2553	1277	9	0	\N
67299	1397	1420858219000	2553	1277	10	0	\N
67300	1693	6077157500454	2553	1277	11	0	\N
67301	1397	1420848218000	2553	1277	12	0	\N
67302	1397	1420838217000	2553	1277	13	0	\N
67303	1397	1420828216000	2553	1277	14	0	\N
67304	1397	1420818215000	2553	1277	15	0	\N
67305	1397	1420808214000	2553	1277	16	0	\N
67306	1397	1420798213000	2553	1277	17	0	\N
67307	1397	1420788212000	2553	1277	18	0	\N
67308	1397	1420778211000	2553	1277	19	0	\N
67309	1397	1420768210000	2553	1277	20	0	\N
67310	1397	1420758209000	2553	1277	21	0	\N
67311	1397	1420748208000	2553	1277	22	0	\N
67312	1397	1420738207000	2553	1277	23	0	\N
67313	1397	1420728206000	2553	1277	24	0	\N
67314	1397	1420718205000	2553	1277	25	0	\N
67315	1397	1420708204000	2553	1277	26	0	\N
67316	1397	1420698203000	2553	1277	27	0	\N
67317	1397	1420688202000	2553	1277	28	0	\N
67318	1397	1420678201000	2553	1277	29	0	\N
67319	1397	1420668200000	2553	1277	30	0	\N
67320	1397	1420658199000	2553	1277	31	0	\N
67190	1397	1420198153000	2520	1323	2	0	1864
67191	1693	6077157500454	2520	1323	3	0	118
67196	1397	1420188152000	2522	1324	0	0	1865
67197	1397	1420178151000	2523	1325	0	0	1866
67198	1397	1420168150000	2524	1326	0	0	1867
67200	1397	1420148148000	2524	1326	2	0	1869
67201	1397	1420138147000	2525	1327	0	0	1870
67202	1397	1420128146000	2525	1327	1	0	1871
67204	1397	1420118145000	2527	1328	0	0	1872
67206	1397	1420108144000	2529	1329	0	0	1873
67208	1397	1420088142000	2531	1331	0	0	1875
67260	1397	1420078141000	2534	1333	0	0	1876
67261	1397	1420068140000	2534	1333	1	0	1877
67264	1397	1420058139000	2536	1334	0	0	1878
67268	1397	1420048138000	2538	1335	1	0	1879
67270	1397	1420038137000	2540	1336	0	0	1880
67272	1397	1420028136000	2542	1337	0	0	1881
67273	1397	1420018135000	2543	1338	0	0	1882
67274	1397	1420008134000	2544	1339	0	0	1883
67281	1397	1419988132000	2549	1341	0	0	1885
67282	1397	1419978131000	2549	1341	1	0	1886
67283	1397	1419968130000	2549	1341	2	0	1887
67284	1397	1419958129000	2549	1341	3	0	1888
67285	1397	1419948128000	2550	1342	0	0	1889
67287	1397	1419928126000	2551	1343	1	0	1891
67288	1397	1419918125000	2552	1344	0	0	1892
67321	1397	1420648198000	2553	1277	32	0	\N
67322	1397	1420638197000	2553	1277	33	0	\N
67323	1397	1420628196000	2553	1277	34	0	\N
67324	1397	1420618195000	2553	1277	35	0	\N
67325	1397	1420608194000	2553	1277	36	0	\N
67326	1397	1420598193000	2553	1277	37	0	\N
67327	1397	1420588192000	2553	1277	38	0	\N
67328	1397	1420578191000	2553	1277	39	0	\N
67329	1397	1420568190000	2553	1277	40	0	\N
67330	1397	1420558189000	2553	1277	41	0	\N
67331	1397	1420548188000	2553	1277	42	0	\N
67332	1397	1420538187000	2553	1277	43	0	\N
67333	1397	1420528186000	2553	1277	44	0	\N
67334	1397	1420518185000	2553	1277	45	0	\N
67335	1397	1420508184000	2553	1277	46	0	\N
67336	1397	1420498183000	2553	1277	47	0	\N
67337	1397	1420488182000	2553	1277	48	0	\N
67338	1397	1420478181000	2553	1277	49	0	\N
67339	1397	1420468180000	2553	1277	50	0	\N
67340	1397	1420458179000	2553	1277	51	0	\N
67341	1397	1420448178000	2553	1277	52	0	\N
67342	1397	1420438177000	2553	1277	53	0	\N
67343	1397	1420428176000	2553	1277	54	0	\N
67344	1397	1420418175000	2553	1277	55	0	\N
67345	1397	1420408174000	2553	1277	56	0	\N
67346	1397	1420398173000	2553	1277	57	0	\N
67347	1397	1420388172000	2553	1277	58	0	\N
67348	1397	1420378171000	2553	1277	59	0	\N
67349	1397	1420368170000	2553	1277	60	0	\N
67350	1397	1420358169000	2553	1277	61	0	\N
67351	1397	1420348168000	2553	1277	62	0	\N
67352	1397	1420338167000	2553	1277	63	0	\N
67353	1397	1420328166000	2553	1277	64	0	\N
67354	1397	1420318165000	2553	1277	65	0	\N
67355	1397	1420308164000	2553	1277	66	0	\N
67356	1397	1420298163000	2553	1277	67	0	\N
67357	1397	1420288162000	2553	1277	69	0	\N
67358	1397	1420278161000	2553	1277	70	0	\N
67359	1397	1420268160000	2553	1277	71	0	\N
67360	1397	1420258159000	2553	1277	72	0	\N
67361	1397	1420248158000	2553	1277	73	0	\N
67362	1397	1420238157000	2553	1277	74	0	\N
67363	1397	1420228156000	2553	1277	75	0	\N
67364	1397	1420218155000	2553	1277	76	0	\N
67365	1397	1420208154000	2553	1277	77	0	\N
67366	1397	1420198153000	2553	1277	78	0	\N
67367	1397	1420188152000	2553	1277	79	0	\N
67368	1397	1420178151000	2553	1277	80	0	\N
67371	1397	1419908124000	2555	1345	0	0	\N
67372	1397	1419898123000	2555	1345	1	0	\N
67378	1397	1419838117000	2560	1350	0	0	\N
67379	1397	1419828116000	2560	1350	1	0	\N
67380	1706	4316771000000	2561	1321	0	0	\N
67381	1397	1420258159000	2561	1321	1	0	\N
67382	1693	6077157500454	2561	1321	2	0	\N
67383	1397	1420248158000	2561	1321	3	0	\N
67384	1397	1420238157000	2561	1321	4	0	\N
67385	1397	1420228156000	2561	1321	5	0	\N
67386	1397	1420218155000	2561	1321	6	0	\N
67387	1397	1420208154000	2561	1321	7	0	\N
67388	1397	1420198153000	2561	1321	8	0	\N
67389	1397	1420188152000	2561	1321	9	0	\N
67390	1397	1420178151000	2561	1321	10	0	\N
67391	1397	1420168150000	2561	1321	11	0	\N
67392	1397	1420158149000	2561	1321	12	0	\N
67393	1397	1420148148000	2561	1321	13	0	\N
67394	1397	1420138147000	2561	1321	14	0	\N
67395	1397	1420128146000	2561	1321	15	0	\N
67396	1397	1420118145000	2561	1321	16	0	\N
67397	1397	1420108144000	2561	1321	17	0	\N
67398	1397	1420098143000	2561	1321	18	0	\N
67399	1397	1420088142000	2561	1321	19	0	\N
67400	1397	1420078141000	2561	1321	20	0	\N
67401	1397	1420068140000	2561	1321	21	0	\N
67402	1397	1420058139000	2561	1321	22	0	\N
67403	1397	1420048138000	2561	1321	23	0	\N
67404	1397	1420038137000	2561	1321	24	0	\N
67405	1397	1420028136000	2561	1321	25	0	\N
67406	1397	1420018135000	2561	1321	26	0	\N
67407	1397	1420008134000	2561	1321	27	0	\N
67408	1397	1419998133000	2561	1321	28	0	\N
67409	1397	1419988132000	2561	1321	29	0	\N
67410	1397	1419978131000	2561	1321	30	0	\N
67411	1397	1419968130000	2561	1321	31	0	\N
67412	1397	1419958129000	2561	1321	32	0	\N
67413	1397	1419948128000	2561	1321	33	0	\N
67414	1397	1419938127000	2561	1321	34	0	\N
67415	1397	1419928126000	2561	1321	35	0	\N
67416	1397	1419918125000	2561	1321	36	0	\N
67417	1397	1419908124000	2561	1321	37	0	\N
67418	1397	1419898123000	2561	1321	38	0	\N
67419	1397	1419888122000	2561	1321	39	0	\N
67420	1397	1419878121000	2561	1321	40	0	\N
67421	1397	1419868120000	2561	1321	42	0	\N
67422	1397	1419858119000	2561	1321	43	0	\N
67423	1397	1419848118000	2561	1321	44	0	\N
67424	1397	1419838117000	2561	1321	45	0	\N
67425	1397	1419828116000	2561	1321	46	0	\N
67426	1397	1419838117000	2562	1350	0	0	\N
67427	1397	1419828116000	2562	1350	1	0	\N
67430	1397	1419838117000	2564	1350	0	0	\N
67431	1397	1419828116000	2564	1350	1	0	\N
67435	1397	1419798113000	2568	1353	0	0	\N
67436	1714	5749000000000	2569	1144	0	0	\N
67437	1706	4316771000000	2569	1144	1	0	\N
67438	633	69598950000000	2569	1144	2	0	\N
67439	1687	4319051000000	2569	1144	3	0	\N
67440	1397	1422808414000	2569	1144	4	0	\N
67441	1519	719000000000	2569	1144	5	0	\N
67442	1397	1422798413000	2569	1144	6	0	\N
67443	1397	1422788412000	2569	1144	7	0	\N
67444	1397	1422778411000	2569	1144	8	0	\N
67445	1397	1422768410000	2569	1144	9	0	\N
67446	1397	1422758409000	2569	1144	10	0	\N
67447	1397	1422748408000	2569	1144	12	0	\N
67448	1397	1419798113000	2570	1353	0	0	\N
67373	1397	1419888122000	2556	1346	0	0	1895
67374	1397	1419878121000	2557	1347	0	0	1896
67375	1397	1419868120000	2557	1347	1	0	1897
67376	1397	1419858119000	2558	1348	0	0	1898
67377	1397	1419848118000	2559	1349	0	0	1899
67429	1397	1419828116000	2563	1350	1	0	1901
67432	1397	1419818115000	2565	1351	0	0	1902
67433	1397	1419808114000	2566	1352	0	0	1903
67434	1397	1419798113000	2567	1353	0	0	1904
67449	1397	1419788112000	2571	1354	0	0	1905
67451	1397	1419768110000	2572	1355	0	0	1907
67452	1397	1419758109000	2572	1355	1	0	1908
67453	1397	1419748108000	2573	1356	0	0	1909
67454	1397	1419738107000	2573	1356	1	0	1910
67456	1397	1419718105000	2574	1357	1	0	1912
67459	1397	1419698103000	2577	1359	0	0	\N
67460	1397	1419688102000	2579	1360	0	0	\N
67461	1397	1419678101000	2579	1360	1	0	\N
67462	1397	1419668100000	2579	1360	2	0	\N
67466	1397	1419658099000	2581	1361	0	0	\N
67468	1397	1419648098000	2583	1362	0	0	\N
67469	1397	1419648098000	2584	1362	0	0	\N
67472	1397	1419638097000	2588	1363	0	0	\N
67475	1397	1419628096000	2590	1364	0	0	\N
67476	1397	1419618095000	2590	1364	1	0	\N
67478	1397	1419598093000	2592	1366	0	0	\N
67480	1397	1419598093000	2594	1366	0	0	\N
67483	1397	1419588092000	2596	1367	0	0	\N
67484	1397	1419578091000	2596	1367	1	0	\N
67485	1397	1419588092000	2597	1367	0	0	\N
67486	1397	1419578091000	2597	1367	1	0	\N
67488	1397	1419558089000	2603	1370	0	0	\N
67489	1397	1419548088000	2603	1370	1	0	\N
67494	1397	1419538087000	2606	1371	0	0	\N
67495	1397	1419528086000	2606	1371	1	0	\N
67496	1397	1419518085000	2607	1372	0	0	\N
67498	1397	1419818115000	2609	1322	0	0	\N
67499	1397	1419808114000	2609	1322	1	0	\N
67500	1397	1419798113000	2609	1322	2	0	\N
67501	1397	1419788112000	2609	1322	3	0	\N
67502	1397	1419778111000	2609	1322	4	0	\N
67503	1397	1419768110000	2609	1322	5	0	\N
67504	1397	1419758109000	2609	1322	6	0	\N
67505	1397	1419748108000	2609	1322	7	0	\N
67506	1397	1419738107000	2609	1322	8	0	\N
67507	1397	1419728106000	2609	1322	9	0	\N
67508	1397	1419718105000	2609	1322	10	0	\N
67509	1397	1419708104000	2609	1322	11	0	\N
67510	1397	1419698103000	2609	1322	12	0	\N
67511	1397	1419688102000	2609	1322	13	0	\N
67512	1397	1419678101000	2609	1322	14	0	\N
67513	1397	1419668100000	2609	1322	15	0	\N
67514	1397	1419658099000	2609	1322	16	0	\N
67515	1397	1419648098000	2609	1322	17	0	\N
67516	1397	1419638097000	2609	1322	18	0	\N
67517	1397	1419628096000	2609	1322	19	0	\N
67518	1397	1419618095000	2609	1322	20	0	\N
67519	1397	1419608094000	2609	1322	21	0	\N
67520	1397	1419598093000	2609	1322	22	0	\N
67521	1397	1419588092000	2609	1322	23	0	\N
67522	1397	1419578091000	2609	1322	24	0	\N
67523	1397	1419568090000	2609	1322	25	0	\N
67524	1397	1419558089000	2609	1322	26	0	\N
67525	1397	1419548088000	2609	1322	27	0	\N
67526	1397	1419538087000	2609	1322	28	0	\N
67527	1397	1419528086000	2609	1322	29	0	\N
67528	1397	1419518085000	2609	1322	30	0	\N
67531	1397	1419508084000	2611	1373	0	0	\N
67532	1397	1419498083000	2611	1373	1	0	\N
67539	1397	1419478081000	2614	1375	0	0	\N
67540	1397	1419468080000	2614	1375	1	0	\N
67541	1397	1419458079000	2614	1375	2	0	\N
67542	1397	1419448078000	2614	1375	3	0	\N
67543	1397	1419438077000	2614	1375	4	0	\N
67546	1397	1419408074000	2618	1378	0	0	\N
67547	1397	1419408074000	2619	1378	0	0	\N
67549	1397	1419408074000	2622	1378	0	0	\N
67555	1397	1419358069000	2626	1381	0	0	\N
67556	1397	1419358069000	2627	1381	0	0	\N
67561	1397	1419328066000	2631	1384	0	0	\N
67562	1397	1419318065000	2631	1384	1	0	\N
67564	1397	1419308064000	2633	1385	0	0	\N
67566	1397	1419298063000	2635	1386	0	0	\N
67568	1397	1419288062000	2637	1387	0	0	\N
67569	1397	1419278061000	2638	1388	0	0	\N
67570	1397	1419278061000	2639	1388	0	0	\N
67572	1397	1419278061000	2641	1388	0	0	\N
67577	1397	1419228056000	2645	1392	0	0	\N
67580	1397	1419218055000	2648	1393	0	0	\N
67582	1397	1419208054000	2650	1394	0	0	\N
67585	1397	1419198053000	2652	1395	0	0	\N
67586	1397	1419188052000	2652	1395	1	0	\N
67587	1397	1419198053000	2653	1395	0	0	\N
67588	1397	1419188052000	2653	1395	1	0	\N
67463	1397	1419688102000	2580	1360	0	0	1915
67464	1397	1419678101000	2580	1360	1	0	1916
67465	1397	1419668100000	2580	1360	2	0	1917
67467	1397	1419658099000	2582	1361	0	0	1918
67470	1397	1419648098000	2585	1362	0	0	1919
67473	1397	1419628096000	2589	1364	0	0	1921
67474	1397	1419618095000	2589	1364	1	0	1922
67477	1397	1419608094000	2591	1365	0	0	1923
67479	1397	1419598093000	2593	1366	0	0	1924
67481	1397	1419588092000	2595	1367	0	0	1925
67487	1397	1419568090000	2598	1368	0	0	1927
67490	1397	1419558089000	2604	1370	0	0	1928
67491	1397	1419548088000	2604	1370	1	0	1929
67492	1397	1419538087000	2605	1371	0	0	1930
67497	1397	1419518085000	2608	1372	0	0	1932
67529	1397	1419508084000	2610	1373	0	0	1933
67530	1397	1419498083000	2610	1373	1	0	1934
67533	1397	1419488082000	2612	1374	0	0	1935
67534	1397	1419478081000	2613	1375	0	0	1936
67536	1397	1419458079000	2613	1375	2	0	1938
67537	1397	1419448078000	2613	1375	3	0	1939
67538	1397	1419438077000	2613	1375	4	0	1940
67544	1397	1419428076000	2615	1376	0	0	1941
67545	1397	1419418075000	2616	1377	0	0	1942
67550	1397	1419398073000	2623	1379	0	0	1944
67551	1397	1419388072000	2623	1379	1	0	1945
67552	1397	1419378071000	2624	1380	0	0	1946
67553	1397	1419368070000	2624	1380	1	0	1947
67557	1397	1419348068000	2628	1382	0	0	1949
67558	1397	1419338067000	2629	1383	0	0	1950
67559	1397	1419328066000	2630	1384	0	0	1951
67560	1397	1419318065000	2630	1384	1	0	1952
67563	1397	1419308064000	2632	1385	0	0	1953
67567	1397	1419288062000	2636	1387	0	0	1955
67571	1397	1419278061000	2640	1388	0	0	1956
67573	1397	1419268060000	2642	1389	0	0	1957
67574	1397	1419258059000	2643	1390	0	0	1958
67575	1397	1419248058000	2643	1390	1	0	1959
67578	1397	1419228056000	2646	1392	0	0	1961
67579	1397	1419218055000	2647	1393	0	0	1962
67581	1397	1419208054000	2649	1394	0	0	1963
67583	1397	1419198053000	2651	1395	0	0	1964
67589	1397	1419178051000	2654	1396	0	0	1966
67590	1397	1419168050000	2654	1396	1	0	1967
67591	1397	1419158049000	2654	1396	2	0	1968
67592	1397	1419148048000	2654	1396	3	0	1969
67594	1706	4316771000000	2655	1267	0	0	\N
67595	1516	0	2655	1267	1	0	\N
67596	1693	6077157500454	2655	1267	2	0	\N
67597	1397	1420418175000	2655	1267	3	0	\N
67598	1397	1420408174000	2655	1267	4	0	\N
67599	1397	1420398173000	2655	1267	5	0	\N
67600	1397	1420388172000	2655	1267	6	0	\N
67601	1397	1420378171000	2655	1267	7	0	\N
67602	1397	1420368170000	2655	1267	8	0	\N
67603	1397	1420358169000	2655	1267	9	0	\N
67604	1397	1420348168000	2655	1267	10	0	\N
67605	1397	1420338167000	2655	1267	11	0	\N
67606	1397	1420328166000	2655	1267	12	0	\N
67607	1397	1420318165000	2655	1267	13	0	\N
67608	1397	1420308164000	2655	1267	14	0	\N
67609	1397	1420298163000	2655	1267	15	0	\N
67610	1397	1420288162000	2655	1267	16	0	\N
67611	1397	1420278161000	2655	1267	17	0	\N
67612	1397	1420268160000	2655	1267	18	0	\N
67613	1397	1420258159000	2655	1267	19	0	\N
67614	1397	1420248158000	2655	1267	20	0	\N
67615	1397	1420238157000	2655	1267	21	0	\N
67616	1397	1420228156000	2655	1267	22	0	\N
67617	1397	1420218155000	2655	1267	23	0	\N
67618	1397	1420208154000	2655	1267	24	0	\N
67619	1397	1420198153000	2655	1267	25	0	\N
67620	1397	1420188152000	2655	1267	26	0	\N
67621	1397	1420178151000	2655	1267	27	0	\N
67622	1397	1420168150000	2655	1267	28	0	\N
67623	1397	1420158149000	2655	1267	29	0	\N
67624	1397	1420148148000	2655	1267	30	0	\N
67625	1397	1420138147000	2655	1267	31	0	\N
67626	1397	1420128146000	2655	1267	32	0	\N
67627	1397	1420118145000	2655	1267	33	0	\N
67628	1397	1420108144000	2655	1267	34	0	\N
67629	1397	1420098143000	2655	1267	35	0	\N
67630	1397	1420088142000	2655	1267	37	0	\N
67631	1397	1420078141000	2655	1267	38	0	\N
67632	1397	1420068140000	2655	1267	39	0	\N
67633	1397	1420058139000	2655	1267	40	0	\N
67634	1397	1420048138000	2655	1267	41	0	\N
67635	1397	1420038137000	2655	1267	42	0	\N
67636	1397	1420028136000	2655	1267	43	0	\N
67637	1397	1420018135000	2655	1267	44	0	\N
67638	1397	1420008134000	2655	1267	45	0	\N
67639	1397	1419998133000	2655	1267	46	0	\N
67640	1397	1419988132000	2655	1267	47	0	\N
67641	1397	1419978131000	2655	1267	48	0	\N
67642	1397	1419968130000	2655	1267	49	0	\N
67643	1397	1419958129000	2655	1267	50	0	\N
67644	1397	1419948128000	2655	1267	51	0	\N
67645	1397	1419938127000	2655	1267	52	0	\N
67646	1397	1419928126000	2655	1267	53	0	\N
67647	1397	1419918125000	2655	1267	54	0	\N
67648	1397	1419908124000	2655	1267	55	0	\N
67649	1397	1419898123000	2655	1267	56	0	\N
67650	1397	1419888122000	2655	1267	57	0	\N
67651	1397	1419878121000	2655	1267	58	0	\N
67652	1397	1419868120000	2655	1267	59	0	\N
67653	1397	1419858119000	2655	1267	60	0	\N
67654	1397	1419848118000	2655	1267	61	0	\N
67655	1397	1419838117000	2655	1267	62	0	\N
67656	1397	1419828116000	2655	1267	63	0	\N
67657	1397	1419818115000	2655	1267	64	0	\N
67658	1397	1419808114000	2655	1267	65	0	\N
67659	1397	1419798113000	2655	1267	66	0	\N
67660	1397	1419788112000	2655	1267	67	0	\N
67661	1397	1419778111000	2655	1267	68	0	\N
67662	1397	1419768110000	2655	1267	69	0	\N
67663	1397	1419758109000	2655	1267	70	0	\N
67664	1397	1419748108000	2655	1267	71	0	\N
67665	1397	1419738107000	2655	1267	72	0	\N
67666	1397	1419728106000	2655	1267	73	0	\N
67667	1397	1419718105000	2655	1267	74	0	\N
67668	1397	1419708104000	2655	1267	75	0	\N
67669	1397	1419698103000	2655	1267	76	0	\N
67670	1397	1419688102000	2655	1267	77	0	\N
67671	1397	1419678101000	2655	1267	78	0	\N
67672	1397	1419668100000	2655	1267	79	0	\N
67673	1397	1419658099000	2655	1267	80	0	\N
67674	1397	1419648098000	2655	1267	81	0	\N
67675	1397	1419638097000	2655	1267	82	0	\N
67676	1397	1419628096000	2655	1267	83	0	\N
67677	1397	1419618095000	2655	1267	84	0	\N
67678	1397	1419608094000	2655	1267	85	0	\N
67679	1397	1419598093000	2655	1267	86	0	\N
67680	1397	1419128046000	2656	1397	0	0	\N
67681	1397	1419128046000	2657	1397	0	0	\N
67684	1397	1419118045000	2660	1398	0	0	\N
67685	1397	1419118045000	2661	1398	0	0	\N
67688	1397	1419108044000	2663	1399	0	0	\N
67689	1397	1419098043000	2663	1399	1	0	\N
67690	1397	1419088042000	2664	1400	0	0	\N
67691	1397	1419088042000	2665	1400	0	0	\N
67696	1397	1419068040000	2669	1402	0	0	\N
67697	1397	1419058039000	2669	1402	1	0	\N
67698	1397	1419068040000	2670	1402	0	0	\N
67699	1397	1419058039000	2670	1402	1	0	\N
67701	1397	1419038037000	2672	1404	0	0	\N
67704	1397	1419018035000	2675	1406	0	0	\N
67705	1397	1419008034000	2675	1406	1	0	\N
67706	1397	1418998033000	2675	1406	2	0	\N
67707	1397	1418988032000	2675	1406	3	0	\N
67708	1397	1419018035000	2676	1406	0	0	\N
67709	1397	1419008034000	2676	1406	1	0	\N
67710	1397	1418998033000	2676	1406	2	0	\N
67711	1397	1418988032000	2676	1406	3	0	\N
67720	1397	1418948028000	2681	1409	0	0	\N
67721	1706	4316771000000	2682	1269	0	0	\N
67722	1516	0	2682	1269	1	0	\N
67723	1397	1421038237000	2682	1269	2	0	\N
67724	1519	719000000000	2682	1269	3	0	\N
67725	1397	1421028236000	2682	1269	4	0	\N
67726	1693	6077157500454	2682	1269	5	0	\N
67727	1397	1421018235000	2682	1269	6	0	\N
67728	1397	1421008234000	2682	1269	7	0	\N
67683	1397	1419118045000	2659	1398	0	0	1972
67686	1397	1419108044000	2662	1399	0	0	1973
67687	1397	1419098043000	2662	1399	1	0	1974
67692	1397	1419088042000	2666	1400	0	0	1975
67693	1397	1419078041000	2667	1401	0	0	1976
67695	1397	1419058039000	2668	1402	1	0	1978
67700	1397	1419048038000	2671	1403	0	0	1979
67702	1397	1419038037000	2673	1404	0	0	1980
67703	1397	1419028036000	2674	1405	0	0	1981
67712	1397	1419018035000	2677	1406	0	0	1982
67714	1397	1418998033000	2677	1406	2	0	1984
67715	1397	1418988032000	2677	1406	3	0	1985
67716	1397	1418978031000	2678	1407	0	0	1986
67717	1397	1418968030000	2678	1407	1	0	1987
67719	1397	1418948028000	2680	1409	0	0	1989
67729	1397	1420998233000	2682	1269	8	0	\N
67730	1397	1420988232000	2682	1269	9	0	\N
67731	1397	1420978231000	2682	1269	10	0	\N
67732	1397	1420968230000	2682	1269	11	0	\N
67733	1397	1420958229000	2682	1269	12	0	\N
67734	1397	1420948228000	2682	1269	13	0	\N
67735	1397	1420938227000	2682	1269	14	0	\N
67736	1397	1420928226000	2682	1269	15	0	\N
67737	1397	1420918225000	2682	1269	16	0	\N
67738	1397	1420908224000	2682	1269	17	0	\N
67739	1397	1420898223000	2682	1269	18	0	\N
67740	1397	1420888222000	2682	1269	19	0	\N
67741	1397	1420878221000	2682	1269	20	0	\N
67742	1397	1420868220000	2682	1269	21	0	\N
67743	1397	1420858219000	2682	1269	22	0	\N
67744	1397	1420848218000	2682	1269	23	0	\N
67745	1397	1420838217000	2682	1269	24	0	\N
67746	1397	1420828216000	2682	1269	25	0	\N
67747	1397	1420818215000	2682	1269	26	0	\N
67748	1397	1420808214000	2682	1269	27	0	\N
67749	1397	1420798213000	2682	1269	28	0	\N
67750	1397	1420788212000	2682	1269	29	0	\N
67751	1397	1420778211000	2682	1269	30	0	\N
67752	1397	1420768210000	2682	1269	31	0	\N
67753	1397	1420758209000	2682	1269	32	0	\N
67754	1397	1420748208000	2682	1269	33	0	\N
67755	1397	1420738207000	2682	1269	34	0	\N
67756	1397	1420728206000	2682	1269	35	0	\N
67757	1397	1420718205000	2682	1269	36	0	\N
67758	1397	1420708204000	2682	1269	37	0	\N
67759	1397	1420698203000	2682	1269	38	0	\N
67760	1397	1420688202000	2682	1269	39	0	\N
67761	1397	1420678201000	2682	1269	40	0	\N
67762	1397	1420668200000	2682	1269	41	0	\N
67763	1397	1420658199000	2682	1269	42	0	\N
67764	1397	1420648198000	2682	1269	43	0	\N
67765	1397	1420638197000	2682	1269	44	0	\N
67766	1397	1420628196000	2682	1269	45	0	\N
67767	1397	1420618195000	2682	1269	46	0	\N
67768	1397	1420608194000	2682	1269	47	0	\N
67769	1397	1420598193000	2682	1269	48	0	\N
67770	1397	1420588192000	2682	1269	49	0	\N
67771	1397	1420578191000	2682	1269	50	0	\N
67772	1397	1420568190000	2682	1269	51	0	\N
67773	1397	1420558189000	2682	1269	52	0	\N
67774	1397	1420548188000	2682	1269	53	0	\N
67775	1397	1420538187000	2682	1269	54	0	\N
67776	1397	1420528186000	2682	1269	55	0	\N
67777	1397	1420518185000	2682	1269	56	0	\N
67778	1397	1420508184000	2682	1269	57	0	\N
67779	1397	1420498183000	2682	1269	58	0	\N
67780	1397	1420488182000	2682	1269	59	0	\N
67781	1397	1420478181000	2682	1269	60	0	\N
67782	1397	1420468180000	2682	1269	61	0	\N
67783	1397	1420458179000	2682	1269	62	0	\N
67784	1397	1420448178000	2682	1269	63	0	\N
67785	1397	1420438177000	2682	1269	64	0	\N
67786	1397	1420428176000	2682	1269	65	0	\N
67787	1397	1420418175000	2682	1269	66	0	\N
67788	1397	1420408174000	2682	1269	67	0	\N
67789	1397	1420398173000	2682	1269	68	0	\N
67790	1397	1420388172000	2682	1269	69	0	\N
67791	1397	1420378171000	2682	1269	70	0	\N
67792	1397	1420368170000	2682	1269	71	0	\N
67793	1397	1420358169000	2682	1269	72	0	\N
67794	1397	1420348168000	2682	1269	73	0	\N
67795	1397	1420338167000	2682	1269	74	0	\N
67796	1397	1420328166000	2682	1269	75	0	\N
67797	1397	1420318165000	2682	1269	76	0	\N
67798	1397	1420308164000	2682	1269	77	0	\N
67799	1397	1420298163000	2682	1269	78	0	\N
67800	1397	1420288162000	2682	1269	79	0	\N
67801	1397	1420278161000	2682	1269	80	0	\N
67802	1397	1420268160000	2682	1269	81	0	\N
67803	1397	1420258159000	2682	1269	82	0	\N
67804	1397	1420248158000	2682	1269	83	0	\N
67805	1397	1420238157000	2682	1269	84	0	\N
67806	1397	1420228156000	2682	1269	85	0	\N
67807	1397	1420218155000	2682	1269	86	0	\N
67808	1397	1420208154000	2682	1269	87	0	\N
67809	1397	1420198153000	2682	1269	88	0	\N
67810	1397	1420188152000	2682	1269	89	0	\N
67811	1397	1420178151000	2682	1269	90	0	\N
67812	1397	1420168150000	2682	1269	91	0	\N
67813	1397	1420158149000	2682	1269	92	0	\N
67814	1397	1420148148000	2682	1269	93	0	\N
67815	1397	1418938027000	2683	1410	0	0	\N
67818	1397	1418928026000	2686	1411	0	0	\N
67819	1397	1418918025000	2687	1412	0	0	\N
67821	1397	1418918025000	2689	1412	0	0	\N
67822	1397	1418918025000	2690	1412	0	0	\N
67824	1397	1418898023000	2692	1414	0	0	\N
67825	1397	1418888022000	2692	1414	1	0	\N
67833	1397	1418838017000	2698	1418	0	0	\N
67834	1397	1418838017000	2699	1418	0	0	\N
67836	1397	1418828016000	2701	1419	0	0	\N
67837	1397	1418828016000	2702	1419	0	0	\N
67838	1706	4316771000000	2703	1289	0	0	\N
67839	1516	0	2703	1289	1	0	\N
67840	1519	719000000000	2703	1289	2	0	\N
67841	1693	6077157500454	2703	1289	3	0	\N
67842	1397	1420768210000	2703	1289	4	0	\N
67843	1397	1420758209000	2703	1289	5	0	\N
67844	1397	1420748208000	2703	1289	6	0	\N
67845	1397	1420738207000	2703	1289	7	0	\N
67846	1397	1420728206000	2703	1289	8	0	\N
67847	1397	1420718205000	2703	1289	9	0	\N
67848	1397	1420708204000	2703	1289	10	0	\N
67849	1397	1420698203000	2703	1289	11	0	\N
67850	1397	1420688202000	2703	1289	12	0	\N
67851	1397	1420678201000	2703	1289	13	0	\N
67852	1397	1420668200000	2703	1289	14	0	\N
67853	1397	1420658199000	2703	1289	15	0	\N
67854	1397	1420648198000	2703	1289	16	0	\N
67855	1397	1420638197000	2703	1289	17	0	\N
67856	1397	1420628196000	2703	1289	18	0	\N
67857	1397	1420618195000	2703	1289	19	0	\N
67858	1397	1420608194000	2703	1289	20	0	\N
67859	1397	1420598193000	2703	1289	21	0	\N
67860	1397	1420588192000	2703	1289	22	0	\N
67861	1397	1420578191000	2703	1289	23	0	\N
67862	1397	1420568190000	2703	1289	24	0	\N
67863	1397	1420558189000	2703	1289	25	0	\N
67864	1397	1420548188000	2703	1289	26	0	\N
67820	1397	1418918025000	2688	1412	0	0	1992
67823	1397	1418908024000	2691	1413	0	0	1993
67826	1397	1418898023000	2693	1414	0	0	1994
67827	1397	1418888022000	2693	1414	1	0	1995
67828	1397	1418878021000	2694	1415	0	0	1996
67830	1397	1418858019000	2695	1416	1	0	1998
67831	1397	1418848018000	2696	1417	0	0	1999
67832	1397	1418838017000	2697	1418	0	0	2000
67835	1397	1418828016000	2700	1419	0	0	2001
67865	1397	1420538187000	2703	1289	27	0	\N
67866	1397	1420528186000	2703	1289	29	0	\N
67867	1397	1420518185000	2703	1289	30	0	\N
67868	1397	1420508184000	2703	1289	31	0	\N
67869	1397	1420498183000	2703	1289	32	0	\N
67870	1397	1420488182000	2703	1289	33	0	\N
67871	1397	1420478181000	2703	1289	34	0	\N
67872	1397	1420468180000	2703	1289	35	0	\N
67873	1397	1420458179000	2703	1289	36	0	\N
67874	1397	1420448178000	2703	1289	37	0	\N
67875	1397	1420438177000	2703	1289	38	0	\N
67876	1397	1420428176000	2703	1289	39	0	\N
67877	1397	1420418175000	2703	1289	40	0	\N
67878	1397	1420408174000	2703	1289	41	0	\N
67879	1397	1420398173000	2703	1289	42	0	\N
67880	1397	1420388172000	2703	1289	43	0	\N
67881	1397	1420378171000	2703	1289	44	0	\N
67882	1397	1420368170000	2703	1289	45	0	\N
67883	1397	1420358169000	2703	1289	46	0	\N
67884	1397	1420348168000	2703	1289	47	0	\N
67885	1397	1420338167000	2703	1289	48	0	\N
67886	1397	1420328166000	2703	1289	49	0	\N
67887	1397	1420318165000	2703	1289	50	0	\N
67888	1397	1420308164000	2703	1289	51	0	\N
67889	1397	1420298163000	2703	1289	52	0	\N
67890	1397	1420288162000	2703	1289	53	0	\N
67891	1397	1420278161000	2703	1289	54	0	\N
67892	1397	1420268160000	2703	1289	55	0	\N
67893	1397	1420258159000	2703	1289	56	0	\N
67894	1397	1420248158000	2703	1289	57	0	\N
67895	1397	1420238157000	2703	1289	58	0	\N
67896	1397	1420228156000	2703	1289	59	0	\N
67897	1397	1420218155000	2703	1289	60	0	\N
67898	1397	1420208154000	2703	1289	61	0	\N
67899	1397	1420198153000	2703	1289	62	0	\N
67900	1397	1420188152000	2703	1289	63	0	\N
67901	1397	1420178151000	2703	1289	64	0	\N
67902	1397	1420168150000	2703	1289	65	0	\N
67903	1397	1420158149000	2703	1289	66	0	\N
67904	1397	1420148148000	2703	1289	67	0	\N
67905	1397	1420138147000	2703	1289	68	0	\N
67906	1397	1420128146000	2703	1289	69	0	\N
67907	1397	1420118145000	2703	1289	70	0	\N
67908	1397	1420108144000	2703	1289	71	0	\N
67909	1397	1420098143000	2703	1289	72	0	\N
67910	1397	1420088142000	2703	1289	73	0	\N
67911	1397	1420078141000	2703	1289	74	0	\N
67912	1397	1420068140000	2703	1289	75	0	\N
67913	1397	1420058139000	2703	1289	76	0	\N
67914	1397	1420048138000	2703	1289	77	0	\N
67915	1397	1420038137000	2703	1289	78	0	\N
67916	1397	1420028136000	2703	1289	79	0	\N
67917	1397	1420018135000	2703	1289	80	0	\N
67918	1397	1420008134000	2703	1289	81	0	\N
67919	1397	1419998133000	2703	1289	82	0	\N
67920	1397	1419988132000	2703	1289	83	0	\N
67921	1397	1419978131000	2703	1289	84	0	\N
67922	1397	1419968130000	2703	1289	85	0	\N
67923	1397	1419958129000	2703	1289	86	0	\N
67924	1397	1419948128000	2703	1289	87	0	\N
67925	1397	1419938127000	2703	1289	88	0	\N
67926	1397	1419928126000	2703	1289	89	0	\N
67927	1397	1419918125000	2703	1289	90	0	\N
67928	1397	1419908124000	2703	1289	91	0	\N
67929	1397	1419898123000	2703	1289	92	0	\N
67930	1397	1419888122000	2703	1289	93	0	\N
67931	1397	1419878121000	2703	1289	94	0	\N
67932	1397	1419868120000	2703	1289	95	0	\N
67933	1397	1419858119000	2703	1289	96	0	\N
67934	1397	1419848118000	2703	1289	97	0	\N
67935	1397	1419838117000	2703	1289	98	0	\N
67936	1397	1419828116000	2703	1289	99	0	\N
67937	1397	1419818115000	2703	1289	100	0	\N
67938	1397	1419808114000	2703	1289	101	0	\N
67939	1397	1419798113000	2703	1289	102	0	\N
67940	1397	1419788112000	2703	1289	103	0	\N
67941	1397	1419778111000	2703	1289	104	0	\N
67942	1397	1419768110000	2703	1289	105	0	\N
67943	1397	1419758109000	2703	1289	106	0	\N
67944	1397	1419748108000	2703	1289	107	0	\N
67945	1397	1419738107000	2703	1289	108	0	\N
67946	1397	1419728106000	2703	1289	109	0	\N
67947	1397	1419718105000	2703	1289	110	0	\N
67948	1397	1419708104000	2703	1289	111	0	\N
67949	1397	1419698103000	2703	1289	112	0	\N
67950	1397	1419688102000	2703	1289	113	0	\N
67951	1397	1419678101000	2703	1289	114	0	\N
67952	1397	1419668100000	2703	1289	115	0	\N
67953	1397	1419658099000	2703	1289	116	0	\N
67954	1397	1419648098000	2703	1289	117	0	\N
67955	1397	1419638097000	2703	1289	118	0	\N
67956	1397	1419628096000	2703	1289	119	0	\N
67957	1397	1419618095000	2703	1289	120	0	\N
67958	1397	1419608094000	2703	1289	121	0	\N
67959	1397	1419598093000	2703	1289	122	0	\N
67960	1397	1419588092000	2703	1289	123	0	\N
67961	1397	1419578091000	2703	1289	124	0	\N
67962	1397	1419568090000	2703	1289	125	0	\N
67966	1397	1418788012000	2706	1422	0	0	\N
67967	1397	1418788012000	2707	1422	0	0	\N
67970	1397	1418768010000	2710	1424	0	0	\N
67972	1397	1418768010000	2712	1424	0	0	\N
67979	1397	1418708004000	2718	1428	0	0	\N
67980	1397	1418698003000	2719	1429	0	0	\N
67981	1397	1418688002000	2719	1429	1	0	\N
67985	1397	1418698003000	2721	1429	0	0	\N
67986	1397	1418688002000	2721	1429	1	0	\N
67988	1397	1418657999000	2723	1431	0	0	\N
67989	1397	1418647998000	2723	1431	1	0	\N
67990	1397	1418657999000	2724	1431	0	0	\N
67991	1397	1418647998000	2724	1431	1	0	\N
67992	1397	1418657999000	2725	1431	0	0	\N
67993	1397	1418647998000	2725	1431	1	0	\N
67994	1397	1418657999000	2726	1431	0	0	\N
67995	1397	1418647998000	2726	1431	1	0	\N
67998	1397	1419558089000	2728	1290	0	0	\N
67999	1397	1419548088000	2728	1290	1	0	\N
68000	1397	1419538087000	2728	1290	2	0	\N
67965	1397	1418798013000	2705	1421	0	0	2004
67968	1397	1418788012000	2708	1422	0	0	2005
67969	1397	1418778011000	2709	1423	0	0	2006
67971	1397	1418768010000	2711	1424	0	0	2007
67973	1397	1418758009000	2714	1425	0	0	2008
67975	1397	1418738007000	2715	1426	1	0	2010
67976	1397	1418728006000	2715	1426	2	0	2011
67977	1397	1418718005000	2716	1427	0	0	2012
67978	1397	1418708004000	2717	1428	0	0	2013
67982	1397	1418698003000	2720	1429	0	0	2014
67984	1397	1418678001000	2720	1429	2	0	2016
67987	1397	1418668000000	2722	1430	0	0	2017
67996	1397	1418657999000	2727	1431	0	0	2018
67997	1397	1418647998000	2727	1431	1	0	2019
68001	1397	1419528086000	2728	1290	3	0	\N
68002	1397	1419518085000	2728	1290	4	0	\N
68003	1397	1419508084000	2728	1290	5	0	\N
68004	1397	1419498083000	2728	1290	6	0	\N
68005	1397	1419488082000	2728	1290	7	0	\N
68006	1397	1419478081000	2728	1290	8	0	\N
68007	1397	1419468080000	2728	1290	9	0	\N
68008	1397	1419458079000	2728	1290	10	0	\N
68009	1397	1419448078000	2728	1290	11	0	\N
68010	1397	1419438077000	2728	1290	12	0	\N
68011	1397	1419428076000	2728	1290	13	0	\N
68012	1397	1419418075000	2728	1290	14	0	\N
68013	1397	1419408074000	2728	1290	15	0	\N
68014	1397	1419398073000	2728	1290	16	0	\N
68015	1397	1419388072000	2728	1290	17	0	\N
68016	1397	1419378071000	2728	1290	18	0	\N
68017	1397	1419368070000	2728	1290	19	0	\N
68018	1397	1419358069000	2728	1290	20	0	\N
68019	1397	1419348068000	2728	1290	21	0	\N
68020	1397	1419338067000	2728	1290	22	0	\N
68021	1397	1419328066000	2728	1290	23	0	\N
68022	1397	1419318065000	2728	1290	24	0	\N
68023	1397	1419308064000	2728	1290	25	0	\N
68024	1397	1419298063000	2728	1290	26	0	\N
68025	1397	1419288062000	2728	1290	27	0	\N
68026	1397	1419278061000	2728	1290	29	0	\N
68027	1397	1419268060000	2728	1290	30	0	\N
68028	1397	1419258059000	2728	1290	31	0	\N
68029	1397	1419248058000	2728	1290	32	0	\N
68030	1397	1419238057000	2728	1290	33	0	\N
68031	1397	1419228056000	2728	1290	34	0	\N
68032	1397	1419218055000	2728	1290	35	0	\N
68033	1397	1419208054000	2728	1290	36	0	\N
68034	1397	1419198053000	2728	1290	37	0	\N
68035	1397	1419188052000	2728	1290	38	0	\N
68036	1397	1419178051000	2728	1290	39	0	\N
68037	1397	1419168050000	2728	1290	40	0	\N
68038	1397	1419158049000	2728	1290	41	0	\N
68039	1397	1419148048000	2728	1290	42	0	\N
68040	1397	1419138047000	2728	1290	43	0	\N
68041	1397	1419128046000	2728	1290	44	0	\N
68042	1397	1419118045000	2728	1290	45	0	\N
68043	1397	1419108044000	2728	1290	46	0	\N
68044	1397	1419098043000	2728	1290	47	0	\N
68045	1397	1419088042000	2728	1290	48	0	\N
68046	1397	1419078041000	2728	1290	49	0	\N
68047	1397	1419068040000	2728	1290	50	0	\N
68048	1397	1419058039000	2728	1290	51	0	\N
68049	1397	1419048038000	2728	1290	52	0	\N
68050	1397	1419038037000	2728	1290	53	0	\N
68051	1397	1419028036000	2728	1290	54	0	\N
68052	1397	1419018035000	2728	1290	55	0	\N
68053	1397	1419008034000	2728	1290	56	0	\N
68054	1397	1418998033000	2728	1290	57	0	\N
68055	1397	1418988032000	2728	1290	58	0	\N
68056	1397	1418978031000	2728	1290	59	0	\N
68057	1397	1418968030000	2728	1290	60	0	\N
68058	1397	1418958029000	2728	1290	61	0	\N
68059	1397	1418948028000	2728	1290	62	0	\N
68060	1397	1418938027000	2728	1290	63	0	\N
68061	1397	1418928026000	2728	1290	64	0	\N
68062	1397	1418918025000	2728	1290	65	0	\N
68063	1397	1418908024000	2728	1290	66	0	\N
68064	1397	1418898023000	2728	1290	67	0	\N
68065	1397	1418888022000	2728	1290	68	0	\N
68066	1397	1418878021000	2728	1290	69	0	\N
68067	1397	1418868020000	2728	1290	70	0	\N
68068	1397	1418858019000	2728	1290	71	0	\N
68069	1397	1418848018000	2728	1290	72	0	\N
68070	1397	1418838017000	2728	1290	73	0	\N
68071	1397	1418828016000	2728	1290	74	0	\N
68072	1397	1418818015000	2728	1290	75	0	\N
68073	1397	1418808014000	2728	1290	76	0	\N
68074	1397	1418798013000	2728	1290	77	0	\N
68075	1397	1418788012000	2728	1290	78	0	\N
68076	1397	1418778011000	2728	1290	79	0	\N
68077	1397	1418768010000	2728	1290	80	0	\N
68078	1397	1418758009000	2728	1290	81	0	\N
68079	1397	1418748008000	2728	1290	82	0	\N
68080	1397	1418738007000	2728	1290	83	0	\N
68081	1397	1418728006000	2728	1290	84	0	\N
68082	1397	1418718005000	2728	1290	85	0	\N
68083	1397	1418708004000	2728	1290	86	0	\N
68084	1397	1418698003000	2728	1290	87	0	\N
68085	1397	1418688002000	2728	1290	88	0	\N
68086	1397	1418678001000	2728	1290	89	0	\N
68087	1397	1418668000000	2728	1290	90	0	\N
68088	1397	1418657999000	2728	1290	91	0	\N
68089	1397	1418647998000	2728	1290	92	0	\N
68094	1397	1418617995000	2732	1434	0	0	\N
68095	1397	1418607994000	2732	1434	1	0	\N
68097	1397	1418587992000	2734	1436	0	0	\N
68098	1397	1418577991000	2734	1436	1	0	\N
68102	1397	1418567990000	2737	1437	0	0	\N
68103	1397	1418567990000	2738	1437	0	0	\N
68104	1397	1418557989000	2739	1438	0	0	\N
68106	1397	1418547988000	2741	1439	0	0	\N
68107	1397	1418537987000	2741	1439	1	0	\N
68110	1397	1419228056000	2743	1392	0	0	\N
68111	1397	1419218055000	2743	1392	1	0	\N
68112	1397	1419208054000	2743	1392	2	0	\N
68113	1397	1419198053000	2743	1392	3	0	\N
68114	1397	1419188052000	2743	1392	4	0	\N
68115	1397	1419178051000	2743	1392	5	0	\N
68116	1397	1419168050000	2743	1392	6	0	\N
68117	1397	1419158049000	2743	1392	7	0	\N
68118	1397	1419148048000	2743	1392	8	0	\N
68119	1397	1419138047000	2743	1392	9	0	\N
68120	1397	1419128046000	2743	1392	10	0	\N
68121	1397	1419118045000	2743	1392	11	0	\N
68122	1397	1419108044000	2743	1392	12	0	\N
68123	1397	1419098043000	2743	1392	13	0	\N
68124	1397	1419088042000	2743	1392	14	0	\N
68125	1397	1419078041000	2743	1392	15	0	\N
68126	1397	1419068040000	2743	1392	16	0	\N
68127	1397	1419058039000	2743	1392	17	0	\N
68128	1397	1419048038000	2743	1392	18	0	\N
68129	1397	1419038037000	2743	1392	19	0	\N
68130	1397	1419028036000	2743	1392	20	0	\N
68131	1397	1419018035000	2743	1392	21	0	\N
68132	1397	1419008034000	2743	1392	22	0	\N
68133	1397	1418998033000	2743	1392	23	0	\N
68134	1397	1418988032000	2743	1392	24	0	\N
68135	1397	1418978031000	2743	1392	25	0	\N
68136	1397	1418968030000	2743	1392	26	0	\N
68092	1397	1418617995000	2731	1434	0	0	2022
68093	1397	1418607994000	2731	1434	1	0	2023
68096	1397	1418597993000	2733	1435	0	0	2024
68099	1397	1418587992000	2735	1436	0	0	2025
68100	1397	1418577991000	2735	1436	1	0	2026
68105	1397	1418557989000	2740	1438	0	0	2028
68108	1397	1418547988000	2742	1439	0	0	2029
68109	1397	1418537987000	2742	1439	1	0	2030
68137	1397	1418958029000	2743	1392	27	0	\N
68138	1397	1418948028000	2743	1392	28	0	\N
68139	1397	1418938027000	2743	1392	29	0	\N
68140	1397	1418928026000	2743	1392	30	0	\N
68141	1397	1418918025000	2743	1392	31	0	\N
68142	1397	1418908024000	2743	1392	32	0	\N
68143	1397	1418898023000	2743	1392	33	0	\N
68144	1397	1418888022000	2743	1392	34	0	\N
68145	1397	1418878021000	2743	1392	35	0	\N
68146	1397	1418868020000	2743	1392	36	0	\N
68147	1397	1418858019000	2743	1392	37	0	\N
68148	1397	1418848018000	2743	1392	38	0	\N
68149	1397	1418838017000	2743	1392	39	0	\N
68150	1397	1418828016000	2743	1392	40	0	\N
68151	1397	1418818015000	2743	1392	41	0	\N
68152	1397	1418808014000	2743	1392	42	0	\N
68153	1397	1418798013000	2743	1392	43	0	\N
68154	1397	1418788012000	2743	1392	44	0	\N
68155	1397	1418778011000	2743	1392	45	0	\N
68156	1397	1418768010000	2743	1392	46	0	\N
68157	1397	1418758009000	2743	1392	47	0	\N
68158	1397	1418748008000	2743	1392	49	0	\N
68159	1397	1418738007000	2743	1392	50	0	\N
68160	1397	1418728006000	2743	1392	51	0	\N
68161	1397	1418718005000	2743	1392	52	0	\N
68162	1397	1418708004000	2743	1392	53	0	\N
68163	1397	1418698003000	2743	1392	54	0	\N
68164	1397	1418688002000	2743	1392	55	0	\N
68165	1397	1418678001000	2743	1392	56	0	\N
68166	1397	1418668000000	2743	1392	57	0	\N
68167	1397	1418657999000	2743	1392	58	0	\N
68168	1397	1418647998000	2743	1392	59	0	\N
68169	1397	1418637997000	2743	1392	60	0	\N
68170	1397	1418627996000	2743	1392	61	0	\N
68171	1397	1418617995000	2743	1392	62	0	\N
68172	1397	1418607994000	2743	1392	63	0	\N
68173	1397	1418597993000	2743	1392	64	0	\N
68174	1397	1418587992000	2743	1392	65	0	\N
68175	1397	1418577991000	2743	1392	66	0	\N
68176	1397	1418567990000	2743	1392	67	0	\N
68177	1397	1418557989000	2743	1392	68	0	\N
68178	1397	1418547988000	2743	1392	69	0	\N
68179	1397	1418537987000	2743	1392	70	0	\N
68180	1397	1418527986000	2744	1440	0	0	\N
68181	1397	1418527986000	2745	1440	0	0	\N
68182	1397	1418527986000	2746	1440	0	0	\N
68184	1397	1418517985000	2749	1441	0	0	\N
68185	1397	1418517985000	2750	1441	0	0	\N
68186	1397	1418517985000	2753	1441	0	0	\N
68187	1397	1418517985000	2755	1442	0	0	\N
68188	1397	1418507984000	2755	1442	1	0	\N
68189	1397	1418517985000	2756	1442	0	0	\N
68190	1397	1418517985000	2757	1442	0	0	\N
68191	1397	1418507984000	2757	1442	1	0	\N
68194	1397	1418517985000	2759	1442	0	0	\N
68195	1397	1418507984000	2759	1442	1	0	\N
68196	1706	4316771000000	2760	1231	0	0	\N
68197	1516	0	2760	1231	1	0	\N
68198	1519	719000000000	2760	1231	2	0	\N
68199	1693	5357147500454	2760	1231	3	0	\N
68200	1397	1420558189000	2760	1231	4	0	\N
68201	1397	1420548188000	2760	1231	5	0	\N
68202	1397	1420538187000	2760	1231	6	0	\N
68203	1397	1420528186000	2760	1231	7	0	\N
68204	1397	1420518185000	2760	1231	8	0	\N
68205	1397	1420508184000	2760	1231	9	0	\N
68206	1397	1420498183000	2760	1231	10	0	\N
68207	1397	1420488182000	2760	1231	11	0	\N
68208	1397	1420478181000	2760	1231	12	0	\N
68209	1397	1420468180000	2760	1231	13	0	\N
68210	1397	1420458179000	2760	1231	14	0	\N
68211	1397	1420448178000	2760	1231	15	0	\N
68212	1397	1420438177000	2760	1231	16	0	\N
68213	1397	1420428176000	2760	1231	17	0	\N
68214	1397	1420418175000	2760	1231	18	0	\N
68215	1397	1420408174000	2760	1231	19	0	\N
68216	1397	1420398173000	2760	1231	20	0	\N
68217	1397	1420388172000	2760	1231	21	0	\N
68218	1397	1420378171000	2760	1231	22	0	\N
68219	1397	1420368170000	2760	1231	23	0	\N
68220	1397	1420358169000	2760	1231	24	0	\N
68221	1397	1420348168000	2760	1231	25	0	\N
68222	1397	1420338167000	2760	1231	26	0	\N
68223	1397	1420328166000	2760	1231	27	0	\N
68224	1397	1420318165000	2760	1231	28	0	\N
68225	1397	1420308164000	2760	1231	29	0	\N
68226	1397	1420298163000	2760	1231	30	0	\N
68227	1397	1420288162000	2760	1231	31	0	\N
68228	1397	1420278161000	2760	1231	32	0	\N
68229	1397	1420268160000	2760	1231	33	0	\N
68230	1397	1420258159000	2760	1231	34	0	\N
68231	1397	1420248158000	2760	1231	35	0	\N
68232	1397	1420238157000	2760	1231	36	0	\N
68233	1397	1420228156000	2760	1231	37	0	\N
68234	1397	1420218155000	2760	1231	38	0	\N
68235	1397	1420208154000	2760	1231	39	0	\N
68236	1397	1420198153000	2760	1231	40	0	\N
68237	1397	1420188152000	2760	1231	41	0	\N
68238	1397	1420178151000	2760	1231	42	0	\N
68239	1397	1420168150000	2760	1231	43	0	\N
68240	1397	1420158149000	2760	1231	44	0	\N
68241	1397	1420148148000	2760	1231	45	0	\N
68242	1397	1420138147000	2760	1231	46	0	\N
68243	1397	1420128146000	2760	1231	47	0	\N
68244	1397	1420118145000	2760	1231	48	0	\N
68245	1397	1420108144000	2760	1231	49	0	\N
68246	1397	1420098143000	2760	1231	50	0	\N
68247	1397	1420088142000	2760	1231	51	0	\N
68248	1397	1420078141000	2760	1231	52	0	\N
68249	1397	1420068140000	2760	1231	53	0	\N
68250	1397	1420058139000	2760	1231	54	0	\N
68251	1397	1420048138000	2760	1231	55	0	\N
68252	1397	1420038137000	2760	1231	56	0	\N
68253	1397	1420028136000	2760	1231	57	0	\N
68254	1397	1420018135000	2760	1231	58	0	\N
68255	1397	1420008134000	2760	1231	59	0	\N
68256	1397	1419998133000	2760	1231	60	0	\N
68257	1397	1419988132000	2760	1231	61	0	\N
68258	1397	1419978131000	2760	1231	62	0	\N
68259	1397	1419968130000	2760	1231	63	0	\N
68260	1397	1419958129000	2760	1231	64	0	\N
68261	1397	1419948128000	2760	1231	65	0	\N
68262	1397	1419938127000	2760	1231	66	0	\N
68263	1397	1419928126000	2760	1231	67	0	\N
68264	1397	1419918125000	2760	1231	68	0	\N
68265	1397	1419908124000	2760	1231	69	0	\N
68266	1397	1419898123000	2760	1231	70	0	\N
68267	1397	1419888122000	2760	1231	71	0	\N
68268	1397	1419878121000	2760	1231	72	0	\N
68269	1397	1419868120000	2760	1231	73	0	\N
68270	1397	1419858119000	2760	1231	74	0	\N
68271	1397	1419848118000	2760	1231	75	0	\N
68272	1397	1419838117000	2760	1231	76	0	\N
68193	1397	1418507984000	2758	1442	1	0	2033
68273	1397	1419828116000	2760	1231	77	0	\N
68274	1397	1419818115000	2760	1231	78	0	\N
68275	1397	1419808114000	2760	1231	79	0	\N
68276	1397	1419798113000	2760	1231	80	0	\N
68277	1397	1419788112000	2760	1231	81	0	\N
68278	1397	1419778111000	2760	1231	82	0	\N
68279	1397	1419768110000	2760	1231	83	0	\N
68280	1397	1419758109000	2760	1231	84	0	\N
68281	1397	1419748108000	2760	1231	85	0	\N
68282	1397	1419738107000	2760	1231	86	0	\N
68283	1397	1419728106000	2760	1231	87	0	\N
68284	1397	1419718105000	2760	1231	88	0	\N
68285	1397	1419708104000	2760	1231	89	0	\N
68286	1397	1419698103000	2760	1231	90	0	\N
68287	1397	1419688102000	2760	1231	91	0	\N
68288	1397	1419678101000	2760	1231	92	0	\N
68289	1397	1419668100000	2760	1231	93	0	\N
68290	1397	1419658099000	2760	1231	94	0	\N
68291	1397	1419648098000	2760	1231	95	0	\N
68292	1397	1419638097000	2760	1231	96	0	\N
68293	1397	1419628096000	2760	1231	97	0	\N
68294	1397	1419618095000	2760	1231	98	0	\N
68295	1397	1419608094000	2760	1231	99	0	\N
68296	1397	1419598093000	2760	1231	100	0	\N
68297	1397	1419588092000	2760	1231	101	0	\N
68298	1397	1419578091000	2760	1231	102	0	\N
68299	1397	1419568090000	2760	1231	103	0	\N
68300	1397	1419558089000	2760	1231	104	0	\N
68301	1397	1419548088000	2760	1231	105	0	\N
68302	1397	1419538087000	2760	1231	106	0	\N
68303	1397	1419528086000	2760	1231	107	0	\N
68304	1397	1419518085000	2760	1231	108	0	\N
68305	1397	1419508084000	2760	1231	109	0	\N
68306	1397	1419498083000	2760	1231	110	0	\N
68307	1397	1419488082000	2760	1231	111	0	\N
68308	1397	1419478081000	2760	1231	112	0	\N
68309	1397	1419468080000	2760	1231	113	0	\N
68310	1397	1419458079000	2760	1231	114	0	\N
68311	1397	1419448078000	2760	1231	115	0	\N
68312	1397	1419438077000	2760	1231	116	0	\N
68313	1397	1419428076000	2760	1231	122	0	\N
68314	1397	1419418075000	2760	1231	123	0	\N
68315	1397	1419408074000	2760	1231	124	0	\N
68316	1397	1419398073000	2760	1231	125	0	\N
68322	1397	1418457979000	2763	1444	0	0	\N
68323	1397	1418447978000	2764	1445	0	0	\N
68335	1397	1418337967000	2775	1453	0	0	\N
68336	1397	1418327966000	2775	1453	1	0	\N
68339	1397	1418337967000	2777	1453	0	0	\N
68340	1397	1418327966000	2777	1453	1	0	\N
68341	1397	1418337967000	2778	1453	0	0	\N
68342	1397	1418327966000	2778	1453	1	0	\N
68345	1397	1418317965000	2780	1454	0	0	\N
68346	1397	1418307964000	2780	1454	1	0	\N
68351	1397	1418267960000	2786	1458	0	0	\N
68354	1706	4316771000000	2788	1333	0	0	\N
68355	1397	1420078141000	2788	1333	1	0	\N
68356	1397	1420068140000	2788	1333	2	0	\N
68357	1474	5758070000000	2788	1333	3	0	\N
68358	1397	1420058139000	2788	1333	4	0	\N
68359	1397	1420048138000	2788	1333	5	0	\N
68360	1397	1420038137000	2788	1333	6	0	\N
68361	1397	1420028136000	2788	1333	7	0	\N
68362	1397	1420018135000	2788	1333	8	0	\N
68363	1397	1420008134000	2788	1333	9	0	\N
68364	1397	1419998133000	2788	1333	10	0	\N
68365	1397	1419988132000	2788	1333	11	0	\N
68366	1397	1419978131000	2788	1333	12	0	\N
68367	1397	1419968130000	2788	1333	13	0	\N
68368	1397	1419958129000	2788	1333	14	0	\N
68369	1397	1419948128000	2788	1333	15	0	\N
68370	1397	1419938127000	2788	1333	16	0	\N
68371	1397	1419928126000	2788	1333	17	0	\N
68372	1397	1419918125000	2788	1333	18	0	\N
68373	1397	1419908124000	2788	1333	19	0	\N
68374	1397	1419898123000	2788	1333	20	0	\N
68375	1397	1419888122000	2788	1333	21	0	\N
68376	1397	1419878121000	2788	1333	22	0	\N
68377	1397	1419868120000	2788	1333	23	0	\N
68378	1397	1419858119000	2788	1333	24	0	\N
68379	1397	1419848118000	2788	1333	25	0	\N
68380	1397	1419838117000	2788	1333	26	0	\N
68381	1397	1419828116000	2788	1333	27	0	\N
68382	1397	1419818115000	2788	1333	28	0	\N
68383	1397	1419808114000	2788	1333	29	0	\N
68384	1397	1419798113000	2788	1333	30	0	\N
68385	1397	1419788112000	2788	1333	31	0	\N
68386	1397	1419778111000	2788	1333	32	0	\N
68387	1397	1419768110000	2788	1333	33	0	\N
68388	1397	1419758109000	2788	1333	34	0	\N
68389	1397	1419748108000	2788	1333	35	0	\N
68390	1397	1419738107000	2788	1333	36	0	\N
68391	1397	1419728106000	2788	1333	37	0	\N
68392	1397	1419718105000	2788	1333	38	0	\N
68393	1397	1419708104000	2788	1333	39	0	\N
68394	1397	1419698103000	2788	1333	40	0	\N
68395	1397	1419688102000	2788	1333	41	0	\N
68396	1397	1419678101000	2788	1333	42	0	\N
68397	1397	1419668100000	2788	1333	43	0	\N
68398	1397	1419658099000	2788	1333	44	0	\N
68399	1397	1419648098000	2788	1333	45	0	\N
68400	1397	1419638097000	2788	1333	46	0	\N
68401	1397	1419628096000	2788	1333	47	0	\N
68402	1397	1419618095000	2788	1333	48	0	\N
68403	1397	1419608094000	2788	1333	49	0	\N
68404	1397	1419598093000	2788	1333	50	0	\N
68405	1397	1419588092000	2788	1333	51	0	\N
68406	1397	1419578091000	2788	1333	52	0	\N
68407	1397	1419568090000	2788	1333	53	0	\N
68408	1397	1419558089000	2788	1333	54	0	\N
68319	1397	1418477981000	2761	1443	3	0	2036
68320	1397	1418467980000	2761	1443	4	0	2037
68321	1397	1418457979000	2762	1444	0	0	2038
68324	1397	1418447978000	2765	1445	0	0	2039
68325	1397	1418437977000	2767	1446	0	0	2040
68327	1397	1418417975000	2767	1446	2	0	2042
68328	1397	1418407974000	2767	1446	3	0	2043
68329	1397	1418397973000	2769	1447	0	0	2044
68330	1397	1418387972000	2770	1448	0	0	2045
68331	1397	1418377971000	2771	1449	0	0	2046
68333	1397	1418357969000	2773	1451	0	0	2048
68334	1397	1418347968000	2774	1452	0	0	2049
68337	1397	1418337967000	2776	1453	0	0	2050
68338	1397	1418327966000	2776	1453	1	0	2051
68344	1397	1418307964000	2779	1454	1	0	2053
68347	1397	1418297963000	2781	1455	0	0	2054
68348	1397	1418287962000	2783	1456	0	0	2055
68349	1397	1418277961000	2784	1457	0	0	2056
68350	1397	1418267960000	2785	1458	0	0	2057
68353	1474	6478080000000	2787	1459	1	0	1
68409	1397	1419548088000	2788	1333	55	0	\N
68410	1397	1419538087000	2788	1333	56	0	\N
68411	1397	1419528086000	2788	1333	57	0	\N
68412	1397	1419518085000	2788	1333	58	0	\N
68413	1397	1419508084000	2788	1333	59	0	\N
68414	1397	1419498083000	2788	1333	60	0	\N
68415	1397	1419488082000	2788	1333	61	0	\N
68416	1397	1419478081000	2788	1333	62	0	\N
68417	1397	1419468080000	2788	1333	63	0	\N
68418	1397	1419458079000	2788	1333	64	0	\N
68419	1397	1419448078000	2788	1333	65	0	\N
68420	1397	1419438077000	2788	1333	66	0	\N
68421	1397	1419428076000	2788	1333	67	0	\N
68422	1397	1419418075000	2788	1333	68	0	\N
68423	1397	1419408074000	2788	1333	69	0	\N
68424	1397	1419398073000	2788	1333	70	0	\N
68425	1397	1419388072000	2788	1333	71	0	\N
68426	1397	1419378071000	2788	1333	72	0	\N
68427	1397	1419368070000	2788	1333	73	0	\N
68428	1397	1419358069000	2788	1333	74	0	\N
68429	1397	1419348068000	2788	1333	75	0	\N
68430	1397	1419338067000	2788	1333	76	0	\N
68431	1397	1419328066000	2788	1333	77	0	\N
68432	1397	1419318065000	2788	1333	78	0	\N
68433	1397	1419308064000	2788	1333	79	0	\N
68434	1397	1419298063000	2788	1333	80	0	\N
68435	1397	1419288062000	2788	1333	81	0	\N
68436	1397	1419278061000	2788	1333	82	0	\N
68437	1397	1419268060000	2788	1333	83	0	\N
68438	1397	1419258059000	2788	1333	84	0	\N
68439	1397	1419248058000	2788	1333	85	0	\N
68440	1397	1419238057000	2788	1333	86	0	\N
68441	1397	1419228056000	2788	1333	87	0	\N
68442	1397	1419218055000	2788	1333	88	0	\N
68443	1397	1419208054000	2788	1333	89	0	\N
68444	1397	1419198053000	2788	1333	90	0	\N
68445	1397	1419188052000	2788	1333	91	0	\N
68446	1397	1419178051000	2788	1333	92	0	\N
68447	1397	1419168050000	2788	1333	93	0	\N
68448	1397	1419158049000	2788	1333	94	0	\N
68449	1397	1419148048000	2788	1333	95	0	\N
68450	1397	1419138047000	2788	1333	96	0	\N
68451	1397	1419128046000	2788	1333	97	0	\N
68452	1397	1419118045000	2788	1333	98	0	\N
68453	1397	1419108044000	2788	1333	99	0	\N
68454	1397	1419098043000	2788	1333	100	0	\N
68455	1397	1419088042000	2788	1333	101	0	\N
68456	1397	1419078041000	2788	1333	102	0	\N
68457	1397	1419068040000	2788	1333	103	0	\N
68458	1397	1419058039000	2788	1333	104	0	\N
68459	1397	1419048038000	2788	1333	105	0	\N
68460	1397	1419038037000	2788	1333	106	0	\N
68461	1397	1419028036000	2788	1333	107	0	\N
68462	1397	1419018035000	2788	1333	108	0	\N
68463	1397	1419008034000	2788	1333	109	0	\N
68464	1397	1418998033000	2788	1333	110	0	\N
68465	1397	1418988032000	2788	1333	111	0	\N
68466	1397	1418978031000	2788	1333	112	0	\N
68467	1397	1418968030000	2788	1333	113	0	\N
68468	1397	1418958029000	2788	1333	114	0	\N
68469	1397	1418948028000	2788	1333	115	0	\N
68470	1397	1418938027000	2788	1333	116	0	\N
68471	1397	1418928026000	2788	1333	117	0	\N
68472	1397	1418918025000	2788	1333	118	0	\N
68473	1397	1418908024000	2788	1333	119	0	\N
68474	1397	1418898023000	2788	1333	120	0	\N
68475	1397	1418888022000	2788	1333	121	0	\N
68476	1397	1418878021000	2788	1333	122	0	\N
68477	1397	1418868020000	2788	1333	123	0	\N
68478	1397	1418858019000	2788	1333	124	0	\N
68479	1397	1418848018000	2788	1333	125	0	\N
68481	1397	1418247958000	2790	1460	0	0	\N
68483	1397	1418227956000	2792	1462	0	0	\N
68485	1397	1418227956000	2794	1462	0	0	\N
68486	1397	1418217955000	2795	1463	0	0	\N
68487	1397	1418217955000	2796	1463	0	0	\N
68489	1397	1418207954000	2798	1464	0	0	\N
68490	1397	1418197953000	2798	1464	1	0	\N
68491	1397	1418187952000	2798	1464	2	0	\N
68492	1397	1418177951000	2798	1464	3	0	\N
68497	1397	1418207954000	2800	1464	0	0	\N
68498	1397	1418197953000	2800	1464	1	0	\N
68499	1397	1418187952000	2800	1464	2	0	\N
68500	1397	1418177951000	2800	1464	3	0	\N
68501	1397	1418167950000	2801	1465	0	0	\N
68502	1397	1418157949000	2801	1465	1	0	\N
68503	1397	1418147948000	2801	1465	2	0	\N
68507	1397	1418167950000	2803	1465	0	0	\N
68508	1397	1418157949000	2803	1465	1	0	\N
68509	1397	1418147948000	2803	1465	2	0	\N
68510	1706	4316771000000	2804	1334	0	0	\N
68511	1474	5758070000000	2804	1334	1	0	\N
68512	1397	1420058139000	2804	1334	2	0	\N
68513	1397	1420048138000	2804	1334	3	0	\N
68514	1397	1420038137000	2804	1334	4	0	\N
68515	1397	1420028136000	2804	1334	5	0	\N
68516	1397	1420018135000	2804	1334	6	0	\N
68517	1397	1420008134000	2804	1334	7	0	\N
68518	1397	1419998133000	2804	1334	8	0	\N
68519	1397	1419988132000	2804	1334	9	0	\N
68520	1397	1419978131000	2804	1334	10	0	\N
68521	1397	1419968130000	2804	1334	11	0	\N
68522	1397	1419958129000	2804	1334	12	0	\N
68523	1397	1419948128000	2804	1334	13	0	\N
68524	1397	1419938127000	2804	1334	14	0	\N
68525	1397	1419928126000	2804	1334	15	0	\N
68526	1397	1419918125000	2804	1334	16	0	\N
68527	1397	1419908124000	2804	1334	17	0	\N
68528	1397	1419898123000	2804	1334	18	0	\N
68529	1397	1419888122000	2804	1334	19	0	\N
68530	1397	1419878121000	2804	1334	20	0	\N
68531	1397	1419868120000	2804	1334	21	0	\N
68532	1397	1419858119000	2804	1334	22	0	\N
68533	1397	1419848118000	2804	1334	23	0	\N
68534	1397	1419838117000	2804	1334	24	0	\N
68535	1397	1419828116000	2804	1334	25	0	\N
68536	1397	1419818115000	2804	1334	26	0	\N
68537	1397	1419808114000	2804	1334	27	0	\N
68538	1397	1419798113000	2804	1334	28	0	\N
68539	1397	1419788112000	2804	1334	29	0	\N
68540	1397	1419778111000	2804	1334	30	0	\N
68541	1397	1419768110000	2804	1334	31	0	\N
68542	1397	1419758109000	2804	1334	32	0	\N
68543	1397	1419748108000	2804	1334	33	0	\N
68544	1397	1419738107000	2804	1334	34	0	\N
68484	1397	1418227956000	2793	1462	0	0	2061
68488	1397	1418217955000	2797	1463	0	0	2062
68493	1397	1418207954000	2799	1464	0	0	2063
68494	1397	1418197953000	2799	1464	1	0	2064
68495	1397	1418187952000	2799	1464	2	0	2065
68504	1397	1418167950000	2802	1465	0	0	2067
68505	1397	1418157949000	2802	1465	1	0	2068
68506	1397	1418147948000	2802	1465	2	0	2069
68545	1397	1419728106000	2804	1334	35	0	\N
68546	1397	1419718105000	2804	1334	36	0	\N
68547	1397	1419708104000	2804	1334	37	0	\N
68548	1397	1419698103000	2804	1334	38	0	\N
68549	1397	1419688102000	2804	1334	39	0	\N
68550	1397	1419678101000	2804	1334	40	0	\N
68551	1397	1419668100000	2804	1334	41	0	\N
68552	1397	1419658099000	2804	1334	42	0	\N
68553	1397	1419648098000	2804	1334	43	0	\N
68554	1397	1419638097000	2804	1334	44	0	\N
68555	1397	1419628096000	2804	1334	45	0	\N
68556	1397	1419618095000	2804	1334	46	0	\N
68557	1397	1419608094000	2804	1334	47	0	\N
68558	1397	1419598093000	2804	1334	48	0	\N
68559	1397	1419588092000	2804	1334	49	0	\N
68560	1397	1419578091000	2804	1334	50	0	\N
68561	1397	1419568090000	2804	1334	51	0	\N
68562	1397	1419558089000	2804	1334	52	0	\N
68563	1397	1419548088000	2804	1334	53	0	\N
68564	1397	1419538087000	2804	1334	54	0	\N
68565	1397	1419528086000	2804	1334	55	0	\N
68566	1397	1419518085000	2804	1334	56	0	\N
68567	1397	1419508084000	2804	1334	57	0	\N
68568	1397	1419498083000	2804	1334	58	0	\N
68569	1397	1419488082000	2804	1334	59	0	\N
68570	1397	1419478081000	2804	1334	60	0	\N
68571	1397	1419468080000	2804	1334	61	0	\N
68572	1397	1419458079000	2804	1334	62	0	\N
68573	1397	1419448078000	2804	1334	63	0	\N
68574	1397	1419438077000	2804	1334	64	0	\N
68575	1397	1419428076000	2804	1334	65	0	\N
68576	1397	1419418075000	2804	1334	66	0	\N
68577	1397	1419408074000	2804	1334	67	0	\N
68578	1397	1419398073000	2804	1334	68	0	\N
68579	1397	1419388072000	2804	1334	69	0	\N
68580	1397	1419378071000	2804	1334	70	0	\N
68581	1397	1419368070000	2804	1334	71	0	\N
68582	1397	1419358069000	2804	1334	72	0	\N
68583	1397	1419348068000	2804	1334	73	0	\N
68584	1397	1419338067000	2804	1334	74	0	\N
68585	1397	1419328066000	2804	1334	75	0	\N
68586	1397	1419318065000	2804	1334	76	0	\N
68587	1397	1419308064000	2804	1334	77	0	\N
68588	1397	1419298063000	2804	1334	78	0	\N
68589	1397	1419288062000	2804	1334	79	0	\N
68590	1397	1419278061000	2804	1334	80	0	\N
68591	1397	1419268060000	2804	1334	81	0	\N
68592	1397	1419258059000	2804	1334	82	0	\N
68593	1397	1419248058000	2804	1334	83	0	\N
68594	1397	1419238057000	2804	1334	84	0	\N
68595	1397	1419228056000	2804	1334	85	0	\N
68596	1397	1419218055000	2804	1334	86	0	\N
68597	1397	1419208054000	2804	1334	87	0	\N
68598	1397	1419198053000	2804	1334	88	0	\N
68599	1397	1419188052000	2804	1334	89	0	\N
68600	1397	1419178051000	2804	1334	90	0	\N
68601	1397	1419168050000	2804	1334	91	0	\N
68602	1397	1419158049000	2804	1334	92	0	\N
68603	1397	1419148048000	2804	1334	93	0	\N
68604	1397	1419138047000	2804	1334	94	0	\N
68605	1397	1419128046000	2804	1334	95	0	\N
68606	1397	1419118045000	2804	1334	96	0	\N
68607	1397	1419108044000	2804	1334	97	0	\N
68608	1397	1419098043000	2804	1334	98	0	\N
68609	1397	1419088042000	2804	1334	99	0	\N
68610	1397	1419078041000	2804	1334	100	0	\N
68611	1397	1419068040000	2804	1334	101	0	\N
68612	1397	1419058039000	2804	1334	102	0	\N
68613	1397	1419048038000	2804	1334	103	0	\N
68614	1397	1419038037000	2804	1334	104	0	\N
68615	1397	1419028036000	2804	1334	105	0	\N
68616	1397	1419018035000	2804	1334	106	0	\N
68617	1397	1419008034000	2804	1334	107	0	\N
68618	1397	1418998033000	2804	1334	108	0	\N
68619	1397	1418988032000	2804	1334	109	0	\N
68620	1397	1418978031000	2804	1334	110	0	\N
68621	1397	1418968030000	2804	1334	111	0	\N
68622	1397	1418958029000	2804	1334	112	0	\N
68623	1397	1418948028000	2804	1334	113	0	\N
68624	1397	1418938027000	2804	1334	114	0	\N
68625	1397	1418928026000	2804	1334	115	0	\N
68626	1397	1418918025000	2804	1334	116	0	\N
68627	1397	1418908024000	2804	1334	117	0	\N
68628	1397	1418898023000	2804	1334	118	0	\N
68629	1397	1418888022000	2804	1334	119	0	\N
68630	1397	1418878021000	2804	1334	120	0	\N
68631	1397	1418868020000	2804	1334	122	0	\N
68632	1397	1418858019000	2804	1334	123	0	\N
68633	1397	1418848018000	2804	1334	124	0	\N
68634	1397	1418838017000	2804	1334	125	0	\N
68635	1397	1418167950000	2805	1465	0	0	\N
68636	1397	1418157949000	2805	1465	1	0	\N
68637	1397	1418147948000	2805	1465	2	0	\N
68639	1397	1418127946000	2807	1467	0	0	\N
68640	1397	1418117945000	2807	1467	1	0	\N
68647	1397	1418077941000	2813	1471	0	0	\N
68655	1397	1418027936000	2828	1478	0	0	\N
68656	1397	1418017935000	2828	1478	1	0	\N
68657	1397	1418007934000	2828	1478	2	0	\N
68658	1397	1417997933000	2828	1478	3	0	\N
68659	1397	1417987932000	2828	1478	4	0	\N
68660	1397	1417977931000	2828	1478	5	0	\N
68661	1397	1417967930000	2828	1478	6	0	\N
68662	1397	1417957929000	2828	1478	7	0	\N
68673	1397	1417947928000	2833	1480	0	0	\N
68674	1397	1417937927000	2833	1480	1	0	\N
68675	1397	1417927926000	2833	1480	2	0	\N
68642	1397	1418117945000	2808	1467	1	0	2072
68643	1397	1418107944000	2809	1468	0	0	2073
68644	1397	1418097943000	2810	1469	0	0	2074
68645	1397	1418087942000	2811	1470	0	0	2075
68646	1397	1418077941000	2812	1471	0	0	2076
68649	1397	1418057939000	2817	1473	0	0	2078
68650	1397	1418047938000	2817	1473	1	0	2079
68651	1474	6476070000000	2822	1474	0	0	2
68652	1397	1418037937000	2822	1474	1	0	2080
68653	1474	6474060000000	2825	1475	0	0	3
68663	1397	1418027936000	2829	1478	0	0	2081
68664	1397	1418017935000	2829	1478	1	0	2082
68665	1397	1418007934000	2829	1478	2	0	2083
68666	1397	1417997933000	2829	1478	3	0	2084
68668	1397	1417977931000	2829	1478	5	0	2086
68669	1397	1417967930000	2829	1478	6	0	2087
68670	1397	1417957929000	2829	1478	7	0	2088
68671	1397	1417947928000	2832	1480	0	0	2089
68672	1397	1417937927000	2832	1480	1	0	2090
68677	1397	1417917925000	2836	1482	0	0	2092
68678	1397	1417907924000	2836	1482	1	0	2093
68679	1397	1417897923000	2836	1482	2	0	2094
68680	1769	2997000000	2836	1482	3	0	2
68691	1397	1417787912000	2845	1490	0	0	\N
68697	1397	1417747908000	2852	1493	0	0	\N
68700	1397	1417737907000	2855	1495	0	0	\N
68701	1397	1417727906000	2855	1495	1	0	\N
68705	1397	1417717905000	2857	1496	0	0	\N
68706	1397	1417707904000	2857	1496	1	0	\N
68707	1769	2995000000	2857	1496	2	0	\N
68708	1397	1417717905000	2858	1496	0	0	\N
68709	1397	1417707904000	2858	1496	1	0	\N
68710	1769	2995000000	2858	1496	2	0	\N
68711	1769	2995000000	2859	1496	0	0	\N
68712	1397	1417717905000	2860	1496	0	0	\N
68713	1397	1417707904000	2860	1496	1	0	\N
68714	1769	2995000000	2860	1496	2	0	\N
68716	1397	1419028036000	2862	1405	0	0	\N
68719	1397	1417667900000	2864	1499	0	0	\N
68724	1397	1417657899000	2867	1500	0	0	\N
68725	1397	1417647898000	2867	1500	1	0	\N
68726	1397	1417637897000	2867	1500	2	0	\N
68727	1397	1417627896000	2869	1501	0	0	\N
68730	1397	1417627896000	2872	1502	0	0	\N
68731	1397	1417617895000	2872	1502	1	0	\N
68733	1397	1417597893000	2875	1504	0	0	\N
68735	1397	1417587892000	2877	1505	0	0	\N
68736	1397	1417587892000	2878	1505	0	0	\N
68737	1397	1417587892000	2879	1505	0	0	\N
68740	1397	1417587892000	2882	1506	0	0	\N
68741	1397	1417577891000	2882	1506	1	0	\N
68742	1397	1417587892000	2883	1506	0	0	\N
68743	1397	1417577891000	2883	1506	1	0	\N
68744	1397	1417567890000	2884	1507	0	0	\N
68746	1397	1417567890000	2886	1507	0	0	\N
68749	1397	1417547888000	2889	1509	0	0	\N
68751	1397	1417537887000	2891	1510	0	0	\N
68752	1397	1417537887000	2892	1510	0	0	\N
68753	1397	1417537887000	2893	1510	0	0	\N
68754	1397	1417537887000	2894	1510	0	0	\N
68760	1397	1417477881000	2897	1513	0	0	\N
68763	1397	1417467880000	2900	1514	0	0	\N
68764	1397	1417457879000	2902	1515	0	0	\N
68767	1397	1417437877000	2905	1517	0	0	\N
68768	1397	1417427876000	2905	1517	1	0	\N
68769	1397	1417417875000	2905	1517	2	0	\N
68770	1397	1417407874000	2905	1517	3	0	\N
68775	1397	1417437877000	2908	1517	0	0	\N
68776	1397	1417427876000	2908	1517	1	0	\N
68777	1397	1417417875000	2908	1517	2	0	\N
68778	1397	1417407874000	2908	1517	3	0	\N
68779	1397	1417437877000	2909	1517	0	0	\N
68780	1397	1417427876000	2909	1517	1	0	\N
68781	1397	1417417875000	2909	1517	2	0	\N
68782	1397	1417407874000	2909	1517	3	0	\N
68783	1397	1417397873000	2911	1518	0	0	\N
68784	1397	1417387872000	2911	1518	1	0	\N
68785	1397	1417377871000	2911	1518	2	0	\N
68786	1397	1417367870000	2911	1518	3	0	\N
68787	1397	1417357869000	2911	1518	4	0	\N
68788	1474	6476070000000	2912	1465	0	0	\N
68789	1397	1418167950000	2912	1465	1	0	\N
68790	1397	1418157949000	2912	1465	2	0	\N
68791	1397	1418147948000	2912	1465	3	0	\N
68792	1397	1418137947000	2912	1465	4	0	\N
68793	1397	1418127946000	2912	1465	5	0	\N
68794	1397	1418117945000	2912	1465	6	0	\N
68795	1397	1418107944000	2912	1465	7	0	\N
68796	1474	6474060000000	2912	1465	8	0	\N
68797	1397	1418097943000	2912	1465	9	0	\N
68798	1397	1418087942000	2912	1465	10	0	\N
68799	1397	1418077941000	2912	1465	11	0	\N
68800	1397	1418067940000	2912	1465	12	0	\N
68801	1397	1418057939000	2912	1465	13	0	\N
68802	1397	1418047938000	2912	1465	14	0	\N
68803	1397	1418037937000	2912	1465	15	0	\N
68804	1397	1418027936000	2912	1465	16	0	\N
68805	1397	1418017935000	2912	1465	17	0	\N
68806	1397	1418007934000	2912	1465	18	0	\N
68807	1397	1417997933000	2912	1465	19	0	\N
68808	1397	1417987932000	2912	1465	20	0	\N
68809	1397	1417977931000	2912	1465	21	0	\N
68810	1397	1417967930000	2912	1465	22	0	\N
68811	1397	1417957929000	2912	1465	23	0	\N
68812	1397	1417947928000	2912	1465	24	0	\N
68813	1397	1417937927000	2912	1465	25	0	\N
68814	1397	1417927926000	2912	1465	26	0	\N
68815	1397	1417917925000	2912	1465	27	0	\N
68816	1397	1417907924000	2912	1465	28	0	\N
68683	1397	1417867920000	2838	1484	2	0	2097
68684	1397	1417857919000	2840	1485	0	0	2098
68685	1397	1417847918000	2841	1486	0	0	2099
68686	1397	1417837917000	2841	1486	1	0	2100
68687	1397	1417827916000	2842	1487	0	0	2101
68689	1397	1417807914000	2843	1488	0	0	2103
68690	1397	1417797913000	2844	1489	0	0	2104
68692	1397	1417787912000	2846	1490	0	0	2105
68693	1397	1417777911000	2847	1491	0	0	2106
68694	1397	1417767910000	2847	1491	1	0	2107
68696	1397	1417747908000	2850	1493	0	0	2109
68698	1397	1417737907000	2854	1495	0	0	2110
68699	1397	1417727906000	2854	1495	1	0	2111
68702	1397	1417717905000	2856	1496	0	0	2112
68704	1769	2995000000	2856	1496	2	0	3
68715	1397	1417697903000	2861	1497	0	0	2114
68717	1397	1417687902000	2863	1498	0	0	2115
68718	1397	1417677901000	2863	1498	1	0	2116
68720	1397	1417667900000	2865	1499	0	0	2117
68722	1397	1417647898000	2866	1500	1	0	2119
68723	1397	1417637897000	2866	1500	2	0	2120
68728	1397	1417627896000	2871	1502	0	0	2121
68729	1397	1417617895000	2871	1502	1	0	2122
68732	1397	1417607894000	2873	1503	0	0	2123
68738	1397	1417587892000	2881	1506	0	0	2125
68739	1397	1417577891000	2881	1506	1	0	2126
68745	1397	1417567890000	2885	1507	0	0	2127
68747	1397	1417557889000	2887	1508	0	0	2128
68750	1397	1417537887000	2890	1510	0	0	2130
68755	1397	1417527886000	2895	1511	0	0	2131
68756	1397	1417517885000	2895	1511	1	0	2132
68757	1397	1417507884000	2895	1511	2	0	2133
68758	1397	1417497883000	2896	1512	0	0	2134
68761	1397	1417477881000	2898	1513	0	0	2136
68762	1397	1417467880000	2899	1514	0	0	2137
68765	1397	1417457879000	2903	1515	0	0	2138
68766	1397	1417447878000	2904	1516	0	0	2139
68771	1397	1417437877000	2906	1517	0	0	2140
68773	1397	1417417875000	2906	1517	2	0	2142
68774	1397	1417407874000	2906	1517	3	0	2143
68817	1397	1417897923000	2912	1465	29	0	\N
68818	1397	1417887922000	2912	1465	30	0	\N
68819	1397	1417877921000	2912	1465	31	0	\N
68820	1397	1417867920000	2912	1465	32	0	\N
68821	1397	1417857919000	2912	1465	33	0	\N
68822	1397	1417847918000	2912	1465	34	0	\N
68823	1397	1417837917000	2912	1465	35	0	\N
68824	1397	1417827916000	2912	1465	36	0	\N
68825	1397	1417817915000	2912	1465	37	0	\N
68826	1397	1417807914000	2912	1465	38	0	\N
68827	1397	1417797913000	2912	1465	39	0	\N
68828	1397	1417787912000	2912	1465	40	0	\N
68829	1397	1417777911000	2912	1465	41	0	\N
68830	1397	1417767910000	2912	1465	42	0	\N
68831	1397	1417757909000	2912	1465	43	0	\N
68832	1397	1417747908000	2912	1465	44	0	\N
68833	1397	1417737907000	2912	1465	45	0	\N
68834	1397	1417727906000	2912	1465	46	0	\N
68835	1397	1417717905000	2912	1465	47	0	\N
68836	1397	1417707904000	2912	1465	48	0	\N
68837	1397	1417697903000	2912	1465	49	0	\N
68838	1397	1417687902000	2912	1465	50	0	\N
68844	1397	1417397873000	2914	1518	0	0	\N
68845	1397	1417387872000	2914	1518	1	0	\N
68846	1397	1417377871000	2914	1518	2	0	\N
68847	1397	1417367870000	2914	1518	3	0	\N
68848	1397	1417357869000	2914	1518	4	0	\N
68849	1397	1417347868000	2915	1519	0	0	\N
68855	1397	1418637997000	2921	1432	0	0	\N
68856	1397	1418627996000	2921	1432	1	0	\N
68857	1397	1418617995000	2921	1432	2	0	\N
68858	1474	6478080000000	2921	1432	3	0	\N
68859	1474	6476070000000	2921	1432	4	0	\N
68860	1474	6474060000000	2921	1432	5	0	\N
68861	1397	1418607994000	2921	1432	6	0	\N
68862	1397	1418597993000	2921	1432	7	0	\N
68863	1397	1418587992000	2921	1432	8	0	\N
68864	1397	1418577991000	2921	1432	9	0	\N
68865	1397	1418567990000	2921	1432	10	0	\N
68866	1397	1418557989000	2921	1432	11	0	\N
68867	1397	1418547988000	2921	1432	12	0	\N
68868	1397	1418537987000	2921	1432	13	0	\N
68869	1397	1418527986000	2921	1432	14	0	\N
68870	1397	1418517985000	2921	1432	15	0	\N
68871	1397	1418507984000	2921	1432	16	0	\N
68872	1397	1418497983000	2921	1432	17	0	\N
68873	1397	1418487982000	2921	1432	18	0	\N
68874	1397	1418477981000	2921	1432	19	0	\N
68875	1397	1418467980000	2921	1432	20	0	\N
68876	1397	1418457979000	2921	1432	21	0	\N
68877	1397	1418447978000	2921	1432	22	0	\N
68878	1397	1418437977000	2921	1432	23	0	\N
68879	1397	1418427976000	2921	1432	24	0	\N
68880	1397	1418417975000	2921	1432	25	0	\N
68881	1397	1418407974000	2921	1432	26	0	\N
68882	1397	1418397973000	2921	1432	27	0	\N
68883	1397	1418387972000	2921	1432	28	0	\N
68884	1397	1418377971000	2921	1432	29	0	\N
68885	1397	1418367970000	2921	1432	30	0	\N
68886	1397	1418357969000	2921	1432	31	0	\N
68887	1397	1418347968000	2921	1432	32	0	\N
68888	1397	1418337967000	2921	1432	33	0	\N
68889	1397	1418327966000	2921	1432	34	0	\N
68890	1397	1418317965000	2921	1432	35	0	\N
68891	1397	1418307964000	2921	1432	36	0	\N
68892	1397	1418297963000	2921	1432	38	0	\N
68893	1397	1418287962000	2921	1432	39	0	\N
68894	1397	1418277961000	2921	1432	40	0	\N
68895	1397	1418267960000	2921	1432	41	0	\N
68896	1397	1418257959000	2921	1432	42	0	\N
68897	1397	1418247958000	2921	1432	43	0	\N
68898	1397	1418237957000	2921	1432	44	0	\N
68899	1397	1418227956000	2921	1432	45	0	\N
68900	1397	1418217955000	2921	1432	46	0	\N
68901	1397	1418207954000	2921	1432	47	0	\N
68902	1397	1418197953000	2921	1432	48	0	\N
68903	1397	1418187952000	2921	1432	49	0	\N
68904	1397	1418177951000	2921	1432	50	0	\N
68905	1397	1418167950000	2921	1432	51	0	\N
68906	1397	1418157949000	2921	1432	52	0	\N
68907	1397	1418147948000	2921	1432	53	0	\N
68908	1397	1418137947000	2921	1432	54	0	\N
68909	1397	1418127946000	2921	1432	55	0	\N
68910	1397	1418117945000	2921	1432	56	0	\N
68911	1397	1418107944000	2921	1432	57	0	\N
68912	1397	1418097943000	2921	1432	58	0	\N
68913	1397	1418087942000	2921	1432	59	0	\N
68914	1397	1418077941000	2921	1432	60	0	\N
68915	1397	1418067940000	2921	1432	61	0	\N
68916	1397	1418057939000	2921	1432	62	0	\N
68917	1397	1418047938000	2921	1432	63	0	\N
68918	1397	1418037937000	2921	1432	64	0	\N
68919	1397	1418027936000	2921	1432	65	0	\N
68920	1397	1418017935000	2921	1432	66	0	\N
68921	1397	1418007934000	2921	1432	67	0	\N
68922	1397	1417997933000	2921	1432	68	0	\N
68923	1397	1417987932000	2921	1432	69	0	\N
68924	1397	1417977931000	2921	1432	70	0	\N
68925	1397	1417967930000	2921	1432	71	0	\N
68926	1397	1417957929000	2921	1432	72	0	\N
68927	1397	1417947928000	2921	1432	73	0	\N
68928	1397	1417937927000	2921	1432	74	0	\N
68929	1397	1417927926000	2921	1432	75	0	\N
68930	1397	1417917925000	2921	1432	76	0	\N
68931	1397	1417907924000	2921	1432	77	0	\N
68932	1397	1417897923000	2921	1432	78	0	\N
68933	1397	1417887922000	2921	1432	79	0	\N
68934	1397	1417877921000	2921	1432	80	0	\N
68935	1397	1417867920000	2921	1432	81	0	\N
68936	1397	1417857919000	2921	1432	82	0	\N
68937	1397	1417847918000	2921	1432	83	0	\N
68938	1397	1417837917000	2921	1432	84	0	\N
68939	1397	1417827916000	2921	1432	85	0	\N
68940	1397	1417817915000	2921	1432	86	0	\N
68941	1397	1417807914000	2921	1432	87	0	\N
68942	1397	1417797913000	2921	1432	88	0	\N
68943	1397	1417787912000	2921	1432	89	0	\N
68944	1397	1417777911000	2921	1432	90	0	\N
68945	1397	1417767910000	2921	1432	91	0	\N
68946	1397	1417757909000	2921	1432	92	0	\N
68947	1397	1417747908000	2921	1432	93	0	\N
68948	1397	1417737907000	2921	1432	94	0	\N
68949	1397	1417727906000	2921	1432	95	0	\N
68950	1397	1417717905000	2921	1432	96	0	\N
68951	1397	1417707904000	2921	1432	97	0	\N
68952	1397	1417697903000	2921	1432	98	0	\N
68841	1397	1417377871000	2913	1518	2	0	2146
68842	1397	1417367870000	2913	1518	3	0	2147
68843	1397	1417357869000	2913	1518	4	0	2148
68850	1397	1417347868000	2916	1519	0	0	2149
68851	1397	1417337867000	2918	1520	0	0	2150
68853	1397	1417317865000	2918	1520	2	0	2152
68854	1397	1417307864000	2919	1521	0	0	2153
68953	1397	1417687902000	2921	1432	99	0	\N
68954	1397	1417677901000	2921	1432	100	0	\N
68955	1397	1417667900000	2921	1432	101	0	\N
68956	1397	1417657899000	2921	1432	102	0	\N
68957	1397	1417647898000	2921	1432	103	0	\N
68958	1397	1417637897000	2921	1432	104	0	\N
68959	1397	1417627896000	2921	1432	105	0	\N
68960	1397	1417617895000	2921	1432	106	0	\N
68961	1397	1417607894000	2921	1432	107	0	\N
68962	1397	1417597893000	2921	1432	108	0	\N
68963	1397	1417587892000	2921	1432	109	0	\N
68964	1397	1417577891000	2921	1432	110	0	\N
68965	1397	1417567890000	2921	1432	111	0	\N
68966	1397	1417557889000	2921	1432	112	0	\N
68967	1397	1417547888000	2921	1432	113	0	\N
68968	1397	1417537887000	2921	1432	114	0	\N
68969	1397	1417527886000	2921	1432	115	0	\N
68970	1397	1417517885000	2921	1432	116	0	\N
68971	1397	1417507884000	2921	1432	117	0	\N
68972	1397	1417497883000	2921	1432	118	0	\N
68973	1397	1417487882000	2921	1432	119	0	\N
68974	1397	1417477881000	2921	1432	120	0	\N
68975	1397	1417467880000	2921	1432	121	0	\N
68976	1397	1417457879000	2921	1432	122	0	\N
68977	1397	1417447878000	2921	1432	123	0	\N
68978	1397	1417437877000	2921	1432	124	0	\N
68979	1397	1417427876000	2921	1432	125	0	\N
68980	1397	1417297863000	2922	1522	0	0	\N
68981	1397	1417287862000	2922	1522	1	0	\N
68984	1397	1417297863000	2924	1522	0	0	\N
68985	1397	1417287862000	2924	1522	1	0	\N
68986	1397	1417297863000	2925	1522	0	0	\N
68987	1397	1417287862000	2925	1522	1	0	\N
68988	1397	1417277861000	2927	1523	0	0	\N
68989	1397	1417277861000	2928	1523	0	0	\N
68990	1397	1417277861000	2929	1524	0	0	\N
68991	1397	1417267860000	2929	1524	1	0	\N
68994	1397	1417277861000	2931	1524	0	0	\N
68995	1397	1417267860000	2931	1524	1	0	\N
68998	1397	1417237857000	2934	1526	0	0	\N
69003	1397	1417207854000	2942	1529	0	0	\N
69005	1397	1417187852000	2945	1531	0	0	\N
69008	1397	1417167850000	2948	1533	0	0	\N
69019	1397	1417067840000	2954	1537	0	0	\N
69020	1397	1417067840000	2955	1537	0	0	\N
69023	1397	1417057839000	2959	1538	0	0	\N
69024	1397	1417057839000	2960	1538	0	0	\N
69025	1397	1417057839000	2961	1538	0	0	\N
69027	1397	1417047838000	2963	1539	0	0	\N
69028	1397	1417037837000	2964	1540	0	0	\N
69030	1397	1417037837000	2966	1540	0	0	\N
69040	1397	1416967830000	2972	1545	0	0	\N
69041	1397	1416957829000	2972	1545	1	0	\N
69042	1397	1416947828000	2972	1545	2	0	\N
69044	1397	1416937827000	2974	1546	0	0	\N
69048	1397	1416897823000	2978	1549	0	0	\N
69049	1397	1416897823000	2979	1549	0	0	\N
69053	1397	1416867820000	2983	1552	0	0	\N
69055	1397	1416867820000	2985	1552	0	0	\N
69056	1397	1416867820000	2986	1552	0	0	\N
69058	1397	1416857819000	2988	1553	0	0	\N
69062	1397	1416847818000	2991	1554	0	0	\N
69063	1397	1416837817000	2991	1554	2	0	\N
69064	1397	1416827816000	2991	1554	3	0	\N
69066	1397	1416817815000	2993	1555	0	0	\N
69070	1397	1416797813000	2996	1557	0	0	\N
69071	1397	1416787812000	2996	1557	1	0	\N
69072	1706	5756591000000	2997	1558	0	0	\N
69073	1706	5756591000000	2998	1558	0	0	\N
69075	1706	4316571000000	3004	1359	0	0	\N
69076	1397	1419698103000	3004	1359	1	0	\N
69077	1397	1419688102000	3004	1359	2	0	\N
69078	1397	1419678101000	3004	1359	3	0	\N
69079	1397	1419668100000	3004	1359	4	0	\N
69080	1397	1419658099000	3004	1359	5	0	\N
69081	1397	1419648098000	3004	1359	6	0	\N
69082	1397	1419638097000	3004	1359	7	0	\N
69083	1474	5758070000000	3004	1359	8	0	\N
69084	1474	5756060000000	3004	1359	9	0	\N
69085	1474	5754050000000	3004	1359	10	0	\N
69086	1397	1419628096000	3004	1359	11	0	\N
69087	1397	1419618095000	3004	1359	12	0	\N
69088	1397	1419608094000	3004	1359	13	0	\N
68992	1397	1417277861000	2930	1524	0	0	2156
68993	1397	1417267860000	2930	1524	1	0	2157
68996	1397	1417257859000	2932	1525	0	0	2158
68997	1397	1417247858000	2932	1525	1	0	2159
68999	1397	1417237857000	2935	1527	0	0	2160
69001	1397	1417217855000	2936	1528	0	0	2162
69002	1397	1417207854000	2941	1529	0	0	2163
69004	1397	1417197853000	2943	1530	0	0	2164
69006	1397	1417187852000	2946	1531	0	0	2165
69007	1397	1417177851000	2947	1532	0	0	2166
69010	1397	1417157849000	2950	1534	0	0	2168
69011	1397	1417147848000	2950	1534	1	0	2169
69012	1397	1417137847000	2950	1534	2	0	2170
69013	1397	1417127846000	2950	1534	3	0	2171
69015	1397	1417107844000	2952	1535	1	0	2173
69016	1397	1417097843000	2952	1535	2	0	2174
69017	1397	1417087842000	2952	1535	3	0	2175
69018	1397	1417077841000	2953	1536	0	0	2176
69021	1397	1417067840000	2956	1537	0	0	2177
69026	1397	1417047838000	2962	1539	0	0	2179
69029	1397	1417037837000	2965	1540	0	0	2180
69031	1397	1417027836000	2967	1541	0	0	2181
69032	1397	1417017835000	2968	1542	0	0	2182
69033	1397	1417007834000	2969	1543	0	0	2183
69035	1397	1416987832000	2969	1543	2	0	2185
69036	1397	1416977831000	2970	1544	0	0	2186
69037	1397	1416967830000	2971	1545	0	0	2187
69038	1397	1416957829000	2971	1545	1	0	2188
69043	1397	1416937827000	2973	1546	0	0	2190
69045	1397	1416927826000	2975	1547	0	0	2191
69046	1397	1416917825000	2975	1547	1	0	2192
69047	1397	1416907824000	2976	1548	0	0	2193
69050	1397	1416897823000	2980	1549	0	0	2194
69052	1397	1416877821000	2982	1551	0	0	2196
69054	1397	1416867820000	2984	1552	0	0	2197
69057	1397	1416857819000	2987	1553	0	0	2198
69059	1397	1416847818000	2990	1554	0	0	2199
69060	1397	1416837817000	2990	1554	2	0	2200
69065	1397	1416817815000	2992	1555	0	0	2202
69067	1397	1416807814000	2994	1556	0	0	2203
69068	1397	1416797813000	2995	1557	0	0	2204
69069	1397	1416787812000	2995	1557	1	0	2205
69089	1397	1419598093000	3004	1359	14	0	\N
69090	1397	1419588092000	3004	1359	15	0	\N
69091	1397	1419578091000	3004	1359	16	0	\N
69092	1397	1419568090000	3004	1359	17	0	\N
69093	1397	1419558089000	3004	1359	18	0	\N
69094	1397	1419548088000	3004	1359	19	0	\N
69095	1397	1419538087000	3004	1359	20	0	\N
69096	1397	1419528086000	3004	1359	21	0	\N
69097	1397	1419518085000	3004	1359	22	0	\N
69098	1397	1419508084000	3004	1359	23	0	\N
69099	1397	1419498083000	3004	1359	24	0	\N
69100	1397	1419488082000	3004	1359	25	0	\N
69101	1397	1419478081000	3004	1359	26	0	\N
69102	1397	1419468080000	3004	1359	27	0	\N
69103	1397	1419458079000	3004	1359	28	0	\N
69104	1397	1419448078000	3004	1359	29	0	\N
69105	1397	1419438077000	3004	1359	30	0	\N
69106	1397	1419428076000	3004	1359	31	0	\N
69107	1397	1419418075000	3004	1359	32	0	\N
69108	1397	1419408074000	3004	1359	33	0	\N
69109	1397	1419398073000	3004	1359	35	0	\N
69110	1397	1419388072000	3004	1359	36	0	\N
69111	1397	1419378071000	3004	1359	37	0	\N
69112	1397	1419368070000	3004	1359	38	0	\N
69113	1397	1419358069000	3004	1359	39	0	\N
69114	1397	1419348068000	3004	1359	40	0	\N
69115	1397	1419338067000	3004	1359	41	0	\N
69116	1397	1419328066000	3004	1359	42	0	\N
69117	1397	1419318065000	3004	1359	43	0	\N
69118	1397	1419308064000	3004	1359	44	0	\N
69119	1397	1419298063000	3004	1359	45	0	\N
69120	1397	1419288062000	3004	1359	46	0	\N
69121	1397	1419278061000	3004	1359	47	0	\N
69122	1397	1419268060000	3004	1359	48	0	\N
69123	1397	1419258059000	3004	1359	49	0	\N
69124	1397	1419248058000	3004	1359	50	0	\N
69125	1397	1419238057000	3004	1359	51	0	\N
69126	1397	1419228056000	3004	1359	52	0	\N
69127	1397	1419218055000	3004	1359	53	0	\N
69128	1397	1419208054000	3004	1359	54	0	\N
69129	1397	1419198053000	3004	1359	55	0	\N
69130	1397	1419188052000	3004	1359	56	0	\N
69131	1397	1419178051000	3004	1359	57	0	\N
69132	1397	1419168050000	3004	1359	58	0	\N
69133	1397	1419158049000	3004	1359	59	0	\N
69134	1397	1419148048000	3004	1359	60	0	\N
69135	1397	1419138047000	3004	1359	61	0	\N
69136	1397	1419128046000	3004	1359	62	0	\N
69137	1397	1419118045000	3004	1359	63	0	\N
69138	1397	1419108044000	3004	1359	64	0	\N
69139	1397	1419098043000	3004	1359	65	0	\N
69140	1397	1419088042000	3004	1359	66	0	\N
69141	1397	1419078041000	3004	1359	67	0	\N
69142	1397	1419068040000	3004	1359	68	0	\N
69145	1397	1416757809000	3011	1564	0	0	\N
69147	1397	1416747808000	3013	1565	0	0	\N
69148	1397	1416747808000	3014	1565	0	0	\N
69151	1397	1416737807000	3017	1566	0	0	\N
69153	1397	1416727806000	3019	1567	0	0	\N
69154	1397	1416717805000	3020	1568	0	0	\N
69159	1397	1416677801000	3025	1572	0	0	\N
69160	1397	1416677801000	3026	1572	0	0	\N
69161	1397	1416677801000	3027	1572	0	0	\N
69165	1397	1416647798000	3031	1575	0	0	\N
69167	1397	1416647798000	3033	1575	0	0	\N
69168	1397	1416637797000	3034	1576	0	0	\N
69172	1397	1416607794000	3037	1578	0	0	\N
69174	1397	1416597793000	3039	1579	0	0	\N
69178	1397	1416567790000	3043	1581	0	0	\N
69179	1397	1416557789000	3043	1581	1	0	\N
69183	1706	5756591000000	3046	1552	0	0	\N
69184	1397	1416867820000	3046	1552	1	0	\N
69185	1397	1416857819000	3046	1552	2	0	\N
69186	1397	1416847818000	3046	1552	3	0	\N
69187	1397	1416837817000	3046	1552	4	0	\N
69188	1397	1416827816000	3046	1552	5	0	\N
69189	1397	1416817815000	3046	1552	6	0	\N
69190	1397	1416807814000	3046	1552	8	0	\N
69191	1397	1416797813000	3046	1552	9	0	\N
69192	1397	1416787812000	3046	1552	10	0	\N
69193	1397	1416777811000	3046	1552	11	0	\N
69194	1397	1416767810000	3046	1552	12	0	\N
69195	1397	1416757809000	3046	1552	13	0	\N
69196	1397	1416747808000	3046	1552	14	0	\N
69197	1397	1416737807000	3046	1552	15	0	\N
69198	1397	1416727806000	3046	1552	16	0	\N
69199	1397	1416717805000	3046	1552	17	0	\N
69200	1397	1416707804000	3046	1552	18	0	\N
69201	1397	1416697803000	3046	1552	19	0	\N
69202	1397	1416687802000	3046	1552	20	0	\N
69203	1397	1416677801000	3046	1552	21	0	\N
69204	1397	1416667800000	3046	1552	22	0	\N
69205	1397	1416657799000	3046	1552	23	0	\N
69206	1397	1416647798000	3046	1552	24	0	\N
69207	1397	1416637797000	3046	1552	25	0	\N
69208	1397	1416627796000	3046	1552	26	0	\N
69209	1397	1416617795000	3046	1552	27	0	\N
69210	1397	1416607794000	3046	1552	28	0	\N
69211	1397	1416597793000	3046	1552	29	0	\N
69212	1397	1416587792000	3046	1552	30	0	\N
69213	1397	1416577791000	3046	1552	31	0	\N
69214	1397	1416567790000	3046	1552	32	0	\N
69215	1397	1416557789000	3046	1552	33	0	\N
69216	1397	1416547788000	3046	1552	34	0	\N
69219	1397	1416537787000	3048	1583	0	0	\N
69220	1397	1416527786000	3048	1583	1	0	\N
69146	1397	1416757809000	3012	1564	0	0	2208
69149	1397	1416747808000	3015	1565	0	0	2209
69150	1397	1416737807000	3016	1566	0	0	2210
69152	1397	1416727806000	3018	1567	0	0	2211
69155	1397	1416717805000	3021	1568	0	0	2212
69157	1397	1416697803000	3023	1570	0	0	2214
69158	1397	1416687802000	3024	1571	0	0	2215
69162	1397	1416677801000	3028	1572	0	0	2216
69163	1397	1416667800000	3029	1573	0	0	2217
69164	1397	1416657799000	3030	1574	0	0	2218
69169	1397	1416637797000	3035	1576	0	0	2220
69170	1397	1416627796000	3036	1577	0	0	2221
69171	1397	1416617795000	3036	1577	1	0	2222
69173	1397	1416607794000	3038	1578	0	0	2223
69176	1397	1416587792000	3042	1580	0	0	2225
69177	1397	1416577791000	3042	1580	1	0	2226
69180	1397	1416567790000	3044	1581	0	0	2227
69181	1397	1416557789000	3044	1581	1	0	2228
69182	1397	1416547788000	3045	1582	0	0	2229
69218	1397	1416527786000	3047	1583	1	0	2231
69221	1397	1416517785000	3049	1584	0	0	2232
69222	1397	1416507784000	3050	1585	0	0	2233
69223	1397	1416497783000	3050	1585	1	0	2234
69224	1397	1416487782000	3050	1585	2	0	2235
69228	1397	1416447778000	3053	1588	0	0	\N
69230	1397	1416447778000	3055	1588	0	0	\N
69234	1686	211805500013	3062	1566	0	0	\N
69244	1397	1416327766000	3072	1598	0	0	\N
69246	1397	1416327766000	3074	1598	0	0	\N
69247	1397	1416327766000	3075	1598	0	0	\N
69248	1706	5036581000000	3076	1473	0	0	\N
69249	1686	211805500013	3076	1473	1	0	\N
69250	1474	6476070000000	3076	1473	2	0	\N
69251	1397	1418057939000	3076	1473	3	0	\N
69252	1397	1418047938000	3076	1473	4	0	\N
69253	1397	1418037937000	3076	1473	5	0	\N
69254	1397	1418027936000	3076	1473	6	0	\N
69255	1397	1418017935000	3076	1473	7	0	\N
69256	1397	1418007934000	3076	1473	8	0	\N
69257	1474	6474060000000	3076	1473	9	0	\N
69258	1397	1417997933000	3076	1473	10	0	\N
69259	1397	1417987932000	3076	1473	11	0	\N
69260	1397	1417977931000	3076	1473	12	0	\N
69261	1397	1417967930000	3076	1473	13	0	\N
69262	1397	1417957929000	3076	1473	14	0	\N
69263	1397	1417947928000	3076	1473	15	0	\N
69264	1397	1417937927000	3076	1473	16	0	\N
69265	1397	1417927926000	3076	1473	17	0	\N
69266	1397	1417917925000	3076	1473	18	0	\N
69267	1397	1417907924000	3076	1473	19	0	\N
69268	1397	1417897923000	3076	1473	20	0	\N
69269	1397	1417887922000	3076	1473	21	0	\N
69270	1397	1417877921000	3076	1473	22	0	\N
69271	1397	1417867920000	3076	1473	23	0	\N
69272	1397	1417857919000	3076	1473	25	0	\N
69273	1397	1417847918000	3076	1473	26	0	\N
69274	1397	1417837917000	3076	1473	27	0	\N
69275	1397	1417827916000	3076	1473	28	0	\N
69276	1397	1417817915000	3076	1473	29	0	\N
69277	1397	1417807914000	3076	1473	30	0	\N
69278	1397	1417797913000	3076	1473	31	0	\N
69279	1397	1417787912000	3076	1473	32	0	\N
69280	1397	1417777911000	3076	1473	33	0	\N
69281	1397	1417767910000	3076	1473	34	0	\N
69282	1397	1417757909000	3076	1473	35	0	\N
69283	1397	1417747908000	3076	1473	36	0	\N
69284	1397	1417737907000	3076	1473	37	0	\N
69285	1397	1417727906000	3076	1473	38	0	\N
69286	1397	1417717905000	3076	1473	39	0	\N
69287	1397	1417707904000	3076	1473	40	0	\N
69288	1397	1417697903000	3076	1473	41	0	\N
69289	1397	1417687902000	3076	1473	42	0	\N
69290	1397	1417677901000	3076	1473	43	0	\N
69291	1397	1417667900000	3076	1473	44	0	\N
69292	1397	1417657899000	3076	1473	45	0	\N
69293	1397	1417647898000	3076	1473	46	0	\N
69294	1397	1417637897000	3076	1473	47	0	\N
69295	1397	1417627896000	3076	1473	48	0	\N
69296	1397	1417617895000	3076	1473	49	0	\N
69297	1397	1417607894000	3076	1473	50	0	\N
69298	1397	1417597893000	3076	1473	51	0	\N
69299	1397	1417587892000	3076	1473	52	0	\N
69300	1397	1417577891000	3076	1473	53	0	\N
69301	1397	1417567890000	3076	1473	54	0	\N
69302	1397	1417557889000	3076	1473	55	0	\N
69303	1397	1417547888000	3076	1473	56	0	\N
69304	1397	1417537887000	3076	1473	57	0	\N
69305	1397	1417527886000	3076	1473	58	0	\N
69306	1397	1417517885000	3076	1473	59	0	\N
69307	1397	1417507884000	3076	1473	60	0	\N
69308	1397	1417497883000	3076	1473	61	0	\N
69309	1397	1417487882000	3076	1473	62	0	\N
69310	1397	1417477881000	3076	1473	63	0	\N
69311	1397	1417467880000	3076	1473	64	0	\N
69312	1397	1417457879000	3076	1473	65	0	\N
69313	1397	1417447878000	3076	1473	66	0	\N
69314	1397	1417437877000	3076	1473	67	0	\N
69315	1397	1417427876000	3076	1473	68	0	\N
69316	1397	1417417875000	3076	1473	69	0	\N
69317	1397	1417407874000	3076	1473	70	0	\N
69318	1397	1417397873000	3076	1473	71	0	\N
69319	1397	1417387872000	3076	1473	72	0	\N
69320	1397	1417377871000	3076	1473	73	0	\N
69321	1397	1417367870000	3076	1473	74	0	\N
69322	1397	1417357869000	3076	1473	75	0	\N
69323	1397	1417347868000	3076	1473	76	0	\N
69324	1397	1417337867000	3076	1473	77	0	\N
69325	1397	1417327866000	3076	1473	78	0	\N
69326	1397	1417317865000	3076	1473	79	0	\N
69327	1397	1417307864000	3076	1473	80	0	\N
69328	1397	1417297863000	3076	1473	81	0	\N
69329	1397	1417287862000	3076	1473	82	0	\N
69330	1397	1417277861000	3076	1473	83	0	\N
69331	1397	1417267860000	3076	1473	84	0	\N
69332	1397	1417257859000	3076	1473	85	0	\N
69333	1397	1417247858000	3076	1473	86	0	\N
69334	1397	1417237857000	3076	1473	87	0	\N
69335	1397	1417227856000	3076	1473	88	0	\N
69336	1397	1417217855000	3076	1473	89	0	\N
69337	1397	1417207854000	3076	1473	90	0	\N
69338	1397	1417197853000	3076	1473	91	0	\N
69339	1397	1417187852000	3076	1473	92	0	\N
69340	1397	1417177851000	3076	1473	93	0	\N
69341	1397	1417167850000	3076	1473	94	0	\N
69342	1397	1417157849000	3076	1473	95	0	\N
69343	1397	1417147848000	3076	1473	96	0	\N
69344	1397	1417137847000	3076	1473	97	0	\N
69345	1397	1417127846000	3076	1473	98	0	\N
69346	1397	1417117845000	3076	1473	99	0	\N
69347	1397	1417107844000	3076	1473	100	0	\N
69348	1397	1417097843000	3076	1473	101	0	\N
69349	1397	1417087842000	3076	1473	102	0	\N
69350	1397	1417077841000	3076	1473	103	0	\N
69351	1397	1417067840000	3076	1473	104	0	\N
69352	1397	1417057839000	3076	1473	105	0	\N
69353	1397	1417047838000	3076	1473	106	0	\N
69354	1397	1417037837000	3076	1473	107	0	\N
69355	1397	1417027836000	3076	1473	108	0	\N
69356	1397	1417017835000	3076	1473	109	0	\N
69357	1397	1417007834000	3076	1473	110	0	\N
69358	1397	1416997833000	3076	1473	111	0	\N
69359	1397	1416987832000	3076	1473	112	0	\N
69360	1397	1416977831000	3076	1473	113	0	\N
69227	1397	1416457779000	3052	1587	1	0	2238
69229	1397	1416447778000	3054	1588	0	0	2239
69231	1686	931815500013	3058	1589	0	0	2
69232	1397	1416437777000	3058	1589	1	0	2240
69233	1397	1416427776000	3058	1589	2	0	2241
69236	1397	1416407774000	3064	1591	0	0	2243
69237	1397	1416397773000	3065	1592	0	0	2244
69238	1397	1416387772000	3067	1593	0	0	2245
69239	1397	1416377771000	3068	1594	0	0	2246
69240	1397	1416367770000	3068	1594	1	0	2247
69242	1397	1416347768000	3070	1596	1	0	2249
69243	1397	1416337767000	3071	1597	0	0	2250
69245	1397	1416327766000	3073	1598	0	0	2251
69361	1397	1416967830000	3076	1473	114	0	\N
69362	1397	1416957829000	3076	1473	115	0	\N
69363	1397	1416947828000	3076	1473	116	0	\N
69364	1397	1416937827000	3076	1473	117	0	\N
69365	1397	1416927826000	3076	1473	118	0	\N
69366	1397	1416917825000	3076	1473	119	0	\N
69367	1397	1416907824000	3076	1473	120	0	\N
69368	1397	1416897823000	3076	1473	121	0	\N
69369	1397	1416887822000	3076	1473	122	0	\N
69370	1397	1416877821000	3076	1473	123	0	\N
69371	1397	1416867820000	3076	1473	124	0	\N
69372	1397	1416857819000	3076	1473	125	0	\N
69374	1397	1416307764000	3078	1600	0	0	\N
69376	1397	1416307764000	3080	1600	0	0	\N
69377	1397	1416307764000	3081	1600	0	0	\N
69378	1397	1416307764000	3082	1600	0	0	\N
69379	1397	1416307764000	3083	1600	0	0	\N
69380	1686	211805500013	3084	1553	0	0	\N
69381	1397	1416537787000	3084	1553	1	0	\N
69382	1397	1416527786000	3084	1553	2	0	\N
69383	1397	1416517785000	3084	1553	3	0	\N
69384	1397	1416507784000	3084	1553	4	0	\N
69385	1397	1416497783000	3084	1553	5	0	\N
69386	1397	1416487782000	3084	1553	6	0	\N
69387	1397	1416477781000	3084	1553	7	0	\N
69388	1397	1416467780000	3084	1553	8	0	\N
69389	1397	1416457779000	3084	1553	9	0	\N
69390	1397	1416447778000	3084	1553	10	0	\N
69391	1397	1416437777000	3084	1553	11	0	\N
69392	1397	1416427776000	3084	1553	12	0	\N
69393	1397	1416417775000	3084	1553	13	0	\N
69394	1397	1416407774000	3084	1553	14	0	\N
69395	1397	1416397773000	3084	1553	15	0	\N
69396	1397	1416387772000	3084	1553	16	0	\N
69397	1397	1416377771000	3084	1553	17	0	\N
69398	1397	1416367770000	3084	1553	18	0	\N
69399	1397	1416357769000	3084	1553	19	0	\N
69400	1397	1416347768000	3084	1553	20	0	\N
69401	1397	1416337767000	3084	1553	21	0	\N
69402	1397	1416327766000	3084	1553	22	0	\N
69403	1397	1416317765000	3084	1553	23	0	\N
69404	1397	1416307764000	3085	1600	0	0	\N
69408	1397	1416287762000	3088	1602	0	0	\N
69409	1397	1416277761000	3088	1602	1	0	\N
69413	1706	4316571000000	3092	1334	0	0	\N
69414	1686	211805500013	3092	1334	1	0	\N
69415	1474	5756060000000	3092	1334	2	0	\N
69416	1397	1418838017000	3092	1334	3	0	\N
69417	1397	1418828016000	3092	1334	4	0	\N
69418	1397	1418818015000	3092	1334	5	0	\N
69419	1397	1418808014000	3092	1334	6	0	\N
69420	1397	1418798013000	3092	1334	7	0	\N
69421	1397	1418788012000	3092	1334	8	0	\N
69422	1397	1418778011000	3092	1334	9	0	\N
69423	1397	1418768010000	3092	1334	10	0	\N
69424	1397	1418758009000	3092	1334	11	0	\N
69425	1397	1418748008000	3092	1334	12	0	\N
69426	1397	1418738007000	3092	1334	13	0	\N
69427	1397	1418728006000	3092	1334	14	0	\N
69428	1474	5754050000000	3092	1334	15	0	\N
69429	1397	1418718005000	3092	1334	16	0	\N
69430	1397	1418708004000	3092	1334	17	0	\N
69431	1397	1418698003000	3092	1334	18	0	\N
69432	1397	1418688002000	3092	1334	19	0	\N
69433	1397	1418678001000	3092	1334	20	0	\N
69434	1397	1418668000000	3092	1334	21	0	\N
69435	1397	1418657999000	3092	1334	22	0	\N
69436	1397	1418647998000	3092	1334	23	0	\N
69437	1397	1418637997000	3092	1334	24	0	\N
69438	1397	1418627996000	3092	1334	25	0	\N
69439	1397	1418617995000	3092	1334	26	0	\N
69440	1397	1418607994000	3092	1334	27	0	\N
69441	1397	1418597993000	3092	1334	28	0	\N
69442	1397	1418587992000	3092	1334	29	0	\N
69443	1397	1418577991000	3092	1334	30	0	\N
69444	1397	1418567990000	3092	1334	31	0	\N
69445	1397	1418557989000	3092	1334	32	0	\N
69446	1397	1418547988000	3092	1334	33	0	\N
69447	1397	1418537987000	3092	1334	34	0	\N
69448	1397	1418527986000	3092	1334	35	0	\N
69449	1397	1418517985000	3092	1334	36	0	\N
69450	1397	1418507984000	3092	1334	37	0	\N
69451	1397	1418497983000	3092	1334	38	0	\N
69452	1397	1418487982000	3092	1334	39	0	\N
69453	1397	1418477981000	3092	1334	40	0	\N
69454	1397	1418467980000	3092	1334	41	0	\N
69455	1397	1418457979000	3092	1334	42	0	\N
69456	1397	1418447978000	3092	1334	43	0	\N
69457	1397	1418437977000	3092	1334	44	0	\N
69458	1397	1418427976000	3092	1334	45	0	\N
69459	1397	1418417975000	3092	1334	46	0	\N
69460	1397	1418407974000	3092	1334	47	0	\N
69461	1397	1418397973000	3092	1334	48	0	\N
69462	1397	1418387972000	3092	1334	49	0	\N
69463	1397	1418377971000	3092	1334	50	0	\N
69464	1397	1418367970000	3092	1334	51	0	\N
69465	1397	1418357969000	3092	1334	52	0	\N
69466	1397	1418347968000	3092	1334	53	0	\N
69467	1397	1418337967000	3092	1334	54	0	\N
69468	1397	1418327966000	3092	1334	55	0	\N
69469	1397	1418317965000	3092	1334	56	0	\N
69470	1397	1418307964000	3092	1334	57	0	\N
69471	1397	1418297963000	3092	1334	58	0	\N
69472	1397	1418287962000	3092	1334	59	0	\N
69473	1397	1418277961000	3092	1334	60	0	\N
69474	1397	1418267960000	3092	1334	61	0	\N
69475	1397	1418257959000	3092	1334	62	0	\N
69476	1397	1418247958000	3092	1334	63	0	\N
69477	1397	1418237957000	3092	1334	64	0	\N
69478	1397	1418227956000	3092	1334	65	0	\N
69479	1397	1418217955000	3092	1334	66	0	\N
69480	1397	1418207954000	3092	1334	67	0	\N
69481	1397	1418197953000	3092	1334	68	0	\N
69482	1397	1418187952000	3092	1334	69	0	\N
69483	1397	1418177951000	3092	1334	70	0	\N
69484	1397	1418167950000	3092	1334	71	0	\N
69485	1397	1418157949000	3092	1334	72	0	\N
69486	1397	1418147948000	3092	1334	73	0	\N
69487	1397	1418137947000	3092	1334	74	0	\N
69488	1397	1418127946000	3092	1334	75	0	\N
69489	1397	1418117945000	3092	1334	76	0	\N
69490	1397	1418107944000	3092	1334	77	0	\N
69491	1397	1418097943000	3092	1334	78	0	\N
69492	1397	1418087942000	3092	1334	79	0	\N
69493	1397	1418077941000	3092	1334	80	0	\N
69494	1397	1418067940000	3092	1334	81	0	\N
69495	1397	1418057939000	3092	1334	82	0	\N
69496	1397	1418047938000	3092	1334	83	0	\N
69405	1397	1416297763000	3086	1601	0	0	2254
69406	1397	1416287762000	3087	1602	0	0	2255
69407	1397	1416277761000	3087	1602	1	0	2256
69410	1397	1416267760000	3089	1603	0	0	2257
69411	1397	1416257759000	3090	1604	0	0	2258
69497	1397	1418037937000	3092	1334	84	0	\N
69498	1397	1418027936000	3092	1334	85	0	\N
69499	1397	1418017935000	3092	1334	86	0	\N
69500	1397	1418007934000	3092	1334	87	0	\N
69501	1397	1417997933000	3092	1334	88	0	\N
69502	1397	1417987932000	3092	1334	89	0	\N
69503	1397	1417977931000	3092	1334	90	0	\N
69504	1397	1417967930000	3092	1334	91	0	\N
69505	1397	1417957929000	3092	1334	92	0	\N
69506	1397	1417947928000	3092	1334	93	0	\N
69507	1397	1417937927000	3092	1334	94	0	\N
69508	1397	1417927926000	3092	1334	95	0	\N
69509	1397	1417917925000	3092	1334	96	0	\N
69510	1397	1417907924000	3092	1334	97	0	\N
69511	1397	1417897923000	3092	1334	98	0	\N
69512	1397	1417887922000	3092	1334	99	0	\N
69513	1397	1417877921000	3092	1334	100	0	\N
69514	1397	1417867920000	3092	1334	101	0	\N
69515	1397	1417857919000	3092	1334	102	0	\N
69516	1397	1417847918000	3092	1334	103	0	\N
69517	1397	1417837917000	3092	1334	104	0	\N
69518	1397	1417827916000	3092	1334	105	0	\N
69519	1397	1417817915000	3092	1334	106	0	\N
69520	1397	1417807914000	3092	1334	107	0	\N
69521	1397	1417797913000	3092	1334	108	0	\N
69522	1397	1417787912000	3092	1334	109	0	\N
69523	1397	1417777911000	3092	1334	110	0	\N
69524	1397	1417767910000	3092	1334	111	0	\N
69525	1397	1417757909000	3092	1334	112	0	\N
69526	1397	1417747908000	3092	1334	113	0	\N
69527	1397	1417737907000	3092	1334	114	0	\N
69528	1397	1417727906000	3092	1334	115	0	\N
69529	1397	1417717905000	3092	1334	116	0	\N
69530	1397	1417707904000	3092	1334	117	0	\N
69531	1397	1417697903000	3092	1334	118	0	\N
69532	1397	1417687902000	3092	1334	119	0	\N
69533	1397	1417677901000	3092	1334	120	0	\N
69534	1397	1417667900000	3092	1334	121	0	\N
69535	1397	1417657899000	3092	1334	122	0	\N
69536	1397	1417647898000	3092	1334	123	0	\N
69537	1397	1417637897000	3092	1334	124	0	\N
69538	1397	1417627896000	3092	1334	125	0	\N
69539	1397	1416237757000	3093	1606	0	0	\N
69540	1397	1416227756000	3093	1606	1	0	\N
69541	1397	1416217755000	3093	1606	2	0	\N
69542	1397	1416207754000	3093	1606	3	0	\N
69543	1397	1416197753000	3093	1606	4	0	\N
69544	1397	1416187752000	3093	1606	5	0	\N
69545	1397	1416177751000	3093	1606	6	0	\N
69546	1770	4034710760393	3093	1606	7	0	\N
69555	1397	1416237757000	3095	1606	0	0	\N
69556	1397	1416227756000	3095	1606	1	0	\N
69557	1397	1416217755000	3095	1606	2	0	\N
69558	1397	1416207754000	3095	1606	3	0	\N
69559	1397	1416197753000	3095	1606	4	0	\N
69560	1397	1416187752000	3095	1606	5	0	\N
69561	1397	1416177751000	3095	1606	6	0	\N
69562	1770	4034710760393	3095	1606	7	0	\N
69566	1397	1416167750000	3097	1607	0	0	\N
69567	1397	1416157749000	3097	1607	1	0	\N
69568	1770	4034700364453	3097	1607	2	0	\N
69569	1397	1416147748000	3098	1608	0	0	\N
69572	1397	1416137747000	3101	1609	0	0	\N
69576	1397	1416097743000	3104	1612	0	0	\N
69582	1397	1416077741000	3109	1614	0	0	\N
69583	1397	1416067740000	3109	1614	1	0	\N
69584	1397	1416057739000	3109	1614	2	0	\N
69587	1397	1416047738000	3111	1615	0	0	\N
69588	1397	1416037737000	3111	1615	1	0	\N
69589	1397	1416047738000	3112	1615	0	0	\N
69590	1397	1416037737000	3112	1615	1	0	\N
69593	1397	1416007734000	3115	1618	0	0	\N
69594	1397	1415997733000	3115	1618	1	0	\N
69595	1397	1415987732000	3115	1618	2	0	\N
69603	1770	4034690363513	3120	1622	0	0	\N
69604	1770	4034680362573	3120	1622	1	0	\N
69605	1397	1415937727000	3120	1622	2	0	\N
69606	1397	1415927726000	3120	1622	3	0	\N
69607	1770	4034670361633	3120	1622	4	0	\N
69608	1770	4034660360693	3120	1622	5	0	\N
69609	1770	3965244611203	3120	1622	6	0	\N
69610	1770	3895828861713	3120	1622	7	0	\N
69611	1770	3367360729145	3120	1622	8	0	\N
69612	1770	2420358283411	3120	1622	9	0	\N
69613	1770	1781393610117	3120	1622	10	0	\N
69614	1770	879600299	3120	1622	11	0	\N
69627	1397	1415917725000	3122	1623	0	0	\N
69628	1397	1415907724000	3122	1623	1	0	\N
69629	1397	1415897723000	3122	1623	2	0	\N
69549	1397	1416217755000	3094	1606	2	0	2262
69550	1397	1416207754000	3094	1606	3	0	2263
69551	1397	1416197753000	3094	1606	4	0	2264
69552	1397	1416187752000	3094	1606	5	0	2265
69553	1397	1416177751000	3094	1606	6	0	2266
69563	1397	1416167750000	3096	1607	0	0	2267
69564	1397	1416157749000	3096	1607	1	0	2268
69565	1770	4034700364453	3096	1607	2	0	2
69570	1397	1416147748000	3099	1608	0	0	2269
69571	1397	1416137747000	3100	1609	0	0	2270
69574	1397	1416117745000	3103	1611	0	0	2272
69575	1397	1416107744000	3103	1611	1	0	2273
69577	1397	1416097743000	3106	1612	0	0	2274
69578	1397	1416087742000	3107	1613	0	0	2275
69580	1397	1416067740000	3108	1614	1	0	2277
69581	1397	1416057739000	3108	1614	2	0	2278
69585	1397	1416047738000	3110	1615	0	0	2279
69586	1397	1416037737000	3110	1615	1	0	2280
69591	1397	1416027736000	3113	1616	0	0	2281
69596	1397	1416007734000	3116	1618	0	0	2283
69597	1397	1415997733000	3116	1618	1	0	2284
69598	1397	1415987732000	3116	1618	2	0	2285
69599	1397	1415977731000	3117	1619	0	0	2286
69600	1397	1415967730000	3117	1619	1	0	2287
69602	1397	1415947728000	3119	1621	0	0	2289
69615	1770	4034690363513	3121	1622	0	0	3
69616	1770	4034680362573	3121	1622	1	0	4
69617	1397	1415937727000	3121	1622	2	0	2290
69619	1770	4034670361633	3121	1622	4	0	5
69620	1770	4034660360693	3121	1622	5	0	6
69621	1770	3965244611203	3121	1622	6	0	7
69622	1770	3895828861713	3121	1622	7	0	8
69623	1770	3367360729145	3121	1622	8	0	9
69625	1770	1781393610117	3121	1622	10	0	11
69626	1770	879600299	3121	1622	11	0	12
69630	1397	1415917725000	3123	1623	0	0	2292
69631	1397	1415907724000	3123	1623	1	0	2293
69632	1397	1415897723000	3123	1623	2	0	2294
69645	1397	1415787712000	3130	1628	0	0	\N
69646	1770	4034710760393	3131	1567	0	0	\N
69647	1770	4034700364453	3131	1567	1	0	\N
69648	1770	4034690363513	3131	1567	2	0	\N
69649	1770	4034680362573	3131	1567	3	0	\N
69650	1770	4034670361633	3131	1567	4	0	\N
69651	1770	4034660360693	3131	1567	5	0	\N
69652	1770	3965244611203	3131	1567	6	0	\N
69653	1770	3895828861713	3131	1567	7	0	\N
69654	1770	3367360729145	3131	1567	8	0	\N
69655	1770	2420358283411	3131	1567	9	0	\N
69656	1770	1781393610117	3131	1567	10	0	\N
69657	1770	879600299	3131	1567	11	0	\N
69658	1770	0	3131	1567	12	0	\N
69660	1397	1415777711000	3133	1629	0	0	\N
69663	1397	1415757709000	3136	1631	0	0	\N
69664	1397	1415757709000	3137	1631	0	0	\N
69665	1397	1415747708000	3138	1632	0	0	\N
69666	1397	1415737707000	3138	1632	1	0	\N
69667	1397	1415727706000	3138	1632	2	0	\N
69668	1397	1415717705000	3138	1632	3	0	\N
69680	1397	1415637697000	3142	1635	0	0	\N
69681	1397	1415637697000	3143	1635	0	0	\N
69682	1397	1415637697000	3144	1635	0	0	\N
69684	1397	1415627696000	3146	1636	0	0	\N
69686	1397	1415617695000	3148	1637	0	0	\N
69687	1397	1415607694000	3148	1637	1	0	\N
69691	1397	1415617695000	3151	1637	0	0	\N
69692	1397	1415607694000	3151	1637	1	0	\N
69693	1397	1415597693000	3151	1637	2	0	\N
69694	1397	1415597693000	3152	1638	0	0	\N
69697	1397	1415567690000	3155	1641	0	0	\N
69699	1397	1415567690000	3157	1641	0	0	\N
69700	1397	1415567690000	3158	1641	0	0	\N
69701	1397	1415557689000	3159	1642	0	0	\N
69703	1397	1415557689000	3161	1642	0	0	\N
69704	1397	1415557689000	3162	1642	0	0	\N
69713	1397	1415477681000	3167	1646	0	0	\N
69715	1397	1415467680000	3169	1647	0	0	\N
69717	1397	1415457679000	3171	1648	0	0	\N
69718	1397	1415457679000	3172	1648	0	0	\N
69719	1397	1415457679000	3173	1648	0	0	\N
69720	1397	1415447678000	3174	1649	0	0	\N
69722	1706	5756591000000	3176	1531	0	0	\N
69723	1686	211805500013	3176	1531	1	0	\N
69724	1397	1415437677000	3177	1650	0	0	\N
69725	1397	1415427676000	3177	1650	1	0	\N
69728	1397	1415417675000	3179	1651	0	0	\N
69729	1397	1415407674000	3179	1651	1	0	\N
69732	1397	1415397673000	3181	1652	0	0	\N
69734	1397	1415397673000	3183	1652	0	0	\N
69736	1397	1415387672000	3185	1653	0	0	\N
69738	1397	1415367670000	3187	1655	0	0	\N
69739	1397	1415367670000	3188	1655	0	0	\N
69746	1397	1415317665000	3192	1657	0	0	\N
69748	1397	1415307664000	3194	1658	0	0	\N
69749	1397	1415307664000	3195	1658	0	0	\N
69751	1397	1415287662000	3197	1660	0	0	\N
69752	1397	1415277661000	3197	1660	1	0	\N
69755	1397	1415267660000	3199	1661	0	0	\N
69757	1397	1415257659000	3202	1663	0	0	\N
69758	1397	1415247658000	3202	1663	1	0	\N
69759	1397	1415237657000	3202	1663	2	0	\N
69760	1397	1415227656000	3202	1663	3	0	\N
69761	1397	1415217655000	3202	1663	4	0	\N
69762	1397	1415207654000	3202	1663	5	0	\N
69763	1397	1415197653000	3202	1663	6	0	\N
69635	1397	1415867720000	3124	1624	2	0	2297
69636	1770	0	3124	1624	3	0	13
69637	1397	1415857719000	3125	1625	0	0	2298
69638	1397	1415847718000	3125	1625	1	0	2299
69639	1397	1415837717000	3125	1625	2	0	2300
69641	1397	1415817715000	3128	1627	1	0	2302
69642	1397	1415807714000	3128	1627	2	0	2303
69643	1397	1415797713000	3128	1627	3	0	2304
69644	1397	1415787712000	3129	1628	0	0	2305
69659	1397	1415777711000	3132	1629	0	0	2306
69662	1397	1415757709000	3135	1631	0	0	2308
69669	1397	1415747708000	3139	1632	0	0	2309
69670	1397	1415737707000	3139	1632	1	0	2310
69671	1397	1415727706000	3139	1632	2	0	2311
69673	1397	1415707704000	3140	1633	0	0	2313
69674	1397	1415697703000	3140	1633	1	0	2314
69675	1397	1415687702000	3141	1634	0	0	2315
69676	1397	1415677701000	3141	1634	1	0	2316
69677	1397	1415667700000	3141	1634	2	0	2317
69679	1397	1415647698000	3141	1634	4	0	2319
69683	1397	1415637697000	3145	1635	0	0	2320
69685	1397	1415627696000	3147	1636	0	0	2321
69688	1397	1415617695000	3149	1637	0	0	2322
69689	1397	1415607694000	3149	1637	1	0	2323
69695	1397	1415587692000	3153	1639	0	0	2325
69696	1397	1415577691000	3154	1640	0	0	2326
69698	1397	1415567690000	3156	1641	0	0	2327
69702	1397	1415557689000	3160	1642	0	0	2328
69706	1397	1415537687000	3164	1644	0	0	2330
69707	1397	1415527686000	3165	1645	0	0	2331
69708	1397	1415517685000	3165	1645	1	0	2332
69709	1397	1415507684000	3165	1645	2	0	2333
69710	1397	1415497683000	3165	1645	3	0	2334
69712	1397	1415477681000	3166	1646	0	0	2336
69714	1397	1415467680000	3168	1647	0	0	2337
69716	1397	1415457679000	3170	1648	0	0	2338
69721	1397	1415447678000	3175	1649	0	0	2339
69726	1397	1415437677000	3178	1650	0	0	2340
69730	1397	1415417675000	3180	1651	0	0	2342
69731	1397	1415407674000	3180	1651	1	0	2343
69733	1397	1415397673000	3182	1652	0	0	2344
69735	1397	1415387672000	3184	1653	0	0	2345
69740	1397	1415367670000	3189	1655	0	0	2347
69741	1397	1415357669000	3190	1656	0	0	2348
69742	1397	1415347668000	3190	1656	1	0	2349
69743	1397	1415337667000	3190	1656	2	0	2350
69744	1397	1415327666000	3190	1656	3	0	2351
69747	1397	1415307664000	3193	1658	0	0	2353
69750	1397	1415297663000	3196	1659	0	0	2354
69753	1397	1415287662000	3198	1660	0	0	2355
69754	1397	1415277661000	3198	1660	1	0	2356
69756	1397	1415267660000	3200	1661	0	0	2357
69765	1397	1415247658000	3203	1663	1	0	2359
69766	1397	1415237657000	3203	1663	2	0	2360
69767	1397	1415227656000	3203	1663	3	0	2361
69768	1397	1415217655000	3203	1663	4	0	2362
69773	1397	1415167650000	3206	1666	0	0	\N
69774	1397	1415167650000	3207	1666	0	0	\N
69776	1397	1416307764000	3209	1554	0	0	\N
69777	1397	1416297763000	3209	1554	1	0	\N
69778	1397	1416287762000	3209	1554	2	0	\N
69779	1397	1416277761000	3209	1554	3	0	\N
69780	1397	1416267760000	3209	1554	4	0	\N
69781	1397	1416257759000	3209	1554	5	0	\N
69782	1397	1416247758000	3209	1554	6	0	\N
69783	1397	1416237757000	3209	1554	7	0	\N
69784	1397	1416227756000	3209	1554	8	0	\N
69785	1397	1416217755000	3209	1554	9	0	\N
69786	1397	1416207754000	3209	1554	10	0	\N
69787	1397	1416197753000	3209	1554	11	0	\N
69788	1397	1416187752000	3209	1554	12	0	\N
69789	1397	1416177751000	3209	1554	13	0	\N
69790	1397	1416167750000	3209	1554	14	0	\N
69791	1397	1416157749000	3209	1554	15	0	\N
69792	1397	1416147748000	3209	1554	16	0	\N
69793	1770	4034710760393	3209	1554	17	0	\N
69794	1397	1416137747000	3209	1554	18	0	\N
69795	1397	1416127746000	3209	1554	19	0	\N
69796	1397	1416117745000	3209	1554	20	0	\N
69797	1770	4034700364453	3209	1554	21	0	\N
69798	1770	4034690363513	3209	1554	22	0	\N
69799	1770	4034680362573	3209	1554	23	0	\N
69800	1770	4034670361633	3209	1554	24	0	\N
69801	1770	4034660360693	3209	1554	25	0	\N
69802	1770	3965244611203	3209	1554	26	0	\N
69803	1770	3895828861713	3209	1554	27	0	\N
69804	1770	3367360729145	3209	1554	28	0	\N
69805	1770	2420358283411	3209	1554	29	0	\N
69806	1770	1781393610117	3209	1554	30	0	\N
69807	1770	879600299	3209	1554	31	0	\N
69808	1770	0	3209	1554	32	0	\N
69809	1397	1416107744000	3209	1554	33	0	\N
69810	1397	1416097743000	3209	1554	34	0	\N
69811	1397	1416087742000	3209	1554	35	0	\N
69812	1397	1416077741000	3209	1554	36	0	\N
69813	1397	1416067740000	3209	1554	37	0	\N
69814	1397	1416057739000	3209	1554	38	0	\N
69815	1397	1416047738000	3209	1554	39	0	\N
69816	1397	1416037737000	3209	1554	40	0	\N
69817	1397	1416027736000	3209	1554	41	0	\N
69818	1397	1416017735000	3209	1554	42	0	\N
69819	1397	1416007734000	3209	1554	43	0	\N
69820	1397	1415997733000	3209	1554	44	0	\N
69821	1397	1415987732000	3209	1554	45	0	\N
69822	1397	1415977731000	3209	1554	46	0	\N
69823	1397	1415967730000	3209	1554	47	0	\N
69824	1397	1415957729000	3209	1554	48	0	\N
69825	1397	1415947728000	3209	1554	49	0	\N
69826	1397	1415937727000	3209	1554	50	0	\N
69827	1397	1415927726000	3209	1554	51	0	\N
69828	1397	1415917725000	3209	1554	52	0	\N
69829	1397	1415907724000	3209	1554	53	0	\N
69830	1397	1415897723000	3209	1554	54	0	\N
69831	1397	1415887722000	3209	1554	55	0	\N
69832	1397	1415877721000	3209	1554	56	0	\N
69833	1397	1415867720000	3209	1554	57	0	\N
69834	1397	1415857719000	3209	1554	58	0	\N
69835	1397	1415847718000	3209	1554	59	0	\N
69836	1397	1415837717000	3209	1554	60	0	\N
69837	1397	1415827716000	3209	1554	61	0	\N
69838	1397	1415817715000	3209	1554	62	0	\N
69839	1397	1415807714000	3209	1554	63	0	\N
69840	1397	1415797713000	3209	1554	64	0	\N
69841	1397	1415787712000	3209	1554	65	0	\N
69842	1397	1415777711000	3209	1554	66	0	\N
69843	1397	1415767710000	3209	1554	67	0	\N
69844	1397	1415757709000	3209	1554	68	0	\N
69845	1397	1415747708000	3209	1554	69	0	\N
69846	1397	1415737707000	3209	1554	70	0	\N
69847	1397	1415727706000	3209	1554	71	0	\N
69848	1397	1415717705000	3209	1554	73	0	\N
69849	1397	1415707704000	3209	1554	74	0	\N
69850	1397	1415697703000	3209	1554	75	0	\N
69851	1397	1415687702000	3209	1554	76	0	\N
69852	1397	1415677701000	3209	1554	77	0	\N
69853	1397	1415667700000	3209	1554	78	0	\N
69854	1397	1415657699000	3209	1554	79	0	\N
69855	1397	1415647698000	3209	1554	80	0	\N
69856	1397	1415637697000	3209	1554	81	0	\N
69857	1397	1415627696000	3209	1554	82	0	\N
69858	1397	1415617695000	3209	1554	83	0	\N
69859	1397	1415607694000	3209	1554	84	0	\N
69860	1397	1415597693000	3209	1554	85	0	\N
69861	1397	1415587692000	3209	1554	86	0	\N
69862	1397	1415577691000	3209	1554	87	0	\N
69863	1397	1415567690000	3209	1554	88	0	\N
69864	1397	1415557689000	3209	1554	89	0	\N
69865	1397	1415547688000	3209	1554	90	0	\N
69866	1397	1415537687000	3209	1554	91	0	\N
69867	1397	1415527686000	3209	1554	92	0	\N
69868	1397	1415517685000	3209	1554	93	0	\N
69869	1397	1415507684000	3209	1554	94	0	\N
69870	1397	1415497683000	3209	1554	95	0	\N
69871	1397	1415487682000	3209	1554	96	0	\N
69872	1397	1415477681000	3209	1554	97	0	\N
69873	1397	1415467680000	3209	1554	98	0	\N
69874	1397	1415457679000	3209	1554	99	0	\N
69875	1397	1415447678000	3209	1554	100	0	\N
69876	1397	1415437677000	3209	1554	101	0	\N
69877	1397	1415427676000	3209	1554	102	0	\N
69878	1397	1415417675000	3209	1554	103	0	\N
69879	1397	1415407674000	3209	1554	104	0	\N
69880	1397	1415397673000	3209	1554	105	0	\N
69881	1397	1415387672000	3209	1554	106	0	\N
69882	1397	1415377671000	3209	1554	107	0	\N
69883	1397	1415367670000	3209	1554	108	0	\N
69884	1397	1415357669000	3209	1554	109	0	\N
69885	1397	1415347668000	3209	1554	110	0	\N
69886	1397	1415337667000	3209	1554	111	0	\N
69887	1397	1415327666000	3209	1554	112	0	\N
69888	1397	1415317665000	3209	1554	113	0	\N
69889	1397	1415307664000	3209	1554	114	0	\N
69890	1397	1415297663000	3209	1554	115	0	\N
69891	1397	1415287662000	3209	1554	116	0	\N
69892	1397	1415277661000	3209	1554	117	0	\N
69893	1397	1415267660000	3209	1554	118	0	\N
69894	1397	1415257659000	3209	1554	119	0	\N
69895	1397	1415247658000	3209	1554	120	0	\N
69896	1397	1415237657000	3209	1554	121	0	\N
69897	1397	1415227656000	3209	1554	122	0	\N
69898	1397	1415217655000	3209	1554	123	0	\N
69899	1397	1415207654000	3209	1554	124	0	\N
69900	1397	1415197653000	3209	1554	125	0	\N
69771	1397	1415187652000	3204	1664	0	0	2365
69772	1397	1415177651000	3205	1665	0	0	2366
69775	1397	1415167650000	3208	1666	0	0	2367
69901	1397	1415157649000	3210	1667	0	0	2368
69902	1397	1415147648000	3210	1667	1	0	2369
69904	1397	1415127646000	3212	1669	0	0	2371
69908	1397	1415097643000	3215	1671	0	0	\N
69911	1397	1415087642000	3217	1672	0	0	\N
69912	1397	1415077641000	3217	1672	1	0	\N
69914	1397	1415067640000	3219	1673	0	0	\N
69915	1397	1415057639000	3220	1674	0	0	\N
69917	1397	1415057639000	3222	1674	0	0	\N
69918	1397	1415057639000	3223	1674	0	0	\N
69919	1397	1415057639000	3224	1674	0	0	\N
69920	1397	1415057639000	3225	1674	0	0	\N
69934	1706	6476491000000	3227	1675	0	0	\N
69935	1397	1415047638000	3227	1675	1	0	\N
69936	1397	1415037637000	3227	1675	2	0	\N
69937	1693	8907419262733	3227	1675	3	0	\N
69938	1693	8857631025012	3227	1675	4	0	\N
69939	1693	8807842787291	3227	1675	5	0	\N
69940	1693	8758054549570	3227	1675	6	0	\N
69941	1693	8708266311849	3227	1675	7	0	\N
69942	1693	8658478074128	3227	1675	8	0	\N
69943	1693	8505322183241	3227	1675	9	0	\N
69944	1693	8455533945520	3227	1675	10	0	\N
69945	1693	8454015514083	3227	1675	11	0	\N
69946	1693	8404227276362	3227	1675	12	0	\N
69947	1706	6476491000000	3228	1675	0	0	\N
69948	1397	1415047638000	3228	1675	1	0	\N
69949	1397	1415037637000	3228	1675	2	0	\N
69950	1693	8907419262733	3228	1675	3	0	\N
69951	1693	8857631025012	3228	1675	4	0	\N
69952	1693	8807842787291	3228	1675	5	0	\N
69953	1693	8758054549570	3228	1675	6	0	\N
69954	1693	8708266311849	3228	1675	7	0	\N
69955	1693	8658478074128	3228	1675	8	0	\N
69956	1693	8505322183241	3228	1675	9	0	\N
69957	1693	8455533945520	3228	1675	10	0	\N
69958	1693	8454015514083	3228	1675	11	0	\N
69959	1693	8404227276362	3228	1675	12	0	\N
69960	1706	6476491000000	3229	1675	0	0	\N
69961	1397	1415047638000	3229	1675	1	0	\N
69962	1397	1415037637000	3229	1675	2	0	\N
69963	1693	8907419262733	3229	1675	3	0	\N
69980	1706	5756591000000	3233	1551	0	0	\N
69981	1706	5756391000000	3233	1551	1	0	\N
69982	1686	211805500013	3233	1551	2	0	\N
69983	1397	1416877821000	3233	1551	3	0	\N
69984	1397	1416867820000	3233	1551	4	0	\N
69985	1397	1416857819000	3233	1551	5	0	\N
69986	1397	1416847818000	3233	1551	6	0	\N
69987	1397	1416837817000	3233	1551	7	0	\N
69988	1397	1416827816000	3233	1551	8	0	\N
69989	1397	1416817815000	3233	1551	9	0	\N
70002	1397	1414947628000	3236	1681	0	0	\N
70003	1397	1414947628000	3237	1681	0	0	\N
70023	1693	6592040458502	3240	1682	0	0	\N
70024	1693	6212839533730	3240	1682	1	0	\N
70025	1693	6163051296009	3240	1682	2	0	\N
70026	1693	6113263058288	3240	1682	3	0	\N
70027	1693	6063474820567	3240	1682	4	0	\N
70028	1693	6013686582846	3240	1682	5	0	\N
70029	1693	5963898345125	3240	1682	6	0	\N
70030	1693	5914110107404	3240	1682	7	0	\N
70031	1693	5908820597346	3240	1682	8	0	\N
70032	1693	5859032359625	3240	1682	9	0	\N
70033	1693	5809244121904	3240	1682	10	0	\N
70034	1693	5759455884183	3240	1682	11	0	\N
70035	1693	5709667646462	3240	1682	12	0	\N
70036	1397	1414937627000	3240	1682	13	0	\N
70037	1397	1414927626000	3240	1682	14	0	\N
70038	1397	1414917625000	3240	1682	15	0	\N
70039	1693	5659879408741	3240	1682	16	0	\N
70040	1693	5610091171020	3240	1682	17	0	\N
69907	1397	1415097643000	3214	1671	0	0	2374
69909	1397	1415087642000	3216	1672	0	0	2375
69910	1397	1415077641000	3216	1672	1	0	2376
69913	1397	1415067640000	3218	1673	0	0	2377
69916	1397	1415057639000	3221	1674	0	0	2378
69922	1397	1415047638000	3226	1675	1	0	2379
69923	1397	1415037637000	3226	1675	2	0	2380
69924	1693	8907419262733	3226	1675	3	0	119
69925	1693	8857631025012	3226	1675	4	0	120
69926	1693	8807842787291	3226	1675	5	0	121
69928	1693	8708266311849	3226	1675	7	0	123
69929	1693	8658478074128	3226	1675	8	0	124
69930	1693	8505322183241	3226	1675	9	0	125
69931	1693	8455533945520	3226	1675	10	0	126
69933	1693	8404227276362	3226	1675	12	0	128
69964	1397	1415027636000	3230	1676	0	0	2381
69965	1693	8354439038641	3230	1676	1	0	129
69966	1693	7674922150341	3230	1676	2	0	130
69967	1693	7625133912620	3230	1676	3	0	131
69969	1693	7525557437178	3230	1676	5	0	133
69970	1693	7475769199457	3231	1677	0	0	134
69971	1693	7425980961736	3231	1677	1	0	135
69972	1397	1415017635000	3231	1677	2	0	2382
69973	1397	1415007634000	3231	1677	3	0	2383
69975	1397	1414987632000	3232	1678	1	0	2385
69976	1693	7376192724015	3232	1678	2	0	136
69977	1693	7144772056121	3232	1678	3	0	137
69978	1693	7139711073433	3232	1678	4	0	138
69990	1693	7040134597991	3234	1679	0	0	140
69991	1693	6990346360270	3234	1679	1	0	141
69992	1693	6940558122549	3234	1679	2	0	142
69993	1397	1414977631000	3234	1679	3	0	2386
69994	1397	1414967630000	3234	1679	4	0	2387
69996	1693	6840981647107	3234	1679	6	0	144
69997	1693	6791193409386	3234	1679	7	0	145
69998	1397	1414957629000	3235	1680	0	0	2388
69999	1693	6741405171665	3235	1680	1	0	146
70000	1693	6691616933944	3235	1680	2	0	147
70004	1397	1414947628000	3238	1681	0	0	2389
70005	1693	6592040458502	3239	1682	0	0	149
70006	1693	6212839533730	3239	1682	1	0	150
70007	1693	6163051296009	3239	1682	2	0	151
70009	1693	6063474820567	3239	1682	4	0	153
70010	1693	6013686582846	3239	1682	5	0	154
70011	1693	5963898345125	3239	1682	6	0	155
70012	1693	5914110107404	3239	1682	7	0	156
70013	1693	5908820597346	3239	1682	8	0	157
70015	1693	5809244121904	3239	1682	10	0	159
70016	1693	5759455884183	3239	1682	11	0	160
70017	1693	5709667646462	3239	1682	12	0	161
70018	1397	1414937627000	3239	1682	13	0	2390
70019	1397	1414927626000	3239	1682	14	0	2391
70021	1693	5659879408741	3239	1682	16	0	162
70022	1693	5610091171020	3239	1682	17	0	163
70044	1397	1414907624000	3242	1683	0	0	\N
70045	1693	5560302933299	3242	1683	1	0	\N
70046	1693	5556521854688	3242	1683	2	0	\N
70048	1397	1414897623000	3244	1684	0	0	\N
70049	1397	1414887622000	3245	1685	0	0	\N
70050	1397	1414877621000	3245	1685	1	0	\N
70053	1706	6476491000000	3247	1675	0	0	\N
70054	1397	1415047638000	3247	1675	1	0	\N
70055	1397	1415037637000	3247	1675	2	0	\N
70056	1397	1415027636000	3247	1675	3	0	\N
70057	1397	1415017635000	3247	1675	4	0	\N
70058	1397	1415007634000	3247	1675	5	0	\N
70059	1397	1414997633000	3247	1675	6	0	\N
70060	1397	1414987632000	3247	1675	7	0	\N
70061	1397	1414977631000	3247	1675	8	0	\N
70062	1397	1414967630000	3247	1675	9	0	\N
70063	1397	1414957629000	3247	1675	10	0	\N
70064	1397	1414947628000	3247	1675	11	0	\N
70065	1397	1414937627000	3247	1675	12	0	\N
70066	1397	1414927626000	3247	1675	13	0	\N
70067	1397	1414917625000	3247	1675	14	0	\N
70068	1397	1414907624000	3247	1675	15	0	\N
70069	1397	1414897623000	3247	1675	16	0	\N
70070	1397	1414887622000	3247	1675	17	0	\N
70071	1397	1414877621000	3247	1675	18	0	\N
70072	1693	8907419262733	3247	1675	19	0	\N
70073	1693	8857631025012	3247	1675	20	0	\N
70074	1693	8807842787291	3247	1675	21	0	\N
70075	1693	8758054549570	3247	1675	22	0	\N
70076	1693	8708266311849	3247	1675	23	0	\N
70077	1693	8658478074128	3247	1675	24	0	\N
70078	1693	8505322183241	3247	1675	25	0	\N
70079	1693	8455533945520	3247	1675	26	0	\N
70080	1693	8454015514083	3247	1675	27	0	\N
70081	1693	8404227276362	3247	1675	28	0	\N
70082	1693	8354439038641	3247	1675	29	0	\N
70083	1693	7674922150341	3247	1675	30	0	\N
70084	1693	7625133912620	3247	1675	31	0	\N
70085	1693	7575345674899	3247	1675	32	0	\N
70086	1693	7525557437178	3247	1675	33	0	\N
70087	1693	7475769199457	3247	1675	34	0	\N
70088	1693	7425980961736	3247	1675	35	0	\N
70089	1693	7376192724015	3247	1675	36	0	\N
70090	1693	7144772056121	3247	1675	37	0	\N
70091	1693	7139711073433	3247	1675	38	0	\N
70092	1693	7089922835712	3247	1675	39	0	\N
70093	1693	7040134597991	3247	1675	40	0	\N
70094	1693	6990346360270	3247	1675	41	0	\N
70095	1693	6940558122549	3247	1675	42	0	\N
70096	1693	6890769884828	3247	1675	43	0	\N
70097	1693	6840981647107	3247	1675	44	0	\N
70098	1693	6791193409386	3247	1675	45	0	\N
70099	1693	6741405171665	3247	1675	46	0	\N
70100	1693	6691616933944	3247	1675	47	0	\N
70101	1693	6641828696223	3247	1675	48	0	\N
70102	1693	6592040458502	3247	1675	49	0	\N
70103	1693	6212839533730	3247	1675	50	0	\N
70104	1693	6163051296009	3247	1675	51	0	\N
70105	1693	6113263058288	3247	1675	52	0	\N
70106	1693	6063474820567	3247	1675	53	0	\N
70107	1693	6013686582846	3247	1675	54	0	\N
70108	1693	5963898345125	3247	1675	55	0	\N
70109	1693	5914110107404	3247	1675	56	0	\N
70110	1693	5908820597346	3247	1675	57	0	\N
70111	1693	5859032359625	3247	1675	58	0	\N
70112	1693	5809244121904	3247	1675	59	0	\N
70113	1693	5759455884183	3247	1675	60	0	\N
70114	1693	5709667646462	3247	1675	61	0	\N
70115	1693	5659879408741	3247	1675	62	0	\N
70116	1693	5610091171020	3247	1675	63	0	\N
70117	1693	5560302933299	3247	1675	64	0	\N
70118	1693	5556521854688	3247	1675	65	0	\N
70120	1397	1414857619000	3249	1687	0	0	\N
70127	1397	1414797613000	3254	1691	0	0	\N
70128	1397	1414787612000	3254	1691	1	0	\N
70129	1397	1414797613000	3255	1691	0	0	\N
70130	1397	1414787612000	3255	1691	1	0	\N
70134	1397	1414777611000	3258	1692	0	0	\N
70136	1397	1414757609000	3260	1694	0	0	\N
70143	1397	1414717605000	3263	1696	0	0	\N
70144	1397	1414717605000	3264	1696	0	0	\N
70147	1397	1414697603000	3267	1698	0	0	\N
70148	1397	1414697603000	3268	1698	0	0	\N
70150	1706	6476491000000	3270	1568	0	0	\N
70151	1693	8907419262733	3270	1568	1	0	\N
70152	1693	8857631025012	3270	1568	2	0	\N
70153	1693	8807842787291	3270	1568	3	0	\N
70154	1693	8758054549570	3270	1568	4	0	\N
70155	1693	8708266311849	3270	1568	5	0	\N
70156	1693	8658478074128	3270	1568	6	0	\N
70157	1693	8505322183241	3270	1568	7	0	\N
70158	1693	8455533945520	3270	1568	8	0	\N
70159	1693	8454015514083	3270	1568	9	0	\N
70160	1693	8404227276362	3270	1568	10	0	\N
70161	1693	8354439038641	3270	1568	11	0	\N
70162	1693	7674922150341	3270	1568	12	0	\N
70163	1693	7625133912620	3270	1568	13	0	\N
70164	1693	7575345674899	3270	1568	14	0	\N
70165	1693	7525557437178	3270	1568	15	0	\N
70166	1693	7475769199457	3270	1568	16	0	\N
70167	1693	7425980961736	3270	1568	17	0	\N
70168	1693	7376192724015	3270	1568	18	0	\N
70169	1693	7144772056121	3270	1568	19	0	\N
70170	1693	7139711073433	3270	1568	20	0	\N
70171	1693	7089922835712	3270	1568	21	0	\N
70172	1693	7040134597991	3270	1568	22	0	\N
70173	1693	6990346360270	3270	1568	23	0	\N
70174	1693	6940558122549	3270	1568	24	0	\N
70175	1693	6890769884828	3270	1568	25	0	\N
70176	1693	6840981647107	3270	1568	26	0	\N
70043	1693	5556521854688	3241	1683	2	0	165
70047	1397	1414897623000	3243	1684	0	0	2394
70051	1397	1414887622000	3246	1685	0	0	2395
70052	1397	1414877621000	3246	1685	1	0	2396
70119	1397	1414867620000	3248	1686	0	0	2397
70122	1397	1414847618000	3251	1688	0	0	2399
70123	1397	1414837617000	3251	1688	1	0	2400
70124	1397	1414827616000	3252	1689	0	0	2401
70125	1397	1414817615000	3252	1689	1	0	2402
70126	1397	1414807614000	3253	1690	0	0	2403
70132	1397	1414787612000	3256	1691	1	0	2405
70133	1397	1414777611000	3257	1692	0	0	2406
70135	1397	1414767610000	3259	1693	0	0	2407
70137	1397	1414757609000	3261	1694	0	0	2408
70139	1693	5505215185530	3262	1695	1	0	167
70140	1397	1414747608000	3262	1695	2	0	2409
70141	1397	1414737607000	3262	1695	3	0	2410
70142	1397	1414727606000	3262	1695	4	0	2411
70145	1397	1414717605000	3265	1696	0	0	2412
70149	1397	1414697603000	3269	1698	0	0	2414
70177	1693	6791193409386	3270	1568	27	0	\N
70178	1693	6741405171665	3270	1568	28	0	\N
70179	1693	6691616933944	3270	1568	29	0	\N
70180	1693	6641828696223	3270	1568	30	0	\N
70181	1693	6592040458502	3270	1568	31	0	\N
70182	1693	6212839533730	3270	1568	32	0	\N
70183	1693	6163051296009	3270	1568	33	0	\N
70184	1693	6113263058288	3270	1568	34	0	\N
70185	1693	6063474820567	3270	1568	35	0	\N
70186	1693	6013686582846	3270	1568	36	0	\N
70187	1693	5963898345125	3270	1568	37	0	\N
70188	1693	5914110107404	3270	1568	38	0	\N
70189	1693	5908820597346	3270	1568	39	0	\N
70190	1693	5859032359625	3270	1568	40	0	\N
70191	1693	5809244121904	3270	1568	41	0	\N
70192	1693	5759455884183	3270	1568	42	0	\N
70193	1693	5709667646462	3270	1568	43	0	\N
70194	1693	5659879408741	3270	1568	44	0	\N
70195	1693	5610091171020	3270	1568	45	0	\N
70196	1693	5560302933299	3270	1568	46	0	\N
70197	1693	5556521854688	3270	1568	47	0	\N
70198	1693	5555003423251	3270	1568	48	0	\N
70199	1693	5505215185530	3270	1568	49	0	\N
70200	1397	1414687602000	3271	1699	0	0	\N
70201	1397	1414677601000	3271	1699	1	0	\N
70206	1397	1414667600000	3274	1700	0	0	\N
70207	1397	1414657599000	3274	1700	1	0	\N
70213	1693	5455426947809	3277	1702	0	0	\N
70214	1397	1414637597000	3277	1702	1	0	\N
70215	1693	5405638710088	3277	1702	2	0	\N
70216	1693	5355850472367	3277	1702	3	0	\N
70217	1693	5455426947809	3278	1702	0	0	\N
70218	1397	1414637597000	3278	1702	1	0	\N
70219	1693	5405638710088	3278	1702	2	0	\N
70220	1693	5355850472367	3278	1702	3	0	\N
70230	1397	1414567590000	3283	1706	0	0	\N
70231	1397	1414557589000	3283	1706	1	0	\N
70232	1397	1414547588000	3283	1706	2	0	\N
70235	1397	1414537587000	3285	1707	0	0	\N
70236	1693	5306062234646	3285	1707	1	0	\N
70237	877	203061162331632	3286	1708	0	0	\N
70238	1693	5256273996925	3286	1708	1	0	\N
70239	1693	5206485759204	3286	1708	2	0	\N
70240	1693	5156697521483	3286	1708	3	0	\N
70241	1693	5106909283762	3286	1708	4	0	\N
70242	1693	5057121046041	3286	1708	5	0	\N
70243	1693	5007332808320	3286	1708	6	0	\N
70244	1397	1414527586000	3286	1708	7	0	\N
70253	877	203061162331632	3288	1708	0	0	\N
70254	1693	5256273996925	3288	1708	1	0	\N
70255	1693	5206485759204	3288	1708	2	0	\N
70256	1693	5156697521483	3288	1708	3	0	\N
70257	1693	5106909283762	3288	1708	4	0	\N
70258	1693	5057121046041	3288	1708	5	0	\N
70259	1693	5007332808320	3288	1708	6	0	\N
70260	1397	1414527586000	3288	1708	7	0	\N
70261	877	203061162331632	3291	1708	0	0	\N
70262	1693	5256273996925	3291	1708	1	0	\N
70263	1693	5206485759204	3291	1708	2	0	\N
70264	1693	5156697521483	3291	1708	3	0	\N
70265	1693	5106909283762	3291	1708	4	0	\N
70266	1693	5057121046041	3291	1708	5	0	\N
70267	1693	5007332808320	3291	1708	6	0	\N
70268	1693	4957544570599	3291	1708	7	0	\N
70269	1693	4908263165845	3291	1708	8	0	\N
70270	1693	4858474928124	3291	1708	9	0	\N
70271	1693	4808686690403	3291	1708	10	0	\N
70272	1397	1414527586000	3291	1708	11	0	\N
70273	1397	1414517585000	3291	1708	12	0	\N
70280	1397	1414507584000	3297	1709	0	0	\N
70281	1397	1414497583000	3297	1709	1	0	\N
70284	1397	1414477581000	3299	1712	0	0	\N
70285	1397	1414467580000	3299	1712	1	0	\N
70292	1693	4350199852735	3302	1713	0	0	\N
70293	1693	4300411615014	3302	1713	1	0	\N
70294	1693	4250623377293	3302	1713	2	0	\N
70295	1397	1414457579000	3302	1713	3	0	\N
70304	1397	1414417575000	3307	1717	0	0	\N
70305	1397	1414417575000	3308	1717	0	0	\N
70306	1397	1414417575000	3309	1717	0	0	\N
70308	1397	1414407574000	3311	1718	0	0	\N
70311	1396	20000000	3313	1719	0	0	\N
70312	1397	1414397573000	3313	1719	1	0	\N
70204	1397	1414667600000	3273	1700	0	0	2417
70205	1397	1414657599000	3273	1700	1	0	2418
70208	1397	1414647598000	3275	1701	0	0	2419
70209	1693	5455426947809	3276	1702	0	0	168
70210	1397	1414637597000	3276	1702	1	0	2420
70212	1693	5355850472367	3276	1702	3	0	170
70221	1397	1414627596000	3279	1703	0	0	2421
70222	1397	1414617595000	3279	1703	1	0	2422
70223	1397	1414607594000	3280	1704	0	0	2423
70224	1397	1414597593000	3280	1704	1	0	2424
70226	1397	1414577591000	3281	1705	1	0	2426
70227	1397	1414567590000	3282	1706	0	0	2427
70228	1397	1414557589000	3282	1706	1	0	2428
70229	1397	1414547588000	3282	1706	2	0	2429
70234	1693	5306062234646	3284	1707	1	0	171
70245	877	203061162331632	3287	1708	0	0	1
70246	1693	5256273996925	3287	1708	1	0	172
70247	1693	5206485759204	3287	1708	2	0	173
70248	1693	5156697521483	3287	1708	3	0	174
70250	1693	5057121046041	3287	1708	5	0	176
70251	1693	5007332808320	3287	1708	6	0	177
70252	1397	1414527586000	3287	1708	7	0	2431
70274	1693	4957544570599	3293	1709	0	0	178
70275	1693	4908263165845	3293	1709	1	0	179
70277	1693	4808686690403	3293	1709	3	0	181
70278	1397	1414517585000	3293	1709	4	0	2432
70279	1397	1414507584000	3296	1710	0	0	2433
70282	1397	1414497583000	3298	1711	0	0	2434
70286	1397	1414477581000	3300	1712	0	0	2436
70287	1397	1414467580000	3300	1712	1	0	2437
70288	1693	4350199852735	3301	1713	0	0	182
70289	1693	4300411615014	3301	1713	1	0	183
70290	1693	4250623377293	3301	1713	2	0	184
70296	1397	1414447578000	3303	1714	0	0	2439
70297	1702	2874030000000	3303	1714	1	0	1
70298	1396	718420000000	3305	1716	0	0	1
70299	1396	716820000000	3305	1716	1	0	2
70300	1699	1905970500039	3305	1716	2	0	2
70302	1397	1414427576000	3305	1716	4	0	2441
70303	1397	1414417575000	3306	1717	0	0	2442
70307	1397	1414407574000	3310	1718	0	0	2443
70309	1396	20000000	3312	1719	0	0	3
70313	1396	20000000	3314	1719	0	0	\N
70314	1397	1414397573000	3314	1719	1	0	\N
70315	1397	1414387572000	3315	1720	0	0	\N
70316	1397	1414377571000	3315	1720	1	0	\N
70317	1397	1414387572000	3316	1720	0	0	\N
70318	1397	1414377571000	3316	1720	1	0	\N
70321	1397	1414387572000	3318	1720	0	0	\N
70322	1397	1414377571000	3318	1720	1	0	\N
70325	1397	1414367570000	3320	1721	0	0	\N
70326	1693	4200835139572	3320	1721	1	0	\N
70336	1397	1414347568000	3322	1723	0	0	\N
70337	1397	1414337567000	3322	1723	1	0	\N
70338	1693	3777963482302	3322	1723	2	0	\N
70339	1693	2500367008662	3322	1723	3	0	\N
70340	1693	2450578770941	3322	1723	4	0	\N
70341	1693	2400790533220	3322	1723	5	0	\N
70342	1693	2351002295499	3322	1723	6	0	\N
70343	1693	2301214057778	3322	1723	7	0	\N
70344	1693	2251425820057	3322	1723	8	0	\N
70345	1693	2201637582336	3322	1723	9	0	\N
70346	1693	2151849344615	3322	1723	10	0	\N
70347	1693	2102061106894	3322	1723	11	0	\N
70348	1693	2052272869173	3322	1723	12	0	\N
70349	1693	2002484631452	3322	1723	13	0	\N
70350	1693	1994932474229	3322	1723	14	0	\N
70351	1693	1763511806335	3322	1723	15	0	\N
70352	1693	1713723568614	3322	1723	16	0	\N
70353	1693	1663935330893	3322	1723	17	0	\N
70354	1693	1614147093172	3322	1723	18	0	\N
70374	1397	1414327566000	3324	1724	0	0	\N
70375	114	66004490000000	3324	1724	1	0	\N
70376	114	66003980000000	3324	1724	2	0	\N
70377	114	66003470000000	3324	1724	3	0	\N
70378	114	66003260000000	3324	1724	4	0	\N
70394	1397	1414327566000	3329	1724	0	0	\N
70395	1397	1414317565000	3329	1724	1	0	\N
70396	114	66004490000000	3329	1724	2	0	\N
70397	114	66003980000000	3329	1724	3	0	\N
70398	1397	1414307564000	3329	1724	4	0	\N
70399	1397	1414297563000	3329	1724	5	0	\N
70400	1397	1414287562000	3329	1724	6	0	\N
70401	1773	8738330301113	3329	1724	7	0	\N
70402	1773	8635694835210	3329	1724	8	0	\N
70403	114	66003470000000	3329	1724	9	0	\N
70404	114	66003260000000	3329	1724	10	0	\N
70405	114	66002750000000	3329	1724	11	0	\N
70408	1396	718420000000	3331	1709	0	0	\N
70409	1396	716820000000	3331	1709	1	0	\N
70410	1396	20000000	3331	1709	2	0	\N
70411	1699	1905970500039	3331	1709	3	0	\N
70412	1702	2874030000000	3331	1709	4	0	\N
70417	1397	1414267560000	3333	1729	0	0	\N
70418	114	66002740000000	3333	1729	1	0	\N
70419	1397	1414257559000	3333	1729	2	0	\N
70420	10	32558990000000	3333	1729	3	0	\N
70425	283	66000490000000	3336	1732	0	0	\N
70426	1397	1414217555000	3336	1732	1	0	\N
70427	1397	1414207554000	3336	1732	2	0	\N
70436	1397	1414157549000	3340	1735	0	0	\N
70438	1397	1414147548000	3342	1736	0	0	\N
70439	1397	1414137547000	3342	1736	1	0	\N
70440	1750	7498000000	3342	1736	2	0	\N
70445	1397	1414117545000	3345	1738	0	0	\N
70446	1693	1564358855451	3345	1738	1	0	\N
70447	1693	1514570617730	3345	1738	2	0	\N
70448	1693	1464782380009	3345	1738	3	0	\N
70323	1397	1414367570000	3319	1721	0	0	2447
70324	1693	4200835139572	3319	1721	1	0	185
70327	1397	1414357569000	3321	1722	0	0	2448
70328	1693	4151046901851	3321	1722	1	0	186
70329	1693	4101258664130	3321	1722	2	0	187
70331	1693	4001682188688	3321	1722	4	0	189
70332	1693	3951893950967	3321	1722	5	0	190
70333	1693	3902105713246	3321	1722	6	0	191
70334	1693	3877539957744	3321	1722	7	0	192
70335	1693	3827751720023	3321	1722	8	0	193
70356	1397	1414337567000	3323	1723	1	0	2450
70357	1693	3777963482302	3323	1723	2	0	194
70358	1693	2500367008662	3323	1723	3	0	195
70359	1693	2450578770941	3323	1723	4	0	196
70361	1693	2351002295499	3323	1723	6	0	198
70362	1693	2301214057778	3323	1723	7	0	199
70363	1693	2251425820057	3323	1723	8	0	200
70364	1693	2201637582336	3323	1723	9	0	201
70365	1693	2151849344615	3323	1723	10	0	202
70367	1693	2052272869173	3323	1723	12	0	204
70368	1693	2002484631452	3323	1723	13	0	205
70369	1693	1994932474229	3323	1723	14	0	206
70370	1693	1763511806335	3323	1723	15	0	207
70371	1693	1713723568614	3323	1723	16	0	208
70373	1693	1614147093172	3323	1723	18	0	210
70379	1397	1414327566000	3325	1724	0	0	2451
70380	114	66004490000000	3325	1724	1	0	1
70381	114	66003980000000	3325	1724	2	0	2
70383	114	66003260000000	3325	1724	4	0	4
70384	1397	1414317565000	3326	1725	0	0	2452
70385	114	66002750000000	3327	1726	0	0	5
70386	1397	1414307564000	3327	1726	1	0	2453
70387	1397	1414297563000	3328	1727	0	0	2454
70389	1773	8635694835210	3328	1727	2	0	2
70390	1773	7464006184587	3328	1727	3	0	3
70391	1773	5364358081609	3328	1727	4	0	4
70392	1773	3947680415286	3328	1727	5	0	5
70393	1773	0	3328	1727	6	0	6
70407	1397	1414277561000	3330	1728	1	0	2456
70413	1397	1414267560000	3332	1729	0	0	2457
70414	114	66002740000000	3332	1729	1	0	6
70415	1397	1414257559000	3332	1729	2	0	2458
70421	301	66000490000000	3334	1730	0	0	1
70422	1397	1414247558000	3334	1730	1	0	2459
70423	1397	1414237557000	3334	1730	2	0	2460
70424	1397	1414227556000	3335	1731	0	0	2461
70428	283	66000490000000	3337	1732	0	0	1
70430	1397	1414207554000	3337	1732	2	0	2463
70431	1397	1414197553000	3338	1733	0	0	2464
70432	1750	7499000000	3338	1733	1	0	1
70433	1397	1414187552000	3339	1734	0	0	2465
70434	1397	1414177551000	3339	1734	1	0	2466
70437	1397	1414157549000	3341	1735	0	0	2468
70441	1397	1414147548000	3343	1736	0	0	2469
70442	1397	1414137547000	3343	1736	1	0	2470
70443	1750	7498000000	3343	1736	2	0	2
70449	1693	1414994142288	3345	1738	5	0	\N
70450	1693	1365205904567	3345	1738	6	0	\N
70467	1693	799253170035	3348	1740	0	0	\N
70468	1693	749464932314	3348	1740	1	0	\N
70469	1693	747946500877	3348	1740	2	0	\N
70470	1397	1414097543000	3348	1740	3	0	\N
70471	1750	6397000000	3348	1740	4	0	\N
70477	1396	718420000000	3350	1532	0	0	\N
70478	1396	716820000000	3350	1532	1	0	\N
70479	1396	20000000	3350	1532	2	0	\N
70480	1706	5756391000000	3350	1532	3	0	\N
70481	1699	1905970500039	3350	1532	4	0	\N
70482	1702	2154020000000	3350	1532	5	0	\N
70483	1693	7467389262733	3350	1532	6	0	\N
70484	1693	7417601025012	3350	1532	7	0	\N
70485	1693	7367812787291	3350	1532	8	0	\N
70486	1693	7318024549570	3350	1532	9	0	\N
70487	1693	7268236311849	3350	1532	10	0	\N
70488	1693	7218448074128	3350	1532	11	0	\N
70489	1693	7065292183241	3350	1532	12	0	\N
70490	1693	7015503945520	3350	1532	13	0	\N
70491	1693	7013985514083	3350	1532	14	0	\N
70492	1693	6964197276362	3350	1532	15	0	\N
70493	1693	6914409038641	3350	1532	16	0	\N
70494	1693	6234892150341	3350	1532	17	0	\N
70495	1693	6185103912620	3350	1532	18	0	\N
70496	1693	6135315674899	3350	1532	19	0	\N
70497	1693	6085527437178	3350	1532	20	0	\N
70498	1693	6035739199457	3350	1532	21	0	\N
70499	1693	5985950961736	3350	1532	22	0	\N
70500	1693	5936162724015	3350	1532	23	0	\N
70501	1693	5704742056121	3350	1532	24	0	\N
70502	1693	5699681073433	3350	1532	25	0	\N
70503	1693	5649892835712	3350	1532	26	0	\N
70504	1693	5600104597991	3350	1532	27	0	\N
70505	1693	5550316360270	3350	1532	28	0	\N
70506	1693	5500528122549	3350	1532	29	0	\N
70507	1693	5450739884828	3350	1532	30	0	\N
70508	1693	5400951647107	3350	1532	31	0	\N
70509	1693	5351163409386	3350	1532	32	0	\N
70510	1693	5301375171665	3350	1532	33	0	\N
70511	1693	5251586933944	3350	1532	34	0	\N
70512	1693	5201798696223	3350	1532	35	0	\N
70513	1693	5152010458502	3350	1532	36	0	\N
70514	1693	4772809533730	3350	1532	37	0	\N
70515	1693	4723021296009	3350	1532	38	0	\N
70516	1693	4673233058288	3350	1532	39	0	\N
70517	1693	4623444820567	3350	1532	40	0	\N
70518	1693	4573656582846	3350	1532	41	0	\N
70519	1693	4523868345125	3350	1532	42	0	\N
70520	1693	4474080107404	3350	1532	43	0	\N
70521	1693	4468790597346	3350	1532	44	0	\N
70522	1693	4419002359625	3350	1532	45	0	\N
70523	1693	4369214121904	3350	1532	46	0	\N
70524	1693	4319425884183	3350	1532	47	0	\N
70525	1693	4269637646462	3350	1532	48	0	\N
70526	1693	4219849408741	3350	1532	49	0	\N
70527	1693	4170061171020	3350	1532	50	0	\N
70528	1693	4120272933299	3350	1532	51	0	\N
70529	1693	4116491854688	3350	1532	52	0	\N
70530	1693	4114973423251	3350	1532	53	0	\N
70531	1693	4065185185530	3350	1532	54	0	\N
70532	1693	4015396947809	3350	1532	55	0	\N
70533	1693	3965608710088	3350	1532	56	0	\N
70534	1693	3915820472367	3350	1532	57	0	\N
70535	1693	3866032234646	3350	1532	58	0	\N
70536	1693	3816243996925	3350	1532	59	0	\N
70537	1693	3766455759204	3350	1532	60	0	\N
70538	1693	3716667521483	3350	1532	61	0	\N
70539	1693	3666879283762	3350	1532	62	0	\N
70540	1693	3617091046041	3350	1532	63	0	\N
70541	1693	3567302808320	3350	1532	64	0	\N
70542	1693	3517514570599	3350	1532	65	0	\N
70543	1693	3468233165845	3350	1532	66	0	\N
70544	1693	3418444928124	3350	1532	67	0	\N
70545	1693	3368656690403	3350	1532	68	0	\N
70546	1693	2910169852735	3350	1532	69	0	\N
70547	1693	2860381615014	3350	1532	70	0	\N
70548	1693	2810593377293	3350	1532	71	0	\N
70549	1693	2760805139572	3350	1532	72	0	\N
70550	1693	2711016901851	3350	1532	73	0	\N
70551	1693	2661228664130	3350	1532	74	0	\N
70552	1693	2611440426409	3350	1532	75	0	\N
70553	1693	2561652188688	3350	1532	76	0	\N
70554	1693	2511863950967	3350	1532	77	0	\N
70555	1693	2462075713246	3350	1532	78	0	\N
70556	1397	1414087542000	3351	1741	0	0	\N
70565	1397	1414047538000	3355	1743	0	0	\N
70566	1397	1414037537000	3355	1743	1	0	\N
70567	1396	718420000000	3356	1648	0	0	\N
70568	1396	716820000000	3356	1648	1	0	\N
70569	1396	20000000	3356	1648	2	0	\N
70570	1706	6476491000000	3356	1648	3	0	\N
70571	1699	1905970500039	3356	1648	4	0	\N
70572	1702	2154020000000	3356	1648	5	0	\N
70573	1693	8907419262733	3356	1648	6	0	\N
70574	1693	8857631025012	3356	1648	7	0	\N
70575	1693	8807842787291	3356	1648	8	0	\N
70576	1693	8758054549570	3356	1648	9	0	\N
70577	1693	8708266311849	3356	1648	10	0	\N
70578	1693	8658478074128	3356	1648	11	0	\N
70579	1693	8505322183241	3356	1648	12	0	\N
70580	1693	8455533945520	3356	1648	13	0	\N
70581	1693	8454015514083	3356	1648	14	0	\N
70582	1693	8404227276362	3356	1648	15	0	\N
70583	1693	8354439038641	3356	1648	16	0	\N
70584	1693	7674922150341	3356	1648	17	0	\N
70453	1693	1514570617730	3346	1738	2	0	212
70454	1693	1464782380009	3346	1738	3	0	213
70455	1693	1414994142288	3346	1738	5	0	214
70456	1693	1365205904567	3346	1738	6	0	215
70457	1397	1414107544000	3347	1739	0	0	2473
70459	1693	1300926724969	3347	1739	2	0	217
70460	1693	1251138487248	3347	1739	3	0	218
70461	1693	1201350249527	3347	1739	4	0	219
70462	1693	1151562011806	3347	1739	5	0	220
70463	1693	1101773774085	3347	1739	6	0	221
70465	1693	1002197298643	3347	1739	8	0	223
70466	1693	952409060922	3347	1739	9	0	224
70472	1693	799253170035	3349	1740	0	0	225
70473	1693	749464932314	3349	1740	1	0	226
70475	1397	1414097543000	3349	1740	3	0	2474
70476	1750	6397000000	3349	1740	4	0	3
70557	878	203062162331632	3352	1741	0	0	1
70558	1397	1414087542000	3352	1741	1	0	2475
70559	1397	1414077541000	3352	1741	2	0	2476
70561	1397	1414067540000	3353	1742	1	0	2477
70562	1397	1414057539000	3353	1742	2	0	2478
70563	1397	1414047538000	3354	1743	0	0	2479
70564	1397	1414037537000	3354	1743	1	0	2480
70585	1693	7625133912620	3356	1648	18	0	\N
70586	1693	7575345674899	3356	1648	19	0	\N
70587	1693	7525557437178	3356	1648	20	0	\N
70588	1693	7475769199457	3356	1648	21	0	\N
70589	1693	7425980961736	3356	1648	22	0	\N
70590	1693	7376192724015	3356	1648	23	0	\N
70591	1693	7144772056121	3356	1648	24	0	\N
70592	1693	7139711073433	3356	1648	25	0	\N
70593	1693	7089922835712	3356	1648	26	0	\N
70594	1693	7040134597991	3356	1648	27	0	\N
70595	1693	6990346360270	3356	1648	28	0	\N
70596	1693	6940558122549	3356	1648	29	0	\N
70597	1693	6890769884828	3356	1648	30	0	\N
70598	1693	6840981647107	3356	1648	31	0	\N
70599	1693	6791193409386	3356	1648	32	0	\N
70600	1693	6741405171665	3356	1648	33	0	\N
70601	1693	6691616933944	3356	1648	34	0	\N
70602	1693	6641828696223	3356	1648	35	0	\N
70603	1693	6592040458502	3356	1648	36	0	\N
70604	1693	6212839533730	3356	1648	37	0	\N
70605	1693	6163051296009	3356	1648	38	0	\N
70606	1693	6113263058288	3356	1648	39	0	\N
70607	1693	6063474820567	3356	1648	40	0	\N
70608	1693	6013686582846	3356	1648	41	0	\N
70609	1693	5963898345125	3356	1648	42	0	\N
70610	1693	5914110107404	3356	1648	43	0	\N
70611	1693	5908820597346	3356	1648	44	0	\N
70612	1693	5859032359625	3356	1648	45	0	\N
70613	1693	5809244121904	3356	1648	46	0	\N
70614	1693	5759455884183	3356	1648	47	0	\N
70616	1397	1414027536000	3358	1744	0	0	\N
70624	1397	1413957529000	3364	1749	0	0	\N
70629	1397	1413907524000	3368	1753	0	0	\N
70630	1397	1413897523000	3368	1753	1	0	\N
70631	1396	718420000000	3369	1703	0	0	\N
70632	1396	716820000000	3369	1703	1	0	\N
70633	1396	20000000	3369	1703	2	0	\N
70634	1699	1905970500039	3369	1703	3	0	\N
70635	877	203061162331632	3369	1703	4	0	\N
70636	1693	5306062234646	3369	1703	5	0	\N
70637	1702	2874030000000	3369	1703	6	0	\N
70638	1693	5256273996925	3369	1703	7	0	\N
70639	1693	5206485759204	3369	1703	8	0	\N
70640	1693	5156697521483	3369	1703	9	0	\N
70641	1693	5106909283762	3369	1703	10	0	\N
70642	1693	5057121046041	3369	1703	11	0	\N
70643	1693	5007332808320	3369	1703	12	0	\N
70644	1693	4957544570599	3369	1703	13	0	\N
70645	1693	4908263165845	3369	1703	14	0	\N
70646	1693	4858474928124	3369	1703	15	0	\N
70647	1693	4808686690403	3369	1703	16	0	\N
70648	1693	4350199852735	3369	1703	17	0	\N
70649	1693	4300411615014	3369	1703	18	0	\N
70650	1693	4250623377293	3369	1703	19	0	\N
70651	1397	1414627596000	3369	1703	20	0	\N
70652	1397	1414617595000	3369	1703	21	0	\N
70653	1397	1414607594000	3369	1703	22	0	\N
70654	1397	1414597593000	3369	1703	23	0	\N
70655	1397	1414587592000	3369	1703	24	0	\N
70656	1397	1414577591000	3369	1703	25	0	\N
70657	1397	1414567590000	3369	1703	26	0	\N
70658	1397	1414557589000	3369	1703	27	0	\N
70659	1397	1414547588000	3369	1703	28	0	\N
70660	1397	1414537587000	3369	1703	29	0	\N
70661	1397	1414527586000	3369	1703	30	0	\N
70662	1397	1414517585000	3369	1703	31	0	\N
70663	1397	1414507584000	3369	1703	32	0	\N
70664	1397	1414497583000	3369	1703	33	0	\N
70665	1397	1414487582000	3369	1703	34	0	\N
70666	1397	1414477581000	3369	1703	35	0	\N
70667	1397	1414467580000	3369	1703	36	0	\N
70668	1397	1414457579000	3369	1703	37	0	\N
70669	1397	1414447578000	3369	1703	38	0	\N
70670	1397	1414437577000	3369	1703	39	0	\N
70671	1397	1414427576000	3369	1703	40	0	\N
70672	1397	1414417575000	3369	1703	41	0	\N
70673	1397	1414407574000	3369	1703	42	0	\N
70674	1397	1414397573000	3369	1703	43	0	\N
70675	1397	1414387572000	3369	1703	44	0	\N
70676	1397	1414377571000	3369	1703	45	0	\N
70677	1397	1414367570000	3369	1703	46	0	\N
70678	1397	1414357569000	3369	1703	47	0	\N
70679	1397	1414347568000	3369	1703	48	0	\N
70680	1397	1414337567000	3369	1703	49	0	\N
70681	1397	1414327566000	3369	1703	50	0	\N
70682	1397	1414317565000	3369	1703	51	0	\N
70683	1397	1414307564000	3369	1703	52	0	\N
70684	1397	1414297563000	3369	1703	53	0	\N
70685	1397	1414287562000	3369	1703	54	0	\N
70686	1397	1414277561000	3369	1703	55	0	\N
70687	1397	1414267560000	3369	1703	56	0	\N
70688	1397	1414257559000	3369	1703	57	0	\N
70689	1397	1414247558000	3369	1703	58	0	\N
70690	1397	1414237557000	3369	1703	60	0	\N
70693	1397	1413887522000	3371	1754	0	0	\N
70702	1397	1413837517000	3375	1756	0	0	\N
70703	1397	1413827516000	3375	1756	1	0	\N
70704	1396	718420000000	3376	1611	0	0	\N
70705	1396	716820000000	3376	1611	1	0	\N
70706	1396	20000000	3376	1611	2	0	\N
70707	1706	6476491000000	3376	1611	3	0	\N
70708	1699	1905970500039	3376	1611	4	0	\N
70709	1397	1416117745000	3376	1611	5	0	\N
70710	1770	4034690363513	3376	1611	6	0	\N
70711	1770	4034680362573	3376	1611	7	0	\N
70712	1702	2154020000000	3376	1611	8	0	\N
70713	1770	4034670361633	3376	1611	9	0	\N
70714	1770	4034660360693	3376	1611	10	0	\N
70715	1770	3965244611203	3376	1611	11	0	\N
70716	1770	3895828861713	3376	1611	12	0	\N
70717	1770	3367360729145	3376	1611	13	0	\N
70718	1770	2420358283411	3376	1611	14	0	\N
70719	1770	1781393610117	3376	1611	15	0	\N
70720	1770	879600299	3376	1611	16	0	\N
70618	1397	1414007534000	3360	1746	0	0	2483
70619	1397	1413997533000	3360	1746	1	0	2484
70620	1397	1413987532000	3361	1747	0	0	2485
70621	1397	1413977531000	3361	1747	1	0	2486
70622	1397	1413967530000	3362	1748	0	0	2487
70625	1397	1413947528000	3365	1750	0	0	2489
70626	1397	1413937527000	3365	1750	1	0	2490
70627	1397	1413927526000	3366	1751	0	0	2491
70628	1397	1413917525000	3367	1752	0	0	2492
70691	1397	1413907524000	3370	1753	0	0	2493
70694	1397	1413887522000	3372	1754	0	0	2495
70695	1397	1413877521000	3373	1755	0	0	2496
70696	1397	1413867520000	3373	1755	1	0	2497
70697	1397	1413857519000	3373	1755	2	0	2498
70699	436	66719690000000	3373	1755	4	0	1
70700	1397	1413837517000	3374	1756	0	0	2500
70701	1397	1413827516000	3374	1756	1	0	2501
70721	1770	0	3376	1611	17	0	\N
70722	1397	1416107744000	3376	1611	18	0	\N
70723	1397	1416097743000	3376	1611	19	0	\N
70724	1397	1416087742000	3376	1611	20	0	\N
70725	1397	1416077741000	3376	1611	21	0	\N
70726	1397	1416067740000	3376	1611	22	0	\N
70727	1397	1416057739000	3376	1611	23	0	\N
70728	1397	1416047738000	3376	1611	24	0	\N
70729	1397	1416037737000	3376	1611	25	0	\N
70730	1397	1416027736000	3376	1611	26	0	\N
70731	1397	1416017735000	3376	1611	27	0	\N
70732	1397	1416007734000	3376	1611	28	0	\N
70733	1397	1415997733000	3376	1611	29	0	\N
70734	1397	1415987732000	3376	1611	30	0	\N
70735	1397	1415977731000	3376	1611	31	0	\N
70736	1397	1415967730000	3376	1611	32	0	\N
70737	1397	1415957729000	3376	1611	33	0	\N
70738	1397	1415947728000	3376	1611	34	0	\N
70739	1397	1415937727000	3376	1611	35	0	\N
70740	1397	1415927726000	3376	1611	36	0	\N
70741	1397	1415917725000	3376	1611	37	0	\N
70742	1397	1415907724000	3376	1611	38	0	\N
70743	1397	1415897723000	3376	1611	39	0	\N
70744	1397	1415887722000	3376	1611	40	0	\N
70745	1397	1415877721000	3376	1611	41	0	\N
70746	1397	1415867720000	3376	1611	42	0	\N
70747	1397	1415857719000	3376	1611	43	0	\N
70748	1397	1415847718000	3376	1611	44	0	\N
70749	1397	1415837717000	3376	1611	45	0	\N
70750	1397	1415827716000	3376	1611	46	0	\N
70751	1397	1415817715000	3376	1611	47	0	\N
70752	1397	1415807714000	3376	1611	48	0	\N
70753	1693	8907419262733	3376	1611	49	0	\N
70754	1693	8857631025012	3376	1611	50	0	\N
70755	1693	8807842787291	3376	1611	51	0	\N
70756	1693	8758054549570	3376	1611	52	0	\N
70757	1693	8708266311849	3376	1611	53	0	\N
70758	1693	8658478074128	3376	1611	54	0	\N
70759	1693	8505322183241	3376	1611	55	0	\N
70760	1693	8455533945520	3376	1611	56	0	\N
70761	1693	8454015514083	3376	1611	57	0	\N
70762	1693	8404227276362	3376	1611	58	0	\N
70763	1693	8354439038641	3376	1611	59	0	\N
70764	1693	7674922150341	3376	1611	60	0	\N
70765	1693	7625133912620	3376	1611	61	0	\N
70766	1693	7575345674899	3376	1611	62	0	\N
70767	1693	7525557437178	3376	1611	63	0	\N
70768	1693	7475769199457	3376	1611	64	0	\N
70769	1693	7425980961736	3376	1611	65	0	\N
70770	1693	7376192724015	3376	1611	66	0	\N
70771	1693	7144772056121	3376	1611	67	0	\N
70772	1693	7139711073433	3376	1611	68	0	\N
70773	1693	7089922835712	3376	1611	69	0	\N
70774	1693	7040134597991	3376	1611	71	0	\N
70775	1693	6990346360270	3376	1611	72	0	\N
70776	1693	6940558122549	3376	1611	73	0	\N
70777	1693	6890769884828	3376	1611	74	0	\N
70778	1693	6840981647107	3376	1611	75	0	\N
70779	1693	6791193409386	3376	1611	76	0	\N
70780	1693	6741405171665	3376	1611	77	0	\N
70781	1693	6691616933944	3376	1611	78	0	\N
70782	1693	6641828696223	3376	1611	79	0	\N
70783	1693	6592040458502	3376	1611	80	0	\N
70784	1693	6212839533730	3376	1611	81	0	\N
70785	1693	6163051296009	3376	1611	82	0	\N
70786	1693	6113263058288	3376	1611	83	0	\N
70787	1693	6063474820567	3376	1611	84	0	\N
70788	1693	6013686582846	3376	1611	85	0	\N
70789	1693	5963898345125	3376	1611	86	0	\N
70790	1693	5914110107404	3376	1611	87	0	\N
70791	1693	5908820597346	3376	1611	88	0	\N
70792	1693	5859032359625	3376	1611	89	0	\N
70793	1693	5809244121904	3376	1611	90	0	\N
70794	1693	5759455884183	3376	1611	91	0	\N
70795	1693	5709667646462	3376	1611	92	0	\N
70796	1693	5659879408741	3376	1611	93	0	\N
70797	1693	5610091171020	3376	1611	94	0	\N
70798	1693	5560302933299	3376	1611	95	0	\N
70799	1693	5556521854688	3376	1611	96	0	\N
70800	1693	5555003423251	3376	1611	97	0	\N
70801	1693	5505215185530	3376	1611	98	0	\N
70802	1693	5455426947809	3376	1611	99	0	\N
70803	1693	5405638710088	3376	1611	100	0	\N
70804	1693	5355850472367	3376	1611	101	0	\N
70805	1693	5306062234646	3376	1611	102	0	\N
70806	1693	5256273996925	3376	1611	103	0	\N
70807	1693	5206485759204	3376	1611	104	0	\N
70808	1693	5156697521483	3376	1611	105	0	\N
70809	1693	5106909283762	3376	1611	106	0	\N
70810	1693	5057121046041	3376	1611	107	0	\N
70811	1693	5007332808320	3376	1611	108	0	\N
70812	1693	4957544570599	3376	1611	109	0	\N
70813	1693	4908263165845	3376	1611	110	0	\N
70814	1693	4858474928124	3376	1611	111	0	\N
70815	1693	4808686690403	3376	1611	112	0	\N
70816	1693	4350199852735	3376	1611	113	0	\N
70817	1693	4300411615014	3376	1611	114	0	\N
70818	1693	4250623377293	3376	1611	115	0	\N
70819	1693	4200835139572	3376	1611	116	0	\N
70820	1693	4151046901851	3376	1611	117	0	\N
70821	1693	4101258664130	3376	1611	118	0	\N
70822	1693	4051470426409	3376	1611	119	0	\N
70823	1693	4001682188688	3376	1611	120	0	\N
70824	1693	3951893950967	3376	1611	121	0	\N
70825	1693	3902105713246	3376	1611	122	0	\N
70826	1693	3877539957744	3376	1611	123	0	\N
70827	1693	3827751720023	3376	1611	124	0	\N
70828	1693	3777963482302	3376	1611	125	0	\N
70829	1397	1413817515000	3377	1757	0	0	\N
70833	1397	1413797513000	3381	1759	0	0	\N
70834	1397	1413787512000	3382	1760	0	0	\N
70835	1397	1413787512000	3383	1760	0	0	\N
70840	1397	1414027536000	3389	1744	0	0	\N
70841	1397	1414017535000	3389	1744	1	0	\N
70842	1397	1414007534000	3389	1744	2	0	\N
70843	1397	1413997533000	3389	1744	3	0	\N
70844	1397	1413987532000	3389	1744	4	0	\N
70845	1397	1413977531000	3389	1744	5	0	\N
70846	1397	1413967530000	3389	1744	6	0	\N
70847	1397	1413957529000	3389	1744	7	0	\N
70848	1397	1413947528000	3389	1744	8	0	\N
70849	1397	1413937527000	3389	1744	9	0	\N
70850	1397	1413927526000	3389	1744	10	0	\N
70851	1397	1413917525000	3389	1744	11	0	\N
70852	1397	1413907524000	3389	1744	12	0	\N
70853	1397	1413897523000	3389	1744	13	0	\N
70854	1397	1413887522000	3389	1744	14	0	\N
70855	1397	1413877521000	3389	1744	15	0	\N
70856	1397	1413867520000	3389	1744	16	0	\N
70832	1397	1413797513000	3380	1759	0	0	2504
70836	1397	1413787512000	3384	1760	0	0	2505
70837	1397	1413777511000	3386	1761	0	0	2506
70838	1397	1413767510000	3387	1762	0	0	2507
70839	1397	1413757509000	3388	1763	0	0	2508
70857	1397	1413857519000	3389	1744	17	0	\N
70858	1397	1413847518000	3389	1744	18	0	\N
70859	1397	1413837517000	3389	1744	19	0	\N
70860	1397	1413827516000	3389	1744	20	0	\N
70861	1397	1413817515000	3389	1744	21	0	\N
70862	1397	1413807514000	3389	1744	22	0	\N
70863	1397	1413797513000	3389	1744	23	0	\N
70864	1397	1413787512000	3389	1744	24	0	\N
70865	1397	1413777511000	3389	1744	25	0	\N
70866	1397	1413767510000	3389	1744	26	0	\N
70867	1397	1413757509000	3389	1744	27	0	\N
70868	1397	1413747508000	3389	1744	28	0	\N
70869	436	66719690000000	3389	1744	29	0	\N
70871	1397	1413747508000	3391	1764	0	0	\N
70873	1397	1413727506000	3393	1766	0	0	\N
70875	1397	1415797713000	3395	1612	0	0	\N
70876	1397	1415787712000	3395	1612	1	0	\N
70877	1397	1415777711000	3395	1612	2	0	\N
70878	1397	1415767710000	3395	1612	3	0	\N
70879	1397	1415757709000	3395	1612	4	0	\N
70880	1397	1415747708000	3395	1612	5	0	\N
70881	1397	1415737707000	3395	1612	6	0	\N
70882	1397	1415727706000	3395	1612	7	0	\N
70883	1397	1415717705000	3395	1612	8	0	\N
70884	1397	1415707704000	3395	1612	9	0	\N
70885	1397	1415697703000	3395	1612	10	0	\N
70886	1397	1415687702000	3395	1612	11	0	\N
70887	1397	1415677701000	3395	1612	12	0	\N
70888	1397	1415667700000	3395	1612	13	0	\N
70889	1397	1415657699000	3395	1612	14	0	\N
70890	1397	1415647698000	3395	1612	15	0	\N
70891	1397	1415637697000	3395	1612	16	0	\N
70892	1397	1415627696000	3395	1612	17	0	\N
70893	1397	1415617695000	3395	1612	18	0	\N
70894	1397	1415607694000	3395	1612	19	0	\N
70895	1397	1415597693000	3395	1612	20	0	\N
70896	1397	1415587692000	3395	1612	21	0	\N
70897	1397	1415577691000	3395	1612	22	0	\N
70898	1397	1415567690000	3395	1612	23	0	\N
70899	1397	1415557689000	3395	1612	24	0	\N
70900	1397	1415547688000	3395	1612	25	0	\N
70901	1397	1415537687000	3395	1612	26	0	\N
70902	1397	1415527686000	3395	1612	27	0	\N
70903	1397	1415517685000	3395	1612	28	0	\N
70904	1397	1415507684000	3395	1612	29	0	\N
70905	1397	1415497683000	3395	1612	30	0	\N
70906	1397	1415487682000	3395	1612	31	0	\N
70907	1397	1415477681000	3395	1612	32	0	\N
70908	1397	1415467680000	3395	1612	33	0	\N
70909	1397	1415457679000	3395	1612	34	0	\N
70910	1397	1415447678000	3395	1612	35	0	\N
70911	1397	1415437677000	3395	1612	36	0	\N
70912	1397	1415427676000	3395	1612	37	0	\N
70913	1397	1415417675000	3395	1612	38	0	\N
70914	1397	1415407674000	3395	1612	39	0	\N
70915	1397	1415397673000	3395	1612	40	0	\N
70916	1397	1415387672000	3395	1612	41	0	\N
70917	1397	1415377671000	3395	1612	42	0	\N
70918	1397	1415367670000	3395	1612	43	0	\N
70919	1397	1415357669000	3395	1612	44	0	\N
70920	1397	1415347668000	3395	1612	45	0	\N
70921	1397	1415337667000	3395	1612	46	0	\N
70922	1397	1415327666000	3395	1612	47	0	\N
70923	1397	1415317665000	3395	1612	48	0	\N
70924	1397	1415307664000	3395	1612	49	0	\N
70925	1397	1415297663000	3395	1612	50	0	\N
70926	1397	1415287662000	3395	1612	51	0	\N
70927	1397	1415277661000	3395	1612	52	0	\N
70928	1397	1415267660000	3395	1612	53	0	\N
70929	1397	1415257659000	3395	1612	54	0	\N
70930	1397	1415247658000	3395	1612	55	0	\N
70931	1397	1415237657000	3395	1612	56	0	\N
70932	1397	1415227656000	3395	1612	57	0	\N
70933	1397	1415217655000	3395	1612	58	0	\N
70934	1397	1415207654000	3395	1612	59	0	\N
70935	1397	1415197653000	3395	1612	60	0	\N
70936	1397	1415187652000	3395	1612	61	0	\N
70937	1397	1415177651000	3395	1612	62	0	\N
70938	1397	1415167650000	3395	1612	63	0	\N
70939	1397	1415157649000	3395	1612	64	0	\N
70940	1397	1415147648000	3395	1612	65	0	\N
70941	1397	1415137647000	3395	1612	66	0	\N
70942	1397	1415127646000	3395	1612	67	0	\N
70943	1397	1415117645000	3395	1612	68	0	\N
70944	1397	1415107644000	3395	1612	69	0	\N
70945	1397	1415097643000	3395	1612	71	0	\N
70946	1397	1415087642000	3395	1612	72	0	\N
70947	1397	1415077641000	3395	1612	73	0	\N
70948	1397	1415067640000	3395	1612	74	0	\N
70949	1397	1415057639000	3395	1612	75	0	\N
70950	1397	1415047638000	3395	1612	76	0	\N
70951	1397	1415037637000	3395	1612	77	0	\N
70952	1397	1415027636000	3395	1612	78	0	\N
70953	1397	1415017635000	3395	1612	79	0	\N
70954	1397	1415007634000	3395	1612	80	0	\N
70955	1397	1414997633000	3395	1612	81	0	\N
70956	1397	1414987632000	3395	1612	82	0	\N
70957	1397	1414977631000	3395	1612	83	0	\N
70958	1397	1414967630000	3395	1612	84	0	\N
70959	1397	1414957629000	3395	1612	85	0	\N
70960	1397	1414947628000	3395	1612	86	0	\N
70961	1397	1414937627000	3395	1612	87	0	\N
70962	1397	1414927626000	3395	1612	88	0	\N
70963	1397	1414917625000	3395	1612	89	0	\N
70964	1397	1414907624000	3395	1612	90	0	\N
70965	1397	1414897623000	3395	1612	91	0	\N
70966	1397	1414887622000	3395	1612	92	0	\N
70967	1397	1414877621000	3395	1612	93	0	\N
70968	1397	1414867620000	3395	1612	94	0	\N
70969	1397	1414857619000	3395	1612	95	0	\N
70970	1397	1414847618000	3395	1612	96	0	\N
70971	1397	1414837617000	3395	1612	97	0	\N
70972	1397	1414827616000	3395	1612	98	0	\N
70973	1397	1414817615000	3395	1612	99	0	\N
70974	1397	1414807614000	3395	1612	100	0	\N
70975	1397	1414797613000	3395	1612	101	0	\N
70976	1397	1414787612000	3395	1612	102	0	\N
70977	1397	1414777611000	3395	1612	103	0	\N
70978	1397	1414767610000	3395	1612	104	0	\N
70979	1397	1414757609000	3395	1612	105	0	\N
70980	1397	1414747608000	3395	1612	106	0	\N
70981	1397	1414737607000	3395	1612	107	0	\N
70982	1397	1414727606000	3395	1612	108	0	\N
70983	1397	1414717605000	3395	1612	109	0	\N
70984	1397	1414707604000	3395	1612	110	0	\N
70985	1397	1414697603000	3395	1612	111	0	\N
70986	1397	1414687602000	3395	1612	112	0	\N
70987	1397	1414677601000	3395	1612	113	0	\N
70988	1397	1414667600000	3395	1612	114	0	\N
70989	1397	1414657599000	3395	1612	115	0	\N
70990	1397	1414647598000	3395	1612	116	0	\N
70991	1397	1414637597000	3395	1612	117	0	\N
70992	1397	1414627596000	3395	1612	118	0	\N
70874	1397	1413727506000	3394	1766	0	0	2511
70993	1397	1414617595000	3395	1612	119	0	\N
70994	1397	1414607594000	3395	1612	120	0	\N
70995	1397	1414597593000	3395	1612	121	0	\N
70996	1397	1414587592000	3395	1612	122	0	\N
70997	1397	1414577591000	3395	1612	123	0	\N
70998	1397	1414567590000	3395	1612	124	0	\N
70999	1397	1414557589000	3395	1612	125	0	\N
71001	1397	1413717505000	3397	1767	0	0	\N
71002	1397	1413747508000	3398	1764	0	0	\N
71003	1397	1413737507000	3398	1764	1	0	\N
71004	1397	1413727506000	3398	1764	2	0	\N
71005	1397	1413717505000	3398	1764	3	0	\N
71007	1397	1413707504000	3400	1768	0	0	\N
71008	1397	1413707504000	3401	1768	0	0	\N
71009	1772	258750000000	3402	1741	0	0	\N
71010	878	203062162331632	3402	1741	1	0	\N
71011	1397	1414087542000	3402	1741	2	0	\N
71012	1397	1414077541000	3402	1741	3	0	\N
71013	1397	1414067540000	3402	1741	4	0	\N
71014	1397	1414057539000	3402	1741	5	0	\N
71015	1397	1414047538000	3402	1741	6	0	\N
71016	1397	1414037537000	3402	1741	7	0	\N
71017	1397	1414027536000	3402	1741	8	0	\N
71018	1397	1414017535000	3402	1741	9	0	\N
71019	1397	1414007534000	3402	1741	10	0	\N
71020	1397	1413997533000	3402	1741	11	0	\N
71021	1397	1413987532000	3402	1741	12	0	\N
71022	1397	1413977531000	3402	1741	13	0	\N
71023	1397	1413967530000	3402	1741	14	0	\N
71024	1397	1413957529000	3402	1741	15	0	\N
71025	1397	1413947528000	3402	1741	16	0	\N
71026	1397	1413937527000	3402	1741	17	0	\N
71027	1397	1413927526000	3402	1741	18	0	\N
71028	1397	1413917525000	3402	1741	19	0	\N
71029	1397	1413907524000	3402	1741	20	0	\N
71030	1397	1413897523000	3402	1741	21	0	\N
71031	1397	1413887522000	3402	1741	22	0	\N
71032	1397	1413877521000	3402	1741	23	0	\N
71033	1397	1413867520000	3402	1741	24	0	\N
71034	1397	1413857519000	3402	1741	25	0	\N
71035	1397	1413847518000	3402	1741	26	0	\N
71036	1397	1413837517000	3402	1741	27	0	\N
71037	1397	1413827516000	3402	1741	28	0	\N
71038	1397	1413817515000	3402	1741	29	0	\N
71039	1397	1413807514000	3402	1741	30	0	\N
71040	1397	1413797513000	3402	1741	31	0	\N
71041	1397	1413787512000	3402	1741	32	0	\N
71042	1397	1413777511000	3402	1741	33	0	\N
71043	1397	1413767510000	3402	1741	34	0	\N
71044	1397	1413757509000	3402	1741	35	0	\N
71045	1397	1413747508000	3402	1741	36	0	\N
71046	1397	1413737507000	3402	1741	37	0	\N
71047	1397	1413727506000	3402	1741	38	0	\N
71048	1397	1413717505000	3402	1741	39	0	\N
71049	436	66719690000000	3402	1741	40	0	\N
71052	1397	1413737507000	3408	1745	0	0	\N
71053	1397	1413727506000	3408	1745	1	0	\N
71054	1397	1413717505000	3408	1745	2	0	\N
71055	1397	1413707504000	3408	1745	3	0	\N
71056	1397	1413697503000	3408	1745	4	0	\N
71057	1397	1413687502000	3408	1745	5	0	\N
71058	1397	1413677501000	3408	1745	6	0	\N
71059	1397	1413667500000	3408	1745	7	0	\N
71060	1397	1413677501000	3409	1773	0	0	\N
71061	1397	1413667500000	3409	1773	1	0	\N
71062	1397	1413677501000	3410	1773	0	0	\N
71063	1397	1413667500000	3410	1773	1	0	\N
71064	1397	1413677501000	3411	1773	0	0	\N
71065	1397	1413667500000	3411	1773	1	0	\N
71071	1397	1413637497000	3416	1776	0	0	\N
71072	1397	1413627496000	3417	1777	0	0	\N
71073	1397	1413627496000	3418	1777	0	0	\N
71075	1397	1413617495000	3420	1778	0	0	\N
71076	1397	1413607494000	3420	1778	1	0	\N
71079	1397	1413597493000	3422	1779	0	0	\N
71080	1397	1413597493000	3424	1779	0	0	\N
71081	1397	1413597493000	3425	1780	0	0	\N
71082	1397	1413587492000	3425	1780	1	0	\N
71083	1397	1413577491000	3425	1780	2	0	\N
71084	1397	1413597493000	3426	1780	0	0	\N
71085	1397	1413587492000	3426	1780	1	0	\N
71086	1397	1413577491000	3426	1780	2	0	\N
71090	1397	1413597493000	3428	1780	0	0	\N
71091	1397	1413587492000	3428	1780	1	0	\N
71092	1397	1413577491000	3428	1780	2	0	\N
71093	1397	1413567490000	3429	1781	0	0	\N
71098	1722	171000000	3445	1789	0	0	\N
71100	1722	171000000	3447	1789	0	0	\N
71101	1722	171000000	3448	1789	0	0	\N
71102	1396	718420000000	3456	1676	0	0	\N
71103	1396	716820000000	3456	1676	1	0	\N
71104	1396	20000000	3456	1676	2	0	\N
71105	1699	1905970500039	3456	1676	3	0	\N
71106	877	203061162331632	3456	1676	4	0	\N
71107	1702	2874030000000	3456	1676	5	0	\N
71108	1693	5555003423251	3456	1676	6	0	\N
71109	1722	7932191000000	3456	1676	7	0	\N
71110	1397	1414867620000	3456	1676	8	0	\N
71111	1397	1414857619000	3456	1676	9	0	\N
71112	1397	1414847618000	3456	1676	10	0	\N
71113	1722	3612181000000	3456	1676	11	0	\N
71114	1722	171000000	3456	1676	12	0	\N
71115	1397	1414837617000	3456	1676	13	0	\N
71116	1397	1414827616000	3456	1676	15	0	\N
71117	1397	1414817615000	3456	1676	16	0	\N
71118	1397	1414807614000	3456	1676	17	0	\N
71119	1397	1414797613000	3456	1676	18	0	\N
71120	1397	1414787612000	3456	1676	19	0	\N
71121	1397	1414777611000	3456	1676	20	0	\N
71122	1397	1414767610000	3456	1676	21	0	\N
71123	1397	1414757609000	3456	1676	22	0	\N
71124	1693	5505215185530	3456	1676	23	0	\N
71125	1693	5455426947809	3456	1676	24	0	\N
71126	1693	5405638710088	3456	1676	25	0	\N
71127	1693	5355850472367	3456	1676	26	0	\N
71128	1693	5306062234646	3456	1676	27	0	\N
71050	1397	1413697503000	3403	1769	0	0	2514
71051	1397	1413687502000	3404	1770	0	0	2515
71066	1397	1413677501000	3413	1774	0	0	2516
71067	1397	1413667500000	3413	1774	1	0	2517
71068	1397	1413657499000	3413	1774	2	0	2518
71070	1397	1413637497000	3415	1776	0	0	2520
71074	1397	1413627496000	3419	1777	0	0	2521
71077	1397	1413617495000	3421	1778	0	0	2522
71078	1397	1413607494000	3421	1778	1	0	2523
71087	1397	1413597493000	3427	1780	0	0	2524
71089	1397	1413577491000	3427	1780	2	0	2526
71094	1397	1413567490000	3430	1781	0	0	2527
71095	1397	1413557489000	3431	1782	0	0	2528
71096	1722	7932191000000	3444	1788	0	0	5
71099	1722	171000000	3446	1789	0	0	7
71129	1693	5256273996925	3456	1676	28	0	\N
71130	1693	5206485759204	3456	1676	29	0	\N
71131	1693	5156697521483	3456	1676	30	0	\N
71132	1693	5106909283762	3456	1676	31	0	\N
71133	1693	5057121046041	3456	1676	32	0	\N
71134	1693	5007332808320	3456	1676	33	0	\N
71135	1693	4957544570599	3456	1676	34	0	\N
71136	1693	4908263165845	3456	1676	35	0	\N
71137	1693	4858474928124	3456	1676	36	0	\N
71138	1693	4808686690403	3456	1676	37	0	\N
71139	1693	4350199852735	3456	1676	38	0	\N
71140	1693	4300411615014	3456	1676	39	0	\N
71141	1693	4250623377293	3456	1676	40	0	\N
71142	1397	1414747608000	3456	1676	41	0	\N
71143	1397	1414737607000	3456	1676	42	0	\N
71144	1397	1414727606000	3456	1676	43	0	\N
71145	1397	1414717605000	3456	1676	44	0	\N
71146	1397	1414707604000	3456	1676	45	0	\N
71147	1397	1414697603000	3456	1676	46	0	\N
71148	1397	1414687602000	3456	1676	47	0	\N
71149	1397	1414677601000	3456	1676	48	0	\N
71150	1397	1414667600000	3456	1676	49	0	\N
71151	1397	1414657599000	3456	1676	50	0	\N
71152	1397	1414647598000	3456	1676	51	0	\N
71153	1397	1414637597000	3456	1676	52	0	\N
71154	1397	1414627596000	3456	1676	53	0	\N
71155	1397	1414617595000	3456	1676	54	0	\N
71156	1397	1414607594000	3456	1676	55	0	\N
71157	1397	1414597593000	3456	1676	56	0	\N
71158	1397	1414587592000	3456	1676	57	0	\N
71159	1397	1414577591000	3456	1676	58	0	\N
71160	1397	1414567590000	3456	1676	59	0	\N
71161	1397	1414557589000	3456	1676	60	0	\N
71162	1397	1414547588000	3456	1676	61	0	\N
71163	1397	1414537587000	3456	1676	62	0	\N
71164	1397	1414527586000	3456	1676	63	0	\N
71165	1397	1414517585000	3456	1676	64	0	\N
71166	1397	1414507584000	3456	1676	65	0	\N
71167	1397	1414497583000	3456	1676	66	0	\N
71168	1397	1414487582000	3456	1676	67	0	\N
71169	1397	1414477581000	3456	1676	68	0	\N
71170	1397	1414467580000	3456	1676	69	0	\N
71171	1397	1414457579000	3456	1676	70	0	\N
71172	1397	1414447578000	3456	1676	71	0	\N
71173	1397	1414437577000	3456	1676	72	0	\N
71174	1397	1414427576000	3456	1676	73	0	\N
71175	1397	1414417575000	3456	1676	74	0	\N
71176	1397	1414407574000	3456	1676	75	0	\N
71177	1397	1414397573000	3456	1676	76	0	\N
71178	1397	1414387572000	3456	1676	77	0	\N
71179	1397	1414377571000	3456	1676	78	0	\N
71180	1397	1414367570000	3456	1676	79	0	\N
71181	1397	1414357569000	3456	1676	80	0	\N
71182	1397	1414347568000	3456	1676	81	0	\N
71183	1397	1414337567000	3456	1676	82	0	\N
71184	1397	1414327566000	3456	1676	83	0	\N
71185	1397	1414317565000	3456	1676	84	0	\N
71186	1397	1414307564000	3456	1676	85	0	\N
71187	1397	1414297563000	3456	1676	86	0	\N
71188	1397	1414287562000	3456	1676	87	0	\N
71189	1397	1414277561000	3456	1676	88	0	\N
71190	1397	1414267560000	3456	1676	89	0	\N
71191	1397	1414257559000	3456	1676	90	0	\N
71192	1397	1414247558000	3456	1676	91	0	\N
71193	1397	1414237557000	3456	1676	92	0	\N
71194	1397	1414227556000	3456	1676	93	0	\N
71195	1397	1414217555000	3456	1676	94	0	\N
71196	1397	1414207554000	3456	1676	95	0	\N
71197	1397	1414197553000	3456	1676	96	0	\N
71198	1397	1414187552000	3456	1676	97	0	\N
71199	1397	1414177551000	3456	1676	98	0	\N
71200	1397	1414167550000	3456	1676	99	0	\N
71201	1397	1414157549000	3456	1676	100	0	\N
71202	1397	1414147548000	3456	1676	101	0	\N
71203	1397	1414137547000	3456	1676	102	0	\N
71204	1397	1414127546000	3456	1676	103	0	\N
71205	1397	1414117545000	3456	1676	104	0	\N
71206	1397	1414107544000	3456	1676	105	0	\N
71207	1693	4200835139572	3456	1676	106	0	\N
71208	1693	4151046901851	3456	1676	107	0	\N
71209	1693	4101258664130	3456	1676	108	0	\N
71210	1693	4051470426409	3456	1676	109	0	\N
71211	1693	4001682188688	3456	1676	110	0	\N
71212	1693	3951893950967	3456	1676	111	0	\N
71213	1693	3902105713246	3456	1676	112	0	\N
71214	1693	3877539957744	3456	1676	113	0	\N
71215	1693	3827751720023	3456	1676	114	0	\N
71216	1693	3777963482302	3456	1676	115	0	\N
71217	1693	2500367008662	3456	1676	116	0	\N
71218	1693	2450578770941	3456	1676	117	0	\N
71219	1693	2400790533220	3456	1676	118	0	\N
71220	1693	2351002295499	3456	1676	119	0	\N
71221	1693	2301214057778	3456	1676	120	0	\N
71222	1693	2251425820057	3456	1676	121	0	\N
71223	1693	2201637582336	3456	1676	122	0	\N
71224	1693	2151849344615	3456	1676	123	0	\N
71225	1693	2102061106894	3456	1676	124	0	\N
71226	1693	2052272869173	3456	1676	125	0	\N
71228	1396	718420000000	3489	1701	0	0	\N
71229	1396	716820000000	3489	1701	1	0	\N
71230	1396	20000000	3489	1701	2	0	\N
71231	1699	1905970500039	3489	1701	3	0	\N
71232	877	203061162331632	3489	1701	4	0	\N
71233	1693	5455426947809	3489	1701	5	0	\N
71234	1397	1414647598000	3489	1701	6	0	\N
71235	1702	2874030000000	3489	1701	7	0	\N
71236	1722	7932191000000	3489	1701	8	0	\N
71237	1397	1414637597000	3489	1701	9	0	\N
71238	1722	3612181000000	3489	1701	10	0	\N
71239	1722	171000000	3489	1701	11	0	\N
71240	1397	1414627596000	3489	1701	12	0	\N
71241	1397	1414617595000	3489	1701	13	0	\N
71242	1397	1414607594000	3489	1701	14	0	\N
71243	1397	1414597593000	3489	1701	15	0	\N
71244	1693	5405638710088	3489	1701	16	0	\N
71245	1693	5355850472367	3489	1701	17	0	\N
71246	1693	5306062234646	3489	1701	18	0	\N
71247	1693	5256273996925	3489	1701	19	0	\N
71248	1693	5206485759204	3489	1701	20	0	\N
71249	1693	5156697521483	3489	1701	21	0	\N
71250	1693	5106909283762	3489	1701	22	0	\N
71251	1693	5057121046041	3489	1701	23	0	\N
71252	1693	5007332808320	3489	1701	24	0	\N
71253	1693	4957544570599	3489	1701	25	0	\N
71254	1693	4908263165845	3489	1701	26	0	\N
71255	1693	4858474928124	3489	1701	27	0	\N
71256	1693	4808686690403	3489	1701	28	0	\N
71257	1693	4350199852735	3489	1701	29	0	\N
71258	1693	4300411615014	3489	1701	30	0	\N
71259	1693	4250623377293	3489	1701	31	0	\N
71260	1397	1414587592000	3489	1701	32	0	\N
71261	1397	1414577591000	3489	1701	33	0	\N
71262	1397	1414567590000	3489	1701	34	0	\N
71263	1397	1414557589000	3489	1701	35	0	\N
71264	1397	1414547588000	3489	1701	36	0	\N
71265	1397	1414537587000	3489	1701	37	0	\N
71266	1397	1414527586000	3489	1701	38	0	\N
71267	1397	1414517585000	3489	1701	39	0	\N
71268	1397	1414507584000	3489	1701	40	0	\N
71269	1397	1414497583000	3489	1701	41	0	\N
71270	1397	1414487582000	3489	1701	42	0	\N
71271	1397	1414477581000	3489	1701	43	0	\N
71272	1397	1414467580000	3489	1701	44	0	\N
71273	1397	1414457579000	3489	1701	45	0	\N
71274	1397	1414447578000	3489	1701	46	0	\N
71275	1397	1414437577000	3489	1701	47	0	\N
71276	1397	1414427576000	3489	1701	48	0	\N
71277	1397	1414417575000	3489	1701	49	0	\N
71278	1397	1414407574000	3489	1701	50	0	\N
71279	1397	1414397573000	3489	1701	51	0	\N
71280	1397	1414387572000	3489	1701	52	0	\N
71281	1397	1414377571000	3489	1701	53	0	\N
71282	1397	1414367570000	3489	1701	54	0	\N
71283	1397	1414357569000	3489	1701	55	0	\N
71284	1397	1414347568000	3489	1701	56	0	\N
71285	1397	1414337567000	3489	1701	57	0	\N
71286	1397	1414327566000	3489	1701	58	0	\N
71287	1397	1414317565000	3489	1701	59	0	\N
71288	1397	1414307564000	3489	1701	60	0	\N
71289	1397	1414297563000	3489	1701	61	0	\N
71290	1397	1414287562000	3489	1701	62	0	\N
71291	1397	1414277561000	3489	1701	63	0	\N
71292	1397	1414267560000	3489	1701	64	0	\N
71293	1397	1414257559000	3489	1701	65	0	\N
71294	1397	1414247558000	3489	1701	66	0	\N
71295	1397	1414237557000	3489	1701	67	0	\N
71296	1397	1414227556000	3489	1701	69	0	\N
71297	1397	1414217555000	3489	1701	70	0	\N
71298	1397	1414207554000	3489	1701	71	0	\N
71299	1397	1414197553000	3489	1701	72	0	\N
71300	1397	1414187552000	3489	1701	73	0	\N
71301	1397	1414177551000	3489	1701	74	0	\N
71302	1397	1414167550000	3489	1701	75	0	\N
71303	1397	1414157549000	3489	1701	76	0	\N
71304	1397	1414147548000	3489	1701	77	0	\N
71305	1397	1414137547000	3489	1701	78	0	\N
71306	1397	1414127546000	3489	1701	79	0	\N
71307	1397	1414117545000	3489	1701	80	0	\N
71308	1397	1414107544000	3489	1701	81	0	\N
71309	1693	4200835139572	3489	1701	82	0	\N
71310	1693	4151046901851	3489	1701	83	0	\N
71311	1693	4101258664130	3489	1701	84	0	\N
71312	1722	7212181000000	3493	1613	0	0	\N
71313	1722	2892171000000	3493	1613	1	0	\N
71314	1397	1414547588000	3493	1613	2	0	\N
71315	1397	1414537587000	3493	1613	3	0	\N
71316	1397	1414527586000	3493	1613	4	0	\N
71317	1397	1414517585000	3493	1613	5	0	\N
71318	1397	1414507584000	3493	1613	6	0	\N
71319	1397	1414497583000	3493	1613	7	0	\N
71320	1397	1414487582000	3493	1613	8	0	\N
71321	1397	1414477581000	3493	1613	9	0	\N
71322	1397	1414467580000	3493	1613	10	0	\N
71323	1397	1414457579000	3493	1613	11	0	\N
71324	1397	1414447578000	3493	1613	12	0	\N
71325	1397	1414437577000	3493	1613	13	0	\N
71326	1397	1414427576000	3493	1613	14	0	\N
71327	1397	1414417575000	3493	1613	15	0	\N
71328	1397	1414407574000	3493	1613	16	0	\N
71329	1397	1414397573000	3493	1613	17	0	\N
71330	1397	1414387572000	3493	1613	18	0	\N
71331	1397	1414377571000	3493	1613	19	0	\N
71332	1397	1414367570000	3493	1613	20	0	\N
71333	1397	1414357569000	3493	1613	21	0	\N
71334	1397	1414347568000	3493	1613	22	0	\N
71335	1397	1414337567000	3493	1613	23	0	\N
71336	1397	1414327566000	3493	1613	24	0	\N
71337	1397	1414317565000	3493	1613	25	0	\N
71338	1397	1414307564000	3493	1613	26	0	\N
71339	1397	1414297563000	3493	1613	27	0	\N
71340	1397	1414287562000	3493	1613	28	0	\N
71341	1397	1414277561000	3493	1613	29	0	\N
71342	1397	1414267560000	3493	1613	30	0	\N
71343	1397	1414257559000	3493	1613	31	0	\N
71344	1397	1414247558000	3493	1613	32	0	\N
71345	1397	1414237557000	3493	1613	33	0	\N
71346	1397	1414227556000	3493	1613	34	0	\N
71347	1397	1414217555000	3493	1613	35	0	\N
71348	1397	1414207554000	3493	1613	36	0	\N
71349	1397	1414197553000	3493	1613	37	0	\N
71350	1397	1414187552000	3493	1613	38	0	\N
71351	1397	1414177551000	3493	1613	39	0	\N
71352	1397	1414167550000	3493	1613	40	0	\N
71353	1397	1414157549000	3493	1613	41	0	\N
71354	1397	1414147548000	3493	1613	42	0	\N
71355	1397	1414137547000	3493	1613	43	0	\N
71356	1397	1414127546000	3493	1613	44	0	\N
71357	1397	1414117545000	3493	1613	45	0	\N
71358	1397	1414107544000	3493	1613	46	0	\N
71359	1397	1414097543000	3493	1613	47	0	\N
71360	1397	1414087542000	3493	1613	48	0	\N
71361	1397	1414077541000	3493	1613	49	0	\N
71362	1397	1414067540000	3493	1613	50	0	\N
71363	1397	1414057539000	3493	1613	51	0	\N
71364	1397	1414047538000	3493	1613	52	0	\N
71365	1397	1414037537000	3493	1613	53	0	\N
71366	1397	1414027536000	3493	1613	54	0	\N
71367	1397	1414017535000	3493	1613	55	0	\N
71368	1397	1414007534000	3493	1613	56	0	\N
71369	1397	1413997533000	3493	1613	57	0	\N
71370	1397	1413987532000	3493	1613	58	0	\N
71371	1397	1413977531000	3493	1613	59	0	\N
71372	1397	1413967530000	3493	1613	60	0	\N
71373	1397	1413957529000	3493	1613	61	0	\N
71374	1397	1413947528000	3493	1613	62	0	\N
71375	1397	1413937527000	3493	1613	63	0	\N
71376	1397	1413927526000	3493	1613	64	0	\N
71377	1397	1413917525000	3493	1613	65	0	\N
71378	1397	1413907524000	3493	1613	66	0	\N
71379	1397	1413897523000	3493	1613	67	0	\N
71380	1397	1413887522000	3493	1613	68	0	\N
71381	1397	1413877521000	3493	1613	69	0	\N
71382	1397	1413867520000	3493	1613	71	0	\N
71383	1397	1413857519000	3493	1613	72	0	\N
71384	1397	1413847518000	3493	1613	73	0	\N
71385	1397	1413837517000	3493	1613	74	0	\N
71386	1397	1413827516000	3493	1613	75	0	\N
71387	1397	1413817515000	3493	1613	76	0	\N
71388	1397	1413807514000	3493	1613	77	0	\N
71389	1397	1413797513000	3493	1613	78	0	\N
71390	1397	1413787512000	3493	1613	79	0	\N
71391	1397	1413777511000	3493	1613	80	0	\N
71392	1397	1413767510000	3493	1613	81	0	\N
71393	1397	1413757509000	3493	1613	82	0	\N
71394	1397	1413747508000	3493	1613	83	0	\N
71395	1397	1413737507000	3493	1613	84	0	\N
71396	1397	1413727506000	3493	1613	85	0	\N
71397	1397	1413717505000	3493	1613	86	0	\N
71398	1397	1413707504000	3493	1613	87	0	\N
71399	1397	1413697503000	3493	1613	88	0	\N
71400	1397	1413687502000	3493	1613	89	0	\N
71401	1397	1413677501000	3493	1613	90	0	\N
71402	1397	1413667500000	3493	1613	91	0	\N
71403	1397	1413657499000	3493	1613	92	0	\N
71404	1397	1413647498000	3493	1613	93	0	\N
71405	1397	1413637497000	3493	1613	94	0	\N
71406	1397	1413627496000	3493	1613	95	0	\N
71408	1749	703989000000	3496	1814	0	0	\N
71410	1397	1414097543000	3499	1677	0	0	\N
71411	1397	1414087542000	3499	1677	1	0	\N
71412	1397	1414077541000	3499	1677	2	0	\N
71413	1397	1414067540000	3499	1677	3	0	\N
71414	1397	1414057539000	3499	1677	4	0	\N
71415	1397	1414047538000	3499	1677	5	0	\N
71416	1397	1414037537000	3499	1677	6	0	\N
71417	1397	1414027536000	3499	1677	7	0	\N
71418	1397	1414017535000	3499	1677	8	0	\N
71419	1397	1414007534000	3499	1677	9	0	\N
71420	1397	1413997533000	3499	1677	10	0	\N
71421	1397	1413987532000	3499	1677	11	0	\N
71422	1397	1413977531000	3499	1677	12	0	\N
71423	1397	1413967530000	3499	1677	13	0	\N
71424	1397	1413957529000	3499	1677	15	0	\N
71425	1397	1413947528000	3499	1677	16	0	\N
71426	1397	1413937527000	3499	1677	17	0	\N
71427	1397	1413927526000	3499	1677	18	0	\N
71428	1397	1413917525000	3499	1677	19	0	\N
71429	1397	1413907524000	3499	1677	20	0	\N
71430	1397	1413897523000	3499	1677	21	0	\N
71431	1397	1413887522000	3499	1677	22	0	\N
71432	1397	1413877521000	3499	1677	23	0	\N
71433	1397	1413867520000	3499	1677	24	0	\N
71434	1397	1413857519000	3499	1677	25	0	\N
71435	1397	1413847518000	3499	1677	26	0	\N
71436	1397	1413837517000	3499	1677	27	0	\N
71437	1397	1413827516000	3499	1677	28	0	\N
71438	1397	1413817515000	3499	1677	29	0	\N
71439	1397	1413807514000	3499	1677	30	0	\N
71440	1397	1413797513000	3499	1677	31	0	\N
71441	1397	1413787512000	3499	1677	32	0	\N
71442	1397	1413777511000	3499	1677	33	0	\N
71443	1397	1413767510000	3499	1677	34	0	\N
71444	1397	1413757509000	3499	1677	35	0	\N
71445	1397	1413747508000	3499	1677	36	0	\N
71446	1397	1413737507000	3499	1677	37	0	\N
71447	1397	1413727506000	3499	1677	38	0	\N
71448	1397	1413717505000	3499	1677	39	0	\N
71449	1397	1413707504000	3499	1677	40	0	\N
71450	1397	1413697503000	3499	1677	41	0	\N
71451	1397	1413687502000	3499	1677	42	0	\N
71452	1397	1413677501000	3499	1677	43	0	\N
71453	1397	1413667500000	3499	1677	44	0	\N
71454	1397	1413657499000	3499	1677	45	0	\N
71455	1397	1413647498000	3499	1677	46	0	\N
71456	1397	1413637497000	3499	1677	47	0	\N
71457	1397	1413627496000	3499	1677	48	0	\N
71458	1397	1413617495000	3499	1677	49	0	\N
71459	1397	1413607494000	3499	1677	50	0	\N
71460	1397	1413597493000	3499	1677	51	0	\N
71461	1397	1413587492000	3499	1677	52	0	\N
71462	1397	1413577491000	3499	1677	53	0	\N
71463	1397	1413567490000	3499	1677	54	0	\N
71464	1397	1413557489000	3499	1677	55	0	\N
71465	1749	703989000000	3499	1677	56	0	\N
71466	1750	7499000000	3499	1677	57	0	\N
71467	1750	7498000000	3499	1677	58	0	\N
71468	1750	6397000000	3499	1677	59	0	\N
71469	1764	5040009000000	3499	1677	60	0	\N
71470	1521	1437049000000	3499	1677	61	0	\N
71471	1775	1989000000	3503	1819	0	0	\N
71473	1775	1989000000	3505	1819	0	0	\N
71474	1709	6479241000000	3508	1821	0	0	\N
71476	1709	6479241000000	3510	1821	0	0	\N
71480	1709	5759240000000	3526	1793	0	0	\N
71481	1709	5759230000000	3526	1793	1	0	\N
71482	1749	703989000000	3526	1793	2	0	\N
71483	1722	70000000	3526	1793	3	0	\N
71484	1764	5040009000000	3526	1793	4	0	\N
71485	1521	1437049000000	3526	1793	5	0	\N
71486	1775	1967000000	3528	1832	0	0	\N
71488	1775	1967000000	3530	1832	0	0	\N
71489	1775	1967000000	3531	1832	0	0	\N
71492	329	66718800000000	3533	1833	0	0	\N
71493	1775	1946000000	3533	1833	1	0	\N
71494	329	66718800000000	3543	1710	0	0	\N
71495	1722	7932191000000	3543	1710	1	0	\N
71496	1709	5759240000000	3543	1710	2	0	\N
71497	1722	3612181000000	3543	1710	3	0	\N
71498	1722	171000000	3543	1710	4	0	\N
71499	1709	5759230000000	3543	1710	5	0	\N
71500	1750	7499000000	3543	1710	6	0	\N
71501	1722	70000000	3543	1710	7	0	\N
71502	1521	1437049000000	3543	1710	8	0	\N
71503	329	66718800000000	3628	1794	0	0	\N
71510	1709	6478221000000	3636	1885	0	0	\N
71511	443	66000388000000	3636	1885	1	0	\N
71512	530	66000099000000	3636	1885	2	0	\N
71513	1709	6478221000000	3637	1885	0	0	\N
71514	443	66000388000000	3637	1885	1	0	\N
71515	530	66000099000000	3637	1885	2	0	\N
71516	1709	5758220000000	3640	1712	0	0	\N
71517	1541	3599099000000	3640	1712	1	0	\N
71518	1541	3597098000000	3640	1712	2	0	\N
71519	443	66000389000000	3640	1712	3	0	\N
71520	443	66000388000000	3640	1712	4	0	\N
71523	1693	6506836500877	3665	1903	0	0	\N
71530	1397	1413517485000	3673	1907	0	0	\N
71531	1397	1413507484000	3674	1908	0	0	\N
71532	1397	1413507484000	3675	1908	0	0	\N
71534	1397	1413507484000	3677	1908	0	0	\N
71472	1775	1989000000	3504	1819	0	0	1
71475	1709	6479241000000	3509	1821	0	0	1
71477	1775	1978000000	3519	1827	0	0	2
71478	1709	6479231000000	3520	1828	0	0	2
71479	1722	70000000	3521	1829	0	0	8
71490	329	66718800000000	3532	1833	0	0	1
71491	1775	1946000000	3532	1833	1	0	4
71504	1541	3599099000000	3632	1882	0	0	1
71505	1541	3597098000000	3632	1882	1	0	2
71506	443	66000389000000	3633	1883	0	0	2
71508	443	66000388000000	3635	1885	1	0	3
71509	530	66000099000000	3635	1885	2	0	1
71521	1709	6477211000000	3644	1891	0	0	4
71522	1776	989000000	3653	1896	0	0	1
71525	1397	1413547488000	3669	1905	0	0	2529
71526	1397	1413537487000	3669	1905	1	0	2530
71527	1754	999000000	3669	1905	2	0	1
71528	1397	1413527486000	3670	1906	0	0	2531
71529	1397	1413517485000	3671	1907	0	0	2532
71535	1397	1413497483000	3678	1909	0	0	2534
71536	1397	1413487482000	3679	1910	0	0	2535
71537	1397	1413477481000	3680	1911	0	0	\N
71541	1778	90000000	3684	1914	0	0	\N
71542	1397	1413447478000	3684	1914	1	0	\N
71543	1397	1413437477000	3684	1914	2	0	\N
71547	1397	1413427476000	3686	1915	0	0	\N
71548	1397	1413417475000	3686	1915	1	0	\N
71551	1397	1413427476000	3688	1915	0	0	\N
71552	1397	1413417475000	3688	1915	1	0	\N
71554	1397	1413407474000	3690	1916	0	0	\N
71555	1397	1413407474000	3691	1916	0	0	\N
71556	1397	1413407474000	3692	1916	0	0	\N
71559	1397	1413377471000	3695	1919	0	0	\N
71560	1397	1413367470000	3695	1919	1	0	\N
71561	1754	798000000	3695	1919	2	0	\N
71566	1397	1413357469000	3698	1920	0	0	\N
71567	1397	1413347468000	3699	1921	0	0	\N
71569	1693	6506726500877	3701	1922	0	0	\N
71570	1397	1413337467000	3701	1922	1	0	\N
71571	1754	673543211	3701	1922	2	0	\N
71572	1693	6506726500877	3702	1922	0	0	\N
71573	1397	1413337467000	3702	1922	1	0	\N
71574	1754	673543211	3702	1922	2	0	\N
71578	1397	1413327466000	3704	1923	0	0	\N
71580	1397	1413327466000	3706	1923	0	0	\N
71587	1397	1413257459000	3710	1927	0	0	\N
71588	1397	1413247458000	3710	1927	1	0	\N
71591	1397	1413257459000	3712	1927	0	0	\N
71592	1397	1413247458000	3712	1927	1	0	\N
71594	1397	1413237457000	3714	1928	0	0	\N
71597	1397	1413217455000	3717	1930	0	0	\N
71598	1397	1413217455000	3718	1930	0	0	\N
71599	1397	1413217455000	3719	1930	0	0	\N
71600	1693	6506726500877	3720	1922	0	0	\N
71601	1397	1413337467000	3720	1922	1	0	\N
71602	1397	1413327466000	3720	1922	2	0	\N
71603	1397	1413317465000	3720	1922	4	0	\N
71604	1397	1413307464000	3720	1922	5	0	\N
71605	1397	1413297463000	3720	1922	6	0	\N
71606	1397	1413287462000	3720	1922	7	0	\N
71607	1397	1413277461000	3720	1922	8	0	\N
71608	1397	1413267460000	3720	1922	9	0	\N
71609	1397	1413257459000	3720	1922	10	0	\N
71610	1397	1413247458000	3720	1922	11	0	\N
71611	1397	1413207454000	3721	1931	0	0	\N
71615	1397	1413187452000	3725	1933	0	0	\N
71616	1397	1413187452000	3726	1933	0	0	\N
71617	1397	1413187452000	3727	1933	0	0	\N
71620	1397	1413157449000	3730	1936	0	0	\N
71621	1397	1413157449000	3731	1936	0	0	\N
71623	1397	1413157449000	3733	1936	0	0	\N
71625	1397	1413137447000	3735	1938	0	0	\N
71626	1397	1413127446000	3735	1938	1	0	\N
71629	1397	1413117445000	3737	1939	0	0	\N
71630	1397	1413117445000	3738	1939	0	0	\N
71632	1397	1413107444000	3740	1940	0	0	\N
71634	1397	1413107444000	3742	1940	0	0	\N
71635	1397	1413097443000	3743	1941	0	0	\N
71636	1266	606459749000000	3743	1941	1	0	\N
71639	1397	1413097443000	3745	1941	0	0	\N
71640	1266	606459749000000	3745	1941	1	0	\N
71641	1397	1413087442000	3746	1942	0	0	\N
71642	1397	1413077441000	3746	1942	1	0	\N
71648	1397	1413057439000	3750	1944	0	0	\N
71649	1397	1413047438000	3750	1944	1	0	\N
71651	1266	606459749000000	3752	1919	0	0	\N
71653	1397	1413027436000	3754	1946	0	0	\N
71659	1397	1412987432000	3758	1949	0	0	\N
71660	1397	1412977431000	3758	1949	1	0	\N
71661	1709	5757210000000	3759	1713	0	0	\N
71662	1266	606459749000000	3759	1713	1	0	\N
71666	1397	1412947428000	3763	1952	0	0	\N
71669	1397	1412917425000	3765	1954	0	0	\N
71670	1397	1412907424000	3765	1954	1	0	\N
71671	1397	1412917425000	3766	1954	0	0	\N
71672	1397	1412907424000	3766	1954	1	0	\N
71540	1397	1413457479000	3683	1913	0	0	2538
71544	1778	90000000	3685	1914	0	0	1
71545	1397	1413447478000	3685	1914	1	0	2539
71546	1397	1413437477000	3685	1914	2	0	2540
71549	1397	1413427476000	3687	1915	0	0	2541
71553	1397	1413407474000	3689	1916	0	0	2543
71557	1397	1413397473000	3693	1917	0	0	2544
71558	1397	1413387472000	3694	1918	0	0	2545
71562	1397	1413377471000	3696	1919	0	0	2546
71563	1397	1413367470000	3696	1919	1	0	2547
71565	1397	1413357469000	3697	1920	0	0	2548
71568	1397	1413347468000	3700	1921	0	0	2549
71575	1693	6506726500877	3703	1922	0	0	229
71576	1397	1413337467000	3703	1922	1	0	2550
71579	1397	1413327466000	3705	1923	0	0	2551
71581	1397	1413317465000	3707	1924	0	0	2552
71582	1397	1413307464000	3708	1925	0	0	2553
71583	1397	1413297463000	3709	1926	0	0	2554
71584	1397	1413287462000	3709	1926	1	0	2555
71586	1397	1413267460000	3709	1926	3	0	2557
71589	1397	1413257459000	3711	1927	0	0	2558
71590	1397	1413247458000	3711	1927	1	0	2559
71593	1397	1413237457000	3713	1928	0	0	2560
71595	1397	1413227456000	3715	1929	0	0	2561
71612	1397	1413207454000	3722	1931	0	0	2563
71613	1397	1413197453000	3723	1932	0	0	2564
71614	1397	1413187452000	3724	1933	0	0	2565
71618	1397	1413177451000	3728	1934	0	0	2566
71622	1397	1413157449000	3732	1936	0	0	2568
71624	1397	1413147448000	3734	1937	0	0	2569
71627	1397	1413137447000	3736	1938	0	0	2570
71628	1397	1413127446000	3736	1938	1	0	2571
71631	1397	1413117445000	3739	1939	0	0	2572
71637	1397	1413097443000	3744	1941	0	0	2574
71638	1266	606459749000000	3744	1941	1	0	1
71643	1397	1413087442000	3747	1942	0	0	2575
71644	1397	1413077441000	3747	1942	1	0	2576
71645	1397	1413067440000	3748	1943	0	0	2577
71647	1397	1413047438000	3749	1944	1	0	2579
71650	1397	1413037437000	3751	1945	0	0	2580
71652	1397	1413027436000	3753	1946	0	0	2581
71654	1397	1413017435000	3755	1947	0	0	2582
71656	1397	1412997433000	3756	1948	1	0	2584
71657	1397	1412987432000	3757	1949	0	0	2585
71658	1397	1412977431000	3757	1949	1	0	2586
71663	1397	1412967430000	3760	1950	0	0	2587
71664	1397	1412957429000	3761	1951	0	0	2588
71667	1397	1412937427000	3764	1953	0	0	2590
71668	1397	1412927426000	3764	1953	1	0	2591
71673	1397	1412917425000	3767	1954	0	0	\N
71674	1397	1412907424000	3767	1954	1	0	\N
71680	1397	1412877421000	3771	1956	0	0	\N
71681	1397	1412867420000	3772	1957	0	0	\N
71684	1397	1412847418000	3779	1959	0	0	\N
71686	1397	1412847418000	3781	1959	0	0	\N
71687	1397	1412837417000	3782	1960	0	0	\N
71688	1397	1412827416000	3782	1960	1	0	\N
71689	1397	1412837417000	3783	1960	0	0	\N
71690	1397	1412827416000	3783	1960	1	0	\N
71693	1397	1412837417000	3785	1960	0	0	\N
71694	1397	1412827416000	3785	1960	1	0	\N
71695	1397	1412837417000	3786	1960	0	0	\N
71696	1397	1412827416000	3786	1960	1	0	\N
71704	1397	1412787412000	3790	1963	0	0	\N
71705	1397	1412777411000	3790	1963	1	0	\N
71706	1397	1412767410000	3790	1963	2	0	\N
71707	1397	1412757409000	3790	1963	3	0	\N
71709	1397	1412747408000	3793	1964	0	0	\N
71713	1397	1412707404000	3797	1968	0	0	\N
71716	1397	1412687402000	3800	1970	0	0	\N
71717	1397	1412677401000	3800	1970	1	0	\N
71720	1397	1412687402000	3802	1970	0	0	\N
71721	1397	1412677401000	3802	1970	1	0	\N
71723	1397	1412657399000	3804	1972	0	0	\N
71724	1397	1412647398000	3804	1972	1	0	\N
71725	1397	1412637397000	3804	1972	2	0	\N
71726	1397	1412657399000	3805	1972	0	0	\N
71727	1397	1412647398000	3805	1972	1	0	\N
71728	1397	1412637397000	3805	1972	2	0	\N
71735	1397	1412597393000	3810	1976	0	0	\N
71737	1397	1412587392000	3812	1977	0	0	\N
71738	1397	1412577391000	3812	1977	1	0	\N
71739	1397	1412587392000	3813	1977	0	0	\N
71740	1397	1412577391000	3813	1977	1	0	\N
71743	1397	1412587392000	3815	1977	0	0	\N
71744	1397	1412577391000	3815	1977	1	0	\N
71745	1397	1412567390000	3816	1978	0	0	\N
71747	1397	1412567390000	3818	1978	0	0	\N
71749	1397	1412557389000	3820	1979	0	0	\N
71758	329	66718800000000	3826	1793	0	0	\N
71759	1397	1413547488000	3826	1793	1	0	\N
71760	1397	1413537487000	3826	1793	2	0	\N
71761	1709	5759240000000	3826	1793	3	0	\N
71762	1693	2186836500877	3826	1793	4	0	\N
71763	1693	2186726500877	3826	1793	5	0	\N
71764	1397	1413527486000	3826	1793	6	0	\N
71765	1397	1413517485000	3826	1793	7	0	\N
71766	1397	1413507484000	3826	1793	8	0	\N
71767	1397	1413497483000	3826	1793	9	0	\N
71768	1397	1413487482000	3826	1793	10	0	\N
71769	1709	5759230000000	3826	1793	11	0	\N
71770	1709	5758220000000	3826	1793	12	0	\N
71771	1709	5757210000000	3826	1793	13	0	\N
71772	1397	1413477481000	3826	1793	14	0	\N
71773	1397	1413467480000	3826	1793	15	0	\N
71774	1397	1413457479000	3826	1793	16	0	\N
71775	1397	1413447478000	3826	1793	17	0	\N
71776	1397	1413437477000	3826	1793	18	0	\N
71777	1397	1413427476000	3826	1793	19	0	\N
71778	1397	1413417475000	3826	1793	20	0	\N
71779	1397	1413407474000	3826	1793	21	0	\N
71780	1397	1413397473000	3826	1793	22	0	\N
71781	1397	1413387472000	3826	1793	23	0	\N
71782	1397	1413377471000	3826	1793	24	0	\N
71783	1397	1413367470000	3826	1793	25	0	\N
71784	1397	1413357469000	3826	1793	26	0	\N
71785	1397	1413347468000	3826	1793	27	0	\N
71786	1397	1413337467000	3826	1793	28	0	\N
71787	1397	1413327466000	3826	1793	29	0	\N
71788	1397	1413317465000	3826	1793	30	0	\N
71789	1397	1413307464000	3826	1793	31	0	\N
71790	1397	1413297463000	3826	1793	32	0	\N
71791	1397	1413287462000	3826	1793	33	0	\N
71792	1397	1413277461000	3826	1793	34	0	\N
71793	1397	1413267460000	3826	1793	35	0	\N
71794	1397	1413257459000	3826	1793	36	0	\N
71795	1397	1413247458000	3826	1793	37	0	\N
71796	1397	1413237457000	3826	1793	38	0	\N
71797	1397	1413227456000	3826	1793	39	0	\N
71798	1397	1413217455000	3826	1793	40	0	\N
71799	1397	1413207454000	3826	1793	41	0	\N
71800	1397	1413197453000	3826	1793	42	0	\N
71801	1397	1413187452000	3826	1793	43	0	\N
71802	1397	1413177451000	3826	1793	44	0	\N
71803	1397	1413167450000	3826	1793	45	0	\N
71804	1397	1413157449000	3826	1793	46	0	\N
71805	1397	1413147448000	3826	1793	47	0	\N
71806	1397	1413137447000	3826	1793	48	0	\N
71807	1397	1413127446000	3826	1793	49	0	\N
71808	1397	1413117445000	3826	1793	50	0	\N
71677	1397	1412897423000	3769	1955	0	0	2594
71678	1397	1412887422000	3769	1955	1	0	2595
71679	1397	1412877421000	3770	1956	0	0	2596
71682	1397	1412867420000	3775	1957	0	0	2597
71683	1397	1412857419000	3778	1958	0	0	2598
71691	1397	1412837417000	3784	1960	0	0	2600
71692	1397	1412827416000	3784	1960	1	0	2601
71697	1397	1412817415000	3787	1961	0	0	2602
71698	1397	1412807414000	3788	1962	0	0	2603
71699	1397	1412797413000	3788	1962	1	0	2604
71701	1397	1412777411000	3789	1963	1	0	2606
71702	1397	1412767410000	3789	1963	2	0	2607
71703	1397	1412757409000	3789	1963	3	0	2608
71708	1397	1412747408000	3792	1964	0	0	2609
71711	1397	1412727406000	3795	1966	0	0	2611
71712	1397	1412717405000	3796	1967	0	0	2612
71714	1397	1412707404000	3798	1968	0	0	2613
71715	1397	1412697403000	3799	1969	0	0	2614
71718	1397	1412687402000	3801	1970	0	0	2615
71722	1397	1412667400000	3803	1971	0	0	2617
71729	1397	1412657399000	3806	1972	0	0	2618
71730	1397	1412647398000	3806	1972	1	0	2619
71731	1397	1412637397000	3806	1972	2	0	2620
71732	1397	1412627396000	3807	1973	0	0	2621
71734	1397	1412607394000	3809	1975	0	0	2623
71736	1397	1412597393000	3811	1976	0	0	2624
71741	1397	1412587392000	3814	1977	0	0	2625
71742	1397	1412577391000	3814	1977	1	0	2626
71748	1397	1412557389000	3819	1979	0	0	2628
71750	1397	1412547388000	3821	1980	0	0	2629
71751	1397	1412537387000	3822	1981	0	0	2630
71752	1397	1412527386000	3823	1982	0	0	2631
71753	1397	1412517385000	3823	1982	1	0	2632
71755	1397	1412507384000	3824	1983	1	0	2633
71756	1780	718910000000	3825	1984	0	0	1
71757	1397	1412497383000	3825	1984	1	0	2634
71809	1397	1413107444000	3826	1793	51	0	\N
71810	1397	1413097443000	3826	1793	52	0	\N
71811	1397	1413087442000	3826	1793	53	0	\N
71812	1397	1413077441000	3826	1793	54	0	\N
71813	1397	1413067440000	3826	1793	55	0	\N
71814	1397	1413057439000	3826	1793	56	0	\N
71815	1397	1413047438000	3826	1793	57	0	\N
71816	1397	1413037437000	3826	1793	58	0	\N
71817	1397	1413027436000	3826	1793	59	0	\N
71818	1397	1413017435000	3826	1793	60	0	\N
71819	1397	1413007434000	3826	1793	61	0	\N
71820	1397	1412997433000	3826	1793	62	0	\N
71821	1397	1412987432000	3826	1793	63	0	\N
71822	1397	1412977431000	3826	1793	64	0	\N
71823	1397	1412967430000	3826	1793	65	0	\N
71824	1397	1412957429000	3826	1793	66	0	\N
71825	1397	1412947428000	3826	1793	67	0	\N
71826	1397	1412937427000	3826	1793	68	0	\N
71827	1397	1412927426000	3826	1793	69	0	\N
71828	1397	1412917425000	3826	1793	70	0	\N
71829	1397	1412907424000	3826	1793	71	0	\N
71830	1397	1412897423000	3826	1793	72	0	\N
71831	1397	1412887422000	3826	1793	73	0	\N
71832	1397	1412877421000	3826	1793	74	0	\N
71833	1397	1412867420000	3826	1793	75	0	\N
71834	1397	1412857419000	3826	1793	76	0	\N
71835	1397	1412847418000	3826	1793	77	0	\N
71836	1397	1412837417000	3826	1793	78	0	\N
71837	1397	1412827416000	3826	1793	79	0	\N
71838	1397	1412817415000	3826	1793	80	0	\N
71839	1397	1412807414000	3826	1793	82	0	\N
71840	1397	1412797413000	3826	1793	83	0	\N
71841	1397	1412787412000	3826	1793	84	0	\N
71842	1397	1412777411000	3826	1793	85	0	\N
71843	1397	1412767410000	3826	1793	86	0	\N
71844	1397	1412757409000	3826	1793	87	0	\N
71845	1397	1412747408000	3826	1793	88	0	\N
71846	1397	1412737407000	3826	1793	89	0	\N
71847	1397	1412727406000	3826	1793	90	0	\N
71848	1397	1412717405000	3826	1793	91	0	\N
71849	1397	1412707404000	3826	1793	92	0	\N
71850	1397	1412697403000	3826	1793	93	0	\N
71851	1397	1412687402000	3826	1793	94	0	\N
71852	1397	1412677401000	3826	1793	95	0	\N
71853	1397	1412667400000	3826	1793	96	0	\N
71854	1397	1412657399000	3826	1793	97	0	\N
71855	1397	1412647398000	3826	1793	98	0	\N
71856	1397	1412637397000	3826	1793	99	0	\N
71857	1397	1412627396000	3826	1793	100	0	\N
71858	1397	1412617395000	3826	1793	101	0	\N
71859	1397	1412607394000	3826	1793	102	0	\N
71860	1397	1412597393000	3826	1793	103	0	\N
71861	1397	1412587392000	3826	1793	104	0	\N
71862	1397	1412577391000	3826	1793	105	0	\N
71863	1397	1412567390000	3826	1793	106	0	\N
71864	1397	1412557389000	3826	1793	107	0	\N
71865	1397	1412547388000	3826	1793	108	0	\N
71866	1397	1412537387000	3826	1793	109	0	\N
71867	1397	1412527386000	3826	1793	110	0	\N
71868	1397	1412517385000	3826	1793	111	0	\N
71873	1590	5700000000	3830	1988	0	0	\N
71874	1397	1412457379000	3830	1988	1	0	\N
71890	1397	1412337367000	3839	1995	0	0	\N
71891	1590	5700000000	3840	1891	0	0	\N
71892	1765	70000000	3840	1891	1	0	\N
71893	1709	6477211000000	3840	1891	2	0	\N
71894	1397	1413547488000	3840	1891	3	0	\N
71895	1397	1413537487000	3840	1891	4	0	\N
71896	1693	5786836500877	3840	1891	5	0	\N
71897	1693	5786726500877	3840	1891	6	0	\N
71898	1397	1413527486000	3840	1891	7	0	\N
71899	1397	1413517485000	3840	1891	8	0	\N
71900	1397	1413507484000	3840	1891	9	0	\N
71901	1397	1413497483000	3840	1891	10	0	\N
71902	1397	1413487482000	3840	1891	11	0	\N
71903	1397	1413477481000	3840	1891	12	0	\N
71904	1397	1413467480000	3840	1891	13	0	\N
71905	1397	1413457479000	3840	1891	14	0	\N
71906	1397	1413447478000	3840	1891	15	0	\N
71907	1397	1413437477000	3840	1891	16	0	\N
71908	1397	1413427476000	3840	1891	17	0	\N
71909	1397	1413417475000	3840	1891	18	0	\N
71910	1397	1413407474000	3840	1891	19	0	\N
71911	1397	1413397473000	3840	1891	20	0	\N
71912	1397	1413387472000	3840	1891	21	0	\N
71913	1397	1413377471000	3840	1891	22	0	\N
71914	1397	1413367470000	3840	1891	23	0	\N
71915	1397	1413357469000	3840	1891	24	0	\N
71916	1397	1413347468000	3840	1891	25	0	\N
71917	1397	1413337467000	3840	1891	26	0	\N
71918	1397	1413327466000	3840	1891	27	0	\N
71919	1397	1413317465000	3840	1891	28	0	\N
71920	1397	1413307464000	3840	1891	29	0	\N
71921	1397	1413297463000	3840	1891	30	0	\N
71922	1397	1413287462000	3840	1891	31	0	\N
71923	1397	1413277461000	3840	1891	32	0	\N
71924	1397	1413267460000	3840	1891	33	0	\N
71925	1397	1413257459000	3840	1891	34	0	\N
71926	1397	1413247458000	3840	1891	35	0	\N
71927	1397	1413237457000	3840	1891	36	0	\N
71928	1397	1413227456000	3840	1891	37	0	\N
71929	1397	1413217455000	3840	1891	38	0	\N
71930	1397	1413207454000	3840	1891	39	0	\N
71931	1397	1413197453000	3840	1891	40	0	\N
71932	1397	1413187452000	3840	1891	41	0	\N
71933	1397	1413177451000	3840	1891	42	0	\N
71934	1397	1413167450000	3840	1891	43	0	\N
71935	1397	1413157449000	3840	1891	44	0	\N
71936	1397	1413147448000	3840	1891	45	0	\N
71937	1397	1413137447000	3840	1891	46	0	\N
71938	1397	1413127446000	3840	1891	47	0	\N
71939	1397	1413117445000	3840	1891	48	0	\N
71940	1397	1413107444000	3840	1891	49	0	\N
71941	1397	1413097443000	3840	1891	50	0	\N
71942	1397	1413087442000	3840	1891	51	0	\N
71943	1397	1413077441000	3840	1891	52	0	\N
71944	1397	1413067440000	3840	1891	53	0	\N
71871	1397	1412477381000	3828	1986	0	0	2636
71872	1397	1412467380000	3829	1987	0	0	2637
71875	1590	5700000000	3831	1988	0	0	2
71876	1397	1412457379000	3831	1988	1	0	2638
71877	871	109739593307813	3832	1989	0	0	1
71879	1397	1412437377000	3832	1989	2	0	2640
71880	1397	1412427376000	3832	1989	3	0	2641
71881	1397	1412417375000	3833	1990	0	0	2642
71882	1397	1412407374000	3833	1990	1	0	2643
71883	1397	1412397373000	3834	1991	0	0	2644
71885	1397	1412377371000	3835	1992	0	0	2646
71886	1397	1412367370000	3836	1993	0	0	2647
71887	1397	1412357369000	3836	1993	1	0	2648
71888	1397	1412347368000	3837	1994	0	0	2649
71945	1397	1413057439000	3840	1891	54	0	\N
71946	1397	1413047438000	3840	1891	55	0	\N
71947	1397	1413037437000	3840	1891	56	0	\N
71948	1397	1413027436000	3840	1891	57	0	\N
71949	1397	1413017435000	3840	1891	58	0	\N
71950	1397	1413007434000	3840	1891	59	0	\N
71951	1397	1412997433000	3840	1891	60	0	\N
71952	1397	1412987432000	3840	1891	61	0	\N
71953	1397	1412977431000	3840	1891	62	0	\N
71954	1397	1412967430000	3840	1891	63	0	\N
71955	1397	1412957429000	3840	1891	64	0	\N
71956	1397	1412947428000	3840	1891	65	0	\N
71957	1397	1412937427000	3840	1891	66	0	\N
71958	1397	1412927426000	3840	1891	67	0	\N
71959	1397	1412917425000	3840	1891	68	0	\N
71960	1397	1412907424000	3840	1891	69	0	\N
71961	1397	1412897423000	3840	1891	70	0	\N
71962	1397	1412887422000	3840	1891	71	0	\N
71963	1397	1412877421000	3840	1891	72	0	\N
71964	1397	1412867420000	3840	1891	73	0	\N
71965	1397	1412857419000	3840	1891	74	0	\N
71966	1397	1412847418000	3840	1891	75	0	\N
71967	1397	1412837417000	3840	1891	76	0	\N
71968	1397	1412827416000	3840	1891	77	0	\N
71969	1397	1412817415000	3840	1891	78	0	\N
71970	1397	1412807414000	3840	1891	79	0	\N
71971	1397	1412797413000	3840	1891	80	0	\N
71972	1397	1412787412000	3840	1891	82	0	\N
71973	1397	1412777411000	3840	1891	83	0	\N
71974	1397	1412767410000	3840	1891	84	0	\N
71975	1397	1412757409000	3840	1891	85	0	\N
71976	1397	1412747408000	3840	1891	86	0	\N
71977	1397	1412737407000	3840	1891	87	0	\N
71978	1397	1412727406000	3840	1891	88	0	\N
71979	1397	1412717405000	3840	1891	89	0	\N
71980	1397	1412707404000	3840	1891	90	0	\N
71981	1397	1412697403000	3840	1891	91	0	\N
71982	1397	1412687402000	3840	1891	92	0	\N
71983	1397	1412677401000	3840	1891	93	0	\N
71984	1397	1412667400000	3840	1891	94	0	\N
71985	1397	1412657399000	3840	1891	95	0	\N
71986	1397	1412647398000	3840	1891	96	0	\N
71987	1397	1412637397000	3840	1891	97	0	\N
71988	1397	1412627396000	3840	1891	98	0	\N
71989	1397	1412617395000	3840	1891	99	0	\N
71990	1397	1412607394000	3840	1891	100	0	\N
71991	1397	1412597393000	3840	1891	101	0	\N
71992	1397	1412587392000	3840	1891	102	0	\N
71993	1397	1412577391000	3840	1891	103	0	\N
71994	1397	1412567390000	3840	1891	104	0	\N
71995	1397	1412557389000	3840	1891	105	0	\N
71996	1397	1412547388000	3840	1891	106	0	\N
71997	1397	1412537387000	3840	1891	107	0	\N
71998	1397	1412527386000	3840	1891	108	0	\N
71999	1397	1412517385000	3840	1891	109	0	\N
72000	1397	1412507384000	3840	1891	110	0	\N
72001	1397	1412497383000	3840	1891	111	0	\N
72002	1397	1412487382000	3840	1891	112	0	\N
72003	1397	1412477381000	3840	1891	113	0	\N
72004	1397	1412467380000	3840	1891	114	0	\N
72005	1397	1412457379000	3840	1891	115	0	\N
72006	1397	1412447378000	3840	1891	116	0	\N
72007	1397	1412437377000	3840	1891	117	0	\N
72008	1397	1412427376000	3840	1891	118	0	\N
72009	1397	1412417375000	3840	1891	119	0	\N
72010	1397	1412407374000	3840	1891	120	0	\N
72011	1397	1412397373000	3840	1891	121	0	\N
72012	1397	1412387372000	3840	1891	122	0	\N
72013	1397	1412377371000	3840	1891	123	0	\N
72014	1397	1412367370000	3840	1891	124	0	\N
72015	1397	1412357369000	3840	1891	125	0	\N
72017	1397	1412317365000	3842	1997	0	0	\N
72018	1397	1412307364000	3842	1997	1	0	\N
72019	1397	1412317365000	3843	1997	0	0	\N
72020	1397	1412307364000	3843	1997	1	0	\N
72021	1397	1412317365000	3844	1997	0	0	\N
72022	1397	1412307364000	3844	1997	1	0	\N
72023	1397	1412317365000	3845	1997	0	0	\N
72024	1397	1412307364000	3845	1997	1	0	\N
72028	1397	1412297363000	3848	1998	0	0	\N
72029	1397	1412287362000	3849	1999	0	0	\N
72030	1397	1412277361000	3849	1999	1	0	\N
72033	1397	1412287362000	3851	1999	0	0	\N
72034	1397	1412277361000	3851	1999	1	0	\N
72035	1397	1412267360000	3852	2000	0	0	\N
72038	1397	1412247358000	3855	2002	0	0	\N
72039	1397	1412237357000	3855	2002	1	0	\N
72040	1397	1412227356000	3855	2002	2	0	\N
72041	1397	1412217355000	3855	2002	3	0	\N
72047	1397	1412207354000	3858	2003	0	0	\N
72048	1397	1412207354000	3859	2003	0	0	\N
72050	1397	1412187352000	3861	2005	0	0	\N
72055	1397	1412177351000	3864	2006	0	0	\N
72056	1397	1412167350000	3864	2006	1	0	\N
72057	1397	1412157349000	3864	2006	2	0	\N
72058	1397	1412177351000	3865	2006	0	0	\N
72059	1397	1412167350000	3865	2006	1	0	\N
72060	1397	1412157349000	3865	2006	2	0	\N
72064	1397	1412137347000	3868	2008	0	0	\N
72065	1397	1412127346000	3868	2008	1	0	\N
72068	1397	1412107344000	3871	2010	0	0	\N
72069	1397	1412107344000	3872	2010	0	0	\N
72073	1397	1412077341000	3876	2013	0	0	\N
72075	1397	1412067340000	3878	2014	0	0	\N
72076	1397	1412067340000	3879	2014	0	0	\N
72026	1397	1412307364000	3846	1997	1	0	2653
72027	1397	1412297363000	3847	1998	0	0	2654
72031	1397	1412287362000	3850	1999	0	0	2655
72032	1397	1412277361000	3850	1999	1	0	2656
72036	1397	1412267360000	3853	2000	0	0	2657
72042	1397	1412247358000	3856	2002	0	0	2659
72043	1397	1412237357000	3856	2002	1	0	2660
72044	1397	1412227356000	3856	2002	2	0	2661
72045	1397	1412217355000	3856	2002	3	0	2662
72046	1397	1412207354000	3857	2003	0	0	2663
72051	1397	1412187352000	3862	2005	0	0	2665
72052	1397	1412177351000	3863	2006	0	0	2666
72053	1397	1412167350000	3863	2006	1	0	2667
72054	1397	1412157349000	3863	2006	2	0	2668
72062	1397	1412137347000	3867	2008	0	0	2670
72063	1397	1412127346000	3867	2008	1	0	2671
72066	1397	1412117345000	3869	2009	0	0	2672
72067	1397	1412107344000	3870	2010	0	0	2673
72070	1397	1412097343000	3873	2011	0	0	2674
72072	1397	1412077341000	3875	2013	0	0	2676
72074	1397	1412067340000	3877	2014	0	0	2677
72077	1397	1412057339000	3880	2015	0	0	2678
72078	1397	1412047338000	3881	2016	0	0	2679
72079	1397	1412037337000	3882	2017	0	0	2680
72082	1397	1412027336000	3884	2018	0	0	\N
72083	1397	1412017335000	3884	2018	1	0	\N
72084	1397	1412007334000	3885	2019	0	0	\N
72086	1397	1411997333000	3887	2020	0	0	\N
72087	1397	1411987332000	3887	2020	1	0	\N
72091	1397	1411967330000	3894	2022	0	0	\N
72092	1397	1411957329000	3894	2022	1	0	\N
72096	1397	1411947328000	3897	2023	0	0	\N
72098	1397	1411937327000	3899	2024	0	0	\N
72100	1397	1411917325000	3901	2026	0	0	\N
72102	1397	1411907324000	3903	2027	0	0	\N
72103	1397	1411897323000	3903	2027	1	0	\N
72109	1397	1411877321000	3907	2029	0	0	\N
72110	1397	1411867320000	3907	2029	1	0	\N
72111	1397	1411877321000	3908	2029	0	0	\N
72112	1397	1411867320000	3908	2029	1	0	\N
72114	1397	1411847318000	3911	2031	0	0	\N
72115	1397	1411837317000	3911	2031	1	0	\N
72119	1397	1411817315000	3918	2033	0	0	\N
72122	1397	1411807314000	3921	2034	0	0	\N
72124	1397	1411787312000	3923	2036	0	0	\N
72125	1397	1411777311000	3923	2036	1	0	\N
72126	1397	1411787312000	3924	2036	0	0	\N
72127	1397	1411777311000	3924	2036	1	0	\N
72130	1397	1411787312000	3926	2036	0	0	\N
72131	1397	1411777311000	3926	2036	1	0	\N
72132	1397	1412347368000	3927	1892	0	0	\N
72133	1397	1412337367000	3927	1892	1	0	\N
72134	1397	1412327366000	3927	1892	2	0	\N
72135	1397	1412317365000	3927	1892	3	0	\N
72136	1397	1412307364000	3927	1892	4	0	\N
72137	1397	1412297363000	3927	1892	5	0	\N
72138	1397	1412287362000	3927	1892	6	0	\N
72139	1397	1412277361000	3927	1892	7	0	\N
72140	1397	1412267360000	3927	1892	8	0	\N
72141	1397	1412257359000	3927	1892	9	0	\N
72142	1397	1412247358000	3927	1892	10	0	\N
72143	1397	1412237357000	3927	1892	11	0	\N
72144	1397	1412227356000	3927	1892	12	0	\N
72145	1397	1412217355000	3927	1892	13	0	\N
72146	1397	1412207354000	3927	1892	14	0	\N
72147	1397	1412197353000	3927	1892	15	0	\N
72148	1397	1412187352000	3927	1892	16	0	\N
72149	1397	1412177351000	3927	1892	17	0	\N
72150	1397	1412167350000	3927	1892	18	0	\N
72151	1397	1412157349000	3927	1892	19	0	\N
72152	1397	1412147348000	3927	1892	20	0	\N
72153	1397	1412137347000	3927	1892	21	0	\N
72154	1397	1412127346000	3927	1892	22	0	\N
72155	1397	1412117345000	3927	1892	23	0	\N
72156	1397	1412107344000	3927	1892	24	0	\N
72157	1397	1412097343000	3927	1892	25	0	\N
72158	1397	1412087342000	3927	1892	26	0	\N
72159	1397	1412077341000	3927	1892	27	0	\N
72160	1397	1412067340000	3927	1892	28	0	\N
72161	1397	1412057339000	3927	1892	29	0	\N
72162	1397	1412047338000	3927	1892	30	0	\N
72163	1397	1412037337000	3927	1892	31	0	\N
72164	1397	1412027336000	3927	1892	32	0	\N
72165	1397	1412017335000	3927	1892	33	0	\N
72166	1397	1412007334000	3927	1892	34	0	\N
72167	1397	1411997333000	3927	1892	35	0	\N
72168	1397	1411987332000	3927	1892	36	0	\N
72169	1397	1411977331000	3927	1892	37	0	\N
72170	1397	1411967330000	3927	1892	38	0	\N
72171	1397	1411957329000	3927	1892	39	0	\N
72172	1397	1411947328000	3927	1892	40	0	\N
72173	1397	1411937327000	3927	1892	41	0	\N
72174	1397	1411927326000	3927	1892	42	0	\N
72175	1397	1411917325000	3927	1892	43	0	\N
72176	1397	1411907324000	3927	1892	44	0	\N
72177	1397	1411897323000	3927	1892	45	0	\N
72178	1397	1411887322000	3927	1892	46	0	\N
72179	1397	1411877321000	3927	1892	47	0	\N
72180	1397	1411867320000	3927	1892	48	0	\N
72181	1397	1411857319000	3927	1892	49	0	\N
72182	1397	1411847318000	3927	1892	50	0	\N
72183	1397	1411837317000	3927	1892	51	0	\N
72184	1397	1411827316000	3927	1892	52	0	\N
72185	1397	1411817315000	3927	1892	53	0	\N
72186	1397	1411807314000	3927	1892	54	0	\N
72187	1397	1411797313000	3927	1892	55	0	\N
72188	1397	1411787312000	3927	1892	56	0	\N
72189	1397	1411777311000	3927	1892	57	0	\N
72190	1266	606459749000000	3927	1892	58	0	\N
72191	1754	5999000000	3927	1892	59	0	\N
72192	1754	5798000000	3927	1892	60	0	\N
72193	1754	5673543211	3927	1892	61	0	\N
72197	1397	1411737307000	3930	2039	0	0	\N
72198	1397	1411727306000	3930	2039	1	0	\N
72199	1397	1411737307000	3931	2039	0	0	\N
72200	1397	1411727306000	3931	2039	1	0	\N
72205	1397	1411707304000	3935	2041	0	0	\N
72212	1397	1411637297000	3941	2046	0	0	\N
72216	1397	1411627296000	3944	2047	0	0	\N
72088	1397	1411997333000	3889	2020	0	0	2684
72089	1397	1411987332000	3889	2020	1	0	2685
72090	1397	1411977331000	3893	2021	0	0	2686
72093	1397	1411967330000	3895	2022	0	0	2687
72094	1397	1411957329000	3895	2022	1	0	2688
72097	1397	1411937327000	3898	2024	0	0	2690
72099	1397	1411927326000	3900	2025	0	0	2691
72101	1397	1411917325000	3902	2026	0	0	2692
72104	1397	1411907324000	3904	2027	0	0	2693
72105	1397	1411897323000	3904	2027	1	0	2694
72107	1397	1411877321000	3906	2029	0	0	2696
72108	1397	1411867320000	3906	2029	1	0	2697
72113	1397	1411857319000	3909	2030	0	0	2698
72116	1397	1411847318000	3912	2031	0	0	2699
72118	1397	1411827316000	3917	2032	0	0	2701
72120	1397	1411817315000	3919	2033	0	0	2702
72121	1397	1411807314000	3920	2034	0	0	2703
72123	1397	1411797313000	3922	2035	0	0	2704
72128	1397	1411787312000	3925	2036	0	0	2705
72194	1397	1411767310000	3928	2037	0	0	2707
72195	1397	1411757309000	3929	2038	0	0	2708
72196	1397	1411747308000	3929	2038	1	0	2709
72201	1397	1411737307000	3932	2039	0	0	2710
72202	1397	1411727306000	3932	2039	1	0	2711
72204	1397	1411707304000	3934	2041	0	0	2713
72206	1397	1411697303000	3936	2042	0	0	2714
72207	1397	1411687302000	3937	2043	0	0	2715
72208	1397	1411677301000	3938	2044	0	0	2716
72210	1397	1411657299000	3939	2045	0	0	2718
72211	1397	1411647298000	3939	2045	1	0	2719
72213	1397	1411637297000	3942	2046	0	0	2720
72214	1397	1411627296000	3943	2047	0	0	2721
72215	1397	1411617295000	3943	2047	1	0	2722
72217	1397	1411617295000	3944	2047	1	0	\N
72232	1397	1411517285000	3951	2054	0	0	\N
72235	1397	1411497283000	3954	2056	0	0	\N
72236	1397	1411497283000	3955	2056	0	0	\N
72241	1397	1411467280000	3960	2059	0	0	\N
72242	1397	1411467280000	3961	2059	0	0	\N
72243	1397	1411457279000	3962	2060	0	0	\N
72245	1397	1411457279000	3964	2060	0	0	\N
72246	1397	1411457279000	3965	2060	0	0	\N
72247	1590	5700000000	3966	1988	0	0	\N
72248	1722	79000000	3966	1988	1	0	\N
72249	1749	5755088000000	3966	1988	2	0	\N
72250	1759	7199999000000	3966	1988	3	0	\N
72251	1764	5760008000000	3966	1988	4	0	\N
72252	1722	78000000	3966	1988	5	0	\N
72255	1397	1411427276000	3968	2062	0	0	\N
72257	1397	1411417275000	3970	2063	0	0	\N
72259	1397	1411407274000	3972	2064	0	0	\N
72260	1397	1411407274000	3973	2064	0	0	\N
72261	1397	1411407274000	3974	2064	0	0	\N
72263	1397	1411397273000	3976	2065	0	0	\N
72268	1397	1411367270000	3980	2067	0	0	\N
72269	1397	1411357269000	3981	2068	0	0	\N
72270	1397	1411357269000	3982	2068	0	0	\N
72274	1397	1411347268000	3985	2069	0	0	\N
72275	1397	1411337267000	3985	2069	1	0	\N
72277	1397	1411317265000	3987	2071	0	0	\N
72280	1397	1411307264000	3990	2072	0	0	\N
72281	1397	1411307264000	3991	2072	0	0	\N
72282	1397	1411307264000	3992	2072	0	0	\N
72283	1397	1411307264000	3993	2072	0	0	\N
72285	1397	1411287262000	3995	2074	0	0	\N
72286	1397	1411287262000	3996	2074	0	0	\N
72290	1397	1411257259000	3999	2076	0	0	\N
72291	1397	1411257259000	4000	2076	0	0	\N
72293	1397	1411247258000	4002	2077	0	0	\N
72295	1397	1411237257000	4004	2078	0	0	\N
72300	1397	1411197253000	4008	2081	0	0	\N
72302	1397	1411187252000	4011	2082	0	0	\N
72303	1397	1411177251000	4011	2082	1	0	\N
72304	1397	1411187252000	4012	2082	0	0	\N
72305	1397	1411177251000	4012	2082	1	0	\N
72308	1397	1411187252000	4014	2082	0	0	\N
72309	1397	1411177251000	4014	2082	1	0	\N
72311	1397	1411167250000	4016	2083	0	0	\N
72312	1397	1411167250000	4017	2083	0	0	\N
72314	1397	1411157249000	4019	2084	0	0	\N
72325	1397	1411067240000	4027	2091	0	0	\N
72326	1397	1411067240000	4028	2091	0	0	\N
72328	1397	1411047238000	4030	2093	0	0	\N
72330	1397	1411047238000	4032	2093	0	0	\N
72332	1397	1411027236000	4034	2095	0	0	\N
72333	1397	1411027236000	4035	2095	0	0	\N
72340	1397	1410997233000	4041	2098	0	0	\N
72341	1397	1410987232000	4041	2098	1	0	\N
72342	1397	1410977231000	4041	2098	2	0	\N
72346	1397	1410947228000	4044	2100	0	0	\N
72347	1397	1410937227000	4045	2101	0	0	\N
72220	1722	79000000	3945	2048	2	0	9
72221	1397	1411587292000	3946	2049	0	0	2725
72222	1749	5755088000000	3946	2049	1	0	3
72223	1759	8640029000000	3946	2049	2	0	1
72224	1764	6480018000000	3946	2049	3	0	2
72226	1397	1411577291000	3947	2050	0	0	2726
72227	1397	1411567290000	3948	2051	0	0	2727
72228	1397	1411557289000	3949	2052	0	0	2728
72229	1397	1411547288000	3949	2052	1	0	2729
72230	1397	1411537287000	3949	2052	2	0	2730
72233	1397	1411517285000	3952	2054	0	0	2732
72234	1397	1411507284000	3953	2055	0	0	2733
72237	1397	1411497283000	3956	2056	0	0	2734
72238	1397	1411487282000	3957	2057	0	0	2735
72240	1397	1411467280000	3959	2059	0	0	2737
72244	1397	1411457279000	3963	2060	0	0	2738
72253	1397	1411447278000	3967	2061	0	0	2739
72254	1397	1411437277000	3967	2061	1	0	2740
72256	1397	1411427276000	3969	2062	0	0	2741
72262	1397	1411407274000	3975	2064	0	0	2743
72264	1397	1411397273000	3977	2065	0	0	2744
72265	1397	1411387272000	3978	2066	0	0	2745
72266	1397	1411377271000	3978	2066	1	0	2746
72267	1397	1411367270000	3979	2067	0	0	2747
72272	1397	1411347268000	3984	2069	0	0	2749
72273	1397	1411337267000	3984	2069	1	0	2750
72276	1397	1411327266000	3986	2070	0	0	2751
72278	1397	1411317265000	3988	2071	0	0	2752
72284	1397	1411297263000	3994	2073	0	0	2754
72287	1397	1411287262000	3997	2074	0	0	2755
72288	1397	1411277261000	3998	2075	0	0	2756
72289	1397	1411267260000	3998	2075	1	0	2757
72292	1397	1411257259000	4001	2076	0	0	2758
72296	1397	1411237257000	4005	2078	0	0	2760
72297	1397	1411227256000	4006	2079	0	0	2761
72298	1397	1411217255000	4006	2079	1	0	2762
72299	1397	1411207254000	4007	2080	0	0	2763
72301	1397	1411197253000	4009	2081	0	0	2764
72307	1397	1411177251000	4013	2082	1	0	2766
72310	1397	1411167250000	4015	2083	0	0	2767
72313	1397	1411157249000	4018	2084	0	0	2768
72315	1397	1411147248000	4020	2085	0	0	2769
72317	1397	1411127246000	4021	2086	0	0	2771
72318	1397	1411117245000	4021	2086	1	0	2772
72319	1738	718910000000	4022	2087	0	0	1
72320	1397	1411107244000	4022	2087	1	0	2773
72321	1397	1411097243000	4023	2088	0	0	2774
72323	1397	1411077241000	4025	2090	0	0	2776
72324	1397	1411067240000	4026	2091	0	0	2777
72327	1397	1411057239000	4029	2092	0	0	2778
72329	1397	1411047238000	4031	2093	0	0	2779
72331	1397	1411037237000	4033	2094	0	0	2780
72335	1397	1411017235000	4038	2096	0	0	2782
72336	1397	1411007234000	4039	2097	0	0	2783
72337	1397	1410997233000	4040	2098	0	0	2784
72338	1397	1410987232000	4040	2098	1	0	2785
72343	1397	1410967230000	4042	2099	0	0	2787
72344	1397	1410957229000	4042	2099	1	0	2788
72345	1397	1410947228000	4043	2100	0	0	2789
72348	1397	1410937227000	4046	2101	0	0	2790
72349	1397	1410927226000	4047	2102	0	0	2791
72351	1397	1410907224000	4047	2102	2	0	2793
72352	1397	1410897223000	4048	2103	0	0	2794
72353	1397	1410897223000	4049	2103	0	0	\N
72354	1397	1410897223000	4050	2103	0	0	\N
72358	1397	1410857219000	4053	2106	0	0	\N
72359	1397	1410847218000	4053	2106	1	0	\N
72360	1397	1410857219000	4054	2106	0	0	\N
72361	1397	1410847218000	4054	2106	1	0	\N
72368	1397	1410817215000	4058	2108	0	0	\N
72369	1397	1410807214000	4059	2109	0	0	\N
72372	1397	1410787212000	4062	2111	0	0	\N
72373	1397	1410777211000	4062	2111	1	0	\N
72374	1397	1410767210000	4062	2111	2	0	\N
72379	1397	1410757209000	4065	2112	0	0	\N
72382	1397	1410737207000	4068	2114	0	0	\N
72385	1397	1410707204000	4070	2116	0	0	\N
72387	1397	1410697203000	4072	2117	0	0	\N
72388	1397	1410697203000	4073	2117	0	0	\N
72390	1397	1410687202000	4075	2118	0	0	\N
72393	1397	1410667200000	4078	2120	0	0	\N
72394	1397	1410657199000	4078	2120	1	0	\N
72395	1397	1410667200000	4079	2120	0	0	\N
72396	1397	1410657199000	4079	2120	1	0	\N
72397	1397	1410667200000	4080	2120	0	0	\N
72398	1397	1410657199000	4080	2120	1	0	\N
72402	1397	1410647198000	4083	2121	0	0	\N
72404	1397	1410627196000	4085	2123	0	0	\N
72406	1397	1410617195000	4087	2124	0	0	\N
72408	1726	998800000000	4089	2125	0	0	\N
72409	1397	1410607194000	4089	2125	1	0	\N
72417	1726	997500000000	4092	2126	0	0	\N
72418	1397	1410597193000	4092	2126	1	0	\N
72419	1397	1410587192000	4092	2126	2	0	\N
72420	1397	1410577191000	4092	2126	3	0	\N
72421	1397	1410567190000	4092	2126	4	0	\N
72424	1397	1410537187000	4095	2129	0	0	\N
72430	1397	1410507184000	4099	2131	0	0	\N
72431	1397	1410497183000	4099	2131	1	0	\N
72433	1397	1410487182000	4101	2132	0	0	\N
72434	11	4651900000000	4102	2133	0	0	\N
72435	1397	1410477181000	4102	2133	1	0	\N
72438	11	4651900000000	4104	2133	0	0	\N
72439	1397	1410477181000	4104	2133	1	0	\N
72440	11	4651900000000	4105	2057	0	0	\N
72441	1738	718910000000	4105	2057	1	0	\N
72442	1167	608321416666323	4105	2057	2	0	\N
72443	11	4651900000000	4106	2133	0	0	\N
72444	1397	1410477181000	4106	2133	1	0	\N
72451	1397	1410437177000	4111	2137	0	0	\N
72452	1397	1410437177000	4112	2137	0	0	\N
72453	1397	1410427176000	4113	2138	0	0	\N
72454	1397	1410427176000	4114	2138	0	0	\N
72458	348	66000900000000	4117	2039	0	0	\N
72459	11	4651900000000	4117	2039	1	0	\N
72460	1738	718910000000	4117	2039	2	0	\N
72461	312	66000000000000	4117	2039	3	0	\N
72462	1397	1411737307000	4117	2039	4	0	\N
72463	1397	1411727306000	4117	2039	5	0	\N
72464	1397	1411717305000	4117	2039	6	0	\N
72465	1397	1411707304000	4117	2039	7	0	\N
72466	1397	1411697303000	4117	2039	8	0	\N
72467	1397	1411687302000	4117	2039	9	0	\N
72468	1397	1411677301000	4117	2039	10	0	\N
72469	1397	1411667300000	4117	2039	11	0	\N
72470	1397	1411657299000	4117	2039	12	0	\N
72471	1397	1411647298000	4117	2039	13	0	\N
72472	1397	1411637297000	4117	2039	14	0	\N
72473	1397	1411627296000	4117	2039	15	0	\N
72474	1397	1411617295000	4117	2039	16	0	\N
72475	1397	1411607294000	4117	2039	17	0	\N
72476	1397	1411597293000	4117	2039	18	0	\N
72477	1397	1411587292000	4117	2039	19	0	\N
72478	1397	1411577291000	4117	2039	20	0	\N
72479	1397	1411567290000	4117	2039	21	0	\N
72480	1397	1411557289000	4117	2039	22	0	\N
72481	1397	1411547288000	4117	2039	23	0	\N
72482	1397	1411537287000	4117	2039	24	0	\N
72483	1397	1411527286000	4117	2039	25	0	\N
72484	1397	1411517285000	4117	2039	26	0	\N
72485	1397	1411507284000	4117	2039	27	0	\N
72486	1397	1411497283000	4117	2039	28	0	\N
72487	1397	1411487282000	4117	2039	29	0	\N
72488	1397	1411477281000	4117	2039	30	0	\N
72357	1397	1410867220000	4052	2105	1	0	2797
72362	1397	1410857219000	4055	2106	0	0	2798
72363	1397	1410847218000	4055	2106	1	0	2799
72364	1397	1410837217000	4056	2107	0	0	2800
72365	1397	1410827216000	4056	2107	1	0	2801
72367	1397	1410817215000	4057	2108	0	0	2802
72370	1397	1410807214000	4060	2109	0	0	2803
72371	1397	1410797213000	4061	2110	0	0	2804
72375	1397	1410787212000	4063	2111	0	0	2805
72376	1397	1410777211000	4063	2111	1	0	2806
72378	1397	1410757209000	4064	2112	0	0	2808
72380	1397	1410747208000	4066	2113	0	0	2809
72381	1397	1410737207000	4067	2114	0	0	2810
72383	1397	1410727206000	4069	2115	0	0	2811
72386	1397	1410707204000	4071	2116	0	0	2813
72389	1397	1410697203000	4074	2117	0	0	2814
72391	1397	1410687202000	4076	2118	0	0	2815
72392	1397	1410677201000	4077	2119	0	0	2816
72399	1397	1410667200000	4081	2120	0	0	2817
72401	1397	1410647198000	4082	2121	0	0	2819
72403	1397	1410637197000	4084	2122	0	0	2820
72405	1397	1410627196000	4086	2123	0	0	2821
72407	1397	1410617195000	4088	2124	0	0	2822
72410	1726	998800000000	4090	2125	0	0	1
72412	1726	997500000000	4091	2126	0	0	2
72413	1397	1410597193000	4091	2126	1	0	2824
72414	1397	1410587192000	4091	2126	2	0	2825
72415	1397	1410577191000	4091	2126	3	0	2826
72422	1397	1410557189000	4093	2127	0	0	2828
72423	1397	1410547188000	4094	2128	0	0	2829
72425	1397	1410537187000	4096	2129	0	0	2830
72426	1397	1410527186000	4097	2130	0	0	2831
72427	1397	1410517185000	4097	2130	1	0	2832
72429	1397	1410497183000	4098	2131	1	0	2834
72432	1397	1410487182000	4100	2132	0	0	2835
72436	11	4651900000000	4103	2133	0	0	1
72437	1397	1410477181000	4103	2133	1	0	2836
72445	348	66000900000000	4107	2134	0	0	1
72447	1397	1410457179000	4108	2135	0	0	2838
72448	1397	1410447178000	4109	2136	0	0	2839
72449	1750	5296000000	4109	2136	1	0	4
72450	1397	1410437177000	4110	2137	0	0	2840
72456	312	66000000000000	4116	2139	0	0	1
72457	1397	1410417175000	4116	2139	1	0	2842
72489	1397	1411467280000	4117	2039	31	0	\N
72490	1397	1411457279000	4117	2039	32	0	\N
72491	1397	1411447278000	4117	2039	33	0	\N
72492	1397	1411437277000	4117	2039	34	0	\N
72493	1397	1411427276000	4117	2039	35	0	\N
72494	1397	1411417275000	4117	2039	36	0	\N
72495	1397	1411407274000	4117	2039	37	0	\N
72496	1397	1411397273000	4117	2039	38	0	\N
72497	1397	1411387272000	4117	2039	39	0	\N
72498	1397	1411377271000	4117	2039	40	0	\N
72499	1397	1411367270000	4117	2039	41	0	\N
72500	1397	1411357269000	4117	2039	42	0	\N
72501	1397	1411347268000	4117	2039	43	0	\N
72502	1397	1411337267000	4117	2039	44	0	\N
72503	1397	1411327266000	4117	2039	45	0	\N
72504	1397	1411317265000	4117	2039	46	0	\N
72505	1397	1411307264000	4117	2039	47	0	\N
72506	1397	1411297263000	4117	2039	48	0	\N
72507	1397	1411287262000	4117	2039	49	0	\N
72508	1397	1411277261000	4117	2039	50	0	\N
72509	1397	1411267260000	4117	2039	51	0	\N
72510	1397	1411257259000	4117	2039	52	0	\N
72511	1397	1411247258000	4117	2039	53	0	\N
72512	1397	1411237257000	4117	2039	54	0	\N
72513	1397	1411227256000	4117	2039	55	0	\N
72514	1397	1411217255000	4117	2039	56	0	\N
72515	1397	1411207254000	4117	2039	57	0	\N
72516	1397	1411197253000	4117	2039	58	0	\N
72517	1397	1411187252000	4117	2039	59	0	\N
72518	1397	1411177251000	4117	2039	60	0	\N
72519	1397	1411167250000	4117	2039	61	0	\N
72520	1397	1411157249000	4117	2039	62	0	\N
72521	1397	1411147248000	4117	2039	63	0	\N
72522	1397	1411137247000	4117	2039	64	0	\N
72523	1397	1411127246000	4117	2039	65	0	\N
72524	1397	1411117245000	4117	2039	66	0	\N
72525	1397	1411107244000	4117	2039	67	0	\N
72526	1397	1411097243000	4117	2039	68	0	\N
72527	1397	1411087242000	4117	2039	69	0	\N
72528	1397	1411077241000	4117	2039	70	0	\N
72529	1397	1411067240000	4117	2039	71	0	\N
72530	1397	1411057239000	4117	2039	72	0	\N
72531	1397	1411047238000	4117	2039	73	0	\N
72532	1397	1411037237000	4117	2039	74	0	\N
72533	1397	1411027236000	4117	2039	75	0	\N
72534	1397	1411017235000	4117	2039	76	0	\N
72535	1397	1411007234000	4117	2039	77	0	\N
72536	1397	1410997233000	4117	2039	78	0	\N
72537	1397	1410987232000	4117	2039	79	0	\N
72538	1397	1410977231000	4117	2039	80	0	\N
72539	1397	1410967230000	4117	2039	81	0	\N
72540	1397	1410957229000	4117	2039	82	0	\N
72541	1397	1410947228000	4117	2039	83	0	\N
72542	1397	1410937227000	4117	2039	84	0	\N
72543	1397	1410927226000	4117	2039	85	0	\N
72544	1397	1410917225000	4117	2039	86	0	\N
72545	1397	1410907224000	4117	2039	87	0	\N
72546	1397	1410897223000	4117	2039	88	0	\N
72547	1397	1410887222000	4117	2039	89	0	\N
72548	1397	1410877221000	4117	2039	90	0	\N
72549	1397	1410867220000	4117	2039	91	0	\N
72550	1397	1410857219000	4117	2039	92	0	\N
72551	1397	1410847218000	4117	2039	93	0	\N
72552	1397	1410837217000	4117	2039	94	0	\N
72553	1397	1410827216000	4117	2039	95	0	\N
72554	1397	1410817215000	4117	2039	96	0	\N
72555	1397	1410807214000	4117	2039	97	0	\N
72556	1397	1410797213000	4117	2039	98	0	\N
72557	1397	1410787212000	4117	2039	99	0	\N
72558	1397	1410777211000	4117	2039	100	0	\N
72559	1397	1410767210000	4117	2039	101	0	\N
72560	1397	1410757209000	4117	2039	102	0	\N
72561	1397	1410747208000	4117	2039	103	0	\N
72562	1397	1410737207000	4117	2039	104	0	\N
72563	1397	1410727206000	4117	2039	105	0	\N
72564	1397	1410717205000	4117	2039	106	0	\N
72565	1397	1410707204000	4117	2039	107	0	\N
72566	1397	1410697203000	4117	2039	108	0	\N
72567	1397	1410687202000	4117	2039	109	0	\N
72568	1397	1410677201000	4117	2039	110	0	\N
72569	1397	1410667200000	4117	2039	111	0	\N
72570	1397	1410657199000	4117	2039	112	0	\N
72571	1397	1410647198000	4117	2039	114	0	\N
72572	1397	1410637197000	4117	2039	115	0	\N
72573	1397	1410627196000	4117	2039	116	0	\N
72574	1397	1410617195000	4117	2039	117	0	\N
72575	1397	1410607194000	4117	2039	118	0	\N
72576	1397	1410597193000	4117	2039	119	0	\N
72577	1397	1410587192000	4117	2039	120	0	\N
72578	1397	1410577191000	4117	2039	121	0	\N
72579	1397	1410567190000	4117	2039	122	0	\N
72580	1397	1410557189000	4117	2039	123	0	\N
72581	1397	1410547188000	4117	2039	124	0	\N
72582	1397	1410537187000	4117	2039	125	0	\N
72585	1397	1410387172000	4119	2141	0	0	\N
72586	1397	1410377171000	4119	2141	1	0	\N
72593	1397	1410337167000	4124	2144	0	0	\N
72594	1397	1410337167000	4125	2144	0	0	\N
72596	1397	1410317165000	4128	2147	0	0	\N
72597	1397	1410307164000	4128	2147	1	0	\N
72604	1397	1410267160000	4133	2150	0	0	\N
72606	1397	1410257159000	4135	2151	0	0	\N
72607	1397	1410257159000	4136	2151	0	0	\N
72609	1726	996200000000	4138	2153	0	0	\N
72610	1726	994900000000	4138	2153	1	0	\N
72611	1726	993600000000	4138	2153	2	0	\N
72612	1726	992300000000	4138	2153	3	0	\N
72613	1726	991000000000	4138	2153	4	0	\N
72614	329	66717700000000	4138	2153	5	0	\N
72615	1397	1410237157000	4138	2153	6	0	\N
72616	1397	1410227156000	4138	2153	7	0	\N
72617	1397	1410217155000	4138	2153	8	0	\N
72587	1397	1410387172000	4120	2141	0	0	2845
72588	1397	1410377171000	4120	2141	1	0	2846
72589	1397	1410367170000	4121	2142	0	0	2847
72590	1397	1410357169000	4122	2143	0	0	2848
72591	1397	1410347168000	4122	2143	1	0	2849
72595	1397	1410327166000	4126	2145	0	0	2851
72598	1397	1410317165000	4129	2147	0	0	2852
72599	1397	1410307164000	4129	2147	1	0	2853
72600	1397	1410297163000	4130	2148	0	0	2854
72601	1397	1410287162000	4130	2148	1	0	2855
72603	1397	1410267160000	4132	2150	0	0	2857
72605	1397	1410257159000	4134	2151	0	0	2858
72608	1397	1410247158000	4137	2152	0	0	2859
72618	1726	996200000000	4139	2153	0	0	3
72620	1726	993600000000	4139	2153	2	0	5
72621	1726	992300000000	4139	2153	3	0	6
72622	1726	991000000000	4139	2153	4	0	7
72623	329	66717700000000	4139	2153	5	0	2
72624	1397	1410237157000	4139	2153	6	0	2860
72627	1397	1410207154000	4140	2154	0	0	\N
72628	1397	1410197153000	4140	2154	1	0	\N
72632	1397	1410187152000	4143	2155	0	0	\N
72633	1397	1410187152000	4144	2155	0	0	\N
72640	1397	1410117145000	4149	2160	0	0	\N
72641	1397	1410117145000	4150	2160	0	0	\N
72643	1397	1410117145000	4152	2160	0	0	\N
72644	1397	1410117145000	4153	2160	0	0	\N
72645	1397	1410117145000	4154	2160	0	0	\N
72649	1726	989700000000	4157	2162	0	0	\N
72650	1397	1410097143000	4157	2162	1	0	\N
72652	1397	1410087142000	4159	2163	0	0	\N
72653	1397	1410087142000	4160	2163	0	0	\N
72655	1397	1410067140000	4162	2165	0	0	\N
72657	329	66714600000000	4164	2166	0	0	\N
72658	1397	1410057139000	4164	2166	1	0	\N
72661	329	66714600000000	4166	2166	0	0	\N
72662	1397	1410057139000	4166	2166	1	0	\N
72670	1397	1409987132000	4171	2171	0	0	\N
72673	1397	1409977131000	4174	2172	0	0	\N
72678	1397	1409957129000	4177	2174	0	0	\N
72679	1397	1409947128000	4177	2174	1	0	\N
72680	1397	1409937127000	4177	2174	2	0	\N
72685	329	66717700000000	4180	2040	0	0	\N
72686	329	66714600000000	4180	2040	1	0	\N
72687	329	66004590000000	4180	2040	2	0	\N
72688	1397	1410527186000	4180	2040	3	0	\N
72689	1397	1410517185000	4180	2040	4	0	\N
72690	1397	1410507184000	4180	2040	5	0	\N
72691	1397	1410497183000	4180	2040	6	0	\N
72692	1397	1410487182000	4180	2040	7	0	\N
72693	1397	1410477181000	4180	2040	8	0	\N
72694	1397	1410467180000	4180	2040	9	0	\N
72695	1397	1410457179000	4180	2040	10	0	\N
72696	1397	1410447178000	4180	2040	11	0	\N
72697	1397	1410437177000	4180	2040	12	0	\N
72698	1397	1410427176000	4180	2040	13	0	\N
72699	1397	1410417175000	4180	2040	14	0	\N
72700	1397	1410407174000	4180	2040	15	0	\N
72701	1397	1410397173000	4180	2040	16	0	\N
72702	1397	1410387172000	4180	2040	17	0	\N
72703	1397	1410377171000	4180	2040	18	0	\N
72704	1397	1410367170000	4180	2040	19	0	\N
72705	1397	1410357169000	4180	2040	20	0	\N
72706	1397	1410347168000	4180	2040	21	0	\N
72707	1397	1410337167000	4180	2040	22	0	\N
72708	1397	1410327166000	4180	2040	23	0	\N
72709	1397	1410317165000	4180	2040	24	0	\N
72710	1397	1410307164000	4180	2040	25	0	\N
72711	1397	1410297163000	4180	2040	26	0	\N
72712	1397	1410287162000	4180	2040	27	0	\N
72713	1397	1410277161000	4180	2040	28	0	\N
72714	1397	1410267160000	4180	2040	29	0	\N
72715	1397	1410257159000	4180	2040	30	0	\N
72716	1397	1410247158000	4180	2040	31	0	\N
72717	1397	1410237157000	4180	2040	32	0	\N
72718	1397	1410227156000	4180	2040	33	0	\N
72719	1397	1410217155000	4180	2040	34	0	\N
72720	1397	1410207154000	4180	2040	35	0	\N
72721	1397	1410197153000	4180	2040	36	0	\N
72722	1397	1410187152000	4180	2040	37	0	\N
72723	1397	1410177151000	4180	2040	38	0	\N
72724	1397	1410167150000	4180	2040	39	0	\N
72725	1397	1410157149000	4180	2040	40	0	\N
72726	1397	1410147148000	4180	2040	41	0	\N
72727	1397	1410137147000	4180	2040	42	0	\N
72728	1397	1410127146000	4180	2040	43	0	\N
72729	1397	1410117145000	4180	2040	44	0	\N
72730	1397	1410107144000	4180	2040	45	0	\N
72731	1397	1410097143000	4180	2040	46	0	\N
72732	1397	1410087142000	4180	2040	47	0	\N
72733	1397	1410077141000	4180	2040	48	0	\N
72734	1397	1410067140000	4180	2040	49	0	\N
72735	1397	1410057139000	4180	2040	50	0	\N
72736	1397	1410047138000	4180	2040	51	0	\N
72737	1397	1410037137000	4180	2040	52	0	\N
72738	1397	1410027136000	4180	2040	53	0	\N
72739	1397	1410017135000	4180	2040	54	0	\N
72740	1397	1410007134000	4180	2040	55	0	\N
72741	1397	1409997133000	4180	2040	56	0	\N
72742	1397	1409987132000	4180	2040	57	0	\N
72743	1397	1409977131000	4180	2040	58	0	\N
72744	1397	1409967130000	4180	2040	59	0	\N
72745	1397	1409957129000	4180	2040	60	0	\N
72746	1397	1409947128000	4180	2040	61	0	\N
72747	1397	1409937127000	4180	2040	62	0	\N
72748	1397	1409927126000	4180	2040	63	0	\N
72749	1397	1409917125000	4180	2040	64	0	\N
72750	1722	79000000	4180	2040	65	0	\N
72751	1167	608321416666323	4180	2040	66	0	\N
72752	1749	5755088000000	4180	2040	67	0	\N
72753	1769	2994000000	4180	2040	68	0	\N
72754	1759	8640029000000	4180	2040	69	0	\N
72755	1750	5296000000	4180	2040	70	0	\N
72756	1764	5760008000000	4180	2040	71	0	\N
72757	1775	1944000000	4180	2040	72	0	\N
72758	1722	78000000	4180	2040	73	0	\N
72629	1397	1410207154000	4141	2154	0	0	2863
72630	1397	1410197153000	4141	2154	1	0	2864
72631	1397	1410187152000	4142	2155	0	0	2865
72634	1397	1410177151000	4145	2156	0	0	2866
72635	1397	1410167150000	4145	2156	1	0	2867
72637	1397	1410147148000	4147	2158	0	0	2869
72638	1397	1410137147000	4147	2158	1	0	2870
72639	1397	1410127146000	4148	2159	0	0	2871
72642	1397	1410117145000	4151	2160	0	0	2872
72646	1397	1410107144000	4155	2161	0	0	2873
72648	1397	1410097143000	4156	2162	1	0	2874
72651	1397	1410087142000	4158	2163	0	0	2875
72654	1397	1410077141000	4161	2164	0	0	2876
72656	1397	1410067140000	4163	2165	0	0	2877
72660	1397	1410057139000	4165	2166	1	0	2878
72663	1397	1410047138000	4167	2167	0	0	2879
72664	1397	1410037137000	4168	2168	0	0	2880
72665	1397	1410027136000	4168	2168	1	0	2881
72666	1397	1410017135000	4168	2168	2	0	2882
72668	1397	1410007134000	4169	2169	0	0	2883
72669	1397	1409997133000	4170	2170	0	0	2884
72671	1397	1409987132000	4172	2171	0	0	2885
72672	1397	1409977131000	4173	2172	0	0	2886
72674	1397	1409967130000	4175	2173	0	0	2887
72676	1397	1409947128000	4176	2174	1	0	2889
72677	1397	1409937127000	4176	2174	2	0	2890
72681	329	66004590000000	4178	2175	0	0	4
72682	1397	1409927126000	4178	2175	1	0	2891
72684	1769	2994000000	4179	2176	1	0	4
72759	1397	1409907124000	4182	2177	0	0	2893
72760	1769	2993000000	4183	2178	0	0	5
72761	348	66000900000000	4184	2058	0	0	\N
72762	312	66000000000000	4184	2058	1	0	\N
72763	329	66717700000000	4184	2058	2	0	\N
72764	329	66714600000000	4184	2058	3	0	\N
72765	329	66004590000000	4184	2058	4	0	\N
72766	1769	2994000000	4184	2058	5	0	\N
72767	1750	5296000000	4184	2058	6	0	\N
72768	1769	2993000000	4184	2058	7	0	\N
72769	1769	2991000000	4184	2058	8	0	\N
72770	1775	1944000000	4184	2058	9	0	\N
72774	1397	1409897123000	4186	2179	0	0	\N
72775	1397	1409887122000	4186	2179	1	0	\N
72776	1769	2991000000	4186	2179	2	0	\N
72777	1726	988400000000	4187	2180	0	0	\N
72778	1726	987100000000	4187	2180	1	0	\N
72779	1397	1409877121000	4187	2180	2	0	\N
72780	1397	1409867120000	4187	2180	3	0	\N
72785	1397	1409857119000	4189	2181	0	0	\N
72786	1779	0	4189	2181	1	0	\N
72789	1397	1409847118000	4191	2182	0	0	\N
72790	1397	1409837117000	4191	2182	1	0	\N
72799	1726	985800000000	4194	2183	0	0	\N
72800	1769	2981000000	4194	2183	1	0	\N
72801	1397	1409827116000	4194	2183	2	0	\N
72802	1397	1409817115000	4194	2183	3	0	\N
72803	1397	1409807114000	4194	2183	4	0	\N
72804	1769	2971000000	4194	2183	5	0	\N
72806	1397	1409787112000	4196	2185	0	0	\N
72807	1397	1409777111000	4196	2185	1	0	\N
72810	1726	984500000000	4198	2186	0	0	\N
72811	1397	1409767110000	4198	2186	1	0	\N
72812	1397	1409757109000	4198	2186	2	0	\N
72813	1397	1409747108000	4198	2186	3	0	\N
72818	1397	1409737107000	4200	2187	0	0	\N
72819	1397	1409737107000	4201	2187	0	0	\N
72820	1397	1409737107000	4202	2187	0	0	\N
72827	1726	983200000000	4205	2188	0	0	\N
72828	1397	1409727106000	4205	2188	1	0	\N
72829	1397	1409717105000	4205	2188	2	0	\N
72830	1397	1409707104000	4205	2188	3	0	\N
72831	1397	1409697103000	4205	2188	4	0	\N
72832	1397	1409727106000	4206	2188	0	0	\N
72833	1397	1409717105000	4206	2188	1	0	\N
72835	1397	1409677101000	4208	2190	0	0	\N
72837	1397	1409667100000	4210	2191	0	0	\N
72838	1397	1409667100000	4211	2191	0	0	\N
72840	1397	1409657099000	4213	2192	0	0	\N
72842	1397	1409657099000	4215	2192	0	0	\N
72843	1397	1409657099000	4216	2192	0	0	\N
72844	1397	1409657099000	4217	2192	0	0	\N
72845	1397	1409657099000	4218	2192	0	0	\N
72846	1397	1409647098000	4219	2193	0	0	\N
72847	1397	1409647098000	4220	2193	0	0	\N
72850	1397	1409627096000	4223	2195	0	0	\N
72851	1397	1409617095000	4223	2195	1	0	\N
72852	1397	1409627096000	4224	2195	0	0	\N
72853	1397	1409617095000	4224	2195	1	0	\N
72856	1769	2981000000	4226	2059	0	0	\N
72857	1769	2971000000	4226	2059	1	0	\N
72858	1779	0	4226	2059	2	0	\N
72868	1397	1409557089000	4228	2197	0	0	\N
72870	1397	1409557089000	4230	2197	0	0	\N
72880	1726	981900000000	4233	2199	0	0	\N
72881	1397	1409517085000	4233	2199	1	0	\N
72882	1397	1409507084000	4233	2199	2	0	\N
72883	1397	1409497083000	4233	2199	3	0	\N
72884	1397	1409487082000	4233	2199	4	0	\N
72885	1397	1409477081000	4234	2200	0	0	\N
72886	1397	1409477081000	4235	2200	0	0	\N
72889	1643	3666077263000	4238	2060	0	0	\N
72890	1643	2169419021000	4238	2060	1	0	\N
72891	1643	1159711651000	4238	2060	2	0	\N
72892	1643	324223113700	4238	2060	3	0	\N
72893	1643	324213113700	4238	2060	4	0	\N
72894	1397	1409467080000	4239	2201	0	0	\N
72895	1397	1409467080000	4240	2201	0	0	\N
72896	1397	1409467080000	4241	2201	0	0	\N
72773	1769	2991000000	4185	2179	2	0	6
72781	1726	988400000000	4188	2180	0	0	9
72782	1726	987100000000	4188	2180	1	0	10
72783	1397	1409877121000	4188	2180	2	0	2896
72784	1397	1409867120000	4188	2180	3	0	2897
72788	1779	0	4190	2181	1	0	1
72791	1397	1409847118000	4192	2182	0	0	2899
72792	1397	1409837117000	4192	2182	1	0	2900
72793	1726	985800000000	4193	2183	0	0	11
72794	1769	2981000000	4193	2183	1	0	7
72796	1397	1409817115000	4193	2183	3	0	2902
72797	1397	1409807114000	4193	2183	4	0	2903
72798	1769	2971000000	4193	2183	5	0	8
72805	1397	1409797113000	4195	2184	0	0	2904
72809	1397	1409777111000	4197	2185	1	0	2906
72814	1726	984500000000	4199	2186	0	0	12
72815	1397	1409767110000	4199	2186	1	0	2907
72816	1397	1409757109000	4199	2186	2	0	2908
72817	1397	1409747108000	4199	2186	3	0	2909
72822	1726	983200000000	4204	2188	0	0	13
72823	1397	1409727106000	4204	2188	1	0	2911
72824	1397	1409717105000	4204	2188	2	0	2912
72825	1397	1409707104000	4204	2188	3	0	2913
72826	1397	1409697103000	4204	2188	4	0	2914
72836	1397	1409677101000	4209	2190	0	0	2916
72839	1397	1409667100000	4212	2191	0	0	2917
72841	1397	1409657099000	4214	2192	0	0	2918
72848	1397	1409647098000	4221	2193	0	0	2919
72854	1397	1409627096000	4225	2195	0	0	2921
72855	1397	1409617095000	4225	2195	1	0	2922
72859	1643	3666077263000	4227	2196	0	0	1
72860	1643	2169419021000	4227	2196	1	0	2
72861	1643	1159711651000	4227	2196	2	0	3
72863	1397	1409607094000	4227	2196	4	0	2923
72864	1397	1409597093000	4227	2196	5	0	2924
72865	1397	1409587092000	4227	2196	6	0	2925
72866	1397	1409577091000	4227	2196	7	0	2926
72867	1397	1409567090000	4227	2196	8	0	2927
72871	1397	1409547088000	4231	2198	0	0	2929
72872	1397	1409537087000	4231	2198	1	0	2930
72873	1397	1409527086000	4231	2198	2	0	2931
72874	1643	324213113700	4231	2198	3	0	5
72876	1397	1409517085000	4232	2199	1	0	2932
72877	1397	1409507084000	4232	2199	2	0	2933
72878	1397	1409497083000	4232	2199	3	0	2934
72879	1397	1409487082000	4232	2199	4	0	2935
72887	1397	1409477081000	4236	2200	0	0	2936
72898	1397	1409447078000	4243	2203	0	0	\N
72900	329	66714600000000	4245	2163	0	0	\N
72901	1643	3666077263000	4245	2163	1	0	\N
72902	1643	2169419021000	4245	2163	2	0	\N
72903	1643	1159711651000	4245	2163	3	0	\N
72904	1643	324223113700	4245	2163	4	0	\N
72905	329	66004590000000	4245	2163	5	0	\N
72906	1397	1410087142000	4245	2163	6	0	\N
72907	1397	1410077141000	4245	2163	7	0	\N
72908	1397	1410067140000	4245	2163	8	0	\N
72909	1643	324213113700	4245	2163	9	0	\N
72910	1397	1410057139000	4245	2163	10	0	\N
72911	1397	1410047138000	4245	2163	11	0	\N
72912	1397	1410037137000	4245	2163	12	0	\N
72913	1397	1410027136000	4245	2163	13	0	\N
72914	1397	1410017135000	4245	2163	14	0	\N
72915	1397	1410007134000	4245	2163	15	0	\N
72916	1397	1409997133000	4245	2163	16	0	\N
72917	1397	1409987132000	4245	2163	17	0	\N
72918	1397	1409977131000	4245	2163	18	0	\N
72919	1397	1409967130000	4245	2163	19	0	\N
72920	1397	1409957129000	4245	2163	20	0	\N
72921	1397	1409947128000	4245	2163	21	0	\N
72922	1397	1409937127000	4245	2163	22	0	\N
72923	1397	1409927126000	4245	2163	23	0	\N
72924	1397	1409917125000	4245	2163	24	0	\N
72925	1397	1409907124000	4245	2163	25	0	\N
72926	1397	1409897123000	4245	2163	26	0	\N
72927	1397	1409887122000	4245	2163	27	0	\N
72928	1397	1409877121000	4245	2163	28	0	\N
72929	1397	1409867120000	4245	2163	29	0	\N
72930	1397	1409857119000	4245	2163	30	0	\N
72931	1397	1409847118000	4245	2163	31	0	\N
72932	1397	1409837117000	4245	2163	32	0	\N
72933	1397	1409827116000	4245	2163	33	0	\N
72934	1397	1409817115000	4245	2163	34	0	\N
72935	1397	1409807114000	4245	2163	35	0	\N
72936	1397	1409797113000	4245	2163	36	0	\N
72937	1397	1409787112000	4245	2163	37	0	\N
72938	1397	1409777111000	4245	2163	38	0	\N
72939	1397	1409767110000	4245	2163	39	0	\N
72940	1397	1409757109000	4245	2163	40	0	\N
72941	1397	1409747108000	4245	2163	41	0	\N
72942	1397	1409737107000	4245	2163	42	0	\N
72943	1397	1409727106000	4245	2163	43	0	\N
72944	1397	1409717105000	4245	2163	44	0	\N
72945	1397	1409707104000	4245	2163	45	0	\N
72946	1397	1409697103000	4245	2163	46	0	\N
72947	1397	1409687102000	4245	2163	47	0	\N
72948	1397	1409677101000	4245	2163	48	0	\N
72949	1397	1409667100000	4245	2163	49	0	\N
72950	1397	1409657099000	4245	2163	50	0	\N
72951	1397	1409647098000	4245	2163	51	0	\N
72952	1397	1409637097000	4245	2163	52	0	\N
72953	1397	1409627096000	4245	2163	53	0	\N
72954	1397	1409617095000	4245	2163	54	0	\N
72955	1397	1409607094000	4245	2163	55	0	\N
72956	1397	1409597093000	4245	2163	56	0	\N
72957	1397	1409587092000	4245	2163	57	0	\N
72958	1397	1409577091000	4245	2163	58	0	\N
72959	1397	1409567090000	4245	2163	59	0	\N
72960	1397	1409557089000	4245	2163	60	0	\N
72961	1397	1409547088000	4245	2163	61	0	\N
72962	1397	1409537087000	4245	2163	62	0	\N
72963	1397	1409527086000	4245	2163	63	0	\N
72964	1397	1409517085000	4245	2163	64	0	\N
72965	1397	1409507084000	4245	2163	66	0	\N
72966	1397	1409497083000	4245	2163	67	0	\N
72967	1397	1409487082000	4245	2163	68	0	\N
72968	1397	1409477081000	4245	2163	69	0	\N
72969	1397	1409467080000	4245	2163	70	0	\N
72970	1397	1409457079000	4245	2163	71	0	\N
72971	1397	1409447078000	4245	2163	72	0	\N
72972	1397	1409437077000	4245	2163	73	0	\N
72973	1769	2994000000	4245	2163	74	0	\N
72974	1769	2993000000	4245	2163	75	0	\N
72975	1769	2991000000	4245	2163	76	0	\N
72976	1769	2981000000	4245	2163	77	0	\N
72977	1769	2971000000	4245	2163	78	0	\N
72978	1779	0	4245	2163	79	0	\N
72979	1775	1944000000	4245	2163	80	0	\N
72984	1706	7916302000000	4247	2204	0	0	\N
72985	1397	1409437077000	4247	2204	1	0	\N
72986	1397	1409427076000	4247	2204	2	0	\N
72987	1397	1409417075000	4247	2204	3	0	\N
72988	1706	7916302000000	4248	2204	0	0	\N
72989	1397	1409437077000	4248	2204	1	0	\N
72990	1397	1409427076000	4248	2204	2	0	\N
72991	1397	1409417075000	4248	2204	3	0	\N
72992	1706	7916302000000	4249	2204	0	0	\N
72993	1397	1409437077000	4249	2204	1	0	\N
72994	1397	1409427076000	4249	2204	2	0	\N
72995	1397	1409417075000	4249	2204	3	0	\N
72999	1397	1409377071000	4252	2207	0	0	\N
73000	1397	1409367070000	4252	2207	1	0	\N
73001	1397	1409377071000	4253	2207	0	0	\N
73002	1397	1409367070000	4253	2207	1	0	\N
73008	1397	1409327066000	4256	2209	0	0	\N
73009	1397	1409327066000	4257	2209	0	0	\N
73011	1397	1409327066000	4259	2209	0	0	\N
73014	1397	1409317065000	4262	2210	0	0	\N
73015	1397	1409307064000	4262	2210	2	0	\N
73016	1397	1409317065000	4263	2210	0	0	\N
73017	1397	1409307064000	4263	2210	2	0	\N
73018	1397	1409307064000	4264	2211	0	0	\N
73019	1397	1409297063000	4264	2211	1	0	\N
73020	1397	1409297063000	4265	2211	0	0	\N
73022	1397	1409297063000	4267	2212	0	0	\N
73024	1397	1409287062000	4269	2213	0	0	\N
73029	1726	980600000000	4273	2217	0	0	\N
73030	1397	1409237057000	4273	2217	1	0	\N
72980	1706	7916302000000	4246	2204	0	0	6
72981	1397	1409437077000	4246	2204	1	0	2940
72982	1397	1409427076000	4246	2204	2	0	2941
72983	1397	1409417075000	4246	2204	3	0	2942
72996	1397	1409407074000	4250	2205	0	0	2943
72998	1397	1409387072000	4251	2206	0	0	2945
73003	1397	1409377071000	4254	2207	0	0	2946
73004	1397	1409367070000	4254	2207	1	0	2947
73005	1397	1409357069000	4255	2208	0	0	2948
73006	1397	1409347068000	4255	2208	1	0	2949
73010	1397	1409327066000	4258	2209	0	0	2951
73012	1397	1409317065000	4260	2210	0	0	2952
73013	1397	1409307064000	4261	2211	0	0	2953
73021	1397	1409297063000	4266	2212	0	0	2954
73025	1397	1409277061000	4270	2214	0	0	2956
73026	1397	1409267060000	4270	2214	1	0	2957
73027	1397	1409257059000	4271	2215	0	0	2958
73028	1397	1409247058000	4272	2216	0	0	2959
73031	1726	980600000000	4274	2217	0	0	15
73033	1726	980600000000	4275	2217	0	0	\N
73034	1397	1409237057000	4275	2217	1	0	\N
73035	1706	7916302000000	4276	2041	0	0	\N
73036	1643	3666077263000	4276	2041	1	0	\N
73037	1643	2169419021000	4276	2041	2	0	\N
73038	1643	1159711651000	4276	2041	3	0	\N
73039	1643	324223113700	4276	2041	4	0	\N
73040	1643	324213113700	4276	2041	5	0	\N
73041	1397	1409907124000	4276	2041	6	0	\N
73042	1397	1409897123000	4276	2041	7	0	\N
73043	1397	1409887122000	4276	2041	8	0	\N
73044	1397	1409877121000	4276	2041	9	0	\N
73045	1397	1409867120000	4276	2041	10	0	\N
73046	1397	1409857119000	4276	2041	11	0	\N
73047	1397	1409847118000	4276	2041	12	0	\N
73048	1397	1409837117000	4276	2041	13	0	\N
73049	1397	1409827116000	4276	2041	14	0	\N
73050	1397	1409817115000	4276	2041	15	0	\N
73051	1397	1409807114000	4276	2041	16	0	\N
73052	1397	1409797113000	4276	2041	17	0	\N
73053	1397	1409787112000	4276	2041	18	0	\N
73054	1397	1409777111000	4276	2041	19	0	\N
73055	1397	1409767110000	4276	2041	20	0	\N
73056	1397	1409757109000	4276	2041	21	0	\N
73057	1397	1409747108000	4276	2041	22	0	\N
73058	1397	1409737107000	4276	2041	23	0	\N
73059	1397	1409727106000	4276	2041	24	0	\N
73060	1397	1409717105000	4276	2041	25	0	\N
73061	1397	1409707104000	4276	2041	26	0	\N
73062	1397	1409697103000	4276	2041	27	0	\N
73063	1397	1409687102000	4276	2041	28	0	\N
73064	1397	1409677101000	4276	2041	29	0	\N
73065	1397	1409667100000	4276	2041	30	0	\N
73066	1397	1409657099000	4276	2041	31	0	\N
73067	1397	1409647098000	4276	2041	32	0	\N
73068	1397	1409637097000	4276	2041	33	0	\N
73069	1397	1409627096000	4276	2041	34	0	\N
73070	1397	1409617095000	4276	2041	35	0	\N
73071	1397	1409607094000	4276	2041	36	0	\N
73072	1397	1409597093000	4276	2041	38	0	\N
73073	1397	1409587092000	4276	2041	39	0	\N
73074	1397	1409577091000	4276	2041	40	0	\N
73075	1397	1409567090000	4276	2041	41	0	\N
73076	1397	1409557089000	4276	2041	42	0	\N
73077	1397	1409547088000	4276	2041	43	0	\N
73078	1397	1409537087000	4276	2041	44	0	\N
73079	1397	1409527086000	4276	2041	45	0	\N
73080	1397	1409517085000	4276	2041	46	0	\N
73081	1397	1409507084000	4276	2041	47	0	\N
73082	1397	1409497083000	4276	2041	48	0	\N
73083	1397	1409487082000	4276	2041	49	0	\N
73084	1397	1409477081000	4276	2041	50	0	\N
73085	1397	1409467080000	4276	2041	51	0	\N
73086	1397	1409457079000	4276	2041	52	0	\N
73087	1397	1409447078000	4276	2041	53	0	\N
73088	1397	1409437077000	4276	2041	54	0	\N
73089	1397	1409427076000	4276	2041	55	0	\N
73090	1397	1409417075000	4276	2041	56	0	\N
73091	1397	1409407074000	4276	2041	57	0	\N
73092	1397	1409397073000	4276	2041	58	0	\N
73093	1397	1409387072000	4276	2041	59	0	\N
73094	1397	1409377071000	4276	2041	60	0	\N
73095	1397	1409367070000	4276	2041	61	0	\N
73096	1397	1409357069000	4276	2041	62	0	\N
73097	1397	1409347068000	4276	2041	63	0	\N
73098	1397	1409337067000	4276	2041	64	0	\N
73099	1397	1409327066000	4276	2041	65	0	\N
73100	1397	1409317065000	4276	2041	66	0	\N
73101	1397	1409307064000	4276	2041	67	0	\N
73102	1397	1409297063000	4276	2041	68	0	\N
73103	1397	1409287062000	4276	2041	69	0	\N
73104	1397	1409277061000	4276	2041	70	0	\N
73105	1397	1409267060000	4276	2041	71	0	\N
73106	1397	1409257059000	4276	2041	72	0	\N
73107	1397	1409247058000	4276	2041	73	0	\N
73108	1397	1409237057000	4276	2041	74	0	\N
73109	1769	2993000000	4276	2041	75	0	\N
73110	1769	2991000000	4276	2041	76	0	\N
73111	1769	2981000000	4276	2041	77	0	\N
73112	1769	2971000000	4276	2041	78	0	\N
73113	1779	0	4276	2041	79	0	\N
73114	1726	980600000000	4277	2217	0	0	\N
73115	1397	1409237057000	4277	2217	1	0	\N
73116	1397	1409227056000	4277	2217	2	0	\N
73119	1397	1409227056000	4279	2218	0	0	\N
73120	1397	1409217055000	4279	2218	1	0	\N
73123	1397	1409187052000	4282	2221	0	0	\N
73128	1397	1409177051000	4285	2222	0	0	\N
73129	1397	1409167050000	4285	2222	1	0	\N
73130	1397	1409157049000	4285	2222	2	0	\N
73131	1397	1409177051000	4286	2222	0	0	\N
73132	1397	1409167050000	4286	2222	1	0	\N
73133	1397	1409157049000	4286	2222	2	0	\N
73134	1397	1409177051000	4287	2222	0	0	\N
73135	1397	1409167050000	4287	2222	1	0	\N
73136	1397	1409157049000	4287	2222	2	0	\N
73137	1397	1409177051000	4288	2222	0	0	\N
73138	1397	1409167050000	4288	2222	1	0	\N
73139	1397	1409157049000	4288	2222	2	0	\N
73147	1397	1409097043000	4295	2228	0	0	\N
73148	1397	1409087042000	4296	2229	0	0	\N
73152	1397	1409067040000	4303	2231	0	0	\N
73156	348	66000900000000	4306	1996	0	0	\N
73157	1706	7916302000000	4306	1996	1	0	\N
73158	1643	3666077263000	4306	1996	3	0	\N
73159	1643	2169419021000	4306	1996	4	0	\N
73160	11	4651900000000	4306	1996	5	0	\N
73161	1738	718910000000	4306	1996	6	0	\N
73162	1643	1159711651000	4306	1996	7	0	\N
73163	1643	324223113700	4306	1996	8	0	\N
73164	312	66000000000000	4306	1996	9	0	\N
73165	329	66717700000000	4306	1996	10	0	\N
73166	329	66714600000000	4306	1996	11	0	\N
73167	329	66004590000000	4306	1996	12	0	\N
73168	1397	1412327366000	4306	1996	13	0	\N
73121	1397	1409207054000	4280	2219	0	0	2963
73122	1397	1409197053000	4281	2220	0	0	2964
73124	1397	1409187052000	4283	2221	0	0	2965
73125	1397	1409177051000	4284	2222	0	0	2966
73126	1397	1409167050000	4284	2222	1	0	2967
73140	1397	1409147048000	4289	2223	0	0	2969
73141	1397	1409137047000	4290	2224	0	0	2970
73142	1397	1409127046000	4291	2225	0	0	2971
73143	1397	1409117045000	4292	2226	0	0	2972
73144	1726	979300000000	4293	2227	0	0	16
73146	1397	1409097043000	4294	2228	0	0	2974
73149	1397	1409087042000	4297	2229	0	0	2975
73150	1726	978000000000	4299	2230	0	0	17
73151	1397	1409077041000	4299	2230	1	0	2976
73154	1726	976700000000	4305	2232	0	0	18
73155	1397	1409057039000	4305	2232	1	0	2978
73169	1643	324213113700	4306	1996	14	0	\N
73170	1397	1412317365000	4306	1996	15	0	\N
73171	1397	1412307364000	4306	1996	16	0	\N
73172	1397	1412297363000	4306	1996	17	0	\N
73173	1397	1412287362000	4306	1996	18	0	\N
73174	1397	1412277361000	4306	1996	19	0	\N
73175	1397	1412267360000	4306	1996	20	0	\N
73176	1397	1412257359000	4306	1996	21	0	\N
73177	1397	1412247358000	4306	1996	22	0	\N
73178	1397	1412237357000	4306	1996	23	0	\N
73179	1397	1412227356000	4306	1996	24	0	\N
73180	1397	1412217355000	4306	1996	25	0	\N
73181	1397	1412207354000	4306	1996	26	0	\N
73182	1397	1412197353000	4306	1996	27	0	\N
73183	1397	1412187352000	4306	1996	28	0	\N
73184	1397	1412177351000	4306	1996	29	0	\N
73185	1397	1412167350000	4306	1996	30	0	\N
73186	1397	1412157349000	4306	1996	31	0	\N
73187	1397	1412147348000	4306	1996	32	0	\N
73188	1397	1412137347000	4306	1996	33	0	\N
73189	1397	1412127346000	4306	1996	34	0	\N
73190	1397	1412117345000	4306	1996	35	0	\N
73191	1397	1412107344000	4306	1996	36	0	\N
73192	1397	1412097343000	4306	1996	37	0	\N
73193	1397	1412087342000	4306	1996	38	0	\N
73194	1397	1412077341000	4306	1996	39	0	\N
73195	1397	1412067340000	4306	1996	40	0	\N
73196	1397	1412057339000	4306	1996	41	0	\N
73197	1397	1412047338000	4306	1996	42	0	\N
73198	1397	1412037337000	4306	1996	43	0	\N
73199	1397	1412027336000	4306	1996	44	0	\N
73200	1397	1412017335000	4306	1996	45	0	\N
73201	1397	1412007334000	4306	1996	46	0	\N
73202	1397	1411997333000	4306	1996	47	0	\N
73203	1397	1411987332000	4306	1996	48	0	\N
73204	1397	1411977331000	4306	1996	49	0	\N
73205	1397	1411967330000	4306	1996	50	0	\N
73206	1397	1411957329000	4306	1996	51	0	\N
73207	1397	1411947328000	4306	1996	52	0	\N
73208	1397	1411937327000	4306	1996	53	0	\N
73209	1397	1411927326000	4306	1996	54	0	\N
73210	1397	1411917325000	4306	1996	55	0	\N
73211	1397	1411907324000	4306	1996	56	0	\N
73212	1397	1411897323000	4306	1996	57	0	\N
73213	1397	1411887322000	4306	1996	58	0	\N
73214	1397	1411877321000	4306	1996	59	0	\N
73215	1397	1411867320000	4306	1996	60	0	\N
73216	1397	1411857319000	4306	1996	61	0	\N
73217	1397	1411847318000	4306	1996	62	0	\N
73218	1397	1411837317000	4306	1996	63	0	\N
73219	1397	1411827316000	4306	1996	64	0	\N
73220	1397	1411817315000	4306	1996	65	0	\N
73221	1397	1411807314000	4306	1996	66	0	\N
73222	1397	1411797313000	4306	1996	67	0	\N
73223	1397	1411787312000	4306	1996	68	0	\N
73224	1397	1411777311000	4306	1996	69	0	\N
73225	1397	1411767310000	4306	1996	70	0	\N
73226	1397	1411757309000	4306	1996	71	0	\N
73227	1397	1411747308000	4306	1996	72	0	\N
73228	1397	1411737307000	4306	1996	73	0	\N
73229	1397	1411727306000	4306	1996	74	0	\N
73230	1397	1411717305000	4306	1996	75	0	\N
73231	1397	1411707304000	4306	1996	76	0	\N
73232	1397	1411697303000	4306	1996	77	0	\N
73233	1397	1411687302000	4306	1996	78	0	\N
73234	1397	1411677301000	4306	1996	79	0	\N
73235	1397	1411667300000	4306	1996	80	0	\N
73236	1397	1411657299000	4306	1996	81	0	\N
73237	1397	1411647298000	4306	1996	82	0	\N
73238	1397	1411637297000	4306	1996	83	0	\N
73239	1397	1411627296000	4306	1996	84	0	\N
73240	1397	1411617295000	4306	1996	85	0	\N
73241	1397	1411607294000	4306	1996	86	0	\N
73242	1397	1411597293000	4306	1996	87	0	\N
73243	1397	1411587292000	4306	1996	88	0	\N
73244	1397	1411577291000	4306	1996	89	0	\N
73245	1397	1411567290000	4306	1996	90	0	\N
73246	1397	1411557289000	4306	1996	91	0	\N
73247	1397	1411547288000	4306	1996	92	0	\N
73248	1397	1411537287000	4306	1996	93	0	\N
73249	1397	1411527286000	4306	1996	94	0	\N
73250	1397	1411517285000	4306	1996	95	0	\N
73251	1397	1411507284000	4306	1996	96	0	\N
73252	1397	1411497283000	4306	1996	97	0	\N
73253	1397	1411487282000	4306	1996	98	0	\N
73254	1397	1411477281000	4306	1996	99	0	\N
73255	1397	1411467280000	4306	1996	100	0	\N
73256	1397	1411457279000	4306	1996	101	0	\N
73257	1397	1411447278000	4306	1996	102	0	\N
73258	1397	1411437277000	4306	1996	103	0	\N
73259	1397	1411427276000	4306	1996	104	0	\N
73260	1397	1411417275000	4306	1996	105	0	\N
73261	1397	1411407274000	4306	1996	106	0	\N
73262	1397	1411397273000	4306	1996	107	0	\N
73263	1397	1411387272000	4306	1996	108	0	\N
73264	1397	1411377271000	4306	1996	109	0	\N
73265	1397	1411367270000	4306	1996	110	0	\N
73266	1397	1411357269000	4306	1996	111	0	\N
73267	1397	1411347268000	4306	1996	112	0	\N
73268	1397	1411337267000	4306	1996	113	0	\N
73269	1397	1411327266000	4306	1996	114	0	\N
73270	1397	1411317265000	4306	1996	115	0	\N
73271	1397	1411307264000	4306	1996	116	0	\N
73272	1397	1411297263000	4306	1996	117	0	\N
73273	1397	1411287262000	4306	1996	118	0	\N
73274	1397	1411277261000	4306	1996	119	0	\N
73275	1397	1411267260000	4306	1996	120	0	\N
73276	1397	1411257259000	4306	1996	121	0	\N
73277	1397	1411247258000	4306	1996	122	0	\N
73278	1397	1411237257000	4306	1996	123	0	\N
73279	1397	1411227256000	4306	1996	124	0	\N
73280	1397	1411217255000	4306	1996	125	0	\N
73284	1397	1409027036000	4309	2235	0	0	\N
73288	1397	1409017035000	4313	2236	0	0	\N
73289	1397	1409007034000	4313	2236	1	0	\N
73290	1397	1409017035000	4314	2236	0	0	\N
73291	1397	1409007034000	4314	2236	1	0	\N
73295	1397	1408967030000	4316	2238	0	0	\N
73296	1397	1408967030000	4317	2238	0	0	\N
73298	1397	1408957029000	4319	2239	0	0	\N
73299	1397	1408957029000	4320	2239	0	0	\N
73303	1706	7916302000000	4324	2061	0	0	\N
73304	1693	7226626500877	4324	2061	1	0	\N
73283	1693	11546697500877	4308	2234	1	0	230
73285	1397	1409027036000	4310	2235	0	0	2981
73286	1397	1409017035000	4312	2236	0	0	2982
73287	1397	1409007034000	4312	2236	1	0	2983
73292	1397	1408997033000	4315	2237	0	0	2984
73294	1397	1408977031000	4315	2237	2	0	2986
73297	1397	1408967030000	4318	2238	0	0	2987
73300	1397	1408957029000	4322	2239	0	0	2988
73301	1397	1408947028000	4323	2240	0	0	2989
73302	1397	1408937027000	4323	2240	1	0	2990
73307	1397	1408907024000	4326	2242	0	0	\N
73310	1397	1408897023000	4329	2243	0	0	\N
73311	1397	1408897023000	4330	2243	0	0	\N
73312	1397	1408887022000	4331	2244	0	0	\N
73318	1397	1408837017000	4338	2249	0	0	\N
73319	1397	1408827016000	4338	2249	1	0	\N
73320	1397	1408817015000	4338	2249	2	0	\N
73324	1397	1408807014000	4340	2250	0	0	\N
73326	1397	1408807014000	4342	2250	0	0	\N
73327	1397	1408797013000	4343	2251	0	0	\N
73328	1397	1408797013000	4344	2251	0	0	\N
73329	1726	998800000000	4345	2113	0	0	\N
73330	348	66000900000000	4345	2113	1	0	\N
73331	1706	7916302000000	4345	2113	2	0	\N
73332	1643	3666077263000	4345	2113	3	0	\N
73333	1643	2169419021000	4345	2113	4	0	\N
73334	11	4651900000000	4345	2113	5	0	\N
73335	1643	1159711651000	4345	2113	6	0	\N
73336	1643	324223113700	4345	2113	7	0	\N
73337	1726	997500000000	4345	2113	8	0	\N
73338	1726	996200000000	4345	2113	9	0	\N
73339	1726	994900000000	4345	2113	10	0	\N
73340	1726	993600000000	4345	2113	11	0	\N
73341	1726	992300000000	4345	2113	12	0	\N
73342	1726	991000000000	4345	2113	13	0	\N
73343	1726	989700000000	4345	2113	14	0	\N
73344	1726	988400000000	4345	2113	15	0	\N
73345	1726	987100000000	4345	2113	16	0	\N
73346	312	66000000000000	4345	2113	17	0	\N
73347	329	66717700000000	4345	2113	18	0	\N
73348	329	66714600000000	4345	2113	19	0	\N
73349	1726	985800000000	4345	2113	20	0	\N
73350	1726	984500000000	4345	2113	21	0	\N
73351	1726	983200000000	4345	2113	22	0	\N
73352	1726	981900000000	4345	2113	23	0	\N
73353	1726	980600000000	4345	2113	24	0	\N
73354	1726	979300000000	4345	2113	25	0	\N
73355	1726	978000000000	4345	2113	26	0	\N
73356	1726	976700000000	4345	2113	27	0	\N
73357	329	66004590000000	4345	2113	28	0	\N
73358	1643	324213113700	4345	2113	29	0	\N
73359	1693	9386667500877	4345	2113	30	0	\N
73360	1769	2994000000	4345	2113	31	0	\N
73361	1750	5296000000	4345	2113	32	0	\N
73362	1769	2993000000	4345	2113	33	0	\N
73363	1769	2991000000	4345	2113	34	0	\N
73364	1769	2981000000	4345	2113	35	0	\N
73365	1769	2971000000	4345	2113	36	0	\N
73366	1779	0	4345	2113	37	0	\N
73367	1775	1944000000	4345	2113	38	0	\N
73369	1397	1411207254000	4347	1997	0	0	\N
73370	1397	1411197253000	4347	1997	1	0	\N
73371	1397	1411187252000	4347	1997	3	0	\N
73372	1397	1411177251000	4347	1997	4	0	\N
73373	1397	1411167250000	4347	1997	5	0	\N
73374	1397	1411157249000	4347	1997	6	0	\N
73375	1397	1411147248000	4347	1997	7	0	\N
73376	1397	1411137247000	4347	1997	8	0	\N
73377	1397	1411127246000	4347	1997	9	0	\N
73378	1397	1411117245000	4347	1997	10	0	\N
73379	1397	1411107244000	4347	1997	11	0	\N
73380	1397	1411097243000	4347	1997	12	0	\N
73381	1693	7226626500877	4347	1997	13	0	\N
73382	1397	1411087242000	4347	1997	14	0	\N
73383	1397	1411077241000	4347	1997	15	0	\N
73384	1397	1411067240000	4347	1997	16	0	\N
73385	1397	1411057239000	4347	1997	17	0	\N
73386	1397	1411047238000	4347	1997	18	0	\N
73387	1397	1411037237000	4347	1997	19	0	\N
73388	1397	1411027236000	4347	1997	20	0	\N
73389	1397	1411017235000	4347	1997	21	0	\N
73390	1397	1411007234000	4347	1997	22	0	\N
73391	1397	1410997233000	4347	1997	23	0	\N
73392	1397	1410987232000	4347	1997	24	0	\N
73393	1397	1410977231000	4347	1997	25	0	\N
73394	1397	1410967230000	4347	1997	26	0	\N
73395	1397	1410957229000	4347	1997	27	0	\N
73396	1397	1410947228000	4347	1997	28	0	\N
73397	1397	1410937227000	4347	1997	29	0	\N
73398	1397	1410927226000	4347	1997	30	0	\N
73399	1397	1410917225000	4347	1997	31	0	\N
73400	1397	1410907224000	4347	1997	32	0	\N
73401	1397	1410897223000	4347	1997	33	0	\N
73402	1397	1410887222000	4347	1997	34	0	\N
73403	1397	1410877221000	4347	1997	35	0	\N
73404	1397	1410867220000	4347	1997	36	0	\N
73405	1397	1410857219000	4347	1997	37	0	\N
73406	1397	1410847218000	4347	1997	38	0	\N
73407	1397	1410837217000	4347	1997	39	0	\N
73408	1397	1410827216000	4347	1997	40	0	\N
73409	1397	1410817215000	4347	1997	41	0	\N
73410	1397	1410807214000	4347	1997	42	0	\N
73411	1397	1410797213000	4347	1997	43	0	\N
73412	1397	1410787212000	4347	1997	44	0	\N
73413	1397	1410777211000	4347	1997	45	0	\N
73414	1397	1410767210000	4347	1997	46	0	\N
73415	1397	1410757209000	4347	1997	47	0	\N
73416	1397	1410747208000	4347	1997	48	0	\N
73417	1397	1410737207000	4347	1997	49	0	\N
73418	1397	1410727206000	4347	1997	50	0	\N
73419	1397	1410717205000	4347	1997	51	0	\N
73420	1397	1410707204000	4347	1997	52	0	\N
73421	1397	1410697203000	4347	1997	53	0	\N
73422	1397	1410687202000	4347	1997	54	0	\N
73423	1397	1410677201000	4347	1997	55	0	\N
73424	1397	1410667200000	4347	1997	56	0	\N
73425	1397	1410657199000	4347	1997	57	0	\N
73426	1397	1410647198000	4347	1997	58	0	\N
73427	1397	1410637197000	4347	1997	59	0	\N
73428	1397	1410627196000	4347	1997	60	0	\N
73429	1397	1410617195000	4347	1997	61	0	\N
73430	1397	1410607194000	4347	1997	62	0	\N
73431	1397	1410597193000	4347	1997	63	0	\N
73432	1397	1410587192000	4347	1997	64	0	\N
73433	1397	1410577191000	4347	1997	65	0	\N
73434	1397	1410567190000	4347	1997	66	0	\N
73435	1397	1410557189000	4347	1997	67	0	\N
73436	1397	1410547188000	4347	1997	68	0	\N
73437	1397	1410537187000	4347	1997	69	0	\N
73438	1397	1410527186000	4347	1997	70	0	\N
73439	1397	1410517185000	4347	1997	71	0	\N
73440	1397	1410507184000	4347	1997	72	0	\N
73308	1397	1408907024000	4327	2242	0	0	2993
73309	1397	1408897023000	4328	2243	0	0	2994
73313	1397	1408887022000	4332	2244	0	0	2995
73314	1397	1408877021000	4333	2245	0	0	2996
73315	1397	1408867020000	4334	2246	0	0	2997
73317	1397	1408847018000	4335	2247	0	0	2999
73321	1397	1408837017000	4339	2249	0	0	3000
73322	1397	1408827016000	4339	2249	1	0	3001
73323	1397	1408817015000	4339	2249	2	0	3002
73325	1397	1408807014000	4341	2250	0	0	3003
73441	1397	1410497183000	4347	1997	73	0	\N
73442	1397	1410487182000	4347	1997	74	0	\N
73443	1397	1410477181000	4347	1997	75	0	\N
73444	1397	1410467180000	4347	1997	76	0	\N
73445	1397	1410457179000	4347	1997	77	0	\N
73446	1397	1410447178000	4347	1997	78	0	\N
73447	1397	1410437177000	4347	1997	79	0	\N
73448	1397	1410427176000	4347	1997	80	0	\N
73449	1397	1410417175000	4347	1997	81	0	\N
73450	1397	1410407174000	4347	1997	82	0	\N
73451	1397	1410397173000	4347	1997	83	0	\N
73452	1397	1410387172000	4347	1997	84	0	\N
73453	1397	1410377171000	4347	1997	85	0	\N
73454	1397	1410367170000	4347	1997	86	0	\N
73455	1397	1410357169000	4347	1997	87	0	\N
73456	1397	1410347168000	4347	1997	88	0	\N
73457	1397	1410337167000	4347	1997	89	0	\N
73458	1397	1410327166000	4347	1997	90	0	\N
73459	1397	1410317165000	4347	1997	91	0	\N
73460	1397	1410307164000	4347	1997	92	0	\N
73461	1397	1410297163000	4347	1997	93	0	\N
73462	1397	1410287162000	4347	1997	94	0	\N
73463	1397	1410277161000	4347	1997	95	0	\N
73464	1397	1410267160000	4347	1997	96	0	\N
73465	1397	1410257159000	4347	1997	97	0	\N
73466	1397	1410247158000	4347	1997	98	0	\N
73467	1397	1410237157000	4347	1997	99	0	\N
73468	1397	1410227156000	4347	1997	100	0	\N
73469	1397	1410217155000	4347	1997	101	0	\N
73470	1397	1410207154000	4347	1997	102	0	\N
73471	1397	1410197153000	4347	1997	103	0	\N
73472	1397	1410187152000	4347	1997	104	0	\N
73473	1397	1410177151000	4347	1997	105	0	\N
73474	1397	1410167150000	4347	1997	106	0	\N
73475	1397	1410157149000	4347	1997	107	0	\N
73476	1397	1410147148000	4347	1997	108	0	\N
73477	1397	1410137147000	4347	1997	109	0	\N
73478	1397	1410127146000	4347	1997	110	0	\N
73479	1397	1410117145000	4347	1997	111	0	\N
73480	1397	1410107144000	4347	1997	112	0	\N
73481	1397	1410097143000	4347	1997	113	0	\N
73482	1397	1410087142000	4347	1997	114	0	\N
73483	1397	1410077141000	4347	1997	115	0	\N
73484	1397	1410067140000	4347	1997	116	0	\N
73485	1397	1410057139000	4347	1997	117	0	\N
73486	1397	1410047138000	4347	1997	118	0	\N
73487	1397	1410037137000	4347	1997	119	0	\N
73488	1397	1410027136000	4347	1997	120	0	\N
73489	1397	1410017135000	4347	1997	121	0	\N
73490	1397	1410007134000	4347	1997	122	0	\N
73491	1397	1409997133000	4347	1997	123	0	\N
73492	1397	1409987132000	4347	1997	124	0	\N
73493	1397	1409977131000	4347	1997	125	0	\N
73503	1397	1408707004000	4353	2255	0	0	\N
73508	1397	1408677001000	4357	2258	0	0	\N
73510	1397	1408667000000	4359	2259	0	0	\N
73515	1397	1408626996000	4363	2263	0	0	\N
73516	1397	1408616995000	4363	2263	1	0	\N
73519	1397	1408606994000	4365	2264	0	0	\N
73521	1397	1408606994000	4367	2264	0	0	\N
73529	1397	1408556989000	4371	2267	0	0	\N
73531	1397	1408546988000	4374	2268	0	0	\N
73532	1397	1408536987000	4375	2269	0	0	\N
73533	1397	1408536987000	4376	2269	0	0	\N
73538	1397	1408496983000	4381	2273	0	0	\N
73539	1397	1408496983000	4382	2273	0	0	\N
73540	1397	1408496983000	4383	2273	0	0	\N
73542	1397	1408486982000	4385	2274	0	0	\N
73543	1601	11520251000000	4385	2274	1	0	\N
73547	1726	979300000000	4388	2223	0	0	\N
73548	1726	978000000000	4388	2223	1	0	\N
73549	1726	976700000000	4388	2223	2	0	\N
73550	1726	975400000000	4388	2223	3	0	\N
73551	1726	974100000000	4388	2223	4	0	\N
73552	1397	1409147048000	4388	2223	5	0	\N
73553	1769	2960900000	4388	2223	6	0	\N
73554	1397	1409137047000	4388	2223	7	0	\N
73555	1397	1409127046000	4388	2223	8	0	\N
73556	1397	1409117045000	4388	2223	9	0	\N
73557	1397	1409107044000	4388	2223	10	0	\N
73558	1397	1409097043000	4388	2223	11	0	\N
73559	1397	1409087042000	4388	2223	12	0	\N
73560	1397	1409077041000	4388	2223	13	0	\N
73561	1397	1409067040000	4388	2223	14	0	\N
73562	1397	1409057039000	4388	2223	15	0	\N
73563	1397	1409047038000	4388	2223	16	0	\N
73564	1397	1409037037000	4388	2223	17	0	\N
73565	1397	1409027036000	4388	2223	18	0	\N
73566	1397	1409017035000	4388	2223	19	0	\N
73567	1397	1409007034000	4388	2223	20	0	\N
73568	1397	1408997033000	4388	2223	21	0	\N
73569	1769	2950900000	4388	2223	22	0	\N
73570	1601	11520251000000	4388	2223	23	0	\N
73571	1397	1408987032000	4388	2223	24	0	\N
73572	1397	1408977031000	4388	2223	25	0	\N
73573	1397	1408967030000	4388	2223	26	0	\N
73574	1397	1408957029000	4388	2223	27	0	\N
73575	1397	1408947028000	4388	2223	28	0	\N
73576	1397	1408937027000	4388	2223	29	0	\N
73496	1397	1408767010000	4348	2252	2	0	3007
73497	1397	1408757009000	4349	2253	0	0	3008
73498	1397	1408747008000	4351	2254	0	0	3009
73499	1397	1408737007000	4351	2254	1	0	3010
73500	1397	1408727006000	4351	2254	2	0	3011
73502	1397	1408707004000	4352	2255	0	0	3013
73504	1726	975400000000	4354	2256	0	0	19
73505	1397	1408697003000	4354	2256	1	0	3014
73506	1397	1408687002000	4355	2257	0	0	3015
73507	1397	1408677001000	4356	2258	0	0	3016
73511	1726	974100000000	4360	2260	0	0	20
73512	1397	1408656999000	4360	2260	1	0	3018
73513	1397	1408646998000	4361	2261	0	0	3019
73514	1397	1408636997000	4362	2262	0	0	3020
73518	1397	1408616995000	4364	2263	1	0	3022
73520	1397	1408606994000	4366	2264	0	0	3023
73522	1397	1408596993000	4368	2265	0	0	3024
73523	1397	1408586992000	4368	2265	1	0	3025
73524	1769	2960900000	4368	2265	2	0	9
73526	1397	1408576991000	4368	2265	4	0	3026
73527	1397	1408566990000	4369	2266	0	0	3027
73528	1397	1408556989000	4370	2267	0	0	3028
73530	1397	1408546988000	4372	2268	0	0	3029
73534	1397	1408536987000	4377	2269	0	0	3030
73536	1397	1408516985000	4379	2271	0	0	3032
73537	1397	1408506984000	4380	2272	0	0	3033
73541	1397	1408496983000	4384	2273	0	0	3034
73544	1397	1408486982000	4386	2274	0	0	3035
73546	1397	1408476981000	4387	2275	0	0	3036
73577	1397	1408927026000	4388	2223	30	0	\N
73578	1397	1408917025000	4388	2223	31	0	\N
73579	1397	1408907024000	4388	2223	32	0	\N
73580	1397	1408897023000	4388	2223	33	0	\N
73581	1397	1408887022000	4388	2223	34	0	\N
73582	1693	11546697500877	4388	2223	35	0	\N
73583	1397	1408877021000	4388	2223	36	0	\N
73584	1397	1408867020000	4388	2223	37	0	\N
73585	1397	1408857019000	4388	2223	38	0	\N
73586	1397	1408847018000	4388	2223	39	0	\N
73587	1397	1408837017000	4388	2223	40	0	\N
73588	1397	1408827016000	4388	2223	41	0	\N
73589	1397	1408817015000	4388	2223	42	0	\N
73590	1397	1408807014000	4388	2223	43	0	\N
73591	1397	1408797013000	4388	2223	44	0	\N
73592	1397	1408787012000	4388	2223	45	0	\N
73593	1397	1408777011000	4388	2223	46	0	\N
73594	1397	1408767010000	4388	2223	47	0	\N
73595	1397	1408757009000	4388	2223	48	0	\N
73596	1397	1408747008000	4388	2223	49	0	\N
73597	1397	1408737007000	4388	2223	50	0	\N
73598	1397	1408727006000	4388	2223	51	0	\N
73599	1397	1408717005000	4388	2223	52	0	\N
73600	1397	1408707004000	4388	2223	53	0	\N
73601	1397	1408697003000	4388	2223	54	0	\N
73602	1397	1408687002000	4388	2223	55	0	\N
73603	1397	1408677001000	4388	2223	56	0	\N
73604	1397	1408667000000	4388	2223	57	0	\N
73605	1397	1408656999000	4388	2223	58	0	\N
73606	1397	1408646998000	4388	2223	59	0	\N
73607	1397	1408636997000	4388	2223	60	0	\N
73608	1397	1408626996000	4388	2223	61	0	\N
73609	1397	1408616995000	4388	2223	62	0	\N
73610	1397	1408606994000	4388	2223	63	0	\N
73611	1397	1408596993000	4388	2223	64	0	\N
73612	1397	1408586992000	4388	2223	65	0	\N
73613	1397	1408576991000	4388	2223	66	0	\N
73614	1397	1408566990000	4388	2223	67	0	\N
73615	1397	1408556989000	4388	2223	68	0	\N
73616	1397	1408546988000	4388	2223	69	0	\N
73617	1397	1408536987000	4388	2223	70	0	\N
73618	1397	1408526986000	4388	2223	71	0	\N
73619	1397	1408516985000	4388	2223	72	0	\N
73620	1397	1408506984000	4388	2223	73	0	\N
73621	1397	1408496983000	4388	2223	74	0	\N
73622	1397	1408486982000	4388	2223	75	0	\N
73623	1397	1408476981000	4388	2223	76	0	\N
73624	1601	8393676900000	4389	2276	0	0	\N
73625	1693	12200337731495	4389	2276	1	0	\N
73626	1397	1408466980000	4389	2276	2	0	\N
73634	1601	8393676900000	4392	2275	0	0	\N
73635	1693	12200337731495	4392	2275	1	0	\N
73636	1693	12198316526375	4392	2275	2	0	\N
73637	1693	12131936756993	4392	2275	3	0	\N
73638	1397	1408476981000	4392	2275	4	0	\N
73639	1397	1408466980000	4392	2275	5	0	\N
73640	1397	1408456979000	4392	2275	6	0	\N
73641	1693	12065556987611	4392	2275	7	0	\N
73665	1693	10488657426942	4395	2279	0	0	\N
73666	1601	4680894600000	4395	2279	1	0	\N
73667	1693	10422277657560	4395	2279	2	0	\N
73668	1397	1408436977000	4395	2279	3	0	\N
73669	1693	10355897888178	4395	2279	4	0	\N
73670	1693	10488657426942	4396	2279	0	0	\N
73671	1601	4680894600000	4396	2279	1	0	\N
73672	1693	10422277657560	4396	2279	2	0	\N
73673	1397	1408436977000	4396	2279	3	0	\N
73674	1693	10355897888178	4396	2279	4	0	\N
73675	1693	10289518118796	4396	2279	5	0	\N
73676	1693	9980966206435	4396	2279	7	0	\N
73677	1693	9914586437053	4396	2279	8	0	\N
73678	1693	9848206667671	4396	2279	9	0	\N
73679	1693	9841462147296	4396	2279	10	0	\N
73680	1693	9775082377914	4396	2279	11	0	\N
73681	1397	1408426976000	4397	2280	0	0	\N
73682	1693	9708702608532	4397	2280	1	0	\N
73683	1693	9642322839150	4397	2280	2	0	\N
73684	1693	9575943069768	4397	2280	3	0	\N
73685	1693	9509563300386	4397	2280	4	0	\N
73686	1693	9443183531004	4397	2280	5	0	\N
73687	1693	9376803761622	4397	2280	6	0	\N
73688	1693	9310423992240	4397	2280	7	0	\N
73689	1693	9244044222858	4397	2280	8	0	\N
73690	1693	9177664453476	4397	2280	9	0	\N
73711	1397	1408416975000	4400	2281	0	0	\N
73712	1693	9111284684094	4400	2281	1	0	\N
73629	1397	1408466980000	4390	2276	2	0	3037
73630	1693	12198316526375	4391	2277	0	0	232
73631	1693	12131936756993	4391	2277	1	0	233
73632	1397	1408456979000	4391	2277	2	0	3038
73633	1693	12065556987611	4391	2277	3	0	234
73643	1601	5609092700000	4393	2278	1	0	4
73644	1397	1408446978000	4393	2278	2	0	3039
73645	1693	11999177218229	4393	2278	3	0	235
73646	1693	11932797448847	4393	2278	4	0	236
73647	1693	11728596663372	4393	2278	5	0	237
73649	1693	11595837124608	4393	2278	7	0	239
73650	1693	11593815919488	4393	2278	8	0	240
73651	1693	11527436150106	4393	2278	9	0	241
73652	1693	11461056380724	4393	2278	10	0	242
73654	1693	10488657426942	4394	2279	0	0	244
73655	1601	4680894600000	4394	2279	1	0	5
73656	1693	10422277657560	4394	2279	2	0	245
73657	1397	1408436977000	4394	2279	3	0	3040
73658	1693	10355897888178	4394	2279	4	0	246
73660	1693	9980966206435	4394	2279	7	0	248
73661	1693	9914586437053	4394	2279	8	0	249
73662	1693	9848206667671	4394	2279	9	0	250
73663	1693	9841462147296	4394	2279	10	0	251
73664	1693	9775082377914	4394	2279	11	0	252
73692	1693	9708702608532	4398	2280	1	0	253
73693	1693	9642322839150	4398	2280	2	0	254
73694	1693	9575943069768	4398	2280	3	0	255
73695	1693	9509563300386	4398	2280	4	0	256
73697	1693	9376803761622	4398	2280	6	0	258
73698	1693	9310423992240	4398	2280	7	0	259
73699	1693	9244044222858	4398	2280	8	0	260
73700	1693	9177664453476	4398	2280	9	0	261
73701	1397	1408416975000	4399	2281	0	0	3042
73703	1693	8605686784398	4399	2281	2	0	263
73704	1693	8539307015016	4399	2281	3	0	264
73705	1693	8532257797056	4399	2281	4	0	265
73706	1693	8465878027674	4399	2281	5	0	266
73707	1693	8399498258292	4399	2281	6	0	267
73709	1693	8266738719528	4399	2281	8	0	269
73710	1693	8200358950146	4399	2281	9	0	270
73713	1693	8605686784398	4400	2281	2	0	\N
73714	1693	8539307015016	4400	2281	3	0	\N
73715	1693	8532257797056	4400	2281	4	0	\N
73716	1693	8465878027674	4400	2281	5	0	\N
73717	1693	8399498258292	4400	2281	6	0	\N
73718	1693	8333118488910	4400	2281	7	0	\N
73719	1693	8266738719528	4400	2281	8	0	\N
73720	1693	8200358950146	4400	2281	9	0	\N
73721	1397	1408416975000	4401	2281	0	0	\N
73722	1693	9111284684094	4401	2281	1	0	\N
73723	1693	8605686784398	4401	2281	2	0	\N
73724	1693	8539307015016	4401	2281	3	0	\N
73725	1693	8532257797056	4401	2281	4	0	\N
73726	1693	8465878027674	4401	2281	5	0	\N
73727	1693	8399498258292	4401	2281	6	0	\N
73728	1693	8333118488910	4401	2281	7	0	\N
73729	1693	8266738719528	4401	2281	8	0	\N
73730	1693	8200358950146	4401	2281	9	0	\N
73731	1397	1408416975000	4402	2281	0	0	\N
73732	1693	9111284684094	4402	2281	1	0	\N
73733	1693	8605686784398	4402	2281	2	0	\N
73734	1693	8539307015016	4402	2281	3	0	\N
73735	1693	8532257797056	4402	2281	4	0	\N
73736	1693	8465878027674	4402	2281	5	0	\N
73737	1693	8399498258292	4402	2281	6	0	\N
73738	1693	8333118488910	4402	2281	7	0	\N
73739	1693	8266738719528	4402	2281	8	0	\N
73740	1693	8200358950146	4402	2281	9	0	\N
73751	1693	8133979180764	4404	2282	0	0	\N
73752	1397	1408406974000	4404	2282	1	0	\N
73753	1693	8067599411382	4404	2282	2	0	\N
73754	1693	8001219642000	4404	2282	3	0	\N
73755	1693	7934839872618	4404	2282	4	0	\N
73756	1693	7868460103236	4404	2282	5	0	\N
73757	1693	7802080333854	4404	2282	6	0	\N
73758	1693	7797042321028	4404	2282	7	0	\N
73759	1693	7730662551646	4404	2282	8	0	\N
73760	1693	7728641346526	4404	2282	9	0	\N
73761	1397	1408396973000	4405	2283	0	0	\N
73762	1693	7662261577144	4405	2283	1	0	\N
73763	1693	7595881807762	4405	2283	2	0	\N
73764	1693	7529502038380	4405	2283	3	0	\N
73765	1693	7463122268998	4405	2283	4	0	\N
73766	1693	7396742499616	4405	2283	5	0	\N
73767	1693	7330362730234	4405	2283	6	0	\N
73768	1693	7263982960852	4405	2283	7	0	\N
73769	1693	7197603191470	4405	2283	8	0	\N
73779	1726	980600000000	4407	2212	0	0	\N
73780	1726	979300000000	4407	2212	1	0	\N
73781	1726	978000000000	4407	2212	2	0	\N
73782	1726	976700000000	4407	2212	3	0	\N
73783	1726	975400000000	4407	2212	4	0	\N
73784	1726	974100000000	4407	2212	5	0	\N
73785	1397	1409287062000	4407	2212	6	0	\N
73786	1769	2960900000	4407	2212	7	0	\N
73787	1769	2950900000	4407	2212	8	0	\N
73788	1397	1409277061000	4407	2212	9	0	\N
73789	1397	1409267060000	4407	2212	10	0	\N
73790	1397	1409257059000	4407	2212	11	0	\N
73791	1397	1409247058000	4407	2212	12	0	\N
73792	1397	1409237057000	4407	2212	13	0	\N
73793	1397	1409227056000	4407	2212	14	0	\N
73794	1397	1409217055000	4407	2212	15	0	\N
73795	1397	1409207054000	4407	2212	16	0	\N
73796	1397	1409197053000	4407	2212	17	0	\N
73797	1601	11520251000000	4407	2212	18	0	\N
73798	1601	8393676900000	4407	2212	19	0	\N
73799	1601	6730862800000	4407	2212	20	0	\N
73800	1601	5609092700000	4407	2212	21	0	\N
73801	1601	4680894600000	4407	2212	22	0	\N
73802	1397	1409187052000	4407	2212	23	0	\N
73803	1397	1409177051000	4407	2212	24	0	\N
73804	1397	1409167050000	4407	2212	25	0	\N
73805	1397	1409157049000	4407	2212	26	0	\N
73806	1397	1409147048000	4407	2212	27	0	\N
73807	1397	1409137047000	4407	2212	28	0	\N
73808	1397	1409127046000	4407	2212	29	0	\N
73809	1397	1409117045000	4407	2212	30	0	\N
73810	1397	1409107044000	4407	2212	31	0	\N
73811	1397	1409097043000	4407	2212	32	0	\N
73812	1397	1409087042000	4407	2212	33	0	\N
73813	1397	1409077041000	4407	2212	34	0	\N
73814	1397	1409067040000	4407	2212	35	0	\N
73815	1397	1409057039000	4407	2212	36	0	\N
73816	1397	1409047038000	4407	2212	37	0	\N
73817	1397	1409037037000	4407	2212	38	0	\N
73818	1397	1409027036000	4407	2212	39	0	\N
73819	1397	1409017035000	4407	2212	40	0	\N
73820	1397	1409007034000	4407	2212	41	0	\N
73821	1397	1408997033000	4407	2212	42	0	\N
73822	1397	1408987032000	4407	2212	43	0	\N
73823	1397	1408977031000	4407	2212	44	0	\N
73824	1397	1408967030000	4407	2212	45	0	\N
73825	1397	1408957029000	4407	2212	46	0	\N
73826	1397	1408947028000	4407	2212	47	0	\N
73827	1397	1408937027000	4407	2212	48	0	\N
73828	1397	1408927026000	4407	2212	49	0	\N
73829	1397	1408917025000	4407	2212	50	0	\N
73830	1397	1408907024000	4407	2212	51	0	\N
73831	1397	1408897023000	4407	2212	52	0	\N
73832	1397	1408887022000	4407	2212	53	0	\N
73833	1693	10826687500877	4407	2212	54	0	\N
73834	1693	10760307731495	4407	2212	55	0	\N
73835	1693	10758286526375	4407	2212	56	0	\N
73836	1693	10691906756993	4407	2212	57	0	\N
73837	1693	10625526987611	4407	2212	58	0	\N
73838	1693	10559147218229	4407	2212	59	0	\N
73839	1693	10492767448847	4407	2212	60	0	\N
73840	1693	10288566663372	4407	2212	61	0	\N
73841	1693	10222186893990	4407	2212	62	0	\N
73842	1693	10155807124608	4407	2212	63	0	\N
73843	1693	10153785919488	4407	2212	64	0	\N
73844	1693	10087406150106	4407	2212	65	0	\N
73845	1693	10021026380724	4407	2212	66	0	\N
73846	1693	9115007196324	4407	2212	67	0	\N
73847	1693	9048627426942	4407	2212	68	0	\N
73848	1693	8982247657560	4407	2212	69	0	\N
73743	1693	8067599411382	4403	2282	2	0	272
73744	1693	8001219642000	4403	2282	3	0	273
73745	1693	7934839872618	4403	2282	4	0	274
73746	1693	7868460103236	4403	2282	5	0	275
73747	1693	7802080333854	4403	2282	6	0	276
73749	1693	7730662551646	4403	2282	8	0	278
73750	1693	7728641346526	4403	2282	9	0	279
73770	1397	1408396973000	4406	2283	0	0	3044
73771	1693	7662261577144	4406	2283	1	0	280
73772	1693	7595881807762	4406	2283	2	0	281
73774	1693	7463122268998	4406	2283	4	0	283
73775	1693	7396742499616	4406	2283	5	0	284
73776	1693	7330362730234	4406	2283	6	0	285
73777	1693	7263982960852	4406	2283	7	0	286
73849	1693	8915867888178	4407	2212	70	0	\N
73850	1693	8849488118796	4407	2212	71	0	\N
73851	1693	8540936206435	4407	2212	72	0	\N
73852	1693	8474556437053	4407	2212	73	0	\N
73853	1693	8408176667671	4407	2212	74	0	\N
73854	1693	8401432147296	4407	2212	75	0	\N
73855	1693	8335052377914	4407	2212	76	0	\N
73856	1693	8268672608532	4407	2212	77	0	\N
73857	1693	8202292839150	4407	2212	78	0	\N
73858	1693	8135913069768	4407	2212	79	0	\N
73859	1693	8069533300386	4407	2212	80	0	\N
73860	1693	8003153531004	4407	2212	81	0	\N
73861	1693	7936773761622	4407	2212	82	0	\N
73862	1693	7870393992240	4407	2212	83	0	\N
73863	1693	7804014222858	4407	2212	84	0	\N
73864	1693	7737634453476	4407	2212	85	0	\N
73865	1693	7671254684094	4407	2212	86	0	\N
73866	1693	7165656784398	4407	2212	87	0	\N
73867	1693	7099277015016	4407	2212	88	0	\N
73868	1693	7092227797056	4407	2212	89	0	\N
73869	1693	7025848027674	4407	2212	90	0	\N
73870	1397	1408877021000	4407	2212	91	0	\N
73871	1397	1408867020000	4407	2212	92	0	\N
73872	1397	1408857019000	4407	2212	93	0	\N
73873	1397	1408847018000	4407	2212	94	0	\N
73874	1397	1408837017000	4407	2212	95	0	\N
73875	1397	1408827016000	4407	2212	96	0	\N
73876	1397	1408817015000	4407	2212	97	0	\N
73877	1397	1408807014000	4407	2212	98	0	\N
73878	1397	1408797013000	4407	2212	99	0	\N
73879	1397	1408787012000	4407	2212	100	0	\N
73880	1397	1408777011000	4407	2212	101	0	\N
73881	1397	1408767010000	4407	2212	102	0	\N
73882	1397	1408757009000	4407	2212	103	0	\N
73883	1397	1408747008000	4407	2212	104	0	\N
73884	1397	1408737007000	4407	2212	105	0	\N
73885	1397	1408727006000	4407	2212	106	0	\N
73886	1397	1408717005000	4407	2212	107	0	\N
73887	1397	1408707004000	4407	2212	108	0	\N
73888	1397	1408697003000	4407	2212	109	0	\N
73889	1397	1408687002000	4407	2212	110	0	\N
73890	1397	1408677001000	4407	2212	111	0	\N
73891	1397	1408667000000	4407	2212	112	0	\N
73892	1397	1408656999000	4407	2212	113	0	\N
73893	1397	1408646998000	4407	2212	114	0	\N
73894	1397	1408636997000	4407	2212	115	0	\N
73895	1397	1408626996000	4407	2212	116	0	\N
73896	1397	1408616995000	4407	2212	117	0	\N
73897	1397	1408606994000	4407	2212	118	0	\N
73898	1397	1408596993000	4407	2212	119	0	\N
73899	1397	1408586992000	4407	2212	120	0	\N
73900	1397	1408576991000	4407	2212	121	0	\N
73901	1397	1408566990000	4407	2212	123	0	\N
73902	1397	1408556989000	4407	2212	124	0	\N
73903	1397	1408546988000	4407	2212	125	0	\N
73934	1397	1408356969000	4411	2287	0	0	\N
73935	1693	3005404832514	4411	2287	1	0	\N
73936	1693	2939025063132	4411	2287	2	0	\N
73937	1693	2872645293750	4411	2287	3	0	\N
73938	1693	2806265524368	4411	2287	4	0	\N
73939	1693	2739885754986	4411	2287	5	0	\N
73940	1693	2673505985604	4411	2287	6	0	\N
73941	1693	2607126216222	4411	2287	7	0	\N
73942	1693	2540746446840	4411	2287	8	0	\N
73943	1693	2474366677458	4411	2287	9	0	\N
73976	1693	1924010953131	4415	2289	0	0	\N
73977	1693	1857631183749	4415	2289	1	0	\N
73978	1397	1408336967000	4415	2289	2	0	\N
73979	1397	1408326966000	4415	2289	3	0	\N
73980	1397	1408316965000	4415	2289	4	0	\N
73981	1397	1408306964000	4415	2289	5	0	\N
73982	1693	1791251414367	4415	2289	6	0	\N
73983	1693	1724871644985	4415	2289	7	0	\N
73984	1693	1658491875603	4415	2289	8	0	\N
73906	1693	7064843652706	4408	2284	2	0	289
73907	1693	6998463883324	4408	2284	3	0	290
73908	1693	6932759878873	4408	2284	4	0	291
73909	1693	6866380109491	4408	2284	5	0	292
73910	1693	6800000340109	4408	2284	6	0	293
73912	1693	6667240801345	4408	2284	8	0	295
73913	1693	6657174775693	4408	2284	9	0	296
73914	1693	6590795006311	4409	2285	0	0	297
73915	1397	1408376971000	4409	2285	1	0	3046
73916	1693	5979482556087	4409	2285	2	0	298
73918	1693	5846723017323	4409	2285	4	0	300
73919	1693	5780343247941	4409	2285	5	0	301
73920	1693	5713963478559	4409	2285	6	0	302
73921	1693	5647583709177	4409	2285	7	0	303
73923	1693	5548453531451	4409	2285	9	0	305
73924	1693	5482073762069	4410	2286	0	0	306
73925	1693	3778615130549	4410	2286	1	0	307
73926	1693	3712235361167	4410	2286	2	0	308
73927	1397	1408366970000	4410	2286	3	0	3047
73929	1693	3337303679424	4410	2286	5	0	310
73930	1693	3270923910042	4410	2286	6	0	311
73931	1693	3204544140660	4410	2286	7	0	312
73932	1693	3138164371278	4410	2286	8	0	313
73933	1693	3071784601896	4410	2286	9	0	314
73945	1693	3005404832514	4412	2287	1	0	315
73946	1693	2939025063132	4412	2287	2	0	316
73947	1693	2872645293750	4412	2287	3	0	317
73948	1693	2806265524368	4412	2287	4	0	318
73950	1693	2673505985604	4412	2287	6	0	320
73951	1693	2607126216222	4412	2287	7	0	321
73952	1693	2540746446840	4412	2287	8	0	322
73953	1693	2474366677458	4412	2287	9	0	323
73954	1726	972800000000	4413	2288	0	0	21
73956	1726	970200000000	4413	2288	2	0	23
73957	1726	968900000000	4413	2288	3	0	24
73958	1693	2407986908076	4413	2288	4	0	324
73959	1693	2341607138694	4413	2288	5	0	325
73960	1397	1408346968000	4413	2288	6	0	3049
73962	1693	2208847599930	4413	2288	8	0	327
73963	1693	2189530030659	4413	2288	9	0	328
73964	1693	2123150261277	4413	2288	10	0	329
73965	1693	2056770491895	4413	2288	11	0	330
73967	1693	1924010953131	4414	2289	0	0	332
73968	1693	1857631183749	4414	2289	1	0	333
73969	1397	1408336967000	4414	2289	2	0	3050
73970	1397	1408326966000	4414	2289	3	0	3051
73971	1397	1408316965000	4414	2289	4	0	3052
73973	1693	1791251414367	4414	2289	6	0	334
73974	1693	1724871644985	4414	2289	7	0	335
73975	1693	1658491875603	4414	2289	8	0	336
73985	1693	1454291090128	4415	2289	9	0	\N
73986	1693	1387911320746	4415	2289	11	0	\N
73987	1693	1321531551364	4415	2289	12	0	\N
73988	1693	1924010953131	4416	2289	0	0	\N
73989	1693	1857631183749	4416	2289	1	0	\N
73990	1397	1408336967000	4416	2289	2	0	\N
73991	1397	1408326966000	4416	2289	3	0	\N
73992	1397	1408316965000	4416	2289	4	0	\N
73993	1397	1408306964000	4416	2289	5	0	\N
73994	1693	1791251414367	4416	2289	6	0	\N
73995	1693	1724871644985	4416	2289	7	0	\N
73996	1693	1658491875603	4416	2289	8	0	\N
73997	1693	1454291090128	4416	2289	9	0	\N
73998	1693	1387911320746	4416	2289	11	0	\N
73999	1693	1321531551364	4416	2289	12	0	\N
74009	1397	1408296963000	4419	2290	0	0	\N
74010	1693	1454291090128	4419	2290	1	0	\N
74011	1693	1387911320746	4419	2290	2	0	\N
74012	1397	1408286962000	4419	2290	3	0	\N
74013	1693	1321531551364	4419	2290	4	0	\N
74014	1693	1321421551364	4419	2290	5	0	\N
74015	1769	2949900000	4419	2290	6	0	\N
74016	1769	2948900000	4419	2290	7	0	\N
74017	1769	2947900000	4419	2290	8	0	\N
74023	1397	1408266960000	4422	2292	0	0	\N
74024	1397	1408256959000	4422	2292	1	0	\N
74026	1726	975400000000	4424	2241	0	0	\N
74027	1726	974100000000	4424	2241	1	0	\N
74028	1726	972800000000	4424	2241	2	0	\N
74029	1726	971500000000	4424	2241	3	0	\N
74030	1726	970200000000	4424	2241	4	0	\N
74031	1726	968900000000	4424	2241	5	0	\N
74032	1726	967600000000	4424	2241	6	0	\N
74033	1726	966300000000	4424	2241	7	0	\N
74034	1693	12200337731495	4424	2241	8	0	\N
74035	1693	12198316526375	4424	2241	9	0	\N
74036	1693	12131936756993	4424	2241	10	0	\N
74037	1769	2960900000	4424	2241	11	0	\N
74038	1769	2950900000	4424	2241	12	0	\N
74039	1601	11520251000000	4424	2241	13	0	\N
74040	1601	8393676900000	4424	2241	14	0	\N
74041	1601	6730862800000	4424	2241	15	0	\N
74042	1601	5609092700000	4424	2241	16	0	\N
74043	1601	4680894600000	4424	2241	17	0	\N
74044	1693	12065556987611	4424	2241	18	0	\N
74045	1693	11999177218229	4424	2241	19	0	\N
74046	1693	11932797448847	4424	2241	20	0	\N
74047	1693	11728596663372	4424	2241	21	0	\N
74051	1397	1408216955000	4427	2296	0	0	\N
74054	1397	1408206954000	4430	2297	0	0	\N
74055	1726	972800000000	4431	2283	0	0	\N
74056	1726	971500000000	4431	2283	1	0	\N
74057	1726	970200000000	4431	2283	2	0	\N
74058	1726	968900000000	4431	2283	3	0	\N
74059	1726	967600000000	4431	2283	4	0	\N
74060	1726	966300000000	4431	2283	5	0	\N
74061	1397	1408396973000	4431	2283	6	0	\N
74062	1397	1408386972000	4431	2283	7	0	\N
74063	1397	1408376971000	4431	2283	8	0	\N
74064	1397	1408366970000	4431	2283	9	0	\N
74065	1397	1408356969000	4431	2283	10	0	\N
74066	1397	1408346968000	4431	2283	11	0	\N
74067	1397	1408336967000	4431	2283	12	0	\N
74068	1397	1408326966000	4431	2283	13	0	\N
74069	1397	1408316965000	4431	2283	14	0	\N
74070	1397	1408306964000	4431	2283	15	0	\N
74071	1397	1408296963000	4431	2283	16	0	\N
74072	1397	1408286962000	4431	2283	17	0	\N
74073	1397	1408276961000	4431	2283	18	0	\N
74074	1397	1408266960000	4431	2283	19	0	\N
74075	1397	1408256959000	4431	2283	20	0	\N
74076	1397	1408246958000	4431	2283	21	0	\N
74077	1397	1408236957000	4431	2283	22	0	\N
74078	1397	1408226956000	4431	2283	23	0	\N
74079	1397	1408216955000	4431	2283	24	0	\N
74080	1397	1408206954000	4431	2283	25	0	\N
74081	1769	2949900000	4431	2283	26	0	\N
74082	1769	2948900000	4431	2283	27	0	\N
74083	1769	2947900000	4431	2283	28	0	\N
74084	1726	965000000000	4432	2298	0	0	\N
74085	1397	1408196953000	4432	2298	1	0	\N
74086	1397	1408186952000	4432	2298	2	0	\N
74087	1801	719020000000	4432	2298	3	0	\N
74092	1397	1408176951000	4434	2299	0	0	\N
74093	1397	1408166950000	4434	2299	1	0	\N
74096	1397	1408176951000	4436	2299	0	0	\N
74097	1397	1408166950000	4436	2299	1	0	\N
74100	1397	1408156949000	4438	2300	0	0	\N
74101	1397	1408146948000	4438	2300	1	0	\N
74103	1397	1408126946000	4440	2302	0	0	\N
74105	1726	963700000000	4442	2303	0	0	\N
74106	1726	962400000000	4442	2303	1	0	\N
74107	1397	1408116945000	4442	2303	2	0	\N
74108	1693	1040311551364	4442	2303	3	0	\N
74109	1726	963700000000	4443	2303	0	0	\N
74110	1726	962400000000	4443	2303	1	0	\N
74111	1397	1408116945000	4443	2303	2	0	\N
74112	1693	1040311551364	4443	2303	3	0	\N
74117	1397	1408106944000	4445	2304	0	0	\N
74118	1800	199000000	4445	2304	1	0	\N
74119	1397	1408106944000	4446	2304	0	0	\N
74120	1800	199000000	4446	2304	1	0	\N
74002	1693	1387911320746	4417	2290	2	0	338
74003	1397	1408286962000	4417	2290	3	0	3055
74004	1693	1321531551364	4417	2290	4	0	339
74005	1693	1321421551364	4417	2290	5	0	340
74006	1769	2949900000	4417	2290	6	0	11
74008	1769	2947900000	4417	2290	8	0	13
74018	1726	967600000000	4420	2291	0	0	25
74019	1693	321411551364	4420	2291	1	0	341
74020	1397	1408276961000	4420	2291	2	0	3056
74021	1397	1408266960000	4421	2292	0	0	3057
74025	1397	1408246958000	4423	2293	0	0	3059
74048	1726	966300000000	4425	2294	0	0	26
74049	1397	1408236957000	4425	2294	1	0	3060
74050	1397	1408226956000	4426	2295	0	0	3061
74053	1397	1408206954000	4429	2297	0	0	3063
74088	1726	965000000000	4433	2298	0	0	27
74089	1397	1408196953000	4433	2298	1	0	3064
74090	1397	1408186952000	4433	2298	2	0	3065
74091	1801	719020000000	4433	2298	3	0	1
74095	1397	1408166950000	4435	2299	1	0	3067
74098	1397	1408156949000	4437	2300	0	0	3068
74099	1397	1408146948000	4437	2300	1	0	3069
74102	1397	1408136947000	4439	2301	0	0	3070
74104	1397	1408126946000	4441	2302	0	0	3071
74114	1726	962400000000	4444	2303	1	0	29
74115	1397	1408116945000	4444	2303	2	0	3072
74116	1693	1040311551364	4444	2303	3	0	342
74123	1397	1408106944000	4448	2304	0	0	\N
74124	1800	199000000	4448	2304	1	0	\N
74125	1726	972800000000	4449	2213	0	0	\N
74126	1726	971500000000	4449	2213	1	0	\N
74127	1726	970200000000	4449	2213	2	0	\N
74128	1726	968900000000	4449	2213	3	0	\N
74129	1726	967600000000	4449	2213	4	0	\N
74130	1726	966300000000	4449	2213	5	0	\N
74131	1726	965000000000	4449	2213	6	0	\N
74132	1726	963700000000	4449	2213	7	0	\N
74133	1726	962400000000	4449	2213	8	0	\N
74134	1397	1408536987000	4449	2213	9	0	\N
74135	1397	1408526986000	4449	2213	10	0	\N
74136	1397	1408516985000	4449	2213	11	0	\N
74137	1397	1408506984000	4449	2213	12	0	\N
74138	1397	1408496983000	4449	2213	13	0	\N
74139	1397	1408486982000	4449	2213	14	0	\N
74140	1397	1408476981000	4449	2213	15	0	\N
74141	1397	1408466980000	4449	2213	16	0	\N
74142	1397	1408456979000	4449	2213	17	0	\N
74143	1397	1408446978000	4449	2213	18	0	\N
74144	1397	1408436977000	4449	2213	19	0	\N
74145	1397	1408426976000	4449	2213	20	0	\N
74146	1397	1408416975000	4449	2213	21	0	\N
74147	1397	1408406974000	4449	2213	22	0	\N
74148	1397	1408396973000	4449	2213	23	0	\N
74149	1397	1408106944000	4450	2304	0	0	\N
74150	1800	199000000	4450	2304	1	0	\N
74157	1397	1408056939000	4455	2309	0	0	\N
74158	1397	1408056939000	4456	2309	0	0	\N
74168	1726	981900000000	4461	2193	0	0	\N
74169	1706	7916302000000	4461	2193	1	0	\N
74170	1726	980600000000	4461	2193	2	0	\N
74171	1726	979300000000	4461	2193	3	0	\N
74172	1726	978000000000	4461	2193	4	0	\N
74173	1726	976700000000	4461	2193	5	0	\N
74174	1726	975400000000	4461	2193	6	0	\N
74175	1726	974100000000	4461	2193	7	0	\N
74176	1726	972800000000	4461	2193	8	0	\N
74177	1726	971500000000	4461	2193	9	0	\N
74178	1726	970200000000	4461	2193	10	0	\N
74179	1726	968900000000	4461	2193	11	0	\N
74180	1726	967600000000	4461	2193	12	0	\N
74181	1726	966300000000	4461	2193	13	0	\N
74182	1726	965000000000	4461	2193	14	0	\N
74183	1726	963700000000	4461	2193	15	0	\N
74184	1726	962400000000	4461	2193	16	0	\N
74185	1726	961100000000	4461	2193	17	0	\N
74186	1726	959800000000	4461	2193	18	0	\N
74187	1726	958500000000	4461	2193	19	0	\N
74188	1769	2960900000	4461	2193	20	0	\N
74189	1769	2950900000	4461	2193	21	0	\N
74190	1601	11520251000000	4461	2193	22	0	\N
74191	1601	8393676900000	4461	2193	23	0	\N
74192	1601	6730862800000	4461	2193	24	0	\N
74193	1601	5609092700000	4461	2193	25	0	\N
74194	1601	4680894600000	4461	2193	26	0	\N
74195	1693	10106677500877	4461	2193	27	0	\N
74196	1693	10040297731495	4461	2193	28	0	\N
74197	1693	10038276526375	4461	2193	29	0	\N
74198	1693	9971896756993	4461	2193	30	0	\N
74199	1693	9905516987611	4461	2193	31	0	\N
74200	1693	9839137218229	4461	2193	32	0	\N
74201	1693	9772757448847	4461	2193	33	0	\N
74202	1693	9568556663372	4461	2193	34	0	\N
74203	1693	9502176893990	4461	2193	35	0	\N
74204	1693	9435797124608	4461	2193	36	0	\N
74205	1693	9433775919488	4461	2193	37	0	\N
74206	1693	9367396150106	4461	2193	38	0	\N
74207	1693	9301016380724	4461	2193	39	0	\N
74208	1693	8394997196324	4461	2193	40	0	\N
74209	1693	8328617426942	4461	2193	41	0	\N
74210	1693	8262237657560	4461	2193	42	0	\N
74211	1693	8195857888178	4461	2193	43	0	\N
74212	1693	8129478118796	4461	2193	44	0	\N
74213	1693	7820926206435	4461	2193	45	0	\N
74214	1693	7754546437053	4461	2193	46	0	\N
74215	1693	7688166667671	4461	2193	47	0	\N
74216	1693	7681422147296	4461	2193	48	0	\N
74217	1693	7615042377914	4461	2193	49	0	\N
74218	1693	7548662608532	4461	2193	50	0	\N
74219	1693	7482282839150	4461	2193	51	0	\N
74220	1693	7415903069768	4461	2193	52	0	\N
74221	1693	7349523300386	4461	2193	53	0	\N
74222	1693	7283143531004	4461	2193	54	0	\N
74223	1693	7216763761622	4461	2193	55	0	\N
74224	1693	7150383992240	4461	2193	56	0	\N
74225	1693	7084004222858	4461	2193	57	0	\N
74226	1693	7017624453476	4461	2193	58	0	\N
74227	1693	6951244684094	4461	2193	59	0	\N
74228	1693	6445646784398	4461	2193	60	0	\N
74229	1693	6379267015016	4461	2193	61	0	\N
74230	1693	6372217797056	4461	2193	62	0	\N
74231	1693	6305838027674	4461	2193	63	0	\N
74232	1693	6239458258292	4461	2193	64	0	\N
74233	1693	6173078488910	4461	2193	65	0	\N
74234	1693	6106698719528	4461	2193	66	0	\N
74235	1693	6040318950146	4461	2193	67	0	\N
74236	1693	5973939180764	4461	2193	68	0	\N
74237	1693	5907559411382	4461	2193	69	0	\N
74238	1693	5841179642000	4461	2193	70	0	\N
74239	1693	5774799872618	4461	2193	71	0	\N
74240	1693	5708420103236	4461	2193	72	0	\N
74241	1693	5642040333854	4461	2193	73	0	\N
74242	1693	5637002321028	4461	2193	74	0	\N
74243	1693	5570622551646	4461	2193	76	0	\N
74244	1693	5568601346526	4461	2193	77	0	\N
74245	1693	5502221577144	4461	2193	78	0	\N
74246	1693	5435841807762	4461	2193	79	0	\N
74247	1693	5369462038380	4461	2193	80	0	\N
74248	1693	5303082268998	4461	2193	81	0	\N
74249	1693	5236702499616	4461	2193	82	0	\N
74250	1693	5170322730234	4461	2193	83	0	\N
74251	1693	5103942960852	4461	2193	84	0	\N
74252	1693	5037563191470	4461	2193	85	0	\N
74253	1693	4971183422088	4461	2193	86	0	\N
74254	1693	4904803652706	4461	2193	87	0	\N
74255	1693	4838423883324	4461	2193	88	0	\N
74256	1693	4772719878873	4461	2193	89	0	\N
74151	1397	1408096943000	4451	2305	0	0	3074
74152	1800	198000000	4451	2305	1	0	2
74153	1397	1408086942000	4452	2306	0	0	3075
74154	1397	1408076941000	4453	2307	0	0	3076
74155	1811	90000000	4453	2307	1	0	1
74159	1397	1408056939000	4457	2309	0	0	3078
74160	1726	961100000000	4458	2310	0	0	30
74161	1397	1408046938000	4458	2310	1	0	3079
74162	1397	1408036937000	4458	2310	2	0	3080
74163	1397	1408026936000	4459	2311	0	0	3081
74165	1726	958500000000	4460	2312	1	0	32
74166	1397	1408016935000	4460	2312	2	0	3082
74167	237	66000090000000	4460	2312	3	0	1
74257	1693	4706340109491	4461	2193	90	0	\N
74258	1693	4639960340109	4461	2193	91	0	\N
74259	1693	4573580570727	4461	2193	92	0	\N
74260	1693	4507200801345	4461	2193	93	0	\N
74261	1693	4497134775693	4461	2193	94	0	\N
74262	1693	4430755006311	4461	2193	95	0	\N
74263	1693	3819442556087	4461	2193	96	0	\N
74264	1693	3753062786705	4461	2193	97	0	\N
74265	1693	3686683017323	4461	2193	98	0	\N
74266	1693	3620303247941	4461	2193	99	0	\N
74267	1693	3553923478559	4461	2193	100	0	\N
74268	1693	3487543709177	4461	2193	101	0	\N
74269	1693	3454793300833	4461	2193	102	0	\N
74270	1693	3388413531451	4461	2193	103	0	\N
74271	1693	3322033762069	4461	2193	104	0	\N
74272	1693	1618575130549	4461	2193	105	0	\N
74273	1693	1552195361167	4461	2193	106	0	\N
74274	1693	1485815591785	4461	2193	107	0	\N
74275	1693	1177263679424	4461	2193	108	0	\N
74276	1693	1110883910042	4461	2193	109	0	\N
74277	1693	1044504140660	4461	2193	110	0	\N
74278	1693	978124371278	4461	2193	111	0	\N
74279	1693	911744601896	4461	2193	112	0	\N
74280	1693	845364832514	4461	2193	113	0	\N
74281	1693	778985063132	4461	2193	114	0	\N
74282	1693	712605293750	4461	2193	115	0	\N
74283	1693	646225524368	4461	2193	116	0	\N
74284	1693	579845754986	4461	2193	117	0	\N
74285	1693	513465985604	4461	2193	118	0	\N
74286	1693	447086216222	4461	2193	119	0	\N
74287	1693	380706446840	4461	2193	120	0	\N
74288	1693	314326677458	4461	2193	121	0	\N
74289	1693	247946908076	4461	2193	122	0	\N
74290	1693	181567138694	4461	2193	123	0	\N
74291	1693	115187369312	4461	2193	124	0	\N
74292	1693	48807599930	4461	2193	125	0	\N
74293	1397	1408006934000	4462	2313	0	0	\N
74294	1397	1408006934000	4463	2313	0	0	\N
74295	1397	1408006934000	4464	2313	0	0	\N
74297	1397	1407996933000	4466	2314	0	0	\N
74298	1397	1407996933000	4467	2314	0	0	\N
74306	1726	957200000000	4472	2317	0	0	\N
74307	1397	1407956929000	4472	2317	1	0	\N
74308	1397	1407946928000	4472	2317	2	0	\N
74315	1397	1407886922000	4474	2319	0	0	\N
74316	1397	1407886922000	4475	2319	0	0	\N
74318	1816	0	4477	2320	0	0	\N
74319	1397	1407876921000	4477	2320	1	0	\N
74320	1816	0	4479	2321	0	0	\N
74321	1397	1407876921000	4479	2321	2	0	\N
74322	1397	1407866920000	4479	2321	3	0	\N
74326	1816	0	4481	2321	0	0	\N
74327	1397	1407876921000	4481	2321	2	0	\N
74328	1816	0	4482	2321	0	0	\N
74329	1397	1407876921000	4482	2321	2	0	\N
74330	1397	1407866920000	4482	2321	3	0	\N
74331	1397	1407856919000	4483	2322	0	0	\N
74334	1397	1407836917000	4486	2324	0	0	\N
74338	1397	1407816915000	4490	2326	0	0	\N
74339	1397	1407806914000	4491	2327	0	0	\N
74340	41	66000471816426	4491	2327	1	0	\N
74341	6	32558703045112	4491	2327	2	0	\N
74342	1397	1407806914000	4492	2327	0	0	\N
74343	41	66000471816426	4492	2327	1	0	\N
74344	6	32558703045112	4492	2327	2	0	\N
74348	1397	1407806914000	4495	2327	0	0	\N
74349	41	66000471816426	4495	2327	1	0	\N
74350	6	32558703045112	4495	2327	2	0	\N
74351	1726	955900000000	4496	2328	0	0	\N
74352	739	10000244820647	4496	2328	1	0	\N
74353	1397	1407796913000	4496	2328	2	0	\N
74354	1397	1407786912000	4496	2328	3	0	\N
74355	5	6697563753375	4496	2328	4	0	\N
74356	1726	955900000000	4497	2328	0	0	\N
74357	739	10000244820647	4497	2328	1	0	\N
74358	1397	1407796913000	4497	2328	2	0	\N
74359	1397	1407786912000	4497	2328	3	0	\N
74360	5	6697563753375	4497	2328	4	0	\N
74366	41	66000471816426	4499	2326	0	0	\N
74367	1397	1407816915000	4499	2326	1	0	\N
74375	1397	1407736907000	4503	2331	0	0	\N
74376	1397	1407726906000	4503	2331	1	0	\N
74377	1397	1407716905000	4504	2332	0	0	\N
74379	1397	1407716905000	4506	2332	0	0	\N
74380	1397	1407706904000	4507	2333	0	0	\N
74381	1397	1407706904000	4508	2333	0	0	\N
74383	1397	1407706904000	4510	2333	0	0	\N
74384	1726	961100000000	4511	2305	0	0	\N
74385	1726	959800000000	4511	2305	1	0	\N
74386	1726	958500000000	4511	2305	2	0	\N
74387	1726	957200000000	4511	2305	3	0	\N
74388	1726	955900000000	4511	2305	4	0	\N
74389	37	65329909092470	4511	2305	5	0	\N
74390	1693	1039201551364	4511	2305	6	0	\N
74391	237	66000090000000	4511	2305	7	0	\N
74392	41	66000471816426	4511	2305	8	0	\N
74300	1397	1407986932000	4469	2315	1	0	3085
74301	1397	1407976931000	4469	2315	2	0	3086
74302	1397	1407966930000	4470	2316	0	0	3087
74303	1726	957200000000	4471	2317	0	0	33
74304	1397	1407956929000	4471	2317	1	0	3088
74309	1693	1759321551364	4473	2318	0	0	343
74310	1397	1407936927000	4473	2318	1	0	3090
74311	1397	1407926926000	4473	2318	2	0	3091
74312	1397	1407916925000	4473	2318	3	0	3092
74313	1397	1407906924000	4473	2318	4	0	3093
74317	1397	1407886922000	4476	2319	0	0	3095
74323	1816	0	4480	2321	0	0	1
74324	1397	1407876921000	4480	2321	2	0	3096
74325	1397	1407866920000	4480	2321	3	0	3097
74333	1397	1407846918000	4485	2323	0	0	3099
74335	1397	1407836917000	4487	2324	0	0	3100
74336	1397	1407826916000	4488	2325	0	0	3101
74337	1397	1407816915000	4489	2326	0	0	3102
74345	1397	1407806914000	4494	2327	0	0	3103
74347	6	32558703045112	4494	2327	2	0	1
74361	1726	955900000000	4498	2328	0	0	34
74362	739	10000244820647	4498	2328	1	0	1
74363	1397	1407796913000	4498	2328	2	0	3104
74364	1397	1407786912000	4498	2328	3	0	3105
74368	37	65329909092470	4500	2329	0	0	1
74369	1397	1407776911000	4500	2329	1	0	3106
74370	1397	1407766910000	4500	2329	2	0	3107
74371	1397	1407756909000	4500	2329	3	0	3108
74373	1397	1407736907000	4502	2331	0	0	3110
74374	1397	1407726906000	4502	2331	1	0	3111
74378	1397	1407716905000	4505	2332	0	0	3112
74382	1397	1407706904000	4509	2333	0	0	3113
74393	1811	303090000000	4511	2305	9	0	\N
74394	739	10000244820647	4511	2305	10	0	\N
74395	6	32558703045112	4511	2305	11	0	\N
74396	1397	1408096943000	4511	2305	12	0	\N
74397	1397	1408086942000	4511	2305	13	0	\N
74398	1397	1408076941000	4511	2305	14	0	\N
74399	5	6697563753375	4511	2305	15	0	\N
74400	1397	1408066940000	4511	2305	16	0	\N
74401	1397	1408056939000	4511	2305	17	0	\N
74402	1397	1408046938000	4511	2305	18	0	\N
74403	1397	1408036937000	4511	2305	19	0	\N
74404	1397	1408026936000	4511	2305	20	0	\N
74405	1397	1408016935000	4511	2305	21	0	\N
74406	1397	1408006934000	4511	2305	22	0	\N
74407	1397	1407996933000	4511	2305	23	0	\N
74408	1397	1407986932000	4511	2305	24	0	\N
74409	1397	1407976931000	4511	2305	25	0	\N
74410	1397	1407966930000	4511	2305	26	0	\N
74411	1397	1407956929000	4511	2305	27	0	\N
74412	1397	1407946928000	4511	2305	28	0	\N
74413	1397	1407936927000	4511	2305	29	0	\N
74414	1397	1407926926000	4511	2305	30	0	\N
74415	1397	1407916925000	4511	2305	31	0	\N
74416	1397	1407906924000	4511	2305	32	0	\N
74417	1397	1407896923000	4511	2305	33	0	\N
74418	1397	1407886922000	4511	2305	34	0	\N
74419	1397	1407876921000	4511	2305	35	0	\N
74420	1397	1407866920000	4511	2305	36	0	\N
74421	1397	1407856919000	4511	2305	37	0	\N
74422	1397	1407846918000	4511	2305	38	0	\N
74423	1397	1407836917000	4511	2305	39	0	\N
74424	1397	1407826916000	4511	2305	40	0	\N
74425	1397	1407816915000	4511	2305	41	0	\N
74426	1397	1407806914000	4511	2305	42	0	\N
74427	1397	1407796913000	4511	2305	43	0	\N
74428	1397	1407786912000	4511	2305	44	0	\N
74429	1397	1407776911000	4511	2305	45	0	\N
74430	1397	1407766910000	4511	2305	46	0	\N
74431	1397	1407756909000	4511	2305	47	0	\N
74432	1397	1407746908000	4511	2305	48	0	\N
74433	1397	1407736907000	4511	2305	49	0	\N
74434	1397	1407726906000	4511	2305	50	0	\N
74435	1397	1407716905000	4511	2305	51	0	\N
74436	1397	1407706904000	4511	2305	52	0	\N
74437	1800	198000000	4511	2305	53	0	\N
74440	1397	1407696903000	4513	2334	0	0	\N
74441	1397	1407686902000	4513	2334	1	0	\N
74443	1397	1407666900000	4515	2336	0	0	\N
74444	1397	1407666900000	4516	2336	0	0	\N
74445	1397	1407666900000	4517	2336	0	0	\N
74451	1397	1407616895000	4522	2340	0	0	\N
74454	1397	1407606894000	4525	2341	0	0	\N
74455	1397	1407596893000	4526	2342	0	0	\N
74457	1397	1407586892000	4528	2343	0	0	\N
74458	1397	1407586892000	4529	2343	0	0	\N
74460	1397	1407576891000	4531	2344	0	0	\N
74462	1397	1407696903000	4533	2306	0	0	\N
74463	1397	1407686902000	4533	2306	1	0	\N
74464	1397	1407676901000	4533	2306	2	0	\N
74465	1397	1407666900000	4533	2306	3	0	\N
74466	1397	1407656899000	4533	2306	4	0	\N
74467	1397	1407646898000	4533	2306	6	0	\N
74468	1397	1407636897000	4533	2306	7	0	\N
74469	1397	1407626896000	4533	2306	8	0	\N
74470	1397	1407616895000	4533	2306	9	0	\N
74471	1397	1407606894000	4533	2306	10	0	\N
74472	1397	1407596893000	4533	2306	11	0	\N
74473	1397	1407586892000	4533	2306	12	0	\N
74474	1397	1407576891000	4533	2306	13	0	\N
74476	1397	1407566890000	4535	2345	0	0	\N
74477	1397	1407556889000	4536	2346	0	0	\N
74478	1397	1407556889000	4537	2346	0	0	\N
74483	1397	1407526886000	4542	2349	0	0	\N
74493	1397	1407446878000	4549	2355	0	0	\N
74509	1726	954600000000	4555	2356	0	0	\N
74510	1726	953300000000	4555	2356	1	0	\N
74511	1726	952000000000	4555	2356	2	0	\N
74512	1726	950700000000	4555	2356	3	0	\N
74513	1726	949400000000	4555	2356	4	0	\N
74514	1726	948100000000	4555	2356	6	0	\N
74515	1726	946800000000	4555	2356	7	0	\N
74516	1726	945500000000	4555	2356	8	0	\N
74517	1726	944200000000	4555	2356	9	0	\N
74518	1726	942900000000	4555	2356	10	0	\N
74519	1726	941600000000	4555	2356	11	0	\N
74520	1397	1407436877000	4555	2356	12	0	\N
74521	1397	1407426876000	4555	2356	13	0	\N
74522	1397	1407416875000	4555	2356	14	0	\N
74523	1397	1407406874000	4558	2357	0	0	\N
74524	1397	1407406874000	4559	2357	0	0	\N
74525	1726	954600000000	4560	2356	0	0	\N
74526	1726	953300000000	4560	2356	1	0	\N
74527	1726	952000000000	4560	2356	2	0	\N
74528	1726	950700000000	4560	2356	3	0	\N
74442	1397	1407676901000	4514	2335	0	0	3116
74446	1397	1407666900000	4518	2336	0	0	3117
74447	1397	1407656899000	4519	2337	0	0	3118
74448	1397	1407646898000	4519	2337	1	0	3119
74449	1397	1407636897000	4520	2338	0	0	3120
74452	1397	1407616895000	4523	2340	0	0	3122
74453	1397	1407606894000	4524	2341	0	0	3123
74456	1397	1407596893000	4527	2342	0	0	3124
74459	1397	1407586892000	4530	2343	0	0	3125
74461	1397	1407576891000	4532	2344	0	0	3126
74479	1397	1407556889000	4538	2346	0	0	3128
74480	1397	1407546888000	4539	2347	0	0	3129
74481	1397	1407536887000	4540	2348	0	0	3130
74482	1397	1407526886000	4541	2349	0	0	3131
74485	1397	1407506884000	4543	2350	1	0	3133
74486	1590	4600000000	4544	2351	0	0	3
74487	1397	1407496883000	4544	2351	1	0	3134
74488	1397	1407486882000	4545	2352	0	0	3135
74489	1397	1407476881000	4545	2352	1	0	3136
74491	1590	3500000000	4548	2354	0	0	4
74492	1397	1407456879000	4548	2354	1	0	3138
74494	1397	1407446878000	4550	2355	0	0	3139
74495	1726	954600000000	4553	2356	0	0	35
74496	1726	953300000000	4553	2356	1	0	36
74498	1726	950700000000	4553	2356	3	0	38
74499	1726	949400000000	4553	2356	4	0	39
74500	1726	948100000000	4553	2356	6	0	40
74501	1726	946800000000	4553	2356	7	0	41
74503	1726	944200000000	4553	2356	9	0	43
74504	1726	942900000000	4553	2356	10	0	44
74505	1726	941600000000	4553	2356	11	0	45
74506	1397	1407436877000	4553	2356	12	0	3140
74507	1397	1407426876000	4553	2356	13	0	3141
74529	1726	949400000000	4560	2356	4	0	\N
74530	1726	948100000000	4560	2356	6	0	\N
74531	1726	946800000000	4560	2356	7	0	\N
74532	1726	945500000000	4560	2356	8	0	\N
74533	1726	944200000000	4560	2356	9	0	\N
74534	1726	942900000000	4560	2356	10	0	\N
74535	1726	941600000000	4560	2356	11	0	\N
74536	1397	1407436877000	4560	2356	12	0	\N
74537	1397	1407426876000	4560	2356	13	0	\N
74538	1397	1407416875000	4560	2356	14	0	\N
74539	1726	954600000000	4561	2356	0	0	\N
74540	1726	953300000000	4561	2356	1	0	\N
74541	1726	952000000000	4561	2356	2	0	\N
74542	1726	950700000000	4561	2356	3	0	\N
74543	1726	949400000000	4561	2356	4	0	\N
74544	1726	948100000000	4561	2356	6	0	\N
74545	1726	946800000000	4561	2356	7	0	\N
74546	1726	945500000000	4561	2356	8	0	\N
74547	1726	944200000000	4561	2356	9	0	\N
74548	1726	942900000000	4561	2356	10	0	\N
74549	1726	941600000000	4561	2356	11	0	\N
74550	1397	1407436877000	4561	2356	12	0	\N
74551	1397	1407426876000	4561	2356	13	0	\N
74552	1397	1407416875000	4561	2356	14	0	\N
74557	636	66000000000000	4565	2361	0	0	\N
74558	1726	940300000000	4565	2361	1	0	\N
74559	1397	1407366870000	4565	2361	2	0	\N
74565	1397	1407346868000	4569	2363	0	0	\N
74567	636	66000000000000	4571	2260	0	0	\N
74568	1726	974100000000	4571	2260	1	0	\N
74569	1726	972800000000	4571	2260	2	0	\N
74570	1726	971500000000	4571	2260	3	0	\N
74571	1726	970200000000	4571	2260	4	0	\N
74572	1726	968900000000	4571	2260	5	0	\N
74573	1726	967600000000	4571	2260	6	0	\N
74574	1726	966300000000	4571	2260	7	0	\N
74575	1726	965000000000	4571	2260	8	0	\N
74576	1726	963700000000	4571	2260	9	0	\N
74577	1726	962400000000	4571	2260	10	0	\N
74578	1726	961100000000	4571	2260	11	0	\N
74579	1726	959800000000	4571	2260	12	0	\N
74580	1726	958500000000	4571	2260	13	0	\N
74581	1726	957200000000	4571	2260	14	0	\N
74582	1726	955900000000	4571	2260	15	0	\N
74583	1726	954600000000	4571	2260	16	0	\N
74584	1726	953300000000	4571	2260	17	0	\N
74585	1726	952000000000	4571	2260	18	0	\N
74586	1726	950700000000	4571	2260	19	0	\N
74587	1726	949400000000	4571	2260	20	0	\N
74588	1726	948100000000	4571	2260	21	0	\N
74589	1726	946800000000	4571	2260	22	0	\N
74590	1726	945500000000	4571	2260	23	0	\N
74591	1726	944200000000	4571	2260	24	0	\N
74592	1726	942900000000	4571	2260	25	0	\N
74593	1726	941600000000	4571	2260	26	0	\N
74594	1726	940300000000	4571	2260	27	0	\N
74595	1590	4600000000	4571	2260	28	0	\N
74596	1590	3500000000	4571	2260	29	0	\N
74597	1693	12200337731495	4571	2260	30	0	\N
74598	1693	12198316526375	4571	2260	31	0	\N
74599	1693	12131936756993	4571	2260	32	0	\N
74600	1801	719020000000	4571	2260	33	0	\N
74601	1397	1408656999000	4571	2260	34	0	\N
74602	1397	1408646998000	4571	2260	35	0	\N
74603	1769	2960900000	4571	2260	36	0	\N
74604	1769	2950900000	4571	2260	37	0	\N
74605	1601	11520251000000	4571	2260	38	0	\N
74606	1601	8393676900000	4571	2260	39	0	\N
74607	1601	6730862800000	4571	2260	40	0	\N
74608	1601	5609092700000	4571	2260	41	0	\N
74609	1601	4680894600000	4571	2260	42	0	\N
74610	1693	12065556987611	4571	2260	43	0	\N
74611	1693	11999177218229	4571	2260	44	0	\N
74612	1693	11932797448847	4571	2260	45	0	\N
74613	1693	11728596663372	4571	2260	46	0	\N
74614	1693	11662216893990	4571	2260	47	0	\N
74615	1693	11595837124608	4571	2260	48	0	\N
74616	1693	11593815919488	4571	2260	49	0	\N
74617	1693	11527436150106	4571	2260	50	0	\N
74618	1693	11461056380724	4571	2260	51	0	\N
74619	1693	10555037196324	4571	2260	52	0	\N
74620	1693	10488657426942	4571	2260	53	0	\N
74621	1693	10422277657560	4571	2260	54	0	\N
74622	1693	10355897888178	4571	2260	55	0	\N
74623	1693	10289518118796	4571	2260	56	0	\N
74624	1693	9980966206435	4571	2260	57	0	\N
74625	1693	9914586437053	4571	2260	58	0	\N
74626	1693	9848206667671	4571	2260	59	0	\N
74627	1693	9841462147296	4571	2260	60	0	\N
74628	1693	9775082377914	4571	2260	61	0	\N
74629	1693	9708702608532	4571	2260	62	0	\N
74630	1693	9642322839150	4571	2260	63	0	\N
74631	1693	9575943069768	4571	2260	64	0	\N
74632	1693	9509563300386	4571	2260	65	0	\N
74633	1693	9443183531004	4571	2260	66	0	\N
74634	1693	9376803761622	4571	2260	67	0	\N
74635	1693	9310423992240	4571	2260	68	0	\N
74636	1693	9244044222858	4571	2260	69	0	\N
74637	1693	9177664453476	4571	2260	70	0	\N
74638	1693	9111284684094	4571	2260	71	0	\N
74639	1693	8605686784398	4571	2260	72	0	\N
74640	1693	8539307015016	4571	2260	73	0	\N
74641	1693	8532257797056	4571	2260	74	0	\N
74642	1693	8465878027674	4571	2260	75	0	\N
74643	1693	8399498258292	4571	2260	76	0	\N
74644	1693	8333118488910	4571	2260	77	0	\N
74645	1693	8266738719528	4571	2260	78	0	\N
74646	1693	8200358950146	4571	2260	79	0	\N
74647	1693	8133979180764	4571	2260	80	0	\N
74648	1693	8067599411382	4571	2260	81	0	\N
74649	1693	8001219642000	4571	2260	82	0	\N
74650	1693	7934839872618	4571	2260	83	0	\N
74651	1693	7868460103236	4571	2260	84	0	\N
74652	1693	7802080333854	4571	2260	85	0	\N
74653	1693	7797042321028	4571	2260	87	0	\N
74654	1693	7730662551646	4571	2260	88	0	\N
74655	1693	7728641346526	4571	2260	89	0	\N
74656	1693	7662261577144	4571	2260	90	0	\N
74657	1693	7595881807762	4571	2260	91	0	\N
74658	1693	7529502038380	4571	2260	92	0	\N
74659	1693	7463122268998	4571	2260	93	0	\N
74660	1693	7396742499616	4571	2260	94	0	\N
74661	1693	7330362730234	4571	2260	95	0	\N
74662	1693	7263982960852	4571	2260	96	0	\N
74663	1693	7197603191470	4571	2260	97	0	\N
74664	1693	7131223422088	4571	2260	98	0	\N
74555	1397	1407386872000	4564	2360	0	0	3145
74556	1397	1407376871000	4564	2360	1	0	3146
74560	636	66000000000000	4566	2361	0	0	1
74561	1397	1407366870000	4566	2361	1	0	3147
74562	1726	940300000000	4567	2362	0	0	46
74564	1397	1407346868000	4568	2363	0	0	3149
74566	1397	1407336867000	4570	2364	0	0	3150
74665	1693	7064843652706	4571	2260	99	0	\N
74666	1693	6998463883324	4571	2260	100	0	\N
74667	1693	6932759878873	4571	2260	101	0	\N
74668	1693	6866380109491	4571	2260	102	0	\N
74669	1693	6800000340109	4571	2260	103	0	\N
74670	1693	6733620570727	4571	2260	104	0	\N
74671	1693	6667240801345	4571	2260	105	0	\N
74672	1693	6657174775693	4571	2260	106	0	\N
74673	1693	6590795006311	4571	2260	107	0	\N
74674	1693	5979482556087	4571	2260	108	0	\N
74675	1693	5913102786705	4571	2260	109	0	\N
74676	1693	5846723017323	4571	2260	110	0	\N
74677	1693	5780343247941	4571	2260	111	0	\N
74678	1693	5713963478559	4571	2260	112	0	\N
74679	1693	5647583709177	4571	2260	113	0	\N
74680	1693	5614833300833	4571	2260	114	0	\N
74681	1693	5548453531451	4571	2260	115	0	\N
74682	1693	5482073762069	4571	2260	116	0	\N
74683	1693	3778615130549	4571	2260	117	0	\N
74684	1693	3712235361167	4571	2260	118	0	\N
74685	1693	3645855591785	4571	2260	119	0	\N
74686	1693	3337303679424	4571	2260	120	0	\N
74687	1693	3270923910042	4571	2260	121	0	\N
74688	1693	3204544140660	4571	2260	122	0	\N
74689	1693	3138164371278	4571	2260	123	0	\N
74690	1693	3071784601896	4571	2260	124	0	\N
74691	1693	3005404832514	4571	2260	125	0	\N
74697	1397	1407296863000	4575	2367	0	0	\N
74698	1397	1407286862000	4576	2368	0	0	\N
74699	1397	1407276861000	4576	2368	1	0	\N
74702	1397	1407266860000	4578	2369	0	0	\N
74704	1397	1407256859000	4580	2370	0	0	\N
74705	1397	1407256859000	4581	2370	0	0	\N
74706	1397	1407256859000	4582	2370	0	0	\N
74714	1726	937700000000	4586	2372	0	0	\N
74715	1397	1407236857000	4586	2372	1	0	\N
74716	1397	1407226856000	4586	2372	2	0	\N
74717	1397	1407216855000	4586	2372	3	0	\N
74718	1397	1407206854000	4586	2372	4	0	\N
74719	1726	937700000000	4587	2372	0	0	\N
74720	1397	1407236857000	4587	2372	1	0	\N
74721	1397	1407226856000	4587	2372	2	0	\N
74722	1397	1407216855000	4587	2372	3	0	\N
74723	1397	1407206854000	4587	2372	4	0	\N
74724	1726	937700000000	4588	2372	0	0	\N
74725	1397	1407236857000	4588	2372	1	0	\N
74726	1397	1407226856000	4588	2372	2	0	\N
74727	1397	1407216855000	4588	2372	3	0	\N
74728	1397	1407206854000	4588	2372	4	0	\N
74729	636	66000000000000	4589	2323	0	0	\N
74730	1726	955900000000	4589	2323	1	0	\N
74731	1726	954600000000	4589	2323	2	0	\N
74732	1726	953300000000	4589	2323	3	0	\N
74733	1726	952000000000	4589	2323	4	0	\N
74734	1726	950700000000	4589	2323	5	0	\N
74735	1726	949400000000	4589	2323	6	0	\N
74736	1726	948100000000	4589	2323	7	0	\N
74737	1726	946800000000	4589	2323	8	0	\N
74738	1726	945500000000	4589	2323	9	0	\N
74739	1726	944200000000	4589	2323	10	0	\N
74740	1726	942900000000	4589	2323	11	0	\N
74741	1726	941600000000	4589	2323	12	0	\N
74742	1726	940300000000	4589	2323	13	0	\N
74743	1726	939000000000	4589	2323	14	0	\N
74744	1726	937700000000	4589	2323	15	0	\N
74745	1590	4600000000	4589	2323	16	0	\N
74746	1590	3500000000	4589	2323	17	0	\N
74747	37	65329909092470	4589	2323	18	0	\N
74748	1397	1407846918000	4589	2323	19	0	\N
74749	1397	1407836917000	4589	2323	20	0	\N
74750	1397	1407826916000	4589	2323	21	0	\N
74751	41	66000471816426	4589	2323	22	0	\N
74752	739	10000244820647	4589	2323	23	0	\N
74753	6	32558703045112	4589	2323	24	0	\N
74754	1397	1407816915000	4589	2323	25	0	\N
74755	1397	1407806914000	4589	2323	26	0	\N
74756	1397	1407796913000	4589	2323	27	0	\N
74757	1397	1407786912000	4589	2323	28	0	\N
74758	1397	1407776911000	4589	2323	29	0	\N
74759	1397	1407766910000	4589	2323	30	0	\N
74760	1397	1407756909000	4589	2323	31	0	\N
74761	1397	1407746908000	4589	2323	32	0	\N
74762	1397	1407736907000	4589	2323	33	0	\N
74763	1397	1407726906000	4589	2323	34	0	\N
74764	1397	1407716905000	4589	2323	35	0	\N
74765	1397	1407706904000	4589	2323	36	0	\N
74766	1397	1407696903000	4589	2323	37	0	\N
74767	1397	1407686902000	4589	2323	38	0	\N
74768	1397	1407676901000	4589	2323	39	0	\N
74769	1397	1407666900000	4589	2323	40	0	\N
74770	1397	1407656899000	4589	2323	41	0	\N
74771	1397	1407646898000	4589	2323	42	0	\N
74772	1397	1407636897000	4589	2323	43	0	\N
74773	1397	1407626896000	4589	2323	44	0	\N
74774	1397	1407616895000	4589	2323	45	0	\N
74775	1397	1407606894000	4589	2323	46	0	\N
74776	1397	1407596893000	4589	2323	47	0	\N
74777	1397	1407586892000	4589	2323	48	0	\N
74778	1397	1407576891000	4589	2323	49	0	\N
74779	1397	1407566890000	4589	2323	50	0	\N
74780	1397	1407556889000	4589	2323	51	0	\N
74781	1397	1407546888000	4589	2323	52	0	\N
74782	1397	1407536887000	4589	2323	53	0	\N
74783	1397	1407526886000	4589	2323	54	0	\N
74784	1397	1407516885000	4589	2323	55	0	\N
74785	1397	1407506884000	4589	2323	56	0	\N
74786	1397	1407496883000	4589	2323	57	0	\N
74787	1397	1407486882000	4589	2323	58	0	\N
74788	1397	1407476881000	4589	2323	59	0	\N
74789	1397	1407466880000	4589	2323	60	0	\N
74790	1397	1407456879000	4589	2323	61	0	\N
74791	1397	1407446878000	4589	2323	62	0	\N
74792	1397	1407436877000	4589	2323	63	0	\N
74793	1397	1407426876000	4589	2323	64	0	\N
74794	1397	1407416875000	4589	2323	65	0	\N
74795	1397	1407406874000	4589	2323	66	0	\N
74796	1397	1407396873000	4589	2323	67	0	\N
74797	1397	1407386872000	4589	2323	68	0	\N
74798	1397	1407376871000	4589	2323	69	0	\N
74799	1397	1407366870000	4589	2323	70	0	\N
74800	1397	1407356869000	4589	2323	71	0	\N
74694	1726	939000000000	4573	2366	0	0	47
74695	1397	1407306864000	4573	2366	1	0	3153
74696	1397	1407296863000	4574	2367	0	0	3154
74700	1397	1407286862000	4577	2368	0	0	3155
74701	1397	1407276861000	4577	2368	1	0	3156
74707	1397	1407256859000	4583	2370	0	0	3158
74708	1397	1407246858000	4584	2371	0	0	3159
74709	1726	937700000000	4585	2372	0	0	48
74710	1397	1407236857000	4585	2372	1	0	3160
74711	1397	1407226856000	4585	2372	2	0	3161
74713	1397	1407206854000	4585	2372	4	0	3163
74801	1397	1407346868000	4589	2323	72	0	\N
74802	1397	1407336867000	4589	2323	73	0	\N
74803	1397	1407326866000	4589	2323	74	0	\N
74804	1397	1407316865000	4589	2323	75	0	\N
74805	1397	1407306864000	4589	2323	76	0	\N
74806	1397	1407296863000	4589	2323	77	0	\N
74807	1397	1407286862000	4589	2323	78	0	\N
74808	1397	1407276861000	4589	2323	79	0	\N
74809	1397	1407266860000	4589	2323	80	0	\N
74810	1397	1407256859000	4589	2323	81	0	\N
74811	1397	1407246858000	4589	2323	82	0	\N
74812	1397	1407236857000	4589	2323	83	0	\N
74813	1397	1407226856000	4589	2323	84	0	\N
74814	1397	1407216855000	4589	2323	85	0	\N
74815	1397	1407206854000	4589	2323	86	0	\N
74816	5	6697563753375	4589	2323	87	0	\N
74821	636	66000000000000	4591	2194	0	0	\N
74822	1726	957200000000	4591	2194	1	0	\N
74823	1726	955900000000	4591	2194	2	0	\N
74824	1726	954600000000	4591	2194	3	0	\N
74825	1726	953300000000	4591	2194	4	0	\N
74826	1726	952000000000	4591	2194	5	0	\N
74827	1726	950700000000	4591	2194	6	0	\N
74828	1726	949400000000	4591	2194	7	0	\N
74829	1726	948100000000	4591	2194	8	0	\N
74830	1726	946800000000	4591	2194	9	0	\N
74831	1726	945500000000	4591	2194	10	0	\N
74832	1726	944200000000	4591	2194	11	0	\N
74833	1726	942900000000	4591	2194	12	0	\N
74834	1726	941600000000	4591	2194	13	0	\N
74835	1726	940300000000	4591	2194	14	0	\N
74836	1726	939000000000	4591	2194	15	0	\N
74837	1726	937700000000	4591	2194	16	0	\N
74838	1590	4600000000	4591	2194	17	0	\N
74839	1590	3500000000	4591	2194	18	0	\N
74840	37	65329909092470	4591	2194	19	0	\N
74841	739	10000244820647	4591	2194	20	0	\N
74842	6	32558703045112	4591	2194	21	0	\N
74843	5	6697563753375	4591	2194	22	0	\N
74844	1769	2949900000	4591	2194	23	0	\N
74845	1769	2948900000	4591	2194	24	0	\N
74846	1769	2947900000	4591	2194	25	0	\N
74852	1397	1407116845000	4595	2377	0	0	\N
74853	748	2002390000000	4595	2377	1	0	\N
74854	1397	1407106844000	4595	2377	2	0	\N
74866	1397	1407026836000	4603	2382	0	0	\N
74867	1397	1407016835000	4604	2383	0	0	\N
74869	1397	1407006834000	4606	2384	0	0	\N
74875	1397	1406956829000	4611	2388	0	0	\N
74876	1397	1406956829000	4612	2388	0	0	\N
74881	1803	100000000	4616	2390	0	0	\N
74882	1397	1406946828000	4616	2390	1	0	\N
74883	1397	1406936827000	4616	2390	2	0	\N
74884	636	66000000000000	4617	2284	0	0	\N
74885	1803	100000000	4617	2284	1	0	\N
74886	1726	965000000000	4617	2284	2	0	\N
74887	1726	963700000000	4617	2284	3	0	\N
74888	1726	962400000000	4617	2284	4	0	\N
74889	1726	961100000000	4617	2284	5	0	\N
74890	1726	959800000000	4617	2284	6	0	\N
74891	1726	958500000000	4617	2284	7	0	\N
74892	1726	957200000000	4617	2284	8	0	\N
74893	1726	955900000000	4617	2284	9	0	\N
74894	1726	954600000000	4617	2284	10	0	\N
74895	1726	953300000000	4617	2284	11	0	\N
74896	1726	952000000000	4617	2284	12	0	\N
74897	1726	950700000000	4617	2284	13	0	\N
74898	1726	949400000000	4617	2284	14	0	\N
74899	1726	948100000000	4617	2284	15	0	\N
74900	1726	946800000000	4617	2284	16	0	\N
74901	1726	945500000000	4617	2284	17	0	\N
74902	1726	944200000000	4617	2284	18	0	\N
74903	1726	942900000000	4617	2284	19	0	\N
74904	1726	941600000000	4617	2284	20	0	\N
74905	1726	940300000000	4617	2284	21	0	\N
74906	1726	939000000000	4617	2284	22	0	\N
74907	1726	937700000000	4617	2284	23	0	\N
74908	1590	4600000000	4617	2284	24	0	\N
74909	1590	3500000000	4617	2284	25	0	\N
74910	1397	1408196953000	4617	2284	26	0	\N
74911	1397	1408186952000	4617	2284	27	0	\N
74912	1801	719020000000	4617	2284	28	0	\N
74913	1397	1408176951000	4617	2284	29	0	\N
74914	1397	1408166950000	4617	2284	30	0	\N
74915	1397	1408156949000	4617	2284	31	0	\N
74916	1397	1408146948000	4617	2284	32	0	\N
74917	1397	1408136947000	4617	2284	33	0	\N
74918	1397	1408126946000	4617	2284	34	0	\N
74919	1397	1408116945000	4617	2284	35	0	\N
74920	1397	1408106944000	4617	2284	36	0	\N
74921	1397	1408096943000	4617	2284	37	0	\N
74922	1397	1408086942000	4617	2284	38	0	\N
74923	1397	1408076941000	4617	2284	39	0	\N
74924	5	6697563753375	4617	2284	40	0	\N
74925	1397	1408066940000	4617	2284	41	0	\N
74926	1397	1408056939000	4617	2284	42	0	\N
74927	1397	1408046938000	4617	2284	43	0	\N
74928	1397	1408036937000	4617	2284	44	0	\N
74929	1397	1408026936000	4617	2284	45	0	\N
74930	1397	1408016935000	4617	2284	46	0	\N
74931	1397	1408006934000	4617	2284	47	0	\N
74932	1397	1407996933000	4617	2284	48	0	\N
74933	1397	1407986932000	4617	2284	49	0	\N
74934	1397	1407976931000	4617	2284	50	0	\N
74935	1397	1407966930000	4617	2284	51	0	\N
74936	1397	1407956929000	4617	2284	52	0	\N
74819	1397	1407176851000	4590	2373	2	0	3166
74820	1397	1407166850000	4590	2373	3	0	3167
74847	1397	1407156849000	4592	2374	0	0	3168
74848	1397	1407146848000	4593	2375	0	0	3169
74849	1397	1407136847000	4593	2375	1	0	3170
74851	1397	1407126846000	4594	2376	1	0	3171
74855	1397	1407116845000	4596	2377	0	0	3172
74856	748	2002390000000	4596	2377	1	0	1
74857	1397	1407106844000	4596	2377	2	0	3173
74858	1397	1407096843000	4598	2378	0	0	3174
74860	1397	1407076841000	4599	2379	1	0	3176
74861	1397	1407066840000	4599	2379	2	0	3177
74862	1397	1407056839000	4600	2380	0	0	3178
74863	1397	1407046838000	4601	2381	0	0	3179
74865	1397	1407026836000	4602	2382	0	0	3181
74868	1397	1407016835000	4605	2383	0	0	3182
74870	1397	1407006834000	4607	2384	0	0	3183
74871	1397	1406996833000	4608	2385	0	0	3184
74872	1397	1406986832000	4609	2386	0	0	3185
74874	1397	1406966830000	4610	2387	0	0	3187
74877	1397	1406956829000	4613	2388	0	0	3188
74878	1803	100000000	4615	2390	0	0	1
74879	1397	1406946828000	4615	2390	1	0	3189
74880	1397	1406936827000	4615	2390	2	0	3190
74937	1397	1407946928000	4617	2284	54	0	\N
74938	1397	1407936927000	4617	2284	55	0	\N
74939	1397	1407926926000	4617	2284	56	0	\N
74940	1397	1407916925000	4617	2284	57	0	\N
74941	1397	1407906924000	4617	2284	58	0	\N
74942	1397	1407896923000	4617	2284	59	0	\N
74943	1397	1407886922000	4617	2284	60	0	\N
74944	1397	1407876921000	4617	2284	61	0	\N
74945	1397	1407866920000	4617	2284	62	0	\N
74946	1397	1407856919000	4617	2284	63	0	\N
74947	1397	1407846918000	4617	2284	64	0	\N
74948	1397	1407836917000	4617	2284	65	0	\N
74949	1397	1407826916000	4617	2284	66	0	\N
74950	1397	1407816915000	4617	2284	67	0	\N
74951	1397	1407806914000	4617	2284	68	0	\N
74952	1397	1407796913000	4617	2284	69	0	\N
74953	1397	1407786912000	4617	2284	70	0	\N
74954	1397	1407776911000	4617	2284	71	0	\N
74955	1397	1407766910000	4617	2284	72	0	\N
74956	1397	1407756909000	4617	2284	73	0	\N
74957	1397	1407746908000	4617	2284	74	0	\N
74958	1397	1407736907000	4617	2284	75	0	\N
74959	1397	1407726906000	4617	2284	76	0	\N
74960	1397	1407716905000	4617	2284	77	0	\N
74961	1397	1407706904000	4617	2284	78	0	\N
74962	1397	1407696903000	4617	2284	79	0	\N
74963	1397	1407686902000	4617	2284	80	0	\N
74964	1397	1407676901000	4617	2284	81	0	\N
74965	1397	1407666900000	4617	2284	82	0	\N
74966	1397	1407656899000	4617	2284	83	0	\N
74967	1397	1407646898000	4617	2284	84	0	\N
74968	1397	1407636897000	4617	2284	85	0	\N
74969	1397	1407626896000	4617	2284	86	0	\N
74970	1397	1407616895000	4617	2284	87	0	\N
74971	1397	1407606894000	4617	2284	88	0	\N
74972	1397	1407596893000	4617	2284	89	0	\N
74973	1397	1407586892000	4617	2284	90	0	\N
74974	1397	1407576891000	4617	2284	91	0	\N
74975	1397	1407566890000	4617	2284	92	0	\N
74976	1397	1407556889000	4617	2284	93	0	\N
74977	1397	1407546888000	4617	2284	94	0	\N
74978	1397	1407536887000	4617	2284	95	0	\N
74979	1397	1407526886000	4617	2284	96	0	\N
74980	1397	1407516885000	4617	2284	97	0	\N
74981	1397	1407506884000	4617	2284	98	0	\N
74983	1397	1406926826000	4619	2391	0	0	\N
74985	1397	1406916825000	4621	2392	0	0	\N
74986	1397	1406916825000	4622	2392	0	0	\N
74987	1397	1406906824000	4623	2393	0	0	\N
74988	1397	1406906824000	4624	2393	0	0	\N
74989	1397	1406906824000	4625	2393	0	0	\N
74991	1397	1406896823000	4627	2394	0	0	\N
74992	1397	1406886822000	4627	2394	1	0	\N
74993	1397	1406876821000	4627	2394	2	0	\N
74998	1397	1406856819000	4630	2396	0	0	\N
74999	1397	1406856819000	4631	2396	0	0	\N
75000	1397	1406856819000	4632	2396	0	0	\N
75003	1397	1406846818000	4635	2397	0	0	\N
75004	1397	1406846818000	4636	2397	0	0	\N
75008	1397	1406816815000	4639	2399	0	0	\N
75009	1397	1406816815000	4640	2399	0	0	\N
75010	1397	1406816815000	4641	2399	0	0	\N
75011	1397	1406806814000	4642	2400	0	0	\N
75012	636	66000000000000	4643	2329	0	0	\N
75013	1803	100000000	4643	2329	1	0	\N
75014	1726	954600000000	4643	2329	2	0	\N
75015	1726	953300000000	4643	2329	3	0	\N
75016	1726	952000000000	4643	2329	4	0	\N
75017	1726	950700000000	4643	2329	5	0	\N
75018	1726	949400000000	4643	2329	6	0	\N
75019	1726	948100000000	4643	2329	7	0	\N
75020	1726	946800000000	4643	2329	8	0	\N
75021	1726	945500000000	4643	2329	9	0	\N
75022	1726	944200000000	4643	2329	10	0	\N
75023	1726	942900000000	4643	2329	11	0	\N
75024	1726	941600000000	4643	2329	12	0	\N
75025	1726	940300000000	4643	2329	13	0	\N
75026	1726	939000000000	4643	2329	14	0	\N
75027	1726	937700000000	4643	2329	15	0	\N
75028	1590	4600000000	4643	2329	16	0	\N
75029	1590	3500000000	4643	2329	17	0	\N
75032	1397	1406796813000	4646	2401	0	0	\N
75033	1397	1406796813000	4647	2401	0	0	\N
75034	1397	1406796813000	4648	2401	0	0	\N
75035	1397	1406796813000	4649	2401	0	0	\N
75042	1397	1406746808000	4653	2404	0	0	\N
75043	1699	2769912500051	4653	2404	1	0	\N
75044	1397	1406746808000	4654	2404	0	0	\N
75045	1699	2769912500051	4654	2404	1	0	\N
75057	1397	1406696803000	4660	2409	0	0	\N
75059	1397	1406686802000	4662	2410	0	0	\N
75060	1397	1406686802000	4663	2410	0	0	\N
75063	1397	1406656799000	4666	2413	0	0	\N
75066	1397	1406646798000	4669	2414	0	0	\N
75069	281	66001000000000	4671	2415	0	0	\N
75070	1397	1406636797000	4671	2415	1	0	\N
75071	281	66001000000000	4672	2415	0	0	\N
75072	1397	1406636797000	4672	2415	1	0	\N
74990	1397	1406906824000	4626	2393	0	0	3193
74994	1397	1406896823000	4628	2394	0	0	3194
74995	1397	1406886822000	4628	2394	1	0	3195
74996	1397	1406876821000	4628	2394	2	0	3196
74997	1397	1406866820000	4629	2395	0	0	3197
75002	1397	1406846818000	4634	2397	0	0	3199
75005	1397	1406836817000	4637	2398	0	0	3200
75006	1397	1406826816000	4637	2398	1	0	3201
75007	1397	1406816815000	4638	2399	0	0	3202
75030	1397	1406806814000	4644	2400	0	0	3203
75036	1397	1406786812000	4650	2402	0	0	3205
75037	1397	1406776811000	4651	2403	0	0	3206
75038	1397	1406766810000	4651	2403	1	0	3207
75039	1397	1406756809000	4651	2403	2	0	3208
75041	1699	2769912500051	4652	2404	1	0	3
75046	1397	1406736807000	4655	2405	0	0	3210
75047	1773	2688739938804	4656	2406	0	0	7
75048	1773	2657164564680	4656	2406	1	0	8
75049	1773	2296638056796	4656	2406	2	0	9
75051	1773	1214677820088	4656	2406	4	0	11
75052	1773	0	4656	2406	5	0	12
75053	1397	1406726806000	4656	2406	6	0	3211
75054	1397	1406716805000	4657	2407	0	0	3212
75055	1397	1406706804000	4658	2408	0	0	3213
75058	1397	1406686802000	4661	2410	0	0	3215
75061	1397	1406676801000	4664	2411	0	0	3216
75062	1397	1406666800000	4665	2412	0	0	3217
75064	1397	1406656799000	4667	2413	0	0	3218
75067	281	66001000000000	4670	2415	0	0	1
75068	1397	1406636797000	4670	2415	1	0	3220
75074	636	66000000000000	4674	2325	0	0	\N
75075	1803	100000000	4674	2325	1	0	\N
75076	1726	955900000000	4674	2325	2	0	\N
75077	1726	954600000000	4674	2325	3	0	\N
75078	1726	953300000000	4674	2325	4	0	\N
75079	1726	952000000000	4674	2325	5	0	\N
75080	1726	950700000000	4674	2325	6	0	\N
75081	1726	949400000000	4674	2325	7	0	\N
75082	1726	948100000000	4674	2325	8	0	\N
75083	1726	946800000000	4674	2325	9	0	\N
75084	1726	945500000000	4674	2325	10	0	\N
75085	1726	944200000000	4674	2325	11	0	\N
75086	1726	942900000000	4674	2325	12	0	\N
75087	1726	941600000000	4674	2325	13	0	\N
75088	1726	940300000000	4674	2325	14	0	\N
75089	1726	939000000000	4674	2325	15	0	\N
75090	1726	937700000000	4674	2325	16	0	\N
75091	1590	4600000000	4674	2325	17	0	\N
75092	1590	3500000000	4674	2325	18	0	\N
75093	1397	1407826916000	4674	2325	19	0	\N
75094	37	65329909092470	4674	2325	20	0	\N
75095	1699	2769912500051	4674	2325	21	0	\N
75096	41	66000471816426	4674	2325	22	0	\N
75097	739	10000244820647	4674	2325	23	0	\N
75098	6	32558703045112	4674	2325	24	0	\N
75099	1397	1407816915000	4674	2325	25	0	\N
75100	1397	1407806914000	4674	2325	26	0	\N
75101	1397	1407796913000	4674	2325	27	0	\N
75102	1397	1407786912000	4674	2325	28	0	\N
75103	1397	1407776911000	4674	2325	29	0	\N
75104	1397	1407766910000	4674	2325	30	0	\N
75105	1397	1407756909000	4674	2325	31	0	\N
75106	1397	1407746908000	4674	2325	32	0	\N
75107	1397	1407736907000	4674	2325	33	0	\N
75108	1397	1407726906000	4674	2325	34	0	\N
75109	1397	1407716905000	4674	2325	35	0	\N
75110	1397	1407706904000	4674	2325	36	0	\N
75111	1397	1407696903000	4674	2325	37	0	\N
75112	1397	1407686902000	4674	2325	38	0	\N
75113	1397	1407676901000	4674	2325	39	0	\N
75114	1397	1407666900000	4674	2325	40	0	\N
75115	1397	1407656899000	4674	2325	41	0	\N
75116	1397	1407646898000	4674	2325	42	0	\N
75117	1397	1407636897000	4674	2325	43	0	\N
75118	1397	1407626896000	4674	2325	44	0	\N
75119	1397	1407616895000	4674	2325	45	0	\N
75120	1397	1407606894000	4674	2325	46	0	\N
75121	1397	1407596893000	4674	2325	47	0	\N
75122	1397	1407586892000	4674	2325	48	0	\N
75123	1397	1407576891000	4674	2325	49	0	\N
75124	1397	1407566890000	4674	2325	50	0	\N
75125	1397	1407556889000	4674	2325	51	0	\N
75126	1397	1407546888000	4674	2325	52	0	\N
75127	1397	1407536887000	4674	2325	53	0	\N
75128	1397	1407526886000	4674	2325	54	0	\N
75129	1397	1407516885000	4674	2325	55	0	\N
75130	1397	1407506884000	4674	2325	56	0	\N
75131	1397	1407496883000	4674	2325	57	0	\N
75132	1397	1407486882000	4674	2325	58	0	\N
75133	1397	1407476881000	4674	2325	59	0	\N
75134	1397	1407466880000	4674	2325	60	0	\N
75135	1397	1407456879000	4674	2325	61	0	\N
75136	1397	1407446878000	4674	2325	62	0	\N
75137	1397	1407436877000	4674	2325	63	0	\N
75138	1397	1407426876000	4674	2325	64	0	\N
75139	1397	1407416875000	4674	2325	65	0	\N
75140	1397	1407406874000	4674	2325	66	0	\N
75141	1397	1407396873000	4674	2325	67	0	\N
75142	1397	1407386872000	4674	2325	68	0	\N
75143	1397	1407376871000	4674	2325	69	0	\N
75144	1397	1407366870000	4674	2325	70	0	\N
75145	1397	1407356869000	4674	2325	71	0	\N
75146	1397	1407346868000	4674	2325	72	0	\N
75147	1397	1407336867000	4674	2325	73	0	\N
75148	1397	1407326866000	4674	2325	74	0	\N
75149	1397	1407316865000	4674	2325	75	0	\N
75150	1397	1407306864000	4674	2325	76	0	\N
75151	1397	1407296863000	4674	2325	77	0	\N
75152	1397	1407286862000	4674	2325	78	0	\N
75153	1397	1407276861000	4674	2325	79	0	\N
75154	1397	1407266860000	4674	2325	80	0	\N
75155	1397	1407256859000	4674	2325	81	0	\N
75156	1397	1407246858000	4674	2325	82	0	\N
75157	1397	1407236857000	4674	2325	83	0	\N
75158	1397	1407226856000	4674	2325	84	0	\N
75159	1397	1407216855000	4674	2325	85	0	\N
75160	1397	1407206854000	4674	2325	86	0	\N
75161	1397	1407196853000	4674	2325	87	0	\N
75162	1397	1407186852000	4674	2325	88	0	\N
75163	1397	1407176851000	4674	2325	89	0	\N
75164	1397	1407166850000	4674	2325	90	0	\N
75165	1397	1407156849000	4674	2325	91	0	\N
75166	1397	1407146848000	4674	2325	92	0	\N
75167	1397	1407136847000	4674	2325	93	0	\N
75168	1397	1407126846000	4674	2325	94	0	\N
75169	1397	1407116845000	4674	2325	95	0	\N
75170	1397	1407106844000	4674	2325	96	0	\N
75171	1397	1407096843000	4674	2325	97	0	\N
75172	1397	1407086842000	4674	2325	98	0	\N
75173	1397	1407076841000	4674	2325	99	0	\N
75174	1397	1407066840000	4674	2325	100	0	\N
75175	1397	1407056839000	4674	2325	101	0	\N
75176	1397	1407046838000	4674	2325	102	0	\N
75177	1397	1407036837000	4674	2325	103	0	\N
75178	1397	1407026836000	4674	2325	104	0	\N
75179	1397	1407016835000	4674	2325	105	0	\N
75180	1397	1407006834000	4674	2325	106	0	\N
75181	1397	1406996833000	4674	2325	107	0	\N
75182	5	6697563753375	4674	2325	108	0	\N
75183	1397	1406986832000	4674	2325	109	0	\N
75184	1397	1406976831000	4674	2325	110	0	\N
75185	1397	1406966830000	4674	2325	111	0	\N
75186	1397	1406956829000	4674	2325	112	0	\N
75187	1397	1406946828000	4674	2325	113	0	\N
75188	1397	1406936827000	4674	2325	115	0	\N
75189	1397	1406926826000	4674	2325	116	0	\N
75190	1397	1406916825000	4674	2325	117	0	\N
75191	1397	1406906824000	4674	2325	118	0	\N
75192	1397	1406896823000	4674	2325	119	0	\N
75193	1397	1406886822000	4674	2325	120	0	\N
75194	1397	1406876821000	4674	2325	121	0	\N
75195	1397	1406866820000	4674	2325	122	0	\N
75196	1397	1406856819000	4674	2325	123	0	\N
75197	1397	1406846818000	4674	2325	124	0	\N
75198	1397	1406836817000	4674	2325	125	0	\N
75200	1397	1406616795000	4676	2417	0	0	\N
75203	1397	1406606794000	4678	2418	0	0	\N
75204	1397	1406596793000	4678	2418	1	0	\N
75205	1397	1406586792000	4679	2419	0	0	\N
75206	1397	1406586792000	4680	2419	0	0	\N
75208	1397	1406576791000	4682	2420	0	0	\N
75201	1397	1406606794000	4677	2418	0	0	3223
75202	1397	1406596793000	4677	2418	1	0	3224
75207	1397	1406586792000	4681	2419	0	0	3225
75211	1397	1406556789000	4685	2422	0	0	\N
75215	1397	1406536787000	4689	2424	0	0	\N
75216	1397	1406566790000	4690	2421	0	0	\N
75217	1397	1406556789000	4690	2421	1	0	\N
75218	1397	1406546788000	4690	2421	2	0	\N
75219	1397	1406536787000	4690	2421	3	0	\N
75220	1397	1406526786000	4690	2421	4	0	\N
75223	1803	100000000	4693	2195	0	0	\N
75224	281	66001000000000	4693	2195	1	0	\N
75225	1699	2049902500051	4693	2195	2	0	\N
75226	354	66002390000000	4693	2195	3	0	\N
75227	748	2002390000000	4693	2195	4	0	\N
75232	1397	1406486782000	4698	2429	0	0	\N
75233	1397	1406476781000	4699	2430	0	0	\N
75235	1397	1406476781000	4701	2430	0	0	\N
75237	1397	1406466780000	4703	2431	0	0	\N
75238	1397	1406466780000	4704	2431	0	0	\N
75239	281	66001000000000	4705	2411	0	0	\N
75240	1397	1406676801000	4705	2411	1	0	\N
75241	1397	1406666800000	4705	2411	2	0	\N
75242	1397	1406656799000	4705	2411	3	0	\N
75243	1397	1406646798000	4705	2411	4	0	\N
75244	112	66152471816426	4705	2411	5	0	\N
75245	1397	1406636797000	4705	2411	6	0	\N
75246	1397	1406626796000	4705	2411	7	0	\N
75247	1397	1406616795000	4705	2411	8	0	\N
75248	1397	1406606794000	4705	2411	9	0	\N
75249	1397	1406596793000	4705	2411	10	0	\N
75250	1397	1406586792000	4705	2411	11	0	\N
75251	1397	1406576791000	4705	2411	12	0	\N
75252	1397	1406566790000	4705	2411	13	0	\N
75253	1397	1406556789000	4705	2411	14	0	\N
75254	1397	1406546788000	4705	2411	15	0	\N
75255	1397	1406536787000	4705	2411	16	0	\N
75256	1397	1406526786000	4705	2411	17	0	\N
75257	1397	1406516785000	4705	2411	18	0	\N
75258	1397	1406506784000	4705	2411	19	0	\N
75259	1397	1406496783000	4705	2411	20	0	\N
75260	1397	1406486782000	4705	2411	21	0	\N
75261	1397	1406476781000	4705	2411	22	0	\N
75262	1397	1406466780000	4705	2411	23	0	\N
75264	1397	1406456779000	4707	2432	0	0	\N
75270	1397	1406406774000	4712	2436	0	0	\N
75271	1397	1406396773000	4713	2437	0	0	\N
75273	1397	1406386772000	4715	2438	0	0	\N
75275	1397	1406376771000	4717	2439	0	0	\N
75283	1397	1406316765000	4723	2444	0	0	\N
75284	1397	1406306764000	4723	2444	1	0	\N
75285	1397	1406316765000	4724	2444	0	0	\N
75286	1397	1406306764000	4724	2444	1	0	\N
75289	1397	1406316765000	4726	2444	0	0	\N
75290	1397	1406306764000	4726	2444	1	0	\N
75291	1397	1406296763000	4727	2445	0	0	\N
75292	1693	3199111551364	4727	2445	1	0	\N
75293	1397	1406296763000	4728	2445	0	0	\N
75294	1693	3199111551364	4728	2445	1	0	\N
75297	1397	1406296763000	4730	2445	0	0	\N
75298	1693	3199111551364	4730	2445	1	0	\N
75302	1818	88890000	4732	2446	0	0	\N
75303	1397	1406286762000	4732	2446	1	0	\N
75304	1397	1406276761000	4732	2446	2	0	\N
75306	1397	1406266760000	4734	2447	0	0	\N
75307	1397	1406256759000	4735	2448	0	0	\N
75314	1397	1406206754000	4740	2452	0	0	\N
75315	1397	1406196753000	4740	2452	1	0	\N
75318	1397	1406386772000	4742	2438	0	0	\N
75319	1397	1406376771000	4742	2438	1	0	\N
75320	1397	1406366770000	4742	2438	2	0	\N
75321	1397	1406356769000	4742	2438	3	0	\N
75322	112	66002461816426	4742	2438	4	0	\N
75323	1397	1406346768000	4742	2438	5	0	\N
75324	1693	3199221551364	4742	2438	6	0	\N
75325	1693	3199111551364	4742	2438	7	0	\N
75326	1397	1406336767000	4742	2438	8	0	\N
75327	1397	1406326766000	4742	2438	9	0	\N
75328	1397	1406316765000	4742	2438	10	0	\N
75329	1397	1406306764000	4742	2438	11	0	\N
75330	1397	1406296763000	4742	2438	12	0	\N
75331	1397	1406286762000	4742	2438	13	0	\N
75332	1397	1406276761000	4742	2438	14	0	\N
75333	1397	1406266760000	4742	2438	15	0	\N
75334	1397	1406256759000	4742	2438	16	0	\N
75335	1397	1406246758000	4742	2438	17	0	\N
75336	1397	1406236757000	4742	2438	18	0	\N
75337	1397	1406226756000	4742	2438	19	0	\N
75338	1397	1406216755000	4742	2438	20	0	\N
75339	1397	1406206754000	4742	2438	21	0	\N
75340	1397	1406196753000	4742	2438	22	0	\N
75343	1397	1406186752000	4744	2453	0	0	\N
75344	1397	1406176751000	4744	2453	1	0	\N
75212	1397	1406556789000	4686	2422	0	0	3228
75213	1397	1406546788000	4687	2423	0	0	3229
75214	1397	1406536787000	4688	2424	0	0	3230
75221	1397	1406526786000	4691	2425	0	0	3231
75222	1397	1406516785000	4692	2426	0	0	3232
75229	1397	1406496783000	4696	2428	1	0	3234
75230	112	66152471816426	4696	2428	2	0	1
75231	1397	1406486782000	4697	2429	0	0	3235
75234	1397	1406476781000	4700	2430	0	0	3236
75236	1397	1406466780000	4702	2431	0	0	3237
75265	1397	1406446778000	4708	2433	0	0	3239
75266	1397	1406436777000	4709	2434	0	0	3240
75267	1397	1406426776000	4709	2434	1	0	3241
75268	1397	1406416775000	4710	2435	0	0	3242
75272	1397	1406396773000	4714	2437	0	0	3244
75274	1397	1406386772000	4716	2438	0	0	3245
75276	1397	1406376771000	4718	2439	0	0	3246
75277	1397	1406366770000	4718	2439	1	0	3247
75278	1397	1406356769000	4719	2440	0	0	3248
75280	1397	1406346768000	4720	2441	0	0	3249
75281	1397	1406336767000	4721	2442	0	0	3250
75282	1397	1406326766000	4722	2443	0	0	3251
75287	1397	1406316765000	4725	2444	0	0	3252
75288	1397	1406306764000	4725	2444	1	0	3253
75296	1693	3199111551364	4729	2445	1	0	345
75299	1818	88890000	4731	2446	0	0	1
75300	1397	1406286762000	4731	2446	1	0	3255
75301	1397	1406276761000	4731	2446	2	0	3256
75308	1397	1406256759000	4736	2448	0	0	3258
75309	1397	1406246758000	4737	2449	0	0	3259
75310	112	66002461816426	4737	2449	1	0	2
75311	1397	1406236757000	4738	2450	0	0	3260
75312	1397	1406226756000	4738	2450	1	0	3261
75316	1397	1406206754000	4741	2452	0	0	3263
75317	1397	1406196753000	4741	2452	1	0	3264
75341	1397	1406186752000	4743	2453	0	0	3265
75342	1397	1406176751000	4743	2453	1	0	3266
75345	1397	1406186752000	4746	2453	0	0	\N
75346	1397	1406176751000	4746	2453	1	0	\N
75350	1397	1406166750000	4748	2454	0	0	\N
75351	1397	1406156749000	4748	2454	1	0	\N
75352	1397	1406146748000	4748	2454	2	0	\N
75353	1397	1406166750000	4749	2454	0	0	\N
75354	1397	1406156749000	4749	2454	1	0	\N
75355	1397	1406146748000	4749	2454	2	0	\N
75357	1397	1406136747000	4751	2455	0	0	\N
75358	1397	1406136747000	4752	2455	0	0	\N
75360	1397	1406116745000	4754	2457	0	0	\N
75364	1821	149990000000	4757	2457	0	0	\N
75365	1821	149990000000	4758	2458	0	0	\N
75368	1397	1406076741000	4760	2460	0	0	\N
75369	1397	1406076741000	4761	2460	0	0	\N
75372	636	66000000000000	4764	2278	0	0	\N
75373	1803	100000000	4764	2278	1	0	\N
75374	1726	972800000000	4764	2278	2	0	\N
75375	1726	971500000000	4764	2278	3	0	\N
75376	1726	970200000000	4764	2278	4	0	\N
75377	1726	968900000000	4764	2278	5	0	\N
75378	1726	967600000000	4764	2278	6	0	\N
75379	1726	966300000000	4764	2278	7	0	\N
75380	1726	965000000000	4764	2278	8	0	\N
75381	1726	963700000000	4764	2278	9	0	\N
75382	1590	4600000000	4764	2278	10	0	\N
75383	1590	3500000000	4764	2278	11	0	\N
75384	1699	2049902500051	4764	2278	12	0	\N
75385	1601	6730862800000	4764	2278	13	0	\N
75386	1601	5609092700000	4764	2278	14	0	\N
75387	1397	1408446978000	4764	2278	15	0	\N
75388	1801	719020000000	4764	2278	16	0	\N
75389	1601	4680894600000	4764	2278	17	0	\N
75390	1693	11999177218229	4764	2278	18	0	\N
75391	1397	1408436977000	4764	2278	19	0	\N
75392	1397	1408426976000	4764	2278	21	0	\N
75393	1397	1408416975000	4764	2278	22	0	\N
75394	1397	1408406974000	4764	2278	23	0	\N
75395	1397	1408396973000	4764	2278	24	0	\N
75396	1397	1408386972000	4764	2278	25	0	\N
75397	1397	1408376971000	4764	2278	26	0	\N
75398	1397	1408366970000	4764	2278	27	0	\N
75399	1397	1408356969000	4764	2278	28	0	\N
75400	1397	1408346968000	4764	2278	29	0	\N
75401	1397	1406056739000	4765	2462	0	0	\N
75404	1397	1406036737000	4768	2464	0	0	\N
75406	1397	1406026736000	4770	2465	0	0	\N
75407	1397	1406016735000	4770	2465	1	0	\N
75408	1397	1406006734000	4770	2465	2	0	\N
75409	1397	1405996733000	4770	2465	3	0	\N
75417	1397	1405976731000	4775	2467	0	0	\N
75418	1397	1405966730000	4775	2467	1	0	\N
75419	1397	1405986732000	4776	2466	0	0	\N
75420	1397	1405976731000	4776	2466	1	0	\N
75421	1397	1405966730000	4776	2466	2	0	\N
75422	1397	1405956729000	4777	2468	0	0	\N
75425	1397	1405946728000	4780	2469	0	0	\N
75431	1397	1405886722000	4785	2474	0	0	\N
75434	1397	1405866720000	4788	2476	0	0	\N
75435	1397	1405856719000	4788	2476	1	0	\N
75440	1397	1405846718000	4791	2477	0	0	\N
75441	1397	1405836717000	4791	2477	1	0	\N
75447	1397	1405786712000	4797	2482	0	0	\N
75448	1726	936400000000	4798	2483	0	0	\N
75449	1726	935100000000	4798	2483	1	0	\N
75450	1726	933800000000	4798	2483	2	0	\N
75451	1726	932500000000	4798	2483	3	0	\N
75452	1726	931200000000	4798	2483	4	0	\N
75453	1726	929900000000	4798	2483	5	0	\N
75454	1397	1405776711000	4798	2483	6	0	\N
75463	1397	1405766710000	4801	2484	0	0	\N
75466	1397	1405746708000	4803	2486	0	0	\N
75468	1397	1405736707000	4805	2487	0	0	\N
75472	1397	1405706704000	4809	2490	0	0	\N
75474	1726	936400000000	4811	2395	0	0	\N
75475	1726	935100000000	4811	2395	1	0	\N
75476	1726	933800000000	4811	2395	2	0	\N
75477	1726	932500000000	4811	2395	3	0	\N
75478	281	66001000000000	4811	2395	4	0	\N
75479	1726	931200000000	4811	2395	5	0	\N
75480	1726	929900000000	4811	2395	6	0	\N
75349	1397	1406146748000	4747	2454	2	0	3269
75356	1397	1406136747000	4750	2455	0	0	3270
75359	1397	1406126746000	4753	2456	0	0	3271
75361	1397	1406116745000	4755	2457	0	0	3272
75362	1397	1406106744000	4756	2458	0	0	3273
75366	1397	1406096743000	4759	2459	0	0	3274
75367	1397	1406086742000	4759	2459	1	0	3275
75370	1397	1406076741000	4762	2460	0	0	3276
75371	1397	1406066740000	4763	2461	0	0	3277
75402	1397	1406056739000	4766	2462	0	0	3278
75405	1397	1406036737000	4769	2464	0	0	3280
75410	1397	1406026736000	4771	2465	0	0	3281
75411	1397	1406016735000	4771	2465	1	0	3282
75412	1397	1406006734000	4771	2465	2	0	3283
75414	1397	1405986732000	4772	2466	0	0	3285
75415	1397	1405976731000	4774	2467	0	0	3286
75416	1397	1405966730000	4774	2467	1	0	3287
75423	1397	1405956729000	4778	2468	0	0	3288
75424	1397	1405946728000	4779	2469	0	0	3289
75427	1397	1405926726000	4782	2471	0	0	3291
75428	1397	1405916725000	4783	2472	0	0	3292
75429	1397	1405906724000	4783	2472	1	0	3293
75430	1397	1405896723000	4784	2473	0	0	3294
75432	1397	1405886722000	4786	2474	0	0	3295
75436	1397	1405866720000	4789	2476	0	0	3297
75437	1397	1405856719000	4789	2476	1	0	3298
75438	1397	1405846718000	4790	2477	0	0	3299
75439	1397	1405836717000	4790	2477	1	0	3300
75443	1397	1405816715000	4793	2479	0	0	3302
75444	1397	1405806714000	4794	2480	0	0	3303
75445	1397	1405796713000	4795	2481	0	0	3304
75446	1397	1405786712000	4796	2482	0	0	3305
75455	1726	936400000000	4799	2483	0	0	49
75457	1726	933800000000	4799	2483	2	0	51
75458	1726	932500000000	4799	2483	3	0	52
75459	1726	931200000000	4799	2483	4	0	53
75460	1726	929900000000	4799	2483	5	0	54
75461	1397	1405776711000	4799	2483	6	0	3306
75464	1726	928600000000	4802	2485	0	0	55
75465	1397	1405756709000	4802	2485	1	0	3308
75467	1397	1405746708000	4804	2486	0	0	3309
75469	1397	1405736707000	4806	2487	0	0	3310
75471	1397	1405716705000	4808	2489	0	0	3312
75473	1397	1405706704000	4810	2490	0	0	3313
75481	1726	928600000000	4811	2395	7	0	\N
75482	1699	2769912500051	4811	2395	8	0	\N
75483	1693	3199221551364	4811	2395	9	0	\N
75484	1693	3199111551364	4811	2395	10	0	\N
75485	112	66152471816426	4811	2395	11	0	\N
75486	112	66002461816426	4811	2395	12	0	\N
75487	1397	1406866820000	4811	2395	13	0	\N
75488	1397	1406856819000	4811	2395	14	0	\N
75489	1397	1406846818000	4811	2395	15	0	\N
75490	1397	1406836817000	4811	2395	16	0	\N
75491	1397	1406826816000	4811	2395	17	0	\N
75492	1397	1406816815000	4811	2395	18	0	\N
75493	1397	1406806814000	4811	2395	19	0	\N
75494	1397	1406796813000	4811	2395	20	0	\N
75495	1397	1406786812000	4811	2395	21	0	\N
75496	1397	1406776811000	4811	2395	22	0	\N
75497	1397	1406766810000	4811	2395	23	0	\N
75498	1397	1406756809000	4811	2395	24	0	\N
75499	1397	1406746808000	4811	2395	25	0	\N
75500	1397	1406736807000	4811	2395	26	0	\N
75501	1397	1406726806000	4811	2395	27	0	\N
75502	1397	1406716805000	4811	2395	28	0	\N
75503	1397	1406706804000	4811	2395	29	0	\N
75504	1397	1406696803000	4811	2395	30	0	\N
75505	1397	1406686802000	4811	2395	31	0	\N
75506	1397	1406676801000	4811	2395	32	0	\N
75507	1397	1406666800000	4811	2395	33	0	\N
75508	1397	1406656799000	4811	2395	34	0	\N
75509	1397	1406646798000	4811	2395	35	0	\N
75510	1397	1406636797000	4811	2395	36	0	\N
75511	1397	1406626796000	4811	2395	37	0	\N
75512	1397	1406616795000	4811	2395	38	0	\N
75513	1397	1406606794000	4811	2395	39	0	\N
75514	1397	1406596793000	4811	2395	40	0	\N
75515	1397	1406586792000	4811	2395	41	0	\N
75516	1397	1406576791000	4811	2395	42	0	\N
75517	1397	1406566790000	4811	2395	43	0	\N
75518	1397	1406556789000	4811	2395	44	0	\N
75519	1397	1406546788000	4811	2395	45	0	\N
75520	1397	1406536787000	4811	2395	46	0	\N
75521	1397	1406526786000	4811	2395	47	0	\N
75522	1397	1406516785000	4811	2395	48	0	\N
75523	1397	1406506784000	4811	2395	49	0	\N
75524	1397	1406496783000	4811	2395	50	0	\N
75525	1397	1406486782000	4811	2395	51	0	\N
75526	1397	1406476781000	4811	2395	52	0	\N
75527	1397	1406466780000	4811	2395	53	0	\N
75528	1397	1406456779000	4811	2395	54	0	\N
75529	1397	1406446778000	4811	2395	55	0	\N
75530	1397	1406436777000	4811	2395	56	0	\N
75531	1397	1406426776000	4811	2395	57	0	\N
75532	1397	1406416775000	4811	2395	58	0	\N
75533	1397	1406406774000	4811	2395	59	0	\N
75534	1397	1406396773000	4811	2395	60	0	\N
75535	1397	1406386772000	4811	2395	61	0	\N
75536	1397	1406376771000	4811	2395	62	0	\N
75537	1397	1406366770000	4811	2395	63	0	\N
75538	1397	1406356769000	4811	2395	64	0	\N
75539	1397	1406346768000	4811	2395	65	0	\N
75540	1397	1406336767000	4811	2395	66	0	\N
75541	1397	1406326766000	4811	2395	67	0	\N
75542	1397	1406316765000	4811	2395	68	0	\N
75543	1397	1406306764000	4811	2395	69	0	\N
75544	1397	1406296763000	4811	2395	70	0	\N
75545	1397	1406286762000	4811	2395	71	0	\N
75546	1397	1406276761000	4811	2395	72	0	\N
75547	1397	1406266760000	4811	2395	73	0	\N
75548	1397	1406256759000	4811	2395	74	0	\N
75549	1397	1406246758000	4811	2395	75	0	\N
75550	1397	1406236757000	4811	2395	76	0	\N
75551	1397	1406226756000	4811	2395	77	0	\N
75552	1397	1406216755000	4811	2395	78	0	\N
75553	1397	1406206754000	4811	2395	79	0	\N
75554	1397	1406196753000	4811	2395	80	0	\N
75555	1397	1406186752000	4811	2395	81	0	\N
75556	1397	1406176751000	4811	2395	82	0	\N
75557	1397	1406166750000	4811	2395	83	0	\N
75558	1397	1406156749000	4811	2395	84	0	\N
75559	1397	1406146748000	4811	2395	85	0	\N
75560	1397	1406136747000	4811	2395	86	0	\N
75561	1397	1406126746000	4811	2395	87	0	\N
75562	1397	1406116745000	4811	2395	88	0	\N
75563	1397	1406106744000	4811	2395	89	0	\N
75564	1397	1406096743000	4811	2395	90	0	\N
75565	1397	1406086742000	4811	2395	91	0	\N
75566	1397	1406076741000	4811	2395	92	0	\N
75567	1397	1406066740000	4811	2395	93	0	\N
75568	1397	1406056739000	4811	2395	94	0	\N
75569	1397	1406046738000	4811	2395	95	0	\N
75570	1397	1406036737000	4811	2395	96	0	\N
75571	1397	1406026736000	4811	2395	97	0	\N
75572	1397	1406016735000	4811	2395	98	0	\N
75573	1397	1406006734000	4811	2395	99	0	\N
75574	1397	1405996733000	4811	2395	100	0	\N
75575	1397	1405986732000	4811	2395	101	0	\N
75576	1397	1405976731000	4811	2395	102	0	\N
75577	1397	1405966730000	4811	2395	103	0	\N
75578	1397	1405956729000	4811	2395	104	0	\N
75579	1397	1405946728000	4811	2395	105	0	\N
75580	1397	1405936727000	4811	2395	106	0	\N
75588	1828	0	4817	2495	0	0	\N
75589	1397	1405656699000	4817	2495	1	0	\N
75590	1828	0	4818	2495	0	0	\N
75591	1397	1405656699000	4818	2495	1	0	\N
75592	1397	1405646698000	4819	2496	0	0	\N
75598	1805	190000000	4823	2499	0	0	\N
75599	1397	1405606694000	4823	2499	1	0	\N
75602	1726	936400000000	4825	2397	0	0	\N
75603	1726	935100000000	4825	2397	1	0	\N
75604	1726	933800000000	4825	2397	2	0	\N
75605	1726	932500000000	4825	2397	3	0	\N
75606	281	66001000000000	4825	2397	4	0	\N
75607	1726	931200000000	4825	2397	5	0	\N
75608	1726	929900000000	4825	2397	6	0	\N
75609	1726	928600000000	4825	2397	7	0	\N
75610	436	66718640000000	4825	2397	8	0	\N
75611	1699	2769912500051	4825	2397	9	0	\N
75612	1397	1406846818000	4825	2397	10	0	\N
75613	1397	1406836817000	4825	2397	11	0	\N
75614	1397	1406826816000	4825	2397	12	0	\N
75615	1397	1406816815000	4825	2397	13	0	\N
75616	1397	1406806814000	4825	2397	14	0	\N
75583	1397	1405686702000	4813	2492	1	0	3315
75584	1397	1405676701000	4814	2493	0	0	3316
75585	1397	1405666700000	4815	2494	0	0	3317
75586	1828	0	4816	2495	0	0	1
75587	1397	1405656699000	4816	2495	1	0	3318
75594	436	66718640000000	4821	2497	0	0	2
75595	1397	1405636697000	4821	2497	1	0	3320
75596	1397	1405626696000	4821	2497	2	0	3321
75597	1397	1405616695000	4822	2498	0	0	3322
75600	1805	190000000	4824	2499	0	0	1
75617	1397	1406796813000	4825	2397	15	0	\N
75618	1805	190000000	4825	2397	16	0	\N
75619	1693	3199221551364	4825	2397	17	0	\N
75620	1693	3199111551364	4825	2397	18	0	\N
75621	1397	1406786812000	4825	2397	19	0	\N
75622	1397	1406776811000	4825	2397	20	0	\N
75623	1397	1406766810000	4825	2397	21	0	\N
75624	1397	1406756809000	4825	2397	22	0	\N
75625	1397	1406746808000	4825	2397	23	0	\N
75626	1397	1406736807000	4825	2397	24	0	\N
75627	112	66152471816426	4825	2397	25	0	\N
75628	112	66002461816426	4825	2397	26	0	\N
75629	1397	1406726806000	4825	2397	27	0	\N
75630	1397	1406716805000	4825	2397	28	0	\N
75631	1397	1406706804000	4825	2397	29	0	\N
75632	1397	1406696803000	4825	2397	30	0	\N
75633	1397	1406686802000	4825	2397	31	0	\N
75634	1397	1406676801000	4825	2397	32	0	\N
75635	1397	1406666800000	4825	2397	33	0	\N
75636	1397	1406656799000	4825	2397	34	0	\N
75637	1397	1406646798000	4825	2397	35	0	\N
75638	1397	1406636797000	4825	2397	36	0	\N
75639	1397	1406626796000	4825	2397	37	0	\N
75640	1397	1406616795000	4825	2397	38	0	\N
75641	1397	1406606794000	4825	2397	39	0	\N
75642	1397	1406596793000	4825	2397	40	0	\N
75643	1397	1406586792000	4825	2397	41	0	\N
75644	1397	1406576791000	4825	2397	42	0	\N
75645	1397	1406566790000	4825	2397	43	0	\N
75646	1397	1406556789000	4825	2397	44	0	\N
75647	1397	1406546788000	4825	2397	45	0	\N
75648	1397	1406536787000	4825	2397	46	0	\N
75649	1397	1406526786000	4825	2397	47	0	\N
75650	1397	1406516785000	4825	2397	48	0	\N
75651	1397	1406506784000	4825	2397	49	0	\N
75652	1397	1406496783000	4825	2397	50	0	\N
75653	1397	1406486782000	4825	2397	51	0	\N
75654	1397	1406476781000	4825	2397	52	0	\N
75655	1397	1406466780000	4825	2397	53	0	\N
75656	1397	1406456779000	4825	2397	54	0	\N
75657	1397	1406446778000	4825	2397	55	0	\N
75658	1397	1406436777000	4825	2397	56	0	\N
75659	1397	1406426776000	4825	2397	57	0	\N
75660	1397	1406416775000	4825	2397	58	0	\N
75661	1397	1406406774000	4825	2397	59	0	\N
75662	1397	1406396773000	4825	2397	60	0	\N
75663	1397	1406386772000	4825	2397	61	0	\N
75664	1397	1406376771000	4825	2397	62	0	\N
75665	1397	1406366770000	4825	2397	63	0	\N
75666	1397	1406356769000	4825	2397	64	0	\N
75667	1397	1406346768000	4825	2397	65	0	\N
75668	1397	1406336767000	4825	2397	66	0	\N
75669	1397	1406326766000	4825	2397	67	0	\N
75670	1397	1406316765000	4825	2397	68	0	\N
75671	1397	1406306764000	4825	2397	69	0	\N
75672	1397	1406296763000	4825	2397	70	0	\N
75673	1397	1406286762000	4825	2397	71	0	\N
75674	1397	1406276761000	4825	2397	72	0	\N
75675	1397	1406266760000	4825	2397	73	0	\N
75676	1397	1406256759000	4825	2397	74	0	\N
75677	1397	1406246758000	4825	2397	75	0	\N
75678	1397	1406236757000	4825	2397	76	0	\N
75679	1397	1406226756000	4825	2397	77	0	\N
75680	1397	1406216755000	4825	2397	78	0	\N
75681	1397	1406206754000	4825	2397	79	0	\N
75682	1397	1406196753000	4825	2397	80	0	\N
75683	1397	1406186752000	4825	2397	81	0	\N
75684	1397	1406176751000	4825	2397	82	0	\N
75685	1397	1406166750000	4825	2397	83	0	\N
75686	1397	1406156749000	4825	2397	84	0	\N
75687	1397	1406146748000	4825	2397	85	0	\N
75688	1397	1406136747000	4825	2397	86	0	\N
75689	1397	1406126746000	4825	2397	87	0	\N
75690	1397	1406116745000	4825	2397	88	0	\N
75691	1397	1406106744000	4825	2397	89	0	\N
75692	1397	1406096743000	4825	2397	90	0	\N
75693	1397	1406086742000	4825	2397	91	0	\N
75694	1397	1406076741000	4825	2397	92	0	\N
75695	1397	1406066740000	4825	2397	93	0	\N
75696	1397	1406056739000	4825	2397	94	0	\N
75697	1397	1406046738000	4825	2397	95	0	\N
75698	1397	1406036737000	4825	2397	96	0	\N
75699	1397	1406026736000	4825	2397	97	0	\N
75700	1397	1406016735000	4825	2397	98	0	\N
75701	1397	1406006734000	4825	2397	99	0	\N
75702	1397	1405996733000	4825	2397	100	0	\N
75703	1397	1405986732000	4825	2397	101	0	\N
75704	1397	1405976731000	4825	2397	103	0	\N
75705	1397	1405966730000	4825	2397	104	0	\N
75706	1397	1405956729000	4825	2397	105	0	\N
75707	1397	1405946728000	4825	2397	106	0	\N
75708	1397	1405936727000	4825	2397	107	0	\N
75709	1397	1405926726000	4825	2397	108	0	\N
75710	1397	1405916725000	4825	2397	109	0	\N
75711	1397	1405906724000	4825	2397	110	0	\N
75712	1397	1405896723000	4825	2397	111	0	\N
75713	1397	1405886722000	4825	2397	112	0	\N
75714	1397	1405876721000	4825	2397	113	0	\N
75715	1397	1405866720000	4825	2397	114	0	\N
75716	1397	1405856719000	4825	2397	115	0	\N
75717	1397	1405846718000	4825	2397	116	0	\N
75718	1397	1405836717000	4825	2397	117	0	\N
75719	1397	1405826716000	4825	2397	118	0	\N
75720	1397	1405816715000	4825	2397	119	0	\N
75721	1397	1405806714000	4825	2397	120	0	\N
75722	1397	1405796713000	4825	2397	121	0	\N
75723	1397	1405786712000	4825	2397	122	0	\N
75724	1397	1405776711000	4825	2397	123	0	\N
75725	1397	1405766710000	4825	2397	124	0	\N
75726	1397	1405756709000	4825	2397	125	0	\N
75730	1397	1405586692000	4830	2502	0	0	\N
75731	1397	1405576691000	4830	2502	1	0	\N
75735	1397	1405746708000	4833	2398	0	0	\N
75736	1397	1405736707000	4833	2398	1	0	\N
75737	1397	1405726706000	4833	2398	2	0	\N
75738	1397	1405716705000	4833	2398	3	0	\N
75739	1397	1405706704000	4833	2398	4	0	\N
75740	1397	1405696703000	4833	2398	5	0	\N
75741	1397	1405686702000	4833	2398	6	0	\N
75742	1397	1405676701000	4833	2398	7	0	\N
75743	1397	1405666700000	4833	2398	8	0	\N
75744	1397	1405656699000	4833	2398	9	0	\N
75745	1397	1405646698000	4833	2398	10	0	\N
75746	1397	1405636697000	4833	2398	11	0	\N
75747	1397	1405626696000	4833	2398	12	0	\N
75748	1397	1405616695000	4833	2398	13	0	\N
75749	1397	1405606694000	4833	2398	14	0	\N
75750	1397	1405596693000	4833	2398	15	0	\N
75751	1397	1405586692000	4833	2398	16	0	\N
75752	1397	1405576691000	4833	2398	17	0	\N
75729	1397	1405576691000	4829	2502	1	0	3326
75732	1397	1405566690000	4831	2503	0	0	3327
75733	1397	1405556689000	4832	2504	0	0	3328
75734	1397	1405546688000	4832	2504	1	0	3329
75753	1397	1405566690000	4833	2398	18	0	\N
75754	1397	1405556689000	4833	2398	19	0	\N
75755	1397	1405546688000	4833	2398	20	0	\N
75756	1397	1405556689000	4834	2504	0	0	\N
75757	1397	1405546688000	4834	2504	1	0	\N
75758	1397	1405536687000	4835	2505	0	0	\N
75759	1397	1405526686000	4835	2505	1	0	\N
75760	1397	1405516685000	4835	2505	2	0	\N
75764	1397	1405536687000	4837	2505	0	0	\N
75765	1397	1405526686000	4837	2505	1	0	\N
75766	1397	1405516685000	4837	2505	2	0	\N
75771	1803	100000000	4843	2261	0	0	\N
75772	1726	939000000000	4843	2261	1	0	\N
75773	1726	937700000000	4843	2261	2	0	\N
75774	1726	936400000000	4843	2261	3	0	\N
75775	1726	935100000000	4843	2261	4	0	\N
75776	1726	933800000000	4843	2261	5	0	\N
75777	1726	932500000000	4843	2261	6	0	\N
75778	281	66001000000000	4843	2261	7	0	\N
75779	1726	931200000000	4843	2261	8	0	\N
75780	1726	929900000000	4843	2261	9	0	\N
75781	1726	928600000000	4843	2261	10	0	\N
75782	436	66718640000000	4843	2261	11	0	\N
75783	1699	2049902500051	4843	2261	12	0	\N
75784	354	66002390000000	4843	2261	13	0	\N
75785	1805	190000000	4843	2261	14	0	\N
75786	748	2002390000000	4843	2261	15	0	\N
75787	112	66086102047044	4843	2261	16	0	\N
75788	1397	1408636997000	4843	2261	17	0	\N
75789	1397	1408626996000	4843	2261	18	0	\N
75790	1397	1408616995000	4843	2261	19	0	\N
75791	1397	1408606994000	4843	2261	20	0	\N
75792	1397	1408596993000	4843	2261	21	0	\N
75793	1397	1408586992000	4843	2261	22	0	\N
75794	1397	1408576991000	4843	2261	23	0	\N
75795	1397	1408566990000	4843	2261	24	0	\N
75796	1397	1408556989000	4843	2261	25	0	\N
75797	1397	1408546988000	4843	2261	26	0	\N
75798	1397	1408536987000	4843	2261	27	0	\N
75799	1397	1408526986000	4843	2261	28	0	\N
75800	1397	1408516985000	4843	2261	29	0	\N
75801	1397	1408506984000	4843	2261	30	0	\N
75802	1397	1408496983000	4843	2261	31	0	\N
75803	1397	1408486982000	4843	2261	32	0	\N
75804	1397	1408476981000	4843	2261	33	0	\N
75805	1397	1408466980000	4843	2261	34	0	\N
75806	1397	1408456979000	4843	2261	35	0	\N
75807	1397	1408446978000	4843	2261	36	0	\N
75808	1397	1408436977000	4843	2261	37	0	\N
75809	1397	1408426976000	4843	2261	38	0	\N
75810	1397	1408416975000	4843	2261	39	0	\N
75811	1397	1408406974000	4843	2261	40	0	\N
75812	1397	1408396973000	4843	2261	41	0	\N
75813	1397	1408386972000	4843	2261	42	0	\N
75814	1397	1408376971000	4843	2261	43	0	\N
75815	1397	1408366970000	4843	2261	44	0	\N
75816	1397	1408356969000	4843	2261	45	0	\N
75817	1397	1408346968000	4843	2261	46	0	\N
75818	1397	1408336967000	4843	2261	47	0	\N
75819	1397	1408326966000	4843	2261	48	0	\N
75820	1397	1408316965000	4843	2261	49	0	\N
75821	1397	1408306964000	4843	2261	50	0	\N
75822	1397	1408296963000	4843	2261	51	0	\N
75823	1397	1408286962000	4843	2261	52	0	\N
75824	1397	1408276961000	4843	2261	53	0	\N
75825	1397	1408266960000	4843	2261	54	0	\N
75826	1397	1408256959000	4843	2261	55	0	\N
75827	1397	1408246958000	4843	2261	56	0	\N
75828	1397	1408236957000	4843	2261	57	0	\N
75829	1397	1408226956000	4843	2261	58	0	\N
75830	1397	1408216955000	4843	2261	59	0	\N
75831	1397	1408206954000	4843	2261	60	0	\N
75832	1397	1408196953000	4843	2261	61	0	\N
75833	1397	1408186952000	4843	2261	62	0	\N
75834	1397	1408176951000	4843	2261	63	0	\N
75835	1397	1408166950000	4843	2261	64	0	\N
75836	1397	1408156949000	4843	2261	65	0	\N
75837	1397	1408146948000	4843	2261	66	0	\N
75838	1397	1408136947000	4843	2261	67	0	\N
75839	1397	1408126946000	4843	2261	68	0	\N
75840	1397	1408116945000	4843	2261	69	0	\N
75841	1397	1408106944000	4843	2261	70	0	\N
75842	1397	1408096943000	4843	2261	71	0	\N
75843	1397	1408086942000	4843	2261	72	0	\N
75844	1397	1408076941000	4843	2261	73	0	\N
75845	1397	1408066940000	4843	2261	74	0	\N
75846	1397	1408056939000	4843	2261	75	0	\N
75847	1397	1408046938000	4843	2261	76	0	\N
75848	1397	1408036937000	4843	2261	77	0	\N
75849	1397	1408026936000	4843	2261	78	0	\N
75850	1397	1408016935000	4843	2261	79	0	\N
75851	1397	1408006934000	4843	2261	80	0	\N
75852	1397	1407996933000	4843	2261	81	0	\N
75853	1397	1407986932000	4843	2261	82	0	\N
75854	1397	1407976931000	4843	2261	83	0	\N
75855	1397	1407966930000	4843	2261	84	0	\N
75856	1397	1407956929000	4843	2261	85	0	\N
75857	1397	1407946928000	4843	2261	87	0	\N
75858	1397	1407936927000	4843	2261	88	0	\N
75859	1397	1407926926000	4843	2261	89	0	\N
75860	1397	1407916925000	4843	2261	90	0	\N
75861	1397	1407906924000	4843	2261	91	0	\N
75862	1397	1407896923000	4843	2261	92	0	\N
75863	1397	1407886922000	4843	2261	93	0	\N
75864	1397	1407876921000	4843	2261	94	0	\N
75865	1397	1407866920000	4843	2261	95	0	\N
75866	1397	1407856919000	4843	2261	96	0	\N
75867	1397	1407846918000	4843	2261	97	0	\N
75868	1397	1407836917000	4843	2261	98	0	\N
75869	1397	1407826916000	4843	2261	99	0	\N
75870	1397	1407816915000	4843	2261	100	0	\N
75871	1397	1407806914000	4843	2261	101	0	\N
75872	1397	1407796913000	4843	2261	102	0	\N
75873	1397	1407786912000	4843	2261	103	0	\N
75874	1397	1407776911000	4843	2261	104	0	\N
75875	1397	1407766910000	4843	2261	105	0	\N
75876	1397	1407756909000	4843	2261	106	0	\N
75877	1397	1407746908000	4843	2261	107	0	\N
75878	1397	1407736907000	4843	2261	108	0	\N
75879	1397	1407726906000	4843	2261	109	0	\N
75880	1397	1407716905000	4843	2261	110	0	\N
75881	1397	1407706904000	4843	2261	111	0	\N
75882	1397	1407696903000	4843	2261	112	0	\N
75883	1397	1407686902000	4843	2261	113	0	\N
75884	1397	1407676901000	4843	2261	114	0	\N
75885	1397	1407666900000	4843	2261	115	0	\N
75886	1397	1407656899000	4843	2261	116	0	\N
75887	1397	1407646898000	4843	2261	117	0	\N
75888	1397	1407636897000	4843	2261	118	0	\N
75763	1397	1405516685000	4836	2505	2	0	3332
75767	1397	1405506684000	4840	2507	0	0	3333
75768	1397	1405496683000	4841	2508	0	0	3334
75769	1397	1405486682000	4842	2509	0	0	3335
75770	1397	1405476681000	4842	2509	1	0	3336
75889	1397	1407626896000	4843	2261	119	0	\N
75890	1397	1407616895000	4843	2261	120	0	\N
75891	1397	1407606894000	4843	2261	121	0	\N
75892	1397	1407596893000	4843	2261	122	0	\N
75893	1397	1407586892000	4843	2261	123	0	\N
75894	1397	1407576891000	4843	2261	124	0	\N
75895	1397	1407566890000	4843	2261	125	0	\N
75897	1397	1405466680000	4845	2510	0	0	\N
75898	1397	1405466680000	4846	2510	0	0	\N
75900	1397	1405446678000	4848	2512	0	0	\N
75905	1726	926000000000	4852	2515	0	0	\N
75906	1397	1405416675000	4852	2515	1	0	\N
75907	1726	926000000000	4853	2515	0	0	\N
75908	1397	1405416675000	4853	2515	1	0	\N
75911	1397	1405406674000	4855	2516	0	0	\N
75912	1397	1405406674000	4856	2516	0	0	\N
75913	1397	1405406674000	4858	2516	0	0	\N
75915	1726	936400000000	4860	2431	0	0	\N
75916	1726	935100000000	4860	2431	1	0	\N
75917	1726	933800000000	4860	2431	2	0	\N
75918	1726	932500000000	4860	2431	3	0	\N
75919	1726	931200000000	4860	2431	4	0	\N
75920	1726	929900000000	4860	2431	5	0	\N
75921	1726	928600000000	4860	2431	6	0	\N
75922	1726	927300000000	4860	2431	7	0	\N
75923	1726	926000000000	4860	2431	8	0	\N
75924	436	66718640000000	4860	2431	9	0	\N
75925	1397	1406466780000	4860	2431	10	0	\N
75926	1397	1406456779000	4860	2431	11	0	\N
75927	1397	1406446778000	4860	2431	12	0	\N
75928	1397	1406436777000	4860	2431	13	0	\N
75929	1397	1406426776000	4860	2431	14	0	\N
75930	1397	1406416775000	4860	2431	15	0	\N
75931	112	66002461816426	4860	2431	16	0	\N
75932	1397	1406406774000	4860	2431	17	0	\N
75933	1397	1406396773000	4860	2431	18	0	\N
75934	1397	1406386772000	4860	2431	19	0	\N
75935	1397	1406376771000	4860	2431	20	0	\N
75936	1397	1406366770000	4860	2431	21	0	\N
75937	1397	1406356769000	4860	2431	22	0	\N
75938	1805	190000000	4860	2431	23	0	\N
75939	1397	1406346768000	4860	2431	24	0	\N
75940	1693	3199221551364	4860	2431	25	0	\N
75941	1693	3199111551364	4860	2431	26	0	\N
75942	1397	1406336767000	4860	2431	27	0	\N
75943	1397	1406326766000	4860	2431	28	0	\N
75944	1397	1406316765000	4860	2431	29	0	\N
75945	1397	1406306764000	4860	2431	30	0	\N
75946	1397	1406296763000	4860	2431	31	0	\N
75947	1397	1406286762000	4860	2431	32	0	\N
75948	1397	1406276761000	4860	2431	33	0	\N
75949	1397	1406266760000	4860	2431	34	0	\N
75950	1397	1406256759000	4860	2431	35	0	\N
75951	1397	1406246758000	4860	2431	36	0	\N
75952	1397	1406236757000	4860	2431	37	0	\N
75953	1397	1406226756000	4860	2431	38	0	\N
75954	1397	1406216755000	4860	2431	39	0	\N
75955	1397	1406206754000	4860	2431	40	0	\N
75956	1397	1406196753000	4860	2431	41	0	\N
75957	1397	1406186752000	4860	2431	42	0	\N
75958	1397	1406176751000	4860	2431	43	0	\N
75959	1397	1406166750000	4860	2431	44	0	\N
75960	1397	1406156749000	4860	2431	45	0	\N
75961	1397	1406146748000	4860	2431	46	0	\N
75962	1397	1406136747000	4860	2431	47	0	\N
75963	1397	1406126746000	4860	2431	48	0	\N
75964	1397	1406116745000	4860	2431	49	0	\N
75965	1397	1406106744000	4860	2431	50	0	\N
75966	1397	1406096743000	4860	2431	51	0	\N
75967	1397	1406086742000	4860	2431	52	0	\N
75968	1397	1406076741000	4860	2431	53	0	\N
75969	1397	1406066740000	4860	2431	54	0	\N
75970	1397	1406056739000	4860	2431	55	0	\N
75971	1397	1406046738000	4860	2431	56	0	\N
75972	1397	1406036737000	4860	2431	57	0	\N
75973	1397	1406026736000	4860	2431	58	0	\N
75974	1397	1406016735000	4860	2431	59	0	\N
75975	1397	1406006734000	4860	2431	60	0	\N
75976	1397	1405996733000	4860	2431	61	0	\N
75977	1397	1405986732000	4860	2431	62	0	\N
75978	1397	1405976731000	4860	2431	63	0	\N
75979	1397	1405966730000	4860	2431	64	0	\N
75980	1397	1405956729000	4860	2431	65	0	\N
75981	1397	1405946728000	4860	2431	66	0	\N
75982	1397	1405936727000	4860	2431	67	0	\N
75983	1397	1405926726000	4860	2431	68	0	\N
75984	1397	1405916725000	4860	2431	69	0	\N
75985	1397	1405906724000	4860	2431	70	0	\N
75986	1397	1405896723000	4860	2431	71	0	\N
75987	1397	1405886722000	4860	2431	72	0	\N
75988	1397	1405876721000	4860	2431	73	0	\N
75989	1397	1405866720000	4860	2431	74	0	\N
75990	1397	1405856719000	4860	2431	75	0	\N
75991	1397	1405846718000	4860	2431	76	0	\N
75992	1397	1405836717000	4860	2431	77	0	\N
75993	1397	1405826716000	4860	2431	78	0	\N
75994	1397	1405816715000	4860	2431	79	0	\N
75995	1397	1405806714000	4860	2431	80	0	\N
75996	1397	1405796713000	4860	2431	81	0	\N
75997	1397	1405786712000	4860	2431	82	0	\N
75998	1397	1405776711000	4860	2431	83	0	\N
75999	1397	1405766710000	4860	2431	84	0	\N
76000	1397	1405756709000	4860	2431	85	0	\N
76001	1397	1405746708000	4860	2431	86	0	\N
76002	1397	1405736707000	4860	2431	87	0	\N
76003	1397	1405726706000	4860	2431	88	0	\N
76004	1397	1405716705000	4860	2431	89	0	\N
76005	1397	1405706704000	4860	2431	90	0	\N
76006	1397	1405696703000	4860	2431	91	0	\N
76007	1397	1405686702000	4860	2431	92	0	\N
76008	1397	1405676701000	4860	2431	93	0	\N
76009	1397	1405666700000	4860	2431	94	0	\N
76010	1397	1405656699000	4860	2431	95	0	\N
76011	1397	1405646698000	4860	2431	96	0	\N
76012	1397	1405636697000	4860	2431	97	0	\N
76013	1397	1405626696000	4860	2431	98	0	\N
76014	1397	1405616695000	4860	2431	99	0	\N
76015	1397	1405606694000	4860	2431	100	0	\N
76016	1397	1405596693000	4860	2431	101	0	\N
76017	1397	1405586692000	4860	2431	102	0	\N
76018	1397	1405576691000	4860	2431	103	0	\N
76019	1397	1405566690000	4860	2431	104	0	\N
76020	1397	1405556689000	4860	2431	105	0	\N
76021	1397	1405546688000	4860	2431	106	0	\N
76022	1397	1405536687000	4860	2431	107	0	\N
76023	1397	1405526686000	4860	2431	108	0	\N
76024	1397	1405516685000	4860	2431	109	0	\N
75901	1397	1405446678000	4849	2512	0	0	3339
75902	1397	1405436677000	4850	2513	0	0	3340
75903	1726	927300000000	4851	2514	0	0	56
75904	1397	1405426676000	4851	2514	1	0	3341
75909	1726	926000000000	4854	2515	0	0	57
75914	1397	1405406674000	4859	2516	0	0	3343
76025	1397	1405506684000	4860	2431	110	0	\N
76026	1397	1405496683000	4860	2431	111	0	\N
76027	1397	1405486682000	4860	2431	112	0	\N
76028	1397	1405476681000	4860	2431	113	0	\N
76029	1397	1405466680000	4860	2431	114	0	\N
76030	1397	1405456679000	4860	2431	115	0	\N
76031	1397	1405446678000	4860	2431	117	0	\N
76032	1397	1405436677000	4860	2431	118	0	\N
76033	1397	1405426676000	4860	2431	119	0	\N
76034	1397	1405416675000	4860	2431	120	0	\N
76035	1397	1405406674000	4860	2431	121	0	\N
76036	1397	1405396673000	4861	2517	0	0	\N
76037	1397	1405386672000	4861	2517	1	0	\N
76038	1397	1405376671000	4861	2517	2	0	\N
76039	1397	1405366670000	4861	2517	3	0	\N
76044	1397	1405396673000	4863	2517	0	0	\N
76045	1397	1405386672000	4863	2517	1	0	\N
76046	1397	1405376671000	4863	2517	2	0	\N
76047	1397	1405366670000	4863	2517	3	0	\N
76052	1397	1405316665000	4868	2522	0	0	\N
76053	1397	1405316665000	4869	2522	0	0	\N
76055	1397	1405306664000	4871	2523	0	0	\N
76057	1397	1405306664000	4873	2523	0	0	\N
76058	1726	936400000000	4874	2326	0	0	\N
76059	1726	935100000000	4874	2326	1	0	\N
76060	1726	933800000000	4874	2326	2	0	\N
76061	1726	932500000000	4874	2326	3	0	\N
76062	436	66718640000000	4874	2326	4	0	\N
76063	1397	1406826816000	4874	2326	5	0	\N
76064	1397	1406816815000	4874	2326	6	0	\N
76065	1397	1406806814000	4874	2326	7	0	\N
76066	1397	1406796813000	4874	2326	8	0	\N
76067	1805	190000000	4874	2326	9	0	\N
76068	1693	1759211551364	4874	2326	10	0	\N
76069	1693	1759101551364	4874	2326	11	0	\N
76070	1397	1406786812000	4874	2326	12	0	\N
76071	1397	1406776811000	4874	2326	13	0	\N
76072	1397	1406766810000	4874	2326	14	0	\N
76073	1397	1406756809000	4874	2326	15	0	\N
76074	1397	1406746808000	4874	2326	16	0	\N
76075	1397	1406736807000	4874	2326	17	0	\N
76076	112	66152471816426	4874	2326	18	0	\N
76077	112	66002461816426	4874	2326	19	0	\N
76078	1397	1406726806000	4874	2326	20	0	\N
76079	1397	1406716805000	4874	2326	21	0	\N
76080	1397	1406706804000	4874	2326	22	0	\N
76081	1397	1406696803000	4874	2326	23	0	\N
76082	1397	1406686802000	4874	2326	24	0	\N
76083	1397	1406676801000	4874	2326	25	0	\N
76084	1397	1406666800000	4874	2326	26	0	\N
76085	1397	1406656799000	4874	2326	27	0	\N
76086	1397	1406646798000	4874	2326	28	0	\N
76087	1397	1406636797000	4874	2326	29	0	\N
76088	1397	1406626796000	4874	2326	30	0	\N
76089	1397	1406616795000	4874	2326	31	0	\N
76090	1397	1406606794000	4874	2326	32	0	\N
76091	1397	1406596793000	4874	2326	33	0	\N
76092	1397	1406586792000	4874	2326	34	0	\N
76093	1397	1406576791000	4874	2326	35	0	\N
76094	1397	1406566790000	4874	2326	36	0	\N
76095	1397	1406556789000	4874	2326	37	0	\N
76096	1397	1406546788000	4874	2326	38	0	\N
76097	1397	1406536787000	4874	2326	39	0	\N
76098	1397	1406526786000	4874	2326	40	0	\N
76099	1397	1406516785000	4874	2326	41	0	\N
76100	1397	1406506784000	4874	2326	42	0	\N
76101	1397	1406496783000	4874	2326	43	0	\N
76102	1397	1406486782000	4874	2326	44	0	\N
76103	1397	1406476781000	4874	2326	45	0	\N
76104	1397	1406466780000	4874	2326	46	0	\N
76105	1397	1406456779000	4874	2326	47	0	\N
76106	1397	1406446778000	4874	2326	48	0	\N
76107	1397	1406436777000	4874	2326	49	0	\N
76108	1397	1406426776000	4874	2326	50	0	\N
76109	1397	1406416775000	4874	2326	51	0	\N
76110	1397	1406406774000	4874	2326	52	0	\N
76111	1397	1406396773000	4874	2326	53	0	\N
76112	1397	1406386772000	4874	2326	54	0	\N
76113	1397	1406376771000	4874	2326	55	0	\N
76114	1397	1406366770000	4874	2326	56	0	\N
76115	1397	1406356769000	4874	2326	57	0	\N
76116	1397	1406346768000	4874	2326	58	0	\N
76117	1397	1406336767000	4874	2326	59	0	\N
76118	1397	1406326766000	4874	2326	60	0	\N
76119	1397	1406316765000	4874	2326	61	0	\N
76120	1397	1406306764000	4874	2326	62	0	\N
76121	1397	1406296763000	4874	2326	63	0	\N
76122	1397	1406286762000	4874	2326	64	0	\N
76123	1397	1406276761000	4874	2326	65	0	\N
76124	1397	1406266760000	4874	2326	66	0	\N
76125	1397	1406256759000	4874	2326	67	0	\N
76126	1397	1406246758000	4874	2326	68	0	\N
76127	1397	1406236757000	4874	2326	69	0	\N
76128	1397	1406226756000	4874	2326	70	0	\N
76129	1397	1406216755000	4874	2326	71	0	\N
76130	1397	1406206754000	4874	2326	72	0	\N
76131	1397	1406196753000	4874	2326	73	0	\N
76132	1397	1406186752000	4874	2326	74	0	\N
76133	1397	1406176751000	4874	2326	75	0	\N
76134	1397	1406166750000	4874	2326	76	0	\N
76135	1397	1406156749000	4874	2326	77	0	\N
76136	1397	1406146748000	4874	2326	78	0	\N
76137	1397	1406136747000	4874	2326	79	0	\N
76138	1397	1406126746000	4874	2326	80	0	\N
76139	1397	1406116745000	4874	2326	81	0	\N
76140	1397	1406106744000	4874	2326	82	0	\N
76141	1397	1406096743000	4874	2326	83	0	\N
76142	1397	1406086742000	4874	2326	84	0	\N
76143	1397	1406076741000	4874	2326	85	0	\N
76144	1397	1406066740000	4874	2326	86	0	\N
76145	1397	1406056739000	4874	2326	87	0	\N
76146	1397	1406046738000	4874	2326	88	0	\N
76147	1397	1406036737000	4874	2326	89	0	\N
76148	1397	1406026736000	4874	2326	90	0	\N
76149	1397	1406016735000	4874	2326	91	0	\N
76150	1397	1406006734000	4874	2326	92	0	\N
76151	1397	1405996733000	4874	2326	93	0	\N
76152	1397	1405986732000	4874	2326	94	0	\N
76153	1397	1405976731000	4874	2326	95	0	\N
76154	1397	1405966730000	4874	2326	96	0	\N
76155	1397	1405956729000	4874	2326	97	0	\N
76156	1397	1405946728000	4874	2326	98	0	\N
76157	1397	1405936727000	4874	2326	99	0	\N
76158	1397	1405926726000	4874	2326	100	0	\N
76159	1397	1405916725000	4874	2326	101	0	\N
76160	1397	1405906724000	4874	2326	102	0	\N
76042	1397	1405376671000	4862	2517	2	0	3346
76043	1397	1405366670000	4862	2517	3	0	3347
76048	1397	1405356669000	4864	2518	0	0	3348
76049	1397	1405346668000	4865	2519	0	0	3349
76050	1397	1405336667000	4866	2520	0	0	3350
76054	1397	1405316665000	4870	2522	0	0	3352
76056	1397	1405306664000	4872	2523	0	0	3353
76161	1397	1405896723000	4874	2326	103	0	\N
76162	1397	1405886722000	4874	2326	104	0	\N
76163	1397	1405876721000	4874	2326	105	0	\N
76164	1397	1405866720000	4874	2326	106	0	\N
76165	1397	1405856719000	4874	2326	107	0	\N
76166	1397	1405846718000	4874	2326	108	0	\N
76167	1397	1405836717000	4874	2326	109	0	\N
76168	1397	1405826716000	4874	2326	110	0	\N
76169	1397	1405816715000	4874	2326	111	0	\N
76170	1397	1405806714000	4874	2326	115	0	\N
76171	1397	1405796713000	4874	2326	116	0	\N
76172	1397	1405786712000	4874	2326	117	0	\N
76173	1397	1405776711000	4874	2326	118	0	\N
76174	1397	1405766710000	4874	2326	119	0	\N
76175	1397	1405756709000	4874	2326	120	0	\N
76176	1397	1405746708000	4874	2326	121	0	\N
76177	1397	1405736707000	4874	2326	122	0	\N
76178	1397	1405726706000	4874	2326	123	0	\N
76179	1397	1405716705000	4874	2326	124	0	\N
76180	1397	1405706704000	4874	2326	125	0	\N
76185	1397	1405256659000	4879	2528	0	0	\N
76186	1397	1405246658000	4879	2528	1	0	\N
76187	1397	1405236657000	4879	2528	2	0	\N
76188	1397	1405256659000	4880	2528	0	0	\N
76189	1397	1405246658000	4880	2528	1	0	\N
76190	1397	1405236657000	4880	2528	2	0	\N
76194	1397	1405256659000	4882	2528	0	0	\N
76195	1397	1405246658000	4882	2528	1	0	\N
76196	1397	1405236657000	4882	2528	2	0	\N
76197	1397	1405256659000	4883	2528	0	0	\N
76198	1397	1405246658000	4883	2528	1	0	\N
76199	1397	1405236657000	4883	2528	2	0	\N
76202	1397	1405206654000	4886	2531	0	0	\N
76203	436	66717630000000	4886	2531	1	0	\N
76212	1397	1405156649000	4892	2535	0	0	\N
76213	1397	1405156649000	4893	2535	0	0	\N
76214	1397	1405156649000	4894	2535	0	0	\N
76215	1726	927300000000	4895	2262	0	0	\N
76216	1726	926000000000	4895	2262	1	0	\N
76217	1397	1407556889000	4895	2262	2	0	\N
76218	1397	1407546888000	4895	2262	3	0	\N
76219	1397	1407536887000	4895	2262	4	0	\N
76220	1397	1407526886000	4895	2262	5	0	\N
76221	1397	1407516885000	4895	2262	6	0	\N
76222	1397	1407506884000	4895	2262	7	0	\N
76223	1397	1407496883000	4895	2262	8	0	\N
76224	1397	1407486882000	4895	2262	9	0	\N
76225	1397	1407476881000	4895	2262	10	0	\N
76226	1397	1407466880000	4895	2262	11	0	\N
76227	1397	1407456879000	4895	2262	12	0	\N
76228	1397	1407446878000	4895	2262	13	0	\N
76229	1397	1407436877000	4895	2262	14	0	\N
76230	1397	1407426876000	4895	2262	15	0	\N
76231	1397	1407416875000	4895	2262	16	0	\N
76232	1397	1407406874000	4895	2262	17	0	\N
76233	1397	1407396873000	4895	2262	18	0	\N
76234	1397	1407386872000	4895	2262	19	0	\N
76235	1397	1407376871000	4895	2262	20	0	\N
76236	1397	1407366870000	4895	2262	21	0	\N
76237	1397	1407356869000	4895	2262	22	0	\N
76238	1397	1407346868000	4895	2262	23	0	\N
76239	1397	1407336867000	4895	2262	24	0	\N
76240	1397	1407326866000	4895	2262	25	0	\N
76241	1397	1407316865000	4895	2262	26	0	\N
76242	1397	1407306864000	4895	2262	27	0	\N
76243	1397	1407296863000	4895	2262	28	0	\N
76244	1397	1407286862000	4895	2262	29	0	\N
76245	1397	1407276861000	4895	2262	30	0	\N
76246	1397	1407266860000	4895	2262	31	0	\N
76247	1397	1407256859000	4895	2262	32	0	\N
76248	1397	1407246858000	4895	2262	33	0	\N
76249	1397	1407236857000	4895	2262	34	0	\N
76250	1397	1407226856000	4895	2262	35	0	\N
76251	1397	1407216855000	4895	2262	36	0	\N
76252	1397	1407206854000	4895	2262	37	0	\N
76253	1397	1407196853000	4895	2262	38	0	\N
76254	1397	1407186852000	4895	2262	39	0	\N
76255	1397	1407176851000	4895	2262	40	0	\N
76256	1397	1407166850000	4895	2262	41	0	\N
76257	1397	1407156849000	4895	2262	42	0	\N
76258	1397	1407146848000	4895	2262	43	0	\N
76259	1397	1407136847000	4895	2262	44	0	\N
76260	1397	1407126846000	4895	2262	45	0	\N
76261	1397	1407116845000	4895	2262	46	0	\N
76262	1397	1407106844000	4895	2262	47	0	\N
76263	1397	1407096843000	4895	2262	48	0	\N
76264	1397	1407086842000	4895	2262	49	0	\N
76265	1397	1407076841000	4895	2262	50	0	\N
76266	1397	1407066840000	4895	2262	51	0	\N
76267	1397	1407056839000	4895	2262	52	0	\N
76268	1397	1407046838000	4895	2262	53	0	\N
76269	1397	1407036837000	4895	2262	54	0	\N
76270	1397	1407026836000	4895	2262	55	0	\N
76271	1397	1407016835000	4895	2262	56	0	\N
76272	1397	1407006834000	4895	2262	57	0	\N
76273	1397	1406996833000	4895	2262	58	0	\N
76274	1397	1406986832000	4895	2262	59	0	\N
76275	1397	1406976831000	4895	2262	60	0	\N
76276	1397	1406966830000	4895	2262	61	0	\N
76277	1397	1406956829000	4895	2262	62	0	\N
76278	1397	1406946828000	4895	2262	63	0	\N
76279	1397	1406936827000	4895	2262	64	0	\N
76280	1397	1406926826000	4895	2262	65	0	\N
76281	1397	1406916825000	4895	2262	66	0	\N
76282	1397	1406906824000	4895	2262	67	0	\N
76283	1397	1406896823000	4895	2262	68	0	\N
76284	1397	1406886822000	4895	2262	69	0	\N
76285	1397	1406876821000	4895	2262	70	0	\N
76286	1397	1406866820000	4895	2262	71	0	\N
76287	1397	1406856819000	4895	2262	72	0	\N
76288	1397	1406846818000	4895	2262	73	0	\N
76289	1397	1406836817000	4895	2262	74	0	\N
76290	1397	1406826816000	4895	2262	75	0	\N
76291	1397	1406816815000	4895	2262	76	0	\N
76292	1397	1406806814000	4895	2262	77	0	\N
76293	1397	1406796813000	4895	2262	78	0	\N
76294	1397	1406786812000	4895	2262	79	0	\N
76295	1397	1406776811000	4895	2262	80	0	\N
76296	1397	1406766810000	4895	2262	81	0	\N
76183	1397	1405276661000	4877	2526	0	0	3356
76184	1397	1405266660000	4878	2527	0	0	3357
76191	1397	1405256659000	4881	2528	0	0	3358
76192	1397	1405246658000	4881	2528	1	0	3359
76193	1397	1405236657000	4881	2528	2	0	3360
76201	1397	1405216655000	4885	2530	0	0	3362
76204	1397	1405206654000	4887	2531	0	0	3363
76205	436	66717630000000	4887	2531	1	0	3
76206	1397	1405196653000	4888	2532	0	0	3364
76207	1829	990000000	4889	2533	0	0	1
76209	1397	1405176651000	4889	2533	2	0	3366
76210	1397	1405166650000	4890	2534	0	0	3367
76211	1397	1405156649000	4891	2535	0	0	3368
76297	1397	1406756809000	4895	2262	82	0	\N
76298	1397	1406746808000	4895	2262	83	0	\N
76299	1397	1406736807000	4895	2262	84	0	\N
76300	1397	1406726806000	4895	2262	85	0	\N
76301	1397	1406716805000	4895	2262	87	0	\N
76302	1397	1406706804000	4895	2262	88	0	\N
76303	1397	1406696803000	4895	2262	89	0	\N
76304	1397	1406686802000	4895	2262	90	0	\N
76305	1397	1406676801000	4895	2262	91	0	\N
76306	1397	1406666800000	4895	2262	92	0	\N
76307	1397	1406656799000	4895	2262	93	0	\N
76308	1397	1406646798000	4895	2262	94	0	\N
76309	1397	1406636797000	4895	2262	95	0	\N
76310	1397	1406626796000	4895	2262	96	0	\N
76311	1397	1406616795000	4895	2262	97	0	\N
76312	1397	1406606794000	4895	2262	98	0	\N
76313	1397	1406596793000	4895	2262	99	0	\N
76314	1397	1406586792000	4895	2262	100	0	\N
76315	1397	1406576791000	4895	2262	101	0	\N
76316	1397	1406566790000	4895	2262	102	0	\N
76317	1397	1406556789000	4895	2262	103	0	\N
76319	1397	1405146648000	4898	2536	0	0	\N
76321	1397	1405136647000	4901	2537	0	0	\N
76322	1397	1405126646000	4903	2538	0	0	\N
76324	1397	1405116645000	4905	2539	0	0	\N
76329	1829	0	4909	2541	0	0	\N
76330	1397	1405106644000	4909	2541	1	0	\N
76331	1397	1405096643000	4909	2541	2	0	\N
76332	1829	0	4910	2541	0	0	\N
76333	1397	1405106644000	4910	2541	1	0	\N
76334	1397	1405096643000	4910	2541	2	0	\N
76335	1829	0	4911	2541	0	0	\N
76336	1397	1405106644000	4911	2541	1	0	\N
76337	1397	1405096643000	4911	2541	2	0	\N
76338	1397	1405086642000	4912	2542	0	0	\N
76339	1397	1405086642000	4913	2542	0	0	\N
76347	1397	1405046638000	4917	2544	0	0	\N
76348	1397	1405036637000	4917	2544	1	0	\N
76350	1397	1405026636000	4919	2545	0	0	\N
76351	1397	1405026636000	4920	2545	0	0	\N
76354	1397	1405006634000	4923	2547	0	0	\N
76356	1397	1404996633000	4925	2548	0	0	\N
76358	1397	1404976631000	4927	2550	0	0	\N
76363	1397	1404936627000	4930	2552	0	0	\N
76364	1397	1404926626000	4930	2552	1	0	\N
76375	1397	1404856619000	4937	2557	0	0	\N
76377	1726	936400000000	4939	2420	0	0	\N
76378	1726	935100000000	4939	2420	1	0	\N
76379	1726	933800000000	4939	2420	2	0	\N
76380	1726	932500000000	4939	2420	3	0	\N
76381	1726	931200000000	4939	2420	4	0	\N
76382	1726	929900000000	4939	2420	5	0	\N
76383	1726	928600000000	4939	2420	6	0	\N
76384	1726	927300000000	4939	2420	7	0	\N
76385	1726	926000000000	4939	2420	8	0	\N
76386	1726	924700000000	4939	2420	9	0	\N
76387	1726	923400000000	4939	2420	10	0	\N
76388	436	66718640000000	4939	2420	11	0	\N
76389	542	66000988890000	4939	2420	12	0	\N
76390	1805	190000000	4939	2420	13	0	\N
76391	1693	3199221551364	4939	2420	14	0	\N
76392	1693	3199111551364	4939	2420	15	0	\N
76393	436	66717630000000	4939	2420	16	0	\N
76395	1397	1404836617000	4941	2559	0	0	\N
76398	1397	1404826616000	4944	2560	0	0	\N
76399	1397	1404816615000	4945	2561	0	0	\N
76400	1397	1404816615000	4946	2561	0	0	\N
76402	1397	1404806614000	4948	2562	0	0	\N
76412	1397	1404716605000	4954	2567	0	0	\N
76416	1397	1404686602000	4958	2570	0	0	\N
76421	1397	1404656599000	4961	2572	0	0	\N
76422	1397	1404646598000	4961	2572	1	0	\N
76425	1397	1404656599000	4963	2572	0	0	\N
76426	1397	1404646598000	4963	2572	1	0	\N
76430	1397	1404626596000	4966	2574	0	0	\N
76431	1397	1404616595000	4966	2574	1	0	\N
76323	1397	1405126646000	4904	2538	0	0	3371
76325	1397	1405116645000	4906	2539	0	0	3372
76326	1829	0	4908	2541	0	0	2
76327	1397	1405106644000	4908	2541	1	0	3373
76328	1397	1405096643000	4908	2541	2	0	3374
76341	1726	924700000000	4915	2543	0	0	58
76342	1397	1405076641000	4915	2543	1	0	3376
76343	1397	1405066640000	4915	2543	2	0	3377
76344	1397	1405056639000	4915	2543	3	0	3378
76345	1397	1405046638000	4916	2544	0	0	3379
76349	1397	1405026636000	4918	2545	0	0	3381
76352	1397	1405016635000	4921	2546	0	0	3382
76353	1397	1405006634000	4922	2547	0	0	3383
76355	1397	1404996633000	4924	2548	0	0	3384
76359	1397	1404976631000	4928	2550	0	0	3386
76360	1397	1404966630000	4929	2551	0	0	3387
76361	1397	1404956629000	4929	2551	1	0	3388
76362	1397	1404946628000	4929	2551	2	0	3389
76365	1397	1404936627000	4931	2552	0	0	3390
76367	1397	1404916625000	4932	2553	0	0	3392
76368	1397	1404906624000	4932	2553	1	0	3393
76369	1397	1404896623000	4932	2553	2	0	3394
76370	1726	923400000000	4933	2554	0	0	59
76371	1397	1404886622000	4933	2554	1	0	3395
76373	1397	1404876621000	4934	2555	1	0	3396
76374	1397	1404866620000	4936	2556	0	0	3397
76376	1397	1404856619000	4938	2557	0	0	3398
76394	1397	1404846618000	4940	2558	0	0	3399
76397	1397	1404826616000	4943	2560	0	0	3401
76401	1397	1404816615000	4947	2561	0	0	3402
76403	1397	1404806614000	4949	2562	0	0	3403
76404	1397	1404796613000	4950	2563	0	0	3404
76405	1397	1404786612000	4950	2563	1	0	3405
76407	1397	1404766610000	4950	2563	3	0	3407
76408	1397	1404756609000	4950	2563	4	0	3408
76409	1397	1404746608000	4951	2564	0	0	3409
76410	1397	1404736607000	4952	2565	0	0	3410
76411	1397	1404726606000	4953	2566	0	0	3411
76414	1397	1404706604000	4956	2568	0	0	3413
76415	1397	1404696603000	4957	2569	0	0	3414
76417	1397	1404686602000	4959	2570	0	0	3415
76418	1726	922100000000	4960	2571	0	0	60
76420	1397	1404666600000	4960	2571	2	0	3417
76423	1397	1404656599000	4962	2572	0	0	3418
76424	1397	1404646598000	4962	2572	1	0	3419
76427	1397	1404636597000	4964	2573	0	0	3420
76428	1397	1404626596000	4965	2574	0	0	3421
76432	1397	1404606594000	4967	2575	0	0	3423
76434	1397	1404586592000	4969	2577	0	0	\N
76435	1397	1404576591000	4969	2577	1	0	\N
76438	1397	1404566590000	4971	2578	0	0	\N
76439	1397	1404566590000	4972	2578	0	0	\N
76444	1397	1404536587000	4976	2581	0	0	\N
76445	1397	1404526586000	4976	2581	1	0	\N
76446	1397	1404516585000	4976	2581	2	0	\N
76450	1397	1404536587000	4978	2581	0	0	\N
76451	1397	1404526586000	4978	2581	1	0	\N
76452	1397	1404516585000	4978	2581	2	0	\N
76453	1834	90000000	4979	2582	0	0	\N
76454	1397	1404506584000	4979	2582	1	0	\N
76455	1397	1404496583000	4979	2582	2	0	\N
76456	1397	1404486582000	4979	2582	3	0	\N
76461	1834	90000000	4981	2582	0	0	\N
76462	1397	1404506584000	4981	2582	1	0	\N
76463	1397	1404496583000	4981	2582	2	0	\N
76464	1397	1404486582000	4981	2582	3	0	\N
76466	1397	1404476581000	4983	2583	0	0	\N
76470	1397	1404466580000	4985	2584	0	0	\N
76471	1397	1404456579000	4985	2584	1	0	\N
76472	1397	1404446578000	4985	2584	2	0	\N
76473	1397	1404466580000	4986	2584	0	0	\N
76474	1397	1404456579000	4986	2584	1	0	\N
76475	1397	1404446578000	4986	2584	2	0	\N
76476	1397	1404466580000	4987	2584	0	0	\N
76477	1397	1404456579000	4987	2584	1	0	\N
76478	1397	1404446578000	4987	2584	2	0	\N
76482	1397	1404406574000	4990	2587	0	0	\N
76484	1397	1404406574000	4992	2587	0	0	\N
76490	1726	920800000000	4995	2589	0	0	\N
76491	1397	1404386572000	4995	2589	1	0	\N
76492	1397	1404376571000	4995	2589	2	0	\N
76493	1397	1404366570000	4995	2589	3	0	\N
76498	1397	1404326566000	4998	2592	0	0	\N
76501	1397	1404316565000	5001	2593	0	0	\N
76502	1397	1404306564000	5002	2594	0	0	\N
76504	1397	1404306564000	5004	2594	0	0	\N
76505	1397	1404306564000	5005	2594	0	0	\N
76506	1397	1404306564000	5006	2594	0	0	\N
76509	1726	919500000000	5008	2595	0	0	\N
76510	1397	1404296563000	5008	2595	1	0	\N
76513	1397	1404266560000	5011	2598	0	0	\N
76527	1726	918200000000	5022	2608	0	0	\N
76528	1397	1404136547000	5022	2608	1	0	\N
76532	1397	1404126546000	5025	2609	0	0	\N
76533	1397	1404126546000	5026	2609	0	0	\N
76534	1397	1404126546000	5027	2609	0	0	\N
76536	1397	1404116545000	5030	2610	0	0	\N
76538	1397	1404106544000	5032	2611	0	0	\N
76540	1397	1404096543000	5034	2612	0	0	\N
76541	1397	1404096543000	5035	2612	0	0	\N
76542	1397	1404096543000	5036	2612	0	0	\N
76543	1397	1404086542000	5037	2613	0	0	\N
76544	1397	1404076541000	5037	2613	1	0	\N
76547	1397	1404066540000	5039	2614	0	0	\N
76548	1397	1404056539000	5039	2614	1	0	\N
76551	1397	1404046538000	5041	2615	0	0	\N
76552	1397	1404046538000	5042	2615	0	0	\N
76553	1397	1404046538000	5043	2615	0	0	\N
76554	1397	1404066540000	5044	2614	0	0	\N
76555	1397	1404056539000	5044	2614	1	0	\N
76556	1397	1404046538000	5044	2614	2	0	\N
76437	1397	1404576591000	4970	2577	1	0	3426
76440	1397	1404566590000	4973	2578	0	0	3427
76441	1834	100000000	4974	2579	0	0	1
76442	1397	1404556589000	4974	2579	1	0	3428
76443	1397	1404546588000	4975	2580	0	0	3429
76448	1397	1404526586000	4977	2581	1	0	3431
76449	1397	1404516585000	4977	2581	2	0	3432
76457	1834	90000000	4980	2582	0	0	2
76458	1397	1404506584000	4980	2582	1	0	3433
76459	1397	1404496583000	4980	2582	2	0	3434
76465	1397	1404476581000	4982	2583	0	0	3436
76467	1397	1404466580000	4984	2584	0	0	3437
76468	1397	1404456579000	4984	2584	1	0	3438
76469	1397	1404446578000	4984	2584	2	0	3439
76480	1397	1404426576000	4989	2586	0	0	3441
76481	1397	1404416575000	4989	2586	1	0	3442
76483	1397	1404406574000	4991	2587	0	0	3443
76485	1397	1404396573000	4993	2588	0	0	3444
76486	1726	920800000000	4994	2589	0	0	61
76488	1397	1404376571000	4994	2589	2	0	3446
76489	1397	1404366570000	4994	2589	3	0	3447
76494	1397	1404356569000	4996	2590	0	0	3448
76495	1803	0	4997	2591	0	0	2
76496	1397	1404346568000	4997	2591	1	0	3449
76499	1397	1404326566000	4999	2592	0	0	3451
76500	1397	1404316565000	5000	2593	0	0	3452
76503	1397	1404306564000	5003	2594	0	0	3453
76507	1726	919500000000	5007	2595	0	0	62
76511	1397	1404286562000	5009	2596	0	0	3455
76512	1397	1404276561000	5010	2597	0	0	3456
76514	1397	1404266560000	5012	2598	0	0	3457
76515	1397	1404256559000	5013	2599	0	0	3458
76516	1397	1404246558000	5014	2600	0	0	3459
76518	1397	1404226556000	5016	2602	0	0	3461
76519	1397	1404216555000	5017	2603	0	0	3462
76520	1397	1404206554000	5017	2603	1	0	3463
76521	1397	1404196553000	5018	2604	0	0	3464
76522	1397	1404186552000	5019	2605	0	0	3465
76524	1397	1404166550000	5020	2606	0	0	3467
76525	1397	1404156549000	5021	2607	0	0	3468
76526	1397	1404146548000	5021	2607	1	0	3469
76529	1726	918200000000	5023	2608	0	0	63
76531	1397	1404126546000	5024	2609	0	0	3471
76535	1397	1404116545000	5029	2610	0	0	3472
76537	1397	1404106544000	5031	2611	0	0	3473
76539	1397	1404096543000	5033	2612	0	0	3474
76545	1397	1404086542000	5038	2613	0	0	3475
76549	1397	1404066540000	5040	2614	0	0	3477
76550	1397	1404056539000	5040	2614	1	0	3478
76557	1397	1404046538000	5046	2616	0	0	3479
76558	1397	1404036537000	5046	2616	1	0	3480
76559	1397	1404026536000	5047	2617	0	0	3481
76561	1397	1404006534000	5048	2618	1	0	3483
76562	1397	1403996533000	5048	2618	2	0	3484
76563	1397	1403986532000	5048	2618	3	0	3485
76564	1397	1403976531000	5049	2619	0	0	3486
76566	1693	3919041551364	5051	2621	0	0	346
76567	1397	1403956529000	5051	2621	1	0	3488
76568	1397	1403946528000	5051	2621	2	0	3489
76570	1397	1403926526000	5053	2623	0	0	\N
76572	1397	1403936527000	5055	2622	0	0	\N
76574	1397	1403906524000	5058	2625	0	0	\N
76575	1397	1403906524000	5059	2625	0	0	\N
76578	1397	1403886522000	5062	2627	0	0	\N
76579	1397	1403886522000	5063	2627	0	0	\N
76581	1397	1403886522000	5065	2627	0	0	\N
76584	1397	1403856519000	5067	2629	0	0	\N
76586	1397	1403856519000	5069	2629	0	0	\N
76587	1397	1403876521000	5070	2628	0	0	\N
76588	1397	1403866520000	5070	2628	1	0	\N
76589	1397	1403856519000	5070	2628	2	0	\N
76592	1397	1403836517000	5073	2631	0	0	\N
76601	1397	1403756509000	5078	2636	0	0	\N
76602	1769	2946900000	5078	2636	1	0	\N
76603	1397	1403756509000	5079	2636	0	0	\N
76604	1769	2946900000	5079	2636	1	0	\N
76605	1397	1403756509000	5080	2636	0	0	\N
76606	1769	2946900000	5080	2636	1	0	\N
76608	1769	2946900000	5082	2636	0	0	\N
76612	1397	1403736507000	5085	2639	0	0	\N
76613	1397	1403726506000	5085	2639	1	0	\N
76614	1397	1403736507000	5086	2639	0	0	\N
76615	1397	1403726506000	5086	2639	1	0	\N
76619	1397	1403706504000	5089	2641	0	0	\N
76620	1397	1403696503000	5089	2641	1	0	\N
76621	1397	1403706504000	5090	2641	0	0	\N
76622	1397	1403696503000	5090	2641	1	0	\N
76629	1397	1403646498000	5095	2645	0	0	\N
76630	1397	1403636497000	5095	2645	1	0	\N
76640	1397	1403576491000	5102	2649	0	0	\N
76641	1397	1403576491000	5103	2649	0	0	\N
76642	1397	1403566490000	5104	2650	0	0	\N
76643	1397	1403566490000	5105	2650	0	0	\N
76647	1397	1403536487000	5109	2653	0	0	\N
76648	1397	1403536487000	5110	2653	0	0	\N
76650	1397	1403526486000	5112	2654	0	0	\N
76652	1397	1403526486000	5114	2654	0	0	\N
76653	1397	1403526486000	5115	2654	0	0	\N
76654	1397	1403516485000	5115	2654	1	0	\N
76655	1397	1403516485000	5116	2655	0	0	\N
76656	1397	1403516485000	5117	2655	0	0	\N
76657	1397	1403516485000	5119	2655	0	0	\N
76658	1397	1403506484000	5119	2655	1	0	\N
76659	1397	1403516485000	5120	2656	0	0	\N
76660	1397	1403506484000	5120	2656	1	0	\N
76663	1397	1403496483000	5122	2657	0	0	\N
76664	1397	1403486482000	5122	2657	1	0	\N
76670	1397	1403446478000	5125	2659	0	0	\N
76671	1397	1403436477000	5125	2659	1	0	\N
76672	1397	1403446478000	5126	2659	0	0	\N
76673	1397	1403436477000	5126	2659	1	0	\N
76674	1397	1403446478000	5127	2659	0	0	\N
76675	1397	1403436477000	5127	2659	1	0	\N
76676	1397	1403446478000	5128	2659	0	0	\N
76677	1397	1403436477000	5128	2659	1	0	\N
76678	1397	1403446478000	5129	2659	0	0	\N
76679	1397	1403436477000	5129	2659	1	0	\N
76683	1397	1403426476000	5132	2660	0	0	\N
76684	1397	1403416475000	5132	2660	1	0	\N
76685	1397	1403406474000	5132	2660	2	0	\N
76686	1397	1403416475000	5133	2661	0	0	\N
76687	1397	1403406474000	5133	2661	1	0	\N
76688	1397	1403396473000	5133	2661	2	0	\N
76689	1397	1403386472000	5133	2661	3	0	\N
76696	1397	1403376471000	5136	2662	0	0	\N
76699	1726	916900000000	5138	2663	0	0	\N
76700	1397	1403356469000	5138	2663	1	0	\N
76701	1726	916900000000	5139	2663	0	0	\N
76702	1397	1403356469000	5139	2663	1	0	\N
76703	1726	916900000000	5140	2663	0	0	\N
76704	1397	1403356469000	5140	2663	1	0	\N
76573	1397	1403916525000	5056	2624	0	0	3492
76576	1397	1403906524000	5060	2625	0	0	3493
76577	1397	1403896523000	5061	2626	0	0	3494
76580	1397	1403886522000	5064	2627	0	0	3495
76582	1397	1403876521000	5066	2628	0	0	3496
76585	1397	1403856519000	5068	2629	0	0	3498
76590	1397	1403846518000	5071	2630	0	0	3499
76591	1397	1403836517000	5072	2631	0	0	3500
76593	1397	1403826516000	5074	2632	0	0	3501
76594	1397	1403816515000	5075	2633	0	0	3502
76596	1397	1403806514000	5075	2633	2	0	3503
76597	1397	1403796513000	5075	2633	3	0	3504
76598	1397	1403786512000	5076	2634	0	0	3505
76599	1397	1403776511000	5076	2634	1	0	3506
76607	1769	2946900000	5081	2636	0	0	14
76609	1397	1403756509000	5083	2637	0	0	3508
76610	872	109739593307813	5084	2638	0	0	1
76611	1397	1403746508000	5084	2638	1	0	3509
76616	1397	1403736507000	5087	2639	0	0	3510
76618	1397	1403716505000	5088	2640	0	0	3512
76623	1397	1403706504000	5091	2641	0	0	3513
76624	1397	1403696503000	5091	2641	1	0	3514
76625	1397	1403686502000	5092	2642	0	0	3515
76626	1397	1403676501000	5093	2643	0	0	3516
76628	1397	1403656499000	5094	2644	1	0	3518
76631	1397	1403646498000	5096	2645	0	0	3519
76632	1397	1403636497000	5096	2645	1	0	3520
76633	1397	1403626496000	5098	2646	0	0	3521
76635	1397	1403606494000	5098	2646	2	0	3523
76636	1397	1403596493000	5099	2647	0	0	3524
76637	649	66000090000000	5100	2648	0	0	1
76638	1397	1403586492000	5100	2648	1	0	3525
76639	1397	1403576491000	5101	2649	0	0	3526
76645	1397	1403556489000	5107	2651	0	0	3528
76646	1397	1403546488000	5108	2652	0	0	3529
76649	1397	1403536487000	5111	2653	0	0	3530
76651	1397	1403526486000	5113	2654	0	0	3531
76661	1397	1403516485000	5121	2656	0	0	3532
76665	1397	1403496483000	5123	2657	0	0	3534
76666	1397	1403486482000	5123	2657	1	0	3535
76667	1397	1403476481000	5124	2658	0	0	3536
76668	1397	1403466480000	5124	2658	1	0	3537
76680	1397	1403446478000	5130	2659	0	0	3539
76681	1397	1403436477000	5130	2659	1	0	3540
76682	1397	1403426476000	5131	2660	0	0	3541
76690	1397	1403416475000	5134	2661	0	0	3542
76691	1397	1403406474000	5134	2661	1	0	3543
76693	1397	1403386472000	5134	2661	3	0	3545
76694	1397	1403376471000	5135	2662	0	0	3546
76695	1397	1403366470000	5135	2662	1	0	3547
76697	1726	916900000000	5137	2663	0	0	64
76698	1397	1403356469000	5137	2663	1	0	3548
76705	1726	916900000000	5141	2663	0	0	\N
76706	1397	1403356469000	5141	2663	1	0	\N
76715	1397	1403276461000	5147	2669	0	0	\N
76717	1397	1403266460000	5149	2670	0	0	\N
76718	1397	1403256459000	5149	2670	1	0	\N
76722	1397	1403246458000	5152	2671	0	0	\N
76730	1397	1403166450000	5159	2678	0	0	\N
76731	1397	1403166450000	5160	2678	0	0	\N
76732	1397	1403166450000	5161	2678	0	0	\N
76735	1397	1403156449000	5164	2679	0	0	\N
76741	1397	1403106444000	5169	2683	0	0	\N
76746	1397	1403056439000	5175	2687	0	0	\N
76747	1397	1403046438000	5175	2687	1	0	\N
76748	1397	1403056439000	5176	2687	0	0	\N
76749	1397	1403046438000	5176	2687	1	0	\N
76750	1397	1403056439000	5178	2688	0	0	\N
76751	1397	1403046438000	5178	2688	1	0	\N
76752	1397	1403036437000	5178	2688	2	0	\N
76753	1397	1403056439000	5179	2689	0	0	\N
76754	1397	1403046438000	5179	2689	1	0	\N
76755	1397	1403036437000	5179	2689	2	0	\N
76756	1397	1403026436000	5179	2689	3	0	\N
76757	1397	1403016435000	5179	2689	4	0	\N
76770	1397	1402946428000	5187	2695	0	0	\N
76776	1397	1402886422000	5191	2699	0	0	\N
76780	1397	1402866420000	5195	2701	0	0	\N
76782	1397	1402856419000	5197	2702	0	0	\N
76788	1397	1402826416000	5201	2705	0	0	\N
76789	1397	1402816415000	5201	2705	1	0	\N
76790	1397	1402826416000	5202	2705	0	0	\N
76791	1397	1402816415000	5202	2705	1	0	\N
76793	1397	1402796413000	5204	2707	0	0	\N
76804	1397	1402706404000	5218	2714	0	0	\N
76805	1397	1402696403000	5218	2714	1	0	\N
76806	1397	1402706404000	5219	2714	0	0	\N
76807	1397	1402696403000	5219	2714	1	0	\N
76808	1397	1402706404000	5220	2714	0	0	\N
76809	1397	1402696403000	5220	2714	1	0	\N
76813	1397	1402686402000	5223	2715	0	0	\N
76814	1397	1402676401000	5224	2716	0	0	\N
76816	1397	1402676401000	5226	2716	0	0	\N
76819	1397	1402646398000	5229	2719	0	0	\N
76820	1397	1402636397000	5229	2719	1	0	\N
76821	1397	1402646398000	5230	2719	0	0	\N
76822	1397	1402636397000	5230	2719	1	0	\N
76825	1397	1402626396000	5237	2720	0	0	\N
76826	1397	1402616395000	5237	2720	1	0	\N
76827	1397	1402606394000	5237	2720	2	0	\N
76828	1397	1402626396000	5238	2720	0	0	\N
76829	1397	1402616395000	5238	2720	1	0	\N
76830	1397	1402606394000	5238	2720	2	0	\N
76834	1397	1402626396000	5241	2720	0	0	\N
76835	1397	1402616395000	5241	2720	1	0	\N
76836	1397	1402606394000	5241	2720	2	0	\N
76839	1397	1402586392000	5246	2722	0	0	\N
76709	1397	1403326466000	5143	2665	0	0	3551
76710	1397	1403316465000	5143	2665	1	0	3552
76711	1397	1403306464000	5144	2666	0	0	3553
76712	1397	1403296463000	5145	2667	0	0	3554
76713	510	66719990000000	5145	2667	1	0	1
76716	1397	1403276461000	5148	2669	0	0	3556
76719	1397	1403266460000	5150	2670	0	0	3557
76720	1397	1403256459000	5150	2670	1	0	3558
76721	1397	1403246458000	5151	2671	0	0	3559
76723	1397	1403236457000	5153	2672	0	0	3560
76725	1397	1403216455000	5155	2674	0	0	3562
76726	1397	1403206454000	5156	2675	0	0	3563
76727	1397	1403196453000	5157	2676	0	0	3564
76728	1397	1403186452000	5157	2676	1	0	3565
76733	1397	1403166450000	5162	2678	0	0	3567
76734	1397	1403156449000	5163	2679	0	0	3568
76736	1397	1403146448000	5165	2680	0	0	3569
76737	1397	1403136447000	5166	2681	0	0	3570
76738	1397	1403126446000	5166	2681	1	0	3571
76740	1397	1403106444000	5168	2683	0	0	3573
76742	1397	1403096443000	5170	2684	0	0	3574
76743	1397	1403086442000	5170	2684	1	0	3575
76744	1397	1403076441000	5170	2684	2	0	3576
76745	1397	1403066440000	5171	2685	0	0	3577
76759	1397	1403046438000	5180	2689	1	0	3579
76760	1397	1403036437000	5180	2689	2	0	3580
76761	1397	1403026436000	5180	2689	3	0	3581
76762	1397	1403016435000	5180	2689	4	0	3582
76764	1397	1402996433000	5182	2691	0	0	3584
76765	1397	1402986432000	5183	2692	0	0	3585
76766	1397	1402976431000	5183	2692	1	0	3586
76767	1397	1402966430000	5184	2693	0	0	3587
76768	1397	1402956429000	5185	2694	0	0	3588
76771	1397	1402936427000	5188	2696	0	0	3590
76772	1397	1402926426000	5188	2696	1	0	3591
76773	1397	1402916425000	5189	2697	0	0	3592
76774	1397	1402906424000	5190	2698	0	0	3593
76775	1397	1402896423000	5190	2698	1	0	3594
76778	1397	1402876421000	5193	2700	0	0	3596
76779	1397	1402866420000	5194	2701	0	0	3597
76781	1397	1402856419000	5196	2702	0	0	3598
76783	1397	1402846418000	5198	2703	0	0	3599
76785	1800	188000000	5199	2704	1	0	3
76786	1397	1402826416000	5200	2705	0	0	3601
76787	1397	1402816415000	5200	2705	1	0	3602
76792	1397	1402806414000	5203	2706	0	0	3603
76794	1397	1402796413000	5205	2707	0	0	3604
76796	1397	1402776411000	5208	2709	0	0	3606
76797	1397	1402766410000	5209	2710	0	0	3607
76798	1397	1402756409000	5209	2710	1	0	3608
76799	1726	915600000000	5215	2711	0	0	65
76800	1397	1402746408000	5215	2711	1	0	3609
76802	1397	1402726406000	5216	2712	0	0	3611
76803	1397	1402716405000	5217	2713	0	0	3612
76810	1397	1402706404000	5221	2714	0	0	3613
76811	1397	1402696403000	5221	2714	1	0	3614
76815	1397	1402676401000	5225	2716	0	0	3616
76817	1397	1402666400000	5227	2717	0	0	3617
76818	1397	1402656399000	5228	2718	0	0	3618
76823	1397	1402646398000	5231	2719	0	0	3619
76824	1397	1402636397000	5231	2719	1	0	3620
76832	1397	1402616395000	5239	2720	1	0	3622
76833	1397	1402606394000	5239	2720	2	0	3623
76837	1397	1402596393000	5244	2721	0	0	3624
76838	1397	1402586392000	5245	2722	0	0	3625
76840	1397	1402576391000	5247	2723	0	0	3626
76842	1397	1402556389000	5252	2726	0	0	\N
76843	1397	1402546388000	5252	2726	1	0	\N
76849	1397	1402516385000	5261	2730	0	0	\N
76856	1397	1402456379000	5265	2734	0	0	\N
76860	711	3002390000000	5268	2735	0	0	\N
76861	1397	1402446378000	5268	2735	1	0	\N
76864	1397	1402436377000	5270	2736	0	0	\N
76865	1397	1402426376000	5270	2736	1	0	\N
76873	1397	1402346368000	5276	2742	0	0	\N
76874	1397	1402336367000	5276	2742	1	0	\N
76877	1397	1402346368000	5278	2742	0	0	\N
76878	1397	1402336367000	5278	2742	1	0	\N
76879	1397	1402346368000	5279	2742	0	0	\N
76880	1397	1402336367000	5279	2742	1	0	\N
76881	1397	1402326366000	5280	2743	0	0	\N
76883	1397	1402326366000	5282	2743	0	0	\N
76884	1397	1402326366000	5283	2743	0	0	\N
76888	1397	1402286362000	5287	2747	0	0	\N
76889	1397	1402276361000	5287	2747	1	0	\N
76892	1397	1402266360000	5289	2748	0	0	\N
76894	1397	1402256359000	5291	2749	0	0	\N
76895	1397	1402256359000	5292	2749	0	0	\N
76899	1397	1402226356000	5296	2752	0	0	\N
76901	1397	1402226356000	5298	2752	0	0	\N
76902	1397	1402216355000	5299	2753	0	0	\N
76903	1397	1402206354000	5299	2753	1	0	\N
76907	1397	1402186352000	5302	2755	0	0	\N
76914	1397	1402136347000	5307	2759	0	0	\N
76919	1397	1402096343000	5311	2762	0	0	\N
76920	1397	1402096343000	5312	2762	0	0	\N
76922	1397	1402086342000	5314	2763	0	0	\N
76923	1397	1402086342000	5315	2763	0	0	\N
76925	1397	1402076341000	5317	2764	0	0	\N
76926	1397	1402076341000	5318	2764	0	0	\N
76928	1397	1402076341000	5320	2764	0	0	\N
76929	1397	1402076341000	5321	2764	0	0	\N
76931	1397	1402066340000	5323	2765	0	0	\N
76932	1397	1402066340000	5324	2765	0	0	\N
76933	1726	916900000000	5325	2656	0	0	\N
76934	1726	915600000000	5325	2656	1	0	\N
76935	1397	1403506484000	5325	2656	2	0	\N
76936	711	3002390000000	5325	2656	3	0	\N
76937	1800	188000000	5325	2656	4	0	\N
76938	458	66002390000000	5325	2656	5	0	\N
76939	1397	1403496483000	5325	2656	6	0	\N
76940	1397	1403486482000	5325	2656	7	0	\N
76941	1397	1403476481000	5325	2656	8	0	\N
76942	1397	1403466480000	5325	2656	9	0	\N
76943	510	66719990000000	5325	2656	10	0	\N
76944	1397	1403456479000	5325	2656	11	0	\N
76945	1397	1403446478000	5325	2656	12	0	\N
76946	1397	1403436477000	5325	2656	13	0	\N
76947	1397	1403426476000	5325	2656	14	0	\N
76948	1397	1403416475000	5325	2656	15	0	\N
76949	1397	1403406474000	5325	2656	16	0	\N
76950	1397	1403396473000	5325	2656	17	0	\N
76951	1397	1403386472000	5325	2656	18	0	\N
76952	1397	1403376471000	5325	2656	19	0	\N
76953	1397	1403366470000	5325	2656	20	0	\N
76954	1397	1403356469000	5325	2656	21	0	\N
76955	1397	1403346468000	5325	2656	22	0	\N
76956	1397	1403336467000	5325	2656	23	0	\N
76957	1397	1403326466000	5325	2656	24	0	\N
76958	1397	1403316465000	5325	2656	25	0	\N
76959	1397	1403306464000	5325	2656	26	0	\N
76960	1397	1403296463000	5325	2656	27	0	\N
76961	1397	1403286462000	5325	2656	28	0	\N
76962	1397	1403276461000	5325	2656	29	0	\N
76963	1397	1403266460000	5325	2656	30	0	\N
76964	1397	1403256459000	5325	2656	31	0	\N
76965	1397	1403246458000	5325	2656	32	0	\N
76966	1397	1403236457000	5325	2656	33	0	\N
76967	1397	1403226456000	5325	2656	34	0	\N
76968	1397	1403216455000	5325	2656	35	0	\N
76969	1397	1403206454000	5325	2656	36	0	\N
76970	1397	1403196453000	5325	2656	37	0	\N
76971	1397	1403186452000	5325	2656	38	0	\N
76972	1397	1403176451000	5325	2656	39	0	\N
76973	1397	1403166450000	5325	2656	40	0	\N
76974	1397	1403156449000	5325	2656	41	0	\N
76975	1397	1403146448000	5325	2656	42	0	\N
76976	1397	1403136447000	5325	2656	43	0	\N
76845	1397	1402546388000	5253	2726	1	0	3629
76846	1397	1402536387000	5256	2728	0	0	3630
76847	1397	1402526386000	5256	2728	1	0	3631
76848	1397	1402516385000	5260	2730	0	0	3632
76850	1397	1402506384000	5262	2731	0	0	3633
76852	1397	1402486382000	5263	2732	0	0	3635
76853	1397	1402476381000	5263	2732	1	0	3636
76854	1397	1402466380000	5264	2733	0	0	3637
76855	458	66002390000000	5264	2733	1	0	1
76857	1397	1402456379000	5266	2734	0	0	3638
76859	1397	1402446378000	5267	2735	1	0	3639
76862	1397	1402436377000	5269	2736	0	0	3640
76863	1397	1402426376000	5269	2736	1	0	3641
76866	1397	1402416375000	5271	2737	0	0	3642
76868	1397	1402396373000	5272	2738	1	0	3644
76869	1397	1402386372000	5273	2739	0	0	3645
76870	1397	1402376371000	5273	2739	1	0	3646
76871	1397	1402366370000	5274	2740	0	0	3647
76872	1397	1402356369000	5275	2741	0	0	3648
76876	1397	1402336367000	5277	2742	1	0	3650
76882	1397	1402326366000	5281	2743	0	0	3651
76885	1397	1402316365000	5284	2744	0	0	3652
76886	1397	1402306364000	5285	2745	0	0	3653
76887	1397	1402296363000	5286	2746	0	0	3654
76891	1397	1402276361000	5288	2747	1	0	3656
76893	1397	1402266360000	5290	2748	0	0	3657
76896	1397	1402256359000	5293	2749	0	0	3658
76897	1397	1402246358000	5294	2750	0	0	3659
76900	1397	1402226356000	5297	2752	0	0	3661
76904	1397	1402216355000	5300	2753	0	0	3662
76905	1397	1402206354000	5300	2753	1	0	3663
76906	1397	1402196353000	5301	2754	0	0	3664
76908	1397	1402186352000	5303	2755	0	0	3665
76910	1397	1402166350000	5305	2757	0	0	3667
76911	1397	1402156349000	5305	2757	1	0	3668
76912	1397	1402146348000	5306	2758	0	0	3669
76913	1639	718019000000	5306	2758	1	0	1
76915	1397	1402136347000	5308	2759	0	0	3670
76917	1397	1402116345000	5310	2761	0	0	3672
76918	1397	1402106344000	5310	2761	1	0	3673
76921	1397	1402096343000	5313	2762	0	0	3674
76924	1397	1402086342000	5316	2763	0	0	3675
76930	1397	1402066340000	5322	2765	0	0	3677
76977	1397	1403126446000	5325	2656	44	0	\N
76978	1397	1403116445000	5325	2656	45	0	\N
76979	1397	1403106444000	5325	2656	46	0	\N
76980	1397	1403096443000	5325	2656	47	0	\N
76981	1397	1403086442000	5325	2656	48	0	\N
76982	1397	1403076441000	5325	2656	49	0	\N
76983	1397	1403066440000	5325	2656	50	0	\N
76984	1397	1403056439000	5325	2656	51	0	\N
76985	1397	1403046438000	5325	2656	52	0	\N
76986	1397	1403036437000	5325	2656	53	0	\N
76987	1397	1403026436000	5325	2656	54	0	\N
76988	1397	1403016435000	5325	2656	55	0	\N
76989	1397	1403006434000	5325	2656	56	0	\N
76990	1397	1402996433000	5325	2656	57	0	\N
76991	1397	1402986432000	5325	2656	58	0	\N
76992	1397	1402976431000	5325	2656	59	0	\N
76993	1397	1402966430000	5325	2656	60	0	\N
76994	1397	1402956429000	5325	2656	61	0	\N
76995	1397	1402946428000	5325	2656	62	0	\N
76996	1397	1402936427000	5325	2656	63	0	\N
76997	1397	1402926426000	5325	2656	64	0	\N
76998	1397	1402916425000	5325	2656	65	0	\N
76999	1397	1402906424000	5325	2656	66	0	\N
77000	1397	1402896423000	5325	2656	67	0	\N
77001	1397	1402886422000	5325	2656	68	0	\N
77002	1397	1402876421000	5325	2656	69	0	\N
77003	1397	1402866420000	5325	2656	70	0	\N
77004	1397	1402856419000	5325	2656	71	0	\N
77005	1397	1402846418000	5325	2656	72	0	\N
77006	1397	1402836417000	5325	2656	73	0	\N
77007	1397	1402826416000	5325	2656	74	0	\N
77008	1397	1402816415000	5325	2656	75	0	\N
77009	1397	1402806414000	5325	2656	76	0	\N
77010	1397	1402796413000	5325	2656	77	0	\N
77011	1397	1402786412000	5325	2656	78	0	\N
77012	1397	1402776411000	5325	2656	79	0	\N
77013	1397	1402766410000	5325	2656	80	0	\N
77014	1397	1402756409000	5325	2656	81	0	\N
77015	1397	1402746408000	5325	2656	82	0	\N
77016	1397	1402736407000	5325	2656	83	0	\N
77017	1397	1402726406000	5325	2656	84	0	\N
77018	1397	1402716405000	5325	2656	85	0	\N
77019	1397	1402706404000	5325	2656	86	0	\N
77020	1397	1402696403000	5325	2656	87	0	\N
77021	1397	1402686402000	5325	2656	88	0	\N
77022	1397	1402676401000	5325	2656	89	0	\N
77023	1397	1402666400000	5325	2656	90	0	\N
77024	1397	1402656399000	5325	2656	91	0	\N
77025	1397	1402646398000	5325	2656	92	0	\N
77026	1397	1402636397000	5325	2656	93	0	\N
77027	1397	1402626396000	5325	2656	94	0	\N
77028	1397	1402616395000	5325	2656	95	0	\N
77029	1397	1402606394000	5325	2656	96	0	\N
77030	1397	1402596393000	5325	2656	97	0	\N
77031	1397	1402586392000	5325	2656	98	0	\N
77032	1397	1402576391000	5325	2656	99	0	\N
77033	1397	1402566390000	5325	2656	100	0	\N
77034	1397	1402556389000	5325	2656	101	0	\N
77035	1397	1402546388000	5325	2656	102	0	\N
77036	1397	1402536387000	5325	2656	103	0	\N
77037	1397	1402526386000	5325	2656	104	0	\N
77039	1397	1402056339000	5327	2766	0	0	\N
77040	1397	1402056339000	5328	2766	0	0	\N
77041	1397	1402046338000	5329	2767	0	0	\N
77042	1397	1402046338000	5330	2767	0	0	\N
77043	1397	1402046338000	5331	2767	0	0	\N
77046	1397	1402026336000	5334	2769	0	0	\N
77047	1397	1402026336000	5335	2769	0	0	\N
77049	1397	1402026336000	5337	2769	0	0	\N
77050	1397	1402026336000	5338	2769	0	0	\N
77052	1397	1402016335000	5340	2770	0	0	\N
77055	1397	1402006334000	5343	2771	0	0	\N
77056	1397	1401996333000	5343	2771	1	0	\N
77057	1397	1401986332000	5343	2771	2	0	\N
77058	1397	1401976331000	5343	2771	3	0	\N
77063	1397	1401956329000	5346	2774	0	0	\N
77066	1397	1401926326000	5350	2777	0	0	\N
77070	1397	1401896323000	5354	2780	0	0	\N
77071	1397	1401896323000	5355	2780	0	0	\N
77075	1397	1401866320000	5358	2782	0	0	\N
77079	1397	1402056339000	5361	2766	0	0	\N
77080	1397	1402046338000	5361	2766	1	0	\N
77081	1397	1402036337000	5361	2766	2	0	\N
77082	1397	1402026336000	5361	2766	3	0	\N
77083	1397	1402016335000	5361	2766	4	0	\N
77084	1397	1402006334000	5361	2766	5	0	\N
77085	1397	1401996333000	5361	2766	6	0	\N
77086	1397	1401986332000	5361	2766	7	0	\N
77087	1397	1401976331000	5361	2766	8	0	\N
77088	1397	1401966330000	5361	2766	9	0	\N
77089	1397	1401956329000	5361	2766	10	0	\N
77090	1397	1401946328000	5361	2766	11	0	\N
77091	1397	1401936327000	5361	2766	12	0	\N
77092	1397	1401926326000	5361	2766	13	0	\N
77093	1397	1401916325000	5361	2766	14	0	\N
77094	1397	1401906324000	5361	2766	15	0	\N
77095	1397	1401896323000	5361	2766	16	0	\N
77096	1397	1401886322000	5361	2766	17	0	\N
77097	1397	1401876321000	5361	2766	18	0	\N
77098	1397	1401866320000	5361	2766	19	0	\N
77099	1397	1401856319000	5361	2766	20	0	\N
77100	1397	1401846318000	5361	2766	21	0	\N
77106	1397	1401786312000	5365	2787	0	0	\N
77045	1397	1402036337000	5333	2768	0	0	3680
77048	1397	1402026336000	5336	2769	0	0	3681
77051	1397	1402016335000	5339	2770	0	0	3682
77053	1397	1402006334000	5341	2771	0	0	3683
77054	1397	1401996333000	5342	2772	0	0	3684
77060	1397	1401976331000	5344	2773	1	0	3686
77061	1397	1401966330000	5344	2773	2	0	3687
77062	1397	1401956329000	5345	2774	0	0	3688
77064	1397	1401946328000	5347	2775	0	0	3689
77065	1397	1401936327000	5348	2776	0	0	3690
77068	1397	1401916325000	5352	2778	0	0	3692
77069	1397	1401906324000	5353	2779	0	0	3693
77072	1397	1401896323000	5356	2780	0	0	3694
77073	1397	1401886322000	5357	2781	0	0	3695
77076	1397	1401866320000	5359	2782	0	0	3697
77077	1397	1401856319000	5360	2783	0	0	3698
77078	1397	1401846318000	5360	2783	1	0	3699
77101	1397	1401836317000	5362	2784	0	0	3700
77102	1397	1401826316000	5362	2784	1	0	3701
77104	1397	1401806314000	5364	2786	0	0	3703
77105	1397	1401796313000	5364	2786	1	0	3704
77107	1397	1401786312000	5366	2787	0	0	3705
77108	1397	1401776311000	5367	2788	0	0	3706
77109	1397	1401766310000	5367	2788	1	0	3707
77111	1397	1401746308000	5369	2790	0	0	3709
77112	1397	1401736307000	5369	2790	1	0	3710
77114	1840	899000000	5380	2799	0	0	\N
77117	1397	1401836317000	5414	2767	0	0	\N
77118	1397	1401826316000	5414	2767	1	0	\N
77119	1397	1401816315000	5414	2767	2	0	\N
77120	1397	1401806314000	5414	2767	3	0	\N
77121	1397	1401796313000	5414	2767	4	0	\N
77122	1397	1401786312000	5414	2767	5	0	\N
77123	1397	1401776311000	5414	2767	6	0	\N
77124	1397	1401766310000	5414	2767	7	0	\N
77125	1397	1401756309000	5414	2767	8	0	\N
77126	1397	1401746308000	5414	2767	9	0	\N
77127	1397	1401736307000	5414	2767	10	0	\N
77128	1840	899000000	5414	2767	11	0	\N
77129	1639	716118000000	5414	2767	12	0	\N
77130	1840	8000000	5415	2818	0	0	\N
77132	1840	898000000	5418	2805	0	0	\N
77133	1639	716118000000	5418	2805	1	0	\N
77135	1840	898000000	5432	2813	0	0	\N
77136	1840	897000000	5432	2813	1	0	\N
77137	1639	716118000000	5432	2813	2	0	\N
77138	1639	0	5439	2831	0	0	\N
77139	1639	0	5440	2831	0	0	\N
77140	1639	0	5441	2831	0	0	\N
77143	1750	4195000000	5450	2836	0	0	\N
77144	1397	1402716405000	5453	2713	0	0	\N
77145	1397	1402706404000	5453	2713	1	0	\N
77146	1397	1402696403000	5453	2713	2	0	\N
77147	1397	1402686402000	5453	2713	3	0	\N
77148	1397	1402676401000	5453	2713	4	0	\N
77149	1397	1402666400000	5453	2713	5	0	\N
77150	1397	1402656399000	5453	2713	6	0	\N
77151	1397	1402646398000	5453	2713	7	0	\N
77152	1397	1402636397000	5453	2713	8	0	\N
77153	1397	1402626396000	5453	2713	9	0	\N
77154	1397	1402616395000	5453	2713	10	0	\N
77155	1397	1402606394000	5453	2713	11	0	\N
77156	1397	1402596393000	5453	2713	12	0	\N
77157	1397	1402586392000	5453	2713	13	0	\N
77158	1397	1402576391000	5453	2713	14	0	\N
77159	1397	1402566390000	5453	2713	15	0	\N
77160	1397	1402556389000	5453	2713	16	0	\N
77161	1397	1402546388000	5453	2713	17	0	\N
77162	1397	1402536387000	5453	2713	18	0	\N
77163	1397	1402526386000	5453	2713	19	0	\N
77164	1397	1402516385000	5453	2713	20	0	\N
77165	1397	1402506384000	5453	2713	21	0	\N
77166	1397	1402496383000	5453	2713	22	0	\N
77167	1397	1402486382000	5453	2713	23	0	\N
77168	1397	1402476381000	5453	2713	24	0	\N
77169	1397	1402466380000	5453	2713	25	0	\N
77170	1397	1402456379000	5453	2713	26	0	\N
77171	1397	1402446378000	5453	2713	27	0	\N
77172	1397	1402436377000	5453	2713	28	0	\N
77173	1397	1402426376000	5453	2713	29	0	\N
77174	1397	1402416375000	5453	2713	30	0	\N
77175	1397	1402406374000	5453	2713	31	0	\N
77176	1397	1402396373000	5453	2713	32	0	\N
77177	1397	1402386372000	5453	2713	33	0	\N
77178	1397	1402376371000	5453	2713	34	0	\N
77179	1397	1402366370000	5453	2713	35	0	\N
77180	1397	1402356369000	5453	2713	36	0	\N
77181	1397	1402346368000	5453	2713	37	0	\N
77182	1397	1402336367000	5453	2713	38	0	\N
77183	1726	914300000000	5457	2840	0	0	\N
77184	1726	913000000000	5457	2840	1	0	\N
77185	1726	911700000000	5457	2840	2	0	\N
77186	1726	910400000000	5457	2840	3	0	\N
77187	1726	909100000000	5457	2840	4	0	\N
77188	1726	907800000000	5457	2840	5	0	\N
77189	1726	906500000000	5457	2840	6	0	\N
77199	1802	0	5512	2868	0	0	\N
77201	1726	915600000000	5514	2708	0	0	\N
77202	1726	914300000000	5514	2708	1	0	\N
77203	1726	913000000000	5514	2708	2	0	\N
77204	1726	911700000000	5514	2708	3	0	\N
77205	1726	910400000000	5514	2708	4	0	\N
77206	1726	909100000000	5514	2708	5	0	\N
77207	1726	907800000000	5514	2708	6	0	\N
77208	1726	906500000000	5514	2708	7	0	\N
77209	1726	905200000000	5514	2708	8	0	\N
77210	711	3002390000000	5514	2708	9	0	\N
77211	458	66002390000000	5514	2708	10	0	\N
77212	1397	1402786412000	5514	2708	11	0	\N
77213	1397	1402776411000	5514	2708	12	0	\N
77214	1802	0	5514	2708	13	0	\N
77215	1397	1402766410000	5514	2708	14	0	\N
77216	1397	1402756409000	5514	2708	15	0	\N
77217	1397	1402746408000	5514	2708	16	0	\N
77218	1397	1402736407000	5514	2708	17	0	\N
77219	1397	1402726406000	5514	2708	18	0	\N
77220	1397	1402716405000	5514	2708	19	0	\N
77221	1397	1402706404000	5514	2708	20	0	\N
77222	1397	1402696403000	5514	2708	21	0	\N
77223	1397	1402686402000	5514	2708	22	0	\N
77224	1397	1402676401000	5514	2708	23	0	\N
77225	1397	1402666400000	5514	2708	24	0	\N
77226	1397	1402656399000	5514	2708	25	0	\N
77227	1397	1402646398000	5514	2708	26	0	\N
77228	1397	1402636397000	5514	2708	27	0	\N
77229	1397	1402626396000	5514	2708	28	0	\N
77230	1397	1402616395000	5514	2708	29	0	\N
77231	1397	1402606394000	5514	2708	30	0	\N
77232	1397	1402596393000	5514	2708	31	0	\N
77233	1397	1402586392000	5514	2708	32	0	\N
77234	1397	1402576391000	5514	2708	33	0	\N
77235	1397	1402566390000	5514	2708	34	0	\N
77236	1397	1402556389000	5514	2708	35	0	\N
77237	1397	1402546388000	5514	2708	36	0	\N
77238	1397	1402536387000	5514	2708	37	0	\N
77239	1397	1402526386000	5514	2708	38	0	\N
77240	1397	1402516385000	5514	2708	39	0	\N
77241	1397	1402506384000	5514	2708	40	0	\N
77242	1397	1402496383000	5514	2708	41	0	\N
77243	1397	1402486382000	5514	2708	42	0	\N
77244	1397	1402476381000	5514	2708	43	0	\N
77245	1397	1402466380000	5514	2708	44	0	\N
77246	1397	1402456379000	5514	2708	45	0	\N
77247	1397	1402446378000	5514	2708	46	0	\N
77248	1397	1402436377000	5514	2708	47	0	\N
77116	1841	899000000	5410	2815	0	0	1
77131	1840	8000000	5416	2818	0	0	2
77134	1840	0	5422	2820	0	0	3
77141	1639	0	5442	2831	0	0	3
77142	1750	4195000000	5449	2836	0	0	5
77191	1726	913000000000	5458	2840	1	0	67
77192	1726	911700000000	5458	2840	2	0	68
77193	1726	910400000000	5458	2840	3	0	69
77194	1726	909100000000	5458	2840	4	0	70
77195	1726	907800000000	5458	2840	5	0	71
77197	1769	2945900000	5459	2841	0	0	15
77198	1726	905200000000	5504	2863	0	0	73
77200	1802	0	5513	2868	0	0	1
77249	1397	1402426376000	5514	2708	48	0	\N
77250	1397	1402416375000	5514	2708	49	0	\N
77251	1397	1402406374000	5514	2708	50	0	\N
77252	1397	1402396373000	5514	2708	51	0	\N
77253	1397	1402386372000	5514	2708	52	0	\N
77254	1397	1402376371000	5514	2708	53	0	\N
77255	1397	1402366370000	5514	2708	54	0	\N
77256	1397	1402356369000	5514	2708	55	0	\N
77257	1397	1402346368000	5514	2708	56	0	\N
77259	240	66001100000000	5540	2880	0	0	\N
77260	240	66001100000000	5560	2869	0	0	\N
77261	240	66001100000000	5570	2877	0	0	\N
77262	1726	914300000000	5596	2837	0	0	\N
77263	240	66001100000000	5596	2837	1	0	\N
77264	1726	913000000000	5596	2837	2	0	\N
77265	1726	911700000000	5596	2837	3	0	\N
77266	1726	910400000000	5596	2837	4	0	\N
77267	1726	909100000000	5596	2837	5	0	\N
77268	1726	907800000000	5596	2837	6	0	\N
77269	1726	906500000000	5596	2837	7	0	\N
77270	1726	905200000000	5596	2837	8	0	\N
77271	1802	0	5596	2837	9	0	\N
77272	1769	2945900000	5596	2837	10	0	\N
77273	1562	990000000	5630	2925	0	0	\N
77275	1726	914300000000	5656	2814	0	0	\N
77276	240	66001100000000	5656	2814	1	0	\N
77277	1726	913000000000	5656	2814	2	0	\N
77278	1726	911700000000	5656	2814	3	0	\N
77279	1726	910400000000	5656	2814	4	0	\N
77280	1726	909100000000	5656	2814	5	0	\N
77281	1726	907800000000	5656	2814	6	0	\N
77282	1726	906500000000	5656	2814	7	0	\N
77283	1726	905200000000	5656	2814	8	0	\N
77284	1802	0	5656	2814	9	0	\N
77285	1750	4195000000	5656	2814	10	0	\N
77286	1769	2945900000	5656	2814	12	0	\N
77287	1726	914300000000	5678	2830	0	0	\N
77288	240	66001100000000	5678	2830	1	0	\N
77289	1726	913000000000	5678	2830	2	0	\N
77290	1726	911700000000	5678	2830	3	0	\N
77291	1726	910400000000	5678	2830	4	0	\N
77292	1726	909100000000	5678	2830	5	0	\N
77293	1726	907800000000	5678	2830	6	0	\N
77294	1726	906500000000	5678	2830	7	0	\N
77295	1726	905200000000	5678	2830	8	0	\N
77296	1802	0	5678	2830	9	0	\N
77297	1750	4195000000	5678	2830	10	0	\N
77298	1769	2945900000	5678	2830	11	0	\N
77299	1639	0	5678	2830	12	0	\N
77302	1682	1441000000	5681	2945	0	0	\N
77303	1682	1441000000	5682	2945	0	0	\N
77304	1682	1441000000	5683	2945	0	0	\N
77306	1702	6474091000000	5700	2955	0	0	\N
77308	1726	903900000000	5714	2838	0	0	\N
77309	1682	8625451000000	5714	2838	1	0	\N
77310	1682	1441000000	5714	2838	2	0	\N
77311	1702	6474091000000	5714	2838	3	0	\N
77312	1844	1300000000	5716	2964	0	0	\N
77313	1844	1200000000	5716	2964	1	0	\N
77316	1844	1300000000	5718	2964	0	0	\N
77317	1844	1200000000	5718	2964	1	0	\N
77318	1843	100000000	5726	2967	0	0	\N
77320	1397	1401726306000	5739	2974	0	0	\N
77323	1397	1401716305000	5742	2975	0	0	\N
77330	1397	1401656299000	5749	2980	0	0	\N
77331	1397	1401646298000	5750	2981	0	0	\N
77334	1397	1401626296000	5753	2983	0	0	\N
77335	1397	1401616295000	5753	2983	1	0	\N
77336	1397	1401606294000	5753	2983	2	0	\N
77342	1397	1401586292000	5758	2985	0	0	\N
77345	1397	1401576291000	5760	2986	0	0	\N
77346	1397	1401566290000	5760	2986	1	0	\N
77350	1397	1401526286000	5763	2989	0	0	\N
77351	1397	1401516285000	5763	2989	1	0	\N
77352	1397	1401506284000	5763	2989	2	0	\N
77362	1397	1401446278000	5769	2992	0	0	\N
77363	1397	1401436277000	5770	2993	0	0	\N
77381	1843	100000000	5783	2945	0	0	\N
77382	1844	1300000000	5783	2945	1	0	\N
77383	1844	1200000000	5783	2945	2	0	\N
77384	1726	903900000000	5783	2945	3	0	\N
77300	1682	8625451000000	5679	2944	0	0	5
77301	1682	1441000000	5680	2945	0	0	6
77305	1702	6474091000000	5699	2955	0	0	2
77307	1726	903900000000	5710	2961	0	0	74
77314	1844	1300000000	5717	2964	0	0	1
77319	1843	100000000	5727	2967	0	0	1
77321	1397	1401726306000	5740	2974	0	0	3711
77322	1397	1401716305000	5741	2975	0	0	3712
77324	1397	1401706304000	5744	2976	0	0	3713
77325	1397	1401696303000	5744	2976	1	0	3714
77327	1397	1401676301000	5746	2978	0	0	3716
77328	1397	1401666300000	5747	2979	0	0	3717
77329	1397	1401656299000	5748	2980	0	0	3718
77332	1397	1401646298000	5751	2981	0	0	3719
77337	1397	1401626296000	5754	2983	0	0	3721
77338	1397	1401616295000	5754	2983	1	0	3722
77339	1397	1401606294000	5754	2983	2	0	3723
77340	1397	1401596293000	5756	2984	0	0	3724
77341	1397	1401586292000	5757	2985	0	0	3725
77344	1397	1401566290000	5759	2986	1	0	3727
77347	1397	1401556289000	5761	2987	0	0	3728
77348	1397	1401546288000	5762	2988	0	0	3729
77349	1397	1401536287000	5762	2988	1	0	3730
77353	1397	1401526286000	5764	2989	0	0	3731
77355	1397	1401506284000	5764	2989	2	0	3733
77356	1397	1401496283000	5765	2990	0	0	3734
77357	1397	1401486282000	5765	2990	1	0	3735
77358	1397	1401476281000	5765	2990	2	0	3736
77360	1397	1401456279000	5766	2991	1	0	3738
77361	1397	1401446278000	5768	2992	0	0	3739
77364	1397	1401436277000	5771	2993	0	0	3740
77365	1397	1401426276000	5774	2994	0	0	3741
77366	1397	1401416275000	5774	2994	1	0	3742
77368	1397	1401396273000	5775	2995	1	0	3744
77369	1397	1401386272000	5777	2996	0	0	3745
77370	1397	1401376271000	5777	2996	1	0	3746
77371	1397	1401366270000	5777	2996	2	0	3747
77372	1397	1401356269000	5777	2996	3	0	3748
77374	1397	1401336267000	5778	2997	1	0	3750
77375	1397	1401326266000	5779	2998	0	0	3751
77376	1397	1401316265000	5780	2999	0	0	3752
77377	1397	1401306264000	5780	2999	1	0	3753
77379	1397	1401286262000	5782	3001	0	0	3755
77380	1397	1401276261000	5782	3001	1	0	3756
77385	1397	1401726306000	5783	2945	4	0	\N
77386	1397	1401716305000	5783	2945	5	0	\N
77387	1397	1401706304000	5783	2945	6	0	\N
77388	1397	1401696303000	5783	2945	7	0	\N
77389	1397	1401686302000	5783	2945	8	0	\N
77390	1397	1401676301000	5783	2945	9	0	\N
77391	1397	1401666300000	5783	2945	10	0	\N
77392	1397	1401656299000	5783	2945	11	0	\N
77393	1397	1401646298000	5783	2945	12	0	\N
77394	1397	1401636297000	5783	2945	13	0	\N
77395	1397	1401626296000	5783	2945	14	0	\N
77396	1397	1401616295000	5783	2945	15	0	\N
77397	1397	1401606294000	5783	2945	16	0	\N
77398	1397	1401596293000	5783	2945	17	0	\N
77399	1397	1401586292000	5783	2945	18	0	\N
77400	1397	1401576291000	5783	2945	19	0	\N
77401	1397	1401566290000	5783	2945	20	0	\N
77402	1682	1441000000	5783	2945	21	0	\N
77403	1702	6474091000000	5783	2945	22	0	\N
77404	1397	1401556289000	5783	2945	23	0	\N
77405	1397	1401546288000	5783	2945	24	0	\N
77406	1397	1401536287000	5783	2945	25	0	\N
77407	1397	1401526286000	5783	2945	26	0	\N
77408	1397	1401516285000	5783	2945	27	0	\N
77409	1397	1401506284000	5783	2945	28	0	\N
77410	1397	1401496283000	5783	2945	29	0	\N
77411	1397	1401486282000	5783	2945	30	0	\N
77412	1397	1401476281000	5783	2945	31	0	\N
77413	1397	1401466280000	5783	2945	32	0	\N
77414	1397	1401456279000	5783	2945	33	0	\N
77415	1397	1401446278000	5783	2945	34	0	\N
77416	1397	1401436277000	5783	2945	35	0	\N
77417	1397	1401426276000	5783	2945	36	0	\N
77418	1397	1401416275000	5783	2945	37	0	\N
77419	1397	1401406274000	5783	2945	38	0	\N
77420	1397	1401396273000	5783	2945	39	0	\N
77421	1397	1401386272000	5783	2945	40	0	\N
77422	1397	1401376271000	5783	2945	41	0	\N
77423	1397	1401366270000	5783	2945	42	0	\N
77424	1397	1401356269000	5783	2945	43	0	\N
77425	1397	1401346268000	5783	2945	44	0	\N
77426	1397	1401336267000	5783	2945	45	0	\N
77427	1397	1401326266000	5783	2945	46	0	\N
77428	1397	1401316265000	5783	2945	47	0	\N
77429	1397	1401306264000	5783	2945	48	0	\N
77430	1397	1401296263000	5783	2945	49	0	\N
77431	1397	1401286262000	5783	2945	50	0	\N
77432	1397	1401276261000	5783	2945	51	0	\N
77433	1397	1401266260000	5783	2945	52	0	\N
77434	1397	1401256259000	5783	2945	53	0	\N
77437	1726	902600000000	5785	3003	0	0	\N
77438	1726	901300000000	5785	3003	1	0	\N
77439	1397	1401246258000	5785	3003	2	0	\N
77440	1726	902600000000	5787	3003	0	0	\N
77441	1726	901300000000	5787	3003	1	0	\N
77442	1397	1401246258000	5787	3003	2	0	\N
77446	1726	902600000000	5789	3003	0	0	\N
77447	1726	901300000000	5789	3003	1	0	\N
77448	1397	1401246258000	5789	3003	2	0	\N
77449	1397	1401236257000	5790	3004	0	0	\N
77454	1397	1401216255000	5795	3006	0	0	\N
77455	1397	1401206254000	5795	3006	1	0	\N
77456	1397	1401216255000	5796	3006	0	0	\N
77457	1397	1401206254000	5796	3006	1	0	\N
77459	1397	1401186252000	5798	3008	0	0	\N
77460	1397	1401176251000	5798	3008	1	0	\N
77465	1397	1401146248000	5801	3010	0	0	\N
77471	1397	1401096243000	5808	3014	0	0	\N
77473	1397	1401096243000	5810	3014	0	0	\N
77474	1397	1401086242000	5811	3015	0	0	\N
77475	1397	1401076241000	5811	3015	1	0	\N
77482	1397	1401026236000	5816	3019	0	0	\N
77483	1397	1401016235000	5816	3019	1	0	\N
77487	1397	1400996233000	5820	3021	0	0	\N
77488	1397	1400996233000	5821	3021	0	0	\N
77490	1397	1400986232000	5823	3022	0	0	\N
77491	1397	1400986232000	5824	3022	0	0	\N
77493	1397	1400986232000	5826	3022	0	0	\N
77494	1397	1400976231000	5827	3023	0	0	\N
77500	1397	1400936227000	5832	3026	0	0	\N
77502	1397	1400916225000	5834	3028	0	0	\N
77504	1726	900000000000	5836	3029	0	0	\N
77505	1726	898700000000	5836	3029	2	0	\N
77506	1397	1400906224000	5836	3029	3	0	\N
77507	1397	1400896223000	5836	3029	4	0	\N
77508	1726	900000000000	5837	3029	0	0	\N
77509	1726	898700000000	5837	3029	2	0	\N
77510	1397	1400906224000	5837	3029	3	0	\N
77511	1397	1400896223000	5837	3029	4	0	\N
77516	1726	900000000000	5839	3029	0	0	\N
77517	1726	898700000000	5839	3029	2	0	\N
77518	1397	1400906224000	5839	3029	3	0	\N
77519	1397	1400896223000	5839	3029	4	0	\N
77520	1726	900000000000	5840	3029	0	0	\N
77443	1726	902600000000	5788	3003	0	0	75
77444	1726	901300000000	5788	3003	1	0	76
77445	1397	1401246258000	5788	3003	2	0	3759
77450	1397	1401236257000	5791	3004	0	0	3760
77451	1397	1401226256000	5793	3005	0	0	3761
77453	1397	1401206254000	5794	3006	1	0	3763
77458	1397	1401196253000	5797	3007	0	0	3764
77461	1397	1401186252000	5799	3008	0	0	3765
77462	1397	1401176251000	5799	3008	1	0	3766
77463	1397	1401166250000	5800	3009	0	0	3767
77466	1397	1401146248000	5802	3010	0	0	3769
77467	1397	1401136247000	5803	3011	0	0	3770
77468	1397	1401126246000	5805	3012	0	0	3771
77469	1397	1401116245000	5805	3012	1	0	3772
77472	1397	1401096243000	5809	3014	0	0	3774
77476	1397	1401086242000	5812	3015	0	0	3775
77477	1397	1401076241000	5812	3015	1	0	3776
77478	1397	1401066240000	5813	3016	0	0	3777
77479	1397	1401056239000	5814	3017	0	0	3778
77481	1397	1401036237000	5815	3018	1	0	3780
77484	1397	1401026236000	5817	3019	0	0	3781
77485	1397	1401016235000	5817	3019	1	0	3782
77486	1397	1401006234000	5818	3020	0	0	3783
77489	1397	1400996233000	5822	3021	0	0	3784
77495	1397	1400976231000	5828	3023	0	0	3786
77496	1397	1400966230000	5829	3024	0	0	3787
77497	1397	1400956229000	5829	3024	1	0	3788
77498	1397	1400946228000	5830	3025	0	0	3789
77501	1397	1400926226000	5833	3027	0	0	3791
77503	1397	1400916225000	5835	3028	0	0	3792
77512	1726	900000000000	5838	3029	0	0	77
77513	1726	898700000000	5838	3029	2	0	78
77514	1397	1400906224000	5838	3029	3	0	3793
77521	1726	898700000000	5840	3029	2	0	\N
77522	1397	1400906224000	5840	3029	3	0	\N
77523	1397	1400896223000	5840	3029	4	0	\N
77528	1397	1400876221000	5843	3031	0	0	\N
77529	1397	1400866220000	5843	3031	1	0	\N
77530	1397	1400856219000	5843	3031	2	0	\N
77532	1397	1400846218000	5845	3032	0	0	\N
77533	1397	1400836217000	5846	3033	0	0	\N
77535	1397	1400836217000	5848	3033	0	0	\N
77538	1397	1400816215000	5851	3035	0	0	\N
77543	1397	1400776211000	5855	3038	0	0	\N
77546	1397	1400746208000	5863	3040	0	0	\N
77547	1397	1400736207000	5863	3040	1	0	\N
77548	1397	1400746208000	5864	3040	0	0	\N
77549	1397	1400736207000	5864	3040	1	0	\N
77552	1726	902600000000	5866	2946	0	0	\N
77553	1726	901300000000	5866	2946	1	0	\N
77554	1726	900000000000	5866	2946	2	0	\N
77555	1726	898700000000	5866	2946	3	0	\N
77556	1397	1401246258000	5866	2946	4	0	\N
77557	1397	1401236257000	5866	2946	5	0	\N
77558	1397	1401226256000	5866	2946	6	0	\N
77559	1397	1401216255000	5866	2946	7	0	\N
77560	1397	1401206254000	5866	2946	8	0	\N
77561	1397	1401196253000	5866	2946	9	0	\N
77562	1397	1401186252000	5866	2946	10	0	\N
77563	1397	1401176251000	5866	2946	11	0	\N
77564	1397	1401166250000	5866	2946	12	0	\N
77565	1397	1401156249000	5866	2946	13	0	\N
77566	1397	1401146248000	5866	2946	14	0	\N
77567	1397	1401136247000	5866	2946	15	0	\N
77568	1397	1401126246000	5866	2946	16	0	\N
77569	1397	1401116245000	5866	2946	17	0	\N
77570	1397	1401106244000	5866	2946	18	0	\N
77571	1397	1401096243000	5866	2946	19	0	\N
77572	1397	1401086242000	5866	2946	20	0	\N
77573	1397	1401076241000	5866	2946	21	0	\N
77574	1397	1401066240000	5866	2946	22	0	\N
77575	1397	1401056239000	5866	2946	23	0	\N
77576	1397	1401046238000	5866	2946	24	0	\N
77577	1397	1401036237000	5866	2946	25	0	\N
77578	1397	1401026236000	5866	2946	26	0	\N
77579	1397	1401016235000	5866	2946	27	0	\N
77580	1397	1401006234000	5866	2946	28	0	\N
77581	1397	1400996233000	5866	2946	29	0	\N
77582	1397	1400986232000	5866	2946	30	0	\N
77583	1397	1400976231000	5866	2946	31	0	\N
77584	1397	1400966230000	5866	2946	32	0	\N
77585	1397	1400956229000	5866	2946	33	0	\N
77586	1397	1400946228000	5866	2946	34	0	\N
77587	1397	1400936227000	5866	2946	35	0	\N
77588	1397	1400926226000	5866	2946	36	0	\N
77589	1397	1400916225000	5866	2946	37	0	\N
77590	1397	1400906224000	5866	2946	38	0	\N
77591	1397	1400896223000	5866	2946	39	0	\N
77592	1397	1400886222000	5866	2946	40	0	\N
77593	1397	1400876221000	5866	2946	41	0	\N
77594	1397	1400866220000	5866	2946	42	0	\N
77595	1397	1400856219000	5866	2946	43	0	\N
77596	1397	1400846218000	5866	2946	44	0	\N
77597	1397	1400836217000	5866	2946	45	0	\N
77598	1397	1400826216000	5866	2946	46	0	\N
77599	1397	1400816215000	5866	2946	47	0	\N
77600	1397	1400806214000	5866	2946	48	0	\N
77601	1397	1400796213000	5866	2946	49	0	\N
77602	1397	1400786212000	5866	2946	50	0	\N
77603	1397	1400776211000	5866	2946	51	0	\N
77604	1397	1400766210000	5866	2946	53	0	\N
77605	1397	1400756209000	5866	2946	54	0	\N
77606	1397	1400746208000	5866	2946	55	0	\N
77607	1397	1400746208000	5867	3040	0	0	\N
77608	1397	1400736207000	5867	3040	1	0	\N
77609	1397	1400726206000	5868	3041	0	0	\N
77610	1397	1400716205000	5868	3041	1	0	\N
77611	1397	1400706204000	5868	3041	2	0	\N
77620	1397	1400646198000	5873	3045	0	0	\N
77621	1397	1400636197000	5873	3045	1	0	\N
77625	1397	1400616195000	5876	3047	0	0	\N
77626	1397	1400616195000	5877	3047	0	0	\N
77630	1397	1400606194000	5880	3048	0	0	\N
77631	1397	1400596193000	5880	3048	1	0	\N
77641	1397	1400576191000	5892	3054	0	0	\N
77642	1397	1400566190000	5892	3054	1	0	\N
77643	1397	1400556189000	5892	3054	2	0	\N
77644	1397	1400546188000	5892	3054	3	0	\N
77645	1397	1400536187000	5892	3054	4	0	\N
77646	1397	1400576191000	5893	3054	0	0	\N
77647	1397	1400566190000	5893	3054	1	0	\N
77648	1397	1400556189000	5893	3054	2	0	\N
77649	1397	1400546188000	5893	3054	3	0	\N
77650	1397	1400536187000	5893	3054	4	0	\N
77651	1397	1400526186000	5894	3055	0	0	\N
77526	1397	1400866220000	5842	3031	1	0	3797
77527	1397	1400856219000	5842	3031	2	0	3798
77531	1397	1400846218000	5844	3032	0	0	3799
77534	1397	1400836217000	5847	3033	0	0	3800
77536	1397	1400826216000	5849	3034	0	0	3801
77539	1397	1400806214000	5852	3036	0	0	3803
77540	1397	1400796213000	5853	3037	0	0	3804
77541	1397	1400786212000	5853	3037	1	0	3805
77542	1397	1400776211000	5854	3038	0	0	3806
77544	1397	1400766210000	5857	3039	0	0	3807
77550	1397	1400746208000	5865	3040	0	0	3809
77551	1397	1400736207000	5865	3040	1	0	3810
77612	1397	1400726206000	5869	3041	0	0	3811
77613	1397	1400716205000	5869	3041	1	0	3812
77615	1397	1400696203000	5870	3042	0	0	3814
77616	1397	1400686202000	5870	3042	1	0	3815
77617	1397	1400676201000	5871	3043	0	0	3816
77618	1397	1400666200000	5872	3044	0	0	3817
77619	1397	1400656199000	5872	3044	1	0	3818
77623	1397	1400636197000	5874	3045	1	0	3820
77624	1397	1400626196000	5875	3046	0	0	3821
77627	1397	1400616195000	5878	3047	0	0	3822
77628	1397	1400606194000	5879	3048	0	0	3823
77629	1397	1400596193000	5879	3048	1	0	3824
77633	1726	897400000000	5884	3051	0	0	79
77634	1726	896100000000	5884	3051	1	0	80
77635	1726	894800000000	5884	3051	2	0	81
77636	1397	1400576191000	5891	3054	0	0	3826
77638	1397	1400556189000	5891	3054	2	0	3828
77639	1397	1400546188000	5891	3054	3	0	3829
77640	1397	1400536187000	5891	3054	4	0	3830
77652	1397	1400526186000	5895	3055	0	0	3831
77653	1397	1400516185000	5896	3056	0	0	3832
77655	1397	1400496183000	5896	3056	2	0	3834
77656	1397	1400486182000	5896	3056	3	0	3835
77659	1397	1400456179000	5898	3058	0	0	\N
77660	1397	1400456179000	5899	3058	0	0	\N
77664	1397	1400436177000	5903	3060	0	0	\N
77665	1397	1400426176000	5904	3061	0	0	\N
77667	1397	1400426176000	5907	3061	0	0	\N
77671	1397	1400386172000	5910	3064	0	0	\N
77675	1397	1400356169000	5915	3067	0	0	\N
77676	1397	1400346168000	5915	3067	1	0	\N
77677	1397	1400336167000	5915	3067	2	0	\N
77681	1397	1400356169000	5917	3067	0	0	\N
77682	1397	1400346168000	5917	3067	1	0	\N
77683	1397	1400336167000	5917	3067	2	0	\N
77684	1397	1400356169000	5918	3067	0	0	\N
77685	1397	1400346168000	5918	3067	1	0	\N
77686	1397	1400336167000	5918	3067	2	0	\N
77687	1397	1400356169000	5919	3067	0	0	\N
77688	1397	1400346168000	5919	3067	1	0	\N
77689	1397	1400336167000	5919	3067	2	0	\N
77691	1397	1400326166000	5921	3068	0	0	\N
77692	1397	1400326166000	5922	3068	0	0	\N
77693	1397	1400326166000	5923	3068	0	0	\N
77696	1397	1400306164000	5926	3070	0	0	\N
77697	1397	1400306164000	5927	3070	0	0	\N
77698	1397	1400296163000	5928	3071	0	0	\N
77699	1397	1400286162000	5928	3071	1	0	\N
77700	1397	1400296163000	5929	3071	0	0	\N
77701	1397	1400286162000	5929	3071	1	0	\N
77707	1397	1400526186000	5933	3055	0	0	\N
77708	1397	1400516185000	5933	3055	1	0	\N
77709	1397	1400506184000	5933	3055	2	0	\N
77710	1397	1400496183000	5933	3055	3	0	\N
77711	1397	1400486182000	5933	3055	4	0	\N
77712	1397	1400476181000	5933	3055	5	0	\N
77713	1397	1400466180000	5933	3055	6	0	\N
77714	1397	1400456179000	5933	3055	7	0	\N
77715	1397	1400446178000	5933	3055	8	0	\N
77716	1397	1400436177000	5933	3055	9	0	\N
77717	1397	1400426176000	5933	3055	10	0	\N
77718	1397	1400416175000	5933	3055	11	0	\N
77719	1397	1400406174000	5933	3055	12	0	\N
77720	1397	1400396173000	5933	3055	13	0	\N
77721	1397	1400386172000	5933	3055	14	0	\N
77722	1397	1400376171000	5933	3055	15	0	\N
77723	1397	1400366170000	5933	3055	16	0	\N
77724	1397	1400356169000	5933	3055	17	0	\N
77725	1397	1400346168000	5933	3055	18	0	\N
77726	1397	1400336167000	5933	3055	19	0	\N
77727	1397	1400326166000	5933	3055	20	0	\N
77728	1397	1400316165000	5933	3055	21	0	\N
77729	1397	1400306164000	5933	3055	22	0	\N
77730	1397	1400296163000	5933	3055	23	0	\N
77731	1397	1400286162000	5933	3055	24	0	\N
77732	1397	1400276161000	5933	3055	25	0	\N
77733	1397	1400266160000	5933	3055	26	0	\N
77734	1397	1400256159000	5933	3055	27	0	\N
77735	1397	1400246158000	5934	3074	0	0	\N
77736	1397	1400246158000	5935	3074	0	0	\N
77744	1397	1400206154000	5941	3078	0	0	\N
77745	1397	1400196153000	5941	3078	1	0	\N
77746	1397	1400186152000	5941	3078	2	0	\N
77747	1397	1400206154000	5942	3078	0	0	\N
77748	1397	1400196153000	5942	3078	1	0	\N
77749	1397	1400186152000	5942	3078	2	0	\N
77754	1397	1400136147000	5946	3082	0	0	\N
77755	1397	1400126146000	5946	3082	1	0	\N
77758	1397	1400116145000	5948	3083	0	0	\N
77761	1397	1400106144000	5951	3084	0	0	\N
77762	1397	1400106144000	5952	3084	0	0	\N
77768	1397	1400056139000	5957	3088	0	0	\N
77779	1397	1399986132000	5963	3093	0	0	\N
77780	1397	1399986132000	5964	3093	0	0	\N
77781	1397	1399986132000	5965	3093	0	0	\N
77785	1397	1399966130000	5968	3095	0	0	\N
77786	1397	1399956129000	5968	3095	1	0	\N
77789	1397	1399926126000	5970	3097	0	0	\N
77790	1397	1399916125000	5970	3097	1	0	\N
77661	1397	1400456179000	5900	3058	0	0	3838
77662	1397	1400446178000	5901	3059	0	0	3839
77663	1397	1400436177000	5902	3060	0	0	3840
77666	1397	1400426176000	5905	3061	0	0	3841
77668	1397	1400416175000	5908	3062	0	0	3842
77670	1397	1400396173000	5909	3063	0	0	3844
77672	1397	1400386172000	5911	3064	0	0	3845
77673	1397	1400376171000	5913	3065	0	0	3846
77674	1397	1400366170000	5914	3066	0	0	3847
77678	1397	1400356169000	5916	3067	0	0	3848
77680	1397	1400336167000	5916	3067	2	0	3850
77690	1397	1400326166000	5920	3068	0	0	3851
77694	1397	1400316165000	5924	3069	0	0	3852
77695	1397	1400306164000	5925	3070	0	0	3853
77703	1397	1400286162000	5930	3071	1	0	3855
77704	1397	1400276161000	5931	3072	0	0	3856
77705	1397	1400266160000	5931	3072	1	0	3857
77706	1397	1400256159000	5932	3073	0	0	3858
77737	1397	1400246158000	5936	3074	0	0	3859
77739	1397	1400226156000	5938	3076	0	0	3861
77740	1397	1400216155000	5939	3077	0	0	3862
77741	1397	1400206154000	5940	3078	0	0	3863
77742	1397	1400196153000	5940	3078	1	0	3864
77743	1397	1400186152000	5940	3078	2	0	3865
77751	1397	1400166150000	5944	3080	0	0	3867
77752	1397	1400156149000	5945	3081	0	0	3868
77753	1397	1400146148000	5945	3081	1	0	3869
77756	1397	1400136147000	5947	3082	0	0	3870
77759	1397	1400116145000	5949	3083	0	0	3872
77760	1397	1400106144000	5950	3084	0	0	3873
77763	1397	1400096143000	5953	3085	0	0	3874
77764	1397	1400086142000	5954	3086	0	0	3875
77765	1397	1400076141000	5954	3086	1	0	3876
77767	1397	1400056139000	5956	3088	0	0	3878
77769	1397	1400046138000	5958	3089	0	0	3879
77770	1397	1400036137000	5958	3089	1	0	3880
77771	1397	1400026136000	5959	3090	0	0	3881
77772	1397	1400016135000	5959	3090	1	0	3882
77774	127	66001471816426	5959	3090	3	0	1
77775	878	203055343117107	5959	3090	4	0	2
77776	1397	1400006134000	5960	3091	0	0	3883
77777	1397	1399996133000	5961	3092	0	0	3884
77782	1397	1399976131000	5966	3094	0	0	3886
77783	1397	1399966130000	5967	3095	0	0	3887
77784	1397	1399956129000	5967	3095	1	0	3888
77787	1397	1399946128000	5969	3096	0	0	3889
77788	1397	1399936127000	5969	3096	1	0	3890
77792	1397	1399916125000	5971	3097	1	0	3892
77794	1397	1399896123000	5973	3099	0	0	\N
77798	1397	1399866120000	5977	3102	0	0	\N
77799	1397	1399866120000	5978	3102	0	0	\N
77801	1397	1399866120000	5980	3102	0	0	\N
77804	1397	1399856119000	5982	3103	0	0	\N
77805	1397	1399846118000	5982	3103	1	0	\N
77807	1397	1399826116000	5984	3105	0	0	\N
77808	1397	1399816115000	5984	3105	1	0	\N
77811	1397	1399826116000	5986	3105	0	0	\N
77812	1397	1399816115000	5986	3105	1	0	\N
77814	1397	1399806114000	5988	3106	0	0	\N
77815	1397	1399796113000	5989	3107	0	0	\N
77819	1397	1399766110000	5993	3110	0	0	\N
77820	1397	1399756109000	5993	3110	1	0	\N
77821	1397	1399766110000	5994	3110	0	0	\N
77822	1397	1399756109000	5994	3110	1	0	\N
77830	1397	1399746108000	5997	3111	0	0	\N
77831	1397	1399736107000	5997	3111	1	0	\N
77832	1397	1399726106000	5997	3111	2	0	\N
77833	1397	1399716105000	5997	3111	3	0	\N
77834	1397	1399706104000	5997	3111	4	0	\N
77836	1397	1399686102000	5999	3113	0	0	\N
77837	1665	720000000000	5999	3113	1	0	\N
77838	1665	719900000000	5999	3113	2	0	\N
77839	1397	1399676101000	5999	3113	3	0	\N
77844	1397	1399666100000	6001	3114	0	0	\N
77845	1397	1399666100000	6002	3114	0	0	\N
77848	1397	1399646098000	6005	3116	0	0	\N
77853	1397	1399616095000	6009	3118	0	0	\N
77854	1726	900000000000	6010	3010	0	0	\N
77855	1726	898700000000	6010	3010	1	0	\N
77856	1726	897400000000	6010	3010	2	0	\N
77857	1726	896100000000	6010	3010	3	0	\N
77858	1726	894800000000	6010	3010	4	0	\N
77859	1665	720000000000	6010	3010	5	0	\N
77860	1665	719900000000	6010	3010	6	0	\N
77861	877	203054343117107	6010	3010	7	0	\N
77862	127	66001471816426	6010	3010	8	0	\N
77863	878	203055343117107	6010	3010	9	0	\N
77865	1397	1399606094000	6012	3119	0	0	\N
77866	1397	1399596093000	6013	3120	0	0	\N
77867	1397	1399596093000	6014	3120	0	0	\N
77869	1397	1399586092000	6016	3121	0	0	\N
77872	1397	1399576091000	6019	3122	0	0	\N
77877	1397	1399536087000	6022	3125	0	0	\N
77878	1397	1399526086000	6022	3125	1	0	\N
77881	1397	1399536087000	6024	3125	0	0	\N
77882	1397	1399526086000	6024	3125	1	0	\N
77889	1397	1399476081000	6027	3127	0	0	\N
77890	1397	1399466080000	6028	3128	0	0	\N
77891	1397	1399456079000	6028	3128	1	0	\N
77892	1397	1399446078000	6028	3128	2	0	\N
77893	1397	1399466080000	6029	3128	0	0	\N
77894	1397	1399456079000	6029	3128	1	0	\N
77895	1397	1399446078000	6029	3128	2	0	\N
77903	1397	1399416075000	6033	3131	0	0	\N
77914	1397	1399366070000	6040	3136	0	0	\N
77921	1397	1399306064000	6045	3141	0	0	\N
77924	1397	1399296063000	6048	3142	0	0	\N
77927	1397	1399286062000	6050	3143	0	0	\N
77928	1397	1399276061000	6050	3143	1	0	\N
77796	1397	1399886122000	5975	3100	0	0	3895
77797	1397	1399876121000	5976	3101	0	0	3896
77800	1397	1399866120000	5979	3102	0	0	3897
77802	1397	1399856119000	5981	3103	0	0	3898
77803	1397	1399846118000	5981	3103	1	0	3899
77809	1397	1399826116000	5985	3105	0	0	3901
77810	1397	1399816115000	5985	3105	1	0	3902
77813	1397	1399806114000	5987	3106	0	0	3903
77816	1397	1399796113000	5990	3107	0	0	3904
77817	1397	1399786112000	5991	3108	0	0	3905
77823	1397	1399766110000	5995	3110	0	0	3907
77824	1397	1399756109000	5995	3110	1	0	3908
77825	1397	1399746108000	5996	3111	0	0	3909
77826	1397	1399736107000	5996	3111	1	0	3910
77828	1397	1399716105000	5996	3111	3	0	3912
77829	1397	1399706104000	5996	3111	4	0	3913
77835	1397	1399696103000	5998	3112	0	0	3914
77840	1397	1399686102000	6000	3113	0	0	3915
77841	1665	720000000000	6000	3113	1	0	1
77843	1397	1399676101000	6000	3113	3	0	3916
77846	1397	1399666100000	6003	3114	0	0	3917
77847	1397	1399656099000	6004	3115	0	0	3918
77849	1397	1399646098000	6006	3116	0	0	3919
77850	1397	1399636097000	6007	3117	0	0	3920
77852	1397	1399616095000	6008	3118	0	0	3922
77864	1397	1399606094000	6011	3119	0	0	3923
77868	1397	1399596093000	6015	3120	0	0	3924
77870	1397	1399586092000	6017	3121	0	0	3925
77873	1397	1399566090000	6020	3123	0	0	3927
77874	1692	43920133000000	6021	3124	0	0	1
77875	1397	1399556089000	6021	3124	1	0	3928
77876	1397	1399546088000	6021	3124	2	0	3929
77879	1397	1399536087000	6023	3125	0	0	3930
77883	1397	1399516085000	6025	3126	0	0	3932
77884	1397	1399506084000	6025	3126	1	0	3933
77885	1397	1399496083000	6025	3126	2	0	3934
77886	1397	1399486082000	6025	3126	3	0	3935
77887	1692	43919113000000	6025	3126	4	0	2
77896	1397	1399466080000	6030	3128	0	0	3937
77897	1397	1399456079000	6030	3128	1	0	3938
77898	1397	1399446078000	6030	3128	2	0	3939
77899	1692	43819093000000	6031	3129	0	0	3
77901	1665	717880000000	6031	3129	2	0	3
77902	1397	1399426076000	6032	3130	0	0	3941
77904	1397	1399416075000	6034	3131	0	0	3942
77905	1860	99000000000	6035	3132	0	0	1
77906	1397	1399406074000	6035	3132	1	0	3943
77908	1397	1399396073000	6036	3133	0	0	3944
77909	1665	870000000	6037	3134	0	0	4
77910	1397	1399386072000	6037	3134	1	0	3945
77911	1692	19083000000	6038	3135	0	0	4
77912	1397	1399376071000	6038	3135	1	0	3946
77915	1861	717990000000	6041	3137	0	0	2
77916	1397	1399356069000	6041	3137	1	0	3948
77917	1397	1399346068000	6042	3138	0	0	3949
77918	1397	1399336067000	6042	3138	1	0	3950
77920	1397	1399316065000	6044	3140	0	0	3952
77922	1397	1399306064000	6046	3141	0	0	3953
77923	1397	1399296063000	6047	3142	0	0	3954
77925	1397	1399286062000	6049	3143	0	0	3955
77926	1397	1399276061000	6049	3143	1	0	3956
77929	1665	720000000000	6051	3100	0	0	\N
77930	1665	719900000000	6051	3100	1	0	\N
77931	1692	43920133000000	6051	3100	2	0	\N
77932	1665	717880000000	6051	3100	3	0	\N
77933	1692	43919113000000	6051	3100	4	0	\N
77934	1692	43819093000000	6051	3100	5	0	\N
77935	1692	19083000000	6051	3100	6	0	\N
77937	1397	1399266060000	6053	3144	0	0	\N
77940	1397	1399246058000	6056	3146	0	0	\N
77941	1397	1399246058000	6057	3146	0	0	\N
77942	1397	1399246058000	6058	3146	0	0	\N
77947	1397	1399216055000	6061	3148	0	0	\N
77948	1397	1399206054000	6061	3148	1	0	\N
77949	1397	1399216055000	6062	3148	0	0	\N
77950	1397	1399206054000	6062	3148	1	0	\N
77951	1397	1399196053000	6063	3149	0	0	\N
77957	1397	1399176051000	6067	3151	0	0	\N
77958	1397	1399166050000	6067	3151	1	0	\N
77959	1397	1399156049000	6067	3151	2	0	\N
77963	1397	1399126046000	6070	3153	0	0	\N
77964	1397	1399126046000	6071	3153	0	0	\N
77966	1397	1399116045000	6073	3154	0	0	\N
77968	1397	1399096043000	6075	3156	0	0	\N
77969	1397	1399086042000	6075	3156	1	0	\N
77970	1397	1399096043000	6076	3156	0	0	\N
77971	1397	1399086042000	6076	3156	1	0	\N
77974	1397	1399096043000	6078	3156	0	0	\N
77975	1397	1399086042000	6078	3156	1	0	\N
77976	1397	1399076041000	6079	3157	0	0	\N
77977	1397	1399066040000	6079	3157	1	0	\N
77978	1397	1399076041000	6080	3157	0	0	\N
77981	1397	1399076041000	6082	3157	0	0	\N
77982	1397	1399066040000	6082	3157	1	0	\N
77984	1397	1399056039000	6086	3159	0	0	\N
77985	1397	1399046038000	6087	3160	0	0	\N
77988	1397	1399036037000	6090	3161	0	0	\N
77989	1397	1399026036000	6090	3161	1	0	\N
77993	1397	1399026036000	6092	3162	0	0	\N
77994	1397	1399016035000	6092	3162	1	0	\N
77995	1397	1399006034000	6092	3162	2	0	\N
77996	1397	1399026036000	6093	3162	0	0	\N
77997	1397	1399016035000	6093	3162	1	0	\N
77998	1397	1399006034000	6093	3162	2	0	\N
78002	1397	1398996033000	6095	3163	0	0	\N
78003	1397	1398986032000	6095	3163	1	0	\N
78004	1397	1398976031000	6095	3163	2	0	\N
78009	1397	1398946028000	6098	3165	0	0	\N
78010	1397	1398936027000	6098	3165	1	0	\N
78011	1397	1398946028000	6099	3165	0	0	\N
78012	1397	1398936027000	6099	3165	1	0	\N
78013	1397	1398926026000	6100	3166	0	0	\N
78015	1397	1398916025000	6102	3167	0	0	\N
78016	1397	1398916025000	6103	3167	0	0	\N
78018	1692	43920133000000	6105	3011	0	0	\N
78019	1665	717880000000	6105	3011	1	0	\N
78020	1692	43919113000000	6105	3011	2	0	\N
78021	1692	43819093000000	6105	3011	3	0	\N
78022	1692	19083000000	6105	3011	4	0	\N
78023	1397	1398916025000	6106	3167	0	0	\N
78028	42	74639120000000	6108	3168	0	0	\N
78029	1596	11409150000000	6108	3168	1	0	\N
78030	1397	1398906024000	6108	3168	2	0	\N
78031	1397	1398896023000	6108	3168	3	0	\N
78032	42	74639120000000	6109	3168	0	0	\N
78033	1596	11409150000000	6109	3168	1	0	\N
78034	1397	1398906024000	6109	3168	2	0	\N
78035	1397	1398896023000	6109	3168	3	0	\N
78036	1397	1398886022000	6110	3169	0	0	\N
78037	1397	1398886022000	6111	3169	0	0	\N
78040	1397	1398876021000	6114	3170	0	0	\N
78042	1397	1398866020000	6116	3171	0	0	\N
78047	1397	1398826016000	6120	3173	0	0	\N
78048	1397	1398826016000	6121	3173	0	0	\N
78056	1397	1398766010000	6127	3178	0	0	\N
78057	1397	1398766010000	6128	3178	0	0	\N
78058	1397	1398756009000	6129	3179	0	0	\N
78060	1397	1398756009000	6131	3179	0	0	\N
78061	1397	1398746008000	6131	3179	1	0	\N
78062	1397	1398756009000	6132	3179	0	0	\N
78064	1397	1398746008000	6134	3180	0	0	\N
77939	1397	1399246058000	6055	3146	0	0	3959
77943	1397	1399236057000	6059	3147	0	0	3960
77944	1397	1399226056000	6059	3147	1	0	3961
77945	1397	1399216055000	6060	3148	0	0	3962
77946	1397	1399206054000	6060	3148	1	0	3963
77953	1397	1399186052000	6065	3150	0	0	3965
77954	1397	1399176051000	6066	3151	0	0	3966
77955	1397	1399166050000	6066	3151	1	0	3967
77956	1397	1399156049000	6066	3151	2	0	3968
77960	1397	1399146048000	6068	3152	0	0	3969
77962	1397	1399126046000	6069	3153	0	0	3971
77965	1397	1399116045000	6072	3154	0	0	3972
77967	1397	1399106044000	6074	3155	0	0	3973
77972	1397	1399096043000	6077	3156	0	0	3974
77979	1397	1399076041000	6081	3157	0	0	3976
77980	1397	1399066040000	6081	3157	1	0	3977
77983	1397	1399056039000	6085	3159	0	0	3978
77986	1397	1399046038000	6088	3160	0	0	3979
77987	1397	1399036037000	6089	3161	0	0	3980
77991	1397	1399016035000	6091	3162	1	0	3982
77992	1397	1399006034000	6091	3162	2	0	3983
77999	1397	1398996033000	6094	3163	0	0	3984
78000	1397	1398986032000	6094	3163	1	0	3985
78001	1397	1398976031000	6094	3163	2	0	3986
78006	1397	1398956029000	6096	3164	1	0	3988
78007	1397	1398946028000	6097	3165	0	0	3989
78008	1397	1398936027000	6097	3165	1	0	3990
78014	1397	1398926026000	6101	3166	0	0	3991
78024	42	74639120000000	6107	3168	0	0	1
78025	1596	11409150000000	6107	3168	1	0	1
78026	1397	1398906024000	6107	3168	2	0	3993
78027	1397	1398896023000	6107	3168	3	0	3994
78038	1397	1398886022000	6112	3169	0	0	3995
78041	1397	1398866020000	6115	3171	0	0	3997
78043	1397	1398856019000	6118	3172	0	0	3998
78044	1397	1398846018000	6118	3172	1	0	3999
78045	1397	1398836017000	6118	3172	2	0	4000
78046	1397	1398826016000	6119	3173	0	0	4001
78050	1726	893500000000	6123	3175	0	0	82
78051	1397	1398806014000	6123	3175	1	0	4003
78052	1397	1398796013000	6125	3177	0	0	4004
78053	1397	1398786012000	6125	3177	1	0	4005
78055	1397	1398766010000	6126	3178	0	0	4007
78059	1397	1398756009000	6130	3179	0	0	4008
78063	1397	1398746008000	6133	3180	0	0	4009
78066	1397	1398726006000	6136	3182	0	0	\N
78067	1397	1398726006000	6137	3182	0	0	\N
78071	1397	1398706004000	6141	3184	0	0	\N
78072	1397	1398706004000	6142	3184	0	0	\N
78074	1397	1398696003000	6145	3185	0	0	\N
78077	1397	1398666000000	6151	3187	0	0	\N
78079	1397	1398655999000	6153	3188	0	0	\N
78081	1397	1398655999000	6155	3188	0	0	\N
78082	1397	1398645998000	6156	3189	0	0	\N
78084	1397	1398635997000	6158	3190	0	0	\N
78086	1397	1398625996000	6160	3191	0	0	\N
78087	1397	1398625996000	6161	3191	0	0	\N
78092	1397	1398585992000	6164	3193	0	0	\N
78093	1397	1398585992000	6165	3193	0	0	\N
78095	1397	1398575991000	6167	3194	0	0	\N
78097	1397	1398575991000	6169	3194	0	0	\N
78098	1397	1398565990000	6170	3195	0	0	\N
78105	1397	1398545988000	6174	3197	0	0	\N
78106	1397	1398535987000	6174	3197	1	0	\N
78107	1397	1398525986000	6174	3197	2	0	\N
78108	1397	1398515985000	6174	3197	3	0	\N
78109	1397	1398545988000	6175	3197	0	0	\N
78110	1397	1398535987000	6175	3197	1	0	\N
78111	1397	1398525986000	6175	3197	2	0	\N
78112	1397	1398515985000	6175	3197	3	0	\N
78114	1397	1398495983000	6177	3199	0	0	\N
78115	1397	1398485982000	6177	3199	1	0	\N
78116	1397	1398475981000	6177	3199	2	0	\N
78117	1397	1398465980000	6177	3199	3	0	\N
78118	1397	1398455979000	6177	3199	4	0	\N
78119	1397	1398495983000	6178	3199	0	0	\N
78120	1397	1398485982000	6178	3199	1	0	\N
78121	1397	1398475981000	6178	3199	2	0	\N
78122	1397	1398465980000	6178	3199	3	0	\N
78123	1397	1398455979000	6178	3199	4	0	\N
78129	1397	1398445978000	6180	3200	0	0	\N
78131	1397	1398435977000	6182	3201	0	0	\N
78132	1397	1398425976000	6182	3201	1	0	\N
78135	1397	1398435977000	6184	3201	0	0	\N
78136	1397	1398425976000	6184	3201	1	0	\N
78145	1844	1100000000	6188	3204	0	0	\N
78146	1687	805983726450	6188	3204	1	0	\N
78147	1397	1398385972000	6188	3204	2	0	\N
78149	1397	1398375971000	6190	3205	0	0	\N
78150	1397	1398375971000	6191	3205	0	0	\N
78151	1397	1398375971000	6192	3205	0	0	\N
78157	1397	1398335967000	6196	3208	0	0	\N
78158	1397	1398335967000	6197	3208	0	0	\N
78159	1397	1398335967000	6198	3208	0	0	\N
78160	1397	1398335967000	6199	3208	0	0	\N
78161	1397	1398335967000	6200	3208	0	0	\N
78162	1866	11996467329355	6202	3210	0	0	\N
78163	1866	11991625815924	6202	3210	1	0	\N
78164	1866	10632291957560	6202	3210	2	0	\N
78165	1866	9272958099196	6202	3210	3	0	\N
78166	1866	8014764929790	6202	3210	4	0	\N
78167	1866	5760172749566	6202	3210	5	0	\N
78168	1866	4238921951632	6202	3210	6	0	\N
78169	1866	0	6202	3210	7	0	\N
78170	1397	1398325966000	6202	3210	8	0	\N
78171	1397	1398315965000	6202	3210	9	0	\N
78183	1397	1398305964000	6205	3211	0	0	\N
78184	1397	1398295963000	6205	3211	1	0	\N
78185	1397	1398285962000	6205	3211	2	0	\N
78188	1397	1398295963000	6207	3212	0	0	\N
78189	1397	1398285962000	6207	3212	1	0	\N
78191	1397	1398265960000	6209	3214	0	0	\N
78192	1397	1398265960000	6210	3214	0	0	\N
78194	42	74637920000000	6212	3215	0	0	\N
78195	1397	1398255959000	6212	3215	1	0	\N
78196	1397	1398245958000	6212	3215	2	0	\N
78197	1397	1398235957000	6212	3215	3	0	\N
78069	1397	1398716005000	6139	3183	0	0	4012
78070	1397	1398706004000	6140	3184	0	0	4013
78073	1397	1398696003000	6144	3185	0	0	4014
78075	1397	1398686002000	6150	3186	0	0	4015
78076	1397	1398676001000	6150	3186	1	0	4016
78080	1397	1398655999000	6154	3188	0	0	4018
78083	1397	1398645998000	6157	3189	0	0	4019
78085	1397	1398635997000	6159	3190	0	0	4020
78088	1397	1398625996000	6162	3191	0	0	4021
78089	1397	1398615995000	6163	3192	0	0	4022
78091	1397	1398595993000	6163	3192	2	0	4024
78094	1397	1398585992000	6166	3193	0	0	4025
78096	1397	1398575991000	6168	3194	0	0	4026
78099	1397	1398565990000	6171	3195	0	0	4027
78101	1397	1398545988000	6173	3197	0	0	4029
78102	1397	1398535987000	6173	3197	1	0	4030
78103	1397	1398525986000	6173	3197	2	0	4031
78104	1397	1398515985000	6173	3197	3	0	4032
78113	1397	1398505984000	6176	3198	0	0	4033
78125	1397	1398485982000	6179	3199	1	0	4035
78126	1397	1398475981000	6179	3199	2	0	4036
78127	1397	1398465980000	6179	3199	3	0	4037
78128	1397	1398455979000	6179	3199	4	0	4038
78130	1397	1398445978000	6181	3200	0	0	4039
78134	1397	1398425976000	6183	3201	1	0	4041
78137	1687	12949121000000	6185	3202	0	0	2
78138	42	74638020000000	6185	3202	1	0	2
78139	1397	1398415975000	6185	3202	2	0	4042
78141	1397	1398395973000	6186	3203	0	0	4044
78142	1844	1100000000	6187	3204	0	0	3
78143	1687	805983726450	6187	3204	1	0	3
78144	1397	1398385972000	6187	3204	2	0	4045
78148	1397	1398375971000	6189	3205	0	0	4046
78153	1397	1398365970000	6193	3206	1	0	4047
78154	1397	1398355969000	6193	3206	2	0	4048
78155	1397	1398345968000	6194	3207	0	0	4049
78156	1397	1398335967000	6195	3208	0	0	4050
78172	1866	11996467329355	6203	3210	0	0	1
78174	1866	10632291957560	6203	3210	2	0	3
78175	1866	9272958099196	6203	3210	3	0	4
78176	1866	8014764929790	6203	3210	4	0	5
78177	1866	5760172749566	6203	3210	5	0	6
78179	1866	0	6203	3210	7	0	8
78180	1397	1398325966000	6203	3210	8	0	4051
78181	1397	1398315965000	6203	3210	9	0	4052
78182	1397	1398305964000	6204	3211	0	0	4053
78186	1397	1398295963000	6206	3212	0	0	4054
78190	1397	1398275961000	6208	3213	0	0	4056
78193	1397	1398265960000	6211	3214	0	0	4057
78198	42	74637920000000	6213	3215	0	0	3
78199	1397	1398255959000	6213	3215	1	0	4058
78200	1397	1398245958000	6213	3215	2	0	4059
78202	42	74637920000000	6214	3215	0	0	\N
78203	1397	1398255959000	6214	3215	1	0	\N
78204	1397	1398245958000	6214	3215	2	0	\N
78205	1397	1398235957000	6214	3215	3	0	\N
78207	1863	900000000	6216	3217	0	0	\N
78208	42	74637820000000	6216	3217	1	0	\N
78209	1397	1398215955000	6216	3217	2	0	\N
78213	1397	1398205954000	6218	3218	0	0	\N
78214	1397	1398205954000	6219	3218	0	0	\N
78222	1397	1398145948000	6223	3221	0	0	\N
78223	1397	1398145948000	6224	3221	0	0	\N
78224	1397	1398145948000	6225	3221	0	0	\N
78228	1863	900000000	6228	3213	0	0	\N
78229	1726	892200000000	6228	3213	1	0	\N
78230	42	74637920000000	6228	3213	2	0	\N
78231	42	74637820000000	6228	3213	3	0	\N
78232	1397	1398275961000	6228	3213	4	0	\N
78233	1397	1398265960000	6228	3213	5	0	\N
78234	1397	1398255959000	6228	3213	6	0	\N
78235	1397	1398245958000	6228	3213	7	0	\N
78236	1397	1398235957000	6228	3213	8	0	\N
78237	1397	1398225956000	6228	3213	9	0	\N
78238	1397	1398215955000	6228	3213	10	0	\N
78239	1397	1398205954000	6228	3213	11	0	\N
78240	1397	1398195953000	6228	3213	12	0	\N
78241	1397	1398185952000	6228	3213	13	0	\N
78242	1397	1398175951000	6228	3213	14	0	\N
78243	1397	1398165950000	6228	3213	15	0	\N
78244	1397	1398155949000	6228	3213	16	0	\N
78245	1397	1398145948000	6228	3213	17	0	\N
78246	1397	1398135947000	6228	3213	18	0	\N
78247	1397	1398125946000	6228	3213	19	0	\N
78249	1397	1398105944000	6230	3224	0	0	\N
78250	1397	1398095943000	6230	3224	1	0	\N
78251	1397	1398085942000	6230	3224	2	0	\N
78255	1687	12949121000000	6232	3012	0	0	\N
78256	1726	893500000000	6232	3012	1	0	\N
78257	1726	892200000000	6232	3012	2	0	\N
78258	42	74639120000000	6232	3012	3	0	\N
78259	42	74638020000000	6232	3012	4	0	\N
78260	1844	1100000000	6232	3012	5	0	\N
78261	1687	805983726450	6232	3012	6	0	\N
78262	1687	804883726450	6232	3012	7	0	\N
78263	42	74637920000000	6232	3012	8	0	\N
78264	42	74637820000000	6232	3012	9	0	\N
78265	1596	10689140000000	6232	3012	10	0	\N
78267	1397	1398065940000	6234	3226	0	0	\N
78268	1397	1398055939000	6234	3226	1	0	\N
78271	1397	1398065940000	6236	3226	0	0	\N
78272	1397	1398055939000	6236	3226	1	0	\N
78273	1397	1398065940000	6237	3226	0	0	\N
78274	1397	1398055939000	6237	3226	1	0	\N
78275	1397	1398065940000	6238	3226	0	0	\N
78276	1397	1398055939000	6238	3226	1	0	\N
78279	1397	1398045938000	6240	3227	0	0	\N
78280	1397	1398035937000	6240	3227	1	0	\N
78284	1397	1398015935000	6243	3229	0	0	\N
78285	1397	1398005934000	6243	3229	1	0	\N
78287	1397	1397995933000	6245	3230	0	0	\N
78290	1397	1397975931000	6248	3232	0	0	\N
78291	1397	1397965930000	6249	3233	0	0	\N
78292	1397	1397955929000	6249	3233	1	0	\N
78303	1397	1397895923000	6255	3237	0	0	\N
78304	1868	7990000000	6255	3237	1	0	\N
78315	1397	1397805914000	6262	3243	0	0	\N
78316	1397	1397805914000	6263	3243	0	0	\N
78318	1397	1397785912000	6265	3245	0	0	\N
78319	1397	1397775911000	6265	3245	1	0	\N
78329	1397	1397695903000	6271	3250	0	0	\N
78330	1397	1397685902000	6271	3250	1	0	\N
78331	1397	1397675901000	6271	3250	2	0	\N
78332	1397	1397665900000	6271	3250	3	0	\N
78333	1397	1397695903000	6272	3250	0	0	\N
78334	1397	1397685902000	6272	3250	1	0	\N
78335	1397	1397675901000	6272	3250	2	0	\N
78336	1397	1397665900000	6272	3250	3	0	\N
78210	1863	900000000	6217	3217	0	0	1
78211	42	74637820000000	6217	3217	1	0	4
78212	1397	1398215955000	6217	3217	2	0	4062
78215	1397	1398205954000	6220	3218	0	0	4063
78216	1726	892200000000	6221	3219	0	0	83
78218	1397	1398185952000	6221	3219	2	0	4065
78219	1397	1398175951000	6221	3219	3	0	4066
78220	1397	1398165950000	6222	3220	0	0	4067
78221	1397	1398155949000	6222	3220	1	0	4068
78225	1397	1398145948000	6226	3221	0	0	4069
78227	1397	1398125946000	6227	3222	1	0	4071
78248	1397	1398115945000	6229	3223	0	0	4072
78252	1397	1398105944000	6231	3224	0	0	4073
78253	1397	1398095943000	6231	3224	1	0	4074
78266	1397	1398075941000	6233	3225	0	0	4076
78269	1397	1398065940000	6235	3226	0	0	4077
78270	1397	1398055939000	6235	3226	1	0	4078
78277	1397	1398045938000	6239	3227	0	0	4079
78278	1397	1398035937000	6239	3227	1	0	4080
78282	1397	1398015935000	6242	3229	0	0	4082
78283	1397	1398005934000	6242	3229	1	0	4083
78286	1397	1397995933000	6244	3230	0	0	4084
78288	1397	1397985932000	6246	3231	0	0	4085
78289	1397	1397975931000	6247	3232	0	0	4086
78294	1397	1397955929000	6250	3233	1	0	4088
78295	1397	1397945928000	6251	3234	0	0	4089
78296	1397	1397935927000	6252	3235	0	0	4090
78297	1397	1397925926000	6252	3235	1	0	4091
78299	687	66710029000000	6252	3235	3	0	1
78300	1397	1397905924000	6253	3236	0	0	4093
78301	1397	1397895923000	6254	3237	0	0	4094
78302	1868	7990000000	6254	3237	1	0	1
78305	1868	6980000000	6256	3238	0	0	2
78307	1397	1397875921000	6256	3238	2	0	4096
78308	1397	1397865920000	6256	3238	3	0	4097
78309	1397	1397855919000	6257	3239	0	0	4098
78310	1397	1397845918000	6258	3240	0	0	4099
78311	1397	1397835917000	6259	3241	0	0	4100
78313	1397	1397815915000	6260	3242	1	0	4102
78314	1397	1397805914000	6261	3243	0	0	4103
78317	1397	1397795913000	6264	3244	0	0	4104
78320	1397	1397785912000	6266	3245	0	0	4105
78322	1397	1397765910000	6267	3246	0	0	4107
78323	1397	1397755909000	6268	3247	0	0	4108
78324	1397	1397745908000	6268	3247	1	0	4109
78325	1397	1397735907000	6269	3248	0	0	4110
78326	1397	1397725906000	6270	3249	0	0	4111
78328	1397	1397705904000	6270	3249	2	0	4113
78341	1397	1397695903000	6274	3250	0	0	\N
78342	1397	1397685902000	6274	3250	1	0	\N
78343	1397	1397675901000	6274	3250	2	0	\N
78344	1397	1397665900000	6274	3250	3	0	\N
78345	1397	1397695903000	6275	3250	0	0	\N
78346	1397	1397685902000	6275	3250	1	0	\N
78347	1397	1397675901000	6275	3250	2	0	\N
78348	1397	1397665900000	6275	3250	3	0	\N
78349	1397	1397655899000	6276	3251	0	0	\N
78350	1397	1397655899000	6277	3251	0	0	\N
78353	1397	1397635897000	6280	3253	0	0	\N
78354	1397	1397635897000	6281	3253	0	0	\N
78356	1397	1397625896000	6283	3254	0	0	\N
78360	1397	1397595893000	6287	3257	0	0	\N
78365	1397	1397555889000	6291	3260	0	0	\N
78367	1397	1397555889000	6293	3260	0	0	\N
78368	1397	1397555889000	6294	3260	0	0	\N
78369	1397	1397555889000	6295	3260	0	0	\N
78370	1397	1397545888000	6296	3261	0	0	\N
78372	1397	1397545888000	6298	3261	0	0	\N
78373	1397	1397545888000	6299	3261	0	0	\N
78374	1397	1397545888000	6300	3261	0	0	\N
78376	1397	1397535887000	6302	3262	0	0	\N
78377	687	66710029000000	6303	3013	0	0	\N
78381	1726	890900000000	6306	3265	0	0	\N
78382	1726	889600000000	6306	3265	1	0	\N
78383	1397	1397495883000	6306	3265	2	0	\N
78384	1397	1397485882000	6306	3265	3	0	\N
78385	1397	1397475881000	6306	3265	4	0	\N
78386	1726	890900000000	6307	3265	0	0	\N
78387	1726	889600000000	6307	3265	1	0	\N
78388	1397	1397495883000	6307	3265	2	0	\N
78389	1397	1397485882000	6307	3265	3	0	\N
78390	1397	1397475881000	6307	3265	4	0	\N
78396	1397	1397465880000	6309	3266	0	0	\N
78401	1397	1397435877000	6313	3268	0	0	\N
78402	1397	1397425876000	6314	3269	0	0	\N
78403	1397	1397415875000	6314	3269	1	0	\N
78404	1397	1397405874000	6314	3269	2	0	\N
78408	1397	1397395873000	6316	3270	0	0	\N
78410	1397	1397385872000	6318	3271	0	0	\N
78411	1397	1397385872000	6319	3271	0	0	\N
78413	1397	1397375871000	6321	3272	0	0	\N
78415	1397	1397375871000	6323	3272	0	0	\N
78417	1397	1397365870000	6325	3273	0	0	\N
78419	1397	1397345868000	6327	3275	0	0	\N
78426	1397	1397295863000	6332	3278	0	0	\N
78427	1397	1397295863000	6333	3278	0	0	\N
78428	1726	890900000000	6334	3014	0	0	\N
78429	1726	889600000000	6334	3014	1	0	\N
78430	1397	1397285862000	6335	3279	0	0	\N
78435	1687	12949121000000	6339	3048	0	0	\N
78436	1726	897400000000	6339	3048	1	0	\N
78437	1726	896100000000	6339	3048	2	0	\N
78438	42	74639120000000	6339	3048	3	0	\N
78439	42	74638020000000	6339	3048	4	0	\N
78440	1726	894800000000	6339	3048	5	0	\N
78441	1726	893500000000	6339	3048	6	0	\N
78442	1726	892200000000	6339	3048	7	0	\N
78443	1726	890900000000	6339	3048	8	0	\N
78444	1726	889600000000	6339	3048	9	0	\N
78445	1844	1100000000	6339	3048	10	0	\N
78446	1687	805983726450	6339	3048	11	0	\N
78447	1687	804883726450	6339	3048	12	0	\N
78448	42	74637920000000	6339	3048	13	0	\N
78449	42	74637820000000	6339	3048	14	0	\N
78450	1397	1400606194000	6339	3048	15	0	\N
78451	1596	10689140000000	6339	3048	16	0	\N
78452	1665	720000000000	6339	3048	17	0	\N
78453	1665	719900000000	6339	3048	18	0	\N
78454	877	203054343117107	6339	3048	19	0	\N
78455	1692	43920133000000	6339	3048	20	0	\N
78456	1665	717880000000	6339	3048	21	0	\N
78457	1397	1400596193000	6339	3048	22	0	\N
78458	1397	1400586192000	6339	3048	23	0	\N
78459	1397	1400576191000	6339	3048	24	0	\N
78460	1692	43919113000000	6339	3048	25	0	\N
78461	1692	43819093000000	6339	3048	26	0	\N
78462	1692	19083000000	6339	3048	27	0	\N
78463	1397	1400566190000	6339	3048	28	0	\N
78464	1397	1400556189000	6339	3048	29	0	\N
78465	1397	1400546188000	6339	3048	30	0	\N
78466	1397	1400536187000	6339	3048	31	0	\N
78467	1397	1400526186000	6339	3048	32	0	\N
78468	1397	1400516185000	6339	3048	33	0	\N
78469	1397	1400506184000	6339	3048	34	0	\N
78470	1397	1400496183000	6339	3048	35	0	\N
78471	1397	1400486182000	6339	3048	36	0	\N
78472	1397	1400476181000	6339	3048	37	0	\N
78339	1397	1397675901000	6273	3250	2	0	4116
78340	1397	1397665900000	6273	3250	3	0	4117
78351	1397	1397655899000	6278	3251	0	0	4118
78352	1397	1397645898000	6279	3252	0	0	4119
78355	1397	1397635897000	6282	3253	0	0	4120
78358	1397	1397615895000	6285	3255	0	0	4122
78359	1397	1397605894000	6286	3256	0	0	4123
78361	1397	1397595893000	6288	3257	0	0	4124
78362	1397	1397585892000	6289	3258	0	0	4125
78363	1397	1397575891000	6289	3258	1	0	4126
78366	1397	1397555889000	6292	3260	0	0	4128
78371	1397	1397545888000	6297	3261	0	0	4129
78375	1397	1397535887000	6301	3262	0	0	4130
78378	1397	1397525886000	6304	3263	0	0	4131
78380	1397	1397505884000	6305	3264	0	0	4133
78391	1726	890900000000	6308	3265	0	0	84
78392	1726	889600000000	6308	3265	1	0	85
78393	1397	1397495883000	6308	3265	2	0	4134
78394	1397	1397485882000	6308	3265	3	0	4135
78397	1397	1397465880000	6310	3266	0	0	4137
78398	1397	1397455879000	6311	3267	0	0	4138
78399	1397	1397445878000	6311	3267	1	0	4139
78400	1397	1397435877000	6312	3268	0	0	4140
78405	1397	1397425876000	6315	3269	0	0	4141
78407	1397	1397405874000	6315	3269	2	0	4143
78409	1397	1397395873000	6317	3270	0	0	4144
78412	1397	1397385872000	6320	3271	0	0	4145
78414	1397	1397375871000	6322	3272	0	0	4146
78418	1397	1397355869000	6326	3274	0	0	4148
78420	1397	1397345868000	6328	3275	0	0	4149
78421	1397	1397335867000	6329	3276	0	0	4150
78422	1397	1397325866000	6330	3277	0	0	4151
78423	1397	1397315865000	6330	3277	1	0	4152
78425	1397	1397295863000	6331	3278	0	0	4154
78431	1397	1397285862000	6336	3279	0	0	4155
78432	1397	1397275861000	6337	3280	0	0	4156
78433	1397	1397265860000	6338	3281	0	0	4157
78434	1397	1397255859000	6338	3281	1	0	4158
78473	1397	1400466180000	6339	3048	38	0	\N
78474	1397	1400456179000	6339	3048	39	0	\N
78475	1397	1400446178000	6339	3048	40	0	\N
78476	1397	1400436177000	6339	3048	41	0	\N
78477	1397	1400426176000	6339	3048	42	0	\N
78478	1397	1400416175000	6339	3048	43	0	\N
78479	1397	1400406174000	6339	3048	44	0	\N
78480	1397	1400396173000	6339	3048	45	0	\N
78481	1397	1400386172000	6339	3048	46	0	\N
78482	1397	1400376171000	6339	3048	47	0	\N
78483	1397	1400366170000	6339	3048	48	0	\N
78484	1397	1400356169000	6339	3048	49	0	\N
78485	1397	1400346168000	6339	3048	50	0	\N
78486	127	66001471816426	6339	3048	51	0	\N
78487	1397	1400336167000	6339	3048	52	0	\N
78488	1397	1400326166000	6339	3048	53	0	\N
78489	1397	1400316165000	6339	3048	54	0	\N
78490	1397	1400306164000	6339	3048	55	0	\N
78491	1397	1400296163000	6339	3048	56	0	\N
78492	1397	1400286162000	6339	3048	57	0	\N
78493	1397	1400276161000	6339	3048	59	0	\N
78494	1397	1400266160000	6339	3048	60	0	\N
78495	1397	1400256159000	6339	3048	61	0	\N
78496	1397	1400246158000	6339	3048	62	0	\N
78497	1397	1400236157000	6339	3048	63	0	\N
78498	1397	1400226156000	6339	3048	64	0	\N
78499	1397	1400216155000	6339	3048	65	0	\N
78500	1397	1400206154000	6339	3048	66	0	\N
78501	1397	1400196153000	6339	3048	67	0	\N
78502	1397	1400186152000	6339	3048	68	0	\N
78503	1397	1400176151000	6339	3048	69	0	\N
78504	1397	1400166150000	6339	3048	70	0	\N
78505	1397	1400156149000	6339	3048	71	0	\N
78506	1397	1400146148000	6339	3048	72	0	\N
78507	1397	1400136147000	6339	3048	73	0	\N
78508	1397	1400126146000	6339	3048	74	0	\N
78509	1397	1400116145000	6339	3048	75	0	\N
78510	1397	1400106144000	6339	3048	76	0	\N
78511	1397	1400096143000	6339	3048	77	0	\N
78512	1397	1400086142000	6339	3048	78	0	\N
78513	1397	1400076141000	6339	3048	79	0	\N
78514	1397	1400066140000	6339	3048	80	0	\N
78515	1397	1400056139000	6339	3048	81	0	\N
78516	1397	1400046138000	6339	3048	82	0	\N
78517	1397	1400036137000	6339	3048	83	0	\N
78518	1397	1400026136000	6339	3048	84	0	\N
78519	1397	1400016135000	6339	3048	85	0	\N
78520	1397	1400006134000	6339	3048	86	0	\N
78521	1397	1399996133000	6339	3048	87	0	\N
78522	1397	1399986132000	6339	3048	88	0	\N
78523	1397	1399976131000	6339	3048	89	0	\N
78524	1397	1399966130000	6339	3048	90	0	\N
78525	1397	1399956129000	6339	3048	91	0	\N
78526	1397	1399946128000	6339	3048	92	0	\N
78527	1397	1399936127000	6339	3048	93	0	\N
78528	1397	1399926126000	6339	3048	94	0	\N
78529	1397	1399916125000	6339	3048	95	0	\N
78530	1397	1399906124000	6339	3048	96	0	\N
78531	1397	1399896123000	6339	3048	97	0	\N
78532	1397	1399886122000	6339	3048	98	0	\N
78533	1397	1399876121000	6339	3048	99	0	\N
78534	1397	1399866120000	6339	3048	100	0	\N
78535	1397	1399856119000	6339	3048	101	0	\N
78536	1397	1399846118000	6339	3048	102	0	\N
78537	1397	1399836117000	6339	3048	103	0	\N
78538	1397	1399826116000	6339	3048	104	0	\N
78539	1397	1399816115000	6339	3048	105	0	\N
78540	1397	1399806114000	6339	3048	106	0	\N
78541	1397	1399796113000	6339	3048	107	0	\N
78542	1397	1399786112000	6339	3048	108	0	\N
78543	1397	1399776111000	6339	3048	109	0	\N
78544	1397	1399766110000	6339	3048	110	0	\N
78545	1397	1399756109000	6339	3048	111	0	\N
78546	1397	1399746108000	6339	3048	112	0	\N
78547	1397	1399736107000	6339	3048	113	0	\N
78548	1397	1399726106000	6339	3048	114	0	\N
78549	1397	1399716105000	6339	3048	115	0	\N
78550	1397	1399706104000	6339	3048	116	0	\N
78551	1397	1399696103000	6339	3048	117	0	\N
78552	1397	1399686102000	6339	3048	118	0	\N
78553	1397	1399676101000	6339	3048	119	0	\N
78554	1397	1399666100000	6339	3048	120	0	\N
78555	1397	1399656099000	6339	3048	121	0	\N
78556	1397	1399646098000	6339	3048	122	0	\N
78557	1397	1399636097000	6339	3048	123	0	\N
78558	1397	1399626096000	6339	3048	124	0	\N
78559	1397	1399616095000	6339	3048	125	0	\N
78560	1397	1397245858000	6340	3282	0	0	\N
78562	1397	1397245858000	6342	3282	0	0	\N
78564	1397	1397225856000	6344	3284	0	0	\N
78565	1397	1397225856000	6345	3284	0	0	\N
78566	1397	1399606094000	6346	3049	0	0	\N
78567	1397	1399596093000	6346	3049	1	0	\N
78568	1397	1399586092000	6346	3049	2	0	\N
78569	1397	1399576091000	6346	3049	3	0	\N
78570	1397	1399566090000	6346	3049	4	0	\N
78571	1397	1399556089000	6346	3049	5	0	\N
78572	1397	1399546088000	6346	3049	6	0	\N
78573	1397	1399536087000	6346	3049	7	0	\N
78574	1397	1399526086000	6346	3049	8	0	\N
78575	1397	1399516085000	6346	3049	9	0	\N
78576	1397	1399506084000	6346	3049	10	0	\N
78577	1397	1399496083000	6346	3049	11	0	\N
78578	1397	1399486082000	6346	3049	12	0	\N
78579	1397	1399476081000	6346	3049	13	0	\N
78580	1397	1399466080000	6346	3049	14	0	\N
78581	1397	1399456079000	6346	3049	15	0	\N
78582	1397	1399446078000	6346	3049	16	0	\N
78583	1397	1399436077000	6346	3049	17	0	\N
78584	1397	1399426076000	6346	3049	18	0	\N
78585	1397	1399416075000	6346	3049	19	0	\N
78586	1397	1399406074000	6346	3049	20	0	\N
78587	878	203055343117107	6346	3049	21	0	\N
78588	1397	1399396073000	6346	3049	22	0	\N
78589	1397	1399386072000	6346	3049	23	0	\N
78590	1397	1399376071000	6346	3049	24	0	\N
78591	1397	1399366070000	6346	3049	25	0	\N
78592	1397	1399356069000	6346	3049	26	0	\N
78593	1397	1399346068000	6346	3049	27	0	\N
78594	1397	1399336067000	6346	3049	28	0	\N
78595	1397	1399326066000	6346	3049	29	0	\N
78596	1397	1399316065000	6346	3049	30	0	\N
78597	1397	1399306064000	6346	3049	31	0	\N
78598	1397	1399296063000	6346	3049	32	0	\N
78599	1397	1399286062000	6346	3049	33	0	\N
78600	1397	1399276061000	6346	3049	34	0	\N
78601	1397	1399266060000	6346	3049	35	0	\N
78602	1397	1399256059000	6346	3049	36	0	\N
78603	1397	1399246058000	6346	3049	37	0	\N
78604	1397	1399236057000	6346	3049	38	0	\N
78605	1397	1399226056000	6346	3049	39	0	\N
78606	1397	1399216055000	6346	3049	40	0	\N
78607	1397	1399206054000	6346	3049	41	0	\N
78608	1397	1399196053000	6346	3049	42	0	\N
78609	1397	1399186052000	6346	3049	43	0	\N
78610	1397	1399176051000	6346	3049	44	0	\N
78611	1397	1399166050000	6346	3049	45	0	\N
78612	1397	1399156049000	6346	3049	46	0	\N
78613	1397	1399146048000	6346	3049	47	0	\N
78614	1397	1399136047000	6346	3049	48	0	\N
78615	1397	1399126046000	6346	3049	49	0	\N
78616	1397	1399116045000	6346	3049	50	0	\N
78617	1397	1399106044000	6346	3049	51	0	\N
78618	1397	1399096043000	6346	3049	52	0	\N
78619	1397	1399086042000	6346	3049	53	0	\N
78620	1397	1399076041000	6346	3049	54	0	\N
78621	1397	1399066040000	6346	3049	55	0	\N
78622	1397	1399056039000	6346	3049	56	0	\N
78623	1397	1399046038000	6346	3049	57	0	\N
78624	1397	1399036037000	6346	3049	59	0	\N
78625	1397	1399026036000	6346	3049	60	0	\N
78626	1397	1399016035000	6346	3049	61	0	\N
78627	1397	1399006034000	6346	3049	62	0	\N
78628	1397	1398996033000	6346	3049	63	0	\N
78629	1397	1398986032000	6346	3049	64	0	\N
78630	1397	1398976031000	6346	3049	65	0	\N
78631	1397	1398966030000	6346	3049	66	0	\N
78632	1397	1398956029000	6346	3049	67	0	\N
78633	1397	1398946028000	6346	3049	68	0	\N
78634	1397	1398936027000	6346	3049	69	0	\N
78635	1397	1398926026000	6346	3049	70	0	\N
78636	1397	1398916025000	6346	3049	71	0	\N
78637	1397	1398906024000	6346	3049	72	0	\N
78638	1397	1398896023000	6346	3049	73	0	\N
78639	1397	1398886022000	6346	3049	74	0	\N
78640	1397	1398876021000	6346	3049	75	0	\N
78641	1397	1398866020000	6346	3049	76	0	\N
78642	1397	1398856019000	6346	3049	77	0	\N
78643	1397	1398846018000	6346	3049	78	0	\N
78644	1397	1398836017000	6346	3049	79	0	\N
78645	1397	1398826016000	6346	3049	80	0	\N
78646	1397	1398816015000	6346	3049	81	0	\N
78647	1397	1398806014000	6346	3049	82	0	\N
78648	1397	1398796013000	6346	3049	83	0	\N
78649	1397	1398786012000	6346	3049	84	0	\N
78650	1397	1398776011000	6346	3049	85	0	\N
78651	1397	1398766010000	6346	3049	86	0	\N
78652	1397	1398756009000	6346	3049	87	0	\N
78653	1397	1398746008000	6346	3049	88	0	\N
78654	1397	1398736007000	6346	3049	89	0	\N
78655	1397	1398726006000	6346	3049	90	0	\N
78656	1397	1398716005000	6346	3049	91	0	\N
78657	1397	1398706004000	6346	3049	92	0	\N
78658	1397	1398696003000	6346	3049	93	0	\N
78659	1397	1398686002000	6346	3049	94	0	\N
78660	1397	1398676001000	6346	3049	95	0	\N
78661	1397	1398666000000	6346	3049	96	0	\N
78662	1397	1398655999000	6346	3049	97	0	\N
78663	1397	1398645998000	6346	3049	98	0	\N
78664	1397	1398635997000	6346	3049	99	0	\N
78665	1397	1398625996000	6346	3049	100	0	\N
78666	1397	1398615995000	6346	3049	101	0	\N
78667	1397	1398605994000	6346	3049	102	0	\N
78668	1397	1398595993000	6346	3049	103	0	\N
78669	1397	1398585992000	6346	3049	104	0	\N
78670	1397	1398575991000	6346	3049	105	0	\N
78671	1397	1398565990000	6346	3049	106	0	\N
78672	1397	1398555989000	6346	3049	107	0	\N
78673	1397	1398545988000	6346	3049	108	0	\N
78674	1397	1398535987000	6346	3049	109	0	\N
78675	1397	1398525986000	6346	3049	110	0	\N
78676	1397	1398515985000	6346	3049	111	0	\N
78677	1397	1398505984000	6346	3049	112	0	\N
78678	1397	1398495983000	6346	3049	113	0	\N
78679	1397	1398485982000	6346	3049	114	0	\N
78680	1397	1398475981000	6346	3049	115	0	\N
78681	1397	1398465980000	6346	3049	116	0	\N
78682	1397	1398455979000	6346	3049	117	0	\N
78683	1397	1398445978000	6346	3049	118	0	\N
78684	1397	1398435977000	6346	3049	119	0	\N
78685	1397	1398425976000	6346	3049	120	0	\N
78686	1397	1398415975000	6346	3049	121	0	\N
78687	1397	1398405974000	6346	3049	122	0	\N
78688	1397	1398395973000	6346	3049	123	0	\N
78689	1397	1398385972000	6346	3049	124	0	\N
78690	1397	1398375971000	6346	3049	125	0	\N
78693	1397	1397215855000	6349	3285	0	0	\N
78697	1397	1397195853000	6352	3287	0	0	\N
78698	1397	1397185852000	6352	3287	1	0	\N
78699	1397	1397195853000	6353	3287	0	0	\N
78700	1397	1397185852000	6353	3287	1	0	\N
78704	1397	1397175851000	6355	3288	0	0	\N
78705	1397	1397165850000	6355	3288	1	0	\N
78706	1397	1397155849000	6355	3288	2	0	\N
78713	1687	12949121000000	6360	3185	0	0	\N
78714	1726	892200000000	6360	3185	1	0	\N
78715	42	74638020000000	6360	3185	2	0	\N
78716	1726	890900000000	6360	3185	3	0	\N
78717	1726	889600000000	6360	3185	4	0	\N
78718	1844	1100000000	6360	3185	5	0	\N
78719	1687	805983726450	6360	3185	6	0	\N
78720	1687	804883726450	6360	3185	7	0	\N
78721	42	74637920000000	6360	3185	8	0	\N
78722	42	74637820000000	6360	3185	9	0	\N
78723	687	66710029000000	6360	3185	10	0	\N
78727	1397	1397055839000	6363	3295	0	0	\N
78729	1397	1397045838000	6365	3296	0	0	\N
78731	1397	1397035837000	6367	3297	0	0	\N
78738	1397	1396975831000	6372	3301	0	0	\N
78739	1397	1396965830000	6372	3301	1	0	\N
78740	1397	1396955829000	6372	3301	2	0	\N
78744	1397	1396945828000	6374	3302	0	0	\N
78694	1397	1397205854000	6350	3286	0	0	4163
78695	1397	1397195853000	6351	3287	0	0	4164
78696	1397	1397185852000	6351	3287	1	0	4165
78701	1397	1397175851000	6354	3288	0	0	4166
78702	1397	1397165850000	6354	3288	1	0	4167
78707	1397	1397145848000	6356	3289	0	0	4169
78708	1397	1397135847000	6356	3289	1	0	4170
78709	1397	1397125846000	6357	3290	0	0	4171
78710	1397	1397115845000	6358	3291	0	0	4172
78711	1397	1397105844000	6358	3291	1	0	4173
78724	1397	1397085842000	6361	3293	0	0	4175
78725	1397	1397075841000	6361	3293	1	0	4176
78726	1397	1397065840000	6362	3294	0	0	4177
78728	1397	1397055839000	6364	3295	0	0	4178
78732	1397	1397035837000	6368	3297	0	0	4180
78733	1397	1397025836000	6369	3298	0	0	4181
78734	1397	1397015835000	6370	3299	0	0	4182
78735	1397	1397005834000	6370	3299	1	0	4183
78736	1397	1396995833000	6370	3299	2	0	4184
78741	1397	1396975831000	6373	3301	0	0	4186
78742	1397	1396965830000	6373	3301	1	0	4187
78743	1397	1396955829000	6373	3301	2	0	4188
78745	1397	1396945828000	6375	3302	0	0	\N
78747	1397	1396935827000	6377	3303	0	0	\N
78755	1397	1396885822000	6382	3307	0	0	\N
78760	1397	1396855819000	6387	3310	0	0	\N
78763	1397	1396845818000	6389	3311	0	0	\N
78764	1397	1396835817000	6389	3311	1	0	\N
78767	1397	1396815815000	6392	3313	0	0	\N
78768	1397	1396805814000	6393	3314	0	0	\N
78769	1397	1396795813000	6393	3314	1	0	\N
78772	1397	1396785812000	6399	3316	0	0	\N
78773	1397	1396775811000	6399	3316	1	0	\N
78774	1397	1396765810000	6399	3316	2	0	\N
78775	1397	1396785812000	6400	3316	0	0	\N
78776	1397	1396775811000	6400	3316	1	0	\N
78777	1397	1396765810000	6400	3316	2	0	\N
78782	1397	1396745808000	6403	3318	0	0	\N
78783	1397	1396735807000	6403	3318	1	0	\N
78784	1397	1396725806000	6403	3318	2	0	\N
78785	1397	1396715805000	6403	3318	3	0	\N
78790	1726	888300000000	6405	3281	0	0	\N
78791	1726	887000000000	6405	3281	1	0	\N
78792	1397	1396705804000	6406	3319	0	0	\N
78793	1397	1396695803000	6406	3319	1	0	\N
78794	1397	1396685802000	6406	3319	2	0	\N
78808	1397	1396605794000	6412	3323	0	0	\N
78809	1726	886980000000	6412	3323	1	0	\N
78810	1397	1396595793000	6413	3324	0	0	\N
78811	1726	886970000000	6413	3324	1	0	\N
78812	1397	1396585792000	6413	3324	2	0	\N
78813	1397	1396575791000	6413	3324	3	0	\N
78814	1726	886960000000	6413	3324	4	0	\N
78815	1726	886950000000	6413	3324	5	0	\N
78822	1397	1396595793000	6415	3324	0	0	\N
78823	1726	886970000000	6415	3324	1	0	\N
78824	1397	1396585792000	6415	3324	2	0	\N
78825	1397	1396575791000	6415	3324	3	0	\N
78826	1726	886960000000	6415	3324	4	0	\N
78827	1726	886950000000	6415	3324	5	0	\N
78828	1397	1396595793000	6416	3324	0	0	\N
78829	1726	886970000000	6416	3324	1	0	\N
78830	1397	1396585792000	6416	3324	2	0	\N
78831	1397	1396575791000	6416	3324	3	0	\N
78832	1726	886960000000	6416	3324	4	0	\N
78833	1726	886950000000	6416	3324	5	0	\N
78834	1397	1396565790000	6417	3325	0	0	\N
78835	1726	886940000000	6417	3325	1	0	\N
78836	1397	1396565790000	6418	3325	0	0	\N
78837	1726	886940000000	6418	3325	1	0	\N
78838	1397	1396565790000	6419	3325	0	0	\N
78839	1726	886940000000	6419	3325	1	0	\N
78840	1397	1396565790000	6420	3325	0	0	\N
78841	1726	886940000000	6420	3325	1	0	\N
78844	1726	888300000000	6422	3050	0	0	\N
78845	1726	887000000000	6422	3050	1	0	\N
78846	1726	886990000000	6422	3050	2	0	\N
78847	1397	1398365970000	6422	3050	3	0	\N
78848	1397	1398355969000	6422	3050	4	0	\N
78849	1397	1398345968000	6422	3050	5	0	\N
78850	1397	1398335967000	6422	3050	6	0	\N
78851	1726	886980000000	6422	3050	7	0	\N
78852	1726	886970000000	6422	3050	8	0	\N
78853	1726	886960000000	6422	3050	9	0	\N
78854	1726	886950000000	6422	3050	10	0	\N
78855	1397	1398325966000	6422	3050	11	0	\N
78856	1397	1398315965000	6422	3050	12	0	\N
78857	1397	1398305964000	6422	3050	13	0	\N
78858	1397	1398295963000	6422	3050	14	0	\N
78859	1397	1398285962000	6422	3050	15	0	\N
78860	1397	1398275961000	6422	3050	16	0	\N
78861	1397	1398265960000	6422	3050	17	0	\N
78862	1397	1398255959000	6422	3050	18	0	\N
78863	1397	1398245958000	6422	3050	19	0	\N
78864	1397	1398235957000	6422	3050	20	0	\N
78865	1397	1398225956000	6422	3050	21	0	\N
78866	1397	1398215955000	6422	3050	22	0	\N
78867	1397	1398205954000	6422	3050	23	0	\N
78868	1397	1398195953000	6422	3050	24	0	\N
78869	1397	1398185952000	6422	3050	25	0	\N
78870	1397	1398175951000	6422	3050	26	0	\N
78871	1397	1398165950000	6422	3050	27	0	\N
78872	1397	1398155949000	6422	3050	28	0	\N
78873	1726	886940000000	6422	3050	29	0	\N
78874	1397	1398145948000	6422	3050	30	0	\N
78875	1397	1398135947000	6422	3050	31	0	\N
78876	1397	1398125946000	6422	3050	32	0	\N
78877	1397	1398115945000	6422	3050	33	0	\N
78878	1397	1398105944000	6422	3050	34	0	\N
78879	1397	1398095943000	6422	3050	35	0	\N
78880	1397	1398085942000	6422	3050	36	0	\N
78749	1726	888300000000	6379	3304	0	0	86
78750	1397	1396925826000	6379	3304	1	0	4191
78751	1726	887000000000	6380	3305	0	0	87
78752	1397	1396915825000	6380	3305	1	0	4192
78753	1397	1396905824000	6380	3305	2	0	4193
78756	1397	1396885822000	6383	3307	0	0	4195
78757	1397	1396875821000	6384	3308	0	0	4196
78758	1397	1396865820000	6385	3309	0	0	4197
78759	1397	1396855819000	6386	3310	0	0	4198
78761	1397	1396845818000	6388	3311	0	0	4199
78765	1397	1396825816000	6390	3312	0	0	4201
78766	1397	1396815815000	6391	3313	0	0	4202
78770	1397	1396805814000	6394	3314	0	0	4203
78771	1397	1396795813000	6394	3314	1	0	4204
78779	1397	1396775811000	6401	3316	1	0	4206
78780	1397	1396765810000	6401	3316	2	0	4207
78781	1397	1396755809000	6402	3317	0	0	4208
78786	1397	1396745808000	6404	3318	0	0	4209
78787	1397	1396735807000	6404	3318	1	0	4210
78789	1397	1396715805000	6404	3318	3	0	4212
78795	1397	1396705804000	6407	3319	0	0	4213
78796	1397	1396695803000	6407	3319	1	0	4214
78797	1397	1396685802000	6407	3319	2	0	4215
78798	1397	1396675801000	6408	3320	0	0	4216
78800	1397	1396655799000	6408	3320	2	0	4218
78801	1397	1396645798000	6408	3320	3	0	4219
78802	1397	1396635797000	6409	3321	0	0	4220
78803	1397	1396625796000	6410	3322	0	0	4221
78805	1397	1396615795000	6410	3322	2	0	4222
78806	1397	1396605794000	6411	3323	0	0	4223
78807	1726	886980000000	6411	3323	1	0	89
78816	1397	1396595793000	6414	3324	0	0	4224
78817	1726	886970000000	6414	3324	1	0	90
78819	1397	1396575791000	6414	3324	3	0	4226
78820	1726	886960000000	6414	3324	4	0	91
78821	1726	886950000000	6414	3324	5	0	92
78842	1397	1396565790000	6421	3325	0	0	4227
78843	1726	886940000000	6421	3325	1	0	93
78881	1397	1398075941000	6422	3050	37	0	\N
78882	1397	1398065940000	6422	3050	38	0	\N
78883	1397	1398055939000	6422	3050	39	0	\N
78884	1397	1398045938000	6422	3050	40	0	\N
78885	1397	1398035937000	6422	3050	41	0	\N
78886	1397	1398025936000	6422	3050	42	0	\N
78887	1397	1398015935000	6422	3050	43	0	\N
78888	1397	1398005934000	6422	3050	44	0	\N
78889	1397	1397995933000	6422	3050	45	0	\N
78890	1397	1397985932000	6422	3050	46	0	\N
78891	1397	1397975931000	6422	3050	47	0	\N
78892	1397	1397965930000	6422	3050	48	0	\N
78893	1397	1397955929000	6422	3050	49	0	\N
78894	1397	1397945928000	6422	3050	50	0	\N
78895	1397	1397935927000	6422	3050	51	0	\N
78896	1397	1397925926000	6422	3050	52	0	\N
78897	1397	1397915925000	6422	3050	53	0	\N
78898	1397	1397905924000	6422	3050	54	0	\N
78899	1397	1397895923000	6422	3050	55	0	\N
78900	1397	1397885922000	6422	3050	56	0	\N
78901	1397	1397875921000	6422	3050	57	0	\N
78902	1397	1397865920000	6422	3050	59	0	\N
78903	1397	1397855919000	6422	3050	60	0	\N
78904	1397	1397845918000	6422	3050	61	0	\N
78905	1397	1397835917000	6422	3050	62	0	\N
78906	1397	1397825916000	6422	3050	63	0	\N
78907	1397	1397815915000	6422	3050	64	0	\N
78908	1397	1397805914000	6422	3050	65	0	\N
78909	1397	1397795913000	6422	3050	66	0	\N
78910	1397	1397785912000	6422	3050	67	0	\N
78911	1397	1397775911000	6422	3050	68	0	\N
78912	1397	1397765910000	6422	3050	69	0	\N
78913	1397	1397755909000	6422	3050	70	0	\N
78914	1397	1397745908000	6422	3050	71	0	\N
78915	1397	1397735907000	6422	3050	72	0	\N
78916	1397	1397725906000	6422	3050	73	0	\N
78917	1397	1397715905000	6422	3050	74	0	\N
78918	1397	1397705904000	6422	3050	75	0	\N
78919	1397	1397695903000	6422	3050	76	0	\N
78920	1397	1397685902000	6422	3050	77	0	\N
78921	1397	1397675901000	6422	3050	78	0	\N
78922	1397	1397665900000	6422	3050	79	0	\N
78923	1397	1397655899000	6422	3050	80	0	\N
78924	1397	1397645898000	6422	3050	81	0	\N
78925	1397	1397635897000	6422	3050	82	0	\N
78926	1397	1397625896000	6422	3050	83	0	\N
78927	1397	1397615895000	6422	3050	84	0	\N
78928	1397	1397605894000	6422	3050	85	0	\N
78929	1397	1397595893000	6422	3050	86	0	\N
78930	1397	1397585892000	6422	3050	87	0	\N
78931	1397	1397575891000	6422	3050	88	0	\N
78932	1397	1397565890000	6422	3050	89	0	\N
78935	1726	886930000000	6424	3326	0	0	\N
78936	1397	1396555789000	6424	3326	1	0	\N
78939	1726	886990000000	6426	3282	0	0	\N
78940	1726	886980000000	6426	3282	1	0	\N
78941	1726	886970000000	6426	3282	2	0	\N
78942	1726	886960000000	6426	3282	3	0	\N
78943	1726	886950000000	6426	3282	4	0	\N
78944	1726	886940000000	6426	3282	5	0	\N
78945	1726	886930000000	6426	3282	6	0	\N
78946	1726	886920000000	6426	3282	7	0	\N
78947	1726	886910000000	6427	3328	0	0	\N
78948	1726	886900000000	6427	3328	1	0	\N
78949	1397	1396535787000	6427	3328	2	0	\N
78950	1397	1396525786000	6427	3328	3	0	\N
78951	1726	886910000000	6428	3328	0	0	\N
78952	1726	886900000000	6428	3328	1	0	\N
78953	1397	1396535787000	6428	3328	2	0	\N
78954	1397	1396525786000	6428	3328	3	0	\N
78955	1726	886910000000	6429	3328	0	0	\N
78956	1726	886900000000	6429	3328	1	0	\N
78957	1397	1396535787000	6429	3328	2	0	\N
78958	1397	1396525786000	6429	3328	3	0	\N
78965	1397	1396505784000	6432	3330	0	0	\N
78966	1726	886880000000	6432	3330	1	0	\N
78967	1397	1396505784000	6433	3330	0	0	\N
78968	1726	886880000000	6433	3330	1	0	\N
78971	1397	1396505784000	6435	3330	0	0	\N
78972	1726	886880000000	6435	3330	1	0	\N
78975	1397	1396495783000	6437	3331	0	0	\N
78976	1726	886870000000	6437	3331	1	0	\N
78977	1397	1396495783000	6438	3331	0	0	\N
78978	1726	886870000000	6438	3331	1	0	\N
78993	1726	886800000000	6442	3334	0	0	\N
78994	1397	1396425776000	6442	3334	1	0	\N
78997	1726	886790000000	6445	3335	0	0	\N
78998	1397	1396415775000	6445	3335	1	0	\N
79005	1397	1396385772000	6449	3338	0	0	\N
79006	1726	886760000000	6449	3338	1	0	\N
79013	1397	1396365770000	6453	3341	0	0	\N
79014	1726	886730000000	6453	3341	1	0	\N
79015	1397	1396355769000	6453	3341	2	0	\N
78937	1726	886920000000	6425	3327	0	0	95
78938	1397	1396545788000	6425	3327	1	0	4229
78959	1726	886910000000	6430	3328	0	0	96
78960	1726	886900000000	6430	3328	1	0	97
78961	1397	1396535787000	6430	3328	2	0	4230
78963	1397	1396515785000	6431	3329	0	0	4232
78964	1726	886890000000	6431	3329	1	0	98
78969	1397	1396505784000	6434	3330	0	0	4233
78970	1726	886880000000	6434	3330	1	0	99
78973	1397	1396495783000	6436	3331	0	0	4234
78979	1726	886860000000	6439	3332	0	0	101
78980	1726	886850000000	6439	3332	1	0	102
78981	1726	886840000000	6439	3332	2	0	103
78982	1397	1396485782000	6439	3332	3	0	4235
78984	1397	1396465780000	6439	3332	5	0	4237
78985	1726	886830000000	6440	3333	0	0	104
78986	1726	886820000000	6440	3333	1	0	105
78987	1397	1396455779000	6440	3333	2	0	4238
78988	1726	886810000000	6440	3333	3	0	106
78990	1397	1396435777000	6440	3333	5	0	4240
78991	1726	886800000000	6441	3334	0	0	107
78992	1397	1396425776000	6441	3334	1	0	4241
78995	1726	886790000000	6444	3335	0	0	108
78996	1397	1396415775000	6444	3335	1	0	4242
79000	1397	1396405774000	6446	3336	1	0	4243
79001	1397	1396395773000	6447	3337	0	0	4244
79002	1726	886770000000	6447	3337	1	0	110
79003	1397	1396385772000	6448	3338	0	0	4245
79007	1726	886750000000	6450	3339	0	0	112
79008	1397	1396375771000	6450	3339	1	0	4246
79009	1726	886740000000	6451	3340	0	0	113
79010	1397	1396365770000	6452	3341	0	0	4247
79011	1726	886730000000	6452	3341	1	0	114
79016	1397	1396345768000	6454	3342	0	0	4249
79030	1397	1396295763000	6459	3346	0	0	\N
79031	1397	1396285762000	6459	3346	1	0	\N
79032	1726	886670000000	6459	3346	2	0	\N
79033	1726	886660000000	6459	3346	3	0	\N
79034	1397	1396295763000	6460	3346	0	0	\N
79035	1397	1396285762000	6460	3346	1	0	\N
79036	1726	886670000000	6460	3346	2	0	\N
79037	1726	886660000000	6460	3346	3	0	\N
79042	1726	886650000000	6462	3347	0	0	\N
79043	1726	886640000000	6462	3347	1	0	\N
79044	1397	1396275761000	6462	3347	2	0	\N
79045	1397	1396265760000	6462	3347	3	0	\N
79052	1397	1396225756000	6466	3350	0	0	\N
79053	1397	1396215755000	6467	3351	0	0	\N
79054	1726	884220000000	6467	3351	1	0	\N
79062	1397	1396165750000	6472	3355	0	0	\N
79063	1726	882909999000	6472	3355	1	0	\N
79068	1726	882899998000	6475	3356	0	0	\N
79069	1397	1396155749000	6475	3356	1	0	\N
79070	1397	1396145748000	6476	3357	0	0	\N
79071	1726	882889997000	6476	3357	1	0	\N
79078	1726	882859994000	6479	3359	0	0	\N
79079	1397	1396115745000	6479	3359	1	0	\N
79080	1726	882859994000	6480	3359	0	0	\N
79081	1397	1396115745000	6480	3359	1	0	\N
79082	1726	882859994000	6481	3359	0	0	\N
79083	1397	1396115745000	6481	3359	1	0	\N
79086	1397	1396105744000	6483	3360	0	0	\N
79087	1726	882849993000	6483	3360	1	0	\N
79092	1726	882839992000	6486	3361	0	0	\N
79093	1397	1396095743000	6486	3361	1	0	\N
79096	1726	890900000000	6488	3256	0	0	\N
79097	1726	889600000000	6488	3256	1	0	\N
79098	1726	888300000000	6488	3256	2	0	\N
79099	1726	887000000000	6488	3256	3	0	\N
79100	1726	886990000000	6488	3256	4	0	\N
79101	1726	886980000000	6488	3256	5	0	\N
79102	1726	886970000000	6488	3256	6	0	\N
79103	1726	886960000000	6488	3256	7	0	\N
79104	1726	886950000000	6488	3256	8	0	\N
79105	1726	886940000000	6488	3256	9	0	\N
79106	1726	886930000000	6488	3256	10	0	\N
79107	1726	886920000000	6488	3256	11	0	\N
79108	1726	886910000000	6488	3256	12	0	\N
79109	1726	886900000000	6488	3256	13	0	\N
79110	1726	886890000000	6488	3256	14	0	\N
79111	1726	886880000000	6488	3256	15	0	\N
79112	1726	886870000000	6488	3256	16	0	\N
79113	1726	886860000000	6488	3256	17	0	\N
79114	1726	886850000000	6488	3256	18	0	\N
79115	1726	886840000000	6488	3256	19	0	\N
79116	1726	886830000000	6488	3256	20	0	\N
79117	1726	886820000000	6488	3256	21	0	\N
79118	1726	886810000000	6488	3256	22	0	\N
79119	1726	886800000000	6488	3256	23	0	\N
79120	1726	886790000000	6488	3256	24	0	\N
79121	1726	886780000000	6488	3256	25	0	\N
79122	1726	886770000000	6488	3256	26	0	\N
79123	1726	886760000000	6488	3256	27	0	\N
79124	1726	886750000000	6488	3256	28	0	\N
79125	1726	886740000000	6488	3256	29	0	\N
79126	1726	886730000000	6488	3256	30	0	\N
79127	1726	886720000000	6488	3256	31	0	\N
79128	1726	886710000000	6488	3256	32	0	\N
79129	1726	886700000000	6488	3256	33	0	\N
79130	1726	886690000000	6488	3256	34	0	\N
79131	1726	886680000000	6488	3256	35	0	\N
79132	1726	886670000000	6488	3256	36	0	\N
79133	1726	886660000000	6488	3256	37	0	\N
79134	1726	886650000000	6488	3256	38	0	\N
79135	1726	886640000000	6488	3256	39	0	\N
79136	1726	886630000000	6488	3256	40	0	\N
79137	1726	885430000000	6488	3256	41	0	\N
79138	1726	884220000000	6488	3256	42	0	\N
79139	1726	882920000000	6488	3256	43	0	\N
79140	1726	882909999000	6488	3256	44	0	\N
79141	1726	882899998000	6488	3256	45	0	\N
79142	1726	882889997000	6488	3256	46	0	\N
79143	1726	882879996000	6488	3256	47	0	\N
79144	1726	882869995000	6488	3256	48	0	\N
79145	1726	882859994000	6488	3256	49	0	\N
79146	1726	882849993000	6488	3256	50	0	\N
79147	1726	882839992000	6488	3256	51	0	\N
79148	1726	882829991000	6488	3256	52	0	\N
79149	1726	882819990000	6488	3256	53	0	\N
79150	1397	1396075741000	6489	3363	0	0	\N
79151	1397	1396065740000	6489	3363	1	0	\N
79152	1726	882819990000	6489	3363	2	0	\N
79019	1726	886700000000	6456	3344	1	0	117
79020	1397	1396335767000	6456	3344	2	0	4250
79021	1397	1396325766000	6456	3344	3	0	4251
79022	1397	1396315765000	6457	3345	0	0	4252
79023	1397	1396305764000	6457	3345	1	0	4253
79025	1726	886680000000	6457	3345	3	0	119
79026	1397	1396295763000	6458	3346	0	0	4254
79027	1397	1396285762000	6458	3346	1	0	4255
79028	1726	886670000000	6458	3346	2	0	120
79029	1726	886660000000	6458	3346	3	0	121
79039	1726	886640000000	6461	3347	1	0	123
79040	1397	1396275761000	6461	3347	2	0	4256
79041	1397	1396265760000	6461	3347	3	0	4257
79046	1397	1396255759000	6463	3348	0	0	4258
79048	1726	885430000000	6464	3349	0	0	125
79049	1397	1396245758000	6464	3349	1	0	4259
79050	1397	1396235757000	6464	3349	2	0	4260
79051	1397	1396225756000	6465	3350	0	0	4261
79055	1397	1396215755000	6468	3351	0	0	4262
79057	1397	1396205754000	6469	3352	0	0	4263
79058	1397	1396195753000	6470	3353	0	0	4264
79059	1726	882920000000	6471	3354	0	0	127
79060	1397	1396185752000	6471	3354	1	0	4265
79061	1397	1396175751000	6471	3354	2	0	4266
79065	1726	882909999000	6473	3355	1	0	128
79066	1726	882899998000	6474	3356	0	0	129
79067	1397	1396155749000	6474	3356	1	0	4268
79072	1397	1396145748000	6477	3357	0	0	4269
79074	1397	1396135747000	6478	3358	0	0	4270
79075	1397	1396125746000	6478	3358	1	0	4271
79076	1726	882879996000	6478	3358	2	0	131
79077	1726	882869995000	6478	3358	3	0	132
79084	1726	882859994000	6482	3359	0	0	133
79088	1397	1396105744000	6484	3360	0	0	4273
79089	1726	882849993000	6484	3360	1	0	134
79090	1726	882839992000	6485	3361	0	0	135
79091	1397	1396095743000	6485	3361	1	0	4274
79094	1397	1396085742000	6487	3362	0	0	4275
79153	1726	882809989000	6489	3363	3	0	\N
79162	1726	882789987000	6493	3365	0	0	\N
79163	1397	1396045738000	6493	3365	1	0	\N
79164	1397	1396035737000	6494	3366	0	0	\N
79165	1726	882779986000	6494	3366	1	0	\N
79168	1726	882769985000	6496	3367	0	0	\N
79169	1726	882759984000	6496	3367	1	0	\N
79170	1397	1396025736000	6496	3367	2	0	\N
79171	1397	1396015735000	6496	3367	3	0	\N
79176	1726	882749983000	6499	3368	0	0	\N
79177	1397	1396005734000	6499	3368	1	0	\N
79184	1397	1395975731000	6503	3371	0	0	\N
79185	1726	882719980000	6503	3371	1	0	\N
79196	1397	1395935727000	6508	3374	0	0	\N
79197	1726	882679976000	6508	3374	1	0	\N
79200	1397	1395925726000	6510	3375	0	0	\N
79201	1726	882669975000	6510	3375	1	0	\N
79202	1397	1395925726000	6511	3375	0	0	\N
79203	1726	882669975000	6511	3375	1	0	\N
79204	1397	1395925726000	6512	3375	0	0	\N
79205	1726	882669975000	6512	3375	1	0	\N
79212	1726	882649973000	6515	3377	0	0	\N
79213	1726	882639972000	6515	3377	1	0	\N
79214	1397	1395905724000	6515	3377	2	0	\N
79215	1397	1395895723000	6515	3377	3	0	\N
79216	1726	882649973000	6517	3377	0	0	\N
79217	1726	882639972000	6517	3377	1	0	\N
79218	1397	1395905724000	6517	3377	2	0	\N
79219	1397	1395895723000	6517	3377	3	0	\N
79222	1397	1395875721000	6519	3379	0	0	\N
79223	1726	882619970000	6519	3379	1	0	\N
79224	1397	1395875721000	6520	3379	0	0	\N
79225	1726	882619970000	6520	3379	1	0	\N
79230	1726	882609969000	6523	3380	0	0	\N
79231	1397	1395865720000	6523	3380	1	0	\N
79232	1726	882609969000	6524	3380	0	0	\N
79233	1397	1395865720000	6524	3380	1	0	\N
79242	1726	882569965000	6529	3384	0	0	\N
79243	1397	1395825716000	6529	3384	1	0	\N
79244	1726	882569965000	6530	3384	0	0	\N
79245	1397	1395825716000	6530	3384	1	0	\N
79246	1397	1395815715000	6531	3385	0	0	\N
79247	1726	882559964000	6531	3385	1	0	\N
79250	1397	1395815715000	6533	3385	0	0	\N
79251	1726	882559964000	6533	3385	1	0	\N
79254	1726	882539962000	6535	3387	0	0	\N
79255	1397	1395795713000	6535	3387	1	0	\N
79258	1726	882539962000	6538	3387	0	0	\N
79259	1397	1395795713000	6538	3387	1	0	\N
79262	1397	1395785712000	6540	3388	0	0	\N
79263	1726	882529961000	6540	3388	1	0	\N
79266	1726	882509959000	6542	3390	0	0	\N
79267	1397	1395765710000	6542	3390	1	0	\N
79284	1397	1395695703000	6551	3395	0	0	\N
79285	1726	882439952000	6551	3395	1	0	\N
79286	1397	1395695703000	6552	3395	0	0	\N
79287	1726	882439952000	6552	3395	1	0	\N
79156	1726	882819990000	6490	3363	2	0	137
79157	1726	882809989000	6490	3363	3	0	138
79158	1726	882799988000	6491	3364	0	0	139
79159	1397	1396055739000	6491	3364	1	0	4278
79160	1726	882789987000	6492	3365	0	0	140
79166	1397	1396035737000	6495	3366	0	0	4280
79167	1726	882779986000	6495	3366	1	0	141
79172	1726	882769985000	6497	3367	0	0	142
79173	1726	882759984000	6497	3367	1	0	143
79174	1397	1396025736000	6497	3367	2	0	4281
79178	1726	882749983000	6500	3368	0	0	144
79179	1397	1396005734000	6500	3368	1	0	4283
79180	1397	1395995733000	6501	3369	0	0	4284
79181	1726	882739982000	6501	3369	1	0	145
79183	1726	882729981000	6502	3370	1	0	146
79186	1397	1395975731000	6504	3371	0	0	4286
79187	1726	882719980000	6504	3371	1	0	147
79188	1397	1395965730000	6505	3372	0	0	4287
79189	1726	882709979000	6505	3372	1	0	148
79191	1397	1395945728000	6506	3373	1	0	4289
79192	1726	882699978000	6506	3373	2	0	149
79193	1726	882689977000	6506	3373	3	0	150
79194	1397	1395935727000	6507	3374	0	0	4290
79195	1726	882679976000	6507	3374	1	0	151
79199	1726	882669975000	6509	3375	1	0	152
79206	1726	882659974000	6513	3376	0	0	153
79207	1397	1395915725000	6513	3376	1	0	4292
79208	1726	882649973000	6514	3377	0	0	154
79210	1397	1395905724000	6514	3377	2	0	4293
79211	1397	1395895723000	6514	3377	3	0	4294
79220	1726	882629971000	6518	3378	0	0	156
79221	1397	1395885722000	6518	3378	1	0	4295
79226	1397	1395875721000	6521	3379	0	0	4296
79228	1726	882609969000	6522	3380	0	0	158
79229	1397	1395865720000	6522	3380	1	0	4297
79234	1726	882599968000	6525	3381	0	0	159
79235	1397	1395855719000	6525	3381	1	0	4298
79236	1397	1395845718000	6526	3382	0	0	4299
79238	1397	1395835717000	6527	3383	0	0	4300
79239	1726	882579966000	6527	3383	1	0	161
79240	1726	882569965000	6528	3384	0	0	162
79241	1397	1395825716000	6528	3384	1	0	4301
79249	1726	882559964000	6532	3385	1	0	163
79252	1397	1395805714000	6534	3386	0	0	4303
79253	1726	882549963000	6534	3386	1	0	164
79256	1726	882539962000	6537	3387	0	0	165
79257	1397	1395795713000	6537	3387	1	0	4304
79261	1726	882529961000	6539	3388	1	0	166
79264	1397	1395775711000	6541	3389	0	0	4306
79265	1726	882519960000	6541	3389	1	0	167
79268	1726	882509959000	6543	3390	0	0	168
79269	1397	1395765710000	6543	3390	1	0	4307
79271	1397	1395755709000	6544	3391	1	0	4308
79272	1726	882489957000	6546	3392	0	0	170
79273	1726	882479956000	6546	3392	1	0	171
79274	1397	1395745708000	6546	3392	2	0	4309
79276	1397	1395725706000	6546	3392	4	0	4311
79277	1726	882469955000	6546	3392	5	0	172
79278	1397	1395715705000	6547	3393	0	0	4312
79279	1726	882459954000	6547	3393	1	0	173
79280	1397	1395705704000	6548	3394	0	0	4313
79282	1397	1395695703000	6550	3395	0	0	4314
79283	1726	882439952000	6550	3395	1	0	175
79288	1397	1395685702000	6553	3396	0	0	4315
79291	1397	1395685702000	6554	3396	0	0	\N
79292	1726	882429951000	6554	3396	1	0	\N
79293	1540	715009000000	6554	3396	2	0	\N
79294	1726	882419950000	6555	3397	0	0	\N
79295	1397	1395675701000	6555	3397	1	0	\N
79298	1726	882419950000	6558	3397	0	0	\N
79299	1397	1395675701000	6558	3397	1	0	\N
79301	1397	1395655699000	6560	3399	0	0	\N
79302	1726	882409949000	6560	3399	1	0	\N
79303	1397	1395655699000	6561	3399	0	0	\N
79304	1726	882409949000	6561	3399	1	0	\N
79305	1397	1395655699000	6562	3399	0	0	\N
79306	1726	882409949000	6562	3399	1	0	\N
79307	1397	1395655699000	6563	3399	0	0	\N
79308	1726	882409949000	6563	3399	1	0	\N
79309	1540	715009000000	6564	3389	0	0	\N
79310	1397	1395655699000	6565	3399	0	0	\N
79311	1726	882409949000	6565	3399	1	0	\N
79318	1397	1395625696000	6569	3402	0	0	\N
79319	1726	882379946000	6569	3402	1	0	\N
79320	1397	1395625696000	6570	3402	0	0	\N
79321	1726	882379946000	6570	3402	1	0	\N
79328	1397	1395615695000	6573	3403	0	0	\N
79329	1397	1395605694000	6573	3403	1	0	\N
79330	1726	882369945000	6573	3403	2	0	\N
79331	1726	882359944000	6573	3403	3	0	\N
79332	1397	1395615695000	6574	3403	0	0	\N
79333	1397	1395605694000	6574	3403	1	0	\N
79334	1726	882369945000	6574	3403	2	0	\N
79335	1726	882359944000	6574	3403	3	0	\N
79336	1726	882349943000	6575	3404	0	0	\N
79337	1397	1395595693000	6575	3404	1	0	\N
79342	1726	882339942000	6578	3405	0	0	\N
79343	1397	1395585692000	6578	3405	1	0	\N
79344	1726	882339942000	6579	3405	0	0	\N
79345	1397	1395585692000	6579	3405	1	0	\N
79346	1726	882339942000	6580	3405	0	0	\N
79347	1397	1395585692000	6580	3405	1	0	\N
79348	1726	882339942000	6581	3405	0	0	\N
79349	1397	1395585692000	6581	3405	1	0	\N
79350	1540	715009000000	6582	3365	0	0	\N
79354	1876	3980000000	6584	3407	0	0	\N
79355	1397	1395565690000	6584	3407	1	0	\N
79356	1397	1395555689000	6584	3407	2	0	\N
79357	1726	882319940000	6584	3407	3	0	\N
79358	1726	882309939000	6584	3407	4	0	\N
79364	1876	3980000000	6586	3407	0	0	\N
79365	1397	1395565690000	6586	3407	1	0	\N
79366	1397	1395555689000	6586	3407	2	0	\N
79367	1726	882319940000	6586	3407	3	0	\N
79368	1726	882309939000	6586	3407	4	0	\N
79369	1540	367308000000	6587	3366	0	0	\N
79370	1726	882299938000	6588	3408	0	0	\N
79371	1726	882289937000	6588	3408	1	0	\N
79372	1397	1395545688000	6588	3408	2	0	\N
79373	1876	2970000000	6588	3408	3	0	\N
79374	1726	882279936000	6588	3408	4	0	\N
79375	1726	882269935000	6588	3408	5	0	\N
79376	1397	1395535687000	6588	3408	6	0	\N
79377	1397	1395525686000	6588	3408	7	0	\N
79378	1540	367308000000	6588	3408	8	0	\N
79394	1397	1395495683000	6593	3411	0	0	\N
79395	1726	882239932000	6593	3411	1	0	\N
79396	1397	1395495683000	6594	3411	0	0	\N
79397	1726	882239932000	6594	3411	1	0	\N
79400	1397	1395475681000	6597	3413	0	0	\N
79401	1397	1395465680000	6597	3413	1	0	\N
79402	1726	882219930000	6597	3413	2	0	\N
79403	1726	882209929000	6597	3413	3	0	\N
79404	1397	1395475681000	6598	3413	0	0	\N
79405	1397	1395465680000	6598	3413	1	0	\N
79406	1726	882219930000	6598	3413	2	0	\N
79407	1726	882209929000	6598	3413	3	0	\N
79408	1397	1395475681000	6599	3413	0	0	\N
79409	1397	1395465680000	6599	3413	1	0	\N
79410	1726	882219930000	6599	3413	2	0	\N
79411	1726	882209929000	6599	3413	3	0	\N
79412	1397	1395475681000	6600	3413	0	0	\N
79413	1397	1395465680000	6600	3413	1	0	\N
79414	1726	882219930000	6600	3413	2	0	\N
79415	1726	882209929000	6600	3413	3	0	\N
79416	1540	715009000000	6601	3328	0	0	\N
79417	1540	367308000000	6601	3328	1	0	\N
79296	1726	882419950000	6557	3397	0	0	177
79297	1397	1395675701000	6557	3397	1	0	4316
79300	1397	1395665700000	6559	3398	0	0	4317
79312	1397	1395655699000	6566	3399	0	0	4318
79313	1726	882409949000	6566	3399	1	0	178
79315	1397	1395645698000	6567	3400	1	0	4319
79316	1397	1395635697000	6568	3401	0	0	4320
79317	1726	882389947000	6568	3401	1	0	180
79322	1397	1395625696000	6571	3402	0	0	4321
79323	1726	882379946000	6571	3402	1	0	181
79325	1397	1395605694000	6572	3403	1	0	4323
79326	1726	882369945000	6572	3403	2	0	182
79327	1726	882359944000	6572	3403	3	0	183
79338	1726	882349943000	6576	3404	0	0	184
79340	1726	882339942000	6577	3405	0	0	185
79341	1397	1395585692000	6577	3405	1	0	4325
79351	1876	3990000000	6583	3406	0	0	1
79352	1726	882329941000	6583	3406	1	0	186
79353	1397	1395575691000	6583	3406	2	0	4326
79360	1397	1395565690000	6585	3407	1	0	4327
79361	1397	1395555689000	6585	3407	2	0	4328
79362	1726	882319940000	6585	3407	3	0	187
79363	1726	882309939000	6585	3407	4	0	188
79379	1726	882299938000	6589	3408	0	0	189
79381	1397	1395545688000	6589	3408	2	0	4329
79382	1876	2970000000	6589	3408	3	0	3
79383	1726	882279936000	6589	3408	4	0	191
79384	1726	882269935000	6589	3408	5	0	192
79386	1397	1395525686000	6589	3408	7	0	4331
79387	1540	367308000000	6589	3408	8	0	2
79388	1726	882259934000	6590	3409	0	0	193
79389	1397	1395515685000	6590	3409	1	0	4332
79390	1726	882249933000	6591	3410	0	0	194
79392	1397	1395495683000	6592	3411	0	0	4334
79393	1726	882239932000	6592	3411	1	0	195
79398	1397	1395485682000	6595	3412	0	0	4335
79399	1726	882229931000	6595	3412	1	0	196
79418	1397	1395475681000	6602	3414	0	0	4336
79420	1397	1395455679000	6602	3414	2	0	4338
79421	1726	882219930000	6602	3414	3	0	197
79422	1726	882209929000	6602	3414	4	0	198
79423	1726	882199928000	6602	3414	5	0	199
79428	1397	1395445678000	6604	3415	0	0	\N
79429	1397	1395435677000	6604	3415	1	0	\N
79430	1726	882189927000	6604	3415	2	0	\N
79431	1726	882179926000	6604	3415	3	0	\N
79434	1397	1395415675000	6606	3417	0	0	\N
79435	1397	1395405674000	6606	3417	1	0	\N
79436	1397	1395395673000	6606	3417	2	0	\N
79437	1726	882159924000	6606	3417	3	0	\N
79438	1397	1395385672000	6606	3417	4	0	\N
79439	1726	882149923000	6606	3417	5	0	\N
79440	1726	882139922000	6606	3417	6	0	\N
79441	1726	882129921000	6606	3417	7	0	\N
79452	1726	882109919000	6609	3419	0	0	\N
79453	1397	1395365670000	6609	3419	1	0	\N
79456	1726	882109919000	6611	3419	0	0	\N
79457	1397	1395365670000	6611	3419	1	0	\N
79458	1726	882109919000	6612	3419	0	0	\N
79459	1397	1395365670000	6612	3419	1	0	\N
79468	1397	1395315665000	6620	3424	0	0	\N
79469	1726	882059914000	6620	3424	1	0	\N
79472	1397	1395315665000	6622	3424	0	0	\N
79473	1726	882059914000	6622	3424	1	0	\N
79478	1397	1395285662000	6624	3426	0	0	\N
79479	1397	1395275661000	6624	3426	1	0	\N
79480	1397	1395265660000	6624	3426	2	0	\N
79481	606	76800190000000	6624	3426	3	0	\N
79482	1726	882029911000	6625	3426	0	0	\N
79483	1726	882019910000	6625	3426	1	0	\N
79484	1726	882009909000	6625	3426	2	0	\N
79485	1397	1395285662000	6625	3426	3	0	\N
79486	1397	1395275661000	6625	3426	4	0	\N
79487	1397	1395265660000	6625	3426	5	0	\N
79488	606	76800190000000	6625	3426	6	0	\N
79500	1726	881999908000	6632	3427	0	0	\N
79501	1397	1395255659000	6632	3427	2	0	\N
79502	1397	1395245658000	6632	3427	3	0	\N
79503	1726	881989907000	6632	3427	4	0	\N
79504	1397	1395235657000	6633	3428	0	0	\N
79505	1726	881979906000	6633	3428	1	0	\N
79506	1397	1395235657000	6634	3428	0	0	\N
79507	1726	881979906000	6634	3428	1	0	\N
79512	1726	881969905000	6637	3429	0	0	\N
79513	1397	1395225656000	6637	3429	1	0	\N
79538	1397	1395105644000	6645	3436	0	0	\N
79539	1726	881849893000	6645	3436	1	0	\N
79540	1397	1395105644000	6646	3436	0	0	\N
79541	1726	881849893000	6646	3436	1	0	\N
79544	1726	881839892000	6648	3437	0	0	\N
79545	1397	1395095643000	6648	3437	1	0	\N
79550	1397	1395065640000	6650	3439	0	0	\N
79551	1726	881809889000	6650	3439	1	0	\N
79556	1397	1395055639000	6653	3440	0	0	\N
79557	1726	881799888000	6653	3440	1	0	\N
79427	1726	882179926000	6603	3415	3	0	201
79432	1397	1395425676000	6605	3416	0	0	4341
79433	1726	882169925000	6605	3416	1	0	202
79442	1397	1395415675000	6607	3417	0	0	4342
79443	1397	1395405674000	6607	3417	1	0	4343
79445	1726	882159924000	6607	3417	3	0	203
79446	1397	1395385672000	6607	3417	4	0	4345
79447	1726	882149923000	6607	3417	5	0	204
79448	1726	882139922000	6607	3417	6	0	205
79449	1726	882129921000	6607	3417	7	0	206
79451	1397	1395375671000	6608	3418	1	0	4346
79454	1726	882109919000	6610	3419	0	0	208
79455	1397	1395365670000	6610	3419	1	0	4347
79460	1726	882099918000	6616	3420	0	0	209
79462	1726	882089917000	6617	3421	0	0	210
79463	1397	1395345668000	6617	3421	1	0	4349
79464	1397	1395335667000	6618	3422	0	0	4350
79465	1726	882079916000	6618	3422	1	0	211
79466	1397	1395325666000	6619	3423	0	0	4351
79470	1397	1395315665000	6621	3424	0	0	4352
79471	1726	882059914000	6621	3424	1	0	213
79474	1397	1395305664000	6623	3425	0	0	4353
79475	1397	1395295663000	6623	3425	1	0	4354
79476	1726	882049913000	6623	3425	2	0	214
79489	1726	882029911000	6626	3426	0	0	216
79490	1726	882019910000	6626	3426	1	0	217
79491	1726	882009909000	6626	3426	2	0	218
79492	1397	1395285662000	6626	3426	3	0	4355
79494	1397	1395265660000	6626	3426	5	0	4357
79495	606	76800190000000	6626	3426	6	0	1
79496	1726	881999908000	6631	3427	0	0	219
79497	1397	1395255659000	6631	3427	2	0	4358
79498	1397	1395245658000	6631	3427	3	0	4359
79508	1397	1395235657000	6635	3428	0	0	4360
79509	1726	881979906000	6635	3428	1	0	221
79510	1726	881969905000	6636	3429	0	0	222
79511	1397	1395225656000	6636	3429	1	0	4361
79514	1726	881959904000	6638	3430	0	0	223
79516	1397	1395205654000	6638	3430	2	0	4363
79517	1397	1395195653000	6638	3430	3	0	4364
79518	1726	881949903000	6638	3430	4	0	224
79519	1726	881939902000	6638	3430	5	0	225
79521	1397	1395175651000	6639	3431	1	0	4366
79522	1726	881929901000	6639	3431	2	0	226
79523	1726	881919900000	6639	3431	3	0	227
79524	1726	881909899000	6640	3432	0	0	228
79525	1397	1395165650000	6640	3432	1	0	4367
79527	1726	881889897000	6641	3433	1	0	230
79528	1397	1395155649000	6641	3433	2	0	4368
79529	1397	1395145648000	6641	3433	3	0	4369
79530	1397	1395135647000	6642	3434	0	0	4370
79531	1397	1395125646000	6642	3434	1	0	4371
79533	1726	881869895000	6642	3434	3	0	232
79534	1726	881859894000	6643	3435	0	0	233
79535	1397	1395115645000	6643	3435	1	0	4372
79536	1397	1395105644000	6644	3436	0	0	4373
79542	1726	881839892000	6647	3437	0	0	235
79543	1397	1395095643000	6647	3437	1	0	4374
79546	1726	881829891000	6649	3438	0	0	236
79547	1726	881819890000	6649	3438	1	0	237
79548	1397	1395085642000	6649	3438	2	0	4375
79552	1397	1395065640000	6651	3439	0	0	4377
79553	1726	881809889000	6651	3439	1	0	238
79554	1397	1395055639000	6652	3440	0	0	4378
79555	1726	881799888000	6652	3440	1	0	239
79558	1397	1395045638000	6654	3441	0	0	4379
79560	1397	1395025636000	6654	3441	2	0	4381
79564	1397	1395015635000	6655	3442	0	0	\N
79565	1726	881759884000	6655	3442	1	0	\N
79566	1397	1395015635000	6656	3442	0	0	\N
79567	1726	881759884000	6656	3442	1	0	\N
79568	1397	1395015635000	6657	3442	0	0	\N
79569	1726	881759884000	6657	3442	1	0	\N
79572	1726	881749883000	6659	3443	0	0	\N
79573	1397	1395005634000	6659	3443	1	0	\N
79575	1726	881749883000	6661	3443	0	0	\N
79576	1397	1395005634000	6661	3443	1	0	\N
79577	1726	881739882000	6662	3444	0	0	\N
79578	1397	1395005634000	6662	3444	1	0	\N
79579	1397	1394995633000	6662	3444	2	0	\N
79583	1726	881749883000	6664	3443	0	0	\N
79584	1726	881739882000	6664	3443	1	0	\N
79585	1397	1395005634000	6664	3443	2	0	\N
79586	1397	1394995633000	6664	3443	3	0	\N
79587	1726	881729881000	6665	3445	0	0	\N
79588	1397	1394985632000	6665	3445	1	0	\N
79589	1726	881729881000	6666	3445	0	0	\N
79590	1397	1394985632000	6666	3445	1	0	\N
79595	1397	1394965630000	6669	3447	0	0	\N
79596	1397	1394955629000	6669	3447	1	0	\N
79597	1726	881709879000	6669	3447	2	0	\N
79598	1726	881699878000	6669	3447	3	0	\N
79603	1397	1394965630000	6671	3447	0	0	\N
79604	1397	1394955629000	6671	3447	1	0	\N
79605	1726	881709879000	6671	3447	2	0	\N
79606	1726	881699878000	6671	3447	3	0	\N
79611	1726	886990000000	6674	3310	0	0	\N
79612	1726	886980000000	6674	3310	1	0	\N
79613	1726	886970000000	6674	3310	2	0	\N
79614	1726	886960000000	6674	3310	3	0	\N
79615	1726	886950000000	6674	3310	4	0	\N
79616	606	76800190000000	6674	3310	5	0	\N
79617	1726	886940000000	6674	3310	6	0	\N
79618	1726	886930000000	6674	3310	7	0	\N
79619	1726	886920000000	6674	3310	8	0	\N
79620	1726	886910000000	6674	3310	9	0	\N
79621	1726	886900000000	6674	3310	10	0	\N
79622	1726	886890000000	6674	3310	11	0	\N
79623	1726	886880000000	6674	3310	12	0	\N
79624	1726	886870000000	6674	3310	13	0	\N
79625	1726	886860000000	6674	3310	14	0	\N
79626	1726	886850000000	6674	3310	15	0	\N
79627	606	76800190000000	6675	3367	0	0	\N
79636	1798	180000000	6679	3453	0	0	\N
79637	1726	881639871000	6679	3453	1	0	\N
79638	1726	881629870000	6679	3453	3	0	\N
79639	1397	1394885622000	6679	3453	4	0	\N
79640	1397	1394875621000	6679	3453	5	0	\N
79646	1798	180000000	6681	3453	0	0	\N
79647	1726	881639871000	6681	3453	1	0	\N
79648	1726	881629870000	6681	3453	3	0	\N
79649	1397	1394885622000	6681	3453	4	0	\N
79650	1397	1394875621000	6681	3453	5	0	\N
79654	1397	1394855619000	6683	3455	0	0	\N
79655	1397	1394845618000	6683	3455	1	0	\N
79656	1726	881619868000	6683	3455	2	0	\N
79657	1726	881609867000	6683	3455	3	0	\N
79658	1397	1394855619000	6684	3455	0	0	\N
79659	1397	1394845618000	6684	3455	1	0	\N
79660	1726	881619868000	6684	3455	2	0	\N
79661	1726	881609867000	6684	3455	3	0	\N
79666	1798	180000000	6686	3368	0	0	\N
79667	1798	160000000	6686	3368	1	0	\N
79668	1798	158000000	6686	3368	2	0	\N
79669	1798	156000000	6686	3368	3	0	\N
79670	1798	154000000	6686	3368	4	0	\N
79671	1798	152000000	6686	3368	5	0	\N
79672	1798	150000000	6686	3368	6	0	\N
79688	1798	180000000	6689	3283	0	0	\N
79689	1798	160000000	6689	3283	1	0	\N
79690	1726	886930000000	6689	3283	2	0	\N
79691	1726	886920000000	6689	3283	3	0	\N
79692	1726	886910000000	6689	3283	4	0	\N
79693	1726	886900000000	6689	3283	5	0	\N
79694	1726	886890000000	6689	3283	6	0	\N
79695	1726	886880000000	6689	3283	7	0	\N
79696	1726	886870000000	6689	3283	8	0	\N
79563	1726	881769885000	6654	3441	5	0	242
79570	1397	1395015635000	6658	3442	0	0	4382
79571	1726	881759884000	6658	3442	1	0	243
79574	1726	881749883000	6660	3443	0	0	244
79580	1726	881739882000	6663	3444	0	0	245
79582	1397	1394995633000	6663	3444	2	0	4384
79591	1726	881729881000	6667	3445	0	0	246
79592	1397	1394985632000	6667	3445	1	0	4385
79593	1726	881719880000	6668	3446	0	0	247
79594	1397	1394975631000	6668	3446	1	0	4386
79600	1397	1394955629000	6670	3447	1	0	4388
79601	1726	881709879000	6670	3447	2	0	248
79602	1726	881699878000	6670	3447	3	0	249
79607	1726	881689877000	6672	3448	0	0	250
79609	1726	881679876000	6673	3449	0	0	251
79610	1397	1394935627000	6673	3449	1	0	4390
79628	1726	881669875000	6676	3450	0	0	252
79629	1726	881659874000	6676	3450	1	0	253
79630	1397	1394925626000	6676	3450	2	0	4391
79632	1397	1394905624000	6677	3451	0	0	4393
79633	1726	881649873000	6677	3451	1	0	254
79634	1397	1394895623000	6678	3452	0	0	4394
79635	1726	881639872000	6678	3452	1	0	255
79641	1798	180000000	6680	3453	0	0	1
79643	1726	881629870000	6680	3453	3	0	257
79644	1397	1394885622000	6680	3453	4	0	4395
79645	1397	1394875621000	6680	3453	5	0	4396
79651	1397	1394865620000	6682	3454	0	0	4397
79653	1726	881629869000	6682	3454	2	0	258
79662	1397	1394855619000	6685	3455	0	0	4398
79663	1397	1394845618000	6685	3455	1	0	4399
79664	1726	881619868000	6685	3455	2	0	259
79665	1726	881609867000	6685	3455	3	0	260
79674	1726	881589865000	6687	3456	1	0	262
79675	1726	881579864000	6687	3456	2	0	263
79676	1397	1394835617000	6687	3456	3	0	4400
79677	1397	1394825616000	6687	3456	4	0	4401
79678	1397	1394815615000	6687	3456	5	0	4402
79680	1798	156000000	6687	3456	7	0	4
79681	1798	154000000	6687	3456	8	0	5
79682	1798	152000000	6687	3456	9	0	6
79683	1798	150000000	6687	3456	10	0	7
79685	1726	881564862000	6688	3457	1	0	265
79686	1397	1394805614000	6688	3457	2	0	4403
79687	1397	1394795613000	6688	3457	3	0	4404
79697	1726	886860000000	6689	3283	9	0	\N
79698	1726	886850000000	6689	3283	10	0	\N
79699	1726	886840000000	6689	3283	11	0	\N
79700	1726	886830000000	6689	3283	12	0	\N
79701	1726	886820000000	6689	3283	13	0	\N
79702	1726	886810000000	6689	3283	14	0	\N
79703	1726	886800000000	6689	3283	15	0	\N
79704	1726	886790000000	6689	3283	16	0	\N
79705	606	76800190000000	6689	3283	17	0	\N
79706	1726	886780000000	6689	3283	18	0	\N
79707	1726	886770000000	6689	3283	19	0	\N
79708	1726	886760000000	6689	3283	20	0	\N
79709	1726	886750000000	6689	3283	21	0	\N
79710	1726	886740000000	6689	3283	22	0	\N
79711	1726	886730000000	6689	3283	23	0	\N
79712	1726	886720000000	6689	3283	24	0	\N
79713	1726	886710000000	6689	3283	25	0	\N
79714	1726	886700000000	6689	3283	26	0	\N
79715	1726	886690000000	6689	3283	27	0	\N
79716	1726	886680000000	6689	3283	28	0	\N
79717	1726	886670000000	6689	3283	29	0	\N
79718	1726	886660000000	6689	3283	30	0	\N
79719	1726	886650000000	6689	3283	31	0	\N
79720	1726	885450000000	6689	3283	32	0	\N
79721	1726	884240000000	6689	3283	33	0	\N
79722	1726	882940000000	6689	3283	34	0	\N
79723	1726	882929999000	6689	3283	35	0	\N
79724	1726	882919998000	6689	3283	36	0	\N
79725	1726	882909997000	6689	3283	37	0	\N
79726	1726	882899996000	6689	3283	38	0	\N
79727	1726	882889995000	6689	3283	39	0	\N
79728	1726	882879994000	6689	3283	40	0	\N
79729	1726	882869993000	6689	3283	41	0	\N
79730	1726	882859992000	6689	3283	42	0	\N
79731	1726	882849991000	6689	3283	43	0	\N
79732	1726	882839990000	6689	3283	44	0	\N
79733	1726	882829989000	6689	3283	45	0	\N
79734	1726	882819988000	6689	3283	46	0	\N
79735	1726	882809987000	6689	3283	47	0	\N
79736	1726	882799986000	6689	3283	48	0	\N
79737	1726	882789985000	6689	3283	49	0	\N
79738	1726	882779984000	6689	3283	50	0	\N
79739	1726	882769983000	6689	3283	51	0	\N
79740	1726	882759982000	6689	3283	52	0	\N
79741	1726	882749981000	6689	3283	53	0	\N
79742	1726	882739980000	6689	3283	54	0	\N
79743	1726	882729979000	6689	3283	55	0	\N
79744	1726	882719978000	6689	3283	56	0	\N
79745	1726	882709977000	6689	3283	57	0	\N
79746	1726	882699976000	6689	3283	58	0	\N
79747	1726	882689975000	6689	3283	59	0	\N
79748	1726	882679974000	6689	3283	60	0	\N
79749	1726	882669973000	6689	3283	61	0	\N
79750	1726	882659972000	6689	3283	62	0	\N
79751	1726	882649971000	6689	3283	63	0	\N
79752	1726	882639970000	6689	3283	64	0	\N
79753	1726	882629969000	6689	3283	65	0	\N
79754	1726	882619968000	6689	3283	66	0	\N
79755	1726	882609967000	6689	3283	67	0	\N
79756	1726	882599966000	6689	3283	68	0	\N
79757	1726	882589965000	6689	3283	69	0	\N
79758	1726	882579964000	6689	3283	70	0	\N
79759	1726	882569963000	6689	3283	71	0	\N
79760	1726	882559962000	6689	3283	72	0	\N
79761	1726	882549961000	6689	3283	73	0	\N
79762	1726	882539960000	6689	3283	74	0	\N
79763	1726	882529959000	6689	3283	75	0	\N
79764	1726	882519958000	6689	3283	76	0	\N
79765	1726	882509957000	6689	3283	77	0	\N
79766	1726	882499956000	6689	3283	78	0	\N
79767	1726	882489955000	6689	3283	79	0	\N
79768	1726	882479954000	6689	3283	80	0	\N
79769	1726	882469953000	6689	3283	81	0	\N
79770	1726	882459952000	6689	3283	82	0	\N
79771	1726	882449951000	6689	3283	83	0	\N
79772	1726	882439950000	6689	3283	84	0	\N
79773	1726	882429949000	6689	3283	85	0	\N
79774	1726	882419948000	6689	3283	86	0	\N
79775	1726	882409947000	6689	3283	87	0	\N
79776	1726	882399946000	6689	3283	88	0	\N
79777	1726	882389945000	6689	3283	89	0	\N
79778	1726	882379944000	6689	3283	90	0	\N
79779	1726	882369943000	6689	3283	91	0	\N
79780	1726	882359942000	6689	3283	92	0	\N
79781	1726	882349941000	6689	3283	93	0	\N
79782	1726	882339940000	6689	3283	94	0	\N
79783	1726	882329939000	6689	3283	95	0	\N
79784	1726	882319938000	6689	3283	96	0	\N
79785	1726	882309937000	6689	3283	97	0	\N
79786	1726	882299936000	6689	3283	98	0	\N
79787	1726	882289935000	6689	3283	99	0	\N
79788	1726	882279934000	6689	3283	100	0	\N
79789	1726	882269933000	6689	3283	101	0	\N
79790	1726	882259932000	6689	3283	102	0	\N
79791	1726	882249931000	6689	3283	103	0	\N
79792	1726	882239930000	6689	3283	105	0	\N
79793	1726	882229929000	6689	3283	106	0	\N
79794	1726	882219928000	6689	3283	107	0	\N
79795	1726	882209927000	6689	3283	108	0	\N
79796	1726	882199926000	6689	3283	109	0	\N
79797	1726	882189925000	6689	3283	110	0	\N
79798	1726	882179924000	6689	3283	111	0	\N
79799	1726	882169923000	6689	3283	112	0	\N
79800	1726	882159922000	6689	3283	113	0	\N
79801	1726	882149921000	6689	3283	114	0	\N
79802	1726	882139920000	6689	3283	115	0	\N
79803	1726	882129919000	6689	3283	116	0	\N
79804	1726	882119918000	6689	3283	117	0	\N
79805	1726	882109917000	6689	3283	118	0	\N
79806	1726	882099916000	6689	3283	119	0	\N
79807	1726	882089915000	6689	3283	120	0	\N
79808	1726	882079914000	6689	3283	121	0	\N
79809	1726	882069913000	6689	3283	122	0	\N
79810	1726	882059912000	6689	3283	123	0	\N
79811	1726	882049911000	6689	3283	124	0	\N
79812	1726	882109919000	6690	3419	0	0	\N
79813	1726	882099918000	6690	3419	1	0	\N
79814	1726	882089917000	6690	3419	2	0	\N
79815	1798	180000000	6690	3419	3	0	\N
79816	1798	160000000	6690	3419	4	0	\N
79817	1397	1395365670000	6690	3419	5	0	\N
79818	1397	1395355669000	6690	3419	6	0	\N
79819	1397	1395345668000	6690	3419	7	0	\N
79820	1397	1395335667000	6690	3419	8	0	\N
79821	1397	1395325666000	6690	3419	9	0	\N
79822	1397	1395315665000	6690	3419	10	0	\N
79823	1397	1395305664000	6690	3419	11	0	\N
79824	1397	1395295663000	6690	3419	12	0	\N
79825	1397	1395285662000	6690	3419	13	0	\N
79826	1726	882099916000	6690	3419	14	0	\N
79827	1726	882089915000	6690	3419	15	0	\N
79828	1726	882079914000	6690	3419	16	0	\N
79829	1726	882069913000	6690	3419	17	0	\N
79830	1726	882059912000	6690	3419	18	0	\N
79831	1726	882049911000	6690	3419	19	0	\N
79832	1726	882039910000	6690	3419	20	0	\N
79833	1726	882029909000	6690	3419	21	0	\N
79834	1726	882019908000	6690	3419	22	0	\N
79835	1726	882009907000	6690	3419	23	0	\N
79836	1726	881999906000	6690	3419	24	0	\N
79837	1726	881989905000	6690	3419	25	0	\N
79838	1726	881979904000	6690	3419	26	0	\N
79839	1726	881969903000	6690	3419	27	0	\N
79840	1726	881959902000	6690	3419	28	0	\N
79841	1726	881949901000	6690	3419	29	0	\N
79842	1726	881939900000	6690	3419	30	0	\N
79843	1726	881929899000	6690	3419	31	0	\N
79844	1726	881919898000	6690	3419	32	0	\N
79845	1726	881909897000	6690	3419	33	0	\N
79846	1397	1395275661000	6690	3419	34	0	\N
79847	1397	1395265660000	6690	3419	35	0	\N
79848	1397	1395255659000	6690	3419	36	0	\N
79849	1397	1395245658000	6690	3419	37	0	\N
79850	1397	1395235657000	6690	3419	38	0	\N
79851	1397	1395225656000	6690	3419	39	0	\N
79852	1397	1395215655000	6690	3419	41	0	\N
79853	1397	1395205654000	6690	3419	42	0	\N
79854	1397	1395195653000	6690	3419	43	0	\N
79855	1397	1395185652000	6690	3419	44	0	\N
79856	1397	1395175651000	6690	3419	45	0	\N
79857	1397	1395165650000	6690	3419	46	0	\N
79858	1397	1395155649000	6690	3419	47	0	\N
79859	1397	1395145648000	6690	3419	48	0	\N
79860	1397	1395135647000	6690	3419	49	0	\N
79861	1397	1395125646000	6690	3419	50	0	\N
79862	606	76800190000000	6690	3419	51	0	\N
79863	1397	1395115645000	6690	3419	52	0	\N
79864	1397	1395105644000	6690	3419	53	0	\N
79865	1397	1395095643000	6690	3419	54	0	\N
79866	1397	1395085642000	6690	3419	55	0	\N
79867	1397	1395075641000	6690	3419	56	0	\N
79868	1397	1395065640000	6690	3419	57	0	\N
79869	1397	1395055639000	6690	3419	58	0	\N
79870	1397	1395045638000	6690	3419	59	0	\N
79871	1397	1395035637000	6690	3419	60	0	\N
79872	1397	1395025636000	6690	3419	61	0	\N
79873	1397	1395015635000	6690	3419	62	0	\N
79874	1397	1395005634000	6690	3419	63	0	\N
79875	1397	1394995633000	6690	3419	64	0	\N
79876	1726	881899896000	6690	3419	65	0	\N
79877	1726	881889895000	6690	3419	66	0	\N
79878	1726	881879894000	6690	3419	67	0	\N
79879	1726	881869893000	6690	3419	68	0	\N
79880	1726	881859892000	6690	3419	69	0	\N
79881	1726	881849891000	6690	3419	70	0	\N
79882	1726	881839890000	6690	3419	71	0	\N
79883	1726	881829889000	6690	3419	72	0	\N
79884	1726	881819888000	6690	3419	73	0	\N
79885	1726	881809887000	6690	3419	74	0	\N
79886	1726	881799886000	6690	3419	75	0	\N
79887	1726	881789885000	6690	3419	76	0	\N
79888	1726	881779884000	6690	3419	77	0	\N
79889	1726	881769883000	6690	3419	78	0	\N
79890	1726	881759882000	6690	3419	79	0	\N
79891	1726	881749881000	6690	3419	80	0	\N
79892	1726	881739880000	6690	3419	81	0	\N
79893	1726	881729879000	6690	3419	82	0	\N
79894	1726	881719878000	6690	3419	83	0	\N
79895	1726	881709877000	6690	3419	84	0	\N
79896	1726	881699876000	6690	3419	85	0	\N
79897	1726	881689875000	6690	3419	86	0	\N
79898	1726	881679874000	6690	3419	87	0	\N
79899	1726	881669873000	6690	3419	88	0	\N
79900	1726	881659872000	6690	3419	89	0	\N
79901	1726	881649871000	6690	3419	90	0	\N
79902	1726	881639870000	6690	3419	91	0	\N
79903	1726	881629869000	6690	3419	92	0	\N
79904	1726	881619868000	6690	3419	93	0	\N
79905	1726	881609867000	6690	3419	94	0	\N
79906	1726	881599866000	6690	3419	95	0	\N
79907	1726	881589865000	6690	3419	96	0	\N
79908	1726	881579864000	6690	3419	97	0	\N
79909	1726	881569863000	6690	3419	98	0	\N
79910	1726	881559862000	6690	3419	99	0	\N
79911	1726	881549861000	6690	3419	100	0	\N
79912	1397	1394985632000	6690	3419	101	0	\N
79913	1397	1394975631000	6690	3419	102	0	\N
79914	1397	1394965630000	6690	3419	103	0	\N
79915	1397	1394955629000	6690	3419	104	0	\N
79916	1397	1394945628000	6690	3419	105	0	\N
79917	1397	1394935627000	6690	3419	106	0	\N
79918	1397	1394925626000	6690	3419	107	0	\N
79919	1397	1394915625000	6690	3419	108	0	\N
79920	1397	1394905624000	6690	3419	109	0	\N
79921	1397	1394895623000	6690	3419	110	0	\N
79922	1397	1394885622000	6690	3419	111	0	\N
79923	1397	1394875621000	6690	3419	112	0	\N
79924	1397	1394865620000	6690	3419	113	0	\N
79925	1397	1394855619000	6690	3419	114	0	\N
79926	1397	1394845618000	6690	3419	115	0	\N
79927	1397	1394835617000	6690	3419	116	0	\N
79928	1397	1394825616000	6690	3419	117	0	\N
79929	1397	1394815615000	6690	3419	118	0	\N
79930	1397	1394805614000	6690	3419	119	0	\N
79931	1397	1394795613000	6690	3419	120	0	\N
79932	1397	1394785612000	6690	3419	121	0	\N
79933	1798	158000000	6690	3419	122	0	\N
79934	1798	156000000	6690	3419	123	0	\N
79935	1798	154000000	6690	3419	124	0	\N
79936	1798	152000000	6690	3419	125	0	\N
79937	1726	881554861000	6691	3458	0	0	\N
79938	1726	881544860000	6691	3458	1	0	\N
79939	1397	1394785612000	6691	3458	2	0	\N
79940	1397	1394775611000	6691	3458	3	0	\N
79953	1726	881494855000	6695	3461	0	0	\N
79954	1726	881484854000	6695	3461	1	0	\N
79955	1397	1394725606000	6695	3461	2	0	\N
79956	1397	1394715605000	6695	3461	3	0	\N
79965	1726	881474853000	6698	3462	0	0	\N
79966	1726	881464852000	6698	3462	1	0	\N
79967	1397	1394705604000	6698	3462	2	0	\N
79968	1397	1394695603000	6698	3462	3	0	\N
79943	1397	1394785612000	6692	3458	2	0	4405
79944	1397	1394775611000	6692	3458	3	0	4406
79945	1397	1394765610000	6693	3459	0	0	4407
79946	1726	881534859000	6693	3459	1	0	268
79947	1397	1394755609000	6694	3460	0	0	4408
79949	1397	1394735607000	6694	3460	2	0	4410
79950	1726	881524858000	6694	3460	3	0	269
79951	1726	881514857000	6694	3460	4	0	270
79952	1726	881504856000	6694	3460	5	0	271
79957	1726	881494855000	6696	3461	0	0	272
79959	1397	1394725606000	6696	3461	2	0	4411
79960	1397	1394715605000	6696	3461	3	0	4412
79961	1726	881474853000	6697	3462	0	0	274
79962	1726	881464852000	6697	3462	1	0	275
79964	1397	1394695603000	6697	3462	3	0	4414
79971	1726	881444850000	6700	3464	0	0	\N
79972	1397	1394675601000	6700	3464	1	0	\N
79975	1876	3990000000	6702	3402	0	0	\N
79976	1798	180000000	6702	3402	1	0	\N
79977	1798	160000000	6702	3402	3	0	\N
79978	1876	3980000000	6702	3402	4	0	\N
79979	1876	2970000000	6702	3402	5	0	\N
79980	1397	1395625696000	6702	3402	6	0	\N
79981	1397	1395615695000	6702	3402	7	0	\N
79982	1397	1395605694000	6702	3402	8	0	\N
79983	1397	1395595693000	6702	3402	9	0	\N
79984	1397	1395585692000	6702	3402	10	0	\N
79985	1397	1395575691000	6702	3402	11	0	\N
79986	1726	882399946000	6702	3402	12	0	\N
79987	1726	882389945000	6702	3402	13	0	\N
79988	1397	1395565690000	6702	3402	14	0	\N
79989	1397	1395555689000	6702	3402	15	0	\N
79990	1397	1395545688000	6702	3402	16	0	\N
79991	1397	1395535687000	6702	3402	17	0	\N
79992	1397	1395525686000	6702	3402	18	0	\N
79993	606	76800190000000	6702	3402	19	0	\N
79994	1397	1395515685000	6702	3402	20	0	\N
79995	1397	1395505684000	6702	3402	21	0	\N
79996	1397	1395495683000	6702	3402	22	0	\N
79997	1397	1395485682000	6702	3402	23	0	\N
79998	1397	1395475681000	6702	3402	24	0	\N
79999	1397	1395465680000	6702	3402	25	0	\N
80000	1397	1395455679000	6702	3402	26	0	\N
80001	1397	1395445678000	6702	3402	27	0	\N
80002	1397	1395435677000	6702	3402	28	0	\N
80003	1397	1395425676000	6702	3402	29	0	\N
80004	1397	1395415675000	6702	3402	30	0	\N
80005	1397	1395405674000	6702	3402	31	0	\N
80006	1397	1395395673000	6702	3402	32	0	\N
80007	1397	1395385672000	6702	3402	33	0	\N
80008	1397	1395375671000	6702	3402	34	0	\N
80009	1397	1395365670000	6702	3402	35	0	\N
80010	1397	1395355669000	6702	3402	36	0	\N
80011	1397	1395345668000	6702	3402	37	0	\N
80012	1397	1395335667000	6702	3402	38	0	\N
80013	1397	1395325666000	6702	3402	39	0	\N
80014	1397	1395315665000	6702	3402	40	0	\N
80015	1397	1395305664000	6702	3402	41	0	\N
80016	1397	1395295663000	6702	3402	42	0	\N
80017	1397	1395285662000	6702	3402	43	0	\N
80018	1397	1395275661000	6702	3402	44	0	\N
80019	1397	1395265660000	6702	3402	45	0	\N
80020	1397	1395255659000	6702	3402	46	0	\N
80021	1397	1395245658000	6702	3402	47	0	\N
80022	1397	1395235657000	6702	3402	48	0	\N
80023	1397	1395225656000	6702	3402	49	0	\N
80024	1397	1395215655000	6702	3402	50	0	\N
80025	1397	1395205654000	6702	3402	51	0	\N
80026	1397	1395195653000	6702	3402	52	0	\N
80027	1397	1395185652000	6702	3402	53	0	\N
80028	1397	1395175651000	6702	3402	54	0	\N
80029	1397	1395165650000	6702	3402	55	0	\N
80030	1397	1395155649000	6702	3402	56	0	\N
80031	1397	1395145648000	6702	3402	57	0	\N
80032	1397	1395135647000	6702	3402	58	0	\N
80033	1397	1395125646000	6702	3402	59	0	\N
80034	1397	1395115645000	6702	3402	60	0	\N
80035	1397	1395105644000	6702	3402	61	0	\N
80036	1397	1395095643000	6702	3402	62	0	\N
80037	1397	1395085642000	6702	3402	63	0	\N
80038	1397	1395075641000	6702	3402	64	0	\N
80039	1397	1395065640000	6702	3402	65	0	\N
80040	1397	1395055639000	6702	3402	66	0	\N
80041	1397	1395045638000	6702	3402	67	0	\N
80042	1397	1395035637000	6702	3402	68	0	\N
80043	1397	1395025636000	6702	3402	69	0	\N
80044	1397	1395015635000	6702	3402	70	0	\N
80045	1397	1395005634000	6702	3402	71	0	\N
80046	1397	1394995633000	6702	3402	72	0	\N
80047	1726	882379944000	6702	3402	73	0	\N
80048	1726	882369943000	6702	3402	74	0	\N
80049	1726	882359942000	6702	3402	75	0	\N
80050	1726	882349941000	6702	3402	76	0	\N
80051	1726	882339940000	6702	3402	77	0	\N
80052	1726	882329939000	6702	3402	78	0	\N
80053	1726	882319938000	6702	3402	79	0	\N
80054	1726	882309937000	6702	3402	80	0	\N
80055	1726	882299936000	6702	3402	81	0	\N
80056	1726	882289935000	6702	3402	82	0	\N
80057	1726	882279934000	6702	3402	83	0	\N
80058	1726	882269933000	6702	3402	84	0	\N
80059	1726	882259932000	6702	3402	85	0	\N
80060	1726	882249931000	6702	3402	86	0	\N
80061	1726	882239930000	6702	3402	87	0	\N
80062	1726	882229929000	6702	3402	88	0	\N
80063	1726	882219928000	6702	3402	89	0	\N
80064	1726	882209927000	6702	3402	90	0	\N
80065	1726	882199926000	6702	3402	91	0	\N
80066	1726	882189925000	6702	3402	92	0	\N
80067	1726	882179924000	6702	3402	93	0	\N
80068	1726	882169923000	6702	3402	94	0	\N
80069	1726	882159922000	6702	3402	95	0	\N
80070	1726	882149921000	6702	3402	96	0	\N
80071	1726	882139920000	6702	3402	97	0	\N
80072	1726	882129919000	6702	3402	98	0	\N
80073	1726	882119918000	6702	3402	99	0	\N
80074	1726	882109917000	6702	3402	100	0	\N
80075	1726	882099916000	6702	3402	101	0	\N
80076	1726	882089915000	6702	3402	102	0	\N
80077	1726	882079914000	6702	3402	103	0	\N
80078	1726	882069913000	6702	3402	104	0	\N
80079	1726	882059912000	6702	3402	105	0	\N
80080	1726	882049911000	6702	3402	106	0	\N
80081	1726	882039910000	6702	3402	107	0	\N
80082	1726	882029909000	6702	3402	108	0	\N
80083	1726	882019908000	6702	3402	109	0	\N
80084	1726	882009907000	6702	3402	110	0	\N
80085	1726	881999906000	6702	3402	111	0	\N
80086	1726	881989905000	6702	3402	112	0	\N
80087	1726	881979904000	6702	3402	113	0	\N
80088	1726	881969903000	6702	3402	114	0	\N
80089	1726	881959902000	6702	3402	115	0	\N
80090	1726	881949901000	6702	3402	116	0	\N
80091	1726	881939900000	6702	3402	117	0	\N
80092	1726	881929899000	6702	3402	118	0	\N
80093	1726	881919898000	6702	3402	119	0	\N
80094	1726	881909897000	6702	3402	120	0	\N
80095	1726	881899896000	6702	3402	121	0	\N
80096	1726	881889895000	6702	3402	122	0	\N
80097	1726	881879894000	6702	3402	123	0	\N
80098	1726	881869893000	6702	3402	124	0	\N
80099	1726	881859892000	6702	3402	125	0	\N
79973	1726	881444850000	6701	3464	0	0	277
79974	1397	1394675601000	6701	3464	1	0	4416
80100	1726	881434849000	6703	3465	0	0	278
80101	1726	881424848000	6703	3465	1	0	279
80102	1397	1394665600000	6703	3465	2	0	4417
80104	1726	881414847000	6704	3466	0	0	280
80124	1726	881324838000	6711	3471	0	0	\N
80125	1397	1394555589000	6711	3471	1	0	\N
80126	1726	881324838000	6712	3471	0	0	\N
80127	1397	1394555589000	6712	3471	1	0	\N
80132	1726	881304836000	6715	3473	0	0	\N
80133	1397	1394535587000	6715	3473	1	0	\N
80148	1876	3990000000	6720	3390	0	0	\N
80149	1798	180000000	6720	3390	1	0	\N
80150	1798	160000000	6720	3390	2	0	\N
80151	1876	3980000000	6720	3390	3	0	\N
80152	1876	2970000000	6720	3390	4	0	\N
80153	606	76800190000000	6720	3390	5	0	\N
80154	1798	158000000	6720	3390	6	0	\N
80155	1798	156000000	6720	3390	7	0	\N
80156	1540	367308000000	6720	3390	8	0	\N
80157	1798	154000000	6720	3390	9	0	\N
80158	1798	152000000	6720	3390	10	0	\N
80159	1798	150000000	6720	3390	11	0	\N
80164	1397	1394455579000	6722	3478	0	0	\N
80165	1726	881224828000	6722	3478	1	0	\N
80166	1726	881214827000	6722	3478	2	0	\N
80167	1397	1394445578000	6722	3478	3	0	\N
80168	1726	881204826000	6723	3479	0	0	\N
80169	1397	1394435577000	6723	3479	1	0	\N
80172	1726	881204826000	6725	3479	0	0	\N
80173	1397	1394435577000	6725	3479	1	0	\N
80180	1726	881164822000	6730	3483	0	0	\N
80181	1397	1394395573000	6730	3483	1	0	\N
80184	1726	881154821000	6732	3484	0	0	\N
80185	1726	881144820000	6732	3484	1	0	\N
80186	1397	1394385572000	6732	3484	2	0	\N
80187	1397	1394375571000	6732	3484	3	0	\N
80194	1397	1394365570000	6735	3485	0	0	\N
80195	1726	881134819000	6735	3485	1	0	\N
80196	1397	1394355569000	6736	3486	0	0	\N
80197	1726	881124818000	6736	3486	1	0	\N
80198	1397	1394355569000	6737	3486	0	0	\N
80199	1726	881124818000	6737	3486	1	0	\N
80202	1726	881114817000	6739	3487	0	0	\N
80203	1397	1394345568000	6739	3487	1	0	\N
80208	1397	1394325566000	6742	3489	0	0	\N
80209	1726	881094815000	6742	3489	1	0	\N
80212	1397	1394325566000	6744	3489	0	0	\N
80213	1726	881094815000	6744	3489	1	0	\N
80224	1397	1394285562000	6749	3493	0	0	\N
80225	1726	881054811000	6749	3493	1	0	\N
80226	1726	881044810000	6749	3493	2	0	\N
80227	1397	1394275561000	6749	3493	3	0	\N
80232	1726	881024808000	6752	3495	0	0	\N
80233	1397	1394255559000	6752	3495	1	0	\N
80236	1726	881014807000	6754	3496	0	0	\N
80237	1397	1394245558000	6754	3496	1	0	\N
80238	1397	1394235557000	6755	3497	0	0	\N
80239	1726	881004806000	6755	3497	1	0	\N
80107	1397	1394645598000	6704	3466	3	0	4419
80108	1397	1394635597000	6704	3466	4	0	4420
80109	1397	1394625596000	6704	3466	5	0	4421
80110	1726	881384844000	6705	3467	0	0	283
80111	1397	1394615595000	6705	3467	1	0	4422
80113	1397	1394595593000	6707	3468	1	0	4424
80114	1397	1394585592000	6707	3468	2	0	4425
80115	1726	881374843000	6707	3468	3	0	284
80116	1726	881364842000	6707	3468	4	0	285
80117	1726	881354841000	6707	3468	5	0	286
80119	1397	1394575591000	6708	3469	1	0	4426
80120	1397	1394565590000	6709	3470	0	0	4427
80121	1726	881334839000	6709	3470	1	0	288
80122	1726	881324838000	6710	3471	0	0	289
80128	1726	881314837000	6713	3472	0	0	290
80129	1397	1394545588000	6713	3472	1	0	4429
80130	1726	881304836000	6714	3473	0	0	291
80131	1397	1394535587000	6714	3473	1	0	4430
80134	1726	881294835000	6716	3474	0	0	292
80136	1397	1394515585000	6716	3474	2	0	4432
80137	1726	881284834000	6716	3474	3	0	293
80138	1397	1394505584000	6717	3475	0	0	4433
80139	1726	881274833000	6717	3475	1	0	294
80140	1726	881264832000	6718	3476	0	0	295
80142	1397	1394485582000	6718	3476	2	0	4435
80143	1726	881254831000	6718	3476	3	0	296
80144	1397	1394475581000	6719	3477	0	0	4436
80145	1397	1394465580000	6719	3477	1	0	4437
80147	1726	881234829000	6719	3477	3	0	298
80160	1397	1394455579000	6721	3478	0	0	4438
80161	1726	881224828000	6721	3478	1	0	299
80162	1726	881214827000	6721	3478	2	0	300
80163	1397	1394445578000	6721	3478	3	0	4439
80171	1397	1394435577000	6724	3479	1	0	4440
80174	1726	881194825000	6726	3480	0	0	302
80175	1397	1394425576000	6726	3480	1	0	4441
80176	1397	1394415575000	6727	3481	0	0	4442
80177	1726	881184824000	6727	3481	1	0	303
80179	1397	1394405574000	6729	3482	1	0	4443
80182	1726	881164822000	6731	3483	0	0	305
80183	1397	1394395573000	6731	3483	1	0	4444
80188	1726	881154821000	6733	3484	0	0	306
80190	1397	1394385572000	6733	3484	2	0	4445
80191	1397	1394375571000	6733	3484	3	0	4446
80192	1397	1394365570000	6734	3485	0	0	4447
80193	1726	881134819000	6734	3485	1	0	308
80200	1397	1394355569000	6738	3486	0	0	4448
80204	1726	881114817000	6740	3487	0	0	310
80205	1397	1394345568000	6740	3487	1	0	4449
80206	1726	881104816000	6741	3488	0	0	311
80207	1397	1394335567000	6741	3488	1	0	4450
80210	1397	1394325566000	6743	3489	0	0	4451
80214	1726	881084814000	6745	3490	0	0	313
80215	1397	1394315565000	6745	3490	1	0	4452
80216	1397	1394305564000	6746	3491	0	0	4453
80217	1726	881074813000	6746	3491	1	0	314
80219	1397	1394295563000	6747	3492	1	0	4454
80220	1397	1394285562000	6748	3493	0	0	4455
80221	1726	881054811000	6748	3493	1	0	316
80222	1726	881044810000	6748	3493	2	0	317
80223	1397	1394275561000	6748	3493	3	0	4456
80229	1726	881034809000	6750	3494	1	0	318
80230	1726	881024808000	6751	3495	0	0	319
80231	1397	1394255559000	6751	3495	1	0	4458
80234	1726	881014807000	6753	3496	0	0	320
80235	1397	1394245558000	6753	3496	1	0	4459
80244	1726	880994805000	6758	3498	0	0	\N
80245	1397	1394225556000	6758	3498	1	0	\N
80254	1726	880984804000	6760	3499	0	0	\N
80255	1397	1394215555000	6760	3499	1	0	\N
80256	1726	880974803000	6760	3499	2	0	\N
80257	1726	880964802000	6760	3499	3	0	\N
80258	1726	880954801000	6760	3499	4	0	\N
80259	1397	1394205554000	6760	3499	5	0	\N
80260	1397	1394195553000	6760	3499	6	0	\N
80261	1397	1394185552000	6760	3499	7	0	\N
80262	1726	880984804000	6761	3499	0	0	\N
80263	1397	1394215555000	6761	3499	1	0	\N
80264	1726	880974803000	6761	3499	2	0	\N
80265	1726	880964802000	6761	3499	3	0	\N
80266	1726	880954801000	6761	3499	4	0	\N
80267	1397	1394205554000	6761	3499	5	0	\N
80268	1397	1394195553000	6761	3499	6	0	\N
80269	1397	1394185552000	6761	3499	7	0	\N
80270	1726	879654801000	6762	3500	0	0	\N
80271	1726	878354801000	6762	3500	1	0	\N
80272	1397	1394175551000	6762	3500	2	0	\N
80273	1726	878344800000	6762	3500	3	0	\N
80274	1726	877044800000	6762	3500	4	0	\N
80280	1726	875744800000	6764	3501	0	0	\N
80281	1397	1394165550000	6764	3501	1	0	\N
80282	1726	875734799000	6764	3501	2	0	\N
80287	1397	1394145548000	6768	3504	0	0	\N
80288	1397	1394135547000	6768	3504	1	0	\N
80289	1726	875724798000	6768	3504	2	0	\N
80290	1726	875714797000	6768	3504	3	0	\N
80297	1726	875694795000	6772	3506	0	0	\N
80298	1397	1394115545000	6772	3506	1	0	\N
80301	1726	875694795000	6774	3506	0	0	\N
80302	1397	1394115545000	6774	3506	1	0	\N
80303	1726	875694795000	6775	3506	0	0	\N
80304	1397	1394115545000	6775	3506	1	0	\N
80315	1726	875634789000	6782	3512	0	0	\N
80316	1397	1394055539000	6782	3512	1	0	\N
80325	1397	1394035537000	6787	3514	0	0	\N
80326	1397	1394025536000	6787	3514	1	0	\N
80327	1726	875614787000	6787	3514	2	0	\N
80328	1726	875604786000	6787	3514	3	0	\N
80331	1397	1394015535000	6789	3515	0	0	\N
80332	1726	875594785000	6789	3515	1	0	\N
80333	1397	1394015535000	6790	3515	0	0	\N
80334	1726	875594785000	6790	3515	1	0	\N
80339	1397	1394005534000	6792	3516	0	0	\N
80340	1397	1393995533000	6792	3516	1	0	\N
80341	1726	875584784000	6792	3516	2	0	\N
80342	1726	875574783000	6792	3516	3	0	\N
80345	1726	875554781000	6794	3518	0	0	\N
80346	1397	1393975531000	6794	3518	1	0	\N
80349	1726	875554781000	6796	3518	0	0	\N
80350	1397	1393975531000	6796	3518	1	0	\N
80363	1726	874194775000	6801	3522	0	0	\N
80364	1397	1393925526000	6801	3522	1	0	\N
80365	1397	1393925526000	6802	3522	0	0	\N
80366	1397	1393925526000	6804	3522	0	0	\N
80367	1397	1393915525000	6805	3523	0	0	\N
80368	1397	1393915525000	6806	3523	0	0	\N
80369	1726	874184774000	6806	3523	1	0	\N
80376	1726	874174773000	6809	3524	0	0	\N
80243	1397	1394225556000	6757	3498	1	0	4461
80246	1726	880984804000	6759	3499	0	0	323
80247	1397	1394215555000	6759	3499	1	0	4462
80248	1726	880974803000	6759	3499	2	0	324
80249	1726	880964802000	6759	3499	3	0	325
80251	1397	1394205554000	6759	3499	5	0	4463
80252	1397	1394195553000	6759	3499	6	0	4464
80253	1397	1394185552000	6759	3499	7	0	4465
80275	1726	879654801000	6763	3500	0	0	327
80276	1726	878354801000	6763	3500	1	0	328
80278	1726	878344800000	6763	3500	3	0	329
80279	1726	877044800000	6763	3500	4	0	330
80283	1726	875744800000	6765	3501	0	0	331
80284	1397	1394165550000	6765	3501	1	0	4467
80286	1397	1394155549000	6766	3502	0	0	4468
80291	1397	1394145548000	6769	3504	0	0	4469
80292	1397	1394135547000	6769	3504	1	0	4470
80293	1726	875724798000	6769	3504	2	0	333
80294	1726	875714797000	6769	3504	3	0	334
80296	1397	1394125546000	6770	3505	1	0	4471
80299	1726	875694795000	6773	3506	0	0	336
80300	1397	1394115545000	6773	3506	1	0	4472
80305	1397	1394105544000	6776	3507	0	0	4473
80306	1726	875684794000	6776	3507	1	0	337
80308	1397	1394095543000	6777	3508	1	0	4474
80309	1726	875664792000	6778	3509	0	0	339
80310	1397	1394085542000	6778	3509	1	0	4475
80311	1726	875654791000	6779	3510	0	0	340
80313	1397	1394065540000	6781	3511	0	0	4477
80314	1726	875644790000	6781	3511	1	0	341
80317	1726	875634789000	6783	3512	0	0	342
80318	1397	1394055539000	6783	3512	1	0	4478
80319	1397	1394045538000	6784	3513	0	0	4479
80321	1397	1394035537000	6786	3514	0	0	4480
80322	1397	1394025536000	6786	3514	1	0	4481
80323	1726	875614787000	6786	3514	2	0	344
80324	1726	875604786000	6786	3514	3	0	345
80329	1397	1394015535000	6788	3515	0	0	4482
80335	1397	1394005534000	6791	3516	0	0	4483
80336	1397	1393995533000	6791	3516	1	0	4484
80337	1726	875584784000	6791	3516	2	0	347
80338	1726	875574783000	6791	3516	3	0	348
80344	1726	875564782000	6793	3517	1	0	349
80347	1726	875554781000	6795	3518	0	0	350
80348	1397	1393975531000	6795	3518	1	0	4486
80351	1397	1393965530000	6797	3519	0	0	4487
80352	1397	1393955529000	6797	3519	1	0	4488
80354	1726	874244780000	6798	3520	1	0	352
80355	1397	1393945528000	6798	3520	2	0	4489
80356	1726	874234779000	6798	3520	3	0	353
80357	1726	874224778000	6798	3520	4	0	354
80358	1726	874214777000	6798	3520	5	0	355
80360	1397	1393935527000	6799	3521	1	0	4490
80361	1726	874194775000	6800	3522	0	0	357
80362	1397	1393925526000	6800	3522	1	0	4491
80370	1397	1393915525000	6807	3523	0	0	4492
80372	1726	874174773000	6808	3524	0	0	359
80373	1397	1393905524000	6808	3524	1	0	4493
80374	1397	1393895523000	6808	3524	2	0	4494
80375	1726	874164772000	6808	3524	3	0	360
80377	1397	1393905524000	6809	3524	1	0	\N
80378	1397	1393895523000	6809	3524	2	0	\N
80379	1726	874164772000	6809	3524	3	0	\N
80380	1726	874174773000	6810	3524	0	0	\N
80381	1397	1393905524000	6810	3524	1	0	\N
80382	1397	1393895523000	6810	3524	2	0	\N
80383	1726	874164772000	6810	3524	3	0	\N
80392	1726	874134769000	6814	3527	0	0	\N
80393	1726	872834769000	6814	3527	1	0	\N
80394	1726	871534769000	6814	3527	2	0	\N
80395	1397	1393865520000	6814	3527	3	0	\N
80396	1726	871524768000	6815	3528	0	0	\N
80397	1726	871514767000	6815	3528	1	0	\N
80398	1397	1393855519000	6815	3528	2	0	\N
80399	1397	1393845518000	6815	3528	3	0	\N
80409	1397	1393825516000	6819	3530	0	0	\N
80410	1726	870194765000	6819	3530	1	0	\N
80419	1726	870144760000	6822	3533	0	0	\N
80420	1397	1393775511000	6822	3533	1	0	\N
80421	1726	870144760000	6823	3533	0	0	\N
80422	1397	1393775511000	6823	3533	1	0	\N
80425	1726	870134759000	6825	3534	0	0	\N
80426	1397	1393765510000	6825	3534	1	0	\N
80437	1397	1393755509000	6828	3535	0	0	\N
80438	1726	870124758000	6828	3535	1	0	\N
80439	1726	870114757000	6828	3535	2	0	\N
80440	1726	870104756000	6828	3535	3	0	\N
80441	1726	870094755000	6828	3535	4	0	\N
80442	1397	1393745508000	6828	3535	5	0	\N
80443	1397	1393735507000	6828	3535	6	0	\N
80444	1397	1393725506000	6828	3535	7	0	\N
80445	1726	870084754000	6829	3536	0	0	\N
80446	1397	1393715505000	6829	3536	1	0	\N
80447	1726	870084754000	6830	3536	0	0	\N
80448	1397	1393715505000	6830	3536	1	0	\N
80451	1726	870084754000	6832	3536	0	0	\N
80452	1397	1393715505000	6832	3536	1	0	\N
80453	1397	1393715505000	6833	3536	0	0	\N
80456	1726	870064752000	6835	3538	0	0	\N
80457	1397	1393695503000	6835	3538	1	0	\N
80458	1726	870064752000	6836	3538	0	0	\N
80459	1397	1393695503000	6836	3538	1	0	\N
80462	1726	870064752000	6838	3538	0	0	\N
80463	1397	1393695503000	6838	3538	1	0	\N
80464	1397	1393685502000	6839	3539	0	0	\N
80465	1397	1393675501000	6839	3539	1	0	\N
80466	1726	870054751000	6839	3539	2	0	\N
80467	1726	870044750000	6839	3539	3	0	\N
80472	1397	1393665500000	6841	3540	0	0	\N
80473	1726	870034749000	6841	3540	1	0	\N
80474	1397	1393665500000	6842	3540	0	0	\N
80475	1726	870034749000	6842	3540	1	0	\N
80480	1726	870014747000	6845	3542	0	0	\N
80481	1726	870004746000	6845	3542	1	0	\N
80482	1726	869994745000	6845	3542	2	0	\N
80483	1397	1393645498000	6845	3542	3	0	\N
80484	1397	1393635497000	6845	3542	4	0	\N
80485	1397	1393625496000	6845	3542	5	0	\N
80486	1726	870014747000	6846	3542	0	0	\N
80487	1726	870004746000	6846	3542	1	0	\N
80488	1726	869994745000	6846	3542	2	0	\N
80489	1397	1393645498000	6846	3542	3	0	\N
80490	1397	1393635497000	6846	3542	4	0	\N
80491	1397	1393625496000	6846	3542	5	0	\N
80498	1397	1393645498000	6848	3542	0	0	\N
80499	1397	1393635497000	6848	3542	1	0	\N
80500	1397	1393625496000	6848	3542	2	0	\N
80501	1726	870014747000	6849	3542	0	0	\N
80502	1726	870004746000	6849	3542	1	0	\N
80503	1726	869994745000	6849	3542	2	0	\N
80504	1397	1393645498000	6849	3542	3	0	\N
80505	1397	1393635497000	6849	3542	4	0	\N
80506	1397	1393625496000	6849	3542	5	0	\N
80507	1726	870014747000	6850	3542	0	0	\N
80508	1726	870004746000	6850	3542	1	0	\N
80509	1726	869994745000	6850	3542	2	0	\N
80510	1397	1393645498000	6850	3542	3	0	\N
80511	1397	1393635497000	6850	3542	4	0	\N
80512	1397	1393625496000	6850	3542	5	0	\N
80386	1726	874144770000	6812	3526	0	0	362
80387	1397	1393875521000	6812	3526	1	0	4496
80388	1726	874134769000	6813	3527	0	0	363
80389	1726	872834769000	6813	3527	1	0	364
80390	1726	871534769000	6813	3527	2	0	365
80400	1726	871524768000	6816	3528	0	0	366
80401	1726	871514767000	6816	3528	1	0	367
80402	1397	1393855519000	6816	3528	2	0	4498
80403	1397	1393845518000	6816	3528	3	0	4499
80404	1397	1393835517000	6817	3529	0	0	4500
80406	1726	870204766000	6817	3529	2	0	369
80407	1397	1393825516000	6818	3530	0	0	4501
80408	1726	870194765000	6818	3530	1	0	370
80411	1397	1393815515000	6820	3531	0	0	4502
80413	1397	1393805514000	6821	3532	0	0	4503
80414	1397	1393795513000	6821	3532	1	0	4504
80415	1397	1393785512000	6821	3532	2	0	4505
80416	1726	870174763000	6821	3532	3	0	372
80417	1726	870164762000	6821	3532	4	0	373
80423	1726	870144760000	6824	3533	0	0	375
80424	1397	1393775511000	6824	3533	1	0	4506
80427	1726	870134759000	6826	3534	0	0	376
80428	1397	1393765510000	6826	3534	1	0	4507
80429	1397	1393755509000	6827	3535	0	0	4508
80431	1726	870114757000	6827	3535	2	0	378
80432	1726	870104756000	6827	3535	3	0	379
80433	1726	870094755000	6827	3535	4	0	380
80434	1397	1393745508000	6827	3535	5	0	4509
80436	1397	1393725506000	6827	3535	7	0	4511
80449	1726	870084754000	6831	3536	0	0	381
80450	1397	1393715505000	6831	3536	1	0	4512
80454	1397	1393705504000	6834	3537	0	0	4513
80455	1726	870074753000	6834	3537	1	0	382
80461	1397	1393695503000	6837	3538	1	0	4514
80468	1397	1393685502000	6840	3539	0	0	4515
80469	1397	1393675501000	6840	3539	1	0	4516
80470	1726	870054751000	6840	3539	2	0	384
80471	1726	870044750000	6840	3539	3	0	385
80477	1397	1393655499000	6844	3541	0	0	4518
80478	1726	870034749000	6844	3541	1	0	386
80479	1726	870024748000	6844	3541	2	0	387
80492	1726	870014747000	6847	3542	0	0	388
80494	1726	869994745000	6847	3542	2	0	390
80495	1397	1393645498000	6847	3542	3	0	4519
80496	1397	1393635497000	6847	3542	4	0	4520
80497	1397	1393625496000	6847	3542	5	0	4521
80513	1397	1393615495000	6850	3542	6	0	\N
80516	1397	1393615495000	6852	3543	0	0	\N
80517	1397	1393605494000	6852	3543	1	0	\N
80518	1726	869984744000	6852	3543	2	0	\N
80525	1726	869964742000	6855	3545	0	0	\N
80526	1726	869954741000	6855	3545	1	0	\N
80527	1397	1393595493000	6855	3545	2	0	\N
80528	1397	1393585492000	6855	3545	3	0	\N
80538	1885	100000000	6857	3546	0	0	\N
80539	1726	869944740000	6857	3546	1	0	\N
80540	1726	869934739000	6857	3546	2	0	\N
80541	1726	869924738000	6857	3546	3	0	\N
80542	1726	869914737000	6857	3546	4	0	\N
80543	1397	1393575491000	6857	3546	5	0	\N
80544	1397	1393565490000	6857	3546	6	0	\N
80545	1397	1393555489000	6857	3546	7	0	\N
80546	1397	1393545488000	6857	3546	8	0	\N
80549	1397	1393535487000	6859	3547	0	0	\N
80550	1726	869904736000	6859	3547	1	0	\N
80553	1397	1393525486000	6861	3548	0	0	\N
80554	1726	869894735000	6861	3548	1	0	\N
80566	1397	1393485482000	6865	3551	0	0	\N
80567	1397	1393475481000	6865	3551	1	0	\N
80568	1726	869854731000	6865	3551	2	0	\N
80569	1726	868554731000	6865	3551	3	0	\N
80570	1726	868544730000	6865	3551	4	0	\N
80579	1397	1393425476000	6869	3554	0	0	\N
80580	1726	868494725000	6869	3554	1	0	\N
80581	1397	1393425476000	6870	3554	0	0	\N
80582	1726	868494725000	6870	3554	1	0	\N
80583	1397	1393425476000	6871	3554	0	0	\N
80584	1726	868494725000	6871	3554	1	0	\N
80587	1397	1393425476000	6873	3554	0	0	\N
80588	1726	868494725000	6873	3554	1	0	\N
80589	1397	1393425476000	6874	3554	0	0	\N
80590	1726	868494725000	6874	3554	1	0	\N
80591	1397	1393425476000	6875	3554	0	0	\N
80592	1726	868494725000	6875	3554	1	0	\N
80597	1726	881543860000	6878	3420	0	0	\N
80598	1397	1394775611000	6878	3420	1	0	\N
80599	1397	1394765610000	6878	3420	2	0	\N
80600	1397	1394755609000	6878	3420	3	0	\N
80601	1397	1394745608000	6878	3420	4	0	\N
80602	1397	1394735607000	6878	3420	5	0	\N
80603	1397	1394725606000	6878	3420	6	0	\N
80604	1726	881533859000	6878	3420	7	0	\N
80605	1726	881523858000	6878	3420	8	0	\N
80606	1726	881513857000	6878	3420	9	0	\N
80607	1726	881503856000	6878	3420	10	0	\N
80608	1726	881493855000	6878	3420	11	0	\N
80609	1726	881483854000	6878	3420	12	0	\N
80610	1726	881473853000	6878	3420	13	0	\N
80611	1726	881463852000	6878	3420	14	0	\N
80612	1726	881453851000	6878	3420	15	0	\N
80613	1726	881443850000	6878	3420	16	0	\N
80614	1726	881433849000	6878	3420	17	0	\N
80615	1726	881423848000	6878	3420	18	0	\N
80616	1726	881413847000	6878	3420	19	0	\N
80617	1726	881403846000	6878	3420	20	0	\N
80618	1726	881393845000	6878	3420	21	0	\N
80619	1726	881383844000	6878	3420	22	0	\N
80620	1726	881373843000	6878	3420	23	0	\N
80621	1726	881363842000	6878	3420	24	0	\N
80622	1726	881353841000	6878	3420	25	0	\N
80623	1726	881343840000	6878	3420	26	0	\N
80624	1726	881333839000	6878	3420	27	0	\N
80625	1726	881323838000	6878	3420	28	0	\N
80626	1726	881313837000	6878	3420	29	0	\N
80627	1726	881303836000	6878	3420	30	0	\N
80628	1726	881293835000	6878	3420	31	0	\N
80629	1726	881283834000	6878	3420	32	0	\N
80630	1726	881273833000	6878	3420	33	0	\N
80631	1726	881263832000	6878	3420	34	0	\N
80632	1726	881253831000	6878	3420	35	0	\N
80633	1726	881243830000	6878	3420	36	0	\N
80634	1726	881233829000	6878	3420	37	0	\N
80635	1726	881223828000	6878	3420	38	0	\N
80636	1726	881213827000	6878	3420	39	0	\N
80637	1726	881203826000	6878	3420	41	0	\N
80638	1726	881193825000	6878	3420	42	0	\N
80639	1726	881183824000	6878	3420	43	0	\N
80640	1726	881173823000	6878	3420	44	0	\N
80641	1726	881163822000	6878	3420	45	0	\N
80642	1726	881153821000	6878	3420	46	0	\N
80643	1726	881143820000	6878	3420	47	0	\N
80644	1726	881133819000	6878	3420	48	0	\N
80645	1726	881123818000	6878	3420	49	0	\N
80646	1726	881113817000	6878	3420	50	0	\N
80647	1726	881103816000	6878	3420	51	0	\N
80648	1726	881093815000	6878	3420	52	0	\N
80519	1726	869974743000	6853	3544	0	0	392
80520	1397	1393605494000	6853	3544	1	0	4523
80521	1726	869964742000	6854	3545	0	0	393
80522	1726	869954741000	6854	3545	1	0	394
80523	1397	1393595493000	6854	3545	2	0	4524
80529	1885	100000000	6856	3546	0	0	1
80530	1726	869944740000	6856	3546	1	0	395
80531	1726	869934739000	6856	3546	2	0	396
80532	1726	869924738000	6856	3546	3	0	397
80533	1726	869914737000	6856	3546	4	0	398
80535	1397	1393565490000	6856	3546	6	0	4527
80536	1397	1393555489000	6856	3546	7	0	4528
80537	1397	1393545488000	6856	3546	8	0	4529
80547	1397	1393535487000	6858	3547	0	0	4530
80551	1397	1393525486000	6860	3548	0	0	4531
80552	1726	869894735000	6860	3548	1	0	400
80555	1397	1393515485000	6862	3549	0	0	4532
80556	1397	1393505484000	6862	3549	1	0	4533
80557	1726	869884734000	6862	3549	2	0	401
80559	1397	1393495483000	6863	3550	0	0	4534
80560	1726	869864732000	6863	3550	1	0	403
80561	1397	1393485482000	6864	3551	0	0	4535
80562	1397	1393475481000	6864	3551	1	0	4536
80563	1726	869854731000	6864	3551	2	0	404
80565	1726	868544730000	6864	3551	4	0	406
80571	1726	868534729000	6867	3552	0	0	407
80572	1397	1393465480000	6867	3552	1	0	4537
80573	1726	868524728000	6868	3553	0	0	408
80575	1726	868504726000	6868	3553	2	0	410
80576	1397	1393455479000	6868	3553	3	0	4538
80577	1397	1393445478000	6868	3553	4	0	4539
80578	1397	1393435477000	6868	3553	5	0	4540
80585	1397	1393425476000	6872	3554	0	0	4541
80593	1397	1393415475000	6876	3555	0	0	4542
80594	1726	868484724000	6876	3555	1	0	412
80595	1726	868474723000	6877	3556	0	0	413
80596	1397	1393405474000	6877	3556	1	0	4543
80649	1726	881083814000	6878	3420	53	0	\N
80650	1726	881073813000	6878	3420	54	0	\N
80651	1726	881063812000	6878	3420	55	0	\N
80652	1726	881053811000	6878	3420	56	0	\N
80653	1726	881043810000	6878	3420	57	0	\N
80654	1726	881033809000	6878	3420	58	0	\N
80655	1726	881023808000	6878	3420	59	0	\N
80656	1726	881013807000	6878	3420	60	0	\N
80657	1726	881003806000	6878	3420	61	0	\N
80658	1726	880993805000	6878	3420	62	0	\N
80659	1726	880983804000	6878	3420	63	0	\N
80660	1726	880973803000	6878	3420	64	0	\N
80661	1726	880963802000	6878	3420	65	0	\N
80662	1726	880953801000	6878	3420	66	0	\N
80663	1726	879653801000	6878	3420	67	0	\N
80664	1726	878353801000	6878	3420	68	0	\N
80665	1726	878343800000	6878	3420	69	0	\N
80666	1726	877043800000	6878	3420	70	0	\N
80667	1726	875743800000	6878	3420	71	0	\N
80668	1726	875733799000	6878	3420	72	0	\N
80669	1726	875723798000	6878	3420	73	0	\N
80670	1726	875713797000	6878	3420	74	0	\N
80671	1726	875703796000	6878	3420	75	0	\N
80672	1726	875693795000	6878	3420	76	0	\N
80673	1726	875683794000	6878	3420	77	0	\N
80674	1726	875673793000	6878	3420	78	0	\N
80675	1726	875663792000	6878	3420	79	0	\N
80676	1726	875653791000	6878	3420	80	0	\N
80677	1726	875643790000	6878	3420	81	0	\N
80678	1726	875633789000	6878	3420	82	0	\N
80679	1726	875623788000	6878	3420	83	0	\N
80680	1726	875613787000	6878	3420	84	0	\N
80681	1726	875603786000	6878	3420	85	0	\N
80682	1726	875593785000	6878	3420	86	0	\N
80683	1726	875583784000	6878	3420	87	0	\N
80684	1726	875573783000	6878	3420	88	0	\N
80685	1726	875563782000	6878	3420	89	0	\N
80686	1726	875553781000	6878	3420	90	0	\N
80687	1726	875543780000	6878	3420	91	0	\N
80688	1726	874243780000	6878	3420	92	0	\N
80689	1726	874233779000	6878	3420	93	0	\N
80690	1726	874223778000	6878	3420	94	0	\N
80691	1726	874213777000	6878	3420	95	0	\N
80692	1726	874203776000	6878	3420	96	0	\N
80693	1726	874193775000	6878	3420	97	0	\N
80694	1726	874183774000	6878	3420	98	0	\N
80695	1726	874173773000	6878	3420	99	0	\N
80696	1726	874163772000	6878	3420	100	0	\N
80697	1726	874153771000	6878	3420	101	0	\N
80698	1726	874143770000	6878	3420	102	0	\N
80699	1726	874133769000	6878	3420	103	0	\N
80700	1726	872833769000	6878	3420	104	0	\N
80701	1726	871533769000	6878	3420	105	0	\N
80702	1726	871523768000	6878	3420	106	0	\N
80703	1726	871513767000	6878	3420	107	0	\N
80704	1726	871503766000	6878	3420	108	0	\N
80705	1726	870203766000	6878	3420	109	0	\N
80706	1726	870193765000	6878	3420	110	0	\N
80707	1726	870183764000	6878	3420	111	0	\N
80708	1726	870173763000	6878	3420	112	0	\N
80709	1726	870163762000	6878	3420	113	0	\N
80710	1726	870153761000	6878	3420	114	0	\N
80711	1726	870143760000	6878	3420	115	0	\N
80712	1726	870133759000	6878	3420	116	0	\N
80713	1726	870123758000	6878	3420	117	0	\N
80714	1726	870113757000	6878	3420	118	0	\N
80715	1726	870103756000	6878	3420	119	0	\N
80716	1726	870093755000	6878	3420	120	0	\N
80717	1726	870083754000	6878	3420	121	0	\N
80718	1726	870073753000	6878	3420	122	0	\N
80719	1726	870063752000	6878	3420	123	0	\N
80720	1726	870053751000	6878	3420	124	0	\N
80721	1726	870043750000	6878	3420	125	0	\N
80722	1397	1393395473000	6879	3557	0	0	\N
80723	1397	1393385472000	6879	3557	1	0	\N
80724	1769	2944900000	6879	3557	2	0	\N
80725	1397	1393395473000	6880	3557	0	0	\N
80726	1726	868464722000	6880	3557	1	0	\N
80727	1726	868454721000	6880	3557	2	0	\N
80728	1397	1393385472000	6880	3557	3	0	\N
80729	1769	2944900000	6880	3557	4	0	\N
80730	1397	1393395473000	6881	3557	0	0	\N
80731	1726	868464722000	6881	3557	1	0	\N
80732	1726	868454721000	6881	3557	2	0	\N
80733	1397	1393385472000	6881	3557	3	0	\N
80734	1769	2944900000	6881	3557	4	0	\N
80735	1397	1393395473000	6882	3557	0	0	\N
80736	1726	868464722000	6882	3557	1	0	\N
80737	1726	868454721000	6882	3557	2	0	\N
80738	1397	1393385472000	6882	3557	3	0	\N
80739	1769	2944900000	6882	3557	4	0	\N
80745	1397	1393395473000	6884	3557	0	0	\N
80746	1397	1393385472000	6884	3557	1	0	\N
80747	1769	2944900000	6884	3557	2	0	\N
80748	1397	1393395473000	6885	3557	0	0	\N
80749	1726	868464722000	6885	3557	1	0	\N
80750	1726	868454721000	6885	3557	2	0	\N
80751	1397	1393385472000	6885	3557	3	0	\N
80752	1769	2944900000	6885	3557	4	0	\N
80753	1397	1393375471000	6886	3558	0	0	\N
80754	1726	868444720000	6886	3558	1	0	\N
80757	1397	1393375471000	6888	3558	0	0	\N
80758	1726	868444720000	6888	3558	1	0	\N
80759	1769	2944900000	6889	3370	0	0	\N
80760	1769	2934900000	6889	3370	1	0	\N
80770	1397	1393345468000	6893	3561	0	0	\N
80771	1726	868414717000	6893	3561	1	0	\N
80772	1726	868404716000	6893	3561	2	0	\N
80773	1397	1393335467000	6893	3561	3	0	\N
80782	1397	1393285462000	6899	3565	0	0	\N
80783	1726	868354711000	6899	3565	1	0	\N
80784	1397	1393285462000	6900	3565	0	0	\N
80742	1726	868454721000	6883	3557	2	0	415
80743	1397	1393385472000	6883	3557	3	0	4545
80744	1769	2944900000	6883	3557	4	0	16
80755	1397	1393375471000	6887	3558	0	0	4546
80756	1726	868444720000	6887	3558	1	0	416
80762	1769	2934900000	6890	3559	1	0	17
80763	1726	868434719000	6890	3559	2	0	417
80764	1397	1393355469000	6891	3560	0	0	4548
80765	1726	868424718000	6891	3560	1	0	418
80766	1397	1393345468000	6892	3561	0	0	4549
80768	1726	868404716000	6892	3561	2	0	420
80769	1397	1393335467000	6892	3561	3	0	4550
80774	1726	868394715000	6895	3562	0	0	421
80775	1726	868384714000	6895	3562	1	0	422
80777	1397	1393315465000	6895	3562	3	0	4552
80778	1397	1393305464000	6896	3563	0	0	4553
80779	1726	868374713000	6896	3563	1	0	423
80780	1397	1393295463000	6898	3564	0	0	4554
80781	1726	868364712000	6898	3564	1	0	424
80785	1726	868354711000	6900	3565	1	0	\N
80788	1726	868344710000	6902	3566	0	0	\N
80789	1397	1393275461000	6902	3566	1	0	\N
80798	1397	1393245458000	6906	3568	0	0	\N
80799	1726	868314707000	6906	3568	1	0	\N
80802	1726	868304706000	6908	3569	0	0	\N
80803	1397	1393235457000	6908	3569	1	0	\N
80804	1397	1393225456000	6909	3570	0	0	\N
80805	1397	1393225456000	6910	3570	0	0	\N
80806	1726	868294705000	6910	3570	1	0	\N
80807	1397	1393225456000	6911	3570	0	0	\N
80808	1726	868294705000	6911	3570	1	0	\N
80811	1397	1393225456000	6913	3570	0	0	\N
80814	1726	868284704000	6915	3571	0	0	\N
80815	1397	1393215455000	6915	3571	1	0	\N
80816	1726	868274703000	6916	3572	0	0	\N
80817	1397	1393205454000	6916	3572	1	0	\N
80818	1726	868274703000	6917	3572	0	0	\N
80819	1397	1393205454000	6917	3572	1	0	\N
80820	1726	868274703000	6918	3572	0	0	\N
80821	1397	1393205454000	6918	3572	1	0	\N
80822	1726	868274703000	6919	3572	0	0	\N
80823	1397	1393205454000	6919	3572	1	0	\N
80826	1397	1393195453000	6921	3573	0	0	\N
80827	1397	1393185452000	6921	3573	1	0	\N
80828	1726	868264702000	6921	3573	2	0	\N
80829	1726	868254701000	6921	3573	3	0	\N
80834	1397	1393195453000	6923	3573	0	0	\N
80835	1397	1393185452000	6923	3573	1	0	\N
80840	1397	1393165450000	6926	3575	0	0	\N
80841	1397	1393165450000	6927	3575	0	0	\N
80842	1726	868234699000	6927	3575	1	0	\N
80845	1726	868224698000	6929	3576	0	0	\N
80846	1397	1393155449000	6929	3576	1	0	\N
80847	1726	868214697000	6930	3577	0	0	\N
80848	1726	868204696000	6930	3577	1	0	\N
80849	1397	1393145448000	6930	3577	2	0	\N
80850	1397	1393135447000	6930	3577	3	0	\N
80869	1726	868134689000	6942	3583	0	0	\N
80870	1397	1393065440000	6942	3583	1	0	\N
80871	1397	1393065440000	6943	3583	0	0	\N
80876	1726	868104686000	6946	3585	0	0	\N
80877	1726	866804686000	6946	3585	1	0	\N
80878	1397	1393035437000	6946	3585	2	0	\N
80883	1397	1393015435000	6950	3587	0	0	\N
80884	1397	1393005434000	6950	3587	1	0	\N
80885	1397	1392995433000	6950	3587	2	0	\N
80889	1726	866794685000	6952	3587	0	0	\N
80890	1726	866784684000	6952	3587	1	0	\N
80891	1397	1393015435000	6952	3587	2	0	\N
80892	1397	1393005434000	6952	3587	3	0	\N
80893	1726	866774683000	6952	3587	4	0	\N
80894	1726	866764682000	6952	3587	5	0	\N
80895	1397	1392995433000	6952	3587	6	0	\N
80896	1726	866794685000	6953	3587	0	0	\N
80897	1726	866784684000	6953	3587	1	0	\N
80898	1397	1393015435000	6953	3587	2	0	\N
80899	1397	1393005434000	6953	3587	3	0	\N
80900	1726	866774683000	6953	3587	4	0	\N
80901	1726	866764682000	6953	3587	5	0	\N
80902	1397	1392995433000	6953	3587	6	0	\N
80903	1397	1393355469000	6954	3560	0	0	\N
80904	1397	1393345468000	6954	3560	1	0	\N
80905	1726	868424718000	6954	3560	2	0	\N
80906	1726	868414717000	6954	3560	3	0	\N
80907	1726	868404716000	6954	3560	4	0	\N
80908	1726	868394715000	6954	3560	5	0	\N
80909	1726	868384714000	6954	3560	6	0	\N
80910	1726	868374713000	6954	3560	7	0	\N
80911	1726	868364712000	6954	3560	8	0	\N
80912	1726	868354711000	6954	3560	9	0	\N
80913	1726	868344710000	6954	3560	10	0	\N
80914	1726	868334709000	6954	3560	11	0	\N
80915	1397	1393335467000	6954	3560	12	0	\N
80916	1397	1393325466000	6954	3560	13	0	\N
80917	1397	1393315465000	6954	3560	14	0	\N
80918	1397	1393305464000	6954	3560	15	0	\N
80919	1397	1393295463000	6954	3560	16	0	\N
80920	1397	1393285462000	6954	3560	17	0	\N
80790	1726	868344710000	6903	3566	0	0	426
80791	1397	1393275461000	6903	3566	1	0	4556
80792	1726	868334709000	6904	3567	0	0	427
80793	1397	1393265460000	6904	3567	1	0	4557
80794	1726	868324708000	6904	3567	2	0	428
80796	1397	1393245458000	6905	3568	0	0	4559
80797	1726	868314707000	6905	3568	1	0	429
80800	1726	868304706000	6907	3569	0	0	430
80801	1397	1393235457000	6907	3569	1	0	4560
80809	1397	1393225456000	6912	3570	0	0	4561
80812	1726	868284704000	6914	3571	0	0	432
80813	1397	1393215455000	6914	3571	1	0	4562
80824	1726	868274703000	6920	3572	0	0	433
80825	1397	1393205454000	6920	3572	1	0	4563
80831	1397	1393185452000	6922	3573	1	0	4565
80832	1726	868264702000	6922	3573	2	0	434
80833	1726	868254701000	6922	3573	3	0	435
80836	1726	868244700000	6924	3574	0	0	436
80837	1397	1393175451000	6924	3574	1	0	4566
80839	1726	868234699000	6925	3575	1	0	437
80843	1726	868224698000	6928	3576	0	0	438
80844	1397	1393155449000	6928	3576	1	0	4568
80851	1726	868214697000	6931	3577	0	0	439
80852	1726	868204696000	6931	3577	1	0	440
80854	1397	1393135447000	6931	3577	3	0	4570
80855	1726	868194695000	6934	3578	0	0	441
80856	1397	1393125446000	6934	3578	1	0	4571
80857	1726	868184694000	6937	3579	0	0	442
80859	1397	1393115445000	6937	3579	2	0	4572
80860	1397	1393105444000	6937	3579	3	0	4573
80861	1397	1393095443000	6938	3580	0	0	4574
80862	1726	868164692000	6938	3580	1	0	444
80863	1397	1393085442000	6939	3581	0	0	4575
80865	1726	868144690000	6940	3582	0	0	446
80866	1397	1393075441000	6940	3582	1	0	4576
80867	1726	868134689000	6941	3583	0	0	447
80868	1397	1393065440000	6941	3583	1	0	4577
80872	1726	868124688000	6945	3584	0	0	448
80874	1397	1393055439000	6945	3584	2	0	4578
80875	1397	1393045438000	6945	3584	3	0	4579
80879	1726	868104686000	6947	3585	0	0	450
80880	1726	866804686000	6947	3585	1	0	451
80882	1397	1393025436000	6949	3586	0	0	4581
80886	1397	1393015435000	6951	3587	0	0	4582
80887	1397	1393005434000	6951	3587	1	0	4583
80888	1397	1392995433000	6951	3587	2	0	4584
80921	1726	868324708000	6954	3560	18	0	\N
80922	1726	868314707000	6954	3560	19	0	\N
80923	1397	1393275461000	6954	3560	20	0	\N
80924	1397	1393265460000	6954	3560	21	0	\N
80925	1726	868304706000	6954	3560	22	0	\N
80926	1397	1393255459000	6954	3560	23	0	\N
80927	1397	1393245458000	6954	3560	24	0	\N
80928	1397	1393235457000	6954	3560	25	0	\N
80929	1397	1393225456000	6954	3560	26	0	\N
80930	1726	868294705000	6954	3560	27	0	\N
80931	1726	868284704000	6954	3560	28	0	\N
80932	1726	868274703000	6954	3560	29	0	\N
80933	1397	1393215455000	6954	3560	30	0	\N
80934	1397	1393205454000	6954	3560	31	0	\N
80935	1397	1393195453000	6954	3560	32	0	\N
80936	1397	1393185452000	6954	3560	33	0	\N
80937	1397	1393175451000	6954	3560	34	0	\N
80938	1397	1393165450000	6954	3560	35	0	\N
80939	1397	1393155449000	6954	3560	36	0	\N
80940	1397	1393145448000	6954	3560	37	0	\N
80941	1397	1393135447000	6954	3560	38	0	\N
80942	1397	1393125446000	6954	3560	39	0	\N
80943	1397	1393115445000	6954	3560	40	0	\N
80944	1397	1393105444000	6954	3560	41	0	\N
80945	1397	1393095443000	6954	3560	42	0	\N
80946	1397	1393085442000	6954	3560	43	0	\N
80947	1397	1393075441000	6954	3560	44	0	\N
80948	1397	1393065440000	6954	3560	45	0	\N
80949	1397	1393055439000	6954	3560	46	0	\N
80950	1397	1393045438000	6954	3560	47	0	\N
80951	1397	1393035437000	6954	3560	48	0	\N
80952	1397	1393025436000	6954	3560	49	0	\N
80953	1397	1393015435000	6954	3560	50	0	\N
80954	1397	1393005434000	6954	3560	51	0	\N
80955	1397	1392995433000	6954	3560	52	0	\N
80956	1726	868264702000	6954	3560	53	0	\N
80957	1726	868254701000	6954	3560	54	0	\N
80958	1726	868244700000	6954	3560	55	0	\N
80959	1726	868234699000	6954	3560	56	0	\N
80960	1726	868224698000	6954	3560	57	0	\N
80961	1726	868214697000	6954	3560	58	0	\N
80962	1726	868204696000	6954	3560	59	0	\N
80963	1726	868194695000	6954	3560	60	0	\N
80964	1726	868184694000	6954	3560	61	0	\N
80965	1726	868174693000	6954	3560	62	0	\N
80966	1726	868164692000	6954	3560	63	0	\N
80967	1726	868154691000	6954	3560	64	0	\N
80968	1726	868144690000	6954	3560	65	0	\N
80969	1726	868134689000	6954	3560	66	0	\N
80970	1726	868124688000	6954	3560	67	0	\N
80971	1726	868114687000	6954	3560	68	0	\N
80972	1726	868104686000	6954	3560	69	0	\N
80973	1726	866804686000	6954	3560	70	0	\N
80974	1726	866794685000	6954	3560	71	0	\N
80975	1726	866784684000	6954	3560	72	0	\N
80976	1726	866774683000	6954	3560	73	0	\N
80977	1726	866764682000	6954	3560	74	0	\N
80978	1726	866754681000	6954	3560	75	0	\N
80987	1726	866744680000	6957	3589	0	0	\N
80988	1397	1392975431000	6957	3589	1	0	\N
80991	1726	866734679000	6959	3590	0	0	\N
80992	1397	1392965430000	6959	3590	1	0	\N
80993	1726	866734679000	6960	3590	0	0	\N
80994	1397	1392965430000	6960	3590	1	0	\N
80995	1397	1392955429000	6961	3591	0	0	\N
80998	1726	866714677000	6963	3592	0	0	\N
80999	1397	1392945428000	6963	3592	1	0	\N
81006	1726	866694675000	6967	3594	0	0	\N
81007	1397	1392925426000	6967	3594	1	0	\N
81021	1726	866624668000	6972	3598	0	0	\N
81022	1397	1392855419000	6972	3598	1	0	\N
81023	1726	866624668000	6973	3598	0	0	\N
81024	1397	1392855419000	6973	3598	1	0	\N
81025	1726	866624668000	6974	3598	0	0	\N
81026	1397	1392855419000	6974	3598	1	0	\N
81027	1726	866624668000	6975	3598	0	0	\N
81028	1397	1392855419000	6975	3598	1	0	\N
81032	1397	1392845418000	6977	3599	0	0	\N
81033	1726	866624668000	6977	3599	1	0	\N
81034	1726	866614667000	6977	3599	2	0	\N
81037	1726	866594665000	6979	3601	0	0	\N
81038	1397	1392825416000	6979	3601	1	0	\N
81045	1397	1392815415000	6982	3602	0	0	\N
81046	1397	1392805414000	6982	3602	1	0	\N
81047	1726	866584664000	6982	3602	2	0	\N
81048	1726	866574663000	6982	3602	3	0	\N
80981	1726	866784684000	6955	3588	2	0	453
80982	1726	866774683000	6955	3588	3	0	454
80983	1726	866764682000	6955	3588	4	0	455
80984	1726	866754681000	6955	3588	5	0	456
80985	1726	866744680000	6956	3589	0	0	457
80989	1726	866734679000	6958	3590	0	0	458
80990	1397	1392965430000	6958	3590	1	0	4587
80996	1397	1392955429000	6962	3591	0	0	4588
80997	1726	866724678000	6962	3591	1	0	459
81000	1726	866714677000	6964	3592	0	0	460
81002	1397	1392935427000	6965	3593	0	0	4590
81003	1726	866704676000	6965	3593	1	0	461
81004	1726	866694675000	6966	3594	0	0	462
81005	1397	1392925426000	6966	3594	1	0	4591
81009	1726	866684674000	6968	3595	1	0	463
81010	1397	1392905424000	6969	3596	0	0	4593
81011	1726	866674673000	6970	3597	0	0	464
81012	1726	866664672000	6970	3597	1	0	465
81013	1397	1392895423000	6970	3597	2	0	4594
81015	1397	1392875421000	6970	3597	4	0	4596
81016	1397	1392865420000	6970	3597	5	0	4597
81017	1726	866654671000	6970	3597	6	0	466
81018	1726	866644670000	6970	3597	7	0	467
81019	1726	866634669000	6970	3597	8	0	468
81029	1397	1392845418000	6976	3599	0	0	4599
81030	1726	866624668000	6976	3599	1	0	469
81031	1726	866614667000	6976	3599	2	0	470
81035	1397	1392835417000	6978	3600	0	0	4600
81039	1726	866594665000	6980	3601	0	0	472
81040	1397	1392825416000	6980	3601	1	0	4601
81041	1397	1392815415000	6981	3602	0	0	4602
81042	1397	1392805414000	6981	3602	1	0	4603
81043	1726	866584664000	6981	3602	2	0	473
81049	1726	866564662000	6983	3603	0	0	475
81050	1397	1392795413000	6983	3603	1	0	4604
81051	1397	1392785412000	6984	3604	0	0	4605
81052	1397	1392775411000	6984	3604	1	0	4606
81053	1726	866554661000	6984	3604	2	0	476
81055	1726	866534659000	6985	3605	0	0	478
81056	1397	1392765410000	6985	3605	1	0	4607
81061	1726	866514657000	6988	3607	0	0	\N
81062	1397	1392745408000	6988	3607	1	0	\N
81069	1726	866494655000	6991	3609	0	0	\N
81070	1397	1392725406000	6991	3609	1	0	\N
81071	1726	866484654000	6991	3609	2	0	\N
81072	1397	1392715405000	6991	3609	3	0	\N
81073	1726	866474653000	6992	3610	0	0	\N
81074	1726	865174653000	6992	3610	1	0	\N
81075	1397	1392705404000	6992	3610	2	0	\N
81076	1726	865164652000	6992	3610	3	0	\N
81077	1397	1392695403000	6992	3610	4	0	\N
81078	1397	1392685402000	6992	3610	5	0	\N
81079	1397	1392675401000	6992	3610	6	0	\N
81080	1726	865154651000	6992	3610	7	0	\N
81081	1726	865144650000	6992	3610	8	0	\N
81082	1726	866474653000	6993	3610	0	0	\N
81083	1726	865174653000	6993	3610	1	0	\N
81084	1397	1392705404000	6993	3610	2	0	\N
81085	1726	865164652000	6993	3610	3	0	\N
81086	1397	1392695403000	6993	3610	4	0	\N
81087	1397	1392685402000	6993	3610	5	0	\N
81088	1397	1392675401000	6993	3610	6	0	\N
81089	1726	865154651000	6993	3610	7	0	\N
81090	1726	865144650000	6993	3610	8	0	\N
81100	1397	1392665400000	6995	3611	0	0	\N
81101	1726	865134649000	6995	3611	1	0	\N
81108	1397	1392645398000	7000	3613	0	0	\N
81109	1726	865114647000	7000	3613	1	0	\N
81110	1726	865104646000	7005	3614	0	0	\N
81111	1397	1392635397000	7005	3614	1	0	\N
81112	1726	865104646000	7006	3614	0	0	\N
81113	1397	1392635397000	7006	3614	1	0	\N
81116	1397	1392625396000	7008	3615	0	0	\N
81117	1397	1392615395000	7008	3615	1	0	\N
81118	1726	865094645000	7008	3615	2	0	\N
81119	1726	865084644000	7008	3615	3	0	\N
81120	1644	1199000000	7008	3615	4	0	\N
81126	1397	1392625396000	7010	3615	0	0	\N
81127	1397	1392615395000	7010	3615	1	0	\N
81128	1726	865094645000	7010	3615	2	0	\N
81129	1726	865084644000	7010	3615	3	0	\N
81130	1644	1199000000	7010	3615	4	0	\N
81131	1397	1392625396000	7011	3615	0	0	\N
81132	1397	1392615395000	7011	3615	1	0	\N
81133	1726	865094645000	7011	3615	2	0	\N
81134	1726	865084644000	7011	3615	3	0	\N
81135	1644	1199000000	7011	3615	4	0	\N
81136	1726	865074643000	7012	3616	0	0	\N
81137	1397	1392605394000	7012	3616	1	0	\N
81140	1726	865074643000	7014	3616	0	0	\N
81141	1397	1392605394000	7014	3616	1	0	\N
81148	1726	865054641000	7017	3618	0	0	\N
81149	1726	865044640000	7017	3618	1	0	\N
81150	1397	1392585392000	7017	3618	2	0	\N
81151	1397	1392575391000	7017	3618	3	0	\N
81156	1397	1392565390000	7019	3619	0	0	\N
81157	1726	865034639000	7019	3619	1	0	\N
81158	1726	865024638000	7019	3619	2	0	\N
81159	1397	1392555389000	7019	3619	3	0	\N
81160	1397	1392565390000	7020	3619	0	0	\N
81161	1726	865034639000	7020	3619	1	0	\N
81162	1726	865024638000	7020	3619	2	0	\N
81163	1397	1392555389000	7020	3619	3	0	\N
81168	1397	1392525386000	7022	3621	0	0	\N
81169	1397	1392515385000	7022	3621	1	0	\N
81170	1726	864994635000	7022	3621	2	0	\N
81171	1726	864984634000	7022	3621	3	0	\N
81172	1726	864974633000	7022	3621	4	0	\N
81173	1397	1392505384000	7022	3621	5	0	\N
81180	1726	864964632000	7024	3622	0	0	\N
81181	1397	1392495383000	7024	3622	1	0	\N
81182	1397	1392485382000	7024	3622	2	0	\N
81183	1726	864954631000	7024	3622	3	0	\N
81188	1726	864964632000	7026	3622	0	0	\N
81189	1397	1392495383000	7026	3622	1	0	\N
81190	1397	1392485382000	7026	3622	2	0	\N
81191	1726	864954631000	7026	3622	3	0	\N
81192	1726	864944630000	7027	3623	0	0	\N
81059	1726	866514657000	6987	3607	0	0	480
81060	1397	1392745408000	6987	3607	1	0	4609
81063	1397	1392735407000	6989	3608	0	0	4610
81064	1726	866504656000	6989	3608	1	0	481
81065	1726	866494655000	6990	3609	0	0	482
81067	1726	866484654000	6990	3609	2	0	483
81068	1397	1392715405000	6990	3609	3	0	4612
81091	1726	866474653000	6994	3610	0	0	484
81092	1726	865174653000	6994	3610	1	0	485
81093	1397	1392705404000	6994	3610	2	0	4613
81095	1397	1392695403000	6994	3610	4	0	4614
81096	1397	1392685402000	6994	3610	5	0	4615
81097	1397	1392675401000	6994	3610	6	0	4616
81098	1726	865154651000	6994	3610	7	0	487
81102	1397	1392665400000	6996	3611	0	0	4617
81103	1726	865134649000	6996	3611	1	0	489
81104	1397	1392655399000	6997	3612	0	0	4618
81105	1726	865124648000	6997	3612	1	0	490
81106	1397	1392645398000	6999	3613	0	0	4619
81114	1726	865104646000	7007	3614	0	0	492
81115	1397	1392635397000	7007	3614	1	0	4620
81121	1397	1392625396000	7009	3615	0	0	4621
81122	1397	1392615395000	7009	3615	1	0	4622
81123	1726	865094645000	7009	3615	2	0	493
81125	1644	1199000000	7009	3615	4	0	1
81138	1726	865074643000	7013	3616	0	0	495
81139	1397	1392605394000	7013	3616	1	0	4623
81142	1726	865064642000	7015	3617	0	0	496
81144	1726	865054641000	7016	3618	0	0	497
81145	1726	865044640000	7016	3618	1	0	498
81146	1397	1392585392000	7016	3618	2	0	4625
81147	1397	1392575391000	7016	3618	3	0	4626
81152	1397	1392565390000	7018	3619	0	0	4627
81154	1726	865024638000	7018	3619	2	0	500
81155	1397	1392555389000	7018	3619	3	0	4628
81164	1397	1392545388000	7021	3620	0	0	4629
81165	1397	1392535387000	7021	3620	1	0	4630
81166	1726	865014637000	7021	3620	2	0	501
81174	1397	1392525386000	7023	3621	0	0	4631
81175	1397	1392515385000	7023	3621	1	0	4632
81176	1726	864994635000	7023	3621	2	0	503
81177	1726	864984634000	7023	3621	3	0	504
81179	1397	1392505384000	7023	3621	5	0	4633
81184	1726	864964632000	7025	3622	0	0	506
81185	1397	1392495383000	7025	3622	1	0	4634
81186	1397	1392485382000	7025	3622	2	0	4635
81187	1726	864954631000	7025	3622	3	0	507
81193	1397	1392475381000	7027	3623	1	0	\N
81200	1397	1392465380000	7030	3624	0	0	\N
81201	1397	1392455379000	7030	3624	1	0	\N
81202	1726	864934629000	7030	3624	2	0	\N
81203	1726	864924628000	7030	3624	3	0	\N
81224	1397	1392355369000	7039	3632	0	0	\N
81225	1726	864824618000	7039	3632	1	0	\N
81226	1397	1392345368000	7040	3633	0	0	\N
81227	1726	864814617000	7040	3633	1	0	\N
81235	1726	863484614000	7043	3635	0	0	\N
81236	1726	863474613000	7043	3635	1	0	\N
81237	1397	1392315365000	7043	3635	2	0	\N
81238	1397	1392305364000	7043	3635	3	0	\N
81249	1397	1392285362000	7047	3637	0	0	\N
81250	1397	1392275361000	7047	3637	1	0	\N
81251	1726	863454611000	7047	3637	2	0	\N
81252	1726	863444610000	7047	3637	3	0	\N
81253	1397	1392285362000	7048	3637	0	0	\N
81254	1397	1392275361000	7048	3637	1	0	\N
81255	1726	863454611000	7048	3637	2	0	\N
81256	1726	863444610000	7048	3637	3	0	\N
81261	1397	1392245358000	7051	3640	0	0	\N
81262	1726	863414607000	7051	3640	1	0	\N
81263	1397	1392245358000	7052	3640	0	0	\N
81264	1726	863414607000	7052	3640	1	0	\N
81267	1397	1392235357000	7054	3641	0	0	\N
81268	1397	1392225356000	7054	3641	1	0	\N
81269	1726	863404606000	7054	3641	2	0	\N
81270	1726	863394605000	7054	3641	3	0	\N
81279	1726	863364602000	7058	3644	0	0	\N
81280	1397	1392195353000	7058	3644	1	0	\N
81289	1726	863324598000	7064	3647	0	0	\N
81290	1726	863314597000	7064	3647	1	0	\N
81291	1397	1392155349000	7064	3647	2	0	\N
81292	1397	1392145348000	7064	3647	3	0	\N
81297	1726	863304596000	7066	3648	0	0	\N
81298	1726	862004596000	7066	3648	1	0	\N
81299	1397	1392135347000	7066	3648	2	0	\N
81300	1726	863304596000	7067	3648	0	0	\N
81301	1726	862004596000	7067	3648	1	0	\N
81302	1397	1392135347000	7067	3648	2	0	\N
81303	1726	863304596000	7068	3648	0	0	\N
81304	1726	862004596000	7068	3648	1	0	\N
81305	1397	1392135347000	7068	3648	2	0	\N
81306	1726	864944630000	7070	3623	0	0	\N
81307	1726	864934629000	7070	3623	1	0	\N
81308	1726	864924628000	7070	3623	2	0	\N
81309	1726	864914627000	7070	3623	3	0	\N
81310	1726	864904626000	7070	3623	4	0	\N
81311	1726	864894625000	7070	3623	5	0	\N
81312	1726	864884624000	7070	3623	6	0	\N
81313	1397	1392475381000	7070	3623	7	0	\N
81314	1397	1392465380000	7070	3623	8	0	\N
81315	1397	1392455379000	7070	3623	9	0	\N
81316	1397	1392445378000	7070	3623	10	0	\N
81317	1397	1392435377000	7070	3623	11	0	\N
81318	1397	1392425376000	7070	3623	12	0	\N
81319	1397	1392415375000	7070	3623	13	0	\N
81320	1397	1392405374000	7070	3623	14	0	\N
81321	1397	1392395373000	7070	3623	15	0	\N
81322	1397	1392385372000	7070	3623	16	0	\N
81323	1397	1392375371000	7070	3623	17	0	\N
81324	1397	1392365370000	7070	3623	18	0	\N
81325	1397	1392355369000	7070	3623	19	0	\N
81326	1397	1392345368000	7070	3623	20	0	\N
81327	1397	1392335367000	7070	3623	21	0	\N
81328	1397	1392325366000	7070	3623	22	0	\N
81196	1397	1392465380000	7029	3624	0	0	4637
81197	1397	1392455379000	7029	3624	1	0	4638
81198	1726	864934629000	7029	3624	2	0	509
81199	1726	864924628000	7029	3624	3	0	510
81204	1397	1392445378000	7031	3625	0	0	4639
81206	1726	864904626000	7032	3626	0	0	512
81207	1726	864894625000	7032	3626	1	0	513
81208	1397	1392435377000	7032	3626	2	0	4640
81209	1397	1392425376000	7032	3626	3	0	4641
81210	1726	864884624000	7033	3627	0	0	514
81212	1397	1392405374000	7034	3628	0	0	4643
81213	1726	864874623000	7034	3628	1	0	515
81214	1397	1392395373000	7035	3629	0	0	4644
81215	1726	864864622000	7035	3629	1	0	516
81217	1397	1392385372000	7035	3629	3	0	4645
81218	1397	1392375371000	7036	3630	0	0	4646
81219	1726	864844620000	7036	3630	1	0	518
81220	1726	864834619000	7037	3631	0	0	519
81221	1397	1392365370000	7037	3631	1	0	4647
81223	1726	864824618000	7038	3632	1	0	520
81228	1397	1392345368000	7041	3633	0	0	4649
81229	1726	864814617000	7041	3633	1	0	521
81230	1726	863514617000	7042	3634	0	0	522
81231	1397	1392335367000	7042	3634	1	0	4650
81233	1726	863504616000	7042	3634	4	0	523
81234	1726	863494615000	7042	3634	5	0	524
81239	1726	863484614000	7044	3635	0	0	525
81240	1726	863474613000	7044	3635	1	0	526
81242	1397	1392305364000	7044	3635	3	0	4653
81243	1726	863464612000	7045	3636	0	0	527
81244	1397	1392295363000	7045	3636	1	0	4654
81245	1397	1392285362000	7046	3637	0	0	4655
81246	1397	1392275361000	7046	3637	1	0	4656
81248	1726	863444610000	7046	3637	3	0	529
81257	1397	1392265360000	7049	3638	0	0	4657
81258	1726	863434609000	7049	3638	1	0	530
81259	1397	1392255359000	7050	3639	0	0	4658
81260	1726	863424608000	7050	3639	1	0	531
81266	1726	863414607000	7053	3640	1	0	532
81271	1397	1392235357000	7055	3641	0	0	4660
81272	1397	1392225356000	7055	3641	1	0	4661
81273	1726	863404606000	7055	3641	2	0	533
81275	1397	1392215355000	7056	3642	0	0	4662
81276	1726	863384604000	7056	3642	1	0	535
81277	1397	1392205354000	7057	3643	0	0	4663
81278	1726	863374603000	7057	3643	1	0	536
81281	1726	863364602000	7059	3644	0	0	537
81283	1397	1392185352000	7060	3645	0	0	4665
81284	1397	1392175351000	7060	3645	1	0	4666
81285	1726	863354601000	7060	3645	2	0	538
81286	1726	863344600000	7060	3645	3	0	539
81287	1726	863334599000	7062	3646	0	0	540
81293	1726	863324598000	7065	3647	0	0	541
81294	1726	863314597000	7065	3647	1	0	542
81295	1397	1392155349000	7065	3647	2	0	4668
81296	1397	1392145348000	7065	3647	3	0	4669
81329	1397	1392315365000	7070	3623	23	0	\N
81330	1397	1392305364000	7070	3623	24	0	\N
81331	1397	1392295363000	7070	3623	25	0	\N
81332	1397	1392285362000	7070	3623	26	0	\N
81333	1397	1392275361000	7070	3623	27	0	\N
81334	1397	1392265360000	7070	3623	28	0	\N
81335	1397	1392255359000	7070	3623	29	0	\N
81336	1397	1392245358000	7070	3623	30	0	\N
81337	1397	1392235357000	7070	3623	31	0	\N
81338	1397	1392225356000	7070	3623	32	0	\N
81339	1397	1392215355000	7070	3623	33	0	\N
81340	1397	1392205354000	7070	3623	34	0	\N
81341	1397	1392195353000	7070	3623	35	0	\N
81342	1397	1392185352000	7070	3623	36	0	\N
81343	1397	1392175351000	7070	3623	37	0	\N
81344	1397	1392165350000	7070	3623	38	0	\N
81345	1397	1392155349000	7070	3623	39	0	\N
81346	1397	1392145348000	7070	3623	40	0	\N
81347	1726	864874623000	7070	3623	41	0	\N
81348	1726	864864622000	7070	3623	42	0	\N
81349	1726	864854621000	7070	3623	43	0	\N
81350	1726	864844620000	7070	3623	44	0	\N
81351	1726	864834619000	7070	3623	45	0	\N
81352	1726	864824618000	7070	3623	46	0	\N
81353	1726	864814617000	7070	3623	47	0	\N
81354	1726	863514617000	7070	3623	48	0	\N
81355	1726	863504616000	7070	3623	49	0	\N
81356	1726	863494615000	7070	3623	50	0	\N
81357	1726	863484614000	7070	3623	51	0	\N
81358	1726	863474613000	7070	3623	52	0	\N
81359	1726	863464612000	7070	3623	54	0	\N
81360	1726	863454611000	7070	3623	55	0	\N
81361	1726	863444610000	7070	3623	56	0	\N
81362	1726	863434609000	7070	3623	57	0	\N
81363	1726	863424608000	7070	3623	58	0	\N
81364	1726	863414607000	7070	3623	59	0	\N
81365	1726	863404606000	7070	3623	60	0	\N
81366	1726	863394605000	7070	3623	61	0	\N
81367	1726	863384604000	7070	3623	62	0	\N
81368	1726	863374603000	7070	3623	63	0	\N
81369	1726	863364602000	7070	3623	64	0	\N
81370	1726	863354601000	7070	3623	65	0	\N
81371	1726	863344600000	7070	3623	66	0	\N
81372	1726	863334599000	7070	3623	67	0	\N
81373	1726	863324598000	7070	3623	68	0	\N
81374	1726	863314597000	7070	3623	69	0	\N
81375	1726	863304596000	7070	3623	70	0	\N
81376	1726	862004596000	7070	3623	71	0	\N
81377	1397	1392135347000	7070	3623	72	0	\N
81385	1726	860684594000	7073	3651	0	0	\N
81386	1397	1392105344000	7073	3651	1	0	\N
81387	1726	860684594000	7074	3651	0	0	\N
81388	1397	1392105344000	7074	3651	1	0	\N
81402	1693	20479431551364	7077	3652	0	0	\N
81403	1726	860684594000	7077	3652	1	0	\N
81404	1726	860674593000	7077	3652	2	0	\N
81405	1726	860664592000	7077	3652	3	0	\N
81406	1726	860654591000	7077	3652	4	0	\N
81407	1726	860644590000	7077	3652	5	0	\N
81408	1726	860634589000	7077	3652	6	0	\N
81409	1397	1392105344000	7077	3652	7	0	\N
81410	1397	1392095343000	7077	3652	8	0	\N
81411	1397	1392085342000	7077	3652	9	0	\N
81412	1397	1392075341000	7077	3652	10	0	\N
81413	1397	1392065340000	7077	3652	11	0	\N
81414	1397	1392055339000	7077	3652	12	0	\N
81415	1726	865104646000	7078	3614	0	0	\N
81416	1397	1392635397000	7078	3614	1	0	\N
81417	1693	19759411551364	7078	3614	2	0	\N
81418	1397	1392625396000	7078	3614	3	0	\N
81419	1397	1392615395000	7078	3614	4	0	\N
81420	1726	865094645000	7078	3614	5	0	\N
81421	1726	865084644000	7078	3614	6	0	\N
81422	1726	865074643000	7078	3614	7	0	\N
81423	1726	865064642000	7078	3614	8	0	\N
81424	1726	865054641000	7078	3614	9	0	\N
81425	1726	865044640000	7078	3614	10	0	\N
81426	1726	865034639000	7078	3614	11	0	\N
81427	1726	865024638000	7078	3614	12	0	\N
81428	1726	865014637000	7078	3614	13	0	\N
81429	1726	865004636000	7078	3614	14	0	\N
81430	1397	1392605394000	7078	3614	15	0	\N
81431	1397	1392595393000	7078	3614	16	0	\N
81432	1397	1392585392000	7078	3614	17	0	\N
81433	1397	1392575391000	7078	3614	18	0	\N
81434	1397	1392565390000	7078	3614	19	0	\N
81435	1726	864994635000	7078	3614	20	0	\N
81436	1726	864984634000	7078	3614	21	0	\N
81437	1726	864974633000	7078	3614	22	0	\N
81438	1726	864964632000	7078	3614	23	0	\N
81439	1726	864954631000	7078	3614	24	0	\N
81440	1397	1392555389000	7078	3614	25	0	\N
81441	1397	1392545388000	7078	3614	26	0	\N
81442	1397	1392535387000	7078	3614	27	0	\N
81443	1397	1392525386000	7078	3614	28	0	\N
81444	1397	1392515385000	7078	3614	29	0	\N
81445	1397	1392505384000	7078	3614	30	0	\N
81446	1397	1392495383000	7078	3614	31	0	\N
81447	1397	1392485382000	7078	3614	32	0	\N
81448	1726	864944630000	7078	3614	33	0	\N
81449	1726	864934629000	7078	3614	34	0	\N
81450	1726	864924628000	7078	3614	35	0	\N
81451	1726	864914627000	7078	3614	36	0	\N
81452	1726	864904626000	7078	3614	37	0	\N
81453	1726	864894625000	7078	3614	38	0	\N
81454	1726	864884624000	7078	3614	39	0	\N
81455	1397	1392475381000	7078	3614	40	0	\N
81456	1397	1392465380000	7078	3614	41	0	\N
81457	1397	1392455379000	7078	3614	42	0	\N
81458	1397	1392445378000	7078	3614	43	0	\N
81459	1397	1392435377000	7078	3614	44	0	\N
81460	1397	1392425376000	7078	3614	45	0	\N
81461	1397	1392415375000	7078	3614	46	0	\N
81462	1397	1392405374000	7078	3614	47	0	\N
81463	1397	1392395373000	7078	3614	48	0	\N
81464	1397	1392385372000	7078	3614	49	0	\N
81380	1726	860704596000	7071	3649	2	0	545
81381	1726	860694595000	7071	3649	3	0	546
81382	1397	1392135347000	7071	3649	4	0	4670
81383	1397	1392125346000	7071	3649	5	0	4671
81384	1397	1392115345000	7072	3650	0	0	4672
81390	1726	860684594000	7076	3652	1	0	547
81391	1726	860674593000	7076	3652	2	0	548
81392	1726	860664592000	7076	3652	3	0	549
81393	1726	860654591000	7076	3652	4	0	550
81394	1726	860644590000	7076	3652	5	0	551
81396	1397	1392105344000	7076	3652	7	0	4673
81397	1397	1392095343000	7076	3652	8	0	4674
81398	1397	1392085342000	7076	3652	9	0	4675
81399	1397	1392075341000	7076	3652	10	0	4676
81401	1397	1392055339000	7076	3652	12	0	4678
81465	1397	1392375371000	7078	3614	50	0	\N
81466	1397	1392365370000	7078	3614	51	0	\N
81467	1397	1392355369000	7078	3614	52	0	\N
81468	1397	1392345368000	7078	3614	53	0	\N
81469	1397	1392335367000	7078	3614	54	0	\N
81470	1397	1392325366000	7078	3614	55	0	\N
81471	1397	1392315365000	7078	3614	56	0	\N
81472	1397	1392305364000	7078	3614	57	0	\N
81473	1397	1392295363000	7078	3614	58	0	\N
81474	1397	1392285362000	7078	3614	59	0	\N
81475	1397	1392275361000	7078	3614	60	0	\N
81476	1397	1392265360000	7078	3614	61	0	\N
81477	1397	1392255359000	7078	3614	62	0	\N
81478	1397	1392245358000	7078	3614	63	0	\N
81479	1397	1392235357000	7078	3614	64	0	\N
81480	1397	1392225356000	7078	3614	65	0	\N
81481	1397	1392215355000	7078	3614	66	0	\N
81482	1397	1392205354000	7078	3614	67	0	\N
81483	1397	1392195353000	7078	3614	68	0	\N
81484	1397	1392185352000	7078	3614	69	0	\N
81485	1397	1392175351000	7078	3614	70	0	\N
81486	1397	1392165350000	7078	3614	71	0	\N
81487	1397	1392155349000	7078	3614	72	0	\N
81488	1397	1392145348000	7078	3614	73	0	\N
81489	1726	864874623000	7078	3614	74	0	\N
81490	1726	864864622000	7078	3614	75	0	\N
81491	1726	864854621000	7078	3614	76	0	\N
81492	1726	864844620000	7078	3614	77	0	\N
81493	1726	864834619000	7078	3614	78	0	\N
81494	1726	864824618000	7078	3614	79	0	\N
81495	1726	864814617000	7078	3614	80	0	\N
81496	1726	863514617000	7078	3614	81	0	\N
81497	1726	863504616000	7078	3614	82	0	\N
81498	1726	863494615000	7078	3614	83	0	\N
81499	1726	863484614000	7078	3614	84	0	\N
81500	1726	863474613000	7078	3614	85	0	\N
81501	1726	863464612000	7078	3614	86	0	\N
81502	1726	863454611000	7078	3614	87	0	\N
81503	1726	863444610000	7078	3614	88	0	\N
81504	1726	863434609000	7078	3614	89	0	\N
81505	1726	863424608000	7078	3614	90	0	\N
81506	1726	863414607000	7078	3614	91	0	\N
81507	1726	863404606000	7078	3614	92	0	\N
81508	1726	863394605000	7078	3614	93	0	\N
81509	1726	863384604000	7078	3614	94	0	\N
81510	1726	863374603000	7078	3614	95	0	\N
81511	1726	863364602000	7078	3614	96	0	\N
81512	1726	863354601000	7078	3614	97	0	\N
81513	1726	863344600000	7078	3614	98	0	\N
81514	1726	863334599000	7078	3614	99	0	\N
81515	1726	863324598000	7078	3614	100	0	\N
81516	1726	863314597000	7078	3614	101	0	\N
81517	1726	863304596000	7078	3614	102	0	\N
81518	1726	862004596000	7078	3614	103	0	\N
81519	1726	860704596000	7078	3614	105	0	\N
81520	1726	860694595000	7078	3614	106	0	\N
81521	1726	860684594000	7078	3614	107	0	\N
81522	1726	860674593000	7078	3614	108	0	\N
81523	1726	860664592000	7078	3614	109	0	\N
81524	1726	860654591000	7078	3614	110	0	\N
81525	1726	860644590000	7078	3614	111	0	\N
81526	1726	860634589000	7078	3614	112	0	\N
81527	1397	1392135347000	7078	3614	113	0	\N
81528	1397	1392125346000	7078	3614	114	0	\N
81529	1397	1392115345000	7078	3614	115	0	\N
81530	1397	1392105344000	7078	3614	116	0	\N
81531	1397	1392095343000	7078	3614	117	0	\N
81532	1397	1392085342000	7078	3614	118	0	\N
81533	1397	1392075341000	7078	3614	119	0	\N
81534	1397	1392065340000	7078	3614	120	0	\N
81535	1397	1392055339000	7078	3614	121	0	\N
81536	1644	1199000000	7078	3614	122	0	\N
81537	1726	860624588000	7079	3653	0	0	\N
81538	1397	1392045338000	7079	3653	1	0	\N
81539	1397	1392035337000	7079	3653	2	0	\N
81540	1726	860614587000	7079	3653	3	0	\N
81549	1397	1392005334000	7082	3655	0	0	\N
81550	1397	1391995333000	7082	3655	1	0	\N
81551	1726	860584584000	7082	3655	2	0	\N
81552	1726	860574583000	7082	3655	3	0	\N
81557	1397	1392005334000	7084	3655	0	0	\N
81558	1397	1391995333000	7084	3655	1	0	\N
81559	1726	860584584000	7084	3655	2	0	\N
81560	1726	860574583000	7084	3655	3	0	\N
81563	1726	860564582000	7086	3656	0	0	\N
81564	1397	1391985332000	7086	3656	1	0	\N
81574	1397	1391935327000	7092	3662	0	0	\N
81575	1726	860504576000	7092	3662	1	0	\N
81576	1397	1391925326000	7092	3662	2	0	\N
81580	1397	1391915325000	7094	3663	0	0	\N
81583	1397	1391905324000	7096	3664	0	0	\N
81584	1726	860484574000	7096	3664	1	0	\N
81585	1397	1391905324000	7097	3664	0	0	\N
81586	1726	860484574000	7097	3664	1	0	\N
81589	1726	860474573000	7099	3665	0	0	\N
81590	1397	1391895323000	7099	3665	1	0	\N
81591	1726	860474573000	7100	3665	0	0	\N
81592	1397	1391895323000	7100	3665	1	0	\N
81595	1726	860474573000	7102	3665	0	0	\N
81543	1397	1392035337000	7080	3653	2	0	4680
81544	1726	860614587000	7080	3653	3	0	554
81545	1726	860604586000	7081	3654	0	0	555
81546	1726	860594585000	7081	3654	1	0	556
81547	1397	1392025336000	7081	3654	2	0	4681
81553	1397	1392005334000	7083	3655	0	0	4683
81554	1397	1391995333000	7083	3655	1	0	4684
81555	1726	860584584000	7083	3655	2	0	557
81556	1726	860574583000	7083	3655	3	0	558
81561	1726	860564582000	7085	3656	0	0	559
81565	1726	860554581000	7087	3657	0	0	560
81566	1397	1391975331000	7087	3657	1	0	4686
81567	1397	1391965330000	7088	3658	0	0	4687
81568	1726	860544580000	7088	3658	1	0	561
81570	1726	860534579000	7089	3659	1	0	562
81571	1726	860524578000	7090	3660	0	0	563
81572	1397	1391945328000	7090	3660	1	0	4689
81573	1726	860514577000	7091	3661	0	0	564
81577	1397	1391935327000	7093	3662	0	0	4690
81579	1397	1391925326000	7093	3662	2	0	4691
81581	1397	1391915325000	7095	3663	0	0	4692
81582	1726	860494575000	7095	3663	1	0	566
81587	1397	1391905324000	7098	3664	0	0	4693
81588	1726	860484574000	7098	3664	1	0	567
81594	1397	1391895323000	7101	3665	1	0	4694
81596	1397	1391885322000	7103	3666	0	0	4695
81597	1726	860464572000	7103	3666	1	0	569
81598	1726	860454571000	7104	3667	0	0	570
81600	1397	1391875321000	7104	3667	2	0	4696
81601	1397	1391865320000	7105	3668	0	0	\N
81602	1726	860434569000	7105	3668	1	0	\N
81607	1726	860414567000	7108	3670	0	0	\N
81608	1726	860404566000	7108	3670	1	0	\N
81609	1397	1391845318000	7108	3670	2	0	\N
81610	1397	1391835317000	7108	3670	3	0	\N
81619	1397	1391805314000	7111	3672	0	0	\N
81620	1397	1391795313000	7111	3672	1	0	\N
81621	1726	860374563000	7111	3672	2	0	\N
81622	1726	860364562000	7111	3672	3	0	\N
81644	1726	858974553000	7117	3677	0	0	\N
81645	1726	858964552000	7117	3677	1	0	\N
81646	1726	858954551000	7117	3677	2	0	\N
81647	1726	858944550000	7117	3677	3	0	\N
81648	1397	1391705304000	7117	3677	4	0	\N
81649	1397	1391695303000	7117	3677	5	0	\N
81650	1397	1391685302000	7117	3677	6	0	\N
81651	1397	1391675301000	7117	3677	7	0	\N
81652	1726	858934549000	7117	3677	8	0	\N
81653	1397	1391665300000	7117	3677	9	0	\N
81654	1693	21199341551364	7117	3677	10	0	\N
81666	1397	1391655299000	7119	3678	0	0	\N
81667	1726	858924548000	7119	3678	1	0	\N
81675	1726	857594545000	7122	3680	0	0	\N
81676	1726	857584544000	7122	3680	1	0	\N
81677	1397	1391625296000	7122	3680	2	0	\N
81678	1397	1391615295000	7122	3680	3	0	\N
81679	1397	1391605294000	7122	3680	4	0	\N
81680	1726	857574543000	7122	3680	5	0	\N
81687	1397	1391595293000	7124	3681	0	0	\N
81688	1726	857564542000	7124	3681	1	0	\N
81697	1397	1391565290000	7129	3684	0	0	\N
81698	1726	857534539000	7129	3684	1	0	\N
81701	1397	1391555289000	7131	3685	0	0	\N
81702	1726	857524538000	7131	3685	1	0	\N
81705	1397	1391535287000	7133	3687	0	0	\N
81706	1726	857504536000	7133	3687	1	0	\N
81707	1726	857494535000	7133	3687	2	0	\N
81711	1397	1391535287000	7135	3687	0	0	\N
81712	1726	857504536000	7135	3687	1	0	\N
81713	1726	857494535000	7135	3687	2	0	\N
81714	1726	857484534000	7136	3688	0	0	\N
81715	1726	857474533000	7136	3688	1	0	\N
81716	1726	857484534000	7137	3688	0	0	\N
81717	1726	857474533000	7137	3688	1	0	\N
81722	1896	180000000	7142	3691	0	0	\N
81723	1726	857444530000	7142	3691	1	0	\N
81724	1726	857434529000	7142	3691	2	0	\N
81730	1726	857414527000	7146	3693	0	0	\N
81731	1726	857414527000	7147	3693	0	0	\N
81732	1726	856114527000	7148	3694	0	0	\N
81733	1726	856104526000	7148	3694	1	0	\N
81736	1726	860704596000	7150	3624	0	0	\N
81605	1397	1391855319000	7107	3669	0	0	4698
81606	1726	860424568000	7107	3669	1	0	573
81611	1726	860414567000	7109	3670	0	0	574
81612	1726	860404566000	7109	3670	1	0	575
81613	1397	1391845318000	7109	3670	2	0	4699
81615	1726	860394565000	7110	3671	0	0	576
81616	1726	860384564000	7110	3671	1	0	577
81617	1397	1391825316000	7110	3671	2	0	4701
81618	1397	1391815315000	7110	3671	3	0	4702
81623	1397	1391805314000	7112	3672	0	0	4703
81625	1726	860374563000	7112	3672	2	0	578
81626	1726	860364562000	7112	3672	3	0	579
81627	1726	860354561000	7113	3673	0	0	580
81628	1726	860344560000	7113	3673	1	0	581
81630	1397	1391785312000	7113	3673	3	0	4705
81631	1397	1391775311000	7113	3673	4	0	4706
81632	1397	1391765310000	7113	3673	5	0	4707
81633	1726	860324558000	7114	3674	0	0	583
81634	1726	859024558000	7114	3674	1	0	584
81636	1726	859014557000	7115	3675	0	0	585
81637	1726	859004556000	7115	3675	1	0	586
81638	1397	1391745308000	7115	3675	2	0	4709
81639	1397	1391735307000	7115	3675	3	0	4710
81640	1397	1391725306000	7116	3676	0	0	4711
81642	1726	858994555000	7116	3676	2	0	587
81643	1726	858984554000	7116	3676	3	0	588
81655	1726	858974553000	7118	3677	0	0	589
81656	1726	858964552000	7118	3677	1	0	590
81658	1726	858944550000	7118	3677	3	0	592
81659	1397	1391705304000	7118	3677	4	0	4713
81660	1397	1391695303000	7118	3677	5	0	4714
81661	1397	1391685302000	7118	3677	6	0	4715
81662	1397	1391675301000	7118	3677	7	0	4716
81664	1397	1391665300000	7118	3677	9	0	4717
81665	1693	21199341551364	7118	3677	10	0	348
81668	1397	1391655299000	7120	3678	0	0	4718
81669	1726	858924548000	7120	3678	1	0	594
81670	1397	1391645298000	7121	3679	0	0	4719
81672	1726	858914547000	7121	3679	2	0	595
81673	1726	857614547000	7121	3679	3	0	596
81674	1726	857604546000	7121	3679	4	0	597
81681	1726	857594545000	7123	3680	0	0	598
81683	1397	1391625296000	7123	3680	2	0	4721
81684	1397	1391615295000	7123	3680	3	0	4722
81685	1397	1391605294000	7123	3680	4	0	4723
81686	1726	857574543000	7123	3680	5	0	600
81689	1397	1391595293000	7125	3681	0	0	4724
81691	1397	1391585292000	7126	3682	0	0	4725
81692	1726	857554541000	7126	3682	1	0	602
81693	1726	857544540000	7127	3683	0	0	603
81694	1397	1391575291000	7127	3683	1	0	4726
81695	1397	1391565290000	7128	3684	0	0	4727
81699	1397	1391555289000	7130	3685	0	0	4728
81700	1726	857524538000	7130	3685	1	0	605
81703	1397	1391545288000	7132	3686	0	0	4729
81704	1726	857514537000	7132	3686	1	0	606
81709	1726	857504536000	7134	3687	1	0	607
81710	1726	857494535000	7134	3687	2	0	608
81718	1726	857484534000	7138	3688	0	0	609
81719	1726	857474533000	7138	3688	1	0	610
81720	1726	857464532000	7139	3689	0	0	611
81725	1896	180000000	7143	3691	0	0	1
81726	1726	857444530000	7143	3691	1	0	613
81727	1726	857434529000	7143	3691	2	0	614
81728	1726	857424528000	7144	3692	0	0	615
81729	1726	857414527000	7145	3693	0	0	616
81735	1726	856104526000	7149	3694	1	0	618
81737	1693	19759411551364	7150	3624	1	0	\N
81738	1726	860694595000	7150	3624	2	0	\N
81739	1726	860684594000	7150	3624	3	0	\N
81740	1726	860674593000	7150	3624	4	0	\N
81741	1726	860664592000	7150	3624	5	0	\N
81742	1726	860654591000	7150	3624	6	0	\N
81743	1726	860644590000	7150	3624	7	0	\N
81744	1726	860634589000	7150	3624	8	0	\N
81745	1726	860624588000	7150	3624	9	0	\N
81746	1397	1392125346000	7150	3624	10	0	\N
81747	1397	1392115345000	7150	3624	11	0	\N
81748	1397	1392105344000	7150	3624	12	0	\N
81749	1397	1392095343000	7150	3624	13	0	\N
81750	1397	1392085342000	7150	3624	14	0	\N
81751	1397	1392075341000	7150	3624	15	0	\N
81752	1397	1392065340000	7150	3624	16	0	\N
81753	1397	1392055339000	7150	3624	17	0	\N
81754	1397	1392045338000	7150	3624	18	0	\N
81755	1397	1392035337000	7150	3624	19	0	\N
81756	1397	1392025336000	7150	3624	20	0	\N
81757	1397	1392015335000	7150	3624	21	0	\N
81758	1397	1392005334000	7150	3624	22	0	\N
81759	1397	1391995333000	7150	3624	23	0	\N
81760	1397	1391985332000	7150	3624	24	0	\N
81761	1397	1391975331000	7150	3624	25	0	\N
81762	1397	1391965330000	7150	3624	26	0	\N
81763	1397	1391955329000	7150	3624	27	0	\N
81764	1397	1391945328000	7150	3624	28	0	\N
81765	1397	1391935327000	7150	3624	29	0	\N
81766	1397	1391925326000	7150	3624	30	0	\N
81767	1397	1391915325000	7150	3624	31	0	\N
81768	1397	1391905324000	7150	3624	32	0	\N
81769	1726	860614587000	7150	3624	33	0	\N
81770	1726	860604586000	7150	3624	34	0	\N
81771	1726	860594585000	7150	3624	35	0	\N
81772	1726	860584584000	7150	3624	36	0	\N
81773	1726	860574583000	7150	3624	37	0	\N
81774	1726	860564582000	7150	3624	38	0	\N
81775	1726	860554581000	7150	3624	39	0	\N
81776	1726	860544580000	7150	3624	40	0	\N
81777	1726	860534579000	7150	3624	41	0	\N
81778	1726	860524578000	7150	3624	42	0	\N
81779	1726	860514577000	7150	3624	43	0	\N
81780	1726	860504576000	7150	3624	44	0	\N
81781	1726	860494575000	7150	3624	45	0	\N
81782	1726	860484574000	7150	3624	46	0	\N
81783	1726	860474573000	7150	3624	47	0	\N
81784	1726	860464572000	7150	3624	48	0	\N
81785	1726	860454571000	7150	3624	49	0	\N
81786	1726	860444570000	7150	3624	50	0	\N
81787	1397	1391895323000	7150	3624	51	0	\N
81788	1397	1391885322000	7150	3624	52	0	\N
81789	1397	1391875321000	7150	3624	53	0	\N
81790	1397	1391865320000	7150	3624	54	0	\N
81791	1397	1391855319000	7150	3624	55	0	\N
81792	1397	1391845318000	7150	3624	56	0	\N
81793	1397	1391835317000	7150	3624	57	0	\N
81794	1397	1391825316000	7150	3624	58	0	\N
81795	1397	1391815315000	7150	3624	59	0	\N
81796	1397	1391805314000	7150	3624	60	0	\N
81797	1397	1391795313000	7150	3624	61	0	\N
81798	1397	1391785312000	7150	3624	62	0	\N
81799	1397	1391775311000	7150	3624	63	0	\N
81800	1397	1391765310000	7150	3624	64	0	\N
81801	1397	1391755309000	7150	3624	65	0	\N
81802	1397	1391745308000	7150	3624	66	0	\N
81803	1397	1391735307000	7150	3624	67	0	\N
81804	1397	1391725306000	7150	3624	68	0	\N
81805	1397	1391715305000	7150	3624	69	0	\N
81806	1397	1391705304000	7150	3624	70	0	\N
81807	1397	1391695303000	7150	3624	71	0	\N
81808	1397	1391685302000	7150	3624	72	0	\N
81809	1397	1391675301000	7150	3624	73	0	\N
81810	1397	1391665300000	7150	3624	74	0	\N
81811	1397	1391655299000	7150	3624	75	0	\N
81812	1397	1391645298000	7150	3624	76	0	\N
81813	1397	1391635297000	7150	3624	77	0	\N
81814	1397	1391625296000	7150	3624	78	0	\N
81815	1397	1391615295000	7150	3624	79	0	\N
81816	1397	1391605294000	7150	3624	80	0	\N
81817	1397	1391595293000	7150	3624	81	0	\N
81818	1397	1391585292000	7150	3624	82	0	\N
81819	1397	1391575291000	7150	3624	83	0	\N
81820	1397	1391565290000	7150	3624	84	0	\N
81821	1397	1391555289000	7150	3624	85	0	\N
81822	1397	1391545288000	7150	3624	86	0	\N
81823	1397	1391535287000	7150	3624	87	0	\N
81824	1693	19759301551364	7150	3624	88	0	\N
81825	1726	860434569000	7150	3624	89	0	\N
81826	1726	860424568000	7150	3624	90	0	\N
81827	1726	860414567000	7150	3624	91	0	\N
81828	1726	860404566000	7150	3624	92	0	\N
81829	1726	860394565000	7150	3624	93	0	\N
81830	1726	860384564000	7150	3624	94	0	\N
81831	1726	860374563000	7150	3624	95	0	\N
81832	1726	860364562000	7150	3624	96	0	\N
81833	1726	860354561000	7150	3624	97	0	\N
81834	1726	860344560000	7150	3624	98	0	\N
81835	1726	860334559000	7150	3624	99	0	\N
81836	1726	860324558000	7150	3624	100	0	\N
81837	1726	859024558000	7150	3624	101	0	\N
81838	1726	859014557000	7150	3624	102	0	\N
81839	1726	859004556000	7150	3624	103	0	\N
81840	1726	858994555000	7150	3624	104	0	\N
81841	1726	858984554000	7150	3624	105	0	\N
81842	1726	858974553000	7150	3624	107	0	\N
81843	1726	858964552000	7150	3624	108	0	\N
81844	1726	858954551000	7150	3624	109	0	\N
81845	1726	858944550000	7150	3624	110	0	\N
81846	1726	858934549000	7150	3624	111	0	\N
81847	1726	858924548000	7150	3624	112	0	\N
81848	1726	858914547000	7150	3624	113	0	\N
81849	1726	857614547000	7150	3624	114	0	\N
81850	1726	857604546000	7150	3624	115	0	\N
81851	1726	857594545000	7150	3624	116	0	\N
81852	1726	857584544000	7150	3624	117	0	\N
81853	1726	857574543000	7150	3624	118	0	\N
81854	1726	857564542000	7150	3624	119	0	\N
81855	1726	857554541000	7150	3624	120	0	\N
81856	1726	857544540000	7150	3624	121	0	\N
81857	1726	857534539000	7150	3624	122	0	\N
81858	1726	857524538000	7150	3624	123	0	\N
81859	1726	857514537000	7150	3624	124	0	\N
81860	1726	857504536000	7150	3624	125	0	\N
81865	1726	856074523000	7153	3696	0	0	\N
81866	1726	856064522000	7153	3696	1	0	\N
81868	1726	856054521000	7155	3697	0	0	\N
81869	1726	856054521000	7156	3697	0	0	\N
81870	1522	11519970000000	7157	3698	0	0	\N
81871	1726	856044520000	7157	3698	1	0	\N
81872	1726	856034519000	7157	3698	2	0	\N
81863	1726	856074523000	7152	3696	0	0	621
81864	1726	856064522000	7152	3696	1	0	622
81867	1726	856054521000	7154	3697	0	0	623
81873	1522	11519970000000	7158	3698	0	0	\N
81874	1726	856044520000	7158	3698	1	0	\N
81875	1726	856034519000	7158	3698	2	0	\N
81876	1522	11519970000000	7159	3698	0	0	\N
81877	1726	856044520000	7159	3698	1	0	\N
81878	1726	856034519000	7159	3698	2	0	\N
81882	1522	11519970000000	7161	3698	0	0	\N
81883	1726	856044520000	7161	3698	1	0	\N
81884	1726	856034519000	7161	3698	2	0	\N
81887	1726	856014517000	7164	3700	0	0	\N
81889	1726	856004516000	7166	3701	0	0	\N
81890	1726	856004516000	7167	3701	0	0	\N
81892	1726	855994515000	7169	3702	0	0	\N
81893	1726	855984514000	7170	3703	0	0	\N
81902	1726	855934509000	7174	3705	0	0	\N
81903	1726	855924508000	7174	3705	1	0	\N
81907	1726	855884504000	7176	3707	0	0	\N
81909	1726	855884504000	7178	3707	0	0	\N
81910	1726	855884504000	7179	3707	0	0	\N
81919	1726	855804496000	7188	3715	0	0	\N
81924	1726	855754491000	7192	3719	0	0	\N
81925	1726	855744490000	7192	3719	2	0	\N
81926	1726	855754491000	7193	3719	0	0	\N
81927	1726	855744490000	7193	3719	2	0	\N
81934	1726	855714487000	7197	3721	0	0	\N
81935	1726	855704486000	7197	3721	1	0	\N
81936	1726	855734489000	7198	3720	0	0	\N
81937	1726	855724488000	7198	3720	1	0	\N
81938	1726	855714487000	7198	3720	2	0	\N
81939	1726	855704486000	7198	3720	3	0	\N
81940	1726	855694485000	7199	3722	0	0	\N
81941	1726	855694485000	7200	3722	0	0	\N
81943	1726	855684484000	7202	3723	0	0	\N
81944	1726	855674483000	7202	3723	1	0	\N
81945	1726	855684484000	7203	3723	0	0	\N
81946	1726	855674483000	7203	3723	1	0	\N
81947	1726	855684484000	7204	3723	0	0	\N
81948	1726	855674483000	7204	3723	1	0	\N
81956	1726	855624478000	7209	3726	0	0	\N
81959	1726	855604476000	7212	3728	0	0	\N
81962	1726	855574473000	7215	3731	0	0	\N
81963	1726	855564472000	7215	3731	1	0	\N
81964	1726	855554471000	7215	3731	2	0	\N
81969	1726	855544470000	7218	3732	0	0	\N
81970	1726	855534469000	7219	3733	0	0	\N
81971	1726	855534469000	7220	3733	0	0	\N
81972	1726	855534469000	7221	3733	0	0	\N
81974	327	66000000000000	7223	3734	0	0	\N
81975	1726	855524468000	7223	3734	1	0	\N
81976	327	66000000000000	7224	3734	0	0	\N
81977	1726	855524468000	7224	3734	1	0	\N
81982	1726	855494465000	7228	3737	0	0	\N
81984	1726	865074643000	7230	3616	0	0	\N
81985	1693	19759411551364	7230	3616	1	0	\N
81986	1726	865064642000	7230	3616	2	0	\N
81987	1726	865054641000	7230	3616	3	0	\N
81988	1726	865044640000	7230	3616	4	0	\N
81989	1726	865034639000	7230	3616	5	0	\N
81990	1726	865024638000	7230	3616	6	0	\N
81991	1726	865014637000	7230	3616	7	0	\N
81992	1726	865004636000	7230	3616	8	0	\N
81993	1397	1392605394000	7230	3616	9	0	\N
81994	1397	1392595393000	7230	3616	10	0	\N
81995	1397	1392585392000	7230	3616	11	0	\N
81996	1397	1392575391000	7230	3616	12	0	\N
81997	1397	1392565390000	7230	3616	13	0	\N
81998	1726	864994635000	7230	3616	14	0	\N
81999	1726	864984634000	7230	3616	15	0	\N
82000	1726	864974633000	7230	3616	16	0	\N
82001	1726	864964632000	7230	3616	17	0	\N
82002	1726	864954631000	7230	3616	18	0	\N
82003	1397	1392555389000	7230	3616	19	0	\N
82004	1397	1392545388000	7230	3616	20	0	\N
82005	1397	1392535387000	7230	3616	21	0	\N
82006	1397	1392525386000	7230	3616	22	0	\N
82007	1397	1392515385000	7230	3616	23	0	\N
82008	1397	1392505384000	7230	3616	24	0	\N
81881	1726	856034519000	7160	3698	2	0	625
81885	1726	856024518000	7162	3699	0	0	626
81886	1726	856014517000	7163	3700	0	0	627
81888	1726	856004516000	7165	3701	0	0	628
81891	1726	855994515000	7168	3702	0	0	629
81895	1726	855974513000	7172	3704	0	0	631
81896	1726	855964512000	7172	3704	1	0	632
81897	1726	855954511000	7172	3704	2	0	633
81898	1726	855944510000	7172	3704	3	0	634
81899	154	66000090000000	7172	3704	4	0	1
81901	1726	855924508000	7173	3705	1	0	636
81904	1726	855914507000	7175	3706	0	0	637
81905	1726	855904506000	7175	3706	1	0	638
81906	1726	855894505000	7175	3706	2	0	639
81911	1726	855874503000	7180	3708	0	0	641
81912	1726	855864502000	7181	3709	0	0	642
81913	1726	855854501000	7182	3710	0	0	643
81914	1726	855844500000	7183	3711	0	0	644
81915	1726	855834499000	7184	3712	0	0	645
81917	1726	855814497000	7186	3714	0	0	647
81918	1726	855804496000	7187	3715	0	0	648
81920	1726	855794495000	7189	3716	0	0	649
81921	1726	855784494000	7190	3717	0	0	650
81922	1726	855774493000	7191	3718	0	0	651
81928	1726	855754491000	7194	3719	0	0	653
81929	1726	855744490000	7194	3719	2	0	654
81930	1726	855734489000	7195	3720	0	0	655
81931	1726	855724488000	7195	3720	1	0	656
81933	1726	855704486000	7196	3721	1	0	658
81942	1726	855694485000	7201	3722	0	0	659
81949	1726	855684484000	7205	3723	0	0	660
81950	1726	855674483000	7205	3723	1	0	661
81951	1726	855664482000	7206	3724	0	0	662
81953	1726	855644480000	7207	3725	1	0	664
81954	1726	855634479000	7207	3725	2	0	665
81955	1726	855624478000	7208	3726	0	0	666
81957	1726	855614477000	7210	3727	0	0	667
81958	1726	855604476000	7211	3728	0	0	668
81961	1726	855584474000	7214	3730	0	0	670
81965	1726	855574473000	7216	3731	0	0	671
81966	1726	855564472000	7216	3731	1	0	672
81967	1726	855554471000	7216	3731	2	0	673
81973	1726	855534469000	7222	3733	0	0	675
81978	327	66000000000000	7225	3734	0	0	1
81979	1726	855524468000	7225	3734	1	0	676
81980	1726	855514467000	7226	3735	0	0	677
81981	1726	855504466000	7227	3736	0	0	678
82009	1397	1392495383000	7230	3616	25	0	\N
82010	1397	1392485382000	7230	3616	26	0	\N
82011	1726	864944630000	7230	3616	27	0	\N
82012	1726	864934629000	7230	3616	28	0	\N
82013	1726	864924628000	7230	3616	29	0	\N
82014	1726	864914627000	7230	3616	30	0	\N
82015	1726	864904626000	7230	3616	31	0	\N
82016	1726	864894625000	7230	3616	32	0	\N
82017	1726	864884624000	7230	3616	33	0	\N
82018	1397	1392475381000	7230	3616	34	0	\N
82019	1397	1392465380000	7230	3616	35	0	\N
82020	1397	1392455379000	7230	3616	36	0	\N
82021	1397	1392445378000	7230	3616	37	0	\N
82022	1397	1392435377000	7230	3616	38	0	\N
82023	1397	1392425376000	7230	3616	39	0	\N
82024	1397	1392415375000	7230	3616	40	0	\N
82025	1397	1392405374000	7230	3616	41	0	\N
82026	1397	1392395373000	7230	3616	42	0	\N
82027	1397	1392385372000	7230	3616	43	0	\N
82028	1397	1392375371000	7230	3616	44	0	\N
82029	1397	1392365370000	7230	3616	45	0	\N
82030	1397	1392355369000	7230	3616	46	0	\N
82031	1397	1392345368000	7230	3616	47	0	\N
82032	1397	1392335367000	7230	3616	48	0	\N
82033	1397	1392325366000	7230	3616	49	0	\N
82034	1397	1392315365000	7230	3616	50	0	\N
82035	1397	1392305364000	7230	3616	51	0	\N
82036	1397	1392295363000	7230	3616	52	0	\N
82037	1397	1392285362000	7230	3616	53	0	\N
82038	1397	1392275361000	7230	3616	54	0	\N
82039	1397	1392265360000	7230	3616	55	0	\N
82040	1397	1392255359000	7230	3616	56	0	\N
82041	1397	1392245358000	7230	3616	57	0	\N
82042	1397	1392235357000	7230	3616	58	0	\N
82043	1397	1392225356000	7230	3616	59	0	\N
82044	1397	1392215355000	7230	3616	60	0	\N
82045	1397	1392205354000	7230	3616	61	0	\N
82046	1397	1392195353000	7230	3616	62	0	\N
82047	1397	1392185352000	7230	3616	63	0	\N
82048	1397	1392175351000	7230	3616	64	0	\N
82049	1397	1392165350000	7230	3616	65	0	\N
82050	1397	1392155349000	7230	3616	66	0	\N
82051	1397	1392145348000	7230	3616	67	0	\N
82052	1726	864874623000	7230	3616	68	0	\N
82053	1726	864864622000	7230	3616	69	0	\N
82054	1726	864854621000	7230	3616	70	0	\N
82055	1726	864844620000	7230	3616	71	0	\N
82056	1726	864834619000	7230	3616	72	0	\N
82057	1726	864824618000	7230	3616	73	0	\N
82058	1726	864814617000	7230	3616	74	0	\N
82059	1726	863514617000	7230	3616	75	0	\N
82060	1726	863504616000	7230	3616	76	0	\N
82061	1726	863494615000	7230	3616	77	0	\N
82062	1726	863484614000	7230	3616	78	0	\N
82063	1726	863474613000	7230	3616	79	0	\N
82064	1726	863464612000	7230	3616	80	0	\N
82065	1726	863454611000	7230	3616	81	0	\N
82066	1726	863444610000	7230	3616	82	0	\N
82067	1726	863434609000	7230	3616	83	0	\N
82068	1726	863424608000	7230	3616	84	0	\N
82069	1726	863414607000	7230	3616	85	0	\N
82070	1726	863404606000	7230	3616	86	0	\N
82071	1726	863394605000	7230	3616	87	0	\N
82072	1726	863384604000	7230	3616	88	0	\N
82073	1726	863374603000	7230	3616	89	0	\N
82074	1726	863364602000	7230	3616	90	0	\N
82075	1726	863354601000	7230	3616	91	0	\N
82076	1726	863344600000	7230	3616	92	0	\N
82077	1726	863334599000	7230	3616	94	0	\N
82078	1726	863324598000	7230	3616	95	0	\N
82079	1726	863314597000	7230	3616	96	0	\N
82080	1726	863304596000	7230	3616	97	0	\N
82081	1726	862004596000	7230	3616	98	0	\N
82082	1726	860704596000	7230	3616	99	0	\N
82083	1726	860694595000	7230	3616	100	0	\N
82084	1726	860684594000	7230	3616	101	0	\N
82085	1726	860674593000	7230	3616	102	0	\N
82086	1726	860664592000	7230	3616	103	0	\N
82087	1726	860654591000	7230	3616	104	0	\N
82088	1726	860644590000	7230	3616	105	0	\N
82089	1726	860634589000	7230	3616	106	0	\N
82090	1397	1392135347000	7230	3616	107	0	\N
82091	1397	1392125346000	7230	3616	108	0	\N
82092	1397	1392115345000	7230	3616	109	0	\N
82093	1397	1392105344000	7230	3616	110	0	\N
82094	1397	1392095343000	7230	3616	111	0	\N
82095	1397	1392085342000	7230	3616	112	0	\N
82096	1397	1392075341000	7230	3616	113	0	\N
82097	1397	1392065340000	7230	3616	114	0	\N
82098	1397	1392055339000	7230	3616	115	0	\N
82099	1726	855484464000	7231	3738	0	0	\N
82100	1726	855474463000	7231	3738	1	0	\N
82103	1726	855464462000	7233	3739	0	0	\N
82107	1726	855454461000	7236	3740	0	0	\N
82108	1726	855444460000	7236	3740	1	0	\N
82109	1726	855434459000	7237	3741	0	0	\N
82110	1726	855434459000	7238	3741	0	0	\N
82113	1726	855424458000	7241	3742	0	0	\N
82114	1726	855414457000	7243	3744	0	0	\N
82115	1726	855404456000	7243	3744	1	0	\N
82116	1726	855394455000	7243	3744	2	0	\N
82124	1726	855344450000	7248	3748	0	0	\N
82125	1726	855334449000	7248	3748	1	0	\N
82128	1726	855324448000	7250	3749	0	0	\N
82131	1726	855304446000	7253	3751	0	0	\N
82135	1726	855284444000	7257	3753	0	0	\N
82138	1522	11519970000000	7260	3677	0	0	\N
82139	327	66000000000000	7260	3677	1	0	\N
82140	1726	858974553000	7260	3677	2	0	\N
82141	1726	858964552000	7260	3677	3	0	\N
82142	1726	858954551000	7260	3677	4	0	\N
82143	1726	858944550000	7260	3677	5	0	\N
82144	1397	1391705304000	7260	3677	6	0	\N
82104	1726	855464462000	7234	3739	0	0	682
82105	1726	855454461000	7235	3740	0	0	683
82106	1726	855444460000	7235	3740	1	0	684
82111	1726	855434459000	7239	3741	0	0	685
82112	1726	855424458000	7240	3742	0	0	686
82118	1726	855404456000	7244	3744	1	0	688
82119	1726	855394455000	7244	3744	2	0	689
82120	1726	855384454000	7245	3745	0	0	690
82121	1726	855374453000	7245	3745	1	0	691
82122	1726	855364452000	7246	3746	0	0	692
82126	1726	855344450000	7249	3748	0	0	694
82127	1726	855334449000	7249	3748	1	0	695
82129	1726	855324448000	7251	3749	0	0	696
82130	1726	855314447000	7252	3750	0	0	697
82133	1726	855294445000	7255	3752	0	0	699
82134	1726	855284444000	7256	3753	0	0	700
82136	1726	855274443000	7258	3754	0	0	701
82137	1726	855264442000	7259	3755	0	0	702
82145	1397	1391695303000	7260	3677	7	0	\N
82146	1397	1391685302000	7260	3677	8	0	\N
82147	1397	1391675301000	7260	3677	9	0	\N
82148	1726	858934549000	7260	3677	10	0	\N
82149	1726	858924548000	7260	3677	11	0	\N
82150	1397	1391665300000	7260	3677	12	0	\N
82151	1397	1391655299000	7260	3677	13	0	\N
82152	1397	1391645298000	7260	3677	14	0	\N
82153	1397	1391635297000	7260	3677	15	0	\N
82154	1397	1391625296000	7260	3677	16	0	\N
82155	1397	1391615295000	7260	3677	17	0	\N
82156	1397	1391605294000	7260	3677	18	0	\N
82157	1397	1391595293000	7260	3677	19	0	\N
82158	1397	1391585292000	7260	3677	20	0	\N
82159	1397	1391575291000	7260	3677	21	0	\N
82160	1397	1391565290000	7260	3677	22	0	\N
82161	1397	1391555289000	7260	3677	23	0	\N
82162	1397	1391545288000	7260	3677	24	0	\N
82163	1397	1391535287000	7260	3677	25	0	\N
82164	1726	858914547000	7260	3677	26	0	\N
82165	1726	857614547000	7260	3677	27	0	\N
82166	1726	857604546000	7260	3677	28	0	\N
82167	1726	857594545000	7260	3677	29	0	\N
82168	1726	857584544000	7260	3677	30	0	\N
82169	1726	857574543000	7260	3677	31	0	\N
82170	1726	857564542000	7260	3677	32	0	\N
82171	1726	857554541000	7260	3677	33	0	\N
82172	1726	857544540000	7260	3677	34	0	\N
82173	1726	857534539000	7260	3677	35	0	\N
82174	1726	857524538000	7260	3677	36	0	\N
82175	1726	857514537000	7260	3677	37	0	\N
82176	1726	857504536000	7260	3677	38	0	\N
82177	1726	857494535000	7260	3677	39	0	\N
82178	1726	857484534000	7260	3677	40	0	\N
82179	1726	857474533000	7260	3677	41	0	\N
82180	1726	857464532000	7260	3677	42	0	\N
82181	1726	857454531000	7260	3677	44	0	\N
82182	1726	857444530000	7260	3677	45	0	\N
82183	1693	21199341551364	7260	3677	46	0	\N
82184	1726	857434529000	7260	3677	47	0	\N
82185	1726	857424528000	7260	3677	48	0	\N
82186	1726	857414527000	7260	3677	49	0	\N
82187	1726	856114527000	7260	3677	50	0	\N
82188	1726	856104526000	7260	3677	51	0	\N
82189	1726	856094525000	7260	3677	52	0	\N
82190	1726	856084524000	7260	3677	53	0	\N
82191	1726	856074523000	7260	3677	54	0	\N
82192	1726	856064522000	7260	3677	55	0	\N
82193	1726	856054521000	7260	3677	56	0	\N
82194	1726	856044520000	7260	3677	57	0	\N
82195	1726	856034519000	7260	3677	58	0	\N
82196	1726	856024518000	7260	3677	59	0	\N
82197	1726	856014517000	7260	3677	60	0	\N
82198	1726	856004516000	7260	3677	61	0	\N
82199	1726	855994515000	7260	3677	62	0	\N
82200	1726	855984514000	7260	3677	63	0	\N
82201	1726	855974513000	7260	3677	64	0	\N
82202	1726	855964512000	7260	3677	65	0	\N
82203	1726	855954511000	7260	3677	66	0	\N
82204	1726	855944510000	7260	3677	67	0	\N
82205	1726	855934509000	7260	3677	68	0	\N
82206	1726	855924508000	7260	3677	69	0	\N
82207	1726	855914507000	7260	3677	70	0	\N
82208	1726	855904506000	7260	3677	71	0	\N
82209	1726	855894505000	7260	3677	72	0	\N
82210	1726	855884504000	7260	3677	73	0	\N
82211	1726	855874503000	7260	3677	74	0	\N
82212	1726	855864502000	7260	3677	75	0	\N
82213	1726	855854501000	7260	3677	76	0	\N
82214	1726	855844500000	7260	3677	77	0	\N
82215	1726	855834499000	7260	3677	78	0	\N
82216	1726	855824498000	7260	3677	79	0	\N
82217	1726	855814497000	7260	3677	80	0	\N
82218	1726	855804496000	7260	3677	81	0	\N
82219	1726	855794495000	7260	3677	82	0	\N
82220	1726	855784494000	7260	3677	83	0	\N
82221	1726	855774493000	7260	3677	84	0	\N
82222	1726	855764492000	7260	3677	85	0	\N
82223	1726	855754491000	7260	3677	86	0	\N
82224	1726	855744490000	7260	3677	87	0	\N
82225	1726	855734489000	7260	3677	88	0	\N
82226	1726	855724488000	7260	3677	89	0	\N
82227	1726	855714487000	7260	3677	90	0	\N
82228	1726	855704486000	7260	3677	91	0	\N
82229	1726	855694485000	7260	3677	92	0	\N
82230	1726	855684484000	7260	3677	93	0	\N
82231	1726	855674483000	7260	3677	94	0	\N
82232	1726	855664482000	7260	3677	95	0	\N
82233	1726	855654481000	7260	3677	96	0	\N
82234	1726	855644480000	7260	3677	97	0	\N
82235	1726	855634479000	7260	3677	98	0	\N
82236	1726	855624478000	7260	3677	99	0	\N
82237	1726	855614477000	7260	3677	100	0	\N
82238	1726	855604476000	7260	3677	101	0	\N
82239	1726	855594475000	7260	3677	102	0	\N
82240	1726	855584474000	7260	3677	103	0	\N
82241	1726	855574473000	7260	3677	104	0	\N
82242	1726	855564472000	7260	3677	105	0	\N
82243	1726	855554471000	7260	3677	106	0	\N
82244	1726	855544470000	7260	3677	107	0	\N
82245	1726	855534469000	7260	3677	108	0	\N
82246	1726	855524468000	7260	3677	109	0	\N
82247	1726	855514467000	7260	3677	110	0	\N
82248	1726	855504466000	7260	3677	111	0	\N
82249	1726	855494465000	7260	3677	112	0	\N
82250	1726	855484464000	7260	3677	113	0	\N
82251	1726	855474463000	7260	3677	114	0	\N
82252	1726	855464462000	7260	3677	115	0	\N
82253	1726	855454461000	7260	3677	116	0	\N
82254	1726	855444460000	7260	3677	117	0	\N
82255	1726	855434459000	7260	3677	118	0	\N
82256	1726	855424458000	7260	3677	119	0	\N
82257	1726	855414457000	7260	3677	120	0	\N
82258	1726	855404456000	7260	3677	121	0	\N
82259	1726	855394455000	7260	3677	122	0	\N
82260	1726	855384454000	7260	3677	123	0	\N
82261	1726	855374453000	7260	3677	124	0	\N
82262	1726	855364452000	7260	3677	125	0	\N
82266	1726	855224438000	7262	3757	0	0	\N
82268	1726	855224438000	7264	3757	0	0	\N
82269	1726	855224438000	7265	3757	0	0	\N
82270	1726	855224438000	7266	3757	0	0	\N
82271	1726	855224438000	7267	3757	0	0	\N
82272	1726	855214437000	7268	3758	0	0	\N
82273	1726	855214437000	7269	3758	0	0	\N
82277	1726	855184434000	7272	3760	0	0	\N
82265	1726	855234439000	7261	3756	2	0	705
82267	1726	855224438000	7263	3757	0	0	706
82274	1726	855214437000	7270	3758	0	0	707
82275	1726	855204436000	7271	3759	0	0	708
82276	1726	855194435000	7271	3759	1	0	709
82279	1726	855174433000	7274	3761	0	0	711
82280	1726	855164432000	7274	3761	1	0	712
82281	1726	855154431000	7275	3762	0	0	\N
82282	1726	855154431000	7276	3762	0	0	\N
82283	1726	855154431000	7277	3762	0	0	\N
82284	1726	855154431000	7280	3763	0	0	\N
82285	1726	855144430000	7280	3763	1	0	\N
82288	1726	855134429000	7282	3764	0	0	\N
82292	1726	855104426000	7285	3766	0	0	\N
82296	1726	855094425000	7288	3767	0	0	\N
82297	1726	855084424000	7288	3767	1	0	\N
82298	1726	855074423000	7289	3768	0	0	\N
82300	1726	855064422000	7291	3769	0	0	\N
82302	1726	855054421000	7293	3770	0	0	\N
82303	1726	855044420000	7293	3770	1	0	\N
82306	1726	855054421000	7295	3770	0	0	\N
82307	1726	855044420000	7295	3770	1	0	\N
82311	1726	855034419000	7300	3771	0	0	\N
82312	1726	855024418000	7300	3771	1	0	\N
82313	1726	855014417000	7300	3771	2	0	\N
82315	1726	854994415000	7302	3773	0	0	\N
82316	1726	854984414000	7302	3773	1	0	\N
82317	1726	854974413000	7302	3773	2	0	\N
82318	1726	854964412000	7302	3773	3	0	\N
82319	1726	854954411000	7302	3773	4	0	\N
82325	1726	854944410000	7304	3774	0	0	\N
82326	1726	854944410000	7306	3775	0	0	\N
82327	1726	854934409000	7306	3775	1	0	\N
82338	1740	16557913000000	7311	3778	0	0	\N
82339	1726	854884404000	7311	3778	1	0	\N
82340	1726	854874403000	7311	3778	2	0	\N
82341	1726	854864402000	7311	3778	3	0	\N
82342	1726	854854401000	7312	3779	0	0	\N
82345	1726	854834399000	7315	3781	0	0	\N
82346	1726	854824398000	7315	3781	1	0	\N
82352	1726	854814397000	7318	3782	0	0	\N
82353	1726	854804396000	7318	3782	1	0	\N
82354	1726	854794395000	7318	3782	2	0	\N
82356	1726	854784394000	7320	3783	0	0	\N
82359	1726	854764392000	7323	3785	0	0	\N
82360	1726	854764392000	7324	3785	0	0	\N
82362	1726	854744390000	7326	3787	0	0	\N
82364	1726	854734389000	7328	3788	0	0	\N
82366	1726	854734389000	7330	3788	0	0	\N
82368	1726	854724388000	7333	3789	0	0	\N
82370	1643	3175474999700	7335	3791	0	0	\N
82371	1643	2011330092700	7335	3791	1	0	\N
82372	1643	1225855074000	7335	3791	2	0	\N
82373	1643	576213113700	7335	3791	3	0	\N
82374	1726	854704386000	7335	3791	4	0	\N
82380	1643	3175474999700	7337	3791	0	0	\N
82381	1643	2011330092700	7337	3791	1	0	\N
82382	1643	1225855074000	7337	3791	2	0	\N
82383	1643	576213113700	7337	3791	3	0	\N
82384	1726	854704386000	7337	3791	4	0	\N
82389	327	66000000000000	7340	3700	0	0	\N
82390	1643	3175474999700	7340	3700	1	0	\N
82391	1643	2011330092700	7340	3700	2	0	\N
82392	1643	1225855074000	7340	3700	3	0	\N
82393	1643	576213113700	7340	3700	4	0	\N
82394	1740	16557913000000	7340	3700	5	0	\N
82395	1522	11519970000000	7341	3695	0	0	\N
82396	327	66000000000000	7341	3695	1	0	\N
82397	1643	3175474999700	7341	3695	2	0	\N
82398	1643	2011330092700	7341	3695	3	0	\N
82399	1643	1225855074000	7341	3695	4	0	\N
82400	1643	576213113700	7341	3695	5	0	\N
82401	1726	856094525000	7341	3695	6	0	\N
82402	1726	856084524000	7341	3695	7	0	\N
82403	1726	856074523000	7341	3695	8	0	\N
82404	1726	856064522000	7341	3695	9	0	\N
82405	1726	856054521000	7341	3695	10	0	\N
82406	1740	16557913000000	7341	3695	11	0	\N
82407	154	66000090000000	7341	3695	12	0	\N
82408	1726	856044520000	7341	3695	13	0	\N
82409	1726	856034519000	7341	3695	14	0	\N
82410	1726	856024518000	7341	3695	15	0	\N
82411	1726	856014517000	7341	3695	16	0	\N
82412	1726	856004516000	7341	3695	17	0	\N
82413	1726	855994515000	7341	3695	18	0	\N
82414	1726	855984514000	7341	3695	19	0	\N
82415	1726	855974513000	7341	3695	20	0	\N
82416	1726	855964512000	7341	3695	21	0	\N
82289	1726	855134429000	7283	3764	0	0	715
82290	1726	855124428000	7284	3765	0	0	716
82291	1726	855114427000	7284	3765	1	0	717
82293	1726	855104426000	7286	3766	0	0	718
82294	1726	855094425000	7287	3767	0	0	719
82299	1726	855074423000	7290	3768	0	0	721
82301	1726	855064422000	7292	3769	0	0	722
82304	1726	855054421000	7294	3770	0	0	723
82305	1726	855044420000	7294	3770	1	0	724
82308	1726	855034419000	7298	3771	0	0	725
82310	1726	855014417000	7298	3771	2	0	727
82314	1726	855004416000	7301	3772	0	0	728
82320	1726	854994415000	7303	3773	0	0	729
82321	1726	854984414000	7303	3773	1	0	730
82323	1726	854964412000	7303	3773	3	0	732
82324	1726	854954411000	7303	3773	4	0	733
82328	1726	854944410000	7307	3775	0	0	734
82329	1726	854934409000	7307	3775	1	0	735
82330	1726	854924408000	7308	3776	0	0	736
82332	1726	854904406000	7309	3777	1	0	738
82333	1726	854894405000	7309	3777	2	0	739
82334	1740	16557913000000	7310	3778	0	0	4
82335	1726	854884404000	7310	3778	1	0	740
82336	1726	854874403000	7310	3778	2	0	741
82343	1726	854854401000	7313	3779	0	0	743
82344	1726	854844400000	7314	3780	0	0	744
82347	1726	854834399000	7316	3781	0	0	745
82348	1726	854824398000	7316	3781	1	0	746
82350	1726	854804396000	7317	3782	1	0	748
82351	1726	854794395000	7317	3782	2	0	749
82355	1726	854784394000	7319	3783	0	0	750
82357	1726	854774393000	7321	3784	0	0	751
82358	1726	854764392000	7322	3785	0	0	752
82363	1726	854744390000	7327	3787	0	0	754
82365	1726	854734389000	7329	3788	0	0	755
82367	1726	854724388000	7332	3789	0	0	756
82369	1726	854714387000	7334	3790	0	0	757
82375	1643	3175474999700	7336	3791	0	0	6
82377	1643	1225855074000	7336	3791	2	0	8
82378	1643	576213113700	7336	3791	3	0	9
82379	1726	854704386000	7336	3791	4	0	758
82385	1726	854694385000	7338	3792	0	0	759
82387	1726	854674383000	7338	3792	3	0	761
82388	1726	854664382000	7339	3793	0	0	762
82417	1726	855954511000	7341	3695	22	0	\N
82418	1726	855944510000	7341	3695	23	0	\N
82419	1726	855934509000	7341	3695	24	0	\N
82420	1726	855924508000	7341	3695	25	0	\N
82421	1726	855914507000	7341	3695	26	0	\N
82422	1726	855904506000	7341	3695	27	0	\N
82423	1726	855894505000	7341	3695	28	0	\N
82424	1726	855884504000	7341	3695	29	0	\N
82425	1726	855874503000	7341	3695	30	0	\N
82426	1726	855864502000	7341	3695	31	0	\N
82427	1726	855854501000	7341	3695	32	0	\N
82428	1726	855844500000	7341	3695	33	0	\N
82429	1726	855834499000	7341	3695	34	0	\N
82430	1726	855824498000	7341	3695	35	0	\N
82431	1726	855814497000	7341	3695	36	0	\N
82432	1726	855804496000	7341	3695	37	0	\N
82433	1726	855794495000	7341	3695	38	0	\N
82434	1726	855784494000	7341	3695	39	0	\N
82435	1726	855774493000	7341	3695	40	0	\N
82436	1726	855764492000	7341	3695	41	0	\N
82437	1726	855754491000	7341	3695	42	0	\N
82438	1726	855744490000	7341	3695	43	0	\N
82439	1726	855734489000	7341	3695	44	0	\N
82440	1726	855724488000	7341	3695	45	0	\N
82441	1726	855714487000	7341	3695	46	0	\N
82442	1726	855704486000	7341	3695	47	0	\N
82443	1726	855694485000	7341	3695	48	0	\N
82444	1726	855684484000	7341	3695	49	0	\N
82445	1726	855674483000	7341	3695	50	0	\N
82446	1726	855664482000	7341	3695	51	0	\N
82447	1726	855654481000	7341	3695	52	0	\N
82448	1726	855644480000	7341	3695	53	0	\N
82449	1726	855634479000	7341	3695	54	0	\N
82450	1726	855624478000	7341	3695	55	0	\N
82451	1726	855614477000	7341	3695	56	0	\N
82452	1726	855604476000	7341	3695	57	0	\N
82453	1726	855594475000	7341	3695	58	0	\N
82454	1726	855584474000	7341	3695	59	0	\N
82455	1726	855574473000	7341	3695	60	0	\N
82456	1726	855564472000	7341	3695	61	0	\N
82457	1726	855554471000	7341	3695	62	0	\N
82458	1726	855544470000	7341	3695	63	0	\N
82459	1726	855534469000	7341	3695	64	0	\N
82460	1726	855524468000	7341	3695	65	0	\N
82461	1726	855514467000	7341	3695	66	0	\N
82462	1726	855504466000	7341	3695	67	0	\N
82463	1726	855494465000	7341	3695	68	0	\N
82464	1726	855484464000	7341	3695	69	0	\N
82465	1726	855474463000	7341	3695	70	0	\N
82466	1726	855464462000	7341	3695	71	0	\N
82467	1726	855454461000	7341	3695	72	0	\N
82468	1726	855444460000	7341	3695	73	0	\N
82469	1726	855434459000	7341	3695	74	0	\N
82470	1726	855424458000	7341	3695	75	0	\N
82471	1726	855414457000	7341	3695	76	0	\N
82472	1726	855404456000	7341	3695	77	0	\N
82473	1726	855394455000	7341	3695	78	0	\N
82474	1726	855384454000	7341	3695	79	0	\N
82475	1726	855374453000	7341	3695	80	0	\N
82476	1726	855364452000	7341	3695	81	0	\N
82477	1726	855354451000	7341	3695	82	0	\N
82478	1726	855344450000	7341	3695	83	0	\N
82479	1726	855334449000	7341	3695	84	0	\N
82480	1726	855324448000	7341	3695	86	0	\N
82481	1726	855314447000	7341	3695	87	0	\N
82482	1726	855304446000	7341	3695	88	0	\N
82483	1726	855294445000	7341	3695	89	0	\N
82484	1726	855284444000	7341	3695	90	0	\N
82485	1726	855274443000	7341	3695	91	0	\N
82486	1726	855264442000	7341	3695	92	0	\N
82487	1726	855254441000	7341	3695	93	0	\N
82488	1726	855244440000	7341	3695	94	0	\N
82489	1726	855234439000	7341	3695	95	0	\N
82490	1726	855224438000	7341	3695	96	0	\N
82491	1726	855214437000	7341	3695	97	0	\N
82492	1726	855204436000	7341	3695	98	0	\N
82493	1726	855194435000	7341	3695	99	0	\N
82494	1726	855184434000	7341	3695	100	0	\N
82495	1726	855174433000	7341	3695	101	0	\N
82496	1726	855164432000	7341	3695	102	0	\N
82497	1726	855154431000	7341	3695	103	0	\N
82498	1726	855144430000	7341	3695	104	0	\N
82499	1726	855134429000	7341	3695	105	0	\N
82500	1726	855124428000	7341	3695	106	0	\N
82501	1726	855114427000	7341	3695	107	0	\N
82502	1726	855104426000	7341	3695	108	0	\N
82503	1726	855094425000	7341	3695	109	0	\N
82504	1726	855084424000	7341	3695	110	0	\N
82505	1726	855074423000	7341	3695	111	0	\N
82506	1726	855064422000	7341	3695	112	0	\N
82507	1726	855054421000	7341	3695	113	0	\N
82508	1726	855044420000	7341	3695	114	0	\N
82509	1726	855034419000	7341	3695	115	0	\N
82510	1726	855024418000	7341	3695	116	0	\N
82511	1726	855014417000	7341	3695	117	0	\N
82512	1726	855004416000	7341	3695	118	0	\N
82513	1726	854994415000	7341	3695	119	0	\N
82514	1726	854984414000	7341	3695	120	0	\N
82515	1726	854974413000	7341	3695	121	0	\N
82516	1726	854964412000	7341	3695	122	0	\N
82517	1726	854954411000	7341	3695	123	0	\N
82518	1726	854944410000	7341	3695	124	0	\N
82519	1726	854934409000	7341	3695	125	0	\N
82524	1726	854614377000	7344	3796	0	0	\N
82533	1693	23230765543017	7347	3797	0	0	\N
82534	1726	854604376000	7347	3797	1	0	\N
82535	1693	23102159534670	7347	3797	2	0	\N
82536	1693	22973553526323	7347	3797	3	0	\N
82537	1693	22844947517976	7347	3797	4	0	\N
82538	1693	22716341509629	7347	3797	5	0	\N
82539	1769	2933900000	7347	3797	6	0	\N
82550	1693	21430281426159	7349	3799	0	0	\N
82551	1693	21301675417812	7349	3799	1	0	\N
82552	1693	21173069409465	7349	3799	2	0	\N
82522	1726	854634379000	7342	3794	2	0	765
82523	1726	854624378000	7343	3795	0	0	766
82525	1726	854614377000	7345	3796	0	0	767
82526	1693	23230765543017	7346	3797	0	0	349
82527	1726	854604376000	7346	3797	1	0	768
82529	1693	22973553526323	7346	3797	3	0	351
82530	1693	22844947517976	7346	3797	4	0	352
82531	1693	22716341509629	7346	3797	5	0	353
82532	1769	2933900000	7346	3797	6	0	18
82540	1726	854594375000	7348	3798	0	0	769
82542	1693	22459129492935	7348	3798	2	0	355
82543	1693	22330523484588	7348	3798	3	0	356
82544	1693	22201917476241	7348	3798	4	0	357
82545	1693	22073311467894	7348	3798	5	0	358
82547	1693	21816099451200	7348	3798	7	0	360
82548	1693	21687493442853	7348	3798	8	0	361
82549	1693	21558887434506	7348	3798	9	0	362
82553	1726	854584374000	7349	3799	3	0	\N
82554	1693	21044463401118	7349	3799	4	0	\N
82555	1693	20915857392771	7349	3799	5	0	\N
82556	1693	20787251384424	7349	3799	6	0	\N
82557	1693	20658645376077	7349	3799	7	0	\N
82566	1693	21430281426159	7351	3799	0	0	\N
82567	1693	21301675417812	7351	3799	1	0	\N
82568	1693	21173069409465	7351	3799	2	0	\N
82569	1726	854584374000	7351	3799	3	0	\N
82570	1693	21044463401118	7351	3799	4	0	\N
82571	1693	20915857392771	7351	3799	5	0	\N
82572	1693	20787251384424	7351	3799	6	0	\N
82573	1693	20658645376077	7351	3799	7	0	\N
82582	1693	20530039367730	7353	3800	0	0	\N
82583	1693	20401433359383	7353	3800	1	0	\N
82584	1693	20272827351036	7353	3800	2	0	\N
82585	1693	20145530683866	7353	3800	3	0	\N
82586	1693	18961122186557	7353	3800	4	0	\N
82587	1693	18832516178210	7353	3800	5	0	\N
82588	1693	18703910169863	7353	3800	6	0	\N
82589	1726	854574373000	7353	3800	7	0	\N
82590	1693	22510755543017	7354	3780	0	0	\N
82591	1693	22382149534670	7354	3780	1	0	\N
82592	1693	22253543526323	7354	3780	2	0	\N
82593	1693	22124937517976	7354	3780	3	0	\N
82594	1726	854844400000	7354	3780	4	0	\N
82595	1726	854834399000	7354	3780	5	0	\N
82596	1726	854824398000	7354	3780	6	0	\N
82597	1726	854814397000	7354	3780	7	0	\N
82598	1726	854804396000	7354	3780	8	0	\N
82599	1726	854794395000	7354	3780	9	0	\N
82600	1726	854784394000	7354	3780	10	0	\N
82601	1643	3175474999700	7354	3780	11	0	\N
82602	1643	2011330092700	7354	3780	12	0	\N
82603	1643	1225855074000	7354	3780	13	0	\N
82604	1643	576213113700	7354	3780	14	0	\N
82605	1726	854774393000	7354	3780	15	0	\N
82606	1726	854764392000	7354	3780	16	0	\N
82607	1726	854754391000	7354	3780	17	0	\N
82608	1726	854744390000	7354	3780	18	0	\N
82609	1693	21996331509629	7354	3780	19	0	\N
82610	1693	21867725501282	7354	3780	20	0	\N
82611	1693	21739119492935	7354	3780	21	0	\N
82612	1693	21610513484588	7354	3780	22	0	\N
82613	1693	21481907476241	7354	3780	23	0	\N
82614	1693	21353301467894	7354	3780	24	0	\N
82615	1693	21224695459547	7354	3780	25	0	\N
82616	1693	21096089451200	7354	3780	26	0	\N
82617	1693	20967483442853	7354	3780	27	0	\N
82618	1693	20838877434506	7354	3780	28	0	\N
82619	1693	20710271426159	7354	3780	29	0	\N
82620	1693	20581665417812	7354	3780	30	0	\N
82621	1693	20453059409465	7354	3780	31	0	\N
82622	1693	20324453401118	7354	3780	32	0	\N
82623	1693	20195847392771	7354	3780	33	0	\N
82624	1693	20067241384424	7354	3780	34	0	\N
82625	1693	19938635376077	7354	3780	35	0	\N
82626	1693	19810029367730	7354	3780	36	0	\N
82627	1693	19681423359383	7354	3780	37	0	\N
82628	1693	19552817351036	7354	3780	38	0	\N
82629	1693	19425520683866	7354	3780	39	0	\N
82630	1693	18241112186557	7354	3780	40	0	\N
82631	1726	854734389000	7354	3780	41	0	\N
82632	1726	854724388000	7354	3780	42	0	\N
82633	1726	854714387000	7354	3780	43	0	\N
82634	1726	854704386000	7354	3780	45	0	\N
82635	1726	854694385000	7354	3780	46	0	\N
82636	1726	854684384000	7354	3780	47	0	\N
82637	1726	854674383000	7354	3780	48	0	\N
82638	1726	854664382000	7354	3780	49	0	\N
82639	1726	854654381000	7354	3780	50	0	\N
82640	1726	854644380000	7354	3780	51	0	\N
82641	1726	854634379000	7354	3780	52	0	\N
82642	1726	854624378000	7354	3780	53	0	\N
82643	1726	854614377000	7354	3780	54	0	\N
82644	1726	854604376000	7354	3780	55	0	\N
82645	1726	854594375000	7354	3780	56	0	\N
82646	1726	854584374000	7354	3780	57	0	\N
82647	1769	2933900000	7354	3780	58	0	\N
82657	1693	18700003321141	7356	3801	0	0	\N
82658	1726	854564372000	7356	3801	1	0	\N
82659	1693	18571397312794	7356	3801	2	0	\N
82660	1693	18442791304447	7356	3801	3	0	\N
82661	1693	18314185296100	7356	3801	4	0	\N
82662	1693	18185579287753	7356	3801	5	0	\N
82663	1693	18056973279406	7356	3801	6	0	\N
82664	1693	17928367271059	7356	3801	7	0	\N
82665	1693	17799761262712	7356	3801	8	0	\N
82684	1693	17795854413990	7358	3802	0	0	\N
82685	1726	854554371000	7358	3802	1	0	\N
82686	1726	854544370000	7358	3802	2	0	\N
82687	1693	17667248405643	7358	3802	3	0	\N
82688	1693	17538642397296	7358	3802	4	0	\N
82560	1693	21173069409465	7350	3799	2	0	365
82561	1726	854584374000	7350	3799	3	0	770
82562	1693	21044463401118	7350	3799	4	0	366
82563	1693	20915857392771	7350	3799	5	0	367
82564	1693	20787251384424	7350	3799	6	0	368
82574	1693	20530039367730	7352	3800	0	0	370
82575	1693	20401433359383	7352	3800	1	0	371
82576	1693	20272827351036	7352	3800	2	0	372
82577	1693	20145530683866	7352	3800	3	0	373
82578	1693	18961122186557	7352	3800	4	0	374
82580	1693	18703910169863	7352	3800	6	0	376
82581	1726	854574373000	7352	3800	7	0	771
82648	1693	18700003321141	7355	3801	0	0	377
82649	1726	854564372000	7355	3801	1	0	772
82651	1693	18442791304447	7355	3801	3	0	379
82652	1693	18314185296100	7355	3801	4	0	380
82653	1693	18185579287753	7355	3801	5	0	381
82654	1693	18056973279406	7355	3801	6	0	382
82655	1693	17928367271059	7355	3801	7	0	383
82666	1693	17795854413990	7357	3802	0	0	385
82667	1726	854554371000	7357	3802	1	0	773
82668	1726	854544370000	7357	3802	2	0	774
82669	1693	17667248405643	7357	3802	3	0	386
82670	1693	17538642397296	7357	3802	4	0	387
82672	1693	17281430380602	7357	3802	6	0	389
82673	1693	13980988657032	7357	3802	7	0	390
82674	1693	13585344918966	7357	3802	8	0	391
82675	1693	13189701180900	7357	3802	9	0	392
82677	1693	12932489164206	7357	3802	11	0	394
82678	1693	12919430566230	7357	3802	12	0	395
82679	1693	12790824557883	7357	3802	13	0	396
82680	1693	12662218549536	7357	3802	14	0	397
82681	1693	12533612541189	7357	3802	15	0	398
82683	1693	12401099684120	7357	3802	17	0	400
82689	1693	17410036388949	7358	3802	5	0	\N
82690	1693	17281430380602	7358	3802	6	0	\N
82691	1693	13980988657032	7358	3802	7	0	\N
82692	1693	13585344918966	7358	3802	8	0	\N
82693	1693	13189701180900	7358	3802	9	0	\N
82694	1693	13061095172553	7358	3802	10	0	\N
82695	1693	12932489164206	7358	3802	11	0	\N
82696	1693	12919430566230	7358	3802	12	0	\N
82697	1693	12790824557883	7358	3802	13	0	\N
82698	1693	12662218549536	7358	3802	14	0	\N
82699	1693	12533612541189	7358	3802	15	0	\N
82700	1693	12405006532842	7358	3802	16	0	\N
82701	1693	12401099684120	7358	3802	17	0	\N
82702	1726	854534369000	7359	3803	0	0	\N
82703	1693	12387450713546	7359	3803	1	0	\N
82704	1693	12258844705199	7359	3803	2	0	\N
82705	1693	12130238696852	7359	3803	3	0	\N
82706	1693	12001632688505	7359	3803	4	0	\N
82707	1693	11873026680158	7359	3803	5	0	\N
82708	1693	10893440124497	7359	3803	6	0	\N
82709	1693	10764834116150	7359	3803	7	0	\N
82710	1693	10636228107803	7359	3803	8	0	\N
82720	1726	854534369000	7361	3803	0	0	\N
82721	1693	12387450713546	7361	3803	1	0	\N
82722	1693	12258844705199	7361	3803	2	0	\N
82723	1693	12130238696852	7361	3803	3	0	\N
82724	1693	12001632688505	7361	3803	4	0	\N
82725	1693	11873026680158	7361	3803	5	0	\N
82726	1693	10893440124497	7361	3803	6	0	\N
82727	1693	10764834116150	7361	3803	7	0	\N
82728	1693	10636228107803	7361	3803	8	0	\N
82729	1693	10507622099456	7362	3804	0	0	\N
82730	1693	10379016091109	7362	3804	1	0	\N
82731	1693	10250410082762	7362	3804	2	0	\N
82732	1693	10121804074415	7362	3804	3	0	\N
82733	1726	854524368000	7362	3804	4	0	\N
82734	1693	9993198066068	7362	3804	5	0	\N
82735	1693	9864592057721	7362	3804	6	0	\N
82736	1693	9266760810037	7362	3804	7	0	\N
82737	1693	10507622099456	7363	3804	0	0	\N
82738	1693	10379016091109	7363	3804	1	0	\N
82739	1693	10250410082762	7363	3804	2	0	\N
82740	1693	10121804074415	7363	3804	3	0	\N
82741	1726	854524368000	7363	3804	4	0	\N
82742	1693	9993198066068	7363	3804	5	0	\N
82743	1693	9864592057721	7363	3804	6	0	\N
82744	1693	9266760810037	7363	3804	7	0	\N
82745	1693	10507622099456	7364	3804	0	0	\N
82746	1693	10379016091109	7364	3804	1	0	\N
82747	1693	10250410082762	7364	3804	2	0	\N
82748	1693	10121804074415	7364	3804	3	0	\N
82749	1726	854524368000	7364	3804	4	0	\N
82750	1693	9993198066068	7364	3804	5	0	\N
82751	1693	9864592057721	7364	3804	6	0	\N
82752	1693	9266760810037	7364	3804	7	0	\N
82761	1726	854514367000	7366	3805	0	0	\N
82762	1693	9138154801690	7366	3805	1	0	\N
82763	1693	9009548793343	7366	3805	2	0	\N
82764	1693	8880942784996	7366	3805	3	0	\N
82765	1693	8752336776649	7366	3805	4	0	\N
82766	1693	8623730768302	7366	3805	5	0	\N
82767	1693	8495124759955	7366	3805	6	0	\N
82768	1726	854514367000	7367	3805	0	0	\N
82769	1693	9138154801690	7367	3805	1	0	\N
82770	1693	9009548793343	7367	3805	2	0	\N
82771	1693	8880942784996	7367	3805	3	0	\N
82772	1693	8752336776649	7367	3805	4	0	\N
82773	1693	8623730768302	7367	3805	5	0	\N
82774	1693	8495124759955	7367	3805	6	0	\N
82782	1693	8457705012081	7369	3806	0	0	\N
82783	1726	854504366000	7369	3806	1	0	\N
82784	1693	8329099003734	7369	3806	2	0	\N
82785	1693	6573696208959	7369	3806	3	0	\N
82786	1693	6445090200612	7369	3806	4	0	\N
82787	1693	6316484192265	7369	3806	5	0	\N
82788	1693	6187878183918	7369	3806	6	0	\N
82789	1693	8457705012081	7370	3806	0	0	\N
82790	1726	854504366000	7370	3806	1	0	\N
82791	1693	8329099003734	7370	3806	2	0	\N
82792	1693	6573696208959	7370	3806	3	0	\N
82793	1693	6445090200612	7370	3806	4	0	\N
82794	1693	6316484192265	7370	3806	5	0	\N
82795	1693	6187878183918	7370	3806	6	0	\N
82713	1693	12258844705199	7360	3803	2	0	402
82714	1693	12130238696852	7360	3803	3	0	403
82715	1693	12001632688505	7360	3803	4	0	404
82716	1693	11873026680158	7360	3803	5	0	405
82717	1693	10893440124497	7360	3803	6	0	406
82719	1693	10636228107803	7360	3803	8	0	408
82753	1693	10507622099456	7365	3804	0	0	409
82754	1693	10379016091109	7365	3804	1	0	410
82755	1693	10250410082762	7365	3804	2	0	411
82756	1693	10121804074415	7365	3804	3	0	412
82758	1693	9993198066068	7365	3804	5	0	413
82759	1693	9864592057721	7365	3804	6	0	414
82760	1693	9266760810037	7365	3804	7	0	415
82775	1726	854514367000	7368	3805	0	0	777
82777	1693	9009548793343	7368	3805	2	0	417
82778	1693	8880942784996	7368	3805	3	0	418
82779	1693	8752336776649	7368	3805	4	0	419
82780	1693	8623730768302	7368	3805	5	0	420
82781	1693	8495124759955	7368	3805	6	0	421
82797	1726	854504366000	7371	3806	1	0	778
82798	1693	8329099003734	7371	3806	2	0	423
82799	1693	6573696208959	7371	3806	3	0	424
82800	1693	6445090200612	7371	3806	4	0	425
82801	1693	6316484192265	7371	3806	5	0	426
82803	1726	854494365000	7372	3807	1	0	779
82804	1769	1823900000	7372	3807	2	0	19
82805	1693	6187878183918	7372	3807	3	0	427
82806	1693	6178126062085	7372	3807	4	0	428
82808	1693	6030025810067	7372	3807	6	0	430
82809	1693	5901419801720	7372	3807	7	0	431
82810	1693	5772813793373	7372	3807	8	0	432
82811	1693	5644207785026	7372	3807	9	0	433
82812	1693	5515601776679	7372	3807	10	0	434
82814	1693	5258389759985	7372	3807	12	0	436
82815	1693	5129783751638	7372	3807	13	0	437
82816	1693	5001177743291	7372	3807	14	0	438
82817	1693	4872571734944	7372	3807	15	0	439
82818	1693	4743965726597	7372	3807	16	0	440
82820	1693	4486753709903	7372	3807	18	0	442
82821	1693	3888922462219	7372	3807	19	0	443
82822	1693	3760316453872	7372	3807	20	0	444
82823	1693	3631710445525	7372	3807	21	0	445
82832	1740	16557888000000	7373	3807	0	0	\N
82833	1726	854494365000	7373	3807	1	0	\N
82834	1769	1823900000	7373	3807	2	0	\N
82835	1693	6178126062085	7373	3807	3	0	\N
82836	1693	6158631818414	7373	3807	4	0	\N
82837	1693	6030025810067	7373	3807	5	0	\N
82838	1693	5901419801720	7373	3807	6	0	\N
82839	1693	5772813793373	7373	3807	7	0	\N
82840	1693	5644207785026	7373	3807	8	0	\N
82841	1693	5515601776679	7373	3807	9	0	\N
82842	1693	5386995768332	7373	3807	10	0	\N
82843	1693	5258389759985	7373	3807	11	0	\N
82844	1693	5129783751638	7373	3807	12	0	\N
82845	1693	5001177743291	7373	3807	13	0	\N
82846	1693	4872571734944	7373	3807	14	0	\N
82847	1693	4743965726597	7373	3807	15	0	\N
82848	1693	4615359718250	7373	3807	16	0	\N
82849	1693	4486753709903	7373	3807	17	0	\N
82850	1693	3888922462219	7373	3807	18	0	\N
82851	1693	3760316453872	7373	3807	19	0	\N
82852	1693	3631710445525	7373	3807	20	0	\N
82853	1693	3503104437178	7373	3807	21	0	\N
82854	1693	3439657636593	7373	3807	22	0	\N
82855	1693	3311051628246	7373	3807	23	0	\N
82856	1693	3182445619899	7373	3807	24	0	\N
82857	1693	3053839611552	7373	3807	25	0	\N
82858	1693	2925233603205	7373	3807	26	0	\N
82859	1726	854484364000	7373	3807	27	0	\N
82860	1693	2796627594858	7373	3807	28	0	\N
82862	1726	854474363000	7375	3808	0	0	\N
82863	1726	854474363000	7376	3808	0	0	\N
82865	1726	854464362000	7378	3809	0	0	\N
82866	1726	854464362000	7379	3809	0	0	\N
82869	1726	854434359000	7382	3812	0	0	\N
82871	1726	854434359000	7384	3812	0	0	\N
82877	1726	854384354000	7388	3815	0	0	\N
82886	1726	854354351000	7391	3817	0	0	\N
82887	1693	2539415578164	7391	3817	1	0	\N
82888	1693	2410809569817	7391	3817	2	0	\N
82889	1693	2282203561470	7391	3817	3	0	\N
82890	1693	2153597553123	7391	3817	4	0	\N
82892	1726	854344350000	7393	3818	0	0	\N
82895	1726	854324348000	7395	3820	0	0	\N
82896	1726	854314347000	7395	3820	1	0	\N
82899	1726	854304346000	7397	3821	0	0	\N
82911	1623	24481650899898	7402	3825	0	0	\N
82912	1726	851614337000	7402	3825	1	0	\N
82913	1726	851604336000	7402	3825	2	0	\N
82918	1726	851594335000	7405	3826	0	0	\N
82926	1726	851544330000	7410	3830	0	0	\N
82927	1726	851534329000	7410	3830	1	0	\N
82928	1726	851524328000	7411	3831	0	0	\N
82930	1726	851524328000	7413	3831	0	0	\N
82931	1726	851514327000	7413	3831	1	0	\N
82932	1726	851514327000	7414	3832	0	0	\N
82933	1596	12651155000000	7414	3832	2	0	\N
82934	1726	851514327000	7415	3832	0	0	\N
82935	1596	12651155000000	7415	3832	2	0	\N
82936	1726	851514327000	7416	3832	0	0	\N
82937	1596	12651155000000	7416	3832	2	0	\N
82939	1726	851504326000	7418	3833	0	0	\N
82940	1769	1822900000	7418	3833	1	0	\N
82948	1522	11519970000000	7424	3561	0	0	\N
82949	1397	1392985432000	7424	3561	1	0	\N
82950	1693	19759411551364	7424	3561	2	0	\N
82951	1726	866744680000	7424	3561	3	0	\N
82952	1623	20881520899898	7424	3561	4	0	\N
82953	1643	3175474999700	7424	3561	5	0	\N
82954	1643	2011330092700	7424	3561	6	0	\N
82955	1643	1225855074000	7424	3561	7	0	\N
82956	1643	576213113700	7424	3561	8	0	\N
82957	1726	866734679000	7424	3561	9	0	\N
82958	1596	12030150000000	7424	3561	10	0	\N
82959	1740	15837893000000	7424	3561	11	0	\N
82960	1740	15837868000000	7424	3561	12	0	\N
82827	1693	3182445619899	7372	3807	25	0	449
82828	1693	3053839611552	7372	3807	26	0	450
82829	1693	2925233603205	7372	3807	27	0	451
82830	1726	854484364000	7372	3807	28	0	780
82831	1693	2796627594858	7372	3807	29	0	452
82864	1726	854464362000	7377	3809	0	0	782
82867	1726	854454361000	7380	3810	0	0	783
82868	1726	854444360000	7381	3811	0	0	784
82870	1726	854434359000	7383	3812	0	0	785
82872	1726	854424358000	7385	3813	0	0	786
82874	1726	854404356000	7386	3814	0	0	788
82875	1726	854394355000	7386	3814	1	0	789
82876	1726	854384354000	7387	3815	0	0	790
82878	1726	854374353000	7389	3816	0	0	791
82880	1726	854364352000	7389	3816	2	0	792
82881	1726	854354351000	7390	3817	0	0	793
82882	1693	2539415578164	7390	3817	1	0	454
82883	1693	2410809569817	7390	3817	2	0	455
82884	1693	2282203561470	7390	3817	3	0	456
82891	1726	854344350000	7392	3818	0	0	794
82893	1726	854334349000	7394	3819	0	0	795
82894	1611	11510200000000	7394	3819	1	0	1
82897	1726	854324348000	7396	3820	0	0	796
82898	1726	854314347000	7396	3820	1	0	797
82901	1726	854294345000	7399	3822	0	0	799
82902	1726	854284344000	7400	3823	0	0	800
82903	1726	854274343000	7400	3823	1	0	801
82904	1726	852974343000	7400	3823	2	0	802
82906	1726	851664342000	7400	3823	4	0	804
82907	1726	851654341000	7400	3823	5	0	805
82908	1726	851644340000	7400	3823	6	0	806
82909	1726	851634339000	7400	3823	7	0	807
82910	1726	851624338000	7401	3824	0	0	808
82915	1726	851614337000	7403	3825	1	0	809
82916	1726	851604336000	7403	3825	2	0	810
82917	1726	851594335000	7404	3826	0	0	811
82919	1726	851584334000	7406	3827	0	0	812
82920	1726	851574333000	7407	3828	0	0	813
82922	1726	851554331000	7408	3829	1	0	815
82923	1596	12750160000000	7408	3829	2	0	2
82924	1726	851544330000	7409	3830	0	0	816
82925	1726	851534329000	7409	3830	1	0	817
82938	1596	12651155000000	7417	3832	0	0	3
82941	1726	851514327000	7419	3833	0	0	819
82942	1726	851504326000	7419	3833	1	0	820
82943	1769	1822900000	7419	3833	2	0	20
82944	1726	851494325000	7421	3834	0	0	821
82946	1726	851474323000	7422	3835	0	0	823
82947	1726	851464322000	7423	3836	0	0	824
82961	1397	1392975431000	7424	3561	13	0	\N
82962	1397	1392965430000	7424	3561	14	0	\N
82963	1397	1392955429000	7424	3561	15	0	\N
82964	1726	866724678000	7424	3561	16	0	\N
82965	1726	866714677000	7424	3561	17	0	\N
82966	1726	866704676000	7424	3561	18	0	\N
82967	1726	866694675000	7424	3561	19	0	\N
82968	1726	866684674000	7424	3561	20	0	\N
82969	1726	866674673000	7424	3561	21	0	\N
82970	1726	866664672000	7424	3561	22	0	\N
82971	1726	866654671000	7424	3561	23	0	\N
82972	1726	866644670000	7424	3561	25	0	\N
82973	1726	866634669000	7424	3561	26	0	\N
82974	1726	866624668000	7424	3561	27	0	\N
82975	1726	866614667000	7424	3561	28	0	\N
82976	1726	866604666000	7424	3561	29	0	\N
82977	1726	866594665000	7424	3561	30	0	\N
82978	1726	866584664000	7424	3561	31	0	\N
82979	1726	866574663000	7424	3561	32	0	\N
82980	1726	866564662000	7424	3561	33	0	\N
82981	1726	866554661000	7424	3561	34	0	\N
82982	1397	1392945428000	7424	3561	35	0	\N
82983	1397	1392935427000	7424	3561	36	0	\N
82984	1726	866544660000	7424	3561	37	0	\N
82985	1726	866534659000	7424	3561	38	0	\N
82986	1726	866524658000	7424	3561	39	0	\N
82987	1726	866514657000	7424	3561	40	0	\N
82988	1726	866504656000	7424	3561	41	0	\N
82989	1726	866494655000	7424	3561	42	0	\N
82990	1726	866484654000	7424	3561	43	0	\N
82991	1726	866474653000	7424	3561	44	0	\N
82992	1726	865174653000	7424	3561	45	0	\N
82993	1726	865164652000	7424	3561	46	0	\N
82994	1726	865154651000	7424	3561	47	0	\N
82995	1726	865144650000	7424	3561	48	0	\N
82996	1726	865134649000	7424	3561	49	0	\N
82997	1397	1392925426000	7424	3561	50	0	\N
82998	1397	1392915425000	7424	3561	51	0	\N
82999	1397	1392905424000	7424	3561	52	0	\N
83000	1397	1392895423000	7424	3561	53	0	\N
83001	1397	1392885422000	7424	3561	54	0	\N
83002	1397	1392875421000	7424	3561	55	0	\N
83003	1397	1392865420000	7424	3561	56	0	\N
83004	1397	1392855419000	7424	3561	57	0	\N
83005	1397	1392845418000	7424	3561	58	0	\N
83006	1397	1392835417000	7424	3561	59	0	\N
83007	1397	1392825416000	7424	3561	60	0	\N
83008	1397	1392815415000	7424	3561	61	0	\N
83009	1397	1392805414000	7424	3561	62	0	\N
83010	1397	1392795413000	7424	3561	63	0	\N
83011	1397	1392785412000	7424	3561	64	0	\N
83012	1397	1392775411000	7424	3561	65	0	\N
83013	1397	1392765410000	7424	3561	66	0	\N
83014	1397	1392755409000	7424	3561	67	0	\N
83015	1726	865124648000	7424	3561	68	0	\N
83016	1726	865114647000	7424	3561	69	0	\N
83017	1726	865104646000	7424	3561	70	0	\N
83018	1726	865094645000	7424	3561	71	0	\N
83019	1726	865084644000	7424	3561	72	0	\N
83020	1726	865074643000	7424	3561	73	0	\N
83021	1726	865064642000	7424	3561	74	0	\N
83022	1726	865054641000	7424	3561	75	0	\N
83023	1726	865044640000	7424	3561	76	0	\N
83024	1726	865034639000	7424	3561	77	0	\N
83025	1726	865024638000	7424	3561	78	0	\N
83026	1726	865014637000	7424	3561	79	0	\N
83027	1726	865004636000	7424	3561	80	0	\N
83028	1726	864994635000	7424	3561	81	0	\N
83029	1726	864984634000	7424	3561	82	0	\N
83030	1726	864974633000	7424	3561	83	0	\N
83031	1726	864964632000	7424	3561	84	0	\N
83032	1726	864954631000	7424	3561	85	0	\N
83033	1726	864944630000	7424	3561	86	0	\N
83034	1726	864934629000	7424	3561	87	0	\N
83035	1726	864924628000	7424	3561	88	0	\N
83036	1726	864914627000	7424	3561	89	0	\N
83037	1726	864904626000	7424	3561	90	0	\N
83038	1726	864894625000	7424	3561	91	0	\N
83039	1726	864884624000	7424	3561	92	0	\N
83040	1611	10790190000000	7424	3561	93	0	\N
83041	1693	19759301551364	7424	3561	94	0	\N
83042	1693	19630695543017	7424	3561	95	0	\N
83043	1693	19502089534670	7424	3561	96	0	\N
83044	1693	19373483526323	7424	3561	97	0	\N
83045	1693	19244877517976	7424	3561	98	0	\N
83046	1693	19116271509629	7424	3561	99	0	\N
83047	1693	18987665501282	7424	3561	100	0	\N
83048	1693	18859059492935	7424	3561	101	0	\N
83049	1693	18730453484588	7424	3561	102	0	\N
83050	1693	18601847476241	7424	3561	103	0	\N
83051	1693	18473241467894	7424	3561	104	0	\N
83052	1693	18344635459547	7424	3561	105	0	\N
83053	1693	18216029451200	7424	3561	106	0	\N
83054	1693	18087423442853	7424	3561	107	0	\N
83055	1693	17958817434506	7424	3561	108	0	\N
83056	1693	17830211426159	7424	3561	109	0	\N
83057	1693	17701605417812	7424	3561	110	0	\N
83058	1693	17572999409465	7424	3561	111	0	\N
83059	1693	17444393401118	7424	3561	112	0	\N
83060	1693	17315787392771	7424	3561	113	0	\N
83061	1693	17187181384424	7424	3561	114	0	\N
83062	1693	17058575376077	7424	3561	115	0	\N
83063	1693	16929969367730	7424	3561	116	0	\N
83064	1693	16801363359383	7424	3561	117	0	\N
83065	1693	16672757351036	7424	3561	118	0	\N
83066	1693	16545460683866	7424	3561	119	0	\N
83067	1693	15361052186557	7424	3561	120	0	\N
83068	1693	15232446178210	7424	3561	121	0	\N
83069	1693	15103840169863	7424	3561	122	0	\N
83070	1693	15099933321141	7424	3561	123	0	\N
83071	1693	14971327312794	7424	3561	124	0	\N
83072	1693	14842721304447	7424	3561	125	0	\N
83073	1726	851454321000	7425	3837	0	0	\N
83074	1726	851444320000	7425	3837	1	0	\N
83075	1726	851434319000	7425	3837	2	0	\N
83081	1726	851424318000	7428	3838	0	0	\N
83082	1726	851414317000	7428	3838	1	0	\N
83083	1726	851404316000	7429	3839	0	0	\N
83085	1726	851404316000	7431	3839	0	0	\N
83086	1726	851394315000	7431	3839	1	0	\N
83087	1726	851394315000	7432	3840	0	0	\N
83094	1726	851334309000	7438	3845	0	0	\N
83096	1726	851334309000	7440	3845	0	0	\N
83078	1726	851434319000	7426	3837	2	0	827
83079	1726	851424318000	7427	3838	0	0	828
83080	1726	851414317000	7427	3838	1	0	829
83084	1726	851404316000	7430	3839	0	0	830
83088	1726	851394315000	7433	3840	0	0	831
83090	1726	851374313000	7435	3842	0	0	833
83091	1726	851364312000	7435	3842	1	0	834
83092	1726	851354311000	7436	3843	0	0	835
83093	1726	851344310000	7437	3844	0	0	836
83095	1726	851334309000	7439	3845	0	0	837
83100	1726	851304306000	7443	3848	0	0	\N
83101	1726	851304306000	7444	3848	0	0	\N
83110	1726	851244300000	7451	3853	0	0	\N
83111	1726	851234299000	7451	3853	1	0	\N
83117	1726	851184294000	7454	3856	0	0	\N
83119	1726	851174293000	7456	3857	0	0	\N
83121	1726	851174293000	7458	3857	0	0	\N
83123	1726	851154291000	7460	3859	0	0	\N
83124	1726	851144290000	7460	3859	1	0	\N
83125	1726	851134289000	7460	3859	2	0	\N
83126	1726	851154291000	7461	3859	0	0	\N
83127	1726	851144290000	7461	3859	1	0	\N
83128	1726	851134289000	7461	3859	2	0	\N
83136	1726	851094285000	7467	3863	0	0	\N
83137	1726	851094285000	7468	3863	0	0	\N
83138	1726	851094285000	7469	3863	0	0	\N
83142	1726	851064282000	7472	3865	0	0	\N
83143	1740	16557888000000	7473	3787	0	0	\N
83144	1522	12239960000000	7473	3787	1	0	\N
83145	1522	12239940000000	7473	3787	2	0	\N
83146	1693	22510755543017	7473	3787	3	0	\N
83147	1693	22382149534670	7473	3787	4	0	\N
83148	1693	22253543526323	7473	3787	5	0	\N
83149	1693	22124937517976	7473	3787	6	0	\N
83150	1623	23761640899898	7473	3787	7	0	\N
83151	1643	3175474999700	7473	3787	8	0	\N
83152	1643	2011330092700	7473	3787	9	0	\N
83153	1643	1225855074000	7473	3787	10	0	\N
83154	1643	576213113700	7473	3787	11	0	\N
83155	1596	12750160000000	7473	3787	12	0	\N
83156	1693	21996331509629	7473	3787	13	0	\N
83157	1693	21867725501282	7473	3787	14	0	\N
83158	1693	21739119492935	7473	3787	15	0	\N
83159	1693	21610513484588	7473	3787	16	0	\N
83160	1693	21481907476241	7473	3787	17	0	\N
83161	1693	21353301467894	7473	3787	18	0	\N
83162	1693	21224695459547	7473	3787	19	0	\N
83163	1693	21096089451200	7473	3787	21	0	\N
83166	1726	851034279000	7475	3867	0	0	\N
83167	1900	90000000	7475	3867	1	0	\N
83168	1726	851034279000	7476	3867	0	0	\N
83169	1900	90000000	7476	3867	1	0	\N
83170	1726	851034279000	7477	3867	0	0	\N
83171	1900	90000000	7477	3867	1	0	\N
83178	1726	851014277000	7482	3870	0	0	\N
83179	1726	851004276000	7482	3870	1	0	\N
83180	1900	89000000	7482	3870	2	0	\N
83181	1726	851014277000	7483	3870	0	0	\N
83182	1726	851004276000	7483	3870	1	0	\N
83183	1900	89000000	7483	3870	2	0	\N
83185	1726	850994275000	7485	3871	0	0	\N
83189	1726	850974273000	7488	3873	0	0	\N
83190	1726	850964272000	7488	3873	1	0	\N
83191	1726	850974273000	7489	3873	0	0	\N
83192	1726	850964272000	7489	3873	1	0	\N
83193	1726	850974273000	7490	3873	0	0	\N
83194	1726	850964272000	7490	3873	1	0	\N
83196	1726	850954271000	7492	3874	0	0	\N
83208	1726	850854261000	7499	3881	0	0	\N
83209	1726	850854261000	7500	3881	0	0	\N
83214	1726	850834259000	7504	3883	0	0	\N
83215	1726	850824258000	7504	3883	1	0	\N
83222	1726	850764252000	7509	3888	0	0	\N
83223	1726	850754251000	7509	3888	1	0	\N
83224	1726	850744250000	7509	3888	2	0	\N
83225	1596	12419140000000	7509	3888	3	0	\N
83226	1726	850764252000	7510	3888	0	0	\N
83227	1726	850754251000	7510	3888	1	0	\N
83228	1726	850744250000	7510	3888	2	0	\N
83229	1596	12419140000000	7510	3888	3	0	\N
83230	1522	12239960000000	7511	3818	0	0	\N
83231	1522	12239940000000	7511	3818	1	0	\N
83232	1726	854344350000	7511	3818	2	0	\N
83099	1726	851314307000	7442	3847	0	0	839
83102	1726	851304306000	7445	3848	0	0	840
83103	1726	851294305000	7446	3849	0	0	841
83104	1726	851284304000	7447	3850	0	0	842
83105	1726	851274303000	7448	3851	0	0	843
83107	1726	851254301000	7449	3852	1	0	845
83108	1726	851244300000	7450	3853	0	0	846
83109	1726	851234299000	7450	3853	1	0	847
83112	1726	851224298000	7452	3854	0	0	848
83113	1726	851214297000	7452	3854	1	0	849
83115	1726	851204296000	7453	3855	1	0	850
83116	1726	851194295000	7453	3855	2	0	851
83118	1726	851184294000	7455	3856	0	0	852
83120	1726	851174293000	7457	3857	0	0	853
83129	1726	851154291000	7462	3859	0	0	855
83130	1726	851144290000	7462	3859	1	0	856
83131	1726	851134289000	7462	3859	2	0	857
83132	1726	851124288000	7463	3860	0	0	858
83133	1726	851114287000	7464	3861	0	0	859
83135	1726	851094285000	7466	3863	0	0	861
83139	1726	851084284000	7470	3864	0	0	862
83140	1726	851074283000	7470	3864	1	0	863
83141	1726	851064282000	7471	3865	0	0	864
83164	1726	851054281000	7474	3866	0	0	865
83172	1726	851034279000	7478	3867	0	0	867
83173	1900	90000000	7478	3867	1	0	1
83174	1726	851024278000	7479	3868	0	0	868
83175	1726	851014277000	7481	3870	0	0	869
83177	1900	89000000	7481	3870	2	0	2
83184	1726	850994275000	7484	3871	0	0	871
83186	1726	850984274000	7486	3872	0	0	872
83187	1726	850974273000	7487	3873	0	0	873
83188	1726	850964272000	7487	3873	1	0	874
83197	1726	850944270000	7493	3875	0	0	876
83198	1900	79000000	7494	3876	0	0	3
83199	1726	850934269000	7494	3876	1	0	877
83200	1726	850924268000	7495	3877	0	0	878
83201	1726	850914267000	7495	3877	1	0	879
83203	1726	850904266000	7496	3878	1	0	880
83204	1726	850894265000	7497	3879	0	0	881
83205	1726	850884264000	7498	3880	0	0	882
83206	1726	850874263000	7498	3880	1	0	883
83210	1726	850854261000	7501	3881	0	0	885
83211	1726	850844260000	7502	3882	0	0	886
83212	1726	850834259000	7503	3883	0	0	887
83213	1726	850824258000	7503	3883	1	0	888
83216	1726	850814257000	7505	3884	0	0	889
83218	1596	12641145000000	7506	3885	0	0	4
83219	1726	850794255000	7506	3885	1	0	891
83220	1726	850784254000	7507	3886	0	0	892
83221	1726	850774253000	7508	3887	0	0	893
83233	1623	23761640899898	7511	3818	3	0	\N
83234	1726	854334349000	7511	3818	4	0	\N
83235	1726	854324348000	7511	3818	5	0	\N
83236	1726	854314347000	7511	3818	6	0	\N
83237	1596	12750160000000	7511	3818	7	0	\N
83238	1900	90000000	7511	3818	8	0	\N
83239	1726	854304346000	7511	3818	9	0	\N
83240	1726	854294345000	7511	3818	10	0	\N
83241	1726	854284344000	7511	3818	11	0	\N
83242	1726	854274343000	7511	3818	12	0	\N
83243	1726	852974343000	7511	3818	13	0	\N
83244	1726	851674343000	7511	3818	14	0	\N
83245	1726	851664342000	7511	3818	15	0	\N
83246	1726	851654341000	7511	3818	16	0	\N
83247	1726	851644340000	7511	3818	17	0	\N
83248	1726	851634339000	7511	3818	18	0	\N
83249	1726	851624338000	7511	3818	19	0	\N
83250	1726	851614337000	7511	3818	20	0	\N
83251	1726	851604336000	7511	3818	21	0	\N
83252	1726	851594335000	7511	3818	22	0	\N
83253	1726	851584334000	7511	3818	23	0	\N
83254	1726	851574333000	7511	3818	24	0	\N
83255	1726	851564332000	7511	3818	25	0	\N
83256	1726	851554331000	7511	3818	26	0	\N
83257	1726	851544330000	7511	3818	27	0	\N
83258	1726	851534329000	7511	3818	28	0	\N
83259	1726	851524328000	7511	3818	29	0	\N
83260	1726	851514327000	7511	3818	30	0	\N
83261	1726	851504326000	7511	3818	31	0	\N
83262	1726	851494325000	7511	3818	32	0	\N
83263	1726	851484324000	7511	3818	33	0	\N
83264	1726	851474323000	7511	3818	34	0	\N
83265	1726	851464322000	7511	3818	35	0	\N
83266	1726	851454321000	7511	3818	36	0	\N
83267	1726	851444320000	7511	3818	37	0	\N
83268	1726	851434319000	7511	3818	38	0	\N
83269	1726	851424318000	7511	3818	39	0	\N
83270	1726	851414317000	7511	3818	40	0	\N
83271	1726	851404316000	7511	3818	41	0	\N
83272	1726	851394315000	7511	3818	42	0	\N
83273	1726	851384314000	7511	3818	43	0	\N
83274	1726	851374313000	7511	3818	44	0	\N
83275	1726	851364312000	7511	3818	45	0	\N
83276	1726	851354311000	7511	3818	46	0	\N
83277	1726	851344310000	7511	3818	47	0	\N
83278	1726	851334309000	7511	3818	48	0	\N
83279	1726	851324308000	7511	3818	49	0	\N
83280	1726	851314307000	7511	3818	50	0	\N
83281	1726	851304306000	7511	3818	51	0	\N
83282	1726	851294305000	7511	3818	52	0	\N
83283	1726	851284304000	7511	3818	53	0	\N
83284	1726	851274303000	7511	3818	54	0	\N
83285	1726	851264302000	7511	3818	55	0	\N
83286	1726	851254301000	7511	3818	56	0	\N
83287	1726	851244300000	7511	3818	58	0	\N
83288	1726	851234299000	7511	3818	59	0	\N
83289	1726	851224298000	7511	3818	60	0	\N
83290	1726	851214297000	7511	3818	61	0	\N
83291	1726	851204296000	7511	3818	62	0	\N
83292	1726	851194295000	7511	3818	63	0	\N
83293	1726	851184294000	7511	3818	64	0	\N
83294	1726	851174293000	7511	3818	65	0	\N
83295	1726	851164292000	7511	3818	66	0	\N
83296	1726	851154291000	7511	3818	67	0	\N
83297	1726	851144290000	7511	3818	68	0	\N
83298	1726	851134289000	7511	3818	69	0	\N
83299	1726	851124288000	7511	3818	70	0	\N
83300	1726	851114287000	7511	3818	71	0	\N
83301	1726	851104286000	7511	3818	72	0	\N
83302	1726	851094285000	7511	3818	73	0	\N
83303	1726	851084284000	7511	3818	74	0	\N
83304	1726	851074283000	7511	3818	75	0	\N
83305	1726	851064282000	7511	3818	76	0	\N
83306	1726	851054281000	7511	3818	77	0	\N
83307	1726	851044280000	7511	3818	78	0	\N
83308	1726	851034279000	7511	3818	79	0	\N
83309	1726	851024278000	7511	3818	80	0	\N
83310	1726	851014277000	7511	3818	81	0	\N
83311	1726	851004276000	7511	3818	82	0	\N
83312	1726	850994275000	7511	3818	83	0	\N
83313	1726	850984274000	7511	3818	84	0	\N
83314	1726	850974273000	7511	3818	85	0	\N
83315	1726	850964272000	7511	3818	86	0	\N
83316	1726	850954271000	7511	3818	87	0	\N
83317	1726	850944270000	7511	3818	88	0	\N
83318	1726	850934269000	7511	3818	89	0	\N
83319	1726	850924268000	7511	3818	90	0	\N
83320	1726	850914267000	7511	3818	91	0	\N
83321	1726	850904266000	7511	3818	92	0	\N
83322	1726	850894265000	7511	3818	93	0	\N
83323	1726	850884264000	7511	3818	94	0	\N
83324	1726	850874263000	7511	3818	95	0	\N
83325	1611	11510200000000	7511	3818	96	0	\N
83326	1726	850864262000	7511	3818	97	0	\N
83327	1726	850854261000	7511	3818	98	0	\N
83328	1726	850844260000	7511	3818	99	0	\N
83329	1726	850834259000	7511	3818	100	0	\N
83330	1726	850824258000	7511	3818	101	0	\N
83331	1726	850814257000	7511	3818	102	0	\N
83332	1726	850804256000	7511	3818	103	0	\N
83333	1726	850794255000	7511	3818	104	0	\N
83334	1726	850784254000	7511	3818	105	0	\N
83335	1726	850774253000	7511	3818	106	0	\N
83336	1726	850764252000	7511	3818	107	0	\N
83337	1726	850754251000	7511	3818	108	0	\N
83338	1726	850744250000	7511	3818	109	0	\N
83339	1596	12651155000000	7511	3818	110	0	\N
83340	1596	12641145000000	7511	3818	111	0	\N
83341	1596	12419140000000	7511	3818	112	0	\N
83342	1900	89000000	7511	3818	113	0	\N
83343	1900	79000000	7511	3818	114	0	\N
83344	1900	69000000	7511	3818	115	0	\N
83345	1769	1822900000	7511	3818	116	0	\N
83350	1726	850764252000	7513	3888	0	0	\N
83351	1726	850754251000	7513	3888	1	0	\N
83352	1726	850744250000	7513	3888	2	0	\N
83353	1596	12419140000000	7513	3888	3	0	\N
83358	1726	850714247000	7518	3892	0	0	\N
83359	1726	850704246000	7519	3893	0	0	\N
83360	1726	850694245000	7519	3893	1	0	\N
83361	1726	850684244000	7519	3893	2	0	\N
83365	1726	850704246000	7521	3893	0	0	\N
83366	1726	850694245000	7521	3893	1	0	\N
83367	1726	850684244000	7521	3893	2	0	\N
83348	1726	850744250000	7512	3888	2	0	896
83349	1596	12419140000000	7512	3888	3	0	5
83354	1876	350660000000	7514	3889	0	0	4
83355	1726	850734249000	7515	3890	0	0	897
83356	1726	850724248000	7516	3891	0	0	898
83362	1726	850704246000	7520	3893	0	0	900
83363	1726	850694245000	7520	3893	1	0	901
83364	1726	850684244000	7520	3893	2	0	902
83368	1726	850674243000	7522	3894	0	0	903
83371	1726	850654241000	7525	3896	0	0	\N
83374	1522	11519950000000	7528	3678	0	0	\N
83375	1522	11519930000000	7528	3678	1	0	\N
83376	1693	21070735543017	7528	3678	2	0	\N
83377	1726	855354451000	7528	3678	3	0	\N
83378	1693	20942129534670	7528	3678	4	0	\N
83379	1693	20813523526323	7528	3678	5	0	\N
83380	1693	20684917517976	7528	3678	6	0	\N
83381	1876	350660000000	7528	3678	7	0	\N
83382	1623	23041590899898	7528	3678	8	0	\N
83383	1643	3175474999700	7528	3678	9	0	\N
83384	1643	2011330092700	7528	3678	10	0	\N
83385	1643	1225855074000	7528	3678	11	0	\N
83386	1643	576213113700	7528	3678	12	0	\N
83387	1596	12030150000000	7528	3678	13	0	\N
83388	1740	16557913000000	7528	3678	14	0	\N
83389	1740	16557888000000	7528	3678	15	0	\N
83390	1726	855344450000	7528	3678	16	0	\N
83391	1726	855334449000	7528	3678	17	0	\N
83392	1726	855324448000	7528	3678	18	0	\N
83393	1726	855314447000	7528	3678	19	0	\N
83394	1726	855304446000	7528	3678	20	0	\N
83395	1726	855294445000	7528	3678	21	0	\N
83396	1726	855284444000	7528	3678	22	0	\N
83397	1726	855274443000	7528	3678	23	0	\N
83398	1726	855264442000	7528	3678	24	0	\N
83399	1726	855254441000	7528	3678	25	0	\N
83400	1726	855244440000	7528	3678	26	0	\N
83401	1726	855234439000	7528	3678	27	0	\N
83402	1726	855224438000	7528	3678	28	0	\N
83403	1726	855214437000	7528	3678	29	0	\N
83404	1726	855204436000	7528	3678	30	0	\N
83405	1726	855194435000	7528	3678	31	0	\N
83406	1726	855184434000	7528	3678	32	0	\N
83407	1726	855174433000	7528	3678	33	0	\N
83408	1726	855164432000	7528	3678	34	0	\N
83409	1726	855154431000	7528	3678	35	0	\N
83410	1726	855144430000	7528	3678	36	0	\N
83411	1726	855134429000	7528	3678	37	0	\N
83412	1726	855124428000	7528	3678	38	0	\N
83413	1726	855114427000	7528	3678	39	0	\N
83414	1726	855104426000	7528	3678	40	0	\N
83415	1726	855094425000	7528	3678	41	0	\N
83416	1726	855084424000	7528	3678	42	0	\N
83417	1726	855074423000	7528	3678	44	0	\N
83418	1726	855064422000	7528	3678	45	0	\N
83419	1726	855054421000	7528	3678	46	0	\N
83420	1726	855044420000	7528	3678	47	0	\N
83421	1726	855034419000	7528	3678	48	0	\N
83422	1726	855024418000	7528	3678	49	0	\N
83423	1726	855014417000	7528	3678	50	0	\N
83424	1726	855004416000	7528	3678	51	0	\N
83425	1726	854994415000	7528	3678	52	0	\N
83426	1726	854984414000	7528	3678	53	0	\N
83427	1726	854974413000	7528	3678	54	0	\N
83428	1726	854964412000	7528	3678	55	0	\N
83429	1726	854954411000	7528	3678	56	0	\N
83430	1726	854944410000	7528	3678	57	0	\N
83431	1726	854934409000	7528	3678	58	0	\N
83432	1726	854924408000	7528	3678	59	0	\N
83433	1726	854914407000	7528	3678	60	0	\N
83434	1726	854904406000	7528	3678	61	0	\N
83435	1726	854894405000	7528	3678	62	0	\N
83436	1726	854884404000	7528	3678	63	0	\N
83437	1726	854874403000	7528	3678	64	0	\N
83438	1726	854864402000	7528	3678	65	0	\N
83439	1726	854854401000	7528	3678	66	0	\N
83440	1726	854844400000	7528	3678	67	0	\N
83441	1726	854834399000	7528	3678	68	0	\N
83442	1726	854824398000	7528	3678	69	0	\N
83443	1726	854814397000	7528	3678	70	0	\N
83444	1726	854804396000	7528	3678	71	0	\N
83445	1726	854794395000	7528	3678	72	0	\N
83446	1726	854784394000	7528	3678	73	0	\N
83447	1726	854774393000	7528	3678	74	0	\N
83448	1726	854764392000	7528	3678	75	0	\N
83449	1726	854754391000	7528	3678	76	0	\N
83450	1726	854744390000	7528	3678	77	0	\N
83451	1693	20556311509629	7528	3678	78	0	\N
83452	1693	20427705501282	7528	3678	79	0	\N
83453	1693	20299099492935	7528	3678	80	0	\N
83454	1693	20170493484588	7528	3678	81	0	\N
83455	1693	20041887476241	7528	3678	82	0	\N
83456	1693	19913281467894	7528	3678	83	0	\N
83457	1693	19784675459547	7528	3678	84	0	\N
83458	1693	19656069451200	7528	3678	85	0	\N
83459	1693	19527463442853	7528	3678	86	0	\N
83460	1693	19398857434506	7528	3678	87	0	\N
83461	1693	19270251426159	7528	3678	88	0	\N
83462	1693	19141645417812	7528	3678	89	0	\N
83463	1693	19013039409465	7528	3678	90	0	\N
83464	1693	18884433401118	7528	3678	91	0	\N
83465	1693	18755827392771	7528	3678	92	0	\N
83466	1693	18627221384424	7528	3678	93	0	\N
83467	1693	18498615376077	7528	3678	94	0	\N
83468	1693	18370009367730	7528	3678	95	0	\N
83469	1693	18241403359383	7528	3678	96	0	\N
83470	1693	18112797351036	7528	3678	97	0	\N
83471	1693	17985500683866	7528	3678	98	0	\N
83472	1693	16801092186557	7528	3678	99	0	\N
83473	1693	16672486178210	7528	3678	100	0	\N
83474	1693	16543880169863	7528	3678	101	0	\N
83475	1693	16539973321141	7528	3678	102	0	\N
83476	1693	16411367312794	7528	3678	103	0	\N
83477	1693	16282761304447	7528	3678	104	0	\N
83478	1611	10790190000000	7528	3678	105	0	\N
83479	1726	854734389000	7528	3678	106	0	\N
83480	1726	854724388000	7528	3678	107	0	\N
83481	1726	854714387000	7528	3678	108	0	\N
83482	1726	854704386000	7528	3678	109	0	\N
83483	1726	854694385000	7528	3678	110	0	\N
83484	1726	854684384000	7528	3678	111	0	\N
83485	1726	854674383000	7528	3678	112	0	\N
83486	1726	854664382000	7528	3678	113	0	\N
83487	1726	854654381000	7528	3678	114	0	\N
83488	1726	854644380000	7528	3678	115	0	\N
83489	1726	854634379000	7528	3678	116	0	\N
83490	1726	854624378000	7528	3678	117	0	\N
83491	1726	854614377000	7528	3678	118	0	\N
83492	1726	854604376000	7528	3678	119	0	\N
83493	1726	854594375000	7528	3678	120	0	\N
83494	1726	854584374000	7528	3678	121	0	\N
83495	1726	854574373000	7528	3678	122	0	\N
83496	1726	854564372000	7528	3678	123	0	\N
83497	1726	854554371000	7528	3678	124	0	\N
83498	1726	854544370000	7528	3678	125	0	\N
83499	1740	16557888000000	7529	3696	0	0	\N
83500	1522	11519950000000	7529	3696	1	0	\N
83501	1522	11519930000000	7529	3696	2	0	\N
83502	1693	21790745543017	7529	3696	3	0	\N
83503	1693	21662139534670	7529	3696	4	0	\N
83504	1693	21533533526323	7529	3696	5	0	\N
83372	1726	850644240000	7527	3897	0	0	906
83373	1726	850634239000	7527	3897	1	0	907
83505	1693	21404927517976	7529	3696	6	0	\N
83506	1876	350660000000	7529	3696	7	0	\N
83507	1623	23041590899898	7529	3696	8	0	\N
83508	1596	12750160000000	7529	3696	9	0	\N
83509	1726	854924408000	7529	3696	10	0	\N
83510	1726	854914407000	7529	3696	11	0	\N
83511	1726	854904406000	7529	3696	12	0	\N
83512	1726	854894405000	7529	3696	13	0	\N
83513	1726	854884404000	7529	3696	14	0	\N
83514	1726	854874403000	7529	3696	15	0	\N
83515	1726	854864402000	7529	3696	16	0	\N
83516	1726	854854401000	7529	3696	17	0	\N
83517	1726	854844400000	7529	3696	18	0	\N
83518	1726	854834399000	7529	3696	19	0	\N
83519	1726	854824398000	7529	3696	20	0	\N
83520	1726	854814397000	7529	3696	21	0	\N
83521	1726	854804396000	7529	3696	22	0	\N
83522	1726	854794395000	7529	3696	23	0	\N
83523	1726	854784394000	7529	3696	24	0	\N
83524	1726	854774393000	7529	3696	25	0	\N
83525	1726	854764392000	7529	3696	26	0	\N
83526	1726	854754391000	7529	3696	27	0	\N
83527	1726	854744390000	7529	3696	28	0	\N
83528	1693	21276321509629	7529	3696	29	0	\N
83529	1693	21147715501282	7529	3696	30	0	\N
83530	1693	21019109492935	7529	3696	31	0	\N
83531	1693	20890503484588	7529	3696	32	0	\N
83532	1693	20761897476241	7529	3696	33	0	\N
83533	1693	20633291467894	7529	3696	34	0	\N
83534	1693	20504685459547	7529	3696	35	0	\N
83535	1693	20376079451200	7529	3696	36	0	\N
83536	1693	20247473442853	7529	3696	37	0	\N
83537	1693	20118867434506	7529	3696	38	0	\N
83538	1693	19990261426159	7529	3696	39	0	\N
83539	1693	19861655417812	7529	3696	40	0	\N
83540	1693	19733049409465	7529	3696	41	0	\N
83541	1693	19604443401118	7529	3696	42	0	\N
83542	1693	19475837392771	7529	3696	43	0	\N
83543	1693	19347231384424	7529	3696	44	0	\N
83544	1693	19218625376077	7529	3696	45	0	\N
83545	1693	19090019367730	7529	3696	46	0	\N
83546	1693	18961413359383	7529	3696	47	0	\N
83547	1693	18832807351036	7529	3696	48	0	\N
83548	1693	18705510683866	7529	3696	49	0	\N
83549	1693	17521102186557	7529	3696	50	0	\N
83550	1693	17392496178210	7529	3696	51	0	\N
83551	1693	17263890169863	7529	3696	52	0	\N
83552	1693	17259983321141	7529	3696	53	0	\N
83553	1693	17131377312794	7529	3696	54	0	\N
83554	1693	17002771304447	7529	3696	55	0	\N
83555	1611	10790190000000	7529	3696	56	0	\N
83556	1726	854734389000	7529	3696	57	0	\N
83557	1726	854724388000	7529	3696	58	0	\N
83558	1726	854714387000	7529	3696	59	0	\N
83559	1726	854704386000	7529	3696	60	0	\N
83560	1726	854694385000	7529	3696	61	0	\N
83561	1726	854684384000	7529	3696	62	0	\N
83562	1726	854674383000	7529	3696	63	0	\N
83563	1726	854664382000	7529	3696	64	0	\N
83564	1726	854654381000	7529	3696	65	0	\N
83565	1726	854644380000	7529	3696	66	0	\N
83566	1726	854634379000	7529	3696	67	0	\N
83567	1726	854624378000	7529	3696	68	0	\N
83568	1726	854614377000	7529	3696	69	0	\N
83569	1726	854604376000	7529	3696	70	0	\N
83570	1726	854594375000	7529	3696	71	0	\N
83571	1726	854584374000	7529	3696	72	0	\N
83572	1726	854574373000	7529	3696	73	0	\N
83573	1726	854564372000	7529	3696	74	0	\N
83574	1726	854554371000	7529	3696	75	0	\N
83575	1726	854544370000	7529	3696	76	0	\N
83576	1726	854534369000	7529	3696	77	0	\N
83577	1726	854524368000	7529	3696	78	0	\N
83578	1726	854514367000	7529	3696	79	0	\N
83579	1726	854504366000	7529	3696	80	0	\N
83580	1726	854494365000	7529	3696	81	0	\N
83581	1726	854484364000	7529	3696	82	0	\N
83582	1726	854474363000	7529	3696	83	0	\N
83583	1726	854464362000	7529	3696	84	0	\N
83584	1726	854454361000	7529	3696	86	0	\N
83585	1726	854444360000	7529	3696	87	0	\N
83586	1726	854434359000	7529	3696	88	0	\N
83587	1726	854424358000	7529	3696	89	0	\N
83588	1726	854414357000	7529	3696	90	0	\N
83589	1726	854404356000	7529	3696	91	0	\N
83590	1726	854394355000	7529	3696	92	0	\N
83591	1726	854384354000	7529	3696	93	0	\N
83592	1726	854374353000	7529	3696	94	0	\N
83593	1693	16874165296100	7529	3696	95	0	\N
83594	1693	16745559287753	7529	3696	96	0	\N
83595	1693	16616953279406	7529	3696	97	0	\N
83596	1693	16488347271059	7529	3696	98	0	\N
83597	1693	16359741262712	7529	3696	99	0	\N
83598	1693	16355834413990	7529	3696	100	0	\N
83599	1693	16227228405643	7529	3696	101	0	\N
83600	1693	16098622397296	7529	3696	102	0	\N
83601	1693	15970016388949	7529	3696	103	0	\N
83602	1693	15841410380602	7529	3696	104	0	\N
83603	1693	12540968657032	7529	3696	105	0	\N
83604	1693	12145324918966	7529	3696	106	0	\N
83605	1693	11749681180900	7529	3696	107	0	\N
83606	1693	11621075172553	7529	3696	108	0	\N
83607	1693	11492469164206	7529	3696	109	0	\N
83608	1693	11479410566230	7529	3696	110	0	\N
83609	1693	11350804557883	7529	3696	111	0	\N
83610	1693	11222198549536	7529	3696	112	0	\N
83611	1693	11093592541189	7529	3696	113	0	\N
83612	1693	10964986532842	7529	3696	114	0	\N
83613	1693	10961079684120	7529	3696	115	0	\N
83614	1693	10947430713546	7529	3696	116	0	\N
83615	1693	10818824705199	7529	3696	117	0	\N
83616	1693	10690218696852	7529	3696	118	0	\N
83617	1693	10561612688505	7529	3696	119	0	\N
83618	1693	10433006680158	7529	3696	120	0	\N
83619	1693	9453420124497	7529	3696	121	0	\N
83620	1693	9324814116150	7529	3696	122	0	\N
83621	1693	9196208107803	7529	3696	123	0	\N
83622	1693	9067602099456	7529	3696	124	0	\N
83623	1693	8938996091109	7529	3696	125	0	\N
83624	1726	850624238000	7530	3898	0	0	\N
83625	1900	68000000	7530	3898	1	0	\N
83629	1726	850624238000	7533	3898	0	0	\N
83630	1726	850614237000	7533	3898	1	0	\N
83631	1900	68000000	7533	3898	2	0	\N
83632	1726	850624238000	7534	3898	0	0	\N
83633	1726	850614237000	7534	3898	1	0	\N
83634	1726	850604236000	7534	3898	2	0	\N
83635	1900	68000000	7534	3898	3	0	\N
83639	1726	850584234000	7537	3902	0	0	\N
83628	1726	850614237000	7532	3899	0	0	909
83636	1726	850604236000	7535	3900	0	0	910
83637	1900	67000000	7535	3900	1	0	6
83638	1726	850594235000	7536	3901	0	0	911
83640	1726	850584234000	7538	3902	0	0	912
83641	1726	850584234000	7539	3902	0	0	\N
83643	1726	850564232000	7541	3904	0	0	\N
83647	1726	850554231000	7544	3905	0	0	\N
83648	1726	850544230000	7544	3905	1	0	\N
83649	1726	850554231000	7545	3905	0	0	\N
83650	1726	850544230000	7545	3905	1	0	\N
83657	1726	850484224000	7551	3910	0	0	\N
83660	1726	850454221000	7553	3912	0	0	\N
83661	1726	850454221000	7554	3912	0	0	\N
83663	1726	850444220000	7556	3913	0	0	\N
83666	1726	850434219000	7559	3914	0	0	\N
83667	1726	850424218000	7560	3915	0	0	\N
83669	1726	850414217000	7562	3916	0	0	\N
83670	1726	850414217000	7563	3916	0	0	\N
83673	1726	850404216000	7566	3917	0	0	\N
83674	1726	850404216000	7567	3917	0	0	\N
83676	1726	850394215000	7569	3918	0	0	\N
83677	1726	850384214000	7570	3919	0	0	\N
83678	1726	850384214000	7571	3919	0	0	\N
83679	1876	350660000000	7572	3886	0	0	\N
83680	1900	68000000	7572	3886	1	0	\N
83681	1900	67000000	7572	3886	2	0	\N
83682	1726	850384214000	7573	3919	0	0	\N
83684	1726	850374213000	7575	3920	0	0	\N
83685	1726	850374213000	7576	3920	0	0	\N
83687	1726	850364212000	7578	3921	0	0	\N
83688	1596	12641145000000	7579	3881	0	0	\N
83689	1876	350660000000	7579	3881	1	0	\N
83690	1726	850854261000	7579	3881	2	0	\N
83691	1726	850844260000	7579	3881	3	0	\N
83692	1726	850834259000	7579	3881	4	0	\N
83693	1726	850824258000	7579	3881	5	0	\N
83694	1726	850814257000	7579	3881	6	0	\N
83695	1726	850804256000	7579	3881	7	0	\N
83696	1726	850794255000	7579	3881	8	0	\N
83697	1726	850784254000	7579	3881	9	0	\N
83698	1726	850774253000	7579	3881	10	0	\N
83699	1726	850764252000	7579	3881	11	0	\N
83700	1726	850754251000	7579	3881	12	0	\N
83701	1726	850744250000	7579	3881	13	0	\N
83702	1726	850734249000	7579	3881	14	0	\N
83703	1726	850724248000	7579	3881	15	0	\N
83704	1726	850714247000	7579	3881	16	0	\N
83705	1726	850704246000	7579	3881	17	0	\N
83706	1726	850694245000	7579	3881	18	0	\N
83707	1726	850684244000	7579	3881	19	0	\N
83708	1726	850674243000	7579	3881	20	0	\N
83709	1726	850664242000	7579	3881	21	0	\N
83710	1726	850654241000	7579	3881	22	0	\N
83711	1726	850644240000	7579	3881	23	0	\N
83712	1726	850634239000	7579	3881	24	0	\N
83713	1726	850624238000	7579	3881	25	0	\N
83714	1726	850614237000	7579	3881	26	0	\N
83715	1726	850604236000	7579	3881	27	0	\N
83716	1726	850594235000	7579	3881	28	0	\N
83717	1726	850584234000	7579	3881	29	0	\N
83718	1726	850574233000	7579	3881	30	0	\N
83719	1726	850564232000	7579	3881	31	0	\N
83720	1726	850554231000	7579	3881	32	0	\N
83721	1726	850544230000	7579	3881	33	0	\N
83722	1726	850534229000	7579	3881	34	0	\N
83723	1726	850524228000	7579	3881	35	0	\N
83724	1726	850514227000	7579	3881	36	0	\N
83725	1726	850504226000	7579	3881	37	0	\N
83726	1726	850494225000	7579	3881	38	0	\N
83727	1726	850484224000	7579	3881	39	0	\N
83728	1726	850474223000	7579	3881	40	0	\N
83729	1726	850464222000	7579	3881	41	0	\N
83730	1726	850454221000	7579	3881	42	0	\N
83731	1726	850444220000	7579	3881	43	0	\N
83732	1726	850434219000	7579	3881	44	0	\N
83733	1726	850424218000	7579	3881	45	0	\N
83734	1726	850414217000	7579	3881	46	0	\N
83735	1726	850404216000	7579	3881	47	0	\N
83736	1726	850394215000	7579	3881	48	0	\N
83737	1726	850384214000	7579	3881	49	0	\N
83738	1726	850374213000	7579	3881	50	0	\N
83739	1596	12419140000000	7579	3881	51	0	\N
83740	1900	68000000	7579	3881	52	0	\N
83741	1900	67000000	7579	3881	53	0	\N
83742	1726	850364212000	7580	3921	0	0	\N
83743	1726	850364212000	7581	3921	0	0	\N
83751	1726	850334209000	7586	3924	0	0	\N
83752	1726	850324208000	7586	3924	1	0	\N
83753	1726	850314207000	7586	3924	2	0	\N
83754	1726	850304206000	7586	3924	3	0	\N
83755	1726	850294205000	7587	3925	0	0	\N
83756	1726	850294205000	7588	3925	0	0	\N
83758	1726	850294205000	7590	3925	0	0	\N
83759	1726	850284204000	7590	3925	1	0	\N
83760	1726	850284204000	7591	3926	0	0	\N
83761	1480	718990000000	7591	3926	1	0	\N
83770	1726	850284204000	7594	3927	0	0	\N
83771	1726	850274203000	7594	3927	1	0	\N
83772	1726	850264202000	7594	3927	2	0	\N
83773	1726	850254201000	7594	3927	3	0	\N
83774	1726	850244200000	7594	3927	4	0	\N
83775	1726	848944200000	7594	3927	5	0	\N
83776	1726	847644200000	7594	3927	6	0	\N
83645	1726	850554231000	7543	3905	0	0	915
83646	1726	850544230000	7543	3905	1	0	916
83651	1726	850534229000	7546	3906	0	0	917
83652	1726	850524228000	7547	3907	0	0	918
83653	1726	850514227000	7547	3907	1	0	919
83655	1726	850494225000	7549	3909	0	0	921
83656	1726	850484224000	7550	3910	0	0	922
83658	1726	850474223000	7552	3911	0	0	923
83659	1726	850464222000	7552	3911	1	0	924
83662	1726	850454221000	7555	3912	0	0	925
83665	1726	850434219000	7558	3914	0	0	927
83668	1726	850424218000	7561	3915	0	0	928
83671	1726	850414217000	7564	3916	0	0	929
83672	1726	850404216000	7565	3917	0	0	930
83683	1726	850384214000	7574	3919	0	0	932
83686	1726	850374213000	7577	3920	0	0	933
83744	1726	850364212000	7582	3921	0	0	934
83745	1726	850354211000	7583	3922	0	0	935
83746	1726	850344210000	7584	3923	0	0	936
83748	1726	850324208000	7585	3924	1	0	938
83749	1726	850314207000	7585	3924	2	0	939
83750	1726	850304206000	7585	3924	3	0	940
83757	1726	850294205000	7589	3925	0	0	941
83762	1480	718990000000	7592	3926	0	0	1
83764	1726	850274203000	7593	3927	1	0	943
83765	1726	850264202000	7593	3927	2	0	944
83766	1726	850254201000	7593	3927	3	0	945
83767	1726	850244200000	7593	3927	4	0	946
83769	1726	847644200000	7593	3927	6	0	948
83778	1726	847624198000	7596	3929	0	0	\N
83780	1726	850734249000	7598	3819	0	0	\N
83781	1876	350660000000	7598	3819	1	0	\N
83782	1726	850724248000	7598	3819	2	0	\N
83783	1726	850714247000	7598	3819	3	0	\N
83784	1726	850704246000	7598	3819	4	0	\N
83785	1726	850694245000	7598	3819	5	0	\N
83786	1726	850684244000	7598	3819	6	0	\N
83787	1726	850674243000	7598	3819	7	0	\N
83788	1726	850664242000	7598	3819	8	0	\N
83789	1726	850654241000	7598	3819	9	0	\N
83790	1726	850644240000	7598	3819	10	0	\N
83791	1726	850634239000	7598	3819	11	0	\N
83792	1726	850624238000	7598	3819	12	0	\N
83793	1726	850614237000	7598	3819	13	0	\N
83794	1726	850604236000	7598	3819	14	0	\N
83795	1726	850594235000	7598	3819	15	0	\N
83796	1726	850584234000	7598	3819	16	0	\N
83797	1726	850574233000	7598	3819	17	0	\N
83798	1726	850564232000	7598	3819	18	0	\N
83799	1726	850554231000	7598	3819	19	0	\N
83800	1726	850544230000	7598	3819	20	0	\N
83801	1726	850534229000	7598	3819	21	0	\N
83802	1726	850524228000	7598	3819	22	0	\N
83803	1726	850514227000	7598	3819	23	0	\N
83804	1726	850504226000	7598	3819	24	0	\N
83805	1726	850494225000	7598	3819	25	0	\N
83806	1726	850484224000	7598	3819	26	0	\N
83807	1726	850474223000	7598	3819	27	0	\N
83808	1726	850464222000	7598	3819	28	0	\N
83809	1726	850454221000	7598	3819	29	0	\N
83810	1726	850444220000	7598	3819	30	0	\N
83811	1726	850434219000	7598	3819	31	0	\N
83812	1726	850424218000	7598	3819	32	0	\N
83813	1726	850414217000	7598	3819	33	0	\N
83814	1726	850404216000	7598	3819	34	0	\N
83815	1726	850394215000	7598	3819	35	0	\N
83816	1726	850384214000	7598	3819	36	0	\N
83817	1726	850374213000	7598	3819	37	0	\N
83818	1726	850364212000	7598	3819	38	0	\N
83819	1726	850354211000	7598	3819	39	0	\N
83820	1726	850344210000	7598	3819	40	0	\N
83821	1726	850334209000	7598	3819	41	0	\N
83822	1726	850324208000	7598	3819	42	0	\N
83823	1726	850314207000	7598	3819	43	0	\N
83824	1726	850304206000	7598	3819	44	0	\N
83825	1726	850294205000	7598	3819	45	0	\N
83826	1726	850284204000	7598	3819	46	0	\N
83827	1726	850274203000	7598	3819	47	0	\N
83828	1726	850264202000	7598	3819	48	0	\N
83829	1726	850254201000	7598	3819	49	0	\N
83830	1726	850244200000	7598	3819	50	0	\N
83831	1726	848944200000	7598	3819	51	0	\N
83832	1726	847644200000	7598	3819	52	0	\N
83833	1726	847634199000	7598	3819	53	0	\N
83834	1726	847624198000	7598	3819	54	0	\N
83835	1900	68000000	7598	3819	55	0	\N
83836	1900	67000000	7598	3819	56	0	\N
83849	1726	846214187000	7606	3937	0	0	\N
83852	1726	846204186000	7611	3938	0	0	\N
83853	1480	717980000000	7611	3938	1	0	\N
83854	1726	846194185000	7611	3938	2	0	\N
83855	1726	846204186000	7612	3939	0	0	\N
83856	1726	846194185000	7612	3939	1	0	\N
83857	1726	846184184000	7612	3939	2	0	\N
83861	1726	846204186000	7614	3939	0	0	\N
83862	1726	846194185000	7614	3939	1	0	\N
83863	1726	846184184000	7614	3939	2	0	\N
83864	1726	846174183000	7615	3940	0	0	\N
83865	1726	846164182000	7615	3940	1	0	\N
83869	1726	846154181000	7619	3941	0	0	\N
83870	1726	846144180000	7621	3943	0	0	\N
83871	1726	846134179000	7621	3943	1	0	\N
83872	1699	1653829000078	7621	3943	2	0	\N
83880	1596	12641145000000	7624	3874	0	0	\N
83881	1876	350660000000	7624	3874	1	0	\N
83882	1480	718990000000	7624	3874	2	0	\N
83883	1480	717980000000	7624	3874	3	0	\N
83884	1596	12419140000000	7624	3874	4	0	\N
83885	1699	1653829000078	7624	3874	5	0	\N
83886	1726	846084174000	7625	3945	0	0	\N
83887	1726	846074173000	7625	3945	1	0	\N
83890	1726	846084174000	7627	3945	0	0	\N
83891	1726	846074173000	7627	3945	1	0	\N
83905	1726	845954161000	7636	3952	0	0	\N
83907	1726	845944160000	7638	3953	0	0	\N
83908	1726	845944160000	7639	3953	0	0	\N
83837	1726	847614197000	7599	3930	0	0	951
83838	1726	847604196000	7600	3931	0	0	952
83839	1726	847594195000	7600	3931	1	0	953
83840	321	66009960000000	7601	3932	0	0	1
83841	1726	847584194000	7601	3932	1	0	954
83843	1726	846274193000	7601	3932	3	0	956
83844	1726	846264192000	7601	3932	4	0	957
83845	1726	846254191000	7602	3933	0	0	958
83846	1726	846244190000	7603	3934	0	0	959
83847	1726	846234189000	7604	3935	0	0	960
83850	1726	846214187000	7608	3937	0	0	962
83851	1480	717980000000	7610	3938	0	0	2
83858	1726	846204186000	7613	3939	0	0	963
83859	1726	846194185000	7613	3939	1	0	964
83866	1726	846174183000	7616	3940	0	0	966
83867	1726	846164182000	7616	3940	1	0	967
83868	1726	846154181000	7618	3941	0	0	968
83873	1726	846144180000	7622	3943	0	0	969
83874	1726	846134179000	7622	3943	1	0	970
83876	1726	846124178000	7623	3944	0	0	971
83877	1726	846114177000	7623	3944	1	0	972
83878	1726	846104176000	7623	3944	2	0	973
83879	1726	846094175000	7623	3944	3	0	974
83888	1726	846084174000	7626	3945	0	0	975
83892	1726	846064172000	7629	3946	0	0	977
83893	1726	846054171000	7629	3946	1	0	978
83894	1726	846044170000	7629	3946	2	0	979
83895	1480	716970000000	7629	3946	3	0	3
83897	1726	846024168000	7629	3946	5	0	981
83898	1726	846014167000	7630	3947	0	0	982
83899	1726	846004166000	7631	3948	0	0	983
83900	1726	845994165000	7632	3949	0	0	984
83901	1726	845984164000	7632	3949	1	0	985
83903	1726	845964162000	7634	3951	0	0	987
83904	1726	845954161000	7635	3952	0	0	988
83906	1726	845944160000	7637	3953	0	0	989
83909	1773	6049625162309	7640	3954	0	0	13
83910	1726	845934159000	7640	3954	1	0	990
83912	1726	845924158000	7640	3954	3	0	991
83918	1480	715960000000	7641	3953	0	0	\N
83919	1773	6049625162309	7642	3954	0	0	\N
83920	1726	845934159000	7642	3954	1	0	\N
83921	1480	715960000000	7642	3954	2	0	\N
83922	1726	845924158000	7642	3954	3	0	\N
83923	1773	5978570270530	7642	3954	4	0	\N
83924	1773	5167398127791	7642	3954	5	0	\N
83925	1773	3713792518037	7642	3954	6	0	\N
83926	1773	2733012595198	7642	3954	7	0	\N
83927	1773	0	7642	3954	8	0	\N
83928	1773	6049625162309	7643	3954	0	0	\N
83929	1726	845934159000	7643	3954	1	0	\N
83930	1480	715960000000	7643	3954	2	0	\N
83931	1726	845924158000	7643	3954	3	0	\N
83932	1773	5978570270530	7643	3954	4	0	\N
83933	1773	5167398127791	7643	3954	5	0	\N
83934	1773	3713792518037	7643	3954	6	0	\N
83935	1773	2733012595198	7643	3954	7	0	\N
83936	1773	0	7643	3954	8	0	\N
83937	321	66009960000000	7644	3820	0	0	\N
83938	1726	847614197000	7644	3820	1	0	\N
83939	1726	847604196000	7644	3820	2	0	\N
83940	1726	847594195000	7644	3820	3	0	\N
83941	1726	847584194000	7644	3820	4	0	\N
83942	1726	847574193000	7644	3820	5	0	\N
83943	1726	846274193000	7644	3820	6	0	\N
83944	1726	846264192000	7644	3820	8	0	\N
83945	1726	846254191000	7644	3820	9	0	\N
83946	1726	846244190000	7644	3820	10	0	\N
83947	1726	846234189000	7644	3820	11	0	\N
83948	1726	846224188000	7644	3820	12	0	\N
83949	1726	846214187000	7644	3820	13	0	\N
83950	1726	846204186000	7644	3820	14	0	\N
83951	1726	846194185000	7644	3820	15	0	\N
83952	1726	846184184000	7644	3820	16	0	\N
83953	1726	846174183000	7644	3820	17	0	\N
83954	1726	846164182000	7644	3820	18	0	\N
83955	1726	846154181000	7644	3820	19	0	\N
83956	1726	846144180000	7644	3820	20	0	\N
83957	1726	846134179000	7644	3820	21	0	\N
83958	1726	846124178000	7644	3820	22	0	\N
83959	1726	846114177000	7644	3820	23	0	\N
83960	1726	846104176000	7644	3820	24	0	\N
83961	1726	846094175000	7644	3820	25	0	\N
83962	1726	846084174000	7644	3820	26	0	\N
83963	1726	846074173000	7644	3820	27	0	\N
83964	1726	846064172000	7644	3820	28	0	\N
83965	1726	846054171000	7644	3820	29	0	\N
83966	1726	846044170000	7644	3820	30	0	\N
83967	1726	846034169000	7644	3820	31	0	\N
83968	1726	846024168000	7644	3820	32	0	\N
83969	1726	846014167000	7644	3820	33	0	\N
83970	1726	846004166000	7644	3820	34	0	\N
83971	1726	845994165000	7644	3820	35	0	\N
83972	1726	845984164000	7644	3820	36	0	\N
83973	1726	845974163000	7644	3820	37	0	\N
83974	1726	845964162000	7644	3820	38	0	\N
83975	1726	845954161000	7644	3820	39	0	\N
83976	1726	845944160000	7644	3820	40	0	\N
83977	1726	845934159000	7644	3820	41	0	\N
83978	1726	845924158000	7644	3820	42	0	\N
83979	1699	933819000078	7644	3820	43	0	\N
83984	1726	845874153000	7648	3958	0	0	\N
83985	1726	845864152000	7648	3958	1	0	\N
83988	1726	845914157000	7651	3821	0	0	\N
83989	1726	845904156000	7651	3821	1	0	\N
83990	1726	845894155000	7651	3821	2	0	\N
83991	1726	845884154000	7651	3821	3	0	\N
83992	1726	845874153000	7651	3821	4	0	\N
83993	1726	845864152000	7651	3821	5	0	\N
83994	1726	845854151000	7651	3821	6	0	\N
83995	1726	845844150000	7651	3821	7	0	\N
84001	1726	845834149000	7654	3961	0	0	\N
84002	1726	845824148000	7654	3961	1	0	\N
84006	1726	845794145000	7657	3963	0	0	\N
84009	1726	845764142000	7661	3966	0	0	\N
84010	1726	845754141000	7661	3966	1	0	\N
84011	1726	845764142000	7663	3966	0	0	\N
84012	1726	845754141000	7663	3966	1	0	\N
84020	1726	845734139000	7666	3969	0	0	\N
84021	1726	845724138000	7666	3969	1	0	\N
84022	1726	845734139000	7667	3969	0	0	\N
84023	1726	845724138000	7667	3969	1	0	\N
84024	1726	845734139000	7668	3969	0	0	\N
84025	1726	845724138000	7668	3969	1	0	\N
84028	1726	845714137000	7670	3970	0	0	\N
84037	878	203053176619445	7675	3973	0	0	\N
84038	127	66000010000000	7675	3973	1	0	\N
84039	1480	712930000000	7675	3973	2	0	\N
84040	1726	845684134000	7675	3973	3	0	\N
84041	877	203053176619445	7675	3973	4	0	\N
84047	1726	845624128000	7679	3977	0	0	\N
83915	1773	3713792518037	7640	3954	6	0	16
83916	1773	2733012595198	7640	3954	7	0	17
83917	1773	0	7640	3954	8	0	18
83980	1726	845914157000	7645	3955	0	0	992
83981	1726	845904156000	7646	3956	0	0	993
83983	1726	845884154000	7647	3957	0	0	995
83986	1726	845874153000	7649	3958	0	0	996
83987	1726	845864152000	7649	3958	1	0	997
83996	1726	845854151000	7652	3960	0	0	998
83997	1726	845844150000	7652	3960	1	0	999
83999	1726	845834149000	7653	3961	0	0	1000
84000	1726	845824148000	7653	3961	1	0	1001
84003	1726	845814147000	7655	3962	0	0	1002
84004	1726	845804146000	7655	3962	1	0	1003
84007	1726	845784144000	7659	3964	0	0	1005
84008	1726	845774143000	7660	3965	0	0	1006
84013	1480	713940000000	7664	3967	0	0	6
84014	1726	845764142000	7664	3967	1	0	1007
84015	1726	845754141000	7664	3967	2	0	1008
84017	877	203449876855173	7665	3968	0	0	3
84018	878	203450876855173	7665	3968	1	0	3
84019	127	66129967824773	7665	3968	2	0	2
84026	1726	845734139000	7669	3969	0	0	1010
84027	1726	845724138000	7669	3969	1	0	1011
84030	1726	845704136000	7672	3971	0	0	1013
84031	1726	845694135000	7673	3972	0	0	1014
84032	878	203053176619445	7674	3973	0	0	4
84033	127	66000010000000	7674	3973	1	0	3
84035	1726	845684134000	7674	3973	3	0	1015
84036	877	203053176619445	7674	3973	4	0	4
84042	1726	845674133000	7677	3975	0	0	1016
84043	1726	845664132000	7677	3975	2	0	1017
84044	1726	845654131000	7677	3975	3	0	1018
84046	1726	845634129000	7678	3976	0	0	1020
84048	1726	845624128000	7680	3977	0	0	1021
84049	1726	845614127000	7682	3978	0	0	\N
84053	1726	845614127000	7684	3979	0	0	\N
84054	1726	845604126000	7684	3979	1	0	\N
84055	1726	845594125000	7684	3979	2	0	\N
84060	1726	845554121000	7688	3982	0	0	\N
84065	1726	845504116000	7692	3985	0	0	\N
84069	1726	845484114000	7694	3987	0	0	\N
84071	1726	845474113000	7696	3988	0	0	\N
84073	1726	845464112000	7698	3989	0	0	\N
84075	1726	845464112000	7700	3989	0	0	\N
84077	1726	845444110000	7702	3991	0	0	\N
84079	1726	845444110000	7704	3991	0	0	\N
84080	1726	845444110000	7705	3991	0	0	\N
84082	1726	845454111000	7707	3990	0	0	\N
84083	1726	845444110000	7707	3990	1	0	\N
84084	1726	845434109000	7707	3990	2	0	\N
84085	1726	845424108000	7708	3993	0	0	\N
84086	1726	845414107000	7708	3993	1	0	\N
84089	1726	845404106000	7710	3994	0	0	\N
84091	1726	845404106000	7712	3994	0	0	\N
84094	1726	845384104000	7715	3996	0	0	\N
84097	1726	845364102000	7718	3998	0	0	\N
84098	1726	845364102000	7719	3998	0	0	\N
84099	1726	845364102000	7720	3998	0	0	\N
84100	1726	845364102000	7721	3998	0	0	\N
84102	1726	845354101000	7723	3999	0	0	\N
84113	1726	843964092000	7731	4005	0	0	\N
84118	1726	843914087000	7734	4008	0	0	\N
84120	1726	845384104000	7736	3996	0	0	\N
84121	1726	845374103000	7736	3996	1	0	\N
84122	1726	845364102000	7736	3996	2	0	\N
84123	1726	845354101000	7736	3996	3	0	\N
84124	1726	845344100000	7736	3996	4	0	\N
84125	1726	845334099000	7736	3996	5	0	\N
84126	1726	845324098000	7736	3996	6	0	\N
84127	1726	845314097000	7736	3996	7	0	\N
84128	1726	845304096000	7736	3996	8	0	\N
84129	1726	845294095000	7736	3996	9	0	\N
84130	1726	843994095000	7736	3996	10	0	\N
84131	1726	843984094000	7736	3996	11	0	\N
84132	1726	843974093000	7736	3996	12	0	\N
84133	1726	843964092000	7736	3996	13	0	\N
84134	1726	843954091000	7736	3996	14	0	\N
84135	1726	843944090000	7736	3996	15	0	\N
84136	1726	843934089000	7736	3996	16	0	\N
84137	1726	843924088000	7736	3996	17	0	\N
84138	1726	843914087000	7736	3996	18	0	\N
84144	1726	843864082000	7742	4012	0	0	\N
84148	1726	843854081000	7746	4015	0	0	\N
84149	1726	843844080000	7746	4015	1	0	\N
84150	1726	843834079000	7746	4015	2	0	\N
84152	1726	843824078000	7748	4016	0	0	\N
84156	1726	843784074000	7751	4019	0	0	\N
84157	1726	843784074000	7752	4019	0	0	\N
84158	1726	843784074000	7753	4019	0	0	\N
84160	1726	843784074000	7755	4019	0	0	\N
84164	1726	843754071000	7759	4022	0	0	\N
84165	1726	843764072000	7760	4021	0	0	\N
84166	1726	843754071000	7760	4021	1	0	\N
84170	1726	843714067000	7763	4025	0	0	\N
84172	1726	843714067000	7765	4025	0	0	\N
84181	1726	843634059000	7771	4030	0	0	\N
84182	1726	843634059000	7772	4030	0	0	\N
84184	1726	843624058000	7774	4031	0	0	\N
84052	1726	845594125000	7683	3979	2	0	1024
84056	1726	845584124000	7685	3980	0	0	1025
84057	1726	845574123000	7685	3980	1	0	1026
84058	1726	845564122000	7686	3981	0	0	1027
84059	1726	845554121000	7687	3982	0	0	1028
84062	1726	845534119000	7689	3983	1	0	1030
84063	1726	845524118000	7689	3983	2	0	1031
84064	1726	845514117000	7690	3984	0	0	1032
84066	298	71039170000000	7693	3986	0	0	3
84067	1726	845504116000	7693	3986	1	0	1033
84070	1726	845484114000	7695	3987	0	0	1035
84072	1726	845474113000	7697	3988	0	0	1036
84074	1726	845464112000	7699	3989	0	0	1037
84076	1726	845454111000	7701	3990	0	0	1038
84081	1726	845434109000	7706	3992	0	0	1040
84087	1726	845424108000	7709	3993	0	0	1041
84088	1726	845414107000	7709	3993	1	0	1042
84090	1726	845404106000	7711	3994	0	0	1043
84092	1726	845394105000	7713	3995	0	0	1044
84095	1726	845374103000	7716	3997	0	0	1046
84096	1726	845364102000	7717	3998	0	0	1047
84101	1726	845354101000	7722	3999	0	0	1048
84103	1726	845344100000	7724	4000	0	0	1049
84104	1726	845334099000	7724	4000	1	0	1050
84106	1726	845314097000	7726	4002	0	0	1052
84107	1726	845304096000	7727	4003	0	0	1053
84108	1726	845294095000	7727	4003	1	0	1054
84109	1726	843994095000	7729	4004	0	0	1055
84111	1726	843974093000	7729	4004	2	0	1057
84112	1726	843964092000	7730	4005	0	0	1058
84114	1726	843954091000	7732	4006	0	0	1059
84115	1726	843944090000	7733	4007	0	0	1060
84116	1726	843934089000	7733	4007	1	0	1061
84119	1726	843914087000	7735	4008	0	0	1063
84139	1726	843904086000	7737	4009	0	0	1064
84140	1726	843894085000	7738	4010	0	0	1065
84141	1726	843884084000	7738	4010	1	0	1066
84142	1726	843874083000	7740	4011	0	0	1067
84145	1726	843854081000	7745	4015	0	0	1069
84146	1726	843844080000	7745	4015	1	0	1070
84147	1726	843834079000	7745	4015	2	0	1071
84151	1726	843824078000	7747	4016	0	0	1072
84154	1726	843804076000	7750	4018	0	0	1074
84155	1726	843794075000	7750	4018	1	0	1075
84159	1726	843784074000	7754	4019	0	0	1076
84161	1726	843774073000	7756	4020	0	0	1077
84162	1726	843764072000	7757	4021	0	0	1078
84167	1726	843744070000	7762	4024	0	0	1080
84168	1726	843734069000	7762	4024	1	0	1081
84169	1726	843724068000	7762	4024	2	0	1082
84171	1726	843714067000	7764	4025	0	0	1083
84173	1726	843704066000	7767	4027	0	0	1084
84175	1726	843684064000	7767	4027	2	0	1086
84176	1726	843674063000	7768	4028	0	0	1087
84177	1726	843664062000	7768	4028	1	0	1088
84178	1726	843654061000	7768	4028	2	0	1089
84180	1726	843634059000	7770	4030	0	0	1091
84183	1726	843624058000	7773	4031	0	0	1092
84185	1726	843614057000	7775	4032	0	0	\N
84187	1726	843604056000	7777	4033	0	0	\N
84189	1726	843604056000	7779	4033	0	0	\N
84191	1726	843584054000	7782	4035	0	0	\N
84193	1726	843574053000	7784	4036	0	0	\N
84194	1726	843564052000	7784	4036	1	0	\N
84201	1726	843534049000	7788	4038	0	0	\N
84206	1726	840914047000	7791	4040	0	0	\N
84207	1726	840904046000	7792	4041	0	0	\N
84209	1726	840904046000	7794	4041	0	0	\N
84210	1726	840904046000	7795	4041	0	0	\N
84212	1726	840884044000	7797	4043	0	0	\N
84216	1726	840854041000	7800	4045	0	0	\N
84218	1726	840854041000	7802	4045	0	0	\N
84221	1726	840834039000	7805	4047	0	0	\N
84222	1726	840824038000	7806	4048	0	0	\N
84223	1726	840824038000	7807	4048	0	0	\N
84224	1726	840824038000	7808	4048	0	0	\N
84226	1726	840814037000	7810	4049	0	0	\N
84227	1726	840804036000	7810	4049	1	0	\N
84230	1726	840794035000	7812	4050	0	0	\N
84233	1726	840784034000	7815	4051	0	0	\N
84234	1726	840784034000	7816	4051	0	0	\N
84236	1726	840764032000	7819	4054	0	0	\N
84237	1726	840754031000	7819	4054	1	0	\N
84238	1726	840744030000	7819	4054	2	0	\N
84239	1726	840734029000	7819	4054	3	0	\N
84244	1726	840724028000	7821	4055	0	0	\N
84245	1726	840714027000	7821	4055	1	0	\N
84248	1726	840704026000	7823	4056	0	0	\N
84251	1726	840684024000	7826	4058	0	0	\N
84254	1726	840664022000	7829	4060	0	0	\N
84256	1726	840664022000	7831	4060	0	0	\N
84257	1726	840664022000	7832	4060	0	0	\N
84259	1726	840644020000	7834	4062	0	0	\N
84261	1726	840644020000	7836	4062	0	0	\N
84262	1726	840644020000	7837	4062	0	0	\N
84263	1726	840634019000	7838	4063	0	0	\N
84265	1480	711920000000	7841	4064	0	0	\N
84266	1726	840624018000	7841	4064	1	0	\N
84267	1726	840614017000	7841	4064	2	0	\N
84268	1726	840604016000	7841	4064	3	0	\N
84269	1726	840594015000	7841	4064	4	0	\N
84270	1726	840584014000	7841	4064	5	0	\N
84278	1726	840564012000	7844	4066	0	0	\N
84279	1726	840554011000	7844	4066	1	0	\N
84282	1726	840544010000	7846	4067	0	0	\N
84283	1726	840544010000	7847	4067	0	0	\N
84288	1726	840514007000	7851	4069	0	0	\N
84293	1726	840464002000	7854	4072	0	0	\N
84297	1726	840444000000	7858	4074	0	0	\N
84299	1726	840433999000	7860	4075	0	0	\N
84300	1726	840423998000	7861	4076	0	0	\N
84301	1726	840423998000	7862	4076	0	0	\N
84303	1726	840423998000	7865	4076	0	0	\N
84304	877	203054243117107	7866	3793	0	0	\N
84305	878	203055243117107	7866	3793	1	0	\N
84306	298	71039170000000	7866	3793	2	0	\N
84307	127	66001371816426	7866	3793	3	0	\N
84308	1740	16557888000000	7866	3793	4	0	\N
84309	1522	12239960000000	7866	3793	5	0	\N
84310	1522	12239940000000	7866	3793	6	0	\N
84311	1876	350660000000	7866	3793	7	0	\N
84312	1623	23761640899898	7866	3793	8	0	\N
84313	1596	12750160000000	7866	3793	9	0	\N
84314	353	66153471816426	7866	3793	10	0	\N
84315	1611	11510200000000	7866	3793	11	0	\N
84316	1596	12651155000000	7866	3793	12	0	\N
84317	1596	12641145000000	7866	3793	13	0	\N
84318	1596	12419140000000	7866	3793	14	0	\N
84319	1699	933819000078	7866	3793	15	0	\N
84190	1726	843594055000	7781	4034	0	0	1095
84192	1726	843584054000	7783	4035	0	0	1096
84195	1726	843574053000	7785	4036	0	0	1097
84196	1726	843564052000	7785	4036	1	0	1098
84197	1726	843554051000	7786	4037	0	0	1099
84199	353	66282067824773	7786	4037	2	0	1
84200	1726	843534049000	7787	4038	0	0	1101
84202	1726	843524048000	7789	4039	0	0	1102
84203	1726	842224048000	7789	4039	1	0	1103
84204	1726	840924048000	7789	4039	2	0	1104
84208	1726	840904046000	7793	4041	0	0	1106
84211	1726	840894045000	7796	4042	0	0	1107
84213	1726	840884044000	7798	4043	0	0	1108
84214	1726	840874043000	7799	4044	0	0	1109
84217	1726	840854041000	7801	4045	0	0	1111
84219	1726	840844040000	7803	4046	0	0	1112
84220	1726	840834039000	7804	4047	0	0	1113
84225	1726	840824038000	7809	4048	0	0	1114
84228	1726	840814037000	7811	4049	0	0	1115
84231	1726	840794035000	7813	4050	0	0	1117
84232	1726	840784034000	7814	4051	0	0	1118
84235	1726	840774033000	7817	4052	0	0	1119
84240	1726	840764032000	7820	4054	0	0	1120
84241	1726	840754031000	7820	4054	1	0	1121
84243	1726	840734029000	7820	4054	3	0	1123
84246	1726	840724028000	7822	4055	0	0	1124
84247	1726	840714027000	7822	4055	1	0	1125
84249	1726	840704026000	7824	4056	0	0	1126
84252	1726	840684024000	7827	4058	0	0	1128
84253	1726	840674023000	7828	4059	0	0	1129
84255	1726	840664022000	7830	4060	0	0	1130
84258	1726	840654021000	7833	4061	0	0	1131
84260	1726	840644020000	7835	4062	0	0	1132
84271	1480	711920000000	7842	4064	0	0	8
84272	1726	840624018000	7842	4064	1	0	1134
84273	1726	840614017000	7842	4064	2	0	1135
84274	1726	840604016000	7842	4064	3	0	1136
84275	1726	840594015000	7842	4064	4	0	1137
84277	1726	840574013000	7843	4065	0	0	1139
84280	1726	840564012000	7845	4066	0	0	1140
84281	1726	840554011000	7845	4066	1	0	1141
84284	1726	840544010000	7848	4067	0	0	1142
84286	1726	840524008000	7849	4068	1	0	1144
84287	1726	840514007000	7850	4069	0	0	1145
84289	1726	840504006000	7852	4070	0	0	1146
84290	1726	840494005000	7852	4070	1	0	1147
84291	1726	840484004000	7852	4070	2	0	1148
84294	1726	840464002000	7855	4072	0	0	1150
84295	1726	840454001000	7856	4073	0	0	1151
84296	1726	840444000000	7857	4074	0	0	1152
84298	1726	840433999000	7859	4075	0	0	1153
84302	1726	840423998000	7863	4076	0	0	1154
84324	1726	840393995000	7870	4079	0	0	\N
84325	1726	840383994000	7870	4079	1	0	\N
84326	1726	840393995000	7871	4079	0	0	\N
84327	1726	840383994000	7871	4079	1	0	\N
84328	1726	840393995000	7872	4079	0	0	\N
84329	1726	840383994000	7872	4079	1	0	\N
84330	1726	840373993000	7873	4080	0	0	\N
84334	1726	840363992000	7876	4081	0	0	\N
84335	1726	840353991000	7876	4081	1	0	\N
84336	1726	840363992000	7877	4081	0	0	\N
84337	1726	840353991000	7877	4081	1	0	\N
84342	1726	840323988000	7880	4083	0	0	\N
84343	1726	840323988000	7881	4083	0	0	\N
84346	1726	840293985000	7883	4085	0	0	\N
84348	1726	840293985000	7885	4085	0	0	\N
84354	1726	840243980000	7891	4090	0	0	\N
84355	1726	840243980000	7892	4090	0	0	\N
84356	1726	840243980000	7893	4090	0	0	\N
84358	1726	840233979000	7895	4091	0	0	\N
84359	1726	840223978000	7896	4092	0	0	\N
84360	1726	840223978000	7897	4092	0	0	\N
84362	1726	840213977000	7899	4093	0	0	\N
84363	1726	840203976000	7899	4093	1	0	\N
84364	1726	840213977000	7900	4093	0	0	\N
84365	1726	840203976000	7900	4093	1	0	\N
84368	1726	840193975000	7902	4094	0	0	\N
84369	1918	999000000	7902	4094	1	0	\N
84372	1726	840193975000	7904	4094	0	0	\N
84373	1918	999000000	7904	4094	1	0	\N
84374	1726	840193975000	7905	4094	0	0	\N
84375	1918	999000000	7905	4094	1	0	\N
84378	1726	840163972000	7908	4097	0	0	\N
84385	1726	840123968000	7914	4101	0	0	\N
84386	1726	840113967000	7914	4101	1	0	\N
84389	1726	840093965000	7917	4103	0	0	\N
84393	1726	840083964000	7919	4104	0	0	\N
84394	1726	840073963000	7919	4104	1	0	\N
84395	1726	840063962000	7919	4104	2	0	\N
84398	1726	840033959000	7921	4106	0	0	\N
84399	1726	840023958000	7921	4106	1	0	\N
84406	1726	839993955000	7925	4108	0	0	\N
84409	1726	839983954000	7927	4109	0	0	\N
84410	1726	839973953000	7927	4109	1	0	\N
84413	1726	839953951000	7930	4111	0	0	\N
84414	1726	839953951000	7931	4111	0	0	\N
84415	1726	843904086000	7932	3997	0	0	\N
84416	1726	843894085000	7932	3997	1	0	\N
84417	1480	711920000000	7932	3997	2	0	\N
84418	1726	843884084000	7932	3997	3	0	\N
84419	353	66282067824773	7932	3997	4	0	\N
84420	1726	843874083000	7932	3997	5	0	\N
84421	1726	843864082000	7932	3997	6	0	\N
84422	1726	843854081000	7932	3997	7	0	\N
84423	1726	843844080000	7932	3997	8	0	\N
84424	1726	843834079000	7932	3997	9	0	\N
84425	1726	843824078000	7932	3997	10	0	\N
84426	1726	843814077000	7932	3997	11	0	\N
84427	1726	843804076000	7932	3997	12	0	\N
84428	1726	843794075000	7932	3997	13	0	\N
84429	1726	843784074000	7932	3997	14	0	\N
84430	1726	843774073000	7932	3997	15	0	\N
84431	1726	843764072000	7932	3997	16	0	\N
84432	1726	843754071000	7932	3997	17	0	\N
84433	1726	843744070000	7932	3997	18	0	\N
84434	1726	843734069000	7932	3997	19	0	\N
84435	1726	843724068000	7932	3997	20	0	\N
84436	1726	843714067000	7932	3997	21	0	\N
84437	1726	843704066000	7932	3997	22	0	\N
84438	1726	843694065000	7932	3997	23	0	\N
84439	1726	843684064000	7932	3997	24	0	\N
84440	1726	843674063000	7932	3997	25	0	\N
84441	1726	843664062000	7932	3997	26	0	\N
84442	1726	843654061000	7932	3997	27	0	\N
84443	1726	843644060000	7932	3997	28	0	\N
84444	1726	843634059000	7932	3997	29	0	\N
84445	1726	843624058000	7932	3997	30	0	\N
84446	1726	843614057000	7932	3997	31	0	\N
84447	1726	843604056000	7932	3997	32	0	\N
84448	1726	843594055000	7932	3997	33	0	\N
84449	1726	843584054000	7932	3997	34	0	\N
84450	1726	843574053000	7932	3997	35	0	\N
84451	1726	843564052000	7932	3997	36	0	\N
84452	1726	843554051000	7932	3997	38	0	\N
84453	1726	843544050000	7932	3997	39	0	\N
84454	1726	843534049000	7932	3997	40	0	\N
84455	1726	843524048000	7932	3997	41	0	\N
84456	1726	842224048000	7932	3997	42	0	\N
84323	1726	840383994000	7869	4079	1	0	1158
84331	1726	840373993000	7874	4080	0	0	1159
84332	1726	840363992000	7875	4081	0	0	1160
84333	1726	840353991000	7875	4081	1	0	1161
84338	1726	840343990000	7878	4082	0	0	1162
84340	1456	1438139000000	7878	4082	2	0	1
84341	1726	840323988000	7879	4083	0	0	1164
84344	1726	840313987000	7882	4084	0	0	1165
84345	1726	840303986000	7882	4084	1	0	1166
84347	1726	840293985000	7884	4085	0	0	1167
84350	1726	840273983000	7887	4087	0	0	1169
84351	1726	840263982000	7888	4088	0	0	1170
84352	1726	840253981000	7889	4089	0	0	1171
84353	1726	840243980000	7890	4090	0	0	1172
84361	1726	840223978000	7898	4092	0	0	1174
84366	1726	840213977000	7901	4093	0	0	1175
84367	1726	840203976000	7901	4093	1	0	1176
84370	1726	840193975000	7903	4094	0	0	1177
84371	1918	999000000	7903	4094	1	0	1
84377	1726	840173973000	7907	4096	0	0	1179
84379	1726	840163972000	7909	4097	0	0	1180
84380	1726	840153971000	7910	4098	0	0	1181
84381	1726	840143970000	7911	4099	0	0	1182
84382	1726	840133969000	7912	4100	0	0	1183
84384	1726	840113967000	7913	4101	1	0	1185
84387	1726	840103966000	7915	4102	0	0	1186
84388	1726	840093965000	7916	4103	0	0	1187
84390	1726	840083964000	7918	4104	0	0	1188
84392	1726	840063962000	7918	4104	2	0	1190
84396	1726	840053961000	7920	4105	0	0	1191
84397	1726	840043960000	7920	4105	1	0	1192
84400	1726	840033959000	7922	4106	0	0	1193
84401	1726	840023958000	7922	4106	1	0	1194
84403	1726	840003956000	7923	4107	1	0	1196
84404	1456	0	7923	4107	2	0	2
84405	1726	839993955000	7924	4108	0	0	1197
84407	1726	839983954000	7926	4109	0	0	1198
84408	1726	839973953000	7926	4109	1	0	1199
84412	1726	839953951000	7929	4111	0	0	1201
84457	1726	840924048000	7932	3997	43	0	\N
84458	1726	840914047000	7932	3997	44	0	\N
84459	1726	840904046000	7932	3997	45	0	\N
84460	1726	840894045000	7932	3997	46	0	\N
84461	1726	840884044000	7932	3997	47	0	\N
84462	1726	840874043000	7932	3997	48	0	\N
84463	1726	840864042000	7932	3997	49	0	\N
84464	1726	840854041000	7932	3997	50	0	\N
84465	1726	840844040000	7932	3997	51	0	\N
84466	1726	840834039000	7932	3997	52	0	\N
84467	1726	840824038000	7932	3997	53	0	\N
84468	1726	840814037000	7932	3997	54	0	\N
84469	1726	840804036000	7932	3997	55	0	\N
84470	1726	840794035000	7932	3997	56	0	\N
84471	1726	840784034000	7932	3997	57	0	\N
84472	1726	840774033000	7932	3997	58	0	\N
84473	1726	840764032000	7932	3997	59	0	\N
84474	1726	840754031000	7932	3997	60	0	\N
84475	1726	840744030000	7932	3997	61	0	\N
84476	1726	840734029000	7932	3997	62	0	\N
84477	1726	840724028000	7932	3997	63	0	\N
84478	1726	840714027000	7932	3997	64	0	\N
84479	1726	840704026000	7932	3997	65	0	\N
84480	1726	840694025000	7932	3997	66	0	\N
84481	1726	840684024000	7932	3997	67	0	\N
84482	1726	840674023000	7932	3997	68	0	\N
84483	1726	840664022000	7932	3997	69	0	\N
84484	1726	840654021000	7932	3997	70	0	\N
84485	1726	840644020000	7932	3997	71	0	\N
84486	1726	840634019000	7932	3997	72	0	\N
84487	1726	840624018000	7932	3997	73	0	\N
84488	1726	840614017000	7932	3997	74	0	\N
84489	1726	840604016000	7932	3997	75	0	\N
84490	1726	840594015000	7932	3997	76	0	\N
84491	1726	840584014000	7932	3997	77	0	\N
84492	1726	840574013000	7932	3997	78	0	\N
84493	1726	840564012000	7932	3997	79	0	\N
84494	1726	840554011000	7932	3997	80	0	\N
84495	1726	840544010000	7932	3997	81	0	\N
84496	1726	840534009000	7932	3997	82	0	\N
84497	1726	840524008000	7932	3997	83	0	\N
84498	1726	840514007000	7932	3997	84	0	\N
84499	1726	840504006000	7932	3997	85	0	\N
84500	1726	840494005000	7932	3997	86	0	\N
84501	1726	840484004000	7932	3997	87	0	\N
84502	1726	840474003000	7932	3997	88	0	\N
84503	1726	840464002000	7932	3997	89	0	\N
84504	1726	840454001000	7932	3997	90	0	\N
84505	1726	840444000000	7932	3997	91	0	\N
84506	1726	840433999000	7932	3997	92	0	\N
84507	1726	840423998000	7932	3997	93	0	\N
84508	1726	840413997000	7932	3997	94	0	\N
84509	1726	840403996000	7932	3997	95	0	\N
84510	1726	840393995000	7932	3997	96	0	\N
84511	1726	840383994000	7932	3997	97	0	\N
84512	1726	840373993000	7932	3997	98	0	\N
84513	1726	840363992000	7932	3997	99	0	\N
84514	1726	840353991000	7932	3997	100	0	\N
84515	1726	840343990000	7932	3997	101	0	\N
84516	1726	840333989000	7932	3997	102	0	\N
84517	1726	840323988000	7932	3997	103	0	\N
84518	1726	840313987000	7932	3997	104	0	\N
84519	1726	840303986000	7932	3997	105	0	\N
84520	1726	840293985000	7932	3997	106	0	\N
84521	1726	840283984000	7932	3997	107	0	\N
84522	1726	840273983000	7932	3997	108	0	\N
84523	1726	840263982000	7932	3997	109	0	\N
84524	1726	840253981000	7932	3997	110	0	\N
84525	1726	840243980000	7932	3997	111	0	\N
84526	1726	840233979000	7932	3997	112	0	\N
84527	1726	840223978000	7932	3997	113	0	\N
84528	1726	840213977000	7932	3997	114	0	\N
84529	1726	840203976000	7932	3997	115	0	\N
84530	1726	840193975000	7932	3997	116	0	\N
84531	1726	840183974000	7932	3997	117	0	\N
84532	1726	840173973000	7932	3997	118	0	\N
84533	1726	840163972000	7932	3997	119	0	\N
84534	1726	840153971000	7932	3997	120	0	\N
84535	1726	840143970000	7932	3997	121	0	\N
84536	1726	840133969000	7932	3997	122	0	\N
84537	1726	840123968000	7932	3997	123	0	\N
84538	1726	840113967000	7932	3997	124	0	\N
84539	1726	840103966000	7932	3997	125	0	\N
84540	1726	839983954000	7933	4109	0	0	\N
84541	1726	839973953000	7933	4109	1	0	\N
84542	1726	839963952000	7933	4109	2	0	\N
84543	1726	839953951000	7933	4109	3	0	\N
84546	1726	839933949000	7936	4113	0	0	\N
84548	1726	839923948000	7938	4114	0	0	\N
84550	1726	839913947000	7940	4115	0	0	\N
84551	1726	839913947000	7941	4115	0	0	\N
84552	1726	839913947000	7942	4115	0	0	\N
84553	1726	839903946000	7943	4116	0	0	\N
84554	1726	839903946000	7944	4116	0	0	\N
84556	1726	839903946000	7946	4116	0	0	\N
84558	1726	839883944000	7948	4118	0	0	\N
84559	1726	839883944000	7949	4118	0	0	\N
84562	1726	839863942000	7952	4120	0	0	\N
84568	1726	839813937000	7957	4124	0	0	\N
84569	1726	839813937000	7958	4124	0	0	\N
84570	1726	840093965000	7959	3998	0	0	\N
84571	1726	840083964000	7959	3998	1	0	\N
84572	1726	840073963000	7959	3998	2	0	\N
84573	1726	840063962000	7959	3998	3	0	\N
84574	1726	840053961000	7959	3998	4	0	\N
84575	1726	840043960000	7959	3998	5	0	\N
84576	1726	840033959000	7959	3998	6	0	\N
84577	1726	840023958000	7959	3998	7	0	\N
84578	1726	840013957000	7959	3998	8	0	\N
84579	1726	840003956000	7959	3998	9	0	\N
84580	1726	839993955000	7959	3998	10	0	\N
84581	1726	839983954000	7959	3998	11	0	\N
84582	1726	839973953000	7959	3998	12	0	\N
84583	1726	839963952000	7959	3998	13	0	\N
84584	1726	839953951000	7959	3998	14	0	\N
84585	1726	839943950000	7959	3998	15	0	\N
84586	1726	839933949000	7959	3998	16	0	\N
84587	1726	839923948000	7959	3998	17	0	\N
84588	1726	839913947000	7959	3998	18	0	\N
84589	1726	839903946000	7959	3998	19	0	\N
84590	1726	839893945000	7959	3998	20	0	\N
84591	1726	839883944000	7959	3998	21	0	\N
84592	1726	839873943000	7959	3998	22	0	\N
84547	1726	839923948000	7937	4114	0	0	1204
84549	1726	839913947000	7939	4115	0	0	1205
84555	1726	839903946000	7945	4116	0	0	1206
84557	1726	839893945000	7947	4117	0	0	1207
84560	1726	839883944000	7950	4118	0	0	1208
84563	1726	839863942000	7953	4120	0	0	1210
84564	1726	839853941000	7954	4121	0	0	1211
84565	1726	839843940000	7955	4122	0	0	1212
84566	1726	839833939000	7956	4123	0	0	1213
84567	1726	839823938000	7956	4123	1	0	1214
84593	1726	839863942000	7959	3998	23	0	\N
84594	1726	839853941000	7959	3998	24	0	\N
84595	1726	839843940000	7959	3998	25	0	\N
84596	1726	839833939000	7959	3998	26	0	\N
84597	1726	839823938000	7959	3998	27	0	\N
84598	1726	839813937000	7959	3998	28	0	\N
84599	1456	1438139000000	7959	3998	29	0	\N
84600	1456	0	7959	3998	30	0	\N
84608	1726	839743930000	7963	4127	0	0	\N
84610	1726	839733929000	7969	4129	0	0	\N
84611	1726	839723928000	7969	4129	1	0	\N
84612	1726	839713927000	7969	4129	2	0	\N
84613	497	66000000000000	7969	4129	3	0	\N
84614	1726	839703926000	7969	4129	4	0	\N
84615	497	66000000000000	7970	4129	0	0	\N
84629	1726	839623918000	7977	4134	0	0	\N
84631	1726	839613917000	7979	4135	0	0	\N
84632	1726	839603916000	7980	4136	0	0	\N
84633	1726	839593915000	7980	4136	1	0	\N
84634	1693	5033547553123	7980	4136	2	0	\N
84635	1726	839603916000	7981	4136	0	0	\N
84636	1726	839593915000	7981	4136	1	0	\N
84637	1693	5033547553123	7981	4136	2	0	\N
84651	1726	839513907000	7987	4141	0	0	\N
84652	1726	839503906000	7987	4141	1	0	\N
84653	1726	839493905000	7987	4141	2	0	\N
84659	1726	839483904000	7990	4142	0	0	\N
84660	1726	839473903000	7990	4142	1	0	\N
84665	1726	839443900000	7994	4145	0	0	\N
84666	1726	839433899000	7994	4145	1	0	\N
84669	1726	839403896000	7996	4147	0	0	\N
84670	1726	839403896000	7997	4147	0	0	\N
84671	1726	839403896000	7998	4147	0	0	\N
84673	1726	839403896000	8001	4147	0	0	\N
84674	1726	839393895000	8004	4148	0	0	\N
84675	1726	839383894000	8004	4148	1	0	\N
84676	1726	839393895000	8005	4148	0	0	\N
84677	1726	839383894000	8005	4148	1	0	\N
84682	1726	839353891000	8009	4151	0	0	\N
84685	1726	839333889000	8012	4153	0	0	\N
84686	1750	4194000000	8012	4153	1	0	\N
84687	1726	839333889000	8013	4153	0	0	\N
84688	1750	4194000000	8013	4153	1	0	\N
84689	1726	839333889000	8014	4153	0	0	\N
84690	1750	4194000000	8014	4153	1	0	\N
84699	1726	839263882000	8020	4158	0	0	\N
84700	1726	839253881000	8020	4158	1	0	\N
84706	1726	839213877000	8024	4161	0	0	\N
84707	1726	839203876000	8024	4161	1	0	\N
84708	1726	839213877000	8025	4161	0	0	\N
84709	1726	839203876000	8025	4161	1	0	\N
84712	1726	839193875000	8027	4162	0	0	\N
84713	1726	839193875000	8028	4162	0	0	\N
84715	1726	839183874000	8030	4163	0	0	\N
84716	1726	839173873000	8030	4163	1	0	\N
84717	1726	839163872000	8030	4163	2	0	\N
84718	1726	839183874000	8032	4163	0	0	\N
84719	1726	839173873000	8032	4163	1	0	\N
84720	1726	839163872000	8032	4163	2	0	\N
84721	1726	839183874000	8033	4164	0	0	\N
84722	1726	839173873000	8033	4164	1	0	\N
84723	1726	839163872000	8033	4164	2	0	\N
84724	1726	839153871000	8033	4164	3	0	\N
84725	1726	837853871000	8033	4164	4	0	\N
84726	1726	836553871000	8033	4164	5	0	\N
84727	1726	835253871000	8033	4164	6	0	\N
84728	1726	833953871000	8033	4164	7	0	\N
84603	1726	839793935000	7961	4125	1	0	1217
84604	1726	839783934000	7961	4125	2	0	1218
84605	1726	839773933000	7962	4126	0	0	1219
84606	1726	839763932000	7962	4126	1	0	1220
84607	1726	839753931000	7962	4126	2	0	1221
84616	1726	839733929000	7971	4129	0	0	1223
84617	1726	839723928000	7971	4129	1	0	1224
84618	1726	839713927000	7971	4129	2	0	1225
84619	497	66000000000000	7971	4129	3	0	1
84620	1726	839703926000	7971	4129	4	0	1226
84622	1726	839683924000	7973	4131	0	0	1228
84623	1726	839673923000	7974	4132	0	0	1229
84624	1726	839663922000	7974	4132	1	0	1230
84625	1726	839653921000	7975	4133	0	0	1231
84627	1726	839633919000	7975	4133	2	0	1233
84628	1726	839623918000	7976	4134	0	0	1234
84630	1726	839613917000	7978	4135	0	0	1235
84638	1726	839603916000	7982	4136	0	0	1236
84639	1726	839593915000	7982	4136	1	0	1237
84641	1726	839583914000	7983	4137	0	0	1238
84642	320	66280977824773	7984	4138	0	0	1
84643	1726	839573913000	7984	4138	1	0	1239
84644	1726	839563912000	7984	4138	2	0	1240
84645	320	66000877824773	7985	4139	0	0	2
84647	1726	839543910000	7985	4139	2	0	1242
84648	366	66000000000000	7986	4140	0	0	1
84649	1726	839533909000	7986	4140	1	0	1243
84650	1726	839523908000	7986	4140	2	0	1244
84655	1726	839503906000	7988	4141	1	0	1246
84656	1726	839493905000	7988	4141	2	0	1247
84657	1726	839483904000	7989	4142	0	0	1248
84658	1726	839473903000	7989	4142	1	0	1249
84661	1726	839463902000	7991	4143	0	0	1250
84663	1726	839443900000	7993	4145	0	0	1252
84664	1726	839433899000	7993	4145	1	0	1253
84667	1726	839423898000	7995	4146	0	0	1254
84668	1726	839413897000	7995	4146	1	0	1255
84672	1726	839403896000	8000	4147	0	0	1256
84679	1726	839383894000	8006	4148	1	0	1258
84680	1726	839373893000	8007	4149	0	0	1259
84681	1726	839363892000	8007	4149	1	0	1260
84683	1726	839353891000	8010	4151	0	0	1261
84691	1726	839333889000	8015	4153	0	0	1263
84692	1750	4194000000	8015	4153	1	0	6
84693	1726	839323888000	8016	4154	0	0	1264
84694	1726	839313887000	8016	4154	1	0	1265
84695	1726	839303886000	8016	4154	2	0	1266
84697	1726	839283884000	8018	4156	0	0	1268
84698	1726	839273883000	8019	4157	0	0	1269
84701	1726	839263882000	8021	4158	0	0	1270
84702	1726	839253881000	8021	4158	1	0	1271
84703	1726	839243880000	8022	4159	0	0	1272
84705	1726	839223878000	8023	4160	0	0	1274
84710	1726	839213877000	8026	4161	0	0	1275
84711	1726	839203876000	8026	4161	1	0	1276
84714	1726	839193875000	8029	4162	0	0	1277
84729	1726	832653871000	8033	4164	8	0	\N
84730	1726	832643870000	8033	4164	9	0	\N
84731	1726	831343870000	8033	4164	10	0	\N
84732	1726	831333869000	8033	4164	11	0	\N
84745	1726	839183874000	8035	4164	0	0	\N
84746	1726	839173873000	8035	4164	1	0	\N
84747	1726	839163872000	8035	4164	2	0	\N
84748	1726	839153871000	8035	4164	3	0	\N
84749	1726	837853871000	8035	4164	4	0	\N
84750	1726	836553871000	8035	4164	5	0	\N
84751	1726	835253871000	8035	4164	6	0	\N
84752	1726	833953871000	8035	4164	7	0	\N
84753	1726	832653871000	8035	4164	8	0	\N
84754	1726	832643870000	8035	4164	9	0	\N
84755	1726	831343870000	8035	4164	10	0	\N
84756	1726	831333869000	8035	4164	11	0	\N
84758	1726	831313867000	8037	4166	0	0	\N
84760	1726	831303866000	8039	4167	0	0	\N
84762	1726	831293865000	8041	4168	0	0	\N
84764	1726	831293865000	8043	4168	0	0	\N
84765	1726	831293865000	8044	4168	0	0	\N
84766	1726	831293865000	8045	4168	0	0	\N
84767	1726	831283864000	8046	4169	0	0	\N
84769	1726	831273863000	8048	4170	0	0	\N
84771	1726	831273863000	8050	4170	0	0	\N
84772	1726	831263862000	8051	4171	0	0	\N
84773	1726	831253861000	8051	4171	1	0	\N
84774	1726	831243860000	8051	4171	2	0	\N
84779	1726	831233859000	8054	4172	0	0	\N
84783	1726	831193855000	8058	4176	0	0	\N
84784	1726	831183854000	8058	4176	1	0	\N
84787	1726	831193855000	8060	4176	0	0	\N
84788	1726	831183854000	8060	4176	1	0	\N
84792	189	66000100000000	8063	4178	0	0	\N
84793	1726	831163852000	8063	4178	1	0	\N
84797	1726	831143850000	8066	4180	0	0	\N
84798	1750	4193000000	8066	4180	1	0	\N
84799	1726	831143850000	8067	4180	0	0	\N
84800	1750	4193000000	8067	4180	1	0	\N
84806	1726	831103846000	8072	4184	0	0	\N
84807	1726	831093845000	8072	4184	1	0	\N
84814	1726	831073843000	8075	4186	0	0	\N
84815	1726	831063842000	8075	4186	1	0	\N
84816	1750	4191000000	8075	4186	2	0	\N
84817	1745	6205000000	8075	4186	3	0	\N
84820	1726	831033839000	8077	4188	0	0	\N
84822	1726	831033839000	8079	4188	0	0	\N
84832	1726	830993835000	8083	4192	0	0	\N
84834	1726	830993835000	8085	4192	0	0	\N
84839	1726	830963832000	8089	4195	0	0	\N
84840	1726	830963832000	8090	4195	0	0	\N
84841	1726	830953831000	8091	4196	0	0	\N
84843	1726	830953831000	8093	4196	0	0	\N
84844	1726	830953831000	8094	4196	0	0	\N
84847	1726	830943830000	8096	4197	0	0	\N
84848	1750	4188000000	8096	4197	1	0	\N
84849	1726	830943830000	8097	4197	0	0	\N
84850	1750	4188000000	8097	4197	1	0	\N
84851	1726	830943830000	8098	4197	0	0	\N
84852	1750	4188000000	8098	4197	1	0	\N
84853	1726	830933829000	8099	4198	0	0	\N
84854	1750	4187000000	8099	4198	1	0	\N
84855	1726	830933829000	8100	4198	0	0	\N
84856	1750	4187000000	8100	4198	1	0	\N
84860	1726	829633829000	8103	4200	0	0	\N
84861	1726	829623828000	8103	4200	1	0	\N
84862	1726	829613827000	8103	4200	2	0	\N
84863	1750	4185000000	8103	4200	3	0	\N
84735	1726	839163872000	8034	4164	2	0	1280
84736	1726	839153871000	8034	4164	3	0	1281
84737	1726	837853871000	8034	4164	4	0	1282
84738	1726	836553871000	8034	4164	5	0	1283
84739	1726	835253871000	8034	4164	6	0	1284
84741	1726	832653871000	8034	4164	8	0	1286
84742	1726	832643870000	8034	4164	9	0	1287
84743	1726	831343870000	8034	4164	10	0	1288
84744	1726	831333869000	8034	4164	11	0	1289
84757	1726	831323868000	8036	4165	0	0	1290
84761	1726	831303866000	8040	4167	0	0	1292
84763	1726	831293865000	8042	4168	0	0	1293
84768	1726	831283864000	8047	4169	0	0	1294
84770	1726	831273863000	8049	4170	0	0	1295
84776	1726	831253861000	8052	4171	1	0	1297
84777	1726	831243860000	8052	4171	2	0	1298
84778	1726	831233859000	8053	4172	0	0	1299
84780	1726	831223858000	8055	4173	0	0	1300
84781	1726	831213857000	8056	4174	0	0	1301
84785	1726	831193855000	8059	4176	0	0	1303
84786	1726	831183854000	8059	4176	1	0	1304
84789	1726	831173853000	8061	4177	0	0	1305
84790	189	66000100000000	8062	4178	0	0	1
84791	1726	831163852000	8062	4178	1	0	1306
84795	1726	831143850000	8065	4180	0	0	1308
84796	1750	4193000000	8065	4180	1	0	7
84801	1726	831133849000	8069	4182	0	0	1309
84802	1726	831123848000	8070	4183	0	0	1310
84804	1726	831103846000	8071	4184	0	0	1312
84805	1726	831093845000	8071	4184	1	0	1313
84808	1726	831083844000	8073	4185	0	0	1314
84809	1750	4192000000	8073	4185	1	0	8
84810	1726	831073843000	8074	4186	0	0	1315
84812	1750	4191000000	8074	4186	2	0	9
84813	1745	6205000000	8074	4186	3	0	3
84818	1726	831053841000	8076	4187	0	0	1317
84819	1726	831043840000	8076	4187	1	0	1318
84821	1726	831033839000	8078	4188	0	0	1319
84824	1745	4004000000	8080	4189	1	0	4
84825	1726	831013837000	8081	4190	0	0	1321
84826	1750	4190000000	8081	4190	1	0	10
84827	1745	1803000000	8081	4190	2	0	5
84829	1726	831003836000	8082	4191	1	0	1322
84830	1750	4189000000	8082	4191	2	0	11
84831	1752	96000000	8082	4191	3	0	3
84833	1726	830993835000	8084	4192	0	0	1323
84835	1726	830983834000	8086	4193	0	0	1324
84837	1726	830973833000	8087	4194	0	0	1325
84838	1726	830963832000	8088	4195	0	0	1326
84842	1726	830953831000	8092	4196	0	0	1327
84845	1726	830943830000	8095	4197	0	0	1328
84846	1750	4188000000	8095	4197	1	0	12
84858	1750	4187000000	8102	4199	0	0	13
84859	1750	4186000000	8102	4199	1	0	14
84864	1726	829633829000	8104	4200	0	0	1330
84869	1726	829593825000	8106	4202	0	0	\N
84876	1726	829543820000	8112	4206	0	0	\N
84877	1726	829543820000	8113	4206	0	0	\N
84886	1726	829473813000	8116	4208	0	0	\N
84887	1726	829473813000	8117	4208	0	0	\N
84889	1726	829453811000	8119	4210	0	0	\N
84891	1726	829443810000	8122	4211	0	0	\N
84892	1726	829433809000	8122	4211	1	0	\N
84893	1726	829443810000	8123	4211	0	0	\N
84894	1726	829433809000	8123	4211	1	0	\N
84901	1726	829403806000	8126	4213	0	0	\N
84903	1726	829393805000	8129	4214	0	0	\N
84904	1726	829393805000	8130	4214	0	0	\N
84908	1726	829353801000	8133	4217	0	0	\N
84909	1726	829343800000	8133	4217	1	0	\N
84916	1726	829293795000	8139	4221	0	0	\N
84917	1726	829283794000	8139	4221	1	0	\N
84920	1726	829273793000	8141	4222	0	0	\N
84922	1726	829273793000	8143	4222	0	0	\N
84923	1726	829263792000	8144	4223	0	0	\N
84924	1726	829253791000	8144	4223	1	0	\N
84925	1726	829263792000	8145	4223	0	0	\N
84926	1726	829253791000	8145	4223	1	0	\N
84927	1726	829263792000	8146	4223	0	0	\N
84928	1726	829253791000	8146	4223	1	0	\N
84932	1883	100000000	8149	4205	0	0	\N
84933	1750	4184000000	8149	4205	1	0	\N
84938	1726	829233789000	8151	4225	0	0	\N
84939	1726	829223788000	8151	4225	1	0	\N
84940	1726	827923788000	8151	4225	2	0	\N
84941	1726	827913787000	8151	4225	3	0	\N
84943	1883	100000000	8153	4201	0	0	\N
84944	1726	829603826000	8153	4201	1	0	\N
84945	1726	829593825000	8153	4201	2	0	\N
84946	1726	829583824000	8153	4201	3	0	\N
84947	1726	829573823000	8153	4201	4	0	\N
84948	1726	829563822000	8153	4201	5	0	\N
84949	1726	829553821000	8153	4201	6	0	\N
84950	1726	829543820000	8153	4201	7	0	\N
84951	1726	829533819000	8153	4201	8	0	\N
84952	1726	829523818000	8153	4201	9	0	\N
84953	1726	829513817000	8153	4201	10	0	\N
84954	1726	829503816000	8153	4201	11	0	\N
84955	1726	829493815000	8153	4201	12	0	\N
84956	1726	829483814000	8153	4201	13	0	\N
84957	1726	829473813000	8153	4201	14	0	\N
84958	1726	829463812000	8153	4201	15	0	\N
84959	1726	829453811000	8153	4201	16	0	\N
84960	1726	829443810000	8153	4201	17	0	\N
84961	1726	829433809000	8153	4201	18	0	\N
84962	1726	829423808000	8153	4201	19	0	\N
84963	1726	829413807000	8153	4201	20	0	\N
84964	1726	829403806000	8153	4201	21	0	\N
84965	1726	829393805000	8153	4201	22	0	\N
84966	1726	829383804000	8153	4201	23	0	\N
84967	1726	829373803000	8153	4201	24	0	\N
84968	1726	829363802000	8153	4201	25	0	\N
84969	1726	829353801000	8153	4201	26	0	\N
84970	1726	829343800000	8153	4201	27	0	\N
84971	1726	829333799000	8153	4201	28	0	\N
84972	1726	829323798000	8153	4201	29	0	\N
84973	1726	829313797000	8153	4201	30	0	\N
84974	1726	829303796000	8153	4201	31	0	\N
84975	1726	829293795000	8153	4201	32	0	\N
84976	1726	829283794000	8153	4201	33	0	\N
84977	1726	829273793000	8153	4201	34	0	\N
84978	1726	829263792000	8153	4201	35	0	\N
84979	1726	829253791000	8153	4201	36	0	\N
84980	1726	829243790000	8153	4201	37	0	\N
84981	1726	829233789000	8153	4201	38	0	\N
84982	1726	829223788000	8153	4201	39	0	\N
84983	1726	827923788000	8153	4201	40	0	\N
84984	1726	827913787000	8153	4201	41	0	\N
84985	1726	827903786000	8153	4201	42	0	\N
84986	1750	4184000000	8153	4201	43	0	\N
84988	1726	827883784000	8155	4228	0	0	\N
84990	1726	827883784000	8157	4228	0	0	\N
84992	1726	827863782000	8159	4230	0	0	\N
84993	1726	827863782000	8160	4230	0	0	\N
84995	1726	827893785000	8162	4202	0	0	\N
84996	1726	827883784000	8162	4202	1	0	\N
84997	1726	827873783000	8162	4202	2	0	\N
84998	1726	827863782000	8162	4202	3	0	\N
84867	1750	4185000000	8104	4200	3	0	15
84868	1726	829603826000	8105	4201	0	0	1333
84870	1726	829593825000	8107	4202	0	0	1334
84871	1726	829583824000	8108	4203	0	0	1335
84872	1726	829573823000	8109	4204	0	0	1336
84874	1726	829553821000	8110	4205	1	0	1338
84875	1726	829543820000	8111	4206	0	0	1339
84878	1726	829533819000	8114	4207	0	0	1340
84879	1726	829523818000	8114	4207	1	0	1341
84880	1726	829513817000	8114	4207	2	0	1342
84882	1726	829493815000	8114	4207	4	0	1344
84883	1726	829483814000	8114	4207	5	0	1345
84884	1750	4184000000	8114	4207	6	0	16
84885	1726	829473813000	8115	4208	0	0	1346
84890	1726	829453811000	8120	4210	0	0	1348
84895	1883	100000000	8124	4212	0	0	1
84896	1726	829443810000	8124	4212	1	0	1349
84897	1726	829433809000	8124	4212	2	0	1350
84898	1726	829423808000	8124	4212	3	0	1351
84900	1726	829403806000	8125	4213	0	0	1353
84902	1726	829393805000	8127	4214	0	0	1354
84905	1726	829383804000	8131	4215	0	0	1355
84906	1726	829373803000	8132	4216	0	0	1356
84907	1726	829363802000	8132	4216	1	0	1357
84911	1726	829343800000	8134	4217	1	0	1359
84912	1726	829333799000	8135	4218	0	0	1360
84913	1726	829323798000	8136	4219	0	0	1361
84914	1726	829313797000	8137	4220	0	0	1362
84918	1726	829293795000	8140	4221	0	0	1364
84919	1726	829283794000	8140	4221	1	0	1365
84921	1726	829273793000	8142	4222	0	0	1366
84929	1726	829263792000	8147	4223	0	0	1367
84930	1726	829253791000	8147	4223	1	0	1368
84934	1726	829233789000	8150	4225	0	0	1370
84935	1726	829223788000	8150	4225	1	0	1371
84936	1726	827923788000	8150	4225	2	0	1372
84937	1726	827913787000	8150	4225	3	0	1373
84942	1726	827903786000	8152	4226	0	0	1374
84989	1726	827883784000	8156	4228	0	0	1376
84991	1726	827873783000	8158	4229	0	0	1377
84994	1726	827863782000	8161	4230	0	0	1378
84999	1726	827853781000	8163	4231	0	0	1379
85002	1726	827833779000	8166	4232	0	0	\N
85003	1726	827823778000	8167	4233	0	0	\N
85004	1726	827813777000	8167	4233	1	0	\N
85005	1726	827823778000	8168	4233	0	0	\N
85006	1726	827813777000	8168	4233	1	0	\N
85009	1726	827803776000	8170	4234	0	0	\N
85011	1726	827803776000	8172	4234	0	0	\N
85012	1726	827803776000	8173	4234	0	0	\N
85014	1726	827783774000	8175	4236	0	0	\N
85015	1726	827773773000	8175	4236	1	0	\N
85016	1726	827783774000	8176	4236	0	0	\N
85017	1726	827773773000	8176	4236	1	0	\N
85018	1726	827783774000	8177	4236	0	0	\N
85019	1726	827773773000	8177	4236	1	0	\N
85030	1726	827723768000	8183	4240	0	0	\N
85031	1726	827713767000	8183	4240	1	0	\N
85032	1726	827703766000	8183	4240	2	0	\N
85033	1726	827693765000	8183	4240	3	0	\N
85036	1726	827663762000	8186	4243	0	0	\N
85041	1726	827633759000	8191	4246	0	0	\N
85042	1726	827623758000	8192	4247	0	0	\N
85043	1726	827613757000	8192	4247	1	0	\N
85047	1726	827623758000	8195	4248	0	0	\N
85048	1726	827613757000	8195	4248	1	0	\N
85049	1726	827603756000	8195	4248	2	0	\N
85050	1726	827623758000	8196	4248	0	0	\N
85051	1726	827613757000	8196	4248	1	0	\N
85052	1726	827603756000	8196	4248	2	0	\N
85054	1726	827593755000	8198	4249	0	0	\N
85055	1726	827583754000	8199	4250	0	0	\N
85058	1726	826273753000	8202	4252	0	0	\N
85059	1726	824973753000	8202	4252	1	0	\N
85060	1726	824963752000	8202	4252	2	0	\N
85064	1726	826273753000	8204	4252	0	0	\N
85065	1726	824973753000	8204	4252	1	0	\N
85066	1726	824963752000	8204	4252	2	0	\N
85069	1726	824933749000	8207	4255	0	0	\N
85070	1726	824933749000	8208	4255	0	0	\N
85072	1726	829373803000	8210	4216	0	0	\N
85073	1726	829363802000	8210	4216	1	0	\N
85074	1726	829353801000	8210	4216	2	0	\N
85075	1726	829343800000	8210	4216	3	0	\N
85076	1726	829333799000	8210	4216	4	0	\N
85077	1726	829323798000	8210	4216	5	0	\N
85078	1726	829313797000	8210	4216	6	0	\N
85079	1726	829303796000	8210	4216	7	0	\N
85080	1726	829293795000	8210	4216	8	0	\N
85081	1726	829283794000	8210	4216	9	0	\N
85082	1726	829273793000	8210	4216	10	0	\N
85083	1726	829263792000	8210	4216	11	0	\N
85084	1726	829253791000	8210	4216	12	0	\N
85085	1726	829243790000	8210	4216	13	0	\N
85086	1726	829233789000	8210	4216	14	0	\N
85087	1726	829223788000	8210	4216	15	0	\N
85088	1726	827923788000	8210	4216	16	0	\N
85089	1726	827913787000	8210	4216	17	0	\N
85090	1726	827903786000	8210	4216	18	0	\N
85091	1726	827893785000	8210	4216	19	0	\N
85092	1726	827883784000	8210	4216	20	0	\N
85093	1726	827873783000	8210	4216	21	0	\N
85094	1726	827863782000	8210	4216	22	0	\N
85095	1726	827853781000	8210	4216	23	0	\N
85096	1726	827843780000	8210	4216	24	0	\N
85097	1726	827833779000	8210	4216	25	0	\N
85098	1726	827823778000	8210	4216	26	0	\N
85099	1726	827813777000	8210	4216	27	0	\N
85100	1726	827803776000	8210	4216	28	0	\N
85101	1726	827793775000	8210	4216	29	0	\N
85102	1726	827783774000	8210	4216	30	0	\N
85103	1726	827773773000	8210	4216	31	0	\N
85104	1726	827763772000	8210	4216	32	0	\N
85105	1726	827753771000	8210	4216	33	0	\N
85106	1726	827743770000	8210	4216	34	0	\N
85107	1726	827733769000	8210	4216	35	0	\N
85108	1726	827723768000	8210	4216	36	0	\N
85109	1726	827713767000	8210	4216	37	0	\N
85110	1726	827703766000	8210	4216	38	0	\N
85111	1726	827693765000	8210	4216	39	0	\N
85112	1726	827683764000	8210	4216	40	0	\N
85113	1726	827673763000	8210	4216	41	0	\N
85114	1726	827663762000	8210	4216	42	0	\N
85115	1726	827653761000	8210	4216	43	0	\N
85116	1726	827643760000	8210	4216	44	0	\N
85117	1726	827633759000	8210	4216	45	0	\N
85118	1726	827623758000	8210	4216	46	0	\N
85119	1726	827613757000	8210	4216	47	0	\N
85120	1726	827603756000	8210	4216	48	0	\N
85121	1726	827593755000	8210	4216	49	0	\N
85122	1726	827583754000	8210	4216	50	0	\N
85123	1726	827573753000	8210	4216	51	0	\N
85124	1726	826273753000	8210	4216	52	0	\N
85125	1726	824973753000	8210	4216	53	0	\N
85126	1726	824963752000	8210	4216	54	0	\N
85127	1726	824953751000	8210	4216	55	0	\N
85128	1726	824943750000	8210	4216	57	0	\N
85129	1726	824933749000	8210	4216	58	0	\N
85133	1726	824893745000	8213	4258	0	0	\N
85136	1726	824883744000	8216	4259	0	0	\N
85008	1726	827813777000	8169	4233	1	0	1383
85010	1726	827803776000	8171	4234	0	0	1384
85013	1726	827793775000	8174	4235	0	0	1385
85020	1726	827783774000	8178	4236	0	0	1386
85021	1726	827773773000	8178	4236	1	0	1387
85023	1726	827753771000	8180	4238	0	0	1389
85024	1726	827743770000	8181	4239	0	0	1390
85025	1726	827733769000	8181	4239	1	0	1391
85026	1726	827723768000	8182	4240	0	0	1392
85027	1726	827713767000	8182	4240	1	0	1393
85029	1726	827693765000	8182	4240	3	0	1395
85034	1726	827683764000	8184	4241	0	0	1396
85035	1726	827673763000	8185	4242	0	0	1397
85037	1726	827663762000	8187	4243	0	0	1398
85039	1726	827643760000	8189	4245	0	0	1400
85040	1726	827633759000	8190	4246	0	0	1401
85044	1726	827623758000	8194	4248	0	0	1402
85045	1726	827613757000	8194	4248	1	0	1403
85046	1726	827603756000	8194	4248	2	0	1404
85056	1726	827583754000	8200	4250	0	0	1406
85057	1726	827573753000	8201	4251	0	0	1407
85061	1726	826273753000	8203	4252	0	0	1408
85062	1726	824973753000	8203	4252	1	0	1409
85063	1726	824963752000	8203	4252	2	0	1410
85068	1726	824943750000	8206	4254	0	0	1412
85071	1726	824933749000	8209	4255	0	0	1413
85130	1726	824923748000	8211	4256	0	0	1414
85131	1726	824913747000	8212	4257	0	0	1415
85134	1726	824893745000	8214	4258	0	0	1417
85135	1726	824883744000	8215	4259	0	0	1418
85139	1726	824873743000	8218	4260	0	0	\N
85140	1726	823573743000	8218	4260	1	0	\N
85141	1726	824873743000	8219	4260	0	0	\N
85142	1726	823573743000	8219	4260	1	0	\N
85143	1726	824873743000	8220	4260	0	0	\N
85144	1726	823573743000	8220	4260	1	0	\N
85147	1726	823553741000	8223	4262	0	0	\N
85148	1726	823543740000	8224	4263	0	0	\N
85150	1726	823533739000	8226	4264	0	0	\N
85152	1726	823533739000	8228	4264	0	0	\N
85157	1726	823513737000	8231	4266	0	0	\N
85158	1726	823503736000	8231	4266	1	0	\N
85159	1726	823493735000	8231	4266	2	0	\N
85160	1726	823513737000	8232	4266	0	0	\N
85161	1726	823503736000	8232	4266	1	0	\N
85162	1726	823493735000	8232	4266	2	0	\N
85163	1726	823513737000	8233	4266	0	0	\N
85164	1726	823503736000	8233	4266	1	0	\N
85165	1726	823493735000	8233	4266	2	0	\N
85166	1726	823513737000	8234	4266	0	0	\N
85167	1726	823503736000	8234	4266	1	0	\N
85168	1726	823493735000	8234	4266	2	0	\N
85172	1726	823453731000	8238	4269	0	0	\N
85173	1726	823453731000	8239	4269	0	0	\N
85174	1726	823453731000	8240	4269	0	0	\N
85175	1726	823453731000	8242	4269	0	0	\N
85179	1726	823453731000	8244	4270	0	0	\N
85180	1726	823443730000	8244	4270	1	0	\N
85181	1726	823453731000	8245	4270	0	0	\N
85182	1726	823443730000	8245	4270	1	0	\N
85183	1726	823433729000	8245	4270	3	0	\N
85184	1726	823453731000	8246	4270	0	0	\N
85185	1726	823443730000	8246	4270	1	0	\N
85186	1726	823433729000	8246	4270	3	0	\N
85188	1726	823423728000	8248	4271	0	0	\N
85190	1726	823403726000	8250	4273	0	0	\N
85191	1726	823403726000	8251	4273	0	0	\N
85192	1726	823403726000	8252	4273	0	0	\N
85194	1726	823393725000	8254	4274	0	0	\N
85195	1521	2877099000000	8254	4274	1	0	\N
85198	1726	823393725000	8256	4274	0	0	\N
85199	1521	2877099000000	8256	4274	1	0	\N
85201	1726	823373723000	8259	4277	0	0	\N
85202	1726	823363722000	8259	4277	1	0	\N
85205	1726	823373723000	8261	4277	0	0	\N
85206	1726	823363722000	8261	4277	1	0	\N
85213	1929	1300000000	8263	4278	0	0	\N
85214	1726	823353721000	8263	4278	1	0	\N
85215	1726	823343720000	8263	4278	2	0	\N
85216	1726	823333719000	8263	4278	3	0	\N
85217	1726	823323718000	8263	4278	4	0	\N
85218	1726	823313717000	8263	4278	5	0	\N
85226	1726	823273713000	8267	4281	0	0	\N
85227	1726	823263712000	8267	4281	1	0	\N
85228	1521	2877088000000	8267	4281	2	0	\N
85229	305	66000009000000	8268	4282	0	0	\N
85231	1726	823253711000	8270	4283	0	0	\N
85237	1726	823233709000	8274	4285	0	0	\N
85238	1726	823223708000	8274	4285	1	0	\N
85239	1726	823213707000	8274	4285	2	0	\N
85244	1726	823173703000	8277	4288	0	0	\N
85245	1931	9000000	8277	4288	1	0	\N
85246	1726	823173703000	8278	4288	0	0	\N
85247	1931	9000000	8278	4288	1	0	\N
85248	1726	823173703000	8279	4288	0	0	\N
85249	1931	9000000	8279	4288	1	0	\N
85253	1726	823153701000	8282	4290	0	0	\N
85255	1726	823153701000	8284	4290	0	0	\N
85256	1726	823153701000	8285	4290	0	0	\N
85260	1726	823113697000	8288	4293	0	0	\N
85261	1596	13837435000000	8288	4293	1	0	\N
85264	1726	823103696000	8290	4294	0	0	\N
85265	1726	823093695000	8290	4294	1	0	\N
85266	1521	1599000000	8290	4294	2	0	\N
85270	1726	823083694000	8293	4295	0	0	\N
85271	1726	823073693000	8293	4295	1	0	\N
85272	1726	823083694000	8294	4295	0	0	\N
85145	1726	823563742000	8221	4261	0	0	1421
85146	1726	823553741000	8222	4262	0	0	1422
85149	1726	823543740000	8225	4263	0	0	1423
85151	1726	823533739000	8227	4264	0	0	1424
85153	1726	823523738000	8229	4265	0	0	1425
85155	1726	823503736000	8230	4266	1	0	1427
85156	1726	823493735000	8230	4266	2	0	1428
85169	1726	823483734000	8235	4267	0	0	1429
85170	1726	823473733000	8235	4267	1	0	1430
85171	1726	823463732000	8237	4268	0	0	1431
85177	1726	823443730000	8243	4270	1	0	1433
85178	1726	823433729000	8243	4270	3	0	1434
85187	1726	823423728000	8247	4271	0	0	1435
85189	1726	823413727000	8249	4272	0	0	1436
85196	1726	823393725000	8255	4274	0	0	1438
85197	1521	2877099000000	8255	4274	1	0	2
85200	1726	823383724000	8258	4276	0	0	1439
85203	1726	823373723000	8260	4277	0	0	1440
85204	1726	823363722000	8260	4277	1	0	1441
85208	1726	823353721000	8262	4278	1	0	1442
85209	1726	823343720000	8262	4278	2	0	1443
85210	1726	823333719000	8262	4278	3	0	1444
85211	1726	823323718000	8262	4278	4	0	1445
85212	1726	823313717000	8262	4278	5	0	1446
85220	310	66000009000000	8264	4279	1	0	1
85221	1726	823293715000	8265	4280	0	0	1448
85222	1726	823283714000	8265	4280	1	0	1449
85223	1726	823273713000	8266	4281	0	0	1450
85225	1521	2877088000000	8266	4281	2	0	3
85230	305	66000009000000	8269	4282	0	0	1
85232	1726	823253711000	8271	4283	0	0	1452
85233	1726	823243710000	8272	4284	0	0	1453
85234	1726	823233709000	8273	4285	0	0	1454
85236	1726	823213707000	8273	4285	2	0	1456
85240	1726	823203706000	8275	4286	0	0	1457
85241	1726	823193705000	8275	4286	1	0	1458
85242	1521	2876077000000	8275	4286	2	0	4
85243	1726	823183704000	8276	4287	0	0	1459
85251	1931	9000000	8280	4288	1	0	1
85252	1726	823163702000	8281	4289	0	0	1461
85254	1726	823153701000	8283	4290	0	0	1462
85257	1726	823143700000	8286	4291	0	0	1463
85259	1726	823123698000	8287	4292	0	0	1465
85262	1726	823113697000	8289	4293	0	0	1466
85263	1596	13837435000000	8289	4293	1	0	6
85267	1726	823103696000	8291	4294	0	0	1467
85268	1726	823093695000	8291	4294	1	0	1468
85273	1726	823073693000	8294	4295	1	0	\N
85276	1726	823083694000	8296	4295	0	0	\N
85277	1726	823073693000	8296	4295	1	0	\N
85278	262	66000099000000	8297	4296	0	0	\N
85281	1726	823053691000	8299	4297	0	0	\N
85282	1726	823053691000	8300	4297	0	0	\N
85284	1726	823043690000	8302	4298	0	0	\N
85285	1541	7917237000000	8302	4298	1	0	\N
85288	1726	823033689000	8304	4299	0	0	\N
85289	1726	823033689000	8305	4299	0	0	\N
85290	1726	823033689000	8306	4299	0	0	\N
85292	1726	821733689000	8308	4300	0	0	\N
85293	1726	821723688000	8308	4300	1	0	\N
85294	1521	1588000000	8308	4300	2	0	\N
85298	1726	827873783000	8310	4229	0	0	\N
85299	1726	827863782000	8310	4229	1	0	\N
85300	1726	827853781000	8310	4229	2	0	\N
85301	1726	827843780000	8310	4229	3	0	\N
85302	1726	827833779000	8310	4229	4	0	\N
85303	1726	827823778000	8310	4229	5	0	\N
85304	1726	827813777000	8310	4229	6	0	\N
85305	1726	827803776000	8310	4229	7	0	\N
85306	1726	827793775000	8310	4229	8	0	\N
85307	1726	827783774000	8310	4229	10	0	\N
85308	1726	827773773000	8310	4229	11	0	\N
85309	1726	827763772000	8310	4229	12	0	\N
85310	1726	827753771000	8310	4229	13	0	\N
85311	1726	827743770000	8310	4229	14	0	\N
85312	1726	827733769000	8310	4229	15	0	\N
85313	1726	827723768000	8310	4229	16	0	\N
85314	1726	827713767000	8310	4229	17	0	\N
85315	1726	827703766000	8310	4229	18	0	\N
85316	1726	827693765000	8310	4229	19	0	\N
85317	1726	827683764000	8310	4229	20	0	\N
85318	1726	827673763000	8310	4229	21	0	\N
85319	1726	827663762000	8310	4229	22	0	\N
85320	1726	827653761000	8310	4229	23	0	\N
85321	1726	827643760000	8310	4229	24	0	\N
85322	1726	827633759000	8310	4229	25	0	\N
85323	1726	827623758000	8310	4229	26	0	\N
85324	1726	827613757000	8310	4229	27	0	\N
85325	1726	827603756000	8310	4229	28	0	\N
85326	1726	827593755000	8310	4229	29	0	\N
85327	1726	827583754000	8310	4229	30	0	\N
85328	1726	827573753000	8310	4229	31	0	\N
85329	1726	826273753000	8310	4229	32	0	\N
85330	1726	824973753000	8310	4229	33	0	\N
85331	1726	824963752000	8310	4229	34	0	\N
85332	1726	824953751000	8310	4229	35	0	\N
85333	1726	824943750000	8310	4229	36	0	\N
85334	1726	824933749000	8310	4229	37	0	\N
85335	1726	824923748000	8310	4229	38	0	\N
85336	1726	824913747000	8310	4229	39	0	\N
85337	1726	824903746000	8310	4229	40	0	\N
85338	1726	824893745000	8310	4229	41	0	\N
85339	1726	824883744000	8310	4229	42	0	\N
85340	1726	824873743000	8310	4229	43	0	\N
85341	1726	823573743000	8310	4229	44	0	\N
85342	1726	823563742000	8310	4229	45	0	\N
85343	1726	823553741000	8310	4229	46	0	\N
85344	1726	823543740000	8310	4229	47	0	\N
85345	1726	823533739000	8310	4229	48	0	\N
85346	1726	823523738000	8310	4229	49	0	\N
85347	1726	823513737000	8310	4229	50	0	\N
85348	1726	823503736000	8310	4229	51	0	\N
85349	1726	823493735000	8310	4229	52	0	\N
85350	1726	823483734000	8310	4229	53	0	\N
85351	1726	823473733000	8310	4229	54	0	\N
85352	1726	823463732000	8310	4229	55	0	\N
85353	1726	823453731000	8310	4229	56	0	\N
85354	1726	823443730000	8310	4229	57	0	\N
85355	1726	823433729000	8310	4229	58	0	\N
85356	1726	823423728000	8310	4229	59	0	\N
85357	1726	823413727000	8310	4229	60	0	\N
85358	1726	823403726000	8310	4229	61	0	\N
85359	1726	823393725000	8310	4229	62	0	\N
85360	1726	823383724000	8310	4229	63	0	\N
85361	1726	823373723000	8310	4229	64	0	\N
85362	1726	823363722000	8310	4229	65	0	\N
85363	1726	823353721000	8310	4229	66	0	\N
85364	1726	823343720000	8310	4229	67	0	\N
85365	1726	823333719000	8310	4229	68	0	\N
85366	1726	823323718000	8310	4229	69	0	\N
85367	1726	823313717000	8310	4229	70	0	\N
85368	1726	823303716000	8310	4229	71	0	\N
85369	1726	823293715000	8310	4229	72	0	\N
85370	1726	823283714000	8310	4229	73	0	\N
85371	1726	823273713000	8310	4229	74	0	\N
85372	1726	823263712000	8310	4229	75	0	\N
85373	1726	823253711000	8310	4229	76	0	\N
85374	1726	823243710000	8310	4229	77	0	\N
85375	1726	823233709000	8310	4229	78	0	\N
85376	1726	823223708000	8310	4229	79	0	\N
85377	1726	823213707000	8310	4229	80	0	\N
85378	1726	823203706000	8310	4229	81	0	\N
85379	1726	823193705000	8310	4229	82	0	\N
85380	1726	823183704000	8310	4229	83	0	\N
85381	1726	823173703000	8310	4229	84	0	\N
85382	1726	823163702000	8310	4229	85	0	\N
85383	1726	823153701000	8310	4229	86	0	\N
85384	1726	823143700000	8310	4229	87	0	\N
85385	1726	823133699000	8310	4229	88	0	\N
85386	1726	823123698000	8310	4229	89	0	\N
85387	1726	823113697000	8310	4229	90	0	\N
85388	1726	823103696000	8310	4229	91	0	\N
85389	1726	823093695000	8310	4229	92	0	\N
85390	1726	823083694000	8310	4229	93	0	\N
85391	1726	823073693000	8310	4229	94	0	\N
85392	1726	823063692000	8310	4229	95	0	\N
85393	1726	823053691000	8310	4229	96	0	\N
85394	1726	823043690000	8310	4229	97	0	\N
85395	1726	823033689000	8310	4229	98	0	\N
85396	1596	13837435000000	8310	4229	99	0	\N
85397	262	66000099000000	8310	4229	100	0	\N
85398	1521	2157089000000	8310	4229	101	0	\N
85399	1521	2157078000000	8310	4229	102	0	\N
85400	1541	7917237000000	8310	4229	103	0	\N
85401	1521	2156067000000	8310	4229	104	0	\N
85402	1726	821713687000	8311	4301	0	0	\N
85279	1726	823063692000	8298	4296	0	0	1471
85280	262	66000099000000	8298	4296	1	0	1
85283	1726	823053691000	8301	4297	0	0	1472
85286	1726	823043690000	8303	4298	0	0	1473
85287	1541	7917237000000	8303	4298	1	0	3
85295	1726	821733689000	8309	4300	0	0	1475
85296	1726	821723688000	8309	4300	1	0	1476
85297	1521	1588000000	8309	4300	2	0	6
85403	1726	821713687000	8312	4301	0	0	1477
85404	1726	821703686000	8313	4302	0	0	1478
85406	1541	36000000	8313	4302	2	0	4
85407	1726	821683684000	8314	4303	0	0	1480
85408	342	66001100000000	8316	4305	0	0	1
85413	342	66001100000000	8317	4305	0	0	\N
85414	1726	821673683000	8317	4305	1	0	\N
85415	1726	821663682000	8317	4305	2	0	\N
85416	1726	821653681000	8317	4305	3	0	\N
85417	1718	10077439000000	8317	4305	4	0	\N
85418	342	66001100000000	8318	4305	0	0	\N
85419	1726	821673683000	8318	4305	1	0	\N
85420	1726	821663682000	8318	4305	2	0	\N
85421	1726	821653681000	8318	4305	3	0	\N
85422	1718	10077439000000	8318	4305	4	0	\N
85424	166	66000009000000	8320	4307	0	0	\N
85426	166	66000009000000	8322	4307	0	0	\N
85429	1726	821613677000	8324	4309	0	0	\N
85430	1726	821603676000	8324	4309	1	0	\N
85433	1726	821593675000	8326	4310	0	0	\N
85435	1726	821593675000	8328	4310	0	0	\N
85445	1726	821503666000	8337	4318	0	0	\N
85446	1726	821493665000	8339	4319	0	0	\N
85447	1726	821493665000	8340	4319	0	0	\N
85448	1726	821493665000	8341	4319	0	0	\N
85452	1726	821493665000	8343	4320	0	0	\N
85453	1726	821483664000	8343	4320	1	0	\N
85454	1726	820183664000	8343	4320	2	0	\N
85463	1726	813643660000	8347	4324	0	0	\N
85464	1726	813633659000	8347	4324	1	0	\N
85465	1449	710024000459	8347	4324	2	0	\N
85466	1726	813643660000	8348	4324	0	0	\N
85467	1726	813633659000	8348	4324	1	0	\N
85468	1449	710024000459	8348	4324	2	0	\N
85472	1726	813623658000	8350	4325	0	0	\N
85473	1726	813613657000	8350	4325	1	0	\N
85474	1769	1821900000	8350	4325	2	0	\N
85475	1726	813623658000	8351	4325	0	0	\N
85476	1726	813613657000	8351	4325	1	0	\N
85477	1769	1821900000	8351	4325	2	0	\N
85481	1726	813623658000	8353	4325	0	0	\N
85482	1726	813613657000	8353	4325	1	0	\N
85483	1769	1821900000	8353	4325	2	0	\N
85488	1726	813573653000	8355	4327	0	0	\N
85489	1726	813563652000	8355	4327	1	0	\N
85494	1726	813553651000	8358	4328	0	0	\N
85495	1769	1720900000	8358	4328	1	0	\N
85505	1726	813453641000	8364	4334	0	0	\N
85508	1726	813433639000	8367	4336	0	0	\N
85510	1726	813433639000	8369	4336	0	0	\N
85514	1726	813403636000	8372	4338	0	0	\N
85524	1934	0	8377	4342	0	0	\N
85525	1941	470000000	8377	4342	1	0	\N
85526	1726	813363632000	8377	4342	2	0	\N
85527	1726	813353631000	8377	4342	3	0	\N
85528	1934	0	8378	4342	0	0	\N
85529	1941	470000000	8378	4342	1	0	\N
85530	1726	813363632000	8378	4342	2	0	\N
85531	1726	813353631000	8378	4342	3	0	\N
85532	1934	0	8379	4342	0	0	\N
85533	1941	470000000	8379	4342	1	0	\N
85534	1726	813363632000	8379	4342	2	0	\N
85535	1726	813353631000	8379	4342	3	0	\N
85536	1934	0	8380	4342	0	0	\N
85537	1941	470000000	8380	4342	1	0	\N
85538	1726	813363632000	8380	4342	2	0	\N
85539	1726	813353631000	8380	4342	3	0	\N
85540	1726	813343630000	8381	4343	0	0	\N
85541	1726	813333629000	8381	4343	1	0	\N
85411	1726	821653681000	8316	4305	3	0	1483
85412	1718	10077439000000	8316	4305	4	0	1
85423	1726	821643680000	8319	4306	0	0	1484
85425	166	66000009000000	8321	4307	0	0	1
85427	1726	821633679000	8323	4308	0	0	1485
85431	1726	821613677000	8325	4309	0	0	1487
85432	1726	821603676000	8325	4309	1	0	1488
85434	1726	821593675000	8327	4310	0	0	1489
85436	1726	821583674000	8329	4311	0	0	1490
85437	1726	821573673000	8330	4312	0	0	1491
85439	1726	821553671000	8332	4314	0	0	1493
85440	1726	821543670000	8333	4315	0	0	1494
85441	1726	821533669000	8334	4316	0	0	1495
85442	1726	821523668000	8335	4317	0	0	1496
85444	1726	821503666000	8336	4318	0	0	1498
85449	1726	821493665000	8342	4320	0	0	1499
85450	1726	821483664000	8342	4320	1	0	1500
85451	1726	820183664000	8342	4320	2	0	1501
85455	1726	818883664000	8344	4321	0	0	1502
85457	1726	817573663000	8344	4321	2	0	1504
85458	1726	816273663000	8344	4321	3	0	1505
85459	1726	814973663000	8344	4321	4	0	1506
85460	1726	813673663000	8344	4321	5	0	1507
85461	1726	813663662000	8345	4322	0	0	1508
85469	1726	813643660000	8349	4324	0	0	1510
85470	1726	813633659000	8349	4324	1	0	1511
85471	1449	710024000459	8349	4324	2	0	1
85478	1726	813623658000	8352	4325	0	0	1512
85480	1769	1821900000	8352	4325	2	0	21
85484	1726	813603656000	8354	4326	0	0	1514
85485	1726	813593655000	8354	4326	1	0	1515
85486	1726	813583654000	8354	4326	2	0	1516
85487	1936	199000000	8354	4326	3	0	1
85491	1726	813563652000	8356	4327	1	0	1518
85492	1726	813553651000	8357	4328	0	0	1519
85493	1769	1720900000	8357	4328	1	0	22
85496	1726	813543650000	8359	4329	0	0	1520
85497	1726	813533649000	8359	4329	1	0	1521
85499	1726	813513647000	8360	4330	1	0	1523
85500	1726	813503646000	8361	4331	0	0	1524
85501	1726	813493645000	8361	4331	1	0	1525
85502	1726	813483644000	8362	4332	0	0	1526
85504	1726	813463642000	8363	4333	1	0	1528
85506	1726	813453641000	8365	4334	0	0	1529
85507	1726	813443640000	8366	4335	0	0	1530
85509	1726	813433639000	8368	4336	0	0	1531
85511	1726	813423638000	8370	4337	0	0	1532
85513	1726	813403636000	8371	4338	0	0	1534
85515	1726	813393635000	8373	4339	0	0	1535
85516	1511	718501000000	8373	4339	1	0	1
85517	1726	813383634000	8374	4340	0	0	1536
85518	1726	813373633000	8375	4341	0	0	1537
85520	1934	0	8376	4342	0	0	2
85521	1941	470000000	8376	4342	1	0	1
85522	1726	813363632000	8376	4342	2	0	1538
85523	1726	813353631000	8376	4342	3	0	1539
85543	1726	813333629000	8382	4343	1	0	1541
85544	1726	813323628000	8383	4344	0	0	1542
85549	1726	813293625000	8384	4345	0	0	\N
85552	1726	813283624000	8387	4346	0	0	\N
85553	1726	827833779000	8388	4232	0	0	\N
85554	1726	827823778000	8388	4232	1	0	\N
85555	1726	827813777000	8388	4232	2	0	\N
85556	1726	827803776000	8388	4232	3	0	\N
85557	1726	827793775000	8388	4232	4	0	\N
85558	1726	827783774000	8388	4232	5	0	\N
85559	1726	827773773000	8388	4232	6	0	\N
85560	1726	827763772000	8388	4232	7	0	\N
85561	1726	827753771000	8388	4232	8	0	\N
85562	1726	827743770000	8388	4232	9	0	\N
85563	1726	827733769000	8388	4232	10	0	\N
85564	1726	827723768000	8388	4232	11	0	\N
85565	1726	827713767000	8388	4232	12	0	\N
85566	1726	827703766000	8388	4232	13	0	\N
85567	1449	710024000459	8388	4232	14	0	\N
85568	1726	827693765000	8388	4232	15	0	\N
85569	1726	827683764000	8388	4232	16	0	\N
85570	1726	827673763000	8388	4232	17	0	\N
85571	1726	827663762000	8388	4232	18	0	\N
85572	1726	827653761000	8388	4232	19	0	\N
85573	1726	827643760000	8388	4232	20	0	\N
85574	1726	827633759000	8388	4232	21	0	\N
85575	1726	827623758000	8388	4232	22	0	\N
85576	1726	827613757000	8388	4232	23	0	\N
85577	1726	827603756000	8388	4232	24	0	\N
85578	1726	827593755000	8388	4232	25	0	\N
85579	1726	827583754000	8388	4232	26	0	\N
85580	1726	827573753000	8388	4232	27	0	\N
85581	1726	826273753000	8388	4232	28	0	\N
85582	1726	824973753000	8388	4232	29	0	\N
85583	1726	824963752000	8388	4232	30	0	\N
85584	1726	824953751000	8388	4232	31	0	\N
85585	1726	824943750000	8388	4232	32	0	\N
85586	1726	824933749000	8388	4232	33	0	\N
85587	1726	824923748000	8388	4232	34	0	\N
85588	1726	824913747000	8388	4232	35	0	\N
85589	1726	824903746000	8388	4232	36	0	\N
85590	1726	824893745000	8388	4232	37	0	\N
85591	1726	824883744000	8388	4232	38	0	\N
85592	1726	824873743000	8388	4232	39	0	\N
85593	1726	823573743000	8388	4232	40	0	\N
85594	1726	823563742000	8388	4232	41	0	\N
85595	1726	823553741000	8388	4232	42	0	\N
85596	1726	823543740000	8388	4232	43	0	\N
85597	1726	823533739000	8388	4232	44	0	\N
85598	1726	823523738000	8388	4232	45	0	\N
85599	1726	823513737000	8388	4232	46	0	\N
85600	1726	823503736000	8388	4232	47	0	\N
85601	1726	823493735000	8388	4232	48	0	\N
85602	1726	823483734000	8388	4232	49	0	\N
85603	1726	823473733000	8388	4232	50	0	\N
85604	1726	823463732000	8388	4232	51	0	\N
85605	1726	823453731000	8388	4232	52	0	\N
85606	1726	823443730000	8388	4232	53	0	\N
85607	1726	823433729000	8388	4232	54	0	\N
85608	1726	823423728000	8388	4232	55	0	\N
85609	1726	823413727000	8388	4232	56	0	\N
85610	1726	823403726000	8388	4232	57	0	\N
85611	1726	823393725000	8388	4232	58	0	\N
85612	1726	823383724000	8388	4232	59	0	\N
85613	1726	823373723000	8388	4232	60	0	\N
85614	1726	823363722000	8388	4232	61	0	\N
85615	1726	823353721000	8388	4232	62	0	\N
85616	1726	823343720000	8388	4232	63	0	\N
85617	1726	823333719000	8388	4232	64	0	\N
85618	1726	823323718000	8388	4232	65	0	\N
85619	1726	823313717000	8388	4232	66	0	\N
85620	1726	823303716000	8388	4232	67	0	\N
85621	1726	823293715000	8388	4232	68	0	\N
85622	1726	823283714000	8388	4232	69	0	\N
85623	1726	823273713000	8388	4232	70	0	\N
85624	1726	823263712000	8388	4232	71	0	\N
85625	1726	823253711000	8388	4232	72	0	\N
85626	1726	823243710000	8388	4232	73	0	\N
85627	1726	823233709000	8388	4232	74	0	\N
85628	1726	823223708000	8388	4232	75	0	\N
85629	1726	823213707000	8388	4232	76	0	\N
85630	1726	823203706000	8388	4232	77	0	\N
85631	1726	823193705000	8388	4232	78	0	\N
85632	1726	823183704000	8388	4232	79	0	\N
85633	1726	823173703000	8388	4232	80	0	\N
85634	1726	823163702000	8388	4232	81	0	\N
85635	1726	823153701000	8388	4232	82	0	\N
85636	1726	823143700000	8388	4232	83	0	\N
85637	1726	823133699000	8388	4232	84	0	\N
85638	1726	823123698000	8388	4232	85	0	\N
85639	1726	823113697000	8388	4232	86	0	\N
85640	1726	823103696000	8388	4232	87	0	\N
85641	1726	823093695000	8388	4232	88	0	\N
85642	1726	823083694000	8388	4232	89	0	\N
85643	1726	823073693000	8388	4232	90	0	\N
85644	1726	823063692000	8388	4232	91	0	\N
85645	1726	823053691000	8388	4232	92	0	\N
85646	1726	823043690000	8388	4232	93	0	\N
85647	1726	823033689000	8388	4232	94	0	\N
85648	1726	821733689000	8388	4232	95	0	\N
85649	1726	821723688000	8388	4232	96	0	\N
85650	1726	821713687000	8388	4232	97	0	\N
85651	1726	821703686000	8388	4232	98	0	\N
85652	1726	821693685000	8388	4232	99	0	\N
85653	1726	821683684000	8388	4232	100	0	\N
85654	1726	821673683000	8388	4232	101	0	\N
85655	1726	821663682000	8388	4232	102	0	\N
85656	1726	821653681000	8388	4232	103	0	\N
85657	1726	821643680000	8388	4232	104	0	\N
85658	1726	821633679000	8388	4232	105	0	\N
85659	1726	821623678000	8388	4232	106	0	\N
85660	1726	821613677000	8388	4232	107	0	\N
85661	1726	821603676000	8388	4232	108	0	\N
85662	1726	821593675000	8388	4232	109	0	\N
85663	1726	821583674000	8388	4232	110	0	\N
85664	1726	821573673000	8388	4232	111	0	\N
85665	1726	821563672000	8388	4232	112	0	\N
85666	1726	821553671000	8388	4232	113	0	\N
85667	1726	821543670000	8388	4232	114	0	\N
85668	1726	821533669000	8388	4232	115	0	\N
85669	1726	821523668000	8388	4232	116	0	\N
85670	1726	821513667000	8388	4232	117	0	\N
85671	1726	821503666000	8388	4232	118	0	\N
85672	1726	821493665000	8388	4232	119	0	\N
85673	1726	821483664000	8388	4232	120	0	\N
85674	1726	820183664000	8388	4232	121	0	\N
85675	1726	818883664000	8388	4232	122	0	\N
85676	1726	818873663000	8388	4232	123	0	\N
85677	1726	817573663000	8388	4232	124	0	\N
85678	1726	816273663000	8388	4232	125	0	\N
85547	1511	0	8383	4344	3	0	2
85548	903	114218749973438	8383	4344	4	0	1
85550	1726	813293625000	8385	4345	0	0	1545
85551	1726	813283624000	8386	4346	0	0	1546
85679	1726	813273623000	8389	4347	0	0	1547
85681	1726	813273623000	8390	4347	0	0	\N
85682	904	114218749973438	8390	4347	1	0	\N
85685	1726	813253621000	8393	4349	0	0	\N
85686	1726	813243620000	8394	4350	0	0	\N
85687	1941	718966000000	8394	4350	1	0	\N
85688	1726	813243620000	8395	4350	0	0	\N
85689	1941	718966000000	8395	4350	1	0	\N
85694	1726	813213617000	8399	4353	0	0	\N
85696	1726	813203616000	8401	4354	0	0	\N
85698	1726	813203616000	8403	4354	0	0	\N
85700	1726	813183614000	8405	4356	0	0	\N
85702	1726	813183614000	8407	4356	0	0	\N
85705	1726	813163612000	8410	4358	0	0	\N
85706	1726	813153611000	8411	4359	0	0	\N
85707	1726	811853611000	8411	4359	1	0	\N
85708	1726	811843610000	8411	4359	2	0	\N
85712	1726	813153611000	8413	4359	0	0	\N
85713	1726	811853611000	8413	4359	1	0	\N
85714	1726	811843610000	8413	4359	2	0	\N
85720	1726	811833609000	8450	4378	0	0	\N
85721	1726	810533609000	8450	4378	1	0	\N
85722	1726	810523608000	8450	4378	2	0	\N
85723	1726	810513607000	8451	4379	0	0	\N
85726	1726	810503606000	8454	4380	0	0	\N
85728	1726	810483604000	8456	4382	0	0	\N
85729	1726	810483604000	8457	4382	0	0	\N
85731	1726	810483604000	8459	4382	0	0	\N
85732	1511	718501000000	8460	4337	0	0	\N
85733	1511	0	8460	4337	1	0	\N
85734	1726	813423638000	8460	4337	2	0	\N
85735	1726	813413637000	8460	4337	3	0	\N
85736	1726	813403636000	8460	4337	4	0	\N
85737	1726	813393635000	8460	4337	5	0	\N
85738	1726	810473603000	8461	4383	0	0	\N
85742	1726	810443600000	8465	4386	0	0	\N
85744	1726	810443600000	8467	4386	0	0	\N
85750	1726	810433599000	8469	4387	0	0	\N
85751	1726	810423598000	8469	4387	1	0	\N
85752	1726	810413597000	8469	4387	2	0	\N
85753	1726	810403596000	8469	4387	3	0	\N
85754	1726	810383596000	8469	4387	4	0	\N
85756	1726	810373595000	8471	4388	0	0	\N
85757	1726	810363594000	8472	4389	0	0	\N
85759	1726	810363594000	8474	4389	0	0	\N
85764	1726	810333591000	8478	4392	0	0	\N
85765	1726	809123591000	8478	4392	1	0	\N
85766	1726	809113590000	8479	4393	0	0	\N
85770	603	66721010000000	8482	4394	0	0	\N
85771	1726	809103589000	8482	4394	1	0	\N
85772	603	66721010000000	8483	4394	0	0	\N
85773	1726	809103589000	8483	4394	1	0	\N
85774	1726	809093588000	8484	4395	0	0	\N
85775	1726	809083587000	8484	4395	1	0	\N
85776	1726	809093588000	8485	4395	0	0	\N
85777	1726	809083587000	8485	4395	1	0	\N
85781	1726	809073586000	8488	4396	0	0	\N
85783	1726	809053584000	8490	4398	0	0	\N
85784	1543	0	8490	4398	1	0	\N
85785	1726	809043583000	8490	4398	2	0	\N
85789	1726	809033582000	8492	4399	0	0	\N
85791	1726	809023581000	8494	4400	0	0	\N
85793	1726	809013580000	8496	4401	0	0	\N
85794	1726	809013580000	8497	4401	0	0	\N
85797	1726	809003579000	8500	4402	0	0	\N
85798	1726	808993578000	8501	4403	0	0	\N
85803	1726	808963575000	8506	4406	0	0	\N
85805	1726	808953574000	8508	4407	0	0	\N
85806	1726	808953574000	8509	4407	0	0	\N
85808	1726	808933572000	8511	4409	0	0	\N
85812	1726	808903569000	8515	4412	0	0	\N
85814	1726	808893568000	8517	4413	0	0	\N
85815	1726	808883567000	8517	4413	1	0	\N
85816	1726	808893568000	8518	4413	0	0	\N
85690	1726	813243620000	8396	4350	0	0	1550
85691	1941	718966000000	8396	4350	1	0	2
85692	1726	813233619000	8397	4351	0	0	1551
85693	1726	813223618000	8398	4352	0	0	1552
85695	1726	813213617000	8400	4353	0	0	1553
85699	1726	813193615000	8404	4355	0	0	1555
85701	1726	813183614000	8406	4356	0	0	1556
85703	1726	813173613000	8408	4357	0	0	1557
85704	1726	813163612000	8409	4358	0	0	1558
85709	1726	813153611000	8412	4359	0	0	1559
85711	1726	811843610000	8412	4359	2	0	1561
85715	1943	718900000000	8447	4376	0	0	1
85716	1592	9000000	8448	4377	0	0	1
85717	1726	811833609000	8449	4378	0	0	1562
85719	1726	810523608000	8449	4378	2	0	1564
85724	1726	810513607000	8452	4379	0	0	1565
85725	1726	810503606000	8453	4380	0	0	1566
85727	1726	810493605000	8455	4381	0	0	1567
85730	1726	810483604000	8458	4382	0	0	1568
85740	1726	810463602000	8463	4384	0	0	1570
85741	1726	810453601000	8464	4385	0	0	1571
85743	1726	810443600000	8466	4386	0	0	1572
85745	1726	810433599000	8468	4387	0	0	1573
85746	1726	810423598000	8468	4387	1	0	1574
85748	1726	810403596000	8468	4387	3	0	1576
85749	1726	810383596000	8468	4387	4	0	1577
85755	1726	810373595000	8470	4388	0	0	1578
85758	1726	810363594000	8473	4389	0	0	1579
85761	1726	810343592000	8476	4391	0	0	1581
85762	1726	810333591000	8477	4392	0	0	1582
85763	1726	809123591000	8477	4392	1	0	1583
85767	1726	809113590000	8480	4393	0	0	1584
85768	603	66721010000000	8481	4394	0	0	1
85778	1726	809093588000	8486	4395	0	0	1586
85779	1726	809083587000	8486	4395	1	0	1587
85780	1726	809073586000	8487	4396	0	0	1588
85782	1726	809063585000	8489	4397	0	0	1589
85786	1726	809053584000	8491	4398	0	0	1590
85788	1726	809043583000	8491	4398	2	0	1591
85790	1726	809033582000	8493	4399	0	0	1592
85792	1726	809023581000	8495	4400	0	0	1593
85795	1726	809013580000	8498	4401	0	0	1594
85799	1726	808993578000	8502	4403	0	0	1596
85800	1726	808983577000	8503	4404	0	0	1597
85801	1726	808973576000	8504	4405	0	0	1598
85802	1726	808963575000	8505	4406	0	0	1599
85804	1726	808953574000	8507	4407	0	0	1600
85809	1726	808933572000	8512	4409	0	0	1602
85810	1726	808923571000	8513	4410	0	0	1603
85811	1726	808913570000	8514	4411	0	0	1604
85813	1726	808903569000	8516	4412	0	0	1605
85817	1726	808883567000	8518	4413	1	0	\N
85818	1726	808893568000	8519	4413	0	0	\N
85819	1726	808883567000	8519	4413	1	0	\N
85828	1726	808823561000	8524	4417	0	0	\N
85831	1726	808813560000	8527	4418	0	0	\N
85832	1726	808813560000	8528	4418	0	0	\N
85833	1726	808803559000	8530	4419	0	0	\N
85834	1726	808793558000	8530	4419	1	0	\N
85837	1726	808783557000	8532	4420	0	0	\N
85840	1726	808763555000	8535	4422	0	0	\N
85846	1726	808713550000	8538	4424	0	0	\N
85847	1726	808713550000	8539	4424	0	0	\N
85850	1726	808693548000	8542	4426	0	0	\N
85851	1726	808683547000	8542	4426	1	0	\N
85854	1726	808693548000	8544	4426	0	0	\N
85855	1726	808683547000	8544	4426	1	0	\N
85857	1726	808663545000	8546	4428	0	0	\N
85858	1726	808653544000	8546	4428	1	0	\N
85862	1726	808643543000	8549	4429	0	0	\N
85868	1726	808583537000	8557	4435	0	0	\N
85870	1726	808573536000	8559	4436	0	0	\N
85875	1726	808533532000	8563	4439	0	0	\N
85876	1726	808523531000	8563	4439	1	0	\N
85879	1726	808513530000	8565	4440	0	0	\N
85881	1726	808513530000	8567	4440	0	0	\N
85882	1726	808503529000	8568	4441	0	0	\N
85884	1726	808493528000	8570	4442	0	0	\N
85885	1726	808483527000	8570	4442	1	0	\N
85888	1726	808473526000	8572	4443	0	0	\N
85889	1726	808463525000	8572	4443	1	0	\N
85893	1726	808453524000	8575	4444	0	0	\N
85899	1726	808393518000	8580	4449	0	0	\N
85901	1726	808393518000	8582	4449	0	0	\N
85903	603	66001000000000	8584	4367	0	0	\N
85904	1943	718900000000	8584	4367	1	0	\N
85905	1543	0	8584	4367	2	0	\N
85906	1726	811833609000	8584	4367	3	0	\N
85907	1726	810533609000	8584	4367	4	0	\N
85908	1726	810523608000	8584	4367	5	0	\N
85909	1726	810513607000	8584	4367	6	0	\N
85910	1726	810503606000	8584	4367	7	0	\N
85911	1726	810493605000	8584	4367	8	0	\N
85912	1726	810483604000	8584	4367	9	0	\N
85913	1726	810473603000	8584	4367	10	0	\N
85914	1726	810463602000	8584	4367	11	0	\N
85915	1726	810453601000	8584	4367	12	0	\N
85916	1726	810443600000	8584	4367	13	0	\N
85917	1726	810433599000	8584	4367	14	0	\N
85918	1726	810423598000	8584	4367	15	0	\N
85919	1726	810413597000	8584	4367	16	0	\N
85920	1726	810403596000	8584	4367	17	0	\N
85921	1726	810383596000	8584	4367	18	0	\N
85922	1726	810373595000	8584	4367	19	0	\N
85923	1726	810363594000	8584	4367	20	0	\N
85924	1726	810353593000	8584	4367	21	0	\N
85925	1726	810343592000	8584	4367	22	0	\N
85926	1726	810333591000	8584	4367	23	0	\N
85927	1726	809123591000	8584	4367	24	0	\N
85928	1726	809113590000	8584	4367	25	0	\N
85929	1726	809103589000	8584	4367	26	0	\N
85930	1726	809093588000	8584	4367	27	0	\N
85931	1726	809083587000	8584	4367	28	0	\N
85932	1726	809073586000	8584	4367	29	0	\N
85933	1726	809063585000	8584	4367	30	0	\N
85934	1726	809053584000	8584	4367	31	0	\N
85935	1726	809043583000	8584	4367	32	0	\N
85936	1726	809033582000	8584	4367	33	0	\N
85937	1726	809023581000	8584	4367	34	0	\N
85938	1726	809013580000	8584	4367	35	0	\N
85939	1726	809003579000	8584	4367	36	0	\N
85940	1726	808993578000	8584	4367	37	0	\N
85941	1726	808983577000	8584	4367	38	0	\N
85942	1726	808973576000	8584	4367	39	0	\N
85943	1726	808963575000	8584	4367	40	0	\N
85944	1726	808953574000	8584	4367	41	0	\N
85945	1726	808943573000	8584	4367	42	0	\N
85946	1726	808933572000	8584	4367	44	0	\N
85947	1726	808923571000	8584	4367	45	0	\N
85948	1726	808913570000	8584	4367	46	0	\N
85949	1726	808903569000	8584	4367	47	0	\N
85950	1726	808893568000	8584	4367	48	0	\N
85951	1726	808883567000	8584	4367	49	0	\N
85952	1726	808873566000	8584	4367	50	0	\N
85822	1726	808873566000	8521	4414	0	0	1608
85823	1726	808863565000	8522	4415	0	0	1609
85824	1726	808853564000	8522	4415	1	0	1610
85825	1449	10023000459	8522	4415	2	0	2
85826	1726	808843563000	8523	4416	0	0	1611
85829	1726	808823561000	8525	4417	0	0	1613
85830	1726	808813560000	8526	4418	0	0	1614
85835	1726	808803559000	8531	4419	0	0	1615
85836	1726	808793558000	8531	4419	1	0	1616
85838	1726	808783557000	8533	4420	0	0	1617
85841	1726	808763555000	8536	4422	0	0	1619
85842	1726	808753554000	8537	4423	0	0	1620
85843	1726	808743553000	8537	4423	1	0	1621
85844	1726	808733552000	8537	4423	2	0	1622
85848	1726	808713550000	8540	4424	0	0	1624
85849	1726	808703549000	8541	4425	0	0	1625
85852	1726	808693548000	8543	4426	0	0	1626
85853	1726	808683547000	8543	4426	1	0	1627
85856	1726	808673546000	8545	4427	0	0	1628
85860	1726	808653544000	8547	4428	1	0	1630
85861	1726	808643543000	8548	4429	0	0	1631
85863	1726	808633542000	8550	4430	0	0	1632
85864	1726	808623541000	8553	4431	0	0	1633
85865	1726	808613540000	8554	4432	0	0	1634
85867	1726	808593538000	8556	4434	0	0	1636
85869	1726	808583537000	8558	4435	0	0	1637
85871	1726	808573536000	8560	4436	0	0	1638
85872	1726	808563535000	8561	4437	0	0	1639
85874	1726	808543533000	8562	4438	1	0	1641
85877	1726	808533532000	8564	4439	0	0	1642
85878	1726	808523531000	8564	4439	1	0	1643
85880	1726	808513530000	8566	4440	0	0	1644
85883	1726	808503529000	8569	4441	0	0	1645
85887	1726	808483527000	8571	4442	1	0	1647
85890	1726	808473526000	8573	4443	0	0	1648
85891	1726	808463525000	8573	4443	1	0	1649
85892	1726	808453524000	8574	4444	0	0	1650
85894	1726	808443523000	8576	4445	0	0	1651
85896	1726	808423521000	8577	4446	0	0	1653
85897	1726	808413520000	8578	4447	0	0	1654
85898	1726	808403519000	8579	4448	0	0	1655
85900	1726	808393518000	8581	4449	0	0	1656
85953	1726	808863565000	8584	4367	51	0	\N
85954	1726	808853564000	8584	4367	52	0	\N
85955	1726	808843563000	8584	4367	53	0	\N
85956	1726	808833562000	8584	4367	54	0	\N
85957	1726	808823561000	8584	4367	55	0	\N
85958	1726	808813560000	8584	4367	56	0	\N
85959	1726	808803559000	8584	4367	57	0	\N
85960	1726	808793558000	8584	4367	58	0	\N
85961	1726	808783557000	8584	4367	59	0	\N
85962	1726	808773556000	8584	4367	60	0	\N
85963	1726	808763555000	8584	4367	61	0	\N
85964	1726	808753554000	8584	4367	62	0	\N
85965	1726	808743553000	8584	4367	63	0	\N
85966	1726	808733552000	8584	4367	64	0	\N
85967	1726	808723551000	8584	4367	65	0	\N
85968	1726	808713550000	8584	4367	66	0	\N
85969	1726	808703549000	8584	4367	67	0	\N
85970	1726	808693548000	8584	4367	68	0	\N
85971	1726	808683547000	8584	4367	69	0	\N
85972	1726	808673546000	8584	4367	70	0	\N
85973	1726	808663545000	8584	4367	71	0	\N
85974	1726	808653544000	8584	4367	72	0	\N
85975	1726	808643543000	8584	4367	73	0	\N
85976	1726	808633542000	8584	4367	74	0	\N
85977	1726	808623541000	8584	4367	75	0	\N
85978	1726	808613540000	8584	4367	76	0	\N
85979	1726	808603539000	8584	4367	77	0	\N
85980	1726	808593538000	8584	4367	78	0	\N
85981	1726	808583537000	8584	4367	79	0	\N
85982	1726	808573536000	8584	4367	80	0	\N
85983	1726	808563535000	8584	4367	81	0	\N
85984	1726	808553534000	8584	4367	82	0	\N
85985	1726	808543533000	8584	4367	83	0	\N
85986	1726	808533532000	8584	4367	84	0	\N
85987	1726	808523531000	8584	4367	85	0	\N
85988	1726	808513530000	8584	4367	86	0	\N
85989	1726	808503529000	8584	4367	87	0	\N
85990	1726	808493528000	8584	4367	88	0	\N
85991	1726	808483527000	8584	4367	89	0	\N
85992	1726	808473526000	8584	4367	90	0	\N
85993	1726	808463525000	8584	4367	91	0	\N
85994	1726	808453524000	8584	4367	92	0	\N
85995	1726	808443523000	8584	4367	93	0	\N
85996	1726	808433522000	8584	4367	94	0	\N
85997	1726	808423521000	8584	4367	95	0	\N
85998	1726	808413520000	8584	4367	96	0	\N
85999	1726	808403519000	8584	4367	97	0	\N
86000	1726	808393518000	8584	4367	98	0	\N
86001	1726	808383517000	8584	4367	99	0	\N
86002	1449	10023000459	8584	4367	100	0	\N
86003	1592	9000000	8584	4367	101	0	\N
86006	1726	808353514000	8587	4453	0	0	\N
86007	1726	808353514000	8588	4453	0	0	\N
86012	1726	808323511000	8592	4455	0	0	\N
86013	1726	808323511000	8593	4455	0	0	\N
86014	1726	808323511000	8594	4455	0	0	\N
86017	1726	808303509000	8596	4457	0	0	\N
86021	1726	808283507000	8600	4459	0	0	\N
86023	1726	808273506000	8602	4460	0	0	\N
86024	1726	808263505000	8603	4461	0	0	\N
86025	1726	808253504000	8603	4461	1	0	\N
86026	1726	808243503000	8603	4461	2	0	\N
86027	1726	808233502000	8603	4461	3	0	\N
86028	1726	808223501000	8603	4461	4	0	\N
86029	1726	808213500000	8603	4461	5	0	\N
86030	1726	808203499000	8603	4461	6	0	\N
86031	1726	808193498000	8603	4461	8	0	\N
86032	1480	709918000000	8603	4461	9	0	\N
86033	1480	708917000000	8603	4461	10	0	\N
86034	1480	707916000000	8603	4461	11	0	\N
86035	1480	706915000000	8603	4461	12	0	\N
86036	1480	705914000000	8603	4461	13	0	\N
86037	1480	704913000000	8603	4461	14	0	\N
86038	1480	703912000000	8603	4461	15	0	\N
86039	1480	702911000000	8603	4461	16	0	\N
86040	1480	701910000000	8603	4461	17	0	\N
86041	1480	700909000000	8603	4461	18	0	\N
86060	1726	808263505000	8605	4461	0	0	\N
86061	1726	808253504000	8605	4461	1	0	\N
86062	1726	808243503000	8605	4461	2	0	\N
86063	1726	808233502000	8605	4461	3	0	\N
86064	1726	808223501000	8605	4461	4	0	\N
86065	1726	808213500000	8605	4461	5	0	\N
86066	1726	808203499000	8605	4461	6	0	\N
86067	1726	808193498000	8605	4461	8	0	\N
86068	1480	709918000000	8605	4461	9	0	\N
86069	1480	708917000000	8605	4461	10	0	\N
86070	1480	707916000000	8605	4461	11	0	\N
86071	1480	706915000000	8605	4461	12	0	\N
86072	1480	705914000000	8605	4461	13	0	\N
86073	1480	704913000000	8605	4461	14	0	\N
86074	1480	703912000000	8605	4461	15	0	\N
86075	1480	702911000000	8605	4461	16	0	\N
86076	1480	701910000000	8605	4461	17	0	\N
86077	1480	700909000000	8605	4461	18	0	\N
86078	1726	808373516000	8606	4368	0	0	\N
86079	1726	808363515000	8606	4368	1	0	\N
86080	1726	808353514000	8606	4368	2	0	\N
86081	1726	808343513000	8606	4368	3	0	\N
86082	1726	808333512000	8606	4368	4	0	\N
86083	1726	808323511000	8606	4368	5	0	\N
86084	1726	808313510000	8606	4368	6	0	\N
86085	1726	808303509000	8606	4368	7	0	\N
86086	1726	808293508000	8606	4368	8	0	\N
86087	1726	808283507000	8606	4368	9	0	\N
86088	1726	808273506000	8606	4368	10	0	\N
86008	1726	808353514000	8589	4453	0	0	1660
86009	1726	808343513000	8590	4454	0	0	1661
86010	1726	808333512000	8590	4454	1	0	1662
86011	1726	808323511000	8591	4455	0	0	1663
86015	1726	808313510000	8595	4456	0	0	1664
86018	1726	808303509000	8597	4457	0	0	1665
86019	1726	808293508000	8598	4458	0	0	1666
86020	1726	808283507000	8599	4459	0	0	1667
86022	1726	808273506000	8601	4460	0	0	1668
86042	1726	808263505000	8604	4461	0	0	1669
86044	1726	808243503000	8604	4461	2	0	1671
86045	1726	808233502000	8604	4461	3	0	1672
86046	1726	808223501000	8604	4461	4	0	1673
86047	1726	808213500000	8604	4461	5	0	1674
86049	1726	808193498000	8604	4461	8	0	1676
86050	1480	709918000000	8604	4461	9	0	10
86051	1480	708917000000	8604	4461	10	0	11
86052	1480	707916000000	8604	4461	11	0	12
86053	1480	706915000000	8604	4461	12	0	13
86055	1480	704913000000	8604	4461	14	0	15
86056	1480	703912000000	8604	4461	15	0	16
86057	1480	702911000000	8604	4461	16	0	17
86058	1480	701910000000	8604	4461	17	0	18
86059	1480	700909000000	8604	4461	18	0	19
86089	1726	808263505000	8606	4368	11	0	\N
86090	1726	808253504000	8606	4368	12	0	\N
86091	1726	808243503000	8606	4368	13	0	\N
86092	1726	808233502000	8606	4368	14	0	\N
86093	1726	808223501000	8606	4368	15	0	\N
86094	1726	808213500000	8606	4368	16	0	\N
86095	1726	808203499000	8606	4368	17	0	\N
86096	1726	808193498000	8606	4368	18	0	\N
86097	1726	808183497000	8606	4368	19	0	\N
86098	1726	808173496000	8606	4368	20	0	\N
86099	1726	808163495000	8606	4368	21	0	\N
86100	1480	710919000000	8606	4368	22	0	\N
86101	1480	709918000000	8606	4368	23	0	\N
86102	1480	708917000000	8606	4368	24	0	\N
86103	1480	707916000000	8606	4368	25	0	\N
86104	1480	706915000000	8606	4368	26	0	\N
86105	1480	705914000000	8606	4368	27	0	\N
86106	1480	704913000000	8606	4368	28	0	\N
86107	1480	703912000000	8606	4368	29	0	\N
86108	1480	702911000000	8606	4368	30	0	\N
86109	1480	701910000000	8606	4368	31	0	\N
86110	1480	700909000000	8606	4368	32	0	\N
86115	1726	808143493000	8608	4463	0	0	\N
86117	603	66001000000000	8610	4332	0	0	\N
86118	1726	813483644000	8610	4332	1	0	\N
86119	1543	0	8610	4332	2	0	\N
86120	1726	813473643000	8610	4332	3	0	\N
86121	1726	813463642000	8610	4332	4	0	\N
86122	1726	813453641000	8610	4332	5	0	\N
86123	1726	813443640000	8610	4332	6	0	\N
86124	1726	813433639000	8610	4332	7	0	\N
86125	1511	718501000000	8610	4332	8	0	\N
86126	1511	0	8610	4332	9	0	\N
86127	1726	813423638000	8610	4332	10	0	\N
86128	1726	813413637000	8610	4332	11	0	\N
86129	1726	813403636000	8610	4332	12	0	\N
86130	1726	813393635000	8610	4332	13	0	\N
86131	1726	813383634000	8610	4332	14	0	\N
86132	1726	813373633000	8610	4332	15	0	\N
86133	1726	813363632000	8610	4332	16	0	\N
86134	1726	813353631000	8610	4332	17	0	\N
86135	1726	813343630000	8610	4332	18	0	\N
86136	1726	813333629000	8610	4332	19	0	\N
86137	1726	813323628000	8610	4332	20	0	\N
86138	1726	813313627000	8610	4332	21	0	\N
86140	1726	808123491000	8612	4465	0	0	\N
86141	1726	808113490000	8612	4465	1	0	\N
86144	1726	808123491000	8614	4465	0	0	\N
86145	1726	808113490000	8614	4465	1	0	\N
86146	1726	808103489000	8615	4466	0	0	\N
86148	1726	808093488000	8617	4467	0	0	\N
86151	1726	808073486000	8620	4469	0	0	\N
86153	1726	808063485000	8622	4470	0	0	\N
86154	1726	808053484000	8624	4471	0	0	\N
86157	603	66001000000000	8626	4336	0	0	\N
86158	1543	0	8626	4336	1	0	\N
86159	1726	813433639000	8626	4336	2	0	\N
86160	1511	718501000000	8626	4336	3	0	\N
86161	1511	0	8626	4336	4	0	\N
86162	1726	813423638000	8626	4336	5	0	\N
86163	1726	813413637000	8626	4336	6	0	\N
86164	1726	813403636000	8626	4336	7	0	\N
86165	1726	813393635000	8626	4336	8	0	\N
86166	1726	813383634000	8626	4336	10	0	\N
86167	1726	813373633000	8626	4336	11	0	\N
86168	1726	813363632000	8626	4336	12	0	\N
86169	1726	813353631000	8626	4336	13	0	\N
86170	1726	813343630000	8626	4336	14	0	\N
86171	1726	813333629000	8626	4336	15	0	\N
86172	1726	813323628000	8626	4336	16	0	\N
86173	1726	813313627000	8626	4336	17	0	\N
86174	1726	813303626000	8626	4336	18	0	\N
86175	1726	813293625000	8626	4336	19	0	\N
86176	1726	813283624000	8626	4336	20	0	\N
86177	1726	813273623000	8626	4336	21	0	\N
86178	1726	813263622000	8626	4336	22	0	\N
86179	1726	813253621000	8626	4336	23	0	\N
86180	1726	813243620000	8626	4336	24	0	\N
86181	1726	813233619000	8626	4336	25	0	\N
86182	1726	813223618000	8626	4336	26	0	\N
86183	1726	813213617000	8626	4336	27	0	\N
86184	1726	813203616000	8626	4336	28	0	\N
86185	1726	813193615000	8626	4336	29	0	\N
86186	1726	813183614000	8626	4336	30	0	\N
86187	1726	813173613000	8626	4336	31	0	\N
86188	1726	813163612000	8626	4336	32	0	\N
86189	1726	813153611000	8626	4336	33	0	\N
86190	1726	811853611000	8626	4336	34	0	\N
86191	1726	811843610000	8626	4336	35	0	\N
86192	1726	811833609000	8626	4336	36	0	\N
86193	1726	810533609000	8626	4336	37	0	\N
86194	1726	810523608000	8626	4336	38	0	\N
86195	1726	810513607000	8626	4336	39	0	\N
86196	1726	810503606000	8626	4336	40	0	\N
86197	1726	810493605000	8626	4336	41	0	\N
86198	1726	810483604000	8626	4336	42	0	\N
86199	1726	810473603000	8626	4336	43	0	\N
86200	1726	810463602000	8626	4336	44	0	\N
86201	1726	810453601000	8626	4336	45	0	\N
86202	1726	810443600000	8626	4336	46	0	\N
86203	1726	810433599000	8626	4336	47	0	\N
86204	1726	810423598000	8626	4336	48	0	\N
86205	1726	810413597000	8626	4336	49	0	\N
86206	1726	810403596000	8626	4336	50	0	\N
86207	1726	810383596000	8626	4336	51	0	\N
86208	1726	810373595000	8626	4336	52	0	\N
86209	1726	810363594000	8626	4336	53	0	\N
86210	1726	810353593000	8626	4336	54	0	\N
86211	1726	810343592000	8626	4336	55	0	\N
86212	1726	810333591000	8626	4336	56	0	\N
86213	1726	809123591000	8626	4336	57	0	\N
86214	1726	809113590000	8626	4336	58	0	\N
86215	1726	809103589000	8626	4336	59	0	\N
86216	1726	809093588000	8626	4336	60	0	\N
86217	1726	809083587000	8626	4336	61	0	\N
86218	1726	809073586000	8626	4336	62	0	\N
86219	1726	809063585000	8626	4336	63	0	\N
86220	1726	809053584000	8626	4336	64	0	\N
86221	1726	809043583000	8626	4336	65	0	\N
86222	1726	809033582000	8626	4336	66	0	\N
86223	1726	809023581000	8626	4336	67	0	\N
86224	1726	809013580000	8626	4336	68	0	\N
86113	1726	808163495000	8607	4462	2	0	1679
86114	1726	808153494000	8607	4462	3	0	1680
86116	1726	808143493000	8609	4463	0	0	1681
86139	1726	808133492000	8611	4464	0	0	1682
86142	1726	808123491000	8613	4465	0	0	1683
86147	1726	808103489000	8616	4466	0	0	1685
86149	1726	808093488000	8618	4467	0	0	1686
86150	1726	808083487000	8619	4468	0	0	1687
86152	1726	808073486000	8621	4469	0	0	1688
86155	1726	808063485000	8625	4471	0	0	1689
86225	1726	809003579000	8626	4336	69	0	\N
86226	1726	808993578000	8626	4336	70	0	\N
86227	1726	808983577000	8626	4336	71	0	\N
86228	1726	808973576000	8626	4336	72	0	\N
86229	1726	808963575000	8626	4336	73	0	\N
86230	1726	808953574000	8626	4336	74	0	\N
86231	1726	808943573000	8626	4336	75	0	\N
86232	1726	808933572000	8626	4336	76	0	\N
86233	1726	808923571000	8626	4336	77	0	\N
86234	1726	808913570000	8626	4336	78	0	\N
86235	1726	808903569000	8626	4336	79	0	\N
86236	1726	808893568000	8626	4336	80	0	\N
86237	1726	808883567000	8626	4336	81	0	\N
86238	1726	808873566000	8626	4336	82	0	\N
86239	1726	808863565000	8626	4336	83	0	\N
86240	1726	808853564000	8626	4336	84	0	\N
86241	1726	808843563000	8626	4336	85	0	\N
86242	1726	808833562000	8626	4336	86	0	\N
86243	1726	808823561000	8626	4336	87	0	\N
86244	1726	808813560000	8626	4336	88	0	\N
86245	1726	808803559000	8626	4336	89	0	\N
86246	1726	808793558000	8626	4336	90	0	\N
86247	1726	808783557000	8626	4336	91	0	\N
86248	1726	808773556000	8626	4336	92	0	\N
86249	1726	808763555000	8626	4336	93	0	\N
86250	1726	808753554000	8626	4336	94	0	\N
86251	1726	808743553000	8626	4336	95	0	\N
86252	1726	808733552000	8626	4336	96	0	\N
86253	1726	808723551000	8626	4336	97	0	\N
86254	1726	808713550000	8626	4336	98	0	\N
86255	1726	808703549000	8626	4336	99	0	\N
86256	1726	808693548000	8626	4336	100	0	\N
86257	1726	808683547000	8626	4336	101	0	\N
86258	1726	808673546000	8626	4336	102	0	\N
86259	1726	808663545000	8626	4336	103	0	\N
86260	1726	808653544000	8626	4336	104	0	\N
86261	1726	808643543000	8626	4336	105	0	\N
86262	1726	808633542000	8626	4336	106	0	\N
86263	1726	808623541000	8626	4336	107	0	\N
86264	1726	808613540000	8626	4336	108	0	\N
86265	1726	808603539000	8626	4336	109	0	\N
86266	1726	808593538000	8626	4336	110	0	\N
86267	1726	808583537000	8626	4336	111	0	\N
86268	1726	808573536000	8626	4336	112	0	\N
86269	1726	808563535000	8626	4336	113	0	\N
86270	1726	808553534000	8626	4336	114	0	\N
86271	1726	808543533000	8626	4336	115	0	\N
86272	1726	808533532000	8626	4336	116	0	\N
86273	1726	808523531000	8626	4336	117	0	\N
86274	1726	808513530000	8626	4336	118	0	\N
86275	1726	808503529000	8626	4336	119	0	\N
86276	1726	808493528000	8626	4336	120	0	\N
86277	1726	808483527000	8626	4336	121	0	\N
86278	1726	808473526000	8626	4336	122	0	\N
86279	1726	808463525000	8626	4336	123	0	\N
86280	1726	808043483000	8627	4472	0	0	\N
86281	1726	808033482000	8627	4472	1	0	\N
86284	1726	808043483000	8629	4472	0	0	\N
86285	1726	808033482000	8629	4472	1	0	\N
86288	1726	808023481000	8631	4473	0	0	\N
86289	1726	808013480000	8631	4473	1	0	\N
86290	603	66001000000000	8632	4355	0	0	\N
86291	1726	813193615000	8632	4355	1	0	\N
86292	1726	813183614000	8632	4355	2	0	\N
86293	1543	0	8632	4355	3	0	\N
86294	1726	813173613000	8632	4355	4	0	\N
86295	1726	813163612000	8632	4355	5	0	\N
86296	1726	813153611000	8632	4355	6	0	\N
86297	1726	811853611000	8632	4355	7	0	\N
86298	1726	811843610000	8632	4355	8	0	\N
86299	1726	811833609000	8632	4355	9	0	\N
86300	1726	810533609000	8632	4355	10	0	\N
86301	1726	810523608000	8632	4355	11	0	\N
86302	1726	810513607000	8632	4355	12	0	\N
86303	1726	810503606000	8632	4355	13	0	\N
86304	1726	810493605000	8632	4355	14	0	\N
86305	1726	810483604000	8632	4355	15	0	\N
86306	1726	810473603000	8632	4355	16	0	\N
86307	1726	810463602000	8632	4355	17	0	\N
86308	1726	810453601000	8632	4355	18	0	\N
86309	1726	810443600000	8632	4355	19	0	\N
86310	1726	810433599000	8632	4355	20	0	\N
86311	1726	810423598000	8632	4355	21	0	\N
86312	1726	810413597000	8632	4355	22	0	\N
86313	1726	810403596000	8632	4355	23	0	\N
86314	1726	810383596000	8632	4355	24	0	\N
86315	1726	810373595000	8632	4355	25	0	\N
86316	1726	810363594000	8632	4355	26	0	\N
86317	1726	810353593000	8632	4355	27	0	\N
86318	1726	810343592000	8632	4355	28	0	\N
86319	1726	810333591000	8632	4355	29	0	\N
86320	1726	809123591000	8632	4355	30	0	\N
86321	1726	809113590000	8632	4355	31	0	\N
86322	1726	809103589000	8632	4355	32	0	\N
86323	1726	809093588000	8632	4355	33	0	\N
86324	1726	809083587000	8632	4355	34	0	\N
86325	1726	809073586000	8632	4355	35	0	\N
86326	1726	809063585000	8632	4355	36	0	\N
86327	1726	809053584000	8632	4355	37	0	\N
86328	1726	809043583000	8632	4355	38	0	\N
86329	1726	809033582000	8632	4355	39	0	\N
86330	1726	809023581000	8632	4355	40	0	\N
86331	1726	809013580000	8632	4355	41	0	\N
86332	1726	809003579000	8632	4355	42	0	\N
86333	1726	808993578000	8632	4355	43	0	\N
86334	1726	808983577000	8632	4355	44	0	\N
86335	1726	808973576000	8632	4355	45	0	\N
86336	1726	808963575000	8632	4355	46	0	\N
86337	1726	808953574000	8632	4355	47	0	\N
86338	1726	808943573000	8632	4355	48	0	\N
86339	1726	808933572000	8632	4355	49	0	\N
86340	1726	808923571000	8632	4355	50	0	\N
86341	1726	808913570000	8632	4355	51	0	\N
86342	1726	808903569000	8632	4355	52	0	\N
86343	1726	808893568000	8632	4355	53	0	\N
86344	1726	808883567000	8632	4355	54	0	\N
86345	1726	808873566000	8632	4355	55	0	\N
86346	1726	808863565000	8632	4355	56	0	\N
86347	1726	808853564000	8632	4355	57	0	\N
86348	1726	808843563000	8632	4355	58	0	\N
86349	1726	808833562000	8632	4355	59	0	\N
86350	1726	808823561000	8632	4355	60	0	\N
86351	1726	808813560000	8632	4355	61	0	\N
86352	1726	808803559000	8632	4355	62	0	\N
86353	1726	808793558000	8632	4355	63	0	\N
86354	1726	808783557000	8632	4355	64	0	\N
86355	1726	808773556000	8632	4355	65	0	\N
86356	1726	808763555000	8632	4355	66	0	\N
86357	1726	808753554000	8632	4355	68	0	\N
86358	1726	808743553000	8632	4355	69	0	\N
86359	1726	808733552000	8632	4355	70	0	\N
86360	1726	808723551000	8632	4355	71	0	\N
86286	1726	808023481000	8630	4473	0	0	1693
86287	1726	808013480000	8630	4473	1	0	1694
86361	1726	808713550000	8632	4355	72	0	\N
86362	1726	808703549000	8632	4355	73	0	\N
86363	1726	808693548000	8632	4355	74	0	\N
86364	1726	808683547000	8632	4355	75	0	\N
86365	1726	808673546000	8632	4355	76	0	\N
86366	1726	808663545000	8632	4355	77	0	\N
86367	1726	808653544000	8632	4355	78	0	\N
86368	1726	808643543000	8632	4355	79	0	\N
86369	1726	808633542000	8632	4355	80	0	\N
86370	1726	808623541000	8632	4355	81	0	\N
86371	1726	808613540000	8632	4355	82	0	\N
86372	1726	808603539000	8632	4355	83	0	\N
86373	1726	808593538000	8632	4355	84	0	\N
86374	1726	808583537000	8632	4355	85	0	\N
86375	1726	808573536000	8632	4355	86	0	\N
86376	1726	808563535000	8632	4355	87	0	\N
86377	1726	808553534000	8632	4355	88	0	\N
86378	1726	808543533000	8632	4355	89	0	\N
86379	1726	808533532000	8632	4355	90	0	\N
86380	1726	808523531000	8632	4355	91	0	\N
86381	1726	808513530000	8632	4355	92	0	\N
86382	1726	808503529000	8632	4355	93	0	\N
86383	1726	808493528000	8632	4355	94	0	\N
86386	1726	807993478000	8637	4476	0	0	\N
86388	1726	807993478000	8639	4476	0	0	\N
86390	1726	807983477000	8641	4477	0	0	\N
86391	1726	807983477000	8642	4477	0	0	\N
86392	1726	807983477000	8643	4477	0	0	\N
86401	1726	807893468000	8647	4480	0	0	\N
86402	1726	807883467000	8647	4480	1	0	\N
86410	1726	807833462000	8651	4482	0	0	\N
86411	1726	807833462000	8652	4482	0	0	\N
86414	1756	1836499808900	8654	4483	0	0	\N
86415	1726	807823461000	8654	4483	1	0	\N
86416	1726	807813460000	8655	4484	0	0	\N
86417	1726	807813460000	8656	4484	0	0	\N
86418	1726	807813460000	8657	4484	0	0	\N
86420	1726	807813460000	8660	4484	0	0	\N
86421	1726	807803459000	8661	4485	0	0	\N
86422	1726	807803459000	8662	4485	0	0	\N
86424	1726	807803459000	8664	4485	0	0	\N
86439	1397	1391505284000	8680	4498	0	0	\N
86441	238	66000190000000	8682	4450	0	0	\N
86442	1397	1391525286000	8682	4450	1	0	\N
86443	238	66000160000000	8682	4450	2	0	\N
86444	1726	808383517000	8682	4450	3	0	\N
86445	1756	1836499808900	8682	4450	4	0	\N
86446	1726	808373516000	8682	4450	5	0	\N
86447	1726	808363515000	8682	4450	6	0	\N
86448	1726	808353514000	8682	4450	7	0	\N
86449	1726	808343513000	8682	4450	8	0	\N
86450	1726	808333512000	8682	4450	9	0	\N
86451	1726	808323511000	8682	4450	10	0	\N
86452	1726	808313510000	8682	4450	11	0	\N
86453	1726	808303509000	8682	4450	12	0	\N
86454	1397	1391515285000	8682	4450	13	0	\N
86455	1397	1391505284000	8682	4450	14	0	\N
86456	1397	1391495283000	8682	4450	15	0	\N
86457	1726	808293508000	8682	4450	16	0	\N
86458	1726	808283507000	8682	4450	17	0	\N
86459	1726	808273506000	8682	4450	18	0	\N
86460	1726	808263505000	8682	4450	19	0	\N
86461	1726	808253504000	8682	4450	20	0	\N
86462	1726	808243503000	8682	4450	21	0	\N
86463	1726	808233502000	8682	4450	22	0	\N
86464	1726	808223501000	8682	4450	23	0	\N
86465	1726	808213500000	8682	4450	24	0	\N
86466	1726	808203499000	8682	4450	25	0	\N
86467	1726	808193498000	8682	4450	26	0	\N
86468	1726	808183497000	8682	4450	27	0	\N
86469	1726	808173496000	8682	4450	28	0	\N
86470	1726	808163495000	8682	4450	29	0	\N
86471	1726	808153494000	8682	4450	30	0	\N
86472	1726	808143493000	8682	4450	31	0	\N
86473	1726	808133492000	8682	4450	32	0	\N
86474	1726	808123491000	8682	4450	33	0	\N
86475	1726	808113490000	8682	4450	34	0	\N
86476	1726	808103489000	8682	4450	35	0	\N
86477	1726	808093488000	8682	4450	36	0	\N
86478	1726	808083487000	8682	4450	37	0	\N
86479	1726	808073486000	8682	4450	38	0	\N
86480	1726	808063485000	8682	4450	39	0	\N
86481	1726	808053484000	8682	4450	40	0	\N
86482	1726	808043483000	8682	4450	41	0	\N
86483	1726	808033482000	8682	4450	43	0	\N
86484	1726	808023481000	8682	4450	44	0	\N
86485	1726	808013480000	8682	4450	45	0	\N
86486	1726	808003479000	8682	4450	46	0	\N
86487	1726	807993478000	8682	4450	47	0	\N
86488	1726	807983477000	8682	4450	48	0	\N
86489	1726	807973476000	8682	4450	49	0	\N
86490	1726	807963475000	8682	4450	50	0	\N
86491	1726	807953474000	8682	4450	51	0	\N
86492	1726	807943473000	8682	4450	52	0	\N
86493	1726	807933472000	8682	4450	53	0	\N
86494	1726	807923471000	8682	4450	54	0	\N
86495	1726	807913470000	8682	4450	55	0	\N
86496	1726	807903469000	8682	4450	56	0	\N
86387	1726	807993478000	8638	4476	0	0	1696
86389	1726	807983477000	8640	4477	0	0	1697
86393	1726	807973476000	8644	4478	0	0	1698
86394	1726	807963475000	8644	4478	1	0	1699
86395	1726	807953474000	8646	4479	0	0	1700
86397	1726	807933472000	8646	4479	2	0	1702
86398	1726	807923471000	8646	4479	3	0	1703
86399	1726	807913470000	8646	4479	4	0	1704
86400	1726	807903469000	8646	4479	5	0	1705
86403	1726	807893468000	8648	4480	0	0	1706
86405	1726	807873466000	8649	4481	0	0	1708
86406	1726	807863465000	8649	4481	1	0	1709
86407	1726	807853464000	8649	4481	2	0	1710
86408	1726	807843463000	8649	4481	3	0	1711
86412	1756	1836499808900	8653	4483	0	0	2
86413	1726	807823461000	8653	4483	1	0	1713
86419	1726	807813460000	8659	4484	0	0	1714
86423	1726	807803459000	8663	4485	0	0	1715
86425	1726	807793458000	8665	4486	0	0	1716
86427	1726	807773456000	8666	4487	0	0	1718
86428	1726	807763455000	8667	4488	0	0	1719
86429	1726	807753454000	8667	4488	1	0	1720
86430	1726	807743453000	8667	4488	2	0	1721
86431	238	66000160000000	8667	4488	3	0	2
86433	1726	807723451000	8668	4489	1	0	1723
86434	1726	807713450000	8669	4490	0	0	1724
86435	1726	807703449000	8671	4491	0	0	1725
86436	1397	1391525286000	8678	4497	0	0	4731
86438	1397	1391505284000	8679	4498	0	0	4733
86440	1397	1391495283000	8681	4499	0	0	4734
86497	1726	807893468000	8682	4450	57	0	\N
86498	1726	807883467000	8682	4450	58	0	\N
86499	1726	807873466000	8682	4450	59	0	\N
86500	1726	807863465000	8682	4450	60	0	\N
86501	1726	807853464000	8682	4450	61	0	\N
86502	1726	807843463000	8682	4450	62	0	\N
86503	1726	807833462000	8682	4450	63	0	\N
86504	1726	807823461000	8682	4450	64	0	\N
86505	1726	807813460000	8682	4450	65	0	\N
86506	1726	807803459000	8682	4450	66	0	\N
86507	1726	807793458000	8682	4450	67	0	\N
86508	1726	807783457000	8682	4450	68	0	\N
86509	1726	807773456000	8682	4450	69	0	\N
86510	1726	807763455000	8682	4450	70	0	\N
86511	1726	807753454000	8682	4450	71	0	\N
86512	1726	807743453000	8682	4450	72	0	\N
86513	1726	807733452000	8682	4450	73	0	\N
86514	1726	807723451000	8682	4450	74	0	\N
86515	1726	807713450000	8682	4450	75	0	\N
86516	1726	807703449000	8682	4450	76	0	\N
86517	1480	710919000000	8682	4450	77	0	\N
86518	1480	709918000000	8682	4450	78	0	\N
86519	1480	708917000000	8682	4450	79	0	\N
86520	1480	707916000000	8682	4450	80	0	\N
86521	1480	706915000000	8682	4450	81	0	\N
86522	1480	705914000000	8682	4450	82	0	\N
86523	1480	704913000000	8682	4450	83	0	\N
86524	1480	703912000000	8682	4450	84	0	\N
86525	1480	702911000000	8682	4450	85	0	\N
86526	1480	701910000000	8682	4450	86	0	\N
86527	1480	700909000000	8682	4450	87	0	\N
86532	1397	1391465280000	8687	4502	0	0	\N
86533	441	66000010000000	8687	4502	1	0	\N
86534	238	66000190000000	8688	4421	0	0	\N
86535	1397	1391525286000	8688	4421	1	0	\N
86536	238	66000160000000	8688	4421	2	0	\N
86537	1756	1116489808900	8688	4421	3	0	\N
86538	1397	1391515285000	8688	4421	4	0	\N
86539	1397	1391505284000	8688	4421	5	0	\N
86540	1397	1391495283000	8688	4421	6	0	\N
86541	1397	1391485282000	8688	4421	7	0	\N
86542	1397	1391475281000	8688	4421	8	0	\N
86543	1397	1391465280000	8688	4421	9	0	\N
86544	1397	1391455279000	8688	4421	10	0	\N
86545	1480	710919000000	8688	4421	11	0	\N
86546	1480	709918000000	8688	4421	12	0	\N
86550	1397	1391425276000	8692	4506	0	0	\N
86551	1397	1391415275000	8692	4506	1	0	\N
86555	1397	1391395273000	8695	4508	0	0	\N
86557	1397	1391395273000	8697	4508	0	0	\N
86559	1397	1391375271000	8699	4510	0	0	\N
86560	1397	1391375271000	8700	4510	0	0	\N
86567	1397	1391365270000	8703	4511	0	0	\N
86568	1397	1391355269000	8703	4511	1	0	\N
86569	1397	1391345268000	8703	4511	2	0	\N
86570	1397	1391335267000	8703	4511	3	0	\N
86571	640	66000009000000	8703	4511	4	0	\N
86583	1397	1391215255000	8710	4518	0	0	\N
86584	1397	1391205254000	8710	4518	1	0	\N
86585	1397	1391195253000	8710	4518	2	0	\N
86586	1397	1391185252000	8710	4518	3	0	\N
86587	1397	1391175251000	8710	4518	4	0	\N
86588	1726	807693448000	8710	4518	5	0	\N
86589	1726	806483448000	8710	4518	6	0	\N
86590	1726	806473447000	8710	4518	7	0	\N
86601	603	66001000000000	8713	4374	0	0	\N
86602	1943	718900000000	8713	4374	1	0	\N
86603	238	66000190000000	8713	4374	2	0	\N
86604	1397	1391525286000	8713	4374	3	0	\N
86605	1543	0	8713	4374	4	0	\N
86606	238	66000160000000	8713	4374	5	0	\N
86607	1756	396479808900	8713	4374	6	0	\N
86608	1397	1391515285000	8713	4374	7	0	\N
86609	1397	1391505284000	8713	4374	8	0	\N
86610	1397	1391495283000	8713	4374	9	0	\N
86611	1397	1391485282000	8713	4374	10	0	\N
86612	1397	1391475281000	8713	4374	11	0	\N
86613	1397	1391465280000	8713	4374	12	0	\N
86614	1397	1391455279000	8713	4374	13	0	\N
86615	1397	1391445278000	8713	4374	14	0	\N
86616	1726	811833609000	8713	4374	15	0	\N
86617	1726	810533609000	8713	4374	16	0	\N
86618	1726	810523608000	8713	4374	17	0	\N
86619	1726	810513607000	8713	4374	18	0	\N
86620	1726	810503606000	8713	4374	19	0	\N
86621	1726	810493605000	8713	4374	20	0	\N
86622	1726	810483604000	8713	4374	21	0	\N
86623	1726	810473603000	8713	4374	22	0	\N
86624	1726	810463602000	8713	4374	23	0	\N
86625	1726	810453601000	8713	4374	24	0	\N
86626	1726	810443600000	8713	4374	25	0	\N
86627	1726	810433599000	8713	4374	26	0	\N
86628	1726	810423598000	8713	4374	27	0	\N
86629	1726	810413597000	8713	4374	28	0	\N
86630	1726	810403596000	8713	4374	29	0	\N
86631	1726	810383596000	8713	4374	30	0	\N
86632	1726	810373595000	8713	4374	31	0	\N
86530	1397	1391465280000	8686	4502	0	0	4737
86531	441	66000010000000	8686	4502	1	0	1
86547	1397	1391455279000	8689	4503	0	0	4738
86548	1397	1391445278000	8690	4504	0	0	4739
86549	1397	1391435277000	8691	4505	0	0	4740
86553	1397	1391415275000	8693	4506	1	0	4742
86554	1397	1391405274000	8694	4507	0	0	4743
86556	1397	1391395273000	8696	4508	0	0	4744
86558	1397	1391385272000	8698	4509	0	0	4745
86561	1397	1391375271000	8701	4510	0	0	4746
86563	1397	1391355269000	8702	4511	1	0	4748
86564	1397	1391345268000	8702	4511	2	0	4749
86565	1397	1391335267000	8702	4511	3	0	4750
86566	640	66000009000000	8702	4511	4	0	1
86573	1397	1391315265000	8704	4512	1	0	4752
86574	1397	1391305264000	8705	4513	0	0	4753
86575	1397	1391295263000	8706	4514	0	0	4754
86576	1397	1391285262000	8706	4514	1	0	4755
86577	1397	1391275261000	8706	4514	2	0	4756
86579	1397	1391255259000	8707	4515	0	0	4758
86580	1397	1391245258000	8707	4515	1	0	4759
86581	1397	1391235257000	8708	4516	0	0	4760
86582	1397	1391225256000	8709	4517	0	0	4761
86591	1397	1391215255000	8711	4518	0	0	4762
86593	1397	1391195253000	8711	4518	2	0	4764
86594	1397	1391185252000	8711	4518	3	0	4765
86595	1397	1391175251000	8711	4518	4	0	4766
86596	1726	807693448000	8711	4518	5	0	1726
86598	1726	806473447000	8711	4518	7	0	1728
86599	1397	1391165250000	8712	4519	0	0	4767
86600	1726	806463446000	8712	4519	1	0	1729
86633	1726	810363594000	8713	4374	32	0	\N
86634	1726	810353593000	8713	4374	33	0	\N
86635	1726	810343592000	8713	4374	34	0	\N
86636	1726	810333591000	8713	4374	35	0	\N
86637	1726	809123591000	8713	4374	37	0	\N
86638	1726	809113590000	8713	4374	38	0	\N
86639	1726	809103589000	8713	4374	39	0	\N
86640	1726	809093588000	8713	4374	40	0	\N
86641	1726	809083587000	8713	4374	41	0	\N
86642	1726	809073586000	8713	4374	42	0	\N
86643	1726	809063585000	8713	4374	43	0	\N
86644	1726	809053584000	8713	4374	44	0	\N
86645	1726	809043583000	8713	4374	45	0	\N
86646	1726	809033582000	8713	4374	46	0	\N
86647	1726	809023581000	8713	4374	47	0	\N
86648	1726	809013580000	8713	4374	48	0	\N
86649	1726	809003579000	8713	4374	49	0	\N
86650	1726	808993578000	8713	4374	50	0	\N
86651	1726	808983577000	8713	4374	51	0	\N
86652	1726	808973576000	8713	4374	52	0	\N
86653	1726	808963575000	8713	4374	53	0	\N
86654	1726	808953574000	8713	4374	54	0	\N
86655	1726	808943573000	8713	4374	55	0	\N
86656	1726	808933572000	8713	4374	56	0	\N
86657	1726	808923571000	8713	4374	57	0	\N
86658	1726	808913570000	8713	4374	58	0	\N
86659	1726	808903569000	8713	4374	59	0	\N
86660	1726	808893568000	8713	4374	60	0	\N
86661	1726	808883567000	8713	4374	61	0	\N
86662	1726	808873566000	8713	4374	62	0	\N
86663	1726	808863565000	8713	4374	63	0	\N
86664	1726	808853564000	8713	4374	64	0	\N
86665	1726	808843563000	8713	4374	65	0	\N
86666	1726	808833562000	8713	4374	66	0	\N
86667	1726	808823561000	8713	4374	67	0	\N
86668	1726	808813560000	8713	4374	68	0	\N
86669	1726	808803559000	8713	4374	69	0	\N
86670	1726	808793558000	8713	4374	70	0	\N
86671	1726	808783557000	8713	4374	71	0	\N
86672	1726	808773556000	8713	4374	72	0	\N
86673	1726	808763555000	8713	4374	73	0	\N
86674	1726	808753554000	8713	4374	74	0	\N
86675	1726	808743553000	8713	4374	75	0	\N
86676	1726	808733552000	8713	4374	76	0	\N
86677	1726	808723551000	8713	4374	77	0	\N
86678	1726	808713550000	8713	4374	78	0	\N
86679	1726	808703549000	8713	4374	79	0	\N
86680	1726	808693548000	8713	4374	80	0	\N
86681	1726	808683547000	8713	4374	81	0	\N
86682	1726	808673546000	8713	4374	82	0	\N
86683	1726	808663545000	8713	4374	83	0	\N
86684	1726	808653544000	8713	4374	84	0	\N
86685	1726	808643543000	8713	4374	85	0	\N
86686	1726	808633542000	8713	4374	86	0	\N
86687	1726	808623541000	8713	4374	87	0	\N
86688	1726	808613540000	8713	4374	88	0	\N
86689	1726	808603539000	8713	4374	89	0	\N
86690	1726	808593538000	8713	4374	90	0	\N
86691	1726	808583537000	8713	4374	91	0	\N
86692	1726	808573536000	8713	4374	92	0	\N
86693	1726	808563535000	8713	4374	93	0	\N
86694	1726	808553534000	8713	4374	94	0	\N
86695	1726	808543533000	8713	4374	95	0	\N
86696	1726	808533532000	8713	4374	96	0	\N
86697	1726	808523531000	8713	4374	97	0	\N
86698	1726	808513530000	8713	4374	98	0	\N
86699	1726	808503529000	8713	4374	99	0	\N
86700	1726	808493528000	8713	4374	100	0	\N
86701	1726	808483527000	8713	4374	101	0	\N
86702	1726	808473526000	8713	4374	102	0	\N
86703	1726	808463525000	8713	4374	103	0	\N
86704	1726	808453524000	8713	4374	104	0	\N
86705	1726	808443523000	8713	4374	105	0	\N
86706	1726	808433522000	8713	4374	106	0	\N
86707	1726	808423521000	8713	4374	107	0	\N
86708	1726	808413520000	8713	4374	108	0	\N
86709	1726	808403519000	8713	4374	109	0	\N
86710	1726	808393518000	8713	4374	110	0	\N
86711	1726	808383517000	8713	4374	111	0	\N
86712	1726	808373516000	8713	4374	112	0	\N
86713	1726	808363515000	8713	4374	113	0	\N
86714	1726	808353514000	8713	4374	114	0	\N
86715	1726	808343513000	8713	4374	115	0	\N
86716	1726	808333512000	8713	4374	116	0	\N
86717	1726	808323511000	8713	4374	117	0	\N
86718	1726	808313510000	8713	4374	118	0	\N
86719	1397	1391165250000	8714	4519	0	0	\N
86720	1726	806463446000	8714	4519	1	0	\N
86721	1726	806453445000	8715	4520	0	0	\N
86722	1397	1391155249000	8715	4520	1	0	\N
86725	1726	806443444000	8718	4521	0	0	\N
86726	1726	806433443000	8718	4521	1	0	\N
86727	1397	1391145248000	8718	4521	2	0	\N
86728	1397	1391135247000	8718	4521	3	0	\N
86735	1726	806413441000	8721	4523	0	0	\N
86736	1726	806403440000	8721	4523	1	0	\N
86737	1397	1391115245000	8721	4523	2	0	\N
86738	1397	1391105244000	8721	4523	3	0	\N
86739	1726	806413441000	8722	4523	0	0	\N
86740	1726	806403440000	8722	4523	1	0	\N
86741	1397	1391115245000	8722	4523	2	0	\N
86742	1397	1391105244000	8722	4523	3	0	\N
86758	1397	1391045238000	8728	4527	0	0	\N
86759	1397	1391045238000	8729	4527	0	0	\N
86762	1397	1391035237000	8731	4528	0	0	\N
86763	1726	806333433000	8731	4528	1	0	\N
86766	1726	806323432000	8733	4529	0	0	\N
86767	1397	1391025236000	8733	4529	1	0	\N
86729	1726	806443444000	8719	4521	0	0	1731
86730	1726	806433443000	8719	4521	1	0	1732
86731	1397	1391145248000	8719	4521	2	0	4769
86732	1397	1391135247000	8719	4521	3	0	4770
86733	1726	806423442000	8720	4522	0	0	1733
86743	1726	806413441000	8723	4523	0	0	1734
86744	1726	806403440000	8723	4523	1	0	1735
86745	1397	1391115245000	8723	4523	2	0	4772
86746	1397	1391105244000	8723	4523	3	0	4773
86747	1684	34560041000000	8724	4524	0	0	1
86749	1726	806383438000	8724	4524	2	0	1737
86750	1726	806373437000	8724	4524	3	0	1738
86751	1397	1391095243000	8724	4524	4	0	4774
86752	1397	1391085242000	8724	4524	5	0	4775
86754	1397	1391065240000	8726	4525	0	0	4777
86755	1726	806363436000	8726	4525	1	0	1739
86756	1726	806353435000	8727	4526	0	0	1740
86757	1397	1391055239000	8727	4526	1	0	4778
86760	1397	1391045238000	8730	4527	0	0	4779
86764	1397	1391035237000	8732	4528	0	0	4780
86765	1726	806333433000	8732	4528	1	0	1742
86768	1726	806323432000	8734	4529	0	0	1743
86792	1397	1390915225000	8742	4536	0	0	\N
86793	1726	806213421000	8742	4536	1	0	\N
86794	1397	1390905224000	8743	4537	0	0	\N
86795	1726	806203420000	8743	4537	1	0	\N
86798	1397	1390905224000	8745	4537	0	0	\N
86799	1726	806203420000	8745	4537	1	0	\N
86808	1726	806163416000	8750	4541	0	0	\N
86809	1397	1390865220000	8750	4541	1	0	\N
86810	1397	1390855219000	8751	4542	0	0	\N
86811	1397	1390855219000	8752	4542	0	0	\N
86812	1726	806153415000	8752	4542	1	0	\N
86813	1397	1390855219000	8753	4542	0	0	\N
86814	1726	806153415000	8753	4542	1	0	\N
86821	1726	806123412000	8757	4545	0	0	\N
86822	1397	1390825216000	8757	4545	1	0	\N
86823	1726	806123412000	8758	4545	0	0	\N
86824	1397	1390825216000	8758	4545	1	0	\N
86825	1726	806123412000	8759	4545	0	0	\N
86826	1397	1390825216000	8759	4545	1	0	\N
86831	1397	1390805214000	8762	4547	0	0	\N
86832	1726	806103410000	8762	4547	1	0	\N
86833	1397	1390805214000	8763	4547	0	0	\N
86834	1726	806103410000	8763	4547	1	0	\N
86837	1397	1390805214000	8765	4547	0	0	\N
86838	1726	806103410000	8765	4547	1	0	\N
86839	1397	1390805214000	8766	4547	0	0	\N
86840	1726	806103410000	8766	4547	1	0	\N
86841	1397	1390805214000	8767	4547	0	0	\N
86842	1726	806103410000	8767	4547	1	0	\N
86843	1397	1390805214000	8768	4547	0	0	\N
86844	1726	806103410000	8768	4547	1	0	\N
86847	1397	1390795213000	8770	4548	0	0	\N
86848	1726	806093409000	8770	4548	1	0	\N
86851	1397	1390775211000	8772	4550	0	0	\N
86852	1397	1390765210000	8772	4550	1	0	\N
86853	1397	1390755209000	8772	4550	2	0	\N
86854	1726	806073407000	8772	4550	3	0	\N
86855	1726	806063406000	8772	4550	4	0	\N
86856	1726	806053405000	8772	4550	5	0	\N
86865	1726	806043404000	8775	4551	0	0	\N
86866	1397	1390745208000	8775	4551	1	0	\N
86871	1397	1390725206000	8778	4553	0	0	\N
86872	1726	806023402000	8778	4553	1	0	\N
86879	1726	806003400000	8781	4555	0	0	\N
86880	1726	804793400000	8781	4555	1	0	\N
86881	1397	1390705204000	8781	4555	2	0	\N
86882	1726	803583400000	8781	4555	3	0	\N
86883	1726	806003400000	8782	4555	0	0	\N
86884	1726	804793400000	8782	4555	1	0	\N
86885	1397	1390705204000	8782	4555	2	0	\N
86886	1726	803583400000	8782	4555	3	0	\N
86887	1726	806003400000	8783	4555	0	0	\N
86888	1726	804793400000	8783	4555	1	0	\N
86889	1397	1390705204000	8783	4555	2	0	\N
86890	1726	803583400000	8783	4555	3	0	\N
86893	1397	1390695203000	8785	4556	0	0	\N
86894	1726	803573399000	8785	4556	1	0	\N
86895	1397	1390695203000	8786	4556	0	0	\N
86896	1726	803573399000	8786	4556	1	0	\N
86897	1397	1390695203000	8787	4556	0	0	\N
86898	1726	803573399000	8787	4556	1	0	\N
86771	1397	1391015235000	8735	4530	1	0	4782
86772	1726	806303430000	8735	4530	2	0	1745
86773	1726	806293429000	8735	4530	3	0	1746
86774	1397	1391005234000	8735	4530	4	0	4783
86775	1397	1390995233000	8735	4530	5	0	4784
86777	1397	1390985232000	8736	4531	1	0	4785
86778	1726	806273427000	8737	4532	0	0	1748
86779	1397	1390975231000	8737	4532	1	0	4786
86780	1397	1390965230000	8738	4533	0	0	4787
86781	1397	1390955229000	8738	4533	1	0	4788
86783	1726	806253425000	8738	4533	3	0	1750
86784	1726	806243424000	8739	4534	0	0	1751
86785	1726	806233423000	8739	4534	1	0	1752
86786	1397	1390945228000	8739	4534	2	0	4789
86788	1397	1390925226000	8740	4535	0	0	4791
86789	1726	806223422000	8740	4535	1	0	1753
86790	1397	1390915225000	8741	4536	0	0	4792
86791	1726	806213421000	8741	4536	1	0	1754
86796	1397	1390905224000	8744	4537	0	0	4793
86800	1397	1390895223000	8746	4538	0	0	4794
86801	1726	806193419000	8746	4538	1	0	1756
86802	1726	806183418000	8747	4539	0	0	1757
86803	1397	1390885222000	8747	4539	1	0	4795
86804	1726	806173417000	8748	4540	0	0	1758
86806	1726	806163416000	8749	4541	0	0	1759
86807	1397	1390865220000	8749	4541	1	0	4797
86815	1397	1390855219000	8754	4542	0	0	4798
86816	1726	806153415000	8754	4542	1	0	1760
86818	1397	1390845218000	8755	4543	1	0	4799
86819	1397	1390835217000	8756	4544	0	0	4800
86820	1726	806133413000	8756	4544	1	0	1762
86827	1726	806123412000	8760	4545	0	0	1763
86828	1397	1390825216000	8760	4545	1	0	4801
86830	1397	1390815215000	8761	4546	1	0	4802
86835	1397	1390805214000	8764	4547	0	0	4803
86836	1726	806103410000	8764	4547	1	0	1765
86845	1397	1390795213000	8769	4548	0	0	4804
86846	1726	806093409000	8769	4548	1	0	1766
86850	1726	806083408000	8771	4549	1	0	1767
86857	1397	1390775211000	8773	4550	0	0	4806
86858	1397	1390765210000	8773	4550	1	0	4807
86859	1397	1390755209000	8773	4550	2	0	4808
86861	1726	806063406000	8773	4550	4	0	1769
86862	1726	806053405000	8773	4550	5	0	1770
86863	1726	806043404000	8774	4551	0	0	1771
86864	1397	1390745208000	8774	4551	1	0	4809
86867	1726	806033403000	8776	4552	0	0	1772
86869	1397	1390725206000	8777	4553	0	0	4811
86870	1726	806023402000	8777	4553	1	0	1773
86873	1726	806013401000	8779	4554	0	0	1774
86874	1397	1390715205000	8779	4554	1	0	4812
86875	1726	806003400000	8780	4555	0	0	1775
86877	1397	1390705204000	8780	4555	2	0	4813
86878	1726	803583400000	8780	4555	3	0	1777
86891	1397	1390695203000	8784	4556	0	0	4814
86892	1726	803573399000	8784	4556	1	0	1778
86900	1397	1390685202000	8788	4557	1	0	4815
86901	1397	1390675201000	8791	4558	0	0	4816
86902	1397	1390665200000	8791	4558	1	0	4817
86903	1726	803553397000	8791	4558	2	0	1780
86904	1726	803543396000	8791	4558	3	0	1781
86905	1397	1390675201000	8792	4558	0	0	\N
86906	1397	1390665200000	8792	4558	1	0	\N
86907	1726	803553397000	8792	4558	2	0	\N
86908	1726	803543396000	8792	4558	3	0	\N
86909	1397	1390675201000	8793	4558	0	0	\N
86910	1397	1390665200000	8793	4558	1	0	\N
86911	1726	803553397000	8793	4558	2	0	\N
86912	1726	803543396000	8793	4558	3	0	\N
86913	1397	1390675201000	8794	4558	0	0	\N
86914	1397	1390665200000	8794	4558	1	0	\N
86915	1726	803553397000	8794	4558	2	0	\N
86916	1726	803543396000	8794	4558	3	0	\N
86923	1397	1390625196000	8797	4561	0	0	\N
86924	1726	803503392000	8797	4561	1	0	\N
86927	1726	803493391000	8799	4562	0	0	\N
86928	1397	1390615195000	8799	4562	1	0	\N
86933	1726	803473389000	8802	4564	0	0	\N
86934	1397	1390595193000	8802	4564	1	0	\N
86943	1726	803433385000	8807	4567	0	0	\N
86944	1397	1390555189000	8807	4567	1	0	\N
86948	1397	1390555189000	8809	4567	0	0	\N
86949	1397	1390545188000	8810	4568	0	0	\N
86950	1726	803433385000	8810	4568	1	0	\N
86951	1726	803423384000	8810	4568	2	0	\N
86953	1397	1390535187000	8812	4569	0	0	\N
86954	1726	803413383000	8812	4569	1	0	\N
86957	1474	13854303000000	8814	4548	0	0	\N
86958	1397	1390795213000	8814	4548	1	0	\N
86959	1726	806093409000	8814	4548	2	0	\N
86960	1726	806083408000	8814	4548	3	0	\N
86967	1397	1390505184000	8818	4572	0	0	\N
86968	1726	800973381000	8818	4572	1	0	\N
86969	1726	800963380000	8818	4572	2	0	\N
86973	1397	1390505184000	8820	4572	0	0	\N
86974	1726	800973381000	8820	4572	1	0	\N
86975	1726	800963380000	8820	4572	2	0	\N
86984	1397	1390465180000	8824	4575	0	0	\N
86985	1726	800923376000	8824	4575	1	0	\N
86989	1397	1390445178000	8826	4577	0	0	\N
86990	1726	800903374000	8826	4577	1	0	\N
86991	1726	800893373000	8826	4577	2	0	\N
86992	1397	1390435177000	8826	4577	3	0	\N
86993	1726	800883372000	8826	4577	4	0	\N
86994	1397	1390425176000	8826	4577	5	0	\N
86995	1397	1390445178000	8827	4577	0	0	\N
86996	1726	800903374000	8827	4577	1	0	\N
86997	1726	800893373000	8827	4577	2	0	\N
86998	1397	1390435177000	8827	4577	3	0	\N
86999	1726	800883372000	8827	4577	4	0	\N
87000	1397	1390425176000	8827	4577	5	0	\N
87001	1397	1390445178000	8828	4577	0	0	\N
87002	1726	800903374000	8828	4577	1	0	\N
87003	1726	800893373000	8828	4577	2	0	\N
87004	1397	1390435177000	8828	4577	3	0	\N
87005	1726	800883372000	8828	4577	4	0	\N
87006	1397	1390425176000	8828	4577	5	0	\N
87013	1397	1390445178000	8830	4577	0	0	\N
87014	1726	800903374000	8830	4577	1	0	\N
87015	1726	800893373000	8830	4577	2	0	\N
87016	1397	1390435177000	8830	4577	3	0	\N
87017	1726	800883372000	8830	4577	4	0	\N
87018	1397	1390425176000	8830	4577	5	0	\N
87030	1397	1390385172000	8834	4580	0	0	\N
87031	1726	799633368000	8834	4580	1	0	\N
87035	806	1222212187776490	8836	4581	0	0	\N
87036	1726	799623367000	8836	4581	1	0	\N
87037	1397	1390375171000	8836	4581	2	0	\N
87038	1726	799613366000	8837	4582	0	0	\N
87039	1726	799603365000	8837	4582	1	0	\N
87040	1397	1390365170000	8837	4582	2	0	\N
86919	1397	1390655199000	8795	4559	2	0	4818
86920	1397	1390645198000	8795	4559	3	0	4819
86921	1726	803513393000	8796	4560	0	0	1784
86922	1397	1390635197000	8796	4560	1	0	4820
86925	1397	1390625196000	8798	4561	0	0	4821
86929	1397	1390615195000	8800	4562	0	0	4822
86930	1726	803493391000	8801	4563	0	0	1786
86931	1726	803483390000	8801	4563	1	0	1787
86932	1397	1390605194000	8801	4563	2	0	4823
86935	1726	803473389000	8803	4564	0	0	1788
86937	1726	803463388000	8805	4565	0	0	1789
86938	1397	1390585192000	8805	4565	1	0	4825
86939	1397	1390575191000	8805	4565	2	0	4826
86940	1726	803453387000	8805	4565	3	0	1790
86942	1726	803443386000	8806	4566	1	0	1791
86945	1726	803433385000	8808	4567	0	0	1792
86946	1397	1390555189000	8808	4567	1	0	4828
86947	1726	803423384000	8808	4567	2	0	1793
86952	1397	1390545188000	8811	4568	0	0	4829
86956	1726	803413383000	8813	4569	1	0	1794
86961	1726	803403382000	8815	4570	0	0	1795
86962	1474	13854303000000	8815	4570	1	0	4
86963	1397	1390525186000	8815	4570	2	0	4831
86964	1397	1390515185000	8817	4571	0	0	4832
86966	1726	802183381000	8817	4571	2	0	1797
86970	1397	1390505184000	8819	4572	0	0	4833
86971	1726	800973381000	8819	4572	1	0	1798
86972	1726	800963380000	8819	4572	2	0	1799
86977	1397	1390495183000	8821	4573	1	0	4834
86978	1397	1390485182000	8822	4574	0	0	4835
86979	1726	800943378000	8822	4574	1	0	1801
86980	1726	800933377000	8822	4574	2	0	1802
86981	1397	1390475181000	8822	4574	3	0	4836
86983	1726	800923376000	8823	4575	1	0	1803
86986	436	66718550000000	8825	4576	0	0	4
86987	1397	1390455179000	8825	4576	1	0	4838
86988	1726	800913375000	8825	4576	2	0	1804
87007	1397	1390445178000	8829	4577	0	0	4839
87009	1726	800893373000	8829	4577	2	0	1806
87010	1397	1390435177000	8829	4577	3	0	4840
87011	1726	800883372000	8829	4577	4	0	1807
87012	1397	1390425176000	8829	4577	5	0	4841
87020	1726	800873371000	8831	4578	1	0	1808
87021	1397	1390415175000	8831	4578	2	0	4842
87022	1726	799663371000	8832	4579	0	0	1809
87023	1397	1390405174000	8832	4579	1	0	4843
87024	1726	799653370000	8832	4579	2	0	1810
87026	1397	1390395173000	8832	4579	4	0	4844
87027	436	66718320000000	8832	4579	5	0	5
87028	1397	1390385172000	8833	4580	0	0	4845
87029	1726	799633368000	8833	4580	1	0	1812
87032	806	1222212187776490	8835	4581	0	0	1
87034	1397	1390375171000	8835	4581	2	0	4846
87041	1397	1390355169000	8837	4582	3	0	\N
87042	1726	799613366000	8838	4582	0	0	\N
87043	1726	799603365000	8838	4582	1	0	\N
87044	1397	1390365170000	8838	4582	2	0	\N
87045	1397	1390355169000	8838	4582	3	0	\N
87050	1726	799613366000	8840	4582	0	0	\N
87051	1726	799603365000	8840	4582	1	0	\N
87052	1397	1390365170000	8840	4582	2	0	\N
87053	1397	1390355169000	8840	4582	3	0	\N
87054	1726	799593364000	8841	4583	0	0	\N
87055	1726	799583363000	8841	4583	1	0	\N
87056	1726	799573362000	8841	4583	2	0	\N
87057	1397	1390345168000	8841	4583	3	0	\N
87058	1397	1390335167000	8841	4583	4	0	\N
87059	1397	1390325166000	8841	4583	5	0	\N
87066	1726	799593364000	8843	4583	0	0	\N
87067	1726	799583363000	8843	4583	1	0	\N
87068	1726	799573362000	8843	4583	2	0	\N
87069	1397	1390345168000	8843	4583	3	0	\N
87070	1397	1390335167000	8843	4583	4	0	\N
87071	1397	1390325166000	8843	4583	5	0	\N
87072	1397	1390315165000	8844	4584	0	0	\N
87073	1726	799563361000	8844	4584	1	0	\N
87074	1397	1390315165000	8845	4584	0	0	\N
87076	1397	1390315165000	8847	4584	0	0	\N
87077	1726	799563361000	8847	4584	1	0	\N
87083	1397	1390295163000	8850	4586	0	0	\N
87084	1726	799543359000	8850	4586	1	0	\N
87085	1726	799533358000	8851	4587	0	0	\N
87086	1397	1390285162000	8851	4587	1	0	\N
87087	1726	799533358000	8852	4587	0	0	\N
87088	1397	1390285162000	8852	4587	1	0	\N
87091	1726	799533358000	8854	4587	0	0	\N
87092	1397	1390285162000	8854	4587	1	0	\N
87093	1726	799533358000	8855	4587	0	0	\N
87094	1397	1390285162000	8855	4587	1	0	\N
87103	1397	1390235157000	8860	4592	0	0	\N
87104	1726	799483353000	8860	4592	1	0	\N
87107	1397	1390225156000	8862	4593	0	0	\N
87108	1726	799473352000	8862	4593	1	0	\N
87111	1397	1390225156000	8864	4593	0	0	\N
87112	1726	799473352000	8864	4593	1	0	\N
87115	1397	1390215155000	8866	4594	0	0	\N
87116	1726	799463351000	8866	4594	1	0	\N
87119	1397	1390205154000	8868	4595	0	0	\N
87120	1726	799453350000	8868	4595	1	0	\N
87125	1397	1390175151000	8870	4597	0	0	\N
87126	1726	799423347000	8870	4597	1	0	\N
87127	1397	1390175151000	8871	4597	0	0	\N
87128	1726	799423347000	8871	4597	1	0	\N
87129	1397	1390175151000	8872	4597	0	0	\N
87130	1726	799423347000	8872	4597	1	0	\N
87135	1397	1390205154000	8876	4595	0	0	\N
87136	1397	1390195153000	8876	4595	1	0	\N
87137	1726	799453350000	8876	4595	2	0	\N
87138	1726	799443349000	8876	4595	3	0	\N
87139	1726	799433348000	8876	4595	4	0	\N
87140	1726	799423347000	8876	4595	5	0	\N
87141	1726	799413346000	8876	4595	6	0	\N
87142	1397	1390185152000	8876	4595	7	0	\N
87143	1397	1390175151000	8876	4595	8	0	\N
87149	1397	1390155149000	8878	4599	0	0	\N
87150	1397	1390145148000	8878	4599	1	0	\N
87151	1397	1390135147000	8878	4599	2	0	\N
87152	1726	799403345000	8878	4599	3	0	\N
87153	1726	799393344000	8878	4599	4	0	\N
87154	436	66718550000000	8879	4549	0	0	\N
87155	436	66718320000000	8879	4549	1	0	\N
87160	1726	799383343000	8881	4600	0	0	\N
87161	1397	1390125146000	8881	4600	1	0	\N
87162	1397	1390115145000	8881	4600	2	0	\N
87163	1726	799373342000	8881	4600	3	0	\N
87048	1397	1390365170000	8839	4582	2	0	4847
87049	1397	1390355169000	8839	4582	3	0	4848
87060	1726	799593364000	8842	4583	0	0	1816
87061	1726	799583363000	8842	4583	1	0	1817
87062	1726	799573362000	8842	4583	2	0	1818
87064	1397	1390335167000	8842	4583	4	0	4850
87065	1397	1390325166000	8842	4583	5	0	4851
87075	1397	1390315165000	8846	4584	0	0	4852
87078	1397	1390305164000	8848	4585	0	0	4853
87079	1726	799563361000	8848	4585	1	0	1819
87081	1397	1390295163000	8849	4586	0	0	4854
87082	1726	799543359000	8849	4586	1	0	1821
87089	1726	799533358000	8853	4587	0	0	1822
87090	1397	1390285162000	8853	4587	1	0	4855
87096	1726	799523357000	8856	4588	1	0	1823
87097	1726	799513356000	8857	4589	0	0	1824
87098	1397	1390265160000	8857	4589	1	0	4857
87099	1397	1390255159000	8858	4590	0	0	4858
87100	1726	799503355000	8858	4590	1	0	1825
87102	1397	1390245158000	8859	4591	1	0	4859
87105	1397	1390235157000	8861	4592	0	0	4860
87106	1726	799483353000	8861	4592	1	0	1827
87109	1397	1390225156000	8863	4593	0	0	4861
87110	1726	799473352000	8863	4593	1	0	1828
87114	1726	799463351000	8865	4594	1	0	1829
87117	1397	1390205154000	8867	4595	0	0	4863
87118	1726	799453350000	8867	4595	1	0	1830
87121	1726	799443349000	8869	4596	0	0	1831
87123	1397	1390195153000	8869	4596	2	0	4864
87124	1397	1390185152000	8869	4596	3	0	4865
87131	1397	1390175151000	8873	4597	0	0	4866
87132	1726	799423347000	8873	4597	1	0	1833
87133	1397	1390165150000	8874	4598	0	0	4867
87144	1397	1390155149000	8877	4599	0	0	4868
87145	1397	1390145148000	8877	4599	1	0	4869
87146	1397	1390135147000	8877	4599	2	0	4870
87147	1726	799403345000	8877	4599	3	0	1835
87148	1726	799393344000	8877	4599	4	0	1836
87157	1397	1390125146000	8880	4600	1	0	4871
87158	1397	1390115145000	8880	4600	2	0	4872
87159	1726	799373342000	8880	4600	3	0	1838
87164	208	66000000000000	8882	4601	0	0	1
87166	1726	799353340000	8882	4601	2	0	1840
87167	1397	1390105144000	8882	4601	3	0	4873
87168	1726	799343339000	8883	4602	0	0	1841
87169	1397	1390095143000	8883	4602	1	0	4874
87170	1397	1390085142000	8883	4602	2	0	4875
87172	1397	1390075141000	8884	4603	0	0	4876
87173	1726	799323337000	8884	4603	1	0	1843
87174	1726	799313336000	8885	4604	0	0	1844
87175	1397	1390065140000	8885	4604	1	0	4877
87176	1397	1390055139000	8886	4605	0	0	4878
87184	1397	1390015135000	8887	4606	0	0	\N
87185	1726	799263331000	8887	4606	1	0	\N
87188	1726	799253330000	8889	4607	0	0	\N
87189	1397	1390005134000	8889	4607	1	0	\N
87190	1726	799253330000	8891	4607	0	0	\N
87191	1397	1390005134000	8891	4607	1	0	\N
87192	1726	799253330000	8892	4607	0	0	\N
87193	1397	1390005134000	8892	4607	1	0	\N
87200	1397	1389975131000	8896	4610	0	0	\N
87201	1397	1389965130000	8896	4610	1	0	\N
87202	1726	799243329000	8897	4609	0	0	\N
87203	1397	1389995133000	8897	4609	1	0	\N
87204	1397	1389985132000	8897	4609	2	0	\N
87205	1397	1389975131000	8897	4609	3	0	\N
87206	1397	1389965130000	8897	4609	4	0	\N
87207	1726	799233328000	8897	4609	5	0	\N
87208	1726	799223327000	8897	4609	6	0	\N
87209	1726	799213326000	8897	4609	7	0	\N
87210	1397	1389975131000	8898	4610	0	0	\N
87211	1397	1389965130000	8898	4610	1	0	\N
87212	1726	799223327000	8898	4610	2	0	\N
87213	1726	799213326000	8898	4610	3	0	\N
87218	1397	1389955129000	8900	4611	0	0	\N
87219	1726	799203325000	8900	4611	1	0	\N
87220	1726	797993325000	8900	4611	2	0	\N
87224	1397	1389955129000	8902	4611	0	0	\N
87225	1726	799203325000	8902	4611	1	0	\N
87226	1726	797993325000	8902	4611	2	0	\N
87227	1397	1389955129000	8903	4610	0	0	\N
87228	1726	799203325000	8903	4610	1	0	\N
87229	1726	797993325000	8903	4610	2	0	\N
87230	1397	1389955129000	8904	4611	0	0	\N
87231	1726	799203325000	8904	4611	1	0	\N
87240	1397	1389905124000	8908	4615	0	0	\N
87241	1726	797943320000	8908	4615	1	0	\N
87252	1397	1389865120000	8912	4617	0	0	\N
87253	1726	797903316000	8912	4617	1	0	\N
87258	1397	1389845118000	8915	4619	0	0	\N
87264	1397	1389835117000	8917	4620	0	0	\N
87265	1397	1389825116000	8917	4620	1	0	\N
87266	1726	797873313000	8917	4620	2	0	\N
87267	1726	797863312000	8917	4620	3	0	\N
87268	485	66717999000000	8917	4620	4	0	\N
87271	1726	797853311000	8919	4621	0	0	\N
87272	1397	1389815115000	8919	4621	1	0	\N
87282	1515	10603400	8923	4596	0	0	\N
87283	485	66717999000000	8923	4596	1	0	\N
87288	1726	797783304000	8926	4627	0	0	\N
87289	1397	1389745108000	8926	4627	1	0	\N
87292	1726	797783304000	8928	4627	0	0	\N
87293	1397	1389745108000	8928	4627	1	0	\N
87305	1726	797723298000	8933	4632	0	0	\N
87306	1726	797713297000	8933	4632	1	0	\N
87307	1397	1389685102000	8933	4632	2	0	\N
87308	1397	1389675101000	8933	4632	3	0	\N
87179	1397	1390035137000	8886	4605	3	0	4880
87180	1397	1390025136000	8886	4605	4	0	4881
87181	1726	799293334000	8886	4605	5	0	1846
87182	1726	799283333000	8886	4605	6	0	1847
87183	1726	799273332000	8886	4605	7	0	1848
87187	1726	799263331000	8888	4606	1	0	1849
87194	1726	799253330000	8893	4607	0	0	1850
87195	1397	1390005134000	8893	4607	1	0	4883
87196	1726	799243329000	8895	4609	0	0	1851
87197	1397	1389995133000	8895	4609	1	0	4884
87199	1726	799233328000	8895	4609	3	0	1852
87214	1397	1389975131000	8899	4610	0	0	4886
87215	1397	1389965130000	8899	4610	1	0	4887
87216	1726	799223327000	8899	4610	2	0	1853
87221	1397	1389955129000	8901	4611	0	0	4888
87222	1726	799203325000	8901	4611	1	0	1855
87223	1726	797993325000	8901	4611	2	0	1856
87232	1726	797983324000	8905	4612	0	0	1857
87233	1397	1389945128000	8905	4612	1	0	4889
87235	1726	797973323000	8906	4613	1	0	1858
87236	1726	797963322000	8907	4614	0	0	1859
87237	1726	797953321000	8907	4614	1	0	1860
87238	1397	1389925126000	8907	4614	2	0	4891
87239	1397	1389915125000	8907	4614	3	0	4892
87243	1726	797943320000	8909	4615	1	0	1861
87244	1397	1389895123000	8910	4616	0	0	4894
87245	1726	797933319000	8910	4616	1	0	1862
87246	1397	1389885122000	8910	4616	2	0	4895
87248	1726	797923318000	8910	4616	4	0	1863
87249	1726	797913317000	8910	4616	5	0	1864
87250	1397	1389865120000	8911	4617	0	0	4897
87251	1726	797903316000	8911	4617	1	0	1865
87254	1726	797893315000	8913	4618	0	0	1866
87256	1726	797883314000	8914	4619	0	0	1867
87257	1397	1389845118000	8914	4619	1	0	4899
87259	1397	1389835117000	8916	4620	0	0	4900
87260	1397	1389825116000	8916	4620	1	0	4901
87261	1726	797873313000	8916	4620	2	0	1868
87263	485	66717999000000	8916	4620	4	0	1
87269	1726	797853311000	8918	4621	0	0	1870
87270	1397	1389815115000	8918	4621	1	0	4902
87273	1397	1389805114000	8920	4622	0	0	4903
87275	1397	1389795113000	8921	4623	0	0	4904
87276	1726	797833309000	8921	4623	1	0	1872
87277	1726	797823308000	8921	4623	2	0	1873
87278	1397	1389785112000	8921	4623	3	0	4905
87279	1515	10603400	8921	4623	4	0	1
87281	1726	797813307000	8922	4624	1	0	1874
87284	1397	1389765110000	8924	4625	0	0	4907
87285	1726	797803306000	8924	4625	1	0	1875
87286	1726	797793305000	8925	4626	0	0	1876
87287	1397	1389755109000	8925	4626	1	0	4908
87291	1397	1389745108000	8927	4627	1	0	4909
87294	1397	1389735107000	8929	4628	0	0	4910
87295	1726	797773303000	8929	4628	1	0	1878
87296	724	20000750000000	8930	4629	0	0	1
87298	1726	797763302000	8930	4629	2	0	1879
87299	1726	797753301000	8931	4630	0	0	1880
87300	1726	797743300000	8931	4630	1	0	1881
87301	1397	1389715105000	8931	4630	2	0	4912
87302	1397	1389705104000	8931	4630	3	0	4913
87304	1397	1389695103000	8932	4631	1	0	4914
87309	1726	797723298000	8934	4632	0	0	1883
87310	1726	797713297000	8934	4632	1	0	1884
87311	1397	1389685102000	8934	4632	2	0	4915
87312	1397	1389675101000	8934	4632	3	0	4916
87313	1397	1389665100000	8935	4633	0	0	\N
87314	1726	797703296000	8935	4633	1	0	\N
87319	1726	797683294000	8939	4635	0	0	\N
87320	1397	1389645098000	8939	4635	2	0	\N
87321	1397	1389635097000	8939	4635	3	0	\N
87322	1726	797673293000	8939	4635	4	0	\N
87335	1397	1389605094000	8943	4638	0	0	\N
87336	1726	795223290000	8943	4638	1	0	\N
87340	724	20000750000000	8945	4597	0	0	\N
87341	1868	3880000000	8945	4597	1	0	\N
87342	1397	1389585092000	8946	4640	0	0	\N
87343	1726	795203288000	8946	4640	1	0	\N
87349	1868	780000000	8948	4640	0	0	\N
87350	1397	1389585092000	8948	4640	1	0	\N
87351	1397	1389575091000	8948	4640	2	0	\N
87352	1726	795203288000	8948	4640	3	0	\N
87353	1726	795193287000	8948	4640	4	0	\N
87361	1397	1389535087000	8953	4644	0	0	\N
87362	1397	1389525086000	8953	4644	1	0	\N
87363	1726	795153283000	8953	4644	2	0	\N
87364	1726	795143282000	8953	4644	3	0	\N
87369	724	20002750000000	8955	4598	0	0	\N
87370	1868	780000000	8955	4598	1	0	\N
87371	1726	795133281000	8956	4645	0	0	\N
87372	1726	795123280000	8956	4645	1	0	\N
87373	1397	1389515085000	8956	4645	2	0	\N
87374	1397	1389505084000	8956	4645	3	0	\N
87379	724	20000750000000	8958	4569	0	0	\N
87380	1868	3880000000	8958	4569	1	0	\N
87381	1868	780000000	8958	4569	2	0	\N
87382	1948	100000000	8958	4569	3	0	\N
87383	208	66000000000000	8958	4569	4	0	\N
87384	436	66718550000000	8958	4569	5	0	\N
87385	1474	13854303000000	8958	4569	6	0	\N
87386	1397	1390535187000	8958	4569	7	0	\N
87387	1726	803413383000	8958	4569	8	0	\N
87388	1726	803403382000	8958	4569	9	0	\N
87389	1726	802193382000	8958	4569	10	0	\N
87390	1726	802183381000	8958	4569	11	0	\N
87391	1726	800973381000	8958	4569	12	0	\N
87392	1726	800963380000	8958	4569	13	0	\N
87393	1726	800953379000	8958	4569	14	0	\N
87394	1397	1390525186000	8958	4569	15	0	\N
87395	1397	1390515185000	8958	4569	16	0	\N
87396	1397	1390505184000	8958	4569	17	0	\N
87397	1397	1390495183000	8958	4569	18	0	\N
87398	1397	1390485182000	8958	4569	19	0	\N
87399	1726	800943378000	8958	4569	20	0	\N
87400	1726	800933377000	8958	4569	21	0	\N
87401	1726	800923376000	8958	4569	22	0	\N
87402	1726	800913375000	8958	4569	23	0	\N
87403	1726	800903374000	8958	4569	24	0	\N
87404	1726	800893373000	8958	4569	25	0	\N
87405	1726	800883372000	8958	4569	26	0	\N
87406	1726	800873371000	8958	4569	27	0	\N
87407	1726	799663371000	8958	4569	28	0	\N
87408	1726	799653370000	8958	4569	29	0	\N
87409	1726	799643369000	8958	4569	30	0	\N
87410	1726	799633368000	8958	4569	31	0	\N
87411	1726	799623367000	8958	4569	32	0	\N
87412	1726	799613366000	8958	4569	33	0	\N
87413	1726	799603365000	8958	4569	34	0	\N
87414	1726	799593364000	8958	4569	35	0	\N
87415	1726	799583363000	8958	4569	36	0	\N
87416	1726	799573362000	8958	4569	37	0	\N
87417	1726	799563361000	8958	4569	38	0	\N
87418	1726	799553360000	8958	4569	39	0	\N
87419	1726	799543359000	8958	4569	40	0	\N
87420	1726	799533358000	8958	4569	41	0	\N
87421	1397	1390475181000	8958	4569	42	0	\N
87422	1397	1390465180000	8958	4569	43	0	\N
87423	1397	1390455179000	8958	4569	44	0	\N
87424	1397	1390445178000	8958	4569	45	0	\N
87425	1397	1390435177000	8958	4569	46	0	\N
87426	1397	1390425176000	8958	4569	47	0	\N
87427	1397	1390415175000	8958	4569	48	0	\N
87428	1397	1390405174000	8958	4569	49	0	\N
87429	1397	1390395173000	8958	4569	50	0	\N
87430	1397	1390385172000	8958	4569	51	0	\N
87431	1397	1390375171000	8958	4569	52	0	\N
87432	1397	1390365170000	8958	4569	53	0	\N
87433	1397	1390355169000	8958	4569	54	0	\N
87434	1397	1390345168000	8958	4569	55	0	\N
87435	1397	1390335167000	8958	4569	56	0	\N
87436	1397	1390325166000	8958	4569	57	0	\N
87437	1397	1390315165000	8958	4569	58	0	\N
87438	1397	1390305164000	8958	4569	59	0	\N
87439	1397	1390295163000	8958	4569	60	0	\N
87440	1397	1390285162000	8958	4569	61	0	\N
87441	1397	1390275161000	8958	4569	62	0	\N
87442	1397	1390265160000	8958	4569	63	0	\N
87443	1397	1390255159000	8958	4569	64	0	\N
87444	1397	1390245158000	8958	4569	65	0	\N
87445	1397	1390235157000	8958	4569	66	0	\N
87446	1397	1390225156000	8958	4569	68	0	\N
87447	1397	1390215155000	8958	4569	69	0	\N
87448	1397	1390205154000	8958	4569	70	0	\N
87317	1397	1389655099000	8937	4634	0	0	4918
87318	1726	797693295000	8937	4634	1	0	1886
87323	1726	797683294000	8941	4637	0	0	1887
87324	1397	1389645098000	8941	4637	1	0	4919
87325	1397	1389635097000	8941	4637	2	0	4920
87327	1397	1389615095000	8941	4637	4	0	4922
87328	1726	797673293000	8941	4637	5	0	1888
87329	1726	797663292000	8941	4637	6	0	1889
87330	1726	797653291000	8941	4637	7	0	1890
87331	1726	796443291000	8941	4637	8	0	1891
87333	1397	1389605094000	8942	4638	0	0	4923
87334	1726	795223290000	8942	4638	1	0	1893
87337	1868	3880000000	8944	4639	0	0	3
87338	1726	795213289000	8944	4639	1	0	1894
87344	1868	780000000	8947	4640	0	0	4
87345	1397	1389585092000	8947	4640	1	0	4925
87346	1397	1389575091000	8947	4640	2	0	4926
87347	1726	795203288000	8947	4640	3	0	1895
87348	1726	795193287000	8947	4640	4	0	1896
87355	1726	795183286000	8950	4641	1	0	1897
87356	724	20002750000000	8951	4642	0	0	2
87357	1726	795173285000	8951	4642	1	0	1898
87358	1397	1389555089000	8951	4642	2	0	4928
87359	1726	795163284000	8952	4643	0	0	1899
87365	1397	1389535087000	8954	4644	0	0	4930
87366	1397	1389525086000	8954	4644	1	0	4931
87367	1726	795153283000	8954	4644	2	0	1900
87368	1726	795143282000	8954	4644	3	0	1901
87376	1726	795123280000	8957	4645	1	0	1903
87377	1397	1389515085000	8957	4645	2	0	4932
87378	1397	1389505084000	8957	4645	3	0	4933
87449	1397	1390195153000	8958	4569	71	0	\N
87450	436	66718320000000	8958	4569	72	0	\N
87451	1397	1390185152000	8958	4569	73	0	\N
87452	1397	1390175151000	8958	4569	74	0	\N
87453	1397	1390165150000	8958	4569	75	0	\N
87454	1397	1390155149000	8958	4569	76	0	\N
87455	1397	1390145148000	8958	4569	77	0	\N
87456	1397	1390135147000	8958	4569	78	0	\N
87457	1397	1390125146000	8958	4569	79	0	\N
87458	1397	1390115145000	8958	4569	80	0	\N
87459	1397	1390105144000	8958	4569	81	0	\N
87460	1397	1390095143000	8958	4569	82	0	\N
87461	1397	1390085142000	8958	4569	83	0	\N
87462	1397	1390075141000	8958	4569	84	0	\N
87463	1397	1390065140000	8958	4569	85	0	\N
87464	1397	1390055139000	8958	4569	86	0	\N
87465	1397	1390045138000	8958	4569	87	0	\N
87466	1397	1390035137000	8958	4569	88	0	\N
87467	1397	1390025136000	8958	4569	89	0	\N
87468	1397	1390015135000	8958	4569	90	0	\N
87469	1397	1390005134000	8958	4569	91	0	\N
87470	1397	1389995133000	8958	4569	92	0	\N
87471	1397	1389985132000	8958	4569	93	0	\N
87472	1397	1389975131000	8958	4569	94	0	\N
87473	1397	1389965130000	8958	4569	95	0	\N
87474	1397	1389955129000	8958	4569	96	0	\N
87475	1397	1389945128000	8958	4569	97	0	\N
87476	1397	1389935127000	8958	4569	98	0	\N
87477	1397	1389925126000	8958	4569	99	0	\N
87478	1397	1389915125000	8958	4569	100	0	\N
87479	1397	1389905124000	8958	4569	101	0	\N
87480	1397	1389895123000	8958	4569	102	0	\N
87481	1397	1389885122000	8958	4569	103	0	\N
87482	1397	1389875121000	8958	4569	104	0	\N
87483	1397	1389865120000	8958	4569	105	0	\N
87484	1397	1389855119000	8958	4569	106	0	\N
87485	1397	1389845118000	8958	4569	107	0	\N
87486	1397	1389835117000	8958	4569	108	0	\N
87487	1397	1389825116000	8958	4569	109	0	\N
87488	1397	1389815115000	8958	4569	110	0	\N
87489	1397	1389805114000	8958	4569	111	0	\N
87490	1397	1389795113000	8958	4569	112	0	\N
87491	1397	1389785112000	8958	4569	113	0	\N
87492	1397	1389775111000	8958	4569	114	0	\N
87493	1397	1389765110000	8958	4569	115	0	\N
87494	1397	1389755109000	8958	4569	116	0	\N
87495	1397	1389745108000	8958	4569	117	0	\N
87496	1397	1389735107000	8958	4569	118	0	\N
87497	1397	1389725106000	8958	4569	119	0	\N
87498	1397	1389715105000	8958	4569	120	0	\N
87499	1397	1389705104000	8958	4569	121	0	\N
87500	1397	1389695103000	8958	4569	122	0	\N
87501	1397	1389685102000	8958	4569	123	0	\N
87502	1397	1389675101000	8958	4569	124	0	\N
87503	1397	1389665100000	8958	4569	125	0	\N
87504	1726	795113279000	8959	4646	0	0	\N
87505	1397	1389495083000	8959	4646	1	0	\N
87506	1397	1389485082000	8959	4646	2	0	\N
87507	1726	795103278000	8959	4646	3	0	\N
87508	1718	12857522889008	8959	4646	4	0	\N
87514	1397	1389475081000	8961	4647	0	0	\N
87515	1726	795093277000	8961	4647	1	0	\N
87526	1718	12137482889008	8966	4599	0	0	\N
87531	1397	1389425076000	8968	4651	0	0	\N
87532	1726	795043272000	8968	4651	1	0	\N
87533	1726	795033271000	8968	4651	2	0	\N
87534	1397	1389415075000	8968	4651	3	0	\N
87535	1397	1389405074000	8969	4652	0	0	\N
87536	1397	1389395073000	8969	4652	1	0	\N
87537	1726	795023270000	8969	4652	2	0	\N
87538	1726	795013269000	8969	4652	3	0	\N
87539	1941	717951000000	8969	4652	4	0	\N
87555	1397	1389345068000	8974	4655	0	0	\N
87556	1726	794963264000	8974	4655	1	0	\N
87557	724	20000750000000	8975	4488	0	0	\N
87558	1868	3880000000	8975	4488	1	0	\N
87559	1868	780000000	8975	4488	2	0	\N
87560	1684	33840041000000	8975	4488	3	0	\N
87561	1726	807763455000	8975	4488	4	0	\N
87562	436	66718550000000	8975	4488	5	0	\N
87563	1397	1391525286000	8975	4488	6	0	\N
87564	1726	807753454000	8975	4488	7	0	\N
87565	1726	807743453000	8975	4488	8	0	\N
87566	1474	13854303000000	8975	4488	9	0	\N
87567	238	66000160000000	8975	4488	10	0	\N
87568	1726	807733452000	8975	4488	11	0	\N
87569	1726	807723451000	8975	4488	12	0	\N
87570	1397	1391515285000	8975	4488	13	0	\N
87571	1397	1391505284000	8975	4488	14	0	\N
87572	1397	1391495283000	8975	4488	15	0	\N
87573	1397	1391485282000	8975	4488	16	0	\N
87574	1397	1391475281000	8975	4488	17	0	\N
87575	1397	1391465280000	8975	4488	18	0	\N
87576	1397	1391455279000	8975	4488	19	0	\N
87577	1397	1391445278000	8975	4488	21	0	\N
87578	1726	807713450000	8975	4488	22	0	\N
87579	1726	807703449000	8975	4488	23	0	\N
87580	1726	807693448000	8975	4488	24	0	\N
87581	1726	806483448000	8975	4488	25	0	\N
87582	1726	806473447000	8975	4488	26	0	\N
87583	1726	806463446000	8975	4488	27	0	\N
87584	1726	806453445000	8975	4488	28	0	\N
87511	1397	1389485082000	8960	4646	2	0	4935
87512	1726	795103278000	8960	4646	3	0	1905
87513	1718	12857522889008	8960	4646	4	0	2
87516	1397	1389475081000	8962	4647	0	0	4936
87517	1726	795093277000	8962	4647	1	0	1906
87519	1397	1389465080000	8963	4648	1	0	4937
87520	1726	795073275000	8964	4649	0	0	1908
87521	1397	1389455079000	8964	4649	1	0	4938
87522	1397	1389445078000	8964	4649	2	0	4939
87523	1726	795063274000	8964	4649	3	0	1909
87525	1726	795053273000	8965	4650	1	0	1910
87527	1397	1389425076000	8967	4651	0	0	4941
87528	1726	795043272000	8967	4651	1	0	1911
87529	1726	795033271000	8967	4651	2	0	1912
87540	1397	1389405074000	8970	4652	0	0	4943
87541	1397	1389395073000	8970	4652	1	0	4944
87542	1726	795023270000	8970	4652	2	0	1913
87543	1726	795013269000	8970	4652	3	0	1914
87544	1941	717951000000	8970	4652	4	0	3
87546	1726	795003268000	8971	4653	1	0	1915
87547	1397	1389375071000	8972	4654	0	0	4946
87548	1397	1389365070000	8972	4654	1	0	4947
87549	1397	1389355069000	8972	4654	2	0	4948
87550	1726	794993267000	8972	4654	3	0	1916
87552	1726	794973265000	8972	4654	5	0	1918
87553	1397	1389345068000	8973	4655	0	0	4949
87554	1726	794963264000	8973	4655	1	0	1919
87585	1726	806443444000	8975	4488	29	0	\N
87586	1726	806433443000	8975	4488	30	0	\N
87587	1726	806423442000	8975	4488	31	0	\N
87588	1726	806413441000	8975	4488	32	0	\N
87589	1726	806403440000	8975	4488	33	0	\N
87590	1726	806393439000	8975	4488	34	0	\N
87591	1726	806383438000	8975	4488	35	0	\N
87592	1726	806373437000	8975	4488	36	0	\N
87593	1726	806363436000	8975	4488	37	0	\N
87594	1726	806353435000	8975	4488	38	0	\N
87595	1726	806343434000	8975	4488	39	0	\N
87596	1726	806333433000	8975	4488	40	0	\N
87597	1726	806323432000	8975	4488	41	0	\N
87598	1726	806313431000	8975	4488	42	0	\N
87599	1726	806303430000	8975	4488	43	0	\N
87600	1726	806293429000	8975	4488	44	0	\N
87601	1726	806283428000	8975	4488	45	0	\N
87602	1726	806273427000	8975	4488	46	0	\N
87603	1726	806263426000	8975	4488	47	0	\N
87604	1726	806253425000	8975	4488	48	0	\N
87605	1726	806243424000	8975	4488	49	0	\N
87606	1726	806233423000	8975	4488	50	0	\N
87607	1726	806223422000	8975	4488	51	0	\N
87608	1726	806213421000	8975	4488	52	0	\N
87609	1726	806203420000	8975	4488	53	0	\N
87610	1726	806193419000	8975	4488	54	0	\N
87611	1726	806183418000	8975	4488	55	0	\N
87612	1726	806173417000	8975	4488	56	0	\N
87613	1726	806163416000	8975	4488	57	0	\N
87614	1726	806153415000	8975	4488	58	0	\N
87615	1726	806143414000	8975	4488	59	0	\N
87616	1726	806133413000	8975	4488	60	0	\N
87617	1726	806123412000	8975	4488	61	0	\N
87618	1726	806113411000	8975	4488	62	0	\N
87621	1726	794953263000	8977	4656	0	0	\N
87622	1397	1389335067000	8977	4656	1	0	\N
87625	1726	794933261000	8979	4658	0	0	\N
87626	1397	1389315065000	8979	4658	1	0	\N
87629	1726	794933261000	8981	4658	0	0	\N
87630	1397	1389315065000	8981	4658	1	0	\N
87633	1397	1389305064000	8983	4659	0	0	\N
87634	1397	1389295063000	8984	4660	0	0	\N
87635	1726	794913259000	8984	4660	1	0	\N
87637	1726	794913259000	8986	4661	0	0	\N
87638	1397	1389285062000	8986	4661	2	0	\N
87639	1726	794903258000	8986	4661	3	0	\N
87640	1726	794893257000	8986	4661	4	0	\N
87641	1397	1389275061000	8986	4661	5	0	\N
87642	1560	28800839000000	8986	4661	6	0	\N
87643	1726	794913259000	8987	4661	0	0	\N
87644	1397	1389285062000	8987	4661	2	0	\N
87645	1726	794903258000	8987	4661	3	0	\N
87646	1726	794893257000	8987	4661	4	0	\N
87647	1397	1389275061000	8987	4661	5	0	\N
87648	1560	28800839000000	8987	4661	6	0	\N
87649	1726	794913259000	8988	4661	0	0	\N
87650	1397	1389285062000	8988	4661	2	0	\N
87651	1726	794903258000	8988	4661	3	0	\N
87652	1726	794893257000	8988	4661	4	0	\N
87653	1397	1389275061000	8988	4661	5	0	\N
87654	1560	28800839000000	8988	4661	6	0	\N
87655	1726	794913259000	8989	4661	0	0	\N
87656	1397	1389285062000	8989	4661	2	0	\N
87657	1726	794903258000	8989	4661	3	0	\N
87658	1726	794893257000	8989	4661	4	0	\N
87659	1397	1389275061000	8989	4661	5	0	\N
87660	1560	28800839000000	8989	4661	6	0	\N
87667	1726	794913259000	8991	4661	0	0	\N
87668	1397	1389285062000	8991	4661	2	0	\N
87669	1726	794903258000	8991	4661	3	0	\N
87670	1726	794893257000	8991	4661	4	0	\N
87671	1397	1389275061000	8991	4661	5	0	\N
87672	1560	28800839000000	8991	4661	6	0	\N
87677	1726	794873255000	8994	4663	0	0	\N
87678	1397	1389255059000	8994	4663	1	0	\N
87684	1397	1389245058000	8996	4664	0	0	\N
87685	1726	794863254000	8996	4664	1	0	\N
87686	1726	794853253000	8996	4664	2	0	\N
87687	1397	1389235057000	8996	4664	3	0	\N
87688	1957	0	8996	4664	4	0	\N
87695	1397	1389225056000	8998	4665	0	0	\N
87696	1726	794843252000	8998	4665	1	0	\N
87697	1726	794833251000	8998	4665	2	0	\N
87698	1726	794823250000	8998	4665	3	0	\N
87699	1397	1389215055000	8998	4665	4	0	\N
87700	1397	1389205054000	8998	4665	5	0	\N
87705	1397	1389175051000	9000	4667	0	0	\N
87706	1726	794793247000	9000	4667	1	0	\N
87707	1397	1389175051000	9001	4667	0	0	\N
87708	1726	794793247000	9001	4667	1	0	\N
87711	1397	1389175051000	9003	4667	0	0	\N
87714	1726	794783246000	9005	4668	0	0	\N
87715	1397	1389165050000	9005	4668	1	0	\N
87718	1726	794763244000	9009	4670	0	0	\N
87719	1726	794753243000	9009	4670	1	0	\N
87720	1397	1389145048000	9009	4670	2	0	\N
87623	1726	794943262000	8978	4657	0	0	1921
87624	1397	1389325066000	8978	4657	1	0	4951
87627	1726	794933261000	8980	4658	0	0	1922
87628	1397	1389315065000	8980	4658	1	0	4952
87631	1726	794923260000	8982	4659	0	0	1923
87636	1397	1389295063000	8985	4660	0	0	4954
87661	1726	794913259000	8990	4661	0	0	1924
87662	1397	1389285062000	8990	4661	2	0	4955
87663	1726	794903258000	8990	4661	3	0	1925
87664	1726	794893257000	8990	4661	4	0	1926
87666	1560	28800839000000	8990	4661	6	0	1
87673	1726	794883256000	8992	4662	0	0	1927
87674	1397	1389265060000	8992	4662	1	0	4957
87675	1726	794873255000	8993	4663	0	0	1928
87679	1397	1389245058000	8995	4664	0	0	4959
87680	1726	794863254000	8995	4664	1	0	1929
87681	1726	794853253000	8995	4664	2	0	1930
87682	1397	1389235057000	8995	4664	3	0	4960
87683	1957	0	8995	4664	4	0	1
87690	1726	794843252000	8997	4665	1	0	1931
87691	1726	794833251000	8997	4665	2	0	1932
87692	1726	794823250000	8997	4665	3	0	1933
87693	1397	1389215055000	8997	4665	4	0	4962
87694	1397	1389205054000	8997	4665	5	0	4963
87702	1726	794803248000	8999	4666	1	0	1935
87703	1397	1389195053000	8999	4666	2	0	4964
87704	1397	1389185052000	8999	4666	3	0	4965
87709	1397	1389175051000	9002	4667	0	0	4966
87712	1726	794783246000	9004	4668	0	0	1937
87713	1397	1389165050000	9004	4668	1	0	4967
87716	1397	1389155049000	9006	4669	0	0	4968
87717	1726	794773245000	9006	4669	1	0	1938
87721	1397	1389135047000	9009	4670	3	0	\N
87726	1726	794763244000	9011	4670	0	0	\N
87727	1726	794753243000	9011	4670	1	0	\N
87728	1397	1389145048000	9011	4670	2	0	\N
87729	1397	1389135047000	9011	4670	3	0	\N
87738	1397	1389085042000	9015	4674	0	0	\N
87739	1726	794703238000	9015	4674	1	0	\N
87751	1726	794653233000	9019	4677	0	0	\N
87752	1397	1389035037000	9019	4677	1	0	\N
87755	1726	794653233000	9021	4677	0	0	\N
87762	1397	1389015035000	9024	4679	0	0	\N
87763	1397	1389005034000	9024	4679	1	0	\N
87764	1726	794633231000	9024	4679	2	0	\N
87765	1726	794623230000	9024	4679	3	0	\N
87766	1397	1388995033000	9025	4680	0	0	\N
87767	1726	794613229000	9025	4680	1	0	\N
87772	1726	794603228000	9028	4681	0	0	\N
87773	1397	1388985032000	9028	4681	1	0	\N
87776	1726	794593227000	9030	4682	0	0	\N
87777	1397	1388975031000	9030	4682	1	0	\N
87778	1397	1388965030000	9031	4683	0	0	\N
87779	1903	0	9031	4683	1	0	\N
87780	1726	794583226000	9031	4683	2	0	\N
87784	1397	1388965030000	9033	4683	0	0	\N
87785	1903	0	9033	4683	1	0	\N
87786	1726	794583226000	9033	4683	2	0	\N
87793	1397	1388935027000	9036	4685	0	0	\N
87794	1726	794553223000	9036	4685	1	0	\N
87797	1726	794543222000	9038	4686	0	0	\N
87798	1397	1388925026000	9038	4686	2	0	\N
87801	1397	1388905024000	9040	4688	0	0	\N
87802	1726	794523220000	9040	4688	1	0	\N
87805	1726	794513219000	9042	4689	0	0	\N
87806	1726	794503218000	9042	4689	1	0	\N
87807	1397	1388895023000	9042	4689	2	0	\N
87808	1397	1388885022000	9042	4689	3	0	\N
87809	687	66700028000000	9042	4689	4	0	\N
87815	724	20000750000000	9045	4429	0	0	\N
87816	1868	3880000000	9045	4429	1	0	\N
87817	1868	780000000	9045	4429	2	0	\N
87818	1726	794493217000	9046	4690	0	0	\N
87819	1726	794483216000	9046	4690	1	0	\N
87820	1397	1388875021000	9046	4690	2	0	\N
87821	1397	1388865020000	9046	4690	3	0	\N
87839	1397	1388855019000	9049	4691	0	0	\N
87840	112	66001047824773	9049	4691	1	0	\N
87841	1397	1388845018000	9049	4691	2	0	\N
87842	1397	1388835017000	9049	4691	3	0	\N
87843	1397	1388825016000	9049	4691	4	0	\N
87844	1397	1388815015000	9049	4691	5	0	\N
87845	1726	794473215000	9049	4691	6	0	\N
87846	1726	794463214000	9049	4691	7	0	\N
87847	1726	794453213000	9049	4691	8	0	\N
87848	1726	793243213000	9049	4691	9	0	\N
87849	1726	793233212000	9049	4691	10	0	\N
87850	1726	793223211000	9049	4691	11	0	\N
87851	687	66000029000000	9049	4691	12	0	\N
87852	1397	1388855019000	9050	4691	0	0	\N
87853	112	66001047824773	9050	4691	1	0	\N
87854	1397	1388845018000	9050	4691	2	0	\N
87855	1397	1388835017000	9050	4691	3	0	\N
87856	1397	1388825016000	9050	4691	4	0	\N
87724	1397	1389145048000	9010	4670	2	0	4969
87725	1397	1389135047000	9010	4670	3	0	4970
87730	1397	1389125046000	9012	4671	0	0	4971
87731	1726	794743242000	9012	4671	1	0	1941
87732	1726	794733241000	9013	4672	0	0	1942
87734	1397	1389115045000	9013	4672	2	0	4972
87735	1397	1389105044000	9013	4672	3	0	4973
87736	1397	1389095043000	9014	4673	0	0	4974
87737	1726	794713239000	9014	4673	1	0	1944
87740	1397	1389085042000	9016	4674	0	0	4975
87742	1726	794693237000	9017	4675	0	0	1946
87743	1726	794683236000	9017	4675	1	0	1947
87744	1397	1389075041000	9017	4675	2	0	4976
87745	1397	1389065040000	9017	4675	3	0	4977
87747	1726	794673235000	9018	4676	1	0	1948
87748	1397	1389045038000	9018	4676	2	0	4979
87749	1726	794663234000	9018	4676	3	0	1949
87750	667	66000095000000	9018	4676	4	0	1
87753	1726	794653233000	9020	4677	0	0	1950
87756	1397	1389025036000	9022	4678	0	0	4981
87757	1726	794643232000	9022	4678	1	0	1951
87758	1397	1389015035000	9023	4679	0	0	4982
87759	1397	1389005034000	9023	4679	1	0	4983
87760	1726	794633231000	9023	4679	2	0	1952
87768	1397	1388995033000	9026	4680	0	0	4984
87769	1726	794613229000	9026	4680	1	0	1954
87770	1726	794603228000	9027	4681	0	0	1955
87771	1397	1388985032000	9027	4681	1	0	4985
87775	1397	1388975031000	9029	4682	1	0	4986
87781	1397	1388965030000	9032	4683	0	0	4987
87782	1903	0	9032	4683	1	0	1
87783	1726	794583226000	9032	4683	2	0	1957
87787	1397	1388955029000	9034	4684	0	0	4988
87789	1726	794573225000	9034	4684	2	0	1958
87790	1726	794563224000	9034	4684	3	0	1959
87791	1397	1388935027000	9035	4685	0	0	4990
87792	1726	794553223000	9035	4685	1	0	1960
87795	1726	794543222000	9037	4686	0	0	1961
87799	1397	1388915025000	9039	4687	0	0	4992
87800	1726	794533221000	9039	4687	1	0	1962
87803	1397	1388905024000	9041	4688	0	0	4993
87804	1726	794523220000	9041	4688	1	0	1963
87811	1726	794503218000	9044	4689	1	0	1965
87812	1397	1388895023000	9044	4689	2	0	4994
87813	1397	1388885022000	9044	4689	3	0	4995
87814	687	66700028000000	9044	4689	4	0	2
87822	1726	794493217000	9047	4690	0	0	1966
87824	1397	1388875021000	9047	4690	2	0	4996
87825	1397	1388865020000	9047	4690	3	0	4997
87826	1397	1388855019000	9048	4691	0	0	4998
87827	112	66001047824773	9048	4691	1	0	3
87828	1397	1388845018000	9048	4691	2	0	4999
87830	1397	1388825016000	9048	4691	4	0	5001
87831	1397	1388815015000	9048	4691	5	0	5002
87832	1726	794473215000	9048	4691	6	0	1968
87833	1726	794463214000	9048	4691	7	0	1969
87835	1726	793243213000	9048	4691	9	0	1971
87836	1726	793233212000	9048	4691	10	0	1972
87837	1726	793223211000	9048	4691	11	0	1973
87838	687	66000029000000	9048	4691	12	0	3
87857	1397	1388815015000	9050	4691	5	0	\N
87858	1726	794473215000	9050	4691	6	0	\N
87859	1726	794463214000	9050	4691	7	0	\N
87860	1726	794453213000	9050	4691	8	0	\N
87861	1726	793243213000	9050	4691	9	0	\N
87862	1726	793233212000	9050	4691	10	0	\N
87863	1726	793223211000	9050	4691	11	0	\N
87864	687	66000029000000	9050	4691	12	0	\N
87865	1726	793213210000	9051	4692	0	0	\N
87866	1397	1388805014000	9051	4692	1	0	\N
87869	1726	793203209000	9053	4693	0	0	\N
87870	1397	1388795013000	9053	4693	1	0	\N
87878	1397	1388785012000	9056	4694	0	0	\N
87879	1726	793193208000	9056	4694	1	0	\N
87880	1726	793183207000	9056	4694	2	0	\N
87881	1397	1388775011000	9056	4694	3	0	\N
87882	409	66000000000000	9056	4694	4	0	\N
87883	1397	1388785012000	9057	4694	0	0	\N
87884	1726	793193208000	9057	4694	1	0	\N
87885	1726	793183207000	9057	4694	2	0	\N
87886	1397	1388775011000	9057	4694	3	0	\N
87887	409	66000000000000	9057	4694	4	0	\N
87890	1726	793163205000	9059	4696	0	0	\N
87891	1397	1388755009000	9059	4696	1	0	\N
87898	1397	1388745008000	9062	4697	0	0	\N
87899	1397	1388735007000	9062	4697	1	0	\N
87900	1726	793153204000	9062	4697	2	0	\N
87901	1726	793143203000	9062	4697	3	0	\N
87902	1726	791933203000	9063	4698	0	0	\N
87903	1726	791923202000	9063	4698	1	0	\N
87904	1397	1388725006000	9063	4698	2	0	\N
87917	1397	1388685002000	9069	4701	0	0	\N
87918	1726	791883198000	9069	4701	1	0	\N
87950	1516	15154709112008	9077	4708	0	0	\N
87951	1397	1388564990000	9077	4708	1	0	\N
87952	1397	1388554989000	9077	4708	2	0	\N
87953	1516	10891963511560	9077	4708	4	0	\N
87954	1516	8015800860938	9077	4708	5	0	\N
87955	1726	791763186000	9077	4708	6	0	\N
87956	1726	791753185000	9077	4708	7	0	\N
87957	1397	1388544988000	9078	4709	0	0	\N
87958	1726	791743184000	9078	4709	1	0	\N
87964	1397	1388534987000	9081	4710	0	0	\N
87965	261	66000067824773	9081	4710	1	0	\N
87966	1726	791743184000	9081	4710	2	0	\N
87967	1726	791733183000	9081	4710	3	0	\N
87968	1397	1388534987000	9082	4710	0	0	\N
87969	261	66000067824773	9082	4710	1	0	\N
87970	1726	791743184000	9082	4710	2	0	\N
87971	1397	1388534987000	9083	4710	0	0	\N
87972	261	66000067824773	9083	4710	1	0	\N
87973	1397	1388524986000	9084	4711	0	0	\N
87974	1540	365307000000	9084	4711	1	0	\N
87977	1885	0	9086	4687	0	0	\N
87978	1756	1906509808900	9086	4687	1	0	\N
87979	1516	15154709112008	9086	4687	2	0	\N
87980	1397	1388915025000	9086	4687	3	0	\N
87981	1397	1388905024000	9086	4687	4	0	\N
87982	193	66000067824773	9086	4687	5	0	\N
87983	112	66001047824773	9086	4687	6	0	\N
87984	261	66000067824773	9086	4687	7	0	\N
87985	1516	10891963511560	9086	4687	8	0	\N
87986	1516	8015800860938	9086	4687	9	0	\N
87987	1726	794533221000	9086	4687	10	0	\N
87988	1726	794523220000	9086	4687	11	0	\N
87989	1726	794513219000	9086	4687	12	0	\N
87990	1726	794503218000	9086	4687	13	0	\N
87991	1726	794493217000	9086	4687	14	0	\N
87992	1726	794483216000	9086	4687	15	0	\N
87871	1726	793203209000	9054	4693	0	0	1975
87872	1397	1388795013000	9054	4693	1	0	5004
87873	1397	1388785012000	9055	4694	0	0	5005
87874	1726	793193208000	9055	4694	1	0	1976
87875	1726	793183207000	9055	4694	2	0	1977
87877	409	66000000000000	9055	4694	4	0	1
87888	1397	1388765010000	9058	4695	0	0	5007
87889	1726	793173206000	9058	4695	1	0	1978
87892	1726	793163205000	9060	4696	0	0	1979
87893	1397	1388755009000	9060	4696	1	0	5008
87895	1397	1388735007000	9061	4697	1	0	5010
87896	1726	793153204000	9061	4697	2	0	1980
87897	1726	793143203000	9061	4697	3	0	1981
87905	1726	791933203000	9064	4698	0	0	1982
87907	1397	1388725006000	9064	4698	2	0	5011
87908	1397	1388715005000	9065	4699	0	0	5012
87909	1726	791913201000	9065	4699	1	0	1984
87910	193	66000067824773	9067	4700	0	0	1
87911	1397	1388705004000	9067	4700	1	0	5013
87913	1726	791903200000	9067	4700	3	0	1985
87914	1726	791893199000	9067	4700	4	0	1986
87915	1397	1388685002000	9068	4701	0	0	5015
87916	1726	791883198000	9068	4701	1	0	1987
87919	1756	1906509808900	9070	4702	0	0	3
87921	1726	791863196000	9070	4702	2	0	1989
87922	1397	1388675001000	9070	4702	3	0	5016
87923	1726	791853195000	9070	4702	4	0	1990
87924	1726	791843194000	9070	4702	5	0	1991
87926	1397	1388665000000	9070	4702	7	0	5017
87927	1397	1388654999000	9070	4702	8	0	5018
87928	1397	1388644998000	9070	4702	9	0	5019
87929	1397	1388634997000	9070	4702	10	0	5020
87930	1726	791823192000	9071	4703	0	0	1993
87932	1885	0	9072	4704	0	0	2
87933	1726	791813191000	9072	4704	1	0	1994
87934	1726	791803190000	9072	4704	2	0	1995
87935	1397	1388614995000	9072	4704	3	0	5022
87936	1397	1388604994000	9072	4704	4	0	5023
87938	1726	791793189000	9073	4705	1	0	1996
87939	1726	791783188000	9074	4706	0	0	1997
87940	1397	1388584992000	9074	4706	1	0	5025
87941	1726	791773187000	9075	4707	0	0	1998
87943	1516	15154709112008	9076	4708	0	0	3
87944	1397	1388564990000	9076	4708	1	0	5027
87945	1397	1388554989000	9076	4708	2	0	5028
87946	1516	10891963511560	9076	4708	4	0	4
87947	1516	8015800860938	9076	4708	5	0	5
87949	1726	791753185000	9076	4708	7	0	2000
87959	1397	1388544988000	9079	4709	0	0	5029
87960	1397	1388534987000	9080	4710	0	0	5030
87961	261	66000067824773	9080	4710	1	0	1
87962	1726	791743184000	9080	4710	2	0	2001
87975	1397	1388524986000	9085	4711	0	0	5031
87976	1540	365307000000	9085	4711	1	0	3
87993	1397	1388895023000	9086	4687	16	0	\N
87994	1397	1388885022000	9086	4687	17	0	\N
87995	1397	1388875021000	9086	4687	18	0	\N
87996	1397	1388865020000	9086	4687	19	0	\N
87997	1397	1388855019000	9086	4687	20	0	\N
87998	1397	1388845018000	9086	4687	21	0	\N
87999	1397	1388835017000	9086	4687	22	0	\N
88000	1397	1388825016000	9086	4687	23	0	\N
88001	1397	1388815015000	9086	4687	24	0	\N
88002	1397	1388805014000	9086	4687	25	0	\N
88003	1397	1388795013000	9086	4687	26	0	\N
88004	1397	1388785012000	9086	4687	27	0	\N
88005	1397	1388775011000	9086	4687	28	0	\N
88006	1397	1388765010000	9086	4687	29	0	\N
88007	1397	1388755009000	9086	4687	30	0	\N
88008	1397	1388745008000	9086	4687	31	0	\N
88009	1397	1388735007000	9086	4687	32	0	\N
88010	1397	1388725006000	9086	4687	33	0	\N
88011	1397	1388715005000	9086	4687	34	0	\N
88017	55	67439030000000	9088	4488	0	0	\N
88018	55	68159050000000	9089	4713	0	0	\N
88019	1516	0	9089	4713	1	0	\N
88020	1397	1388494983000	9089	4713	2	0	\N
88021	1397	1388484982000	9089	4713	3	0	\N
88022	1397	1388474981000	9089	4713	4	0	\N
88023	1726	791703180000	9089	4713	5	0	\N
88024	1726	791693179000	9089	4713	6	0	\N
88025	1726	791683178000	9089	4713	7	0	\N
88026	1726	790473178000	9089	4713	8	0	\N
88027	1963	999000000	9089	4713	9	0	\N
88028	1540	0	9089	4713	10	0	\N
88040	55	68159050000000	9091	4713	0	0	\N
88041	1516	0	9091	4713	1	0	\N
88042	1397	1388494983000	9091	4713	2	0	\N
88043	1397	1388484982000	9091	4713	3	0	\N
88044	1397	1388474981000	9091	4713	4	0	\N
88045	1726	791703180000	9091	4713	5	0	\N
88046	1726	791693179000	9091	4713	6	0	\N
88047	1726	791683178000	9091	4713	7	0	\N
88048	1726	790473178000	9091	4713	8	0	\N
88049	1963	999000000	9091	4713	9	0	\N
88050	1540	0	9091	4713	10	0	\N
88051	55	68159050000000	9092	4713	0	0	\N
88052	1516	0	9092	4713	1	0	\N
88053	1397	1388494983000	9092	4713	2	0	\N
88054	1397	1388484982000	9092	4713	3	0	\N
88055	1397	1388474981000	9092	4713	4	0	\N
88056	1726	791703180000	9092	4713	5	0	\N
88057	1726	791693179000	9092	4713	6	0	\N
88058	1726	791683178000	9092	4713	7	0	\N
88059	1726	790473178000	9092	4713	8	0	\N
88060	1963	999000000	9092	4713	9	0	\N
88061	1540	0	9092	4713	10	0	\N
88062	55	67439030000000	9093	4501	0	0	\N
88063	55	67439030000000	9094	4515	0	0	\N
88064	55	67439030000000	9095	4528	0	0	\N
88065	1726	790463177000	9096	4714	0	0	\N
88066	1397	1388464980000	9096	4714	1	0	\N
88069	1726	790463177000	9098	4714	0	0	\N
88070	1397	1388464980000	9098	4714	1	0	\N
88076	1726	790433174000	9101	4717	0	0	\N
88077	1397	1388434977000	9101	4717	1	0	\N
88080	1726	790433174000	9103	4717	0	0	\N
88081	1397	1388434977000	9103	4717	1	0	\N
88082	1726	790433174000	9104	4717	0	0	\N
88083	1397	1388434977000	9104	4717	1	0	\N
88088	1726	790413172000	9107	4719	0	0	\N
88089	1397	1388414975000	9107	4719	1	0	\N
88090	1726	790403171000	9108	4720	0	0	\N
88091	1397	1388404974000	9108	4720	1	0	\N
88092	1726	790403171000	9109	4720	0	0	\N
88093	1397	1388404974000	9109	4720	1	0	\N
88102	1397	1388384972000	9113	4722	0	0	\N
88103	1397	1388374971000	9113	4722	1	0	\N
88104	1726	790383169000	9113	4722	2	0	\N
88105	1726	790373168000	9113	4722	3	0	\N
88110	1726	790343165000	9116	4724	0	0	\N
88111	1726	790333164000	9116	4724	1	0	\N
88112	1397	1388344968000	9116	4724	2	0	\N
88113	1397	1388334967000	9116	4724	3	0	\N
88114	1726	790343165000	9117	4724	0	0	\N
88115	1726	790333164000	9117	4724	1	0	\N
88116	1397	1388344968000	9117	4724	2	0	\N
88117	1397	1388334967000	9117	4724	3	0	\N
88122	1726	790343165000	9119	4724	0	0	\N
88123	1726	790333164000	9119	4724	1	0	\N
88124	1397	1388344968000	9119	4724	2	0	\N
88125	1397	1388334967000	9119	4724	3	0	\N
88126	1397	1388324966000	9121	4725	0	0	\N
88127	1726	790323163000	9121	4725	1	0	\N
88128	1397	1388324966000	9122	4725	0	0	\N
88014	1726	791713181000	9087	4712	2	0	2004
88015	1397	1388514985000	9087	4712	3	0	5032
88016	1397	1388504984000	9087	4712	4	0	5033
88029	55	68159050000000	9090	4713	0	0	1
88030	1516	0	9090	4713	1	0	7
88032	1397	1388484982000	9090	4713	3	0	5035
88033	1397	1388474981000	9090	4713	4	0	5036
88034	1726	791703180000	9090	4713	5	0	2005
88035	1726	791693179000	9090	4713	6	0	2006
88036	1726	791683178000	9090	4713	7	0	2007
88038	1963	999000000	9090	4713	9	0	1
88039	1540	0	9090	4713	10	0	4
88067	1726	790463177000	9097	4714	0	0	2009
88068	1397	1388464980000	9097	4714	1	0	5037
88072	1397	1388454979000	9099	4715	1	0	5038
88073	1726	790453176000	9099	4715	2	0	2010
88074	1397	1388444978000	9100	4716	0	0	5039
88075	1726	790443175000	9100	4716	1	0	2011
88078	1726	790433174000	9102	4717	0	0	2012
88084	1397	1388424976000	9105	4718	0	0	5041
88085	1726	790423173000	9105	4718	1	0	2013
88086	1726	790413172000	9106	4719	0	0	2014
88087	1397	1388414975000	9106	4719	1	0	5042
88094	1726	790403171000	9110	4720	0	0	2015
88096	1397	1388394973000	9111	4721	0	0	5044
88097	1726	790393170000	9111	4721	1	0	2016
88098	1397	1388384972000	9112	4722	0	0	5045
88099	1397	1388374971000	9112	4722	1	0	5046
88101	1726	790373168000	9112	4722	3	0	2018
88106	1397	1388364970000	9114	4723	0	0	5047
88107	1726	790363167000	9114	4723	1	0	2019
88108	1397	1388354969000	9114	4723	2	0	5048
88109	1726	790353166000	9114	4723	3	0	2020
88119	1726	790333164000	9118	4724	1	0	2022
88120	1397	1388344968000	9118	4724	2	0	5049
88121	1397	1388334967000	9118	4724	3	0	5050
88129	1726	790323163000	9122	4725	1	0	\N
88136	1397	1388314965000	9125	4726	0	0	\N
88137	1397	1388304964000	9125	4726	1	0	\N
88138	1726	790313162000	9125	4726	2	0	\N
88139	1726	790303161000	9125	4726	3	0	\N
88140	1397	1388294963000	9126	4727	0	0	\N
88141	1726	790293160000	9126	4727	1	0	\N
88144	1885	0	9128	4600	0	0	\N
88145	1756	1186489808900	9128	4600	1	0	\N
88146	55	67439030000000	9128	4600	2	0	\N
88147	1516	15154709112008	9128	4600	3	0	\N
88148	193	66000067824773	9128	4600	4	0	\N
88149	1903	0	9128	4600	5	0	\N
88150	112	66001047824773	9128	4600	6	0	\N
88151	261	66000067824773	9128	4600	7	0	\N
88152	1516	10891963511560	9128	4600	8	0	\N
88153	1516	8015800860938	9128	4600	9	0	\N
88154	1941	717951000000	9128	4600	10	0	\N
88155	667	66000095000000	9128	4600	11	0	\N
88156	1560	28800839000000	9128	4600	12	0	\N
88157	409	66000000000000	9128	4600	13	0	\N
88158	1540	365307000000	9128	4600	14	0	\N
88159	1540	0	9128	4600	15	0	\N
88160	687	66700028000000	9128	4600	16	0	\N
88161	687	66000029000000	9128	4600	17	0	\N
88166	1397	1388264960000	9130	4729	0	0	\N
88171	1397	1388254959000	9133	4730	0	0	\N
88172	1726	790253156000	9133	4730	1	0	\N
88177	1397	1388234957000	9136	4732	0	0	\N
88178	1726	790233154000	9136	4732	1	0	\N
88181	1726	790213152000	9138	4734	0	0	\N
88182	1397	1388214955000	9138	4734	1	0	\N
88194	1726	788983150000	9143	4737	0	0	\N
88195	1397	1388184952000	9143	4737	1	0	\N
88196	1397	1388174951000	9143	4737	2	0	\N
88197	1726	788973149000	9143	4737	3	0	\N
88198	1726	788963148000	9143	4737	4	0	\N
88206	1726	787713144000	9145	4739	0	0	\N
88207	1397	1388134947000	9145	4739	1	0	\N
88208	1397	1388124946000	9145	4739	2	0	\N
88209	1726	787703143000	9145	4739	3	0	\N
88210	1726	787713144000	9146	4739	0	0	\N
88211	1397	1388134947000	9146	4739	1	0	\N
88212	1397	1388124946000	9146	4739	2	0	\N
88213	1726	787703143000	9146	4739	3	0	\N
88214	1726	787713144000	9147	4739	0	0	\N
88215	1397	1388134947000	9147	4739	1	0	\N
88216	1397	1388124946000	9147	4739	2	0	\N
88217	1726	787703143000	9147	4739	3	0	\N
88226	1726	787693142000	9150	4740	0	0	\N
88227	1397	1388114945000	9150	4740	1	0	\N
88228	1397	1388104944000	9150	4740	2	0	\N
88229	1726	787683141000	9150	4740	3	0	\N
88232	1726	787673140000	9152	4741	0	0	\N
88233	1397	1388094943000	9152	4741	1	0	\N
88236	1726	787653138000	9154	4743	0	0	\N
88237	1397	1388074941000	9154	4743	1	0	\N
88242	1726	787633136000	9157	4745	0	0	\N
88243	1397	1388054939000	9157	4745	1	0	\N
88248	1726	787623135000	9160	4746	0	0	\N
88249	1397	1388044938000	9160	4746	1	0	\N
88258	1726	787573130000	9162	4748	0	0	\N
88259	1726	787563129000	9162	4748	1	0	\N
88260	1397	1387994933000	9162	4748	2	0	\N
88261	1397	1387984932000	9162	4748	3	0	\N
88132	1397	1388314965000	9124	4726	0	0	5052
88133	1397	1388304964000	9124	4726	1	0	5053
88134	1726	790313162000	9124	4726	2	0	2024
88135	1726	790303161000	9124	4726	3	0	2025
88142	1397	1388294963000	9127	4727	0	0	5054
88162	1726	790283159000	9129	4728	0	0	2027
88163	1726	790273158000	9129	4728	1	0	2028
88164	1397	1388284962000	9129	4728	2	0	5055
88165	1397	1388274961000	9129	4728	3	0	5056
88167	1397	1388264960000	9131	4729	0	0	5057
88169	1397	1388254959000	9132	4730	0	0	5058
88170	1726	790253156000	9132	4730	1	0	2030
88173	1397	1388244958000	9134	4731	0	0	5059
88174	1726	790243155000	9134	4731	1	0	2031
88176	1726	790233154000	9135	4732	1	0	2032
88179	1397	1388224956000	9137	4733	0	0	5061
88180	1726	790223153000	9137	4733	2	0	2033
88183	1726	790213152000	9139	4734	0	0	2034
88184	1397	1388214955000	9139	4734	1	0	5062
88186	1726	790203151000	9140	4735	1	0	2035
88187	1397	1388194953000	9141	4736	0	0	5064
88188	1726	790193150000	9141	4736	1	0	2036
88189	1726	788983150000	9142	4737	0	0	2037
88190	1397	1388184952000	9142	4737	1	0	5065
88192	1726	788973149000	9142	4737	3	0	2038
88193	1726	788963148000	9142	4737	4	0	2039
88199	1397	1388164950000	9144	4738	0	0	5067
88200	1726	788953147000	9144	4738	1	0	2040
88202	1397	1388154949000	9144	4738	3	0	5068
88203	1397	1388144948000	9144	4738	4	0	5069
88204	1726	787733146000	9144	4738	5	0	2042
88205	1726	787723145000	9144	4738	6	0	2043
88218	1726	787713144000	9148	4739	0	0	2044
88220	1397	1388124946000	9148	4739	2	0	5071
88221	1726	787703143000	9148	4739	3	0	2045
88222	1726	787693142000	9149	4740	0	0	2046
88223	1397	1388114945000	9149	4740	1	0	5072
88224	1397	1388104944000	9149	4740	2	0	5073
88230	1726	787673140000	9151	4741	0	0	2048
88231	1397	1388094943000	9151	4741	1	0	5074
88234	1726	787663139000	9153	4742	0	0	2049
88235	1397	1388084942000	9153	4742	1	0	5075
88239	1397	1388074941000	9155	4743	1	0	5076
88240	1726	787643137000	9156	4744	0	0	2051
88241	1397	1388064940000	9156	4744	1	0	5077
88244	1726	787633136000	9158	4745	0	0	2052
88245	1397	1388054939000	9158	4745	1	0	5078
88247	1397	1388044938000	9159	4746	1	0	5079
88250	1397	1388034937000	9161	4747	0	0	5080
88251	1397	1388024936000	9161	4747	1	0	5081
88252	1397	1388014935000	9161	4747	2	0	5082
88253	1397	1388004934000	9161	4747	3	0	5083
88255	1726	787603133000	9161	4747	5	0	2055
88256	1726	787593132000	9161	4747	6	0	2056
88257	1726	787583131000	9161	4747	7	0	2057
88262	1726	787573130000	9163	4748	0	0	2058
88264	1397	1387994933000	9163	4748	2	0	5084
88272	1397	1387954929000	9167	4751	0	0	\N
88273	1726	787533126000	9167	4751	1	0	\N
88274	1726	787523125000	9169	4752	0	0	\N
88275	1397	1387944928000	9169	4752	1	0	\N
88281	1397	1387934927000	9172	4753	0	0	\N
88282	1726	787513124000	9172	4753	1	0	\N
88283	262	66000088000000	9172	4753	2	0	\N
88296	1397	1387894923000	9176	4756	0	0	\N
88297	1726	787473120000	9176	4756	1	0	\N
88298	1397	1387894923000	9177	4756	0	0	\N
88299	1726	787473120000	9177	4756	1	0	\N
88300	1397	1387894923000	9178	4756	0	0	\N
88301	1726	787473120000	9178	4756	1	0	\N
88308	1397	1387884922000	9180	4757	0	0	\N
88309	1726	787463119000	9180	4757	1	0	\N
88310	1726	787453118000	9180	4757	2	0	\N
88311	1726	787443117000	9180	4757	3	0	\N
88312	1397	1387874921000	9180	4757	5	0	\N
88313	1397	1387864920000	9180	4757	6	0	\N
88314	1397	1387884922000	9181	4757	0	0	\N
88315	1726	787463119000	9181	4757	1	0	\N
88316	1726	787453118000	9181	4757	2	0	\N
88317	1726	787443117000	9181	4757	3	0	\N
88318	1397	1387874921000	9181	4757	5	0	\N
88319	1397	1387864920000	9181	4757	6	0	\N
88331	1397	1387794913000	9186	4762	0	0	\N
88332	1397	1387784912000	9186	4762	1	0	\N
88333	1726	787383111000	9186	4762	2	0	\N
88334	1726	787373110000	9186	4762	3	0	\N
88335	1397	1387794913000	9187	4762	0	0	\N
88336	1397	1387784912000	9187	4762	1	0	\N
88337	1726	787383111000	9187	4762	2	0	\N
88338	1726	787373110000	9187	4762	3	0	\N
88343	1726	787363109000	9189	4763	0	0	\N
88344	1726	787353108000	9189	4763	1	0	\N
88345	1397	1387774911000	9189	4763	2	0	\N
88346	1397	1387764910000	9189	4763	3	0	\N
88351	1726	787363109000	9191	4763	0	0	\N
88352	1726	787353108000	9191	4763	1	0	\N
88353	1397	1387774911000	9191	4763	2	0	\N
88354	1397	1387764910000	9191	4763	3	0	\N
88355	262	66000088000000	9192	4601	0	0	\N
88356	262	66000077000000	9192	4601	1	0	\N
88357	262	66000066000000	9192	4601	2	0	\N
88372	55	67125247000000	9196	4766	0	0	\N
88373	1726	787323105000	9196	4766	1	0	\N
88374	55	66870658500000	9196	4766	2	0	\N
88375	1397	1387734907000	9196	4766	3	0	\N
88376	1919	149000000	9196	4766	4	0	\N
88377	1885	0	9197	4570	0	0	\N
88378	1756	1186489808900	9197	4570	1	0	\N
88379	55	67439030000000	9197	4570	2	0	\N
88380	1516	15154709112008	9197	4570	3	0	\N
88381	193	66000067824773	9197	4570	4	0	\N
88382	1397	1389655099000	9197	4570	5	0	\N
88383	55	67435162750000	9197	4570	6	0	\N
88384	1397	1389645098000	9197	4570	7	0	\N
88385	1903	0	9197	4570	8	0	\N
88386	1397	1389635097000	9197	4570	9	0	\N
88387	112	66001047824773	9197	4570	10	0	\N
88388	1397	1389625096000	9197	4570	11	0	\N
88389	1397	1389615095000	9197	4570	12	0	\N
88390	1397	1389605094000	9197	4570	13	0	\N
88391	55	67423581000000	9197	4570	14	0	\N
88392	261	66000067824773	9197	4570	15	0	\N
88393	55	67168992500000	9197	4570	16	0	\N
88394	55	66914404000000	9197	4570	17	0	\N
88395	55	66659815500000	9197	4570	18	0	\N
88396	55	66405227000000	9197	4570	19	0	\N
88397	55	66150638500000	9197	4570	20	0	\N
88398	1516	10891963511560	9197	4570	21	0	\N
88399	1516	8015800860938	9197	4570	22	0	\N
88400	1397	1389595093000	9197	4570	23	0	\N
88267	1726	787553128000	9164	4749	1	0	2060
88268	1726	787543127000	9165	4750	0	0	2061
88269	1397	1387964930000	9165	4750	1	0	5087
88270	1397	1387954929000	9166	4751	0	0	5088
88271	1726	787533126000	9166	4751	1	0	2062
88277	1397	1387944928000	9170	4752	1	0	5089
88278	1397	1387934927000	9171	4753	0	0	5090
88279	1726	787513124000	9171	4753	1	0	2064
88280	262	66000088000000	9171	4753	2	0	2
88284	1397	1387924926000	9173	4754	0	0	5091
88286	262	66000077000000	9173	4754	2	0	3
88287	262	66000066000000	9173	4754	3	0	4
88288	1397	1387914925000	9174	4755	0	0	5092
88289	1397	1387904924000	9174	4755	1	0	5093
88291	425	66000000000000	9174	4755	3	0	1
88292	1726	787493122000	9174	4755	4	0	2066
88293	1726	787483121000	9174	4755	5	0	2067
88294	1397	1387894923000	9175	4756	0	0	5094
88295	1726	787473120000	9175	4756	1	0	2068
88303	1726	787463119000	9179	4757	1	0	2069
88304	1726	787453118000	9179	4757	2	0	2070
88305	1726	787443117000	9179	4757	3	0	2071
88306	1397	1387874921000	9179	4757	5	0	5096
88307	1397	1387864920000	9179	4757	6	0	5097
88321	1397	1387854919000	9182	4758	1	0	5098
88322	1397	1387844918000	9183	4759	0	0	5099
88323	1726	787423115000	9183	4759	1	0	2073
88324	1397	1387834917000	9184	4760	0	0	5100
88326	1397	1387814915000	9184	4760	2	0	5102
88327	1726	787413114000	9184	4760	3	0	2074
88328	1726	787403113000	9184	4760	4	0	2075
88329	1726	787393112000	9185	4761	0	0	2076
88330	1397	1387804914000	9185	4761	1	0	5103
88340	1397	1387784912000	9188	4762	1	0	5105
88341	1726	787383111000	9188	4762	2	0	2077
88342	1726	787373110000	9188	4762	3	0	2078
88347	1726	787363109000	9190	4763	0	0	2079
88348	1726	787353108000	9190	4763	1	0	2080
88350	1397	1387764910000	9190	4763	3	0	5107
88358	55	68155182750000	9193	4764	0	0	2
88359	1397	1387754909000	9193	4764	1	0	5108
88360	1726	787343107000	9193	4764	2	0	2081
88362	55	68143601000000	9194	4765	1	0	3
88363	55	67889012500000	9194	4765	2	0	4
88364	55	67634424000000	9194	4765	3	0	5
88365	55	67379835500000	9194	4765	4	0	6
88366	1397	1387744908000	9194	4765	5	0	5109
88368	1726	787323105000	9195	4766	1	0	2083
88369	55	66870658500000	9195	4766	2	0	8
88370	1397	1387734907000	9195	4766	3	0	5110
88371	1919	149000000	9195	4766	4	0	2
88401	1397	1389585092000	9197	4570	24	0	\N
88402	1397	1389575091000	9197	4570	25	0	\N
88403	1397	1389565090000	9197	4570	26	0	\N
88404	1397	1389555089000	9197	4570	27	0	\N
88405	1397	1389545088000	9197	4570	28	0	\N
88406	1397	1389535087000	9197	4570	29	0	\N
88407	1397	1389525086000	9197	4570	30	0	\N
88408	1397	1389515085000	9197	4570	31	0	\N
88409	1397	1389505084000	9197	4570	32	0	\N
88410	1397	1389495083000	9197	4570	33	0	\N
88411	1397	1389485082000	9197	4570	34	0	\N
88412	1397	1389475081000	9197	4570	35	0	\N
88413	1397	1389465080000	9197	4570	36	0	\N
88414	1397	1389455079000	9197	4570	37	0	\N
88415	1397	1389445078000	9197	4570	38	0	\N
88416	1397	1389435077000	9197	4570	39	0	\N
88417	1397	1389425076000	9197	4570	40	0	\N
88418	1397	1389415075000	9197	4570	41	0	\N
88419	1397	1389405074000	9197	4570	42	0	\N
88420	1397	1389395073000	9197	4570	43	0	\N
88421	1397	1389385072000	9197	4570	44	0	\N
88422	1397	1389375071000	9197	4570	45	0	\N
88423	1397	1389365070000	9197	4570	46	0	\N
88424	1397	1389355069000	9197	4570	47	0	\N
88425	1397	1389345068000	9197	4570	48	0	\N
88426	1397	1389335067000	9197	4570	49	0	\N
88427	1397	1389325066000	9197	4570	50	0	\N
88428	1397	1389315065000	9197	4570	51	0	\N
88429	1397	1389305064000	9197	4570	52	0	\N
88430	1397	1389295063000	9197	4570	53	0	\N
88431	1397	1389285062000	9197	4570	54	0	\N
88432	1397	1389275061000	9197	4570	55	0	\N
88433	1397	1389265060000	9197	4570	56	0	\N
88434	1397	1389255059000	9197	4570	57	0	\N
88435	1397	1389245058000	9197	4570	58	0	\N
88436	1397	1389235057000	9197	4570	59	0	\N
88437	1397	1389225056000	9197	4570	60	0	\N
88438	1397	1389215055000	9197	4570	61	0	\N
88439	1397	1389205054000	9197	4570	62	0	\N
88440	1397	1389195053000	9197	4570	63	0	\N
88441	1397	1389185052000	9197	4570	64	0	\N
88442	1397	1389175051000	9197	4570	65	0	\N
88443	1397	1389165050000	9197	4570	66	0	\N
88444	1397	1389155049000	9197	4570	68	0	\N
88445	1397	1389145048000	9197	4570	69	0	\N
88446	1397	1389135047000	9197	4570	70	0	\N
88447	1397	1389125046000	9197	4570	71	0	\N
88448	1397	1389115045000	9197	4570	72	0	\N
88449	1397	1389105044000	9197	4570	73	0	\N
88450	1397	1389095043000	9197	4570	74	0	\N
88451	1397	1389085042000	9197	4570	75	0	\N
88452	1397	1389075041000	9197	4570	76	0	\N
88453	1397	1389065040000	9197	4570	77	0	\N
88454	1397	1389055039000	9197	4570	78	0	\N
88455	1397	1389045038000	9197	4570	79	0	\N
88456	1397	1389035037000	9197	4570	80	0	\N
88457	1397	1389025036000	9197	4570	81	0	\N
88458	1397	1389015035000	9197	4570	82	0	\N
88459	1397	1389005034000	9197	4570	83	0	\N
88460	1397	1388995033000	9197	4570	84	0	\N
88461	1397	1388985032000	9197	4570	85	0	\N
88462	1397	1388975031000	9197	4570	86	0	\N
88463	1397	1388965030000	9197	4570	87	0	\N
88464	1397	1388955029000	9197	4570	88	0	\N
88465	1397	1388945028000	9197	4570	89	0	\N
88466	1397	1388935027000	9197	4570	90	0	\N
88467	1397	1388925026000	9197	4570	91	0	\N
88468	1397	1388915025000	9197	4570	92	0	\N
88469	1397	1388905024000	9197	4570	93	0	\N
88470	1397	1388895023000	9197	4570	94	0	\N
88471	1397	1388885022000	9197	4570	95	0	\N
88472	1397	1388875021000	9197	4570	96	0	\N
88473	1397	1388865020000	9197	4570	97	0	\N
88474	1397	1388855019000	9197	4570	98	0	\N
88475	1397	1388845018000	9197	4570	99	0	\N
88476	1397	1388835017000	9197	4570	100	0	\N
88477	1397	1388825016000	9197	4570	101	0	\N
88478	1397	1388815015000	9197	4570	102	0	\N
88479	1397	1388805014000	9197	4570	103	0	\N
88480	1397	1388795013000	9197	4570	104	0	\N
88481	1397	1388785012000	9197	4570	105	0	\N
88482	1397	1388775011000	9197	4570	106	0	\N
88483	1397	1388765010000	9197	4570	107	0	\N
88484	1397	1388755009000	9197	4570	108	0	\N
88485	1397	1388745008000	9197	4570	109	0	\N
88486	1397	1388735007000	9197	4570	110	0	\N
88487	1397	1388725006000	9197	4570	111	0	\N
88488	1397	1388715005000	9197	4570	112	0	\N
88489	1397	1388705004000	9197	4570	113	0	\N
88490	1397	1388695003000	9197	4570	114	0	\N
88491	1397	1388685002000	9197	4570	115	0	\N
88492	1397	1388675001000	9197	4570	116	0	\N
88493	1397	1388665000000	9197	4570	117	0	\N
88494	1397	1388654999000	9197	4570	118	0	\N
88495	1397	1388644998000	9197	4570	119	0	\N
88496	1397	1388634997000	9197	4570	120	0	\N
88497	1397	1388624996000	9197	4570	121	0	\N
88498	1397	1388614995000	9197	4570	122	0	\N
88499	1397	1388604994000	9197	4570	123	0	\N
88500	1397	1388594993000	9197	4570	124	0	\N
88505	1397	1387704904000	9200	4769	0	0	\N
88506	1726	787293102000	9200	4769	1	0	\N
88515	1726	787253098000	9205	4773	0	0	\N
88516	1726	787243097000	9205	4773	1	0	\N
88517	1726	787233096000	9205	4773	2	0	\N
88518	1726	787223095000	9205	4773	3	0	\N
88519	1397	1387664900000	9205	4773	4	0	\N
88520	1397	1387654899000	9205	4773	5	0	\N
88521	1397	1387644898000	9205	4773	6	0	\N
88522	1397	1387634897000	9205	4773	7	0	\N
88503	1726	787303103000	9199	4768	0	0	2085
88504	1397	1387714905000	9199	4768	1	0	5112
88507	1397	1387704904000	9201	4769	0	0	5113
88508	1726	787293102000	9201	4769	1	0	2086
88509	1726	787283101000	9202	4770	0	0	2087
88511	1726	787273100000	9203	4771	0	0	2088
88512	1397	1387684902000	9203	4771	1	0	5115
88513	1397	1387674901000	9204	4772	0	0	5116
88514	1726	787263099000	9204	4772	1	0	2089
88523	1726	787253098000	9206	4773	0	0	2090
88525	1726	787233096000	9206	4773	2	0	2092
88526	1726	787223095000	9206	4773	3	0	2093
88527	1397	1387664900000	9206	4773	4	0	5117
88528	1397	1387654899000	9206	4773	5	0	5118
88530	1397	1387634897000	9206	4773	7	0	5120
88531	55	66616060000000	9207	4774	0	0	9
88532	55	66361461500000	9207	4774	1	0	10
88533	1397	1387624896000	9207	4774	2	0	5121
88534	1726	787213094000	9207	4774	3	0	2094
88536	1726	787203093000	9208	4775	1	0	2095
88542	1397	1387584892000	9211	4778	0	0	\N
88543	1726	787173090000	9211	4778	1	0	\N
88544	1397	1387574891000	9211	4778	2	0	\N
88545	1726	787163089000	9211	4778	3	0	\N
88550	1397	1387584892000	9213	4778	0	0	\N
88551	1726	787173090000	9213	4778	1	0	\N
88552	1397	1387574891000	9213	4778	2	0	\N
88553	1726	787163089000	9213	4778	3	0	\N
88554	1397	1387584892000	9214	4778	0	0	\N
88555	1726	787173090000	9214	4778	1	0	\N
88556	1397	1387574891000	9214	4778	2	0	\N
88557	1726	787163089000	9214	4778	3	0	\N
88564	1397	1387564890000	9216	4779	0	0	\N
88565	1397	1387554889000	9216	4779	1	0	\N
88566	1397	1387544888000	9216	4779	2	0	\N
88567	1726	787153088000	9216	4779	3	0	\N
88568	1726	787143087000	9216	4779	4	0	\N
88569	1726	787133086000	9216	4779	5	0	\N
88570	1397	1387564890000	9217	4779	0	0	\N
88571	1397	1387554889000	9217	4779	1	0	\N
88572	1397	1387544888000	9217	4779	2	0	\N
88573	1726	787153088000	9217	4779	3	0	\N
88574	1726	787143087000	9217	4779	4	0	\N
88575	1726	787133086000	9217	4779	5	0	\N
88576	1397	1387534887000	9218	4780	0	0	\N
88577	1397	1387524886000	9218	4780	1	0	\N
88578	1726	787123085000	9218	4780	2	0	\N
88579	1726	787113084000	9218	4780	3	0	\N
88584	1726	787103083000	9220	4781	0	0	\N
88585	1397	1387514885000	9220	4781	1	0	\N
88588	1726	787103083000	9222	4781	0	0	\N
88589	1397	1387514885000	9222	4781	1	0	\N
88592	1726	787093082000	9224	4782	0	0	\N
88593	1397	1387504884000	9224	4782	1	0	\N
88594	1726	787093082000	9225	4782	0	0	\N
88595	1397	1387504884000	9225	4782	1	0	\N
88596	1726	785883082000	9226	4783	0	0	\N
88597	1726	785873081000	9226	4783	1	0	\N
88598	1397	1387494883000	9226	4783	2	0	\N
88599	55	66000000000000	9227	4775	0	0	\N
88600	1726	785883082000	9228	4783	0	0	\N
88601	1726	785873081000	9228	4783	1	0	\N
88602	1397	1387494883000	9228	4783	2	0	\N
88603	1726	785883082000	9229	4783	0	0	\N
88604	1726	785873081000	9229	4783	1	0	\N
88605	1397	1387494883000	9229	4783	2	0	\N
88618	1397	1387444878000	9236	4788	0	0	\N
88619	1726	785833077000	9236	4788	1	0	\N
88632	1726	785763070000	9242	4794	0	0	\N
88633	1397	1387374871000	9242	4794	1	0	\N
88634	1693	11759708897158	9242	4794	2	0	\N
88635	1726	785763070000	9243	4794	0	0	\N
88636	1397	1387374871000	9243	4794	1	0	\N
88637	1693	11759708897158	9243	4794	2	0	\N
88638	1726	785763070000	9244	4794	0	0	\N
88639	1397	1387374871000	9244	4794	1	0	\N
88640	1693	11759708897158	9244	4794	2	0	\N
88539	1397	1387594893000	9210	4777	0	0	5124
88540	1726	787183091000	9210	4777	1	0	2097
88541	55	66000000000000	9210	4777	2	0	11
88546	1397	1387584892000	9212	4778	0	0	5125
88547	1726	787173090000	9212	4778	1	0	2098
88549	1726	787163089000	9212	4778	3	0	2099
88558	1397	1387564890000	9215	4779	0	0	5127
88559	1397	1387554889000	9215	4779	1	0	5128
88560	1397	1387544888000	9215	4779	2	0	5129
88561	1726	787153088000	9215	4779	3	0	2100
88563	1726	787133086000	9215	4779	5	0	2102
88580	1397	1387534887000	9219	4780	0	0	5130
88581	1397	1387524886000	9219	4780	1	0	5131
88582	1726	787123085000	9219	4780	2	0	2103
88586	1726	787103083000	9221	4781	0	0	2105
88587	1397	1387514885000	9221	4781	1	0	5132
88590	1726	787093082000	9223	4782	0	0	2106
88591	1397	1387504884000	9223	4782	1	0	5133
88606	1726	785883082000	9230	4783	0	0	2107
88608	1397	1387494883000	9230	4783	2	0	5134
88609	1397	1387484882000	9231	4784	0	0	5135
88610	1397	1387474881000	9232	4785	0	0	5136
88611	1726	785863080000	9232	4785	1	0	2109
88612	1397	1387464880000	9233	4786	0	0	5137
88614	1397	1387454879000	9234	4787	0	0	5138
88615	1726	785843078000	9234	4787	1	0	2111
88616	1397	1387444878000	9235	4788	0	0	5139
88617	1726	785833077000	9235	4788	1	0	2112
88621	1397	1387434877000	9237	4789	1	0	5140
88622	1397	1387424876000	9237	4789	2	0	5141
88623	1726	785813075000	9237	4789	3	0	2114
88624	1397	1387414875000	9238	4790	0	0	5142
88625	1726	785803074000	9238	4790	1	0	2115
88627	1397	1387404874000	9239	4791	1	0	5143
88628	1397	1387394873000	9240	4792	0	0	5144
88629	1726	785783072000	9240	4792	1	0	2117
88630	1726	785773071000	9241	4793	0	0	2118
88631	1397	1387384872000	9241	4793	1	0	5145
88642	1397	1387374871000	9245	4794	1	0	5146
88643	1693	11759708897158	9245	4794	2	0	459
88644	1726	785753069000	9246	4795	0	0	2120
88645	1693	11697476056330	9246	4795	1	0	460
88647	1693	11635243215502	9246	4795	3	0	461
88648	1693	11573010374674	9246	4795	4	0	462
88649	1693	11510777533846	9246	4795	5	0	463
88650	1693	11448544693018	9246	4795	6	0	464
88651	1693	11441935300813	9246	4795	7	0	465
88653	1397	1387354869000	9246	4795	9	0	5148
88654	1397	1387344868000	9247	4796	0	0	5149
88655	1726	785733067000	9247	4796	1	0	2122
88656	1726	785723066000	9247	4796	2	0	2123
88657	1726	785713065000	9247	4796	3	0	2124
88659	1693	11379702459985	9247	4796	5	0	466
88660	1693	11317469619157	9247	4796	6	0	467
88661	1397	1387324866000	9247	4796	7	0	5151
88662	1693	11255236778329	9247	4796	8	0	468
88664	1693	11022745645635	9247	4796	10	0	470
88665	1693	10960512804807	9247	4796	11	0	471
88666	1693	10898279963979	9247	4796	12	0	472
88667	1693	10836047123151	9247	4796	13	0	473
88668	1693	9239054031101	9247	4796	14	0	474
88670	1693	9114588349445	9247	4796	16	0	476
88671	1693	9052355508617	9247	4796	17	0	477
88672	1693	8990122667789	9247	4796	18	0	478
88698	1397	1387284862000	9250	4799	0	0	\N
88699	1726	785673061000	9250	4799	1	0	\N
88700	1397	1387274861000	9250	4799	2	0	\N
88701	1397	1387264860000	9250	4799	3	0	\N
88702	1693	6912064949205	9250	4799	4	0	\N
88703	1693	6849832108377	9250	4799	5	0	\N
88704	1693	6787599267549	9250	4799	7	0	\N
88705	1726	785663060000	9250	4799	8	0	\N
88706	1693	6725366426721	9250	4799	9	0	\N
88707	1693	6663133585893	9250	4799	10	0	\N
88708	1693	6600900745065	9250	4799	11	0	\N
88709	1693	6538667904237	9250	4799	12	0	\N
88710	1693	6476435063409	9250	4799	13	0	\N
88711	1726	785653059000	9250	4799	14	0	\N
88712	1693	6414202222581	9250	4799	15	0	\N
88713	1693	6351969381753	9250	4799	16	0	\N
88714	1693	6289736540925	9250	4799	17	0	\N
88715	1693	6227503700097	9250	4799	18	0	\N
88716	1693	6165270859269	9250	4799	19	0	\N
88717	1693	6163375318648	9250	4799	20	0	\N
88718	1693	6101142477820	9250	4799	21	0	\N
88719	1693	6038909636992	9250	4799	22	0	\N
88720	1693	5976676796164	9250	4799	23	0	\N
88721	1693	5914443955336	9250	4799	24	0	\N
88746	1397	1387974931000	9252	4749	0	0	\N
88747	1726	787553128000	9252	4749	1	0	\N
88748	55	68155182750000	9252	4749	2	0	\N
88749	1726	787543127000	9252	4749	3	0	\N
88750	1726	787533126000	9252	4749	4	0	\N
88751	1726	787523125000	9252	4749	5	0	\N
88752	1726	787513124000	9252	4749	6	0	\N
88753	55	68143601000000	9252	4749	7	0	\N
88754	1693	11759708897158	9252	4749	8	0	\N
88755	1693	11697476056330	9252	4749	9	0	\N
88756	1726	787503123000	9252	4749	10	0	\N
88757	55	67889012500000	9252	4749	11	0	\N
88758	55	67634424000000	9252	4749	12	0	\N
88759	55	67379835500000	9252	4749	13	0	\N
88760	55	67125247000000	9252	4749	14	0	\N
88761	55	66870658500000	9252	4749	15	0	\N
88762	55	66616070000000	9252	4749	16	0	\N
88763	1397	1387964930000	9252	4749	17	0	\N
88764	1397	1387954929000	9252	4749	18	0	\N
88765	1397	1387944928000	9252	4749	19	0	\N
88766	1397	1387934927000	9252	4749	20	0	\N
88767	1397	1387924926000	9252	4749	21	0	\N
88768	1397	1387914925000	9252	4749	22	0	\N
88769	1397	1387904924000	9252	4749	23	0	\N
88770	1397	1387894923000	9252	4749	24	0	\N
88771	1397	1387884922000	9252	4749	25	0	\N
88772	1397	1387874921000	9252	4749	26	0	\N
88773	1397	1387864920000	9252	4749	27	0	\N
88774	1397	1387854919000	9252	4749	28	0	\N
88775	1397	1387844918000	9252	4749	29	0	\N
88776	1397	1387834917000	9252	4749	30	0	\N
88777	1397	1387824916000	9252	4749	31	0	\N
88778	1397	1387814915000	9252	4749	32	0	\N
88779	1397	1387804914000	9252	4749	33	0	\N
88780	1397	1387794913000	9252	4749	34	0	\N
88781	1397	1387784912000	9252	4749	35	0	\N
88782	1397	1387774911000	9252	4749	36	0	\N
88783	1397	1387764910000	9252	4749	37	0	\N
88784	1397	1387754909000	9252	4749	38	0	\N
88785	1397	1387744908000	9252	4749	39	0	\N
88786	1397	1387734907000	9252	4749	40	0	\N
88787	1397	1387724906000	9252	4749	41	0	\N
88788	1397	1387714905000	9252	4749	42	0	\N
88789	1397	1387704904000	9252	4749	44	0	\N
88790	1397	1387694903000	9252	4749	45	0	\N
88791	1397	1387684902000	9252	4749	46	0	\N
88792	1397	1387674901000	9252	4749	47	0	\N
88793	55	66361481500000	9252	4749	48	0	\N
88794	1397	1387664900000	9252	4749	49	0	\N
88795	1397	1387654899000	9252	4749	50	0	\N
88796	1397	1387644898000	9252	4749	51	0	\N
88797	1397	1387634897000	9252	4749	52	0	\N
88798	1397	1387624896000	9252	4749	53	0	\N
88799	1397	1387614895000	9252	4749	54	0	\N
88800	1397	1387604894000	9252	4749	55	0	\N
88801	1397	1387594893000	9252	4749	56	0	\N
88802	1397	1387584892000	9252	4749	57	0	\N
88803	1397	1387574891000	9252	4749	58	0	\N
88804	1397	1387564890000	9252	4749	59	0	\N
88805	1397	1387554889000	9252	4749	60	0	\N
88806	1397	1387544888000	9252	4749	61	0	\N
88807	1397	1387534887000	9252	4749	62	0	\N
88808	1397	1387524886000	9252	4749	63	0	\N
88675	1397	1387314865000	9248	4797	1	0	5152
88676	1693	8482791990159	9248	4797	2	0	480
88677	1693	8420559149331	9248	4797	3	0	481
88678	1693	8358326308503	9248	4797	4	0	482
88679	1693	8296093467675	9248	4797	5	0	483
88681	1693	8171627786019	9248	4797	7	0	485
88682	1726	785693063000	9249	4798	0	0	2126
88683	1726	785683062000	9249	4798	1	0	2127
88684	1397	1387304864000	9249	4798	2	0	5153
88685	1397	1387294863000	9249	4798	3	0	5154
88687	1693	8107499404570	9249	4798	5	0	487
88688	1693	8045266563742	9249	4798	6	0	488
88689	1693	7472160516657	9249	4798	7	0	489
88690	1693	7409927675829	9249	4798	8	0	490
88692	1693	7285461994173	9249	4798	10	0	492
88693	1693	7223229153345	9249	4798	11	0	493
88694	1693	7160996312517	9249	4798	12	0	494
88695	1693	7098763471689	9249	4798	13	0	495
88696	1693	7036530630861	9249	4798	14	0	496
88722	1397	1387284862000	9251	4799	0	0	5155
88723	1726	785673061000	9251	4799	1	0	2128
88724	1397	1387274861000	9251	4799	2	0	5156
88725	1397	1387264860000	9251	4799	3	0	5157
88726	1693	6912064949205	9251	4799	4	0	498
88728	1693	6787599267549	9251	4799	7	0	500
88729	1726	785663060000	9251	4799	8	0	2129
88730	1693	6725366426721	9251	4799	9	0	501
88731	1693	6663133585893	9251	4799	10	0	502
88733	1693	6538667904237	9251	4799	12	0	504
88734	1693	6476435063409	9251	4799	13	0	505
88735	1726	785653059000	9251	4799	14	0	2130
88736	1693	6414202222581	9251	4799	15	0	506
88737	1693	6351969381753	9251	4799	16	0	507
88739	1693	6227503700097	9251	4799	18	0	509
88740	1693	6165270859269	9251	4799	19	0	510
88741	1693	6163375318648	9251	4799	20	0	511
88742	1693	6101142477820	9251	4799	21	0	512
88743	1693	6038909636992	9251	4799	22	0	513
88745	1693	5914443955336	9251	4799	24	0	515
88809	1397	1387514885000	9252	4749	64	0	\N
88810	1397	1387504884000	9252	4749	65	0	\N
88811	1726	787493122000	9252	4749	66	0	\N
88812	1726	787483121000	9252	4749	67	0	\N
88813	1726	787473120000	9252	4749	68	0	\N
88814	1726	787463119000	9252	4749	69	0	\N
88815	1726	787453118000	9252	4749	70	0	\N
88816	1726	787443117000	9252	4749	71	0	\N
88817	1726	787433116000	9252	4749	72	0	\N
88818	1726	787423115000	9252	4749	73	0	\N
88819	1726	787413114000	9252	4749	74	0	\N
88820	1726	787403113000	9252	4749	75	0	\N
88821	1726	787393112000	9252	4749	76	0	\N
88822	1726	787383111000	9252	4749	77	0	\N
88823	1726	787373110000	9252	4749	78	0	\N
88824	1726	787363109000	9252	4749	79	0	\N
88825	1726	787353108000	9252	4749	80	0	\N
88826	1726	787343107000	9252	4749	81	0	\N
88827	1726	787333106000	9252	4749	82	0	\N
88828	1726	787323105000	9252	4749	83	0	\N
88829	1726	787313104000	9252	4749	84	0	\N
88830	1726	787303103000	9252	4749	85	0	\N
88831	1726	787293102000	9252	4749	86	0	\N
88832	1726	787283101000	9252	4749	87	0	\N
88833	1726	787273100000	9252	4749	88	0	\N
88834	1726	787263099000	9252	4749	89	0	\N
88835	1726	787253098000	9252	4749	90	0	\N
88836	1726	787243097000	9252	4749	91	0	\N
88837	1726	787233096000	9252	4749	92	0	\N
88838	1726	787223095000	9252	4749	93	0	\N
88839	1726	787213094000	9252	4749	94	0	\N
88840	1726	787203093000	9252	4749	95	0	\N
88841	1726	787193092000	9252	4749	96	0	\N
88842	1726	787183091000	9252	4749	97	0	\N
88843	1726	787173090000	9252	4749	98	0	\N
88844	1726	787163089000	9252	4749	99	0	\N
88845	1693	11635243215502	9252	4749	100	0	\N
88846	1693	11573010374674	9252	4749	101	0	\N
88847	1693	11510777533846	9252	4749	102	0	\N
88848	1693	11448544693018	9252	4749	103	0	\N
88849	1693	11441935300813	9252	4749	104	0	\N
88850	1693	11379702459985	9252	4749	105	0	\N
88851	1693	11317469619157	9252	4749	106	0	\N
88852	1693	11255236778329	9252	4749	107	0	\N
88853	1693	11084978486463	9252	4749	108	0	\N
88854	1693	11022745645635	9252	4749	109	0	\N
88855	1693	10960512804807	9252	4749	110	0	\N
88856	1693	10898279963979	9252	4749	111	0	\N
88857	1693	10836047123151	9252	4749	112	0	\N
88858	1693	9239054031101	9252	4749	113	0	\N
88859	1693	9176821190273	9252	4749	114	0	\N
88860	1693	9114588349445	9252	4749	115	0	\N
88861	1693	9052355508617	9252	4749	116	0	\N
88862	1693	8990122667789	9252	4749	117	0	\N
88863	1693	8545024830987	9252	4749	118	0	\N
88864	1693	8482791990159	9252	4749	119	0	\N
88865	1693	8420559149331	9252	4749	120	0	\N
88866	1693	8358326308503	9252	4749	121	0	\N
88867	1693	8296093467675	9252	4749	122	0	\N
88868	1693	8233860626847	9252	4749	123	0	\N
88869	1693	8171627786019	9252	4749	124	0	\N
88870	1693	8109394945191	9252	4749	125	0	\N
88871	1397	1387284862000	9253	4799	0	0	\N
88872	1726	785673061000	9253	4799	1	0	\N
88873	1397	1387274861000	9253	4799	2	0	\N
88874	1397	1387264860000	9253	4799	3	0	\N
88875	1693	6912064949205	9253	4799	4	0	\N
88876	1693	6849832108377	9253	4799	5	0	\N
88877	1693	6787599267549	9253	4799	7	0	\N
88878	1726	785663060000	9253	4799	8	0	\N
88879	1693	6725366426721	9253	4799	9	0	\N
88880	1693	6663133585893	9253	4799	10	0	\N
88881	1693	6600900745065	9253	4799	11	0	\N
88882	1693	6538667904237	9253	4799	12	0	\N
88883	1693	6476435063409	9253	4799	13	0	\N
88884	1726	785653059000	9253	4799	14	0	\N
88885	1693	6414202222581	9253	4799	15	0	\N
88886	1693	6351969381753	9253	4799	16	0	\N
88887	1693	6289736540925	9253	4799	17	0	\N
88888	1693	6227503700097	9253	4799	18	0	\N
88889	1693	6165270859269	9253	4799	19	0	\N
88890	1693	6163375318648	9253	4799	20	0	\N
88891	1693	6101142477820	9253	4799	21	0	\N
88892	1693	6038909636992	9253	4799	22	0	\N
88893	1693	5976676796164	9253	4799	23	0	\N
88894	1693	5914443955336	9253	4799	24	0	\N
88902	1397	1387254859000	9255	4800	0	0	\N
88903	1726	785643058000	9255	4800	1	0	\N
88904	1693	5852211114508	9255	4800	2	0	\N
88905	1693	5789978273680	9255	4800	3	0	\N
88906	1693	5727745432852	9255	4800	4	0	\N
88907	1693	5665512592024	9255	4800	5	0	\N
88908	1693	5603279751196	9255	4800	6	0	\N
88909	1397	1387244858000	9256	4801	0	0	\N
88910	1726	785633057000	9256	4801	1	0	\N
88911	1693	5541046910368	9256	4801	2	0	\N
88912	1693	5478814069540	9256	4801	3	0	\N
88913	1693	5416581228712	9256	4801	4	0	\N
88914	1693	5354348387884	9256	4801	5	0	\N
88915	1693	5292115547056	9256	4801	6	0	\N
88916	1693	5229882706228	9256	4801	7	0	\N
88925	1397	1387244858000	9258	4801	0	0	\N
88926	1726	785633057000	9258	4801	1	0	\N
88927	1693	5541046910368	9258	4801	2	0	\N
88928	1693	5478814069540	9258	4801	3	0	\N
88929	1693	5416581228712	9258	4801	4	0	\N
88930	1693	5354348387884	9258	4801	5	0	\N
88931	1693	5292115547056	9258	4801	6	0	\N
88932	1693	5229882706228	9258	4801	7	0	\N
88933	1397	1387244858000	9259	4801	0	0	\N
88934	1726	785633057000	9259	4801	1	0	\N
88935	1693	5541046910368	9259	4801	2	0	\N
88936	1693	5478814069540	9259	4801	3	0	\N
88937	1693	5416581228712	9259	4801	4	0	\N
88938	1693	5354348387884	9259	4801	5	0	\N
88939	1693	5292115547056	9259	4801	6	0	\N
88940	1693	5229882706228	9259	4801	7	0	\N
88897	1693	5852211114508	9254	4800	2	0	516
88898	1693	5789978273680	9254	4800	3	0	517
88899	1693	5727745432852	9254	4800	4	0	518
88900	1693	5665512592024	9254	4800	5	0	519
88901	1693	5603279751196	9254	4800	6	0	520
88918	1726	785633057000	9257	4801	1	0	2132
88919	1693	5541046910368	9257	4801	2	0	521
88920	1693	5478814069540	9257	4801	3	0	522
88921	1693	5416581228712	9257	4801	4	0	523
88922	1693	5354348387884	9257	4801	5	0	524
88924	1693	5229882706228	9257	4801	7	0	526
88941	1693	5167649865400	9260	4802	0	0	527
88942	1693	5165754324779	9260	4802	1	0	528
88943	1693	5103521483951	9260	4802	2	0	529
88949	1693	5167649865400	9261	4802	0	0	\N
88950	1693	5165754324779	9261	4802	1	0	\N
88951	1693	5103521483951	9261	4802	2	0	\N
88952	1726	785623056000	9261	4802	3	0	\N
88953	1693	5041288643123	9261	4802	4	0	\N
88954	1693	4979055802295	9261	4802	5	0	\N
88955	1693	4916822961467	9261	4802	6	0	\N
88956	1397	1387234857000	9261	4802	7	0	\N
88965	1726	785603054000	9263	4804	0	0	\N
88966	1397	1387214855000	9263	4804	1	0	\N
88967	1693	4481193075671	9263	4804	2	0	\N
88968	1726	785593053000	9263	4804	3	0	\N
88969	1397	1387204854000	9263	4804	4	0	\N
88970	1693	4418960234843	9263	4804	5	0	\N
88971	1693	4356727394015	9263	4804	6	0	\N
88972	1693	4294494553187	9263	4804	7	0	\N
88973	1693	4289770701614	9263	4804	8	0	\N
88974	1693	4227537860786	9263	4804	9	0	\N
88975	1693	4165305019958	9263	4804	10	0	\N
88976	1693	3315911409583	9263	4804	11	0	\N
88977	1693	3253678568755	9263	4804	12	0	\N
88978	1693	2964405030836	9263	4804	13	0	\N
88979	1693	2902172190008	9263	4804	14	0	\N
88995	668	66000000000000	9267	4802	0	0	\N
89016	1397	1387164850000	9270	4807	0	0	\N
89017	1397	1387154849000	9270	4807	1	0	\N
89018	1726	785553049000	9270	4807	2	0	\N
89022	1397	1387164850000	9272	4807	0	0	\N
89023	1397	1387154849000	9272	4807	1	0	\N
89024	1726	785553049000	9272	4807	2	0	\N
89025	1397	1387164850000	9273	4807	0	0	\N
89026	1397	1387154849000	9273	4807	1	0	\N
89027	1726	785553049000	9273	4807	2	0	\N
89032	1726	785533047000	9276	4809	0	0	\N
89033	1397	1387134847000	9276	4809	1	0	\N
89038	1397	1387104844000	9279	4812	0	0	\N
89039	1726	785503044000	9279	4812	1	0	\N
89042	1726	785493043000	9281	4813	0	0	\N
89043	1397	1387094843000	9281	4813	1	0	\N
89044	1726	785493043000	9282	4813	0	0	\N
89045	1397	1387094843000	9282	4813	1	0	\N
89050	1726	785483042000	9285	4814	0	0	\N
89058	1397	1387044838000	9289	4818	0	0	\N
89059	1726	785443038000	9289	4818	1	0	\N
89062	1885	0	9291	4683	0	0	\N
89063	1756	1906509808900	9291	4683	1	0	\N
89064	55	67439030000000	9291	4683	2	0	\N
89065	1516	15154709112008	9291	4683	3	0	\N
89066	193	66000067824773	9291	4683	4	0	\N
89067	55	67435162750000	9291	4683	5	0	\N
89068	1397	1388965030000	9291	4683	6	0	\N
89069	1397	1388955029000	9291	4683	7	0	\N
89070	1397	1388945028000	9291	4683	8	0	\N
89071	1397	1388935027000	9291	4683	9	0	\N
89072	1397	1388925026000	9291	4683	10	0	\N
89073	1397	1388915025000	9291	4683	11	0	\N
89074	1397	1388905024000	9291	4683	12	0	\N
89075	1903	0	9291	4683	13	0	\N
89076	112	66001047824773	9291	4683	14	0	\N
89077	55	67423581000000	9291	4683	15	0	\N
89078	1693	11759708897158	9291	4683	17	0	\N
89079	1693	11697476056330	9291	4683	18	0	\N
89080	261	66000067824773	9291	4683	19	0	\N
88947	1693	4916822961467	9260	4802	6	0	532
88948	1397	1387234857000	9260	4802	7	0	5160
88957	1726	785613055000	9262	4803	0	0	2134
88958	1693	4854590120639	9262	4803	1	0	533
88959	1397	1387224856000	9262	4803	2	0	5161
88961	1693	4730124438983	9262	4803	4	0	535
88962	1693	4667891598155	9262	4803	5	0	536
88963	1693	4605658757327	9262	4803	6	0	537
88964	1693	4543425916499	9262	4803	7	0	538
88980	1726	785603054000	9264	4804	0	0	2135
88982	1693	4481193075671	9264	4804	2	0	539
88983	1726	785593053000	9264	4804	3	0	2136
88984	1397	1387204854000	9264	4804	4	0	5163
88985	1693	4418960234843	9264	4804	5	0	540
88987	1693	4294494553187	9264	4804	7	0	542
88988	1693	4289770701614	9264	4804	8	0	543
88989	1693	4227537860786	9264	4804	9	0	544
88990	1693	4165305019958	9264	4804	10	0	545
88991	1693	3315911409583	9264	4804	11	0	546
88993	1693	2964405030836	9264	4804	13	0	548
88994	1693	2902172190008	9264	4804	14	0	549
88996	1693	2884060999956	9268	4805	0	0	550
88997	668	66000000000000	9268	4805	1	0	1
88998	1397	1387194853000	9268	4805	2	0	5164
89000	1693	2759595318300	9268	4805	4	0	552
89001	1693	2697362477472	9268	4805	5	0	553
89002	1693	2635129636644	9268	4805	6	0	554
89003	1693	2345856098725	9268	4805	7	0	555
89005	1693	2283623257897	9269	4806	0	0	556
89006	1693	2221390417069	9269	4806	1	0	557
89007	1397	1387184852000	9269	4806	2	0	5165
89008	1397	1387174851000	9269	4806	3	0	5166
89009	1693	2159157576241	9269	4806	4	0	558
89011	1693	2096924735413	9269	4806	6	0	559
89012	1726	785563050000	9269	4806	7	0	2139
89013	1693	2034691894585	9269	4806	8	0	560
89014	1693	1972459053757	9269	4806	9	0	561
89015	1946	991428570	9269	4806	10	0	1
89020	1397	1387154849000	9271	4807	1	0	5168
89021	1726	785553049000	9271	4807	2	0	2140
89028	1397	1387144848000	9274	4808	0	0	5169
89029	1726	785543048000	9274	4808	1	0	2141
89031	1397	1387134847000	9275	4809	1	0	5170
89034	1397	1387124846000	9277	4810	0	0	5171
89035	1726	785523046000	9277	4810	1	0	2143
89036	1397	1387114845000	9278	4811	0	0	5172
89037	1726	785513045000	9278	4811	1	0	2144
89041	1726	785503044000	9280	4812	1	0	2145
89046	1726	785493043000	9283	4813	0	0	2146
89047	1397	1387094843000	9283	4813	1	0	5174
89048	1397	1387084842000	9284	4814	0	0	5175
89049	1726	785483042000	9284	4814	1	0	2147
89052	1397	1387074841000	9286	4815	1	0	5176
89053	1693	22449053757	9286	4815	2	0	562
89054	1726	785463040000	9287	4816	0	0	2149
89055	1397	1387064840000	9287	4816	1	0	5177
89057	1726	785453039000	9288	4817	1	0	2150
89060	1397	1387044838000	9290	4818	0	0	5179
89061	1726	785443038000	9290	4818	1	0	2151
89081	55	67168992500000	9291	4683	20	0	\N
89082	55	66914404000000	9291	4683	21	0	\N
89083	55	66659815500000	9291	4683	22	0	\N
89084	55	66405227000000	9291	4683	23	0	\N
89085	55	66150638500000	9291	4683	24	0	\N
89086	1516	10891963511560	9291	4683	25	0	\N
89087	1516	8015800860938	9291	4683	26	0	\N
89088	1693	11635243215502	9291	4683	27	0	\N
89089	1693	11573010374674	9291	4683	28	0	\N
89090	1693	11510777533846	9291	4683	29	0	\N
89091	1693	11448544693018	9291	4683	30	0	\N
89092	1693	11441935300813	9291	4683	31	0	\N
89093	1693	11379702459985	9291	4683	32	0	\N
89094	1693	11317469619157	9291	4683	33	0	\N
89095	1693	11255236778329	9291	4683	34	0	\N
89096	1693	11084978486463	9291	4683	35	0	\N
89097	1693	11022745645635	9291	4683	36	0	\N
89098	1693	10960512804807	9291	4683	37	0	\N
89099	1693	10898279963979	9291	4683	38	0	\N
89100	1693	10836047123151	9291	4683	39	0	\N
89101	1693	9239054031101	9291	4683	40	0	\N
89102	1693	9176821190273	9291	4683	41	0	\N
89103	1693	9114588349445	9291	4683	42	0	\N
89104	1693	9052355508617	9291	4683	43	0	\N
89105	1693	8990122667789	9291	4683	44	0	\N
89106	1693	8545024830987	9291	4683	45	0	\N
89107	1693	8482791990159	9291	4683	46	0	\N
89108	1693	8420559149331	9291	4683	47	0	\N
89109	1693	8358326308503	9291	4683	48	0	\N
89110	1693	8296093467675	9291	4683	49	0	\N
89111	1693	8233860626847	9291	4683	50	0	\N
89112	1693	8171627786019	9291	4683	51	0	\N
89113	1693	8109394945191	9291	4683	52	0	\N
89114	1693	8107499404570	9291	4683	53	0	\N
89115	1693	8045266563742	9291	4683	54	0	\N
89116	1693	7472160516657	9291	4683	55	0	\N
89117	1693	7409927675829	9291	4683	56	0	\N
89118	1693	7347694835001	9291	4683	57	0	\N
89119	1693	7285461994173	9291	4683	58	0	\N
89120	1693	7223229153345	9291	4683	59	0	\N
89121	1693	7160996312517	9291	4683	60	0	\N
89122	1693	7098763471689	9291	4683	61	0	\N
89123	1693	7036530630861	9291	4683	62	0	\N
89124	1693	6974297790033	9291	4683	63	0	\N
89125	1693	6912064949205	9291	4683	64	0	\N
89126	1693	6849832108377	9291	4683	65	0	\N
89127	1693	6787599267549	9291	4683	66	0	\N
89128	1693	6725366426721	9291	4683	67	0	\N
89129	1693	6663133585893	9291	4683	68	0	\N
89130	1693	6600900745065	9291	4683	69	0	\N
89131	1693	6538667904237	9291	4683	70	0	\N
89132	1693	6476435063409	9291	4683	71	0	\N
89133	1693	6414202222581	9291	4683	72	0	\N
89134	1693	6351969381753	9291	4683	73	0	\N
89135	1693	6289736540925	9291	4683	74	0	\N
89136	1693	6227503700097	9291	4683	75	0	\N
89137	1693	6165270859269	9291	4683	76	0	\N
89138	1693	6163375318648	9291	4683	77	0	\N
89139	1693	6101142477820	9291	4683	78	0	\N
89140	1693	6038909636992	9291	4683	79	0	\N
89141	1693	5976676796164	9291	4683	80	0	\N
89142	1693	5914443955336	9291	4683	81	0	\N
89143	1693	5852211114508	9291	4683	82	0	\N
89144	1693	5789978273680	9291	4683	83	0	\N
89145	1693	5727745432852	9291	4683	84	0	\N
89146	1693	5665512592024	9291	4683	85	0	\N
89147	1693	5603279751196	9291	4683	86	0	\N
89148	1397	1388895023000	9291	4683	87	0	\N
89149	1397	1388885022000	9291	4683	88	0	\N
89150	1397	1388875021000	9291	4683	89	0	\N
89151	1397	1388865020000	9291	4683	90	0	\N
89152	1397	1388855019000	9291	4683	91	0	\N
89153	1397	1388845018000	9291	4683	92	0	\N
89154	1397	1388835017000	9291	4683	93	0	\N
89155	1397	1388825016000	9291	4683	94	0	\N
89156	1397	1388815015000	9291	4683	95	0	\N
89157	1397	1388805014000	9291	4683	96	0	\N
89158	1397	1388795013000	9291	4683	97	0	\N
89159	1397	1388785012000	9291	4683	98	0	\N
89160	1397	1388775011000	9291	4683	99	0	\N
89161	1397	1388765010000	9291	4683	100	0	\N
89162	1397	1388755009000	9291	4683	101	0	\N
89163	1397	1388745008000	9291	4683	102	0	\N
89164	1397	1388735007000	9291	4683	103	0	\N
89165	1397	1388725006000	9291	4683	104	0	\N
89166	1397	1388715005000	9291	4683	105	0	\N
89167	1397	1388705004000	9291	4683	106	0	\N
89168	1397	1388695003000	9291	4683	107	0	\N
89169	1397	1388685002000	9291	4683	108	0	\N
89170	1397	1388675001000	9291	4683	109	0	\N
89171	1397	1388665000000	9291	4683	110	0	\N
89172	1397	1388654999000	9291	4683	111	0	\N
89173	1397	1388644998000	9291	4683	112	0	\N
89174	1397	1388634997000	9291	4683	113	0	\N
89175	1397	1388624996000	9291	4683	114	0	\N
89176	1397	1388614995000	9291	4683	115	0	\N
89177	1397	1388604994000	9291	4683	116	0	\N
89178	1397	1388594993000	9291	4683	117	0	\N
89179	1397	1388584992000	9291	4683	118	0	\N
89180	1397	1388574991000	9291	4683	119	0	\N
89181	1397	1388564990000	9291	4683	120	0	\N
89182	1397	1388554989000	9291	4683	121	0	\N
89183	1397	1388544988000	9291	4683	122	0	\N
89184	1397	1388534987000	9291	4683	123	0	\N
89185	1397	1388524986000	9291	4683	124	0	\N
89186	1397	1388514985000	9291	4683	125	0	\N
89194	1397	1387004834000	9294	4821	0	0	\N
89195	1726	785403034000	9294	4821	1	0	\N
89204	1726	785373031000	9299	4824	0	0	\N
89205	1397	1386974831000	9299	4824	1	0	\N
89214	1726	785323026000	9302	4827	0	0	\N
89215	1397	1386924826000	9302	4827	1	0	\N
89189	1726	785433037000	9292	4819	2	0	2152
89190	1726	785423036000	9292	4819	3	0	2153
89191	1397	1387014835000	9293	4820	0	0	5182
89192	1726	785413035000	9293	4820	1	0	2154
89193	1933	1439020000000	9293	4820	2	0	1
89197	1726	785403034000	9295	4821	1	0	2155
89198	1726	785393033000	9296	4822	0	0	2156
89199	1397	1386994833000	9296	4822	1	0	5184
89200	1397	1386984832000	9297	4823	0	0	5185
89201	1726	785383032000	9297	4823	1	0	2157
89203	1397	1386974831000	9298	4824	1	0	5186
89206	1397	1386964830000	9300	4825	0	0	5187
89207	1726	785363030000	9300	4825	1	0	2159
89208	1726	785353029000	9301	4826	0	0	2160
89210	1726	785333027000	9301	4826	2	0	2162
89211	1397	1386954829000	9301	4826	3	0	5188
89212	1397	1386944828000	9301	4826	4	0	5189
89213	1397	1386934827000	9301	4826	5	0	5190
89216	1726	785323026000	9303	4827	0	0	2163
89218	1397	1386914825000	9304	4828	0	0	\N
89219	1726	785313025000	9304	4828	1	0	\N
89220	1726	785303024000	9304	4828	2	0	\N
89221	1726	785293023000	9304	4828	3	0	\N
89222	1726	785283022000	9304	4828	4	0	\N
89223	1397	1386904824000	9304	4828	5	0	\N
89224	1397	1386894823000	9304	4828	6	0	\N
89225	1397	1386884822000	9304	4828	7	0	\N
89238	1397	1386874821000	9307	4829	0	0	\N
89239	1726	785273021000	9307	4829	1	0	\N
89240	1397	1386864820000	9307	4829	2	0	\N
89241	1740	18715027000000	9307	4829	3	0	\N
89242	1726	785263020000	9308	4830	0	0	\N
89243	1726	785253019000	9308	4830	1	0	\N
89244	1397	1386854819000	9308	4830	2	0	\N
89245	1397	1386844818000	9308	4830	3	0	\N
89250	1397	1386834817000	9310	4831	0	0	\N
89251	1726	785243018000	9310	4831	1	0	\N
89252	1899	1999000000	9310	4831	2	0	\N
89253	1397	1386834817000	9311	4831	0	0	\N
89254	1726	785243018000	9311	4831	1	0	\N
89255	1899	1999000000	9311	4831	2	0	\N
89256	1397	1386834817000	9312	4831	0	0	\N
89257	1726	785243018000	9312	4831	1	0	\N
89258	1899	1999000000	9312	4831	2	0	\N
89259	1397	1386834817000	9313	4831	0	0	\N
89260	1726	785243018000	9313	4831	1	0	\N
89261	1899	1999000000	9313	4831	2	0	\N
89263	1397	1386834817000	9315	4832	0	0	\N
89264	1397	1386824816000	9315	4832	1	0	\N
89265	1726	785233017000	9315	4832	2	0	\N
89266	1899	1999000000	9315	4832	3	0	\N
89271	1397	1386814815000	9317	4833	0	0	\N
89272	1726	785223016000	9317	4833	1	0	\N
89273	1397	1386814815000	9318	4833	0	0	\N
89274	1726	785223016000	9318	4833	1	0	\N
89277	1397	1386814815000	9320	4833	0	0	\N
89278	1726	785223016000	9320	4833	1	0	\N
89279	1726	785223016000	9321	4833	0	0	\N
89292	1726	785163010000	9325	4836	0	0	\N
89303	1397	1386704804000	9328	4839	0	0	\N
89304	1726	785113005000	9328	4839	1	0	\N
89305	1397	1386704804000	9329	4839	0	0	\N
89306	1726	785113005000	9329	4839	1	0	\N
89319	1397	1386664800000	9335	4843	0	0	\N
89320	1397	1386654799000	9335	4843	1	0	\N
89321	1397	1386644798000	9335	4843	2	0	\N
89322	1726	785073001000	9335	4843	3	0	\N
89323	1726	785063000000	9335	4843	4	0	\N
89324	1726	785052999000	9335	4843	5	0	\N
89325	1740	18715026000000	9335	4843	6	0	\N
89333	1397	1386624796000	9338	4845	0	0	\N
89334	1726	785032997000	9338	4845	1	0	\N
89337	1726	785022996000	9340	4846	0	0	\N
89338	1397	1386614795000	9340	4846	1	0	\N
89341	1397	1386594793000	9342	4848	0	0	\N
89342	1726	785002994000	9342	4848	1	0	\N
89343	1397	1386594793000	9343	4848	0	0	\N
89344	1726	785002994000	9343	4848	1	0	\N
89349	1726	784982992000	9346	4850	0	0	\N
89350	1397	1386574791000	9346	4850	1	0	\N
89227	1726	785313025000	9305	4828	1	0	2164
89228	1726	785303024000	9305	4828	2	0	2165
89229	1726	785293023000	9305	4828	3	0	2166
89230	1726	785283022000	9305	4828	4	0	2167
89231	1397	1386904824000	9305	4828	5	0	5193
89233	1397	1386884822000	9305	4828	7	0	5195
89234	1397	1386874821000	9306	4829	0	0	5196
89235	1726	785273021000	9306	4829	1	0	2168
89236	1397	1386864820000	9306	4829	2	0	5197
89237	1740	18715027000000	9306	4829	3	0	6
89247	1726	785253019000	9309	4830	1	0	2170
89248	1397	1386854819000	9309	4830	2	0	5198
89249	1397	1386844818000	9309	4830	3	0	5199
89262	1726	785243018000	9314	4831	0	0	2171
89268	1397	1386824816000	9316	4832	1	0	5201
89269	1726	785233017000	9316	4832	2	0	2172
89270	1899	1999000000	9316	4832	3	0	1
89275	1397	1386814815000	9319	4833	0	0	5202
89276	1726	785223016000	9319	4833	1	0	2173
89281	1726	785213015000	9322	4834	1	0	2174
89282	1726	785203014000	9322	4834	2	0	2175
89283	1726	785193013000	9322	4834	3	0	2176
89284	1397	1386794813000	9322	4834	4	0	5204
89285	1397	1386784812000	9322	4834	5	0	5205
89287	1726	785183012000	9323	4835	1	0	2177
89288	1726	785173011000	9323	4835	2	0	2178
89289	1397	1386764810000	9323	4835	3	0	5207
89290	1397	1386754809000	9324	4836	0	0	5208
89293	1726	785153009000	9326	4837	0	0	2180
89294	1961	343212840828	9326	4837	1	0	1
89295	1726	785143008000	9326	4837	2	0	2181
89296	1397	1386744808000	9326	4837	3	0	5209
89297	1397	1386734807000	9326	4837	4	0	5210
89299	1726	785123006000	9327	4838	1	0	2183
89300	1962	343212840828	9327	4838	3	0	1
89301	1397	1386724806000	9327	4838	4	0	5211
89302	1397	1386714805000	9327	4838	5	0	5212
89307	1397	1386704804000	9330	4839	0	0	5213
89309	1397	1386694803000	9331	4840	0	0	5214
89310	1726	785103004000	9331	4840	1	0	2185
89311	1397	1386684802000	9332	4841	0	0	5215
89312	1726	785093003000	9332	4841	1	0	2186
89314	1397	1386674801000	9333	4842	1	0	5216
89315	1397	1386664800000	9334	4843	0	0	5217
89316	1397	1386654799000	9334	4843	1	0	5218
89317	1397	1386644798000	9334	4843	2	0	5219
89318	1740	18715026000000	9334	4843	3	0	7
89327	1726	785073001000	9336	4844	1	0	2188
89328	1726	785063000000	9336	4844	2	0	2189
89329	1726	785052999000	9336	4844	3	0	2190
89330	1726	785042998000	9336	4844	4	0	2191
89331	1397	1386624796000	9337	4845	0	0	5221
89335	1726	785022996000	9339	4846	0	0	2193
89336	1397	1386614795000	9339	4846	1	0	5222
89339	1397	1386604794000	9341	4847	0	0	5223
89340	1726	785012995000	9341	4847	1	0	2194
89346	1726	785002994000	9344	4848	1	0	2195
89347	1726	784992993000	9345	4849	0	0	2196
89348	1397	1386584792000	9345	4849	1	0	5225
89351	1726	784982992000	9347	4850	0	0	2197
89352	1397	1386574791000	9347	4850	1	0	5226
89353	1726	784982992000	9348	4850	0	0	\N
89354	1397	1386574791000	9348	4850	1	0	\N
89363	1397	1386534787000	9351	4853	0	0	\N
89364	1726	784932987000	9351	4853	1	0	\N
89367	1397	1386534787000	9353	4853	0	0	\N
89368	1726	784932987000	9353	4853	1	0	\N
89371	1397	1386514785000	9355	4855	0	0	\N
89372	1726	784912985000	9355	4855	1	0	\N
89378	1397	1386484782000	9364	4858	0	0	\N
89379	1726	784892983000	9364	4858	1	0	\N
89380	1397	1386484782000	9365	4858	0	0	\N
89381	1726	784892983000	9365	4858	1	0	\N
89386	1397	1386474781000	9368	4859	0	0	\N
89387	1726	784882982000	9368	4859	1	0	\N
89394	1950	97990000000	9372	4863	0	0	\N
89395	1900	66000000	9372	4863	1	0	\N
89400	1726	784832977000	9374	4864	0	0	\N
89401	238	66000170000000	9374	4864	1	0	\N
89402	1397	1386424776000	9374	4864	2	0	\N
89406	1726	784832977000	9376	4864	0	0	\N
89407	238	66000170000000	9376	4864	1	0	\N
89408	1397	1386424776000	9376	4864	2	0	\N
89411	1397	1386414775000	9378	4865	0	0	\N
89412	1726	784822976000	9378	4865	1	0	\N
89417	1726	784812975000	9380	4866	0	0	\N
89418	1726	784802974000	9380	4866	1	0	\N
89419	1397	1386404774000	9380	4866	2	0	\N
89420	1397	1386394773000	9380	4866	4	0	\N
89421	1726	784812975000	9381	4866	0	0	\N
89422	1726	784802974000	9381	4866	1	0	\N
89423	1397	1386404774000	9381	4866	2	0	\N
89424	1397	1386394773000	9381	4866	4	0	\N
89425	1397	1386384772000	9382	4867	0	0	\N
89428	1474	16114284000000	9384	4750	0	0	\N
89429	1950	97990000000	9384	4750	1	0	\N
89430	1961	343212840828	9384	4750	2	0	\N
89431	1693	8107499404570	9384	4750	3	0	\N
89432	1693	8045266563742	9384	4750	4	0	\N
89433	1693	7472160516657	9384	4750	5	0	\N
89434	1962	280990000000	9384	4750	6	0	\N
89435	1693	7409927675829	9384	4750	7	0	\N
89436	1693	7347694835001	9384	4750	8	0	\N
89437	1693	7285461994173	9384	4750	9	0	\N
89438	1693	7223229153345	9384	4750	10	0	\N
89439	1693	7160996312517	9384	4750	11	0	\N
89440	1693	7098763471689	9384	4750	12	0	\N
89441	1693	7036530630861	9384	4750	13	0	\N
89442	1693	6974297790033	9384	4750	14	0	\N
89443	1693	6912064949205	9384	4750	15	0	\N
89444	1693	6849832108377	9384	4750	16	0	\N
89445	1693	6787599267549	9384	4750	17	0	\N
89446	1693	6725366426721	9384	4750	18	0	\N
89447	1693	6663133585893	9384	4750	19	0	\N
89448	1693	6600900745065	9384	4750	20	0	\N
89449	1693	6538667904237	9384	4750	21	0	\N
89450	1693	6476435063409	9384	4750	22	0	\N
89451	1693	6414202222581	9384	4750	23	0	\N
89452	1693	6351969381753	9384	4750	24	0	\N
89453	1693	6289736540925	9384	4750	25	0	\N
89454	1693	6227503700097	9384	4750	26	0	\N
89455	1693	6165270859269	9384	4750	27	0	\N
89456	1693	6163375318648	9384	4750	28	0	\N
89457	1693	6101142477820	9384	4750	29	0	\N
89458	1693	6038909636992	9384	4750	30	0	\N
89459	1693	5976676796164	9384	4750	31	0	\N
89460	1693	5914443955336	9384	4750	32	0	\N
89461	1693	5852211114508	9384	4750	33	0	\N
89462	1693	5789978273680	9384	4750	34	0	\N
89463	1693	5727745432852	9384	4750	35	0	\N
89464	1693	5665512592024	9384	4750	36	0	\N
89465	1693	5603279751196	9384	4750	37	0	\N
89466	1397	1387494883000	9384	4750	38	0	\N
89467	1397	1387484882000	9384	4750	39	0	\N
89468	1397	1387474881000	9384	4750	40	0	\N
89469	1397	1387464880000	9384	4750	41	0	\N
89470	1397	1387454879000	9384	4750	42	0	\N
89471	1397	1387444878000	9384	4750	44	0	\N
89472	1397	1387434877000	9384	4750	45	0	\N
89473	1397	1387424876000	9384	4750	46	0	\N
89474	1397	1387414875000	9384	4750	47	0	\N
89475	1397	1387404874000	9384	4750	48	0	\N
89476	1397	1387394873000	9384	4750	49	0	\N
89477	1397	1387384872000	9384	4750	50	0	\N
89478	1397	1387374871000	9384	4750	51	0	\N
89479	1693	5541046910368	9384	4750	52	0	\N
89480	1693	5478814069540	9384	4750	53	0	\N
89481	1693	5416581228712	9384	4750	54	0	\N
89482	1693	5354348387884	9384	4750	55	0	\N
89483	1693	5292115547056	9384	4750	56	0	\N
89484	1693	5229882706228	9384	4750	57	0	\N
89485	1693	5167649865400	9384	4750	58	0	\N
89486	1693	5165754324779	9384	4750	59	0	\N
89487	1693	5103521483951	9384	4750	60	0	\N
89488	1693	5041288643123	9384	4750	61	0	\N
89357	1397	1386554789000	9349	4851	2	0	5228
89358	1726	784972991000	9349	4851	3	0	2198
89359	1726	784962990000	9349	4851	4	0	2199
89360	1726	784952989000	9349	4851	5	0	2200
89361	1397	1386544788000	9350	4852	0	0	5229
89365	1397	1386534787000	9352	4853	0	0	5230
89366	1726	784932987000	9352	4853	1	0	2202
89369	1397	1386524786000	9354	4854	0	0	5231
89370	1726	784922986000	9354	4854	1	0	2203
89373	1397	1386514785000	9356	4855	0	0	5232
89375	1397	1386504784000	9358	4856	0	0	5233
89376	1397	1386494783000	9363	4857	0	0	5234
89377	1726	784902984000	9363	4857	1	0	2205
89382	1397	1386484782000	9366	4858	0	0	5235
89384	1397	1386474781000	9367	4859	0	0	5236
89385	1726	784882982000	9367	4859	1	0	2207
89388	1726	784872981000	9369	4860	0	0	2208
89389	1397	1386464780000	9369	4860	1	0	5237
89390	1726	784862980000	9370	4861	0	0	2209
89392	1726	784852979000	9371	4862	0	0	2210
89393	1397	1386444778000	9371	4862	1	0	5239
89396	1950	97990000000	9373	4863	0	0	1
89397	1397	1386434777000	9373	4863	1	0	5240
89398	1726	784842978000	9373	4863	2	0	2211
89403	1726	784832977000	9375	4864	0	0	2212
89404	238	66000170000000	9375	4864	1	0	3
89405	1397	1386424776000	9375	4864	2	0	5241
89409	1397	1386414775000	9377	4865	0	0	5242
89413	1726	784812975000	9379	4866	0	0	2214
89414	1726	784802974000	9379	4866	1	0	2215
89415	1397	1386404774000	9379	4866	2	0	5243
89416	1397	1386394773000	9379	4866	4	0	5244
89426	1726	784792973000	9383	4867	0	0	2216
89489	1693	4979055802295	9384	4750	62	0	\N
89490	1693	4916822961467	9384	4750	63	0	\N
89491	1693	4854590120639	9384	4750	64	0	\N
89492	1693	4792357279811	9384	4750	65	0	\N
89493	1693	4730124438983	9384	4750	66	0	\N
89494	1693	4667891598155	9384	4750	67	0	\N
89495	1693	4605658757327	9384	4750	68	0	\N
89496	1693	4543425916499	9384	4750	69	0	\N
89497	1693	4481193075671	9384	4750	70	0	\N
89498	1693	4418960234843	9384	4750	71	0	\N
89499	1693	4356727394015	9384	4750	72	0	\N
89500	1693	4294494553187	9384	4750	73	0	\N
89501	1693	4289770701614	9384	4750	74	0	\N
89502	1693	4227537860786	9384	4750	75	0	\N
89503	1693	4165305019958	9384	4750	76	0	\N
89504	1693	3315911409583	9384	4750	77	0	\N
89505	1693	3253678568755	9384	4750	78	0	\N
89506	1693	2964405030836	9384	4750	79	0	\N
89507	1693	2902172190008	9384	4750	80	0	\N
89508	1693	2884060999956	9384	4750	81	0	\N
89509	1693	2821828159128	9384	4750	82	0	\N
89510	1693	2759595318300	9384	4750	83	0	\N
89511	1693	2697362477472	9384	4750	84	0	\N
89512	1693	2635129636644	9384	4750	85	0	\N
89513	1693	2345856098725	9384	4750	86	0	\N
89514	1693	2283623257897	9384	4750	87	0	\N
89515	1693	2221390417069	9384	4750	88	0	\N
89516	1693	2159157576241	9384	4750	89	0	\N
89517	1693	2096924735413	9384	4750	90	0	\N
89518	1693	2034691894585	9384	4750	91	0	\N
89519	1693	1972459053757	9384	4750	92	0	\N
89520	1693	22449053757	9384	4750	93	0	\N
89521	1726	787153088000	9384	4750	94	0	\N
89522	1726	787143087000	9384	4750	95	0	\N
89523	1726	787133086000	9384	4750	96	0	\N
89524	1726	787123085000	9384	4750	97	0	\N
89525	1726	787113084000	9384	4750	98	0	\N
89526	1726	787103083000	9384	4750	99	0	\N
89527	1726	787093082000	9384	4750	100	0	\N
89528	1726	785883082000	9384	4750	101	0	\N
89529	1726	785873081000	9384	4750	102	0	\N
89530	1726	785863080000	9384	4750	103	0	\N
89531	1726	785853079000	9384	4750	104	0	\N
89532	1726	785843078000	9384	4750	105	0	\N
89533	1726	785833077000	9384	4750	106	0	\N
89534	1726	785823076000	9384	4750	107	0	\N
89535	1726	785813075000	9384	4750	108	0	\N
89536	1726	785803074000	9384	4750	109	0	\N
89537	1726	785793073000	9384	4750	110	0	\N
89538	1726	785783072000	9384	4750	111	0	\N
89539	1726	785773071000	9384	4750	112	0	\N
89540	1726	785763070000	9384	4750	113	0	\N
89541	1726	785753069000	9384	4750	114	0	\N
89542	1726	785743068000	9384	4750	115	0	\N
89543	1726	785733067000	9384	4750	116	0	\N
89544	1726	785723066000	9384	4750	117	0	\N
89545	1726	785713065000	9384	4750	118	0	\N
89546	1726	785703064000	9384	4750	119	0	\N
89547	1726	785693063000	9384	4750	120	0	\N
89548	1726	785683062000	9384	4750	121	0	\N
89549	1726	785673061000	9384	4750	122	0	\N
89550	1726	785663060000	9384	4750	123	0	\N
89551	1726	785653059000	9384	4750	124	0	\N
89552	1726	785643058000	9384	4750	125	0	\N
89553	1397	1386374771000	9385	4868	0	0	\N
89554	1726	784782972000	9385	4868	1	0	\N
89559	1726	784772971000	9388	4869	0	0	\N
89560	1397	1386364770000	9388	4869	1	0	\N
89572	1726	784712965000	9392	4873	0	0	\N
89573	1726	784702964000	9392	4873	1	0	\N
89574	1397	1386304764000	9392	4873	2	0	\N
89575	1397	1386294763000	9392	4873	3	0	\N
89576	1726	784712965000	9393	4873	0	0	\N
89577	1726	784702964000	9393	4873	1	0	\N
89578	1397	1386304764000	9393	4873	2	0	\N
89579	1397	1386294763000	9393	4873	3	0	\N
89595	1726	782232959000	9397	4876	0	0	\N
89596	1397	1386244758000	9397	4876	1	0	\N
89597	1726	782232959000	9398	4876	0	0	\N
89598	1397	1386244758000	9398	4876	1	0	\N
89601	1726	782222958000	9400	4877	0	0	\N
89602	1397	1386234757000	9400	4877	1	0	\N
89603	1397	1386224756000	9400	4877	2	0	\N
89604	1726	782212957000	9400	4877	3	0	\N
89609	1726	782222958000	9402	4877	0	0	\N
89610	1397	1386234757000	9402	4877	1	0	\N
89611	1397	1386224756000	9402	4877	2	0	\N
89612	1726	782212957000	9402	4877	3	0	\N
89557	1726	784772971000	9387	4869	0	0	2218
89558	1397	1386364770000	9387	4869	1	0	5247
89561	1397	1386354769000	9389	4870	0	0	5248
89562	1726	784762970000	9389	4870	1	0	2219
89563	1726	784752969000	9389	4870	2	0	2220
89565	1397	1386334767000	9390	4871	0	0	5250
89566	1726	784742968000	9390	4871	1	0	2221
89567	1864	0	9390	4871	2	0	1
89568	1726	784732967000	9391	4872	0	0	2222
89569	1397	1386324766000	9391	4872	1	0	5251
89571	1726	784722966000	9391	4872	3	0	2223
89580	1726	784712965000	9394	4873	0	0	2224
89581	1726	784702964000	9394	4873	1	0	2225
89582	1397	1386304764000	9394	4873	2	0	5253
89584	1397	1386284762000	9395	4874	0	0	5255
89585	1726	784692963000	9395	4874	1	0	2226
89586	1397	1386274761000	9395	4874	2	0	5256
89587	1726	784682962000	9395	4874	3	0	2227
89588	1474	16834304000000	9396	4875	0	0	6
89590	1726	783462961000	9396	4875	2	0	2229
89591	1726	783452960000	9396	4875	3	0	2230
89592	1726	782242960000	9396	4875	4	0	2231
89593	1397	1386264760000	9396	4875	5	0	5257
89594	1397	1386254759000	9396	4875	6	0	5258
89600	1397	1386244758000	9399	4876	1	0	5259
89605	1726	782222958000	9401	4877	0	0	2233
89606	1397	1386234757000	9401	4877	1	0	5260
89607	1397	1386224756000	9401	4877	2	0	5261
89613	1397	1386214755000	9403	4878	0	0	5262
89614	1726	782202956000	9403	4878	1	0	2235
89615	1950	617980000000	9404	4879	0	0	2
89616	1726	782192955000	9404	4879	1	0	2236
89617	1726	782182954000	9404	4879	2	0	2237
89619	1726	782172953000	9404	4879	4	0	2238
89620	1726	782162952000	9404	4879	5	0	2239
89621	1397	1386204754000	9404	4879	6	0	5263
89622	1397	1386194753000	9404	4879	7	0	5264
89623	1397	1386184752000	9404	4879	8	0	5265
89625	1726	782152951000	9405	4880	0	0	\N
89626	1397	1386164750000	9405	4880	1	0	\N
89643	1726	782082944000	9411	4884	0	0	\N
89644	1397	1386094743000	9411	4884	1	0	\N
89645	1726	782082944000	9412	4884	0	0	\N
89646	1397	1386094743000	9412	4884	1	0	\N
89647	1726	782082944000	9413	4884	0	0	\N
89648	1397	1386094743000	9413	4884	1	0	\N
89655	1397	1386054739000	9416	4887	0	0	\N
89656	1397	1386044738000	9416	4887	1	0	\N
89657	1726	782042940000	9416	4887	2	0	\N
89658	1726	782032939000	9416	4887	3	0	\N
89663	1397	1386054739000	9418	4887	0	0	\N
89664	1397	1386044738000	9418	4887	1	0	\N
89665	1726	782042940000	9418	4887	2	0	\N
89666	1726	782032939000	9418	4887	3	0	\N
89679	1449	30053000459	9427	4890	0	0	\N
89680	1939	708990000000	9428	4879	0	0	\N
89681	1449	30053000459	9428	4879	1	0	\N
89682	1449	30053000459	9429	4892	0	0	\N
89687	1397	1385964730000	9431	4893	0	0	\N
89688	1726	780752932000	9431	4893	1	0	\N
89691	1397	1385964730000	9433	4893	0	0	\N
89692	1726	780752932000	9433	4893	1	0	\N
89693	1397	1385964730000	9434	4893	0	0	\N
89694	1726	780752932000	9434	4893	1	0	\N
89695	1397	1385964730000	9435	4893	0	0	\N
89696	1726	780752932000	9435	4893	1	0	\N
89697	1939	708990000000	9436	4880	0	0	\N
89698	1449	30053000459	9436	4880	1	0	\N
89702	1474	14674223000000	9438	4656	0	0	\N
89703	1885	0	9438	4656	1	0	\N
89704	1756	1906509808900	9438	4656	2	0	\N
89705	1950	97990000000	9438	4656	3	0	\N
89706	1726	794953263000	9438	4656	4	0	\N
89707	1726	794943262000	9438	4656	5	0	\N
89708	55	67439030000000	9438	4656	6	0	\N
89709	1516	15154709112008	9438	4656	7	0	\N
89710	1474	13954213000000	9438	4656	8	0	\N
89711	193	66000067824773	9438	4656	9	0	\N
89712	1397	1389335067000	9438	4656	10	0	\N
89713	1397	1389325066000	9438	4656	11	0	\N
89714	55	67435162750000	9438	4656	12	0	\N
89715	1726	794933261000	9438	4656	13	0	\N
89716	1726	794923260000	9438	4656	14	0	\N
89717	1726	794913259000	9438	4656	15	0	\N
89718	1939	708990000000	9438	4656	16	0	\N
89719	1724	20878090000000	9438	4656	17	0	\N
89720	1864	0	9438	4656	18	0	\N
89721	1903	0	9438	4656	19	0	\N
89722	112	66001047824773	9438	4656	21	0	\N
89723	55	67423581000000	9438	4656	22	0	\N
89724	1693	11039668897158	9438	4656	23	0	\N
89725	1693	10977436056330	9438	4656	24	0	\N
89726	261	66000067824773	9438	4656	25	0	\N
89729	1726	779522930000	9440	4895	0	0	\N
89730	1397	1385944728000	9440	4895	1	0	\N
89737	1397	1385914725000	9443	4897	0	0	\N
89738	1726	779492927000	9443	4897	1	0	\N
89739	1397	1385904724000	9444	4898	0	0	\N
89740	1726	779482926000	9444	4898	1	0	\N
89741	1726	779472925000	9444	4898	2	0	\N
89742	1397	1385894723000	9444	4898	3	0	\N
89747	1397	1385884722000	9446	4899	0	0	\N
89748	1726	779462924000	9446	4899	1	0	\N
89753	1397	1385874721000	9449	4900	0	0	\N
89754	1726	779452923000	9449	4900	1	0	\N
89757	1397	1385854719000	9451	4902	0	0	\N
89758	1726	779442922000	9451	4902	1	0	\N
89759	1726	779432921000	9451	4902	2	0	\N
89760	1397	1385844718000	9451	4902	3	0	\N
89629	1726	782142950000	9407	4881	0	0	2241
89630	1397	1386154749000	9407	4881	1	0	5268
89631	1726	782132949000	9408	4882	0	0	2242
89632	1397	1386144748000	9408	4882	1	0	5269
89633	1397	1386134747000	9409	4883	0	0	5270
89635	1726	782112947000	9409	4883	2	0	2244
89636	1726	782102946000	9409	4883	3	0	2245
89637	1726	782092945000	9409	4883	4	0	2246
89638	1397	1386124746000	9409	4883	5	0	5271
89639	1397	1386114745000	9409	4883	6	0	5272
89641	1726	782082944000	9410	4884	0	0	2247
89642	1397	1386094743000	9410	4884	1	0	5274
89649	1397	1386084742000	9414	4885	0	0	5275
89650	1726	782072943000	9414	4885	1	0	2248
89652	1726	782052941000	9415	4886	1	0	2250
89653	1397	1386074741000	9415	4886	2	0	5276
89654	1397	1386064740000	9415	4886	3	0	5277
89659	1397	1386054739000	9417	4887	0	0	5278
89660	1397	1386044738000	9417	4887	1	0	5279
89662	1726	782032939000	9417	4887	3	0	2252
89667	1726	782022938000	9420	4888	0	0	2253
89668	1397	1386034737000	9420	4888	1	0	5280
89669	1726	782012937000	9424	4889	0	0	2254
89670	1397	1386024736000	9424	4889	1	0	5281
89672	1726	781992935000	9425	4890	1	0	2256
89673	1397	1386014735000	9425	4890	2	0	5282
89674	1397	1386004734000	9425	4890	3	0	5283
89675	1397	1385994733000	9426	4891	0	0	5284
89677	1726	781982934000	9426	4891	2	0	2257
89678	1726	781972933000	9426	4891	3	0	2258
89683	1939	708990000000	9430	4892	0	0	1
89684	1397	1385974731000	9430	4892	1	0	5286
89685	1726	781962932000	9430	4892	2	0	2259
89689	1397	1385964730000	9432	4893	0	0	5287
89690	1726	780752932000	9432	4893	1	0	2260
89699	1397	1385954729000	9437	4894	0	0	5288
89700	1726	779542932000	9437	4894	1	0	2261
89701	1726	779532931000	9437	4894	2	0	2262
89728	1397	1385944728000	9439	4895	1	0	5289
89731	1397	1385934727000	9441	4896	0	0	5290
89732	1397	1385924726000	9441	4896	1	0	5291
89733	1726	779512929000	9441	4896	2	0	2264
89735	1397	1385914725000	9442	4897	0	0	5292
89736	1726	779492927000	9442	4897	1	0	2266
89743	1397	1385904724000	9445	4898	0	0	5293
89744	1726	779482926000	9445	4898	1	0	2267
89745	1726	779472925000	9445	4898	2	0	2268
89749	1397	1385884722000	9447	4899	0	0	5295
89750	1726	779462924000	9447	4899	1	0	2269
89751	1397	1385874721000	9448	4900	0	0	5296
89752	1726	779452923000	9448	4900	1	0	2270
89755	1397	1385864720000	9450	4901	0	0	5297
89761	563	66000527000000	9451	4902	4	0	\N
89767	1397	1385854719000	9453	4902	0	0	\N
89768	1726	779442922000	9453	4902	1	0	\N
89769	1726	779432921000	9453	4902	2	0	\N
89770	1397	1385844718000	9453	4902	3	0	\N
89771	563	66000527000000	9453	4902	4	0	\N
89772	1397	1385834717000	9454	4903	0	0	\N
89773	1726	779422920000	9454	4903	1	0	\N
89776	1397	1385834717000	9457	4903	0	0	\N
89777	1726	779422920000	9457	4903	1	0	\N
89778	1726	779412919000	9458	4904	0	0	\N
89779	1397	1385824716000	9458	4904	1	0	\N
89782	1726	779402918000	9460	4905	0	0	\N
89783	1397	1385814715000	9460	4905	1	0	\N
89787	1726	779392917000	9463	4906	0	0	\N
89788	1397	1385804714000	9463	4906	1	0	\N
89789	44	82551009000000	9464	4881	0	0	\N
89790	563	66000527000000	9464	4881	1	0	\N
89800	1397	1385884722000	9468	4899	0	0	\N
89801	1397	1385874721000	9468	4899	1	0	\N
89802	1397	1385864720000	9468	4899	2	0	\N
89803	1397	1385854719000	9468	4899	3	0	\N
89804	1397	1385844718000	9468	4899	4	0	\N
89805	1397	1385834717000	9468	4899	5	0	\N
89806	1397	1385824716000	9468	4899	6	0	\N
89807	1397	1385814715000	9468	4899	7	0	\N
89808	1397	1385804714000	9468	4899	8	0	\N
89809	1397	1385794713000	9468	4899	9	0	\N
89810	1397	1385784712000	9468	4899	10	0	\N
89811	1397	1385774711000	9468	4899	11	0	\N
89812	1397	1385764710000	9468	4899	12	0	\N
89813	1726	779462924000	9468	4899	13	0	\N
89814	1726	779452923000	9468	4899	14	0	\N
89815	1726	779442922000	9468	4899	15	0	\N
89816	1726	779432921000	9468	4899	16	0	\N
89817	1726	779422920000	9468	4899	17	0	\N
89818	1726	779412919000	9468	4899	18	0	\N
89819	1726	779402918000	9468	4899	19	0	\N
89820	1726	779392917000	9468	4899	20	0	\N
89821	1726	779382916000	9468	4899	21	0	\N
89822	1726	779372915000	9468	4899	22	0	\N
89823	1726	779362914000	9468	4899	23	0	\N
89824	1726	779352913000	9468	4899	24	0	\N
89825	44	82551009000000	9468	4899	25	0	\N
89826	563	66000527000000	9468	4899	26	0	\N
89834	498	66001750000000	9470	4911	0	0	\N
89835	1397	1385724706000	9470	4911	1	0	\N
89836	1726	779312909000	9470	4911	2	0	\N
89839	498	66001750000000	9472	4911	0	0	\N
89840	1397	1385724706000	9472	4911	1	0	\N
89841	1726	779312909000	9472	4911	2	0	\N
89842	498	66001750000000	9473	4719	0	0	\N
89843	1474	16114284000000	9473	4719	1	0	\N
89844	1950	97990000000	9473	4719	2	0	\N
89845	1961	280990000000	9473	4719	3	0	\N
89846	1474	15394274000000	9473	4719	4	0	\N
89847	1726	790413172000	9473	4719	5	0	\N
89848	1726	790403171000	9473	4719	6	0	\N
89849	55	68155182750000	9473	4719	7	0	\N
89850	1397	1388414975000	9473	4719	8	0	\N
89851	1397	1388404974000	9473	4719	9	0	\N
89852	1939	708990000000	9473	4719	10	0	\N
89853	1962	280990000000	9473	4719	11	0	\N
89854	1724	20878090000000	9473	4719	12	0	\N
89855	1864	0	9473	4719	13	0	\N
89856	55	68143601000000	9473	4719	14	0	\N
89857	1693	11759708897158	9473	4719	15	0	\N
89858	1693	11697476056330	9473	4719	16	0	\N
89859	1397	1388394973000	9473	4719	17	0	\N
89860	1397	1388384972000	9473	4719	18	0	\N
89861	1397	1388374971000	9473	4719	19	0	\N
89862	1397	1388364970000	9473	4719	20	0	\N
89863	1397	1388354969000	9473	4719	21	0	\N
89864	1397	1388344968000	9473	4719	22	0	\N
89865	1397	1388334967000	9473	4719	23	0	\N
89866	1397	1388324966000	9473	4719	24	0	\N
89867	1397	1388314965000	9473	4719	25	0	\N
89868	1397	1388304964000	9473	4719	26	0	\N
89869	1397	1388294963000	9473	4719	27	0	\N
89870	1397	1388284962000	9473	4719	28	0	\N
89871	1397	1388274961000	9473	4719	29	0	\N
89872	1397	1388264960000	9473	4719	30	0	\N
89873	1397	1388254959000	9473	4719	31	0	\N
89874	1397	1388244958000	9473	4719	32	0	\N
89875	1397	1388234957000	9473	4719	33	0	\N
89876	1397	1388224956000	9473	4719	34	0	\N
89877	1397	1388214955000	9473	4719	35	0	\N
89878	1397	1388204954000	9473	4719	36	0	\N
89879	1397	1388194953000	9473	4719	37	0	\N
89880	1397	1388184952000	9473	4719	38	0	\N
89881	1397	1388174951000	9473	4719	39	0	\N
89882	1397	1388164950000	9473	4719	40	0	\N
89883	1726	790393170000	9473	4719	41	0	\N
89884	1726	790383169000	9473	4719	42	0	\N
89885	1726	790373168000	9473	4719	43	0	\N
89886	1726	790363167000	9473	4719	44	0	\N
89887	1726	790353166000	9473	4719	45	0	\N
89888	1726	790343165000	9473	4719	46	0	\N
89889	1726	790333164000	9473	4719	47	0	\N
89890	1726	790323163000	9473	4719	48	0	\N
89891	55	67889012500000	9473	4719	49	0	\N
89892	55	67634424000000	9473	4719	50	0	\N
89893	55	67379835500000	9473	4719	51	0	\N
89894	55	67125247000000	9473	4719	52	0	\N
89895	55	66870658500000	9473	4719	53	0	\N
89896	55	66616070000000	9473	4719	54	0	\N
89764	1726	779432921000	9452	4902	2	0	2272
89765	1397	1385844718000	9452	4902	3	0	5299
89766	563	66000527000000	9452	4902	4	0	3
89774	1397	1385834717000	9455	4903	0	0	5300
89775	1726	779422920000	9455	4903	1	0	2273
89781	1397	1385824716000	9459	4904	1	0	5301
89784	1726	779402918000	9461	4905	0	0	2275
89785	1397	1385814715000	9461	4905	1	0	5302
89786	1397	1385804714000	9462	4906	0	0	5303
89791	1726	779392917000	9465	4907	0	0	2276
89793	1726	779382916000	9465	4907	2	0	2277
89794	1726	779372915000	9466	4908	0	0	2278
89795	1726	779362914000	9466	4908	1	0	2279
89796	1397	1385784712000	9466	4908	2	0	5305
89798	1726	779352913000	9467	4909	0	0	2280
89799	1397	1385764710000	9467	4909	1	0	5307
89827	1726	779342912000	9469	4910	0	0	2281
89828	1397	1385754709000	9469	4910	1	0	5308
89829	1397	1385744708000	9469	4910	2	0	5309
89831	1726	779332911000	9469	4910	4	0	2282
89832	1726	779322910000	9469	4910	5	0	2283
89833	44	82541008000000	9469	4910	6	0	2
89837	498	66001750000000	9471	4911	0	0	1
89838	1726	779312909000	9471	4911	1	0	2284
89897	1726	790313162000	9473	4719	55	0	\N
89898	1726	790303161000	9473	4719	56	0	\N
89899	55	66361481500000	9473	4719	57	0	\N
89900	1397	1388154949000	9473	4719	58	0	\N
89901	1397	1388144948000	9473	4719	59	0	\N
89902	1397	1388134947000	9473	4719	60	0	\N
89903	1397	1388124946000	9473	4719	61	0	\N
89904	1397	1388114945000	9473	4719	62	0	\N
89905	1397	1388104944000	9473	4719	63	0	\N
89906	1397	1388094943000	9473	4719	64	0	\N
89907	1397	1388084942000	9473	4719	65	0	\N
89908	1397	1388074941000	9473	4719	66	0	\N
89909	1397	1388064940000	9473	4719	68	0	\N
89910	1397	1388054939000	9473	4719	69	0	\N
89911	1397	1388044938000	9473	4719	70	0	\N
89912	1397	1388034937000	9473	4719	71	0	\N
89913	1397	1388024936000	9473	4719	72	0	\N
89914	1397	1388014935000	9473	4719	73	0	\N
89915	1397	1388004934000	9473	4719	74	0	\N
89916	1726	790293160000	9473	4719	75	0	\N
89917	1726	790283159000	9473	4719	76	0	\N
89918	1726	790273158000	9473	4719	77	0	\N
89919	1397	1387994933000	9473	4719	78	0	\N
89920	1397	1387984932000	9473	4719	79	0	\N
89921	1397	1387974931000	9473	4719	80	0	\N
89922	1397	1387964930000	9473	4719	81	0	\N
89923	1397	1387954929000	9473	4719	82	0	\N
89924	1397	1387944928000	9473	4719	83	0	\N
89925	1397	1387934927000	9473	4719	84	0	\N
89926	1397	1387924926000	9473	4719	85	0	\N
89927	1397	1387914925000	9473	4719	86	0	\N
89928	1397	1387904924000	9473	4719	87	0	\N
89929	1397	1387894923000	9473	4719	88	0	\N
89930	1397	1387884922000	9473	4719	89	0	\N
89931	1397	1387874921000	9473	4719	90	0	\N
89932	1397	1387864920000	9473	4719	91	0	\N
89933	1397	1387854919000	9473	4719	92	0	\N
89934	1397	1387844918000	9473	4719	93	0	\N
89935	1397	1387834917000	9473	4719	94	0	\N
89936	1397	1387824916000	9473	4719	95	0	\N
89937	1397	1387814915000	9473	4719	96	0	\N
89938	1397	1387804914000	9473	4719	97	0	\N
89939	1397	1387794913000	9473	4719	98	0	\N
89940	1397	1387784912000	9473	4719	99	0	\N
89941	1397	1387774911000	9473	4719	100	0	\N
89942	1397	1387764910000	9473	4719	101	0	\N
89943	1397	1387754909000	9473	4719	102	0	\N
89944	1397	1387744908000	9473	4719	103	0	\N
89945	1397	1387734907000	9473	4719	104	0	\N
89946	1397	1387724906000	9473	4719	105	0	\N
89947	1397	1387714905000	9473	4719	106	0	\N
89948	1397	1387704904000	9473	4719	107	0	\N
89949	1397	1387694903000	9473	4719	108	0	\N
89950	1397	1387684902000	9473	4719	109	0	\N
89951	1397	1387674901000	9473	4719	110	0	\N
89952	1397	1387664900000	9473	4719	111	0	\N
89953	1397	1387654899000	9473	4719	112	0	\N
89954	1397	1387644898000	9473	4719	113	0	\N
89955	1397	1387634897000	9473	4719	114	0	\N
89956	1397	1387624896000	9473	4719	115	0	\N
89957	1397	1387614895000	9473	4719	116	0	\N
89958	1397	1387604894000	9473	4719	117	0	\N
89959	1397	1387594893000	9473	4719	118	0	\N
89960	1397	1387584892000	9473	4719	119	0	\N
89961	1397	1387574891000	9473	4719	120	0	\N
89962	1397	1387564890000	9473	4719	121	0	\N
89963	1397	1387554889000	9473	4719	122	0	\N
89964	1397	1387544888000	9473	4719	123	0	\N
89965	1397	1387534887000	9473	4719	124	0	\N
89966	1397	1387524886000	9473	4719	125	0	\N
89974	1397	1385684702000	9476	4914	0	0	\N
89975	1726	779272905000	9476	4914	1	0	\N
89984	1397	1385664700000	9480	4916	0	0	\N
89985	1726	776832903000	9480	4916	1	0	\N
89986	1397	1385664700000	9481	4916	0	0	\N
89987	1726	776832903000	9481	4916	1	0	\N
89990	1397	1385654699000	9483	4917	0	0	\N
89991	1726	776822902000	9483	4917	1	0	\N
89992	528	66001900000000	9484	4918	0	0	\N
89993	1726	776812901000	9484	4918	1	0	\N
89994	1726	776802900000	9484	4918	2	0	\N
89995	1726	776792899000	9484	4918	3	0	\N
89996	1397	1385644698000	9484	4918	4	0	\N
89997	1397	1385634697000	9484	4918	5	0	\N
89998	1397	1385624696000	9484	4918	6	0	\N
90012	1726	775552896000	9489	4922	0	0	\N
90013	1397	1385584692000	9489	4922	1	0	\N
90021	724	20001400000000	9493	4925	0	0	\N
90022	1726	775522893000	9493	4925	1	0	\N
90023	1397	1385554689000	9493	4925	2	0	\N
90024	1397	1385544688000	9493	4925	3	0	\N
90025	1726	775512892000	9493	4925	4	0	\N
90031	1726	775502891000	9495	4926	0	0	\N
90032	1397	1385534687000	9495	4926	1	0	\N
89969	1397	1385714705000	9474	4912	2	0	5312
89970	1397	1385704704000	9475	4913	0	0	5313
89971	1397	1385694703000	9475	4913	1	0	5314
89972	1726	779292907000	9475	4913	2	0	2286
89973	1726	779282906000	9475	4913	3	0	2287
89977	1726	779272905000	9477	4914	1	0	2288
89978	1726	778062905000	9478	4915	0	0	2289
89979	1726	776852905000	9478	4915	1	0	2290
89980	1397	1385674701000	9478	4915	3	0	5316
89981	1726	776842904000	9478	4915	4	0	2291
89983	1726	776832903000	9479	4916	1	0	2292
89988	1397	1385654699000	9482	4917	0	0	5318
89989	1726	776822902000	9482	4917	1	0	2293
89999	528	66001900000000	9485	4918	0	0	1
90001	1726	776802900000	9485	4918	2	0	2295
90002	1726	776792899000	9485	4918	3	0	2296
90003	1397	1385644698000	9485	4918	4	0	5319
90004	1397	1385634697000	9485	4918	5	0	5320
90005	1397	1385624696000	9485	4918	6	0	5321
90007	1397	1385614695000	9486	4919	1	0	5322
90008	1397	1385604694000	9487	4920	0	0	5323
90009	1726	776772897000	9487	4920	1	0	2298
90010	1726	775562897000	9488	4921	0	0	2299
90011	1397	1385594693000	9488	4921	1	0	5324
90015	1397	1385584692000	9490	4922	1	0	5325
90016	1726	775542895000	9491	4923	0	0	2301
90017	1397	1385574691000	9491	4923	1	0	5326
90018	724	20001650000000	9492	4924	0	0	3
90020	1726	775532894000	9492	4924	2	0	2302
90026	724	20001400000000	9494	4925	0	0	4
90027	1726	775522893000	9494	4925	1	0	2303
90028	1397	1385554689000	9494	4925	2	0	5328
90029	1397	1385544688000	9494	4925	3	0	5329
90035	1726	775502891000	9497	4926	0	0	\N
90036	1397	1385534687000	9497	4926	1	0	\N
90037	1726	775502891000	9498	4926	0	0	\N
90038	1397	1385534687000	9498	4926	1	0	\N
90045	1726	775472888000	9501	4928	0	0	\N
90046	1397	1385504684000	9501	4928	1	0	\N
90047	498	66001500000000	9502	4929	0	0	\N
90048	1726	775462887000	9502	4929	1	0	\N
90049	1397	1385494683000	9502	4929	2	0	\N
90050	498	66001500000000	9503	4929	0	0	\N
90051	1726	775462887000	9503	4929	1	0	\N
90052	1397	1385494683000	9503	4929	2	0	\N
90053	498	66001500000000	9504	4929	0	0	\N
90054	1726	775462887000	9504	4929	1	0	\N
90055	1397	1385494683000	9504	4929	2	0	\N
90056	498	66001500000000	9505	4929	0	0	\N
90057	1726	775462887000	9505	4929	1	0	\N
90058	1397	1385494683000	9505	4929	2	0	\N
90062	1726	775452886000	9507	4930	0	0	\N
90063	1397	1385484682000	9507	4930	1	0	\N
90068	1726	775432884000	9510	4932	0	0	\N
90069	1397	1385464680000	9510	4932	1	0	\N
90070	1397	1385454679000	9510	4932	2	0	\N
90074	1726	775432884000	9512	4932	0	0	\N
90075	1397	1385464680000	9512	4932	1	0	\N
90076	1397	1385454679000	9512	4932	2	0	\N
90079	1397	1385444678000	9514	4933	0	0	\N
90080	1726	775422883000	9514	4933	1	0	\N
90083	1397	1385434677000	9516	4934	0	0	\N
90084	1726	775412882000	9516	4934	1	0	\N
90085	1726	775402881000	9517	4935	0	0	\N
90086	1397	1385424676000	9517	4935	1	0	\N
90091	1670	22319110000000	9520	4937	0	0	\N
90092	1726	775382879000	9520	4937	1	0	\N
90093	411	66719910000000	9520	4937	2	0	\N
90094	1397	1385404674000	9520	4937	3	0	\N
90095	1397	1385394673000	9520	4937	4	0	\N
90096	1726	775372878000	9520	4937	5	0	\N
90097	1670	22319110000000	9521	4937	0	0	\N
90098	1726	775382879000	9521	4937	1	0	\N
90099	411	66719910000000	9521	4937	2	0	\N
90100	1397	1385404674000	9521	4937	3	0	\N
90101	1397	1385394673000	9521	4937	4	0	\N
90102	1726	775372878000	9521	4937	5	0	\N
90103	1670	22319110000000	9522	4937	0	0	\N
90104	1726	775382879000	9522	4937	1	0	\N
90105	411	66719910000000	9522	4937	2	0	\N
90106	1397	1385404674000	9522	4937	3	0	\N
90107	1397	1385394673000	9522	4937	4	0	\N
90108	1726	775372878000	9522	4937	5	0	\N
90115	1397	1385384672000	9524	4938	0	0	\N
90116	1397	1385374671000	9524	4938	1	0	\N
90117	1726	775362877000	9524	4938	2	0	\N
90118	1726	775352876000	9524	4938	3	0	\N
90119	9	32567999000000	9524	4938	4	0	\N
90132	1670	7467910000000	9529	4942	0	0	\N
90133	1726	775322873000	9529	4942	1	0	\N
90134	1726	775312872000	9529	4942	2	0	\N
90135	1397	1385344668000	9529	4942	3	0	\N
90136	1397	1385334667000	9529	4942	4	0	\N
90142	1670	3987810000000	9531	4943	0	0	\N
90143	1397	1385324666000	9531	4943	1	0	\N
90144	1397	1385314665000	9531	4943	2	0	\N
90145	1726	775302871000	9531	4943	3	0	\N
90146	1726	775292870000	9531	4943	4	0	\N
90152	1726	775282869000	9533	4944	0	0	\N
90153	1397	1385304664000	9533	4944	1	0	\N
90156	1726	775282869000	9535	4944	0	0	\N
90157	1397	1385304664000	9535	4944	1	0	\N
90158	1670	1109710000000	9536	4945	0	0	\N
90159	1397	1385294663000	9536	4945	1	0	\N
90160	1726	775272868000	9536	4945	2	0	\N
90164	1670	1109710000000	9538	4945	0	0	\N
90165	1397	1385294663000	9538	4945	1	0	\N
90039	1726	775492890000	9499	4927	0	0	2306
90040	1726	775482889000	9499	4927	1	0	2307
90041	1397	1385524686000	9499	4927	2	0	5331
90042	1397	1385514685000	9499	4927	3	0	5332
90043	1726	775472888000	9500	4928	0	0	2308
90059	498	66001500000000	9506	4929	0	0	2
90060	1726	775462887000	9506	4929	1	0	2309
90061	1397	1385494683000	9506	4929	2	0	5334
90064	1726	775452886000	9508	4930	0	0	2310
90065	1397	1385484682000	9508	4930	1	0	5335
90067	1397	1385474681000	9509	4931	1	0	5336
90071	1726	775432884000	9511	4932	0	0	2312
90072	1397	1385464680000	9511	4932	1	0	5337
90073	1397	1385454679000	9511	4932	2	0	5338
90078	1726	775422883000	9513	4933	1	0	2313
90081	1397	1385434677000	9515	4934	0	0	5340
90082	1726	775412882000	9515	4934	1	0	2314
90087	1726	775402881000	9518	4935	0	0	2315
90088	1397	1385424676000	9518	4935	1	0	5341
90090	1726	775392880000	9519	4936	1	0	2316
90109	1670	22319110000000	9523	4937	0	0	1
90110	1726	775382879000	9523	4937	1	0	2317
90111	411	66719910000000	9523	4937	2	0	1
90112	1397	1385404674000	9523	4937	3	0	5343
90114	1726	775372878000	9523	4937	5	0	2318
90120	1397	1385384672000	9525	4938	0	0	5345
90121	1397	1385374671000	9525	4938	1	0	5346
90122	1726	775362877000	9525	4938	2	0	2319
90124	9	32567999000000	9525	4938	4	0	1
90125	1670	12625010000000	9526	4939	0	0	2
90126	411	66419900000000	9526	4939	1	0	2
90127	1397	1385364670000	9526	4939	2	0	5347
90128	1726	775342875000	9526	4939	3	0	2321
90130	1397	1385354669000	9527	4940	0	0	5348
90131	1726	775332874000	9527	4940	1	0	2322
90137	1670	7467910000000	9530	4942	0	0	3
90138	1726	775322873000	9530	4942	1	0	2323
90139	1726	775312872000	9530	4942	2	0	2324
90141	1397	1385334667000	9530	4942	4	0	5350
90147	1670	3987810000000	9532	4943	0	0	4
90148	1397	1385324666000	9532	4943	1	0	5351
90149	1397	1385314665000	9532	4943	2	0	5352
90151	1726	775292870000	9532	4943	4	0	2326
90154	1726	775282869000	9534	4944	0	0	2327
90155	1397	1385304664000	9534	4944	1	0	5353
90161	1670	1109710000000	9537	4945	0	0	5
90162	1397	1385294663000	9537	4945	1	0	5354
90166	1670	610000000	9539	4946	0	0	6
90167	1950	689410000000	9539	4946	1	0	3
90168	1397	1385284662000	9539	4946	2	0	5355
90175	1726	775252866000	9541	4947	0	0	\N
90176	1726	775242865000	9541	4947	1	0	\N
90177	1397	1385264660000	9541	4947	2	0	\N
90178	1397	1385254659000	9541	4947	3	0	\N
90179	1726	775252866000	9542	4947	0	0	\N
90180	1726	775242865000	9542	4947	1	0	\N
90181	1397	1385264660000	9542	4947	2	0	\N
90182	1397	1385254659000	9542	4947	3	0	\N
90189	1397	1385224656000	9546	4950	0	0	\N
90190	1726	775212862000	9546	4950	1	0	\N
90199	1397	1385184652000	9550	4953	0	0	\N
90200	1726	775172858000	9550	4953	1	0	\N
90201	1397	1385184652000	9551	4953	0	0	\N
90203	1397	1385174651000	9555	4954	0	0	\N
90220	1397	1385104644000	9563	4959	0	0	\N
90221	1726	775102851000	9563	4959	1	0	\N
90222	1726	775092850000	9563	4959	2	0	\N
90223	1397	1385094643000	9563	4959	3	0	\N
90224	1726	775082849000	9564	4960	0	0	\N
90225	1397	1385084642000	9564	4960	1	0	\N
90226	1764	18520678100000	9564	4960	2	0	\N
90230	1726	775072848000	9566	4961	0	0	\N
90231	1397	1385074641000	9566	4961	1	0	\N
90234	1726	775072848000	9568	4961	0	0	\N
90235	1397	1385074641000	9568	4961	1	0	\N
90245	1726	775062847000	9570	4962	0	0	\N
90246	1726	775052846000	9570	4962	1	0	\N
90247	1726	775042845000	9570	4962	2	0	\N
90248	1726	775032844000	9570	4962	3	0	\N
90249	1397	1385064640000	9570	4962	4	0	\N
90250	1397	1385054639000	9570	4962	5	0	\N
90251	1397	1385044638000	9570	4962	6	0	\N
90252	1397	1385034637000	9570	4962	7	0	\N
90253	1764	15720677100000	9570	4962	8	0	\N
90257	1397	1385014635000	9572	4964	0	0	\N
90258	1726	775012842000	9572	4964	1	0	\N
90269	1726	774972838000	9578	4968	0	0	\N
90273	1958	705988000000	9580	4969	0	0	\N
90274	1726	774962837000	9580	4969	1	0	\N
90275	1397	1384964630000	9580	4969	2	0	\N
90280	1950	3689400000000	9583	4972	0	0	\N
90281	1726	774932834000	9583	4972	1	0	\N
90282	1397	1384934627000	9583	4972	2	0	\N
90283	1397	1384924626000	9583	4972	3	0	\N
90288	1726	774922833000	9585	4973	0	0	\N
90289	1397	1384914625000	9585	4973	1	0	\N
90292	1726	774912832000	9587	4974	0	0	\N
90293	1397	1384904624000	9587	4974	1	0	\N
90296	1726	774912832000	9589	4974	0	0	\N
90297	1397	1384904624000	9589	4974	1	0	\N
90300	1726	774902831000	9591	4975	0	0	\N
90301	1397	1384894623000	9591	4975	1	0	\N
90302	1726	774892830000	9592	4976	0	0	\N
90303	1397	1384884622000	9592	4976	1	0	\N
90304	1726	774892830000	9593	4976	0	0	\N
90171	1726	775252866000	9540	4947	0	0	2330
90172	1726	775242865000	9540	4947	1	0	2331
90173	1397	1385264660000	9540	4947	2	0	5357
90174	1397	1385254659000	9540	4947	3	0	5358
90183	1726	775232864000	9543	4948	0	0	2332
90185	1397	1385234657000	9544	4949	0	0	5360
90186	1726	775222863000	9544	4949	1	0	2333
90187	1397	1385224656000	9545	4950	0	0	5361
90188	1726	775212862000	9545	4950	1	0	2334
90191	1397	1385214655000	9547	4951	0	0	5362
90193	1726	775202861000	9547	4951	2	0	2335
90194	1726	775192860000	9547	4951	3	0	2336
90195	1397	1385194653000	9548	4952	0	0	5364
90196	1726	775182859000	9548	4952	1	0	2337
90198	1726	775172858000	9549	4953	1	0	2338
90202	1397	1385174651000	9553	4954	0	0	5366
90204	1397	1385164650000	9558	4955	0	0	5367
90205	1397	1385154649000	9558	4955	1	0	5368
90206	1726	775162857000	9558	4955	2	0	2339
90208	1726	775142855000	9559	4956	0	0	2341
90209	1726	775132854000	9559	4956	1	0	2342
90210	1397	1385144648000	9559	4956	2	0	5369
90211	1397	1385134647000	9559	4956	3	0	5370
90212	1397	1385124646000	9560	4957	0	0	5371
90214	1726	775112852000	9561	4958	0	0	2344
90215	1397	1385114645000	9561	4958	1	0	5372
90216	1397	1385104644000	9562	4959	0	0	5373
90217	1726	775102851000	9562	4959	1	0	2345
90219	1397	1385094643000	9562	4959	3	0	5374
90227	1726	775082849000	9565	4960	0	0	2347
90228	1397	1385084642000	9565	4960	1	0	5375
90229	1764	18520678100000	9565	4960	2	0	3
90232	1726	775072848000	9567	4961	0	0	2348
90236	1726	775062847000	9569	4962	0	0	2349
90237	1726	775052846000	9569	4962	1	0	2350
90238	1726	775042845000	9569	4962	2	0	2351
90239	1726	775032844000	9569	4962	3	0	2352
90240	1397	1385064640000	9569	4962	4	0	5377
90242	1397	1385044638000	9569	4962	6	0	5379
90243	1397	1385034637000	9569	4962	7	0	5380
90244	1764	15720677100000	9569	4962	8	0	4
90254	1974	0	9571	4963	0	0	1
90256	1726	775022843000	9571	4963	2	0	2353
90259	1397	1385014635000	9573	4964	0	0	5382
90260	1726	775012842000	9573	4964	1	0	2354
90261	1397	1385004634000	9574	4965	0	0	5383
90262	1726	775002841000	9574	4965	1	0	2355
90264	1397	1384994633000	9575	4966	1	0	5384
90265	1726	774982839000	9576	4967	0	0	2357
90266	1397	1384984632000	9576	4967	1	0	5385
90267	1397	1384974631000	9577	4968	0	0	5386
90268	1726	774972838000	9577	4968	1	0	2358
90271	1726	774962837000	9579	4969	1	0	2359
90272	1397	1384964630000	9579	4969	2	0	5387
90276	1726	774952836000	9581	4970	0	0	2360
90277	1397	1384954629000	9581	4970	1	0	5388
90279	1726	774942835000	9582	4971	1	0	2361
90284	1950	3689400000000	9584	4972	0	0	4
90285	1726	774932834000	9584	4972	1	0	2362
90286	1397	1384934627000	9584	4972	2	0	5390
90287	1397	1384924626000	9584	4972	3	0	5391
90291	1397	1384914625000	9586	4973	1	0	5392
90294	1726	774912832000	9588	4974	0	0	2364
90295	1397	1384904624000	9588	4974	1	0	5393
90298	1726	774902831000	9590	4975	0	0	2365
90299	1397	1384894623000	9590	4975	1	0	5394
90305	1397	1384884622000	9593	4976	1	0	\N
90318	1726	774852826000	9598	4979	0	0	\N
90319	1397	1384844618000	9598	4979	1	0	\N
90320	1726	774842825000	9598	4979	2	0	\N
90321	1397	1384834617000	9598	4979	3	0	\N
90322	1726	774832824000	9599	4980	0	0	\N
90323	1397	1384824616000	9599	4980	1	0	\N
90324	411	66119890000000	9599	4980	2	0	\N
90328	1726	774832824000	9601	4980	0	0	\N
90329	1397	1384824616000	9601	4980	1	0	\N
90330	411	66119890000000	9601	4980	2	0	\N
90341	1397	1384794613000	9605	4983	0	0	\N
90342	1726	774812822000	9605	4983	1	0	\N
90343	1726	774802821000	9605	4983	2	0	\N
90344	1397	1384784612000	9605	4983	3	0	\N
90345	1694	38880369000000	9605	4983	4	0	\N
90346	1694	38880368000000	9605	4983	5	0	\N
90347	1397	1384774611000	9606	4984	0	0	\N
90348	1726	774792820000	9606	4984	1	0	\N
90349	1397	1384764610000	9606	4984	2	0	\N
90350	1726	774782819000	9606	4984	3	0	\N
90364	1397	1384734607000	9610	4986	0	0	\N
90365	1726	774752816000	9610	4986	1	0	\N
90366	1694	38880367000000	9610	4986	2	0	\N
90367	1694	38880366000000	9610	4986	3	0	\N
90368	1694	38880365000000	9610	4986	4	0	\N
90369	1726	774742815000	9611	4987	0	0	\N
90370	1397	1384724606000	9611	4987	1	0	\N
90371	1726	774742815000	9612	4987	0	0	\N
90372	1397	1384724606000	9612	4987	1	0	\N
90375	1397	1384714605000	9614	4988	0	0	\N
90376	1726	774732814000	9614	4988	1	0	\N
90379	1726	774722813000	9616	4989	0	0	\N
90380	1397	1384704604000	9616	4989	1	0	\N
90381	1726	774722813000	9617	4989	0	0	\N
90382	1397	1384704604000	9617	4989	1	0	\N
90384	1397	1384704604000	9619	4990	0	0	\N
90385	1397	1384694603000	9619	4990	1	0	\N
90386	1397	1384684602000	9619	4990	2	0	\N
90387	1397	1384674601000	9619	4990	3	0	\N
90388	1397	1384664600000	9619	4990	4	0	\N
90389	1726	774712812000	9619	4990	5	0	\N
90390	1726	774702811000	9619	4990	6	0	\N
90391	1726	774692810000	9619	4990	7	0	\N
90392	1726	774682809000	9619	4990	8	0	\N
90402	1397	1384704604000	9621	4990	0	0	\N
90403	1397	1384694603000	9621	4990	1	0	\N
90404	1397	1384684602000	9621	4990	2	0	\N
90405	1397	1384674601000	9621	4990	3	0	\N
90406	1397	1384664600000	9621	4990	4	0	\N
90407	1726	774712812000	9621	4990	5	0	\N
90408	1726	774702811000	9621	4990	6	0	\N
90409	1726	774692810000	9621	4990	7	0	\N
90410	1726	774682809000	9621	4990	8	0	\N
90308	1726	774882829000	9595	4977	0	0	2367
90309	1726	774872828000	9595	4977	1	0	2368
90310	1397	1384874621000	9595	4977	2	0	5396
90311	1397	1384864620000	9595	4977	3	0	5397
90312	1726	774862827000	9596	4978	0	0	2369
90314	1726	774852826000	9597	4979	0	0	2370
90315	1397	1384844618000	9597	4979	1	0	5399
90316	1726	774842825000	9597	4979	2	0	2371
90317	1397	1384834617000	9597	4979	3	0	5400
90325	1726	774832824000	9600	4980	0	0	2372
90327	411	66119890000000	9600	4980	2	0	3
90331	1397	1384814615000	9602	4981	0	0	5402
90332	1950	3389390000000	9602	4981	1	0	5
90333	1726	774822823000	9603	4982	0	0	2373
90335	1397	1384794613000	9604	4983	0	0	5404
90336	1726	774812822000	9604	4983	1	0	2374
90337	1726	774802821000	9604	4983	2	0	2375
90338	1397	1384784612000	9604	4983	3	0	5405
90339	1694	38880369000000	9604	4983	4	0	2
90351	1397	1384774611000	9607	4984	0	0	5406
90352	1726	774792820000	9607	4984	1	0	2376
90353	1397	1384764610000	9607	4984	2	0	5407
90354	1726	774782819000	9607	4984	3	0	2377
90355	1397	1384754609000	9608	4985	0	0	5408
90357	1397	1384744608000	9608	4985	2	0	5409
90358	1726	774762817000	9608	4985	3	0	2379
90359	1397	1384734607000	9609	4986	0	0	5410
90360	1726	774752816000	9609	4986	1	0	2380
90362	1694	38880366000000	9609	4986	3	0	5
90363	1694	38880365000000	9609	4986	4	0	6
90373	1726	774742815000	9613	4987	0	0	2381
90374	1397	1384724606000	9613	4987	1	0	5411
90377	1397	1384714605000	9615	4988	0	0	5412
90383	1726	774722813000	9618	4989	0	0	2383
90393	1397	1384704604000	9620	4990	0	0	5413
90394	1397	1384694603000	9620	4990	1	0	5414
90395	1397	1384684602000	9620	4990	2	0	5415
90396	1397	1384674601000	9620	4990	3	0	5416
90398	1726	774712812000	9620	4990	5	0	2384
90399	1726	774702811000	9620	4990	6	0	2385
90400	1726	774692810000	9620	4990	7	0	2386
90401	1726	774682809000	9620	4990	8	0	2387
90412	1397	1384644598000	9622	4991	1	0	5419
90413	1397	1384634597000	9622	4991	2	0	5420
90414	1726	774672808000	9622	4991	3	0	2388
90415	1726	774662807000	9622	4991	4	0	2389
90416	1726	774652806000	9622	4991	5	0	2390
90418	1397	1384624596000	9623	4992	1	0	5421
90419	1397	1384614595000	9623	4992	2	0	5422
90420	1397	1384604594000	9623	4992	3	0	5423
90421	1709	16557501000000	9623	4992	4	0	5
90422	1726	774632804000	9623	4992	5	0	2392
90424	1726	774612802000	9624	4993	0	0	2394
90425	1397	1384594593000	9624	4993	1	0	5424
90426	1709	16556450000000	9624	4993	2	0	6
90427	1726	774602801000	9625	4994	0	0	2395
90429	1726	774592800000	9626	4995	0	0	2396
90430	1397	1384574591000	9626	4995	1	0	5426
90431	1694	38426327977032	9626	4995	2	0	7
90432	1979	40000000	9626	4995	3	0	1
90433	1694	37972290954064	9626	4995	4	0	8
90435	1694	37294271024826	9626	4995	6	0	10
90436	1694	36840234001858	9626	4995	7	0	11
90437	1694	36386196978890	9626	4995	8	0	12
90438	1694	35932159955922	9626	4995	9	0	13
90439	1694	35478122932954	9626	4995	10	0	14
90460	1397	1384564590000	9627	4996	0	0	\N
90461	1726	774582799000	9627	4996	1	0	\N
90471	1397	1384554589000	9630	4997	0	0	\N
90472	1979	20000000	9630	4997	1	0	\N
90473	1397	1384544588000	9630	4997	2	0	\N
90474	1397	1384534587000	9630	4997	3	0	\N
90475	1726	774572798000	9630	4997	4	0	\N
90476	1726	774562797000	9630	4997	5	0	\N
90477	1726	774552796000	9630	4997	6	0	\N
90482	1397	1384514585000	9633	4999	0	0	\N
90493	1397	1384474581000	9635	5001	0	0	\N
90494	1726	774492790000	9635	5001	1	0	\N
90495	1726	774482789000	9635	5001	2	0	\N
90496	1397	1384464580000	9635	5001	3	0	\N
90501	1601	8318804100000	9637	4997	0	0	\N
90502	1601	5658307600000	9637	4997	1	0	\N
90503	1601	3863481500000	9637	4997	2	0	\N
90504	1601	2378370600000	9637	4997	3	0	\N
90505	1397	1384454579000	9638	5002	0	0	\N
90506	1726	774472788000	9638	5002	1	0	\N
90507	1397	1384454579000	9639	5002	0	0	\N
90508	1726	774472788000	9639	5002	1	0	\N
90509	1397	1384454579000	9640	5002	0	0	\N
90510	1726	774472788000	9640	5002	1	0	\N
90511	1397	1384454579000	9641	5002	0	0	\N
90512	1726	774472788000	9641	5002	1	0	\N
90515	1397	1384454579000	9643	5002	0	0	\N
90516	1726	774472788000	9643	5002	1	0	\N
90523	1397	1384414575000	9648	5006	0	0	\N
90524	1709	0	9648	5006	1	0	\N
90525	1726	774432784000	9648	5006	2	0	\N
90531	1726	774422783000	9651	5007	0	0	\N
90532	1397	1384404574000	9651	5007	1	0	\N
90533	1397	1384394573000	9652	5008	0	0	\N
90534	1726	774412782000	9652	5008	1	0	\N
90552	1726	774362777000	9658	5013	0	0	\N
90553	1397	1384334567000	9658	5013	1	0	\N
90554	1726	774362777000	9659	5013	0	0	\N
90555	1397	1384334567000	9659	5013	1	0	\N
90560	1397	1384314565000	9662	5015	0	0	\N
90561	1726	774342775000	9662	5015	1	0	\N
90562	1979	0	9662	5015	2	0	\N
90566	1397	1384314565000	9664	5015	0	0	\N
90567	1726	774342775000	9664	5015	1	0	\N
90568	1979	0	9664	5015	2	0	\N
90573	1397	1384284562000	9666	5017	0	0	\N
90574	1726	774312772000	9666	5017	1	0	\N
90443	1694	33661974841082	9626	4995	14	0	18
90444	1694	33207937818114	9626	4995	15	0	19
90445	1694	32753900795146	9626	4995	16	0	20
90446	1694	32299863772178	9626	4995	17	0	21
90447	1694	31845826749210	9626	4995	18	0	22
90449	1694	30937752703274	9626	4995	20	0	24
90450	1694	30483715680306	9626	4995	21	0	25
90451	1694	30029678657338	9626	4995	22	0	26
90452	1694	29575641634370	9626	4995	23	0	27
90453	1694	29121604611402	9626	4995	24	0	28
90455	1694	28213530565466	9626	4995	26	0	30
90456	1694	24680132202245	9626	4995	27	0	31
90457	1694	18348558224952	9626	4995	28	0	32
90458	1694	14076418236419	9626	4995	29	0	33
90462	1397	1384564590000	9628	4996	0	0	5427
90463	1726	774582799000	9628	4996	1	0	2397
90464	1397	1384554589000	9629	4997	0	0	5428
90465	1979	20000000	9629	4997	1	0	2
90466	1397	1384544588000	9629	4997	2	0	5429
90468	1726	774572798000	9629	4997	4	0	2398
90469	1726	774562797000	9629	4997	5	0	2399
90470	1726	774552796000	9629	4997	6	0	2400
90478	1397	1384524586000	9631	4998	0	0	5431
90479	1726	774542795000	9631	4998	1	0	2401
90481	1397	1384514585000	9632	4999	0	0	5432
90483	1397	1384504584000	9634	5000	0	0	5433
90484	1397	1384494583000	9634	5000	1	0	5434
90485	1397	1384484582000	9634	5000	2	0	5435
90487	1726	774512792000	9634	5000	4	0	2404
90488	1726	774502791000	9634	5000	5	0	2405
90489	1601	8318804100000	9634	5000	6	0	6
90490	1601	5658307600000	9634	5000	7	0	7
90491	1601	3863481500000	9634	5000	8	0	8
90497	1397	1384474581000	9636	5001	0	0	5436
90498	1726	774492790000	9636	5001	1	0	2406
90499	1726	774482789000	9636	5001	2	0	2407
90500	1397	1384464580000	9636	5001	3	0	5437
90513	1397	1384454579000	9642	5002	0	0	5438
90517	1397	1384444578000	9645	5003	0	0	5439
90518	1726	774462787000	9645	5003	1	0	2409
90519	1726	774452786000	9646	5004	0	0	2410
90520	1397	1384434577000	9646	5004	1	0	5440
90522	1397	1384424576000	9647	5005	1	0	5441
90526	1397	1384414575000	9649	5006	0	0	5442
90527	1709	0	9649	5006	1	0	7
90528	1726	774432784000	9649	5006	2	0	2412
90529	1726	774422783000	9650	5007	0	0	2413
90535	1397	1384394573000	9653	5008	0	0	5444
90536	1726	774412782000	9653	5008	1	0	2414
90537	1979	16281874029894	9654	5009	0	0	3
90538	1726	774402781000	9654	5009	1	0	2415
90539	1397	1384384572000	9654	5009	2	0	5445
90541	1397	1384374571000	9655	5010	1	0	5446
90542	1726	774392780000	9655	5010	3	0	2416
90543	1726	774382779000	9656	5011	0	0	2417
90544	1979	14148574405003	9656	5011	1	0	5
90546	1726	774372778000	9657	5012	0	0	2418
90547	1397	1384354569000	9657	5012	1	0	5448
90548	1397	1384344568000	9657	5012	2	0	5449
90549	1979	10400296773674	9657	5012	3	0	6
90550	1979	7871255914697	9657	5012	4	0	7
90556	1726	774362777000	9660	5013	0	0	2419
90557	1397	1384334567000	9660	5013	1	0	5450
90558	1397	1384324566000	9661	5014	0	0	5451
90559	1726	774352776000	9661	5014	1	0	2420
90563	1397	1384314565000	9663	5015	0	0	5452
90565	1979	0	9663	5015	2	0	9
90569	1726	774332774000	9665	5016	0	0	2422
90570	1726	774322773000	9665	5016	1	0	2423
90571	1397	1384304564000	9665	5016	2	0	5453
90575	1397	1384284562000	9667	5017	0	0	5455
90576	1726	774312772000	9667	5017	1	0	2424
90579	1397	1384264560000	9669	5019	0	0	\N
90580	1726	774292770000	9669	5019	1	0	\N
90581	1397	1384264560000	9670	5019	0	0	\N
90582	1726	774292770000	9670	5019	1	0	\N
90585	1397	1384254559000	9672	5020	0	0	\N
90586	1397	1384244558000	9672	5020	1	0	\N
90587	1726	774282769000	9672	5020	2	0	\N
90588	1726	774272768000	9672	5020	3	0	\N
90589	1900	65000000	9672	5020	4	0	\N
90590	1397	1384254559000	9673	5020	0	0	\N
90591	1397	1384244558000	9673	5020	1	0	\N
90592	1726	774282769000	9673	5020	2	0	\N
90593	1726	774272768000	9673	5020	3	0	\N
90594	1900	65000000	9673	5020	4	0	\N
90605	1397	1384234557000	9676	5021	0	0	\N
90606	1633	15120259993434	9676	5021	1	0	\N
90607	1633	15120249989942	9676	5021	2	0	\N
90608	1522	15119950000000	9677	5022	0	0	\N
90609	1522	15119930000000	9677	5022	1	0	\N
90610	1397	1384224556000	9677	5022	2	0	\N
90611	1633	15120229985638	9677	5022	3	0	\N
90612	1522	15119950000000	9678	5022	0	0	\N
90613	1726	774262767000	9678	5022	1	0	\N
90614	1522	15119930000000	9678	5022	2	0	\N
90615	1397	1384224556000	9678	5022	3	0	\N
90616	1633	15120239987586	9678	5022	4	0	\N
90617	1633	15120229985638	9678	5022	5	0	\N
90622	1522	15119950000000	9680	5022	0	0	\N
90623	1726	774262767000	9680	5022	1	0	\N
90624	1522	15119930000000	9680	5022	2	0	\N
90625	1397	1384224556000	9680	5022	3	0	\N
90626	1633	15120239987586	9680	5022	4	0	\N
90627	1633	15120229985638	9680	5022	5	0	\N
90628	1522	15119950000000	9681	5022	0	0	\N
90629	1522	15119930000000	9681	5022	1	0	\N
90630	1397	1384224556000	9681	5022	2	0	\N
90631	1633	15120229985638	9681	5022	3	0	\N
90635	1397	1384204554000	9683	5024	0	0	\N
90636	1726	774242765000	9683	5024	1	0	\N
90639	1397	1384204554000	9685	5024	0	0	\N
90640	1726	774242765000	9685	5024	1	0	\N
90641	1397	1384204554000	9686	5024	0	0	\N
90642	1726	774242765000	9686	5024	1	0	\N
90655	1633	5061500922591	9690	5028	0	0	\N
90656	1397	1384154549000	9690	5028	1	0	\N
90657	1633	2705095866582	9690	5028	2	0	\N
90658	1633	756189985638	9690	5028	3	0	\N
90659	1726	774192760000	9690	5028	4	0	\N
90660	1726	774182759000	9690	5028	5	0	\N
90661	1726	774172758000	9690	5028	6	0	\N
90662	1397	1384144548000	9690	5028	7	0	\N
90663	1397	1384134547000	9690	5028	8	0	\N
90664	1980	7197990000000	9690	5028	9	0	\N
90676	1397	1384124546000	9693	5029	0	0	\N
90677	1726	774162757000	9694	5030	0	0	\N
90678	1850	17975550000000	9694	5030	1	0	\N
90679	1397	1384114545000	9694	5030	2	0	\N
90683	596	83898262000000	9696	5026	0	0	\N
90684	1397	1384184552000	9696	5026	1	0	\N
90685	1397	1384174551000	9696	5026	2	0	\N
90686	1850	17975550000000	9696	5026	3	0	\N
90687	1633	8553915643102	9696	5026	4	0	\N
90688	1633	5061500922591	9696	5026	5	0	\N
90689	1726	774222763000	9696	5026	6	0	\N
90690	700	73198270000000	9696	5026	7	0	\N
90691	700	66001260000000	9696	5026	8	0	\N
90692	1397	1384164550000	9696	5026	9	0	\N
90693	1397	1384154549000	9696	5026	10	0	\N
90694	1633	2705095866582	9696	5026	11	0	\N
90695	1633	756189985638	9696	5026	12	0	\N
90696	1397	1384144548000	9696	5026	13	0	\N
90697	1397	1384134547000	9696	5026	14	0	\N
90698	1397	1384124546000	9696	5026	15	0	\N
90699	1397	1384114545000	9696	5026	16	0	\N
90700	1726	774212762000	9696	5026	17	0	\N
90701	1726	774202761000	9696	5026	18	0	\N
90702	1726	774192760000	9696	5026	19	0	\N
90703	1726	774182759000	9696	5026	20	0	\N
90704	1726	774172758000	9696	5026	21	0	\N
90705	1726	774162757000	9696	5026	22	0	\N
90706	1981	100900000000	9697	5031	0	0	\N
90707	1397	1384104544000	9697	5031	1	0	\N
90708	1726	774152756000	9697	5031	2	0	\N
90709	1981	100900000000	9698	5031	0	0	\N
90710	1397	1384104544000	9698	5031	1	0	\N
90711	1726	774152756000	9698	5031	2	0	\N
90712	1850	10379540000000	9698	5031	3	0	\N
90583	1397	1384264560000	9671	5019	0	0	5457
90584	1726	774292770000	9671	5019	1	0	2426
90595	1397	1384254559000	9674	5020	0	0	5458
90596	1397	1384244558000	9674	5020	1	0	5459
90597	1726	774282769000	9674	5020	2	0	2427
90599	1900	65000000	9674	5020	4	0	8
90600	1726	774262767000	9675	5021	0	0	2429
90601	1397	1384234557000	9675	5021	1	0	5460
90602	1633	15120259993434	9675	5021	2	0	1
90603	1633	15120249989942	9675	5021	3	0	2
90618	1522	15119950000000	9679	5022	0	0	4
90619	1522	15119930000000	9679	5022	1	0	5
90620	1397	1384224556000	9679	5022	2	0	5461
90621	1633	15120229985638	9679	5022	3	0	4
90633	1397	1384214555000	9682	5023	1	0	5462
90634	1726	774252766000	9682	5023	2	0	2430
90637	1397	1384204554000	9684	5024	0	0	5463
90638	1726	774242765000	9684	5024	1	0	2431
90643	1726	774232764000	9687	5025	0	0	2432
90645	1397	1384184552000	9688	5026	0	0	5465
90646	1397	1384174551000	9688	5026	1	0	5466
90647	1726	774222763000	9688	5026	2	0	2433
90648	700	73198270000000	9688	5026	3	0	1
90649	1726	774212762000	9688	5026	4	0	2434
90651	700	66001260000000	9689	5027	1	0	2
90652	1726	774202761000	9689	5027	2	0	2435
90653	1633	8553915643102	9689	5027	3	0	5
90654	1397	1384164550000	9689	5027	4	0	5467
90666	1397	1384154549000	9691	5028	1	0	5468
90667	1633	2705095866582	9691	5028	2	0	7
90668	1633	756189985638	9691	5028	3	0	8
90669	1726	774192760000	9691	5028	4	0	2436
90670	1726	774182759000	9691	5028	5	0	2437
90672	1397	1384144548000	9691	5028	7	0	5469
90673	1397	1384134547000	9691	5028	8	0	5470
90674	1980	7197990000000	9691	5028	9	0	1
90675	1397	1384124546000	9692	5029	0	0	5471
90680	1726	774162757000	9695	5030	0	0	2439
90682	1397	1384114545000	9695	5030	2	0	5472
90713	1850	6339530000000	9698	5031	4	0	\N
90714	1981	100900000000	9699	5031	0	0	\N
90715	1397	1384104544000	9699	5031	1	0	\N
90716	1726	774152756000	9699	5031	2	0	\N
90717	1397	1384094543000	9699	5031	3	0	\N
90718	1850	10379540000000	9699	5031	4	0	\N
90719	1850	6339530000000	9699	5031	5	0	\N
90720	1850	3613520000000	9699	5031	6	0	\N
90721	1850	1358510000000	9699	5031	7	0	\N
90737	1726	774132754000	9703	5033	0	0	\N
90738	1610	10300547230000	9703	5033	1	0	\N
90739	1726	774122753000	9703	5033	2	0	\N
90740	1397	1384084542000	9703	5033	3	0	\N
90741	1397	1384074541000	9703	5033	4	0	\N
90742	1610	1391123470000	9703	5033	5	0	\N
90743	1397	1384074541000	9704	5034	0	0	\N
90744	1397	1384064540000	9704	5034	1	0	\N
90745	1726	774122753000	9704	5034	2	0	\N
90746	1726	774112752000	9704	5034	3	0	\N
90747	1397	1384074541000	9705	5034	0	0	\N
90748	1397	1384064540000	9705	5034	1	0	\N
90749	1726	774122753000	9705	5034	2	0	\N
90750	1726	774112752000	9705	5034	3	0	\N
90755	1726	774112752000	9707	5034	0	0	\N
90756	1397	1384064540000	9707	5034	1	0	\N
90760	1397	1384054539000	9709	5035	0	0	\N
90761	1726	774102751000	9709	5035	1	0	\N
90762	470	85440411000000	9709	5035	2	0	\N
90763	1397	1384044538000	9710	5036	0	0	\N
90765	1397	1384044538000	9712	5036	0	0	\N
90770	470	77147401000000	9714	5037	0	0	\N
90771	1726	774092750000	9714	5037	1	0	\N
90772	470	72736391000000	9714	5037	2	0	\N
90773	1397	1384034537000	9714	5037	3	0	\N
90774	1397	1384974631000	9715	4969	0	0	\N
90775	1950	3689400000000	9715	4969	1	0	\N
90776	1850	17975550000000	9715	4969	2	0	\N
90777	1958	705988000000	9715	4969	3	0	\N
90778	1726	774962837000	9715	4969	4	0	\N
90779	1726	774952836000	9715	4969	5	0	\N
90780	1726	774942835000	9715	4969	6	0	\N
90781	1726	774932834000	9715	4969	7	0	\N
90782	470	85440411000000	9715	4969	8	0	\N
90783	470	77147401000000	9715	4969	9	0	\N
90784	470	72736391000000	9715	4969	10	0	\N
90785	1726	774922833000	9715	4969	11	0	\N
90786	1726	774912832000	9715	4969	12	0	\N
90787	1726	774902831000	9715	4969	13	0	\N
90788	1726	774892830000	9715	4969	14	0	\N
90789	411	66119890000000	9715	4969	15	0	\N
90790	1726	774882829000	9715	4969	16	0	\N
90791	1726	774872828000	9715	4969	17	0	\N
90792	1726	774862827000	9715	4969	18	0	\N
90793	1726	774852826000	9715	4969	19	0	\N
90794	1726	774842825000	9715	4969	20	0	\N
90795	1726	774832824000	9715	4969	21	0	\N
90796	1726	774822823000	9715	4969	22	0	\N
90797	1726	774812822000	9715	4969	23	0	\N
90798	1726	774802821000	9715	4969	24	0	\N
90799	1726	774792820000	9715	4969	25	0	\N
90800	1610	18236443260000	9715	4969	26	0	\N
90801	1610	13497804490000	9715	4969	27	0	\N
90802	1610	10300547230000	9715	4969	28	0	\N
90803	1601	8318804100000	9715	4969	29	0	\N
90804	1601	5658307600000	9715	4969	30	0	\N
90805	1601	3863481500000	9715	4969	31	0	\N
90806	1601	2378370600000	9715	4969	32	0	\N
90807	1610	1391123470000	9715	4969	33	0	\N
90808	1709	16557501000000	9715	4969	34	0	\N
90809	1850	10379540000000	9715	4969	35	0	\N
90810	1850	6339530000000	9715	4969	36	0	\N
90811	1850	3613520000000	9715	4969	37	0	\N
90812	1850	1358510000000	9715	4969	38	0	\N
90813	1950	3389390000000	9715	4969	39	0	\N
90814	1726	774782819000	9715	4969	40	0	\N
90815	1726	774772818000	9715	4969	41	0	\N
90816	1726	774762817000	9715	4969	42	0	\N
90817	1726	774752816000	9715	4969	43	0	\N
90818	1726	774742815000	9715	4969	44	0	\N
90819	1726	774732814000	9715	4969	45	0	\N
90820	1726	774722813000	9715	4969	46	0	\N
90821	1397	1384964630000	9715	4969	47	0	\N
90822	1397	1384954629000	9715	4969	48	0	\N
90823	1397	1384944628000	9715	4969	49	0	\N
90824	1397	1384934627000	9715	4969	50	0	\N
90825	1397	1384924626000	9715	4969	51	0	\N
90826	1397	1384914625000	9715	4969	52	0	\N
90827	1397	1384904624000	9715	4969	53	0	\N
90828	1397	1384894623000	9715	4969	54	0	\N
90829	1397	1384884622000	9715	4969	55	0	\N
90830	1397	1384874621000	9715	4969	56	0	\N
90831	1397	1384864620000	9715	4969	57	0	\N
90832	1397	1384854619000	9715	4969	58	0	\N
90833	1397	1384844618000	9715	4969	59	0	\N
90834	1397	1384834617000	9715	4969	60	0	\N
90835	1397	1384824616000	9715	4969	61	0	\N
90836	1397	1384814615000	9715	4969	62	0	\N
90837	1397	1384804614000	9715	4969	63	0	\N
90838	1397	1384794613000	9715	4969	64	0	\N
90839	1397	1384784612000	9715	4969	65	0	\N
90840	1397	1384774611000	9715	4969	66	0	\N
90841	1397	1384764610000	9715	4969	67	0	\N
90842	1397	1384754609000	9715	4969	68	0	\N
90843	1397	1384744608000	9715	4969	69	0	\N
90844	1397	1384734607000	9715	4969	70	0	\N
90845	1397	1384724606000	9715	4969	71	0	\N
90846	1726	774712812000	9715	4969	72	0	\N
90847	1726	774702811000	9715	4969	73	0	\N
90848	1726	774692810000	9715	4969	74	0	\N
90724	1726	774152756000	9700	5031	2	0	2440
90725	1726	774142755000	9701	5032	0	0	2441
90726	1397	1384094543000	9701	5032	1	0	5474
90727	1610	18236443260000	9701	5032	2	0	1
90728	1610	13497804490000	9701	5032	3	0	2
90730	1850	6339530000000	9701	5032	5	0	3
90731	1850	3613520000000	9701	5032	6	0	4
90732	1850	1358510000000	9701	5032	7	0	5
90733	1726	774132754000	9702	5033	0	0	2442
90734	1610	10300547230000	9702	5033	1	0	3
90736	1610	1391123470000	9702	5033	3	0	4
90751	1397	1384074541000	9706	5034	0	0	5476
90752	1397	1384064540000	9706	5034	1	0	5477
90753	1726	774122753000	9706	5034	2	0	2443
90757	1397	1384054539000	9708	5035	0	0	5478
90758	1726	774102751000	9708	5035	1	0	2445
90759	470	85440411000000	9708	5035	2	0	1
90764	1397	1384044538000	9711	5036	0	0	5479
90766	470	77147401000000	9713	5037	0	0	2
90768	470	72736391000000	9713	5037	2	0	3
90769	1397	1384034537000	9713	5037	3	0	5480
90849	1726	774682809000	9715	4969	75	0	\N
90850	1726	774672808000	9715	4969	76	0	\N
90851	1726	774662807000	9715	4969	77	0	\N
90852	1726	774652806000	9715	4969	78	0	\N
90853	1726	774642805000	9715	4969	79	0	\N
90854	1726	774632804000	9715	4969	80	0	\N
90855	1726	774622803000	9715	4969	81	0	\N
90856	1726	774612802000	9715	4969	82	0	\N
90857	1726	774602801000	9715	4969	83	0	\N
90858	1726	774592800000	9715	4969	84	0	\N
90859	1726	774582799000	9715	4969	85	0	\N
90860	1726	774572798000	9715	4969	86	0	\N
90861	1726	774562797000	9715	4969	87	0	\N
90862	1726	774552796000	9715	4969	88	0	\N
90863	1726	774542795000	9715	4969	89	0	\N
90864	1726	774532794000	9715	4969	90	0	\N
90865	1726	774522793000	9715	4969	91	0	\N
90866	1726	774512792000	9715	4969	92	0	\N
90867	1726	774502791000	9715	4969	93	0	\N
90868	1726	774492790000	9715	4969	94	0	\N
90869	1726	774482789000	9715	4969	95	0	\N
90870	1726	774472788000	9715	4969	96	0	\N
90871	1726	774462787000	9715	4969	97	0	\N
90872	1726	774452786000	9715	4969	98	0	\N
90873	1726	774442785000	9715	4969	99	0	\N
90874	1726	774432784000	9715	4969	100	0	\N
90875	1726	774422783000	9715	4969	101	0	\N
90876	1726	774412782000	9715	4969	102	0	\N
90877	1726	774402781000	9715	4969	103	0	\N
90878	1726	774392780000	9715	4969	104	0	\N
90879	1726	774382779000	9715	4969	105	0	\N
90880	1726	774372778000	9715	4969	106	0	\N
90881	1726	774362777000	9715	4969	107	0	\N
90882	1726	774352776000	9715	4969	108	0	\N
90883	1726	774342775000	9715	4969	109	0	\N
90884	1726	774332774000	9715	4969	110	0	\N
90885	1726	774322773000	9715	4969	111	0	\N
90886	1726	774312772000	9715	4969	112	0	\N
90887	1726	774302771000	9715	4969	113	0	\N
90888	1726	774292770000	9715	4969	114	0	\N
90889	1709	16556450000000	9715	4969	115	0	\N
90890	1694	38880369000000	9715	4969	116	0	\N
90891	1694	38880368000000	9715	4969	117	0	\N
90892	1694	38880367000000	9715	4969	118	0	\N
90893	1694	38880366000000	9715	4969	119	0	\N
90894	1694	38880365000000	9715	4969	121	0	\N
90895	1694	38426327977032	9715	4969	122	0	\N
90896	1694	37972290954064	9715	4969	123	0	\N
90897	1694	37518253931096	9715	4969	124	0	\N
90898	1694	37294271024826	9715	4969	125	0	\N
90899	470	77147401000000	9716	5037	0	0	\N
90900	1726	774092750000	9716	5037	1	0	\N
90901	470	72736391000000	9716	5037	2	0	\N
90902	1397	1384034537000	9716	5037	3	0	\N
90903	1726	774082749000	9717	5038	0	0	\N
90904	470	69760381000000	9717	5038	1	0	\N
90905	1726	774072748000	9717	5038	2	0	\N
90906	1397	1384024536000	9717	5038	3	0	\N
90907	1397	1384014535000	9717	5038	4	0	\N
90908	1701	15575079675069	9717	5038	5	0	\N
90909	470	70274381000000	9718	5038	0	0	\N
90910	1726	774082749000	9718	5038	1	0	\N
90911	1726	774072748000	9718	5038	2	0	\N
90912	1397	1384024536000	9718	5038	3	0	\N
90913	1397	1384014535000	9718	5038	4	0	\N
90914	1701	15575079675069	9718	5038	5	0	\N
90915	1726	774082749000	9719	5038	0	0	\N
90916	1726	774072748000	9719	5038	1	0	\N
90917	1397	1384024536000	9719	5038	2	0	\N
90918	1397	1384014535000	9719	5038	3	0	\N
90919	1701	15575079675069	9719	5038	4	0	\N
90926	1726	774062747000	9721	5039	0	0	\N
90927	1536	18409250000000	9721	5039	1	0	\N
90928	1397	1384004534000	9721	5039	2	0	\N
90929	1701	13569061438048	9721	5039	3	0	\N
90934	498	66001750000000	9723	4882	0	0	\N
90935	498	66001500000000	9723	4882	1	0	\N
90936	724	20001650000000	9723	4882	2	0	\N
90937	724	20001400000000	9723	4882	3	0	\N
90938	528	66001900000000	9723	4882	4	0	\N
90939	1950	389310000000	9723	4882	5	0	\N
90940	1670	22319110000000	9723	4882	6	0	\N
90941	1670	12625010000000	9723	4882	7	0	\N
90942	1670	7467910000000	9723	4882	8	0	\N
90943	1670	3987810000000	9723	4882	9	0	\N
90944	1670	1109710000000	9723	4882	10	0	\N
90945	1670	610000000	9723	4882	11	0	\N
90946	596	83898262000000	9723	4882	12	0	\N
90947	596	81618162000000	9723	4882	13	0	\N
90948	1522	15119950000000	9723	4882	14	0	\N
90949	1850	17255530000000	9723	4882	15	0	\N
90950	1958	705988000000	9723	4882	16	0	\N
90951	1522	15119930000000	9723	4882	17	0	\N
90952	1522	15119910000000	9723	4882	18	0	\N
90953	411	66719910000000	9723	4882	19	0	\N
90954	411	66419900000000	9723	4882	20	0	\N
90955	470	85440411000000	9723	4882	21	0	\N
90956	470	77147401000000	9723	4882	22	0	\N
90957	1536	17689230000000	9723	4882	23	0	\N
90958	700	72478250000000	9723	4882	24	0	\N
90959	470	72736391000000	9723	4882	25	0	\N
90960	470	69760381000000	9723	4882	26	0	\N
90961	411	66119890000000	9723	4882	27	0	\N
90962	1610	18236443260000	9723	4882	28	0	\N
90963	1610	13497804490000	9723	4882	29	0	\N
90964	1610	10300547230000	9723	4882	30	0	\N
90965	1536	9701720000000	9723	4882	31	0	\N
90966	1601	8318804100000	9723	4882	32	0	\N
90967	1601	5658307600000	9723	4882	33	0	\N
90968	1601	3863481500000	9723	4882	34	0	\N
90969	1601	2378370600000	9723	4882	35	0	\N
90970	1610	1391123470000	9723	4882	36	0	\N
90971	1709	16557501000000	9723	4882	37	0	\N
90972	1850	9659520000000	9723	4882	38	0	\N
90973	1850	5619510000000	9723	4882	39	0	\N
90974	1850	2893500000000	9723	4882	41	0	\N
90975	1850	638490000000	9723	4882	42	0	\N
90976	596	81618162000000	9724	5040	0	0	\N
90977	1726	774052746000	9724	5040	1	0	\N
90978	1536	10421740000000	9724	5040	2	0	\N
90979	1726	774042745000	9724	5040	3	0	\N
90980	1397	1383994533000	9724	5040	4	0	\N
90981	1397	1383984532000	9724	5040	5	0	\N
90982	1610	1389113470000	9724	5040	6	0	\N
90983	1701	9974294736852	9724	5040	7	0	\N
90984	1701	7548833687494	9724	5040	8	0	\N
90922	1726	774072748000	9720	5038	2	0	2448
90923	1397	1384024536000	9720	5038	3	0	5481
90924	1397	1384014535000	9720	5038	4	0	5482
90925	1701	15575079675069	9720	5038	5	0	5
90930	1726	774062747000	9722	5039	0	0	2449
90932	1397	1384004534000	9722	5039	2	0	5483
90933	1701	13569061438048	9722	5039	3	0	6
90985	596	81618162000000	9725	5040	0	0	\N
90986	1726	774052746000	9725	5040	1	0	\N
90987	1536	10421740000000	9725	5040	2	0	\N
90988	1726	774042745000	9725	5040	3	0	\N
90989	1397	1383994533000	9725	5040	4	0	\N
90990	1397	1383984532000	9725	5040	5	0	\N
90991	1610	1389113470000	9725	5040	6	0	\N
90992	1701	9974294736852	9725	5040	7	0	\N
90993	1701	7548833687494	9725	5040	8	0	\N
91003	596	77533062000000	9727	5041	0	0	\N
91004	596	74775962000000	9727	5041	1	0	\N
91005	596	67094862000000	9727	5041	2	0	\N
91006	1610	0	9727	5041	3	0	\N
91007	1397	1383974531000	9727	5041	4	0	\N
91008	1397	1383964530000	9727	5041	5	0	\N
91009	1397	1383954529000	9727	5041	6	0	\N
91010	1536	6173430000000	9727	5041	7	0	\N
91011	1536	3307020000000	9727	5041	8	0	\N
91012	1536	936310000000	9727	5041	9	0	\N
91013	1726	774032744000	9727	5041	10	0	\N
91014	1726	774022743000	9727	5041	11	0	\N
91015	1726	774012742000	9727	5041	12	0	\N
91029	596	77533062000000	9729	5041	0	0	\N
91030	596	74775962000000	9729	5041	1	0	\N
91031	596	67094862000000	9729	5041	2	0	\N
91032	1610	0	9729	5041	3	0	\N
91033	1397	1383974531000	9729	5041	4	0	\N
91034	1397	1383964530000	9729	5041	5	0	\N
91035	1397	1383954529000	9729	5041	6	0	\N
91036	1536	6173430000000	9729	5041	7	0	\N
91037	1536	3307020000000	9729	5041	8	0	\N
91038	1536	936310000000	9729	5041	9	0	\N
91039	1726	774032744000	9729	5041	10	0	\N
91040	1726	774022743000	9729	5041	11	0	\N
91041	1726	774012742000	9729	5041	12	0	\N
91042	1397	1383944528000	9730	5042	0	0	\N
91043	1726	774002741000	9730	5042	1	0	\N
91046	1397	1383944528000	9732	5042	0	0	\N
91047	1726	774002741000	9732	5042	1	0	\N
91061	1536	0	9734	5043	0	0	\N
91062	470	67298371000000	9734	5043	1	0	\N
91063	1671	12797614237287	9734	5043	2	0	\N
91064	1397	1383934527000	9734	5043	3	0	\N
91065	1397	1383924526000	9734	5043	4	0	\N
91066	1397	1383914525000	9734	5043	5	0	\N
91067	1671	7732365128278	9734	5043	6	0	\N
91068	1671	4314737369410	9734	5043	7	0	\N
91069	1671	1488129530515	9734	5043	8	0	\N
91070	1726	773992740000	9734	5043	9	0	\N
91071	1726	773982739000	9734	5043	10	0	\N
91072	1726	773972738000	9734	5043	11	0	\N
91073	1689	18718471000000	9734	5043	12	0	\N
91074	1536	0	9735	5043	0	0	\N
91075	470	67298371000000	9735	5043	1	0	\N
91076	1671	12797614237287	9735	5043	2	0	\N
91077	1397	1383934527000	9735	5043	3	0	\N
91078	1397	1383924526000	9735	5043	4	0	\N
91079	1397	1383914525000	9735	5043	5	0	\N
91080	1671	7732365128278	9735	5043	6	0	\N
91081	1671	4314737369410	9735	5043	7	0	\N
91082	1671	1488129530515	9735	5043	8	0	\N
91083	1726	773992740000	9735	5043	9	0	\N
91084	1726	773982739000	9735	5043	10	0	\N
91085	1726	773972738000	9735	5043	11	0	\N
91086	1689	18718471000000	9735	5043	12	0	\N
91090	1397	1383894523000	9737	5045	0	0	\N
91091	1476	10732380000000	9737	5045	1	0	\N
91092	1726	773952736000	9737	5045	2	0	\N
91093	1476	6483370000000	9737	5045	3	0	\N
91094	1476	3616360000000	9737	5045	4	0	\N
91095	1476	1245350000000	9737	5045	5	0	\N
91096	1689	18717470000000	9737	5045	6	0	\N
91104	1476	10732380000000	9739	5041	0	0	\N
91105	1476	6483370000000	9739	5041	1	0	\N
91106	1689	18718471000000	9739	5041	2	0	\N
91107	1689	18717470000000	9739	5041	3	0	\N
91108	1726	773942735000	9740	5046	0	0	\N
91109	1726	773932734000	9740	5046	1	0	\N
91110	470	66000011000000	9740	5046	2	0	\N
91111	1397	1383884522000	9740	5046	3	0	\N
91112	1397	1383874521000	9740	5046	4	0	\N
91113	1476	0	9740	5046	5	0	\N
91114	1689	16348030489454	9740	5046	6	0	\N
90996	1536	10421740000000	9726	5040	2	0	2
90997	1726	774042745000	9726	5040	3	0	2451
90998	1397	1383994533000	9726	5040	4	0	5484
90999	1397	1383984532000	9726	5040	5	0	5485
91000	1610	1389113470000	9726	5040	6	0	5
91002	1701	7548833687494	9726	5040	8	0	8
91016	596	77533062000000	9728	5041	0	0	3
91017	596	74775962000000	9728	5041	1	0	4
91018	596	67094862000000	9728	5041	2	0	5
91019	1610	0	9728	5041	3	0	6
91021	1397	1383964530000	9728	5041	5	0	5487
91022	1397	1383954529000	9728	5041	6	0	5488
91023	1536	6173430000000	9728	5041	7	0	3
91024	1536	3307020000000	9728	5041	8	0	4
91026	1726	774032744000	9728	5041	10	0	2452
91027	1726	774022743000	9728	5041	11	0	2453
91028	1726	774012742000	9728	5041	12	0	2454
91044	1397	1383944528000	9731	5042	0	0	5489
91045	1726	774002741000	9731	5042	1	0	2455
91049	470	67298371000000	9733	5043	1	0	5
91050	1671	12797614237287	9733	5043	2	0	1
91051	1397	1383934527000	9733	5043	3	0	5490
91052	1397	1383924526000	9733	5043	4	0	5491
91053	1397	1383914525000	9733	5043	5	0	5492
91055	1671	4314737369410	9733	5043	7	0	3
91056	1671	1488129530515	9733	5043	8	0	4
91057	1726	773992740000	9733	5043	9	0	2456
91058	1726	773982739000	9733	5043	10	0	2457
91060	1689	18718471000000	9733	5043	12	0	1
91087	1726	773962737000	9736	5044	0	0	2459
91088	1701	790063600056	9736	5044	1	0	9
91089	1397	1383904524000	9736	5044	2	0	5493
91097	1397	1383894523000	9738	5045	0	0	5494
91099	1726	773952736000	9738	5045	2	0	2460
91100	1476	6483370000000	9738	5045	3	0	2
91101	1476	3616360000000	9738	5045	4	0	3
91102	1476	1245350000000	9738	5045	5	0	4
91103	1689	18717470000000	9738	5045	6	0	2
91116	1726	773932734000	9741	5046	1	0	2462
91117	470	66000011000000	9741	5046	2	0	6
91118	1397	1383884522000	9741	5046	3	0	5495
91119	1397	1383874521000	9741	5046	4	0	5496
91122	1476	10732380000000	9742	5045	0	0	\N
91123	1476	6483370000000	9742	5045	1	0	\N
91124	1689	18717470000000	9742	5045	2	0	\N
91125	1689	16348030489454	9742	5045	3	0	\N
91128	1726	773912732000	9744	5048	0	0	\N
91129	1726	773902731000	9744	5048	1	0	\N
91130	1397	1383854519000	9744	5048	2	0	\N
91131	1397	1383844518000	9744	5048	3	0	\N
91132	1689	12102015979905	9744	5048	4	0	\N
91138	1397	1383834517000	9746	5049	0	0	\N
91139	1726	773892730000	9746	5049	1	0	\N
91140	1594	15721020000000	9746	5049	2	0	\N
91147	1397	1383824516000	9749	5050	0	0	\N
91152	1726	773872728000	9751	5052	0	0	\N
91153	1397	1383804514000	9751	5052	1	0	\N
91154	1689	1253929287614	9751	5052	2	0	\N
91158	1397	1383794513000	9753	5053	0	0	\N
91159	1726	773862727000	9753	5053	1	0	\N
91168	1397	1383764510000	9757	5056	0	0	\N
91169	1726	773832724000	9757	5056	1	0	\N
91170	1397	1383764510000	9758	5056	0	0	\N
91171	1726	773832724000	9758	5056	1	0	\N
91189	1726	773792720000	9764	5060	0	0	\N
91190	1397	1383714505000	9764	5060	1	0	\N
91191	1983	1390093470000	9764	5060	2	0	\N
91192	1726	773782719000	9765	5061	0	0	\N
91193	1726	773772718000	9765	5061	1	0	\N
91194	1397	1383704504000	9765	5061	2	0	\N
91195	1397	1383694503000	9765	5061	3	0	\N
91196	1397	1383684502000	9765	5061	4	0	\N
91197	1726	773762717000	9765	5061	5	0	\N
91198	1711	18719399000000	9765	5061	6	0	\N
91199	1711	18719398000000	9765	5061	7	0	\N
91200	1711	18719397000000	9765	5061	8	0	\N
91201	1711	18719396000000	9765	5061	9	0	\N
91202	1711	18719395000000	9765	5061	10	0	\N
91203	1726	773782719000	9766	5061	0	0	\N
91204	1726	773772718000	9766	5061	1	0	\N
91205	1397	1383704504000	9766	5061	2	0	\N
91206	1397	1383694503000	9766	5061	3	0	\N
91207	1397	1383684502000	9766	5061	4	0	\N
91208	1726	773762717000	9766	5061	5	0	\N
91209	1711	18719399000000	9766	5061	6	0	\N
91210	1711	18719398000000	9766	5061	7	0	\N
91211	1711	18719397000000	9766	5061	8	0	\N
91212	1711	18719396000000	9766	5061	9	0	\N
91213	1711	18719395000000	9766	5061	10	0	\N
91214	1726	773782719000	9767	5061	0	0	\N
91215	1726	773772718000	9767	5061	1	0	\N
91216	1397	1383704504000	9767	5061	2	0	\N
91217	1397	1383694503000	9767	5061	3	0	\N
91218	1397	1383684502000	9767	5061	4	0	\N
91219	1726	773762717000	9767	5061	5	0	\N
91220	1711	18719399000000	9767	5061	6	0	\N
91221	1711	18719398000000	9767	5061	7	0	\N
91222	1711	18719397000000	9767	5061	8	0	\N
91223	1711	18719396000000	9767	5061	9	0	\N
91224	1711	18719395000000	9767	5061	10	0	\N
91236	1726	773782719000	9769	5061	0	0	\N
91237	1726	773772718000	9769	5061	1	0	\N
91238	1397	1383704504000	9769	5061	2	0	\N
91239	1397	1383694503000	9769	5061	3	0	\N
91240	1397	1383684502000	9769	5061	4	0	\N
91241	1726	773762717000	9769	5061	5	0	\N
91242	1711	18719399000000	9769	5061	6	0	\N
91243	1711	18719398000000	9769	5061	7	0	\N
91244	1711	18719397000000	9769	5061	8	0	\N
91245	1711	18719396000000	9769	5061	9	0	\N
91246	1711	18719395000000	9769	5061	10	0	\N
91253	1726	773732714000	9773	5064	0	0	\N
91254	1397	1383654499000	9773	5064	1	0	\N
91255	1726	773722713000	9775	5065	0	0	\N
91256	1397	1383644498000	9775	5065	1	0	\N
91127	1726	773922733000	9743	5047	1	0	2463
91133	1726	773912732000	9745	5048	0	0	2464
91134	1726	773902731000	9745	5048	1	0	2465
91135	1397	1383854519000	9745	5048	2	0	5498
91136	1397	1383844518000	9745	5048	3	0	5499
91141	1397	1383834517000	9747	5049	0	0	5500
91142	1726	773892730000	9747	5049	1	0	2466
91143	1594	15721020000000	9747	5049	2	0	1
91144	1726	773882729000	9748	5050	0	0	2467
91145	1397	1383824516000	9748	5050	1	0	5501
91148	1594	8040770000000	9750	5051	0	0	2
91149	1594	5284610000000	9750	5051	1	0	3
91150	1594	1199720000000	9750	5051	2	0	4
91151	1397	1383814515000	9750	5051	3	0	5502
91156	1397	1383804514000	9752	5052	1	0	5503
91157	1689	1253929287614	9752	5052	2	0	6
91160	1397	1383794513000	9754	5053	0	0	5504
91161	1726	773862727000	9754	5053	1	0	2469
91162	1397	1383784512000	9755	5054	0	0	5505
91164	1727	11976585000000	9756	5055	0	0	1
91165	1726	773842725000	9756	5055	1	0	2471
91166	1397	1383774511000	9756	5055	2	0	5506
91167	1689	28287614	9756	5055	3	0	7
91172	1397	1383764510000	9759	5056	0	0	5507
91174	1594	1710000000	9760	5057	0	0	5
91175	1397	1383754509000	9760	5057	1	0	5508
91176	1727	8925465000000	9761	5058	0	0	2
91177	1397	1383744508000	9761	5058	1	0	5509
91179	1727	6866815000000	9762	5059	0	0	3
91180	1727	1130205000000	9762	5059	1	0	4
91181	1727	906685000000	9762	5059	2	0	5
91182	1726	773812722000	9762	5059	3	0	2474
91183	1397	1383734507000	9762	5059	4	0	5510
91185	1726	773802721000	9762	5059	6	0	2475
91186	1726	773792720000	9763	5060	0	0	2476
91187	1397	1383714505000	9763	5060	1	0	5512
91188	1983	1390093470000	9763	5060	2	0	1
91225	1726	773782719000	9768	5061	0	0	2477
91227	1397	1383704504000	9768	5061	2	0	5513
91228	1397	1383694503000	9768	5061	3	0	5514
91229	1397	1383684502000	9768	5061	4	0	5515
91230	1726	773762717000	9768	5061	5	0	2479
91232	1711	18719398000000	9768	5061	7	0	2
91233	1711	18719397000000	9768	5061	8	0	3
91234	1711	18719396000000	9768	5061	9	0	4
91235	1711	18719395000000	9768	5061	10	0	5
91247	1397	1383674501000	9770	5062	0	0	5516
91249	1726	773742715000	9771	5063	0	0	2481
91250	1397	1383664500000	9771	5063	1	0	5517
91251	1726	773732714000	9772	5064	0	0	2482
91252	1397	1383654499000	9772	5064	1	0	5518
91265	1711	16348385000000	9778	5066	0	0	\N
91266	1711	13481375000000	9778	5066	1	0	\N
91267	1711	9232365000000	9778	5066	2	0	\N
91268	1711	1244355000000	9778	5066	3	0	\N
91276	1668	21598630000000	9781	5068	0	0	\N
91277	1397	1383614495000	9781	5068	1	0	\N
91278	1726	773702711000	9781	5068	2	0	\N
91279	1397	1383604494000	9782	5069	0	0	\N
91280	1726	773692710000	9782	5069	1	0	\N
91281	1726	773682709000	9782	5069	2	0	\N
91282	1397	1383594493000	9782	5069	3	0	\N
91303	1726	773632704000	9788	5073	0	0	\N
91304	1675	15052759999977	9788	5073	1	0	\N
91305	1675	11060749999977	9788	5073	2	0	\N
91306	1602	11318380000000	9788	5073	4	0	\N
91307	1397	1383544488000	9788	5073	5	0	\N
91308	1675	8366739999977	9788	5073	6	0	\N
91309	1675	861729999977	9788	5073	7	0	\N
91331	1397	1383494483000	9793	5077	0	0	\N
91332	1726	772372699000	9793	5077	1	0	\N
91342	1397	1383454479000	9797	5080	0	0	\N
91343	1726	772332695000	9797	5080	1	0	\N
91344	1602	0	9797	5080	2	0	\N
91345	1397	1383454479000	9798	5080	0	0	\N
91346	1726	772332695000	9798	5080	1	0	\N
91347	1602	0	9798	5080	2	0	\N
91359	1726	772302692000	9800	5082	0	0	\N
91360	1397	1383424476000	9800	5082	1	0	\N
91361	1726	772302692000	9801	5082	0	0	\N
91362	1397	1383424476000	9801	5082	1	0	\N
91363	1726	772302692000	9802	5082	0	0	\N
91365	1397	1383424476000	9804	5083	0	0	\N
91366	1397	1383414475000	9804	5083	1	0	\N
91376	1726	772282690000	9808	5085	0	0	\N
91377	1397	1383394473000	9808	5085	1	0	\N
91378	1972	298000000	9808	5085	2	0	\N
91379	1972	297000000	9808	5085	3	0	\N
91380	1726	772282690000	9809	5085	0	0	\N
91381	1397	1383394473000	9809	5085	1	0	\N
91382	1972	298000000	9809	5085	2	0	\N
91383	1972	297000000	9809	5085	3	0	\N
91259	1726	773712712000	9777	5066	0	0	2484
91260	1397	1383634497000	9777	5066	1	0	5520
91261	1711	16348385000000	9777	5066	2	0	6
91262	1711	13481375000000	9777	5066	3	0	7
91263	1711	9232365000000	9777	5066	4	0	8
91269	1397	1383624496000	9779	5067	0	0	5521
91270	1747	8338869000000	9779	5067	1	0	1
91271	1747	8038768000000	9779	5067	2	0	2
91272	1747	8015667000000	9779	5067	3	0	3
91273	1668	21598630000000	9780	5068	0	0	1
91275	1726	773702711000	9780	5068	2	0	2485
91283	1397	1383604494000	9783	5069	0	0	5523
91284	1726	773692710000	9783	5069	1	0	2486
91285	1726	773682709000	9783	5069	2	0	2487
91287	1726	773672708000	9784	5070	0	0	2488
91288	1397	1383584492000	9784	5070	1	0	5525
91289	1726	773662707000	9785	5071	0	0	2489
91290	1397	1383574491000	9785	5071	1	0	5526
91291	1987	490000000	9785	5071	2	0	1
91293	1397	1383554489000	9786	5072	1	0	5528
91294	1726	773652706000	9786	5072	2	0	2490
91295	1726	773642705000	9786	5072	3	0	2491
91296	1726	773632704000	9787	5073	0	0	2492
91297	1675	15052759999977	9787	5073	1	0	1
91299	1602	11318380000000	9787	5073	4	0	1
91300	1397	1383544488000	9787	5073	5	0	5529
91301	1675	8366739999977	9787	5073	6	0	3
91302	1675	861729999977	9787	5073	7	0	4
91311	1397	1383534487000	9789	5074	1	0	5530
91312	1587	10034104000000	9789	5074	2	0	1
91313	1587	6180054000000	9789	5074	3	0	2
91314	1587	3579644000000	9789	5074	4	0	3
91315	1587	1428934000000	9789	5074	5	0	4
91317	1587	864254000000	9789	5074	7	0	6
91318	1726	773612702000	9790	5075	0	0	2494
91319	1587	0	9790	5075	1	0	7
91320	1726	773602701000	9790	5075	2	0	2495
91321	1602	8376370000000	9790	5075	3	0	2
91323	1602	861350000000	9790	5075	5	0	4
91324	1397	1383524486000	9790	5075	6	0	5531
91325	1397	1383514485000	9790	5075	7	0	5532
91326	1397	1383504484000	9791	5076	0	0	5533
91328	1726	772382700000	9791	5076	2	0	2497
91329	1397	1383494483000	9792	5077	0	0	5534
91330	1726	772372699000	9792	5077	1	0	2498
91333	1397	1383484482000	9794	5078	0	0	5535
91334	1726	772362698000	9794	5078	1	0	2499
91336	1397	1383474481000	9794	5078	3	0	5536
91337	1397	1383464480000	9795	5079	0	0	5537
91338	1726	772342696000	9795	5079	1	0	2501
91339	1397	1383454479000	9796	5080	0	0	5538
91340	1726	772332695000	9796	5080	1	0	2502
91348	724	20001150000000	9799	5081	0	0	5
91349	498	66001250000000	9799	5081	1	0	3
91350	1672	17561733000000	9799	5081	2	0	1
91351	1672	12904723000000	9799	5081	3	0	2
91353	1397	1383444478000	9799	5081	5	0	5539
91354	1397	1383434477000	9799	5081	6	0	5540
91355	1726	772322694000	9799	5081	7	0	2503
91356	1726	772312693000	9799	5081	8	0	2504
91357	1672	9761713000000	9799	5081	9	0	3
91364	1726	772302692000	9803	5082	0	0	2505
91367	1397	1383424476000	9805	5083	0	0	5541
91368	1397	1383414475000	9805	5083	1	0	5542
91369	1397	1383404474000	9806	5084	0	0	5543
91370	1726	772292691000	9806	5084	1	0	2506
91372	1726	772282690000	9807	5085	0	0	2507
91373	1397	1383394473000	9807	5085	1	0	5544
91374	1972	298000000	9807	5085	2	0	2
91375	1972	297000000	9807	5085	3	0	3
91385	1397	1383384472000	9810	5086	1	0	5545
91386	1972	296000000	9810	5086	2	0	4
91387	1972	295000000	9810	5086	3	0	5
91388	1972	294000000	9810	5086	4	0	6
91389	1972	293000000	9810	5086	5	0	7
91391	1972	291000000	9810	5086	7	0	9
91392	1972	290000000	9810	5086	8	0	10
91393	1726	772272689000	9811	5086	0	0	\N
91394	1397	1383384472000	9811	5086	1	0	\N
91395	1972	296000000	9811	5086	2	0	\N
91396	1972	295000000	9811	5086	3	0	\N
91397	1972	294000000	9811	5086	4	0	\N
91398	1972	293000000	9811	5086	5	0	\N
91399	1972	292000000	9811	5086	6	0	\N
91400	1972	291000000	9811	5086	7	0	\N
91401	1972	290000000	9811	5086	8	0	\N
91402	1726	772262688000	9812	5087	0	0	\N
91403	1522	13833920000000	9812	5087	1	0	\N
91404	1522	10238910000000	9812	5087	2	0	\N
91405	1522	7812900000000	9812	5087	3	0	\N
91406	1522	1053890000000	9812	5087	4	0	\N
91407	1972	189000000	9812	5087	5	0	\N
91408	1726	772262688000	9813	5087	0	0	\N
91409	1522	13833920000000	9813	5087	1	0	\N
91410	1522	10238910000000	9813	5087	2	0	\N
91411	1522	7812900000000	9813	5087	3	0	\N
91412	1522	1053890000000	9813	5087	4	0	\N
91413	1972	189000000	9813	5087	5	0	\N
91414	1726	772262688000	9814	5087	0	0	\N
91415	1522	13833920000000	9814	5087	1	0	\N
91416	1522	10238910000000	9814	5087	2	0	\N
91417	1522	7812900000000	9814	5087	3	0	\N
91418	1522	1053890000000	9814	5087	4	0	\N
91419	1972	189000000	9814	5087	5	0	\N
91428	1397	1383364470000	9817	5089	0	0	\N
91429	1726	772242686000	9817	5089	1	0	\N
91430	1974	99000000	9817	5089	2	0	\N
91431	1974	98000000	9817	5089	3	0	\N
91432	1974	97000000	9817	5089	4	0	\N
91433	1974	96000000	9817	5089	5	0	\N
91434	1974	95000000	9817	5089	6	0	\N
91435	1974	94000000	9817	5089	7	0	\N
91436	1974	93000000	9817	5089	8	0	\N
91437	1974	92000000	9817	5089	9	0	\N
91438	1974	91000000	9817	5089	10	0	\N
91439	1974	90000000	9817	5089	11	0	\N
91440	1397	1383364470000	9818	5089	0	0	\N
91441	1726	772242686000	9818	5089	1	0	\N
91442	1974	99000000	9818	5089	2	0	\N
91443	1974	98000000	9818	5089	3	0	\N
91444	1974	97000000	9818	5089	4	0	\N
91445	1974	96000000	9818	5089	5	0	\N
91446	1974	95000000	9818	5089	6	0	\N
91447	1974	94000000	9818	5089	7	0	\N
91448	1974	93000000	9818	5089	8	0	\N
91449	1974	92000000	9818	5089	9	0	\N
91450	1974	91000000	9818	5089	10	0	\N
91451	1974	90000000	9818	5089	11	0	\N
91464	1397	1383364470000	9820	5089	0	0	\N
91465	1726	772242686000	9820	5089	1	0	\N
91466	1974	99000000	9820	5089	2	0	\N
91467	1974	98000000	9820	5089	3	0	\N
91468	1974	97000000	9820	5089	4	0	\N
91469	1974	96000000	9820	5089	5	0	\N
91470	1974	95000000	9820	5089	6	0	\N
91471	1974	94000000	9820	5089	7	0	\N
91472	1974	93000000	9820	5089	8	0	\N
91473	1974	92000000	9820	5089	9	0	\N
91474	1974	91000000	9820	5089	10	0	\N
91475	1974	90000000	9820	5089	11	0	\N
91485	1726	772232685000	9822	5090	0	0	\N
91486	1397	1383354469000	9822	5090	1	0	\N
91487	1972	188000000	9822	5090	2	0	\N
91488	1972	187000000	9822	5090	3	0	\N
91489	1972	186000000	9822	5090	4	0	\N
91490	1972	185000000	9822	5090	5	0	\N
91491	1972	184000000	9822	5090	6	0	\N
91492	1974	89000000	9822	5090	7	0	\N
91493	1972	183000000	9822	5090	8	0	\N
91494	1972	182000000	9822	5090	10	0	\N
91495	1726	772232685000	9823	5090	0	0	\N
91496	1397	1383354469000	9823	5090	1	0	\N
91497	1972	188000000	9823	5090	2	0	\N
91498	1972	187000000	9823	5090	3	0	\N
91499	1972	186000000	9823	5090	4	0	\N
91500	1972	185000000	9823	5090	5	0	\N
91501	1972	184000000	9823	5090	6	0	\N
91502	1974	89000000	9823	5090	7	0	\N
91503	1972	183000000	9823	5090	8	0	\N
91504	1972	182000000	9823	5090	10	0	\N
91505	1972	181000000	9823	5090	11	0	\N
91506	1972	180000000	9823	5090	12	0	\N
91507	1974	88000000	9823	5090	13	0	\N
91508	1974	87000000	9823	5090	14	0	\N
91509	1974	86000000	9823	5090	15	0	\N
91510	1974	85000000	9823	5090	16	0	\N
91511	1974	84000000	9823	5090	17	0	\N
91512	1974	83000000	9823	5090	18	0	\N
91513	1974	82000000	9823	5090	19	0	\N
91514	1974	81000000	9823	5090	20	0	\N
91515	1974	80000000	9823	5090	21	0	\N
91516	1972	179000000	9823	5090	22	0	\N
91517	724	20001150000000	9824	5014	0	0	\N
91518	498	66001250000000	9824	5014	1	0	\N
91519	1727	11976585000000	9824	5014	2	0	\N
91520	596	83898262000000	9824	5014	3	0	\N
91521	596	81618162000000	9824	5014	4	0	\N
91522	596	77533062000000	9824	5014	5	0	\N
91523	596	74775962000000	9824	5014	6	0	\N
91524	596	67094862000000	9824	5014	7	0	\N
91525	1671	12797614237287	9824	5014	8	0	\N
91526	1668	21598630000000	9824	5014	9	0	\N
91527	1675	14332739999977	9824	5014	10	0	\N
91528	1675	10340729999977	9824	5014	11	0	\N
91422	1522	10238910000000	9815	5087	2	0	8
91423	1522	7812900000000	9815	5087	3	0	9
91424	1522	1053890000000	9815	5087	4	0	10
91425	1972	189000000	9815	5087	5	0	11
91426	1726	772252687000	9816	5088	0	0	2510
91452	1397	1383364470000	9819	5089	0	0	5547
91453	1726	772242686000	9819	5089	1	0	2511
91454	1974	99000000	9819	5089	2	0	2
91455	1974	98000000	9819	5089	3	0	3
91456	1974	97000000	9819	5089	4	0	4
91458	1974	95000000	9819	5089	6	0	6
91459	1974	94000000	9819	5089	7	0	7
91460	1974	93000000	9819	5089	8	0	8
91461	1974	92000000	9819	5089	9	0	9
91463	1974	90000000	9819	5089	11	0	11
91476	1726	772232685000	9821	5090	0	0	2512
91477	1397	1383354469000	9821	5090	1	0	5548
91478	1972	188000000	9821	5090	2	0	12
91479	1972	187000000	9821	5090	3	0	13
91481	1972	185000000	9821	5090	5	0	15
91482	1972	184000000	9821	5090	6	0	16
91483	1974	89000000	9821	5090	7	0	12
91484	1972	183000000	9821	5090	8	0	17
91529	1476	10732380000000	9824	5014	12	0	\N
91530	1850	17975550000000	9824	5014	13	0	\N
91531	1672	16841703000000	9824	5014	14	0	\N
91532	1672	12184693000000	9824	5014	15	0	\N
91533	1727	8925465000000	9824	5014	16	0	\N
91534	1727	6866815000000	9824	5014	17	0	\N
91535	1476	6483370000000	9824	5014	18	0	\N
91536	1476	3616360000000	9824	5014	19	0	\N
91537	1476	1245350000000	9824	5014	20	0	\N
91538	470	85440411000000	9824	5014	21	0	\N
91539	470	77147401000000	9824	5014	22	0	\N
91540	1536	18409250000000	9824	5014	23	0	\N
91541	700	73198270000000	9824	5014	24	0	\N
91542	700	66001260000000	9824	5014	25	0	\N
91543	470	72736391000000	9824	5014	26	0	\N
91544	470	69760381000000	9824	5014	27	0	\N
91545	470	67298371000000	9824	5014	28	0	\N
91546	470	66000011000000	9824	5014	29	0	\N
91547	1602	11318380000000	9824	5014	30	0	\N
91548	1671	7732365128278	9824	5014	31	0	\N
91549	1671	4314737369410	9824	5014	32	0	\N
91550	1671	1488129530515	9824	5014	33	0	\N
91551	1727	1130205000000	9824	5014	34	0	\N
91552	1727	906685000000	9824	5014	35	0	\N
91553	1476	0	9824	5014	36	0	\N
91554	1610	18236443260000	9824	5014	37	0	\N
91555	1610	13497804490000	9824	5014	38	0	\N
91556	1610	10300547230000	9824	5014	39	0	\N
91557	1536	10421740000000	9824	5014	40	0	\N
91558	1536	6173430000000	9824	5014	41	0	\N
91559	1536	3307020000000	9824	5014	42	0	\N
91560	1536	936310000000	9824	5014	43	0	\N
91561	1536	0	9824	5014	44	0	\N
91562	1610	1391123470000	9824	5014	45	0	\N
91563	1675	7646719999977	9824	5014	46	0	\N
91564	1675	141709999977	9824	5014	47	0	\N
91565	1850	10379540000000	9824	5014	48	0	\N
91566	1850	6339530000000	9824	5014	49	0	\N
91567	1850	3613520000000	9824	5014	50	0	\N
91568	1850	1358510000000	9824	5014	51	0	\N
91569	1594	15000980000000	9824	5014	52	0	\N
91570	1594	7320730000000	9824	5014	53	0	\N
91571	1594	4564570000000	9824	5014	54	0	\N
91572	1594	479680000000	9824	5014	55	0	\N
91573	1587	9314091000000	9824	5014	56	0	\N
91574	1587	5460041000000	9824	5014	57	0	\N
91575	1587	2859631000000	9824	5014	58	0	\N
91576	1587	708921000000	9824	5014	59	0	\N
91577	1587	426581000000	9824	5014	60	0	\N
91578	1587	144241000000	9824	5014	61	0	\N
91579	1602	8376370000000	9824	5014	62	0	\N
91580	1602	6391360000000	9824	5014	63	0	\N
91581	1602	861350000000	9824	5014	64	0	\N
91582	1602	0	9824	5014	65	0	\N
91583	1672	9041683000000	9824	5014	66	0	\N
91584	1672	285673000000	9824	5014	67	0	\N
91585	1610	1389113470000	9824	5014	68	0	\N
91586	1610	0	9824	5014	69	0	\N
91587	1701	15575079675069	9824	5014	70	0	\N
91588	1747	8338869000000	9824	5014	71	0	\N
91589	1711	18719399000000	9824	5014	72	0	\N
91590	1701	13569061438048	9824	5014	73	0	\N
91591	1972	299000000	9824	5014	74	0	\N
91592	1972	298000000	9824	5014	75	0	\N
91593	1689	18718471000000	9824	5014	76	0	\N
91594	1689	18717470000000	9824	5014	77	0	\N
91595	1689	16348030489454	9824	5014	78	0	\N
91596	1701	9974294736852	9824	5014	79	0	\N
91597	1711	18719398000000	9824	5014	80	0	\N
91598	1711	18719397000000	9824	5014	81	0	\N
91599	1972	297000000	9824	5014	82	0	\N
91600	1972	296000000	9824	5014	83	0	\N
91601	1972	295000000	9824	5014	84	0	\N
91602	1972	294000000	9824	5014	85	0	\N
91603	1972	293000000	9824	5014	86	0	\N
91604	1972	292000000	9824	5014	87	0	\N
91605	1972	291000000	9824	5014	88	0	\N
91606	1972	290000000	9824	5014	89	0	\N
91607	1972	189000000	9824	5014	90	0	\N
91608	1972	188000000	9824	5014	91	0	\N
91609	1972	187000000	9824	5014	92	0	\N
91610	1972	186000000	9824	5014	93	0	\N
91611	1972	185000000	9824	5014	94	0	\N
91612	1972	184000000	9824	5014	95	0	\N
91613	1972	183000000	9824	5014	96	0	\N
91614	1972	182000000	9824	5014	97	0	\N
91615	1972	181000000	9824	5014	98	0	\N
91616	1972	180000000	9824	5014	99	0	\N
91617	1689	12102015979905	9824	5014	100	0	\N
91618	1689	9237145057216	9824	5014	101	0	\N
91619	1689	1253929287614	9824	5014	102	0	\N
91620	1689	28287614	9824	5014	103	0	\N
91621	1747	8038768000000	9824	5014	104	0	\N
91622	1747	8015667000000	9824	5014	105	0	\N
91623	1701	7548833687494	9824	5014	106	0	\N
91624	1701	790072600056	9824	5014	108	0	\N
91625	1972	179000000	9824	5014	109	0	\N
91626	1711	18719396000000	9824	5014	110	0	\N
91627	1711	18719395000000	9824	5014	111	0	\N
91628	1711	16348385000000	9824	5014	112	0	\N
91629	1711	13481375000000	9824	5014	113	0	\N
91630	1711	9232365000000	9824	5014	114	0	\N
91631	1711	1244355000000	9824	5014	115	0	\N
91659	1564	545112000000	9827	5093	0	0	\N
91660	1397	1383304464000	9827	5093	1	0	\N
91661	1397	1383294463000	9827	5093	2	0	\N
91662	1397	1383284462000	9827	5093	3	0	\N
91663	1726	772182680000	9827	5093	4	0	\N
91664	1726	772172679000	9827	5093	5	0	\N
91634	1564	2643227000000	9826	5092	1	0	3
91635	1564	548212000000	9826	5092	2	0	4
91636	1397	1383344468000	9826	5092	3	0	5549
91637	1397	1383334467000	9826	5092	4	0	5550
91638	1726	772222684000	9826	5092	5	0	2513
91640	1397	1383324466000	9826	5092	7	0	5551
91641	1397	1383314465000	9826	5092	8	0	5552
91642	1726	772202682000	9826	5092	9	0	2515
91643	1726	772192681000	9826	5092	10	0	2516
91644	1668	19579406000000	9826	5092	11	0	2
91646	1972	181000000	9826	5092	13	0	19
91647	1972	180000000	9826	5092	14	0	20
91648	1974	88000000	9826	5092	15	0	13
91649	1974	87000000	9826	5092	16	0	14
91651	1974	85000000	9826	5092	18	0	16
91652	1974	84000000	9826	5092	19	0	17
91653	1974	83000000	9826	5092	20	0	18
91654	1974	82000000	9826	5092	21	0	19
91655	1974	81000000	9826	5092	22	0	20
91657	1974	79000000	9826	5092	24	0	22
91658	1972	179000000	9826	5092	25	0	21
91665	1726	772162678000	9827	5093	6	0	\N
91666	1972	178000000	9827	5093	7	0	\N
91668	724	20001150000000	9829	5041	0	0	\N
91669	498	66001250000000	9829	5041	1	0	\N
91670	1727	11976585000000	9829	5041	2	0	\N
91671	1564	7843257000000	9829	5041	3	0	\N
91672	1564	4738242000000	9829	5041	4	0	\N
91673	1564	2643227000000	9829	5041	5	0	\N
91674	1564	548212000000	9829	5041	6	0	\N
91675	1564	545112000000	9829	5041	7	0	\N
91676	470	67298371000000	9829	5041	8	0	\N
91677	1671	12797614237287	9829	5041	9	0	\N
91678	1668	21598630000000	9829	5041	10	0	\N
91679	1675	14332739999977	9829	5041	11	0	\N
91680	1675	10340729999977	9829	5041	12	0	\N
91681	1476	10732380000000	9829	5041	13	0	\N
91682	1672	16841703000000	9829	5041	14	0	\N
91683	1672	12184693000000	9829	5041	15	0	\N
91684	1727	8925465000000	9829	5041	16	0	\N
91685	1522	13113900000000	9829	5041	17	0	\N
91686	1522	9518890000000	9829	5041	18	0	\N
91687	1727	6866815000000	9829	5041	19	0	\N
91688	1476	6483370000000	9829	5041	20	0	\N
91689	1476	3616360000000	9829	5041	21	0	\N
91690	1476	1245350000000	9829	5041	22	0	\N
91691	470	66000011000000	9829	5041	23	0	\N
91692	1602	11318380000000	9829	5041	24	0	\N
91693	1671	7732365128278	9829	5041	25	0	\N
91694	1671	4314737369410	9829	5041	26	0	\N
91695	1671	1488129530515	9829	5041	27	0	\N
91696	1727	1130205000000	9829	5041	28	0	\N
91697	1727	906685000000	9829	5041	29	0	\N
91698	1536	6173430000000	9829	5041	30	0	\N
91699	1536	3307020000000	9829	5041	31	0	\N
91700	1536	936310000000	9829	5041	32	0	\N
91701	1536	0	9829	5041	33	0	\N
91702	1983	990000000	9829	5041	34	0	\N
91703	1701	790063600056	9829	5041	35	0	\N
91704	1476	0	9829	5041	36	0	\N
91705	1522	7092880000000	9829	5041	37	0	\N
91706	1522	333870000000	9829	5041	38	0	\N
91707	1675	7646719999977	9829	5041	39	0	\N
91708	1675	141709999977	9829	5041	40	0	\N
91709	1594	15721020000000	9829	5041	41	0	\N
91710	1594	8040770000000	9829	5041	42	0	\N
91711	1594	5284610000000	9829	5041	43	0	\N
91712	1594	1199720000000	9829	5041	44	0	\N
91713	1594	1710000000	9829	5041	45	0	\N
91714	1587	9314091000000	9829	5041	46	0	\N
91715	1587	5460041000000	9829	5041	47	0	\N
91716	1587	2859631000000	9829	5041	48	0	\N
91717	1587	708921000000	9829	5041	49	0	\N
91718	1587	426581000000	9829	5041	50	0	\N
91719	1587	144241000000	9829	5041	51	0	\N
91720	1602	8376370000000	9829	5041	52	0	\N
91721	1602	6391360000000	9829	5041	53	0	\N
91722	1602	861350000000	9829	5041	54	0	\N
91723	1602	0	9829	5041	55	0	\N
91724	1672	9041683000000	9829	5041	56	0	\N
91725	1672	285673000000	9829	5041	57	0	\N
91726	1668	18858896000000	9829	5041	58	0	\N
91727	1747	8338869000000	9829	5041	59	0	\N
91728	1711	18719399000000	9829	5041	60	0	\N
91729	1972	299000000	9829	5041	61	0	\N
91730	1972	298000000	9829	5041	62	0	\N
91731	1689	18718471000000	9829	5041	63	0	\N
91732	1689	18717470000000	9829	5041	64	0	\N
91733	1689	16348030489454	9829	5041	65	0	\N
91734	1711	18719398000000	9829	5041	66	0	\N
91735	1711	18719397000000	9829	5041	67	0	\N
91736	1972	297000000	9829	5041	68	0	\N
91737	1972	296000000	9829	5041	69	0	\N
91738	1972	295000000	9829	5041	70	0	\N
91739	1972	294000000	9829	5041	71	0	\N
91740	1972	293000000	9829	5041	72	0	\N
91741	1972	292000000	9829	5041	73	0	\N
91742	1972	291000000	9829	5041	74	0	\N
91761	1397	1383234457000	9833	5096	0	0	\N
91762	1726	772112673000	9833	5096	1	0	\N
91763	1397	1383224456000	9833	5096	2	0	\N
91781	1397	1383154449000	9837	5099	0	0	\N
91782	1726	772042666000	9837	5099	1	0	\N
91785	1726	772032665000	9839	5100	0	0	\N
91786	1397	1383144448000	9839	5100	1	0	\N
91789	1726	772022664000	9841	5101	0	0	\N
91790	1397	1383134447000	9841	5101	1	0	\N
91791	1726	772022664000	9842	5101	0	0	\N
91792	1397	1383134447000	9842	5101	1	0	\N
91795	1726	772012663000	9844	5102	0	0	\N
91796	1397	1383124446000	9844	5102	1	0	\N
91799	1726	771992661000	9846	5104	0	0	\N
91800	1726	771982660000	9846	5104	1	0	\N
91744	1397	1383294463000	9830	5094	1	0	5554
91745	1397	1383284462000	9830	5094	2	0	5555
91746	1397	1383274461000	9830	5094	3	0	5556
91747	1726	772182680000	9830	5094	4	0	2517
91748	1726	772172679000	9830	5094	5	0	2518
91750	1726	772152677000	9830	5094	7	0	2520
91751	1972	178000000	9830	5094	8	0	22
91752	1397	1383264460000	9831	5095	0	0	5557
91753	1397	1383254459000	9831	5095	1	0	5558
91754	1397	1383244458000	9831	5095	2	0	5559
91756	1726	772142676000	9831	5095	4	0	2521
91757	1726	772132675000	9831	5095	5	0	2522
91758	1726	772122674000	9831	5095	6	0	2523
91759	1397	1383234457000	9832	5096	0	0	5560
91764	1726	772102672000	9834	5097	0	0	2525
91765	1726	772092671000	9834	5097	1	0	2526
91766	1726	772082670000	9834	5097	2	0	2527
91767	1726	772072669000	9834	5097	3	0	2528
91768	1397	1383224456000	9834	5097	4	0	5561
91770	1397	1383214455000	9834	5097	6	0	5562
91771	1397	1383204454000	9834	5097	7	0	5563
91772	1397	1383194453000	9834	5097	8	0	5564
91773	1397	1383184452000	9834	5097	9	0	5565
91774	1397	1383174451000	9834	5097	10	0	5566
91776	1668	2126441000000	9834	5097	12	0	5
91777	1397	1383164450000	9835	5098	0	0	5567
91778	1726	772052667000	9835	5098	1	0	2530
91779	1397	1383154449000	9836	5099	0	0	5568
91783	1726	772032665000	9838	5100	0	0	2532
91784	1397	1383144448000	9838	5100	1	0	5569
91787	1726	772022664000	9840	5101	0	0	2533
91788	1397	1383134447000	9840	5101	1	0	5570
91793	1726	772012663000	9843	5102	0	0	2534
91797	1397	1383114445000	9845	5103	0	0	5572
91798	1726	772002662000	9845	5103	1	0	2535
91801	1397	1383104444000	9846	5104	2	0	\N
91802	1397	1383094443000	9846	5104	3	0	\N
91803	1397	1383084442000	9846	5104	4	0	\N
91811	1726	771972659000	9849	5105	0	0	\N
91821	1444	19439533000000	9853	5108	0	0	\N
91822	1397	1383034437000	9853	5108	1	0	\N
91823	1726	771932655000	9853	5108	2	0	\N
91847	1726	771832645000	9861	5116	0	0	\N
91848	1397	1382924426000	9861	5116	1	0	\N
91849	1726	771832645000	9862	5116	0	0	\N
91850	1397	1382924426000	9862	5116	1	0	\N
91851	1726	771832645000	9863	5116	0	0	\N
91852	1397	1382924426000	9863	5116	1	0	\N
91855	1397	1382914425000	9865	5117	0	0	\N
91857	1726	771822644000	9867	5118	0	0	\N
91858	1397	1382904424000	9867	5118	1	0	\N
91859	1397	1382894423000	9867	5118	2	0	\N
91860	1726	771812643000	9867	5118	3	0	\N
91865	1726	771822644000	9869	5118	0	0	\N
91866	1397	1382904424000	9869	5118	1	0	\N
91867	1397	1382894423000	9869	5118	2	0	\N
91868	1726	771812643000	9869	5118	3	0	\N
91873	1726	771792641000	9872	5120	0	0	\N
91874	1397	1382874421000	9872	5120	1	0	\N
91877	1397	1382864420000	9874	5121	0	0	\N
91878	1726	771782640000	9874	5121	1	0	\N
91886	1726	771742636000	9878	5124	0	0	\N
91887	1397	1382814415000	9878	5124	1	0	\N
91888	1726	771742636000	9879	5124	0	0	\N
91889	1397	1382814415000	9879	5124	1	0	\N
91890	1726	771742636000	9881	5124	0	0	\N
91891	1397	1382814415000	9881	5124	1	0	\N
91896	1726	771732635000	9886	5125	0	0	\N
91897	1397	1382804414000	9886	5125	1	0	\N
91898	1726	771732635000	9887	5125	0	0	\N
91899	1397	1382804414000	9887	5125	1	0	\N
91900	1397	1382794413000	9888	5126	0	0	\N
91901	1726	771722634000	9888	5126	1	0	\N
91902	1397	1382794413000	9889	5126	0	0	\N
91903	1726	771722634000	9889	5126	1	0	\N
91911	1397	1382764410000	9893	5128	0	0	\N
91912	1726	771712633000	9894	5127	0	0	\N
91913	1397	1382784412000	9894	5127	1	0	\N
91914	1397	1382774411000	9894	5127	2	0	\N
91915	1397	1382764410000	9894	5127	3	0	\N
91916	1726	771702632000	9894	5127	4	0	\N
91923	1726	771672629000	9897	5130	0	0	\N
91924	1397	1382734407000	9897	5130	1	0	\N
91927	1726	771652627000	9899	5132	0	0	\N
91928	1397	1382714405000	9899	5132	1	0	\N
91806	1397	1383104444000	9847	5104	2	0	5573
91807	1397	1383094443000	9847	5104	3	0	5574
91808	1397	1383084442000	9847	5104	4	0	5575
91809	1397	1383074441000	9847	5104	5	0	5576
91810	1726	771972659000	9848	5105	0	0	2538
91813	1397	1383064440000	9850	5106	1	0	5577
91814	1397	1383054439000	9851	5107	0	0	5578
91815	1726	771952657000	9851	5107	1	0	2540
91816	1726	771942656000	9851	5107	2	0	2541
91817	1397	1383044438000	9851	5107	3	0	5579
91819	1397	1383034437000	9852	5108	1	0	5580
91820	1726	771932655000	9852	5108	2	0	2542
91824	1397	1383024436000	9854	5109	0	0	5581
91825	1397	1383014435000	9856	5111	0	0	5582
91827	1444	11144865400000	9856	5111	2	0	2
91828	1726	771912653000	9856	5111	3	0	2544
91829	1726	771902652000	9856	5111	4	0	2545
91830	1397	1383004434000	9856	5111	5	0	5583
91831	1397	1382994433000	9856	5111	6	0	5584
91833	1397	1382984432000	9857	5112	1	0	5585
91834	1397	1382974431000	9858	5113	0	0	5586
91835	1726	771882650000	9858	5113	1	0	2547
91836	1726	771872649000	9858	5113	2	0	2548
91837	1444	6733195530000	9858	5113	3	0	3
91839	1444	1294665160000	9858	5113	5	0	5
91840	1397	1382964430000	9858	5113	6	0	5587
91841	1726	771862648000	9859	5114	0	0	2549
91842	1726	771852647000	9859	5114	1	0	2550
91844	1397	1382944428000	9859	5114	3	0	5589
91845	1726	771842646000	9860	5115	0	0	2551
91846	1397	1382934427000	9860	5115	1	0	5590
91853	1726	771832645000	9864	5116	0	0	2552
91854	1397	1382924426000	9864	5116	1	0	5591
91861	1726	771822644000	9868	5118	0	0	2553
91862	1397	1382904424000	9868	5118	1	0	5593
91863	1397	1382894423000	9868	5118	2	0	5594
91864	1726	771812643000	9868	5118	3	0	2554
91869	1397	1382884422000	9870	5119	0	0	5595
91871	1726	771792641000	9871	5120	0	0	2556
91872	1397	1382874421000	9871	5120	1	0	5596
91875	1397	1382864420000	9873	5121	0	0	5597
91876	1726	771782640000	9873	5121	1	0	2557
91880	1726	771772639000	9875	5122	1	0	2558
91881	1726	771762638000	9876	5123	0	0	2559
91882	1397	1382844418000	9876	5123	1	0	5599
91883	1397	1382834417000	9876	5123	2	0	5600
91884	1397	1382824416000	9876	5123	3	0	5601
91892	1726	771742636000	9882	5124	0	0	2561
91893	1397	1382814415000	9882	5124	1	0	5602
91894	1726	771732635000	9885	5125	0	0	2562
91895	1397	1382804414000	9885	5125	1	0	5603
91904	1397	1382794413000	9890	5126	0	0	5604
91906	1726	771712633000	9891	5127	0	0	2564
91907	1397	1382784412000	9891	5127	1	0	5605
91908	1397	1382774411000	9891	5127	2	0	5606
91909	1726	771702632000	9891	5127	3	0	2565
91917	1726	771692631000	9895	5129	0	0	2566
91918	1726	771682630000	9895	5129	1	0	2567
91919	1397	1382754409000	9895	5129	2	0	5608
91920	1397	1382744408000	9895	5129	3	0	5609
91921	1726	771672629000	9896	5130	0	0	2568
91925	1397	1382724406000	9898	5131	0	0	5611
91926	1726	771662628000	9898	5131	1	0	2569
91929	1726	771652627000	9900	5132	0	0	2570
91930	1397	1382714405000	9900	5132	1	0	5612
91931	1397	1382704404000	9901	5133	0	0	5613
91933	1397	1382694403000	9902	5134	0	0	5614
91934	1726	771632625000	9902	5134	1	0	2572
91935	1726	771622624000	9903	5135	0	0	2573
91936	1397	1382684402000	9903	5135	1	0	5615
91939	1726	771622624000	9905	5135	0	0	\N
91940	1397	1382684402000	9905	5135	1	0	\N
91941	1397	1382674401000	9905	5135	2	0	\N
91942	1726	771612623000	9905	5135	3	0	\N
91959	1397	1382604394000	9912	5141	0	0	\N
91960	1726	771542616000	9912	5141	1	0	\N
91961	1726	771532615000	9912	5141	2	0	\N
91962	1397	1382594393000	9912	5141	3	0	\N
91972	1397	1382534387000	9917	5146	0	0	\N
91973	1726	771482610000	9917	5146	1	0	\N
91974	1759	21599998999999	9917	5146	2	0	\N
91987	1397	1382484382000	9921	5149	0	0	\N
91988	1726	771432605000	9921	5149	1	0	\N
91993	1397	1382464380000	9924	5151	0	0	\N
91994	1726	771412603000	9924	5151	1	0	\N
91997	1710	10958551520848	9926	5152	0	0	\N
91998	1710	8533045369394	9926	5152	1	0	\N
91999	1710	1774335473290	9926	5152	2	0	\N
92000	1726	771402602000	9926	5152	3	0	\N
92001	1397	1382454379000	9926	5152	4	0	\N
92012	1726	771382600000	9932	5155	0	0	\N
92013	1397	1382424376000	9932	5155	1	0	\N
92018	1726	771372599000	9934	5156	0	0	\N
92019	1726	771362598000	9934	5156	1	0	\N
92020	1397	1382414375000	9934	5156	2	0	\N
92021	1397	1382404374000	9934	5156	3	0	\N
92024	1681	24072051210200	9936	5158	0	0	\N
92025	1726	771342596000	9936	5158	1	0	\N
92026	1681	20971901644968	9936	5158	2	0	\N
92027	1681	15416468106056	9936	5158	3	0	\N
92028	1397	1382384372000	9936	5158	4	0	\N
92029	1681	11668103144718	9936	5158	5	0	\N
92030	1681	1222968759830	9936	5158	6	0	\N
92038	1726	771332595000	9938	5159	0	0	\N
92039	1397	1382374371000	9938	5159	1	0	\N
92040	1726	771332595000	9939	5159	0	0	\N
92041	1397	1382374371000	9939	5159	1	0	\N
92042	1726	771332595000	9940	5159	0	0	\N
92043	1397	1382374371000	9940	5159	1	0	\N
92044	1726	771332595000	9941	5159	0	0	\N
92045	1397	1382374371000	9941	5159	1	0	\N
92061	1726	771252587000	9947	5164	0	0	\N
92062	1726	771242586000	9947	5164	1	0	\N
92063	1397	1382304364000	9947	5164	2	0	\N
92064	1397	1382294363000	9947	5164	3	0	\N
92065	1397	1382284362000	9947	5164	4	0	\N
92066	1397	1382274361000	9947	5164	5	0	\N
91943	1726	771602622000	9906	5137	0	0	2575
91944	1397	1382664400000	9906	5137	1	0	5617
91945	1397	1382654399000	9909	5139	0	0	5618
91946	1726	771592621000	9909	5139	1	0	2576
91947	1726	771582620000	9909	5139	2	0	2577
91949	1726	771562618000	9909	5139	4	0	2579
91950	1397	1382644398000	9909	5139	5	0	5619
91951	1397	1382634397000	9909	5139	6	0	5620
91952	1397	1382624396000	9909	5139	7	0	5621
91953	1726	771552617000	9910	5140	0	0	2580
91955	1397	1382604394000	9911	5141	0	0	5623
91956	1726	771542616000	9911	5141	1	0	2581
91957	1726	771532615000	9911	5141	2	0	2582
91958	1397	1382594393000	9911	5141	3	0	5624
91964	1726	771522614000	9914	5143	0	0	2583
91965	1397	1382574391000	9914	5143	1	0	5626
91966	1397	1382564390000	9915	5144	0	0	5627
91967	1397	1382554389000	9915	5144	1	0	5628
91968	1726	771512613000	9915	5144	2	0	2584
91970	1397	1382544388000	9916	5145	0	0	5629
91971	1726	771492611000	9916	5145	1	0	2586
91975	1397	1382534387000	9918	5146	0	0	5630
91976	1726	771482610000	9918	5146	1	0	2587
91977	1759	21599998999999	9918	5146	2	0	2
91979	1397	1382524386000	9919	5147	1	0	5631
91980	1726	771472609000	9919	5147	2	0	2588
91981	1397	1382514385000	9919	5147	3	0	5632
91982	1397	1382504384000	9919	5147	4	0	5633
91984	1726	771452607000	9919	5147	6	0	2590
91985	1397	1382494383000	9920	5148	0	0	5634
91986	1726	771442606000	9920	5148	1	0	2591
91989	1397	1382484382000	9922	5149	0	0	5635
91990	1397	1382474381000	9923	5150	0	0	5636
91992	1726	771422604000	9923	5150	2	0	2593
91995	1397	1382464380000	9925	5151	0	0	5637
91996	1726	771412603000	9925	5151	1	0	2594
92002	1710	10958551520848	9927	5152	0	0	3
92003	1710	8533045369394	9927	5152	1	0	4
92005	1726	771402602000	9927	5152	3	0	2595
92006	1397	1382454379000	9927	5152	4	0	5638
92007	1397	1382444378000	9928	5153	0	0	5639
92008	1397	1382434377000	9930	5154	0	0	5640
92010	1726	771382600000	9931	5155	0	0	2597
92011	1397	1382424376000	9931	5155	1	0	5641
92014	1726	771372599000	9933	5156	0	0	2598
92015	1726	771362598000	9933	5156	1	0	2599
92016	1397	1382414375000	9933	5156	2	0	5642
92022	1397	1382394373000	9935	5157	0	0	5644
92023	1726	771352597000	9935	5157	1	0	2600
92031	1681	24072051210200	9937	5158	0	0	2
92032	1726	771342596000	9937	5158	1	0	2601
92033	1681	20971901644968	9937	5158	2	0	3
92035	1397	1382384372000	9937	5158	4	0	5645
92036	1681	11668103144718	9937	5158	5	0	5
92037	1681	1222968759830	9937	5158	6	0	6
92046	1726	771332595000	9942	5159	0	0	2602
92048	1726	771322594000	9943	5160	0	0	2603
92049	1397	1382364370000	9943	5160	1	0	5647
92050	1397	1382354369000	9943	5160	2	0	5648
92051	1397	1382344368000	9944	5161	0	0	5649
92052	1726	771312593000	9944	5161	1	0	2604
92054	1397	1382334367000	9945	5162	1	0	5650
92055	1397	1382324366000	9946	5163	0	0	5651
92056	1397	1382314365000	9946	5163	1	0	5652
92057	1726	771292591000	9946	5163	2	0	2606
92058	1726	771282590000	9946	5163	3	0	2607
92060	1726	771262588000	9946	5163	5	0	2609
92067	1726	771252587000	9949	5165	0	0	2610
92068	1726	771242586000	9949	5165	1	0	2611
92069	1726	771232585000	9949	5165	2	0	2612
92071	1397	1382294363000	9949	5165	4	0	5654
92072	1397	1382284362000	9949	5165	5	0	5655
92079	1397	1382244358000	9952	5168	0	0	\N
92081	1397	1382244358000	9954	5168	0	0	\N
92087	1397	1382234357000	9956	5169	0	0	\N
92088	1397	1382224356000	9956	5169	1	0	\N
92089	1726	771202582000	9956	5169	2	0	\N
92090	1726	771192581000	9956	5169	3	0	\N
92091	1749	14835357000000	9956	5169	4	0	\N
92093	1449	3043000459	9964	5167	0	0	\N
92094	1726	771212583000	9964	5167	1	0	\N
92095	1397	1382244358000	9964	5167	2	0	\N
92096	1397	1382234357000	9964	5167	3	0	\N
92097	1397	1382224356000	9964	5167	4	0	\N
92098	1726	771202582000	9964	5167	5	0	\N
92099	1726	771192581000	9964	5167	6	0	\N
92100	1726	771182580000	9964	5167	7	0	\N
92101	1726	771172579000	9964	5167	8	0	\N
92102	1397	1382214355000	9964	5167	9	0	\N
92103	1397	1382204354000	9964	5167	10	0	\N
92104	1397	1382194353000	9964	5167	11	0	\N
92105	1749	14835357000000	9964	5167	12	0	\N
92106	1397	1382204354000	9965	5171	0	0	\N
92107	1726	771182580000	9965	5171	1	0	\N
92108	1726	771172579000	9965	5171	2	0	\N
92109	1726	771162578000	9965	5171	3	0	\N
92110	1397	1382194353000	9965	5171	4	0	\N
92111	1397	1382184352000	9965	5171	5	0	\N
92112	1749	14555397000000	9965	5171	6	0	\N
92120	1726	771182580000	9967	5170	0	0	\N
92121	1726	771172579000	9967	5170	1	0	\N
92122	1726	771162578000	9967	5170	2	0	\N
92123	1397	1382214355000	9967	5170	3	0	\N
92124	1397	1382204354000	9967	5170	4	0	\N
92125	1397	1382194353000	9967	5170	5	0	\N
92126	1397	1382184352000	9967	5170	6	0	\N
92127	1749	14555397000000	9967	5170	7	0	\N
92128	1397	1382204354000	9968	5171	0	0	\N
92129	1726	771182580000	9968	5171	1	0	\N
92130	1726	771172579000	9968	5171	2	0	\N
92131	1726	771162578000	9968	5171	3	0	\N
92132	1397	1382194353000	9968	5171	4	0	\N
92133	1397	1382184352000	9968	5171	5	0	\N
92134	1749	14555397000000	9968	5171	6	0	\N
92135	724	20001150000000	9969	5079	0	0	\N
92136	498	66001250000000	9969	5079	1	0	\N
92137	1710	13833317340144	9969	5079	2	0	\N
92138	1710	10238531520848	9969	5079	3	0	\N
92139	1710	7813025369394	9969	5079	4	0	\N
92140	1710	1054315473290	9969	5079	5	0	\N
92141	1564	7843257000000	9969	5079	6	0	\N
92142	1564	4738242000000	9969	5079	7	0	\N
92143	1564	2643227000000	9969	5079	8	0	\N
92144	1564	548212000000	9969	5079	9	0	\N
92145	1564	545112000000	9969	5079	10	0	\N
92146	1449	3043000459	9969	5079	11	0	\N
92147	1444	19439533000000	9969	5079	12	0	\N
92148	1672	17561733000000	9969	5079	13	0	\N
92149	1672	12904723000000	9969	5079	14	0	\N
92150	1681	24072051210200	9969	5079	15	0	\N
92151	1444	11144865400000	9969	5079	16	0	\N
92152	1522	13833920000000	9969	5079	17	0	\N
92153	1522	10238910000000	9969	5079	18	0	\N
92154	606	75493560563149	9969	5079	19	0	\N
92155	606	71734469933884	9969	5079	20	0	\N
92156	1681	20971901644968	9969	5079	21	0	\N
92157	1681	15416468106056	9969	5079	22	0	\N
92158	1681	11668103144718	9969	5079	23	0	\N
92159	1522	7812900000000	9969	5079	24	0	\N
92160	1522	1053890000000	9969	5079	25	0	\N
92161	1681	1222968759830	9969	5079	26	0	\N
92162	1672	9761713000000	9969	5079	27	0	\N
92163	1672	1005703000000	9969	5079	28	0	\N
92164	1444	6733195530000	9969	5079	29	0	\N
92165	1444	4271309990000	9969	5079	30	0	\N
92166	1444	1294665160000	9969	5079	31	0	\N
92167	1668	18859396000000	9969	5079	32	0	\N
92168	1668	13949825000000	9969	5079	33	0	\N
92169	1668	10637236000000	9969	5079	34	0	\N
92170	1668	1406431000000	9969	5079	35	0	\N
92171	1759	20879958999999	9969	5079	36	0	\N
92172	1749	14835357000000	9969	5079	37	0	\N
92173	1749	13835356000000	9969	5079	38	0	\N
92174	1972	299000000	9969	5079	39	0	\N
92175	1972	298000000	9969	5079	40	0	\N
92176	1972	297000000	9969	5079	41	0	\N
92177	1972	296000000	9969	5079	42	0	\N
92178	1972	295000000	9969	5079	43	0	\N
92179	1972	294000000	9969	5079	44	0	\N
92180	1972	293000000	9969	5079	45	0	\N
92181	1972	292000000	9969	5079	46	0	\N
92182	1972	291000000	9969	5079	47	0	\N
92183	1972	290000000	9969	5079	48	0	\N
92184	1972	189000000	9969	5079	49	0	\N
92185	1972	188000000	9969	5079	50	0	\N
92186	1972	187000000	9969	5079	51	0	\N
92187	1972	186000000	9969	5079	52	0	\N
92188	1972	185000000	9969	5079	53	0	\N
92189	1972	184000000	9969	5079	54	0	\N
92190	1972	183000000	9969	5079	55	0	\N
92191	1972	182000000	9969	5079	56	0	\N
92192	1972	181000000	9969	5079	57	0	\N
92193	1972	180000000	9969	5079	58	0	\N
92194	1972	179000000	9969	5079	59	0	\N
92195	1972	178000000	9969	5079	60	0	\N
92196	606	75493560563149	9970	5172	0	0	\N
92197	606	71734469933884	9970	5172	1	0	\N
92198	1726	771152577000	9970	5172	2	0	\N
92199	1397	1382174351000	9970	5172	3	0	\N
92200	606	75493560563149	9971	5172	0	0	\N
92201	606	71734469933884	9971	5172	1	0	\N
92202	1726	771152577000	9971	5172	2	0	\N
92203	1397	1382174351000	9971	5172	3	0	\N
92075	1726	771222584000	9950	5166	0	0	2613
92076	1397	1382254359000	9950	5166	1	0	5658
92077	1449	3043000459	9951	5167	0	0	4
92078	1726	771212583000	9951	5167	1	0	2614
92080	1397	1382244358000	9953	5168	0	0	5659
92083	1397	1382224356000	9955	5169	1	0	5661
92084	1726	771202582000	9955	5169	2	0	2615
92085	1726	771192581000	9955	5169	3	0	2616
92086	1749	14835357000000	9955	5169	4	0	4
92092	1397	1382214355000	9961	5170	0	0	5662
92114	1726	771182580000	9966	5171	1	0	2617
92115	1726	771172579000	9966	5171	2	0	2618
92116	1726	771162578000	9966	5171	3	0	2619
92117	1397	1382194353000	9966	5171	4	0	5664
92119	1749	14555397000000	9966	5171	6	0	5
92204	606	75493560563149	9972	5172	0	0	2
92205	606	71734469933884	9972	5172	1	0	3
92206	1726	771152577000	9972	5172	2	0	2620
92207	1397	1382174351000	9972	5172	3	0	5666
92209	606	75493560563149	9974	5163	0	0	\N
92210	606	71734469933884	9974	5163	1	0	\N
92211	606	69197808048273	9974	5163	2	0	\N
92212	606	75493560563149	9975	5154	0	0	\N
92213	606	71734469933884	9975	5154	1	0	\N
92214	606	69197808048273	9975	5154	2	0	\N
92215	1397	1382204354000	9976	5171	0	0	\N
92216	1726	771182580000	9976	5171	1	0	\N
92217	1726	771172579000	9976	5171	2	0	\N
92218	606	75493560563149	9976	5171	3	0	\N
92219	1397	1382194353000	9976	5171	4	0	\N
92220	606	71734469933884	9976	5171	5	0	\N
92221	606	69197808048273	9976	5171	6	0	\N
92227	1397	1382134347000	9978	5175	0	0	\N
92228	1726	771122574000	9978	5175	1	0	\N
92231	1726	771112573000	9980	5176	0	0	\N
92232	1700	13207392964990	9980	5176	1	0	\N
92233	1397	1382124346000	9980	5176	2	0	\N
92234	1397	1382114345000	9980	5176	3	0	\N
92235	1726	771102572000	9980	5176	4	0	\N
92236	1700	13207372964990	9980	5176	5	0	\N
92237	1726	771112573000	9981	5176	0	0	\N
92238	1700	13207392964990	9981	5176	1	0	\N
92239	1397	1382124346000	9981	5176	2	0	\N
92240	1397	1382114345000	9981	5176	3	0	\N
92241	1726	771102572000	9981	5176	4	0	\N
92242	1700	13207372964990	9981	5176	5	0	\N
92249	1726	771112573000	9983	5176	0	0	\N
92250	1700	13207392964990	9983	5176	1	0	\N
92251	1397	1382124346000	9983	5176	2	0	\N
92252	1397	1382114345000	9983	5176	3	0	\N
92253	1726	771102572000	9983	5176	4	0	\N
92254	1700	13207372964990	9983	5176	5	0	\N
92260	1726	771162578000	9985	5168	0	0	\N
92261	1700	13207392964990	9985	5168	1	0	\N
92262	606	75493560563149	9985	5168	2	0	\N
92263	606	71734469933884	9985	5168	3	0	\N
92264	606	69197808048273	9985	5168	4	0	\N
92265	1397	1382184352000	9985	5168	5	0	\N
92266	1726	771152577000	9985	5168	6	0	\N
92267	1726	771142576000	9985	5168	7	0	\N
92268	1726	771132575000	9985	5168	8	0	\N
92269	1726	771122574000	9985	5168	9	0	\N
92270	1726	771112573000	9985	5168	10	0	\N
92271	1397	1382174351000	9985	5168	11	0	\N
92272	1726	771102572000	9985	5168	12	0	\N
92273	1726	771092571000	9985	5168	13	0	\N
92274	1726	771082570000	9985	5168	14	0	\N
92275	1397	1382164350000	9985	5168	15	0	\N
92276	1397	1382154349000	9985	5168	16	0	\N
92277	1397	1382144348000	9985	5168	17	0	\N
92278	1397	1382134347000	9985	5168	18	0	\N
92279	1397	1382124346000	9985	5168	19	0	\N
92280	1397	1382114345000	9985	5168	20	0	\N
92281	1397	1382104344000	9985	5168	21	0	\N
92282	1397	1382094343000	9985	5168	22	0	\N
92283	1700	13207372964990	9985	5168	23	0	\N
92284	1700	9780614742484	9985	5168	24	0	\N
92285	606	67099644812964	9985	5168	25	0	\N
92286	1749	13835356000000	9985	5168	26	0	\N
92287	1749	12835355000000	9985	5168	27	0	\N
92288	1397	1382084342000	9986	5178	0	0	\N
92289	606	71734449933884	9986	5178	1	0	\N
92290	1397	1382074341000	9986	5178	2	0	\N
92291	1700	7468509433968	9986	5178	3	0	\N
92292	1700	1025640276737	9986	5178	4	0	\N
92293	1726	771072569000	9986	5178	5	0	\N
92294	1397	1382084342000	9987	5178	0	0	\N
92295	606	71734449933884	9987	5178	1	0	\N
92296	1397	1382074341000	9987	5178	2	0	\N
92297	1700	7468509433968	9987	5178	3	0	\N
92298	1700	1025640276737	9987	5178	4	0	\N
92299	1726	771072569000	9987	5178	5	0	\N
92300	1397	1382084342000	9988	5178	0	0	\N
92301	606	71734449933884	9988	5178	1	0	\N
92302	1397	1382074341000	9988	5178	2	0	\N
92303	1700	7468509433968	9988	5178	3	0	\N
92304	1700	1025640276737	9988	5178	4	0	\N
92305	1726	771072569000	9988	5178	5	0	\N
92324	1726	771012563000	9994	5183	0	0	\N
92325	1397	1382014335000	9994	5183	1	0	\N
92328	606	71734449933884	9996	5175	0	0	\N
92329	1700	13207392964990	9996	5175	1	0	\N
92330	1397	1382134347000	9996	5175	2	0	\N
92331	1397	1382124346000	9996	5175	3	0	\N
92332	1397	1382114345000	9996	5175	4	0	\N
92333	1397	1382104344000	9996	5175	5	0	\N
92334	1726	771122574000	9996	5175	6	0	\N
92335	1726	771112573000	9996	5175	7	0	\N
92336	1397	1382094343000	9996	5175	8	0	\N
92337	1397	1382084342000	9996	5175	9	0	\N
92338	1397	1382074341000	9996	5175	10	0	\N
92339	1397	1382064340000	9996	5175	11	0	\N
92340	1397	1382054339000	9996	5175	12	0	\N
92341	1397	1382044338000	9996	5175	13	0	\N
92342	1397	1382034337000	9996	5175	14	0	\N
92343	1397	1382024336000	9996	5175	15	0	\N
92344	1397	1382014335000	9996	5175	16	0	\N
92224	1726	771132575000	9977	5174	2	0	2622
92225	1397	1382144348000	9977	5174	3	0	5669
92226	1749	13555396000000	9977	5174	4	0	6
92229	1397	1382134347000	9979	5175	0	0	5670
92230	1726	771122574000	9979	5175	1	0	2623
92244	1700	13207392964990	9982	5176	1	0	2
92245	1397	1382124346000	9982	5176	2	0	5671
92246	1397	1382114345000	9982	5176	3	0	5672
92247	1726	771102572000	9982	5176	4	0	2625
92248	1700	13207372964990	9982	5176	5	0	3
92256	1700	9780614742484	9984	5177	1	0	4
92257	1726	771092571000	9984	5177	2	0	2626
92258	1397	1382094343000	9984	5177	3	0	5674
92259	1726	771082570000	9984	5177	4	0	2627
92307	606	71734449933884	9989	5178	1	0	4
92308	1397	1382074341000	9989	5178	2	0	5676
92309	1700	7468509433968	9989	5178	3	0	5
92310	1700	1025640276737	9989	5178	4	0	6
92311	1726	771072569000	9989	5178	5	0	2628
92313	1397	1382064340000	9990	5179	1	0	5677
92314	1397	1382054339000	9991	5180	0	0	5678
92315	1726	771052567000	9991	5180	1	0	2630
92316	1397	1382044338000	9992	5181	0	0	5679
92317	1726	771042566000	9992	5181	1	0	2631
92319	1397	1382024336000	9993	5182	1	0	5681
92320	606	71734429933884	9993	5182	2	0	5
92321	1726	771032565000	9993	5182	3	0	2632
92322	1726	771022564000	9993	5182	4	0	2633
92326	1726	771012563000	9995	5183	0	0	2634
92327	1397	1382014335000	9995	5183	1	0	5682
92345	1726	771102572000	9996	5175	17	0	\N
92346	1726	771092571000	9996	5175	18	0	\N
92347	606	71734429933884	9996	5175	19	0	\N
92348	1726	771082570000	9996	5175	20	0	\N
92349	1726	771072569000	9996	5175	21	0	\N
92350	1726	771062568000	9996	5175	22	0	\N
92351	1700	13207372964990	9996	5175	23	0	\N
92352	1700	9780614742484	9996	5175	24	0	\N
92353	1700	7468509433968	9996	5175	25	0	\N
92354	1700	1025640276737	9996	5175	26	0	\N
92355	1726	771052567000	9996	5175	27	0	\N
92356	1726	771042566000	9996	5175	28	0	\N
92357	1726	771032565000	9996	5175	29	0	\N
92358	1726	771022564000	9996	5175	30	0	\N
92359	1726	771012563000	9996	5175	31	0	\N
92360	619	66000499000000	9996	5175	32	0	\N
92361	1726	771012563000	9997	5183	0	0	\N
92362	1397	1382014335000	9997	5183	1	0	\N
92363	724	20001150000000	9998	5027	0	0	\N
92364	498	66001250000000	9998	5027	1	0	\N
92365	1981	100900000000	9998	5027	2	0	\N
92366	596	81618162000000	9998	5027	3	0	\N
92367	596	77533062000000	9998	5027	4	0	\N
92368	596	74775962000000	9998	5027	5	0	\N
92369	596	67094862000000	9998	5027	6	0	\N
92370	1727	11976585000000	9998	5027	7	0	\N
92371	1710	13833317340144	9998	5027	8	0	\N
92372	1710	10238531520848	9998	5027	9	0	\N
92373	1710	7813025369394	9998	5027	10	0	\N
92374	1710	1054315473290	9998	5027	11	0	\N
92375	1564	7843257000000	9998	5027	12	0	\N
92376	1564	4738242000000	9998	5027	13	0	\N
92377	1564	2643227000000	9998	5027	14	0	\N
92378	1564	548212000000	9998	5027	15	0	\N
92379	1564	545112000000	9998	5027	16	0	\N
92380	1449	3043000459	9998	5027	17	0	\N
92381	1444	19439533000000	9998	5027	18	0	\N
92382	1671	12797614237287	9998	5027	19	0	\N
92383	1668	21598630000000	9998	5027	20	0	\N
92384	1675	14332739999977	9998	5027	21	0	\N
92385	1675	10340729999977	9998	5027	23	0	\N
92386	1476	10732380000000	9998	5027	24	0	\N
92387	1397	1384104544000	9998	5027	25	0	\N
92388	1726	774152756000	9998	5027	26	0	\N
92389	1672	16841703000000	9998	5027	27	0	\N
92390	1672	12184693000000	9998	5027	28	0	\N
92391	1727	8925465000000	9998	5027	29	0	\N
92392	1681	24072051210200	9998	5027	30	0	\N
92393	1444	11144865400000	9998	5027	31	0	\N
92394	1522	13113900000000	9998	5027	32	0	\N
92395	1522	9518890000000	9998	5027	33	0	\N
92396	1727	6866815000000	9998	5027	34	0	\N
92397	1476	6483370000000	9998	5027	35	0	\N
92398	1476	3616360000000	9998	5027	36	0	\N
92399	1476	1245350000000	9998	5027	37	0	\N
92400	1700	13207392964990	9998	5027	38	0	\N
92401	470	85440411000000	9998	5027	39	0	\N
92402	470	77147401000000	9998	5027	40	0	\N
92403	1536	18409250000000	9998	5027	41	0	\N
92404	606	74773520563149	9998	5027	42	0	\N
92405	470	72736391000000	9998	5027	43	0	\N
92406	1726	774142755000	9998	5027	44	0	\N
92407	1726	774132754000	9998	5027	45	0	\N
92408	470	69760381000000	9998	5027	46	0	\N
92409	470	67298371000000	9998	5027	47	0	\N
92410	470	66000011000000	9998	5027	48	0	\N
92411	606	71014429933884	9998	5027	49	0	\N
92412	606	68477768048273	9998	5027	50	0	\N
92413	1602	11318380000000	9998	5027	51	0	\N
92414	1397	1384094543000	9998	5027	52	0	\N
92415	1671	7732365128278	9998	5027	53	0	\N
92416	1671	4314737369410	9998	5027	54	0	\N
92417	1671	1488129530515	9998	5027	55	0	\N
92418	1681	20971901644968	9998	5027	56	0	\N
92419	1681	15416468106056	9998	5027	57	0	\N
92420	1727	1130205000000	9998	5027	58	0	\N
92421	1727	906685000000	9998	5027	59	0	\N
92422	1681	11668103144718	9998	5027	60	0	\N
92423	1726	774122753000	9998	5027	61	0	\N
92424	1726	774112752000	9998	5027	62	0	\N
92425	1726	774102751000	9998	5027	63	0	\N
92426	1726	774092750000	9998	5027	64	0	\N
92427	1726	774082749000	9998	5027	65	0	\N
92428	1726	774072748000	9998	5027	66	0	\N
92429	1726	774062747000	9998	5027	67	0	\N
92430	1726	774052746000	9998	5027	68	0	\N
92431	1397	1384084542000	9998	5027	69	0	\N
92432	1397	1384074541000	9998	5027	70	0	\N
92433	1397	1384064540000	9998	5027	71	0	\N
92434	1397	1384054539000	9998	5027	72	0	\N
92435	1397	1384044538000	9998	5027	73	0	\N
92436	1397	1384034537000	9998	5027	74	0	\N
92437	1476	0	9998	5027	75	0	\N
92438	1397	1384024536000	9998	5027	76	0	\N
92439	1397	1384014535000	9998	5027	77	0	\N
92440	1397	1384004534000	9998	5027	78	0	\N
92441	1522	7092880000000	9998	5027	79	0	\N
92442	1522	333870000000	9998	5027	80	0	\N
92443	1610	18236443260000	9998	5027	81	0	\N
92444	1610	13497804490000	9998	5027	82	0	\N
92445	1610	10300547230000	9998	5027	83	0	\N
92446	1536	10421740000000	9998	5027	84	0	\N
92447	1536	6173430000000	9998	5027	85	0	\N
92448	1536	3307020000000	9998	5027	86	0	\N
92449	1536	936310000000	9998	5027	87	0	\N
92450	1536	0	9998	5027	88	0	\N
92451	1726	774042745000	9998	5027	89	0	\N
92452	1610	1391123470000	9998	5027	90	0	\N
92453	1681	1222968759830	9998	5027	91	0	\N
92454	1675	7646719999977	9998	5027	92	0	\N
92455	1675	141709999977	9998	5027	93	0	\N
92456	1397	1383994533000	9998	5027	94	0	\N
92457	1397	1383984532000	9998	5027	95	0	\N
92458	1397	1383974531000	9998	5027	96	0	\N
92459	1397	1383964530000	9998	5027	97	0	\N
92460	1397	1383954529000	9998	5027	98	0	\N
92461	1397	1383944528000	9998	5027	99	0	\N
92462	1397	1383934527000	9998	5027	100	0	\N
92463	1397	1383924526000	9998	5027	101	0	\N
92464	1397	1383914525000	9998	5027	102	0	\N
92465	1397	1383904524000	9998	5027	103	0	\N
92466	1397	1383894523000	9998	5027	104	0	\N
92467	1397	1383884522000	9998	5027	105	0	\N
92468	1397	1383874521000	9998	5027	106	0	\N
92469	1397	1383864520000	9998	5027	107	0	\N
92470	1850	10379540000000	9998	5027	108	0	\N
92471	1850	6339530000000	9998	5027	109	0	\N
92472	1850	3613520000000	9998	5027	110	0	\N
92473	1850	1358510000000	9998	5027	111	0	\N
92474	1594	15721020000000	9998	5027	112	0	\N
92475	1594	8040770000000	9998	5027	113	0	\N
92476	1594	5284610000000	9998	5027	114	0	\N
92477	1594	1199720000000	9998	5027	115	0	\N
92478	1594	1710000000	9998	5027	116	0	\N
92479	1587	9314091000000	9998	5027	117	0	\N
92480	1700	13207372964990	9998	5027	118	0	\N
92481	1700	9780614742484	9998	5027	119	0	\N
92482	1700	7468509433968	9998	5027	120	0	\N
92483	1700	1025640276737	9998	5027	121	0	\N
92484	1587	5460041000000	9998	5027	122	0	\N
92485	1587	2859631000000	9998	5027	123	0	\N
92486	1587	708921000000	9998	5027	124	0	\N
92487	1587	426581000000	9998	5027	125	0	\N
92488	1397	1382004334000	9999	5184	0	0	\N
92489	44	66000000000000	9999	5184	1	0	\N
92490	1397	1382004334000	10000	5184	0	0	\N
92491	44	66000000000000	10000	5184	1	0	\N
92496	1726	770992561000	10003	5186	0	0	\N
92497	1397	1381984332000	10003	5186	1	0	\N
92500	1726	770982560000	10005	5187	0	0	\N
92501	1397	1381974331000	10005	5187	1	0	\N
92502	1397	1381964330000	10005	5187	2	0	\N
92503	1397	1381954329000	10005	5187	3	0	\N
92504	1726	770972559000	10005	5187	4	0	\N
92505	1726	770982560000	10006	5187	0	0	\N
92506	1397	1381974331000	10006	5187	1	0	\N
92507	1397	1381964330000	10006	5187	2	0	\N
92508	1397	1381954329000	10006	5187	3	0	\N
92509	1726	770972559000	10006	5187	4	0	\N
92510	1726	770962558000	10006	5187	5	0	\N
92511	1749	13554395000000	10006	5187	7	0	\N
92512	1991	16288916155534	10006	5187	8	0	\N
92513	1991	16037825311068	10006	5187	9	0	\N
92514	1991	15786734466602	10006	5187	10	0	\N
92515	1991	15535643622136	10006	5187	11	0	\N
92516	1991	15284552777670	10006	5187	12	0	\N
92517	1991	13372904944501	10006	5187	13	0	\N
92518	1991	9947249198447	10006	5187	14	0	\N
92519	1991	7635890680296	10006	5187	15	0	\N
92520	1991	1195086441475	10006	5187	16	0	\N
92544	1726	770932555000	10011	5190	0	0	\N
92545	1397	1381924326000	10011	5190	1	0	\N
92546	1397	1381914325000	10011	5190	2	0	\N
92547	1726	770922554000	10012	5191	0	0	\N
92548	606	69197768048272	10012	5191	1	0	\N
92549	606	67099604812962	10012	5191	2	0	\N
92550	1397	1381904324000	10012	5191	3	0	\N
92572	1397	1381844318000	10018	5195	0	0	\N
92573	1726	770862548000	10018	5195	1	0	\N
92574	1397	1382084342000	10019	5169	0	0	\N
92575	1397	1382074341000	10019	5169	1	0	\N
92576	1700	7468509433968	10019	5169	2	0	\N
92577	1700	1025640276737	10019	5169	3	0	\N
92578	1397	1382064340000	10019	5169	4	0	\N
92579	1397	1382054339000	10019	5169	5	0	\N
92580	1397	1382044338000	10019	5169	6	0	\N
92581	1397	1382034337000	10019	5169	7	0	\N
92582	1397	1382024336000	10019	5169	8	0	\N
92583	1397	1382014335000	10019	5169	9	0	\N
92584	1726	771072569000	10019	5169	10	0	\N
92585	1726	771062568000	10019	5169	11	0	\N
92586	1397	1382004334000	10019	5169	12	0	\N
92587	1397	1381994333000	10019	5169	13	0	\N
92588	1397	1381984332000	10019	5169	14	0	\N
92589	1397	1381974331000	10019	5169	15	0	\N
92590	1397	1381964330000	10019	5169	16	0	\N
92591	1397	1381954329000	10019	5169	17	0	\N
92592	1397	1381944328000	10019	5169	18	0	\N
92593	1397	1381934327000	10019	5169	19	0	\N
92594	1397	1381924326000	10019	5169	20	0	\N
92595	1397	1381914325000	10019	5169	21	0	\N
92596	1397	1381904324000	10019	5169	22	0	\N
92597	1397	1381894323000	10019	5169	23	0	\N
92598	1397	1381884322000	10019	5169	24	0	\N
92599	1397	1381874321000	10019	5169	25	0	\N
92600	1397	1381864320000	10019	5169	26	0	\N
92601	1397	1381854319000	10019	5169	27	0	\N
92602	1397	1381844318000	10019	5169	28	0	\N
92603	1726	771052567000	10019	5169	29	0	\N
92604	1726	771042566000	10019	5169	30	0	\N
92605	1726	771032565000	10019	5169	31	0	\N
92606	1726	771022564000	10019	5169	32	0	\N
92607	1726	771012563000	10019	5169	33	0	\N
92608	1726	771002562000	10019	5169	34	0	\N
92609	1726	770992561000	10019	5169	35	0	\N
92610	1726	770982560000	10019	5169	36	0	\N
92611	1726	770972559000	10019	5169	37	0	\N
92612	1726	770962558000	10019	5169	38	0	\N
92613	1726	770952557000	10019	5169	39	0	\N
92614	1726	770942556000	10019	5169	40	0	\N
92615	1726	770932555000	10019	5169	41	0	\N
92616	1726	770922554000	10019	5169	42	0	\N
92494	1397	1381994333000	10002	5185	0	0	5684
92495	1726	771002562000	10002	5185	1	0	2635
92498	1726	770992561000	10004	5186	0	0	2636
92499	1397	1381984332000	10004	5186	1	0	5685
92521	1726	770982560000	10007	5187	0	0	2637
92523	1397	1381964330000	10007	5187	2	0	5687
92524	1397	1381954329000	10007	5187	3	0	5688
92525	1726	770972559000	10007	5187	4	0	2638
92526	1726	770962558000	10007	5187	5	0	2639
92527	1749	13554395000000	10007	5187	7	0	7
92529	1991	16037825311068	10007	5187	9	0	2
92530	1991	15786734466602	10007	5187	10	0	3
92531	1991	15535643622136	10007	5187	11	0	4
92532	1991	15284552777670	10007	5187	12	0	5
92534	1991	9947249198447	10007	5187	14	0	7
92535	1991	7635890680296	10007	5187	15	0	8
92536	1991	1195086441475	10007	5187	16	0	9
92537	1397	1381944328000	10008	5188	0	0	5689
92538	1726	770952557000	10008	5188	1	0	2640
92540	1726	770942556000	10009	5189	1	0	2641
92541	1726	770932555000	10010	5190	0	0	2642
92542	1397	1381924326000	10010	5190	1	0	5691
92543	1397	1381914325000	10010	5190	2	0	5692
92551	1726	770922554000	10013	5191	0	0	2643
92553	606	67099604812962	10013	5191	2	0	7
92554	1397	1381904324000	10013	5191	3	0	5693
92555	1397	1381894323000	10014	5192	0	0	5694
92556	1726	770912553000	10014	5192	1	0	2644
92558	1991	1195084441475	10014	5192	3	0	11
92559	1991	1195083441475	10014	5192	4	0	12
92560	1397	1381884322000	10015	5193	0	0	5695
92561	606	67099584812962	10015	5193	1	0	8
92562	1397	1381874321000	10015	5193	2	0	5696
92564	1726	770892551000	10015	5193	4	0	2646
92565	1726	770882550000	10016	5194	0	0	2647
92566	1397	1381864320000	10016	5194	1	0	5697
92567	1726	770872549000	10016	5194	2	0	2648
92568	1397	1381854319000	10016	5194	3	0	5698
92570	1397	1381844318000	10017	5195	0	0	5699
92571	1726	770862548000	10017	5195	1	0	2649
92617	1726	770912553000	10019	5169	43	0	\N
92618	1726	770902552000	10019	5169	44	0	\N
92619	1726	770892551000	10019	5169	45	0	\N
92620	1726	770882550000	10019	5169	46	0	\N
92621	1726	770872549000	10019	5169	47	0	\N
92622	1726	770862548000	10019	5169	48	0	\N
92623	619	66000499000000	10019	5169	49	0	\N
92624	1749	12834354000000	10019	5169	50	0	\N
92625	1749	12833353000000	10019	5169	51	0	\N
92626	44	66000000000000	10019	5169	52	0	\N
92627	1397	1381834317000	10020	5196	0	0	\N
92628	1726	770852547000	10020	5196	1	0	\N
92629	1759	12054997999999	10020	5196	2	0	\N
92630	1680	25500227610710	10020	5196	3	0	\N
92635	1397	1381824316000	10022	5197	0	0	\N
92636	1397	1381814315000	10022	5197	1	0	\N
92637	1397	1381804314000	10022	5197	2	0	\N
92638	1726	770842546000	10022	5197	3	0	\N
92639	1726	770832545000	10022	5197	4	0	\N
92640	1759	6978496999999	10022	5197	5	0	\N
92641	1759	3553495999999	10022	5197	6	0	\N
92642	1759	719494999999	10022	5197	7	0	\N
92643	1680	22308906470030	10022	5197	8	0	\N
92644	1680	16590087121150	10022	5197	9	0	\N
92645	1680	12731485425655	10022	5197	10	0	\N
92646	1680	1979150500035	10022	5197	11	0	\N
92684	606	71734449933884	10031	5080	0	0	\N
92685	641	82988672000000	10031	5080	1	0	\N
92686	1700	13207392964990	10031	5080	2	0	\N
92687	641	80013406000000	10031	5080	3	0	\N
92688	641	69989484000000	10031	5080	4	0	\N
92689	641	66391490000000	10031	5080	5	0	\N
92690	606	71734429933884	10031	5080	6	0	\N
92691	606	69197768048272	10031	5080	7	0	\N
92692	606	67099604812962	10031	5080	8	0	\N
92693	606	67099584812962	10031	5080	9	0	\N
92694	1700	13207372964990	10031	5080	10	0	\N
92695	1700	9780614742484	10031	5080	11	0	\N
92696	1700	7468509433968	10031	5080	12	0	\N
92697	1700	1025640276737	10031	5080	13	0	\N
92698	1716	19492890000000	10031	5080	14	0	\N
92699	1759	11334957999999	10031	5080	15	0	\N
92700	1759	6258456999999	10031	5080	16	0	\N
92701	619	66000499000000	10031	5080	17	0	\N
92702	1759	2833455999999	10031	5080	18	0	\N
92703	44	66000000000000	10031	5080	19	0	\N
92704	1749	12835355000000	10031	5080	20	0	\N
92705	1749	12834354000000	10031	5080	21	0	\N
92706	1749	12833353000000	10031	5080	22	0	\N
92712	1397	1381684302000	10033	5206	0	0	\N
92713	1726	770722534000	10033	5206	1	0	\N
92714	1716	15867699000000	10033	5206	2	0	\N
92715	1716	12450078000000	10033	5206	3	0	\N
92716	1716	2926577000000	10033	5206	4	0	\N
92717	1397	1381684302000	10034	5206	0	0	\N
92718	1726	770722534000	10034	5206	1	0	\N
92719	1716	15867699000000	10034	5206	2	0	\N
92720	1716	12450078000000	10034	5206	3	0	\N
92721	1716	2926577000000	10034	5206	4	0	\N
92729	1726	770712533000	10037	5207	0	0	\N
92730	1397	1381674301000	10037	5207	1	0	\N
92731	1726	770702532000	10038	5208	0	0	\N
92732	1726	770692531000	10038	5208	1	0	\N
92733	1726	770682530000	10038	5208	2	0	\N
92734	1397	1381664300000	10038	5208	3	0	\N
92735	1397	1381654299000	10038	5208	4	0	\N
92736	1397	1381644298000	10038	5208	5	0	\N
92746	1397	1381624296000	10042	5210	0	0	\N
92747	1726	770672529000	10042	5210	1	0	\N
92748	1397	1381624296000	10043	5210	0	0	\N
92749	1726	770672529000	10043	5210	1	0	\N
92750	1397	1381624296000	10044	5210	0	0	\N
92751	1726	770672529000	10044	5210	1	0	\N
92752	1710	13833317340144	10045	5015	0	0	\N
92633	1759	12054997999999	10021	5196	2	0	3
92634	1680	25500227610710	10021	5196	3	0	1
92647	1397	1381824316000	10023	5197	0	0	5701
92648	1397	1381814315000	10023	5197	1	0	5702
92649	1397	1381804314000	10023	5197	2	0	5703
92651	1726	770832545000	10023	5197	4	0	2652
92652	1759	6978496999999	10023	5197	5	0	4
92653	1759	3553495999999	10023	5197	6	0	5
92654	1759	719494999999	10023	5197	7	0	6
92655	1680	22308906470030	10023	5197	8	0	2
92657	1680	12731485425655	10023	5197	10	0	4
92658	1680	1979150500035	10023	5197	11	0	5
92659	1397	1381794313000	10024	5198	0	0	5704
92660	641	82988672000000	10024	5198	1	0	1
92662	641	69989484000000	10025	5199	0	0	3
92663	1726	770822544000	10025	5199	1	0	2653
92664	1397	1381784312000	10025	5199	2	0	5705
92665	641	66391490000000	10025	5199	3	0	4
92666	1680	729149500035	10025	5199	4	0	6
92668	1726	770812543000	10026	5200	1	0	2654
92669	1933	129000000	10026	5200	2	0	2
92670	1722	1322117000000	10026	5200	3	0	11
92671	1397	1381764310000	10027	5201	0	0	5707
92672	1726	770802542000	10027	5201	1	0	2655
92674	1726	770792541000	10028	5202	0	0	2656
92675	1726	770782540000	10028	5202	1	0	2657
92676	1397	1381754309000	10028	5202	2	0	5708
92677	1397	1381744308000	10028	5202	3	0	5709
92679	1726	770772539000	10029	5203	1	0	2658
92680	1726	770762538000	10029	5203	2	0	2659
92681	1397	1381724306000	10029	5203	3	0	5711
92682	1726	770752537000	10030	5204	0	0	2660
92683	1397	1381714305000	10030	5204	1	0	5712
92708	1726	770742536000	10032	5205	1	0	2661
92709	1397	1381694303000	10032	5205	2	0	5714
92710	1726	770732535000	10032	5205	3	0	2662
92711	1716	20932940000000	10032	5205	4	0	1
92722	1397	1381684302000	10035	5206	0	0	5715
92724	1716	15867699000000	10035	5206	2	0	2
92725	1716	12450078000000	10035	5206	3	0	3
92726	1716	2926577000000	10035	5206	4	0	4
92727	1726	770712533000	10036	5207	0	0	2664
92737	1726	770702532000	10039	5208	0	0	2665
92738	1726	770692531000	10039	5208	1	0	2666
92739	1726	770682530000	10039	5208	2	0	2667
92740	1397	1381664300000	10040	5209	0	0	5717
92741	1397	1381654299000	10040	5209	1	0	5718
92743	1397	1381634297000	10040	5209	3	0	5720
92744	1397	1381624296000	10041	5210	0	0	5721
92745	1726	770672529000	10041	5210	1	0	2668
92753	1710	10238531520848	10045	5015	1	0	\N
92754	1710	7813025369394	10045	5015	2	0	\N
92755	1710	1054315473290	10045	5015	3	0	\N
92756	1564	7843257000000	10045	5015	4	0	\N
92757	1564	4738242000000	10045	5015	5	0	\N
92758	1564	2643227000000	10045	5015	6	0	\N
92759	1564	548212000000	10045	5015	7	0	\N
92760	1564	545112000000	10045	5015	8	0	\N
92761	1449	3043000459	10045	5015	9	0	\N
92762	1444	19439533000000	10045	5015	10	0	\N
92763	1681	24072051210200	10045	5015	11	0	\N
92764	1444	11144865400000	10045	5015	12	0	\N
92765	641	82988672000000	10045	5015	13	0	\N
92766	1700	13207392964990	10045	5015	14	0	\N
92767	606	74773520563149	10045	5015	15	0	\N
92768	606	71014429933884	10045	5015	16	0	\N
92769	606	68477768048273	10045	5015	17	0	\N
92770	1681	20971901644968	10045	5015	18	0	\N
92771	1681	15416468106056	10045	5015	19	0	\N
92772	641	80013406000000	10045	5015	20	0	\N
92773	641	69989484000000	10045	5015	21	0	\N
92774	1681	11668103144718	10045	5015	22	0	\N
92775	641	66391490000000	10045	5015	23	0	\N
92776	1681	1222968759830	10045	5015	24	0	\N
92777	1700	13207372964990	10045	5015	25	0	\N
92778	1700	9780614742484	10045	5015	26	0	\N
92779	1700	7468509433968	10045	5015	27	0	\N
92780	1700	1025640276737	10045	5015	28	0	\N
92781	1444	6733195530000	10045	5015	29	0	\N
92782	1444	4271309990000	10045	5015	30	0	\N
92783	1444	1294665160000	10045	5015	31	0	\N
92784	606	66379604812964	10045	5015	32	0	\N
92785	1668	18858896000000	10045	5015	33	0	\N
92786	1668	13949325000000	10045	5015	34	0	\N
92787	1668	10636736000000	10045	5015	35	0	\N
92788	1668	1405931000000	10045	5015	36	0	\N
92789	1759	20159908999999	10045	5015	37	0	\N
92790	1749	14835357000000	10045	5015	38	0	\N
92791	1716	19492890000000	10045	5015	39	0	\N
92792	1759	10614907999999	10045	5015	40	0	\N
92793	1759	5538406999999	10045	5015	41	0	\N
92794	1749	13835356000000	10045	5015	42	0	\N
92795	1716	14427649000000	10045	5015	43	0	\N
92796	1759	2113405999999	10045	5015	44	0	\N
92797	1972	178000000	10045	5015	45	0	\N
92798	1716	11010028000000	10045	5015	46	0	\N
92799	44	66000000000000	10045	5015	47	0	\N
92800	1716	1486527000000	10045	5015	48	0	\N
92801	1749	12835355000000	10045	5015	49	0	\N
92802	1749	12834354000000	10045	5015	50	0	\N
92803	1749	12833353000000	10045	5015	51	0	\N
92804	1680	24780097610710	10045	5015	52	0	\N
92805	1680	21588776470030	10045	5015	53	0	\N
92806	1680	15869957121150	10045	5015	54	0	\N
92807	1680	12011355425655	10045	5015	55	0	\N
92808	1680	1259020500035	10045	5015	56	0	\N
92809	1680	9019500035	10045	5015	57	0	\N
92810	1722	1322117000000	10045	5015	58	0	\N
92811	1764	7283676100000	10045	5015	59	0	\N
92812	1397	1381614295000	10046	5211	0	0	\N
92813	1726	770662528000	10046	5211	1	0	\N
92816	1397	1381614295000	10048	5211	0	0	\N
92817	1726	770662528000	10048	5211	1	0	\N
92818	1397	1381614295000	10049	5211	0	0	\N
92819	1726	770662528000	10049	5211	1	0	\N
92822	1397	1381604294000	10051	5212	0	0	\N
92823	1726	770652527000	10051	5212	1	0	\N
92826	1397	1381584292000	10053	5214	0	0	\N
92832	1397	1381554289000	10056	5216	0	0	\N
92833	1726	770612523000	10056	5216	1	0	\N
92834	1702	151000000	10056	5216	2	0	\N
92838	1726	770602522000	10058	5217	0	0	\N
92839	1397	1381544288000	10058	5217	1	0	\N
92841	1726	770602522000	10060	5218	0	0	\N
92842	1726	770592521000	10060	5218	1	0	\N
92843	1397	1381534287000	10060	5218	2	0	\N
92844	1397	1381524286000	10060	5218	3	0	\N
92845	58	86880854999659	10060	5218	4	0	\N
92846	1703	1753580000000	10060	5218	5	0	\N
92847	1726	769382521000	10060	5218	6	0	\N
92848	1726	768172521000	10060	5218	7	0	\N
92849	1726	766962521000	10060	5218	8	0	\N
92850	1726	765752521000	10060	5218	9	0	\N
92851	1726	764542521000	10060	5218	10	0	\N
92852	1726	764532520000	10060	5218	11	0	\N
92853	1726	764522519000	10060	5218	12	0	\N
92854	1397	1381514285000	10060	5218	13	0	\N
92869	58	86880854999659	10062	5056	0	0	\N
92874	1726	764512518000	10064	5219	0	0	\N
92875	1423	3336987230768	10064	5219	1	0	\N
92876	1423	3073894461536	10064	5219	2	0	\N
92877	1397	1381504284000	10064	5219	3	0	\N
92878	1397	1381494283000	10065	5220	0	0	\N
92879	1423	2810801692304	10065	5220	1	0	\N
92880	1423	2547708923072	10065	5220	2	0	\N
92881	1423	2284616153840	10065	5220	3	0	\N
92882	1423	2021523384608	10065	5220	4	0	\N
92883	1423	1758430615376	10065	5220	5	0	\N
92884	1423	1495337846144	10065	5220	6	0	\N
92885	1423	1232245076912	10065	5220	7	0	\N
92886	1423	969152307680	10065	5220	8	0	\N
92887	1423	706059538448	10065	5220	9	0	\N
92820	1397	1381604294000	10050	5212	0	0	5723
92821	1726	770652527000	10050	5212	1	0	2670
92824	1397	1381594293000	10052	5213	0	0	5724
92825	1726	770642526000	10052	5213	1	0	2671
92827	1397	1381584292000	10054	5214	0	0	5725
92829	1726	770622524000	10055	5215	1	0	2673
92830	1397	1381574291000	10055	5215	2	0	5726
92831	1397	1381564290000	10055	5215	3	0	5727
92835	1397	1381554289000	10057	5216	0	0	5728
92836	1726	770612523000	10057	5216	1	0	2674
92840	1397	1381544288000	10059	5217	0	0	5729
92855	1726	770602522000	10061	5218	0	0	2675
92856	1726	770592521000	10061	5218	1	0	2676
92857	1397	1381534287000	10061	5218	2	0	5730
92859	58	86880854999659	10061	5218	4	0	1
92860	1703	1753580000000	10061	5218	5	0	2
92861	1726	769382521000	10061	5218	6	0	2677
92862	1726	768172521000	10061	5218	7	0	2678
92863	1726	766962521000	10061	5218	8	0	2679
92865	1726	764542521000	10061	5218	10	0	2681
92866	1726	764532520000	10061	5218	11	0	2682
92867	1726	764522519000	10061	5218	12	0	2683
92868	1397	1381514285000	10061	5218	13	0	5732
92870	1726	764512518000	10063	5219	0	0	2684
92872	1423	3073894461536	10063	5219	2	0	2
92873	1397	1381504284000	10063	5219	3	0	5733
92888	1397	1381494283000	10066	5220	0	0	5734
92898	1726	764512518000	10067	5219	0	0	\N
92899	1726	764502517000	10067	5219	1	0	\N
92900	1423	3336987230768	10067	5219	2	0	\N
92901	1423	3073894461536	10067	5219	3	0	\N
92902	1423	2810801692304	10067	5219	4	0	\N
92903	1423	2547708923072	10067	5219	5	0	\N
92904	1397	1381504284000	10067	5219	6	0	\N
92905	1397	1381494283000	10067	5219	7	0	\N
92906	1397	1381484282000	10067	5219	8	0	\N
92907	1423	2284616153840	10067	5219	9	0	\N
92908	1423	2021523384608	10067	5219	10	0	\N
92909	1423	1758430615376	10067	5219	11	0	\N
92910	1423	1495337846144	10067	5219	12	0	\N
92911	1423	1232245076912	10067	5219	13	0	\N
92912	1423	969152307680	10067	5219	14	0	\N
92913	1423	706059538448	10067	5219	15	0	\N
92914	1423	442966769216	10067	5219	16	0	\N
92915	1726	764502517000	10068	5221	0	0	\N
92916	1397	1381484282000	10068	5221	1	0	\N
92917	1750	4183000000	10068	5221	2	0	\N
92921	641	82988672000000	10070	5170	0	0	\N
92922	1423	3336987230768	10070	5170	1	0	\N
92923	1423	3073894461536	10070	5170	2	0	\N
92924	58	86880854999659	10070	5170	3	0	\N
92925	1397	1381834317000	10070	5170	4	0	\N
92926	1397	1381824316000	10070	5170	5	0	\N
92927	1397	1381814315000	10070	5170	6	0	\N
92928	1397	1381804314000	10070	5170	7	0	\N
92929	1397	1381794313000	10070	5170	8	0	\N
92930	1703	1753580000000	10070	5170	9	0	\N
92965	1397	1381384272000	10075	5225	0	0	\N
92966	1726	761992508000	10075	5225	1	0	\N
92967	1759	493999999	10075	5225	2	0	\N
92980	1726	760762506000	10078	5227	0	0	\N
92981	1397	1381364270000	10078	5227	1	0	\N
92982	1397	1381354269000	10078	5227	2	0	\N
92983	1726	760752505000	10078	5227	3	0	\N
92984	1607	4063675326172	10078	5227	4	0	\N
92985	1607	3652247405726	10078	5227	5	0	\N
92986	1607	3240819485280	10078	5227	6	0	\N
92993	1397	1381354269000	10080	5228	0	0	\N
92994	1726	760752505000	10080	5228	1	0	\N
92995	1726	760742504000	10080	5228	2	0	\N
92996	1423	33177999985	10080	5228	3	0	\N
92997	1397	1381344268000	10080	5228	4	0	\N
92998	1764	1673100000	10080	5228	5	0	\N
93008	1397	1381304264000	10084	5232	0	0	\N
93009	1397	1381294263000	10084	5232	1	0	\N
93010	1397	1381284262000	10084	5232	2	0	\N
93011	1684	40926997904059	10084	5232	3	0	\N
93012	1684	40591902965776	10084	5232	4	0	\N
93013	1684	40256808027493	10084	5232	5	0	\N
93014	1684	39921713089210	10084	5232	6	0	\N
93015	1684	39586618150927	10084	5232	7	0	\N
93016	1684	39251523212644	10084	5232	8	0	\N
93017	1684	38916428274361	10084	5232	9	0	\N
93018	1684	38581333336078	10084	5232	10	0	\N
93019	1684	38246238397795	10084	5232	11	0	\N
93020	1684	37911143459512	10084	5232	12	0	\N
93021	1684	37576048521229	10084	5232	13	0	\N
93022	1684	37240953582946	10084	5232	14	0	\N
93023	1684	36905858644663	10084	5232	15	0	\N
93024	1684	36570763706380	10084	5232	16	0	\N
92891	1423	2284616153840	10066	5220	3	0	5
92892	1423	2021523384608	10066	5220	4	0	6
92893	1423	1758430615376	10066	5220	5	0	7
92894	1423	1495337846144	10066	5220	6	0	8
92895	1423	1232245076912	10066	5220	7	0	9
92897	1423	706059538448	10066	5220	9	0	11
92918	1726	764502517000	10069	5221	0	0	2685
92919	1397	1381484282000	10069	5221	1	0	5735
92920	1750	4183000000	10069	5221	2	0	17
92931	1423	559374538449	10071	5222	0	0	12
92933	1397	1381464280000	10071	5222	2	0	5737
92934	1726	764492516000	10071	5222	3	0	2686
92935	1726	763282516000	10071	5222	4	0	2687
92936	58	86539694999659	10071	5222	5	0	2
92938	1726	762062515000	10071	5222	7	0	2689
92939	1726	762052514000	10071	5222	8	0	2690
92940	1726	762042513000	10071	5222	9	0	2691
92941	1397	1381454279000	10071	5222	10	0	5738
92942	1397	1381444278000	10071	5222	11	0	5739
92944	1764	2540674100000	10071	5222	13	0	7
92945	1397	1381434277000	10072	5223	0	0	5740
92946	1726	762032512000	10072	5223	1	0	2692
92947	58	77783824999659	10072	5223	2	0	3
92948	58	73126854999659	10072	5223	3	0	4
92950	58	67385914999659	10072	5223	5	0	6
92951	1722	1320116000000	10072	5223	6	0	12
92952	1607	16508018724978	10073	5224	0	0	1
92953	1423	296281769217	10073	5224	1	0	13
92955	1397	1381414275000	10073	5224	3	0	5742
92956	1397	1381404274000	10073	5224	4	0	5743
92957	1397	1381394273000	10073	5224	5	0	5744
92958	1726	762022511000	10073	5224	6	0	2693
92959	1726	762012510000	10073	5224	7	0	2694
92961	1607	11118761966447	10073	5224	9	0	2
92962	1607	7482519790139	10073	5224	10	0	3
92963	1607	4475103246618	10073	5224	11	0	4
92964	1722	115000000	10073	5224	12	0	13
92968	1423	33188999985	10076	5226	0	0	14
92970	1397	1381374271000	10076	5226	2	0	5746
92971	1726	761992508000	10076	5226	3	0	2696
92972	1726	761982507000	10076	5226	4	0	2697
92973	1726	760772507000	10076	5226	5	0	2698
92975	1726	760762506000	10077	5227	0	0	2699
92976	1397	1381364270000	10077	5227	1	0	5747
92977	1607	4063675326172	10077	5227	2	0	5
92978	1607	3652247405726	10077	5227	3	0	6
92979	1607	3240819485280	10077	5227	4	0	7
92988	1726	760752505000	10079	5228	1	0	2700
92989	1726	760742504000	10079	5228	2	0	2701
92990	1423	33177999985	10079	5228	3	0	15
92991	1397	1381344268000	10079	5228	4	0	5749
92992	1764	1673100000	10079	5228	5	0	8
93000	1397	1381334267000	10081	5229	1	0	5750
93001	1726	760722502000	10082	5230	0	0	2703
93002	1397	1381324266000	10082	5230	1	0	5751
93003	1749	8022393000000	10082	5230	2	0	9
93005	1749	1280391000000	10082	5230	4	0	11
93006	1726	760712501000	10083	5231	0	0	2704
93007	1397	1381314265000	10083	5231	1	0	5752
93025	1684	36235668768097	10084	5232	17	0	\N
93026	1684	35900573829814	10084	5232	18	0	\N
93027	1684	35565478891531	10084	5232	19	0	\N
93028	1684	35230383953248	10084	5232	20	0	\N
93029	1684	34895289014965	10084	5232	21	0	\N
93030	1726	760702500000	10084	5232	22	0	\N
93031	1726	760692499000	10084	5232	23	0	\N
93032	1726	759482499000	10084	5232	24	0	\N
93033	1726	759472498000	10084	5232	25	0	\N
93060	1726	759462497000	10086	5233	0	0	\N
93061	1684	34560194076682	10086	5233	1	0	\N
93062	1684	34225099138399	10086	5233	2	0	\N
93063	1684	33890004200116	10086	5233	3	0	\N
93064	1684	33554909261833	10086	5233	4	0	\N
93065	1684	33219814323550	10086	5233	5	0	\N
93066	1684	32884719385267	10086	5233	6	0	\N
93067	1684	32549624446984	10086	5233	7	0	\N
93068	1684	32214529508701	10086	5233	8	0	\N
93069	1684	31879434570418	10086	5233	9	0	\N
93070	1684	31544339632135	10086	5233	10	0	\N
93071	1684	31209244693852	10086	5233	11	0	\N
93072	1684	30874149755569	10086	5233	12	0	\N
93073	1684	30539054817286	10086	5233	13	0	\N
93074	1397	1381274261000	10086	5233	14	0	\N
93075	1397	1381264260000	10086	5233	15	0	\N
93076	1726	759452496000	10086	5233	16	0	\N
93077	1684	30203959879003	10086	5233	17	0	\N
93078	1684	29868864940720	10086	5233	18	0	\N
93079	1684	29533770002437	10086	5233	19	0	\N
93080	1684	29198675064154	10086	5233	20	0	\N
93081	1750	4182000000	10086	5233	21	0	\N
93082	1726	759462497000	10087	5233	0	0	\N
93083	1684	34560194076682	10087	5233	1	0	\N
93084	1684	34225099138399	10087	5233	2	0	\N
93085	1684	33890004200116	10087	5233	3	0	\N
93086	1684	33554909261833	10087	5233	4	0	\N
93087	1684	33219814323550	10087	5233	5	0	\N
93088	1684	32884719385267	10087	5233	6	0	\N
93089	1684	32549624446984	10087	5233	7	0	\N
93090	1684	32214529508701	10087	5233	8	0	\N
93091	1684	31879434570418	10087	5233	9	0	\N
93092	1684	31544339632135	10087	5233	10	0	\N
93093	1684	31209244693852	10087	5233	11	0	\N
93094	1684	30874149755569	10087	5233	12	0	\N
93095	1684	30539054817286	10087	5233	13	0	\N
93096	1397	1381274261000	10087	5233	14	0	\N
93097	1397	1381264260000	10087	5233	15	0	\N
93098	1726	759452496000	10087	5233	16	0	\N
93099	1684	30203959879003	10087	5233	17	0	\N
93100	1684	29868864940720	10087	5233	18	0	\N
93101	1684	29533770002437	10087	5233	19	0	\N
93102	1684	29198675064154	10087	5233	20	0	\N
93103	1750	4182000000	10087	5233	21	0	\N
93138	641	82988672000000	10090	5172	0	0	\N
93139	1700	13207392964990	10090	5172	1	0	\N
93140	1607	15787998724978	10090	5172	2	0	\N
93141	606	75493560563149	10090	5172	3	0	\N
93142	606	71734469933884	10090	5172	4	0	\N
93143	606	69197808048273	10090	5172	5	0	\N
93144	1726	771152577000	10090	5172	6	0	\N
93145	1423	3336987230768	10090	5172	7	0	\N
93146	1423	3073894461536	10090	5172	8	0	\N
93147	1726	771142576000	10090	5172	9	0	\N
93148	1726	771132575000	10090	5172	10	0	\N
93149	1684	40926997904059	10090	5172	11	0	\N
93150	1684	40591902965776	10090	5172	12	0	\N
93151	1684	40256808027493	10090	5172	13	0	\N
93152	1684	39921713089210	10090	5172	14	0	\N
93153	58	86880854999659	10090	5172	15	0	\N
93154	1703	1753580000000	10090	5172	16	0	\N
93155	1726	771122574000	10090	5172	17	0	\N
93156	1726	771112573000	10090	5172	18	0	\N
93157	641	80013406000000	10090	5172	19	0	\N
93158	641	69989484000000	10090	5172	20	0	\N
93159	58	86539694999659	10090	5172	21	0	\N
93160	1423	2810801692304	10090	5172	22	0	\N
93036	1397	1381284262000	10085	5232	2	0	5755
93037	1684	40926997904059	10085	5232	3	0	2
93038	1684	40591902965776	10085	5232	4	0	3
93039	1684	40256808027493	10085	5232	5	0	4
93040	1684	39921713089210	10085	5232	6	0	5
93042	1684	39251523212644	10085	5232	8	0	7
93043	1684	38916428274361	10085	5232	9	0	8
93044	1684	38581333336078	10085	5232	10	0	9
93045	1684	38246238397795	10085	5232	11	0	10
93046	1684	37911143459512	10085	5232	12	0	11
93048	1684	37240953582946	10085	5232	14	0	13
93049	1684	36905858644663	10085	5232	15	0	14
93050	1684	36570763706380	10085	5232	16	0	15
93051	1684	36235668768097	10085	5232	17	0	16
93053	1684	35565478891531	10085	5232	19	0	18
93054	1684	35230383953248	10085	5232	20	0	19
93055	1684	34895289014965	10085	5232	21	0	20
93056	1726	760702500000	10085	5232	22	0	2705
93057	1726	760692499000	10085	5232	23	0	2706
93059	1726	759472498000	10085	5232	25	0	2708
93104	1726	759462497000	10088	5233	0	0	2709
93105	1684	34560194076682	10088	5233	1	0	21
93106	1684	34225099138399	10088	5233	2	0	22
93107	1684	33890004200116	10088	5233	3	0	23
93109	1684	33219814323550	10088	5233	5	0	25
93110	1684	32884719385267	10088	5233	6	0	26
93111	1684	32549624446984	10088	5233	7	0	27
93112	1684	32214529508701	10088	5233	8	0	28
93114	1684	31544339632135	10088	5233	10	0	30
93115	1684	31209244693852	10088	5233	11	0	31
93116	1684	30874149755569	10088	5233	12	0	32
93117	1684	30539054817286	10088	5233	13	0	33
93118	1397	1381274261000	10088	5233	14	0	5756
93120	1726	759452496000	10088	5233	16	0	2710
93121	1684	30203959879003	10088	5233	17	0	34
93122	1684	29868864940720	10088	5233	18	0	35
93123	1684	29533770002437	10088	5233	19	0	36
93124	1684	29198675064154	10088	5233	20	0	37
93126	558	66329984938283	10089	5234	0	0	1
93127	1397	1381254259000	10089	5234	1	0	5758
93128	1684	28863580125871	10089	5234	2	0	38
93129	1684	28528485187588	10089	5234	3	0	39
93131	1684	28193390249305	10089	5234	5	0	40
93132	1684	27858295311022	10089	5234	6	0	41
93133	1684	27523200372739	10089	5234	7	0	42
93134	1684	27188105434456	10089	5234	8	0	43
93135	1684	26853010496173	10089	5234	9	0	44
93137	1684	26182820619607	10089	5234	11	0	46
93161	1423	2547708923072	10090	5172	23	0	\N
93162	1397	1382174351000	10090	5172	24	0	\N
93163	641	66391490000000	10090	5172	25	0	\N
93164	1423	2284616153840	10090	5172	26	0	\N
93165	1423	2021523384608	10090	5172	27	0	\N
93166	1423	1758430615376	10090	5172	28	0	\N
93167	1423	1495337846144	10090	5172	29	0	\N
93168	1423	1232245076912	10090	5172	30	0	\N
93169	1423	969152307680	10090	5172	31	0	\N
93170	1684	39586618150927	10090	5172	32	0	\N
93171	1684	39251523212644	10090	5172	33	0	\N
93172	1684	38916428274361	10090	5172	34	0	\N
93173	1684	38581333336078	10090	5172	35	0	\N
93174	1684	38246238397795	10090	5172	36	0	\N
93175	1684	37911143459512	10090	5172	37	0	\N
93176	1684	37576048521229	10090	5172	38	0	\N
93177	1684	37240953582946	10090	5172	39	0	\N
93178	1684	36905858644663	10090	5172	40	0	\N
93179	1684	36570763706380	10090	5172	41	0	\N
93180	1684	36235668768097	10090	5172	42	0	\N
93181	1684	35900573829814	10090	5172	43	0	\N
93182	1684	35565478891531	10090	5172	44	0	\N
93183	1684	35230383953248	10090	5172	45	0	\N
93184	1684	34895289014965	10090	5172	46	0	\N
93185	1684	34560194076682	10090	5172	47	0	\N
93186	1684	34225099138399	10090	5172	48	0	\N
93187	1684	33890004200116	10090	5172	49	0	\N
93188	1684	33554909261833	10090	5172	50	0	\N
93189	1684	33219814323550	10090	5172	51	0	\N
93190	1684	32884719385267	10090	5172	52	0	\N
93191	1684	32549624446984	10090	5172	53	0	\N
93192	1684	32214529508701	10090	5172	54	0	\N
93193	1684	31879434570418	10090	5172	55	0	\N
93194	1684	31544339632135	10090	5172	56	0	\N
93195	1684	31209244693852	10090	5172	57	0	\N
93196	1684	30874149755569	10090	5172	58	0	\N
93197	1684	30539054817286	10090	5172	59	0	\N
93198	1726	771102572000	10090	5172	60	0	\N
93199	1726	771092571000	10090	5172	61	0	\N
93200	1423	706059538448	10090	5172	62	0	\N
93201	1726	771082570000	10090	5172	63	0	\N
93202	1726	771072569000	10090	5172	64	0	\N
93203	1726	771062568000	10090	5172	65	0	\N
93204	1397	1382164350000	10090	5172	66	0	\N
93205	1397	1382154349000	10090	5172	67	0	\N
93206	1397	1382144348000	10090	5172	68	0	\N
93207	1397	1382134347000	10090	5172	69	0	\N
93208	1397	1382124346000	10090	5172	70	0	\N
93209	1397	1382114345000	10090	5172	71	0	\N
93210	1397	1382104344000	10090	5172	72	0	\N
93211	1397	1382094343000	10090	5172	73	0	\N
93212	1397	1382084342000	10090	5172	74	0	\N
93213	1397	1382074341000	10090	5172	75	0	\N
93214	1397	1382064340000	10090	5172	76	0	\N
93215	1397	1382054339000	10090	5172	77	0	\N
93216	1397	1382044338000	10090	5172	78	0	\N
93217	1397	1382034337000	10090	5172	79	0	\N
93218	1397	1382024336000	10090	5172	80	0	\N
93219	1397	1382014335000	10090	5172	81	0	\N
93220	1397	1382004334000	10090	5172	82	0	\N
93221	1397	1381994333000	10090	5172	83	0	\N
93222	1397	1381984332000	10090	5172	84	0	\N
93223	1397	1381974331000	10090	5172	86	0	\N
93224	1397	1381964330000	10090	5172	87	0	\N
93225	1397	1381954329000	10090	5172	88	0	\N
93226	1397	1381944328000	10090	5172	89	0	\N
93227	1397	1381934327000	10090	5172	90	0	\N
93228	1397	1381924326000	10090	5172	91	0	\N
93229	1397	1381914325000	10090	5172	92	0	\N
93230	1397	1381904324000	10090	5172	93	0	\N
93231	1397	1381894323000	10090	5172	94	0	\N
93232	1397	1381884322000	10090	5172	95	0	\N
93233	1397	1381874321000	10090	5172	96	0	\N
93234	1397	1381864320000	10090	5172	97	0	\N
93235	1397	1381854319000	10090	5172	98	0	\N
93236	1397	1381844318000	10090	5172	99	0	\N
93237	1397	1381834317000	10090	5172	100	0	\N
93238	1397	1381824316000	10090	5172	101	0	\N
93239	1397	1381814315000	10090	5172	102	0	\N
93240	1397	1381804314000	10090	5172	103	0	\N
93241	1397	1381794313000	10090	5172	104	0	\N
93242	1397	1381784312000	10090	5172	105	0	\N
93243	1397	1381774311000	10090	5172	106	0	\N
93244	1397	1381764310000	10090	5172	107	0	\N
93245	1397	1381754309000	10090	5172	108	0	\N
93246	1397	1381744308000	10090	5172	109	0	\N
93247	1397	1381734307000	10090	5172	110	0	\N
93248	1700	13207372964990	10090	5172	111	0	\N
93249	1700	9780614742484	10090	5172	112	0	\N
93250	1700	7468509433968	10090	5172	113	0	\N
93284	298	68001070000000	10093	5236	0	0	\N
93285	1695	8689341000000	10093	5236	1	0	\N
93286	558	66324884938283	10093	5236	2	0	\N
93287	1726	759422493000	10093	5236	3	0	\N
93288	1397	1381234257000	10093	5236	4	0	\N
93289	1397	1381224256000	10093	5236	5	0	\N
93290	1684	22831871236777	10093	5236	6	0	\N
93291	1684	22821707147738	10093	5236	8	0	\N
93292	1684	22811543058699	10093	5236	9	0	\N
93293	1684	22806456014180	10093	5236	10	0	\N
93294	1684	22801368969661	10093	5236	11	0	\N
93295	1684	22796281925142	10093	5236	12	0	\N
93296	1684	22791194880623	10093	5236	13	0	\N
93253	1726	759432494000	10091	5235	2	0	2712
93254	1397	1381244258000	10091	5235	3	0	5759
93255	1684	25512630743041	10091	5235	4	0	48
93256	1684	25177535804758	10091	5235	5	0	49
93257	1684	24842440866475	10091	5235	6	0	50
93259	1684	24172250989909	10091	5235	8	0	52
93260	1684	23837156051626	10091	5235	9	0	53
93261	1684	23502061113343	10091	5235	10	0	54
93262	1684	23166966175060	10091	5235	11	0	55
93263	298	68001070000000	10092	5236	0	0	4
93265	558	66324884938283	10092	5236	2	0	2
93266	1726	759422493000	10092	5236	3	0	2713
93267	1397	1381234257000	10092	5236	4	0	5760
93268	1397	1381224256000	10092	5236	5	0	5761
93270	1684	22821707147738	10092	5236	8	0	57
93271	1684	22811543058699	10092	5236	9	0	58
93272	1684	22806456014180	10092	5236	10	0	59
93273	1684	22801368969661	10092	5236	11	0	60
93274	1684	22796281925142	10092	5236	12	0	61
93276	1684	20183184880623	10092	5236	14	0	63
93277	1684	15510174880623	10092	5236	15	0	64
93278	1684	12357164880623	10092	5236	16	0	65
93279	1684	3571154880623	10092	5236	17	0	66
93280	1729	13924679000000	10092	5236	18	0	1
93282	1729	8178207000000	10092	5236	20	0	3
93283	1729	1726706000000	10092	5236	21	0	4
93297	1684	20183184880623	10093	5236	14	0	\N
93298	1684	15510174880623	10093	5236	15	0	\N
93299	1684	12357164880623	10093	5236	16	0	\N
93300	1684	3571154880623	10093	5236	17	0	\N
93301	1729	13924679000000	10093	5236	18	0	\N
93302	1729	10493378000000	10093	5236	19	0	\N
93303	1729	8178207000000	10093	5236	20	0	\N
93304	1729	1726706000000	10093	5236	21	0	\N
93305	298	68001070000000	10094	5236	0	0	\N
93306	1695	8689341000000	10094	5236	1	0	\N
93307	558	66324884938283	10094	5236	2	0	\N
93308	1726	759422493000	10094	5236	3	0	\N
93309	1397	1381234257000	10094	5236	4	0	\N
93310	1397	1381224256000	10094	5236	5	0	\N
93311	1684	22831871236777	10094	5236	6	0	\N
93312	1684	22821707147738	10094	5236	8	0	\N
93313	1684	22811543058699	10094	5236	9	0	\N
93314	1684	22806456014180	10094	5236	10	0	\N
93315	1684	22801368969661	10094	5236	11	0	\N
93316	1684	22796281925142	10094	5236	12	0	\N
93317	1684	22791194880623	10094	5236	13	0	\N
93318	1684	20183184880623	10094	5236	14	0	\N
93319	1684	15510174880623	10094	5236	15	0	\N
93320	1684	12357164880623	10094	5236	16	0	\N
93321	1684	3571154880623	10094	5236	17	0	\N
93322	1729	13924679000000	10094	5236	18	0	\N
93323	1729	10493378000000	10094	5236	19	0	\N
93324	1729	8178207000000	10094	5236	20	0	\N
93325	1729	1726706000000	10094	5236	21	0	\N
93326	298	68001070000000	10095	5236	0	0	\N
93327	1695	8689341000000	10095	5236	1	0	\N
93328	558	66324884938283	10095	5236	2	0	\N
93329	1726	759422493000	10095	5236	3	0	\N
93330	1397	1381234257000	10095	5236	4	0	\N
93331	1397	1381224256000	10095	5236	5	0	\N
93332	1684	22831871236777	10095	5236	6	0	\N
93333	1684	22821707147738	10095	5236	8	0	\N
93334	1684	22811543058699	10095	5236	9	0	\N
93335	1684	22806456014180	10095	5236	10	0	\N
93336	1684	22801368969661	10095	5236	11	0	\N
93337	1684	22796281925142	10095	5236	12	0	\N
93338	1684	22791194880623	10095	5236	13	0	\N
93339	1684	20183184880623	10095	5236	14	0	\N
93340	1684	15510174880623	10095	5236	15	0	\N
93341	1684	12357164880623	10095	5236	16	0	\N
93342	1684	3571154880623	10095	5236	17	0	\N
93343	1729	13924679000000	10095	5236	18	0	\N
93344	1729	10493378000000	10095	5236	19	0	\N
93345	1729	8178207000000	10095	5236	20	0	\N
93346	1729	1726706000000	10095	5236	21	0	\N
93351	1695	6381241000000	10097	5237	0	0	\N
93352	1695	2961141000000	10097	5237	1	0	\N
93353	1695	1052041000000	10097	5237	2	0	\N
93354	1397	1381214255000	10097	5237	3	0	\N
93376	1397	1381114245000	10104	5243	0	0	\N
93377	1727	1626595000000	10104	5243	1	0	\N
93380	1397	1381114245000	10106	5243	0	0	\N
93381	1727	1626595000000	10106	5243	1	0	\N
93382	1397	1381104244000	10107	5244	0	0	\N
93383	1439	11436824998477	10107	5244	1	0	\N
93384	1727	1626486000000	10107	5244	2	0	\N
93395	1397	1381094243000	10111	5245	0	0	\N
93396	1397	1381084242000	10111	5245	1	0	\N
93397	1726	759412492000	10111	5245	2	0	\N
93398	1596	9344601022416	10111	5245	3	0	\N
93399	1596	5423120583183	10111	5245	4	0	\N
93400	1596	2777217963415	10111	5245	5	0	\N
93401	1596	588879152658	10111	5245	6	0	\N
93402	298	68001070000000	10112	5209	0	0	\N
93403	1695	8689341000000	10112	5209	1	0	\N
93404	298	66000970000000	10112	5209	2	0	\N
93405	311	66000950000000	10112	5209	3	0	\N
93406	1695	6381241000000	10112	5209	4	0	\N
93407	1695	2961141000000	10112	5209	5	0	\N
93408	1695	1052041000000	10112	5209	6	0	\N
93409	1607	16508018724978	10112	5209	7	0	\N
93410	1727	1626595000000	10112	5209	8	0	\N
93411	1439	12960257000000	10112	5209	9	0	\N
93412	1439	12960246998477	10112	5209	10	0	\N
93413	1439	11436824998477	10112	5209	11	0	\N
93414	1423	3336987230768	10112	5209	12	0	\N
93415	1423	3073894461536	10112	5209	13	0	\N
93416	1684	40926997904059	10112	5209	14	0	\N
93417	1684	40591902965776	10112	5209	15	0	\N
93418	1684	40256808027493	10112	5209	16	0	\N
93419	1684	39921713089210	10112	5209	17	0	\N
93420	58	86880854999659	10112	5209	18	0	\N
93421	1727	1626486000000	10112	5209	19	0	\N
93422	1703	1753580000000	10112	5209	20	0	\N
93423	58	86539694999659	10112	5209	21	0	\N
93424	1423	2810801692304	10112	5209	22	0	\N
93425	1423	2547708923072	10112	5209	23	0	\N
93426	1726	770672529000	10112	5209	24	0	\N
93427	1726	770662528000	10112	5209	25	0	\N
93428	1423	2284616153840	10112	5209	26	0	\N
93429	1423	2021523384608	10112	5209	27	0	\N
93430	1423	1758430615376	10112	5209	28	0	\N
93431	1423	1495337846144	10112	5209	29	0	\N
93432	1423	1232245076912	10112	5209	30	0	\N
93349	1695	1052041000000	10096	5237	2	0	5
93350	1397	1381214255000	10096	5237	3	0	5762
93355	558	66029784938283	10098	5238	0	0	3
93356	1397	1381204254000	10098	5238	1	0	5763
93357	1651	19834721632047	10098	5238	2	0	1
93359	1397	1381194253000	10099	5239	1	0	5764
93360	1397	1381184252000	10099	5239	2	0	5765
93361	1607	2829391564834	10099	5239	3	0	8
93362	1651	19486999345179	10099	5239	4	0	2
93363	1439	12960257000000	10099	5239	5	0	1
93365	1607	2417963644388	10099	5239	7	0	9
93366	1397	1381174251000	10099	5239	8	0	5766
93367	1397	1381164250000	10099	5239	9	0	5767
93368	1397	1381154249000	10101	5240	0	0	5768
93370	1439	12960246998477	10103	5242	0	0	2
93371	1397	1381134247000	10103	5242	1	0	5770
93372	1397	1381124246000	10103	5242	2	0	5771
93373	1651	5843070678379	10103	5242	3	0	4
93374	1651	2646781839253	10103	5242	4	0	5
93378	1397	1381114245000	10105	5243	0	0	5772
93379	1727	1626595000000	10105	5243	1	0	6
93385	1397	1381104244000	10109	5244	0	0	5773
93386	1439	11436824998477	10109	5244	1	0	3
93387	1727	1626486000000	10109	5244	2	0	7
93389	1397	1381084242000	10110	5245	1	0	5775
93390	1726	759412492000	10110	5245	2	0	2714
93391	1596	9344601022416	10110	5245	3	0	7
93392	1596	5423120583183	10110	5245	4	0	8
93394	1596	588879152658	10110	5245	6	0	10
93433	1423	969152307680	10112	5209	31	0	\N
93434	1684	39586618150927	10112	5209	32	0	\N
93435	1684	39251523212644	10112	5209	33	0	\N
93436	1684	38916428274361	10112	5209	34	0	\N
93437	1684	38581333336078	10112	5209	35	0	\N
93438	1684	38246238397795	10112	5209	36	0	\N
93439	1684	37911143459512	10112	5209	37	0	\N
93440	1684	37576048521229	10112	5209	38	0	\N
93441	1684	37240953582946	10112	5209	39	0	\N
93442	1684	36905858644663	10112	5209	40	0	\N
93443	1684	36570763706380	10112	5209	41	0	\N
93444	1684	36235668768097	10112	5209	42	0	\N
93445	1684	35900573829814	10112	5209	43	0	\N
93446	1684	35565478891531	10112	5209	44	0	\N
93447	1684	35230383953248	10112	5209	45	0	\N
93448	1684	34895289014965	10112	5209	46	0	\N
93449	1684	34560194076682	10112	5209	47	0	\N
93450	1684	34225099138399	10112	5209	48	0	\N
93451	1684	33890004200116	10112	5209	49	0	\N
93452	1684	33554909261833	10112	5209	50	0	\N
93453	1684	33219814323550	10112	5209	51	0	\N
93454	1684	32884719385267	10112	5209	52	0	\N
93455	1684	32549624446984	10112	5209	53	0	\N
93456	1684	32214529508701	10112	5209	54	0	\N
93457	1684	31879434570418	10112	5209	55	0	\N
93458	1684	31544339632135	10112	5209	56	0	\N
93459	1684	31209244693852	10112	5209	57	0	\N
93460	1684	30874149755569	10112	5209	58	0	\N
93461	1684	30539054817286	10112	5209	59	0	\N
93462	1423	706059538448	10112	5209	60	0	\N
93463	1397	1381634297000	10112	5209	61	0	\N
93464	1397	1381624296000	10112	5209	62	0	\N
93465	1397	1381614295000	10112	5209	63	0	\N
93466	1397	1381604294000	10112	5209	64	0	\N
93467	1397	1381594293000	10112	5209	65	0	\N
93468	1397	1381584292000	10112	5209	66	0	\N
93469	1397	1381574291000	10112	5209	67	0	\N
93470	1397	1381564290000	10112	5209	68	0	\N
93471	1397	1381554289000	10112	5209	69	0	\N
93472	1397	1381544288000	10112	5209	70	0	\N
93473	1397	1381534287000	10112	5209	71	0	\N
93474	1397	1381524286000	10112	5209	72	0	\N
93475	1397	1381514285000	10112	5209	73	0	\N
93476	1397	1381504284000	10112	5209	74	0	\N
93477	1397	1381494283000	10112	5209	75	0	\N
93478	1397	1381484282000	10112	5209	76	0	\N
93479	1397	1381474281000	10112	5209	77	0	\N
93480	1397	1381464280000	10112	5209	78	0	\N
93481	1726	770652527000	10112	5209	79	0	\N
93482	1726	770642526000	10112	5209	80	0	\N
93483	1726	770632525000	10112	5209	81	0	\N
93484	1726	770622524000	10112	5209	82	0	\N
93485	1726	770612523000	10112	5209	83	0	\N
93486	1726	770602522000	10112	5209	84	0	\N
93487	1726	770592521000	10112	5209	85	0	\N
93488	1726	769382521000	10112	5209	86	0	\N
93489	1726	768172521000	10112	5209	87	0	\N
93490	1726	766962521000	10112	5209	88	0	\N
93491	1726	765752521000	10112	5209	89	0	\N
93492	1726	764542521000	10112	5209	90	0	\N
93493	1726	764532520000	10112	5209	91	0	\N
93494	1726	764522519000	10112	5209	92	0	\N
93495	1726	764512518000	10112	5209	93	0	\N
93496	1726	764502517000	10112	5209	94	0	\N
93497	1726	764492516000	10112	5209	95	0	\N
93498	1726	763282516000	10112	5209	96	0	\N
93499	1726	763272515000	10112	5209	97	0	\N
93500	1726	762062515000	10112	5209	98	0	\N
93501	1726	762052514000	10112	5209	99	0	\N
93502	1726	762042513000	10112	5209	100	0	\N
93503	1726	762032512000	10112	5209	101	0	\N
93504	1726	762022511000	10112	5209	102	0	\N
93505	1726	762012510000	10112	5209	103	0	\N
93506	1726	762002509000	10112	5209	104	0	\N
93507	1726	761992508000	10112	5209	105	0	\N
93508	1726	761982507000	10112	5209	106	0	\N
93509	1726	760772507000	10112	5209	107	0	\N
93510	1726	760762506000	10112	5209	108	0	\N
93511	1726	760752505000	10112	5209	109	0	\N
93512	1726	760742504000	10112	5209	110	0	\N
93513	1726	760732503000	10112	5209	111	0	\N
93514	1726	760722502000	10112	5209	112	0	\N
93515	1726	760712501000	10112	5209	113	0	\N
93516	1726	760702500000	10112	5209	115	0	\N
93517	1726	760692499000	10112	5209	116	0	\N
93518	1726	759482499000	10112	5209	117	0	\N
93519	1726	759472498000	10112	5209	118	0	\N
93520	1726	759462497000	10112	5209	119	0	\N
93521	1726	759452496000	10112	5209	120	0	\N
93522	1726	759442495000	10112	5209	121	0	\N
93523	1726	759432494000	10112	5209	122	0	\N
93524	1726	759422493000	10112	5209	123	0	\N
93525	1726	759412492000	10112	5209	124	0	\N
93526	1397	1381454279000	10112	5209	125	0	\N
93538	1726	759402491000	10114	5246	0	0	\N
93539	1397	1381074241000	10114	5246	1	0	\N
93540	1726	759392490000	10114	5246	2	0	\N
93541	1397	1381064240000	10114	5246	3	0	\N
93542	1439	9594868998477	10114	5246	4	0	\N
93543	1439	6864917998477	10114	5246	5	0	\N
93544	1439	1732162998477	10114	5246	6	0	\N
93545	1719	14462199000000	10114	5246	7	0	\N
93546	1719	10704108000000	10114	5246	8	0	\N
93547	1719	8168447000000	10114	5246	9	0	\N
93548	1719	1102626000000	10114	5246	10	0	\N
93567	1397	1381024236000	10118	5250	0	0	\N
93568	1726	755722486000	10118	5250	1	0	\N
93529	1726	759392490000	10113	5246	2	0	2716
93530	1397	1381064240000	10113	5246	3	0	5777
93531	1439	9594868998477	10113	5246	4	0	4
93532	1439	6864917998477	10113	5246	5	0	5
93533	1439	1732162998477	10113	5246	6	0	6
93535	1719	10704108000000	10113	5246	8	0	2
93536	1719	8168447000000	10113	5246	9	0	3
93537	1719	1102626000000	10113	5246	10	0	4
93549	1397	1381054239000	10115	5247	0	0	5778
93550	1703	720570000000	10115	5247	1	0	3
93552	1726	758172489000	10115	5247	3	0	2718
93553	1726	756962489000	10115	5247	4	0	2719
93554	1768	17996311110000	10116	5248	0	0	1
93555	1768	17995211110000	10116	5248	1	0	2
93557	1726	755752489000	10116	5248	3	0	2720
93558	1726	755742488000	10116	5248	4	0	2721
93559	149	71399817000341	10116	5248	5	0	2
93560	149	69380037000341	10116	5248	6	0	3
93561	149	67709537000341	10116	5248	7	0	4
93563	1719	0	10116	5248	9	0	5
93564	2003	1384970654821	10117	5249	0	0	1
93565	1397	1381034237000	10117	5249	1	0	5780
93566	1726	755732487000	10117	5249	2	0	2722
93569	1726	754512486000	10118	5250	2	0	\N
93570	1397	1381024236000	10119	5250	0	0	\N
93571	1726	755722486000	10119	5250	1	0	\N
93572	1726	754512486000	10119	5250	2	0	\N
93576	1768	10697911110000	10121	5251	0	0	\N
93577	1768	6816111110000	10121	5251	1	0	\N
93578	1768	4197311110000	10121	5251	2	0	\N
93579	1768	2030611110000	10121	5251	3	0	\N
93580	1397	1381014235000	10121	5251	4	0	\N
93581	1397	1381004234000	10121	5251	5	0	\N
93582	1397	1380994233000	10121	5251	6	0	\N
93583	1726	754502485000	10121	5251	7	0	\N
93584	1726	754492484000	10121	5251	8	0	\N
93585	1726	754482483000	10121	5251	9	0	\N
93586	1397	1380984232000	10121	5251	10	0	\N
93587	1726	754472482000	10121	5251	11	0	\N
93588	1419	23522740649627	10121	5251	12	0	\N
93602	1768	17996311110000	10123	5210	0	0	\N
93603	1768	17995211110000	10123	5210	1	0	\N
93604	1768	10697911110000	10123	5210	2	0	\N
93605	1768	6816111110000	10123	5210	3	0	\N
93606	1768	4197311110000	10123	5210	4	0	\N
93607	1768	2030611110000	10123	5210	5	0	\N
93608	1397	1381444278000	10123	5210	6	0	\N
93609	1726	759402491000	10123	5210	7	0	\N
93610	1397	1381434277000	10123	5210	8	0	\N
93611	149	74393317000341	10123	5210	9	0	\N
93612	149	71399817000341	10123	5210	10	0	\N
93613	149	69380037000341	10123	5210	11	0	\N
93614	149	67709537000341	10123	5210	12	0	\N
93615	1726	759392490000	10123	5210	13	0	\N
93616	1419	23522740649627	10123	5210	14	0	\N
93617	1439	9594868998477	10123	5210	15	0	\N
93618	1439	6864917998477	10123	5210	16	0	\N
93619	1439	1732162998477	10123	5210	17	0	\N
93620	1397	1381424276000	10123	5210	18	0	\N
93621	1397	1381414275000	10123	5210	19	0	\N
93622	1397	1381404274000	10123	5210	20	0	\N
93623	1397	1381394273000	10123	5210	21	0	\N
93624	1397	1381384272000	10123	5210	22	0	\N
93625	1397	1381374271000	10123	5210	23	0	\N
93626	1397	1381364270000	10123	5210	24	0	\N
93627	1397	1381354269000	10123	5210	25	0	\N
93628	1397	1381344268000	10123	5210	26	0	\N
93629	1397	1381334267000	10123	5210	27	0	\N
93630	1397	1381324266000	10123	5210	28	0	\N
93631	1397	1381314265000	10123	5210	29	0	\N
93632	1397	1381304264000	10123	5210	30	0	\N
93633	1397	1381294263000	10123	5210	31	0	\N
93634	1397	1381284262000	10123	5210	32	0	\N
93635	1397	1381274261000	10123	5210	33	0	\N
93636	1397	1381264260000	10123	5210	34	0	\N
93637	1397	1381254259000	10123	5210	35	0	\N
93638	1397	1381244258000	10123	5210	36	0	\N
93639	1397	1381234257000	10123	5210	37	0	\N
93640	1397	1381224256000	10123	5210	38	0	\N
93641	1703	720570000000	10123	5210	39	0	\N
93642	1607	11118761966447	10123	5210	40	0	\N
93643	1607	7482519790139	10123	5210	41	0	\N
93644	1607	4475103246618	10123	5210	42	0	\N
93645	1607	4063675326172	10123	5210	43	0	\N
93646	1607	3652247405726	10123	5210	44	0	\N
93647	1607	3240819485280	10123	5210	45	0	\N
93648	1607	2829391564834	10123	5210	46	0	\N
93649	1607	2417963644388	10123	5210	47	0	\N
93650	58	77783824999659	10123	5210	48	0	\N
93651	58	73126854999659	10123	5210	49	0	\N
93652	58	69984694999659	10123	5210	50	0	\N
93653	1397	1381214255000	10123	5210	51	0	\N
93654	1397	1381204254000	10123	5210	52	0	\N
93655	1397	1381194253000	10123	5210	53	0	\N
93656	1397	1381184252000	10123	5210	54	0	\N
93657	1397	1381174251000	10123	5210	55	0	\N
93658	1397	1381164250000	10123	5210	56	0	\N
93659	1397	1381154249000	10123	5210	57	0	\N
93660	1397	1381144248000	10123	5210	58	0	\N
93661	1397	1381134247000	10123	5210	59	0	\N
93662	1397	1381124246000	10123	5210	60	0	\N
93663	1397	1381114245000	10123	5210	61	0	\N
93664	1397	1381104244000	10123	5210	62	0	\N
93665	1397	1381094243000	10123	5210	63	0	\N
93666	1397	1381084242000	10123	5210	64	0	\N
93667	1397	1381074241000	10123	5210	65	0	\N
93668	1397	1381064240000	10123	5210	66	0	\N
93669	1397	1381054239000	10123	5210	67	0	\N
93670	1397	1381044238000	10123	5210	68	0	\N
93671	1397	1381034237000	10123	5210	69	0	\N
93672	1397	1381024236000	10123	5210	70	0	\N
93673	1397	1381014235000	10123	5210	71	0	\N
93674	1397	1381004234000	10123	5210	72	0	\N
93675	1397	1380994233000	10123	5210	73	0	\N
93676	1397	1380984232000	10123	5210	74	0	\N
93677	1397	1380974231000	10123	5210	75	0	\N
93678	1702	151000000	10123	5210	76	0	\N
93679	1684	30203959879003	10123	5210	77	0	\N
93680	1684	29868864940720	10123	5210	78	0	\N
93681	1684	29533770002437	10123	5210	79	0	\N
93682	1684	29198675064154	10123	5210	80	0	\N
93683	1684	28863580125871	10123	5210	81	0	\N
93684	1684	28528485187588	10123	5210	82	0	\N
93685	1684	28193390249305	10123	5210	83	0	\N
93686	1684	27858295311022	10123	5210	84	0	\N
93687	1684	27523200372739	10123	5210	85	0	\N
93688	1684	27188105434456	10123	5210	86	0	\N
93689	1684	26853010496173	10123	5210	87	0	\N
93690	1684	26517915557890	10123	5210	88	0	\N
93691	1684	26182820619607	10123	5210	89	0	\N
93692	1684	25847725681324	10123	5210	90	0	\N
93693	1684	25512630743041	10123	5210	91	0	\N
93694	1684	25177535804758	10123	5210	92	0	\N
93695	1684	24842440866475	10123	5210	93	0	\N
93696	1684	24507345928192	10123	5210	94	0	\N
93697	1684	24172250989909	10123	5210	95	0	\N
93698	1684	23837156051626	10123	5210	96	0	\N
93699	1684	23502061113343	10123	5210	97	0	\N
93700	1684	23166966175060	10123	5210	98	0	\N
93701	1684	22831871236777	10123	5210	99	0	\N
93702	1684	22821707147738	10123	5210	100	0	\N
93703	1684	22811543058699	10123	5210	101	0	\N
93704	1684	22806456014180	10123	5210	102	0	\N
93575	1726	754512486000	10120	5250	2	0	2724
93589	1768	10697911110000	10122	5251	0	0	3
93590	1768	6816111110000	10122	5251	1	0	4
93591	1768	4197311110000	10122	5251	2	0	5
93592	1768	2030611110000	10122	5251	3	0	6
93594	1397	1381004234000	10122	5251	5	0	5783
93595	1397	1380994233000	10122	5251	6	0	5784
93596	1726	754502485000	10122	5251	7	0	2725
93597	1726	754492484000	10122	5251	8	0	2726
93598	1726	754482483000	10122	5251	9	0	2727
93600	1726	754472482000	10122	5251	11	0	2728
93601	1419	23522740649627	10122	5251	12	0	1
93705	1684	22801368969661	10123	5210	103	0	\N
93706	1684	22796281925142	10123	5210	104	0	\N
93707	1684	22791194880623	10123	5210	105	0	\N
93708	1684	20183184880623	10123	5210	106	0	\N
93709	1684	15510174880623	10123	5210	107	0	\N
93710	1684	12357164880623	10123	5210	108	0	\N
93711	58	67385914999659	10123	5210	109	0	\N
93712	1726	759382489000	10123	5210	110	0	\N
93713	1726	758172489000	10123	5210	111	0	\N
93714	1726	756962489000	10123	5210	112	0	\N
93715	1726	755752489000	10123	5210	113	0	\N
93716	1726	755742488000	10123	5210	115	0	\N
93717	1726	755732487000	10123	5210	116	0	\N
93718	1726	755722486000	10123	5210	117	0	\N
93719	1726	754512486000	10123	5210	118	0	\N
93720	1726	754502485000	10123	5210	119	0	\N
93721	1726	754492484000	10123	5210	120	0	\N
93722	1726	754482483000	10123	5210	121	0	\N
93723	1726	754472482000	10123	5210	122	0	\N
93724	1726	754462481000	10123	5210	123	0	\N
93725	1596	9344601022416	10123	5210	124	0	\N
93726	1596	5423120583183	10123	5210	125	0	\N
93729	1726	754462481000	10125	5252	0	0	\N
93730	1397	1380974231000	10125	5252	1	0	\N
93731	1726	754462481000	10126	5252	0	0	\N
93732	1397	1380974231000	10126	5252	1	0	\N
93737	1397	1380954229000	10128	5254	0	0	\N
93738	1726	753232479000	10129	5254	0	0	\N
93739	1397	1380954229000	10129	5254	1	0	\N
93742	2008	0	10131	5255	0	0	\N
93743	1419	1900817280064	10131	5255	1	0	\N
93744	1397	1380944228000	10131	5255	2	0	\N
93745	2008	0	10132	5255	0	0	\N
93746	1726	753222478000	10132	5255	1	0	\N
93747	1419	1900817280064	10132	5255	2	0	\N
93748	1397	1380944228000	10132	5255	3	0	\N
93762	298	68001070000000	10137	5028	0	0	\N
93763	1762	9547480000000	10137	5028	1	0	\N
93764	1695	8689341000000	10137	5028	2	0	\N
93765	298	66000970000000	10137	5028	3	0	\N
93766	1768	17996311110000	10137	5028	4	0	\N
93767	1768	17995211110000	10137	5028	5	0	\N
93768	1768	10697911110000	10137	5028	6	0	\N
93769	1762	6293310000000	10137	5028	7	0	\N
93770	311	66000950000000	10137	5028	8	0	\N
93771	1762	10109360000000	10137	5028	9	0	\N
93772	1768	6816111110000	10137	5028	10	0	\N
93773	1695	6381241000000	10137	5028	11	0	\N
93774	1695	2961141000000	10137	5028	12	0	\N
93775	1695	1052041000000	10137	5028	13	0	\N
93776	149	72612047000000	10137	5028	14	0	\N
93777	641	82988672000000	10137	5028	15	0	\N
93778	1607	15787998724978	10137	5028	16	0	\N
93779	1727	906575000000	10137	5028	17	0	\N
93780	1439	12240230000000	10137	5028	18	0	\N
93781	1439	12240219998477	10137	5028	19	0	\N
93782	1439	10716797998477	10137	5028	20	0	\N
93783	1423	3336987230768	10137	5028	21	0	\N
93784	1423	3073894461536	10137	5028	23	0	\N
93785	149	69618547000000	10137	5028	24	0	\N
93786	149	67598767000000	10137	5028	25	0	\N
93787	1684	40206975904059	10137	5028	26	0	\N
93788	1684	39871880965776	10137	5028	27	0	\N
93789	1684	39536786027493	10137	5028	28	0	\N
93790	1684	39201691089210	10137	5028	29	0	\N
93791	58	86880854999659	10137	5028	30	0	\N
93792	1727	906466000000	10137	5028	31	0	\N
93793	1703	1033540000000	10137	5028	32	0	\N
93794	641	80013406000000	10137	5028	33	0	\N
93795	641	69989484000000	10137	5028	34	0	\N
93796	58	86539694999659	10137	5028	35	0	\N
93797	1423	2810801692304	10137	5028	36	0	\N
93798	1423	2547708923072	10137	5028	37	0	\N
93799	641	66391490000000	10137	5028	38	0	\N
93800	1423	2284616153840	10137	5028	39	0	\N
93801	1423	2021523384608	10137	5028	40	0	\N
93802	1423	1758430615376	10137	5028	41	0	\N
93803	1423	1495337846144	10137	5028	42	0	\N
93804	1423	1232245076912	10137	5028	43	0	\N
93805	1423	969152307680	10137	5028	44	0	\N
93806	1419	22802679649627	10137	5028	45	0	\N
93807	1419	21000842927387	10137	5028	46	0	\N
93808	1419	1180756280064	10137	5028	47	0	\N
93809	1684	38866596150927	10137	5028	48	0	\N
93810	1684	38531501212644	10137	5028	49	0	\N
93811	1684	38196406274361	10137	5028	50	0	\N
93812	1684	37861311336078	10137	5028	51	0	\N
93813	1684	37526216397795	10137	5028	52	0	\N
93814	1684	37191121459512	10137	5028	53	0	\N
93815	1684	36856026521229	10137	5028	54	0	\N
93816	1684	36520931582946	10137	5028	55	0	\N
93817	1684	36185836644663	10137	5028	56	0	\N
93818	1684	35850741706380	10137	5028	57	0	\N
93819	1684	35515646768097	10137	5028	58	0	\N
93820	1684	35180551829814	10137	5028	59	0	\N
93821	1684	34845456891531	10137	5028	60	0	\N
93822	1684	34510361953248	10137	5028	61	0	\N
93823	1684	34175267014965	10137	5028	62	0	\N
93824	1684	33840172076682	10137	5028	63	0	\N
93825	1684	33505077138399	10137	5028	64	0	\N
93826	1684	33169982200116	10137	5028	65	0	\N
93827	1684	32834887261833	10137	5028	66	0	\N
93828	1684	32499792323550	10137	5028	67	0	\N
93829	1684	32164697385267	10137	5028	68	0	\N
93830	1684	31829602446984	10137	5028	69	0	\N
93831	1684	31494507508701	10137	5028	70	0	\N
93832	1684	31159412570418	10137	5028	71	0	\N
93833	1684	30824317632135	10137	5028	72	0	\N
93834	1684	30489222693852	10137	5028	73	0	\N
93835	1684	30154127755569	10137	5028	74	0	\N
93836	1684	29819032817286	10137	5028	75	0	\N
93837	1439	8874841998477	10137	5028	76	0	\N
93838	1439	6144890998477	10137	5028	77	0	\N
93839	1439	1012135998477	10137	5028	78	0	\N
93840	1423	706059538448	10137	5028	79	0	\N
93733	1419	21720903927387	10127	5253	0	0	2
93734	1726	754452480000	10127	5253	1	0	2730
93735	1397	1380964230000	10127	5253	2	0	5787
93736	1726	753242480000	10127	5253	3	0	2731
93740	1726	753232479000	10130	5254	0	0	2732
93749	2008	0	10133	5255	0	0	1
93750	1726	753222478000	10133	5255	1	0	2733
93751	1419	1900817280064	10133	5255	2	0	3
93752	1762	19626660000000	10134	5256	0	0	1
93753	1726	753212477000	10134	5256	1	0	2734
93755	1397	1380944228000	10134	5256	3	0	5789
93756	1397	1380934227000	10134	5256	4	0	5790
93757	1397	1380924226000	10134	5256	5	0	5791
93758	1762	16372490000000	10136	5257	0	0	2
93760	1762	2481680000000	10136	5257	2	0	4
93761	1726	753192475000	10136	5257	3	0	2736
93841	1703	530000000	10137	5028	80	0	\N
93842	1607	10398741966447	10137	5028	81	0	\N
93843	1607	6762499790139	10137	5028	82	0	\N
93844	1607	3755083246618	10137	5028	83	0	\N
93845	1607	3343655326172	10137	5028	84	0	\N
93846	1607	2932227405726	10137	5028	85	0	\N
93847	1607	2520799485280	10137	5028	86	0	\N
93848	1607	2109371564834	10137	5028	87	0	\N
93849	1607	1697943644388	10137	5028	88	0	\N
93850	58	77783824999659	10137	5028	89	0	\N
93851	58	73126854999659	10137	5028	90	0	\N
93852	58	69984694999659	10137	5028	91	0	\N
93853	1602	8376370000000	10137	5028	92	0	\N
93854	1602	6391360000000	10137	5028	93	0	\N
93855	1602	861350000000	10137	5028	94	0	\N
93856	1602	0	10137	5028	95	0	\N
93857	1423	442966769216	10137	5028	96	0	\N
93858	1423	179873999984	10137	5028	97	0	\N
93859	1672	9041683000000	10137	5028	98	0	\N
93860	1397	1383854519000	10137	5028	99	0	\N
93861	1397	1383844518000	10137	5028	100	0	\N
93862	1397	1383834517000	10137	5028	101	0	\N
93863	1702	151000000	10137	5028	102	0	\N
93864	1684	29483937879003	10137	5028	103	0	\N
93865	1684	29148842940720	10137	5028	104	0	\N
93866	1684	28813748002437	10137	5028	105	0	\N
93867	1684	28478653064154	10137	5028	106	0	\N
93868	1684	28143558125871	10137	5028	107	0	\N
93869	1684	27808463187588	10137	5028	108	0	\N
93870	1684	27473368249305	10137	5028	109	0	\N
93871	1684	27138273311022	10137	5028	110	0	\N
93872	1684	26803178372739	10137	5028	111	0	\N
93873	1684	26468083434456	10137	5028	112	0	\N
93874	1684	26132988496173	10137	5028	113	0	\N
93875	1684	25797893557890	10137	5028	114	0	\N
93876	1684	25462798619607	10137	5028	115	0	\N
93877	1684	25127703681324	10137	5028	116	0	\N
93878	1684	24792608743041	10137	5028	117	0	\N
93879	1684	24457513804758	10137	5028	118	0	\N
93880	1684	24122418866475	10137	5028	119	0	\N
93881	1684	23787323928192	10137	5028	120	0	\N
93882	1684	23452228989909	10137	5028	121	0	\N
93883	1684	23117134051626	10137	5028	122	0	\N
93884	1684	22782039113343	10137	5028	123	0	\N
93885	1684	22446944175060	10137	5028	124	0	\N
93886	1684	22111849236777	10137	5028	125	0	\N
93887	1762	19626660000000	10138	5256	0	0	\N
93888	1726	753212477000	10138	5256	1	0	\N
93889	1726	753202476000	10138	5256	2	0	\N
93890	1397	1380944228000	10138	5256	3	0	\N
93891	1397	1380934227000	10138	5256	4	0	\N
93892	1397	1380924226000	10138	5256	5	0	\N
93893	1762	16372490000000	10139	5257	0	0	\N
93894	1762	11549540000000	10139	5257	1	0	\N
93895	1762	2481680000000	10139	5257	2	0	\N
93896	1726	753192475000	10139	5257	3	0	\N
93897	724	20001150000000	10140	5029	0	0	\N
93898	498	66001250000000	10140	5029	1	0	\N
93899	1981	100900000000	10140	5029	2	0	\N
93900	596	81618162000000	10140	5029	3	0	\N
93901	596	77533062000000	10140	5029	4	0	\N
93902	596	74775962000000	10140	5029	5	0	\N
93903	596	67094862000000	10140	5029	6	0	\N
93904	1727	11976585000000	10140	5029	7	0	\N
93905	1710	13833317340144	10140	5029	8	0	\N
93906	1710	10238531520848	10140	5029	9	0	\N
93907	1710	7813025369394	10140	5029	10	0	\N
93908	1710	1054315473290	10140	5029	11	0	\N
93909	1564	7843257000000	10140	5029	12	0	\N
93910	1564	4738242000000	10140	5029	13	0	\N
93911	1564	2643227000000	10140	5029	14	0	\N
93912	1564	548212000000	10140	5029	15	0	\N
93913	1564	545112000000	10140	5029	16	0	\N
93914	1397	1384124546000	10140	5029	17	0	\N
93915	1449	3043000459	10140	5029	18	0	\N
93916	1444	19439533000000	10140	5029	19	0	\N
93917	1671	12797614237287	10140	5029	20	0	\N
93927	1397	1380874221000	10144	5260	0	0	\N
93928	1726	753142470000	10144	5260	1	0	\N
93931	1397	1380874221000	10146	5260	0	0	\N
93932	1726	753142470000	10146	5260	1	0	\N
93933	1726	753132469000	10147	5261	0	0	\N
93934	1397	1380864220000	10147	5261	1	0	\N
93935	1726	753132469000	10148	5261	0	0	\N
93936	1397	1380864220000	10148	5261	1	0	\N
93937	1726	753132469000	10149	5261	0	0	\N
93938	1397	1380864220000	10149	5261	1	0	\N
93941	1397	1380854219000	10151	5262	0	0	\N
93942	1726	753122468000	10151	5262	1	0	\N
93947	1397	1380844218000	10154	5263	0	0	\N
93948	1726	753112467000	10154	5263	1	0	\N
93949	1726	753102466000	10155	5264	0	0	\N
93950	1397	1380834217000	10155	5264	1	0	\N
93951	1397	1380824216000	10155	5264	2	0	\N
93952	1726	753092465000	10155	5264	3	0	\N
93957	1726	753082464000	10157	5265	0	0	\N
93958	1397	1380814215000	10157	5265	1	0	\N
93961	1726	753082464000	10159	5265	0	0	\N
93962	1397	1380814215000	10159	5265	1	0	\N
93963	1726	753082464000	10160	5265	0	0	\N
93964	1397	1380814215000	10160	5265	1	0	\N
93967	1397	1380804214000	10162	5266	0	0	\N
93968	1726	753072463000	10162	5266	1	0	\N
93969	171	79165121590727	10163	5267	0	0	\N
93970	1726	753062462000	10163	5267	1	0	\N
93971	1397	1380794213000	10163	5267	2	0	\N
93972	171	75661520312938	10163	5267	3	0	\N
93973	1705	20719609242793	10163	5267	4	0	\N
93974	171	73297567463829	10163	5267	5	0	\N
93975	1705	20714872856220	10163	5267	6	0	\N
93976	1705	19530143600955	10163	5267	7	0	\N
93920	1754	6995000000	10142	5258	2	0	4
93921	1397	1380904224000	10143	5259	0	0	5793
93922	1397	1380894223000	10143	5259	1	0	5794
93923	1397	1380884222000	10143	5259	2	0	5795
93924	1726	753172473000	10143	5259	3	0	2738
93926	1726	753152471000	10143	5259	5	0	2740
93929	1397	1380874221000	10145	5260	0	0	5796
93930	1726	753142470000	10145	5260	1	0	2741
93939	1726	753132469000	10150	5261	0	0	2742
93940	1397	1380864220000	10150	5261	1	0	5797
93944	1726	753122468000	10152	5262	1	0	2743
93945	1397	1380844218000	10153	5263	0	0	5799
93946	1726	753112467000	10153	5263	1	0	2744
93953	1726	753102466000	10156	5264	0	0	2745
93955	1397	1380824216000	10156	5264	2	0	5801
93956	1726	753092465000	10156	5264	3	0	2746
93959	1726	753082464000	10158	5265	0	0	2747
93960	1397	1380814215000	10158	5265	1	0	5802
93965	1397	1380804214000	10161	5266	0	0	5803
93977	1705	17407126846190	10163	5267	8	0	\N
93978	1705	15974681884856	10163	5267	9	0	\N
93979	1705	11983064500065	10163	5267	10	0	\N
93980	171	66710220524688	10163	5267	11	0	\N
93995	1726	753042460000	10166	5269	0	0	\N
93996	1397	1380774211000	10166	5269	1	0	\N
93997	1726	753042460000	10167	5269	0	0	\N
93998	1397	1380774211000	10167	5269	1	0	\N
94001	1726	753042460000	10169	5269	0	0	\N
94002	1397	1380774211000	10169	5269	1	0	\N
94003	1726	753042460000	10170	5269	0	0	\N
94004	1397	1380774211000	10170	5269	1	0	\N
94005	1397	1380764210000	10171	5270	0	0	\N
94006	1726	753032459000	10171	5270	1	0	\N
94029	1397	1380734207000	10176	5273	0	0	\N
94030	1726	753002456000	10176	5273	1	0	\N
94031	1726	752992455000	10178	5275	0	0	\N
94032	1726	752982454000	10178	5275	1	0	\N
94033	1397	1380724206000	10178	5275	2	0	\N
94034	1397	1380714205000	10178	5275	3	0	\N
94035	1726	752992455000	10179	5275	0	0	\N
94036	1726	752982454000	10179	5275	1	0	\N
94037	1397	1380724206000	10179	5275	2	0	\N
94038	1397	1380714205000	10179	5275	3	0	\N
94039	1726	752992455000	10180	5275	0	0	\N
94040	1726	752982454000	10180	5275	1	0	\N
94041	1397	1380724206000	10180	5275	2	0	\N
94042	1397	1380714205000	10180	5275	3	0	\N
94047	1726	752992455000	10182	5275	0	0	\N
94048	1726	752982454000	10182	5275	1	0	\N
94049	1397	1380724206000	10182	5275	2	0	\N
94050	1397	1380714205000	10182	5275	3	0	\N
94051	1726	752992455000	10183	5275	0	0	\N
94052	1726	752982454000	10183	5275	1	0	\N
94053	1397	1380724206000	10183	5275	2	0	\N
94054	1397	1380714205000	10183	5275	3	0	\N
94055	1726	752992455000	10184	5275	0	0	\N
94056	1726	752982454000	10184	5275	1	0	\N
94057	1397	1380724206000	10184	5275	2	0	\N
94058	1397	1380704204000	10185	5276	0	0	\N
94059	1726	752972453000	10185	5276	1	0	\N
94062	1397	1380704204000	10187	5276	0	0	\N
94063	1726	752972453000	10187	5276	1	0	\N
94064	1726	752962452000	10188	5277	0	0	\N
94065	1726	752952451000	10188	5277	1	0	\N
94066	1726	751742451000	10188	5277	2	0	\N
94067	1397	1380694203000	10188	5277	3	0	\N
94068	1397	1380684202000	10188	5277	4	0	\N
94069	1726	752962452000	10189	5277	0	0	\N
94070	1726	752952451000	10189	5277	1	0	\N
94071	1726	751742451000	10189	5277	2	0	\N
94072	1397	1380694203000	10189	5277	3	0	\N
94073	1397	1380684202000	10189	5277	4	0	\N
94079	1871	718910000000	10191	5278	0	0	\N
94080	1726	751732450000	10191	5278	1	0	\N
94081	1726	751722449000	10191	5278	2	0	\N
94082	1397	1380674201000	10191	5278	3	0	\N
94083	1726	751712448000	10191	5278	4	0	\N
94084	1397	1380664200000	10191	5278	5	0	\N
94085	1397	1380654199000	10191	5278	6	0	\N
94097	1397	1380644198000	10194	5279	0	0	\N
94098	1397	1380634197000	10194	5279	1	0	\N
94099	1726	751702447000	10194	5279	2	0	\N
94100	1726	751692446000	10194	5279	3	0	\N
94101	1397	1380644198000	10195	5279	0	0	\N
94102	1397	1380634197000	10195	5279	1	0	\N
94103	1726	751702447000	10195	5279	2	0	\N
94104	1726	751692446000	10195	5279	3	0	\N
94105	1726	751682445000	10196	5280	0	0	\N
94106	1397	1380624196000	10196	5280	1	0	\N
94109	1726	751682445000	10198	5280	0	0	\N
94110	1397	1380624196000	10198	5280	1	0	\N
93983	1397	1380794213000	10164	5267	2	0	5804
93984	171	75661520312938	10164	5267	3	0	2
93985	1705	20719609242793	10164	5267	4	0	3
93986	171	73297567463829	10164	5267	5	0	3
93987	1705	20714872856220	10164	5267	6	0	4
93989	1705	17407126846190	10164	5267	8	0	6
93990	1705	15974681884856	10164	5267	9	0	7
93991	1705	11983064500065	10164	5267	10	0	8
93992	171	66710220524688	10164	5267	11	0	4
93993	1397	1380784212000	10165	5268	0	0	5805
93999	1726	753042460000	10168	5269	0	0	2751
94000	1397	1380774211000	10168	5269	1	0	5806
94007	1397	1380764210000	10172	5270	0	0	5807
94008	1726	753032459000	10173	5271	0	0	2752
94010	1726	753022458000	10173	5271	2	0	2753
94011	1560	30492770553746	10173	5271	3	0	2
94012	1560	30024622107492	10173	5271	4	0	3
94013	1560	29556473661238	10173	5271	5	0	4
94014	1560	29088325214984	10173	5271	6	0	5
94016	1560	28152028322476	10173	5271	8	0	7
94017	1560	27683879876222	10173	5271	9	0	8
94018	1560	27215731429968	10173	5271	10	0	9
94019	1560	26747582983714	10173	5271	11	0	10
94020	1560	26279434537460	10173	5271	12	0	11
94022	1560	16822133409944	10173	5271	14	0	13
94023	1560	12726579794951	10173	5271	15	0	14
94024	1560	1313957277002	10173	5271	16	0	15
94025	1397	1380744208000	10174	5272	0	0	5809
94027	1397	1380734207000	10175	5273	0	0	5810
94028	1726	753002456000	10175	5273	1	0	2755
94043	1726	752992455000	10181	5275	0	0	2756
94044	1726	752982454000	10181	5275	1	0	2757
94045	1397	1380724206000	10181	5275	2	0	5811
94060	1397	1380704204000	10186	5276	0	0	5813
94061	1726	752972453000	10186	5276	1	0	2758
94074	1726	752962452000	10190	5277	0	0	2759
94075	1726	752952451000	10190	5277	1	0	2760
94076	1726	751742451000	10190	5277	2	0	2761
94078	1397	1380684202000	10190	5277	4	0	5815
94086	1871	718910000000	10192	5278	0	0	1
94087	1726	751732450000	10192	5278	1	0	2762
94088	1726	751722449000	10192	5278	2	0	2763
94090	1726	751712448000	10192	5278	4	0	2764
94091	1397	1380664200000	10192	5278	5	0	5817
94092	1397	1380654199000	10192	5278	6	0	5818
94093	1397	1380644198000	10193	5279	0	0	5819
94094	1397	1380634197000	10193	5279	1	0	5820
94096	1726	751692446000	10193	5279	3	0	2766
94107	1726	751682445000	10197	5280	0	0	2767
94108	1397	1380624196000	10197	5280	1	0	5821
94111	1397	1380614195000	10199	5281	0	0	5822
94112	1726	751672444000	10199	5281	1	0	2768
94115	1726	751652442000	10201	5283	0	0	\N
94116	1397	1380594193000	10201	5283	1	0	\N
94121	1726	751642441000	10204	5284	0	0	\N
94122	1397	1380584192000	10204	5284	1	0	\N
94125	1397	1380574191000	10206	5285	0	0	\N
94126	1726	751632440000	10206	5285	1	0	\N
94129	1397	1380564190000	10208	5286	0	0	\N
94130	1726	751622439000	10208	5286	1	0	\N
94131	1726	751612438000	10209	5287	0	0	\N
94132	1397	1380554189000	10209	5287	1	0	\N
94133	1726	750402438000	10209	5287	2	0	\N
94137	1726	750392437000	10212	5288	0	0	\N
94138	1726	750382436000	10212	5288	1	0	\N
94139	1726	750372435000	10212	5288	2	0	\N
94140	1397	1380544188000	10212	5288	3	0	\N
94141	1397	1380534187000	10212	5288	4	0	\N
94142	1397	1380524186000	10212	5288	5	0	\N
94149	1726	750392437000	10214	5288	0	0	\N
94150	1726	750382436000	10214	5288	1	0	\N
94151	1726	750372435000	10214	5288	2	0	\N
94152	1397	1380544188000	10214	5288	3	0	\N
94153	1397	1380534187000	10214	5288	4	0	\N
94154	1397	1380524186000	10214	5288	5	0	\N
94157	1726	750362434000	10216	5289	0	0	\N
94158	1397	1380514185000	10216	5289	1	0	\N
94165	1397	1380484182000	10220	5291	0	0	\N
94166	1726	750332431000	10220	5291	1	0	\N
94167	1397	1380484182000	10221	5291	0	0	\N
94168	1726	750332431000	10221	5291	1	0	\N
94169	1871	718910000000	10223	5029	0	0	\N
94170	171	79165121590727	10223	5029	1	0	\N
94171	171	75661520312938	10223	5029	2	0	\N
94172	1705	19999589242793	10223	5029	3	0	\N
94173	171	73297567463829	10223	5029	4	0	\N
94174	1705	19994852856220	10223	5029	5	0	\N
94175	1705	18810123600955	10223	5029	6	0	\N
94176	1705	16687106846190	10223	5029	7	0	\N
94177	1684	22101685147738	10223	5029	8	0	\N
94178	1684	22091521058699	10223	5029	9	0	\N
94179	1705	15254661884856	10223	5029	10	0	\N
94180	1705	11263044500065	10223	5029	11	0	\N
94181	171	66710220524688	10223	5029	12	0	\N
94182	1684	22086434014180	10223	5029	13	0	\N
94183	1684	22081346969661	10223	5029	14	0	\N
94184	1684	22076259925142	10223	5029	15	0	\N
94185	1684	22071172880623	10223	5029	16	0	\N
94186	1684	19463162880623	10223	5029	17	0	\N
94187	1397	1383824516000	10223	5029	18	0	\N
94188	1397	1383814515000	10223	5029	19	0	\N
94189	1397	1383804514000	10223	5029	20	0	\N
94190	1397	1383794513000	10223	5029	21	0	\N
94191	1397	1383784512000	10223	5029	23	0	\N
94192	1397	1383774511000	10223	5029	24	0	\N
94193	1397	1383764510000	10223	5029	25	0	\N
94194	1397	1383754509000	10223	5029	26	0	\N
94195	1397	1383744508000	10223	5029	27	0	\N
94196	1397	1383734507000	10223	5029	28	0	\N
94197	1397	1383724506000	10223	5029	29	0	\N
94198	1397	1383714505000	10223	5029	30	0	\N
94199	1397	1383704504000	10223	5029	31	0	\N
94200	1397	1383694503000	10223	5029	32	0	\N
94201	1397	1383684502000	10223	5029	33	0	\N
94202	1397	1383674501000	10223	5029	34	0	\N
94203	1397	1383664500000	10223	5029	35	0	\N
94204	1397	1383654499000	10223	5029	36	0	\N
94205	1397	1383644498000	10223	5029	37	0	\N
94206	1397	1383634497000	10223	5029	38	0	\N
94207	1397	1383624496000	10223	5029	39	0	\N
94208	1397	1383614495000	10223	5029	40	0	\N
94209	1397	1383604494000	10223	5029	41	0	\N
94210	1397	1383594493000	10223	5029	42	0	\N
94211	1397	1383584492000	10223	5029	43	0	\N
94212	1397	1383574491000	10223	5029	44	0	\N
94213	1397	1383564490000	10223	5029	45	0	\N
94214	1397	1383554489000	10223	5029	46	0	\N
94215	1397	1383544488000	10223	5029	47	0	\N
94216	1397	1383534487000	10223	5029	48	0	\N
94217	1397	1383524486000	10223	5029	49	0	\N
94218	1397	1383514485000	10223	5029	50	0	\N
94219	1397	1383504484000	10223	5029	51	0	\N
94220	1397	1383494483000	10223	5029	52	0	\N
94221	1397	1383484482000	10223	5029	53	0	\N
94222	1397	1383474481000	10223	5029	54	0	\N
94223	1397	1383464480000	10223	5029	55	0	\N
94224	1397	1383454479000	10223	5029	56	0	\N
94225	1397	1383444478000	10223	5029	57	0	\N
94226	1397	1383434477000	10223	5029	58	0	\N
94227	1397	1383424476000	10223	5029	59	0	\N
94228	1397	1383414475000	10223	5029	60	0	\N
94229	1726	750322430000	10224	5292	0	0	\N
94230	1726	750312429000	10224	5292	1	0	\N
94231	1726	750302428000	10224	5292	2	0	\N
94232	1397	1380474181000	10224	5292	3	0	\N
94233	1397	1380464180000	10224	5292	4	0	\N
94234	1397	1380454179000	10224	5292	5	0	\N
94244	1726	750282426000	10227	5293	0	0	\N
94245	1726	750282426000	10228	5293	0	0	\N
94117	1726	751652442000	10202	5283	0	0	2770
94118	1397	1380594193000	10202	5283	1	0	5824
94119	1726	751642441000	10203	5284	0	0	2771
94120	1397	1380584192000	10203	5284	1	0	5825
94123	1397	1380574191000	10205	5285	0	0	5826
94127	1397	1380564190000	10207	5286	0	0	5827
94128	1726	751622439000	10207	5286	1	0	2773
94134	1726	751612438000	10210	5287	0	0	2774
94135	1397	1380554189000	10210	5287	1	0	5828
94136	1726	750402438000	10210	5287	2	0	2775
94144	1726	750382436000	10213	5288	1	0	2777
94145	1726	750372435000	10213	5288	2	0	2778
94146	1397	1380544188000	10213	5288	3	0	5829
94147	1397	1380534187000	10213	5288	4	0	5830
94155	1726	750362434000	10215	5289	0	0	2779
94156	1397	1380514185000	10215	5289	1	0	5832
94159	1397	1380504184000	10218	5290	0	0	5833
94160	1726	750352433000	10218	5290	1	0	2780
94161	1726	750342432000	10218	5290	2	0	2781
94163	1397	1380484182000	10219	5291	0	0	5835
94164	1726	750332431000	10219	5291	1	0	2782
94235	1726	750322430000	10225	5292	0	0	2783
94236	1726	750312429000	10225	5292	1	0	2784
94237	1726	750302428000	10225	5292	2	0	2785
94239	1397	1380474181000	10225	5292	4	0	5836
94240	1397	1380464180000	10225	5292	5	0	5837
94241	1397	1380454179000	10225	5292	6	0	5838
94242	1397	1380444178000	10225	5292	7	0	5839
94246	1397	1380434177000	10229	5294	0	0	5840
94247	1397	1380424176000	10229	5294	1	0	5841
94248	1726	750272425000	10229	5294	2	0	2788
94250	724	20001150000000	10230	5007	0	0	\N
94251	498	66001250000000	10230	5007	1	0	\N
94252	298	68001070000000	10230	5007	2	0	\N
94253	1762	9547480000000	10230	5007	3	0	\N
94254	1695	8689341000000	10230	5007	4	0	\N
94255	298	66000970000000	10230	5007	5	0	\N
94256	1727	11976585000000	10230	5007	6	0	\N
94257	1768	17996311110000	10230	5007	7	0	\N
94258	1768	17995211110000	10230	5007	8	0	\N
94259	1768	10697911110000	10230	5007	9	0	\N
94260	1871	718910000000	10230	5007	10	0	\N
94261	1762	6293310000000	10230	5007	11	0	\N
94262	311	66000950000000	10230	5007	12	0	\N
94263	1762	10109360000000	10230	5007	13	0	\N
94264	1710	13833317340144	10230	5007	14	0	\N
94265	1710	10238531520848	10230	5007	16	0	\N
94266	1710	7813025369394	10230	5007	17	0	\N
94267	1710	1054315473290	10230	5007	18	0	\N
94268	1768	6816111110000	10230	5007	19	0	\N
94269	1695	6381241000000	10230	5007	20	0	\N
94270	1695	2961141000000	10230	5007	21	0	\N
94271	596	83898262000000	10230	5007	22	0	\N
94272	596	81618162000000	10230	5007	23	0	\N
94273	596	77533062000000	10230	5007	24	0	\N
94274	596	74775962000000	10230	5007	25	0	\N
94275	596	67094862000000	10230	5007	26	0	\N
94276	1695	1052041000000	10230	5007	27	0	\N
94277	1564	7843257000000	10230	5007	28	0	\N
94278	1564	4738242000000	10230	5007	29	0	\N
94279	1564	2643227000000	10230	5007	30	0	\N
94280	1564	548212000000	10230	5007	31	0	\N
94281	1564	545112000000	10230	5007	32	0	\N
94282	1449	3043000459	10230	5007	33	0	\N
94283	1444	19439533000000	10230	5007	34	0	\N
94284	1671	12797614237287	10230	5007	35	0	\N
94285	1668	21598630000000	10230	5007	36	0	\N
94286	1675	14332739999977	10230	5007	37	0	\N
94287	1675	10340729999977	10230	5007	38	0	\N
94288	1726	774422783000	10230	5007	39	0	\N
94289	1476	10732380000000	10230	5007	40	0	\N
94290	1522	15119950000000	10230	5007	41	0	\N
94291	1850	17975550000000	10230	5007	42	0	\N
94292	1672	16121683000000	10230	5007	43	0	\N
94293	1672	11464673000000	10230	5007	44	0	\N
94294	1727	8925465000000	10230	5007	45	0	\N
94295	1681	24072051210200	10230	5007	46	0	\N
94296	1444	11144865400000	10230	5007	47	0	\N
94297	1727	6866815000000	10230	5007	48	0	\N
94298	1476	6483370000000	10230	5007	49	0	\N
94299	1476	3616360000000	10230	5007	50	0	\N
94300	1476	1245350000000	10230	5007	51	0	\N
94301	1397	1384404574000	10230	5007	52	0	\N
94302	1397	1384394573000	10230	5007	53	0	\N
94303	149	71892027000000	10230	5007	54	0	\N
94304	1522	15119930000000	10230	5007	55	0	\N
94305	1522	15119910000000	10230	5007	56	0	\N
94306	1522	13113900000000	10230	5007	57	0	\N
94307	1522	9518890000000	10230	5007	58	0	\N
94308	641	82988672000000	10230	5007	59	0	\N
94309	1700	13207392964990	10230	5007	60	0	\N
94310	470	85440411000000	10230	5007	61	0	\N
94311	470	77147401000000	10230	5007	62	0	\N
94312	1607	15787998724978	10230	5007	63	0	\N
94313	1536	18409250000000	10230	5007	64	0	\N
94314	700	73198270000000	10230	5007	65	0	\N
94315	700	66001260000000	10230	5007	66	0	\N
94316	606	74773520563149	10230	5007	67	0	\N
94317	470	72736391000000	10230	5007	68	0	\N
94318	1979	16281874029894	10230	5007	69	0	\N
94319	1979	16240261610390	10230	5007	70	0	\N
94320	1979	14148574405003	10230	5007	71	0	\N
94321	1439	12240230000000	10230	5007	72	0	\N
94322	1439	12240219998477	10230	5007	73	0	\N
94323	1439	10716797998477	10230	5007	74	0	\N
94324	470	69760381000000	10230	5007	75	0	\N
94331	1455	17820231000000	10232	5296	0	0	\N
94332	1397	1380384172000	10232	5296	1	0	\N
94333	1726	750222420000	10232	5296	2	0	\N
94337	1455	17820231000000	10234	5296	0	0	\N
94338	1397	1380384172000	10234	5296	1	0	\N
94339	1726	750222420000	10234	5296	2	0	\N
94340	1455	17820231000000	10235	5296	0	0	\N
94341	1397	1380384172000	10235	5296	1	0	\N
94342	1726	750222420000	10235	5296	2	0	\N
94345	1455	17820231000000	10238	5294	0	0	\N
94346	1397	1380434177000	10238	5294	1	0	\N
94347	1397	1380424176000	10238	5294	2	0	\N
94348	1397	1380414175000	10238	5294	3	0	\N
94349	1397	1380404174000	10238	5294	4	0	\N
94350	1397	1380394173000	10238	5294	5	0	\N
94351	1397	1380384172000	10238	5294	6	0	\N
94352	1397	1380374171000	10238	5294	7	0	\N
94353	1726	750272425000	10238	5294	8	0	\N
94354	1726	750262424000	10238	5294	9	0	\N
94355	1726	750252423000	10238	5294	10	0	\N
94356	1726	750242422000	10238	5294	11	0	\N
94357	1726	750232421000	10238	5294	12	0	\N
94358	1726	750222420000	10238	5294	13	0	\N
94359	1726	750202418000	10239	5298	0	0	\N
94360	1397	1380364170000	10239	5298	1	0	\N
94367	1397	1380354169000	10245	5299	0	0	\N
94368	1397	1380344168000	10245	5299	1	0	\N
94369	1726	750192417000	10245	5299	2	0	\N
94370	1726	750182416000	10245	5299	3	0	\N
94381	1455	17820231000000	10250	5176	0	0	\N
94382	298	68001070000000	10250	5176	1	0	\N
94383	1762	10267640000000	10250	5176	2	0	\N
94384	1695	8689341000000	10250	5176	3	0	\N
94326	1397	1380404174000	10231	5295	1	0	5843
94327	1397	1380394173000	10231	5295	2	0	5844
94328	1726	750252423000	10231	5295	3	0	2790
94329	1726	750242422000	10231	5295	4	0	2791
94330	1726	750232421000	10231	5295	5	0	2792
94335	1397	1380384172000	10233	5296	1	0	5845
94336	1726	750222420000	10233	5296	2	0	2793
94343	1397	1380374171000	10237	5297	0	0	5846
94344	1726	750212419000	10237	5297	1	0	2794
94361	1726	750202418000	10240	5298	0	0	2795
94363	1397	1380354169000	10242	5299	0	0	5848
94364	1397	1380344168000	10242	5299	1	0	5849
94365	1726	750192417000	10242	5299	2	0	2796
94366	1726	750182416000	10242	5299	3	0	2797
94372	1726	750172415000	10247	5300	1	0	2798
94373	1726	750162414000	10248	5301	0	0	2799
94374	1726	750152413000	10248	5301	1	0	2800
94375	1726	750142412000	10248	5301	2	0	2801
94376	1397	1380324166000	10248	5301	3	0	5851
94378	1397	1380304164000	10248	5301	5	0	5853
94379	1397	1380294163000	10249	5302	0	0	5854
94380	1726	750132411000	10249	5302	1	0	2802
94385	298	66000970000000	10250	5176	4	0	\N
94386	1768	17996311110000	10250	5176	5	0	\N
94387	1768	17995211110000	10250	5176	6	0	\N
94388	1768	10697911110000	10250	5176	7	0	\N
94389	1871	718910000000	10250	5176	8	0	\N
94390	1762	7013470000000	10250	5176	9	0	\N
94391	311	66000950000000	10250	5176	10	0	\N
94392	1762	10829520000000	10250	5176	11	0	\N
94393	1768	6816111110000	10250	5176	12	0	\N
94394	1695	6381241000000	10250	5176	13	0	\N
94395	1695	2961141000000	10250	5176	14	0	\N
94396	1695	1052041000000	10250	5176	15	0	\N
94397	171	79165121590727	10250	5176	16	0	\N
94398	1651	10480721632047	10250	5176	17	0	\N
94399	149	73332127000341	10250	5176	18	0	\N
94400	1651	10132999345179	10250	5176	19	0	\N
94401	1607	15787998724978	10250	5176	20	0	\N
94402	1727	906575000000	10250	5176	21	0	\N
94403	1439	12960257000000	10250	5176	22	0	\N
94404	1439	12960246998477	10250	5176	23	0	\N
94405	1439	11436824998477	10250	5176	24	0	\N
94406	1651	1226274162690	10250	5176	25	0	\N
94407	149	70338627000341	10250	5176	26	0	\N
94408	149	68318847000341	10250	5176	27	0	\N
94434	1397	1380204154000	10254	5305	0	0	\N
94435	1726	748832402000	10254	5305	1	0	\N
94445	1726	747612401000	10259	5307	0	0	\N
94446	1397	1380184152000	10259	5307	1	0	\N
94447	1397	1380174151000	10259	5307	2	0	\N
94448	1726	747602400000	10259	5307	3	0	\N
94449	1726	747592399000	10259	5307	4	0	\N
94450	1726	747612401000	10260	5307	0	0	\N
94451	1397	1380184152000	10260	5307	1	0	\N
94452	1397	1380174151000	10260	5307	2	0	\N
94453	1726	747602400000	10260	5307	3	0	\N
94454	1726	747592399000	10260	5307	4	0	\N
94455	1397	1380164150000	10261	5308	0	0	\N
94456	1397	1380154149000	10261	5308	1	0	\N
94457	1726	747582398000	10261	5308	2	0	\N
94458	1726	747572397000	10261	5308	3	0	\N
94463	1397	1380164150000	10263	5308	0	0	\N
94464	1397	1380154149000	10263	5308	1	0	\N
94465	1726	747582398000	10263	5308	2	0	\N
94466	1726	747572397000	10263	5308	3	0	\N
94477	1455	15407131000000	10266	5310	0	0	\N
94478	1455	11082031000000	10266	5310	1	0	\N
94479	1455	8163931000000	10266	5310	2	0	\N
94480	1455	33831000000	10266	5310	3	0	\N
94481	1726	747552395000	10266	5310	4	0	\N
94482	1726	747542394000	10266	5310	5	0	\N
94483	1397	1380134147000	10266	5310	6	0	\N
94484	1397	1380124146000	10266	5310	7	0	\N
94487	1397	1380114145000	10268	5311	0	0	\N
94488	1726	747532393000	10268	5311	1	0	\N
94517	1547	12220263000000	10277	5319	0	0	\N
94518	1726	747432383000	10277	5319	1	0	\N
94519	1726	747422382000	10277	5319	3	0	\N
94520	1397	1380014135000	10277	5319	4	0	\N
94411	1726	748902409000	10252	5303	2	0	2805
94412	1726	748892408000	10252	5303	3	0	2806
94413	1397	1380284162000	10252	5303	4	0	5855
94414	1397	1380274161000	10252	5303	5	0	5856
94415	1397	1380264160000	10252	5303	6	0	5857
94417	1448	15083299992378	10253	5304	1	0	2
94418	1448	14836898742069	10253	5304	2	0	3
94419	1448	14590497491760	10253	5304	3	0	4
94420	1448	12713517100219	10253	5304	4	0	5
94421	1448	9349992292575	10253	5304	5	0	6
94423	1397	1380254159000	10253	5304	7	0	5858
94424	1397	1380244158000	10253	5304	8	0	5859
94425	1397	1380234157000	10253	5304	9	0	5860
94426	1726	748882407000	10253	5304	10	0	2807
94428	1397	1380224156000	10253	5304	12	0	5861
94429	1397	1380214155000	10253	5304	13	0	5862
94430	1726	748872406000	10253	5304	14	0	2808
94431	1726	748862405000	10253	5304	15	0	2809
94432	1726	748852404000	10253	5304	16	0	2810
94436	1397	1380204154000	10255	5305	0	0	5863
94437	1726	748832402000	10255	5305	1	0	2812
94438	1397	1380194153000	10256	5306	0	0	5864
94439	1726	748822401000	10256	5306	1	0	2813
94440	1726	747612401000	10258	5307	0	0	2814
94442	1397	1380174151000	10258	5307	2	0	5866
94443	1726	747602400000	10258	5307	3	0	2815
94444	1726	747592399000	10258	5307	4	0	2816
94459	1397	1380164150000	10262	5308	0	0	5867
94461	1726	747582398000	10262	5308	2	0	2817
94462	1726	747572397000	10262	5308	3	0	2818
94467	1726	747562396000	10264	5309	0	0	2819
94468	1397	1380144148000	10264	5309	1	0	5869
94469	1455	15407131000000	10265	5310	0	0	2
94471	1455	8163931000000	10265	5310	2	0	4
94472	1455	33831000000	10265	5310	3	0	5
94473	1726	747552395000	10265	5310	4	0	2820
94474	1726	747542394000	10265	5310	5	0	2821
94475	1397	1380134147000	10265	5310	6	0	5870
94485	1397	1380114145000	10267	5311	0	0	5872
94486	1726	747532393000	10267	5311	1	0	2822
94489	1397	1380104144000	10269	5312	0	0	5873
94490	1726	747522392000	10269	5312	1	0	2823
94492	1397	1380094143000	10270	5313	1	0	5874
94493	1726	747502390000	10271	5314	0	0	2825
94494	1397	1380084142000	10271	5314	1	0	5875
94495	1726	747492389000	10272	5315	0	0	2826
94496	1397	1380074141000	10272	5315	1	0	5876
94498	1397	1380064140000	10273	5316	1	0	5877
94499	1397	1380054139000	10274	5317	0	0	5878
94500	1726	747472387000	10274	5317	1	0	2828
94501	1724	18954022200000	10274	5317	2	0	4
94502	1547	13679283000000	10275	5318	0	0	1
94504	1397	1380034137000	10275	5318	2	0	5880
94505	1397	1380024136000	10275	5318	3	0	5881
94506	1596	720020000000	10275	5318	4	0	11
94507	1726	747462386000	10275	5318	5	0	2829
94509	1726	747442384000	10275	5318	7	0	2831
94510	1547	12220263000000	10276	5319	0	0	2
94511	1726	747432383000	10276	5319	1	0	2832
94512	1726	747422382000	10276	5319	3	0	2833
94513	1397	1380014135000	10276	5319	4	0	5882
94515	1397	1379994133000	10276	5319	6	0	5884
94516	1726	747412381000	10276	5319	7	0	2834
94521	1397	1380004134000	10277	5319	5	0	\N
94522	1397	1379994133000	10277	5319	6	0	\N
94523	1726	747412381000	10277	5319	7	0	\N
94524	1547	12220263000000	10278	5319	0	0	\N
94525	1726	747432383000	10278	5319	1	0	\N
94526	1726	747422382000	10278	5319	3	0	\N
94527	1397	1380014135000	10278	5319	4	0	\N
94528	1397	1380004134000	10278	5319	5	0	\N
94529	1397	1379994133000	10278	5319	6	0	\N
94530	1726	747412381000	10278	5319	7	0	\N
94531	1547	12220263000000	10279	5319	0	0	\N
94532	1726	747432383000	10279	5319	1	0	\N
94533	1726	747422382000	10279	5319	3	0	\N
94534	1397	1380014135000	10279	5319	4	0	\N
94535	1397	1380004134000	10279	5319	5	0	\N
94536	1397	1379994133000	10279	5319	6	0	\N
94537	1726	747412381000	10279	5319	7	0	\N
94538	1547	12220263000000	10280	5319	0	0	\N
94539	1726	747432383000	10280	5319	1	0	\N
94540	1726	747422382000	10280	5319	3	0	\N
94541	1397	1380014135000	10280	5319	4	0	\N
94542	1397	1380004134000	10280	5319	5	0	\N
94543	1397	1379994133000	10280	5319	6	0	\N
94544	1726	747412381000	10280	5319	7	0	\N
94558	1726	747372377000	10283	5322	0	0	\N
94559	1693	6502660053757	10283	5322	1	0	\N
94560	1726	747372377000	10284	5322	0	0	\N
94561	1693	6502660053757	10284	5322	1	0	\N
94562	1397	1379954129000	10284	5322	2	0	\N
94566	1397	1379944128000	10286	5323	0	0	\N
94567	1724	15756449000000	10286	5323	1	0	\N
94568	1724	11017618600000	10286	5323	2	0	\N
94569	1726	747362376000	10286	5323	3	0	\N
94574	1397	1379944128000	10288	5323	0	0	\N
94575	1724	15756449000000	10288	5323	1	0	\N
94576	1724	11017618600000	10288	5323	2	0	\N
94577	1726	747362376000	10288	5323	3	0	\N
94578	1397	1379944128000	10289	5323	0	0	\N
94579	1724	15756449000000	10289	5323	1	0	\N
94580	1726	747362376000	10289	5323	2	0	\N
94584	1547	7840223000000	10291	5324	0	0	\N
94585	1397	1379934127000	10291	5324	1	0	\N
94586	1726	747352375000	10291	5324	2	0	\N
94590	1547	2924203000000	10293	5326	0	0	\N
94591	1726	747332373000	10293	5326	1	0	\N
94592	1726	747322372000	10293	5326	2	0	\N
94593	1397	1379914125000	10293	5326	3	0	\N
94594	1397	1379904124000	10293	5326	4	0	\N
94595	1547	2924203000000	10294	5326	0	0	\N
94596	1726	747332373000	10294	5326	1	0	\N
94597	1726	747322372000	10294	5326	2	0	\N
94598	1397	1379914125000	10294	5326	3	0	\N
94599	1397	1379904124000	10294	5326	4	0	\N
94605	1726	747312371000	10296	5327	0	0	\N
94606	1397	1379894123000	10296	5327	1	0	\N
94609	1726	747312371000	10298	5327	0	0	\N
94610	1397	1379894123000	10298	5327	1	0	\N
94621	1726	747272367000	10301	5329	0	0	\N
94622	1726	746062367000	10301	5329	1	0	\N
94623	1397	1379854119000	10301	5329	2	0	\N
94635	1397	1379814115000	10306	5332	0	0	\N
94636	1673	22703821000000	10306	5332	1	0	\N
94637	1726	746022363000	10306	5332	2	0	\N
94638	1726	746012362000	10306	5332	3	0	\N
94639	1724	2109261000000	10306	5332	4	0	\N
94640	1397	1379804114000	10306	5332	5	0	\N
94641	1397	1379814115000	10307	5332	0	0	\N
94642	1673	22703821000000	10307	5332	1	0	\N
94643	1726	746022363000	10307	5332	2	0	\N
94644	1726	746012362000	10307	5332	3	0	\N
94645	1724	2109261000000	10307	5332	4	0	\N
94646	1397	1379804114000	10307	5332	5	0	\N
94647	1397	1379814115000	10308	5332	0	0	\N
94648	1673	22703821000000	10308	5332	1	0	\N
94649	1726	746022363000	10308	5332	2	0	\N
94650	1726	746012362000	10308	5332	3	0	\N
94651	1397	1379804114000	10308	5332	4	0	\N
94652	1397	1379814115000	10309	5332	0	0	\N
94653	1673	22703821000000	10309	5332	1	0	\N
94654	1726	746022363000	10309	5332	2	0	\N
94655	1726	746012362000	10309	5332	3	0	\N
94656	1397	1379804114000	10309	5332	4	0	\N
94547	1547	10455243000000	10282	5321	0	0	3
94548	1397	1379974131000	10282	5321	1	0	5886
94549	1397	1379964130000	10282	5321	2	0	5887
94550	1705	12511449945944	10282	5321	3	0	9
94551	1705	12505631323105	10282	5321	4	0	10
94553	1705	8434563926145	10282	5321	6	0	12
94554	1705	6671557050657	10282	5321	7	0	13
94555	1705	1758799500145	10282	5321	8	0	14
94556	1726	747392379000	10282	5321	9	0	2836
94557	1726	747382378000	10282	5321	10	0	2837
94564	1693	6502660053757	10285	5322	1	0	563
94565	1397	1379954129000	10285	5322	2	0	5888
94570	1397	1379944128000	10287	5323	0	0	5889
94571	1724	15756449000000	10287	5323	1	0	5
94573	1726	747362376000	10287	5323	3	0	2839
94581	1547	7840223000000	10290	5324	0	0	4
94582	1397	1379934127000	10290	5324	1	0	5890
94583	1726	747352375000	10290	5324	2	0	2840
94587	344	66000090000000	10292	5325	0	0	1
94589	1726	747342374000	10292	5325	2	0	2841
94600	1547	2924203000000	10295	5326	0	0	5
94601	1726	747332373000	10295	5326	1	0	2842
94602	1726	747322372000	10295	5326	2	0	2843
94603	1397	1379914125000	10295	5326	3	0	5892
94607	1726	747312371000	10297	5327	0	0	2844
94608	1397	1379894123000	10297	5327	1	0	5894
94611	1547	2733183000000	10299	5328	0	0	6
94612	1726	747302370000	10299	5328	1	0	2845
94614	1397	1379884122000	10299	5328	3	0	5895
94615	1726	747282368000	10299	5328	4	0	2847
94616	1397	1379874121000	10299	5328	5	0	5896
94617	1397	1379864120000	10299	5328	6	0	5897
94618	1726	747272367000	10300	5329	0	0	2848
94620	1397	1379854119000	10300	5329	2	0	5898
94624	1726	746052366000	10303	5330	0	0	2850
94625	1397	1379844118000	10303	5330	1	0	5899
94626	1726	746042365000	10304	5331	0	0	2851
94627	1397	1379834117000	10304	5331	1	0	5900
94629	1726	746032364000	10304	5331	3	0	2852
94630	1397	1379814115000	10305	5332	0	0	5902
94631	1673	22703821000000	10305	5332	1	0	1
94632	1726	746022363000	10305	5332	2	0	2853
94634	1397	1379804114000	10305	5332	4	0	5903
94667	1726	745982359000	10313	5335	0	0	\N
94668	1397	1379774111000	10313	5335	1	0	\N
94669	1422	20160510000000	10313	5335	2	0	\N
94670	1726	745982359000	10314	5335	0	0	\N
94671	1397	1379774111000	10314	5335	1	0	\N
94672	1422	20160510000000	10314	5335	2	0	\N
94693	1773	6721874027010	10318	5338	0	0	\N
94694	1397	1379714105000	10318	5338	1	0	\N
94695	1397	1379704104000	10318	5338	2	0	\N
94696	1726	745922353000	10318	5338	3	0	\N
94697	1726	745912352000	10318	5338	4	0	\N
94698	1773	6642851411700	10318	5338	5	0	\N
94699	1773	5741550141990	10318	5338	6	0	\N
94700	1773	4126433908930	10318	5338	7	0	\N
94701	1773	3036679550220	10318	5338	8	0	\N
94702	1773	0	10318	5338	10	0	\N
94705	1726	745892350000	10320	5340	0	0	\N
94706	1726	745882349000	10320	5340	1	0	\N
94707	1397	1379684102000	10320	5340	2	0	\N
94708	1397	1379674101000	10320	5340	3	0	\N
94713	1726	745892350000	10322	5340	0	0	\N
94714	1726	745882349000	10322	5340	1	0	\N
94715	1397	1379684102000	10322	5340	2	0	\N
94716	1397	1379674101000	10322	5340	3	0	\N
94717	1726	745892350000	10323	5340	0	0	\N
94718	1726	745882349000	10323	5340	1	0	\N
94719	1397	1379684102000	10323	5340	2	0	\N
94720	1397	1379674101000	10323	5340	3	0	\N
94727	1397	1379654099000	10326	5342	0	0	\N
94728	1397	1379644098000	10326	5342	1	0	\N
94729	1726	745862347000	10326	5342	2	0	\N
94730	1726	745852346000	10326	5342	3	0	\N
94740	1714	17794507299806	10329	5344	0	0	\N
94741	1714	14280219598078	10329	5344	1	0	\N
94742	1714	4487523103056	10329	5344	2	0	\N
94743	1397	1379624096000	10329	5344	3	0	\N
94744	1726	745832344000	10329	5344	4	0	\N
94768	1397	1379524086000	10335	5349	0	0	\N
94769	1714	4485513103056	10335	5349	1	0	\N
94770	1726	745732334000	10335	5349	2	0	\N
94771	1397	1379514085000	10336	5350	0	0	\N
94772	1726	745722333000	10336	5350	1	0	\N
94781	1397	1379484082000	10340	5352	0	0	\N
94782	1726	745692330000	10340	5352	1	0	\N
94783	1397	1379474081000	10340	5352	2	0	\N
94786	1397	1379474081000	10342	5353	0	0	\N
94787	1726	745682329000	10342	5353	1	0	\N
94788	1397	1379474081000	10343	5353	0	0	\N
94789	1726	745682329000	10343	5353	1	0	\N
94790	1726	745672328000	10344	5354	0	0	\N
94791	1726	745662327000	10344	5354	1	0	\N
94792	1726	745652326000	10344	5354	2	0	\N
94659	1724	2109261000000	10310	5333	2	0	7
94660	1726	745992360000	10311	5334	0	0	2856
94661	1673	22366541000000	10311	5334	1	0	2
94662	1397	1379784112000	10311	5334	2	0	5905
94663	1422	20160511000000	10311	5334	3	0	1
94665	1397	1379774111000	10312	5335	1	0	5906
94666	1422	20160510000000	10312	5335	2	0	2
94673	1726	745972358000	10315	5336	0	0	2858
94674	1397	1379764110000	10315	5336	1	0	5907
94675	1397	1379754109000	10315	5336	2	0	5908
94677	1726	745952356000	10315	5336	4	0	2860
94678	1397	1379744108000	10315	5336	5	0	5909
94679	1726	745942355000	10316	5337	0	0	2861
94680	1726	745932354000	10316	5337	1	0	2862
94682	1397	1379724106000	10316	5337	3	0	5911
94683	1699	2733836050108	10316	5337	4	0	5
94684	1773	6721874027010	10317	5338	0	0	19
94685	1397	1379714105000	10317	5338	1	0	5912
94686	1397	1379704104000	10317	5338	2	0	5913
94688	1726	745912352000	10317	5338	4	0	2864
94689	1773	6642851411700	10317	5338	5	0	20
94690	1773	5741550141990	10317	5338	6	0	21
94691	1773	4126433908930	10317	5338	7	0	22
94692	1773	3036679550220	10317	5338	8	0	23
94704	1397	1379694103000	10319	5339	1	0	5914
94709	1726	745892350000	10321	5340	0	0	2866
94710	1726	745882349000	10321	5340	1	0	2867
94711	1397	1379684102000	10321	5340	2	0	5915
94721	1397	1379664100000	10324	5341	0	0	5917
94722	1726	745872348000	10324	5341	1	0	2868
94723	1397	1379654099000	10325	5342	0	0	5918
94724	1397	1379644098000	10325	5342	1	0	5919
94725	1726	745862347000	10325	5342	2	0	2869
94731	1714	23002972377216	10327	5343	0	0	3
94732	1397	1379634097000	10327	5343	1	0	5920
94733	1726	745842345000	10327	5343	2	0	2871
94734	112	66001269665601	10327	5343	3	0	4
94735	1714	17794507299806	10328	5344	0	0	4
94737	1714	4487523103056	10328	5344	2	0	6
94738	1397	1379624096000	10328	5344	3	0	5921
94739	1726	745832344000	10328	5344	4	0	2872
94745	1397	1379614095000	10330	5345	0	0	5922
94747	1726	745822343000	10330	5345	2	0	2873
94748	1726	745812342000	10330	5345	3	0	2874
94749	1958	885987000000	10330	5345	4	0	2
94750	1726	745802341000	10331	5346	0	0	2875
94751	1726	745792340000	10331	5346	1	0	2876
94753	1726	745772338000	10332	5347	1	0	2878
94754	1397	1379594093000	10332	5347	2	0	5924
94755	1397	1379584092000	10332	5347	3	0	5925
94756	1397	1379574091000	10332	5347	4	0	5926
94757	1397	1379564090000	10332	5347	5	0	5927
94759	1726	745762337000	10333	5348	1	0	2879
94760	1397	1379554089000	10333	5348	2	0	5928
94761	1397	1379544088000	10333	5348	3	0	5929
94762	1726	745752336000	10333	5348	4	0	2880
94764	1397	1379534087000	10333	5348	6	0	5930
94765	1397	1379524086000	10334	5349	0	0	5931
94766	1714	4485513103056	10334	5349	1	0	7
94767	1726	745732334000	10334	5349	2	0	2882
94773	1397	1379514085000	10337	5350	0	0	5932
94775	1397	1379504084000	10338	5351	0	0	5933
94776	1397	1379494083000	10338	5351	1	0	5934
94777	1726	745712332000	10338	5351	2	0	2884
94778	1726	745702331000	10338	5351	3	0	2885
94779	1397	1379484082000	10339	5352	0	0	5935
94784	1397	1379474081000	10341	5353	0	0	5936
94785	1726	745682329000	10341	5353	1	0	2887
94793	1397	1379464080000	10344	5354	3	0	\N
94794	1397	1379454079000	10344	5354	4	0	\N
94795	1397	1379444078000	10344	5354	5	0	\N
94804	1397	1379434077000	10347	5355	0	0	\N
94805	1726	745642325000	10347	5355	1	0	\N
94806	1397	1379424076000	10348	5356	0	0	\N
94807	1726	745632324000	10348	5356	1	0	\N
94810	1397	1379424076000	10350	5356	0	0	\N
94811	1726	745632324000	10350	5356	1	0	\N
94812	1726	745622323000	10350	5356	2	0	\N
94813	1397	1379414075000	10350	5356	3	0	\N
94818	1726	745622323000	10352	5357	0	0	\N
94819	1726	745612322000	10352	5357	1	0	\N
94820	1397	1379414075000	10352	5357	2	0	\N
94821	1397	1379404074000	10352	5357	3	0	\N
94822	1726	745602321000	10353	5358	0	0	\N
94823	1397	1379394073000	10353	5358	1	0	\N
94824	1726	745602321000	10354	5358	0	0	\N
94825	1397	1379394073000	10354	5358	1	0	\N
94828	1726	745592320000	10357	5359	0	0	\N
94829	1397	1379384072000	10357	5359	1	0	\N
94832	1726	745592320000	10360	5359	0	0	\N
94833	1397	1379384072000	10360	5359	1	0	\N
94840	1726	745572318000	10366	5361	0	0	\N
94841	1726	745562317000	10366	5361	1	0	\N
94842	1397	1379364070000	10366	5361	2	0	\N
94843	1397	1379354069000	10366	5361	3	0	\N
94844	333	66324984938283	10367	5362	0	0	\N
94845	1397	1379344068000	10367	5362	1	0	\N
94846	1726	745552316000	10367	5362	3	0	\N
94847	1726	745542315000	10367	5362	4	0	\N
94848	1397	1379334067000	10367	5362	5	0	\N
94854	333	66324984938283	10369	5362	0	0	\N
94855	1397	1379344068000	10369	5362	1	0	\N
94856	1726	745552316000	10369	5362	3	0	\N
94857	1726	745542315000	10369	5362	4	0	\N
94858	1397	1379334067000	10369	5362	5	0	\N
94861	1726	745532314000	10371	5363	0	0	\N
94862	1397	1379324066000	10371	5363	1	0	\N
94863	1726	745532314000	10372	5363	0	0	\N
94864	1397	1379324066000	10372	5363	1	0	\N
94865	1397	1379324066000	10373	5363	0	0	\N
94866	1726	745532314000	10374	5363	0	0	\N
94867	1397	1379324066000	10374	5363	1	0	\N
94868	1397	1379324066000	10375	5363	0	0	\N
94889	1650	11400330000000	10379	5366	0	0	\N
94890	1650	8608220000000	10379	5366	1	0	\N
94891	1650	6724110000000	10379	5366	2	0	\N
94892	1650	1474000000000	10379	5366	3	0	\N
94893	1726	745472308000	10379	5366	4	0	\N
94894	1397	1379254059000	10379	5366	5	0	\N
94895	1726	745462307000	10380	5367	0	0	\N
94896	1726	745452306000	10380	5367	1	0	\N
94897	1397	1379244058000	10380	5367	2	0	\N
94898	1397	1379234057000	10380	5367	3	0	\N
94906	333	66000084938283	10383	5368	0	0	\N
94907	1726	745442305000	10383	5368	1	0	\N
94910	1397	1379204054000	10385	5370	0	0	\N
94911	1726	745422303000	10385	5370	1	0	\N
94914	1650	12958440000000	10387	5295	0	0	\N
94915	1650	11400330000000	10387	5295	1	0	\N
94916	1650	8608220000000	10387	5295	2	0	\N
94917	1650	6724110000000	10387	5295	3	0	\N
94918	1650	1474000000000	10387	5295	4	0	\N
94919	333	66324984938283	10387	5295	5	0	\N
94920	333	66000084938283	10387	5295	6	0	\N
94921	1455	15407131000000	10387	5295	7	0	\N
94922	1714	22282912377216	10387	5295	8	0	\N
94923	1455	11082031000000	10387	5295	9	0	\N
94924	1455	8163931000000	10387	5295	11	0	\N
94925	1455	33831000000	10387	5295	12	0	\N
94926	1547	13679283000000	10387	5295	13	0	\N
94927	1714	17074447299806	10387	5295	14	0	\N
94928	1714	13560159598078	10387	5295	15	0	\N
94798	1726	745652326000	10345	5354	2	0	2890
94799	1397	1379464080000	10345	5354	3	0	5937
94800	1397	1379454079000	10345	5354	4	0	5938
94801	1397	1379444078000	10345	5354	5	0	5939
94802	1397	1379434077000	10346	5355	0	0	5940
94808	1397	1379424076000	10349	5356	0	0	5941
94809	1726	745632324000	10349	5356	1	0	2892
94814	1726	745622323000	10351	5357	0	0	2893
94815	1726	745612322000	10351	5357	1	0	2894
94816	1397	1379414075000	10351	5357	2	0	5942
94826	1726	745602321000	10355	5358	0	0	2895
94827	1397	1379394073000	10355	5358	1	0	5944
94830	1726	745592320000	10359	5359	0	0	2896
94831	1397	1379384072000	10359	5359	1	0	5945
94835	1397	1379374071000	10364	5360	1	0	5946
94836	1726	745572318000	10365	5361	0	0	2898
94837	1726	745562317000	10365	5361	1	0	2899
94838	1397	1379364070000	10365	5361	2	0	5947
94839	1397	1379354069000	10365	5361	3	0	5948
94850	1397	1379344068000	10368	5362	1	0	5949
94851	1726	745552316000	10368	5362	3	0	2900
94852	1726	745542315000	10368	5362	4	0	2901
94853	1397	1379334067000	10368	5362	5	0	5950
94859	1726	745532314000	10370	5363	0	0	2902
94869	1650	12958440000000	10376	5364	0	0	1
94870	1726	745522313000	10376	5364	1	0	2903
94871	1726	745512312000	10376	5364	2	0	2904
94872	1397	1379314065000	10376	5364	3	0	5952
94874	2002	0	10377	5365	0	0	1
94875	1726	745502311000	10377	5365	1	0	2905
94876	1397	1379294063000	10377	5365	2	0	5954
94877	1397	1379284062000	10377	5365	3	0	5955
94878	1397	1379274061000	10377	5365	4	0	5956
94880	1726	745492310000	10377	5365	6	0	2906
94881	1726	745482309000	10377	5365	7	0	2907
94882	1422	20152119623498	10377	5365	8	0	3
94883	1650	11400330000000	10378	5366	0	0	2
94884	1650	8608220000000	10378	5366	1	0	3
94886	1650	1474000000000	10378	5366	3	0	5
94887	1726	745472308000	10378	5366	4	0	2908
94888	1397	1379254059000	10378	5366	5	0	5958
94899	1726	745462307000	10381	5367	0	0	2909
94901	1397	1379244058000	10381	5367	2	0	5959
94902	1397	1379234057000	10381	5367	3	0	5960
94903	333	66000084938283	10382	5368	0	0	2
94904	1726	745442305000	10382	5368	1	0	2911
94905	1397	1379224056000	10382	5368	2	0	5961
94909	1726	745432304000	10384	5369	1	0	2912
94912	1397	1379204054000	10386	5370	0	0	5963
94913	1726	745422303000	10386	5370	1	0	2913
94929	1714	3767463103056	10387	5295	16	0	\N
94930	1547	12220263000000	10387	5295	17	0	\N
94931	1547	10455243000000	10387	5295	18	0	\N
94932	1547	7840223000000	10387	5295	19	0	\N
94933	1547	2924203000000	10387	5295	20	0	\N
94934	1547	2733183000000	10387	5295	21	0	\N
94935	2002	0	10387	5295	22	0	\N
94936	1448	15101975996189	10387	5295	23	0	\N
94937	1448	15083299992378	10387	5295	24	0	\N
94938	1448	14836898742069	10387	5295	25	0	\N
94939	1448	14590497491760	10387	5295	26	0	\N
94940	1448	12713517100219	10387	5295	27	0	\N
94941	1448	9349992292575	10387	5295	28	0	\N
94942	1448	7080551816496	10387	5295	29	0	\N
94943	1714	3765453103056	10387	5295	30	0	\N
94944	1693	6502660053757	10387	5295	31	0	\N
94945	1673	21263781000000	10387	5295	32	0	\N
94946	1673	20926501000000	10387	5295	33	0	\N
94947	1397	1380364170000	10387	5295	34	0	\N
94948	1397	1380354169000	10387	5295	35	0	\N
94949	1397	1380344168000	10387	5295	36	0	\N
94950	1397	1380334167000	10387	5295	37	0	\N
94951	1448	756572000001	10387	5295	38	0	\N
94952	1726	750212419000	10387	5295	39	0	\N
94953	1726	750202418000	10387	5295	40	0	\N
94954	1726	750192417000	10387	5295	41	0	\N
94955	1726	750182416000	10387	5295	42	0	\N
94956	1726	750172415000	10387	5295	43	0	\N
94957	1726	750162414000	10387	5295	44	0	\N
94958	1726	750152413000	10387	5295	45	0	\N
94959	1726	750142412000	10387	5295	46	0	\N
94960	1726	750132411000	10387	5295	47	0	\N
94961	1726	748922411000	10387	5295	48	0	\N
94962	1726	748912410000	10387	5295	49	0	\N
94963	1726	748902409000	10387	5295	50	0	\N
94964	1726	748892408000	10387	5295	51	0	\N
94965	1726	748882407000	10387	5295	52	0	\N
94966	1705	11791369945944	10387	5295	53	0	\N
94967	1705	11785551323105	10387	5295	54	0	\N
94968	1705	10327425316625	10387	5295	55	0	\N
94969	1705	7714483926145	10387	5295	56	0	\N
94970	1705	5951477050657	10387	5295	57	0	\N
94971	1705	1038719500145	10387	5295	58	0	\N
94972	1596	720020000000	10387	5295	59	0	\N
94973	1724	18954022200000	10387	5295	60	0	\N
94974	1724	15756449000000	10387	5295	61	0	\N
94975	1724	11017618600000	10387	5295	62	0	\N
94976	1724	2109261000000	10387	5295	63	0	\N
94977	1397	1380324166000	10387	5295	64	0	\N
94978	1397	1380314165000	10387	5295	65	0	\N
94979	1397	1380304164000	10387	5295	66	0	\N
94980	1397	1380294163000	10387	5295	67	0	\N
94981	1726	748872406000	10387	5295	68	0	\N
94982	1726	748862405000	10387	5295	69	0	\N
94983	1726	748852404000	10387	5295	70	0	\N
94984	1397	1380284162000	10387	5295	71	0	\N
94985	1397	1380274161000	10387	5295	72	0	\N
94986	1397	1380264160000	10387	5295	73	0	\N
94987	1397	1380254159000	10387	5295	74	0	\N
94988	1397	1380244158000	10387	5295	75	0	\N
94989	1397	1380234157000	10387	5295	76	0	\N
94990	1397	1380224156000	10387	5295	77	0	\N
94991	1397	1380214155000	10387	5295	78	0	\N
94992	1397	1380204154000	10387	5295	79	0	\N
94993	1397	1380194153000	10387	5295	80	0	\N
94994	1397	1380184152000	10387	5295	81	0	\N
94995	1397	1380174151000	10387	5295	82	0	\N
94996	1397	1380164150000	10387	5295	83	0	\N
94997	1397	1380154149000	10387	5295	84	0	\N
94998	1397	1380144148000	10387	5295	85	0	\N
94999	1397	1380134147000	10387	5295	86	0	\N
95000	1397	1380124146000	10387	5295	87	0	\N
95001	1397	1380114145000	10387	5295	88	0	\N
95002	1397	1380104144000	10387	5295	89	0	\N
95003	1397	1380094143000	10387	5295	90	0	\N
95004	1397	1380084142000	10387	5295	91	0	\N
95005	1397	1380074141000	10387	5295	92	0	\N
95006	1397	1380064140000	10387	5295	93	0	\N
95007	1397	1380054139000	10387	5295	94	0	\N
95008	1397	1380044138000	10387	5295	95	0	\N
95009	1397	1380034137000	10387	5295	96	0	\N
95010	1397	1380024136000	10387	5295	97	0	\N
95011	1397	1380014135000	10387	5295	98	0	\N
95012	1397	1380004134000	10387	5295	99	0	\N
95013	1397	1379994133000	10387	5295	100	0	\N
95014	1397	1379984132000	10387	5295	101	0	\N
95015	1397	1379974131000	10387	5295	102	0	\N
95016	1397	1379964130000	10387	5295	103	0	\N
95017	1397	1379954129000	10387	5295	104	0	\N
95018	1397	1379944128000	10387	5295	105	0	\N
95019	1397	1379934127000	10387	5295	106	0	\N
95020	1397	1379924126000	10387	5295	107	0	\N
95021	1397	1379914125000	10387	5295	108	0	\N
95022	1397	1379904124000	10387	5295	109	0	\N
95023	1397	1379894123000	10387	5295	110	0	\N
95024	1397	1379884122000	10387	5295	111	0	\N
95025	1397	1379874121000	10387	5295	112	0	\N
95026	1397	1379864120000	10387	5295	113	0	\N
95027	1397	1379854119000	10387	5295	114	0	\N
95028	1397	1379844118000	10387	5295	115	0	\N
95029	1397	1379834117000	10387	5295	116	0	\N
95030	1397	1379824116000	10387	5295	117	0	\N
95031	1397	1379814115000	10387	5295	118	0	\N
95032	1397	1379804114000	10387	5295	119	0	\N
95033	1397	1379794113000	10387	5295	120	0	\N
95034	1397	1379784112000	10387	5295	121	0	\N
95035	1397	1379774111000	10387	5295	122	0	\N
95036	1397	1379764110000	10387	5295	123	0	\N
95037	1397	1379754109000	10387	5295	124	0	\N
95038	1397	1379744108000	10387	5295	125	0	\N
95039	1726	745412302000	10388	5371	0	0	\N
95040	1397	1379194053000	10388	5371	1	0	\N
95041	1422	12651818852698	10388	5371	2	0	\N
95042	1397	1379194053000	10389	5371	0	0	\N
95043	1422	12651818852698	10389	5371	1	0	\N
95051	1726	745382299000	10392	5373	0	0	\N
95052	1397	1379164050000	10392	5373	1	0	\N
95055	1726	745382299000	10394	5373	0	0	\N
95056	1397	1379164050000	10394	5373	1	0	\N
95059	1726	745382299000	10396	5373	0	0	\N
95060	1726	745372298000	10396	5373	1	0	\N
95061	1397	1379164050000	10396	5373	2	0	\N
95064	1726	745362297000	10398	5375	0	0	\N
95046	1422	12651818852698	10390	5371	2	0	4
95047	1726	745402301000	10391	5372	0	0	2915
95048	1726	745392300000	10391	5372	1	0	2916
95049	1397	1379184052000	10391	5372	2	0	5965
95050	1397	1379174051000	10391	5372	3	0	5966
95054	1397	1379164050000	10393	5373	1	0	5967
95057	1726	745372298000	10395	5374	0	0	2918
95058	1397	1379154049000	10395	5374	1	0	5968
95062	1726	745362297000	10397	5375	0	0	2919
95063	1397	1379144048000	10397	5375	1	0	5969
95065	1397	1379144048000	10398	5375	1	0	\N
95068	1397	1379134047000	10400	5376	0	0	\N
95069	1726	745352296000	10400	5376	1	0	\N
95086	1397	1379064040000	10407	5382	0	0	\N
95087	1726	745272288000	10407	5382	1	0	\N
95092	1726	745242285000	10409	5384	0	0	\N
95093	1688	147340107830000	10409	5384	1	0	\N
95094	1726	745232284000	10409	5384	2	0	\N
95095	1397	1379034037000	10409	5384	3	0	\N
95096	1397	1379024036000	10409	5384	4	0	\N
95106	1397	1379004034000	10413	5386	0	0	\N
95107	1726	745212282000	10413	5386	2	0	\N
95115	1397	1378964030000	10415	5388	0	0	\N
95116	1688	141756558907000	10415	5388	1	0	\N
95117	1726	745172278000	10415	5388	2	0	\N
95118	1397	1378954029000	10415	5388	3	0	\N
95119	1726	745162277000	10415	5388	4	0	\N
95125	1726	745152276000	10417	5389	0	0	\N
95126	1397	1378944028000	10417	5389	1	0	\N
95127	1688	141645144721000	10417	5389	2	0	\N
95128	1726	745152276000	10418	5389	0	0	\N
95129	1397	1378944028000	10418	5389	1	0	\N
95130	1688	141645144721000	10418	5389	2	0	\N
95145	1688	141645144721000	10421	5390	0	0	\N
95146	1688	140419689737000	10421	5390	1	0	\N
95147	1726	745142275000	10421	5390	2	0	\N
95148	1726	745132274000	10421	5390	3	0	\N
95149	1726	745122273000	10421	5390	4	0	\N
95150	1726	745112272000	10421	5390	5	0	\N
95151	1688	130616318139000	10421	5390	6	0	\N
95152	1688	129725092671000	10421	5390	7	0	\N
95153	1397	1378934027000	10421	5390	8	0	\N
95154	1397	1378924026000	10421	5390	9	0	\N
95155	1397	1378914025000	10421	5390	10	0	\N
95156	1397	1378904024000	10421	5390	11	0	\N
95157	1688	141645144721000	10422	5390	0	0	\N
95158	1688	140419689737000	10422	5390	1	0	\N
95159	1726	745142275000	10422	5390	2	0	\N
95160	1726	745132274000	10422	5390	3	0	\N
95161	1726	745122273000	10422	5390	4	0	\N
95162	1726	745112272000	10422	5390	5	0	\N
95163	1688	130616318139000	10422	5390	6	0	\N
95164	1688	129725092671000	10422	5390	7	0	\N
95165	1397	1378934027000	10422	5390	8	0	\N
95166	1397	1378924026000	10422	5390	9	0	\N
95167	1397	1378914025000	10422	5390	10	0	\N
95168	1397	1378904024000	10422	5390	11	0	\N
95169	1397	1378894023000	10423	5391	0	0	\N
95170	1726	745102271000	10423	5391	1	0	\N
95179	1397	1378864020000	10427	5394	0	0	\N
95180	1397	1378854019000	10427	5394	1	0	\N
95181	1688	117248002732000	10427	5394	2	0	\N
95182	1688	117192295630000	10427	5394	3	0	\N
95183	1688	116579618037000	10427	5394	4	0	\N
95184	1688	116523900630000	10427	5394	5	0	\N
95185	1397	1378844018000	10427	5394	6	0	\N
95186	1726	745072268000	10427	5394	7	0	\N
95187	1726	745062267000	10427	5394	8	0	\N
95188	1726	745052266000	10427	5394	9	0	\N
95189	1688	115911109685000	10427	5394	10	0	\N
95190	1688	115479971940000	10427	5394	11	0	\N
95191	1688	110737560878000	10427	5394	12	0	\N
95192	1688	103819452596000	10427	5394	13	0	\N
95193	1688	27720427904000	10427	5394	14	0	\N
95070	1672	2160774000000	10401	5377	0	0	5
95071	1726	745342295000	10401	5377	1	0	2921
95072	1397	1379124046000	10401	5377	2	0	5971
95073	1726	745332294000	10402	5378	0	0	2922
95074	1726	745322293000	10403	5379	0	0	2923
95076	1726	745312292000	10404	5380	0	0	2924
95077	1397	1379104044000	10404	5380	1	0	5973
95078	1726	745302291000	10405	5381	0	0	2925
95079	1397	1379094043000	10405	5381	1	0	5974
95080	1397	1379084042000	10405	5381	2	0	5975
95082	1726	745292290000	10405	5381	4	0	2926
95083	1726	745282289000	10405	5381	5	0	2927
95084	1397	1379064040000	10406	5382	0	0	5977
95085	1726	745272288000	10406	5382	1	0	2928
95089	1726	745262287000	10408	5383	1	0	2929
95090	1397	1379044038000	10408	5383	2	0	5979
95091	1726	745252286000	10408	5383	3	0	2930
95097	1726	745242285000	10410	5384	0	0	2931
95098	1688	147340107830000	10410	5384	1	0	1
95100	1397	1379034037000	10410	5384	3	0	5980
95101	1397	1379024036000	10410	5384	4	0	5981
95102	1397	1379014035000	10411	5385	0	0	5982
95103	1726	745222283000	10411	5385	1	0	2933
95104	1397	1379004034000	10412	5386	0	0	5983
95108	1397	1378994033000	10414	5387	0	0	5984
95109	1688	142051849064000	10414	5387	1	0	2
95110	1397	1378984032000	10414	5387	2	0	5985
95111	1397	1378974031000	10414	5387	3	0	5986
95113	1726	745192280000	10414	5387	5	0	2936
95114	1726	745182279000	10414	5387	6	0	2937
95120	1397	1378964030000	10416	5388	0	0	5987
95121	1688	141756558907000	10416	5388	1	0	3
95122	1726	745172278000	10416	5388	2	0	2938
95124	1726	745162277000	10416	5388	4	0	2939
95131	1726	745152276000	10419	5389	0	0	2940
95132	1397	1378944028000	10419	5389	1	0	5989
95133	1688	141645144721000	10420	5390	0	0	4
95134	1688	140419689737000	10420	5390	1	0	5
95136	1726	745132274000	10420	5390	3	0	2942
95137	1726	745122273000	10420	5390	4	0	2943
95138	1726	745112272000	10420	5390	5	0	2944
95139	1688	130616318139000	10420	5390	6	0	6
95141	1397	1378934027000	10420	5390	8	0	5990
95142	1397	1378924026000	10420	5390	9	0	5991
95143	1397	1378914025000	10420	5390	10	0	5992
95144	1397	1378904024000	10420	5390	11	0	5993
95171	1397	1378894023000	10424	5391	0	0	5994
95173	1688	119921721073000	10425	5392	0	0	8
95174	1726	745092270000	10425	5392	1	0	2946
95175	1688	117470821105000	10425	5392	2	0	9
95176	1397	1378884022000	10425	5392	3	0	5995
95177	1726	745082269000	10426	5393	0	0	2947
95194	1397	1378864020000	10428	5394	0	0	5997
95195	1397	1378854019000	10428	5394	1	0	5998
95196	1688	117248002732000	10428	5394	2	0	10
95197	1688	117192295630000	10428	5394	3	0	11
95199	1688	116523900630000	10428	5394	5	0	13
95200	1397	1378844018000	10428	5394	6	0	5999
95211	1397	1378824016000	10430	5396	0	0	\N
95212	1445	16559330000000	10430	5396	1	0	\N
95213	1726	745032264000	10430	5396	2	0	\N
95217	1397	1378824016000	10432	5396	0	0	\N
95218	1445	16559330000000	10432	5396	1	0	\N
95219	1726	745032264000	10432	5396	2	0	\N
95220	1397	1378824016000	10433	5396	0	0	\N
95221	1397	1378814015000	10433	5396	1	0	\N
95222	1445	16559330000000	10433	5396	2	0	\N
95223	1726	745032264000	10433	5396	3	0	\N
95224	1397	1378814015000	10434	5397	0	0	\N
95225	1726	745022263000	10434	5397	1	0	\N
95226	1397	1378814015000	10435	5397	0	0	\N
95227	1726	745022263000	10435	5397	1	0	\N
95248	1445	2444290000000	10442	5402	0	0	\N
95249	1397	1378744008000	10442	5402	1	0	\N
95250	1726	744962257000	10442	5402	2	0	\N
95254	1679	80827780187000	10444	5403	0	0	\N
95255	1726	744952256000	10444	5403	1	0	\N
95256	1397	1378734007000	10444	5403	2	0	\N
95267	295	66000000665601	10446	5404	0	0	\N
95268	1397	1378724006000	10446	5404	1	0	\N
95269	1397	1378714005000	10446	5404	2	0	\N
95270	1679	80385834097000	10446	5404	3	0	\N
95271	1679	79561895865000	10446	5404	4	0	\N
95272	1679	73461673341000	10446	5404	5	0	\N
95273	1679	61644631114000	10446	5404	6	0	\N
95274	1679	60341603174000	10446	5404	7	0	\N
95275	1726	744942255000	10446	5404	8	0	\N
95276	1726	744932254000	10446	5404	9	0	\N
95277	1650	12958440000000	10447	5243	0	0	\N
95278	1650	11400330000000	10447	5243	1	0	\N
95279	1650	8608220000000	10447	5243	2	0	\N
95280	1650	6724110000000	10447	5243	3	0	\N
95281	1650	1474000000000	10447	5243	4	0	\N
95282	1455	17820231000000	10447	5243	5	0	\N
95283	1762	19626660000000	10447	5243	6	0	\N
95284	333	66324984938283	10447	5243	7	0	\N
95285	333	66000084938283	10447	5243	8	0	\N
95286	1768	17996311110000	10447	5243	9	0	\N
95287	1768	17995211110000	10447	5243	10	0	\N
95288	1768	10697911110000	10447	5243	11	0	\N
95289	1871	718910000000	10447	5243	12	0	\N
95290	1762	16372490000000	10447	5243	13	0	\N
95291	1455	15407131000000	10447	5243	14	0	\N
95292	1714	22282912377216	10447	5243	15	0	\N
95293	1455	11082031000000	10447	5243	16	0	\N
95294	1455	8163931000000	10447	5243	17	0	\N
95295	1455	33831000000	10447	5243	18	0	\N
95296	1762	11549540000000	10447	5243	19	0	\N
95297	1762	2481680000000	10447	5243	20	0	\N
95298	295	66000000665601	10447	5243	21	0	\N
95299	1768	6816111110000	10447	5243	22	0	\N
95300	1547	13679283000000	10447	5243	23	0	\N
95301	1714	17074447299806	10447	5243	24	0	\N
95302	1768	4197311110000	10447	5243	25	0	\N
95303	1768	2030611110000	10447	5243	26	0	\N
95304	1714	13560159598078	10447	5243	27	0	\N
95305	1714	3767463103056	10447	5243	28	0	\N
95306	1547	12220263000000	10447	5243	29	0	\N
95307	1547	10455243000000	10447	5243	30	0	\N
95308	1547	7840223000000	10447	5243	31	0	\N
95309	1547	2924203000000	10447	5243	32	0	\N
95310	1547	2733183000000	10447	5243	33	0	\N
95311	171	79165121590727	10447	5243	34	0	\N
95312	2002	0	10447	5243	35	0	\N
95313	1679	76507499187000	10447	5243	36	0	\N
95314	1397	1381114245000	10447	5243	37	0	\N
95315	1397	1381104244000	10447	5243	38	0	\N
95316	1397	1381094243000	10447	5243	39	0	\N
95317	1683	43631871149541	10447	5243	40	0	\N
95318	2003	351970654821	10447	5243	41	0	\N
95319	1397	1381084242000	10447	5243	42	0	\N
95320	1672	1440724000000	10447	5243	43	0	\N
95321	1397	1381074241000	10447	5243	44	0	\N
95322	1688	138699355830000	10447	5243	45	0	\N
95323	149	74393317000341	10447	5243	46	0	\N
95324	1448	15101975996189	10447	5243	47	0	\N
95325	1448	15083299992378	10447	5243	48	0	\N
95326	1448	14836898742069	10447	5243	49	0	\N
95327	1448	14590497491760	10447	5243	50	0	\N
95328	1448	12713517100219	10447	5243	51	0	\N
95329	1448	9349992292575	10447	5243	52	0	\N
95330	1448	7080551816496	10447	5243	53	0	\N
95331	1714	3765453103056	10447	5243	54	0	\N
95332	1693	5782620053757	10447	5243	55	0	\N
95333	1673	21263781000000	10447	5243	56	0	\N
95334	1673	20926501000000	10447	5243	57	0	\N
95335	1677	20807702325000	10447	5243	58	0	\N
95336	1688	133411097064000	10447	5243	59	0	\N
95203	1726	745052266000	10428	5394	9	0	2950
95204	1688	115911109685000	10428	5394	10	0	14
95205	1688	115479971940000	10428	5394	11	0	15
95206	1688	110737560878000	10428	5394	12	0	16
95207	1688	103819452596000	10428	5394	13	0	17
95209	1726	745042265000	10429	5395	0	0	2951
95210	1397	1378834017000	10429	5395	1	0	6000
95214	1397	1378824016000	10431	5396	0	0	6001
95215	1445	16559330000000	10431	5396	1	0	1
95216	1726	745032264000	10431	5396	2	0	2952
95229	1726	745022263000	10436	5397	1	0	2953
95230	1445	10107320000000	10437	5398	0	0	2
95231	1397	1378804014000	10437	5398	1	0	6003
95232	1726	745012262000	10437	5398	2	0	2954
95234	1397	1378794013000	10438	5399	0	0	6004
95235	1726	745002261000	10438	5399	1	0	2955
95236	1445	4359300000000	10438	5399	2	0	4
95237	1397	1378784012000	10438	5399	3	0	6005
95238	1683	60912741149541	10439	5400	0	0	1
95240	1397	1378774011000	10439	5400	2	0	6006
95241	1726	744982259000	10440	5401	0	0	2957
95242	1726	744972258000	10440	5401	1	0	2958
95243	1677	28008051325000	10440	5401	2	0	1
95244	1397	1378764010000	10440	5401	3	0	6007
95246	1397	1378744008000	10441	5402	0	0	6009
95247	1726	744962257000	10441	5402	1	0	2959
95251	1679	80827780187000	10443	5403	0	0	1
95252	1726	744952256000	10443	5403	1	0	2960
95257	295	66000000665601	10445	5404	0	0	1
95258	1397	1378724006000	10445	5404	1	0	6011
95259	1397	1378714005000	10445	5404	2	0	6012
95260	1679	80385834097000	10445	5404	3	0	2
95261	1679	79561895865000	10445	5404	4	0	3
95263	1679	61644631114000	10445	5404	6	0	5
95264	1679	60341603174000	10445	5404	7	0	6
95265	1726	744942255000	10445	5404	8	0	2961
95266	1726	744932254000	10445	5404	9	0	2962
95337	1688	133115806907000	10447	5243	60	0	\N
95338	1727	1626595000000	10447	5243	61	0	\N
95339	1439	11436824998477	10447	5243	62	0	\N
95340	149	71399817000341	10447	5243	63	0	\N
95341	149	69380037000341	10447	5243	64	0	\N
95342	149	67709537000341	10447	5243	65	0	\N
95343	1445	16559330000000	10447	5243	66	0	\N
95344	1445	10107320000000	10447	5243	67	0	\N
95345	1727	1626486000000	10447	5243	68	0	\N
95346	1448	756572000001	10447	5243	69	0	\N
95347	171	75661520312938	10447	5243	70	0	\N
95348	1705	20719609242793	10447	5243	71	0	\N
95349	1397	1381064240000	10447	5243	72	0	\N
95350	1397	1381054239000	10447	5243	73	0	\N
95351	1726	759412492000	10447	5243	75	0	\N
95352	1726	759402491000	10447	5243	76	0	\N
95353	1726	759392490000	10447	5243	77	0	\N
95354	1419	23522740649627	10447	5243	78	0	\N
95355	1419	21720903927387	10447	5243	79	0	\N
95356	1419	1900817280064	10447	5243	80	0	\N
95357	1688	133004392721000	10447	5243	81	0	\N
95358	1688	131778937737000	10447	5243	82	0	\N
95359	171	73297567463829	10447	5243	83	0	\N
95360	1705	20714872856220	10447	5243	84	0	\N
95361	1705	19530143600955	10447	5243	85	0	\N
95362	1705	17407126846190	10447	5243	86	0	\N
95363	1439	9594868998477	10447	5243	87	0	\N
95364	1439	6864917998477	10447	5243	88	0	\N
95365	1439	1732162998477	10447	5243	89	0	\N
95366	1397	1381044238000	10447	5243	90	0	\N
95367	1397	1381034237000	10447	5243	91	0	\N
95368	1397	1381024236000	10447	5243	92	0	\N
95369	1397	1381014235000	10447	5243	93	0	\N
95370	1397	1381004234000	10447	5243	94	0	\N
95371	1397	1380994233000	10447	5243	95	0	\N
95372	1397	1380984232000	10447	5243	96	0	\N
95373	1397	1380974231000	10447	5243	97	0	\N
95374	1397	1380964230000	10447	5243	98	0	\N
95375	1397	1380954229000	10447	5243	99	0	\N
95376	1703	720570000000	10447	5243	100	0	\N
95377	1724	18954022200000	10447	5243	101	0	\N
95378	1724	15756449000000	10447	5243	102	0	\N
95379	1724	11017618600000	10447	5243	103	0	\N
95380	1724	2109261000000	10447	5243	104	0	\N
95381	1397	1380944228000	10447	5243	105	0	\N
95382	1397	1380934227000	10447	5243	106	0	\N
95383	1397	1380924226000	10447	5243	107	0	\N
95384	1705	15974681884856	10447	5243	108	0	\N
95385	1705	11983064500065	10447	5243	109	0	\N
95386	1705	11791369945944	10447	5243	110	0	\N
95387	1705	11785551323105	10447	5243	111	0	\N
95388	1705	10327425316625	10447	5243	112	0	\N
95389	1705	7714483926145	10447	5243	113	0	\N
95390	1705	5951477050657	10447	5243	114	0	\N
95391	1705	1038719500145	10447	5243	115	0	\N
95392	171	66710220524688	10447	5243	116	0	\N
95393	1397	1380914225000	10447	5243	117	0	\N
95394	1397	1380904224000	10447	5243	118	0	\N
95395	1397	1380894223000	10447	5243	119	0	\N
95396	1397	1380884222000	10447	5243	120	0	\N
95397	1397	1380874221000	10447	5243	121	0	\N
95398	1397	1380864220000	10447	5243	122	0	\N
95399	1397	1380854219000	10447	5243	123	0	\N
95400	1397	1380844218000	10447	5243	124	0	\N
95401	1397	1380834217000	10447	5243	125	0	\N
95402	1726	744922253000	10448	5405	0	0	\N
95403	1679	59652345518000	10448	5405	2	0	\N
95404	1726	744912252000	10448	5405	3	0	\N
95405	1679	57914407852000	10448	5405	4	0	\N
95406	1679	55513914636000	10448	5405	5	0	\N
95407	1679	53406549734000	10448	5405	6	0	\N
95408	1679	40572273032000	10448	5405	7	0	\N
95409	1679	39199738031000	10448	5405	8	0	\N
95410	1726	743702252000	10448	5405	9	0	\N
95411	1726	742492252000	10448	5405	10	0	\N
95412	1726	741282252000	10448	5405	11	0	\N
95413	1397	1378704004000	10448	5405	12	0	\N
95414	1397	1378694003000	10448	5405	13	0	\N
95415	1726	744922253000	10449	5405	0	0	\N
95416	1679	59652345518000	10449	5405	2	0	\N
95417	1726	744912252000	10449	5405	3	0	\N
95418	1679	57914407852000	10449	5405	4	0	\N
95419	1679	55513914636000	10449	5405	5	0	\N
95420	1679	53406549734000	10449	5405	6	0	\N
95421	1679	40572273032000	10449	5405	7	0	\N
95422	1679	39199738031000	10449	5405	8	0	\N
95423	1726	743702252000	10449	5405	9	0	\N
95424	1726	742492252000	10449	5405	10	0	\N
95425	1726	741282252000	10449	5405	11	0	\N
95426	1397	1378704004000	10449	5405	12	0	\N
95427	1397	1378694003000	10449	5405	13	0	\N
95428	1726	744922253000	10450	5405	0	0	\N
95429	1679	59652345518000	10450	5405	2	0	\N
95430	1726	744912252000	10450	5405	3	0	\N
95431	1679	57914407852000	10450	5405	4	0	\N
95432	1679	55513914636000	10450	5405	5	0	\N
95433	1679	53406549734000	10450	5405	6	0	\N
95434	1679	40572273032000	10450	5405	7	0	\N
95435	1679	39199738031000	10450	5405	8	0	\N
95436	1726	743702252000	10450	5405	9	0	\N
95437	1726	742492252000	10450	5405	10	0	\N
95438	1726	741282252000	10450	5405	11	0	\N
95439	1397	1378704004000	10450	5405	12	0	\N
95440	1397	1378694003000	10450	5405	13	0	\N
95441	1726	744922253000	10451	5405	0	0	\N
95442	1679	59652345518000	10451	5405	2	0	\N
95443	1726	744912252000	10451	5405	3	0	\N
95444	1679	57914407852000	10451	5405	4	0	\N
95445	1679	55513914636000	10451	5405	5	0	\N
95446	1679	53406549734000	10451	5405	6	0	\N
95447	1679	40572273032000	10451	5405	7	0	\N
95448	1679	39199738031000	10451	5405	8	0	\N
95449	1726	743702252000	10451	5405	9	0	\N
95450	1726	742492252000	10451	5405	10	0	\N
95451	1726	741282252000	10451	5405	11	0	\N
95452	1397	1378704004000	10451	5405	12	0	\N
95453	1397	1378694003000	10451	5405	13	0	\N
95454	1726	744922253000	10452	5405	0	0	\N
95455	1679	59652345518000	10452	5405	2	0	\N
95456	1726	744912252000	10452	5405	3	0	\N
95457	1679	57914407852000	10452	5405	4	0	\N
95458	1679	55513914636000	10452	5405	5	0	\N
95459	1679	53406549734000	10452	5405	6	0	\N
95460	1679	40572273032000	10452	5405	7	0	\N
95461	1679	39199738031000	10452	5405	8	0	\N
95462	1726	743702252000	10452	5405	9	0	\N
95463	1726	742492252000	10452	5405	10	0	\N
95464	1726	741282252000	10452	5405	11	0	\N
95465	1397	1378704004000	10452	5405	12	0	\N
95466	1397	1378694003000	10452	5405	13	0	\N
95467	1726	744922253000	10453	5405	0	0	\N
95468	1679	59652345518000	10453	5405	2	0	\N
95469	1726	744912252000	10453	5405	3	0	\N
95470	1679	57914407852000	10453	5405	4	0	\N
95471	1679	55513914636000	10453	5405	5	0	\N
95472	1679	53406549734000	10453	5405	6	0	\N
95473	1679	40572273032000	10453	5405	7	0	\N
95474	1679	39199738031000	10453	5405	8	0	\N
95475	1726	743702252000	10453	5405	9	0	\N
95476	1726	742492252000	10453	5405	10	0	\N
95477	1726	741282252000	10453	5405	11	0	\N
95478	1397	1378704004000	10453	5405	12	0	\N
95479	1397	1378694003000	10453	5405	13	0	\N
95480	1726	744922253000	10454	5405	0	0	\N
95481	1679	59652345518000	10454	5405	2	0	\N
95482	1726	744912252000	10454	5405	3	0	\N
95483	1679	57914407852000	10454	5405	4	0	\N
95484	1679	55513914636000	10454	5405	5	0	\N
95485	1679	53406549734000	10454	5405	6	0	\N
95486	1679	40572273032000	10454	5405	7	0	\N
95487	1679	39199738031000	10454	5405	8	0	\N
95488	1726	743702252000	10454	5405	9	0	\N
95489	1726	742492252000	10454	5405	10	0	\N
95490	1726	741282252000	10454	5405	11	0	\N
95491	1397	1378704004000	10454	5405	12	0	\N
95492	1397	1378694003000	10454	5405	13	0	\N
95506	1726	744922253000	10456	5405	0	0	\N
95507	1679	59652345518000	10456	5405	2	0	\N
95508	1726	744912252000	10456	5405	3	0	\N
95509	1679	57914407852000	10456	5405	4	0	\N
95510	1679	55513914636000	10456	5405	5	0	\N
95511	1679	53406549734000	10456	5405	6	0	\N
95512	1679	40572273032000	10456	5405	7	0	\N
95513	1679	39199738031000	10456	5405	8	0	\N
95514	1726	743702252000	10456	5405	9	0	\N
95515	1726	742492252000	10456	5405	10	0	\N
95516	1726	741282252000	10456	5405	11	0	\N
95517	1397	1378704004000	10456	5405	12	0	\N
95518	1397	1378694003000	10456	5405	13	0	\N
95519	2017	343100000000	10457	5406	0	0	\N
95520	1397	1378684002000	10457	5406	1	0	\N
95521	1679	26365461329000	10457	5406	2	0	\N
95522	1726	741272251000	10457	5406	3	0	\N
95523	1679	25240472396000	10457	5406	4	0	\N
95524	1679	24527447579000	10457	5406	5	0	\N
95530	1726	744922253000	10459	5405	0	0	\N
95531	1679	59652345518000	10459	5405	2	0	\N
95532	1726	744912252000	10459	5405	3	0	\N
95533	1679	57914407852000	10459	5405	4	0	\N
95534	1679	55513914636000	10459	5405	5	0	\N
95535	1679	53406549734000	10459	5405	6	0	\N
95536	1679	40572273032000	10459	5405	7	0	\N
95537	1679	39199738031000	10459	5405	8	0	\N
95538	1726	743702252000	10459	5405	9	0	\N
95539	1726	742492252000	10459	5405	10	0	\N
95540	1726	741282252000	10459	5405	11	0	\N
95541	1397	1378704004000	10459	5405	12	0	\N
95542	1397	1378694003000	10459	5405	13	0	\N
95543	2017	343100000000	10460	5406	0	0	\N
95544	1397	1378684002000	10460	5406	1	0	\N
95545	1679	26365461329000	10460	5406	2	0	\N
95546	1726	741272251000	10460	5406	3	0	\N
95547	1679	25240472396000	10460	5406	4	0	\N
95553	2017	343100000000	10462	5406	0	0	\N
95554	1397	1378684002000	10462	5406	1	0	\N
95555	1679	26365461329000	10462	5406	2	0	\N
95556	1726	741272251000	10462	5406	3	0	\N
95557	1679	25240472396000	10462	5406	4	0	\N
95558	1397	1378674001000	10463	5407	0	0	\N
95559	1679	24527447579000	10463	5407	1	0	\N
95560	1679	21437706707000	10463	5407	2	0	\N
95561	1679	20962353496000	10463	5407	3	0	\N
95562	1726	741262250000	10463	5407	4	0	\N
95579	1679	17179532223000	10467	5409	0	0	\N
95580	1726	741232247000	10467	5409	1	0	\N
95581	1726	741222246000	10467	5409	2	0	\N
95582	1726	741212245000	10467	5409	3	0	\N
95583	1397	1378643998000	10467	5409	4	0	\N
95584	1679	14957292711000	10467	5409	5	0	\N
95585	1447	24479807000000	10467	5409	6	0	\N
95586	1397	1378633997000	10467	5409	7	0	\N
95587	1397	1378623996000	10467	5409	8	0	\N
95588	1679	17179532223000	10468	5409	0	0	\N
95589	1726	741232247000	10468	5409	1	0	\N
95590	1726	741222246000	10468	5409	2	0	\N
95591	1726	741212245000	10468	5409	3	0	\N
95592	1397	1378643998000	10468	5409	4	0	\N
95593	1679	14957292711000	10468	5409	5	0	\N
95594	1447	24479807000000	10468	5409	6	0	\N
95595	1397	1378633997000	10468	5409	7	0	\N
95596	1397	1378623996000	10468	5409	8	0	\N
95495	1726	744912252000	10455	5405	3	0	2964
95496	1679	57914407852000	10455	5405	4	0	8
95497	1679	55513914636000	10455	5405	5	0	9
95498	1679	53406549734000	10455	5405	6	0	10
95499	1679	40572273032000	10455	5405	7	0	11
95501	1726	743702252000	10455	5405	9	0	2965
95502	1726	742492252000	10455	5405	10	0	2966
95503	1726	741282252000	10455	5405	11	0	2967
95504	1397	1378704004000	10455	5405	12	0	6013
95505	1397	1378694003000	10455	5405	13	0	6014
95526	1397	1378684002000	10458	5406	1	0	6015
95527	1679	26365461329000	10458	5406	2	0	13
95528	1726	741272251000	10458	5406	3	0	2968
95529	1679	25240472396000	10458	5406	4	0	14
95549	1679	24527447579000	10461	5407	1	0	15
95550	1679	21437706707000	10461	5407	2	0	16
95551	1679	20962353496000	10461	5407	3	0	17
95552	1726	741262250000	10461	5407	4	0	2969
95563	1726	741252249000	10465	5408	0	0	2970
95565	1679	18003074829000	10465	5408	2	0	19
95566	1679	17797488397000	10465	5408	3	0	20
95567	1397	1378664000000	10465	5408	4	0	6017
95568	1726	741242248000	10465	5408	5	0	2971
95569	1397	1378653999000	10465	5408	6	0	6018
95571	1726	741232247000	10466	5409	1	0	2972
95572	1726	741222246000	10466	5409	2	0	2973
95573	1726	741212245000	10466	5409	3	0	2974
95574	1397	1378643998000	10466	5409	4	0	6019
95576	1447	24479807000000	10466	5409	6	0	1
95577	1397	1378633997000	10466	5409	7	0	6020
95578	1397	1378623996000	10466	5409	8	0	6021
95597	1726	741202244000	10469	5410	0	0	2975
95598	1397	1378613995000	10469	5410	1	0	6022
95600	1726	741192243000	10469	5410	3	0	2976
95601	2017	342900000000	10470	5411	0	0	2
95602	1447	15334560602000	10470	5411	1	0	2
95603	1447	10470495404000	10470	5411	2	0	3
95604	1397	1378593993000	10470	5411	3	0	6024
95606	1447	7188610439000	10470	5411	5	0	4
95607	1447	4474270944000	10470	5411	6	0	5
95608	1726	741182242000	10470	5411	7	0	2977
95622	1397	1378573991000	10472	5412	0	0	\N
95623	1726	741162240000	10472	5412	1	0	\N
95632	1726	741132237000	10476	5415	0	0	\N
95633	1726	741122236000	10476	5415	1	0	\N
95634	1397	1378543988000	10476	5415	2	0	\N
95635	1397	1378533987000	10476	5415	3	0	\N
95636	1445	4359289000000	10476	5415	4	0	\N
95642	1698	25197471000000	10478	5412	0	0	\N
95643	1445	4359289000000	10478	5412	1	0	\N
95646	1397	1378503984000	10480	5418	0	0	\N
95647	1397	1378493983000	10480	5418	1	0	\N
95648	1397	1378483982000	10480	5418	2	0	\N
95649	1726	741092233000	10480	5418	3	0	\N
95650	1726	741082232000	10480	5418	4	0	\N
95651	1726	741072231000	10480	5418	5	0	\N
95652	1397	1378503984000	10481	5418	0	0	\N
95653	1397	1378493983000	10481	5418	1	0	\N
95654	1397	1378483982000	10481	5418	2	0	\N
95655	1726	741092233000	10481	5418	3	0	\N
95656	1726	741082232000	10481	5418	4	0	\N
95657	1726	741072231000	10481	5418	5	0	\N
95673	1726	741062230000	10484	5419	0	0	\N
95674	1397	1378473981000	10484	5419	1	0	\N
95675	1397	1378463980000	10484	5419	2	0	\N
95676	1397	1378453979000	10484	5419	3	0	\N
95677	1397	1378443978000	10484	5419	4	0	\N
95678	1397	1378433977000	10484	5419	5	0	\N
95679	1726	741052229000	10484	5419	6	0	\N
95680	1726	741042228000	10484	5419	7	0	\N
95681	1726	741032227000	10484	5419	8	0	\N
95682	1397	1378423976000	10485	5420	0	0	\N
95683	1726	741022226000	10485	5420	1	0	\N
95684	1397	1378423976000	10486	5420	0	0	\N
95685	1726	741022226000	10486	5420	1	0	\N
95688	1397	1378423976000	10488	5420	0	0	\N
95689	1726	741022226000	10488	5420	1	0	\N
95690	1397	1378423976000	10489	5420	0	0	\N
95691	1726	741022226000	10489	5420	1	0	\N
95692	1726	741062230000	10490	5419	0	0	\N
95693	1397	1378473981000	10490	5419	1	0	\N
95694	1397	1378463980000	10490	5419	2	0	\N
95695	1397	1378453979000	10490	5419	3	0	\N
95696	1397	1378443978000	10490	5419	4	0	\N
95697	1397	1378433977000	10490	5419	5	0	\N
95698	1397	1378423976000	10490	5419	6	0	\N
95699	1726	741052229000	10490	5419	7	0	\N
95700	1726	741042228000	10490	5419	8	0	\N
95701	1726	741032227000	10490	5419	9	0	\N
95702	1726	741022226000	10490	5419	10	0	\N
95703	1698	24777896660710	10492	5422	0	0	\N
95704	1726	741012225000	10492	5422	1	0	\N
95705	1726	741002224000	10492	5422	2	0	\N
95706	1726	740992223000	10492	5422	3	0	\N
95707	1726	740982222000	10492	5422	4	0	\N
95708	1397	1378413975000	10492	5422	5	0	\N
95709	1397	1378403974000	10492	5422	6	0	\N
95710	1397	1378393973000	10492	5422	7	0	\N
95711	1397	1378383972000	10492	5422	8	0	\N
95712	1397	1378373971000	10492	5422	9	0	\N
95713	1698	21586566520030	10492	5422	10	0	\N
95714	1698	15867738171150	10492	5422	11	0	\N
95715	1698	12009127475655	10492	5422	12	0	\N
95716	1698	1256783550035	10492	5422	13	0	\N
95717	1706	20700093647920	10492	5422	14	0	\N
95718	1706	20523605295840	10492	5422	15	0	\N
95719	1706	20518247466997	10492	5422	16	0	\N
95720	1706	19174750967727	10492	5422	17	0	\N
95721	1706	16767224672027	10492	5422	18	0	\N
95722	1706	15142815454177	10492	5422	19	0	\N
95723	1706	10616272600077	10492	5422	20	0	\N
95724	1726	740972221000	10492	5422	21	0	\N
95725	1698	24777896660710	10493	5422	0	0	\N
95726	1726	741012225000	10493	5422	1	0	\N
95727	1726	741002224000	10493	5422	2	0	\N
95728	1726	740992223000	10493	5422	3	0	\N
95729	1726	740982222000	10493	5422	4	0	\N
95730	1397	1378413975000	10493	5422	5	0	\N
95731	1397	1378403974000	10493	5422	6	0	\N
95732	1397	1378393973000	10493	5422	7	0	\N
95733	1397	1378383972000	10493	5422	8	0	\N
95734	1397	1378373971000	10493	5422	9	0	\N
95735	1698	21586566520030	10493	5422	10	0	\N
95736	1698	15867738171150	10493	5422	11	0	\N
95737	1698	12009127475655	10493	5422	12	0	\N
95738	1698	1256783550035	10493	5422	13	0	\N
95739	1706	20700093647920	10493	5422	14	0	\N
95740	1706	20523605295840	10493	5422	15	0	\N
95741	1706	20518247466997	10493	5422	16	0	\N
95742	1706	19174750967727	10493	5422	17	0	\N
95743	1706	16767224672027	10493	5422	18	0	\N
95744	1706	15142815454177	10493	5422	19	0	\N
95611	1972	176000000	10470	5411	10	0	24
95612	1972	175000000	10470	5411	11	0	25
95613	1972	174000000	10470	5411	12	0	26
95614	1972	173000000	10470	5411	13	0	27
95615	1972	172000000	10470	5411	14	0	28
95617	1972	170000000	10470	5411	16	0	30
95618	1972	169000000	10470	5411	17	0	31
95619	1972	168000000	10470	5411	18	0	32
95620	1397	1378573991000	10471	5412	0	0	6026
95621	1726	741162240000	10471	5412	1	0	2979
95625	1726	741152239000	10473	5413	1	0	2980
95626	1397	1378563990000	10473	5413	2	0	6027
95627	1397	1378553989000	10474	5414	0	0	6028
95628	1726	741142238000	10474	5414	1	0	2981
95630	1397	1378543988000	10475	5415	1	0	6029
95631	1445	4359289000000	10475	5415	2	0	5
95637	1698	25197471000000	10477	5416	0	0	2
95638	1726	741122236000	10477	5416	1	0	2983
95639	1726	741112235000	10477	5416	2	0	2984
95641	1397	1378523986000	10477	5416	4	0	6031
95644	1397	1378513985000	10479	5417	0	0	6032
95645	1726	741102234000	10479	5417	1	0	2985
95658	1397	1378503984000	10482	5418	0	0	6033
95659	1397	1378493983000	10482	5418	1	0	6034
95661	1726	741092233000	10482	5418	3	0	2986
95662	1726	741082232000	10482	5418	4	0	2987
95663	1726	741072231000	10482	5418	5	0	2988
95664	1726	741062230000	10483	5419	0	0	2989
95666	1397	1378463980000	10483	5419	2	0	6037
95667	1397	1378453979000	10483	5419	3	0	6038
95668	1397	1378443978000	10483	5419	4	0	6039
95669	1397	1378433977000	10483	5419	5	0	6040
95670	1726	741052229000	10483	5419	6	0	2990
95672	1726	741032227000	10483	5419	8	0	2992
95686	1397	1378423976000	10487	5420	0	0	6041
95687	1726	741022226000	10487	5420	1	0	2993
95745	1706	10616272600077	10493	5422	20	0	\N
95746	1726	740972221000	10493	5422	21	0	\N
95781	1706	10486856746065	10497	5424	0	0	\N
95782	1726	740952219000	10497	5424	1	0	\N
95783	1726	739742219000	10497	5424	2	0	\N
95784	1706	10357440892053	10497	5424	3	0	\N
95785	1706	10353509502543	10497	5424	4	0	\N
95786	1706	9368276069745	10497	5424	5	0	\N
95787	1706	7602754119565	10497	5424	6	0	\N
95788	1706	6411518026475	10497	5424	7	0	\N
95789	1706	3092050600135	10497	5424	8	0	\N
95790	1397	1378363970000	10497	5424	9	0	\N
95791	1397	1378353969000	10497	5424	10	0	\N
95792	1706	10486856746065	10498	5424	0	0	\N
95793	1726	740952219000	10498	5424	1	0	\N
95794	1726	739742219000	10498	5424	2	0	\N
95795	1706	10357440892053	10498	5424	3	0	\N
95796	1706	10353509502543	10498	5424	4	0	\N
95797	1706	9368276069745	10498	5424	5	0	\N
95798	1706	7602754119565	10498	5424	6	0	\N
95799	1706	6411518026475	10498	5424	7	0	\N
95800	1706	3092050600135	10498	5424	8	0	\N
95801	1397	1378363970000	10498	5424	9	0	\N
95802	1397	1378353969000	10498	5424	10	0	\N
95803	1706	10486856746065	10499	5424	0	0	\N
95804	1726	740952219000	10499	5424	1	0	\N
95805	1726	739742219000	10499	5424	2	0	\N
95806	1706	10357440892053	10499	5424	3	0	\N
95807	1706	10353509502543	10499	5424	4	0	\N
95808	1706	9368276069745	10499	5424	5	0	\N
95809	1706	7602754119565	10499	5424	6	0	\N
95810	1706	6411518026475	10499	5424	7	0	\N
95811	1706	3092050600135	10499	5424	8	0	\N
95812	1397	1378363970000	10499	5424	9	0	\N
95813	1397	1378353969000	10499	5424	10	0	\N
95814	1706	10486856746065	10500	5424	0	0	\N
95815	1726	740952219000	10500	5424	1	0	\N
95816	1726	739742219000	10500	5424	2	0	\N
95817	1706	10357440892053	10500	5424	3	0	\N
95818	1706	10353509502543	10500	5424	4	0	\N
95819	1706	9368276069745	10500	5424	5	0	\N
95820	1706	7602754119565	10500	5424	6	0	\N
95821	1706	6411518026475	10500	5424	7	0	\N
95822	1706	3092050600135	10500	5424	8	0	\N
95823	1397	1378363970000	10500	5424	9	0	\N
95824	1397	1378353969000	10500	5424	10	0	\N
95831	1397	1378313965000	10503	5427	0	0	\N
95832	1726	739702215000	10503	5427	1	0	\N
95835	1726	739692214000	10505	5428	0	0	\N
95836	1726	739682213000	10505	5428	1	0	\N
95837	1726	739672212000	10505	5428	2	0	\N
95838	1726	739662211000	10505	5428	3	0	\N
95839	1726	739652210000	10505	5428	4	0	\N
95840	1397	1378303964000	10505	5428	5	0	\N
95841	1397	1378293963000	10505	5428	6	0	\N
95842	1397	1378283962000	10505	5428	7	0	\N
95843	1397	1378273961000	10505	5428	8	0	\N
95844	1726	739692214000	10506	5428	0	0	\N
95845	1726	739682213000	10506	5428	1	0	\N
95846	1726	739672212000	10506	5428	2	0	\N
95847	1726	739662211000	10506	5428	3	0	\N
95848	1726	739652210000	10506	5428	4	0	\N
95849	1397	1378303964000	10506	5428	5	0	\N
95850	1397	1378293963000	10506	5428	6	0	\N
95851	1397	1378283962000	10506	5428	7	0	\N
95852	1397	1378273961000	10506	5428	8	0	\N
95862	1726	739642209000	10508	5429	0	0	\N
95863	1397	1378263960000	10509	5429	0	0	\N
95864	1726	739642209000	10509	5429	1	0	\N
95867	1397	1378263960000	10511	5429	0	0	\N
95868	1726	739642209000	10511	5429	1	0	\N
95869	1397	1378263960000	10512	5429	0	0	\N
95870	1726	739642209000	10512	5429	1	0	\N
95871	1397	1378263960000	10513	5429	0	0	\N
95872	1726	739642209000	10513	5429	1	0	\N
95873	1726	739632208000	10513	5429	2	0	\N
95874	1397	1378253959000	10513	5429	3	0	\N
95749	1726	741002224000	10494	5422	2	0	2995
95750	1726	740992223000	10494	5422	3	0	2996
95751	1726	740982222000	10494	5422	4	0	2997
95752	1397	1378413975000	10494	5422	5	0	6042
95753	1397	1378403974000	10494	5422	6	0	6043
95755	1397	1378383972000	10494	5422	8	0	6045
95756	1397	1378373971000	10494	5422	9	0	6046
95757	1698	21586566520030	10494	5422	10	0	4
95758	1698	15867738171150	10494	5422	11	0	5
95759	1698	12009127475655	10494	5422	12	0	6
95761	1706	20700093647920	10494	5422	14	0	7
95762	1706	20523605295840	10494	5422	15	0	8
95763	1706	20518247466997	10494	5422	16	0	9
95764	1706	19174750967727	10494	5422	17	0	10
95766	1706	15142815454177	10494	5422	19	0	12
95767	1706	10616272600077	10494	5422	20	0	13
95768	1726	740972221000	10494	5422	21	0	2998
95769	1726	740962220000	10495	5423	0	0	2999
95770	1706	10486856746065	10496	5424	0	0	14
95772	1726	739742219000	10496	5424	2	0	3001
95773	1706	10357440892053	10496	5424	3	0	15
95774	1706	10353509502543	10496	5424	4	0	16
95775	1706	9368276069745	10496	5424	5	0	17
95776	1706	7602754119565	10496	5424	6	0	18
95778	1706	3092050600135	10496	5424	8	0	20
95779	1397	1378363970000	10496	5424	9	0	6047
95780	1397	1378353969000	10496	5424	10	0	6048
95825	1726	739732218000	10501	5425	0	0	3002
95827	1726	739722217000	10502	5426	0	0	3003
95828	1726	739712216000	10502	5426	1	0	3004
95829	1397	1378333967000	10502	5426	2	0	6050
95830	1397	1378323966000	10502	5426	3	0	6051
95833	1397	1378313965000	10504	5427	0	0	6052
95853	1726	739692214000	10507	5428	0	0	3006
95854	1726	739682213000	10507	5428	1	0	3007
95855	1726	739672212000	10507	5428	2	0	3008
95856	1726	739662211000	10507	5428	3	0	3009
95857	1726	739652210000	10507	5428	4	0	3010
95859	1397	1378293963000	10507	5428	6	0	6054
95860	1397	1378283962000	10507	5428	7	0	6055
95861	1397	1378273961000	10507	5428	8	0	6056
95865	1397	1378263960000	10510	5429	0	0	6057
95875	1726	739632208000	10514	5430	0	0	3012
95876	1397	1378253959000	10514	5430	1	0	6058
95877	1397	1378243958000	10514	5430	2	0	6059
95878	1397	1378233957000	10514	5430	3	0	6060
95879	1726	739622207000	10514	5430	4	0	3013
95881	1726	739632208000	10515	5430	0	0	\N
95882	1397	1378253959000	10515	5430	1	0	\N
95883	1397	1378243958000	10515	5430	2	0	\N
95884	1397	1378233957000	10515	5430	3	0	\N
95885	1726	739622207000	10515	5430	4	0	\N
95886	1726	739612206000	10515	5430	5	0	\N
95889	1397	1378213955000	10517	5432	0	0	\N
95890	1726	739592204000	10517	5432	1	0	\N
95891	1397	1378213955000	10518	5432	0	0	\N
95892	1726	739592204000	10518	5432	1	0	\N
95897	1726	739572202000	10521	5434	0	0	\N
95898	1726	739562201000	10521	5434	1	0	\N
95899	1397	1378193953000	10521	5434	2	0	\N
95900	1397	1378183952000	10521	5434	3	0	\N
95901	1726	739572202000	10522	5434	0	0	\N
95902	1726	739562201000	10522	5434	1	0	\N
95903	1397	1378193953000	10522	5434	2	0	\N
95904	1397	1378183952000	10522	5434	3	0	\N
95905	1726	739572202000	10523	5434	0	0	\N
95906	1726	739562201000	10523	5434	1	0	\N
95907	1397	1378193953000	10523	5434	2	0	\N
95908	1397	1378183952000	10523	5434	3	0	\N
95921	1397	1378173951000	10526	5435	0	0	\N
95922	1726	739552200000	10526	5435	1	0	\N
95923	1726	739542199000	10526	5435	2	0	\N
95924	1397	1378163950000	10526	5435	3	0	\N
95925	1397	1378153949000	10526	5435	4	0	\N
95926	1397	1378143948000	10526	5435	5	0	\N
95927	1726	739532198000	10526	5435	6	0	\N
95928	1726	739522197000	10526	5435	7	0	\N
95929	1726	739692214000	10527	5428	0	0	\N
95930	1726	739682213000	10527	5428	1	0	\N
95931	1726	739672212000	10527	5428	2	0	\N
95932	1726	739662211000	10527	5428	3	0	\N
95933	1726	739652210000	10527	5428	4	0	\N
95934	1726	739642209000	10527	5428	5	0	\N
95935	1726	739632208000	10527	5428	6	0	\N
95936	1726	739622207000	10527	5428	7	0	\N
95937	1726	739612206000	10527	5428	8	0	\N
95938	1726	739602205000	10527	5428	9	0	\N
95939	1726	739592204000	10527	5428	10	0	\N
95940	1726	739582203000	10527	5428	11	0	\N
95941	1726	739572202000	10527	5428	12	0	\N
95942	1726	739562201000	10527	5428	13	0	\N
95943	1726	739552200000	10527	5428	14	0	\N
95944	1726	739542199000	10527	5428	15	0	\N
95945	1397	1378303964000	10527	5428	16	0	\N
95946	1397	1378293963000	10527	5428	17	0	\N
95947	1726	739532198000	10527	5428	18	0	\N
95948	1726	739522197000	10527	5428	19	0	\N
95949	1726	739512196000	10527	5428	20	0	\N
95950	1726	739502195000	10527	5428	21	0	\N
95951	1397	1378283962000	10527	5428	22	0	\N
95952	1397	1378273961000	10527	5428	23	0	\N
95953	1397	1378263960000	10527	5428	24	0	\N
95954	1397	1378253959000	10527	5428	25	0	\N
95955	1397	1378243958000	10527	5428	26	0	\N
95956	1397	1378233957000	10527	5428	27	0	\N
95957	1397	1378223956000	10527	5428	28	0	\N
95958	1397	1378213955000	10527	5428	29	0	\N
95959	1397	1378203954000	10527	5428	30	0	\N
95960	1397	1378193953000	10527	5428	31	0	\N
95961	1397	1378183952000	10527	5428	32	0	\N
95962	1397	1378173951000	10527	5428	33	0	\N
95963	1397	1378163950000	10527	5428	34	0	\N
95964	1397	1378153949000	10527	5428	35	0	\N
95965	1397	1378143948000	10527	5428	36	0	\N
95966	1397	1378133947000	10527	5428	37	0	\N
95967	1397	1378123946000	10527	5428	38	0	\N
95972	1726	739512196000	10529	5436	0	0	\N
95973	1726	739502195000	10529	5436	1	0	\N
95974	1397	1378133947000	10529	5436	2	0	\N
95975	1397	1378123946000	10529	5436	3	0	\N
95984	1726	739482193000	10532	5438	0	0	\N
95985	1397	1378103944000	10532	5438	1	0	\N
95986	1397	1378093943000	10532	5438	2	0	\N
95987	1740	19435145000000	10532	5438	3	0	\N
95995	1726	739452190000	10535	5440	0	0	\N
95996	1397	1378063940000	10535	5440	1	0	\N
96008	1397	1378003934000	10541	5446	0	0	\N
96009	1726	739392184000	10541	5446	1	0	\N
96012	1397	1378003934000	10543	5446	0	0	\N
96013	1726	739392184000	10543	5446	1	0	\N
96014	1397	1378003934000	10544	5446	0	0	\N
96015	1726	739392184000	10544	5446	1	0	\N
96016	1726	739402185000	10545	5445	0	0	\N
95893	1397	1378213955000	10519	5432	0	0	6062
95894	1726	739592204000	10519	5432	1	0	3016
95895	1397	1378203954000	10520	5433	0	0	6063
95896	1726	739582203000	10520	5433	1	0	3017
95909	1726	739572202000	10524	5434	0	0	3018
95911	1397	1378193953000	10524	5434	2	0	6064
95912	1397	1378183952000	10524	5434	3	0	6065
95913	1397	1378173951000	10525	5435	0	0	6066
95914	1726	739552200000	10525	5435	1	0	3020
95915	1726	739542199000	10525	5435	2	0	3021
95917	1397	1378153949000	10525	5435	4	0	6068
95918	1397	1378143948000	10525	5435	5	0	6069
95919	1726	739532198000	10525	5435	6	0	3022
95920	1726	739522197000	10525	5435	7	0	3023
95969	1726	739502195000	10528	5436	1	0	3025
95970	1397	1378133947000	10528	5436	2	0	6070
95971	1397	1378123946000	10528	5436	3	0	6071
95976	1726	739492194000	10530	5437	0	0	3026
95977	1397	1378113945000	10530	5437	1	0	6072
95979	1950	6385388000000	10530	5437	3	0	7
95980	1726	739482193000	10531	5438	0	0	3027
95981	1397	1378103944000	10531	5438	1	0	6073
95982	1397	1378093943000	10531	5438	2	0	6074
95983	1740	19435145000000	10531	5438	3	0	8
95989	1397	1378083942000	10533	5439	1	0	6075
95990	1397	1378073941000	10533	5439	2	0	6076
95991	1726	739462191000	10533	5439	3	0	3029
95992	563	66000526000000	10533	5439	5	0	4
95994	1397	1378063940000	10534	5440	1	0	6077
95997	1726	739442189000	10536	5441	0	0	3031
95998	1397	1378053939000	10536	5441	1	0	6078
95999	1726	739432188000	10537	5442	0	0	3032
96000	1397	1378043938000	10537	5442	1	0	6079
96002	1726	739422187000	10538	5443	1	0	3033
96003	1397	1378023936000	10539	5444	0	0	6081
96004	1726	739412186000	10539	5444	1	0	3034
96005	1950	6383387000000	10539	5444	2	0	8
96006	1726	739402185000	10540	5445	0	0	3035
96010	1397	1378003934000	10542	5446	0	0	6083
96011	1726	739392184000	10542	5446	1	0	3036
96017	1726	739392184000	10545	5445	1	0	\N
96018	1397	1378013935000	10545	5445	2	0	\N
96019	1397	1378003934000	10545	5445	3	0	\N
96020	1397	1378003934000	10546	5446	0	0	\N
96021	1726	739392184000	10546	5446	1	0	\N
96022	1726	739382183000	10547	5447	0	0	\N
96023	1726	739372182000	10547	5447	1	0	\N
96024	1397	1377993933000	10547	5447	2	0	\N
96025	1397	1377983932000	10547	5447	3	0	\N
96026	1950	5385386000000	10547	5447	4	0	\N
96027	1726	739382183000	10548	5447	0	0	\N
96028	1726	739372182000	10548	5447	1	0	\N
96029	1397	1377993933000	10548	5447	2	0	\N
96030	1397	1377983932000	10548	5447	3	0	\N
96031	1950	5385386000000	10548	5447	4	0	\N
96039	1726	739492194000	10551	5429	0	0	\N
96040	1726	739482193000	10551	5429	1	0	\N
96041	1726	739472192000	10551	5429	2	0	\N
96042	1726	739462191000	10551	5429	3	0	\N
96043	1726	739452190000	10551	5429	4	0	\N
96044	1726	739442189000	10551	5429	5	0	\N
96045	1726	739432188000	10551	5429	6	0	\N
96046	1397	1378113945000	10551	5429	7	0	\N
96047	1397	1378103944000	10551	5429	8	0	\N
96048	1397	1378093943000	10551	5429	9	0	\N
96049	1397	1378083942000	10551	5429	10	0	\N
96050	1397	1378073941000	10551	5429	11	0	\N
96051	1397	1378063940000	10551	5429	12	0	\N
96052	1397	1378053939000	10551	5429	13	0	\N
96053	1397	1378043938000	10551	5429	14	0	\N
96054	1397	1378033937000	10551	5429	15	0	\N
96055	1397	1378023936000	10551	5429	16	0	\N
96056	1397	1378013935000	10551	5429	17	0	\N
96057	1397	1378003934000	10551	5429	18	0	\N
96058	1397	1377993933000	10551	5429	19	0	\N
96059	1397	1377983932000	10551	5429	20	0	\N
96060	1397	1377973931000	10551	5429	21	0	\N
96061	1397	1377963930000	10551	5429	22	0	\N
96062	1397	1377953929000	10551	5429	23	0	\N
96063	1397	1377943928000	10551	5429	24	0	\N
96064	1726	739422187000	10551	5429	25	0	\N
96065	1726	739412186000	10551	5429	26	0	\N
96066	1726	739402185000	10551	5429	27	0	\N
96067	1726	739392184000	10551	5429	28	0	\N
96068	1726	739382183000	10551	5429	29	0	\N
96069	1726	739372182000	10551	5429	30	0	\N
96070	1726	739362181000	10551	5429	31	0	\N
96071	1726	739352180000	10551	5429	33	0	\N
96072	1726	739342179000	10551	5429	34	0	\N
96073	1726	739332178000	10551	5429	35	0	\N
96074	1726	739322177000	10551	5429	36	0	\N
96075	1740	19435145000000	10551	5429	37	0	\N
96076	563	66000526000000	10551	5429	38	0	\N
96077	1950	6387389000000	10551	5429	39	0	\N
96078	1950	6385388000000	10551	5429	40	0	\N
96079	1950	6383387000000	10551	5429	41	0	\N
96080	1950	5385386000000	10551	5429	42	0	\N
96081	1726	739352180000	10552	5449	0	0	\N
96082	1726	739342179000	10552	5449	1	0	\N
96083	1726	739332178000	10552	5449	2	0	\N
96084	1726	739322177000	10552	5449	3	0	\N
96085	1397	1377963930000	10552	5449	4	0	\N
96086	1397	1377953929000	10552	5449	5	0	\N
96087	1397	1377943928000	10552	5449	6	0	\N
96097	1726	739352180000	10555	5449	0	0	\N
96098	1726	739342179000	10555	5449	1	0	\N
96099	1726	739332178000	10555	5449	2	0	\N
96100	1726	739322177000	10555	5449	3	0	\N
96101	1726	739312176000	10555	5449	4	0	\N
96102	1397	1377963930000	10555	5449	5	0	\N
96103	1397	1377953929000	10555	5449	6	0	\N
96104	1397	1377943928000	10555	5449	7	0	\N
96105	1397	1377933927000	10555	5449	8	0	\N
96106	1397	1377933927000	10556	5450	0	0	\N
96107	1726	739312176000	10556	5450	1	0	\N
96108	1397	1377923926000	10556	5450	2	0	\N
96113	1698	25197471000000	10558	5296	0	0	\N
96114	295	66000000665601	10558	5296	1	0	\N
96115	1698	24777896660710	10558	5296	2	0	\N
96116	1679	79387619187000	10558	5296	3	0	\N
96117	1683	47952411149541	10558	5296	4	0	\N
96118	1397	1379734107000	10558	5296	5	0	\N
96119	1397	1379724106000	10558	5296	6	0	\N
96120	1397	1379714105000	10558	5296	7	0	\N
96121	1397	1379704104000	10558	5296	8	0	\N
96122	1672	1440724000000	10558	5296	9	0	\N
96123	1688	142299886830000	10558	5296	11	0	\N
96124	1677	22247742325000	10558	5296	12	0	\N
96125	1688	137011628064000	10558	5296	13	0	\N
96126	1688	136716337907000	10558	5296	14	0	\N
96127	1698	21586566520030	10558	5296	15	0	\N
96128	1445	16559330000000	10558	5296	16	0	\N
96129	1445	10107320000000	10558	5296	17	0	\N
96130	1698	15867738171150	10558	5296	18	0	\N
96131	1698	12009127475655	10558	5296	19	0	\N
96132	1698	1256783550035	10558	5296	20	0	\N
96133	1688	136604923721000	10558	5296	21	0	\N
96134	1688	135379468737000	10558	5296	22	0	\N
96135	1447	24479807000000	10558	5296	23	0	\N
96136	1447	15334560602000	10558	5296	24	0	\N
96137	1447	10470495404000	10558	5296	25	0	\N
96138	1447	7188610439000	10558	5296	26	0	\N
96139	1447	4474270944000	10558	5296	27	0	\N
96140	1679	78945673097000	10558	5296	28	0	\N
96141	1679	78121734865000	10558	5296	29	0	\N
96142	1679	72021512341000	10558	5296	30	0	\N
96143	1679	60204470114000	10558	5296	31	0	\N
96144	1679	58901442174000	10558	5296	32	0	\N
96145	1679	58212184518000	10558	5296	33	0	\N
96146	1679	56474246852000	10558	5296	34	0	\N
96147	1679	54073753636000	10558	5296	35	0	\N
96148	1679	51966388734000	10558	5296	36	0	\N
96149	1679	39132112032000	10558	5296	37	0	\N
96150	1679	37759577031000	10558	5296	38	0	\N
96151	1679	24925300329000	10558	5296	39	0	\N
96152	1679	23800311396000	10558	5296	40	0	\N
96034	1397	1377993933000	10549	5447	2	0	6084
96035	1397	1377983932000	10549	5447	3	0	6085
96036	1950	5385386000000	10549	5447	4	0	9
96037	1397	1377973931000	10550	5448	0	0	6086
96038	1726	739362181000	10550	5448	1	0	3039
96089	1726	739342179000	10553	5449	1	0	3041
96090	1726	739332178000	10553	5449	2	0	3042
96091	1726	739322177000	10553	5449	3	0	3043
96092	1397	1377963930000	10553	5449	4	0	6087
96093	1397	1377953929000	10553	5449	5	0	6088
96095	1397	1377933927000	10554	5450	0	0	6090
96096	1726	739312176000	10554	5450	1	0	3044
96109	1397	1377923926000	10557	5451	0	0	6091
96110	1397	1377913925000	10557	5451	1	0	6092
96112	1726	739292174000	10557	5451	3	0	3046
96153	1679	23087286579000	10558	5296	41	0	\N
96154	1679	19997545707000	10558	5296	42	0	\N
96155	1679	19522192496000	10558	5296	43	0	\N
96156	1679	18103477902000	10558	5296	44	0	\N
96157	1679	16912541437000	10558	5296	45	0	\N
96158	1679	16706955005000	10558	5296	46	0	\N
96159	1679	16088998831000	10558	5296	47	0	\N
96160	1679	13866759319000	10558	5296	48	0	\N
96161	1688	125576097139000	10558	5296	49	0	\N
96162	1688	124684871671000	10558	5296	50	0	\N
96163	1688	114881500073000	10558	5296	51	0	\N
96164	1688	112430600105000	10558	5296	52	0	\N
96165	1688	112207781732000	10558	5296	53	0	\N
96166	1688	112152074630000	10558	5296	54	0	\N
96167	1688	111539397037000	10558	5296	55	0	\N
96168	1688	111483679630000	10558	5296	56	0	\N
96169	1688	110870888685000	10558	5296	57	0	\N
96170	1688	110439750940000	10558	5296	58	0	\N
96171	1688	105697339878000	10558	5296	59	0	\N
96172	1688	98779231596000	10558	5296	60	0	\N
96173	1688	22680206904000	10558	5296	61	0	\N
96174	1706	19260033647920	10558	5296	62	0	\N
96175	1706	19083545295840	10558	5296	63	0	\N
96176	1706	19078187466997	10558	5296	64	0	\N
96177	1706	17734690967727	10558	5296	65	0	\N
96178	1706	15327164672027	10558	5296	66	0	\N
96179	1706	13702755454177	10558	5296	67	0	\N
96180	1706	9176212600077	10558	5296	68	0	\N
96181	1706	9046796746065	10558	5296	69	0	\N
96182	1706	8917380892053	10558	5296	70	0	\N
96183	1706	8913449502543	10558	5296	71	0	\N
96184	1706	7928216069745	10558	5296	72	0	\N
96185	1706	6162694119565	10558	5296	73	0	\N
96186	1706	4971458026475	10558	5296	74	0	\N
96187	1706	1651990600135	10558	5296	75	0	\N
96188	1397	1379694103000	10558	5296	76	0	\N
96189	1397	1379684102000	10558	5296	77	0	\N
96190	1397	1379674101000	10558	5296	78	0	\N
96191	1397	1379664100000	10558	5296	79	0	\N
96192	1397	1379654099000	10558	5296	80	0	\N
96193	1397	1379644098000	10558	5296	81	0	\N
96194	1397	1379634097000	10558	5296	82	0	\N
96195	1397	1379624096000	10558	5296	83	0	\N
96196	1397	1379614095000	10558	5296	84	0	\N
96197	1397	1379604094000	10558	5296	85	0	\N
96198	1397	1379594093000	10558	5296	86	0	\N
96199	1397	1379584092000	10558	5296	87	0	\N
96200	1397	1379574091000	10558	5296	88	0	\N
96201	1397	1379564090000	10558	5296	89	0	\N
96202	1397	1379554089000	10558	5296	90	0	\N
96203	1397	1379544088000	10558	5296	91	0	\N
96204	1397	1379534087000	10558	5296	92	0	\N
96205	1397	1379524086000	10558	5296	93	0	\N
96206	1397	1379514085000	10558	5296	94	0	\N
96207	1397	1379504084000	10558	5296	95	0	\N
96208	1397	1379494083000	10558	5296	96	0	\N
96209	1397	1379484082000	10558	5296	97	0	\N
96210	1397	1379474081000	10558	5296	98	0	\N
96211	1397	1379464080000	10558	5296	99	0	\N
96212	1397	1379454079000	10558	5296	100	0	\N
96213	1397	1379444078000	10558	5296	101	0	\N
96214	1397	1379434077000	10558	5296	102	0	\N
96215	1397	1379424076000	10558	5296	103	0	\N
96216	1397	1379414075000	10558	5296	104	0	\N
96217	1397	1379404074000	10558	5296	105	0	\N
96218	1397	1379394073000	10558	5296	106	0	\N
96219	1397	1379384072000	10558	5296	107	0	\N
96220	1397	1379374071000	10558	5296	108	0	\N
96221	1397	1379364070000	10558	5296	109	0	\N
96222	1397	1379354069000	10558	5296	110	0	\N
96223	1397	1379344068000	10558	5296	111	0	\N
96224	1397	1379334067000	10558	5296	112	0	\N
96225	1397	1379324066000	10558	5296	113	0	\N
96226	1397	1379314065000	10558	5296	114	0	\N
96227	1397	1379304064000	10558	5296	115	0	\N
96228	1397	1379294063000	10558	5296	116	0	\N
96229	1397	1379284062000	10558	5296	117	0	\N
96230	1397	1379274061000	10558	5296	118	0	\N
96231	1397	1379264060000	10558	5296	119	0	\N
96232	1397	1379254059000	10558	5296	120	0	\N
96233	1445	6675310000000	10558	5296	121	0	\N
96234	1445	4359300000000	10558	5296	122	0	\N
96235	1445	2444290000000	10558	5296	123	0	\N
96236	1397	1379244058000	10558	5296	124	0	\N
96237	1397	1379234057000	10558	5296	125	0	\N
96246	1726	739262171000	10563	5454	0	0	\N
96247	1397	1377883922000	10563	5454	1	0	\N
96248	1726	739252170000	10563	5454	2	0	\N
96249	1397	1377873921000	10563	5454	3	0	\N
96254	1726	739232168000	10566	5457	0	0	\N
96255	1397	1377853919000	10566	5457	1	0	\N
96256	1726	739232168000	10567	5457	0	0	\N
96257	1397	1377853919000	10567	5457	1	0	\N
96258	1726	739232168000	10568	5457	0	0	\N
96259	1397	1377853919000	10568	5457	1	0	\N
96260	1726	739232168000	10569	5457	0	0	\N
96261	1397	1377853919000	10569	5457	1	0	\N
96264	1726	739222167000	10571	5458	0	0	\N
96265	1397	1377843918000	10571	5458	1	0	\N
96266	1726	739212166000	10572	5459	0	0	\N
96267	1397	1377833917000	10572	5459	1	0	\N
96277	1397	1377783912000	10576	5462	0	0	\N
96278	1726	739172162000	10576	5462	1	0	\N
96240	1726	739272172000	10560	5453	0	0	3048
96241	1397	1377893923000	10560	5453	1	0	6094
96242	1726	739262171000	10561	5454	0	0	3049
96243	1397	1377883922000	10561	5454	1	0	6095
96244	1726	739252170000	10562	5455	0	0	3050
96250	1397	1377863920000	10564	5456	0	0	6097
96251	1726	739242169000	10564	5456	1	0	3051
96252	1726	739232168000	10565	5457	0	0	3052
96253	1397	1377853919000	10565	5457	1	0	6098
96262	1726	739222167000	10570	5458	0	0	3053
96268	1726	739212166000	10573	5459	0	0	3054
96269	1397	1377833917000	10573	5459	1	0	6100
96270	1397	1377823916000	10573	5459	2	0	6101
96271	1726	739202165000	10574	5460	0	0	3055
96273	1397	1377813915000	10574	5460	2	0	6102
96274	1397	1377803914000	10575	5461	0	0	6103
96275	1397	1377793913000	10575	5461	1	0	6104
96276	1726	739182163000	10575	5461	2	0	3057
96279	1397	1377783912000	10577	5462	0	0	6105
96281	1726	739162161000	10578	5463	0	0	3059
96282	1726	739152160000	10578	5463	1	0	3060
96283	1726	739142159000	10578	5463	2	0	3061
96284	1397	1377773911000	10578	5463	3	0	6106
96285	1397	1377763910000	10578	5463	4	0	6107
96287	1397	1377743908000	10579	5464	0	0	6109
96288	1726	739132158000	10579	5464	1	0	3062
96291	1726	739122157000	10581	5465	0	0	\N
96292	1397	1377733907000	10581	5465	1	0	\N
96293	1397	1377723906000	10582	5466	0	0	\N
96294	1726	739112156000	10582	5466	1	0	\N
96297	1397	1377723906000	10584	5466	0	0	\N
96298	1726	739112156000	10584	5466	1	0	\N
96299	1397	1377723906000	10585	5466	0	0	\N
96300	1726	739112156000	10585	5466	1	0	\N
96307	1726	739072152000	10590	5470	0	0	\N
96308	1726	739062151000	10590	5470	1	0	\N
96309	1397	1377683902000	10590	5470	2	0	\N
96310	1397	1377673901000	10590	5470	3	0	\N
96315	1726	739072152000	10592	5470	0	0	\N
96316	1726	739062151000	10592	5470	1	0	\N
96317	1397	1377683902000	10592	5470	2	0	\N
96318	1397	1377673901000	10592	5470	3	0	\N
96319	1397	1377663900000	10593	5471	0	0	\N
96320	1726	739052150000	10593	5471	1	0	\N
96327	1726	739042149000	10596	5472	0	0	\N
96328	1726	739032148000	10596	5472	1	0	\N
96329	1397	1377653899000	10596	5472	2	0	\N
96330	1397	1377643898000	10596	5472	3	0	\N
96337	1726	739002145000	10600	5475	0	0	\N
96338	1397	1377613895000	10600	5475	1	0	\N
96339	1726	738992144000	10601	5476	0	0	\N
96340	1397	1377603894000	10601	5476	1	0	\N
96343	1726	738992144000	10603	5476	0	0	\N
96344	1397	1377603894000	10603	5476	1	0	\N
96345	1726	738982143000	10604	5477	0	0	\N
96346	1397	1377593893000	10604	5477	1	0	\N
96351	1726	738962141000	10607	5479	0	0	\N
96352	1397	1377573891000	10607	5479	1	0	\N
96353	1726	738962141000	10608	5479	0	0	\N
96354	1397	1377573891000	10608	5479	1	0	\N
96357	1397	1377563890000	10610	5480	0	0	\N
96358	1397	1377553889000	10610	5480	1	0	\N
96359	1726	738952140000	10610	5480	2	0	\N
96360	1726	738942139000	10610	5480	3	0	\N
96367	1726	738932138000	10613	5481	0	0	\N
96368	1397	1377543888000	10613	5481	1	0	\N
96374	1726	738912136000	10616	5483	0	0	\N
96375	1397	1377523886000	10616	5483	1	0	\N
96376	1397	1377513885000	10617	5484	0	0	\N
96377	1726	738902135000	10617	5484	1	0	\N
96378	1397	1379224056000	10618	5297	0	0	\N
96379	1397	1379214055000	10618	5297	1	0	\N
96380	1397	1379204054000	10618	5297	2	0	\N
96381	1397	1379194053000	10618	5297	3	0	\N
96382	1397	1379184052000	10618	5297	4	0	\N
96383	1397	1379174051000	10618	5297	5	0	\N
96384	1397	1379164050000	10618	5297	6	0	\N
96385	1397	1379154049000	10618	5297	7	0	\N
96386	1397	1379144048000	10618	5297	8	0	\N
96387	1397	1379134047000	10618	5297	9	0	\N
96388	1397	1379124046000	10618	5297	11	0	\N
96389	1397	1379114045000	10618	5297	12	0	\N
96390	1397	1379104044000	10618	5297	13	0	\N
96391	1397	1379094043000	10618	5297	14	0	\N
96392	1397	1379084042000	10618	5297	15	0	\N
96393	1397	1379074041000	10618	5297	16	0	\N
96394	1397	1379064040000	10618	5297	17	0	\N
96395	1397	1379054039000	10618	5297	18	0	\N
96396	1397	1379044038000	10618	5297	19	0	\N
96397	1397	1379034037000	10618	5297	20	0	\N
96398	1397	1379024036000	10618	5297	21	0	\N
96399	1397	1379014035000	10618	5297	22	0	\N
96400	1397	1379004034000	10618	5297	23	0	\N
96401	1397	1378994033000	10618	5297	24	0	\N
96402	1397	1378984032000	10618	5297	25	0	\N
96403	1397	1378974031000	10618	5297	26	0	\N
96404	1397	1378964030000	10618	5297	27	0	\N
96405	1397	1378954029000	10618	5297	28	0	\N
96406	1397	1378944028000	10618	5297	29	0	\N
96407	1397	1378934027000	10618	5297	30	0	\N
96408	1397	1378924026000	10618	5297	31	0	\N
96409	1397	1378914025000	10618	5297	32	0	\N
96410	1397	1378904024000	10618	5297	33	0	\N
96411	1397	1378894023000	10618	5297	34	0	\N
96412	1397	1378884022000	10618	5297	35	0	\N
96415	1726	738892134000	10620	5485	0	0	\N
96416	1726	738882133000	10620	5485	1	0	\N
96417	1397	1377503884000	10620	5485	2	0	\N
96418	1397	1377493883000	10620	5485	3	0	\N
96295	1397	1377723906000	10583	5466	0	0	6111
96296	1726	739112156000	10583	5466	1	0	3064
96301	1726	739102155000	10586	5467	0	0	3065
96302	1397	1377713905000	10586	5467	1	0	6112
96303	1726	739092154000	10587	5468	0	0	3066
96305	1397	1377693903000	10588	5469	0	0	6114
96306	1726	739082153000	10588	5469	1	0	3067
96311	1726	739072152000	10591	5470	0	0	3068
96312	1726	739062151000	10591	5470	1	0	3069
96313	1397	1377683902000	10591	5470	2	0	6115
96321	1397	1377663900000	10594	5471	0	0	6117
96322	1726	739052150000	10594	5471	1	0	3070
96323	1726	739042149000	10595	5472	0	0	3071
96324	1726	739032148000	10595	5472	1	0	3072
96326	1397	1377643898000	10595	5472	3	0	6119
96331	1726	739022147000	10597	5473	0	0	3073
96332	1397	1377633897000	10597	5473	1	0	6120
96333	1726	739012146000	10598	5474	0	0	3074
96334	1397	1377623896000	10598	5474	1	0	6121
96336	1397	1377613895000	10599	5475	1	0	6122
96341	1726	738992144000	10602	5476	0	0	3076
96342	1397	1377603894000	10602	5476	1	0	6123
96347	1726	738982143000	10605	5477	0	0	3077
96348	1397	1377593893000	10605	5477	1	0	6124
96350	1726	738972142000	10606	5478	1	0	3078
96355	1726	738962141000	10609	5479	0	0	3079
96356	1397	1377573891000	10609	5479	1	0	6126
96361	1397	1377563890000	10611	5480	0	0	6127
96363	1726	738952140000	10611	5480	2	0	3080
96364	1726	738942139000	10611	5480	3	0	3081
96365	1726	738932138000	10612	5481	0	0	3082
96366	1397	1377543888000	10612	5481	1	0	6129
96369	1397	1377533887000	10614	5482	0	0	6130
96371	1950	5309185000000	10614	5482	2	0	10
96372	1726	738912136000	10615	5483	0	0	3084
96373	1397	1377523886000	10615	5483	1	0	6131
96413	1397	1377513885000	10619	5484	0	0	6132
96414	1726	738902135000	10619	5484	1	0	3085
96420	1726	738882133000	10621	5485	1	0	3087
96421	1397	1377503884000	10621	5485	2	0	6133
96422	1397	1377493883000	10621	5485	3	0	6134
96423	1726	738872132000	10622	5486	0	0	3088
96429	1726	738872132000	10623	5486	0	0	\N
96430	1726	738862131000	10623	5486	1	0	\N
96431	1726	738852130000	10623	5486	2	0	\N
96432	1397	1377483882000	10623	5486	3	0	\N
96433	1397	1377473881000	10623	5486	4	0	\N
96434	1397	1377463880000	10623	5486	5	0	\N
96437	1397	1377453879000	10625	5487	0	0	\N
96438	1726	738842129000	10625	5487	1	0	\N
96439	1397	1377453879000	10626	5487	0	0	\N
96440	1726	738842129000	10626	5487	1	0	\N
96447	1397	1377423876000	10630	5490	0	0	\N
96448	1726	738812126000	10630	5490	1	0	\N
96449	1397	1377423876000	10631	5490	0	0	\N
96450	1726	738812126000	10631	5490	1	0	\N
96454	1726	738792124000	10633	5492	0	0	\N
96455	1397	1377413875000	10633	5492	1	0	\N
96456	1397	1377403874000	10633	5492	2	0	\N
96459	1726	738792124000	10635	5492	0	0	\N
96460	1397	1377413875000	10635	5492	1	0	\N
96471	1726	738742119000	10638	5495	0	0	\N
96472	1397	1377353869000	10638	5495	1	0	\N
96480	1726	738722117000	10642	5497	0	0	\N
96481	1397	1377333867000	10642	5497	1	0	\N
96482	1698	24777896660710	10643	5413	0	0	\N
96483	1698	21586566520030	10643	5413	1	0	\N
96484	1698	15867738171150	10643	5413	2	0	\N
96485	1698	12009127475655	10643	5413	3	0	\N
96486	1698	1256783550035	10643	5413	4	0	\N
96487	1706	19980073647920	10643	5413	5	0	\N
96488	1706	19803585295840	10643	5413	6	0	\N
96489	1706	19798227466997	10643	5413	7	0	\N
96490	1706	18454730967727	10643	5413	8	0	\N
96491	1706	16047204672027	10643	5413	9	0	\N
96492	1706	14422795454177	10643	5413	10	0	\N
96493	1706	9896252600077	10643	5413	11	0	\N
96494	1706	9766836746065	10643	5413	12	0	\N
96495	1706	9637420892053	10643	5413	13	0	\N
96496	1706	9633489502543	10643	5413	14	0	\N
96497	1706	8648256069745	10643	5413	15	0	\N
96498	1706	6882734119565	10643	5413	16	0	\N
96499	1706	5691498026475	10643	5413	17	0	\N
96500	1706	2372030600135	10643	5413	18	0	\N
96501	1740	19435145000000	10643	5413	19	0	\N
96502	1740	19434144000000	10643	5413	20	0	\N
96503	1740	1961142000000	10643	5413	21	0	\N
96504	563	83474526000000	10643	5413	22	0	\N
96505	1950	6387389000000	10643	5413	23	0	\N
96506	1950	6385388000000	10643	5413	24	0	\N
96507	1950	6383387000000	10643	5413	25	0	\N
96508	1950	5385386000000	10643	5413	26	0	\N
96509	1950	5309185000000	10643	5413	27	0	\N
96510	1950	4479854000000	10643	5413	28	0	\N
96511	1950	3479853000000	10643	5413	29	0	\N
96520	1397	1377313865000	10646	5499	0	0	\N
96521	1397	1377303864000	10646	5499	1	0	\N
96524	1726	738682113000	10648	5500	0	0	\N
96525	1397	1377293863000	10648	5500	1	0	\N
96526	1726	738682113000	10649	5500	0	0	\N
96527	1397	1377293863000	10649	5500	1	0	\N
96528	1726	738682113000	10650	5500	0	0	\N
96529	1397	1377293863000	10650	5500	1	0	\N
96530	1726	738672112000	10651	5501	0	0	\N
96531	1726	738662111000	10651	5501	1	0	\N
96532	1397	1377283862000	10651	5501	2	0	\N
96533	1397	1377273861000	10651	5501	3	0	\N
96534	1726	738672112000	10652	5501	0	0	\N
96535	1726	738662111000	10652	5501	1	0	\N
96536	1397	1377283862000	10652	5501	2	0	\N
96537	1397	1377273861000	10652	5501	3	0	\N
96546	1726	738632108000	10656	5504	0	0	\N
96547	1726	738622107000	10656	5504	1	0	\N
96548	1397	1377243858000	10656	5504	2	0	\N
96549	1397	1377233857000	10656	5504	3	0	\N
96550	1726	738632108000	10657	5504	0	0	\N
96551	1726	738622107000	10657	5504	1	0	\N
96552	1397	1377243858000	10657	5504	2	0	\N
96553	1397	1377233857000	10657	5504	3	0	\N
96558	1726	738632108000	10659	5504	0	0	\N
96559	1726	738622107000	10659	5504	1	0	\N
96560	1397	1377243858000	10659	5504	2	0	\N
96427	1397	1377473881000	10622	5486	4	0	6136
96428	1397	1377463880000	10622	5486	5	0	6137
96435	1397	1377453879000	10624	5487	0	0	6138
96436	1726	738842129000	10624	5487	1	0	3091
96441	1726	738832128000	10627	5488	0	0	3092
96443	1950	4479854000000	10627	5488	2	0	11
96444	1397	1377433877000	10628	5489	0	0	6140
96445	1726	738822127000	10628	5489	1	0	3093
96446	1397	1377423876000	10629	5490	0	0	6141
96451	1726	738812126000	10632	5491	0	0	3094
96453	1950	3479853000000	10632	5491	2	0	12
96457	1726	738792124000	10634	5492	0	0	3096
96458	1397	1377413875000	10634	5492	1	0	6142
96461	1726	738782123000	10636	5493	0	0	3097
96463	1397	1377393873000	10636	5493	2	0	6144
96464	1726	738772122000	10637	5494	0	0	3098
96465	1726	738762121000	10637	5494	1	0	3099
96466	1726	738752120000	10637	5494	2	0	3100
96467	1397	1377383872000	10637	5494	4	0	6145
96469	1397	1377363870000	10637	5494	6	0	6147
96470	1740	20874174000000	10637	5494	7	0	9
96473	1726	738742119000	10639	5495	0	0	3101
96474	1397	1377353869000	10639	5495	1	0	6148
96475	1397	1377343868000	10640	5496	0	0	6149
96477	1740	3401172000000	10640	5496	2	0	10
96478	1726	738722117000	10641	5497	0	0	3103
96479	1397	1377333867000	10641	5497	1	0	6150
96512	1397	1377323866000	10644	5498	0	0	6151
96514	563	75487725000000	10644	5498	2	0	5
96515	563	71239124000000	10644	5498	3	0	6
96516	1397	1377313865000	10645	5499	0	0	6152
96517	1726	738702115000	10645	5499	1	0	3105
96518	1726	738692114000	10645	5499	2	0	3106
96522	1726	738682113000	10647	5500	0	0	3107
96523	1397	1377293863000	10647	5500	1	0	6154
96538	1726	738672112000	10653	5501	0	0	3108
96539	1726	738662111000	10653	5501	1	0	3109
96540	1397	1377283862000	10653	5501	2	0	6155
96542	1397	1377263860000	10655	5503	0	0	6157
96543	1397	1377253859000	10655	5503	1	0	6158
96544	1726	738652110000	10655	5503	2	0	3110
96545	1726	738642109000	10655	5503	3	0	3111
96555	1726	738622107000	10658	5504	1	0	3113
96556	1397	1377243858000	10658	5504	2	0	6159
96557	1397	1377233857000	10658	5504	3	0	6160
96561	1397	1377233857000	10659	5504	3	0	\N
96565	1397	1377203854000	10663	5507	0	0	\N
96566	1726	738602105000	10663	5507	1	0	\N
96567	1397	1377203854000	10664	5507	0	0	\N
96568	1726	738602105000	10664	5507	1	0	\N
96569	1397	1377203854000	10665	5507	0	0	\N
96570	1726	738602105000	10665	5507	1	0	\N
96573	1726	738592104000	10667	5508	0	0	\N
96574	1397	1377193853000	10667	5508	1	0	\N
96575	1397	1377183852000	10667	5508	2	0	\N
96576	1726	738582103000	10667	5508	3	0	\N
96577	1726	738572102000	10667	5508	4	0	\N
96578	1726	738592104000	10668	5508	0	0	\N
96579	1397	1377193853000	10668	5508	1	0	\N
96580	1397	1377183852000	10668	5508	2	0	\N
96581	1726	738582103000	10668	5508	3	0	\N
96582	1726	738572102000	10668	5508	4	0	\N
96588	1397	1377173851000	10670	5509	0	0	\N
96589	1397	1377163850000	10670	5509	1	0	\N
96590	1397	1377153849000	10670	5509	2	0	\N
96591	1726	738562101000	10670	5509	3	0	\N
96592	1726	738552100000	10670	5509	4	0	\N
96593	1726	738542099000	10670	5509	5	0	\N
96600	1397	1377173851000	10672	5509	0	0	\N
96601	1397	1377163850000	10672	5509	1	0	\N
96602	1397	1377153849000	10672	5509	2	0	\N
96603	1726	738562101000	10672	5509	3	0	\N
96604	1726	738552100000	10672	5509	4	0	\N
96605	1726	738542099000	10672	5509	5	0	\N
96606	1397	1377173851000	10673	5509	0	0	\N
96607	1397	1377163850000	10673	5509	1	0	\N
96608	1397	1377153849000	10673	5509	2	0	\N
96609	1397	1377143848000	10673	5509	3	0	\N
96610	1726	738562101000	10673	5509	4	0	\N
96611	1726	738552100000	10673	5509	5	0	\N
96612	1726	738542099000	10673	5509	6	0	\N
96613	1726	738532098000	10673	5509	7	0	\N
96620	1726	738512096000	10676	5511	0	0	\N
96621	1397	1377123846000	10676	5511	1	0	\N
96622	1726	738512096000	10677	5511	0	0	\N
96623	1397	1377123846000	10677	5511	1	0	\N
96626	1397	1377103844000	10679	5513	0	0	\N
96627	1726	738492094000	10679	5513	1	0	\N
96630	1726	738482093000	10681	5514	0	0	\N
96631	1397	1377093843000	10681	5514	1	0	\N
96641	1726	738452090000	10686	5517	0	0	\N
96642	1397	1377063840000	10686	5517	1	0	\N
96643	563	66000122000000	10686	5517	2	0	\N
96644	1397	1377053839000	10688	5518	0	0	\N
96645	1726	738442089000	10688	5518	1	0	\N
96651	1397	1377033837000	10690	5520	0	0	\N
96652	1726	738422087000	10690	5520	1	0	\N
96653	1397	1377033837000	10691	5520	0	0	\N
96654	1726	738422087000	10691	5520	1	0	\N
96665	1397	1376973831000	10697	5524	0	0	\N
96666	1397	1376963830000	10697	5524	1	0	\N
96667	1726	738392084000	10697	5524	2	0	\N
96668	1726	738382083000	10697	5524	3	0	\N
96669	1726	738372082000	10697	5524	4	0	\N
96670	1726	738362081000	10697	5524	5	0	\N
96671	1726	738352080000	10697	5524	6	0	\N
96672	563	66001418000000	10697	5524	7	0	\N
96681	1397	1376973831000	10699	5524	0	0	\N
96682	1397	1376963830000	10699	5524	1	0	\N
96683	1726	738392084000	10699	5524	2	0	\N
96684	1726	738382083000	10699	5524	3	0	\N
96685	1726	738372082000	10699	5524	4	0	\N
96686	1726	738362081000	10699	5524	5	0	\N
96687	1726	738352080000	10699	5524	6	0	\N
96688	563	66001418000000	10699	5524	7	0	\N
96689	1397	1376973831000	10700	5524	0	0	\N
96690	1397	1376963830000	10700	5524	1	0	\N
96691	1726	738392084000	10700	5524	2	0	\N
96692	1726	738382083000	10700	5524	3	0	\N
96693	1726	738372082000	10700	5524	4	0	\N
96694	1726	738362081000	10700	5524	5	0	\N
96695	1726	738352080000	10700	5524	6	0	\N
96696	563	66001418000000	10700	5524	7	0	\N
96564	1726	738612106000	10661	5506	1	0	3114
96571	1397	1377203854000	10666	5507	0	0	6163
96572	1726	738602105000	10666	5507	1	0	3115
96583	1726	738592104000	10669	5508	0	0	3116
96584	1397	1377193853000	10669	5508	1	0	6164
96586	1726	738582103000	10669	5508	3	0	3117
96587	1726	738572102000	10669	5508	4	0	3118
96594	1397	1377173851000	10671	5509	0	0	6166
96595	1397	1377163850000	10671	5509	1	0	6167
96596	1397	1377153849000	10671	5509	2	0	6168
96598	1726	738552100000	10671	5509	4	0	3120
96599	1726	738542099000	10671	5509	5	0	3121
96614	1726	738532098000	10674	5510	0	0	3122
96615	1726	738522097000	10674	5510	1	0	3123
96617	1397	1377133847000	10674	5510	3	0	6170
96618	1726	738512096000	10675	5511	0	0	3124
96619	1397	1377123846000	10675	5511	1	0	6171
96624	1397	1377113845000	10678	5512	0	0	6172
96625	1726	738502095000	10678	5512	1	0	3125
96629	1726	738492094000	10680	5513	1	0	3126
96632	1726	738482093000	10682	5514	0	0	3127
96633	1397	1377093843000	10682	5514	1	0	6174
96634	1726	738472092000	10683	5515	0	0	3128
96635	1397	1377083842000	10683	5515	1	0	6175
96637	1397	1377073841000	10684	5516	1	0	6176
96638	1726	738452090000	10685	5517	0	0	3130
96639	1397	1377063840000	10685	5517	1	0	6177
96640	563	66000122000000	10685	5517	2	0	7
96647	1726	738442089000	10689	5519	1	0	3131
96648	1726	738432088000	10689	5519	2	0	3132
96649	1397	1377043838000	10689	5519	3	0	6179
96650	1740	3401170000000	10689	5519	4	0	11
96655	1397	1377033837000	10692	5520	0	0	6180
96657	1397	1377023836000	10695	5522	0	0	6181
96658	1397	1377013835000	10695	5522	1	0	6182
96659	1726	738412086000	10695	5522	2	0	3134
96660	1726	738402085000	10695	5522	3	0	3135
96661	563	68372220000000	10695	5522	4	0	8
96663	1397	1376993833000	10696	5523	1	0	6184
96664	1397	1376983832000	10696	5523	2	0	6185
96673	1397	1376973831000	10698	5524	0	0	6186
96674	1397	1376963830000	10698	5524	1	0	6187
96676	1726	738382083000	10698	5524	3	0	3137
96677	1726	738372082000	10698	5524	4	0	3138
96678	1726	738362081000	10698	5524	5	0	3139
96679	1726	738352080000	10698	5524	6	0	3140
96680	563	66001418000000	10698	5524	7	0	9
96697	1397	1376973831000	10701	5524	0	0	\N
96698	1397	1376963830000	10701	5524	1	0	\N
96699	1726	738392084000	10701	5524	2	0	\N
96700	1726	738382083000	10701	5524	3	0	\N
96701	1726	738372082000	10701	5524	4	0	\N
96702	1726	738362081000	10701	5524	5	0	\N
96703	1726	738352080000	10701	5524	6	0	\N
96704	563	66001418000000	10701	5524	7	0	\N
96707	1397	1376953829000	10703	5525	0	0	\N
96708	1726	738342079000	10703	5525	1	0	\N
96722	1726	738312076000	10706	5527	0	0	\N
96723	1726	738302075000	10706	5527	1	0	\N
96724	1726	738292074000	10706	5527	2	0	\N
96725	1726	738282073000	10706	5527	3	0	\N
96726	1397	1376923826000	10706	5527	4	0	\N
96727	1397	1376913825000	10706	5527	5	0	\N
96728	1397	1376903824000	10706	5527	6	0	\N
96729	1397	1376893823000	10706	5527	7	0	\N
96730	43	66720469890000	10706	5527	8	0	\N
96731	1397	1376883822000	10707	5528	0	0	\N
96732	1726	738272072000	10707	5528	1	0	\N
96736	1726	738262071000	10710	5530	0	0	\N
96737	1397	1376863820000	10710	5530	1	0	\N
96740	1397	1376853819000	10712	5531	0	0	\N
96741	1726	738252070000	10712	5531	1	0	\N
96742	1397	1376853819000	10713	5531	0	0	\N
96743	1726	738252070000	10713	5531	1	0	\N
96744	1397	1376853819000	10714	5531	0	0	\N
96745	1726	738252070000	10714	5531	1	0	\N
96748	1397	1376853819000	10716	5531	0	0	\N
96749	1726	738252070000	10716	5531	1	0	\N
96750	1726	738242069000	10717	5532	0	0	\N
96751	1397	1376843818000	10717	5532	1	0	\N
96754	1726	738242069000	10719	5532	0	0	\N
96755	1397	1376843818000	10719	5532	1	0	\N
96758	576	82015504938283	10721	5534	0	0	\N
96759	1397	1376823816000	10721	5534	1	0	\N
96760	1726	738222067000	10721	5534	2	0	\N
96761	1726	738212066000	10721	5534	3	0	\N
96762	1397	1376813815000	10721	5534	4	0	\N
96763	2028	16977223460000	10721	5534	5	0	\N
96770	1726	738202065000	10723	5535	0	0	\N
96771	1397	1376803814000	10723	5535	1	0	\N
96774	576	82015504938283	10725	5418	0	0	\N
96775	1698	24777896660710	10725	5418	1	0	\N
96776	1698	21586566520030	10725	5418	2	0	\N
96777	1698	15867738171150	10725	5418	3	0	\N
96778	1698	12009127475655	10725	5418	4	0	\N
96779	1698	1256783550035	10725	5418	5	0	\N
96780	1397	1378503984000	10725	5418	6	0	\N
96781	1397	1378493983000	10725	5418	7	0	\N
96782	1397	1378483982000	10725	5418	8	0	\N
96783	1397	1378473981000	10725	5418	9	0	\N
96784	1397	1378463980000	10725	5418	10	0	\N
96785	1397	1378453979000	10725	5418	11	0	\N
96786	1397	1378443978000	10725	5418	12	0	\N
96787	1397	1378433977000	10725	5418	13	0	\N
96788	1397	1378423976000	10725	5418	14	0	\N
96789	1397	1378413975000	10725	5418	15	0	\N
96790	1397	1378403974000	10725	5418	16	0	\N
96791	1397	1378393973000	10725	5418	17	0	\N
96792	1397	1378383972000	10725	5418	18	0	\N
96793	1397	1378373971000	10725	5418	19	0	\N
96794	1726	741092233000	10725	5418	20	0	\N
96795	1726	741082232000	10725	5418	21	0	\N
96796	1726	741072231000	10725	5418	22	0	\N
96797	1726	741062230000	10725	5418	24	0	\N
96798	1726	741052229000	10725	5418	25	0	\N
96799	1726	741042228000	10725	5418	26	0	\N
96800	1726	741032227000	10725	5418	27	0	\N
96801	1726	741022226000	10725	5418	28	0	\N
96802	1726	741012225000	10725	5418	29	0	\N
96803	1726	741002224000	10725	5418	30	0	\N
96804	1726	740992223000	10725	5418	31	0	\N
96805	1726	740982222000	10725	5418	32	0	\N
96806	1706	20700093647920	10725	5418	33	0	\N
96807	1706	20523605295840	10725	5418	34	0	\N
96808	1706	20518247466997	10725	5418	35	0	\N
96809	1706	19174750967727	10725	5418	36	0	\N
96810	1706	16767224672027	10725	5418	37	0	\N
96811	1706	15142815454177	10725	5418	38	0	\N
96812	1706	10616272600077	10725	5418	39	0	\N
96813	1706	10486856746065	10725	5418	40	0	\N
96814	1706	10357440892053	10725	5418	41	0	\N
96815	1706	10353509502543	10725	5418	42	0	\N
96816	1706	9368276069745	10725	5418	43	0	\N
96817	1706	7602754119565	10725	5418	44	0	\N
96818	1706	6411518026475	10725	5418	45	0	\N
96819	1706	3092050600135	10725	5418	46	0	\N
96820	1397	1378363970000	10725	5418	47	0	\N
96821	1397	1378353969000	10725	5418	48	0	\N
96822	1397	1378343968000	10725	5418	49	0	\N
96823	1397	1378333967000	10725	5418	50	0	\N
96824	1397	1378323966000	10725	5418	51	0	\N
96825	1397	1378313965000	10725	5418	52	0	\N
96826	1397	1378303964000	10725	5418	53	0	\N
96827	1397	1378293963000	10725	5418	54	0	\N
96828	1397	1378283962000	10725	5418	55	0	\N
96829	1397	1378273961000	10725	5418	56	0	\N
96830	1397	1378263960000	10725	5418	57	0	\N
96831	1397	1378253959000	10725	5418	58	0	\N
96832	1397	1378243958000	10725	5418	59	0	\N
96709	1397	1376943828000	10704	5526	0	0	6189
96710	1726	738332078000	10704	5526	1	0	3142
96711	1726	738322077000	10704	5526	2	0	3143
96712	1397	1376933827000	10704	5526	3	0	6190
96713	1726	738312076000	10705	5527	0	0	3144
96715	1726	738292074000	10705	5527	2	0	3146
96716	1726	738282073000	10705	5527	3	0	3147
96717	1397	1376923826000	10705	5527	4	0	6191
96718	1397	1376913825000	10705	5527	5	0	6192
96719	1397	1376903824000	10705	5527	6	0	6193
96721	43	66720469890000	10705	5527	8	0	1
96733	1397	1376883822000	10708	5528	0	0	6195
96734	1726	738272072000	10708	5528	1	0	3148
96735	1397	1376873821000	10709	5529	0	0	6196
96739	1397	1376863820000	10711	5530	1	0	6197
96746	1397	1376853819000	10715	5531	0	0	6198
96747	1726	738252070000	10715	5531	1	0	3150
96752	1726	738242069000	10718	5532	0	0	3151
96753	1397	1376843818000	10718	5532	1	0	6199
96757	1397	1376833817000	10720	5533	1	0	6200
96764	576	82015504938283	10722	5534	0	0	1
96765	1397	1376823816000	10722	5534	1	0	6201
96766	1726	738222067000	10722	5534	2	0	3153
96767	1726	738212066000	10722	5534	3	0	3154
96769	2028	16977223460000	10722	5534	5	0	1
96772	1726	738202065000	10724	5535	0	0	3155
96773	1397	1376803814000	10724	5535	1	0	6203
96833	1397	1378233957000	10725	5418	60	0	\N
96834	1397	1378223956000	10725	5418	61	0	\N
96835	1397	1378213955000	10725	5418	62	0	\N
96836	1397	1378203954000	10725	5418	63	0	\N
96837	1726	740972221000	10725	5418	64	0	\N
96838	1726	740962220000	10725	5418	65	0	\N
96839	1726	740952219000	10725	5418	66	0	\N
96840	1726	739742219000	10725	5418	67	0	\N
96841	1726	739732218000	10725	5418	68	0	\N
96842	1726	739722217000	10725	5418	69	0	\N
96843	1726	739712216000	10725	5418	70	0	\N
96844	1726	739702215000	10725	5418	71	0	\N
96845	1726	739692214000	10725	5418	72	0	\N
96846	1726	739682213000	10725	5418	73	0	\N
96847	1726	739672212000	10725	5418	74	0	\N
96848	1726	739662211000	10725	5418	75	0	\N
96849	1726	739652210000	10725	5418	76	0	\N
96850	1726	739642209000	10725	5418	77	0	\N
96851	1726	739632208000	10725	5418	78	0	\N
96852	1726	739622207000	10725	5418	79	0	\N
96853	1726	739612206000	10725	5418	80	0	\N
96854	1726	739602205000	10725	5418	81	0	\N
96855	1726	739592204000	10725	5418	82	0	\N
96856	1726	739582203000	10725	5418	83	0	\N
96857	1726	739572202000	10725	5418	84	0	\N
96858	1726	739562201000	10725	5418	85	0	\N
96859	1726	739552200000	10725	5418	86	0	\N
96860	1726	739542199000	10725	5418	87	0	\N
96861	1726	739532198000	10725	5418	88	0	\N
96862	1726	739522197000	10725	5418	89	0	\N
96863	1726	739512196000	10725	5418	90	0	\N
96864	1726	739502195000	10725	5418	91	0	\N
96865	1726	739492194000	10725	5418	92	0	\N
96866	1726	739482193000	10725	5418	93	0	\N
96867	1726	739472192000	10725	5418	94	0	\N
96868	1726	739462191000	10725	5418	95	0	\N
96869	1726	739452190000	10725	5418	96	0	\N
96870	1726	739442189000	10725	5418	97	0	\N
96871	1726	739432188000	10725	5418	98	0	\N
96872	1397	1378193953000	10725	5418	99	0	\N
96873	1397	1378183952000	10725	5418	100	0	\N
96874	1397	1378173951000	10725	5418	101	0	\N
96875	1397	1378163950000	10725	5418	102	0	\N
96876	1397	1378153949000	10725	5418	103	0	\N
96877	1397	1378143948000	10725	5418	104	0	\N
96878	1397	1378133947000	10725	5418	105	0	\N
96879	1397	1378123946000	10725	5418	106	0	\N
96880	1397	1378113945000	10725	5418	107	0	\N
96881	1397	1378103944000	10725	5418	108	0	\N
96882	1397	1378093943000	10725	5418	109	0	\N
96883	1397	1378083942000	10725	5418	110	0	\N
96884	1397	1378073941000	10725	5418	111	0	\N
96885	1397	1378063940000	10725	5418	112	0	\N
96886	1397	1378053939000	10725	5418	113	0	\N
96887	1397	1378043938000	10725	5418	114	0	\N
96888	1397	1378033937000	10725	5418	115	0	\N
96889	1397	1378023936000	10725	5418	116	0	\N
96890	1397	1378013935000	10725	5418	117	0	\N
96891	1397	1378003934000	10725	5418	118	0	\N
96892	1397	1377993933000	10725	5418	119	0	\N
96893	1397	1377983932000	10725	5418	120	0	\N
96894	1397	1377973931000	10725	5418	121	0	\N
96895	1397	1377963930000	10725	5418	122	0	\N
96896	1397	1377953929000	10725	5418	123	0	\N
96897	1397	1377943928000	10725	5418	124	0	\N
96898	1397	1377933927000	10725	5418	125	0	\N
96906	576	79210244938283	10727	5535	0	0	\N
96907	576	75052594938283	10727	5535	1	0	\N
96908	1726	738202065000	10727	5535	2	0	\N
96909	1397	1376803814000	10727	5535	3	0	\N
96910	1397	1376793813000	10727	5535	4	0	\N
96911	1726	738192064000	10727	5535	5	0	\N
96912	2028	8682564860000	10727	5535	6	0	\N
96913	2028	5705929040000	10727	5535	7	0	\N
96914	2028	1294268170000	10727	5535	8	0	\N
96917	1726	738172062000	10729	5538	0	0	\N
96918	1397	1376773811000	10729	5538	1	0	\N
96920	1726	738172062000	10731	5538	0	0	\N
96921	1397	1376773811000	10731	5538	1	0	\N
96922	1726	738172062000	10732	5538	0	0	\N
96923	1397	1376773811000	10732	5538	1	0	\N
96929	1726	738152060000	10735	5540	0	0	\N
96930	1397	1376753809000	10735	5540	1	0	\N
96939	1726	738102055000	10738	5543	0	0	\N
96940	1397	1376703804000	10738	5543	1	0	\N
96941	1726	738102055000	10739	5543	0	0	\N
96942	1397	1376703804000	10739	5543	1	0	\N
96952	1397	1376673801000	10743	5545	0	0	\N
96953	1726	738072052000	10743	5545	1	0	\N
96954	1449	8053000459	10743	5545	3	0	\N
96957	1726	738062051000	10745	5546	0	0	\N
96958	1397	1376663800000	10745	5546	1	0	\N
96959	1726	738052050000	10746	5547	0	0	\N
96960	1397	1376653799000	10746	5547	1	0	\N
96963	1397	1376643798000	10748	5548	0	0	\N
96964	1726	738042049000	10748	5548	1	0	\N
96965	1726	736832049000	10748	5548	2	0	\N
96966	1397	1376643798000	10749	5548	0	0	\N
96967	1726	738042049000	10749	5548	1	0	\N
96968	1726	736832049000	10749	5548	2	0	\N
96901	1397	1376793813000	10726	5536	2	0	6204
96902	1726	738192064000	10726	5536	3	0	3156
96903	2028	8682564860000	10726	5536	4	0	2
96904	2028	5705929040000	10726	5536	5	0	3
96905	2028	1294268170000	10726	5536	6	0	4
96916	1397	1376783812000	10728	5537	1	0	6205
96919	1726	738172062000	10730	5538	0	0	3158
96924	1397	1376773811000	10733	5539	0	0	6206
96925	1397	1376763810000	10733	5539	1	0	6207
96926	1726	738162061000	10733	5539	2	0	3159
96928	1397	1376753809000	10734	5540	1	0	6208
96931	1397	1376743808000	10736	5541	0	0	6209
96932	1397	1376733807000	10736	5541	1	0	6210
96933	1726	738142059000	10736	5541	2	0	3161
96935	1397	1376723806000	10737	5542	0	0	6211
96936	1397	1376713805000	10737	5542	1	0	6212
96937	1726	738122057000	10737	5542	2	0	3163
96938	1726	738112056000	10737	5542	3	0	3164
96943	1726	738102055000	10740	5543	0	0	3165
96945	1726	738092054000	10741	5544	0	0	3166
96946	1726	738082053000	10741	5544	1	0	3167
96947	1397	1376693803000	10741	5544	2	0	6214
96948	1397	1376683802000	10741	5544	3	0	6215
96949	1397	1376673801000	10742	5545	0	0	6216
96951	1449	8053000459	10742	5545	3	0	5
96955	1726	738062051000	10744	5546	0	0	3169
96956	1397	1376663800000	10744	5546	1	0	6217
96961	1726	738052050000	10747	5547	0	0	3170
96972	1397	1376643798000	10751	5548	0	0	\N
96973	1726	738042049000	10751	5548	1	0	\N
96974	1726	736832049000	10751	5548	2	0	\N
96992	1397	1376563790000	10757	5552	0	0	\N
96993	1726	735542041000	10757	5552	1	0	\N
96996	1397	1376543788000	10759	5554	0	0	\N
96997	1397	1376533787000	10759	5554	1	0	\N
96998	1726	735522039000	10759	5554	2	0	\N
96999	1726	735512038000	10759	5554	3	0	\N
97000	1397	1376543788000	10760	5554	0	0	\N
97001	1397	1376533787000	10760	5554	1	0	\N
97002	1726	735522039000	10760	5554	2	0	\N
97003	1726	735512038000	10760	5554	3	0	\N
97004	1397	1376543788000	10761	5554	0	0	\N
97005	1397	1376533787000	10761	5554	1	0	\N
97006	1726	735522039000	10761	5554	2	0	\N
97007	1726	735512038000	10761	5554	3	0	\N
97020	1726	735482035000	10766	5557	0	0	\N
97021	1726	735472034000	10766	5557	1	0	\N
97022	1397	1376503784000	10766	5557	2	0	\N
97023	1397	1376493783000	10766	5557	3	0	\N
97024	1726	735482035000	10767	5557	0	0	\N
97025	1726	735472034000	10767	5557	1	0	\N
97026	1397	1376503784000	10767	5557	2	0	\N
97027	1397	1376493783000	10767	5557	3	0	\N
97034	1474	17555384000000	10770	5559	0	0	\N
97035	1397	1376483782000	10770	5559	1	0	\N
97036	1474	17554374000000	10770	5559	2	0	\N
97037	1726	735452032000	10770	5559	3	0	\N
97038	1474	17555384000000	10771	5559	0	0	\N
97039	1397	1376483782000	10771	5559	1	0	\N
97040	1474	17554374000000	10771	5559	2	0	\N
97041	1726	735452032000	10771	5559	3	0	\N
97042	1397	1376473781000	10772	5560	0	0	\N
97043	1726	735442031000	10772	5560	1	0	\N
97044	1726	735432030000	10772	5560	2	0	\N
97045	1397	1376463780000	10772	5560	3	0	\N
97054	1474	11594834293650	10775	5562	0	0	\N
97055	1726	735412028000	10775	5562	1	0	\N
97056	1726	735402027000	10775	5562	2	0	\N
97057	1397	1376443778000	10775	5562	3	0	\N
97058	1397	1376433777000	10775	5562	4	0	\N
97068	1474	9014010660887	10779	5564	0	0	\N
97069	1397	1376413775000	10779	5564	1	0	\N
97070	1726	735392026000	10779	5564	2	0	\N
97071	1474	9014010660887	10780	5564	0	0	\N
97072	1397	1376413775000	10780	5564	1	0	\N
97073	1726	735392026000	10780	5564	2	0	\N
97078	1397	1376403774000	10782	5565	0	0	\N
97079	1397	1376393773000	10782	5565	1	0	\N
97080	1726	735382025000	10782	5565	2	0	\N
97081	1726	735372024000	10782	5565	3	0	\N
97082	1397	1376403774000	10783	5565	0	0	\N
97083	1397	1376393773000	10783	5565	1	0	\N
97084	1726	735382025000	10783	5565	2	0	\N
97085	1726	735372024000	10783	5565	3	0	\N
97086	576	82015504938283	10784	5443	0	0	\N
97087	576	79210244938283	10784	5443	1	0	\N
97088	576	75052594938283	10784	5443	2	0	\N
97089	576	67235544938283	10784	5443	3	0	\N
97090	1397	1378033937000	10784	5443	4	0	\N
97091	1397	1378023936000	10784	5443	5	0	\N
97092	1559	20398311000000	10784	5443	6	0	\N
97093	1474	17555384000000	10784	5443	7	0	\N
97094	1474	17554374000000	10784	5443	8	0	\N
97095	1474	15419858987543	10784	5443	9	0	\N
97096	1474	11594834293650	10784	5443	10	0	\N
97097	1474	9014010660887	10784	5443	11	0	\N
97098	1397	1378013935000	10784	5443	12	0	\N
97099	1397	1378003934000	10784	5443	13	0	\N
97100	1397	1377993933000	10784	5443	14	0	\N
97101	1397	1377983932000	10784	5443	15	0	\N
97102	1397	1377973931000	10784	5443	16	0	\N
97103	1397	1377963930000	10784	5443	17	0	\N
97104	1397	1377953929000	10784	5443	18	0	\N
96971	1726	736832049000	10750	5548	2	0	3172
96975	1397	1376633797000	10752	5549	0	0	6220
96976	1726	735622049000	10752	5549	1	0	3173
96977	1726	735612048000	10752	5549	2	0	3174
96978	1726	735602047000	10752	5549	3	0	3175
96980	1397	1376623796000	10752	5549	5	0	6221
96981	1397	1376613795000	10752	5549	6	0	6222
96982	1726	735582045000	10753	5550	0	0	3177
96983	1726	735572044000	10753	5550	1	0	3178
96984	1726	735562043000	10753	5550	2	0	3179
96986	1397	1376593793000	10753	5550	4	0	6224
96987	1397	1376583792000	10753	5550	5	0	6225
96988	1397	1376573791000	10754	5551	0	0	6226
96989	1726	735552042000	10754	5551	1	0	3180
96991	1726	735542041000	10756	5552	1	0	3181
96994	1726	735532040000	10758	5553	0	0	3182
96995	1397	1376553789000	10758	5553	1	0	6228
97008	1397	1376543788000	10762	5554	0	0	6229
97009	1397	1376533787000	10762	5554	1	0	6230
97011	1726	735512038000	10762	5554	3	0	3184
97012	1726	735502037000	10763	5555	0	0	3185
97013	1397	1376523786000	10763	5555	1	0	6231
97014	1726	735492036000	10764	5556	0	0	3186
97015	1397	1376513785000	10764	5556	1	0	6232
97017	1726	735472034000	10765	5557	1	0	3188
97018	1397	1376503784000	10765	5557	2	0	6233
97019	1397	1376493783000	10765	5557	3	0	6234
97028	1726	735462033000	10768	5558	0	0	3189
97030	1474	17555384000000	10769	5559	0	0	7
97031	1397	1376483782000	10769	5559	1	0	6235
97032	1474	17554374000000	10769	5559	2	0	8
97033	1726	735452032000	10769	5559	3	0	3190
97046	1397	1376473781000	10773	5560	0	0	6236
97048	1726	735432030000	10773	5560	2	0	3192
97049	1397	1376463780000	10773	5560	3	0	6237
97050	1726	735422029000	10774	5561	0	0	3193
97051	1559	20398311000000	10774	5561	1	0	1
97052	1397	1376453779000	10774	5561	2	0	6238
97059	1474	11594834293650	10776	5562	0	0	10
97060	1726	735412028000	10776	5562	1	0	3194
97061	1726	735402027000	10776	5562	2	0	3195
97062	1397	1376443778000	10776	5562	3	0	6239
97064	1397	1376423776000	10777	5563	0	0	6241
97065	1474	9014010660887	10778	5564	0	0	11
97066	1397	1376413775000	10778	5564	1	0	6242
97067	1726	735392026000	10778	5564	2	0	3196
97074	1397	1376403774000	10781	5565	0	0	6243
97076	1726	735382025000	10781	5565	2	0	3197
97077	1726	735372024000	10781	5565	3	0	3198
97105	1397	1377943928000	10784	5443	19	0	\N
97106	1397	1377933927000	10784	5443	20	0	\N
97107	1397	1377923926000	10784	5443	21	0	\N
97108	1397	1377913925000	10784	5443	22	0	\N
97109	1397	1377903924000	10784	5443	23	0	\N
97110	1397	1377893923000	10784	5443	24	0	\N
97111	1397	1377883922000	10784	5443	25	0	\N
97112	1397	1377873921000	10784	5443	26	0	\N
97113	1397	1377863920000	10784	5443	27	0	\N
97114	1397	1377853919000	10784	5443	28	0	\N
97115	1397	1377843918000	10784	5443	29	0	\N
97116	1397	1377833917000	10784	5443	30	0	\N
97117	1397	1377823916000	10784	5443	31	0	\N
97118	1397	1377813915000	10784	5443	32	0	\N
97119	1397	1377803914000	10784	5443	33	0	\N
97120	1397	1377793913000	10784	5443	34	0	\N
97121	1397	1377783912000	10784	5443	35	0	\N
97122	1397	1377773911000	10784	5443	36	0	\N
97123	1397	1377763910000	10784	5443	37	0	\N
97124	1397	1377753909000	10784	5443	38	0	\N
97125	1397	1377743908000	10784	5443	39	0	\N
97126	1397	1377733907000	10784	5443	40	0	\N
97127	1397	1377723906000	10784	5443	41	0	\N
97128	1397	1377713905000	10784	5443	42	0	\N
97129	1397	1377703904000	10784	5443	43	0	\N
97130	1397	1377693903000	10784	5443	44	0	\N
97131	1397	1377683902000	10784	5443	45	0	\N
97132	1397	1377673901000	10784	5443	46	0	\N
97133	1397	1377663900000	10784	5443	47	0	\N
97134	1397	1377653899000	10784	5443	48	0	\N
97135	1397	1377643898000	10784	5443	49	0	\N
97136	1397	1377633897000	10784	5443	50	0	\N
97137	1397	1377623896000	10784	5443	51	0	\N
97138	1397	1377613895000	10784	5443	52	0	\N
97139	1397	1377603894000	10784	5443	53	0	\N
97140	1397	1377593893000	10784	5443	54	0	\N
97141	1397	1377583892000	10784	5443	55	0	\N
97142	1397	1377573891000	10784	5443	56	0	\N
97143	1397	1377563890000	10784	5443	57	0	\N
97144	1397	1377553889000	10784	5443	58	0	\N
97145	1397	1377543888000	10784	5443	59	0	\N
97146	1397	1377533887000	10784	5443	60	0	\N
97147	1397	1377523886000	10784	5443	61	0	\N
97148	1397	1377513885000	10784	5443	62	0	\N
97149	1397	1377503884000	10784	5443	63	0	\N
97150	1397	1377493883000	10784	5443	64	0	\N
97151	1397	1377483882000	10784	5443	65	0	\N
97152	1397	1377473881000	10784	5443	66	0	\N
97153	1397	1377463880000	10784	5443	67	0	\N
97154	1397	1377453879000	10784	5443	68	0	\N
97155	1397	1377443878000	10784	5443	69	0	\N
97156	1397	1377433877000	10784	5443	70	0	\N
97157	1397	1377423876000	10784	5443	71	0	\N
97158	1397	1377413875000	10784	5443	72	0	\N
97159	1397	1377403874000	10784	5443	73	0	\N
97160	1397	1377393873000	10784	5443	74	0	\N
97161	1397	1377383872000	10784	5443	75	0	\N
97162	1397	1377373871000	10784	5443	76	0	\N
97163	1397	1377363870000	10784	5443	77	0	\N
97164	1397	1377353869000	10784	5443	78	0	\N
97165	1397	1377343868000	10784	5443	79	0	\N
97166	1397	1377333867000	10784	5443	80	0	\N
97167	1397	1377323866000	10784	5443	81	0	\N
97168	1397	1377313865000	10784	5443	82	0	\N
97169	1397	1377303864000	10784	5443	83	0	\N
97170	1397	1377293863000	10784	5443	84	0	\N
97171	1397	1377283862000	10784	5443	85	0	\N
97172	1397	1377273861000	10784	5443	86	0	\N
97173	1397	1377263860000	10784	5443	87	0	\N
97174	1397	1377253859000	10784	5443	88	0	\N
97175	1397	1377243858000	10784	5443	89	0	\N
97176	1397	1377233857000	10784	5443	90	0	\N
97177	1397	1377223856000	10784	5443	91	0	\N
97178	1397	1377213855000	10784	5443	92	0	\N
97179	1397	1377203854000	10784	5443	93	0	\N
97180	1397	1377193853000	10784	5443	94	0	\N
97181	1397	1377183852000	10784	5443	95	0	\N
97182	1397	1377173851000	10784	5443	96	0	\N
97183	1397	1377163850000	10784	5443	97	0	\N
97184	1397	1377153849000	10784	5443	98	0	\N
97185	1397	1377143848000	10784	5443	99	0	\N
97186	1397	1377133847000	10784	5443	100	0	\N
97187	1397	1377123846000	10784	5443	101	0	\N
97188	1397	1377113845000	10784	5443	102	0	\N
97189	1397	1377103844000	10784	5443	103	0	\N
97190	1397	1377093843000	10784	5443	104	0	\N
97191	1397	1377083842000	10784	5443	105	0	\N
97192	1397	1377073841000	10784	5443	106	0	\N
97193	1397	1377063840000	10784	5443	107	0	\N
97194	1397	1377053839000	10784	5443	108	0	\N
97195	1397	1377043838000	10784	5443	109	0	\N
97196	1397	1377033837000	10784	5443	110	0	\N
97197	1397	1377023836000	10784	5443	111	0	\N
97198	1397	1377013835000	10784	5443	113	0	\N
97199	1397	1377003834000	10784	5443	114	0	\N
97200	1397	1376993833000	10784	5443	115	0	\N
97201	1397	1376983832000	10784	5443	116	0	\N
97202	1397	1376973831000	10784	5443	117	0	\N
97203	1397	1376963830000	10784	5443	118	0	\N
97204	1397	1376953829000	10784	5443	119	0	\N
97205	1397	1376943828000	10784	5443	120	0	\N
97206	1397	1376933827000	10784	5443	121	0	\N
97207	1397	1376923826000	10784	5443	122	0	\N
97208	1397	1376913825000	10784	5443	123	0	\N
97209	1397	1376903824000	10784	5443	124	0	\N
97210	1397	1376893823000	10784	5443	125	0	\N
97215	1474	1823334000023	10786	5567	0	0	\N
97216	1397	1376373771000	10786	5567	1	0	\N
97217	1726	734142022000	10786	5567	2	0	\N
97232	1726	734082016000	10791	5571	0	0	\N
97233	1726	734072015000	10791	5571	1	0	\N
97234	1726	734062014000	10791	5571	2	0	\N
97235	1397	1376313765000	10791	5571	3	0	\N
97236	1397	1376303764000	10791	5571	4	0	\N
97237	1397	1376293763000	10791	5571	5	0	\N
97213	1397	1376383772000	10785	5566	2	0	6245
97214	1718	15016631889008	10785	5566	3	0	3
97218	1474	1823334000023	10787	5567	0	0	12
97219	1397	1376373771000	10787	5567	1	0	6246
97220	1726	734142022000	10787	5567	2	0	3201
97222	1397	1376363770000	10788	5568	1	0	6247
97223	1397	1376353769000	10788	5568	2	0	6248
97224	1726	734122020000	10788	5568	3	0	3203
97225	1726	734112019000	10789	5569	0	0	3204
97226	1397	1376343768000	10789	5569	1	0	6249
97228	1397	1376333767000	10790	5570	1	0	6250
97229	1397	1376323766000	10790	5570	2	0	6251
97230	1726	734092017000	10790	5570	3	0	3206
97231	1718	15015630889008	10790	5570	4	0	4
97239	1726	734072015000	10792	5571	1	0	3208
97240	1726	734062014000	10792	5571	2	0	3209
97249	1894	105000000	10794	5572	0	0	\N
97250	1726	734052013000	10794	5572	1	0	\N
97251	1726	734042012000	10794	5572	2	0	\N
97252	1397	1376283762000	10794	5572	3	0	\N
97253	1397	1376273761000	10794	5572	4	0	\N
97254	1894	105000000	10795	5572	0	0	\N
97255	1726	734052013000	10795	5572	1	0	\N
97256	1726	734042012000	10795	5572	2	0	\N
97257	1397	1376283762000	10795	5572	3	0	\N
97258	1397	1376273761000	10795	5572	4	0	\N
97259	1397	1376263760000	10796	5573	0	0	\N
97260	1726	734032011000	10796	5573	1	0	\N
97261	1397	1376263760000	10797	5573	0	0	\N
97262	1726	734032011000	10797	5573	1	0	\N
97263	1397	1376263760000	10798	5573	0	0	\N
97264	1726	734032011000	10798	5573	1	0	\N
97276	1894	105000000	10802	5444	0	0	\N
97277	1474	1822334000023	10802	5444	1	0	\N
97278	1397	1376883822000	10802	5444	2	0	\N
97279	1397	1376873821000	10802	5444	3	0	\N
97280	1397	1376863820000	10802	5444	4	0	\N
97281	1397	1376853819000	10802	5444	5	0	\N
97282	1397	1376843818000	10802	5444	6	0	\N
97283	1559	17202861000000	10802	5444	7	0	\N
97284	1397	1376833817000	10802	5444	8	0	\N
97285	1397	1376823816000	10802	5444	9	0	\N
97286	1397	1376813815000	10802	5444	10	0	\N
97287	1397	1376803814000	10802	5444	11	0	\N
97288	1397	1376793813000	10802	5444	12	0	\N
97289	1397	1376783812000	10802	5444	13	0	\N
97290	1397	1376773811000	10802	5444	14	0	\N
97291	1397	1376763810000	10802	5444	15	0	\N
97292	1397	1376753809000	10802	5444	16	0	\N
97293	1397	1376743808000	10802	5444	17	0	\N
97294	1397	1376733807000	10802	5444	18	0	\N
97295	1397	1376723806000	10802	5444	19	0	\N
97296	1397	1376713805000	10802	5444	20	0	\N
97297	1397	1376703804000	10802	5444	21	0	\N
97298	1397	1376693803000	10802	5444	22	0	\N
97299	1397	1376683802000	10802	5444	23	0	\N
97300	1397	1376673801000	10802	5444	24	0	\N
97301	1397	1376663800000	10802	5444	25	0	\N
97302	1397	1376653799000	10802	5444	26	0	\N
97303	1397	1376643798000	10802	5444	27	0	\N
97304	1397	1376633797000	10802	5444	28	0	\N
97305	1397	1376623796000	10802	5444	29	0	\N
97306	1397	1376613795000	10802	5444	30	0	\N
97307	1397	1376603794000	10802	5444	31	0	\N
97308	1397	1376593793000	10802	5444	32	0	\N
97309	1397	1376583792000	10802	5444	33	0	\N
97310	1397	1376573791000	10802	5444	34	0	\N
97311	1397	1376563790000	10802	5444	35	0	\N
97312	1397	1376553789000	10802	5444	36	0	\N
97313	1397	1376543788000	10802	5444	37	0	\N
97314	1397	1376533787000	10802	5444	38	0	\N
97315	1397	1376523786000	10802	5444	39	0	\N
97316	1397	1376513785000	10802	5444	40	0	\N
97317	1397	1376503784000	10802	5444	41	0	\N
97318	1397	1376493783000	10802	5444	42	0	\N
97319	1397	1376483782000	10802	5444	43	0	\N
97320	1397	1376473781000	10802	5444	44	0	\N
97321	1397	1376463780000	10802	5444	45	0	\N
97322	1397	1376453779000	10802	5444	46	0	\N
97323	1397	1376443778000	10802	5444	47	0	\N
97324	1397	1376433777000	10802	5444	48	0	\N
97325	1397	1376423776000	10802	5444	49	0	\N
97326	1397	1376413775000	10802	5444	50	0	\N
97327	1397	1376403774000	10802	5444	51	0	\N
97328	1397	1376393773000	10802	5444	52	0	\N
97329	1397	1376383772000	10802	5444	53	0	\N
97330	1397	1376373771000	10802	5444	54	0	\N
97331	1397	1376363770000	10802	5444	55	0	\N
97332	1397	1376353769000	10802	5444	56	0	\N
97333	1397	1376343768000	10802	5444	57	0	\N
97334	1397	1376333767000	10802	5444	58	0	\N
97335	1397	1376323766000	10802	5444	59	0	\N
97336	1397	1376313765000	10802	5444	60	0	\N
97337	1397	1376303764000	10802	5444	61	0	\N
97338	1397	1376293763000	10802	5444	62	0	\N
97339	1397	1376283762000	10802	5444	63	0	\N
97340	1397	1376273761000	10802	5444	64	0	\N
97341	1397	1376263760000	10802	5444	65	0	\N
97342	1397	1376253759000	10802	5444	66	0	\N
97343	1397	1376243758000	10802	5444	67	0	\N
97344	1397	1376233757000	10802	5444	68	0	\N
97345	1397	1376223756000	10802	5444	69	0	\N
97346	1726	739422187000	10802	5444	70	0	\N
97347	1726	739412186000	10802	5444	71	0	\N
97348	1726	739402185000	10802	5444	72	0	\N
97349	1726	739392184000	10802	5444	73	0	\N
97350	1726	739382183000	10802	5444	74	0	\N
97351	1726	739372182000	10802	5444	75	0	\N
97352	1726	739362181000	10802	5444	76	0	\N
97353	1726	739352180000	10802	5444	77	0	\N
97354	1726	739342179000	10802	5444	78	0	\N
97355	1726	739332178000	10802	5444	79	0	\N
97356	1726	739322177000	10802	5444	80	0	\N
97357	1726	739312176000	10802	5444	81	0	\N
97358	1726	739302175000	10802	5444	82	0	\N
97359	1726	739292174000	10802	5444	83	0	\N
97360	1726	739282173000	10802	5444	84	0	\N
97361	1726	739272172000	10802	5444	85	0	\N
97362	1726	739262171000	10802	5444	86	0	\N
97363	1726	739252170000	10802	5444	87	0	\N
97364	1726	739242169000	10802	5444	88	0	\N
97365	1726	739232168000	10802	5444	89	0	\N
97366	1726	739222167000	10802	5444	90	0	\N
97367	1726	739212166000	10802	5444	91	0	\N
97368	1726	739202165000	10802	5444	92	0	\N
97369	1726	739192164000	10802	5444	93	0	\N
97370	1726	739182163000	10802	5444	94	0	\N
97371	1726	739172162000	10802	5444	95	0	\N
97372	1726	739162161000	10802	5444	96	0	\N
97373	1726	739152160000	10802	5444	97	0	\N
97374	1726	739142159000	10802	5444	98	0	\N
97375	1726	739132158000	10802	5444	99	0	\N
97376	1726	739122157000	10802	5444	100	0	\N
97243	1397	1376293763000	10792	5571	5	0	6254
97244	1894	105000000	10793	5572	0	0	1
97245	1726	734052013000	10793	5572	1	0	3210
97246	1726	734042012000	10793	5572	2	0	3211
97247	1397	1376283762000	10793	5572	3	0	6255
97265	1397	1376263760000	10799	5573	0	0	6257
97266	1726	734032011000	10799	5573	1	0	3212
97267	1397	1376253759000	10800	5574	0	0	6258
97268	1726	734022010000	10800	5574	1	0	3213
97269	1397	1376243758000	10800	5574	2	0	6259
97271	1726	734012009000	10800	5574	4	0	3214
97272	1397	1376233757000	10801	5575	0	0	6260
97273	1397	1376223756000	10801	5575	1	0	6261
97274	1726	734002008000	10801	5575	2	0	3215
97377	1726	739112156000	10802	5444	101	0	\N
97378	1726	739102155000	10802	5444	102	0	\N
97379	1726	739092154000	10802	5444	103	0	\N
97380	1726	739082153000	10802	5444	104	0	\N
97381	1726	739072152000	10802	5444	105	0	\N
97382	1726	739062151000	10802	5444	106	0	\N
97383	1726	739052150000	10802	5444	107	0	\N
97384	1726	739042149000	10802	5444	108	0	\N
97385	1726	739032148000	10802	5444	109	0	\N
97386	1726	739022147000	10802	5444	110	0	\N
97387	1726	739012146000	10802	5444	111	0	\N
97388	1726	739002145000	10802	5444	113	0	\N
97389	1726	738992144000	10802	5444	114	0	\N
97390	1726	738982143000	10802	5444	115	0	\N
97391	1726	738972142000	10802	5444	116	0	\N
97392	1726	738962141000	10802	5444	117	0	\N
97393	1726	738952140000	10802	5444	118	0	\N
97394	1726	738942139000	10802	5444	119	0	\N
97395	1726	738932138000	10802	5444	120	0	\N
97396	1726	738922137000	10802	5444	121	0	\N
97397	1726	738912136000	10802	5444	122	0	\N
97398	1726	738902135000	10802	5444	123	0	\N
97399	1726	738892134000	10802	5444	124	0	\N
97400	1726	738882133000	10802	5444	125	0	\N
97401	1726	733982006000	10803	5576	0	0	\N
97402	1726	733972005000	10803	5576	1	0	\N
97403	1397	1376213755000	10803	5576	2	0	\N
97404	1397	1376203754000	10803	5576	3	0	\N
97411	1397	1376183752000	10806	5578	0	0	\N
97412	1726	733952003000	10806	5578	1	0	\N
97413	1559	13186952000000	10806	5578	2	0	\N
97414	1397	1376183752000	10807	5578	0	0	\N
97415	1726	733952003000	10807	5578	1	0	\N
97416	1559	13186952000000	10807	5578	2	0	\N
97420	1894	105000000	10809	5419	0	0	\N
97421	576	79210244938283	10809	5419	1	0	\N
97422	576	75052594938283	10809	5419	2	0	\N
97423	576	67235544938283	10809	5419	3	0	\N
97424	1559	20398311000000	10809	5419	4	0	\N
97425	1474	17555384000000	10809	5419	5	0	\N
97426	1397	1377923926000	10809	5419	6	0	\N
97427	1397	1377913925000	10809	5419	7	0	\N
97428	1397	1377903924000	10809	5419	8	0	\N
97429	1397	1377893923000	10809	5419	9	0	\N
97430	1397	1377883922000	10809	5419	10	0	\N
97431	1474	17554374000000	10809	5419	11	0	\N
97432	1474	15419858987543	10809	5419	12	0	\N
97433	1474	11594834293650	10809	5419	13	0	\N
97434	1474	9014010660887	10809	5419	14	0	\N
97435	1474	1822334000023	10809	5419	15	0	\N
97436	1397	1377873921000	10809	5419	16	0	\N
97437	1397	1377863920000	10809	5419	17	0	\N
97438	1397	1377853919000	10809	5419	18	0	\N
97439	1559	17202861000000	10809	5419	19	0	\N
97440	1397	1377843918000	10809	5419	20	0	\N
97441	1397	1377833917000	10809	5419	21	0	\N
97442	1397	1377823916000	10809	5419	22	0	\N
97443	1397	1377813915000	10809	5419	24	0	\N
97444	1397	1377803914000	10809	5419	25	0	\N
97445	1397	1377793913000	10809	5419	26	0	\N
97446	1397	1377783912000	10809	5419	27	0	\N
97447	1397	1377773911000	10809	5419	28	0	\N
97448	1397	1377763910000	10809	5419	29	0	\N
97449	1397	1377753909000	10809	5419	30	0	\N
97450	1397	1377743908000	10809	5419	31	0	\N
97451	1397	1377733907000	10809	5419	32	0	\N
97452	1397	1377723906000	10809	5419	33	0	\N
97453	1397	1377713905000	10809	5419	34	0	\N
97454	1397	1377703904000	10809	5419	35	0	\N
97455	1397	1377693903000	10809	5419	36	0	\N
97456	1397	1377683902000	10809	5419	37	0	\N
97457	1397	1377673901000	10809	5419	38	0	\N
97458	1397	1377663900000	10809	5419	39	0	\N
97459	1397	1377653899000	10809	5419	40	0	\N
97460	1397	1377643898000	10809	5419	41	0	\N
97461	1397	1377633897000	10809	5419	42	0	\N
97462	1559	12466911000000	10809	5419	43	0	\N
97463	1397	1377623896000	10809	5419	44	0	\N
97464	1397	1377613895000	10809	5419	45	0	\N
97465	1397	1377603894000	10809	5419	46	0	\N
97466	1397	1377593893000	10809	5419	47	0	\N
97467	1397	1377583892000	10809	5419	48	0	\N
97468	1397	1377573891000	10809	5419	49	0	\N
97469	1397	1377563890000	10809	5419	50	0	\N
97470	1397	1377553889000	10809	5419	51	0	\N
97471	1397	1377543888000	10809	5419	52	0	\N
97472	1397	1377533887000	10809	5419	53	0	\N
97473	1397	1377523886000	10809	5419	54	0	\N
97474	1397	1377513885000	10809	5419	55	0	\N
97475	1397	1377503884000	10809	5419	56	0	\N
97476	1397	1377493883000	10809	5419	57	0	\N
97477	1397	1377483882000	10809	5419	58	0	\N
97478	1397	1377473881000	10809	5419	59	0	\N
97479	1397	1377463880000	10809	5419	60	0	\N
97480	1397	1377453879000	10809	5419	61	0	\N
97481	1397	1377443878000	10809	5419	62	0	\N
97482	1397	1377433877000	10809	5419	63	0	\N
97483	1397	1377423876000	10809	5419	64	0	\N
97484	1397	1377413875000	10809	5419	65	0	\N
97485	1397	1377403874000	10809	5419	66	0	\N
97486	1397	1377393873000	10809	5419	67	0	\N
97487	1397	1377383872000	10809	5419	68	0	\N
97488	1397	1377373871000	10809	5419	69	0	\N
97489	1397	1377363870000	10809	5419	70	0	\N
97490	1397	1377353869000	10809	5419	71	0	\N
97491	1397	1377343868000	10809	5419	72	0	\N
97492	1397	1377333867000	10809	5419	73	0	\N
97493	1397	1377323866000	10809	5419	74	0	\N
97494	1397	1377313865000	10809	5419	75	0	\N
97495	1397	1377303864000	10809	5419	76	0	\N
97496	1397	1377293863000	10809	5419	77	0	\N
97497	1397	1377283862000	10809	5419	78	0	\N
97498	1397	1377273861000	10809	5419	79	0	\N
97499	1397	1377263860000	10809	5419	80	0	\N
97500	1397	1377253859000	10809	5419	81	0	\N
97501	1397	1377243858000	10809	5419	82	0	\N
97502	1397	1377233857000	10809	5419	83	0	\N
97503	1397	1377223856000	10809	5419	84	0	\N
97504	1397	1377213855000	10809	5419	85	0	\N
97505	1397	1377203854000	10809	5419	86	0	\N
97506	1397	1377193853000	10809	5419	87	0	\N
97507	1397	1377183852000	10809	5419	88	0	\N
97508	1397	1377173851000	10809	5419	89	0	\N
97509	1397	1377163850000	10809	5419	90	0	\N
97510	1397	1377153849000	10809	5419	91	0	\N
97511	1397	1377143848000	10809	5419	92	0	\N
97512	1397	1377133847000	10809	5419	93	0	\N
97407	1397	1376213755000	10804	5576	2	0	6262
97408	1397	1376203754000	10804	5576	3	0	6263
97409	1397	1376193753000	10805	5577	0	0	6264
97410	1726	733962004000	10805	5577	1	0	3219
97417	1397	1376183752000	10808	5578	0	0	6265
97419	1559	13186952000000	10808	5578	2	0	3
97513	1397	1377123846000	10809	5419	94	0	\N
97514	1397	1377113845000	10809	5419	95	0	\N
97515	1397	1377103844000	10809	5419	96	0	\N
97516	1397	1377093843000	10809	5419	97	0	\N
97517	1397	1377083842000	10809	5419	98	0	\N
97518	1397	1377073841000	10809	5419	99	0	\N
97519	1397	1377063840000	10809	5419	100	0	\N
97520	1397	1377053839000	10809	5419	101	0	\N
97521	1397	1377043838000	10809	5419	102	0	\N
97522	1397	1377033837000	10809	5419	103	0	\N
97523	1397	1377023836000	10809	5419	104	0	\N
97524	1397	1377013835000	10809	5419	105	0	\N
97525	1397	1377003834000	10809	5419	106	0	\N
97526	1397	1376993833000	10809	5419	107	0	\N
97527	1397	1376983832000	10809	5419	108	0	\N
97528	1397	1376973831000	10809	5419	109	0	\N
97529	1397	1376963830000	10809	5419	110	0	\N
97530	1397	1376953829000	10809	5419	111	0	\N
97531	1397	1376943828000	10809	5419	112	0	\N
97532	1397	1376933827000	10809	5419	113	0	\N
97533	1397	1376923826000	10809	5419	114	0	\N
97534	1397	1376913825000	10809	5419	115	0	\N
97535	1397	1376903824000	10809	5419	116	0	\N
97536	1397	1376893823000	10809	5419	117	0	\N
97537	1397	1376883822000	10809	5419	118	0	\N
97538	1397	1376873821000	10809	5419	119	0	\N
97539	1397	1376863820000	10809	5419	120	0	\N
97540	1397	1376853819000	10809	5419	121	0	\N
97541	1397	1376843818000	10809	5419	122	0	\N
97542	1397	1376833817000	10809	5419	123	0	\N
97543	1397	1376823816000	10809	5419	124	0	\N
97544	1397	1376813815000	10809	5419	125	0	\N
97545	1726	733942002000	10810	5579	0	0	\N
97546	1397	1376173751000	10810	5579	1	0	\N
97547	1718	13283148946880	10810	5579	2	0	\N
97551	1726	733942002000	10812	5579	0	0	\N
97552	1397	1376173751000	10812	5579	1	0	\N
97553	1726	733932001000	10813	5580	0	0	\N
97554	1397	1376163750000	10813	5580	1	0	\N
97557	1397	1376163750000	10815	5580	0	0	\N
97568	589	66335074938283	10817	5582	0	0	\N
97569	1726	733891997000	10817	5582	1	0	\N
97570	1397	1376123746000	10817	5582	2	0	\N
97574	1397	1376113745000	10819	5583	0	0	\N
97575	1726	733881996000	10819	5583	1	0	\N
97578	1397	1376113745000	10821	5583	0	0	\N
97579	1726	733881996000	10821	5583	1	0	\N
97586	1726	732661995000	10824	5585	0	0	\N
97587	1726	731451995000	10824	5585	1	0	\N
97588	1726	731441994000	10824	5585	2	0	\N
97589	1397	1376083742000	10825	5586	0	0	\N
97590	1726	730231994000	10825	5586	1	0	\N
97591	1726	730221993000	10825	5586	2	0	\N
97592	1397	1376083742000	10826	5586	0	0	\N
97593	1726	730231994000	10826	5586	1	0	\N
97594	1726	730221993000	10826	5586	2	0	\N
97605	1726	730191990000	10831	5589	0	0	\N
97606	1397	1376043738000	10831	5589	1	0	\N
97607	1397	1376073741000	10832	5587	0	0	\N
97608	1397	1376063740000	10832	5587	1	0	\N
97609	1397	1376053739000	10832	5587	2	0	\N
97610	1397	1376043738000	10832	5587	3	0	\N
97631	1506	17137520000000	10837	5593	0	0	\N
97632	1506	17137509999713	10837	5593	1	0	\N
97633	1506	17137499997525	10837	5593	2	0	\N
97634	1506	17137489994880	10837	5593	3	0	\N
97635	1506	17137479990959	10837	5593	4	0	\N
97636	1726	728931985000	10837	5593	5	0	\N
97637	1726	728921984000	10837	5593	6	0	\N
97638	1397	1375993733000	10837	5593	7	0	\N
97639	1397	1375983732000	10837	5593	8	0	\N
97640	1506	17137520000000	10838	5593	0	0	\N
97641	1506	17137509999713	10838	5593	1	0	\N
97642	1506	17137499997525	10838	5593	2	0	\N
97643	1506	17137489994880	10838	5593	3	0	\N
97644	1506	17137479990959	10838	5593	4	0	\N
97645	1726	728931985000	10838	5593	5	0	\N
97646	1726	728921984000	10838	5593	6	0	\N
97647	1397	1375993733000	10838	5593	7	0	\N
97648	1397	1375983732000	10838	5593	8	0	\N
97550	1718	13283148946880	10811	5579	2	0	5
97555	1726	733932001000	10814	5580	0	0	3222
97556	1397	1376163750000	10814	5580	1	0	6267
97558	1397	1376153749000	10816	5581	0	0	6268
97559	1397	1376143748000	10816	5581	1	0	6269
97561	1726	733911999000	10816	5581	3	0	3224
97562	1726	733901998000	10816	5581	4	0	3225
97563	1397	1376133747000	10816	5581	5	0	6270
97564	1559	4282582000000	10816	5581	6	0	4
97565	1718	10178556942475	10816	5581	7	0	6
97567	1718	2246675763340	10816	5581	9	0	8
97571	589	66335074938283	10818	5582	0	0	1
97572	1726	733891997000	10818	5582	1	0	3226
97573	1397	1376123746000	10818	5582	2	0	6271
97577	1726	733881996000	10820	5583	1	0	3227
97580	1726	733871995000	10822	5584	0	0	3228
97581	1397	1376103744000	10822	5584	1	0	6273
97582	1397	1376093743000	10822	5584	2	0	6274
97583	1726	732661995000	10823	5585	0	0	3229
97585	1726	731441994000	10823	5585	2	0	3231
97595	1397	1376083742000	10827	5586	0	0	6275
97596	1726	730231994000	10827	5586	1	0	3232
97597	1726	730221993000	10827	5586	2	0	3233
97598	1397	1376073741000	10828	5587	0	0	6276
97600	1726	730201991000	10828	5587	2	0	3235
97601	1397	1376063740000	10828	5587	3	0	6277
97602	1397	1376053739000	10829	5588	0	0	6278
97603	1726	730191990000	10830	5589	0	0	3236
97611	1397	1376033737000	10833	5590	0	0	6280
97612	1397	1376023736000	10833	5590	1	0	6281
97613	1726	730181989000	10833	5590	2	0	3237
97614	1506	17999530000000	10833	5590	3	0	1
97615	1726	730171988000	10833	5590	4	0	3238
97617	1726	728951987000	10834	5591	0	0	3240
97618	1726	728941986000	10834	5591	1	0	3241
97619	1397	1376013735000	10834	5591	2	0	6282
97620	1397	1376003734000	10834	5591	3	0	6283
97621	1506	17137520000000	10836	5593	0	0	2
97623	1506	17137499997525	10836	5593	2	0	4
97624	1506	17137489994880	10836	5593	3	0	5
97625	1506	17137479990959	10836	5593	4	0	6
97626	1726	728931985000	10836	5593	5	0	3242
97628	1726	728911983000	10836	5593	7	0	3244
97629	1397	1375993733000	10836	5593	8	0	6284
97630	1397	1375983732000	10836	5593	9	0	6285
97649	1397	1375973731000	10839	5594	0	0	\N
97650	1506	17137469983586	10839	5594	1	0	\N
97664	1726	728871979000	10843	5596	0	0	\N
97665	1397	1375943728000	10843	5596	1	0	\N
97666	1506	17137449981111	10843	5596	2	0	\N
97667	1506	17137439978466	10843	5596	3	0	\N
97668	1506	17137429974545	10843	5596	4	0	\N
97669	1506	17137419967172	10843	5596	5	0	\N
97670	1726	728871979000	10844	5596	0	0	\N
97671	1397	1375943728000	10844	5596	1	0	\N
97672	1506	17137449981111	10844	5596	2	0	\N
97673	1506	17137439978466	10844	5596	3	0	\N
97674	1506	17137429974545	10844	5596	4	0	\N
97675	1506	17137419967172	10844	5596	5	0	\N
97685	1506	12015743967172	10847	5599	0	0	\N
97686	1506	8094144967172	10847	5599	1	0	\N
97687	1397	1375913725000	10847	5599	2	0	\N
97688	1726	728841976000	10847	5599	3	0	\N
97689	1506	720891967172	10847	5599	4	0	\N
97703	1726	728811973000	10851	5601	0	0	\N
97704	1397	1375883722000	10851	5601	1	0	\N
97715	1445	4357189000000	10854	5445	0	0	\N
97716	589	66335074938283	10854	5445	1	0	\N
97717	1726	738872132000	10854	5445	2	0	\N
97718	1726	738862131000	10854	5445	3	0	\N
97719	1726	738852130000	10854	5445	4	0	\N
97720	1726	738842129000	10854	5445	5	0	\N
97721	1506	17279490000000	10854	5445	6	0	\N
97722	1506	16417480000000	10854	5445	7	0	\N
97723	1506	16417469999713	10854	5445	8	0	\N
97724	1506	16417459997525	10854	5445	9	0	\N
97725	1506	16417449994880	10854	5445	10	0	\N
97726	1506	16417439990959	10854	5445	11	0	\N
97727	1506	16417429983586	10854	5445	12	0	\N
97728	1506	16417419983299	10854	5445	13	0	\N
97729	1506	16417409981111	10854	5445	14	0	\N
97730	1726	738832128000	10854	5445	15	0	\N
97731	1726	738822127000	10854	5445	16	0	\N
97732	1506	16417399978466	10854	5445	17	0	\N
97733	1506	16417389974545	10854	5445	18	0	\N
97734	1506	16417379967172	10854	5445	19	0	\N
97735	1506	16130096967172	10854	5445	20	0	\N
97736	1506	13941688967172	10854	5445	21	0	\N
97737	1506	11295703967172	10854	5445	22	0	\N
97738	1506	7374104967172	10854	5445	23	0	\N
97739	1506	851967172	10854	5445	24	0	\N
97740	1397	1376213755000	10854	5445	25	0	\N
97741	1397	1376203754000	10854	5445	26	0	\N
97742	1397	1376193753000	10854	5445	27	0	\N
97743	1397	1376183752000	10854	5445	28	0	\N
97744	1397	1376173751000	10854	5445	29	0	\N
97745	1397	1376163750000	10854	5445	30	0	\N
97746	1397	1376153749000	10854	5445	31	0	\N
97747	1397	1376143748000	10854	5445	32	0	\N
97748	1397	1376133747000	10854	5445	33	0	\N
97749	1397	1376123746000	10854	5445	34	0	\N
97750	1397	1376113745000	10854	5445	35	0	\N
97751	1397	1376103744000	10854	5445	36	0	\N
97752	1397	1376093743000	10854	5445	37	0	\N
97753	1397	1376083742000	10854	5445	38	0	\N
97754	1397	1376073741000	10854	5445	39	0	\N
97755	1397	1376063740000	10854	5445	40	0	\N
97756	1397	1376053739000	10854	5445	41	0	\N
97757	1397	1376043738000	10854	5445	42	0	\N
97758	1397	1376033737000	10854	5445	43	0	\N
97759	1397	1376023736000	10854	5445	44	0	\N
97760	1397	1376013735000	10854	5445	45	0	\N
97761	1397	1376003734000	10854	5445	46	0	\N
97762	1726	738812126000	10854	5445	47	0	\N
97763	1726	738802125000	10854	5445	48	0	\N
97764	1726	738792124000	10854	5445	49	0	\N
97765	1726	738782123000	10854	5445	50	0	\N
97766	1726	738772122000	10854	5445	51	0	\N
97767	1726	738762121000	10854	5445	52	0	\N
97768	1726	738752120000	10854	5445	53	0	\N
97769	1726	738742119000	10854	5445	54	0	\N
97770	1726	738732118000	10854	5445	55	0	\N
97771	1726	738722117000	10854	5445	56	0	\N
97772	1726	738712116000	10854	5445	57	0	\N
97773	1726	738702115000	10854	5445	58	0	\N
97774	1726	738692114000	10854	5445	59	0	\N
97775	1726	738682113000	10854	5445	60	0	\N
97776	1726	738672112000	10854	5445	61	0	\N
97777	1726	738662111000	10854	5445	62	0	\N
97778	1397	1375993733000	10854	5445	63	0	\N
97779	1397	1375983732000	10854	5445	64	0	\N
97780	1397	1375973731000	10854	5445	65	0	\N
97781	1397	1375963730000	10854	5445	66	0	\N
97782	1397	1375953729000	10854	5445	67	0	\N
97783	1397	1375943728000	10854	5445	68	0	\N
97784	1397	1375933727000	10854	5445	69	0	\N
97653	1445	4357189000000	10841	5595	0	0	6
97654	1726	728901982000	10841	5595	1	0	3245
97655	1397	1375963730000	10841	5595	2	0	6287
97656	1506	17137459983299	10841	5595	3	0	8
97657	1397	1375953729000	10841	5595	4	0	6288
97659	1726	728881980000	10841	5595	6	0	3247
97660	1506	17137449981111	10842	5596	0	0	9
97661	1506	17137439978466	10842	5596	1	0	10
97662	1506	17137429974545	10842	5596	2	0	11
97663	1506	17137419967172	10842	5596	3	0	12
97677	1506	14661728967172	10845	5597	1	0	14
97678	1726	728871979000	10845	5597	2	0	3248
97679	1726	728861978000	10845	5597	3	0	3249
97680	1397	1375943728000	10845	5597	4	0	6289
97682	2039	980000000	10845	5597	6	0	1
97683	1397	1375923726000	10846	5598	0	0	6291
97684	1726	728851977000	10846	5598	1	0	3250
97690	1506	12015743967172	10848	5599	0	0	15
97691	1506	8094144967172	10848	5599	1	0	16
97693	1726	728841976000	10848	5599	3	0	3251
97694	1506	720891967172	10848	5599	4	0	17
97695	1397	1375903724000	10849	5600	0	0	6293
97696	1397	1375893723000	10849	5600	1	0	6294
97697	1726	728831975000	10849	5600	2	0	3252
97699	2038	199000000	10849	5600	4	0	1
97700	2038	109000000	10849	5600	5	0	2
97701	1726	728811973000	10850	5601	0	0	3254
97702	1397	1375883722000	10850	5601	1	0	6295
97706	1397	1375863720000	10852	5602	1	0	6297
97707	1726	728801972000	10852	5602	2	0	3255
97708	1726	728791971000	10852	5602	3	0	3256
97709	1397	1375853719000	10853	5603	0	0	6298
97710	1397	1375843718000	10853	5603	1	0	6299
97712	1397	1375833717000	10853	5603	3	0	6300
97713	1726	728771969000	10853	5603	4	0	3258
97714	1726	728761968000	10853	5603	5	0	3259
97785	1397	1375923726000	10854	5445	70	0	\N
97786	1397	1375913725000	10854	5445	71	0	\N
97787	1397	1375903724000	10854	5445	72	0	\N
97788	1397	1375893723000	10854	5445	73	0	\N
97789	1397	1375883722000	10854	5445	74	0	\N
97790	1397	1375873721000	10854	5445	75	0	\N
97791	1397	1375863720000	10854	5445	76	0	\N
97792	1397	1375853719000	10854	5445	77	0	\N
97793	1397	1375843718000	10854	5445	78	0	\N
97794	1397	1375833717000	10854	5445	79	0	\N
97795	1559	12466911000000	10854	5445	80	0	\N
97796	1559	3562541000000	10854	5445	81	0	\N
97797	1726	738652110000	10854	5445	82	0	\N
97798	1726	738642109000	10854	5445	83	0	\N
97799	1726	738632108000	10854	5445	84	0	\N
97800	1726	738622107000	10854	5445	85	0	\N
97801	1726	738612106000	10854	5445	86	0	\N
97802	1726	738602105000	10854	5445	87	0	\N
97803	1726	738592104000	10854	5445	88	0	\N
97804	1726	738582103000	10854	5445	89	0	\N
97805	1726	738572102000	10854	5445	90	0	\N
97806	1726	738562101000	10854	5445	91	0	\N
97807	1726	738552100000	10854	5445	92	0	\N
97808	1726	738542099000	10854	5445	93	0	\N
97809	1726	738532098000	10854	5445	94	0	\N
97810	1726	738522097000	10854	5445	95	0	\N
97811	1726	738512096000	10854	5445	96	0	\N
97812	1726	738502095000	10854	5445	97	0	\N
97813	1726	738492094000	10854	5445	98	0	\N
97814	1726	738482093000	10854	5445	99	0	\N
97815	1726	738472092000	10854	5445	100	0	\N
97816	1726	738462091000	10854	5445	101	0	\N
97817	1726	738452090000	10854	5445	102	0	\N
97818	1726	738442089000	10854	5445	103	0	\N
97819	1726	738432088000	10854	5445	104	0	\N
97820	1726	738422087000	10854	5445	105	0	\N
97821	1726	738412086000	10854	5445	106	0	\N
97822	1726	738402085000	10854	5445	107	0	\N
97823	1726	738392084000	10854	5445	108	0	\N
97824	1726	738382083000	10854	5445	109	0	\N
97825	1726	738372082000	10854	5445	110	0	\N
97826	1726	738362081000	10854	5445	111	0	\N
97827	1726	738352080000	10854	5445	113	0	\N
97828	1726	738342079000	10854	5445	114	0	\N
97829	1726	738332078000	10854	5445	115	0	\N
97834	1397	1375813715000	10857	5605	0	0	\N
97835	1726	728741966000	10857	5605	1	0	\N
97836	1397	1375813715000	10858	5605	0	0	\N
97837	1726	728741966000	10858	5605	1	0	\N
97838	1397	1375813715000	10859	5605	0	0	\N
97839	1726	728741966000	10859	5605	1	0	\N
97840	1726	728731965000	10860	5606	0	0	\N
97841	1397	1375803714000	10860	5606	1	0	\N
97842	1397	1375793713000	10860	5606	2	0	\N
97843	1726	728721964000	10860	5606	3	0	\N
97848	1726	728731965000	10862	5606	0	0	\N
97849	1397	1375803714000	10862	5606	1	0	\N
97850	1397	1375793713000	10862	5606	2	0	\N
97851	1726	728721964000	10862	5606	3	0	\N
97852	1726	728731965000	10863	5606	0	0	\N
97853	1397	1375803714000	10863	5606	1	0	\N
97854	1397	1375793713000	10863	5606	2	0	\N
97855	1726	728721964000	10863	5606	3	0	\N
97858	1397	1375783712000	10865	5607	0	0	\N
97859	1726	728711963000	10865	5607	1	0	\N
97860	1723	22303861909760	10866	5608	0	0	\N
97861	1397	1375773711000	10866	5608	1	0	\N
97862	1726	728701962000	10866	5608	2	0	\N
97871	1723	22303851906979	10869	5609	0	0	\N
97872	1397	1375763710000	10869	5609	1	0	\N
97873	1397	1375753709000	10869	5609	2	0	\N
97874	1726	728691961000	10869	5609	3	0	\N
97875	1726	728681960000	10869	5609	4	0	\N
97876	1723	22303861909760	10870	5599	0	0	\N
97877	1723	22303851906979	10870	5599	1	0	\N
97878	1506	12015743967172	10870	5599	2	0	\N
97879	1506	8094144967172	10870	5599	3	0	\N
97880	1397	1375913725000	10870	5599	4	0	\N
97881	1397	1375903724000	10870	5599	5	0	\N
97882	1397	1375893723000	10870	5599	6	0	\N
97883	1726	728841976000	10870	5599	7	0	\N
97884	1506	720891967172	10870	5599	8	0	\N
97885	1726	728831975000	10870	5599	9	0	\N
97886	1726	728821974000	10870	5599	10	0	\N
97887	1726	728811973000	10870	5599	11	0	\N
97888	1726	728801972000	10870	5599	12	0	\N
97889	1726	728791971000	10870	5599	13	0	\N
97890	1726	728781970000	10870	5599	14	0	\N
97891	1397	1375883722000	10870	5599	15	0	\N
97892	1397	1375873721000	10870	5599	16	0	\N
97893	1397	1375863720000	10870	5599	17	0	\N
97894	1397	1375853719000	10870	5599	18	0	\N
97895	1397	1375843718000	10870	5599	19	0	\N
97896	1397	1375833717000	10870	5599	20	0	\N
97897	1397	1375823716000	10870	5599	21	0	\N
97898	1397	1375813715000	10870	5599	22	0	\N
97899	1397	1375803714000	10870	5599	23	0	\N
97900	1397	1375793713000	10870	5599	24	0	\N
97901	1397	1375783712000	10870	5599	25	0	\N
97902	1397	1375773711000	10870	5599	26	0	\N
97903	1397	1375763710000	10870	5599	27	0	\N
97904	1397	1375753709000	10870	5599	28	0	\N
97905	1726	728771969000	10870	5599	29	0	\N
97906	1726	728761968000	10870	5599	30	0	\N
97907	1726	728751967000	10870	5599	31	0	\N
97908	1726	728741966000	10870	5599	32	0	\N
97909	1726	728731965000	10870	5599	33	0	\N
97910	1726	728721964000	10870	5599	34	0	\N
97911	1726	728711963000	10870	5599	35	0	\N
97912	1726	728701962000	10870	5599	36	0	\N
97913	1726	728691961000	10870	5599	37	0	\N
97914	1726	728681960000	10870	5599	38	0	\N
97915	2038	199000000	10870	5599	39	0	\N
97916	2038	109000000	10870	5599	40	0	\N
97919	1726	728671959000	10873	5610	0	0	\N
97920	1397	1375743708000	10873	5610	1	0	\N
97832	1397	1375813715000	10856	5605	0	0	6302
97833	1726	728741966000	10856	5605	1	0	3261
97844	1726	728731965000	10861	5606	0	0	3262
97845	1397	1375803714000	10861	5606	1	0	6303
97846	1397	1375793713000	10861	5606	2	0	6304
97856	1397	1375783712000	10864	5607	0	0	6305
97857	1726	728711963000	10864	5607	1	0	3264
97863	1723	22303861909760	10867	5608	0	0	1
97864	1397	1375773711000	10867	5608	1	0	6306
97865	1726	728701962000	10867	5608	2	0	3265
97867	1397	1375763710000	10868	5609	1	0	6307
97868	1397	1375753709000	10868	5609	2	0	6308
97869	1726	728691961000	10868	5609	3	0	3266
97870	1726	728681960000	10868	5609	4	0	3267
97918	1397	1375743708000	10872	5610	1	0	6309
97921	1726	728671959000	10874	5610	0	0	\N
97922	1397	1375743708000	10874	5610	1	0	\N
97928	1397	1375733707000	10876	5611	0	0	\N
97929	1440	24479840000000	10876	5611	1	0	\N
97930	1726	728661958000	10876	5611	2	0	\N
97931	1726	728651957000	10876	5611	3	0	\N
97932	1397	1375723706000	10876	5611	4	0	\N
97933	1397	1375733707000	10877	5611	0	0	\N
97934	1440	24479840000000	10877	5611	1	0	\N
97935	1726	728661958000	10877	5611	2	0	\N
97936	1726	728651957000	10877	5611	3	0	\N
97937	1397	1375723706000	10877	5611	4	0	\N
97940	1440	24479840000000	10879	5605	0	0	\N
97941	1440	23363790000000	10879	5605	1	0	\N
97942	1723	22303861909760	10879	5605	2	0	\N
97943	1723	22303851906979	10879	5605	3	0	\N
97944	1440	20486740000000	10879	5605	4	0	\N
97945	1440	17008120000000	10879	5605	5	0	\N
97951	1440	23363790000000	10881	5613	0	0	\N
97952	1440	20486740000000	10881	5613	1	0	\N
97953	1440	17008120000000	10881	5613	2	0	\N
97954	1726	728631955000	10881	5613	3	0	\N
97955	1440	23363790000000	10882	5613	0	0	\N
97956	1397	1375703704000	10882	5613	1	0	\N
97957	1440	20486740000000	10882	5613	2	0	\N
97958	1440	17008120000000	10882	5613	3	0	\N
97959	1726	728631955000	10882	5613	4	0	\N
97960	1440	23363790000000	10883	5613	0	0	\N
97961	1397	1375703704000	10883	5613	1	0	\N
97962	1440	20486740000000	10883	5613	2	0	\N
97963	1440	17008120000000	10883	5613	3	0	\N
97964	1726	728631955000	10883	5613	4	0	\N
97965	1440	23363790000000	10884	5613	0	0	\N
97966	1397	1375703704000	10884	5613	1	0	\N
97967	1440	20486740000000	10884	5613	2	0	\N
97968	1440	17008120000000	10884	5613	3	0	\N
97969	1726	728631955000	10884	5613	4	0	\N
97970	1440	23363790000000	10885	5613	0	0	\N
97971	1397	1375703704000	10885	5613	1	0	\N
97972	1440	20486740000000	10885	5613	2	0	\N
97973	1440	17008120000000	10885	5613	3	0	\N
97974	1726	728631955000	10885	5613	4	0	\N
97975	1440	11852480000000	10886	5614	0	0	\N
97976	1397	1375693703000	10886	5614	1	0	\N
97977	1726	728621954000	10886	5614	2	0	\N
97978	1445	2917179000000	10886	5614	3	0	\N
97979	1440	11852480000000	10887	5614	0	0	\N
97980	1397	1375693703000	10887	5614	1	0	\N
97981	1726	728621954000	10887	5614	2	0	\N
97982	1445	2917179000000	10887	5614	3	0	\N
97987	1726	728611953000	10889	5615	0	0	\N
97988	1397	1375683702000	10889	5615	1	0	\N
97997	1726	728601952000	10892	5616	0	0	\N
97998	1445	1002169000000	10892	5616	1	0	\N
97999	1726	728591951000	10892	5616	2	0	\N
98000	1397	1375673701000	10892	5616	3	0	\N
98001	1397	1375663700000	10892	5616	4	0	\N
98004	1397	1375653699000	10894	5617	0	0	\N
98005	1726	728581950000	10894	5617	1	0	\N
98006	1440	24479840000000	10895	5604	0	0	\N
98007	1440	23363790000000	10895	5604	1	0	\N
98008	1723	22303861909760	10895	5604	2	0	\N
98009	1723	22303851906979	10895	5604	3	0	\N
98010	1440	20486740000000	10895	5604	4	0	\N
98011	1440	17008120000000	10895	5604	5	0	\N
98012	1440	11852480000000	10895	5604	6	0	\N
98013	1440	2159020000000	10895	5604	7	0	\N
98014	1726	728751967000	10895	5604	8	0	\N
98015	1726	728741966000	10895	5604	9	0	\N
98016	1726	728731965000	10895	5604	10	0	\N
98017	1726	728721964000	10895	5604	11	0	\N
98018	1726	728711963000	10895	5604	12	0	\N
98019	1397	1375823716000	10895	5604	13	0	\N
98020	1397	1375813715000	10895	5604	14	0	\N
98021	1397	1375803714000	10895	5604	15	0	\N
98022	1397	1375793713000	10895	5604	16	0	\N
98023	1397	1375783712000	10895	5604	17	0	\N
98024	1397	1375773711000	10895	5604	18	0	\N
98025	1397	1375763710000	10895	5604	19	0	\N
98026	1397	1375753709000	10895	5604	20	0	\N
98027	1397	1375743708000	10895	5604	21	0	\N
98028	1397	1375733707000	10895	5604	22	0	\N
98029	1397	1375723706000	10895	5604	23	0	\N
98030	1397	1375713705000	10895	5604	24	0	\N
98031	1397	1375703704000	10895	5604	25	0	\N
98032	1397	1375693703000	10895	5604	26	0	\N
98033	1397	1375683702000	10895	5604	27	0	\N
98034	1397	1375673701000	10895	5604	28	0	\N
98035	1397	1375663700000	10895	5604	29	0	\N
98036	1397	1375653699000	10895	5604	30	0	\N
98037	1445	2917179000000	10895	5604	31	0	\N
98038	1445	1002169000000	10895	5604	32	0	\N
98039	1726	728701962000	10895	5604	33	0	\N
98040	1726	728691961000	10895	5604	34	0	\N
98041	1726	728681960000	10895	5604	35	0	\N
98042	1726	728671959000	10895	5604	36	0	\N
98043	1726	728661958000	10895	5604	37	0	\N
98044	1726	728651957000	10895	5604	38	0	\N
98045	1726	728641956000	10895	5604	39	0	\N
98046	1726	728631955000	10895	5604	40	0	\N
98047	1726	728621954000	10895	5604	41	0	\N
98048	1726	728611953000	10895	5604	42	0	\N
98049	1726	728601952000	10895	5604	43	0	\N
98050	1726	728591951000	10895	5604	44	0	\N
98051	1726	728581950000	10895	5604	45	0	\N
97925	1726	728661958000	10875	5611	2	0	3269
97926	1726	728651957000	10875	5611	3	0	3270
97927	1397	1375723706000	10875	5611	4	0	6311
97938	1397	1375713705000	10878	5612	0	0	6312
97939	1726	728641956000	10878	5612	1	0	3271
97947	1397	1375703704000	10880	5613	1	0	6313
97948	1440	20486740000000	10880	5613	2	0	3
97949	1440	17008120000000	10880	5613	3	0	4
97950	1726	728631955000	10880	5613	4	0	3272
97983	1440	11852480000000	10888	5614	0	0	5
97985	1726	728621954000	10888	5614	2	0	3273
97986	1445	2917179000000	10888	5614	3	0	7
97989	1440	2159020000000	10890	5615	0	0	6
97990	1726	728611953000	10890	5615	1	0	3274
97992	1726	728601952000	10891	5616	0	0	3275
97993	1445	1002169000000	10891	5616	1	0	8
97994	1726	728591951000	10891	5616	2	0	3276
97995	1397	1375673701000	10891	5616	3	0	6316
97996	1397	1375663700000	10891	5616	4	0	6317
98003	1726	728581950000	10893	5617	1	0	3277
98052	1397	1375643698000	10896	5618	0	0	6319
98053	1397	1375633697000	10896	5618	1	0	6320
98054	1397	1375623696000	10896	5618	2	0	6321
98055	1723	19521957085979	10896	5618	3	0	3
98059	1397	1375643698000	10897	5618	0	0	\N
98060	1397	1375633697000	10897	5618	1	0	\N
98061	1397	1375623696000	10897	5618	2	0	\N
98062	1723	19521957085979	10897	5618	3	0	\N
98063	1726	728571949000	10897	5618	4	0	\N
98064	1726	728561948000	10897	5618	5	0	\N
98065	1726	728551947000	10897	5618	6	0	\N
98066	1397	1375643698000	10898	5618	0	0	\N
98067	1397	1375633697000	10898	5618	1	0	\N
98068	1397	1375623696000	10898	5618	2	0	\N
98069	1723	19521957085979	10898	5618	3	0	\N
98070	1726	728571949000	10898	5618	4	0	\N
98071	1726	728561948000	10898	5618	5	0	\N
98072	1726	728551947000	10898	5618	6	0	\N
98101	1397	1375513685000	10905	5625	0	0	\N
98102	1397	1375503684000	10905	5625	1	0	\N
98103	1726	728451937000	10905	5625	2	0	\N
98104	1726	728441936000	10905	5625	3	0	\N
98115	406	66001900000000	10909	5627	0	0	\N
98116	1726	728421934000	10909	5627	1	0	\N
98117	1397	1375483682000	10909	5627	2	0	\N
98122	1397	1375463680000	10911	5629	0	0	\N
98123	1726	728401932000	10911	5629	1	0	\N
98126	1656	15782634000000	10913	5605	0	0	\N
98127	1656	10389514000000	10913	5605	1	0	\N
98128	1656	6750394000000	10913	5605	3	0	\N
98129	1656	3741274000000	10913	5605	4	0	\N
98130	1755	2156950000000	10913	5605	5	0	\N
98131	633	77159889900000	10913	5605	6	0	\N
98132	633	72755869900000	10913	5605	7	0	\N
98133	633	69781849900000	10913	5605	8	0	\N
98134	633	67323829900000	10913	5605	9	0	\N
98135	1397	1375643698000	10913	5605	10	0	\N
98136	1397	1375633697000	10913	5605	11	0	\N
98137	1397	1375623696000	10913	5605	12	0	\N
98138	1397	1375613695000	10913	5605	13	0	\N
98139	1397	1375603694000	10913	5605	14	0	\N
98140	1723	19521957085979	10913	5605	15	0	\N
98141	1723	16157947085979	10913	5605	16	0	\N
98142	1397	1375593693000	10913	5605	17	0	\N
98143	1723	11171937085979	10913	5605	18	0	\N
98144	1723	1798927085979	10913	5605	19	0	\N
98145	1726	728571949000	10913	5605	20	0	\N
98146	1726	728561948000	10913	5605	21	0	\N
98147	1726	728551947000	10913	5605	22	0	\N
98148	1726	728541946000	10913	5605	23	0	\N
98149	1726	728531945000	10913	5605	24	0	\N
98150	1726	728521944000	10913	5605	25	0	\N
98151	1397	1375583692000	10913	5605	26	0	\N
98152	1397	1375573691000	10913	5605	27	0	\N
98153	1397	1375563690000	10913	5605	28	0	\N
98154	1397	1375553689000	10913	5605	29	0	\N
98155	1397	1375543688000	10913	5605	30	0	\N
98156	1397	1375533687000	10913	5605	31	0	\N
98157	1397	1375523686000	10913	5605	32	0	\N
98158	1397	1375513685000	10913	5605	33	0	\N
98159	1397	1375503684000	10913	5605	34	0	\N
98160	1397	1375493683000	10913	5605	35	0	\N
98161	1397	1375483682000	10913	5605	36	0	\N
98162	1397	1375473681000	10913	5605	37	0	\N
98163	1397	1375463680000	10913	5605	38	0	\N
98164	1397	1375453679000	10913	5605	39	0	\N
98165	1726	728511943000	10913	5605	40	0	\N
98166	1726	728501942000	10913	5605	41	0	\N
98167	1726	728491941000	10913	5605	42	0	\N
98168	1726	728481940000	10913	5605	43	0	\N
98169	1726	728471939000	10913	5605	44	0	\N
98170	1726	728461938000	10913	5605	45	0	\N
98171	1726	728451937000	10913	5605	46	0	\N
98172	1726	728441936000	10913	5605	47	0	\N
98173	1726	728431935000	10913	5605	48	0	\N
98174	1726	728421934000	10913	5605	49	0	\N
98175	1726	728411933000	10913	5605	50	0	\N
98176	1726	728401932000	10913	5605	51	0	\N
98177	1726	728391931000	10913	5605	52	0	\N
98178	1608	10828470000000	10914	5630	0	0	\N
98179	1608	7396460000000	10914	5630	1	0	\N
98180	1608	5080450000000	10914	5630	2	0	\N
98181	1726	728391931000	10914	5630	3	0	\N
98182	1726	728381930000	10914	5630	4	0	\N
98183	1608	3165440000000	10914	5630	5	0	\N
98184	1397	1375453679000	10914	5630	6	0	\N
98185	1397	1375443678000	10914	5630	7	0	\N
98073	1397	1375613695000	10899	5619	0	0	6322
98074	1726	728541946000	10900	5620	0	0	3281
98075	1397	1375603694000	10900	5620	1	0	6323
98076	1723	16157947085979	10901	5621	0	0	4
98077	1726	728531945000	10901	5621	1	0	3282
98079	1397	1375593693000	10901	5621	3	0	6324
98080	1397	1375583692000	10901	5621	4	0	6325
98081	1397	1375573691000	10902	5622	0	0	6326
98082	1726	728511943000	10902	5622	1	0	3284
98083	633	77159889900000	10903	5623	0	0	2
98085	633	69781849900000	10903	5623	2	0	4
98086	633	67323829900000	10903	5623	3	0	5
98087	1397	1375563690000	10903	5623	4	0	6327
98088	1726	728501942000	10903	5623	5	0	3285
98090	1726	728491941000	10903	5623	7	0	3286
98091	1397	1375543688000	10903	5623	8	0	6329
98092	1723	11171937085979	10903	5623	9	0	5
98093	1726	728481940000	10903	5623	10	0	3287
98094	1656	15782634000000	10904	5624	0	0	1
98096	1723	1798927085979	10904	5624	2	0	6
98097	1397	1375533687000	10904	5624	3	0	6330
98098	1726	728471939000	10904	5624	4	0	3288
98099	1726	728461938000	10904	5624	5	0	3289
98100	1397	1375523686000	10904	5624	6	0	6331
98106	1397	1375503684000	10906	5625	1	0	6333
98107	1726	728451937000	10906	5625	2	0	3290
98108	1726	728441936000	10906	5625	3	0	3291
98109	1656	10389514000000	10907	5626	0	0	2
98111	1656	3741274000000	10907	5626	2	0	4
98112	1726	728431935000	10907	5626	3	0	3292
98113	1397	1375493683000	10907	5626	4	0	6334
98114	406	66001900000000	10908	5627	0	0	1
98118	1726	728421934000	10910	5628	0	0	3293
98120	1397	1375483682000	10910	5628	2	0	6335
98121	1397	1375473681000	10910	5628	3	0	6336
98124	1397	1375463680000	10912	5629	0	0	6337
98125	1726	728401932000	10912	5629	1	0	3295
98186	1608	10828470000000	10915	5630	0	0	1
98188	1608	5080450000000	10915	5630	2	0	3
98189	1726	728391931000	10915	5630	3	0	3296
98190	1726	728381930000	10915	5630	4	0	3297
98191	1608	3165440000000	10915	5630	5	0	4
98195	1726	728371929000	10917	5631	0	0	\N
98196	1397	1375433677000	10917	5631	1	0	\N
98197	1726	728371929000	10918	5631	0	0	\N
98198	1397	1375433677000	10918	5631	1	0	\N
98207	1397	1375393673000	10920	5633	0	0	\N
98210	1397	1375393673000	10922	5633	0	0	\N
98211	1726	728331925000	10922	5633	1	0	\N
98212	1397	1375383672000	10923	5634	0	0	\N
98213	1654	9558071000000	10923	5634	1	0	\N
98214	1654	7242584200000	10923	5634	3	0	\N
98215	1726	728321924000	10923	5634	4	0	\N
98216	1397	1375383672000	10924	5634	0	0	\N
98217	1654	9558071000000	10924	5634	1	0	\N
98218	1654	7242584200000	10924	5634	3	0	\N
98219	1726	728321924000	10924	5634	4	0	\N
98222	1726	728321924000	10926	5634	0	0	\N
98228	1726	728311923000	10928	5635	0	0	\N
98229	1397	1375383672000	10928	5635	1	0	\N
98230	1654	9558071000000	10928	5635	2	0	\N
98231	1654	7242584200000	10928	5635	3	0	\N
98232	1726	728301922000	10928	5635	4	0	\N
98233	1397	1375373671000	10928	5635	5	0	\N
98234	1654	5327853000000	10928	5635	6	0	\N
98235	1422	8662651198464	10928	5635	7	0	\N
98236	1726	728311923000	10929	5635	0	0	\N
98237	1397	1375383672000	10929	5635	1	0	\N
98238	1654	9558071000000	10929	5635	2	0	\N
98239	1654	7242584200000	10929	5635	3	0	\N
98240	1726	728301922000	10929	5635	4	0	\N
98241	1397	1375373671000	10929	5635	5	0	\N
98242	1654	5327853000000	10929	5635	6	0	\N
98243	1422	8662651198464	10929	5635	7	0	\N
98244	1726	728301922000	10930	5636	0	0	\N
98245	1397	1375373671000	10930	5636	1	0	\N
98248	1397	1375373671000	10932	5636	0	0	\N
98249	1726	728301922000	10933	5636	0	0	\N
98250	1397	1375373671000	10933	5636	1	0	\N
98253	1726	728301922000	10935	5636	0	0	\N
98254	1726	728291921000	10935	5636	1	0	\N
98255	1397	1375373671000	10935	5636	2	0	\N
98256	1397	1375363670000	10935	5636	3	0	\N
98257	1726	728301922000	10936	5636	0	0	\N
98258	1726	728291921000	10936	5636	1	0	\N
98259	1397	1375373671000	10936	5636	2	0	\N
98260	1397	1375363670000	10936	5636	3	0	\N
98263	1726	728271919000	10938	5639	0	0	\N
98264	1397	1375343668000	10938	5639	1	0	\N
98267	1726	728271919000	10940	5639	0	0	\N
98268	1397	1375343668000	10940	5639	1	0	\N
98271	1726	728261918000	10942	5640	0	0	\N
98272	1397	1375333667000	10942	5640	1	0	\N
98273	1726	728261918000	10943	5640	0	0	\N
98274	1397	1375333667000	10943	5640	1	0	\N
98275	1726	728251917000	10944	5641	0	0	\N
98276	1397	1375323666000	10944	5641	1	0	\N
98277	1726	728251917000	10945	5641	0	0	\N
98278	1397	1375323666000	10945	5641	1	0	\N
98282	1726	728241916000	10948	5643	0	0	\N
98283	1726	728231915000	10948	5643	1	0	\N
98284	1726	728221914000	10948	5643	2	0	\N
98285	1397	1375303664000	10948	5643	3	0	\N
98286	1397	1375293663000	10948	5643	4	0	\N
98287	1397	1375283662000	10948	5643	5	0	\N
98288	1726	728241916000	10949	5643	0	0	\N
98289	1726	728231915000	10949	5643	1	0	\N
98290	1726	728221914000	10949	5643	2	0	\N
98291	1397	1375303664000	10949	5643	3	0	\N
98292	1397	1375293663000	10949	5643	4	0	\N
98293	1397	1375283662000	10949	5643	5	0	\N
98294	1726	728301922000	10950	5636	0	0	\N
98295	1726	728291921000	10950	5636	1	0	\N
98296	1726	728281920000	10950	5636	2	0	\N
98297	1726	728271919000	10950	5636	3	0	\N
98298	1726	728261918000	10950	5636	4	0	\N
98299	1726	728251917000	10950	5636	5	0	\N
98300	1397	1375373671000	10950	5636	6	0	\N
98301	1397	1375363670000	10950	5636	7	0	\N
98302	1397	1375353669000	10950	5636	8	0	\N
98303	1726	728241916000	10950	5636	9	0	\N
98304	1726	728231915000	10950	5636	10	0	\N
98305	1726	728221914000	10950	5636	11	0	\N
98306	1397	1375343668000	10950	5636	12	0	\N
98307	1397	1375333667000	10950	5636	13	0	\N
98308	1397	1375323666000	10950	5636	14	0	\N
98309	1397	1375313665000	10950	5636	15	0	\N
98310	1397	1375303664000	10950	5636	16	0	\N
98311	1397	1375293663000	10950	5636	17	0	\N
98312	1397	1375283662000	10950	5636	18	0	\N
98319	1726	728211913000	10952	5644	0	0	\N
98326	1458	23002236908540	10955	5645	0	0	\N
98327	1726	728201912000	10955	5645	1	0	\N
98328	1726	728191911000	10955	5645	2	0	\N
98199	1726	728361928000	10919	5632	0	0	3299
98200	1654	12989640600000	10919	5632	1	0	1
98201	1726	728351927000	10919	5632	2	0	3300
98202	1726	728341926000	10919	5632	3	0	3301
98203	1397	1375433677000	10919	5632	4	0	6340
98205	1397	1375413675000	10919	5632	6	0	6342
98206	1397	1375403674000	10919	5632	7	0	6343
98208	1397	1375393673000	10921	5633	0	0	6344
98209	1726	728331925000	10921	5633	1	0	3302
98220	1654	9558071000000	10925	5634	0	0	2
98223	1726	728311923000	10927	5635	0	0	3304
98224	1397	1375383672000	10927	5635	1	0	6345
98225	1654	7242584200000	10927	5635	2	0	3
98226	1654	5327853000000	10927	5635	3	0	4
98246	1726	728301922000	10931	5636	0	0	3305
98247	1397	1375373671000	10931	5636	1	0	6346
98251	1397	1375363670000	10934	5637	0	0	6347
98252	1726	728291921000	10934	5637	1	0	3306
98261	1397	1375353669000	10937	5638	0	0	6348
98265	1726	728271919000	10939	5639	0	0	3308
98266	1397	1375343668000	10939	5639	1	0	6349
98269	1726	728261918000	10941	5640	0	0	3309
98270	1397	1375333667000	10941	5640	1	0	6350
98279	1726	728251917000	10946	5641	0	0	3310
98281	1397	1375313665000	10947	5642	0	0	6352
98313	1726	728241916000	10951	5643	0	0	3311
98314	1726	728231915000	10951	5643	1	0	3312
98315	1726	728221914000	10951	5643	2	0	3313
98317	1397	1375293663000	10951	5643	4	0	6354
98318	1397	1375283662000	10951	5643	5	0	6355
98320	1726	728211913000	10953	5644	0	0	3314
98321	1458	23002236908540	10954	5645	0	0	1
98322	1726	728201912000	10954	5645	1	0	3315
98324	1397	1375273661000	10954	5645	3	0	6356
98325	1397	1375263660000	10954	5645	4	0	6357
98329	1397	1375273661000	10955	5645	3	0	\N
98330	1397	1375263660000	10955	5645	4	0	\N
98336	1458	23002236908540	10958	5606	0	0	\N
98337	1726	728381930000	10958	5606	1	0	\N
98338	1654	12989640600000	10958	5606	2	0	\N
98339	1654	9558071000000	10958	5606	3	0	\N
98340	1654	7242584200000	10958	5606	4	0	\N
98341	1726	728371929000	10958	5606	5	0	\N
98342	1726	728361928000	10958	5606	6	0	\N
98343	1726	728351927000	10958	5606	7	0	\N
98344	1726	728341926000	10958	5606	8	0	\N
98345	1726	728331925000	10958	5606	9	0	\N
98346	1726	728321924000	10958	5606	10	0	\N
98347	1726	728311923000	10958	5606	11	0	\N
98348	1726	728301922000	10958	5606	12	0	\N
98349	1726	728291921000	10958	5606	13	0	\N
98350	1726	728281920000	10958	5606	14	0	\N
98351	1726	728271919000	10958	5606	15	0	\N
98352	1726	728261918000	10958	5606	16	0	\N
98353	1726	728251917000	10958	5606	17	0	\N
98354	1608	10828470000000	10958	5606	18	0	\N
98355	1397	1375443678000	10958	5606	19	0	\N
98356	1726	728241916000	10958	5606	20	0	\N
98357	1726	728231915000	10958	5606	21	0	\N
98358	1726	728221914000	10958	5606	22	0	\N
98359	1726	728211913000	10958	5606	23	0	\N
98360	1726	728201912000	10958	5606	24	0	\N
98361	1726	728191911000	10958	5606	25	0	\N
98362	1726	728181910000	10958	5606	26	0	\N
98363	1726	728171909000	10958	5606	27	0	\N
98364	1654	5327853000000	10958	5606	28	0	\N
98365	1397	1375433677000	10958	5606	29	0	\N
98366	1397	1375423676000	10958	5606	30	0	\N
98367	1397	1375413675000	10958	5606	31	0	\N
98368	1397	1375403674000	10958	5606	32	0	\N
98369	1397	1375393673000	10958	5606	33	0	\N
98370	1397	1375383672000	10958	5606	34	0	\N
98371	1397	1375373671000	10958	5606	35	0	\N
98372	1397	1375363670000	10958	5606	36	0	\N
98373	1397	1375353669000	10958	5606	37	0	\N
98374	1397	1375343668000	10958	5606	38	0	\N
98375	1397	1375333667000	10958	5606	39	0	\N
98376	1397	1375323666000	10958	5606	40	0	\N
98377	1397	1375313665000	10958	5606	41	0	\N
98378	1397	1375303664000	10958	5606	42	0	\N
98379	1397	1375293663000	10958	5606	43	0	\N
98380	1397	1375283662000	10958	5606	44	0	\N
98381	1397	1375273661000	10958	5606	45	0	\N
98382	1397	1375263660000	10958	5606	46	0	\N
98383	1397	1375253659000	10958	5606	47	0	\N
98384	1397	1375243658000	10958	5606	48	0	\N
98385	1422	8662651198464	10958	5606	49	0	\N
98386	1422	5971079967091	10958	5606	50	0	\N
98390	1458	19473936908540	10960	5649	0	0	\N
98391	1458	14244636908540	10960	5649	1	0	\N
98392	1397	1375223656000	10960	5649	2	0	\N
98393	1397	1375213655000	10960	5649	3	0	\N
98394	1726	728151907000	10960	5649	4	0	\N
98395	1726	728141906000	10960	5649	5	0	\N
98396	700	66000290000000	10960	5649	6	0	\N
98397	1458	19473936908540	10961	5649	0	0	\N
98398	1458	14244636908540	10961	5649	1	0	\N
98399	1397	1375223656000	10961	5649	2	0	\N
98400	1397	1375213655000	10961	5649	3	0	\N
98401	1726	728151907000	10961	5649	4	0	\N
98402	1726	728141906000	10961	5649	5	0	\N
98403	700	66000290000000	10961	5649	6	0	\N
98411	1726	728131905000	10963	5650	0	0	\N
98412	1397	1375203654000	10963	5650	1	0	\N
98415	1726	728131905000	10965	5650	0	0	\N
98416	1397	1375203654000	10965	5650	1	0	\N
98417	1397	1375193653000	10966	5651	0	0	\N
98418	1726	728121904000	10966	5651	1	0	\N
98419	1397	1375193653000	10967	5651	0	0	\N
98420	1726	728121904000	10967	5651	1	0	\N
98421	1397	1375193653000	10968	5651	0	0	\N
98422	1726	728121904000	10968	5651	1	0	\N
98423	1397	1375193653000	10969	5651	0	0	\N
98424	1726	728121904000	10969	5651	1	0	\N
98428	1397	1375173651000	10972	5653	0	0	\N
98429	1726	728111903000	10972	5653	1	0	\N
98430	1726	728101902000	10972	5653	2	0	\N
98437	1726	728091901000	10975	5654	0	0	\N
98438	1397	1375153649000	10975	5654	1	0	\N
98444	1397	1375123646000	10978	5657	0	0	\N
98445	1726	728061898000	10978	5657	1	0	\N
98446	2041	719339000000	10978	5657	2	0	\N
98447	1397	1375123646000	10979	5657	0	0	\N
98448	1726	728061898000	10979	5657	1	0	\N
98449	2041	719339000000	10979	5657	2	0	\N
98455	1397	1375113645000	10982	5658	0	0	\N
98456	1726	728051897000	10982	5658	1	0	\N
98457	1397	1375113645000	10983	5658	0	0	\N
98458	1726	728051897000	10983	5658	1	0	\N
98333	1726	728171909000	10957	5647	1	0	3318
98334	1397	1375243658000	10957	5647	2	0	6359
98335	1422	5971079967091	10957	5647	3	0	6
98387	2015	333700000000	10959	5648	0	0	1
98388	1726	728161908000	10959	5648	1	0	3319
98404	1458	19473936908540	10962	5649	0	0	2
98405	1458	14244636908540	10962	5649	1	0	3
98406	1397	1375223656000	10962	5649	2	0	6361
98407	1397	1375213655000	10962	5649	3	0	6362
98408	1726	728151907000	10962	5649	4	0	3320
98410	700	66000290000000	10962	5649	6	0	3
98413	1726	728131905000	10964	5650	0	0	3322
98414	1397	1375203654000	10964	5650	1	0	6363
98425	1397	1375193653000	10970	5651	0	0	6364
98427	1397	1375183652000	10971	5652	0	0	6365
98431	1397	1375173651000	10973	5653	0	0	6366
98432	1397	1375163650000	10973	5653	1	0	6367
98433	1726	728111903000	10973	5653	2	0	3324
98434	1726	728101902000	10973	5653	3	0	3325
98436	1397	1375153649000	10974	5654	1	0	6368
98439	1458	4413336908540	10976	5655	0	0	4
98440	1397	1375143648000	10976	5655	1	0	6369
98441	1726	728081900000	10976	5655	2	0	3327
98442	1726	728071899000	10977	5656	0	0	3328
98450	1397	1375123646000	10980	5657	0	0	6371
98451	1726	728061898000	10980	5657	1	0	3329
98452	2041	719339000000	10980	5657	2	0	1
98453	1397	1375113645000	10981	5658	0	0	6372
98459	1397	1375103644000	10984	5659	0	0	6373
98460	1726	728041896000	10984	5659	1	0	3331
98461	1726	728031895000	10985	5660	0	0	3332
98462	1726	728021894000	10985	5660	1	0	3333
98463	1397	1375093643000	10985	5660	2	0	6374
98471	1726	728001892000	10989	5662	0	0	\N
98472	1726	727991891000	10989	5662	1	0	\N
98473	1397	1375063640000	10989	5662	2	0	\N
98474	1397	1375053639000	10989	5662	3	0	\N
98475	1726	728001892000	10990	5662	0	0	\N
98476	1726	727991891000	10990	5662	1	0	\N
98477	1397	1375063640000	10990	5662	2	0	\N
98478	1397	1375053639000	10990	5662	3	0	\N
98479	1726	727981890000	10991	5663	0	0	\N
98480	1726	727971889000	10991	5663	1	0	\N
98481	1397	1375043638000	10991	5663	2	0	\N
98482	1397	1375033637000	10991	5663	3	0	\N
98487	1726	727981890000	10993	5663	0	0	\N
98488	1726	727971889000	10993	5663	1	0	\N
98489	1397	1375043638000	10993	5663	2	0	\N
98490	1397	1375033637000	10993	5663	3	0	\N
98497	1726	727931885000	10996	5666	0	0	\N
98498	1397	1374993633000	10996	5666	1	0	\N
98499	1726	727931885000	10997	5666	0	0	\N
98500	1397	1374993633000	10997	5666	1	0	\N
98503	1726	727921884000	10999	5667	0	0	\N
98504	1726	727921884000	11001	5667	0	0	\N
98506	1726	727921884000	11004	5667	0	0	\N
98507	1397	1374983632000	11006	5667	0	0	\N
98508	1726	727921884000	11006	5667	1	0	\N
98509	1726	727911883000	11006	5667	2	0	\N
98510	1397	1374983632000	11007	5668	0	0	\N
98511	1397	1374973631000	11007	5668	1	0	\N
98512	1726	727911883000	11007	5668	2	0	\N
98513	1726	727901882000	11007	5668	3	0	\N
98518	1397	1374983632000	11009	5668	0	0	\N
98519	1397	1374973631000	11009	5668	1	0	\N
98520	1726	727911883000	11009	5668	2	0	\N
98521	1726	727901882000	11009	5668	3	0	\N
98522	1509	21600649000000	11010	5669	0	0	\N
98523	1397	1374963630000	11010	5669	1	0	\N
98524	1726	727891881000	11010	5669	2	0	\N
98525	1726	727881880000	11010	5669	3	0	\N
98526	1397	1374953629000	11010	5669	4	0	\N
98527	411	66837920000000	11010	5669	5	0	\N
98528	1509	21600649000000	11011	5669	0	0	\N
98529	1397	1374963630000	11011	5669	1	0	\N
98530	1726	727891881000	11011	5669	2	0	\N
98531	1726	727881880000	11011	5669	3	0	\N
98532	1397	1374953629000	11011	5669	4	0	\N
98533	411	66837920000000	11011	5669	5	0	\N
98541	1509	18956312312008	11014	5671	0	0	\N
98542	1509	15759086021455	11014	5671	1	0	\N
98543	1509	11020536532383	11014	5671	2	0	\N
98544	1509	2111359851155	11014	5671	3	0	\N
98545	1726	727871879000	11014	5671	4	0	\N
98546	1397	1374933627000	11014	5671	5	0	\N
98553	1509	21600649000000	11016	5669	0	0	\N
98554	1509	18956312312008	11016	5669	1	0	\N
98555	1509	15759086021455	11016	5669	2	0	\N
98556	1509	11020536532383	11016	5669	3	0	\N
98557	1509	2111359851155	11016	5669	4	0	\N
98558	1397	1374963630000	11016	5669	5	0	\N
98559	1726	727891881000	11016	5669	6	0	\N
98560	1726	727881880000	11016	5669	7	0	\N
98561	1726	727871879000	11016	5669	8	0	\N
98562	1397	1374953629000	11016	5669	9	0	\N
98563	411	66837920000000	11016	5669	10	0	\N
98564	1397	1374943628000	11016	5669	11	0	\N
98565	1397	1374933627000	11016	5669	12	0	\N
98566	1726	727861878000	11017	5670	0	0	\N
98567	1397	1374923626000	11017	5670	1	0	\N
98572	1726	727841876000	11019	5673	0	0	\N
98573	1397	1374903624000	11019	5673	1	0	\N
98576	1726	727851877000	11021	5671	0	0	\N
98577	1726	727841876000	11021	5671	1	0	\N
98578	1397	1374913625000	11021	5671	2	0	\N
98579	1397	1374903624000	11021	5671	3	0	\N
98583	1726	727821874000	11023	5675	0	0	\N
98584	1726	727821874000	11024	5675	0	0	\N
98586	1726	727811873000	11026	5676	0	0	\N
98587	411	66008410000000	11026	5676	1	0	\N
98588	439	66000040000000	11026	5676	2	0	\N
98589	1397	1374883622000	11026	5676	3	0	\N
98590	1397	1374873621000	11026	5676	4	0	\N
98591	1397	1374863620000	11026	5676	5	0	\N
98592	1397	1374853619000	11026	5676	6	0	\N
98593	1726	727801872000	11026	5676	7	0	\N
98594	1726	727791871000	11026	5676	8	0	\N
98595	1726	727781870000	11026	5676	9	0	\N
98596	1726	727811873000	11027	5676	0	0	\N
98597	411	66008410000000	11027	5676	1	0	\N
98598	439	66000040000000	11027	5676	2	0	\N
98599	1397	1374883622000	11027	5676	3	0	\N
98600	1397	1374873621000	11027	5676	4	0	\N
98467	1726	728001892000	10988	5662	0	0	3335
98468	1726	727991891000	10988	5662	1	0	3336
98469	1397	1375063640000	10988	5662	2	0	6377
98470	1397	1375053639000	10988	5662	3	0	6378
98483	1726	727981890000	10992	5663	0	0	3337
98485	1397	1375043638000	10992	5663	2	0	6379
98486	1397	1375033637000	10992	5663	3	0	6380
98491	1726	727961888000	10994	5664	0	0	3339
98492	1726	727951887000	10994	5664	1	0	3340
98493	1397	1375023636000	10994	5664	2	0	6381
98495	1397	1375003634000	10995	5665	0	0	6383
98496	1726	727941886000	10995	5665	1	0	3341
98501	1726	727931885000	10998	5666	0	0	3342
98502	1397	1374993633000	10998	5666	1	0	6384
98514	1397	1374983632000	11008	5668	0	0	6385
98515	1397	1374973631000	11008	5668	1	0	6386
98516	1726	727911883000	11008	5668	2	0	3344
98517	1726	727901882000	11008	5668	3	0	3345
98534	1509	21600649000000	11012	5669	0	0	1
98536	1726	727891881000	11012	5669	2	0	3346
98537	1726	727881880000	11012	5669	3	0	3347
98538	1397	1374953629000	11012	5669	4	0	6388
98539	411	66837920000000	11012	5669	5	0	4
98540	1397	1374943628000	11013	5670	0	0	6389
98548	1509	15759086021455	11015	5671	1	0	3
98549	1509	11020536532383	11015	5671	2	0	4
98550	1509	2111359851155	11015	5671	3	0	5
98551	1726	727871879000	11015	5671	4	0	3348
98568	1726	727861878000	11018	5672	0	0	3349
98569	1726	727851877000	11018	5672	1	0	3350
98570	1397	1374923626000	11018	5672	2	0	6391
98571	1397	1374913625000	11018	5672	3	0	6392
98574	1726	727841876000	11020	5673	0	0	3351
98580	1397	1374893623000	11022	5674	0	0	6394
98581	2042	490000000	11022	5674	1	0	1
98582	1726	727831875000	11022	5674	2	0	3352
98585	1726	727821874000	11025	5675	0	0	3353
98601	1397	1374863620000	11027	5676	5	0	\N
98602	1397	1374853619000	11027	5676	6	0	\N
98603	1726	727801872000	11027	5676	7	0	\N
98604	1726	727791871000	11027	5676	8	0	\N
98605	1726	727781870000	11027	5676	9	0	\N
98624	1458	19473936908540	11033	5607	0	0	\N
98625	1458	14244636908540	11033	5607	1	0	\N
98626	1458	4413336908540	11033	5607	2	0	\N
98627	2015	333700000000	11033	5607	3	0	\N
98628	1509	20880543000000	11033	5607	4	0	\N
98629	1509	18236206312008	11033	5607	5	0	\N
98630	1509	15038980021455	11033	5607	6	0	\N
98631	1509	10300430532383	11033	5607	7	0	\N
98632	1509	1391253851155	11033	5607	8	0	\N
98633	1726	728161908000	11033	5607	9	0	\N
98634	1726	728151907000	11033	5607	10	0	\N
98635	411	66837920000000	11033	5607	11	0	\N
98636	411	66007910000000	11033	5607	12	0	\N
98637	1397	1375233657000	11033	5607	13	0	\N
98638	1397	1375223656000	11033	5607	14	0	\N
98639	1397	1375213655000	11033	5607	15	0	\N
98640	1397	1375203654000	11033	5607	16	0	\N
98641	1397	1375193653000	11033	5607	17	0	\N
98642	1397	1375183652000	11033	5607	18	0	\N
98643	1397	1375173651000	11033	5607	19	0	\N
98644	1397	1375163650000	11033	5607	20	0	\N
98645	1397	1375153649000	11033	5607	21	0	\N
98646	1397	1375143648000	11033	5607	23	0	\N
98647	1397	1375133647000	11033	5607	24	0	\N
98648	1397	1375123646000	11033	5607	25	0	\N
98649	1397	1375113645000	11033	5607	26	0	\N
98650	1397	1375103644000	11033	5607	27	0	\N
98651	1397	1375093643000	11033	5607	28	0	\N
98652	1397	1375083642000	11033	5607	29	0	\N
98653	1397	1375073641000	11033	5607	30	0	\N
98654	1397	1375063640000	11033	5607	31	0	\N
98655	1397	1375053639000	11033	5607	32	0	\N
98656	1397	1375043638000	11033	5607	33	0	\N
98657	1397	1375033637000	11033	5607	34	0	\N
98658	1397	1375023636000	11033	5607	35	0	\N
98659	1397	1375013635000	11033	5607	36	0	\N
98660	1397	1375003634000	11033	5607	37	0	\N
98661	1397	1374993633000	11033	5607	38	0	\N
98662	1397	1374983632000	11033	5607	39	0	\N
98663	1397	1374973631000	11033	5607	40	0	\N
98664	1397	1374963630000	11033	5607	41	0	\N
98665	1397	1374953629000	11033	5607	42	0	\N
98666	1397	1374943628000	11033	5607	43	0	\N
98667	1397	1374933627000	11033	5607	44	0	\N
98668	1397	1374923626000	11033	5607	45	0	\N
98669	1397	1374913625000	11033	5607	46	0	\N
98670	1397	1374903624000	11033	5607	47	0	\N
98671	1397	1374893623000	11033	5607	48	0	\N
98672	1397	1374883622000	11033	5607	49	0	\N
98673	1397	1374873621000	11033	5607	50	0	\N
98674	1397	1374863620000	11033	5607	51	0	\N
98675	1397	1374853619000	11033	5607	52	0	\N
98676	1397	1374843618000	11033	5607	53	0	\N
98677	1397	1374833617000	11033	5607	54	0	\N
98678	1397	1374823616000	11033	5607	55	0	\N
98679	1397	1374813615000	11033	5607	56	0	\N
98680	1726	728141906000	11033	5607	57	0	\N
98681	1726	728131905000	11033	5607	58	0	\N
98682	1726	728121904000	11033	5607	59	0	\N
98683	1726	728111903000	11033	5607	60	0	\N
98684	1726	728101902000	11033	5607	61	0	\N
98685	1726	728091901000	11033	5607	62	0	\N
98686	1726	728081900000	11033	5607	63	0	\N
98687	1726	728071899000	11033	5607	64	0	\N
98688	1726	728061898000	11033	5607	65	0	\N
98689	1726	728051897000	11033	5607	66	0	\N
98690	1726	728041896000	11033	5607	67	0	\N
98691	1726	728031895000	11033	5607	68	0	\N
98692	1726	728021894000	11033	5607	69	0	\N
98693	1726	728011893000	11033	5607	70	0	\N
98694	1726	728001892000	11033	5607	71	0	\N
98695	1726	727991891000	11033	5607	72	0	\N
98696	1726	727981890000	11033	5607	73	0	\N
98697	1726	727971889000	11033	5607	74	0	\N
98698	1726	727961888000	11033	5607	75	0	\N
98699	1726	727951887000	11033	5607	76	0	\N
98700	1726	727941886000	11033	5607	77	0	\N
98701	1726	727931885000	11033	5607	78	0	\N
98702	1726	727921884000	11033	5607	79	0	\N
98703	1726	727911883000	11033	5607	80	0	\N
98704	1726	727901882000	11033	5607	81	0	\N
98705	1726	727891881000	11033	5607	82	0	\N
98706	1726	727881880000	11033	5607	83	0	\N
98707	1726	727871879000	11033	5607	84	0	\N
98708	1726	727861878000	11033	5607	85	0	\N
98709	1726	727851877000	11033	5607	86	0	\N
98710	1726	727841876000	11033	5607	87	0	\N
98711	1726	727831875000	11033	5607	88	0	\N
98712	1726	727821874000	11033	5607	89	0	\N
98713	1726	727811873000	11033	5607	90	0	\N
98714	1726	727801872000	11033	5607	91	0	\N
98715	1726	727791871000	11033	5607	92	0	\N
98716	1726	727781870000	11033	5607	93	0	\N
98717	1726	727771869000	11033	5607	94	0	\N
98718	1726	727761868000	11033	5607	95	0	\N
98719	1726	727751867000	11033	5607	96	0	\N
98720	1726	727741866000	11033	5607	97	0	\N
98721	700	66000290000000	11033	5607	98	0	\N
98722	1397	1374803614000	11034	5681	0	0	\N
98723	1726	727731865000	11034	5681	1	0	\N
98724	1397	1374803614000	11035	5681	0	0	\N
98727	1397	1374803614000	11037	5681	0	0	\N
98728	1726	727731865000	11037	5681	1	0	\N
98729	1397	1374793613000	11038	5682	0	0	\N
98730	1726	727721864000	11038	5682	1	0	\N
98733	1397	1374783612000	11040	5683	0	0	\N
98734	1726	727711863000	11040	5683	1	0	\N
98735	1397	1374783612000	11041	5683	0	0	\N
98736	1726	727711863000	11041	5683	1	0	\N
98608	439	66000040000000	11028	5676	2	0	1
98609	1397	1374883622000	11028	5676	3	0	6395
98610	1397	1374873621000	11028	5676	4	0	6396
98611	1397	1374863620000	11028	5676	5	0	6397
98612	1397	1374853619000	11028	5676	6	0	6398
98614	1726	727791871000	11028	5676	8	0	3356
98615	1726	727781870000	11028	5676	9	0	3357
98616	1397	1374843618000	11029	5677	0	0	6399
98617	1726	727771869000	11029	5677	1	0	3358
98618	1726	727761868000	11030	5678	0	0	3359
98620	1397	1374823616000	11031	5679	0	0	6401
98621	1726	727751867000	11031	5679	1	0	3360
98622	1397	1374813615000	11032	5680	0	0	6402
98623	1726	727741866000	11032	5680	1	0	3361
98726	1726	727731865000	11036	5681	1	0	3362
98731	1397	1374793613000	11039	5682	0	0	6404
98732	1726	727721864000	11039	5682	1	0	3363
98737	1397	1374783612000	11042	5683	0	0	\N
98738	1726	727711863000	11042	5683	1	0	\N
98739	1397	1374783612000	11043	5683	0	0	\N
98740	1726	727711863000	11043	5683	1	0	\N
98743	1397	1374783612000	11045	5683	0	0	\N
98744	1726	727711863000	11045	5683	1	0	\N
98745	1726	727701862000	11046	5684	0	0	\N
98746	1397	1374773611000	11046	5684	1	0	\N
98747	1726	727701862000	11047	5684	0	0	\N
98748	1397	1374773611000	11047	5684	1	0	\N
98753	1397	1374763610000	11050	5685	0	0	\N
98754	1726	727691861000	11050	5685	1	0	\N
98755	1726	727701862000	11051	5684	0	0	\N
98756	1397	1374773611000	11051	5684	1	0	\N
98765	1726	727661858000	11054	5687	0	0	\N
98766	1726	727651857000	11054	5687	1	0	\N
98767	1397	1374733607000	11054	5687	2	0	\N
98768	1397	1374723606000	11054	5687	3	0	\N
98769	2042	490000000	11055	5673	0	0	\N
98770	411	66008410000000	11055	5673	1	0	\N
98771	439	66000040000000	11055	5673	2	0	\N
98772	1726	727841876000	11055	5673	3	0	\N
98773	1726	727831875000	11055	5673	4	0	\N
98774	1726	727821874000	11055	5673	5	0	\N
98775	1726	727811873000	11055	5673	6	0	\N
98776	1397	1374903624000	11055	5673	7	0	\N
98777	1397	1374893623000	11055	5673	8	0	\N
98778	1397	1374883622000	11055	5673	9	0	\N
98779	1397	1374873621000	11055	5673	10	0	\N
98780	1397	1374863620000	11055	5673	11	0	\N
98781	1397	1374853619000	11055	5673	12	0	\N
98782	1397	1374843618000	11055	5673	13	0	\N
98783	1397	1374833617000	11055	5673	14	0	\N
98784	1397	1374823616000	11055	5673	15	0	\N
98785	1397	1374813615000	11055	5673	16	0	\N
98786	1397	1374803614000	11055	5673	17	0	\N
98787	1397	1374793613000	11055	5673	18	0	\N
98788	1397	1374783612000	11055	5673	19	0	\N
98789	1397	1374773611000	11055	5673	20	0	\N
98790	1397	1374763610000	11055	5673	21	0	\N
98791	1397	1374753609000	11055	5673	22	0	\N
98792	1397	1374743608000	11055	5673	23	0	\N
98793	1397	1374733607000	11055	5673	24	0	\N
98794	1397	1374723606000	11055	5673	25	0	\N
98795	1726	727801872000	11055	5673	26	0	\N
98796	1726	727791871000	11055	5673	27	0	\N
98797	1726	727781870000	11055	5673	28	0	\N
98798	1726	727771869000	11055	5673	29	0	\N
98799	1726	727761868000	11055	5673	30	0	\N
98800	1726	727751867000	11055	5673	31	0	\N
98801	1726	727741866000	11055	5673	32	0	\N
98802	1726	727731865000	11055	5673	33	0	\N
98803	1726	727721864000	11055	5673	34	0	\N
98804	1726	727711863000	11055	5673	35	0	\N
98805	1726	727701862000	11055	5673	36	0	\N
98806	1726	727691861000	11055	5673	37	0	\N
98807	1726	727681860000	11055	5673	38	0	\N
98808	1726	727671859000	11055	5673	39	0	\N
98809	1726	727661858000	11055	5673	40	0	\N
98810	1726	727651857000	11055	5673	41	0	\N
98811	1726	727661858000	11056	5687	0	0	\N
98812	1726	727651857000	11056	5687	1	0	\N
98813	1397	1374733607000	11056	5687	2	0	\N
98814	1397	1374723606000	11056	5687	3	0	\N
98815	1726	727661858000	11057	5687	0	0	\N
98816	1726	727651857000	11057	5687	1	0	\N
98817	1397	1374733607000	11057	5687	2	0	\N
98818	1397	1374723606000	11057	5687	3	0	\N
98821	1726	727631855000	11060	5690	0	0	\N
98822	1726	727621854000	11060	5690	1	0	\N
98823	1726	727611853000	11060	5690	2	0	\N
98824	1397	1374703604000	11060	5690	3	0	\N
98825	1397	1374693603000	11060	5690	4	0	\N
98826	1397	1374683602000	11060	5690	5	0	\N
98837	1397	1374673601000	11063	5691	0	0	\N
98838	1726	727601852000	11063	5691	1	0	\N
98839	1726	727591851000	11063	5691	2	0	\N
98840	1397	1374663600000	11063	5691	3	0	\N
98841	1397	1374653599000	11064	5692	0	0	\N
98842	1726	727581850000	11064	5692	1	0	\N
98847	1726	727571849000	11067	5693	0	0	\N
98848	1397	1374643598000	11067	5693	1	0	\N
98849	1726	727571849000	11068	5693	0	0	\N
98850	1397	1374643598000	11068	5693	1	0	\N
98856	1726	727551847000	11071	5695	0	0	\N
98857	1397	1374623596000	11071	5695	1	0	\N
98862	1458	4413336908540	11074	5651	0	0	\N
98863	1509	20880551000000	11074	5651	1	0	\N
98864	1509	18236214312008	11074	5651	2	0	\N
98865	1509	15038988021455	11074	5651	3	0	\N
98866	1509	10300438532383	11074	5651	4	0	\N
98867	1509	1391261851155	11074	5651	5	0	\N
98868	1546	21599641000000	11074	5651	6	0	\N
98869	1397	1375193653000	11074	5651	7	0	\N
98870	1397	1375183652000	11074	5651	8	0	\N
98871	1397	1375173651000	11074	5651	9	0	\N
98872	1397	1375163650000	11074	5651	10	0	\N
98749	1726	727701862000	11048	5684	0	0	3365
98750	1397	1374773611000	11048	5684	1	0	6406
98751	1397	1374763610000	11049	5685	0	0	6407
98752	1726	727691861000	11049	5685	1	0	3366
98757	1726	727681860000	11052	5686	0	0	3367
98759	1397	1374753609000	11052	5686	2	0	6408
98760	1397	1374743608000	11052	5686	3	0	6409
98761	1726	727661858000	11053	5687	0	0	3369
98762	1726	727651857000	11053	5687	1	0	3370
98763	1397	1374733607000	11053	5687	2	0	6410
98819	1726	727641856000	11059	5689	0	0	3371
98820	1397	1374713605000	11059	5689	1	0	6412
98827	1726	727631855000	11061	5690	0	0	3372
98828	1726	727621854000	11061	5690	1	0	3373
98830	1397	1374703604000	11061	5690	3	0	6413
98831	1397	1374693603000	11061	5690	4	0	6414
98832	1397	1374683602000	11061	5690	5	0	6415
98833	1397	1374673601000	11062	5691	0	0	6416
98834	1726	727601852000	11062	5691	1	0	3375
98836	1397	1374663600000	11062	5691	3	0	6417
98843	1397	1374653599000	11065	5692	0	0	6418
98844	1726	727581850000	11065	5692	1	0	3377
98845	1726	727571849000	11066	5693	0	0	3378
98846	1397	1374643598000	11066	5693	1	0	6419
98852	1726	727561848000	11069	5694	1	0	3379
98853	1397	1374633597000	11069	5694	2	0	6420
98854	1726	727551847000	11070	5695	0	0	3380
98855	1397	1374623596000	11070	5695	1	0	6421
98859	1726	727541846000	11072	5696	1	0	3381
98860	1726	727531845000	11073	5697	0	0	3382
98861	1397	1374603594000	11073	5697	1	0	6423
98873	1397	1375153649000	11074	5651	11	0	\N
98874	1397	1375143648000	11074	5651	12	0	\N
98875	1397	1375133647000	11074	5651	13	0	\N
98876	1397	1375123646000	11074	5651	14	0	\N
98877	1397	1375113645000	11074	5651	15	0	\N
98878	1397	1375103644000	11074	5651	16	0	\N
98879	439	66000040000000	11074	5651	17	0	\N
98880	411	66837920000000	11074	5651	18	0	\N
98881	411	66007910000000	11074	5651	19	0	\N
98882	1726	728121904000	11074	5651	20	0	\N
98883	1726	728111903000	11074	5651	21	0	\N
98884	1726	728101902000	11074	5651	22	0	\N
98885	1726	728091901000	11074	5651	23	0	\N
98886	1726	728081900000	11074	5651	24	0	\N
98887	1726	728071899000	11074	5651	25	0	\N
98888	1726	728061898000	11074	5651	26	0	\N
98889	1726	728051897000	11074	5651	27	0	\N
98890	1726	728041896000	11074	5651	28	0	\N
98891	1726	728031895000	11074	5651	29	0	\N
98892	1726	728021894000	11074	5651	30	0	\N
98893	1397	1375093643000	11074	5651	31	0	\N
98894	1397	1375083642000	11074	5651	32	0	\N
98895	1397	1375073641000	11074	5651	33	0	\N
98896	1397	1375063640000	11074	5651	34	0	\N
98897	1397	1375053639000	11074	5651	35	0	\N
98898	1397	1375043638000	11074	5651	36	0	\N
98899	1397	1375033637000	11074	5651	37	0	\N
98900	1397	1375023636000	11074	5651	38	0	\N
98901	1397	1375013635000	11074	5651	39	0	\N
98902	1397	1375003634000	11074	5651	40	0	\N
98903	1397	1374993633000	11074	5651	41	0	\N
98904	1397	1374983632000	11074	5651	42	0	\N
98905	1397	1374973631000	11074	5651	43	0	\N
98906	1397	1374963630000	11074	5651	44	0	\N
98907	1397	1374953629000	11074	5651	45	0	\N
98908	1397	1374943628000	11074	5651	46	0	\N
98909	1397	1374933627000	11074	5651	48	0	\N
98910	1397	1374923626000	11074	5651	49	0	\N
98911	1397	1374913625000	11074	5651	50	0	\N
98912	1397	1374903624000	11074	5651	51	0	\N
98913	1397	1374893623000	11074	5651	52	0	\N
98914	1397	1374883622000	11074	5651	53	0	\N
98915	1397	1374873621000	11074	5651	54	0	\N
98916	1397	1374863620000	11074	5651	55	0	\N
98917	1397	1374853619000	11074	5651	56	0	\N
98918	1397	1374843618000	11074	5651	57	0	\N
98919	1397	1374833617000	11074	5651	58	0	\N
98920	1397	1374823616000	11074	5651	59	0	\N
98921	1397	1374813615000	11074	5651	60	0	\N
98922	1397	1374803614000	11074	5651	61	0	\N
98923	1397	1374793613000	11074	5651	62	0	\N
98924	1397	1374783612000	11074	5651	63	0	\N
98925	1397	1374773611000	11074	5651	64	0	\N
98926	1397	1374763610000	11074	5651	65	0	\N
98927	1726	728011893000	11074	5651	66	0	\N
98928	1726	728001892000	11074	5651	67	0	\N
98929	1726	727991891000	11074	5651	68	0	\N
98930	1726	727981890000	11074	5651	69	0	\N
98931	1726	727971889000	11074	5651	70	0	\N
98932	1726	727961888000	11074	5651	71	0	\N
98933	1726	727951887000	11074	5651	72	0	\N
98934	1726	727941886000	11074	5651	73	0	\N
98935	1726	727931885000	11074	5651	74	0	\N
98936	1726	727921884000	11074	5651	75	0	\N
98937	1726	727911883000	11074	5651	76	0	\N
98938	1726	727901882000	11074	5651	77	0	\N
98939	1726	727891881000	11074	5651	78	0	\N
98940	1726	727881880000	11074	5651	79	0	\N
98941	1726	727871879000	11074	5651	80	0	\N
98942	1726	727861878000	11074	5651	81	0	\N
98943	1726	727851877000	11074	5651	82	0	\N
98944	1726	727841876000	11074	5651	83	0	\N
98945	1726	727831875000	11074	5651	84	0	\N
98946	1726	727821874000	11074	5651	85	0	\N
98947	1726	727811873000	11074	5651	86	0	\N
98948	1397	1374753609000	11074	5651	87	0	\N
98949	1397	1374743608000	11074	5651	88	0	\N
98950	1397	1374733607000	11074	5651	89	0	\N
98951	1397	1374723606000	11074	5651	90	0	\N
98952	1397	1374713605000	11074	5651	91	0	\N
98953	1397	1374703604000	11074	5651	92	0	\N
98954	1397	1374693603000	11074	5651	93	0	\N
98955	1397	1374683602000	11074	5651	94	0	\N
98956	1397	1374673601000	11074	5651	95	0	\N
98957	1397	1374663600000	11074	5651	96	0	\N
98958	1397	1374653599000	11074	5651	97	0	\N
98959	1397	1374643598000	11074	5651	98	0	\N
98960	1397	1374633597000	11074	5651	99	0	\N
98961	1397	1374623596000	11074	5651	100	0	\N
98962	1397	1374613595000	11074	5651	101	0	\N
98963	1726	727801872000	11074	5651	102	0	\N
98964	1726	727791871000	11074	5651	103	0	\N
98965	1726	727781870000	11074	5651	104	0	\N
98966	1726	727771869000	11074	5651	105	0	\N
98967	1726	727761868000	11074	5651	106	0	\N
98968	1726	727751867000	11074	5651	107	0	\N
98969	1726	727741866000	11074	5651	108	0	\N
98970	1726	727731865000	11074	5651	109	0	\N
98971	1726	727721864000	11074	5651	110	0	\N
98972	1726	727711863000	11074	5651	111	0	\N
98973	1726	727701862000	11074	5651	112	0	\N
98974	1726	727691861000	11074	5651	113	0	\N
98975	1726	727681860000	11074	5651	114	0	\N
98976	1726	727671859000	11074	5651	115	0	\N
98977	1726	727661858000	11074	5651	116	0	\N
98978	1726	727651857000	11074	5651	117	0	\N
98979	1726	727641856000	11074	5651	118	0	\N
98980	1726	727631855000	11074	5651	119	0	\N
98981	1726	727621854000	11074	5651	120	0	\N
98982	1726	727611853000	11074	5651	121	0	\N
98983	1726	727601852000	11074	5651	122	0	\N
98984	1726	727591851000	11074	5651	123	0	\N
98985	1726	727581850000	11074	5651	124	0	\N
98986	1726	727571849000	11074	5651	125	0	\N
98987	1397	1374593593000	11075	5698	0	0	\N
98988	1726	727521844000	11075	5698	1	0	\N
98991	1546	19228631000000	11077	5699	0	0	\N
98992	1726	727511843000	11077	5699	1	0	\N
98993	1397	1374583592000	11077	5699	2	0	\N
98999	1397	1374573591000	11080	5700	0	0	\N
99000	1726	727501842000	11080	5700	1	0	\N
99001	1397	1374573591000	11081	5700	0	0	\N
99002	1726	727501842000	11081	5700	1	0	\N
99007	1397	1374553589000	11083	5702	0	0	\N
99008	1726	727481840000	11083	5702	1	0	\N
98994	1546	19228631000000	11078	5699	0	0	2
98995	1726	727511843000	11078	5699	1	0	3384
98996	1397	1374583592000	11078	5699	2	0	6425
98997	1397	1374573591000	11079	5700	0	0	6426
98998	1726	727501842000	11079	5700	1	0	3385
99004	1546	16361621000000	11082	5701	1	0	3
99005	1546	12112611000000	11082	5701	2	0	4
99006	1397	1374563590000	11082	5701	3	0	6427
99014	1397	1374543588000	11086	5703	0	0	\N
99015	1546	4124601000000	11086	5703	1	0	\N
99016	1726	727471839000	11086	5703	2	0	\N
99029	1726	727411833000	11092	5708	0	0	\N
99030	1397	1374493583000	11092	5708	1	0	\N
99031	1546	2880591000000	11092	5708	2	0	\N
99034	1726	727401832000	11094	5709	0	0	\N
99035	1397	1374483582000	11094	5709	1	0	\N
99036	1726	727401832000	11095	5709	0	0	\N
99037	1397	1374483582000	11095	5709	1	0	\N
99038	1726	727401832000	11096	5709	0	0	\N
99039	1397	1374483582000	11096	5709	1	0	\N
99040	1726	727401832000	11097	5709	0	0	\N
99041	1397	1374483582000	11097	5709	1	0	\N
99042	1726	727391831000	11098	5710	0	0	\N
99043	1397	1374473581000	11098	5710	1	0	\N
99046	1691	14171602645814	11100	5697	0	0	\N
99047	1546	19228631000000	11100	5697	1	0	\N
99048	1691	12439161712302	11100	5697	2	0	\N
99049	1691	9334650322910	11100	5697	3	0	\N
99050	1691	7239971373927	11100	5697	4	0	\N
99051	1691	1402980100019	11100	5697	5	0	\N
99052	1546	16361621000000	11100	5697	6	0	\N
99053	1546	12112611000000	11100	5697	7	0	\N
99054	1546	4124601000000	11100	5697	8	0	\N
99055	1546	2880591000000	11100	5697	9	0	\N
99065	1726	727381830000	11102	5711	0	0	\N
99066	1691	14171602645814	11102	5711	1	0	\N
99067	1691	12439161712302	11102	5711	2	0	\N
99068	1691	9334650322910	11102	5711	3	0	\N
99069	1691	7239971373927	11102	5711	4	0	\N
99070	1691	1402980100019	11102	5711	5	0	\N
99071	1397	1374463580000	11102	5711	6	0	\N
99072	1397	1374453579000	11102	5711	7	0	\N
99073	1726	727371829000	11102	5711	8	0	\N
99074	1726	727381830000	11103	5711	0	0	\N
99075	1691	14171602645814	11103	5711	1	0	\N
99076	1691	12439161712302	11103	5711	2	0	\N
99077	1691	9334650322910	11103	5711	3	0	\N
99078	1691	7239971373927	11103	5711	4	0	\N
99079	1691	1402980100019	11103	5711	5	0	\N
99080	1397	1374463580000	11103	5711	6	0	\N
99081	1397	1374453579000	11103	5711	7	0	\N
99082	1726	727371829000	11103	5711	8	0	\N
99083	1397	1374803614000	11104	5608	0	0	\N
99084	1546	20879541000000	11104	5608	1	0	\N
99085	1726	727731865000	11104	5608	2	0	\N
99086	1691	14171602645814	11104	5608	3	0	\N
99087	1546	18508531000000	11104	5608	4	0	\N
99088	1397	1374793613000	11104	5608	5	0	\N
99089	1726	727721864000	11104	5608	6	0	\N
99090	1691	12439161712302	11104	5608	7	0	\N
99091	1691	9334650322910	11104	5608	8	0	\N
99092	1691	7239971373927	11104	5608	9	0	\N
99093	1691	1402980100019	11104	5608	10	0	\N
99094	1546	15641521000000	11104	5608	11	0	\N
99095	1397	1374783612000	11104	5608	12	0	\N
99096	1726	727711863000	11104	5608	13	0	\N
99097	1726	727701862000	11104	5608	14	0	\N
99098	1726	727691861000	11104	5608	15	0	\N
99099	1397	1374773611000	11104	5608	16	0	\N
99100	1397	1374763610000	11104	5608	17	0	\N
99101	1726	727681860000	11104	5608	18	0	\N
99102	1726	727671859000	11104	5608	19	0	\N
99103	1726	727661858000	11104	5608	20	0	\N
99104	1726	727651857000	11104	5608	21	0	\N
99105	1726	727641856000	11104	5608	22	0	\N
99106	1726	727631855000	11104	5608	23	0	\N
99107	1726	727621854000	11104	5608	24	0	\N
99108	1726	727611853000	11104	5608	25	0	\N
99109	1726	727601852000	11104	5608	26	0	\N
99110	1726	727591851000	11104	5608	27	0	\N
99111	1726	727581850000	11104	5608	28	0	\N
99112	1726	727571849000	11104	5608	29	0	\N
99113	1726	727561848000	11104	5608	30	0	\N
99114	1726	727551847000	11104	5608	31	0	\N
99115	1726	727541846000	11104	5608	32	0	\N
99116	1726	727531845000	11104	5608	33	0	\N
99117	1726	727521844000	11104	5608	34	0	\N
99118	1726	727511843000	11104	5608	35	0	\N
99119	1726	727501842000	11104	5608	36	0	\N
99120	1726	727491841000	11104	5608	37	0	\N
99121	1546	11392511000000	11104	5608	38	0	\N
99122	1546	3404501000000	11104	5608	39	0	\N
99123	1546	2160491000000	11104	5608	40	0	\N
99124	1726	727481840000	11104	5608	41	0	\N
99125	1726	727471839000	11104	5608	42	0	\N
99126	1726	727461838000	11104	5608	43	0	\N
99127	1726	727451837000	11104	5608	44	0	\N
99128	1726	727441836000	11104	5608	45	0	\N
99129	1726	727431835000	11104	5608	46	0	\N
99130	1726	727421834000	11104	5608	47	0	\N
99131	1726	727411833000	11104	5608	48	0	\N
99132	1726	727401832000	11104	5608	50	0	\N
99133	1726	727391831000	11104	5608	51	0	\N
99134	1726	727381830000	11104	5608	52	0	\N
99135	1726	727371829000	11104	5608	53	0	\N
99136	1397	1374753609000	11104	5608	54	0	\N
99137	1397	1374743608000	11104	5608	55	0	\N
99138	1397	1374733607000	11104	5608	56	0	\N
99139	1397	1374723606000	11104	5608	57	0	\N
99140	1397	1374713605000	11104	5608	58	0	\N
99141	1397	1374703604000	11104	5608	59	0	\N
99142	1397	1374693603000	11104	5608	60	0	\N
99143	1397	1374683602000	11104	5608	61	0	\N
99144	1397	1374673601000	11104	5608	62	0	\N
99011	1397	1374543588000	11085	5703	0	0	6429
99012	1546	4124601000000	11085	5703	1	0	5
99013	1726	727471839000	11085	5703	2	0	3388
99017	1726	727461838000	11087	5704	0	0	3389
99018	1726	727451837000	11087	5704	1	0	3390
99020	1397	1374523586000	11087	5704	3	0	6431
99021	1726	727441836000	11088	5705	0	0	3391
99022	1397	1374513585000	11088	5705	1	0	6432
99023	1726	727431835000	11089	5706	0	0	3392
99024	1397	1374503584000	11090	5707	0	0	6433
99026	1726	727411833000	11091	5708	0	0	3394
99027	1397	1374493583000	11091	5708	1	0	6434
99028	1546	2880591000000	11091	5708	2	0	6
99032	1726	727401832000	11093	5709	0	0	3395
99044	1726	727391831000	11099	5710	0	0	3396
99045	1397	1374473581000	11099	5710	1	0	6436
99056	1726	727381830000	11101	5711	0	0	3397
99057	1691	14171602645814	11101	5711	1	0	1
99058	1691	12439161712302	11101	5711	2	0	2
99060	1691	7239971373927	11101	5711	4	0	4
99061	1691	1402980100019	11101	5711	5	0	5
99062	1397	1374463580000	11101	5711	6	0	6437
99063	1397	1374453579000	11101	5711	7	0	6438
99064	1726	727371829000	11101	5711	8	0	3398
99145	1397	1374663600000	11104	5608	63	0	\N
99146	1397	1374653599000	11104	5608	64	0	\N
99147	1397	1374643598000	11104	5608	65	0	\N
99148	1397	1374633597000	11104	5608	66	0	\N
99149	1397	1374623596000	11104	5608	67	0	\N
99150	1397	1374613595000	11104	5608	68	0	\N
99151	1397	1374603594000	11104	5608	69	0	\N
99152	1397	1374593593000	11104	5608	70	0	\N
99153	1397	1374583592000	11104	5608	71	0	\N
99154	1397	1374573591000	11104	5608	72	0	\N
99155	1397	1374563590000	11104	5608	73	0	\N
99156	1397	1374553589000	11104	5608	74	0	\N
99157	1397	1374543588000	11104	5608	75	0	\N
99158	1397	1374533587000	11104	5608	76	0	\N
99159	1397	1374523586000	11104	5608	77	0	\N
99160	1397	1374513585000	11104	5608	78	0	\N
99161	1397	1374443578000	11105	5712	0	0	\N
99162	1397	1374433577000	11105	5712	1	0	\N
99163	1726	727361828000	11105	5712	2	0	\N
99164	1726	727351827000	11105	5712	3	0	\N
99165	1726	726141827000	11105	5712	4	0	\N
99173	1726	726131826000	11108	5713	0	0	\N
99174	1397	1374423576000	11108	5713	2	0	\N
99175	1726	726131826000	11109	5713	0	0	\N
99176	1397	1374423576000	11109	5713	2	0	\N
99177	1726	726131826000	11110	5713	0	0	\N
99178	1397	1374423576000	11110	5713	2	0	\N
99179	1397	1374413575000	11111	5714	0	0	\N
99180	1726	724921826000	11111	5714	1	0	\N
99181	1726	724911825000	11111	5714	2	0	\N
99182	1397	1374403574000	11111	5714	3	0	\N
99183	1726	724901824000	11111	5714	4	0	\N
99193	1397	1374393573000	11114	5715	0	0	\N
99194	1726	724891823000	11114	5715	1	0	\N
99195	1726	724881822000	11114	5715	2	0	\N
99196	1397	1374383572000	11114	5715	3	0	\N
99197	1397	1374393573000	11115	5715	0	0	\N
99198	1726	724891823000	11115	5715	1	0	\N
99199	1726	724881822000	11115	5715	2	0	\N
99200	1397	1374383572000	11115	5715	3	0	\N
99201	1397	1374393573000	11116	5715	0	0	\N
99202	1726	724891823000	11116	5715	1	0	\N
99203	1726	724881822000	11116	5715	2	0	\N
99204	1397	1374383572000	11116	5715	3	0	\N
99205	1397	1374373571000	11118	5716	0	0	\N
99206	1397	1374363570000	11118	5716	1	0	\N
99207	1726	724871821000	11118	5716	2	0	\N
99208	1726	724861820000	11118	5716	3	0	\N
99215	1726	724841818000	11121	5718	0	0	\N
99216	1397	1374343568000	11121	5718	1	0	\N
99217	1726	724841818000	11122	5718	0	0	\N
99218	1397	1374343568000	11122	5718	1	0	\N
99223	1546	21599641000000	11125	5693	0	0	\N
99224	1726	727571849000	11125	5693	1	0	\N
99225	1397	1374643598000	11125	5693	2	0	\N
99226	1691	14171602645814	11125	5693	3	0	\N
99227	1546	19228631000000	11125	5693	4	0	\N
99228	1726	727561848000	11125	5693	5	0	\N
99229	1726	727551847000	11125	5693	6	0	\N
99230	1691	12439161712302	11125	5693	7	0	\N
99231	1691	9334650322910	11125	5693	8	0	\N
99232	1691	7239971373927	11125	5693	9	0	\N
99233	1691	1402980100019	11125	5693	10	0	\N
99234	1546	16361621000000	11125	5693	11	0	\N
99235	1726	727541846000	11125	5693	12	0	\N
99236	1726	727531845000	11125	5693	13	0	\N
99237	1726	727521844000	11125	5693	14	0	\N
99238	1726	727511843000	11125	5693	15	0	\N
99239	1726	727501842000	11125	5693	16	0	\N
99240	1726	727491841000	11125	5693	17	0	\N
99241	1397	1374633597000	11125	5693	18	0	\N
99242	1397	1374623596000	11125	5693	19	0	\N
99243	1397	1374613595000	11125	5693	20	0	\N
99244	1397	1374603594000	11125	5693	21	0	\N
99245	1397	1374593593000	11125	5693	22	0	\N
99246	1397	1374583592000	11125	5693	23	0	\N
99247	1397	1374573591000	11125	5693	24	0	\N
99248	1546	12112611000000	11125	5693	25	0	\N
99249	1546	4124601000000	11125	5693	26	0	\N
99250	1546	2880591000000	11125	5693	27	0	\N
99251	1726	727481840000	11125	5693	28	0	\N
99252	1726	727471839000	11125	5693	29	0	\N
99253	1726	727461838000	11125	5693	30	0	\N
99254	1726	727451837000	11125	5693	31	0	\N
99255	1726	727441836000	11125	5693	32	0	\N
99256	1726	727431835000	11125	5693	33	0	\N
99257	1726	727421834000	11125	5693	34	0	\N
99258	1726	727411833000	11125	5693	35	0	\N
99259	1726	727401832000	11125	5693	36	0	\N
99260	1726	727391831000	11125	5693	37	0	\N
99261	1726	727381830000	11125	5693	38	0	\N
99262	1726	727371829000	11125	5693	39	0	\N
99263	1726	727361828000	11125	5693	40	0	\N
99264	1726	727351827000	11125	5693	41	0	\N
99265	1726	726141827000	11125	5693	42	0	\N
99266	1726	726131826000	11125	5693	43	0	\N
99267	1726	724921826000	11125	5693	44	0	\N
99268	1726	724911825000	11125	5693	45	0	\N
99269	1397	1374563590000	11125	5693	46	0	\N
99270	1397	1374553589000	11125	5693	47	0	\N
99271	1397	1374543588000	11125	5693	48	0	\N
99272	1726	724901824000	11125	5693	49	0	\N
99273	1726	724891823000	11125	5693	50	0	\N
99274	1726	724881822000	11125	5693	51	0	\N
99275	1726	724871821000	11125	5693	52	0	\N
99276	1726	724861820000	11125	5693	53	0	\N
99277	1726	724851819000	11125	5693	54	0	\N
99278	1726	724841818000	11125	5693	55	0	\N
99279	1726	724831817000	11125	5693	56	0	\N
99280	1397	1374533587000	11125	5693	57	0	\N
99168	1726	727361828000	11106	5712	2	0	3399
99169	1726	727351827000	11106	5712	3	0	3400
99170	1726	726141827000	11106	5712	4	0	3401
99171	1726	726131826000	11107	5713	0	0	3402
99172	1397	1374423576000	11107	5713	2	0	6441
99185	1726	724921826000	11112	5714	1	0	3403
99186	1726	724911825000	11112	5714	2	0	3404
99187	1397	1374403574000	11112	5714	3	0	6443
99188	1726	724901824000	11112	5714	4	0	3405
99189	1397	1374393573000	11113	5715	0	0	6444
99191	1726	724881822000	11113	5715	2	0	3407
99192	1397	1374383572000	11113	5715	3	0	6445
99209	1397	1374373571000	11119	5716	0	0	6446
99210	1397	1374363570000	11119	5716	1	0	6447
99212	1726	724861820000	11119	5716	3	0	3409
99213	1397	1374353569000	11120	5717	0	0	6448
99214	1726	724851819000	11120	5717	1	0	3410
99219	1726	724841818000	11123	5718	0	0	3411
99220	1397	1374343568000	11123	5718	1	0	6449
99222	1726	724831817000	11124	5719	1	0	3412
99281	1397	1374523586000	11125	5693	58	0	\N
99282	1397	1374513585000	11125	5693	59	0	\N
99283	1397	1374503584000	11125	5693	60	0	\N
99284	1397	1374493583000	11125	5693	61	0	\N
99285	1397	1374483582000	11125	5693	62	0	\N
99286	1397	1374473581000	11125	5693	63	0	\N
99287	1397	1374463580000	11125	5693	64	0	\N
99288	1397	1374453579000	11125	5693	65	0	\N
99289	1397	1374443578000	11125	5693	66	0	\N
99290	1397	1374433577000	11125	5693	67	0	\N
99291	1397	1374423576000	11125	5693	68	0	\N
99292	1397	1374413575000	11125	5693	69	0	\N
99293	1397	1374403574000	11125	5693	70	0	\N
99294	1397	1374393573000	11125	5693	71	0	\N
99295	1397	1374383572000	11125	5693	72	0	\N
99296	1397	1374373571000	11125	5693	73	0	\N
99297	1397	1374363570000	11125	5693	74	0	\N
99298	1397	1374353569000	11125	5693	75	0	\N
99299	1397	1374343568000	11125	5693	76	0	\N
99300	1397	1374333567000	11125	5693	77	0	\N
99303	1726	724821816000	11127	5720	0	0	\N
99304	1397	1374323566000	11127	5720	1	0	\N
99305	1726	724821816000	11128	5720	0	0	\N
99306	1397	1374323566000	11128	5720	1	0	\N
99307	1397	1374313565000	11129	5721	0	0	\N
99308	1726	724811815000	11129	5721	1	0	\N
99309	1726	724801814000	11129	5721	2	0	\N
99310	1397	1374303564000	11129	5721	3	0	\N
99315	1546	21599641000000	11131	5673	0	0	\N
99316	2042	490000000	11131	5673	1	0	\N
99317	1691	14171602645814	11131	5673	2	0	\N
99318	1546	19228631000000	11131	5673	3	0	\N
99319	411	66008410000000	11131	5673	4	0	\N
99320	1691	12439161712302	11131	5673	5	0	\N
99321	1691	9334650322910	11131	5673	6	0	\N
99322	1691	7239971373927	11131	5673	7	0	\N
99323	1691	1402980100019	11131	5673	8	0	\N
99324	1546	16361621000000	11131	5673	9	0	\N
99325	439	66000040000000	11131	5673	10	0	\N
99326	1726	727841876000	11131	5673	11	0	\N
99327	1726	727831875000	11131	5673	12	0	\N
99328	1726	727821874000	11131	5673	13	0	\N
99329	1726	727811873000	11131	5673	14	0	\N
99330	1397	1374903624000	11131	5673	15	0	\N
99331	1397	1374893623000	11131	5673	16	0	\N
99332	1397	1374883622000	11131	5673	17	0	\N
99333	1397	1374873621000	11131	5673	18	0	\N
99334	1397	1374863620000	11131	5673	19	0	\N
99335	1397	1374853619000	11131	5673	20	0	\N
99336	1397	1374843618000	11131	5673	21	0	\N
99337	1397	1374833617000	11131	5673	22	0	\N
99338	1397	1374823616000	11131	5673	23	0	\N
99339	1397	1374813615000	11131	5673	24	0	\N
99340	1397	1374803614000	11131	5673	25	0	\N
99341	1397	1374793613000	11131	5673	26	0	\N
99342	1397	1374783612000	11131	5673	27	0	\N
99343	1397	1374773611000	11131	5673	28	0	\N
99344	1397	1374763610000	11131	5673	29	0	\N
99345	1546	12112611000000	11131	5673	30	0	\N
99346	1546	4124601000000	11131	5673	31	0	\N
99347	1546	2880591000000	11131	5673	32	0	\N
99348	1397	1374753609000	11131	5673	33	0	\N
99349	1397	1374743608000	11131	5673	34	0	\N
99350	1397	1374733607000	11131	5673	35	0	\N
99351	1397	1374723606000	11131	5673	36	0	\N
99352	1397	1374713605000	11131	5673	37	0	\N
99353	1397	1374703604000	11131	5673	38	0	\N
99354	1397	1374693603000	11131	5673	39	0	\N
99355	1397	1374683602000	11131	5673	40	0	\N
99356	1397	1374673601000	11131	5673	41	0	\N
99357	1397	1374663600000	11131	5673	42	0	\N
99358	1397	1374653599000	11131	5673	43	0	\N
99359	1397	1374643598000	11131	5673	44	0	\N
99360	1397	1374633597000	11131	5673	45	0	\N
99361	1397	1374623596000	11131	5673	46	0	\N
99362	1397	1374613595000	11131	5673	47	0	\N
99363	1397	1374603594000	11131	5673	48	0	\N
99364	1397	1374593593000	11131	5673	49	0	\N
99365	1397	1374583592000	11131	5673	50	0	\N
99366	1397	1374573591000	11131	5673	51	0	\N
99367	1397	1374563590000	11131	5673	52	0	\N
99368	1397	1374553589000	11131	5673	53	0	\N
99369	1397	1374543588000	11131	5673	54	0	\N
99370	1726	727801872000	11131	5673	55	0	\N
99371	1726	727791871000	11131	5673	56	0	\N
99372	1726	727781870000	11131	5673	57	0	\N
99373	1726	727771869000	11131	5673	58	0	\N
99374	1726	727761868000	11131	5673	59	0	\N
99375	1726	727751867000	11131	5673	60	0	\N
99376	1726	727741866000	11131	5673	61	0	\N
99377	1726	727731865000	11131	5673	62	0	\N
99378	1726	727721864000	11131	5673	63	0	\N
99379	1726	727711863000	11131	5673	64	0	\N
99380	1726	727701862000	11131	5673	66	0	\N
99381	1726	727691861000	11131	5673	67	0	\N
99382	1726	727681860000	11131	5673	68	0	\N
99383	1726	727671859000	11131	5673	69	0	\N
99384	1726	727661858000	11131	5673	70	0	\N
99385	1726	727651857000	11131	5673	71	0	\N
99386	1726	727641856000	11131	5673	72	0	\N
99387	1726	727631855000	11131	5673	73	0	\N
99388	1726	727621854000	11131	5673	74	0	\N
99389	1726	727611853000	11131	5673	75	0	\N
99390	1726	727601852000	11131	5673	76	0	\N
99391	1726	727591851000	11131	5673	77	0	\N
99392	1726	727581850000	11131	5673	78	0	\N
99393	1726	727571849000	11131	5673	79	0	\N
99394	1726	727561848000	11131	5673	80	0	\N
99395	1726	727551847000	11131	5673	81	0	\N
99396	1726	727541846000	11131	5673	82	0	\N
99397	1726	727531845000	11131	5673	83	0	\N
99398	1726	727521844000	11131	5673	84	0	\N
99399	1726	727511843000	11131	5673	85	0	\N
99400	1726	727501842000	11131	5673	86	0	\N
99401	1726	727491841000	11131	5673	87	0	\N
99402	1726	727481840000	11131	5673	88	0	\N
99403	1726	727471839000	11131	5673	89	0	\N
99404	1726	727461838000	11131	5673	90	0	\N
99405	1726	727451837000	11131	5673	91	0	\N
99406	1726	727441836000	11131	5673	92	0	\N
99407	1726	727431835000	11131	5673	93	0	\N
99408	1726	727421834000	11131	5673	94	0	\N
99409	1726	727411833000	11131	5673	95	0	\N
99410	1726	727401832000	11131	5673	96	0	\N
99411	1726	727391831000	11131	5673	97	0	\N
99412	1726	727381830000	11131	5673	98	0	\N
99413	1726	727371829000	11131	5673	99	0	\N
99414	1726	727361828000	11131	5673	100	0	\N
99415	1726	727351827000	11131	5673	101	0	\N
99416	1726	726141827000	11131	5673	102	0	\N
99311	1397	1374313565000	11130	5721	0	0	6452
99312	1726	724811815000	11130	5721	1	0	3414
99313	1726	724801814000	11130	5721	2	0	3415
99314	1397	1374303564000	11130	5721	3	0	6453
99417	1726	726131826000	11131	5673	103	0	\N
99418	1726	724921826000	11131	5673	104	0	\N
99419	1726	724911825000	11131	5673	105	0	\N
99420	1726	724901824000	11131	5673	106	0	\N
99421	1726	724891823000	11131	5673	107	0	\N
99422	1726	724881822000	11131	5673	108	0	\N
99423	1726	724871821000	11131	5673	109	0	\N
99424	1726	724861820000	11131	5673	110	0	\N
99425	1726	724851819000	11131	5673	111	0	\N
99426	1726	724841818000	11131	5673	112	0	\N
99427	1726	724831817000	11131	5673	113	0	\N
99428	1726	724821816000	11131	5673	114	0	\N
99429	1726	724811815000	11131	5673	115	0	\N
99430	1726	724801814000	11131	5673	116	0	\N
99431	1397	1374533587000	11131	5673	117	0	\N
99432	1397	1374523586000	11131	5673	118	0	\N
99433	1397	1374513585000	11131	5673	119	0	\N
99434	1397	1374503584000	11131	5673	120	0	\N
99435	1397	1374493583000	11131	5673	121	0	\N
99436	1397	1374483582000	11131	5673	122	0	\N
99437	1397	1374473581000	11131	5673	123	0	\N
99438	1397	1374463580000	11131	5673	124	0	\N
99439	1397	1374453579000	11131	5673	125	0	\N
99442	1397	1374283562000	11133	5723	0	0	\N
99443	1726	724781812000	11133	5723	1	0	\N
99446	1397	1374283562000	11135	5723	0	0	\N
99447	1726	724781812000	11135	5723	1	0	\N
99448	1397	1374283562000	11136	5723	0	0	\N
99449	1726	724781812000	11136	5723	1	0	\N
99450	1726	724771811000	11137	5724	0	0	\N
99451	1726	724761810000	11137	5724	1	0	\N
99452	1397	1374273561000	11137	5724	2	0	\N
99453	1397	1374263560000	11137	5724	3	0	\N
99454	1397	1374253559000	11137	5724	4	0	\N
99455	1726	724751809000	11137	5724	5	0	\N
99464	1726	724731807000	11140	5726	0	0	\N
99465	1397	1374233557000	11140	5726	1	0	\N
99468	1726	724731807000	11142	5726	0	0	\N
99469	1397	1374233557000	11142	5726	1	0	\N
99473	1726	724711805000	11144	5728	0	0	\N
99474	1726	724701804000	11144	5728	1	0	\N
99475	1397	1374203554000	11144	5728	2	0	\N
99476	1397	1374193553000	11144	5728	3	0	\N
99481	1726	724711805000	11146	5728	0	0	\N
99482	1726	724701804000	11146	5728	1	0	\N
99483	1397	1374203554000	11146	5728	2	0	\N
99484	1397	1374193553000	11146	5728	3	0	\N
99485	1726	724711805000	11147	5728	0	0	\N
99486	1726	724701804000	11147	5728	1	0	\N
99487	1397	1374203554000	11147	5728	2	0	\N
99488	1397	1374193553000	11147	5728	3	0	\N
99489	1726	724691803000	11148	5729	0	0	\N
99490	1397	1374183552000	11148	5729	1	0	\N
99501	1397	1374133547000	11154	5734	0	0	\N
99502	1726	724641798000	11154	5734	1	0	\N
99520	1726	724561790000	11166	5739	0	0	\N
99521	1397	1374063540000	11166	5739	1	0	\N
99522	1726	724551789000	11170	5741	0	0	\N
99523	1726	724541788000	11170	5741	1	0	\N
99524	1397	1374053539000	11170	5741	2	0	\N
99525	1397	1374043538000	11170	5741	3	0	\N
99526	1726	724551789000	11171	5741	0	0	\N
99527	1726	724541788000	11171	5741	1	0	\N
99528	1397	1374053539000	11171	5741	2	0	\N
99529	1397	1374043538000	11171	5741	3	0	\N
99530	1726	724551789000	11172	5741	0	0	\N
99531	1726	724541788000	11172	5741	1	0	\N
99532	1397	1374053539000	11172	5741	2	0	\N
99533	1397	1374043538000	11172	5741	3	0	\N
99534	1726	724551789000	11173	5741	0	0	\N
99535	1726	724541788000	11173	5741	1	0	\N
99536	1397	1374053539000	11173	5741	2	0	\N
99537	1397	1374043538000	11173	5741	3	0	\N
99538	1726	724551789000	11174	5741	0	0	\N
99539	1726	724541788000	11174	5741	1	0	\N
99540	1397	1374053539000	11174	5741	2	0	\N
99541	1397	1374043538000	11174	5741	3	0	\N
99542	1726	724551789000	11175	5741	0	0	\N
99543	1726	724541788000	11175	5741	1	0	\N
99544	1397	1374053539000	11175	5741	2	0	\N
99545	1397	1374043538000	11175	5741	3	0	\N
99550	1458	23002236908540	11177	5617	0	0	\N
99551	1458	19473936908540	11177	5617	1	0	\N
99552	1458	14244636908540	11177	5617	2	0	\N
99444	1397	1374283562000	11134	5723	0	0	6455
99445	1726	724781812000	11134	5723	1	0	3417
99456	1726	724771811000	11138	5724	0	0	3418
99457	1726	724761810000	11138	5724	1	0	3419
99458	1397	1374273561000	11138	5724	2	0	6456
99460	1397	1374253559000	11138	5724	4	0	6458
99461	1726	724751809000	11138	5724	5	0	3420
99462	1397	1374243558000	11139	5725	0	0	6459
99463	1726	724741808000	11139	5725	1	0	3421
99466	1726	724731807000	11141	5726	0	0	3422
99470	1397	1374223556000	11143	5727	0	0	6461
99471	1397	1374213555000	11143	5727	1	0	6462
99472	1726	724721806000	11143	5727	2	0	3423
99477	1726	724711805000	11145	5728	0	0	3424
99479	1397	1374203554000	11145	5728	2	0	6463
99480	1397	1374193553000	11145	5728	3	0	6464
99491	1726	724691803000	11149	5729	0	0	3426
99492	1397	1374183552000	11149	5729	1	0	6465
99493	1397	1374173551000	11151	5731	0	0	6466
99495	1726	724671801000	11151	5731	2	0	3428
99496	1397	1374163550000	11151	5731	3	0	6467
99497	1726	724661800000	11152	5732	0	0	3429
99498	1397	1374153549000	11152	5732	1	0	6468
99499	1397	1374143548000	11153	5733	0	0	6469
99503	1397	1374133547000	11155	5734	0	0	6470
99504	1726	724641798000	11155	5734	1	0	3431
99505	1397	1374123546000	11156	5735	0	0	6471
99506	1726	724631797000	11156	5735	1	0	3432
99508	1726	724611795000	11158	5736	0	0	3434
99509	1397	1374113545000	11158	5736	1	0	6472
99510	1397	1374103544000	11163	5737	0	0	6473
99511	1397	1374093543000	11163	5737	1	0	6474
99512	1397	1374083542000	11163	5737	2	0	6475
99514	1726	724591793000	11163	5737	4	0	3436
99515	1726	724581792000	11163	5737	5	0	3437
99516	1726	724571791000	11164	5738	0	0	3438
99517	1397	1374073541000	11164	5738	1	0	6476
99518	1726	724561790000	11165	5739	0	0	3439
99546	1726	724551789000	11176	5741	0	0	3440
99547	1726	724541788000	11176	5741	1	0	3441
99548	1397	1374053539000	11176	5741	2	0	6478
99549	1397	1374043538000	11176	5741	3	0	6479
99553	1458	4413336908540	11177	5617	3	0	\N
99554	1656	15782634000000	11177	5617	4	0	\N
99555	1656	10389514000000	11177	5617	5	0	\N
99556	1656	6750394000000	11177	5617	6	0	\N
99557	1656	3741274000000	11177	5617	7	0	\N
99558	2015	333700000000	11177	5617	8	0	\N
99559	1509	20880543000000	11177	5617	9	0	\N
99560	1509	18236206312008	11177	5617	10	0	\N
99561	1509	15038980021455	11177	5617	11	0	\N
99562	1509	10300430532383	11177	5617	12	0	\N
99563	1509	1391253851155	11177	5617	13	0	\N
99564	1755	2156950000000	11177	5617	14	0	\N
99565	633	77159889900000	11177	5617	15	0	\N
99566	633	72755869900000	11177	5617	16	0	\N
99567	633	69781849900000	11177	5617	17	0	\N
99568	633	67323829900000	11177	5617	18	0	\N
99569	1546	20879541000000	11177	5617	19	0	\N
99570	1691	14171602645814	11177	5617	20	0	\N
99571	1546	18508531000000	11177	5617	21	0	\N
99572	1397	1375653699000	11177	5617	22	0	\N
99573	1397	1375643698000	11177	5617	23	0	\N
99574	1397	1375633697000	11177	5617	24	0	\N
99575	1691	12439161712302	11177	5617	25	0	\N
99576	1691	9334650322910	11177	5617	26	0	\N
99577	1654	12989640600000	11177	5617	27	0	\N
99578	1654	9558071000000	11177	5617	28	0	\N
99579	1654	7242584200000	11177	5617	29	0	\N
99580	1691	7239971373927	11177	5617	30	0	\N
99581	1691	1402980100019	11177	5617	31	0	\N
99582	1397	1375623696000	11177	5617	32	0	\N
99583	1397	1375613695000	11177	5617	33	0	\N
99584	1546	15641521000000	11177	5617	34	0	\N
99585	1397	1375603694000	11177	5617	35	0	\N
99586	439	66000040000000	11177	5617	36	0	\N
99587	1608	10828470000000	11177	5617	37	0	\N
99588	1608	7396460000000	11177	5617	38	0	\N
99589	1608	5080450000000	11177	5617	39	0	\N
99590	1723	19521957085979	11177	5617	40	0	\N
99591	1723	16157947085979	11177	5617	41	0	\N
99592	411	66837920000000	11177	5617	42	0	\N
99593	411	66007910000000	11177	5617	43	0	\N
99594	1397	1375593693000	11177	5617	44	0	\N
99595	1723	11171937085979	11177	5617	45	0	\N
99596	1723	1798927085979	11177	5617	46	0	\N
99597	1608	3165440000000	11177	5617	47	0	\N
99598	1726	728581950000	11177	5617	48	0	\N
99599	1546	11392511000000	11177	5617	49	0	\N
99600	1546	3404501000000	11177	5617	50	0	\N
99601	1546	2160491000000	11177	5617	51	0	\N
99602	1654	5327853000000	11177	5617	52	0	\N
99603	1726	728571949000	11177	5617	53	0	\N
99604	1726	728561948000	11177	5617	54	0	\N
99605	1726	728551947000	11177	5617	55	0	\N
99606	1726	728541946000	11177	5617	56	0	\N
99607	1726	728531945000	11177	5617	57	0	\N
99608	1726	728521944000	11177	5617	58	0	\N
99609	1397	1375583692000	11177	5617	59	0	\N
99610	1397	1375573691000	11177	5617	60	0	\N
99611	1397	1375563690000	11177	5617	61	0	\N
99612	1397	1375553689000	11177	5617	62	0	\N
99613	1397	1375543688000	11177	5617	63	0	\N
99614	1397	1375533687000	11177	5617	64	0	\N
99615	1397	1375523686000	11177	5617	65	0	\N
99616	1397	1375513685000	11177	5617	66	0	\N
99617	1397	1375503684000	11177	5617	67	0	\N
99618	1397	1375493683000	11177	5617	68	0	\N
99619	1397	1375483682000	11177	5617	69	0	\N
99620	1397	1375473681000	11177	5617	70	0	\N
99621	1397	1375463680000	11177	5617	71	0	\N
99622	1397	1375453679000	11177	5617	72	0	\N
99623	1397	1375443678000	11177	5617	73	0	\N
99624	1397	1375433677000	11177	5617	74	0	\N
99625	1397	1375423676000	11177	5617	75	0	\N
99626	1397	1375413675000	11177	5617	76	0	\N
99627	1397	1375403674000	11177	5617	77	0	\N
99628	1397	1375393673000	11177	5617	78	0	\N
99629	1397	1375383672000	11177	5617	79	0	\N
99630	1397	1375373671000	11177	5617	80	0	\N
99631	1397	1375363670000	11177	5617	81	0	\N
99632	1397	1375353669000	11177	5617	82	0	\N
99633	1397	1375343668000	11177	5617	83	0	\N
99634	1397	1375333667000	11177	5617	84	0	\N
99635	1397	1375323666000	11177	5617	85	0	\N
99636	1397	1375313665000	11177	5617	86	0	\N
99637	1397	1375303664000	11177	5617	87	0	\N
99638	1397	1375293663000	11177	5617	88	0	\N
99639	1397	1375283662000	11177	5617	89	0	\N
99640	1397	1375273661000	11177	5617	90	0	\N
99641	1397	1375263660000	11177	5617	91	0	\N
99642	1397	1375253659000	11177	5617	92	0	\N
99643	1397	1375243658000	11177	5617	93	0	\N
99644	1397	1375233657000	11177	5617	94	0	\N
99645	1397	1375223656000	11177	5617	95	0	\N
99646	1397	1375213655000	11177	5617	96	0	\N
99647	1397	1375203654000	11177	5617	97	0	\N
99648	1397	1375193653000	11177	5617	98	0	\N
99649	1397	1375183652000	11177	5617	99	0	\N
99650	1397	1375173651000	11177	5617	100	0	\N
99651	1397	1375163650000	11177	5617	101	0	\N
99652	1397	1375153649000	11177	5617	102	0	\N
99653	1397	1375143648000	11177	5617	103	0	\N
99654	1397	1375133647000	11177	5617	104	0	\N
99655	1397	1375123646000	11177	5617	105	0	\N
99656	1397	1375113645000	11177	5617	106	0	\N
99657	1397	1375103644000	11177	5617	107	0	\N
99658	1397	1375093643000	11177	5617	109	0	\N
99659	1397	1375083642000	11177	5617	110	0	\N
99660	1397	1375073641000	11177	5617	111	0	\N
99661	1397	1375063640000	11177	5617	112	0	\N
99662	1397	1375053639000	11177	5617	113	0	\N
99663	1397	1375043638000	11177	5617	114	0	\N
99664	1397	1375033637000	11177	5617	115	0	\N
99665	1397	1375023636000	11177	5617	116	0	\N
99666	1397	1375013635000	11177	5617	117	0	\N
99667	1397	1375003634000	11177	5617	118	0	\N
99668	1397	1374993633000	11177	5617	119	0	\N
99669	1397	1374983632000	11177	5617	120	0	\N
99670	1397	1374973631000	11177	5617	121	0	\N
99671	1397	1374963630000	11177	5617	122	0	\N
99672	1397	1374953629000	11177	5617	123	0	\N
99673	1397	1374943628000	11177	5617	124	0	\N
99674	1397	1374933627000	11177	5617	125	0	\N
99675	1726	724531787000	11178	5742	0	0	\N
99676	1726	724521786000	11178	5742	1	0	\N
99677	1397	1374033537000	11178	5742	2	0	\N
99678	1397	1374023536000	11178	5742	3	0	\N
99679	1726	724531787000	11179	5742	0	0	\N
99680	1726	724521786000	11179	5742	1	0	\N
99681	1397	1374033537000	11179	5742	2	0	\N
99682	1397	1374023536000	11179	5742	3	0	\N
99685	1397	1374033537000	11180	5742	2	0	6480
99686	1397	1374023536000	11180	5742	3	0	6481
99687	1397	1374013535000	11181	5743	0	0	6482
99688	1397	1374003534000	11181	5743	1	0	6483
99691	1397	1374013535000	11182	5743	0	0	\N
99692	1397	1374003534000	11182	5743	1	0	\N
99693	1726	724511785000	11182	5743	2	0	\N
99694	1726	724501784000	11182	5743	3	0	\N
99695	1397	1374013535000	11184	5743	0	0	\N
99696	1397	1374003534000	11184	5743	1	0	\N
99697	1726	724511785000	11184	5743	2	0	\N
99698	1726	724501784000	11184	5743	3	0	\N
99699	1726	724491783000	11185	5744	0	0	\N
99700	1397	1373993533000	11185	5744	1	0	\N
99701	1726	724491783000	11186	5744	0	0	\N
99702	1397	1373993533000	11186	5744	1	0	\N
99705	1726	724491783000	11188	5744	0	0	\N
99706	1397	1373993533000	11188	5744	1	0	\N
99710	1726	724481782000	11190	5745	0	0	\N
99711	1726	724471781000	11190	5745	1	0	\N
99712	1397	1373983532000	11190	5745	2	0	\N
99715	1726	724461780000	11192	5746	0	0	\N
99716	1397	1373973531000	11192	5746	1	0	\N
99719	1397	1373963530000	11194	5747	0	0	\N
99720	1726	724451779000	11194	5747	1	0	\N
99721	1397	1373963530000	11195	5747	0	0	\N
99722	1726	724451779000	11195	5747	1	0	\N
99733	1397	1373913525000	11200	5751	0	0	\N
99734	1726	724401774000	11200	5751	1	0	\N
99740	1726	724381772000	11203	5753	0	0	\N
99741	1726	723171772000	11203	5753	1	0	\N
99742	1397	1373893523000	11203	5753	2	0	\N
99749	1937	0	11205	5754	0	0	\N
99750	1397	1373883522000	11205	5754	1	0	\N
99751	1397	1373873521000	11205	5754	2	0	\N
99752	1726	723161771000	11205	5754	3	0	\N
99753	1726	723151770000	11205	5754	4	0	\N
99754	2045	199000000	11205	5754	5	0	\N
99755	1937	0	11206	5754	0	0	\N
99756	1397	1373883522000	11206	5754	1	0	\N
99757	1397	1373873521000	11206	5754	2	0	\N
99758	1726	723161771000	11206	5754	3	0	\N
99759	1726	723151770000	11206	5754	4	0	\N
99760	2045	199000000	11206	5754	5	0	\N
99761	1937	0	11207	5754	0	0	\N
99762	1397	1373883522000	11207	5754	1	0	\N
99763	1397	1373873521000	11207	5754	2	0	\N
99764	1726	723161771000	11207	5754	3	0	\N
99765	1726	723151770000	11207	5754	4	0	\N
99766	2045	199000000	11207	5754	5	0	\N
99776	1937	100000000	11211	5758	0	0	\N
99777	1397	1373823516000	11211	5758	1	0	\N
99778	1726	723101765000	11211	5758	2	0	\N
99795	1397	1373763510000	11215	5760	0	0	\N
99796	1397	1373753509000	11215	5760	1	0	\N
99797	1726	723041759000	11215	5760	2	0	\N
99808	1726	722991754000	11220	5764	0	0	\N
99809	1397	1373703504000	11220	5764	1	0	\N
99814	1726	722961751000	11223	5767	0	0	\N
99815	1726	722951750000	11223	5767	1	0	\N
99816	1397	1373673501000	11223	5767	2	0	\N
99817	1397	1373663500000	11223	5767	3	0	\N
99703	1726	724491783000	11187	5744	0	0	3446
99704	1397	1373993533000	11187	5744	1	0	6484
99707	1726	724481782000	11189	5745	0	0	3447
99708	1726	724471781000	11189	5745	1	0	3448
99709	1397	1373983532000	11189	5745	2	0	6485
99714	1397	1373973531000	11191	5746	1	0	6486
99717	1397	1373963530000	11193	5747	0	0	6487
99718	1726	724451779000	11193	5747	1	0	3450
99723	1397	1373953529000	11196	5748	0	0	6488
99724	1726	724441778000	11196	5748	1	0	3451
99726	1726	724431777000	11197	5749	1	0	3452
99727	1726	724421776000	11198	5750	0	0	3453
99728	1397	1373933527000	11198	5750	1	0	6490
99729	1397	1373923526000	11198	5750	2	0	6491
99731	1397	1373913525000	11199	5751	0	0	6492
99732	1726	724401774000	11199	5751	1	0	3455
99735	1726	724391773000	11201	5752	0	0	3456
99736	1397	1373903524000	11201	5752	1	0	6493
99737	1726	724381772000	11202	5753	0	0	3457
99739	1397	1373893523000	11202	5753	2	0	6494
99743	1937	0	11204	5754	0	0	1
99744	1397	1373883522000	11204	5754	1	0	6495
99745	1397	1373873521000	11204	5754	2	0	6496
99746	1726	723161771000	11204	5754	3	0	3459
99748	2045	199000000	11204	5754	5	0	1
99767	1397	1373863520000	11208	5755	0	0	6497
99768	1726	723141769000	11208	5755	1	0	3461
99769	1726	723131768000	11208	5755	2	0	3462
99771	1726	723121767000	11209	5756	0	0	3463
99772	1397	1373843518000	11209	5756	1	0	6499
99773	2046	0	11210	5757	0	0	1
99774	1726	723111766000	11210	5757	1	0	3464
99775	1397	1373833517000	11210	5757	2	0	6500
99780	1397	1373823516000	11212	5758	1	0	6501
99781	1726	723101765000	11212	5758	2	0	3465
99782	1726	723091764000	11213	5759	0	0	3466
99783	1726	723081763000	11213	5759	1	0	3467
99784	1726	723071762000	11213	5759	2	0	3468
99786	1726	723051760000	11213	5759	4	0	3470
99787	1397	1373813515000	11213	5759	5	0	6502
99788	1397	1373803514000	11213	5759	6	0	6503
99789	1397	1373793513000	11213	5759	7	0	6504
99791	1397	1373773511000	11213	5759	9	0	6506
99792	1397	1373763510000	11214	5760	0	0	6507
99793	1397	1373753509000	11214	5760	1	0	6508
99794	1726	723041759000	11214	5760	2	0	3471
99798	1726	723031758000	11216	5761	0	0	3472
99800	1726	723021757000	11217	5762	0	0	3473
99801	1397	1373733507000	11217	5762	1	0	6510
99802	1397	1373723506000	11217	5762	2	0	6511
99803	1726	723011756000	11217	5762	3	0	3474
99804	1726	723001755000	11218	5763	0	0	3475
99806	1726	722991754000	11219	5764	0	0	3476
99807	1397	1373703504000	11219	5764	1	0	6513
99810	1397	1373693503000	11221	5765	0	0	6514
99811	1726	722981753000	11221	5765	1	0	3477
99813	1726	722971752000	11222	5766	1	0	3478
99818	1726	722961751000	11224	5767	0	0	3479
99819	1726	722951750000	11224	5767	1	0	3480
99820	1397	1373673501000	11224	5767	2	0	6516
99821	1397	1373663500000	11224	5767	3	0	6517
99823	1397	1373653499000	11225	5768	1	0	6518
99824	1726	722931748000	11226	5769	0	0	3482
99831	1397	1373633497000	11228	5770	0	0	\N
99832	1726	722921747000	11228	5770	1	0	\N
99833	1726	722911746000	11228	5770	2	0	\N
99834	1397	1373623496000	11228	5770	3	0	\N
99835	1726	722910745000	11228	5770	4	0	\N
99841	1397	1373613495000	11230	5771	0	0	\N
99842	1397	1373603494000	11230	5771	1	0	\N
99843	1726	722909744000	11230	5771	2	0	\N
99844	1726	722908743000	11230	5771	3	0	\N
99845	1726	722907742000	11230	5771	4	0	\N
99846	1397	1373613495000	11231	5771	0	0	\N
99847	1397	1373603494000	11231	5771	1	0	\N
99848	1726	722909744000	11231	5771	2	0	\N
99849	1726	722908743000	11231	5771	3	0	\N
99850	1726	722907742000	11231	5771	4	0	\N
99851	1397	1373613495000	11232	5771	0	0	\N
99852	1397	1373603494000	11232	5771	1	0	\N
99853	1726	722909744000	11232	5771	2	0	\N
99854	1726	722908743000	11232	5771	3	0	\N
99855	1726	722907742000	11232	5771	4	0	\N
99856	1397	1373593493000	11233	5772	0	0	\N
99857	1397	1373583492000	11233	5772	1	0	\N
99858	1397	1373573491000	11233	5772	2	0	\N
99859	1726	722906741000	11233	5772	3	0	\N
99860	1726	722905740000	11233	5772	4	0	\N
99861	1726	722904739000	11233	5772	5	0	\N
99862	1397	1373593493000	11234	5772	0	0	\N
99863	1397	1373583492000	11234	5772	1	0	\N
99864	1397	1373573491000	11234	5772	2	0	\N
99865	1726	722906741000	11234	5772	3	0	\N
99866	1726	722905740000	11234	5772	4	0	\N
99867	1726	722904739000	11234	5772	5	0	\N
99874	1397	1373563490000	11236	5773	0	0	\N
99875	1726	722903738000	11236	5773	1	0	\N
99876	1397	1373563490000	11237	5773	0	0	\N
99877	1726	722903738000	11237	5773	1	0	\N
99878	1397	1373563490000	11238	5773	0	0	\N
99879	1726	722903738000	11238	5773	1	0	\N
99897	1397	1373473481000	11245	5778	0	0	\N
99898	1397	1373463480000	11245	5778	1	0	\N
99899	1726	722895730000	11245	5778	2	0	\N
99900	1726	722894729000	11245	5778	3	0	\N
99901	1397	1373473481000	11246	5778	0	0	\N
99902	1397	1373463480000	11246	5778	1	0	\N
99903	1726	722895730000	11246	5778	2	0	\N
99904	1726	722894729000	11246	5778	3	0	\N
99914	1693	12192547629428	11249	5779	0	0	\N
99915	1693	12190400555969	11249	5779	1	0	\N
99916	1397	1373453479000	11249	5779	2	0	\N
99917	1693	12119867131640	11249	5779	3	0	\N
99918	1726	722893728000	11249	5779	4	0	\N
99919	1693	12049333707311	11250	5780	0	0	\N
99920	1397	1373443478000	11250	5780	1	0	\N
99921	1693	11856364138609	11250	5780	2	0	\N
99922	1397	1373433477000	11250	5780	3	0	\N
99923	1693	11785830714280	11250	5780	4	0	\N
99924	1693	11281357755619	11250	5780	5	0	\N
99925	1693	11210824331290	11250	5780	6	0	\N
99926	1693	11205471647635	11250	5780	7	0	\N
99927	1693	11134938223306	11250	5780	8	0	\N
99928	1693	10172293464881	11250	5780	9	0	\N
99929	1693	10101760040552	11250	5780	10	0	\N
99930	1693	10081234135297	11250	5780	11	0	\N
99931	1693	10010700710968	11250	5780	12	0	\N
99932	1726	722892727000	11250	5780	13	0	\N
99933	1726	722891726000	11250	5780	14	0	\N
99827	1726	722921747000	11227	5770	1	0	3483
99828	1726	722911746000	11227	5770	2	0	3484
99829	1397	1373623496000	11227	5770	3	0	6521
99830	1726	722910745000	11227	5770	4	0	3485
99836	1397	1373613495000	11229	5771	0	0	6522
99838	1726	722909744000	11229	5771	2	0	3486
99839	1726	722908743000	11229	5771	3	0	3487
99840	1726	722907742000	11229	5771	4	0	3488
99868	1397	1373593493000	11235	5772	0	0	6524
99869	1397	1373583492000	11235	5772	1	0	6525
99871	1726	722906741000	11235	5772	3	0	3489
99872	1726	722905740000	11235	5772	4	0	3490
99873	1726	722904739000	11235	5772	5	0	3491
99880	1397	1373563490000	11239	5773	0	0	6527
99882	1397	1373553489000	11240	5774	0	0	6528
99883	1397	1373543488000	11240	5774	1	0	6529
99884	1726	722902737000	11240	5774	2	0	3493
99885	1397	1373533487000	11241	5775	0	0	6530
99886	1397	1373523486000	11241	5775	1	0	6531
99888	1726	722901736000	11241	5775	3	0	3494
99889	1726	722900735000	11241	5775	4	0	3495
99890	1726	722899734000	11241	5775	5	0	3496
99891	1397	1373503484000	11243	5776	0	0	6533
99892	1726	722898733000	11243	5776	1	0	3497
99894	1397	1373483482000	11244	5777	1	0	6535
99895	1726	722897732000	11244	5777	2	0	3498
99896	1726	722896731000	11244	5777	3	0	3499
99905	1397	1373473481000	11247	5778	0	0	6536
99907	1726	722895730000	11247	5778	2	0	3500
99908	1726	722894729000	11247	5778	3	0	3501
99909	1693	12192547629428	11248	5779	0	0	564
99910	1693	12190400555969	11248	5779	1	0	565
99911	1397	1373453479000	11248	5779	2	0	6538
99913	1726	722893728000	11248	5779	4	0	3502
99934	1693	12049333707311	11251	5780	0	0	567
99935	1397	1373443478000	11251	5780	1	0	6539
99936	1693	11856364138609	11251	5780	2	0	568
99937	1397	1373433477000	11251	5780	3	0	6540
99939	1693	11281357755619	11251	5780	5	0	570
99940	1693	11210824331290	11251	5780	6	0	571
99941	1693	11205471647635	11251	5780	7	0	572
99942	1693	11134938223306	11251	5780	8	0	573
99944	1693	10101760040552	11251	5780	10	0	575
99945	1693	10081234135297	11251	5780	11	0	576
99946	1693	10010700710968	11251	5780	12	0	577
99947	1726	722892727000	11251	5780	13	0	3503
99948	1726	722891726000	11251	5780	14	0	3504
99950	1693	9940167286639	11252	5781	1	0	578
99951	1693	9869633862310	11252	5781	2	0	579
99952	1693	9799100437981	11252	5781	3	0	580
99953	1693	9471238881251	11252	5781	4	0	581
99954	1693	9400705456922	11252	5781	5	0	582
99956	1397	1373413475000	11253	5782	0	0	6542
99957	1693	9330172032593	11253	5782	1	0	583
99958	1693	9002310475863	11253	5782	2	0	584
99959	1693	8931777051534	11253	5782	3	0	585
99996	1693	8226442808244	11260	5785	0	0	\N
99997	1693	8155909383915	11260	5785	1	0	\N
99998	1693	8085375959586	11260	5785	2	0	\N
99999	1693	8014842535257	11260	5785	3	0	\N
100000	1693	7944309110928	11260	5785	4	0	\N
100001	1693	7873775686599	11260	5785	5	0	\N
100002	1693	7803242262270	11260	5785	6	0	\N
100003	1693	7732708837941	11260	5785	7	0	\N
100004	1693	7662175413612	11260	5785	8	0	\N
100005	1693	7591641989283	11260	5785	9	0	\N
100006	1693	7589494915824	11260	5785	10	0	\N
100007	1693	7518961491495	11260	5785	11	0	\N
100008	1693	7448428067166	11260	5785	12	0	\N
100009	1693	7377894642837	11260	5785	13	0	\N
100010	1693	7307361218508	11260	5785	14	0	\N
100011	1693	7236827794179	11260	5785	15	0	\N
100012	1693	7166294369850	11260	5785	16	0	\N
100013	1693	7095760945521	11260	5785	17	0	\N
100014	1397	1373393473000	11260	5785	18	0	\N
100015	1397	1373383472000	11260	5785	19	0	\N
100016	1397	1373373471000	11260	5785	20	0	\N
100017	1726	722887722000	11260	5785	21	0	\N
100018	1726	722886721000	11260	5785	22	0	\N
100019	1726	722885720000	11260	5785	23	0	\N
100027	1693	7025227521192	11262	5786	0	0	\N
100028	1693	6954694096863	11262	5786	1	0	\N
100029	1693	6884160672534	11262	5786	2	0	\N
100030	1693	6813627248205	11262	5786	3	0	\N
100031	1693	6743093823876	11262	5786	4	0	\N
100032	1693	6672560399547	11262	5786	5	0	\N
100033	1726	722884719000	11262	5786	6	0	\N
100034	1397	1373363470000	11263	5787	0	0	\N
100035	1397	1373353469000	11263	5787	1	0	\N
100036	1693	6602026975218	11263	5787	2	0	\N
100037	1693	6531493550889	11263	5787	3	0	\N
100038	1693	6460960126560	11263	5787	4	0	\N
100039	1693	6390426702231	11263	5787	5	0	\N
100040	1693	6319893277902	11263	5787	6	0	\N
100041	1693	5670374424539	11263	5787	7	0	\N
100042	1726	722883718000	11263	5787	8	0	\N
100043	1726	722882717000	11263	5787	9	0	\N
99963	1726	722889724000	11253	5782	7	0	3506
99964	1397	1373403474000	11254	5783	0	0	6543
99965	1693	8649643354218	11254	5783	1	0	589
99966	1693	8579109929889	11254	5783	2	0	590
99967	1693	8508576505560	11254	5783	3	0	591
99969	1693	8367509656902	11254	5783	5	0	593
99970	1693	8296976232573	11254	5783	6	0	594
99971	1726	722888723000	11254	5783	7	0	3507
99972	1693	8226442808244	11259	5785	0	0	595
99973	1693	8155909383915	11259	5785	1	0	596
99975	1693	8014842535257	11259	5785	3	0	598
99976	1693	7944309110928	11259	5785	4	0	599
99977	1693	7873775686599	11259	5785	5	0	600
99978	1693	7803242262270	11259	5785	6	0	601
99980	1693	7662175413612	11259	5785	8	0	603
99981	1693	7591641989283	11259	5785	9	0	604
99982	1693	7589494915824	11259	5785	10	0	605
99983	1693	7518961491495	11259	5785	11	0	606
99984	1693	7448428067166	11259	5785	12	0	607
99986	1693	7307361218508	11259	5785	14	0	609
99987	1693	7236827794179	11259	5785	15	0	610
99988	1693	7166294369850	11259	5785	16	0	611
99989	1693	7095760945521	11259	5785	17	0	612
99990	1397	1373393473000	11259	5785	18	0	6544
99992	1397	1373373471000	11259	5785	20	0	6546
99993	1726	722887722000	11259	5785	21	0	3508
99994	1726	722886721000	11259	5785	22	0	3509
99995	1726	722885720000	11259	5785	23	0	3510
100021	1693	6954694096863	11261	5786	1	0	614
100022	1693	6884160672534	11261	5786	2	0	615
100023	1693	6813627248205	11261	5786	3	0	616
100024	1693	6743093823876	11261	5786	4	0	617
100025	1693	6672560399547	11261	5786	5	0	618
100044	1397	1373363470000	11265	5787	0	0	6547
100045	1397	1373353469000	11265	5787	1	0	6548
100046	1693	6602026975218	11265	5787	2	0	619
100047	1693	6531493550889	11265	5787	3	0	620
100048	1693	6460960126560	11265	5787	4	0	621
100050	1693	6319893277902	11265	5787	6	0	623
100051	1693	5670374424539	11265	5787	7	0	624
100052	1693	5599841000210	11265	5787	8	0	625
100053	1726	722883718000	11265	5787	9	0	3512
100055	1397	1373343468000	11266	5788	0	0	6549
100056	1693	5529307575881	11266	5788	1	0	626
100057	1693	5458774151552	11266	5788	2	0	627
100058	1693	5388240727223	11266	5788	3	0	628
100059	1693	5317707302894	11266	5788	4	0	629
100061	1397	1373323466000	11266	5788	6	0	6551
100062	1397	1373313465000	11266	5788	7	0	6552
100063	1693	5247173878565	11266	5788	8	0	630
100064	1693	5176640454236	11266	5788	9	0	631
100065	1693	5106107029907	11266	5788	10	0	632
100067	1693	5033426532119	11266	5788	12	0	634
100068	1693	4962893107790	11266	5788	13	0	635
100069	1693	4892359683461	11266	5788	14	0	636
100070	1693	4821826259132	11266	5788	15	0	637
100072	1693	4680759410474	11266	5788	17	0	639
100073	1693	4610225986145	11266	5788	18	0	640
100074	1693	4539692561816	11266	5788	19	0	641
100075	1693	4469159137487	11266	5788	20	0	642
100076	1693	4398625713158	11266	5788	21	0	643
100078	1693	4257558864500	11266	5788	23	0	645
100079	1693	4187025440171	11266	5788	24	0	646
100080	1693	3649828296744	11266	5788	25	0	647
100081	1693	3579294872415	11266	5788	26	0	648
100082	1693	3571805115295	11266	5788	27	0	649
100084	1693	3430738266637	11266	5788	29	0	651
100085	1693	3360204842308	11266	5788	30	0	652
100086	1693	3289671417979	11266	5788	31	0	653
100087	1726	722881716000	11266	5788	32	0	3514
100089	1726	722879714000	11266	5788	34	0	3516
100090	1726	722878713000	11266	5788	35	0	3517
100091	1397	1373303464000	11267	5789	0	0	6553
100092	1693	3219137993650	11267	5789	1	0	654
100093	1693	3148604569321	11267	5789	2	0	655
100095	1693	3007537720663	11267	5789	4	0	657
100096	1693	2937004296334	11267	5789	5	0	658
100098	1693	2866470872005	11269	5790	0	0	\N
100099	1693	1056546701015	11269	5790	1	0	\N
100100	1693	986013276686	11269	5790	2	0	\N
100101	1693	915479852357	11269	5790	3	0	\N
100102	1693	844946428028	11269	5790	4	0	\N
100103	1693	774413003699	11269	5790	5	0	\N
100104	1397	1373293463000	11269	5790	6	0	\N
100105	1726	722876711000	11269	5790	7	0	\N
100114	1693	2866470872005	11271	5790	0	0	\N
100115	1397	1373293463000	11271	5790	1	0	\N
100116	1726	722876711000	11271	5790	2	0	\N
100117	1397	1373283462000	11272	5791	0	0	\N
100118	1726	722875710000	11272	5791	1	0	\N
100121	1397	1373283462000	11274	5791	0	0	\N
100122	1726	722875710000	11274	5791	1	0	\N
100134	1397	1373253459000	11278	5794	0	0	\N
100135	1726	722871706000	11278	5794	1	0	\N
100136	1937	0	11279	5652	0	0	\N
100137	1691	14171602645814	11279	5652	1	0	\N
100138	1546	19228631000000	11279	5652	2	0	\N
100139	1693	10752477629428	11279	5652	3	0	\N
100140	1726	727561848000	11279	5652	4	0	\N
100141	1726	727551847000	11279	5652	5	0	\N
100142	1693	10750330555969	11279	5652	6	0	\N
100143	1397	1374603594000	11279	5652	7	0	\N
100144	1397	1374593593000	11279	5652	8	0	\N
100145	1397	1374583592000	11279	5652	9	0	\N
100146	1397	1374573591000	11279	5652	10	0	\N
100147	1691	12439161712302	11279	5652	11	0	\N
100148	1691	9334650322910	11279	5652	12	0	\N
100149	1613	11840477800000	11279	5652	13	0	\N
100150	1691	7239971373927	11279	5652	14	0	\N
100151	1691	1402980100019	11279	5652	15	0	\N
100152	1546	16361621000000	11279	5652	16	0	\N
100153	1613	7122275600000	11279	5652	17	0	\N
100154	1726	727541846000	11279	5652	18	0	\N
100155	1726	727531845000	11279	5652	19	0	\N
100156	1726	727521844000	11279	5652	20	0	\N
100157	1726	727511843000	11279	5652	21	0	\N
100158	1726	727501842000	11279	5652	22	0	\N
100159	1726	727491841000	11279	5652	23	0	\N
100160	1693	10679797131640	11279	5652	24	0	\N
100161	1693	10609263707311	11279	5652	25	0	\N
100162	1693	10416294138609	11279	5652	26	0	\N
100163	1613	4244978100000	11279	5652	27	0	\N
100164	1613	1367680600000	11279	5652	28	0	\N
100165	1546	12112611000000	11279	5652	29	0	\N
100166	1546	4124601000000	11279	5652	30	0	\N
100167	1546	2880591000000	11279	5652	31	0	\N
100168	1726	727481840000	11279	5652	32	0	\N
100169	1726	727471839000	11279	5652	33	0	\N
100170	1726	727461838000	11279	5652	34	0	\N
100171	1726	727451837000	11279	5652	35	0	\N
100172	1726	727441836000	11279	5652	36	0	\N
100173	1726	727431835000	11279	5652	37	0	\N
100174	1726	727421834000	11279	5652	38	0	\N
100175	1726	727411833000	11279	5652	39	0	\N
100176	1726	727401832000	11279	5652	40	0	\N
100177	1726	727391831000	11279	5652	41	0	\N
100178	1726	727381830000	11279	5652	42	0	\N
100179	1726	727371829000	11279	5652	43	0	\N
100180	1726	727361828000	11279	5652	44	0	\N
100181	1726	727351827000	11279	5652	45	0	\N
100182	1726	726141827000	11279	5652	46	0	\N
100183	1726	726131826000	11279	5652	48	0	\N
100184	1726	724921826000	11279	5652	49	0	\N
100185	1726	724911825000	11279	5652	50	0	\N
100186	1397	1374563590000	11279	5652	51	0	\N
100187	1397	1374553589000	11279	5652	52	0	\N
100188	1397	1374543588000	11279	5652	53	0	\N
100189	1726	724901824000	11279	5652	54	0	\N
100190	1726	724891823000	11279	5652	55	0	\N
100191	1726	724881822000	11279	5652	56	0	\N
100192	1726	724871821000	11279	5652	57	0	\N
100193	1726	724861820000	11279	5652	58	0	\N
100194	1726	724851819000	11279	5652	59	0	\N
100195	1726	724841818000	11279	5652	60	0	\N
100196	1726	724831817000	11279	5652	61	0	\N
100197	1726	724821816000	11279	5652	62	0	\N
100198	1726	724811815000	11279	5652	63	0	\N
100199	1726	724801814000	11279	5652	64	0	\N
100200	1726	724791813000	11279	5652	65	0	\N
100201	1726	724781812000	11279	5652	66	0	\N
100202	1726	724771811000	11279	5652	67	0	\N
100203	1726	724761810000	11279	5652	68	0	\N
100204	1726	724751809000	11279	5652	69	0	\N
100205	1726	724741808000	11279	5652	70	0	\N
100206	1726	724731807000	11279	5652	71	0	\N
100207	1726	724721806000	11279	5652	72	0	\N
100208	1726	724711805000	11279	5652	73	0	\N
100209	1726	724701804000	11279	5652	74	0	\N
100210	1726	724691803000	11279	5652	75	0	\N
100211	1726	724681802000	11279	5652	76	0	\N
100212	1726	724671801000	11279	5652	77	0	\N
100213	1726	724661800000	11279	5652	78	0	\N
100214	1726	724651799000	11279	5652	79	0	\N
100215	1726	724641798000	11279	5652	80	0	\N
100216	1726	724631797000	11279	5652	81	0	\N
100217	1726	724621796000	11279	5652	82	0	\N
100218	1726	724611795000	11279	5652	83	0	\N
100219	1693	1423880579370	11280	5795	0	0	\N
100220	1693	1353347155041	11280	5795	2	0	\N
100221	1397	1373243458000	11280	5795	3	0	\N
100222	1726	722870705000	11280	5795	4	0	\N
100223	1693	1423880579370	11281	5795	0	0	\N
100224	1693	1353347155041	11281	5795	2	0	\N
100225	1397	1373243458000	11281	5795	3	0	\N
100226	1726	722870705000	11281	5795	4	0	\N
100107	1693	1056546701015	11270	5790	1	0	660
100108	1693	986013276686	11270	5790	2	0	661
100109	1693	915479852357	11270	5790	3	0	662
100110	1693	844946428028	11270	5790	4	0	663
100111	1693	774413003699	11270	5790	5	0	664
100113	1726	722876711000	11270	5790	7	0	3519
100119	1397	1373283462000	11273	5791	0	0	6555
100120	1726	722875710000	11273	5791	1	0	3520
100123	1726	722874709000	11275	5792	0	0	3521
100124	1397	1373273461000	11276	5793	0	0	6556
100126	1397	1373263460000	11276	5793	2	0	6557
100127	1613	7122275600000	11276	5793	3	0	4
100128	1613	4244978100000	11276	5793	4	0	5
100129	1613	1367680600000	11276	5793	5	0	6
100131	1726	722872707000	11276	5793	7	0	3523
100132	1397	1373253459000	11277	5794	0	0	6558
100133	1726	722871706000	11277	5794	1	0	3524
100227	1693	1423880579370	11282	5795	0	0	665
100228	1693	1353347155041	11282	5795	2	0	666
100230	1726	722870705000	11282	5795	4	0	3525
100231	1397	1373233457000	11283	5796	0	0	6560
100232	1726	722869704000	11283	5796	1	0	3526
100233	1397	1373233457000	11284	5796	0	0	\N
100234	1726	722869704000	11284	5796	1	0	\N
100235	1397	1373233457000	11285	5796	0	0	\N
100236	1726	722869704000	11285	5796	1	0	\N
100239	1397	1373213455000	11287	5798	0	0	\N
100240	1726	722867702000	11287	5798	1	0	\N
100245	1397	1373203454000	11290	5799	0	0	\N
100246	1726	722866701000	11290	5799	1	0	\N
100249	1397	1373193453000	11292	5800	0	0	\N
100250	1726	722865700000	11292	5800	1	0	\N
100259	1397	1373143448000	11295	5803	0	0	\N
100260	1726	722860695000	11295	5803	1	0	\N
100261	1397	1373143448000	11296	5803	0	0	\N
100262	1726	722860695000	11296	5803	1	0	\N
100263	1397	1373143448000	11297	5803	0	0	\N
100264	1726	722860695000	11297	5803	1	0	\N
100267	1397	1373133447000	11300	5804	0	0	\N
100268	1397	1373133447000	11301	5804	0	0	\N
100270	1397	1373123446000	11303	5805	0	0	\N
100271	1726	722859694000	11303	5805	1	0	\N
100276	1726	722857692000	11306	5807	0	0	\N
100283	1397	1373093443000	11310	5809	0	0	\N
100284	1397	1373083442000	11310	5809	1	0	\N
100285	1726	722855690000	11310	5809	2	0	\N
100286	1397	1373073441000	11311	5810	0	0	\N
100287	1726	722854689000	11311	5810	1	0	\N
100288	1397	1373073441000	11312	5810	0	0	\N
100289	1726	722854689000	11312	5810	1	0	\N
100294	1397	1373063440000	11315	5811	0	0	\N
100295	1726	722853688000	11315	5811	1	0	\N
100296	1726	722853688000	11316	5811	0	0	\N
100297	1397	1373053439000	11318	5812	0	0	\N
100298	1726	722852687000	11318	5812	1	0	\N
100303	1397	1373043438000	11321	5813	0	0	\N
100304	1726	722851686000	11321	5813	1	0	\N
100306	1397	1373033437000	11323	5814	0	0	\N
100307	1397	1373023436000	11324	5815	0	0	\N
100308	1726	722850685000	11324	5815	1	0	\N
100311	1397	1373013435000	11326	5816	0	0	\N
100312	1726	722849684000	11326	5816	1	0	\N
100319	1397	1372983432000	11330	5819	0	0	\N
100320	1726	722846681000	11330	5819	1	0	\N
100332	1397	1372933427000	11334	5822	0	0	\N
100333	1726	722841676000	11334	5822	1	0	\N
100334	1397	1372933427000	11335	5822	0	0	\N
100335	1726	722841676000	11335	5822	1	0	\N
100338	1397	1372923426000	11337	5823	0	0	\N
100339	1397	1372913425000	11337	5823	1	0	\N
100340	1726	722840675000	11337	5823	2	0	\N
100341	1726	722839674000	11337	5823	3	0	\N
100342	1397	1372923426000	11338	5823	0	0	\N
100343	1397	1372913425000	11338	5823	1	0	\N
100344	1726	722840675000	11338	5823	2	0	\N
100345	1726	722839674000	11338	5823	3	0	\N
100356	1397	1372873421000	11343	5826	0	0	\N
100357	1397	1372863420000	11343	5826	1	0	\N
100358	1397	1372853419000	11343	5826	2	0	\N
100359	1726	722835670000	11343	5826	3	0	\N
100360	1726	722834669000	11343	5826	4	0	\N
100361	1726	722833668000	11343	5826	5	0	\N
100368	1397	1372873421000	11345	5826	0	0	\N
100241	1397	1373213455000	11288	5798	0	0	6562
100242	1726	722867702000	11288	5798	1	0	3528
100243	1397	1373203454000	11289	5799	0	0	6563
100244	1726	722866701000	11289	5799	1	0	3529
100247	1397	1373193453000	11291	5800	0	0	6564
100251	1397	1373183452000	11293	5801	0	0	6565
100252	1397	1373173451000	11293	5801	1	0	6566
100253	1726	722864699000	11293	5801	2	0	3531
100254	1726	722863698000	11293	5801	3	0	3532
100255	1397	1373163450000	11294	5802	0	0	6567
100257	1726	722862697000	11294	5802	2	0	3533
100258	1726	722861696000	11294	5802	3	0	3534
100265	1397	1373143448000	11298	5803	0	0	6569
100266	1726	722860695000	11298	5803	1	0	3535
100272	1397	1373123446000	11304	5805	0	0	6571
100273	1726	722859694000	11304	5805	1	0	3536
100274	1397	1373113445000	11305	5806	0	0	6572
100275	1726	722858693000	11305	5806	1	0	3537
100277	1397	1373103444000	11307	5807	0	0	6573
100279	1726	722856691000	11308	5808	0	0	3539
100280	1397	1373093443000	11309	5809	0	0	6574
100281	1397	1373083442000	11309	5809	1	0	6575
100282	1726	722855690000	11309	5809	2	0	3540
100290	1397	1373073441000	11313	5810	0	0	6576
100292	1397	1373063440000	11314	5811	0	0	6577
100293	1726	722853688000	11314	5811	1	0	3542
100299	1397	1373053439000	11319	5812	0	0	6578
100300	1726	722852687000	11319	5812	1	0	3543
100302	1726	722851686000	11320	5813	1	0	3544
100305	1397	1373033437000	11322	5814	0	0	6580
100309	1397	1373023436000	11325	5815	0	0	6581
100310	1726	722850685000	11325	5815	1	0	3545
100313	1726	722849684000	11327	5816	0	0	3546
100315	1397	1373003434000	11328	5817	1	0	6583
100316	1726	722848683000	11328	5817	2	0	3547
100317	1397	1372993433000	11329	5818	0	0	6584
100318	1726	722847682000	11329	5818	1	0	3548
100321	1397	1372983432000	11331	5819	0	0	6585
100323	1397	1372973431000	11332	5820	0	0	6586
100324	1397	1372963430000	11332	5820	1	0	6587
100325	1775	1943000000	11332	5820	2	0	6
100326	1726	722845680000	11332	5820	3	0	3550
100328	1397	1372953429000	11333	5821	0	0	6588
100329	1397	1372943428000	11333	5821	1	0	6589
100330	1726	722843678000	11333	5821	2	0	3552
100331	1726	722842677000	11333	5821	3	0	3553
100336	1397	1372933427000	11336	5822	0	0	6590
100346	1397	1372923426000	11339	5823	0	0	6591
100347	1397	1372913425000	11339	5823	1	0	6592
100348	1726	722840675000	11339	5823	2	0	3555
100349	1726	722839674000	11339	5823	3	0	3556
100350	1397	1372903424000	11340	5824	0	0	6593
100352	1397	1372893423000	11342	5825	0	0	6594
100353	1397	1372883422000	11342	5825	1	0	6595
100354	1726	722837672000	11342	5825	2	0	3558
100355	1726	722836671000	11342	5825	3	0	3559
100363	1397	1372863420000	11344	5826	1	0	6597
100364	1397	1372853419000	11344	5826	2	0	6598
100365	1726	722835670000	11344	5826	3	0	3560
100366	1726	722834669000	11344	5826	4	0	3561
100367	1726	722833668000	11344	5826	5	0	3562
100369	1397	1372863420000	11345	5826	1	0	\N
100370	1397	1372853419000	11345	5826	2	0	\N
100371	1726	722835670000	11345	5826	3	0	\N
100372	1726	722834669000	11345	5826	4	0	\N
100373	1726	722833668000	11345	5826	5	0	\N
100376	1397	1372833417000	11347	5828	0	0	\N
100377	1397	1372823416000	11347	5828	1	0	\N
100378	1726	722831666000	11347	5828	2	0	\N
100379	1726	722830665000	11347	5828	3	0	\N
100384	1397	1372813415000	11349	5829	0	0	\N
100385	1726	722829664000	11349	5829	1	0	\N
100386	1397	1372813415000	11350	5829	0	0	\N
100387	1726	722829664000	11350	5829	1	0	\N
100391	1726	722828663000	11353	5830	0	0	\N
100394	1397	1372793413000	11355	5832	0	0	\N
100395	1726	722826661000	11355	5832	1	0	\N
100398	1397	1372783412000	11357	5833	0	0	\N
100400	1397	1372783412000	11359	5833	0	0	\N
100401	1397	1372773411000	11360	5834	0	0	\N
100402	1397	1372763410000	11360	5834	1	0	\N
100403	1397	1372753409000	11360	5834	2	0	\N
100404	1397	1372743408000	11360	5834	3	0	\N
100405	1397	1372733407000	11360	5834	4	0	\N
100406	1726	722825660000	11360	5834	5	0	\N
100407	1726	722824659000	11360	5834	6	0	\N
100408	1726	722823658000	11360	5834	7	0	\N
100409	1726	722822657000	11360	5834	8	0	\N
100410	1726	722821656000	11360	5834	9	0	\N
100425	1397	1372703404000	11364	5837	0	0	\N
100426	1397	1372693403000	11364	5837	1	0	\N
100427	1726	722818653000	11364	5837	2	0	\N
100428	1726	722817652000	11364	5837	3	0	\N
100435	1397	1372683402000	11367	5838	0	0	\N
100436	1726	722816651000	11367	5838	1	0	\N
100437	1397	1372673401000	11368	5839	0	0	\N
100438	1397	1372663400000	11368	5839	1	0	\N
100439	1397	1372653399000	11368	5839	2	0	\N
100440	1726	722815650000	11368	5839	3	0	\N
100441	1726	722814649000	11368	5839	4	0	\N
100442	1726	722813648000	11368	5839	5	0	\N
100451	1397	1372643398000	11371	5840	0	0	\N
100452	1726	722812647000	11371	5840	1	0	\N
100461	1397	1372593393000	11375	5844	0	0	\N
100462	1726	722807642000	11375	5844	1	0	\N
100465	1397	1372583392000	11377	5845	0	0	\N
100466	1397	1372573391000	11377	5845	1	0	\N
100467	1726	722806641000	11377	5845	2	0	\N
100468	1726	722805640000	11377	5845	3	0	\N
100473	1397	1372583392000	11379	5845	0	0	\N
100474	1397	1372573391000	11379	5845	1	0	\N
100475	1726	722806641000	11379	5845	2	0	\N
100476	1726	722805640000	11379	5845	3	0	\N
100479	1397	1372553389000	11381	5847	0	0	\N
100480	1726	722803638000	11381	5847	1	0	\N
100481	1397	1372553389000	11382	5847	0	0	\N
100482	1726	722803638000	11382	5847	1	0	\N
100485	1397	1372543388000	11384	5848	0	0	\N
100486	1726	722802637000	11384	5848	1	0	\N
100487	1397	1372543388000	11385	5848	0	0	\N
100488	1726	722802637000	11385	5848	1	0	\N
100491	1726	722801636000	11387	5849	0	0	\N
100497	1397	1372533387000	11390	5850	0	0	\N
100498	1397	1372523386000	11390	5850	2	0	\N
100499	1726	722800635000	11390	5850	3	0	\N
100500	1726	722799634000	11390	5850	4	0	\N
100501	1397	1372533387000	11391	5850	0	0	\N
100502	1397	1372523386000	11391	5850	2	0	\N
100503	1726	722800635000	11391	5850	3	0	\N
100504	1726	722799634000	11391	5850	4	0	\N
100380	1397	1372833417000	11348	5828	0	0	6600
100381	1397	1372823416000	11348	5828	1	0	6601
100382	1726	722831666000	11348	5828	2	0	3564
100383	1726	722830665000	11348	5828	3	0	3565
100388	1397	1372813415000	11351	5829	0	0	6602
100390	1726	722828663000	11352	5830	0	0	3567
100392	1397	1372803414000	11354	5831	0	0	6603
100393	1726	722827662000	11354	5831	1	0	3568
100396	1397	1372793413000	11356	5832	0	0	6604
100397	1726	722826661000	11356	5832	1	0	3569
100411	1397	1372773411000	11361	5834	0	0	6606
100412	1397	1372763410000	11361	5834	1	0	6607
100413	1397	1372753409000	11361	5834	2	0	6608
100414	1397	1372743408000	11361	5834	3	0	6609
100416	1726	722825660000	11361	5834	5	0	3570
100417	1726	722824659000	11361	5834	6	0	3571
100418	1726	722823658000	11361	5834	7	0	3572
100419	1726	722822657000	11361	5834	8	0	3573
100420	1726	722821656000	11361	5834	9	0	3574
100422	1726	722820655000	11362	5835	1	0	3575
100423	1397	1372713405000	11363	5836	0	0	6612
100424	1726	722819654000	11363	5836	1	0	3576
100429	1397	1372703404000	11365	5837	0	0	6613
100430	1397	1372693403000	11365	5837	1	0	6614
100432	1726	722817652000	11365	5837	3	0	3578
100433	1397	1372683402000	11366	5838	0	0	6615
100434	1726	722816651000	11366	5838	1	0	3579
100443	1397	1372673401000	11369	5839	0	0	6616
100445	1397	1372653399000	11369	5839	2	0	6618
100446	1726	722815650000	11369	5839	3	0	3580
100447	1726	722814649000	11369	5839	4	0	3581
100448	1726	722813648000	11369	5839	5	0	3582
100449	1397	1372643398000	11370	5840	0	0	6619
100453	1397	1372633397000	11372	5841	0	0	6620
100454	1726	722811646000	11372	5841	1	0	3584
100455	1397	1372623396000	11373	5842	0	0	6621
100456	1397	1372613395000	11373	5842	1	0	6622
100457	1726	722810645000	11373	5842	2	0	3585
100459	1397	1372603394000	11374	5843	0	0	6623
100460	1726	722808643000	11374	5843	1	0	3587
100463	1397	1372593393000	11376	5844	0	0	6624
100464	1726	722807642000	11376	5844	1	0	3588
100470	1397	1372573391000	11378	5845	1	0	6626
100471	1726	722806641000	11378	5845	2	0	3589
100472	1726	722805640000	11378	5845	3	0	3590
100477	1397	1372563390000	11380	5846	0	0	6627
100478	1726	722804639000	11380	5846	1	0	3591
100484	1726	722803638000	11383	5847	1	0	3592
100489	1397	1372543388000	11386	5848	0	0	6629
100490	1726	722802637000	11386	5848	1	0	3593
100492	1726	722801636000	11388	5849	0	0	3594
100493	1397	1372533387000	11389	5850	0	0	6630
100495	1726	722800635000	11389	5850	3	0	3595
100496	1726	722799634000	11389	5850	4	0	3596
100507	1397	1372513385000	11393	5851	0	0	\N
100508	1726	722798633000	11393	5851	1	0	\N
100509	1397	1372513385000	11394	5851	0	0	\N
100510	1726	722798633000	11394	5851	1	0	\N
100513	1397	1372503384000	11396	5852	0	0	\N
100514	1726	722797632000	11396	5852	1	0	\N
100515	1397	1372503384000	11397	5852	0	0	\N
100516	1726	722797632000	11397	5852	1	0	\N
100524	1397	1372473381000	11401	5855	0	0	\N
100525	1397	1372463380000	11401	5855	1	0	\N
100526	1726	722795630000	11401	5855	2	0	\N
100527	1726	722794629000	11401	5855	3	0	\N
100532	1397	1372443378000	11404	5857	0	0	\N
100533	1726	722792627000	11404	5857	1	0	\N
100538	1397	1372433377000	11406	5858	0	0	\N
100539	1397	1372423376000	11406	5858	1	0	\N
100540	1726	722791626000	11406	5858	2	0	\N
100541	1726	722790625000	11406	5858	3	0	\N
100550	1397	1372373371000	11409	5861	0	0	\N
100551	1726	722785620000	11409	5861	1	0	\N
100552	1726	721575620000	11409	5861	2	0	\N
100556	1397	1372373371000	11411	5861	0	0	\N
100557	1726	722785620000	11411	5861	1	0	\N
100558	1726	721575620000	11411	5861	2	0	\N
100561	1726	721573618000	11413	5863	0	0	\N
100562	1726	721573618000	11414	5863	0	0	\N
100566	1397	1372343368000	11417	5865	0	0	\N
100567	1726	721571616000	11417	5865	1	0	\N
100568	1397	1372343368000	11418	5865	0	0	\N
100569	1726	721571616000	11418	5865	1	0	\N
100578	1397	1372323366000	11422	5867	0	0	\N
100579	1397	1372313365000	11422	5867	1	0	\N
100580	1726	721569614000	11422	5867	2	0	\N
100581	1726	721568613000	11422	5867	3	0	\N
100586	1397	1372293363000	11425	5869	0	0	\N
100587	1726	721566611000	11425	5869	1	0	\N
100588	1693	703879579370	11426	5792	0	0	\N
100589	1693	633346155041	11426	5792	1	0	\N
100590	1397	1373273461000	11426	5792	2	0	\N
100591	1613	11840477800000	11426	5792	3	0	\N
100592	1397	1373263460000	11426	5792	4	0	\N
100593	1397	1373253459000	11426	5792	5	0	\N
100594	1613	7122275600000	11426	5792	6	0	\N
100595	1397	1373243458000	11426	5792	7	0	\N
100596	1397	1373233457000	11426	5792	8	0	\N
100597	1397	1373223456000	11426	5792	9	0	\N
100598	1397	1373213455000	11426	5792	10	0	\N
100599	1397	1373203454000	11426	5792	11	0	\N
100600	1397	1373193453000	11426	5792	12	0	\N
100601	1397	1373183452000	11426	5792	13	0	\N
100602	1397	1373173451000	11426	5792	14	0	\N
100603	1397	1373163450000	11426	5792	15	0	\N
100604	1397	1373153449000	11426	5792	16	0	\N
100605	1613	4244978100000	11426	5792	17	0	\N
100606	1613	1367680600000	11426	5792	19	0	\N
100607	1397	1373143448000	11426	5792	20	0	\N
100608	1397	1373133447000	11426	5792	21	0	\N
100609	1397	1373123446000	11426	5792	22	0	\N
100610	1397	1373113445000	11426	5792	23	0	\N
100611	1397	1373103444000	11426	5792	24	0	\N
100612	1397	1373093443000	11426	5792	25	0	\N
100613	1397	1373083442000	11426	5792	26	0	\N
100614	1397	1373073441000	11426	5792	27	0	\N
100615	1397	1373063440000	11426	5792	28	0	\N
100616	1397	1373053439000	11426	5792	29	0	\N
100617	1397	1373043438000	11426	5792	30	0	\N
100618	1397	1373033437000	11426	5792	31	0	\N
100619	1397	1373023436000	11426	5792	32	0	\N
100620	1397	1373013435000	11426	5792	33	0	\N
100621	1397	1373003434000	11426	5792	34	0	\N
100622	1397	1372993433000	11426	5792	35	0	\N
100623	1397	1372983432000	11426	5792	36	0	\N
100624	1397	1372973431000	11426	5792	37	0	\N
100625	1397	1372963430000	11426	5792	38	0	\N
100626	1397	1372953429000	11426	5792	39	0	\N
100627	1397	1372943428000	11426	5792	40	0	\N
100628	1397	1372933427000	11426	5792	41	0	\N
100629	1397	1372923426000	11426	5792	42	0	\N
100630	1397	1372913425000	11426	5792	43	0	\N
100631	1397	1372903424000	11426	5792	44	0	\N
100632	1397	1372893423000	11426	5792	45	0	\N
100633	1397	1372883422000	11426	5792	46	0	\N
100634	1397	1372873421000	11426	5792	47	0	\N
100635	1397	1372863420000	11426	5792	48	0	\N
100636	1397	1372853419000	11426	5792	49	0	\N
100637	1397	1372843418000	11426	5792	50	0	\N
100638	1397	1372833417000	11426	5792	51	0	\N
100639	1397	1372823416000	11426	5792	52	0	\N
100640	1397	1372813415000	11426	5792	53	0	\N
100511	1397	1372503384000	11395	5852	0	0	6633
100512	1726	722797632000	11395	5852	1	0	3598
100517	1397	1372493383000	11398	5853	0	0	6634
100518	1397	1372483382000	11399	5854	0	0	6635
100519	1726	722796631000	11399	5854	1	0	3599
100521	1397	1372463380000	11400	5855	1	0	6637
100522	1726	722795630000	11400	5855	2	0	3600
100523	1726	722794629000	11400	5855	3	0	3601
100528	1397	1372453379000	11402	5856	0	0	6638
100529	1726	722793628000	11402	5856	1	0	3602
100531	1726	722792627000	11403	5857	1	0	3603
100534	1397	1372433377000	11405	5858	0	0	6640
100535	1397	1372423376000	11405	5858	1	0	6641
100536	1726	722791626000	11405	5858	2	0	3604
100542	1397	1372413375000	11407	5859	0	0	6642
100543	1397	1372403374000	11407	5859	1	0	6643
100544	1726	722789624000	11407	5859	2	0	3606
100545	1726	722788623000	11407	5859	3	0	3607
100546	1397	1372393373000	11408	5860	0	0	6644
100548	1726	722787622000	11408	5860	2	0	3608
100549	1726	722786621000	11408	5860	3	0	3609
100553	1397	1372373371000	11410	5861	0	0	6646
100554	1726	722785620000	11410	5861	1	0	3610
100555	1726	721575620000	11410	5861	2	0	3611
100560	1726	721574619000	11412	5862	1	0	3612
100563	1726	721573618000	11415	5863	0	0	3613
100564	1397	1372353369000	11416	5864	0	0	6648
100565	1726	721572617000	11416	5864	1	0	3614
100571	1726	721571616000	11419	5865	1	0	3615
100572	1397	1372333367000	11420	5866	0	0	6650
100573	1726	721570615000	11420	5866	1	0	3616
100574	1397	1372323366000	11421	5867	0	0	6651
100575	1397	1372313365000	11421	5867	1	0	6652
100577	1726	721568613000	11421	5867	3	0	3618
100582	1397	1372303364000	11423	5868	0	0	6653
100583	1726	721567612000	11423	5868	1	0	3619
100584	1397	1372293363000	11424	5869	0	0	6654
100585	1726	721566611000	11424	5869	1	0	3620
100641	1397	1372803414000	11426	5792	54	0	\N
100642	1397	1372793413000	11426	5792	55	0	\N
100643	1397	1372783412000	11426	5792	56	0	\N
100644	1397	1372773411000	11426	5792	57	0	\N
100645	1397	1372763410000	11426	5792	58	0	\N
100646	1397	1372753409000	11426	5792	59	0	\N
100647	1397	1372743408000	11426	5792	60	0	\N
100648	1397	1372733407000	11426	5792	61	0	\N
100649	1397	1372723406000	11426	5792	62	0	\N
100650	1397	1372713405000	11426	5792	63	0	\N
100651	1397	1372703404000	11426	5792	64	0	\N
100652	1397	1372693403000	11426	5792	65	0	\N
100653	1397	1372683402000	11426	5792	66	0	\N
100654	1397	1372673401000	11426	5792	67	0	\N
100655	1397	1372663400000	11426	5792	68	0	\N
100656	1397	1372653399000	11426	5792	69	0	\N
100657	1397	1372643398000	11426	5792	70	0	\N
100658	1397	1372633397000	11426	5792	71	0	\N
100659	1397	1372623396000	11426	5792	72	0	\N
100660	1397	1372613395000	11426	5792	73	0	\N
100661	1397	1372603394000	11426	5792	74	0	\N
100662	1397	1372593393000	11426	5792	75	0	\N
100663	1397	1372583392000	11426	5792	76	0	\N
100664	1397	1372573391000	11426	5792	77	0	\N
100665	1397	1372563390000	11426	5792	78	0	\N
100666	1397	1372553389000	11426	5792	79	0	\N
100667	1397	1372543388000	11426	5792	80	0	\N
100668	1397	1372533387000	11426	5792	81	0	\N
100669	1397	1372523386000	11426	5792	82	0	\N
100670	1397	1372513385000	11426	5792	83	0	\N
100671	1397	1372503384000	11426	5792	84	0	\N
100672	1397	1372493383000	11426	5792	85	0	\N
100673	1397	1372483382000	11426	5792	86	0	\N
100674	1397	1372473381000	11426	5792	87	0	\N
100675	1397	1372463380000	11426	5792	88	0	\N
100676	1397	1372453379000	11426	5792	89	0	\N
100677	1397	1372443378000	11426	5792	90	0	\N
100678	1397	1372433377000	11426	5792	91	0	\N
100679	1397	1372423376000	11426	5792	92	0	\N
100680	1397	1372413375000	11426	5792	93	0	\N
100681	1397	1372403374000	11426	5792	94	0	\N
100682	1397	1372393373000	11426	5792	95	0	\N
100683	1397	1372383372000	11426	5792	96	0	\N
100684	1397	1372373371000	11426	5792	97	0	\N
100685	1397	1372363370000	11426	5792	98	0	\N
100686	1397	1372353369000	11426	5792	99	0	\N
100687	1397	1372343368000	11426	5792	100	0	\N
100688	1397	1372333367000	11426	5792	101	0	\N
100689	1397	1372323366000	11426	5792	102	0	\N
100690	1397	1372313365000	11426	5792	103	0	\N
100691	1397	1372303364000	11426	5792	104	0	\N
100692	1397	1372293363000	11426	5792	105	0	\N
100693	1726	722874709000	11426	5792	106	0	\N
100694	1775	1943000000	11426	5792	107	0	\N
100695	1726	722873708000	11426	5792	108	0	\N
100696	1726	722872707000	11426	5792	109	0	\N
100697	1726	722871706000	11426	5792	110	0	\N
100698	1726	722870705000	11426	5792	111	0	\N
100699	1726	722869704000	11426	5792	112	0	\N
100700	1726	722868703000	11426	5792	113	0	\N
100701	1726	722867702000	11426	5792	114	0	\N
100702	1726	722866701000	11426	5792	115	0	\N
100703	1726	722865700000	11426	5792	116	0	\N
100704	1726	722864699000	11426	5792	117	0	\N
100705	1726	722863698000	11426	5792	118	0	\N
100706	1726	722862697000	11426	5792	119	0	\N
100707	1726	722861696000	11426	5792	120	0	\N
100708	1726	722860695000	11426	5792	121	0	\N
100709	1726	722859694000	11426	5792	122	0	\N
100710	1726	722858693000	11426	5792	123	0	\N
100711	1726	722857692000	11426	5792	124	0	\N
100712	1726	722856691000	11426	5792	125	0	\N
100713	1397	1372283362000	11428	5870	0	0	\N
100714	1397	1372273361000	11428	5870	1	0	\N
100715	1397	1372263360000	11428	5870	2	0	\N
100716	1726	721565610000	11428	5870	3	0	\N
100717	1726	721564609000	11428	5870	4	0	\N
100729	1397	1372223356000	11432	5873	0	0	\N
100730	1726	721560605000	11432	5873	1	0	\N
100731	1397	1372223356000	11433	5873	0	0	\N
100732	1726	721560605000	11433	5873	1	0	\N
100733	1397	1372223356000	11434	5873	0	0	\N
100734	1726	721560605000	11434	5873	1	0	\N
100742	1397	1372203354000	11439	5876	0	0	\N
100743	1726	721557602000	11439	5876	1	0	\N
100748	1397	1372803414000	11441	5831	0	0	\N
100749	1397	1372793413000	11441	5831	1	0	\N
100750	1397	1372783412000	11441	5831	2	0	\N
100751	1397	1372773411000	11441	5831	3	0	\N
100752	1397	1372763410000	11441	5831	4	0	\N
100753	1397	1372753409000	11441	5831	5	0	\N
100754	1397	1372743408000	11441	5831	6	0	\N
100755	1397	1372733407000	11441	5831	7	0	\N
100756	1397	1372723406000	11441	5831	8	0	\N
100757	1397	1372713405000	11441	5831	9	0	\N
100758	1397	1372703404000	11441	5831	10	0	\N
100759	1397	1372693403000	11441	5831	11	0	\N
100760	1397	1372683402000	11441	5831	12	0	\N
100761	1397	1372673401000	11441	5831	13	0	\N
100762	1397	1372663400000	11441	5831	14	0	\N
100763	1397	1372653399000	11441	5831	15	0	\N
100764	1397	1372643398000	11441	5831	16	0	\N
100765	1397	1372633397000	11441	5831	17	0	\N
100766	1397	1372623396000	11441	5831	18	0	\N
100767	1397	1372613395000	11441	5831	19	0	\N
100768	1397	1372603394000	11441	5831	20	0	\N
100769	1397	1372593393000	11441	5831	21	0	\N
100770	1397	1372583392000	11441	5831	22	0	\N
100771	1397	1372573391000	11441	5831	23	0	\N
100772	1397	1372563390000	11441	5831	24	0	\N
100773	1397	1372553389000	11441	5831	25	0	\N
100774	1397	1372543388000	11441	5831	26	0	\N
100775	1397	1372533387000	11441	5831	27	0	\N
100776	1397	1372523386000	11441	5831	28	0	\N
100720	1397	1372263360000	11429	5870	2	0	6657
100721	1726	721565610000	11429	5870	3	0	3621
100722	1726	721564609000	11429	5870	4	0	3622
100723	1397	1372253359000	11430	5871	0	0	6658
100724	1726	721563608000	11430	5871	1	0	3623
100726	1397	1372233357000	11431	5872	1	0	6660
100727	1726	721562607000	11431	5872	2	0	3624
100728	1726	721561606000	11431	5872	3	0	3625
100735	1397	1372223356000	11435	5873	0	0	6661
100736	1726	721560605000	11435	5873	1	0	3626
100738	1397	1372213355000	11437	5875	0	0	6662
100739	1726	721558603000	11437	5875	1	0	3628
100740	1397	1372203354000	11438	5876	0	0	6663
100741	1726	721557602000	11438	5876	1	0	3629
100745	1397	1372183352000	11440	5877	1	0	6665
100746	1726	721556601000	11440	5877	2	0	3630
100747	1726	721555600000	11440	5877	3	0	3631
100777	1397	1372513385000	11441	5831	29	0	\N
100778	1397	1372503384000	11441	5831	30	0	\N
100779	1397	1372493383000	11441	5831	31	0	\N
100780	1397	1372483382000	11441	5831	32	0	\N
100781	1397	1372473381000	11441	5831	33	0	\N
100782	1397	1372463380000	11441	5831	34	0	\N
100783	1397	1372453379000	11441	5831	35	0	\N
100784	1397	1372443378000	11441	5831	36	0	\N
100785	1397	1372433377000	11441	5831	37	0	\N
100786	1397	1372423376000	11441	5831	38	0	\N
100787	1397	1372413375000	11441	5831	39	0	\N
100788	1397	1372403374000	11441	5831	40	0	\N
100789	1397	1372393373000	11441	5831	41	0	\N
100790	1397	1372383372000	11441	5831	42	0	\N
100791	1397	1372373371000	11441	5831	43	0	\N
100792	1397	1372363370000	11441	5831	44	0	\N
100793	1397	1372353369000	11441	5831	45	0	\N
100794	1397	1372343368000	11441	5831	46	0	\N
100795	1397	1372333367000	11441	5831	47	0	\N
100796	1397	1372323366000	11441	5831	48	0	\N
100797	1397	1372313365000	11441	5831	49	0	\N
100798	1397	1372303364000	11441	5831	50	0	\N
100799	1397	1372293363000	11441	5831	51	0	\N
100800	1397	1372283362000	11441	5831	52	0	\N
100801	1397	1372273361000	11441	5831	53	0	\N
100802	1397	1372263360000	11441	5831	54	0	\N
100803	1397	1372253359000	11441	5831	55	0	\N
100804	1397	1372243358000	11441	5831	56	0	\N
100805	1397	1372233357000	11441	5831	57	0	\N
100806	1397	1372223356000	11441	5831	58	0	\N
100807	1397	1372213355000	11441	5831	59	0	\N
100808	1397	1372203354000	11441	5831	60	0	\N
100809	1397	1372193353000	11441	5831	61	0	\N
100810	1397	1372183352000	11441	5831	62	0	\N
100811	1397	1372173351000	11441	5831	63	0	\N
100812	1397	1372163350000	11441	5831	64	0	\N
100813	1726	722827662000	11441	5831	65	0	\N
100814	1726	722826661000	11441	5831	66	0	\N
100815	1726	722825660000	11441	5831	67	0	\N
100816	1726	722824659000	11441	5831	68	0	\N
100817	1726	722823658000	11441	5831	69	0	\N
100818	1726	722822657000	11441	5831	70	0	\N
100819	1726	722821656000	11441	5831	71	0	\N
100820	1726	722820655000	11441	5831	72	0	\N
100821	1726	722819654000	11441	5831	73	0	\N
100822	1726	722818653000	11441	5831	74	0	\N
100823	1726	722817652000	11441	5831	75	0	\N
100824	1726	722816651000	11441	5831	76	0	\N
100825	1726	722815650000	11441	5831	77	0	\N
100826	1726	722814649000	11441	5831	78	0	\N
100827	1726	722813648000	11441	5831	79	0	\N
100828	1726	722812647000	11441	5831	80	0	\N
100829	1726	722811646000	11441	5831	81	0	\N
100830	1726	722810645000	11441	5831	82	0	\N
100831	1726	722809644000	11441	5831	83	0	\N
100832	1726	722808643000	11441	5831	84	0	\N
100833	1726	722807642000	11441	5831	85	0	\N
100834	1726	722806641000	11441	5831	86	0	\N
100835	1726	722805640000	11441	5831	87	0	\N
100836	1726	722804639000	11441	5831	88	0	\N
100837	1726	722803638000	11441	5831	89	0	\N
100838	1726	722802637000	11441	5831	90	0	\N
100839	1726	722801636000	11441	5831	91	0	\N
100840	1726	722800635000	11441	5831	92	0	\N
100841	1726	722799634000	11441	5831	94	0	\N
100842	1726	722798633000	11441	5831	95	0	\N
100843	1726	722797632000	11441	5831	96	0	\N
100844	1726	722796631000	11441	5831	97	0	\N
100845	1726	722795630000	11441	5831	98	0	\N
100846	1726	722794629000	11441	5831	99	0	\N
100847	1726	722793628000	11441	5831	100	0	\N
100848	1726	722792627000	11441	5831	101	0	\N
100849	1726	722791626000	11441	5831	102	0	\N
100850	1726	722790625000	11441	5831	103	0	\N
100851	1726	722789624000	11441	5831	104	0	\N
100852	1726	722788623000	11441	5831	105	0	\N
100853	1726	722787622000	11441	5831	106	0	\N
100854	1726	722786621000	11441	5831	107	0	\N
100855	1726	722785620000	11441	5831	108	0	\N
100856	1726	721575620000	11441	5831	109	0	\N
100857	1726	721574619000	11441	5831	110	0	\N
100858	1726	721573618000	11441	5831	111	0	\N
100859	1726	721572617000	11441	5831	112	0	\N
100860	1726	721571616000	11441	5831	113	0	\N
100861	1726	721570615000	11441	5831	114	0	\N
100862	1726	721569614000	11441	5831	115	0	\N
100863	1726	721568613000	11441	5831	116	0	\N
100864	1726	721567612000	11441	5831	117	0	\N
100865	1726	721566611000	11441	5831	118	0	\N
100866	1726	721565610000	11441	5831	119	0	\N
100867	1726	721564609000	11441	5831	120	0	\N
100868	1726	721563608000	11441	5831	121	0	\N
100869	1726	721562607000	11441	5831	122	0	\N
100870	1726	721561606000	11441	5831	123	0	\N
100871	1726	721560605000	11441	5831	124	0	\N
100872	1726	721559604000	11441	5831	125	0	\N
100877	1397	1372173351000	11443	5878	0	0	\N
100878	1397	1372163350000	11443	5878	1	0	\N
100879	1726	721554599000	11443	5878	2	0	\N
100880	1726	721553598000	11443	5878	3	0	\N
100887	1397	1372123346000	11445	5880	0	0	\N
100889	1397	1372123346000	11447	5880	0	0	\N
100890	1397	1372123346000	11448	5880	0	0	\N
100891	1397	1372123346000	11449	5880	0	0	\N
100908	1693	12192547629428	11456	5777	0	0	\N
100909	1693	12190400555969	11456	5777	1	0	\N
100910	1613	11840477800000	11456	5777	2	0	\N
100911	1613	7122275600000	11456	5777	3	0	\N
100912	1693	12119867131640	11456	5777	4	0	\N
100875	1726	721554599000	11442	5878	2	0	3632
100876	1726	721553598000	11442	5878	3	0	3633
100881	1397	1372153349000	11444	5879	0	0	6668
100882	1397	1372143348000	11444	5879	1	0	6669
100883	1397	1372133347000	11444	5879	2	0	6670
100885	1726	721551596000	11444	5879	4	0	3635
100886	1726	721550595000	11444	5879	5	0	3636
100888	1397	1372123346000	11446	5880	0	0	6671
100892	1726	721549594000	11450	5881	0	0	3637
100893	1397	1372113345000	11451	5882	0	0	6672
100895	1726	721548593000	11451	5882	2	0	3638
100896	1726	721547592000	11451	5882	3	0	3639
100897	1397	1372093343000	11452	5883	0	0	6674
100898	1397	1372083342000	11452	5883	1	0	6675
100900	1726	721545590000	11452	5883	3	0	3641
100901	1397	1372073341000	11453	5884	0	0	6676
100902	1726	721544589000	11453	5884	1	0	3642
100903	1726	720334589000	11454	5885	0	0	3643
100904	1397	1372063340000	11454	5885	1	0	6677
100906	1397	1372053339000	11455	5886	0	0	6678
100907	1726	720332587000	11455	5886	1	0	3645
100913	1693	12049333707311	11456	5777	5	0	\N
100914	1693	11856364138609	11456	5777	6	0	\N
100915	1613	4244978100000	11456	5777	7	0	\N
100916	1613	1367680600000	11456	5777	8	0	\N
100917	1693	11785830714280	11456	5777	9	0	\N
100918	1693	11281357755619	11456	5777	10	0	\N
100919	1693	11210824331290	11456	5777	11	0	\N
100920	1693	11205471647635	11456	5777	12	0	\N
100921	1693	11134938223306	11456	5777	13	0	\N
100922	1693	10172293464881	11456	5777	14	0	\N
100923	1693	10101760040552	11456	5777	15	0	\N
100924	1693	10081234135297	11456	5777	16	0	\N
100925	1693	10010700710968	11456	5777	17	0	\N
100926	1693	9940167286639	11456	5777	18	0	\N
100927	1693	9869633862310	11456	5777	19	0	\N
100928	1693	9799100437981	11456	5777	20	0	\N
100929	1693	9471238881251	11456	5777	21	0	\N
100930	1693	9400705456922	11456	5777	22	0	\N
100931	1693	9330172032593	11456	5777	23	0	\N
100932	1693	9002310475863	11456	5777	24	0	\N
100933	1693	8931777051534	11456	5777	25	0	\N
100934	1693	8861243627205	11456	5777	26	0	\N
100935	1693	8790710202876	11456	5777	27	0	\N
100936	1693	8720176778547	11456	5777	28	0	\N
100937	1693	8649643354218	11456	5777	29	0	\N
100938	1693	8579109929889	11456	5777	30	0	\N
100939	1693	8508576505560	11456	5777	31	0	\N
100940	1693	8438043081231	11456	5777	32	0	\N
100941	1693	8367509656902	11456	5777	33	0	\N
100942	1693	8296976232573	11456	5777	34	0	\N
100943	1693	8226442808244	11456	5777	35	0	\N
100944	1693	8155909383915	11456	5777	36	0	\N
100945	1693	8085375959586	11456	5777	37	0	\N
100946	1693	8014842535257	11456	5777	38	0	\N
100947	1693	7944309110928	11456	5777	39	0	\N
100948	1693	7873775686599	11456	5777	40	0	\N
100949	1693	7803242262270	11456	5777	41	0	\N
100950	1693	7732708837941	11456	5777	42	0	\N
100951	1693	7662175413612	11456	5777	43	0	\N
100952	1693	7591641989283	11456	5777	44	0	\N
100953	1693	7589494915824	11456	5777	45	0	\N
100954	1693	7518961491495	11456	5777	46	0	\N
100955	1693	7448428067166	11456	5777	47	0	\N
100956	1693	7377894642837	11456	5777	48	0	\N
100957	1693	7307361218508	11456	5777	49	0	\N
100958	1693	7236827794179	11456	5777	50	0	\N
100959	1693	7166294369850	11456	5777	51	0	\N
100960	1693	7095760945521	11456	5777	52	0	\N
100961	1693	7025227521192	11456	5777	53	0	\N
100962	1693	6954694096863	11456	5777	54	0	\N
100963	1693	6884160672534	11456	5777	55	0	\N
100964	1693	6813627248205	11456	5777	56	0	\N
100965	1693	6743093823876	11456	5777	57	0	\N
100966	1693	6672560399547	11456	5777	58	0	\N
100967	1693	6602026975218	11456	5777	59	0	\N
100968	1693	6531493550889	11456	5777	60	0	\N
100969	1693	6460960126560	11456	5777	61	0	\N
100970	1693	6390426702231	11456	5777	62	0	\N
100971	1693	6319893277902	11456	5777	63	0	\N
100972	1693	5670374424539	11456	5777	64	0	\N
100975	1397	1372033337000	11458	5888	0	0	\N
100976	1726	720330585000	11458	5888	1	0	\N
100979	1397	1372033337000	11460	5888	0	0	\N
100980	1726	720330585000	11460	5888	1	0	\N
100991	1397	1371973331000	11466	5894	0	0	\N
100992	1726	720324579000	11466	5894	1	0	\N
100995	1397	1371963330000	11468	5895	0	0	\N
100996	1726	720323578000	11468	5895	1	0	\N
100997	1422	3744970860211	11468	5895	2	0	\N
100998	1397	1371963330000	11469	5895	0	0	\N
100999	1726	720323578000	11469	5895	1	0	\N
101000	1422	3744970860211	11469	5895	2	0	\N
101014	1775	1932000000	11472	5896	0	0	\N
101015	149	71310039000341	11472	5896	1	0	\N
101016	1397	1371953329000	11472	5896	2	0	\N
101017	1397	1371943328000	11472	5896	3	0	\N
101018	1397	1371933327000	11472	5896	4	0	\N
101019	1397	1371923326000	11472	5896	5	0	\N
101020	1726	720322577000	11472	5896	6	0	\N
101021	1726	720321576000	11472	5896	7	0	\N
101022	1726	720320575000	11472	5896	8	0	\N
101023	1726	720319574000	11472	5896	9	0	\N
101027	1397	1371903324000	11474	5898	0	0	\N
101028	1726	720317572000	11474	5898	1	0	\N
101029	1397	1371903324000	11475	5898	0	0	\N
101030	1726	720317572000	11475	5898	1	0	\N
101035	1397	1371883322000	11478	5900	0	0	\N
101036	1397	1371873321000	11478	5900	1	0	\N
101037	1726	720315570000	11478	5900	2	0	\N
101038	1726	720314569000	11478	5900	3	0	\N
101043	1397	1371863320000	11480	5901	0	0	\N
101044	1726	720313568000	11480	5901	1	0	\N
101047	1397	1371863320000	11482	5901	0	0	\N
101048	1726	720313568000	11482	5901	1	0	\N
100977	1397	1372033337000	11459	5888	0	0	6680
100978	1726	720330585000	11459	5888	1	0	3647
100981	1397	1372023336000	11461	5889	0	0	6681
100982	1726	720329584000	11461	5889	1	0	3648
100983	1397	1372013335000	11462	5890	0	0	6682
100985	1397	1372003334000	11463	5891	0	0	6683
100986	1726	720327582000	11463	5891	1	0	3650
100987	1397	1371993333000	11464	5892	0	0	6684
100988	1726	720326581000	11464	5892	1	0	3651
100989	1397	1371983332000	11465	5893	0	0	6685
100993	1397	1371973331000	11467	5894	0	0	6686
100994	1726	720324579000	11467	5894	1	0	3653
101001	1397	1371963330000	11470	5895	0	0	6687
101002	1726	720323578000	11470	5895	1	0	3654
101004	1775	1932000000	11471	5896	0	0	7
101005	149	71310039000341	11471	5896	1	0	5
101006	1397	1371953329000	11471	5896	2	0	6688
101007	1397	1371943328000	11471	5896	3	0	6689
101008	1397	1371933327000	11471	5896	4	0	6690
101010	1726	720322577000	11471	5896	6	0	3655
101011	1726	720321576000	11471	5896	7	0	3656
101012	1726	720320575000	11471	5896	8	0	3657
101013	1726	720319574000	11471	5896	9	0	3658
101024	58	70266265999659	11473	5897	0	0	7
101026	1726	720318573000	11473	5897	2	0	3659
101031	1397	1371903324000	11476	5898	0	0	6693
101032	1726	720317572000	11476	5898	1	0	3660
101033	1397	1371893323000	11477	5899	0	0	6694
101039	1397	1371883322000	11479	5900	0	0	6695
101040	1397	1371873321000	11479	5900	1	0	6696
101041	1726	720315570000	11479	5900	2	0	3662
101042	1726	720314569000	11479	5900	3	0	3663
101045	1397	1371863320000	11481	5901	0	0	6697
101052	1397	1371853319000	11484	5902	0	0	\N
101053	1726	720312567000	11484	5902	1	0	\N
101054	1775	1931000000	11484	5902	2	0	\N
101055	1397	1371843318000	11485	5903	0	0	\N
101056	1397	1371843318000	11487	5903	0	0	\N
101058	1397	1371843318000	11489	5903	0	0	\N
101059	1397	1371843318000	11490	5903	0	0	\N
101060	1397	1371843318000	11491	5903	0	0	\N
101068	1775	1920000000	11493	5904	0	0	\N
101069	1397	1371833317000	11493	5904	1	0	\N
101070	1397	1371823316000	11493	5904	3	0	\N
101071	1397	1371813315000	11493	5904	4	0	\N
101072	1726	720311566000	11493	5904	5	0	\N
101073	1726	720310565000	11493	5904	6	0	\N
101074	1726	720309564000	11493	5904	7	0	\N
101075	1397	1371803314000	11494	5905	0	0	\N
101076	1397	1371793313000	11494	5905	1	0	\N
101077	1747	8734807000000	11494	5905	2	0	\N
101078	1726	720308563000	11494	5905	3	0	\N
101079	1726	720307562000	11494	5905	4	0	\N
101087	1397	1371783312000	11497	5906	0	0	\N
101088	1726	720306561000	11497	5906	1	0	\N
101089	1775	1932000000	11498	5832	0	0	\N
101090	149	70590017000341	11498	5832	1	0	\N
101091	58	70266265999659	11498	5832	2	0	\N
101092	1397	1372153349000	11498	5832	3	0	\N
101093	1397	1372143348000	11498	5832	4	0	\N
101094	1397	1372133347000	11498	5832	5	0	\N
101095	1397	1372123346000	11498	5832	6	0	\N
101096	1397	1372113345000	11498	5832	7	0	\N
101097	1397	1372103344000	11498	5832	8	0	\N
101098	1397	1372093343000	11498	5832	9	0	\N
101099	1397	1372083342000	11498	5832	10	0	\N
101100	1397	1372073341000	11498	5832	11	0	\N
101101	1397	1372063340000	11498	5832	12	0	\N
101102	1397	1372053339000	11498	5832	13	0	\N
101103	1397	1372043338000	11498	5832	14	0	\N
101104	1397	1372033337000	11498	5832	15	0	\N
101105	1397	1372023336000	11498	5832	16	0	\N
101106	1397	1372013335000	11498	5832	17	0	\N
101107	1397	1372003334000	11498	5832	18	0	\N
101108	1397	1371993333000	11498	5832	19	0	\N
101109	1397	1371983332000	11498	5832	20	0	\N
101110	1397	1371973331000	11498	5832	21	0	\N
101111	1397	1371963330000	11498	5832	22	0	\N
101112	1397	1371953329000	11498	5832	23	0	\N
101113	1397	1371943328000	11498	5832	24	0	\N
101114	1397	1371933327000	11498	5832	25	0	\N
101115	1397	1371923326000	11498	5832	26	0	\N
101116	1397	1371913325000	11498	5832	27	0	\N
101117	1397	1371903324000	11498	5832	28	0	\N
101118	1397	1371893323000	11498	5832	29	0	\N
101119	1397	1371883322000	11498	5832	30	0	\N
101120	1397	1371873321000	11498	5832	31	0	\N
101121	1397	1371863320000	11498	5832	32	0	\N
101122	1397	1371853319000	11498	5832	33	0	\N
101123	1397	1371843318000	11498	5832	34	0	\N
101124	1397	1371833317000	11498	5832	35	0	\N
101125	1397	1371823316000	11498	5832	36	0	\N
101126	1397	1371813315000	11498	5832	37	0	\N
101127	1397	1371803314000	11498	5832	38	0	\N
101128	1397	1371793313000	11498	5832	39	0	\N
101129	1397	1371783312000	11498	5832	40	0	\N
101130	1747	8734807000000	11498	5832	41	0	\N
101131	1422	3744970860211	11498	5832	42	0	\N
101132	1726	721558603000	11498	5832	43	0	\N
101133	1726	721557602000	11498	5832	44	0	\N
101134	1775	1931000000	11498	5832	45	0	\N
101135	1775	1920000000	11498	5832	46	0	\N
101136	1726	721556601000	11498	5832	47	0	\N
101137	1726	721555600000	11498	5832	48	0	\N
101138	1726	721554599000	11498	5832	49	0	\N
101139	1726	721553598000	11498	5832	50	0	\N
101140	1726	721552597000	11498	5832	51	0	\N
101141	1726	721551596000	11498	5832	52	0	\N
101142	1726	721550595000	11498	5832	53	0	\N
101143	1726	721549594000	11498	5832	54	0	\N
101144	1726	721548593000	11498	5832	55	0	\N
101145	1726	721547592000	11498	5832	56	0	\N
101146	1726	721546591000	11498	5832	57	0	\N
101147	1726	721545590000	11498	5832	58	0	\N
101148	1726	721544589000	11498	5832	59	0	\N
101149	1726	720334589000	11498	5832	60	0	\N
101150	1726	720333588000	11498	5832	61	0	\N
101151	1726	720332587000	11498	5832	62	0	\N
101152	1726	720331586000	11498	5832	63	0	\N
101153	1726	720330585000	11498	5832	64	0	\N
101154	1726	720329584000	11498	5832	65	0	\N
101155	1726	720328583000	11498	5832	66	0	\N
101156	1726	720327582000	11498	5832	67	0	\N
101157	1726	720326581000	11498	5832	68	0	\N
101158	1726	720325580000	11498	5832	69	0	\N
101159	1726	720324579000	11498	5832	70	0	\N
101160	1726	720323578000	11498	5832	71	0	\N
101161	1726	720322577000	11498	5832	72	0	\N
101162	1726	720321576000	11498	5832	73	0	\N
101163	1726	720320575000	11498	5832	74	0	\N
101164	1726	720319574000	11498	5832	75	0	\N
101165	1726	720318573000	11498	5832	76	0	\N
101166	1726	720317572000	11498	5832	77	0	\N
101167	1726	720316571000	11498	5832	78	0	\N
101168	1726	720315570000	11498	5832	79	0	\N
101169	1726	720314569000	11498	5832	80	0	\N
101170	1726	720313568000	11498	5832	81	0	\N
101171	1726	720312567000	11498	5832	82	0	\N
101172	1726	720311566000	11498	5832	83	0	\N
101173	1726	720310565000	11498	5832	84	0	\N
101174	1726	720309564000	11498	5832	85	0	\N
101175	1726	720308563000	11498	5832	86	0	\N
101176	1726	720307562000	11498	5832	87	0	\N
101177	1726	720306561000	11498	5832	88	0	\N
101181	1726	719095560000	11500	5908	0	0	\N
101182	1397	1371763310000	11500	5908	1	0	\N
101183	1775	1917000000	11500	5908	2	0	\N
101184	1747	736806000000	11500	5908	3	0	\N
101051	1775	1931000000	11483	5902	2	0	8
101057	1397	1371843318000	11488	5903	0	0	6699
101061	1775	1920000000	11492	5904	0	0	9
101062	1397	1371833317000	11492	5904	1	0	6700
101063	1397	1371823316000	11492	5904	3	0	6701
101065	1726	720311566000	11492	5904	5	0	3666
101066	1726	720310565000	11492	5904	6	0	3667
101067	1726	720309564000	11492	5904	7	0	3668
101080	1397	1371803314000	11495	5905	0	0	6703
101081	1397	1371793313000	11495	5905	1	0	6704
101083	1726	720308563000	11495	5905	3	0	3669
101084	1726	720307562000	11495	5905	4	0	3670
101085	1397	1371783312000	11496	5906	0	0	6705
101086	1726	720306561000	11496	5906	1	0	3671
101179	1775	1919000000	11499	5907	1	0	10
101180	1726	720305560000	11499	5907	2	0	3672
101185	1769	1719900000	11500	5908	4	0	\N
101186	1726	719094559000	11500	5908	5	0	\N
101193	1726	719095560000	11502	5908	0	0	\N
101194	1397	1371763310000	11502	5908	1	0	\N
101195	1775	1917000000	11502	5908	2	0	\N
101196	1747	736806000000	11502	5908	3	0	\N
101197	1769	1719900000	11502	5908	4	0	\N
101198	1726	719094559000	11502	5908	5	0	\N
101202	1775	1932000000	11504	5793	0	0	\N
101203	149	70590017000341	11504	5793	1	0	\N
101204	58	69546254999659	11504	5793	2	0	\N
101205	1397	1372283362000	11504	5793	3	0	\N
101206	1397	1372273361000	11504	5793	4	0	\N
101207	1397	1372263360000	11504	5793	5	0	\N
101208	1397	1372253359000	11504	5793	6	0	\N
101209	1397	1372243358000	11504	5793	7	0	\N
101210	1397	1372233357000	11504	5793	8	0	\N
101211	1397	1372223356000	11504	5793	9	0	\N
101212	1397	1372213355000	11504	5793	10	0	\N
101213	1397	1372203354000	11504	5793	11	0	\N
101214	1397	1372193353000	11504	5793	12	0	\N
101215	1397	1372183352000	11504	5793	13	0	\N
101216	1397	1372173351000	11504	5793	14	0	\N
101217	1397	1372163350000	11504	5793	15	0	\N
101218	1397	1372153349000	11504	5793	16	0	\N
101219	1397	1372143348000	11504	5793	17	0	\N
101220	1397	1372133347000	11504	5793	19	0	\N
101221	1397	1372123346000	11504	5793	20	0	\N
101222	1397	1372113345000	11504	5793	21	0	\N
101223	1397	1372103344000	11504	5793	22	0	\N
101224	1397	1372093343000	11504	5793	23	0	\N
101225	1397	1372083342000	11504	5793	24	0	\N
101226	1397	1372073341000	11504	5793	25	0	\N
101227	1397	1372063340000	11504	5793	26	0	\N
101228	1397	1372053339000	11504	5793	27	0	\N
101229	1397	1372043338000	11504	5793	28	0	\N
101230	1397	1372033337000	11504	5793	29	0	\N
101231	1397	1372023336000	11504	5793	30	0	\N
101232	1397	1372013335000	11504	5793	31	0	\N
101233	1397	1372003334000	11504	5793	32	0	\N
101234	1397	1371993333000	11504	5793	33	0	\N
101235	1397	1371983332000	11504	5793	34	0	\N
101236	1397	1371973331000	11504	5793	35	0	\N
101237	1397	1371963330000	11504	5793	36	0	\N
101238	1397	1371953329000	11504	5793	37	0	\N
101239	1397	1371943328000	11504	5793	38	0	\N
101248	1397	1371713305000	11507	5912	0	0	\N
101249	1726	719089554000	11507	5912	1	0	\N
101252	1397	1371713305000	11509	5912	0	0	\N
101253	1726	719089554000	11509	5912	1	0	\N
101254	1397	1371703304000	11511	5913	0	0	\N
101255	1726	719088553000	11511	5913	1	0	\N
101260	1397	1371693303000	11514	5914	0	0	\N
101261	1726	719087552000	11514	5914	1	0	\N
101262	1397	1371693303000	11515	5914	0	0	\N
101263	1726	719087552000	11515	5914	1	0	\N
101264	1397	1371683302000	11516	5915	0	0	\N
101265	1726	719086551000	11516	5915	1	0	\N
101268	1397	1371683302000	11518	5915	0	0	\N
101269	1726	719086551000	11518	5915	1	0	\N
101270	1397	1371783312000	11520	5906	0	0	\N
101271	1397	1371773311000	11520	5906	1	0	\N
101272	1397	1371763310000	11520	5906	2	0	\N
101273	1397	1371753309000	11520	5906	3	0	\N
101274	1397	1371743308000	11520	5906	4	0	\N
101275	1397	1371733307000	11520	5906	5	0	\N
101276	1397	1371723306000	11520	5906	6	0	\N
101277	1397	1371713305000	11520	5906	7	0	\N
101278	1397	1371703304000	11520	5906	8	0	\N
101279	1397	1371693303000	11520	5906	9	0	\N
101280	1704	66194000000	11520	5906	10	0	\N
101281	1747	736806000000	11520	5906	11	0	\N
101282	1769	1719900000	11520	5906	12	0	\N
101283	1726	720306561000	11520	5906	13	0	\N
101284	1775	1919000000	11520	5906	14	0	\N
101285	1775	1917000000	11520	5906	15	0	\N
101286	1726	720305560000	11520	5906	16	0	\N
101287	1726	719095560000	11520	5906	17	0	\N
101288	1726	719094559000	11520	5906	18	0	\N
101289	1726	719093558000	11520	5906	19	0	\N
101290	1726	719092557000	11520	5906	20	0	\N
101291	1726	719091556000	11520	5906	21	0	\N
101292	1726	719090555000	11520	5906	22	0	\N
101293	1726	719089554000	11520	5906	23	0	\N
101294	1726	719088553000	11520	5906	24	0	\N
101295	1726	719087552000	11520	5906	25	0	\N
101296	1746	6488300000000	11520	5906	26	0	\N
101297	1746	4114299000000	11520	5906	27	0	\N
101312	1397	1371673301000	11524	5917	0	0	\N
101313	1397	1371663300000	11524	5917	1	0	\N
101314	1397	1371653299000	11524	5917	2	0	\N
101315	1397	1371643298000	11524	5917	3	0	\N
101316	1397	1371633297000	11524	5917	4	0	\N
101317	1397	1371623296000	11524	5917	5	0	\N
101318	1397	1371613295000	11524	5917	6	0	\N
101319	1726	719085550000	11524	5917	7	0	\N
101320	1726	719084549000	11524	5917	8	0	\N
101189	1775	1917000000	11501	5908	2	0	11
101190	1747	736806000000	11501	5908	3	0	5
101191	1769	1719900000	11501	5908	4	0	23
101192	1726	719094559000	11501	5908	5	0	3674
101199	1397	1371753309000	11503	5909	0	0	6708
101201	1726	719093558000	11503	5909	2	0	3675
101240	1397	1371743308000	11505	5910	0	0	6709
101241	1726	719092557000	11505	5910	1	0	3676
101242	1746	6488300000000	11505	5910	2	0	1
101243	1397	1371733307000	11506	5911	0	0	6710
101245	1726	719091556000	11506	5911	2	0	3677
101246	1746	4114299000000	11506	5911	3	0	2
101247	1726	719090555000	11506	5911	4	0	3678
101250	1397	1371713305000	11508	5912	0	0	6712
101256	1397	1371703304000	11512	5913	0	0	6713
101257	1726	719088553000	11512	5913	1	0	3680
101258	1397	1371693303000	11513	5914	0	0	6714
101259	1726	719087552000	11513	5914	1	0	3681
101266	1397	1371683302000	11517	5915	0	0	6715
101298	1397	1371673301000	11521	5917	0	0	6716
101299	1397	1371663300000	11521	5917	1	0	6717
101300	1726	719085550000	11521	5917	2	0	3683
101301	1726	719084549000	11521	5917	3	0	3684
101302	1397	1371653299000	11522	5918	0	0	6718
101304	1397	1371643298000	11523	5919	0	0	6719
101305	1397	1371633297000	11523	5919	1	0	6720
101306	1397	1371623296000	11523	5919	2	0	6721
101307	1397	1371613295000	11523	5919	3	0	6722
101309	1726	719081546000	11523	5919	5	0	3687
101310	1726	719080545000	11523	5919	6	0	3688
101311	1726	719079544000	11523	5919	7	0	3689
101321	1726	719083548000	11524	5917	9	0	\N
101322	1726	719082547000	11524	5917	10	0	\N
101323	1726	719081546000	11524	5917	11	0	\N
101324	1726	719080545000	11524	5917	12	0	\N
101325	1726	719079544000	11524	5917	13	0	\N
101326	1458	23002236908540	11525	5637	0	0	\N
101327	1458	19473936908540	11525	5637	1	0	\N
101328	1458	14244636908540	11525	5637	2	0	\N
101329	1458	4413336908540	11525	5637	3	0	\N
101330	1937	0	11525	5637	4	0	\N
101331	2015	333700000000	11525	5637	5	0	\N
101332	1509	20880543000000	11525	5637	6	0	\N
101333	1509	18236206312008	11525	5637	7	0	\N
101334	1509	15038980021455	11525	5637	8	0	\N
101335	1509	10300430532383	11525	5637	9	0	\N
101336	1509	1391253851155	11525	5637	10	0	\N
101337	1546	21599641000000	11525	5637	11	0	\N
101338	149	69870007000341	11525	5637	12	0	\N
101339	1691	14171602645814	11525	5637	13	0	\N
101340	1546	19228631000000	11525	5637	14	0	\N
101341	58	68826234999659	11525	5637	15	0	\N
101342	1693	10752477629428	11525	5637	16	0	\N
101343	1693	10750330555969	11525	5637	17	0	\N
101344	1691	12439161712302	11525	5637	18	0	\N
101345	1691	9334650322910	11525	5637	19	0	\N
101346	1613	11840477800000	11525	5637	20	0	\N
101347	1691	7239971373927	11525	5637	21	0	\N
101348	1691	1402980100019	11525	5637	22	0	\N
101349	1546	16361621000000	11525	5637	23	0	\N
101350	1613	7122275600000	11525	5637	24	0	\N
101351	439	66000040000000	11525	5637	25	0	\N
101352	411	66837920000000	11525	5637	26	0	\N
101353	411	66007910000000	11525	5637	27	0	\N
101354	1693	10679797131640	11525	5637	28	0	\N
101355	1693	10609263707311	11525	5637	29	0	\N
101356	1693	10416294138609	11525	5637	30	0	\N
101357	1613	4244978100000	11525	5637	31	0	\N
101358	1613	1367680600000	11525	5637	32	0	\N
101359	1726	728211913000	11525	5637	33	0	\N
101360	1726	728201912000	11525	5637	34	0	\N
101361	1726	728191911000	11525	5637	35	0	\N
101362	1726	728181910000	11525	5637	36	0	\N
101363	1726	728171909000	11525	5637	37	0	\N
101364	1726	728161908000	11525	5637	38	0	\N
101365	1726	728151907000	11525	5637	39	0	\N
101366	1546	12112611000000	11525	5637	40	0	\N
101367	1546	4124601000000	11525	5637	41	0	\N
101368	1546	2880591000000	11525	5637	42	0	\N
101369	1397	1375273661000	11525	5637	43	0	\N
101370	1397	1375263660000	11525	5637	44	0	\N
101371	1397	1375253659000	11525	5637	45	0	\N
101372	1397	1375243658000	11525	5637	46	0	\N
101373	1397	1375233657000	11525	5637	47	0	\N
101374	1397	1375223656000	11525	5637	48	0	\N
101375	1397	1375213655000	11525	5637	49	0	\N
101376	1397	1375203654000	11525	5637	50	0	\N
101377	1397	1375193653000	11525	5637	51	0	\N
101378	1397	1375183652000	11525	5637	52	0	\N
101379	1397	1375173651000	11525	5637	53	0	\N
101380	1397	1375163650000	11525	5637	54	0	\N
101381	1397	1375153649000	11525	5637	55	0	\N
101382	1397	1375143648000	11525	5637	56	0	\N
101383	1397	1375133647000	11525	5637	57	0	\N
101384	1397	1375123646000	11525	5637	58	0	\N
101385	1397	1375113645000	11525	5637	59	0	\N
101386	1397	1375103644000	11525	5637	60	0	\N
101387	1397	1375093643000	11525	5637	61	0	\N
101388	1397	1375083642000	11525	5637	62	0	\N
101389	1397	1375073641000	11525	5637	63	0	\N
101390	1397	1375063640000	11525	5637	64	0	\N
101391	1397	1375053639000	11525	5637	65	0	\N
101392	1397	1375043638000	11525	5637	66	0	\N
101393	1397	1375033637000	11525	5637	67	0	\N
101394	1397	1375023636000	11525	5637	68	0	\N
101395	1397	1375013635000	11525	5637	69	0	\N
101396	1397	1375003634000	11525	5637	70	0	\N
101397	1397	1374993633000	11525	5637	71	0	\N
101398	1397	1374983632000	11525	5637	72	0	\N
101399	1397	1374973631000	11525	5637	73	0	\N
101400	1397	1374963630000	11525	5637	74	0	\N
101401	1397	1374953629000	11525	5637	75	0	\N
101402	1397	1374943628000	11525	5637	76	0	\N
101403	1397	1374933627000	11525	5637	77	0	\N
101404	1397	1374923626000	11525	5637	78	0	\N
101405	1397	1374913625000	11525	5637	79	0	\N
101406	1397	1374903624000	11525	5637	80	0	\N
101407	1397	1374893623000	11525	5637	81	0	\N
101408	1397	1374883622000	11525	5637	82	0	\N
101409	1397	1374873621000	11525	5637	83	0	\N
101410	1397	1374863620000	11525	5637	84	0	\N
101411	1397	1374853619000	11525	5637	85	0	\N
101412	1397	1374843618000	11525	5637	86	0	\N
101413	1397	1374833617000	11525	5637	87	0	\N
101414	1397	1374823616000	11525	5637	88	0	\N
101415	1397	1374813615000	11525	5637	89	0	\N
101416	1397	1374803614000	11525	5637	90	0	\N
101417	1397	1374793613000	11525	5637	91	0	\N
101418	1397	1374783612000	11525	5637	92	0	\N
101419	1397	1374773611000	11525	5637	93	0	\N
101420	1397	1374763610000	11525	5637	94	0	\N
101421	1726	728141906000	11525	5637	95	0	\N
101422	1726	728131905000	11525	5637	96	0	\N
101423	1726	728121904000	11525	5637	97	0	\N
101424	1726	728111903000	11525	5637	99	0	\N
101425	1726	728101902000	11525	5637	100	0	\N
101426	1726	728091901000	11525	5637	101	0	\N
101427	1726	728081900000	11525	5637	102	0	\N
101428	1726	728071899000	11525	5637	103	0	\N
101429	1726	728061898000	11525	5637	104	0	\N
101430	1726	728051897000	11525	5637	105	0	\N
101431	1726	728041896000	11525	5637	106	0	\N
101432	1726	728031895000	11525	5637	107	0	\N
101433	1726	728021894000	11525	5637	108	0	\N
101434	1726	728011893000	11525	5637	109	0	\N
101435	1726	728001892000	11525	5637	110	0	\N
101436	1726	727991891000	11525	5637	111	0	\N
101437	1726	727981890000	11525	5637	112	0	\N
101438	1726	727971889000	11525	5637	113	0	\N
101439	1726	727961888000	11525	5637	114	0	\N
101440	1726	727951887000	11525	5637	115	0	\N
101441	1726	727941886000	11525	5637	116	0	\N
101442	1726	727931885000	11525	5637	117	0	\N
101443	1726	727921884000	11525	5637	118	0	\N
101444	1726	727911883000	11525	5637	119	0	\N
101445	1726	727901882000	11525	5637	120	0	\N
101446	1726	727891881000	11525	5637	121	0	\N
101447	1726	727881880000	11525	5637	122	0	\N
101448	1726	727871879000	11525	5637	123	0	\N
101449	1726	727861878000	11525	5637	124	0	\N
101450	1726	727851877000	11525	5637	125	0	\N
101453	1397	1371583292000	11526	5920	2	0	6725
101454	1726	719078543000	11526	5920	3	0	3690
101455	1726	719077542000	11526	5920	4	0	3691
101456	1726	719076541000	11526	5920	5	0	3692
101462	1397	1371573291000	11528	5921	0	0	\N
101463	1397	1371563290000	11528	5921	1	0	\N
101464	1726	719075540000	11528	5921	2	0	\N
101465	1726	719074539000	11528	5921	3	0	\N
101466	1457	20487668400000	11528	5921	4	0	\N
101480	1397	1371503284000	11534	5927	0	0	\N
101481	1726	719068533000	11534	5927	1	0	\N
101482	1726	717858533000	11534	5927	2	0	\N
101483	1726	716648533000	11534	5927	3	0	\N
101488	1769	1709900000	11536	5928	0	0	\N
101489	1397	1371493283000	11536	5928	1	0	\N
101490	1397	1371483282000	11536	5928	2	0	\N
101491	1397	1371473281000	11536	5928	3	0	\N
101492	1726	716647532000	11536	5928	4	0	\N
101493	1726	716646531000	11536	5928	5	0	\N
101494	1726	716645530000	11536	5928	6	0	\N
101495	1769	1709900000	11537	5928	0	0	\N
101496	1397	1371493283000	11537	5928	1	0	\N
101497	1397	1371483282000	11537	5928	2	0	\N
101498	1397	1371473281000	11537	5928	3	0	\N
101499	1726	716647532000	11537	5928	4	0	\N
101500	1726	716646531000	11537	5928	5	0	\N
101501	1726	716645530000	11537	5928	6	0	\N
101502	1769	1709900000	11538	5928	0	0	\N
101503	1397	1371493283000	11538	5928	1	0	\N
101504	1397	1371483282000	11538	5928	2	0	\N
101505	1397	1371473281000	11538	5928	3	0	\N
101506	1726	716647532000	11538	5928	4	0	\N
101507	1726	716646531000	11538	5928	5	0	\N
101508	1726	716645530000	11538	5928	6	0	\N
101509	1769	1709900000	11539	5928	0	0	\N
101510	1397	1371493283000	11539	5928	1	0	\N
101511	1397	1371483282000	11539	5928	2	0	\N
101512	1397	1371473281000	11539	5928	3	0	\N
101513	1726	716647532000	11539	5928	4	0	\N
101514	1726	716646531000	11539	5928	5	0	\N
101515	1726	716645530000	11539	5928	6	0	\N
101523	1769	1709900000	11541	5928	0	0	\N
101524	1397	1371493283000	11541	5928	1	0	\N
101525	1397	1371483282000	11541	5928	2	0	\N
101526	1397	1371473281000	11541	5928	3	0	\N
101527	1726	716647532000	11541	5928	4	0	\N
101528	1726	716646531000	11541	5928	5	0	\N
101529	1726	716645530000	11541	5928	6	0	\N
101530	1397	1371463280000	11542	5929	0	0	\N
101531	1726	716644529000	11542	5929	1	0	\N
101536	1397	1371453279000	11545	5930	0	0	\N
101537	1726	716643528000	11545	5930	1	0	\N
101540	1397	1371443278000	11547	5931	0	0	\N
101541	1726	716642527000	11547	5931	1	0	\N
101545	1726	716639524000	11552	5935	0	0	\N
101549	1726	716637522000	11555	5937	0	0	\N
101550	1726	716636521000	11555	5937	1	0	\N
101559	1726	716627512000	11561	5943	0	0	\N
101563	1726	716624509000	11564	5945	0	0	\N
101565	1726	716624509000	11566	5945	0	0	\N
101566	1726	716623508000	11567	5946	0	0	\N
101570	1726	716621506000	11571	5948	0	0	\N
101573	1726	716619504000	11574	5950	0	0	\N
101582	1726	716611496000	11580	5956	0	0	\N
101584	1726	716610495000	11584	5958	0	0	\N
101589	1726	716607492000	11589	5961	0	0	\N
101590	1726	716606491000	11590	5962	0	0	\N
101459	1726	719075540000	11527	5921	2	0	3693
101460	1726	719074539000	11527	5921	3	0	3694
101461	1457	20487668400000	11527	5921	4	0	1
101467	1397	1371553289000	11529	5922	0	0	6728
101468	1726	719073538000	11529	5922	1	0	3695
101470	1726	719072537000	11530	5923	1	0	3696
101471	1397	1371533287000	11531	5924	0	0	6730
101472	1726	719071536000	11531	5924	1	0	3697
101473	1397	1371523286000	11532	5925	0	0	6731
101474	1726	719070535000	11532	5925	1	0	3698
101476	1726	719069534000	11533	5926	1	0	3699
101477	1457	17400939560000	11533	5926	2	0	2
101478	1457	12825908800000	11533	5926	3	0	3
101479	1457	4224170040000	11533	5926	4	0	4
101485	1726	719068533000	11535	5927	1	0	3700
101486	1726	717858533000	11535	5927	2	0	3701
101487	1726	716648533000	11535	5927	3	0	3702
101516	1769	1709900000	11540	5928	0	0	24
101517	1397	1371493283000	11540	5928	1	0	6734
101519	1397	1371473281000	11540	5928	3	0	6736
101520	1726	716647532000	11540	5928	4	0	3703
101521	1726	716646531000	11540	5928	5	0	3704
101522	1726	716645530000	11540	5928	6	0	3705
101532	1397	1371463280000	11543	5929	0	0	6737
101534	1397	1371453279000	11544	5930	0	0	6738
101535	1726	716643528000	11544	5930	1	0	3707
101538	1397	1371443278000	11546	5931	0	0	6739
101539	1726	716642527000	11546	5931	1	0	3708
101543	1726	716640525000	11550	5934	0	0	3710
101544	1726	716639524000	11551	5935	0	0	3711
101546	1726	716638523000	11553	5936	0	0	3712
101547	1726	716637522000	11554	5937	0	0	3713
101548	1726	716636521000	11554	5937	1	0	3714
101552	1726	716634519000	11557	5939	0	0	3716
101553	1726	716633518000	11558	5940	0	0	3717
101554	1726	716632517000	11558	5940	1	0	3718
101555	1726	716631516000	11559	5941	0	0	3719
101556	1726	716630515000	11559	5941	1	0	3720
101558	1726	716628513000	11560	5942	1	0	3722
101560	1726	716627512000	11562	5943	0	0	3723
101561	1726	716626511000	11563	5944	0	0	3724
101562	1726	716625510000	11563	5944	1	0	3725
101567	1726	716623508000	11568	5946	0	0	3727
101568	1726	716622507000	11569	5947	0	0	3728
101569	1726	716621506000	11570	5948	0	0	3729
101571	1726	716620505000	11572	5949	0	0	3730
101572	1726	716619504000	11573	5950	0	0	3731
101575	1726	716617502000	11576	5952	0	0	3733
101576	1726	716616501000	11576	5952	1	0	3734
101577	1726	716615500000	11577	5953	0	0	3735
101578	1525	1000000	11577	5953	1	0	1
101579	1726	716614499000	11578	5954	0	0	3736
101581	1726	716612497000	11579	5955	0	0	3738
101583	1726	716611496000	11581	5956	0	0	3739
101585	1726	716610495000	11585	5958	0	0	3740
101586	1726	716609494000	11586	5959	0	0	3741
101588	1726	716607492000	11588	5961	0	0	3743
101591	1726	716606491000	11591	5962	0	0	3744
101592	1726	716605490000	11592	5963	0	0	3745
101593	1726	716604489000	11593	5964	0	0	\N
101595	1726	716603488000	11595	5965	0	0	\N
101596	1726	716602487000	11595	5965	1	0	\N
101599	1726	716603488000	11597	5965	0	0	\N
101600	1726	716602487000	11597	5965	1	0	\N
101601	1726	716603488000	11598	5965	0	0	\N
101602	1726	716602487000	11598	5965	1	0	\N
101603	1726	716601486000	11599	5966	0	0	\N
101604	1726	716600485000	11599	5966	1	0	\N
101609	149	70590017000341	11604	5818	0	0	\N
101610	1397	1372993433000	11604	5818	1	0	\N
101611	58	70266265999659	11604	5818	2	0	\N
101612	1397	1372983432000	11604	5818	3	0	\N
101613	1397	1372973431000	11604	5818	4	0	\N
101614	1397	1372963430000	11604	5818	5	0	\N
101615	1397	1372953429000	11604	5818	6	0	\N
101616	1397	1372943428000	11604	5818	7	0	\N
101617	1397	1372933427000	11604	5818	8	0	\N
101618	1397	1372923426000	11604	5818	9	0	\N
101619	1397	1372913425000	11604	5818	10	0	\N
101620	1397	1372903424000	11604	5818	11	0	\N
101621	1397	1372893423000	11604	5818	12	0	\N
101622	1397	1372883422000	11604	5818	13	0	\N
101623	1397	1372873421000	11604	5818	14	0	\N
101624	1397	1372863420000	11604	5818	15	0	\N
101625	1397	1372853419000	11604	5818	16	0	\N
101626	1397	1372843418000	11604	5818	17	0	\N
101627	1397	1372833417000	11604	5818	18	0	\N
101628	1397	1372823416000	11604	5818	19	0	\N
101629	1397	1372813415000	11604	5818	20	0	\N
101630	1397	1372803414000	11604	5818	21	0	\N
101631	1397	1372793413000	11604	5818	22	0	\N
101632	1397	1372783412000	11604	5818	23	0	\N
101633	1397	1372773411000	11604	5818	24	0	\N
101634	1397	1372763410000	11604	5818	25	0	\N
101635	1397	1372753409000	11604	5818	26	0	\N
101636	1397	1372743408000	11604	5818	27	0	\N
101637	1397	1372733407000	11604	5818	28	0	\N
101638	1397	1372723406000	11604	5818	29	0	\N
101639	1397	1372713405000	11604	5818	30	0	\N
101640	1397	1372703404000	11604	5818	31	0	\N
101641	1397	1372693403000	11604	5818	33	0	\N
101642	1397	1372683402000	11604	5818	34	0	\N
101643	1397	1372673401000	11604	5818	35	0	\N
101644	1397	1372663400000	11604	5818	36	0	\N
101645	1397	1372653399000	11604	5818	37	0	\N
101646	1397	1372643398000	11604	5818	38	0	\N
101647	1397	1372633397000	11604	5818	39	0	\N
101648	1397	1372623396000	11604	5818	40	0	\N
101649	1397	1372613395000	11604	5818	41	0	\N
101650	1397	1372603394000	11604	5818	42	0	\N
101651	1397	1372593393000	11604	5818	43	0	\N
101652	1397	1372583392000	11604	5818	44	0	\N
101653	1397	1372573391000	11604	5818	45	0	\N
101654	1397	1372563390000	11604	5818	46	0	\N
101655	1397	1372553389000	11604	5818	47	0	\N
101656	1397	1372543388000	11604	5818	48	0	\N
101657	1397	1372533387000	11604	5818	49	0	\N
101658	1397	1372523386000	11604	5818	50	0	\N
101659	1397	1372513385000	11604	5818	51	0	\N
101660	1397	1372503384000	11604	5818	52	0	\N
101661	1397	1372493383000	11604	5818	53	0	\N
101662	1397	1372483382000	11604	5818	54	0	\N
101663	1397	1372473381000	11604	5818	55	0	\N
101664	1397	1372463380000	11604	5818	56	0	\N
101665	1397	1372453379000	11604	5818	57	0	\N
101666	1397	1372443378000	11604	5818	58	0	\N
101667	1397	1372433377000	11604	5818	59	0	\N
101668	1397	1372423376000	11604	5818	60	0	\N
101669	1397	1372413375000	11604	5818	61	0	\N
101670	1397	1372403374000	11604	5818	62	0	\N
101671	1397	1372393373000	11604	5818	63	0	\N
101672	1397	1372383372000	11604	5818	64	0	\N
101673	1397	1372373371000	11604	5818	65	0	\N
101674	1397	1372363370000	11604	5818	66	0	\N
101675	1397	1372353369000	11604	5818	67	0	\N
101676	1397	1372343368000	11604	5818	68	0	\N
101677	1397	1372333367000	11604	5818	69	0	\N
101678	1397	1372323366000	11604	5818	70	0	\N
101679	1397	1372313365000	11604	5818	71	0	\N
101680	1397	1372303364000	11604	5818	72	0	\N
101681	1397	1372293363000	11604	5818	73	0	\N
101682	1397	1372283362000	11604	5818	74	0	\N
101683	1397	1372273361000	11604	5818	75	0	\N
101684	1397	1372263360000	11604	5818	76	0	\N
101685	1397	1372253359000	11604	5818	77	0	\N
101686	1397	1372243358000	11604	5818	78	0	\N
101687	1397	1372233357000	11604	5818	79	0	\N
101688	1397	1372223356000	11604	5818	80	0	\N
101689	1397	1372213355000	11604	5818	81	0	\N
101690	1397	1372203354000	11604	5818	82	0	\N
101691	1397	1372193353000	11604	5818	83	0	\N
101692	1397	1372183352000	11604	5818	84	0	\N
101693	1397	1372173351000	11604	5818	85	0	\N
101694	1397	1372163350000	11604	5818	86	0	\N
101695	1397	1372153349000	11604	5818	87	0	\N
101696	1397	1372143348000	11604	5818	88	0	\N
101697	1397	1372133347000	11604	5818	89	0	\N
101698	1397	1372123346000	11604	5818	90	0	\N
101699	1397	1372113345000	11604	5818	91	0	\N
101700	1397	1372103344000	11604	5818	92	0	\N
101701	1397	1372093343000	11604	5818	93	0	\N
101702	1397	1372083342000	11604	5818	94	0	\N
101703	1397	1372073341000	11604	5818	95	0	\N
101704	1397	1372063340000	11604	5818	96	0	\N
101705	1397	1372053339000	11604	5818	97	0	\N
101706	1397	1372043338000	11604	5818	98	0	\N
101707	1397	1372033337000	11604	5818	99	0	\N
101708	1397	1372023336000	11604	5818	100	0	\N
101709	1397	1372013335000	11604	5818	101	0	\N
101710	1397	1372003334000	11604	5818	102	0	\N
101711	1397	1371993333000	11604	5818	103	0	\N
101712	1397	1371983332000	11604	5818	104	0	\N
101713	1397	1371973331000	11604	5818	105	0	\N
101714	1397	1371963330000	11604	5818	106	0	\N
101715	1397	1371953329000	11604	5818	107	0	\N
101716	1397	1371943328000	11604	5818	108	0	\N
101717	1397	1371933327000	11604	5818	109	0	\N
101718	1397	1371923326000	11604	5818	110	0	\N
101719	1397	1371913325000	11604	5818	111	0	\N
101720	1397	1371903324000	11604	5818	112	0	\N
101721	1397	1371893323000	11604	5818	113	0	\N
101722	1397	1371883322000	11604	5818	114	0	\N
101723	1397	1371873321000	11604	5818	115	0	\N
101724	1397	1371863320000	11604	5818	116	0	\N
101725	1397	1371853319000	11604	5818	117	0	\N
101726	1397	1371843318000	11604	5818	118	0	\N
101727	1397	1371833317000	11604	5818	119	0	\N
101728	1397	1371823316000	11604	5818	120	0	\N
101598	1726	716602487000	11596	5965	1	0	3748
101605	1726	716601486000	11600	5966	0	0	3749
101606	1726	716600485000	11600	5966	1	0	3750
101607	1726	716599484000	11601	5967	0	0	3751
101608	1726	716598483000	11601	5967	1	0	3752
101729	1397	1371813315000	11604	5818	121	0	\N
101730	1397	1371803314000	11604	5818	122	0	\N
101731	1397	1371793313000	11604	5818	123	0	\N
101732	1397	1371783312000	11604	5818	124	0	\N
101738	1726	716592477000	11607	5971	0	0	\N
101739	1726	716591476000	11607	5971	1	0	\N
101751	1769	1709900000	11613	5928	0	0	\N
101752	1397	1371493283000	11613	5928	1	0	\N
101753	1397	1371483282000	11613	5928	2	0	\N
101754	1397	1371473281000	11613	5928	3	0	\N
101755	1397	1371463280000	11613	5928	4	0	\N
101756	1397	1371453279000	11613	5928	5	0	\N
101757	1397	1371443278000	11613	5928	6	0	\N
101758	1726	716647532000	11613	5928	7	0	\N
101759	1726	716646531000	11613	5928	8	0	\N
101760	1726	716645530000	11613	5928	9	0	\N
101761	1726	716644529000	11613	5928	10	0	\N
101762	1726	716643528000	11613	5928	11	0	\N
101763	1726	716642527000	11613	5928	12	0	\N
101764	1726	716641526000	11613	5928	13	0	\N
101765	1726	716640525000	11613	5928	14	0	\N
101766	1726	716639524000	11613	5928	15	0	\N
101767	1726	716638523000	11613	5928	16	0	\N
101768	1726	716637522000	11613	5928	17	0	\N
101769	1726	716636521000	11613	5928	18	0	\N
101770	1726	716635520000	11613	5928	19	0	\N
101771	1726	716634519000	11613	5928	20	0	\N
101772	1726	716633518000	11613	5928	21	0	\N
101773	1726	716632517000	11613	5928	22	0	\N
101774	1726	716631516000	11613	5928	23	0	\N
101775	1726	716630515000	11613	5928	24	0	\N
101776	1726	716629514000	11613	5928	25	0	\N
101777	1726	716628513000	11613	5928	26	0	\N
101778	1726	716627512000	11613	5928	27	0	\N
101779	1726	716626511000	11613	5928	28	0	\N
101780	1726	716625510000	11613	5928	29	0	\N
101781	1726	716624509000	11613	5928	30	0	\N
101782	1726	716623508000	11613	5928	31	0	\N
101783	1726	716622507000	11613	5928	32	0	\N
101784	1726	716621506000	11613	5928	33	0	\N
101785	1726	716620505000	11613	5928	34	0	\N
101786	1726	716619504000	11613	5928	35	0	\N
101787	1726	716618503000	11613	5928	36	0	\N
101788	1726	716617502000	11613	5928	37	0	\N
101789	1726	716616501000	11613	5928	38	0	\N
101790	1726	716615500000	11613	5928	39	0	\N
101791	1726	716614499000	11613	5928	40	0	\N
101792	1726	716613498000	11613	5928	41	0	\N
101793	1726	716612497000	11613	5928	42	0	\N
101794	1726	716611496000	11613	5928	43	0	\N
101795	1726	716610495000	11613	5928	44	0	\N
101796	1726	716609494000	11613	5928	45	0	\N
101797	1726	716608493000	11613	5928	46	0	\N
101798	1726	716607492000	11613	5928	47	0	\N
101799	1726	716606491000	11613	5928	48	0	\N
101800	1726	716605490000	11613	5928	49	0	\N
101801	1726	716604489000	11613	5928	50	0	\N
101802	1726	716603488000	11613	5928	51	0	\N
101803	1726	716602487000	11613	5928	52	0	\N
101804	1726	716601486000	11613	5928	53	0	\N
101805	1726	716600485000	11613	5928	54	0	\N
101806	1726	716599484000	11613	5928	55	0	\N
101807	1726	716598483000	11613	5928	56	0	\N
101808	1726	716597482000	11613	5928	57	0	\N
101809	1726	716596481000	11613	5928	58	0	\N
101810	1726	716595480000	11613	5928	59	0	\N
101811	1726	716594479000	11613	5928	60	0	\N
101812	1726	716593478000	11613	5928	61	0	\N
101813	1726	716592477000	11613	5928	62	0	\N
101814	1726	716591476000	11613	5928	63	0	\N
101815	1726	716590475000	11613	5928	64	0	\N
101816	1726	716589474000	11613	5928	65	0	\N
101817	1726	716588473000	11613	5928	66	0	\N
101818	1726	716587472000	11613	5928	67	0	\N
101819	1726	716586471000	11613	5928	68	0	\N
101820	1726	716585470000	11613	5928	69	0	\N
101821	1726	716584469000	11613	5928	70	0	\N
101822	1726	716583468000	11613	5928	71	0	\N
101823	1726	716582467000	11613	5928	72	0	\N
101825	1726	716581466000	11615	5976	0	0	\N
101828	1726	716580465000	11618	5977	0	0	\N
101829	1726	716579464000	11618	5977	1	0	\N
101834	1726	716574459000	11621	5981	0	0	\N
101835	1726	716574459000	11623	5982	0	0	\N
101836	1726	716573458000	11623	5982	1	0	\N
101837	1726	716572457000	11623	5982	2	0	\N
101849	1726	716565450000	11628	5985	0	0	\N
101850	1726	716565450000	11629	5985	0	0	\N
101852	1726	716564449000	11631	5986	0	0	\N
101853	1726	716564449000	11632	5986	0	0	\N
101855	1769	1709900000	11634	5907	0	0	\N
101856	1397	1371683302000	11634	5907	1	0	\N
101857	1397	1371673301000	11634	5907	2	0	\N
101858	1397	1371663300000	11634	5907	3	0	\N
101859	1397	1371653299000	11634	5907	4	0	\N
101860	1397	1371643298000	11634	5907	5	0	\N
101861	1397	1371633297000	11634	5907	6	0	\N
101862	1397	1371623296000	11634	5907	7	0	\N
101863	1397	1371613295000	11634	5907	8	0	\N
101864	1397	1371603294000	11634	5907	9	0	\N
101735	1726	716595480000	11605	5969	2	0	3755
101736	1726	716594479000	11606	5970	0	0	3756
101737	1726	716593478000	11606	5970	1	0	3757
101740	1726	716592477000	11608	5971	0	0	3758
101741	1726	716591476000	11608	5971	1	0	3759
101743	1726	716589474000	11609	5972	1	0	3761
101744	1726	716588473000	11609	5972	2	0	3762
101745	1726	716587472000	11610	5973	0	0	3763
101746	1726	716586471000	11611	5974	0	0	3764
101747	1726	716585470000	11611	5974	1	0	3765
101749	1726	716583468000	11612	5975	0	0	3767
101750	1726	716582467000	11612	5975	1	0	3768
101824	1726	716581466000	11614	5976	0	0	3769
101826	1726	716580465000	11616	5977	0	0	3770
101830	1726	716578463000	11619	5979	0	0	3772
101831	1726	716577462000	11619	5979	1	0	3773
101832	1726	716576461000	11619	5979	2	0	3774
101833	1726	716575460000	11620	5980	0	0	3775
101838	1726	716574459000	11624	5982	0	0	3776
101840	1726	716572457000	11624	5982	2	0	3778
101841	576	67955594938283	11625	5983	0	0	4
101842	1726	716571456000	11625	5983	1	0	3779
101843	1726	716570455000	11625	5983	2	0	3780
101844	1726	716569454000	11625	5983	3	0	3781
101846	1726	716567452000	11626	5984	0	0	3783
101847	1726	716566451000	11626	5984	1	0	3784
101848	1726	716565450000	11627	5985	0	0	3785
101851	1726	716564449000	11630	5986	0	0	3786
101865	1397	1371593293000	11634	5907	10	0	\N
101866	1397	1371583292000	11634	5907	11	0	\N
101867	1397	1371573291000	11634	5907	12	0	\N
101868	1397	1371563290000	11634	5907	13	0	\N
101869	1397	1371553289000	11634	5907	14	0	\N
101870	1397	1371543288000	11634	5907	15	0	\N
101871	1397	1371533287000	11634	5907	16	0	\N
101872	1397	1371523286000	11634	5907	17	0	\N
101873	1397	1371513285000	11634	5907	18	0	\N
101874	1397	1371503284000	11634	5907	19	0	\N
101875	1397	1371493283000	11634	5907	20	0	\N
101876	1397	1371483282000	11634	5907	21	0	\N
101877	1397	1371473281000	11634	5907	22	0	\N
101878	1397	1371463280000	11634	5907	23	0	\N
101879	1397	1371453279000	11634	5907	24	0	\N
101880	1397	1371443278000	11634	5907	25	0	\N
101881	1726	719086551000	11634	5907	26	0	\N
101882	1726	719085550000	11634	5907	27	0	\N
101883	1726	719084549000	11634	5907	28	0	\N
101884	1726	719083548000	11634	5907	29	0	\N
101885	1726	719082547000	11634	5907	30	0	\N
101886	1457	20487668400000	11634	5907	31	0	\N
101887	1457	17400939560000	11634	5907	32	0	\N
101888	1457	12825908800000	11634	5907	33	0	\N
101889	1457	4224170040000	11634	5907	34	0	\N
101890	1726	719081546000	11634	5907	35	0	\N
101891	1726	719080545000	11634	5907	36	0	\N
101892	1726	719079544000	11634	5907	37	0	\N
101893	1726	719078543000	11634	5907	38	0	\N
101894	1726	719077542000	11634	5907	39	0	\N
101895	1726	719076541000	11634	5907	40	0	\N
101896	1726	719075540000	11634	5907	41	0	\N
101897	1726	719074539000	11634	5907	42	0	\N
101898	1726	719073538000	11634	5907	43	0	\N
101899	1726	719072537000	11634	5907	44	0	\N
101900	1726	719071536000	11634	5907	45	0	\N
101901	1726	719070535000	11634	5907	46	0	\N
101902	1726	719069534000	11634	5907	47	0	\N
101903	1726	719068533000	11634	5907	48	0	\N
101904	1726	717858533000	11634	5907	49	0	\N
101905	1726	716648533000	11634	5907	50	0	\N
101906	1726	716647532000	11634	5907	51	0	\N
101907	1726	716646531000	11634	5907	52	0	\N
101908	1726	716645530000	11634	5907	53	0	\N
101909	1726	716644529000	11634	5907	54	0	\N
101910	1726	716643528000	11634	5907	55	0	\N
101911	1726	716642527000	11634	5907	56	0	\N
101912	1726	716641526000	11634	5907	57	0	\N
101913	1726	716640525000	11634	5907	58	0	\N
101914	1726	716639524000	11634	5907	59	0	\N
101915	1726	716638523000	11634	5907	60	0	\N
101916	1726	716637522000	11634	5907	61	0	\N
101917	1726	716636521000	11634	5907	62	0	\N
101918	1726	716635520000	11634	5907	63	0	\N
101919	1726	716634519000	11634	5907	64	0	\N
101920	1726	716633518000	11634	5907	65	0	\N
101921	1726	716632517000	11634	5907	66	0	\N
101922	1726	716631516000	11634	5907	67	0	\N
101923	1726	716630515000	11634	5907	68	0	\N
101924	1726	716629514000	11634	5907	69	0	\N
101925	1726	716628513000	11634	5907	70	0	\N
101926	1726	716627512000	11634	5907	71	0	\N
101927	1726	716626511000	11634	5907	72	0	\N
101928	1726	716625510000	11634	5907	73	0	\N
101929	1726	716624509000	11634	5907	74	0	\N
101930	1726	716623508000	11634	5907	75	0	\N
101931	1726	716622507000	11634	5907	76	0	\N
101932	1726	716621506000	11634	5907	77	0	\N
101933	1726	716620505000	11634	5907	78	0	\N
101934	1726	716619504000	11634	5907	79	0	\N
101935	1726	716618503000	11634	5907	80	0	\N
101936	1726	716617502000	11634	5907	81	0	\N
101937	1726	716616501000	11634	5907	82	0	\N
101938	1726	716615500000	11634	5907	84	0	\N
101939	1726	716614499000	11634	5907	85	0	\N
101940	1726	716613498000	11634	5907	86	0	\N
101941	1726	716612497000	11634	5907	87	0	\N
101942	1726	716611496000	11634	5907	88	0	\N
101943	1726	716610495000	11634	5907	89	0	\N
101944	1726	716609494000	11634	5907	90	0	\N
101945	1726	716608493000	11634	5907	91	0	\N
101946	1726	716607492000	11634	5907	92	0	\N
101947	1726	716606491000	11634	5907	93	0	\N
101948	1726	716605490000	11634	5907	94	0	\N
101949	1726	716604489000	11634	5907	95	0	\N
101950	1726	716603488000	11634	5907	96	0	\N
101951	1726	716602487000	11634	5907	97	0	\N
101952	1726	716601486000	11634	5907	98	0	\N
101953	1726	716600485000	11634	5907	99	0	\N
101954	1726	716599484000	11634	5907	100	0	\N
101955	1726	716598483000	11634	5907	101	0	\N
101956	1726	716597482000	11634	5907	102	0	\N
101957	1726	716596481000	11634	5907	103	0	\N
101958	1726	716595480000	11634	5907	104	0	\N
101959	1726	716594479000	11634	5907	105	0	\N
101960	1726	716593478000	11634	5907	106	0	\N
101961	1726	716592477000	11634	5907	107	0	\N
101962	1726	716591476000	11634	5907	108	0	\N
101963	1726	716590475000	11634	5907	109	0	\N
101964	1726	716589474000	11634	5907	110	0	\N
101965	1726	716588473000	11634	5907	111	0	\N
101966	1726	716587472000	11634	5907	112	0	\N
101967	1726	716562447000	11635	5988	0	0	\N
101968	1726	716561446000	11635	5988	1	0	\N
101969	1726	716560445000	11635	5988	2	0	\N
101970	1726	716559444000	11635	5988	3	0	\N
101978	1726	716557442000	11641	5991	0	0	\N
101979	1726	716556441000	11641	5991	1	0	\N
101980	1726	716555440000	11643	5992	0	0	\N
101981	1726	716555440000	11644	5992	0	0	\N
101982	1726	716555440000	11645	5992	0	0	\N
101984	1726	716554439000	11647	5993	0	0	\N
101985	1726	716553438000	11647	5993	1	0	\N
101986	1726	716554439000	11648	5993	0	0	\N
101987	1726	716553438000	11648	5993	1	0	\N
101988	1726	716554439000	11649	5993	0	0	\N
101989	1726	716553438000	11649	5993	1	0	\N
101990	1726	716554439000	11650	5993	0	0	\N
101991	1726	716553438000	11650	5993	1	0	\N
101994	1726	716554439000	11652	5993	0	0	\N
101995	1726	716553438000	11652	5993	1	0	\N
101996	1726	716552437000	11653	5994	0	0	\N
101998	1726	716552437000	11655	5994	0	0	\N
102000	1726	716551436000	11657	5995	0	0	\N
101973	1726	716560445000	11636	5988	2	0	3790
101974	1726	716559444000	11636	5988	3	0	3791
101975	1726	716558443000	11639	5990	0	0	3792
101976	1726	716557442000	11640	5991	0	0	3793
101977	1726	716556441000	11640	5991	1	0	3794
101992	1726	716554439000	11651	5993	0	0	3796
101993	1726	716553438000	11651	5993	1	0	3797
101997	1726	716552437000	11654	5994	0	0	3798
101999	1726	716551436000	11656	5995	0	0	3799
102002	1726	716550435000	11659	5996	0	0	\N
102003	1726	716549434000	11660	5997	0	0	\N
102010	1726	716544429000	11664	5999	0	0	\N
102011	1726	716544429000	11665	5999	0	0	\N
102012	1726	716544429000	11666	5999	0	0	\N
102013	1726	716544429000	11667	5999	0	0	\N
102014	1726	716544429000	11668	5999	0	0	\N
102015	1726	716544429000	11669	5999	0	0	\N
102016	1726	716544429000	11670	5999	0	0	\N
102017	1726	716544429000	11671	5999	0	0	\N
102024	1726	716539424000	11678	6004	0	0	\N
102025	1726	716539424000	11679	6004	0	0	\N
102040	2042	1550390000000	11683	6007	0	0	\N
102041	1717	15865277987543	11683	6007	1	0	\N
102042	1717	12040253293650	11683	6007	2	0	\N
102043	1717	9459429660887	11683	6007	3	0	\N
102044	1717	2267753000023	11683	6007	4	0	\N
102045	1726	716533418000	11683	6007	5	0	\N
102046	1726	716532417000	11683	6007	6	0	\N
102047	1726	716531416000	11683	6007	7	0	\N
102048	1726	716530415000	11683	6007	8	0	\N
102049	2042	1550390000000	11684	6007	0	0	\N
102050	1717	15865277987543	11684	6007	1	0	\N
102051	1717	12040253293650	11684	6007	2	0	\N
102052	1717	9459429660887	11684	6007	3	0	\N
102053	1717	2267753000023	11684	6007	4	0	\N
102054	1726	716533418000	11684	6007	5	0	\N
102055	1726	716532417000	11684	6007	6	0	\N
102056	1726	716531416000	11684	6007	7	0	\N
102057	1726	716530415000	11684	6007	8	0	\N
102058	2042	1550390000000	11685	6007	0	0	\N
102059	1717	15865277987543	11685	6007	1	0	\N
102060	1717	12040253293650	11685	6007	2	0	\N
102061	1717	9459429660887	11685	6007	3	0	\N
102062	1717	2267753000023	11685	6007	4	0	\N
102063	1726	716533418000	11685	6007	5	0	\N
102064	1726	716532417000	11685	6007	6	0	\N
102065	1726	716531416000	11685	6007	7	0	\N
102066	1726	716530415000	11685	6007	8	0	\N
102069	1726	716529414000	11687	6008	0	0	\N
102070	1726	716528413000	11687	6008	1	0	\N
102073	1726	716526411000	11690	6010	0	0	\N
102074	1726	716526411000	11691	6010	0	0	\N
102075	1726	716525410000	11692	6011	0	0	\N
102080	1726	716523408000	11696	6013	0	0	\N
102081	1726	716522407000	11696	6013	1	0	\N
102084	1726	716520405000	11699	6015	0	0	\N
102086	1726	716519404000	11701	6016	0	0	\N
102090	1726	716515400000	11705	6020	0	0	\N
102091	1726	716515400000	11706	6020	0	0	\N
102093	2042	1550390000000	11708	5963	0	0	\N
102094	576	67955594938283	11708	5963	1	0	\N
102095	411	66006400000000	11708	5963	2	0	\N
102096	1717	15865277987543	11708	5963	3	0	\N
102097	1717	12040253293650	11708	5963	4	0	\N
102098	1717	9459429660887	11708	5963	5	0	\N
102099	1717	2267753000023	11708	5963	6	0	\N
102103	1726	716511396000	11714	6024	0	0	\N
102106	1726	716510395000	11719	6025	0	0	\N
102108	2042	1550390000000	11721	6001	0	0	\N
102109	1717	15865277987543	11721	6001	1	0	\N
102110	1717	12040253293650	11721	6001	2	0	\N
102111	1717	9459429660887	11721	6001	3	0	\N
102112	1717	2267753000023	11721	6001	4	0	\N
102113	1726	716508393000	11726	6027	0	0	\N
102116	1726	716508393000	11728	6028	0	0	\N
102117	1726	716507392000	11728	6028	1	0	\N
102118	1726	716506391000	11729	6029	0	0	\N
102119	1726	716506391000	11730	6029	0	0	\N
102121	1726	716505390000	11732	6030	0	0	\N
102127	641	68061357200000	11735	6031	0	0	\N
102128	641	67787815600000	11735	6031	1	0	\N
102129	641	66866252400000	11735	6031	2	0	\N
102130	641	66535460000000	11735	6031	3	0	\N
102131	1726	716504389000	11735	6031	4	0	\N
102132	1726	716503388000	11735	6031	5	0	\N
102133	1726	716502387000	11735	6031	6	0	\N
102134	641	68061357200000	11736	6031	0	0	\N
102135	641	67787815600000	11736	6031	1	0	\N
102136	641	66866252400000	11736	6031	2	0	\N
102005	411	66006400000000	11663	5998	0	0	6
102006	1726	716548433000	11663	5998	1	0	3802
102007	1726	716547432000	11663	5998	2	0	3803
102008	1726	716546431000	11663	5998	3	0	3804
102009	1726	716545430000	11663	5998	4	0	3805
102019	1726	716543428000	11673	6000	0	0	3807
102020	1726	716542427000	11674	6001	0	0	3808
102021	1726	716541426000	11675	6002	0	0	3809
102022	1726	716540425000	11676	6003	0	0	3810
102023	1726	716539424000	11677	6004	0	0	3811
102027	1726	716537422000	11680	6005	1	0	3813
102028	1726	716536421000	11680	6005	2	0	3814
102029	1726	716535420000	11681	6006	0	0	3815
102030	1726	716534419000	11681	6006	1	0	3816
102032	1717	15865277987543	11682	6007	1	0	1
102033	1717	12040253293650	11682	6007	2	0	2
102034	1717	9459429660887	11682	6007	3	0	3
102035	1717	2267753000023	11682	6007	4	0	4
102036	1726	716533418000	11682	6007	5	0	3817
102038	1726	716531416000	11682	6007	7	0	3819
102039	1726	716530415000	11682	6007	8	0	3820
102067	1726	716529414000	11686	6008	0	0	3821
102068	1726	716528413000	11686	6008	1	0	3822
102071	1726	716527412000	11688	6009	0	0	3823
102076	1726	716525410000	11693	6011	0	0	3825
102077	1726	716524409000	11694	6012	0	0	3826
102078	1726	716523408000	11695	6013	0	0	3827
102079	1726	716522407000	11695	6013	1	0	3828
102083	1726	716520405000	11698	6015	0	0	3830
102085	1726	716519404000	11700	6016	0	0	3831
102087	1726	716518403000	11702	6017	0	0	3832
102088	1726	716517402000	11703	6018	0	0	3833
102089	1726	716516401000	11704	6019	0	0	3834
102100	1726	716514399000	11711	6022	0	0	3836
102101	1726	716513398000	11711	6022	1	0	3837
102102	1726	716512397000	11712	6023	0	0	3838
102104	1726	716511396000	11715	6024	0	0	3839
102105	1726	716510395000	11718	6025	0	0	3840
102114	1726	716508393000	11727	6028	0	0	3842
102115	1726	716507392000	11727	6028	1	0	3843
102120	1726	716506391000	11731	6029	0	0	3844
102122	1726	716505390000	11733	6030	0	0	3845
102124	641	67787815600000	11734	6031	1	0	6
102125	641	66866252400000	11734	6031	2	0	7
102126	641	66535460000000	11734	6031	3	0	8
102137	641	66535460000000	11736	6031	3	0	\N
102138	1726	716504389000	11736	6031	4	0	\N
102139	1726	716503388000	11736	6031	5	0	\N
102140	1726	716502387000	11736	6031	6	0	\N
102141	641	68061357200000	11737	6031	0	0	\N
102142	641	67787815600000	11737	6031	1	0	\N
102143	641	66866252400000	11737	6031	2	0	\N
102144	641	66535460000000	11737	6031	3	0	\N
102145	1726	716504389000	11737	6031	4	0	\N
102146	1726	716503388000	11737	6031	5	0	\N
102147	1726	716502387000	11737	6031	6	0	\N
102155	1726	715289384000	11742	6034	0	0	\N
102159	1726	715287382000	11745	6036	0	0	\N
102160	1726	715286381000	11745	6036	1	0	\N
102163	1726	715284379000	11748	6038	0	0	\N
102164	1726	715283378000	11749	6039	0	0	\N
102165	1726	715282377000	11749	6039	1	0	\N
102172	1726	715278373000	11757	6044	0	0	\N
102175	1726	715277372000	11759	6045	0	0	\N
102176	1726	715276371000	11759	6045	1	0	\N
102177	1726	715275370000	11760	6046	0	0	\N
102178	1726	715274369000	11760	6046	1	0	\N
102181	1726	715273368000	11762	6047	0	0	\N
102182	1726	715272367000	11762	6047	1	0	\N
102191	1686	12873315312881	11766	6050	0	0	\N
102192	1726	715268363000	11766	6050	1	0	\N
102193	1686	12873315312881	11767	6050	0	0	\N
102194	1726	715268363000	11767	6050	1	0	\N
102197	1686	9716663827101	11769	6051	0	0	\N
102198	1686	7586804916122	11769	6051	1	0	\N
102199	1726	715267362000	11769	6051	2	0	\N
102205	1686	1651781550062	11772	6052	0	0	\N
102206	1726	715266361000	11772	6052	1	0	\N
102207	2042	1550390000000	11773	5929	0	0	\N
102208	1686	15097674705523	11773	5929	1	0	\N
102209	1686	14866263563482	11773	5929	2	0	\N
102210	411	66006400000000	11773	5929	3	0	\N
102211	641	68061357200000	11773	5929	4	0	\N
102212	1686	14634852421441	11773	5929	5	0	\N
102213	1686	12873315312881	11773	5929	6	0	\N
102214	1686	9716663827101	11773	5929	7	0	\N
102215	1686	7586804916122	11773	5929	8	0	\N
102216	1686	1651781550062	11773	5929	9	0	\N
102217	1717	15865277987543	11773	5929	10	0	\N
102218	1717	12040253293650	11773	5929	11	0	\N
102219	1717	9459429660887	11773	5929	12	0	\N
102220	1717	2267753000023	11773	5929	13	0	\N
102221	641	67787815600000	11773	5929	14	0	\N
102222	641	66866252400000	11773	5929	15	0	\N
102223	641	66535460000000	11773	5929	16	0	\N
102224	1726	716581466000	11773	5929	17	0	\N
102225	1726	716580465000	11773	5929	18	0	\N
102226	1726	716579464000	11773	5929	19	0	\N
102227	1726	716578463000	11773	5929	20	0	\N
102228	1726	716577462000	11773	5929	21	0	\N
102229	1726	716576461000	11773	5929	22	0	\N
102230	1726	716575460000	11773	5929	23	0	\N
102231	1726	716574459000	11773	5929	24	0	\N
102232	1726	716573458000	11773	5929	25	0	\N
102233	1726	716572457000	11773	5929	26	0	\N
102234	1726	716571456000	11773	5929	27	0	\N
102235	1726	716570455000	11773	5929	28	0	\N
102236	1726	716569454000	11773	5929	29	0	\N
102237	1726	716568453000	11773	5929	30	0	\N
102238	1726	716567452000	11773	5929	31	0	\N
102239	1726	716566451000	11773	5929	32	0	\N
102240	1726	716565450000	11773	5929	33	0	\N
102241	1726	716564449000	11773	5929	34	0	\N
102242	1726	716563448000	11773	5929	35	0	\N
102243	1726	716562447000	11773	5929	36	0	\N
102244	1726	716561446000	11773	5929	37	0	\N
102245	1726	716560445000	11773	5929	38	0	\N
102246	1726	716559444000	11773	5929	39	0	\N
102247	1726	716558443000	11773	5929	40	0	\N
102248	1726	716557442000	11773	5929	41	0	\N
102249	1726	716556441000	11773	5929	42	0	\N
102250	1726	716555440000	11773	5929	43	0	\N
102251	1726	716554439000	11773	5929	44	0	\N
102252	1726	716553438000	11773	5929	45	0	\N
102253	1726	716552437000	11773	5929	46	0	\N
102254	1726	716551436000	11773	5929	47	0	\N
102255	1726	716550435000	11773	5929	48	0	\N
102256	1726	716549434000	11773	5929	49	0	\N
102257	1726	716548433000	11773	5929	50	0	\N
102258	1726	716547432000	11773	5929	52	0	\N
102259	1726	716546431000	11773	5929	53	0	\N
102260	1726	716545430000	11773	5929	54	0	\N
102261	1726	716544429000	11773	5929	55	0	\N
102262	1726	716543428000	11773	5929	56	0	\N
102263	1726	716542427000	11773	5929	57	0	\N
102264	1726	716541426000	11773	5929	58	0	\N
102265	1726	716540425000	11773	5929	59	0	\N
102266	1726	716539424000	11773	5929	60	0	\N
102267	1726	716538423000	11773	5929	61	0	\N
102268	1726	716537422000	11773	5929	62	0	\N
102269	1726	716536421000	11773	5929	63	0	\N
102270	1726	716535420000	11773	5929	64	0	\N
102271	1726	716534419000	11773	5929	65	0	\N
102272	1726	716533418000	11773	5929	66	0	\N
102150	1726	716502387000	11739	6032	2	0	3848
102151	1726	716501386000	11739	6032	3	0	3849
102152	1726	715291386000	11739	6032	4	0	3850
102153	1726	715290385000	11740	6033	0	0	3851
102154	1726	715289384000	11741	6034	0	0	3852
102157	1726	715287382000	11744	6036	0	0	3854
102158	1726	715286381000	11744	6036	1	0	3855
102161	1726	715285380000	11746	6037	0	0	3856
102162	1726	715284379000	11747	6038	0	0	3857
102166	1726	715283378000	11750	6039	0	0	3858
102168	1726	715281376000	11751	6040	0	0	3860
102169	1726	715280375000	11752	6041	0	0	3861
102170	1726	715279374000	11755	6043	0	0	3862
102171	1726	715278373000	11756	6044	0	0	3863
102174	1726	715276371000	11758	6045	1	0	3865
102179	1726	715275370000	11761	6046	0	0	3866
102180	1726	715274369000	11761	6046	1	0	3867
102183	1726	715273368000	11763	6047	0	0	3868
102184	1726	715272367000	11763	6047	1	0	3869
102186	1686	14866263563482	11764	6048	1	0	4
102187	1726	715271366000	11764	6048	2	0	3870
102188	1726	715270365000	11764	6048	3	0	3871
102189	1686	14634852421441	11765	6049	0	0	5
102190	1726	715269364000	11765	6049	1	0	3872
102196	1726	715268363000	11768	6050	1	0	3873
102200	1686	9716663827101	11770	6051	0	0	7
102201	1686	7586804916122	11770	6051	1	0	8
102202	1726	715267362000	11770	6051	2	0	3874
102204	1726	715266361000	11771	6052	1	0	3875
102273	1726	716532417000	11773	5929	67	0	\N
102274	1726	716531416000	11773	5929	68	0	\N
102275	1726	716530415000	11773	5929	69	0	\N
102276	1726	716529414000	11773	5929	70	0	\N
102277	1726	716528413000	11773	5929	71	0	\N
102278	1726	716527412000	11773	5929	72	0	\N
102279	1726	716526411000	11773	5929	73	0	\N
102280	1726	716525410000	11773	5929	74	0	\N
102281	1726	716524409000	11773	5929	75	0	\N
102282	1726	716523408000	11773	5929	76	0	\N
102283	1726	716522407000	11773	5929	77	0	\N
102284	1726	716521406000	11773	5929	78	0	\N
102285	1726	716520405000	11773	5929	79	0	\N
102286	1726	716519404000	11773	5929	80	0	\N
102287	1726	716518403000	11773	5929	81	0	\N
102288	1726	716517402000	11773	5929	82	0	\N
102289	1726	716516401000	11773	5929	83	0	\N
102290	1726	716515400000	11773	5929	84	0	\N
102291	1726	716514399000	11773	5929	85	0	\N
102292	1726	716513398000	11773	5929	86	0	\N
102293	1726	716512397000	11773	5929	87	0	\N
102294	1726	716511396000	11773	5929	88	0	\N
102295	1726	716510395000	11773	5929	89	0	\N
102296	1726	716509394000	11773	5929	90	0	\N
102297	1726	716508393000	11773	5929	91	0	\N
102298	1726	716507392000	11773	5929	92	0	\N
102299	1726	716506391000	11773	5929	93	0	\N
102300	1726	716505390000	11773	5929	94	0	\N
102301	1726	716504389000	11773	5929	95	0	\N
102302	1726	716503388000	11773	5929	96	0	\N
102303	1726	716502387000	11773	5929	97	0	\N
102304	1726	716501386000	11773	5929	98	0	\N
102305	1726	715291386000	11773	5929	99	0	\N
102306	1726	715290385000	11773	5929	100	0	\N
102307	1726	715289384000	11773	5929	101	0	\N
102308	1726	715288383000	11773	5929	102	0	\N
102309	1726	715287382000	11773	5929	103	0	\N
102310	1726	715286381000	11773	5929	104	0	\N
102311	1726	715285380000	11773	5929	105	0	\N
102312	1726	715284379000	11773	5929	106	0	\N
102313	1726	715283378000	11773	5929	107	0	\N
102314	1726	715282377000	11773	5929	108	0	\N
102315	1726	715281376000	11773	5929	109	0	\N
102316	1726	715280375000	11773	5929	110	0	\N
102317	1726	715279374000	11773	5929	111	0	\N
102318	1726	715278373000	11773	5929	112	0	\N
102319	1726	715277372000	11773	5929	113	0	\N
102320	1726	715276371000	11773	5929	114	0	\N
102321	1726	715275370000	11773	5929	115	0	\N
102322	1726	715274369000	11773	5929	116	0	\N
102323	1726	715273368000	11773	5929	117	0	\N
102324	1726	715272367000	11773	5929	118	0	\N
102325	1726	715271366000	11773	5929	119	0	\N
102326	1726	715270365000	11773	5929	120	0	\N
102327	1726	715269364000	11773	5929	121	0	\N
102328	1726	715268363000	11773	5929	122	0	\N
102329	1726	715267362000	11773	5929	123	0	\N
102330	1726	715266361000	11773	5929	124	0	\N
102331	1686	1651781550062	11774	6052	0	0	\N
102332	1726	715266361000	11774	6052	1	0	\N
102333	1726	715265360000	11774	6052	2	0	\N
102339	1726	715261356000	11778	6056	0	0	\N
102340	1726	715261356000	11779	6056	0	0	\N
102342	1726	715260355000	11781	6057	0	0	\N
102343	1726	715260355000	11782	6057	0	0	\N
102344	1726	715260355000	11783	6057	0	0	\N
102348	1726	715259354000	11787	6058	0	0	\N
102349	1726	715258353000	11787	6058	1	0	\N
102350	1726	715259354000	11788	6058	0	0	\N
102351	1726	715258353000	11788	6058	1	0	\N
102352	2042	1550390000000	11789	5945	0	0	\N
102353	1686	15097674705523	11789	5945	1	0	\N
102354	1686	14866263563482	11789	5945	2	0	\N
102355	411	66006400000000	11789	5945	3	0	\N
102356	641	68061357200000	11789	5945	4	0	\N
102357	1686	14634852421441	11789	5945	5	0	\N
102358	1686	12873315312881	11789	5945	6	0	\N
102359	1686	9716663827101	11789	5945	7	0	\N
102360	1686	7586804916122	11789	5945	8	0	\N
102361	1686	1651781550062	11789	5945	9	0	\N
102362	1717	15865277987543	11789	5945	10	0	\N
102363	1717	12040253293650	11789	5945	11	0	\N
102364	1717	9459429660887	11789	5945	12	0	\N
102365	1717	2267753000023	11789	5945	13	0	\N
102366	641	67787815600000	11789	5945	14	0	\N
102367	641	66866252400000	11789	5945	15	0	\N
102368	641	66535460000000	11789	5945	16	0	\N
102369	1726	716624509000	11789	5945	17	0	\N
102370	1726	716623508000	11789	5945	18	0	\N
102371	1726	716622507000	11789	5945	19	0	\N
102372	1726	716621506000	11789	5945	20	0	\N
102373	1726	716620505000	11789	5945	21	0	\N
102374	1726	716619504000	11789	5945	22	0	\N
102375	1726	716618503000	11789	5945	23	0	\N
102376	1525	1000000	11789	5945	24	0	\N
102377	1726	716617502000	11789	5945	25	0	\N
102378	1726	716616501000	11789	5945	26	0	\N
102379	1726	716615500000	11789	5945	27	0	\N
102380	1726	716614499000	11789	5945	28	0	\N
102381	1726	716613498000	11789	5945	29	0	\N
102382	1726	716612497000	11789	5945	30	0	\N
102383	1726	716611496000	11789	5945	31	0	\N
102384	1726	716610495000	11789	5945	32	0	\N
102385	1726	716609494000	11789	5945	33	0	\N
102386	1726	716608493000	11789	5945	34	0	\N
102387	1726	716607492000	11789	5945	35	0	\N
102388	1726	716606491000	11789	5945	36	0	\N
102389	1726	716605490000	11789	5945	37	0	\N
102390	1726	716604489000	11789	5945	38	0	\N
102391	1726	716603488000	11789	5945	39	0	\N
102392	1726	716602487000	11789	5945	40	0	\N
102393	1726	716601486000	11789	5945	41	0	\N
102394	1726	716600485000	11789	5945	42	0	\N
102395	1726	716599484000	11789	5945	43	0	\N
102396	1726	716598483000	11789	5945	44	0	\N
102397	1726	716597482000	11789	5945	45	0	\N
102398	1726	716596481000	11789	5945	46	0	\N
102399	1737	1299001100	11789	5945	47	0	\N
102400	1726	716595480000	11789	5945	48	0	\N
102401	1726	716594479000	11789	5945	49	0	\N
102402	1726	716593478000	11789	5945	50	0	\N
102403	1726	716592477000	11789	5945	51	0	\N
102404	1726	716591476000	11789	5945	52	0	\N
102405	1726	716590475000	11789	5945	53	0	\N
102406	1726	716589474000	11789	5945	54	0	\N
102407	1726	716588473000	11789	5945	55	0	\N
102408	1726	716587472000	11789	5945	56	0	\N
102336	1726	715264359000	11776	6054	0	0	3877
102337	1726	715263358000	11776	6054	1	0	3878
102338	1726	715262357000	11777	6055	0	0	3879
102341	1726	715261356000	11780	6056	0	0	3880
102345	1726	715260355000	11784	6057	0	0	3881
102347	1726	715258353000	11785	6058	1	0	3883
102409	1726	716586471000	11789	5945	57	0	\N
102410	1726	716585470000	11789	5945	58	0	\N
102411	1726	716584469000	11789	5945	59	0	\N
102412	1726	716583468000	11789	5945	60	0	\N
102413	1726	716582467000	11789	5945	61	0	\N
102414	1726	716581466000	11789	5945	62	0	\N
102415	1726	716580465000	11789	5945	64	0	\N
102416	1726	716579464000	11789	5945	65	0	\N
102417	1726	716578463000	11789	5945	66	0	\N
102418	1726	716577462000	11789	5945	67	0	\N
102419	1726	716576461000	11789	5945	68	0	\N
102420	1726	716575460000	11789	5945	69	0	\N
102421	1726	716574459000	11789	5945	70	0	\N
102422	1726	716573458000	11789	5945	71	0	\N
102423	1726	716572457000	11789	5945	72	0	\N
102424	1726	716571456000	11789	5945	73	0	\N
102425	1726	716570455000	11789	5945	74	0	\N
102426	1726	716569454000	11789	5945	75	0	\N
102427	1726	716568453000	11789	5945	76	0	\N
102428	1726	716567452000	11789	5945	77	0	\N
102429	1726	716566451000	11789	5945	78	0	\N
102430	1726	716565450000	11789	5945	79	0	\N
102431	1726	716564449000	11789	5945	80	0	\N
102432	1726	716563448000	11789	5945	81	0	\N
102433	1726	716562447000	11789	5945	82	0	\N
102434	1726	716561446000	11789	5945	83	0	\N
102435	1726	716560445000	11789	5945	84	0	\N
102436	1726	716559444000	11789	5945	85	0	\N
102437	1726	716558443000	11789	5945	86	0	\N
102438	1726	716557442000	11789	5945	87	0	\N
102439	1726	716556441000	11789	5945	88	0	\N
102440	1726	716555440000	11789	5945	89	0	\N
102441	1726	716554439000	11789	5945	90	0	\N
102442	1726	716553438000	11789	5945	91	0	\N
102443	1726	716552437000	11789	5945	92	0	\N
102444	1726	716551436000	11789	5945	93	0	\N
102445	1726	716550435000	11789	5945	94	0	\N
102446	1726	716549434000	11789	5945	95	0	\N
102447	1726	716548433000	11789	5945	96	0	\N
102448	1726	716547432000	11789	5945	97	0	\N
102449	1726	716546431000	11789	5945	98	0	\N
102450	1726	716545430000	11789	5945	99	0	\N
102451	1726	716544429000	11789	5945	100	0	\N
102452	1726	716543428000	11789	5945	101	0	\N
102453	1726	716542427000	11789	5945	102	0	\N
102454	1726	716541426000	11789	5945	103	0	\N
102455	1726	716540425000	11789	5945	104	0	\N
102456	1726	716539424000	11789	5945	105	0	\N
102457	1726	716538423000	11789	5945	106	0	\N
102458	1726	716537422000	11789	5945	107	0	\N
102459	1726	716536421000	11789	5945	108	0	\N
102460	1726	716535420000	11789	5945	109	0	\N
102461	1726	716534419000	11789	5945	110	0	\N
102462	1726	716533418000	11789	5945	111	0	\N
102463	1726	716532417000	11789	5945	112	0	\N
102464	1726	716531416000	11789	5945	113	0	\N
102465	1726	716530415000	11789	5945	114	0	\N
102466	1726	716529414000	11789	5945	115	0	\N
102467	1726	716528413000	11789	5945	116	0	\N
102468	1726	716527412000	11789	5945	117	0	\N
102469	1726	716526411000	11789	5945	118	0	\N
102470	1726	716525410000	11789	5945	119	0	\N
102471	1726	716524409000	11789	5945	120	0	\N
102472	1726	716523408000	11789	5945	121	0	\N
102473	1726	716522407000	11789	5945	122	0	\N
102474	1726	716521406000	11789	5945	123	0	\N
102475	1726	716520405000	11789	5945	124	0	\N
102476	1726	716519404000	11789	5945	125	0	\N
102480	1726	715256351000	11792	6060	0	0	\N
102481	1726	715255350000	11792	6060	1	0	\N
102482	1726	715254349000	11793	6061	0	0	\N
102484	1726	715254349000	11795	6061	0	0	\N
102485	2042	1550390000000	11796	5819	0	0	\N
102486	1686	15097674705523	11796	5819	1	0	\N
102487	1686	14866263563482	11796	5819	2	0	\N
102488	411	66006400000000	11796	5819	3	0	\N
102489	1397	1371773311000	11796	5819	4	0	\N
102490	1397	1371763310000	11796	5819	5	0	\N
102491	1397	1371753309000	11796	5819	6	0	\N
102492	1397	1371743308000	11796	5819	7	0	\N
102493	1397	1371733307000	11796	5819	8	0	\N
102494	1397	1371723306000	11796	5819	9	0	\N
102495	1397	1371713305000	11796	5819	10	0	\N
102496	1397	1371703304000	11796	5819	11	0	\N
102497	1397	1371693303000	11796	5819	12	0	\N
102498	1397	1371683302000	11796	5819	13	0	\N
102499	1397	1371673301000	11796	5819	14	0	\N
102500	1397	1371663300000	11796	5819	15	0	\N
102501	1397	1371653299000	11796	5819	16	0	\N
102502	1397	1371643298000	11796	5819	17	0	\N
102503	1397	1371633297000	11796	5819	18	0	\N
102504	1397	1371623296000	11796	5819	19	0	\N
102505	1397	1371613295000	11796	5819	20	0	\N
102506	1397	1371603294000	11796	5819	21	0	\N
102507	641	68061357200000	11796	5819	22	0	\N
102508	1686	14634852421441	11796	5819	23	0	\N
102509	1686	12873315312881	11796	5819	24	0	\N
102510	1686	9716663827101	11796	5819	25	0	\N
102511	1686	7586804916122	11796	5819	26	0	\N
102512	1686	1651781550062	11796	5819	27	0	\N
102513	1717	15865277987543	11796	5819	28	0	\N
102514	1717	12040253293650	11796	5819	29	0	\N
102515	1717	9459429660887	11796	5819	30	0	\N
102516	1717	2267753000023	11796	5819	31	0	\N
102517	1397	1371593293000	11796	5819	33	0	\N
102518	1397	1371583292000	11796	5819	34	0	\N
102519	1397	1371573291000	11796	5819	35	0	\N
102520	1397	1371563290000	11796	5819	36	0	\N
102521	1397	1371553289000	11796	5819	37	0	\N
102522	1397	1371543288000	11796	5819	38	0	\N
102523	1397	1371533287000	11796	5819	39	0	\N
102524	1397	1371523286000	11796	5819	40	0	\N
102525	1397	1371513285000	11796	5819	41	0	\N
102526	1397	1371503284000	11796	5819	42	0	\N
102527	1397	1371493283000	11796	5819	43	0	\N
102528	1397	1371483282000	11796	5819	44	0	\N
102529	1397	1371473281000	11796	5819	45	0	\N
102530	1397	1371463280000	11796	5819	46	0	\N
102531	1397	1371453279000	11796	5819	47	0	\N
102532	1397	1371443278000	11796	5819	48	0	\N
102533	641	67787815600000	11796	5819	49	0	\N
102534	641	66866252400000	11796	5819	50	0	\N
102535	641	66535460000000	11796	5819	51	0	\N
102536	1704	65194000000	11796	5819	52	0	\N
102537	1747	8734807000000	11796	5819	53	0	\N
102538	1747	736806000000	11796	5819	54	0	\N
102539	1726	722847682000	11796	5819	55	0	\N
102540	1726	722846681000	11796	5819	56	0	\N
102541	1769	1719900000	11796	5819	57	0	\N
102542	1769	1709900000	11796	5819	58	0	\N
102543	1422	3744970860211	11796	5819	59	0	\N
102544	1775	1943000000	11796	5819	60	0	\N
102479	1726	715255350000	11791	6060	1	0	3886
102483	1726	715254349000	11794	6061	0	0	3887
102545	1775	1932000000	11796	5819	61	0	\N
102546	1775	1931000000	11796	5819	62	0	\N
102547	1775	1920000000	11796	5819	63	0	\N
102548	1775	1919000000	11796	5819	64	0	\N
102549	1775	1917000000	11796	5819	65	0	\N
102550	1457	20487668400000	11796	5819	66	0	\N
102551	1457	17400939560000	11796	5819	67	0	\N
102552	1457	12825908800000	11796	5819	68	0	\N
102553	1457	4224170040000	11796	5819	69	0	\N
102554	1726	722845680000	11796	5819	70	0	\N
102555	1737	1299001100	11796	5819	71	0	\N
102556	1746	6488300000000	11796	5819	72	0	\N
102557	1746	4114299000000	11796	5819	73	0	\N
102558	1726	722844679000	11796	5819	74	0	\N
102559	1726	722843678000	11796	5819	75	0	\N
102560	1726	722842677000	11796	5819	76	0	\N
102561	1726	722841676000	11796	5819	77	0	\N
102562	1726	722840675000	11796	5819	78	0	\N
102563	1726	722839674000	11796	5819	79	0	\N
102564	1726	722838673000	11796	5819	80	0	\N
102565	1726	722837672000	11796	5819	81	0	\N
102566	1726	722836671000	11796	5819	82	0	\N
102567	1726	722835670000	11796	5819	83	0	\N
102568	1726	722834669000	11796	5819	84	0	\N
102569	1726	722833668000	11796	5819	85	0	\N
102570	1726	722832667000	11796	5819	86	0	\N
102571	1726	722831666000	11796	5819	87	0	\N
102572	1726	722830665000	11796	5819	88	0	\N
102573	1726	722829664000	11796	5819	89	0	\N
102574	1726	722828663000	11796	5819	90	0	\N
102575	1726	722827662000	11796	5819	91	0	\N
102576	1726	722826661000	11796	5819	92	0	\N
102577	1726	722825660000	11796	5819	93	0	\N
102578	1726	722824659000	11796	5819	94	0	\N
102579	1726	722823658000	11796	5819	95	0	\N
102580	1726	722822657000	11796	5819	96	0	\N
102581	1726	722821656000	11796	5819	97	0	\N
102582	1726	722820655000	11796	5819	98	0	\N
102583	1726	722819654000	11796	5819	99	0	\N
102584	1726	722818653000	11796	5819	100	0	\N
102585	1726	722817652000	11796	5819	101	0	\N
102586	1726	722816651000	11796	5819	102	0	\N
102587	1726	722815650000	11796	5819	103	0	\N
102588	1726	722814649000	11796	5819	104	0	\N
102589	1726	722813648000	11796	5819	105	0	\N
102590	1726	722812647000	11796	5819	106	0	\N
102591	1726	722811646000	11796	5819	107	0	\N
102592	1726	722810645000	11796	5819	108	0	\N
102593	1726	722809644000	11796	5819	109	0	\N
102594	1726	722808643000	11796	5819	110	0	\N
102595	1726	722807642000	11796	5819	111	0	\N
102596	1726	722806641000	11796	5819	112	0	\N
102597	1726	722805640000	11796	5819	113	0	\N
102598	1726	722804639000	11796	5819	114	0	\N
102599	1726	722803638000	11796	5819	115	0	\N
102600	1726	722802637000	11796	5819	116	0	\N
102601	1726	722801636000	11796	5819	117	0	\N
102602	1726	722800635000	11796	5819	118	0	\N
102603	1726	722799634000	11796	5819	119	0	\N
102604	1726	722798633000	11796	5819	120	0	\N
102605	1726	722797632000	11796	5819	121	0	\N
102606	1726	722796631000	11796	5819	122	0	\N
102607	1726	722795630000	11796	5819	123	0	\N
102608	1726	722794629000	11796	5819	124	0	\N
102612	1726	715250345000	11800	6065	0	0	\N
102613	1726	715249344000	11800	6065	1	0	\N
102617	1726	715247342000	11803	6067	0	0	\N
102618	1726	715247342000	11804	6067	0	0	\N
102619	1726	715247342000	11805	6067	0	0	\N
102620	1726	715247342000	11806	6067	0	0	\N
102624	1726	715245340000	11810	6069	0	0	\N
102625	1726	715245340000	11811	6069	0	0	\N
102627	1726	715244339000	11813	6070	0	0	\N
102628	1726	715244339000	11814	6070	0	0	\N
102629	1726	715244339000	11815	6070	0	0	\N
102636	1726	715240335000	11819	6073	0	0	\N
102637	1726	715239334000	11819	6073	1	0	\N
102638	1726	715238333000	11819	6073	2	0	\N
102644	1726	715233328000	11825	6077	0	0	\N
102657	1726	715229324000	11828	6080	0	0	\N
102658	1726	715228323000	11828	6080	1	0	\N
102661	1726	715229324000	11830	6080	0	0	\N
102662	1726	715228323000	11830	6080	1	0	\N
102670	1726	715225320000	11833	6082	0	0	\N
102671	1726	715224319000	11833	6082	1	0	\N
102672	1726	715223318000	11833	6082	2	0	\N
102673	1726	715222317000	11833	6082	3	0	\N
102674	1726	715221316000	11833	6082	4	0	\N
102675	1726	715225320000	11834	6082	0	0	\N
102676	1726	715224319000	11834	6082	1	0	\N
102677	1726	715223318000	11834	6082	2	0	\N
102678	1726	715222317000	11834	6082	3	0	\N
102679	1726	715221316000	11834	6082	4	0	\N
102611	1726	715251346000	11799	6064	0	0	3890
102614	1726	715250345000	11801	6065	0	0	3891
102615	1726	715249344000	11801	6065	1	0	3892
102616	1726	715248343000	11802	6066	0	0	3893
102621	1726	715247342000	11807	6067	0	0	3894
102623	1726	715245340000	11809	6069	0	0	3896
102626	1726	715244339000	11812	6070	0	0	3897
102630	1726	715243338000	11816	6071	0	0	3898
102631	1726	715242337000	11817	6072	0	0	3899
102632	1726	715241336000	11817	6072	1	0	3900
102634	1726	715239334000	11818	6073	1	0	3902
102635	1726	715238333000	11818	6073	2	0	3903
102639	1726	715237332000	11820	6074	0	0	3904
102640	1726	715236331000	11821	6075	0	0	3905
102642	1726	715234329000	11822	6076	0	0	3907
102643	1726	715233328000	11824	6077	0	0	3908
102645	1634	23738831223333	11826	6078	0	0	1
102646	1634	23727961050489	11826	6078	1	0	2
102647	1634	23419794812544	11826	6078	2	0	3
102649	1634	22803462336654	11826	6078	4	0	5
102650	1634	20517008110328	11826	6078	5	0	6
102651	1634	16419709647008	11826	6078	6	0	7
102652	1634	13655177476572	11826	6078	7	0	8
102653	1634	5951580641004	11826	6078	8	0	9
102655	1726	715231326000	11826	6078	10	0	3910
102656	1726	715230325000	11827	6079	0	0	3911
102659	1726	715229324000	11829	6080	0	0	3912
102660	1726	715228323000	11829	6080	1	0	3913
102664	1726	715226321000	11831	6081	1	0	3915
102665	1726	715225320000	11832	6082	0	0	3916
102666	1726	715224319000	11832	6082	1	0	3917
102667	1726	715223318000	11832	6082	2	0	3918
102668	1726	715222317000	11832	6082	3	0	3919
102680	1726	715220315000	11835	6083	0	0	3921
102687	1726	714004309000	11838	6086	0	0	\N
102693	1726	714000305000	11843	6089	0	0	\N
102695	1726	713998303000	11845	6091	0	0	\N
102696	1726	713998303000	11846	6091	0	0	\N
102697	1726	713998303000	11847	6091	0	0	\N
102699	1726	712788303000	11850	6092	0	0	\N
102700	1726	712787302000	11850	6092	1	0	\N
102704	1634	23738831223333	11854	6068	0	0	\N
102705	1634	23727961050489	11854	6068	1	0	\N
102706	1634	23419794812544	11854	6068	2	0	\N
102707	1634	23111628574599	11854	6068	3	0	\N
102708	1634	22803462336654	11854	6068	4	0	\N
102709	1634	20517008110328	11854	6068	5	0	\N
102710	1634	16419709647008	11854	6068	6	0	\N
102711	1634	13655177476572	11854	6068	7	0	\N
102712	1634	5951580641004	11854	6068	8	0	\N
102713	1726	712786301000	11855	6093	0	0	\N
102716	1726	712785300000	11857	6094	0	0	\N
102717	1726	712784299000	11857	6094	1	0	\N
102719	1726	712782297000	11860	6096	0	0	\N
102721	1555	14828392276082	11862	6097	0	0	\N
102722	1726	712781296000	11862	6097	1	0	\N
102723	1726	712780295000	11862	6097	2	0	\N
102727	2042	1550390000000	11864	5918	0	0	\N
102728	1634	23738831223333	11864	5918	1	0	\N
102729	1397	1371603294000	11864	5918	2	0	\N
102730	1769	1709900000	11864	5918	3	0	\N
102731	1555	14108390276082	11864	5918	4	0	\N
102732	1686	15097674705523	11864	5918	5	0	\N
102733	1686	14866263563482	11864	5918	6	0	\N
102734	411	66006400000000	11864	5918	7	0	\N
102735	1634	23727961050489	11864	5918	8	0	\N
102736	641	68061357200000	11864	5918	9	0	\N
102737	1634	23419794812544	11864	5918	10	0	\N
102738	1686	14634852421441	11864	5918	11	0	\N
102739	1686	12873315312881	11864	5918	12	0	\N
102740	1686	9716663827101	11864	5918	13	0	\N
102741	1686	7586804916122	11864	5918	14	0	\N
102742	1686	1651781550062	11864	5918	15	0	\N
102743	1717	15865277987543	11864	5918	16	0	\N
102744	1717	12040253293650	11864	5918	17	0	\N
102745	1717	9459429660887	11864	5918	18	0	\N
102746	1717	2267753000023	11864	5918	19	0	\N
102747	1634	23111628574599	11864	5918	20	0	\N
102748	1634	22803462336654	11864	5918	21	0	\N
102749	1634	20517008110328	11864	5918	22	0	\N
102750	1634	16419709647008	11864	5918	23	0	\N
102751	1634	13655177476572	11864	5918	24	0	\N
102752	1634	5951580641004	11864	5918	25	0	\N
102753	1397	1371593293000	11864	5918	26	0	\N
102754	1397	1371583292000	11864	5918	27	0	\N
102755	1397	1371573291000	11864	5918	28	0	\N
102756	1397	1371563290000	11864	5918	29	0	\N
102757	1397	1371553289000	11864	5918	30	0	\N
102758	1397	1371543288000	11864	5918	31	0	\N
102759	1397	1371533287000	11864	5918	32	0	\N
102760	1397	1371523286000	11864	5918	33	0	\N
102761	1397	1371513285000	11864	5918	34	0	\N
102762	1397	1371503284000	11864	5918	35	0	\N
102763	1397	1371493283000	11864	5918	36	0	\N
102764	1397	1371483282000	11864	5918	37	0	\N
102765	1397	1371473281000	11864	5918	38	0	\N
102766	1397	1371463280000	11864	5918	39	0	\N
102767	1397	1371453279000	11864	5918	40	0	\N
102768	1397	1371443278000	11864	5918	41	0	\N
102769	641	67787815600000	11864	5918	42	0	\N
102770	641	66866252400000	11864	5918	43	0	\N
102771	641	66535460000000	11864	5918	44	0	\N
102772	1726	719078543000	11864	5918	45	0	\N
102773	1726	719077542000	11864	5918	47	0	\N
102774	1457	20487668400000	11864	5918	48	0	\N
102775	1457	17400939560000	11864	5918	49	0	\N
102776	1457	12825908800000	11864	5918	50	0	\N
102777	1457	4224170040000	11864	5918	51	0	\N
102778	1737	1299001100	11864	5918	52	0	\N
102779	1726	719076541000	11864	5918	53	0	\N
102780	1726	719075540000	11864	5918	54	0	\N
102781	1726	719074539000	11864	5918	55	0	\N
102782	1726	719073538000	11864	5918	56	0	\N
102783	1726	719072537000	11864	5918	57	0	\N
102784	1726	719071536000	11864	5918	58	0	\N
102785	1726	719070535000	11864	5918	59	0	\N
102786	1726	719069534000	11864	5918	60	0	\N
102787	1726	719068533000	11864	5918	61	0	\N
102788	1726	717858533000	11864	5918	62	0	\N
102789	1726	716648533000	11864	5918	63	0	\N
102790	1726	716647532000	11864	5918	64	0	\N
102791	1726	716646531000	11864	5918	65	0	\N
102792	1726	716645530000	11864	5918	66	0	\N
102793	1726	716644529000	11864	5918	67	0	\N
102794	1726	716643528000	11864	5918	68	0	\N
102795	1726	716642527000	11864	5918	69	0	\N
102796	1726	716641526000	11864	5918	70	0	\N
102797	1726	716640525000	11864	5918	71	0	\N
102798	1726	716639524000	11864	5918	72	0	\N
102799	1726	716638523000	11864	5918	73	0	\N
102800	1726	716637522000	11864	5918	74	0	\N
102801	1726	716636521000	11864	5918	75	0	\N
102802	1726	716635520000	11864	5918	76	0	\N
102803	1726	716634519000	11864	5918	77	0	\N
102804	1726	716633518000	11864	5918	78	0	\N
102805	1726	716632517000	11864	5918	79	0	\N
102806	1726	716631516000	11864	5918	80	0	\N
102807	1726	716630515000	11864	5918	81	0	\N
102808	1726	716629514000	11864	5918	82	0	\N
102809	1726	716628513000	11864	5918	83	0	\N
102810	1726	716627512000	11864	5918	84	0	\N
102811	1726	716626511000	11864	5918	85	0	\N
102812	1726	716625510000	11864	5918	86	0	\N
102813	1726	716624509000	11864	5918	87	0	\N
102814	1726	716623508000	11864	5918	88	0	\N
102815	1726	716622507000	11864	5918	89	0	\N
102816	1726	716621506000	11864	5918	90	0	\N
102683	1726	715217312000	11835	6083	3	0	3924
102684	1726	715216311000	11836	6084	0	0	3925
102685	1726	714006311000	11837	6085	0	0	3926
102686	1726	714005310000	11837	6085	1	0	3927
102688	1726	714004309000	11839	6086	0	0	3928
102690	1726	714002307000	11841	6088	0	0	3930
102691	1726	714001306000	11841	6088	1	0	3931
102692	1726	714000305000	11842	6089	0	0	3932
102694	1726	713999304000	11844	6090	0	0	3933
102698	1726	713998303000	11848	6091	0	0	3934
102702	1726	712787302000	11851	6092	1	0	3936
102703	1726	712786301000	11853	6093	0	0	3937
102714	1726	712785300000	11856	6094	0	0	3938
102715	1726	712784299000	11856	6094	1	0	3939
102720	1726	712782297000	11861	6096	0	0	3941
102724	1555	14828392276082	11863	6097	0	0	1
102725	1726	712781296000	11863	6097	1	0	3942
102726	1726	712780295000	11863	6097	2	0	3943
102817	1726	716620505000	11864	5918	91	0	\N
102818	1726	716619504000	11864	5918	92	0	\N
102819	1726	716618503000	11864	5918	93	0	\N
102820	1726	716617502000	11864	5918	94	0	\N
102821	1726	716616501000	11864	5918	95	0	\N
102822	1726	716615500000	11864	5918	96	0	\N
102823	1726	716614499000	11864	5918	97	0	\N
102824	1726	716613498000	11864	5918	98	0	\N
102825	1726	716612497000	11864	5918	99	0	\N
102826	1726	716611496000	11864	5918	100	0	\N
102827	1726	716610495000	11864	5918	101	0	\N
102828	1726	716609494000	11864	5918	102	0	\N
102829	1726	716608493000	11864	5918	103	0	\N
102830	1726	716607492000	11864	5918	104	0	\N
102831	1726	716606491000	11864	5918	105	0	\N
102832	1726	716605490000	11864	5918	106	0	\N
102833	1726	716604489000	11864	5918	107	0	\N
102834	1726	716603488000	11864	5918	108	0	\N
102835	1726	716602487000	11864	5918	109	0	\N
102836	1726	716601486000	11864	5918	110	0	\N
102837	1726	716600485000	11864	5918	111	0	\N
102838	1726	716599484000	11864	5918	112	0	\N
102839	1726	716598483000	11864	5918	113	0	\N
102840	1726	716597482000	11864	5918	114	0	\N
102841	1726	716596481000	11864	5918	115	0	\N
102842	1726	716595480000	11864	5918	116	0	\N
102843	1726	716594479000	11864	5918	117	0	\N
102844	1726	716593478000	11864	5918	118	0	\N
102845	1726	716592477000	11864	5918	119	0	\N
102846	1726	716591476000	11864	5918	120	0	\N
102847	1726	716590475000	11864	5918	121	0	\N
102848	1726	716589474000	11864	5918	122	0	\N
102849	1726	716588473000	11864	5918	123	0	\N
102850	1726	716587472000	11864	5918	124	0	\N
102851	1726	716586471000	11864	5918	125	0	\N
102853	1726	712779294000	11866	6098	0	0	\N
102854	1726	712778293000	11867	6099	0	0	\N
102855	1726	712778293000	11868	6099	0	0	\N
102862	1726	712776291000	11872	6101	0	0	\N
102863	1726	712775290000	11872	6101	1	0	\N
102864	1726	712774289000	11872	6101	2	0	\N
102868	1726	712771286000	11874	6103	0	0	\N
102869	1634	23738831223333	11875	6071	0	0	\N
102870	1555	14828392276082	11875	6071	1	0	\N
102871	1555	11724703786361	11875	6071	2	0	\N
102872	1555	9630580064175	11875	6071	3	0	\N
102873	1634	23727961050489	11875	6071	4	0	\N
102874	1634	23419794812544	11875	6071	5	0	\N
102875	1634	23111628574599	11875	6071	6	0	\N
102876	1634	22803462336654	11875	6071	7	0	\N
102877	1634	20517008110328	11875	6071	8	0	\N
102878	1634	16419709647008	11875	6071	9	0	\N
102879	1634	13655177476572	11875	6071	11	0	\N
102880	1634	5951580641004	11875	6071	12	0	\N
102881	1726	715243338000	11875	6071	13	0	\N
102882	1726	715242337000	11875	6071	14	0	\N
102883	1726	715241336000	11875	6071	15	0	\N
102884	1726	715240335000	11875	6071	16	0	\N
102885	1726	715239334000	11875	6071	17	0	\N
102886	1726	715238333000	11875	6071	18	0	\N
102887	1726	715237332000	11875	6071	19	0	\N
102888	1726	715236331000	11875	6071	20	0	\N
102889	1726	715235330000	11875	6071	21	0	\N
102890	1726	715234329000	11875	6071	22	0	\N
102891	1726	715233328000	11875	6071	23	0	\N
102892	1726	715232327000	11875	6071	24	0	\N
102893	1726	715231326000	11875	6071	25	0	\N
102894	1726	715230325000	11875	6071	26	0	\N
102895	1726	715229324000	11875	6071	27	0	\N
102896	1726	715228323000	11875	6071	28	0	\N
102897	1726	715227322000	11875	6071	29	0	\N
102898	1726	715226321000	11875	6071	30	0	\N
102899	1726	715225320000	11875	6071	31	0	\N
102900	1726	715224319000	11875	6071	32	0	\N
102901	1726	715223318000	11875	6071	33	0	\N
102902	1726	715222317000	11875	6071	34	0	\N
102903	1726	715221316000	11875	6071	35	0	\N
102904	1726	715220315000	11875	6071	36	0	\N
102905	1726	715219314000	11875	6071	37	0	\N
102906	1726	715218313000	11875	6071	38	0	\N
102907	1726	715217312000	11875	6071	39	0	\N
102908	1726	715216311000	11875	6071	40	0	\N
102909	1726	714006311000	11875	6071	41	0	\N
102910	1726	714005310000	11875	6071	42	0	\N
102911	1726	714004309000	11875	6071	43	0	\N
102912	1726	714003308000	11875	6071	44	0	\N
102913	1726	714002307000	11875	6071	45	0	\N
102914	1726	714001306000	11875	6071	46	0	\N
102915	1726	714000305000	11875	6071	47	0	\N
102916	1726	713999304000	11875	6071	48	0	\N
102917	1726	713998303000	11875	6071	49	0	\N
102918	1726	712788303000	11875	6071	50	0	\N
102919	1726	712787302000	11875	6071	51	0	\N
102920	1726	712786301000	11875	6071	52	0	\N
102921	1726	712785300000	11875	6071	53	0	\N
102922	1726	712784299000	11875	6071	54	0	\N
102923	1726	712783298000	11875	6071	55	0	\N
102924	1726	712782297000	11875	6071	56	0	\N
102925	1726	712781296000	11875	6071	57	0	\N
102926	1726	712780295000	11875	6071	58	0	\N
102927	1726	712779294000	11875	6071	59	0	\N
102928	1726	712778293000	11875	6071	60	0	\N
102929	1726	712777292000	11875	6071	61	0	\N
102930	1726	712776291000	11875	6071	62	0	\N
102931	1726	712775290000	11875	6071	63	0	\N
102932	1726	712774289000	11875	6071	64	0	\N
102933	1726	712773288000	11875	6071	65	0	\N
102934	1726	712772287000	11875	6071	66	0	\N
102935	1726	712771286000	11875	6071	67	0	\N
102938	1634	23738831223333	11878	6035	0	0	\N
102939	1555	14828392276082	11878	6035	1	0	\N
102940	1555	11724703786361	11878	6035	2	0	\N
102941	1555	9630580064175	11878	6035	3	0	\N
102942	1555	3795135979096	11878	6035	4	0	\N
102943	1686	15097674705523	11878	6035	5	0	\N
102944	1555	3795135979096	11879	6105	0	0	\N
102945	1726	712769284000	11879	6105	1	0	\N
102946	1555	3795135979096	11880	6105	0	0	\N
102947	1726	712769284000	11880	6105	1	0	\N
102950	1726	712768283000	11882	6106	0	0	\N
102951	1726	712767282000	11882	6106	1	0	\N
102952	1726	712766281000	11882	6106	2	0	\N
102857	1555	11724703786361	11870	6100	0	0	2
102858	1726	712777292000	11870	6100	1	0	3946
102859	1726	712776291000	11871	6101	0	0	3947
102860	1726	712775290000	11871	6101	1	0	3948
102861	1726	712774289000	11871	6101	2	0	3949
102866	1726	712773288000	11873	6102	1	0	3950
102867	1726	712772287000	11873	6102	2	0	3951
102936	1726	712771286000	11876	6103	0	0	3952
102937	1726	712770285000	11877	6104	0	0	3953
102948	1555	3795135979096	11881	6105	0	0	4
102953	1726	712765280000	11882	6106	3	0	\N
102954	1726	712768283000	11883	6106	0	0	\N
102955	1726	712767282000	11883	6106	1	0	\N
102956	1726	712766281000	11883	6106	2	0	\N
102957	1726	712765280000	11883	6106	3	0	\N
102964	1726	712763278000	11887	6108	0	0	\N
102966	1726	712762277000	11889	6109	0	0	\N
102972	2042	1550390000000	11894	5909	0	0	\N
102973	1634	23738831223333	11894	5909	1	0	\N
102974	1555	14108390276082	11894	5909	2	0	\N
102975	1555	11004701786361	11894	5909	3	0	\N
102976	1555	8910578064175	11894	5909	4	0	\N
102977	1555	3075133979096	11894	5909	5	0	\N
102978	1686	15097674705523	11894	5909	6	0	\N
102979	1686	14866263563482	11894	5909	7	0	\N
102980	411	66006400000000	11894	5909	8	0	\N
102981	1634	23727961050489	11894	5909	9	0	\N
102982	641	68061357200000	11894	5909	10	0	\N
102983	1634	23419794812544	11894	5909	11	0	\N
102984	1686	14634852421441	11894	5909	12	0	\N
102985	1686	12873315312881	11894	5909	13	0	\N
102986	1686	9716663827101	11894	5909	14	0	\N
102987	1686	7586804916122	11894	5909	15	0	\N
102988	1686	1651781550062	11894	5909	16	0	\N
102989	1717	15865277987543	11894	5909	17	0	\N
102990	1717	12040253293650	11894	5909	18	0	\N
102991	1717	9459429660887	11894	5909	19	0	\N
102992	1717	2267753000023	11894	5909	20	0	\N
102993	1634	23111628574599	11894	5909	21	0	\N
102994	1634	22803462336654	11894	5909	22	0	\N
102995	1634	20517008110328	11894	5909	23	0	\N
102996	1634	16419709647008	11894	5909	24	0	\N
102997	1634	13655177476572	11894	5909	25	0	\N
102998	1634	5951580641004	11894	5909	26	0	\N
102999	641	67787815600000	11894	5909	27	0	\N
103000	641	66866252400000	11894	5909	28	0	\N
103001	641	66535460000000	11894	5909	29	0	\N
103002	1726	716586471000	11894	5909	30	0	\N
103003	1726	716585470000	11894	5909	31	0	\N
103004	1726	716584469000	11894	5909	32	0	\N
103005	1726	716583468000	11894	5909	33	0	\N
103006	1726	716582467000	11894	5909	34	0	\N
103007	1726	716581466000	11894	5909	35	0	\N
103008	1726	716580465000	11894	5909	36	0	\N
103009	1737	1299001100	11894	5909	37	0	\N
103010	1726	716579464000	11894	5909	38	0	\N
103011	1726	716578463000	11894	5909	39	0	\N
103012	1726	716577462000	11894	5909	40	0	\N
103013	1726	716576461000	11894	5909	41	0	\N
103014	1726	716575460000	11894	5909	42	0	\N
103015	1726	716574459000	11894	5909	43	0	\N
103016	1726	716573458000	11894	5909	44	0	\N
103017	1726	716572457000	11894	5909	45	0	\N
103018	1726	716571456000	11894	5909	46	0	\N
103019	1726	716570455000	11894	5909	47	0	\N
103020	1726	716569454000	11894	5909	48	0	\N
103021	1726	716568453000	11894	5909	49	0	\N
103022	1726	716567452000	11894	5909	50	0	\N
103023	1726	716566451000	11894	5909	51	0	\N
103024	1726	716565450000	11894	5909	52	0	\N
103025	1726	716564449000	11894	5909	53	0	\N
103026	1726	716563448000	11894	5909	54	0	\N
103027	1726	716562447000	11894	5909	55	0	\N
103028	1726	716561446000	11894	5909	56	0	\N
103029	1726	716560445000	11894	5909	57	0	\N
103030	1726	716559444000	11894	5909	58	0	\N
103031	1726	716558443000	11894	5909	59	0	\N
103032	1726	716557442000	11894	5909	60	0	\N
103033	1726	716556441000	11894	5909	61	0	\N
103034	1726	716555440000	11894	5909	62	0	\N
103035	1726	716554439000	11894	5909	63	0	\N
103036	1726	716553438000	11894	5909	64	0	\N
103037	1726	716552437000	11894	5909	65	0	\N
103038	1726	716551436000	11894	5909	66	0	\N
103039	1726	716550435000	11894	5909	67	0	\N
103040	1726	716549434000	11894	5909	68	0	\N
103041	1726	716548433000	11894	5909	69	0	\N
103042	1726	716547432000	11894	5909	70	0	\N
103043	1726	716546431000	11894	5909	71	0	\N
103044	1726	716545430000	11894	5909	72	0	\N
103045	1726	716544429000	11894	5909	73	0	\N
103046	1726	716543428000	11894	5909	74	0	\N
103047	1726	716542427000	11894	5909	75	0	\N
103048	1726	716541426000	11894	5909	76	0	\N
103049	1726	716540425000	11894	5909	77	0	\N
103050	1726	716539424000	11894	5909	78	0	\N
103051	1726	716538423000	11894	5909	79	0	\N
103052	1726	716537422000	11894	5909	80	0	\N
103053	1726	716536421000	11894	5909	81	0	\N
103054	1726	716535420000	11894	5909	82	0	\N
103055	1726	716534419000	11894	5909	83	0	\N
103056	1726	716533418000	11894	5909	84	0	\N
103057	1726	716532417000	11894	5909	85	0	\N
103058	1726	716531416000	11894	5909	86	0	\N
103059	1726	716530415000	11894	5909	87	0	\N
103060	1726	716529414000	11894	5909	88	0	\N
103061	1726	716528413000	11894	5909	89	0	\N
103062	1726	716527412000	11894	5909	90	0	\N
103063	1726	716526411000	11894	5909	91	0	\N
103064	1726	716525410000	11894	5909	92	0	\N
103065	1726	716524409000	11894	5909	93	0	\N
103066	1726	716523408000	11894	5909	96	0	\N
103067	1726	716522407000	11894	5909	97	0	\N
103068	1726	716521406000	11894	5909	98	0	\N
103069	1726	716520405000	11894	5909	99	0	\N
103070	1726	716519404000	11894	5909	100	0	\N
103071	1726	716518403000	11894	5909	101	0	\N
103072	1726	716517402000	11894	5909	102	0	\N
103073	1726	716516401000	11894	5909	103	0	\N
103074	1726	716515400000	11894	5909	104	0	\N
103075	1726	716514399000	11894	5909	105	0	\N
103076	1726	716513398000	11894	5909	106	0	\N
103077	1726	716512397000	11894	5909	107	0	\N
103078	1726	716511396000	11894	5909	108	0	\N
103079	1726	716510395000	11894	5909	109	0	\N
103080	1726	716509394000	11894	5909	110	0	\N
103081	1726	716508393000	11894	5909	111	0	\N
103082	1726	716507392000	11894	5909	112	0	\N
103083	1726	716506391000	11894	5909	113	0	\N
103084	1726	716505390000	11894	5909	114	0	\N
103085	1726	716504389000	11894	5909	115	0	\N
103086	1726	716503388000	11894	5909	116	0	\N
103087	1726	716502387000	11894	5909	117	0	\N
103088	1726	716501386000	11894	5909	118	0	\N
102960	1726	712766281000	11884	6106	2	0	3957
102961	1726	712765280000	11884	6106	3	0	3958
102962	1726	712764279000	11885	6107	0	0	3959
102963	1726	712763278000	11886	6108	0	0	3960
102965	1726	712762277000	11888	6109	0	0	3961
102968	1726	712760275000	11891	6111	0	0	3963
102969	1726	712759274000	11892	6112	0	0	3964
102970	1726	712758273000	11893	6113	0	0	3965
102971	1726	712757272000	11893	6113	1	0	3966
103089	1726	715291386000	11894	5909	119	0	\N
103090	1726	715290385000	11894	5909	120	0	\N
103091	1726	715289384000	11894	5909	121	0	\N
103092	1726	715288383000	11894	5909	122	0	\N
103093	1726	715287382000	11894	5909	123	0	\N
103094	1726	715286381000	11894	5909	124	0	\N
103095	1726	715285380000	11894	5909	125	0	\N
103104	1726	712750265000	11900	6118	0	0	\N
103105	1726	712749264000	11900	6118	1	0	\N
103109	1726	712747262000	11903	6120	0	0	\N
103110	1726	712746261000	11903	6120	1	0	\N
103118	1726	712738253000	11911	6128	0	0	\N
103119	1726	712738253000	11912	6128	0	0	\N
103122	1634	23738831223333	11915	6024	0	0	\N
103123	1555	14828392276082	11915	6024	1	0	\N
103124	1555	11724703786361	11915	6024	2	0	\N
103125	1555	9630580064175	11915	6024	3	0	\N
103126	1555	3795135979096	11915	6024	4	0	\N
103127	1686	15097674705523	11915	6024	5	0	\N
103128	1686	14866263563482	11915	6024	6	0	\N
103129	1634	23727961050489	11915	6024	7	0	\N
103130	641	68061357200000	11915	6024	8	0	\N
103131	1634	23419794812544	11915	6024	9	0	\N
103132	1686	14634852421441	11915	6024	10	0	\N
103133	1686	12873315312881	11915	6024	11	0	\N
103134	1686	9716663827101	11915	6024	12	0	\N
103135	1686	7586804916122	11915	6024	13	0	\N
103136	1686	1651781550062	11915	6024	14	0	\N
103137	1634	23111628574599	11915	6024	15	0	\N
103138	1634	22803462336654	11915	6024	16	0	\N
103139	1634	20517008110328	11915	6024	17	0	\N
103140	1634	16419709647008	11915	6024	18	0	\N
103141	1634	13655177476572	11915	6024	19	0	\N
103142	1634	5951580641004	11915	6024	20	0	\N
103143	641	67787815600000	11915	6024	21	0	\N
103144	641	66866252400000	11915	6024	22	0	\N
103145	641	66535460000000	11915	6024	23	0	\N
103146	1737	1299001100	11915	6024	24	0	\N
103147	1726	712736251000	11916	6130	0	0	\N
103151	1726	712734249000	11920	6132	0	0	\N
103162	1726	712724239000	11929	6140	0	0	\N
103163	1726	712723238000	11930	6141	0	0	\N
103164	1726	712722237000	11930	6141	1	0	\N
103165	1726	712721236000	11930	6141	2	0	\N
103169	1726	712720235000	11932	6142	0	0	\N
103171	1726	712750265000	11934	6118	0	0	\N
103172	1726	712749264000	11934	6118	1	0	\N
103173	1726	712748263000	11934	6118	2	0	\N
103174	1726	712747262000	11934	6118	3	0	\N
103175	1726	712746261000	11934	6118	4	0	\N
103176	1726	712745260000	11934	6118	5	0	\N
103177	1726	712744259000	11934	6118	6	0	\N
103178	1726	712743258000	11934	6118	7	0	\N
103179	1726	712742257000	11934	6118	8	0	\N
103180	1726	712741256000	11934	6118	9	0	\N
103181	1726	712740255000	11934	6118	10	0	\N
103182	1726	712739254000	11934	6118	11	0	\N
103183	1726	712738253000	11934	6118	12	0	\N
103184	1726	712737252000	11934	6118	13	0	\N
103185	1726	712736251000	11934	6118	14	0	\N
103186	1726	712735250000	11934	6118	15	0	\N
103187	1726	712734249000	11934	6118	16	0	\N
103188	1726	712733248000	11934	6118	17	0	\N
103189	1726	712732247000	11934	6118	18	0	\N
103190	1726	712731246000	11934	6118	19	0	\N
103191	1726	712730245000	11934	6118	20	0	\N
103192	1726	712729244000	11934	6118	21	0	\N
103193	1726	712728243000	11934	6118	22	0	\N
103194	1726	712727242000	11934	6118	23	0	\N
103195	1726	712726241000	11934	6118	24	0	\N
103196	1726	712725240000	11934	6118	25	0	\N
103197	1726	712724239000	11934	6118	26	0	\N
103198	1726	712723238000	11934	6118	27	0	\N
103199	1726	712722237000	11934	6118	28	0	\N
103200	1726	712721236000	11934	6118	29	0	\N
103201	1726	712720235000	11934	6118	30	0	\N
103202	1726	712719234000	11934	6118	31	0	\N
103204	1726	712719234000	11936	6143	0	0	\N
103210	1573	23755810000000	11941	6148	0	0	\N
103211	1726	712713228000	11941	6148	1	0	\N
103212	1726	712712227000	11941	6148	2	0	\N
103213	1573	17978809000000	11941	6148	3	0	\N
103214	1573	14081808000000	11941	6148	4	0	\N
103215	1573	11017807000000	11941	6148	5	0	\N
103216	1726	712711226000	11941	6148	6	0	\N
103217	1726	712710225000	11941	6148	7	0	\N
103098	1726	712754269000	11896	6115	0	0	3969
103099	1726	712753268000	11897	6116	0	0	3970
103100	1726	712752267000	11897	6116	1	0	3971
103101	1726	712751266000	11898	6117	0	0	3972
103102	1726	712750265000	11899	6118	0	0	3973
103106	1726	712748263000	11901	6119	0	0	3975
103107	1726	712747262000	11902	6120	0	0	3976
103108	1726	712746261000	11902	6120	1	0	3977
103111	1726	712745260000	11904	6121	0	0	3978
103112	1726	712744259000	11905	6122	0	0	3979
103114	1726	712742257000	11907	6124	0	0	3981
103115	1726	712741256000	11908	6125	0	0	3982
103116	1726	712740255000	11909	6126	0	0	3983
103117	1726	712739254000	11910	6127	0	0	3984
103121	1726	712737252000	11914	6129	0	0	3986
103148	1726	712736251000	11917	6130	0	0	3987
103149	1726	712735250000	11918	6131	0	0	3988
103150	1726	712734249000	11919	6132	0	0	3989
103152	1726	712733248000	11921	6133	0	0	3990
103154	1726	712731246000	11922	6134	0	0	3992
103155	1726	712730245000	11923	6135	0	0	3993
103156	1726	712729244000	11924	6136	0	0	3994
103157	1726	712728243000	11925	6137	0	0	3995
103158	1726	712727242000	11925	6137	1	0	3996
103160	1726	712725240000	11927	6139	0	0	3998
103161	1726	712724239000	11928	6140	0	0	3999
103166	1726	712723238000	11931	6141	0	0	4000
103167	1726	712722237000	11931	6141	1	0	4001
103170	1726	712720235000	11933	6142	0	0	4003
103203	1726	712719234000	11935	6143	0	0	4004
103205	1726	712718233000	11938	6145	0	0	4005
103206	1726	712717232000	11938	6145	1	0	4006
103207	1726	712716231000	11938	6145	2	0	4007
103209	1726	712714229000	11940	6147	1	0	4009
103218	1573	23755810000000	11942	6148	0	0	1
103219	1726	712713228000	11942	6148	1	0	4010
103220	1726	712712227000	11942	6148	2	0	4011
103221	1573	17978809000000	11942	6148	3	0	2
103223	1573	11017807000000	11942	6148	5	0	4
103224	1726	712711226000	11942	6148	6	0	4012
103226	1726	712709224000	11943	6149	0	0	\N
103231	1573	23755810000000	11947	6138	0	0	\N
103232	1573	23750809000000	11947	6138	1	0	\N
103233	1573	23745808000000	11947	6138	2	0	\N
103234	1573	23740807000000	11947	6138	3	0	\N
103235	1573	13421806000000	11947	6138	4	0	\N
103236	1726	712706221000	11948	6152	0	0	\N
103237	1726	712705220000	11948	6152	1	0	\N
103238	1726	712706221000	11949	6152	0	0	\N
103239	1726	712705220000	11949	6152	1	0	\N
103240	1573	23035809000000	11951	5910	0	0	\N
103241	1573	23030808000000	11951	5910	1	0	\N
103242	1573	23025807000000	11951	5910	2	0	\N
103243	1573	23020806000000	11951	5910	3	0	\N
103244	1726	715284379000	11951	5910	4	0	\N
103245	1573	12701805000000	11951	5910	5	0	\N
103246	1726	715283378000	11951	5910	6	0	\N
103247	1726	715282377000	11951	5910	7	0	\N
103248	1726	715281376000	11951	5910	8	0	\N
103249	1726	715280375000	11951	5910	9	0	\N
103250	1726	715279374000	11951	5910	10	0	\N
103251	1726	715278373000	11951	5910	11	0	\N
103252	1726	715277372000	11951	5910	12	0	\N
103253	1726	715276371000	11951	5910	13	0	\N
103254	1726	715275370000	11951	5910	14	0	\N
103255	1726	715274369000	11951	5910	15	0	\N
103256	1573	23755810000000	11952	6119	0	0	\N
103257	1573	23750809000000	11952	6119	1	0	\N
103258	1573	23745808000000	11952	6119	2	0	\N
103259	1573	23740807000000	11952	6119	3	0	\N
103260	1726	712718233000	11952	6119	4	0	\N
103261	1726	712717232000	11952	6119	5	0	\N
103262	1726	712716231000	11952	6119	6	0	\N
103263	1726	712715230000	11952	6119	7	0	\N
103264	1573	13421806000000	11952	6119	8	0	\N
103265	1726	712714229000	11952	6119	9	0	\N
103266	1726	712713228000	11952	6119	10	0	\N
103267	1726	712712227000	11952	6119	11	0	\N
103268	1726	712711226000	11952	6119	12	0	\N
103269	1726	712710225000	11952	6119	13	0	\N
103270	1726	712709224000	11952	6119	14	0	\N
103271	1726	712708223000	11952	6119	15	0	\N
103272	1726	712707222000	11952	6119	16	0	\N
103273	1726	712706221000	11952	6119	17	0	\N
103274	1726	712705220000	11952	6119	18	0	\N
103275	1726	712704219000	11952	6119	19	0	\N
103276	1726	712706221000	11953	6153	0	0	\N
103277	1726	712705220000	11953	6153	1	0	\N
103278	1726	712704219000	11953	6153	2	0	\N
103279	1726	712703218000	11953	6153	3	0	\N
103284	1726	712702217000	11955	6154	0	0	\N
103285	1726	712701216000	11955	6154	1	0	\N
103289	1726	712700215000	11958	6155	0	0	\N
103294	1726	712697212000	11961	6157	0	0	\N
103295	1726	712696211000	11961	6157	1	0	\N
103296	1573	23755810000000	11962	6124	0	0	\N
103297	1573	23750809000000	11962	6124	1	0	\N
103298	1573	23745808000000	11962	6124	2	0	\N
103299	1573	23740807000000	11962	6124	3	0	\N
103300	1573	13421806000000	11962	6124	4	0	\N
103301	1726	712695210000	11963	6158	0	0	\N
103302	1726	712695210000	11964	6158	0	0	\N
103303	1726	712695210000	11965	6158	0	0	\N
103304	1726	712695210000	11966	6158	0	0	\N
103307	1726	712693208000	11969	6160	0	0	\N
103308	1726	712692207000	11969	6160	1	0	\N
103309	1726	712693208000	11970	6160	0	0	\N
103310	1726	712692207000	11970	6160	1	0	\N
103314	1726	712690205000	11973	6162	0	0	\N
103319	1726	712688203000	11977	6164	0	0	\N
103320	1726	712687202000	11977	6164	1	0	\N
103321	1726	712688203000	11978	6164	0	0	\N
103322	1726	712687202000	11978	6164	1	0	\N
103324	1726	712685200000	11980	6166	0	0	\N
103327	1726	712683198000	11983	6168	0	0	\N
103330	1726	712681196000	11986	6170	0	0	\N
103331	1726	712681196000	11987	6170	0	0	\N
103332	1726	712681196000	11988	6170	0	0	\N
103334	1726	712680195000	11990	6171	0	0	\N
103335	1726	712679194000	11990	6171	1	0	\N
103340	1726	712677192000	11994	6173	0	0	\N
103341	1726	712677192000	11995	6173	0	0	\N
103342	1726	712676191000	11996	6174	0	0	\N
103343	1726	712676191000	11997	6174	0	0	\N
103346	1775	916000000	12000	6176	0	0	\N
103347	1726	712674189000	12000	6176	1	0	\N
103352	1726	712673188000	12003	6177	0	0	\N
103357	1726	712667182000	12006	6180	0	0	\N
103358	1726	712667182000	12007	6180	0	0	\N
103360	1726	712667182000	12009	6180	0	0	\N
103228	1726	712708223000	11945	6150	0	0	4015
103229	1726	712707222000	11946	6151	0	0	4016
103230	1573	698806000000	11946	6151	1	0	5
103280	1726	712706221000	11954	6153	0	0	4017
103281	1726	712705220000	11954	6153	1	0	4018
103283	1726	712703218000	11954	6153	3	0	4020
103286	1726	712702217000	11956	6154	0	0	4021
103287	1726	712701216000	11956	6154	1	0	4022
103288	1726	712700215000	11957	6155	0	0	4023
103290	1726	712699214000	11959	6156	0	0	4024
103292	1726	712697212000	11960	6157	0	0	4026
103293	1726	712696211000	11960	6157	1	0	4027
103305	1726	712695210000	11967	6158	0	0	4028
103306	1726	712694209000	11968	6159	0	0	4029
103312	1726	712692207000	11971	6160	1	0	4031
103313	1726	712691206000	11972	6161	0	0	4032
103315	1726	712690205000	11974	6162	0	0	4033
103316	1726	712689204000	11975	6163	0	0	4034
103317	1726	712688203000	11976	6164	0	0	4035
103323	1726	712686201000	11979	6165	0	0	4037
103325	1726	712685200000	11981	6166	0	0	4038
103326	1726	712684199000	11982	6167	0	0	4039
103328	1726	712683198000	11984	6168	0	0	4040
103329	1726	712682197000	11985	6169	0	0	4041
103336	1726	712680195000	11991	6171	0	0	4043
103337	1726	712679194000	11991	6171	1	0	4044
103338	1726	712678193000	11992	6172	0	0	4045
103339	1726	712677192000	11993	6173	0	0	4046
103345	1726	712675190000	11999	6175	0	0	4048
103348	1775	916000000	12001	6176	0	0	12
103349	1726	712674189000	12001	6176	1	0	4049
103350	1726	712673188000	12002	6177	0	0	4050
103351	1726	712672187000	12002	6177	1	0	4051
103354	1726	712670185000	12004	6178	1	0	4053
103355	1726	712669184000	12004	6178	2	0	4054
103356	1726	712668183000	12005	6179	0	0	4055
103359	1726	712667182000	12008	6180	0	0	4056
103369	1573	23035809000000	12013	6072	0	0	\N
103370	1573	23030808000000	12013	6072	1	0	\N
103371	1573	23025807000000	12013	6072	2	0	\N
103372	1573	23020806000000	12013	6072	3	0	\N
103373	1555	3795135979096	12013	6072	4	0	\N
103374	1775	916000000	12013	6072	5	0	\N
103375	1775	905000000	12013	6072	6	0	\N
103376	1573	12701805000000	12013	6072	7	0	\N
103377	1775	884000000	12013	6072	8	0	\N
103378	1726	712770285000	12013	6072	9	0	\N
103379	1726	712769284000	12013	6072	10	0	\N
103380	1726	712768283000	12013	6072	11	0	\N
103381	1726	712767282000	12013	6072	12	0	\N
103382	1726	712766281000	12013	6072	13	0	\N
103383	1726	712765280000	12013	6072	14	0	\N
103384	1726	712764279000	12013	6072	15	0	\N
103385	1726	712763278000	12013	6072	16	0	\N
103386	1726	712762277000	12013	6072	17	0	\N
103387	1726	712761276000	12013	6072	18	0	\N
103388	1726	712760275000	12013	6072	19	0	\N
103389	1726	712759274000	12013	6072	20	0	\N
103390	1726	712758273000	12013	6072	21	0	\N
103391	1726	712757272000	12013	6072	22	0	\N
103392	1726	712756271000	12013	6072	23	0	\N
103393	1726	712755270000	12013	6072	24	0	\N
103394	1726	712754269000	12013	6072	25	0	\N
103395	1726	712753268000	12013	6072	26	0	\N
103396	1726	712752267000	12013	6072	27	0	\N
103397	1726	712751266000	12013	6072	28	0	\N
103398	1726	712750265000	12013	6072	29	0	\N
103399	1726	712749264000	12013	6072	30	0	\N
103400	1726	712748263000	12013	6072	31	0	\N
103401	1726	712747262000	12013	6072	32	0	\N
103402	1726	712746261000	12013	6072	33	0	\N
103403	1726	712745260000	12013	6072	34	0	\N
103404	1726	712744259000	12013	6072	35	0	\N
103405	1726	712743258000	12013	6072	36	0	\N
103406	1726	712742257000	12013	6072	37	0	\N
103407	1726	712741256000	12013	6072	38	0	\N
103408	1726	712740255000	12013	6072	39	0	\N
103409	1726	712739254000	12013	6072	40	0	\N
103410	1726	712738253000	12013	6072	41	0	\N
103411	1726	712737252000	12013	6072	42	0	\N
103412	1726	712736251000	12013	6072	43	0	\N
103413	1726	712735250000	12013	6072	44	0	\N
103414	1726	712734249000	12013	6072	45	0	\N
103415	1726	712733248000	12013	6072	46	0	\N
103416	1726	712732247000	12013	6072	47	0	\N
103417	1726	712731246000	12013	6072	48	0	\N
103418	1726	712730245000	12013	6072	49	0	\N
103419	1726	712729244000	12013	6072	50	0	\N
103420	1726	712728243000	12013	6072	51	0	\N
103421	1726	712727242000	12013	6072	52	0	\N
103422	1726	712726241000	12013	6072	53	0	\N
103423	1726	712725240000	12013	6072	54	0	\N
103424	1726	712724239000	12013	6072	55	0	\N
103425	1726	712723238000	12013	6072	56	0	\N
103426	1726	712722237000	12013	6072	57	0	\N
103427	1726	712721236000	12013	6072	58	0	\N
103428	1726	712720235000	12013	6072	59	0	\N
103429	1726	712719234000	12013	6072	60	0	\N
103430	1726	712718233000	12013	6072	61	0	\N
103431	1726	712717232000	12013	6072	62	0	\N
103432	1726	712716231000	12013	6072	63	0	\N
103433	1726	712715230000	12013	6072	64	0	\N
103434	1726	712714229000	12013	6072	65	0	\N
103435	1726	712713228000	12013	6072	66	0	\N
103436	1726	712712227000	12013	6072	67	0	\N
103437	1726	712711226000	12013	6072	69	0	\N
103438	1726	712710225000	12013	6072	70	0	\N
103439	1726	712709224000	12013	6072	71	0	\N
103440	1726	712708223000	12013	6072	72	0	\N
103441	1726	712707222000	12013	6072	73	0	\N
103442	1726	712706221000	12013	6072	74	0	\N
103443	1726	712705220000	12013	6072	75	0	\N
103444	1726	712704219000	12013	6072	76	0	\N
103445	1726	712703218000	12013	6072	77	0	\N
103446	1726	712702217000	12013	6072	78	0	\N
103447	1726	712701216000	12013	6072	79	0	\N
103448	1726	712700215000	12013	6072	80	0	\N
103449	1726	712699214000	12013	6072	81	0	\N
103450	1726	712698213000	12013	6072	82	0	\N
103451	1726	712697212000	12013	6072	83	0	\N
103452	1726	712696211000	12013	6072	84	0	\N
103453	1726	712695210000	12013	6072	85	0	\N
103454	1726	712694209000	12013	6072	86	0	\N
103455	1726	712693208000	12013	6072	87	0	\N
103456	1726	712692207000	12013	6072	88	0	\N
103457	1726	712691206000	12013	6072	89	0	\N
103458	1726	712690205000	12013	6072	90	0	\N
103459	1726	712689204000	12013	6072	91	0	\N
103460	1726	712688203000	12013	6072	92	0	\N
103461	1726	712687202000	12013	6072	93	0	\N
103462	1726	712686201000	12013	6072	94	0	\N
103463	1726	712685200000	12013	6072	95	0	\N
103464	1726	712684199000	12013	6072	96	0	\N
103465	1726	712683198000	12013	6072	97	0	\N
103466	1726	712682197000	12013	6072	98	0	\N
103467	1726	712681196000	12013	6072	99	0	\N
103468	1726	712680195000	12013	6072	100	0	\N
103469	1726	712679194000	12013	6072	101	0	\N
103470	1726	712678193000	12013	6072	102	0	\N
103471	1726	712677192000	12013	6072	103	0	\N
103472	1726	712676191000	12013	6072	104	0	\N
103473	1726	712675190000	12013	6072	105	0	\N
103474	1726	712674189000	12013	6072	106	0	\N
103475	1726	712673188000	12013	6072	107	0	\N
103476	1726	712672187000	12013	6072	108	0	\N
103477	1726	712671186000	12013	6072	109	0	\N
103478	1726	712670185000	12013	6072	110	0	\N
103479	1726	712669184000	12013	6072	111	0	\N
103480	1726	712668183000	12013	6072	112	0	\N
103481	1726	712667182000	12013	6072	113	0	\N
103482	1726	712666181000	12013	6072	114	0	\N
103483	1726	712665180000	12013	6072	115	0	\N
103484	1726	712664179000	12013	6072	116	0	\N
103485	1726	712663178000	12013	6072	117	0	\N
103486	1726	712662177000	12013	6072	118	0	\N
103487	1726	712661176000	12013	6072	119	0	\N
103488	1726	712661176000	12014	6183	0	0	\N
103489	1573	23755810000000	12015	6134	0	0	\N
103490	1573	23750809000000	12015	6134	1	0	\N
103491	1573	23745808000000	12015	6134	2	0	\N
103492	1573	23740807000000	12015	6134	3	0	\N
103493	1775	916000000	12015	6134	4	0	\N
103494	1726	712731246000	12015	6134	5	0	\N
103495	1726	712730245000	12015	6134	6	0	\N
103496	1726	712729244000	12015	6134	7	0	\N
103363	1775	905000000	12011	6182	1	0	13
103364	1775	884000000	12011	6182	2	0	14
103365	1726	712664179000	12011	6182	3	0	4059
103366	1726	712663178000	12011	6182	4	0	4060
103367	1726	712662177000	12011	6182	5	0	4061
103497	1726	712728243000	12015	6134	8	0	\N
103498	1775	905000000	12015	6134	9	0	\N
103499	1726	712727242000	12015	6134	10	0	\N
103500	1726	712726241000	12015	6134	11	0	\N
103501	1726	712725240000	12015	6134	12	0	\N
103502	1573	13421806000000	12015	6134	13	0	\N
103503	1775	884000000	12015	6134	14	0	\N
103504	1726	712724239000	12015	6134	15	0	\N
103505	1726	712723238000	12015	6134	16	0	\N
103506	1726	712722237000	12015	6134	17	0	\N
103507	1726	712721236000	12015	6134	18	0	\N
103508	1726	712720235000	12015	6134	19	0	\N
103509	1726	712719234000	12015	6134	20	0	\N
103510	1726	712718233000	12015	6134	21	0	\N
103511	1726	712717232000	12015	6134	22	0	\N
103512	1726	712716231000	12015	6134	23	0	\N
103513	1726	712715230000	12015	6134	24	0	\N
103514	1726	712714229000	12015	6134	25	0	\N
103515	1726	712713228000	12015	6134	26	0	\N
103516	1726	712712227000	12015	6134	27	0	\N
103517	1726	712711226000	12015	6134	28	0	\N
103518	1726	712710225000	12015	6134	29	0	\N
103519	1726	712709224000	12015	6134	30	0	\N
103520	1726	712708223000	12015	6134	31	0	\N
103521	1726	712707222000	12015	6134	32	0	\N
103522	1726	712706221000	12015	6134	34	0	\N
103523	1726	712705220000	12015	6134	35	0	\N
103524	1726	712704219000	12015	6134	36	0	\N
103525	1726	712703218000	12015	6134	37	0	\N
103526	1726	712702217000	12015	6134	38	0	\N
103527	1726	712701216000	12015	6134	39	0	\N
103528	1726	712700215000	12015	6134	40	0	\N
103529	1726	712699214000	12015	6134	41	0	\N
103530	1726	712698213000	12015	6134	42	0	\N
103531	1726	712697212000	12015	6134	43	0	\N
103532	1726	712696211000	12015	6134	44	0	\N
103533	1726	712695210000	12015	6134	45	0	\N
103534	1726	712694209000	12015	6134	46	0	\N
103535	1726	712693208000	12015	6134	47	0	\N
103536	1726	712692207000	12015	6134	48	0	\N
103537	1726	712691206000	12015	6134	49	0	\N
103538	1726	712690205000	12015	6134	50	0	\N
103539	1726	712689204000	12015	6134	51	0	\N
103540	1726	712688203000	12015	6134	52	0	\N
103541	1726	712687202000	12015	6134	53	0	\N
103542	1726	712686201000	12015	6134	54	0	\N
103543	1726	712685200000	12015	6134	55	0	\N
103544	1726	712684199000	12015	6134	56	0	\N
103545	1726	712683198000	12015	6134	57	0	\N
103546	1726	712682197000	12015	6134	58	0	\N
103547	1726	712681196000	12015	6134	59	0	\N
103548	1726	712680195000	12015	6134	60	0	\N
103549	1726	712679194000	12015	6134	61	0	\N
103550	1726	712678193000	12015	6134	62	0	\N
103551	1726	712677192000	12015	6134	63	0	\N
103552	1726	712676191000	12015	6134	64	0	\N
103553	1726	712675190000	12015	6134	65	0	\N
103554	1726	712674189000	12015	6134	66	0	\N
103555	1726	712673188000	12015	6134	67	0	\N
103556	1726	712672187000	12015	6134	68	0	\N
103557	1726	712671186000	12015	6134	69	0	\N
103558	1726	712670185000	12015	6134	70	0	\N
103559	1726	712669184000	12015	6134	71	0	\N
103560	1726	712668183000	12015	6134	72	0	\N
103561	1726	712667182000	12015	6134	73	0	\N
103562	1726	712666181000	12015	6134	74	0	\N
103563	1726	712665180000	12015	6134	75	0	\N
103564	1726	712664179000	12015	6134	76	0	\N
103565	1726	712663178000	12015	6134	77	0	\N
103566	1726	712662177000	12015	6134	78	0	\N
103567	1726	712661176000	12015	6134	79	0	\N
103571	1726	712657172000	12018	6186	0	0	\N
103572	1726	712657172000	12019	6186	0	0	\N
103573	1726	712657172000	12020	6186	0	0	\N
103574	1726	712657172000	12021	6186	0	0	\N
103582	1775	916000000	12027	6125	0	0	\N
103583	1775	905000000	12027	6125	1	0	\N
103584	1775	884000000	12027	6125	2	0	\N
103585	1726	712650165000	12028	6191	0	0	\N
103586	1726	712650165000	12029	6191	0	0	\N
103587	1726	712650165000	12030	6191	0	0	\N
103596	1726	712643158000	12037	6197	0	0	\N
103598	1726	712643158000	12039	6197	0	0	\N
103599	1726	712642157000	12040	6198	0	0	\N
103602	1726	712640155000	12043	6200	0	0	\N
103604	1726	712640155000	12045	6200	0	0	\N
103605	1726	712639154000	12046	6201	0	0	\N
103607	1726	712638153000	12048	6202	0	0	\N
103609	1726	712638153000	12050	6202	0	0	\N
103610	1726	712638153000	12051	6202	0	0	\N
103616	1726	712634149000	12054	6205	0	0	\N
103617	1726	712634149000	12055	6205	0	0	\N
103619	1726	712634149000	12057	6205	0	0	\N
103621	1939	2150980000000	12059	6164	0	0	\N
103622	1775	916000000	12059	6164	1	0	\N
103623	1521	1000000	12059	6164	2	0	\N
103624	1726	712688203000	12059	6164	3	0	\N
103625	1775	905000000	12059	6164	4	0	\N
103626	1769	1708900000	12059	6164	5	0	\N
103627	1775	884000000	12059	6164	6	0	\N
103628	1726	712687202000	12059	6164	7	0	\N
103629	1726	712686201000	12059	6164	8	0	\N
103630	1726	712685200000	12059	6164	9	0	\N
103631	1726	712684199000	12059	6164	10	0	\N
103632	1726	712683198000	12059	6164	11	0	\N
103570	1726	712658173000	12017	6185	0	0	4065
103575	1726	712657172000	12022	6186	0	0	4066
103576	1726	712656171000	12023	6187	0	0	4067
103577	1726	712655170000	12023	6187	1	0	4068
103578	1726	712654169000	12024	6188	0	0	4069
103580	1726	712652167000	12026	6190	0	0	4071
103581	1726	712651166000	12026	6190	1	0	4072
103588	1726	712650165000	12031	6191	0	0	4073
103589	1726	712649164000	12032	6192	0	0	4074
103590	1726	712648163000	12033	6193	0	0	4075
103592	1726	712647162000	12034	6194	1	0	4076
103593	1726	712646161000	12035	6195	0	0	4077
103594	1726	712645160000	12036	6196	0	0	4078
103595	1726	712644159000	12036	6196	1	0	4079
103600	1726	712642157000	12041	6198	0	0	4081
103601	1726	712641156000	12042	6199	0	0	4082
103603	1726	712640155000	12044	6200	0	0	4083
103606	1726	712639154000	12047	6201	0	0	4084
103608	1726	712638153000	12049	6202	0	0	4085
103612	1726	712636151000	12053	6204	0	0	4087
103613	1726	712635150000	12053	6204	1	0	4088
103614	1521	1000000	12053	6204	2	0	7
103615	1769	1708900000	12053	6204	3	0	25
103618	1726	712634149000	12056	6205	0	0	4089
103633	1726	712682197000	12059	6164	12	0	\N
103634	1726	712681196000	12059	6164	13	0	\N
103635	1726	712680195000	12059	6164	14	0	\N
103636	1726	712679194000	12059	6164	15	0	\N
103637	1726	712678193000	12059	6164	16	0	\N
103638	1726	712677192000	12059	6164	17	0	\N
103639	1726	712676191000	12059	6164	18	0	\N
103640	1726	712675190000	12059	6164	19	0	\N
103641	1726	712674189000	12059	6164	20	0	\N
103642	1726	712673188000	12059	6164	21	0	\N
103643	1726	712672187000	12059	6164	22	0	\N
103644	1726	712671186000	12059	6164	23	0	\N
103645	1726	712670185000	12059	6164	24	0	\N
103646	1726	712669184000	12059	6164	25	0	\N
103647	1726	712668183000	12059	6164	26	0	\N
103648	1726	712667182000	12059	6164	27	0	\N
103649	1726	712666181000	12059	6164	28	0	\N
103650	1726	712665180000	12059	6164	29	0	\N
103651	1726	712664179000	12059	6164	30	0	\N
103652	1726	712663178000	12059	6164	31	0	\N
103653	1726	712662177000	12059	6164	32	0	\N
103654	1726	712661176000	12059	6164	33	0	\N
103655	1726	712660175000	12059	6164	34	0	\N
103656	1726	712659174000	12059	6164	35	0	\N
103657	1726	712658173000	12059	6164	36	0	\N
103658	1726	712657172000	12059	6164	37	0	\N
103659	1726	712656171000	12059	6164	38	0	\N
103660	1726	712655170000	12059	6164	39	0	\N
103661	1726	712654169000	12059	6164	40	0	\N
103662	1726	712653168000	12059	6164	41	0	\N
103663	1726	712652167000	12059	6164	42	0	\N
103664	1726	712651166000	12059	6164	43	0	\N
103665	1726	712650165000	12059	6164	44	0	\N
103666	1726	712649164000	12059	6164	45	0	\N
103667	1726	712648163000	12059	6164	46	0	\N
103668	1726	712647162000	12059	6164	47	0	\N
103669	1726	712646161000	12059	6164	48	0	\N
103670	1726	712645160000	12059	6164	49	0	\N
103671	1726	712644159000	12059	6164	50	0	\N
103672	1726	712643158000	12059	6164	51	0	\N
103673	1726	712642157000	12059	6164	52	0	\N
103674	1726	712641156000	12059	6164	53	0	\N
103675	1726	712640155000	12059	6164	54	0	\N
103676	1726	712639154000	12059	6164	55	0	\N
103677	1726	712638153000	12059	6164	57	0	\N
103678	1726	712637152000	12059	6164	58	0	\N
103679	1726	712636151000	12059	6164	59	0	\N
103680	1726	712635150000	12059	6164	60	0	\N
103681	1726	712634149000	12059	6164	61	0	\N
103682	1726	712633148000	12059	6164	62	0	\N
103684	1573	23035809000000	12061	6109	0	0	\N
103685	1573	23030808000000	12061	6109	1	0	\N
103686	1573	23025807000000	12061	6109	2	0	\N
103687	1573	23020806000000	12061	6109	3	0	\N
103688	1939	2150980000000	12061	6109	4	0	\N
103689	1726	712762277000	12061	6109	5	0	\N
103690	1726	712761276000	12061	6109	6	0	\N
103691	1775	916000000	12061	6109	7	0	\N
103692	1726	712760275000	12061	6109	8	0	\N
103693	1521	1000000	12061	6109	9	0	\N
103694	1775	905000000	12061	6109	10	0	\N
103695	1726	712759274000	12061	6109	11	0	\N
103696	1726	712758273000	12061	6109	12	0	\N
103697	1726	712757272000	12061	6109	13	0	\N
103698	1726	712756271000	12061	6109	14	0	\N
103699	1769	1708900000	12061	6109	15	0	\N
103700	1573	12701805000000	12061	6109	16	0	\N
103701	1775	884000000	12061	6109	17	0	\N
103702	1726	712755270000	12061	6109	18	0	\N
103703	1726	712754269000	12061	6109	19	0	\N
103704	1726	712753268000	12061	6109	20	0	\N
103705	1726	712752267000	12061	6109	21	0	\N
103706	1726	712751266000	12061	6109	22	0	\N
103707	1726	712750265000	12061	6109	23	0	\N
103708	1726	712749264000	12061	6109	24	0	\N
103709	1726	712748263000	12061	6109	25	0	\N
103710	1726	712747262000	12061	6109	26	0	\N
103711	1726	712746261000	12061	6109	27	0	\N
103712	1726	712745260000	12061	6109	28	0	\N
103713	1726	712744259000	12061	6109	29	0	\N
103714	1726	712743258000	12061	6109	30	0	\N
103715	1726	712742257000	12061	6109	31	0	\N
103716	1726	712741256000	12061	6109	32	0	\N
103717	1726	712740255000	12061	6109	33	0	\N
103718	1726	712739254000	12061	6109	34	0	\N
103719	1726	712738253000	12061	6109	35	0	\N
103720	1726	712737252000	12061	6109	36	0	\N
103721	1726	712736251000	12061	6109	37	0	\N
103722	1726	712735250000	12061	6109	38	0	\N
103723	1726	712734249000	12061	6109	39	0	\N
103724	1726	712733248000	12061	6109	40	0	\N
103725	1726	712732247000	12061	6109	41	0	\N
103726	1726	712731246000	12061	6109	42	0	\N
103727	1726	712730245000	12061	6109	43	0	\N
103728	1726	712729244000	12061	6109	44	0	\N
103729	1726	712728243000	12061	6109	45	0	\N
103730	1726	712727242000	12061	6109	46	0	\N
103731	1726	712726241000	12061	6109	47	0	\N
103732	1726	712725240000	12061	6109	48	0	\N
103733	1726	712724239000	12061	6109	49	0	\N
103734	1726	712723238000	12061	6109	50	0	\N
103735	1726	712722237000	12061	6109	51	0	\N
103736	1726	712721236000	12061	6109	52	0	\N
103737	1726	712720235000	12061	6109	53	0	\N
103738	1726	712719234000	12061	6109	54	0	\N
103739	1726	712718233000	12061	6109	55	0	\N
103740	1726	712717232000	12061	6109	56	0	\N
103741	1726	712716231000	12061	6109	57	0	\N
103742	1726	712715230000	12061	6109	58	0	\N
103743	1726	712714229000	12061	6109	59	0	\N
103744	1726	712713228000	12061	6109	60	0	\N
103745	1726	712712227000	12061	6109	61	0	\N
103746	1726	712711226000	12061	6109	62	0	\N
103747	1726	712710225000	12061	6109	63	0	\N
103748	1726	712709224000	12061	6109	64	0	\N
103749	1726	712708223000	12061	6109	65	0	\N
103750	1726	712707222000	12061	6109	66	0	\N
103751	1726	712706221000	12061	6109	67	0	\N
103752	1726	712705220000	12061	6109	68	0	\N
103753	1726	712704219000	12061	6109	69	0	\N
103754	1726	712703218000	12061	6109	70	0	\N
103755	1726	712702217000	12061	6109	71	0	\N
103756	1726	712701216000	12061	6109	72	0	\N
103757	1726	712700215000	12061	6109	73	0	\N
103758	1726	712699214000	12061	6109	74	0	\N
103759	1726	712698213000	12061	6109	75	0	\N
103760	1726	712697212000	12061	6109	76	0	\N
103761	1726	712696211000	12061	6109	77	0	\N
103762	1726	712695210000	12061	6109	78	0	\N
103763	1726	712694209000	12061	6109	79	0	\N
103764	1726	712693208000	12061	6109	80	0	\N
103765	1726	712692207000	12061	6109	81	0	\N
103766	1726	712691206000	12061	6109	82	0	\N
103767	1726	712690205000	12061	6109	83	0	\N
103768	1726	712689204000	12061	6109	84	0	\N
103769	1726	712688203000	12061	6109	85	0	\N
103770	1726	712687202000	12061	6109	86	0	\N
103771	1726	712686201000	12061	6109	87	0	\N
103772	1726	712685200000	12061	6109	88	0	\N
103773	1726	712684199000	12061	6109	89	0	\N
103774	1726	712683198000	12061	6109	90	0	\N
103775	1726	712682197000	12061	6109	91	0	\N
103776	1726	712681196000	12061	6109	92	0	\N
103777	1726	712680195000	12061	6109	93	0	\N
103778	1726	712679194000	12061	6109	94	0	\N
103779	1726	712678193000	12061	6109	95	0	\N
103780	1726	712677192000	12061	6109	96	0	\N
103781	1726	712676191000	12061	6109	97	0	\N
103782	1726	712675190000	12061	6109	98	0	\N
103783	1726	712674189000	12061	6109	99	0	\N
103784	1726	712673188000	12061	6109	100	0	\N
103785	1726	712672187000	12061	6109	101	0	\N
103786	1726	712671186000	12061	6109	102	0	\N
103787	1726	712670185000	12061	6109	103	0	\N
103788	1726	712669184000	12061	6109	104	0	\N
103789	1726	712668183000	12061	6109	105	0	\N
103790	1726	712667182000	12061	6109	106	0	\N
103791	1726	712666181000	12061	6109	107	0	\N
103792	1726	712665180000	12061	6109	108	0	\N
103793	1726	712664179000	12061	6109	109	0	\N
103794	1726	712663178000	12061	6109	110	0	\N
103795	1726	712662177000	12061	6109	111	0	\N
103796	1726	712661176000	12061	6109	112	0	\N
103797	1726	712660175000	12061	6109	113	0	\N
103798	1726	712659174000	12061	6109	115	0	\N
103799	1726	712658173000	12061	6109	116	0	\N
103800	1726	712657172000	12061	6109	117	0	\N
103801	1726	712656171000	12061	6109	118	0	\N
103802	1726	712655170000	12061	6109	119	0	\N
103803	1726	712654169000	12061	6109	120	0	\N
103804	1726	712653168000	12061	6109	121	0	\N
103805	1726	712652167000	12061	6109	122	0	\N
103806	1726	712651166000	12061	6109	123	0	\N
103807	1726	712650165000	12061	6109	124	0	\N
103808	1726	712649164000	12061	6109	125	0	\N
103815	1726	712630145000	12064	6209	0	0	\N
103816	1726	712629144000	12064	6209	1	0	\N
103817	2058	585000000	12064	6209	2	0	\N
103818	1769	1706900000	12064	6209	3	0	\N
103820	1726	712628143000	12066	6210	0	0	\N
103821	1939	2150980000000	12067	6120	0	0	\N
103822	1775	916000000	12067	6120	1	0	\N
103823	1521	1000000	12067	6120	2	0	\N
103824	1726	712703218000	12067	6120	3	0	\N
103825	1775	905000000	12067	6120	4	0	\N
103826	1769	1708900000	12067	6120	5	0	\N
103827	1775	884000000	12067	6120	6	0	\N
103828	1726	712702217000	12067	6120	7	0	\N
103829	1726	712701216000	12067	6120	8	0	\N
103830	1726	712700215000	12067	6120	9	0	\N
103831	1769	1707900000	12067	6120	10	0	\N
103832	1769	1706900000	12067	6120	11	0	\N
103833	1726	712699214000	12067	6120	12	0	\N
103834	1726	712698213000	12067	6120	13	0	\N
103835	1726	712697212000	12067	6120	14	0	\N
103836	1726	712696211000	12067	6120	15	0	\N
103837	1726	712695210000	12067	6120	16	0	\N
103838	1726	712694209000	12067	6120	17	0	\N
103839	1726	712693208000	12067	6120	18	0	\N
103840	1726	712692207000	12067	6120	19	0	\N
103841	1726	712691206000	12067	6120	20	0	\N
103842	1726	712690205000	12067	6120	21	0	\N
103843	1726	712689204000	12067	6120	22	0	\N
103844	1726	712688203000	12067	6120	23	0	\N
103845	1726	712687202000	12067	6120	24	0	\N
103846	1726	712686201000	12067	6120	25	0	\N
103847	1726	712685200000	12067	6120	26	0	\N
103848	1726	712684199000	12067	6120	27	0	\N
103849	1726	712683198000	12067	6120	29	0	\N
103850	1726	712682197000	12067	6120	30	0	\N
103851	1726	712681196000	12067	6120	31	0	\N
103852	1726	712680195000	12067	6120	32	0	\N
103853	1726	712679194000	12067	6120	33	0	\N
103854	1726	712678193000	12067	6120	34	0	\N
103855	1726	712677192000	12067	6120	35	0	\N
103856	1726	712676191000	12067	6120	36	0	\N
103857	1726	712675190000	12067	6120	37	0	\N
103858	1726	712674189000	12067	6120	38	0	\N
103859	1726	712673188000	12067	6120	39	0	\N
103860	1726	712672187000	12067	6120	40	0	\N
103861	1726	712671186000	12067	6120	41	0	\N
103862	1726	712670185000	12067	6120	42	0	\N
103863	1726	712669184000	12067	6120	43	0	\N
103864	1726	712668183000	12067	6120	44	0	\N
103865	1726	712667182000	12067	6120	45	0	\N
103866	1726	712666181000	12067	6120	46	0	\N
103867	1726	712665180000	12067	6120	47	0	\N
103868	1726	712664179000	12067	6120	48	0	\N
103869	1726	712663178000	12067	6120	49	0	\N
103870	1726	712662177000	12067	6120	50	0	\N
103871	1726	712661176000	12067	6120	51	0	\N
103872	1726	712660175000	12067	6120	52	0	\N
103873	1726	712659174000	12067	6120	53	0	\N
103874	1726	712658173000	12067	6120	54	0	\N
103875	1726	712657172000	12067	6120	55	0	\N
103876	1726	712656171000	12067	6120	56	0	\N
103877	1726	712655170000	12067	6120	57	0	\N
103878	1726	712654169000	12067	6120	58	0	\N
103879	1726	712653168000	12067	6120	59	0	\N
103880	1726	712652167000	12067	6120	60	0	\N
103881	1726	712651166000	12067	6120	61	0	\N
103882	1726	712650165000	12067	6120	62	0	\N
103883	1726	712649164000	12067	6120	63	0	\N
103884	1726	712648163000	12067	6120	64	0	\N
103885	1726	712647162000	12067	6120	65	0	\N
103886	1726	712646161000	12067	6120	66	0	\N
103887	1726	712645160000	12067	6120	67	0	\N
103888	1726	712644159000	12067	6120	68	0	\N
103889	1726	712643158000	12067	6120	69	0	\N
103890	1726	712642157000	12067	6120	70	0	\N
103891	1726	712641156000	12067	6120	71	0	\N
103892	1726	712640155000	12067	6120	72	0	\N
103893	1726	712639154000	12067	6120	73	0	\N
103894	1726	712638153000	12067	6120	74	0	\N
103895	1726	712637152000	12067	6120	75	0	\N
103896	1726	712636151000	12067	6120	76	0	\N
103897	1726	712635150000	12067	6120	77	0	\N
103898	1726	712634149000	12067	6120	78	0	\N
103899	1726	712633148000	12067	6120	79	0	\N
103900	1726	712632147000	12067	6120	80	0	\N
103901	1726	712631146000	12067	6120	81	0	\N
103902	1726	712630145000	12067	6120	82	0	\N
103903	1726	712629144000	12067	6120	83	0	\N
103904	1726	712628143000	12067	6120	84	0	\N
103811	1726	712630145000	12063	6209	0	0	4093
103812	1726	712629144000	12063	6209	1	0	4094
103813	2058	585000000	12063	6209	2	0	1
103814	1769	1706900000	12063	6209	3	0	27
103819	1726	712628143000	12065	6210	0	0	4095
103905	1726	712627142000	12067	6120	85	0	\N
103906	1726	711417142000	12067	6120	86	0	\N
103907	1726	711416141000	12067	6120	87	0	\N
103919	1726	711408133000	12074	6217	0	0	\N
103920	1726	711407132000	12074	6217	1	0	\N
103921	2058	583000000	12074	6217	2	0	\N
103927	1726	711405130000	12078	6219	0	0	\N
103928	1726	711404129000	12079	6220	0	0	\N
103933	1726	711400125000	12082	6222	0	0	\N
103934	1726	711399124000	12082	6222	1	0	\N
103935	1726	711400125000	12083	6222	0	0	\N
103936	1726	711399124000	12083	6222	1	0	\N
103937	1726	711400125000	12084	6222	0	0	\N
103938	1726	711399124000	12084	6222	1	0	\N
103939	1726	711400125000	12085	6222	0	0	\N
103940	1726	711399124000	12085	6222	1	0	\N
103944	1726	711397122000	12088	6224	0	0	\N
103945	1775	873000000	12088	6224	1	0	\N
103946	1726	711397122000	12089	6224	0	0	\N
103947	1775	873000000	12089	6224	1	0	\N
103950	1573	23035809000000	12091	6029	0	0	\N
103951	1573	23030808000000	12091	6029	1	0	\N
103952	1573	23025807000000	12091	6029	2	0	\N
103953	1573	23020806000000	12091	6029	3	0	\N
103954	1634	23738831223333	12091	6029	4	0	\N
103955	1555	14828392276082	12091	6029	5	0	\N
103956	1555	11724703786361	12091	6029	6	0	\N
103957	1555	9630580064175	12091	6029	7	0	\N
103958	1555	3795135979096	12091	6029	8	0	\N
103959	1686	15097674705523	12091	6029	9	0	\N
103960	1686	14866263563482	12091	6029	10	0	\N
103961	1634	23727961050489	12091	6029	11	0	\N
103962	1939	2150980000000	12091	6029	12	0	\N
103963	641	68061357200000	12091	6029	13	0	\N
103964	1634	23419794812544	12091	6029	14	0	\N
103965	1686	14634852421441	12091	6029	15	0	\N
103966	1686	12873315312881	12091	6029	16	0	\N
103967	1686	9716663827101	12091	6029	17	0	\N
103968	1686	7586804916122	12091	6029	18	0	\N
103969	1686	1651781550062	12091	6029	19	0	\N
103970	1634	23111628574599	12091	6029	20	0	\N
103971	1634	22803462336654	12091	6029	21	0	\N
103972	1634	20517008110328	12091	6029	22	0	\N
103973	1634	16419709647008	12091	6029	23	0	\N
103974	1634	13655177476572	12091	6029	24	0	\N
103975	1634	5951580641004	12091	6029	25	0	\N
103976	641	67787815600000	12091	6029	26	0	\N
103977	641	66866252400000	12091	6029	27	0	\N
103978	641	66535460000000	12091	6029	28	0	\N
103979	1775	916000000	12091	6029	29	0	\N
103980	1521	1000000	12091	6029	30	0	\N
103983	1521	1000000	12093	6199	0	0	\N
103984	1726	712641156000	12093	6199	1	0	\N
103985	1775	873000000	12093	6199	2	0	\N
103986	1769	1708900000	12093	6199	3	0	\N
103987	1726	712640155000	12093	6199	4	0	\N
103988	1726	712639154000	12093	6199	5	0	\N
103989	1726	712638153000	12093	6199	6	0	\N
103990	1726	712637152000	12093	6199	7	0	\N
103991	1726	712636151000	12093	6199	8	0	\N
103992	1726	712635150000	12093	6199	9	0	\N
103993	1726	712634149000	12093	6199	10	0	\N
103994	1726	712633148000	12093	6199	11	0	\N
103995	1726	712632147000	12093	6199	12	0	\N
103996	1726	712631146000	12093	6199	13	0	\N
103997	1726	712630145000	12093	6199	14	0	\N
103998	1726	712629144000	12093	6199	15	0	\N
103999	1726	712628143000	12093	6199	16	0	\N
104000	1726	712627142000	12093	6199	17	0	\N
104001	1726	711417142000	12093	6199	18	0	\N
104002	1726	711416141000	12093	6199	19	0	\N
104003	1726	711415140000	12093	6199	20	0	\N
104004	1726	711414139000	12093	6199	21	0	\N
104005	1726	711413138000	12093	6199	22	0	\N
104006	1726	711412137000	12093	6199	23	0	\N
104007	1726	711411136000	12093	6199	24	0	\N
104008	1726	711410135000	12093	6199	25	0	\N
104009	1726	711409134000	12093	6199	26	0	\N
104010	1726	711408133000	12093	6199	27	0	\N
104011	1726	711407132000	12093	6199	28	0	\N
104012	1726	711406131000	12093	6199	29	0	\N
104013	1726	711405130000	12093	6199	30	0	\N
104014	1726	711404129000	12093	6199	31	0	\N
104015	1726	711403128000	12093	6199	32	0	\N
104016	1726	711402127000	12093	6199	33	0	\N
104017	1726	711401126000	12093	6199	34	0	\N
104018	1726	711400125000	12093	6199	35	0	\N
104019	1726	711399124000	12093	6199	36	0	\N
104020	1726	711398123000	12093	6199	37	0	\N
104021	1726	711397122000	12093	6199	38	0	\N
104022	1726	711396121000	12093	6199	39	0	\N
104023	1726	711395120000	12093	6199	40	0	\N
104024	1769	1707900000	12093	6199	41	0	\N
104025	1769	1706900000	12093	6199	42	0	\N
104036	1726	711386111000	12099	6230	0	0	\N
104037	1726	711385110000	12099	6230	1	0	\N
104038	1726	711384109000	12100	6231	0	0	\N
104039	1726	711383108000	12100	6231	1	0	\N
103910	1726	711416141000	12068	6211	2	0	4098
103911	1726	711415140000	12068	6211	3	0	4099
103912	1726	711414139000	12069	6212	0	0	4100
103913	2058	584000000	12070	6213	0	0	2
103914	1726	711413138000	12070	6213	1	0	4101
103916	1726	711411136000	12072	6215	0	0	4103
103917	1726	711410135000	12073	6216	0	0	4104
103918	1726	711409134000	12073	6216	2	0	4105
103922	1726	711408133000	12075	6217	0	0	4106
103923	1726	711407132000	12075	6217	1	0	4107
103925	1726	711406131000	12076	6218	0	0	4108
103926	1726	711405130000	12077	6219	0	0	4109
103929	1726	711404129000	12080	6220	0	0	4110
103930	1726	711403128000	12081	6221	0	0	4111
103932	1726	711401126000	12081	6221	2	0	4113
103941	1726	711400125000	12086	6222	0	0	4114
103942	1726	711399124000	12086	6222	1	0	4115
103943	1726	711398123000	12087	6223	0	0	4116
103948	1726	711397122000	12090	6224	0	0	4117
103981	1726	711396121000	12092	6225	0	0	4118
103982	1726	711395120000	12092	6225	1	0	4119
104026	1726	711394119000	12094	6226	0	0	4120
104027	1726	711393118000	12094	6226	1	0	4121
104028	1726	711392117000	12094	6226	2	0	4122
104030	1726	711390115000	12095	6227	1	0	4124
104031	1726	711389114000	12095	6227	2	0	4125
104032	1726	711388113000	12096	6228	0	0	4126
104033	1726	711387112000	12097	6229	0	0	4127
104035	1726	711385110000	12098	6230	1	0	4129
104040	1726	711384109000	12101	6231	0	0	4130
104042	1950	3349852000000	12102	6232	0	0	\N
104043	1726	711382107000	12102	6232	1	0	\N
104046	1726	711381106000	12104	6233	0	0	\N
104048	1726	711380105000	12106	6234	0	0	\N
104050	1726	711379104000	12109	6236	0	0	\N
104057	1726	710165100000	12114	6239	0	0	\N
104058	1726	710164099000	12115	6240	0	0	\N
104061	1726	710162097000	12119	6243	0	0	\N
104062	1726	710161096000	12119	6243	1	0	\N
104066	1726	710160095000	12123	6244	0	0	\N
104067	1726	710159094000	12124	6245	0	0	\N
104068	1726	710159094000	12125	6245	0	0	\N
104073	1726	710156091000	12129	6247	0	0	\N
104074	1726	710155090000	12130	6248	0	0	\N
104075	1726	710154089000	12130	6248	1	0	\N
104076	1726	710153088000	12130	6248	2	0	\N
104077	1726	710155090000	12132	6248	0	0	\N
104078	1726	710154089000	12132	6248	1	0	\N
104079	1726	710153088000	12132	6248	2	0	\N
104080	1726	710155090000	12133	6248	0	0	\N
104081	1726	710154089000	12133	6248	1	0	\N
104082	1726	710153088000	12133	6248	2	0	\N
104090	1726	710148083000	12141	6254	0	0	\N
104091	1726	710147082000	12141	6254	1	0	\N
104094	1726	710148083000	12143	6254	0	0	\N
104095	1726	710147082000	12143	6254	1	0	\N
104096	1726	710148083000	12144	6254	0	0	\N
104097	1726	710147082000	12144	6254	1	0	\N
104106	1726	710143078000	12150	6258	0	0	\N
104107	1726	710142077000	12151	6259	0	0	\N
104109	1726	710141076000	12153	6260	0	0	\N
104110	1726	710141076000	12154	6260	0	0	\N
104114	1726	708931076000	12157	6261	0	0	\N
104115	1726	708931076000	12158	6261	0	0	\N
104116	1726	708930075000	12158	6261	1	0	\N
104117	1726	708931076000	12159	6261	0	0	\N
104118	1726	708929074000	12160	6262	0	0	\N
104119	1726	708928073000	12160	6262	1	0	\N
104120	1726	708927072000	12160	6262	2	0	\N
104121	1726	708926071000	12160	6262	3	0	\N
104122	1726	708925070000	12160	6262	4	0	\N
104123	1726	708929074000	12161	6262	0	0	\N
104124	1726	708928073000	12161	6262	1	0	\N
104125	1726	708927072000	12161	6262	2	0	\N
104126	1726	708926071000	12161	6262	3	0	\N
104127	1726	708925070000	12161	6262	4	0	\N
104133	1726	708929074000	12163	6262	0	0	\N
104134	1726	708928073000	12163	6262	1	0	\N
104135	1726	708927072000	12163	6262	2	0	\N
104136	1726	708926071000	12163	6262	3	0	\N
104137	1726	708925070000	12163	6262	4	0	\N
104143	1726	708920065000	12169	6265	0	0	\N
104145	1726	708919064000	12171	6266	0	0	\N
104151	1726	708916061000	12174	6268	0	0	\N
104152	1726	708915060000	12174	6268	1	0	\N
104153	1726	708914059000	12174	6268	2	0	\N
104154	1726	708913058000	12175	6269	0	0	\N
104155	1726	708912057000	12175	6269	1	0	\N
104156	1726	708911056000	12175	6269	2	0	\N
104160	1726	708910055000	12177	6270	0	0	\N
104166	1726	708909054000	12180	6271	0	0	\N
104167	1726	708908053000	12180	6271	1	0	\N
104168	1726	708907052000	12180	6271	2	0	\N
104169	1726	708906051000	12180	6271	3	0	\N
104170	1726	708909054000	12181	6271	0	0	\N
104171	1726	708908053000	12181	6271	1	0	\N
104172	1726	708907052000	12181	6271	2	0	\N
104173	1726	708906051000	12181	6271	3	0	\N
104176	1726	708904049000	12183	6273	0	0	\N
104045	1726	711382107000	12103	6232	1	0	4132
104047	1726	711381106000	12105	6233	0	0	4133
104049	1726	711380105000	12108	6235	0	0	4134
104051	1726	711379104000	12110	6236	0	0	4135
104052	1726	711378103000	12111	6237	0	0	4136
104054	1726	711376101000	12112	6238	1	0	4138
104055	1726	710166101000	12112	6238	2	0	4139
104056	1726	710165100000	12113	6239	0	0	4140
104059	1726	710164099000	12116	6240	0	0	4141
104060	1726	710163098000	12117	6241	0	0	4142
104064	1726	710161096000	12121	6243	1	0	4144
104065	1726	710160095000	12122	6244	0	0	4145
104069	1726	710159094000	12126	6245	0	0	4146
104070	1726	710158093000	12127	6246	0	0	4147
104072	1726	710156091000	12128	6247	0	0	4149
104083	1726	710155090000	12134	6248	0	0	4150
104084	1726	710154089000	12134	6248	1	0	4151
104085	1726	710153088000	12134	6248	2	0	4152
104086	1726	710152087000	12135	6249	0	0	4153
104088	1726	710150085000	12137	6251	0	0	4155
104089	1726	710149084000	12138	6252	0	0	4156
104092	1726	710148083000	12142	6254	0	0	4157
104093	1726	710147082000	12142	6254	1	0	4158
104098	1726	710146081000	12145	6255	0	0	4159
104100	641	68348589600000	12145	6255	2	0	10
104101	641	67930027400000	12145	6255	3	0	11
104102	641	67779788000000	12145	6255	4	0	12
104103	1726	710145080000	12146	6256	0	0	4160
104105	1726	710143078000	12149	6258	0	0	4162
104108	1726	710142077000	12152	6259	0	0	4163
104111	1726	710141076000	12155	6260	0	0	4164
104112	1726	708931076000	12156	6261	0	0	4165
104113	1726	708930075000	12156	6261	1	0	4166
104129	1726	708928073000	12162	6262	1	0	4168
104130	1726	708927072000	12162	6262	2	0	4169
104131	1726	708926071000	12162	6262	3	0	4170
104132	1726	708925070000	12162	6262	4	0	4171
104138	1726	708924069000	12166	6264	0	0	4172
104140	1726	708922067000	12166	6264	2	0	4174
104141	1726	708921066000	12166	6264	3	0	4175
104142	1726	708920065000	12168	6265	0	0	4176
104144	1726	708919064000	12170	6266	0	0	4177
104147	1726	708917062000	12172	6267	1	0	4179
104148	1726	708916061000	12173	6268	0	0	4180
104149	1726	708915060000	12173	6268	1	0	4181
104150	1726	708914059000	12173	6268	2	0	4182
104157	1726	708913058000	12176	6269	0	0	4183
104159	1726	708911056000	12176	6269	2	0	4185
104161	1726	708910055000	12178	6270	0	0	4186
104162	1726	708909054000	12179	6271	0	0	4187
104163	1726	708908053000	12179	6271	1	0	4188
104164	1726	708907052000	12179	6271	2	0	4189
104174	1474	4104357000023	12182	6272	0	0	13
104175	1726	708905050000	12182	6272	1	0	4191
104178	1474	3384356000023	12185	6121	0	0	\N
104179	1726	711415140000	12185	6121	1	0	\N
104180	1950	3949852000000	12185	6121	2	0	\N
104181	1775	873000000	12185	6121	3	0	\N
104182	1726	711414139000	12185	6121	4	0	\N
104183	1726	711413138000	12185	6121	5	0	\N
104184	1726	711412137000	12185	6121	6	0	\N
104185	1726	711411136000	12185	6121	7	0	\N
104186	1726	711410135000	12185	6121	8	0	\N
104187	1726	711409134000	12185	6121	9	0	\N
104188	1726	711408133000	12185	6121	10	0	\N
104189	1726	711407132000	12185	6121	11	0	\N
104190	1726	711406131000	12185	6121	12	0	\N
104191	641	67032818200000	12185	6121	13	0	\N
104192	641	66908581600000	12185	6121	14	0	\N
104193	1726	711405130000	12185	6121	15	0	\N
104194	1726	711404129000	12185	6121	16	0	\N
104195	1726	711403128000	12185	6121	17	0	\N
104196	1726	711402127000	12185	6121	18	0	\N
104197	1726	711401126000	12185	6121	19	0	\N
104198	1726	711400125000	12185	6121	20	0	\N
104199	1726	711399124000	12185	6121	21	0	\N
104200	1726	711398123000	12185	6121	22	0	\N
104201	1726	711397122000	12185	6121	23	0	\N
104202	1726	711396121000	12185	6121	24	0	\N
104203	1726	711395120000	12185	6121	25	0	\N
104204	1726	711394119000	12185	6121	26	0	\N
104205	1726	711393118000	12185	6121	27	0	\N
104206	1726	711392117000	12185	6121	28	0	\N
104207	1726	711391116000	12185	6121	29	0	\N
104208	1726	711390115000	12185	6121	30	0	\N
104209	1726	711389114000	12185	6121	31	0	\N
104210	1726	711388113000	12185	6121	32	0	\N
104211	1726	711387112000	12185	6121	33	0	\N
104212	1726	711386111000	12185	6121	34	0	\N
104213	1726	711385110000	12185	6121	35	0	\N
104214	641	66490019400000	12185	6121	36	0	\N
104215	641	66339780000000	12185	6121	37	0	\N
104216	1726	711384109000	12185	6121	38	0	\N
104217	1726	711383108000	12185	6121	39	0	\N
104218	1726	711382107000	12185	6121	40	0	\N
104219	1726	711381106000	12185	6121	41	0	\N
104220	1726	711380105000	12185	6121	42	0	\N
104221	1726	711379104000	12185	6121	43	0	\N
104222	1726	711378103000	12185	6121	44	0	\N
104223	1726	711377102000	12185	6121	45	0	\N
104224	1726	711376101000	12185	6121	46	0	\N
104225	1726	710166101000	12185	6121	47	0	\N
104226	1726	710165100000	12185	6121	48	0	\N
104227	1726	710164099000	12185	6121	49	0	\N
104228	1726	710163098000	12185	6121	50	0	\N
104229	1726	710162097000	12185	6121	51	0	\N
104230	1726	710161096000	12185	6121	52	0	\N
104231	1726	710160095000	12185	6121	53	0	\N
104232	1726	710159094000	12185	6121	54	0	\N
104233	1726	710158093000	12185	6121	55	0	\N
104234	1726	710157092000	12185	6121	56	0	\N
104235	1726	710156091000	12185	6121	57	0	\N
104236	1726	710155090000	12185	6121	58	0	\N
104237	1726	710154089000	12185	6121	59	0	\N
104238	1726	710153088000	12185	6121	60	0	\N
104239	1726	710152087000	12185	6121	61	0	\N
104240	1726	710151086000	12185	6121	62	0	\N
104241	1726	710150085000	12185	6121	63	0	\N
104242	1726	710149084000	12185	6121	64	0	\N
104243	1726	710148083000	12185	6121	65	0	\N
104244	1726	710147082000	12185	6121	67	0	\N
104245	1726	710146081000	12185	6121	68	0	\N
104246	1726	710145080000	12185	6121	69	0	\N
104247	1726	710144079000	12185	6121	70	0	\N
104248	1726	710143078000	12185	6121	71	0	\N
104249	1726	710142077000	12185	6121	72	0	\N
104250	1726	710141076000	12185	6121	73	0	\N
104251	1726	708931076000	12185	6121	74	0	\N
104252	1726	708930075000	12185	6121	75	0	\N
104253	1726	708929074000	12185	6121	76	0	\N
104254	1726	708928073000	12185	6121	77	0	\N
104255	1726	708927072000	12185	6121	78	0	\N
104256	1726	708926071000	12185	6121	79	0	\N
104257	1726	708925070000	12185	6121	80	0	\N
104258	1726	708924069000	12185	6121	81	0	\N
104259	1726	708923068000	12185	6121	82	0	\N
104260	1726	708922067000	12185	6121	83	0	\N
104261	1726	708921066000	12185	6121	84	0	\N
104262	1726	708920065000	12185	6121	85	0	\N
104263	1726	708919064000	12185	6121	86	0	\N
104264	1726	708918063000	12185	6121	87	0	\N
104265	1726	708917062000	12185	6121	88	0	\N
104266	1726	708916061000	12185	6121	89	0	\N
104267	1726	708915060000	12185	6121	90	0	\N
104268	1726	708914059000	12185	6121	91	0	\N
104269	1726	708913058000	12185	6121	92	0	\N
104270	1726	708912057000	12185	6121	93	0	\N
104271	1726	708911056000	12185	6121	94	0	\N
104272	1726	708910055000	12185	6121	95	0	\N
104273	1726	708909054000	12185	6121	96	0	\N
104274	1726	708908053000	12185	6121	97	0	\N
104275	1726	708907052000	12185	6121	98	0	\N
104276	1726	708906051000	12185	6121	99	0	\N
104277	1726	708905050000	12185	6121	100	0	\N
104278	1726	708904049000	12185	6121	101	0	\N
104279	1726	708903048000	12185	6121	102	0	\N
104283	1726	708901046000	12188	6275	0	0	\N
104287	1726	708900045000	12190	6276	0	0	\N
104288	1726	708899044000	12190	6276	1	0	\N
104289	1726	708898043000	12190	6276	2	0	\N
104290	1726	708900045000	12191	6276	0	0	\N
104291	1726	708899044000	12191	6276	1	0	\N
104292	1726	708898043000	12191	6276	2	0	\N
104293	1474	4104357000023	12192	6264	0	0	\N
104294	1726	708924069000	12192	6264	1	0	\N
104295	1726	708923068000	12192	6264	2	0	\N
104296	1726	708922067000	12192	6264	3	0	\N
104297	1726	708921066000	12192	6264	4	0	\N
104298	1726	708920065000	12192	6264	5	0	\N
104299	1726	708919064000	12192	6264	6	0	\N
104300	1726	708918063000	12192	6264	7	0	\N
104301	1726	708917062000	12192	6264	8	0	\N
104302	1726	708916061000	12192	6264	9	0	\N
104303	1726	708915060000	12192	6264	10	0	\N
104304	1726	708914059000	12192	6264	11	0	\N
104305	1726	708913058000	12192	6264	12	0	\N
104306	1726	708912057000	12192	6264	13	0	\N
104307	1726	708911056000	12192	6264	14	0	\N
104308	1726	708910055000	12192	6264	15	0	\N
104309	1726	708909054000	12192	6264	16	0	\N
104310	1726	708908053000	12192	6264	17	0	\N
104311	1726	708907052000	12192	6264	18	0	\N
104312	1726	708906051000	12192	6264	19	0	\N
104281	1726	708902047000	12186	6274	1	0	4194
104282	1726	708901046000	12187	6275	0	0	4195
104284	1726	708900045000	12189	6276	0	0	4196
104285	1726	708899044000	12189	6276	1	0	4197
104286	1726	708898043000	12189	6276	2	0	4198
104313	1726	708905050000	12192	6264	20	0	\N
104314	1726	708904049000	12192	6264	21	0	\N
104315	1726	708903048000	12192	6264	22	0	\N
104316	1726	708902047000	12192	6264	23	0	\N
104317	1726	708901046000	12192	6264	24	0	\N
104318	1726	708900045000	12192	6264	25	0	\N
104319	1726	708899044000	12192	6264	26	0	\N
104320	1726	708898043000	12192	6264	27	0	\N
104322	1726	708897042000	12194	6277	0	0	\N
104343	1726	708882027000	12208	6289	0	0	\N
104344	2060	0	12209	6269	0	0	\N
104345	1705	5176761500145	12209	6269	1	0	\N
104346	1705	5111391500145	12209	6269	2	0	\N
104347	1705	5014501500145	12209	6269	3	0	\N
104348	1705	4960451500145	12209	6269	4	0	\N
104349	1474	4104357000023	12209	6269	5	0	\N
104353	1726	707669024000	12211	6291	0	0	\N
104354	1726	707669024000	12212	6291	0	0	\N
104359	1726	707667022000	12216	6293	0	0	\N
104360	1726	707666021000	12216	6293	1	0	\N
104361	1573	23035809000000	12217	6078	0	0	\N
104362	1573	23030808000000	12217	6078	1	0	\N
104363	1573	23025807000000	12217	6078	2	0	\N
104364	1573	23020806000000	12217	6078	3	0	\N
104365	1705	5176761500145	12217	6078	4	0	\N
104366	1705	5111391500145	12217	6078	5	0	\N
104367	1705	5014501500145	12217	6078	6	0	\N
104368	1705	4960451500145	12217	6078	7	0	\N
104369	1634	23738831223333	12217	6078	8	0	\N
104370	1555	14828392276082	12217	6078	9	0	\N
104371	1555	11724703786361	12217	6078	10	0	\N
104372	1555	9630580064175	12217	6078	11	0	\N
104373	1555	3795135979096	12217	6078	12	0	\N
104374	1634	23727961050489	12217	6078	13	0	\N
104375	1939	2150980000000	12217	6078	14	0	\N
104376	1634	23419794812544	12217	6078	15	0	\N
104377	1474	3384356000023	12217	6078	16	0	\N
104378	1634	23111628574599	12217	6078	17	0	\N
104379	1634	22803462336654	12217	6078	18	0	\N
104380	1634	20517008110328	12217	6078	19	0	\N
104381	1634	16419709647008	12217	6078	20	0	\N
104382	1634	13655177476572	12217	6078	21	0	\N
104383	1634	5951580641004	12217	6078	22	0	\N
104384	1775	916000000	12217	6078	23	0	\N
104385	1950	3949852000000	12217	6078	24	0	\N
104386	1521	1000000	12217	6078	25	0	\N
104387	1726	715232327000	12217	6078	26	0	\N
104388	1775	905000000	12217	6078	27	0	\N
104389	1769	1708900000	12217	6078	28	0	\N
104390	1573	12701805000000	12217	6078	29	0	\N
104391	1726	715231326000	12217	6078	30	0	\N
104392	1726	715230325000	12217	6078	31	0	\N
104393	1775	884000000	12217	6078	32	0	\N
104394	1775	873000000	12217	6078	33	0	\N
104395	641	67032818200000	12217	6078	34	0	\N
104396	641	66908581600000	12217	6078	35	0	\N
104397	641	66490019400000	12217	6078	36	0	\N
104398	641	66339780000000	12217	6078	37	0	\N
104399	1726	715229324000	12217	6078	38	0	\N
104400	1726	715228323000	12217	6078	39	0	\N
104401	1726	715227322000	12217	6078	40	0	\N
104402	1726	715226321000	12217	6078	41	0	\N
104403	1726	715225320000	12217	6078	42	0	\N
104404	1726	715224319000	12217	6078	43	0	\N
104405	1726	715223318000	12217	6078	44	0	\N
104406	1726	715222317000	12217	6078	45	0	\N
104407	1726	715221316000	12217	6078	46	0	\N
104408	1726	715220315000	12217	6078	47	0	\N
104409	1726	715219314000	12217	6078	48	0	\N
104410	1726	715218313000	12217	6078	49	0	\N
104411	1726	715217312000	12217	6078	50	0	\N
104412	1726	715216311000	12217	6078	51	0	\N
104413	1726	714006311000	12217	6078	52	0	\N
104414	1726	714005310000	12217	6078	53	0	\N
104415	1726	714004309000	12217	6078	54	0	\N
104416	1726	714003308000	12217	6078	55	0	\N
104417	1726	714002307000	12217	6078	56	0	\N
104418	1726	714001306000	12217	6078	57	0	\N
104419	1726	714000305000	12217	6078	58	0	\N
104420	1726	713999304000	12217	6078	59	0	\N
104421	1726	713998303000	12217	6078	60	0	\N
104422	1726	712788303000	12217	6078	61	0	\N
104423	1726	712787302000	12217	6078	62	0	\N
104424	1726	712786301000	12217	6078	63	0	\N
104425	1726	712785300000	12217	6078	64	0	\N
104426	1726	712784299000	12217	6078	65	0	\N
104427	1726	712783298000	12217	6078	66	0	\N
104428	1726	712782297000	12217	6078	67	0	\N
104429	1726	712781296000	12217	6078	68	0	\N
104430	1726	712780295000	12217	6078	69	0	\N
104431	1726	712779294000	12217	6078	70	0	\N
104432	1726	712778293000	12217	6078	71	0	\N
104433	1726	712777292000	12217	6078	72	0	\N
104434	1726	712776291000	12217	6078	73	0	\N
104435	1726	712775290000	12217	6078	74	0	\N
104436	1726	712774289000	12217	6078	75	0	\N
104437	1726	712773288000	12217	6078	76	0	\N
104438	1726	712772287000	12217	6078	77	0	\N
104439	1726	712771286000	12217	6078	78	0	\N
104440	1726	712770285000	12217	6078	79	0	\N
104441	1726	712769284000	12217	6078	80	0	\N
104442	1726	712768283000	12217	6078	81	0	\N
104443	1726	712767282000	12217	6078	82	0	\N
104444	1726	712766281000	12217	6078	83	0	\N
104445	1726	712765280000	12217	6078	84	0	\N
104446	1726	712764279000	12217	6078	85	0	\N
104447	1726	712763278000	12217	6078	86	0	\N
104448	1726	712762277000	12217	6078	87	0	\N
104324	1726	708895040000	12196	6279	0	0	4201
104325	1726	708894039000	12196	6279	1	0	4202
104326	1726	708893038000	12197	6280	0	0	4203
104327	2060	0	12198	6281	0	0	1
104328	1726	708892037000	12198	6281	1	0	4204
104330	1726	708891036000	12199	6282	1	0	4205
104331	1726	708890035000	12199	6282	2	0	4206
104332	1726	708889034000	12200	6283	0	0	4207
104333	1726	708888033000	12201	6284	0	0	4208
104334	1705	5111391500145	12202	6285	0	0	16
104336	1726	708887032000	12202	6285	2	0	4209
104337	1726	708886031000	12202	6285	3	0	4210
104338	1705	4960451500145	12203	6286	0	0	18
104339	1726	708885030000	12203	6286	2	0	4211
104341	1726	708883028000	12205	6288	0	0	4213
104342	1726	708882027000	12206	6289	0	0	4214
104350	1726	708881026000	12210	6290	0	0	4215
104351	1726	708880025000	12210	6290	1	0	4216
104352	1726	707670025000	12210	6290	2	0	4217
104356	1726	707668023000	12214	6292	0	0	4219
104357	1726	707667022000	12215	6293	0	0	4220
104358	1726	707666021000	12215	6293	1	0	4221
104449	1726	712761276000	12217	6078	88	0	\N
104450	1726	712760275000	12217	6078	89	0	\N
104451	1726	712759274000	12217	6078	90	0	\N
104452	1726	712758273000	12217	6078	91	0	\N
104453	1726	712757272000	12217	6078	92	0	\N
104454	1726	712756271000	12217	6078	93	0	\N
104455	1726	712755270000	12217	6078	94	0	\N
104456	1726	712754269000	12217	6078	95	0	\N
104457	1726	712753268000	12217	6078	96	0	\N
104458	1726	712752267000	12217	6078	97	0	\N
104459	1726	712751266000	12217	6078	98	0	\N
104460	1726	712750265000	12217	6078	99	0	\N
104461	1726	712749264000	12217	6078	100	0	\N
104462	1726	712748263000	12217	6078	101	0	\N
104463	1726	712747262000	12217	6078	102	0	\N
104464	1726	712746261000	12217	6078	103	0	\N
104465	1726	712745260000	12217	6078	104	0	\N
104466	1726	712744259000	12217	6078	105	0	\N
104467	1726	712743258000	12217	6078	106	0	\N
104468	1726	712742257000	12217	6078	107	0	\N
104469	1726	712741256000	12217	6078	108	0	\N
104470	1726	712740255000	12217	6078	109	0	\N
104471	1726	712739254000	12217	6078	110	0	\N
104472	1726	712738253000	12217	6078	111	0	\N
104473	1726	712737252000	12217	6078	112	0	\N
104474	1726	712736251000	12217	6078	114	0	\N
104475	1726	712735250000	12217	6078	115	0	\N
104476	1726	712734249000	12217	6078	116	0	\N
104477	1726	712733248000	12217	6078	117	0	\N
104478	1726	712732247000	12217	6078	118	0	\N
104479	1726	712731246000	12217	6078	119	0	\N
104480	1726	712730245000	12217	6078	120	0	\N
104481	1726	712729244000	12217	6078	121	0	\N
104482	1726	712728243000	12217	6078	122	0	\N
104483	1726	712727242000	12217	6078	123	0	\N
104484	1726	712726241000	12217	6078	124	0	\N
104485	1726	712725240000	12217	6078	125	0	\N
104488	1726	707665020000	12219	6294	0	0	\N
104489	1726	707664019000	12219	6294	1	0	\N
104490	1726	707665020000	12220	6294	0	0	\N
104491	1726	707664019000	12220	6294	1	0	\N
104492	1726	707665020000	12221	6294	0	0	\N
104493	1726	707664019000	12221	6294	1	0	\N
104496	1726	707662017000	12224	6296	0	0	\N
104500	1726	707661016000	12226	6297	0	0	\N
104501	1726	707660015000	12226	6297	1	0	\N
104502	1726	707659014000	12226	6297	2	0	\N
104504	1471	15877523000000	12228	6299	0	0	\N
104505	1471	15877523000000	12229	6299	0	0	\N
104506	1726	707657012000	12229	6299	1	0	\N
104509	1726	707657012000	12231	6299	0	0	\N
104515	1726	707654009000	12233	6301	0	0	\N
104517	1726	707654009000	12235	6301	0	0	\N
104518	1726	707654009000	12237	6301	0	0	\N
104519	1726	707653008000	12238	6302	0	0	\N
104521	1726	707653008000	12240	6302	0	0	\N
104523	1726	707652007000	12242	6303	0	0	\N
104532	1508	6767773111964	12246	6307	0	0	\N
104533	1726	707647002000	12246	6307	1	0	\N
104540	1508	6516183500009	12249	6308	0	0	\N
104541	1897	199000000	12249	6308	1	0	\N
104542	1726	707646001000	12249	6308	2	0	\N
104543	1726	707645000000	12249	6308	3	0	\N
104544	1508	20876716187700	12250	6301	0	0	\N
104545	1508	18962421650738	12250	6301	1	0	\N
104546	1508	15532030162099	12250	6301	2	0	\N
104547	1508	13217473416525	12250	6301	3	0	\N
104548	1508	6767773111964	12250	6301	4	0	\N
104549	1508	6516183500009	12250	6301	5	0	\N
104550	1897	199000000	12250	6301	6	0	\N
104551	1726	707654009000	12250	6301	7	0	\N
104552	1726	707653008000	12250	6301	8	0	\N
104553	1726	707652007000	12250	6301	9	0	\N
104554	1726	707651006000	12250	6301	10	0	\N
104555	1726	707650005000	12250	6301	11	0	\N
104556	1726	707649004000	12250	6301	12	0	\N
104557	1726	707648003000	12250	6301	13	0	\N
104558	1726	707647002000	12250	6301	14	0	\N
104559	1726	707646001000	12250	6301	15	0	\N
104560	1726	707645000000	12250	6301	16	0	\N
104561	1726	707643999000	12251	6309	0	0	\N
104564	1726	707642998000	12256	6310	0	0	\N
104567	1726	707639995000	12259	6313	0	0	\N
104568	1726	707638994000	12259	6313	1	0	\N
104569	1726	707637993000	12259	6313	2	0	\N
104573	2060	0	12261	6241	0	0	\N
104574	1705	5176761500145	12261	6241	1	0	\N
104575	1705	5111391500145	12261	6241	2	0	\N
104576	1705	5014501500145	12261	6241	3	0	\N
104577	1705	4960451500145	12261	6241	4	0	\N
104578	1471	15877523000000	12261	6241	5	0	\N
104579	1471	11301513000000	12261	6241	6	0	\N
104580	1471	8213503000000	12261	6241	7	0	\N
104581	1471	5659493000000	12261	6241	8	0	\N
104582	1508	20876716187700	12261	6241	9	0	\N
104583	1508	18962421650738	12261	6241	10	0	\N
104584	1508	15532030162099	12261	6241	11	0	\N
104494	1726	707663018000	12222	6295	0	0	4224
104495	1726	707662017000	12223	6296	0	0	4225
104497	1726	707661016000	12225	6297	0	0	4226
104498	1726	707660015000	12225	6297	1	0	4227
104499	1726	707659014000	12225	6297	2	0	4228
104507	1471	15877523000000	12230	6299	0	0	1
104508	1726	707657012000	12230	6299	1	0	4230
104510	1471	11301513000000	12232	6300	0	0	2
104511	1471	8213503000000	12232	6300	1	0	3
104512	1471	5659493000000	12232	6300	2	0	4
104514	1726	707655010000	12232	6300	4	0	4232
104516	1726	707654009000	12234	6301	0	0	4233
104520	1726	707653008000	12239	6302	0	0	4234
104522	1726	707652007000	12241	6303	0	0	4235
104525	1508	20876716187700	12244	6305	0	0	1
104526	1726	707650005000	12244	6305	1	0	4237
104527	1726	707649004000	12244	6305	2	0	4238
104528	1508	18962421650738	12245	6306	0	0	2
104529	1508	15532030162099	12245	6306	1	0	3
104531	1726	707648003000	12245	6306	3	0	4239
104534	1508	6767773111964	12247	6307	0	0	5
104535	1726	707647002000	12247	6307	1	0	4240
104536	1508	6516183500009	12248	6308	0	0	6
104537	1897	199000000	12248	6308	1	0	1
104539	1726	707645000000	12248	6308	3	0	4242
104562	1726	707643999000	12253	6309	0	0	4243
104563	1726	707642998000	12254	6310	0	0	4244
104565	1726	707641997000	12257	6311	0	0	4245
104570	1726	707639995000	12260	6313	0	0	4247
104571	1726	707638994000	12260	6313	1	0	4248
104572	1726	707637993000	12260	6313	2	0	4249
104585	1508	13217473416525	12261	6241	12	0	\N
104586	1508	6767773111964	12261	6241	13	0	\N
104587	1508	6516183500009	12261	6241	14	0	\N
104588	1474	4104357000023	12261	6241	15	0	\N
104589	1897	199000000	12261	6241	16	0	\N
104590	1726	710163098000	12261	6241	17	0	\N
104591	641	67752824200000	12261	6241	18	0	\N
104592	641	67628587600000	12261	6241	19	0	\N
104593	1726	710162097000	12261	6241	20	0	\N
104594	641	67210025400000	12261	6241	21	0	\N
104595	641	67059786000000	12261	6241	22	0	\N
104596	1726	710161096000	12261	6241	23	0	\N
104597	1726	710160095000	12261	6241	24	0	\N
104598	1726	710159094000	12261	6241	25	0	\N
104599	1726	710158093000	12261	6241	26	0	\N
104600	1726	710157092000	12261	6241	27	0	\N
104601	1726	710156091000	12261	6241	28	0	\N
104602	1726	710155090000	12261	6241	29	0	\N
104603	1726	710154089000	12261	6241	30	0	\N
104604	1726	710153088000	12261	6241	31	0	\N
104605	1726	710152087000	12261	6241	32	0	\N
104606	1726	710151086000	12261	6241	33	0	\N
104607	1726	710150085000	12261	6241	34	0	\N
104608	1726	710149084000	12261	6241	35	0	\N
104609	1726	710148083000	12261	6241	36	0	\N
104610	1726	710147082000	12261	6241	37	0	\N
104611	1726	710146081000	12261	6241	39	0	\N
104612	1726	710145080000	12261	6241	40	0	\N
104613	1726	710144079000	12261	6241	41	0	\N
104614	1726	710143078000	12261	6241	42	0	\N
104615	1726	710142077000	12261	6241	43	0	\N
104616	1726	710141076000	12261	6241	44	0	\N
104617	1726	708931076000	12261	6241	45	0	\N
104618	1726	708930075000	12261	6241	46	0	\N
104619	1726	708929074000	12261	6241	47	0	\N
104620	1726	708928073000	12261	6241	48	0	\N
104621	1726	708927072000	12261	6241	49	0	\N
104622	1726	708926071000	12261	6241	50	0	\N
104623	1726	708925070000	12261	6241	51	0	\N
104624	1726	708924069000	12261	6241	52	0	\N
104625	1726	708923068000	12261	6241	53	0	\N
104626	1726	708922067000	12261	6241	54	0	\N
104627	1726	708921066000	12261	6241	55	0	\N
104628	1726	708920065000	12261	6241	56	0	\N
104629	1726	708919064000	12261	6241	57	0	\N
104630	1726	708918063000	12261	6241	58	0	\N
104631	1726	708917062000	12261	6241	59	0	\N
104632	1726	708916061000	12261	6241	60	0	\N
104633	1726	708915060000	12261	6241	61	0	\N
104634	1726	708914059000	12261	6241	62	0	\N
104635	1726	708913058000	12261	6241	63	0	\N
104636	1726	708912057000	12261	6241	64	0	\N
104637	1726	708911056000	12261	6241	65	0	\N
104638	1726	708910055000	12261	6241	66	0	\N
104639	1726	708909054000	12261	6241	67	0	\N
104640	1726	708908053000	12261	6241	68	0	\N
104641	1726	708907052000	12261	6241	69	0	\N
104642	1726	708906051000	12261	6241	70	0	\N
104643	1726	708905050000	12261	6241	71	0	\N
104644	1726	708904049000	12261	6241	72	0	\N
104645	1726	708903048000	12261	6241	73	0	\N
104646	1726	708902047000	12261	6241	74	0	\N
104647	1726	708901046000	12261	6241	75	0	\N
104648	1726	708900045000	12261	6241	76	0	\N
104649	1726	708899044000	12261	6241	77	0	\N
104650	1726	708898043000	12261	6241	78	0	\N
104651	1726	708897042000	12261	6241	79	0	\N
104652	1726	708896041000	12261	6241	80	0	\N
104653	1726	708895040000	12261	6241	81	0	\N
104654	1726	708894039000	12261	6241	82	0	\N
104655	1726	708893038000	12261	6241	83	0	\N
104656	1726	708892037000	12261	6241	84	0	\N
104657	1726	708891036000	12261	6241	85	0	\N
104658	1726	708890035000	12261	6241	86	0	\N
104659	1726	708889034000	12261	6241	87	0	\N
104660	1726	708888033000	12261	6241	88	0	\N
104661	1726	708887032000	12261	6241	89	0	\N
104662	1726	708886031000	12261	6241	90	0	\N
104663	1726	708885030000	12261	6241	91	0	\N
104664	1726	708884029000	12261	6241	92	0	\N
104665	1726	708883028000	12261	6241	93	0	\N
104666	1726	708882027000	12261	6241	94	0	\N
104667	1726	708881026000	12261	6241	95	0	\N
104668	1726	708880025000	12261	6241	96	0	\N
104669	1726	707670025000	12261	6241	97	0	\N
104670	1726	707669024000	12261	6241	98	0	\N
104671	1726	707668023000	12261	6241	99	0	\N
104672	1726	707667022000	12261	6241	100	0	\N
104673	1726	707666021000	12261	6241	101	0	\N
104674	1726	707665020000	12261	6241	102	0	\N
104675	1726	707664019000	12261	6241	103	0	\N
104676	1726	707663018000	12261	6241	104	0	\N
104677	1726	707662017000	12261	6241	105	0	\N
104678	1726	707661016000	12261	6241	106	0	\N
104679	1726	707660015000	12261	6241	107	0	\N
104680	1726	707659014000	12261	6241	108	0	\N
104681	1726	707658013000	12261	6241	109	0	\N
104682	1726	707657012000	12261	6241	110	0	\N
104683	1726	707656011000	12261	6241	111	0	\N
104684	1726	707655010000	12261	6241	112	0	\N
104685	1726	707654009000	12261	6241	113	0	\N
104686	1726	707653008000	12261	6241	114	0	\N
104687	1726	707652007000	12261	6241	115	0	\N
104688	1726	707651006000	12261	6241	116	0	\N
104689	1726	707650005000	12261	6241	117	0	\N
104690	1726	707649004000	12261	6241	118	0	\N
104691	1726	707648003000	12261	6241	119	0	\N
104692	1726	707647002000	12261	6241	120	0	\N
104693	1726	707646001000	12261	6241	121	0	\N
104694	1726	707645000000	12261	6241	122	0	\N
104695	1726	707643999000	12261	6241	123	0	\N
104696	1726	707642998000	12261	6241	124	0	\N
104698	1573	23035809000000	12263	6036	0	0	\N
104699	1573	23030808000000	12263	6036	1	0	\N
104700	1573	23025807000000	12263	6036	2	0	\N
104701	1573	23020806000000	12263	6036	3	0	\N
104702	1705	4456760500145	12263	6036	4	0	\N
104703	1705	4391390500145	12263	6036	5	0	\N
104704	1705	4294500500145	12263	6036	6	0	\N
104705	1705	4240450500145	12263	6036	7	0	\N
104706	1471	15877523000000	12263	6036	8	0	\N
104707	1471	11301513000000	12263	6036	9	0	\N
104708	1686	14866263563482	12263	6036	10	0	\N
104709	1471	8213503000000	12263	6036	11	0	\N
104710	1471	5659493000000	12263	6036	12	0	\N
104711	1726	707636992000	12264	6314	0	0	\N
104713	1726	707635991000	12266	6315	0	0	\N
104714	1726	707634990000	12267	6316	0	0	\N
104715	1726	707634990000	12268	6316	0	0	4252
104716	1451	20159497000000	12270	6318	0	0	1
104717	1426	14428847000000	12270	6318	1	0	1
104718	1426	10996837000000	12270	6318	2	0	2
104719	1426	8680827000000	12270	6318	3	0	3
104724	1726	707631987000	12273	6319	0	0	\N
104725	1726	707631987000	12275	6319	0	0	\N
104727	1726	707630986000	12279	6320	0	0	\N
104728	1726	707629985000	12280	6321	0	0	\N
104741	1726	707623979000	12288	6327	0	0	\N
104743	1451	18719495000000	12290	6139	0	0	\N
104744	1705	5176761500145	12290	6139	1	0	\N
104745	1705	5111391500145	12290	6139	2	0	\N
104746	1705	5014501500145	12290	6139	3	0	\N
104747	1705	4960451500145	12290	6139	4	0	\N
104748	1471	15877523000000	12290	6139	5	0	\N
104749	1471	11301513000000	12290	6139	6	0	\N
104750	1649	17524846999992	12290	6139	7	0	\N
104751	1649	15208836999992	12290	6139	8	0	\N
104752	1471	8213503000000	12290	6139	9	0	\N
104753	1649	11776826999992	12290	6139	10	0	\N
104754	1649	5323816999992	12290	6139	11	0	\N
104755	1471	5659493000000	12290	6139	12	0	\N
104756	1508	20156715187700	12290	6139	14	0	\N
104757	1508	18242420650738	12290	6139	15	0	\N
104758	1508	14812029162099	12290	6139	16	0	\N
104759	1508	12497472416525	12290	6139	17	0	\N
104760	1426	13708846000000	12290	6139	18	0	\N
104761	1426	10276836000000	12290	6139	19	0	\N
104762	1426	7960826000000	12290	6139	20	0	\N
104763	1508	6047772111964	12290	6139	21	0	\N
104770	1866	9331032615274	12294	6332	0	0	\N
104771	1866	9327244264194	12294	6332	1	0	\N
104772	1866	8269816948451	12294	6332	2	0	\N
104773	1866	7212389632708	12294	6332	3	0	\N
104774	1866	6233772723170	12294	6332	4	0	\N
104775	1866	4480178805218	12294	6332	5	0	\N
104776	1866	3296961517936	12294	6332	6	0	\N
104777	1866	0	12294	6332	7	0	\N
104778	1726	707617973000	12294	6332	8	0	\N
104779	1726	707616972000	12294	6332	9	0	\N
104790	1866	9331032615274	12296	6332	0	0	\N
104791	1866	9327244264194	12296	6332	1	0	\N
104792	1726	707617973000	12296	6332	2	0	\N
104793	1726	707616972000	12296	6332	3	0	\N
104797	1726	707613969000	12299	6335	0	0	\N
104799	1451	11556197000000	12301	6336	0	0	\N
104800	1726	707612968000	12301	6336	1	0	\N
104803	1451	11556197000000	12303	6336	0	0	\N
104804	1726	707612968000	12303	6336	1	0	\N
104807	1451	6979997000000	12305	6338	0	0	\N
104808	2062	180000000	12305	6338	1	0	\N
104809	1726	707610966000	12305	6338	2	0	\N
104810	1726	707609965000	12305	6338	3	0	\N
104825	1726	707601957000	12314	6346	0	0	\N
104827	1726	707600956000	12316	6347	0	0	\N
104828	1726	707600956000	12317	6347	0	0	\N
104833	1687	2152459524804	12321	6302	0	0	\N
104834	1451	20159497000000	12321	6302	1	0	\N
104835	1451	20158397000000	12321	6302	2	0	\N
104836	1451	11557297000000	12321	6302	3	0	\N
104837	1451	11556197000000	12321	6302	4	0	\N
104838	1451	6981097000000	12321	6302	5	0	\N
104839	1451	6979997000000	12321	6302	6	0	\N
104840	1451	3892897000000	12321	6302	7	0	\N
104841	1451	3891797000000	12321	6302	8	0	\N
104842	1451	1338697000000	12321	6302	9	0	\N
104843	1649	18964860999992	12321	6302	10	0	\N
104844	1649	16648850999992	12321	6302	11	0	\N
104845	301	66010481000000	12321	6302	12	0	\N
104846	1649	13216840999992	12321	6302	13	0	\N
104847	1649	6763830999992	12321	6302	14	0	\N
104848	2062	180000000	12321	6302	15	0	\N
104849	1426	14428847000000	12321	6302	16	0	\N
104850	1426	10996837000000	12321	6302	17	0	\N
104851	1426	8680827000000	12321	6302	18	0	\N
104852	1426	6764817000000	12321	6302	19	0	\N
104853	1726	707643999000	12321	6302	20	0	\N
104854	1726	707642998000	12321	6302	21	0	\N
104855	1726	707641997000	12321	6302	22	0	\N
104856	1726	707640996000	12321	6302	23	0	\N
104723	1726	707631987000	12272	6319	0	0	4255
104726	1726	707630986000	12278	6320	0	0	4256
104729	1726	707629985000	12281	6321	0	0	4257
104730	301	66010481000000	12282	6322	0	0	2
104731	1726	707628984000	12282	6322	1	0	4258
104733	1726	707626982000	12284	6324	0	0	4260
104734	1726	707625981000	12284	6324	1	0	4261
104735	1649	18964860999992	12285	6325	0	0	1
104736	1649	16648850999992	12285	6325	1	0	2
104737	1649	13216840999992	12285	6325	2	0	3
104739	1726	707624980000	12286	6326	0	0	4262
104740	1726	707623979000	12287	6327	0	0	4263
104742	1726	707622978000	12289	6328	0	0	4264
104764	1726	707621977000	12291	6329	0	0	4265
104766	1726	707620976000	12292	6330	1	0	4266
104767	1726	707619975000	12292	6330	2	0	4267
104768	1451	20158397000000	12293	6331	0	0	2
104769	1726	707618974000	12293	6331	1	0	4268
104780	1866	9331032615274	12295	6332	0	0	9
104782	1866	8269816948451	12295	6332	2	0	11
104783	1866	7212389632708	12295	6332	3	0	12
104784	1866	6233772723170	12295	6332	4	0	13
104785	1866	4480178805218	12295	6332	5	0	14
104786	1866	3296961517936	12295	6332	6	0	15
104788	1726	707617973000	12295	6332	8	0	4269
104789	1726	707616972000	12295	6332	9	0	4270
104794	1726	707615971000	12297	6333	0	0	4271
104795	1451	11557297000000	12298	6334	0	0	3
104798	1726	707613969000	12300	6335	0	0	4273
104801	1451	11556197000000	12302	6336	0	0	4
104802	1726	707612968000	12302	6336	1	0	4274
104805	1451	6981097000000	12304	6337	0	0	5
104806	1726	707611967000	12304	6337	1	0	4275
104812	2062	180000000	12306	6338	1	0	1
104813	1726	707610966000	12306	6338	2	0	4276
104814	1726	707609965000	12306	6338	3	0	4277
104815	1726	707608964000	12307	6339	0	0	4278
104816	1451	3892897000000	12308	6340	0	0	7
104818	1726	707606962000	12309	6341	0	0	4280
104819	1451	3891797000000	12310	6342	0	0	8
104820	1726	707605961000	12310	6342	1	0	4281
104821	1451	1338697000000	12312	6344	0	0	9
104823	1726	707603959000	12313	6345	0	0	4283
104824	1726	707602958000	12313	6345	1	0	4284
104826	1726	707601957000	12315	6346	0	0	4285
104829	1726	707600956000	12318	6347	0	0	4286
104830	1726	707599955000	12319	6348	0	0	4287
104832	1726	707597953000	12320	6349	0	0	4289
104857	1726	707639995000	12321	6302	24	0	\N
104858	1726	707638994000	12321	6302	25	0	\N
104859	1726	707637993000	12321	6302	26	0	\N
104860	1726	707636992000	12321	6302	27	0	\N
104861	1726	707635991000	12321	6302	28	0	\N
104862	1726	707634990000	12321	6302	29	0	\N
104863	1726	707633989000	12321	6302	30	0	\N
104864	1726	707632988000	12321	6302	31	0	\N
104865	1726	707631987000	12321	6302	32	0	\N
104866	1726	707630986000	12321	6302	33	0	\N
104867	1726	707629985000	12321	6302	34	0	\N
104868	1726	707628984000	12321	6302	35	0	\N
104869	1726	707627983000	12321	6302	36	0	\N
104870	1726	707626982000	12321	6302	37	0	\N
104871	1726	707625981000	12321	6302	38	0	\N
104872	1726	707624980000	12321	6302	39	0	\N
104873	1726	707623979000	12321	6302	40	0	\N
104874	1726	707622978000	12321	6302	41	0	\N
104875	1726	707621977000	12321	6302	42	0	\N
104876	1726	707620976000	12321	6302	43	0	\N
104877	1726	707619975000	12321	6302	44	0	\N
104878	1726	707618974000	12321	6302	45	0	\N
104879	1726	707617973000	12321	6302	46	0	\N
104880	1726	707616972000	12321	6302	47	0	\N
104881	1726	707615971000	12321	6302	48	0	\N
104882	1726	707614970000	12321	6302	49	0	\N
104883	1726	707613969000	12321	6302	50	0	\N
104884	1726	707612968000	12321	6302	51	0	\N
104885	1726	707611967000	12321	6302	53	0	\N
104886	1726	707610966000	12321	6302	54	0	\N
104887	1726	707609965000	12321	6302	55	0	\N
104888	1726	707608964000	12321	6302	56	0	\N
104889	1726	707607963000	12321	6302	57	0	\N
104900	1726	707590946000	12326	6353	0	0	\N
104901	1726	707589945000	12326	6353	1	0	\N
104902	1726	707588944000	12326	6353	2	0	\N
104903	1726	707587943000	12326	6353	3	0	\N
104904	1726	707590946000	12327	6353	0	0	\N
104905	1726	707589945000	12327	6353	1	0	\N
104906	1726	707588944000	12327	6353	2	0	\N
104907	1726	707587943000	12327	6353	3	0	\N
104908	1726	707590946000	12328	6353	0	0	\N
104909	1726	707589945000	12328	6353	1	0	\N
104910	1726	707588944000	12328	6353	2	0	\N
104911	1726	707587943000	12328	6353	3	0	\N
104914	1726	707585941000	12333	6356	0	0	\N
104917	1726	707583939000	12338	6359	0	0	\N
104919	1726	707581937000	12340	6361	0	0	\N
104920	1726	707580936000	12340	6361	1	0	\N
104921	1726	707581937000	12341	6361	0	0	\N
104922	1726	707580936000	12341	6361	1	0	\N
104929	1696	16669374260000	12344	6362	0	0	\N
104930	1726	707579935000	12344	6362	1	0	\N
104931	1726	707578934000	12344	6362	2	0	\N
104932	1726	707577933000	12344	6362	3	0	\N
104942	1726	707572928000	12350	6367	0	0	\N
104943	1726	707571927000	12350	6367	1	0	\N
104944	1726	707570926000	12352	6369	0	0	\N
104946	1726	707570926000	12354	6369	0	0	\N
104952	1726	707565921000	12358	6372	0	0	\N
104955	1726	707563919000	12361	6374	0	0	\N
104956	1726	707563919000	12362	6374	0	0	\N
104957	1726	707563919000	12363	6374	0	0	\N
104966	1726	707554910000	12368	6379	0	0	\N
104968	1726	707554910000	12370	6379	0	0	\N
104971	1696	15949373260000	12372	6135	0	0	\N
104972	1696	13179789520000	12372	6135	1	0	\N
104973	1696	8638518180000	12372	6135	2	0	\N
104974	1696	4097246840000	12372	6135	3	0	\N
104975	1687	1432457524804	12372	6135	4	0	\N
104976	1451	18719495000000	12372	6135	5	0	\N
104977	1451	18718395000000	12372	6135	6	0	\N
104978	1451	10117295000000	12372	6135	7	0	\N
104979	1451	10116195000000	12372	6135	8	0	\N
104980	1451	5541095000000	12372	6135	9	0	\N
104981	1451	5539995000000	12372	6135	10	0	\N
104982	1451	2452895000000	12372	6135	11	0	\N
104983	1451	2451795000000	12372	6135	12	0	\N
104984	1705	5176761500145	12372	6135	13	0	\N
104985	1705	5111391500145	12372	6135	14	0	\N
104986	1705	5014501500145	12372	6135	15	0	\N
104987	1705	4960451500145	12372	6135	16	0	\N
104988	1471	15877523000000	12372	6135	17	0	\N
104989	1471	11301513000000	12372	6135	18	0	\N
104990	1649	17524846999992	12372	6135	19	0	\N
104991	1649	15208836999992	12372	6135	20	0	\N
104992	1471	8213503000000	12372	6135	21	0	\N
104892	1726	707594950000	12323	6351	0	0	4292
104893	1726	707593949000	12323	6351	1	0	4293
104894	1726	707592948000	12324	6352	0	0	4294
104895	1726	707591947000	12324	6352	1	0	4295
104896	1726	707590946000	12325	6353	0	0	4296
104898	1726	707588944000	12325	6353	2	0	4298
104899	1726	707587943000	12325	6353	3	0	4299
104912	1726	707586942000	12331	6355	0	0	4300
104913	1726	707585941000	12332	6356	0	0	4301
104915	1726	707584940000	12334	6357	0	0	4302
104918	1726	707582938000	12339	6360	0	0	4304
104923	1726	707581937000	12342	6361	0	0	4305
104924	1726	707580936000	12342	6361	1	0	4306
104925	1696	16669374260000	12343	6362	0	0	2
104927	1726	707578934000	12343	6362	2	0	4308
104928	1726	707577933000	12343	6362	3	0	4309
104933	1726	707576932000	12345	6363	0	0	4310
104934	1726	707575931000	12346	6364	0	0	4311
104935	1696	13899790520000	12347	6365	0	0	3
104937	1696	4817247840000	12347	6365	2	0	5
104938	1726	707574930000	12347	6365	3	0	4312
104939	1726	707573929000	12348	6366	0	0	4313
104940	1726	707572928000	12349	6367	0	0	4314
104941	1726	707571927000	12349	6367	1	0	4315
104947	1726	707569925000	12355	6370	0	0	4317
104948	1726	707568924000	12355	6370	1	0	4318
104949	1726	707567923000	12356	6371	0	0	4319
104950	1726	707566922000	12356	6371	1	0	4320
104953	1726	707564920000	12359	6373	0	0	4322
104954	1726	707563919000	12360	6374	0	0	4323
104958	1726	707562918000	12364	6375	0	0	4324
104959	1726	707561917000	12364	6375	1	0	4325
104960	1726	707560916000	12365	6376	0	0	4326
104962	1726	707558914000	12366	6377	0	0	4328
104963	1726	707557913000	12367	6378	0	0	4329
104964	1726	707556912000	12367	6378	1	0	4330
104965	1726	707555911000	12367	6378	2	0	4331
104967	1726	707554910000	12369	6379	0	0	4332
104970	1726	707552908000	12371	6380	1	0	4334
104993	1649	11776826999992	12372	6135	22	0	\N
104994	1649	5323816999992	12372	6135	23	0	\N
104995	1471	5659493000000	12372	6135	24	0	\N
104996	1508	20156715187700	12372	6135	25	0	\N
104997	1508	18242420650738	12372	6135	26	0	\N
104998	1508	14812029162099	12372	6135	27	0	\N
104999	1508	12497472416525	12372	6135	28	0	\N
105000	1426	13708846000000	12372	6135	29	0	\N
105001	1426	10276836000000	12372	6135	30	0	\N
105002	1426	7960826000000	12372	6135	31	0	\N
105003	1508	6047772111964	12372	6135	32	0	\N
105004	1508	5796182500009	12372	6135	33	0	\N
105005	1426	6044816000000	12372	6135	34	0	\N
105006	1939	2150980000000	12372	6135	35	0	\N
105007	1474	3384356000023	12372	6135	36	0	\N
105008	1897	199000000	12372	6135	37	0	\N
105009	1726	712660175000	12372	6135	38	0	\N
105010	1950	3949852000000	12372	6135	39	0	\N
105011	1726	712659174000	12372	6135	40	0	\N
105012	1521	1000000	12372	6135	41	0	\N
105013	1726	712658173000	12372	6135	42	0	\N
105014	1726	712657172000	12372	6135	43	0	\N
105015	1726	712656171000	12372	6135	44	0	\N
105016	1726	712655170000	12372	6135	45	0	\N
105017	1775	873000000	12372	6135	46	0	\N
105018	1769	1708900000	12372	6135	47	0	\N
105019	1726	712654169000	12372	6135	48	0	\N
105020	1726	712653168000	12372	6135	49	0	\N
105021	1726	712652167000	12372	6135	50	0	\N
105022	1726	712651166000	12372	6135	51	0	\N
105023	1726	712650165000	12372	6135	52	0	\N
105024	1726	712649164000	12372	6135	53	0	\N
105025	1726	712648163000	12372	6135	54	0	\N
105026	1726	712647162000	12372	6135	55	0	\N
105027	1726	712646161000	12372	6135	56	0	\N
105028	1726	712645160000	12372	6135	57	0	\N
105029	641	67032818200000	12372	6135	58	0	\N
105030	641	66908581600000	12372	6135	59	0	\N
105031	641	66490019400000	12372	6135	60	0	\N
105032	641	66339780000000	12372	6135	61	0	\N
105033	1726	712644159000	12372	6135	62	0	\N
105034	1726	712643158000	12372	6135	63	0	\N
105035	1726	712642157000	12372	6135	64	0	\N
105036	1726	712641156000	12372	6135	65	0	\N
105037	1726	712640155000	12372	6135	66	0	\N
105038	1726	712639154000	12372	6135	67	0	\N
105039	1726	712638153000	12372	6135	68	0	\N
105040	1726	712637152000	12372	6135	69	0	\N
105041	1726	712636151000	12372	6135	70	0	\N
105042	1726	712635150000	12372	6135	71	0	\N
105043	1726	712634149000	12372	6135	72	0	\N
105044	1726	712633148000	12372	6135	73	0	\N
105045	1726	712632147000	12372	6135	74	0	\N
105046	1726	712631146000	12372	6135	75	0	\N
105047	1726	712630145000	12372	6135	76	0	\N
105048	1726	712629144000	12372	6135	77	0	\N
105049	1726	712628143000	12372	6135	78	0	\N
105050	1726	712627142000	12372	6135	80	0	\N
105051	1726	711417142000	12372	6135	81	0	\N
105052	1726	711416141000	12372	6135	82	0	\N
105053	1726	711415140000	12372	6135	83	0	\N
105054	1726	711414139000	12372	6135	84	0	\N
105055	1726	711413138000	12372	6135	85	0	\N
105056	1726	711412137000	12372	6135	86	0	\N
105057	1726	711411136000	12372	6135	87	0	\N
105058	1726	711410135000	12372	6135	88	0	\N
105059	1726	711409134000	12372	6135	89	0	\N
105060	1726	711408133000	12372	6135	90	0	\N
105061	1726	711407132000	12372	6135	91	0	\N
105062	1726	711406131000	12372	6135	92	0	\N
105063	1726	711405130000	12372	6135	93	0	\N
105064	1726	711404129000	12372	6135	94	0	\N
105065	1726	711403128000	12372	6135	95	0	\N
105066	1726	711402127000	12372	6135	96	0	\N
105067	1726	711401126000	12372	6135	97	0	\N
105068	1726	711400125000	12372	6135	98	0	\N
105069	1726	711399124000	12372	6135	99	0	\N
105070	1726	711398123000	12372	6135	100	0	\N
105071	1726	711397122000	12372	6135	101	0	\N
105072	1726	711396121000	12372	6135	102	0	\N
105073	1726	711395120000	12372	6135	103	0	\N
105074	1726	711394119000	12372	6135	104	0	\N
105075	1726	711393118000	12372	6135	105	0	\N
105076	1726	711392117000	12372	6135	106	0	\N
105077	1726	711391116000	12372	6135	107	0	\N
105078	1726	711390115000	12372	6135	108	0	\N
105079	1726	711389114000	12372	6135	109	0	\N
105080	1726	711388113000	12372	6135	110	0	\N
105081	1726	711387112000	12372	6135	111	0	\N
105082	1726	711386111000	12372	6135	112	0	\N
105083	1726	711385110000	12372	6135	113	0	\N
105084	1769	1707900000	12372	6135	114	0	\N
105085	1769	1706900000	12372	6135	115	0	\N
105086	1726	711384109000	12372	6135	116	0	\N
105087	1726	711383108000	12372	6135	117	0	\N
105088	1726	711382107000	12372	6135	118	0	\N
105089	1726	711381106000	12372	6135	119	0	\N
105090	1726	711380105000	12372	6135	120	0	\N
105091	1726	711379104000	12372	6135	121	0	\N
105092	1726	711378103000	12372	6135	122	0	\N
105093	1726	711377102000	12372	6135	123	0	\N
105094	1726	711376101000	12372	6135	124	0	\N
105095	1726	710166101000	12372	6135	125	0	\N
105098	1726	707550906000	12375	6382	0	0	\N
105099	1726	707550906000	12376	6382	0	0	\N
105100	1726	707549905000	12377	6383	0	0	\N
105102	1726	707549905000	12379	6383	0	0	\N
105108	1726	707544900000	12385	6388	0	0	\N
105110	1726	707542898000	12387	6390	0	0	\N
105111	1726	707542898000	12388	6390	0	0	\N
105115	1726	707539895000	12392	6392	0	0	\N
105119	1726	706327893000	12395	6394	0	0	\N
105120	1726	706326892000	12395	6394	1	0	\N
105124	1726	706324890000	12398	6396	0	0	\N
105125	1726	706323889000	12398	6396	1	0	\N
105126	1726	706324890000	12399	6396	0	0	\N
105127	1726	706323889000	12399	6396	1	0	\N
105101	1726	707549905000	12378	6383	0	0	4337
105103	1726	707548904000	12380	6384	0	0	4338
105104	1726	707547903000	12381	6385	0	0	4339
105105	1726	707546902000	12382	6386	0	0	4340
105106	1726	707545901000	12383	6387	0	0	4341
105109	1726	707543899000	12386	6389	0	0	4343
105112	1726	707542898000	12389	6390	0	0	4344
105113	1726	707541897000	12391	6391	0	0	4345
105114	1726	707540896000	12391	6391	2	0	4346
105116	1726	707539895000	12393	6392	0	0	4347
105118	1726	706328894000	12394	6393	1	0	4349
105121	1726	706327893000	12396	6394	0	0	4350
105122	1726	706326892000	12396	6394	1	0	4351
105123	1726	706325891000	12397	6395	0	0	4352
105130	1726	706322888000	12402	6398	0	0	\N
105131	1726	706321887000	12402	6398	1	0	\N
105134	1726	706320886000	12404	6399	0	0	\N
105138	1726	706317883000	12407	6401	0	0	\N
105139	1726	706317883000	12408	6401	0	0	\N
105140	1726	706317883000	12409	6401	0	0	\N
105142	1726	706316882000	12411	6402	0	0	\N
105143	1726	706316882000	12412	6402	0	0	\N
105144	1726	706316882000	12413	6402	0	0	\N
105147	1726	706315881000	12416	6403	0	0	\N
105148	1726	706315881000	12417	6403	0	0	\N
105149	131	66001199000000	12419	6404	0	0	\N
105150	1726	706314880000	12419	6404	1	0	\N
105151	1726	706313879000	12419	6404	2	0	\N
105155	1726	706320886000	12421	6399	0	0	\N
105158	1696	15949373260000	12445	6265	0	0	\N
105159	1696	13179789520000	12445	6265	1	0	\N
105160	1696	8638518180000	12445	6265	2	0	\N
105161	1696	4097246840000	12445	6265	3	0	\N
105162	1687	1432457524804	12445	6265	4	0	\N
105163	1451	20159497000000	12445	6265	5	0	\N
105164	1451	20158397000000	12445	6265	6	0	\N
105165	1451	11557297000000	12445	6265	7	0	\N
105166	1451	11556197000000	12445	6265	8	0	\N
105167	1451	6981097000000	12445	6265	9	0	\N
105168	1451	6979997000000	12445	6265	10	0	\N
105169	1451	3892897000000	12445	6265	11	0	\N
105170	1451	3891797000000	12445	6265	12	0	\N
105171	1451	1338697000000	12445	6265	13	0	\N
105172	2060	0	12445	6265	14	0	\N
105173	1705	5176761500145	12445	6265	15	0	\N
105174	1705	5111391500145	12445	6265	16	0	\N
105175	1705	5014501500145	12445	6265	17	0	\N
105176	1705	4960451500145	12445	6265	18	0	\N
105177	1471	15877523000000	12445	6265	19	0	\N
105178	1471	11301513000000	12445	6265	20	0	\N
105179	1649	18244849999992	12445	6265	21	0	\N
105180	1649	15928839999992	12445	6265	22	0	\N
105181	1471	8213503000000	12445	6265	23	0	\N
105182	1649	12496829999992	12445	6265	24	0	\N
105183	1649	6043819999992	12445	6265	25	0	\N
105184	2062	180000000	12445	6265	26	0	\N
105185	1471	5659493000000	12445	6265	27	0	\N
105186	1508	20876716187700	12445	6265	28	0	\N
105187	1508	18962421650738	12445	6265	29	0	\N
105188	1508	15532030162099	12445	6265	30	0	\N
105189	1508	13217473416525	12445	6265	31	0	\N
105190	1426	13708846000000	12445	6265	32	0	\N
105191	1426	10276836000000	12445	6265	33	0	\N
105192	1426	7960826000000	12445	6265	34	0	\N
105193	1508	6767773111964	12445	6265	35	0	\N
105194	1508	6516183500009	12445	6265	36	0	\N
105195	1426	6044816000000	12445	6265	37	0	\N
105196	1897	199000000	12445	6265	38	0	\N
105197	1726	708897042000	12445	6265	39	0	\N
105198	1726	708896041000	12445	6265	40	0	\N
105199	1726	708895040000	12445	6265	41	0	\N
105200	1726	708894039000	12445	6265	42	0	\N
105201	1726	708893038000	12445	6265	43	0	\N
105202	1726	708892037000	12445	6265	44	0	\N
105203	1726	708891036000	12445	6265	45	0	\N
105204	1726	708890035000	12445	6265	46	0	\N
105205	1726	708889034000	12445	6265	47	0	\N
105206	1726	708888033000	12445	6265	48	0	\N
105207	1726	708887032000	12445	6265	49	0	\N
105208	1726	708886031000	12445	6265	50	0	\N
105209	1726	708885030000	12445	6265	51	0	\N
105210	1726	708884029000	12445	6265	52	0	\N
105211	1726	708883028000	12445	6265	53	0	\N
105212	1726	708882027000	12445	6265	54	0	\N
105213	1726	708881026000	12445	6265	55	0	\N
105214	1726	708880025000	12445	6265	56	0	\N
105215	1726	707670025000	12445	6265	57	0	\N
105216	1696	15949373260000	12459	6140	0	0	\N
105217	1696	13179789520000	12459	6140	1	0	\N
105218	1696	8638518180000	12459	6140	2	0	\N
105219	1696	4097246840000	12459	6140	3	0	\N
105220	1687	1432457524804	12459	6140	4	0	\N
105221	1451	18718395000000	12459	6140	5	0	\N
105222	1451	10117295000000	12459	6140	6	0	\N
105223	1451	10116195000000	12459	6140	7	0	\N
105224	1451	5541095000000	12459	6140	8	0	\N
105225	1451	5539995000000	12459	6140	9	0	\N
105227	1699	2229722750126	12461	6420	0	0	\N
105235	1699	2229722750126	12472	6389	0	0	\N
105236	1726	707543899000	12472	6389	1	0	\N
105237	1726	707542898000	12472	6389	2	0	\N
105238	1726	707541897000	12472	6389	3	0	\N
105239	1726	707540896000	12472	6389	4	0	\N
105240	1726	707539895000	12472	6389	5	0	\N
105241	1726	706329895000	12472	6389	6	0	\N
105242	1726	706328894000	12472	6389	8	0	\N
105243	1726	706327893000	12472	6389	9	0	\N
105244	1268	994988000000	12472	6389	10	0	\N
105245	1726	706326892000	12472	6389	11	0	\N
105246	1726	706325891000	12472	6389	12	0	\N
105247	1726	706324890000	12472	6389	13	0	\N
105248	1726	706323889000	12472	6389	14	0	\N
105249	1726	706322888000	12472	6389	15	0	\N
105250	1726	706321887000	12472	6389	16	0	\N
105251	1726	706320886000	12472	6389	17	0	\N
105252	1726	706319885000	12472	6389	18	0	\N
105253	1726	706318884000	12472	6389	19	0	\N
105254	1726	706317883000	12472	6389	20	0	\N
105255	1726	706316882000	12472	6389	21	0	\N
105256	1726	706315881000	12472	6389	22	0	\N
105257	1726	706314880000	12472	6389	23	0	\N
105258	1726	706313879000	12472	6389	24	0	\N
105259	1726	706312878000	12472	6389	25	0	\N
105260	1726	706311877000	12472	6389	26	0	\N
105261	1268	994986000000	12474	6428	0	0	\N
105263	1726	706310876000	12477	6430	0	0	\N
105264	1726	705100876000	12477	6430	1	0	\N
105133	1726	706321887000	12403	6398	1	0	4356
105135	1726	706320886000	12405	6399	0	0	4357
105136	1726	706319885000	12406	6400	0	0	4358
105137	1726	706318884000	12406	6400	1	0	4359
105141	1726	706317883000	12410	6401	0	0	4360
105146	1726	706315881000	12415	6403	0	0	4362
105152	131	66001199000000	12420	6404	0	0	1
105153	1726	706314880000	12420	6404	1	0	4363
105154	1726	706313879000	12420	6404	2	0	4364
105156	1726	706312878000	12424	6405	0	0	4365
105226	1699	2229722750126	12460	6420	0	0	6
105228	1773	4033113028206	12465	6422	0	0	25
105229	1773	3985726847020	12465	6422	1	0	26
105230	1773	3444942085194	12465	6422	2	0	27
105232	1773	1822011730132	12465	6422	4	0	29
105233	1773	0	12465	6422	5	0	30
105234	1268	994988000000	12465	6422	6	0	2
105262	1268	994986000000	12475	6428	0	0	3
105265	1726	703890876000	12477	6430	2	0	\N
105266	1726	706310876000	12478	6430	0	0	\N
105267	1726	705100876000	12478	6430	1	0	\N
105268	1726	703890876000	12478	6430	2	0	\N
105279	1726	701464870000	12485	6436	0	0	\N
105280	1726	701463869000	12485	6436	1	0	\N
105281	1726	701462868000	12485	6436	2	0	\N
105282	1726	701461867000	12485	6436	3	0	\N
105283	1726	701464870000	12486	6436	0	0	\N
105284	1726	701463869000	12486	6436	1	0	\N
105285	1726	701462868000	12486	6436	2	0	\N
105286	1726	701461867000	12486	6436	3	0	\N
105291	1726	701460866000	12488	6437	0	0	\N
105292	1726	701460866000	12489	6437	0	0	\N
105294	1726	701459865000	12491	6438	0	0	\N
105295	1726	701459865000	12492	6438	0	0	\N
105297	1726	701459865000	12494	6438	0	0	\N
105298	1726	701459865000	12495	6438	0	0	\N
105299	1726	701459865000	12496	6438	0	0	\N
105302	1397	1371423276000	12498	6440	0	0	\N
105303	1726	701457863000	12498	6440	1	0	\N
105304	1397	1371423276000	12499	6440	0	0	\N
105305	1726	701457863000	12499	6440	1	0	\N
105310	1397	1371413275000	12502	6441	0	0	\N
105311	1726	701456862000	12502	6441	1	0	\N
105312	1397	1371403274000	12503	6442	0	0	\N
105313	1726	701455861000	12503	6442	1	0	\N
105314	1397	1371403274000	12504	6442	0	0	\N
105315	1726	701455861000	12504	6442	1	0	\N
105316	1397	1371433277000	12505	6438	0	0	\N
105317	1397	1371423276000	12505	6438	1	0	\N
105318	1397	1371413275000	12505	6438	2	0	\N
105319	1397	1371403274000	12505	6438	3	0	\N
105320	1726	701459865000	12505	6438	4	0	\N
105321	1726	701458864000	12505	6438	5	0	\N
105322	1726	701457863000	12505	6438	6	0	\N
105323	1726	701456862000	12505	6438	7	0	\N
105324	1726	701455861000	12505	6438	8	0	\N
105353	1397	1371273261000	12513	6449	0	0	\N
105354	1726	699022848000	12513	6449	1	0	\N
105359	1397	1371253259000	12516	6451	0	0	\N
105360	1726	699020846000	12516	6451	1	0	\N
105363	1397	1371243258000	12518	6452	0	0	\N
105364	1726	699019845000	12518	6452	1	0	\N
105367	1397	1371243258000	12520	6452	0	0	\N
105368	1726	699019845000	12520	6452	1	0	\N
105373	1397	1371233257000	12522	6453	0	0	\N
105374	1397	1371223256000	12522	6453	1	0	\N
105375	1726	699018844000	12522	6453	2	0	\N
105376	1726	699017843000	12522	6453	3	0	\N
105383	1397	1371213255000	12524	6454	0	0	\N
105384	1397	1371203254000	12524	6454	1	0	\N
105385	1397	1371193253000	12524	6454	2	0	\N
105386	1726	699016842000	12524	6454	3	0	\N
105387	1726	699015841000	12524	6454	4	0	\N
105388	1726	699014840000	12524	6454	5	0	\N
105389	1397	1371213255000	12525	6454	0	0	\N
105390	1397	1371203254000	12525	6454	1	0	\N
105391	1397	1371193253000	12525	6454	2	0	\N
105392	1726	699016842000	12525	6454	3	0	\N
105393	1726	699015841000	12525	6454	4	0	\N
105394	1726	699014840000	12525	6454	5	0	\N
105397	1397	1371173251000	12527	6456	0	0	\N
105398	1726	699012838000	12527	6456	1	0	\N
105271	1726	703890876000	12479	6430	2	0	4369
105272	1726	702680876000	12480	6431	0	0	4370
105273	1726	701470876000	12480	6431	1	0	4371
105274	1726	701469875000	12480	6431	2	0	4372
105275	1726	701468874000	12481	6432	0	0	4373
105277	1726	701466872000	12483	6434	0	0	4375
105278	1726	701465871000	12484	6435	0	0	4376
105287	1726	701464870000	12487	6436	0	0	4377
105288	1726	701463869000	12487	6436	1	0	4378
105289	1726	701462868000	12487	6436	2	0	4379
105293	1726	701460866000	12490	6437	0	0	4381
105296	1726	701459865000	12493	6438	0	0	4382
105300	1397	1371433277000	12497	6439	0	0	6740
105301	1726	701458864000	12497	6439	1	0	4383
105307	1726	701457863000	12500	6440	1	0	4384
105308	1397	1371413275000	12501	6441	0	0	6742
105309	1726	701456862000	12501	6441	1	0	4385
105325	1397	1371403274000	12506	6442	0	0	6743
105326	1726	701455861000	12506	6442	1	0	4386
105328	1397	1371393273000	12508	6444	0	0	6744
105329	1726	700244860000	12508	6444	1	0	4388
105330	1397	1371383272000	12508	6444	2	0	6745
105331	1397	1371373271000	12508	6444	3	0	6746
105332	1397	1371363270000	12508	6444	4	0	6747
105334	1397	1371343268000	12508	6444	6	0	6749
105335	1726	700243859000	12508	6444	7	0	4389
105336	1726	700242858000	12508	6444	8	0	4390
105337	1726	700241857000	12508	6444	9	0	4391
105339	1726	700239855000	12508	6444	11	0	4393
105340	1397	1371333267000	12509	6445	0	0	6750
105341	1397	1371323266000	12509	6445	1	0	6751
105342	1726	700238854000	12509	6445	2	0	4394
105343	1726	700237853000	12509	6445	3	0	4395
105345	1726	700236852000	12510	6446	1	0	4396
105346	1397	1371303264000	12511	6447	0	0	6753
105347	1726	699026852000	12511	6447	1	0	4397
105348	1726	699025851000	12511	6447	2	0	4398
105349	1397	1371293263000	12512	6448	0	0	6754
105351	1726	699024850000	12512	6448	2	0	4399
105352	1726	699023849000	12512	6448	3	0	4400
105355	1397	1371273261000	12514	6449	0	0	6756
105356	1726	699022848000	12514	6449	1	0	4401
105358	1726	699021847000	12515	6450	1	0	4402
105361	1397	1371253259000	12517	6451	0	0	6758
105362	1726	699020846000	12517	6451	1	0	4403
105365	1397	1371243258000	12519	6452	0	0	6759
105366	1726	699019845000	12519	6452	1	0	4404
105370	1397	1371223256000	12521	6453	1	0	6761
105371	1726	699018844000	12521	6453	2	0	4405
105372	1726	699017843000	12521	6453	3	0	4406
105377	1397	1371213255000	12523	6454	0	0	6762
105378	1397	1371203254000	12523	6454	1	0	6763
105380	1726	699016842000	12523	6454	3	0	4407
105381	1726	699015841000	12523	6454	4	0	4408
105382	1726	699014840000	12523	6454	5	0	4409
105395	1397	1371183252000	12526	6455	0	0	6765
105399	1397	1371173251000	12528	6456	0	0	6766
105400	1726	699012838000	12528	6456	1	0	4411
105405	1726	699009835000	12531	6459	0	0	\N
105406	1397	1371163250000	12532	6457	0	0	\N
105407	1397	1371153249000	12532	6457	1	0	\N
105408	1726	699011837000	12532	6457	2	0	\N
105409	1726	699010836000	12532	6457	3	0	\N
105410	1726	699009835000	12532	6457	4	0	\N
105411	1726	699009835000	12533	6459	0	0	\N
105419	1397	1371113245000	12537	6462	0	0	\N
105420	1726	699005831000	12537	6462	1	0	\N
105423	1397	1371113245000	12539	6462	0	0	\N
105424	1726	699005831000	12539	6462	1	0	\N
105425	1397	1371103244000	12540	6463	0	0	\N
105426	1397	1371093243000	12540	6463	1	0	\N
105427	1726	699004830000	12540	6463	2	0	\N
105428	1726	699003829000	12540	6463	3	0	\N
105429	1397	1371103244000	12541	6463	0	0	\N
105430	1397	1371093243000	12541	6463	1	0	\N
105431	1726	699004830000	12541	6463	2	0	\N
105432	1726	699003829000	12541	6463	3	0	\N
105442	1397	1371083242000	12544	6464	0	0	\N
105443	1397	1371073241000	12544	6464	1	0	\N
105444	1588	23039737000000	12544	6464	2	0	\N
105445	1726	699002828000	12544	6464	3	0	\N
105446	1726	699001827000	12544	6464	4	0	\N
105447	1397	1371063240000	12545	6465	0	0	\N
105448	1726	699000826000	12545	6465	1	0	\N
105451	1397	1371063240000	12547	6465	0	0	\N
105452	1726	699000826000	12547	6465	1	0	\N
105453	1397	1371053239000	12551	6467	0	0	\N
105454	1397	1371043238000	12551	6467	1	0	\N
105455	1726	698999825000	12551	6467	2	0	\N
105456	1726	698998824000	12551	6467	3	0	\N
105457	1696	16669374260000	12552	6352	0	0	\N
105458	1696	13899790520000	12552	6352	1	0	\N
105459	1696	9358519180000	12552	6352	2	0	\N
105460	1696	4817247840000	12552	6352	4	0	\N
105461	1397	1371433277000	12552	6352	5	0	\N
105462	1397	1371423276000	12552	6352	6	0	\N
105463	1397	1371413275000	12552	6352	7	0	\N
105464	1397	1371403274000	12552	6352	8	0	\N
105465	1397	1371393273000	12552	6352	9	0	\N
105466	1397	1371383272000	12552	6352	10	0	\N
105467	1397	1371373271000	12552	6352	11	0	\N
105468	1397	1371363270000	12552	6352	12	0	\N
105469	1397	1371353269000	12552	6352	13	0	\N
105470	1397	1371343268000	12552	6352	14	0	\N
105471	1397	1371333267000	12552	6352	15	0	\N
105472	1397	1371323266000	12552	6352	16	0	\N
105473	1397	1371313265000	12552	6352	17	0	\N
105474	1397	1371303264000	12552	6352	18	0	\N
105475	1397	1371293263000	12552	6352	19	0	\N
105476	1397	1371283262000	12552	6352	20	0	\N
105477	1397	1371273261000	12552	6352	21	0	\N
105478	1397	1371263260000	12552	6352	22	0	\N
105479	1397	1371253259000	12552	6352	23	0	\N
105480	1397	1371243258000	12552	6352	24	0	\N
105481	1397	1371233257000	12552	6352	25	0	\N
105482	1397	1371223256000	12552	6352	26	0	\N
105483	1397	1371213255000	12552	6352	27	0	\N
105484	1397	1371203254000	12552	6352	28	0	\N
105485	1397	1371193253000	12552	6352	29	0	\N
105486	1397	1371183252000	12552	6352	30	0	\N
105487	1397	1371173251000	12552	6352	31	0	\N
105488	1397	1371163250000	12552	6352	32	0	\N
105489	1397	1371153249000	12552	6352	33	0	\N
105490	1397	1371143248000	12552	6352	34	0	\N
105491	1397	1371133247000	12552	6352	35	0	\N
105492	1397	1371123246000	12552	6352	36	0	\N
105493	1397	1371113245000	12552	6352	37	0	\N
105494	1397	1371103244000	12552	6352	38	0	\N
105495	1397	1371093243000	12552	6352	39	0	\N
105496	1397	1371083242000	12552	6352	40	0	\N
105497	1397	1371073241000	12552	6352	41	0	\N
105498	1397	1371063240000	12552	6352	42	0	\N
105499	1397	1371053239000	12552	6352	43	0	\N
105500	1397	1371043238000	12552	6352	44	0	\N
105501	1397	1371033237000	12552	6352	45	0	\N
105502	1699	2229722750126	12552	6352	46	0	\N
105503	1588	23039737000000	12552	6352	47	0	\N
105504	1726	707592948000	12552	6352	48	0	\N
105505	1726	707591947000	12552	6352	49	0	\N
105506	1726	707590946000	12552	6352	50	0	\N
105507	1726	707589945000	12552	6352	51	0	\N
105508	1726	707588944000	12552	6352	52	0	\N
105509	1726	707587943000	12552	6352	53	0	\N
105510	1726	707586942000	12552	6352	54	0	\N
105511	1726	707585941000	12552	6352	55	0	\N
105512	1268	994988000000	12552	6352	56	0	\N
105513	1268	994986000000	12552	6352	57	0	\N
105514	1726	707584940000	12552	6352	58	0	\N
105515	1726	707583939000	12552	6352	59	0	\N
105516	1726	707582938000	12552	6352	60	0	\N
105517	1726	707581937000	12552	6352	61	0	\N
105518	1726	707580936000	12552	6352	62	0	\N
105519	1726	707579935000	12552	6352	63	0	\N
105520	1726	707578934000	12552	6352	64	0	\N
105521	1726	707577933000	12552	6352	65	0	\N
105522	1726	707576932000	12552	6352	66	0	\N
105523	1726	707575931000	12552	6352	67	0	\N
105524	1726	707574930000	12552	6352	68	0	\N
105525	1726	707573929000	12552	6352	69	0	\N
105526	1726	707572928000	12552	6352	70	0	\N
105527	1726	707571927000	12552	6352	71	0	\N
105528	1726	707570926000	12552	6352	72	0	\N
105529	1726	707569925000	12552	6352	73	0	\N
105530	1726	707568924000	12552	6352	74	0	\N
105531	1726	707567923000	12552	6352	75	0	\N
105532	1726	707566922000	12552	6352	76	0	\N
105533	1726	707565921000	12552	6352	77	0	\N
105534	1726	707564920000	12552	6352	78	0	\N
105535	1726	707563919000	12552	6352	79	0	\N
105536	1726	707562918000	12552	6352	80	0	\N
105403	1397	1371153249000	12530	6458	1	0	6768
105404	1726	699010836000	12530	6458	2	0	4413
105412	1726	699009835000	12534	6459	0	0	4414
105413	1397	1371143248000	12535	6460	0	0	6769
105414	1726	699008834000	12535	6460	1	0	4415
105416	1397	1371123246000	12536	6461	1	0	6771
105417	1726	699007833000	12536	6461	2	0	4416
105418	1726	699006832000	12536	6461	3	0	4417
105421	1397	1371113245000	12538	6462	0	0	6772
105422	1726	699005831000	12538	6462	1	0	4418
105434	1397	1371093243000	12542	6463	1	0	6774
105435	1726	699004830000	12542	6463	2	0	4419
105436	1726	699003829000	12542	6463	3	0	4420
105437	1397	1371083242000	12543	6464	0	0	6775
105439	1588	23039737000000	12543	6464	2	0	1
105440	1726	699002828000	12543	6464	3	0	4421
105441	1726	699001827000	12543	6464	4	0	4422
105449	1397	1371063240000	12546	6465	0	0	6777
105450	1726	699000826000	12546	6465	1	0	4423
105537	1726	707561917000	12552	6352	81	0	\N
105538	1726	707560916000	12552	6352	82	0	\N
105539	1726	707559915000	12552	6352	83	0	\N
105540	1726	707558914000	12552	6352	84	0	\N
105541	1726	707557913000	12552	6352	85	0	\N
105542	1726	707556912000	12552	6352	86	0	\N
105543	1726	707555911000	12552	6352	87	0	\N
105544	1726	707554910000	12552	6352	88	0	\N
105545	1726	707553909000	12552	6352	89	0	\N
105546	1726	707552908000	12552	6352	90	0	\N
105547	1726	707551907000	12552	6352	91	0	\N
105548	1726	707550906000	12552	6352	92	0	\N
105549	1726	707549905000	12552	6352	93	0	\N
105550	1726	707548904000	12552	6352	94	0	\N
105551	1726	707547903000	12552	6352	95	0	\N
105552	1726	707546902000	12552	6352	96	0	\N
105553	1726	707545901000	12552	6352	97	0	\N
105554	1726	707544900000	12552	6352	98	0	\N
105555	1726	707543899000	12552	6352	99	0	\N
105556	1726	707542898000	12552	6352	100	0	\N
105557	1726	707541897000	12552	6352	101	0	\N
105558	1726	707540896000	12552	6352	102	0	\N
105559	1726	707539895000	12552	6352	103	0	\N
105560	1726	706329895000	12552	6352	104	0	\N
105561	1726	706328894000	12552	6352	105	0	\N
105562	1726	706327893000	12552	6352	106	0	\N
105563	1726	706326892000	12552	6352	107	0	\N
105564	1726	706325891000	12552	6352	108	0	\N
105565	1726	706324890000	12552	6352	109	0	\N
105566	1726	706323889000	12552	6352	110	0	\N
105567	1726	706322888000	12552	6352	111	0	\N
105568	1726	706321887000	12552	6352	112	0	\N
105569	1726	706320886000	12552	6352	113	0	\N
105570	1726	706319885000	12552	6352	114	0	\N
105571	1726	706318884000	12552	6352	115	0	\N
105572	1726	706317883000	12552	6352	116	0	\N
105573	1726	706316882000	12552	6352	117	0	\N
105574	1726	706315881000	12552	6352	118	0	\N
105575	1726	706314880000	12552	6352	119	0	\N
105576	1726	706313879000	12552	6352	120	0	\N
105577	1726	706312878000	12552	6352	121	0	\N
105578	1726	706311877000	12552	6352	122	0	\N
105579	1726	706310876000	12552	6352	123	0	\N
105580	1726	705100876000	12552	6352	124	0	\N
105581	1726	703890876000	12552	6352	125	0	\N
105596	1397	1370983232000	12556	6471	0	0	\N
105597	1726	698992818000	12556	6471	1	0	\N
105598	1397	1370983232000	12557	6471	0	0	\N
105599	1726	698992818000	12557	6471	1	0	\N
105602	1397	1370973231000	12559	6472	0	0	\N
105603	1397	1370963230000	12559	6472	1	0	\N
105604	1726	698991817000	12559	6472	2	0	\N
105605	1726	698990816000	12559	6472	3	0	\N
105606	1397	1370973231000	12560	6472	0	0	\N
105607	1397	1370963230000	12560	6472	1	0	\N
105608	1726	698991817000	12560	6472	2	0	\N
105609	1726	698990816000	12560	6472	3	0	\N
105616	1397	1371063240000	12563	6465	0	0	\N
105617	1397	1371053239000	12563	6465	1	0	\N
105618	1397	1371043238000	12563	6465	2	0	\N
105619	1397	1371033237000	12563	6465	3	0	\N
105620	1397	1371023236000	12563	6465	5	0	\N
105621	1397	1371013235000	12563	6465	6	0	\N
105622	1397	1371003234000	12563	6465	7	0	\N
105623	1397	1370993233000	12563	6465	8	0	\N
105630	1397	1370923226000	12567	6476	0	0	\N
105631	1726	698986812000	12567	6476	1	0	\N
105641	1397	1370873221000	12569	6478	0	0	\N
105642	1726	698981807000	12569	6478	1	0	\N
105643	1397	1370873221000	12570	6478	0	0	\N
105644	1726	698981807000	12570	6478	1	0	\N
105653	1397	1370843218000	12575	6481	0	0	\N
105654	1726	698978804000	12575	6481	1	0	\N
105665	1397	1370803214000	12579	6484	0	0	\N
105666	1588	15625887000000	12579	6484	1	0	\N
105667	1588	11300275000000	12579	6484	2	0	\N
105668	1588	8388612000000	12579	6484	3	0	\N
105669	1588	5974754000000	12579	6484	4	0	\N
105670	1726	698974800000	12579	6484	5	0	\N
105584	1397	1371033237000	12553	6468	2	0	6780
105585	1726	698999825000	12553	6468	3	0	4424
105586	1726	698998824000	12553	6468	4	0	4425
105587	1726	698997823000	12553	6468	5	0	4426
105588	1397	1371023236000	12554	6469	0	0	6781
105590	1397	1371013235000	12555	6470	0	0	6782
105591	1397	1371003234000	12555	6470	1	0	6783
105592	1397	1370993233000	12555	6470	2	0	6784
105593	1726	698995821000	12555	6470	3	0	4428
105594	1726	698994820000	12555	6470	4	0	4429
105600	1397	1370983232000	12558	6471	0	0	6785
105601	1726	698992818000	12558	6471	1	0	4431
105610	1397	1370973231000	12561	6472	0	0	6786
105611	1397	1370963230000	12561	6472	1	0	6787
105613	1726	698990816000	12561	6472	3	0	4433
105614	1397	1370953229000	12562	6473	0	0	6788
105615	1726	698989815000	12562	6473	1	0	4434
105624	1397	1370943228000	12564	6474	0	0	6789
105625	1726	698988814000	12564	6474	1	0	4435
105627	1726	698987813000	12565	6475	1	0	4436
105628	1397	1370923226000	12566	6476	0	0	6791
105629	1726	698986812000	12566	6476	1	0	4437
105632	1397	1370913225000	12568	6477	0	0	6792
105633	1397	1370903224000	12568	6477	1	0	6793
105635	1397	1370883222000	12568	6477	3	0	6795
105636	1588	23758759000000	12568	6477	4	0	2
105637	1726	698985811000	12568	6477	5	0	4438
105638	1726	698984810000	12568	6477	6	0	4439
105640	1726	698982808000	12568	6477	8	0	4441
105645	1397	1370873221000	12571	6478	0	0	6796
105646	1726	698981807000	12571	6478	1	0	4442
105647	1397	1370863220000	12572	6479	0	0	6797
105648	1726	698980806000	12572	6479	1	0	4443
105650	1726	698979805000	12573	6480	1	0	4444
105651	1397	1370843218000	12574	6481	0	0	6799
105652	1726	698978804000	12574	6481	1	0	4445
105655	1397	1370833217000	12576	6482	0	0	6800
105656	1397	1370823216000	12576	6482	1	0	6801
105658	1726	698976802000	12576	6482	3	0	4447
105659	1599	18875073052715	12577	6483	0	0	1
105660	1599	15281330064617	12577	6483	1	0	2
105661	1397	1370813215000	12577	6483	2	0	6802
105663	1599	6099728393047	12577	6483	4	0	4
105664	1726	698975801000	12577	6483	5	0	4448
105671	1397	1370803214000	12580	6484	0	0	6803
105672	1588	15625887000000	12580	6484	1	0	3
105677	1397	1370793213000	12581	6485	0	0	\N
105678	1397	1370793213000	12582	6485	0	0	\N
105694	1397	1370733207000	12587	6488	0	0	\N
105695	1397	1370723206000	12587	6488	1	0	\N
105696	1726	698968794000	12587	6488	2	0	\N
105697	1726	698967793000	12587	6488	3	0	\N
105698	1397	1370783212000	12588	6486	0	0	\N
105699	1397	1370773211000	12588	6486	1	0	\N
105700	1397	1370763210000	12588	6486	2	0	\N
105701	1397	1370753209000	12588	6486	3	0	\N
105702	1397	1370743208000	12588	6486	4	0	\N
105703	1397	1370733207000	12588	6486	5	0	\N
105704	1397	1370723206000	12588	6486	6	0	\N
105705	1397	1370713205000	12588	6486	7	0	\N
105706	1726	698973799000	12588	6486	8	0	\N
105707	1726	698972798000	12588	6486	9	0	\N
105708	1726	698971797000	12588	6486	10	0	\N
105709	1726	698970796000	12588	6486	11	0	\N
105710	1726	698969795000	12588	6486	12	0	\N
105711	1726	698968794000	12588	6486	13	0	\N
105712	1726	698967793000	12588	6486	14	0	\N
105713	1726	698966792000	12588	6486	15	0	\N
105722	1397	1370693203000	12593	6492	0	0	\N
105723	1397	1370683202000	12593	6492	1	0	\N
105724	1726	698964790000	12593	6492	2	0	\N
105725	1726	698963789000	12593	6492	3	0	\N
105728	1397	1370673201000	12595	6493	0	0	\N
105729	1726	698962788000	12595	6493	1	0	\N
105748	1397	1370583192000	12602	6499	0	0	\N
105749	1726	698953779000	12602	6499	1	0	\N
105750	1397	1370573191000	12603	6500	0	0	\N
105751	1397	1370563190000	12603	6500	1	0	\N
105752	1397	1370553189000	12603	6500	2	0	\N
105753	1726	698952778000	12603	6500	3	0	\N
105754	1726	698951777000	12603	6500	4	0	\N
105755	1726	698950776000	12603	6500	5	0	\N
105764	1397	1370533187000	12606	6502	0	0	\N
105765	1726	698948774000	12606	6502	1	0	\N
105772	1397	1370513185000	12610	6504	0	0	\N
105773	1726	698946772000	12610	6504	1	0	\N
105786	1397	1370483182000	12614	6507	0	0	\N
105787	1397	1370473181000	12614	6507	1	0	\N
105788	1397	1370463180000	12614	6507	2	0	\N
105789	1726	698943769000	12614	6507	3	0	\N
105790	1750	4181000000	12614	6507	4	0	\N
105791	1718	3186679763340	12614	6507	5	0	\N
105792	1726	698942768000	12614	6507	6	0	\N
105793	1726	698941767000	12614	6507	7	0	\N
105796	1397	1370443178000	12616	6509	0	0	\N
105797	1726	698939765000	12616	6509	1	0	\N
105675	1588	5974754000000	12580	6484	4	0	6
105676	1726	698974800000	12580	6484	5	0	4449
105679	1397	1370793213000	12583	6485	0	0	6804
105680	1397	1370783212000	12584	6486	0	0	6805
105681	1726	698973799000	12584	6486	1	0	4450
105683	1397	1370763210000	12585	6487	1	0	6807
105684	1397	1370753209000	12585	6487	2	0	6808
105685	1397	1370743208000	12585	6487	3	0	6809
105686	1726	698972798000	12585	6487	4	0	4451
105687	1726	698971797000	12585	6487	5	0	4452
105689	1726	698969795000	12585	6487	7	0	4454
105690	1397	1370733207000	12586	6488	0	0	6810
105691	1397	1370723206000	12586	6488	1	0	6811
105692	1726	698968794000	12586	6488	2	0	4455
105714	1397	1370713205000	12589	6489	0	0	6812
105715	1726	698966792000	12589	6489	1	0	4457
105716	1397	1370703204000	12590	6490	0	0	6813
105717	1726	698965791000	12590	6490	1	0	4458
105718	1397	1370693203000	12592	6492	0	0	6814
105720	1726	698964790000	12592	6492	2	0	4459
105721	1726	698963789000	12592	6492	3	0	4460
105726	1397	1370673201000	12594	6493	0	0	6816
105727	1726	698962788000	12594	6493	1	0	4461
105730	1397	1370663200000	12596	6494	0	0	6817
105732	1397	1370643198000	12596	6494	2	0	6819
105733	1397	1370633197000	12596	6494	3	0	6820
105734	1726	698961787000	12596	6494	4	0	4462
105735	1726	698960786000	12596	6494	5	0	4463
105737	1726	698958784000	12596	6494	7	0	4465
105738	1397	1370623196000	12597	6495	0	0	6821
105739	1726	698957783000	12597	6495	1	0	4466
105740	1397	1370613195000	12598	6496	0	0	6822
105741	1726	698956782000	12598	6496	1	0	4467
105743	1726	698955781000	12599	6497	1	0	4468
105744	1397	1370593193000	12600	6498	0	0	6824
105745	1726	698954780000	12600	6498	1	0	4469
105746	1397	1370583192000	12601	6499	0	0	6825
105747	1726	698953779000	12601	6499	1	0	4470
105757	1397	1370563190000	12604	6500	1	0	6827
105758	1397	1370553189000	12604	6500	2	0	6828
105759	1726	698952778000	12604	6500	3	0	4471
105760	1726	698951777000	12604	6500	4	0	4472
105762	1397	1370543188000	12605	6501	0	0	6829
105763	1726	698949775000	12605	6501	1	0	4474
105766	1397	1370533187000	12607	6502	0	0	6830
105767	1726	698948774000	12607	6502	1	0	4475
105768	1397	1370523186000	12608	6503	0	0	6831
105770	1397	1370513185000	12609	6504	0	0	6832
105771	1726	698946772000	12609	6504	1	0	4477
105774	1397	1370503184000	12611	6505	0	0	6833
105775	1726	698945771000	12611	6505	1	0	4478
105776	1397	1370493183000	12612	6506	0	0	6834
105778	1397	1370483182000	12613	6507	0	0	6835
105779	1397	1370473181000	12613	6507	1	0	6836
105780	1397	1370463180000	12613	6507	2	0	6837
105781	1726	698943769000	12613	6507	3	0	4480
105783	1718	3186679763340	12613	6507	5	0	9
105784	1726	698942768000	12613	6507	6	0	4481
105785	1726	698941767000	12613	6507	7	0	4482
105794	1397	1370453179000	12615	6508	0	0	6838
105795	1726	698940766000	12615	6508	1	0	4483
105799	1726	698939765000	12617	6509	1	0	4484
105800	1397	1370433177000	12618	6510	0	0	6840
105801	1397	1370423176000	12618	6510	1	0	6841
105802	1726	698938764000	12618	6510	2	0	4485
105803	1726	698937763000	12618	6510	3	0	4486
105805	1397	1370403174000	12619	6511	1	0	6843
105806	1726	698936762000	12619	6511	2	0	4487
105807	1726	698935761000	12619	6511	3	0	4488
105808	1397	1370393173000	12620	6512	0	0	6844
105824	1397	1370323166000	12626	6516	0	0	\N
105825	1726	698927753000	12626	6516	1	0	\N
105826	1397	1370313165000	12631	6517	0	0	\N
105827	1726	698926752000	12631	6517	1	0	\N
105830	1397	1370313165000	12633	6517	0	0	\N
105831	1726	698926752000	12633	6517	1	0	\N
105832	1397	1370303164000	12634	6518	0	0	\N
105833	1726	698925751000	12634	6518	1	0	\N
105836	1397	1370303164000	12636	6518	0	0	\N
105837	1726	698925751000	12636	6518	1	0	\N
105850	1397	1370263160000	12639	6520	0	0	\N
105851	1397	1370253159000	12639	6520	1	0	\N
105852	1397	1370243158000	12639	6520	2	0	\N
105853	1726	698921747000	12639	6520	3	0	\N
105854	1726	698920746000	12639	6520	4	0	\N
105855	1726	698919745000	12639	6520	5	0	\N
105856	1696	15949373260000	12640	6242	0	0	\N
105857	1696	13179789520000	12640	6242	1	0	\N
105858	1696	8638518180000	12640	6242	2	0	\N
105859	1696	4097246840000	12640	6242	3	0	\N
105860	1687	1432457524804	12640	6242	4	0	\N
105861	1451	19439496000000	12640	6242	5	0	\N
105862	1451	19438396000000	12640	6242	6	0	\N
105863	1451	10837296000000	12640	6242	7	0	\N
105864	1451	10836196000000	12640	6242	8	0	\N
105865	1451	6261096000000	12640	6242	9	0	\N
105866	1451	6259996000000	12640	6242	10	0	\N
105867	1451	3172896000000	12640	6242	11	0	\N
105868	1451	3171796000000	12640	6242	12	0	\N
105869	1451	618696000000	12640	6242	13	0	\N
105870	1599	18155072052715	12640	6242	14	0	\N
105871	1397	1371433277000	12640	6242	15	0	\N
105872	1649	18244849999992	12640	6242	16	0	\N
105873	1649	15928839999992	12640	6242	17	0	\N
105874	1599	14561329064617	12640	6242	18	0	\N
105875	1649	12496829999992	12640	6242	19	0	\N
105876	1649	6043819999992	12640	6242	20	0	\N
105877	1397	1371423276000	12640	6242	21	0	\N
105878	1397	1371413275000	12640	6242	22	0	\N
105879	2062	180000000	12640	6242	23	0	\N
105880	1599	12136555807349	12640	6242	24	0	\N
105881	1599	5379727393047	12640	6242	25	0	\N
105882	1426	13708846000000	12640	6242	26	0	\N
105883	1426	10276836000000	12640	6242	27	0	\N
105884	1426	7960826000000	12640	6242	28	0	\N
105885	1426	6044816000000	12640	6242	29	0	\N
105886	1397	1371403274000	12640	6242	30	0	\N
105887	1397	1371393273000	12640	6242	31	0	\N
105888	1397	1371383272000	12640	6242	32	0	\N
105889	1397	1371373271000	12640	6242	33	0	\N
105890	1397	1371363270000	12640	6242	34	0	\N
105891	1397	1371353269000	12640	6242	35	0	\N
105892	1397	1371343268000	12640	6242	36	0	\N
105893	1397	1371333267000	12640	6242	37	0	\N
105894	1397	1371323266000	12640	6242	39	0	\N
105895	1397	1371313265000	12640	6242	40	0	\N
105896	1397	1371303264000	12640	6242	41	0	\N
105897	1397	1371293263000	12640	6242	42	0	\N
105898	1397	1371283262000	12640	6242	43	0	\N
105899	1397	1371273261000	12640	6242	44	0	\N
105900	1397	1371263260000	12640	6242	45	0	\N
105901	1397	1371253259000	12640	6242	46	0	\N
105902	1397	1371243258000	12640	6242	47	0	\N
105903	1397	1371233257000	12640	6242	48	0	\N
105904	1397	1371223256000	12640	6242	49	0	\N
105905	1397	1371213255000	12640	6242	50	0	\N
105906	1397	1371203254000	12640	6242	51	0	\N
105907	1397	1371193253000	12640	6242	52	0	\N
105908	1397	1371183252000	12640	6242	53	0	\N
105909	1397	1371173251000	12640	6242	54	0	\N
105910	1397	1371163250000	12640	6242	55	0	\N
105911	1397	1371153249000	12640	6242	56	0	\N
105912	1397	1371143248000	12640	6242	57	0	\N
105913	1397	1371133247000	12640	6242	58	0	\N
105914	1397	1371123246000	12640	6242	59	0	\N
105915	1397	1371113245000	12640	6242	60	0	\N
105916	1397	1371103244000	12640	6242	61	0	\N
105917	1397	1371093243000	12640	6242	62	0	\N
105918	1397	1371083242000	12640	6242	63	0	\N
105919	1397	1371073241000	12640	6242	64	0	\N
105920	1397	1371063240000	12640	6242	65	0	\N
105921	1397	1371053239000	12640	6242	66	0	\N
105922	1397	1371043238000	12640	6242	67	0	\N
105923	1397	1371033237000	12640	6242	68	0	\N
105924	1397	1371023236000	12640	6242	69	0	\N
105925	1397	1371013235000	12640	6242	70	0	\N
105926	1397	1371003234000	12640	6242	71	0	\N
105927	1397	1370993233000	12640	6242	72	0	\N
105928	1397	1370983232000	12640	6242	73	0	\N
105929	1397	1370973231000	12640	6242	74	0	\N
105930	1397	1370963230000	12640	6242	75	0	\N
105931	1397	1370953229000	12640	6242	76	0	\N
105932	1397	1370943228000	12640	6242	77	0	\N
105933	1397	1370933227000	12640	6242	78	0	\N
105934	1397	1370923226000	12640	6242	79	0	\N
105935	1397	1370913225000	12640	6242	80	0	\N
105936	1397	1370903224000	12640	6242	81	0	\N
105937	1397	1370893223000	12640	6242	82	0	\N
105938	1397	1370883222000	12640	6242	83	0	\N
105939	1397	1370873221000	12640	6242	84	0	\N
105940	1397	1370863220000	12640	6242	85	0	\N
105941	1397	1370853219000	12640	6242	86	0	\N
105942	1397	1370843218000	12640	6242	87	0	\N
105943	1397	1370833217000	12640	6242	88	0	\N
105944	1397	1370823216000	12640	6242	89	0	\N
105811	1397	1370373171000	12621	6513	1	0	6846
105812	1397	1370363170000	12621	6513	2	0	6847
105813	1726	698933759000	12621	6513	3	0	4490
105814	1726	698932758000	12621	6513	4	0	4491
105815	1726	698931757000	12621	6513	5	0	4492
105817	1397	1370343168000	12622	6514	1	0	6849
105818	1726	698930756000	12622	6514	2	0	4493
105819	1726	698929755000	12622	6514	3	0	4494
105820	1397	1370333167000	12623	6515	0	0	6850
105821	1726	698928754000	12623	6515	1	0	4495
105823	1726	698927753000	12625	6516	1	0	4496
105828	1397	1370313165000	12632	6517	0	0	6852
105829	1726	698926752000	12632	6517	1	0	4497
105834	1397	1370303164000	12635	6518	0	0	6853
105838	1397	1370293163000	12637	6519	0	0	6854
105839	1397	1370283162000	12637	6519	1	0	6855
105840	1397	1370273161000	12637	6519	2	0	6856
105841	1726	698924750000	12637	6519	3	0	4499
105842	1726	698923749000	12637	6519	4	0	4500
105844	1397	1370263160000	12638	6520	0	0	6857
105845	1397	1370253159000	12638	6520	1	0	6858
105846	1397	1370243158000	12638	6520	2	0	6859
105847	1726	698921747000	12638	6520	3	0	4502
105848	1726	698920746000	12638	6520	4	0	4503
105945	1397	1370813215000	12640	6242	90	0	\N
105946	1397	1370803214000	12640	6242	91	0	\N
105947	1397	1370793213000	12640	6242	92	0	\N
105948	1397	1370783212000	12640	6242	93	0	\N
105949	1397	1370773211000	12640	6242	94	0	\N
105950	1397	1370763210000	12640	6242	95	0	\N
105951	1397	1370753209000	12640	6242	96	0	\N
105952	1397	1370743208000	12640	6242	97	0	\N
105953	1397	1370733207000	12640	6242	98	0	\N
105954	1397	1370723206000	12640	6242	99	0	\N
105955	1397	1370713205000	12640	6242	100	0	\N
105956	1397	1370703204000	12640	6242	101	0	\N
105957	1397	1370693203000	12640	6242	102	0	\N
105958	1397	1370683202000	12640	6242	103	0	\N
105959	1397	1370673201000	12640	6242	104	0	\N
105960	1397	1370663200000	12640	6242	105	0	\N
105961	1397	1370653199000	12640	6242	106	0	\N
105962	1397	1370643198000	12640	6242	107	0	\N
105963	1397	1370633197000	12640	6242	108	0	\N
105964	1397	1370623196000	12640	6242	109	0	\N
105965	1397	1370613195000	12640	6242	110	0	\N
105966	1397	1370603194000	12640	6242	111	0	\N
105967	1397	1370593193000	12640	6242	112	0	\N
105968	1397	1370583192000	12640	6242	113	0	\N
105969	1397	1370573191000	12640	6242	114	0	\N
105970	1397	1370563190000	12640	6242	115	0	\N
105971	1397	1370553189000	12640	6242	116	0	\N
105972	1397	1370543188000	12640	6242	117	0	\N
105973	1397	1370533187000	12640	6242	118	0	\N
105974	1397	1370523186000	12640	6242	119	0	\N
105975	1397	1370513185000	12640	6242	120	0	\N
105976	1397	1370503184000	12640	6242	121	0	\N
105977	1397	1370493183000	12640	6242	122	0	\N
105978	1397	1370483182000	12640	6242	123	0	\N
105979	1397	1370473181000	12640	6242	124	0	\N
105980	1397	1370463180000	12640	6242	125	0	\N
105983	1397	1370233157000	12642	6521	0	0	\N
105984	1726	698918744000	12642	6521	1	0	\N
105985	1397	1370233157000	12643	6521	0	0	\N
105986	1726	698918744000	12643	6521	1	0	\N
105987	1397	1370233157000	12644	6521	0	0	\N
105988	1397	1370223156000	12644	6521	1	0	\N
105989	1726	698918744000	12644	6521	2	0	\N
105994	1397	1370213155000	12647	6523	0	0	\N
105995	1726	698916742000	12647	6523	1	0	\N
105996	1397	1370213155000	12648	6523	0	0	\N
105997	1726	698916742000	12648	6523	1	0	\N
106007	1397	1370193153000	12651	6525	0	0	\N
106008	1397	1370183152000	12651	6525	1	0	\N
106009	1397	1370173151000	12651	6525	2	0	\N
106010	1750	4180000000	12651	6525	3	0	\N
106011	1726	698914740000	12651	6525	4	0	\N
106012	1726	698913739000	12651	6525	5	0	\N
106013	1726	698912738000	12651	6525	6	0	\N
106018	1397	1370143148000	12654	6528	0	0	\N
106019	1397	1370133147000	12654	6528	1	0	\N
106020	1397	1370123146000	12654	6528	2	0	\N
106021	1726	698909735000	12654	6528	3	0	\N
106022	1726	698908734000	12654	6528	4	0	\N
106023	1726	698907733000	12654	6528	5	0	\N
106024	1750	4179000000	12654	6528	6	0	\N
106032	1397	1370143148000	12656	6528	0	0	\N
106033	1397	1370133147000	12656	6528	1	0	\N
106034	1397	1370123146000	12656	6528	2	0	\N
106035	1726	698909735000	12656	6528	3	0	\N
106036	1726	698908734000	12656	6528	4	0	\N
106037	1726	698907733000	12656	6528	5	0	\N
106038	1750	4179000000	12656	6528	6	0	\N
106039	1397	1370113145000	12657	6529	0	0	\N
106040	1726	698906732000	12657	6529	1	0	\N
106041	1750	4178000000	12657	6529	2	0	\N
106048	1397	1370103144000	12660	6530	0	0	\N
106049	1726	698905731000	12660	6530	1	0	\N
106050	1750	4177000000	12660	6530	2	0	\N
106059	1726	695273729000	12663	6532	0	0	\N
106060	1397	1370083142000	12664	6532	0	0	\N
106061	1726	695273729000	12664	6532	1	0	\N
106067	1397	1370053139000	12666	6534	0	0	\N
106068	1726	695270726000	12666	6534	1	0	\N
106069	1750	4174000000	12666	6534	2	0	\N
106073	1397	1370053139000	12668	6534	0	0	\N
106074	1726	695270726000	12668	6534	1	0	\N
106075	1750	4174000000	12668	6534	2	0	\N
105990	1397	1370223156000	12645	6522	0	0	6861
105991	1726	698917743000	12645	6522	1	0	4506
105992	1397	1370213155000	12646	6523	0	0	6862
105993	1726	698916742000	12646	6523	1	0	4507
105998	1397	1370203154000	12649	6524	0	0	6863
106000	1397	1370193153000	12650	6525	0	0	6864
106001	1397	1370183152000	12650	6525	1	0	6865
106002	1397	1370173151000	12650	6525	2	0	6866
106003	1750	4180000000	12650	6525	3	0	20
106004	1726	698914740000	12650	6525	4	0	4509
106006	1726	698912738000	12650	6525	6	0	4511
106014	1397	1370163150000	12652	6526	0	0	6867
106015	1726	698911737000	12652	6526	1	0	4512
106016	1397	1370153149000	12653	6527	0	0	6868
106025	1397	1370143148000	12655	6528	0	0	6869
106026	1397	1370133147000	12655	6528	1	0	6870
106027	1397	1370123146000	12655	6528	2	0	6871
106028	1726	698909735000	12655	6528	3	0	4514
106029	1726	698908734000	12655	6528	4	0	4515
106031	1750	4179000000	12655	6528	6	0	21
106042	1397	1370113145000	12658	6529	0	0	6872
106043	1726	698906732000	12658	6529	1	0	4517
106044	1750	4178000000	12658	6529	2	0	22
106045	1397	1370103144000	12659	6530	0	0	6873
106047	1750	4177000000	12659	6530	2	0	23
106051	1397	1370093143000	12661	6531	0	0	6874
106052	1750	4176000000	12661	6531	1	0	24
106053	1726	698904730000	12661	6531	2	0	4519
106055	1726	696484730000	12661	6531	4	0	4521
106056	1726	695274730000	12661	6531	5	0	4522
106057	1397	1370083142000	12662	6532	0	0	6875
106058	1726	695273729000	12662	6532	1	0	4523
106062	1397	1370073141000	12665	6533	0	0	6876
106064	1750	4175000000	12665	6533	2	0	25
106065	1726	695272728000	12665	6533	3	0	4524
106066	1726	695271727000	12665	6533	4	0	4525
106070	1397	1370053139000	12667	6534	0	0	6878
106071	1726	695270726000	12667	6534	1	0	4526
106076	1397	1370043138000	12670	6535	0	0	6879
106077	1726	695269725000	12670	6535	1	0	4527
106078	1397	1370033137000	12671	6536	0	0	6880
106079	1397	1370023136000	12671	6536	1	0	6881
106083	1397	1370033137000	12672	6536	0	0	\N
106084	1397	1370023136000	12672	6536	1	0	\N
106085	1726	695268724000	12672	6536	2	0	\N
106086	1726	695267723000	12672	6536	3	0	\N
106087	1750	4173000000	12672	6536	4	0	\N
106088	1397	1370033137000	12673	6536	0	0	\N
106089	1397	1370023136000	12673	6536	1	0	\N
106090	1726	695268724000	12673	6536	2	0	\N
106091	1726	695267723000	12673	6536	3	0	\N
106092	1750	4173000000	12673	6536	4	0	\N
106095	1397	1370013135000	12675	6537	0	0	\N
106096	1726	695266722000	12675	6537	1	0	\N
106097	1397	1370003134000	12676	6538	0	0	\N
106098	1397	1369993133000	12676	6538	1	0	\N
106099	1726	695265721000	12676	6538	2	0	\N
106100	1726	695264720000	12676	6538	3	0	\N
106107	1397	1369983132000	12679	6539	0	0	\N
106108	1726	695263719000	12679	6539	1	0	\N
106109	1397	1369983132000	12680	6539	0	0	\N
106110	1726	695263719000	12680	6539	1	0	\N
106117	1397	1369953129000	12683	6541	0	0	\N
106118	1726	695260716000	12683	6541	1	0	\N
106121	1397	1369943128000	12685	6542	0	0	\N
106122	1726	695259715000	12685	6542	1	0	\N
106123	1397	1369943128000	12686	6542	0	0	\N
106124	1397	1369933127000	12687	6543	0	0	\N
106125	1726	695258714000	12687	6543	1	0	\N
106128	1397	1369923126000	12689	6544	0	0	\N
106129	1726	695257713000	12689	6544	1	0	\N
106132	1397	1369913125000	12691	6545	0	0	\N
106133	1726	695256712000	12691	6545	1	0	\N
106134	1397	1369913125000	12692	6545	0	0	\N
106135	1726	695256712000	12692	6545	1	0	\N
106137	1397	1369903124000	12694	6546	0	0	\N
106138	1726	695256712000	12694	6546	1	0	\N
106145	1397	1369873121000	12697	6548	0	0	\N
106146	1726	695253709000	12697	6548	1	0	\N
106153	1397	1369843118000	12701	6551	0	0	\N
106154	1397	1369833117000	12701	6551	1	0	\N
106155	1726	695250706000	12701	6551	2	0	\N
106156	1726	695249705000	12701	6551	3	0	\N
106161	1397	1369823116000	12703	6552	0	0	\N
106162	1726	695248704000	12703	6552	1	0	\N
106167	1397	1369813115000	12706	6553	0	0	\N
106168	1726	695247703000	12706	6553	1	0	\N
106169	1397	1369813115000	12707	6553	0	0	\N
106170	1726	695247703000	12707	6553	1	0	\N
106171	1397	1369813115000	12708	6553	0	0	\N
106172	1726	695247703000	12708	6553	1	0	\N
106177	1397	1369803114000	12710	6554	0	0	\N
106178	1397	1369793113000	12710	6554	1	0	\N
106179	1726	695246702000	12710	6554	2	0	\N
106180	1726	695245701000	12710	6554	3	0	\N
106181	1397	1369803114000	12711	6554	0	0	\N
106182	1397	1369793113000	12711	6554	1	0	\N
106183	1726	695246702000	12711	6554	2	0	\N
106184	1726	695245701000	12711	6554	3	0	\N
106187	1397	1369783112000	12713	6555	0	0	\N
106188	1726	695244700000	12713	6555	1	0	\N
106189	1397	1369773111000	12714	6556	0	0	\N
106190	1397	1369763110000	12714	6556	1	0	\N
106191	1397	1369753109000	12714	6556	2	0	\N
106192	1726	695243699000	12714	6556	3	0	\N
106193	1726	695242698000	12714	6556	4	0	\N
106194	1726	695241697000	12714	6556	5	0	\N
106201	1599	18875073052715	12716	6480	0	0	\N
106202	1397	1370853219000	12716	6480	1	0	\N
106203	1397	1370843218000	12716	6480	2	0	\N
106204	1397	1370833217000	12716	6480	3	0	\N
106205	1599	15281330064617	12716	6480	4	0	\N
106206	1599	12856556807349	12716	6480	5	0	\N
106207	1599	6099728393047	12716	6480	6	0	\N
106208	1397	1370823216000	12716	6480	7	0	\N
106209	1397	1370813215000	12716	6480	8	0	\N
106210	1397	1370803214000	12716	6480	9	0	\N
106211	1397	1370793213000	12716	6480	10	0	\N
106212	1397	1370783212000	12716	6480	11	0	\N
106213	1397	1370773211000	12716	6480	12	0	\N
106214	1397	1370763210000	12716	6480	13	0	\N
106215	1397	1370753209000	12716	6480	14	0	\N
106216	1397	1370743208000	12716	6480	15	0	\N
106093	1397	1370013135000	12674	6537	0	0	6882
106094	1726	695266722000	12674	6537	1	0	4530
106101	1397	1370003134000	12677	6538	0	0	6883
106102	1397	1369993133000	12677	6538	1	0	6884
106103	1726	695265721000	12677	6538	2	0	4531
106105	1397	1369983132000	12678	6539	0	0	6885
106106	1726	695263719000	12678	6539	1	0	4533
106111	1397	1369973131000	12681	6540	0	0	6886
106112	1397	1369963130000	12681	6540	1	0	6887
106113	1726	695262718000	12681	6540	3	0	4534
106115	1397	1369953129000	12682	6541	0	0	6888
106116	1726	695260716000	12682	6541	1	0	4536
106119	1397	1369943128000	12684	6542	0	0	6889
106120	1726	695259715000	12684	6542	1	0	4537
106127	1726	695258714000	12688	6543	1	0	4538
106130	1397	1369923126000	12690	6544	0	0	6891
106131	1726	695257713000	12690	6544	1	0	4539
106136	1397	1369913125000	12693	6545	0	0	6892
106139	1397	1369903124000	12695	6546	0	0	6893
106141	1397	1369893123000	12696	6547	0	0	6894
106142	1397	1369883122000	12696	6547	1	0	6895
106143	1726	695255711000	12696	6547	2	0	4541
106144	1726	695254710000	12696	6547	3	0	4542
106147	1397	1369873121000	12698	6548	0	0	6896
106149	1397	1369863120000	12699	6549	0	0	6897
106150	1726	695252708000	12699	6549	1	0	4544
106151	1397	1369853119000	12700	6550	0	0	6898
106152	1726	695251707000	12700	6550	1	0	4545
106158	1397	1369833117000	12702	6551	1	0	6900
106159	1726	695250706000	12702	6551	2	0	4546
106160	1726	695249705000	12702	6551	3	0	4547
106163	1397	1369823116000	12704	6552	0	0	6901
106164	1726	695248704000	12704	6552	1	0	4548
106166	1726	695247703000	12705	6553	1	0	4549
106173	1397	1369803114000	12709	6554	0	0	6903
106174	1397	1369793113000	12709	6554	1	0	6904
106175	1726	695246702000	12709	6554	2	0	4550
106176	1726	695245701000	12709	6554	3	0	4551
106186	1726	695244700000	12712	6555	1	0	4552
106195	1397	1369773111000	12715	6556	0	0	6906
106196	1397	1369763110000	12715	6556	1	0	6907
106197	1397	1369753109000	12715	6556	2	0	6908
106199	1726	695242698000	12715	6556	4	0	4554
106200	1726	695241697000	12715	6556	5	0	4555
106217	1397	1370733207000	12716	6480	16	0	\N
106218	1397	1370723206000	12716	6480	17	0	\N
106219	1397	1370713205000	12716	6480	18	0	\N
106220	1397	1370703204000	12716	6480	19	0	\N
106221	1397	1370693203000	12716	6480	20	0	\N
106222	1397	1370683202000	12716	6480	21	0	\N
106223	1397	1370673201000	12716	6480	22	0	\N
106224	1397	1370663200000	12716	6480	23	0	\N
106225	1397	1370653199000	12716	6480	24	0	\N
106226	1397	1370643198000	12716	6480	25	0	\N
106227	1397	1370633197000	12716	6480	26	0	\N
106228	1397	1370623196000	12716	6480	27	0	\N
106229	1397	1370613195000	12716	6480	28	0	\N
106230	1397	1370603194000	12716	6480	29	0	\N
106231	1397	1370593193000	12716	6480	30	0	\N
106232	1397	1370583192000	12716	6480	31	0	\N
106233	1397	1370573191000	12716	6480	32	0	\N
106234	1397	1370563190000	12716	6480	33	0	\N
106235	1397	1370553189000	12716	6480	34	0	\N
106236	1397	1370543188000	12716	6480	35	0	\N
106237	1397	1370533187000	12716	6480	36	0	\N
106238	1397	1370523186000	12716	6480	37	0	\N
106239	1397	1370513185000	12716	6480	38	0	\N
106240	1397	1370503184000	12716	6480	39	0	\N
106241	1397	1370493183000	12716	6480	40	0	\N
106242	1397	1370483182000	12716	6480	41	0	\N
106243	1726	698979805000	12716	6480	42	0	\N
106244	1750	4181000000	12716	6480	43	0	\N
106245	1726	698978804000	12716	6480	44	0	\N
106246	1726	698977803000	12716	6480	45	0	\N
106247	1726	698976802000	12716	6480	46	0	\N
106248	1726	698975801000	12716	6480	47	0	\N
106249	1750	4180000000	12716	6480	48	0	\N
106250	1588	15625887000000	12716	6480	49	0	\N
106251	1588	11300275000000	12716	6480	50	0	\N
106252	1588	8388612000000	12716	6480	51	0	\N
106253	1588	5974754000000	12716	6480	52	0	\N
106254	1718	3186679763340	12716	6480	53	0	\N
106255	1726	698974800000	12716	6480	54	0	\N
106256	1726	698973799000	12716	6480	55	0	\N
106257	1726	698972798000	12716	6480	56	0	\N
106258	1726	698971797000	12716	6480	57	0	\N
106259	1750	4179000000	12716	6480	58	0	\N
106260	1750	4178000000	12716	6480	59	0	\N
106261	1750	4177000000	12716	6480	60	0	\N
106262	1750	4176000000	12716	6480	62	0	\N
106263	1750	4175000000	12716	6480	63	0	\N
106264	1750	4174000000	12716	6480	64	0	\N
106265	1750	4173000000	12716	6480	65	0	\N
106266	1726	698970796000	12716	6480	66	0	\N
106267	1726	698969795000	12716	6480	67	0	\N
106268	1726	698968794000	12716	6480	68	0	\N
106269	1726	698967793000	12716	6480	69	0	\N
106270	1726	698966792000	12716	6480	70	0	\N
106271	1726	698965791000	12716	6480	71	0	\N
106272	1726	698964790000	12716	6480	72	0	\N
106273	1726	698963789000	12716	6480	73	0	\N
106274	1726	698962788000	12716	6480	74	0	\N
106275	1726	698961787000	12716	6480	75	0	\N
106276	1726	698960786000	12716	6480	76	0	\N
106277	1726	698959785000	12716	6480	77	0	\N
106278	1726	698958784000	12716	6480	78	0	\N
106279	1726	698957783000	12716	6480	79	0	\N
106280	1726	698956782000	12716	6480	80	0	\N
106281	1726	698955781000	12716	6480	81	0	\N
106282	1726	698954780000	12716	6480	82	0	\N
106283	1726	698953779000	12716	6480	83	0	\N
106284	1726	698952778000	12716	6480	84	0	\N
106285	1726	698951777000	12716	6480	85	0	\N
106286	1726	698950776000	12716	6480	86	0	\N
106287	1726	698949775000	12716	6480	87	0	\N
106288	1726	698948774000	12716	6480	88	0	\N
106289	1726	698947773000	12716	6480	89	0	\N
106290	1726	698946772000	12716	6480	90	0	\N
106291	1726	698945771000	12716	6480	91	0	\N
106292	1726	698944770000	12716	6480	92	0	\N
106293	1726	698943769000	12716	6480	93	0	\N
106294	1726	698942768000	12716	6480	94	0	\N
106295	1726	698941767000	12716	6480	95	0	\N
106296	1726	698940766000	12716	6480	96	0	\N
106297	1726	698939765000	12716	6480	97	0	\N
106298	1726	698938764000	12716	6480	98	0	\N
106299	1726	698937763000	12716	6480	99	0	\N
106300	1726	698936762000	12716	6480	100	0	\N
106301	1726	698935761000	12716	6480	101	0	\N
106302	1726	698934760000	12716	6480	102	0	\N
106303	1726	698933759000	12716	6480	103	0	\N
106304	1726	698932758000	12716	6480	104	0	\N
106305	1726	698931757000	12716	6480	105	0	\N
106306	1726	698930756000	12716	6480	106	0	\N
106307	1726	698929755000	12716	6480	107	0	\N
106308	1726	698928754000	12716	6480	108	0	\N
106309	1726	698927753000	12716	6480	109	0	\N
106310	1726	698926752000	12716	6480	110	0	\N
106311	1726	698925751000	12716	6480	111	0	\N
106312	1726	698924750000	12716	6480	112	0	\N
106313	1726	698923749000	12716	6480	113	0	\N
106314	1726	698922748000	12716	6480	114	0	\N
106315	1726	698921747000	12716	6480	115	0	\N
106316	1726	698920746000	12716	6480	116	0	\N
106317	1726	698919745000	12716	6480	117	0	\N
106318	1726	698918744000	12716	6480	118	0	\N
106319	1726	698917743000	12716	6480	119	0	\N
106320	1726	698916742000	12716	6480	120	0	\N
106321	1726	698915741000	12716	6480	121	0	\N
106322	1726	698914740000	12716	6480	122	0	\N
106323	1726	698913739000	12716	6480	123	0	\N
106324	1726	698912738000	12716	6480	124	0	\N
106325	1726	698911737000	12716	6480	125	0	\N
106326	1397	1369773111000	12717	6556	0	0	\N
106327	1397	1369763110000	12717	6556	1	0	\N
106328	1397	1369753109000	12717	6556	2	0	\N
106329	1726	695243699000	12717	6556	3	0	\N
106330	1726	695242698000	12717	6556	4	0	\N
106331	1726	695241697000	12717	6556	5	0	\N
106349	1397	1369663100000	12722	6561	0	0	\N
106350	1397	1369653099000	12722	6561	1	0	\N
106351	1726	695232688000	12722	6561	2	0	\N
106352	1726	695231687000	12722	6561	3	0	\N
106334	1750	4172000000	12718	6557	2	0	28
106335	1726	695240696000	12718	6557	3	0	4556
106336	1726	695239695000	12718	6557	4	0	4557
106337	1397	1369723106000	12719	6558	0	0	6911
106338	1397	1369713105000	12719	6558	1	0	6912
106340	1726	695237693000	12719	6558	3	0	4559
106341	1397	1369703104000	12720	6559	0	0	6913
106342	1397	1369693103000	12720	6559	1	0	6914
106343	1397	1369683102000	12720	6559	2	0	6915
106344	1726	695236692000	12720	6559	3	0	4560
106346	1726	695234690000	12720	6559	5	0	4562
106347	1397	1369673101000	12721	6560	0	0	6916
106348	1726	695233689000	12721	6560	1	0	4563
106353	1397	1369663100000	12723	6561	0	0	\N
106354	1397	1369653099000	12723	6561	1	0	\N
106355	1726	695232688000	12723	6561	2	0	\N
106356	1726	695231687000	12723	6561	3	0	\N
106361	1599	18875073052715	12725	6431	0	0	\N
106362	1397	1371433277000	12725	6431	1	0	\N
106363	1599	15281330064617	12725	6431	2	0	\N
106364	1397	1371423276000	12725	6431	3	0	\N
106365	1397	1371413275000	12725	6431	4	0	\N
106366	1599	12856556807349	12725	6431	5	0	\N
106367	1599	6099728393047	12725	6431	6	0	\N
106368	1397	1371403274000	12725	6431	7	0	\N
106369	1397	1371393273000	12725	6431	8	0	\N
106370	1397	1371383272000	12725	6431	9	0	\N
106371	1397	1371373271000	12725	6431	10	0	\N
106372	1397	1371363270000	12725	6431	11	0	\N
106373	1397	1371353269000	12725	6431	12	0	\N
106374	1397	1371343268000	12725	6431	13	0	\N
106375	1397	1371333267000	12725	6431	14	0	\N
106376	1397	1371323266000	12725	6431	15	0	\N
106377	1397	1371313265000	12725	6431	16	0	\N
106378	1397	1371303264000	12725	6431	17	0	\N
106379	1397	1371293263000	12725	6431	18	0	\N
106380	1397	1371283262000	12725	6431	19	0	\N
106381	1397	1371273261000	12725	6431	20	0	\N
106382	1397	1371263260000	12725	6431	21	0	\N
106383	1397	1371253259000	12725	6431	22	0	\N
106384	1397	1371243258000	12725	6431	23	0	\N
106385	1397	1371233257000	12725	6431	24	0	\N
106386	1397	1371223256000	12725	6431	25	0	\N
106387	1397	1371213255000	12725	6431	26	0	\N
106388	1397	1371203254000	12725	6431	27	0	\N
106389	1397	1371193253000	12725	6431	28	0	\N
106390	1397	1371183252000	12725	6431	29	0	\N
106391	1397	1371173251000	12725	6431	30	0	\N
106392	1397	1371163250000	12725	6431	31	0	\N
106393	1397	1371153249000	12725	6431	32	0	\N
106394	1397	1371143248000	12725	6431	33	0	\N
106395	1397	1371133247000	12725	6431	34	0	\N
106404	1397	1369603094000	12728	6564	0	0	\N
106405	1726	695226682000	12728	6564	1	0	\N
106406	1750	4172000000	12729	6481	0	0	\N
106407	1726	698910736000	12729	6481	1	0	\N
106408	1726	698909735000	12729	6481	2	0	\N
106409	1726	698908734000	12729	6481	3	0	\N
106410	1726	698907733000	12729	6481	4	0	\N
106411	1726	698906732000	12729	6481	5	0	\N
106412	1726	698905731000	12729	6481	6	0	\N
106413	1726	698904730000	12729	6481	7	0	\N
106414	1726	697694730000	12729	6481	8	0	\N
106415	1726	696484730000	12729	6481	9	0	\N
106416	1726	695274730000	12729	6481	10	0	\N
106417	1726	695273729000	12729	6481	11	0	\N
106418	1726	695272728000	12729	6481	12	0	\N
106419	1726	695271727000	12729	6481	13	0	\N
106420	1726	695270726000	12729	6481	14	0	\N
106421	1726	695269725000	12729	6481	15	0	\N
106422	1726	695268724000	12729	6481	16	0	\N
106423	1726	695267723000	12729	6481	17	0	\N
106424	1726	695266722000	12729	6481	18	0	\N
106425	1726	695265721000	12729	6481	19	0	\N
106426	1726	695264720000	12729	6481	20	0	\N
106427	1726	695263719000	12729	6481	21	0	\N
106428	1726	695262718000	12729	6481	22	0	\N
106429	1726	695261717000	12729	6481	23	0	\N
106430	1726	695260716000	12729	6481	24	0	\N
106431	1726	695259715000	12729	6481	25	0	\N
106432	1726	695258714000	12729	6481	26	0	\N
106433	1726	695257713000	12729	6481	27	0	\N
106434	1726	695256712000	12729	6481	28	0	\N
106435	1726	695255711000	12729	6481	29	0	\N
106436	1726	695254710000	12729	6481	30	0	\N
106437	1726	695253709000	12729	6481	31	0	\N
106438	1726	695252708000	12729	6481	32	0	\N
106439	1726	695251707000	12729	6481	33	0	\N
106440	1726	695250706000	12729	6481	34	0	\N
106441	1726	695249705000	12729	6481	35	0	\N
106442	1726	695248704000	12729	6481	36	0	\N
106443	1726	695247703000	12729	6481	37	0	\N
106444	1726	695246702000	12729	6481	38	0	\N
106445	1726	695245701000	12729	6481	39	0	\N
106446	1726	695244700000	12729	6481	40	0	\N
106447	1726	695243699000	12729	6481	41	0	\N
106448	1726	695242698000	12729	6481	42	0	\N
106449	1726	695241697000	12729	6481	43	0	\N
106450	1726	695240696000	12729	6481	44	0	\N
106451	1726	695239695000	12729	6481	45	0	\N
106452	1726	695238694000	12729	6481	46	0	\N
106453	1726	695237693000	12729	6481	47	0	\N
106454	1726	695236692000	12729	6481	48	0	\N
106455	1726	695235691000	12729	6481	49	0	\N
106456	1726	695234690000	12729	6481	50	0	\N
106457	1726	695233689000	12729	6481	51	0	\N
106458	1726	695232688000	12729	6481	52	0	\N
106459	1726	695231687000	12729	6481	53	0	\N
106460	1726	695230686000	12729	6481	54	0	\N
106461	1726	695229685000	12729	6481	55	0	\N
106462	1726	695228684000	12729	6481	56	0	\N
106463	1726	695227683000	12729	6481	57	0	\N
106464	1726	695226682000	12729	6481	58	0	\N
106468	1397	1369593093000	12732	6565	0	0	\N
106469	1726	695225681000	12732	6565	1	0	\N
106470	1397	1369593093000	12733	6565	0	0	\N
106471	1726	695225681000	12733	6565	1	0	\N
106472	1397	1369593093000	12734	6565	0	0	\N
106473	1726	695225681000	12734	6565	1	0	\N
106482	1397	1369563090000	12738	6568	0	0	\N
106483	1397	1369563090000	12739	6568	0	0	\N
106484	1726	695222678000	12739	6568	1	0	\N
106485	1397	1369563090000	12740	6568	0	0	\N
106486	1726	695222678000	12740	6568	1	0	\N
106359	1726	695232688000	12724	6561	2	0	4564
106360	1726	695231687000	12724	6561	3	0	4565
106396	1397	1369643098000	12726	6562	0	0	6919
106397	1726	695230686000	12726	6562	1	0	4566
106398	1397	1369633097000	12727	6563	0	0	6920
106400	1397	1369613095000	12727	6563	2	0	6922
106401	1726	695229685000	12727	6563	3	0	4567
106402	1726	695228684000	12727	6563	4	0	4568
106403	1726	695227683000	12727	6563	5	0	4569
106465	1397	1369603094000	12730	6564	0	0	6923
106467	1397	1369593093000	12731	6565	0	0	6924
106474	1397	1369583092000	12736	6567	0	0	6925
106475	1397	1369573091000	12736	6567	1	0	6926
106476	593	66413823089930	12736	6567	2	0	1
106478	1726	695224680000	12736	6567	4	0	4572
106479	1726	695223679000	12736	6567	5	0	4573
106480	1397	1369563090000	12737	6568	0	0	6927
106481	1726	695222678000	12737	6568	1	0	4574
106487	1397	1369553089000	12741	6569	0	0	6928
106491	1397	1369543088000	12743	6570	0	0	\N
106492	1726	695220676000	12743	6570	1	0	\N
106493	1397	1369533087000	12744	6571	0	0	\N
106494	1726	695219675000	12744	6571	1	0	\N
106495	1397	1369533087000	12745	6571	0	0	\N
106496	1726	695219675000	12745	6571	1	0	\N
106499	1397	1369523086000	12747	6572	0	0	\N
106500	1397	1369513085000	12747	6572	1	0	\N
106501	1549	34560817000000	12747	6572	2	0	\N
106502	1726	695218674000	12747	6572	3	0	\N
106503	1726	695217673000	12747	6572	4	0	\N
106504	1397	1369523086000	12748	6572	0	0	\N
106505	1397	1369513085000	12748	6572	1	0	\N
106506	1549	34560817000000	12748	6572	2	0	\N
106507	1726	695218674000	12748	6572	3	0	\N
106508	1726	695217673000	12748	6572	4	0	\N
106517	1397	1369473081000	12751	6574	0	0	\N
106518	1397	1369463080000	12751	6574	1	0	\N
106519	1397	1369453079000	12751	6574	2	0	\N
106520	1549	31187134000000	12751	6574	3	0	\N
106521	1397	1369473081000	12752	6574	0	0	\N
106522	1397	1369463080000	12752	6574	1	0	\N
106523	1397	1369453079000	12752	6574	2	0	\N
106524	1726	695216672000	12752	6574	3	0	\N
106525	1726	695215671000	12752	6574	4	0	\N
106526	1726	695214670000	12752	6574	5	0	\N
106527	1726	695213669000	12752	6574	6	0	\N
106528	1726	695212668000	12752	6574	7	0	\N
106529	1726	695211667000	12752	6574	8	0	\N
106530	1549	31187134000000	12752	6574	9	0	\N
106541	1397	1369443078000	12754	6575	0	0	\N
106542	1397	1369433077000	12754	6575	1	0	\N
106543	1708	16770835119061	12754	6575	2	0	\N
106544	1708	13278420398550	12754	6575	3	0	\N
106545	1708	10922015342549	12754	6575	4	0	\N
106546	1708	4355701000021	12754	6575	5	0	\N
106547	1549	27108040000000	12754	6575	6	0	\N
106548	1549	21062431000000	12754	6575	7	0	\N
106549	1549	9695676000000	12754	6575	8	0	\N
106550	1726	695210666000	12754	6575	9	0	\N
106551	1726	695209665000	12754	6575	10	0	\N
106571	1397	1369403074000	12758	6577	0	0	\N
106572	1397	1369393073000	12758	6577	1	0	\N
106573	1726	695206662000	12758	6577	2	0	\N
106574	1726	695205661000	12758	6577	3	0	\N
106575	1397	1369403074000	12759	6577	0	0	\N
106576	1397	1369393073000	12759	6577	1	0	\N
106577	1726	695206662000	12759	6577	2	0	\N
106578	1726	695205661000	12759	6577	3	0	\N
106600	1397	1369283062000	12768	6584	0	0	\N
106601	1726	695194650000	12768	6584	1	0	\N
106608	1397	1369263060000	12772	6586	0	0	\N
106609	1726	695192648000	12772	6586	1	0	\N
106610	1397	1369273061000	12773	6585	0	0	\N
106611	1726	695193649000	12773	6585	1	0	\N
106612	1726	695192648000	12773	6585	2	0	\N
106613	1397	1369263060000	12774	6586	0	0	\N
106614	1726	695192648000	12774	6586	1	0	\N
106615	1397	1369263060000	12775	6586	0	0	\N
106616	1726	695192648000	12775	6586	1	0	\N
106617	1397	1369263060000	12776	6586	0	0	\N
106618	1726	695192648000	12776	6586	1	0	\N
106619	1726	695191647000	12777	6587	0	0	\N
106622	1397	1369253059000	12779	6587	0	0	\N
106623	1726	695191647000	12779	6587	1	0	\N
106497	1397	1369533087000	12746	6571	0	0	6930
106498	1726	695219675000	12746	6571	1	0	4577
106509	1397	1369523086000	12749	6572	0	0	6931
106510	1397	1369513085000	12749	6572	1	0	6932
106511	1549	34560817000000	12749	6572	2	0	1
106513	1397	1369493083000	12750	6573	1	0	6934
106514	1397	1369483082000	12750	6573	2	0	6935
106515	1726	695218674000	12750	6573	3	0	4578
106516	1726	695217673000	12750	6573	4	0	4579
106531	1397	1369473081000	12753	6574	0	0	6936
106533	1397	1369453079000	12753	6574	2	0	6938
106534	1726	695216672000	12753	6574	3	0	4580
106535	1726	695215671000	12753	6574	4	0	4581
106536	1726	695214670000	12753	6574	5	0	4582
106538	1726	695212668000	12753	6574	7	0	4584
106539	1726	695211667000	12753	6574	8	0	4585
106540	1549	31187134000000	12753	6574	9	0	2
106552	1397	1369443078000	12755	6575	0	0	6939
106553	1397	1369433077000	12755	6575	1	0	6940
106555	1708	13278420398550	12755	6575	3	0	2
106556	1708	10922015342549	12755	6575	4	0	3
106557	1708	4355701000021	12755	6575	5	0	4
106558	1549	27108040000000	12755	6575	6	0	3
106559	1549	21062431000000	12755	6575	7	0	4
106561	1726	695210666000	12755	6575	9	0	4586
106562	1726	695209665000	12755	6575	10	0	4587
106563	1397	1369423076000	12756	6576	0	0	6941
106564	1397	1369413075000	12756	6576	1	0	6942
106566	1726	695207663000	12756	6576	3	0	4589
106567	1397	1369403074000	12757	6577	0	0	6943
106568	1397	1369393073000	12757	6577	1	0	6944
106569	1726	695206662000	12757	6577	2	0	4590
106570	1726	695205661000	12757	6577	3	0	4591
106580	1397	1369373071000	12760	6578	1	0	6946
106581	1726	695204660000	12760	6578	2	0	4592
106582	106	66413823089930	12760	6578	3	0	1
106583	1726	695203659000	12760	6578	4	0	4593
106584	1397	1369363070000	12761	6579	0	0	6947
106586	1397	1369343068000	12762	6580	0	0	6949
106587	1726	695202658000	12762	6580	1	0	4594
106588	1726	695201657000	12762	6580	2	0	4595
106589	1726	695200656000	12762	6580	3	0	4596
106591	1726	695199655000	12763	6581	1	0	4597
106592	1397	1369323066000	12764	6582	0	0	6951
106593	1397	1369313065000	12764	6582	1	0	6952
106594	1397	1369303064000	12764	6582	2	0	6953
106595	1726	695198654000	12764	6582	3	0	4598
106597	1726	695196652000	12764	6582	5	0	4600
106598	1397	1369293063000	12767	6583	0	0	6954
106599	1726	695195651000	12767	6583	1	0	4601
106602	1397	1369283062000	12769	6584	0	0	6955
106603	1726	695194650000	12769	6584	1	0	4602
106605	1726	695193649000	12770	6585	1	0	4603
106606	1397	1369263060000	12771	6586	0	0	6957
106607	1726	695192648000	12771	6586	1	0	4604
106620	1397	1369253059000	12778	6587	0	0	6958
106624	1726	695190646000	12780	6588	0	0	4606
106625	1397	1369243058000	12781	6589	0	0	\N
106626	1397	1369233057000	12781	6589	1	0	\N
106627	1397	1369223056000	12781	6589	3	0	\N
106628	1726	695189645000	12781	6589	4	0	\N
106629	1657	23031257000000	12781	6589	5	0	\N
106630	1726	695188644000	12781	6589	6	0	\N
106631	1726	695187643000	12781	6589	7	0	\N
106643	1397	1369213055000	12784	6590	0	0	\N
106644	1397	1369203054000	12784	6590	1	0	\N
106645	1726	695186642000	12784	6590	2	0	\N
106646	1726	695185641000	12784	6590	3	0	\N
106647	1397	1369193053000	12785	6591	0	0	\N
106648	1397	1369183052000	12785	6591	1	0	\N
106649	1726	695184640000	12785	6591	2	0	\N
106650	1726	695183639000	12785	6591	3	0	\N
106660	1397	1369153049000	12790	6594	0	0	\N
106661	1726	695180636000	12790	6594	1	0	\N
106667	1397	1369153049000	12792	6595	0	0	\N
106668	1397	1369143048000	12792	6595	1	0	\N
106669	1397	1369133047000	12792	6595	2	0	\N
106670	1397	1369123046000	12792	6595	3	0	\N
106671	1657	17202285000000	12792	6595	4	0	\N
106672	1726	695180636000	12792	6595	5	0	\N
106673	1726	695179635000	12792	6595	6	0	\N
106674	1726	695178634000	12792	6595	7	0	\N
106675	1726	695177633000	12792	6595	8	0	\N
106676	1397	1369113045000	12793	6596	0	0	\N
106677	1726	695180636000	12793	6596	1	0	\N
106678	1726	695179635000	12793	6596	2	0	\N
106679	1726	695178634000	12793	6596	3	0	\N
106680	1726	695177633000	12793	6596	4	0	\N
106681	1726	695176632000	12793	6596	5	0	\N
106682	1657	14678004000000	12793	6596	6	0	\N
106692	1397	1369103044000	12796	6597	0	0	\N
106693	1726	695180636000	12796	6597	1	0	\N
106694	1726	695179635000	12796	6597	2	0	\N
106695	1726	695178634000	12796	6597	3	0	\N
106696	1726	695177633000	12796	6597	4	0	\N
106697	1726	695176632000	12796	6597	5	0	\N
106705	1397	1369073041000	12800	6600	0	0	\N
106706	1726	695172628000	12800	6600	1	0	\N
106713	1397	1369043038000	12804	6603	0	0	\N
106714	1726	695169625000	12804	6603	1	0	\N
106715	1397	1369043038000	12805	6603	0	0	\N
106716	1726	695169625000	12805	6603	1	0	\N
106717	1397	1369033037000	12806	6604	0	0	\N
106718	1932	1136839152658	12806	6604	1	0	\N
106719	1397	1369033037000	12807	6604	0	0	\N
106720	1932	1136839152658	12807	6604	1	0	\N
106721	1726	695169625000	12807	6604	2	0	\N
106728	1397	1369003034000	12812	6607	0	0	\N
106729	1397	1368993033000	12812	6607	1	0	\N
106730	1397	1368983032000	12812	6607	2	0	\N
106734	1397	1369003034000	12814	6607	0	0	\N
106735	1397	1368993033000	12814	6607	1	0	\N
106736	1397	1368983032000	12814	6607	2	0	\N
106745	1397	1368893023000	12822	6614	0	0	\N
106750	1397	1368863020000	12827	6617	0	0	\N
106752	1932	1136839152658	12829	6595	0	0	\N
106753	1932	638829152658	12829	6595	1	0	\N
106754	1397	1368853019000	12830	6618	0	0	\N
106755	1397	1368843018000	12831	6619	0	0	\N
106757	1397	1368843018000	12833	6619	0	0	\N
106758	1397	1368843018000	12834	6619	0	0	\N
106759	1397	1368843018000	12835	6619	0	0	\N
106760	1397	1368833017000	12836	6620	0	0	\N
106634	1397	1369223056000	12782	6589	3	0	6961
106635	1726	695189645000	12782	6589	4	0	4607
106636	1657	23031257000000	12782	6589	5	0	1
106637	1726	695188644000	12782	6589	6	0	4608
106638	1726	695187643000	12782	6589	7	0	4609
106640	1397	1369203054000	12783	6590	1	0	6963
106641	1726	695186642000	12783	6590	2	0	4610
106642	1726	695185641000	12783	6590	3	0	4611
106651	1397	1369193053000	12787	6592	0	0	6964
106652	1397	1369183052000	12787	6592	1	0	6965
106654	1726	695184640000	12787	6592	3	0	4612
106655	1726	695183639000	12787	6592	4	0	4613
106656	1726	695182638000	12787	6592	5	0	4614
106657	1397	1369163050000	12788	6593	0	0	6967
106659	1726	695181637000	12788	6593	2	0	4615
106662	1397	1369153049000	12791	6595	0	0	6968
106663	1397	1369143048000	12791	6595	1	0	6969
106664	1397	1369133047000	12791	6595	2	0	6970
106665	1397	1369123046000	12791	6595	3	0	6971
106683	1397	1369113045000	12794	6596	0	0	6972
106684	1657	14678004000000	12794	6596	1	0	4
106685	1397	1369103044000	12795	6597	0	0	6973
106686	1726	695180636000	12795	6597	1	0	4616
106687	1726	695179635000	12795	6597	2	0	4617
106689	1726	695177633000	12795	6597	4	0	4619
106690	1726	695176632000	12795	6597	5	0	4620
106691	1726	695175631000	12795	6597	6	0	4621
106698	1397	1369093043000	12797	6598	0	0	6974
106700	1726	695174630000	12797	6598	2	0	4622
106701	1397	1369083042000	12798	6599	0	0	6975
106702	1726	695173629000	12798	6599	1	0	4623
106703	1397	1369073041000	12799	6600	0	0	6976
106704	1726	695172628000	12799	6600	1	0	4624
106708	1726	695171627000	12801	6601	1	0	4625
106709	1657	6481282000000	12801	6601	2	0	6
106710	1397	1369053039000	12802	6602	0	0	6978
106711	1726	695170626000	12802	6602	1	0	4626
106712	1397	1369043038000	12803	6603	0	0	6979
106723	1932	1136839152658	12808	6604	1	0	1
106724	1397	1369023036000	12809	6605	0	0	6981
106725	1932	638829152658	12809	6605	1	0	2
106726	1726	695169625000	12809	6605	2	0	4627
106731	1397	1369003034000	12813	6607	0	0	6983
106732	1397	1368993033000	12813	6607	1	0	6984
106733	1397	1368983032000	12813	6607	2	0	6985
106737	1397	1368973031000	12815	6608	0	0	6986
106738	1397	1368963030000	12815	6608	1	0	6987
106740	1397	1368943028000	12818	6610	0	0	6989
106741	1397	1368933027000	12819	6611	0	0	6990
106742	1397	1368923026000	12820	6612	0	0	6991
106743	1397	1368913025000	12821	6613	0	0	6992
106744	1397	1368903024000	12821	6613	1	0	6993
106747	1397	1368883022000	12824	6615	0	0	6995
106748	1397	1368873021000	12825	6616	0	0	6996
106749	1397	1368863020000	12826	6617	0	0	6997
106751	1397	1368853019000	12828	6618	0	0	6998
106762	1397	1368833017000	12838	6620	0	0	\N
106768	1726	693959625000	12841	6622	0	0	\N
106769	1397	1368813015000	12841	6622	1	0	\N
106770	1726	692749625000	12841	6622	2	0	\N
106771	1726	692748624000	12841	6622	3	0	\N
106774	1397	1368803014000	12843	6623	0	0	\N
106775	1726	692747623000	12843	6623	1	0	\N
106776	1397	1368803014000	12844	6623	0	0	\N
106777	1726	692747623000	12844	6623	1	0	\N
106778	1397	1368793013000	12845	6624	0	0	\N
106779	1726	692746622000	12845	6624	1	0	\N
106784	1932	1136839152658	12848	6585	0	0	\N
106785	1397	1369273061000	12848	6585	1	0	\N
106786	1397	1369263060000	12848	6585	2	0	\N
106787	1397	1369253059000	12848	6585	3	0	\N
106788	1397	1369243058000	12848	6585	4	0	\N
106789	1397	1369233057000	12848	6585	5	0	\N
106790	1397	1369223056000	12848	6585	6	0	\N
106791	1397	1369213055000	12848	6585	7	0	\N
106792	1397	1369203054000	12848	6585	8	0	\N
106793	1397	1369193053000	12848	6585	9	0	\N
106794	1397	1369183052000	12848	6585	10	0	\N
106795	1397	1369173051000	12848	6585	11	0	\N
106796	1397	1369163050000	12848	6585	12	0	\N
106797	1397	1369153049000	12848	6585	13	0	\N
106798	1932	638829152658	12848	6585	14	0	\N
106799	1397	1369143048000	12848	6585	15	0	\N
106800	1397	1369133047000	12848	6585	16	0	\N
106801	1397	1369123046000	12848	6585	18	0	\N
106802	1397	1369113045000	12848	6585	19	0	\N
106803	1397	1369103044000	12848	6585	20	0	\N
106804	1397	1369093043000	12848	6585	21	0	\N
106805	1397	1369083042000	12848	6585	22	0	\N
106806	1397	1369073041000	12848	6585	23	0	\N
106807	1397	1369063040000	12848	6585	24	0	\N
106808	1397	1369053039000	12848	6585	25	0	\N
106809	1397	1369043038000	12848	6585	26	0	\N
106810	1397	1369033037000	12848	6585	27	0	\N
106811	1397	1369023036000	12848	6585	28	0	\N
106812	1397	1369013035000	12848	6585	29	0	\N
106813	1397	1369003034000	12848	6585	30	0	\N
106814	1397	1368993033000	12848	6585	31	0	\N
106815	1397	1368983032000	12848	6585	32	0	\N
106816	1397	1368973031000	12848	6585	33	0	\N
106817	1397	1368963030000	12848	6585	34	0	\N
106818	1397	1368953029000	12848	6585	35	0	\N
106819	1397	1368943028000	12848	6585	36	0	\N
106820	1397	1368933027000	12848	6585	37	0	\N
106821	1397	1368923026000	12848	6585	38	0	\N
106822	1397	1368913025000	12848	6585	39	0	\N
106823	1397	1368903024000	12848	6585	40	0	\N
106824	1397	1368893023000	12848	6585	41	0	\N
106825	1397	1368883022000	12848	6585	42	0	\N
106826	1397	1368873021000	12848	6585	43	0	\N
106827	1397	1368863020000	12848	6585	44	0	\N
106828	1397	1368853019000	12848	6585	45	0	\N
106829	1397	1368843018000	12848	6585	46	0	\N
106830	1397	1368833017000	12848	6585	47	0	\N
106831	1397	1368823016000	12848	6585	48	0	\N
106832	1397	1368813015000	12848	6585	49	0	\N
106833	1397	1368803014000	12848	6585	50	0	\N
106834	1397	1368793013000	12848	6585	51	0	\N
106835	1397	1368783012000	12848	6585	52	0	\N
106836	1726	695193649000	12848	6585	53	0	\N
106837	1726	695192648000	12848	6585	54	0	\N
106838	1657	23031257000000	12848	6585	55	0	\N
106839	1657	20943506000000	12848	6585	56	0	\N
106840	1657	17202285000000	12848	6585	57	0	\N
106841	1726	695191647000	12848	6585	58	0	\N
106842	1726	695190646000	12848	6585	59	0	\N
106843	1726	695189645000	12848	6585	60	0	\N
106844	1726	695188644000	12848	6585	61	0	\N
106845	1726	695187643000	12848	6585	62	0	\N
106846	1726	695186642000	12848	6585	63	0	\N
106847	1726	695185641000	12848	6585	64	0	\N
106848	1726	695184640000	12848	6585	65	0	\N
106849	1726	695183639000	12848	6585	66	0	\N
106850	1726	695182638000	12848	6585	67	0	\N
106851	1726	695181637000	12848	6585	68	0	\N
106852	1726	695180636000	12848	6585	69	0	\N
106853	1726	695179635000	12848	6585	70	0	\N
106854	1726	695178634000	12848	6585	71	0	\N
106855	1726	695177633000	12848	6585	72	0	\N
106856	1726	695176632000	12848	6585	73	0	\N
106857	1726	695175631000	12848	6585	74	0	\N
106858	1726	695174630000	12848	6585	75	0	\N
106859	1726	695173629000	12848	6585	76	0	\N
106860	1726	695172628000	12848	6585	77	0	\N
106861	1726	695171627000	12848	6585	78	0	\N
106862	1726	695170626000	12848	6585	79	0	\N
106863	1726	695169625000	12848	6585	80	0	\N
106864	1726	693959625000	12848	6585	81	0	\N
106865	1726	692749625000	12848	6585	82	0	\N
106866	1726	692748624000	12848	6585	83	0	\N
106867	1726	692747623000	12848	6585	84	0	\N
106868	1726	692746622000	12848	6585	85	0	\N
106869	1726	692745621000	12848	6585	86	0	\N
106870	1657	14678004000000	12848	6585	87	0	\N
106871	1657	7643883000000	12848	6585	88	0	\N
106872	1657	6481282000000	12848	6585	89	0	\N
106873	1397	1368773011000	12849	6626	0	0	\N
106874	1726	692744620000	12849	6626	1	0	\N
106879	1397	1368763010000	12852	6627	0	0	\N
106880	1726	692743619000	12852	6627	1	0	\N
106883	1397	1368753009000	12854	6628	0	0	\N
106884	1726	692742618000	12854	6628	1	0	\N
106887	1397	1368733007000	12856	6630	0	0	\N
106888	1397	1368723006000	12856	6630	1	0	\N
106889	1726	692740616000	12856	6630	2	0	\N
106890	1726	692739615000	12856	6630	3	0	\N
106895	1397	1368713005000	12858	6631	0	0	\N
106896	1726	692738614000	12858	6631	1	0	\N
106764	1726	693959625000	12840	6622	0	0	4628
106765	1397	1368813015000	12840	6622	1	0	7002
106766	1726	692749625000	12840	6622	2	0	4629
106767	1726	692748624000	12840	6622	3	0	4630
106772	1397	1368803014000	12842	6623	0	0	7003
106780	1397	1368793013000	12846	6624	0	0	7004
106781	1726	692746622000	12846	6624	1	0	4632
106782	1397	1368783012000	12847	6625	0	0	7005
106783	1726	692745621000	12847	6625	1	0	4633
106875	1397	1368773011000	12850	6626	0	0	7006
106877	1397	1368763010000	12851	6627	0	0	7007
106878	1726	692743619000	12851	6627	1	0	4635
106881	1397	1368753009000	12853	6628	0	0	7008
106882	1726	692742618000	12853	6628	1	0	4636
106886	1726	692741617000	12855	6629	1	0	4637
106891	1397	1368733007000	12857	6630	0	0	7010
106892	1397	1368723006000	12857	6630	1	0	7011
106893	1726	692740616000	12857	6630	2	0	4638
106894	1726	692739615000	12857	6630	3	0	4639
106897	1397	1368713005000	12859	6631	0	0	\N
106898	1726	692738614000	12859	6631	1	0	\N
106909	1397	1368713005000	12862	6631	0	0	\N
106910	1397	1368703004000	12863	6632	0	0	\N
106911	1397	1368693003000	12863	6632	1	0	\N
106912	1397	1368683002000	12863	6632	2	0	\N
106913	1726	692738614000	12863	6632	3	0	\N
106914	1653	1438019000000	12863	6632	4	0	\N
106915	1653	1436009000000	12863	6632	5	0	\N
106916	1726	692737613000	12863	6632	6	0	\N
106917	1726	692736612000	12863	6632	7	0	\N
106918	1726	692735611000	12863	6632	8	0	\N
106919	1397	1368673001000	12864	6633	0	0	\N
106920	1397	1368663000000	12864	6633	1	0	\N
106921	1397	1368652999000	12864	6633	2	0	\N
106922	1726	692734610000	12864	6633	3	0	\N
106923	1726	691524610000	12864	6633	4	0	\N
106924	1726	691523609000	12864	6633	5	0	\N
106925	1726	691522608000	12864	6633	6	0	\N
106947	1397	1368612995000	12868	6635	0	0	\N
106948	1397	1368602994000	12868	6635	1	0	\N
106949	1397	1368592993000	12868	6635	2	0	\N
106950	1397	1368582992000	12868	6635	3	0	\N
106951	1726	691518604000	12868	6635	4	0	\N
106952	1726	691517603000	12868	6635	5	0	\N
106953	1726	691516602000	12868	6635	6	0	\N
106954	1726	691515601000	12868	6635	7	0	\N
106966	1397	1368522986000	12871	6638	0	0	\N
106967	1726	691509595000	12871	6638	1	0	\N
106970	1397	1368522986000	12873	6638	0	0	\N
106971	1726	691509595000	12873	6638	1	0	\N
106972	1397	1368512985000	12874	6639	0	0	\N
106973	1397	1368502984000	12874	6639	1	0	\N
106974	1726	691508594000	12874	6639	2	0	\N
106975	1726	691507593000	12874	6639	3	0	\N
106980	1397	1368512985000	12876	6639	0	0	\N
106981	1397	1368502984000	12876	6639	1	0	\N
106982	1726	691508594000	12876	6639	2	0	\N
106983	1726	691507593000	12876	6639	3	0	\N
106986	1397	1368492983000	12878	6640	0	0	\N
106987	1726	691506592000	12878	6640	1	0	\N
106990	1397	1368773011000	12880	6586	0	0	\N
106991	1397	1368763010000	12880	6586	1	0	\N
106992	1397	1368753009000	12880	6586	2	0	\N
106993	1397	1368743008000	12880	6586	3	0	\N
106994	1397	1368733007000	12880	6586	4	0	\N
106995	1397	1368723006000	12880	6586	5	0	\N
106996	1397	1368713005000	12880	6586	6	0	\N
106997	1397	1368703004000	12880	6586	7	0	\N
106998	1397	1368693003000	12880	6586	8	0	\N
106999	1397	1368683002000	12880	6586	9	0	\N
107000	1397	1368673001000	12880	6586	10	0	\N
107001	1397	1368663000000	12880	6586	11	0	\N
107002	1397	1368652999000	12880	6586	12	0	\N
107003	1397	1368642998000	12880	6586	13	0	\N
107004	1397	1368632997000	12880	6586	14	0	\N
107005	1397	1368622996000	12880	6586	15	0	\N
107006	1397	1368612995000	12880	6586	16	0	\N
107007	1397	1368602994000	12880	6586	17	0	\N
107008	1397	1368592993000	12880	6586	18	0	\N
107009	1397	1368582992000	12880	6586	19	0	\N
107010	1397	1368572991000	12880	6586	20	0	\N
107011	1397	1368562990000	12880	6586	21	0	\N
107012	1397	1368552989000	12880	6586	22	0	\N
107013	1397	1368542988000	12880	6586	23	0	\N
107014	1397	1368532987000	12880	6586	24	0	\N
107015	1397	1368522986000	12880	6586	25	0	\N
107016	1397	1368512985000	12880	6586	26	0	\N
107017	1397	1368502984000	12880	6586	27	0	\N
107018	1397	1368492983000	12880	6586	28	0	\N
107019	2044	199000000	12880	6586	29	0	\N
107020	1726	692744620000	12880	6586	30	0	\N
107021	1653	1438019000000	12880	6586	31	0	\N
107022	1653	1436009000000	12880	6586	32	0	\N
107023	1726	692743619000	12880	6586	33	0	\N
107024	1726	692742618000	12880	6586	34	0	\N
107025	1726	692741617000	12880	6586	35	0	\N
107026	1726	692740616000	12880	6586	36	0	\N
107027	1726	692739615000	12880	6586	37	0	\N
107028	1726	692738614000	12880	6586	38	0	\N
107029	1726	692737613000	12880	6586	39	0	\N
107030	1726	692736612000	12880	6586	40	0	\N
107031	1726	692735611000	12880	6586	41	0	\N
107032	1726	692734610000	12880	6586	42	0	\N
106901	1397	1368703004000	12861	6632	0	0	7013
106902	1397	1368693003000	12861	6632	1	0	7014
106903	1397	1368683002000	12861	6632	2	0	7015
106904	1653	1438019000000	12861	6632	3	0	1
106905	1653	1436009000000	12861	6632	4	0	2
106907	1726	692736612000	12861	6632	6	0	4642
106908	1726	692735611000	12861	6632	7	0	4643
106926	1397	1368673001000	12865	6633	0	0	7016
106927	1397	1368663000000	12865	6633	1	0	7017
106928	1397	1368652999000	12865	6633	2	0	7018
106930	1726	691524610000	12865	6633	4	0	4645
106931	1726	691523609000	12865	6633	5	0	4646
106932	1726	691522608000	12865	6633	6	0	4647
106933	1397	1368642998000	12866	6634	0	0	7019
106935	1397	1368622996000	12866	6634	2	0	7021
106936	1726	691521607000	12866	6634	3	0	4648
106937	1726	691520606000	12866	6634	4	0	4649
106938	1726	691519605000	12866	6634	5	0	4650
106939	1397	1368612995000	12867	6635	0	0	7022
106941	1397	1368592993000	12867	6635	2	0	7024
106942	1397	1368582992000	12867	6635	3	0	7025
106943	1726	691518604000	12867	6635	4	0	4651
106944	1726	691517603000	12867	6635	5	0	4652
106945	1726	691516602000	12867	6635	6	0	4653
106955	1397	1368572991000	12869	6636	0	0	7026
106956	1397	1368562990000	12869	6636	1	0	7027
106957	1397	1368552989000	12869	6636	2	0	7028
106958	1397	1368542988000	12869	6636	3	0	7029
106960	2044	199000000	12869	6636	5	0	1
106961	1726	691513599000	12869	6636	6	0	4656
106962	1726	691512598000	12869	6636	7	0	4657
106963	1726	691511597000	12869	6636	8	0	4658
106964	1397	1368532987000	12870	6637	0	0	7030
106968	1397	1368522986000	12872	6638	0	0	7031
106969	1726	691509595000	12872	6638	1	0	4660
106976	1397	1368512985000	12875	6639	0	0	7032
106977	1397	1368502984000	12875	6639	1	0	7033
106978	1726	691508594000	12875	6639	2	0	4661
106984	1397	1368492983000	12877	6640	0	0	7034
106985	1726	691506592000	12877	6640	1	0	4663
106988	1397	1368482982000	12879	6641	0	0	7035
106989	1726	691505591000	12879	6641	1	0	4664
107033	1726	691524610000	12880	6586	43	0	\N
107034	1726	691523609000	12880	6586	44	0	\N
107035	1726	691522608000	12880	6586	45	0	\N
107036	1726	691521607000	12880	6586	46	0	\N
107037	1726	691520606000	12880	6586	47	0	\N
107038	1726	691519605000	12880	6586	48	0	\N
107039	1726	691518604000	12880	6586	49	0	\N
107040	1726	691517603000	12880	6586	50	0	\N
107041	1726	691516602000	12880	6586	51	0	\N
107042	1726	691515601000	12880	6586	52	0	\N
107043	1726	691514600000	12880	6586	54	0	\N
107044	1726	691513599000	12880	6586	55	0	\N
107045	1726	691512598000	12880	6586	56	0	\N
107046	1726	691511597000	12880	6586	57	0	\N
107047	1726	691510596000	12880	6586	58	0	\N
107048	1726	691509595000	12880	6586	59	0	\N
107049	1726	691508594000	12880	6586	60	0	\N
107050	1726	691507593000	12880	6586	61	0	\N
107051	1726	691506592000	12880	6586	62	0	\N
107052	1397	1368472981000	12881	6642	0	0	\N
107053	1726	691504590000	12881	6642	1	0	\N
107056	1397	1368472981000	12883	6642	0	0	\N
107057	1726	691504590000	12883	6642	1	0	\N
107058	1397	1368462980000	12885	6643	0	0	\N
107059	1726	691503589000	12885	6643	1	0	\N
107062	1397	1368452979000	12887	6644	0	0	\N
107063	1726	691502588000	12887	6644	1	0	\N
107066	1397	1368452979000	12889	6644	0	0	\N
107067	1726	691502588000	12889	6644	1	0	\N
107068	1397	1368452979000	12890	6644	0	0	\N
107069	1726	691502588000	12890	6644	1	0	\N
107070	1397	1368452979000	12891	6644	0	0	\N
107071	1726	691502588000	12891	6644	1	0	\N
107074	1397	1368432977000	12894	6646	0	0	\N
107075	1726	691500586000	12894	6646	1	0	\N
107082	1397	1368412975000	12899	6648	0	0	\N
107083	1726	691498584000	12899	6648	1	0	\N
107084	1397	1368402974000	12900	6649	0	0	\N
107085	1726	691497583000	12900	6649	1	0	\N
107088	1397	1368392973000	12902	6650	0	0	\N
107089	1397	1368382972000	12902	6650	1	0	\N
107090	1726	691496582000	12902	6650	2	0	\N
107091	1726	691495581000	12902	6650	3	0	\N
107096	1397	1368392973000	12904	6650	0	0	\N
107097	1397	1368382972000	12904	6650	1	0	\N
107098	1726	691496582000	12904	6650	2	0	\N
107099	1726	691495581000	12904	6650	3	0	\N
107106	1397	1368362970000	12907	6652	0	0	\N
107107	1397	1368352969000	12907	6652	1	0	\N
107108	1726	691493579000	12907	6652	2	0	\N
107109	1726	691492578000	12907	6652	3	0	\N
107112	1726	691491577000	12909	6653	0	0	\N
107114	1397	1368332967000	12911	6655	0	0	\N
107115	1397	1368322966000	12911	6655	1	0	\N
107116	1397	1368312965000	12911	6655	2	0	\N
107117	1397	1368302964000	12911	6655	3	0	\N
107118	1726	691489575000	12911	6655	4	0	\N
107119	1726	691488574000	12911	6655	5	0	\N
107120	1726	691487573000	12911	6655	6	0	\N
107121	1726	691486572000	12911	6655	7	0	\N
107130	1397	1368332967000	12913	6655	0	0	\N
107131	1397	1368322966000	12913	6655	1	0	\N
107132	1397	1368312965000	12913	6655	2	0	\N
107133	1397	1368302964000	12913	6655	3	0	\N
107134	1726	691489575000	12913	6655	4	0	\N
107135	1726	691488574000	12913	6655	5	0	\N
107136	1726	691487573000	12913	6655	6	0	\N
107137	1726	691486572000	12913	6655	7	0	\N
107138	1397	1368292963000	12914	6656	0	0	\N
107139	1726	691485571000	12914	6656	1	0	\N
107142	1397	1368492983000	12916	6640	0	0	\N
107143	1397	1368482982000	12916	6640	1	0	\N
107144	1397	1368472981000	12916	6640	2	0	\N
107145	1397	1368462980000	12916	6640	3	0	\N
107146	1397	1368452979000	12916	6640	4	0	\N
107147	1397	1368442978000	12916	6640	5	0	\N
107148	1397	1368432977000	12916	6640	6	0	\N
107149	1397	1368422976000	12916	6640	7	0	\N
107150	1397	1368412975000	12916	6640	8	0	\N
107151	1397	1368402974000	12916	6640	9	0	\N
107152	1397	1368392973000	12916	6640	10	0	\N
107153	1397	1368382972000	12916	6640	11	0	\N
107154	1397	1368372971000	12916	6640	12	0	\N
107155	1397	1368362970000	12916	6640	13	0	\N
107156	1397	1368352969000	12916	6640	14	0	\N
107157	1397	1368342968000	12916	6640	16	0	\N
107158	1397	1368332967000	12916	6640	17	0	\N
107159	1397	1368322966000	12916	6640	18	0	\N
107160	1397	1368312965000	12916	6640	19	0	\N
107161	1397	1368302964000	12916	6640	20	0	\N
107162	1397	1368292963000	12916	6640	21	0	\N
107163	1726	691506592000	12916	6640	22	0	\N
107164	1726	691505591000	12916	6640	23	0	\N
107165	1726	691504590000	12916	6640	24	0	\N
107166	1726	691503589000	12916	6640	25	0	\N
107167	1726	691502588000	12916	6640	26	0	\N
107168	1726	691501587000	12916	6640	27	0	\N
107060	1397	1368462980000	12886	6643	0	0	7037
107061	1726	691503589000	12886	6643	1	0	4666
107064	1397	1368452979000	12888	6644	0	0	7038
107065	1726	691502588000	12888	6644	1	0	4667
107072	1397	1368442978000	12893	6645	0	0	7039
107076	1397	1368432977000	12896	6646	0	0	7040
107077	1726	691500586000	12896	6646	1	0	4669
107078	1397	1368422976000	12897	6647	0	0	7041
107079	1726	691499585000	12897	6647	1	0	4670
107080	1397	1368412975000	12898	6648	0	0	7042
107086	1397	1368402974000	12901	6649	0	0	7043
107087	1726	691497583000	12901	6649	1	0	4672
107092	1397	1368392973000	12903	6650	0	0	7044
107093	1397	1368382972000	12903	6650	1	0	7045
107095	1726	691495581000	12903	6650	3	0	4674
107100	1397	1368372971000	12905	6651	0	0	7046
107101	1726	691494580000	12905	6651	1	0	4675
107102	1397	1368362970000	12906	6652	0	0	7047
107103	1397	1368352969000	12906	6652	1	0	7048
107105	1726	691492578000	12906	6652	3	0	4677
107110	1397	1368342968000	12908	6653	0	0	7049
107111	1726	691491577000	12908	6653	1	0	4678
107113	1726	691490576000	12910	6654	0	0	4679
107122	1397	1368332967000	12912	6655	0	0	7050
107124	1397	1368312965000	12912	6655	2	0	7052
107125	1397	1368302964000	12912	6655	3	0	7053
107126	1726	691489575000	12912	6655	4	0	4680
107127	1726	691488574000	12912	6655	5	0	4681
107129	1726	691486572000	12912	6655	7	0	4683
107140	1397	1368292963000	12915	6656	0	0	7054
107141	1726	691485571000	12915	6656	1	0	4684
107169	1726	691500586000	12916	6640	28	0	\N
107170	1726	691499585000	12916	6640	29	0	\N
107171	1726	691498584000	12916	6640	30	0	\N
107172	1726	691497583000	12916	6640	31	0	\N
107173	1726	691496582000	12916	6640	32	0	\N
107174	1726	691495581000	12916	6640	33	0	\N
107175	1726	691494580000	12916	6640	34	0	\N
107176	1726	691493579000	12916	6640	35	0	\N
107177	1726	691492578000	12916	6640	36	0	\N
107178	1726	691491577000	12916	6640	37	0	\N
107179	1726	691490576000	12916	6640	38	0	\N
107180	1726	691489575000	12916	6640	39	0	\N
107181	1726	691488574000	12916	6640	40	0	\N
107182	1726	691487573000	12916	6640	41	0	\N
107183	1726	691486572000	12916	6640	42	0	\N
107184	1726	691485571000	12916	6640	43	0	\N
107189	1397	1368282962000	12918	6657	0	0	\N
107190	1397	1368272961000	12918	6657	1	0	\N
107191	1726	691484570000	12918	6657	2	0	\N
107192	1726	691483569000	12918	6657	3	0	\N
107197	1397	1368252959000	12921	6659	0	0	\N
107198	1726	691481567000	12921	6659	1	0	\N
107203	1397	1368232957000	12924	6661	0	0	\N
107204	1726	691479565000	12924	6661	1	0	\N
107209	1397	1368222956000	12926	6662	0	0	\N
107210	1397	1368212955000	12926	6662	1	0	\N
107211	1726	691478564000	12926	6662	2	0	\N
107212	1726	691477563000	12926	6662	3	0	\N
107217	1397	1368192953000	12929	6664	0	0	\N
107218	1726	691475561000	12929	6664	1	0	\N
107219	1397	1368482982000	12930	6587	0	0	\N
107220	1397	1368472981000	12930	6587	1	0	\N
107221	1397	1368462980000	12930	6587	2	0	\N
107222	1397	1368452979000	12930	6587	3	0	\N
107223	1397	1368442978000	12930	6587	4	0	\N
107224	1397	1368432977000	12930	6587	5	0	\N
107225	1397	1368422976000	12930	6587	6	0	\N
107226	1397	1368412975000	12930	6587	7	0	\N
107227	1397	1368402974000	12930	6587	8	0	\N
107228	1397	1368392973000	12930	6587	9	0	\N
107229	1397	1368382972000	12930	6587	10	0	\N
107230	1397	1368372971000	12930	6587	11	0	\N
107231	1397	1368362970000	12930	6587	12	0	\N
107232	1397	1368352969000	12930	6587	13	0	\N
107233	1397	1368342968000	12930	6587	14	0	\N
107234	1397	1368332967000	12930	6587	15	0	\N
107235	1397	1368322966000	12930	6587	16	0	\N
107236	1397	1368312965000	12930	6587	17	0	\N
107237	1397	1368302964000	12930	6587	18	0	\N
107238	1397	1368292963000	12930	6587	19	0	\N
107239	1397	1368282962000	12930	6587	20	0	\N
107240	1397	1368272961000	12930	6587	21	0	\N
107241	1397	1368262960000	12930	6587	22	0	\N
107242	1397	1368252959000	12930	6587	23	0	\N
107243	1397	1368242958000	12930	6587	24	0	\N
107244	1397	1368232957000	12930	6587	25	0	\N
107245	1397	1368222956000	12930	6587	26	0	\N
107246	1397	1368212955000	12930	6587	27	0	\N
107247	1397	1368202954000	12930	6587	28	0	\N
107248	1397	1368192953000	12930	6587	29	0	\N
107249	1726	691505591000	12930	6587	30	0	\N
107250	1726	691504590000	12930	6587	31	0	\N
107251	1726	691503589000	12930	6587	32	0	\N
107252	1726	691502588000	12930	6587	33	0	\N
107253	1726	691501587000	12930	6587	34	0	\N
107254	1726	691500586000	12930	6587	35	0	\N
107255	1726	691499585000	12930	6587	36	0	\N
107256	1726	691498584000	12930	6587	37	0	\N
107257	1726	691497583000	12930	6587	38	0	\N
107258	1726	691496582000	12930	6587	39	0	\N
107259	1726	691495581000	12930	6587	40	0	\N
107260	1726	691494580000	12930	6587	41	0	\N
107261	1726	691493579000	12930	6587	42	0	\N
107262	1726	691492578000	12930	6587	43	0	\N
107263	1726	691491577000	12930	6587	44	0	\N
107264	1726	691490576000	12930	6587	45	0	\N
107265	1726	691489575000	12930	6587	46	0	\N
107266	1726	691488574000	12930	6587	47	0	\N
107267	1726	691487573000	12930	6587	48	0	\N
107268	1726	691486572000	12930	6587	49	0	\N
107269	1726	691485571000	12930	6587	50	0	\N
107270	1726	691484570000	12930	6587	51	0	\N
107271	1726	691483569000	12930	6587	52	0	\N
107272	1726	691482568000	12930	6587	53	0	\N
107273	1726	691481567000	12930	6587	54	0	\N
107274	1726	691480566000	12930	6587	55	0	\N
107275	1726	691479565000	12930	6587	56	0	\N
107276	1726	691478564000	12930	6587	57	0	\N
107277	1726	691477563000	12930	6587	58	0	\N
107278	1726	691476562000	12930	6587	59	0	\N
107279	1726	691475561000	12930	6587	60	0	\N
107280	1397	1368192953000	12931	6664	0	0	\N
107281	1726	691475561000	12931	6664	1	0	\N
107282	1397	1368182952000	12932	6665	0	0	\N
107283	1726	691474560000	12932	6665	1	0	\N
107288	1397	1368162950000	12935	6667	0	0	\N
107289	1397	1368152949000	12935	6667	1	0	\N
107290	1397	1368142948000	12935	6667	2	0	\N
107291	1397	1368132947000	12935	6667	3	0	\N
107292	1726	691472558000	12935	6667	4	0	\N
107293	1726	691471557000	12935	6667	5	0	\N
107294	1726	691470556000	12935	6667	6	0	\N
107295	1726	691469555000	12935	6667	7	0	\N
107304	1397	1368162950000	12937	6667	0	0	\N
107187	1726	691484570000	12917	6657	2	0	4685
107188	1726	691483569000	12917	6657	3	0	4686
107193	1397	1368262960000	12919	6658	0	0	7057
107194	1726	691482568000	12919	6658	1	0	4687
107195	1397	1368252959000	12920	6659	0	0	7058
107199	1397	1368242958000	12922	6660	0	0	7059
107200	1726	691480566000	12922	6660	1	0	4689
107201	1397	1368232957000	12923	6661	0	0	7060
107202	1726	691479565000	12923	6661	1	0	4690
107205	1397	1368222956000	12925	6662	0	0	7061
107207	1726	691478564000	12925	6662	2	0	4691
107208	1726	691477563000	12925	6662	3	0	4692
107213	1397	1368202954000	12927	6663	0	0	7063
107214	1726	691476562000	12927	6663	1	0	4693
107216	1726	691475561000	12928	6664	1	0	4694
107284	1397	1368182952000	12933	6665	0	0	7065
107285	1726	691474560000	12933	6665	1	0	4695
107286	1397	1368172951000	12934	6666	0	0	7066
107287	1726	691473559000	12934	6666	1	0	4696
107297	1397	1368152949000	12936	6667	1	0	7068
107298	1397	1368142948000	12936	6667	2	0	7069
107299	1397	1368132947000	12936	6667	3	0	7070
107300	1726	691472558000	12936	6667	4	0	4697
107301	1726	691471557000	12936	6667	5	0	4698
107303	1726	691469555000	12936	6667	7	0	4700
107305	1397	1368152949000	12937	6667	1	0	\N
107306	1397	1368142948000	12937	6667	2	0	\N
107307	1397	1368132947000	12937	6667	3	0	\N
107308	1726	691472558000	12937	6667	4	0	\N
107309	1726	691471557000	12937	6667	5	0	\N
107310	1726	691470556000	12937	6667	6	0	\N
107311	1726	691469555000	12937	6667	7	0	\N
107314	1397	1368112945000	12939	6669	0	0	\N
107315	1726	691467553000	12939	6669	1	0	\N
107318	1397	1368102944000	12941	6670	0	0	\N
107319	1726	691466552000	12941	6670	1	0	\N
107321	1397	1368092943000	12943	6671	0	0	\N
107322	1726	691466552000	12943	6671	2	0	\N
107323	1726	691465551000	12943	6671	3	0	\N
107327	1397	1368082942000	12945	6672	0	0	\N
107328	1726	691464550000	12945	6672	1	0	\N
107337	1397	1368042938000	12950	6676	0	0	\N
107338	1397	1368032937000	12950	6676	1	0	\N
107339	1726	691460546000	12950	6676	2	0	\N
107340	1726	691459545000	12950	6676	3	0	\N
107353	1726	691455541000	12956	6680	0	0	\N
107354	1397	1367992933000	12957	6680	0	0	\N
107355	1726	691455541000	12957	6680	1	0	\N
107368	1397	1367922926000	12963	6685	0	0	\N
107369	1397	1367912925000	12963	6685	1	0	\N
107370	1397	1367902924000	12963	6685	2	0	\N
107371	1726	691448534000	12963	6685	3	0	\N
107372	1726	691447533000	12963	6685	4	0	\N
107373	1726	691446532000	12963	6685	5	0	\N
107384	1397	1367872921000	12967	6688	0	0	\N
107385	1726	691443529000	12967	6688	1	0	\N
107386	1397	1367872921000	12968	6688	0	0	\N
107387	1726	691443529000	12968	6688	1	0	\N
107392	1397	1367862920000	12971	6689	0	0	\N
107393	1726	691442528000	12971	6689	1	0	\N
107394	1397	1367862920000	12972	6689	0	0	\N
107395	1726	691442528000	12972	6689	1	0	\N
107396	1397	1367862920000	12973	6689	0	0	\N
107397	1726	691442528000	12973	6689	1	0	\N
107398	1397	1367862920000	12974	6689	0	0	\N
107399	1726	691442528000	12974	6689	1	0	\N
107402	1397	1367862920000	12976	6689	0	0	\N
107403	1397	1367852919000	12976	6689	1	0	\N
107404	1726	691442528000	12976	6689	2	0	\N
107408	1397	1367842918000	12978	6691	0	0	\N
107409	1397	1367832917000	12978	6691	1	0	\N
107410	1726	691440526000	12978	6691	2	0	\N
107415	1397	1367812915000	12981	6693	0	0	\N
107416	1726	691438524000	12981	6693	1	0	\N
107417	1397	1367812915000	12982	6693	0	0	\N
107418	1726	691438524000	12982	6693	1	0	\N
107419	1726	691438524000	12983	6693	0	0	\N
107422	1932	1136839152658	12985	6483	0	0	\N
107425	1397	1367792913000	12987	6695	0	0	\N
107426	1726	691436522000	12987	6695	1	0	\N
107431	1397	1367782912000	12989	6696	0	0	\N
107432	1397	1367772911000	12989	6696	1	0	\N
107433	1726	691435521000	12989	6696	2	0	\N
107434	1726	691434520000	12989	6696	3	0	\N
107435	1397	1367782912000	12990	6696	0	0	\N
107436	1397	1367772911000	12990	6696	1	0	\N
107437	1726	691435521000	12990	6696	2	0	\N
107438	1726	691434520000	12990	6696	3	0	\N
107316	1397	1368112945000	12940	6669	0	0	7072
107317	1726	691467553000	12940	6669	1	0	4702
107320	1397	1368102944000	12942	6670	0	0	7073
107324	1397	1368092943000	12944	6671	0	0	7074
107325	1726	691466552000	12944	6671	2	0	4703
107329	1397	1368082942000	12946	6672	0	0	7075
107330	1726	691464550000	12946	6672	1	0	4705
107331	1397	1368072941000	12947	6673	0	0	7076
107332	1726	691463549000	12947	6673	1	0	4706
107333	1397	1368062940000	12948	6674	0	0	7077
107335	1397	1368052939000	12949	6675	0	0	7078
107336	1726	691461547000	12949	6675	1	0	4708
107341	1397	1368042938000	12951	6676	0	0	7079
107342	1397	1368032937000	12951	6676	1	0	7080
107344	1726	691459545000	12951	6676	3	0	4710
107345	1397	1368022936000	12952	6677	0	0	7081
107346	1726	691458544000	12952	6677	1	0	4711
107347	1397	1368012935000	12953	6678	0	0	7082
107348	1726	691457543000	12953	6678	1	0	4712
107350	1726	691456542000	12954	6679	1	0	4713
107351	1397	1367992933000	12955	6680	0	0	7084
107352	1726	691455541000	12955	6680	1	0	4714
107356	1397	1367982932000	12958	6681	0	0	7085
107357	1726	691454540000	12958	6681	1	0	4715
107359	1726	691453539000	12959	6682	1	0	4716
107360	1397	1367962930000	12961	6683	0	0	7087
107361	1397	1367952929000	12961	6683	1	0	7088
107362	1397	1367942928000	12961	6683	2	0	7089
107364	1726	691451537000	12961	6683	4	0	4718
107365	1726	691450536000	12961	6683	5	0	4719
107366	1397	1367932927000	12962	6684	0	0	7090
107367	1726	691449535000	12962	6684	1	0	4720
107374	1397	1367922926000	12964	6685	0	0	7091
107376	1397	1367902924000	12964	6685	2	0	7093
107377	1726	691448534000	12964	6685	3	0	4721
107378	1726	691447533000	12964	6685	4	0	4722
107379	1726	691446532000	12964	6685	5	0	4723
107380	1397	1367892923000	12965	6686	0	0	7094
107382	1397	1367882922000	12966	6687	0	0	7095
107383	1726	691444530000	12966	6687	1	0	4725
107388	1397	1367872921000	12969	6688	0	0	7096
107389	1726	691443529000	12969	6688	1	0	4726
107391	1726	691442528000	12970	6689	1	0	4727
107400	1397	1367852919000	12975	6690	0	0	7098
107401	1726	691441527000	12975	6690	1	0	4728
107405	1397	1367842918000	12977	6691	0	0	7099
107406	1397	1367832917000	12977	6691	1	0	7100
107411	1397	1367822916000	12979	6692	0	0	7101
107412	1726	691439525000	12979	6692	1	0	4730
107413	1397	1367812915000	12980	6693	0	0	7102
107414	1726	691438524000	12980	6693	1	0	4731
107420	1397	1367802914000	12984	6694	0	0	7103
107423	1397	1367792913000	12986	6695	0	0	7104
107424	1726	691436522000	12986	6695	1	0	4733
107427	1397	1367782912000	12988	6696	0	0	7105
107428	1397	1367772911000	12988	6696	1	0	7106
107430	1726	691434520000	12988	6696	3	0	4735
107439	1397	1367762910000	12991	6697	0	0	7107
107440	1726	691433519000	12991	6697	1	0	4736
107449	1397	1367732907000	12995	6700	0	0	\N
107450	1397	1367722906000	12995	6700	1	0	\N
107451	1726	691430516000	12995	6700	2	0	\N
107452	1726	691429515000	12995	6700	3	0	\N
107453	1397	1367732907000	12996	6700	0	0	\N
107454	1397	1367722906000	12996	6700	1	0	\N
107455	1726	691430516000	12996	6700	2	0	\N
107456	1726	691429515000	12996	6700	3	0	\N
107457	1397	1367732907000	12997	6700	0	0	\N
107458	1397	1367722906000	12997	6700	1	0	\N
107459	1726	691430516000	12997	6700	2	0	\N
107460	1726	691429515000	12997	6700	3	0	\N
107461	1397	1367732907000	12998	6700	0	0	\N
107462	1397	1367722906000	12998	6700	1	0	\N
107463	1726	691430516000	12998	6700	2	0	\N
107464	1726	691429515000	12998	6700	3	0	\N
107467	1397	1367712905000	13000	6701	0	0	\N
107468	1726	691428514000	13000	6701	1	0	\N
107469	1397	1367712905000	13001	6701	0	0	\N
107470	1726	691428514000	13001	6701	1	0	\N
107471	1726	691427513000	13002	6702	0	0	\N
107472	1397	1367702904000	13003	6703	0	0	\N
107473	2054	180000000	13003	6703	1	0	\N
107474	1397	1367692903000	13003	6703	2	0	\N
107475	1397	1367682902000	13003	6703	3	0	\N
107476	1726	691426512000	13003	6703	4	0	\N
107477	1726	691425511000	13003	6703	5	0	\N
107485	2054	180000000	13006	6703	0	0	\N
107486	1397	1367692903000	13006	6703	1	0	\N
107487	1397	1367682902000	13006	6703	2	0	\N
107488	1726	691426512000	13006	6703	3	0	\N
107489	1726	691425511000	13006	6703	4	0	\N
107500	1397	1367632897000	13010	6706	0	0	\N
107501	1726	691420506000	13010	6706	1	0	\N
107502	1397	1367632897000	13011	6706	0	0	\N
107503	1726	691420506000	13011	6706	1	0	\N
107508	1397	1367602894000	13014	6709	0	0	\N
107509	1726	691417503000	13014	6709	1	0	\N
107512	2075	100000000	13016	6710	0	0	\N
107513	1397	1367592893000	13016	6710	1	0	\N
107514	1397	1367582892000	13016	6710	2	0	\N
107515	1726	691416502000	13016	6710	3	0	\N
107516	1726	691415501000	13016	6710	4	0	\N
107528	1693	9993443155041	13019	6712	0	0	\N
107529	1397	1367552889000	13019	6712	1	0	\N
107530	1726	691411497000	13019	6712	2	0	\N
107534	1693	9993443155041	13021	6712	0	0	\N
107535	1397	1367552889000	13021	6712	1	0	\N
107536	1726	691411497000	13021	6712	2	0	\N
107537	1397	1367542888000	13022	6713	0	0	\N
107538	1726	691410496000	13022	6713	1	0	\N
107541	1397	1367532887000	13024	6714	0	0	\N
107542	1726	691409495000	13024	6714	1	0	\N
107543	1397	1367532887000	13026	6715	0	0	\N
107544	1397	1367522886000	13026	6715	1	0	\N
107545	1726	691409495000	13026	6715	2	0	\N
107546	1726	691408494000	13026	6715	3	0	\N
107553	1397	1367512885000	13029	6717	0	0	\N
107554	1397	1367502884000	13029	6717	1	0	\N
107555	1726	691406492000	13029	6717	2	0	\N
107556	2073	412999000000	13029	6717	3	0	\N
107557	1726	691405491000	13029	6717	4	0	\N
107570	1397	1367462880000	13032	6719	0	0	\N
107571	1726	691401487000	13032	6719	1	0	\N
107574	2075	100000000	13034	6643	0	0	\N
107575	1402	99050761608562	13034	6643	1	0	\N
107576	1693	9993443155041	13034	6643	2	0	\N
107443	1726	691432518000	12992	6698	2	0	4737
107444	1726	691431517000	12992	6698	3	0	4738
107445	1397	1367732907000	12994	6700	0	0	7110
107446	1397	1367722906000	12994	6700	1	0	7111
107447	1726	691430516000	12994	6700	2	0	4739
107465	1397	1367712905000	12999	6701	0	0	7112
107466	1726	691428514000	12999	6701	1	0	4741
107478	1397	1367702904000	13004	6702	0	0	7113
107479	1726	691427513000	13004	6702	1	0	4742
107480	2054	180000000	13005	6703	0	0	1
107482	1397	1367682902000	13005	6703	2	0	7115
107483	1726	691426512000	13005	6703	3	0	4743
107484	1726	691425511000	13005	6703	4	0	4744
107490	1397	1367672901000	13007	6704	0	0	7116
107492	1397	1367652899000	13007	6704	2	0	7118
107493	1726	691424510000	13007	6704	3	0	4745
107494	1726	691423509000	13007	6704	4	0	4746
107495	1726	691422508000	13007	6704	5	0	4747
107496	1397	1367642898000	13008	6705	0	0	7119
107498	1397	1367632897000	13009	6706	0	0	7120
107499	1726	691420506000	13009	6706	1	0	4749
107504	1397	1367622896000	13012	6707	0	0	7121
107505	1397	1367612895000	13013	6708	0	0	7122
107506	1726	691419505000	13013	6708	1	0	4750
107510	1397	1367602894000	13015	6709	0	0	7123
107511	1726	691417503000	13015	6709	1	0	4752
107517	2075	100000000	13017	6710	0	0	1
107518	1397	1367592893000	13017	6710	1	0	7124
107520	1726	691416502000	13017	6710	3	0	4753
107521	1726	691415501000	13017	6710	4	0	4754
107522	2075	0	13018	6711	0	0	2
107523	1397	1367572891000	13018	6711	1	0	7126
107524	1397	1367562890000	13018	6711	2	0	7127
107526	1726	691413499000	13018	6711	4	0	4756
107527	1726	691412498000	13018	6711	5	0	4757
107531	1693	9993443155041	13020	6712	0	0	667
107532	1397	1367552889000	13020	6712	1	0	7128
107533	1726	691411497000	13020	6712	2	0	4758
107540	1726	691410496000	13023	6713	1	0	4759
107547	1397	1367532887000	13027	6715	0	0	7130
107548	1397	1367522886000	13027	6715	1	0	7131
107549	1726	691409495000	13027	6715	2	0	4760
107551	106	66000822089930	13028	6716	0	0	2
107552	1726	691407493000	13028	6716	1	0	4762
107558	1397	1367512885000	13030	6717	0	0	7132
107559	1397	1367502884000	13030	6717	1	0	7133
107560	1726	691406492000	13030	6717	2	0	4763
107562	1726	691405491000	13030	6717	4	0	4764
107563	1402	101210793608562	13031	6718	0	0	1
107564	1397	1367492883000	13031	6718	1	0	7134
107565	1397	1367482882000	13031	6718	2	0	7135
107566	1397	1367472881000	13031	6718	3	0	7136
107568	1726	691403489000	13031	6718	5	0	4766
107569	1726	691402488000	13031	6718	6	0	4767
107572	1397	1367462880000	13033	6719	0	0	7137
107573	1726	691401487000	13033	6719	1	0	4768
107597	1397	1367392873000	13037	6722	0	0	\N
107598	1726	691389475000	13037	6722	1	0	\N
107599	1726	691388474000	13037	6722	2	0	\N
107603	1397	1367392873000	13039	6722	0	0	\N
107604	1726	691389475000	13039	6722	1	0	\N
107605	1726	691388474000	13039	6722	2	0	\N
107606	1397	1367382872000	13040	6723	0	0	\N
107607	1397	1367372871000	13040	6723	1	0	\N
107608	1402	98692362570174	13040	6723	2	0	\N
107609	1402	97339598313884	13040	6723	3	0	\N
107610	1402	97060502092957	13040	6723	4	0	\N
107611	1726	691387473000	13040	6723	5	0	\N
107612	1726	691386472000	13040	6723	6	0	\N
107613	1726	691385471000	13040	6723	7	0	\N
107622	1397	1367382872000	13042	6723	0	0	\N
107623	1397	1367372871000	13042	6723	1	0	\N
107624	1402	98692362570174	13042	6723	2	0	\N
107625	1402	97339598313884	13042	6723	3	0	\N
107626	1402	97060502092957	13042	6723	4	0	\N
107627	1726	691387473000	13042	6723	5	0	\N
107628	1726	691386472000	13042	6723	6	0	\N
107629	1726	691385471000	13042	6723	7	0	\N
107650	1397	1367312865000	13048	6728	0	0	\N
107651	1726	690166462000	13048	6728	1	0	\N
107652	1726	688956462000	13048	6728	2	0	\N
107653	1726	688955461000	13048	6728	3	0	\N
107654	1726	688954460000	13048	6728	4	0	\N
107660	1397	1367312865000	13050	6728	0	0	\N
107661	1726	690166462000	13050	6728	1	0	\N
107662	1726	688956462000	13050	6728	2	0	\N
107663	1726	688955461000	13050	6728	3	0	\N
107664	1726	688954460000	13050	6728	4	0	\N
107665	1397	1367312865000	13051	6728	0	0	\N
107666	1726	690166462000	13051	6728	1	0	\N
107667	1726	688956462000	13051	6728	2	0	\N
107668	1726	688955461000	13051	6728	3	0	\N
107669	1726	688954460000	13051	6728	4	0	\N
107670	1397	1367312865000	13052	6728	0	0	\N
107671	1726	690166462000	13052	6728	1	0	\N
107672	1726	688956462000	13052	6728	2	0	\N
107673	1726	688955461000	13052	6728	3	0	\N
107674	1726	688954460000	13052	6728	4	0	\N
107684	1397	1367292863000	13056	6731	0	0	\N
107685	1397	1367282862000	13056	6731	1	0	\N
107686	1726	688950456000	13056	6731	2	0	\N
107687	1726	688949455000	13056	6731	3	0	\N
107688	1726	688948454000	13056	6731	4	0	\N
107689	1397	1367272861000	13057	6732	0	0	\N
107690	1397	1367262860000	13057	6732	1	0	\N
107691	1402	75948613054315	13057	6732	2	0	\N
107692	1402	75341591013563	13057	6732	3	0	\N
107693	1402	73811009223020	13057	6732	4	0	\N
107694	1402	71696922805115	13057	6732	5	0	\N
107695	1402	69840990933336	13057	6732	6	0	\N
107696	1402	58537998102164	13057	6732	7	0	\N
107697	1402	57329222000778	13057	6732	8	0	\N
107698	1402	46026229169606	13057	6732	9	0	\N
107699	1402	45035463884671	13057	6732	10	0	\N
107700	1402	44407510394246	13057	6732	11	0	\N
107701	1726	688947453000	13057	6732	12	0	\N
107702	1726	688946452000	13057	6732	13	0	\N
107703	1726	688945451000	13057	6732	14	0	\N
107704	1726	688944450000	13057	6732	15	0	\N
107705	1397	1367272861000	13058	6732	0	0	\N
107706	1397	1367262860000	13058	6732	1	0	\N
107707	1402	75948613054315	13058	6732	2	0	\N
107708	1402	75341591013563	13058	6732	3	0	\N
107709	1402	73811009223020	13058	6732	4	0	\N
107710	1402	71696922805115	13058	6732	5	0	\N
107711	1402	69840990933336	13058	6732	6	0	\N
107712	1402	58537998102164	13058	6732	7	0	\N
107579	1402	100951163878266	13035	6720	2	0	2
107580	1402	98095339337136	13035	6720	3	0	3
107581	1397	1367432877000	13035	6720	4	0	7140
107582	1397	1367422876000	13035	6720	5	0	7141
107583	1397	1367412875000	13035	6720	6	0	7142
107585	1726	691399485000	13035	6720	8	0	4770
107586	1726	691398484000	13035	6720	9	0	4771
107587	1726	691397483000	13035	6720	10	0	4772
107588	1726	691396482000	13035	6720	11	0	4773
107589	1726	691395481000	13035	6720	12	0	4774
107591	1726	691393479000	13035	6720	14	0	4776
107592	1726	691392478000	13035	6720	15	0	4777
107593	106	66000811089930	13035	6720	16	0	3
107594	1726	691391477000	13035	6720	17	0	4778
107596	1726	691390476000	13036	6721	1	0	4779
107600	1397	1367392873000	13038	6722	0	0	7144
107601	1726	691389475000	13038	6722	1	0	4780
107602	1726	691388474000	13038	6722	2	0	4781
107614	1397	1367382872000	13041	6723	0	0	7145
107616	1402	98692362570174	13041	6723	2	0	4
107617	1402	97339598313884	13041	6723	3	0	5
107618	1402	97060502092957	13041	6723	4	0	6
107619	1726	691387473000	13041	6723	5	0	4782
107620	1726	691386472000	13041	6723	6	0	4783
107630	1710	10314445473290	13043	6724	0	0	6
107631	1397	1367362870000	13043	6724	1	0	7147
107632	1397	1367352869000	13043	6724	2	0	7148
107633	1726	691384470000	13043	6724	3	0	4785
107635	1726	691382468000	13043	6724	5	0	4787
107636	1397	1367342868000	13044	6725	0	0	7149
107637	1726	691381467000	13044	6725	1	0	4788
107638	1726	691380466000	13044	6725	2	0	4789
107639	1402	93990546341729	13045	6726	0	0	7
107641	1402	93601328593782	13045	6726	2	0	8
107642	1402	92875695004825	13045	6726	3	0	9
107643	1402	87503301913255	13045	6726	4	0	10
107644	1402	77096175131128	13045	6726	5	0	11
107645	1726	691379465000	13045	6726	6	0	4790
107647	1397	1367322866000	13046	6727	0	0	7151
107648	1726	691377463000	13046	6727	1	0	4792
107649	1726	691376462000	13046	6727	2	0	4793
107655	1397	1367312865000	13049	6728	0	0	7152
107657	1726	688956462000	13049	6728	2	0	4795
107658	1726	688955461000	13049	6728	3	0	4796
107659	1726	688954460000	13049	6728	4	0	4797
107675	1397	1367302864000	13053	6729	0	0	7153
107676	1726	688953459000	13053	6729	1	0	4798
107678	1726	688951457000	13054	6730	1	0	4800
107679	1397	1367292863000	13055	6731	0	0	7154
107680	1397	1367282862000	13055	6731	1	0	7155
107681	1726	688950456000	13055	6731	2	0	4801
107682	1726	688949455000	13055	6731	3	0	4802
107713	1402	57329222000778	13058	6732	8	0	\N
107714	1402	46026229169606	13058	6732	9	0	\N
107715	1402	45035463884671	13058	6732	10	0	\N
107716	1402	44407510394246	13058	6732	11	0	\N
107717	1726	688947453000	13058	6732	12	0	\N
107718	1726	688946452000	13058	6732	13	0	\N
107719	1726	688945451000	13058	6732	14	0	\N
107720	1726	688944450000	13058	6732	15	0	\N
107721	1397	1367272861000	13059	6732	0	0	\N
107722	1397	1367262860000	13059	6732	1	0	\N
107723	1402	75948613054315	13059	6732	2	0	\N
107724	1402	75341591013563	13059	6732	3	0	\N
107725	1402	73811009223020	13059	6732	4	0	\N
107726	1402	71696922805115	13059	6732	5	0	\N
107727	1402	69840990933336	13059	6732	6	0	\N
107728	1402	58537998102164	13059	6732	7	0	\N
107729	1402	57329222000778	13059	6732	8	0	\N
107730	1402	46026229169606	13059	6732	9	0	\N
107731	1402	45035463884671	13059	6732	10	0	\N
107732	1402	44407510394246	13059	6732	11	0	\N
107733	1726	688947453000	13059	6732	12	0	\N
107734	1726	688946452000	13059	6732	13	0	\N
107735	1726	688945451000	13059	6732	14	0	\N
107736	1726	688944450000	13059	6732	15	0	\N
107775	1397	1367242858000	13063	6734	0	0	\N
107776	1397	1367232857000	13063	6734	1	0	\N
107777	1402	41686411935547	13063	6734	2	0	\N
107778	1402	41267772941914	13063	6734	3	0	\N
107779	1402	40018327033785	13063	6734	4	0	\N
107780	1402	38969482557689	13063	6734	5	0	\N
107781	1402	36667013092652	13063	6734	6	0	\N
107782	1402	36363279385211	13063	6734	7	0	\N
107783	1402	36182220718070	13063	6734	8	0	\N
107784	1402	35637993026391	13063	6734	9	0	\N
107785	1402	33680892481120	13063	6734	10	0	\N
107786	1402	33243483331619	13063	6734	11	0	\N
107787	1402	33238800263830	13063	6734	12	0	\N
107788	1402	32254005319298	13063	6734	13	0	\N
107789	1726	688941445000	13063	6734	14	0	\N
107790	1726	688940443000	13063	6734	15	0	\N
107791	1726	688939440000	13063	6734	16	0	\N
107792	1726	688938438000	13063	6734	17	0	\N
107793	1726	688937437000	13063	6734	18	0	\N
107794	1397	1367222856000	13064	6735	0	0	\N
107795	1726	688936434000	13064	6735	1	0	\N
107796	1726	688935432000	13064	6735	2	0	\N
107797	1726	688934431000	13064	6735	3	0	\N
107798	1397	1367222856000	13065	6735	0	0	\N
107799	1726	688936434000	13065	6735	1	0	\N
107800	1726	688935432000	13065	6735	2	0	\N
107801	1726	688934431000	13065	6735	3	0	\N
107806	1397	1367222856000	13067	6735	0	0	\N
107807	1726	688936434000	13067	6735	1	0	\N
107808	1726	688935432000	13067	6735	2	0	\N
107809	1726	688934431000	13067	6735	3	0	\N
107810	1420	714900220000	13068	6736	0	0	\N
107811	1397	1367212855000	13068	6736	1	0	\N
107812	1397	1367202854000	13068	6736	2	0	\N
107813	1726	688933428000	13068	6736	3	0	\N
107814	1726	688932426000	13068	6736	4	0	\N
107815	1726	688931425000	13068	6736	5	0	\N
107816	1726	688930423000	13068	6736	6	0	\N
107817	1726	688929422000	13068	6736	7	0	\N
107826	1420	714900220000	13070	6736	0	0	\N
107827	1397	1367212855000	13070	6736	1	0	\N
107828	1397	1367202854000	13070	6736	2	0	\N
107829	1726	688933428000	13070	6736	3	0	\N
107830	1726	688932426000	13070	6736	4	0	\N
107831	1726	688931425000	13070	6736	5	0	\N
107832	1726	688930423000	13070	6736	6	0	\N
107833	1726	688929422000	13070	6736	7	0	\N
107834	1397	1367192853000	13071	6737	0	0	\N
107835	1726	688928419000	13071	6737	2	0	\N
107836	1726	688927417000	13071	6737	3	0	\N
107837	1726	688926416000	13071	6737	4	0	\N
107838	1397	1367192853000	13072	6737	0	0	\N
107839	1726	688928419000	13072	6737	2	0	\N
107840	1726	688927417000	13072	6737	3	0	\N
107841	1726	688926416000	13072	6737	4	0	\N
107843	1397	1367192853000	13074	6737	0	0	\N
107739	1402	75948613054315	13060	6732	2	0	12
107740	1402	75341591013563	13060	6732	3	0	13
107741	1402	73811009223020	13060	6732	4	0	14
107742	1402	71696922805115	13060	6732	5	0	15
107743	1402	69840990933336	13060	6732	6	0	16
107745	1402	57329222000778	13060	6732	8	0	18
107746	1402	46026229169606	13060	6732	9	0	19
107747	1402	45035463884671	13060	6732	10	0	20
107748	1402	44407510394246	13060	6732	11	0	21
107749	1726	688947453000	13060	6732	12	0	4804
107751	1726	688945451000	13060	6732	14	0	4806
107752	1726	688944450000	13060	6732	15	0	4807
107753	1397	1367252859000	13061	6733	0	0	7158
107754	1726	688943447000	13061	6733	1	0	4808
107756	1397	1367242858000	13062	6734	0	0	7159
107757	1397	1367232857000	13062	6734	1	0	7160
107758	1402	41686411935547	13062	6734	2	0	22
107759	1402	41267772941914	13062	6734	3	0	23
107760	1402	40018327033785	13062	6734	4	0	24
107762	1402	36667013092652	13062	6734	6	0	26
107763	1402	36363279385211	13062	6734	7	0	27
107764	1402	36182220718070	13062	6734	8	0	28
107765	1402	35637993026391	13062	6734	9	0	29
107766	1402	33680892481120	13062	6734	10	0	30
107768	1402	33238800263830	13062	6734	12	0	32
107769	1402	32254005319298	13062	6734	13	0	33
107770	1726	688941445000	13062	6734	14	0	4810
107771	1726	688940443000	13062	6734	15	0	4811
107773	1726	688938438000	13062	6734	17	0	4813
107774	1726	688937437000	13062	6734	18	0	4814
107802	1397	1367222856000	13066	6735	0	0	7161
107803	1726	688936434000	13066	6735	1	0	4815
107804	1726	688935432000	13066	6735	2	0	4816
107818	1420	714900220000	13069	6736	0	0	1
107819	1397	1367212855000	13069	6736	1	0	7162
107820	1397	1367202854000	13069	6736	2	0	7163
107821	1726	688933428000	13069	6736	3	0	4818
107822	1726	688932426000	13069	6736	4	0	4819
107824	1726	688930423000	13069	6736	6	0	4821
107825	1726	688929422000	13069	6736	7	0	4822
107842	1397	1367192853000	13073	6737	0	0	7164
107844	1397	1367182852000	13075	6738	0	0	7165
107846	1726	688927417000	13075	6738	2	0	4824
107847	1726	688926416000	13075	6738	3	0	4825
107848	1726	688925413000	13075	6738	4	0	4826
107854	1397	1367172851000	13077	6739	0	0	\N
107855	1726	688923410000	13077	6739	1	0	\N
107856	1726	688922407000	13077	6739	2	0	\N
107857	1726	688921405000	13077	6739	3	0	\N
107858	1397	1367162850000	13078	6740	0	0	\N
107859	1726	688920404000	13078	6740	1	0	\N
107860	1726	688919402000	13078	6740	2	0	\N
107864	1397	1367162850000	13080	6740	0	0	\N
107865	1726	688920404000	13080	6740	1	0	\N
107866	1726	688919402000	13080	6740	2	0	\N
107867	1397	1367162850000	13081	6740	0	0	\N
107868	1726	688920404000	13081	6740	1	0	\N
107869	1726	688919402000	13081	6740	2	0	\N
107870	1397	1367152849000	13082	6741	0	0	\N
107871	1726	688918401000	13082	6741	1	0	\N
107872	1726	688917398000	13082	6741	2	0	\N
107873	1726	688916396000	13082	6741	3	0	\N
107874	1397	1367152849000	13083	6741	0	0	\N
107875	1726	688918401000	13083	6741	1	0	\N
107876	1726	688917398000	13083	6741	2	0	\N
107877	1726	688916396000	13083	6741	3	0	\N
107878	1397	1367152849000	13084	6741	0	0	\N
107879	1726	688918401000	13084	6741	1	0	\N
107880	1726	688917398000	13084	6741	2	0	\N
107881	1726	688916396000	13084	6741	3	0	\N
107882	1397	1367152849000	13085	6741	0	0	\N
107883	1726	688918401000	13085	6741	1	0	\N
107884	1726	688917398000	13085	6741	2	0	\N
107885	1726	688916396000	13085	6741	3	0	\N
107904	1397	1367112845000	13090	6744	0	0	\N
107905	1726	687698383000	13090	6744	1	0	\N
107906	1726	687697381000	13090	6744	2	0	\N
107933	1397	1367042838000	13097	6750	0	0	\N
107934	1726	687680348000	13097	6750	1	0	\N
107935	1726	687679347000	13097	6750	2	0	\N
107936	1726	687678345000	13097	6750	3	0	\N
107937	1397	1367032837000	13098	6751	0	0	\N
107938	1726	687677342000	13098	6751	1	0	\N
107939	1726	687676341000	13098	6751	2	0	\N
107940	1726	687675339000	13098	6751	3	0	\N
107945	1397	1367022836000	13100	6752	0	0	\N
107946	1726	687674336000	13100	6752	1	0	\N
107947	1726	687673335000	13100	6752	2	0	\N
107948	1726	687672333000	13100	6752	3	0	\N
107949	1397	1367022836000	13101	6752	0	0	\N
107950	1726	687674336000	13101	6752	1	0	\N
107951	1726	687673335000	13101	6752	2	0	\N
107952	1726	687672333000	13101	6752	3	0	\N
107964	1397	1366992833000	13105	6755	0	0	\N
107965	1397	1366992833000	13107	6755	0	0	\N
107966	1726	687666323000	13107	6755	1	0	\N
107967	1726	687665320000	13107	6755	2	0	\N
107968	1726	687664318000	13107	6755	3	0	\N
107979	1397	1366962830000	13110	6757	0	0	\N
107980	1397	1366952829000	13110	6757	1	0	\N
107981	1726	687659309000	13110	6757	2	0	\N
107982	1726	687658308000	13110	6757	3	0	\N
107983	1726	687657306000	13110	6757	4	0	\N
107984	1726	687656303000	13110	6757	5	0	\N
107851	1726	688923410000	13076	6739	1	0	4828
107852	1726	688922407000	13076	6739	2	0	4829
107853	1726	688921405000	13076	6739	3	0	4830
107861	1397	1367162850000	13079	6740	0	0	7167
107862	1726	688920404000	13079	6740	1	0	4831
107886	1397	1367152849000	13086	6741	0	0	7168
107887	1726	688918401000	13086	6741	1	0	4833
107888	1726	688917398000	13086	6741	2	0	4834
107889	1726	688916396000	13086	6741	3	0	4835
107890	1397	1367142848000	13087	6742	0	0	7169
107892	1726	688915395000	13087	6742	2	0	4836
107893	1726	688914392000	13087	6742	3	0	4837
107894	1726	688913390000	13087	6742	4	0	4838
107895	1726	688912389000	13087	6742	5	0	4839
107897	1726	687701387000	13087	6742	7	0	4841
107898	1397	1367122846000	13088	6743	0	0	7171
107899	1726	687700386000	13088	6743	1	0	4842
107900	1726	687699384000	13088	6743	2	0	4843
107901	1397	1367112845000	13089	6744	0	0	7172
107903	1726	687697381000	13089	6744	2	0	4845
107907	1397	1367102844000	13091	6745	0	0	7173
107908	1397	1367092843000	13092	6746	0	0	7174
107909	1726	687696380000	13092	6746	1	0	4846
107910	1726	687695377000	13092	6746	2	0	4847
107912	1726	687693374000	13092	6746	4	0	4849
107913	1726	687692372000	13092	6746	5	0	4850
107914	1397	1367082842000	13093	6747	0	0	7175
107915	1726	687691371000	13093	6747	1	0	4851
107917	1397	1367072841000	13094	6748	0	0	7176
107918	1726	687689366000	13094	6748	1	0	4853
107919	1726	687688365000	13094	6748	2	0	4854
107920	1726	687687363000	13094	6748	3	0	4855
107921	1397	1367062840000	13095	6749	0	0	7177
107923	1726	687686360000	13095	6749	2	0	4856
107924	1726	687685359000	13095	6749	3	0	4857
107925	1726	687684357000	13095	6749	4	0	4858
107926	1726	687683354000	13095	6749	5	0	4859
107927	1726	687682353000	13095	6749	6	0	4860
107929	1397	1367042838000	13096	6750	0	0	7179
107930	1726	687680348000	13096	6750	1	0	4862
107931	1726	687679347000	13096	6750	2	0	4863
107932	1726	687678345000	13096	6750	3	0	4864
107942	1726	687677342000	13099	6751	1	0	4865
107943	1726	687676341000	13099	6751	2	0	4866
107944	1726	687675339000	13099	6751	3	0	4867
107953	1397	1367022836000	13102	6752	0	0	7181
107954	1726	687674336000	13102	6752	1	0	4868
107956	1726	687672333000	13102	6752	3	0	4870
107957	1397	1367012835000	13103	6753	0	0	7182
107958	1726	687671332000	13103	6753	1	0	4871
107959	1726	687670330000	13103	6753	2	0	4872
107960	1397	1367002834000	13104	6754	0	0	7183
107962	1726	687668326000	13104	6754	2	0	4874
107963	1726	687667324000	13104	6754	3	0	4875
107969	1397	1366992833000	13108	6755	0	0	7184
107970	1726	687666323000	13108	6755	1	0	4876
107972	1726	687664318000	13108	6755	3	0	4878
107973	1397	1366982832000	13109	6756	0	0	7185
107974	1397	1366972831000	13109	6756	1	0	7186
107975	1726	687663317000	13109	6756	2	0	4879
107976	1726	687662315000	13109	6756	3	0	4880
107978	1726	687660312000	13109	6756	5	0	4882
107985	1726	687655302000	13110	6757	7	0	\N
107986	1726	687654300000	13110	6757	8	0	\N
107987	1397	1366962830000	13111	6757	0	0	\N
107988	1397	1366952829000	13111	6757	1	0	\N
108001	1397	1366932827000	13114	6759	0	0	\N
108002	1726	687650293000	13114	6759	1	0	\N
108003	1726	687649291000	13114	6759	2	0	\N
108004	1397	1366932827000	13115	6759	0	0	\N
108005	1726	687650293000	13115	6759	1	0	\N
108006	1726	687649291000	13115	6759	2	0	\N
108021	1397	1366912825000	13119	6761	0	0	\N
108022	1397	1366902824000	13119	6761	1	0	\N
108023	1726	687646285000	13119	6761	2	0	\N
108024	1726	687645284000	13119	6761	3	0	\N
108025	1726	687644282000	13119	6761	4	0	\N
108026	1726	687643279000	13119	6761	5	0	\N
108027	1726	687642278000	13119	6761	6	0	\N
108028	1726	687641276000	13119	6761	7	0	\N
108055	1397	1366832817000	13125	6766	0	0	\N
108056	1726	687623242000	13125	6766	1	0	\N
108057	1726	687622240000	13125	6766	2	0	\N
108070	1397	1366822816000	13128	6767	0	0	\N
108071	1397	1366812815000	13128	6767	1	0	\N
108072	1397	1366802814000	13128	6767	2	0	\N
108073	1726	687621239000	13128	6767	3	0	\N
108074	1726	687620236000	13128	6767	4	0	\N
108075	1726	687619234000	13128	6767	5	0	\N
108076	1726	687618233000	13128	6767	6	0	\N
108077	1726	687617230000	13128	6767	7	0	\N
108078	1726	687616228000	13128	6767	8	0	\N
108079	1726	687615227000	13128	6767	9	0	\N
108080	1726	687614224000	13128	6767	10	0	\N
108081	1726	687613222000	13128	6767	11	0	\N
108082	1397	1366822816000	13129	6767	0	0	\N
108083	1397	1366812815000	13129	6767	1	0	\N
108084	1726	687621239000	13129	6767	2	0	\N
108085	1726	687620236000	13129	6767	3	0	\N
108086	1726	687619234000	13129	6767	4	0	\N
108087	1726	687618233000	13129	6767	5	0	\N
108088	1726	687617230000	13129	6767	6	0	\N
108089	1726	687616228000	13129	6767	7	0	\N
108090	1726	687615227000	13129	6767	8	0	\N
108091	1726	687614224000	13129	6767	9	0	\N
108116	1397	1366732807000	13133	6770	0	0	\N
108117	1726	687594186000	13133	6770	1	0	\N
108118	1726	687593183000	13133	6770	2	0	\N
108119	1726	687592182000	13133	6770	3	0	\N
107991	1726	687659309000	13112	6757	2	0	4883
107992	1726	687658308000	13112	6757	3	0	4884
107993	1726	687657306000	13112	6757	4	0	4885
107994	1726	687656303000	13112	6757	5	0	4886
107995	1726	687655302000	13112	6757	7	0	4887
107997	1397	1366942828000	13113	6758	0	0	7189
107998	1726	687653297000	13113	6758	1	0	4889
107999	1726	687652296000	13113	6758	2	0	4890
108000	1726	687651294000	13113	6758	3	0	4891
108007	1397	1366932827000	13116	6759	0	0	7190
108009	1726	687649291000	13116	6759	2	0	4893
108010	1397	1366922826000	13117	6760	0	0	7191
108011	1726	687648290000	13117	6760	1	0	4894
108012	1726	687647288000	13117	6760	2	0	4895
108014	1397	1366902824000	13118	6761	1	0	7193
108015	1726	687646285000	13118	6761	2	0	4896
108016	1726	687645284000	13118	6761	3	0	4897
108017	1726	687644282000	13118	6761	4	0	4898
108018	1726	687643279000	13118	6761	5	0	4899
108020	1726	687641276000	13118	6761	7	0	4901
108029	1397	1366892823000	13120	6762	0	0	7194
108030	1726	687640273000	13120	6762	1	0	4902
108031	1726	687639272000	13120	6762	2	0	4903
108032	1726	687638270000	13120	6762	3	0	4904
108034	1397	1366872821000	13121	6763	1	0	7196
108035	1397	1366862820000	13121	6763	2	0	7197
108036	1726	687637267000	13121	6763	3	0	4905
108037	1726	687636266000	13121	6763	4	0	4906
108039	1726	687634261000	13121	6763	6	0	4908
108040	1726	687633260000	13121	6763	7	0	4909
108041	1726	687632258000	13121	6763	8	0	4910
108042	1726	687631255000	13121	6763	9	0	4911
108043	1726	687630254000	13121	6763	10	0	4912
108045	1397	1366852819000	13122	6764	0	0	7198
108046	1726	687628251000	13122	6764	1	0	4914
108047	1726	687627249000	13122	6764	2	0	4915
108048	1397	1366842818000	13123	6765	0	0	7199
108049	1726	687626248000	13123	6765	1	0	4916
108051	1726	687624243000	13123	6765	3	0	4918
108052	1397	1366832817000	13124	6766	0	0	7200
108053	1726	687623242000	13124	6766	1	0	4919
108054	1726	687622240000	13124	6766	2	0	4920
108059	1397	1366812815000	13127	6767	1	0	7202
108060	1397	1366802814000	13127	6767	2	0	7203
108061	1726	687621239000	13127	6767	3	0	4921
108062	1726	687620236000	13127	6767	4	0	4922
108063	1726	687619234000	13127	6767	5	0	4923
108065	1726	687617230000	13127	6767	7	0	4925
108066	1726	687616228000	13127	6767	8	0	4926
108067	1726	687615227000	13127	6767	9	0	4927
108068	1726	687614224000	13127	6767	10	0	4928
108069	1726	687613222000	13127	6767	11	0	4929
108093	1726	687612221000	13130	6768	1	0	4930
108094	1726	687611218000	13130	6768	2	0	4931
108095	1726	687610216000	13130	6768	3	0	4932
108096	1726	687609215000	13130	6768	4	0	4933
108098	1726	687607210000	13130	6768	6	0	4935
108099	1397	1366782812000	13132	6769	0	0	7205
108100	1397	1366772811000	13132	6769	1	0	7206
108101	1397	1366762810000	13132	6769	2	0	7207
108102	1397	1366752809000	13132	6769	3	0	7208
108104	1726	687606209000	13132	6769	5	0	4936
108105	1726	687605207000	13132	6769	6	0	4937
108106	1726	687604206000	13132	6769	7	0	4938
108107	1726	687603204000	13132	6769	8	0	4939
108108	1726	687602201000	13132	6769	9	0	4940
108110	1726	687600198000	13132	6769	11	0	4942
108111	1726	687599195000	13132	6769	12	0	4943
108112	1726	687598194000	13132	6769	13	0	4944
108113	1726	687597192000	13132	6769	14	0	4945
108115	1726	687595188000	13132	6769	16	0	4947
108120	1397	1366732807000	13134	6770	0	0	7210
108124	1397	1366722806000	13135	6771	0	0	\N
108125	1726	687591180000	13135	6771	1	0	\N
108126	1726	687590177000	13135	6771	2	0	\N
108127	1726	687589176000	13135	6771	3	0	\N
108132	1397	1366722806000	13137	6771	0	0	\N
108133	1726	687591180000	13137	6771	1	0	\N
108134	1726	687590177000	13137	6771	2	0	\N
108135	1397	1366712805000	13138	6772	0	0	\N
108136	1726	687588174000	13138	6772	1	0	\N
108137	1726	687587171000	13138	6772	2	0	\N
108138	1726	687586170000	13138	6772	3	0	\N
108139	1397	1366712805000	13139	6772	0	0	\N
108140	1726	687588174000	13139	6772	1	0	\N
108141	1726	687587171000	13139	6772	2	0	\N
108142	1726	687586170000	13139	6772	3	0	\N
108147	1397	1366702804000	13141	6773	0	0	\N
108148	1397	1366692803000	13141	6773	2	0	\N
108149	1726	687585168000	13141	6773	3	0	\N
108150	1726	687584165000	13141	6773	4	0	\N
108151	1726	687583164000	13141	6773	5	0	\N
108152	1726	687582162000	13141	6773	6	0	\N
108153	1726	687581159000	13141	6773	7	0	\N
108154	1726	687580158000	13141	6773	8	0	\N
108163	1397	1366682802000	13143	6774	0	0	\N
108164	1726	687579156000	13143	6774	1	0	\N
108165	1726	687578155000	13143	6774	2	0	\N
108166	1397	1366682802000	13144	6774	0	0	\N
108167	1726	687579156000	13144	6774	1	0	\N
108168	1726	687578155000	13144	6774	2	0	\N
108172	1673	21606032000000	13146	6775	0	0	\N
108173	1397	1366672801000	13146	6775	1	0	\N
108174	1397	1366662800000	13146	6775	2	0	\N
108175	1397	1366652799000	13146	6775	3	0	\N
108176	1397	1366642798000	13146	6775	4	0	\N
108177	1397	1366632797000	13146	6775	5	0	\N
108178	1397	1366622796000	13146	6775	6	0	\N
108200	1673	16989952000000	13148	6776	0	0	\N
108201	1397	1366612795000	13148	6776	1	0	\N
108202	1726	687563125000	13148	6776	2	0	\N
108203	1726	687562124000	13148	6776	3	0	\N
108204	1726	687561121000	13148	6776	4	0	\N
108212	1673	16989952000000	13151	6776	0	0	\N
108213	1397	1366612795000	13151	6776	1	0	\N
108214	1397	1366602794000	13151	6776	2	0	\N
108215	1726	687563125000	13151	6776	3	0	\N
108216	1726	687562124000	13151	6776	4	0	\N
108217	1726	687561121000	13151	6776	5	0	\N
108218	1726	687560119000	13151	6776	6	0	\N
108219	1397	1366602794000	13152	6777	0	0	\N
108220	1726	687560119000	13152	6777	1	0	\N
108221	1397	1366602794000	13153	6777	0	0	\N
108222	1726	687560119000	13153	6777	1	0	\N
108232	1489	22647795400000	13155	6778	0	0	\N
108233	1489	18072372600000	13155	6778	1	0	\N
108234	1397	1366592793000	13155	6778	2	0	\N
108235	1397	1366582792000	13155	6778	3	0	\N
108236	1489	14985060200000	13155	6778	4	0	\N
108237	1489	6383887000000	13156	6779	0	0	\N
108238	1397	1366572791000	13156	6779	1	0	\N
108239	1726	687555109000	13156	6779	2	0	\N
108240	1726	687554106000	13156	6779	3	0	\N
108241	1489	6383887000000	13157	6779	0	0	\N
108242	1397	1366572791000	13157	6779	1	0	\N
108243	1726	687555109000	13157	6779	2	0	\N
108244	1726	687554106000	13157	6779	3	0	\N
108253	1673	13875532000000	13160	6780	0	0	\N
108254	1397	1366562790000	13160	6780	1	0	\N
108255	1726	687555109000	13160	6780	2	0	\N
108256	1726	687554106000	13160	6780	3	0	\N
108123	1726	687592182000	13134	6770	3	0	4950
108128	1397	1366722806000	13136	6771	0	0	7211
108129	1726	687591180000	13136	6771	1	0	4951
108130	1726	687590177000	13136	6771	2	0	4952
108131	1726	687589176000	13136	6771	3	0	4953
108144	1726	687588174000	13140	6772	1	0	4954
108145	1726	687587171000	13140	6772	2	0	4955
108146	1726	687586170000	13140	6772	3	0	4956
108155	1397	1366702804000	13142	6773	0	0	7213
108156	1397	1366692803000	13142	6773	2	0	7214
108158	1726	687584165000	13142	6773	4	0	4958
108159	1726	687583164000	13142	6773	5	0	4959
108160	1726	687582162000	13142	6773	6	0	4960
108161	1726	687581159000	13142	6773	7	0	4961
108169	1397	1366682802000	13145	6774	0	0	7215
108170	1726	687579156000	13145	6774	1	0	4963
108171	1726	687578155000	13145	6774	2	0	4964
108179	1673	21606032000000	13147	6775	0	0	3
108180	1397	1366672801000	13147	6775	1	0	7216
108182	1397	1366652799000	13147	6775	3	0	7218
108183	1397	1366642798000	13147	6775	4	0	7219
108184	1397	1366632797000	13147	6775	5	0	7220
108185	1397	1366622796000	13147	6775	6	0	7221
108186	1726	687577153000	13147	6775	7	0	4965
108188	1726	687575149000	13147	6775	9	0	4967
108189	1726	687574148000	13147	6775	10	0	4968
108190	1726	687573145000	13147	6775	11	0	4969
108191	1726	687572143000	13147	6775	12	0	4970
108193	1726	687570139000	13147	6775	14	0	4972
108194	1726	687569137000	13147	6775	15	0	4973
108195	1726	687568136000	13147	6775	16	0	4974
108196	1726	687567133000	13147	6775	17	0	4975
108197	1726	687566131000	13147	6775	18	0	4976
108199	1726	687564127000	13147	6775	20	0	4978
108205	1673	16989952000000	13149	6776	0	0	4
108206	1397	1366612795000	13149	6776	1	0	7222
108207	1726	687563125000	13149	6776	2	0	4979
108208	1726	687562124000	13149	6776	3	0	4980
108210	1397	1366602794000	13150	6777	0	0	7223
108211	1726	687560119000	13150	6777	1	0	4982
108223	1489	22647795400000	13154	6778	0	0	1
108224	1489	18072372600000	13154	6778	1	0	2
108226	1397	1366582792000	13154	6778	3	0	7225
108227	1489	14985060200000	13154	6778	4	0	3
108228	1726	687559117000	13154	6778	5	0	4983
108229	1726	687558116000	13154	6778	6	0	4984
108230	1726	687557114000	13154	6778	7	0	4985
108245	1489	6383887000000	13158	6779	0	0	4
108246	1397	1366572791000	13158	6779	1	0	7226
108247	1673	13875532000000	13159	6780	0	0	5
108248	1397	1366562790000	13159	6780	1	0	7227
108249	1726	687555109000	13159	6780	2	0	4987
108251	1726	687553104000	13159	6780	4	0	4989
108252	1726	687552101000	13159	6780	5	0	4990
108257	1726	687553104000	13160	6780	4	0	\N
108258	1726	687552101000	13160	6780	5	0	\N
108259	1673	13875532000000	13161	6780	0	0	\N
108260	1397	1366562790000	13161	6780	1	0	\N
108261	1726	687553104000	13161	6780	2	0	\N
108262	1726	687552101000	13161	6780	3	0	\N
108274	1397	1366512785000	13164	6783	0	0	\N
108275	1726	687545084000	13164	6783	1	0	\N
108276	1726	687544081000	13164	6783	2	0	\N
108277	1726	687543079000	13164	6783	3	0	\N
108278	1726	687542076000	13164	6783	4	0	\N
108284	1397	1366512785000	13166	6783	0	0	\N
108285	1726	687545084000	13166	6783	1	0	\N
108286	1726	687544081000	13166	6783	2	0	\N
108287	1726	687543079000	13166	6783	3	0	\N
108288	1726	687542076000	13166	6783	4	0	\N
108293	1397	1366492783000	13169	6785	0	0	\N
108294	1726	687540072000	13169	6785	1	0	\N
108295	1673	21606032000000	13170	6752	0	0	\N
108296	1673	16989952000000	13170	6752	1	0	\N
108297	1673	13875532000000	13170	6752	2	0	\N
108298	1489	22647795400000	13170	6752	3	0	\N
108299	1397	1367022836000	13170	6752	4	0	\N
108300	1673	11298692000000	13170	6752	5	0	\N
108301	1489	18072372600000	13170	6752	6	0	\N
108302	1489	14985060200000	13170	6752	7	0	\N
108303	1489	6383887000000	13170	6752	8	0	\N
108304	1397	1367012835000	13170	6752	9	0	\N
108305	1397	1367002834000	13170	6752	10	0	\N
108306	1397	1366992833000	13170	6752	11	0	\N
108307	1397	1366982832000	13170	6752	12	0	\N
108308	1397	1366972831000	13170	6752	13	0	\N
108309	1397	1366962830000	13170	6752	14	0	\N
108310	1397	1366952829000	13170	6752	15	0	\N
108311	1397	1366942828000	13170	6752	16	0	\N
108312	1397	1366932827000	13170	6752	17	0	\N
108313	1397	1366922826000	13170	6752	18	0	\N
108314	1397	1366912825000	13170	6752	19	0	\N
108315	1397	1366902824000	13170	6752	20	0	\N
108316	1397	1366892823000	13170	6752	21	0	\N
108317	1397	1366882822000	13170	6752	22	0	\N
108318	1397	1366872821000	13170	6752	23	0	\N
108319	1397	1366862820000	13170	6752	24	0	\N
108320	1397	1366852819000	13170	6752	25	0	\N
108321	1397	1366842818000	13170	6752	26	0	\N
108322	1397	1366832817000	13170	6752	27	0	\N
108323	1397	1366822816000	13170	6752	28	0	\N
108324	1397	1366812815000	13170	6752	29	0	\N
108325	1397	1366802814000	13170	6752	30	0	\N
108326	1397	1366792813000	13170	6752	31	0	\N
108327	1397	1366782812000	13170	6752	32	0	\N
108328	1397	1366772811000	13170	6752	33	0	\N
108329	1397	1366762810000	13170	6752	34	0	\N
108330	1397	1366752809000	13170	6752	35	0	\N
108331	1397	1366742808000	13170	6752	36	0	\N
108332	1397	1366732807000	13170	6752	38	0	\N
108333	1397	1366722806000	13170	6752	39	0	\N
108334	1397	1366712805000	13170	6752	40	0	\N
108335	1397	1366702804000	13170	6752	41	0	\N
108336	1397	1366692803000	13170	6752	42	0	\N
108337	1397	1366682802000	13170	6752	43	0	\N
108338	1397	1366672801000	13170	6752	44	0	\N
108339	1397	1366662800000	13170	6752	45	0	\N
108340	1397	1366652799000	13170	6752	46	0	\N
108341	1397	1366642798000	13170	6752	47	0	\N
108342	1397	1366632797000	13170	6752	48	0	\N
108343	1397	1366622796000	13170	6752	49	0	\N
108344	1397	1366612795000	13170	6752	50	0	\N
108345	1397	1366602794000	13170	6752	51	0	\N
108346	1397	1366592793000	13170	6752	52	0	\N
108347	1397	1366582792000	13170	6752	53	0	\N
108348	1397	1366572791000	13170	6752	54	0	\N
108349	1397	1366562790000	13170	6752	55	0	\N
108350	1397	1366552789000	13170	6752	56	0	\N
108351	1397	1366542788000	13170	6752	57	0	\N
108352	1397	1366532787000	13170	6752	58	0	\N
108353	1397	1366522786000	13170	6752	59	0	\N
108354	1397	1366512785000	13170	6752	60	0	\N
108355	1397	1366502784000	13170	6752	61	0	\N
108356	1726	687674336000	13170	6752	62	0	\N
108357	1726	687673335000	13170	6752	63	0	\N
108358	1726	687672333000	13170	6752	64	0	\N
108359	1726	687671332000	13170	6752	65	0	\N
108360	1726	687670330000	13170	6752	66	0	\N
108361	1726	687669329000	13170	6752	67	0	\N
108362	1726	687668326000	13170	6752	68	0	\N
108363	1726	687667324000	13170	6752	69	0	\N
108364	1726	687666323000	13170	6752	70	0	\N
108365	1726	687665320000	13170	6752	71	0	\N
108366	1726	687664318000	13170	6752	72	0	\N
108367	1726	687663317000	13170	6752	73	0	\N
108368	1726	687662315000	13170	6752	74	0	\N
108369	1726	687661314000	13170	6752	75	0	\N
108370	1726	687660312000	13170	6752	76	0	\N
108371	1726	687659309000	13170	6752	77	0	\N
108372	1726	687658308000	13170	6752	78	0	\N
108373	1726	687657306000	13170	6752	79	0	\N
108374	1726	687656303000	13170	6752	80	0	\N
108375	1726	687655302000	13170	6752	81	0	\N
108376	1726	687654300000	13170	6752	82	0	\N
108377	1726	687653297000	13170	6752	83	0	\N
108378	1726	687652296000	13170	6752	84	0	\N
108379	1726	687651294000	13170	6752	85	0	\N
108380	1726	687650293000	13170	6752	86	0	\N
108381	1726	687649291000	13170	6752	87	0	\N
108382	1726	687648290000	13170	6752	88	0	\N
108383	1726	687647288000	13170	6752	89	0	\N
108384	1726	687646285000	13170	6752	90	0	\N
108385	1726	687645284000	13170	6752	91	0	\N
108386	1726	687644282000	13170	6752	92	0	\N
108387	1726	687643279000	13170	6752	93	0	\N
108388	1726	687642278000	13170	6752	94	0	\N
108389	1726	687641276000	13170	6752	95	0	\N
108390	1726	687640273000	13170	6752	96	0	\N
108391	1726	687639272000	13170	6752	97	0	\N
108392	1726	687638270000	13170	6752	98	0	\N
108265	1673	11298692000000	13162	6781	2	0	6
108266	1397	1366532787000	13162	6781	3	0	7230
108267	1726	687551099000	13162	6781	4	0	4991
108268	1726	687550096000	13162	6781	5	0	4992
108269	1726	687549094000	13162	6781	6	0	4993
108271	1726	687547089000	13162	6781	8	0	4995
108272	1726	687546086000	13162	6781	9	0	4996
108273	1397	1366522786000	13163	6782	0	0	7231
108279	1397	1366512785000	13165	6783	0	0	7232
108280	1726	687545084000	13165	6783	1	0	4997
108282	1726	687543079000	13165	6783	3	0	4999
108283	1726	687542076000	13165	6783	4	0	5000
108289	1397	1366502784000	13167	6784	0	0	7233
108290	1726	687541074000	13167	6784	1	0	5001
108292	1726	687540072000	13168	6785	1	0	5002
108393	1726	687637267000	13170	6752	99	0	\N
108394	1726	687636266000	13170	6752	100	0	\N
108395	1726	687635264000	13170	6752	101	0	\N
108396	1726	687634261000	13170	6752	102	0	\N
108397	1726	687633260000	13170	6752	103	0	\N
108398	1726	687632258000	13170	6752	104	0	\N
108399	1726	687631255000	13170	6752	105	0	\N
108400	1726	687630254000	13170	6752	106	0	\N
108401	1726	687629252000	13170	6752	107	0	\N
108402	1726	687628251000	13170	6752	108	0	\N
108403	1726	687627249000	13170	6752	109	0	\N
108404	1726	687626248000	13170	6752	110	0	\N
108405	1726	687625245000	13170	6752	111	0	\N
108406	1726	687624243000	13170	6752	112	0	\N
108407	1726	687623242000	13170	6752	113	0	\N
108408	1726	687622240000	13170	6752	114	0	\N
108409	1726	687621239000	13170	6752	115	0	\N
108410	1726	687620236000	13170	6752	116	0	\N
108411	1726	687619234000	13170	6752	117	0	\N
108412	1726	687618233000	13170	6752	118	0	\N
108413	1726	687617230000	13170	6752	119	0	\N
108414	1726	687616228000	13170	6752	120	0	\N
108415	1726	687615227000	13170	6752	121	0	\N
108416	1726	687614224000	13170	6752	122	0	\N
108417	1726	687613222000	13170	6752	123	0	\N
108418	1726	687612221000	13170	6752	124	0	\N
108419	1726	687611218000	13170	6752	125	0	\N
108423	1397	1366472781000	13172	6787	0	0	\N
108424	1673	11132052000000	13172	6787	1	0	\N
108425	1726	687537065000	13172	6787	2	0	\N
108426	1726	687536062000	13172	6787	3	0	\N
108427	1397	1366472781000	13173	6787	0	0	\N
108428	1673	11132052000000	13173	6787	1	0	\N
108429	1726	687537065000	13173	6787	2	0	\N
108430	1726	687536062000	13173	6787	3	0	\N
108435	1397	1366462780000	13175	6788	0	0	\N
108436	1397	1366452779000	13175	6788	1	0	\N
108437	1673	11126092000000	13175	6788	2	0	\N
108438	1593	16503869000000	13175	6788	3	0	\N
108439	1397	1366442778000	13175	6788	4	0	\N
108440	1726	687535060000	13175	6788	5	0	\N
108441	1726	687534057000	13175	6788	6	0	\N
108442	1726	687533055000	13175	6788	7	0	\N
108443	1726	687532053000	13175	6788	8	0	\N
108444	1726	687531050000	13175	6788	9	0	\N
108467	1593	12260859000000	13178	6789	0	0	\N
108468	1397	1366432777000	13178	6789	1	0	\N
108469	1593	9397849000000	13178	6789	2	0	\N
108470	1593	7029839000000	13178	6789	4	0	\N
108471	1397	1366422776000	13178	6789	5	0	\N
108472	1397	1366412775000	13178	6789	6	0	\N
108473	1726	687530048000	13178	6789	7	0	\N
108474	1726	687529045000	13178	6789	8	0	\N
108475	1726	687528043000	13178	6789	9	0	\N
108476	1726	687527040000	13178	6789	10	0	\N
108477	1726	687526038000	13178	6789	11	0	\N
108478	1726	687525035000	13178	6789	12	0	\N
108479	1593	12260859000000	13179	6789	0	0	\N
108480	1397	1366432777000	13179	6789	1	0	\N
108481	1593	9397849000000	13179	6789	2	0	\N
108482	1593	7029839000000	13179	6789	4	0	\N
108483	1397	1366422776000	13179	6789	5	0	\N
108484	1397	1366412775000	13179	6789	6	0	\N
108485	1726	687530048000	13179	6789	7	0	\N
108486	1726	687529045000	13179	6789	8	0	\N
108487	1726	687528043000	13179	6789	9	0	\N
108488	1726	687527040000	13179	6789	10	0	\N
108489	1726	687526038000	13179	6789	11	0	\N
108490	1726	687525035000	13179	6789	12	0	\N
108505	1673	21606032000000	13183	6758	0	0	\N
108506	1673	16989952000000	13183	6758	1	0	\N
108507	1673	13875532000000	13183	6758	2	0	\N
108508	1489	22647795400000	13183	6758	3	0	\N
108509	1673	11298692000000	13183	6758	4	0	\N
108510	1489	18072372600000	13183	6758	5	0	\N
108511	1673	11132052000000	13183	6758	6	0	\N
108512	1673	11126092000000	13183	6758	7	0	\N
108513	1489	14985060200000	13183	6758	8	0	\N
108514	1489	6383887000000	13183	6758	9	0	\N
108515	1593	16503869000000	13183	6758	10	0	\N
108516	1593	12260859000000	13183	6758	11	0	\N
108517	1593	9397849000000	13183	6758	12	0	\N
108518	1593	7029839000000	13183	6758	13	0	\N
108519	1397	1366942828000	13183	6758	14	0	\N
108520	1397	1366932827000	13183	6758	15	0	\N
108521	1397	1366922826000	13183	6758	16	0	\N
108522	1397	1366912825000	13183	6758	17	0	\N
108523	1397	1366902824000	13183	6758	18	0	\N
108524	1397	1366892823000	13183	6758	19	0	\N
108525	1397	1366882822000	13183	6758	20	0	\N
108526	1397	1366872821000	13183	6758	21	0	\N
108527	1397	1366862820000	13183	6758	22	0	\N
108528	1397	1366852819000	13183	6758	23	0	\N
108422	1726	687538067000	13171	6786	2	0	5004
108431	1397	1366472781000	13174	6787	0	0	7236
108432	1673	11132052000000	13174	6787	1	0	7
108433	1726	687537065000	13174	6787	2	0	5005
108434	1726	687536062000	13174	6787	3	0	5006
108446	1397	1366452779000	13176	6788	1	0	7238
108447	1673	11126092000000	13176	6788	2	0	8
108448	1593	16503869000000	13176	6788	3	0	1
108449	1397	1366442778000	13176	6788	4	0	7239
108450	1726	687535060000	13176	6788	5	0	5007
108452	1726	687533055000	13176	6788	7	0	5009
108453	1726	687532053000	13176	6788	8	0	5010
108454	1726	687531050000	13176	6788	9	0	5011
108455	1593	12260859000000	13177	6789	0	0	2
108457	1593	9397849000000	13177	6789	2	0	3
108458	1593	7029839000000	13177	6789	4	0	4
108459	1397	1366422776000	13177	6789	5	0	7241
108460	1397	1366412775000	13177	6789	6	0	7242
108461	1726	687530048000	13177	6789	7	0	5012
108463	1726	687528043000	13177	6789	9	0	5014
108464	1726	687527040000	13177	6789	10	0	5015
108465	1726	687526038000	13177	6789	11	0	5016
108466	1726	687525035000	13177	6789	12	0	5017
108491	1397	1366402774000	13180	6790	0	0	7243
108493	1397	1366382772000	13180	6790	2	0	7245
108494	1726	687524033000	13180	6790	3	0	5018
108495	1726	687523030000	13180	6790	4	0	5019
108496	1726	687522028000	13180	6790	5	0	5020
108498	1726	687520023000	13180	6790	7	0	5022
108499	1726	687519020000	13180	6790	8	0	5023
108500	1397	1366372771000	13181	6791	0	0	7246
108501	1397	1366362770000	13182	6792	0	0	7247
108502	1726	687518018000	13182	6792	1	0	5024
108504	1726	687516013000	13182	6792	3	0	5026
108529	1397	1366842818000	13183	6758	24	0	\N
108530	1397	1366832817000	13183	6758	25	0	\N
108531	1397	1366822816000	13183	6758	26	0	\N
108532	1397	1366812815000	13183	6758	27	0	\N
108533	1397	1366802814000	13183	6758	28	0	\N
108534	1397	1366792813000	13183	6758	29	0	\N
108535	1397	1366782812000	13183	6758	30	0	\N
108536	1397	1366772811000	13183	6758	31	0	\N
108537	1397	1366762810000	13183	6758	32	0	\N
108538	1397	1366752809000	13183	6758	33	0	\N
108539	1397	1366742808000	13183	6758	34	0	\N
108540	1397	1366732807000	13183	6758	35	0	\N
108541	1397	1366722806000	13183	6758	36	0	\N
108542	1397	1366712805000	13183	6758	37	0	\N
108543	1397	1366702804000	13183	6758	38	0	\N
108544	1397	1366692803000	13183	6758	39	0	\N
108545	1397	1366682802000	13183	6758	40	0	\N
108546	1397	1366672801000	13183	6758	41	0	\N
108547	1397	1366662800000	13183	6758	42	0	\N
108548	1397	1366652799000	13183	6758	43	0	\N
108549	1397	1366642798000	13183	6758	44	0	\N
108550	1397	1366632797000	13183	6758	45	0	\N
108551	1397	1366622796000	13183	6758	46	0	\N
108552	1397	1366612795000	13183	6758	47	0	\N
108553	1397	1366602794000	13183	6758	48	0	\N
108554	1397	1366592793000	13183	6758	49	0	\N
108555	1397	1366582792000	13183	6758	50	0	\N
108556	1397	1366572791000	13183	6758	51	0	\N
108557	1397	1366562790000	13183	6758	52	0	\N
108558	1397	1366552789000	13183	6758	53	0	\N
108559	1397	1366542788000	13183	6758	54	0	\N
108560	1397	1366532787000	13183	6758	55	0	\N
108561	1397	1366522786000	13183	6758	56	0	\N
108562	1397	1366512785000	13183	6758	57	0	\N
108563	1397	1366502784000	13183	6758	58	0	\N
108564	1397	1366492783000	13183	6758	59	0	\N
108565	1397	1366482782000	13183	6758	60	0	\N
108566	1397	1366472781000	13183	6758	61	0	\N
108567	1397	1366462780000	13183	6758	62	0	\N
108568	1397	1366452779000	13183	6758	63	0	\N
108569	1397	1366442778000	13183	6758	64	0	\N
108570	1397	1366432777000	13183	6758	65	0	\N
108571	1397	1366422776000	13183	6758	66	0	\N
108572	1397	1366412775000	13183	6758	67	0	\N
108573	1397	1366402774000	13183	6758	68	0	\N
108574	1397	1366392773000	13183	6758	69	0	\N
108575	1397	1366382772000	13183	6758	70	0	\N
108576	1397	1366372771000	13183	6758	71	0	\N
108577	1397	1366362770000	13183	6758	72	0	\N
108578	1726	687653297000	13183	6758	73	0	\N
108579	1726	687652296000	13183	6758	74	0	\N
108580	1726	687651294000	13183	6758	75	0	\N
108581	1726	687650293000	13183	6758	76	0	\N
108582	1726	687649291000	13183	6758	77	0	\N
108583	1726	687648290000	13183	6758	78	0	\N
108584	1726	687647288000	13183	6758	79	0	\N
108585	1726	687646285000	13183	6758	80	0	\N
108586	1726	687645284000	13183	6758	81	0	\N
108587	1726	687644282000	13183	6758	82	0	\N
108588	1726	687643279000	13183	6758	83	0	\N
108589	1726	687642278000	13183	6758	84	0	\N
108590	1726	687641276000	13183	6758	85	0	\N
108591	1726	687640273000	13183	6758	86	0	\N
108592	1726	687639272000	13183	6758	87	0	\N
108593	1726	687638270000	13183	6758	88	0	\N
108594	1726	687637267000	13183	6758	89	0	\N
108595	1726	687636266000	13183	6758	90	0	\N
108596	1726	687635264000	13183	6758	91	0	\N
108597	1726	687634261000	13183	6758	92	0	\N
108598	1726	687633260000	13183	6758	93	0	\N
108599	1726	687632258000	13183	6758	94	0	\N
108600	1726	687631255000	13183	6758	95	0	\N
108601	1726	687630254000	13183	6758	96	0	\N
108602	1726	687629252000	13183	6758	97	0	\N
108603	1726	687628251000	13183	6758	98	0	\N
108604	1726	687627249000	13183	6758	99	0	\N
108605	1726	687626248000	13183	6758	100	0	\N
108606	1726	687625245000	13183	6758	101	0	\N
108607	1726	687624243000	13183	6758	102	0	\N
108608	1726	687623242000	13183	6758	103	0	\N
108609	1726	687622240000	13183	6758	104	0	\N
108610	1726	687621239000	13183	6758	105	0	\N
108611	1726	687620236000	13183	6758	106	0	\N
108612	1726	687619234000	13183	6758	107	0	\N
108613	1726	687618233000	13183	6758	108	0	\N
108614	1726	687617230000	13183	6758	109	0	\N
108615	1726	687616228000	13183	6758	110	0	\N
108616	1726	687615227000	13183	6758	111	0	\N
108617	1726	687614224000	13183	6758	112	0	\N
108618	1726	687613222000	13183	6758	113	0	\N
108619	1726	687612221000	13183	6758	114	0	\N
108620	1726	687611218000	13183	6758	115	0	\N
108621	1726	687610216000	13183	6758	116	0	\N
108622	1726	687609215000	13183	6758	117	0	\N
108623	1726	687608213000	13183	6758	118	0	\N
108624	1726	687607210000	13183	6758	119	0	\N
108625	1726	687606209000	13183	6758	120	0	\N
108626	1726	687605207000	13183	6758	121	0	\N
108627	1726	687604206000	13183	6758	122	0	\N
108628	1726	687603204000	13183	6758	124	0	\N
108629	1726	687602201000	13183	6758	125	0	\N
108636	1397	1366352769000	13185	6793	0	0	\N
108637	1397	1366342768000	13185	6793	1	0	\N
108653	1397	1366282762000	13189	6797	0	0	\N
108654	1397	1366272761000	13189	6797	1	0	\N
108655	1397	1366262760000	13189	6797	2	0	\N
108656	1726	687500976000	13189	6797	3	0	\N
108657	1726	687499973000	13189	6797	4	0	\N
108658	1726	687498971000	13189	6797	5	0	\N
108659	1726	687497968000	13189	6797	6	0	\N
108660	1726	687496966000	13189	6797	7	0	\N
108661	1726	687495963000	13189	6797	8	0	\N
108632	1726	687515010000	13184	6793	2	0	5027
108633	1726	687514008000	13184	6793	3	0	5028
108634	1726	687513005000	13184	6793	4	0	5029
108635	1726	687512003000	13184	6793	5	0	5030
108638	1397	1366332767000	13186	6794	0	0	7250
108640	1397	1366312765000	13187	6795	0	0	7252
108641	1726	687511001000	13187	6795	1	0	5031
108642	1726	687509998000	13187	6795	2	0	5032
108643	1726	687508996000	13187	6795	3	0	5033
108644	1726	687507993000	13187	6795	4	0	5034
108646	1726	687505988000	13187	6795	6	0	5036
108647	1397	1366302764000	13188	6796	0	0	7253
108648	1397	1366292763000	13188	6796	1	0	7254
108649	1726	687504986000	13188	6796	2	0	5037
108651	1726	687502981000	13188	6796	4	0	5039
108652	1726	687501978000	13188	6796	5	0	5040
108662	1397	1366282762000	13190	6797	0	0	7255
108663	1397	1366272761000	13190	6797	1	0	7256
108664	1397	1366262760000	13190	6797	2	0	7257
108665	1397	1366252759000	13191	6798	0	0	\N
108666	1726	687500976000	13191	6798	1	0	\N
108667	1726	687499973000	13191	6798	2	0	\N
108668	1726	687498971000	13191	6798	3	0	\N
108669	1726	687497968000	13191	6798	4	0	\N
108670	1726	687496966000	13191	6798	5	0	\N
108671	1726	687495963000	13191	6798	6	0	\N
108672	1397	1366252759000	13192	6798	0	0	\N
108673	1726	687500976000	13192	6798	1	0	\N
108674	1726	687499973000	13192	6798	2	0	\N
108675	1726	687498971000	13192	6798	3	0	\N
108676	1726	687497968000	13192	6798	4	0	\N
108677	1726	687496966000	13192	6798	5	0	\N
108678	1726	687495963000	13192	6798	6	0	\N
108679	1726	687494961000	13192	6798	7	0	\N
108680	1726	687493958000	13192	6798	8	0	\N
108681	1726	687500976000	13193	6798	0	0	\N
108682	1726	687499973000	13193	6798	1	0	\N
108683	1726	687498971000	13193	6798	2	0	\N
108684	1726	687497968000	13193	6798	3	0	\N
108685	1726	687496966000	13193	6798	4	0	\N
108686	1726	687495963000	13193	6798	5	0	\N
108687	1726	687494961000	13193	6798	6	0	\N
108688	1726	687493958000	13193	6798	7	0	\N
108695	1397	1366252759000	13195	6799	0	0	\N
108696	1397	1366242758000	13195	6799	1	0	\N
108697	1397	1366252759000	13196	6799	0	0	\N
108698	1397	1366242758000	13196	6799	1	0	\N
108699	1726	687494961000	13196	6799	2	0	\N
108700	1726	687493958000	13196	6799	3	0	\N
108701	1726	687492956000	13196	6799	4	0	\N
108702	1726	687491953000	13196	6799	5	0	\N
108723	1397	1366202754000	13201	6802	0	0	\N
108724	1397	1366192753000	13201	6802	1	0	\N
108725	1726	687485938000	13201	6802	2	0	\N
108726	1726	687484936000	13201	6802	3	0	\N
108727	1726	687483933000	13201	6802	4	0	\N
108728	1726	687482931000	13201	6802	5	0	\N
108732	1726	687481928000	13203	6803	0	0	\N
108733	1726	687480926000	13203	6803	1	0	\N
108737	1397	1366172751000	13205	6804	0	0	\N
108738	1726	687479923000	13205	6804	1	0	\N
108739	1726	687478921000	13205	6804	2	0	\N
108740	1397	1366172751000	13206	6804	0	0	\N
108750	1397	1366132747000	13210	6808	0	0	\N
108751	1397	1366122746000	13210	6808	2	0	\N
108752	1726	687471903000	13210	6808	3	0	\N
108753	1726	687470901000	13210	6808	4	0	\N
108754	1726	687469898000	13210	6808	5	0	\N
108755	1726	687468896000	13210	6808	6	0	\N
108765	1397	1366102744000	13213	6810	0	0	\N
108766	1397	1366092743000	13213	6810	1	0	\N
108767	1726	687465888000	13213	6810	2	0	\N
108768	1726	687464886000	13213	6810	3	0	\N
108769	1726	687463884000	13213	6810	4	0	\N
108781	1397	1366352769000	13217	6759	0	0	\N
108782	1397	1366342768000	13217	6759	1	0	\N
108783	1397	1366332767000	13217	6759	2	0	\N
108784	1397	1366322766000	13217	6759	3	0	\N
108785	1397	1366312765000	13217	6759	4	0	\N
108786	1397	1366302764000	13217	6759	5	0	\N
108787	1397	1366292763000	13217	6759	6	0	\N
108788	1397	1366282762000	13217	6759	7	0	\N
108789	1397	1366272761000	13217	6759	8	0	\N
108790	1397	1366262760000	13217	6759	9	0	\N
108791	1397	1366252759000	13217	6759	10	0	\N
108792	1397	1366242758000	13217	6759	11	0	\N
108793	1397	1366232757000	13217	6759	12	0	\N
108794	1397	1366222756000	13217	6759	13	0	\N
108795	1397	1366212755000	13217	6759	14	0	\N
108796	1397	1366202754000	13217	6759	15	0	\N
108797	1397	1366192753000	13217	6759	16	0	\N
108798	1397	1366182752000	13217	6759	17	0	\N
108799	1397	1366172751000	13217	6759	18	0	\N
108800	1397	1366162750000	13217	6759	19	0	\N
108691	1726	687498971000	13194	6798	2	0	5043
108692	1726	687497968000	13194	6798	3	0	5044
108693	1726	687496966000	13194	6798	4	0	5045
108694	1726	687495963000	13194	6798	5	0	5046
108703	1397	1366252759000	13197	6799	0	0	7258
108705	1726	687494961000	13197	6799	2	0	5047
108706	1726	687493958000	13197	6799	3	0	5048
108707	1726	687492956000	13197	6799	4	0	5049
108708	1726	687491953000	13197	6799	5	0	5050
108709	1397	1366232757000	13198	6800	0	0	7260
108711	1726	687489948000	13198	6800	2	0	5052
108712	1397	1366222756000	13199	6801	0	0	7261
108713	1397	1366212755000	13199	6801	1	0	7262
108714	1726	687488946000	13199	6801	2	0	5053
108716	1726	687486941000	13199	6801	4	0	5055
108717	1397	1366202754000	13200	6802	0	0	7263
108718	1397	1366192753000	13200	6802	1	0	7264
108719	1726	687485938000	13200	6802	2	0	5056
108720	1726	687484936000	13200	6802	3	0	5057
108722	1726	687482931000	13200	6802	5	0	5059
108729	1397	1366182752000	13202	6803	0	0	7265
108730	1726	687481928000	13202	6803	1	0	5060
108731	1726	687480926000	13202	6803	2	0	5061
108734	1397	1366172751000	13204	6804	0	0	7266
108736	1726	687478921000	13204	6804	2	0	5063
108741	1397	1366162750000	13207	6805	0	0	7267
108742	1726	687477918000	13207	6805	1	0	5064
108743	1726	687476916000	13207	6805	2	0	5065
108745	1726	687475913000	13208	6806	1	0	5066
108746	1726	687474911000	13208	6806	2	0	5067
108747	1397	1366142748000	13209	6807	0	0	7269
108748	1726	687473908000	13209	6807	1	0	5068
108749	1726	687472906000	13209	6807	2	0	5069
108757	1397	1366122746000	13211	6808	2	0	7271
108758	1397	1366112745000	13212	6809	0	0	7272
108759	1726	687471903000	13212	6809	1	0	5070
108760	1726	687470901000	13212	6809	2	0	5071
108761	1726	687469898000	13212	6809	3	0	5072
108763	1726	687467893000	13212	6809	5	0	5074
108764	1726	687466891000	13212	6809	6	0	5075
108770	1397	1366102744000	13214	6810	0	0	7273
108771	1397	1366092743000	13214	6810	1	0	7274
108773	1726	687464886000	13214	6810	3	0	5077
108774	1726	687463884000	13214	6810	4	0	5078
108775	1397	1366082742000	13215	6811	0	0	7275
108776	1726	687462882000	13215	6811	1	0	5079
108777	1726	687461879000	13215	6811	2	0	5080
108779	1726	687460877000	13216	6812	1	0	5081
108780	1726	687459874000	13216	6812	2	0	5082
108801	1397	1366152749000	13217	6759	20	0	\N
108802	1397	1366142748000	13217	6759	21	0	\N
108803	1397	1366132747000	13217	6759	22	0	\N
108804	1397	1366122746000	13217	6759	23	0	\N
108805	1397	1366112745000	13217	6759	24	0	\N
108806	1397	1366102744000	13217	6759	25	0	\N
108807	1397	1366092743000	13217	6759	26	0	\N
108808	1397	1366082742000	13217	6759	27	0	\N
108809	1397	1366072741000	13217	6759	28	0	\N
108810	1726	687601200000	13217	6759	29	0	\N
108811	1726	687600198000	13217	6759	30	0	\N
108812	1726	687599195000	13217	6759	31	0	\N
108813	1726	687598194000	13217	6759	32	0	\N
108814	1726	687597192000	13217	6759	33	0	\N
108815	1726	687596189000	13217	6759	34	0	\N
108816	1726	687595188000	13217	6759	35	0	\N
108817	1726	687594186000	13217	6759	36	0	\N
108818	1726	687593183000	13217	6759	37	0	\N
108819	1726	687592182000	13217	6759	38	0	\N
108820	1726	687591180000	13217	6759	39	0	\N
108821	1726	687590177000	13217	6759	40	0	\N
108822	1726	687589176000	13217	6759	41	0	\N
108823	1726	687588174000	13217	6759	42	0	\N
108824	1726	687587171000	13217	6759	43	0	\N
108825	1726	687586170000	13217	6759	44	0	\N
108826	1726	687585168000	13217	6759	45	0	\N
108827	1726	687584165000	13217	6759	46	0	\N
108828	1726	687583164000	13217	6759	47	0	\N
108829	1726	687582162000	13217	6759	48	0	\N
108830	1726	687581159000	13217	6759	49	0	\N
108831	1726	687580158000	13217	6759	50	0	\N
108832	1726	687579156000	13217	6759	51	0	\N
108833	1726	687578155000	13217	6759	52	0	\N
108834	1726	687577153000	13217	6759	53	0	\N
108835	1726	687576151000	13217	6759	54	0	\N
108836	1726	687575149000	13217	6759	55	0	\N
108837	1726	687574148000	13217	6759	56	0	\N
108838	1726	687573145000	13217	6759	57	0	\N
108839	1726	687572143000	13217	6759	58	0	\N
108840	1726	687571142000	13217	6759	59	0	\N
108841	1726	687570139000	13217	6759	60	0	\N
108842	1726	687569137000	13217	6759	61	0	\N
108843	1726	687568136000	13217	6759	62	0	\N
108844	1726	687567133000	13217	6759	63	0	\N
108845	1726	687566131000	13217	6759	64	0	\N
108846	1726	687565130000	13217	6759	65	0	\N
108847	1726	687564127000	13217	6759	66	0	\N
108848	1726	687563125000	13217	6759	67	0	\N
108849	1726	687562124000	13217	6759	68	0	\N
108850	1726	687561121000	13217	6759	69	0	\N
108851	1726	687560119000	13217	6759	70	0	\N
108852	1726	687559117000	13217	6759	71	0	\N
108853	1726	687558116000	13217	6759	72	0	\N
108854	1726	687557114000	13217	6759	73	0	\N
108855	1726	687556111000	13217	6759	74	0	\N
108856	1726	687555109000	13217	6759	75	0	\N
108857	1726	687554106000	13217	6759	76	0	\N
108858	1726	687553104000	13217	6759	77	0	\N
108859	1726	687552101000	13217	6759	78	0	\N
108860	1726	687551099000	13217	6759	79	0	\N
108861	1726	687550096000	13217	6759	80	0	\N
108862	1726	687549094000	13217	6759	81	0	\N
108863	1726	687548091000	13217	6759	82	0	\N
108864	1726	687547089000	13217	6759	83	0	\N
108865	1726	687546086000	13217	6759	84	0	\N
108866	1726	687545084000	13217	6759	85	0	\N
108867	1726	687544081000	13217	6759	86	0	\N
108868	1726	687543079000	13217	6759	87	0	\N
108869	1726	687542076000	13217	6759	88	0	\N
108870	1726	687541074000	13217	6759	89	0	\N
108871	1726	687540072000	13217	6759	90	0	\N
108872	1726	687539070000	13217	6759	91	0	\N
108873	1726	687538067000	13217	6759	92	0	\N
108874	1726	687537065000	13217	6759	93	0	\N
108875	1726	687536062000	13217	6759	94	0	\N
108876	1726	687535060000	13217	6759	95	0	\N
108877	1726	687534057000	13217	6759	96	0	\N
108878	1726	687533055000	13217	6759	97	0	\N
108879	1726	687532053000	13217	6759	98	0	\N
108880	1726	687531050000	13217	6759	99	0	\N
108881	1726	687530048000	13217	6759	100	0	\N
108882	1726	687529045000	13217	6759	101	0	\N
108883	1726	687528043000	13217	6759	102	0	\N
108884	1726	687527040000	13217	6759	103	0	\N
108885	1726	687526038000	13217	6759	104	0	\N
108886	1726	687525035000	13217	6759	105	0	\N
108887	1726	687524033000	13217	6759	106	0	\N
108888	1726	687523030000	13217	6759	107	0	\N
108889	1726	687522028000	13217	6759	108	0	\N
108890	1726	687521025000	13217	6759	109	0	\N
108891	1726	687520023000	13217	6759	110	0	\N
108892	1726	687519020000	13217	6759	111	0	\N
108893	1726	687518018000	13217	6759	112	0	\N
108894	1726	687517015000	13217	6759	113	0	\N
108895	1726	687516013000	13217	6759	114	0	\N
108896	1726	687515010000	13217	6759	115	0	\N
108897	1726	687514008000	13217	6759	116	0	\N
108898	1726	687513005000	13217	6759	117	0	\N
108899	1726	687512003000	13217	6759	118	0	\N
108900	1726	687511001000	13217	6759	119	0	\N
108901	1726	687509998000	13217	6759	120	0	\N
108902	1726	687508996000	13217	6759	121	0	\N
108903	1726	687507993000	13217	6759	122	0	\N
108904	1726	687506991000	13217	6759	124	0	\N
108905	1726	687505988000	13217	6759	125	0	\N
108906	1397	1366062740000	13218	6813	0	0	\N
108907	1397	1366052739000	13218	6813	1	0	\N
108908	1726	687458872000	13218	6813	2	0	\N
108909	1726	687457869000	13218	6813	3	0	\N
108910	1726	687456867000	13218	6813	4	0	\N
108911	1726	687455864000	13218	6813	5	0	\N
108914	1397	1366042738000	13220	6814	0	0	\N
108915	1726	687458872000	13220	6814	1	0	\N
108916	1726	687457869000	13220	6814	2	0	\N
108917	1726	687456867000	13220	6814	3	0	\N
108918	1726	687455864000	13220	6814	4	0	\N
108919	1726	687454862000	13220	6814	5	0	\N
108920	1726	687453859000	13220	6814	6	0	\N
108931	1397	1366032737000	13223	6815	0	0	\N
108932	1397	1366032737000	13224	6815	0	0	\N
108933	1726	687452857000	13224	6815	1	0	\N
108934	1726	687451854000	13224	6815	2	0	\N
108935	1397	1366032737000	13225	6815	0	0	\N
108936	1726	687452857000	13225	6815	1	0	\N
108921	1397	1366042738000	13221	6814	0	0	7279
108922	1726	687458872000	13221	6814	1	0	5083
108923	1726	687457869000	13221	6814	2	0	5084
108924	1726	687456867000	13221	6814	3	0	5085
108925	1726	687455864000	13221	6814	4	0	5086
108927	1726	687453859000	13221	6814	6	0	5088
108928	1397	1366032737000	13222	6815	0	0	7280
108929	1726	687452857000	13222	6815	1	0	5089
108930	1726	687451854000	13222	6815	2	0	5090
108937	1726	687451854000	13225	6815	2	0	\N
108938	1673	13875532000000	13226	6778	0	0	\N
108939	1489	22647795400000	13226	6778	1	0	\N
108940	1673	11298692000000	13226	6778	2	0	\N
108941	1489	18072372600000	13226	6778	3	0	\N
108942	1673	11132052000000	13226	6778	4	0	\N
108943	1673	11126092000000	13226	6778	5	0	\N
108944	1397	1366592793000	13226	6778	6	0	\N
108945	1397	1366582792000	13226	6778	7	0	\N
108946	1397	1366572791000	13226	6778	8	0	\N
108947	1397	1366562790000	13226	6778	9	0	\N
108948	1397	1366552789000	13226	6778	10	0	\N
108949	1397	1366542788000	13226	6778	11	0	\N
108950	1489	14985060200000	13226	6778	12	0	\N
108951	1489	6383887000000	13226	6778	13	0	\N
108952	1593	16503869000000	13226	6778	14	0	\N
108953	1593	12260859000000	13226	6778	15	0	\N
108954	1593	9397849000000	13226	6778	16	0	\N
108955	1593	7029839000000	13226	6778	17	0	\N
108956	1397	1366532787000	13226	6778	18	0	\N
108957	1397	1366522786000	13226	6778	19	0	\N
108958	1397	1366512785000	13226	6778	20	0	\N
108959	1397	1366502784000	13226	6778	21	0	\N
108960	1397	1366492783000	13226	6778	22	0	\N
108961	1397	1366482782000	13226	6778	23	0	\N
108962	1397	1366472781000	13226	6778	24	0	\N
108963	1397	1366462780000	13226	6778	25	0	\N
108964	1397	1366452779000	13226	6778	26	0	\N
108965	1397	1366442778000	13226	6778	27	0	\N
108966	1397	1366432777000	13226	6778	28	0	\N
108967	1397	1366422776000	13226	6778	29	0	\N
108968	1397	1366412775000	13226	6778	30	0	\N
108969	1397	1366402774000	13226	6778	31	0	\N
108970	1397	1366392773000	13226	6778	32	0	\N
108971	1397	1366382772000	13226	6778	33	0	\N
108972	1397	1366372771000	13226	6778	34	0	\N
108973	1397	1366362770000	13226	6778	35	0	\N
108974	1397	1366352769000	13226	6778	36	0	\N
108975	1397	1366342768000	13226	6778	37	0	\N
108976	1397	1366332767000	13226	6778	38	0	\N
108977	1397	1366322766000	13226	6778	39	0	\N
108978	1397	1366312765000	13226	6778	40	0	\N
108979	1397	1366302764000	13226	6778	41	0	\N
108980	1397	1366292763000	13226	6778	42	0	\N
108981	1397	1366282762000	13226	6778	43	0	\N
108982	1397	1366272761000	13226	6778	44	0	\N
108983	1397	1366262760000	13226	6778	45	0	\N
108984	1397	1366252759000	13226	6778	46	0	\N
108985	1397	1366242758000	13226	6778	47	0	\N
108986	1397	1366232757000	13226	6778	48	0	\N
108987	1397	1366222756000	13226	6778	49	0	\N
108988	1397	1366212755000	13226	6778	50	0	\N
108989	1397	1366202754000	13226	6778	51	0	\N
108990	1397	1366192753000	13226	6778	52	0	\N
108991	1397	1366182752000	13226	6778	53	0	\N
108992	1397	1366172751000	13226	6778	54	0	\N
108993	1397	1366162750000	13226	6778	55	0	\N
108994	1397	1366152749000	13226	6778	56	0	\N
108995	1397	1366142748000	13226	6778	57	0	\N
108996	1397	1366132747000	13226	6778	58	0	\N
108997	1397	1366122746000	13226	6778	59	0	\N
108998	1397	1366112745000	13226	6778	60	0	\N
108999	1397	1366102744000	13226	6778	61	0	\N
109000	1397	1366092743000	13226	6778	62	0	\N
109001	1397	1366082742000	13226	6778	63	0	\N
109002	1397	1366072741000	13226	6778	64	0	\N
109003	1397	1366062740000	13226	6778	65	0	\N
109004	1397	1366052739000	13226	6778	66	0	\N
109005	1397	1366042738000	13226	6778	67	0	\N
109006	1397	1366032737000	13226	6778	68	0	\N
109007	1397	1366022736000	13228	6816	0	0	\N
109008	1397	1366012735000	13228	6816	1	0	\N
109009	1726	687450852000	13228	6816	2	0	\N
109010	1726	687449849000	13228	6816	3	0	\N
109011	1726	687448847000	13228	6816	4	0	\N
109012	1726	687447844000	13228	6816	5	0	\N
109013	1397	1366022736000	13229	6816	0	0	\N
109014	1397	1366012735000	13229	6816	1	0	\N
109015	1726	687450852000	13229	6816	2	0	\N
109016	1726	687449849000	13229	6816	3	0	\N
109017	1726	687448847000	13229	6816	4	0	\N
109018	1726	687447844000	13229	6816	5	0	\N
109027	1726	687446842000	13232	6817	0	0	\N
109028	1726	687445839000	13232	6817	1	0	\N
109029	1726	687446842000	13233	6817	0	0	\N
109030	1726	687445839000	13233	6817	1	0	\N
109031	1397	1366062740000	13234	6760	0	0	\N
109032	1397	1366052739000	13234	6760	1	0	\N
109033	1397	1366042738000	13234	6760	2	0	\N
109034	1397	1366032737000	13234	6760	3	0	\N
109035	1397	1366022736000	13234	6760	4	0	\N
109036	1397	1366012735000	13234	6760	5	0	\N
109037	1726	687504986000	13234	6760	6	0	\N
109038	1726	687503983000	13234	6760	7	0	\N
109039	1726	687502981000	13234	6760	8	0	\N
109040	1726	687501978000	13234	6760	9	0	\N
109041	1726	687500976000	13234	6760	10	0	\N
109042	1726	687499973000	13234	6760	11	0	\N
109043	1726	687498971000	13234	6760	12	0	\N
109044	1726	687497968000	13234	6760	13	0	\N
109045	1726	687496966000	13234	6760	14	0	\N
109046	1726	687495963000	13234	6760	15	0	\N
109047	1726	687494961000	13234	6760	16	0	\N
109048	1726	687493958000	13234	6760	17	0	\N
109049	1726	687492956000	13234	6760	18	0	\N
109050	1726	687491953000	13234	6760	19	0	\N
109051	1726	687490951000	13234	6760	20	0	\N
109052	1726	687489948000	13234	6760	21	0	\N
109053	1726	687488946000	13234	6760	22	0	\N
109054	1726	687487943000	13234	6760	23	0	\N
109055	1726	687486941000	13234	6760	24	0	\N
109056	1726	687485938000	13234	6760	25	0	\N
109057	1726	687484936000	13234	6760	26	0	\N
109058	1726	687483933000	13234	6760	27	0	\N
109059	1726	687482931000	13234	6760	28	0	\N
109060	1726	687481928000	13234	6760	29	0	\N
109061	1726	687480926000	13234	6760	30	0	\N
109062	1726	687479923000	13234	6760	31	0	\N
109063	1726	687478921000	13234	6760	32	0	\N
109064	1726	687477918000	13234	6760	33	0	\N
109065	1726	687476916000	13234	6760	34	0	\N
109066	1726	687475913000	13234	6760	35	0	\N
109067	1726	687474911000	13234	6760	36	0	\N
109068	1726	687473908000	13234	6760	37	0	\N
109069	1726	687472906000	13234	6760	38	0	\N
109070	1726	687471903000	13234	6760	39	0	\N
109071	1726	687470901000	13234	6760	40	0	\N
109072	1726	687469898000	13234	6760	41	0	\N
109021	1726	687450852000	13230	6817	2	0	5091
109022	1726	687449849000	13230	6817	3	0	5092
109023	1726	687448847000	13230	6817	4	0	5093
109024	1726	687447844000	13230	6817	5	0	5094
109025	1726	687446842000	13230	6817	6	0	5095
109073	1726	687468896000	13234	6760	42	0	\N
109074	1726	687467893000	13234	6760	43	0	\N
109075	1726	687466891000	13234	6760	44	0	\N
109076	1726	687465888000	13234	6760	45	0	\N
109077	1726	687464886000	13234	6760	46	0	\N
109078	1726	687463884000	13234	6760	47	0	\N
109079	1726	687462882000	13234	6760	48	0	\N
109080	1726	687461879000	13234	6760	49	0	\N
109081	1726	687460877000	13234	6760	50	0	\N
109082	1726	687459874000	13234	6760	51	0	\N
109083	1726	687458872000	13234	6760	52	0	\N
109084	1726	687457869000	13234	6760	53	0	\N
109085	1726	687456867000	13234	6760	54	0	\N
109086	1726	687455864000	13234	6760	55	0	\N
109087	1397	1366002734000	13235	6819	0	0	\N
109088	1397	1366002734000	13236	6818	0	0	\N
109089	1726	687444837000	13236	6818	1	0	\N
109090	1397	1366002734000	13237	6819	0	0	\N
109091	1726	687444837000	13237	6819	1	0	\N
109092	1726	687443834000	13237	6819	2	0	\N
109093	1397	1366002734000	13238	6819	0	0	\N
109094	1726	687444837000	13238	6819	1	0	\N
109095	1726	687443834000	13238	6819	2	0	\N
109097	1397	1366002734000	13240	6819	0	0	\N
109098	1726	687444837000	13240	6819	1	0	\N
109099	1726	687443834000	13240	6819	2	0	\N
109104	1593	16503869000000	13242	6787	0	0	\N
109105	1593	12260859000000	13242	6787	1	0	\N
109106	1593	9397849000000	13242	6787	2	0	\N
109107	1593	7029839000000	13242	6787	3	0	\N
109108	1397	1365982732000	13243	6821	0	0	\N
109109	1726	687441829000	13243	6821	1	0	\N
109110	1726	687440827000	13243	6821	2	0	\N
109111	1726	687439824000	13243	6821	3	0	\N
109116	1397	1365972731000	13245	6822	0	0	\N
109117	1726	687438822000	13245	6822	1	0	\N
109121	1397	1365962730000	13248	6823	0	0	\N
109122	1726	687438822000	13248	6823	1	0	\N
109123	1726	687437819000	13248	6823	2	0	\N
109124	1726	687436817000	13248	6823	3	0	\N
109125	1397	1365962730000	13249	6823	0	0	\N
109126	1726	687438822000	13249	6823	1	0	\N
109127	1726	687437819000	13249	6823	2	0	\N
109128	1726	687436817000	13249	6823	3	0	\N
109151	1397	1365882722000	13257	6829	0	0	\N
109152	606	71419722812962	13257	6829	1	0	\N
109163	1397	1365852719000	13261	6832	0	0	\N
109164	1397	1365842718000	13261	6832	1	0	\N
109165	1726	687417770000	13261	6832	2	0	\N
109166	1726	687416768000	13261	6832	3	0	\N
109167	1726	687415766000	13261	6832	4	0	\N
109175	1397	1365852719000	13264	6833	0	0	\N
109176	1397	1365842718000	13264	6833	1	0	\N
109177	1397	1365832717000	13264	6833	2	0	\N
109178	1726	687417770000	13264	6833	3	0	\N
109179	1726	687416768000	13264	6833	4	0	\N
109180	1726	687415766000	13264	6833	5	0	\N
109181	1726	687414764000	13264	6833	6	0	\N
109182	1726	687413761000	13264	6833	7	0	\N
109183	1397	1365852719000	13265	6833	0	0	\N
109184	1397	1365842718000	13265	6833	1	0	\N
109185	1726	687417770000	13265	6833	2	0	\N
109186	1726	687416768000	13265	6833	3	0	\N
109187	1726	687415766000	13265	6833	4	0	\N
109188	1726	687414764000	13265	6833	5	0	\N
109189	1726	687413761000	13265	6833	6	0	\N
109193	1397	1365812715000	13268	6835	0	0	\N
109194	1726	687411757000	13268	6835	1	0	\N
109195	1726	687410754000	13268	6835	2	0	\N
109196	1397	1365812715000	13269	6835	0	0	\N
109197	1726	687411757000	13269	6835	1	0	\N
109198	1726	687410754000	13269	6835	2	0	\N
109202	1397	1365812715000	13271	6835	0	0	\N
109203	1726	687411757000	13271	6835	1	0	\N
109204	1726	687410754000	13271	6835	2	0	\N
109207	1397	1365802714000	13273	6836	0	0	\N
109208	1726	687409752000	13273	6836	1	0	\N
109101	1726	687444837000	13241	6820	1	0	5097
109102	1726	687443834000	13241	6820	2	0	5098
109103	1726	687442832000	13241	6820	3	0	5099
109112	1397	1365982732000	13244	6821	0	0	7285
109113	1726	687441829000	13244	6821	1	0	5100
109115	1726	687439824000	13244	6821	3	0	5102
109118	1397	1365972731000	13246	6822	0	0	7286
109119	1397	1365962730000	13247	6823	0	0	7287
109120	1726	687438822000	13247	6823	1	0	5103
109129	1397	1365952729000	13250	6824	0	0	7288
109131	1726	687436817000	13250	6824	2	0	5105
109132	1726	687435815000	13250	6824	3	0	5106
109133	1397	1365942728000	13251	6825	0	0	7289
109134	1726	687434813000	13251	6825	1	0	5107
109136	1397	1365932727000	13252	6826	0	0	7290
109137	1726	687432808000	13252	6826	1	0	5109
109138	1726	687431805000	13252	6826	2	0	5110
109139	1397	1365922726000	13254	6827	0	0	7291
109140	1397	1365912725000	13254	6827	1	0	7292
109142	1726	687429800000	13254	6827	3	0	5112
109143	1726	687428798000	13254	6827	4	0	5113
109144	1726	687427795000	13254	6827	5	0	5114
109145	1397	1365902724000	13256	6828	0	0	7293
109146	1397	1365892723000	13256	6828	1	0	7294
109148	1726	687425790000	13256	6828	3	0	5116
109149	1726	687424788000	13256	6828	4	0	5117
109150	1726	687423785000	13256	6828	5	0	5118
109153	1397	1365882722000	13258	6829	0	0	7295
109155	1726	687422783000	13258	6829	2	0	5119
109156	1726	687421780000	13258	6829	3	0	5120
109157	1397	1365872721000	13259	6830	0	0	7296
109158	1397	1365862720000	13260	6831	0	0	7297
109159	606	71418712812962	13260	6831	1	0	10
109161	1726	687419775000	13260	6831	3	0	5122
109162	1726	687418773000	13260	6831	5	0	5123
109168	1397	1365852719000	13263	6833	0	0	7298
109169	1397	1365842718000	13263	6833	1	0	7299
109170	1726	687417770000	13263	6833	2	0	5124
109172	1726	687415766000	13263	6833	4	0	5126
109173	1726	687414764000	13263	6833	5	0	5127
109174	1726	687413761000	13263	6833	6	0	5128
109190	1397	1365832717000	13267	6834	0	0	7300
109192	1726	687412759000	13267	6834	2	0	5129
109199	1397	1365812715000	13270	6835	0	0	7302
109200	1726	687411757000	13270	6835	1	0	5130
109201	1726	687410754000	13270	6835	2	0	5131
109205	1397	1365802714000	13272	6836	0	0	7303
109209	1397	1365802714000	13274	6836	0	0	\N
109210	1726	687409752000	13274	6836	1	0	\N
109211	1397	1365802714000	13275	6836	0	0	\N
109212	1726	687409752000	13275	6836	1	0	\N
109228	1397	1365742708000	13280	6841	0	0	\N
109229	1397	1365742708000	13282	6841	0	0	\N
109230	1726	687398724000	13282	6841	1	0	\N
109231	1726	687397722000	13282	6841	2	0	\N
109244	1397	1365712705000	13286	6843	0	0	\N
109245	1726	687392709000	13286	6843	1	0	\N
109246	1726	687391707000	13286	6843	2	0	\N
109253	1397	1365692703000	13289	6845	0	0	\N
109254	1726	687388699000	13289	6845	1	0	\N
109255	1726	687387697000	13289	6845	2	0	\N
109259	1397	1365672701000	13291	6847	0	0	\N
109260	1397	1365662700000	13291	6847	1	0	\N
109261	1726	687384689000	13291	6847	2	0	\N
109262	1726	687383687000	13291	6847	3	0	\N
109263	1726	687382684000	13291	6847	4	0	\N
109264	1726	687381682000	13291	6847	5	0	\N
109271	1397	1365672701000	13293	6847	0	0	\N
109272	1397	1365662700000	13293	6847	1	0	\N
109273	1726	687384689000	13293	6847	2	0	\N
109274	1726	687383687000	13293	6847	3	0	\N
109275	1726	687382684000	13293	6847	4	0	\N
109276	1726	687381682000	13293	6847	5	0	\N
109296	1397	1365592693000	13298	6852	0	0	\N
109297	1726	687370655000	13298	6852	1	0	\N
109298	1726	687369653000	13298	6852	2	0	\N
109305	1860	43897977700000	13301	6830	0	0	\N
109306	1397	1365872721000	13301	6830	1	0	\N
109307	1397	1365862720000	13301	6830	2	0	\N
109308	1397	1365852719000	13301	6830	3	0	\N
109309	1397	1365842718000	13301	6830	4	0	\N
109310	1397	1365832717000	13301	6830	5	0	\N
109311	1397	1365822716000	13301	6830	6	0	\N
109312	1397	1365812715000	13301	6830	8	0	\N
109313	1397	1365802714000	13301	6830	9	0	\N
109314	1397	1365792713000	13301	6830	10	0	\N
109315	1397	1365782712000	13301	6830	11	0	\N
109316	1397	1365772711000	13301	6830	12	0	\N
109317	1397	1365762710000	13301	6830	13	0	\N
109318	1397	1365752709000	13301	6830	14	0	\N
109319	1397	1365742708000	13301	6830	15	0	\N
109320	606	71418712812962	13301	6830	16	0	\N
109321	606	71417702812962	13301	6830	17	0	\N
109322	1397	1365732707000	13301	6830	18	0	\N
109323	1397	1365722706000	13301	6830	19	0	\N
109324	1397	1365712705000	13301	6830	20	0	\N
109325	1397	1365702704000	13301	6830	21	0	\N
109326	1397	1365692703000	13301	6830	22	0	\N
109327	1397	1365682702000	13301	6830	23	0	\N
109328	1397	1365672701000	13301	6830	24	0	\N
109329	1397	1365662700000	13301	6830	25	0	\N
109330	1397	1365652699000	13301	6830	26	0	\N
109331	1397	1365642698000	13301	6830	27	0	\N
109332	1397	1365632697000	13301	6830	28	0	\N
109333	1397	1365622696000	13301	6830	29	0	\N
109334	1397	1365612695000	13301	6830	30	0	\N
109335	1397	1365602694000	13301	6830	31	0	\N
109336	1397	1365592693000	13301	6830	32	0	\N
109337	1397	1365582692000	13301	6830	33	0	\N
109338	1397	1365572691000	13301	6830	34	0	\N
109339	1397	1365562690000	13301	6830	35	0	\N
109340	1749	3465028000000	13301	6830	36	0	\N
109341	1726	687420778000	13301	6830	37	0	\N
109342	1726	687419775000	13301	6830	38	0	\N
109343	1726	687418773000	13301	6830	39	0	\N
109344	1726	687417770000	13301	6830	40	0	\N
109215	1726	687407747000	13276	6837	2	0	5134
109216	1397	1365782712000	13277	6838	0	0	7305
109217	1726	687406744000	13277	6838	1	0	5135
109218	1726	687405742000	13277	6838	2	0	5136
109219	1397	1365772711000	13279	6840	0	0	7306
109221	1397	1365752709000	13279	6840	2	0	7308
109222	1726	687404739000	13279	6840	3	0	5137
109223	1726	687403737000	13279	6840	4	0	5138
109224	1726	687402734000	13279	6840	5	0	5139
109225	1726	687401732000	13279	6840	6	0	5140
109227	1726	687399727000	13279	6840	8	0	5142
109232	1397	1365742708000	13283	6841	0	0	7309
109233	1726	687398724000	13283	6841	1	0	5143
109234	1726	687397722000	13283	6841	2	0	5144
109236	1397	1365722706000	13284	6842	1	0	7311
109237	1726	687396719000	13284	6842	2	0	5145
109238	1726	687395717000	13284	6842	3	0	5146
109239	1726	687394714000	13284	6842	4	0	5147
109240	1726	687393712000	13284	6842	5	0	5148
109242	1726	687392709000	13285	6843	1	0	5149
109243	1726	687391707000	13285	6843	2	0	5150
109247	1397	1365702704000	13287	6844	0	0	7313
109248	1726	687390704000	13287	6844	1	0	5151
109249	1726	687389702000	13287	6844	2	0	5152
109251	1726	687388699000	13288	6845	1	0	5153
109252	1726	687387697000	13288	6845	2	0	5154
109256	1397	1365682702000	13290	6846	0	0	7315
109257	1726	687386694000	13290	6846	1	0	5155
109265	1397	1365672701000	13292	6847	0	0	7316
109266	1397	1365662700000	13292	6847	1	0	7317
109267	1726	687384689000	13292	6847	2	0	5157
109268	1726	687383687000	13292	6847	3	0	5158
109269	1726	687382684000	13292	6847	4	0	5159
109277	1397	1365652699000	13294	6848	0	0	7318
109278	1397	1365642698000	13294	6848	1	0	7319
109279	1749	3465028000000	13294	6848	2	0	12
109280	1726	687380680000	13294	6848	3	0	5161
109281	1726	687379678000	13294	6848	4	0	5162
109283	1397	1365632697000	13295	6849	0	0	7320
109284	1726	687377673000	13295	6849	1	0	5164
109285	1726	687376670000	13295	6849	2	0	5165
109286	1397	1365622696000	13296	6850	0	0	7321
109288	1726	687375668000	13296	6850	2	0	5166
109289	1726	687374665000	13296	6850	3	0	5167
109290	1860	43897977700000	13297	6851	0	0	2
109291	1397	1365612695000	13297	6851	1	0	7322
109292	1397	1365602694000	13297	6851	2	0	7323
109294	1726	687372660000	13297	6851	4	0	5169
109295	1726	687371658000	13297	6851	5	0	5170
109299	1397	1365592693000	13299	6852	0	0	7324
109300	1726	687370655000	13299	6852	1	0	5171
109301	1726	687369653000	13299	6852	2	0	5172
109303	1726	687368650000	13300	6853	1	0	5173
109304	1726	687367648000	13300	6853	2	0	5174
109345	1726	687416768000	13301	6830	41	0	\N
109346	1726	687415766000	13301	6830	42	0	\N
109347	1726	687414764000	13301	6830	43	0	\N
109348	1726	687413761000	13301	6830	44	0	\N
109349	1726	687412759000	13301	6830	45	0	\N
109350	1726	687411757000	13301	6830	46	0	\N
109351	1726	687410754000	13301	6830	47	0	\N
109352	1726	687409752000	13301	6830	48	0	\N
109353	1726	687408749000	13301	6830	49	0	\N
109354	1726	687407747000	13301	6830	50	0	\N
109355	1726	687406744000	13301	6830	51	0	\N
109356	1726	687405742000	13301	6830	52	0	\N
109357	1726	687404739000	13301	6830	53	0	\N
109358	1726	687403737000	13301	6830	54	0	\N
109359	1726	687402734000	13301	6830	55	0	\N
109360	1726	687401732000	13301	6830	56	0	\N
109361	1726	687400729000	13301	6830	57	0	\N
109362	1726	687399727000	13301	6830	58	0	\N
109363	1726	687398724000	13301	6830	59	0	\N
109364	1726	687397722000	13301	6830	60	0	\N
109365	1726	687396719000	13301	6830	61	0	\N
109366	1726	687395717000	13301	6830	62	0	\N
109367	1726	687394714000	13301	6830	63	0	\N
109368	1726	687393712000	13301	6830	64	0	\N
109369	1726	687392709000	13301	6830	65	0	\N
109370	1726	687391707000	13301	6830	66	0	\N
109371	1726	687390704000	13301	6830	67	0	\N
109372	1726	687389702000	13301	6830	68	0	\N
109373	1726	687388699000	13301	6830	69	0	\N
109374	1726	687387697000	13301	6830	70	0	\N
109375	1726	687386694000	13301	6830	71	0	\N
109376	1726	687385692000	13301	6830	72	0	\N
109377	1726	687384689000	13301	6830	73	0	\N
109378	1726	687383687000	13301	6830	74	0	\N
109379	1726	687382684000	13301	6830	75	0	\N
109380	1726	687381682000	13301	6830	76	0	\N
109381	1726	687380680000	13301	6830	77	0	\N
109382	1726	687379678000	13301	6830	78	0	\N
109383	1726	687378675000	13301	6830	79	0	\N
109384	1726	687377673000	13301	6830	80	0	\N
109385	1726	687376670000	13301	6830	81	0	\N
109386	1726	687375668000	13301	6830	82	0	\N
109387	1726	687374665000	13301	6830	83	0	\N
109388	1726	687373663000	13301	6830	84	0	\N
109389	1726	687372660000	13301	6830	85	0	\N
109390	1726	687371658000	13301	6830	86	0	\N
109391	1726	687370655000	13301	6830	87	0	\N
109392	1726	687369653000	13301	6830	88	0	\N
109393	1726	687368650000	13301	6830	89	0	\N
109394	1726	687367648000	13301	6830	90	0	\N
109395	1726	687366645000	13301	6830	91	0	\N
109396	1726	687365643000	13301	6830	92	0	\N
109397	1726	687364640000	13301	6830	93	0	\N
109398	1726	687363638000	13301	6830	94	0	\N
109399	1397	1365572691000	13303	6855	0	0	\N
109400	1397	1365562690000	13303	6855	1	0	\N
109401	1397	1365552689000	13303	6855	2	0	\N
109402	1726	687366645000	13303	6855	3	0	\N
109403	1726	687365643000	13303	6855	4	0	\N
109404	1726	687364640000	13303	6855	5	0	\N
109405	1726	687363638000	13303	6855	6	0	\N
109406	1726	687362635000	13303	6855	7	0	\N
109407	1726	687361633000	13303	6855	8	0	\N
109417	1397	1365552689000	13305	6831	0	0	\N
109418	1397	1365542688000	13305	6831	1	0	\N
109419	1726	687362635000	13305	6831	2	0	\N
109420	1726	687361633000	13305	6831	3	0	\N
109421	1726	687360630000	13305	6831	4	0	\N
109422	1726	687359628000	13305	6831	5	0	\N
109426	1397	1365532687000	13307	6857	0	0	\N
109427	1726	687358625000	13307	6857	1	0	\N
109428	1726	687357623000	13307	6857	2	0	\N
109435	1397	1365522686000	13310	6858	0	0	\N
109436	1726	687356620000	13310	6858	1	0	\N
109437	1397	1365512685000	13311	6859	0	0	\N
109438	1726	687354615000	13311	6859	1	0	\N
109439	1726	687353613000	13311	6859	2	0	\N
109440	1397	1365512685000	13312	6859	0	0	\N
109441	1726	687354615000	13312	6859	1	0	\N
109442	1726	687353613000	13312	6859	2	0	\N
109443	1397	1365512685000	13313	6859	0	0	\N
109444	1726	687354615000	13313	6859	1	0	\N
109445	1726	687353613000	13313	6859	2	0	\N
109446	1397	1365512685000	13314	6859	0	0	\N
109447	1726	687354615000	13314	6859	1	0	\N
109448	1726	687353613000	13314	6859	2	0	\N
109449	1397	1365512685000	13315	6859	0	0	\N
109450	1726	687354615000	13315	6859	1	0	\N
109451	1726	687353613000	13315	6859	2	0	\N
109469	1397	1365572691000	13322	6855	0	0	\N
109470	1397	1365562690000	13322	6855	1	0	\N
109471	1397	1365552689000	13322	6855	2	0	\N
109472	1397	1365542688000	13322	6855	3	0	\N
109473	1397	1365532687000	13322	6855	4	0	\N
109474	1397	1365522686000	13322	6855	5	0	\N
109475	1397	1365512685000	13322	6855	6	0	\N
109476	1397	1365502684000	13322	6855	7	0	\N
109477	1397	1365492683000	13322	6855	8	0	\N
109478	1397	1365482682000	13322	6855	9	0	\N
109479	1397	1365472681000	13322	6855	10	0	\N
109480	1397	1365462680000	13322	6855	11	0	\N
109410	1397	1365552689000	13304	6855	2	0	7328
109411	1726	687366645000	13304	6855	3	0	5175
109412	1726	687365643000	13304	6855	4	0	5176
109413	1726	687364640000	13304	6855	5	0	5177
109414	1726	687363638000	13304	6855	6	0	5178
109416	1726	687361633000	13304	6855	8	0	5180
109423	1397	1365542688000	13306	6856	0	0	7329
109424	1726	687360630000	13306	6856	1	0	5181
109425	1726	687359628000	13306	6856	2	0	5182
109429	1397	1365532687000	13308	6857	0	0	7330
109431	1726	687357623000	13308	6857	2	0	5184
109432	1397	1365522686000	13309	6858	0	0	7331
109433	1726	687356620000	13309	6858	1	0	5185
109434	1726	687355618000	13309	6858	2	0	5186
109453	1726	687354615000	13316	6859	1	0	5187
109454	1726	687353613000	13316	6859	2	0	5188
109455	1397	1365502684000	13317	6860	0	0	7333
109456	1726	687352610000	13317	6860	1	0	5189
109457	1726	687351608000	13317	6860	2	0	5190
109459	1726	687350605000	13318	6861	1	0	5191
109460	1397	1365482682000	13319	6862	0	0	7335
109461	1726	687349603000	13319	6862	1	0	5192
109462	1726	687348600000	13319	6862	2	0	5193
109463	1397	1365472681000	13320	6863	0	0	7336
109465	1726	687346595000	13320	6863	2	0	5195
109466	1397	1365462680000	13321	6864	0	0	7337
109467	1726	687345593000	13321	6864	1	0	5196
109468	1726	687344590000	13321	6864	2	0	5197
109481	1397	1365452679000	13322	6855	12	0	\N
109482	1397	1365442678000	13322	6855	13	0	\N
109483	1397	1365432677000	13322	6855	14	0	\N
109484	1726	687366645000	13322	6855	15	0	\N
109485	1726	687365643000	13322	6855	16	0	\N
109486	1726	687364640000	13322	6855	17	0	\N
109487	1726	687363638000	13322	6855	18	0	\N
109488	1726	687362635000	13322	6855	19	0	\N
109489	1726	687361633000	13322	6855	20	0	\N
109490	1726	687360630000	13322	6855	21	0	\N
109491	1726	687359628000	13322	6855	22	0	\N
109492	1726	687358625000	13322	6855	23	0	\N
109493	1726	687357623000	13322	6855	24	0	\N
109494	1726	687356620000	13322	6855	25	0	\N
109495	1726	687355618000	13322	6855	26	0	\N
109496	1726	687354615000	13322	6855	27	0	\N
109497	1726	687353613000	13322	6855	28	0	\N
109498	1726	687352610000	13322	6855	29	0	\N
109499	1726	687351608000	13322	6855	30	0	\N
109500	1726	687350605000	13322	6855	31	0	\N
109501	1726	687349603000	13322	6855	32	0	\N
109502	1726	687348600000	13322	6855	33	0	\N
109503	1726	687347598000	13322	6855	34	0	\N
109504	1726	687346595000	13322	6855	35	0	\N
109505	1726	687345593000	13322	6855	36	0	\N
109506	1726	687344590000	13322	6855	37	0	\N
109507	1726	687343588000	13322	6855	38	0	\N
109508	1726	687342585000	13322	6855	39	0	\N
109509	1726	687341583000	13322	6855	40	0	\N
109510	1726	687340580000	13322	6855	41	0	\N
109511	1726	687339578000	13322	6855	42	0	\N
109512	1726	687338575000	13322	6855	43	0	\N
109533	1860	43897977700000	13327	6790	0	0	\N
109534	606	71419722812962	13327	6790	1	0	\N
109535	606	71418712812962	13327	6790	2	0	\N
109536	606	71417702812962	13327	6790	3	0	\N
109537	1397	1366402774000	13327	6790	4	0	\N
109538	1397	1366392773000	13327	6790	5	0	\N
109539	1397	1366382772000	13327	6790	6	0	\N
109540	1397	1366372771000	13327	6790	7	0	\N
109541	1397	1366362770000	13327	6790	8	0	\N
109542	1397	1366352769000	13327	6790	9	0	\N
109543	1397	1366342768000	13327	6790	10	0	\N
109544	1397	1366332767000	13327	6790	11	0	\N
109545	1397	1366322766000	13327	6790	12	0	\N
109546	1397	1366312765000	13327	6790	13	0	\N
109547	1397	1366302764000	13327	6790	14	0	\N
109548	1397	1366292763000	13327	6790	15	0	\N
109549	1397	1366282762000	13327	6790	16	0	\N
109550	1397	1366272761000	13327	6790	17	0	\N
109551	1397	1366262760000	13327	6790	18	0	\N
109552	1397	1366252759000	13327	6790	19	0	\N
109553	1397	1366242758000	13327	6790	20	0	\N
109554	1397	1366232757000	13327	6790	21	0	\N
109555	1397	1366222756000	13327	6790	22	0	\N
109556	1397	1366212755000	13327	6790	23	0	\N
109557	1397	1366202754000	13327	6790	24	0	\N
109558	1397	1366192753000	13327	6790	25	0	\N
109559	1397	1366182752000	13327	6790	26	0	\N
109560	1397	1366172751000	13327	6790	27	0	\N
109561	1397	1366162750000	13327	6790	28	0	\N
109562	1397	1366152749000	13327	6790	29	0	\N
109563	1397	1366142748000	13327	6790	30	0	\N
109564	1397	1366132747000	13327	6790	31	0	\N
109565	1397	1366122746000	13327	6790	32	0	\N
109566	1397	1366112745000	13327	6790	33	0	\N
109567	1397	1366102744000	13327	6790	34	0	\N
109568	1397	1366092743000	13327	6790	35	0	\N
109569	1397	1366082742000	13327	6790	36	0	\N
109570	1397	1366072741000	13327	6790	37	0	\N
109571	1397	1366062740000	13327	6790	38	0	\N
109572	1397	1366052739000	13327	6790	39	0	\N
109573	1397	1366042738000	13327	6790	40	0	\N
109574	1397	1366032737000	13327	6790	41	0	\N
109575	1397	1366022736000	13327	6790	42	0	\N
109576	1397	1366012735000	13327	6790	43	0	\N
109577	1397	1366002734000	13327	6790	44	0	\N
109578	1397	1365992733000	13327	6790	45	0	\N
109579	1397	1365982732000	13327	6790	46	0	\N
109580	1397	1365972731000	13327	6790	47	0	\N
109581	1397	1365962730000	13327	6790	48	0	\N
109582	1397	1365952729000	13327	6790	49	0	\N
109583	1397	1365942728000	13327	6790	50	0	\N
109584	1397	1365932727000	13327	6790	51	0	\N
109585	1397	1365922726000	13327	6790	52	0	\N
109586	1397	1365912725000	13327	6790	53	0	\N
109587	1397	1365902724000	13327	6790	54	0	\N
109588	1397	1365892723000	13327	6790	55	0	\N
109589	1397	1365882722000	13327	6790	56	0	\N
109590	1397	1365872721000	13327	6790	57	0	\N
109591	1397	1365862720000	13327	6790	58	0	\N
109592	1397	1365852719000	13327	6790	59	0	\N
109593	1397	1365842718000	13327	6790	60	0	\N
109594	1397	1365832717000	13327	6790	61	0	\N
109595	1397	1365822716000	13327	6790	62	0	\N
109596	1397	1365812715000	13327	6790	63	0	\N
109597	1397	1365802714000	13327	6790	64	0	\N
109598	1397	1365792713000	13327	6790	65	0	\N
109599	1397	1365782712000	13327	6790	66	0	\N
109600	1397	1365772711000	13327	6790	67	0	\N
109601	1397	1365762710000	13327	6790	68	0	\N
109602	1397	1365752709000	13327	6790	69	0	\N
109603	1397	1365742708000	13327	6790	70	0	\N
109604	1397	1365732707000	13327	6790	71	0	\N
109605	1397	1365722706000	13327	6790	72	0	\N
109606	1397	1365712705000	13327	6790	73	0	\N
109607	1397	1365702704000	13327	6790	74	0	\N
109608	1397	1365692703000	13327	6790	75	0	\N
109609	1397	1365682702000	13327	6790	76	0	\N
109610	1397	1365672701000	13327	6790	77	0	\N
109611	1397	1365662700000	13327	6790	78	0	\N
109612	1397	1365652699000	13327	6790	79	0	\N
109613	1397	1365642698000	13327	6790	80	0	\N
109614	1397	1365632697000	13327	6790	81	0	\N
109615	1397	1365622696000	13327	6790	82	0	\N
109616	1397	1365612695000	13327	6790	83	0	\N
109515	1397	1365432677000	13323	6865	2	0	7340
109516	1726	687343588000	13323	6865	3	0	5198
109517	1726	687342585000	13323	6865	4	0	5199
109518	1726	687341583000	13323	6865	5	0	5200
109519	1726	687340580000	13323	6865	6	0	5201
109521	1726	687338575000	13323	6865	8	0	5203
109522	1397	1365422676000	13324	6866	0	0	7341
109523	1726	687337573000	13324	6866	1	0	5204
109524	1726	687336570000	13324	6866	2	0	5205
109525	1397	1365412675000	13325	6867	0	0	7342
109527	1397	1365392673000	13326	6868	1	0	7344
109528	1726	687335568000	13326	6868	2	0	5206
109529	1726	687334565000	13326	6868	3	0	5207
109530	1726	687333563000	13326	6868	4	0	5208
109532	1726	687331558000	13326	6868	6	0	5210
109617	1397	1365602694000	13327	6790	84	0	\N
109618	1397	1365592693000	13327	6790	85	0	\N
109619	1397	1365582692000	13327	6790	86	0	\N
109620	1397	1365572691000	13327	6790	87	0	\N
109621	1397	1365562690000	13327	6790	88	0	\N
109622	1397	1365552689000	13327	6790	89	0	\N
109623	1397	1365542688000	13327	6790	90	0	\N
109624	1397	1365532687000	13327	6790	91	0	\N
109625	1397	1365522686000	13327	6790	92	0	\N
109626	1397	1365512685000	13327	6790	93	0	\N
109627	1397	1365502684000	13327	6790	94	0	\N
109628	1397	1365492683000	13327	6790	95	0	\N
109629	1397	1365482682000	13327	6790	96	0	\N
109630	1397	1365472681000	13327	6790	97	0	\N
109631	1397	1365462680000	13327	6790	98	0	\N
109632	1397	1365452679000	13327	6790	99	0	\N
109633	1397	1365442678000	13327	6790	100	0	\N
109634	1397	1365432677000	13327	6790	101	0	\N
109635	1397	1365422676000	13327	6790	102	0	\N
109636	1397	1365412675000	13327	6790	103	0	\N
109637	1397	1365402674000	13327	6790	104	0	\N
109638	1397	1365392673000	13327	6790	105	0	\N
109639	1749	3465028000000	13327	6790	106	0	\N
109640	1726	687524033000	13327	6790	107	0	\N
109641	1726	687523030000	13327	6790	108	0	\N
109642	1726	687522028000	13327	6790	109	0	\N
109643	1397	1365382672000	13328	6869	0	0	\N
109644	1726	687330555000	13328	6869	1	0	\N
109645	1726	687329553000	13328	6869	2	0	\N
109661	1397	1365352669000	13333	6872	0	0	\N
109662	1397	1365342668000	13333	6872	1	0	\N
109663	1726	684904543000	13333	6872	2	0	\N
109664	1726	684903540000	13333	6872	3	0	\N
109665	1750	4170000000	13333	6872	4	0	\N
109666	1726	684902539000	13333	6872	5	0	\N
109667	1726	683692539000	13333	6872	6	0	\N
109668	1726	683691537000	13333	6872	7	0	\N
109669	1726	683690534000	13333	6872	8	0	\N
109670	1726	683689533000	13333	6872	9	0	\N
109671	1397	1365352669000	13334	6872	0	0	\N
109672	1397	1365342668000	13334	6872	1	0	\N
109673	1726	684904543000	13334	6872	2	0	\N
109674	1726	684903540000	13334	6872	3	0	\N
109675	1750	4170000000	13334	6872	4	0	\N
109676	1726	684902539000	13334	6872	5	0	\N
109677	1726	683692539000	13334	6872	6	0	\N
109678	1726	683691537000	13334	6872	7	0	\N
109679	1726	683690534000	13334	6872	8	0	\N
109680	1726	683689533000	13334	6872	9	0	\N
109681	1397	1365352669000	13335	6872	0	0	\N
109682	1397	1365342668000	13335	6872	1	0	\N
109683	1726	684904543000	13335	6872	2	0	\N
109684	1726	684903540000	13335	6872	3	0	\N
109685	1750	4170000000	13335	6872	4	0	\N
109686	1726	684902539000	13335	6872	5	0	\N
109687	1726	683692539000	13335	6872	6	0	\N
109688	1726	683691537000	13335	6872	7	0	\N
109689	1726	683690534000	13335	6872	8	0	\N
109690	1726	683689533000	13335	6872	9	0	\N
109691	1397	1365352669000	13336	6872	0	0	\N
109692	1397	1365342668000	13336	6872	1	0	\N
109693	1726	684904543000	13336	6872	2	0	\N
109694	1726	684903540000	13336	6872	3	0	\N
109695	1750	4170000000	13336	6872	4	0	\N
109696	1726	684902539000	13336	6872	5	0	\N
109697	1726	683692539000	13336	6872	6	0	\N
109698	1726	683691537000	13336	6872	7	0	\N
109699	1726	683690534000	13336	6872	8	0	\N
109700	1726	683689533000	13336	6872	9	0	\N
109717	1397	1365322666000	13339	6874	0	0	\N
109718	1726	683685525000	13339	6874	1	0	\N
109719	1726	683684522000	13339	6874	2	0	\N
109720	1726	683683521000	13339	6874	3	0	\N
109729	1397	1365312665000	13341	6875	0	0	\N
109730	1397	1365302664000	13341	6875	2	0	\N
109731	1726	683682519000	13341	6875	3	0	\N
109732	1726	683681516000	13341	6875	4	0	\N
109733	1726	683680515000	13341	6875	5	0	\N
109734	1726	683679513000	13341	6875	6	0	\N
109735	1726	683678510000	13341	6875	7	0	\N
109736	1726	683677509000	13341	6875	8	0	\N
109745	1397	1365282662000	13344	6877	0	0	\N
109746	1726	683673501000	13344	6877	1	0	\N
109747	1726	683672498000	13344	6877	2	0	\N
109748	1726	683671497000	13344	6877	3	0	\N
109648	1726	687329553000	13329	6869	2	0	5212
109649	1397	1365372671000	13330	6870	0	0	7346
109650	1750	4171000000	13330	6870	1	0	29
109651	1726	687328550000	13330	6870	2	0	5213
109652	1726	687327548000	13330	6870	3	0	5214
109654	1726	687326546000	13331	6871	1	0	5215
109655	1726	687325545000	13331	6871	2	0	5216
109656	1726	686115545000	13331	6871	3	0	5217
109657	1726	684905545000	13331	6871	4	0	5218
109658	1397	1365352669000	13332	6872	0	0	7348
109660	1750	4170000000	13332	6872	2	0	30
109701	1397	1365332667000	13337	6873	0	0	7350
109702	1750	4169000000	13337	6873	1	0	31
109703	1726	684904543000	13337	6873	2	0	5219
109705	1726	684902539000	13337	6873	4	0	5221
109706	1726	683692539000	13337	6873	5	0	5222
109707	1726	683691537000	13337	6873	6	0	5223
109708	1726	683690534000	13337	6873	7	0	5224
109709	1726	683689533000	13337	6873	8	0	5225
109711	1726	683687528000	13337	6873	10	0	5227
109712	1726	683686527000	13337	6873	11	0	5228
109713	1397	1365322666000	13338	6874	0	0	7351
109714	1726	683685525000	13338	6874	1	0	5229
109715	1726	683684522000	13338	6874	2	0	5230
109721	1397	1365312665000	13340	6875	0	0	7352
109722	1397	1365302664000	13340	6875	2	0	7353
109723	1726	683682519000	13340	6875	3	0	5232
109724	1726	683681516000	13340	6875	4	0	5233
109726	1726	683679513000	13340	6875	6	0	5235
109727	1726	683678510000	13340	6875	7	0	5236
109728	1726	683677509000	13340	6875	8	0	5237
109737	1397	1365292663000	13342	6876	0	0	7354
109738	1726	683676507000	13342	6876	1	0	5238
109740	1726	683674503000	13342	6876	3	0	5240
109741	1397	1365282662000	13343	6877	0	0	7355
109742	1726	683673501000	13343	6877	1	0	5241
109743	1726	683672498000	13343	6877	2	0	5242
109744	1726	683671497000	13343	6877	3	0	5243
109750	1726	683669492000	13345	6878	1	0	5245
109751	1726	683668491000	13345	6878	2	0	5246
109752	1397	1365272661000	13346	6879	0	0	7356
109756	1397	1365262660000	13347	6880	0	0	\N
109757	1726	683664483000	13347	6880	1	0	\N
109758	1874	517000	13347	6880	2	0	\N
109759	1726	683867480000	13347	6880	3	0	\N
109760	1726	683866479000	13347	6880	4	0	\N
109766	1397	1365252659000	13349	6881	0	0	\N
109767	1726	683865477000	13349	6881	1	0	\N
109768	1726	683864474000	13349	6881	2	0	\N
109769	1726	683863473000	13349	6881	3	0	\N
109770	1397	1365252659000	13350	6881	0	0	\N
109771	1726	683865477000	13350	6881	1	0	\N
109772	1726	683864474000	13350	6881	2	0	\N
109773	1726	683863473000	13350	6881	3	0	\N
109782	1397	1365242658000	13353	6882	0	0	\N
109783	1726	683862471000	13353	6882	1	0	\N
109784	1726	683861468000	13353	6882	2	0	\N
109785	1397	1365232657000	13354	6883	0	0	\N
109786	1726	683859465000	13354	6883	1	0	\N
109787	1726	683858464000	13354	6883	2	0	\N
109791	1397	1365232657000	13356	6883	0	0	\N
109792	1726	683859465000	13356	6883	1	0	\N
109793	1726	683858464000	13356	6883	2	0	\N
109794	1397	1365232657000	13357	6883	0	0	\N
109795	1726	683860467000	13357	6883	1	0	\N
109796	1726	683859465000	13357	6883	2	0	\N
109797	1726	683858464000	13357	6883	3	0	\N
109798	1397	1365232657000	13358	6883	0	0	\N
109799	1726	683859465000	13358	6883	1	0	\N
109800	1397	1365232657000	13359	6883	0	0	\N
109801	1726	683860467000	13359	6883	1	0	\N
109802	1726	683859465000	13359	6883	2	0	\N
109807	1397	1365222656000	13361	6884	0	0	\N
109808	1726	683857462000	13361	6884	1	0	\N
109809	1726	683856461000	13361	6884	2	0	\N
109810	1924	1199000000	13361	6884	3	0	\N
109811	1860	43897977700000	13362	6743	0	0	\N
109812	1673	21606032000000	13362	6743	1	0	\N
109813	1673	16989952000000	13362	6743	2	0	\N
109814	1673	13875532000000	13362	6743	3	0	\N
109815	1489	22647795400000	13362	6743	4	0	\N
109816	1673	11298692000000	13362	6743	5	0	\N
109817	1489	18072372600000	13362	6743	6	0	\N
109818	1673	11132052000000	13362	6743	7	0	\N
109819	1673	11126092000000	13362	6743	8	0	\N
109820	1489	14985060200000	13362	6743	9	0	\N
109821	1489	6383887000000	13362	6743	10	0	\N
109822	1593	16503869000000	13362	6743	11	0	\N
109823	1593	12260859000000	13362	6743	12	0	\N
109824	1593	9397849000000	13362	6743	13	0	\N
109825	1593	7029839000000	13362	6743	14	0	\N
109826	606	71419722812962	13362	6743	15	0	\N
109827	606	71418712812962	13362	6743	16	0	\N
109828	606	71417702812962	13362	6743	17	0	\N
109829	1397	1367122846000	13362	6743	18	0	\N
109830	1397	1367112845000	13362	6743	19	0	\N
109831	1397	1367102844000	13362	6743	20	0	\N
109832	1397	1367092843000	13362	6743	21	0	\N
109833	1397	1367082842000	13362	6743	22	0	\N
109834	1397	1367072841000	13362	6743	23	0	\N
109835	1397	1367062840000	13362	6743	24	0	\N
109836	1397	1367052839000	13362	6743	25	0	\N
109837	1397	1367042838000	13362	6743	26	0	\N
109838	1397	1367032837000	13362	6743	27	0	\N
109839	1397	1367022836000	13362	6743	28	0	\N
109840	1397	1367012835000	13362	6743	29	0	\N
109841	1397	1367002834000	13362	6743	30	0	\N
109842	1397	1366992833000	13362	6743	31	0	\N
109843	1397	1366982832000	13362	6743	32	0	\N
109844	1397	1366972831000	13362	6743	33	0	\N
109845	1397	1366962830000	13362	6743	34	0	\N
109846	1397	1366952829000	13362	6743	35	0	\N
109847	1397	1366942828000	13362	6743	36	0	\N
109848	1397	1366932827000	13362	6743	37	0	\N
109849	1397	1366922826000	13362	6743	38	0	\N
109850	1397	1366912825000	13362	6743	39	0	\N
109851	1397	1366902824000	13362	6743	40	0	\N
109852	1397	1366892823000	13362	6743	41	0	\N
109853	1397	1366882822000	13362	6743	42	0	\N
109854	1397	1366872821000	13362	6743	43	0	\N
109855	1397	1366862820000	13362	6743	44	0	\N
109856	1397	1366852819000	13362	6743	45	0	\N
109857	1397	1366842818000	13362	6743	46	0	\N
109858	1397	1366832817000	13362	6743	47	0	\N
109859	1397	1366822816000	13362	6743	48	0	\N
109860	1397	1366812815000	13362	6743	49	0	\N
109861	1397	1366802814000	13362	6743	50	0	\N
109862	1397	1366792813000	13362	6743	51	0	\N
109863	1397	1366782812000	13362	6743	52	0	\N
109864	1397	1366772811000	13362	6743	53	0	\N
109865	1397	1366762810000	13362	6743	54	0	\N
109866	1397	1366752809000	13362	6743	55	0	\N
109867	1397	1366742808000	13362	6743	56	0	\N
109868	1397	1366732807000	13362	6743	57	0	\N
109869	1397	1366722806000	13362	6743	58	0	\N
109870	1397	1366712805000	13362	6743	59	0	\N
109871	1397	1366702804000	13362	6743	60	0	\N
109872	1397	1366692803000	13362	6743	61	0	\N
109873	1397	1366682802000	13362	6743	62	0	\N
109874	1397	1366672801000	13362	6743	63	0	\N
109875	1397	1366662800000	13362	6743	64	0	\N
109876	1397	1366652799000	13362	6743	65	0	\N
109877	1397	1366642798000	13362	6743	66	0	\N
109878	1397	1366632797000	13362	6743	67	0	\N
109879	1397	1366622796000	13362	6743	68	0	\N
109880	1397	1366612795000	13362	6743	69	0	\N
109881	1397	1366602794000	13362	6743	70	0	\N
109882	1397	1366592793000	13362	6743	71	0	\N
109883	1397	1366582792000	13362	6743	72	0	\N
109884	1397	1366572791000	13362	6743	73	0	\N
109885	1397	1366562790000	13362	6743	74	0	\N
109886	1397	1366552789000	13362	6743	75	0	\N
109887	1397	1366542788000	13362	6743	76	0	\N
109888	1397	1366532787000	13362	6743	77	0	\N
109755	1726	683665485000	13346	6879	3	0	5249
109761	1397	1365262660000	13348	6880	0	0	7357
109762	1726	683664483000	13348	6880	1	0	5250
109763	1874	517000	13348	6880	2	0	1
109764	1726	683867480000	13348	6880	3	0	5251
109774	1397	1365252659000	13351	6881	0	0	7358
109775	1397	1365242658000	13352	6882	0	0	7359
109776	1726	683865477000	13352	6882	1	0	5253
109777	1726	683864474000	13352	6882	2	0	5254
109778	1726	683863473000	13352	6882	3	0	5255
109780	1726	683861468000	13352	6882	5	0	5257
109781	1726	683860467000	13352	6882	6	0	5258
109788	1397	1365232657000	13355	6883	0	0	7360
109789	1726	683859465000	13355	6883	1	0	5259
109803	1397	1365222656000	13360	6884	0	0	7361
109804	1726	683857462000	13360	6884	1	0	5261
109805	1726	683856461000	13360	6884	2	0	5262
109806	1924	1199000000	13360	6884	3	0	1
109889	1397	1366522786000	13362	6743	78	0	\N
109890	1397	1366512785000	13362	6743	79	0	\N
109891	1397	1366502784000	13362	6743	80	0	\N
109892	1397	1366492783000	13362	6743	81	0	\N
109893	1397	1366482782000	13362	6743	82	0	\N
109894	1397	1366472781000	13362	6743	83	0	\N
109895	1397	1366462780000	13362	6743	84	0	\N
109896	1397	1366452779000	13362	6743	85	0	\N
109897	1397	1366442778000	13362	6743	86	0	\N
109898	1397	1366432777000	13362	6743	87	0	\N
109899	1397	1366422776000	13362	6743	88	0	\N
109900	1397	1366412775000	13362	6743	89	0	\N
109901	1397	1366402774000	13362	6743	90	0	\N
109902	1397	1366392773000	13362	6743	92	0	\N
109903	1397	1366382772000	13362	6743	93	0	\N
109904	1397	1366372771000	13362	6743	94	0	\N
109905	1397	1366362770000	13362	6743	95	0	\N
109906	1397	1366352769000	13362	6743	96	0	\N
109907	1397	1366342768000	13362	6743	97	0	\N
109908	1397	1366332767000	13362	6743	98	0	\N
109909	1397	1366322766000	13362	6743	99	0	\N
109910	1397	1366312765000	13362	6743	100	0	\N
109911	1397	1366302764000	13362	6743	101	0	\N
109912	1397	1366292763000	13362	6743	102	0	\N
109913	1397	1366282762000	13362	6743	103	0	\N
109914	1397	1366272761000	13362	6743	104	0	\N
109915	1397	1366262760000	13362	6743	105	0	\N
109916	1397	1366252759000	13362	6743	106	0	\N
109917	1397	1366242758000	13362	6743	107	0	\N
109918	1397	1366232757000	13362	6743	108	0	\N
109919	1397	1366222756000	13362	6743	109	0	\N
109920	1397	1366212755000	13362	6743	110	0	\N
109921	1397	1366202754000	13362	6743	111	0	\N
109922	1397	1366192753000	13362	6743	112	0	\N
109923	1397	1366182752000	13362	6743	113	0	\N
109924	1397	1366172751000	13362	6743	114	0	\N
109925	1397	1366162750000	13362	6743	115	0	\N
109926	1397	1366152749000	13362	6743	116	0	\N
109927	1397	1366142748000	13362	6743	117	0	\N
109928	1397	1366132747000	13362	6743	118	0	\N
109929	1397	1366122746000	13362	6743	119	0	\N
109930	1397	1366112745000	13362	6743	120	0	\N
109931	1397	1366102744000	13362	6743	121	0	\N
109932	1397	1366092743000	13362	6743	122	0	\N
109933	1397	1366082742000	13362	6743	123	0	\N
109934	1397	1366072741000	13362	6743	124	0	\N
109935	1397	1366062740000	13362	6743	125	0	\N
109946	1860	43897977700000	13366	6781	0	0	\N
109947	1593	16503869000000	13366	6781	1	0	\N
109948	1593	12260859000000	13366	6781	2	0	\N
109949	1593	9397849000000	13366	6781	3	0	\N
109950	1593	7029839000000	13366	6781	4	0	\N
109951	606	71419722812962	13366	6781	5	0	\N
109952	606	71418712812962	13366	6781	6	0	\N
109953	606	71417702812962	13366	6781	7	0	\N
109954	1750	4171000000	13366	6781	8	0	\N
109955	1749	3465028000000	13366	6781	9	0	\N
109956	1750	4170000000	13366	6781	10	0	\N
109957	1750	4169000000	13366	6781	11	0	\N
109958	1924	1199000000	13366	6781	12	0	\N
109959	1397	1365182652000	13367	6888	0	0	\N
109960	1397	1365172651000	13367	6888	1	0	\N
109961	1726	683848446000	13367	6888	2	0	\N
109962	1726	683847444000	13367	6888	3	0	\N
109963	1726	683846443000	13367	6888	4	0	\N
109964	1726	683845440000	13367	6888	5	0	\N
109965	1726	683844438000	13367	6888	6	0	\N
109981	1397	1365382672000	13370	6791	0	0	\N
109982	1397	1365372671000	13370	6791	1	0	\N
109983	1397	1365362670000	13370	6791	2	0	\N
109984	1397	1365352669000	13370	6791	4	0	\N
109985	1397	1365342668000	13370	6791	5	0	\N
109986	1397	1365332667000	13370	6791	6	0	\N
109987	1397	1365322666000	13370	6791	7	0	\N
109999	1397	1365142648000	13372	6890	0	0	\N
110000	1397	1365132647000	13372	6890	1	0	\N
110001	1397	1365122646000	13372	6890	2	0	\N
110006	1397	1365112645000	13374	6891	0	0	\N
110007	1726	683829410000	13374	6891	1	0	\N
110008	1726	683828407000	13374	6891	2	0	\N
110009	1726	683827405000	13374	6891	3	0	\N
110010	1397	1365112645000	13375	6891	0	0	\N
110011	1726	683829410000	13375	6891	1	0	\N
110012	1726	683828407000	13375	6891	2	0	\N
110013	1726	683827405000	13375	6891	3	0	\N
109938	1726	683855459000	13364	6886	1	0	5263
109939	1726	683854456000	13364	6886	2	0	5264
109940	1726	683853455000	13364	6886	3	0	5265
109941	1726	683852453000	13364	6886	4	0	5266
109942	1726	683851450000	13364	6886	5	0	5267
109944	1726	683850449000	13365	6887	1	0	5268
109945	1726	683849447000	13365	6887	2	0	5269
109966	1397	1365182652000	13368	6888	0	0	7365
109967	1397	1365172651000	13368	6888	1	0	7366
109968	1726	683848446000	13368	6888	2	0	5270
109970	1726	683846443000	13368	6888	4	0	5272
109971	1726	683845440000	13368	6888	5	0	5273
109972	1726	683844438000	13368	6888	6	0	5274
109973	1397	1365162650000	13369	6889	0	0	7367
109975	1726	683843437000	13369	6889	2	0	5275
109976	1726	683842434000	13369	6889	3	0	5276
109977	1726	683841432000	13369	6889	4	0	5277
109978	1726	683840431000	13369	6889	5	0	5278
109979	1726	683839428000	13369	6889	6	0	5279
109988	1397	1365142648000	13371	6890	0	0	7369
109989	1397	1365132647000	13371	6890	1	0	7370
109990	1397	1365122646000	13371	6890	2	0	7371
109991	1726	683837425000	13371	6890	3	0	5281
109992	1726	683836422000	13371	6890	4	0	5282
109994	1726	683834419000	13371	6890	6	0	5284
109995	1726	683833417000	13371	6890	7	0	5285
109996	1726	683832416000	13371	6890	8	0	5286
109997	1726	683831413000	13371	6890	9	0	5287
110002	1397	1365112645000	13373	6891	0	0	7372
110003	1726	683829410000	13373	6891	1	0	5289
110004	1726	683828407000	13373	6891	2	0	5290
110005	1726	683827405000	13373	6891	3	0	5291
110014	1397	1365102644000	13376	6892	0	0	7373
110016	1726	683825401000	13376	6892	2	0	5293
110017	1726	683824399000	13376	6892	3	0	5294
110018	1397	1365092643000	13377	6893	0	0	7374
110019	1726	683823398000	13377	6893	1	0	5295
110020	1726	683822395000	13377	6893	2	0	5296
110022	1397	1365082642000	13378	6894	0	0	7375
110023	1942	198000000	13378	6894	1	0	1
110024	1726	683820392000	13378	6894	2	0	5298
110027	1397	1365072641000	13379	6895	0	0	\N
110028	1726	683817386000	13379	6895	1	0	\N
110029	1726	683816383000	13379	6895	2	0	\N
110030	1726	683815381000	13379	6895	3	0	\N
110047	1397	1365032637000	13382	6897	0	0	\N
110048	1397	1365022636000	13382	6897	1	0	\N
110049	1726	682596365000	13382	6897	2	0	\N
110050	1726	682595362000	13382	6897	3	0	\N
110051	1726	682594360000	13382	6897	4	0	\N
110052	1726	682593359000	13382	6897	5	0	\N
110053	1726	682592356000	13382	6897	6	0	\N
110054	1726	682591354000	13382	6897	7	0	\N
110063	1397	1365032637000	13384	6897	0	0	\N
110064	1397	1365022636000	13384	6897	1	0	\N
110065	1726	682596365000	13384	6897	2	0	\N
110066	1726	682595362000	13384	6897	3	0	\N
110067	1726	682594360000	13384	6897	4	0	\N
110068	1726	682593359000	13384	6897	5	0	\N
110069	1726	682592356000	13384	6897	6	0	\N
110070	1726	682591354000	13384	6897	7	0	\N
110077	1397	1365002634000	13387	6899	0	0	\N
110078	1726	682588350000	13387	6899	1	0	\N
110079	1726	682587348000	13387	6899	2	0	\N
110083	1397	1364982632000	13390	6901	0	0	\N
110084	1726	682584344000	13390	6901	1	0	\N
110085	1726	682583342000	13390	6901	2	0	\N
110086	1397	1364982632000	13391	6901	0	0	\N
110087	1726	682584344000	13391	6901	1	0	\N
110088	1726	682583342000	13391	6901	2	0	\N
110092	1397	1364972631000	13393	6902	0	0	\N
110093	1397	1364962630000	13393	6902	1	0	\N
110094	1726	682582339000	13393	6902	2	0	\N
110095	1726	682581338000	13393	6902	3	0	\N
110096	1726	682580336000	13393	6902	4	0	\N
110097	1726	682579335000	13393	6902	5	0	\N
110098	1726	682578333000	13393	6902	6	0	\N
110106	1397	1364972631000	13395	6902	0	0	\N
110107	1397	1364962630000	13395	6902	1	0	\N
110108	1726	682582339000	13395	6902	2	0	\N
110109	1726	682581338000	13395	6902	3	0	\N
110110	1726	682580336000	13395	6902	4	0	\N
110111	1726	682579335000	13395	6902	5	0	\N
110112	1726	682578333000	13395	6902	6	0	\N
110120	1397	1364952629000	13397	6903	0	0	\N
110121	1397	1364942628000	13397	6903	1	0	\N
110122	1726	682577332000	13397	6903	2	0	\N
110123	1726	682576329000	13397	6903	3	0	\N
110124	1726	682575327000	13397	6903	4	0	\N
110125	1726	682574326000	13397	6903	5	0	\N
110126	1726	682573324000	13397	6903	6	0	\N
110127	1397	1364952629000	13398	6903	0	0	\N
110128	1397	1364942628000	13398	6903	1	0	\N
110129	1726	682577332000	13398	6903	2	0	\N
110130	1726	682576329000	13398	6903	3	0	\N
110131	1726	682575327000	13398	6903	4	0	\N
110132	1726	682574326000	13398	6903	5	0	\N
110133	1726	682573324000	13398	6903	6	0	\N
110134	1726	682572323000	13398	6903	7	0	\N
110135	1397	1364932627000	13399	6904	0	0	\N
110136	1397	1364922626000	13399	6904	1	0	\N
110137	1726	682572323000	13399	6904	2	0	\N
110138	1726	682571321000	13399	6904	3	0	\N
110139	1726	682570320000	13399	6904	4	0	\N
110140	1726	682569317000	13399	6904	5	0	\N
110141	1726	682568315000	13399	6904	6	0	\N
110155	1397	1364912625000	13402	6905	0	0	\N
110156	1397	1364902624000	13402	6905	1	0	\N
110157	1726	682567314000	13402	6905	2	0	\N
110158	1726	682566312000	13402	6905	3	0	\N
110159	1726	682565311000	13402	6905	4	0	\N
110160	1726	682564309000	13402	6905	5	0	\N
110031	1397	1365072641000	13380	6895	0	0	7376
110032	1397	1365062640000	13381	6896	0	0	7377
110033	1397	1365052639000	13381	6896	1	0	7378
110034	1397	1365042638000	13381	6896	2	0	7379
110035	1726	683817386000	13381	6896	3	0	5301
110037	1726	683815381000	13381	6896	5	0	5303
110038	1726	683814380000	13381	6896	6	0	5304
110039	1726	683813377000	13381	6896	7	0	5305
110040	1726	683812375000	13381	6896	8	0	5306
110041	1726	683811374000	13381	6896	9	0	5307
110043	1726	682600372000	13381	6896	11	0	5309
110044	1726	682599371000	13381	6896	12	0	5310
110045	1726	682598368000	13381	6896	13	0	5311
110046	1726	682597366000	13381	6896	14	0	5312
110056	1397	1365022636000	13383	6897	1	0	7381
110057	1726	682596365000	13383	6897	2	0	5313
110058	1726	682595362000	13383	6897	3	0	5314
110059	1726	682594360000	13383	6897	4	0	5315
110060	1726	682593359000	13383	6897	5	0	5316
110062	1726	682591354000	13383	6897	7	0	5318
110071	1397	1365012635000	13385	6898	0	0	7382
110072	1726	682590353000	13385	6898	1	0	5319
110073	1726	682589351000	13385	6898	2	0	5320
110074	1397	1365002634000	13386	6899	0	0	7383
110076	1726	682587348000	13386	6899	2	0	5322
110080	1397	1364992633000	13388	6900	0	0	7384
110081	1726	682586347000	13388	6900	1	0	5323
110082	1726	682585345000	13388	6900	2	0	5324
110090	1726	682584344000	13392	6901	1	0	5325
110091	1726	682583342000	13392	6901	2	0	5326
110099	1397	1364972631000	13394	6902	0	0	7386
110100	1397	1364962630000	13394	6902	1	0	7387
110101	1726	682582339000	13394	6902	2	0	5327
110103	1726	682580336000	13394	6902	4	0	5329
110104	1726	682579335000	13394	6902	5	0	5330
110105	1726	682578333000	13394	6902	6	0	5331
110113	1397	1364952629000	13396	6903	0	0	7388
110114	1397	1364942628000	13396	6903	1	0	7389
110116	1726	682576329000	13396	6903	3	0	5333
110117	1726	682575327000	13396	6903	4	0	5334
110118	1726	682574326000	13396	6903	5	0	5335
110119	1726	682573324000	13396	6903	6	0	5336
110143	1397	1364922626000	13400	6904	1	0	7391
110144	1726	682572323000	13400	6904	2	0	5337
110145	1726	682571321000	13400	6904	3	0	5338
110146	1726	682570320000	13400	6904	4	0	5339
110147	1726	682569317000	13400	6904	5	0	5340
110149	1397	1364912625000	13401	6905	0	0	7392
110150	1397	1364902624000	13401	6905	1	0	7393
110151	1726	682567314000	13401	6905	2	0	5342
110152	1726	682566312000	13401	6905	3	0	5343
110153	1726	682565311000	13401	6905	4	0	5344
110161	1397	1364912625000	13403	6905	0	0	\N
110162	1397	1364902624000	13403	6905	1	0	\N
110163	1726	682567314000	13403	6905	2	0	\N
110164	1397	1364912625000	13404	6905	0	0	\N
110165	1397	1364902624000	13404	6905	1	0	\N
110166	1726	682567314000	13404	6905	2	0	\N
110167	1726	682566312000	13404	6905	3	0	\N
110168	1726	682565311000	13404	6905	4	0	\N
110169	1726	682564309000	13404	6905	5	0	\N
110170	1397	1364912625000	13405	6905	0	0	\N
110171	1397	1364902624000	13405	6905	1	0	\N
110172	1397	1364892623000	13406	6906	0	0	\N
110177	1397	1364892623000	13408	6906	0	0	\N
110178	1726	682563308000	13408	6906	1	0	\N
110179	1726	682562305000	13408	6906	2	0	\N
110180	1726	682561303000	13408	6906	3	0	\N
110199	1397	1364832617000	13413	6910	0	0	\N
110200	1397	1364822616000	13413	6910	1	0	\N
110233	1397	1364732607000	13422	6916	0	0	\N
110234	1397	1364722606000	13422	6916	1	0	\N
110235	1726	682530255000	13422	6916	2	0	\N
110236	1726	682529252000	13422	6916	3	0	\N
110237	1726	682528250000	13422	6916	4	0	\N
110238	1726	682527249000	13422	6916	5	0	\N
110239	1726	682526246000	13422	6916	6	0	\N
110240	1726	682525244000	13422	6916	7	0	\N
110241	1926	1199000000	13422	6916	8	0	\N
110242	1397	1364732607000	13423	6916	0	0	\N
110243	1397	1364722606000	13423	6916	1	0	\N
110244	1726	682530255000	13423	6916	2	0	\N
110245	1726	682529252000	13423	6916	3	0	\N
110246	1726	682528250000	13423	6916	4	0	\N
110247	1726	682527249000	13423	6916	5	0	\N
110248	1726	682526246000	13423	6916	6	0	\N
110249	1726	682525244000	13423	6916	7	0	\N
110250	1926	1199000000	13423	6916	8	0	\N
110261	1397	1364702604000	13425	6918	0	0	\N
110262	1726	682521237000	13425	6918	1	0	\N
110263	1726	682520234000	13425	6918	2	0	\N
110264	1726	682519232000	13425	6918	3	0	\N
110265	1397	1364702604000	13426	6918	0	0	\N
110270	1397	1364702604000	13428	6918	0	0	\N
110275	1397	1364692603000	13430	6919	0	0	\N
110276	1726	682518231000	13430	6919	1	0	\N
110277	1726	682517228000	13430	6919	2	0	\N
110278	1726	682516226000	13430	6919	3	0	\N
110175	1726	682562305000	13407	6906	2	0	5347
110176	1726	682561303000	13407	6906	3	0	5348
110181	1397	1364882622000	13409	6907	0	0	7395
110182	1397	1364872621000	13409	6907	1	0	7396
110183	1726	682560302000	13409	6907	2	0	5349
110185	1726	682558299000	13409	6907	4	0	5351
110186	1726	682557296000	13409	6907	5	0	5352
110187	1726	682556294000	13409	6907	6	0	5353
110188	1569	834000000	13409	6907	7	0	2
110189	1397	1364862620000	13411	6908	0	0	7397
110191	1726	682554290000	13411	6908	2	0	5355
110192	1726	682553288000	13411	6908	3	0	5356
110193	1397	1364852619000	13412	6909	0	0	7398
110194	1397	1364842618000	13412	6909	1	0	7399
110196	1726	682551285000	13412	6909	3	0	5358
110197	1726	682550284000	13412	6909	4	0	5359
110198	1726	682549282000	13412	6909	5	0	5360
110201	1397	1364832617000	13414	6910	0	0	7400
110202	1397	1364822616000	13414	6910	1	0	7401
110204	1726	682547279000	13414	6910	3	0	5362
110205	1726	682546278000	13414	6910	4	0	5363
110206	1397	1364812615000	13415	6911	0	0	7402
110207	1397	1364802614000	13415	6911	1	0	7403
110208	1397	1364792613000	13416	6912	0	0	7404
110210	1726	682545276000	13416	6912	2	0	5364
110211	1726	682544275000	13416	6912	3	0	5365
110212	1726	682543273000	13416	6912	4	0	5366
110213	1726	682542272000	13416	6912	5	0	5367
110215	1726	682540269000	13416	6912	7	0	5369
110216	1726	682539267000	13416	6912	8	0	5370
110217	1726	682538266000	13416	6912	9	0	5371
110218	1397	1364772611000	13418	6913	0	0	7406
110219	1726	682537264000	13418	6913	1	0	5372
110221	1397	1364762610000	13419	6914	0	0	7407
110222	1726	682535261000	13419	6914	1	0	5374
110223	1726	682534260000	13419	6914	2	0	5375
110224	1397	1364752609000	13420	6915	0	0	7408
110225	1397	1364742608000	13420	6915	1	0	7409
110227	1726	682533259000	13420	6915	3	0	5376
110228	1726	682532258000	13420	6915	4	0	5377
110229	1726	682531256000	13420	6915	5	0	5378
110230	1397	1364732607000	13421	6916	0	0	7410
110232	1926	1199000000	13421	6916	2	0	1
110251	1397	1364712605000	13424	6917	0	0	7412
110252	1726	682530255000	13424	6917	1	0	5379
110253	1726	682529252000	13424	6917	2	0	5380
110254	1726	682528250000	13424	6917	3	0	5381
110256	1726	682526246000	13424	6917	5	0	5383
110257	1726	682525244000	13424	6917	6	0	5384
110258	1726	682524243000	13424	6917	7	0	5385
110259	1726	682523240000	13424	6917	8	0	5386
110260	1726	682522238000	13424	6917	9	0	5387
110267	1726	682521237000	13427	6918	1	0	5388
110268	1726	682520234000	13427	6918	2	0	5389
110269	1726	682519232000	13427	6918	3	0	5390
110271	1397	1364692603000	13429	6919	0	0	7414
110273	1726	682517228000	13429	6919	2	0	5392
110274	1726	682516226000	13429	6919	3	0	5393
110279	1397	1364682602000	13431	6920	0	0	7415
110280	1726	682515225000	13431	6920	1	0	5394
110281	1726	682514223000	13431	6920	2	0	5395
110283	1397	1364662600000	13432	6921	1	0	7417
110284	1397	1364652599000	13432	6921	2	0	7418
110285	1726	682513222000	13432	6921	3	0	5396
110286	1726	682512220000	13432	6921	4	0	5397
110287	1726	682511217000	13432	6921	5	0	5398
110289	1726	682509214000	13432	6921	7	0	5400
110290	1726	682508211000	13432	6921	8	0	5401
110291	1726	682507210000	13432	6921	9	0	5402
110292	1726	682506208000	13432	6921	10	0	5403
110294	1397	1364642598000	13433	6922	0	0	7419
110295	1726	682504204000	13433	6922	1	0	5405
110296	1726	682503202000	13433	6922	2	0	5406
110302	1397	1364632597000	13435	6923	0	0	\N
110303	1726	682501198000	13435	6923	1	0	\N
110304	1726	682500195000	13435	6923	2	0	\N
110305	1726	682499193000	13435	6923	3	0	\N
110306	1397	1364622596000	13436	6924	0	0	\N
110311	1397	1364622596000	13438	6924	0	0	\N
110312	1397	1364622596000	13439	6924	0	0	\N
110313	1726	682498192000	13439	6924	1	0	\N
110314	1726	682497189000	13439	6924	2	0	\N
110315	1726	682496187000	13439	6924	3	0	\N
110332	1397	1364562590000	13443	6927	0	0	\N
110333	1726	682484165000	13443	6927	1	0	\N
110334	1726	682483163000	13443	6927	2	0	\N
110335	1726	682482160000	13443	6927	3	0	\N
110336	1726	682481159000	13443	6927	4	0	\N
110337	1726	682480157000	13443	6927	5	0	\N
110348	1397	1364552589000	13446	6928	0	0	\N
110349	1726	682484165000	13446	6928	1	0	\N
110350	1726	682483163000	13446	6928	2	0	\N
110351	1726	682482160000	13446	6928	4	0	\N
110352	1726	682481159000	13446	6928	5	0	\N
110353	1726	682480157000	13446	6928	6	0	\N
110354	1726	682479154000	13446	6928	7	0	\N
110355	1726	682478153000	13446	6928	8	0	\N
110356	1726	682477151000	13446	6928	9	0	\N
110357	1397	1364552589000	13447	6928	0	0	\N
110358	1726	682484165000	13447	6928	1	0	\N
110359	1726	682483163000	13447	6928	2	0	\N
110360	1726	682482160000	13447	6928	4	0	\N
110361	1726	682481159000	13447	6928	5	0	\N
110362	1726	682480157000	13447	6928	6	0	\N
110363	1726	682479154000	13447	6928	7	0	\N
110364	1726	682478153000	13447	6928	8	0	\N
110365	1726	682477151000	13447	6928	9	0	\N
110366	1726	682484165000	13448	6928	0	0	\N
110367	1726	682483163000	13448	6928	1	0	\N
110368	1726	682482160000	13448	6928	2	0	\N
110369	1726	682481159000	13448	6928	4	0	\N
110370	1726	682480157000	13448	6928	5	0	\N
110371	1726	682479154000	13448	6928	6	0	\N
110372	1726	682478153000	13448	6928	7	0	\N
110373	1726	682477151000	13448	6928	8	0	\N
110377	1397	1364542588000	13450	6929	0	0	\N
110378	1726	682476148000	13451	6929	0	0	\N
110379	1726	682475147000	13451	6929	1	0	\N
110380	1726	682474145000	13451	6929	2	0	\N
110386	1397	1364542588000	13453	6930	0	0	\N
110387	1397	1364532587000	13453	6930	1	0	\N
110388	1726	682473142000	13453	6930	2	0	\N
110389	1726	682472141000	13453	6930	3	0	\N
110390	1726	682471139000	13453	6930	4	0	\N
110391	1397	1364542588000	13454	6930	0	0	\N
110392	1726	682473142000	13454	6930	1	0	\N
110393	1726	682472141000	13454	6930	2	0	\N
110394	1726	682471139000	13454	6930	3	0	\N
110406	1397	1364512585000	13458	6933	0	0	\N
110407	1397	1364502584000	13458	6933	1	0	\N
110408	1726	682468135000	13458	6933	2	0	\N
110415	1397	1364482582000	13463	6935	0	0	\N
110416	1726	682460123000	13463	6935	1	0	\N
110417	1726	682459121000	13463	6935	2	0	\N
110421	1397	1364472581000	13465	6936	0	0	\N
110422	1726	682458120000	13465	6936	1	0	\N
110423	1726	682457118000	13465	6936	2	0	\N
110424	1860	43897977700000	13466	6753	0	0	\N
110425	1397	1366492783000	13466	6753	1	0	\N
110426	1397	1366482782000	13466	6753	2	0	\N
110427	1397	1366472781000	13466	6753	3	0	\N
110428	1397	1366462780000	13466	6753	4	0	\N
110429	1397	1366452779000	13466	6753	5	0	\N
110430	1673	11132052000000	13466	6753	6	0	\N
110431	1673	11126092000000	13466	6753	7	0	\N
110432	1593	16503869000000	13466	6753	8	0	\N
110299	1726	682501198000	13434	6923	1	0	5408
110300	1726	682500195000	13434	6923	2	0	5409
110301	1726	682499193000	13434	6923	3	0	5410
110307	1397	1364622596000	13437	6924	0	0	7421
110308	1726	682498192000	13437	6924	1	0	5411
110310	1726	682496187000	13437	6924	3	0	5413
110316	1397	1364612595000	13441	6925	0	0	7422
110317	1397	1364602594000	13441	6925	1	0	7423
110318	1397	1364592593000	13441	6925	2	0	7424
110319	1397	1364582592000	13441	6925	3	0	7425
110321	1726	682494184000	13441	6925	5	0	5415
110322	1726	682493183000	13441	6925	6	0	5416
110323	1726	682492181000	13441	6925	7	0	5417
110324	1726	682491178000	13441	6925	8	0	5418
110326	1726	682489175000	13441	6925	10	0	5420
110327	1726	682488172000	13441	6925	11	0	5421
110328	1726	682487171000	13441	6925	12	0	5422
110329	1726	682486169000	13441	6925	13	0	5423
110330	1726	682485166000	13441	6925	14	0	5424
110338	1397	1364562590000	13444	6927	0	0	7427
110339	1397	1364552589000	13445	6928	0	0	7428
110340	1726	682484165000	13445	6928	1	0	5425
110341	1726	682483163000	13445	6928	2	0	5426
110342	1726	682482160000	13445	6928	4	0	5427
110344	1726	682480157000	13445	6928	6	0	5429
110345	1726	682479154000	13445	6928	7	0	5430
110346	1726	682478153000	13445	6928	8	0	5431
110347	1726	682477151000	13445	6928	9	0	5432
110375	1726	682475147000	13449	6929	1	0	5434
110376	1726	682474145000	13449	6929	2	0	5435
110381	1397	1364542588000	13452	6930	0	0	7429
110382	1397	1364532587000	13452	6930	1	0	7430
110383	1726	682473142000	13452	6930	2	0	5436
110385	1726	682471139000	13452	6930	4	0	5438
110395	1397	1364522586000	13455	6931	0	0	7431
110396	1726	682470138000	13455	6931	1	0	5439
110397	1726	682469136000	13455	6931	2	0	5440
110398	1397	1364512585000	13457	6933	0	0	7432
110400	1726	682468135000	13457	6933	2	0	5441
110401	1726	682467133000	13457	6933	3	0	5442
110402	1726	682466132000	13457	6933	4	0	5443
110403	1726	682465130000	13457	6933	5	0	5444
110405	1726	682463127000	13457	6933	7	0	5446
110409	1397	1364492583000	13461	6934	0	0	7434
110410	1726	682462126000	13461	6934	1	0	5447
110411	1726	682461124000	13461	6934	2	0	5448
110412	1397	1364482582000	13462	6935	0	0	7435
110414	1726	682459121000	13462	6935	2	0	5450
110418	1397	1364472581000	13464	6936	0	0	7436
110419	1726	682458120000	13464	6936	1	0	5451
110420	1726	682457118000	13464	6936	2	0	5452
110433	1593	12260859000000	13466	6753	9	0	\N
110434	1593	9397849000000	13466	6753	10	0	\N
110435	1593	7029839000000	13466	6753	11	0	\N
110436	606	71419722812962	13466	6753	12	0	\N
110437	606	71418712812962	13466	6753	13	0	\N
110438	606	71417702812962	13466	6753	14	0	\N
110439	1397	1366442778000	13466	6753	15	0	\N
110440	1397	1366432777000	13466	6753	16	0	\N
110441	1397	1366422776000	13466	6753	17	0	\N
110442	1397	1366412775000	13466	6753	18	0	\N
110443	1397	1366402774000	13466	6753	19	0	\N
110444	1397	1366392773000	13466	6753	20	0	\N
110445	1397	1366382772000	13466	6753	21	0	\N
110446	1397	1366372771000	13466	6753	22	0	\N
110447	1397	1366362770000	13466	6753	23	0	\N
110448	1397	1366352769000	13466	6753	24	0	\N
110449	1397	1366342768000	13466	6753	25	0	\N
110450	1397	1366332767000	13466	6753	26	0	\N
110451	1397	1366322766000	13466	6753	27	0	\N
110452	1397	1366312765000	13466	6753	28	0	\N
110453	1397	1366302764000	13466	6753	29	0	\N
110454	1397	1366292763000	13466	6753	30	0	\N
110455	1397	1366282762000	13466	6753	31	0	\N
110456	1397	1366272761000	13466	6753	32	0	\N
110457	1397	1366262760000	13466	6753	33	0	\N
110458	1397	1366252759000	13466	6753	34	0	\N
110459	1397	1366242758000	13466	6753	35	0	\N
110460	1397	1366232757000	13466	6753	36	0	\N
110461	1397	1366222756000	13466	6753	38	0	\N
110462	1397	1366212755000	13466	6753	39	0	\N
110463	1397	1366202754000	13466	6753	40	0	\N
110464	1397	1366192753000	13466	6753	41	0	\N
110465	1397	1366182752000	13466	6753	42	0	\N
110466	1397	1366172751000	13466	6753	43	0	\N
110467	1397	1366162750000	13466	6753	44	0	\N
110468	1397	1366152749000	13466	6753	45	0	\N
110469	1397	1366142748000	13466	6753	46	0	\N
110470	1397	1366132747000	13466	6753	47	0	\N
110471	1397	1366122746000	13466	6753	48	0	\N
110472	1397	1366112745000	13466	6753	49	0	\N
110473	1397	1366102744000	13466	6753	50	0	\N
110474	1397	1366092743000	13466	6753	51	0	\N
110475	1397	1366082742000	13466	6753	52	0	\N
110476	1397	1366072741000	13466	6753	53	0	\N
110477	1397	1366062740000	13466	6753	54	0	\N
110478	1397	1366052739000	13466	6753	55	0	\N
110479	1397	1366042738000	13466	6753	56	0	\N
110480	1397	1366032737000	13466	6753	57	0	\N
110481	1397	1366022736000	13466	6753	58	0	\N
110482	1397	1366012735000	13466	6753	59	0	\N
110483	1397	1366002734000	13466	6753	60	0	\N
110484	1397	1365992733000	13466	6753	61	0	\N
110485	1397	1365982732000	13466	6753	62	0	\N
110486	1397	1365972731000	13466	6753	63	0	\N
110487	1397	1365962730000	13466	6753	64	0	\N
110488	1397	1365952729000	13466	6753	65	0	\N
110489	1397	1365942728000	13466	6753	66	0	\N
110490	1397	1365932727000	13466	6753	67	0	\N
110491	1397	1365922726000	13466	6753	68	0	\N
110492	1397	1365912725000	13466	6753	69	0	\N
110493	1397	1365902724000	13466	6753	70	0	\N
110494	1397	1365892723000	13466	6753	71	0	\N
110495	1397	1365882722000	13466	6753	72	0	\N
110496	1397	1365872721000	13466	6753	73	0	\N
110497	1397	1365862720000	13466	6753	74	0	\N
110498	1397	1365852719000	13466	6753	75	0	\N
110505	1397	1364452579000	13470	6938	0	0	\N
110506	1726	682454114000	13470	6938	1	0	\N
110507	1726	682453112000	13470	6938	2	0	\N
110515	1397	1364422576000	13472	6940	0	0	\N
110516	1726	682447100000	13472	6940	1	0	\N
110517	1726	682446099000	13472	6940	2	0	\N
110518	1726	682445097000	13472	6940	3	0	\N
110519	1397	1364422576000	13473	6940	0	0	\N
110520	1726	682447100000	13473	6940	1	0	\N
110521	1726	682446099000	13473	6940	2	0	\N
110522	1726	682445097000	13473	6940	3	0	\N
110523	1397	1364422576000	13474	6940	0	0	\N
110525	1397	1364412575000	13476	6941	0	0	\N
110526	1726	682447100000	13476	6941	1	0	\N
110527	1726	682446099000	13476	6941	2	0	\N
110528	1726	682445097000	13476	6941	3	0	\N
110529	1726	682444094000	13476	6941	4	0	\N
110530	1726	682443093000	13476	6941	5	0	\N
110531	1726	682442091000	13476	6941	6	0	\N
110532	1397	1364412575000	13477	6941	0	0	\N
110533	1726	682447100000	13477	6941	1	0	\N
110534	1726	682446099000	13477	6941	2	0	\N
110535	1726	682445097000	13477	6941	3	0	\N
110536	1726	682444094000	13477	6941	4	0	\N
110537	1726	682443093000	13477	6941	5	0	\N
110538	1726	682442091000	13477	6941	6	0	\N
110539	1397	1364412575000	13478	6941	0	0	\N
110540	1397	1364412575000	13479	6941	0	0	\N
110541	1726	682447100000	13479	6941	1	0	\N
110542	1726	682446099000	13479	6941	2	0	\N
110543	1726	682445097000	13479	6941	3	0	\N
110566	1397	1364352569000	13482	6943	0	0	\N
110567	1397	1364342568000	13482	6943	1	0	\N
110568	1397	1364332567000	13482	6943	2	0	\N
110501	1726	682455115000	13467	6937	2	0	5454
110502	1397	1364452579000	13469	6938	0	0	7438
110503	1726	682454114000	13469	6938	1	0	5455
110504	1726	682453112000	13469	6938	2	0	5456
110508	1397	1364442578000	13471	6939	0	0	7439
110510	1726	682452111000	13471	6939	2	0	5457
110511	1726	682451109000	13471	6939	3	0	5458
110512	1726	682450106000	13471	6939	4	0	5459
110513	1726	682449105000	13471	6939	5	0	5460
110514	1726	682448103000	13471	6939	6	0	5461
110544	1397	1364412575000	13480	6941	0	0	7442
110545	1726	682447100000	13480	6941	1	0	5462
110546	1726	682446099000	13480	6941	2	0	5463
110547	1726	682445097000	13480	6941	3	0	5464
110549	1397	1364392573000	13481	6942	1	0	7444
110550	1397	1364382572000	13481	6942	2	0	7445
110551	1397	1364372571000	13481	6942	3	0	7446
110552	1397	1364362570000	13481	6942	4	0	7447
110553	1653	8000000	13481	6942	5	0	3
110555	1726	682443093000	13481	6942	7	0	5466
110556	1726	682442091000	13481	6942	8	0	5467
110557	1726	682441090000	13481	6942	9	0	5468
110558	1726	682440088000	13481	6942	10	0	5469
110559	1726	682439087000	13481	6942	11	0	5470
110561	1726	682437084000	13481	6942	13	0	5472
110562	1726	682436082000	13481	6942	14	0	5473
110563	1726	682435081000	13481	6942	15	0	5474
110564	1726	682434079000	13481	6942	16	0	5475
110569	1726	682432076000	13482	6943	3	0	\N
110570	1726	682431075000	13482	6943	4	0	\N
110571	1726	682430073000	13482	6943	5	0	\N
110572	1726	682429072000	13482	6943	6	0	\N
110573	1726	682428070000	13482	6943	7	0	\N
110574	1726	682427069000	13482	6943	8	0	\N
110584	1397	1364352569000	13484	6943	0	0	\N
110585	1397	1364342568000	13484	6943	1	0	\N
110586	1397	1364332567000	13484	6943	2	0	\N
110587	1726	682432076000	13484	6943	3	0	\N
110588	1726	682431075000	13484	6943	4	0	\N
110589	1726	682430073000	13484	6943	5	0	\N
110590	1726	682429072000	13484	6943	6	0	\N
110591	1726	682428070000	13484	6943	7	0	\N
110592	1726	682427069000	13484	6943	8	0	\N
110613	1397	1364262560000	13487	6946	0	0	\N
110614	1397	1364252559000	13487	6946	1	0	\N
110615	1726	679994049000	13487	6946	2	0	\N
110616	1726	679993048000	13487	6946	3	0	\N
110617	1726	679992046000	13487	6946	4	0	\N
110618	1726	679991045000	13487	6946	5	0	\N
110623	1397	1364242558000	13489	6947	0	0	\N
110624	2094	199000000	13489	6947	1	0	\N
110631	1397	1364232557000	13491	6948	0	0	\N
110632	1397	1364222556000	13491	6948	1	0	\N
110633	1397	1364212555000	13491	6948	2	0	\N
110634	1726	679988040000	13491	6948	3	0	\N
110635	1726	679987039000	13491	6948	4	0	\N
110636	1397	1364232557000	13492	6948	0	0	\N
110637	1397	1364222556000	13492	6948	1	0	\N
110638	1397	1364212555000	13492	6948	2	0	\N
110639	1726	679988040000	13492	6948	3	0	\N
110640	1726	679987039000	13492	6948	4	0	\N
110641	1726	679986037000	13492	6948	5	0	\N
110642	1726	679985036000	13492	6948	6	0	\N
110643	1726	679984034000	13492	6948	7	0	\N
110644	1726	679983033000	13492	6948	8	0	\N
110654	1397	1364202554000	13494	6949	0	0	\N
110655	1726	679982031000	13494	6949	1	0	\N
110656	1726	679981030000	13494	6949	2	0	\N
110658	1397	1364192553000	13496	6950	0	0	\N
110659	1726	679982031000	13496	6950	1	0	\N
110660	1726	679981030000	13496	6950	2	0	\N
110661	1726	679980028000	13496	6950	3	0	\N
110668	1397	1364192553000	13498	6950	0	0	\N
110672	1397	1364182552000	13500	6951	0	0	\N
110673	1726	678768025000	13500	6951	1	0	\N
110674	1726	678767024000	13500	6951	2	0	\N
110675	1397	1364182552000	13501	6951	0	0	\N
110679	1397	1364162550000	13503	6953	0	0	\N
110680	1726	678764019000	13503	6953	1	0	\N
110681	1726	678763018000	13503	6953	2	0	\N
110682	1397	1364162550000	13504	6953	0	0	\N
110683	1726	678764019000	13504	6953	1	0	\N
110684	1726	678763018000	13504	6953	2	0	\N
110688	1397	1364162550000	13506	6953	0	0	\N
110702	1397	1364152549000	13509	6954	0	0	\N
110703	1397	1364142548000	13509	6954	1	0	\N
110704	1397	1364132547000	13509	6954	2	0	\N
110577	1397	1364332567000	13483	6943	2	0	7450
110578	1726	682432076000	13483	6943	3	0	5477
110579	1726	682431075000	13483	6943	4	0	5478
110580	1726	682430073000	13483	6943	5	0	5479
110581	1726	682429072000	13483	6943	6	0	5480
110583	1726	682427069000	13483	6943	8	0	5482
110593	1397	1364322566000	13485	6944	0	0	7451
110594	1397	1364312565000	13485	6944	1	0	7452
110595	1397	1364302564000	13485	6944	2	0	7453
110596	1726	682426067000	13485	6944	3	0	5483
110598	1726	682424064000	13485	6944	5	0	5485
110599	1726	682423063000	13485	6944	6	0	5486
110600	1726	682422061000	13485	6944	7	0	5487
110601	1726	682421060000	13485	6944	8	0	5488
110603	1397	1364282562000	13486	6945	1	0	7455
110604	1397	1364272561000	13486	6945	2	0	7456
110605	1726	682420058000	13486	6945	3	0	5489
110606	1726	682419057000	13486	6945	4	0	5490
110607	1726	682418055000	13486	6945	5	0	5491
110609	1726	682416052000	13486	6945	8	0	5493
110610	1726	682415051000	13486	6945	9	0	5494
110611	1726	681205051000	13486	6945	10	0	5495
110612	1726	679995051000	13486	6945	11	0	5496
110619	1397	1364262560000	13488	6946	0	0	7457
110621	1726	679994049000	13488	6946	2	0	5497
110622	1726	679993048000	13488	6946	3	0	5498
110625	1397	1364242558000	13490	6947	0	0	7459
110626	1726	679992046000	13490	6947	1	0	5499
110628	1726	679990043000	13490	6947	3	0	5501
110629	1726	679989042000	13490	6947	4	0	5502
110630	2094	199000000	13490	6947	5	0	1
110645	1397	1364232557000	13493	6948	0	0	7460
110646	1397	1364222556000	13493	6948	1	0	7461
110648	1726	679988040000	13493	6948	3	0	5503
110649	1726	679987039000	13493	6948	4	0	5504
110650	1726	679986037000	13493	6948	5	0	5505
110651	1726	679985036000	13493	6948	6	0	5506
110652	1726	679984034000	13493	6948	7	0	5507
110657	1397	1364202554000	13495	6949	0	0	7463
110662	1397	1364192553000	13497	6950	0	0	7464
110663	1726	679982031000	13497	6950	1	0	5509
110664	1726	679981030000	13497	6950	2	0	5510
110666	1726	679979027000	13497	6950	4	0	5512
110667	1726	678769027000	13497	6950	5	0	5513
110669	1397	1364182552000	13499	6951	0	0	7465
110670	1726	678768025000	13499	6951	1	0	5514
110671	1726	678767024000	13499	6951	2	0	5515
110677	1726	678766022000	13502	6952	1	0	5516
110678	1726	678765021000	13502	6952	2	0	5517
110685	1397	1364162550000	13505	6953	0	0	7467
110686	1726	678764019000	13505	6953	1	0	5518
110687	1726	678763018000	13505	6953	2	0	5519
110690	1397	1364142548000	13507	6954	1	0	7469
110691	1397	1364132547000	13507	6954	2	0	7470
110692	1726	678762016000	13507	6954	3	0	5520
110693	1726	678761015000	13507	6954	4	0	5521
110695	1726	678759012000	13507	6954	6	0	5523
110696	1726	678758010000	13507	6954	7	0	5524
110697	1726	678757009000	13507	6954	8	0	5525
110698	1726	677547009000	13507	6954	9	0	5526
110699	1397	1364122546000	13508	6955	0	0	7471
110701	1726	677545006000	13508	6955	2	0	5528
110705	1397	1364122546000	13509	6954	3	0	\N
110706	1397	1364112545000	13509	6954	4	0	\N
110707	1726	678762016000	13509	6954	5	0	\N
110708	1726	678761015000	13509	6954	6	0	\N
110709	1726	678760013000	13509	6954	7	0	\N
110710	1726	678759012000	13509	6954	8	0	\N
110711	1726	678758010000	13509	6954	9	0	\N
110712	1726	678757009000	13509	6954	10	0	\N
110713	1726	677547009000	13509	6954	11	0	\N
110714	1726	677546007000	13509	6954	12	0	\N
110715	1726	677545006000	13509	6954	13	0	\N
110716	1726	677544004000	13509	6954	14	0	\N
110717	1726	677543003000	13509	6954	15	0	\N
110718	1397	1364532587000	13510	6931	0	0	\N
110719	1397	1364522586000	13510	6931	1	0	\N
110720	1397	1364512585000	13510	6931	2	0	\N
110721	1397	1364502584000	13510	6931	3	0	\N
110722	1397	1364492583000	13510	6931	4	0	\N
110723	1397	1364482582000	13510	6931	5	0	\N
110724	1397	1364472581000	13510	6931	6	0	\N
110725	1397	1364462580000	13510	6931	7	0	\N
110726	1397	1364452579000	13510	6931	8	0	\N
110727	1397	1364442578000	13510	6931	9	0	\N
110728	1397	1364432577000	13510	6931	10	0	\N
110729	1397	1364422576000	13510	6931	11	0	\N
110730	1397	1364412575000	13510	6931	12	0	\N
110731	1397	1364402574000	13510	6931	13	0	\N
110732	1397	1364392573000	13510	6931	14	0	\N
110733	1397	1364382572000	13510	6931	15	0	\N
110734	1397	1364372571000	13510	6931	16	0	\N
110735	1397	1364362570000	13510	6931	17	0	\N
110736	1397	1364352569000	13510	6931	18	0	\N
110737	1397	1364342568000	13510	6931	19	0	\N
110738	1397	1364332567000	13510	6931	20	0	\N
110739	1397	1364322566000	13510	6931	21	0	\N
110740	1397	1364312565000	13510	6931	22	0	\N
110741	1397	1364302564000	13510	6931	23	0	\N
110742	1397	1364292563000	13510	6931	24	0	\N
110743	1397	1364282562000	13510	6931	25	0	\N
110744	1397	1364272561000	13510	6931	26	0	\N
110745	1397	1364262560000	13510	6931	27	0	\N
110746	1397	1364252559000	13510	6931	28	0	\N
110747	1397	1364242558000	13510	6931	29	0	\N
110748	1397	1364232557000	13510	6931	30	0	\N
110749	1397	1364222556000	13510	6931	31	0	\N
110750	1397	1364212555000	13510	6931	32	0	\N
110751	1397	1364202554000	13510	6931	33	0	\N
110752	1397	1364192553000	13510	6931	34	0	\N
110753	1397	1364182552000	13510	6931	35	0	\N
110754	1397	1364172551000	13510	6931	36	0	\N
110755	1397	1364162550000	13510	6931	37	0	\N
110756	1397	1364152549000	13510	6931	38	0	\N
110757	1397	1364142548000	13510	6931	39	0	\N
110758	1397	1364132547000	13510	6931	40	0	\N
110759	1397	1364122546000	13510	6931	41	0	\N
110760	1397	1364112545000	13510	6931	42	0	\N
110761	1653	8000000	13510	6931	43	0	\N
110774	1750	4168000000	13515	6906	0	0	\N
110775	1653	8000000	13515	6906	1	0	\N
110776	1926	1199000000	13515	6906	2	0	\N
110777	1397	1364072541000	13516	6959	0	0	\N
110785	1397	1364052539000	13519	6961	0	0	\N
110786	1726	677531986000	13519	6961	1	0	\N
110787	1726	677530985000	13519	6961	2	0	\N
110788	2077	1438998000000	13519	6961	3	0	\N
110789	1397	1364052539000	13520	6961	0	0	\N
110790	1726	677531986000	13520	6961	1	0	\N
110791	1726	677530985000	13520	6961	2	0	\N
110792	2077	1438998000000	13520	6961	3	0	\N
110800	1397	1364032537000	13523	6963	0	0	\N
110801	1726	677527980000	13523	6963	1	0	\N
110802	1726	677526979000	13523	6963	2	0	\N
110803	1726	676316979000	13523	6963	3	0	\N
110808	1397	1364032537000	13525	6963	0	0	\N
110809	1726	677527980000	13525	6963	1	0	\N
110810	1726	677526979000	13525	6963	2	0	\N
110811	1726	676316979000	13525	6963	3	0	\N
110812	1397	1364022536000	13527	6964	0	0	\N
110813	1397	1364012535000	13527	6964	1	0	\N
110814	1726	676315977000	13527	6964	2	0	\N
110815	1726	676314976000	13527	6964	3	0	\N
110816	1726	676313974000	13527	6964	4	0	\N
110817	1726	676312973000	13527	6964	6	0	\N
110818	1397	1364022536000	13528	6964	0	0	\N
110819	1397	1364012535000	13528	6964	1	0	\N
110820	1726	676315977000	13528	6964	2	0	\N
110821	1726	676314976000	13528	6964	3	0	\N
110822	1726	676313974000	13528	6964	4	0	\N
110823	1726	676312973000	13528	6964	6	0	\N
110834	1397	1363992533000	13532	6967	0	0	\N
110835	1726	676308967000	13532	6967	1	0	\N
110836	1726	676307965000	13532	6967	2	0	\N
110840	1397	1363992533000	13534	6967	0	0	\N
110764	1726	677543003000	13511	6956	2	0	5530
110765	1397	1364102544000	13512	6957	0	0	7473
110766	1726	677542001000	13512	6957	1	0	5531
110767	1726	677541000000	13512	6957	2	0	5532
110768	1397	1364092543000	13513	6958	0	0	7474
110770	1726	677539998000	13513	6958	2	0	5533
110771	1726	677538997000	13513	6958	3	0	5534
110772	1726	677537995000	13513	6958	4	0	5535
110773	1726	677536994000	13513	6958	5	0	5536
110778	1397	1364072541000	13517	6959	0	0	7476
110780	1726	677534991000	13517	6959	2	0	5538
110781	1397	1364062540000	13518	6960	0	0	7477
110782	1726	677533989000	13518	6960	1	0	5539
110783	1726	677532988000	13518	6960	2	0	5540
110793	1397	1364052539000	13521	6961	0	0	7478
110794	1726	677531986000	13521	6961	1	0	5541
110795	1726	677530985000	13521	6961	2	0	5542
110796	2077	1438998000000	13521	6961	3	0	2
110797	1397	1364042538000	13522	6962	0	0	7479
110799	1726	677528982000	13522	6962	2	0	5544
110804	1397	1364032537000	13524	6963	0	0	7480
110805	1726	677527980000	13524	6963	1	0	5545
110806	1726	677526979000	13524	6963	2	0	5546
110807	1726	676316979000	13524	6963	3	0	5547
110825	1397	1364012535000	13529	6964	1	0	7482
110826	1726	676315977000	13529	6964	2	0	5548
110827	1726	676314976000	13529	6964	3	0	5549
110828	1726	676313974000	13529	6964	4	0	5550
110830	1726	676311971000	13530	6965	0	0	5552
110831	1397	1364002534000	13531	6966	0	0	7483
110832	1726	676310970000	13531	6966	1	0	5553
110833	1726	676309968000	13531	6966	2	0	5554
110837	1397	1363992533000	13533	6967	0	0	7484
110839	1726	676307965000	13533	6967	2	0	5556
110841	1397	1363982532000	13535	6968	0	0	\N
110842	1726	676308967000	13535	6968	1	0	\N
110843	1726	676307965000	13535	6968	2	0	\N
110844	1726	676306964000	13535	6968	3	0	\N
110845	1726	676305962000	13535	6968	4	0	\N
110849	1397	1363982532000	13538	6968	0	0	\N
110850	1726	676306964000	13538	6968	1	0	\N
110851	1726	676305962000	13538	6968	2	0	\N
110855	1397	1363972531000	13540	6969	0	0	\N
110856	1726	676304961000	13540	6969	1	0	\N
110857	1726	676303959000	13540	6969	2	0	\N
110858	1397	1363962530000	13541	6970	0	0	\N
110859	1726	676302958000	13541	6970	1	0	\N
110860	1726	676301956000	13541	6970	2	0	\N
110861	1397	1363962530000	13542	6970	0	0	\N
110862	1726	676302958000	13542	6970	1	0	\N
110863	1726	676301956000	13542	6970	2	0	\N
110864	1397	1363962530000	13543	6970	0	0	\N
110865	1726	676302958000	13543	6970	1	0	\N
110866	1726	676301956000	13543	6970	2	0	\N
110870	1397	1363952529000	13545	6971	0	0	\N
110871	1726	676300955000	13545	6971	1	0	\N
110872	1726	676299953000	13545	6971	2	0	\N
110873	1397	1363952529000	13546	6971	0	0	\N
110875	1397	1363952529000	13548	6971	0	0	\N
110876	1726	676300955000	13548	6971	1	0	\N
110877	1726	676299953000	13548	6971	2	0	\N
110878	1397	1363942528000	13549	6972	0	0	\N
110879	1726	676300955000	13549	6972	1	0	\N
110880	1726	676299953000	13549	6972	2	0	\N
110881	1726	676298952000	13549	6972	3	0	\N
110882	1726	676297950000	13549	6972	4	0	\N
110883	1397	1363942528000	13550	6972	0	0	\N
110884	1726	676300955000	13550	6972	1	0	\N
110885	1726	676299953000	13550	6972	2	0	\N
110886	1726	676298952000	13550	6972	3	0	\N
110887	1726	676297950000	13550	6972	4	0	\N
110889	1397	1363952529000	13552	6971	0	0	\N
110890	1397	1363932527000	13556	6973	0	0	\N
110891	1726	676300955000	13556	6973	1	0	\N
110892	1726	676299953000	13556	6973	2	0	\N
110893	1726	676298952000	13556	6973	3	0	\N
110894	1726	676297950000	13556	6973	4	0	\N
110895	1726	676296949000	13556	6973	5	0	\N
110896	1726	676295947000	13556	6973	6	0	\N
110897	1397	1363932527000	13557	6973	0	0	\N
110905	1397	1363922526000	13559	6974	0	0	\N
110906	1726	676294946000	13559	6974	1	0	\N
110907	1726	676293944000	13559	6974	2	0	\N
110911	1397	1363922526000	13561	6974	0	0	\N
110912	1726	676294946000	13561	6974	1	0	\N
110935	1397	1363862520000	13566	6978	0	0	\N
110936	1622	22140751904589	13566	6978	1	0	\N
110937	1622	20773033272869	13566	6978	2	0	\N
110938	1622	18322101123349	13566	6978	3	0	\N
110939	1622	16668405110994	13566	6978	4	0	\N
110940	1622	12060252000014	13566	6978	5	0	\N
110941	1726	676283929000	13566	6978	6	0	\N
110942	1726	676282928000	13566	6978	7	0	\N
110943	1397	1363862520000	13567	6978	0	0	\N
110944	1622	22140751904589	13567	6978	1	0	\N
110945	1622	20773033272869	13567	6978	2	0	\N
110946	1622	18322101123349	13567	6978	3	0	\N
110947	1622	16668405110994	13567	6978	4	0	\N
110948	1622	12060252000014	13567	6978	5	0	\N
110949	1726	676283929000	13567	6978	6	0	\N
110950	1726	676282928000	13567	6978	7	0	\N
110951	1397	1364182552000	13568	6951	0	0	\N
110952	1397	1364172551000	13568	6951	1	0	\N
110953	1397	1364162550000	13568	6951	2	0	\N
110954	1397	1364152549000	13568	6951	3	0	\N
110955	1397	1364142548000	13568	6951	4	0	\N
110956	1397	1364132547000	13568	6951	5	0	\N
110957	1397	1364122546000	13568	6951	6	0	\N
110958	1397	1364112545000	13568	6951	7	0	\N
110959	1397	1364102544000	13568	6951	8	0	\N
110960	1397	1364092543000	13568	6951	9	0	\N
110961	1397	1364082542000	13568	6951	10	0	\N
110962	1397	1364072541000	13568	6951	11	0	\N
110963	1397	1364062540000	13568	6951	12	0	\N
110964	1397	1364052539000	13568	6951	13	0	\N
110965	1397	1364042538000	13568	6951	14	0	\N
110966	1397	1364032537000	13568	6951	15	0	\N
110967	1397	1364022536000	13568	6951	16	0	\N
110968	1397	1364012535000	13568	6951	17	0	\N
110969	1397	1364002534000	13568	6951	18	0	\N
110970	1397	1363992533000	13568	6951	19	0	\N
110971	1397	1363982532000	13568	6951	20	0	\N
110972	1397	1363972531000	13568	6951	21	0	\N
110973	1397	1363962530000	13568	6951	22	0	\N
110974	1397	1363952529000	13568	6951	23	0	\N
110975	1397	1363942528000	13568	6951	24	0	\N
110976	1397	1363932527000	13568	6951	25	0	\N
110848	1726	676305962000	13536	6968	2	0	5558
110852	1397	1363972531000	13539	6969	0	0	7486
110853	1726	676304961000	13539	6969	1	0	5559
110854	1726	676303959000	13539	6969	2	0	5560
110867	1397	1363962530000	13544	6970	0	0	7487
110869	1726	676301956000	13544	6970	2	0	5562
110874	1397	1363952529000	13547	6971	0	0	7488
110888	1397	1363942528000	13551	6972	0	0	7489
110898	1397	1363932527000	13558	6973	0	0	7490
110899	1726	676300955000	13558	6973	1	0	5563
110901	1726	676298952000	13558	6973	3	0	5565
110902	1726	676297950000	13558	6973	4	0	5566
110903	1726	676296949000	13558	6973	5	0	5567
110904	1726	676295947000	13558	6973	6	0	5568
110909	1726	676294946000	13560	6974	1	0	5569
110910	1726	676293944000	13560	6974	2	0	5570
110913	1397	1363912525000	13562	6975	0	0	7492
110914	1397	1363902524000	13563	6976	0	0	7493
110915	1397	1363892523000	13563	6976	1	0	7494
110917	1726	676292943000	13563	6976	3	0	5571
110918	1726	676291941000	13563	6976	4	0	5572
110919	1726	676290940000	13563	6976	5	0	5573
110920	1726	676289938000	13563	6976	6	0	5574
110921	1726	676288937000	13563	6976	7	0	5575
110923	1726	676286934000	13563	6976	9	0	5577
110924	1397	1363872521000	13564	6977	0	0	7496
110925	1726	676285932000	13564	6977	1	0	5578
110926	1726	676284931000	13564	6977	2	0	5579
110928	1622	22140751904589	13565	6978	1	0	1
110929	1622	20773033272869	13565	6978	2	0	2
110930	1622	18322101123349	13565	6978	3	0	3
110931	1622	16668405110994	13565	6978	4	0	4
110932	1622	12060252000014	13565	6978	5	0	5
110934	1726	676282928000	13565	6978	7	0	5581
110977	1397	1363922526000	13568	6951	26	0	\N
110978	1622	21420739904589	13568	6951	27	0	\N
110979	1622	20053021272869	13568	6951	28	0	\N
110980	1622	17602089123349	13568	6951	29	0	\N
110981	1622	15948393110994	13568	6951	30	0	\N
110982	1622	11340240000014	13568	6951	31	0	\N
110983	1397	1363912525000	13568	6951	32	0	\N
110984	1397	1363902524000	13568	6951	33	0	\N
110985	1397	1363892523000	13568	6951	34	0	\N
110986	1397	1363882522000	13568	6951	35	0	\N
110987	1397	1363872521000	13568	6951	36	0	\N
110988	1397	1363862520000	13568	6951	37	0	\N
110989	2077	1438999000000	13568	6951	38	0	\N
110990	2077	1438998000000	13568	6951	39	0	\N
110994	1397	1363852519000	13570	6979	0	0	\N
110995	1726	676281926000	13570	6979	1	0	\N
110996	1726	676280925000	13570	6979	2	0	\N
110997	1397	1364102544000	13571	6932	0	0	\N
110998	1397	1364092543000	13571	6932	1	0	\N
110999	1397	1364082542000	13571	6932	2	0	\N
111000	1397	1364072541000	13571	6932	3	0	\N
111001	1397	1364062540000	13571	6932	4	0	\N
111002	1397	1364052539000	13571	6932	5	0	\N
111003	1397	1364042538000	13571	6932	6	0	\N
111004	1397	1364032537000	13571	6932	7	0	\N
111005	1397	1364022536000	13571	6932	8	0	\N
111006	1397	1364012535000	13571	6932	9	0	\N
111007	1397	1364002534000	13571	6932	10	0	\N
111008	1397	1363992533000	13571	6932	11	0	\N
111009	1397	1363982532000	13571	6932	12	0	\N
111010	1397	1363972531000	13571	6932	13	0	\N
111011	1397	1363962530000	13571	6932	14	0	\N
111012	1397	1363952529000	13571	6932	15	0	\N
111013	1397	1363942528000	13571	6932	16	0	\N
111014	1397	1363932527000	13571	6932	17	0	\N
111015	1397	1363922526000	13571	6932	18	0	\N
111016	1622	20700727904589	13571	6932	19	0	\N
111017	1622	19333009272869	13571	6932	20	0	\N
111018	1622	16882077123349	13571	6932	21	0	\N
111019	1622	15228381110994	13571	6932	22	0	\N
111020	1622	10620228000014	13571	6932	23	0	\N
111021	1397	1363912525000	13571	6932	24	0	\N
111022	1397	1363902524000	13571	6932	25	0	\N
111023	1397	1363892523000	13571	6932	26	0	\N
111024	1397	1363882522000	13571	6932	27	0	\N
111025	1397	1363872521000	13571	6932	28	0	\N
111026	1397	1363862520000	13571	6932	29	0	\N
111027	1397	1363852519000	13571	6932	30	0	\N
111028	2077	1438999000000	13571	6932	31	0	\N
111029	2077	1438998000000	13571	6932	32	0	\N
111030	1397	1363852519000	13572	6979	0	0	\N
111031	1726	676281926000	13572	6979	1	0	\N
111032	1726	676280925000	13572	6979	2	0	\N
111033	1397	1363842518000	13573	6980	0	0	\N
111034	1726	676279923000	13573	6980	1	0	\N
111035	1726	676278922000	13573	6980	2	0	\N
111039	1397	1363832517000	13575	6981	0	0	\N
111040	1726	676277920000	13575	6981	1	0	\N
111041	1726	676276919000	13575	6981	2	0	\N
111077	1397	1363732507000	13581	6986	0	0	\N
111078	1726	676253878000	13581	6986	1	0	\N
111079	1726	676252875000	13581	6986	2	0	\N
111080	1726	676251874000	13581	6986	3	0	\N
111085	1397	1363732507000	13583	6986	0	0	\N
111086	1726	676253878000	13583	6986	1	0	\N
111087	1726	676252875000	13583	6986	2	0	\N
111088	1726	676251874000	13583	6986	3	0	\N
111094	2058	560500000	13585	6987	0	0	\N
111095	1397	1363722506000	13585	6987	1	0	\N
111096	1726	676250872000	13585	6987	2	0	\N
111097	1726	676249869000	13585	6987	3	0	\N
111098	1726	676248868000	13585	6987	4	0	\N
111099	1397	1363712505000	13586	6988	0	0	\N
111100	1726	676247866000	13586	6988	1	0	\N
111101	1726	676246863000	13586	6988	2	0	\N
111102	1726	676245862000	13586	6988	3	0	\N
111112	1726	675035862000	13589	6989	0	0	\N
110993	1726	676280925000	13569	6979	2	0	5583
111036	1397	1363842518000	13574	6980	0	0	7499
111037	1726	676279923000	13574	6980	1	0	5584
111038	1726	676278922000	13574	6980	2	0	5585
111042	1397	1363832517000	13576	6981	0	0	7500
111044	1726	676276919000	13576	6981	2	0	5587
111045	1397	1363822516000	13577	6982	0	0	7501
111046	1397	1363812515000	13577	6982	1	0	7502
111047	1397	1363802514000	13577	6982	2	0	7503
111048	1726	676275917000	13577	6982	3	0	5588
111050	1726	676273914000	13577	6982	5	0	5590
111051	1726	676272913000	13577	6982	6	0	5591
111052	1726	676271911000	13577	6982	7	0	5592
111053	1726	676270910000	13577	6982	8	0	5593
111055	1397	1363792513000	13578	6983	1	0	7504
111056	1726	676269908000	13578	6983	2	0	5594
111057	1726	676268907000	13578	6983	3	0	5595
111058	1397	1363782512000	13579	6984	0	0	7505
111059	1397	1363772511000	13579	6984	1	0	7506
111061	1726	676266904000	13579	6984	3	0	5597
111062	1726	676265902000	13579	6984	4	0	5598
111063	1726	676264899000	13579	6984	5	0	5599
111064	1726	676263898000	13579	6984	6	0	5600
111065	1397	1363762510000	13580	6985	0	0	7507
111067	1397	1363742508000	13580	6985	2	0	7509
111068	1726	676262896000	13580	6985	3	0	5601
111069	1726	676261893000	13580	6985	4	0	5602
111070	1726	676260892000	13580	6985	6	0	5603
111072	1726	676258887000	13580	6985	8	0	5605
111073	1726	676257886000	13580	6985	9	0	5606
111074	1726	676256884000	13580	6985	10	0	5607
111075	1726	676255881000	13580	6985	11	0	5608
111076	1726	676254880000	13580	6985	12	0	5609
111082	1726	676253878000	13582	6986	1	0	5610
111083	1726	676252875000	13582	6986	2	0	5611
111084	1726	676251874000	13582	6986	3	0	5612
111089	2058	560500000	13584	6987	0	0	5
111090	1397	1363722506000	13584	6987	1	0	7511
111092	1726	676249869000	13584	6987	3	0	5614
111093	1726	676248868000	13584	6987	4	0	5615
111103	1397	1363712505000	13587	6988	0	0	7512
111104	1726	676247866000	13587	6988	1	0	5616
111106	1726	676245862000	13587	6988	3	0	5618
111107	1726	675035862000	13588	6989	0	0	5619
111108	1397	1363702504000	13588	6989	1	0	7513
111109	1726	675034860000	13588	6989	2	0	5620
111110	1726	675033857000	13588	6989	3	0	5621
111113	1397	1363702504000	13589	6989	1	0	\N
111114	1726	675034860000	13589	6989	2	0	\N
111115	1726	675033857000	13589	6989	3	0	\N
111116	1726	675032856000	13589	6989	4	0	\N
111117	1726	675035862000	13590	6989	0	0	\N
111118	1397	1363702504000	13590	6989	1	0	\N
111119	1726	675034860000	13590	6989	2	0	\N
111120	1726	675033857000	13590	6989	3	0	\N
111121	1726	675032856000	13590	6989	4	0	\N
111122	1397	1363692503000	13591	6990	0	0	\N
111123	1726	675031854000	13591	6990	1	0	\N
111124	1726	675030851000	13591	6990	2	0	\N
111132	1397	1363682502000	13594	6991	0	0	\N
111133	1726	675029850000	13594	6991	1	0	\N
111134	1726	675028848000	13594	6991	2	0	\N
111135	1726	675027845000	13594	6991	3	0	\N
111136	1397	1363682502000	13595	6991	0	0	\N
111137	1726	675029850000	13595	6991	1	0	\N
111138	1726	675028848000	13595	6991	2	0	\N
111139	1726	675027845000	13595	6991	3	0	\N
111140	1397	1363672501000	13596	6992	0	0	\N
111141	1726	675026843000	13596	6992	1	0	\N
111142	1726	675025840000	13596	6992	2	0	\N
111143	1397	1363672501000	13597	6992	0	0	\N
111144	1726	675026843000	13597	6992	1	0	\N
111145	1726	675025840000	13597	6992	2	0	\N
111146	1397	1363672501000	13598	6992	0	0	\N
111147	1726	675026843000	13598	6992	1	0	\N
111148	1726	675025840000	13598	6992	2	0	\N
111152	1397	1363672501000	13600	6992	0	0	\N
111153	1726	675026843000	13600	6992	1	0	\N
111154	1726	675025840000	13600	6992	2	0	\N
111155	1397	1363672501000	13601	6992	0	0	\N
111160	1397	1363652499000	13603	6994	0	0	\N
111161	1397	1363642498000	13603	6994	1	0	\N
111162	1397	1363632497000	13603	6994	2	0	\N
111163	1397	1363622496000	13603	6994	3	0	\N
111164	1397	1363612495000	13603	6994	4	0	\N
111165	1397	1363602494000	13603	6994	5	0	\N
111166	1397	1363592493000	13603	6994	6	0	\N
111167	1726	675021832000	13603	6994	7	0	\N
111168	1726	675020829000	13603	6994	8	0	\N
111169	1726	675019827000	13603	6994	9	0	\N
111170	1726	675018824000	13603	6994	10	0	\N
111171	1726	675017823000	13603	6994	11	0	\N
111172	1726	675016821000	13603	6994	12	0	\N
111173	1726	675015818000	13603	6994	13	0	\N
111174	1726	675014817000	13603	6994	14	0	\N
111175	1726	675013815000	13603	6994	15	0	\N
111176	1726	675012812000	13603	6994	16	0	\N
111177	1726	675011811000	13603	6994	17	0	\N
111178	1726	675010809000	13603	6994	18	0	\N
111179	1726	675009806000	13603	6994	19	0	\N
111180	1726	675008805000	13603	6994	20	0	\N
111181	1726	675007803000	13603	6994	21	0	\N
111182	1726	675006800000	13603	6994	22	0	\N
111183	1726	675005799000	13603	6994	23	0	\N
111184	1726	675004797000	13603	6994	24	0	\N
111185	1726	675003794000	13603	6994	25	0	\N
111186	1726	675002793000	13603	6994	26	0	\N
111214	1397	1363582492000	13606	6995	0	0	\N
111215	1726	675001791000	13606	6995	1	0	\N
111216	1726	675000788000	13606	6995	2	0	\N
111217	1726	674999787000	13606	6995	3	0	\N
111226	1397	1363582492000	13608	6996	0	0	\N
111227	1397	1363572491000	13608	6996	1	0	\N
111228	1726	675001791000	13608	6996	2	0	\N
111229	1726	675000788000	13608	6996	3	0	\N
111230	1726	674999787000	13608	6996	4	0	\N
111231	1726	674998785000	13608	6996	5	0	\N
111232	1726	674997782000	13608	6996	6	0	\N
111233	1726	674996781000	13608	6996	7	0	\N
111246	1397	1363542488000	13612	6998	0	0	\N
111247	1726	674989767000	13612	6998	1	0	\N
111248	1726	674988764000	13612	6998	2	0	\N
111127	1726	675030851000	13592	6990	2	0	5624
111128	1397	1363682502000	13593	6991	0	0	7515
111129	1726	675029850000	13593	6991	1	0	5625
111130	1726	675028848000	13593	6991	2	0	5626
111131	1726	675027845000	13593	6991	3	0	5627
111150	1726	675026843000	13599	6992	1	0	5628
111151	1726	675025840000	13599	6992	2	0	5629
111156	1397	1363662500000	13602	6993	0	0	7517
111157	1726	675024838000	13602	6993	1	0	5630
111158	1726	675023837000	13602	6993	2	0	5631
111187	1397	1363652499000	13604	6994	0	0	7518
111188	1397	1363642498000	13604	6994	1	0	7519
111189	1397	1363632497000	13604	6994	2	0	7520
111190	1397	1363622496000	13604	6994	3	0	7521
111192	1397	1363602494000	13604	6994	5	0	7523
111193	1397	1363592493000	13604	6994	6	0	7524
111194	1726	675021832000	13604	6994	7	0	5633
111195	1726	675020829000	13604	6994	8	0	5634
111196	1726	675019827000	13604	6994	9	0	5635
111198	1726	675017823000	13604	6994	11	0	5637
111199	1726	675016821000	13604	6994	12	0	5638
111200	1726	675015818000	13604	6994	13	0	5639
111201	1726	675014817000	13604	6994	14	0	5640
111202	1726	675013815000	13604	6994	15	0	5641
111204	1726	675011811000	13604	6994	17	0	5643
111205	1726	675010809000	13604	6994	18	0	5644
111206	1726	675009806000	13604	6994	19	0	5645
111207	1726	675008805000	13604	6994	20	0	5646
111209	1726	675006800000	13604	6994	22	0	5648
111210	1726	675005799000	13604	6994	23	0	5649
111211	1726	675004797000	13604	6994	24	0	5650
111212	1726	675003794000	13604	6994	25	0	5651
111213	1726	675002793000	13604	6994	26	0	5652
111219	1397	1363572491000	13607	6996	1	0	7526
111220	1726	675001791000	13607	6996	2	0	5653
111221	1726	675000788000	13607	6996	3	0	5654
111222	1726	674999787000	13607	6996	4	0	5655
111223	1726	674998785000	13607	6996	5	0	5656
111225	1726	674996781000	13607	6996	7	0	5658
111234	2093	100000000	13610	6997	0	0	1
111235	1397	1363562490000	13610	6997	1	0	7527
111236	1397	1363552489000	13610	6997	2	0	7528
111238	1726	674994776000	13610	6997	4	0	5660
111239	1726	674993775000	13610	6997	5	0	5661
111240	1726	674992773000	13610	6997	6	0	5662
111241	1726	674991770000	13610	6997	7	0	5663
111242	1726	674990769000	13610	6997	8	0	5664
111244	1726	674989767000	13611	6998	1	0	5665
111245	1726	674988764000	13611	6998	2	0	5666
111253	1397	1363532487000	13614	6999	0	0	\N
111254	1726	674987763000	13614	6999	1	0	\N
111255	1726	674986761000	13614	6999	2	0	\N
111256	1726	674985758000	13614	6999	3	0	\N
111261	1397	1363512485000	13616	7001	0	0	\N
111262	1726	674981751000	13616	7001	1	0	\N
111263	1726	674980749000	13616	7001	3	0	\N
111264	1726	674979746000	13616	7001	4	0	\N
111265	1397	1363512485000	13617	7001	0	0	\N
111266	1726	674981751000	13617	7001	1	0	\N
111267	1726	674980749000	13617	7001	3	0	\N
111268	1726	674979746000	13617	7001	4	0	\N
111277	1397	1363492483000	13620	7003	0	0	\N
111278	1726	674975739000	13620	7003	1	0	\N
111279	1726	674974737000	13620	7003	2	0	\N
111280	1726	674973734000	13620	7003	3	0	\N
111281	1397	1363492483000	13621	7003	0	0	\N
111282	1726	674975739000	13621	7003	1	0	\N
111283	1726	674974737000	13621	7003	2	0	\N
111284	1726	674973734000	13621	7003	3	0	\N
111285	1397	1363492483000	13622	7003	0	0	\N
111294	1397	1363482482000	13625	7004	0	0	\N
111295	1397	1363472481000	13626	7005	0	0	\N
111296	1397	1363462480000	13626	7005	1	0	\N
111297	1397	1363452479000	13626	7005	2	0	\N
111298	1726	674969727000	13626	7005	3	0	\N
111299	1726	674968725000	13626	7005	4	0	\N
111300	1726	674967722000	13626	7005	5	0	\N
111301	1726	674966721000	13626	7005	6	0	\N
111302	1726	674965719000	13626	7005	7	0	\N
111303	1726	674964716000	13626	7005	8	0	\N
111304	1726	674963715000	13626	7005	9	0	\N
111305	1726	674962713000	13626	7005	10	0	\N
111306	1726	674961710000	13626	7005	11	0	\N
111307	1397	1363472481000	13627	7005	0	0	\N
111308	1397	1363462480000	13627	7005	1	0	\N
111309	1397	1363452479000	13627	7005	2	0	\N
111310	1726	674969727000	13627	7005	3	0	\N
111311	1726	674968725000	13627	7005	4	0	\N
111312	1726	674967722000	13627	7005	5	0	\N
111313	1726	674966721000	13627	7005	6	0	\N
111314	1726	674965719000	13627	7005	7	0	\N
111315	1726	674964716000	13627	7005	8	0	\N
111316	1726	674963715000	13627	7005	9	0	\N
111317	1726	674962713000	13627	7005	10	0	\N
111318	1726	674961710000	13627	7005	11	0	\N
111319	1397	1363472481000	13628	7005	0	0	\N
111320	1397	1363462480000	13628	7005	1	0	\N
111321	1397	1363452479000	13628	7005	2	0	\N
111322	1726	674969727000	13628	7005	3	0	\N
111323	1726	674968725000	13628	7005	4	0	\N
111324	1726	674967722000	13628	7005	5	0	\N
111325	1726	674966721000	13628	7005	6	0	\N
111326	1726	674965719000	13628	7005	7	0	\N
111327	1726	674964716000	13628	7005	8	0	\N
111328	1726	674963715000	13628	7005	9	0	\N
111329	1726	674962713000	13628	7005	10	0	\N
111330	1726	674961710000	13628	7005	11	0	\N
111356	1397	1363392473000	13634	7010	0	0	\N
111357	1397	1363382472000	13634	7010	1	0	\N
111358	1726	674952691000	13634	7010	2	0	\N
111359	1726	674951690000	13634	7010	3	0	\N
111360	1726	674950687000	13634	7010	4	0	\N
111361	1726	674949685000	13634	7010	5	0	\N
111362	1726	674948684000	13634	7010	6	0	\N
111363	1726	674947681000	13634	7010	7	0	\N
111364	1726	674946679000	13634	7010	8	0	\N
111365	1726	674945678000	13634	7010	9	0	\N
111366	1726	674944675000	13634	7010	10	0	\N
111367	1726	674943673000	13634	7010	11	0	\N
111368	1726	674942672000	13634	7010	12	0	\N
111369	1726	674941669000	13634	7010	13	0	\N
111370	1397	1363392473000	13635	7010	0	0	\N
111371	1397	1363382472000	13635	7010	1	0	\N
111372	1726	674952691000	13635	7010	2	0	\N
111373	1726	674951690000	13635	7010	3	0	\N
111374	1726	674950687000	13635	7010	4	0	\N
111375	1726	674949685000	13635	7010	5	0	\N
111376	1726	674948684000	13635	7010	6	0	\N
111377	1726	674947681000	13635	7010	7	0	\N
111378	1726	674946679000	13635	7010	8	0	\N
111379	1726	674945678000	13635	7010	9	0	\N
111380	1726	674944675000	13635	7010	10	0	\N
111381	1726	674943673000	13635	7010	11	0	\N
111382	1726	674942672000	13635	7010	12	0	\N
111383	1726	674941669000	13635	7010	13	0	\N
111251	1726	674986761000	13613	6999	2	0	5668
111252	1726	674985758000	13613	6999	3	0	5669
111257	1397	1363522486000	13615	7000	0	0	7531
111258	1726	674984757000	13615	7000	1	0	5670
111259	1726	674983755000	13615	7000	2	0	5671
111269	1397	1363512485000	13618	7001	0	0	7532
111270	1726	674981751000	13618	7001	1	0	5673
111271	1726	674980749000	13618	7001	3	0	5674
111272	1726	674979746000	13618	7001	4	0	5675
111273	1397	1363502484000	13619	7002	0	0	7533
111275	1726	674977743000	13619	7002	2	0	5677
111276	1726	674976740000	13619	7002	3	0	5678
111286	1397	1363492483000	13623	7003	0	0	7534
111287	1726	674975739000	13623	7003	1	0	5679
111289	1726	674973734000	13623	7003	3	0	5681
111290	1397	1363482482000	13624	7004	0	0	7535
111291	1726	674972733000	13624	7004	1	0	5682
111292	1726	674971731000	13624	7004	2	0	5683
111293	1726	674970728000	13624	7004	3	0	5684
111332	1397	1363462480000	13630	7006	1	0	7537
111333	1397	1363452479000	13630	7006	2	0	7538
111334	1397	1363442478000	13630	7006	3	0	7539
111335	1726	674969727000	13630	7006	4	0	5685
111336	1726	674968725000	13630	7006	5	0	5686
111338	1726	674966721000	13630	7006	7	0	5688
111339	1726	674965719000	13630	7006	8	0	5689
111340	1726	674964716000	13630	7006	9	0	5690
111341	1726	674963715000	13630	7006	10	0	5691
111343	1726	674961710000	13630	7006	12	0	5693
111344	1726	674960709000	13630	7006	13	0	5694
111345	1726	674959707000	13630	7006	14	0	5695
111346	1726	674958704000	13630	7006	15	0	5696
111347	1397	1363432477000	13631	7007	0	0	7540
111349	1726	674956701000	13631	7007	2	0	5698
111350	1726	674955698000	13631	7007	3	0	5699
111351	1397	1363422476000	13632	7008	0	0	7541
111352	1726	674954696000	13632	7008	1	0	5700
111353	1726	674953693000	13632	7008	2	0	5701
111355	1397	1363402474000	13633	7009	1	0	7543
111384	1397	1363392473000	13636	7010	0	0	7544
111398	1397	1363392473000	13637	7010	0	0	\N
111399	1397	1363382472000	13637	7010	1	0	\N
111400	1726	674952691000	13637	7010	2	0	\N
111401	1726	674951690000	13637	7010	3	0	\N
111402	1726	674950687000	13637	7010	4	0	\N
111403	1726	674949685000	13637	7010	5	0	\N
111404	1726	674948684000	13637	7010	6	0	\N
111405	1726	674947681000	13637	7010	7	0	\N
111406	1726	674946679000	13637	7010	8	0	\N
111407	1726	674945678000	13637	7010	9	0	\N
111408	1726	674944675000	13637	7010	10	0	\N
111409	1726	674943673000	13637	7010	11	0	\N
111410	1726	674942672000	13637	7010	12	0	\N
111411	1726	674941669000	13637	7010	13	0	\N
111412	1397	1363392473000	13638	7010	0	0	\N
111413	1397	1363382472000	13638	7010	1	0	\N
111414	1397	1363372471000	13639	7011	0	0	\N
111415	1397	1363362470000	13639	7011	1	0	\N
111416	1397	1363352469000	13639	7011	2	0	\N
111417	1397	1363342468000	13639	7011	3	0	\N
111418	1726	674940667000	13639	7011	4	0	\N
111419	1726	674939666000	13639	7011	5	0	\N
111420	1726	674938663000	13639	7011	6	0	\N
111421	1726	674937661000	13639	7011	7	0	\N
111422	1726	674936660000	13639	7011	8	0	\N
111423	1726	674935657000	13639	7011	9	0	\N
111424	1726	674934655000	13639	7011	10	0	\N
111425	1726	674933654000	13639	7011	11	0	\N
111426	1726	674932651000	13639	7011	12	0	\N
111427	1726	674931649000	13639	7011	13	0	\N
111428	1726	674930648000	13639	7011	14	0	\N
111429	1726	674929645000	13639	7011	15	0	\N
111454	1397	1363312465000	13643	7014	0	0	\N
111455	1726	674922632000	13643	7014	1	0	\N
111456	1726	674921629000	13643	7014	2	0	\N
111457	1397	1363312465000	13644	7014	0	0	\N
111458	1726	674922632000	13644	7014	1	0	\N
111459	1726	674921629000	13644	7014	2	0	\N
111460	1397	1363312465000	13645	7014	0	0	\N
111461	1726	674922632000	13645	7014	1	0	\N
111462	1726	674921629000	13645	7014	2	0	\N
111463	1397	1363312465000	13646	7014	0	0	\N
111464	1726	674922632000	13646	7014	1	0	\N
111465	1726	674921629000	13646	7014	2	0	\N
111474	1397	1363292463000	13650	7016	0	0	\N
111481	1397	1363262460000	13653	7019	0	0	\N
111482	1726	674913611000	13653	7019	2	0	\N
111483	1726	674912610000	13653	7019	3	0	\N
111484	1397	1363262460000	13655	7019	0	0	\N
111485	1726	674913611000	13655	7019	2	0	\N
111486	1726	674912610000	13655	7019	3	0	\N
111487	1420	714900220000	13657	6731	0	0	\N
111488	2058	571500000	13657	6731	1	0	\N
111489	2058	560500000	13657	6731	2	0	\N
111490	1860	43897977700000	13657	6731	3	0	\N
111491	1673	21606032000000	13657	6731	4	0	\N
111492	1397	1367292863000	13657	6731	5	0	\N
111493	1673	16989952000000	13657	6731	6	0	\N
111494	1673	13875532000000	13657	6731	7	0	\N
111495	1489	21927783400000	13657	6731	8	0	\N
111496	1673	11298692000000	13657	6731	9	0	\N
111497	1489	17352360600000	13657	6731	10	0	\N
111498	1673	11132052000000	13657	6731	11	0	\N
111499	1673	11126092000000	13657	6731	12	0	\N
111500	1397	1367282862000	13657	6731	13	0	\N
111501	1397	1367272861000	13657	6731	14	0	\N
111502	1489	14265048200000	13657	6731	15	0	\N
111503	1489	5663875000000	13657	6731	16	0	\N
111504	1397	1367262860000	13657	6731	17	0	\N
111505	1397	1367252859000	13657	6731	18	0	\N
111506	1397	1367242858000	13657	6731	19	0	\N
111507	1397	1367232857000	13657	6731	20	0	\N
111508	1397	1367222856000	13657	6731	21	0	\N
111509	1397	1367212855000	13657	6731	22	0	\N
111510	1593	16503869000000	13657	6731	23	0	\N
111511	1593	12260859000000	13657	6731	24	0	\N
111512	1593	9397849000000	13657	6731	25	0	\N
111513	1593	7029839000000	13657	6731	26	0	\N
111514	1397	1367202854000	13657	6731	27	0	\N
111515	1397	1367192853000	13657	6731	28	0	\N
111516	1397	1367182852000	13657	6731	29	0	\N
111517	1397	1367172851000	13657	6731	30	0	\N
111518	1397	1367162850000	13657	6731	31	0	\N
111519	1397	1367152849000	13657	6731	32	0	\N
111520	1397	1367142848000	13657	6731	33	0	\N
111387	1726	674951690000	13636	7010	3	0	5703
111388	1726	674950687000	13636	7010	4	0	5704
111389	1726	674949685000	13636	7010	5	0	5705
111390	1726	674948684000	13636	7010	6	0	5706
111391	1726	674947681000	13636	7010	7	0	5707
111393	1726	674945678000	13636	7010	9	0	5709
111394	1726	674944675000	13636	7010	10	0	5710
111395	1726	674943673000	13636	7010	11	0	5711
111396	1726	674942672000	13636	7010	12	0	5712
111397	1726	674941669000	13636	7010	13	0	5713
111431	1397	1363362470000	13640	7011	1	0	7547
111432	1397	1363352469000	13640	7011	2	0	7548
111433	1397	1363342468000	13640	7011	3	0	7549
111434	1726	674940667000	13640	7011	4	0	5714
111436	1726	674938663000	13640	7011	6	0	5716
111437	1726	674937661000	13640	7011	7	0	5717
111438	1726	674936660000	13640	7011	8	0	5718
111439	1726	674935657000	13640	7011	9	0	5719
111440	1726	674934655000	13640	7011	10	0	5720
111442	1726	674932651000	13640	7011	12	0	5722
111443	1726	674931649000	13640	7011	13	0	5723
111444	1726	674930648000	13640	7011	14	0	5724
111445	1726	674929645000	13640	7011	15	0	5725
111446	1397	1363332467000	13641	7012	0	0	7550
111448	1726	674927642000	13641	7012	2	0	5727
111449	1726	674926639000	13641	7012	3	0	5728
111450	1397	1363322466000	13642	7013	0	0	7551
111451	1726	674925637000	13642	7013	1	0	5729
111453	1726	674923633000	13642	7013	3	0	5731
111466	1397	1363312465000	13647	7014	0	0	7552
111467	1726	674922632000	13647	7014	1	0	5732
111468	1726	674921629000	13647	7014	2	0	5733
111469	1397	1363302464000	13648	7015	0	0	7553
111471	1726	674919625000	13648	7015	2	0	5735
111472	1397	1363292463000	13649	7016	0	0	7554
111473	1726	674918622000	13649	7016	1	0	5736
111475	1397	1363282462000	13651	7017	0	0	7555
111476	1726	674917619000	13651	7017	1	0	5737
111478	1397	1363272461000	13652	7018	0	0	7556
111479	1726	674915615000	13652	7018	1	0	5739
111480	1726	674914614000	13652	7018	2	0	5740
111521	606	71419722812962	13657	6731	34	0	\N
111522	606	71418712812962	13657	6731	35	0	\N
111523	606	71417702812962	13657	6731	36	0	\N
111524	1622	20700727904589	13657	6731	37	0	\N
111525	1622	19333009272869	13657	6731	38	0	\N
111526	1622	16882077123349	13657	6731	39	0	\N
111527	1622	15228381110994	13657	6731	40	0	\N
111528	1622	10620228000014	13657	6731	41	0	\N
111529	1402	75948613054315	13657	6731	42	0	\N
111530	1402	75341591013563	13657	6731	43	0	\N
111531	1402	73811009223020	13657	6731	44	0	\N
111532	1402	71696922805115	13657	6731	45	0	\N
111533	1402	69840990933336	13657	6731	46	0	\N
111534	1402	58537998102164	13657	6731	47	0	\N
111535	1402	57329222000778	13657	6731	48	0	\N
111536	1402	46026229169606	13657	6731	49	0	\N
111537	1402	45035463884671	13657	6731	50	0	\N
111538	1402	44407510394246	13657	6731	51	0	\N
111539	1402	41686411935547	13657	6731	52	0	\N
111540	1402	41267772941914	13657	6731	53	0	\N
111541	1402	40018327033785	13657	6731	54	0	\N
111542	1402	38969482557689	13657	6731	55	0	\N
111543	1402	36667013092652	13657	6731	56	0	\N
111544	1402	36363279385211	13657	6731	57	0	\N
111545	1402	36182220718070	13657	6731	58	0	\N
111546	1402	35637993026391	13657	6731	59	0	\N
111547	1402	33680892481120	13657	6731	60	0	\N
111548	1397	1367132847000	13657	6731	61	0	\N
111549	1397	1367122846000	13657	6731	62	0	\N
111550	1397	1367112845000	13657	6731	63	0	\N
111551	1397	1367102844000	13657	6731	64	0	\N
111552	1397	1367092843000	13657	6731	65	0	\N
111553	1397	1367082842000	13657	6731	66	0	\N
111554	1397	1367072841000	13657	6731	67	0	\N
111555	1397	1367062840000	13657	6731	69	0	\N
111556	1397	1367052839000	13657	6731	70	0	\N
111557	1397	1367042838000	13657	6731	71	0	\N
111558	1397	1367032837000	13657	6731	72	0	\N
111559	1397	1367022836000	13657	6731	73	0	\N
111560	1397	1367012835000	13657	6731	74	0	\N
111561	1397	1367002834000	13657	6731	75	0	\N
111562	1397	1366992833000	13657	6731	76	0	\N
111563	1397	1366982832000	13657	6731	77	0	\N
111564	1397	1366972831000	13657	6731	78	0	\N
111565	1397	1366962830000	13657	6731	79	0	\N
111566	1397	1366952829000	13657	6731	80	0	\N
111567	1397	1366942828000	13657	6731	81	0	\N
111568	1397	1366932827000	13657	6731	82	0	\N
111569	1397	1366922826000	13657	6731	83	0	\N
111570	1397	1366912825000	13657	6731	84	0	\N
111571	1397	1366902824000	13657	6731	85	0	\N
111572	1397	1366892823000	13657	6731	86	0	\N
111573	1397	1366882822000	13657	6731	87	0	\N
111574	1397	1366872821000	13657	6731	88	0	\N
111575	1397	1366862820000	13657	6731	89	0	\N
111576	1397	1366852819000	13657	6731	90	0	\N
111577	1397	1366842818000	13657	6731	91	0	\N
111578	1397	1366832817000	13657	6731	92	0	\N
111579	1397	1366822816000	13657	6731	93	0	\N
111580	1397	1366812815000	13657	6731	94	0	\N
111581	1397	1366802814000	13657	6731	95	0	\N
111582	1397	1366792813000	13657	6731	96	0	\N
111583	1397	1366782812000	13657	6731	97	0	\N
111584	1397	1366772811000	13657	6731	98	0	\N
111585	1397	1366762810000	13657	6731	99	0	\N
111586	1397	1366752809000	13657	6731	100	0	\N
111587	1397	1366742808000	13657	6731	101	0	\N
111588	1397	1366732807000	13657	6731	102	0	\N
111589	1397	1366722806000	13657	6731	103	0	\N
111590	1397	1366712805000	13657	6731	104	0	\N
111591	1397	1366702804000	13657	6731	105	0	\N
111592	1397	1366692803000	13657	6731	106	0	\N
111593	1397	1366682802000	13657	6731	107	0	\N
111594	1397	1366672801000	13657	6731	108	0	\N
111595	1397	1366662800000	13657	6731	109	0	\N
111596	1397	1366652799000	13657	6731	110	0	\N
111597	1397	1366642798000	13657	6731	111	0	\N
111598	1397	1366632797000	13657	6731	112	0	\N
111599	1397	1366622796000	13657	6731	113	0	\N
111600	1397	1366612795000	13657	6731	114	0	\N
111601	1397	1366602794000	13657	6731	115	0	\N
111602	1397	1366592793000	13657	6731	116	0	\N
111603	1397	1366582792000	13657	6731	117	0	\N
111604	1397	1366572791000	13657	6731	118	0	\N
111605	1397	1366562790000	13657	6731	119	0	\N
111606	1397	1366552789000	13657	6731	120	0	\N
111607	1397	1366542788000	13657	6731	121	0	\N
111608	1397	1366532787000	13657	6731	122	0	\N
111609	1397	1366522786000	13657	6731	123	0	\N
111610	1397	1366512785000	13657	6731	124	0	\N
111611	1397	1366502784000	13657	6731	125	0	\N
111612	1397	1363262460000	13659	7021	0	0	\N
111613	1397	1363252459000	13659	7021	1	0	\N
111614	1397	1363242458000	13659	7021	2	0	\N
111615	1397	1363232457000	13659	7021	3	0	\N
111616	1397	1363222456000	13659	7021	4	0	\N
111617	1726	674913611000	13659	7021	5	0	\N
111618	1726	674912610000	13659	7021	6	0	\N
111619	1726	674911607000	13659	7021	7	0	\N
111620	1726	674910604000	13659	7021	8	0	\N
111621	1726	674909603000	13659	7021	9	0	\N
111622	1726	674908600000	13659	7021	10	0	\N
111623	1726	674907599000	13659	7021	11	0	\N
111624	1726	674906596000	13659	7021	12	0	\N
111625	1726	674905595000	13659	7021	13	0	\N
111626	1397	1363262460000	13660	7021	0	0	\N
111627	1397	1363252459000	13660	7021	1	0	\N
111628	1397	1363242458000	13660	7021	2	0	\N
111629	1397	1363232457000	13660	7021	3	0	\N
111630	1397	1363222456000	13660	7021	4	0	\N
111631	1726	674913611000	13660	7021	5	0	\N
111632	1726	674912610000	13660	7021	6	0	\N
111633	1726	674911607000	13660	7021	7	0	\N
111634	1726	674910604000	13660	7021	8	0	\N
111635	1726	674909603000	13660	7021	9	0	\N
111636	1726	674908600000	13660	7021	10	0	\N
111637	1726	674907599000	13660	7021	11	0	\N
111638	1726	674906596000	13660	7021	12	0	\N
111653	1601	7986677600000	13662	7022	0	0	\N
111654	1397	1363212455000	13662	7022	1	0	\N
111655	1397	1363202454000	13662	7022	2	0	\N
111656	1601	5990667600000	13662	7022	3	0	\N
111641	1397	1363242458000	13661	7021	2	0	7559
111642	1397	1363232457000	13661	7021	3	0	7560
111643	1397	1363222456000	13661	7021	4	0	7561
111644	1726	674913611000	13661	7021	5	0	5741
111645	1726	674912610000	13661	7021	6	0	5742
111647	1726	674910604000	13661	7021	8	0	5744
111648	1726	674909603000	13661	7021	9	0	5745
111649	1726	674908600000	13661	7021	10	0	5746
111650	1726	674907599000	13661	7021	11	0	5747
111651	1726	674906596000	13661	7021	12	0	5748
111657	1601	4644157600000	13662	7022	4	0	\N
111658	1601	3530147600000	13662	7022	5	0	\N
111659	1397	1363192453000	13662	7022	6	0	\N
111660	1397	1363182452000	13662	7022	7	0	\N
111661	1726	674905595000	13662	7022	8	0	\N
111662	1726	674904592000	13662	7022	9	0	\N
111663	1726	674903591000	13662	7022	10	0	\N
111664	1726	674902588000	13662	7022	11	0	\N
111665	1726	674901587000	13662	7022	12	0	\N
111666	1726	674900584000	13662	7022	13	0	\N
111667	1726	674899583000	13662	7022	14	0	\N
111668	1726	674898580000	13662	7022	15	0	\N
111669	1726	674897579000	13662	7022	16	0	\N
111670	1601	7986677600000	13663	7022	0	0	\N
111671	1397	1363212455000	13663	7022	1	0	\N
111672	1397	1363202454000	13663	7022	2	0	\N
111673	1601	5990667600000	13663	7022	3	0	\N
111674	1601	4644157600000	13663	7022	4	0	\N
111675	1601	3530147600000	13663	7022	5	0	\N
111676	1397	1363192453000	13663	7022	6	0	\N
111677	1397	1363182452000	13663	7022	7	0	\N
111678	1726	674905595000	13663	7022	8	0	\N
111679	1726	674904592000	13663	7022	9	0	\N
111680	1726	674903591000	13663	7022	10	0	\N
111681	1726	674902588000	13663	7022	11	0	\N
111682	1726	674901587000	13663	7022	12	0	\N
111683	1726	674900584000	13663	7022	13	0	\N
111684	1726	674899583000	13663	7022	14	0	\N
111685	1726	674898580000	13663	7022	15	0	\N
111686	1726	674897579000	13663	7022	16	0	\N
111706	1397	1363172451000	13667	7023	0	0	\N
111707	1726	674909166000	13667	7023	1	0	\N
111708	1726	674908165000	13667	7023	2	0	\N
111709	1726	674909166000	13668	7023	0	0	\N
111710	1397	1363162450000	13669	7024	0	0	\N
111711	1726	674907162000	13669	7024	1	0	\N
111712	1726	674906161000	13669	7024	2	0	\N
111716	1397	1363172451000	13671	7024	0	0	\N
111717	1726	674908165000	13671	7024	1	0	\N
111723	1397	1363142448000	13674	7026	0	0	\N
111724	1726	674904157000	13674	7026	1	0	\N
111725	1726	674903154000	13674	7026	2	0	\N
111726	1397	1363132447000	13675	7027	0	0	\N
111727	1726	674902153000	13675	7027	1	0	\N
111728	1726	674901150000	13675	7027	2	0	\N
111735	1397	1363112445000	13678	7029	0	0	\N
111736	1726	674898145000	13678	7029	1	0	\N
111737	1726	674897142000	13678	7029	2	0	\N
111743	1397	1363102444000	13681	7030	0	0	\N
111744	1726	674896139000	13681	7030	1	0	\N
111745	1397	1363102444000	13682	7030	0	0	\N
111746	1726	674896139000	13682	7030	1	0	\N
111754	1397	1363062440000	13684	7032	0	0	\N
111755	1726	674892127000	13684	7032	1	0	\N
111756	1397	1363062440000	13685	7032	0	0	\N
111757	1726	674892127000	13685	7032	1	0	\N
111760	1397	1363062440000	13687	7032	0	0	\N
111761	1726	674892127000	13687	7032	1	0	\N
111762	1679	26027876652000	13688	7033	0	0	\N
111763	1726	674891124000	13688	7033	1	0	\N
111766	1397	1363052439000	13690	7034	0	0	\N
111767	1726	674890121000	13690	7034	1	0	\N
111770	1397	1363042438000	13692	7035	0	0	\N
111771	1397	1363032437000	13692	7035	1	0	\N
111772	1726	674889118000	13692	7035	2	0	\N
111773	1726	674888115000	13692	7035	3	0	\N
111778	2093	100000000	13694	6952	0	0	\N
111779	2058	571500000	13694	6952	1	0	\N
111780	2058	560500000	13694	6952	2	0	\N
111781	1601	7266664600000	13694	6952	3	0	\N
111782	1397	1363852519000	13694	6952	4	0	\N
111783	1679	27218813117000	13694	6952	5	0	\N
111784	1601	5270654600000	13694	6952	6	0	\N
111785	1601	3924144600000	13694	6952	7	0	\N
111786	1601	2810134600000	13694	6952	8	0	\N
111787	1397	1363842518000	13694	6952	9	0	\N
111788	1397	1363832517000	13694	6952	10	0	\N
111789	1397	1363822516000	13694	6952	11	0	\N
111790	1397	1363812515000	13694	6952	12	0	\N
111791	1397	1363802514000	13694	6952	13	0	\N
111792	1397	1363792513000	13694	6952	14	0	\N
111689	1397	1363202454000	13664	7022	2	0	7563
111690	1601	5990667600000	13664	7022	3	0	11
111691	1601	4644157600000	13664	7022	4	0	12
111692	1601	3530147600000	13664	7022	5	0	13
111693	1397	1363192453000	13664	7022	6	0	7564
111695	1726	674917182000	13664	7022	8	0	5750
111696	1726	674916181000	13664	7022	9	0	5751
111697	1726	674915178000	13664	7022	10	0	5752
111698	1726	674914177000	13664	7022	11	0	5753
111699	1726	674913174000	13664	7022	12	0	5754
111701	1726	674911170000	13664	7022	14	0	5756
111702	1726	674910169000	13664	7022	15	0	5757
111703	1397	1363172451000	13666	7023	0	0	7566
111704	1726	674909166000	13666	7023	1	0	5758
111713	1397	1363162450000	13670	7024	0	0	7567
111714	1726	674907162000	13670	7024	1	0	5760
111715	1726	674906161000	13670	7024	2	0	5761
111718	1397	1363152449000	13672	7025	0	0	7568
111719	1726	674905158000	13672	7025	1	0	5762
111721	1726	674904157000	13673	7026	1	0	5763
111722	1726	674903154000	13673	7026	2	0	5764
111729	1397	1363132447000	13676	7027	0	0	7570
111730	1726	674902153000	13676	7027	1	0	5765
111731	1726	674901150000	13676	7027	2	0	5766
111733	1726	674900149000	13677	7028	1	0	5767
111734	1726	674899146000	13677	7028	2	0	5768
111738	1397	1363112445000	13679	7029	0	0	7572
111739	1726	674898145000	13679	7029	1	0	5769
111741	1397	1363102444000	13680	7030	0	0	7573
111742	1726	674896139000	13680	7030	1	0	5771
111747	1397	1363092443000	13683	7031	0	0	7574
111748	1397	1363082442000	13683	7031	1	0	7575
111749	1397	1363072441000	13683	7031	2	0	7576
111751	1726	674895136000	13683	7031	4	0	5772
111752	1726	674894133000	13683	7031	5	0	5773
111753	1726	674893130000	13683	7031	6	0	5774
111758	1397	1363062440000	13686	7032	0	0	7577
111759	1726	674892127000	13686	7032	1	0	5775
111765	1726	674891124000	13689	7033	1	0	5776
111768	1397	1363052439000	13691	7034	0	0	7578
111769	1726	674890121000	13691	7034	1	0	5777
111774	1397	1363042438000	13693	7035	0	0	7579
111776	1726	674889118000	13693	7035	2	0	5778
111777	1726	674888115000	13693	7035	3	0	5779
111793	1397	1363782512000	13694	6952	15	0	\N
111794	1397	1363772511000	13694	6952	16	0	\N
111795	1397	1363762510000	13694	6952	17	0	\N
111796	1397	1363752509000	13694	6952	18	0	\N
111797	1397	1363742508000	13694	6952	19	0	\N
111798	1397	1363732507000	13694	6952	20	0	\N
111799	1397	1363722506000	13694	6952	21	0	\N
111800	1397	1363712505000	13694	6952	22	0	\N
111801	1397	1363702504000	13694	6952	23	0	\N
111802	1397	1363692503000	13694	6952	24	0	\N
111803	1397	1363682502000	13694	6952	25	0	\N
111804	1397	1363672501000	13694	6952	26	0	\N
111805	1397	1363662500000	13694	6952	27	0	\N
111806	1397	1363652499000	13694	6952	28	0	\N
111807	1397	1363642498000	13694	6952	29	0	\N
111808	1397	1363632497000	13694	6952	30	0	\N
111809	1397	1363622496000	13694	6952	31	0	\N
111810	1397	1363612495000	13694	6952	32	0	\N
111811	1397	1363602494000	13694	6952	33	0	\N
111812	1397	1363592493000	13694	6952	34	0	\N
111813	1397	1363582492000	13694	6952	35	0	\N
111814	1397	1363572491000	13694	6952	36	0	\N
111815	1397	1363562490000	13694	6952	37	0	\N
111816	1397	1363552489000	13694	6952	38	0	\N
111817	1397	1363542488000	13694	6952	39	0	\N
111818	1679	26027876652000	13694	6952	40	0	\N
111819	1397	1363532487000	13694	6952	42	0	\N
111820	1397	1363522486000	13694	6952	43	0	\N
111821	1397	1363512485000	13694	6952	44	0	\N
111822	1397	1363502484000	13694	6952	45	0	\N
111823	1397	1363492483000	13694	6952	46	0	\N
111824	1397	1363482482000	13694	6952	47	0	\N
111825	1397	1363472481000	13694	6952	48	0	\N
111826	1397	1363462480000	13694	6952	49	0	\N
111827	1397	1363452479000	13694	6952	50	0	\N
111828	1397	1363442478000	13694	6952	51	0	\N
111829	1397	1363432477000	13694	6952	52	0	\N
111830	1397	1363422476000	13694	6952	53	0	\N
111831	1397	1363412475000	13694	6952	54	0	\N
111832	1397	1363402474000	13694	6952	55	0	\N
111833	1397	1363392473000	13694	6952	56	0	\N
111834	1397	1363382472000	13694	6952	57	0	\N
111835	1397	1363372471000	13694	6952	58	0	\N
111836	1397	1363362470000	13694	6952	59	0	\N
111837	1397	1363352469000	13694	6952	60	0	\N
111838	1397	1363342468000	13694	6952	61	0	\N
111839	1397	1363332467000	13694	6952	62	0	\N
111840	1397	1363322466000	13694	6952	63	0	\N
111841	1397	1363312465000	13694	6952	64	0	\N
111842	1397	1363302464000	13694	6952	65	0	\N
111843	1397	1363292463000	13694	6952	66	0	\N
111844	1397	1363282462000	13694	6952	67	0	\N
111845	1397	1363272461000	13694	6952	68	0	\N
111846	1397	1363262460000	13694	6952	69	0	\N
111847	1397	1363252459000	13694	6952	70	0	\N
111848	1397	1363242458000	13694	6952	71	0	\N
111849	1397	1363232457000	13694	6952	72	0	\N
111850	1397	1363222456000	13694	6952	73	0	\N
111851	1397	1363212455000	13694	6952	74	0	\N
111852	1397	1363202454000	13694	6952	75	0	\N
111853	1397	1363192453000	13694	6952	76	0	\N
111854	1397	1363182452000	13694	6952	77	0	\N
111855	1397	1363172451000	13694	6952	78	0	\N
111856	1397	1363162450000	13694	6952	79	0	\N
111857	1397	1363152449000	13694	6952	80	0	\N
111858	1397	1363142448000	13694	6952	81	0	\N
111859	1397	1363132447000	13694	6952	82	0	\N
111860	1397	1363122446000	13694	6952	83	0	\N
111861	1397	1363112445000	13694	6952	84	0	\N
111862	1397	1363102444000	13694	6952	85	0	\N
111863	1397	1363092443000	13694	6952	86	0	\N
111864	1397	1363082442000	13694	6952	87	0	\N
111865	1397	1363072441000	13694	6952	88	0	\N
111872	1397	1362992433000	13696	7037	0	0	\N
111873	1726	674884103000	13696	7037	1	0	\N
111882	1397	1362962430000	13701	7040	0	0	\N
111883	1726	674881094000	13701	7040	1	0	\N
111888	1397	1362952429000	13703	7041	0	0	\N
111889	1397	1362942428000	13703	7041	1	0	\N
111890	1726	674880091000	13703	7041	2	0	\N
111891	1726	674879088000	13703	7041	3	0	\N
111892	2058	571500000	13704	6907	0	0	\N
111893	2058	560500000	13704	6907	1	0	\N
111894	1601	6546645600000	13704	6907	2	0	\N
111895	1679	27218813117000	13704	6907	3	0	\N
111896	1601	4550635600000	13704	6907	4	0	\N
111897	1601	3204125600000	13704	6907	5	0	\N
111898	1601	2090115600000	13704	6907	6	0	\N
111899	1622	20700727904589	13704	6907	7	0	\N
111900	1622	19333009272869	13704	6907	8	0	\N
111901	1622	16882077123349	13704	6907	9	0	\N
111902	1622	15228381110994	13704	6907	10	0	\N
111903	1622	10620228000014	13704	6907	11	0	\N
111904	1679	26027876652000	13704	6907	12	0	\N
111905	2077	1438999000000	13704	6907	13	0	\N
111906	2077	1438998000000	13704	6907	14	0	\N
111919	1397	1362882422000	13709	7046	0	0	\N
111920	1726	674871068000	13709	7046	1	0	\N
111921	1726	674870067000	13709	7046	2	0	\N
111922	1726	674869064000	13709	7046	3	0	\N
111923	1397	1362882422000	13710	7046	0	0	\N
111924	1726	674871068000	13710	7046	1	0	\N
111925	1726	674870067000	13710	7046	2	0	\N
111926	1726	674869064000	13710	7046	3	0	\N
111927	1397	1362882422000	13711	7046	0	0	\N
111928	1726	674871068000	13711	7046	1	0	\N
111868	1397	1363002434000	13695	7036	2	0	7583
111869	1726	674887112000	13695	7036	3	0	5780
111870	1726	674886109000	13695	7036	4	0	5781
111871	1726	674885106000	13695	7036	5	0	5782
111874	1397	1362992433000	13697	7037	0	0	7584
111876	1397	1362982432000	13698	7038	0	0	7585
111877	1726	674883100000	13698	7038	1	0	5784
111878	1397	1362972431000	13699	7039	0	0	7586
111879	1726	674882097000	13699	7039	1	0	5785
111880	1397	1362962430000	13700	7040	0	0	7587
111884	1397	1362952429000	13702	7041	0	0	7588
111885	1397	1362942428000	13702	7041	1	0	7589
111886	1726	674880091000	13702	7041	2	0	5787
111887	1726	674879088000	13702	7041	3	0	5788
111908	1726	674878085000	13705	7042	1	0	5789
111909	1397	1362922426000	13706	7043	0	0	7591
111910	1397	1362912425000	13706	7043	1	0	7592
111911	1726	674877082000	13706	7043	2	0	5790
111912	1726	674876079000	13706	7043	3	0	5791
111914	1726	674875076000	13707	7044	1	0	5792
111915	1397	1362892423000	13708	7045	0	0	7594
111916	1726	674874074000	13708	7045	1	0	5793
111917	1726	674873073000	13708	7045	2	0	5794
111918	1726	674872070000	13708	7045	3	0	5795
111929	1726	674870067000	13711	7046	2	0	\N
111930	1726	674869064000	13711	7046	3	0	\N
111944	631	66718901000000	13714	7047	0	0	\N
111945	1397	1362872421000	13714	7047	1	0	\N
111946	1397	1362862420000	13714	7047	2	0	\N
111947	1726	674868062000	13714	7047	3	0	\N
111948	1726	674867061000	13714	7047	4	0	\N
111949	1726	674866058000	13714	7047	5	0	\N
111950	1726	674865056000	13714	7047	6	0	\N
111951	1726	674864055000	13714	7047	7	0	\N
111952	1726	674863052000	13714	7047	8	0	\N
111978	1397	1362792413000	13718	7051	0	0	\N
111979	1726	674845016000	13718	7051	1	0	\N
111980	1726	674844014000	13718	7051	2	0	\N
111981	1726	674843013000	13718	7051	3	0	\N
111986	1397	1362792413000	13720	7051	0	0	\N
111987	1726	674845016000	13720	7051	1	0	\N
111988	1726	674844014000	13720	7051	2	0	\N
111989	1726	674843013000	13720	7051	3	0	\N
111990	1397	1362782412000	13721	7052	0	0	\N
111991	1726	674842010000	13721	7052	1	0	\N
111992	1726	674841008000	13721	7052	2	0	\N
111993	1726	674840007000	13721	7052	3	0	\N
112007	1397	1362762410000	13725	7054	0	0	\N
112008	1726	674835998000	13725	7054	1	0	\N
112009	1726	674834996000	13725	7054	2	0	\N
112010	1726	674833995000	13725	7054	3	0	\N
112011	2099	718498000000	13725	7054	4	0	\N
112012	1397	1362752409000	13726	7055	0	0	\N
112013	1726	674832992000	13726	7055	1	0	\N
112014	1726	674831990000	13726	7055	2	0	\N
112015	1726	674830989000	13726	7055	3	0	\N
112024	1397	1362742408000	13729	7056	0	0	\N
112025	1726	674832992000	13729	7056	1	0	\N
112026	1726	674831990000	13729	7056	2	0	\N
112027	1726	674830989000	13729	7056	3	0	\N
112028	1726	674829986000	13729	7056	4	0	\N
112029	1726	674828984000	13729	7056	5	0	\N
112030	1726	674827983000	13729	7056	6	0	\N
112039	1397	1362712405000	13732	7059	0	0	\N
112040	1726	674820968000	13732	7059	1	0	\N
112041	1726	674819966000	13732	7059	2	0	\N
112042	1726	674818965000	13732	7059	3	0	\N
112047	1397	1362712405000	13734	7059	0	0	\N
112048	1726	674820968000	13734	7059	1	0	\N
112049	1726	674819966000	13734	7059	2	0	\N
112050	1726	674818965000	13734	7059	3	0	\N
112051	1397	1362712405000	13735	7059	0	0	\N
112052	1726	674820968000	13735	7059	1	0	\N
112053	1726	674819966000	13735	7059	2	0	\N
112054	1397	1362702404000	13736	7060	0	0	\N
112055	1726	674817962000	13736	7060	1	0	\N
112056	1726	674816960000	13736	7060	2	0	\N
112060	1397	1362692403000	13738	7061	0	0	\N
112061	1726	674815959000	13738	7061	1	0	\N
112062	1726	674814956000	13738	7061	2	0	\N
112063	1726	674813954000	13738	7061	3	0	\N
111933	1726	674870067000	13712	7046	2	0	5797
111934	1726	674869064000	13712	7046	3	0	5798
111935	631	66718901000000	13713	7047	0	0	1
111936	1397	1362872421000	13713	7047	1	0	7596
111937	1397	1362862420000	13713	7047	2	0	7597
111939	1726	674867061000	13713	7047	4	0	5800
111940	1726	674866058000	13713	7047	5	0	5801
111941	1726	674865056000	13713	7047	6	0	5802
111942	1726	674864055000	13713	7047	7	0	5803
111943	1726	674863052000	13713	7047	8	0	5804
111954	1397	1362852419000	13715	7048	1	0	7598
111955	1397	1362842418000	13715	7048	2	0	7599
111956	1726	674862050000	13715	7048	3	0	5805
111957	1726	674861049000	13715	7048	4	0	5806
111959	1726	674859044000	13715	7048	6	0	5808
111960	1726	674858043000	13715	7048	7	0	5809
111961	1726	674857040000	13715	7048	8	0	5810
111962	1397	1362832417000	13716	7049	0	0	7600
111963	1397	1362822416000	13716	7049	1	0	7601
111965	1726	674855037000	13716	7049	3	0	5812
111966	1726	674854034000	13716	7049	4	0	5813
111967	1726	674853032000	13716	7049	5	0	5814
111968	1726	674852031000	13716	7049	6	0	5815
111969	1726	674851028000	13716	7049	7	0	5816
111971	1397	1362812415000	13717	7050	0	0	7602
111972	1397	1362802414000	13717	7050	1	0	7603
111973	1726	674850026000	13717	7050	2	0	5817
111974	1726	674849025000	13717	7050	3	0	5818
111976	1726	674847020000	13717	7050	5	0	5820
111977	1726	674846019000	13717	7050	6	0	5821
111982	1397	1362792413000	13719	7051	0	0	7604
111983	1726	674845016000	13719	7051	1	0	5822
111984	1726	674844014000	13719	7051	2	0	5823
111994	1397	1362782412000	13722	7052	0	0	7605
111995	1726	674842010000	13722	7052	1	0	5825
111996	1726	674841008000	13722	7052	2	0	5826
111997	1726	674840007000	13722	7052	3	0	5827
111998	1397	1362772411000	13723	7053	0	0	7606
112000	1726	674838002000	13723	7053	2	0	5829
112001	1726	674837001000	13723	7053	3	0	5830
112002	1397	1362762410000	13724	7054	0	0	7607
112003	1726	674835998000	13724	7054	1	0	5831
112005	1726	674833995000	13724	7054	3	0	5833
112006	2099	718498000000	13724	7054	4	0	2
112016	1397	1362752409000	13727	7055	0	0	7608
112017	1397	1362742408000	13728	7056	0	0	7609
112018	1726	674832992000	13728	7056	1	0	5834
112020	1726	674830989000	13728	7056	3	0	5836
112021	1726	674829986000	13728	7056	4	0	5837
112022	1726	674828984000	13728	7056	5	0	5838
112023	1726	674827983000	13728	7056	6	0	5839
112031	1397	1362732407000	13730	7057	0	0	7610
112033	1726	674825978000	13730	7057	2	0	5841
112034	1726	674824977000	13730	7057	3	0	5842
112035	1397	1362722406000	13731	7058	0	0	7611
112036	1726	674823974000	13731	7058	1	0	5843
112038	1726	674821971000	13731	7058	3	0	5845
112043	1397	1362712405000	13733	7059	0	0	7612
112044	1726	674820968000	13733	7059	1	0	5846
112045	1726	674819966000	13733	7059	2	0	5847
112046	1726	674818965000	13733	7059	3	0	5848
112058	1726	674817962000	13737	7060	1	0	5849
112059	1726	674816960000	13737	7060	2	0	5850
112064	1397	1362692403000	13739	7061	0	0	7614
112068	1397	1362692403000	13740	7061	0	0	\N
112069	1726	674815959000	13740	7061	1	0	\N
112070	1726	674814956000	13740	7061	2	0	\N
112071	1726	674813954000	13740	7061	3	0	\N
112092	1397	1362682402000	13742	7062	0	0	\N
112093	1397	1362672401000	13742	7062	1	0	\N
112094	1397	1362662400000	13742	7062	2	0	\N
112095	1397	1362652399000	13742	7062	3	0	\N
112096	1397	1362642398000	13742	7062	4	0	\N
112097	1726	674812953000	13742	7062	5	0	\N
112098	1726	674811950000	13742	7062	6	0	\N
112099	1726	674810948000	13742	7062	7	0	\N
112100	1726	674809947000	13742	7062	8	0	\N
112101	1726	674808944000	13742	7062	9	0	\N
112102	1726	674807942000	13742	7062	10	0	\N
112103	1726	674806941000	13742	7062	11	0	\N
112104	1726	674805938000	13742	7062	12	0	\N
112105	1726	674804936000	13742	7062	13	0	\N
112106	1726	674803935000	13742	7062	14	0	\N
112107	1726	674802932000	13742	7062	15	0	\N
112108	1726	674801930000	13742	7062	16	0	\N
112109	1726	674800929000	13742	7062	17	0	\N
112110	1726	674799926000	13742	7062	18	0	\N
112111	1726	674798924000	13742	7062	19	0	\N
112112	1397	1362682402000	13743	7062	0	0	\N
112113	1397	1362672401000	13743	7062	1	0	\N
112114	1397	1362662400000	13743	7062	2	0	\N
112115	1397	1362652399000	13743	7062	3	0	\N
112116	1397	1362642398000	13743	7062	4	0	\N
112117	1726	674812953000	13743	7062	5	0	\N
112118	1726	674811950000	13743	7062	6	0	\N
112119	1726	674810948000	13743	7062	7	0	\N
112120	1726	674809947000	13743	7062	8	0	\N
112121	1726	674808944000	13743	7062	9	0	\N
112122	1726	674807942000	13743	7062	10	0	\N
112123	1726	674806941000	13743	7062	11	0	\N
112124	1726	674805938000	13743	7062	12	0	\N
112125	1726	674804936000	13743	7062	13	0	\N
112126	1726	674803935000	13743	7062	14	0	\N
112127	1726	674802932000	13743	7062	15	0	\N
112128	1726	674801930000	13743	7062	16	0	\N
112129	1726	674800929000	13743	7062	17	0	\N
112130	1726	674799926000	13743	7062	18	0	\N
112131	1726	674798924000	13743	7062	19	0	\N
112132	1397	1362682402000	13744	7062	0	0	\N
112133	1397	1362672401000	13744	7062	1	0	\N
112134	1397	1362662400000	13744	7062	2	0	\N
112135	1397	1362652399000	13744	7062	3	0	\N
112136	1397	1362642398000	13744	7062	4	0	\N
112137	1726	674812953000	13744	7062	5	0	\N
112138	1726	674811950000	13744	7062	6	0	\N
112139	1726	674810948000	13744	7062	7	0	\N
112140	1726	674809947000	13744	7062	8	0	\N
112141	1726	674808944000	13744	7062	9	0	\N
112142	1726	674807942000	13744	7062	10	0	\N
112143	1726	674806941000	13744	7062	11	0	\N
112144	1726	674805938000	13744	7062	12	0	\N
112145	1726	674804936000	13744	7062	13	0	\N
112146	1726	674803935000	13744	7062	14	0	\N
112147	1726	674802932000	13744	7062	15	0	\N
112148	1726	674801930000	13744	7062	16	0	\N
112149	1726	674800929000	13744	7062	17	0	\N
112150	1726	674799926000	13744	7062	18	0	\N
112151	1726	674798924000	13744	7062	19	0	\N
112152	1397	1362682402000	13745	7062	0	0	\N
112153	1397	1362672401000	13745	7062	1	0	\N
112154	1397	1362662400000	13745	7062	2	0	\N
112155	1397	1362652399000	13745	7062	3	0	\N
112156	1397	1362642398000	13745	7062	4	0	\N
112161	1397	1362632397000	13747	7063	0	0	\N
112162	1397	1362622396000	13748	7064	0	0	\N
112163	1397	1362612395000	13748	7064	1	0	\N
112164	1726	674794917000	13748	7064	2	0	\N
112165	1726	674793914000	13748	7064	3	0	\N
112166	1726	674792912000	13748	7064	4	0	\N
112167	1726	674791911000	13748	7064	5	0	\N
112168	1726	674790908000	13748	7064	6	0	\N
112176	1397	1362602394000	13750	7065	0	0	\N
112177	1726	674789906000	13750	7065	1	0	\N
112178	1726	674788905000	13750	7065	2	0	\N
112179	1726	674787902000	13750	7065	3	0	\N
112180	1726	674786900000	13750	7065	4	0	\N
112181	1726	674785899000	13750	7065	5	0	\N
112182	1726	674784896000	13750	7065	6	0	\N
112198	1397	1362582392000	13754	7067	0	0	\N
112199	1726	674780888000	13754	7067	1	0	\N
112200	1726	674779887000	13754	7067	2	0	\N
112067	1726	674813954000	13739	7061	3	0	5853
112072	1397	1362682402000	13741	7062	0	0	7615
112073	1397	1362672401000	13741	7062	1	0	7616
112074	1397	1362662400000	13741	7062	2	0	7617
112075	1397	1362652399000	13741	7062	3	0	7618
112077	1726	674812953000	13741	7062	5	0	5854
112078	1726	674811950000	13741	7062	6	0	5855
112079	1726	674810948000	13741	7062	7	0	5856
112080	1726	674809947000	13741	7062	8	0	5857
112081	1726	674808944000	13741	7062	9	0	5858
112083	1726	674806941000	13741	7062	11	0	5860
112084	1726	674805938000	13741	7062	12	0	5861
112085	1726	674804936000	13741	7062	13	0	5862
112086	1726	674803935000	13741	7062	14	0	5863
112088	1726	674801930000	13741	7062	16	0	5865
112089	1726	674800929000	13741	7062	17	0	5866
112090	1726	674799926000	13741	7062	18	0	5867
112091	1726	674798924000	13741	7062	19	0	5868
112157	1397	1362632397000	13746	7063	0	0	7620
112159	1726	674796920000	13746	7063	2	0	5870
112160	1726	674795918000	13746	7063	3	0	5871
112169	1397	1362622396000	13749	7064	0	0	7621
112170	1397	1362612395000	13749	7064	1	0	7622
112171	1726	674794917000	13749	7064	2	0	5872
112173	1726	674792912000	13749	7064	4	0	5874
112174	1726	674791911000	13749	7064	5	0	5875
112175	1726	674790908000	13749	7064	6	0	5876
112183	1397	1362602394000	13751	7065	0	0	7623
112185	1726	674788905000	13751	7065	2	0	5878
112186	1726	674787902000	13751	7065	3	0	5879
112187	1726	674786900000	13751	7065	4	0	5880
112188	1726	674785899000	13751	7065	5	0	5881
112189	1726	674784896000	13751	7065	6	0	5882
112191	1726	674783894000	13752	7066	1	0	5883
112192	1726	674782893000	13752	7066	2	0	5884
112193	1726	674781890000	13752	7066	3	0	5885
112194	1397	1362582392000	13753	7067	0	0	7625
112195	1726	674780888000	13753	7067	1	0	5886
112197	1726	674778884000	13753	7067	3	0	5888
112201	1726	674778884000	13754	7067	3	0	\N
112206	1397	1362562390000	13756	7069	0	0	\N
112207	1397	1362552389000	13756	7069	1	0	\N
112208	1726	674774876000	13756	7069	2	0	\N
112209	1726	674773875000	13756	7069	3	0	\N
112210	1726	674772872000	13756	7069	4	0	\N
112211	1726	674771870000	13756	7069	5	0	\N
112212	1726	674770869000	13756	7069	6	0	\N
112213	1726	674769866000	13756	7069	7	0	\N
112222	1397	1362562390000	13758	7069	0	0	\N
112223	1397	1362552389000	13758	7069	1	0	\N
112224	1726	674774876000	13758	7069	2	0	\N
112225	1726	674773875000	13758	7069	3	0	\N
112226	1726	674772872000	13758	7069	4	0	\N
112227	1726	674771870000	13758	7069	5	0	\N
112228	1726	674770869000	13758	7069	6	0	\N
112229	1726	674769866000	13758	7069	7	0	\N
112230	1397	1362562390000	13759	7069	0	0	\N
112231	1397	1362552389000	13759	7069	1	0	\N
112232	1726	674774876000	13759	7069	2	0	\N
112233	1726	674773875000	13759	7069	3	0	\N
112234	1726	674772872000	13759	7069	4	0	\N
112235	1726	674771870000	13759	7069	5	0	\N
112236	1726	674770869000	13759	7069	6	0	\N
112237	1726	674769866000	13759	7069	7	0	\N
112238	1397	1362562390000	13760	7069	0	0	\N
112239	1397	1362552389000	13760	7069	1	0	\N
112240	1726	674774876000	13760	7069	2	0	\N
112241	1397	1362542388000	13761	7070	0	0	\N
112246	1397	1362532387000	13763	7071	0	0	\N
112247	1726	674765858000	13763	7071	1	0	\N
112248	1726	674764857000	13763	7071	2	0	\N
112249	1726	674763854000	13763	7071	3	0	\N
112258	1397	1362522386000	13766	7072	0	0	\N
112259	1726	674762852000	13766	7072	1	0	\N
112260	1726	674761851000	13766	7072	2	0	\N
112261	1726	674760848000	13766	7072	3	0	\N
112274	1397	1362502384000	13769	7074	0	0	\N
112275	1397	1362492383000	13769	7074	1	0	\N
112276	1726	674756840000	13769	7074	2	0	\N
112277	1726	674755839000	13769	7074	3	0	\N
112278	1726	674754836000	13769	7074	4	0	\N
112279	1726	674753834000	13769	7074	5	0	\N
112280	1726	674752833000	13769	7074	6	0	\N
112281	1726	674751830000	13769	7074	7	0	\N
112282	1397	1362482382000	13770	7075	0	0	\N
112291	1397	1362472381000	13773	7076	0	0	\N
112292	1726	674747822000	13773	7076	1	0	\N
112293	1726	674746821000	13773	7076	2	0	\N
112294	1726	674745818000	13773	7076	3	0	\N
112295	1397	1362462380000	13776	7078	0	0	\N
112296	1397	1362452379000	13776	7078	1	0	\N
112297	1397	1362442378000	13776	7078	2	0	\N
112298	1397	1362432377000	13776	7078	3	0	\N
112299	1726	674744816000	13776	7078	4	0	\N
112300	1726	674743815000	13776	7078	5	0	\N
112301	1726	674742812000	13776	7078	6	0	\N
112302	1726	674741810000	13776	7078	7	0	\N
112303	1726	674740809000	13776	7078	8	0	\N
112304	1726	674739806000	13776	7078	9	0	\N
112305	1726	674738804000	13776	7078	10	0	\N
112306	1726	674737803000	13776	7078	11	0	\N
112307	1726	674736800000	13776	7078	12	0	\N
112308	1726	674735798000	13776	7078	13	0	\N
112309	1726	674734797000	13776	7078	14	0	\N
112310	1726	674733794000	13776	7078	15	0	\N
112327	631	66718901000000	13781	7030	0	0	\N
112328	631	66000801000000	13781	7030	1	0	\N
112329	1397	1363102444000	13781	7030	2	0	\N
112330	1397	1363092443000	13781	7030	3	0	\N
112331	1397	1363082442000	13781	7030	4	0	\N
112332	1397	1363072441000	13781	7030	5	0	\N
112333	1679	27218813117000	13781	7030	6	0	\N
112334	1397	1363062440000	13781	7030	7	0	\N
112335	1397	1363052439000	13781	7030	8	0	\N
112336	1397	1363042438000	13781	7030	9	0	\N
112204	1726	674776881000	13755	7068	2	0	5890
112205	1726	674775878000	13755	7068	3	0	5891
112214	1397	1362562390000	13757	7069	0	0	7627
112215	1397	1362552389000	13757	7069	1	0	7628
112216	1726	674774876000	13757	7069	2	0	5892
112218	1726	674772872000	13757	7069	4	0	5894
112219	1726	674771870000	13757	7069	5	0	5895
112220	1726	674770869000	13757	7069	6	0	5896
112221	1726	674769866000	13757	7069	7	0	5897
112242	1397	1362542388000	13762	7070	0	0	7629
112244	1726	674767863000	13762	7070	2	0	5899
112245	1726	674766860000	13762	7070	3	0	5900
112250	1397	1362532387000	13764	7071	0	0	7630
112251	1726	674765858000	13764	7071	1	0	5901
112253	1726	674763854000	13764	7071	3	0	5903
112254	1397	1362522386000	13765	7072	0	0	7631
112255	1726	674762852000	13765	7072	1	0	5904
112256	1726	674761851000	13765	7072	2	0	5905
112257	1726	674760848000	13765	7072	3	0	5906
112263	1726	674759846000	13767	7073	1	0	5907
112264	1726	674758845000	13767	7073	2	0	5908
112265	1726	674757842000	13767	7073	3	0	5909
112266	1397	1362502384000	13768	7074	0	0	7633
112267	1397	1362492383000	13768	7074	1	0	7634
112269	1726	674755839000	13768	7074	3	0	5911
112270	1726	674754836000	13768	7074	4	0	5912
112271	1726	674753834000	13768	7074	5	0	5913
112272	1726	674752833000	13768	7074	6	0	5914
112283	1397	1362482382000	13771	7075	0	0	7635
112284	1726	674750828000	13771	7075	1	0	5916
112285	1726	674749827000	13771	7075	2	0	5917
112286	1726	674748824000	13771	7075	3	0	5918
112287	1397	1362472381000	13772	7076	0	0	7636
112289	1726	674746821000	13772	7076	2	0	5920
112290	1726	674745818000	13772	7076	3	0	5921
112311	1397	1362462380000	13778	7078	0	0	7637
112312	1397	1362452379000	13778	7078	1	0	7638
112313	1397	1362442378000	13778	7078	2	0	7639
112315	1726	674744816000	13778	7078	4	0	5922
112316	1726	674743815000	13778	7078	5	0	5923
112317	1726	674742812000	13778	7078	6	0	5924
112318	1726	674741810000	13778	7078	7	0	5925
112320	1726	674739806000	13778	7078	9	0	5927
112321	1726	674738804000	13778	7078	10	0	5928
112322	1726	674737803000	13778	7078	11	0	5929
112323	1726	674736800000	13778	7078	12	0	5930
112324	1726	674735798000	13778	7078	13	0	5931
112326	1726	674733794000	13778	7078	15	0	5933
112337	1397	1363032437000	13781	7030	10	0	\N
112338	1679	26027876652000	13781	7030	11	0	\N
112339	1397	1363022436000	13781	7030	12	0	\N
112340	1397	1363012435000	13781	7030	13	0	\N
112341	1397	1363002434000	13781	7030	14	0	\N
112342	1397	1362992433000	13781	7030	15	0	\N
112343	1397	1362982432000	13781	7030	16	0	\N
112344	1397	1362972431000	13781	7030	17	0	\N
112345	1397	1362962430000	13781	7030	18	0	\N
112346	1397	1362952429000	13781	7030	19	0	\N
112347	1397	1362942428000	13781	7030	20	0	\N
112348	1397	1362932427000	13781	7030	21	0	\N
112349	1397	1362922426000	13781	7030	22	0	\N
112350	1397	1362912425000	13781	7030	23	0	\N
112351	1397	1362902424000	13781	7030	24	0	\N
112352	1397	1362892423000	13781	7030	25	0	\N
112353	1397	1362882422000	13781	7030	26	0	\N
112354	1397	1362872421000	13781	7030	27	0	\N
112355	1397	1362862420000	13781	7030	28	0	\N
112356	1397	1362852419000	13781	7030	29	0	\N
112357	1397	1362842418000	13781	7030	30	0	\N
112358	1397	1362832417000	13781	7030	31	0	\N
112359	1397	1362822416000	13781	7030	32	0	\N
112360	1397	1362812415000	13781	7030	33	0	\N
112361	1397	1362802414000	13781	7030	34	0	\N
112362	1397	1362792413000	13781	7030	35	0	\N
112363	1397	1362782412000	13781	7030	36	0	\N
112364	1397	1362772411000	13781	7030	37	0	\N
112365	1397	1362762410000	13781	7030	38	0	\N
112366	1397	1362752409000	13781	7030	39	0	\N
112367	1397	1362742408000	13781	7030	40	0	\N
112368	1397	1362732407000	13781	7030	41	0	\N
112369	1397	1362722406000	13781	7030	42	0	\N
112370	1397	1362712405000	13781	7030	43	0	\N
112371	1397	1362702404000	13781	7030	44	0	\N
112372	1397	1362692403000	13781	7030	45	0	\N
112373	1397	1362682402000	13781	7030	46	0	\N
112374	1397	1362672401000	13781	7030	47	0	\N
112375	1397	1362662400000	13781	7030	48	0	\N
112376	1397	1362652399000	13781	7030	49	0	\N
112377	1397	1362642398000	13781	7030	50	0	\N
112378	1397	1362632397000	13781	7030	51	0	\N
112379	1397	1362622396000	13781	7030	52	0	\N
112380	1397	1362612395000	13781	7030	53	0	\N
112381	1397	1362602394000	13781	7030	54	0	\N
112382	1397	1362592393000	13781	7030	55	0	\N
112383	1397	1362582392000	13781	7030	56	0	\N
112384	1397	1362572391000	13781	7030	57	0	\N
112385	1397	1362562390000	13781	7030	58	0	\N
112386	1397	1362552389000	13781	7030	60	0	\N
112387	1397	1362542388000	13781	7030	61	0	\N
112388	1397	1362532387000	13781	7030	62	0	\N
112389	1397	1362522386000	13781	7030	63	0	\N
112390	1397	1362512385000	13781	7030	64	0	\N
112391	1397	1362502384000	13781	7030	65	0	\N
112392	1397	1362492383000	13781	7030	66	0	\N
112393	1397	1362482382000	13781	7030	67	0	\N
112394	1397	1362472381000	13781	7030	68	0	\N
112395	1397	1362462380000	13781	7030	69	0	\N
112396	1397	1362452379000	13781	7030	70	0	\N
112397	1397	1362442378000	13781	7030	71	0	\N
112398	1397	1362432377000	13781	7030	72	0	\N
112399	1397	1362422376000	13781	7030	73	0	\N
112400	1726	674896139000	13781	7030	74	0	\N
112401	1726	674895136000	13781	7030	75	0	\N
112402	1726	674894133000	13781	7030	76	0	\N
112403	1726	674893130000	13781	7030	77	0	\N
112404	1726	674892127000	13781	7030	78	0	\N
112405	1726	674891124000	13781	7030	79	0	\N
112406	1726	674890121000	13781	7030	80	0	\N
112407	1726	674889118000	13781	7030	81	0	\N
112408	1726	674888115000	13781	7030	82	0	\N
112409	1726	674887112000	13781	7030	83	0	\N
112410	1726	674886109000	13781	7030	84	0	\N
112411	1726	674885106000	13781	7030	85	0	\N
112412	1726	674884103000	13781	7030	86	0	\N
112413	1726	674883100000	13781	7030	87	0	\N
112414	1726	674882097000	13781	7030	88	0	\N
112415	1726	674881094000	13781	7030	89	0	\N
112416	1726	674880091000	13781	7030	90	0	\N
112417	1726	674879088000	13781	7030	91	0	\N
112418	1726	674878085000	13781	7030	92	0	\N
112419	1726	674877082000	13781	7030	93	0	\N
112420	1726	674876079000	13781	7030	94	0	\N
112421	1726	674875076000	13781	7030	95	0	\N
112422	1726	674874074000	13781	7030	96	0	\N
112423	1726	674873073000	13781	7030	97	0	\N
112424	1726	674872070000	13781	7030	98	0	\N
112425	1726	674871068000	13781	7030	99	0	\N
112426	1726	674870067000	13781	7030	100	0	\N
112427	1726	674869064000	13781	7030	101	0	\N
112428	1726	674868062000	13781	7030	102	0	\N
112429	1726	674867061000	13781	7030	103	0	\N
112430	1726	674866058000	13781	7030	104	0	\N
112431	1726	674865056000	13781	7030	105	0	\N
112432	1726	674864055000	13781	7030	106	0	\N
112433	1726	674863052000	13781	7030	107	0	\N
112434	1726	674862050000	13781	7030	108	0	\N
112435	1726	674861049000	13781	7030	109	0	\N
112436	1726	674860046000	13781	7030	110	0	\N
112437	1726	674859044000	13781	7030	111	0	\N
112438	1726	674858043000	13781	7030	112	0	\N
112439	1726	674857040000	13781	7030	113	0	\N
112440	1726	674856038000	13781	7030	114	0	\N
112441	1726	674855037000	13781	7030	115	0	\N
112442	1726	674854034000	13781	7030	116	0	\N
112443	1726	674853032000	13781	7030	117	0	\N
112444	1726	674852031000	13781	7030	118	0	\N
112445	1726	674851028000	13781	7030	119	0	\N
112446	1726	674850026000	13781	7030	120	0	\N
112447	1726	674849025000	13781	7030	121	0	\N
112448	1726	674848022000	13781	7030	122	0	\N
112449	1726	674847020000	13781	7030	123	0	\N
112450	1726	674846019000	13781	7030	124	0	\N
112451	1726	674845016000	13781	7030	125	0	\N
112456	1397	1362412375000	13783	7080	0	0	\N
112457	1397	1362402374000	13783	7080	1	0	\N
112458	1726	674729786000	13783	7080	2	0	\N
112459	1726	674728783000	13783	7080	3	0	\N
112460	1726	674727781000	13783	7080	4	0	\N
112461	1726	674726778000	13783	7080	5	0	\N
112454	1726	674731791000	13782	7079	2	0	5935
112455	1726	674730788000	13782	7079	3	0	5936
112462	1397	1362412375000	13784	7080	0	0	7642
112463	1397	1362402374000	13784	7080	1	0	7643
112464	1726	674729786000	13784	7080	2	0	5937
112466	1726	674727781000	13784	7080	4	0	5939
112467	1726	674726778000	13784	7080	5	0	5940
112468	1397	1362392373000	13785	7081	0	0	7644
112469	1591	718412000000	13785	7081	1	0	1
112470	1726	674725776000	13785	7081	2	0	5941
112472	1726	674723772000	13785	7081	4	0	5943
112473	1397	1362382372000	13786	7082	0	0	\N
112474	1397	1362372371000	13786	7082	1	0	\N
112475	1726	674722770000	13786	7082	2	0	\N
112476	1726	674721767000	13786	7082	3	0	\N
112477	1726	674720766000	13786	7082	4	0	\N
112478	1726	674719764000	13786	7082	5	0	\N
112479	1726	674718761000	13786	7082	6	0	\N
112480	1726	674717760000	13786	7082	7	0	\N
112481	1397	1362382372000	13787	7082	0	0	\N
112482	1397	1362372371000	13787	7082	1	0	\N
112483	1726	674722770000	13787	7082	2	0	\N
112484	1726	674721767000	13787	7082	3	0	\N
112485	1726	674720766000	13787	7082	4	0	\N
112486	1726	674719764000	13787	7082	5	0	\N
112487	1726	674718761000	13787	7082	6	0	\N
112488	1726	674717760000	13787	7082	7	0	\N
112489	1397	1362382372000	13788	7082	0	0	\N
112490	1397	1362372371000	13788	7082	1	0	\N
112491	1726	674722770000	13788	7082	2	0	\N
112492	1726	674721767000	13788	7082	3	0	\N
112493	1726	674720766000	13788	7082	4	0	\N
112494	1726	674719764000	13788	7082	5	0	\N
112495	1726	674718761000	13788	7082	6	0	\N
112496	1726	674717760000	13788	7082	7	0	\N
112505	1397	1362362370000	13790	7083	0	0	\N
112506	2100	890000000	13790	7083	1	0	\N
112507	1726	674716758000	13790	7083	2	0	\N
112508	1726	674715755000	13790	7083	3	0	\N
112509	1726	674714754000	13790	7083	4	0	\N
112510	1397	1362362370000	13791	7083	0	0	\N
112511	1726	674716758000	13791	7083	1	0	\N
112512	1726	674715755000	13791	7083	2	0	\N
112513	1726	674714754000	13791	7083	3	0	\N
112519	1397	1362352369000	13793	7084	0	0	\N
112520	1726	674713752000	13793	7084	1	0	\N
112521	1726	674712749000	13793	7084	2	0	\N
112522	1726	674711748000	13793	7084	3	0	\N
112523	1397	1362352369000	13794	7084	0	0	\N
112533	1397	1362342368000	13797	7085	0	0	\N
112534	1726	674710746000	13797	7085	1	0	\N
112535	1726	674709743000	13797	7085	2	0	\N
112536	1726	674708742000	13797	7085	3	0	\N
112537	1397	1362342368000	13798	7085	0	0	\N
112538	1726	674710746000	13798	7085	1	0	\N
112539	1726	674709743000	13798	7085	2	0	\N
112540	1726	674708742000	13798	7085	3	0	\N
112545	1397	1362362370000	13800	7083	0	0	\N
112546	1397	1362352369000	13800	7083	1	0	\N
112547	1397	1362342368000	13800	7083	2	0	\N
112548	1397	1362332367000	13800	7083	3	0	\N
112549	1591	1411000000	13800	7083	4	0	\N
112560	1397	1362302364000	13802	7088	0	0	\N
112561	1726	672278722000	13802	7088	1	0	\N
112562	1726	672277719000	13802	7088	2	0	\N
112563	1726	672276718000	13802	7088	3	0	\N
112573	1397	1362292363000	13805	7089	0	0	\N
112574	1397	1362282362000	13805	7089	1	0	\N
112575	1726	672275716000	13805	7089	2	0	\N
112576	1726	672274713000	13805	7089	3	0	\N
112577	1726	672273712000	13805	7089	4	0	\N
112578	1726	672272710000	13805	7089	5	0	\N
112579	1397	1362272361000	13806	7090	0	0	\N
112580	1397	1362272361000	13807	7090	0	0	\N
112581	1726	672272710000	13807	7090	1	0	\N
112582	1726	672271707000	13807	7090	2	0	\N
112583	1726	672270706000	13807	7090	3	0	\N
112584	1726	672269704000	13807	7090	4	0	\N
112585	1726	672268701000	13807	7090	5	0	\N
112586	1726	672267700000	13807	7090	6	0	\N
112594	1397	1362272361000	13809	7090	0	0	\N
112600	1397	1362262360000	13811	7091	0	0	\N
112601	2100	717880000000	13811	7091	1	0	\N
112602	1726	672266698000	13811	7091	2	0	\N
112603	1726	672265695000	13811	7091	3	0	\N
112604	1726	672264694000	13811	7091	4	0	\N
112499	1726	674722770000	13789	7082	2	0	5944
112500	1726	674721767000	13789	7082	3	0	5945
112501	1726	674720766000	13789	7082	4	0	5946
112502	1726	674719764000	13789	7082	5	0	5947
112503	1726	674718761000	13789	7082	6	0	5948
112514	1397	1362362370000	13792	7083	0	0	7647
112515	2100	890000000	13792	7083	1	0	1
112516	1726	674716758000	13792	7083	2	0	5950
112517	1726	674715755000	13792	7083	3	0	5951
112518	1726	674714754000	13792	7083	4	0	5952
112525	1726	674713752000	13795	7084	1	0	5953
112526	1726	674712749000	13795	7084	2	0	5954
112527	1726	674711748000	13795	7084	3	0	5955
112528	1397	1362342368000	13796	7085	0	0	7649
112530	1591	1511000000	13796	7085	2	0	2
112531	1726	674709743000	13796	7085	3	0	5957
112532	1726	674708742000	13796	7085	4	0	5958
112541	1397	1362332367000	13799	7086	0	0	7650
112542	1726	674707740000	13799	7086	1	0	5959
112544	1726	674705736000	13799	7086	3	0	5961
112550	1397	1362322366000	13801	7087	0	0	7651
112551	1397	1362312365000	13801	7087	1	0	7652
112552	1726	674704734000	13801	7087	2	0	5962
112553	1726	674703731000	13801	7087	3	0	5963
112555	1726	673492730000	13801	7087	5	0	5965
112556	1726	672282730000	13801	7087	6	0	5966
112557	1726	672281728000	13801	7087	7	0	5967
112558	1726	672280725000	13801	7087	8	0	5968
112564	1397	1362302364000	13803	7088	0	0	7653
112565	1726	672278722000	13803	7088	1	0	5970
112566	1726	672277719000	13803	7088	2	0	5971
112567	1726	672276718000	13803	7088	3	0	5972
112568	1397	1362292363000	13804	7089	0	0	7654
112570	1726	672275716000	13804	7089	2	0	5973
112571	1726	672274713000	13804	7089	3	0	5974
112572	1726	672273712000	13804	7089	4	0	5975
112587	1397	1362272361000	13808	7090	0	0	7656
112588	1726	672272710000	13808	7090	1	0	5976
112590	1726	672270706000	13808	7090	3	0	5978
112591	1726	672269704000	13808	7090	4	0	5979
112592	1726	672268701000	13808	7090	5	0	5980
112593	1726	672267700000	13808	7090	6	0	5981
112596	2100	717880000000	13810	7091	1	0	2
112597	1726	672266698000	13810	7091	2	0	5982
112598	1726	672265695000	13810	7091	3	0	5983
112599	1726	672264694000	13810	7091	4	0	5984
112605	1397	1362252359000	13812	7092	0	0	7658
112607	1726	672263692000	13812	7092	2	0	5985
112608	1726	672262689000	13812	7092	3	0	5986
112613	1397	1362252359000	13813	7092	0	0	\N
112614	1397	1362242358000	13813	7092	1	0	\N
112615	1726	672263692000	13813	7092	2	0	\N
112616	1726	672262689000	13813	7092	3	0	\N
112617	1726	672261688000	13813	7092	4	0	\N
112618	1726	672260686000	13813	7092	5	0	\N
112619	1726	672259683000	13813	7092	6	0	\N
112620	1726	672258682000	13813	7092	7	0	\N
112621	1397	1362252359000	13814	7092	0	0	\N
112622	1397	1362242358000	13814	7092	1	0	\N
112627	1397	1362232357000	13816	7093	0	0	\N
112628	1397	1362222356000	13816	7093	2	0	\N
112629	1397	1362212355000	13816	7093	3	0	\N
112630	1397	1362202354000	13816	7093	4	0	\N
112647	1397	1362222356000	13818	7094	0	0	\N
112648	1397	1362212355000	13818	7094	1	0	\N
112649	1397	1362202354000	13818	7094	2	0	\N
112650	1397	1362192353000	13818	7094	3	0	\N
112651	1726	672254674000	13818	7094	4	0	\N
112652	1726	672253671000	13818	7094	5	0	\N
112653	1726	672252670000	13818	7094	6	0	\N
112654	1726	672251668000	13818	7094	7	0	\N
112655	1726	672250665000	13818	7094	8	0	\N
112656	1726	672249664000	13818	7094	9	0	\N
112657	1726	672248662000	13818	7094	10	0	\N
112658	1726	672247659000	13818	7094	11	0	\N
112659	1726	672246658000	13818	7094	12	0	\N
112660	1726	672245656000	13818	7094	13	0	\N
112661	1726	672244653000	13818	7094	14	0	\N
112662	1726	672243652000	13818	7094	15	0	\N
112664	1397	1362172351000	13820	7096	0	0	\N
112665	1726	672242650000	13820	7096	1	0	\N
112666	1726	672241647000	13820	7096	2	0	\N
112667	1726	672240646000	13820	7096	3	0	\N
112668	1726	672239644000	13820	7096	4	0	\N
112669	1726	672238641000	13820	7096	5	0	\N
112670	1726	672237640000	13820	7096	6	0	\N
112671	1397	1362172351000	13821	7096	0	0	\N
112672	1726	672242650000	13821	7096	1	0	\N
112673	1726	672241647000	13821	7096	2	0	\N
112674	1726	672240646000	13821	7096	3	0	\N
112675	1726	672239644000	13821	7096	4	0	\N
112676	1726	672238641000	13821	7096	5	0	\N
112677	1726	672237640000	13821	7096	6	0	\N
112692	1397	1362142348000	13824	7098	0	0	\N
112693	1397	1362132347000	13824	7098	1	0	\N
112694	1397	1362122346000	13824	7098	2	0	\N
112724	1397	1362062340000	13830	7101	0	0	\N
112725	1397	1362052339000	13830	7101	1	0	\N
112726	1397	1362042338000	13830	7101	2	0	\N
112727	1397	1362032337000	13830	7101	3	0	\N
112728	1397	1362022336000	13830	7101	4	0	\N
112729	1726	672210585000	13830	7101	5	0	\N
112730	1726	672209583000	13830	7101	6	0	\N
112731	1726	672208582000	13830	7101	7	0	\N
112732	1726	672207579000	13830	7101	8	0	\N
112733	1726	672206577000	13830	7101	9	0	\N
112734	1726	672205576000	13830	7101	10	0	\N
112735	1726	672204573000	13830	7101	11	0	\N
112736	1726	672203571000	13830	7101	12	0	\N
112737	1726	672202570000	13830	7101	13	0	\N
112738	1726	672201567000	13830	7101	14	0	\N
112739	1726	672200565000	13830	7101	15	0	\N
112740	1726	672199564000	13830	7101	16	0	\N
112741	1726	672198561000	13830	7101	17	0	\N
112742	1726	672197559000	13830	7101	18	0	\N
112743	1726	672196558000	13830	7101	19	0	\N
112744	1726	672195555000	13830	7101	20	0	\N
112611	1726	672259683000	13812	7092	6	0	5989
112612	1726	672258682000	13812	7092	7	0	5990
112623	1397	1362232357000	13815	7093	0	0	7660
112624	1726	672257680000	13815	7093	2	0	5991
112625	1726	672256677000	13815	7093	3	0	5992
112631	1397	1362222356000	13817	7094	0	0	7661
112632	1397	1362212355000	13817	7094	1	0	7662
112633	1397	1362202354000	13817	7094	2	0	7663
112634	1397	1362192353000	13817	7094	3	0	7664
112635	1726	672254674000	13817	7094	4	0	5994
112637	1726	672252670000	13817	7094	6	0	5996
112638	1726	672251668000	13817	7094	7	0	5997
112639	1726	672250665000	13817	7094	8	0	5998
112640	1726	672249664000	13817	7094	9	0	5999
112642	1726	672247659000	13817	7094	11	0	6001
112643	1726	672246658000	13817	7094	12	0	6002
112644	1726	672245656000	13817	7094	13	0	6003
112645	1726	672244653000	13817	7094	14	0	6004
112646	1726	672243652000	13817	7094	15	0	6005
112678	1397	1362172351000	13822	7096	0	0	7666
112679	1726	672242650000	13822	7096	1	0	6006
112680	1726	672241647000	13822	7096	2	0	6007
112681	1726	672240646000	13822	7096	3	0	6008
112682	1726	672239644000	13822	7096	4	0	6009
112684	1726	672237640000	13822	7096	6	0	6011
112685	1397	1362162350000	13823	7097	0	0	7667
112686	1397	1362152349000	13823	7097	1	0	7668
112687	1726	672236638000	13823	7097	2	0	6012
112689	1726	672234634000	13823	7097	4	0	6014
112690	1726	672233631000	13823	7097	5	0	6015
112691	1726	672232630000	13823	7097	6	0	6016
112695	1397	1362142348000	13826	7098	0	0	7669
112696	1397	1362132347000	13826	7098	1	0	7670
112698	1726	672231627000	13826	7098	3	0	6017
112699	1726	672230625000	13826	7098	4	0	6018
112700	1726	672229624000	13826	7098	5	0	6019
112701	1726	672228621000	13826	7098	6	0	6020
112702	1726	672227619000	13826	7098	7	0	6021
112704	1726	672225615000	13826	7098	9	0	6023
112705	1726	672224613000	13826	7098	10	0	6024
112706	1726	672223612000	13826	7098	11	0	6025
112707	1397	1362112345000	13827	7099	0	0	7672
112709	1397	1362092343000	13827	7099	2	0	7674
112710	1397	1362082342000	13827	7099	3	0	7675
112711	1726	672222609000	13827	7099	4	0	6026
112712	1726	672221607000	13827	7099	5	0	6027
112713	1726	672220606000	13827	7099	6	0	6028
112715	1726	672218601000	13827	7099	8	0	6030
112716	1726	672217600000	13827	7099	9	0	6031
112717	1726	672216597000	13827	7099	10	0	6032
112718	1726	672215595000	13827	7099	11	0	6033
112719	1726	672214594000	13827	7099	12	0	6034
112721	1726	672212589000	13827	7099	14	0	6036
112722	1726	672211588000	13827	7099	15	0	6037
112723	1397	1362072341000	13828	7100	0	0	7676
112745	1726	672194553000	13830	7101	21	0	\N
112746	1726	672193552000	13830	7101	22	0	\N
112774	1397	1362002334000	13833	7103	0	0	\N
112775	1397	1362002334000	13834	7103	0	0	\N
112776	1726	672189543000	13834	7103	1	0	\N
112777	1726	672188541000	13834	7103	2	0	\N
112778	1397	1362002334000	13835	7103	0	0	\N
112779	1726	672189543000	13835	7103	1	0	\N
112780	1726	672188541000	13835	7103	2	0	\N
112784	1397	1362462380000	13837	7078	0	0	\N
112785	1397	1362452379000	13837	7078	1	0	\N
112786	1397	1362442378000	13837	7078	2	0	\N
112787	1397	1362432377000	13837	7078	3	0	\N
112788	1397	1362422376000	13837	7078	4	0	\N
112789	1397	1362412375000	13837	7078	5	0	\N
112790	1397	1362402374000	13837	7078	6	0	\N
112791	1397	1362392373000	13837	7078	7	0	\N
112792	1397	1362382372000	13837	7078	8	0	\N
112793	1397	1362372371000	13837	7078	9	0	\N
112794	1397	1362362370000	13837	7078	10	0	\N
112795	1397	1362352369000	13837	7078	11	0	\N
112796	1397	1362342368000	13837	7078	12	0	\N
112797	1397	1362332367000	13837	7078	13	0	\N
112798	1397	1362322366000	13837	7078	14	0	\N
112799	1397	1362312365000	13837	7078	15	0	\N
112800	1397	1362302364000	13837	7078	16	0	\N
112801	1397	1362292363000	13837	7078	17	0	\N
112802	1397	1362282362000	13837	7078	18	0	\N
112803	1397	1362272361000	13837	7078	19	0	\N
112804	1397	1362262360000	13837	7078	20	0	\N
112805	1397	1362252359000	13837	7078	21	0	\N
112806	1397	1362242358000	13837	7078	22	0	\N
112807	1397	1362232357000	13837	7078	23	0	\N
112808	1397	1362222356000	13837	7078	24	0	\N
112809	1397	1362212355000	13837	7078	25	0	\N
112810	1397	1362202354000	13837	7078	26	0	\N
112811	1397	1362192353000	13837	7078	27	0	\N
112812	1397	1362182352000	13837	7078	28	0	\N
112813	1397	1362172351000	13837	7078	29	0	\N
112814	1397	1362162350000	13837	7078	30	0	\N
112815	1397	1362152349000	13837	7078	31	0	\N
112816	1397	1362142348000	13837	7078	32	0	\N
112817	1397	1362132347000	13837	7078	33	0	\N
112818	1397	1362122346000	13837	7078	34	0	\N
112819	1397	1362112345000	13837	7078	35	0	\N
112820	1397	1362102344000	13837	7078	36	0	\N
112821	1397	1362092343000	13837	7078	37	0	\N
112822	1397	1362082342000	13837	7078	38	0	\N
112823	1397	1362072341000	13837	7078	39	0	\N
112824	1397	1362062340000	13837	7078	40	0	\N
112825	1397	1362052339000	13837	7078	41	0	\N
112826	1397	1362042338000	13837	7078	42	0	\N
112827	1397	1362032337000	13837	7078	43	0	\N
112828	1397	1362022336000	13837	7078	44	0	\N
112829	1397	1362012335000	13837	7078	45	0	\N
112830	1397	1362002334000	13837	7078	46	0	\N
112831	1726	674744816000	13837	7078	47	0	\N
112832	1726	674743815000	13837	7078	48	0	\N
112833	1726	674742812000	13837	7078	49	0	\N
112834	1726	674741810000	13837	7078	50	0	\N
112835	1726	674740809000	13837	7078	51	0	\N
112836	1726	674739806000	13837	7078	52	0	\N
112837	1726	674738804000	13837	7078	53	0	\N
112838	1726	674737803000	13837	7078	54	0	\N
112839	1726	674736800000	13837	7078	55	0	\N
112840	1726	674735798000	13837	7078	56	0	\N
112841	1726	674734797000	13837	7078	57	0	\N
112842	1726	674733794000	13837	7078	58	0	\N
112843	1726	674732792000	13837	7078	59	0	\N
112844	1726	674731791000	13837	7078	60	0	\N
112845	1726	674730788000	13837	7078	61	0	\N
112846	1726	674729786000	13837	7078	62	0	\N
112847	1726	674728783000	13837	7078	63	0	\N
112848	1726	674727781000	13837	7078	64	0	\N
112849	1726	674726778000	13837	7078	65	0	\N
112850	1591	718412000000	13837	7078	66	0	\N
112851	1591	1411000000	13837	7078	67	0	\N
112852	1726	674725776000	13837	7078	68	0	\N
112853	1726	674724773000	13837	7078	69	0	\N
112854	1726	674723772000	13837	7078	70	0	\N
112855	1726	674722770000	13837	7078	71	0	\N
112856	1726	674721767000	13837	7078	72	0	\N
112857	1726	674720766000	13837	7078	73	0	\N
112858	1726	674719764000	13837	7078	74	0	\N
112859	1726	674718761000	13837	7078	75	0	\N
112860	1726	674717760000	13837	7078	76	0	\N
112861	1726	674716758000	13837	7078	77	0	\N
112862	1726	674715755000	13837	7078	78	0	\N
112863	1726	674714754000	13837	7078	79	0	\N
112864	1726	674713752000	13837	7078	80	0	\N
112865	1726	674712749000	13837	7078	81	0	\N
112866	1726	674711748000	13837	7078	82	0	\N
112867	1726	674710746000	13837	7078	83	0	\N
112868	1726	674709743000	13837	7078	84	0	\N
112869	1726	674708742000	13837	7078	85	0	\N
112870	1726	674707740000	13837	7078	86	0	\N
112871	1726	674706737000	13837	7078	87	0	\N
112872	1726	674705736000	13837	7078	88	0	\N
112873	1726	674704734000	13837	7078	89	0	\N
112874	1726	674703731000	13837	7078	90	0	\N
112875	1726	674702730000	13837	7078	91	0	\N
112876	1726	673492730000	13837	7078	92	0	\N
112877	1726	672282730000	13837	7078	93	0	\N
112878	1726	672281728000	13837	7078	94	0	\N
112879	1726	672280725000	13837	7078	95	0	\N
112880	1726	672279724000	13837	7078	96	0	\N
112749	1397	1362042338000	13831	7101	2	0	7679
112750	1397	1362032337000	13831	7101	3	0	7680
112751	1397	1362022336000	13831	7101	4	0	7681
112752	1726	672210585000	13831	7101	5	0	6038
112753	1397	1362012335000	13832	7102	0	0	7682
112755	1726	672208582000	13832	7102	2	0	6040
112756	1726	672207579000	13832	7102	3	0	6041
112757	1726	672206577000	13832	7102	4	0	6042
112758	1726	672205576000	13832	7102	5	0	6043
112759	1726	672204573000	13832	7102	6	0	6044
112761	1726	672202570000	13832	7102	8	0	6046
112762	1726	672201567000	13832	7102	9	0	6047
112763	1726	672200565000	13832	7102	10	0	6048
112764	1726	672199564000	13832	7102	11	0	6049
112766	1726	672197559000	13832	7102	13	0	6051
112767	1726	672196558000	13832	7102	14	0	6052
112768	1726	672195555000	13832	7102	15	0	6053
112769	1726	672194553000	13832	7102	16	0	6054
112770	1726	672193552000	13832	7102	17	0	6055
112772	1726	672191547000	13832	7102	19	0	6057
112773	1726	672190546000	13832	7102	20	0	6058
112781	1397	1362002334000	13836	7103	0	0	7683
112782	1726	672189543000	13836	7103	1	0	6059
112783	1726	672188541000	13836	7103	2	0	6060
112881	1726	672278722000	13837	7078	97	0	\N
112882	1726	672277719000	13837	7078	98	0	\N
112883	1726	672276718000	13837	7078	99	0	\N
112884	1726	672275716000	13837	7078	100	0	\N
112885	1726	672274713000	13837	7078	101	0	\N
112886	1726	672273712000	13837	7078	102	0	\N
112887	1726	672272710000	13837	7078	103	0	\N
112888	1726	672271707000	13837	7078	104	0	\N
112889	1726	672270706000	13837	7078	105	0	\N
112890	1726	672269704000	13837	7078	106	0	\N
112891	1726	672268701000	13837	7078	107	0	\N
112892	1726	672267700000	13837	7078	108	0	\N
112893	1726	672266698000	13837	7078	109	0	\N
112894	1726	672265695000	13837	7078	110	0	\N
112895	1726	672264694000	13837	7078	111	0	\N
112896	1726	672263692000	13837	7078	112	0	\N
112897	1726	672262689000	13837	7078	113	0	\N
112898	1726	672261688000	13837	7078	114	0	\N
112899	1726	672260686000	13837	7078	115	0	\N
112900	1726	672259683000	13837	7078	116	0	\N
112901	1726	672258682000	13837	7078	117	0	\N
112902	1726	672257680000	13837	7078	118	0	\N
112903	1726	672256677000	13837	7078	119	0	\N
112904	1726	672255676000	13837	7078	120	0	\N
112905	1726	672254674000	13837	7078	121	0	\N
112906	1726	672253671000	13837	7078	122	0	\N
112907	1726	672252670000	13837	7078	123	0	\N
112908	1726	672251668000	13837	7078	124	0	\N
112909	1726	672250665000	13837	7078	125	0	\N
112910	1397	1362012335000	13838	7102	0	0	\N
112911	1397	1362002334000	13838	7102	1	0	\N
112912	1726	672209583000	13838	7102	2	0	\N
112913	1726	672208582000	13838	7102	3	0	\N
112914	1726	672207579000	13838	7102	4	0	\N
112915	1726	672206577000	13838	7102	5	0	\N
112916	1726	672205576000	13838	7102	6	0	\N
112917	1726	672204573000	13838	7102	7	0	\N
112918	1726	672203571000	13838	7102	8	0	\N
112919	1726	672202570000	13838	7102	9	0	\N
112920	1726	672201567000	13838	7102	10	0	\N
112921	1726	672200565000	13838	7102	11	0	\N
112922	1726	672199564000	13838	7102	12	0	\N
112923	1726	672198561000	13838	7102	13	0	\N
112924	1726	672197559000	13838	7102	14	0	\N
112925	1726	672196558000	13838	7102	15	0	\N
112926	1726	672195555000	13838	7102	16	0	\N
112927	1726	672194553000	13838	7102	17	0	\N
112928	1726	672193552000	13838	7102	18	0	\N
112929	1726	672192549000	13838	7102	19	0	\N
112946	1397	1361972331000	13841	7105	0	0	\N
112947	1397	1361962330000	13841	7105	1	0	\N
112948	1726	672181528000	13841	7105	3	0	\N
112949	1726	672180525000	13841	7105	4	0	\N
112950	1726	672179523000	13841	7105	5	0	\N
112951	1726	672178522000	13841	7105	6	0	\N
112952	1726	672177519000	13841	7105	7	0	\N
112953	1726	672176517000	13841	7105	8	0	\N
112954	1397	1361972331000	13842	7105	0	0	\N
112955	1397	1361962330000	13842	7105	1	0	\N
112956	1726	672181528000	13842	7105	3	0	\N
112957	1726	672180525000	13842	7105	4	0	\N
112958	1726	672179523000	13842	7105	5	0	\N
112959	1726	672178522000	13842	7105	6	0	\N
112960	1726	672177519000	13842	7105	7	0	\N
112961	1726	672176517000	13842	7105	8	0	\N
112962	1397	1361952329000	13843	7106	0	0	\N
112963	1397	1361942328000	13843	7106	1	0	\N
112964	1397	1361932327000	13843	7106	2	0	\N
112965	1397	1361922326000	13843	7106	3	0	\N
112966	1726	672175516000	13843	7106	4	0	\N
112967	1726	672174513000	13843	7106	5	0	\N
112968	1726	672173511000	13843	7106	6	0	\N
112969	1726	672172510000	13843	7106	7	0	\N
112970	1726	672171507000	13843	7106	8	0	\N
112971	1726	672170505000	13843	7106	9	0	\N
112972	1726	672169504000	13843	7106	10	0	\N
112973	1726	672168501000	13843	7106	11	0	\N
112974	1726	672167499000	13843	7106	12	0	\N
112975	1726	672166498000	13843	7106	13	0	\N
112976	1726	672165495000	13843	7106	14	0	\N
112977	1726	672164493000	13843	7106	15	0	\N
112982	1397	1361952329000	13845	7106	0	0	\N
112983	1397	1361942328000	13845	7106	1	0	\N
112984	1397	1361932327000	13845	7106	2	0	\N
112985	1397	1361922326000	13845	7106	3	0	\N
112986	1726	672175516000	13845	7106	4	0	\N
112987	1397	1361952329000	13846	7106	0	0	\N
112988	1397	1361942328000	13846	7106	1	0	\N
112989	1397	1361932327000	13846	7106	2	0	\N
112990	1397	1361922326000	13846	7106	3	0	\N
112991	1726	672175516000	13846	7106	4	0	\N
112992	1726	672174513000	13846	7106	5	0	\N
112993	1726	672173511000	13846	7106	6	0	\N
112994	1726	672172510000	13846	7106	7	0	\N
112995	1726	672171507000	13846	7106	8	0	\N
112996	1726	672170505000	13846	7106	9	0	\N
112997	1726	672169504000	13846	7106	10	0	\N
112998	1726	672168501000	13846	7106	11	0	\N
112999	1726	672167499000	13846	7106	12	0	\N
113000	1726	672166498000	13846	7106	13	0	\N
113001	1726	672165495000	13846	7106	14	0	\N
113002	1726	672164493000	13846	7106	15	0	\N
113016	1397	1361912325000	13848	7107	0	0	\N
112932	1726	672187540000	13839	7104	2	0	6061
112933	1726	672186537000	13839	7104	3	0	6062
112934	1726	672185535000	13839	7104	4	0	6063
112935	1726	672184534000	13839	7104	5	0	6064
112936	1726	672183531000	13839	7104	6	0	6065
112938	1397	1361972331000	13840	7105	0	0	7686
112939	1397	1361962330000	13840	7105	1	0	7687
112940	1726	672181528000	13840	7105	3	0	6067
112941	1726	672180525000	13840	7105	4	0	6068
112942	1726	672179523000	13840	7105	5	0	6069
112944	1726	672177519000	13840	7105	7	0	6071
112945	1726	672176517000	13840	7105	8	0	6072
112978	1397	1361952329000	13844	7106	0	0	7688
112979	1397	1361942328000	13844	7106	1	0	7689
112981	1397	1361922326000	13844	7106	3	0	7691
113003	1397	1361912325000	13847	7107	0	0	7692
113004	1726	672175516000	13847	7107	1	0	6073
113005	1726	672174513000	13847	7107	2	0	6074
113006	1726	672173511000	13847	7107	3	0	6075
113008	1726	672171507000	13847	7107	5	0	6077
113009	1726	672170505000	13847	7107	6	0	6078
113010	1726	672169504000	13847	7107	7	0	6079
113011	1726	672168501000	13847	7107	8	0	6080
113012	1726	672167499000	13847	7107	9	0	6081
113014	1726	672165495000	13847	7107	11	0	6083
113015	1726	672164493000	13847	7107	12	0	6084
113017	1726	672175516000	13848	7107	1	0	\N
113018	1726	672174513000	13848	7107	2	0	\N
113019	1726	672173511000	13848	7107	3	0	\N
113020	1726	672172510000	13848	7107	4	0	\N
113021	1726	672171507000	13848	7107	5	0	\N
113022	1726	672170505000	13848	7107	6	0	\N
113023	1726	672169504000	13848	7107	7	0	\N
113024	1726	672168501000	13848	7107	8	0	\N
113025	1726	672167499000	13848	7107	9	0	\N
113026	1726	672166498000	13848	7107	10	0	\N
113027	1726	672165495000	13848	7107	11	0	\N
113028	1726	672164493000	13848	7107	12	0	\N
113029	1726	672163492000	13848	7107	13	0	\N
113030	1726	672162489000	13848	7107	14	0	\N
113031	1726	672161487000	13848	7107	15	0	\N
113032	1397	1361912325000	13849	7107	0	0	\N
113034	1397	1361902324000	13851	7108	0	0	\N
113035	1726	672163492000	13851	7108	1	0	\N
113036	1726	672162489000	13851	7108	2	0	\N
113037	1726	672161487000	13851	7108	3	0	\N
113038	1726	672160486000	13851	7108	4	0	\N
113039	1726	672159483000	13851	7108	5	0	\N
113040	1726	672158481000	13851	7108	6	0	\N
113041	1397	1361902324000	13852	7108	0	0	\N
113042	1726	672163492000	13852	7108	1	0	\N
113043	1726	672162489000	13852	7108	2	0	\N
113044	1726	672161487000	13852	7108	3	0	\N
113045	1726	672160486000	13852	7108	4	0	\N
113046	1726	672159483000	13852	7108	5	0	\N
113047	1726	672158481000	13852	7108	6	0	\N
113048	1397	1361902324000	13853	7108	0	0	\N
113049	1397	1361892323000	13854	7109	0	0	\N
113050	1726	672163492000	13854	7109	1	0	\N
113051	1726	672162489000	13854	7109	2	0	\N
113052	1726	672161487000	13854	7109	3	0	\N
113053	1726	672160486000	13854	7109	4	0	\N
113054	1726	672159483000	13854	7109	5	0	\N
113055	1726	672158481000	13854	7109	6	0	\N
113056	1726	672157480000	13854	7109	7	0	\N
113057	1726	672156477000	13854	7109	8	0	\N
113058	1726	672155475000	13854	7109	9	0	\N
113085	1397	1361842318000	13859	7113	0	0	\N
113086	1726	672142450000	13859	7113	1	0	\N
113087	1726	672141447000	13859	7113	2	0	\N
113088	1726	672140445000	13859	7113	3	0	\N
113089	1397	1361842318000	13860	7113	0	0	\N
113090	1726	672142450000	13860	7113	1	0	\N
113091	1726	672141447000	13860	7113	2	0	\N
113092	1726	672140445000	13860	7113	3	0	\N
113094	1397	1361832317000	13862	7114	0	0	\N
113095	1726	672142450000	13862	7114	1	0	\N
113096	1726	672141447000	13862	7114	2	0	\N
113097	1726	672140445000	13862	7114	3	0	\N
113098	1726	672139444000	13862	7114	4	0	\N
113099	1726	672138441000	13862	7114	5	0	\N
113100	1726	672137439000	13862	7114	6	0	\N
113123	1397	1361792313000	13867	7118	0	0	\N
113124	1397	1361782312000	13867	7118	1	0	\N
113125	1726	672124414000	13867	7118	2	0	\N
113126	1726	672123411000	13867	7118	3	0	\N
113127	1726	672122409000	13867	7118	4	0	\N
113128	1726	672121408000	13867	7118	5	0	\N
113129	1726	672120405000	13867	7118	6	0	\N
113130	1726	672119403000	13867	7118	7	0	\N
113131	1397	1361792313000	13868	7118	0	0	\N
113132	1397	1361782312000	13868	7118	1	0	\N
113141	1397	1361792313000	13870	7118	0	0	\N
113142	1397	1361782312000	13870	7118	1	0	\N
113143	1726	672124414000	13870	7118	2	0	\N
113144	1726	672123411000	13870	7118	3	0	\N
113145	1726	672122409000	13870	7118	4	0	\N
113146	1726	672121408000	13870	7118	5	0	\N
113147	1726	672120405000	13870	7118	6	0	\N
113148	1726	672119403000	13870	7118	7	0	\N
113149	1397	1361792313000	13871	7118	0	0	\N
113150	1397	1361782312000	13871	7118	1	0	\N
113060	1726	672163492000	13855	7109	1	0	6085
113061	1726	672162489000	13855	7109	2	0	6086
113062	1726	672161487000	13855	7109	3	0	6087
113063	1726	672160486000	13855	7109	4	0	6088
113064	1726	672159483000	13855	7109	5	0	6089
113066	1726	672157480000	13855	7109	7	0	6091
113067	1726	672156477000	13855	7109	8	0	6092
113068	1726	672155475000	13855	7109	9	0	6093
113069	1397	1361882322000	13856	7110	0	0	7695
113070	1397	1361872321000	13856	7110	1	0	7696
113072	1726	672153471000	13856	7110	3	0	6095
113073	1726	672152469000	13856	7110	4	0	6096
113074	1726	672151468000	13856	7110	5	0	6097
113075	1726	672150465000	13856	7110	6	0	6098
113077	1397	1361862320000	13857	7111	0	0	7697
113078	1726	672148462000	13857	7111	1	0	6100
113079	1726	672147459000	13857	7111	2	0	6101
113080	1726	672146457000	13857	7111	3	0	6102
113081	1397	1361852319000	13858	7112	0	0	7698
113083	1726	672144453000	13858	7112	2	0	6104
113084	1726	672143451000	13858	7112	3	0	6105
113093	1397	1361842318000	13861	7113	0	0	7699
113101	1397	1361832317000	13863	7114	0	0	7700
113102	1397	1361822316000	13864	7115	0	0	7701
113104	1726	672141447000	13864	7115	2	0	6107
113105	1726	672140445000	13864	7115	3	0	6108
113106	1726	672139444000	13864	7115	4	0	6109
113107	1726	672138441000	13864	7115	5	0	6110
113109	1726	672136438000	13864	7115	7	0	6112
113110	1726	672135435000	13864	7115	8	0	6113
113111	1726	672134433000	13864	7115	9	0	6114
113112	1397	1361812315000	13865	7116	0	0	7702
113113	1726	672133432000	13865	7116	1	0	6115
113115	1726	672131427000	13865	7116	3	0	6117
113116	1397	1361802314000	13866	7117	0	0	7703
113117	1726	672130426000	13866	7117	1	0	6118
113118	1726	672129423000	13866	7117	2	0	6119
113119	1726	672128421000	13866	7117	3	0	6120
113121	1726	672126417000	13866	7117	5	0	6122
113122	1726	672125415000	13866	7117	6	0	6123
113133	1397	1361792313000	13869	7118	0	0	7704
113134	1397	1361782312000	13869	7118	1	0	7705
113136	1726	672123411000	13869	7118	3	0	6125
113137	1726	672122409000	13869	7118	4	0	6126
113138	1726	672121408000	13869	7118	5	0	6127
113139	1726	672120405000	13869	7118	6	0	6128
113140	1726	672119403000	13869	7118	7	0	6129
113152	1726	672118402000	13872	7119	1	0	6130
113162	1397	1361742308000	13874	7121	0	0	\N
113163	1397	1361732307000	13874	7121	1	0	\N
113164	1397	1361722306000	13874	7121	2	0	\N
113165	1749	2465027000000	13874	7121	4	0	\N
113179	1397	1361712305000	13876	7122	0	0	\N
113180	1397	1361702304000	13876	7122	1	0	\N
113181	1726	672101367000	13876	7122	2	0	\N
113182	1726	672100366000	13876	7122	3	0	\N
113183	1726	672099363000	13876	7122	4	0	\N
113184	1726	672098361000	13876	7122	5	0	\N
113185	1726	672097360000	13876	7122	6	0	\N
113186	1726	672096357000	13876	7122	7	0	\N
113187	1397	1361712305000	13878	7122	0	0	\N
113188	1397	1361702304000	13878	7122	1	0	\N
113189	1726	672101367000	13878	7122	2	0	\N
113190	1726	672100366000	13878	7122	3	0	\N
113191	1726	672099363000	13878	7122	4	0	\N
113192	1726	672098361000	13878	7122	5	0	\N
113193	1726	672097360000	13878	7122	6	0	\N
113194	1726	672096357000	13878	7122	7	0	\N
113203	1397	1361712305000	13880	7122	0	0	\N
113204	1397	1361702304000	13880	7122	1	0	\N
113205	1397	1361692303000	13882	7123	0	0	\N
113206	1397	1361682302000	13882	7123	1	0	\N
113207	1726	672110385000	13882	7123	2	0	\N
113208	1726	672109384000	13882	7123	3	0	\N
113209	1726	672108381000	13882	7123	4	0	\N
113210	1726	672107379000	13882	7123	5	0	\N
113211	1726	672106378000	13882	7123	6	0	\N
113212	1726	672105375000	13882	7123	7	0	\N
113213	1726	672104373000	13882	7123	8	0	\N
113214	1726	672103372000	13882	7123	9	0	\N
113215	1726	672102369000	13882	7123	10	0	\N
113216	1726	672101367000	13882	7123	11	0	\N
113217	1726	672100366000	13882	7123	12	0	\N
113218	1726	672099363000	13882	7123	13	0	\N
113219	1726	672098361000	13882	7123	14	0	\N
113220	1726	672097360000	13882	7123	15	0	\N
113221	1726	672096357000	13882	7123	16	0	\N
113222	1726	672095355000	13882	7123	17	0	\N
113223	1726	672094354000	13882	7123	18	0	\N
113224	1726	672093351000	13882	7123	19	0	\N
113225	1726	672092349000	13882	7123	20	0	\N
113226	1726	672091348000	13882	7123	21	0	\N
113227	1726	672090345000	13882	7123	22	0	\N
113251	1397	1361642298000	13887	7126	0	0	\N
113252	1726	672081327000	13887	7126	1	0	\N
113253	1726	672080325000	13887	7126	2	0	\N
113254	1726	672079324000	13887	7126	3	0	\N
113255	1397	1361642298000	13888	7126	0	0	\N
113256	1726	672081327000	13888	7126	1	0	\N
113257	1726	672080325000	13888	7126	2	0	\N
113258	1726	672079324000	13888	7126	3	0	\N
113259	1397	1361642298000	13889	7126	0	0	\N
113260	1397	1361632297000	13890	7127	0	0	\N
113261	1726	672081327000	13890	7127	1	0	\N
113262	1726	672080325000	13890	7127	2	0	\N
113263	1726	672079324000	13890	7127	3	0	\N
113264	1726	672078321000	13890	7127	4	0	\N
113265	1726	672077319000	13890	7127	5	0	\N
113266	1726	672076318000	13890	7127	6	0	\N
113269	1397	1361612295000	13893	7129	0	0	\N
113270	1397	1361602294000	13893	7129	1	0	\N
113271	1726	672078321000	13893	7129	2	0	\N
113272	1726	672077319000	13893	7129	3	0	\N
113273	1726	672076318000	13893	7129	4	0	\N
113274	1726	672075315000	13893	7129	5	0	\N
113275	1726	672074313000	13893	7129	6	0	\N
113276	1726	672073312000	13893	7129	7	0	\N
113277	1726	672072309000	13893	7129	8	0	\N
113278	1726	672071307000	13893	7129	9	0	\N
113279	1726	672070306000	13893	7129	10	0	\N
113280	1726	672069303000	13893	7129	11	0	\N
113281	1726	672068301000	13893	7129	12	0	\N
113282	1726	672067300000	13893	7129	13	0	\N
113283	1397	1361612295000	13894	7129	0	0	\N
113284	1397	1361602294000	13894	7129	1	0	\N
113285	1726	672078321000	13894	7129	2	0	\N
113286	1726	672077319000	13894	7129	3	0	\N
113287	1726	672076318000	13894	7129	4	0	\N
113288	1726	672075315000	13894	7129	5	0	\N
113155	1397	1361762310000	13873	7120	0	0	7707
113156	1397	1361752309000	13873	7120	1	0	7708
113157	1726	672115396000	13873	7120	2	0	6133
113158	1726	672114393000	13873	7120	3	0	6134
113159	1726	672113391000	13873	7120	4	0	6135
113161	1726	672111387000	13873	7120	6	0	6137
113166	1397	1361742308000	13875	7121	0	0	7709
113167	1397	1361732307000	13875	7121	1	0	7710
113168	1397	1361722306000	13875	7121	2	0	7711
113169	1726	672110385000	13875	7121	4	0	6138
113171	1726	672108381000	13875	7121	6	0	6140
113172	1749	2465027000000	13875	7121	7	0	13
113173	1726	672107379000	13875	7121	8	0	6141
113174	1726	672106378000	13875	7121	9	0	6142
113176	1726	672104373000	13875	7121	11	0	6144
113177	1726	672103372000	13875	7121	12	0	6145
113178	1726	672102369000	13875	7121	13	0	6146
113195	1397	1361712305000	13879	7122	0	0	7712
113196	1397	1361702304000	13879	7122	1	0	7713
113198	1726	672100366000	13879	7122	3	0	6148
113199	1726	672099363000	13879	7122	4	0	6149
113200	1726	672098361000	13879	7122	5	0	6150
113201	1726	672097360000	13879	7122	6	0	6151
113202	1726	672096357000	13879	7122	7	0	6152
113229	1397	1361682302000	13883	7123	1	0	7715
113230	1726	672095355000	13883	7123	2	0	6153
113231	1397	1361672301000	13884	7124	0	0	7716
113232	1397	1361662300000	13884	7124	1	0	7717
113234	1726	672093351000	13884	7124	3	0	6155
113235	1726	672092349000	13884	7124	4	0	6156
113236	1726	672091348000	13884	7124	5	0	6157
113237	1726	672090345000	13884	7124	6	0	6158
113238	1726	672089343000	13884	7124	7	0	6159
113240	1726	672087339000	13884	7124	9	0	6161
113241	1726	672086337000	13884	7124	10	0	6162
113242	1726	672085336000	13884	7124	11	0	6163
113243	1726	672084333000	13884	7124	12	0	6164
113244	1397	1361652299000	13885	7125	0	0	7718
113246	1726	672082330000	13885	7125	2	0	6166
113247	1397	1361642298000	13886	7126	0	0	7719
113248	1726	672081327000	13886	7126	1	0	6167
113249	1726	672080325000	13886	7126	2	0	6168
113267	1397	1361632297000	13891	7127	0	0	7720
113268	1397	1361622296000	13892	7128	0	0	7721
113289	1726	672074313000	13894	7129	6	0	\N
113290	1726	672073312000	13894	7129	7	0	\N
113291	1726	672072309000	13894	7129	8	0	\N
113292	1726	672071307000	13894	7129	9	0	\N
113293	1726	672070306000	13894	7129	10	0	\N
113294	1726	672069303000	13894	7129	11	0	\N
113295	1726	672068301000	13894	7129	12	0	\N
113296	1726	672067300000	13894	7129	13	0	\N
113297	1397	1361612295000	13895	7129	0	0	\N
113298	1397	1361602294000	13895	7129	1	0	\N
113299	1726	672078321000	13895	7129	2	0	\N
113300	1726	672077319000	13895	7129	3	0	\N
113301	1726	672076318000	13895	7129	4	0	\N
113302	1726	672075315000	13895	7129	5	0	\N
113303	1726	672074313000	13895	7129	6	0	\N
113304	1726	672073312000	13895	7129	7	0	\N
113305	1726	672072309000	13895	7129	8	0	\N
113306	1726	672071307000	13895	7129	9	0	\N
113307	1726	672070306000	13895	7129	10	0	\N
113308	1726	672069303000	13895	7129	11	0	\N
113309	1726	672068301000	13895	7129	12	0	\N
113310	1726	672067300000	13895	7129	13	0	\N
113311	1397	1361612295000	13896	7129	0	0	\N
113312	1397	1361602294000	13896	7129	1	0	\N
113313	1726	672078321000	13896	7129	2	0	\N
113314	1726	672077319000	13896	7129	3	0	\N
113315	1726	672076318000	13896	7129	4	0	\N
113316	1726	672075315000	13896	7129	5	0	\N
113317	1726	672074313000	13896	7129	6	0	\N
113318	1726	672073312000	13896	7129	7	0	\N
113319	1726	672072309000	13896	7129	8	0	\N
113320	1726	672071307000	13896	7129	9	0	\N
113321	1726	672070306000	13896	7129	10	0	\N
113322	1726	672069303000	13896	7129	11	0	\N
113323	1726	672068301000	13896	7129	12	0	\N
113324	1726	672067300000	13896	7129	13	0	\N
113327	1397	1361592293000	13898	7130	0	0	\N
113328	1397	1361582292000	13898	7130	1	0	\N
113329	1397	1361572291000	13898	7130	2	0	\N
113330	1397	1361562290000	13898	7130	3	0	\N
113331	1397	1361552289000	13898	7130	4	0	\N
113332	1726	672078321000	13898	7130	5	0	\N
113333	1726	672077319000	13898	7130	6	0	\N
113334	1726	672076318000	13898	7130	7	0	\N
113335	1726	672075315000	13898	7130	8	0	\N
113336	1726	672074313000	13898	7130	9	0	\N
113337	1726	672073312000	13898	7130	10	0	\N
113338	1726	672072309000	13898	7130	11	0	\N
113339	1726	672071307000	13898	7130	12	0	\N
113340	1726	672070306000	13898	7130	13	0	\N
113341	1726	672069303000	13898	7130	14	0	\N
113342	1726	672068301000	13898	7130	15	0	\N
113343	1726	672067300000	13898	7130	16	0	\N
113344	1726	672066297000	13898	7130	17	0	\N
113345	1726	672065295000	13898	7130	18	0	\N
113346	1726	672064294000	13898	7130	19	0	\N
113347	1726	672063292000	13898	7130	20	0	\N
113348	1726	672062291000	13898	7130	21	0	\N
113349	1726	672061289000	13898	7130	22	0	\N
113350	1726	672060286000	13898	7130	23	0	\N
113351	1726	672059285000	13898	7130	24	0	\N
113352	1726	672058283000	13898	7130	25	0	\N
113353	1726	672057280000	13898	7130	26	0	\N
113354	1726	672056279000	13898	7130	27	0	\N
113355	1726	672055277000	13898	7130	28	0	\N
113356	1726	672054274000	13898	7130	29	0	\N
113357	1726	672053273000	13898	7130	30	0	\N
113389	1397	1361592293000	13900	7130	0	0	\N
113390	1397	1361582292000	13900	7130	1	0	\N
113391	1397	1361572291000	13900	7130	2	0	\N
113392	1397	1361562290000	13900	7130	3	0	\N
113393	1397	1361552289000	13900	7130	4	0	\N
113394	1726	672078321000	13900	7130	5	0	\N
113395	1726	672077319000	13900	7130	6	0	\N
113396	1726	672076318000	13900	7130	7	0	\N
113397	1726	672075315000	13900	7130	8	0	\N
113398	1726	672074313000	13900	7130	9	0	\N
113399	1726	672073312000	13900	7130	10	0	\N
113400	1726	672072309000	13900	7130	11	0	\N
113401	1726	672071307000	13900	7130	12	0	\N
113402	1726	672070306000	13900	7130	13	0	\N
113403	1726	672069303000	13900	7130	14	0	\N
113404	1726	672068301000	13900	7130	15	0	\N
113405	1726	672067300000	13900	7130	16	0	\N
113406	1397	1361592293000	13901	7130	0	0	\N
113407	1397	1361582292000	13901	7130	1	0	\N
113408	1397	1361572291000	13901	7130	2	0	\N
113409	1397	1361562290000	13901	7130	3	0	\N
113410	1397	1361552289000	13901	7130	4	0	\N
113411	1726	672078321000	13901	7130	5	0	\N
113412	1726	672077319000	13901	7130	6	0	\N
113413	1726	672076318000	13901	7130	7	0	\N
113414	1726	672075315000	13901	7130	8	0	\N
113415	1726	672074313000	13901	7130	9	0	\N
113416	1726	672073312000	13901	7130	10	0	\N
113417	1726	672072309000	13901	7130	11	0	\N
113418	1726	672071307000	13901	7130	12	0	\N
113419	1726	672070306000	13901	7130	13	0	\N
113420	1726	672069303000	13901	7130	14	0	\N
113421	1726	672068301000	13901	7130	15	0	\N
113422	1726	672067300000	13901	7130	16	0	\N
113423	1726	672066297000	13901	7130	17	0	\N
113424	1726	672065295000	13901	7130	18	0	\N
113358	1397	1361592293000	13899	7130	0	0	7724
113359	1397	1361582292000	13899	7130	1	0	7725
113360	1397	1361572291000	13899	7130	2	0	7726
113361	1397	1361562290000	13899	7130	3	0	7727
113362	1397	1361552289000	13899	7130	4	0	7728
113364	1726	672077319000	13899	7130	6	0	6171
113365	1726	672076318000	13899	7130	7	0	6172
113366	1726	672075315000	13899	7130	8	0	6173
113367	1726	672074313000	13899	7130	9	0	6174
113368	1726	672073312000	13899	7130	10	0	6175
113370	1726	672071307000	13899	7130	12	0	6177
113371	1726	672070306000	13899	7130	13	0	6178
113372	1726	672069303000	13899	7130	14	0	6179
113373	1726	672068301000	13899	7130	15	0	6180
113375	1726	672066297000	13899	7130	17	0	6182
113376	1726	672065295000	13899	7130	18	0	6183
113377	1726	672064294000	13899	7130	19	0	6184
113378	1726	672063292000	13899	7130	20	0	6185
113379	1726	672062291000	13899	7130	21	0	6186
113381	1726	672060286000	13899	7130	23	0	6188
113382	1726	672059285000	13899	7130	24	0	6189
113383	1726	672058283000	13899	7130	25	0	6190
113384	1726	672057280000	13899	7130	26	0	6191
113385	1726	672056279000	13899	7130	27	0	6192
113387	1726	672054274000	13899	7130	29	0	6194
113388	1726	672053273000	13899	7130	30	0	6195
113425	1726	672064294000	13901	7130	19	0	\N
113426	1726	672063292000	13901	7130	20	0	\N
113427	1726	672062291000	13901	7130	21	0	\N
113428	1726	672061289000	13901	7130	22	0	\N
113429	1726	672060286000	13901	7130	23	0	\N
113430	1726	672059285000	13901	7130	24	0	\N
113431	1726	672058283000	13901	7130	25	0	\N
113432	1726	672057280000	13901	7130	26	0	\N
113433	1726	672056279000	13901	7130	27	0	\N
113434	1726	672055277000	13901	7130	28	0	\N
113435	1726	672054274000	13901	7130	29	0	\N
113436	1726	672053273000	13901	7130	30	0	\N
113437	1397	1361592293000	13902	7130	0	0	\N
113438	1397	1361582292000	13902	7130	1	0	\N
113439	1397	1361572291000	13902	7130	2	0	\N
113440	1397	1361562290000	13902	7130	3	0	\N
113441	1397	1361552289000	13902	7130	4	0	\N
113442	1726	672078321000	13902	7130	5	0	\N
113443	1726	672077319000	13902	7130	6	0	\N
113444	1726	672076318000	13902	7130	7	0	\N
113445	1726	672075315000	13902	7130	8	0	\N
113446	1726	672074313000	13902	7130	9	0	\N
113447	1726	672073312000	13902	7130	10	0	\N
113448	1726	672072309000	13902	7130	11	0	\N
113449	1726	672071307000	13902	7130	12	0	\N
113450	1726	672070306000	13902	7130	13	0	\N
113451	1726	672069303000	13902	7130	14	0	\N
113452	1726	672068301000	13902	7130	15	0	\N
113453	1726	672067300000	13902	7130	16	0	\N
113454	1726	672066297000	13902	7130	17	0	\N
113455	1726	672065295000	13902	7130	18	0	\N
113456	1726	672064294000	13902	7130	19	0	\N
113457	1726	672063292000	13902	7130	20	0	\N
113458	1726	672062291000	13902	7130	21	0	\N
113459	1726	672061289000	13902	7130	22	0	\N
113460	1726	672060286000	13902	7130	23	0	\N
113461	1726	672059285000	13902	7130	24	0	\N
113462	1726	672058283000	13902	7130	25	0	\N
113463	1726	672057280000	13902	7130	26	0	\N
113464	1726	672056279000	13902	7130	27	0	\N
113465	1726	672055277000	13902	7130	28	0	\N
113466	1726	672054274000	13902	7130	29	0	\N
113467	1726	672053273000	13902	7130	30	0	\N
113468	1397	1361592293000	13903	7130	0	0	\N
113469	1397	1361582292000	13903	7130	1	0	\N
113470	1397	1361572291000	13903	7130	2	0	\N
113471	1397	1361562290000	13903	7130	3	0	\N
113472	1397	1361552289000	13903	7130	4	0	\N
113473	1726	672078321000	13903	7130	5	0	\N
113474	1726	672077319000	13903	7130	6	0	\N
113475	1726	672076318000	13903	7130	7	0	\N
113476	1726	672075315000	13903	7130	8	0	\N
113477	1726	672074313000	13903	7130	9	0	\N
113478	1726	672073312000	13903	7130	10	0	\N
113479	1726	672072309000	13903	7130	11	0	\N
113480	1726	672071307000	13903	7130	12	0	\N
113481	1726	672070306000	13903	7130	13	0	\N
113482	1726	672069303000	13903	7130	14	0	\N
113483	1726	672068301000	13903	7130	15	0	\N
113484	1726	672067300000	13903	7130	16	0	\N
113489	1397	1361542288000	13905	7131	0	0	\N
113490	1726	672052271000	13905	7131	1	0	\N
113491	1726	672051268000	13905	7131	2	0	\N
113492	1726	672050267000	13905	7131	3	0	\N
113497	1397	1361522286000	13907	7133	0	0	\N
113498	1397	1361512285000	13907	7133	1	0	\N
113499	1726	672046259000	13907	7133	2	0	\N
113500	1726	672045256000	13907	7133	3	0	\N
113501	1726	672044255000	13907	7133	4	0	\N
113502	1726	672043253000	13907	7133	5	0	\N
113503	1726	672042250000	13907	7133	6	0	\N
113504	1726	672041249000	13907	7133	7	0	\N
113513	1397	1361522286000	13909	7133	0	0	\N
113514	1397	1361512285000	13909	7133	1	0	\N
113519	1397	1361502284000	13911	7134	0	0	\N
113520	1726	672040247000	13911	7134	1	0	\N
113521	1726	672039244000	13911	7134	2	0	\N
113522	1726	672038243000	13911	7134	3	0	\N
113523	1397	1361502284000	13912	7134	0	0	\N
113524	1726	672040247000	13912	7134	1	0	\N
113525	1726	672039244000	13912	7134	2	0	\N
113527	1397	1361492283000	13914	7135	0	0	\N
113528	1726	672081327000	13915	7127	0	0	\N
113529	1726	672080325000	13915	7127	1	0	\N
113530	1726	672079324000	13915	7127	2	0	\N
113531	1397	1361492283000	13916	7135	0	0	\N
113532	1726	672037241000	13916	7135	1	0	\N
113533	1726	672036238000	13916	7135	2	0	\N
113534	1726	672035237000	13916	7135	4	0	\N
113535	1397	1361492283000	13917	7135	0	0	\N
113536	1726	672037241000	13917	7135	1	0	\N
113537	1726	672036238000	13917	7135	2	0	\N
113538	1726	672035237000	13917	7135	4	0	\N
113550	1397	1361462280000	13921	7138	0	0	\N
113551	1726	672028223000	13921	7138	1	0	\N
113552	1726	672027220000	13921	7138	2	0	\N
113553	1726	672026219000	13921	7138	3	0	\N
113558	1397	1361462280000	13923	7138	0	0	\N
113559	1726	672028223000	13923	7138	1	0	\N
113560	1726	672027220000	13923	7138	2	0	\N
113487	1726	672051268000	13904	7131	2	0	6197
113488	1726	672050267000	13904	7131	3	0	6198
113493	1397	1361532287000	13906	7132	0	0	7730
113494	1726	672049265000	13906	7132	1	0	6199
113495	1726	672048262000	13906	7132	2	0	6200
113505	1397	1361522286000	13908	7133	0	0	7731
113506	1397	1361512285000	13908	7133	1	0	7732
113507	1726	672046259000	13908	7133	2	0	6202
113508	1726	672045256000	13908	7133	3	0	6203
113509	1726	672044255000	13908	7133	4	0	6204
113511	1726	672042250000	13908	7133	6	0	6206
113512	1726	672041249000	13908	7133	7	0	6207
113515	1397	1361502284000	13910	7134	0	0	7733
113516	1726	672040247000	13910	7134	1	0	6208
113518	1726	672038243000	13910	7134	3	0	6210
113526	1397	1361492283000	13913	7135	0	0	7734
113539	1397	1361482282000	13920	7137	0	0	7735
113540	1397	1361472281000	13920	7137	1	0	7736
113541	1726	672037241000	13920	7137	2	0	6211
113543	1726	672035237000	13920	7137	4	0	6213
113544	1726	672034235000	13920	7137	5	0	6214
113545	1726	672033232000	13920	7137	6	0	6215
113546	1726	672032231000	13920	7137	7	0	6216
113547	1726	672031229000	13920	7137	8	0	6217
113549	1726	672029225000	13920	7137	10	0	6219
113554	1397	1361462280000	13922	7138	0	0	7737
113555	1726	672028223000	13922	7138	1	0	6220
113556	1726	672027220000	13922	7138	2	0	6221
113561	1726	672026219000	13923	7138	3	0	\N
113562	1397	1361462280000	13924	7138	0	0	\N
113563	1726	672028223000	13924	7138	1	0	\N
113564	1726	672027220000	13924	7138	2	0	\N
113565	1726	672026219000	13924	7138	3	0	\N
113566	1397	1361462280000	13925	7138	0	0	\N
113567	1726	672028223000	13925	7138	1	0	\N
113568	1726	672027220000	13925	7138	2	0	\N
113569	1726	672026219000	13925	7138	3	0	\N
113570	1397	1361462280000	13926	7138	0	0	\N
113572	1397	1361452279000	13928	7139	0	0	\N
113573	1726	672025217000	13928	7139	1	0	\N
113574	1726	672024214000	13928	7139	2	0	\N
113575	1397	1361452279000	13929	7139	0	0	\N
113576	1726	672025217000	13929	7139	1	0	\N
113577	1726	672024214000	13929	7139	2	0	\N
113595	1397	1361402274000	13934	7142	0	0	\N
113596	1726	672012188000	13934	7142	1	0	\N
113597	1726	672011186000	13934	7142	2	0	\N
113598	1726	672010185000	13934	7142	3	0	\N
113603	1397	1361402274000	13936	7142	0	0	\N
113604	1397	1361402274000	13937	7142	0	0	\N
113605	1726	672012188000	13937	7142	1	0	\N
113606	1726	672011186000	13937	7142	2	0	\N
113607	1726	672010185000	13937	7142	3	0	\N
113608	1397	1361402274000	13938	7142	0	0	\N
113613	1397	1361392273000	13941	7143	0	0	\N
113614	1726	672012188000	13941	7143	1	0	\N
113615	1726	672011186000	13941	7143	2	0	\N
113616	1726	672010185000	13941	7143	3	0	\N
113617	1726	672009182000	13941	7143	4	0	\N
113618	1726	672008180000	13941	7143	5	0	\N
113619	1726	672007179000	13941	7143	6	0	\N
113624	1397	1361382272000	13943	7144	0	0	\N
113625	1726	672006177000	13943	7144	1	0	\N
113626	1749	1965026000000	13943	7144	2	0	\N
113627	1726	672005176000	13943	7144	3	0	\N
113636	1397	1361362270000	13946	7146	0	0	\N
113637	1726	672001168000	13946	7146	1	0	\N
113638	1726	672000165000	13946	7146	2	0	\N
113639	1726	671999164000	13946	7146	3	0	\N
113640	1397	1361352269000	13947	7147	0	0	\N
113649	1397	1361332267000	13950	7149	0	0	\N
113650	1726	671992150000	13950	7149	1	0	\N
113651	1726	671991147000	13950	7149	2	0	\N
113652	1726	671990146000	13950	7149	3	0	\N
113654	1397	1361332267000	13952	7149	0	0	\N
113672	1397	1361292263000	13956	7153	0	0	\N
113673	1726	671978122000	13956	7153	1	0	\N
113674	1726	671977120000	13956	7153	2	0	\N
113675	1726	671976117000	13956	7153	3	0	\N
113677	1397	1361292263000	13958	7153	0	0	\N
113678	1397	1361282262000	13959	7154	0	0	\N
113679	1397	1361272261000	13959	7154	1	0	\N
113680	1726	671978122000	13959	7154	2	0	\N
113681	1726	671977120000	13959	7154	3	0	\N
113682	1726	671976117000	13959	7154	4	0	\N
113683	1726	671975116000	13959	7154	5	0	\N
113684	1726	671974114000	13959	7154	6	0	\N
113685	1726	671973111000	13959	7154	7	0	\N
113686	1726	671972110000	13959	7154	8	0	\N
113687	1726	671971108000	13959	7154	9	0	\N
113688	1726	671970105000	13959	7154	10	0	\N
113579	1726	672025217000	13930	7140	1	0	6223
113580	1726	672024214000	13930	7140	2	0	6224
113581	1726	672023213000	13930	7140	3	0	6225
113582	1726	672022211000	13930	7140	4	0	6226
113583	1726	672021208000	13930	7140	5	0	6227
113585	1397	1361422276000	13932	7141	1	0	7741
113586	1397	1361412275000	13932	7141	2	0	7742
113587	1726	672020205000	13932	7141	3	0	6228
113588	1726	672019203000	13932	7141	4	0	6229
113589	1726	672018200000	13932	7141	5	0	6230
113591	1726	672016197000	13932	7141	7	0	6232
113592	1726	672015194000	13932	7141	8	0	6233
113593	1726	672014192000	13932	7141	9	0	6234
113594	1726	672013191000	13932	7141	10	0	6235
113600	1726	672012188000	13935	7142	1	0	6236
113601	1726	672011186000	13935	7142	2	0	6237
113602	1726	672010185000	13935	7142	3	0	6238
113609	1397	1361392273000	13940	7143	0	0	7744
113610	1726	672009182000	13940	7143	1	0	6239
113612	1726	672007179000	13940	7143	3	0	6241
113620	1397	1361382272000	13942	7144	0	0	7745
113621	1726	672006177000	13942	7144	1	0	6242
113622	1749	1965026000000	13942	7144	2	0	14
113623	1726	672005176000	13942	7144	3	0	6243
113629	1726	672004174000	13944	7145	1	0	6244
113630	1726	672003171000	13944	7145	2	0	6245
113631	1726	672002170000	13944	7145	3	0	6246
113632	1397	1361362270000	13945	7146	0	0	7747
113634	1726	672000165000	13945	7146	2	0	6248
113635	1726	671999164000	13945	7146	3	0	6249
113641	1397	1361352269000	13948	7147	0	0	7748
113642	1726	671998162000	13948	7147	1	0	6250
113643	1726	671997159000	13948	7147	2	0	6251
113645	1397	1361342268000	13949	7148	0	0	7749
113646	1726	671995156000	13949	7148	1	0	6253
113647	1726	671994153000	13949	7148	2	0	6254
113648	1726	671993152000	13949	7148	3	0	6255
113653	1397	1361332267000	13951	7149	0	0	7750
113656	1726	671991147000	13953	7150	1	0	6257
113657	1726	671990146000	13953	7150	2	0	6258
113658	1397	1361322266000	13954	7151	0	0	7751
113659	1726	671989144000	13954	7151	1	0	6259
113661	1726	671987140000	13954	7151	3	0	6261
113662	1726	671986138000	13954	7151	4	0	6262
113663	1726	671985135000	13954	7151	5	0	6263
113664	1726	671984134000	13954	7151	6	0	6264
113665	1397	1361312265000	13955	7152	0	0	7752
113667	1726	671983132000	13955	7152	2	0	6265
113668	1726	671982129000	13955	7152	3	0	6266
113669	1726	671981128000	13955	7152	4	0	6267
113670	1726	671980126000	13955	7152	5	0	6268
113671	1726	671979123000	13955	7152	6	0	6269
113689	1397	1361282262000	13960	7154	0	0	7755
113690	1397	1361272261000	13960	7154	1	0	7756
113691	1726	671978122000	13960	7154	2	0	6270
113692	1726	671977120000	13960	7154	3	0	6271
113694	1726	671975116000	13960	7154	5	0	6273
113695	1726	671974114000	13960	7154	6	0	6274
113696	1726	671973111000	13960	7154	7	0	6275
113729	1397	1361262260000	13963	7156	0	0	\N
113730	114	66672743000000	13963	7156	1	0	\N
113731	1397	1361252259000	13963	7156	2	0	\N
113732	1397	1361242258000	13963	7156	3	0	\N
113733	1397	1361232257000	13963	7156	4	0	\N
113734	1397	1361222256000	13963	7156	5	0	\N
113735	1397	1361212255000	13963	7156	6	0	\N
113736	1397	1361202254000	13963	7156	7	0	\N
113737	1726	671969104000	13963	7156	8	0	\N
113738	1726	671968102000	13963	7156	9	0	\N
113739	1726	671967099000	13963	7156	10	0	\N
113740	1726	671966098000	13963	7156	11	0	\N
113741	1726	671965096000	13963	7156	12	0	\N
113742	1397	1361262260000	13964	7156	0	0	\N
113743	114	66672743000000	13964	7156	1	0	\N
113744	1397	1361252259000	13964	7156	2	0	\N
113745	1397	1361242258000	13964	7156	3	0	\N
113746	1397	1361232257000	13964	7156	4	0	\N
113747	1397	1361222256000	13964	7156	5	0	\N
113748	1397	1361212255000	13964	7156	6	0	\N
113749	1397	1361202254000	13964	7156	7	0	\N
113750	1726	671969104000	13964	7156	8	0	\N
113751	1726	671968102000	13964	7156	9	0	\N
113752	1726	671967099000	13964	7156	10	0	\N
113753	1726	671966098000	13964	7156	11	0	\N
113754	1726	671965096000	13964	7156	12	0	\N
113759	1397	1361192253000	13966	7157	0	0	\N
113760	1397	1361182252000	13967	7158	0	0	\N
113761	1726	671945056000	13967	7158	1	0	\N
113762	1726	671944054000	13967	7158	2	0	\N
113763	1726	671943051000	13967	7158	3	0	\N
113765	114	66002733000000	13969	7159	0	0	\N
113766	1397	1361172251000	13969	7159	1	0	\N
113767	1397	1361162250000	13969	7159	2	0	\N
113768	1726	671945056000	13969	7159	3	0	\N
113769	1726	671944054000	13969	7159	4	0	\N
113770	1726	671943051000	13969	7159	5	0	\N
113771	1726	671942049000	13969	7159	6	0	\N
113772	1726	671941048000	13969	7159	7	0	\N
113773	1726	671940045000	13969	7159	8	0	\N
113774	1726	671939043000	13969	7159	9	0	\N
113775	1726	671938042000	13969	7159	10	0	\N
113776	1726	671937039000	13969	7159	11	0	\N
113789	114	66002733000000	13971	7159	0	0	\N
113790	1397	1361172251000	13971	7159	1	0	\N
113791	1397	1361162250000	13971	7159	2	0	\N
113800	1397	1361152249000	13973	7160	0	0	\N
113801	1397	1361142248000	13973	7160	1	0	\N
113802	1397	1361152249000	13974	7160	0	0	\N
113803	1397	1361142248000	13974	7160	1	0	\N
113804	1726	671936037000	13974	7160	2	0	\N
113805	1726	671935036000	13974	7160	3	0	\N
113806	1726	671934033000	13974	7160	4	0	\N
113807	1726	671933031000	13974	7160	5	0	\N
113808	1726	671932030000	13974	7160	6	0	\N
113809	1726	671931027000	13974	7160	7	0	\N
113814	1397	1361132247000	13976	7161	0	0	\N
113815	1726	671930025000	13976	7161	1	0	\N
113816	1726	671929024000	13976	7161	2	0	\N
113817	1726	671928021000	13976	7161	3	0	\N
113818	1397	1361132247000	13977	7161	0	0	\N
113819	1726	671930025000	13977	7161	1	0	\N
113820	1726	671929024000	13977	7161	2	0	\N
113821	1726	671928021000	13977	7161	3	0	\N
113822	1397	1361122246000	13978	7162	0	0	\N
113823	1397	1361112245000	13978	7162	1	0	\N
113824	1397	1361102244000	13978	7162	2	0	\N
113825	1726	671927019000	13978	7162	3	0	\N
113826	1726	671926018000	13978	7162	4	0	\N
113827	1726	671925015000	13978	7162	5	0	\N
113828	1726	671924013000	13978	7162	6	0	\N
113829	1726	671923012000	13978	7162	7	0	\N
113830	1726	671922009000	13978	7162	8	0	\N
113831	1726	671921007000	13978	7162	9	0	\N
113832	1726	671920006000	13978	7162	10	0	\N
113699	1726	671970105000	13960	7154	10	0	6278
113700	1397	1361262260000	13962	7156	0	0	7757
113701	114	66672743000000	13962	7156	1	0	7
113702	1397	1361252259000	13962	7156	2	0	7758
113703	1397	1361242258000	13962	7156	3	0	7759
113705	1397	1361222256000	13962	7156	5	0	7761
113706	1397	1361212255000	13962	7156	6	0	7762
113707	1397	1361202254000	13962	7156	7	0	7763
113708	1726	671969104000	13962	7156	8	0	6279
113709	1726	671968102000	13962	7156	9	0	6280
113711	1726	671966098000	13962	7156	11	0	6282
113712	1726	671965096000	13962	7156	12	0	6283
113713	1726	671964093000	13962	7156	13	0	6284
113714	1726	671963092000	13962	7156	14	0	6285
113716	1726	671961087000	13962	7156	16	0	6287
113717	1726	671960086000	13962	7156	17	0	6288
113718	1726	671959084000	13962	7156	18	0	6289
113719	1726	671958081000	13962	7156	19	0	6290
113720	1726	671957080000	13962	7156	20	0	6291
113722	1726	671955075000	13962	7156	22	0	6293
113723	1726	671954074000	13962	7156	23	0	6294
113724	1726	671953072000	13962	7156	24	0	6295
113725	1726	671952069000	13962	7156	25	0	6296
113726	1726	671951068000	13962	7156	26	0	6297
113728	1726	671949063000	13962	7156	28	0	6299
113755	1397	1361192253000	13965	7157	0	0	7764
113756	1726	671948062000	13965	7157	1	0	6300
113757	1726	671947060000	13965	7157	2	0	6301
113764	1397	1361182252000	13968	7158	0	0	7765
113777	114	66002733000000	13970	7159	0	0	8
113778	1397	1361172251000	13970	7159	1	0	7766
113779	1397	1361162250000	13970	7159	2	0	7767
113780	1726	671945056000	13970	7159	3	0	6303
113782	1726	671943051000	13970	7159	5	0	6305
113783	1726	671942049000	13970	7159	6	0	6306
113784	1726	671941048000	13970	7159	7	0	6307
113785	1726	671940045000	13970	7159	8	0	6308
113786	1726	671939043000	13970	7159	9	0	6309
113788	1726	671937039000	13970	7159	11	0	6311
113792	1397	1361152249000	13972	7160	0	0	7768
113793	1397	1361142248000	13972	7160	1	0	7769
113794	1726	671936037000	13972	7160	2	0	6312
113796	1726	671934033000	13972	7160	4	0	6314
113797	1726	671933031000	13972	7160	5	0	6315
113798	1726	671932030000	13972	7160	6	0	6316
113799	1726	671931027000	13972	7160	7	0	6317
113810	1397	1361132247000	13975	7161	0	0	7770
113812	1726	671929024000	13975	7161	2	0	6319
113813	1726	671928021000	13975	7161	3	0	6320
113833	1726	671919003000	13978	7162	11	0	\N
113838	1397	1361092243000	13980	7163	0	0	\N
113839	1397	1361082242000	13980	7163	1	0	\N
113840	1726	671926018000	13980	7163	2	0	\N
113841	1726	671925015000	13980	7163	3	0	\N
113842	1726	671924013000	13980	7163	4	0	\N
113843	1726	671923012000	13980	7163	5	0	\N
113844	1726	671922009000	13980	7163	6	0	\N
113845	1726	671921007000	13980	7163	7	0	\N
113846	1726	671920006000	13980	7163	8	0	\N
113847	1726	671919003000	13980	7163	9	0	\N
113848	1726	671918001000	13980	7163	10	0	\N
113849	1726	671917000000	13980	7163	11	0	\N
113850	1726	671915997000	13980	7163	12	0	\N
113851	1726	671914995000	13980	7163	13	0	\N
113852	1726	671913994000	13980	7163	14	0	\N
113853	1726	671912991000	13980	7163	15	0	\N
113870	1397	1361092243000	13982	7163	0	0	\N
113871	1397	1361082242000	13982	7163	1	0	\N
113872	1397	1361072241000	13982	7163	2	0	\N
113873	1726	671926018000	13982	7163	3	0	\N
113874	1726	671925015000	13982	7163	4	0	\N
113875	1726	671924013000	13982	7163	5	0	\N
113876	1726	671923012000	13982	7163	6	0	\N
113877	1726	671922009000	13982	7163	7	0	\N
113878	1726	671921007000	13982	7163	8	0	\N
113879	1726	671920006000	13982	7163	9	0	\N
113880	1726	671919003000	13982	7163	10	0	\N
113885	114	66672743000000	13984	7128	0	0	\N
113886	114	66002733000000	13984	7128	1	0	\N
113887	1749	1965026000000	13984	7128	2	0	\N
113898	1397	1361042238000	13987	7167	0	0	\N
113899	1726	671900967000	13987	7167	1	0	\N
113900	1726	671899965000	13987	7167	2	0	\N
113901	1726	671898964000	13987	7167	3	0	\N
113914	1397	1361012235000	13990	7169	0	0	\N
113915	1726	671892952000	13990	7169	1	0	\N
113916	1726	671891949000	13990	7169	2	0	\N
113917	1726	671890947000	13990	7169	3	0	\N
113918	1397	1361012235000	13991	7169	0	0	\N
113919	1726	671892952000	13991	7169	1	0	\N
113920	1726	671891949000	13991	7169	2	0	\N
113921	1726	671890947000	13991	7169	3	0	\N
113922	1397	1361012235000	13992	7169	0	0	\N
113923	1726	671892952000	13992	7169	1	0	\N
113924	1726	671891949000	13992	7169	2	0	\N
113925	1726	671890947000	13992	7169	3	0	\N
113935	1397	1361002234000	13995	7170	0	0	\N
113936	1726	671892952000	13995	7170	1	0	\N
113937	1925	1199000000	13995	7170	2	0	\N
113938	1726	671891949000	13995	7170	3	0	\N
113939	1726	671890947000	13995	7170	4	0	\N
113949	1397	1360992233000	13997	7171	0	0	\N
113950	1397	1360982232000	13997	7171	1	0	\N
113951	1769	1705900000	13997	7171	2	0	\N
113952	1925	1198000000	13997	7171	3	0	\N
113953	1726	671886938000	13997	7171	4	0	\N
113954	1726	671885936000	13997	7171	5	0	\N
113955	1726	671884933000	13997	7171	6	0	\N
113956	1726	671883932000	13997	7171	7	0	\N
113957	1726	671882930000	13997	7171	8	0	\N
113958	1397	1360972231000	13998	7172	0	0	\N
113959	1726	671881927000	13998	7172	1	0	\N
113960	1726	671880926000	13998	7172	2	0	\N
113961	1726	671879924000	13998	7172	3	0	\N
113963	1926	1198000000	14000	7129	0	0	\N
113964	1769	1705900000	14000	7129	1	0	\N
113965	1924	1198000000	14000	7129	2	0	\N
113966	1925	1199000000	14000	7129	3	0	\N
113967	1925	1198000000	14000	7129	4	0	\N
113836	1397	1361102244000	13979	7162	2	0	7773
113837	1726	671927019000	13979	7162	3	0	6321
113854	1397	1361092243000	13981	7163	0	0	7774
113855	1397	1361082242000	13981	7163	1	0	7775
113856	1726	671926018000	13981	7163	2	0	6322
113858	1726	671924013000	13981	7163	4	0	6324
113859	1726	671923012000	13981	7163	5	0	6325
113860	1726	671922009000	13981	7163	6	0	6326
113861	1726	671921007000	13981	7163	7	0	6327
113862	1726	671920006000	13981	7163	8	0	6328
113864	1726	671918001000	13981	7163	10	0	6330
113865	1726	671917000000	13981	7163	11	0	6331
113866	1726	671915997000	13981	7163	12	0	6332
113867	1726	671914995000	13981	7163	13	0	6333
113869	1726	671912991000	13981	7163	15	0	6335
113881	1397	1361072241000	13983	7164	0	0	7776
113882	1726	671911989000	13983	7164	1	0	6336
113883	1726	671910988000	13983	7164	2	0	6337
113884	1726	671909985000	13983	7164	3	0	6338
113889	1726	671908983000	13985	7165	1	0	6339
113890	1726	671907982000	13985	7165	2	0	6340
113891	1726	671906979000	13985	7165	3	0	6341
113892	1726	671905977000	13985	7165	4	0	6342
113893	1726	671904976000	13985	7165	5	0	6343
113895	1726	671903973000	13986	7166	1	0	6344
113896	1726	671902971000	13986	7166	2	0	6345
113897	1726	671901970000	13986	7166	3	0	6346
113902	1397	1361042238000	13988	7167	0	0	7779
113904	1726	671899965000	13988	7167	2	0	6348
113905	1726	671898964000	13988	7167	3	0	6349
113906	1397	1361032237000	13989	7168	0	0	7780
113907	1397	1361022236000	13989	7168	1	0	7781
113908	1926	1198000000	13989	7168	2	0	2
113910	1726	671896959000	13989	7168	4	0	6351
113911	1726	671895958000	13989	7168	5	0	6352
113912	1726	671894955000	13989	7168	6	0	6353
113913	1726	671893953000	13989	7168	8	0	6354
113926	1397	1361012235000	13993	7169	0	0	7782
113928	1726	671892952000	13994	7170	1	0	6355
113929	1925	1199000000	13994	7170	2	0	1
113930	1726	671891949000	13994	7170	3	0	6356
113931	1726	671890947000	13994	7170	4	0	6357
113933	1726	671888943000	13994	7170	6	0	6359
113934	1726	671887941000	13994	7170	7	0	6360
113940	1397	1360992233000	13996	7171	0	0	7784
113941	1397	1360982232000	13996	7171	1	0	7785
113942	1769	1705900000	13996	7171	2	0	28
113944	1726	671886938000	13996	7171	4	0	6361
113945	1726	671885936000	13996	7171	5	0	6362
113946	1726	671884933000	13996	7171	6	0	6363
113947	1726	671883932000	13996	7171	7	0	6364
113948	1726	671882930000	13996	7171	8	0	6365
113968	1397	1360962230000	14001	7173	0	0	7787
114001	1775	849210000	14005	7177	0	0	\N
114002	1397	1360892223000	14005	7177	1	0	\N
114003	1397	1360882222000	14005	7177	2	0	\N
114004	1397	1360872221000	14005	7177	3	0	\N
114005	1726	671858882000	14005	7177	4	0	\N
114006	1726	671857879000	14005	7177	5	0	\N
114007	1726	671856878000	14005	7177	6	0	\N
114008	1726	671855876000	14005	7177	7	0	\N
114009	1726	671854873000	14005	7177	8	0	\N
114010	1726	671853872000	14005	7177	9	0	\N
114011	1726	671852870000	14005	7177	10	0	\N
114012	1726	671851867000	14005	7177	11	0	\N
114013	1726	671850866000	14005	7177	12	0	\N
114031	1397	1360852219000	14008	7179	0	0	\N
114032	1926	1197000000	14008	7179	1	0	\N
114033	1726	671846858000	14008	7179	2	0	\N
114034	1726	671845855000	14008	7179	3	0	\N
114035	1726	671844854000	14008	7179	4	0	\N
114054	1397	1360822216000	14013	7182	0	0	\N
114055	1926	1196000000	14013	7182	1	0	\N
114056	1397	1360812215000	14014	7183	0	0	\N
114057	1925	1196000000	14014	7183	1	0	\N
114058	1726	671836837000	14014	7183	2	0	\N
114059	1726	671835835000	14014	7183	3	0	\N
114060	1726	671834832000	14014	7183	4	0	\N
114061	1397	1360812215000	14015	7183	0	0	\N
114062	1925	1196000000	14015	7183	1	0	\N
114063	1726	671836837000	14015	7183	2	0	\N
114064	1726	671835835000	14015	7183	3	0	\N
114065	1726	671834832000	14015	7183	4	0	\N
114072	1775	861300000	14018	7131	0	0	\N
114073	1775	849210000	14018	7131	1	0	\N
114074	114	66672743000000	14018	7131	2	0	\N
114075	114	66002733000000	14018	7131	3	0	\N
114076	1926	1198000000	14018	7131	4	0	\N
114077	1769	1705900000	14018	7131	5	0	\N
114078	1926	1197000000	14018	7131	6	0	\N
114079	1924	1198000000	14018	7131	7	0	\N
114080	1924	1197000000	14018	7131	8	0	\N
114081	1924	1196000000	14018	7131	9	0	\N
114082	1926	1196000000	14018	7131	10	0	\N
114083	1925	1199000000	14018	7131	11	0	\N
114084	1925	1198000000	14018	7131	12	0	\N
114085	1749	1965026000000	14018	7131	13	0	\N
114086	1925	1197000000	14018	7131	14	0	\N
114087	1925	1196000000	14018	7131	15	0	\N
114088	1769	1704900000	14018	7131	16	0	\N
114099	1397	1360792213000	14021	7185	0	0	\N
114100	1397	1360782212000	14021	7185	1	0	\N
114101	1924	1196000000	14021	7185	2	0	\N
114102	1726	671833830000	14021	7185	3	0	\N
114103	1726	671832827000	14021	7185	4	0	\N
114104	1726	671831825000	14021	7185	5	0	\N
113971	1726	671881927000	14001	7173	3	0	6366
113972	1924	1198000000	14001	7173	4	0	2
113973	1726	671880926000	14001	7173	5	0	6367
113974	1726	671879924000	14001	7173	6	0	6368
113975	1726	671878921000	14001	7173	7	0	6369
113977	1726	671876918000	14001	7173	9	0	6371
113978	1726	671875915000	14001	7173	10	0	6372
113979	1726	671874914000	14001	7173	11	0	6373
113980	1726	671873912000	14001	7173	12	0	6374
113981	1726	671872909000	14001	7173	13	0	6375
113983	1726	671870906000	14001	7173	15	0	6377
113984	1397	1360932227000	14002	7174	0	0	7790
113985	1769	1704900000	14002	7174	1	0	29
113986	1397	1360922226000	14003	7175	0	0	7791
113988	1397	1360912225000	14004	7176	1	0	7792
113989	1397	1360902224000	14004	7176	2	0	7793
113990	1726	671869903000	14004	7176	3	0	6378
113991	1726	671868902000	14004	7176	4	0	6379
113992	1726	671867900000	14004	7176	5	0	6380
113994	1726	671865896000	14004	7176	7	0	6382
113995	1726	671864894000	14004	7176	8	0	6383
113996	1726	671863891000	14004	7176	9	0	6384
113997	1726	671862890000	14004	7176	10	0	6385
113998	1726	671861888000	14004	7176	11	0	6386
114000	1726	671859884000	14004	7176	13	0	6388
114014	1775	849210000	14006	7177	0	0	17
114015	1397	1360892223000	14006	7177	1	0	7794
114016	1397	1360882222000	14006	7177	2	0	7795
114018	1397	1360862220000	14007	7178	0	0	7797
114019	1726	671858882000	14007	7178	1	0	6389
114020	1726	671857879000	14007	7178	2	0	6390
114021	1726	671856878000	14007	7178	3	0	6391
114022	1726	671855876000	14007	7178	4	0	6392
114024	1726	671853872000	14007	7178	6	0	6394
114025	1726	671852870000	14007	7178	7	0	6395
114026	1726	671851867000	14007	7178	8	0	6396
114027	1726	671850866000	14007	7178	9	0	6397
114028	1726	671849864000	14007	7178	10	0	6398
114030	1726	671847860000	14007	7178	12	0	6400
114036	1397	1360852219000	14009	7179	0	0	7798
114037	1926	1197000000	14009	7179	1	0	3
114038	1397	1360842218000	14010	7180	0	0	7799
114040	1726	671845855000	14010	7180	2	0	6402
114041	1726	671844854000	14010	7180	3	0	6403
114042	1726	671843852000	14010	7180	4	0	6404
114043	1726	671842849000	14010	7180	5	0	6405
114044	1397	1360832217000	14011	7181	0	0	7800
114046	1726	671841847000	14011	7181	2	0	6406
114047	1726	671840844000	14011	7181	3	0	6407
114048	1925	1197000000	14011	7181	4	0	3
114049	1397	1360822216000	14012	7182	0	0	7801
114050	1926	1196000000	14012	7182	1	0	4
114052	1726	671838841000	14012	7182	3	0	6409
114053	1726	671837838000	14012	7182	4	0	6410
114066	1397	1360812215000	14016	7183	0	0	7802
114067	1925	1196000000	14016	7183	1	0	4
114069	1726	671835835000	14016	7183	3	0	6412
114070	1726	671834832000	14016	7183	4	0	6413
114071	1397	1360802214000	14017	7184	0	0	7803
114089	1397	1360792213000	14020	7185	0	0	7804
114090	1397	1360782212000	14020	7185	1	0	7805
114092	1726	671833830000	14020	7185	3	0	6414
114093	1726	671832827000	14020	7185	4	0	6415
114094	1726	671831825000	14020	7185	5	0	6416
114095	1726	671830822000	14020	7185	6	0	6417
114096	1726	671829820000	14020	7185	7	0	6418
114098	1726	671827816000	14020	7185	9	0	6420
114105	1726	671830822000	14021	7185	6	0	\N
114106	1726	671829820000	14021	7185	7	0	\N
114107	1726	671828819000	14021	7185	8	0	\N
114108	1726	671827816000	14021	7185	9	0	\N
114109	1397	1360792213000	14022	7185	0	0	\N
114110	1397	1360782212000	14022	7185	1	0	\N
114111	1924	1196000000	14022	7185	2	0	\N
114112	1726	671833830000	14022	7185	3	0	\N
114113	1726	671832827000	14022	7185	4	0	\N
114114	1726	671831825000	14022	7185	5	0	\N
114115	1726	671830822000	14022	7185	6	0	\N
114116	1726	671829820000	14022	7185	7	0	\N
114117	1726	671828819000	14022	7185	8	0	\N
114118	1726	671827816000	14022	7185	9	0	\N
114119	1397	1360792213000	14023	7185	0	0	\N
114120	1397	1360782212000	14023	7185	1	0	\N
114121	1924	1196000000	14023	7185	2	0	\N
114122	1397	1360792213000	14024	7185	0	0	\N
114123	1397	1360782212000	14024	7185	1	0	\N
114124	1924	1196000000	14024	7185	2	0	\N
114125	1726	671833830000	14024	7185	3	0	\N
114126	1726	671832827000	14024	7185	4	0	\N
114127	1726	671831825000	14024	7185	5	0	\N
114128	1726	671830822000	14024	7185	6	0	\N
114129	1726	671829820000	14024	7185	7	0	\N
114130	1726	671828819000	14024	7185	8	0	\N
114131	1726	671827816000	14024	7185	9	0	\N
114132	1397	1360792213000	14025	7185	0	0	\N
114133	1397	1360782212000	14025	7185	1	0	\N
114134	1924	1196000000	14025	7185	2	0	\N
114135	1726	671833830000	14025	7185	3	0	\N
114136	1726	671832827000	14025	7185	4	0	\N
114137	1726	671831825000	14025	7185	5	0	\N
114138	1726	671830822000	14025	7185	6	0	\N
114139	1726	671829820000	14025	7185	7	0	\N
114140	1726	671828819000	14025	7185	8	0	\N
114141	1726	671827816000	14025	7185	9	0	\N
114142	1397	1360792213000	14026	7185	0	0	\N
114143	1397	1360782212000	14026	7185	1	0	\N
114144	1924	1196000000	14026	7185	2	0	\N
114145	1726	671833830000	14026	7185	3	0	\N
114146	1726	671832827000	14026	7185	4	0	\N
114147	1726	671831825000	14026	7185	5	0	\N
114148	1726	671830822000	14026	7185	6	0	\N
114149	1726	671829820000	14026	7185	7	0	\N
114150	1726	671828819000	14026	7185	8	0	\N
114151	1726	671827816000	14026	7185	9	0	\N
114158	1397	1360752209000	14029	7188	0	0	\N
114165	1397	1360762210000	14031	7187	0	0	\N
114166	1397	1360752209000	14031	7187	1	0	\N
114167	1397	1360752209000	14032	7188	0	0	\N
114168	1726	671823808000	14032	7188	1	0	\N
114169	1726	671822807000	14032	7188	2	0	\N
114170	1726	671821804000	14032	7188	3	0	\N
114171	1726	671820802000	14032	7188	4	0	\N
114172	1726	671819799000	14032	7188	5	0	\N
114173	1397	1360752209000	14033	7188	0	0	\N
114174	1397	1360742208000	14034	7189	0	0	\N
114175	1726	671818797000	14034	7189	1	0	\N
114176	1726	671817794000	14034	7189	2	0	\N
114178	1397	1360742208000	14036	7189	0	0	\N
114179	1726	671818797000	14036	7189	1	0	\N
114180	1726	671817794000	14036	7189	2	0	\N
114181	1397	1360742208000	14037	7189	0	0	\N
114182	1397	1360732207000	14038	7190	0	0	\N
114183	1397	1360722206000	14038	7190	1	0	\N
114192	1397	1360712205000	14040	7191	0	0	\N
114193	1397	1360702204000	14040	7191	1	0	\N
114194	1726	671812783000	14040	7191	2	0	\N
114195	1726	671811782000	14040	7191	3	0	\N
114196	1726	671810780000	14040	7191	4	0	\N
114197	1726	671809777000	14040	7191	5	0	\N
114198	1726	671808776000	14040	7191	6	0	\N
114199	1726	671807774000	14040	7191	7	0	\N
114208	1397	1360692203000	14042	7192	0	0	\N
114209	1397	1360682202000	14042	7192	1	0	\N
114210	1726	671806771000	14042	7192	2	0	\N
114211	1726	671805770000	14042	7192	3	0	\N
114212	1726	671804768000	14042	7192	4	0	\N
114213	1726	671803765000	14042	7192	5	0	\N
114214	1726	671802764000	14042	7192	6	0	\N
114215	1726	671801762000	14042	7192	7	0	\N
114218	2058	549500000	14044	7193	0	0	\N
114219	1397	1360672201000	14044	7193	1	0	\N
114220	1726	671806771000	14044	7193	2	0	\N
114221	1726	671805770000	14044	7193	3	0	\N
114222	1726	671804768000	14044	7193	4	0	\N
114223	1726	671803765000	14044	7193	5	0	\N
114224	1726	671802764000	14044	7193	6	0	\N
114225	1726	671801762000	14044	7193	7	0	\N
114237	2058	549500000	14046	7193	0	0	\N
114238	1397	1360672201000	14046	7193	1	0	\N
114239	1726	671806771000	14046	7193	2	0	\N
114240	1726	671805770000	14046	7193	3	0	\N
114154	1726	671825813000	14027	7186	2	0	6422
114155	1726	671824810000	14027	7186	3	0	6423
114156	1925	1195000000	14027	7186	4	0	5
114157	1397	1360762210000	14028	7187	0	0	7807
114159	1397	1360752209000	14030	7188	0	0	7808
114161	1726	671822807000	14030	7188	2	0	6425
114162	1726	671821804000	14030	7188	3	0	6426
114163	1726	671820802000	14030	7188	4	0	6427
114164	1726	671819799000	14030	7188	5	0	6428
114177	1397	1360742208000	14035	7189	0	0	7809
114185	1397	1360722206000	14039	7190	1	0	7811
114186	1726	671818797000	14039	7190	2	0	6429
114187	1726	671817794000	14039	7190	3	0	6430
114188	1726	671816792000	14039	7190	4	0	6431
114190	1726	671814788000	14039	7190	6	0	6433
114191	1726	671813786000	14039	7190	7	0	6434
114200	1397	1360712205000	14041	7191	0	0	7812
114201	1397	1360702204000	14041	7191	1	0	7813
114202	1726	671812783000	14041	7191	2	0	6435
114204	1726	671810780000	14041	7191	4	0	6437
114205	1726	671809777000	14041	7191	5	0	6438
114206	1726	671808776000	14041	7191	6	0	6439
114207	1726	671807774000	14041	7191	7	0	6440
114216	1397	1360692203000	14043	7192	0	0	7814
114226	2058	549500000	14045	7193	0	0	6
114227	1397	1360672201000	14045	7193	1	0	7816
114228	1726	671806771000	14045	7193	2	0	6441
114229	1726	671805770000	14045	7193	3	0	6442
114231	1726	671803765000	14045	7193	5	0	6444
114232	1726	671802764000	14045	7193	6	0	6445
114233	1726	671801762000	14045	7193	7	0	6446
114234	1726	671800759000	14045	7193	8	0	6447
114235	1726	671799758000	14045	7193	9	0	6448
114241	1726	671804768000	14046	7193	4	0	\N
114242	1726	671803765000	14046	7193	5	0	\N
114243	1726	671802764000	14046	7193	6	0	\N
114244	1726	671801762000	14046	7193	7	0	\N
114245	1726	671800759000	14046	7193	8	0	\N
114246	1726	671799758000	14046	7193	9	0	\N
114247	1726	671798756000	14046	7193	10	0	\N
114248	2058	549500000	14047	7193	0	0	\N
114249	1726	671806771000	14047	7193	1	0	\N
114250	1726	671805770000	14047	7193	2	0	\N
114251	1726	671804768000	14047	7193	3	0	\N
114252	1726	671803765000	14047	7193	4	0	\N
114253	1726	671802764000	14047	7193	5	0	\N
114254	1726	671801762000	14047	7193	6	0	\N
114255	1726	671800759000	14047	7193	7	0	\N
114256	1726	671799758000	14047	7193	8	0	\N
114257	1726	671798756000	14047	7193	9	0	\N
114258	2058	549500000	14048	7193	0	0	\N
114259	1397	1360672201000	14048	7193	1	0	\N
114260	1726	671806771000	14048	7193	2	0	\N
114261	1726	671805770000	14048	7193	3	0	\N
114262	1726	671804768000	14048	7193	4	0	\N
114263	1726	671803765000	14048	7193	5	0	\N
114264	1726	671802764000	14048	7193	6	0	\N
114265	1726	671801762000	14048	7193	7	0	\N
114266	1726	671800759000	14048	7193	8	0	\N
114267	1726	671799758000	14048	7193	9	0	\N
114268	1726	671798756000	14048	7193	10	0	\N
114269	2058	549500000	14049	7193	0	0	\N
114270	1397	1360672201000	14049	7193	1	0	\N
114271	2058	549500000	14050	7193	0	0	\N
114272	1397	1360672201000	14050	7193	1	0	\N
114273	1726	671806771000	14050	7193	2	0	\N
114274	1726	671805770000	14050	7193	3	0	\N
114275	1726	671804768000	14050	7193	4	0	\N
114276	1726	671803765000	14050	7193	5	0	\N
114277	1726	671802764000	14050	7193	6	0	\N
114278	1726	671801762000	14050	7193	7	0	\N
114279	1726	671800759000	14050	7193	8	0	\N
114280	1726	671799758000	14050	7193	9	0	\N
114281	1726	671798756000	14050	7193	10	0	\N
114287	1397	1360662200000	14052	7194	0	0	\N
114288	1925	1194000000	14052	7194	1	0	\N
114289	1726	671797753000	14052	7194	2	0	\N
114290	1726	671796752000	14052	7194	3	0	\N
114291	1726	671795750000	14052	7194	4	0	\N
114292	1397	1360652199000	14053	7195	0	0	\N
114293	1397	1360642198000	14053	7195	1	0	\N
114306	1397	1360632197000	14056	7196	0	0	\N
114307	1726	671788735000	14056	7196	1	0	\N
114308	1726	671787734000	14056	7196	2	0	\N
114309	1726	671786732000	14056	7196	3	0	\N
114310	1726	671788735000	14057	7196	0	0	\N
114311	1726	671787734000	14057	7196	1	0	\N
114312	1726	671786732000	14057	7196	2	0	\N
114313	1726	671788735000	14058	7196	0	0	\N
114314	1726	671787734000	14058	7196	1	0	\N
114315	1726	671786732000	14058	7196	2	0	\N
114324	1397	1360622196000	14060	7197	0	0	\N
114325	1726	671785729000	14060	7197	1	0	\N
114326	1769	1703900000	14060	7197	2	0	\N
114327	1726	671784728000	14060	7197	3	0	\N
114328	1726	671783726000	14060	7197	4	0	\N
114329	1726	671782723000	14060	7197	5	0	\N
114330	1726	671781722000	14060	7197	6	0	\N
114331	1726	671780720000	14060	7197	7	0	\N
114332	1397	1360612195000	14061	7198	0	0	\N
114333	1726	671779717000	14061	7198	1	0	\N
114334	1726	671778716000	14061	7198	2	0	\N
114335	1726	671777714000	14061	7198	3	0	\N
114336	1397	1360612195000	14062	7198	0	0	\N
114345	1397	1360592193000	14067	7200	0	0	\N
114346	1397	1360592193000	14068	7200	0	0	\N
114347	1726	671773705000	14068	7200	1	0	\N
114348	1726	671772704000	14068	7200	2	0	\N
114349	1726	671771702000	14068	7200	3	0	\N
114354	1397	1360592193000	14070	7200	0	0	\N
114355	1726	671773705000	14070	7200	1	0	\N
114356	1726	671772704000	14070	7200	2	0	\N
114357	1726	671771702000	14070	7200	3	0	\N
114358	1775	861300000	14071	7130	0	0	\N
114359	1775	849210000	14071	7130	1	0	\N
114360	2058	549500000	14071	7130	2	0	\N
114361	1926	1197000000	14071	7130	3	0	\N
114362	1924	1197000000	14071	7130	4	0	\N
114363	1924	1196000000	14071	7130	5	0	\N
114364	1926	1196000000	14071	7130	6	0	\N
114365	1925	1197000000	14071	7130	7	0	\N
114366	1925	1196000000	14071	7130	8	0	\N
114367	1925	1195000000	14071	7130	9	0	\N
114368	1925	1194000000	14071	7130	10	0	\N
114369	1769	1704900000	14071	7130	11	0	\N
114370	1769	1703900000	14071	7130	12	0	\N
114371	1397	1360582192000	14072	7201	0	0	\N
114372	1726	671770699000	14072	7201	1	0	\N
114373	1726	671769698000	14072	7201	2	0	\N
114374	1726	671768696000	14072	7201	3	0	\N
114284	1726	671797753000	14051	7194	2	0	6450
114285	1726	671796752000	14051	7194	3	0	6451
114286	1726	671795750000	14051	7194	4	0	6452
114294	1397	1360652199000	14054	7195	0	0	7818
114295	1397	1360642198000	14054	7195	1	0	7819
114297	1726	671793746000	14054	7195	3	0	6454
114298	1726	671792744000	14054	7195	4	0	6455
114299	1726	671791741000	14054	7195	5	0	6456
114300	1726	671790740000	14054	7195	6	0	6457
114301	1726	671789738000	14054	7195	7	0	6458
114303	1726	671788735000	14055	7196	1	0	6459
114304	1726	671787734000	14055	7196	2	0	6460
114305	1726	671786732000	14055	7196	3	0	6461
114316	1397	1360622196000	14059	7197	0	0	7821
114318	1769	1703900000	14059	7197	2	0	30
114319	1726	671784728000	14059	7197	3	0	6463
114320	1726	671783726000	14059	7197	4	0	6464
114321	1726	671782723000	14059	7197	5	0	6465
114322	1726	671781722000	14059	7197	6	0	6466
114337	1397	1360612195000	14064	7198	0	0	7822
114338	1726	671779717000	14064	7198	1	0	6468
114339	1726	671778716000	14064	7198	2	0	6469
114340	1726	671777714000	14064	7198	3	0	6470
114341	1397	1360602194000	14066	7199	0	0	7823
114343	1726	671775710000	14066	7199	2	0	6472
114344	1726	671774708000	14066	7199	3	0	6473
114350	1397	1360592193000	14069	7200	0	0	7824
114351	1726	671773705000	14069	7200	1	0	6474
114353	1726	671771702000	14069	7200	3	0	6476
114375	1397	1360582192000	14073	7201	0	0	7825
114376	1726	671770699000	14073	7201	1	0	6477
114393	1397	1360552189000	14084	7204	0	0	\N
114394	1726	671761681000	14084	7204	1	0	\N
114395	1726	670551681000	14084	7204	2	0	\N
114396	1726	669341681000	14084	7204	3	0	\N
114397	1726	669340680000	14084	7204	4	0	\N
114398	1726	669339678000	14084	7204	5	0	\N
114399	1726	668129678000	14085	7205	0	0	\N
114400	1397	1360542188000	14085	7205	1	0	\N
114401	1397	1360532187000	14085	7205	2	0	\N
114402	1726	668128675000	14085	7205	3	0	\N
114403	1726	668127674000	14085	7205	4	0	\N
114404	1726	668126672000	14085	7205	5	0	\N
114405	1726	668125669000	14085	7205	6	0	\N
114406	1726	668124668000	14085	7205	7	0	\N
114407	1726	668123666000	14085	7205	8	0	\N
114408	1726	668129678000	14086	7205	0	0	\N
114409	1397	1360542188000	14086	7205	1	0	\N
114410	1397	1360532187000	14086	7205	2	0	\N
114411	1726	668128675000	14086	7205	3	0	\N
114412	1726	668127674000	14086	7205	4	0	\N
114413	1726	668126672000	14086	7205	5	0	\N
114414	1726	668125669000	14086	7205	6	0	\N
114415	1726	668124668000	14086	7205	7	0	\N
114416	1726	668123666000	14086	7205	8	0	\N
114426	1726	668129678000	14088	7205	0	0	\N
114427	1397	1360542188000	14088	7205	1	0	\N
114428	1397	1360532187000	14088	7205	2	0	\N
114429	1726	668128675000	14088	7205	3	0	\N
114430	1726	668127674000	14088	7205	4	0	\N
114431	1726	668126672000	14088	7205	5	0	\N
114432	1726	668125669000	14088	7205	6	0	\N
114433	1726	668124668000	14088	7205	7	0	\N
114434	1726	668123666000	14088	7205	8	0	\N
114436	1397	1360522186000	14090	7206	0	0	\N
114437	1726	668122663000	14090	7206	1	0	\N
114438	1726	668121662000	14090	7206	2	0	\N
114439	1726	668120660000	14090	7206	3	0	\N
114440	1397	1360522186000	14091	7206	0	0	\N
114441	1726	668122663000	14091	7206	1	0	\N
114442	1726	668121662000	14091	7206	2	0	\N
114443	1726	668120660000	14091	7206	3	0	\N
114444	1397	1360522186000	14092	7206	0	0	\N
114445	1726	668122663000	14092	7206	1	0	\N
114446	1726	668121662000	14092	7206	2	0	\N
114447	1726	668120660000	14092	7206	3	0	\N
114448	1397	1360522186000	14093	7206	0	0	\N
114451	1397	1360512185000	14095	7207	0	0	\N
114452	1926	1195000000	14095	7207	1	0	\N
114453	1726	668122663000	14095	7207	2	0	\N
114454	1726	668121662000	14095	7207	3	0	\N
114455	1726	668120660000	14095	7207	4	0	\N
114456	1726	668119657000	14095	7207	5	0	\N
114457	1726	668118656000	14095	7207	6	0	\N
114458	1397	1360512185000	14096	7207	0	0	\N
114459	1926	1195000000	14096	7207	1	0	\N
114460	1726	668122663000	14096	7207	2	0	\N
114461	1726	668121662000	14096	7207	3	0	\N
114462	1726	668120660000	14096	7207	4	0	\N
114463	1726	668119657000	14096	7207	5	0	\N
114464	1726	668118656000	14096	7207	6	0	\N
114474	1397	1360502184000	14098	7208	0	0	\N
114475	1726	668122663000	14098	7208	1	0	\N
114476	1726	668121662000	14098	7208	2	0	\N
114477	1726	668120660000	14098	7208	3	0	\N
114478	1726	668119657000	14098	7208	4	0	\N
114479	1726	668118656000	14098	7208	5	0	\N
114480	1726	668117653000	14098	7208	6	0	\N
114481	1726	668116651000	14098	7208	7	0	\N
114482	1726	668115650000	14098	7208	8	0	\N
114484	1397	1360492183000	14100	7209	0	0	\N
114485	1726	668114647000	14100	7209	1	0	\N
114486	1726	668113645000	14100	7209	2	0	\N
114487	1726	668112644000	14100	7209	3	0	\N
114494	2058	549500000	14103	7132	0	0	\N
114495	1926	1195000000	14103	7132	1	0	\N
114496	1769	1703900000	14103	7132	2	0	\N
114497	1925	1195000000	14103	7132	3	0	\N
114498	1925	1194000000	14103	7132	4	0	\N
114503	1397	1360472181000	14105	7211	0	0	\N
114504	1397	1360472181000	14106	7211	0	0	\N
114505	1726	668109638000	14106	7211	1	0	\N
114506	1726	668108635000	14106	7211	2	0	\N
114507	1726	668107633000	14106	7211	3	0	\N
114512	1397	1360462180000	14108	7212	0	0	\N
114379	1397	1360572191000	14077	7203	0	0	7826
114380	1397	1360562190000	14077	7203	1	0	7827
114381	1726	671767693000	14077	7203	2	0	6480
114382	1726	671766692000	14077	7203	3	0	6481
114383	1726	671765690000	14077	7203	4	0	6482
114385	1726	671763686000	14077	7203	6	0	6484
114386	1726	671762684000	14077	7203	7	0	6485
114387	1397	1360552189000	14083	7204	0	0	7828
114388	1726	671761681000	14083	7204	1	0	6486
114389	1726	670551681000	14083	7204	2	0	6487
114391	1726	669340680000	14083	7204	4	0	6489
114392	1726	669339678000	14083	7204	5	0	6490
114417	1726	668129678000	14087	7205	0	0	6491
114418	1397	1360542188000	14087	7205	1	0	7829
114420	1726	668128675000	14087	7205	3	0	6492
114421	1726	668127674000	14087	7205	4	0	6493
114422	1726	668126672000	14087	7205	5	0	6494
114423	1726	668125669000	14087	7205	6	0	6495
114424	1726	668124668000	14087	7205	7	0	6496
114435	1397	1360522186000	14089	7206	0	0	7831
114449	1397	1360512185000	14094	7207	0	0	7832
114450	1926	1195000000	14094	7207	1	0	5
114465	1397	1360502184000	14097	7208	0	0	7833
114466	1726	668122663000	14097	7208	1	0	6498
114468	1726	668120660000	14097	7208	3	0	6500
114469	1726	668119657000	14097	7208	4	0	6501
114470	1726	668118656000	14097	7208	5	0	6502
114471	1726	668117653000	14097	7208	6	0	6503
114473	1726	668115650000	14097	7208	8	0	6505
114483	1397	1360492183000	14099	7209	0	0	7834
114488	1397	1360482182000	14102	7210	0	0	7835
114489	1726	668114647000	14102	7210	1	0	6506
114490	1726	668113645000	14102	7210	2	0	6507
114492	1726	668111641000	14102	7210	4	0	6509
114493	1726	668110639000	14102	7210	5	0	6510
114499	1397	1360472181000	14104	7211	0	0	7836
114500	1726	668109638000	14104	7211	1	0	6511
114501	1726	668108635000	14104	7211	2	0	6512
114508	1397	1360462180000	14107	7212	0	0	7837
114509	1726	668106632000	14107	7212	1	0	6514
114510	1726	668105629000	14107	7212	2	0	6515
114511	1726	668104627000	14107	7212	3	0	6516
114513	1726	668106632000	14108	7212	1	0	\N
114514	1726	668105629000	14108	7212	2	0	\N
114515	1726	668104627000	14108	7212	3	0	\N
114516	1397	1360462180000	14109	7212	0	0	\N
114517	1397	1360452179000	14109	7212	1	0	\N
114518	1726	668106632000	14109	7212	2	0	\N
114519	1726	668105629000	14109	7212	3	0	\N
114520	1726	668104627000	14109	7212	4	0	\N
114521	1397	1360462180000	14110	7212	0	0	\N
114522	1397	1360452179000	14110	7212	1	0	\N
114523	1726	668106632000	14110	7212	2	0	\N
114524	1726	668105629000	14110	7212	3	0	\N
114525	1726	668104627000	14110	7212	4	0	\N
114526	1726	668103626000	14110	7212	5	0	\N
114527	1397	1360452179000	14111	7213	0	0	\N
114528	1726	668103626000	14111	7213	1	0	\N
114529	1726	668102623000	14111	7213	2	0	\N
114530	1726	668101621000	14111	7213	3	0	\N
114531	1397	1360452179000	14112	7213	0	0	\N
114532	1726	668103626000	14112	7213	1	0	\N
114533	1726	668102623000	14112	7213	2	0	\N
114534	1726	668101621000	14112	7213	3	0	\N
114559	1397	1360392173000	14118	7217	0	0	\N
114560	1726	668085590000	14118	7217	1	0	\N
114561	1726	668084587000	14118	7217	2	0	\N
114562	1726	668083585000	14118	7217	3	0	\N
114567	1397	1360392173000	14120	7217	0	0	\N
114572	1397	1360382172000	14122	7218	0	0	\N
114573	1726	668082584000	14122	7218	1	0	\N
114574	1726	668081581000	14122	7218	2	0	\N
114575	1726	668080579000	14122	7218	3	0	\N
114576	1397	1360382172000	14123	7218	0	0	\N
114577	1726	668082584000	14123	7218	1	0	\N
114578	1726	668081581000	14123	7218	2	0	\N
114579	1726	668080579000	14123	7218	3	0	\N
114580	1397	1360372171000	14125	7219	0	0	\N
114581	1726	668079576000	14125	7219	1	0	\N
114582	1726	668078575000	14125	7219	2	0	\N
114583	1726	668077573000	14125	7219	3	0	\N
114588	1726	668079576000	14127	7219	0	0	\N
114589	1726	668078575000	14127	7219	1	0	\N
114590	1726	668077573000	14127	7219	2	0	\N
114591	1397	1360372171000	14128	7219	0	0	\N
114592	1726	668079576000	14128	7219	1	0	\N
114593	1726	668078575000	14128	7219	2	0	\N
114594	1397	1360442178000	14129	7214	0	0	\N
114595	1397	1360432177000	14129	7214	1	0	\N
114596	1397	1360422176000	14129	7214	2	0	\N
114597	1397	1360412175000	14129	7214	3	0	\N
114598	1397	1360402174000	14129	7214	4	0	\N
114599	1397	1360392173000	14129	7214	5	0	\N
114600	1397	1360382172000	14129	7214	6	0	\N
114601	1397	1360372171000	14129	7214	7	0	\N
114602	1726	668103626000	14129	7214	8	0	\N
114603	1726	668102623000	14129	7214	9	0	\N
114604	1726	668101621000	14129	7214	10	0	\N
114605	1726	668100620000	14129	7214	11	0	\N
114606	1726	668099617000	14129	7214	12	0	\N
114607	1726	668098615000	14129	7214	13	0	\N
114608	1726	668097614000	14129	7214	14	0	\N
114609	1726	668096611000	14129	7214	15	0	\N
114610	1726	668095609000	14129	7214	16	0	\N
114611	1726	668094608000	14129	7214	17	0	\N
114612	1726	668093605000	14129	7214	18	0	\N
114613	1726	668092603000	14129	7214	19	0	\N
114614	1726	668091602000	14129	7214	20	0	\N
114615	1726	668090599000	14129	7214	21	0	\N
114616	1726	668089597000	14129	7214	22	0	\N
114617	1726	668088596000	14129	7214	23	0	\N
114618	1726	668087593000	14129	7214	24	0	\N
114619	1726	668086591000	14129	7214	25	0	\N
114620	1726	668085590000	14129	7214	26	0	\N
114621	1726	668084587000	14129	7214	27	0	\N
114622	1726	668083585000	14129	7214	28	0	\N
114623	1726	668082584000	14129	7214	29	0	\N
114624	1726	668081581000	14129	7214	30	0	\N
114625	1726	668080579000	14129	7214	31	0	\N
114626	1726	668079576000	14129	7214	32	0	\N
114627	1726	668078575000	14129	7214	33	0	\N
114628	1397	1360362170000	14130	7220	0	0	\N
114629	1397	1360352169000	14130	7220	1	0	\N
114630	1397	1360342168000	14130	7220	2	0	\N
114631	1726	668076570000	14130	7220	3	0	\N
114632	1726	668075568000	14130	7220	4	0	\N
114633	1726	668074565000	14130	7220	5	0	\N
114634	1726	668073564000	14130	7220	6	0	\N
114635	1397	1360362170000	14131	7220	0	0	\N
114636	1397	1360352169000	14131	7220	1	0	\N
114637	1397	1360342168000	14131	7220	2	0	\N
114638	1726	668076570000	14131	7220	3	0	\N
114639	1726	668075568000	14131	7220	4	0	\N
114640	1726	668074565000	14131	7220	5	0	\N
114641	1726	668073564000	14131	7220	6	0	\N
114642	1726	668072562000	14131	7220	8	0	\N
114643	1726	668071559000	14131	7220	9	0	\N
114644	1726	668070558000	14131	7220	10	0	\N
114645	1726	668069556000	14131	7220	11	0	\N
114646	1397	1360362170000	14132	7220	0	0	\N
114647	1397	1360352169000	14132	7220	1	0	\N
114648	1397	1360342168000	14132	7220	2	0	\N
114537	1397	1360432177000	14115	7214	1	0	7840
114538	1397	1360422176000	14115	7214	2	0	7841
114539	1726	668103626000	14115	7214	3	0	6517
114540	1726	668102623000	14115	7214	4	0	6518
114541	1726	668101621000	14115	7214	5	0	6519
114543	1726	668099617000	14115	7214	7	0	6521
114544	1726	668098615000	14115	7214	8	0	6522
114545	1726	668097614000	14115	7214	9	0	6523
114546	1726	668096611000	14115	7214	10	0	6524
114547	1726	668095609000	14115	7214	11	0	6525
114549	1726	668093605000	14115	7214	13	0	6527
114550	1726	668092603000	14115	7214	14	0	6528
114551	1397	1360412175000	14116	7215	0	0	7842
114552	1726	668091602000	14116	7215	1	0	6529
114554	1726	668089597000	14116	7215	3	0	6531
114555	1397	1360402174000	14117	7216	0	0	7843
114556	1726	668088596000	14117	7216	1	0	6532
114557	1726	668087593000	14117	7216	2	0	6533
114558	1726	668086591000	14117	7216	3	0	6534
114564	1726	668085590000	14119	7217	1	0	6535
114565	1726	668084587000	14119	7217	2	0	6536
114566	1726	668083585000	14119	7217	3	0	6537
114568	1397	1360382172000	14121	7218	0	0	7845
114569	1726	668082584000	14121	7218	1	0	6538
114571	1726	668080579000	14121	7218	3	0	6540
114584	1397	1360372171000	14126	7219	0	0	7846
114585	1726	668079576000	14126	7219	1	0	6541
114586	1726	668078575000	14126	7219	2	0	6542
114649	1726	668076570000	14132	7220	3	0	\N
114650	1726	668075568000	14132	7220	4	0	\N
114651	1726	668074565000	14132	7220	5	0	\N
114652	1726	668073564000	14132	7220	6	0	\N
114653	1726	668072562000	14132	7220	8	0	\N
114654	1726	668071559000	14132	7220	9	0	\N
114655	1726	668070558000	14132	7220	10	0	\N
114656	1726	668069556000	14132	7220	11	0	\N
114657	1397	1360362170000	14133	7220	0	0	\N
114658	1397	1360352169000	14133	7220	1	0	\N
114659	1397	1360342168000	14133	7220	2	0	\N
114660	1726	668076570000	14133	7220	3	0	\N
114661	1726	668075568000	14133	7220	4	0	\N
114662	1726	668074565000	14133	7220	5	0	\N
114663	1726	668073564000	14133	7220	6	0	\N
114664	1726	668072562000	14133	7220	8	0	\N
114665	1726	668071559000	14133	7220	9	0	\N
114666	1726	668070558000	14133	7220	10	0	\N
114667	1726	668069556000	14133	7220	11	0	\N
114679	1397	1360362170000	14135	7220	0	0	\N
114680	1397	1360352169000	14135	7220	1	0	\N
114681	1397	1360342168000	14135	7220	2	0	\N
114682	1726	668076570000	14135	7220	3	0	\N
114683	1726	668075568000	14135	7220	4	0	\N
114684	1726	668074565000	14135	7220	5	0	\N
114685	1726	668073564000	14135	7220	6	0	\N
114686	1726	668072562000	14135	7220	8	0	\N
114687	1726	668071559000	14135	7220	9	0	\N
114688	1726	668070558000	14135	7220	10	0	\N
114689	1726	668069556000	14135	7220	11	0	\N
114690	1397	1360332167000	14136	7221	0	0	\N
114691	1726	668068553000	14136	7221	1	0	\N
114692	1726	668067552000	14136	7221	2	0	\N
114693	1397	1360362170000	14137	7215	0	0	\N
114694	1397	1360352169000	14137	7215	1	0	\N
114695	1397	1360342168000	14137	7215	2	0	\N
114696	1397	1360332167000	14137	7215	3	0	\N
114697	1726	668077573000	14137	7215	4	0	\N
114698	1726	668076570000	14137	7215	5	0	\N
114699	1726	668075568000	14137	7215	6	0	\N
114700	1726	668074565000	14137	7215	7	0	\N
114701	1726	668073564000	14137	7215	8	0	\N
114702	1726	668072562000	14137	7215	9	0	\N
114703	1726	668071559000	14137	7215	10	0	\N
114704	1726	668070558000	14137	7215	11	0	\N
114705	1726	668069556000	14137	7215	12	0	\N
114706	1726	668068553000	14137	7215	13	0	\N
114707	1726	668067552000	14137	7215	14	0	\N
114717	1775	861300000	14140	7110	0	0	\N
114718	1775	849210000	14140	7110	1	0	\N
114719	2058	549500000	14140	7110	2	0	\N
114720	1397	1361882322000	14140	7110	3	0	\N
114721	114	66672743000000	14140	7110	4	0	\N
114722	114	66002733000000	14140	7110	5	0	\N
114723	1397	1361872321000	14140	7110	6	0	\N
114724	1397	1361862320000	14140	7110	7	0	\N
114725	1397	1361852319000	14140	7110	8	0	\N
114726	1397	1361842318000	14140	7110	9	0	\N
114727	1397	1361832317000	14140	7110	10	0	\N
114728	1397	1361822316000	14140	7110	11	0	\N
114729	1397	1361812315000	14140	7110	12	0	\N
114730	1397	1361802314000	14140	7110	13	0	\N
114731	1397	1361792313000	14140	7110	14	0	\N
114732	1397	1361782312000	14140	7110	15	0	\N
114733	1397	1361772311000	14140	7110	16	0	\N
114734	1397	1361762310000	14140	7110	17	0	\N
114735	1397	1361752309000	14140	7110	18	0	\N
114736	1397	1361742308000	14140	7110	19	0	\N
114737	1397	1361732307000	14140	7110	20	0	\N
114738	1397	1361722306000	14140	7110	21	0	\N
114739	1397	1361712305000	14140	7110	22	0	\N
114740	1397	1361702304000	14140	7110	23	0	\N
114741	1397	1361692303000	14140	7110	24	0	\N
114742	1397	1361682302000	14140	7110	25	0	\N
114743	1397	1361672301000	14140	7110	26	0	\N
114744	1397	1361662300000	14140	7110	27	0	\N
114745	1397	1361652299000	14140	7110	28	0	\N
114746	1397	1361642298000	14140	7110	29	0	\N
114747	1397	1361632297000	14140	7110	30	0	\N
114748	1397	1361622296000	14140	7110	31	0	\N
114749	1397	1361612295000	14140	7110	32	0	\N
114750	1397	1361602294000	14140	7110	33	0	\N
114751	1397	1361592293000	14140	7110	34	0	\N
114752	1397	1361582292000	14140	7110	35	0	\N
114753	1397	1361572291000	14140	7110	36	0	\N
114754	1397	1361562290000	14140	7110	37	0	\N
114755	1397	1361552289000	14140	7110	38	0	\N
114756	1397	1361542288000	14140	7110	39	0	\N
114757	1397	1361532287000	14140	7110	40	0	\N
114758	1397	1361522286000	14140	7110	41	0	\N
114759	1397	1361512285000	14140	7110	42	0	\N
114760	1397	1361502284000	14140	7110	43	0	\N
114761	1397	1361492283000	14140	7110	44	0	\N
114762	1397	1361482282000	14140	7110	45	0	\N
114763	1397	1361472281000	14140	7110	46	0	\N
114764	1397	1361462280000	14140	7110	47	0	\N
114765	1397	1361452279000	14140	7110	48	0	\N
114766	1397	1361442278000	14140	7110	49	0	\N
114767	1397	1361432277000	14140	7110	50	0	\N
114768	1397	1361422276000	14140	7110	51	0	\N
114769	1397	1361412275000	14140	7110	52	0	\N
114770	1397	1361402274000	14140	7110	53	0	\N
114771	1397	1361392273000	14140	7110	54	0	\N
114772	1397	1361382272000	14140	7110	55	0	\N
114773	1397	1361372271000	14140	7110	56	0	\N
114774	1397	1361362270000	14140	7110	57	0	\N
114775	1397	1361352269000	14140	7110	58	0	\N
114776	1397	1361342268000	14140	7110	59	0	\N
114777	1397	1361332267000	14140	7110	60	0	\N
114778	1397	1361322266000	14140	7110	61	0	\N
114779	1397	1361312265000	14140	7110	62	0	\N
114780	1397	1361302264000	14140	7110	63	0	\N
114781	1397	1361292263000	14140	7110	64	0	\N
114782	1397	1361282262000	14140	7110	65	0	\N
114783	1397	1361272261000	14140	7110	66	0	\N
114784	1397	1361262260000	14140	7110	67	0	\N
114670	1397	1360342168000	14134	7220	2	0	7849
114671	1726	668076570000	14134	7220	3	0	6544
114672	1726	668075568000	14134	7220	4	0	6545
114673	1726	668074565000	14134	7220	5	0	6546
114674	1726	668073564000	14134	7220	6	0	6547
114676	1726	668071559000	14134	7220	9	0	6549
114677	1726	668070558000	14134	7220	10	0	6550
114678	1726	668069556000	14134	7220	11	0	6551
114708	1397	1360332167000	14138	7221	0	0	7850
114709	1726	668068553000	14138	7221	1	0	6552
114711	1397	1360322166000	14139	7222	0	0	7851
114712	1397	1360312165000	14139	7222	1	0	7852
114713	1726	668066550000	14139	7222	2	0	6554
114714	1726	668065549000	14139	7222	3	0	6555
114716	1726	668063544000	14139	7222	5	0	6557
114785	1397	1361252259000	14140	7110	68	0	\N
114786	1397	1361242258000	14140	7110	69	0	\N
114787	1397	1361232257000	14140	7110	70	0	\N
114788	1397	1361222256000	14140	7110	71	0	\N
114789	1397	1361212255000	14140	7110	72	0	\N
114790	1397	1361202254000	14140	7110	73	0	\N
114791	1397	1361192253000	14140	7110	74	0	\N
114792	1397	1361182252000	14140	7110	75	0	\N
114793	1397	1361172251000	14140	7110	76	0	\N
114794	1397	1361162250000	14140	7110	77	0	\N
114795	1397	1361152249000	14140	7110	78	0	\N
114796	1397	1361142248000	14140	7110	79	0	\N
114797	1397	1361132247000	14140	7110	80	0	\N
114798	1397	1361122246000	14140	7110	81	0	\N
114799	1397	1361112245000	14140	7110	82	0	\N
114800	1397	1361102244000	14140	7110	84	0	\N
114801	1397	1361092243000	14140	7110	85	0	\N
114802	1397	1361082242000	14140	7110	86	0	\N
114803	1397	1361072241000	14140	7110	87	0	\N
114804	1397	1361062240000	14140	7110	88	0	\N
114805	1397	1361052239000	14140	7110	89	0	\N
114806	1397	1361042238000	14140	7110	90	0	\N
114807	1397	1361032237000	14140	7110	91	0	\N
114808	1397	1361022236000	14140	7110	92	0	\N
114809	1397	1361012235000	14140	7110	93	0	\N
114810	1397	1361002234000	14140	7110	94	0	\N
114811	1397	1360992233000	14140	7110	95	0	\N
114812	1397	1360982232000	14140	7110	96	0	\N
114813	1397	1360972231000	14140	7110	97	0	\N
114814	1397	1360962230000	14140	7110	98	0	\N
114815	1397	1360952229000	14140	7110	99	0	\N
114816	1397	1360942228000	14140	7110	100	0	\N
114817	1397	1360932227000	14140	7110	101	0	\N
114818	1397	1360922226000	14140	7110	102	0	\N
114819	1397	1360912225000	14140	7110	103	0	\N
114820	1397	1360902224000	14140	7110	104	0	\N
114821	1397	1360892223000	14140	7110	105	0	\N
114822	1397	1360882222000	14140	7110	106	0	\N
114823	1397	1360872221000	14140	7110	107	0	\N
114824	1397	1360862220000	14140	7110	108	0	\N
114825	1397	1360852219000	14140	7110	109	0	\N
114826	1397	1360842218000	14140	7110	110	0	\N
114827	1397	1360832217000	14140	7110	111	0	\N
114828	1397	1360822216000	14140	7110	112	0	\N
114829	1397	1360812215000	14140	7110	113	0	\N
114830	1397	1360802214000	14140	7110	114	0	\N
114831	1397	1360792213000	14140	7110	115	0	\N
114832	1397	1360782212000	14140	7110	116	0	\N
114833	1397	1360772211000	14140	7110	117	0	\N
114834	1397	1360762210000	14140	7110	118	0	\N
114835	1397	1360752209000	14140	7110	119	0	\N
114836	1397	1360742208000	14140	7110	120	0	\N
114837	1397	1360732207000	14140	7110	121	0	\N
114838	1397	1360722206000	14140	7110	122	0	\N
114839	1397	1360712205000	14140	7110	123	0	\N
114840	1397	1360702204000	14140	7110	124	0	\N
114841	1397	1360692203000	14140	7110	125	0	\N
114842	1397	1360322166000	14141	7222	0	0	\N
114843	1397	1360312165000	14141	7222	1	0	\N
114844	1726	668066550000	14141	7222	2	0	\N
114845	1726	668065549000	14141	7222	3	0	\N
114846	1726	668064547000	14141	7222	4	0	\N
114847	1726	668063544000	14141	7222	5	0	\N
114848	1397	1360322166000	14142	7222	0	0	\N
114849	1397	1360312165000	14142	7222	1	0	\N
114850	1726	668066550000	14142	7222	2	0	\N
114851	1726	668065549000	14142	7222	3	0	\N
114852	1726	668064547000	14142	7222	4	0	\N
114853	1726	668063544000	14142	7222	5	0	\N
114854	1397	1360322166000	14143	7222	0	0	\N
114855	1397	1360312165000	14143	7222	1	0	\N
114856	1726	668066550000	14143	7222	2	0	\N
114857	1726	668065549000	14143	7222	3	0	\N
114858	1726	668064547000	14143	7222	4	0	\N
114859	1726	668063544000	14143	7222	5	0	\N
114860	1397	1360322166000	14144	7222	0	0	\N
114861	1397	1360312165000	14144	7222	1	0	\N
114862	1726	668066550000	14144	7222	2	0	\N
114863	1726	668065549000	14144	7222	3	0	\N
114864	1726	668064547000	14144	7222	4	0	\N
114865	1726	668063544000	14144	7222	5	0	\N
114866	1397	1360332167000	14145	7221	0	0	\N
114867	1397	1360322166000	14145	7221	1	0	\N
114868	1397	1360312165000	14145	7221	2	0	\N
114869	1726	668068553000	14145	7221	3	0	\N
114870	1726	668067552000	14145	7221	4	0	\N
114871	1726	668066550000	14145	7221	5	0	\N
114872	1726	668065549000	14145	7221	6	0	\N
114873	1726	668064547000	14145	7221	7	0	\N
114874	1726	668063544000	14145	7221	8	0	\N
114875	1397	1360302164000	14146	7223	0	0	\N
114876	1726	668062542000	14146	7223	1	0	\N
114877	1726	668061539000	14146	7223	2	0	\N
114881	1726	668062542000	14148	7223	0	0	\N
114882	1397	1360302164000	14149	7223	0	0	\N
114883	1726	668062542000	14149	7223	1	0	\N
114884	1726	668061539000	14149	7223	2	0	\N
114885	1397	1360302164000	14150	7223	0	0	\N
114886	1726	668062542000	14150	7223	1	0	\N
114887	1726	668061539000	14150	7223	2	0	\N
114888	1397	1360292163000	14151	7224	0	0	\N
114889	1726	668060537000	14151	7224	1	0	\N
114890	1726	668059534000	14151	7224	2	0	\N
114903	1397	1360262160000	14157	7226	0	0	\N
114904	1726	668054522000	14157	7226	1	0	\N
114905	1726	668053519000	14157	7226	2	0	\N
114906	1397	1360252159000	14159	7227	0	0	\N
114907	1726	668052517000	14159	7227	1	0	\N
114908	1726	668051514000	14159	7227	2	0	\N
114912	1397	1360242158000	14161	7228	0	0	\N
114913	1726	668050512000	14161	7228	1	0	\N
114914	1726	668049509000	14161	7228	2	0	\N
114880	1726	668061539000	14147	7223	2	0	6559
114891	1397	1360292163000	14152	7224	0	0	7854
114892	1397	1360282162000	14153	7225	0	0	7855
114893	1397	1360272161000	14153	7225	1	0	7856
114894	1726	668060537000	14153	7225	2	0	6560
114896	1726	668058532000	14153	7225	4	0	6562
114897	1726	668057529000	14153	7225	5	0	6563
114898	1726	668056527000	14153	7225	6	0	6564
114899	1726	668055524000	14153	7225	7	0	6565
114900	1397	1360262160000	14154	7226	0	0	7857
114902	1726	668053519000	14154	7226	2	0	6567
114909	1397	1360252159000	14160	7227	0	0	7858
114910	1726	668052517000	14160	7227	1	0	6568
114911	1726	668051514000	14160	7227	2	0	6569
114916	1397	1360242158000	14163	7229	0	0	7859
114917	1397	1360232157000	14163	7229	1	0	7860
114918	1726	668049509000	14163	7229	2	0	6571
114919	1726	668048507000	14163	7229	3	0	6572
114920	1726	668047504000	14163	7229	4	0	6573
114923	1397	1360222156000	14164	7230	0	0	\N
114924	1726	668044497000	14164	7230	1	0	\N
114925	1726	668043494000	14164	7230	2	0	\N
114929	1397	1360222156000	14166	7230	0	0	\N
114930	1726	668044497000	14166	7230	1	0	\N
114931	1726	668043494000	14166	7230	2	0	\N
114956	1397	1360152149000	14172	7235	0	0	\N
114957	1726	668028460000	14172	7235	1	0	\N
114958	1726	668027459000	14172	7235	2	0	\N
114959	1726	668026456000	14172	7235	3	0	\N
114973	1397	1360132147000	14175	7237	0	0	\N
114974	1397	1360122146000	14175	7237	1	0	\N
114975	1397	1360132147000	14176	7237	0	0	\N
114976	1397	1360122146000	14176	7237	1	0	\N
114977	1726	666812448000	14176	7237	2	0	\N
114978	1726	666811447000	14176	7237	3	0	\N
114979	1726	666810444000	14176	7237	4	0	\N
114980	1726	666809442000	14176	7237	5	0	\N
114981	1726	666808441000	14176	7237	6	0	\N
114982	1726	666807438000	14176	7237	7	0	\N
114983	1397	1360112145000	14178	7238	0	0	\N
114984	1397	1360102144000	14178	7238	1	0	\N
114985	1397	1360112145000	14179	7238	0	0	\N
114986	1397	1360102144000	14179	7238	1	0	\N
114987	1726	666806436000	14179	7238	2	0	\N
114988	1726	666805435000	14179	7238	3	0	\N
114989	1726	666804433000	14179	7238	4	0	\N
114990	1726	666803432000	14179	7238	5	0	\N
114991	1397	1360112145000	14180	7238	0	0	\N
114992	1397	1360102144000	14180	7238	1	0	\N
114993	1726	666806436000	14180	7238	2	0	\N
114994	1726	666805435000	14180	7238	3	0	\N
114995	1726	666804433000	14180	7238	4	0	\N
114996	1726	666803432000	14180	7238	5	0	\N
114997	1397	1360112145000	14181	7238	0	0	\N
114998	1397	1360102144000	14181	7238	1	0	\N
114999	1397	1360112145000	14182	7238	0	0	\N
115000	1397	1360102144000	14182	7238	1	0	\N
115001	1726	666806436000	14182	7238	2	0	\N
115002	1726	666805435000	14182	7238	3	0	\N
115003	1726	666804433000	14182	7238	4	0	\N
115004	1726	666803432000	14182	7238	5	0	\N
115005	1397	1360112145000	14183	7238	0	0	\N
115006	1397	1360102144000	14183	7238	1	0	\N
115007	1726	666806436000	14183	7238	2	0	\N
115008	1726	666805435000	14183	7238	3	0	\N
115009	1726	666804433000	14183	7238	4	0	\N
115010	1726	666803432000	14183	7238	5	0	\N
115011	1397	1360112145000	14184	7238	0	0	\N
115012	1397	1360102144000	14184	7238	1	0	\N
115024	1397	1360092143000	14188	7239	0	0	\N
115025	1397	1360082142000	14188	7239	1	0	\N
115026	1726	666802429000	14188	7239	2	0	\N
115027	1726	666801427000	14188	7239	3	0	\N
115028	1726	666800426000	14188	7239	5	0	\N
115029	1726	666799424000	14188	7239	6	0	\N
115034	1397	1360062140000	14190	7242	0	0	\N
115035	1726	666796416000	14190	7242	1	0	\N
115036	1726	666795415000	14190	7242	2	0	\N
115037	1726	666794413000	14190	7242	3	0	\N
115038	1397	1360062140000	14191	7242	0	0	\N
115039	1726	666796416000	14191	7242	1	0	\N
115040	1726	666795415000	14191	7242	2	0	\N
115041	1726	666794413000	14191	7242	3	0	\N
115042	1397	1360062140000	14192	7242	0	0	\N
115043	1397	1360062140000	14193	7242	0	0	\N
115044	1726	666796416000	14193	7242	1	0	\N
115045	1726	666795415000	14193	7242	2	0	\N
115046	1726	666794413000	14193	7242	3	0	\N
115051	1397	1360062140000	14195	7242	0	0	\N
114926	1397	1360222156000	14165	7230	0	0	7861
114927	1726	668044497000	14165	7230	1	0	6576
114928	1726	668043494000	14165	7230	2	0	6577
114932	1397	1360212155000	14167	7231	0	0	7862
114933	1726	668042492000	14167	7231	1	0	6578
114935	1397	1360202154000	14168	7232	0	0	7863
114936	1397	1360192153000	14168	7232	1	0	7864
114937	1726	668040487000	14168	7232	2	0	6580
114938	1726	668039484000	14168	7232	3	0	6581
114939	1726	668038482000	14168	7232	4	0	6582
114941	1397	1360182152000	14169	7233	0	0	7865
114942	1397	1360172151000	14170	7234	0	0	7866
114943	1397	1360162150000	14170	7234	1	0	7867
114944	1726	668036477000	14170	7234	2	0	6584
114946	1726	668034472000	14170	7234	4	0	6586
114947	1726	668033471000	14170	7234	5	0	6587
114948	1726	668032468000	14170	7234	6	0	6588
114949	1726	668031466000	14170	7234	7	0	6589
114950	1726	668030465000	14170	7234	8	0	6590
114952	1397	1360152149000	14171	7235	0	0	7868
114953	1726	668028460000	14171	7235	1	0	6592
114954	1726	668027459000	14171	7235	2	0	6593
114955	1726	668026456000	14171	7235	3	0	6594
114960	1397	1360142148000	14173	7236	0	0	7869
114962	1726	666815454000	14173	7236	2	0	6596
114963	1726	666814453000	14173	7236	3	0	6597
114964	1726	666813450000	14173	7236	4	0	6598
114965	1397	1360132147000	14174	7237	0	0	7870
114967	1726	666812448000	14174	7237	2	0	6599
114968	1726	666811447000	14174	7237	3	0	6600
114969	1726	666810444000	14174	7237	4	0	6601
114970	1726	666809442000	14174	7237	5	0	6602
114971	1726	666808441000	14174	7237	6	0	6603
115013	1397	1360112145000	14185	7238	0	0	7872
115014	1397	1360102144000	14185	7238	1	0	7873
115015	1397	1360092143000	14186	7239	0	0	7874
115016	1726	666806436000	14186	7239	1	0	6605
115017	1726	666805435000	14186	7239	2	0	6606
115019	1726	666803432000	14186	7239	4	0	6608
115020	1726	666802429000	14186	7239	5	0	6609
115021	1726	666801427000	14186	7239	6	0	6610
115022	1726	666800426000	14186	7239	7	0	6611
115030	1397	1360072141000	14189	7241	0	0	7876
115031	1726	666799424000	14189	7241	1	0	6612
115032	1726	666798421000	14189	7241	2	0	6613
115033	1726	666797419000	14189	7241	3	0	6614
115047	1397	1360062140000	14194	7242	0	0	7877
115049	1726	666795415000	14194	7242	2	0	6616
115050	1726	666794413000	14194	7242	3	0	6617
115052	1397	1360052139000	14196	7243	0	0	7878
115053	1397	1360042138000	14196	7243	1	0	7879
115054	1726	666793410000	14196	7243	2	0	6618
115056	1726	666791406000	14196	7243	4	0	6620
115058	1397	1360032137000	14197	7244	0	0	\N
115083	1397	1359972131000	14204	7249	0	0	\N
115084	1397	1359962130000	14204	7249	1	0	\N
115085	1726	666773373000	14204	7249	2	0	\N
115086	1726	666772371000	14204	7249	3	0	\N
115087	1726	666771368000	14204	7249	4	0	\N
115088	1726	666770367000	14204	7249	5	0	\N
115089	1726	666769365000	14204	7249	6	0	\N
115090	1726	666768362000	14204	7249	7	0	\N
115091	1397	1359972131000	14205	7249	0	0	\N
115092	1397	1359962130000	14205	7249	1	0	\N
115093	1726	666773373000	14205	7249	2	0	\N
115094	1726	666772371000	14205	7249	3	0	\N
115095	1726	666771368000	14205	7249	4	0	\N
115096	1726	666770367000	14205	7249	5	0	\N
115097	1726	666769365000	14205	7249	6	0	\N
115098	1726	666768362000	14205	7249	7	0	\N
115116	1397	1359922126000	14209	7253	0	0	\N
115117	1726	666759345000	14209	7253	1	0	\N
115118	1726	666758342000	14209	7253	2	0	\N
115119	1726	666757340000	14209	7253	3	0	\N
115132	1397	1360092143000	14213	7239	0	0	\N
115133	1397	1360082142000	14213	7239	1	0	\N
115134	1397	1360072141000	14213	7239	2	0	\N
115135	1397	1360062140000	14213	7239	3	0	\N
115136	1397	1360052139000	14213	7239	5	0	\N
115137	1397	1360042138000	14213	7239	6	0	\N
115138	1397	1360032137000	14213	7239	7	0	\N
115139	1397	1360022136000	14213	7239	8	0	\N
115140	1397	1360012135000	14213	7239	9	0	\N
115141	1397	1360002134000	14213	7239	10	0	\N
115142	1397	1359992133000	14213	7239	11	0	\N
115143	1397	1359982132000	14213	7239	12	0	\N
115144	1397	1359972131000	14213	7239	13	0	\N
115145	1397	1359962130000	14213	7239	14	0	\N
115150	1397	1359892123000	14215	7256	0	0	\N
115151	1726	666750327000	14215	7256	1	0	\N
115152	1726	666749325000	14215	7256	2	0	\N
115153	1726	666748322000	14215	7256	3	0	\N
115158	1397	1359882122000	14217	7257	0	0	\N
115159	1726	666747321000	14217	7257	1	0	\N
115160	1726	666746319000	14217	7257	2	0	\N
115161	1726	666745316000	14217	7257	3	0	\N
115177	1397	1359842118000	14221	7259	0	0	\N
115178	1726	666736298000	14221	7259	2	0	\N
115179	1726	666735297000	14221	7259	3	0	\N
115180	1726	666734295000	14221	7259	4	0	\N
115060	1726	666789401000	14198	7244	1	0	6622
115061	1726	666788399000	14198	7244	2	0	6623
115062	1726	666787398000	14198	7244	3	0	6624
115063	1397	1360022136000	14199	7245	0	0	7881
115064	1726	666786397000	14199	7245	1	0	6625
115066	1397	1360012135000	14200	7246	0	0	7882
115067	1397	1360002134000	14200	7246	1	0	7883
115068	1726	666784394000	14200	7246	2	0	6627
115069	1726	666783391000	14200	7246	3	0	6628
115070	1726	666782389000	14200	7246	4	0	6629
115072	1726	666780385000	14200	7246	6	0	6631
115073	1726	666779383000	14200	7246	7	0	6632
115074	1397	1359992133000	14201	7247	0	0	7884
115075	1397	1359982132000	14202	7248	0	0	7885
115077	1726	666777380000	14202	7248	2	0	6634
115078	1726	666776379000	14202	7248	3	0	6635
115079	1726	666775377000	14202	7248	4	0	6636
115080	1726	666774374000	14202	7248	5	0	6637
115081	1397	1359972131000	14203	7249	0	0	7886
115099	1397	1359952129000	14206	7250	0	0	7888
115100	1726	666773373000	14206	7250	1	0	6638
115101	1726	666772371000	14206	7250	2	0	6639
115102	1726	666771368000	14206	7250	3	0	6640
115103	1726	666770367000	14206	7250	4	0	6641
115105	1726	666768362000	14206	7250	6	0	6643
115106	1726	666767361000	14206	7250	7	0	6644
115107	1726	666766358000	14206	7250	8	0	6645
115108	1397	1359942128000	14207	7251	0	0	7889
115110	1726	666764354000	14207	7251	2	0	6647
115111	1726	666763352000	14207	7251	3	0	6648
115112	1397	1359932127000	14208	7252	0	0	7890
115113	1726	666762351000	14208	7252	1	0	6649
115114	1726	666761348000	14208	7252	2	0	6650
115120	1397	1359922126000	14210	7253	0	0	7891
115121	1726	666759345000	14210	7253	1	0	6652
115122	1726	666758342000	14210	7253	2	0	6653
115123	1726	666757340000	14210	7253	3	0	6654
115124	1397	1359912125000	14211	7254	0	0	7892
115126	1726	666755336000	14211	7254	2	0	6656
115127	1726	666754334000	14211	7254	3	0	6657
115128	1397	1359902124000	14212	7255	0	0	7893
115129	1726	666753333000	14212	7255	1	0	6658
115131	1726	666751328000	14212	7255	3	0	6660
115146	1397	1359892123000	14214	7256	0	0	7894
115147	1726	666750327000	14214	7256	1	0	6661
115148	1726	666749325000	14214	7256	2	0	6662
115149	1726	666748322000	14214	7256	3	0	6663
115155	1726	666747321000	14216	7257	1	0	6664
115156	1726	666746319000	14216	7257	2	0	6665
115157	1726	666745316000	14216	7257	3	0	6666
115162	1397	1359872121000	14218	7258	0	0	7896
115163	1397	1359862120000	14218	7258	1	0	7897
115165	1726	666744315000	14218	7258	3	0	6667
115166	1726	666743313000	14218	7258	4	0	6668
115167	1726	666742310000	14218	7258	5	0	6669
115168	1726	666741309000	14218	7258	6	0	6670
115170	1726	666739304000	14218	7258	8	0	6672
115171	1726	666738303000	14218	7258	9	0	6673
115172	1726	666737301000	14218	7258	10	0	6674
115173	1397	1359842118000	14219	7259	0	0	7899
115174	1726	666736298000	14219	7259	2	0	6675
115176	1726	666734295000	14219	7259	4	0	6677
115181	1726	666733292000	14222	7260	0	0	6678
115182	1726	666732291000	14222	7260	1	0	6679
115183	1397	1359832117000	14223	7261	0	0	7900
115184	1397	1359822116000	14223	7261	1	0	7901
115186	1726	666730288000	14223	7261	3	0	6681
115187	1726	666729286000	14223	7261	4	0	6682
115188	1726	666728283000	14223	7261	5	0	6683
115189	1397	1359812115000	14224	7262	0	0	7902
115191	1726	666726280000	14224	7262	2	0	6685
115192	1726	666725277000	14224	7262	3	0	6686
115193	1397	1359832117000	14225	7261	0	0	\N
115194	1397	1359822116000	14225	7261	1	0	\N
115195	1397	1359812115000	14225	7261	2	0	\N
115196	1726	666731289000	14225	7261	3	0	\N
115197	1726	666730288000	14225	7261	4	0	\N
115198	1726	666729286000	14225	7261	5	0	\N
115199	1726	666728283000	14225	7261	6	0	\N
115200	1726	666727282000	14225	7261	7	0	\N
115201	1726	666726280000	14225	7261	8	0	\N
115202	1726	666725277000	14225	7261	9	0	\N
115215	1397	1359782112000	14229	7265	0	0	\N
115216	1726	666718264000	14229	7265	1	0	\N
115217	1726	666717262000	14229	7265	2	0	\N
115218	1726	666716259000	14229	7265	3	0	\N
115219	1397	1359782112000	14230	7265	0	0	\N
115220	1726	666718264000	14230	7265	1	0	\N
115221	1726	666717262000	14230	7265	2	0	\N
115222	1726	666716259000	14230	7265	3	0	\N
115223	1397	1359772111000	14231	7266	0	0	\N
115224	1726	666715258000	14231	7266	1	0	\N
115225	1726	666714256000	14231	7266	2	0	\N
115226	1726	666713253000	14231	7266	3	0	\N
115231	1397	1359762110000	14233	7267	0	0	\N
115232	1726	666712252000	14233	7267	1	0	\N
115233	1726	666711250000	14233	7267	2	0	\N
115234	1726	666710247000	14233	7267	3	0	\N
115235	1397	1359762110000	14234	7267	0	0	\N
115236	1726	666712252000	14234	7267	1	0	\N
115237	1726	666711250000	14234	7267	2	0	\N
115238	1726	666710247000	14234	7267	3	0	\N
115239	1397	1359762110000	14235	7267	0	0	\N
115240	1726	666712252000	14235	7267	1	0	\N
115241	1726	666711250000	14235	7267	2	0	\N
115242	1726	666710247000	14235	7267	3	0	\N
115247	1397	1359752109000	14237	7268	0	0	\N
115248	1726	666709246000	14237	7268	1	0	\N
115249	1726	666708244000	14237	7268	2	0	\N
115250	1726	666707241000	14237	7268	3	0	\N
115251	1726	666706240000	14237	7268	4	0	\N
115252	1726	666705238000	14237	7268	5	0	\N
115253	1726	666704235000	14237	7268	6	0	\N
115254	1397	1359752109000	14238	7268	0	0	\N
115255	1397	1359752109000	14239	7268	0	0	\N
115256	1726	666709246000	14239	7268	1	0	\N
115257	1726	666708244000	14239	7268	2	0	\N
115258	1726	666707241000	14239	7268	3	0	\N
115259	1726	666706240000	14239	7268	4	0	\N
115260	1726	666705238000	14239	7268	5	0	\N
115261	1726	666704235000	14239	7268	6	0	\N
115281	1726	666697222000	14243	7270	0	0	\N
115282	1726	666696220000	14243	7270	1	0	\N
115290	1397	1359702104000	14246	7272	0	0	\N
115291	1726	666691210000	14246	7272	1	0	\N
115292	1726	666690208000	14246	7272	2	0	\N
115312	1397	1359642098000	14251	7277	0	0	\N
115313	1397	1359632097000	14251	7277	1	0	\N
115314	1726	666675178000	14251	7277	2	0	\N
115315	1726	666674177000	14251	7277	3	0	\N
115316	1726	666673175000	14251	7277	4	0	\N
115317	1726	666672172000	14251	7277	5	0	\N
115318	1726	666671171000	14251	7277	6	0	\N
115319	1726	666670169000	14251	7277	7	0	\N
115320	1397	1359642098000	14252	7277	0	0	\N
115321	1397	1359632097000	14252	7277	1	0	\N
115322	1726	666675178000	14252	7277	2	0	\N
115323	1726	666674177000	14252	7277	3	0	\N
115324	1726	666673175000	14252	7277	4	0	\N
115325	1726	666672172000	14252	7277	5	0	\N
115326	1726	666671171000	14252	7277	6	0	\N
115327	1726	666670169000	14252	7277	7	0	\N
115328	1397	1359642098000	14253	7277	0	0	\N
115205	1726	666723274000	14226	7263	2	0	6688
115206	1726	666722271000	14226	7263	3	0	6689
115207	1397	1359792113000	14227	7264	0	0	7904
115208	1726	666721270000	14227	7264	1	0	6690
115209	1726	666720268000	14227	7264	2	0	6691
115211	1397	1359782112000	14228	7265	0	0	7905
115212	1726	666718264000	14228	7265	1	0	6693
115213	1726	666717262000	14228	7265	2	0	6694
115214	1726	666716259000	14228	7265	3	0	6695
115227	1397	1359772111000	14232	7266	0	0	7906
115229	1726	666714256000	14232	7266	2	0	6697
115230	1726	666713253000	14232	7266	3	0	6698
115243	1397	1359762110000	14236	7267	0	0	7907
115244	1726	666712252000	14236	7267	1	0	6699
115246	1726	666710247000	14236	7267	3	0	6701
115262	1726	666709246000	14240	7268	0	0	6702
115263	1726	666708244000	14240	7268	1	0	6703
115264	1726	666707241000	14240	7268	2	0	6704
115265	1726	666706240000	14240	7268	3	0	6705
115267	1726	666704235000	14240	7268	5	0	6707
115268	1397	1359752109000	14241	7269	0	0	7908
115269	1397	1359742108000	14241	7269	1	0	7909
115270	1397	1359732107000	14241	7269	2	0	7910
115271	1726	666703234000	14241	7269	3	0	6708
115273	1726	666701229000	14241	7269	5	0	6710
115274	1726	666700228000	14241	7269	6	0	6711
115275	1726	666699226000	14241	7269	7	0	6712
115276	1726	666698223000	14241	7269	8	0	6713
115278	1726	666697222000	14242	7270	1	0	6714
115279	1726	666696220000	14242	7270	2	0	6715
115280	1726	666695217000	14242	7270	3	0	6716
115283	1397	1359712105000	14244	7271	0	0	7912
115284	1726	666694216000	14244	7271	1	0	6717
115286	1726	666692211000	14244	7271	3	0	6719
115287	1397	1359702104000	14245	7272	0	0	7913
115288	1726	666691210000	14245	7272	1	0	6720
115289	1726	666690208000	14245	7272	2	0	6721
115293	1397	1359692103000	14247	7273	0	0	7914
115295	1726	666689207000	14247	7273	2	0	6722
115296	1726	666688205000	14247	7273	3	0	6723
115297	1726	666687202000	14247	7273	4	0	6724
115298	1726	666686201000	14247	7273	5	0	6725
115300	1726	666684196000	14247	7273	7	0	6727
115301	1397	1359672101000	14248	7274	0	0	7916
115302	1726	666683195000	14248	7274	1	0	6728
115303	1726	666682193000	14248	7274	2	0	6729
115304	1726	666681190000	14248	7274	3	0	6730
115306	1726	666680189000	14249	7275	1	0	6731
115307	1726	666679187000	14249	7275	2	0	6732
115308	1726	666678184000	14249	7275	3	0	6733
115309	1397	1359652099000	14250	7276	0	0	7918
115310	1726	666677183000	14250	7276	1	0	6734
115329	1397	1359632097000	14253	7277	1	0	\N
115330	1726	666675178000	14253	7277	2	0	\N
115331	1726	666674177000	14253	7277	3	0	\N
115332	1726	666673175000	14253	7277	4	0	\N
115333	1726	666672172000	14253	7277	5	0	\N
115334	1726	666671171000	14253	7277	6	0	\N
115335	1726	666670169000	14253	7277	7	0	\N
115336	1397	1359642098000	14254	7277	0	0	\N
115337	1397	1359632097000	14254	7277	1	0	\N
115338	1726	666675178000	14254	7277	2	0	\N
115339	1726	666674177000	14254	7277	3	0	\N
115340	1726	666673175000	14254	7277	4	0	\N
115341	1726	666672172000	14254	7277	5	0	\N
115342	1726	666671171000	14254	7277	6	0	\N
115343	1726	666670169000	14254	7277	7	0	\N
115364	1397	1359602094000	14259	7280	0	0	\N
115365	1726	666663155000	14259	7280	1	0	\N
115366	1726	666662154000	14259	7280	2	0	\N
115367	1726	666661151000	14259	7280	3	0	\N
115372	1397	1359592093000	14261	7281	0	0	\N
115373	1726	666660149000	14261	7281	1	0	\N
115374	1726	666659148000	14261	7281	2	0	\N
115375	1726	666658145000	14261	7281	3	0	\N
115380	1726	668129678000	14263	7205	0	0	\N
115381	1397	1360542188000	14263	7205	1	0	\N
115382	1397	1360532187000	14263	7205	2	0	\N
115383	1397	1360522186000	14263	7205	3	0	\N
115384	1397	1360512185000	14263	7205	4	0	\N
115385	1397	1360502184000	14263	7205	5	0	\N
115386	1397	1360492183000	14263	7205	6	0	\N
115387	1397	1360482182000	14263	7205	7	0	\N
115388	1397	1360472181000	14263	7205	8	0	\N
115389	1397	1360462180000	14263	7205	9	0	\N
115390	1397	1360452179000	14263	7205	10	0	\N
115391	1397	1360442178000	14263	7205	11	0	\N
115392	1397	1360432177000	14263	7205	12	0	\N
115393	1397	1360422176000	14263	7205	13	0	\N
115394	1397	1360412175000	14263	7205	14	0	\N
115395	1397	1360402174000	14263	7205	15	0	\N
115396	1397	1360392173000	14263	7205	16	0	\N
115397	1397	1360382172000	14263	7205	17	0	\N
115398	1397	1360372171000	14263	7205	18	0	\N
115399	1397	1360362170000	14263	7205	19	0	\N
115400	1397	1360352169000	14263	7205	20	0	\N
115401	1397	1360342168000	14263	7205	21	0	\N
115402	1397	1360332167000	14263	7205	22	0	\N
115403	1397	1360322166000	14263	7205	23	0	\N
115404	1397	1360312165000	14263	7205	24	0	\N
115405	1397	1360302164000	14263	7205	25	0	\N
115406	1397	1360292163000	14263	7205	26	0	\N
115407	1397	1360282162000	14263	7205	27	0	\N
115408	1397	1360272161000	14263	7205	28	0	\N
115409	1397	1360262160000	14263	7205	29	0	\N
115410	1397	1360252159000	14263	7205	30	0	\N
115411	1397	1360242158000	14263	7205	31	0	\N
115412	1397	1360232157000	14263	7205	32	0	\N
115413	1397	1360222156000	14263	7205	33	0	\N
115414	1397	1360212155000	14263	7205	34	0	\N
115415	1397	1360202154000	14263	7205	35	0	\N
115416	1397	1360192153000	14263	7205	36	0	\N
115417	1397	1360182152000	14263	7205	37	0	\N
115418	1397	1360172151000	14263	7205	38	0	\N
115419	1397	1360162150000	14263	7205	39	0	\N
115420	1397	1360152149000	14263	7205	40	0	\N
115421	1397	1360142148000	14263	7205	41	0	\N
115422	1397	1360132147000	14263	7205	42	0	\N
115423	1397	1360122146000	14263	7205	43	0	\N
115424	1397	1360112145000	14263	7205	44	0	\N
115425	1397	1360102144000	14263	7205	45	0	\N
115426	1397	1360092143000	14263	7205	46	0	\N
115427	1397	1360082142000	14263	7205	47	0	\N
115428	1397	1360072141000	14263	7205	48	0	\N
115429	1397	1360062140000	14263	7205	49	0	\N
115430	1397	1360052139000	14263	7205	50	0	\N
115431	1397	1360042138000	14263	7205	51	0	\N
115432	1397	1360032137000	14263	7205	52	0	\N
115433	1397	1360022136000	14263	7205	53	0	\N
115434	1397	1360012135000	14263	7205	54	0	\N
115435	1397	1360002134000	14263	7205	55	0	\N
115436	1397	1359992133000	14263	7205	56	0	\N
115437	1397	1359982132000	14263	7205	57	0	\N
115438	1397	1359972131000	14263	7205	58	0	\N
115439	1397	1359962130000	14263	7205	59	0	\N
115440	1397	1359952129000	14263	7205	60	0	\N
115441	1397	1359942128000	14263	7205	61	0	\N
115442	1397	1359932127000	14263	7205	62	0	\N
115443	1397	1359922126000	14263	7205	63	0	\N
115444	1397	1359912125000	14263	7205	64	0	\N
115445	1397	1359902124000	14263	7205	65	0	\N
115446	1397	1359892123000	14263	7205	66	0	\N
115447	1397	1359882122000	14263	7205	67	0	\N
115448	1397	1359872121000	14263	7205	68	0	\N
115449	1397	1359862120000	14263	7205	69	0	\N
115450	1397	1359852119000	14263	7205	70	0	\N
115451	1397	1359842118000	14263	7205	71	0	\N
115452	1397	1359832117000	14263	7205	72	0	\N
115453	1397	1359822116000	14263	7205	73	0	\N
115454	1397	1359812115000	14263	7205	74	0	\N
115455	1397	1359802114000	14263	7205	75	0	\N
115456	1397	1359792113000	14263	7205	76	0	\N
115457	1397	1359782112000	14263	7205	77	0	\N
115458	1397	1359772111000	14263	7205	78	0	\N
115459	1397	1359762110000	14263	7205	79	0	\N
115460	1397	1359752109000	14263	7205	80	0	\N
115461	1397	1359742108000	14263	7205	81	0	\N
115462	1397	1359732107000	14263	7205	82	0	\N
115463	1397	1359722106000	14263	7205	83	0	\N
115464	1397	1359712105000	14263	7205	84	0	\N
115346	1397	1359622096000	14256	7278	0	0	7921
115347	1726	666675178000	14256	7278	1	0	6736
115348	1726	666674177000	14256	7278	2	0	6737
115349	1726	666673175000	14256	7278	3	0	6738
115350	1726	666672172000	14256	7278	4	0	6739
115352	1726	666670169000	14256	7278	6	0	6741
115353	1726	666669166000	14256	7278	8	0	6742
115354	1726	666668165000	14256	7278	9	0	6743
115355	1726	666667163000	14256	7278	10	0	6744
115356	1397	1359612095000	14257	7279	0	0	7922
115358	1726	666665160000	14257	7279	2	0	6746
115359	1726	666664157000	14257	7279	3	0	6747
115360	1397	1359602094000	14258	7280	0	0	7923
115361	1726	666663155000	14258	7280	1	0	6748
115363	1726	666661151000	14258	7280	3	0	6750
115368	1397	1359592093000	14260	7281	0	0	7924
115369	1726	666660149000	14260	7281	1	0	6751
115370	1726	666659148000	14260	7281	2	0	6752
115371	1726	666658145000	14260	7281	3	0	6753
115377	1726	666657143000	14262	7282	1	0	6754
115378	1726	666656142000	14262	7282	2	0	6755
115379	1726	666655139000	14262	7282	3	0	6756
115465	1397	1359702104000	14263	7205	85	0	\N
115466	1397	1359692103000	14263	7205	86	0	\N
115467	1397	1359682102000	14263	7205	87	0	\N
115468	1397	1359672101000	14263	7205	88	0	\N
115469	1397	1359662100000	14263	7205	89	0	\N
115470	1397	1359652099000	14263	7205	90	0	\N
115471	1397	1359642098000	14263	7205	91	0	\N
115472	1397	1359632097000	14263	7205	92	0	\N
115473	1397	1359622096000	14263	7205	93	0	\N
115474	1397	1359612095000	14263	7205	94	0	\N
115475	1397	1359602094000	14263	7205	95	0	\N
115476	1397	1359592093000	14263	7205	96	0	\N
115477	1926	1195000000	14263	7205	97	0	\N
115478	1726	668128675000	14263	7205	98	0	\N
115479	1726	668127674000	14263	7205	99	0	\N
115480	1726	668126672000	14263	7205	100	0	\N
115481	1726	668125669000	14263	7205	101	0	\N
115482	1726	668124668000	14263	7205	102	0	\N
115483	1726	668123666000	14263	7205	103	0	\N
115484	1726	668122663000	14263	7205	104	0	\N
115485	1726	668121662000	14263	7205	105	0	\N
115486	1726	668120660000	14263	7205	106	0	\N
115487	1726	668119657000	14263	7205	107	0	\N
115488	1726	668118655000	14263	7205	108	0	\N
115489	1726	668117652000	14263	7205	110	0	\N
115490	1726	668116650000	14263	7205	111	0	\N
115491	1726	668115649000	14263	7205	112	0	\N
115492	1726	668114646000	14263	7205	113	0	\N
115493	1726	668113644000	14263	7205	114	0	\N
115494	1726	668112643000	14263	7205	115	0	\N
115495	1726	668111640000	14263	7205	116	0	\N
115496	1726	668110638000	14263	7205	117	0	\N
115497	1726	668109637000	14263	7205	118	0	\N
115498	1726	668108634000	14263	7205	119	0	\N
115499	1726	668107632000	14263	7205	120	0	\N
115500	1726	668106631000	14263	7205	121	0	\N
115501	1726	668105628000	14263	7205	122	0	\N
115502	1726	668104626000	14263	7205	123	0	\N
115503	1726	668103625000	14263	7205	124	0	\N
115504	1726	668102622000	14263	7205	125	0	\N
115509	1397	1359572091000	14265	7283	0	0	\N
115510	1726	666654137000	14265	7283	1	0	\N
115511	1726	666653136000	14265	7283	2	0	\N
115512	1726	666652133000	14265	7283	3	0	\N
115525	1397	1359562090000	14267	7284	0	0	\N
115526	1397	1359552089000	14267	7284	1	0	\N
115527	1397	1359542088000	14267	7284	2	0	\N
115528	1726	666651131000	14267	7284	3	0	\N
115529	1726	666650130000	14267	7284	4	0	\N
115530	1726	666649127000	14267	7284	5	0	\N
115531	1726	666648125000	14267	7284	6	0	\N
115532	1726	666647124000	14267	7284	7	0	\N
115533	1726	666646121000	14267	7284	8	0	\N
115534	1726	666645119000	14267	7284	9	0	\N
115535	1726	666644118000	14267	7284	10	0	\N
115536	1726	666643115000	14267	7284	11	0	\N
115537	1397	1359562090000	14268	7284	0	0	\N
115538	1397	1359552089000	14268	7284	1	0	\N
115539	1397	1359542088000	14268	7284	2	0	\N
115540	1726	666651131000	14268	7284	3	0	\N
115541	1726	666650130000	14268	7284	4	0	\N
115542	1726	666649127000	14268	7284	5	0	\N
115543	1726	666648125000	14268	7284	6	0	\N
115544	1726	666647124000	14268	7284	7	0	\N
115545	1726	666646121000	14268	7284	8	0	\N
115546	1726	666645119000	14268	7284	9	0	\N
115547	1726	666644118000	14268	7284	10	0	\N
115548	1726	666643115000	14268	7284	11	0	\N
115549	1397	1359532087000	14269	7285	0	0	\N
115550	1397	1359532087000	14270	7285	0	0	\N
115551	1726	666642113000	14270	7285	1	0	\N
115552	1726	666641112000	14270	7285	2	0	\N
115553	1726	666640109000	14270	7285	3	0	\N
115566	1397	1359522086000	14273	7286	0	0	\N
115567	1397	1359512085000	14273	7286	1	0	\N
115568	1726	666639107000	14273	7286	2	0	\N
115569	1726	666638106000	14273	7286	3	0	\N
115570	1726	666637103000	14273	7286	4	0	\N
115571	1726	666636101000	14273	7286	5	0	\N
115572	1726	666635100000	14273	7286	6	0	\N
115573	1726	666634097000	14273	7286	7	0	\N
115574	1397	1359522086000	14274	7286	0	0	\N
115575	1397	1359512085000	14274	7286	1	0	\N
115585	1467	25903206035399	14277	7288	0	0	\N
115586	1467	19417301554450	14277	7288	1	0	\N
115587	1467	15041129307591	14277	7288	2	0	\N
115588	1467	2846554100039	14277	7288	3	0	\N
115589	1397	1359492083000	14277	7288	4	0	\N
115590	1397	1359482082000	14277	7288	5	0	\N
115591	1726	666631091000	14277	7288	6	0	\N
115592	1726	666630089000	14277	7288	7	0	\N
115593	1726	666629088000	14277	7288	8	0	\N
115594	1726	666628085000	14277	7288	9	0	\N
115595	1726	666627083000	14277	7288	10	0	\N
115596	1726	666626082000	14277	7288	11	0	\N
115507	1726	666653136000	14264	7283	2	0	6758
115508	1726	666652133000	14264	7283	3	0	6759
115513	1397	1359562090000	14266	7284	0	0	7927
115514	1397	1359552089000	14266	7284	1	0	7928
115515	1397	1359542088000	14266	7284	2	0	7929
115517	1726	666650130000	14266	7284	4	0	6761
115518	1726	666649127000	14266	7284	5	0	6762
115519	1726	666648125000	14266	7284	6	0	6763
115520	1726	666647124000	14266	7284	7	0	6764
115521	1726	666646121000	14266	7284	8	0	6765
115523	1726	666644118000	14266	7284	10	0	6767
115524	1726	666643115000	14266	7284	11	0	6768
115554	1397	1359532087000	14271	7285	0	0	7930
115555	1726	666642113000	14271	7285	1	0	6769
115557	1726	666640109000	14271	7285	3	0	6771
115558	1397	1359522086000	14272	7286	0	0	7931
115559	1397	1359512085000	14272	7286	1	0	7932
115560	1726	666639107000	14272	7286	2	0	6772
115561	1726	666638106000	14272	7286	3	0	6773
115563	1726	666636101000	14272	7286	5	0	6775
115564	1726	666635100000	14272	7286	6	0	6776
115565	1726	666634097000	14272	7286	7	0	6777
115576	1397	1359502084000	14275	7287	0	0	7933
115577	1726	666633095000	14275	7287	1	0	6778
115579	1467	25903206035399	14276	7288	0	0	1
115580	1467	19417301554450	14276	7288	1	0	2
115581	1467	15041129307591	14276	7288	2	0	3
115582	1467	2846554100039	14276	7288	3	0	4
115584	1397	1359482082000	14276	7288	5	0	7935
115597	1397	1359472081000	14278	7289	0	0	7936
115598	1726	666631091000	14278	7289	1	0	6780
115599	1726	666630089000	14278	7289	2	0	6781
115600	1726	666629088000	14278	7289	3	0	6782
115609	1397	1359462080000	14280	7290	0	0	\N
115610	1397	1359452079000	14280	7290	1	0	\N
115611	1726	666622073000	14280	7290	2	0	\N
115612	1726	666621071000	14280	7290	3	0	\N
115613	1726	666620070000	14280	7290	4	0	\N
115614	1726	666619067000	14280	7290	5	0	\N
115615	1726	666618065000	14280	7290	6	0	\N
115616	1726	666617064000	14280	7290	7	0	\N
115617	1397	1359462080000	14281	7290	0	0	\N
115618	1397	1359452079000	14281	7290	1	0	\N
115619	1726	666622073000	14281	7290	2	0	\N
115620	1726	666621071000	14281	7290	3	0	\N
115621	1726	666620070000	14281	7290	4	0	\N
115622	1726	666619067000	14281	7290	5	0	\N
115623	1726	666618065000	14281	7290	6	0	\N
115624	1726	666617064000	14281	7290	7	0	\N
115625	1467	25903206035399	14282	7207	0	0	\N
115626	1467	19417301554450	14282	7207	1	0	\N
115627	1467	15041129307591	14282	7207	2	0	\N
115628	1467	2846554100039	14282	7207	3	0	\N
115629	1397	1360512185000	14282	7207	4	0	\N
115630	1397	1360502184000	14282	7207	5	0	\N
115631	1397	1360492183000	14282	7207	6	0	\N
115632	1397	1360482182000	14282	7207	7	0	\N
115633	1397	1360472181000	14282	7207	8	0	\N
115634	1397	1360462180000	14282	7207	9	0	\N
115635	1397	1360452179000	14282	7207	10	0	\N
115636	1397	1360442178000	14282	7207	11	0	\N
115637	1397	1360432177000	14282	7207	12	0	\N
115638	1397	1360422176000	14282	7207	13	0	\N
115639	1397	1360412175000	14282	7207	14	0	\N
115640	1397	1360402174000	14282	7207	15	0	\N
115641	1397	1360392173000	14282	7207	16	0	\N
115642	1397	1360382172000	14282	7207	17	0	\N
115643	1397	1360372171000	14282	7207	18	0	\N
115644	1397	1360362170000	14282	7207	19	0	\N
115645	1397	1360352169000	14282	7207	20	0	\N
115646	1397	1360342168000	14282	7207	21	0	\N
115647	1397	1360332167000	14282	7207	22	0	\N
115648	1397	1360322166000	14282	7207	23	0	\N
115649	1397	1360312165000	14282	7207	24	0	\N
115650	1397	1360302164000	14282	7207	25	0	\N
115651	1397	1360292163000	14282	7207	26	0	\N
115652	1397	1360282162000	14282	7207	27	0	\N
115653	1397	1360272161000	14282	7207	28	0	\N
115654	1397	1360262160000	14282	7207	29	0	\N
115655	1397	1360252159000	14282	7207	30	0	\N
115656	1397	1360242158000	14282	7207	31	0	\N
115657	1397	1360232157000	14282	7207	32	0	\N
115658	1397	1360222156000	14282	7207	33	0	\N
115659	1397	1360212155000	14282	7207	34	0	\N
115660	1397	1360202154000	14282	7207	35	0	\N
115661	1397	1360192153000	14282	7207	36	0	\N
115662	1397	1360182152000	14282	7207	37	0	\N
115663	1397	1360172151000	14282	7207	38	0	\N
115664	1397	1360162150000	14282	7207	39	0	\N
115665	1397	1360152149000	14282	7207	40	0	\N
115666	1397	1360142148000	14282	7207	41	0	\N
115667	1397	1360132147000	14282	7207	42	0	\N
115668	1397	1360122146000	14282	7207	43	0	\N
115669	1397	1360112145000	14282	7207	44	0	\N
115670	1397	1360102144000	14282	7207	45	0	\N
115671	1397	1360092143000	14282	7207	46	0	\N
115672	1397	1360082142000	14282	7207	47	0	\N
115673	1397	1360072141000	14282	7207	48	0	\N
115674	1397	1360062140000	14282	7207	49	0	\N
115675	1397	1360052139000	14282	7207	50	0	\N
115676	1397	1360042138000	14282	7207	51	0	\N
115677	1397	1360032137000	14282	7207	52	0	\N
115678	1397	1360022136000	14282	7207	53	0	\N
115679	1397	1360012135000	14282	7207	54	0	\N
115680	1397	1360002134000	14282	7207	55	0	\N
115681	1397	1359992133000	14282	7207	56	0	\N
115682	1397	1359982132000	14282	7207	57	0	\N
115683	1397	1359972131000	14282	7207	58	0	\N
115684	1397	1359962130000	14282	7207	59	0	\N
115685	1397	1359952129000	14282	7207	60	0	\N
115686	1397	1359942128000	14282	7207	61	0	\N
115687	1397	1359932127000	14282	7207	62	0	\N
115688	1397	1359922126000	14282	7207	63	0	\N
115689	1397	1359912125000	14282	7207	64	0	\N
115690	1397	1359902124000	14282	7207	65	0	\N
115691	1397	1359892123000	14282	7207	66	0	\N
115692	1397	1359882122000	14282	7207	67	0	\N
115693	1397	1359872121000	14282	7207	68	0	\N
115694	1397	1359862120000	14282	7207	69	0	\N
115695	1397	1359852119000	14282	7207	70	0	\N
115696	1397	1359842118000	14282	7207	71	0	\N
115697	1397	1359832117000	14282	7207	72	0	\N
115698	1397	1359822116000	14282	7207	73	0	\N
115699	1397	1359812115000	14282	7207	74	0	\N
115700	1397	1359802114000	14282	7207	75	0	\N
115701	1397	1359792113000	14282	7207	76	0	\N
115702	1397	1359782112000	14282	7207	77	0	\N
115703	1397	1359772111000	14282	7207	78	0	\N
115704	1397	1359762110000	14282	7207	79	0	\N
115705	1397	1359752109000	14282	7207	80	0	\N
115706	1397	1359742108000	14282	7207	81	0	\N
115707	1397	1359732107000	14282	7207	82	0	\N
115708	1397	1359722106000	14282	7207	83	0	\N
115709	1397	1359712105000	14282	7207	84	0	\N
115710	1397	1359702104000	14282	7207	85	0	\N
115711	1397	1359692103000	14282	7207	86	0	\N
115712	1397	1359682102000	14282	7207	87	0	\N
115713	1397	1359672101000	14282	7207	88	0	\N
115714	1397	1359662100000	14282	7207	89	0	\N
115715	1397	1359652099000	14282	7207	90	0	\N
115716	1397	1359642098000	14282	7207	91	0	\N
115717	1397	1359632097000	14282	7207	92	0	\N
115718	1397	1359622096000	14282	7207	93	0	\N
115719	1397	1359612095000	14282	7207	94	0	\N
115720	1397	1359602094000	14282	7207	96	0	\N
115721	1397	1359592093000	14282	7207	97	0	\N
115722	1397	1359582092000	14282	7207	98	0	\N
115723	1397	1359572091000	14282	7207	99	0	\N
115724	1397	1359562090000	14282	7207	100	0	\N
115725	1397	1359552089000	14282	7207	101	0	\N
115726	1397	1359542088000	14282	7207	102	0	\N
115727	1397	1359532087000	14282	7207	103	0	\N
115728	1397	1359522086000	14282	7207	104	0	\N
115729	1397	1359512085000	14282	7207	105	0	\N
115730	1397	1359502084000	14282	7207	106	0	\N
115731	1397	1359492083000	14282	7207	107	0	\N
115732	1397	1359482082000	14282	7207	108	0	\N
115733	1397	1359472081000	14282	7207	109	0	\N
115734	1397	1359462080000	14282	7207	110	0	\N
115735	1397	1359452079000	14282	7207	111	0	\N
115736	1926	1195000000	14282	7207	112	0	\N
115603	1726	666626082000	14278	7289	6	0	6785
115604	1726	666625079000	14278	7289	7	0	6786
115605	1726	666624077000	14278	7289	8	0	6787
115606	1726	666623076000	14278	7289	9	0	6788
115607	1397	1359462080000	14279	7290	0	0	7937
115737	1726	668122663000	14282	7207	113	0	\N
115752	1397	1359422076000	14284	7292	0	0	\N
115753	1726	666610049000	14284	7292	1	0	\N
115754	1726	666609047000	14284	7292	2	0	\N
115755	1726	666608046000	14284	7292	3	0	\N
115756	1397	1359422076000	14285	7292	0	0	\N
115757	1726	666610049000	14285	7292	1	0	\N
115758	1726	666609047000	14285	7292	2	0	\N
115759	1726	666608046000	14285	7292	3	0	\N
115764	1397	1359422076000	14287	7292	0	0	\N
115765	1726	666610049000	14287	7292	1	0	\N
115766	1726	666609047000	14287	7292	2	0	\N
115767	1726	666608046000	14287	7292	3	0	\N
115768	1397	1359422076000	14288	7292	0	0	\N
115769	1726	666610049000	14288	7292	1	0	\N
115770	1726	666609047000	14288	7292	2	0	\N
115771	1726	666608046000	14288	7292	3	0	\N
115772	1726	666607043000	14288	7292	4	0	\N
115773	1726	666606041000	14288	7292	5	0	\N
115774	1397	1359412075000	14289	7293	0	0	\N
115775	1397	1359402074000	14289	7293	1	0	\N
115776	1726	666607043000	14289	7293	2	0	\N
115777	1726	666606041000	14289	7293	3	0	\N
115778	1726	666605040000	14289	7293	4	0	\N
115779	1726	666604037000	14289	7293	5	0	\N
115780	1726	666603035000	14289	7293	6	0	\N
115781	1397	1359412075000	14290	7293	0	0	\N
115782	1397	1359402074000	14290	7293	1	0	\N
115783	1726	666607043000	14290	7293	2	0	\N
115784	1726	666606041000	14290	7293	3	0	\N
115785	1726	666605040000	14290	7293	4	0	\N
115786	1726	666604037000	14290	7293	5	0	\N
115787	1726	666603035000	14290	7293	6	0	\N
115795	1397	1359392073000	14293	7294	0	0	\N
115796	1726	666602034000	14293	7294	2	0	\N
115797	1726	666601032000	14293	7294	3	0	\N
115798	1726	666600029000	14293	7294	4	0	\N
115803	1726	666602034000	14295	7294	0	0	\N
115804	1726	666601032000	14295	7294	2	0	\N
115805	1726	666600029000	14295	7294	3	0	\N
115829	1467	25903206035399	14300	7221	0	0	\N
115830	1467	19417301554450	14300	7221	1	0	\N
115831	1467	15041129307591	14300	7221	2	0	\N
115832	1467	2846554100039	14300	7221	3	0	\N
115833	849	1155747211256640	14300	7221	4	0	\N
115834	1397	1359332067000	14301	7299	0	0	\N
115835	1397	1359322066000	14301	7299	1	0	\N
115836	1397	1359312065000	14301	7299	2	0	\N
115837	1397	1359332067000	14302	7299	0	0	\N
115838	1397	1359322066000	14302	7299	1	0	\N
115839	1397	1359312065000	14302	7299	2	0	\N
115840	1726	666581993000	14302	7299	3	0	\N
115841	1726	666580991000	14302	7299	4	0	\N
115842	1726	666579988000	14302	7299	5	0	\N
115843	1726	666578987000	14302	7299	6	0	\N
115844	1726	666577985000	14302	7299	7	0	\N
115845	1726	666576982000	14302	7299	8	0	\N
115846	1726	666575981000	14302	7299	9	0	\N
115847	1726	666574979000	14302	7299	10	0	\N
115848	1726	666573976000	14302	7299	11	0	\N
115861	1397	1359582092000	14304	7206	0	0	\N
115862	1467	25903206035399	14304	7206	1	0	\N
115863	1467	19417301554450	14304	7206	2	0	\N
115864	1467	15041129307591	14304	7206	3	0	\N
115865	1467	2846554100039	14304	7206	4	0	\N
115866	1397	1359572091000	14304	7206	5	0	\N
115867	1397	1359562090000	14304	7206	6	0	\N
115868	1397	1359552089000	14304	7206	7	0	\N
115869	1397	1359542088000	14304	7206	8	0	\N
115870	1397	1359532087000	14304	7206	9	0	\N
115871	1397	1359522086000	14304	7206	10	0	\N
115872	1397	1359512085000	14304	7206	11	0	\N
115740	1726	666622073000	14283	7291	2	0	6789
115741	1726	666621071000	14283	7291	3	0	6790
115742	1726	666620070000	14283	7291	4	0	6791
115743	1726	666619067000	14283	7291	5	0	6792
115744	1726	666618065000	14283	7291	6	0	6793
115746	1726	666616061000	14283	7291	8	0	6795
115747	1726	666615059000	14283	7291	9	0	6796
115748	1726	666614058000	14283	7291	10	0	6797
115749	1726	666613055000	14283	7291	11	0	6798
115750	1726	666612053000	14283	7291	12	0	6799
115760	1397	1359422076000	14286	7292	0	0	7941
115761	1726	666610049000	14286	7292	1	0	6801
115762	1726	666609047000	14286	7292	2	0	6802
115763	1726	666608046000	14286	7292	3	0	6803
115789	1397	1359402074000	14291	7293	1	0	7943
115790	1726	666607043000	14291	7293	2	0	6804
115791	1726	666606041000	14291	7293	3	0	6805
115792	1726	666605040000	14291	7293	4	0	6806
115793	1726	666604037000	14291	7293	5	0	6807
115799	1397	1359392073000	14294	7294	0	0	7944
115800	1726	666602034000	14294	7294	2	0	6809
115801	1726	666601032000	14294	7294	3	0	6810
115802	1726	666600029000	14294	7294	4	0	6811
115806	1726	666599027000	14296	7295	0	0	6812
115808	1397	1359382072000	14297	7296	0	0	7945
115809	1397	1359372071000	14297	7296	1	0	7946
115810	1726	666597022000	14297	7296	2	0	6814
115811	1726	666596021000	14297	7296	3	0	6815
115813	849	1155747211256640	14297	7296	5	0	1
115814	1726	666594016000	14297	7296	6	0	6817
115815	1726	666593015000	14297	7296	7	0	6818
115816	1726	666592012000	14297	7296	8	0	6819
115817	1397	1359362070000	14298	7297	0	0	7947
115819	1726	666590009000	14298	7297	2	0	6821
115820	1726	666589006000	14298	7297	3	0	6822
115821	1397	1359352069000	14299	7298	0	0	7948
115822	1397	1359342068000	14299	7298	1	0	7949
115823	1726	666588004000	14299	7298	2	0	6823
115825	1726	666586000000	14299	7298	4	0	6825
115826	1726	666584998000	14299	7298	5	0	6826
115827	1726	666583997000	14299	7298	6	0	6827
115828	1726	666582994000	14299	7298	7	0	6828
115850	1397	1359322066000	14303	7299	1	0	7951
115851	1397	1359312065000	14303	7299	2	0	7952
115852	1726	666581993000	14303	7299	3	0	6829
115853	1726	666580991000	14303	7299	4	0	6830
115854	1726	666579988000	14303	7299	5	0	6831
115856	1726	666577985000	14303	7299	7	0	6833
115857	1726	666576982000	14303	7299	8	0	6834
115858	1726	666575981000	14303	7299	9	0	6835
115859	1726	666574979000	14303	7299	10	0	6836
115860	1726	666573976000	14303	7299	11	0	6837
115873	1397	1359502084000	14304	7206	12	0	\N
115874	1397	1359492083000	14304	7206	13	0	\N
115875	1397	1359482082000	14304	7206	14	0	\N
115876	1397	1359472081000	14304	7206	15	0	\N
115877	1397	1359462080000	14304	7206	16	0	\N
115878	1397	1359452079000	14304	7206	17	0	\N
115879	1397	1359442078000	14304	7206	18	0	\N
115880	1397	1359432077000	14304	7206	19	0	\N
115881	1397	1359422076000	14304	7206	20	0	\N
115882	1397	1359412075000	14304	7206	21	0	\N
115883	1397	1359402074000	14304	7206	22	0	\N
115884	1397	1359392073000	14304	7206	23	0	\N
115885	1397	1359382072000	14304	7206	24	0	\N
115886	1397	1359372071000	14304	7206	25	0	\N
115887	1397	1359362070000	14304	7206	26	0	\N
115888	1397	1359352069000	14304	7206	27	0	\N
115889	1397	1359342068000	14304	7206	28	0	\N
115890	1397	1359332067000	14304	7206	29	0	\N
115891	1397	1359322066000	14304	7206	30	0	\N
115892	1397	1359312065000	14304	7206	31	0	\N
115893	1726	668101620000	14304	7206	32	0	\N
115894	1726	668100619000	14304	7206	33	0	\N
115895	1726	668099616000	14304	7206	34	0	\N
115896	1726	668098614000	14304	7206	35	0	\N
115897	1726	668097613000	14304	7206	36	0	\N
115898	849	1155747211256640	14304	7206	37	0	\N
115899	1726	668096610000	14304	7206	38	0	\N
115900	1726	668095608000	14304	7206	39	0	\N
115901	1726	668094607000	14304	7206	40	0	\N
115902	1726	668093604000	14304	7206	41	0	\N
115903	1726	668092602000	14304	7206	42	0	\N
115904	1726	668091601000	14304	7206	43	0	\N
115905	1726	668090598000	14304	7206	44	0	\N
115906	1726	668089596000	14304	7206	45	0	\N
115907	1726	668088595000	14304	7206	46	0	\N
115908	1726	668087592000	14304	7206	47	0	\N
115909	1726	668086590000	14304	7206	48	0	\N
115910	1726	668085589000	14304	7206	49	0	\N
115911	1726	668084586000	14304	7206	50	0	\N
115912	1726	668083584000	14304	7206	51	0	\N
115913	1726	668082583000	14304	7206	52	0	\N
115914	1726	668081580000	14304	7206	53	0	\N
115915	1726	668080578000	14304	7206	54	0	\N
115916	1726	668079575000	14304	7206	55	0	\N
115917	1726	668078574000	14304	7206	56	0	\N
115918	1726	668077572000	14304	7206	57	0	\N
115919	1726	668076569000	14304	7206	58	0	\N
115920	1726	668075567000	14304	7206	59	0	\N
115921	1726	668074564000	14304	7206	60	0	\N
115922	1726	668073563000	14304	7206	61	0	\N
115923	1726	668072561000	14304	7206	62	0	\N
115924	1726	668071558000	14304	7206	63	0	\N
115925	1726	668070557000	14304	7206	64	0	\N
115926	1726	668069555000	14304	7206	65	0	\N
115927	1726	668068552000	14304	7206	66	0	\N
115928	1726	668067551000	14304	7206	67	0	\N
115929	1726	668066549000	14304	7206	68	0	\N
115930	1726	668065548000	14304	7206	69	0	\N
115931	1726	668064546000	14304	7206	70	0	\N
115932	1726	668063543000	14304	7206	71	0	\N
115933	1726	668062541000	14304	7206	72	0	\N
115934	1726	668061538000	14304	7206	73	0	\N
115935	1726	668060536000	14304	7206	74	0	\N
115936	1726	668059533000	14304	7206	75	0	\N
115937	1726	668058531000	14304	7206	76	0	\N
115938	1726	668057528000	14304	7206	77	0	\N
115939	1726	668056526000	14304	7206	78	0	\N
115940	1726	668055523000	14304	7206	79	0	\N
115941	1726	668054521000	14304	7206	80	0	\N
115942	1726	668053518000	14304	7206	81	0	\N
115943	1726	668052516000	14304	7206	82	0	\N
115944	1726	668051513000	14304	7206	83	0	\N
115945	1726	668050511000	14304	7206	84	0	\N
115946	1726	668049508000	14304	7206	85	0	\N
115947	1726	668048506000	14304	7206	86	0	\N
115948	1726	668047503000	14304	7206	87	0	\N
115949	1726	668046501000	14304	7206	88	0	\N
115950	1726	668045498000	14304	7206	89	0	\N
115951	1726	668044496000	14304	7206	90	0	\N
115952	1726	668043493000	14304	7206	91	0	\N
115953	1726	668042491000	14304	7206	92	0	\N
115954	1726	668041488000	14304	7206	93	0	\N
115955	1726	668040486000	14304	7206	94	0	\N
115956	1726	668039483000	14304	7206	95	0	\N
115957	1726	668038481000	14304	7206	96	0	\N
115958	1726	668037478000	14304	7206	97	0	\N
115959	1726	668036476000	14304	7206	98	0	\N
115960	1726	668035473000	14304	7206	99	0	\N
115961	1726	668034471000	14304	7206	100	0	\N
115962	1726	668033470000	14304	7206	101	0	\N
115963	1726	668032467000	14304	7206	102	0	\N
115964	1726	668031465000	14304	7206	103	0	\N
115965	1726	668030464000	14304	7206	104	0	\N
115966	1726	668029461000	14304	7206	105	0	\N
115967	1726	668028459000	14304	7206	106	0	\N
115968	1726	668027458000	14304	7206	107	0	\N
115969	1726	668026455000	14304	7206	108	0	\N
115970	1726	668025453000	14304	7206	110	0	\N
115971	1726	666815453000	14304	7206	111	0	\N
115972	1726	666814452000	14304	7206	112	0	\N
115973	1726	666813449000	14304	7206	113	0	\N
115974	1726	666812447000	14304	7206	114	0	\N
115975	1726	666811446000	14304	7206	115	0	\N
115976	1726	666810443000	14304	7206	116	0	\N
115977	1726	666809441000	14304	7206	117	0	\N
115978	1726	666808440000	14304	7206	118	0	\N
115979	1726	666807437000	14304	7206	119	0	\N
115980	1726	666806435000	14304	7206	120	0	\N
115981	1726	666805434000	14304	7206	121	0	\N
115982	1726	666804432000	14304	7206	122	0	\N
115983	1726	666803431000	14304	7206	123	0	\N
115984	1726	666802428000	14304	7206	124	0	\N
115985	1726	666801426000	14304	7206	125	0	\N
115993	1397	1359302064000	14306	7300	0	0	\N
115994	1397	1359292063000	14306	7300	1	0	\N
115995	1726	666572975000	14306	7300	2	0	\N
115996	1726	666571973000	14306	7300	3	0	\N
115997	1726	666570970000	14306	7300	4	0	\N
115998	1726	666569968000	14306	7300	5	0	\N
115999	1726	666568965000	14306	7300	6	0	\N
116007	1397	1359282062000	14308	7301	0	0	\N
116008	1397	1359272061000	14308	7301	1	0	\N
115988	1726	666572975000	14305	7300	2	0	6838
115989	1726	666571973000	14305	7300	3	0	6839
115990	1726	666570970000	14305	7300	4	0	6840
115991	1726	666569968000	14305	7300	5	0	6841
115992	1726	666568965000	14305	7300	6	0	6842
116001	1397	1359272061000	14307	7301	1	0	7956
116002	1726	666567964000	14307	7301	2	0	6843
116003	1726	666566961000	14307	7301	3	0	6844
116004	1726	666565960000	14307	7301	4	0	6845
116005	1726	666564958000	14307	7301	5	0	6846
116009	1726	666567964000	14308	7301	2	0	\N
116010	1726	666566961000	14308	7301	3	0	\N
116011	1726	666565960000	14308	7301	4	0	\N
116012	1726	666564958000	14308	7301	5	0	\N
116013	1726	666563955000	14308	7301	6	0	\N
116017	1397	1359252059000	14310	7303	0	0	\N
116018	1726	666560950000	14310	7303	1	0	\N
116019	1726	666559948000	14310	7303	2	0	\N
116020	1726	666558945000	14310	7303	3	0	\N
116025	1397	1359242058000	14312	7304	0	0	\N
116026	1726	666557943000	14312	7304	1	0	\N
116027	1726	666556940000	14312	7304	2	0	\N
116028	1397	1359242058000	14313	7304	0	0	\N
116029	1726	666557943000	14313	7304	1	0	\N
116030	1726	666556940000	14313	7304	2	0	\N
116034	1397	1359232057000	14315	7305	0	0	\N
116035	1726	666555938000	14315	7305	1	0	\N
116036	1726	666554937000	14315	7305	2	0	\N
116037	1397	1359232057000	14316	7305	0	0	\N
116038	1726	666555938000	14316	7305	1	0	\N
116039	1726	666554937000	14316	7305	2	0	\N
116043	1397	1359232057000	14318	7305	0	0	\N
116044	1726	666555938000	14318	7305	1	0	\N
116045	1726	666554937000	14318	7305	2	0	\N
116046	1397	1359222056000	14319	7306	0	0	\N
116047	1726	666553935000	14319	7306	1	0	\N
116048	1726	666552934000	14319	7306	2	0	\N
116049	1726	666551931000	14319	7306	3	0	\N
116054	1397	1359222056000	14321	7306	0	0	\N
116055	1726	666553935000	14321	7306	1	0	\N
116056	1726	666552934000	14321	7306	2	0	\N
116057	1726	666551931000	14321	7306	3	0	\N
116065	1397	1359192053000	14323	7308	0	0	\N
116066	1726	666545919000	14323	7308	1	0	\N
116067	1726	666544917000	14323	7308	2	0	\N
116068	1726	666543916000	14323	7308	3	0	\N
116077	1397	1359182052000	14326	7309	0	0	\N
116078	1726	666542913000	14326	7309	1	0	\N
116079	1726	666541911000	14326	7309	2	0	\N
116091	1397	1359152049000	14330	7312	0	0	\N
116092	1726	666533895000	14330	7312	1	0	\N
116097	1397	1359142048000	14332	7313	0	0	\N
116098	1726	666531892000	14332	7313	1	0	\N
116099	1726	666530889000	14332	7313	2	0	\N
116100	1726	666529887000	14332	7313	3	0	\N
116129	1397	1359072041000	14338	7318	0	0	\N
116130	1726	665301851000	14338	7318	1	0	\N
116131	1726	665300848000	14338	7318	2	0	\N
116132	1726	665299846000	14338	7318	3	0	\N
116141	1397	1359042038000	14340	7320	0	0	\N
116142	1726	665292833000	14340	7320	1	0	\N
116143	1726	665291830000	14340	7320	2	0	\N
116144	1726	665290828000	14340	7320	3	0	\N
116016	1726	666561951000	14309	7302	2	0	6849
116021	1397	1359252059000	14311	7303	0	0	7958
116022	1726	666560950000	14311	7303	1	0	6850
116023	1726	666559948000	14311	7303	2	0	6851
116024	1726	666558945000	14311	7303	3	0	6852
116032	1726	666557943000	14314	7304	1	0	6853
116033	1726	666556940000	14314	7304	2	0	6854
116040	1397	1359232057000	14317	7305	0	0	7960
116041	1726	666555938000	14317	7305	1	0	6855
116042	1726	666554937000	14317	7305	2	0	6856
116051	1726	666553935000	14320	7306	1	0	6857
116052	1726	666552934000	14320	7306	2	0	6858
116053	1726	666551931000	14320	7306	3	0	6859
116058	1397	1359212055000	14322	7307	0	0	7962
116060	1726	666550929000	14322	7307	2	0	6860
116061	1726	666549928000	14322	7307	3	0	6861
116062	1726	666548925000	14322	7307	4	0	6862
116063	1726	666547923000	14322	7307	5	0	6863
116064	1726	666546922000	14322	7307	6	0	6864
116070	1726	666545919000	14324	7308	1	0	6865
116071	1726	666544917000	14324	7308	2	0	6866
116072	1726	666543916000	14324	7308	3	0	6867
116073	1397	1359182052000	14325	7309	0	0	7965
116074	1726	666542913000	14325	7309	1	0	6868
116076	1726	666540910000	14325	7309	3	0	6870
116080	1397	1359172051000	14327	7310	0	0	7966
116081	1726	666539907000	14327	7310	1	0	6871
116082	1726	666538905000	14327	7310	2	0	6872
116084	1397	1359162050000	14328	7311	0	0	7967
116085	1726	666536901000	14328	7311	1	0	6874
116086	1726	666535899000	14328	7311	2	0	6875
116087	1726	666534898000	14328	7311	3	0	6876
116088	1397	1359152049000	14329	7312	0	0	7968
116090	1726	666532893000	14329	7312	2	0	6878
116093	1397	1359142048000	14331	7313	0	0	7969
116094	1726	666531892000	14331	7313	1	0	6879
116095	1726	666530889000	14331	7313	2	0	6880
116096	1726	666529887000	14331	7313	3	0	6881
116102	1397	1359122046000	14333	7314	1	0	7971
116103	1726	666528884000	14333	7314	2	0	6882
116104	1726	665318884000	14333	7314	3	0	6883
116105	1726	665317882000	14333	7314	4	0	6884
116107	1726	665315878000	14333	7314	6	0	6886
116108	1726	665314876000	14333	7314	7	0	6887
116109	1397	1359112045000	14334	7315	0	0	7972
116110	1726	665313875000	14334	7315	1	0	6888
116111	1726	665312872000	14334	7315	2	0	6889
116113	1397	1359102044000	14335	7316	0	0	7973
116114	1397	1359092043000	14335	7316	1	0	7974
116115	1726	665310869000	14335	7316	2	0	6891
116116	1726	665309866000	14335	7316	3	0	6892
116117	1726	665308864000	14335	7316	4	0	6893
116119	1726	665306860000	14335	7316	6	0	6895
116120	1726	665305858000	14335	7316	7	0	6896
116121	1397	1359082042000	14336	7317	0	0	7975
116122	1726	665304857000	14336	7317	1	0	6897
116124	1726	665302852000	14336	7317	3	0	6899
116125	1397	1359072041000	14337	7318	0	0	7976
116126	1726	665301851000	14337	7318	1	0	6900
116127	1726	665300848000	14337	7318	2	0	6901
116128	1726	665299846000	14337	7318	3	0	6902
116134	1397	1359052039000	14339	7319	1	0	7978
116135	1726	665298845000	14339	7319	2	0	6903
116136	1726	665297842000	14339	7319	3	0	6904
116137	1726	665296840000	14339	7319	4	0	6905
116138	1726	665295839000	14339	7319	5	0	6906
116140	1726	665293834000	14339	7319	7	0	6908
116149	1397	1359032037000	14342	7321	0	0	\N
116150	1726	665289827000	14342	7321	1	0	\N
116151	1726	665288824000	14342	7321	2	0	\N
116152	1726	665287822000	14342	7321	3	0	\N
116153	1726	665286821000	14342	7321	4	0	\N
116154	1726	665285818000	14342	7321	5	0	\N
116155	1726	665284816000	14342	7321	6	0	\N
116156	1397	1359032037000	14343	7321	0	0	\N
116157	1726	665289827000	14343	7321	1	0	\N
116158	1726	665288824000	14343	7321	2	0	\N
116159	1726	665287822000	14343	7321	3	0	\N
116160	1726	665286821000	14343	7321	4	0	\N
116161	1726	665285818000	14343	7321	5	0	\N
116162	1726	665284816000	14343	7321	6	0	\N
116178	1397	1359022036000	14346	7322	0	0	\N
116179	1397	1359012035000	14346	7322	1	0	\N
116180	1726	665283815000	14346	7322	2	0	\N
116181	1726	665282812000	14346	7322	3	0	\N
116182	1726	665281810000	14346	7322	4	0	\N
116183	1726	665280809000	14346	7322	5	0	\N
116184	1726	665279806000	14346	7322	6	0	\N
116185	1726	665278804000	14346	7322	7	0	\N
116190	2058	549500000	14348	7192	0	0	\N
116191	1397	1360692203000	14348	7192	1	0	\N
116192	1397	1360682202000	14348	7192	2	0	\N
116193	1397	1360672201000	14348	7192	3	0	\N
116194	1397	1360662200000	14348	7192	4	0	\N
116195	1397	1360652199000	14348	7192	5	0	\N
116196	1397	1360642198000	14348	7192	6	0	\N
116197	1467	25903206035399	14348	7192	7	0	\N
116198	1467	19417301554450	14348	7192	8	0	\N
116199	1467	15041129307591	14348	7192	9	0	\N
116200	1467	2846554100039	14348	7192	10	0	\N
116201	1397	1360632197000	14348	7192	11	0	\N
116202	1397	1360622196000	14348	7192	12	0	\N
116203	1397	1360612195000	14348	7192	13	0	\N
116204	1397	1360602194000	14348	7192	14	0	\N
116205	1397	1360592193000	14348	7192	15	0	\N
116206	1397	1360582192000	14348	7192	16	0	\N
116207	1397	1360572191000	14348	7192	17	0	\N
116208	1397	1360562190000	14348	7192	18	0	\N
116209	1397	1360552189000	14348	7192	19	0	\N
116210	1397	1360542188000	14348	7192	20	0	\N
116211	1397	1360532187000	14348	7192	21	0	\N
116212	1397	1360522186000	14348	7192	22	0	\N
116213	1397	1360512185000	14348	7192	23	0	\N
116214	1397	1360502184000	14348	7192	24	0	\N
116215	1397	1360492183000	14348	7192	25	0	\N
116216	1397	1360482182000	14348	7192	26	0	\N
116217	1397	1360472181000	14348	7192	27	0	\N
116218	1397	1360462180000	14348	7192	28	0	\N
116219	1397	1360452179000	14348	7192	29	0	\N
116220	1397	1360442178000	14348	7192	30	0	\N
116221	1397	1360432177000	14348	7192	31	0	\N
116222	1397	1360422176000	14348	7192	32	0	\N
116223	1397	1360412175000	14348	7192	33	0	\N
116224	1397	1360402174000	14348	7192	34	0	\N
116225	1397	1360392173000	14348	7192	35	0	\N
116226	1397	1360382172000	14348	7192	36	0	\N
116227	1397	1360372171000	14348	7192	37	0	\N
116228	1397	1360362170000	14348	7192	38	0	\N
116229	1397	1360352169000	14348	7192	39	0	\N
116230	1397	1360342168000	14348	7192	40	0	\N
116231	1397	1360332167000	14348	7192	41	0	\N
116232	1397	1360322166000	14348	7192	42	0	\N
116233	1397	1360312165000	14348	7192	43	0	\N
116234	1397	1360302164000	14348	7192	44	0	\N
116235	1397	1360292163000	14348	7192	45	0	\N
116236	1397	1360282162000	14348	7192	46	0	\N
116237	1397	1360272161000	14348	7192	47	0	\N
116238	1397	1360262160000	14348	7192	48	0	\N
116239	1397	1360252159000	14348	7192	49	0	\N
116240	1397	1360242158000	14348	7192	50	0	\N
116241	1397	1360232157000	14348	7192	51	0	\N
116242	1397	1360222156000	14348	7192	52	0	\N
116243	1397	1360212155000	14348	7192	53	0	\N
116244	1397	1360202154000	14348	7192	54	0	\N
116245	1397	1360192153000	14348	7192	55	0	\N
116246	1397	1360182152000	14348	7192	56	0	\N
116247	1397	1360172151000	14348	7192	57	0	\N
116248	1397	1360162150000	14348	7192	58	0	\N
116249	1397	1360152149000	14348	7192	59	0	\N
116250	1397	1360142148000	14348	7192	60	0	\N
116251	1397	1360132147000	14348	7192	61	0	\N
116252	1397	1360122146000	14348	7192	62	0	\N
116253	1397	1360112145000	14348	7192	63	0	\N
116254	1397	1360102144000	14348	7192	64	0	\N
116255	1397	1360092143000	14348	7192	65	0	\N
116256	1397	1360082142000	14348	7192	66	0	\N
116257	1397	1360072141000	14348	7192	67	0	\N
116258	1397	1360062140000	14348	7192	68	0	\N
116259	1397	1360052139000	14348	7192	69	0	\N
116260	1397	1360042138000	14348	7192	70	0	\N
116261	1397	1360032137000	14348	7192	71	0	\N
116262	1397	1360022136000	14348	7192	72	0	\N
116263	1397	1360012135000	14348	7192	73	0	\N
116264	1397	1360002134000	14348	7192	75	0	\N
116265	1397	1359992133000	14348	7192	76	0	\N
116266	1397	1359982132000	14348	7192	77	0	\N
116267	1397	1359972131000	14348	7192	78	0	\N
116268	1397	1359962130000	14348	7192	79	0	\N
116269	1397	1359952129000	14348	7192	80	0	\N
116270	1397	1359942128000	14348	7192	81	0	\N
116271	1397	1359932127000	14348	7192	82	0	\N
116272	1397	1359922126000	14348	7192	83	0	\N
116273	1397	1359912125000	14348	7192	84	0	\N
116274	1397	1359902124000	14348	7192	85	0	\N
116275	1397	1359892123000	14348	7192	86	0	\N
116276	1397	1359882122000	14348	7192	87	0	\N
116277	1397	1359872121000	14348	7192	88	0	\N
116278	1397	1359862120000	14348	7192	89	0	\N
116279	1397	1359852119000	14348	7192	90	0	\N
116280	1397	1359842118000	14348	7192	91	0	\N
116147	1726	665291830000	14341	7320	2	0	6910
116148	1726	665290828000	14341	7320	3	0	6911
116163	1397	1359032037000	14344	7321	0	0	7980
116164	1726	665289827000	14344	7321	1	0	6912
116165	1726	665288824000	14344	7321	2	0	6913
116167	1726	665286821000	14344	7321	4	0	6915
116168	1726	665285818000	14344	7321	5	0	6916
116169	1726	665284816000	14344	7321	6	0	6917
116170	1397	1359022036000	14345	7322	0	0	7981
116171	1397	1359012035000	14345	7322	1	0	7982
116173	1726	665282812000	14345	7322	3	0	6919
116174	1726	665281810000	14345	7322	4	0	6920
116175	1726	665280809000	14345	7322	5	0	6921
116176	1726	665279806000	14345	7322	6	0	6922
116186	1397	1359002034000	14347	7323	0	0	7983
116187	1726	665277803000	14347	7323	1	0	6924
116188	1726	665276800000	14347	7323	2	0	6925
116189	1726	665275798000	14347	7323	3	0	6926
116281	1397	1359832117000	14348	7192	92	0	\N
116282	1397	1359822116000	14348	7192	93	0	\N
116283	1397	1359812115000	14348	7192	94	0	\N
116284	1397	1359802114000	14348	7192	95	0	\N
116285	1397	1359792113000	14348	7192	96	0	\N
116286	1397	1359782112000	14348	7192	97	0	\N
116287	1397	1359772111000	14348	7192	98	0	\N
116288	1397	1359762110000	14348	7192	99	0	\N
116289	1397	1359752109000	14348	7192	100	0	\N
116290	1397	1359742108000	14348	7192	101	0	\N
116291	1397	1359732107000	14348	7192	102	0	\N
116292	1397	1359722106000	14348	7192	103	0	\N
116293	1397	1359712105000	14348	7192	104	0	\N
116294	1397	1359702104000	14348	7192	105	0	\N
116295	1397	1359692103000	14348	7192	106	0	\N
116296	1397	1359682102000	14348	7192	107	0	\N
116297	1397	1359672101000	14348	7192	108	0	\N
116298	1397	1359662100000	14348	7192	109	0	\N
116299	1397	1359652099000	14348	7192	110	0	\N
116300	1397	1359642098000	14348	7192	111	0	\N
116301	1397	1359632097000	14348	7192	112	0	\N
116302	1397	1359622096000	14348	7192	113	0	\N
116303	1397	1359612095000	14348	7192	114	0	\N
116304	1397	1359602094000	14348	7192	115	0	\N
116305	1397	1359592093000	14348	7192	116	0	\N
116306	1397	1359582092000	14348	7192	117	0	\N
116307	1397	1359572091000	14348	7192	118	0	\N
116308	1397	1359562090000	14348	7192	119	0	\N
116309	1397	1359552089000	14348	7192	120	0	\N
116310	1397	1359542088000	14348	7192	121	0	\N
116311	1397	1359532087000	14348	7192	122	0	\N
116312	1397	1359522086000	14348	7192	123	0	\N
116313	1397	1359512085000	14348	7192	124	0	\N
116314	1397	1359502084000	14348	7192	125	0	\N
116325	1397	1358982032000	14351	7325	0	0	\N
116326	1397	1358972031000	14351	7325	1	0	\N
116327	1726	665272792000	14351	7325	2	0	\N
116328	1726	665271791000	14351	7325	3	0	\N
116329	1726	665270789000	14351	7325	4	0	\N
116330	1726	665269786000	14351	7325	5	0	\N
116331	1726	665268785000	14351	7325	6	0	\N
116336	1397	1358952029000	14353	7327	0	0	\N
116337	1726	665264777000	14353	7327	1	0	\N
116338	1726	665263774000	14353	7327	2	0	\N
116339	1726	665262773000	14353	7327	3	0	\N
116353	1693	16473490155041	14357	7227	0	0	\N
116354	1467	25903206035399	14357	7227	1	0	\N
116355	1467	19417301554450	14357	7227	2	0	\N
116356	1467	15041129307591	14357	7227	3	0	\N
116357	1467	2846554100039	14357	7227	4	0	\N
116358	849	1155747211256640	14357	7227	5	0	\N
116363	1397	1358922026000	14359	7330	0	0	\N
116364	1726	665255759000	14359	7330	1	0	\N
116365	1726	665254756000	14359	7330	2	0	\N
116366	1726	665253755000	14359	7330	3	0	\N
116367	1397	1358922026000	14360	7330	0	0	\N
116368	1726	665255759000	14360	7330	1	0	\N
116369	1726	665254756000	14360	7330	2	0	\N
116370	1726	665253755000	14360	7330	3	0	\N
116371	1397	1358922026000	14361	7330	0	0	\N
116372	1726	665255759000	14361	7330	1	0	\N
116373	1726	665254756000	14361	7330	2	0	\N
116374	1726	665253755000	14361	7330	3	0	\N
116375	1693	16473490155041	14362	7238	0	0	\N
116376	1467	25903206035399	14362	7238	1	0	\N
116377	1467	19417301554450	14362	7238	2	0	\N
116378	1467	15041129307591	14362	7238	3	0	\N
116379	1467	2846554100039	14362	7238	4	0	\N
116380	1397	1360112145000	14362	7238	5	0	\N
116381	1397	1360102144000	14362	7238	6	0	\N
116382	1397	1360092143000	14362	7238	7	0	\N
116383	1397	1360082142000	14362	7238	8	0	\N
116384	1397	1360072141000	14362	7238	9	0	\N
116385	1397	1360062140000	14362	7238	10	0	\N
116386	1397	1360052139000	14362	7238	11	0	\N
116387	1397	1360042138000	14362	7238	13	0	\N
116388	1397	1360032137000	14362	7238	14	0	\N
116389	1397	1360022136000	14362	7238	15	0	\N
116390	1397	1360012135000	14362	7238	16	0	\N
116391	1397	1360002134000	14362	7238	17	0	\N
116392	1397	1359992133000	14362	7238	18	0	\N
116393	1397	1359982132000	14362	7238	19	0	\N
116394	1397	1359972131000	14362	7238	20	0	\N
116395	1397	1359962130000	14362	7238	21	0	\N
116396	1397	1359952129000	14362	7238	22	0	\N
116397	1397	1359942128000	14362	7238	23	0	\N
116398	1397	1359932127000	14362	7238	24	0	\N
116399	1397	1359922126000	14362	7238	25	0	\N
116400	1397	1359912125000	14362	7238	26	0	\N
116401	1397	1359902124000	14362	7238	27	0	\N
116402	1397	1359892123000	14362	7238	28	0	\N
116403	1397	1359882122000	14362	7238	29	0	\N
116404	1397	1359872121000	14362	7238	30	0	\N
116405	1397	1359862120000	14362	7238	31	0	\N
116406	1397	1359852119000	14362	7238	32	0	\N
116407	1397	1359842118000	14362	7238	33	0	\N
116408	1397	1359832117000	14362	7238	34	0	\N
116409	1397	1359822116000	14362	7238	35	0	\N
116410	1397	1359812115000	14362	7238	36	0	\N
116411	1397	1359802114000	14362	7238	37	0	\N
116412	1397	1359792113000	14362	7238	38	0	\N
116413	1397	1359782112000	14362	7238	39	0	\N
116414	1397	1359772111000	14362	7238	40	0	\N
116415	1397	1359762110000	14362	7238	41	0	\N
116416	1397	1359752109000	14362	7238	42	0	\N
116317	1726	665273795000	14349	7324	2	0	6928
116318	1397	1358982032000	14350	7325	0	0	7985
116319	1397	1358972031000	14350	7325	1	0	7986
116320	1726	665272792000	14350	7325	2	0	6929
116321	1726	665271791000	14350	7325	3	0	6930
116323	1726	665269786000	14350	7325	5	0	6932
116324	1726	665268785000	14350	7325	6	0	6933
116332	1397	1358962030000	14352	7326	0	0	7987
116333	1726	665267783000	14352	7326	1	0	6934
116334	1726	665266780000	14352	7326	2	0	6935
116340	1397	1358952029000	14354	7327	0	0	7988
116341	1726	665264777000	14354	7327	1	0	6937
116342	1726	665263774000	14354	7327	2	0	6938
116343	1726	665262773000	14354	7327	3	0	6939
116345	1397	1358932027000	14356	7329	0	0	7990
116346	1693	17913529155041	14356	7329	1	0	668
116347	1726	665261771000	14356	7329	2	0	6940
116348	1726	665260768000	14356	7329	3	0	6941
116349	1726	665259767000	14356	7329	4	0	6942
116351	1726	665257762000	14356	7329	6	0	6944
116352	1726	665256761000	14356	7329	7	0	6945
116359	1397	1358922026000	14358	7330	0	0	7991
116360	1726	665255759000	14358	7330	1	0	6946
116361	1726	665254756000	14358	7330	2	0	6947
116417	1397	1359742108000	14362	7238	43	0	\N
116418	1397	1359732107000	14362	7238	44	0	\N
116419	1397	1359722106000	14362	7238	45	0	\N
116420	1397	1359712105000	14362	7238	46	0	\N
116421	1397	1359702104000	14362	7238	47	0	\N
116422	1397	1359692103000	14362	7238	48	0	\N
116423	1397	1359682102000	14362	7238	49	0	\N
116424	1397	1359672101000	14362	7238	50	0	\N
116425	1397	1359662100000	14362	7238	51	0	\N
116426	1397	1359652099000	14362	7238	52	0	\N
116427	1397	1359642098000	14362	7238	53	0	\N
116428	1397	1359632097000	14362	7238	54	0	\N
116429	1397	1359622096000	14362	7238	55	0	\N
116430	1397	1359612095000	14362	7238	56	0	\N
116431	1397	1359602094000	14362	7238	57	0	\N
116432	1397	1359592093000	14362	7238	58	0	\N
116433	1397	1359582092000	14362	7238	59	0	\N
116434	1397	1359572091000	14362	7238	60	0	\N
116435	1397	1359562090000	14362	7238	61	0	\N
116436	1397	1359552089000	14362	7238	62	0	\N
116437	1397	1359542088000	14362	7238	63	0	\N
116438	1397	1359532087000	14362	7238	64	0	\N
116439	1397	1359522086000	14362	7238	65	0	\N
116440	1397	1359512085000	14362	7238	66	0	\N
116441	1397	1359502084000	14362	7238	67	0	\N
116442	1397	1359492083000	14362	7238	68	0	\N
116443	1397	1359482082000	14362	7238	69	0	\N
116444	1397	1359472081000	14362	7238	70	0	\N
116445	1397	1359462080000	14362	7238	71	0	\N
116446	1397	1359452079000	14362	7238	72	0	\N
116447	1397	1359442078000	14362	7238	73	0	\N
116448	1397	1359432077000	14362	7238	74	0	\N
116449	1397	1359422076000	14362	7238	75	0	\N
116450	1397	1359412075000	14362	7238	76	0	\N
116451	1397	1359402074000	14362	7238	77	0	\N
116452	1397	1359392073000	14362	7238	78	0	\N
116453	1397	1359382072000	14362	7238	79	0	\N
116454	1397	1359372071000	14362	7238	80	0	\N
116455	1397	1359362070000	14362	7238	81	0	\N
116456	1397	1359352069000	14362	7238	82	0	\N
116457	1397	1359342068000	14362	7238	83	0	\N
116458	1397	1359332067000	14362	7238	84	0	\N
116459	1397	1359322066000	14362	7238	85	0	\N
116460	1397	1359312065000	14362	7238	86	0	\N
116461	1397	1359302064000	14362	7238	87	0	\N
116462	1397	1359292063000	14362	7238	88	0	\N
116463	1397	1359282062000	14362	7238	89	0	\N
116464	1397	1359272061000	14362	7238	90	0	\N
116465	1397	1359262060000	14362	7238	91	0	\N
116466	1397	1359252059000	14362	7238	92	0	\N
116467	1397	1359242058000	14362	7238	93	0	\N
116468	1397	1359232057000	14362	7238	94	0	\N
116469	1397	1359222056000	14362	7238	95	0	\N
116470	1397	1359212055000	14362	7238	96	0	\N
116471	1397	1359202054000	14362	7238	97	0	\N
116472	1397	1359192053000	14362	7238	98	0	\N
116473	1397	1359182052000	14362	7238	99	0	\N
116474	1397	1359172051000	14362	7238	100	0	\N
116475	1397	1359162050000	14362	7238	101	0	\N
116476	1397	1359152049000	14362	7238	102	0	\N
116477	1397	1359142048000	14362	7238	103	0	\N
116478	1397	1359132047000	14362	7238	104	0	\N
116479	1397	1359122046000	14362	7238	105	0	\N
116480	1397	1359112045000	14362	7238	106	0	\N
116481	1397	1359102044000	14362	7238	107	0	\N
116482	1397	1359092043000	14362	7238	108	0	\N
116483	1397	1359082042000	14362	7238	109	0	\N
116484	1397	1359072041000	14362	7238	110	0	\N
116485	1397	1359062040000	14362	7238	111	0	\N
116486	1397	1359052039000	14362	7238	112	0	\N
116487	1397	1359042038000	14362	7238	113	0	\N
116488	1397	1359032037000	14362	7238	114	0	\N
116489	1397	1359022036000	14362	7238	115	0	\N
116490	1397	1359012035000	14362	7238	116	0	\N
116491	1397	1359002034000	14362	7238	117	0	\N
116492	1397	1358992033000	14362	7238	118	0	\N
116493	1397	1358982032000	14362	7238	119	0	\N
116494	1397	1358972031000	14362	7238	120	0	\N
116495	1397	1358962030000	14362	7238	121	0	\N
116496	1397	1358952029000	14362	7238	122	0	\N
116497	1397	1358942028000	14362	7238	123	0	\N
116498	1397	1358932027000	14362	7238	124	0	\N
116499	1397	1358922026000	14362	7238	125	0	\N
116500	1397	1358922026000	14363	7330	0	0	\N
116501	1726	665255759000	14363	7330	1	0	\N
116502	1726	665254756000	14363	7330	2	0	\N
116503	1726	665253755000	14363	7330	3	0	\N
116504	1693	15753477155041	14364	7193	0	0	\N
116505	1397	1359492083000	14364	7193	1	0	\N
116506	1397	1359482082000	14364	7193	2	0	\N
116507	1397	1359472081000	14364	7193	3	0	\N
116508	1397	1359462080000	14364	7193	4	0	\N
116509	1397	1359452079000	14364	7193	5	0	\N
116510	1397	1359442078000	14364	7193	6	0	\N
116511	1397	1359432077000	14364	7193	7	0	\N
116512	1397	1359422076000	14364	7193	8	0	\N
116513	1397	1359412075000	14364	7193	9	0	\N
116514	1397	1359402074000	14364	7193	10	0	\N
116515	1397	1359392073000	14364	7193	11	0	\N
116516	1397	1359382072000	14364	7193	12	0	\N
116517	1397	1359372071000	14364	7193	13	0	\N
116518	1397	1359362070000	14364	7193	14	0	\N
116519	1397	1359352069000	14364	7193	15	0	\N
116520	1397	1359342068000	14364	7193	16	0	\N
116521	1397	1359332067000	14364	7193	17	0	\N
116522	1397	1359322066000	14364	7193	18	0	\N
116523	1397	1359312065000	14364	7193	19	0	\N
116524	1397	1359302064000	14364	7193	20	0	\N
116525	1397	1359292063000	14364	7193	21	0	\N
116526	1397	1359282062000	14364	7193	22	0	\N
116527	1397	1359272061000	14364	7193	23	0	\N
116528	1397	1359262060000	14364	7193	24	0	\N
116529	1397	1359252059000	14364	7193	25	0	\N
116530	1397	1359242058000	14364	7193	26	0	\N
116531	1397	1359232057000	14364	7193	27	0	\N
116532	1397	1359222056000	14364	7193	28	0	\N
116533	1397	1359212055000	14364	7193	29	0	\N
116534	1397	1359202054000	14364	7193	30	0	\N
116535	1397	1359192053000	14364	7193	31	0	\N
116536	1397	1359182052000	14364	7193	32	0	\N
116537	1397	1359172051000	14364	7193	33	0	\N
116538	1397	1359162050000	14364	7193	34	0	\N
116539	1397	1359152049000	14364	7193	35	0	\N
116540	1397	1359142048000	14364	7193	36	0	\N
116541	1397	1359132047000	14364	7193	37	0	\N
116542	1397	1359122046000	14364	7193	38	0	\N
116543	1397	1359112045000	14364	7193	39	0	\N
116544	1397	1359102044000	14364	7193	40	0	\N
116545	1397	1359092043000	14364	7193	41	0	\N
116546	1397	1359082042000	14364	7193	42	0	\N
116547	1397	1359072041000	14364	7193	43	0	\N
116548	1397	1359062040000	14364	7193	44	0	\N
116549	1397	1359052039000	14364	7193	45	0	\N
116550	1397	1359042038000	14364	7193	46	0	\N
116551	1397	1359032037000	14364	7193	47	0	\N
116552	1397	1359022036000	14364	7193	48	0	\N
116553	1397	1359012035000	14364	7193	49	0	\N
116554	1397	1359002034000	14364	7193	50	0	\N
116555	1397	1358992033000	14364	7193	51	0	\N
116556	1397	1358982032000	14364	7193	52	0	\N
116557	1397	1358972031000	14364	7193	53	0	\N
116558	1397	1358962030000	14364	7193	54	0	\N
116559	1397	1358952029000	14364	7193	55	0	\N
116560	1397	1358942028000	14364	7193	56	0	\N
116561	1397	1358932027000	14364	7193	57	0	\N
116562	1397	1358922026000	14364	7193	58	0	\N
116563	1397	1358912025000	14364	7193	59	0	\N
116564	1726	671806771000	14364	7193	60	0	\N
116565	1926	1195000000	14364	7193	61	0	\N
116566	1769	1703900000	14364	7193	62	0	\N
116567	1925	1194000000	14364	7193	63	0	\N
116568	849	1155747211256640	14364	7193	64	0	\N
116569	1726	671805770000	14364	7193	65	0	\N
116570	1726	671804768000	14364	7193	66	0	\N
116571	1726	671803765000	14364	7193	67	0	\N
116572	1726	671802764000	14364	7193	68	0	\N
116573	1726	671801762000	14364	7193	69	0	\N
116574	1726	671800759000	14364	7193	70	0	\N
116575	1726	671799758000	14364	7193	71	0	\N
116576	1726	671798756000	14364	7193	72	0	\N
116577	1726	671797753000	14364	7193	73	0	\N
116578	1726	671796752000	14364	7193	75	0	\N
116579	1726	671795750000	14364	7193	76	0	\N
116580	1726	671794747000	14364	7193	77	0	\N
116581	1726	671793746000	14364	7193	78	0	\N
116582	1726	671792744000	14364	7193	79	0	\N
116583	1726	671791741000	14364	7193	80	0	\N
116584	1726	671790740000	14364	7193	81	0	\N
116585	1726	671789738000	14364	7193	82	0	\N
116586	1726	671788735000	14364	7193	83	0	\N
116587	1726	671787734000	14364	7193	84	0	\N
116588	1726	671786732000	14364	7193	85	0	\N
116589	1726	671785729000	14364	7193	86	0	\N
116590	1726	671784728000	14364	7193	87	0	\N
116591	1726	671783726000	14364	7193	88	0	\N
116592	1726	671782723000	14364	7193	89	0	\N
116593	1726	671781722000	14364	7193	90	0	\N
116594	1726	671780720000	14364	7193	91	0	\N
116595	1726	671779717000	14364	7193	92	0	\N
116596	1726	671778716000	14364	7193	93	0	\N
116597	1726	671777714000	14364	7193	94	0	\N
116598	1726	671776711000	14364	7193	95	0	\N
116599	1726	671775710000	14364	7193	96	0	\N
116600	1726	671774708000	14364	7193	97	0	\N
116601	1726	671773705000	14364	7193	98	0	\N
116602	1726	671772704000	14364	7193	99	0	\N
116603	1726	671771702000	14364	7193	100	0	\N
116604	1726	671770699000	14364	7193	101	0	\N
116605	1726	671769698000	14364	7193	102	0	\N
116606	1726	671768696000	14364	7193	103	0	\N
116607	1726	671767693000	14364	7193	104	0	\N
116608	1726	671766692000	14364	7193	105	0	\N
116609	1726	671765690000	14364	7193	106	0	\N
116610	1726	671764687000	14364	7193	107	0	\N
116611	1726	671763686000	14364	7193	108	0	\N
116612	1726	671762684000	14364	7193	109	0	\N
116613	1726	671761681000	14364	7193	110	0	\N
116614	1726	670551681000	14364	7193	111	0	\N
116615	1726	669341681000	14364	7193	112	0	\N
116616	1726	669340680000	14364	7193	113	0	\N
116617	1726	669339678000	14364	7193	114	0	\N
116618	1726	668129678000	14364	7193	115	0	\N
116619	1726	668128675000	14364	7193	116	0	\N
116620	1726	668127674000	14364	7193	117	0	\N
116621	1726	668126672000	14364	7193	118	0	\N
116622	1726	668125669000	14364	7193	119	0	\N
116623	1726	668124668000	14364	7193	120	0	\N
116624	1726	668123666000	14364	7193	121	0	\N
116625	1726	668122663000	14364	7193	122	0	\N
116626	1726	668121662000	14364	7193	123	0	\N
116627	1726	668120660000	14364	7193	124	0	\N
116628	1726	668119657000	14364	7193	125	0	\N
116636	1397	1358902024000	14367	7332	0	0	\N
116637	1726	664040748000	14367	7332	1	0	\N
116638	1726	664039745000	14367	7332	2	0	\N
116639	1397	1358902024000	14368	7332	0	0	\N
116640	1726	664040748000	14368	7332	1	0	\N
116641	1726	664039745000	14368	7332	2	0	\N
116642	1397	1358902024000	14369	7332	0	0	\N
116643	1726	664040748000	14369	7332	1	0	\N
116644	1726	664039745000	14369	7332	2	0	\N
116645	1397	1358892023000	14370	7333	0	0	\N
116646	1726	664038743000	14370	7333	1	0	\N
116647	1726	664037740000	14370	7333	2	0	\N
116651	1397	1358882022000	14374	7334	0	0	\N
116652	1726	664036738000	14374	7334	1	0	\N
116653	1726	664035735000	14374	7334	2	0	\N
116654	1397	1360322166000	14376	7222	0	0	\N
116655	1693	16473490155041	14376	7222	1	0	\N
116656	1467	25903206035399	14376	7222	2	0	\N
116657	1467	19417301554450	14376	7222	3	0	\N
116658	1467	15041129307591	14376	7222	4	0	\N
116659	1467	2846554100039	14376	7222	5	0	\N
116660	1397	1360312165000	14376	7222	6	0	\N
116661	1397	1360302164000	14376	7222	7	0	\N
116662	1397	1360292163000	14376	7222	8	0	\N
116663	1397	1360282162000	14376	7222	9	0	\N
116664	1397	1360272161000	14376	7222	10	0	\N
116665	1397	1360262160000	14376	7222	11	0	\N
116666	1397	1360252159000	14376	7222	12	0	\N
116667	1397	1360242158000	14376	7222	13	0	\N
116668	1397	1360232157000	14376	7222	14	0	\N
116669	1397	1360222156000	14376	7222	15	0	\N
116670	1397	1360212155000	14376	7222	16	0	\N
116671	1397	1360202154000	14376	7222	17	0	\N
116672	1397	1360192153000	14376	7222	18	0	\N
116673	1397	1360182152000	14376	7222	19	0	\N
116674	1397	1360172151000	14376	7222	20	0	\N
116675	1397	1360162150000	14376	7222	21	0	\N
116676	1397	1360152149000	14376	7222	22	0	\N
116677	1397	1360142148000	14376	7222	23	0	\N
116678	1397	1360132147000	14376	7222	24	0	\N
116679	1397	1360122146000	14376	7222	25	0	\N
116680	1397	1360112145000	14376	7222	26	0	\N
116681	1397	1360102144000	14376	7222	27	0	\N
116682	1397	1360092143000	14376	7222	28	0	\N
116683	1397	1360082142000	14376	7222	29	0	\N
116684	1397	1360072141000	14376	7222	30	0	\N
116685	1397	1360062140000	14376	7222	31	0	\N
116686	1397	1360052139000	14376	7222	32	0	\N
116687	1397	1360042138000	14376	7222	33	0	\N
116688	1397	1360032137000	14376	7222	34	0	\N
116631	1726	665251750000	14365	7331	2	0	6950
116632	1726	664041750000	14365	7331	3	0	6951
116633	1397	1358902024000	14366	7332	0	0	7993
116634	1726	664040748000	14366	7332	1	0	6952
116635	1726	664039745000	14366	7332	2	0	6953
116649	1726	664038743000	14371	7333	1	0	6954
116650	1726	664037740000	14371	7333	2	0	6955
116689	1397	1360022136000	14376	7222	35	0	\N
116690	1397	1360012135000	14376	7222	36	0	\N
116691	1397	1360002134000	14376	7222	37	0	\N
116692	1397	1359992133000	14376	7222	38	0	\N
116693	1397	1359982132000	14376	7222	39	0	\N
116694	1397	1359972131000	14376	7222	40	0	\N
116695	1397	1359962130000	14376	7222	41	0	\N
116696	1397	1359952129000	14376	7222	42	0	\N
116697	1397	1359942128000	14376	7222	43	0	\N
116698	1397	1359932127000	14376	7222	44	0	\N
116699	1397	1359922126000	14376	7222	45	0	\N
116700	1397	1359912125000	14376	7222	46	0	\N
116701	1397	1359902124000	14376	7222	47	0	\N
116702	1397	1359892123000	14376	7222	48	0	\N
116703	1397	1359882122000	14376	7222	49	0	\N
116704	1397	1359872121000	14376	7222	50	0	\N
116705	1397	1359862120000	14376	7222	51	0	\N
116706	1397	1359852119000	14376	7222	52	0	\N
116707	1397	1359842118000	14376	7222	53	0	\N
116708	1397	1359832117000	14376	7222	54	0	\N
116709	1397	1359822116000	14376	7222	55	0	\N
116710	1397	1359812115000	14376	7222	56	0	\N
116711	1397	1359802114000	14376	7222	57	0	\N
116712	1397	1359792113000	14376	7222	58	0	\N
116713	1397	1359782112000	14376	7222	59	0	\N
116714	1397	1359772111000	14376	7222	60	0	\N
116715	1397	1359762110000	14376	7222	61	0	\N
116716	1397	1359752109000	14376	7222	62	0	\N
116717	1397	1359742108000	14376	7222	63	0	\N
116718	1397	1359732107000	14376	7222	64	0	\N
116719	1397	1359722106000	14376	7222	65	0	\N
116720	1397	1359712105000	14376	7222	66	0	\N
116721	1397	1359702104000	14376	7222	67	0	\N
116722	1397	1359692103000	14376	7222	68	0	\N
116723	1397	1359682102000	14376	7222	69	0	\N
116724	1397	1359672101000	14376	7222	70	0	\N
116725	1397	1359662100000	14376	7222	71	0	\N
116726	1397	1359652099000	14376	7222	72	0	\N
116727	1397	1359642098000	14376	7222	73	0	\N
116728	1397	1359632097000	14376	7222	74	0	\N
116729	1397	1359622096000	14376	7222	75	0	\N
116730	1397	1359612095000	14376	7222	76	0	\N
116731	1397	1359602094000	14376	7222	77	0	\N
116732	1397	1359592093000	14376	7222	78	0	\N
116733	1397	1359582092000	14376	7222	79	0	\N
116734	1397	1359572091000	14376	7222	80	0	\N
116735	1397	1359562090000	14376	7222	81	0	\N
116736	1397	1359552089000	14376	7222	82	0	\N
116737	1397	1359542088000	14376	7222	83	0	\N
116738	1397	1359532087000	14376	7222	84	0	\N
116739	1397	1359522086000	14376	7222	85	0	\N
116740	1397	1359512085000	14376	7222	86	0	\N
116741	1397	1359502084000	14376	7222	87	0	\N
116742	1397	1359492083000	14376	7222	88	0	\N
116743	1397	1359482082000	14376	7222	89	0	\N
116744	1397	1359472081000	14376	7222	90	0	\N
116745	1397	1359462080000	14376	7222	91	0	\N
116746	1397	1359452079000	14376	7222	92	0	\N
116747	1397	1359442078000	14376	7222	93	0	\N
116748	1397	1359432077000	14376	7222	94	0	\N
116749	1397	1359422076000	14376	7222	95	0	\N
116750	1397	1359412075000	14376	7222	96	0	\N
116751	1397	1359402074000	14376	7222	97	0	\N
116752	1397	1359392073000	14376	7222	98	0	\N
116753	1397	1359382072000	14376	7222	99	0	\N
116754	1397	1359372071000	14376	7222	100	0	\N
116755	1397	1359362070000	14376	7222	101	0	\N
116756	1397	1359352069000	14376	7222	102	0	\N
116757	1397	1359342068000	14376	7222	103	0	\N
116758	1397	1359332067000	14376	7222	104	0	\N
116759	1397	1359322066000	14376	7222	105	0	\N
116760	1397	1359312065000	14376	7222	106	0	\N
116761	1397	1359302064000	14376	7222	107	0	\N
116762	1397	1359292063000	14376	7222	108	0	\N
116763	1397	1359282062000	14376	7222	109	0	\N
116764	1397	1359272061000	14376	7222	110	0	\N
116765	1397	1359262060000	14376	7222	111	0	\N
116766	1397	1359252059000	14376	7222	112	0	\N
116767	1397	1359242058000	14376	7222	113	0	\N
116768	1397	1359232057000	14376	7222	114	0	\N
116769	1397	1359222056000	14376	7222	115	0	\N
116770	1397	1359212055000	14376	7222	117	0	\N
116771	1397	1359202054000	14376	7222	118	0	\N
116772	1397	1359192053000	14376	7222	119	0	\N
116773	1397	1359182052000	14376	7222	120	0	\N
116774	1397	1359172051000	14376	7222	121	0	\N
116775	1397	1359162050000	14376	7222	122	0	\N
116776	1397	1359152049000	14376	7222	123	0	\N
116777	1397	1359142048000	14376	7222	124	0	\N
116778	1397	1359132047000	14376	7222	125	0	\N
116779	1775	861300000	14377	7164	0	0	\N
116780	1775	849210000	14377	7164	1	0	\N
116781	2058	549500000	14377	7164	2	0	\N
116782	1397	1361062240000	14377	7164	3	0	\N
116783	1693	15753477155041	14377	7164	4	0	\N
116784	1397	1361052239000	14377	7164	5	0	\N
116785	1397	1361042238000	14377	7164	6	0	\N
116786	1397	1361032237000	14377	7164	7	0	\N
116787	1397	1361022236000	14377	7164	8	0	\N
116788	1467	25903206035399	14377	7164	9	0	\N
116789	1467	19417301554450	14377	7164	10	0	\N
116790	1467	15041129307591	14377	7164	11	0	\N
116791	1467	2846554100039	14377	7164	12	0	\N
116792	1397	1361012235000	14377	7164	13	0	\N
116793	1397	1361002234000	14377	7164	14	0	\N
116794	1397	1360992233000	14377	7164	15	0	\N
116795	1397	1360982232000	14377	7164	16	0	\N
116796	1397	1360972231000	14377	7164	17	0	\N
116797	1397	1360962230000	14377	7164	18	0	\N
116798	1397	1360952229000	14377	7164	19	0	\N
116799	1397	1360942228000	14377	7164	20	0	\N
116800	1397	1360932227000	14377	7164	21	0	\N
116801	1397	1360922226000	14377	7164	22	0	\N
116802	1397	1360912225000	14377	7164	23	0	\N
116803	1397	1360902224000	14377	7164	24	0	\N
116804	1397	1360892223000	14377	7164	25	0	\N
116805	1397	1360882222000	14377	7164	26	0	\N
116806	1397	1360872221000	14377	7164	27	0	\N
116807	1397	1360862220000	14377	7164	28	0	\N
116808	1397	1360852219000	14377	7164	29	0	\N
116809	1397	1360842218000	14377	7164	30	0	\N
116810	1397	1360832217000	14377	7164	31	0	\N
116811	1397	1360822216000	14377	7164	32	0	\N
116812	1397	1360812215000	14377	7164	33	0	\N
116813	1397	1360802214000	14377	7164	34	0	\N
116814	1397	1360792213000	14377	7164	35	0	\N
116815	1397	1360782212000	14377	7164	36	0	\N
116816	1397	1360772211000	14377	7164	37	0	\N
116817	1397	1360762210000	14377	7164	39	0	\N
116818	1397	1360752209000	14377	7164	40	0	\N
116819	1397	1360742208000	14377	7164	41	0	\N
116820	1397	1360732207000	14377	7164	42	0	\N
116821	1397	1360722206000	14377	7164	43	0	\N
116822	1397	1360712205000	14377	7164	44	0	\N
116823	1397	1360702204000	14377	7164	45	0	\N
116824	1397	1360692203000	14377	7164	46	0	\N
116825	1397	1360682202000	14377	7164	47	0	\N
116826	1397	1360672201000	14377	7164	48	0	\N
116827	1397	1360662200000	14377	7164	49	0	\N
116828	1397	1360652199000	14377	7164	50	0	\N
116829	1397	1360642198000	14377	7164	51	0	\N
116830	1397	1360632197000	14377	7164	52	0	\N
116831	1397	1360622196000	14377	7164	53	0	\N
116832	1397	1360612195000	14377	7164	54	0	\N
116833	1397	1360602194000	14377	7164	55	0	\N
116834	1397	1360592193000	14377	7164	56	0	\N
116835	1397	1360582192000	14377	7164	57	0	\N
116836	1397	1360572191000	14377	7164	58	0	\N
116837	1397	1360562190000	14377	7164	59	0	\N
116838	1397	1360552189000	14377	7164	60	0	\N
116839	1397	1360542188000	14377	7164	61	0	\N
116840	1397	1360532187000	14377	7164	62	0	\N
116841	1397	1360522186000	14377	7164	63	0	\N
116842	1397	1360512185000	14377	7164	64	0	\N
116843	1397	1360502184000	14377	7164	65	0	\N
116844	1397	1360492183000	14377	7164	66	0	\N
116849	1397	1358842018000	14379	7337	0	0	\N
116850	1726	664036738000	14379	7337	1	0	\N
116851	1726	664035735000	14379	7337	2	0	\N
116852	1726	664034733000	14379	7337	3	0	\N
116853	1726	664033730000	14379	7337	4	0	\N
116854	1726	664032728000	14379	7337	5	0	\N
116855	1726	664031725000	14379	7337	6	0	\N
116856	1726	664030723000	14379	7337	7	0	\N
116857	1726	664029720000	14379	7337	8	0	\N
116858	1726	664028718000	14379	7337	9	0	\N
116859	1726	664027715000	14379	7337	10	0	\N
116860	1397	1358842018000	14380	7337	0	0	\N
116881	1397	1358802014000	14384	7340	0	0	\N
116882	1397	1358792013000	14384	7340	1	0	\N
116883	1726	664020698000	14384	7340	2	0	\N
116884	1726	664019695000	14384	7340	3	0	\N
116885	1726	664018693000	14384	7340	4	0	\N
116886	1726	664017690000	14384	7340	5	0	\N
116896	1693	15033477155041	14388	7133	0	0	\N
116897	1467	25903206035399	14388	7133	1	0	\N
116898	1467	19417301554450	14388	7133	2	0	\N
116899	1467	15041129307591	14388	7133	3	0	\N
116900	1467	2846554100039	14388	7133	4	0	\N
116901	849	1155747211256640	14388	7133	5	0	\N
116919	1397	1358722006000	14391	7343	0	0	\N
116920	1726	664005660000	14391	7343	1	0	\N
116921	1726	664004658000	14391	7343	2	0	\N
116922	1397	1358722006000	14392	7343	0	0	\N
116932	1397	1358682002000	14397	7347	0	0	\N
116933	1726	663997640000	14397	7347	1	0	\N
116934	1397	1358682002000	14398	7347	0	0	\N
116935	1726	663997640000	14398	7347	1	0	\N
116936	1726	663996638000	14398	7347	2	0	\N
116940	1397	1358682002000	14400	7347	0	0	\N
116941	1726	663997640000	14400	7347	1	0	\N
116942	1726	663996638000	14400	7347	2	0	\N
116946	1397	1358662000000	14402	7349	0	0	\N
116947	1769	1702900000	14402	7349	1	0	\N
116948	1726	663993630000	14402	7349	2	0	\N
116949	1726	663992628000	14402	7349	3	0	\N
116954	1693	16473490155041	14404	7230	0	0	\N
116955	1467	25903206035399	14404	7230	1	0	\N
116956	1467	19417301554450	14404	7230	2	0	\N
116957	1467	15041129307591	14404	7230	3	0	\N
116958	1467	2846554100039	14404	7230	4	0	\N
116959	849	1155747211256640	14404	7230	5	0	\N
116960	1726	663991625000	14405	7350	0	0	\N
116847	1397	1358862020000	14378	7336	2	0	7997
116848	1397	1358852019000	14378	7336	3	0	7998
116861	1397	1358842018000	14381	7337	0	0	7999
116862	1726	664036738000	14381	7337	1	0	6956
116863	1726	664035735000	14381	7337	2	0	6957
116865	1726	664033730000	14381	7337	4	0	6959
116866	1726	664032728000	14381	7337	5	0	6960
116867	1726	664031725000	14381	7337	6	0	6961
116868	1726	664030723000	14381	7337	7	0	6962
116869	1726	664029720000	14381	7337	8	0	6963
116871	1726	664027715000	14381	7337	10	0	6965
116872	1397	1358832017000	14382	7338	0	0	8000
116873	1397	1358822016000	14382	7338	1	0	8001
116874	1726	664026713000	14382	7338	2	0	6966
116876	1726	664024708000	14382	7338	4	0	6968
116877	1726	664023705000	14382	7338	5	0	6969
116878	1397	1358812015000	14383	7339	0	0	8002
116879	1726	664022703000	14383	7339	1	0	6970
116880	1726	664021700000	14383	7339	2	0	6971
116888	1397	1358792013000	14385	7340	1	0	8004
116889	1726	664020698000	14385	7340	2	0	6972
116890	1726	664019695000	14385	7340	3	0	6973
116891	1726	664018693000	14385	7340	4	0	6974
116892	1726	664017690000	14385	7340	5	0	6975
116894	1726	664016688000	14386	7341	1	0	6976
116895	1726	664015685000	14386	7341	2	0	6977
116902	1397	1358772011000	14389	7342	0	0	8006
116903	1397	1358762010000	14389	7342	1	0	8007
116905	1397	1358742008000	14389	7342	3	0	8009
116906	1397	1358732007000	14389	7342	4	0	8010
116907	1726	664014683000	14389	7342	5	0	6978
116908	1726	664013680000	14389	7342	6	0	6979
116909	1726	664012678000	14389	7342	7	0	6980
116911	1726	664010673000	14389	7342	9	0	6982
116912	1726	664009670000	14389	7342	10	0	6983
116913	1726	664008668000	14389	7342	11	0	6984
116914	1726	664007665000	14389	7342	12	0	6985
116915	1726	664006663000	14389	7342	13	0	6986
116917	1726	664005660000	14390	7343	1	0	6987
116918	1726	664004658000	14390	7343	2	0	6988
116923	1397	1358712005000	14393	7344	0	0	8012
116924	1726	664003655000	14393	7344	1	0	6989
116926	1397	1358702004000	14394	7345	0	0	8013
116927	1726	664001650000	14394	7345	1	0	6991
116928	1726	664000648000	14394	7345	2	0	6992
116929	1397	1358692003000	14395	7346	0	0	8014
116930	1726	663999645000	14395	7346	1	0	6993
116937	1397	1358682002000	14399	7347	0	0	8015
116938	1726	663997640000	14399	7347	1	0	6995
116939	1726	663996638000	14399	7347	2	0	6996
116943	1397	1358672001000	14401	7348	0	0	8016
116944	1726	663995635000	14401	7348	1	0	6997
116950	1397	1358662000000	14403	7349	0	0	8017
116951	1769	1702900000	14403	7349	1	0	31
116952	1726	663993630000	14403	7349	2	0	6999
116953	1726	663992628000	14403	7349	3	0	7000
116961	1726	663990623000	14405	7350	1	0	\N
116962	1726	663991625000	14406	7350	0	0	\N
116963	1726	663990623000	14406	7350	1	0	\N
116966	1726	663991625000	14408	7350	0	0	\N
116967	1726	663990623000	14408	7350	1	0	\N
116968	1726	663991625000	14409	7350	0	0	\N
116969	1726	663990623000	14409	7350	1	0	\N
116970	1769	1702900000	14410	7134	0	0	\N
116989	1397	1358591993000	14414	7353	0	0	\N
116990	1397	1358581992000	14414	7353	1	0	\N
116991	1769	1701900000	14414	7353	2	0	\N
116992	1726	663983614000	14414	7353	3	0	\N
116993	1726	663982611000	14414	7353	4	0	\N
116994	1726	663981609000	14414	7353	5	0	\N
116995	1726	663980606000	14414	7353	6	0	\N
116996	1726	663979604000	14414	7353	7	0	\N
116997	1726	663978601000	14414	7353	8	0	\N
116998	1726	663977599000	14414	7353	9	0	\N
116999	1726	663976596000	14414	7353	10	0	\N
117000	1726	663975594000	14414	7353	11	0	\N
117001	1726	663974591000	14414	7353	12	0	\N
117015	1397	1358561990000	14417	7355	0	0	\N
117016	1726	663971586000	14417	7355	1	0	\N
117017	1726	663970583000	14417	7355	2	0	\N
117018	1397	1358561990000	14418	7355	0	0	\N
117020	1397	1358551989000	14420	7356	0	0	\N
117021	1397	1358541988000	14421	7357	0	0	\N
117022	1726	663969581000	14421	7357	1	0	\N
117023	1726	663968578000	14421	7357	2	0	\N
117024	1726	663967576000	14421	7357	3	0	\N
117025	1726	663966573000	14421	7357	4	0	\N
117036	1769	1702900000	14425	7231	0	0	\N
117037	1769	1701900000	14425	7231	1	0	\N
117042	1397	1358511985000	14427	7360	0	0	\N
117043	1726	663962563000	14427	7360	1	0	\N
117044	1726	663961561000	14427	7360	2	0	\N
117045	1726	663960560000	14427	7360	3	0	\N
117054	1397	1360482182000	14430	7166	0	0	\N
117055	1397	1360472181000	14430	7166	1	0	\N
117056	1397	1360462180000	14430	7166	2	0	\N
117057	1397	1360452179000	14430	7166	3	0	\N
117058	1397	1360442178000	14430	7166	4	0	\N
117059	1397	1360432177000	14430	7166	5	0	\N
117060	1397	1360422176000	14430	7166	6	0	\N
117061	1397	1360412175000	14430	7166	7	0	\N
117062	1397	1360402174000	14430	7166	8	0	\N
117063	1397	1360392173000	14430	7166	9	0	\N
117064	1397	1360382172000	14430	7166	10	0	\N
117065	1397	1360372171000	14430	7166	11	0	\N
117066	1397	1360362170000	14430	7166	12	0	\N
117067	1397	1360352169000	14430	7166	13	0	\N
117068	1397	1360342168000	14430	7166	14	0	\N
117069	1397	1360332167000	14430	7166	15	0	\N
117070	1397	1360322166000	14430	7166	16	0	\N
117071	1397	1360312165000	14430	7166	17	0	\N
117072	1397	1360302164000	14430	7166	18	0	\N
117073	1397	1360292163000	14430	7166	19	0	\N
117074	1397	1360282162000	14430	7166	20	0	\N
117075	1397	1360272161000	14430	7166	21	0	\N
117076	1397	1360262160000	14430	7166	22	0	\N
117077	1397	1360252159000	14430	7166	23	0	\N
117078	1397	1360242158000	14430	7166	24	0	\N
117079	1397	1360232157000	14430	7166	25	0	\N
117080	1397	1360222156000	14430	7166	26	0	\N
117081	1397	1360212155000	14430	7166	27	0	\N
117082	1397	1360202154000	14430	7166	28	0	\N
117083	1397	1360192153000	14430	7166	29	0	\N
117084	1397	1360182152000	14430	7166	30	0	\N
117085	1397	1360172151000	14430	7166	31	0	\N
117086	1397	1360162150000	14430	7166	32	0	\N
117087	1397	1360152149000	14430	7166	33	0	\N
117088	1397	1360142148000	14430	7166	34	0	\N
117089	1397	1360132147000	14430	7166	35	0	\N
117090	1397	1360122146000	14430	7166	36	0	\N
117091	1397	1360112145000	14430	7166	37	0	\N
117092	1397	1360102144000	14430	7166	38	0	\N
117093	1397	1360092143000	14430	7166	39	0	\N
117094	1397	1360082142000	14430	7166	40	0	\N
117095	1397	1360072141000	14430	7166	41	0	\N
117096	1397	1360062140000	14430	7166	42	0	\N
116971	1397	1358651999000	14411	7351	0	0	8018
116972	1397	1358641998000	14412	7352	0	0	8019
116973	1397	1358631997000	14412	7352	1	0	8020
116974	1397	1358621996000	14412	7352	2	0	8021
116975	1397	1358611995000	14412	7352	3	0	8022
116977	1726	663989622000	14412	7352	5	0	7003
116978	1726	663988621000	14412	7352	6	0	7004
116979	1726	663987620000	14412	7352	7	0	7005
116980	1726	663986619000	14412	7352	8	0	7006
116981	1726	663985617000	14412	7352	9	0	7007
116983	1397	1358591993000	14413	7353	0	0	8024
116984	1397	1358581992000	14413	7353	1	0	8025
116985	1769	1701900000	14413	7353	2	0	32
116986	1726	663983615000	14413	7353	3	0	7009
116988	1726	663981611000	14413	7353	5	0	7011
117002	1397	1358571991000	14415	7354	0	0	8026
117003	1726	663980608000	14415	7354	1	0	7012
117004	1726	663979606000	14415	7354	2	0	7013
117005	1726	663978603000	14415	7354	3	0	7014
117007	1726	663976598000	14415	7354	5	0	7016
117008	1726	663975596000	14415	7354	6	0	7017
117009	1726	663974593000	14415	7354	7	0	7018
117010	1726	663973591000	14415	7354	8	0	7019
117011	1726	663972588000	14415	7354	9	0	7020
117013	1726	663971586000	14416	7355	1	0	7021
117014	1726	663970583000	14416	7355	2	0	7022
117019	1397	1358551989000	14419	7356	0	0	8028
117026	1397	1358541988000	14422	7357	0	0	8029
117028	1726	663968578000	14422	7357	2	0	7024
117029	1726	663967576000	14422	7357	3	0	7025
117030	1726	663966573000	14422	7357	4	0	7026
117031	1397	1358531987000	14423	7358	0	0	8030
117032	1726	663965571000	14423	7358	1	0	7027
117034	1726	663964568000	14424	7359	1	0	7028
117035	1726	663963566000	14424	7359	2	0	7029
117038	1397	1358511985000	14426	7360	0	0	8032
117039	1726	663962563000	14426	7360	1	0	7030
117040	1726	663961561000	14426	7360	2	0	7031
117046	1397	1358501984000	14428	7361	0	0	8033
117047	1397	1358491983000	14428	7361	1	0	8034
117048	1726	663959557000	14428	7361	2	0	7033
117049	1726	663958555000	14428	7361	3	0	7034
117051	1726	663956551000	14428	7361	5	0	7036
117052	1726	663955549000	14428	7361	6	0	7037
117053	1726	663954548000	14428	7361	7	0	7038
117097	1397	1360052139000	14430	7166	43	0	\N
117098	1397	1360042138000	14430	7166	44	0	\N
117111	141	66000000000000	14433	7364	0	0	\N
117112	1397	1358451979000	14433	7364	1	0	\N
117113	1726	663944527000	14433	7364	2	0	\N
117114	1726	663943525000	14433	7364	3	0	\N
117115	1726	663942524000	14433	7364	4	0	\N
117128	1397	1358421976000	14436	7366	0	0	\N
117129	1726	663936512000	14436	7366	1	0	\N
117130	1726	663935509000	14436	7366	2	0	\N
117148	1397	1358371971000	14441	7370	0	0	\N
117149	1726	663924489000	14441	7370	1	0	\N
117150	1726	663923487000	14441	7370	2	0	\N
117151	1726	663922484000	14441	7370	3	0	\N
117159	1693	17913529155041	14444	7289	0	0	\N
117160	1769	1702900000	14444	7289	1	0	\N
117161	1769	1701900000	14444	7289	2	0	\N
117162	1726	666631091000	14444	7289	3	0	\N
117163	1726	666630089000	14444	7289	4	0	\N
117164	849	1155747211256640	14444	7289	5	0	\N
117165	1726	666629088000	14444	7289	6	0	\N
117166	1726	666628085000	14444	7289	7	0	\N
117167	1726	666627083000	14444	7289	8	0	\N
117168	1726	666626082000	14444	7289	9	0	\N
117172	1726	663917475000	14446	7373	0	0	\N
117173	1726	663916474000	14446	7373	1	0	\N
117174	1726	663915472000	14446	7373	2	0	\N
117184	1726	663908457000	14449	7375	0	0	\N
117185	1726	663907455000	14449	7375	1	0	\N
117191	1397	1358331967000	14452	7377	0	0	\N
117192	1726	663904447000	14452	7377	1	0	\N
117193	1726	663903445000	14452	7377	2	0	\N
117201	1397	1358321966000	14455	7378	0	0	\N
117202	1726	663902444000	14455	7378	1	0	\N
117203	1726	663901441000	14455	7378	2	0	\N
117204	1726	663900439000	14455	7378	3	0	\N
117224	1397	1358261960000	14459	7382	0	0	\N
117225	1726	663885409000	14459	7382	1	0	\N
117226	1726	663884408000	14459	7382	2	0	\N
117227	1726	663883405000	14459	7382	3	0	\N
117232	1397	1358251959000	14461	7383	0	0	\N
117101	1397	1358461980000	14432	7363	1	0	8037
117102	1726	663953545000	14432	7363	2	0	7039
117103	1726	663952543000	14432	7363	3	0	7040
117104	1726	663951542000	14432	7363	4	0	7041
117105	1726	663950539000	14432	7363	5	0	7042
117107	1726	663948536000	14432	7363	7	0	7044
117108	1726	663947533000	14432	7363	8	0	7045
117109	1726	663946531000	14432	7363	9	0	7046
117110	1726	663945530000	14432	7363	10	0	7047
117116	141	66000000000000	14434	7364	0	0	1
117118	1726	663944527000	14434	7364	2	0	7048
117119	1726	663943525000	14434	7364	3	0	7049
117120	1397	1358441978000	14435	7365	0	0	8039
117121	1397	1358431977000	14435	7365	1	0	8040
117123	1726	663941521000	14435	7365	3	0	7051
117124	1726	663940519000	14435	7365	4	0	7052
117125	1726	663939518000	14435	7365	5	0	7053
117126	1726	663938515000	14435	7365	6	0	7054
117127	1726	663937513000	14435	7365	7	0	7055
117132	1726	663936512000	14437	7366	1	0	7056
117133	1726	663935509000	14437	7366	2	0	7057
117134	1397	1358411975000	14438	7367	0	0	8042
117135	1726	663934508000	14438	7367	1	0	7058
117136	1726	663933506000	14438	7367	2	0	7059
117138	1397	1358401974000	14439	7368	0	0	8043
117139	1397	1358391973000	14439	7368	1	0	8044
117140	1726	663931502000	14439	7368	2	0	7061
117141	1726	663930501000	14439	7368	3	0	7062
117143	1726	663928496000	14439	7368	5	0	7064
117144	1397	1358381972000	14440	7369	0	0	8045
117145	1726	663927495000	14440	7369	1	0	7065
117146	1726	663926493000	14440	7369	3	0	7066
117147	1726	663925490000	14440	7369	4	0	7067
117153	1726	663924489000	14442	7370	1	0	7068
117154	1726	663923487000	14442	7370	2	0	7069
117155	1726	663922484000	14442	7370	3	0	7070
117156	1397	1358361970000	14443	7371	0	0	8047
117157	1726	663921483000	14443	7371	1	0	7071
117169	1397	1358351969000	14445	7372	0	0	8048
117170	1726	663919480000	14445	7372	1	0	7073
117171	1726	663918478000	14445	7372	2	0	7074
117175	1726	663917475000	14447	7373	0	0	7075
117177	1726	663915472000	14447	7373	2	0	7077
117178	1726	663914469000	14448	7374	0	0	7078
117179	1726	663913468000	14448	7374	1	0	7079
117180	1726	663912466000	14448	7374	2	0	7080
117181	1726	663911463000	14448	7374	3	0	7081
117183	1726	663909460000	14448	7374	5	0	7083
117186	1726	663908457000	14450	7375	0	0	7084
117187	1726	663907455000	14450	7375	1	0	7085
117188	1397	1358341968000	14451	7376	0	0	8049
117189	1726	663906452000	14451	7376	1	0	7086
117194	1397	1358331967000	14453	7377	0	0	8050
117195	1726	663904447000	14453	7377	1	0	7088
117196	1726	663903445000	14453	7377	2	0	7089
117197	1397	1358321966000	14454	7378	0	0	8051
117199	1726	663901441000	14454	7378	2	0	7091
117200	1726	663900439000	14454	7378	3	0	7092
117205	1397	1358311965000	14456	7379	0	0	8052
117206	1397	1358301964000	14456	7379	1	0	8053
117207	1726	663899438000	14456	7379	2	0	7093
117209	1726	663897433000	14456	7379	4	0	7095
117210	1726	663896432000	14456	7379	5	0	7096
117211	1726	663895429000	14456	7379	6	0	7097
117212	1726	663894427000	14456	7379	7	0	7098
117213	1397	1358291963000	14457	7380	0	0	8054
117215	1726	663892423000	14457	7380	2	0	7100
117216	1726	663891421000	14457	7380	3	0	7101
117217	1397	1358281962000	14458	7381	0	0	8055
117218	1397	1358271961000	14458	7381	1	0	8056
117220	1726	663889417000	14458	7381	3	0	7103
117221	1726	663888415000	14458	7381	4	0	7104
117222	1726	663887414000	14458	7381	5	0	7105
117223	1726	663886411000	14458	7381	6	0	7106
117228	1397	1358261960000	14460	7382	0	0	8057
117230	1726	663884408000	14460	7382	2	0	7108
117231	1726	663883405000	14460	7382	3	0	7109
117233	1726	663882403000	14461	7383	1	0	\N
117234	1726	663881402000	14461	7383	2	0	\N
117235	1726	663880399000	14461	7383	3	0	\N
117236	1397	1358251959000	14462	7383	0	0	\N
117237	1726	663882403000	14462	7383	1	0	\N
117238	1726	663881402000	14462	7383	2	0	\N
117239	1726	663880399000	14462	7383	3	0	\N
117244	1397	1358251959000	14464	7383	0	0	\N
117245	1726	663882403000	14464	7383	1	0	\N
117246	1726	663881402000	14464	7383	2	0	\N
117247	1726	663880399000	14464	7383	3	0	\N
117248	1397	1358251959000	14465	7383	0	0	\N
117257	1397	1358221956000	14467	7385	0	0	\N
117258	1726	663873385000	14467	7385	1	0	\N
117259	1726	663872384000	14467	7385	2	0	\N
117260	1726	663871381000	14467	7385	3	0	\N
117261	1397	1358221956000	14468	7385	0	0	\N
117262	1726	663873385000	14468	7385	1	0	\N
117263	1726	663872384000	14468	7385	2	0	\N
117264	1726	663871381000	14468	7385	3	0	\N
117269	1397	1358251959000	14470	7383	0	0	\N
117270	1397	1358241958000	14470	7383	1	0	\N
117271	1397	1358231957000	14470	7383	2	0	\N
117272	1397	1358221956000	14470	7383	3	0	\N
117273	1726	663882403000	14470	7383	4	0	\N
117274	1726	663881402000	14470	7383	5	0	\N
117275	1726	663880399000	14470	7383	6	0	\N
117276	1726	663879397000	14470	7383	7	0	\N
117277	1726	663878396000	14470	7383	8	0	\N
117278	1726	663877393000	14470	7383	9	0	\N
117279	1726	663876391000	14470	7383	10	0	\N
117280	1726	663875390000	14470	7383	11	0	\N
117281	1726	663874387000	14470	7383	12	0	\N
117282	1726	663873385000	14470	7383	13	0	\N
117283	1726	663872384000	14470	7383	14	0	\N
117284	1726	663871381000	14470	7383	15	0	\N
117288	1397	1358201954000	14472	7387	0	0	\N
117308	141	66000000000000	14475	7351	0	0	\N
117309	1397	1358191953000	14477	7388	0	0	\N
117310	1397	1358181952000	14477	7388	1	0	\N
117311	1397	1358171951000	14477	7388	2	0	\N
117312	1397	1358161950000	14477	7388	3	0	\N
117313	1726	663865369000	14477	7388	4	0	\N
117322	1397	1358151949000	14479	7389	0	0	\N
117323	1397	1358141948000	14479	7389	1	0	\N
117324	1726	663854348000	14479	7389	2	0	\N
117325	1726	663853346000	14479	7389	3	0	\N
117326	1726	663852343000	14479	7389	4	0	\N
117327	1726	663851342000	14479	7389	5	0	\N
117328	1726	663850340000	14479	7389	6	0	\N
117329	1726	663849337000	14479	7389	7	0	\N
117342	1397	1358101944000	14481	7391	0	0	\N
117343	1726	663839317000	14481	7391	1	0	\N
117344	1726	663838316000	14481	7391	2	0	\N
117345	1726	663837313000	14481	7391	3	0	\N
117346	1397	1358101944000	14483	7391	0	0	\N
117352	1397	1358091943000	14486	7392	0	0	\N
117353	1726	663836311000	14486	7392	1	0	\N
117354	1726	663835310000	14486	7392	2	0	\N
117355	1726	663834307000	14486	7392	3	0	\N
117356	1397	1358091943000	14487	7392	0	0	\N
117357	1726	663836311000	14487	7392	1	0	\N
117358	1726	663835310000	14487	7392	2	0	\N
117359	1726	663834307000	14487	7392	3	0	\N
117360	1693	16473490155041	14488	7252	0	0	\N
117361	1467	25903206035399	14488	7252	1	0	\N
117362	1467	19417301554450	14488	7252	2	0	\N
117363	1467	15041129307591	14488	7252	3	0	\N
117364	1467	2846554100039	14488	7252	4	0	\N
117365	1769	1702900000	14488	7252	5	0	\N
117366	1769	1701900000	14488	7252	6	0	\N
117367	849	1155747211256640	14488	7252	7	0	\N
117242	1726	663881402000	14463	7383	2	0	7111
117243	1726	663880399000	14463	7383	3	0	7112
117249	1397	1358241958000	14466	7384	0	0	8059
117250	1397	1358231957000	14466	7384	1	0	8060
117251	1726	663879397000	14466	7384	2	0	7113
117253	1726	663877393000	14466	7384	4	0	7115
117254	1726	663876391000	14466	7384	5	0	7116
117255	1726	663875390000	14466	7384	6	0	7117
117256	1726	663874387000	14466	7384	7	0	7118
117265	1397	1358221956000	14469	7385	0	0	8061
117267	1726	663872384000	14469	7385	2	0	7120
117268	1726	663871381000	14469	7385	3	0	7121
117285	1397	1358211955000	14471	7386	0	0	8062
117286	1726	663870379000	14471	7386	1	0	7122
117289	1397	1358201954000	14473	7387	0	0	8063
117290	1726	663868375000	14473	7387	1	0	7124
117291	1726	663867373000	14473	7387	2	0	7125
117292	1726	663866372000	14473	7387	3	0	7126
117293	1397	1358191953000	14474	7388	0	0	8064
117295	1397	1358171951000	14474	7388	2	0	8066
117296	1397	1358161950000	14474	7388	3	0	8067
117297	1726	663865369000	14474	7388	4	0	7127
117298	1726	663864367000	14474	7388	5	0	7128
117299	1726	663863366000	14474	7388	6	0	7129
117301	1726	663861361000	14474	7388	8	0	7131
117302	1726	663860360000	14474	7388	9	0	7132
117303	1726	663859357000	14474	7388	11	0	7133
117304	1726	663858355000	14474	7388	12	0	7134
117306	1726	663856352000	14474	7388	14	0	7136
117307	1726	663855349000	14474	7388	15	0	7137
117314	1397	1358151949000	14478	7389	0	0	8068
117315	1397	1358141948000	14478	7389	1	0	8069
117316	1726	663854348000	14478	7389	2	0	7138
117318	1726	663852343000	14478	7389	4	0	7140
117319	1726	663851342000	14478	7389	5	0	7141
117320	1726	663850340000	14478	7389	6	0	7142
117321	1726	663849337000	14478	7389	7	0	7143
117330	1397	1358131947000	14480	7390	0	0	8070
117332	1397	1358111945000	14480	7390	2	0	8072
117333	1726	663848335000	14480	7390	3	0	7144
117334	1726	663847334000	14480	7390	4	0	7145
117335	1726	663846331000	14480	7390	5	0	7146
117337	1726	663844328000	14480	7390	7	0	7148
117338	1726	663843325000	14480	7390	8	0	7149
117339	1726	663842323000	14480	7390	9	0	7150
117340	1726	663841322000	14480	7390	10	0	7151
117341	1726	663840319000	14480	7390	11	0	7152
117348	1726	663839317000	14484	7391	1	0	7153
117349	1726	663838316000	14484	7391	2	0	7154
117350	1726	663837313000	14484	7391	3	0	7155
117351	1397	1358091943000	14485	7392	0	0	8074
117368	1397	1358081942000	14489	7393	0	0	8075
117375	1397	1358031937000	14490	7394	0	0	\N
117376	1726	663834307000	14490	7394	1	0	\N
117377	1726	663833306000	14490	7394	2	0	\N
117378	1726	663832304000	14490	7394	3	0	\N
117379	1726	663831301000	14490	7394	4	0	\N
117380	1726	663830299000	14490	7394	5	0	\N
117381	1726	663829298000	14490	7394	6	0	\N
117382	1726	663828295000	14490	7394	7	0	\N
117383	1726	663827293000	14490	7394	8	0	\N
117384	1726	663826292000	14490	7394	9	0	\N
117385	1726	663825289000	14490	7394	10	0	\N
117386	1726	663824287000	14490	7394	11	0	\N
117387	1726	663823286000	14490	7394	12	0	\N
117388	1726	663822283000	14490	7394	13	0	\N
117389	1726	663821281000	14490	7394	14	0	\N
117390	1726	663820280000	14490	7394	15	0	\N
117391	1726	663819277000	14490	7394	16	0	\N
117409	141	66000000000000	14492	7239	0	0	\N
117410	1397	1358912025000	14492	7239	1	0	\N
117411	1397	1358902024000	14492	7239	2	0	\N
117412	1397	1358892023000	14492	7239	3	0	\N
117413	1397	1358882022000	14492	7239	4	0	\N
117414	1397	1358872021000	14492	7239	5	0	\N
117415	1397	1358862020000	14492	7239	6	0	\N
117416	1397	1358852019000	14492	7239	7	0	\N
117417	1397	1358842018000	14492	7239	8	0	\N
117418	1397	1358832017000	14492	7239	9	0	\N
117419	1397	1358822016000	14492	7239	10	0	\N
117420	1397	1358812015000	14492	7239	11	0	\N
117421	1397	1358802014000	14492	7239	13	0	\N
117422	1397	1358792013000	14492	7239	14	0	\N
117423	1397	1358782012000	14492	7239	15	0	\N
117424	1397	1358772011000	14492	7239	16	0	\N
117425	1397	1358762010000	14492	7239	17	0	\N
117426	1397	1358752009000	14492	7239	18	0	\N
117427	1397	1358742008000	14492	7239	19	0	\N
117428	1397	1358732007000	14492	7239	20	0	\N
117429	1397	1358722006000	14492	7239	21	0	\N
117430	1397	1358712005000	14492	7239	22	0	\N
117431	1397	1358702004000	14492	7239	23	0	\N
117432	1397	1358692003000	14492	7239	24	0	\N
117433	1397	1358682002000	14492	7239	25	0	\N
117434	1397	1358672001000	14492	7239	26	0	\N
117435	1397	1358662000000	14492	7239	27	0	\N
117436	1397	1358651999000	14492	7239	28	0	\N
117437	1397	1358641998000	14492	7239	29	0	\N
117438	1397	1358631997000	14492	7239	30	0	\N
117439	1397	1358621996000	14492	7239	31	0	\N
117440	1397	1358611995000	14492	7239	32	0	\N
117441	1397	1358601994000	14492	7239	33	0	\N
117442	1397	1358591993000	14492	7239	34	0	\N
117443	1397	1358581992000	14492	7239	35	0	\N
117444	1397	1358571991000	14492	7239	36	0	\N
117445	1397	1358561990000	14492	7239	37	0	\N
117446	1397	1358551989000	14492	7239	38	0	\N
117447	1397	1358541988000	14492	7239	39	0	\N
117448	1397	1358531987000	14492	7239	40	0	\N
117449	1397	1358521986000	14492	7239	41	0	\N
117450	1397	1358511985000	14492	7239	42	0	\N
117451	1397	1358501984000	14492	7239	43	0	\N
117452	1397	1358491983000	14492	7239	44	0	\N
117453	1397	1358481982000	14492	7239	45	0	\N
117454	1397	1358021936000	14493	7395	0	0	\N
117455	1726	663818275000	14493	7395	1	0	\N
117456	1726	663817274000	14493	7395	2	0	\N
117457	1726	663816271000	14493	7395	3	0	\N
117462	1397	1358021936000	14495	7395	0	0	\N
117463	1726	663818275000	14495	7395	1	0	\N
117464	1726	663817274000	14495	7395	2	0	\N
117465	1726	663816271000	14495	7395	3	0	\N
117466	141	66000000000000	14496	7228	0	0	\N
117467	1769	1702900000	14496	7228	1	0	\N
117468	1769	1701900000	14496	7228	2	0	\N
117469	1397	1358011935000	14497	7396	0	0	\N
117470	1726	663815269000	14497	7396	1	0	\N
117471	1726	663814268000	14497	7396	2	0	\N
117472	1397	1358011935000	14498	7396	0	0	\N
117475	1397	1358011935000	14500	7397	0	0	\N
117476	1397	1358001934000	14500	7397	1	0	\N
117477	1397	1357991933000	14500	7397	2	0	\N
117478	1397	1358011935000	14501	7397	0	0	\N
117479	1397	1358001934000	14501	7397	1	0	\N
117480	1397	1357991933000	14501	7397	2	0	\N
117481	1726	663813265000	14501	7397	3	0	\N
117482	1726	663812263000	14501	7397	4	0	\N
117483	1726	663811262000	14501	7397	5	0	\N
117484	1726	663810259000	14501	7397	6	0	\N
117485	1726	663809258000	14501	7397	7	0	\N
117495	1397	1357981932000	14504	7398	0	0	\N
117496	1726	663808255000	14504	7398	1	0	\N
117497	1726	663807253000	14504	7398	2	0	\N
117498	1726	663806252000	14504	7398	3	0	\N
117371	1397	1358051939000	14489	7393	3	0	8078
117372	1397	1358041938000	14489	7393	4	0	8079
117373	1726	663836311000	14489	7393	5	0	7156
117374	1726	663835310000	14489	7393	6	0	7157
117392	1397	1358031937000	14491	7394	0	0	8080
117394	1726	663833306000	14491	7394	2	0	7159
117395	1726	663832304000	14491	7394	3	0	7160
117396	1726	663831301000	14491	7394	4	0	7161
117397	1726	663830299000	14491	7394	5	0	7162
117398	1726	663829298000	14491	7394	6	0	7163
117400	1726	663827293000	14491	7394	8	0	7165
117401	1726	663826292000	14491	7394	9	0	7166
117402	1726	663825289000	14491	7394	10	0	7167
117403	1726	663824287000	14491	7394	11	0	7168
117405	1726	663822283000	14491	7394	13	0	7170
117406	1726	663821281000	14491	7394	14	0	7171
117407	1726	663820280000	14491	7394	15	0	7172
117408	1726	663819277000	14491	7394	16	0	7173
117458	1397	1358021936000	14494	7395	0	0	8081
117460	1726	663817274000	14494	7395	2	0	7175
117461	1726	663816271000	14494	7395	3	0	7176
117473	1726	663815269000	14499	7396	0	0	7177
117474	1726	663814268000	14499	7396	1	0	7178
117486	1397	1358011935000	14502	7397	0	0	8082
117488	1397	1357991933000	14502	7397	2	0	8084
117489	1726	663813265000	14502	7397	3	0	7179
117490	1726	663812263000	14502	7397	4	0	7180
117491	1726	663811262000	14502	7397	5	0	7181
117493	1726	663809258000	14502	7397	7	0	7183
117494	1397	1357981932000	14503	7398	0	0	8085
117499	1397	1357971931000	14505	7399	0	0	8086
117500	1397	1357961930000	14505	7399	1	0	8087
117501	1397	1357951929000	14505	7399	2	0	8088
117503	1726	663808255000	14505	7399	4	0	7184
117504	1726	663807253000	14505	7399	5	0	7185
117531	1397	1357891923000	14509	7402	0	0	\N
117539	1397	1357891923000	14511	7402	0	0	\N
117540	1726	663784208000	14511	7402	1	0	\N
117541	1726	663783207000	14511	7402	2	0	\N
117542	1726	663782204000	14511	7402	3	0	\N
117543	1726	663781202000	14511	7402	4	0	\N
117544	1726	663780201000	14511	7402	5	0	\N
117545	1726	663779198000	14511	7402	6	0	\N
117546	1397	1357881922000	14512	7403	0	0	\N
117547	1397	1357871921000	14512	7403	1	0	\N
117548	1726	663778197000	14512	7403	2	0	\N
117549	1726	663777195000	14512	7403	3	0	\N
117550	1726	663776192000	14512	7403	4	0	\N
117551	1726	663775191000	14512	7403	5	0	\N
117558	1397	1357881922000	14514	7403	0	0	\N
117559	1397	1357871921000	14514	7403	1	0	\N
117560	1726	663778196000	14514	7403	2	0	\N
117561	1726	663777194000	14514	7403	3	0	\N
117562	1726	663776191000	14514	7403	4	0	\N
117563	1726	663775190000	14514	7403	5	0	\N
117564	1397	1357881922000	14515	7403	0	0	\N
117565	1397	1357871921000	14515	7403	1	0	\N
117566	1726	663778196000	14515	7403	2	0	\N
117567	1726	663777194000	14515	7403	3	0	\N
117568	1726	663776191000	14515	7403	4	0	\N
117569	1726	663775190000	14515	7403	5	0	\N
117570	1397	1357861920000	14516	7404	0	0	\N
117571	1726	663774188000	14516	7404	1	0	\N
117572	1397	1357861920000	14517	7404	0	0	\N
117573	1726	663774188000	14517	7404	1	0	\N
117574	1397	1357861920000	14518	7404	0	0	\N
117575	1726	663774188000	14518	7404	1	0	\N
117601	1397	1357771911000	14526	7410	0	0	\N
117602	1726	663758149000	14526	7410	1	0	\N
117603	1397	1357771911000	14527	7410	0	0	\N
117604	1726	663758149000	14527	7410	1	0	\N
117605	1397	1357771911000	14528	7410	0	0	\N
117606	1726	663758149000	14528	7410	1	0	\N
117609	1397	1357761910000	14530	7411	0	0	\N
117610	1726	663757147000	14530	7411	1	0	\N
117613	1397	1357751909000	14533	7412	0	0	\N
117614	1726	663756145000	14533	7412	1	0	\N
117617	1397	1357751909000	14535	7412	0	0	\N
117618	1726	663756145000	14535	7412	1	0	\N
117638	1397	1357661900000	14541	7418	0	0	\N
117639	1397	1357651899000	14541	7418	1	0	\N
117640	1726	663744117000	14541	7418	2	0	\N
117507	1726	663804247000	14505	7399	8	0	7188
117508	1726	663803246000	14505	7399	9	0	7189
117509	1726	663802243000	14505	7399	10	0	7190
117510	1726	663801241000	14505	7399	11	0	7191
117511	1726	663800240000	14505	7399	12	0	7192
117513	1726	663798235000	14505	7399	14	0	7194
117514	1726	663797234000	14505	7399	15	0	7195
117515	1726	663796231000	14505	7399	16	0	7196
117516	1726	663795229000	14505	7399	17	0	7197
117517	1726	663794228000	14505	7399	18	0	7198
117519	1397	1357921926000	14506	7400	1	0	8091
117520	1726	663793225000	14506	7400	2	0	7199
117521	1726	663792223000	14506	7400	3	0	7200
117522	1726	663791222000	14506	7400	4	0	7201
117524	1726	663789217000	14506	7400	6	0	7203
117525	1726	663788216000	14506	7400	7	0	7204
117526	1397	1357911925000	14507	7401	0	0	8092
117527	1397	1357901924000	14507	7401	1	0	8093
117528	1726	663787214000	14507	7401	2	0	7205
117530	1726	663785210000	14507	7401	4	0	7207
117532	1397	1357891923000	14510	7402	0	0	8094
117533	1726	663784208000	14510	7402	1	0	7208
117534	1726	663783207000	14510	7402	2	0	7209
117535	1726	663782204000	14510	7402	3	0	7210
117537	1726	663780201000	14510	7402	5	0	7212
117538	1726	663779198000	14510	7402	6	0	7213
117552	1397	1357881922000	14513	7403	0	0	8095
117553	1397	1357871921000	14513	7403	1	0	8096
117555	1726	663777194000	14513	7403	3	0	7215
117556	1726	663776191000	14513	7403	4	0	7216
117557	1726	663775190000	14513	7403	5	0	7217
117576	1397	1357861920000	14520	7404	0	0	8097
117577	1726	663774188000	14520	7404	1	0	7218
117579	1397	1357841918000	14521	7405	1	0	8099
117580	1726	663773186000	14521	7405	2	0	7219
117581	1726	663772183000	14521	7405	3	0	7220
117582	1726	663771181000	14521	7405	4	0	7221
117583	1726	663770178000	14521	7405	5	0	7222
117585	1726	663769176000	14522	7406	1	0	7223
117586	1726	663768173000	14522	7406	2	0	7224
117587	1397	1357821916000	14523	7407	0	0	8101
117588	1726	663767171000	14523	7407	1	0	7225
117590	1397	1357801914000	14524	7408	1	0	8103
117591	1726	663766169000	14524	7408	2	0	7226
117592	1726	663765166000	14524	7408	3	0	7227
117593	1726	663764164000	14524	7408	4	0	7228
117594	1726	663763161000	14524	7408	5	0	7229
117596	1397	1357781912000	14525	7409	1	0	8105
117597	1726	663762159000	14525	7409	2	0	7230
117598	1726	663761156000	14525	7409	3	0	7231
117599	1726	663760154000	14525	7409	4	0	7232
117600	1726	663759151000	14525	7409	5	0	7233
117608	1726	663758149000	14529	7410	1	0	7234
117611	1397	1357761910000	14531	7411	0	0	8107
117612	1726	663757147000	14531	7411	1	0	7235
117615	1397	1357751909000	14534	7412	0	0	8108
117619	1397	1357741908000	14536	7413	0	0	8109
117620	1726	663755143000	14536	7413	1	0	7237
117621	1397	1357731907000	14537	7414	0	0	8110
117622	1397	1357721906000	14537	7414	1	0	8111
117623	1726	663754141000	14537	7414	2	0	7238
117625	1397	1357711905000	14538	7415	0	0	8112
117626	1397	1357701904000	14538	7415	1	0	8113
117627	1726	663752137000	14538	7415	2	0	7240
117628	1726	663751135000	14538	7415	3	0	7241
117629	1397	1357691903000	14539	7416	0	0	8114
117631	1726	663750132000	14539	7416	2	0	7242
117632	1726	663749130000	14539	7416	3	0	7243
117633	1726	663748127000	14539	7416	4	0	7244
117634	1726	663747125000	14539	7416	5	0	7245
117636	1726	663746122000	14540	7417	1	0	7246
117637	1726	663745120000	14540	7417	2	0	7247
117641	1726	663743115000	14541	7418	3	0	\N
117642	1726	663742112000	14541	7418	4	0	\N
117643	1726	663741110000	14541	7418	5	0	\N
117644	1397	1357661900000	14542	7418	0	0	\N
117645	1397	1357651899000	14542	7418	1	0	\N
117646	1726	663744117000	14542	7418	2	0	\N
117647	1726	663743115000	14542	7418	3	0	\N
117648	1726	663742112000	14542	7418	4	0	\N
117649	1726	663741110000	14542	7418	5	0	\N
117658	1397	1357631897000	14545	7420	0	0	\N
117659	1397	1357621896000	14545	7420	1	0	\N
117660	1726	663739104000	14545	7420	2	0	\N
117661	1726	663738102000	14545	7420	3	0	\N
117678	1397	1357611895000	14548	7421	0	0	\N
117679	1397	1357601894000	14548	7421	1	0	\N
117680	1397	1357591893000	14548	7421	2	0	\N
117681	1397	1357581892000	14548	7421	3	0	\N
117682	1726	663737099000	14548	7421	4	0	\N
117683	1726	663736097000	14548	7421	5	0	\N
117684	1726	663735094000	14548	7421	6	0	\N
117685	1726	663734092000	14548	7421	7	0	\N
117686	1726	663733089000	14548	7421	8	0	\N
117687	1726	663732087000	14548	7421	9	0	\N
117688	1726	663731084000	14548	7421	10	0	\N
117689	1726	663730082000	14548	7421	11	0	\N
117690	647	66234984938283	14550	7422	0	0	\N
117691	1397	1357571891000	14550	7422	1	0	\N
117692	1397	1357561890000	14550	7422	2	0	\N
117693	1397	1357551889000	14550	7422	3	0	\N
117694	1726	663729079000	14550	7422	4	0	\N
117695	1726	663728077000	14550	7422	5	0	\N
117696	1726	663727074000	14550	7422	6	0	\N
117697	1726	663726072000	14550	7422	7	0	\N
117698	1726	663725069000	14550	7422	8	0	\N
117699	1726	663724067000	14550	7422	9	0	\N
117700	647	66234984938283	14551	7422	0	0	\N
117701	1397	1357571891000	14551	7422	1	0	\N
117702	1397	1357561890000	14551	7422	2	0	\N
117703	1397	1357551889000	14551	7422	3	0	\N
117704	1726	663729079000	14551	7422	4	0	\N
117705	1726	663728077000	14551	7422	5	0	\N
117706	1726	663727074000	14551	7422	6	0	\N
117707	1726	663726072000	14551	7422	7	0	\N
117708	1726	663725069000	14551	7422	8	0	\N
117709	1726	663724067000	14551	7422	9	0	\N
117720	1397	1357541888000	14553	7423	0	0	\N
117721	1726	663723064000	14553	7423	1	0	\N
117722	1726	663722062000	14553	7423	2	0	\N
117723	1397	1357541888000	14554	7423	0	0	\N
117724	1726	663723064000	14554	7423	1	0	\N
117725	1726	663722062000	14554	7423	2	0	\N
117729	1397	1357541888000	14556	7423	0	0	\N
117730	1726	663723064000	14556	7423	1	0	\N
117731	1726	663722062000	14556	7423	2	0	\N
117732	1397	1357541888000	14557	7423	0	0	\N
117733	1726	663723064000	14557	7423	1	0	\N
117734	1726	663722062000	14557	7423	2	0	\N
117743	647	66234984938283	14562	7384	0	0	\N
117744	1397	1358211955000	14562	7384	1	0	\N
117745	1397	1358201954000	14562	7384	2	0	\N
117746	1397	1358191953000	14562	7384	3	0	\N
117747	1397	1358181952000	14562	7384	4	0	\N
117748	1397	1358171951000	14562	7384	5	0	\N
117749	1397	1358161950000	14562	7384	6	0	\N
117750	1397	1358151949000	14562	7384	7	0	\N
117751	1397	1358141948000	14562	7384	8	0	\N
117752	1397	1358131947000	14562	7384	9	0	\N
117753	1397	1358121946000	14562	7384	10	0	\N
117754	1397	1358111945000	14562	7384	11	0	\N
117755	1397	1358101944000	14562	7384	12	0	\N
117756	1397	1358091943000	14562	7384	13	0	\N
117757	1397	1358081942000	14562	7384	14	0	\N
117758	1397	1358071941000	14562	7384	15	0	\N
117759	1397	1358061940000	14562	7384	16	0	\N
117760	1397	1358051939000	14562	7384	17	0	\N
117761	1397	1358041938000	14562	7384	18	0	\N
117762	1397	1358031937000	14562	7384	19	0	\N
117763	1397	1358021936000	14562	7384	20	0	\N
117764	1397	1358011935000	14562	7384	21	0	\N
117765	1397	1358001934000	14562	7384	22	0	\N
117766	1397	1357991933000	14562	7384	23	0	\N
117767	1397	1357981932000	14562	7384	24	0	\N
117768	1397	1357971931000	14562	7384	26	0	\N
117769	1397	1357961930000	14562	7384	27	0	\N
117770	1397	1357951929000	14562	7384	28	0	\N
117771	1397	1357941928000	14562	7384	29	0	\N
117772	1397	1357931927000	14562	7384	30	0	\N
117773	1397	1357921926000	14562	7384	31	0	\N
117774	1397	1357911925000	14562	7384	32	0	\N
117775	1397	1357901924000	14562	7384	33	0	\N
117776	1397	1357891923000	14562	7384	34	0	\N
117652	1726	663744117000	14543	7418	2	0	7248
117653	1726	663743115000	14543	7418	3	0	7249
117654	1726	663742112000	14543	7418	4	0	7250
117655	1726	663741110000	14543	7418	5	0	7251
117656	1397	1357641898000	14544	7419	0	0	8119
117662	1397	1357631897000	14546	7420	0	0	8120
117663	1397	1357621896000	14546	7420	1	0	8121
117664	1726	663739104000	14546	7420	2	0	7253
117665	1726	663738102000	14546	7420	3	0	7254
117666	1397	1357611895000	14547	7421	0	0	8122
117668	1397	1357591893000	14547	7421	2	0	8124
117669	1397	1357581892000	14547	7421	3	0	8125
117670	1726	663737099000	14547	7421	4	0	7255
117671	1726	663736097000	14547	7421	5	0	7256
117673	1726	663734092000	14547	7421	7	0	7258
117674	1726	663733089000	14547	7421	8	0	7259
117675	1726	663732087000	14547	7421	9	0	7260
117676	1726	663731084000	14547	7421	10	0	7261
117677	1726	663730082000	14547	7421	11	0	7262
117711	1397	1357571891000	14552	7422	1	0	8126
117712	1397	1357561890000	14552	7422	2	0	8127
117713	1397	1357551889000	14552	7422	3	0	8128
117714	1726	663729079000	14552	7422	4	0	7263
117715	1726	663728077000	14552	7422	5	0	7264
117717	1726	663726072000	14552	7422	7	0	7266
117718	1726	663725069000	14552	7422	8	0	7267
117719	1726	663724067000	14552	7422	9	0	7268
117726	1397	1357541888000	14555	7423	0	0	8129
117728	1726	663722062000	14555	7423	2	0	7270
117735	1397	1357531887000	14558	7424	0	0	8130
117736	647	66000000000000	14558	7424	1	0	2
117737	1726	663721059000	14558	7424	2	0	7271
117738	1397	1357521886000	14559	7425	0	0	8131
117740	1726	663719054000	14559	7425	2	0	7273
117741	1397	1357511885000	14561	7426	0	0	8132
117742	1726	663718051000	14561	7426	1	0	7274
117777	1397	1357881922000	14562	7384	35	0	\N
117778	1397	1357871921000	14562	7384	36	0	\N
117779	1397	1357861920000	14562	7384	37	0	\N
117780	1397	1357851919000	14562	7384	38	0	\N
117781	1397	1357841918000	14562	7384	39	0	\N
117782	1397	1357831917000	14562	7384	40	0	\N
117783	1397	1357821916000	14562	7384	41	0	\N
117784	1397	1357811915000	14562	7384	42	0	\N
117785	1397	1357801914000	14562	7384	43	0	\N
117786	1397	1357791913000	14562	7384	44	0	\N
117787	1397	1357781912000	14562	7384	45	0	\N
117788	1397	1357771911000	14562	7384	46	0	\N
117789	1397	1357761910000	14562	7384	47	0	\N
117790	1397	1357751909000	14562	7384	48	0	\N
117791	1397	1357741908000	14562	7384	49	0	\N
117792	1397	1357731907000	14562	7384	50	0	\N
117793	1397	1357721906000	14562	7384	51	0	\N
117794	1397	1357711905000	14562	7384	52	0	\N
117795	1397	1357701904000	14562	7384	53	0	\N
117796	1397	1357691903000	14562	7384	54	0	\N
117797	1397	1357681902000	14562	7384	55	0	\N
117798	1397	1357671901000	14562	7384	56	0	\N
117799	1397	1357661900000	14562	7384	57	0	\N
117800	1397	1357651899000	14562	7384	58	0	\N
117801	1397	1357641898000	14562	7384	59	0	\N
117802	1397	1357631897000	14562	7384	60	0	\N
117803	1397	1357621896000	14562	7384	61	0	\N
117804	1397	1357611895000	14562	7384	62	0	\N
117805	1397	1357601894000	14562	7384	63	0	\N
117806	1397	1357591893000	14562	7384	64	0	\N
117807	1397	1357581892000	14562	7384	65	0	\N
117808	1397	1357571891000	14562	7384	66	0	\N
117809	1397	1357561890000	14562	7384	67	0	\N
117810	1397	1357551889000	14562	7384	68	0	\N
117811	1397	1357541888000	14562	7384	69	0	\N
117812	1397	1357531887000	14562	7384	70	0	\N
117813	1397	1357521886000	14562	7384	71	0	\N
117814	1397	1357511885000	14562	7384	72	0	\N
117815	647	66000000000000	14562	7384	73	0	\N
117816	1726	663870379000	14562	7384	74	0	\N
117817	1726	663869378000	14562	7384	75	0	\N
117818	1726	663868375000	14562	7384	76	0	\N
117819	1726	663867373000	14562	7384	77	0	\N
117820	1726	663866372000	14562	7384	78	0	\N
117821	1726	663865369000	14562	7384	79	0	\N
117822	1726	663864367000	14562	7384	80	0	\N
117823	1726	663863366000	14562	7384	81	0	\N
117824	1726	663862363000	14562	7384	82	0	\N
117825	1726	663861361000	14562	7384	83	0	\N
117826	1726	663860360000	14562	7384	84	0	\N
117827	1726	663859357000	14562	7384	85	0	\N
117828	1726	663858355000	14562	7384	86	0	\N
117829	1726	663857354000	14562	7384	87	0	\N
117830	1726	663856352000	14562	7384	88	0	\N
117831	1726	663855349000	14562	7384	89	0	\N
117832	1726	663854348000	14562	7384	90	0	\N
117833	1726	663853346000	14562	7384	91	0	\N
117834	1726	663852343000	14562	7384	92	0	\N
117835	1726	663851342000	14562	7384	93	0	\N
117836	1726	663850340000	14562	7384	94	0	\N
117837	1726	663849337000	14562	7384	95	0	\N
117838	1726	663848335000	14562	7384	96	0	\N
117839	1726	663847334000	14562	7384	97	0	\N
117840	1726	663846331000	14562	7384	98	0	\N
117841	1726	663845329000	14562	7384	99	0	\N
117842	1726	663844328000	14562	7384	100	0	\N
117843	1726	663843325000	14562	7384	101	0	\N
117844	1726	663842323000	14562	7384	102	0	\N
117845	1726	663841322000	14562	7384	103	0	\N
117846	1726	663840319000	14562	7384	104	0	\N
117847	1726	663839317000	14562	7384	105	0	\N
117848	1726	663838316000	14562	7384	106	0	\N
117849	1726	663837313000	14562	7384	107	0	\N
117850	1726	663836311000	14562	7384	108	0	\N
117851	1726	663835310000	14562	7384	109	0	\N
117852	1726	663834307000	14562	7384	110	0	\N
117853	1726	663833306000	14562	7384	111	0	\N
117854	1726	663832304000	14562	7384	112	0	\N
117855	1726	663831301000	14562	7384	113	0	\N
117856	1726	663830299000	14562	7384	114	0	\N
117857	1726	663829298000	14562	7384	115	0	\N
117858	1726	663828295000	14562	7384	116	0	\N
117859	1726	663827293000	14562	7384	117	0	\N
117860	1726	663826292000	14562	7384	118	0	\N
117861	1726	663825289000	14562	7384	119	0	\N
117862	1726	663824287000	14562	7384	120	0	\N
117863	1726	663823286000	14562	7384	121	0	\N
117864	1726	663822283000	14562	7384	122	0	\N
117865	1726	663821281000	14562	7384	123	0	\N
117866	1726	663820280000	14562	7384	124	0	\N
117867	1726	663819277000	14562	7384	125	0	\N
117868	1397	1357501884000	14563	7427	0	0	\N
117869	1726	663717048000	14563	7427	1	0	\N
117870	1397	1357501884000	14564	7427	0	0	\N
117871	1726	663717048000	14564	7427	1	0	\N
117873	1397	1357501884000	14566	7427	0	0	\N
117874	1726	663717048000	14566	7427	1	0	\N
117887	1397	1357471881000	14569	7429	0	0	\N
117888	1397	1357461880000	14569	7429	1	0	\N
117889	1397	1357451879000	14569	7429	2	0	\N
117890	1726	663714039000	14569	7429	3	0	\N
117891	1726	663713036000	14569	7429	4	0	\N
117892	1726	663712033000	14569	7429	5	0	\N
117893	1397	1357471881000	14570	7429	0	0	\N
117894	1397	1357461880000	14570	7429	1	0	\N
117895	1397	1357451879000	14570	7429	2	0	\N
117896	1726	663714039000	14570	7429	3	0	\N
117897	1726	663713036000	14570	7429	4	0	\N
117898	1726	663712033000	14570	7429	5	0	\N
117899	1397	1357471881000	14571	7429	0	0	\N
117900	1397	1357461880000	14571	7429	1	0	\N
117901	1397	1357451879000	14571	7429	2	0	\N
117902	1726	663714039000	14571	7429	3	0	\N
117903	1726	663713036000	14571	7429	4	0	\N
117904	1726	663712033000	14571	7429	5	0	\N
117905	1397	1357441878000	14572	7430	0	0	\N
117906	1726	663711030000	14572	7430	1	0	\N
117907	1397	1357441878000	14573	7430	0	0	\N
117908	1726	663711030000	14573	7430	1	0	\N
117876	1397	1357491883000	14567	7428	1	0	8134
117877	1397	1357481882000	14567	7428	2	0	8135
117878	2113	333982938283	14567	7428	3	0	1
117879	1726	663716045000	14567	7428	4	0	7276
117880	1726	663715042000	14567	7428	5	0	7277
117882	1397	1357461880000	14568	7429	1	0	8137
117883	1397	1357451879000	14568	7429	2	0	8138
117884	1726	663714039000	14568	7429	3	0	7278
117885	1726	663713036000	14568	7429	4	0	7279
117886	1726	663712033000	14568	7429	5	0	7280
117910	1726	663711030000	14574	7430	1	0	7281
117911	1397	1357431877000	14575	7431	0	0	8140
117912	1726	663710027000	14575	7431	1	0	7282
117913	1397	1357431877000	14576	7431	0	0	\N
117914	1726	663710027000	14576	7431	1	0	\N
117917	1397	1357421876000	14578	7432	0	0	\N
117918	1726	663709024000	14578	7432	1	0	\N
117921	1726	663706015000	14581	7435	0	0	\N
117923	1726	663705012000	14583	7436	0	0	\N
117927	1397	1357411875000	14586	7438	0	0	\N
117928	1726	663702005000	14586	7438	1	0	\N
117929	1726	663701002000	14586	7438	2	0	\N
117936	1397	1357401874000	14589	7439	0	0	\N
117937	1726	663700000000	14589	7439	1	0	\N
117938	1726	663698997000	14589	7439	2	0	\N
117939	1397	1357401874000	14590	7439	0	0	\N
117940	1726	663700000000	14590	7439	1	0	\N
117941	1726	663698997000	14590	7439	2	0	\N
117951	1397	1357371871000	14594	7442	0	0	\N
117952	1726	663693985000	14594	7442	1	0	\N
117953	1726	663692982000	14594	7442	2	0	\N
117954	1397	1357371871000	14595	7442	0	0	\N
117955	1726	663693985000	14595	7442	1	0	\N
117956	1726	663692982000	14595	7442	2	0	\N
117957	1397	1357371871000	14596	7442	0	0	\N
117958	1726	663693985000	14596	7442	1	0	\N
117959	1726	663692982000	14596	7442	2	0	\N
117960	1397	1357361870000	14597	7443	0	0	\N
117961	1726	663691980000	14597	7443	1	0	\N
117962	1726	663690977000	14597	7443	2	0	\N
117966	1397	1357361870000	14600	7443	0	0	\N
117967	1726	663691980000	14600	7443	1	0	\N
117968	1726	663690977000	14600	7443	2	0	\N
117969	1397	1357351869000	14601	7444	0	0	\N
117970	1726	663689975000	14601	7444	1	0	\N
117971	1726	663688972000	14601	7444	2	0	\N
117975	1397	1357351869000	14603	7444	0	0	\N
117976	1726	663689975000	14603	7444	1	0	\N
117977	1726	663688972000	14603	7444	2	0	\N
117984	647	66234984938283	14606	7229	0	0	\N
117985	647	66000000000000	14606	7229	1	0	\N
117986	1397	1357321866000	14607	7447	0	0	\N
117987	1726	663683960000	14607	7447	1	0	\N
117988	1726	663682957000	14607	7447	2	0	\N
118003	1397	1357311865000	14610	7448	0	0	\N
118004	1397	1357301864000	14610	7448	1	0	\N
118005	1397	1357291863000	14610	7448	2	0	\N
118006	1397	1357281862000	14610	7448	3	0	\N
118007	1726	663681955000	14610	7448	4	0	\N
118008	1726	663680952000	14610	7448	5	0	\N
118009	1726	663679950000	14610	7448	6	0	\N
118010	1726	663678947000	14610	7448	7	0	\N
118011	1726	663677945000	14610	7448	8	0	\N
118012	1726	663676942000	14610	7448	9	0	\N
118013	1726	663675940000	14610	7448	10	0	\N
118016	1397	1357261860000	14612	7450	0	0	\N
118017	1726	663673935000	14612	7450	1	0	\N
118018	1726	663672932000	14612	7450	2	0	\N
118019	1397	1357261860000	14613	7450	0	0	\N
118020	1726	663673935000	14613	7450	1	0	\N
118021	1726	663672932000	14613	7450	2	0	\N
118025	1397	1357261860000	14615	7450	0	0	\N
118026	1726	663673935000	14615	7450	1	0	\N
118027	1726	663672932000	14615	7450	2	0	\N
118043	1397	1357211855000	14620	7453	0	0	\N
118044	1726	663663910000	14620	7453	1	0	\N
118045	1726	663662907000	14620	7453	2	0	\N
118046	1397	1357211855000	14621	7453	0	0	\N
118047	1726	663663910000	14621	7453	1	0	\N
118048	1726	663662907000	14621	7453	2	0	\N
117919	1726	663708021000	14579	7433	0	0	7284
117920	1726	663707018000	14580	7434	0	0	7285
117922	1726	663706015000	14582	7435	0	0	7286
117924	1726	663705012000	14584	7436	0	0	7287
117925	1726	663704010000	14585	7437	0	0	7288
117930	1397	1357411875000	14587	7438	0	0	8142
117931	1726	663702005000	14587	7438	1	0	7290
117932	1726	663701002000	14587	7438	2	0	7291
117933	1397	1357401874000	14588	7439	0	0	8143
117934	1726	663700000000	14588	7439	1	0	7292
117942	1397	1357391873000	14591	7440	0	0	8144
117943	1726	663697995000	14591	7440	1	0	7294
117944	1726	663696992000	14591	7440	2	0	7295
117945	1397	1357381872000	14592	7441	0	0	8145
117947	1726	663694987000	14592	7441	2	0	7297
117948	1397	1357371871000	14593	7442	0	0	8146
117949	1726	663693985000	14593	7442	1	0	7298
117950	1726	663692982000	14593	7442	2	0	7299
117963	1397	1357361870000	14598	7443	0	0	8147
117965	1726	663690977000	14598	7443	2	0	7301
117972	1397	1357351869000	14602	7444	0	0	8148
117973	1726	663689975000	14602	7444	1	0	7302
117974	1726	663688972000	14602	7444	2	0	7303
117978	1397	1357341868000	14604	7445	0	0	8149
117980	1726	663686967000	14604	7445	2	0	7305
117981	1397	1357331867000	14605	7446	0	0	8150
117982	1726	663685965000	14605	7446	1	0	7306
117983	1726	663684962000	14605	7446	2	0	7307
117990	1726	663683960000	14608	7447	1	0	7308
117991	1726	663682957000	14608	7447	2	0	7309
117992	1397	1357311865000	14609	7448	0	0	8152
117993	1397	1357301864000	14609	7448	1	0	8153
117994	1397	1357291863000	14609	7448	2	0	8154
117996	1726	663681955000	14609	7448	4	0	7310
117997	1726	663680952000	14609	7448	5	0	7311
117998	1726	663679950000	14609	7448	6	0	7312
117999	1726	663678947000	14609	7448	7	0	7313
118000	1726	663677945000	14609	7448	8	0	7314
118002	1726	663675940000	14609	7448	10	0	7316
118014	1397	1357271861000	14611	7449	0	0	8156
118015	1726	663674937000	14611	7449	1	0	7317
118022	1397	1357261860000	14614	7450	0	0	8157
118024	1726	663672932000	14614	7450	2	0	7319
118028	1397	1357251859000	14616	7451	0	0	8158
118029	1726	663671930000	14616	7451	1	0	7320
118030	1726	663670927000	14616	7451	2	0	7321
118031	1397	1357241858000	14617	7452	0	0	8159
118033	1397	1357221856000	14617	7452	2	0	8161
118034	1726	663669925000	14617	7452	3	0	7322
118035	1726	663668922000	14617	7452	4	0	7323
118036	1726	663667920000	14617	7452	5	0	7324
118037	1726	663666917000	14617	7452	6	0	7325
118039	1726	663664912000	14617	7452	8	0	7327
118040	1397	1357211855000	14618	7453	0	0	8162
118041	1726	663663910000	14618	7453	1	0	7328
118042	1726	663662907000	14618	7453	2	0	7329
118049	1397	1357211855000	14622	7453	0	0	\N
118050	1726	663663910000	14622	7453	1	0	\N
118051	1726	663662907000	14622	7453	2	0	\N
118055	1397	1357191853000	14624	7455	0	0	\N
118056	1726	663659900000	14624	7455	1	0	\N
118057	1726	663658897000	14624	7455	2	0	\N
118058	1397	1357191853000	14625	7455	0	0	\N
118059	1726	663659900000	14625	7455	1	0	\N
118060	1726	663658897000	14625	7455	2	0	\N
118073	1397	1357151849000	14629	7458	0	0	\N
118074	1726	663651880000	14629	7458	1	0	\N
118075	1726	663650877000	14629	7458	2	0	\N
118079	1397	1357151849000	14631	7458	0	0	\N
118080	1726	663651880000	14631	7458	1	0	\N
118081	1726	663650877000	14631	7458	2	0	\N
118082	1397	1357141848000	14632	7459	0	0	\N
118083	1397	1357131847000	14632	7459	1	0	\N
118084	1397	1357121846000	14632	7459	2	0	\N
118085	1726	663649875000	14632	7459	3	0	\N
118086	1726	663648872000	14632	7459	4	0	\N
118087	1726	663647870000	14632	7459	5	0	\N
118088	1726	663646867000	14632	7459	6	0	\N
118089	1726	663645865000	14632	7459	7	0	\N
118090	1726	663644862000	14632	7459	8	0	\N
118100	1397	1357111845000	14636	7460	0	0	\N
118101	1397	1357101844000	14636	7460	1	0	\N
118102	1726	663643860000	14636	7460	2	0	\N
118103	1726	663642857000	14636	7460	3	0	\N
118104	1726	663641855000	14636	7460	4	0	\N
118105	1726	663640852000	14636	7460	5	0	\N
118112	1397	1357111845000	14638	7460	0	0	\N
118113	1397	1357101844000	14638	7460	1	0	\N
118114	1726	663643860000	14638	7460	2	0	\N
118115	1726	663642857000	14638	7460	3	0	\N
118116	1726	663641855000	14638	7460	4	0	\N
118117	1726	663640852000	14638	7460	5	0	\N
118118	1726	663639850000	14639	7461	0	0	\N
118119	1726	663638847000	14639	7461	1	0	\N
118122	1726	663639850000	14641	7461	0	0	\N
118123	1726	663638847000	14641	7461	1	0	\N
118124	141	66000000000000	14642	7361	0	0	\N
118125	647	66234984938283	14642	7361	1	0	\N
118126	1397	1358501984000	14642	7361	2	0	\N
118127	1397	1358491983000	14642	7361	3	0	\N
118128	1397	1358481982000	14642	7361	4	0	\N
118129	1397	1358471981000	14642	7361	5	0	\N
118130	1397	1358461980000	14642	7361	6	0	\N
118131	1397	1358451979000	14642	7361	7	0	\N
118132	1397	1358441978000	14642	7361	8	0	\N
118133	1397	1358431977000	14642	7361	9	0	\N
118134	1397	1358421976000	14642	7361	10	0	\N
118135	1397	1358411975000	14642	7361	11	0	\N
118136	1397	1358401974000	14642	7361	12	0	\N
118137	1397	1358391973000	14642	7361	13	0	\N
118138	1397	1358381972000	14642	7361	14	0	\N
118139	1397	1358371971000	14642	7361	15	0	\N
118140	1397	1358361970000	14642	7361	16	0	\N
118141	1397	1358351969000	14642	7361	17	0	\N
118142	1397	1358341968000	14642	7361	18	0	\N
118143	1397	1358331967000	14642	7361	19	0	\N
118144	1397	1358321966000	14642	7361	20	0	\N
118145	1397	1358311965000	14642	7361	21	0	\N
118146	1397	1358301964000	14642	7361	22	0	\N
118147	1397	1358291963000	14642	7361	23	0	\N
118148	1397	1358281962000	14642	7361	24	0	\N
118149	1397	1358271961000	14642	7361	25	0	\N
118150	1397	1358261960000	14642	7361	26	0	\N
118151	1397	1358251959000	14642	7361	27	0	\N
118152	1397	1358241958000	14642	7361	28	0	\N
118153	1397	1358231957000	14642	7361	29	0	\N
118154	1397	1358221956000	14642	7361	30	0	\N
118155	1397	1358211955000	14642	7361	31	0	\N
118156	1397	1358201954000	14642	7361	32	0	\N
118157	1397	1358191953000	14642	7361	33	0	\N
118158	1397	1358181952000	14642	7361	34	0	\N
118159	1397	1358171951000	14642	7361	35	0	\N
118160	1397	1358161950000	14642	7361	36	0	\N
118161	1397	1358151949000	14642	7361	37	0	\N
118162	1397	1358141948000	14642	7361	38	0	\N
118163	1397	1358131947000	14642	7361	39	0	\N
118164	1397	1358121946000	14642	7361	40	0	\N
118165	1397	1358111945000	14642	7361	41	0	\N
118166	1397	1358101944000	14642	7361	42	0	\N
118167	1397	1358091943000	14642	7361	43	0	\N
118168	1397	1358081942000	14642	7361	44	0	\N
118169	1397	1358071941000	14642	7361	45	0	\N
118170	1397	1358061940000	14642	7361	46	0	\N
118171	1397	1358051939000	14642	7361	47	0	\N
118172	1397	1358041938000	14642	7361	48	0	\N
118173	1397	1358031937000	14642	7361	49	0	\N
118174	1397	1358021936000	14642	7361	50	0	\N
118175	1397	1358011935000	14642	7361	51	0	\N
118176	1397	1358001934000	14642	7361	52	0	\N
118177	1397	1357991933000	14642	7361	53	0	\N
118178	1397	1357981932000	14642	7361	54	0	\N
118179	1397	1357971931000	14642	7361	55	0	\N
118180	1397	1357961930000	14642	7361	56	0	\N
118181	1397	1357951929000	14642	7361	57	0	\N
118182	1397	1357941928000	14642	7361	58	0	\N
118183	1397	1357931927000	14642	7361	59	0	\N
118184	1397	1357921926000	14642	7361	60	0	\N
118054	1726	663660902000	14623	7454	2	0	7331
118061	1397	1357191853000	14626	7455	0	0	8164
118062	1726	663659900000	14626	7455	1	0	7332
118063	1726	663658897000	14626	7455	2	0	7333
118064	1397	1357181852000	14627	7456	0	0	8165
118066	1726	663657895000	14627	7456	2	0	7334
118067	1726	663656892000	14627	7456	3	0	7335
118068	1726	663655890000	14627	7456	4	0	7336
118069	1726	663654887000	14627	7456	5	0	7337
118070	1397	1357161850000	14628	7457	0	0	8167
118072	1726	663652882000	14628	7457	2	0	7339
118076	1397	1357151849000	14630	7458	0	0	8168
118077	1726	663651880000	14630	7458	1	0	7340
118078	1726	663650877000	14630	7458	2	0	7341
118092	1397	1357131847000	14633	7459	1	0	8170
118093	1397	1357121846000	14633	7459	2	0	8171
118094	1726	663649875000	14633	7459	3	0	7342
118095	1726	663648872000	14633	7459	4	0	7343
118096	1726	663647870000	14633	7459	5	0	7344
118098	1726	663645865000	14633	7459	7	0	7346
118099	1726	663644862000	14633	7459	8	0	7347
118106	1397	1357111845000	14637	7460	0	0	8172
118107	1397	1357101844000	14637	7460	1	0	8173
118108	1726	663643860000	14637	7460	2	0	7348
118110	1726	663641855000	14637	7460	4	0	7350
118111	1726	663640852000	14637	7460	5	0	7351
118120	1726	663639850000	14640	7461	0	0	7352
118121	1726	663638847000	14640	7461	1	0	7353
118185	1397	1357911925000	14642	7361	61	0	\N
118186	1397	1357901924000	14642	7361	62	0	\N
118187	1397	1357891923000	14642	7361	64	0	\N
118188	1397	1357881922000	14642	7361	65	0	\N
118189	1397	1357871921000	14642	7361	66	0	\N
118190	1397	1357861920000	14642	7361	67	0	\N
118191	1397	1357851919000	14642	7361	68	0	\N
118192	1397	1357841918000	14642	7361	69	0	\N
118193	1397	1357831917000	14642	7361	70	0	\N
118194	1397	1357821916000	14642	7361	71	0	\N
118195	1397	1357811915000	14642	7361	72	0	\N
118196	1397	1357801914000	14642	7361	73	0	\N
118197	1397	1357791913000	14642	7361	74	0	\N
118198	1397	1357781912000	14642	7361	75	0	\N
118199	1397	1357771911000	14642	7361	76	0	\N
118200	1397	1357761910000	14642	7361	77	0	\N
118201	1397	1357751909000	14642	7361	78	0	\N
118202	1397	1357741908000	14642	7361	79	0	\N
118203	1397	1357731907000	14642	7361	80	0	\N
118204	1397	1357721906000	14642	7361	81	0	\N
118205	1397	1357711905000	14642	7361	82	0	\N
118206	1397	1357701904000	14642	7361	83	0	\N
118207	1397	1357691903000	14642	7361	84	0	\N
118208	1397	1357681902000	14642	7361	85	0	\N
118209	1397	1357671901000	14642	7361	86	0	\N
118210	1397	1357661900000	14642	7361	87	0	\N
118211	1397	1357651899000	14642	7361	88	0	\N
118212	1397	1357641898000	14642	7361	89	0	\N
118213	1397	1357631897000	14642	7361	90	0	\N
118214	1397	1357621896000	14642	7361	91	0	\N
118215	1397	1357611895000	14642	7361	92	0	\N
118216	1397	1357601894000	14642	7361	93	0	\N
118217	1397	1357591893000	14642	7361	94	0	\N
118218	1397	1357581892000	14642	7361	95	0	\N
118219	1397	1357571891000	14642	7361	96	0	\N
118220	1397	1357561890000	14642	7361	97	0	\N
118221	1397	1357551889000	14642	7361	98	0	\N
118222	1397	1357541888000	14642	7361	99	0	\N
118223	1397	1357531887000	14642	7361	100	0	\N
118224	1397	1357521886000	14642	7361	101	0	\N
118225	1397	1357511885000	14642	7361	102	0	\N
118226	1397	1357501884000	14642	7361	103	0	\N
118227	1397	1357491883000	14642	7361	104	0	\N
118228	1397	1357481882000	14642	7361	105	0	\N
118229	1397	1357471881000	14642	7361	106	0	\N
118230	1397	1357461880000	14642	7361	107	0	\N
118231	1397	1357451879000	14642	7361	108	0	\N
118232	1397	1357441878000	14642	7361	109	0	\N
118233	1397	1357431877000	14642	7361	110	0	\N
118234	1397	1357421876000	14642	7361	111	0	\N
118235	1397	1357411875000	14642	7361	112	0	\N
118236	1397	1357401874000	14642	7361	113	0	\N
118237	1397	1357391873000	14642	7361	114	0	\N
118238	1397	1357381872000	14642	7361	115	0	\N
118239	1397	1357371871000	14642	7361	116	0	\N
118240	1397	1357361870000	14642	7361	117	0	\N
118241	1397	1357351869000	14642	7361	118	0	\N
118242	1397	1357341868000	14642	7361	119	0	\N
118243	1397	1357331867000	14642	7361	120	0	\N
118244	1397	1357321866000	14642	7361	121	0	\N
118245	1397	1357311865000	14642	7361	122	0	\N
118246	1397	1357301864000	14642	7361	123	0	\N
118247	1397	1357291863000	14642	7361	124	0	\N
118248	1397	1357281862000	14642	7361	125	0	\N
118266	1397	1357061840000	14646	7465	0	0	\N
118267	1726	663623810000	14646	7465	1	0	\N
118268	1726	663622807000	14646	7465	2	0	\N
118272	1397	1357271861000	14648	7362	0	0	\N
118273	1397	1357261860000	14648	7362	1	0	\N
118274	1397	1357251859000	14648	7362	2	0	\N
118275	1397	1357241858000	14648	7362	3	0	\N
118276	1397	1357231857000	14648	7362	4	0	\N
118277	1397	1357221856000	14648	7362	5	0	\N
118278	1397	1357211855000	14648	7362	6	0	\N
118279	1397	1357201854000	14648	7362	7	0	\N
118280	1397	1357191853000	14648	7362	8	0	\N
118281	1397	1357181852000	14648	7362	9	0	\N
118282	1397	1357171851000	14648	7362	10	0	\N
118283	1397	1357161850000	14648	7362	11	0	\N
118284	1397	1357151849000	14648	7362	12	0	\N
118285	1397	1357141848000	14648	7362	13	0	\N
118286	1397	1357131847000	14648	7362	14	0	\N
118287	1397	1357121846000	14648	7362	15	0	\N
118288	1397	1357111845000	14648	7362	16	0	\N
118289	1397	1357101844000	14648	7362	17	0	\N
118290	1397	1357091843000	14648	7362	18	0	\N
118291	1397	1357081842000	14648	7362	19	0	\N
118292	1397	1357071841000	14648	7362	20	0	\N
118293	1397	1357061840000	14648	7362	21	0	\N
118294	647	66000000000000	14648	7362	22	0	\N
118295	1726	663959557000	14648	7362	23	0	\N
118296	1726	663958555000	14648	7362	24	0	\N
118297	1726	663957554000	14648	7362	25	0	\N
118298	1726	663956551000	14648	7362	26	0	\N
118299	1726	663955549000	14648	7362	27	0	\N
118300	1726	663954548000	14648	7362	28	0	\N
118301	1726	663953545000	14648	7362	29	0	\N
118302	1726	663952543000	14648	7362	30	0	\N
118303	1726	663951542000	14648	7362	31	0	\N
118304	1726	663950539000	14648	7362	32	0	\N
118305	1726	663949537000	14648	7362	33	0	\N
118306	1726	663948536000	14648	7362	34	0	\N
118307	1726	663947533000	14648	7362	35	0	\N
118308	1726	663946531000	14648	7362	36	0	\N
118309	1726	663945530000	14648	7362	37	0	\N
118310	1726	663944527000	14648	7362	38	0	\N
118311	1726	663943525000	14648	7362	39	0	\N
118312	1726	663942524000	14648	7362	40	0	\N
118313	1726	663941521000	14648	7362	41	0	\N
118314	1726	663940519000	14648	7362	42	0	\N
118315	1726	663939518000	14648	7362	43	0	\N
118316	1726	663938515000	14648	7362	44	0	\N
118317	1726	663937513000	14648	7362	45	0	\N
118318	1726	663936512000	14648	7362	46	0	\N
118319	1726	663935509000	14648	7362	47	0	\N
118320	1726	663934508000	14648	7362	48	0	\N
118251	1397	1357091843000	14644	7463	0	0	8174
118252	1397	1357081842000	14644	7463	1	0	8175
118253	1726	663635840000	14644	7463	2	0	7356
118254	1726	663634837000	14644	7463	3	0	7357
118255	1726	663633835000	14644	7463	4	0	7358
118257	1726	663631830000	14644	7463	6	0	7360
118258	1726	663630827000	14644	7463	7	0	7361
118259	1726	663629825000	14644	7463	8	0	7362
118260	1726	663628822000	14644	7463	9	0	7363
118261	1726	663627820000	14644	7463	10	0	7364
118263	1397	1357071841000	14645	7464	0	0	8176
118264	1726	663625815000	14645	7464	1	0	7366
118265	1726	663624812000	14645	7464	2	0	7367
118269	1397	1357061840000	14647	7465	0	0	8177
118271	1726	663622807000	14647	7465	2	0	7369
118321	1726	663933506000	14648	7362	49	0	\N
118322	1726	663932505000	14648	7362	50	0	\N
118323	1726	663931502000	14648	7362	51	0	\N
118324	1726	663930501000	14648	7362	52	0	\N
118325	1726	663929498000	14648	7362	53	0	\N
118326	1726	663928496000	14648	7362	54	0	\N
118327	1726	663927495000	14648	7362	55	0	\N
118328	1726	663926493000	14648	7362	56	0	\N
118329	1726	663925490000	14648	7362	57	0	\N
118330	1726	663924489000	14648	7362	58	0	\N
118331	1726	663923487000	14648	7362	59	0	\N
118332	1726	663922484000	14648	7362	60	0	\N
118333	1726	663921483000	14648	7362	61	0	\N
118334	1726	663920481000	14648	7362	62	0	\N
118335	1726	663919480000	14648	7362	64	0	\N
118336	1726	663918478000	14648	7362	65	0	\N
118337	1726	663917475000	14648	7362	66	0	\N
118338	1726	663916474000	14648	7362	67	0	\N
118339	1726	663915472000	14648	7362	68	0	\N
118340	1726	663914469000	14648	7362	69	0	\N
118341	1726	663913468000	14648	7362	70	0	\N
118342	1726	663912466000	14648	7362	71	0	\N
118343	1726	663911463000	14648	7362	72	0	\N
118344	1726	663910462000	14648	7362	73	0	\N
118345	1726	663909460000	14648	7362	74	0	\N
118346	1726	663908457000	14648	7362	75	0	\N
118347	1726	663907455000	14648	7362	76	0	\N
118348	1726	663906452000	14648	7362	77	0	\N
118349	1726	663905450000	14648	7362	78	0	\N
118350	1726	663904447000	14648	7362	79	0	\N
118351	1726	663903445000	14648	7362	80	0	\N
118352	1726	663902444000	14648	7362	81	0	\N
118353	1726	663901441000	14648	7362	82	0	\N
118354	1726	663900439000	14648	7362	83	0	\N
118355	1726	663899438000	14648	7362	84	0	\N
118356	1726	663898435000	14648	7362	85	0	\N
118357	1726	663897433000	14648	7362	86	0	\N
118358	1726	663896432000	14648	7362	87	0	\N
118359	1726	663895429000	14648	7362	88	0	\N
118360	1726	663894427000	14648	7362	89	0	\N
118361	1726	663893426000	14648	7362	90	0	\N
118362	1726	663892423000	14648	7362	91	0	\N
118363	1726	663891421000	14648	7362	92	0	\N
118364	1726	663890420000	14648	7362	93	0	\N
118365	1726	663889417000	14648	7362	94	0	\N
118366	1726	663888415000	14648	7362	95	0	\N
118367	1726	663887414000	14648	7362	96	0	\N
118368	1726	663886411000	14648	7362	97	0	\N
118369	1726	663885409000	14648	7362	98	0	\N
118370	1726	663884408000	14648	7362	99	0	\N
118371	1726	663883405000	14648	7362	100	0	\N
118372	1726	663882403000	14648	7362	101	0	\N
118373	1726	663881402000	14648	7362	102	0	\N
118374	1726	663880399000	14648	7362	103	0	\N
118375	1726	663879397000	14648	7362	104	0	\N
118376	1726	663878396000	14648	7362	105	0	\N
118377	1726	663877393000	14648	7362	106	0	\N
118378	1726	663876391000	14648	7362	107	0	\N
118379	1726	663875390000	14648	7362	108	0	\N
118380	1726	663874387000	14648	7362	109	0	\N
118381	1726	663873385000	14648	7362	110	0	\N
118382	1726	663872384000	14648	7362	111	0	\N
118383	1726	663871381000	14648	7362	112	0	\N
118384	1726	663870379000	14648	7362	113	0	\N
118385	1726	663869378000	14648	7362	114	0	\N
118386	1726	663868375000	14648	7362	115	0	\N
118387	1726	663867373000	14648	7362	116	0	\N
118388	1726	663866372000	14648	7362	117	0	\N
118389	1726	663865369000	14648	7362	118	0	\N
118390	1726	663864367000	14648	7362	119	0	\N
118391	1726	663863366000	14648	7362	120	0	\N
118392	1726	663862363000	14648	7362	121	0	\N
118393	1726	663861361000	14648	7362	122	0	\N
118394	1726	663860360000	14648	7362	123	0	\N
118395	1726	663859357000	14648	7362	124	0	\N
118396	1726	663858355000	14648	7362	125	0	\N
118406	1397	1357031837000	14651	7467	0	0	\N
118407	1726	663617795000	14651	7467	1	0	\N
118408	1726	663616792000	14651	7467	2	0	\N
118409	1397	1357031837000	14652	7467	0	0	\N
118410	1726	663617795000	14652	7467	1	0	\N
118411	1726	663616792000	14652	7467	2	0	\N
118412	1397	1357031837000	14653	7467	0	0	\N
118413	1726	663617795000	14653	7467	1	0	\N
118414	1726	663616792000	14653	7467	2	0	\N
118415	1397	1357031837000	14654	7467	0	0	\N
118416	1726	663617795000	14654	7467	1	0	\N
118417	1726	663616792000	14654	7467	2	0	\N
118418	1397	1357031837000	14656	7467	0	0	\N
118419	1726	663617795000	14656	7467	1	0	\N
118420	1726	663616792000	14656	7467	2	0	\N
118421	1397	1357021836000	14657	7468	0	0	\N
118422	1726	663615790000	14657	7468	1	0	\N
118423	1726	663614787000	14657	7468	2	0	\N
118424	1397	1357021836000	14658	7468	0	0	\N
118425	1726	663615790000	14658	7468	1	0	\N
118426	1726	663614787000	14658	7468	2	0	\N
118430	1397	1357011835000	14660	7469	0	0	\N
118431	1397	1357001834000	14660	7469	1	0	\N
118432	1726	663613785000	14660	7469	2	0	\N
118433	1726	663612783000	14660	7469	3	0	\N
118434	1726	663611780000	14660	7469	4	0	\N
118435	1397	1357011835000	14661	7469	0	0	\N
118436	1397	1357001834000	14661	7469	1	0	\N
118437	1726	663613785000	14661	7469	2	0	\N
118438	1726	663612783000	14661	7469	3	0	\N
118439	1726	663611780000	14661	7469	4	0	\N
118445	1397	1356991833000	14663	7470	0	0	\N
118446	1726	663610778000	14663	7470	1	0	\N
118447	1726	663609775000	14663	7470	2	0	\N
118399	1726	663621805000	14649	7466	2	0	7370
118400	1726	663620802000	14649	7466	3	0	7371
118401	1726	663619800000	14649	7466	4	0	7372
118402	1726	663618797000	14649	7466	6	0	7373
118403	1397	1357031837000	14650	7467	0	0	8180
118405	1726	663616792000	14650	7467	2	0	7375
118427	1397	1357021836000	14659	7468	0	0	8181
118428	1726	663615790000	14659	7468	1	0	7376
118429	1726	663614787000	14659	7468	2	0	7377
118440	1397	1357011835000	14662	7469	0	0	8182
118442	1726	663613785000	14662	7469	2	0	7378
118443	1726	663612783000	14662	7469	3	0	7379
118444	1726	663611780000	14662	7469	4	0	7380
118448	1397	1356991833000	14664	7470	0	0	8184
118450	1726	663609775000	14664	7470	2	0	7382
118451	1693	21397475239447	14665	7471	0	0	669
118452	1397	1356981832000	14665	7471	1	0	8185
118453	1693	21363676464009	14665	7471	2	0	670
118454	1693	21247517548415	14665	7471	3	0	671
118456	1726	663608773000	14665	7471	5	0	7383
118489	1693	15101426785815	14668	7474	0	0	\N
118490	1693	14985267870221	14668	7474	1	0	\N
118491	1693	14869108954627	14668	7474	2	0	\N
118492	1397	1356931827000	14668	7474	3	0	\N
118493	1693	14752950039033	14668	7474	4	0	\N
118494	1693	14636791123439	14668	7474	5	0	\N
118495	1693	14520632207845	14668	7474	6	0	\N
118496	1726	663603758000	14668	7474	7	0	\N
118504	1397	1356921826000	14670	7475	0	0	\N
118505	1693	14404473292251	14670	7475	1	0	\N
118506	1693	14288314376657	14670	7475	2	0	\N
118507	1693	14172155461063	14670	7475	3	0	\N
118508	1693	14055996545469	14670	7475	4	0	\N
118509	1693	13939837629875	14670	7475	5	0	\N
118510	1693	13823678714281	14670	7475	6	0	\N
118511	1726	663603758000	14670	7475	7	0	\N
118512	1726	663602755000	14670	7475	8	0	\N
118522	1397	1356911825000	14672	7476	0	0	\N
118523	1397	1356901824000	14672	7476	1	0	\N
118524	1397	1356891823000	14672	7476	2	0	\N
118525	1397	1356911825000	14673	7476	0	0	\N
118526	1397	1356901824000	14673	7476	1	0	\N
118527	1397	1356891823000	14673	7476	2	0	\N
118528	1693	13707519798687	14673	7476	3	0	\N
118529	1693	13591360883093	14673	7476	4	0	\N
118530	1693	13475201967499	14673	7476	5	0	\N
118531	1693	13359043051905	14673	7476	6	0	\N
118532	1693	13242884136311	14673	7476	7	0	\N
118533	1693	13126725220717	14673	7476	8	0	\N
118534	1693	13010566305123	14673	7476	9	0	\N
118535	1693	12894407389529	14673	7476	10	0	\N
118536	1693	12778248473935	14673	7476	11	0	\N
118537	1693	12662089558341	14673	7476	12	0	\N
118538	1693	12545930642747	14673	7476	13	0	\N
118539	1693	12429771727153	14673	7476	14	0	\N
118540	1693	12313612811559	14673	7476	15	0	\N
118541	1693	12197453895965	14673	7476	16	0	\N
118542	1693	12081294980371	14673	7476	17	0	\N
118543	1693	11965136064777	14673	7476	18	0	\N
118544	1693	11848977149183	14673	7476	19	0	\N
118545	1693	11732818233589	14673	7476	20	0	\N
118546	1726	663601752000	14673	7476	21	0	\N
118547	1726	663600749000	14673	7476	22	0	\N
118548	1726	663599746000	14673	7476	23	0	\N
118549	1397	1356911825000	14674	7476	0	0	\N
118550	1397	1356901824000	14674	7476	1	0	\N
118551	1397	1356891823000	14674	7476	2	0	\N
118552	1693	13707519798687	14674	7476	3	0	\N
118553	1693	13591360883093	14674	7476	4	0	\N
118554	1693	13475201967499	14674	7476	5	0	\N
118555	1693	13359043051905	14674	7476	6	0	\N
118556	1693	13242884136311	14674	7476	7	0	\N
118557	1693	13126725220717	14674	7476	8	0	\N
118558	1693	13010566305123	14674	7476	9	0	\N
118559	1693	12894407389529	14674	7476	10	0	\N
118560	1693	12778248473935	14674	7476	11	0	\N
118561	1693	12662089558341	14674	7476	12	0	\N
118562	1693	12545930642747	14674	7476	13	0	\N
118563	1693	12429771727153	14674	7476	14	0	\N
118564	1693	12313612811559	14674	7476	15	0	\N
118565	1693	12197453895965	14674	7476	16	0	\N
118566	1693	12081294980371	14674	7476	17	0	\N
118567	1693	11965136064777	14674	7476	18	0	\N
118568	1693	11848977149183	14674	7476	19	0	\N
118569	1693	11732818233589	14674	7476	20	0	\N
118570	1726	663601752000	14674	7476	21	0	\N
118571	1726	663600749000	14674	7476	22	0	\N
118572	1726	663599746000	14674	7476	23	0	\N
118573	1397	1356911825000	14675	7476	0	0	\N
118574	1397	1356901824000	14675	7476	1	0	\N
118575	1397	1356891823000	14675	7476	2	0	\N
118576	1693	13707519798687	14675	7476	3	0	\N
118577	1693	13591360883093	14675	7476	4	0	\N
118578	1693	13475201967499	14675	7476	5	0	\N
118579	1693	13359043051905	14675	7476	6	0	\N
118580	1693	13242884136311	14675	7476	7	0	\N
118581	1693	13126725220717	14675	7476	8	0	\N
118582	1693	13010566305123	14675	7476	9	0	\N
118583	1693	12894407389529	14675	7476	10	0	\N
118584	1693	12778248473935	14675	7476	11	0	\N
118585	1693	12662089558341	14675	7476	12	0	\N
118586	1693	12545930642747	14675	7476	13	0	\N
118587	1693	12429771727153	14675	7476	14	0	\N
118588	1693	12313612811559	14675	7476	15	0	\N
118589	1693	12197453895965	14675	7476	16	0	\N
118590	1693	12081294980371	14675	7476	17	0	\N
118591	1693	11965136064777	14675	7476	18	0	\N
118592	1693	11848977149183	14675	7476	19	0	\N
118459	1693	18714994701705	14666	7472	2	0	674
118460	1693	18598835786111	14666	7472	3	0	675
118461	1693	18482676870517	14666	7472	4	0	676
118462	1693	18473867710256	14666	7472	5	0	677
118463	1693	18357708794662	14666	7472	6	0	678
118465	1693	18241549879068	14667	7473	0	0	679
118466	1397	1356961830000	14667	7473	1	0	8187
118467	1397	1356951829000	14667	7473	2	0	8188
118468	1397	1356941828000	14667	7473	3	0	8189
118469	1693	18125390963474	14667	7473	4	0	680
118471	1693	17267618407868	14667	7473	6	0	682
118472	1693	17151459492274	14667	7473	7	0	683
118473	1693	17035300576680	14667	7473	8	0	684
118474	1693	16919141661086	14667	7473	9	0	685
118476	1693	16263015941755	14667	7473	11	0	687
118477	1693	16146857026161	14667	7473	12	0	688
118478	1693	16030698110567	14667	7473	13	0	689
118479	1693	15914539194973	14667	7473	14	0	690
118480	1693	15798380279379	14667	7473	15	0	691
118482	1693	15566062448191	14667	7473	17	0	693
118483	1693	15449903532597	14667	7473	18	0	694
118484	1693	15333744617003	14667	7473	19	0	695
118485	1693	15217585701409	14667	7473	20	0	696
118486	1726	663606767000	14667	7473	21	0	7385
118488	1726	663604761000	14667	7473	23	0	7387
118497	1693	15101426785815	14669	7474	0	0	697
118498	1693	14985267870221	14669	7474	1	0	698
118499	1693	14869108954627	14669	7474	2	0	699
118501	1693	14752950039033	14669	7474	4	0	700
118502	1693	14636791123439	14669	7474	5	0	701
118503	1693	14520632207845	14669	7474	6	0	702
118513	1397	1356921826000	14671	7475	0	0	8191
118514	1693	14404473292251	14671	7475	1	0	703
118516	1693	14172155461063	14671	7475	3	0	705
118517	1693	14055996545469	14671	7475	4	0	706
118518	1693	13939837629875	14671	7475	5	0	707
118519	1693	13823678714281	14671	7475	6	0	708
118520	1726	663603758000	14671	7475	7	0	7388
118593	1693	11732818233589	14675	7476	20	0	\N
118594	1726	663601752000	14675	7476	21	0	\N
118595	1726	663600749000	14675	7476	22	0	\N
118596	1726	663599746000	14675	7476	23	0	\N
118597	1397	1356911825000	14676	7476	0	0	\N
118598	1397	1356901824000	14676	7476	1	0	\N
118599	1397	1356891823000	14676	7476	2	0	\N
118600	1693	13707519798687	14676	7476	3	0	\N
118601	1693	13591360883093	14676	7476	4	0	\N
118602	1693	13475201967499	14676	7476	5	0	\N
118603	1693	13359043051905	14676	7476	6	0	\N
118604	1693	13242884136311	14676	7476	7	0	\N
118605	1693	13126725220717	14676	7476	8	0	\N
118606	1693	13010566305123	14676	7476	9	0	\N
118607	1693	12894407389529	14676	7476	10	0	\N
118608	1693	12778248473935	14676	7476	11	0	\N
118609	1693	12662089558341	14676	7476	12	0	\N
118610	1693	12545930642747	14676	7476	13	0	\N
118611	1693	12429771727153	14676	7476	14	0	\N
118612	1693	12313612811559	14676	7476	15	0	\N
118613	1693	12197453895965	14676	7476	16	0	\N
118614	1693	12081294980371	14676	7476	17	0	\N
118615	1693	11965136064777	14676	7476	18	0	\N
118616	1693	11848977149183	14676	7476	19	0	\N
118617	1693	11732818233589	14676	7476	20	0	\N
118618	1726	663601752000	14676	7476	21	0	\N
118619	1726	663600749000	14676	7476	22	0	\N
118620	1726	663599746000	14676	7476	23	0	\N
118685	1693	19957441239447	14680	7441	0	0	\N
118686	1693	19923642464009	14680	7441	1	0	\N
118687	1693	19807483548415	14680	7441	2	0	\N
118688	1693	18221957475715	14680	7441	3	0	\N
118689	1693	17391119617299	14680	7441	4	0	\N
118690	1693	17274960701705	14680	7441	5	0	\N
118691	1693	17158801786111	14680	7441	6	0	\N
118692	1693	17042642870517	14680	7441	7	0	\N
118693	1693	17033833710256	14680	7441	8	0	\N
118694	1693	16917674794662	14680	7441	9	0	\N
118695	1693	16801515879068	14680	7441	10	0	\N
118696	1693	16685356963474	14680	7441	11	0	\N
118697	1693	16367551211605	14680	7441	12	0	\N
118698	1693	15827584407868	14680	7441	13	0	\N
118699	1693	15711425492274	14680	7441	14	0	\N
118700	1693	15595266576680	14680	7441	15	0	\N
118701	1693	15479107661086	14680	7441	16	0	\N
118702	1693	15362948745492	14680	7441	17	0	\N
118703	1693	14822981941755	14680	7441	18	0	\N
118704	1693	14706823026161	14680	7441	19	0	\N
118705	1693	14590664110567	14680	7441	20	0	\N
118706	1693	14474505194973	14680	7441	21	0	\N
118707	1693	14358346279379	14680	7441	22	0	\N
118708	1693	14242187363785	14680	7441	23	0	\N
118709	1693	14126028448191	14680	7441	24	0	\N
118710	1693	14009869532597	14680	7441	25	0	\N
118711	1693	13893710617003	14680	7441	26	0	\N
118712	1693	13777551701409	14680	7441	27	0	\N
118713	1693	13661392785815	14680	7441	28	0	\N
118714	1693	13545233870221	14680	7441	29	0	\N
118715	1693	13429074954627	14680	7441	30	0	\N
118716	1693	13312916039033	14680	7441	31	0	\N
118717	1693	13196757123439	14680	7441	32	0	\N
118718	1397	1356861820000	14681	7478	0	0	\N
118719	1397	1356851819000	14681	7478	1	0	\N
118720	1397	1356841818000	14681	7478	2	0	\N
118721	1693	9381751210067	14681	7478	3	0	\N
118722	1693	9265592294473	14681	7478	4	0	\N
118723	1693	9149433378879	14681	7478	5	0	\N
118724	1693	9033274463285	14681	7478	6	0	\N
118725	1693	8917115547691	14681	7478	7	0	\N
118726	1693	8800956632097	14681	7478	8	0	\N
118727	1693	8684797716503	14681	7478	9	0	\N
118728	1693	8681268052407	14681	7478	10	0	\N
118623	1397	1356891823000	14677	7476	2	0	8194
118624	1693	13707519798687	14677	7476	3	0	709
118625	1693	13591360883093	14677	7476	4	0	710
118626	1693	13475201967499	14677	7476	5	0	711
118627	1693	13359043051905	14677	7476	6	0	712
118629	1693	13126725220717	14677	7476	8	0	714
118630	1693	13010566305123	14677	7476	9	0	715
118631	1693	12894407389529	14677	7476	10	0	716
118632	1693	12778248473935	14677	7476	11	0	717
118633	1693	12662089558341	14677	7476	12	0	718
118635	1693	12429771727153	14677	7476	14	0	720
118636	1693	12313612811559	14677	7476	15	0	721
118637	1693	12197453895965	14677	7476	16	0	722
118638	1693	12081294980371	14677	7476	17	0	723
118640	1693	11848977149183	14677	7476	19	0	725
118641	1693	11732818233589	14677	7476	20	0	726
118642	1726	663601752000	14677	7476	21	0	7390
118643	1726	663600749000	14677	7476	22	0	7391
118644	1726	663599746000	14677	7476	23	0	7392
118646	1397	1356881822000	14678	7477	1	0	8195
118647	1693	11613129653899	14678	7477	2	0	728
118648	1693	10543340366007	14678	7477	3	0	729
118649	1693	10427181450413	14678	7477	4	0	730
118650	1693	10311022534819	14678	7477	5	0	731
118652	1693	10078704703631	14678	7477	7	0	733
118653	1693	9962545788037	14678	7477	8	0	734
118654	1397	1356871821000	14678	7477	9	0	8196
118655	1693	9846386872443	14678	7477	10	0	735
118657	1693	9614069041255	14678	7477	13	0	737
118658	1693	9497910125661	14678	7477	14	0	738
118659	1726	663598743000	14678	7477	15	0	7393
118660	1726	663597740000	14678	7477	16	0	7394
118661	1397	1356861820000	14679	7478	0	0	8197
118663	1397	1356841818000	14679	7478	2	0	8199
118664	1693	9381751210067	14679	7478	3	0	739
118665	1693	9265592294473	14679	7478	4	0	740
118666	1693	9149433378879	14679	7478	5	0	741
118667	1693	9033274463285	14679	7478	6	0	742
118669	1693	8800956632097	14679	7478	8	0	744
118670	1693	8684797716503	14679	7478	9	0	745
118671	1693	8681268052407	14679	7478	10	0	746
118672	1693	8565109136813	14679	7478	11	0	747
118674	1693	8332791305625	14679	7478	13	0	749
118675	1693	8216632390031	14679	7478	14	0	750
118676	1693	8100473474437	14679	7478	15	0	751
118677	1693	7984314558843	14679	7478	16	0	752
118678	1693	7868155643249	14679	7478	17	0	753
118680	1693	7739667903289	14679	7478	19	0	755
118681	1693	6854879078821	14679	7478	20	0	756
118682	1726	663596737000	14679	7478	21	0	7395
118683	1726	663595734000	14679	7478	22	0	7396
118684	1726	663594731000	14679	7478	23	0	7397
118729	1693	8565109136813	14681	7478	11	0	\N
118730	1693	8448950221219	14681	7478	12	0	\N
118731	1693	8332791305625	14681	7478	13	0	\N
118732	1693	8216632390031	14681	7478	14	0	\N
118733	1693	8100473474437	14681	7478	15	0	\N
118734	1693	7984314558843	14681	7478	16	0	\N
118735	1693	7868155643249	14681	7478	17	0	\N
118736	1693	7751996727655	14681	7478	18	0	\N
118737	1693	7739667903289	14681	7478	19	0	\N
118738	1693	6854879078821	14681	7478	20	0	\N
118739	1726	663596737000	14681	7478	21	0	\N
118740	1726	663595734000	14681	7478	22	0	\N
118741	1726	663594731000	14681	7478	23	0	\N
118742	1397	1356861820000	14682	7478	0	0	\N
118743	1397	1356851819000	14682	7478	1	0	\N
118744	1397	1356841818000	14682	7478	2	0	\N
118745	1693	9381751210067	14682	7478	3	0	\N
118746	1693	9265592294473	14682	7478	4	0	\N
118747	1693	9149433378879	14682	7478	5	0	\N
118748	1693	9033274463285	14682	7478	6	0	\N
118749	1693	8917115547691	14682	7478	7	0	\N
118750	1693	8800956632097	14682	7478	8	0	\N
118751	1693	8684797716503	14682	7478	9	0	\N
118752	1693	8681268052407	14682	7478	10	0	\N
118753	1693	8565109136813	14682	7478	11	0	\N
118754	1693	8448950221219	14682	7478	12	0	\N
118755	1693	8332791305625	14682	7478	13	0	\N
118756	1693	8216632390031	14682	7478	14	0	\N
118757	1693	8100473474437	14682	7478	15	0	\N
118758	1693	7984314558843	14682	7478	16	0	\N
118759	1693	7868155643249	14682	7478	17	0	\N
118760	1693	7751996727655	14682	7478	18	0	\N
118761	1693	7739667903289	14682	7478	19	0	\N
118762	1693	6854879078821	14682	7478	20	0	\N
118763	1726	663596737000	14682	7478	21	0	\N
118764	1726	663595734000	14682	7478	22	0	\N
118765	1726	663594731000	14682	7478	23	0	\N
118766	1693	19957441239447	14683	7419	0	0	\N
118767	1693	19923642464009	14683	7419	1	0	\N
118768	1693	19807483548415	14683	7419	2	0	\N
118769	1693	18221957475715	14683	7419	3	0	\N
118770	1693	17391119617299	14683	7419	4	0	\N
118771	1693	17274960701705	14683	7419	5	0	\N
118772	1693	17158801786111	14683	7419	6	0	\N
118773	1693	17042642870517	14683	7419	7	0	\N
118774	1693	17033833710256	14683	7419	8	0	\N
118775	1693	16917674794662	14683	7419	9	0	\N
118776	1693	16801515879068	14683	7419	10	0	\N
118777	1693	16685356963474	14683	7419	11	0	\N
118778	1693	16367551211605	14683	7419	12	0	\N
118779	1693	15827584407868	14683	7419	13	0	\N
118780	1693	15711425492274	14683	7419	14	0	\N
118781	1693	15595266576680	14683	7419	15	0	\N
118782	1693	15479107661086	14683	7419	16	0	\N
118783	1693	15362948745492	14683	7419	17	0	\N
118784	1693	14822981941755	14683	7419	18	0	\N
118785	1693	14706823026161	14683	7419	19	0	\N
118786	1693	14590664110567	14683	7419	20	0	\N
118787	1693	14474505194973	14683	7419	21	0	\N
118788	1693	14358346279379	14683	7419	22	0	\N
118789	1693	14242187363785	14683	7419	23	0	\N
118790	1693	14126028448191	14683	7419	24	0	\N
118791	1693	14009869532597	14683	7419	25	0	\N
118792	1693	13893710617003	14683	7419	26	0	\N
118793	1693	13777551701409	14683	7419	27	0	\N
118794	1693	13661392785815	14683	7419	28	0	\N
118795	1693	13545233870221	14683	7419	29	0	\N
118805	1693	6738720163227	14685	7479	0	0	\N
118806	1397	1356831817000	14685	7479	1	0	\N
118807	1693	6622561247633	14685	7479	2	0	\N
118808	1693	6506402332039	14685	7479	3	0	\N
118809	1693	6390243416445	14685	7479	4	0	\N
118810	1693	6274084500851	14685	7479	5	0	\N
118811	1693	6157925585257	14685	7479	6	0	\N
118812	1749	2405105000000	14685	7479	7	0	\N
118813	1726	663593728000	14685	7479	8	0	\N
118814	1397	1356831817000	14686	7479	0	0	\N
118815	1749	2405105000000	14686	7479	1	0	\N
118816	1726	663593728000	14686	7479	2	0	\N
118817	1397	1356821816000	14687	7480	0	0	\N
118818	1693	6041766669663	14687	7480	1	0	\N
118819	1693	5925607754069	14687	7480	2	0	\N
118820	1693	5809448838475	14687	7480	3	0	\N
118821	1693	5693289922881	14687	7480	4	0	\N
118822	1693	5577131007287	14687	7480	5	0	\N
118823	1726	663592725000	14687	7480	6	0	\N
118831	1397	1356811815000	14689	7481	0	0	\N
118832	1693	5460972091693	14689	7481	1	0	\N
118833	1693	5344813176099	14689	7481	2	0	\N
118834	1693	2363768070939	14689	7481	3	0	\N
118835	1693	2360238406843	14689	7481	4	0	\N
118836	1726	663591722000	14689	7481	5	0	\N
118843	1397	1356811815000	14691	7481	0	0	\N
118844	1693	5460972091693	14691	7481	1	0	\N
118845	1693	5344813176099	14691	7481	2	0	\N
118846	1693	2363768070939	14691	7481	3	0	\N
118847	1693	2360238406843	14691	7481	4	0	\N
118848	1726	663591722000	14691	7481	5	0	\N
118849	1397	1356801814000	14692	7482	0	0	\N
118850	1726	663590719000	14692	7482	1	0	\N
118853	1397	1356791813000	14694	7483	0	0	\N
118854	1397	1356781812000	14694	7483	1	0	\N
118855	1726	663589716000	14694	7483	2	0	\N
118856	1726	663588713000	14694	7483	3	0	\N
118861	1397	1356771811000	14696	7484	0	0	\N
118862	1726	663587710000	14696	7484	1	0	\N
118798	1693	6622561247633	14684	7479	2	0	758
118799	1693	6506402332039	14684	7479	3	0	759
118800	1693	6390243416445	14684	7479	4	0	760
118801	1693	6274084500851	14684	7479	5	0	761
118802	1693	6157925585257	14684	7479	6	0	762
118804	1726	663593728000	14684	7479	8	0	7398
118824	1397	1356821816000	14688	7480	0	0	8201
118825	1693	6041766669663	14688	7480	1	0	763
118826	1693	5925607754069	14688	7480	2	0	764
118827	1693	5809448838475	14688	7480	3	0	765
118829	1693	5577131007287	14688	7480	5	0	767
118830	1726	663592725000	14688	7480	6	0	7399
118837	1397	1356811815000	14690	7481	0	0	8202
118838	1693	5460972091693	14690	7481	1	0	768
118840	1693	2363768070939	14690	7481	3	0	770
118841	1693	2360238406843	14690	7481	4	0	771
118842	1726	663591722000	14690	7481	5	0	7400
118851	1397	1356801814000	14693	7482	0	0	8203
118852	1726	663590719000	14693	7482	1	0	7401
118858	1397	1356781812000	14695	7483	1	0	8205
118859	1726	663589716000	14695	7483	2	0	7402
118860	1726	663588713000	14695	7483	3	0	7403
118863	1397	1356771811000	14697	7484	0	0	8206
118864	1726	663587710000	14697	7484	1	0	7404
118867	1397	1356761810000	14699	7485	0	0	\N
118868	1726	663586707000	14699	7485	1	0	\N
118869	1693	16357331239447	14700	7230	0	0	\N
118870	1693	16323532464009	14700	7230	1	0	\N
118871	1693	16207373548415	14700	7230	2	0	\N
118872	1693	14621847475715	14700	7230	3	0	\N
118873	1693	13791009617299	14700	7230	4	0	\N
118874	1693	13674850701705	14700	7230	5	0	\N
118875	1693	13558691786111	14700	7230	6	0	\N
118876	1693	13442532870517	14700	7230	7	0	\N
118877	1693	13433723710256	14700	7230	8	0	\N
118878	1693	13317564794662	14700	7230	9	0	\N
118879	1693	13201405879068	14700	7230	10	0	\N
118880	1693	13085246963474	14700	7230	11	0	\N
118881	1693	12767441211605	14700	7230	12	0	\N
118882	1693	12227474407868	14700	7230	13	0	\N
118883	1693	12111315492274	14700	7230	14	0	\N
118884	1693	11995156576680	14700	7230	15	0	\N
118885	1693	11878997661086	14700	7230	16	0	\N
118886	1693	11762838745492	14700	7230	17	0	\N
118887	1693	11222871941755	14700	7230	18	0	\N
118888	1693	11106713026161	14700	7230	19	0	\N
118889	1693	10990554110567	14700	7230	20	0	\N
118890	1693	10874395194973	14700	7230	21	0	\N
118891	1693	10758236279379	14700	7230	22	0	\N
118892	1693	10642077363785	14700	7230	23	0	\N
118893	1693	10525918448191	14700	7230	24	0	\N
118894	1693	10409759532597	14700	7230	25	0	\N
118895	1693	10293600617003	14700	7230	26	0	\N
118896	1693	10177441701409	14700	7230	27	0	\N
118897	1693	10061282785815	14700	7230	28	0	\N
118898	1693	9945123870221	14700	7230	29	0	\N
118899	1693	9828964954627	14700	7230	30	0	\N
118900	1693	9712806039033	14700	7230	31	0	\N
118901	1693	9596647123439	14700	7230	32	0	\N
118902	1693	9480488207845	14700	7230	33	0	\N
118903	1693	9364329292251	14700	7230	34	0	\N
118904	1693	9248170376657	14700	7230	35	0	\N
118905	1693	9132011461063	14700	7230	36	0	\N
118906	1693	9015852545469	14700	7230	37	0	\N
118907	1693	8899693629875	14700	7230	38	0	\N
118908	1693	8783534714281	14700	7230	39	0	\N
118909	1693	8667375798687	14700	7230	40	0	\N
118910	1693	8551216883093	14700	7230	41	0	\N
118911	1693	8435057967499	14700	7230	42	0	\N
118912	1693	8318899051905	14700	7230	43	0	\N
118913	1693	8202740136311	14700	7230	44	0	\N
118914	1693	8086581220717	14700	7230	45	0	\N
118915	1693	7970422305123	14700	7230	46	0	\N
118916	1693	7854263389529	14700	7230	47	0	\N
118917	1693	7738104473935	14700	7230	48	0	\N
118918	1693	7621945558341	14700	7230	49	0	\N
118919	1693	7505786642747	14700	7230	50	0	\N
118920	1693	7389627727153	14700	7230	51	0	\N
118921	1693	7273468811559	14700	7230	52	0	\N
118922	1693	7157309895965	14700	7230	53	0	\N
118923	1693	7041150980371	14700	7230	54	0	\N
118924	1693	6924992064777	14700	7230	55	0	\N
118925	1693	6808833149183	14700	7230	56	0	\N
118926	1693	6692674233589	14700	7230	57	0	\N
118927	1693	6576515317995	14700	7230	58	0	\N
118928	1693	6572985653899	14700	7230	59	0	\N
118929	1693	5503196366007	14700	7230	60	0	\N
118930	1693	5387037450413	14700	7230	61	0	\N
118931	1693	5270878534819	14700	7230	62	0	\N
118932	1693	5154719619225	14700	7230	63	0	\N
118933	1693	5038560703631	14700	7230	64	0	\N
118934	1693	4922401788037	14700	7230	65	0	\N
118935	1693	4806242872443	14700	7230	66	0	\N
118936	1693	4690083956849	14700	7230	67	0	\N
118937	1397	1356751809000	14701	7486	0	0	\N
118938	1397	1356741808000	14701	7486	1	0	\N
118939	1726	663585704000	14701	7486	2	0	\N
118940	1726	663584701000	14701	7486	3	0	\N
118941	1397	1356751809000	14702	7486	0	0	\N
118942	1397	1356741808000	14702	7486	1	0	\N
118943	1726	663585704000	14702	7486	2	0	\N
118944	1726	663584701000	14702	7486	3	0	\N
118951	1397	1356721806000	14705	7488	0	0	\N
118952	1726	663582695000	14705	7488	1	0	\N
118955	1397	1356721806000	14707	7488	0	0	\N
118956	1726	663582695000	14707	7488	1	0	\N
118968	1397	1356691803000	14710	7490	0	0	\N
118969	1397	1356681802000	14710	7490	1	0	\N
118970	1397	1356671801000	14710	7490	2	0	\N
118971	1726	663579686000	14710	7490	3	0	\N
118972	1726	663578683000	14710	7490	4	0	\N
118973	1726	663577680000	14710	7490	5	0	\N
118974	647	66234984938283	14711	7419	0	0	\N
118975	1397	1357641898000	14711	7419	1	0	\N
118976	1693	19957441239447	14711	7419	2	0	\N
118977	1397	1357631897000	14711	7419	3	0	\N
118978	1397	1357621896000	14711	7419	4	0	\N
118979	1397	1357611895000	14711	7419	5	0	\N
118980	1397	1357601894000	14711	7419	6	0	\N
118981	1397	1357591893000	14711	7419	7	0	\N
118982	1397	1357581892000	14711	7419	8	0	\N
118983	1397	1357571891000	14711	7419	9	0	\N
118984	1397	1357561890000	14711	7419	10	0	\N
118985	1397	1357551889000	14711	7419	11	0	\N
118986	1693	19923642464009	14711	7419	12	0	\N
118987	1693	19807483548415	14711	7419	13	0	\N
118988	1693	18221957475715	14711	7419	14	0	\N
118989	1693	17391119617299	14711	7419	15	0	\N
118990	1397	1357541888000	14711	7419	16	0	\N
118991	1397	1357531887000	14711	7419	17	0	\N
118992	1397	1357521886000	14711	7419	18	0	\N
118993	1397	1357511885000	14711	7419	19	0	\N
118994	1397	1357501884000	14711	7419	20	0	\N
118995	1397	1357491883000	14711	7419	21	0	\N
118996	1397	1357481882000	14711	7419	22	0	\N
118997	1397	1357471881000	14711	7419	24	0	\N
118998	1397	1357461880000	14711	7419	25	0	\N
118999	1693	17274960701705	14711	7419	26	0	\N
119000	1693	17158801786111	14711	7419	27	0	\N
118945	1397	1356751809000	14703	7486	0	0	8208
118946	1397	1356741808000	14703	7486	1	0	8209
118947	1726	663585704000	14703	7486	2	0	7406
118948	1726	663584701000	14703	7486	3	0	7407
118949	1397	1356731807000	14704	7487	0	0	8210
118953	1397	1356721806000	14706	7488	0	0	8211
118954	1726	663582695000	14706	7488	1	0	7409
118957	1397	1356711805000	14708	7489	0	0	8212
118958	1397	1356701804000	14708	7489	1	0	8213
118959	1693	860228406843	14708	7489	2	0	772
118961	1726	663580689000	14708	7489	4	0	7411
118962	1397	1356691803000	14709	7490	0	0	8214
118963	1397	1356681802000	14709	7490	1	0	8215
118964	1397	1356671801000	14709	7490	2	0	8216
118966	1726	663578683000	14709	7490	4	0	7413
118967	1726	663577680000	14709	7490	5	0	7414
119001	1693	17042642870517	14711	7419	28	0	\N
119002	1693	17033833710256	14711	7419	29	0	\N
119003	1693	16917674794662	14711	7419	30	0	\N
119004	1693	16801515879068	14711	7419	31	0	\N
119005	1693	16685356963474	14711	7419	32	0	\N
119006	1693	16367551211605	14711	7419	33	0	\N
119007	1693	15827584407868	14711	7419	34	0	\N
119008	1693	15711425492274	14711	7419	35	0	\N
119009	1693	15595266576680	14711	7419	36	0	\N
119010	1693	15479107661086	14711	7419	37	0	\N
119011	1693	15362948745492	14711	7419	38	0	\N
119012	1693	14822981941755	14711	7419	39	0	\N
119013	1693	14706823026161	14711	7419	40	0	\N
119014	1693	14590664110567	14711	7419	41	0	\N
119015	1693	14474505194973	14711	7419	42	0	\N
119016	1693	14358346279379	14711	7419	43	0	\N
119017	1693	14242187363785	14711	7419	44	0	\N
119018	1693	14126028448191	14711	7419	45	0	\N
119019	1693	14009869532597	14711	7419	46	0	\N
119020	1693	13893710617003	14711	7419	47	0	\N
119021	1693	13777551701409	14711	7419	48	0	\N
119022	1693	13661392785815	14711	7419	49	0	\N
119023	1693	13545233870221	14711	7419	50	0	\N
119024	1693	13429074954627	14711	7419	51	0	\N
119025	1693	13312916039033	14711	7419	52	0	\N
119026	1693	13196757123439	14711	7419	53	0	\N
119027	1693	13080598207845	14711	7419	54	0	\N
119028	1693	12964439292251	14711	7419	55	0	\N
119029	1693	12848280376657	14711	7419	56	0	\N
119030	1693	12732121461063	14711	7419	57	0	\N
119031	1693	12615962545469	14711	7419	58	0	\N
119032	1693	12499803629875	14711	7419	59	0	\N
119033	1693	12383644714281	14711	7419	60	0	\N
119034	1693	12267485798687	14711	7419	61	0	\N
119035	1693	12151326883093	14711	7419	62	0	\N
119036	1693	12035167967499	14711	7419	63	0	\N
119037	1693	11919009051905	14711	7419	64	0	\N
119038	1693	11802850136311	14711	7419	65	0	\N
119039	1693	11686691220717	14711	7419	66	0	\N
119040	1693	11570532305123	14711	7419	67	0	\N
119041	1693	11454373389529	14711	7419	68	0	\N
119042	1693	11338214473935	14711	7419	69	0	\N
119043	1693	11222055558341	14711	7419	70	0	\N
119044	1693	11105896642747	14711	7419	71	0	\N
119045	1693	10989737727153	14711	7419	72	0	\N
119046	1693	10873578811559	14711	7419	73	0	\N
119047	1693	10757419895965	14711	7419	74	0	\N
119048	1693	10641260980371	14711	7419	75	0	\N
119049	1693	10525102064777	14711	7419	76	0	\N
119050	1693	10408943149183	14711	7419	77	0	\N
119051	1693	10292784233589	14711	7419	78	0	\N
119052	1693	10176625317995	14711	7419	79	0	\N
119053	1693	10173095653899	14711	7419	80	0	\N
119054	1693	9103306366007	14711	7419	81	0	\N
119055	1693	8987147450413	14711	7419	82	0	\N
119056	1693	8870988534819	14711	7419	83	0	\N
119057	1693	8754829619225	14711	7419	84	0	\N
119058	1693	8638670703631	14711	7419	85	0	\N
119059	1693	8522511788037	14711	7419	86	0	\N
119060	1693	8406352872443	14711	7419	87	0	\N
119061	1693	8290193956849	14711	7419	88	0	\N
119062	1693	8174035041255	14711	7419	89	0	\N
119063	1693	8057876125661	14711	7419	90	0	\N
119064	1693	7941717210067	14711	7419	91	0	\N
119065	1693	7825558294473	14711	7419	92	0	\N
119066	1693	7709399378879	14711	7419	93	0	\N
119067	1693	7593240463285	14711	7419	94	0	\N
119068	1693	7477081547691	14711	7419	95	0	\N
119069	1693	7360922632097	14711	7419	96	0	\N
119070	1693	7244763716503	14711	7419	97	0	\N
119071	1693	7241234052407	14711	7419	98	0	\N
119072	1693	7125075136813	14711	7419	99	0	\N
119073	1693	7008916221219	14711	7419	100	0	\N
119074	1693	6892757305625	14711	7419	101	0	\N
119075	1693	6776598390031	14711	7419	102	0	\N
119076	1693	6660439474437	14711	7419	103	0	\N
119077	1693	6544280558843	14711	7419	104	0	\N
119078	1693	6428121643249	14711	7419	105	0	\N
119079	1693	6311962727655	14711	7419	106	0	\N
119080	1693	6299633903289	14711	7419	107	0	\N
119081	1693	5414845078821	14711	7419	108	0	\N
119082	1693	5298686163227	14711	7419	109	0	\N
119083	1693	5182527247633	14711	7419	110	0	\N
119084	1693	5066368332039	14711	7419	111	0	\N
119085	1693	4950209416445	14711	7419	112	0	\N
119086	1693	4834050500851	14711	7419	113	0	\N
119087	1693	4717891585257	14711	7419	114	0	\N
119088	1693	4601732669663	14711	7419	115	0	\N
119089	1693	4485573754069	14711	7419	116	0	\N
119090	1693	4369414838475	14711	7419	117	0	\N
119091	1693	4253255922881	14711	7419	118	0	\N
119092	1693	4137097007287	14711	7419	119	0	\N
119093	1693	4020938091693	14711	7419	120	0	\N
119094	1693	3904779176099	14711	7419	121	0	\N
119095	1693	923734070939	14711	7419	122	0	\N
119096	1693	920204406843	14711	7419	123	0	\N
119097	1397	1357451879000	14711	7419	124	0	\N
119098	1397	1357441878000	14711	7419	125	0	\N
119099	647	66234984938283	14712	7290	0	0	\N
119100	1693	17797370239447	14712	7290	1	0	\N
119101	1693	17763571464009	14712	7290	2	0	\N
119102	1693	17647412548415	14712	7290	3	0	\N
119103	1693	16061886475715	14712	7290	4	0	\N
119104	1693	15231048617299	14712	7290	5	0	\N
119105	1693	15114889701705	14712	7290	6	0	\N
119106	1693	14998730786111	14712	7290	7	0	\N
119107	1693	14882571870517	14712	7290	8	0	\N
119108	1693	14873762710256	14712	7290	9	0	\N
119109	1693	14757603794662	14712	7290	10	0	\N
119110	1693	14641444879068	14712	7290	11	0	\N
119111	1693	14525285963474	14712	7290	12	0	\N
119112	1693	14207480211605	14712	7290	13	0	\N
119113	1693	13667513407868	14712	7290	14	0	\N
119114	1693	13551354492274	14712	7290	15	0	\N
119115	1693	13435195576680	14712	7290	16	0	\N
119116	1693	13319036661086	14712	7290	17	0	\N
119117	1693	13202877745492	14712	7290	18	0	\N
119118	1693	12662910941755	14712	7290	19	0	\N
119119	1693	12546752026161	14712	7290	20	0	\N
119120	1693	12430593110567	14712	7290	21	0	\N
119121	1693	12314434194973	14712	7290	22	0	\N
119122	1693	12198275279379	14712	7290	23	0	\N
119123	1693	12082116363785	14712	7290	24	0	\N
119124	1693	11965957448191	14712	7290	25	0	\N
119125	1693	11849798532597	14712	7290	26	0	\N
119126	1693	11733639617003	14712	7290	27	0	\N
119127	1693	11617480701409	14712	7290	28	0	\N
119128	1693	11501321785815	14712	7290	29	0	\N
119129	1693	11385162870221	14712	7290	30	0	\N
119130	1693	11269003954627	14712	7290	31	0	\N
119131	1693	11152845039033	14712	7290	32	0	\N
119132	1693	11036686123439	14712	7290	33	0	\N
119133	1693	10920527207845	14712	7290	34	0	\N
119134	1693	10804368292251	14712	7290	35	0	\N
119145	1397	1356661800000	14715	7491	0	0	\N
119146	1397	1356651799000	14715	7491	1	0	\N
119147	1397	1356641798000	14715	7491	2	0	\N
119148	1397	1356631797000	14715	7491	3	0	\N
119149	1397	1356621796000	14715	7491	4	0	\N
119150	1726	663576677000	14715	7491	5	0	\N
119151	1726	663575674000	14715	7491	6	0	\N
119152	1726	663574671000	14715	7491	7	0	\N
119153	1726	663573668000	14715	7491	8	0	\N
119154	1726	663572665000	14715	7491	9	0	\N
119157	1397	1356601794000	14717	7493	0	0	\N
119158	1726	663570659000	14717	7493	1	0	\N
119170	1397	1356551789000	14723	7497	0	0	\N
119171	1726	663566647000	14723	7497	1	0	\N
119172	1397	1356551789000	14724	7497	0	0	\N
119173	1726	663566647000	14724	7497	1	0	\N
119174	1397	1356551789000	14725	7497	0	0	\N
119175	1726	663566647000	14725	7497	1	0	\N
119176	1397	1356541788000	14726	7498	0	0	\N
119177	1397	1356531787000	14726	7498	1	0	\N
119178	1726	663565644000	14726	7498	2	0	\N
119179	1726	663564641000	14726	7498	3	0	\N
119180	1397	1356541788000	14727	7498	0	0	\N
119181	1397	1356531787000	14727	7498	1	0	\N
119182	1726	663565644000	14727	7498	2	0	\N
119183	1726	663564641000	14727	7498	3	0	\N
119190	1397	1356521786000	14730	7499	0	0	\N
119191	1726	663563638000	14730	7499	1	0	\N
119192	1397	1356511785000	14731	7500	0	0	\N
119193	1397	1356501784000	14731	7500	1	0	\N
119194	1397	1356491783000	14731	7500	2	0	\N
119195	1397	1356481782000	14731	7500	3	0	\N
119196	1726	663562635000	14731	7500	4	0	\N
119197	1726	663561632000	14731	7500	5	0	\N
119198	1726	663560629000	14731	7500	6	0	\N
119199	1726	663559626000	14731	7500	7	0	\N
119208	1397	1356511785000	14733	7500	0	0	\N
119209	1397	1356501784000	14733	7500	1	0	\N
119210	1397	1356491783000	14733	7500	2	0	\N
119211	1397	1356481782000	14733	7500	3	0	\N
119212	1726	663562635000	14733	7500	4	0	\N
119213	1726	663561632000	14733	7500	5	0	\N
119214	1726	663560629000	14733	7500	6	0	\N
119215	1726	663559626000	14733	7500	7	0	\N
119224	1397	1356431777000	14737	7502	0	0	\N
119225	1726	663554611000	14737	7502	1	0	\N
119230	1397	1356421776000	14740	7503	0	0	\N
119231	1726	663553608000	14740	7503	1	0	\N
119236	1397	1356411775000	14742	7504	0	0	\N
119237	1397	1356401774000	14742	7504	1	0	\N
119238	1726	663552605000	14742	7504	2	0	\N
119239	1726	663551602000	14742	7504	3	0	\N
119240	1397	1356411775000	14743	7504	0	0	\N
119241	1397	1356401774000	14743	7504	1	0	\N
119242	1726	663552605000	14743	7504	2	0	\N
119243	1726	663551602000	14743	7504	3	0	\N
119246	647	66234984938283	14745	7253	0	0	\N
119247	1693	16357331239447	14745	7253	1	0	\N
119248	1693	16323532464009	14745	7253	2	0	\N
119249	1693	16207373548415	14745	7253	3	0	\N
119250	1693	14621847475715	14745	7253	4	0	\N
119251	1693	13791009617299	14745	7253	5	0	\N
119252	1693	13674850701705	14745	7253	6	0	\N
119253	1693	13558691786111	14745	7253	7	0	\N
119254	1693	13442532870517	14745	7253	8	0	\N
119255	1693	13433723710256	14745	7253	9	0	\N
119256	1693	13317564794662	14745	7253	10	0	\N
119257	1693	13201405879068	14745	7253	11	0	\N
119258	1693	13085246963474	14745	7253	12	0	\N
119259	1693	12767441211605	14745	7253	13	0	\N
119260	1693	12227474407868	14745	7253	14	0	\N
119261	1693	12111315492274	14745	7253	15	0	\N
119262	1693	11995156576680	14745	7253	16	0	\N
119263	1693	11878997661086	14745	7253	17	0	\N
119264	1693	11762838745492	14745	7253	18	0	\N
119265	1693	11222871941755	14745	7253	19	0	\N
119266	1693	11106713026161	14745	7253	20	0	\N
119267	1693	10990554110567	14745	7253	21	0	\N
119268	1693	10874395194973	14745	7253	22	0	\N
119269	1693	10758236279379	14745	7253	23	0	\N
119270	1693	10642077363785	14745	7253	24	0	\N
119271	1693	10525918448191	14745	7253	25	0	\N
119272	1693	10409759532597	14745	7253	26	0	\N
119139	1397	1356621796000	14714	7491	4	0	8221
119140	1726	663576677000	14714	7491	5	0	7415
119141	1726	663575674000	14714	7491	6	0	7416
119142	1726	663574671000	14714	7491	7	0	7417
119143	1726	663573668000	14714	7491	8	0	7418
119155	1397	1356611795000	14716	7492	0	0	8222
119156	1726	663571662000	14716	7492	1	0	7420
119159	1397	1356601794000	14718	7493	0	0	8223
119160	1726	663570659000	14718	7493	1	0	7421
119161	1397	1356591793000	14719	7494	0	0	8224
119163	1397	1356581792000	14720	7495	0	0	8225
119164	1397	1356571791000	14720	7495	1	0	8226
119165	1726	663568653000	14720	7495	2	0	7423
119166	1726	663567650000	14720	7495	3	0	7424
119168	1397	1356551789000	14722	7497	0	0	8228
119169	1726	663566647000	14722	7497	1	0	7425
119184	1397	1356541788000	14728	7498	0	0	8229
119185	1397	1356531787000	14728	7498	1	0	8230
119186	1726	663565644000	14728	7498	2	0	7426
119188	1397	1356521786000	14729	7499	0	0	8231
119189	1726	663563638000	14729	7499	1	0	7428
119200	1397	1356511785000	14732	7500	0	0	8232
119201	1397	1356501784000	14732	7500	1	0	8233
119202	1397	1356491783000	14732	7500	2	0	8234
119204	1726	663562635000	14732	7500	4	0	7429
119205	1726	663561632000	14732	7500	5	0	7430
119206	1726	663560629000	14732	7500	6	0	7431
119207	1726	663559626000	14732	7500	7	0	7432
119217	1397	1356461780000	14736	7501	1	0	8237
119218	1397	1356451779000	14736	7501	2	0	8238
119219	1397	1356441778000	14736	7501	3	0	8239
119220	1726	663558623000	14736	7501	4	0	7433
119221	1726	663557620000	14736	7501	5	0	7434
119223	1726	663555614000	14736	7501	7	0	7436
119226	1397	1356431777000	14738	7502	0	0	8240
119227	1726	663554611000	14738	7502	1	0	7437
119228	1397	1356421776000	14739	7503	0	0	8241
119229	1726	663553608000	14739	7503	1	0	7438
119233	1397	1356401774000	14741	7504	1	0	8243
119234	1726	663552605000	14741	7504	2	0	7439
119235	1726	663551602000	14741	7504	3	0	7440
119244	1397	1356391773000	14744	7505	0	0	8244
119273	1693	10293600617003	14745	7253	27	0	\N
119274	1693	10177441701409	14745	7253	28	0	\N
119275	1693	10061282785815	14745	7253	29	0	\N
119276	1693	9945123870221	14745	7253	30	0	\N
119277	1693	9828964954627	14745	7253	31	0	\N
119278	1693	9712806039033	14745	7253	32	0	\N
119279	1693	9596647123439	14745	7253	33	0	\N
119280	1693	9480488207845	14745	7253	34	0	\N
119281	1693	9364329292251	14745	7253	35	0	\N
119282	1693	9248170376657	14745	7253	36	0	\N
119283	1693	9132011461063	14745	7253	37	0	\N
119284	1693	9015852545469	14745	7253	38	0	\N
119285	1693	8899693629875	14745	7253	39	0	\N
119286	1693	8783534714281	14745	7253	40	0	\N
119287	1693	8667375798687	14745	7253	41	0	\N
119288	1693	8551216883093	14745	7253	42	0	\N
119289	1693	8435057967499	14745	7253	43	0	\N
119290	1693	8318899051905	14745	7253	44	0	\N
119291	1693	8202740136311	14745	7253	46	0	\N
119292	1693	8086581220717	14745	7253	47	0	\N
119293	1693	7970422305123	14745	7253	48	0	\N
119294	1693	7854263389529	14745	7253	49	0	\N
119295	1693	7738104473935	14745	7253	50	0	\N
119296	1693	7621945558341	14745	7253	51	0	\N
119297	1693	7505786642747	14745	7253	52	0	\N
119298	1693	7389627727153	14745	7253	53	0	\N
119299	1693	7273468811559	14745	7253	54	0	\N
119300	1693	7157309895965	14745	7253	55	0	\N
119301	1693	7041150980371	14745	7253	56	0	\N
119302	1693	6924992064777	14745	7253	57	0	\N
119303	1693	6808833149183	14745	7253	58	0	\N
119304	1693	6692674233589	14745	7253	59	0	\N
119305	1693	6576515317995	14745	7253	60	0	\N
119306	1693	6572985653899	14745	7253	61	0	\N
119307	1693	5503196366007	14745	7253	62	0	\N
119308	1693	5387037450413	14745	7253	63	0	\N
119309	1693	5270878534819	14745	7253	64	0	\N
119310	1693	5154719619225	14745	7253	65	0	\N
119311	1693	5038560703631	14745	7253	66	0	\N
119312	1693	4922401788037	14745	7253	67	0	\N
119313	1693	4806242872443	14745	7253	68	0	\N
119314	1693	4690083956849	14745	7253	69	0	\N
119315	1693	4573925041255	14745	7253	70	0	\N
119316	1693	4457766125661	14745	7253	71	0	\N
119317	1693	4341607210067	14745	7253	72	0	\N
119318	1693	4225448294473	14745	7253	73	0	\N
119319	1693	4109289378879	14745	7253	74	0	\N
119320	1693	3993130463285	14745	7253	75	0	\N
119321	1693	3876971547691	14745	7253	76	0	\N
119322	1693	3760812632097	14745	7253	77	0	\N
119323	1693	3644653716503	14745	7253	78	0	\N
119324	1693	3641124052407	14745	7253	79	0	\N
119325	1693	3524965136813	14745	7253	80	0	\N
119326	1693	3408806221219	14745	7253	81	0	\N
119327	1693	3292647305625	14745	7253	82	0	\N
119328	1693	3176488390031	14745	7253	83	0	\N
119329	1693	3060329474437	14745	7253	84	0	\N
119330	1693	2944170558843	14745	7253	85	0	\N
119331	1693	2828011643249	14745	7253	86	0	\N
119332	1693	2711852727655	14745	7253	87	0	\N
119333	1693	2699523903289	14745	7253	88	0	\N
119334	1693	1814735078821	14745	7253	89	0	\N
119335	1693	1698576163227	14745	7253	90	0	\N
119336	1693	1582417247633	14745	7253	91	0	\N
119337	1693	1466258332039	14745	7253	92	0	\N
119338	1693	1350099416445	14745	7253	93	0	\N
119339	1693	1233940500851	14745	7253	94	0	\N
119340	1693	1117781585257	14745	7253	95	0	\N
119341	1693	1001622669663	14745	7253	96	0	\N
119342	1693	885463754069	14745	7253	97	0	\N
119343	1693	769304838475	14745	7253	98	0	\N
119344	1693	653145922881	14745	7253	99	0	\N
119345	1693	536987007287	14745	7253	100	0	\N
119356	1397	1356331767000	14750	7510	0	0	\N
119357	1726	663544581000	14750	7510	1	0	\N
119364	1397	1356301764000	14754	7513	0	0	\N
119365	1726	663541572000	14754	7513	1	0	\N
119370	1726	663539566000	14757	7515	0	0	\N
119376	1397	1356261760000	14761	7518	0	0	\N
119377	1726	663536557000	14761	7518	1	0	\N
119386	1397	1356251759000	14764	7519	0	0	\N
119387	1397	1356241758000	14764	7519	1	0	\N
119388	1397	1356231757000	14764	7519	2	0	\N
119389	1726	663535554000	14764	7519	3	0	\N
119390	1726	663534551000	14764	7519	4	0	\N
119391	1726	663533548000	14764	7519	5	0	\N
119392	1397	1356221756000	14765	7520	0	0	\N
119393	1397	1356211755000	14765	7520	2	0	\N
119394	1726	663532545000	14765	7520	3	0	\N
119395	1726	663531542000	14765	7520	4	0	\N
119400	1397	1356201754000	14767	7521	0	0	\N
119401	1726	663530539000	14767	7521	1	0	\N
119404	1397	1356201754000	14769	7521	0	0	\N
119405	1726	663530539000	14769	7521	1	0	\N
119348	1397	1356371771000	14747	7507	0	0	8246
119349	1397	1356361770000	14747	7507	1	0	8247
119350	1726	663548593000	14747	7507	2	0	7443
119351	1726	663547590000	14747	7507	3	0	7444
119352	1397	1356351769000	14748	7508	0	0	8248
119354	1397	1356341768000	14749	7509	0	0	8249
119355	1726	663545584000	14749	7509	1	0	7446
119358	1397	1356331767000	14751	7510	0	0	8250
119359	1726	663544581000	14751	7510	1	0	7447
119360	1397	1356321766000	14752	7511	0	0	8251
119362	1397	1356311765000	14753	7512	0	0	8252
119363	1726	663542575000	14753	7512	1	0	7449
119366	1397	1356301764000	14755	7513	0	0	8253
119367	1726	663541572000	14755	7513	1	0	7450
119369	1726	663540569000	14756	7514	1	0	7451
119371	1726	663539566000	14758	7515	0	0	7452
119372	1397	1356281762000	14759	7516	0	0	8255
119373	1726	663538563000	14759	7516	1	0	7453
119374	1397	1356271761000	14760	7517	0	0	8256
119378	1397	1356261760000	14762	7518	0	0	8257
119379	1726	663536557000	14762	7518	1	0	7455
119380	1397	1356251759000	14763	7519	0	0	8258
119381	1397	1356241758000	14763	7519	1	0	8259
119382	1397	1356231757000	14763	7519	2	0	8260
119384	1726	663534551000	14763	7519	4	0	7457
119385	1726	663533548000	14763	7519	5	0	7458
119396	1397	1356221756000	14766	7520	0	0	8261
119397	1397	1356211755000	14766	7520	2	0	8262
119399	1726	663531542000	14766	7520	4	0	7460
119402	1397	1356201754000	14768	7521	0	0	8263
119403	1726	663530539000	14768	7521	1	0	7461
119406	1397	1356191753000	14770	7522	0	0	8264
119407	1397	1356181752000	14770	7522	1	0	8265
119414	1397	1356151749000	14777	7525	0	0	\N
119415	1397	1356141748000	14777	7525	1	0	\N
119416	1397	1356131747000	14777	7525	2	0	\N
119417	1726	663525524000	14777	7525	3	0	\N
119418	1726	663524521000	14777	7525	4	0	\N
119419	1726	663523518000	14777	7525	5	0	\N
119426	1397	1356121746000	14779	7526	0	0	\N
119427	1726	663522515000	14779	7526	1	0	\N
119438	1397	1356091743000	14785	7529	0	0	\N
119439	1397	1356081742000	14785	7529	1	0	\N
119440	1726	663519506000	14785	7529	2	0	\N
119441	1726	663518503000	14785	7529	3	0	\N
119444	1397	1356071741000	14787	7530	0	0	\N
119445	1726	663517500000	14787	7530	1	0	\N
119466	1397	1355961730000	14796	7538	0	0	\N
119467	341	66000990000001	14796	7538	1	0	\N
119468	1726	663506467000	14796	7538	2	0	\N
119474	1397	1355941728000	14799	7540	0	0	\N
119475	1726	663504461000	14799	7540	1	0	\N
119487	1397	1355891723000	14803	7543	0	0	\N
119488	1726	663499446000	14803	7543	1	0	\N
119491	1397	1355881722000	14805	7544	0	0	\N
119492	606	71037726812962	14805	7544	1	0	\N
119493	1726	663498443000	14805	7544	2	0	\N
119494	1397	1355881722000	14806	7544	0	0	\N
119495	606	71037726812962	14806	7544	1	0	\N
119499	606	71037726812962	14808	7544	0	0	\N
119503	2085	1100970000000	14811	7547	0	0	\N
119504	1397	1355861720000	14811	7547	1	0	\N
119514	2085	1100970000000	14813	7547	0	0	\N
119515	1397	1355861720000	14813	7547	1	0	\N
119516	1397	1355851719000	14813	7547	2	0	\N
119517	1397	1355841718000	14813	7547	3	0	\N
119518	1397	1355831717000	14813	7547	4	0	\N
119519	1726	663496437000	14813	7547	5	0	\N
119520	1726	663495434000	14813	7547	6	0	\N
119521	1726	663494431000	14813	7547	7	0	\N
119522	1726	663493428000	14813	7547	8	0	\N
119537	1397	1355751709000	14820	7554	0	0	\N
119538	1726	663485404000	14820	7554	1	0	\N
119543	1726	663484401000	14823	7555	0	0	\N
119411	1726	663527530000	14771	7523	1	0	7464
119412	1397	1356161750000	14772	7524	0	0	8267
119413	1726	663526527000	14772	7524	1	0	7465
119420	1397	1356151749000	14778	7525	0	0	8268
119421	1397	1356141748000	14778	7525	1	0	8269
119423	1726	663525524000	14778	7525	3	0	7466
119424	1726	663524521000	14778	7525	4	0	7467
119425	1726	663523518000	14778	7525	5	0	7468
119428	1397	1356121746000	14781	7526	0	0	8271
119429	1726	663522515000	14781	7526	1	0	7469
119431	1726	663521512000	14782	7527	1	0	7470
119432	1397	1356101744000	14783	7528	0	0	8273
119433	1726	663520509000	14783	7528	1	0	7471
119434	1397	1356091743000	14784	7529	0	0	8274
119436	1726	663519506000	14784	7529	2	0	7472
119437	1726	663518503000	14784	7529	3	0	7473
119442	1397	1356071741000	14786	7530	0	0	8276
119443	1726	663517500000	14786	7530	1	0	7474
119446	1397	1356061740000	14788	7531	0	0	8277
119448	1397	1356051739000	14789	7532	0	0	8278
119449	1397	1356041738000	14789	7532	1	0	8279
119450	1726	663515494000	14789	7532	2	0	7476
119451	1726	663514491000	14789	7532	3	0	7477
119452	1397	1356031737000	14790	7533	0	0	8280
119454	1397	1356021736000	14791	7534	0	0	8281
119455	1726	663512485000	14791	7534	1	0	7479
119456	1397	1356011735000	14792	7535	0	0	8282
119457	1726	663511482000	14792	7535	1	0	7480
119459	1397	1355991733000	14793	7536	1	0	8284
119460	1397	1355981732000	14793	7536	2	0	8285
119461	1726	663510479000	14793	7536	3	0	7481
119462	1726	663509476000	14793	7536	4	0	7482
119463	1726	663508473000	14793	7536	5	0	7483
119465	1726	663507470000	14795	7537	1	0	7484
119469	1397	1355961730000	14797	7538	0	0	8287
119470	341	66000990000001	14797	7538	1	0	1
119471	1726	663506467000	14797	7538	2	0	7485
119472	1397	1355951729000	14798	7539	0	0	8288
119476	1397	1355941728000	14800	7540	0	0	8289
119477	1726	663504461000	14800	7540	1	0	7487
119478	1397	1355931727000	14801	7541	0	0	8290
119479	1397	1355921726000	14801	7541	1	0	8291
119481	1726	663502455000	14801	7541	3	0	7489
119482	1397	1355911725000	14802	7542	0	0	8292
119483	1397	1355901724000	14802	7542	1	0	8293
119484	2085	980000000	14802	7542	2	0	1
119485	1726	663501452000	14802	7542	3	0	7490
119489	1397	1355891723000	14804	7543	0	0	8294
119490	1726	663499446000	14804	7543	1	0	7492
119496	1397	1355881722000	14807	7544	0	0	8295
119497	606	71037726812962	14807	7544	1	0	12
119498	1726	663498443000	14807	7544	2	0	7493
119501	1926	1194000000	14809	7545	1	0	6
119502	1726	663497440000	14809	7545	2	0	7494
119505	2085	1100970000000	14812	7547	0	0	2
119506	1397	1355861720000	14812	7547	1	0	8297
119508	1397	1355841718000	14812	7547	3	0	8299
119509	1397	1355831717000	14812	7547	4	0	8300
119510	1726	663496437000	14812	7547	5	0	7495
119511	1726	663495434000	14812	7547	6	0	7496
119512	1726	663494431000	14812	7547	7	0	7497
119523	1397	1355821716000	14814	7548	0	0	8301
119524	1726	663492425000	14814	7548	1	0	7499
119525	1397	1355811715000	14815	7549	0	0	8302
119526	1726	663491422000	14815	7549	1	0	7500
119527	1397	1355801714000	14816	7550	0	0	8303
119529	1397	1355791713000	14817	7551	0	0	8304
119530	1726	663489416000	14817	7551	1	0	7502
119531	1397	1355781712000	14818	7552	0	0	8305
119532	1397	1355771711000	14818	7552	1	0	8306
119534	1726	663487410000	14818	7552	3	0	7504
119535	1397	1355761710000	14819	7553	0	0	8307
119536	1726	663486407000	14819	7553	1	0	7505
119539	1397	1355751709000	14821	7554	0	0	8308
119540	1726	663485404000	14821	7554	1	0	7506
119542	1726	663484401000	14822	7555	1	0	7507
119544	1397	1355731707000	14824	7556	0	0	8310
119548	1397	1355731707000	14825	7556	0	0	\N
119549	1397	1355721706000	14825	7556	1	0	\N
119550	1726	663483398000	14825	7556	2	0	\N
119551	1726	663482395000	14825	7556	3	0	\N
119564	1397	1355671701000	14829	7559	0	0	\N
119565	1397	1355661700000	14829	7559	1	0	\N
119566	1726	663477380000	14829	7559	2	0	\N
119567	1726	663476377000	14829	7559	3	0	\N
119568	1397	1355671701000	14830	7559	0	0	\N
119569	1397	1355661700000	14830	7559	1	0	\N
119570	1726	663477380000	14830	7559	2	0	\N
119571	1726	663476377000	14830	7559	3	0	\N
119572	2085	980000000	14831	7523	0	0	\N
119573	2085	970000000	14831	7523	1	0	\N
119574	606	71037726812962	14831	7523	2	0	\N
119575	341	66000990000001	14831	7523	3	0	\N
119576	1726	663527530000	14831	7523	4	0	\N
119577	1726	663526527000	14831	7523	5	0	\N
119578	1726	663525524000	14831	7523	6	0	\N
119579	1726	663524521000	14831	7523	7	0	\N
119580	1926	1194000000	14831	7523	8	0	\N
119581	1726	663523518000	14831	7523	9	0	\N
119582	1726	663522515000	14831	7523	10	0	\N
119583	1726	663521512000	14831	7523	11	0	\N
119584	1726	663520509000	14831	7523	12	0	\N
119585	1726	663519506000	14831	7523	13	0	\N
119586	1726	663518503000	14831	7523	14	0	\N
119587	1726	663517500000	14831	7523	15	0	\N
119588	1726	663516497000	14831	7523	16	0	\N
119589	1726	663515494000	14831	7523	17	0	\N
119590	1726	663514491000	14831	7523	18	0	\N
119591	1726	663513488000	14831	7523	19	0	\N
119592	1726	663512485000	14831	7523	20	0	\N
119593	1726	663511482000	14831	7523	21	0	\N
119594	1726	663510479000	14831	7523	22	0	\N
119595	1726	663509476000	14831	7523	23	0	\N
119596	1726	663508473000	14831	7523	24	0	\N
119597	1726	663507470000	14831	7523	25	0	\N
119598	1726	663506467000	14831	7523	26	0	\N
119599	1726	663505464000	14831	7523	27	0	\N
119600	1726	663504461000	14831	7523	28	0	\N
119601	1726	663503458000	14831	7523	29	0	\N
119602	1726	663502455000	14831	7523	30	0	\N
119603	1726	663501452000	14831	7523	31	0	\N
119604	1726	663500449000	14831	7523	32	0	\N
119605	1726	663499446000	14831	7523	33	0	\N
119606	1726	663498443000	14831	7523	34	0	\N
119607	1726	663497440000	14831	7523	35	0	\N
119608	1726	663496437000	14831	7523	36	0	\N
119609	1726	663495434000	14831	7523	37	0	\N
119610	1726	663494431000	14831	7523	38	0	\N
119611	1726	663493428000	14831	7523	39	0	\N
119612	1726	663492425000	14831	7523	40	0	\N
119613	1726	663491422000	14831	7523	41	0	\N
119614	1726	663490419000	14831	7523	42	0	\N
119615	1726	663489416000	14831	7523	43	0	\N
119616	1726	663488413000	14831	7523	44	0	\N
119617	1726	663487410000	14831	7523	45	0	\N
119618	1726	663486407000	14831	7523	46	0	\N
119619	1726	663485404000	14831	7523	47	0	\N
119620	1726	663484401000	14831	7523	48	0	\N
119621	1726	663483398000	14831	7523	49	0	\N
119622	1726	663482395000	14831	7523	50	0	\N
119623	1726	663481392000	14831	7523	51	0	\N
119624	1726	663480389000	14831	7523	52	0	\N
119625	1726	663479386000	14831	7523	53	0	\N
119626	1726	663478383000	14831	7523	54	0	\N
119627	1726	663477380000	14831	7523	55	0	\N
119628	1726	663476377000	14831	7523	56	0	\N
119629	1726	663475374000	14831	7523	57	0	\N
119630	1397	1355651699000	14832	7560	0	0	\N
119631	1726	663475374000	14832	7560	1	0	\N
119634	1397	1355651699000	14835	7560	0	0	\N
119635	1726	663475374000	14835	7560	1	0	\N
119648	1397	1355621696000	14839	7563	0	0	\N
119649	1397	1355611695000	14839	7563	1	0	\N
119650	1397	1355601694000	14839	7563	2	0	\N
119651	1397	1355591693000	14839	7563	3	0	\N
119652	1726	663472365000	14839	7563	4	0	\N
119653	1726	663471362000	14839	7563	5	0	\N
119654	1726	663470359000	14839	7563	6	0	\N
119655	1726	663469356000	14839	7563	7	0	\N
119656	1397	1355621696000	14840	7563	0	0	\N
119657	1397	1355611695000	14840	7563	1	0	\N
119658	1397	1355601694000	14840	7563	2	0	\N
119659	1397	1355591693000	14840	7563	3	0	\N
119660	1726	663472365000	14840	7563	4	0	\N
119661	1726	663471362000	14840	7563	5	0	\N
119662	1726	663470359000	14840	7563	6	0	\N
119663	1726	663469356000	14840	7563	7	0	\N
119667	1397	1355571691000	14842	7565	0	0	\N
119668	1726	663467350000	14842	7565	1	0	\N
119671	1397	1355571691000	14844	7565	0	0	\N
119672	1726	663467350000	14844	7565	1	0	\N
119675	1693	19957441239447	14846	7430	0	0	\N
119676	2085	980000000	14846	7430	1	0	\N
119677	2085	970000000	14846	7430	2	0	\N
119678	606	71037726812962	14846	7430	3	0	\N
119679	341	66000990000001	14846	7430	4	0	\N
119680	1693	19923642464009	14846	7430	5	0	\N
119547	1726	663482395000	14824	7556	3	0	7509
119552	1397	1355711705000	14826	7557	0	0	8312
119553	1397	1355701704000	14826	7557	1	0	8313
119554	1397	1355691703000	14826	7557	2	0	8314
119555	1726	663481392000	14826	7557	3	0	7510
119557	1726	663479386000	14826	7557	5	0	7512
119558	1397	1355681702000	14827	7558	0	0	8315
119559	1726	663478383000	14827	7558	1	0	7513
119560	1397	1355671701000	14828	7559	0	0	8316
119561	1397	1355661700000	14828	7559	1	0	8317
119563	1726	663476377000	14828	7559	3	0	7515
119632	1397	1355651699000	14833	7560	0	0	8318
119633	1726	663475374000	14833	7560	1	0	7516
119636	1397	1355641698000	14836	7561	0	0	8319
119638	1397	1355631697000	14837	7562	0	0	8320
119639	1726	663473368000	14837	7562	1	0	7518
119640	1397	1355621696000	14838	7563	0	0	8321
119641	1397	1355611695000	14838	7563	1	0	8322
119642	1397	1355601694000	14838	7563	2	0	8323
119644	1726	663472365000	14838	7563	4	0	7519
119645	1726	663471362000	14838	7563	5	0	7520
119646	1726	663470359000	14838	7563	6	0	7521
119647	1726	663469356000	14838	7563	7	0	7522
119664	1397	1355581692000	14841	7564	0	0	8325
119666	1970	199000000	14841	7564	2	0	1
119669	1397	1355571691000	14843	7565	0	0	8326
119670	1726	663467350000	14843	7565	1	0	7524
119673	1397	1355561690000	14845	7566	0	0	8327
119681	1693	19807483548415	14846	7430	6	0	\N
119682	1693	18221957475715	14846	7430	7	0	\N
119683	1693	17391119617299	14846	7430	8	0	\N
119684	1693	17274960701705	14846	7430	9	0	\N
119685	1693	17158801786111	14846	7430	10	0	\N
119686	1693	17042642870517	14846	7430	11	0	\N
119687	1693	17033833710256	14846	7430	12	0	\N
119688	1693	16917674794662	14846	7430	13	0	\N
119689	1693	16801515879068	14846	7430	14	0	\N
119690	1693	16685356963474	14846	7430	15	0	\N
119691	1693	16367551211605	14846	7430	16	0	\N
119692	1693	15827584407868	14846	7430	17	0	\N
119693	1693	15711425492274	14846	7430	18	0	\N
119694	1693	15595266576680	14846	7430	19	0	\N
119695	1693	15479107661086	14846	7430	20	0	\N
119696	1693	15362948745492	14846	7430	21	0	\N
119697	1693	14822981941755	14846	7430	22	0	\N
119698	1693	14706823026161	14846	7430	23	0	\N
119699	1693	14590664110567	14846	7430	24	0	\N
119700	1693	14474505194973	14846	7430	25	0	\N
119701	1693	14358346279379	14846	7430	26	0	\N
119702	1693	14242187363785	14846	7430	27	0	\N
119703	1693	14126028448191	14846	7430	28	0	\N
119704	1693	14009869532597	14846	7430	29	0	\N
119705	1693	13893710617003	14846	7430	30	0	\N
119706	1693	13777551701409	14846	7430	31	0	\N
119707	1693	13661392785815	14846	7430	32	0	\N
119708	1693	13545233870221	14846	7430	33	0	\N
119709	1693	13429074954627	14846	7430	34	0	\N
119710	1693	13312916039033	14846	7430	35	0	\N
119711	1693	13196757123439	14846	7430	36	0	\N
119712	1693	13080598207845	14846	7430	37	0	\N
119713	1693	12964439292251	14846	7430	38	0	\N
119714	1693	12848280376657	14846	7430	39	0	\N
119715	1693	12732121461063	14846	7430	40	0	\N
119716	1693	12615962545469	14846	7430	41	0	\N
119717	1693	12499803629875	14846	7430	42	0	\N
119718	1693	12383644714281	14846	7430	43	0	\N
119719	1693	12267485798687	14846	7430	44	0	\N
119720	1693	12151326883093	14846	7430	45	0	\N
119721	1693	12035167967499	14846	7430	46	0	\N
119722	1693	11919009051905	14846	7430	47	0	\N
119723	1693	11802850136311	14846	7430	48	0	\N
119724	1693	11686691220717	14846	7430	49	0	\N
119725	1693	11570532305123	14846	7430	50	0	\N
119726	1693	11454373389529	14846	7430	51	0	\N
119727	1693	11338214473935	14846	7430	52	0	\N
119728	1693	11222055558341	14846	7430	53	0	\N
119729	1693	11105896642747	14846	7430	54	0	\N
119730	1693	10989737727153	14846	7430	55	0	\N
119731	1693	10873578811559	14846	7430	56	0	\N
119732	1693	10757419895965	14846	7430	57	0	\N
119733	1693	10641260980371	14846	7430	58	0	\N
119734	1693	10525102064777	14846	7430	59	0	\N
119735	1693	10408943149183	14846	7430	60	0	\N
119736	1693	10292784233589	14846	7430	61	0	\N
119737	1693	10176625317995	14846	7430	62	0	\N
119738	1693	10173095653899	14846	7430	63	0	\N
119739	1693	9103306366007	14846	7430	64	0	\N
119740	1693	8987147450413	14846	7430	65	0	\N
119741	1693	8870988534819	14846	7430	66	0	\N
119742	1693	8754829619225	14846	7430	67	0	\N
119743	1693	8638670703631	14846	7430	68	0	\N
119744	1693	8522511788037	14846	7430	69	0	\N
119745	1693	8406352872443	14846	7430	70	0	\N
119746	1693	8290193956849	14846	7430	71	0	\N
119747	1693	8174035041255	14846	7430	72	0	\N
119748	1693	8057876125661	14846	7430	73	0	\N
119749	1693	7941717210067	14846	7430	74	0	\N
119750	1693	7825558294473	14846	7430	75	0	\N
119751	1397	1355561690000	14847	7566	0	0	\N
119752	1726	663466347000	14847	7566	1	0	\N
119753	1397	1355551689000	14848	7567	0	0	\N
119754	1397	1355541688000	14848	7567	1	0	\N
119755	1397	1355531687000	14848	7567	2	0	\N
119756	1726	663465344000	14848	7567	3	0	\N
119757	1726	663464341000	14848	7567	4	0	\N
119758	1726	663463338000	14848	7567	5	0	\N
119769	1397	1355511685000	14852	7569	0	0	\N
119770	1726	663461332000	14852	7569	1	0	\N
119773	1397	1355491683000	14854	7571	0	0	\N
119774	1397	1355481682000	14854	7571	1	0	\N
119775	1397	1355471681000	14854	7571	2	0	\N
119776	1397	1355461680000	14854	7571	4	0	\N
119777	1726	663459326000	14854	7571	5	0	\N
119778	1726	663458323000	14854	7571	6	0	\N
119779	1726	663457320000	14854	7571	7	0	\N
119780	1726	663456317000	14854	7571	8	0	\N
119781	1397	1355491683000	14855	7571	0	0	\N
119782	1397	1355481682000	14855	7571	1	0	\N
119783	1397	1355471681000	14855	7571	2	0	\N
119784	1397	1355461680000	14855	7571	4	0	\N
119785	1726	663459326000	14855	7571	5	0	\N
119786	1726	663458323000	14855	7571	6	0	\N
119787	1726	663457320000	14855	7571	7	0	\N
119788	1726	663456317000	14855	7571	8	0	\N
119789	1397	1355491683000	14856	7571	0	0	\N
119790	1397	1355481682000	14856	7571	1	0	\N
119791	1397	1355471681000	14856	7571	2	0	\N
119792	1397	1355491683000	14857	7571	0	0	\N
119793	1397	1355481682000	14857	7571	1	0	\N
119794	1397	1355471681000	14857	7571	2	0	\N
119795	1397	1355461680000	14857	7571	4	0	\N
119796	1726	663459326000	14857	7571	5	0	\N
119797	1726	663458323000	14857	7571	6	0	\N
119798	1726	663457320000	14857	7571	7	0	\N
119799	1726	663456317000	14857	7571	8	0	\N
119800	1397	1355451679000	14858	7572	0	0	\N
119801	1726	663455314000	14858	7572	1	0	\N
119802	1397	1355451679000	14859	7572	0	0	\N
119803	1726	663455314000	14859	7572	1	0	\N
119804	1397	1355451679000	14860	7572	0	0	\N
119805	1726	663455314000	14860	7572	1	0	\N
119816	1397	1355451679000	14863	7572	0	0	\N
119761	1397	1355531687000	14849	7567	2	0	8330
119762	1726	663465344000	14849	7567	3	0	7526
119763	1726	663464341000	14849	7567	4	0	7527
119764	1726	663463338000	14849	7567	5	0	7528
119765	1397	1355521686000	14850	7568	0	0	8331
119767	1397	1355511685000	14851	7569	0	0	8332
119768	1726	663461332000	14851	7569	1	0	7530
119771	1397	1355501684000	14853	7570	0	0	8333
119772	1726	663460329000	14853	7570	1	0	7531
119806	1397	1355491683000	14861	7571	0	0	8334
119808	1397	1355471681000	14861	7571	2	0	8336
119809	1397	1355461680000	14861	7571	4	0	8337
119810	1726	663459326000	14861	7571	5	0	7532
119811	1397	1355451679000	14862	7572	0	0	8338
119813	1726	663457320000	14862	7572	2	0	7534
119814	1726	663456317000	14862	7572	3	0	7535
119815	1726	663455314000	14862	7572	4	0	7536
119817	1726	663458323000	14863	7572	1	0	\N
119818	1726	663457320000	14863	7572	2	0	\N
119819	1726	663456317000	14863	7572	3	0	\N
119820	1726	663455314000	14863	7572	4	0	\N
119827	1397	1355421676000	14867	7575	0	0	\N
119828	1726	663452305000	14867	7575	1	0	\N
119829	1397	1355421676000	14868	7575	0	0	\N
119830	1726	663452305000	14868	7575	1	0	\N
119831	1397	1355421676000	14869	7575	0	0	\N
119832	1726	663452305000	14869	7575	1	0	\N
119840	1705	7118473500145	14871	7576	0	0	\N
119841	1397	1355411675000	14871	7576	1	0	\N
119842	1397	1355401674000	14871	7576	2	0	\N
119843	1397	1355391673000	14871	7576	3	0	\N
119844	1726	663451302000	14871	7576	4	0	\N
119845	1726	663450299000	14871	7576	5	0	\N
119846	1726	663449296000	14871	7576	6	0	\N
119847	1705	7118473500145	14872	7576	0	0	\N
119848	1397	1355411675000	14872	7576	1	0	\N
119849	1397	1355401674000	14872	7576	2	0	\N
119850	1397	1355391673000	14872	7576	3	0	\N
119851	1726	663451302000	14872	7576	4	0	\N
119852	1726	663450299000	14872	7576	5	0	\N
119853	1726	663449296000	14872	7576	6	0	\N
119856	1397	1355381672000	14874	7577	0	0	\N
119857	1726	663448293000	14874	7577	1	0	\N
119858	1397	1355381672000	14875	7577	0	0	\N
119859	1726	663448293000	14875	7577	1	0	\N
119860	1397	1355381672000	14876	7577	0	0	\N
119861	1726	663448293000	14876	7577	1	0	\N
119876	1726	662229272000	14880	7581	0	0	\N
119877	1726	661019272000	14880	7581	1	0	\N
119878	1397	1355331667000	14880	7581	2	0	\N
119879	1397	1355321666000	14880	7581	3	0	\N
119880	1726	661018269000	14880	7581	4	0	\N
119881	1726	659808269000	14880	7581	5	0	\N
119882	1726	659807267000	14880	7581	6	0	\N
119883	1726	659806264000	14880	7581	7	0	\N
119884	1726	659805262000	14880	7581	8	0	\N
119894	1726	662229272000	14882	7581	0	0	\N
119895	1726	661019272000	14882	7581	1	0	\N
119896	1397	1355331667000	14882	7581	2	0	\N
119897	1397	1355321666000	14882	7581	3	0	\N
119898	1726	661018269000	14882	7581	4	0	\N
119899	1726	659808269000	14882	7581	5	0	\N
119900	1726	659807267000	14882	7581	6	0	\N
119901	1726	659806264000	14882	7581	7	0	\N
119902	1726	659805262000	14882	7581	8	0	\N
119911	1397	1355301664000	14885	7583	0	0	\N
119912	1726	659801253000	14885	7583	1	0	\N
119913	1726	659800251000	14885	7583	2	0	\N
119942	1397	1355221656000	14889	7587	0	0	\N
119943	1726	659778208000	14889	7587	1	0	\N
119944	1726	659777205000	14889	7587	2	0	\N
119945	1726	659776203000	14889	7587	3	0	\N
119823	1397	1355431677000	14865	7574	0	0	8340
119824	1726	663453308000	14865	7574	1	0	7538
119825	1397	1355421676000	14866	7575	0	0	8341
119826	1726	663452305000	14866	7575	1	0	7539
119833	1705	7118473500145	14870	7576	0	0	19
119835	1397	1355401674000	14870	7576	2	0	8343
119836	1397	1355391673000	14870	7576	3	0	8344
119837	1726	663451302000	14870	7576	4	0	7540
119838	1726	663450299000	14870	7576	5	0	7541
119839	1726	663449296000	14870	7576	6	0	7542
119855	1726	663448293000	14873	7577	1	0	7543
119862	1397	1355371671000	14877	7578	0	0	8346
119863	1397	1355361670000	14877	7578	1	0	8347
119864	1726	663447290000	14877	7578	2	0	7544
119866	1726	663445286000	14877	7578	4	0	7546
119867	1950	7169851000000	14877	7578	5	0	14
119868	1726	663444284000	14877	7578	6	0	7547
119869	1397	1355351669000	14878	7579	0	0	8348
119870	1726	663443281000	14878	7579	1	0	7548
119872	1726	663441278000	14878	7579	3	0	7550
119873	1397	1355341668000	14879	7580	0	0	8349
119874	1726	663440275000	14879	7580	1	0	7551
119875	1726	663439272000	14879	7580	2	0	7552
119885	1726	662229272000	14881	7581	0	0	7553
119887	1397	1355331667000	14881	7581	2	0	8350
119888	1397	1355321666000	14881	7581	3	0	8351
119889	1726	661018269000	14881	7581	4	0	7555
119890	1726	659808269000	14881	7581	5	0	7556
119892	1726	659806264000	14881	7581	7	0	7558
119893	1726	659805262000	14881	7581	8	0	7559
119903	1397	1355311665000	14883	7582	0	0	8352
119904	1726	659804261000	14883	7582	1	0	7560
119905	395	66027932005524	14883	7582	2	0	2
119907	1726	659802256000	14883	7582	4	0	7562
119908	1397	1355301664000	14884	7583	0	0	8353
119909	1726	659801253000	14884	7583	1	0	7563
119910	1726	659800251000	14884	7583	2	0	7564
119914	1726	659799250000	14886	7584	0	0	7565
119916	1726	659797245000	14886	7584	2	0	7567
119917	1726	659796244000	14886	7584	3	0	7568
119918	1726	659795241000	14886	7584	4	0	7569
119919	1726	659794239000	14886	7584	5	0	7570
119921	1726	659792235000	14886	7584	7	0	7572
119922	1726	659791233000	14886	7584	8	0	7573
119923	1726	659790232000	14886	7584	9	0	7574
119924	1726	659789229000	14886	7584	10	0	7575
119925	1726	659788227000	14886	7584	11	0	7576
119927	1397	1355281662000	14887	7585	1	0	8355
119928	1397	1355271661000	14887	7585	2	0	8356
119929	1397	1355261660000	14887	7585	3	0	8357
119930	1397	1355251659000	14887	7585	4	0	8358
119931	1397	1355241658000	14887	7585	5	0	8359
119933	1726	659786223000	14887	7585	7	0	7578
119934	1726	659785221000	14887	7585	8	0	7579
119935	1726	659784220000	14887	7585	9	0	7580
119936	1726	659783217000	14887	7585	10	0	7581
119938	1397	1355231657000	14888	7586	0	0	8360
119939	1726	659781214000	14888	7586	1	0	7583
119940	1726	659780211000	14888	7586	2	0	7584
119941	1726	659779209000	14888	7586	3	0	7585
119946	1397	1355221656000	14890	7587	0	0	8361
119948	1726	659777205000	14890	7587	2	0	7587
119949	1726	659776203000	14890	7587	3	0	7588
119950	1397	1355211655000	14891	7588	0	0	8362
119951	1726	659775202000	14891	7588	1	0	7589
119952	1726	659774199000	14891	7588	2	0	7590
119954	1397	1355201654000	14892	7589	0	0	\N
119955	1397	1355191653000	14892	7589	1	0	\N
119956	1726	659772196000	14892	7589	3	0	\N
119957	1726	659771193000	14892	7589	4	0	\N
119958	1726	659770191000	14892	7589	5	0	\N
119959	1726	659769190000	14892	7589	6	0	\N
119960	1726	659768187000	14892	7589	7	0	\N
119961	1726	659767185000	14892	7589	8	0	\N
119970	1397	1355201654000	14894	7589	0	0	\N
119971	1397	1355191653000	14894	7589	1	0	\N
119972	1726	659772196000	14894	7589	3	0	\N
119973	1726	659771193000	14894	7589	4	0	\N
119974	1726	659770191000	14894	7589	5	0	\N
119975	1726	659769190000	14894	7589	6	0	\N
119976	1726	659768187000	14894	7589	7	0	\N
119977	1726	659767185000	14894	7589	8	0	\N
119978	1397	1355201654000	14895	7589	0	0	\N
119979	1397	1355191653000	14895	7589	1	0	\N
119980	1726	659772196000	14895	7589	3	0	\N
119981	1726	659771193000	14895	7589	4	0	\N
119982	1726	659770191000	14895	7589	5	0	\N
119983	1726	659769190000	14895	7589	6	0	\N
119984	1726	659768187000	14895	7589	7	0	\N
119985	1726	659767185000	14895	7589	8	0	\N
119990	1397	1355181652000	14898	7590	0	0	\N
119991	1726	659766184000	14898	7590	1	0	\N
119992	1726	659765181000	14898	7590	2	0	\N
119993	1726	659764179000	14898	7590	3	0	\N
119994	1397	1355181652000	14899	7590	0	0	\N
119995	1726	659766184000	14899	7590	1	0	\N
119996	1726	659765181000	14899	7590	2	0	\N
119997	1726	659764179000	14899	7590	3	0	\N
120003	1397	1355151649000	14902	7593	0	0	\N
120004	1726	659760173000	14902	7593	1	0	\N
120005	1726	659759171000	14902	7593	2	0	\N
120006	1726	659758168000	14902	7593	3	0	\N
120011	1397	1355151649000	14904	7593	0	0	\N
120012	1726	659760173000	14904	7593	1	0	\N
120013	1726	659759171000	14904	7593	2	0	\N
120014	1726	659758168000	14904	7593	3	0	\N
120015	1397	1355151649000	14905	7593	0	0	\N
120016	1726	659760173000	14905	7593	1	0	\N
120017	1726	659759171000	14905	7593	2	0	\N
120018	1726	659758168000	14905	7593	3	0	\N
120028	1397	1355121646000	14909	7596	0	0	\N
120029	1726	659754162000	14909	7596	1	0	\N
120030	1726	659753160000	14909	7596	2	0	\N
120031	1726	659752157000	14909	7596	3	0	\N
120032	1397	1355111645000	14910	7597	0	0	\N
120033	1726	659751156000	14910	7597	1	0	\N
120034	1726	659750154000	14910	7597	2	0	\N
120035	1726	659749151000	14910	7597	3	0	\N
120040	1397	1355111645000	14912	7597	0	0	\N
120041	1726	659751156000	14912	7597	1	0	\N
120042	1726	659750154000	14912	7597	2	0	\N
120043	1726	659749151000	14912	7597	3	0	\N
120064	1397	1355031637000	14916	7600	0	0	\N
120065	1726	658528127000	14916	7600	1	0	\N
120069	1397	1355021636000	14918	7601	0	0	\N
120070	1726	658527124000	14918	7601	1	0	\N
120071	1726	658526121000	14918	7601	2	0	\N
120072	1397	1355021636000	14919	7601	0	0	\N
120073	1726	658527124000	14919	7601	1	0	\N
120074	1726	658526121000	14919	7601	2	0	\N
120078	1397	1355011635000	14921	7602	0	0	\N
120079	2114	1399000000	14921	7602	1	0	\N
120080	1726	658525119000	14921	7602	2	0	\N
120082	1397	1355001634000	14923	7603	0	0	\N
120083	1397	1355001634000	14924	7603	0	0	\N
119963	1397	1355191653000	14893	7589	1	0	8364
119964	1726	659772196000	14893	7589	3	0	7592
119965	1726	659771193000	14893	7589	4	0	7593
119966	1726	659770191000	14893	7589	5	0	7594
119967	1726	659769190000	14893	7589	6	0	7595
119969	1726	659767185000	14893	7589	8	0	7597
119986	1397	1355181652000	14897	7590	0	0	8365
119987	1726	659766184000	14897	7590	1	0	7598
119988	1726	659765181000	14897	7590	2	0	7599
119989	1726	659764179000	14897	7590	3	0	7600
119999	1726	659763178000	14900	7591	1	0	7601
120000	1726	659762176000	14900	7591	2	0	7602
120001	1397	1355161650000	14901	7592	0	0	8367
120002	1726	659761174000	14901	7592	1	0	7603
120008	1726	659760173000	14903	7593	1	0	7604
120009	1726	659759171000	14903	7593	2	0	7605
120010	1726	659758168000	14903	7593	3	0	7606
120019	1397	1355141648000	14906	7594	0	0	8369
120020	1726	659757167000	14906	7594	1	0	7607
120022	1397	1355131647000	14907	7595	0	0	8370
120023	1726	659755163000	14907	7595	1	0	7609
120024	1397	1355121646000	14908	7596	0	0	8371
120025	1726	659754162000	14908	7596	1	0	7610
120026	1726	659753160000	14908	7596	2	0	7611
120036	1397	1355111645000	14911	7597	0	0	8372
120037	1726	659751156000	14911	7597	1	0	7613
120038	1726	659750154000	14911	7597	2	0	7614
120039	1726	659749151000	14911	7597	3	0	7615
120045	1726	659748150000	14913	7598	1	0	7616
120046	1726	658538150000	14913	7598	2	0	7617
120047	1726	658537148000	14913	7598	3	0	7618
120048	1397	1355091643000	14914	7599	0	0	8374
120049	1397	1355081642000	14914	7599	1	0	8375
120051	1397	1355061640000	14914	7599	3	0	8377
120052	1397	1355051639000	14914	7599	4	0	8378
120053	1397	1355041638000	14914	7599	5	0	8379
120054	1726	658536147000	14914	7599	6	0	7619
120055	1726	658535145000	14914	7599	7	0	7620
120057	1726	658533142000	14914	7599	9	0	7622
120058	1726	658532139000	14914	7599	10	0	7623
120059	1726	658531136000	14914	7599	11	0	7624
120060	1726	658530133000	14914	7599	12	0	7625
120062	1397	1355031637000	14915	7600	0	0	8380
120063	1726	658528127000	14915	7600	1	0	7627
120066	1397	1355021636000	14917	7601	0	0	8381
120067	1726	658527124000	14917	7601	1	0	7628
120068	1726	658526121000	14917	7601	2	0	7629
120076	2114	1399000000	14920	7602	1	0	1
120077	1726	658525119000	14920	7602	2	0	7630
120081	1397	1355001634000	14922	7603	0	0	8383
120084	1397	1354991633000	14925	7604	0	0	8384
120085	1726	658524117000	14925	7604	1	0	7631
120087	1397	1354981632000	14926	7605	0	0	8385
120088	1726	658522112000	14926	7605	1	0	7633
120094	1397	1354951629000	14929	7608	0	0	\N
120095	1397	1354951629000	14930	7608	0	0	\N
120102	1397	1354941628000	14933	7609	0	0	\N
120103	1397	1354931627000	14933	7609	1	0	\N
120104	1726	658518102000	14933	7609	2	0	\N
120105	1726	658517099000	14933	7609	3	0	\N
120106	1726	658516097000	14933	7609	4	0	\N
120107	1397	1354941628000	14934	7609	0	0	\N
120108	1397	1354931627000	14934	7609	1	0	\N
120109	1726	658518102000	14934	7609	2	0	\N
120110	1726	658517099000	14934	7609	3	0	\N
120111	1726	658516097000	14934	7609	4	0	\N
120112	1397	1354941628000	14935	7609	0	0	\N
120113	1397	1354931627000	14935	7609	1	0	\N
120114	1726	658518102000	14935	7609	2	0	\N
120115	1726	658517099000	14935	7609	3	0	\N
120116	1726	658516097000	14935	7609	4	0	\N
120117	1397	1354941628000	14937	7609	0	0	\N
120118	1397	1354931627000	14937	7609	1	0	\N
120119	1726	658518102000	14937	7609	2	0	\N
120120	1726	658517099000	14937	7609	3	0	\N
120121	1726	658516097000	14937	7609	4	0	\N
120122	1397	1354941628000	14938	7609	0	0	\N
120123	1397	1354931627000	14938	7609	1	0	\N
120124	1726	658518102000	14938	7609	2	0	\N
120125	1726	658517099000	14938	7609	3	0	\N
120126	1726	658516097000	14938	7609	4	0	\N
120129	1397	1354921626000	14940	7610	0	0	\N
120130	1726	658515094000	14940	7610	1	0	\N
120131	1397	1354921626000	14941	7610	0	0	\N
120132	1726	658515094000	14941	7610	1	0	\N
120133	1397	1354911625000	14942	7611	0	0	\N
120134	1726	658514092000	14942	7611	1	0	\N
120151	1397	1354841618000	14946	7614	0	0	\N
120152	1726	658505077000	14946	7614	1	0	\N
120155	1397	1354831617000	14948	7615	0	0	\N
120156	1397	1354821616000	14948	7615	1	0	\N
120157	1726	658504076000	14948	7615	2	0	\N
120158	1726	658503074000	14948	7615	3	0	\N
120159	1726	658502073000	14948	7615	4	0	\N
120160	1397	1354831617000	14949	7615	0	0	\N
120161	1397	1354821616000	14949	7615	1	0	\N
120162	1726	658504076000	14949	7615	2	0	\N
120163	1726	658503074000	14949	7615	3	0	\N
120164	1726	658502073000	14949	7615	4	0	\N
120173	1397	1354811615000	14954	7616	0	0	\N
120174	1726	658501071000	14954	7616	1	0	\N
120175	1726	658500070000	14954	7616	2	0	\N
120177	1397	1354791613000	14956	7618	0	0	\N
120178	1726	658499068000	14956	7618	1	0	\N
120179	1726	658498067000	14956	7618	2	0	\N
120183	1397	1354791613000	14958	7618	0	0	\N
120184	1726	658499068000	14958	7618	1	0	\N
120185	1726	658498067000	14958	7618	2	0	\N
120186	1397	1354791613000	14959	7618	0	0	\N
120187	1726	658499068000	14959	7618	1	0	\N
120188	1726	658498067000	14959	7618	2	0	\N
120196	1397	1354761610000	14962	7620	0	0	\N
120197	1726	658494061000	14962	7620	1	0	\N
120207	1397	1354721606000	14967	7624	0	0	\N
120208	1397	1354721606000	14968	7624	0	0	\N
120220	1397	1354671601000	14972	7628	0	0	\N
120221	1726	657272044000	14972	7628	1	0	\N
120091	1397	1354961630000	14928	7607	0	0	8387
120092	1726	658520107000	14928	7607	1	0	7635
120093	1726	658519104000	14928	7607	2	0	7636
120096	1397	1354951629000	14931	7608	0	0	8388
120097	1397	1354941628000	14932	7609	0	0	8389
120099	1726	658518102000	14932	7609	2	0	7637
120100	1726	658517099000	14932	7609	3	0	7638
120101	1726	658516097000	14932	7609	4	0	7639
120127	1397	1354921626000	14939	7610	0	0	8391
120128	1726	658515094000	14939	7610	1	0	7640
120136	1726	658514092000	14943	7611	1	0	7641
120137	1397	1354901624000	14944	7612	0	0	8393
120138	1397	1354891623000	14945	7613	0	0	8394
120139	1397	1354881622000	14945	7613	1	0	8395
120141	1397	1354861620000	14945	7613	3	0	8397
120142	1397	1354851619000	14945	7613	4	0	8398
120143	1726	658513090000	14945	7613	5	0	7642
120144	1726	658512087000	14945	7613	6	0	7643
120145	1726	658511086000	14945	7613	7	0	7644
120147	1726	658509083000	14945	7613	9	0	7646
120148	1726	658508081000	14945	7613	10	0	7647
120149	1726	658507080000	14945	7613	11	0	7648
120150	1726	658506079000	14945	7613	12	0	7649
120153	1397	1354841618000	14947	7614	0	0	8399
120165	1397	1354831617000	14951	7615	0	0	8400
120166	1397	1354821616000	14951	7615	1	0	8401
120167	1726	658504076000	14951	7615	2	0	7651
120168	1726	658503074000	14951	7615	3	0	7652
120170	1397	1354811615000	14953	7616	0	0	8402
120171	1726	658501071000	14953	7616	1	0	7654
120172	1726	658500070000	14953	7616	2	0	7655
120176	1397	1354801614000	14955	7617	0	0	8403
120180	1397	1354791613000	14957	7618	0	0	8404
120182	1726	658498067000	14957	7618	2	0	7657
120189	1397	1354781612000	14960	7619	0	0	8405
120190	1397	1354771611000	14960	7619	1	0	8406
120191	1726	658497066000	14960	7619	2	0	7658
120192	1726	658496064000	14960	7619	3	0	7659
120194	1397	1354761610000	14961	7620	0	0	8407
120195	1726	658494061000	14961	7620	1	0	7661
120198	1397	1354751609000	14963	7621	0	0	8408
120199	1726	658493060000	14963	7621	1	0	7662
120201	1726	658492058000	14964	7622	1	0	7663
120202	1726	658491057000	14964	7622	2	0	7664
120203	1397	1354731607000	14965	7623	0	0	8410
120204	1726	658490055000	14965	7623	1	0	7665
120205	1726	658489054000	14965	7623	2	0	7666
120209	1397	1354711605000	14969	7625	0	0	8412
120210	1726	658488053000	14969	7625	1	0	7667
120211	1726	658487051000	14969	7625	2	0	7668
120212	1397	1354701604000	14970	7626	0	0	8413
120213	1397	1354691603000	14970	7626	1	0	8414
120215	1726	658485048000	14970	7626	3	0	7670
120216	1726	657275048000	14970	7626	4	0	7671
120217	1726	657274047000	14970	7626	5	0	7672
120218	1397	1354681602000	14971	7627	0	0	8415
120222	1397	1354671601000	14973	7628	0	0	8416
120223	1726	657272044000	14973	7628	1	0	7674
120224	1397	1354661600000	14974	7629	0	0	8417
120234	1397	1354631597000	14977	7631	0	0	\N
120235	1726	657267037000	14977	7631	1	0	\N
120236	1726	657266035000	14977	7631	2	0	\N
120237	1397	1354621596000	14978	7632	0	0	\N
120238	1726	657265034000	14978	7632	1	0	\N
120239	1397	1354621596000	14979	7632	0	0	\N
120240	1726	657265034000	14979	7632	1	0	\N
120243	1397	1354621596000	14981	7632	0	0	\N
120244	1726	657265034000	14981	7632	1	0	\N
120248	1397	1354601594000	14983	7634	0	0	\N
120249	1397	1354601594000	14984	7634	0	0	\N
120250	1397	1354601594000	14985	7634	0	0	\N
120258	1397	1354581592000	14989	7636	0	0	\N
120259	1726	657260027000	14989	7636	1	0	\N
120260	1726	657259025000	14989	7636	2	0	\N
120261	1397	1354581592000	14990	7636	0	0	\N
120262	1726	657260027000	14990	7636	1	0	\N
120263	1726	657259025000	14990	7636	2	0	\N
120264	1397	1354581592000	14991	7636	0	0	\N
120265	1726	657260027000	14991	7636	1	0	\N
120266	1726	657259025000	14991	7636	2	0	\N
120274	1397	1354561590000	14994	7638	0	0	\N
120275	1397	1354551589000	14994	7638	1	0	\N
120276	1726	657257022000	14994	7638	2	0	\N
120277	1726	657256021000	14994	7638	3	0	\N
120278	1726	656046021000	14994	7638	4	0	\N
120282	1397	1354541588000	14996	7639	0	0	\N
120283	1726	656045019000	14996	7639	1	0	\N
120284	1726	656044018000	14996	7639	2	0	\N
120288	1397	1354521586000	14998	7641	0	0	\N
120289	1397	1354521586000	15000	7642	0	0	\N
120290	1397	1354511585000	15000	7642	1	0	\N
120291	1726	656041014000	15000	7642	2	0	\N
120292	1726	656040012000	15000	7642	3	0	\N
120297	1705	7118473500145	15002	7547	0	0	\N
120298	2085	1100970000000	15002	7547	1	0	\N
120299	1397	1355861720000	15002	7547	2	0	\N
120300	1397	1355851719000	15002	7547	3	0	\N
120301	1397	1355841718000	15002	7547	4	0	\N
120302	1397	1355831717000	15002	7547	5	0	\N
120303	1397	1355821716000	15002	7547	6	0	\N
120304	1397	1355811715000	15002	7547	7	0	\N
120305	1397	1355801714000	15002	7547	8	0	\N
120306	1397	1355791713000	15002	7547	9	0	\N
120307	1397	1355781712000	15002	7547	10	0	\N
120308	1397	1355771711000	15002	7547	11	0	\N
120309	1397	1355761710000	15002	7547	12	0	\N
120310	1397	1355751709000	15002	7547	13	0	\N
120311	1397	1355741708000	15002	7547	14	0	\N
120312	1397	1355731707000	15002	7547	15	0	\N
120313	1397	1355721706000	15002	7547	16	0	\N
120314	1397	1355711705000	15002	7547	17	0	\N
120315	1397	1355701704000	15002	7547	18	0	\N
120316	1397	1355691703000	15002	7547	19	0	\N
120317	1397	1355681702000	15002	7547	20	0	\N
120318	1397	1355671701000	15002	7547	21	0	\N
120319	1397	1355661700000	15002	7547	22	0	\N
120320	1397	1355651699000	15002	7547	23	0	\N
120321	1397	1355641698000	15002	7547	24	0	\N
120322	1397	1355631697000	15002	7547	25	0	\N
120323	1397	1355621696000	15002	7547	26	0	\N
120324	1397	1355611695000	15002	7547	27	0	\N
120325	1397	1355601694000	15002	7547	28	0	\N
120326	1397	1355591693000	15002	7547	29	0	\N
120327	1397	1355581692000	15002	7547	30	0	\N
120328	1397	1355571691000	15002	7547	31	0	\N
120329	1397	1355561690000	15002	7547	32	0	\N
120330	1397	1355551689000	15002	7547	33	0	\N
120331	1397	1355541688000	15002	7547	34	0	\N
120332	1397	1355531687000	15002	7547	35	0	\N
120333	1397	1355521686000	15002	7547	36	0	\N
120334	1397	1355511685000	15002	7547	37	0	\N
120335	1397	1355501684000	15002	7547	38	0	\N
120336	1397	1355491683000	15002	7547	39	0	\N
120337	1397	1355481682000	15002	7547	40	0	\N
120338	1397	1355471681000	15002	7547	41	0	\N
120339	1397	1355461680000	15002	7547	42	0	\N
120340	1397	1355451679000	15002	7547	43	0	\N
120341	1397	1355441678000	15002	7547	44	0	\N
120342	1397	1355431677000	15002	7547	45	0	\N
120343	1397	1355421676000	15002	7547	46	0	\N
120344	1397	1355411675000	15002	7547	47	0	\N
120345	1397	1355401674000	15002	7547	48	0	\N
120346	1397	1355391673000	15002	7547	49	0	\N
120347	1397	1355381672000	15002	7547	50	0	\N
120348	1397	1355371671000	15002	7547	51	0	\N
120349	1397	1355361670000	15002	7547	52	0	\N
120350	1397	1355351669000	15002	7547	53	0	\N
120351	1397	1355341668000	15002	7547	54	0	\N
120352	1397	1355331667000	15002	7547	55	0	\N
120353	1397	1355321666000	15002	7547	56	0	\N
120354	1397	1355311665000	15002	7547	57	0	\N
120355	1397	1355301664000	15002	7547	58	0	\N
120356	1397	1355291663000	15002	7547	59	0	\N
120357	1397	1355281662000	15002	7547	60	0	\N
120358	1397	1355271661000	15002	7547	61	0	\N
120359	1397	1355261660000	15002	7547	62	0	\N
120360	1397	1355251659000	15002	7547	63	0	\N
120227	1397	1354651599000	14975	7630	0	0	8418
120228	1397	1354641598000	14975	7630	1	0	8419
120229	1726	657269040000	14975	7630	2	0	7677
120230	1726	657268038000	14975	7630	3	0	7678
120231	1397	1354631597000	14976	7631	0	0	8420
120233	1726	657266035000	14976	7631	2	0	7680
120241	1397	1354621596000	14980	7632	0	0	8421
120242	1726	657265034000	14980	7632	1	0	7681
120245	1397	1354611595000	14982	7633	0	0	8422
120246	1726	657264032000	14982	7633	1	0	7682
120251	1397	1354601594000	14986	7634	0	0	8423
120252	1397	1354591593000	14987	7635	0	0	8424
120253	1726	657262029000	14987	7635	1	0	7684
120254	1726	657261028000	14987	7635	2	0	7685
120256	1726	657260027000	14988	7636	1	0	7686
120257	1726	657259025000	14988	7636	2	0	7687
120267	1397	1354571591000	14992	7637	0	0	8426
120268	1726	657258024000	14992	7637	2	0	7688
120269	1397	1354561590000	14993	7638	0	0	8427
120271	1726	657257022000	14993	7638	2	0	7689
120272	1726	657256021000	14993	7638	3	0	7690
120273	1726	656046021000	14993	7638	4	0	7691
120279	1397	1354541588000	14995	7639	0	0	8429
120280	1726	656045019000	14995	7639	1	0	7692
120285	1397	1354531587000	14997	7640	0	0	8430
120286	1726	656043017000	14997	7640	1	0	7694
120287	1726	656042015000	14997	7640	2	0	7695
120293	1397	1354521586000	15001	7642	0	0	8431
120295	1726	656041014000	15001	7642	2	0	7696
120296	1726	656040012000	15001	7642	3	0	7697
120361	1397	1355241658000	15002	7547	64	0	\N
120362	1397	1355231657000	15002	7547	65	0	\N
120363	1397	1355221656000	15002	7547	66	0	\N
120364	1397	1355211655000	15002	7547	67	0	\N
120365	1397	1355201654000	15002	7547	68	0	\N
120366	1397	1355191653000	15002	7547	69	0	\N
120367	1397	1355181652000	15002	7547	70	0	\N
120368	1397	1355171651000	15002	7547	71	0	\N
120369	1397	1355161650000	15002	7547	72	0	\N
120370	1397	1355151649000	15002	7547	73	0	\N
120371	1397	1355141648000	15002	7547	74	0	\N
120372	1397	1355131647000	15002	7547	75	0	\N
120373	1397	1355121646000	15002	7547	76	0	\N
120374	1397	1355111645000	15002	7547	77	0	\N
120375	1397	1355101644000	15002	7547	78	0	\N
120376	1397	1355091643000	15002	7547	79	0	\N
120377	1397	1355081642000	15002	7547	80	0	\N
120378	1397	1355071641000	15002	7547	81	0	\N
120379	1397	1355061640000	15002	7547	82	0	\N
120380	1397	1355051639000	15002	7547	83	0	\N
120381	1397	1355041638000	15002	7547	84	0	\N
120382	1397	1355031637000	15002	7547	85	0	\N
120383	1397	1355021636000	15002	7547	86	0	\N
120384	1397	1355011635000	15002	7547	87	0	\N
120385	1397	1355001634000	15002	7547	88	0	\N
120386	1397	1354991633000	15002	7547	89	0	\N
120387	1397	1354981632000	15002	7547	90	0	\N
120388	1397	1354971631000	15002	7547	91	0	\N
120389	1397	1354961630000	15002	7547	92	0	\N
120390	1397	1354951629000	15002	7547	93	0	\N
120391	1397	1354941628000	15002	7547	94	0	\N
120392	1397	1354931627000	15002	7547	95	0	\N
120393	1397	1354921626000	15002	7547	96	0	\N
120394	1397	1354911625000	15002	7547	97	0	\N
120395	1397	1354901624000	15002	7547	98	0	\N
120396	1397	1354891623000	15002	7547	99	0	\N
120397	1397	1354881622000	15002	7547	100	0	\N
120398	1397	1354871621000	15002	7547	101	0	\N
120399	1397	1354861620000	15002	7547	102	0	\N
120400	1397	1354851619000	15002	7547	103	0	\N
120401	1397	1354841618000	15002	7547	104	0	\N
120402	1397	1354831617000	15002	7547	105	0	\N
120403	1397	1354821616000	15002	7547	106	0	\N
120404	1397	1354811615000	15002	7547	107	0	\N
120405	1397	1354801614000	15002	7547	108	0	\N
120406	1397	1354791613000	15002	7547	109	0	\N
120407	1397	1354781612000	15002	7547	110	0	\N
120408	1397	1354771611000	15002	7547	111	0	\N
120409	1397	1354761610000	15002	7547	112	0	\N
120410	1397	1354751609000	15002	7547	113	0	\N
120411	1397	1354741608000	15002	7547	114	0	\N
120412	1397	1354731607000	15002	7547	115	0	\N
120413	1397	1354721606000	15002	7547	116	0	\N
120414	1397	1354711605000	15002	7547	117	0	\N
120415	1397	1354701604000	15002	7547	118	0	\N
120416	1397	1354691603000	15002	7547	119	0	\N
120417	1397	1354681602000	15002	7547	120	0	\N
120418	1397	1354671601000	15002	7547	121	0	\N
120419	1397	1354661600000	15002	7547	122	0	\N
120420	1397	1354651599000	15002	7547	123	0	\N
120421	1397	1354641598000	15002	7547	124	0	\N
120422	1397	1354631597000	15002	7547	125	0	\N
120425	1397	1354501584000	15004	7643	0	0	\N
120426	1726	656039011000	15004	7643	1	0	\N
120427	1397	1354491583000	15005	7644	0	0	\N
120428	1397	1354481582000	15005	7644	1	0	\N
120429	1726	656038009000	15005	7644	2	0	\N
120430	1726	656037008000	15005	7644	3	0	\N
120431	1726	656036006000	15005	7644	4	0	\N
120437	1397	1354471581000	15007	7645	0	0	\N
120438	1726	656035005000	15007	7645	1	0	\N
120443	1397	1354461580000	15010	7646	0	0	\N
120444	1726	656034003000	15010	7646	1	0	\N
120449	1397	1354431577000	15013	7649	0	0	\N
120450	1726	656030999000	15013	7649	1	0	\N
120451	1726	656029997000	15013	7649	2	0	\N
120464	1397	1354381572000	15018	7653	0	0	\N
120465	1726	656023989000	15018	7653	1	0	\N
120466	1726	656022987000	15018	7653	2	0	\N
120470	1397	1354381572000	15020	7653	0	0	\N
120471	1726	656023989000	15020	7653	1	0	\N
120472	1726	656022987000	15020	7653	2	0	\N
120473	1397	1354371571000	15021	7654	0	0	\N
120474	1726	656021986000	15021	7654	1	0	\N
120487	1397	1354361570000	15024	7655	0	0	\N
120488	1397	1354351569000	15024	7655	1	0	\N
120489	1397	1354341568000	15024	7655	2	0	\N
120490	1397	1354331567000	15024	7655	3	0	\N
120491	1726	656020984000	15024	7655	4	0	\N
120492	1726	656019983000	15024	7655	5	0	\N
120493	1726	656018981000	15024	7655	6	0	\N
120494	1726	656017980000	15024	7655	7	0	\N
120495	1726	656016978000	15024	7655	8	0	\N
120496	1726	656015977000	15024	7655	9	0	\N
120432	1397	1354491583000	15006	7644	0	0	8434
120433	1397	1354481582000	15006	7644	1	0	8435
120434	1726	656038009000	15006	7644	2	0	7699
120435	1726	656037008000	15006	7644	3	0	7700
120436	1726	656036006000	15006	7644	4	0	7701
120440	1726	656035005000	15008	7645	1	0	7702
120441	1397	1354461580000	15009	7646	0	0	8437
120442	1726	656034003000	15009	7646	1	0	7703
120445	1397	1354451579000	15011	7647	0	0	8438
120446	1726	656033002000	15011	7647	1	0	7704
120448	1726	656032000000	15012	7648	1	0	7705
120452	1397	1354431577000	15014	7649	0	0	8440
120453	1726	656030999000	15014	7649	1	0	7706
120454	1726	656029997000	15014	7649	2	0	7707
120456	1397	1354411575000	15015	7650	1	0	8442
120457	1726	656028996000	15015	7650	2	0	7708
120458	1726	656027994000	15015	7650	3	0	7709
120459	1726	656026993000	15015	7650	4	0	7710
120460	1397	1354401574000	15016	7651	0	0	8443
120462	1726	656025991000	15017	7652	1	0	7711
120463	1726	656024990000	15017	7652	2	0	7712
120467	1397	1354381572000	15019	7653	0	0	8445
120468	1726	656023989000	15019	7653	1	0	7713
120469	1726	656022987000	15019	7653	2	0	7714
120476	1726	656021986000	15022	7654	1	0	7715
120477	1397	1354361570000	15023	7655	0	0	8447
120478	1397	1354351569000	15023	7655	1	0	8448
120479	1397	1354341568000	15023	7655	2	0	8449
120481	1726	656020984000	15023	7655	4	0	7716
120482	1726	656019983000	15023	7655	5	0	7717
120483	1726	656018981000	15023	7655	6	0	7718
120484	1726	656017980000	15023	7655	7	0	7719
120485	1726	656016978000	15023	7655	8	0	7720
120498	1397	1354311565000	15026	7657	0	0	\N
120499	1726	656014976000	15026	7657	1	0	\N
120500	1726	656013974000	15026	7657	2	0	\N
120501	1397	1354311565000	15027	7657	0	0	\N
120502	1726	656014976000	15027	7657	1	0	\N
120503	1726	656013974000	15027	7657	2	0	\N
120512	1705	7118473500145	15031	7556	0	0	\N
120513	395	66027932005524	15031	7556	1	0	\N
120514	1970	199000000	15031	7556	2	0	\N
120515	1950	7169851000000	15031	7556	3	0	\N
120518	1397	1354461580000	15033	7646	0	0	\N
120519	1397	1354451579000	15033	7646	1	0	\N
120520	1397	1354441578000	15033	7646	2	0	\N
120521	1397	1354431577000	15033	7646	3	0	\N
120522	1397	1354421576000	15033	7646	4	0	\N
120523	1397	1354411575000	15033	7646	5	0	\N
120524	1397	1354401574000	15033	7646	6	0	\N
120525	1397	1354391573000	15033	7646	7	0	\N
120526	1397	1354381572000	15033	7646	8	0	\N
120527	1397	1354371571000	15033	7646	9	0	\N
120528	1397	1354361570000	15033	7646	10	0	\N
120529	1397	1354351569000	15033	7646	11	0	\N
120530	1397	1354341568000	15033	7646	12	0	\N
120531	1397	1354331567000	15033	7646	13	0	\N
120532	1397	1354321566000	15033	7646	14	0	\N
120533	1397	1354311565000	15033	7646	15	0	\N
120534	1397	1354301564000	15033	7646	16	0	\N
120535	1397	1354291563000	15033	7646	17	0	\N
120536	1397	1354281562000	15033	7646	18	0	\N
120537	1726	656034003000	15033	7646	19	0	\N
120538	1726	656033002000	15033	7646	20	0	\N
120539	1726	656032000000	15033	7646	21	0	\N
120540	1726	656030999000	15033	7646	22	0	\N
120541	1726	656029997000	15033	7646	23	0	\N
120542	1726	656028996000	15033	7646	24	0	\N
120543	1726	656027994000	15033	7646	25	0	\N
120544	1726	656026993000	15033	7646	26	0	\N
120545	1726	656025991000	15033	7646	27	0	\N
120546	1726	656024990000	15033	7646	28	0	\N
120547	1726	656023989000	15033	7646	29	0	\N
120548	1726	656022987000	15033	7646	30	0	\N
120549	1726	656021986000	15033	7646	31	0	\N
120550	1726	656020984000	15033	7646	32	0	\N
120551	1726	656019983000	15033	7646	33	0	\N
120552	1726	656018981000	15033	7646	34	0	\N
120553	1726	656017980000	15033	7646	35	0	\N
120554	1726	656016978000	15033	7646	36	0	\N
120555	1726	656015977000	15033	7646	37	0	\N
120556	1726	656014976000	15033	7646	38	0	\N
120557	1726	656013974000	15033	7646	39	0	\N
120558	1726	656012973000	15033	7646	40	0	\N
120559	1726	656011971000	15033	7646	41	0	\N
120560	1726	656010970000	15033	7646	42	0	\N
120561	1726	656009968000	15033	7646	43	0	\N
120562	1397	1354271561000	15034	7661	0	0	\N
120563	1397	1354261560000	15034	7661	1	0	\N
120564	1726	656008967000	15034	7661	2	0	\N
120565	1726	656007965000	15034	7661	3	0	\N
120566	1726	656006964000	15034	7661	4	0	\N
120572	1397	1354251559000	15036	7662	0	0	\N
120573	1397	1354251559000	15037	7662	0	0	\N
120574	1397	1354251559000	15038	7662	0	0	\N
120579	1397	1354241558000	15041	7663	0	0	\N
120580	1726	656005963000	15041	7663	2	0	\N
120581	1726	656004961000	15041	7663	3	0	\N
120582	1397	1354241558000	15042	7663	0	0	\N
120583	1726	656005963000	15042	7663	2	0	\N
120584	1726	656004961000	15042	7663	3	0	\N
120585	1397	1354241558000	15043	7663	0	0	\N
120586	1726	656005963000	15043	7663	2	0	\N
120587	1726	656004961000	15043	7663	3	0	\N
120588	1397	1354231557000	15044	7664	0	0	\N
120589	1726	656003960000	15044	7664	1	0	\N
120594	1397	1354211555000	15047	7666	0	0	\N
120595	1726	656001956000	15047	7666	1	0	\N
120596	1397	1354211555000	15048	7666	0	0	\N
120597	1726	656001956000	15048	7666	1	0	\N
120601	1397	1354201554000	15051	7667	0	0	\N
120602	1397	1354531587000	15054	7640	0	0	\N
120603	1397	1354521586000	15054	7640	1	0	\N
120604	1397	1354511585000	15054	7640	2	0	\N
120605	1397	1354501584000	15054	7640	3	0	\N
120606	1397	1354491583000	15054	7640	4	0	\N
120607	1397	1354481582000	15054	7640	5	0	\N
120608	1397	1354471581000	15054	7640	6	0	\N
120609	1397	1354461580000	15054	7640	7	0	\N
120610	1397	1354451579000	15054	7640	8	0	\N
120611	1397	1354441578000	15054	7640	9	0	\N
120612	1397	1354431577000	15054	7640	10	0	\N
120613	1397	1354421576000	15054	7640	11	0	\N
120614	1397	1354411575000	15054	7640	12	0	\N
120615	1397	1354401574000	15054	7640	13	0	\N
120616	1397	1354391573000	15054	7640	14	0	\N
120617	1397	1354381572000	15054	7640	15	0	\N
120618	1397	1354371571000	15054	7640	16	0	\N
120619	1397	1354361570000	15054	7640	17	0	\N
120620	1397	1354351569000	15054	7640	18	0	\N
120621	1397	1354341568000	15054	7640	19	0	\N
120622	1397	1354331567000	15054	7640	20	0	\N
120623	1397	1354321566000	15054	7640	21	0	\N
120624	1397	1354311565000	15054	7640	22	0	\N
120625	1397	1354301564000	15054	7640	23	0	\N
120626	1397	1354291563000	15054	7640	24	0	\N
120627	1397	1354281562000	15054	7640	25	0	\N
120628	1397	1354271561000	15054	7640	26	0	\N
120629	1397	1354261560000	15054	7640	27	0	\N
120630	1397	1354251559000	15054	7640	28	0	\N
120631	1397	1354241558000	15054	7640	29	0	\N
120632	1397	1354231557000	15054	7640	30	0	\N
120505	1726	656014976000	15028	7657	1	0	7722
120506	1726	656013974000	15028	7657	2	0	7723
120507	1397	1354301564000	15029	7658	0	0	8453
120508	1726	656012973000	15029	7658	1	0	7724
120509	1397	1354291563000	15030	7659	0	0	8454
120511	1726	656010970000	15030	7659	2	0	7726
120516	1397	1354281562000	15032	7660	0	0	8455
120517	1726	656009968000	15032	7660	1	0	7727
120567	1397	1354271561000	15035	7661	0	0	8456
120568	1397	1354261560000	15035	7661	1	0	8457
120570	1726	656007965000	15035	7661	3	0	7729
120571	1726	656006964000	15035	7661	4	0	7730
120575	1397	1354251559000	15039	7662	0	0	8458
120576	1397	1354241558000	15040	7663	0	0	8459
120578	1726	656004961000	15040	7663	3	0	7732
120590	1397	1354231557000	15045	7664	0	0	8460
120591	1726	656003960000	15045	7664	1	0	7733
120592	1397	1354221556000	15046	7665	0	0	8461
120593	1726	656002958000	15046	7665	1	0	7734
120599	1726	656001956000	15049	7666	1	0	7735
120600	1397	1354201554000	15050	7667	0	0	8463
120633	1397	1354221556000	15054	7640	31	0	\N
120634	1397	1354211555000	15054	7640	32	0	\N
120635	1397	1354201554000	15054	7640	33	0	\N
120636	1726	656043017000	15054	7640	34	0	\N
120637	1726	656042015000	15054	7640	35	0	\N
120638	1726	656041014000	15054	7640	36	0	\N
120639	1726	656040012000	15054	7640	37	0	\N
120640	1726	656039011000	15054	7640	38	0	\N
120641	1726	656038009000	15054	7640	39	0	\N
120642	1726	656037008000	15054	7640	40	0	\N
120643	1726	656036006000	15054	7640	41	0	\N
120644	1726	656035005000	15054	7640	42	0	\N
120645	1726	656034003000	15054	7640	43	0	\N
120646	1726	656033002000	15054	7640	44	0	\N
120647	1726	656032000000	15054	7640	45	0	\N
120648	1726	656030999000	15054	7640	46	0	\N
120649	1726	656029997000	15054	7640	47	0	\N
120650	1726	656028996000	15054	7640	48	0	\N
120651	1726	656027994000	15054	7640	49	0	\N
120652	1726	656026993000	15054	7640	50	0	\N
120653	1726	656025991000	15054	7640	51	0	\N
120654	1726	656024990000	15054	7640	52	0	\N
120655	1726	656023989000	15054	7640	53	0	\N
120656	1726	656022987000	15054	7640	54	0	\N
120657	1726	656021986000	15054	7640	55	0	\N
120658	1726	656020984000	15054	7640	56	0	\N
120659	1726	656019983000	15054	7640	57	0	\N
120660	1726	656018981000	15054	7640	58	0	\N
120661	1726	656017980000	15054	7640	59	0	\N
120662	1726	656016978000	15054	7640	60	0	\N
120663	1726	656015977000	15054	7640	61	0	\N
120664	1726	656014976000	15054	7640	62	0	\N
120665	1726	656013974000	15054	7640	63	0	\N
120666	1726	656012973000	15054	7640	64	0	\N
120667	1726	656011971000	15054	7640	65	0	\N
120668	1726	656010970000	15054	7640	66	0	\N
120669	1726	656009968000	15054	7640	67	0	\N
120670	1726	656008967000	15054	7640	68	0	\N
120671	1726	656007965000	15054	7640	69	0	\N
120672	1726	656006964000	15054	7640	70	0	\N
120673	1726	656005963000	15054	7640	71	0	\N
120674	1726	656004961000	15054	7640	72	0	\N
120675	1726	656003960000	15054	7640	73	0	\N
120676	1726	656002958000	15054	7640	74	0	\N
120677	1726	656001956000	15054	7640	75	0	\N
120683	1397	1354181552000	15057	7669	0	0	\N
120684	1397	1354171551000	15057	7669	1	0	\N
120685	1726	655999952000	15057	7669	2	0	\N
120686	1397	1354161550000	15058	7670	0	0	\N
120687	1726	655998950000	15058	7670	1	0	\N
120690	1397	1354151549000	15060	7671	0	0	\N
120691	1397	1354141548000	15060	7671	1	0	\N
120692	1397	1354131547000	15060	7671	2	0	\N
120693	1726	655997948000	15060	7671	3	0	\N
120698	1397	1354151549000	15062	7671	0	0	\N
120699	1397	1354141548000	15062	7671	1	0	\N
120700	1397	1354131547000	15062	7671	2	0	\N
120701	1726	655997948000	15062	7671	3	0	\N
120702	1397	1354151549000	15063	7671	0	0	\N
120703	1397	1354141548000	15063	7671	1	0	\N
120704	1397	1354131547000	15063	7671	2	0	\N
120705	1726	655997948000	15063	7671	3	0	\N
120706	1397	1354151549000	15064	7671	0	0	\N
120707	1397	1354141548000	15064	7671	1	0	\N
120708	1397	1354131547000	15064	7671	2	0	\N
120709	1726	655997948000	15064	7671	3	0	\N
120710	1397	1354121546000	15065	7672	0	0	\N
120711	1726	655996946000	15065	7672	1	0	\N
120716	1397	1354111545000	15068	7673	0	0	\N
120717	1726	655995944000	15068	7673	1	0	\N
120718	1397	1354101544000	15069	7674	0	0	\N
120720	1397	1354101544000	15071	7674	0	0	\N
120728	1397	1354051539000	15077	7680	0	0	\N
120729	1397	1354041538000	15077	7680	1	0	\N
120730	1397	1354031537000	15077	7680	2	0	\N
120731	1726	655991936000	15077	7680	3	0	\N
120732	1726	655990934000	15077	7680	4	0	\N
120733	1397	1354051539000	15078	7680	0	0	\N
120734	1397	1354041538000	15078	7680	1	0	\N
120735	1397	1354031537000	15078	7680	2	0	\N
120736	1726	655991936000	15078	7680	3	0	\N
120737	1726	655990934000	15078	7680	4	0	\N
120746	1397	1354001534000	15081	7682	0	0	\N
120747	1397	1353991533000	15081	7682	1	0	\N
120748	1726	655988930000	15081	7682	2	0	\N
120759	1397	1353951529000	15087	7686	0	0	\N
120760	1726	655985924000	15087	7686	1	0	\N
120761	1397	1353941528000	15088	7687	0	0	\N
120768	1726	655982918000	15095	7691	0	0	\N
120680	1397	1354181552000	15056	7669	0	0	8465
120681	1397	1354171551000	15056	7669	1	0	8466
120682	1726	655999952000	15056	7669	2	0	7737
120688	1397	1354161550000	15059	7670	0	0	8467
120689	1726	655998950000	15059	7670	1	0	7738
120695	1397	1354141548000	15061	7671	1	0	8469
120696	1397	1354131547000	15061	7671	2	0	8470
120697	1726	655997948000	15061	7671	3	0	7739
120712	1397	1354121546000	15066	7672	0	0	8471
120713	1726	655996946000	15066	7672	1	0	7740
120715	1726	655995944000	15067	7673	1	0	7741
120719	1397	1354101544000	15070	7674	0	0	8473
120721	1726	655994942000	15072	7675	0	0	7742
120722	1397	1354091543000	15073	7676	0	0	8474
120724	1726	655993940000	15074	7677	1	0	7743
120725	1397	1354071541000	15075	7678	0	0	8476
120726	1726	655992938000	15075	7678	1	0	7744
120727	1397	1354061540000	15076	7679	0	0	8477
120738	1397	1354051539000	15079	7680	0	0	8478
120740	1397	1354031537000	15079	7680	2	0	8480
120741	1726	655991936000	15079	7680	3	0	7745
120742	1726	655990934000	15079	7680	4	0	7746
120743	1397	1354021536000	15080	7681	0	0	8481
120744	1397	1354011535000	15080	7681	1	0	8482
120749	1397	1354001534000	15082	7682	0	0	8483
120750	1397	1353991533000	15082	7682	1	0	8484
120751	1726	655988930000	15082	7682	2	0	7748
120752	1397	1353981532000	15083	7683	0	0	8485
120754	1397	1353971531000	15084	7684	0	0	8486
120755	1726	655986926000	15084	7684	1	0	7750
120756	1397	1353961530000	15085	7685	0	0	8487
120757	1397	1353951529000	15086	7686	0	0	8488
120758	1726	655985924000	15086	7686	1	0	7751
120763	1397	1353931527000	15090	7688	0	0	8490
120764	1726	655984922000	15090	7688	1	0	7752
120765	1397	1353921526000	15091	7689	0	0	8491
120766	1726	655983920000	15091	7689	1	0	7753
120767	1726	655982918000	15094	7691	0	0	7754
120769	1726	655982918000	15096	7691	0	0	\N
120771	1397	1353911525000	15099	7694	0	0	\N
120772	1726	655980914000	15099	7694	1	0	\N
120781	1397	1353871521000	15106	7697	0	0	\N
120782	1397	1353861520000	15106	7697	1	0	\N
120783	1726	655978910000	15106	7697	2	0	\N
120784	1726	655977909000	15106	7697	3	0	\N
120785	1726	654767909000	15106	7697	4	0	\N
120786	1726	653557909000	15106	7697	5	0	\N
120787	1726	652347909000	15106	7697	6	0	\N
120788	1726	652346907000	15106	7697	7	0	\N
120789	1397	1353861520000	15107	7698	0	0	\N
120790	1726	655977909000	15107	7698	1	0	\N
120791	1726	654767909000	15107	7698	2	0	\N
120792	1726	653557909000	15107	7698	3	0	\N
120793	1726	652347909000	15107	7698	4	0	\N
120794	1726	652346907000	15107	7698	5	0	\N
120801	1397	1353861520000	15109	7698	0	0	\N
120802	1726	655977909000	15109	7698	1	0	\N
120803	1726	654767909000	15109	7698	2	0	\N
120804	1726	653557909000	15109	7698	3	0	\N
120805	1726	652347909000	15109	7698	4	0	\N
120806	1726	652346907000	15109	7698	5	0	\N
120826	1397	1353771511000	15119	7706	0	0	\N
120827	1726	652336892000	15119	7706	1	0	\N
120828	1397	1353771511000	15120	7706	0	0	\N
120829	1726	652336892000	15120	7706	1	0	\N
120832	1397	1353751509000	15122	7708	0	0	\N
120833	1397	1353751509000	15123	7708	0	0	\N
120834	1397	1353751509000	15124	7708	0	0	\N
120839	1397	1353791513000	15127	7704	0	0	\N
120840	1726	652338896000	15127	7704	1	0	\N
120841	1726	652337894000	15127	7704	2	0	\N
120849	1397	1353711505000	15130	7711	0	0	\N
120850	1397	1353701504000	15130	7711	1	0	\N
120851	1397	1353691503000	15130	7711	2	0	\N
120852	1726	652332884000	15130	7711	3	0	\N
120853	1726	652331882000	15130	7711	4	0	\N
120862	1397	1353651499000	15135	7715	0	0	\N
120863	1397	1353641498000	15135	7715	1	0	\N
120864	1726	652328876000	15135	7715	2	0	\N
120868	1397	1353621496000	15139	7717	0	0	\N
120869	1726	652327874000	15139	7717	1	0	\N
120873	1397	1353601494000	15142	7719	0	0	\N
120874	1397	1353601494000	15143	7719	0	0	\N
120877	1397	1353591493000	15145	7720	0	0	\N
120878	1726	652325870000	15145	7720	1	0	\N
120879	1397	1353741508000	15146	7709	0	0	\N
120880	1397	1353731507000	15146	7709	1	0	\N
120881	1397	1353721506000	15146	7709	2	0	\N
120882	1397	1353711505000	15146	7709	3	0	\N
120883	1397	1353701504000	15146	7709	4	0	\N
120884	1397	1353691503000	15146	7709	5	0	\N
120885	1397	1353681502000	15146	7709	6	0	\N
120886	1397	1353671501000	15146	7709	7	0	\N
120887	1397	1353661500000	15146	7709	8	0	\N
120888	1397	1353651499000	15146	7709	9	0	\N
120889	1397	1353641498000	15146	7709	10	0	\N
120890	1397	1353631497000	15146	7709	11	0	\N
120891	1397	1353621496000	15146	7709	12	0	\N
120892	1397	1353611495000	15146	7709	13	0	\N
120893	1397	1353601494000	15146	7709	14	0	\N
120894	1397	1353591493000	15146	7709	15	0	\N
120895	1726	652334888000	15146	7709	16	0	\N
120896	1726	652333886000	15146	7709	17	0	\N
120897	1726	652332884000	15146	7709	18	0	\N
120898	1726	652331882000	15146	7709	19	0	\N
120899	1726	652330880000	15146	7709	20	0	\N
120900	1726	652329878000	15146	7709	21	0	\N
120901	1726	652328876000	15146	7709	22	0	\N
120902	1726	652327874000	15146	7709	23	0	\N
120903	1726	652326872000	15146	7709	24	0	\N
120904	1726	652325870000	15146	7709	25	0	\N
120774	1726	655980914000	15100	7694	1	0	7756
120775	1397	1353901524000	15103	7695	0	0	8493
120776	1397	1353891523000	15103	7695	1	0	8494
120777	1726	655979912000	15103	7695	2	0	7757
120778	1397	1353881522000	15104	7696	0	0	8495
120780	1726	655978910000	15105	7697	1	0	7758
120795	1397	1353861520000	15108	7698	0	0	8497
120796	1726	655977909000	15108	7698	1	0	7759
120797	1726	654767909000	15108	7698	2	0	7760
120798	1726	653557909000	15108	7698	3	0	7761
120800	1726	652346907000	15108	7698	5	0	7763
120807	1397	1353851519000	15110	7699	0	0	8498
120808	1726	652345906000	15110	7699	1	0	7764
120809	1397	1353841518000	15111	7700	0	0	8499
120811	1726	652344904000	15111	7700	2	0	7765
120812	1726	652343903000	15111	7700	3	0	7766
120813	1397	1353821516000	15113	7701	0	0	8501
120814	1726	652342901000	15113	7701	1	0	7767
120815	1726	652341900000	15113	7701	2	0	7768
120817	1726	652340899000	15114	7702	1	0	7769
120818	1726	652339897000	15114	7702	2	0	7770
120819	1397	1353801514000	15115	7703	0	0	8503
120820	1397	1353791513000	15116	7704	0	0	8504
120821	1726	652338896000	15116	7704	1	0	7771
120823	1397	1353781512000	15117	7705	0	0	8505
120824	1397	1353771511000	15118	7706	0	0	8506
120825	1726	652336892000	15118	7706	1	0	7773
120830	1397	1353761510000	15121	7707	0	0	8507
120835	1397	1353751509000	15125	7708	0	0	8508
120836	1397	1353741508000	15126	7709	0	0	8509
120837	1397	1353731507000	15126	7709	1	0	8510
120838	1726	652334888000	15126	7709	2	0	7775
120842	1397	1353721506000	15128	7710	0	0	8511
120844	1397	1353711505000	15129	7711	0	0	8512
120845	1397	1353701504000	15129	7711	1	0	8513
120846	1397	1353691503000	15129	7711	2	0	8514
120847	1726	652332884000	15129	7711	3	0	7777
120848	1726	652331882000	15129	7711	4	0	7778
120855	1397	1353671501000	15132	7713	0	0	8516
120856	1726	652330880000	15132	7713	1	0	7779
120857	1397	1353661500000	15133	7714	0	0	8517
120858	1726	652329878000	15133	7714	1	0	7780
120860	1397	1353641498000	15134	7715	1	0	8519
120861	1726	652328876000	15134	7715	2	0	7781
120865	1397	1353631497000	15137	7716	0	0	8520
120866	1397	1353621496000	15138	7717	0	0	8521
120867	1726	652327874000	15138	7717	1	0	7782
120918	1397	1353521486000	15149	7723	0	0	\N
120919	1397	1353511485000	15149	7723	1	0	\N
120920	1726	651108860000	15149	7723	2	0	\N
120921	1726	651107858000	15149	7723	3	0	\N
120922	1726	651106857000	15149	7723	4	0	\N
120923	1726	651105855000	15149	7723	6	0	\N
120924	1397	1353521486000	15150	7723	0	0	\N
120925	1397	1353511485000	15150	7723	1	0	\N
120926	1726	651108860000	15150	7723	2	0	\N
120927	1726	651107858000	15150	7723	3	0	\N
120928	1726	651106857000	15150	7723	4	0	\N
120929	1726	651105855000	15150	7723	6	0	\N
120938	1726	651104854000	15154	7724	0	0	\N
120941	1397	1353491483000	15156	7725	0	0	\N
120942	1726	651103852000	15156	7725	1	0	\N
120948	1397	1353471481000	15159	7727	0	0	\N
120949	1726	651101849000	15159	7727	1	0	\N
120950	1726	651100848000	15159	7727	2	0	\N
120955	1598	2579980000000	15161	7693	0	0	\N
120956	1397	1353451479000	15162	7729	0	0	\N
120958	1397	1353451479000	15164	7729	0	0	\N
120959	1397	1353441478000	15165	7730	0	0	\N
120960	1726	651097844000	15165	7730	1	0	\N
120961	1726	651096842000	15165	7730	2	0	\N
120965	1397	1353431477000	15167	7731	0	0	\N
120966	1726	651095841000	15167	7731	1	0	\N
120967	1726	651094839000	15167	7731	2	0	\N
120968	1726	651093838000	15167	7731	3	0	\N
120969	1397	1353431477000	15168	7731	0	0	\N
120970	1726	651095841000	15168	7731	1	0	\N
120971	1726	651094839000	15168	7731	2	0	\N
120972	1726	651093838000	15168	7731	3	0	\N
120973	1397	1353431477000	15169	7731	0	0	\N
120974	1726	651095841000	15169	7731	1	0	\N
120975	1726	651094839000	15169	7731	2	0	\N
120976	1726	651093838000	15169	7731	3	0	\N
120977	1397	1353431477000	15170	7731	0	0	\N
120978	1726	651095841000	15170	7731	1	0	\N
120979	1726	651094839000	15170	7731	2	0	\N
120980	1726	651093838000	15170	7731	3	0	\N
120981	1397	1353431477000	15171	7731	0	0	\N
120982	1726	651095841000	15171	7731	1	0	\N
120983	1726	651094839000	15171	7731	2	0	\N
120984	1726	651093838000	15171	7731	3	0	\N
120985	1397	1353431477000	15172	7731	0	0	\N
120986	1726	651095841000	15172	7731	1	0	\N
120987	1726	651094839000	15172	7731	2	0	\N
120988	1726	651093838000	15172	7731	3	0	\N
120993	1397	1353421476000	15174	7732	0	0	\N
120998	1397	1353411475000	15177	7733	0	0	\N
120999	1726	651092836000	15177	7733	1	0	\N
121000	1726	651091835000	15177	7733	2	0	\N
121004	1397	1353401474000	15179	7734	0	0	\N
121005	1726	651090834000	15179	7734	1	0	\N
121006	1726	651089832000	15179	7734	2	0	\N
121007	1726	649879832000	15180	7735	0	0	\N
121008	1397	1353391473000	15180	7735	1	0	\N
121009	1397	1353381472000	15180	7735	2	0	\N
121010	1726	648669832000	15180	7735	3	0	\N
121011	1726	647459832000	15180	7735	4	0	\N
121012	1726	647458830000	15180	7735	5	0	\N
121022	1397	1353371471000	15183	7736	0	0	\N
121023	1397	1353361470000	15183	7736	1	0	\N
121024	1726	647457828000	15183	7736	2	0	\N
121025	1397	1353371471000	15184	7736	0	0	\N
121026	1397	1353361470000	15184	7736	1	0	\N
121027	1726	647457828000	15184	7736	2	0	\N
121028	1397	1353351469000	15185	7737	0	0	\N
121029	1726	647456826000	15185	7737	1	0	\N
121032	1397	1353351469000	15187	7737	0	0	\N
121033	1726	647456826000	15187	7737	1	0	\N
121035	1397	1353331467000	15189	7739	0	0	\N
121036	1397	1353321466000	15189	7739	1	0	\N
121037	1397	1353311465000	15189	7739	2	0	\N
121038	2125	190000000	15189	7739	3	0	\N
121039	2125	180000000	15189	7739	4	0	\N
121040	2125	170000000	15189	7739	5	0	\N
120931	1397	1353511485000	15151	7723	1	0	8532
120932	1726	651108860000	15151	7723	2	0	7792
120933	1726	651107858000	15151	7723	3	0	7793
120934	1726	651106857000	15151	7723	4	0	7794
120935	1726	651105855000	15151	7723	6	0	7795
120936	1397	1353501484000	15153	7724	0	0	8533
120937	1726	651104854000	15153	7724	1	0	7796
120939	1397	1353491483000	15155	7725	0	0	8534
120940	1726	651103852000	15155	7725	1	0	7797
120943	1397	1353481482000	15157	7726	0	0	8535
120944	1726	651102851000	15157	7726	1	0	7798
120945	1397	1353471481000	15158	7727	0	0	8536
120946	1726	651101849000	15158	7727	1	0	7799
120947	1726	651100848000	15158	7727	2	0	7800
120951	1598	2579980000000	15160	7728	0	0	1
120952	1397	1353461480000	15160	7728	1	0	8537
120953	1726	651099847000	15160	7728	2	0	7801
120954	1726	651098845000	15160	7728	3	0	7802
120957	1397	1353451479000	15163	7729	0	0	8538
120962	1397	1353441478000	15166	7730	0	0	8539
120963	1726	651097844000	15166	7730	1	0	7803
120964	1726	651096842000	15166	7730	2	0	7804
120989	1397	1353431477000	15173	7731	0	0	8540
120990	1726	651095841000	15173	7731	1	0	7805
120991	1726	651094839000	15173	7731	2	0	7806
120992	1726	651093838000	15173	7731	3	0	7807
120994	1397	1353421476000	15175	7732	0	0	8541
120995	1397	1353411475000	15176	7733	0	0	8542
120996	1726	651092836000	15176	7733	1	0	7808
120997	1726	651091835000	15176	7733	2	0	7809
121001	1397	1353401474000	15178	7734	0	0	8543
121002	1726	651090834000	15178	7734	1	0	7810
121003	1726	651089832000	15178	7734	2	0	7811
121013	1726	649879832000	15181	7735	0	0	7812
121014	1397	1353391473000	15181	7735	1	0	8544
121015	1397	1353381472000	15181	7735	2	0	8545
121016	1726	648669832000	15181	7735	3	0	7813
121017	1726	647459832000	15181	7735	4	0	7814
121018	1726	647458830000	15181	7735	5	0	7815
121019	1397	1353371471000	15182	7736	0	0	8546
121020	1397	1353361470000	15182	7736	1	0	8547
121021	1726	647457828000	15182	7736	2	0	7816
121030	1397	1353351469000	15186	7737	0	0	8548
121031	1726	647456826000	15186	7737	1	0	7817
121034	1397	1353341468000	15188	7738	0	0	8549
121041	1726	647455825000	15189	7739	6	0	\N
121042	1726	647454823000	15189	7739	7	0	\N
121043	1726	647453822000	15189	7739	8	0	\N
121044	1726	647452820000	15189	7739	9	0	\N
121045	1726	647451819000	15189	7739	10	0	\N
121064	1397	1353281462000	15194	7742	0	0	\N
121065	1726	647448815000	15194	7742	1	0	\N
121066	1726	647447813000	15194	7742	2	0	\N
121069	1598	2579980000000	15196	7710	0	0	\N
121070	1397	1353581492000	15196	7710	1	0	\N
121071	1397	1353571491000	15196	7710	2	0	\N
121072	1397	1353561490000	15196	7710	3	0	\N
121073	1397	1353551489000	15196	7710	4	0	\N
121074	1397	1353541488000	15196	7710	5	0	\N
121075	1397	1353531487000	15196	7710	6	0	\N
121076	1397	1353521486000	15196	7710	7	0	\N
121077	1397	1353511485000	15196	7710	8	0	\N
121078	1397	1353501484000	15196	7710	9	0	\N
121079	1397	1353491483000	15196	7710	10	0	\N
121080	1397	1353481482000	15196	7710	11	0	\N
121081	1397	1353471481000	15196	7710	12	0	\N
121082	1397	1353461480000	15196	7710	13	0	\N
121083	1397	1353451479000	15196	7710	14	0	\N
121084	1397	1353441478000	15196	7710	15	0	\N
121085	1397	1353431477000	15196	7710	16	0	\N
121086	1397	1353421476000	15196	7710	17	0	\N
121087	1397	1353411475000	15196	7710	18	0	\N
121088	1397	1353401474000	15196	7710	19	0	\N
121089	1397	1353391473000	15196	7710	20	0	\N
121090	1397	1353381472000	15196	7710	21	0	\N
121091	1397	1353371471000	15196	7710	22	0	\N
121092	1397	1353361470000	15196	7710	23	0	\N
121093	1397	1353351469000	15196	7710	24	0	\N
121094	1397	1353341468000	15196	7710	25	0	\N
121095	1397	1353331467000	15196	7710	26	0	\N
121096	1397	1353321466000	15196	7710	27	0	\N
121097	1397	1353311465000	15196	7710	28	0	\N
121098	1397	1353301464000	15196	7710	29	0	\N
121099	1397	1353291463000	15196	7710	30	0	\N
121100	1397	1353281462000	15196	7710	31	0	\N
121101	1397	1353271461000	15196	7710	32	0	\N
121102	1726	652324868000	15196	7710	33	0	\N
121103	1726	652323867000	15196	7710	34	0	\N
121104	1726	651113867000	15196	7710	35	0	\N
121105	1726	651112865000	15196	7710	36	0	\N
121106	1726	651111864000	15196	7710	37	0	\N
121107	1726	651110862000	15196	7710	38	0	\N
121108	1726	651109861000	15196	7710	39	0	\N
121109	1726	651108860000	15196	7710	40	0	\N
121110	1726	651107858000	15196	7710	41	0	\N
121111	1726	651106857000	15196	7710	42	0	\N
121112	1726	651105855000	15196	7710	43	0	\N
121113	1726	651104854000	15196	7710	45	0	\N
121114	1726	651103852000	15196	7710	46	0	\N
121115	1726	651102851000	15196	7710	47	0	\N
121116	1726	651101849000	15196	7710	48	0	\N
121117	1726	651100848000	15196	7710	49	0	\N
121118	1726	651099847000	15196	7710	50	0	\N
121119	1726	651098845000	15196	7710	51	0	\N
121120	1726	651097844000	15196	7710	52	0	\N
121121	1726	651096842000	15196	7710	53	0	\N
121122	1726	651095841000	15196	7710	54	0	\N
121123	1726	651094839000	15196	7710	55	0	\N
121124	1726	651093838000	15196	7710	56	0	\N
121125	1726	651092836000	15196	7710	57	0	\N
121126	1726	651091835000	15196	7710	58	0	\N
121127	1726	651090834000	15196	7710	59	0	\N
121128	1726	651089832000	15196	7710	60	0	\N
121129	1726	649879832000	15196	7710	61	0	\N
121130	1726	648669832000	15196	7710	62	0	\N
121131	1726	647459832000	15196	7710	63	0	\N
121132	1726	647458830000	15196	7710	64	0	\N
121133	1726	647457828000	15196	7710	65	0	\N
121134	1726	647456826000	15196	7710	66	0	\N
121135	1726	647455825000	15196	7710	67	0	\N
121136	1726	647454823000	15196	7710	68	0	\N
121137	1726	647453822000	15196	7710	69	0	\N
121138	1726	647452820000	15196	7710	70	0	\N
121139	1726	647451819000	15196	7710	71	0	\N
121140	1726	647450817000	15196	7710	72	0	\N
121141	1726	647449816000	15196	7710	73	0	\N
121142	1726	647448815000	15196	7710	74	0	\N
121143	1726	647447813000	15196	7710	75	0	\N
121144	1726	647446812000	15196	7710	76	0	\N
121145	1397	1353261460000	15197	7744	0	0	\N
121146	1726	647445810000	15197	7744	1	0	\N
121149	1397	1353251459000	15199	7745	0	0	\N
121150	1726	647444809000	15199	7745	1	0	\N
121151	1726	647443807000	15199	7745	2	0	\N
121155	1397	1353241458000	15201	7746	0	0	\N
121156	1726	647442806000	15201	7746	1	0	\N
121159	1397	1353231457000	15203	7747	0	0	\N
121160	1726	647441804000	15203	7747	1	0	\N
121161	1726	647440803000	15203	7747	2	0	\N
121162	1397	1353231457000	15204	7747	0	0	\N
121163	1726	647441804000	15204	7747	1	0	\N
121164	1726	647440803000	15204	7747	2	0	\N
121165	1726	647441804000	15205	7747	0	0	\N
121166	1726	647440803000	15205	7747	1	0	\N
121170	1397	1353231457000	15207	7747	0	0	\N
121171	1726	647441804000	15207	7747	1	0	\N
121172	1726	647440803000	15207	7747	2	0	\N
121173	1397	1353221456000	15208	7748	0	0	\N
121174	1397	1353211455000	15208	7748	1	0	\N
121175	1726	647439802000	15208	7748	2	0	\N
121176	1726	647438800000	15208	7748	3	0	\N
121048	1397	1353311465000	15190	7739	2	0	8552
121049	2125	190000000	15190	7739	3	0	1
121050	2125	180000000	15190	7739	4	0	2
121051	2125	170000000	15190	7739	5	0	3
121052	1726	647455825000	15190	7739	6	0	7818
121054	1726	647453822000	15190	7739	8	0	7820
121055	1726	647452820000	15190	7739	9	0	7821
121056	1726	647451819000	15190	7739	10	0	7822
121057	1397	1353301464000	15191	7740	0	0	8553
121058	1726	647450817000	15191	7740	1	0	7823
121060	1726	647449816000	15192	7741	1	0	7824
121061	1397	1353281462000	15193	7742	0	0	8555
121062	1726	647448815000	15193	7742	1	0	7825
121063	1726	647447813000	15193	7742	2	0	7826
121068	1726	647446812000	15195	7743	1	0	7827
121147	1397	1353261460000	15198	7744	0	0	8557
121148	1726	647445810000	15198	7744	1	0	7828
121152	1397	1353251459000	15200	7745	0	0	8558
121153	1726	647444809000	15200	7745	1	0	7829
121157	1397	1353241458000	15202	7746	0	0	8559
121158	1726	647442806000	15202	7746	1	0	7831
121167	1397	1353231457000	15206	7747	0	0	8560
121168	1726	647441804000	15206	7747	1	0	7832
121169	1726	647440803000	15206	7747	2	0	7833
121186	1397	1353181452000	15212	7751	0	0	\N
121187	1726	647434794000	15212	7751	1	0	\N
121190	1397	1353181452000	15214	7751	0	0	\N
121191	1726	647434794000	15214	7751	1	0	\N
121194	1397	1353171451000	15216	7752	0	0	\N
121195	1726	647433793000	15216	7752	1	0	\N
121201	1397	1353141448000	15218	7754	0	0	\N
121202	1397	1353131447000	15218	7754	1	0	\N
121203	1726	647429787000	15218	7754	2	0	\N
121204	1726	647428786000	15218	7754	3	0	\N
121205	1726	647427784000	15218	7754	4	0	\N
121206	1397	1353141448000	15219	7754	0	0	\N
121207	1397	1353131447000	15219	7754	1	0	\N
121208	1726	647429787000	15219	7754	2	0	\N
121209	1726	647428786000	15219	7754	3	0	\N
121210	1726	647427784000	15219	7754	4	0	\N
121216	1397	1353141448000	15221	7754	0	0	\N
121217	1397	1353131447000	15221	7754	1	0	\N
121218	1726	647429787000	15221	7754	2	0	\N
121219	1726	647428786000	15221	7754	3	0	\N
121220	1726	647427784000	15221	7754	4	0	\N
121223	1397	1353121446000	15223	7755	0	0	\N
121224	1726	647426783000	15223	7755	1	0	\N
121225	1397	1353121446000	15224	7755	0	0	\N
121226	1726	647426783000	15224	7755	1	0	\N
121227	1397	1353111445000	15225	7756	0	0	\N
121228	1726	647425781000	15225	7756	1	0	\N
121229	1726	647424780000	15225	7756	2	0	\N
121230	1397	1353111445000	15226	7756	0	0	\N
121231	1726	647425781000	15226	7756	1	0	\N
121232	1726	647424780000	15226	7756	2	0	\N
121237	1397	1353101444000	15229	7757	0	0	\N
121238	1397	1353101444000	15230	7757	0	0	\N
121242	1397	1353081442000	15232	7759	0	0	\N
121243	1726	647421776000	15232	7759	1	0	\N
121244	1726	647420774000	15232	7759	2	0	\N
121245	1397	1353081442000	15233	7759	0	0	\N
121246	1726	647421776000	15233	7759	1	0	\N
121247	1726	647420774000	15233	7759	2	0	\N
121251	1397	1353071441000	15235	7760	0	0	\N
121252	1726	647419773000	15235	7760	1	0	\N
121255	1397	1353071441000	15237	7760	0	0	\N
121256	1726	647419773000	15237	7760	1	0	\N
121257	1397	1353071441000	15238	7760	0	0	\N
121258	1726	647419773000	15238	7760	1	0	\N
121275	1397	1353001434000	15244	7765	0	0	\N
121276	1726	647410760000	15244	7765	1	0	\N
121284	1397	1352961430000	15247	7768	0	0	\N
121285	1397	1352951429000	15247	7768	1	0	\N
121286	1397	1352941428000	15247	7768	2	0	\N
121287	1726	647405753000	15247	7768	3	0	\N
121288	1726	647404751000	15247	7768	4	0	\N
121289	1726	647403750000	15247	7768	5	0	\N
121290	1726	647402748000	15247	7768	6	0	\N
121298	1397	1352931427000	15249	7769	0	0	\N
121299	1726	647401747000	15249	7769	1	0	\N
121300	1726	647400745000	15249	7769	2	0	\N
121306	1397	1352911425000	15252	7771	0	0	\N
121307	1397	1352901424000	15252	7771	1	0	\N
121308	1726	647398742000	15252	7771	2	0	\N
121309	1726	647397741000	15252	7771	3	0	\N
121179	1726	647439802000	15209	7748	2	0	7834
121180	1726	647438800000	15209	7748	3	0	7835
121181	1397	1353201454000	15210	7749	0	0	8563
121182	1726	647437799000	15210	7749	1	0	7836
121183	1726	647436797000	15210	7749	2	0	7837
121185	1726	647435796000	15211	7750	1	0	7838
121188	1397	1353181452000	15213	7751	0	0	8565
121189	1726	647434794000	15213	7751	1	0	7839
121192	1397	1353171451000	15215	7752	0	0	8566
121193	1726	647433793000	15215	7752	1	0	7840
121197	1397	1353151449000	15217	7753	1	0	8568
121198	1726	647432791000	15217	7753	2	0	7841
121199	1726	647431790000	15217	7753	3	0	7842
121200	1726	647430789000	15217	7753	4	0	7843
121212	1397	1353131447000	15220	7754	1	0	8570
121213	1726	647429787000	15220	7754	2	0	7844
121214	1726	647428786000	15220	7754	3	0	7845
121215	1726	647427784000	15220	7754	4	0	7846
121221	1397	1353121446000	15222	7755	0	0	8571
121233	1397	1353111445000	15227	7756	0	0	8572
121234	1726	647425781000	15227	7756	1	0	7848
121235	1726	647424780000	15227	7756	2	0	7849
121236	1397	1353101444000	15228	7757	0	0	8573
121239	1397	1353091443000	15231	7758	0	0	8574
121241	1726	647422777000	15231	7758	2	0	7851
121248	1397	1353081442000	15234	7759	0	0	8575
121249	1726	647421776000	15234	7759	1	0	7852
121250	1726	647420774000	15234	7759	2	0	7853
121254	1726	647419773000	15236	7760	1	0	7854
121259	1397	1353061440000	15239	7761	0	0	8577
121260	1726	647418771000	15239	7761	1	0	7855
121261	1397	1353051439000	15240	7762	0	0	8578
121262	1726	647417770000	15240	7762	1	0	7856
121264	1397	1353031437000	15241	7763	1	0	8580
121265	1397	1353021436000	15241	7763	2	0	8581
121266	1726	647416768000	15241	7763	3	0	7857
121267	1726	647415767000	15241	7763	4	0	7858
121268	1726	647414765000	15241	7763	5	0	7859
121270	1397	1353011435000	15242	7764	0	0	8582
121271	1726	647412763000	15242	7764	1	0	7861
121272	1726	647411761000	15242	7764	2	0	7862
121273	1397	1353001434000	15243	7765	0	0	8583
121277	1397	1352991433000	15245	7766	0	0	8584
121278	1397	1352981432000	15245	7766	1	0	8585
121279	1726	647409758000	15245	7766	2	0	7864
121280	1726	647408757000	15245	7766	3	0	7865
121281	1726	647407755000	15245	7766	4	0	7866
121283	1726	647406754000	15246	7767	1	0	7867
121291	1397	1352961430000	15248	7768	0	0	8587
121292	1397	1352951429000	15248	7768	1	0	8588
121293	1397	1352941428000	15248	7768	2	0	8589
121294	1726	647405753000	15248	7768	3	0	7868
121296	1726	647403750000	15248	7768	5	0	7870
121297	1726	647402748000	15248	7768	6	0	7871
121301	1397	1352931427000	15250	7769	0	0	8590
121302	1726	647401747000	15250	7769	1	0	7872
121304	1397	1352921426000	15251	7770	0	0	8591
121305	1726	647399744000	15251	7770	1	0	7874
121310	1397	1352911425000	15253	7771	0	0	8592
121311	1397	1352901424000	15253	7771	1	0	8593
121312	1726	647398742000	15253	7771	2	0	7875
121314	1397	1352911425000	15254	7771	0	0	\N
121315	1397	1352901424000	15254	7771	1	0	\N
121316	1726	647398742000	15254	7771	2	0	\N
121317	1726	647397741000	15254	7771	3	0	\N
121318	1397	1352911425000	15255	7771	0	0	\N
121319	1397	1352901424000	15255	7771	1	0	\N
121320	1726	647398742000	15255	7771	2	0	\N
121321	1726	647397741000	15255	7771	3	0	\N
121332	1397	1352891423000	15257	7772	0	0	\N
121333	1397	1352881422000	15257	7772	1	0	\N
121334	1397	1352871421000	15257	7772	2	0	\N
121335	1397	1352861420000	15257	7772	3	0	\N
121336	1726	647396740000	15257	7772	4	0	\N
121337	1726	647395738000	15257	7772	5	0	\N
121338	1726	647394737000	15257	7772	6	0	\N
121339	1726	647393735000	15257	7772	7	0	\N
121340	1726	647392734000	15257	7772	8	0	\N
121341	1726	647391732000	15257	7772	10	0	\N
121342	1397	1352891423000	15258	7772	0	0	\N
121343	1397	1352881422000	15258	7772	1	0	\N
121344	1397	1352871421000	15258	7772	2	0	\N
121345	1397	1352861420000	15258	7772	3	0	\N
121346	1726	647396740000	15258	7772	4	0	\N
121347	1726	647395738000	15258	7772	5	0	\N
121348	1726	647394737000	15258	7772	6	0	\N
121349	1726	647393735000	15258	7772	7	0	\N
121350	1726	647392734000	15258	7772	8	0	\N
121351	1726	647391732000	15258	7772	10	0	\N
121354	1397	1352851419000	15260	7773	0	0	\N
121355	1726	647390731000	15260	7773	1	0	\N
121356	1397	1352841418000	15261	7774	0	0	\N
121357	1726	647389729000	15261	7774	1	0	\N
121358	1726	647388728000	15261	7774	2	0	\N
121365	1397	1352821416000	15264	7776	0	0	\N
121367	1397	1352821416000	15266	7776	0	0	\N
121368	1397	1352811415000	15267	7777	0	0	\N
121369	1397	1352801414000	15267	7777	1	0	\N
121370	1726	647385724000	15267	7777	2	0	\N
121371	1726	647384722000	15267	7777	3	0	\N
121372	1726	647383721000	15267	7777	4	0	\N
121378	1397	1352811415000	15269	7777	0	0	\N
121379	1397	1352801414000	15269	7777	1	0	\N
121380	1726	647385724000	15269	7777	2	0	\N
121381	1726	647384722000	15269	7777	3	0	\N
121382	1726	647383721000	15269	7777	4	0	\N
121383	1397	1352791413000	15270	7778	0	0	\N
121384	1726	646173721000	15270	7778	1	0	\N
121385	1726	646172719000	15270	7778	2	0	\N
121386	1726	646171718000	15270	7778	3	0	\N
121401	1397	1352771411000	15274	7780	0	0	\N
121402	1397	1352761410000	15274	7780	1	0	\N
121403	1397	1352751409000	15274	7780	2	0	\N
121404	1726	646169715000	15274	7780	3	0	\N
121405	1534	180000000	15274	7780	4	0	\N
121406	1726	646168714000	15274	7780	5	0	\N
121407	1726	646167712000	15274	7780	6	0	\N
121408	1726	646166711000	15274	7780	7	0	\N
121413	1397	1352741408000	15276	7781	0	0	\N
121414	1397	1352731407000	15276	7781	1	0	\N
121415	1726	646165709000	15276	7781	2	0	\N
121416	1726	646164708000	15276	7781	3	0	\N
121417	1534	180000000	15277	7753	0	0	\N
121418	1397	1352721406000	15278	7782	0	0	\N
121419	1726	646163706000	15278	7782	1	0	\N
121420	1726	646162705000	15278	7782	2	0	\N
121424	1397	1352721406000	15280	7782	0	0	\N
121425	1726	646163706000	15280	7782	1	0	\N
121426	1726	646162705000	15280	7782	2	0	\N
121435	1397	1352671401000	15285	7787	0	0	\N
121436	1397	1352661400000	15285	7787	1	0	\N
121437	1397	1352651399000	15285	7787	2	0	\N
121438	1397	1352641398000	15285	7787	3	0	\N
121439	1726	646157698000	15285	7787	4	0	\N
121440	1726	646156697000	15285	7787	5	0	\N
121441	1726	646155695000	15285	7787	6	0	\N
121442	1726	646154694000	15285	7787	7	0	\N
121443	1726	646153693000	15285	7787	8	0	\N
121444	1726	646152691000	15285	7787	9	0	\N
121323	1397	1352881422000	15256	7772	1	0	8595
121324	1397	1352871421000	15256	7772	2	0	8596
121325	1397	1352861420000	15256	7772	3	0	8597
121326	1726	647396740000	15256	7772	4	0	7877
121327	1726	647395738000	15256	7772	5	0	7878
121329	1726	647393735000	15256	7772	7	0	7880
121330	1726	647392734000	15256	7772	8	0	7881
121331	1726	647391732000	15256	7772	10	0	7882
121352	1397	1352851419000	15259	7773	0	0	8598
121353	1726	647390731000	15259	7773	1	0	7883
121360	1726	647389729000	15262	7774	1	0	7884
121361	1726	647388728000	15262	7774	2	0	7885
121362	1397	1352831417000	15263	7775	0	0	8600
121363	1726	647387727000	15263	7775	1	0	7886
121366	1397	1352821416000	15265	7776	0	0	8601
121373	1397	1352811415000	15268	7777	0	0	8602
121374	1397	1352801414000	15268	7777	1	0	8603
121375	1726	647385724000	15268	7777	2	0	7888
121376	1726	647384722000	15268	7777	3	0	7889
121387	1397	1352791413000	15271	7778	0	0	8604
121388	1726	646173721000	15271	7778	1	0	7891
121389	1726	646172719000	15271	7778	2	0	7892
121390	1726	646171718000	15271	7778	3	0	7893
121391	1397	1352781412000	15272	7779	0	0	8605
121393	1397	1352771411000	15273	7780	0	0	8606
121394	1397	1352761410000	15273	7780	1	0	8607
121395	1397	1352751409000	15273	7780	2	0	8608
121396	1726	646169715000	15273	7780	3	0	7895
121398	1726	646168714000	15273	7780	5	0	7896
121399	1726	646167712000	15273	7780	6	0	7897
121400	1726	646166711000	15273	7780	7	0	7898
121409	1397	1352741408000	15275	7781	0	0	8609
121410	1397	1352731407000	15275	7781	1	0	8610
121412	1726	646164708000	15275	7781	3	0	7900
121421	1397	1352721406000	15279	7782	0	0	8611
121422	1726	646163706000	15279	7782	1	0	7901
121423	1726	646162705000	15279	7782	2	0	7902
121427	1397	1352711405000	15281	7783	0	0	8612
121429	1397	1352701404000	15282	7784	0	0	8613
121430	1397	1352691403000	15283	7785	0	0	8614
121431	1726	646160703000	15283	7785	1	0	7904
121432	1726	646159701000	15283	7785	2	0	7905
121434	1726	646158700000	15284	7786	1	0	7906
121445	1397	1352671401000	15286	7787	0	0	8616
121446	1397	1352661400000	15286	7787	1	0	8617
121447	1397	1352651399000	15286	7787	2	0	8618
121448	1397	1352641398000	15286	7787	3	0	8619
121471	1397	1352561390000	15293	7794	0	0	\N
121472	1726	646142677000	15293	7794	1	0	\N
121473	1726	646141675000	15293	7794	2	0	\N
121479	1598	2579980000000	15296	7530	0	0	\N
121480	1705	7118473500145	15296	7530	1	0	\N
121481	2085	980000000	15296	7530	2	0	\N
121482	2085	970000000	15296	7530	3	0	\N
121483	606	71037726812962	15296	7530	4	0	\N
121484	341	66000990000001	15296	7530	5	0	\N
121485	395	66027932005524	15296	7530	6	0	\N
121486	1970	199000000	15296	7530	7	0	\N
121487	1926	1194000000	15296	7530	8	0	\N
121488	1950	7169851000000	15296	7530	9	0	\N
121489	1397	1352541388000	15297	7796	0	0	\N
121490	1726	646139672000	15297	7796	1	0	\N
121493	1397	1352541388000	15299	7796	0	0	\N
121494	1726	646139672000	15299	7796	1	0	\N
121495	1397	1352531387000	15302	7798	0	0	\N
121496	1397	1352521386000	15302	7798	1	0	\N
121497	1397	1352511385000	15302	7798	2	0	\N
121498	1726	646138671000	15302	7798	3	0	\N
121507	1397	1352701404000	15304	7784	0	0	\N
121508	1397	1352691403000	15304	7784	1	0	\N
121509	1397	1352681402000	15304	7784	2	0	\N
121510	1397	1352671401000	15304	7784	3	0	\N
121511	1397	1352661400000	15304	7784	4	0	\N
121512	1397	1352651399000	15304	7784	5	0	\N
121513	1397	1352641398000	15304	7784	6	0	\N
121514	1397	1352631397000	15304	7784	7	0	\N
121515	1397	1352621396000	15304	7784	8	0	\N
121516	1397	1352611395000	15304	7784	9	0	\N
121517	1397	1352601394000	15304	7784	10	0	\N
121518	1397	1352591393000	15304	7784	11	0	\N
121519	1397	1352581392000	15304	7784	12	0	\N
121520	1397	1352571391000	15304	7784	13	0	\N
121521	1397	1352561390000	15304	7784	14	0	\N
121522	1397	1352551389000	15304	7784	15	0	\N
121523	1397	1352541388000	15304	7784	16	0	\N
121524	1397	1352531387000	15304	7784	17	0	\N
121525	1397	1352521386000	15304	7784	18	0	\N
121526	1397	1352511385000	15304	7784	19	0	\N
121527	1726	646160703000	15304	7784	20	0	\N
121528	1726	646159701000	15304	7784	21	0	\N
121529	1726	646158700000	15304	7784	22	0	\N
121530	1726	646157698000	15304	7784	23	0	\N
121531	1726	646156697000	15304	7784	24	0	\N
121532	1726	646155695000	15304	7784	25	0	\N
121533	1726	646154694000	15304	7784	26	0	\N
121534	1726	646153693000	15304	7784	27	0	\N
121535	1726	646152691000	15304	7784	28	0	\N
121536	1726	646151690000	15304	7784	29	0	\N
121537	1726	646150688000	15304	7784	30	0	\N
121538	1726	646149687000	15304	7784	31	0	\N
121539	1726	646148685000	15304	7784	32	0	\N
121540	1726	646147684000	15304	7784	33	0	\N
121541	1726	646146682000	15304	7784	34	0	\N
121542	1726	646145681000	15304	7784	35	0	\N
121543	1726	646144680000	15304	7784	36	0	\N
121544	1726	646143678000	15304	7784	37	0	\N
121545	1726	646142677000	15304	7784	38	0	\N
121546	1726	646141675000	15304	7784	39	0	\N
121547	1726	646140674000	15304	7784	40	0	\N
121548	1726	646139672000	15304	7784	41	0	\N
121549	1726	646138671000	15304	7784	42	0	\N
121550	1726	646137669000	15304	7784	43	0	\N
121551	1726	646136668000	15304	7784	44	0	\N
121552	1726	646135667000	15304	7784	45	0	\N
121553	1726	646134665000	15304	7784	46	0	\N
121554	1397	1352531387000	15305	7798	0	0	\N
121555	1397	1352521386000	15305	7798	1	0	\N
121556	1397	1352511385000	15305	7798	2	0	\N
121557	1726	646138671000	15305	7798	3	0	\N
121558	1726	646137669000	15305	7798	4	0	\N
121559	1726	646136668000	15305	7798	5	0	\N
121560	1726	646135667000	15305	7798	6	0	\N
121561	1726	646134665000	15305	7798	7	0	\N
121562	1397	1352531387000	15306	7798	0	0	\N
121563	1397	1352521386000	15306	7798	1	0	\N
121564	1397	1352511385000	15306	7798	2	0	\N
121565	1726	646138671000	15306	7798	3	0	\N
121566	1726	646137669000	15306	7798	4	0	\N
121567	1726	646136668000	15306	7798	5	0	\N
121568	1726	646135667000	15306	7798	6	0	\N
121569	1726	646134665000	15306	7798	7	0	\N
121570	1397	1352501384000	15307	7799	0	0	\N
121572	1397	1352491383000	15309	7800	0	0	\N
121573	1726	646133664000	15309	7800	1	0	\N
121574	1726	646132662000	15309	7800	2	0	\N
121580	1397	1352481382000	15312	7801	0	0	\N
121581	1726	646131661000	15312	7801	1	0	\N
121582	1397	1352471381000	15313	7802	0	0	\N
121583	1726	646130659000	15313	7802	1	0	\N
121584	1726	646129658000	15313	7802	2	0	\N
121451	1726	646155695000	15286	7787	6	0	7909
121452	1726	646154694000	15286	7787	7	0	7910
121453	1726	646153693000	15286	7787	8	0	7911
121454	1726	646152691000	15286	7787	9	0	7912
121455	1397	1352631397000	15287	7788	0	0	8620
121457	1397	1352621396000	15288	7789	0	0	8621
121458	1397	1352611395000	15288	7789	1	0	8622
121459	1726	646150688000	15288	7789	2	0	7914
121460	1726	646149687000	15288	7789	3	0	7915
121461	1726	646148685000	15288	7789	4	0	7916
121463	1726	646147684000	15289	7790	1	0	7917
121464	1397	1352591393000	15290	7791	0	0	8624
121465	1726	646146682000	15290	7791	1	0	7918
121466	1726	646145681000	15290	7791	2	0	7919
121468	1397	1352571391000	15292	7793	0	0	8626
121469	1726	646144680000	15292	7793	1	0	7920
121470	1726	646143678000	15292	7793	2	0	7921
121474	1397	1352561390000	15294	7794	0	0	8627
121475	1726	646142677000	15294	7794	1	0	7922
121477	1397	1352551389000	15295	7795	0	0	8628
121478	1726	646140674000	15295	7795	1	0	7924
121491	1397	1352541388000	15298	7796	0	0	8629
121492	1726	646139672000	15298	7796	1	0	7925
121499	1397	1352531387000	15303	7798	0	0	8630
121501	1397	1352511385000	15303	7798	2	0	8632
121502	1726	646138671000	15303	7798	3	0	7926
121503	1726	646137669000	15303	7798	4	0	7927
121504	1726	646136668000	15303	7798	5	0	7928
121506	1726	646134665000	15303	7798	7	0	7930
121571	1397	1352501384000	15308	7799	0	0	8633
121575	1397	1352491383000	15310	7800	0	0	8634
121576	1726	646133664000	15310	7800	1	0	7931
121577	1726	646132662000	15310	7800	2	0	7932
121579	1726	646131661000	15311	7801	1	0	7933
121595	1397	1352431377000	15317	7805	0	0	\N
121596	1726	646124651000	15317	7805	1	0	\N
121609	1397	1352381372000	15322	7809	0	0	\N
121611	1397	1352371371000	15324	7810	0	0	\N
121612	1726	646117641000	15324	7810	1	0	\N
121613	1726	646116639000	15324	7810	2	0	\N
121622	1397	1352351369000	15328	7812	0	0	\N
121623	1726	646113635000	15328	7812	1	0	\N
121631	1397	1352311365000	15330	7814	0	0	\N
121632	1726	646108628000	15330	7814	1	0	\N
121633	1726	646107626000	15330	7814	2	0	\N
121637	1397	1352311365000	15332	7814	0	0	\N
121638	1726	646108628000	15332	7814	1	0	\N
121639	1726	646107626000	15332	7814	2	0	\N
121646	1397	1352281362000	15335	7816	0	0	\N
121647	1726	646104622000	15335	7816	1	0	\N
121648	1397	1352271361000	15336	7817	0	0	\N
121649	1397	1352261360000	15336	7817	1	0	\N
121650	1397	1352251359000	15336	7817	2	0	\N
121651	1726	646103620000	15336	7817	3	0	\N
121652	1726	646102619000	15336	7817	4	0	\N
121653	1726	646101617000	15336	7817	5	0	\N
121654	1726	646100616000	15336	7817	6	0	\N
121655	1397	1352271361000	15337	7817	0	0	\N
121656	1397	1352261360000	15337	7817	1	0	\N
121657	1397	1352251359000	15337	7817	2	0	\N
121658	1726	646103620000	15337	7817	3	0	\N
121659	1726	646102619000	15337	7817	4	0	\N
121660	1726	646101617000	15337	7817	5	0	\N
121661	1726	646100616000	15337	7817	6	0	\N
121662	1397	1352271361000	15338	7817	0	0	\N
121663	1397	1352261360000	15338	7817	1	0	\N
121664	1397	1352251359000	15338	7817	2	0	\N
121665	1726	646103620000	15338	7817	3	0	\N
121666	1726	646102619000	15338	7817	4	0	\N
121667	1726	646101617000	15338	7817	5	0	\N
121668	1726	646100616000	15338	7817	6	0	\N
121686	1397	1352211355000	15342	7819	0	0	\N
121687	1726	646095609000	15342	7819	1	0	\N
121688	1726	646094607000	15342	7819	2	0	\N
121689	1397	1352201354000	15343	7820	0	0	\N
121690	1726	646093606000	15343	7820	1	0	\N
121693	1397	1352201354000	15345	7820	0	0	\N
121694	1726	646093606000	15345	7820	1	0	\N
121698	1397	1352191353000	15347	7821	0	0	\N
121699	1726	646092604000	15347	7821	2	0	\N
121700	1726	646091603000	15347	7821	3	0	\N
121701	1397	1352181352000	15348	7822	0	0	\N
121703	1397	1352171351000	15350	7823	0	0	\N
121704	1726	646090602000	15350	7823	1	0	\N
121705	1726	646089600000	15350	7823	2	0	\N
121709	1397	1352161350000	15352	7824	0	0	\N
121710	1726	646088599000	15352	7824	1	0	\N
121716	1397	1352151349000	15357	7825	0	0	\N
121717	1726	646087597000	15357	7825	1	0	\N
121718	1726	646086596000	15357	7825	2	0	\N
121587	1726	646129658000	15314	7802	2	0	7935
121588	1397	1352461380000	15315	7803	0	0	8637
121589	1397	1352451379000	15315	7803	1	0	8638
121590	1726	646128656000	15315	7803	2	0	7936
121591	1726	646127655000	15315	7803	3	0	7937
121593	1726	646126654000	15316	7804	1	0	7938
121594	1726	646125652000	15316	7804	2	0	7939
121597	1397	1352431377000	15318	7805	0	0	8640
121598	1726	646124651000	15318	7805	1	0	7940
121599	1397	1352421376000	15319	7806	0	0	8641
121601	1397	1352411375000	15320	7807	0	0	8642
121602	1397	1352401374000	15320	7807	1	0	8643
121603	1726	646122648000	15320	7807	2	0	7942
121604	1726	646121646000	15320	7807	3	0	7943
121606	1397	1352391373000	15321	7808	0	0	8644
121607	1726	646119643000	15321	7808	1	0	7945
121608	1726	646118642000	15321	7808	2	0	7946
121610	1397	1352381372000	15323	7809	0	0	8645
121614	1397	1352371371000	15325	7810	0	0	8646
121616	1726	646116639000	15325	7810	2	0	7948
121617	1397	1352361370000	15326	7811	0	0	8647
121618	1726	646115638000	15326	7811	1	0	7949
121619	1726	646114636000	15326	7811	2	0	7950
121620	1397	1352351369000	15327	7812	0	0	8648
121624	1397	1352341368000	15329	7813	0	0	8649
121625	1397	1352331367000	15329	7813	1	0	8650
121626	1397	1352321366000	15329	7813	2	0	8651
121627	1726	646112633000	15329	7813	3	0	7952
121629	1726	646110630000	15329	7813	5	0	7954
121630	1726	646109629000	15329	7813	6	0	7955
121634	1397	1352311365000	15331	7814	0	0	8652
121635	1726	646108628000	15331	7814	1	0	7956
121636	1726	646107626000	15331	7814	2	0	7957
121641	1397	1352291363000	15333	7815	1	0	8654
121642	1726	646106625000	15333	7815	2	0	7958
121643	1726	646105623000	15333	7815	3	0	7959
121644	1397	1352281362000	15334	7816	0	0	8655
121645	1726	646104622000	15334	7816	1	0	7960
121670	1397	1352261360000	15339	7817	1	0	8657
121671	1397	1352251359000	15339	7817	2	0	8658
121672	1726	646103620000	15339	7817	3	0	7961
121673	1726	646102619000	15339	7817	4	0	7962
121675	1726	646100616000	15339	7817	6	0	7964
121676	1397	1352241358000	15340	7818	0	0	8659
121677	1397	1352231357000	15340	7818	1	0	8660
121678	1397	1352221356000	15340	7818	2	0	8661
121679	1726	646099615000	15340	7818	3	0	7965
121681	1726	646097612000	15340	7818	5	0	7967
121682	1726	646096610000	15340	7818	6	0	7968
121683	1397	1352211355000	15341	7819	0	0	8662
121684	1726	646095609000	15341	7819	1	0	7969
121685	1726	646094607000	15341	7819	2	0	7970
121692	1726	646093606000	15344	7820	1	0	7971
121695	1397	1352191353000	15346	7821	0	0	8664
121696	1726	646092604000	15346	7821	2	0	7972
121697	1726	646091603000	15346	7821	3	0	7973
121706	1397	1352171351000	15351	7823	0	0	8666
121707	1726	646090602000	15351	7823	1	0	7974
121708	1726	646089600000	15351	7823	2	0	7975
121711	1397	1352161350000	15353	7824	0	0	8667
121712	1726	646088599000	15353	7824	1	0	7976
121714	1726	646087597000	15356	7825	1	0	7977
121715	1726	646086596000	15356	7825	2	0	7978
121719	1397	1352141348000	15358	7826	0	0	8669
121720	1726	646085594000	15358	7826	1	0	7979
121723	1397	1352131347000	15361	7827	0	0	\N
121724	1726	646084593000	15361	7827	1	0	\N
121730	1397	1352121346000	15365	7828	0	0	\N
121731	1397	1352111345000	15365	7828	1	0	\N
121732	1726	646083591000	15365	7828	2	0	\N
121733	1726	646082590000	15365	7828	3	0	\N
121734	1726	646081589000	15365	7828	4	0	\N
121735	1397	1352121346000	15366	7828	0	0	\N
121736	1397	1352111345000	15366	7828	1	0	\N
121737	1726	646083591000	15366	7828	2	0	\N
121738	1726	646082590000	15366	7828	3	0	\N
121739	1726	646081589000	15366	7828	4	0	\N
121740	1397	1352121346000	15367	7828	0	0	\N
121741	1397	1352111345000	15367	7828	1	0	\N
121742	1726	646083591000	15367	7828	2	0	\N
121743	1726	646082590000	15367	7828	3	0	\N
121744	1726	646081589000	15367	7828	4	0	\N
121745	1397	1352101344000	15368	7829	0	0	\N
121746	1397	1352091343000	15368	7829	1	0	\N
121747	1726	646080587000	15368	7829	2	0	\N
121748	1726	646079586000	15368	7829	3	0	\N
121749	1726	646078584000	15368	7829	4	0	\N
121757	1397	1352071341000	15371	7831	0	0	\N
121758	1726	646076581000	15371	7831	1	0	\N
121759	1726	646075580000	15371	7831	2	0	\N
121764	1397	1352061340000	15374	7832	0	0	\N
121765	1397	1352061340000	15375	7832	0	0	\N
121766	1397	1352161350000	15377	7824	0	0	\N
121767	1397	1352151349000	15377	7824	1	0	\N
121768	1397	1352141348000	15377	7824	2	0	\N
121769	1397	1352131347000	15377	7824	3	0	\N
121770	1397	1352121346000	15377	7824	4	0	\N
121771	1397	1352111345000	15377	7824	5	0	\N
121772	1397	1352101344000	15377	7824	6	0	\N
121773	1397	1352091343000	15377	7824	7	0	\N
121774	1397	1352081342000	15377	7824	8	0	\N
121775	1397	1352071341000	15377	7824	9	0	\N
121776	1397	1352061340000	15377	7824	10	0	\N
121777	1397	1352051339000	15377	7824	11	0	\N
121778	1397	1352041338000	15377	7824	12	0	\N
121779	1726	646088599000	15377	7824	13	0	\N
121780	1726	646087597000	15377	7824	14	0	\N
121781	1726	646086596000	15377	7824	15	0	\N
121782	1726	646085594000	15377	7824	16	0	\N
121783	1726	646084593000	15377	7824	17	0	\N
121784	1726	646083591000	15377	7824	18	0	\N
121785	1726	646082590000	15377	7824	19	0	\N
121786	1726	646081589000	15377	7824	20	0	\N
121787	1726	646080587000	15377	7824	21	0	\N
121788	1726	646079586000	15377	7824	22	0	\N
121789	1726	646078584000	15377	7824	23	0	\N
121790	1726	646077583000	15377	7824	24	0	\N
121791	1726	646076581000	15377	7824	25	0	\N
121792	1726	646075580000	15377	7824	26	0	\N
121793	1726	646074578000	15377	7824	27	0	\N
121794	1726	646073577000	15377	7824	28	0	\N
121795	1726	646072576000	15377	7824	29	0	\N
121796	1726	646071574000	15377	7824	30	0	\N
121810	1598	2579980000000	15380	7652	0	0	\N
121811	2058	548500000	15380	7652	1	0	\N
121825	1397	1351961330000	15388	7838	0	0	\N
121826	1726	646061560000	15388	7838	1	0	\N
121832	1397	1351941328000	15393	7840	0	0	\N
121833	1726	646058555000	15393	7840	1	0	\N
121834	1397	1351941328000	15394	7840	0	0	\N
121835	1726	646058555000	15394	7840	1	0	\N
121836	2119	199000000	15395	7653	0	0	\N
121839	1397	1351931327000	15397	7841	0	0	\N
121840	1726	646057554000	15397	7841	1	0	\N
121853	1397	1351871321000	15402	7846	0	0	\N
121854	1726	646049542000	15402	7846	2	0	\N
121855	1726	646048541000	15402	7846	3	0	\N
121725	1397	1352121346000	15364	7828	0	0	8671
121726	1397	1352111345000	15364	7828	1	0	8672
121727	1726	646083591000	15364	7828	2	0	7981
121728	1726	646082590000	15364	7828	3	0	7982
121729	1726	646081589000	15364	7828	4	0	7983
121751	1397	1352091343000	15369	7829	1	0	8674
121752	1726	646080587000	15369	7829	2	0	7984
121753	1726	646079586000	15369	7829	3	0	7985
121754	1726	646078584000	15369	7829	4	0	7986
121755	1397	1352081342000	15370	7830	0	0	8675
121760	1397	1352071341000	15372	7831	0	0	8676
121761	1726	646076581000	15372	7831	1	0	7988
121762	1726	646075580000	15372	7831	2	0	7989
121763	1397	1352061340000	15373	7832	0	0	8677
121798	1397	1352041338000	15378	7833	1	0	8679
121799	1726	646074578000	15378	7833	2	0	7990
121800	1726	646073577000	15378	7833	3	0	7991
121801	1726	646072576000	15378	7833	4	0	7992
121802	1726	646071574000	15378	7833	5	0	7993
121804	1397	1352021336000	15379	7834	1	0	8681
121805	1397	1352011335000	15379	7834	2	0	8682
121806	2058	548500000	15379	7834	3	0	7
121807	1726	646070573000	15379	7834	4	0	7994
121808	1726	646069571000	15379	7834	5	0	7995
121812	1397	1352001334000	15381	7835	0	0	8683
121813	1397	1351991333000	15381	7835	1	0	8684
121814	1726	646067568000	15381	7835	2	0	7997
121815	1726	646066567000	15381	7835	3	0	7998
121817	1726	646064564000	15381	7835	5	0	8000
121818	1397	1351981332000	15383	7836	0	0	8685
121819	2119	199000000	15383	7836	1	0	1
121820	1397	1351971331000	15385	7837	0	0	8686
121821	1726	646063563000	15385	7837	1	0	8001
121823	1397	1351961330000	15387	7838	0	0	8687
121824	1726	646061560000	15387	7838	1	0	8003
121827	1397	1351951329000	15391	7839	0	0	8688
121828	1726	646060558000	15391	7839	1	0	8004
121829	1726	646059557000	15391	7839	2	0	8005
121831	1726	646058555000	15392	7840	1	0	8006
121837	1397	1351931327000	15396	7841	0	0	8690
121838	1726	646057554000	15396	7841	1	0	8007
121841	1397	1351921326000	15398	7842	0	0	8691
121843	1726	646055551000	15398	7842	2	0	8009
121844	1397	1351911325000	15399	7843	0	0	8692
121845	1726	646054550000	15399	7843	1	0	8010
121846	1397	1351901324000	15400	7844	0	0	8693
121847	1726	646053548000	15400	7844	1	0	8011
121849	1397	1351881322000	15401	7845	1	0	8695
121850	1726	646052547000	15401	7845	2	0	8012
121851	1726	646051545000	15401	7845	3	0	8013
121852	1726	646050544000	15401	7845	4	0	8014
121856	1397	1351871321000	15403	7846	0	0	8696
121859	1397	1351871321000	15404	7846	0	0	\N
121860	1726	646049542000	15404	7846	2	0	\N
121861	1726	646048541000	15404	7846	3	0	\N
121869	1643	4875888428700	15407	7849	0	0	\N
121870	1643	2950241740700	15407	7849	1	0	\N
121871	1397	1351831317000	15407	7849	2	0	\N
121872	1726	646043534000	15407	7849	3	0	\N
121873	1643	4875888428700	15408	7849	0	0	\N
121874	1643	2950241740700	15408	7849	1	0	\N
121875	1397	1351831317000	15408	7849	2	0	\N
121876	1726	646043534000	15408	7849	3	0	\N
121877	1643	4875888428700	15409	7849	0	0	\N
121878	1643	2950241740700	15409	7849	1	0	\N
121879	1397	1351831317000	15409	7849	2	0	\N
121880	1726	646043534000	15409	7849	3	0	\N
121887	1397	1351811315000	15412	7851	0	0	\N
121888	1643	1650966296700	15412	7851	1	0	\N
121889	1643	576377114700	15412	7851	2	0	\N
121890	1726	646041531000	15412	7851	3	0	\N
121895	1643	4155877428700	15414	7654	0	0	\N
121896	1643	2230230740700	15414	7654	1	0	\N
121900	1397	1351791313000	15416	7853	0	0	\N
121901	1726	646038527000	15416	7853	1	0	\N
121902	1726	646037525000	15416	7853	2	0	\N
121903	1397	1351791313000	15417	7853	0	0	\N
121904	1726	646038527000	15417	7853	1	0	\N
121905	1726	646037525000	15417	7853	2	0	\N
121913	1397	1351761310000	15420	7855	0	0	\N
121914	1726	646034521000	15420	7855	1	0	\N
121915	1397	1351761310000	15421	7855	0	0	\N
121916	1726	646034521000	15421	7855	1	0	\N
121919	1397	1351751309000	15423	7856	0	0	\N
121920	1726	646033519000	15423	7856	1	0	\N
121921	1726	646032518000	15423	7856	2	0	\N
121927	1397	1351731307000	15426	7858	0	0	\N
121928	1726	646030515000	15426	7858	1	0	\N
121929	1397	1351731307000	15427	7858	0	0	\N
121930	1726	646030515000	15427	7858	1	0	\N
121933	1397	1351731307000	15429	7858	0	0	\N
121934	1726	646030515000	15429	7858	1	0	\N
121938	1397	1351721306000	15431	7859	0	0	\N
121939	1726	646029514000	15431	7859	1	0	\N
121940	1726	646028512000	15431	7859	2	0	\N
121948	1397	1351711305000	15433	7860	0	0	\N
121949	1397	1351701304000	15433	7860	1	0	\N
121950	1397	1351691303000	15433	7860	2	0	\N
121951	1726	646027511000	15433	7860	3	0	\N
121952	1726	646026509000	15433	7860	4	0	\N
121953	1726	646025508000	15433	7860	5	0	\N
121954	1726	646024506000	15433	7860	6	0	\N
121964	1397	1351661300000	15436	7862	0	0	\N
121965	1397	1351651299000	15436	7862	1	0	\N
121966	1726	646020501000	15436	7862	2	0	\N
121967	1726	646019499000	15436	7862	3	0	\N
121968	1397	1351641298000	15437	7863	0	0	\N
121969	1397	1351631297000	15437	7863	1	0	\N
121970	1726	646018498000	15437	7863	2	0	\N
121971	1726	646017496000	15437	7863	3	0	\N
121972	1726	646016495000	15437	7863	4	0	\N
121973	1397	1351641298000	15438	7863	0	0	\N
121974	1397	1351631297000	15438	7863	1	0	\N
121975	1726	646018498000	15438	7863	2	0	\N
121976	1726	646017496000	15438	7863	3	0	\N
121977	1726	646016495000	15438	7863	4	0	\N
121983	1397	1351741308000	15440	7857	0	0	\N
121984	1397	1351731307000	15440	7857	1	0	\N
121985	1397	1351721306000	15440	7857	2	0	\N
121986	1397	1351711305000	15440	7857	3	0	\N
121987	1397	1351701304000	15440	7857	4	0	\N
121988	1397	1351691303000	15440	7857	5	0	\N
121989	1397	1351681302000	15440	7857	6	0	\N
121990	1397	1351671301000	15440	7857	7	0	\N
121991	1397	1351661300000	15440	7857	8	0	\N
121992	1397	1351651299000	15440	7857	9	0	\N
121862	1397	1351861320000	15405	7847	0	0	8697
121863	1397	1351851319000	15406	7848	0	0	8698
121864	1397	1351841318000	15406	7848	1	0	8699
121865	1726	646047539000	15406	7848	2	0	8017
121866	1726	646046538000	15406	7848	3	0	8018
121868	1726	646044535000	15406	7848	5	0	8020
121881	1643	4875888428700	15410	7849	0	0	10
121882	1643	2950241740700	15410	7849	1	0	11
121883	1397	1351831317000	15410	7849	2	0	8700
121884	1726	646043534000	15410	7849	3	0	8021
121886	1726	646042532000	15411	7850	1	0	8022
121891	1397	1351811315000	15413	7851	0	0	8702
121892	1643	1650966296700	15413	7851	1	0	12
121893	1643	576377114700	15413	7851	2	0	13
121897	1397	1351801314000	15415	7852	0	0	8703
121898	1726	646040529000	15415	7852	1	0	8024
121899	1726	646039528000	15415	7852	2	0	8025
121906	1397	1351791313000	15418	7853	0	0	8704
121907	1726	646038527000	15418	7853	1	0	8026
121909	1397	1351781312000	15419	7854	0	0	8705
121910	1397	1351771311000	15419	7854	1	0	8706
121911	1726	646036524000	15419	7854	2	0	8028
121912	1726	646035522000	15419	7854	3	0	8029
121917	1397	1351761310000	15422	7855	0	0	8707
121922	1397	1351751309000	15424	7856	0	0	8708
121923	1726	646033519000	15424	7856	1	0	8031
121924	1726	646032518000	15424	7856	2	0	8032
121925	1397	1351741308000	15425	7857	0	0	8709
121931	1397	1351731307000	15428	7858	0	0	8710
121932	1726	646030515000	15428	7858	1	0	8034
121935	1397	1351721306000	15430	7859	0	0	8711
121936	1726	646029514000	15430	7859	1	0	8035
121937	1726	646028512000	15430	7859	2	0	8036
121942	1397	1351701304000	15432	7860	1	0	8713
121943	1397	1351691303000	15432	7860	2	0	8714
121944	1726	646027511000	15432	7860	3	0	8037
121945	1726	646026509000	15432	7860	4	0	8038
121946	1726	646025508000	15432	7860	5	0	8039
121955	1397	1351681302000	15434	7861	0	0	8715
121956	1397	1351671301000	15434	7861	1	0	8716
121957	1726	646023505000	15434	7861	2	0	8041
121958	1726	646022503000	15434	7861	3	0	8042
121960	1397	1351661300000	15435	7862	0	0	8717
121961	1397	1351651299000	15435	7862	1	0	8718
121962	1726	646020501000	15435	7862	2	0	8044
121963	1726	646019499000	15435	7862	3	0	8045
121978	1397	1351641298000	15439	7863	0	0	8719
121980	1726	646018498000	15439	7863	2	0	8046
121981	1726	646017496000	15439	7863	3	0	8047
121982	1726	646016495000	15439	7863	4	0	8048
121993	1397	1351641298000	15440	7857	10	0	\N
121994	1397	1351631297000	15440	7857	11	0	\N
121995	1726	646031516000	15440	7857	12	0	\N
121996	1726	646030515000	15440	7857	13	0	\N
121997	1726	646029514000	15440	7857	14	0	\N
121998	1726	646028512000	15440	7857	15	0	\N
121999	1726	646027511000	15440	7857	16	0	\N
122000	1726	646026509000	15440	7857	17	0	\N
122001	1726	646025508000	15440	7857	18	0	\N
122002	1726	646024506000	15440	7857	19	0	\N
122003	1726	646023505000	15440	7857	20	0	\N
122004	1726	646022503000	15440	7857	21	0	\N
122005	1726	646021502000	15440	7857	22	0	\N
122006	1726	646020501000	15440	7857	23	0	\N
122007	1726	646019499000	15440	7857	24	0	\N
122008	1726	646018498000	15440	7857	25	0	\N
122009	1726	646017496000	15440	7857	26	0	\N
122010	1726	646016495000	15440	7857	27	0	\N
122013	1397	1351621296000	15442	7864	0	0	\N
122014	1726	646015493000	15442	7864	1	0	\N
122015	1397	1351621296000	15443	7864	0	0	\N
122016	1726	646015493000	15443	7864	1	0	\N
122017	1397	1351621296000	15444	7864	0	0	\N
122018	1726	646015493000	15444	7864	1	0	\N
122033	1397	1351551289000	15448	7868	0	0	\N
122034	1726	646006480000	15448	7868	1	0	\N
122035	1726	646005479000	15448	7868	2	0	\N
122039	1397	1351541288000	15452	7870	0	0	\N
122040	1397	1351531287000	15452	7870	1	0	\N
122041	1397	1351521286000	15452	7870	2	0	\N
122042	1726	646004477000	15452	7870	3	0	\N
122043	1726	646003476000	15452	7870	4	0	\N
122044	1726	646002475000	15452	7870	5	0	\N
122045	1726	646001473000	15452	7870	6	0	\N
122053	1397	1351541288000	15454	7870	0	0	\N
122054	1397	1351531287000	15454	7870	1	0	\N
122055	1397	1351521286000	15454	7870	2	0	\N
122056	1726	646004477000	15454	7870	3	0	\N
122057	1726	646003476000	15454	7870	4	0	\N
122058	1726	646002475000	15454	7870	5	0	\N
122059	1726	646001473000	15454	7870	6	0	\N
122060	1397	1351541288000	15455	7870	0	0	\N
122061	1397	1351531287000	15455	7870	1	0	\N
122062	1397	1351521286000	15455	7870	2	0	\N
122063	1726	646004477000	15455	7870	3	0	\N
122064	1726	646003476000	15455	7870	4	0	\N
122065	1726	646002475000	15455	7870	5	0	\N
122066	1726	646001473000	15455	7870	6	0	\N
122067	1397	1351511285000	15456	7871	0	0	\N
122068	1726	646000472000	15456	7871	1	0	\N
122073	1397	1351491283000	15459	7873	0	0	\N
122074	1726	645998469000	15459	7873	1	0	\N
122077	1397	1352501384000	15461	7785	0	0	\N
122078	1643	4875888428700	15461	7785	1	0	\N
122079	1643	2950241740700	15461	7785	2	0	\N
122080	1643	1650966296700	15461	7785	3	0	\N
122081	1643	576377114700	15461	7785	4	0	\N
122082	1397	1352491383000	15461	7785	5	0	\N
122083	1397	1352481382000	15461	7785	6	0	\N
122084	1397	1352471381000	15461	7785	7	0	\N
122085	1397	1352461380000	15461	7785	8	0	\N
122086	1397	1352451379000	15461	7785	9	0	\N
122087	1397	1352441378000	15461	7785	10	0	\N
122088	1397	1352431377000	15461	7785	11	0	\N
122089	1397	1352421376000	15461	7785	12	0	\N
122090	1397	1352411375000	15461	7785	13	0	\N
122091	1397	1352401374000	15461	7785	14	0	\N
122092	1397	1352391373000	15461	7785	15	0	\N
122093	1397	1352381372000	15461	7785	17	0	\N
122094	1397	1352371371000	15461	7785	18	0	\N
122095	1397	1352361370000	15461	7785	19	0	\N
122096	1397	1352351369000	15461	7785	20	0	\N
122097	1397	1352341368000	15461	7785	21	0	\N
122098	1397	1352331367000	15461	7785	22	0	\N
122099	1397	1352321366000	15461	7785	23	0	\N
122100	1397	1352311365000	15461	7785	24	0	\N
122101	1397	1352301364000	15461	7785	25	0	\N
122102	1397	1352291363000	15461	7785	26	0	\N
122103	1397	1352281362000	15461	7785	27	0	\N
122104	1397	1352271361000	15461	7785	28	0	\N
122105	1397	1352261360000	15461	7785	29	0	\N
122106	1397	1352251359000	15461	7785	30	0	\N
122107	1397	1352241358000	15461	7785	31	0	\N
122108	1397	1352231357000	15461	7785	32	0	\N
122109	1397	1352221356000	15461	7785	33	0	\N
122110	1397	1352211355000	15461	7785	34	0	\N
122111	1397	1352201354000	15461	7785	35	0	\N
122112	1397	1352191353000	15461	7785	36	0	\N
122113	1397	1352181352000	15461	7785	37	0	\N
122114	1397	1352171351000	15461	7785	38	0	\N
122115	1397	1352161350000	15461	7785	39	0	\N
122116	1397	1352151349000	15461	7785	40	0	\N
122117	1397	1352141348000	15461	7785	41	0	\N
122118	1397	1352131347000	15461	7785	42	0	\N
122119	1397	1352121346000	15461	7785	43	0	\N
122120	1397	1352111345000	15461	7785	44	0	\N
122121	1397	1352101344000	15461	7785	45	0	\N
122122	1397	1352091343000	15461	7785	46	0	\N
122123	1397	1352081342000	15461	7785	47	0	\N
122124	1397	1352071341000	15461	7785	48	0	\N
122125	1397	1352061340000	15461	7785	49	0	\N
122126	1397	1352051339000	15461	7785	50	0	\N
122127	1397	1352041338000	15461	7785	51	0	\N
122128	1397	1352031337000	15461	7785	52	0	\N
122019	1397	1351611295000	15445	7865	0	0	8722
122020	1397	1351601294000	15445	7865	1	0	8723
122021	1726	646014492000	15445	7865	2	0	8050
122022	1726	646013490000	15445	7865	3	0	8051
122023	1726	646012489000	15445	7865	4	0	8052
122025	1726	646011488000	15446	7866	1	0	8053
122026	1397	1351581292000	15447	7867	0	0	8725
122027	1397	1351571291000	15447	7867	1	0	8726
122028	1397	1351561290000	15447	7867	2	0	8727
122029	1726	646010486000	15447	7867	3	0	8054
122031	1726	646008483000	15447	7867	5	0	8056
122032	1726	646007482000	15447	7867	6	0	8057
122036	1397	1351551289000	15449	7868	0	0	8728
122037	1726	646006480000	15449	7868	1	0	8058
122046	1397	1351541288000	15453	7870	0	0	8729
122047	1397	1351531287000	15453	7870	1	0	8730
122048	1397	1351521286000	15453	7870	2	0	8731
122049	1726	646004477000	15453	7870	3	0	8060
122050	1726	646003476000	15453	7870	4	0	8061
122052	1726	646001473000	15453	7870	6	0	8063
122069	1397	1351511285000	15457	7871	0	0	8732
122070	1726	646000472000	15457	7871	1	0	8064
122071	1397	1351501284000	15458	7872	0	0	8733
122072	1726	645999470000	15458	7872	1	0	8065
122076	1726	645998469000	15460	7873	1	0	8066
122129	1397	1352021336000	15461	7785	53	0	\N
122130	1397	1352011335000	15461	7785	54	0	\N
122131	1397	1352001334000	15461	7785	55	0	\N
122132	1397	1351991333000	15461	7785	56	0	\N
122133	1397	1351981332000	15461	7785	57	0	\N
122134	1397	1351971331000	15461	7785	58	0	\N
122135	1397	1351961330000	15461	7785	59	0	\N
122136	1397	1351951329000	15461	7785	60	0	\N
122137	1397	1351941328000	15461	7785	61	0	\N
122138	1397	1351931327000	15461	7785	62	0	\N
122139	1397	1351921326000	15461	7785	63	0	\N
122140	1397	1351911325000	15461	7785	64	0	\N
122141	1397	1351901324000	15461	7785	65	0	\N
122142	1397	1351891323000	15461	7785	66	0	\N
122143	1397	1351881322000	15461	7785	67	0	\N
122144	1397	1351871321000	15461	7785	68	0	\N
122145	1397	1351861320000	15461	7785	69	0	\N
122146	1397	1351851319000	15461	7785	70	0	\N
122147	1397	1351841318000	15461	7785	71	0	\N
122148	1397	1351831317000	15461	7785	72	0	\N
122149	1397	1351821316000	15461	7785	73	0	\N
122150	1397	1351811315000	15461	7785	74	0	\N
122151	1397	1351801314000	15461	7785	75	0	\N
122152	1397	1351791313000	15461	7785	76	0	\N
122153	1397	1351781312000	15461	7785	77	0	\N
122154	1397	1351771311000	15461	7785	78	0	\N
122155	1397	1351761310000	15461	7785	79	0	\N
122156	1397	1351751309000	15461	7785	80	0	\N
122157	1397	1351741308000	15461	7785	81	0	\N
122158	1397	1351731307000	15461	7785	82	0	\N
122159	1397	1351721306000	15461	7785	83	0	\N
122160	1397	1351711305000	15461	7785	84	0	\N
122161	1397	1351701304000	15461	7785	85	0	\N
122162	1397	1351691303000	15461	7785	86	0	\N
122163	1397	1351681302000	15461	7785	87	0	\N
122164	1397	1351671301000	15461	7785	88	0	\N
122165	1397	1351661300000	15461	7785	89	0	\N
122166	1397	1351651299000	15461	7785	90	0	\N
122167	1397	1351641298000	15461	7785	91	0	\N
122168	1397	1351631297000	15461	7785	92	0	\N
122169	1397	1351621296000	15461	7785	93	0	\N
122170	1397	1351611295000	15461	7785	94	0	\N
122171	1397	1351601294000	15461	7785	95	0	\N
122172	1397	1351591293000	15461	7785	96	0	\N
122173	1397	1351581292000	15461	7785	97	0	\N
122174	1397	1351571291000	15461	7785	98	0	\N
122175	1397	1351561290000	15461	7785	99	0	\N
122176	1397	1351551289000	15461	7785	100	0	\N
122177	1397	1351541288000	15461	7785	101	0	\N
122178	1397	1351531287000	15461	7785	102	0	\N
122179	1397	1351521286000	15461	7785	103	0	\N
122180	1397	1351511285000	15461	7785	104	0	\N
122181	1397	1351501284000	15461	7785	105	0	\N
122182	1397	1351491283000	15461	7785	106	0	\N
122183	2058	548500000	15461	7785	107	0	\N
122184	1726	646133664000	15461	7785	108	0	\N
122185	2119	199000000	15461	7785	109	0	\N
122186	1726	646132662000	15461	7785	110	0	\N
122187	1726	646131661000	15461	7785	111	0	\N
122188	1726	646130659000	15461	7785	112	0	\N
122189	1726	646129658000	15461	7785	113	0	\N
122190	1726	646128656000	15461	7785	114	0	\N
122191	1726	646127655000	15461	7785	115	0	\N
122192	1726	646126654000	15461	7785	116	0	\N
122193	1726	646125652000	15461	7785	117	0	\N
122194	1726	646124651000	15461	7785	118	0	\N
122195	1726	646123649000	15461	7785	119	0	\N
122196	1726	646122648000	15461	7785	120	0	\N
122197	1726	646121646000	15461	7785	121	0	\N
122198	1726	646120645000	15461	7785	122	0	\N
122199	1726	646119643000	15461	7785	123	0	\N
122200	1726	646118642000	15461	7785	124	0	\N
122201	1726	646117641000	15461	7785	125	0	\N
122205	1397	1351481282000	15463	7874	0	0	\N
122206	1726	645997467000	15463	7874	1	0	\N
122207	1726	645996466000	15463	7874	2	0	\N
122212	1397	1351451279000	15468	7876	0	0	\N
122223	1397	1351421276000	15473	7879	0	0	\N
122224	1726	645988454000	15473	7879	1	0	\N
122225	1397	1351421276000	15474	7879	0	0	\N
122226	1726	645988454000	15474	7879	1	0	\N
122227	1397	1351421276000	15475	7879	0	0	\N
122228	1726	645988454000	15475	7879	1	0	\N
122229	1397	1351421276000	15476	7879	0	0	\N
122230	1726	645988454000	15476	7879	1	0	\N
122236	1397	1351411275000	15478	7880	0	0	\N
122237	1397	1351401274000	15478	7880	1	0	\N
122238	1726	645987453000	15478	7880	2	0	\N
122239	1726	645986451000	15478	7880	3	0	\N
122240	1726	645985450000	15478	7880	4	0	\N
122241	1397	1351391273000	15479	7881	0	0	\N
122242	1397	1351381272000	15479	7881	1	0	\N
122243	1726	645984449000	15479	7881	2	0	\N
122244	1726	645983447000	15479	7881	3	0	\N
122245	1397	1351391273000	15480	7881	0	0	\N
122246	1397	1351381272000	15480	7881	1	0	\N
122247	1726	645984449000	15480	7881	2	0	\N
122248	1726	645983447000	15480	7881	3	0	\N
122261	1397	1351351269000	15485	7884	0	0	\N
122262	1726	645979441000	15485	7884	1	0	\N
122263	1726	645978440000	15485	7884	2	0	\N
122264	1397	1351351269000	15487	7884	0	0	\N
122204	1726	645996466000	15462	7874	2	0	8068
122208	1397	1351471281000	15467	7875	0	0	8736
122209	1397	1351461280000	15467	7875	1	0	8737
122210	1726	645995464000	15467	7875	2	0	8069
122211	1726	645994463000	15467	7875	3	0	8070
122214	1726	645993462000	15469	7876	1	0	8071
122215	1726	645992460000	15469	7876	2	0	8072
122216	1397	1351441278000	15470	7877	0	0	8739
122217	1726	645991459000	15470	7877	1	0	8073
122218	1397	1351431277000	15471	7878	0	0	8740
122220	1726	645989456000	15471	7878	2	0	8075
122221	1397	1351421276000	15472	7879	0	0	8741
122222	1726	645988454000	15472	7879	1	0	8076
122231	1397	1351411275000	15477	7880	0	0	8742
122233	1726	645987453000	15477	7880	2	0	8077
122234	1726	645986451000	15477	7880	3	0	8078
122235	1726	645985450000	15477	7880	4	0	8079
122249	1397	1351391273000	15481	7881	0	0	8744
122250	1397	1351381272000	15481	7881	1	0	8745
122252	1726	645983447000	15481	7881	3	0	8081
122253	1397	1351371271000	15482	7882	0	0	8746
122254	1726	645982446000	15482	7882	1	0	8082
122255	1726	645981444000	15482	7882	2	0	8083
122256	1397	1351361270000	15483	7883	0	0	8747
122258	1397	1351351269000	15484	7884	0	0	8748
122259	1726	645979441000	15484	7884	1	0	8085
122260	1726	645978440000	15484	7884	2	0	8086
122265	1726	645979441000	15487	7884	1	0	\N
122266	1726	645978440000	15487	7884	2	0	\N
122268	1643	5595899428700	15493	7839	0	0	\N
122269	1643	3670252740700	15493	7839	1	0	\N
122270	1643	2370977296700	15493	7839	2	0	\N
122271	1643	1296388114700	15493	7839	3	0	\N
122284	1397	1351311265000	15496	7887	0	0	\N
122285	1397	1351301264000	15496	7887	1	0	\N
122286	1397	1351291263000	15496	7887	2	0	\N
122287	1726	645973433000	15496	7887	3	0	\N
122288	1726	645972431000	15496	7887	4	0	\N
122289	1726	645971430000	15496	7887	5	0	\N
122290	1397	1351311265000	15497	7887	0	0	\N
122291	1397	1351301264000	15497	7887	1	0	\N
122292	1397	1351291263000	15497	7887	2	0	\N
122293	1726	645973433000	15497	7887	3	0	\N
122294	1726	645972431000	15497	7887	4	0	\N
122295	1726	645971430000	15497	7887	5	0	\N
122296	1397	1351281262000	15499	7888	0	0	\N
122297	1726	645970428000	15499	7888	1	0	\N
122298	1726	645969427000	15499	7888	2	0	\N
122305	1397	1351271261000	15502	7889	0	0	\N
122306	1726	645968425000	15502	7889	1	0	\N
122307	1726	645967424000	15502	7889	2	0	\N
122317	1397	1351221256000	15507	7892	0	0	\N
122318	1726	645961415000	15507	7892	1	0	\N
122319	1397	1351221256000	15508	7892	0	0	\N
122320	1726	645961415000	15508	7892	1	0	\N
122323	1397	1351211255000	15510	7893	0	0	\N
122324	1726	645960414000	15510	7893	1	0	\N
122326	1705	8553674500145	15512	7894	0	0	\N
122327	1397	1351211255000	15512	7894	2	0	\N
122328	1397	1351201254000	15512	7894	3	0	\N
122329	1726	645959413000	15512	7894	4	0	\N
122330	1726	645958411000	15512	7894	5	0	\N
122331	1705	8553674500145	15513	7894	0	0	\N
122332	1397	1351211255000	15513	7894	2	0	\N
122333	1397	1351201254000	15513	7894	3	0	\N
122334	1726	645959413000	15513	7894	4	0	\N
122335	1726	645958411000	15513	7894	5	0	\N
122336	1705	8553674500145	15514	7894	0	0	\N
122337	1397	1351211255000	15514	7894	2	0	\N
122338	1397	1351201254000	15514	7894	3	0	\N
122339	1726	645959413000	15514	7894	4	0	\N
122340	1726	645958411000	15514	7894	5	0	\N
122361	2129	1989000000	15522	7900	0	0	\N
122362	1397	1351131247000	15522	7900	1	0	\N
122363	1397	1351121246000	15522	7900	2	0	\N
122364	1726	645948397000	15522	7900	3	0	\N
122365	1726	645947395000	15522	7900	4	0	\N
122366	1726	645946394000	15522	7900	5	0	\N
122367	2129	1989000000	15523	7900	0	0	\N
122368	1397	1351131247000	15523	7900	1	0	\N
122369	1397	1351121246000	15523	7900	2	0	\N
122370	1726	645948397000	15523	7900	3	0	\N
122371	1726	645947395000	15523	7900	4	0	\N
122372	1726	645946394000	15523	7900	5	0	\N
122381	1397	1351111245000	15526	7901	0	0	\N
122382	1726	645945392000	15526	7901	1	0	\N
122383	1397	1351111245000	15527	7901	0	0	\N
122384	1726	645945392000	15527	7901	1	0	\N
122394	1397	1351091243000	15530	7903	0	0	\N
122395	1397	1351081242000	15530	7903	1	0	\N
122396	1397	1351071241000	15530	7903	2	0	\N
122397	1726	645943389000	15530	7903	3	0	\N
122398	1726	645942388000	15530	7903	4	0	\N
122399	1726	645941387000	15530	7903	5	0	\N
122400	1726	645940385000	15530	7903	6	0	\N
122273	1397	1351321266000	15494	7886	1	0	8751
122274	1726	645977438000	15494	7886	2	0	8087
122275	1726	645976437000	15494	7886	3	0	8088
122276	1726	645975436000	15494	7886	4	0	8089
122277	1726	645974434000	15494	7886	5	0	8090
122279	1397	1351301264000	15495	7887	1	0	8753
122280	1397	1351291263000	15495	7887	2	0	8754
122281	1726	645973433000	15495	7887	3	0	8091
122282	1726	645972431000	15495	7887	4	0	8092
122283	1726	645971430000	15495	7887	5	0	8093
122300	1726	645970428000	15500	7888	1	0	8094
122301	1726	645969427000	15500	7888	2	0	8095
122302	1397	1351271261000	15501	7889	0	0	8756
122303	1726	645968425000	15501	7889	1	0	8096
122308	1397	1351261260000	15503	7890	0	0	8757
122309	1397	1351251259000	15504	7891	0	0	8758
122310	1397	1351241258000	15504	7891	1	0	8759
122311	1397	1351231257000	15504	7891	2	0	8760
122312	1726	645966423000	15504	7891	3	0	8098
122314	1726	645964420000	15504	7891	5	0	8100
122315	1726	645963418000	15504	7891	6	0	8101
122316	1726	645962417000	15504	7891	7	0	8102
122321	1397	1351221256000	15509	7892	0	0	8761
122322	1726	645961415000	15509	7892	1	0	8103
122341	1705	8553674500145	15515	7894	0	0	20
122342	1397	1351211255000	15515	7894	2	0	8762
122343	1726	645959413000	15515	7894	3	0	8105
122344	1726	645958411000	15515	7894	4	0	8106
122346	1397	1351191253000	15516	7895	1	0	8764
122347	1726	645957410000	15516	7895	2	0	8107
122348	1397	1351181252000	15517	7896	0	0	8765
122349	1726	645956408000	15517	7896	1	0	8108
122350	1726	645955407000	15517	7896	2	0	8109
122352	1397	1351171251000	15518	7897	0	0	8766
122353	1726	645953404000	15518	7897	1	0	8111
122354	1397	1351161250000	15519	7898	0	0	8767
122355	1726	645952402000	15519	7898	1	0	8112
122356	1726	645951401000	15519	7898	2	0	8113
122358	1397	1351141248000	15521	7899	1	0	8769
122359	1726	645950400000	15521	7899	2	0	8114
122360	1726	645949398000	15521	7899	3	0	8115
122373	2129	1989000000	15524	7900	0	0	1
122375	1397	1351121246000	15524	7900	2	0	8771
122376	1726	645948397000	15524	7900	3	0	8116
122377	1726	645947395000	15524	7900	4	0	8117
122378	1726	645946394000	15524	7900	5	0	8118
122379	1397	1351111245000	15525	7901	0	0	8772
122385	1397	1351101244000	15528	7902	0	0	8773
122386	1726	645944391000	15528	7902	1	0	8120
122387	1397	1351091243000	15529	7903	0	0	8774
122388	1397	1351081242000	15529	7903	1	0	8775
122389	1397	1351071241000	15529	7903	2	0	8776
122391	1726	645942388000	15529	7903	4	0	8122
122392	1726	645941387000	15529	7903	5	0	8123
122393	1726	645940385000	15529	7903	6	0	8124
122404	1397	1351061240000	15532	7904	0	0	\N
122405	1726	645939384000	15532	7904	1	0	\N
122406	1726	645938382000	15532	7904	2	0	\N
122407	1397	1351051239000	15534	7905	0	0	\N
122408	1397	1351041238000	15534	7905	1	0	\N
122409	1726	645937381000	15534	7905	2	0	\N
122410	1726	645936379000	15534	7905	3	0	\N
122411	1726	645935378000	15534	7905	4	0	\N
122433	1397	1350961230000	15541	7911	0	0	\N
122434	1397	1350951229000	15541	7911	1	0	\N
122435	1726	645925364000	15541	7911	2	0	\N
122436	1726	645924362000	15541	7911	3	0	\N
122437	1397	1350961230000	15542	7911	0	0	\N
122438	1397	1350951229000	15542	7911	1	0	\N
122439	1726	645925364000	15542	7911	2	0	\N
122440	1726	645924362000	15542	7911	3	0	\N
122445	1397	1350961230000	15544	7911	0	0	\N
122446	1397	1350951229000	15544	7911	1	0	\N
122447	1726	645925364000	15544	7911	2	0	\N
122448	1726	645924362000	15544	7911	3	0	\N
122466	1397	1350891223000	15548	7914	0	0	\N
122467	1397	1350881222000	15548	7914	1	0	\N
122468	1726	645916351000	15548	7914	2	0	\N
122469	1726	645915349000	15548	7914	3	0	\N
122470	1726	645914348000	15548	7914	4	0	\N
122473	1397	1350871221000	15550	7915	0	0	\N
122474	1726	645913346000	15550	7915	1	0	\N
122484	1397	1350831217000	15553	7917	0	0	\N
122490	1397	1350821216000	15555	7918	0	0	\N
122491	1397	1350811215000	15555	7918	1	0	\N
122492	1726	645907338000	15555	7918	2	0	\N
122493	1726	645906336000	15555	7918	3	0	\N
122494	1726	645905335000	15555	7918	4	0	\N
122495	1397	1350801214000	15556	7919	0	0	\N
122496	1397	1350791213000	15556	7919	1	0	\N
122497	1726	645904333000	15556	7919	2	0	\N
122498	1726	644694333000	15556	7919	3	0	\N
122499	1726	643484333000	15556	7919	4	0	\N
122500	1726	643483331000	15556	7919	5	0	\N
122501	1397	1350801214000	15557	7919	0	0	\N
122502	1397	1350791213000	15557	7919	1	0	\N
122503	1726	645904333000	15557	7919	2	0	\N
122504	1726	644694333000	15557	7919	3	0	\N
122505	1726	643484333000	15557	7919	4	0	\N
122506	1726	643483331000	15557	7919	5	0	\N
122513	1705	8553674500145	15559	7843	0	0	\N
122514	1397	1351911325000	15559	7843	1	0	\N
122515	1397	1351901324000	15559	7843	2	0	\N
122516	1397	1351891323000	15559	7843	3	0	\N
122517	1397	1351881322000	15559	7843	4	0	\N
122518	1397	1351871321000	15559	7843	5	0	\N
122519	1397	1351861320000	15559	7843	6	0	\N
122520	1397	1351851319000	15559	7843	7	0	\N
122521	1397	1351841318000	15559	7843	8	0	\N
122522	1643	4875888428700	15559	7843	9	0	\N
122523	1643	2950241740700	15559	7843	10	0	\N
122524	1643	1650966296700	15559	7843	11	0	\N
122525	1643	576377114700	15559	7843	12	0	\N
122526	1397	1351831317000	15559	7843	13	0	\N
122527	1397	1351821316000	15559	7843	14	0	\N
122528	1397	1351811315000	15559	7843	15	0	\N
122529	1397	1351801314000	15559	7843	17	0	\N
122530	1397	1351791313000	15559	7843	18	0	\N
122531	1397	1351781312000	15559	7843	19	0	\N
122532	1397	1351771311000	15559	7843	20	0	\N
122533	1397	1351761310000	15559	7843	21	0	\N
122534	1397	1351751309000	15559	7843	22	0	\N
122535	1397	1351741308000	15559	7843	23	0	\N
122536	1397	1351731307000	15559	7843	24	0	\N
122403	1726	645938382000	15531	7904	2	0	8126
122412	1397	1351051239000	15536	7906	0	0	8778
122413	1397	1351041238000	15536	7906	1	0	8779
122414	1397	1351031237000	15536	7906	2	0	8780
122415	1726	645937381000	15536	7906	3	0	8127
122417	1726	645935378000	15536	7906	5	0	8129
122418	1397	1351021236000	15537	7907	0	0	8781
122419	1397	1351011235000	15537	7907	1	0	8782
122420	1726	645934376000	15537	7907	2	0	8130
122421	1726	645933375000	15537	7907	3	0	8131
122423	1726	645931372000	15537	7907	5	0	8133
122424	1397	1351001234000	15538	7908	0	0	8783
122425	1726	645930371000	15538	7908	1	0	8134
122426	1397	1350991233000	15539	7909	0	0	8784
122428	1726	645929369000	15539	7909	2	0	8135
122429	1726	645928368000	15539	7909	3	0	8136
122430	1397	1350971231000	15540	7910	0	0	8786
122431	1726	645927366000	15540	7910	1	0	8137
122432	1726	645926365000	15540	7910	2	0	8138
122442	1397	1350951229000	15543	7911	1	0	8788
122443	1726	645925364000	15543	7911	2	0	8139
122444	1726	645924362000	15543	7911	3	0	8140
122449	1397	1350941228000	15545	7912	0	0	8789
122450	1726	645923361000	15545	7912	1	0	8141
122452	1397	1350931227000	15546	7913	0	0	8790
122453	1397	1350921226000	15546	7913	1	0	8791
122454	1397	1350911225000	15546	7913	2	0	8792
122455	1397	1350901224000	15546	7913	3	0	8793
122457	1726	645920356000	15546	7913	5	0	8144
122458	1726	645919355000	15546	7913	6	0	8145
122459	1726	645918353000	15546	7913	7	0	8146
122460	1726	645917352000	15546	7913	8	0	8147
122461	1397	1350891223000	15547	7914	0	0	8794
122463	1726	645916351000	15547	7914	2	0	8148
122464	1726	645915349000	15547	7914	3	0	8149
122465	1726	645914348000	15547	7914	4	0	8150
122471	1397	1350871221000	15549	7915	0	0	8796
122472	1726	645913346000	15549	7915	1	0	8151
122476	1397	1350851219000	15551	7916	2	0	8798
122477	1397	1350841218000	15551	7916	3	0	8799
122478	1726	645912345000	15551	7916	4	0	8152
122479	1726	645911343000	15551	7916	5	0	8153
122481	1726	645909340000	15551	7916	7	0	8155
122482	1726	645908339000	15551	7916	8	0	8156
122483	1397	1350831217000	15552	7917	0	0	8800
122485	1397	1350821216000	15554	7918	0	0	8801
122486	1397	1350811215000	15554	7918	1	0	8802
122488	1726	645906336000	15554	7918	3	0	8158
122489	1726	645905335000	15554	7918	4	0	8159
122507	1397	1350801214000	15558	7919	0	0	8803
122508	1397	1350791213000	15558	7919	1	0	8804
122509	1726	645904333000	15558	7919	2	0	8160
122511	1726	643484333000	15558	7919	4	0	8162
122512	1726	643483331000	15558	7919	5	0	8163
122537	1397	1351721306000	15559	7843	25	0	\N
122538	1397	1351711305000	15559	7843	26	0	\N
122539	1397	1351701304000	15559	7843	27	0	\N
122540	1397	1351691303000	15559	7843	28	0	\N
122541	1397	1351681302000	15559	7843	29	0	\N
122542	1397	1351671301000	15559	7843	30	0	\N
122543	1397	1351661300000	15559	7843	31	0	\N
122544	1397	1351651299000	15559	7843	32	0	\N
122545	1397	1351641298000	15559	7843	33	0	\N
122546	1397	1351631297000	15559	7843	34	0	\N
122547	1397	1351621296000	15559	7843	35	0	\N
122548	1397	1351611295000	15559	7843	36	0	\N
122549	1397	1351601294000	15559	7843	37	0	\N
122550	1397	1351591293000	15559	7843	38	0	\N
122551	1397	1351581292000	15559	7843	39	0	\N
122552	1397	1351571291000	15559	7843	40	0	\N
122553	1397	1351561290000	15559	7843	41	0	\N
122554	1397	1351551289000	15559	7843	42	0	\N
122555	1397	1351541288000	15559	7843	43	0	\N
122556	1397	1351531287000	15559	7843	44	0	\N
122557	1397	1351521286000	15559	7843	45	0	\N
122558	1397	1351511285000	15559	7843	46	0	\N
122559	1397	1351501284000	15559	7843	47	0	\N
122560	1397	1351491283000	15559	7843	48	0	\N
122561	1397	1351481282000	15559	7843	49	0	\N
122562	1397	1351471281000	15559	7843	50	0	\N
122563	1397	1351461280000	15559	7843	51	0	\N
122564	1397	1351451279000	15559	7843	52	0	\N
122565	1397	1351441278000	15559	7843	53	0	\N
122566	1397	1351431277000	15559	7843	54	0	\N
122567	1397	1351421276000	15559	7843	55	0	\N
122568	1397	1351411275000	15559	7843	56	0	\N
122569	1397	1351401274000	15559	7843	57	0	\N
122570	1397	1351391273000	15559	7843	58	0	\N
122571	1397	1351381272000	15559	7843	59	0	\N
122572	1397	1351371271000	15559	7843	60	0	\N
122573	1397	1351361270000	15559	7843	61	0	\N
122574	1397	1351351269000	15559	7843	62	0	\N
122575	1397	1351341268000	15559	7843	63	0	\N
122576	1397	1351331267000	15559	7843	64	0	\N
122577	1397	1351321266000	15559	7843	65	0	\N
122578	1397	1351311265000	15559	7843	66	0	\N
122579	1397	1351301264000	15559	7843	67	0	\N
122580	1397	1351291263000	15559	7843	68	0	\N
122581	1397	1351281262000	15559	7843	69	0	\N
122582	1397	1351271261000	15559	7843	70	0	\N
122583	1397	1351261260000	15559	7843	71	0	\N
122584	1397	1351251259000	15559	7843	72	0	\N
122585	1397	1351241258000	15559	7843	73	0	\N
122586	1397	1351231257000	15559	7843	74	0	\N
122587	1397	1351221256000	15559	7843	75	0	\N
122588	1397	1351211255000	15559	7843	76	0	\N
122589	1397	1351201254000	15559	7843	77	0	\N
122590	1397	1351191253000	15559	7843	78	0	\N
122591	1397	1351181252000	15559	7843	79	0	\N
122592	1397	1351171251000	15559	7843	80	0	\N
122593	1397	1351161250000	15559	7843	81	0	\N
122594	1397	1351151249000	15559	7843	82	0	\N
122595	1397	1351141248000	15559	7843	83	0	\N
122596	1397	1351131247000	15559	7843	84	0	\N
122597	1397	1351121246000	15559	7843	85	0	\N
122598	1397	1351111245000	15559	7843	86	0	\N
122599	1397	1351101244000	15559	7843	87	0	\N
122600	1397	1351091243000	15559	7843	88	0	\N
122601	1397	1351081242000	15559	7843	89	0	\N
122602	1397	1351071241000	15559	7843	90	0	\N
122603	1397	1351061240000	15559	7843	91	0	\N
122604	1397	1351051239000	15559	7843	92	0	\N
122605	1397	1351041238000	15559	7843	93	0	\N
122606	1397	1351031237000	15559	7843	94	0	\N
122607	1397	1351021236000	15559	7843	95	0	\N
122608	1397	1351011235000	15559	7843	96	0	\N
122609	1397	1351001234000	15559	7843	97	0	\N
122610	1397	1350991233000	15559	7843	98	0	\N
122611	1397	1350981232000	15559	7843	99	0	\N
122612	1397	1350971231000	15559	7843	100	0	\N
122613	1397	1350961230000	15559	7843	101	0	\N
122614	1397	1350951229000	15559	7843	102	0	\N
122615	1397	1350941228000	15559	7843	103	0	\N
122616	1397	1350931227000	15559	7843	104	0	\N
122617	1397	1350921226000	15559	7843	105	0	\N
122618	1397	1350911225000	15559	7843	106	0	\N
122619	1397	1350901224000	15559	7843	107	0	\N
122620	1397	1350891223000	15559	7843	108	0	\N
122621	1397	1350881222000	15559	7843	109	0	\N
122622	1397	1350871221000	15559	7843	110	0	\N
122623	1397	1350861220000	15559	7843	111	0	\N
122624	1397	1350851219000	15559	7843	112	0	\N
122625	1397	1350841218000	15559	7843	113	0	\N
122626	1397	1350831217000	15559	7843	114	0	\N
122627	1397	1350821216000	15559	7843	115	0	\N
122628	1397	1350811215000	15559	7843	116	0	\N
122629	1397	1350801214000	15559	7843	117	0	\N
122630	1397	1350791213000	15559	7843	118	0	\N
122631	1397	1350781212000	15559	7843	119	0	\N
122632	1397	1350771211000	15559	7843	120	0	\N
122633	1397	1350761210000	15559	7843	121	0	\N
122634	1726	646054550000	15559	7843	122	0	\N
122635	1726	646053548000	15559	7843	123	0	\N
122636	1726	646052547000	15559	7843	124	0	\N
122637	1726	646051545000	15559	7843	125	0	\N
122638	1397	1350781212000	15560	7920	0	0	\N
122639	1397	1350771211000	15560	7920	1	0	\N
122640	1397	1350761210000	15560	7920	2	0	\N
122641	1397	1350751209000	15560	7920	3	0	\N
122642	1726	642273331000	15560	7920	4	0	\N
122643	1726	641063331000	15560	7920	5	0	\N
122650	1397	1350741208000	15563	7921	0	0	\N
122651	1397	1350741208000	15564	7921	0	0	\N
122657	1397	1350691203000	15568	7924	0	0	\N
122658	1397	1350681202000	15568	7924	1	0	\N
122659	1397	1350671201000	15568	7924	2	0	\N
122668	1397	1350631197000	15573	7928	0	0	\N
122669	1397	1350631197000	15574	7928	0	0	\N
122670	1397	1350631197000	15575	7928	0	0	\N
122646	1397	1350761210000	15561	7920	2	0	8807
122647	1397	1350751209000	15561	7920	3	0	8808
122648	1726	642273331000	15561	7920	4	0	8164
122649	1726	641063331000	15561	7920	5	0	8165
122652	1397	1350741208000	15565	7921	0	0	8809
122654	1397	1350721206000	15566	7922	1	0	8811
122655	1397	1350711205000	15567	7923	0	0	8812
122656	1397	1350701204000	15567	7923	1	0	8813
122660	1397	1350691203000	15569	7924	0	0	8814
122661	1397	1350681202000	15569	7924	1	0	8815
122663	1397	1350661200000	15570	7925	0	0	8817
122664	1397	1350651199000	15571	7926	0	0	8818
122665	1874	481000	15571	7926	1	0	2
122666	1726	491068109000	15572	7927	0	0	8166
122671	1397	1350631197000	15576	7928	0	0	8820
122672	1397	1350621196000	15577	7929	0	0	8821
122676	1397	1350611195000	15579	7930	0	0	\N
122677	1397	1350601194000	15579	7930	1	0	\N
122678	1726	341067109000	15579	7930	2	0	\N
122687	1397	1350541188000	15582	7932	0	0	\N
122688	1397	1350541188000	15583	7932	0	0	\N
122689	1397	1350531187000	15584	7933	0	0	\N
122690	2133	98998998000	15584	7933	1	0	\N
122697	1397	1350521186000	15587	7934	0	0	\N
122698	1397	1350511185000	15587	7934	1	0	\N
122699	2133	98997996000	15587	7934	2	0	\N
122700	2133	98996994000	15587	7934	3	0	\N
122703	1397	1350491183000	15589	7936	0	0	\N
122704	1397	1350481182000	15589	7936	1	0	\N
122705	1397	1350471181000	15589	7936	2	0	\N
122706	2133	98994990000	15589	7936	3	0	\N
122707	2133	98993988000	15589	7936	4	0	\N
122708	2133	98992986000	15589	7936	5	0	\N
122709	1397	1350491183000	15590	7936	0	0	\N
122710	1397	1350481182000	15590	7936	1	0	\N
122711	1397	1350471181000	15590	7936	2	0	\N
122712	2133	98994990000	15590	7936	3	0	\N
122713	2133	98993988000	15590	7936	4	0	\N
122714	2133	98992986000	15590	7936	5	0	\N
122725	2133	98989980000	15593	7938	0	0	\N
122726	2133	98988978000	15593	7938	1	0	\N
122727	2133	98989980000	15594	7938	0	0	\N
122728	2133	98988978000	15594	7938	1	0	\N
122729	2133	98989980000	15595	7938	0	0	\N
122730	2133	98988978000	15595	7938	1	0	\N
122739	1397	1350431177000	15600	7941	0	0	\N
122740	2133	98984970000	15600	7941	2	0	\N
122741	1397	1350421176000	15601	7942	0	0	\N
122742	2133	98983968000	15601	7942	1	0	\N
122745	1397	1350411175000	15603	7943	0	0	\N
122746	2133	98982966000	15603	7943	1	0	\N
122751	1397	1350401174000	15606	7944	0	0	\N
122752	2133	98981964000	15606	7944	1	0	\N
122753	1397	1350401174000	15607	7944	0	0	\N
122754	2133	98981964000	15607	7944	1	0	\N
122762	1397	1350361170000	15609	7946	0	0	\N
122763	2132	148997998000	15609	7946	1	0	\N
122764	2133	98977956000	15609	7946	2	0	\N
122768	1397	1350361170000	15611	7946	0	0	\N
122769	2132	148997998000	15611	7946	1	0	\N
122770	2133	98977956000	15611	7946	2	0	\N
122771	1397	1350361170000	15612	7946	0	0	\N
122772	2132	148997998000	15612	7946	1	0	\N
122773	2133	98977956000	15612	7946	2	0	\N
122776	1397	1350341168000	15614	7948	0	0	\N
122777	2133	98975952000	15614	7948	1	0	\N
122787	1397	1350321166000	15618	7950	0	0	\N
122788	1397	1350311165000	15618	7950	1	0	\N
122789	2133	98973948000	15618	7950	2	0	\N
122790	2133	98972946000	15618	7950	3	0	\N
122791	2132	148996997000	15618	7950	4	0	\N
122792	1397	1350301164000	15619	7951	0	0	\N
122793	2133	98971944000	15619	7951	1	0	\N
122796	1397	1350291163000	15621	7952	0	0	\N
122797	2134	98998997000	15621	7952	1	0	\N
122798	2132	148995996000	15621	7952	2	0	\N
122799	2133	98970942000	15621	7952	3	0	\N
122675	1726	341067109000	15578	7930	2	0	8167
122679	1397	1350591193000	15580	7931	0	0	8824
122680	1397	1350581192000	15580	7931	1	0	8825
122681	1397	1350571191000	15580	7931	2	0	8826
122682	1397	1350561190000	15580	7931	3	0	8827
122684	1726	241066109000	15580	7931	5	0	8168
122685	1726	141065109000	15580	7931	6	0	8169
122686	1397	1350541188000	15581	7932	0	0	8829
122691	1397	1350531187000	15585	7933	0	0	8830
122692	2133	98998998000	15585	7933	1	0	1
122694	1397	1350511185000	15586	7934	1	0	8832
122695	2133	98997996000	15586	7934	2	0	2
122696	2133	98996994000	15586	7934	3	0	3
122701	1397	1350501184000	15588	7935	0	0	8833
122715	1397	1350491183000	15591	7936	0	0	8834
122716	1397	1350481182000	15591	7936	1	0	8835
122717	1397	1350471181000	15591	7936	2	0	8836
122718	2133	98994990000	15591	7936	3	0	5
122719	2133	98993988000	15591	7936	4	0	6
122721	1397	1350461180000	15592	7937	0	0	8837
122722	1397	1350451179000	15592	7937	1	0	8838
122723	2133	98991984000	15592	7937	2	0	8
122724	2133	98990982000	15592	7937	3	0	9
122731	2133	98989980000	15596	7938	0	0	10
122733	2133	98987976000	15597	7939	0	0	12
122734	2133	98986974000	15597	7939	1	0	13
122735	1397	1350441178000	15598	7940	0	0	8839
122736	2133	98985972000	15598	7940	1	0	14
122738	2133	98984970000	15599	7941	2	0	15
122743	1397	1350421176000	15602	7942	0	0	8841
122744	2133	98983968000	15602	7942	1	0	16
122747	1397	1350411175000	15604	7943	0	0	8842
122748	2133	98982966000	15604	7943	1	0	17
122750	2133	98981964000	15605	7944	1	0	18
122755	1397	1350391173000	15608	7945	0	0	8844
122756	1397	1350381172000	15608	7945	1	0	8845
122757	1397	1350371171000	15608	7945	2	0	8846
122758	2132	148998999000	15608	7945	3	0	1
122760	2133	98979960000	15608	7945	5	0	20
122761	2133	98978958000	15608	7945	6	0	21
122765	1397	1350361170000	15610	7946	0	0	8847
122766	2132	148997998000	15610	7946	1	0	2
122774	1397	1350351169000	15613	7947	0	0	8848
122775	2133	98976954000	15613	7947	1	0	23
122778	1397	1350341168000	15615	7948	0	0	8849
122779	2133	98975952000	15615	7948	1	0	24
122780	1397	1350331167000	15616	7949	0	0	8850
122782	1397	1350321166000	15617	7950	0	0	8851
122783	1397	1350311165000	15617	7950	1	0	8852
122784	2133	98973948000	15617	7950	2	0	26
122785	2133	98972946000	15617	7950	3	0	27
122786	2132	148996997000	15617	7950	4	0	3
122795	2133	98971944000	15620	7951	1	0	28
122800	1397	1350291163000	15622	7952	0	0	8854
122801	2134	98998997000	15622	7952	1	0	1
122802	2132	148995996000	15622	7952	2	0	4
122804	1397	1350281162000	15623	7953	0	0	8855
122805	1397	1350271161000	15623	7953	1	0	8856
122806	2133	98969940000	15623	7953	2	0	30
122807	2134	98997994000	15623	7953	3	0	2
122808	2134	98996991000	15623	7953	4	0	3
122810	1397	1350261160000	15624	7954	0	0	\N
122811	2132	148994995000	15624	7954	1	0	\N
122812	2134	98995988000	15624	7954	2	0	\N
122813	2133	98967936000	15624	7954	3	0	\N
122824	1397	1350241158000	15629	7956	0	0	\N
122825	2133	98965932000	15629	7956	1	0	\N
122826	2134	98993982000	15629	7956	2	0	\N
122827	1397	1350231157000	15630	7957	0	0	\N
122828	2133	98964930000	15630	7957	1	0	\N
122829	2134	98992979000	15630	7957	2	0	\N
122830	1397	1350231157000	15631	7957	0	0	\N
122831	2133	98964930000	15631	7957	1	0	\N
122832	2134	98992979000	15631	7957	2	0	\N
122833	1397	1350231157000	15632	7957	0	0	\N
122834	2133	98964930000	15632	7957	1	0	\N
122835	2134	98992979000	15632	7957	2	0	\N
122839	1397	1350221156000	15634	7958	0	0	\N
122840	2133	98963928000	15634	7958	1	0	\N
122841	2134	98991976000	15634	7958	2	0	\N
122842	2132	148993994000	15634	7958	3	0	\N
122847	1397	1350221156000	15636	7958	0	0	\N
122848	2133	98963928000	15636	7958	1	0	\N
122849	2134	98991976000	15636	7958	2	0	\N
122850	2132	148993994000	15636	7958	3	0	\N
122851	1397	1350221156000	15637	7958	0	0	\N
122852	2133	98963928000	15637	7958	1	0	\N
122853	2134	98991976000	15637	7958	2	0	\N
122854	2132	148993994000	15637	7958	3	0	\N
122855	1397	1350221156000	15638	7958	0	0	\N
122856	2133	98963928000	15638	7958	1	0	\N
122857	2134	98991976000	15638	7958	2	0	\N
122858	2132	148993994000	15638	7958	3	0	\N
122859	1397	1350281162000	15639	7953	0	0	\N
122860	1397	1350271161000	15639	7953	1	0	\N
122861	1397	1350261160000	15639	7953	2	0	\N
122862	1397	1350251159000	15639	7953	3	0	\N
122863	1397	1350241158000	15639	7953	4	0	\N
122864	2133	98969940000	15639	7953	5	0	\N
122865	2132	148994995000	15639	7953	6	0	\N
122866	2134	98997994000	15639	7953	7	0	\N
122867	2134	98996991000	15639	7953	8	0	\N
122868	2134	98995988000	15639	7953	9	0	\N
122869	2134	98994985000	15639	7953	10	0	\N
122870	2134	98993982000	15639	7953	11	0	\N
122871	2134	98992979000	15639	7953	12	0	\N
122872	2133	98968938000	15639	7953	13	0	\N
122873	2133	98967936000	15639	7953	14	0	\N
122874	2133	98966934000	15639	7953	15	0	\N
122875	2133	98965932000	15639	7953	16	0	\N
122876	1397	1350211155000	15640	7959	0	0	\N
122877	2133	98962926000	15640	7959	1	0	\N
122878	2134	98990973000	15640	7959	2	0	\N
122884	1397	1350201154000	15643	7960	0	0	\N
122885	2134	98989970000	15643	7960	1	0	\N
122886	1397	1350191153000	15644	7961	0	0	\N
122887	2134	98988967000	15644	7961	1	0	\N
122888	2132	148992993000	15644	7961	2	0	\N
122889	2133	98961924000	15644	7961	3	0	\N
122890	1397	1350191153000	15645	7961	0	0	\N
122891	2134	98988967000	15645	7961	1	0	\N
122892	2132	148992993000	15645	7961	2	0	\N
122893	2133	98961924000	15645	7961	3	0	\N
122904	1397	1350161150000	15648	7963	0	0	\N
122905	2134	98985958000	15648	7963	1	0	\N
122906	2132	148991992000	15648	7963	2	0	\N
122907	2133	98958918000	15648	7963	3	0	\N
122918	1397	1350131147000	15651	7965	0	0	\N
122919	2134	98982949000	15651	7965	1	0	\N
122920	2133	98955912000	15651	7965	2	0	\N
122924	1397	1350131147000	15653	7965	0	0	\N
122925	2134	98982949000	15653	7965	1	0	\N
122926	2133	98955912000	15653	7965	2	0	\N
122934	1397	1350111145000	15656	7967	0	0	\N
122935	2133	98953908000	15656	7967	1	0	\N
122936	2134	98980943000	15656	7967	2	0	\N
122944	1397	1350101144000	15658	7968	0	0	\N
122815	2132	148994995000	15625	7954	1	0	5
122816	2134	98995988000	15625	7954	2	0	4
122817	2133	98967936000	15625	7954	3	0	32
122818	1397	1350251159000	15626	7955	0	0	8858
122819	2134	98994985000	15626	7955	1	0	5
122821	1397	1350241158000	15628	7956	0	0	8859
122822	2133	98965932000	15628	7956	1	0	34
122823	2134	98993982000	15628	7956	2	0	6
122836	1397	1350231157000	15633	7957	0	0	8860
122837	2133	98964930000	15633	7957	1	0	35
122843	1397	1350221156000	15635	7958	0	0	8861
122844	2133	98963928000	15635	7958	1	0	36
122845	2134	98991976000	15635	7958	2	0	8
122846	2132	148993994000	15635	7958	3	0	6
122880	2133	98962926000	15641	7959	1	0	37
122881	2134	98990973000	15641	7959	2	0	9
122882	1397	1350201154000	15642	7960	0	0	8863
122883	2134	98989970000	15642	7960	1	0	10
122894	1397	1350191153000	15646	7961	0	0	8864
122896	2132	148992993000	15646	7961	2	0	7
122897	2133	98961924000	15646	7961	3	0	38
122898	1397	1350181152000	15647	7962	0	0	8865
122899	1397	1350171151000	15647	7962	1	0	8866
122900	2134	98987964000	15647	7962	2	0	12
122902	2133	98960922000	15647	7962	4	0	39
122903	2133	98959920000	15647	7962	5	0	40
122908	1397	1350161150000	15649	7963	0	0	8867
122909	2134	98985958000	15649	7963	1	0	14
122911	2133	98958918000	15649	7963	3	0	41
122912	1397	1350151149000	15650	7964	0	0	8868
122913	1397	1350141148000	15650	7964	1	0	8869
122914	2133	98957916000	15650	7964	2	0	42
122915	2134	98984955000	15650	7964	3	0	15
122917	2133	98956914000	15650	7964	6	0	43
122921	1397	1350131147000	15652	7965	0	0	8870
122922	2134	98982949000	15652	7965	1	0	17
122923	2133	98955912000	15652	7965	2	0	44
122927	1397	1350121146000	15654	7966	0	0	8871
122929	2132	148990991000	15654	7966	2	0	9
122930	2134	98981946000	15654	7966	3	0	18
122931	1397	1350111145000	15655	7967	0	0	8872
122932	2133	98953908000	15655	7967	1	0	46
122937	1397	1350101144000	15657	7968	0	0	8873
122938	1397	1350091143000	15657	7968	1	0	8874
122939	2134	98979940000	15657	7968	2	0	20
122940	2134	98978937000	15657	7968	3	0	21
122941	2133	98952906000	15657	7968	4	0	47
122943	2132	148989990000	15657	7968	6	0	10
122945	1397	1350091143000	15658	7968	1	0	\N
122946	2134	98979940000	15658	7968	2	0	\N
122947	2134	98978937000	15658	7968	3	0	\N
122948	2133	98952906000	15658	7968	4	0	\N
122949	2133	98951904000	15658	7968	5	0	\N
122950	2132	148989990000	15658	7968	6	0	\N
122974	1397	1350011135000	15665	7975	0	0	\N
122975	1397	1350001134000	15665	7975	1	0	\N
122976	2134	98970913000	15665	7975	2	0	\N
122977	2134	98969910000	15665	7975	3	0	\N
122978	2133	98943888000	15665	7975	4	0	\N
122979	2133	98942886000	15665	7975	5	0	\N
122980	1397	1350011135000	15666	7975	0	0	\N
122981	1397	1350001134000	15666	7975	1	0	\N
122982	2134	98970913000	15666	7975	2	0	\N
122983	2134	98969910000	15666	7975	3	0	\N
122984	2133	98943888000	15666	7975	4	0	\N
122985	2133	98942886000	15666	7975	5	0	\N
122986	1397	1350011135000	15667	7975	0	0	\N
122987	1397	1350001134000	15667	7975	1	0	\N
122988	2134	98970913000	15667	7975	2	0	\N
122989	2134	98969910000	15667	7975	3	0	\N
122990	2133	98943888000	15667	7975	4	0	\N
122991	2133	98942886000	15667	7975	5	0	\N
122998	1397	1350021136000	15669	7974	0	0	\N
122999	2132	148987988000	15669	7974	1	0	\N
123000	2133	98944890000	15669	7974	2	0	\N
123001	2134	98971916000	15669	7974	3	0	\N
123002	1397	1350011135000	15670	7975	0	0	\N
123003	1397	1350001134000	15670	7975	1	0	\N
123004	2134	98970913000	15670	7975	2	0	\N
123005	2134	98969910000	15670	7975	3	0	\N
123006	2133	98943888000	15670	7975	4	0	\N
123007	2133	98942886000	15670	7975	5	0	\N
123015	1397	1349991133000	15672	7976	0	0	\N
123016	1397	1349981132000	15672	7976	1	0	\N
123017	2133	98941884000	15672	7976	2	0	\N
123018	2134	98968907000	15672	7976	3	0	\N
123019	2134	98967904000	15672	7976	4	0	\N
123020	2133	98940882000	15672	7976	5	0	\N
123021	2132	148986987000	15672	7976	6	0	\N
123022	1397	1349991133000	15673	7976	0	0	\N
123023	1397	1349981132000	15673	7976	1	0	\N
123024	2133	98941884000	15673	7976	2	0	\N
123025	2134	98968907000	15673	7976	3	0	\N
123026	2134	98967904000	15673	7976	4	0	\N
123027	2133	98940882000	15673	7976	5	0	\N
123028	2132	148986987000	15673	7976	6	0	\N
123029	1397	1349971131000	15674	7977	0	0	\N
123030	2133	98939880000	15674	7977	1	0	\N
123031	2134	98966901000	15674	7977	2	0	\N
123035	1397	1349961130000	15676	7978	0	0	\N
123036	2132	148985986000	15676	7978	1	0	\N
123037	2133	98938878000	15676	7978	2	0	\N
123038	2134	98965898000	15676	7978	3	0	\N
123043	1397	1349961130000	15678	7978	0	0	\N
123044	2132	148985986000	15678	7978	1	0	\N
123045	2133	98938878000	15678	7978	2	0	\N
123046	2134	98965898000	15678	7978	3	0	\N
123047	1397	1349961130000	15679	7978	0	0	\N
123048	2132	148985986000	15679	7978	1	0	\N
123049	2133	98938878000	15679	7978	2	0	\N
123050	2134	98965898000	15679	7978	3	0	\N
123051	1397	1349961130000	15680	7978	0	0	\N
123052	2132	148985986000	15680	7978	1	0	\N
123053	2133	98938878000	15680	7978	2	0	\N
123054	2134	98965898000	15680	7978	3	0	\N
123055	1397	1349951129000	15681	7979	0	0	\N
123056	2133	98937876000	15681	7979	1	0	\N
123057	2134	98964895000	15681	7979	2	0	\N
123061	1397	1349941128000	15683	7980	0	0	\N
123062	2134	98963892000	15683	7980	1	0	\N
123063	2133	98936874000	15683	7980	2	0	\N
123064	1397	1349941128000	15684	7980	0	0	\N
123065	2134	98963892000	15684	7980	1	0	\N
123066	1397	1349941128000	15685	7980	0	0	\N
123067	2134	98963892000	15685	7980	1	0	\N
123068	2133	98936874000	15685	7980	2	0	\N
123069	1397	1349941128000	15686	7980	0	0	\N
123070	2134	98963892000	15686	7980	1	0	\N
123071	2133	98936874000	15686	7980	2	0	\N
123075	1397	1349941128000	15688	7980	0	0	\N
123076	2134	98963892000	15688	7980	1	0	\N
123077	2133	98936874000	15688	7980	2	0	\N
123078	1397	1349931127000	15689	7981	0	0	\N
123079	1397	1349921126000	15689	7981	1	0	\N
123080	2134	98962889000	15689	7981	2	0	\N
122953	2133	98950902000	15659	7969	2	0	49
122954	1397	1350071141000	15660	7970	0	0	8876
122955	2133	98949900000	15660	7970	1	0	50
122956	2134	98976931000	15660	7970	2	0	23
122957	1397	1350061140000	15661	7971	0	0	8877
122959	2132	148988989000	15661	7971	2	0	11
122960	2133	98948898000	15661	7971	3	0	51
122961	1397	1350051139000	15662	7972	0	0	8878
122962	1397	1350041138000	15662	7972	1	0	8879
122963	2133	98947896000	15662	7972	2	0	52
122965	2134	98973922000	15662	7972	4	0	26
122966	2133	98946894000	15662	7972	5	0	53
122967	1397	1350031137000	15663	7973	0	0	8880
122968	2133	98945892000	15663	7973	1	0	54
122970	1397	1350021136000	15664	7974	0	0	8881
122971	2132	148987988000	15664	7974	1	0	12
122972	2133	98944890000	15664	7974	2	0	55
122973	2134	98971916000	15664	7974	3	0	28
122992	1397	1350011135000	15668	7975	0	0	8882
122994	2134	98970913000	15668	7975	2	0	29
122995	2134	98969910000	15668	7975	3	0	30
122996	2133	98943888000	15668	7975	4	0	56
122997	2133	98942886000	15668	7975	5	0	57
123008	1397	1349991133000	15671	7976	0	0	8884
123010	2133	98941884000	15671	7976	2	0	58
123011	2134	98968907000	15671	7976	3	0	31
123012	2134	98967904000	15671	7976	4	0	32
123013	2133	98940882000	15671	7976	5	0	59
123032	1397	1349971131000	15675	7977	0	0	8886
123033	2133	98939880000	15675	7977	1	0	60
123034	2134	98966901000	15675	7977	2	0	33
123039	1397	1349961130000	15677	7978	0	0	8887
123040	2132	148985986000	15677	7978	1	0	14
123042	2134	98965898000	15677	7978	3	0	34
123058	1397	1349951129000	15682	7979	0	0	8888
123059	2133	98937876000	15682	7979	1	0	62
123060	2134	98964895000	15682	7979	2	0	35
123072	1397	1349941128000	15687	7980	0	0	8889
123074	2133	98936874000	15687	7980	2	0	63
123081	2134	98961886000	15689	7981	3	0	\N
123082	2132	148984985000	15689	7981	4	0	\N
123083	1397	1349931127000	15690	7981	0	0	\N
123084	1397	1349921126000	15690	7981	1	0	\N
123085	2134	98962889000	15690	7981	2	0	\N
123086	2134	98961886000	15690	7981	3	0	\N
123087	2132	148984985000	15690	7981	4	0	\N
123088	2133	98935872000	15690	7981	5	0	\N
123089	2133	98934870000	15690	7981	6	0	\N
123103	1397	1349901124000	15695	7983	0	0	\N
123104	2134	98959880000	15695	7983	1	0	\N
123105	2133	98932866000	15695	7983	2	0	\N
123106	1397	1349891123000	15696	7984	0	0	\N
123107	2134	98958877000	15696	7984	1	0	\N
123108	2132	148983984000	15696	7984	2	0	\N
123109	2133	98931864000	15696	7984	3	0	\N
123114	1397	1349891123000	15698	7984	0	0	\N
123115	2134	98958877000	15698	7984	1	0	\N
123116	2132	148983984000	15698	7984	2	0	\N
123117	2133	98931864000	15698	7984	3	0	\N
123118	1397	1349891123000	15699	7984	0	0	\N
123119	2134	98958877000	15699	7984	1	0	\N
123120	2132	148983984000	15699	7984	2	0	\N
123121	2133	98931864000	15699	7984	3	0	\N
123122	1397	1349881122000	15700	7985	0	0	\N
123123	1397	1349871121000	15700	7985	2	0	\N
123129	1397	1349881122000	15702	7985	0	0	\N
123130	1397	1349871121000	15702	7985	2	0	\N
123131	2133	98930862000	15702	7985	3	0	\N
123132	2133	98929860000	15702	7985	4	0	\N
123133	1569	845000000	15702	7985	5	0	\N
123134	2134	98957874000	15702	7985	6	0	\N
123135	2134	98956871000	15702	7985	7	0	\N
123136	1397	1349881122000	15703	7985	0	0	\N
123137	1397	1349871121000	15703	7985	2	0	\N
123138	2133	98930862000	15703	7985	3	0	\N
123139	2133	98929860000	15703	7985	4	0	\N
123140	1569	845000000	15703	7985	5	0	\N
123141	2134	98957874000	15703	7985	6	0	\N
123142	2134	98956871000	15703	7985	7	0	\N
123143	1397	1349861120000	15704	7986	0	0	\N
123144	2132	148982983000	15704	7986	1	0	\N
123145	2133	98930862000	15704	7986	2	0	\N
123146	2134	98955868000	15704	7986	3	0	\N
123147	2133	98929860000	15704	7986	4	0	\N
123148	2133	98928858000	15704	7986	5	0	\N
123155	1397	1349861120000	15706	7986	0	0	\N
123156	2132	148982983000	15706	7986	1	0	\N
123157	2133	98930862000	15706	7986	2	0	\N
123158	2133	98929860000	15706	7986	3	0	\N
123159	2133	98928858000	15706	7986	4	0	\N
123160	1569	845000000	15706	7986	5	0	\N
123161	2134	98957874000	15706	7986	6	0	\N
123162	2134	98956871000	15706	7986	7	0	\N
123163	2134	98955868000	15706	7986	8	0	\N
123180	1874	420000	15711	7902	0	0	\N
123181	1397	1349801114000	15712	7990	0	0	\N
123182	2133	98922846000	15712	7990	1	0	\N
123183	2134	98949850000	15712	7990	2	0	\N
123184	1397	1349801114000	15713	7990	0	0	\N
123185	2133	98922846000	15713	7990	1	0	\N
123186	2134	98949850000	15713	7990	2	0	\N
123190	1397	1349791113000	15715	7991	0	0	\N
123191	2133	98921844000	15715	7991	1	0	\N
123192	2134	98948847000	15715	7991	2	0	\N
123193	2132	148980981000	15715	7991	3	0	\N
123198	1397	1350751209000	15717	7844	0	0	\N
123199	1397	1350741208000	15717	7844	1	0	\N
123200	1397	1350731207000	15717	7844	2	0	\N
123201	1397	1350721206000	15717	7844	3	0	\N
123202	1397	1350711205000	15717	7844	4	0	\N
123203	1397	1350701204000	15717	7844	5	0	\N
123204	1397	1350691203000	15717	7844	6	0	\N
123205	1397	1350681202000	15717	7844	7	0	\N
123206	1397	1350671201000	15717	7844	8	0	\N
123207	1397	1350661200000	15717	7844	9	0	\N
123208	1397	1350651199000	15717	7844	10	0	\N
123209	1397	1350641198000	15717	7844	11	0	\N
123210	1397	1350631197000	15717	7844	12	0	\N
123211	1397	1350621196000	15717	7844	13	0	\N
123212	1397	1350611195000	15717	7844	14	0	\N
123213	1397	1350601194000	15717	7844	15	0	\N
123214	1397	1350591193000	15717	7844	17	0	\N
123215	1397	1350581192000	15717	7844	18	0	\N
123216	1397	1350571191000	15717	7844	19	0	\N
123092	2134	98962889000	15691	7981	2	0	37
123093	2134	98961886000	15691	7981	3	0	38
123094	2132	148984985000	15691	7981	4	0	15
123095	2133	98935872000	15691	7981	5	0	64
123096	2133	98934870000	15691	7981	6	0	65
123098	2133	98933868000	15693	7982	1	0	66
123099	2134	98960883000	15693	7982	2	0	39
123100	1397	1349901124000	15694	7983	0	0	8893
123101	2134	98959880000	15694	7983	1	0	40
123102	2133	98932866000	15694	7983	2	0	67
123111	2134	98958877000	15697	7984	1	0	41
123112	2132	148983984000	15697	7984	2	0	16
123113	2133	98931864000	15697	7984	3	0	68
123124	1397	1349881122000	15701	7985	0	0	8895
123126	1569	845000000	15701	7985	3	0	3
123127	2134	98957874000	15701	7985	4	0	42
123128	2134	98956871000	15701	7985	5	0	43
123149	1397	1349861120000	15705	7986	0	0	8897
123150	2132	148982983000	15705	7986	1	0	17
123152	2134	98955868000	15705	7986	3	0	44
123153	2133	98929860000	15705	7986	4	0	70
123154	2133	98928858000	15705	7986	5	0	71
123164	1397	1349851119000	15707	7987	0	0	8898
123165	2133	98927856000	15707	7987	1	0	72
123167	1397	1349841118000	15708	7988	0	0	8899
123168	2133	98926854000	15708	7988	1	0	73
123169	2134	98953862000	15708	7988	2	0	46
123170	1397	1349831117000	15710	7989	0	0	8900
123172	1397	1349811115000	15710	7989	2	0	8902
123173	2132	148981982000	15710	7989	3	0	18
123174	2133	98925852000	15710	7989	4	0	74
123175	2133	98924850000	15710	7989	5	0	75
123176	2133	98923848000	15710	7989	6	0	76
123178	2134	98951856000	15710	7989	8	0	48
123179	2134	98950853000	15710	7989	9	0	49
123187	1397	1349801114000	15714	7990	0	0	8903
123188	2133	98922846000	15714	7990	1	0	77
123189	2134	98949850000	15714	7990	2	0	50
123195	2133	98921844000	15716	7991	1	0	78
123196	2134	98948847000	15716	7991	2	0	51
123197	2132	148980981000	15716	7991	3	0	19
123217	1397	1350561190000	15717	7844	20	0	\N
123218	1397	1350551189000	15717	7844	21	0	\N
123219	1397	1350541188000	15717	7844	22	0	\N
123220	1397	1350531187000	15717	7844	23	0	\N
123221	1397	1350521186000	15717	7844	24	0	\N
123222	1397	1350511185000	15717	7844	25	0	\N
123223	1397	1350501184000	15717	7844	26	0	\N
123224	1397	1350491183000	15717	7844	27	0	\N
123225	1397	1350481182000	15717	7844	28	0	\N
123226	1397	1350471181000	15717	7844	29	0	\N
123227	1397	1350461180000	15717	7844	30	0	\N
123228	1397	1350451179000	15717	7844	31	0	\N
123229	1397	1350441178000	15717	7844	32	0	\N
123230	1397	1350431177000	15717	7844	33	0	\N
123231	1397	1350421176000	15717	7844	34	0	\N
123232	1397	1350411175000	15717	7844	35	0	\N
123233	1397	1350401174000	15717	7844	36	0	\N
123234	1397	1350391173000	15717	7844	37	0	\N
123235	1397	1350381172000	15717	7844	38	0	\N
123236	1397	1350371171000	15717	7844	39	0	\N
123237	1397	1350361170000	15717	7844	40	0	\N
123238	1397	1350351169000	15717	7844	41	0	\N
123239	1397	1350341168000	15717	7844	42	0	\N
123240	1397	1350331167000	15717	7844	43	0	\N
123241	1397	1350321166000	15717	7844	44	0	\N
123242	1397	1350311165000	15717	7844	45	0	\N
123243	1397	1350301164000	15717	7844	46	0	\N
123244	1397	1350291163000	15717	7844	47	0	\N
123245	1397	1350281162000	15717	7844	48	0	\N
123246	1397	1350271161000	15717	7844	49	0	\N
123247	1397	1350261160000	15717	7844	50	0	\N
123248	1397	1350251159000	15717	7844	51	0	\N
123249	1397	1350241158000	15717	7844	52	0	\N
123250	1397	1350231157000	15717	7844	53	0	\N
123251	1397	1350221156000	15717	7844	54	0	\N
123252	1397	1350211155000	15717	7844	55	0	\N
123253	1397	1350201154000	15717	7844	56	0	\N
123254	1397	1350191153000	15717	7844	57	0	\N
123255	1397	1350181152000	15717	7844	58	0	\N
123256	1397	1350171151000	15717	7844	59	0	\N
123257	1397	1350161150000	15717	7844	60	0	\N
123258	1397	1350151149000	15717	7844	61	0	\N
123259	1397	1350141148000	15717	7844	62	0	\N
123260	1397	1350131147000	15717	7844	63	0	\N
123261	1397	1350121146000	15717	7844	64	0	\N
123262	1397	1350111145000	15717	7844	65	0	\N
123263	1397	1350101144000	15717	7844	66	0	\N
123264	1397	1350091143000	15717	7844	67	0	\N
123265	1397	1350081142000	15717	7844	68	0	\N
123266	1397	1350071141000	15717	7844	69	0	\N
123267	1397	1350061140000	15717	7844	70	0	\N
123268	1397	1350051139000	15717	7844	71	0	\N
123269	1397	1350041138000	15717	7844	72	0	\N
123270	1397	1350031137000	15717	7844	73	0	\N
123271	1397	1350021136000	15717	7844	74	0	\N
123272	1397	1350011135000	15717	7844	75	0	\N
123273	1397	1350001134000	15717	7844	76	0	\N
123274	1397	1349991133000	15717	7844	77	0	\N
123275	1397	1349981132000	15717	7844	78	0	\N
123276	1397	1349971131000	15717	7844	79	0	\N
123277	1397	1349961130000	15717	7844	80	0	\N
123278	1397	1349951129000	15717	7844	81	0	\N
123279	1397	1349941128000	15717	7844	82	0	\N
123280	1397	1349931127000	15717	7844	83	0	\N
123281	1397	1349921126000	15717	7844	84	0	\N
123282	1397	1349911125000	15717	7844	85	0	\N
123283	1397	1349901124000	15717	7844	86	0	\N
123284	1397	1349891123000	15717	7844	87	0	\N
123285	1397	1349881122000	15717	7844	88	0	\N
123286	1397	1349871121000	15717	7844	89	0	\N
123287	1397	1349861120000	15717	7844	90	0	\N
123288	1397	1349851119000	15717	7844	91	0	\N
123289	1397	1349841118000	15717	7844	92	0	\N
123290	1397	1349831117000	15717	7844	93	0	\N
123291	1397	1349821116000	15717	7844	94	0	\N
123292	1397	1349811115000	15717	7844	95	0	\N
123293	1397	1349801114000	15717	7844	96	0	\N
123294	1397	1349791113000	15717	7844	97	0	\N
123295	1874	267000	15717	7844	98	0	\N
123296	1726	646055322000	15717	7844	99	0	\N
123297	1726	646054320000	15717	7844	100	0	\N
123298	1726	646053319000	15717	7844	101	0	\N
123299	1726	646052317000	15717	7844	102	0	\N
123300	1726	646051316000	15717	7844	103	0	\N
123301	1726	646050315000	15717	7844	104	0	\N
123302	1726	646049313000	15717	7844	105	0	\N
123303	1726	646048312000	15717	7844	106	0	\N
123304	1726	646047310000	15717	7844	107	0	\N
123305	1726	646046309000	15717	7844	108	0	\N
123306	1726	646045307000	15717	7844	109	0	\N
123307	1726	646044306000	15717	7844	110	0	\N
123308	1726	646043305000	15717	7844	111	0	\N
123309	1726	646042303000	15717	7844	112	0	\N
123310	1726	646041302000	15717	7844	113	0	\N
123311	1726	646040300000	15717	7844	114	0	\N
123312	1726	646039299000	15717	7844	115	0	\N
123313	1726	646038297000	15717	7844	116	0	\N
123314	1726	646037296000	15717	7844	117	0	\N
123315	1726	646036294000	15717	7844	118	0	\N
123316	1726	646035293000	15717	7844	119	0	\N
123317	1726	646034292000	15717	7844	120	0	\N
123318	1726	646033290000	15717	7844	121	0	\N
123319	1726	646032289000	15717	7844	122	0	\N
123320	1726	646031287000	15717	7844	123	0	\N
123321	1726	646030286000	15717	7844	124	0	\N
123322	1726	646029284000	15717	7844	125	0	\N
123323	1397	1349781112000	15718	7992	0	0	\N
123324	1397	1349771111000	15718	7992	1	0	\N
123325	1397	1349761110000	15718	7992	2	0	\N
123326	2132	148979980000	15718	7992	3	0	\N
123327	2133	98920842000	15718	7992	4	0	\N
123328	2133	98919840000	15718	7992	5	0	\N
123329	2133	98918838000	15718	7992	6	0	\N
123330	2134	98947844000	15718	7992	7	0	\N
123331	2134	98946841000	15718	7992	8	0	\N
123332	2134	98945838000	15718	7992	9	0	\N
123349	1397	1349741108000	15722	7994	0	0	\N
123350	2133	98916834000	15722	7994	1	0	\N
123351	2134	98943832000	15722	7994	2	0	\N
123352	1397	1349731107000	15723	7995	0	0	\N
123335	1397	1349761110000	15719	7992	2	0	8907
123336	2132	148979980000	15719	7992	3	0	20
123337	2133	98920842000	15719	7992	4	0	79
123338	2133	98919840000	15719	7992	5	0	80
123339	2133	98918838000	15719	7992	6	0	81
123341	2134	98946841000	15719	7992	8	0	53
123342	2134	98945838000	15719	7992	9	0	54
123343	1397	1349751109000	15720	7993	0	0	8908
123344	2134	98944835000	15720	7993	1	0	55
123345	2133	98917836000	15720	7993	2	0	82
123347	2133	98916834000	15721	7994	1	0	83
123348	2134	98943832000	15721	7994	2	0	56
123353	2134	98942829000	15723	7995	1	0	\N
123354	2133	98915832000	15723	7995	2	0	\N
123358	1397	1349731107000	15725	7995	0	0	\N
123359	2134	98942829000	15725	7995	1	0	\N
123360	2133	98915832000	15725	7995	2	0	\N
123365	1397	1349721106000	15727	7996	0	0	\N
123366	2134	98941826000	15727	7996	1	0	\N
123367	2133	98914830000	15727	7996	2	0	\N
123368	2132	148978979000	15727	7996	3	0	\N
123375	1397	1349701104000	15730	7998	0	0	\N
123376	2133	98912826000	15730	7998	1	0	\N
123377	2134	98939820000	15730	7998	2	0	\N
123396	1397	1349641098000	15734	8002	0	0	\N
123397	2133	98906814000	15734	8002	1	0	\N
123398	2134	98933802000	15734	8002	2	0	\N
123413	1397	1349631097000	15737	8003	0	0	\N
123414	1397	1349621096000	15737	8003	1	0	\N
123415	1397	1349611095000	15737	8003	2	0	\N
123416	2132	148975976000	15737	8003	3	0	\N
123417	129	66000025022968	15737	8003	4	0	\N
123418	2134	98932799000	15737	8003	5	0	\N
123419	2133	98905812000	15737	8003	6	0	\N
123420	2133	98904810000	15737	8003	7	0	\N
123421	2133	98903808000	15737	8003	9	0	\N
123422	2134	98931796000	15737	8003	10	0	\N
123423	2134	98930793000	15737	8003	11	0	\N
123427	365	66619901000000	15739	8004	0	0	\N
123428	1397	1349601094000	15739	8004	1	0	\N
123429	1397	1349591093000	15740	8005	0	0	\N
123430	1397	1349581092000	15740	8005	1	0	\N
123431	2134	98928787000	15740	8005	2	0	\N
123432	2133	98902806000	15740	8005	3	0	\N
123433	2134	98927784000	15740	8005	4	0	\N
123434	2133	98901804000	15740	8005	5	0	\N
123435	2132	148974975000	15740	8005	6	0	\N
123446	1397	1349571091000	15743	8006	0	0	\N
123447	2133	98900802000	15743	8006	1	0	\N
123448	2134	98926781000	15743	8006	2	0	\N
123453	365	66619901000000	15745	7903	0	0	\N
123454	1474	11074422000023	15745	7903	1	0	\N
123455	129	66444026022968	15745	7903	2	0	\N
123456	129	66000025022968	15745	7903	3	0	\N
123464	1474	11074422000023	15747	8008	0	0	\N
123465	1397	1349551089000	15747	8008	1	0	\N
123466	1397	1349541088000	15747	8008	2	0	\N
123467	2133	98898798000	15747	8008	3	0	\N
123468	2133	98897796000	15747	8008	4	0	\N
123469	2134	98924775000	15747	8008	5	0	\N
123470	2134	98923772000	15747	8008	6	0	\N
123471	688	66000000000000	15748	8009	0	0	\N
123472	1397	1349531087000	15748	8009	1	0	\N
123473	1397	1349521086000	15748	8009	2	0	\N
123474	1397	1349511085000	15748	8009	3	0	\N
123475	1397	1349501084000	15748	8009	4	0	\N
123476	2132	148972973000	15748	8009	5	0	\N
123477	2134	98922769000	15748	8009	6	0	\N
123478	2133	98896794000	15748	8009	7	0	\N
123479	2133	98895792000	15748	8009	8	0	\N
123480	2133	98894790000	15748	8009	9	0	\N
123481	2133	98893788000	15748	8009	10	0	\N
123482	2134	98921766000	15748	8009	11	0	\N
123483	2134	98920763000	15748	8009	12	0	\N
123484	2134	98919760000	15748	8009	13	0	\N
123485	688	66000000000000	15749	8009	0	0	\N
123486	1397	1349531087000	15749	8009	1	0	\N
123487	1397	1349521086000	15749	8009	2	0	\N
123488	1397	1349511085000	15749	8009	3	0	\N
123357	2133	98915832000	15724	7995	2	0	84
123361	1397	1349721106000	15726	7996	0	0	8911
123362	2134	98941826000	15726	7996	1	0	58
123363	2133	98914830000	15726	7996	2	0	85
123364	2132	148978979000	15726	7996	3	0	21
123370	2133	98913828000	15728	7997	1	0	86
123371	2134	98940823000	15728	7997	2	0	59
123372	1397	1349701104000	15729	7998	0	0	8913
123373	2133	98912826000	15729	7998	1	0	87
123374	2134	98939820000	15729	7998	2	0	60
123379	1397	1349681102000	15731	7999	1	0	8915
123380	2132	148977978000	15731	7999	2	0	22
123381	2133	98911824000	15731	7999	3	0	88
123382	2134	98938817000	15731	7999	4	0	61
123384	2133	98910822000	15731	7999	6	0	89
123385	1397	1349671101000	15732	8000	0	0	8916
123386	1397	1349661100000	15732	8000	1	0	8917
123387	2133	98909820000	15732	8000	2	0	90
123388	2133	98908818000	15732	8000	3	0	91
123390	129	66444026022968	15732	8000	5	0	1
123391	2134	98936811000	15732	8000	6	0	63
123392	2134	98935808000	15732	8000	7	0	64
123393	1397	1349651099000	15733	8001	0	0	8918
123394	2134	98934805000	15733	8001	1	0	65
123399	1397	1349641098000	15735	8002	0	0	8919
123400	2133	98906814000	15735	8002	1	0	93
123401	2134	98933802000	15735	8002	2	0	66
123402	1397	1349631097000	15736	8003	0	0	8920
123404	1397	1349611095000	15736	8003	2	0	8922
123405	2132	148975976000	15736	8003	3	0	24
123406	129	66000025022968	15736	8003	4	0	2
123407	2134	98932799000	15736	8003	5	0	67
123408	2133	98905812000	15736	8003	6	0	94
123410	2133	98903808000	15736	8003	9	0	96
123411	2134	98931796000	15736	8003	10	0	68
123412	2134	98930793000	15736	8003	11	0	69
123424	365	66619901000000	15738	8004	0	0	1
123425	1397	1349601094000	15738	8004	1	0	8923
123436	1397	1349591093000	15741	8005	0	0	8924
123437	1397	1349581092000	15741	8005	1	0	8925
123438	2134	98928787000	15741	8005	2	0	71
123439	2133	98902806000	15741	8005	3	0	97
123441	2133	98901804000	15741	8005	5	0	98
123442	2132	148974975000	15741	8005	6	0	25
123443	1397	1349571091000	15742	8006	0	0	8926
123444	2133	98900802000	15742	8006	1	0	99
123445	2134	98926781000	15742	8006	2	0	73
123450	2134	98925778000	15744	8007	1	0	74
123451	2133	98899800000	15744	8007	2	0	100
123452	2132	148973974000	15744	8007	3	0	26
123457	1474	11074422000023	15746	8008	0	0	14
123458	1397	1349551089000	15746	8008	1	0	8928
123460	2133	98898798000	15746	8008	3	0	101
123461	2133	98897796000	15746	8008	4	0	102
123462	2134	98924775000	15746	8008	5	0	75
123463	2134	98923772000	15746	8008	6	0	76
123489	1397	1349501084000	15749	8009	4	0	\N
123490	2132	148972973000	15749	8009	5	0	\N
123491	2134	98922769000	15749	8009	6	0	\N
123492	2133	98896794000	15749	8009	7	0	\N
123493	2133	98895792000	15749	8009	8	0	\N
123494	2133	98894790000	15749	8009	9	0	\N
123495	2133	98893788000	15749	8009	10	0	\N
123496	2134	98921766000	15749	8009	11	0	\N
123497	2134	98920763000	15749	8009	12	0	\N
123498	2134	98919760000	15749	8009	13	0	\N
123520	1397	1349471081000	15752	8011	0	0	\N
123521	1397	1349461080000	15752	8011	1	0	\N
123522	2134	98916751000	15752	8011	2	0	\N
123523	2134	98915748000	15752	8011	3	0	\N
123524	2132	148970971000	15752	8011	4	0	\N
123525	2133	98890782000	15752	8011	5	0	\N
123526	2133	98889780000	15752	8011	6	0	\N
123527	1397	1349471081000	15753	8011	0	0	\N
123528	1397	1349461080000	15753	8011	1	0	\N
123529	2134	98916751000	15753	8011	2	0	\N
123530	2134	98915748000	15753	8011	3	0	\N
123531	2132	148970971000	15753	8011	4	0	\N
123532	2133	98890782000	15753	8011	5	0	\N
123533	2133	98889780000	15753	8011	6	0	\N
123541	1397	1349471081000	15755	8011	0	0	\N
123542	1397	1349461080000	15755	8011	1	0	\N
123543	2134	98916751000	15755	8011	2	0	\N
123544	2134	98915748000	15755	8011	3	0	\N
123545	2132	148970971000	15755	8011	4	0	\N
123546	2133	98890782000	15755	8011	5	0	\N
123547	2133	98889780000	15755	8011	6	0	\N
123548	2133	98888778000	15755	8011	7	0	\N
123555	1397	1349431077000	15757	8013	0	0	\N
123556	2134	98912739000	15757	8013	1	0	\N
123557	2133	98886774000	15757	8013	2	0	\N
123565	1397	1349421076000	15760	8014	0	0	\N
123566	2134	98911736000	15760	8014	1	0	\N
123567	2133	98885772000	15760	8014	2	0	\N
123568	2132	148969970000	15760	8014	3	0	\N
123581	1397	1349381072000	15763	8016	0	0	\N
123582	2133	98881764000	15763	8016	1	0	\N
123583	2134	98908727000	15763	8016	2	0	\N
123591	1697	401990000000	15766	8019	0	0	\N
123592	1397	1349351069000	15766	8019	1	0	\N
123593	1397	1349341068000	15766	8019	2	0	\N
123594	2133	98878758000	15766	8019	3	0	\N
123595	2133	98877756000	15766	8019	4	0	\N
123596	2134	98905718000	15766	8019	5	0	\N
123597	2134	98904715000	15766	8019	6	0	\N
123605	1697	401990000000	15768	8019	0	0	\N
123606	1397	1349351069000	15768	8019	1	0	\N
123607	1397	1349341068000	15768	8019	2	0	\N
123608	2133	98878758000	15768	8019	3	0	\N
123609	2133	98877756000	15768	8019	4	0	\N
123610	2134	98905718000	15768	8019	5	0	\N
123611	2134	98904715000	15768	8019	6	0	\N
123623	1397	1349301064000	15772	8023	0	0	\N
123624	1397	1349291063000	15772	8023	1	0	\N
123501	1397	1349521086000	15750	8009	2	0	8931
123502	1397	1349511085000	15750	8009	3	0	8932
123503	1397	1349501084000	15750	8009	4	0	8933
123504	2132	148972973000	15750	8009	5	0	27
123505	2134	98922769000	15750	8009	6	0	77
123507	2133	98895792000	15750	8009	8	0	104
123508	2133	98894790000	15750	8009	9	0	105
123509	2133	98893788000	15750	8009	10	0	106
123510	2134	98921766000	15750	8009	11	0	78
123511	2134	98920763000	15750	8009	12	0	79
123513	1397	1349491083000	15751	8010	0	0	8934
123514	1397	1349481082000	15751	8010	1	0	8935
123515	2132	148971972000	15751	8010	2	0	28
123516	2134	98918757000	15751	8010	3	0	81
123518	2133	98892786000	15751	8010	5	0	107
123519	2133	98891784000	15751	8010	6	0	108
123534	1397	1349471081000	15754	8011	0	0	8936
123535	1397	1349461080000	15754	8011	1	0	8937
123536	2134	98916751000	15754	8011	2	0	83
123538	2132	148970971000	15754	8011	4	0	29
123539	2133	98890782000	15754	8011	5	0	109
123540	2133	98889780000	15754	8011	6	0	110
123549	1397	1349451079000	15756	8012	0	0	8938
123550	1397	1349441078000	15756	8012	1	0	8939
123552	2134	98913742000	15756	8012	3	0	86
123553	2133	98888778000	15756	8012	4	0	111
123554	2133	98887776000	15756	8012	5	0	112
123558	1397	1349431077000	15758	8013	0	0	8940
123560	2133	98886774000	15758	8013	2	0	113
123561	1397	1349421076000	15759	8014	0	0	8941
123562	2134	98911736000	15759	8014	1	0	88
123563	2133	98885772000	15759	8014	2	0	114
123564	2132	148969970000	15759	8014	3	0	30
123570	1397	1349401074000	15761	8015	1	0	8943
123571	1397	1349391073000	15761	8015	2	0	8944
123572	2133	98884770000	15761	8015	3	0	115
123573	2132	148968969000	15761	8015	4	0	31
123574	2134	98910733000	15761	8015	5	0	89
123576	2133	98883768000	15761	8015	7	0	116
123577	2133	98882766000	15761	8015	8	0	117
123578	1397	1349381072000	15762	8016	0	0	8945
123579	2133	98881764000	15762	8016	1	0	118
123584	1397	1349371071000	15764	8017	0	0	8946
123585	2134	98907724000	15764	8017	1	0	92
123586	2133	98880762000	15764	8017	2	0	119
123587	1397	1349361070000	15765	8018	0	0	8947
123588	2132	148967968000	15765	8018	1	0	32
123590	2133	98879760000	15765	8018	3	0	120
123598	1697	401990000000	15767	8019	0	0	1
123599	1397	1349351069000	15767	8019	1	0	8948
123600	1397	1349341068000	15767	8019	2	0	8949
123601	2133	98878758000	15767	8019	3	0	121
123603	2134	98905718000	15767	8019	5	0	94
123604	2134	98904715000	15767	8019	6	0	95
123612	1397	1349331067000	15769	8020	0	0	8950
123613	2133	98876754000	15769	8020	1	0	123
123615	1397	1349321066000	15770	8021	0	0	8951
123616	1504	937236000000	15770	8021	1	0	8
123617	2133	98875752000	15770	8021	2	0	124
123618	2132	148966967000	15770	8021	3	0	33
123619	2134	98902709000	15770	8021	4	0	97
123621	2134	98901706000	15771	8022	1	0	98
123622	2133	98874750000	15771	8022	2	0	125
123625	1397	1349281062000	15772	8023	2	0	\N
123626	1397	1349271061000	15772	8023	3	0	\N
123627	2132	148965966000	15772	8023	4	0	\N
123628	1504	437235000000	15772	8023	5	0	\N
123629	2134	98900703000	15772	8023	6	0	\N
123630	2134	98899700000	15772	8023	7	0	\N
123631	2134	98898697000	15772	8023	8	0	\N
123632	2134	98897694000	15772	8023	9	0	\N
123646	1397	1349261060000	15775	8024	0	0	\N
123647	2134	98896691000	15775	8024	1	0	\N
123648	2132	148964965000	15775	8024	2	0	\N
123649	2133	98873748000	15775	8024	3	0	\N
123650	2133	98872746000	15775	8024	4	0	\N
123651	2133	98871744000	15775	8024	5	0	\N
123652	2133	98870742000	15775	8024	6	0	\N
123653	2133	98869740000	15775	8024	7	0	\N
123654	1397	1349251059000	15776	8025	0	0	\N
123655	2134	98895688000	15776	8025	1	0	\N
123656	2133	98873748000	15776	8025	2	0	\N
123657	2133	98872746000	15776	8025	3	0	\N
123658	2133	98871744000	15776	8025	4	0	\N
123659	2133	98870742000	15776	8025	5	0	\N
123660	2133	98869740000	15776	8025	6	0	\N
123661	2133	98868738000	15776	8025	7	0	\N
123670	1397	1349241058000	15778	8026	0	0	\N
123674	1397	1349231057000	15780	8027	0	0	\N
123675	2134	98893682000	15780	8027	1	0	\N
123676	2133	98866734000	15780	8027	2	0	\N
123684	1397	1349221056000	15783	8028	0	0	\N
123685	2134	98892679000	15783	8028	1	0	\N
123686	2132	148963964000	15783	8028	2	0	\N
123687	2133	98865732000	15783	8028	3	0	\N
123688	1397	1349221056000	15784	8028	0	0	\N
123689	2134	98892679000	15784	8028	1	0	\N
123690	2132	148963964000	15784	8028	2	0	\N
123712	1397	1349161050000	15789	8032	0	0	\N
123713	1397	1349151049000	15789	8032	1	0	\N
123714	2132	148961962000	15789	8032	2	0	\N
123723	1397	1349121046000	15792	8035	0	0	\N
123724	2133	98855712000	15792	8035	1	0	\N
123725	2132	148960961000	15792	8035	2	0	\N
123726	2134	98882649000	15792	8035	3	0	\N
123760	1397	1349031037000	15798	8039	0	0	\N
123635	1397	1349281062000	15773	8023	2	0	8955
123636	1397	1349271061000	15773	8023	3	0	8956
123637	2132	148965966000	15773	8023	4	0	34
123638	1504	437235000000	15773	8023	5	0	9
123639	2134	98900703000	15773	8023	6	0	99
123641	2134	98898697000	15773	8023	8	0	101
123642	2134	98897694000	15773	8023	9	0	102
123643	1397	1349261060000	15774	8024	0	0	8957
123644	2134	98896691000	15774	8024	1	0	103
123645	2132	148964965000	15774	8024	2	0	35
123663	2134	98895688000	15777	8025	1	0	104
123664	2133	98873748000	15777	8025	2	0	126
123665	2133	98872746000	15777	8025	3	0	127
123666	2133	98871744000	15777	8025	4	0	128
123668	2133	98869740000	15777	8025	6	0	130
123669	2133	98868738000	15777	8025	7	0	131
123671	1397	1349241058000	15779	8026	0	0	8959
123672	2133	98867736000	15779	8026	1	0	132
123673	2134	98894685000	15779	8026	2	0	105
123678	2134	98893682000	15781	8027	1	0	106
123679	2133	98866734000	15781	8027	2	0	133
123680	1397	1349221056000	15782	8028	0	0	8961
123681	2134	98892679000	15782	8028	1	0	107
123682	2132	148963964000	15782	8028	2	0	36
123691	1397	1349211055000	15785	8029	0	0	8962
123692	1397	1349201054000	15785	8029	1	0	8963
123693	2134	98891676000	15785	8029	2	0	108
123694	2134	98890673000	15785	8029	3	0	109
123696	2133	98863728000	15785	8029	5	0	136
123697	1397	1349191053000	15786	8030	0	0	8964
123698	2133	98862726000	15786	8030	1	0	137
123699	2132	148962963000	15786	8030	2	0	37
123700	2134	98889670000	15786	8030	3	0	110
123702	1397	1349171051000	15787	8031	1	0	8966
123703	2133	98861724000	15787	8031	2	0	138
123704	2133	98860722000	15787	8031	3	0	139
123705	2134	98888667000	15787	8031	4	0	111
123706	2134	98887664000	15787	8031	5	0	112
123708	1397	1349151049000	15788	8032	1	0	8968
123709	2132	148961962000	15788	8032	2	0	38
123710	2134	98886661000	15788	8032	3	0	113
123711	2134	98885658000	15788	8032	4	0	114
123716	2133	98859720000	15790	8033	1	0	140
123717	2133	98858718000	15790	8033	2	0	141
123718	2134	98884655000	15790	8033	3	0	115
123719	2133	98857716000	15790	8033	4	0	142
123720	1397	1349131047000	15791	8034	0	0	8970
123722	2134	98883652000	15791	8034	2	0	116
123727	1397	1349121046000	15793	8035	0	0	8971
123728	2133	98855712000	15793	8035	1	0	144
123729	2132	148960961000	15793	8035	2	0	39
123730	2134	98882649000	15793	8035	3	0	117
123732	1397	1349101044000	15794	8036	1	0	8973
123733	2133	98854710000	15794	8036	2	0	145
123734	2133	98853708000	15794	8036	3	0	146
123735	2134	98881646000	15794	8036	4	0	118
123737	1397	1349091043000	15795	8037	0	0	8974
123738	2134	98879640000	15795	8037	1	0	120
123739	2133	98852706000	15795	8037	2	0	147
123740	2132	148959960000	15795	8037	3	0	40
123741	1397	1349081042000	15796	8038	0	0	8975
123743	1397	1349061040000	15796	8038	2	0	8977
123744	1397	1349051039000	15796	8038	3	0	8978
123745	1397	1349041038000	15796	8038	4	0	8979
123746	2132	148958959000	15796	8038	5	0	41
123747	2134	98878637000	15796	8038	7	0	121
123749	2133	98850702000	15796	8038	9	0	149
123750	2133	98849700000	15796	8038	10	0	150
123751	2133	98848698000	15796	8038	11	0	151
123752	2133	98847696000	15796	8038	12	0	152
123754	2134	98876631000	15796	8038	14	0	123
123755	2134	98875628000	15796	8038	15	0	124
123756	2134	98874625000	15796	8038	16	0	125
123757	1397	1349031037000	15797	8039	0	0	8980
123758	2134	98873622000	15797	8039	1	0	126
123761	2134	98873622000	15798	8039	1	0	\N
123762	2133	98846694000	15798	8039	2	0	\N
123779	1397	1348981032000	15804	8044	0	0	\N
123780	2134	98868607000	15804	8044	1	0	\N
123781	2133	98842686000	15804	8044	2	0	\N
123790	1397	1348961030000	15807	8046	0	0	\N
123791	2134	98866601000	15807	8046	1	0	\N
123792	2132	148955956000	15807	8046	2	0	\N
123793	2133	98840682000	15807	8046	3	0	\N
123794	365	66619901000000	15808	7957	0	0	\N
123795	1697	401990000000	15808	7957	1	0	\N
123796	1683	27215449399541	15808	7957	2	0	\N
123797	1474	11074422000023	15808	7957	3	0	\N
123798	1677	9557256850100	15808	7957	4	0	\N
123799	1504	937236000000	15808	7957	5	0	\N
123800	1504	437235000000	15808	7957	6	0	\N
123801	129	66444026022968	15808	7957	7	0	\N
123802	129	66000025022968	15808	7957	8	0	\N
123807	1688	100006778076000	15811	8048	0	0	\N
123808	1688	99821618771000	15811	8048	1	0	\N
123809	1688	99655639030000	15811	8048	2	0	\N
123810	1397	1348941028000	15811	8048	3	0	\N
123811	1397	1348931027000	15811	8048	4	0	\N
123812	1397	1348921026000	15811	8048	5	0	\N
123813	1688	99585775343000	15811	8048	6	0	\N
123814	2133	98838678000	15811	8048	7	0	\N
123815	2133	98837676000	15811	8048	8	0	\N
123816	2133	98836674000	15811	8048	9	0	\N
123817	2132	148954955000	15811	8048	10	0	\N
123818	1688	100006778076000	15812	8048	0	0	\N
123819	1688	99821618771000	15812	8048	1	0	\N
123820	1688	99655639030000	15812	8048	2	0	\N
123821	1397	1348941028000	15812	8048	3	0	\N
123822	1397	1348931027000	15812	8048	4	0	\N
123823	1397	1348921026000	15812	8048	5	0	\N
123824	1688	99585775343000	15812	8048	6	0	\N
123825	2134	98864595000	15812	8048	7	0	\N
123826	2134	98863592000	15812	8048	8	0	\N
123827	2133	98838678000	15812	8048	9	0	\N
123828	2133	98837676000	15812	8048	10	0	\N
123829	2133	98836674000	15812	8048	11	0	\N
123830	2132	148954955000	15812	8048	12	0	\N
123831	2134	98862589000	15812	8048	13	0	\N
123846	1688	100006778076000	15814	8048	0	0	\N
123847	1688	99821618771000	15814	8048	1	0	\N
123848	1688	99655639030000	15814	8048	2	0	\N
123849	1397	1348941028000	15814	8048	3	0	\N
123850	1397	1348931027000	15814	8048	4	0	\N
123851	1397	1348921026000	15814	8048	5	0	\N
123852	1688	99585775343000	15814	8048	6	0	\N
123853	2134	98864595000	15814	8048	7	0	\N
123854	2134	98863592000	15814	8048	8	0	\N
123855	2133	98838678000	15814	8048	9	0	\N
123856	2133	98837676000	15814	8048	10	0	\N
123857	2133	98836674000	15814	8048	11	0	\N
123858	2132	148954955000	15814	8048	12	0	\N
123859	2134	98862589000	15814	8048	13	0	\N
123860	1688	100006778076000	15815	8048	0	0	\N
123861	1688	99821618771000	15815	8048	1	0	\N
123862	1688	99655639030000	15815	8048	2	0	\N
123863	1397	1348941028000	15815	8048	3	0	\N
123864	1397	1348931027000	15815	8048	4	0	\N
123865	1397	1348921026000	15815	8048	5	0	\N
123866	1688	99585775343000	15815	8048	6	0	\N
123867	2134	98864595000	15815	8048	7	0	\N
123868	2134	98863592000	15815	8048	8	0	\N
123869	2133	98838678000	15815	8048	9	0	\N
123870	2133	98837676000	15815	8048	10	0	\N
123871	2133	98836674000	15815	8048	11	0	\N
123872	2132	148954955000	15815	8048	12	0	\N
123873	2134	98862589000	15815	8048	13	0	\N
123874	1688	100006778076000	15816	8048	0	0	\N
123875	1688	99821618771000	15816	8048	1	0	\N
123876	1688	99655639030000	15816	8048	2	0	\N
123877	1397	1348941028000	15816	8048	3	0	\N
123878	1397	1348931027000	15816	8048	4	0	\N
123879	1397	1348921026000	15816	8048	5	0	\N
123880	1688	99585775343000	15816	8048	6	0	\N
123881	2133	98838678000	15816	8048	7	0	\N
123882	2133	98837676000	15816	8048	8	0	\N
123883	2133	98836674000	15816	8048	9	0	\N
123884	2132	148954955000	15816	8048	10	0	\N
123765	2134	98872619000	15799	8040	2	0	127
123766	1397	1349011035000	15800	8041	0	0	8982
123767	2133	98845692000	15800	8041	1	0	154
123768	2134	98871616000	15800	8041	2	0	128
123769	1683	27215449399541	15801	8042	0	0	2
123771	2133	98844690000	15801	8042	2	0	155
123772	1397	1348991033000	15802	8043	0	0	8984
123773	2132	148956957000	15802	8043	1	0	43
123774	2133	98843688000	15802	8043	2	0	156
123775	2134	98870613000	15802	8043	3	0	129
123777	1397	1348981032000	15803	8044	0	0	8985
123778	2133	98842686000	15803	8044	1	0	157
123782	1397	1348971031000	15805	8045	0	0	8986
123783	1677	9557256850100	15805	8045	1	0	2
123785	2134	98868607000	15805	8045	3	0	131
123786	2134	98867604000	15805	8045	4	0	132
123787	1397	1348961030000	15806	8046	0	0	8987
123788	2132	148955956000	15806	8046	1	0	44
123789	2133	98840682000	15806	8046	2	0	159
123804	2134	98866601000	15809	8047	1	0	133
123805	2133	98839680000	15809	8047	2	0	160
123806	2134	98865598000	15809	8047	3	0	134
123832	1688	100006778076000	15813	8048	0	0	19
123833	1688	99821618771000	15813	8048	1	0	20
123835	1397	1348941028000	15813	8048	3	0	8989
123836	1397	1348931027000	15813	8048	4	0	8990
123837	1397	1348921026000	15813	8048	5	0	8991
123838	1688	99585775343000	15813	8048	6	0	22
123840	2134	98863592000	15813	8048	8	0	136
123841	2133	98838678000	15813	8048	9	0	161
123842	2133	98837676000	15813	8048	10	0	162
123843	2133	98836674000	15813	8048	11	0	163
123844	2132	148954955000	15813	8048	12	0	45
123885	1397	1348911025000	15817	8049	0	0	8992
123886	1397	1348901024000	15817	8049	1	0	8993
123887	1397	1348891023000	15817	8049	2	0	8994
123888	1688	98817375454000	15817	8049	3	0	23
123889	1688	92670370668000	15817	8049	4	0	24
123891	1688	85964537687000	15817	8049	6	0	26
123892	1688	85824820313000	15817	8049	7	0	27
123893	1688	84288030535000	15817	8049	8	0	28
123894	1688	84253096821000	15817	8049	9	0	29
123896	1688	83833986125000	15817	8049	11	0	31
123909	1688	83449744529000	15819	8050	0	0	\N
123910	1688	83179404808000	15819	8050	1	0	\N
123911	1397	1348881022000	15819	8050	2	0	\N
123912	2134	98858577000	15819	8050	3	0	\N
123913	2133	98832666000	15819	8050	4	0	\N
123927	1679	36723797703000	15821	8052	0	0	\N
123928	1679	36539289298000	15821	8052	1	0	\N
123929	1397	1348841018000	15821	8052	2	0	\N
123930	1679	36195307741000	15821	8052	3	0	\N
123931	1679	33648595836000	15821	8052	4	0	\N
123932	1679	28715239930000	15821	8052	5	0	\N
123933	1397	1348831017000	15821	8052	6	0	\N
123934	1397	1348821016000	15821	8052	8	0	\N
123935	1679	28171249166000	15821	8052	9	0	\N
123936	1679	27883493729000	15821	8052	10	0	\N
123937	1679	27157937909000	15821	8052	11	0	\N
123938	1679	26155780008000	15821	8052	12	0	\N
123939	2133	98828658000	15821	8052	13	0	\N
123940	2134	98854565000	15821	8052	14	0	\N
123941	2134	98853562000	15821	8052	15	0	\N
123942	2133	98827656000	15821	8052	16	0	\N
123943	2133	98826654000	15821	8052	17	0	\N
123944	2134	98852559000	15821	8052	18	0	\N
123945	2132	148951952000	15821	8052	19	0	\N
123946	1679	36723797703000	15822	8052	0	0	\N
123947	1679	36539289298000	15822	8052	1	0	\N
123948	1397	1348841018000	15822	8052	2	0	\N
123949	1679	36195307741000	15822	8052	3	0	\N
123950	1679	33648595836000	15822	8052	4	0	\N
123951	1679	28715239930000	15822	8052	5	0	\N
123952	1397	1348831017000	15822	8052	6	0	\N
123953	1397	1348821016000	15822	8052	8	0	\N
123954	1679	28171249166000	15822	8052	9	0	\N
123955	1679	27883493729000	15822	8052	10	0	\N
123956	1679	27157937909000	15822	8052	11	0	\N
123957	1679	26155780008000	15822	8052	12	0	\N
123958	2133	98828658000	15822	8052	13	0	\N
123959	2134	98854565000	15822	8052	14	0	\N
123960	2134	98853562000	15822	8052	15	0	\N
123961	2133	98827656000	15822	8052	16	0	\N
123962	2133	98826654000	15822	8052	17	0	\N
123963	2134	98852559000	15822	8052	18	0	\N
123964	2132	148951952000	15822	8052	19	0	\N
123965	1679	36723797703000	15823	8052	0	0	\N
123966	1679	36539289298000	15823	8052	1	0	\N
123967	1397	1348841018000	15823	8052	2	0	\N
123968	1679	36195307741000	15823	8052	3	0	\N
123969	1679	33648595836000	15823	8052	4	0	\N
123970	1679	28715239930000	15823	8052	5	0	\N
123971	1397	1348831017000	15823	8052	6	0	\N
123972	1397	1348821016000	15823	8052	8	0	\N
123973	1679	28171249166000	15823	8052	9	0	\N
123974	1679	27883493729000	15823	8052	10	0	\N
123975	1679	27157937909000	15823	8052	11	0	\N
123976	1679	26155780008000	15823	8052	12	0	\N
123977	2133	98828658000	15823	8052	13	0	\N
123978	2134	98854565000	15823	8052	14	0	\N
123979	2134	98853562000	15823	8052	15	0	\N
123980	2133	98827656000	15823	8052	16	0	\N
123981	2133	98826654000	15823	8052	17	0	\N
123982	2134	98852559000	15823	8052	18	0	\N
123983	2132	148951952000	15823	8052	19	0	\N
123984	1679	36723797703000	15824	8052	0	0	\N
123985	1679	36539289298000	15824	8052	1	0	\N
123986	1397	1348841018000	15824	8052	2	0	\N
123987	1679	36195307741000	15824	8052	3	0	\N
123988	1679	33648595836000	15824	8052	4	0	\N
123989	1679	28715239930000	15824	8052	5	0	\N
123990	1397	1348831017000	15824	8052	6	0	\N
123991	1397	1348821016000	15824	8052	8	0	\N
123992	1679	28171249166000	15824	8052	9	0	\N
123993	1679	27883493729000	15824	8052	10	0	\N
123994	1679	27157937909000	15824	8052	11	0	\N
123995	1679	26155780008000	15824	8052	12	0	\N
123996	2133	98828658000	15824	8052	13	0	\N
123997	2134	98854565000	15824	8052	14	0	\N
123998	2134	98853562000	15824	8052	15	0	\N
123999	2133	98827656000	15824	8052	16	0	\N
124000	2133	98826654000	15824	8052	17	0	\N
124001	2134	98852559000	15824	8052	18	0	\N
124002	2132	148951952000	15824	8052	19	0	\N
124022	1679	36723797703000	15826	8052	0	0	\N
124023	1679	36539289298000	15826	8052	1	0	\N
124024	1397	1348841018000	15826	8052	2	0	\N
124025	1679	36195307741000	15826	8052	3	0	\N
124026	1679	33648595836000	15826	8052	4	0	\N
124027	1679	28715239930000	15826	8052	5	0	\N
124028	1397	1348831017000	15826	8052	6	0	\N
124029	1397	1348821016000	15826	8052	8	0	\N
124030	1679	28171249166000	15826	8052	9	0	\N
124031	1679	27883493729000	15826	8052	10	0	\N
124032	1679	27157937909000	15826	8052	11	0	\N
123899	2134	98861586000	15817	8049	14	0	138
123900	2134	98860583000	15817	8049	15	0	139
123901	2134	98859580000	15817	8049	16	0	140
123902	2133	98833668000	15817	8049	17	0	166
123903	2132	148953954000	15817	8049	18	0	46
123905	1688	83179404808000	15818	8050	1	0	33
123906	1397	1348881022000	15818	8050	2	0	8995
123907	2134	98858577000	15818	8050	3	0	141
123908	2133	98832666000	15818	8050	4	0	167
123914	1397	1348871021000	15820	8051	0	0	8996
123916	1397	1348851019000	15820	8051	2	0	8998
123917	1688	80205770474000	15820	8051	3	0	34
123918	1688	75867910273000	15820	8051	4	0	35
123919	1688	28151589708000	15820	8051	5	0	36
123921	2133	98830662000	15820	8051	7	0	169
123922	2134	98857574000	15820	8051	8	0	142
123923	2134	98856571000	15820	8051	9	0	143
123924	2134	98855568000	15820	8051	10	0	144
123925	2133	98829660000	15820	8051	11	0	170
124003	1679	36723797703000	15825	8052	0	0	25
124004	1679	36539289298000	15825	8052	1	0	26
124005	1397	1348841018000	15825	8052	2	0	8999
124006	1679	36195307741000	15825	8052	3	0	27
124007	1679	33648595836000	15825	8052	4	0	28
124009	1397	1348831017000	15825	8052	6	0	9000
124010	1397	1348821016000	15825	8052	8	0	9001
124011	1679	28171249166000	15825	8052	9	0	30
124012	1679	27883493729000	15825	8052	10	0	31
124014	1679	26155780008000	15825	8052	12	0	33
124015	2133	98828658000	15825	8052	13	0	171
124016	2134	98854565000	15825	8052	14	0	145
124017	2134	98853562000	15825	8052	15	0	146
124018	2133	98827656000	15825	8052	16	0	172
124020	2134	98852559000	15825	8052	18	0	147
124021	2132	148951952000	15825	8052	19	0	48
124033	1679	26155780008000	15826	8052	12	0	\N
124034	2133	98828658000	15826	8052	13	0	\N
124035	2134	98854565000	15826	8052	14	0	\N
124036	2134	98853562000	15826	8052	15	0	\N
124037	2133	98827656000	15826	8052	16	0	\N
124038	2133	98826654000	15826	8052	17	0	\N
124039	2134	98852559000	15826	8052	18	0	\N
124040	2132	148951952000	15826	8052	19	0	\N
124041	1679	36723797703000	15827	8052	0	0	\N
124042	1679	36539289298000	15827	8052	1	0	\N
124043	1397	1348841018000	15827	8052	2	0	\N
124044	1679	36195307741000	15827	8052	3	0	\N
124045	1679	33648595836000	15827	8052	4	0	\N
124046	1679	28715239930000	15827	8052	5	0	\N
124047	1397	1348831017000	15827	8052	6	0	\N
124048	1397	1348821016000	15827	8052	8	0	\N
124049	1679	28171249166000	15827	8052	9	0	\N
124050	1679	27883493729000	15827	8052	10	0	\N
124051	1679	27157937909000	15827	8052	11	0	\N
124052	1679	26155780008000	15827	8052	12	0	\N
124053	2133	98828658000	15827	8052	13	0	\N
124054	2134	98854565000	15827	8052	14	0	\N
124055	2134	98853562000	15827	8052	15	0	\N
124056	2133	98827656000	15827	8052	16	0	\N
124057	2133	98826654000	15827	8052	17	0	\N
124058	2134	98852559000	15827	8052	18	0	\N
124059	2132	148951952000	15827	8052	19	0	\N
124060	1679	36723797703000	15828	8052	0	0	\N
124061	1679	36539289298000	15828	8052	1	0	\N
124062	1397	1348841018000	15828	8052	2	0	\N
124063	1679	36195307741000	15828	8052	3	0	\N
124064	1679	33648595836000	15828	8052	4	0	\N
124065	1679	28715239930000	15828	8052	5	0	\N
124066	1397	1348831017000	15828	8052	6	0	\N
124067	1397	1348821016000	15828	8052	8	0	\N
124068	1679	28171249166000	15828	8052	9	0	\N
124069	1679	27883493729000	15828	8052	10	0	\N
124070	1679	27157937909000	15828	8052	11	0	\N
124071	1679	26155780008000	15828	8052	12	0	\N
124072	2133	98828658000	15828	8052	13	0	\N
124073	2134	98854565000	15828	8052	14	0	\N
124074	2134	98853562000	15828	8052	15	0	\N
124075	2133	98827656000	15828	8052	16	0	\N
124076	2133	98826654000	15828	8052	17	0	\N
124077	2134	98852559000	15828	8052	18	0	\N
124078	2132	148951952000	15828	8052	19	0	\N
124079	1679	25275996603000	15829	8053	0	0	\N
124080	1679	19917968120000	15829	8053	1	0	\N
124081	1679	19344959717000	15829	8053	2	0	\N
124082	2133	98825652000	15829	8053	3	0	\N
124083	2134	98851556000	15829	8053	4	0	\N
124094	1679	13986931234000	15832	8054	0	0	\N
124095	1397	1348811015000	15832	8054	1	0	\N
124096	1679	13517267762000	15832	8054	2	0	\N
124097	2133	98824650000	15832	8054	3	0	\N
124098	2134	98850553000	15832	8054	4	0	\N
124099	1397	1348801014000	15833	8055	0	0	\N
124100	1679	13219590069000	15833	8055	1	0	\N
124101	1679	11929686731000	15833	8055	2	0	\N
124102	1679	11731231602000	15833	8055	3	0	\N
124103	2132	148950951000	15833	8055	4	0	\N
124104	2133	98823648000	15833	8055	5	0	\N
124105	2134	98849550000	15833	8055	6	0	\N
124136	1397	1348741008000	15837	8058	0	0	\N
124137	2133	98817636000	15837	8058	1	0	\N
124138	2134	98843532000	15837	8058	2	0	\N
124139	1397	1348741008000	15838	8058	0	0	\N
124140	2133	98817636000	15838	8058	1	0	\N
124144	1397	1348741008000	15840	8058	0	0	\N
124145	2133	98817636000	15840	8058	1	0	\N
124146	2134	98843532000	15840	8058	2	0	\N
124147	1397	1348731007000	15841	8059	0	0	\N
124148	2132	148948949000	15841	8059	1	0	\N
124149	2133	98816634000	15841	8059	2	0	\N
124150	2134	98842529000	15841	8059	3	0	\N
124151	1397	1348731007000	15842	8059	0	0	\N
124152	2132	148948949000	15842	8059	1	0	\N
124153	2133	98816634000	15842	8059	2	0	\N
124154	2134	98842529000	15842	8059	3	0	\N
124159	1397	1348731007000	15844	8059	0	0	\N
124160	2132	148948949000	15844	8059	1	0	\N
124161	2133	98816634000	15844	8059	2	0	\N
124162	2134	98842529000	15844	8059	3	0	\N
124166	1397	1348721006000	15846	8060	0	0	\N
124167	2133	98815632000	15846	8060	1	0	\N
124168	2134	98841526000	15846	8060	2	0	\N
124086	1679	19344959717000	15830	8053	2	0	36
124087	2133	98825652000	15830	8053	3	0	174
124088	2134	98851556000	15830	8053	4	0	148
124089	1679	13986931234000	15831	8054	0	0	37
124090	1397	1348811015000	15831	8054	1	0	9002
124092	2133	98824650000	15831	8054	3	0	175
124093	2134	98850553000	15831	8054	4	0	149
124106	1397	1348801014000	15834	8055	0	0	9003
124107	1679	13219590069000	15834	8055	1	0	39
124108	1679	11929686731000	15834	8055	2	0	40
124110	2132	148950951000	15834	8055	4	0	49
124111	2133	98823648000	15834	8055	5	0	176
124112	2134	98849550000	15834	8055	6	0	150
124113	1397	1348791013000	15835	8056	0	0	9004
124115	1679	10641749167000	15835	8056	2	0	43
124116	1679	9550290958000	15835	8056	3	0	44
124117	2133	98822646000	15835	8056	4	0	177
124118	2134	98848547000	15835	8056	5	0	151
124119	1679	9406305048000	15836	8057	0	0	45
124121	1397	1348771011000	15836	8057	2	0	9006
124122	1397	1348761010000	15836	8057	3	0	9007
124123	1397	1348751009000	15836	8057	4	0	9008
124124	1679	9320471499000	15836	8057	5	0	46
124125	1679	9062482831000	15836	8057	6	0	47
124127	2132	148949950000	15836	8057	8	0	50
124128	2134	98847544000	15836	8057	9	0	152
124129	2134	98846541000	15836	8057	10	0	153
124130	2134	98845538000	15836	8057	11	0	154
124132	2133	98821644000	15836	8057	13	0	178
124133	2133	98820642000	15836	8057	14	0	179
124134	2133	98819640000	15836	8057	15	0	180
124135	2133	98818638000	15836	8057	16	0	181
124141	1397	1348741008000	15839	8058	0	0	9009
124143	2134	98843532000	15839	8058	2	0	156
124155	1397	1348731007000	15843	8059	0	0	9010
124156	2132	148948949000	15843	8059	1	0	51
124157	2133	98816634000	15843	8059	2	0	183
124158	2134	98842529000	15843	8059	3	0	157
124164	2133	98815632000	15845	8060	1	0	184
124165	2134	98841526000	15845	8060	2	0	158
124169	1397	1348711005000	15847	8061	0	0	\N
124170	1397	1348701004000	15847	8061	1	0	\N
124171	1397	1348691003000	15847	8061	2	0	\N
124172	2133	98814630000	15847	8061	3	0	\N
124173	2134	98840523000	15847	8061	4	0	\N
124174	2134	98839520000	15847	8061	5	0	\N
124175	2134	98838517000	15847	8061	6	0	\N
124176	2132	148947948000	15847	8061	7	0	\N
124177	2133	98813628000	15847	8061	8	0	\N
124178	2133	98812626000	15847	8061	9	0	\N
124189	1397	1348711005000	15849	8061	0	0	\N
124190	1397	1348701004000	15849	8061	1	0	\N
124191	1397	1348691003000	15849	8061	2	0	\N
124192	2133	98814630000	15849	8061	3	0	\N
124193	2134	98840523000	15849	8061	4	0	\N
124194	2134	98839520000	15849	8061	5	0	\N
124195	2134	98838517000	15849	8061	6	0	\N
124196	2132	148947948000	15849	8061	7	0	\N
124197	2133	98813628000	15849	8061	8	0	\N
124198	2133	98812626000	15849	8061	9	0	\N
124199	1397	1348711005000	15850	8061	0	0	\N
124200	1397	1348701004000	15850	8061	1	0	\N
124201	1397	1348691003000	15850	8061	2	0	\N
124202	2133	98814630000	15850	8061	3	0	\N
124203	2134	98840523000	15850	8061	4	0	\N
124204	2134	98839520000	15850	8061	5	0	\N
124205	2134	98838517000	15850	8061	6	0	\N
124206	2132	148947948000	15850	8061	7	0	\N
124207	2133	98813628000	15850	8061	8	0	\N
124208	2133	98812626000	15850	8061	9	0	\N
124209	365	66569801000000	15851	8062	0	0	\N
124210	1397	1348681002000	15851	8062	1	0	\N
124211	2133	98811624000	15851	8062	2	0	\N
124212	2134	98837514000	15851	8062	3	0	\N
124217	365	66569801000000	15853	8062	0	0	\N
124218	1397	1348681002000	15853	8062	1	0	\N
124219	2133	98811624000	15853	8062	2	0	\N
124220	2134	98837514000	15853	8062	3	0	\N
124227	1397	1348671001000	15855	8063	0	0	\N
124228	1397	1348661000000	15855	8063	1	0	\N
124229	2132	148946947000	15855	8063	2	0	\N
124230	2134	98836511000	15855	8063	3	0	\N
124231	2134	98835508000	15855	8063	4	0	\N
124232	2133	98810622000	15855	8063	5	0	\N
124236	1397	1348640998000	15857	8065	0	0	\N
124237	2133	98808618000	15857	8065	1	0	\N
124238	2134	98833502000	15857	8065	2	0	\N
124239	1397	1348640998000	15858	8065	0	0	\N
124240	2133	98808618000	15858	8065	1	0	\N
124241	2134	98833502000	15858	8065	2	0	\N
124252	1397	1348630997000	15861	8066	0	0	\N
124253	1397	1348620996000	15861	8066	1	0	\N
124254	2134	98832499000	15861	8066	2	0	\N
124255	2134	98831496000	15861	8066	3	0	\N
124256	2133	98807616000	15861	8066	4	0	\N
124257	2133	98806614000	15861	8066	5	0	\N
124258	2132	148945946000	15861	8066	6	0	\N
124259	365	66619901000000	15862	7978	0	0	\N
124260	365	66569801000000	15862	7978	1	0	\N
124261	1697	401990000000	15862	7978	2	0	\N
124262	1683	27215449399541	15862	7978	3	0	\N
124263	1474	11074422000023	15862	7978	4	0	\N
124264	1677	9557256850100	15862	7978	5	0	\N
124265	1688	98566741076000	15862	7978	6	0	\N
124266	1679	36723797703000	15862	7978	7	0	\N
124267	1679	36539289298000	15862	7978	8	0	\N
124268	1688	98381581771000	15862	7978	9	0	\N
124269	1688	98215602030000	15862	7978	10	0	\N
124270	1679	36195307741000	15862	7978	11	0	\N
124271	1679	33648595836000	15862	7978	12	0	\N
124272	1679	28715239930000	15862	7978	13	0	\N
124273	1688	98145738343000	15862	7978	14	0	\N
124274	1688	97377338454000	15862	7978	15	0	\N
124275	1688	91230333668000	15862	7978	16	0	\N
124276	1688	90671505473000	15862	7978	17	0	\N
124277	1688	84524500687000	15862	7978	18	0	\N
124278	1688	84384783313000	15862	7978	19	0	\N
124279	1688	82847993535000	15862	7978	20	0	\N
124280	1688	82813059821000	15862	7978	21	0	\N
124281	1688	82428889300000	15862	7978	22	0	\N
124282	1688	82393949125000	15862	7978	23	0	\N
124283	1688	82009707529000	15862	7978	24	0	\N
124284	1688	81739367808000	15862	7978	25	0	\N
124285	1688	78765733474000	15862	7978	26	0	\N
124286	1688	74427873273000	15862	7978	27	0	\N
124287	1688	26711552708000	15862	7978	28	0	\N
124288	1679	28171249166000	15862	7978	29	0	\N
124289	1679	27883493729000	15862	7978	30	0	\N
124290	1679	27157937909000	15862	7978	31	0	\N
124291	1679	26155780008000	15862	7978	32	0	\N
124292	1679	25275996603000	15862	7978	33	0	\N
124293	1679	19917968120000	15862	7978	34	0	\N
124294	1679	19344959717000	15862	7978	35	0	\N
124295	1679	13986931234000	15862	7978	36	0	\N
124296	1679	13517267762000	15862	7978	37	0	\N
124297	1679	13219590069000	15862	7978	38	0	\N
124298	1679	11929686731000	15862	7978	39	0	\N
124299	1679	11731231602000	15862	7978	40	0	\N
124300	1679	11138944255000	15862	7978	41	0	\N
124304	1397	1348600994000	15864	8068	0	0	\N
124181	1397	1348691003000	15848	8061	2	0	9014
124182	2133	98814630000	15848	8061	3	0	185
124183	2134	98840523000	15848	8061	4	0	159
124184	2134	98839520000	15848	8061	5	0	160
124185	2134	98838517000	15848	8061	6	0	161
124187	2133	98813628000	15848	8061	8	0	186
124188	2133	98812626000	15848	8061	9	0	187
124213	365	66569801000000	15852	8062	0	0	2
124214	1397	1348681002000	15852	8062	1	0	9015
124215	2133	98811624000	15852	8062	2	0	188
124221	1397	1348671001000	15854	8063	0	0	9016
124222	1397	1348661000000	15854	8063	1	0	9017
124223	2132	148946947000	15854	8063	2	0	53
124224	2134	98836511000	15854	8063	3	0	163
124226	2133	98810622000	15854	8063	5	0	189
124233	1397	1348650999000	15856	8064	0	0	9018
124234	2133	98809620000	15856	8064	1	0	190
124235	2134	98834505000	15856	8064	2	0	165
124242	1397	1348640998000	15859	8065	0	0	9019
124244	2134	98833502000	15859	8065	2	0	166
124245	1397	1348630997000	15860	8066	0	0	9020
124246	1397	1348620996000	15860	8066	1	0	9021
124247	2134	98832499000	15860	8066	2	0	167
124248	2134	98831496000	15860	8066	3	0	168
124250	2133	98806614000	15860	8066	5	0	193
124251	2132	148945946000	15860	8066	6	0	54
124301	1397	1348610995000	15863	8067	0	0	9022
124302	2134	98830493000	15863	8067	1	0	169
124305	2133	98804610000	15864	8068	1	0	\N
124306	2134	98829490000	15864	8068	2	0	\N
124307	2132	148944945000	15864	8068	3	0	\N
124308	1397	1348600994000	15865	8068	0	0	\N
124309	2133	98804610000	15865	8068	1	0	\N
124310	2134	98829490000	15865	8068	2	0	\N
124311	2132	148944945000	15865	8068	3	0	\N
124329	1397	1348560990000	15871	8072	0	0	\N
124330	2133	98800602000	15871	8072	1	0	\N
124331	2132	148943944000	15871	8072	2	0	\N
124332	2134	98825478000	15871	8072	3	0	\N
124336	1397	1348540988000	15873	8074	0	0	\N
124337	2134	98823472000	15873	8074	1	0	\N
124338	1893	208900000	15873	8074	2	0	\N
124339	2133	98798598000	15873	8074	3	0	\N
124348	1397	1348530987000	15876	8075	0	0	\N
124349	2132	148942943000	15876	8075	1	0	\N
124350	2133	98797596000	15876	8075	2	0	\N
124351	2134	98822469000	15876	8075	3	0	\N
124352	1893	208900000	15878	8002	0	0	\N
124353	1893	208900000	15879	8012	0	0	\N
124354	1397	1348520986000	15880	8076	0	0	\N
124358	1397	1348520986000	15883	8076	0	0	\N
124359	2133	98796594000	15883	8076	1	0	\N
124360	2134	98821466000	15883	8076	2	0	\N
124361	1397	1348520986000	15885	8076	0	0	\N
124362	1397	1348510985000	15885	8076	1	0	\N
124363	2133	98796594000	15885	8076	2	0	\N
124364	2134	98821466000	15885	8076	3	0	\N
124365	1893	208900000	15886	8029	0	0	\N
124366	1397	1348510985000	15887	8077	0	0	\N
124367	1397	1348500984000	15887	8077	1	0	\N
124368	2132	148941942000	15887	8077	2	0	\N
124369	2134	98820463000	15887	8077	3	0	\N
124370	2134	98819460000	15887	8077	4	0	\N
124371	2133	98795592000	15887	8077	5	0	\N
124387	1397	1348460980000	15890	8079	0	0	\N
124388	2133	98791584000	15890	8079	1	0	\N
124389	2132	148940941000	15890	8079	2	0	\N
124390	2134	98815448000	15890	8079	3	0	\N
124391	1397	1348460980000	15891	8079	0	0	\N
124392	2133	98791584000	15891	8079	1	0	\N
124393	2132	148940941000	15891	8079	2	0	\N
124394	2134	98815448000	15891	8079	3	0	\N
124417	1397	1348400974000	15897	8083	0	0	\N
124418	2134	98809430000	15897	8083	1	0	\N
124419	2133	98785572000	15897	8083	2	0	\N
124420	1397	1348400974000	15898	8083	0	0	\N
124421	2134	98809430000	15898	8083	1	0	\N
124422	2133	98785572000	15898	8083	2	0	\N
124429	1397	1348370971000	15901	8086	0	0	\N
124430	1397	1348360970000	15901	8086	1	0	\N
124431	2133	98782566000	15901	8086	2	0	\N
124432	2133	98781564000	15901	8086	3	0	\N
124433	2134	98806421000	15901	8086	4	0	\N
124434	2134	98805418000	15901	8086	5	0	\N
124435	1397	1348370971000	15902	8086	0	0	\N
124436	1397	1348360970000	15902	8086	1	0	\N
124437	2133	98782566000	15902	8086	2	0	\N
124438	2133	98781564000	15902	8086	3	0	\N
124439	2134	98806421000	15902	8086	4	0	\N
124440	2134	98805418000	15902	8086	5	0	\N
124314	2134	98829490000	15866	8068	2	0	170
124315	2132	148944945000	15866	8068	3	0	55
124316	1397	1348590993000	15867	8069	0	0	9024
124317	2133	98803608000	15867	8069	1	0	196
124318	2134	98828487000	15867	8069	2	0	171
124320	2133	98802606000	15868	8070	1	0	197
124321	2134	98827484000	15868	8070	2	0	172
124322	1397	1348570991000	15869	8071	0	0	9026
124323	2133	98801604000	15869	8071	1	0	198
124324	2134	98826481000	15869	8071	2	0	173
124326	2133	98800602000	15870	8072	1	0	199
124327	2132	148943944000	15870	8072	2	0	56
124328	2134	98825478000	15870	8072	3	0	174
124333	1397	1348550989000	15872	8073	0	0	9028
124335	2133	98799600000	15872	8073	2	0	200
124340	1397	1348540988000	15874	8074	0	0	9029
124341	2134	98823472000	15874	8074	1	0	176
124342	1893	208900000	15874	8074	2	0	1
124343	2133	98798598000	15874	8074	3	0	201
124345	2132	148942943000	15875	8075	1	0	57
124346	2133	98797596000	15875	8075	2	0	202
124347	2134	98822469000	15875	8075	3	0	177
124355	1397	1348520986000	15881	8076	0	0	9031
124356	2133	98796594000	15881	8076	1	0	203
124372	1397	1348510985000	15888	8077	0	0	9032
124373	1397	1348500984000	15888	8077	1	0	9033
124374	2132	148941942000	15888	8077	2	0	58
124375	2134	98820463000	15888	8077	3	0	179
124377	2133	98795592000	15888	8077	5	0	204
124378	1397	1348490983000	15889	8078	0	0	9034
124379	1397	1348480982000	15889	8078	1	0	9035
124380	1397	1348470981000	15889	8078	2	0	9036
124381	2133	98794590000	15889	8078	3	0	205
124383	2133	98792586000	15889	8078	5	0	207
124384	2134	98818457000	15889	8078	6	0	181
124385	2134	98817454000	15889	8078	7	0	182
124386	2134	98816451000	15889	8078	8	0	183
124395	1397	1348460980000	15892	8079	0	0	9037
124397	2132	148940941000	15892	8079	2	0	59
124398	2134	98815448000	15892	8079	3	0	184
124399	1397	1348450979000	15893	8080	0	0	9038
124400	2133	98790582000	15893	8080	1	0	209
124402	1397	1348440978000	15894	8081	0	0	9039
124403	2134	98813442000	15894	8081	1	0	186
124404	2133	98789580000	15894	8081	2	0	210
124405	1397	1348430977000	15895	8082	0	0	9040
124406	1397	1348420976000	15895	8082	1	0	9041
124408	2134	98812439000	15895	8082	3	0	187
124409	2134	98811436000	15895	8082	4	0	188
124410	2134	98810433000	15895	8082	5	0	189
124411	2133	98788578000	15895	8082	6	0	211
124412	2133	98787576000	15895	8082	7	0	212
124414	1397	1348400974000	15896	8083	0	0	9043
124415	2134	98809430000	15896	8083	1	0	190
124416	2133	98785572000	15896	8083	2	0	214
124423	1397	1348390973000	15899	8084	0	0	9044
124425	2133	98784570000	15899	8084	2	0	215
124426	1397	1348380972000	15900	8085	0	0	9045
124427	2133	98783568000	15900	8085	1	0	216
124428	2134	98807424000	15900	8085	2	0	192
124447	1397	1348350969000	15904	8087	0	0	\N
124448	1397	1348340968000	15904	8087	1	0	\N
124449	2133	98780562000	15904	8087	2	0	\N
124450	2134	98804415000	15904	8087	3	0	\N
124451	2133	98779560000	15904	8087	4	0	\N
124452	2134	98803412000	15904	8087	5	0	\N
124453	1397	1348350969000	15905	8087	0	0	\N
124454	1397	1348340968000	15905	8087	1	0	\N
124455	2133	98780562000	15905	8087	2	0	\N
124456	2134	98804415000	15905	8087	3	0	\N
124457	2133	98779560000	15905	8087	4	0	\N
124458	2134	98803412000	15905	8087	5	0	\N
124465	1397	1348350969000	15907	8087	0	0	\N
124466	1397	1348340968000	15907	8087	1	0	\N
124467	2133	98780562000	15907	8087	2	0	\N
124468	2134	98804415000	15907	8087	3	0	\N
124469	2133	98779560000	15907	8087	4	0	\N
124470	2134	98803412000	15907	8087	5	0	\N
124471	1397	1348330967000	15908	8088	0	0	\N
124472	2133	98778558000	15908	8088	1	0	\N
124475	1397	1348320966000	15910	8089	0	0	\N
124476	2133	98777556000	15910	8089	1	0	\N
124477	2134	98802409000	15910	8089	2	0	\N
124487	1397	1348290963000	15914	8092	0	0	\N
124488	1397	1348280962000	15914	8092	1	0	\N
124489	2133	98774550000	15914	8092	2	0	\N
124490	2134	98799400000	15914	8092	3	0	\N
124491	2134	98798397000	15914	8092	4	0	\N
124492	2133	98773548000	15914	8092	5	0	\N
124499	1397	1348270961000	15916	8093	0	0	\N
124500	1397	1348260960000	15916	8093	1	0	\N
124501	2133	98772546000	15916	8093	2	0	\N
124502	2134	98797394000	15916	8093	3	0	\N
124503	2134	98796391000	15916	8093	4	0	\N
124504	1397	1348270961000	15917	8093	0	0	\N
124505	1397	1348260960000	15917	8093	1	0	\N
124506	2133	98772546000	15917	8093	2	0	\N
124507	2133	98771544000	15917	8093	3	0	\N
124508	2134	98797394000	15917	8093	4	0	\N
124509	2134	98796391000	15917	8093	5	0	\N
124510	1397	1348270961000	15918	8093	0	0	\N
124511	1397	1348260960000	15918	8093	1	0	\N
124512	2133	98772546000	15918	8093	2	0	\N
124513	2133	98771544000	15918	8093	3	0	\N
124514	2134	98797394000	15918	8093	4	0	\N
124515	2134	98796391000	15918	8093	5	0	\N
124525	1397	1348240958000	15921	8095	0	0	\N
124526	2134	98794385000	15921	8095	1	0	\N
124527	2133	98769540000	15921	8095	2	0	\N
124531	1397	1348230957000	15923	8096	0	0	\N
124532	1397	1348220956000	15923	8096	1	0	\N
124533	2133	98768538000	15923	8096	2	0	\N
124534	2133	98767536000	15923	8096	3	0	\N
124535	2134	98793382000	15923	8096	4	0	\N
124536	2134	98792379000	15923	8096	5	0	\N
124546	1397	1348210955000	15926	8097	0	0	\N
124547	2134	98791376000	15926	8097	1	0	\N
124548	2133	98766534000	15926	8097	2	0	\N
124549	1397	1348210955000	15927	8097	0	0	\N
124550	2134	98791376000	15927	8097	1	0	\N
124551	2133	98766534000	15927	8097	2	0	\N
124552	1397	1348200954000	15928	8098	0	0	\N
124553	2134	98790373000	15928	8098	1	0	\N
124565	1397	1348190953000	15931	8099	0	0	\N
124566	1397	1348180952000	15931	8099	1	0	\N
124567	1397	1348170951000	15931	8099	2	0	\N
124568	2134	98789370000	15931	8099	3	0	\N
124569	2134	98788367000	15931	8099	4	0	\N
124570	2133	98765532000	15931	8099	5	0	\N
124571	2133	98764530000	15931	8099	6	0	\N
124572	2133	98763528000	15931	8099	7	0	\N
124573	2134	98787364000	15931	8099	8	0	\N
124574	1397	1348160950000	15932	8100	0	0	\N
124575	2133	98762526000	15932	8100	1	0	\N
124576	2134	98786361000	15932	8100	2	0	\N
124443	2133	98782566000	15903	8086	2	0	217
124444	2133	98781564000	15903	8086	3	0	218
124445	2134	98806421000	15903	8086	4	0	193
124446	2134	98805418000	15903	8086	5	0	194
124459	1397	1348350969000	15906	8087	0	0	9048
124461	2133	98780562000	15906	8087	2	0	219
124462	2134	98804415000	15906	8087	3	0	195
124463	2133	98779560000	15906	8087	4	0	220
124464	2134	98803412000	15906	8087	5	0	196
124473	1397	1348330967000	15909	8088	0	0	9050
124478	1397	1348320966000	15911	8089	0	0	9051
124479	2133	98777556000	15911	8089	1	0	222
124480	2134	98802409000	15911	8089	2	0	197
124481	1397	1348310965000	15912	8090	0	0	9052
124483	2134	98801406000	15912	8090	2	0	198
124484	1397	1348300964000	15913	8091	0	0	9053
124485	2134	98800403000	15913	8091	1	0	199
124486	2133	98775552000	15913	8091	2	0	224
124493	1397	1348290963000	15915	8092	0	0	9054
124495	2133	98774550000	15915	8092	2	0	225
124496	2134	98799400000	15915	8092	3	0	200
124497	2134	98798397000	15915	8092	4	0	201
124498	2133	98773548000	15915	8092	5	0	226
124516	1397	1348270961000	15919	8093	0	0	9056
124518	2133	98772546000	15919	8093	2	0	227
124519	2133	98771544000	15919	8093	3	0	228
124520	2134	98797394000	15919	8093	4	0	202
124521	2134	98796391000	15919	8093	5	0	203
124523	2134	98795388000	15920	8094	1	0	204
124524	2133	98770542000	15920	8094	2	0	229
124528	1397	1348240958000	15922	8095	0	0	9059
124529	2134	98794385000	15922	8095	1	0	205
124530	2133	98769540000	15922	8095	2	0	230
124538	1397	1348220956000	15924	8096	1	0	9061
124539	2133	98768538000	15924	8096	2	0	231
124540	2133	98767536000	15924	8096	3	0	232
124541	2134	98793382000	15924	8096	4	0	206
124542	2134	98792379000	15924	8096	5	0	207
124544	2134	98791376000	15925	8097	1	0	208
124545	2133	98766534000	15925	8097	2	0	233
124554	1397	1348200954000	15929	8098	0	0	9063
124555	2134	98790373000	15929	8098	1	0	209
124557	1397	1348180952000	15930	8099	1	0	9065
124558	1397	1348170951000	15930	8099	2	0	9066
124559	2134	98789370000	15930	8099	3	0	210
124560	2134	98788367000	15930	8099	4	0	211
124561	2133	98765532000	15930	8099	5	0	234
124563	2133	98763528000	15930	8099	7	0	236
124564	2134	98787364000	15930	8099	8	0	212
124577	1397	1348160950000	15933	8100	0	0	\N
124578	2133	98762526000	15933	8100	1	0	\N
124579	2134	98786361000	15933	8100	2	0	\N
124583	1397	1348150949000	15935	8101	0	0	\N
124584	2134	98785358000	15935	8101	1	0	\N
124585	2133	98761524000	15935	8101	2	0	\N
124589	1397	1348140948000	15937	8102	0	0	\N
124590	2134	98784355000	15937	8102	1	0	\N
124591	2133	98760522000	15937	8102	2	0	\N
124595	1397	1348130947000	15939	8103	0	0	\N
124596	2134	98783352000	15939	8103	1	0	\N
124597	2133	98759520000	15939	8103	2	0	\N
124598	1397	1348130947000	15940	8103	0	0	\N
124599	2134	98783352000	15940	8103	1	0	\N
124600	2133	98759520000	15940	8103	2	0	\N
124616	1397	1348080942000	15944	8106	0	0	\N
124617	2134	98778337000	15944	8106	1	0	\N
124618	2133	98754510000	15944	8106	2	0	\N
124625	1397	1348070941000	15947	8107	0	0	\N
124626	2134	98777334000	15947	8107	1	0	\N
124627	2133	98753508000	15947	8107	2	0	\N
124634	1397	1348060940000	15950	8108	0	0	\N
124635	1397	1348050939000	15950	8108	1	0	\N
124636	2133	98752506000	15950	8108	2	0	\N
124637	2133	98751504000	15950	8108	3	0	\N
124638	2134	98776331000	15950	8108	4	0	\N
124639	2134	98775328000	15950	8108	5	0	\N
124649	1397	1348010935000	15954	8112	0	0	\N
124650	2133	98747496000	15954	8112	1	0	\N
124651	2134	98771316000	15954	8112	2	0	\N
124652	1397	1348010935000	15955	8112	0	0	\N
124653	2133	98747496000	15955	8112	1	0	\N
124654	2134	98771316000	15955	8112	2	0	\N
124658	1397	1348000934000	15957	8113	0	0	\N
124659	2133	98746494000	15957	8113	1	0	\N
124660	2134	98770313000	15957	8113	2	0	\N
124664	1397	1348000934000	15959	8113	0	0	\N
124665	2133	98746494000	15959	8113	1	0	\N
124666	2134	98770313000	15959	8113	2	0	\N
124667	1397	1348000934000	15960	8113	0	0	\N
124668	2133	98746494000	15960	8113	1	0	\N
124669	2134	98770313000	15960	8113	2	0	\N
124670	1397	1348000934000	15961	8113	0	0	\N
124671	2133	98746494000	15961	8113	1	0	\N
124672	2134	98770313000	15961	8113	2	0	\N
124673	1397	1347990933000	15962	8114	0	0	\N
124674	1397	1347980932000	15962	8114	1	0	\N
124675	2133	98745492000	15962	8114	2	0	\N
124676	2134	98769310000	15962	8114	3	0	\N
124677	2133	98744490000	15962	8114	4	0	\N
124678	2134	98768307000	15962	8114	5	0	\N
124679	1397	1347990933000	15963	8114	0	0	\N
124680	1397	1347980932000	15963	8114	1	0	\N
124681	2133	98745492000	15963	8114	2	0	\N
124682	2134	98769310000	15963	8114	3	0	\N
124683	2133	98744490000	15963	8114	4	0	\N
124684	2134	98768307000	15963	8114	5	0	\N
124694	1397	1347960930000	15967	8117	0	0	\N
124695	1397	1347950929000	15967	8117	1	0	\N
124696	2133	98742486000	15967	8117	2	0	\N
124697	2133	98741484000	15967	8117	3	0	\N
124698	2134	98766301000	15967	8117	4	0	\N
124699	2134	98765298000	15967	8117	5	0	\N
124700	1397	1347960930000	15968	8117	0	0	\N
124701	1397	1347950929000	15968	8117	1	0	\N
124702	2133	98742486000	15968	8117	2	0	\N
124703	2133	98741484000	15968	8117	3	0	\N
124704	2134	98766301000	15968	8117	4	0	\N
124705	2134	98765298000	15968	8117	5	0	\N
124712	1397	1347960930000	15970	8117	0	0	\N
124582	2134	98786361000	15934	8100	2	0	213
124586	1397	1348150949000	15936	8101	0	0	9068
124587	2134	98785358000	15936	8101	1	0	214
124588	2133	98761524000	15936	8101	2	0	238
124592	1397	1348140948000	15938	8102	0	0	9069
124594	2133	98760522000	15938	8102	2	0	239
124601	1397	1348130947000	15941	8103	0	0	9070
124602	2134	98783352000	15941	8103	1	0	216
124603	2133	98759520000	15941	8103	2	0	240
124604	1397	1348120946000	15942	8104	0	0	9071
124606	2134	98782349000	15942	8104	2	0	217
124607	2133	98758518000	15942	8104	3	0	241
124608	2133	98757516000	15942	8104	4	0	242
124609	2134	98781346000	15942	8104	5	0	218
124611	1397	1348090943000	15943	8105	1	0	9074
124612	2134	98780343000	15943	8105	2	0	219
124613	2134	98779340000	15943	8105	3	0	220
124614	2133	98756514000	15943	8105	4	0	243
124615	2133	98755512000	15943	8105	5	0	244
124620	2134	98778337000	15945	8106	1	0	221
124621	2133	98754510000	15945	8106	2	0	245
124622	1397	1348070941000	15946	8107	0	0	9076
124623	2134	98777334000	15946	8107	1	0	222
124624	2133	98753508000	15946	8107	2	0	246
124629	1397	1348050939000	15949	8108	1	0	9078
124630	2133	98752506000	15949	8108	2	0	247
124631	2133	98751504000	15949	8108	3	0	248
124632	2134	98776331000	15949	8108	4	0	223
124640	1397	1348040938000	15951	8109	0	0	9079
124641	2133	98750502000	15951	8109	1	0	249
124642	2134	98774325000	15951	8109	2	0	225
124643	1397	1348030937000	15952	8110	0	0	9080
124644	2134	98773322000	15952	8110	1	0	226
124646	1397	1348020936000	15953	8111	0	0	9081
124647	2134	98772319000	15953	8111	1	0	227
124648	2133	98748498000	15953	8111	2	0	251
124655	1397	1348010935000	15956	8112	0	0	9082
124656	2133	98747496000	15956	8112	1	0	252
124661	1397	1348000934000	15958	8113	0	0	9083
124662	2133	98746494000	15958	8113	1	0	253
124663	2134	98770313000	15958	8113	2	0	229
124685	1397	1347990933000	15964	8114	0	0	9084
124687	2133	98745492000	15964	8114	2	0	254
124688	2134	98769310000	15964	8114	3	0	230
124689	2133	98744490000	15964	8114	4	0	255
124690	2134	98768307000	15964	8114	5	0	231
124691	1397	1347970931000	15965	8115	0	0	9086
124693	2133	98743488000	15965	8115	2	0	256
124706	1397	1347960930000	15969	8117	0	0	9087
124707	1397	1347950929000	15969	8117	1	0	9088
124708	2133	98742486000	15969	8117	2	0	257
124709	2133	98741484000	15969	8117	3	0	258
124711	2134	98765298000	15969	8117	5	0	234
124713	1397	1347950929000	15970	8117	1	0	\N
124714	2133	98742486000	15970	8117	2	0	\N
124715	2133	98741484000	15970	8117	3	0	\N
124716	2134	98766301000	15970	8117	4	0	\N
124717	2134	98765298000	15970	8117	5	0	\N
124718	1397	1347960930000	15971	8117	0	0	\N
124719	1397	1347950929000	15971	8117	1	0	\N
124720	2133	98742486000	15971	8117	2	0	\N
124721	2133	98741484000	15971	8117	3	0	\N
124722	2134	98766301000	15971	8117	4	0	\N
124723	2134	98765298000	15971	8117	5	0	\N
124733	1397	1347920926000	15975	8120	0	0	\N
124734	2134	98762289000	15975	8120	1	0	\N
124735	2133	98738478000	15975	8120	2	0	\N
124736	365	66569801000000	15976	8047	0	0	\N
124737	1893	208900000	15976	8047	1	0	\N
124757	1397	1347860920000	15979	8122	0	0	\N
124758	2133	98732466000	15979	8122	1	0	\N
124759	2134	98756271000	15979	8122	2	0	\N
124760	1397	1347860920000	15980	8122	0	0	\N
124761	2133	98732466000	15980	8122	1	0	\N
124762	2134	98756271000	15980	8122	2	0	\N
124775	1397	1347810915000	15984	8126	0	0	\N
124776	2133	98727456000	15984	8126	1	0	\N
124777	2134	98751256000	15984	8126	2	0	\N
124781	1397	1347810915000	15986	8126	0	0	\N
124782	2133	98727456000	15986	8126	1	0	\N
124783	2134	98751256000	15986	8126	2	0	\N
124790	1397	1347780912000	15988	8128	0	0	\N
124791	2134	98748247000	15988	8128	1	0	\N
124792	2133	98724450000	15988	8128	2	0	\N
124793	1397	1347780912000	15989	8128	0	0	\N
124794	2134	98748247000	15989	8128	1	0	\N
124795	2133	98724450000	15989	8128	2	0	\N
124808	1397	1347750909000	15994	8131	0	0	\N
124809	2134	98745238000	15994	8131	1	0	\N
124810	2133	98721444000	15994	8131	2	0	\N
124830	1397	1347710905000	15999	8135	0	0	\N
124831	1397	1347700904000	15999	8135	1	0	\N
124832	1397	1347690903000	15999	8135	2	0	\N
124833	1726	139855109000	15999	8135	3	0	\N
124834	2133	98717436000	15999	8135	4	0	\N
124835	2133	98716434000	15999	8135	5	0	\N
124836	2133	98715432000	15999	8135	6	0	\N
124837	2134	98741226000	15999	8135	7	0	\N
124838	2132	148939940000	15999	8135	8	0	\N
124839	2134	98740223000	15999	8135	9	0	\N
124726	2133	98740482000	15972	8118	2	0	259
124727	1397	1347930927000	15973	8119	0	0	9090
124728	2134	98763292000	15973	8119	1	0	236
124729	2133	98739480000	15973	8119	2	0	260
124730	1397	1347920926000	15974	8120	0	0	9091
124732	2133	98738478000	15974	8120	2	0	261
124738	1397	1347910925000	15977	8121	0	0	9092
124739	1397	1347900924000	15977	8121	1	0	9093
124740	1397	1347890923000	15977	8121	2	0	9094
124741	1397	1347880922000	15977	8121	3	0	9095
124743	2134	98761286000	15977	8121	5	0	238
124744	112	66001941005524	15977	8121	6	0	5
124745	2134	98760283000	15977	8121	7	0	239
124746	2134	98759280000	15977	8121	8	0	240
124748	2134	98757274000	15977	8121	10	0	242
124749	2133	98737476000	15977	8121	11	0	262
124750	2133	98736474000	15977	8121	12	0	263
124751	2133	98735472000	15977	8121	13	0	264
124752	2133	98734470000	15977	8121	14	0	265
124754	1397	1347860920000	15978	8122	0	0	9097
124755	2133	98732466000	15978	8122	1	0	267
124756	2134	98756271000	15978	8122	2	0	243
124763	1397	1347850919000	15981	8123	0	0	9098
124764	2134	98755268000	15981	8123	1	0	244
124766	1397	1347840918000	15982	8124	0	0	9099
124767	1397	1347830917000	15982	8124	1	0	9100
124768	2134	98754265000	15982	8124	2	0	245
124769	2133	98730462000	15982	8124	3	0	269
124771	2134	98753262000	15982	8124	5	0	246
124772	1397	1347820916000	15983	8125	0	0	9101
124773	2133	98728458000	15983	8125	1	0	271
124774	2134	98752259000	15983	8125	2	0	247
124778	1397	1347810915000	15985	8126	0	0	9102
124780	2134	98751256000	15985	8126	2	0	248
124784	1397	1347800914000	15987	8127	0	0	9103
124785	1397	1347790913000	15987	8127	1	0	9104
124786	2134	98750253000	15987	8127	2	0	249
124787	2134	98749250000	15987	8127	3	0	250
124789	2133	98725452000	15987	8127	5	0	274
124796	1397	1347780912000	15990	8128	0	0	9105
124797	2134	98748247000	15990	8128	1	0	251
124798	2133	98724450000	15990	8128	2	0	275
124800	2134	98747244000	15991	8129	1	0	252
124801	2133	98723448000	15991	8129	2	0	276
124802	1397	1347760910000	15992	8130	0	0	9107
124803	2134	98746241000	15992	8130	2	0	253
124804	2133	98722446000	15992	8130	3	0	277
124806	2134	98745238000	15993	8131	1	0	254
124807	2133	98721444000	15993	8131	2	0	278
124811	1397	1347740908000	15995	8132	0	0	9109
124812	2134	98744235000	15995	8132	1	0	255
124813	2133	98720442000	15995	8132	2	0	279
124815	2134	98743232000	15996	8133	1	0	256
124816	2133	98719440000	15996	8133	2	0	280
124817	1397	1347720906000	15997	8134	0	0	9111
124818	2134	98742229000	15997	8134	1	0	257
124820	1397	1347710905000	15998	8135	0	0	9112
124821	1397	1347700904000	15998	8135	1	0	9113
124822	1397	1347690903000	15998	8135	2	0	9114
124823	1726	139855109000	15998	8135	3	0	8170
124824	2133	98717436000	15998	8135	4	0	282
124826	2133	98715432000	15998	8135	6	0	284
124827	2134	98741226000	15998	8135	7	0	258
124828	2132	148939940000	15998	8135	8	0	60
124829	2134	98740223000	15998	8135	9	0	259
124840	1397	1347680902000	16000	8136	0	0	9115
124842	1397	1347660900000	16000	8136	2	0	9117
124843	2132	148938939000	16000	8136	3	0	61
124844	2134	98739220000	16000	8136	4	0	260
124845	2134	98738217000	16000	8136	5	0	261
124847	2133	98714430000	16000	8136	7	0	285
124848	2133	98713428000	16000	8136	8	0	286
124852	1397	1347650899000	16002	8137	0	0	\N
124853	2133	98712426000	16002	8137	1	0	\N
124854	2134	98736211000	16002	8137	2	0	\N
124869	1397	1347630897000	16005	8139	0	0	\N
124870	1397	1347620896000	16005	8139	1	0	\N
124871	1397	1347610895000	16005	8139	2	0	\N
124872	2132	148936937000	16005	8139	3	0	\N
124873	2134	98734205000	16005	8139	4	0	\N
124874	2134	98733202000	16005	8139	5	0	\N
124875	2133	98710422000	16005	8139	6	0	\N
124876	2133	98709420000	16005	8139	7	0	\N
124877	2134	98732199000	16005	8139	8	0	\N
124878	2133	98708418000	16005	8139	9	0	\N
124898	1397	1347590893000	16008	8141	0	0	\N
124899	1397	1347580892000	16008	8141	1	0	\N
124900	1397	1347570891000	16008	8141	2	0	\N
124901	1397	1347560890000	16008	8141	3	0	\N
124902	1397	1347550889000	16008	8141	4	0	\N
124903	2134	98730193000	16008	8141	5	0	\N
124904	2134	98729190000	16008	8141	6	0	\N
124905	2134	98728187000	16008	8141	7	0	\N
124906	2133	98706414000	16008	8141	8	0	\N
124907	2133	98705412000	16008	8141	9	0	\N
124908	2133	98704410000	16008	8141	10	0	\N
124909	2133	98703408000	16008	8141	11	0	\N
124910	2133	98702406000	16008	8141	12	0	\N
124911	2132	148935936000	16008	8141	13	0	\N
124912	2134	98727184000	16008	8141	14	0	\N
124913	2134	98726181000	16008	8141	15	0	\N
124914	1397	1347590893000	16009	8141	0	0	\N
124915	1397	1347580892000	16009	8141	1	0	\N
124916	1397	1347570891000	16009	8141	2	0	\N
124917	1397	1347560890000	16009	8141	3	0	\N
124918	1397	1347550889000	16009	8141	4	0	\N
124919	2134	98730193000	16009	8141	5	0	\N
124920	2134	98729190000	16009	8141	6	0	\N
124921	2134	98728187000	16009	8141	7	0	\N
124922	2133	98706414000	16009	8141	8	0	\N
124923	2133	98705412000	16009	8141	9	0	\N
124924	2133	98704410000	16009	8141	10	0	\N
124925	2133	98703408000	16009	8141	11	0	\N
124926	2133	98702406000	16009	8141	12	0	\N
124927	2132	148935936000	16009	8141	13	0	\N
124928	2134	98727184000	16009	8141	14	0	\N
124929	2134	98726181000	16009	8141	15	0	\N
124930	1397	1347540888000	16010	8142	0	0	\N
124931	2134	98725178000	16010	8142	1	0	\N
124932	2133	98701404000	16010	8142	2	0	\N
124933	2132	148934935000	16010	8142	3	0	\N
124938	1397	1347540888000	16012	8142	0	0	\N
124939	2134	98725178000	16012	8142	1	0	\N
124940	2133	98701404000	16012	8142	2	0	\N
124941	2132	148934935000	16012	8142	3	0	\N
124942	1397	1347540888000	16013	8142	0	0	\N
124943	2134	98725178000	16013	8142	1	0	\N
124944	2133	98701404000	16013	8142	2	0	\N
124945	2132	148934935000	16013	8142	3	0	\N
124946	1397	1347530887000	16014	8143	0	0	\N
124947	2134	98724175000	16014	8143	1	0	\N
124948	2133	98700402000	16014	8143	2	0	\N
124949	1397	1347530887000	16015	8143	0	0	\N
124950	2134	98724175000	16015	8143	1	0	\N
124951	2133	98700402000	16015	8143	2	0	\N
124955	1397	1347520886000	16017	8144	0	0	\N
124956	2134	98723172000	16017	8144	1	0	\N
124957	2133	98699400000	16017	8144	2	0	\N
124961	1397	1347520886000	16019	8144	0	0	\N
124962	2134	98723172000	16019	8144	1	0	\N
124963	2133	98699400000	16019	8144	2	0	\N
124978	1397	1347480882000	16024	8148	0	0	\N
124979	2133	98695392000	16024	8148	1	0	\N
124980	2132	148932933000	16024	8148	3	0	\N
124981	2134	98719160000	16024	8148	4	0	\N
124982	1397	1347480882000	16025	8148	0	0	\N
124983	2133	98695392000	16025	8148	1	0	\N
124984	2132	148932933000	16025	8148	3	0	\N
124851	2134	98736211000	16001	8137	2	0	263
124855	1397	1347640898000	16003	8138	0	0	9119
124856	2134	98735208000	16003	8138	1	0	264
124857	2132	148937938000	16003	8138	2	0	62
124858	2133	98711424000	16003	8138	3	0	288
124860	1397	1347620896000	16004	8139	1	0	9121
124861	1397	1347610895000	16004	8139	2	0	9122
124862	2132	148936937000	16004	8139	3	0	63
124863	2134	98734205000	16004	8139	4	0	265
124864	2134	98733202000	16004	8139	5	0	266
124866	2133	98709420000	16004	8139	7	0	290
124867	2134	98732199000	16004	8139	8	0	267
124868	2133	98708418000	16004	8139	9	0	291
124879	1397	1347600894000	16006	8140	0	0	9123
124881	2134	98731196000	16006	8140	2	0	268
124882	1397	1347590893000	16007	8141	0	0	9124
124883	1397	1347580892000	16007	8141	1	0	9125
124884	1397	1347570891000	16007	8141	2	0	9126
124885	1397	1347560890000	16007	8141	3	0	9127
124887	2134	98730193000	16007	8141	5	0	269
124888	2134	98729190000	16007	8141	6	0	270
124889	2134	98728187000	16007	8141	7	0	271
124890	2133	98706414000	16007	8141	8	0	293
124891	2133	98705412000	16007	8141	9	0	294
124893	2133	98703408000	16007	8141	11	0	296
124894	2133	98702406000	16007	8141	12	0	297
124895	2132	148935936000	16007	8141	13	0	64
124896	2134	98727184000	16007	8141	14	0	272
124934	1397	1347540888000	16011	8142	0	0	9129
124935	2134	98725178000	16011	8142	1	0	274
124936	2133	98701404000	16011	8142	2	0	298
124937	2132	148934935000	16011	8142	3	0	65
124952	1397	1347530887000	16016	8143	0	0	9130
124954	2133	98700402000	16016	8143	2	0	299
124958	1397	1347520886000	16018	8144	0	0	9131
124959	2134	98723172000	16018	8144	1	0	276
124960	2133	98699400000	16018	8144	2	0	300
124964	1397	1347510885000	16020	8145	0	0	9132
124966	2134	98722169000	16020	8145	2	0	277
124967	2133	98698398000	16020	8145	3	0	301
124968	1397	1347500884000	16021	8146	0	0	9133
124969	2133	98697396000	16021	8146	1	0	302
124971	1397	1347490883000	16022	8147	0	0	9134
124972	2133	98696394000	16022	8147	1	0	303
124973	2134	98720163000	16022	8147	2	0	279
124974	1397	1347480882000	16023	8148	0	0	9135
124975	2133	98695392000	16023	8148	1	0	304
124977	2134	98719160000	16023	8148	4	0	280
124985	2134	98719160000	16025	8148	4	0	\N
124986	1397	1347470881000	16026	8149	0	0	\N
124987	1397	1347460880000	16026	8149	1	0	\N
124988	1397	1347450879000	16026	8149	2	0	\N
124989	2133	98694390000	16026	8149	3	0	\N
124990	2134	98718157000	16026	8149	4	0	\N
124991	2133	98693388000	16026	8149	5	0	\N
124992	2133	98692386000	16026	8149	6	0	\N
124993	2134	98717154000	16026	8149	7	0	\N
124994	2134	98716151000	16026	8149	8	0	\N
125008	1397	1347430877000	16029	8151	0	0	\N
125009	2133	98690382000	16029	8151	1	0	\N
125010	2134	98714145000	16029	8151	2	0	\N
125024	1397	1347390873000	16034	8154	0	0	\N
125025	1397	1347380872000	16034	8154	1	0	\N
125026	2133	98686374000	16034	8154	2	0	\N
125027	2134	98710133000	16034	8154	3	0	\N
125028	2132	148929930000	16034	8154	4	0	\N
125029	2133	98685372000	16034	8154	5	0	\N
125030	2134	98709130000	16034	8154	6	0	\N
125038	1397	1347370871000	16036	8155	0	0	\N
125039	1397	1347360870000	16036	8155	1	0	\N
125040	2134	98708127000	16036	8155	2	0	\N
125041	2134	98707124000	16036	8155	3	0	\N
125051	1397	1347340868000	16039	8157	0	0	\N
125052	2134	98705118000	16039	8157	1	0	\N
125053	2132	148928929000	16039	8157	2	0	\N
125054	2133	98681364000	16039	8157	3	0	\N
125059	1397	1347340868000	16041	8157	0	0	\N
125060	2134	98705118000	16041	8157	1	0	\N
125061	2132	148928929000	16041	8157	2	0	\N
125062	2133	98681364000	16041	8157	3	0	\N
125063	1397	1347340868000	16042	8157	0	0	\N
125064	2134	98705118000	16042	8157	1	0	\N
125065	2132	148928929000	16042	8157	2	0	\N
125066	2133	98681364000	16042	8157	3	0	\N
125077	1397	1347310865000	16046	8160	0	0	\N
125078	2134	98702109000	16046	8160	1	0	\N
125079	2133	98678358000	16046	8160	2	0	\N
125080	2132	148927928000	16046	8160	3	0	\N
125087	1397	1347290863000	16049	8162	0	0	\N
125088	2133	98676354000	16049	8162	1	0	\N
125089	2134	98700103000	16049	8162	2	0	\N
125103	1397	1347260860000	16053	8165	0	0	\N
125104	1397	1347250859000	16053	8165	1	0	\N
125105	2134	98697094000	16053	8165	2	0	\N
125106	2134	98696091000	16053	8165	3	0	\N
125107	2133	98673348000	16053	8165	4	0	\N
125108	2133	98672346000	16053	8165	5	0	\N
125109	1397	1348320966000	16054	8089	0	0	\N
125110	1397	1348310965000	16054	8089	1	0	\N
125111	1397	1348300964000	16054	8089	2	0	\N
125112	1397	1348290963000	16054	8089	3	0	\N
125113	1397	1348280962000	16054	8089	4	0	\N
125114	1397	1348270961000	16054	8089	5	0	\N
125115	1397	1348260960000	16054	8089	6	0	\N
125116	1397	1348250959000	16054	8089	7	0	\N
125117	1726	139855109000	16054	8089	8	0	\N
125118	1397	1348240958000	16054	8089	9	0	\N
125119	1397	1348230957000	16054	8089	10	0	\N
125120	1397	1348220956000	16054	8089	11	0	\N
124997	1397	1347450879000	16027	8149	2	0	9138
124998	2133	98694390000	16027	8149	3	0	305
124999	2134	98718157000	16027	8149	4	0	281
125000	2133	98693388000	16027	8149	5	0	306
125001	2133	98692386000	16027	8149	6	0	307
125003	2134	98716151000	16027	8149	8	0	283
125004	1397	1347440878000	16028	8150	0	0	9139
125005	2133	98691384000	16028	8150	1	0	308
125006	2134	98715148000	16028	8150	2	0	284
125007	2132	148931932000	16028	8150	3	0	68
125012	2133	98690382000	16030	8151	1	0	309
125013	2134	98714145000	16030	8151	2	0	285
125014	1397	1347420876000	16031	8152	0	0	9141
125015	1397	1347410875000	16031	8152	1	0	9142
125017	2133	98689380000	16031	8152	3	0	310
125018	2133	98688378000	16031	8152	4	0	311
125019	2134	98713142000	16031	8152	5	0	286
125020	2134	98712139000	16031	8152	6	0	287
125021	1397	1347400874000	16033	8153	0	0	9143
125023	2134	98711136000	16033	8153	2	0	288
125031	1397	1347390873000	16035	8154	0	0	9144
125032	1397	1347380872000	16035	8154	1	0	9145
125033	2133	98686374000	16035	8154	2	0	313
125034	2134	98710133000	16035	8154	3	0	289
125036	2133	98685372000	16035	8154	5	0	314
125037	2134	98709130000	16035	8154	6	0	290
125042	1397	1347370871000	16037	8155	0	0	9146
125043	1397	1347360870000	16037	8155	1	0	9147
125045	2134	98708127000	16037	8155	3	0	291
125046	2133	98683368000	16037	8155	4	0	316
125047	2134	98707124000	16037	8155	5	0	292
125048	1397	1347350869000	16038	8156	0	0	9148
125049	2133	98682366000	16038	8156	1	0	317
125055	1397	1347340868000	16040	8157	0	0	9149
125056	2134	98705118000	16040	8157	1	0	294
125057	2132	148928929000	16040	8157	2	0	71
125058	2133	98681364000	16040	8157	3	0	318
125067	1397	1347330867000	16043	8158	0	0	9150
125069	2134	98704115000	16043	8158	2	0	295
125070	1397	1347320866000	16044	8159	0	0	9151
125071	2133	98679360000	16044	8159	1	0	320
125072	2134	98703112000	16044	8159	2	0	296
125074	2134	98702109000	16045	8160	1	0	297
125075	2133	98678358000	16045	8160	2	0	321
125076	2132	148927928000	16045	8160	3	0	72
125081	1397	1347300864000	16047	8161	0	0	9153
125082	2134	98701106000	16047	8161	1	0	298
125084	1397	1347290863000	16048	8162	0	0	9154
125085	2133	98676354000	16048	8162	1	0	323
125086	2134	98700103000	16048	8162	2	0	299
125090	1397	1347280862000	16050	8163	0	0	9155
125091	2133	98675352000	16050	8163	1	0	324
125093	2132	148926927000	16050	8163	3	0	73
125094	1397	1347270861000	16051	8164	0	0	9156
125095	2133	98674350000	16051	8164	1	0	325
125096	2134	98698097000	16051	8164	2	0	301
125098	1397	1347250859000	16052	8165	1	0	9158
125099	2134	98697094000	16052	8165	2	0	302
125100	2134	98696091000	16052	8165	3	0	303
125101	2133	98673348000	16052	8165	4	0	326
125102	2133	98672346000	16052	8165	5	0	327
125121	1397	1348210955000	16054	8089	12	0	\N
125122	1397	1348200954000	16054	8089	13	0	\N
125123	1397	1348190953000	16054	8089	14	0	\N
125124	1397	1348180952000	16054	8089	15	0	\N
125125	1397	1348170951000	16054	8089	16	0	\N
125126	1397	1348160950000	16054	8089	17	0	\N
125127	1397	1348150949000	16054	8089	18	0	\N
125128	1397	1348140948000	16054	8089	19	0	\N
125129	1397	1348130947000	16054	8089	20	0	\N
125130	1397	1348120946000	16054	8089	21	0	\N
125131	1397	1348110945000	16054	8089	22	0	\N
125132	1397	1348100944000	16054	8089	23	0	\N
125133	1397	1348090943000	16054	8089	24	0	\N
125134	1397	1348080942000	16054	8089	25	0	\N
125135	1397	1348070941000	16054	8089	26	0	\N
125136	1397	1348060940000	16054	8089	27	0	\N
125137	1397	1348050939000	16054	8089	28	0	\N
125138	1397	1348040938000	16054	8089	29	0	\N
125139	1397	1348030937000	16054	8089	30	0	\N
125140	1397	1348020936000	16054	8089	31	0	\N
125141	1397	1348010935000	16054	8089	32	0	\N
125142	1397	1348000934000	16054	8089	33	0	\N
125143	1397	1347990933000	16054	8089	34	0	\N
125144	1397	1347980932000	16054	8089	35	0	\N
125145	1397	1347970931000	16054	8089	36	0	\N
125146	1397	1347960930000	16054	8089	37	0	\N
125147	1397	1347950929000	16054	8089	38	0	\N
125148	1397	1347940928000	16054	8089	39	0	\N
125149	1397	1347930927000	16054	8089	40	0	\N
125150	1397	1347920926000	16054	8089	41	0	\N
125151	1397	1347910925000	16054	8089	42	0	\N
125152	1397	1347900924000	16054	8089	43	0	\N
125153	1397	1347890923000	16054	8089	44	0	\N
125154	1397	1347880922000	16054	8089	45	0	\N
125155	1397	1347870921000	16054	8089	46	0	\N
125156	1397	1347860920000	16054	8089	47	0	\N
125157	1397	1347850919000	16054	8089	48	0	\N
125158	1397	1347840918000	16054	8089	49	0	\N
125159	1397	1347830917000	16054	8089	50	0	\N
125160	1397	1347820916000	16054	8089	51	0	\N
125161	1397	1347810915000	16054	8089	52	0	\N
125162	1397	1347800914000	16054	8089	53	0	\N
125163	1397	1347790913000	16054	8089	54	0	\N
125164	1397	1347780912000	16054	8089	55	0	\N
125165	1397	1347770911000	16054	8089	56	0	\N
125166	1397	1347760910000	16054	8089	57	0	\N
125167	1397	1347750909000	16054	8089	58	0	\N
125168	1397	1347740908000	16054	8089	59	0	\N
125169	1397	1347730907000	16054	8089	60	0	\N
125170	1397	1347720906000	16054	8089	61	0	\N
125171	1397	1347710905000	16054	8089	62	0	\N
125172	1397	1347700904000	16054	8089	63	0	\N
125173	1397	1347690903000	16054	8089	64	0	\N
125174	1397	1347680902000	16054	8089	65	0	\N
125175	1397	1347670901000	16054	8089	66	0	\N
125176	1397	1347660900000	16054	8089	67	0	\N
125177	1397	1347650899000	16054	8089	68	0	\N
125178	1397	1347640898000	16054	8089	69	0	\N
125179	1397	1347630897000	16054	8089	70	0	\N
125180	1397	1347620896000	16054	8089	71	0	\N
125181	1397	1347610895000	16054	8089	72	0	\N
125182	1397	1347600894000	16054	8089	73	0	\N
125183	1397	1347590893000	16054	8089	74	0	\N
125184	1397	1347580892000	16054	8089	75	0	\N
125185	1397	1347570891000	16054	8089	76	0	\N
125186	1397	1347560890000	16054	8089	77	0	\N
125187	1397	1347550889000	16054	8089	78	0	\N
125188	1397	1347540888000	16054	8089	79	0	\N
125189	1397	1347530887000	16054	8089	80	0	\N
125190	1397	1347520886000	16054	8089	81	0	\N
125191	1397	1347510885000	16054	8089	82	0	\N
125192	1397	1347500884000	16054	8089	83	0	\N
125193	1397	1347490883000	16054	8089	84	0	\N
125194	1397	1347480882000	16054	8089	85	0	\N
125195	1397	1347470881000	16054	8089	86	0	\N
125196	1397	1347460880000	16054	8089	87	0	\N
125197	1397	1347450879000	16054	8089	88	0	\N
125198	1397	1347440878000	16054	8089	89	0	\N
125199	1397	1347430877000	16054	8089	90	0	\N
125200	1397	1347420876000	16054	8089	91	0	\N
125201	1397	1347410875000	16054	8089	92	0	\N
125202	1397	1347400874000	16054	8089	93	0	\N
125203	1397	1347390873000	16054	8089	94	0	\N
125204	1397	1347380872000	16054	8089	95	0	\N
125205	1397	1347370871000	16054	8089	96	0	\N
125206	1397	1347360870000	16054	8089	97	0	\N
125207	1397	1347350869000	16054	8089	98	0	\N
125208	1397	1347340868000	16054	8089	99	0	\N
125209	1397	1347330867000	16054	8089	100	0	\N
125210	1397	1347320866000	16054	8089	101	0	\N
125211	1397	1347310865000	16054	8089	102	0	\N
125212	1397	1347300864000	16054	8089	103	0	\N
125213	1397	1347290863000	16054	8089	104	0	\N
125214	1397	1347280862000	16054	8089	105	0	\N
125215	1397	1347270861000	16054	8089	106	0	\N
125216	1397	1347260860000	16054	8089	107	0	\N
125217	1397	1347250859000	16054	8089	108	0	\N
125218	2133	98777556000	16054	8089	109	0	\N
125219	2134	98802409000	16054	8089	110	0	\N
125220	112	66001941005524	16054	8089	111	0	\N
125221	2133	98776554000	16054	8089	112	0	\N
125222	2133	98775552000	16054	8089	113	0	\N
125223	2132	148939940000	16054	8089	114	0	\N
125224	2134	98801406000	16054	8089	115	0	\N
125225	2134	98800403000	16054	8089	116	0	\N
125226	1397	1347240858000	16055	8166	0	0	\N
125227	2133	98671344000	16055	8166	1	0	\N
125228	2132	148925926000	16055	8166	2	0	\N
125229	2134	98695088000	16055	8166	3	0	\N
125241	1397	1347230857000	16058	8167	0	0	\N
125242	1397	1347220856000	16058	8167	1	0	\N
125243	1749	5945222000000	16058	8167	2	0	\N
125244	2133	98670342000	16058	8167	3	0	\N
125245	2133	98669340000	16058	8167	4	0	\N
125246	2134	98694085000	16058	8167	5	0	\N
125247	2134	98693082000	16058	8167	6	0	\N
125248	1397	1347210855000	16059	8168	0	0	\N
125249	2134	98692079000	16059	8168	1	0	\N
125250	2133	98668338000	16059	8168	2	0	\N
125251	2132	148924925000	16059	8168	3	0	\N
125252	1397	1347210855000	16060	8168	0	0	\N
125253	2134	98692079000	16060	8168	1	0	\N
125254	2133	98668338000	16060	8168	2	0	\N
125255	2132	148924925000	16060	8168	3	0	\N
125232	2132	148925926000	16056	8166	2	0	74
125233	2134	98695088000	16056	8166	3	0	304
125234	1397	1347230857000	16057	8167	0	0	9160
125235	1397	1347220856000	16057	8167	1	0	9161
125236	1749	5945222000000	16057	8167	2	0	16
125238	2133	98669340000	16057	8167	4	0	330
125239	2134	98694085000	16057	8167	5	0	305
125240	2134	98693082000	16057	8167	6	0	306
125256	1397	1347210855000	16061	8168	0	0	9162
125260	1397	1347210855000	16062	8168	0	0	\N
125261	2134	98692079000	16062	8168	1	0	\N
125262	2133	98668338000	16062	8168	2	0	\N
125263	2132	148924925000	16062	8168	3	0	\N
125264	1397	1347210855000	16063	8168	0	0	\N
125265	2134	98692079000	16063	8168	1	0	\N
125266	2133	98668338000	16063	8168	2	0	\N
125267	2132	148924925000	16063	8168	3	0	\N
125268	1397	1347200854000	16064	8169	0	0	\N
125269	1397	1347190853000	16064	8169	1	0	\N
125270	2134	98691076000	16064	8169	2	0	\N
125271	2134	98690073000	16064	8169	3	0	\N
125278	1397	1347180852000	16066	8170	0	0	\N
125279	2134	98689070000	16066	8170	1	0	\N
125280	2133	98665332000	16066	8170	2	0	\N
125281	2132	148923924000	16066	8170	3	0	\N
125286	1397	1347180852000	16068	8170	0	0	\N
125287	2134	98689070000	16068	8170	1	0	\N
125288	2133	98667336000	16068	8170	2	0	\N
125289	2133	98666334000	16068	8170	3	0	\N
125290	2133	98665332000	16068	8170	4	0	\N
125291	2132	148923924000	16068	8170	5	0	\N
125299	1397	1347150849000	16070	8172	0	0	\N
125300	1397	1347140848000	16070	8172	1	0	\N
125301	2133	98662326000	16070	8172	2	0	\N
125302	2132	148922923000	16070	8172	3	0	\N
125303	2134	98686061000	16070	8172	4	0	\N
125304	2134	98685058000	16070	8172	5	0	\N
125305	2133	98661324000	16070	8172	6	0	\N
125306	1397	1347150849000	16071	8172	0	0	\N
125307	1397	1347140848000	16071	8172	1	0	\N
125308	2133	98662326000	16071	8172	2	0	\N
125309	2132	148922923000	16071	8172	3	0	\N
125310	2134	98686061000	16071	8172	4	0	\N
125311	2134	98685058000	16071	8172	5	0	\N
125312	2133	98661324000	16071	8172	6	0	\N
125313	1397	1347150849000	16072	8172	0	0	\N
125314	1397	1347140848000	16072	8172	1	0	\N
125315	2133	98662326000	16072	8172	2	0	\N
125316	2132	148922923000	16072	8172	3	0	\N
125317	2134	98686061000	16072	8172	4	0	\N
125318	2134	98685058000	16072	8172	5	0	\N
125319	2133	98661324000	16072	8172	6	0	\N
125327	1397	1347150849000	16074	8172	0	0	\N
125328	1397	1347140848000	16074	8172	1	0	\N
125329	2133	98662326000	16074	8172	2	0	\N
125330	2132	148922923000	16074	8172	3	0	\N
125331	2134	98686061000	16074	8172	4	0	\N
125332	2134	98685058000	16074	8172	5	0	\N
125333	2133	98661324000	16074	8172	6	0	\N
125334	1397	1347150849000	16075	8172	0	0	\N
125335	1397	1347140848000	16075	8172	1	0	\N
125336	2133	98662326000	16075	8172	2	0	\N
125337	2132	148922923000	16075	8172	3	0	\N
125338	2134	98686061000	16075	8172	4	0	\N
125339	2134	98685058000	16075	8172	5	0	\N
125340	2133	98661324000	16075	8172	6	0	\N
125343	1397	1347130847000	16078	8173	0	0	\N
125344	1397	1347120846000	16079	8174	0	0	\N
125345	2134	98683052000	16079	8174	1	0	\N
125346	2133	98660322000	16079	8174	2	0	\N
125347	1397	1347120846000	16080	8174	0	0	\N
125348	2134	98683052000	16080	8174	1	0	\N
125349	2133	98660322000	16080	8174	2	0	\N
125356	1397	1347110845000	16083	8175	0	0	\N
125357	2133	98659320000	16083	8175	1	0	\N
125358	2132	148921922000	16083	8175	2	0	\N
125359	2133	98659320000	16084	8175	0	0	\N
125360	2132	148921922000	16084	8175	1	0	\N
125364	1397	1347100844000	16086	8176	0	0	\N
125365	2134	98682049000	16086	8176	1	0	\N
125366	2133	98658318000	16086	8176	2	0	\N
125367	1397	1347100844000	16087	8176	0	0	\N
125368	2134	98682049000	16087	8176	1	0	\N
125369	2133	98658318000	16087	8176	2	0	\N
125370	1397	1347110845000	16088	8175	0	0	\N
125371	2134	98682049000	16088	8175	1	0	\N
125372	2133	98659320000	16088	8175	2	0	\N
125373	2132	148921922000	16088	8175	3	0	\N
125377	1397	1347080842000	16090	8178	0	0	\N
125378	1397	1347070841000	16090	8178	1	0	\N
125379	1397	1347060840000	16090	8178	2	0	\N
125380	1397	1347050839000	16090	8178	3	0	\N
125381	1397	1347040838000	16090	8178	4	0	\N
125382	1397	1347030837000	16090	8178	5	0	\N
125383	2133	98656314000	16090	8178	6	0	\N
125384	2133	98655312000	16090	8178	7	0	\N
125385	2133	98654310000	16090	8178	8	0	\N
125386	2133	98653308000	16090	8178	9	0	\N
125387	2133	98652306000	16090	8178	10	0	\N
125388	2134	98680043000	16090	8178	11	0	\N
125389	2134	98679040000	16090	8178	12	0	\N
125390	2134	98678037000	16090	8178	13	0	\N
125391	2134	98677034000	16090	8178	14	0	\N
125392	2134	98676031000	16090	8178	15	0	\N
125259	2132	148924925000	16061	8168	3	0	75
125272	1397	1347200854000	16065	8169	0	0	9163
125273	1397	1347190853000	16065	8169	1	0	9164
125274	2133	98667336000	16065	8169	2	0	332
125275	2134	98691076000	16065	8169	3	0	308
125277	2133	98666334000	16065	8169	5	0	333
125282	1397	1347180852000	16067	8170	0	0	9165
125283	2134	98689070000	16067	8170	1	0	310
125284	2133	98665332000	16067	8170	2	0	334
125285	2132	148923924000	16067	8170	3	0	76
125293	1397	1347160850000	16069	8171	1	0	9167
125294	1749	4445221000000	16069	8171	2	0	17
125295	2133	98664330000	16069	8171	3	0	335
125296	2133	98663328000	16069	8171	4	0	336
125298	2134	98687064000	16069	8171	6	0	312
125320	1397	1347150849000	16073	8172	0	0	9168
125321	1397	1347140848000	16073	8172	1	0	9169
125322	2133	98662326000	16073	8172	2	0	337
125323	2132	148922923000	16073	8172	3	0	77
125325	2134	98685058000	16073	8172	5	0	314
125326	2133	98661324000	16073	8172	6	0	338
125341	1397	1347130847000	16076	8173	0	0	9170
125342	2134	98684055000	16076	8173	1	0	315
125350	1397	1347120846000	16081	8174	0	0	9171
125352	2133	98660322000	16081	8174	2	0	339
125353	1397	1347110845000	16082	8175	0	0	9172
125354	2133	98659320000	16082	8175	1	0	340
125355	2132	148921922000	16082	8175	2	0	78
125362	2134	98682049000	16085	8176	1	0	317
125363	2133	98658318000	16085	8176	2	0	341
125374	1397	1347090843000	16089	8177	0	0	9174
125375	2133	98657316000	16089	8177	1	0	342
125376	2134	98681046000	16089	8177	2	0	318
125393	2134	98675028000	16090	8178	16	0	\N
125394	2134	98674025000	16090	8178	17	0	\N
125395	2133	98651304000	16090	8178	18	0	\N
125396	2133	98650302000	16090	8178	19	0	\N
125397	2132	148920921000	16090	8178	20	0	\N
125398	2132	148919920000	16090	8178	21	0	\N
125431	1397	1347000834000	16094	8180	0	0	\N
125432	2133	98647296000	16094	8180	1	0	\N
125433	2134	98671016000	16094	8180	2	0	\N
125434	1397	1347000834000	16095	8180	0	0	\N
125435	2133	98647296000	16095	8180	1	0	\N
125436	2134	98671016000	16095	8180	2	0	\N
125450	1397	1346960830000	16099	8183	0	0	\N
125451	2133	98643288000	16099	8183	1	0	\N
125452	2134	98667004000	16099	8183	2	0	\N
125453	1397	1347600894000	16100	8140	0	0	\N
125454	1397	1347590893000	16100	8140	1	0	\N
125455	1397	1347580892000	16100	8140	2	0	\N
125456	1397	1347570891000	16100	8140	3	0	\N
125457	1397	1347560890000	16100	8140	4	0	\N
125458	1397	1347550889000	16100	8140	5	0	\N
125459	1397	1347540888000	16100	8140	6	0	\N
125460	1397	1347530887000	16100	8140	7	0	\N
125461	1397	1347520886000	16100	8140	8	0	\N
125462	1397	1347510885000	16100	8140	9	0	\N
125463	1397	1347500884000	16100	8140	10	0	\N
125464	1397	1347490883000	16100	8140	11	0	\N
125465	1397	1347480882000	16100	8140	12	0	\N
125466	1397	1347470881000	16100	8140	13	0	\N
125467	1397	1347460880000	16100	8140	14	0	\N
125468	1397	1347450879000	16100	8140	15	0	\N
125469	1397	1347440878000	16100	8140	16	0	\N
125470	1397	1347430877000	16100	8140	17	0	\N
125471	1397	1347420876000	16100	8140	18	0	\N
125472	1397	1347410875000	16100	8140	19	0	\N
125473	1397	1347400874000	16100	8140	20	0	\N
125474	1397	1347390873000	16100	8140	21	0	\N
125475	1397	1347380872000	16100	8140	22	0	\N
125476	1397	1347370871000	16100	8140	23	0	\N
125477	1397	1347360870000	16100	8140	24	0	\N
125478	1397	1347350869000	16100	8140	25	0	\N
125479	1397	1347340868000	16100	8140	26	0	\N
125480	1397	1347330867000	16100	8140	27	0	\N
125481	1397	1347320866000	16100	8140	28	0	\N
125482	1397	1347310865000	16100	8140	29	0	\N
125483	1397	1347300864000	16100	8140	30	0	\N
125484	1397	1347290863000	16100	8140	31	0	\N
125485	1397	1347280862000	16100	8140	32	0	\N
125486	1397	1347270861000	16100	8140	33	0	\N
125487	1397	1347260860000	16100	8140	34	0	\N
125488	1397	1347250859000	16100	8140	35	0	\N
125489	1397	1347240858000	16100	8140	36	0	\N
125490	1397	1347230857000	16100	8140	37	0	\N
125491	1397	1347220856000	16100	8140	38	0	\N
125492	1397	1347210855000	16100	8140	39	0	\N
125493	1397	1347200854000	16100	8140	40	0	\N
125494	1397	1347190853000	16100	8140	41	0	\N
125495	1397	1347180852000	16100	8140	42	0	\N
125496	1397	1347170851000	16100	8140	43	0	\N
125497	1397	1347160850000	16100	8140	44	0	\N
125498	1397	1347150849000	16100	8140	45	0	\N
125499	1397	1347140848000	16100	8140	46	0	\N
125500	1397	1347130847000	16100	8140	47	0	\N
125501	1397	1347120846000	16100	8140	48	0	\N
125502	1397	1347110845000	16100	8140	49	0	\N
125503	1397	1347100844000	16100	8140	50	0	\N
125504	1397	1347090843000	16100	8140	51	0	\N
125505	1397	1347080842000	16100	8140	52	0	\N
125506	1397	1347070841000	16100	8140	53	0	\N
125507	1397	1347060840000	16100	8140	54	0	\N
125508	1397	1347050839000	16100	8140	55	0	\N
125509	1397	1347040838000	16100	8140	56	0	\N
125510	1397	1347030837000	16100	8140	58	0	\N
125511	1397	1347020836000	16100	8140	59	0	\N
125512	1397	1347010835000	16100	8140	60	0	\N
125513	1397	1347000834000	16100	8140	61	0	\N
125514	1397	1346990833000	16100	8140	62	0	\N
125515	1397	1346980832000	16100	8140	63	0	\N
125516	1397	1346970831000	16100	8140	64	0	\N
125517	1397	1346960830000	16100	8140	65	0	\N
125518	2133	98707416000	16100	8140	66	0	\N
125519	1749	5945222000000	16100	8140	67	0	\N
125520	1749	4445221000000	16100	8140	68	0	\N
125521	2133	98706414000	16100	8140	69	0	\N
125522	2133	98705412000	16100	8140	70	0	\N
125523	2133	98704410000	16100	8140	71	0	\N
125524	2133	98703408000	16100	8140	72	0	\N
125525	2133	98702406000	16100	8140	73	0	\N
125526	2133	98701404000	16100	8140	74	0	\N
125527	2133	98700402000	16100	8140	75	0	\N
125528	2132	148935936000	16100	8140	76	0	\N
125401	1397	1347060840000	16091	8178	2	0	9177
125402	1397	1347050839000	16091	8178	3	0	9178
125403	1397	1347040838000	16091	8178	4	0	9179
125404	1397	1347030837000	16091	8178	5	0	9180
125405	2133	98656314000	16091	8178	6	0	343
125407	2133	98654310000	16091	8178	8	0	345
125408	2133	98653308000	16091	8178	9	0	346
125409	2133	98652306000	16091	8178	10	0	347
125410	2134	98680043000	16091	8178	11	0	319
125411	2134	98679040000	16091	8178	12	0	320
125413	2134	98677034000	16091	8178	14	0	322
125414	2134	98676031000	16091	8178	15	0	323
125415	2134	98675028000	16091	8178	16	0	324
125416	2134	98674025000	16091	8178	17	0	325
125418	2133	98650302000	16091	8178	19	0	349
125419	2132	148920921000	16091	8178	20	0	79
125420	2132	148919920000	16091	8178	21	0	80
125421	1397	1347020836000	16092	8179	0	0	9181
125422	1397	1347010835000	16092	8179	1	0	9182
125424	2132	148918919000	16092	8179	3	0	81
125425	2133	98648298000	16092	8179	4	0	351
125426	2134	98673022000	16092	8179	5	0	326
125427	2134	98672019000	16092	8179	6	0	327
125428	1397	1347000834000	16093	8180	0	0	9183
125430	2134	98671016000	16093	8180	2	0	328
125437	1397	1346990833000	16096	8181	0	0	9184
125438	2132	148917918000	16096	8181	1	0	82
125439	2133	98646294000	16096	8181	2	0	353
125441	1397	1346980832000	16097	8182	0	0	9185
125442	1397	1346970831000	16097	8182	1	0	9186
125443	2134	98669010000	16097	8182	2	0	330
125444	2134	98668007000	16097	8182	3	0	331
125445	2133	98645292000	16097	8182	4	0	354
125447	1397	1346960830000	16098	8183	0	0	9187
125448	2133	98643288000	16098	8183	1	0	356
125449	2134	98667004000	16098	8183	2	0	332
125529	2132	148934935000	16100	8140	77	0	\N
125530	2132	148933934000	16100	8140	78	0	\N
125531	2132	148932933000	16100	8140	79	0	\N
125532	2132	148931932000	16100	8140	80	0	\N
125533	2132	148930931000	16100	8140	81	0	\N
125534	2132	148929930000	16100	8140	82	0	\N
125535	2132	148928929000	16100	8140	83	0	\N
125536	2132	148927928000	16100	8140	84	0	\N
125537	2133	98699400000	16100	8140	85	0	\N
125538	2133	98698398000	16100	8140	86	0	\N
125539	2133	98697396000	16100	8140	87	0	\N
125540	2133	98696394000	16100	8140	88	0	\N
125541	2133	98695392000	16100	8140	89	0	\N
125542	2133	98694390000	16100	8140	90	0	\N
125543	2133	98693388000	16100	8140	91	0	\N
125544	2133	98692386000	16100	8140	92	0	\N
125545	2133	98691384000	16100	8140	93	0	\N
125546	2133	98690382000	16100	8140	94	0	\N
125547	2133	98689380000	16100	8140	95	0	\N
125548	2133	98688378000	16100	8140	96	0	\N
125549	2133	98687376000	16100	8140	97	0	\N
125550	2133	98686374000	16100	8140	98	0	\N
125551	2133	98685372000	16100	8140	99	0	\N
125552	2133	98684370000	16100	8140	100	0	\N
125553	2133	98683368000	16100	8140	101	0	\N
125554	2133	98682366000	16100	8140	102	0	\N
125555	2133	98681364000	16100	8140	103	0	\N
125556	2133	98680362000	16100	8140	104	0	\N
125557	2133	98679360000	16100	8140	105	0	\N
125558	2133	98678358000	16100	8140	106	0	\N
125559	2133	98677356000	16100	8140	107	0	\N
125560	2133	98676354000	16100	8140	108	0	\N
125561	2133	98675352000	16100	8140	109	0	\N
125562	2133	98674350000	16100	8140	110	0	\N
125563	2134	98731196000	16100	8140	111	0	\N
125564	2134	98730193000	16100	8140	112	0	\N
125565	2134	98729190000	16100	8140	113	0	\N
125566	2134	98728187000	16100	8140	114	0	\N
125567	2134	98727184000	16100	8140	115	0	\N
125568	2134	98726181000	16100	8140	116	0	\N
125569	2134	98725178000	16100	8140	117	0	\N
125570	2134	98724175000	16100	8140	118	0	\N
125571	2134	98723172000	16100	8140	119	0	\N
125572	2134	98722169000	16100	8140	120	0	\N
125573	2134	98721166000	16100	8140	121	0	\N
125574	2134	98720163000	16100	8140	122	0	\N
125575	2134	98719160000	16100	8140	123	0	\N
125576	2134	98718157000	16100	8140	124	0	\N
125577	2132	148926927000	16100	8140	125	0	\N
125585	1397	1346940828000	16103	8185	0	0	\N
125586	2134	98664998000	16103	8185	1	0	\N
125587	2133	98641284000	16103	8185	3	0	\N
125588	1397	1346940828000	16104	8185	0	0	\N
125589	2134	98664998000	16104	8185	1	0	\N
125590	2133	98641284000	16104	8185	3	0	\N
125598	1397	1346930827000	16106	8186	0	0	\N
125599	1397	1346920826000	16106	8186	1	0	\N
125600	2133	98640282000	16106	8186	2	0	\N
125601	2133	98639280000	16106	8186	3	0	\N
125602	2132	148915916000	16106	8186	4	0	\N
125603	2134	98663995000	16106	8186	5	0	\N
125604	2134	98662992000	16106	8186	6	0	\N
125605	1397	1346910825000	16107	8187	0	0	\N
125606	2134	98661989000	16107	8187	1	0	\N
125607	2133	98638278000	16107	8187	2	0	\N
125608	1397	1346910825000	16108	8187	0	0	\N
125609	2134	98661989000	16108	8187	1	0	\N
125610	2133	98638278000	16108	8187	2	0	\N
125637	1397	1346840818000	16114	8191	0	0	\N
125638	2134	98654968000	16114	8191	1	0	\N
125639	2133	98631264000	16114	8191	2	0	\N
125647	1397	1346820816000	16117	8193	0	0	\N
125648	2132	148912913000	16117	8193	1	0	\N
125649	2133	98629260000	16117	8193	2	0	\N
125650	2134	98652962000	16117	8193	3	0	\N
125651	1397	1346810815000	16118	8194	0	0	\N
125652	1397	1346800814000	16118	8194	1	0	\N
125653	2134	98651959000	16118	8194	2	0	\N
125654	2133	98628258000	16118	8194	3	0	\N
125655	2133	98627256000	16118	8194	4	0	\N
125656	2134	98650956000	16118	8194	5	0	\N
125580	2132	148916917000	16101	8184	2	0	83
125581	2134	98666001000	16101	8184	3	0	333
125582	1397	1346940828000	16102	8185	0	0	9189
125583	2134	98664998000	16102	8185	1	0	334
125584	2133	98641284000	16102	8185	3	0	358
125592	1397	1346920826000	16105	8186	1	0	9191
125593	2133	98640282000	16105	8186	2	0	359
125594	2133	98639280000	16105	8186	3	0	360
125595	2132	148915916000	16105	8186	4	0	84
125596	2134	98663995000	16105	8186	5	0	335
125611	1397	1346910825000	16109	8187	0	0	9192
125612	2134	98661989000	16109	8187	1	0	337
125613	2133	98638278000	16109	8187	2	0	361
125614	1397	1346900824000	16110	8188	0	0	9193
125616	2133	98637276000	16110	8188	2	0	362
125617	1397	1346890823000	16111	8189	0	0	9194
125618	2132	148914915000	16111	8189	1	0	85
125619	2134	98659983000	16111	8189	2	0	339
125620	2133	98636274000	16111	8189	3	0	363
125622	1397	1346870821000	16112	8190	1	0	9196
125623	1397	1346860820000	16112	8190	2	0	9197
125624	1397	1346850819000	16112	8190	3	0	9198
125625	2132	148913914000	16112	8190	4	0	86
125626	2134	98658980000	16112	8190	5	0	340
125628	2133	98634270000	16112	8190	7	0	365
125629	2134	98657977000	16112	8190	8	0	341
125630	2134	98656974000	16112	8190	9	0	342
125631	2134	98655971000	16112	8190	10	0	343
125633	2133	98632266000	16112	8190	12	0	367
125634	1397	1346840818000	16113	8191	0	0	9199
125635	2134	98654968000	16113	8191	1	0	344
125636	2133	98631264000	16113	8191	2	0	368
125640	1397	1346830817000	16115	8192	0	0	9200
125642	2134	98653965000	16115	8192	2	0	345
125643	1397	1346820816000	16116	8193	0	0	9201
125644	2132	148912913000	16116	8193	1	0	87
125645	2133	98629260000	16116	8193	2	0	370
125646	2134	98652962000	16116	8193	3	0	346
125658	1397	1346800814000	16119	8194	1	0	9203
125659	2134	98651959000	16119	8194	2	0	347
125660	2133	98628258000	16119	8194	3	0	371
125661	2133	98627256000	16119	8194	4	0	372
125663	1397	1346790813000	16120	8195	0	0	9204
125664	2133	98626254000	16120	8195	1	0	373
125670	1397	1346780812000	16122	8196	0	0	\N
125671	2133	98625252000	16122	8196	1	0	\N
125672	2134	98648950000	16122	8196	2	0	\N
125676	1397	1346760810000	16124	8198	0	0	\N
125677	1397	1346750809000	16124	8198	1	0	\N
125678	2132	148910911000	16124	8198	2	0	\N
125679	2133	98623248000	16124	8198	3	0	\N
125680	2133	98622246000	16124	8198	4	0	\N
125681	2134	98646944000	16124	8198	5	0	\N
125682	2134	98645941000	16124	8198	6	0	\N
125696	1397	1346730807000	16128	8200	0	0	\N
125697	2133	98620242000	16128	8200	1	0	\N
125698	2134	98643935000	16128	8200	2	0	\N
125699	1726	139855109000	16129	8113	0	0	\N
125700	112	66001941005524	16129	8113	1	0	\N
125701	1749	5945222000000	16129	8113	2	0	\N
125702	1749	4445221000000	16129	8113	3	0	\N
125703	2132	148939940000	16129	8113	4	0	\N
125704	2132	148938939000	16129	8113	5	0	\N
125705	2132	148937938000	16129	8113	6	0	\N
125706	2132	148936937000	16129	8113	7	0	\N
125707	2132	148935936000	16129	8113	8	0	\N
125708	2132	148934935000	16129	8113	9	0	\N
125709	2132	148933934000	16129	8113	10	0	\N
125710	2132	148932933000	16129	8113	11	0	\N
125711	2132	148931932000	16129	8113	12	0	\N
125712	2132	148930931000	16129	8113	13	0	\N
125713	2132	148929930000	16129	8113	14	0	\N
125714	2132	148928929000	16129	8113	15	0	\N
125715	2132	148927928000	16129	8113	16	0	\N
125716	2132	148926927000	16129	8113	17	0	\N
125717	2132	148925926000	16129	8113	18	0	\N
125718	2132	148924925000	16129	8113	19	0	\N
125719	2132	148923924000	16129	8113	20	0	\N
125720	2132	148922923000	16129	8113	21	0	\N
125721	2132	148921922000	16129	8113	22	0	\N
125722	2132	148920921000	16129	8113	23	0	\N
125723	2132	148919920000	16129	8113	24	0	\N
125724	2132	148918919000	16129	8113	25	0	\N
125725	2132	148917918000	16129	8113	26	0	\N
125726	2132	148916917000	16129	8113	27	0	\N
125727	2132	148915916000	16129	8113	28	0	\N
125728	2132	148914915000	16129	8113	29	0	\N
125729	2132	148913914000	16129	8113	30	0	\N
125730	2132	148912913000	16129	8113	31	0	\N
125731	2132	148911912000	16129	8113	32	0	\N
125732	2132	148910911000	16129	8113	33	0	\N
125733	2132	148909910000	16129	8113	34	0	\N
125738	1397	1346720806000	16131	8201	0	0	\N
125739	2134	98642932000	16131	8201	1	0	\N
125740	2133	98619240000	16131	8201	2	0	\N
125741	2132	148909910000	16131	8201	3	0	\N
125742	1397	1346710805000	16132	8202	0	0	\N
125743	2134	98641929000	16132	8202	1	0	\N
125746	1397	1346700804000	16134	8203	0	0	\N
125747	1397	1346690803000	16134	8203	1	0	\N
125748	2134	98640926000	16134	8203	2	0	\N
125749	2133	98618238000	16134	8203	3	0	\N
125750	2133	98617236000	16134	8203	4	0	\N
125751	2134	98639923000	16134	8203	5	0	\N
125752	2132	148908909000	16134	8203	6	0	\N
125753	1397	1346700804000	16135	8203	0	0	\N
125754	1397	1346690803000	16135	8203	1	0	\N
125755	2134	98640926000	16135	8203	2	0	\N
125756	2133	98618238000	16135	8203	3	0	\N
125757	2133	98617236000	16135	8203	4	0	\N
125758	2134	98639923000	16135	8203	5	0	\N
125759	2132	148908909000	16135	8203	6	0	\N
125767	1397	1346680802000	16138	8204	0	0	\N
125768	1397	1346670801000	16138	8204	1	0	\N
125769	2133	98616234000	16138	8204	2	0	\N
125770	2133	98615232000	16138	8204	3	0	\N
125771	2134	98638920000	16138	8204	4	0	\N
125772	2134	98637917000	16138	8204	5	0	\N
125773	1397	1346680802000	16139	8204	0	0	\N
125774	1397	1346670801000	16139	8204	1	0	\N
125775	2133	98616234000	16139	8204	2	0	\N
125776	2133	98615232000	16139	8204	3	0	\N
125777	2134	98638920000	16139	8204	4	0	\N
125778	2134	98637917000	16139	8204	5	0	\N
125794	1397	1346640798000	16143	8206	0	0	\N
125795	2134	98635911000	16143	8206	1	0	\N
125796	2133	98612226000	16143	8206	2	0	\N
125800	1397	1346630797000	16145	8207	0	0	\N
125667	1397	1346780812000	16121	8196	0	0	9205
125668	2133	98625252000	16121	8196	1	0	374
125669	2134	98648950000	16121	8196	2	0	350
125673	1397	1346770811000	16123	8197	0	0	9206
125674	2134	98647947000	16123	8197	1	0	351
125683	1397	1346760810000	16125	8198	0	0	9207
125684	1397	1346750809000	16125	8198	1	0	9208
125685	2132	148910911000	16125	8198	2	0	89
125686	2133	98623248000	16125	8198	3	0	376
125687	2133	98622246000	16125	8198	4	0	377
125689	2134	98645941000	16125	8198	6	0	353
125690	1397	1346740808000	16126	8199	0	0	9209
125691	2133	98621244000	16126	8199	1	0	378
125692	2134	98644938000	16126	8199	2	0	354
125694	2133	98620242000	16127	8200	1	0	379
125695	2134	98643935000	16127	8200	2	0	355
125734	1397	1346720806000	16130	8201	0	0	9211
125735	2134	98642932000	16130	8201	1	0	356
125736	2133	98619240000	16130	8201	2	0	380
125744	1397	1346710805000	16133	8202	0	0	9212
125745	2134	98641929000	16133	8202	1	0	357
125760	1397	1346700804000	16136	8203	0	0	9213
125761	1397	1346690803000	16136	8203	1	0	9214
125762	2134	98640926000	16136	8203	2	0	358
125764	2133	98617236000	16136	8203	4	0	382
125765	2134	98639923000	16136	8203	5	0	359
125766	2132	148908909000	16136	8203	6	0	91
125779	1397	1346680802000	16140	8204	0	0	9215
125781	2133	98616234000	16140	8204	2	0	383
125782	2133	98615232000	16140	8204	3	0	384
125783	2134	98638920000	16140	8204	4	0	360
125784	2134	98637917000	16140	8204	5	0	361
125785	1397	1346660800000	16141	8205	0	0	9217
125787	2133	98614230000	16141	8205	2	0	385
125788	2133	98613228000	16141	8205	3	0	386
125789	2132	148907908000	16141	8205	4	0	92
125790	2134	98636914000	16141	8205	5	0	362
125791	1397	1346640798000	16142	8206	0	0	9219
125793	2133	98612226000	16142	8206	2	0	387
125797	1397	1346630797000	16144	8207	0	0	9220
125798	2133	98611224000	16144	8207	1	0	388
125799	2134	98634908000	16144	8207	2	0	364
125801	2133	98611224000	16145	8207	1	0	\N
125802	2134	98634908000	16145	8207	2	0	\N
125803	1397	1346620796000	16146	8208	0	0	\N
125804	1397	1346610795000	16146	8208	1	0	\N
125805	2133	98610222000	16146	8208	2	0	\N
125806	2132	148906907000	16146	8208	3	0	\N
125807	2134	98633905000	16146	8208	4	0	\N
125808	2134	98632902000	16146	8208	5	0	\N
125815	1397	1346600794000	16148	8209	0	0	\N
125816	2134	98631899000	16148	8209	1	0	\N
125817	2133	98609220000	16148	8209	2	0	\N
125825	1397	1346590793000	16151	8210	0	0	\N
125826	2132	148905906000	16151	8210	1	0	\N
125827	2133	98608218000	16151	8210	2	0	\N
125828	2134	98630896000	16151	8210	3	0	\N
125832	1397	1346580792000	16153	8211	0	0	\N
125833	2134	98629893000	16153	8211	1	0	\N
125834	2133	98607216000	16153	8211	2	0	\N
125835	1397	1346660800000	16154	8205	0	0	\N
125836	1397	1346650799000	16154	8205	1	0	\N
125837	1397	1346640798000	16154	8205	2	0	\N
125838	1397	1346630797000	16154	8205	3	0	\N
125839	1397	1346620796000	16154	8205	4	0	\N
125840	1397	1346610795000	16154	8205	5	0	\N
125841	1397	1346600794000	16154	8205	6	0	\N
125842	1397	1346590793000	16154	8205	7	0	\N
125843	1397	1346580792000	16154	8205	8	0	\N
125844	2133	98614230000	16154	8205	9	0	\N
125845	2133	98613228000	16154	8205	10	0	\N
125846	2133	98612226000	16154	8205	11	0	\N
125847	2133	98611224000	16154	8205	12	0	\N
125848	2133	98610222000	16154	8205	13	0	\N
125849	2133	98609220000	16154	8205	14	0	\N
125850	2133	98608218000	16154	8205	15	0	\N
125851	2133	98607216000	16154	8205	16	0	\N
125852	2132	148907908000	16154	8205	17	0	\N
125853	2132	148906907000	16154	8205	18	0	\N
125854	2132	148905906000	16154	8205	19	0	\N
125855	2134	98636914000	16154	8205	20	0	\N
125856	2134	98635911000	16154	8205	21	0	\N
125857	2134	98634908000	16154	8205	22	0	\N
125858	2134	98633905000	16154	8205	23	0	\N
125859	2134	98632902000	16154	8205	24	0	\N
125860	2134	98631899000	16154	8205	25	0	\N
125861	2134	98630896000	16154	8205	26	0	\N
125862	2134	98629893000	16154	8205	27	0	\N
125866	1397	1346570791000	16156	8212	0	0	\N
125867	2133	98606214000	16156	8212	1	0	\N
125868	2134	98628890000	16156	8212	2	0	\N
125869	1397	1346560790000	16157	8213	0	0	\N
125870	2134	98627887000	16157	8213	1	0	\N
125871	2133	98605212000	16157	8213	2	0	\N
125872	1397	1346560790000	16158	8213	0	0	\N
125873	2134	98627887000	16158	8213	1	0	\N
125874	2133	98605212000	16158	8213	2	0	\N
125875	1397	1346560790000	16159	8213	0	0	\N
125876	2134	98627887000	16159	8213	1	0	\N
125877	2133	98605212000	16159	8213	2	0	\N
125878	1397	1346560790000	16160	8213	0	0	\N
125879	2134	98627887000	16160	8213	1	0	\N
125880	2133	98605212000	16160	8213	2	0	\N
125904	1397	1346500784000	16168	8219	0	0	\N
125905	2133	98599200000	16168	8219	1	0	\N
125906	2134	98621869000	16168	8219	2	0	\N
125907	1397	1346500784000	16169	8219	0	0	\N
125908	2133	98599200000	16169	8219	1	0	\N
125909	2134	98621869000	16169	8219	2	0	\N
125910	1397	1346490783000	16170	8220	0	0	\N
125911	2134	98620866000	16170	8220	1	0	\N
125912	2132	148902903000	16170	8220	2	0	\N
125913	2133	98598198000	16170	8220	3	0	\N
125918	1397	1346490783000	16172	8220	0	0	\N
125919	2134	98620866000	16172	8220	1	0	\N
125920	2132	148902903000	16172	8220	2	0	\N
125921	2133	98598198000	16172	8220	3	0	\N
125922	1397	1346490783000	16173	8220	0	0	\N
125923	2134	98620866000	16173	8220	1	0	\N
125924	2132	148902903000	16173	8220	2	0	\N
125925	2133	98598198000	16173	8220	3	0	\N
125928	1397	1346950829000	16175	8141	0	0	\N
125929	1397	1346940828000	16175	8141	1	0	\N
125930	1397	1346930827000	16175	8141	2	0	\N
125931	1397	1346920826000	16175	8141	3	0	\N
125932	1397	1346910825000	16175	8141	4	0	\N
125933	1397	1346900824000	16175	8141	5	0	\N
125934	1397	1346890823000	16175	8141	6	0	\N
125935	1397	1346880822000	16175	8141	7	0	\N
125936	1397	1346870821000	16175	8141	8	0	\N
125811	2133	98610222000	16147	8208	2	0	389
125812	2132	148906907000	16147	8208	3	0	93
125813	2134	98633905000	16147	8208	4	0	365
125814	2134	98632902000	16147	8208	5	0	366
125818	1397	1346600794000	16149	8209	0	0	9223
125820	2133	98609220000	16149	8209	2	0	390
125821	1397	1346590793000	16150	8210	0	0	9224
125822	2132	148905906000	16150	8210	1	0	94
125823	2133	98608218000	16150	8210	2	0	391
125824	2134	98630896000	16150	8210	3	0	368
125830	2134	98629893000	16152	8211	1	0	369
125831	2133	98607216000	16152	8211	2	0	392
125863	1397	1346570791000	16155	8212	0	0	9226
125864	2133	98606214000	16155	8212	1	0	393
125881	1397	1346560790000	16161	8213	0	0	9227
125882	2134	98627887000	16161	8213	1	0	371
125883	2133	98605212000	16161	8213	2	0	394
125884	1397	1346550789000	16162	8214	0	0	9228
125885	2132	148904905000	16162	8214	1	0	95
125887	2133	98604210000	16162	8214	3	0	395
125888	1397	1346540788000	16163	8215	0	0	9229
125889	2133	98603208000	16163	8215	1	0	396
125890	2134	98625881000	16163	8215	2	0	373
125891	1397	1346530787000	16164	8216	0	0	9230
125893	2134	98624878000	16164	8216	2	0	374
125894	1397	1346520786000	16165	8217	0	0	9231
125895	2132	148903904000	16165	8217	1	0	96
125896	2133	98601204000	16165	8217	2	0	398
125898	1397	1346510785000	16166	8218	0	0	9232
125899	2133	98600202000	16166	8218	1	0	399
125900	2134	98622872000	16166	8218	2	0	376
125901	1397	1346500784000	16167	8219	0	0	9233
125902	2133	98599200000	16167	8219	1	0	400
125914	1397	1346490783000	16171	8220	0	0	9234
125915	2134	98620866000	16171	8220	1	0	378
125916	2132	148902903000	16171	8220	2	0	97
125917	2133	98598198000	16171	8220	3	0	401
125926	1397	1346480782000	16174	8221	0	0	9235
125937	1397	1346860820000	16175	8141	9	0	\N
125938	1397	1346850819000	16175	8141	10	0	\N
125939	1397	1346840818000	16175	8141	11	0	\N
125940	1397	1346830817000	16175	8141	12	0	\N
125941	1397	1346820816000	16175	8141	13	0	\N
125942	1397	1346810815000	16175	8141	14	0	\N
125943	1397	1346800814000	16175	8141	15	0	\N
125944	1397	1346790813000	16175	8141	16	0	\N
125945	1397	1346780812000	16175	8141	17	0	\N
125946	1397	1346770811000	16175	8141	18	0	\N
125947	1397	1346760810000	16175	8141	19	0	\N
125948	1397	1346750809000	16175	8141	20	0	\N
125949	1397	1346740808000	16175	8141	21	0	\N
125950	1397	1346730807000	16175	8141	22	0	\N
125951	1397	1346720806000	16175	8141	23	0	\N
125952	1397	1346710805000	16175	8141	24	0	\N
125953	1397	1346700804000	16175	8141	25	0	\N
125954	1397	1346690803000	16175	8141	26	0	\N
125955	1397	1346680802000	16175	8141	27	0	\N
125956	1397	1346670801000	16175	8141	28	0	\N
125957	1397	1346660800000	16175	8141	29	0	\N
125958	1397	1346650799000	16175	8141	30	0	\N
125959	1397	1346640798000	16175	8141	31	0	\N
125960	1397	1346630797000	16175	8141	32	0	\N
125961	1397	1346620796000	16175	8141	33	0	\N
125962	1397	1346610795000	16175	8141	34	0	\N
125963	1397	1346600794000	16175	8141	35	0	\N
125964	1397	1346590793000	16175	8141	36	0	\N
125965	1397	1346580792000	16175	8141	37	0	\N
125966	1397	1346570791000	16175	8141	38	0	\N
125967	1397	1346560790000	16175	8141	39	0	\N
125968	1397	1346550789000	16175	8141	40	0	\N
125969	1397	1346540788000	16175	8141	41	0	\N
125970	1397	1346530787000	16175	8141	42	0	\N
125971	1397	1346520786000	16175	8141	43	0	\N
125972	1397	1346510785000	16175	8141	44	0	\N
125973	1397	1346500784000	16175	8141	45	0	\N
125974	1397	1346490783000	16175	8141	46	0	\N
125975	2132	148925926000	16175	8141	47	0	\N
125976	2132	148924925000	16175	8141	48	0	\N
125977	2132	148923924000	16175	8141	49	0	\N
125978	2132	148922923000	16175	8141	50	0	\N
125979	2132	148921922000	16175	8141	51	0	\N
125980	2134	98717154000	16175	8141	52	0	\N
125981	2134	98716151000	16175	8141	53	0	\N
125982	2134	98715148000	16175	8141	54	0	\N
125983	2134	98714145000	16175	8141	55	0	\N
125984	2132	148920921000	16175	8141	56	0	\N
125985	2133	98673348000	16175	8141	58	0	\N
125986	2133	98672346000	16175	8141	59	0	\N
125987	2133	98671344000	16175	8141	60	0	\N
125988	2133	98670342000	16175	8141	61	0	\N
125989	2133	98669340000	16175	8141	62	0	\N
125990	2133	98668338000	16175	8141	63	0	\N
125991	2133	98667336000	16175	8141	64	0	\N
125992	2133	98666334000	16175	8141	65	0	\N
125993	2133	98665332000	16175	8141	66	0	\N
125994	2133	98664330000	16175	8141	67	0	\N
125995	2133	98663328000	16175	8141	68	0	\N
125996	2133	98662326000	16175	8141	69	0	\N
125997	2133	98661324000	16175	8141	70	0	\N
125998	2133	98660322000	16175	8141	71	0	\N
125999	2133	98659320000	16175	8141	72	0	\N
126000	2133	98658318000	16175	8141	73	0	\N
126001	2133	98657316000	16175	8141	74	0	\N
126002	2133	98656314000	16175	8141	75	0	\N
126003	2133	98655312000	16175	8141	76	0	\N
126004	2133	98654310000	16175	8141	77	0	\N
126005	2133	98653308000	16175	8141	78	0	\N
126006	2133	98652306000	16175	8141	79	0	\N
126007	2133	98651304000	16175	8141	80	0	\N
126008	2133	98650302000	16175	8141	81	0	\N
126009	2133	98649300000	16175	8141	82	0	\N
126010	2133	98648298000	16175	8141	83	0	\N
126011	2133	98647296000	16175	8141	84	0	\N
126012	2133	98646294000	16175	8141	85	0	\N
126013	2133	98645292000	16175	8141	86	0	\N
126014	2133	98644290000	16175	8141	87	0	\N
126015	2133	98643288000	16175	8141	88	0	\N
126016	2133	98642286000	16175	8141	89	0	\N
126017	2133	98641284000	16175	8141	90	0	\N
126018	2133	98640282000	16175	8141	91	0	\N
126019	2133	98639280000	16175	8141	92	0	\N
126020	2133	98638278000	16175	8141	93	0	\N
126021	2133	98637276000	16175	8141	94	0	\N
126022	2134	98713142000	16175	8141	95	0	\N
126023	2134	98712139000	16175	8141	96	0	\N
126024	2134	98711136000	16175	8141	97	0	\N
126025	2134	98710133000	16175	8141	98	0	\N
126026	2134	98709130000	16175	8141	99	0	\N
126027	2134	98708127000	16175	8141	100	0	\N
126028	2134	98707124000	16175	8141	101	0	\N
126029	2134	98706121000	16175	8141	102	0	\N
126030	2134	98705118000	16175	8141	103	0	\N
126031	2134	98704115000	16175	8141	104	0	\N
126032	2134	98703112000	16175	8141	105	0	\N
126033	2134	98702109000	16175	8141	106	0	\N
126034	2134	98701106000	16175	8141	107	0	\N
126035	2134	98700103000	16175	8141	108	0	\N
126036	2134	98699100000	16175	8141	109	0	\N
126037	2134	98698097000	16175	8141	110	0	\N
126038	2134	98697094000	16175	8141	111	0	\N
126039	2134	98696091000	16175	8141	112	0	\N
126040	2134	98695088000	16175	8141	113	0	\N
126041	2134	98694085000	16175	8141	114	0	\N
126042	2134	98693082000	16175	8141	115	0	\N
126043	2134	98692079000	16175	8141	116	0	\N
126044	2134	98691076000	16175	8141	117	0	\N
126045	2134	98690073000	16175	8141	118	0	\N
126046	2134	98689070000	16175	8141	119	0	\N
126047	2134	98688067000	16175	8141	120	0	\N
126048	2134	98687064000	16175	8141	121	0	\N
126049	2134	98686061000	16175	8141	122	0	\N
126050	2134	98685058000	16175	8141	123	0	\N
126051	2134	98684055000	16175	8141	124	0	\N
126052	2134	98683052000	16175	8141	125	0	\N
126059	1397	1346460780000	16178	8223	0	0	\N
126060	2133	98596194000	16178	8223	1	0	\N
126061	2134	98617857000	16178	8223	2	0	\N
126062	1397	1346450779000	16179	8224	0	0	\N
126063	2133	98595192000	16179	8224	1	0	\N
126064	2134	98616854000	16179	8224	2	0	\N
126065	2132	148901902000	16179	8224	3	0	\N
126072	1397	1346440778000	16182	8226	0	0	\N
126055	2134	98618860000	16176	8222	2	0	380
126056	1397	1346460780000	16177	8223	0	0	9237
126057	2133	98596194000	16177	8223	1	0	403
126058	2134	98617857000	16177	8223	2	0	381
126066	1397	1346450779000	16180	8224	0	0	9238
126068	2134	98616854000	16180	8224	2	0	382
126069	2132	148901902000	16180	8224	3	0	98
126070	2134	98615851000	16181	8225	0	0	383
126071	2133	98594190000	16181	8225	1	0	405
126073	1397	1346430777000	16182	8226	1	0	\N
126074	1397	1346420776000	16182	8226	2	0	\N
126075	2132	148900901000	16182	8226	3	0	\N
126076	1684	16531440880623	16182	8226	4	0	\N
126077	2133	98593188000	16182	8226	5	0	\N
126078	2133	98592186000	16182	8226	6	0	\N
126079	2133	98591184000	16182	8226	7	0	\N
126080	2134	98614848000	16182	8226	8	0	\N
126081	2134	98613845000	16182	8226	9	0	\N
126082	2134	98612842000	16182	8226	10	0	\N
126083	1397	1346440778000	16183	8226	0	0	\N
126084	1397	1346430777000	16183	8226	1	0	\N
126085	1397	1346420776000	16183	8226	2	0	\N
126086	2132	148900901000	16183	8226	3	0	\N
126087	1684	16531440880623	16183	8226	4	0	\N
126088	2133	98593188000	16183	8226	5	0	\N
126089	2133	98592186000	16183	8226	6	0	\N
126090	2133	98591184000	16183	8226	7	0	\N
126091	2134	98614848000	16183	8226	8	0	\N
126092	2134	98613845000	16183	8226	9	0	\N
126093	2134	98612842000	16183	8226	10	0	\N
126094	1397	1346440778000	16184	8226	0	0	\N
126095	1397	1346430777000	16184	8226	1	0	\N
126096	1397	1346420776000	16184	8226	2	0	\N
126097	2132	148900901000	16184	8226	3	0	\N
126098	1684	16531440880623	16184	8226	4	0	\N
126099	2133	98593188000	16184	8226	5	0	\N
126100	2133	98592186000	16184	8226	6	0	\N
126101	2133	98591184000	16184	8226	7	0	\N
126102	2134	98614848000	16184	8226	8	0	\N
126103	2134	98613845000	16184	8226	9	0	\N
126104	2134	98612842000	16184	8226	10	0	\N
126116	1397	1346440778000	16186	8226	0	0	\N
126117	1397	1346430777000	16186	8226	1	0	\N
126118	1397	1346420776000	16186	8226	2	0	\N
126119	2132	148900901000	16186	8226	3	0	\N
126120	1684	16531440880623	16186	8226	4	0	\N
126121	2133	98593188000	16186	8226	5	0	\N
126122	2133	98592186000	16186	8226	6	0	\N
126123	2133	98591184000	16186	8226	7	0	\N
126124	2134	98614848000	16186	8226	8	0	\N
126125	2134	98613845000	16186	8226	9	0	\N
126126	2134	98612842000	16186	8226	10	0	\N
126127	1397	1346410775000	16187	8227	0	0	\N
126128	1684	16530438880623	16187	8227	1	0	\N
126129	2133	98590182000	16187	8227	2	0	\N
126130	2134	98611839000	16187	8227	3	0	\N
126135	1397	1346410775000	16189	8227	0	0	\N
126136	1684	16530438880623	16189	8227	1	0	\N
126137	2133	98590182000	16189	8227	2	0	\N
126138	2134	98611839000	16189	8227	3	0	\N
126139	1684	16531440880623	16190	8224	0	0	\N
126140	1684	16530438880623	16190	8224	1	0	\N
126165	1397	1346330767000	16195	8232	0	0	\N
126166	2134	98603815000	16195	8232	1	0	\N
126167	2132	148897898000	16195	8232	2	0	\N
126168	2133	98582166000	16195	8232	3	0	\N
126173	1397	1346320766000	16197	8233	0	0	\N
126174	2142	2000000	16197	8233	1	0	\N
126175	2134	98602812000	16197	8233	2	0	\N
126179	1397	1346320766000	16199	8233	0	0	\N
126180	2142	2000000	16199	8233	1	0	\N
126181	2134	98602812000	16199	8233	2	0	\N
126182	1397	1346320766000	16200	8233	0	0	\N
126183	2142	2000000	16200	8233	1	0	\N
126184	2134	98602812000	16200	8233	2	0	\N
126185	1397	1346310765000	16201	8234	0	0	\N
126186	2134	98601809000	16201	8234	1	0	\N
126187	2133	98581164000	16201	8234	2	0	\N
126190	1397	1346310765000	16203	8234	0	0	\N
126191	2134	98601809000	16203	8234	1	0	\N
126192	2133	98581164000	16203	8234	2	0	\N
126199	1684	13680425880623	16205	8235	0	0	\N
126200	1397	1346310765000	16205	8235	1	0	\N
126201	1397	1346300764000	16205	8235	2	0	\N
126202	2132	148896897000	16205	8235	3	0	\N
126203	2134	98600806000	16205	8235	4	0	\N
126204	2133	98580162000	16205	8235	5	0	\N
126205	1684	13680425880623	16206	8235	0	0	\N
126206	1397	1346310765000	16206	8235	1	0	\N
126207	1397	1346300764000	16206	8235	2	0	\N
126208	2132	148896897000	16206	8235	3	0	\N
126107	1397	1346420776000	16185	8226	2	0	9241
126108	2132	148900901000	16185	8226	3	0	99
126109	1684	16531440880623	16185	8226	4	0	67
126110	2133	98593188000	16185	8226	5	0	406
126111	2133	98592186000	16185	8226	6	0	407
126113	2134	98614848000	16185	8226	8	0	384
126114	2134	98613845000	16185	8226	9	0	385
126115	2134	98612842000	16185	8226	10	0	386
126131	1397	1346410775000	16188	8227	0	0	9242
126132	1684	16530438880623	16188	8227	1	0	68
126134	2134	98611839000	16188	8227	3	0	387
126141	1397	1346400774000	16191	8228	0	0	9243
126142	1397	1346390773000	16191	8228	1	0	9244
126143	2132	148899900000	16191	8228	2	0	100
126145	2133	98588178000	16191	8228	4	0	411
126146	2134	98610836000	16191	8228	5	0	388
126147	2134	98609833000	16191	8228	6	0	389
126148	1397	1346380772000	16192	8229	0	0	9245
126149	1397	1346370771000	16192	8229	1	0	9246
126151	2134	98608830000	16192	8229	3	0	390
126152	2133	98587176000	16192	8229	4	0	412
126153	2133	98586174000	16192	8229	5	0	413
126154	2134	98607827000	16192	8229	6	0	391
126155	1397	1346360770000	16193	8230	0	0	9247
126157	2132	148898899000	16193	8230	2	0	101
126158	2134	98606824000	16193	8230	3	0	392
126159	1397	1346350769000	16194	8231	0	0	9248
126160	1397	1346340768000	16194	8231	1	0	9249
126162	2134	98604818000	16194	8231	3	0	394
126163	2133	98584170000	16194	8231	4	0	415
126164	2133	98583168000	16194	8231	5	0	416
126169	1397	1346330767000	16196	8232	0	0	9250
126170	2134	98603815000	16196	8232	1	0	395
126172	2133	98582166000	16196	8232	3	0	417
126176	1397	1346320766000	16198	8233	0	0	9251
126177	2142	2000000	16198	8233	1	0	1
126178	2134	98602812000	16198	8233	2	0	396
126188	2134	98601809000	16202	8234	0	0	397
126193	1684	13680425880623	16204	8235	0	0	70
126194	1397	1346310765000	16204	8235	1	0	9252
126195	1397	1346300764000	16204	8235	2	0	9253
126196	2132	148896897000	16204	8235	3	0	103
126198	2133	98580162000	16204	8235	5	0	419
126209	2134	98600806000	16206	8235	4	0	\N
126210	2133	98580162000	16206	8235	5	0	\N
126211	1397	1346310765000	16207	8235	0	0	\N
126212	1397	1346300764000	16207	8235	1	0	\N
126213	2133	98580162000	16207	8235	2	0	\N
126228	1726	138645109000	16210	8225	0	0	\N
126229	1726	137435109000	16210	8225	1	0	\N
126230	1726	136225109000	16210	8225	2	0	\N
126231	1726	135015109000	16210	8225	3	0	\N
126232	1684	16530434880623	16210	8225	4	0	\N
126233	1684	13680424880623	16210	8225	5	0	\N
126234	1729	18203081000000	16210	8225	6	0	\N
126235	1729	18091975279700	16210	8225	7	0	\N
126236	1729	18000749223850	16210	8225	8	0	\N
126237	1729	17835943880750	16210	8225	9	0	\N
126245	1397	1346250759000	16212	8239	0	0	\N
126246	1397	1346240758000	16212	8239	1	0	\N
126247	2134	98595791000	16212	8239	2	0	\N
126248	2133	98575152000	16212	8239	3	0	\N
126249	2133	98574150000	16212	8239	4	0	\N
126256	1397	1346250759000	16214	8239	0	0	\N
126257	1397	1346240758000	16214	8239	1	0	\N
126258	1397	1346230757000	16214	8239	2	0	\N
126259	2134	98595791000	16214	8239	3	0	\N
126260	2134	98594788000	16214	8239	4	0	\N
126261	2133	98575152000	16214	8239	5	0	\N
126262	2133	98574150000	16214	8239	6	0	\N
126272	1397	1346210755000	16217	8241	0	0	\N
126273	2134	98592782000	16217	8241	1	0	\N
126274	2133	98571144000	16217	8241	2	0	\N
126279	1397	1346200754000	16219	8242	0	0	\N
126280	2132	148893894000	16219	8242	1	0	\N
126281	2134	98591779000	16219	8242	2	0	\N
126282	2133	98570142000	16219	8242	3	0	\N
126291	1397	1346170751000	16223	8245	0	0	\N
126292	1397	1346160750000	16223	8245	1	0	\N
126293	2132	148892893000	16223	8245	2	0	\N
126294	2133	98568138000	16223	8245	4	0	\N
126295	2133	98567136000	16223	8245	5	0	\N
126296	2134	98588770000	16223	8245	6	0	\N
126297	2134	98587767000	16223	8245	7	0	\N
126316	1397	1346130747000	16227	8248	0	0	\N
126317	1397	1346120746000	16227	8248	1	0	\N
126318	2134	98584758000	16227	8248	2	0	\N
126319	2133	98564130000	16227	8248	3	0	\N
126320	2133	98563128000	16227	8248	4	0	\N
126321	2134	98583755000	16227	8248	5	0	\N
126322	2132	148891892000	16227	8248	6	0	\N
126323	1397	1346140748000	16228	8247	0	0	\N
126324	1397	1346130747000	16228	8247	1	0	\N
126325	1397	1346120746000	16228	8247	2	0	\N
126326	2133	98565132000	16228	8247	3	0	\N
126327	2133	98564130000	16228	8247	4	0	\N
126328	2133	98563128000	16228	8247	5	0	\N
126329	2132	148891892000	16228	8247	6	0	\N
126330	2134	98585761000	16228	8247	7	0	\N
126331	2134	98584758000	16228	8247	8	0	\N
126332	2134	98583755000	16228	8247	9	0	\N
126342	1397	1346080742000	16232	8252	0	0	\N
126343	2133	98560122000	16232	8252	1	0	\N
126344	2134	98579743000	16232	8252	2	0	\N
126216	1726	137435109000	16208	8236	2	0	8172
126217	1726	136225109000	16208	8236	3	0	8173
126218	1726	135015109000	16208	8236	4	0	8174
126219	2134	98599803000	16208	8236	5	0	399
126220	2133	98579160000	16208	8236	6	0	420
126222	1729	18091975279700	16208	8236	8	0	6
126223	1729	18000749223850	16208	8236	9	0	7
126224	1729	17835943880750	16208	8236	10	0	8
126225	1397	1346280762000	16209	8237	0	0	9255
126226	2133	98578158000	16209	8237	1	0	421
126238	1397	1346270761000	16211	8238	0	0	9256
126239	1397	1346260760000	16211	8238	1	0	9257
126240	2132	148895896000	16211	8238	2	0	104
126241	2134	98597797000	16211	8238	3	0	401
126243	2133	98577156000	16211	8238	5	0	422
126244	2133	98576154000	16211	8238	6	0	423
126250	1397	1346250759000	16213	8239	0	0	9258
126251	1397	1346240758000	16213	8239	1	0	9259
126252	2134	98595791000	16213	8239	2	0	403
126254	2133	98575152000	16213	8239	4	0	424
126255	2133	98574150000	16213	8239	5	0	425
126263	1397	1346230757000	16215	8240	0	0	9260
126264	1397	1346220756000	16215	8240	1	0	9261
126265	2132	148894895000	16215	8240	2	0	105
126267	2133	98573148000	16215	8240	4	0	426
126268	2133	98572146000	16215	8240	5	0	427
126269	1397	1346210755000	16216	8241	0	0	9262
126270	2134	98592782000	16216	8241	1	0	406
126275	1397	1346200754000	16218	8242	0	0	9263
126276	2132	148893894000	16218	8242	1	0	106
126277	2134	98591779000	16218	8242	2	0	407
126278	2133	98570142000	16218	8242	3	0	429
126283	1397	1346190753000	16220	8243	0	0	9264
126285	2133	98569140000	16220	8243	2	0	430
126286	1397	1346180752000	16221	8244	0	0	9265
126287	2134	98589773000	16221	8244	1	0	409
126288	1397	1346170751000	16222	8245	0	0	9266
126289	2133	98568138000	16222	8245	1	0	431
126298	1397	1346160750000	16224	8246	0	0	9267
126299	1397	1346150749000	16224	8246	1	0	9268
126300	2132	148892893000	16224	8246	2	0	107
126301	2134	98587767000	16224	8246	3	0	411
126303	1729	17280942880750	16224	8246	5	0	9
126304	2133	98567136000	16224	8246	6	0	432
126305	2133	98566134000	16224	8246	7	0	433
126306	1397	1346140748000	16225	8247	0	0	9269
126307	2133	98565132000	16225	8247	1	0	434
126309	1397	1346130747000	16226	8248	0	0	9270
126310	1397	1346120746000	16226	8248	1	0	9271
126311	2134	98584758000	16226	8248	2	0	414
126312	2133	98564130000	16226	8248	3	0	435
126313	2133	98563128000	16226	8248	4	0	436
126315	2132	148891892000	16226	8248	6	0	108
126333	1397	1346110745000	16229	8249	0	0	9272
126334	2134	98582752000	16229	8249	1	0	416
126335	2133	98562126000	16229	8249	2	0	437
126337	2134	98581749000	16230	8250	1	0	417
126338	2132	148890891000	16230	8250	2	0	109
126339	2133	98561124000	16230	8250	3	0	438
126340	1397	1346090743000	16231	8251	0	0	9274
126341	2134	98580746000	16231	8251	1	0	418
126348	1397	1346080742000	16234	8252	0	0	\N
126349	2133	98560122000	16234	8252	1	0	\N
126350	2134	98579743000	16234	8252	2	0	\N
126351	1726	138645109000	16235	8210	0	0	\N
126352	1726	137435109000	16235	8210	1	0	\N
126353	1726	136225109000	16235	8210	2	0	\N
126354	1726	135015109000	16235	8210	3	0	\N
126355	1724	7148325000000	16235	8210	4	0	\N
126356	1684	16531440880623	16235	8210	5	0	\N
126357	1684	16530438880623	16235	8210	6	0	\N
126358	1684	16530434880623	16235	8210	7	0	\N
126359	1684	13680424880623	16235	8210	8	0	\N
126360	1729	18203081000000	16235	8210	9	0	\N
126361	1729	18091975279700	16235	8210	10	0	\N
126362	1729	18000749223850	16235	8210	11	0	\N
126363	1729	17835943880750	16235	8210	12	0	\N
126364	1729	17280942880750	16235	8210	13	0	\N
126369	1397	1346060740000	16237	8254	0	0	\N
126370	1724	7147319000000	16237	8254	1	0	\N
126371	2133	98558118000	16237	8254	2	0	\N
126372	2134	98577737000	16237	8254	3	0	\N
126373	2132	148889890000	16237	8254	4	0	\N
126379	1397	1346400774000	16239	8228	0	0	\N
126380	1726	138645109000	16239	8228	1	0	\N
126381	1726	137435109000	16239	8228	2	0	\N
126382	1397	1346390773000	16239	8228	3	0	\N
126383	1397	1346380772000	16239	8228	4	0	\N
126384	1397	1346370771000	16239	8228	5	0	\N
126385	1397	1346360770000	16239	8228	6	0	\N
126386	1726	136225109000	16239	8228	7	0	\N
126387	1726	135015109000	16239	8228	8	0	\N
126388	1397	1346350769000	16239	8228	9	0	\N
126389	1397	1346340768000	16239	8228	10	0	\N
126390	1397	1346330767000	16239	8228	11	0	\N
126391	1397	1346320766000	16239	8228	12	0	\N
126392	1397	1346310765000	16239	8228	13	0	\N
126393	1397	1346300764000	16239	8228	14	0	\N
126394	1397	1346290763000	16239	8228	15	0	\N
126395	1397	1346280762000	16239	8228	16	0	\N
126396	1397	1346270761000	16239	8228	17	0	\N
126397	1397	1346260760000	16239	8228	18	0	\N
126398	1397	1346250759000	16239	8228	19	0	\N
126399	1397	1346240758000	16239	8228	20	0	\N
126400	1397	1346230757000	16239	8228	21	0	\N
126401	1397	1346220756000	16239	8228	22	0	\N
126402	1397	1346210755000	16239	8228	23	0	\N
126403	1397	1346200754000	16239	8228	24	0	\N
126404	1397	1346190753000	16239	8228	25	0	\N
126405	1397	1346180752000	16239	8228	26	0	\N
126406	1397	1346170751000	16239	8228	27	0	\N
126407	1397	1346160750000	16239	8228	28	0	\N
126408	1397	1346150749000	16239	8228	29	0	\N
126409	1397	1346140748000	16239	8228	30	0	\N
126410	1397	1346130747000	16239	8228	31	0	\N
126411	1397	1346120746000	16239	8228	32	0	\N
126412	1397	1346110745000	16239	8228	33	0	\N
126413	1397	1346100744000	16239	8228	34	0	\N
126414	1397	1346090743000	16239	8228	35	0	\N
126415	1397	1346080742000	16239	8228	36	0	\N
126416	1397	1346070741000	16239	8228	37	0	\N
126417	1397	1346060740000	16239	8228	38	0	\N
126418	1724	7148325000000	16239	8228	39	0	\N
126419	1724	7147319000000	16239	8228	40	0	\N
126420	1684	16530434880623	16239	8228	41	0	\N
126421	1684	13680424880623	16239	8228	42	0	\N
126422	2132	148899900000	16239	8228	43	0	\N
126423	2132	148898899000	16239	8228	44	0	\N
126424	2132	148897898000	16239	8228	45	0	\N
126425	2132	148896897000	16239	8228	46	0	\N
126426	2132	148895896000	16239	8228	47	0	\N
126427	2132	148894895000	16239	8228	48	0	\N
126428	2132	148893894000	16239	8228	49	0	\N
126429	2132	148892893000	16239	8228	50	0	\N
126430	1729	18203081000000	16239	8228	51	0	\N
126431	1729	18091975279700	16239	8228	52	0	\N
126432	1729	18000749223850	16239	8228	53	0	\N
126433	1729	17835943880750	16239	8228	54	0	\N
126434	1729	17280942880750	16239	8228	55	0	\N
126435	2132	148891892000	16239	8228	56	0	\N
126436	2132	148890891000	16239	8228	57	0	\N
126437	2133	98589180000	16239	8228	58	0	\N
126438	2134	98610836000	16239	8228	59	0	\N
126439	2132	148889890000	16239	8228	60	0	\N
126440	1397	1346180752000	16240	8244	0	0	\N
126441	1397	1346170751000	16240	8244	1	0	\N
126442	1397	1346160750000	16240	8244	2	0	\N
126443	1397	1346150749000	16240	8244	3	0	\N
126444	1397	1346140748000	16240	8244	4	0	\N
126445	1397	1346130747000	16240	8244	5	0	\N
126446	1397	1346120746000	16240	8244	6	0	\N
126447	1397	1346110745000	16240	8244	8	0	\N
126448	1397	1346100744000	16240	8244	9	0	\N
126449	1397	1346090743000	16240	8244	10	0	\N
126450	1397	1346080742000	16240	8244	11	0	\N
126451	1397	1346070741000	16240	8244	12	0	\N
126452	1397	1346060740000	16240	8244	13	0	\N
126453	1724	7148325000000	16240	8244	14	0	\N
126454	1724	7147319000000	16240	8244	15	0	\N
126455	2134	98589773000	16240	8244	16	0	\N
126456	2132	148892893000	16240	8244	17	0	\N
126457	1729	17280942880750	16240	8244	18	0	\N
126458	2133	98568138000	16240	8244	19	0	\N
126459	2133	98567136000	16240	8244	20	0	\N
126460	2133	98566134000	16240	8244	21	0	\N
126461	2133	98565132000	16240	8244	22	0	\N
126462	2133	98564130000	16240	8244	23	0	\N
126463	2133	98563128000	16240	8244	24	0	\N
126464	2133	98562126000	16240	8244	25	0	\N
126465	2132	148891892000	16240	8244	26	0	\N
126466	2132	148890891000	16240	8244	27	0	\N
126467	2134	98588770000	16240	8244	28	0	\N
126471	1397	1346050739000	16242	8255	0	0	\N
126472	2134	98576734000	16242	8255	1	0	\N
126473	2133	98557116000	16242	8255	2	0	\N
126477	1397	1346030737000	16244	8257	0	0	\N
126478	2134	98574728000	16244	8257	1	0	\N
126479	2132	148888889000	16244	8257	2	0	\N
126480	2133	98555112000	16244	8257	3	0	\N
126347	2134	98579743000	16233	8252	2	0	419
126365	1397	1346070741000	16236	8253	0	0	9276
126366	1724	7148325000000	16236	8253	1	0	8
126367	2133	98559120000	16236	8253	2	0	440
126368	2134	98578740000	16236	8253	3	0	420
126375	1724	7147319000000	16238	8254	1	0	9
126376	2133	98558118000	16238	8254	2	0	441
126377	2134	98577737000	16238	8254	3	0	421
126378	2132	148889890000	16238	8254	4	0	110
126468	1397	1346050739000	16241	8255	0	0	9278
126470	2133	98557116000	16241	8255	2	0	442
126474	1397	1346040738000	16243	8256	0	0	9279
126475	2134	98575731000	16243	8256	1	0	423
126476	2133	98556114000	16243	8256	2	0	443
126485	1397	1346020736000	16246	8258	0	0	\N
126486	2134	98573725000	16246	8258	1	0	\N
126489	1397	1346020736000	16248	8258	0	0	\N
126490	2134	98573725000	16248	8258	1	0	\N
126491	1397	1346020736000	16249	8258	0	0	\N
126492	2134	98573725000	16249	8258	1	0	\N
126493	1397	1346020736000	16250	8258	0	0	\N
126494	2134	98573725000	16250	8258	1	0	\N
126495	1397	1346020736000	16251	8258	0	0	\N
126496	2134	98573725000	16251	8258	1	0	\N
126510	1397	1345980732000	16256	8262	0	0	\N
126511	2134	98569713000	16256	8262	1	0	\N
126512	2133	98551104000	16256	8262	2	0	\N
126513	1397	1345980732000	16257	8262	0	0	\N
126514	2134	98569713000	16257	8262	1	0	\N
126515	2133	98551104000	16257	8262	2	0	\N
126516	1726	138645109000	16258	8159	0	0	\N
126517	1397	1347320866000	16258	8159	1	0	\N
126518	1726	137435109000	16258	8159	2	0	\N
126519	1397	1347310865000	16258	8159	3	0	\N
126520	1397	1347300864000	16258	8159	4	0	\N
126521	1397	1347290863000	16258	8159	5	0	\N
126522	1397	1347280862000	16258	8159	6	0	\N
126523	1726	136225109000	16258	8159	7	0	\N
126524	1726	135015109000	16258	8159	8	0	\N
126525	1397	1347270861000	16258	8159	9	0	\N
126526	1397	1347260860000	16258	8159	10	0	\N
126527	1397	1347250859000	16258	8159	11	0	\N
126528	1397	1347240858000	16258	8159	12	0	\N
126529	1397	1347230857000	16258	8159	13	0	\N
126530	1397	1347220856000	16258	8159	14	0	\N
126531	1397	1347210855000	16258	8159	15	0	\N
126532	1397	1347200854000	16258	8159	16	0	\N
126533	1397	1347190853000	16258	8159	17	0	\N
126534	1397	1347180852000	16258	8159	18	0	\N
126535	1397	1347170851000	16258	8159	19	0	\N
126536	1397	1347160850000	16258	8159	20	0	\N
126537	1397	1347150849000	16258	8159	21	0	\N
126538	1397	1347140848000	16258	8159	22	0	\N
126539	1397	1347130847000	16258	8159	23	0	\N
126540	1397	1347120846000	16258	8159	24	0	\N
126541	1397	1347110845000	16258	8159	25	0	\N
126542	1397	1347100844000	16258	8159	26	0	\N
126543	1397	1347090843000	16258	8159	27	0	\N
126544	1397	1347080842000	16258	8159	28	0	\N
126545	1397	1347070841000	16258	8159	29	0	\N
126546	1397	1347060840000	16258	8159	30	0	\N
126547	1397	1347050839000	16258	8159	31	0	\N
126548	1397	1347040838000	16258	8159	32	0	\N
126549	1397	1347030837000	16258	8159	33	0	\N
126550	1397	1347020836000	16258	8159	34	0	\N
126551	1397	1347010835000	16258	8159	35	0	\N
126552	1397	1347000834000	16258	8159	36	0	\N
126553	1397	1346990833000	16258	8159	37	0	\N
126554	1397	1346980832000	16258	8159	38	0	\N
126555	1397	1346970831000	16258	8159	39	0	\N
126556	1397	1346960830000	16258	8159	40	0	\N
126557	1397	1346950829000	16258	8159	41	0	\N
126558	1397	1346940828000	16258	8159	42	0	\N
126559	1397	1346930827000	16258	8159	43	0	\N
126560	1397	1346920826000	16258	8159	44	0	\N
126561	1397	1346910825000	16258	8159	45	0	\N
126562	1397	1346900824000	16258	8159	46	0	\N
126563	1397	1346890823000	16258	8159	47	0	\N
126564	1397	1346880822000	16258	8159	48	0	\N
126565	1397	1346870821000	16258	8159	49	0	\N
126566	1397	1346860820000	16258	8159	50	0	\N
126567	1397	1346850819000	16258	8159	51	0	\N
126568	1397	1346840818000	16258	8159	52	0	\N
126569	1397	1346830817000	16258	8159	53	0	\N
126570	1397	1346820816000	16258	8159	55	0	\N
126571	1397	1346810815000	16258	8159	56	0	\N
126572	1397	1346800814000	16258	8159	57	0	\N
126573	1397	1346790813000	16258	8159	58	0	\N
126574	1397	1346780812000	16258	8159	59	0	\N
126575	1397	1346770811000	16258	8159	60	0	\N
126576	1397	1346760810000	16258	8159	61	0	\N
126577	1397	1346750809000	16258	8159	62	0	\N
126578	1397	1346740808000	16258	8159	63	0	\N
126579	1397	1346730807000	16258	8159	64	0	\N
126580	1397	1346720806000	16258	8159	65	0	\N
126581	1397	1346710805000	16258	8159	66	0	\N
126582	1397	1346700804000	16258	8159	67	0	\N
126583	1397	1346690803000	16258	8159	68	0	\N
126584	1397	1346680802000	16258	8159	69	0	\N
126585	1397	1346670801000	16258	8159	70	0	\N
126586	1397	1346660800000	16258	8159	71	0	\N
126587	1397	1346650799000	16258	8159	72	0	\N
126588	1397	1346640798000	16258	8159	73	0	\N
126589	1397	1346630797000	16258	8159	74	0	\N
126590	1397	1346620796000	16258	8159	75	0	\N
126591	1397	1346610795000	16258	8159	76	0	\N
126592	1397	1346600794000	16258	8159	77	0	\N
126593	1397	1346590793000	16258	8159	78	0	\N
126594	1397	1346580792000	16258	8159	79	0	\N
126595	1397	1346570791000	16258	8159	80	0	\N
126596	1397	1346560790000	16258	8159	81	0	\N
126597	1397	1346550789000	16258	8159	82	0	\N
126598	1397	1346540788000	16258	8159	83	0	\N
126599	1397	1346530787000	16258	8159	84	0	\N
126600	1397	1346520786000	16258	8159	85	0	\N
126601	1397	1346510785000	16258	8159	86	0	\N
126602	1397	1346500784000	16258	8159	87	0	\N
126603	1397	1346490783000	16258	8159	88	0	\N
126604	1397	1346480782000	16258	8159	89	0	\N
126605	1397	1346470781000	16258	8159	90	0	\N
126606	1397	1346460780000	16258	8159	91	0	\N
126607	1397	1346450779000	16258	8159	92	0	\N
126608	1397	1346440778000	16258	8159	93	0	\N
126609	1397	1346430777000	16258	8159	94	0	\N
126610	1397	1346420776000	16258	8159	95	0	\N
126611	1397	1346410775000	16258	8159	96	0	\N
126612	1397	1346400774000	16258	8159	97	0	\N
126613	1397	1346390773000	16258	8159	98	0	\N
126614	1397	1346380772000	16258	8159	99	0	\N
126615	1397	1346370771000	16258	8159	100	0	\N
126616	1397	1346360770000	16258	8159	101	0	\N
126483	2132	148888889000	16245	8257	2	0	111
126484	2133	98555112000	16245	8257	3	0	444
126487	1397	1346020736000	16247	8258	0	0	9281
126488	2134	98573725000	16247	8258	1	0	425
126497	1397	1346010735000	16252	8259	0	0	9282
126499	2133	98554110000	16252	8259	2	0	445
126500	1397	1346000734000	16253	8260	0	0	9283
126501	2134	98571719000	16253	8260	1	0	427
126502	2132	148887888000	16253	8260	2	0	112
126503	2133	98553108000	16253	8260	3	0	446
126505	2133	98552106000	16254	8261	1	0	447
126506	2134	98570716000	16254	8261	2	0	428
126507	1397	1345980732000	16255	8262	0	0	9285
126508	2134	98569713000	16255	8262	1	0	429
126617	1397	1346350769000	16258	8159	102	0	\N
126618	1397	1346340768000	16258	8159	103	0	\N
126619	1397	1346330767000	16258	8159	104	0	\N
126620	1397	1346320766000	16258	8159	105	0	\N
126621	1397	1346310765000	16258	8159	106	0	\N
126622	1397	1346300764000	16258	8159	107	0	\N
126623	1397	1346290763000	16258	8159	108	0	\N
126624	1397	1346280762000	16258	8159	109	0	\N
126625	1397	1346270761000	16258	8159	110	0	\N
126626	1397	1346260760000	16258	8159	111	0	\N
126627	1397	1346250759000	16258	8159	112	0	\N
126628	1397	1346240758000	16258	8159	113	0	\N
126629	1397	1346230757000	16258	8159	114	0	\N
126630	1397	1346220756000	16258	8159	115	0	\N
126631	1397	1346210755000	16258	8159	116	0	\N
126632	1397	1346200754000	16258	8159	117	0	\N
126633	1397	1346190753000	16258	8159	118	0	\N
126634	1397	1346180752000	16258	8159	119	0	\N
126635	1397	1346170751000	16258	8159	120	0	\N
126636	1397	1346160750000	16258	8159	121	0	\N
126637	1397	1346150749000	16258	8159	122	0	\N
126638	1397	1346140748000	16258	8159	123	0	\N
126639	1397	1346130747000	16258	8159	124	0	\N
126640	1397	1346120746000	16258	8159	125	0	\N
126641	1397	1345970731000	16259	8263	0	0	\N
126642	2134	98568710000	16259	8263	1	0	\N
126643	2133	98550102000	16259	8263	2	0	\N
126647	1397	1345960730000	16261	8264	0	0	\N
126648	1397	1345950729000	16261	8264	1	0	\N
126649	2134	98567707000	16261	8264	2	0	\N
126650	2134	98566704000	16261	8264	3	0	\N
126651	2132	148886887000	16261	8264	4	0	\N
126666	1397	1345920726000	16264	8266	0	0	\N
126667	2133	98545092000	16264	8266	1	0	\N
126668	2134	98563695000	16264	8266	2	0	\N
126695	1397	1345840718000	16271	8271	0	0	\N
126696	1397	1345830717000	16271	8271	1	0	\N
126697	2132	148882883000	16271	8271	2	0	\N
126698	1769	1699900000	16271	8271	3	0	\N
126699	2134	98555671000	16271	8271	4	0	\N
126700	2134	98554668000	16271	8271	5	0	\N
126701	2133	98538078000	16271	8271	6	0	\N
126702	2133	98537076000	16271	8271	7	0	\N
126711	1397	1345840718000	16273	8271	0	0	\N
126712	1397	1345830717000	16273	8271	1	0	\N
126713	2132	148882883000	16273	8271	2	0	\N
126714	1769	1699900000	16273	8271	3	0	\N
126715	2134	98555671000	16273	8271	4	0	\N
126716	2134	98554668000	16273	8271	5	0	\N
126717	2133	98538078000	16273	8271	6	0	\N
126718	2133	98537076000	16273	8271	7	0	\N
126725	1397	1345800714000	16276	8274	0	0	\N
126726	2132	148881882000	16276	8274	1	0	\N
126727	2134	98551659000	16276	8274	2	0	\N
126728	2133	98534070000	16276	8274	3	0	\N
126733	1397	1345800714000	16278	8274	0	0	\N
126734	2132	148881882000	16278	8274	1	0	\N
126735	2134	98551659000	16278	8274	2	0	\N
126736	2133	98534070000	16278	8274	3	0	\N
126737	1397	1345800714000	16279	8274	0	0	\N
126738	2132	148881882000	16279	8274	1	0	\N
126739	2134	98551659000	16279	8274	2	0	\N
126740	2133	98534070000	16279	8274	3	0	\N
126741	1397	1345800714000	16280	8274	0	0	\N
126742	2132	148881882000	16280	8274	1	0	\N
126743	2134	98551659000	16280	8274	2	0	\N
126744	2133	98534070000	16280	8274	3	0	\N
126745	1397	1345790713000	16281	8275	0	0	\N
126746	2134	98550656000	16281	8275	1	0	\N
126747	1397	1345790713000	16282	8275	0	0	\N
126748	2134	98550656000	16282	8275	1	0	\N
126749	2133	98533068000	16282	8275	2	0	\N
126750	1397	1345790713000	16283	8275	0	0	\N
126751	2134	98550656000	16283	8275	1	0	\N
126752	2133	98533068000	16283	8275	2	0	\N
126646	2133	98550102000	16260	8263	2	0	449
126652	1397	1345960730000	16262	8264	0	0	9287
126653	1397	1345950729000	16262	8264	1	0	9288
126654	2134	98567707000	16262	8264	2	0	431
126655	2134	98566704000	16262	8264	3	0	432
126657	2132	148886887000	16262	8264	5	0	113
126658	2133	98548098000	16262	8264	6	0	451
126659	1397	1345940728000	16263	8265	0	0	9289
126660	1397	1345930727000	16263	8265	1	0	9290
126661	2134	98565701000	16263	8265	2	0	433
126663	2133	98546094000	16263	8265	4	0	453
126664	2132	148885886000	16263	8265	5	0	114
126665	2134	98564698000	16263	8265	6	0	434
126669	1397	1345920726000	16265	8266	0	0	9291
126671	2134	98563695000	16265	8266	2	0	435
126672	1397	1345910725000	16268	8268	0	0	9292
126673	1397	1345900724000	16268	8268	1	0	9293
126674	2134	98562692000	16268	8268	2	0	436
126675	2133	98544090000	16268	8268	3	0	455
126677	2132	148884885000	16268	8268	5	0	115
126678	2134	98561689000	16268	8268	6	0	437
126679	1397	1345890723000	16269	8269	0	0	9294
126680	2133	98542086000	16269	8269	1	0	457
126681	2134	98560686000	16269	8269	2	0	438
126683	1397	1345870721000	16270	8270	1	0	9296
126684	1397	1345860720000	16270	8270	2	0	9297
126685	1397	1345850719000	16270	8270	3	0	9298
126686	2132	148883884000	16270	8270	4	0	116
126688	2133	98540082000	16270	8270	6	0	459
126689	2133	98539080000	16270	8270	7	0	460
126690	1769	1700900000	16270	8270	8	0	33
126691	2134	98559683000	16270	8270	9	0	439
126692	2134	98558680000	16270	8270	10	0	440
126694	2134	98556674000	16270	8270	12	0	442
126703	1397	1345840718000	16272	8271	0	0	9299
126704	1397	1345830717000	16272	8271	1	0	9300
126705	2132	148882883000	16272	8271	2	0	117
126706	1769	1699900000	16272	8271	3	0	34
126708	2134	98554668000	16272	8271	5	0	444
126709	2133	98538078000	16272	8271	6	0	461
126710	2133	98537076000	16272	8271	7	0	462
126719	1397	1345820716000	16274	8272	0	0	9301
126721	2133	98536074000	16274	8272	2	0	463
126722	1397	1345810715000	16275	8273	0	0	9302
126723	2133	98535072000	16275	8273	1	0	464
126724	2134	98552662000	16275	8273	2	0	446
126729	1397	1345800714000	16277	8274	0	0	9303
126731	2134	98551659000	16277	8274	2	0	447
126732	2133	98534070000	16277	8274	3	0	465
126753	1397	1345790713000	16284	8275	0	0	\N
126754	2134	98550656000	16284	8275	1	0	\N
126755	2133	98533068000	16284	8275	2	0	\N
126759	1397	1345780712000	16287	8276	0	0	\N
126760	2134	98549653000	16287	8276	1	0	\N
126761	1397	1345780712000	16288	8276	0	0	\N
126762	2133	98532066000	16288	8276	1	0	\N
126763	2134	98549653000	16288	8276	2	0	\N
126764	1397	1345780712000	16289	8276	0	0	\N
126765	2133	98532066000	16289	8276	1	0	\N
126775	1397	1346110745000	16293	8160	0	0	\N
126776	1397	1346100744000	16293	8160	1	0	\N
126777	1397	1346090743000	16293	8160	2	0	\N
126778	1397	1346080742000	16293	8160	3	0	\N
126779	1397	1346070741000	16293	8160	4	0	\N
126780	1397	1346060740000	16293	8160	5	0	\N
126781	1397	1346050739000	16293	8160	6	0	\N
126782	1397	1346040738000	16293	8160	7	0	\N
126783	1397	1346030737000	16293	8160	8	0	\N
126784	1397	1346020736000	16293	8160	9	0	\N
126785	1397	1346010735000	16293	8160	10	0	\N
126786	1397	1346000734000	16293	8160	11	0	\N
126787	1397	1345990733000	16293	8160	12	0	\N
126788	1397	1345980732000	16293	8160	13	0	\N
126789	1397	1345970731000	16293	8160	14	0	\N
126790	1397	1345960730000	16293	8160	15	0	\N
126791	1397	1345950729000	16293	8160	16	0	\N
126792	1397	1345940728000	16293	8160	17	0	\N
126793	1397	1345930727000	16293	8160	18	0	\N
126794	1397	1345920726000	16293	8160	19	0	\N
126795	1397	1345910725000	16293	8160	20	0	\N
126796	1397	1345900724000	16293	8160	21	0	\N
126797	1397	1345890723000	16293	8160	22	0	\N
126798	1397	1345880722000	16293	8160	23	0	\N
126799	1397	1345870721000	16293	8160	24	0	\N
126800	1397	1345860720000	16293	8160	25	0	\N
126801	1397	1345850719000	16293	8160	26	0	\N
126802	1397	1345840718000	16293	8160	27	0	\N
126803	1397	1345830717000	16293	8160	28	0	\N
126804	1397	1345820716000	16293	8160	29	0	\N
126805	1397	1345810715000	16293	8160	30	0	\N
126806	1397	1345800714000	16293	8160	31	0	\N
126807	1397	1345790713000	16293	8160	32	0	\N
126808	1397	1345780712000	16293	8160	33	0	\N
126809	1397	1345770711000	16293	8160	34	0	\N
126810	1724	7148325000000	16293	8160	35	0	\N
126811	1724	7147319000000	16293	8160	36	0	\N
126812	1684	15811428880623	16293	8160	37	0	\N
126813	1684	15810426880623	16293	8160	38	0	\N
126814	1684	15810422880623	16293	8160	39	0	\N
126815	1684	12960412880623	16293	8160	40	0	\N
126816	2133	98679360000	16293	8160	41	0	\N
126817	2134	98703112000	16293	8160	42	0	\N
126818	2134	98702109000	16293	8160	43	0	\N
126819	2134	98701106000	16293	8160	44	0	\N
126820	2133	98678358000	16293	8160	45	0	\N
126821	2133	98677356000	16293	8160	46	0	\N
126822	2133	98676354000	16293	8160	47	0	\N
126823	2133	98675352000	16293	8160	48	0	\N
126824	2133	98674350000	16293	8160	49	0	\N
126825	1749	5945222000000	16293	8160	50	0	\N
126826	1749	4445221000000	16293	8160	51	0	\N
126827	2132	148927928000	16293	8160	52	0	\N
126828	1729	18203081000000	16293	8160	53	0	\N
126829	1729	18091975279700	16293	8160	55	0	\N
126830	1729	18000749223850	16293	8160	56	0	\N
126831	1729	17835943880750	16293	8160	57	0	\N
126832	1729	17280942880750	16293	8160	58	0	\N
126833	2132	148926927000	16293	8160	59	0	\N
126834	2132	148925926000	16293	8160	60	0	\N
126835	2132	148924925000	16293	8160	61	0	\N
126836	2132	148923924000	16293	8160	62	0	\N
126837	2132	148922923000	16293	8160	63	0	\N
126838	2132	148921922000	16293	8160	64	0	\N
126839	2132	148920921000	16293	8160	65	0	\N
126840	2133	98673348000	16293	8160	66	0	\N
126841	2133	98672346000	16293	8160	67	0	\N
126842	2133	98671344000	16293	8160	68	0	\N
126843	2133	98670342000	16293	8160	69	0	\N
126844	2133	98669340000	16293	8160	70	0	\N
126845	2133	98668338000	16293	8160	71	0	\N
126846	2133	98667336000	16293	8160	72	0	\N
126847	2133	98666334000	16293	8160	73	0	\N
126848	2133	98665332000	16293	8160	74	0	\N
126849	2133	98664330000	16293	8160	75	0	\N
126850	2133	98663328000	16293	8160	76	0	\N
126851	2133	98662326000	16293	8160	77	0	\N
126852	2133	98661324000	16293	8160	78	0	\N
126853	2133	98660322000	16293	8160	79	0	\N
126854	2133	98659320000	16293	8160	80	0	\N
126855	2133	98658318000	16293	8160	81	0	\N
126856	2133	98657316000	16293	8160	82	0	\N
126857	2133	98656314000	16293	8160	83	0	\N
126858	2133	98655312000	16293	8160	84	0	\N
126859	2133	98654310000	16293	8160	85	0	\N
126860	2133	98653308000	16293	8160	86	0	\N
126861	2133	98652306000	16293	8160	87	0	\N
126862	2133	98651304000	16293	8160	88	0	\N
126863	2133	98650302000	16293	8160	89	0	\N
126864	2133	98649300000	16293	8160	90	0	\N
126865	2133	98648298000	16293	8160	91	0	\N
126866	2133	98647296000	16293	8160	92	0	\N
126867	2133	98646294000	16293	8160	93	0	\N
126868	2133	98645292000	16293	8160	94	0	\N
126869	2133	98644290000	16293	8160	95	0	\N
126870	2133	98643288000	16293	8160	96	0	\N
126871	2133	98642286000	16293	8160	97	0	\N
126872	2133	98641284000	16293	8160	98	0	\N
126873	2133	98640282000	16293	8160	99	0	\N
126874	2133	98639280000	16293	8160	100	0	\N
126875	2133	98638278000	16293	8160	101	0	\N
126876	2133	98637276000	16293	8160	102	0	\N
126877	1769	1700900000	16293	8160	103	0	\N
126878	1769	1699900000	16293	8160	104	0	\N
126879	2134	98700103000	16293	8160	105	0	\N
126880	2134	98699100000	16293	8160	106	0	\N
126881	2134	98698097000	16293	8160	107	0	\N
126882	2134	98697094000	16293	8160	108	0	\N
126883	2134	98696091000	16293	8160	109	0	\N
126884	2134	98695088000	16293	8160	110	0	\N
126885	2134	98694085000	16293	8160	111	0	\N
126886	2134	98693082000	16293	8160	112	0	\N
126887	2134	98692079000	16293	8160	113	0	\N
126888	2134	98691076000	16293	8160	114	0	\N
126758	2133	98533068000	16285	8275	2	0	466
126766	1397	1345780712000	16290	8276	0	0	9305
126767	2133	98532066000	16290	8276	1	0	467
126768	2134	98549653000	16290	8276	2	0	449
126769	1397	1345770711000	16291	8277	0	0	9306
126771	1397	1345760710000	16292	8278	0	0	9307
126772	2132	148880881000	16292	8278	1	0	119
126773	2134	98548650000	16292	8278	2	0	450
126774	2133	98530062000	16292	8278	3	0	469
126889	2134	98690073000	16293	8160	115	0	\N
126890	2134	98689070000	16293	8160	116	0	\N
126891	2134	98688067000	16293	8160	117	0	\N
126892	2134	98687064000	16293	8160	118	0	\N
126893	2134	98686061000	16293	8160	119	0	\N
126894	2134	98685058000	16293	8160	120	0	\N
126895	2134	98684055000	16293	8160	121	0	\N
126896	2134	98683052000	16293	8160	122	0	\N
126897	2134	98682049000	16293	8160	123	0	\N
126898	2134	98681046000	16293	8160	124	0	\N
126899	2134	98680043000	16293	8160	125	0	\N
126906	1397	1345730707000	16295	8280	0	0	\N
126907	2133	98527056000	16295	8280	1	0	\N
126908	2132	148879880000	16295	8280	2	0	\N
126909	2134	98545641000	16295	8280	3	0	\N
126917	1397	1345710705000	16298	8282	0	0	\N
126918	2133	98525052000	16298	8282	1	0	\N
126919	2134	98543635000	16298	8282	2	0	\N
126920	1397	1345710705000	16299	8282	0	0	\N
126921	2133	98525052000	16299	8282	1	0	\N
126922	2134	98543635000	16299	8282	2	0	\N
126932	1397	1345690703000	16303	8284	0	0	\N
126933	2133	98524050000	16303	8284	1	0	\N
126934	2134	98541629000	16303	8284	2	0	\N
126935	1397	1345680702000	16304	8285	0	0	\N
126936	2134	98540626000	16304	8285	1	0	\N
126937	2133	98523048000	16304	8285	2	0	\N
126941	1397	1345960730000	16306	8264	0	0	\N
126942	1397	1345950729000	16306	8264	1	0	\N
126943	1397	1345940728000	16306	8264	2	0	\N
126944	1397	1345930727000	16306	8264	3	0	\N
126945	1397	1345920726000	16306	8264	4	0	\N
126946	1397	1345910725000	16306	8264	5	0	\N
126947	1397	1345900724000	16306	8264	6	0	\N
126948	1397	1345890723000	16306	8264	7	0	\N
126949	1397	1345880722000	16306	8264	8	0	\N
126950	1397	1345870721000	16306	8264	9	0	\N
126951	1397	1345860720000	16306	8264	10	0	\N
126952	1397	1345850719000	16306	8264	11	0	\N
126953	1397	1345840718000	16306	8264	12	0	\N
126954	1397	1345830717000	16306	8264	13	0	\N
126955	1397	1345820716000	16306	8264	14	0	\N
126956	1397	1345810715000	16306	8264	15	0	\N
126957	1397	1345800714000	16306	8264	16	0	\N
126958	1397	1345790713000	16306	8264	17	0	\N
126959	1397	1345780712000	16306	8264	18	0	\N
126960	1397	1345770711000	16306	8264	19	0	\N
126961	1397	1345760710000	16306	8264	20	0	\N
126962	1397	1345750709000	16306	8264	21	0	\N
126963	1397	1345740708000	16306	8264	22	0	\N
126964	1397	1345730707000	16306	8264	24	0	\N
126965	1397	1345720706000	16306	8264	25	0	\N
126966	1397	1345710705000	16306	8264	26	0	\N
126967	1397	1345700704000	16306	8264	27	0	\N
126968	1397	1345690703000	16306	8264	28	0	\N
126969	1397	1345680702000	16306	8264	29	0	\N
126970	2134	98567707000	16306	8264	30	0	\N
126971	2134	98566704000	16306	8264	31	0	\N
126972	2134	98565701000	16306	8264	32	0	\N
126973	2133	98549100000	16306	8264	33	0	\N
126974	2132	148886887000	16306	8264	34	0	\N
126975	2133	98548098000	16306	8264	35	0	\N
126976	2133	98547096000	16306	8264	36	0	\N
126977	2133	98546094000	16306	8264	37	0	\N
126978	2133	98545092000	16306	8264	38	0	\N
126979	2133	98544090000	16306	8264	39	0	\N
126980	2133	98543088000	16306	8264	40	0	\N
126981	2133	98542086000	16306	8264	41	0	\N
126982	2133	98541084000	16306	8264	42	0	\N
126983	2133	98540082000	16306	8264	43	0	\N
126984	2133	98539080000	16306	8264	44	0	\N
126985	1769	1700900000	16306	8264	45	0	\N
126986	1769	1699900000	16306	8264	46	0	\N
126987	2132	148885886000	16306	8264	47	0	\N
126988	2132	148884885000	16306	8264	48	0	\N
126989	2132	148883884000	16306	8264	49	0	\N
126990	2132	148882883000	16306	8264	50	0	\N
126991	2132	148881882000	16306	8264	51	0	\N
126992	2132	148880881000	16306	8264	52	0	\N
126993	2132	148879880000	16306	8264	53	0	\N
126994	2132	148878879000	16306	8264	54	0	\N
126995	2134	98564698000	16306	8264	55	0	\N
126996	2134	98563695000	16306	8264	56	0	\N
126997	2134	98562692000	16306	8264	57	0	\N
126998	2134	98561689000	16306	8264	58	0	\N
126999	2134	98560686000	16306	8264	59	0	\N
127000	2133	98538078000	16306	8264	60	0	\N
127001	2133	98537076000	16306	8264	61	0	\N
127002	2133	98536074000	16306	8264	62	0	\N
127003	2133	98535072000	16306	8264	63	0	\N
127004	2134	98559683000	16306	8264	64	0	\N
127005	2134	98558680000	16306	8264	65	0	\N
127006	2134	98557677000	16306	8264	66	0	\N
127007	2134	98556674000	16306	8264	67	0	\N
127008	2134	98555671000	16306	8264	68	0	\N
127009	2134	98554668000	16306	8264	69	0	\N
127010	2134	98553665000	16306	8264	70	0	\N
127011	2134	98552662000	16306	8264	71	0	\N
127012	2134	98551659000	16306	8264	72	0	\N
127013	2134	98550656000	16306	8264	73	0	\N
127014	2134	98549653000	16306	8264	74	0	\N
127015	2134	98548650000	16306	8264	75	0	\N
127016	2134	98547647000	16306	8264	76	0	\N
127017	2134	98546644000	16306	8264	77	0	\N
127018	2134	98545641000	16306	8264	78	0	\N
127019	2134	98544638000	16306	8264	79	0	\N
127020	2134	98543635000	16306	8264	80	0	\N
127021	2134	98542632000	16306	8264	81	0	\N
127022	2134	98541629000	16306	8264	82	0	\N
127023	2134	98540626000	16306	8264	83	0	\N
127024	2133	98534070000	16306	8264	84	0	\N
126902	2134	98547647000	16294	8279	2	0	451
126903	2133	98529060000	16294	8279	3	0	470
126904	2133	98528058000	16294	8279	4	0	471
126905	2134	98546644000	16294	8279	5	0	452
126910	1397	1345730707000	16296	8280	0	0	9310
126912	2132	148879880000	16296	8280	2	0	120
126913	2134	98545641000	16296	8280	3	0	453
126914	1397	1345720706000	16297	8281	0	0	9311
126915	2133	98526054000	16297	8281	1	0	473
126916	2134	98544638000	16297	8281	2	0	454
126924	2133	98525052000	16300	8282	1	0	474
126925	2134	98543635000	16300	8282	2	0	455
126926	1397	1345700704000	16301	8283	0	0	9313
126927	2134	98542632000	16301	8283	1	0	456
126929	1397	1345690703000	16302	8284	0	0	9314
126930	2133	98524050000	16302	8284	1	0	475
126931	2134	98541629000	16302	8284	2	0	457
126938	1397	1345680702000	16305	8285	0	0	9315
126939	2134	98540626000	16305	8285	1	0	458
127025	2133	98533068000	16306	8264	85	0	\N
127026	2133	98532066000	16306	8264	86	0	\N
127027	2133	98531064000	16306	8264	87	0	\N
127028	2133	98530062000	16306	8264	88	0	\N
127029	2133	98529060000	16306	8264	89	0	\N
127030	2133	98528058000	16306	8264	90	0	\N
127031	2133	98527056000	16306	8264	91	0	\N
127032	2133	98526054000	16306	8264	92	0	\N
127033	2133	98525052000	16306	8264	93	0	\N
127034	2133	98524050000	16306	8264	94	0	\N
127035	2133	98523048000	16306	8264	95	0	\N
127039	1397	1345660700000	16308	8287	0	0	\N
127040	1397	1345650699000	16308	8287	1	0	\N
127041	2132	148877878000	16308	8287	2	0	\N
127042	2134	98538620000	16308	8287	3	0	\N
127043	2134	98537617000	16308	8287	4	0	\N
127044	2133	98521044000	16308	8287	5	0	\N
127045	2133	98520042000	16308	8287	6	0	\N
127046	1397	1345660700000	16309	8287	0	0	\N
127047	1397	1345650699000	16309	8287	1	0	\N
127048	2132	148877878000	16309	8287	2	0	\N
127049	2134	98538620000	16309	8287	3	0	\N
127050	2134	98537617000	16309	8287	4	0	\N
127051	2133	98521044000	16309	8287	5	0	\N
127052	2133	98520042000	16309	8287	6	0	\N
127053	1397	1345660700000	16310	8287	0	0	\N
127054	1397	1345650699000	16310	8287	1	0	\N
127055	2132	148877878000	16310	8287	2	0	\N
127056	2134	98538620000	16310	8287	3	0	\N
127057	2134	98537617000	16310	8287	4	0	\N
127058	2133	98521044000	16310	8287	5	0	\N
127059	2133	98520042000	16310	8287	6	0	\N
127060	1397	1345660700000	16311	8287	0	0	\N
127061	1397	1345650699000	16311	8287	1	0	\N
127062	2132	148877878000	16311	8287	2	0	\N
127063	2134	98538620000	16311	8287	3	0	\N
127064	2134	98537617000	16311	8287	4	0	\N
127065	2133	98521044000	16311	8287	5	0	\N
127066	2133	98520042000	16311	8287	6	0	\N
127087	2144	100000000	16316	8291	0	0	\N
127088	1397	1345600694000	16316	8291	1	0	\N
127089	2134	98532602000	16316	8291	2	0	\N
127090	2132	148875876000	16316	8291	3	0	\N
127091	2133	98515032000	16316	8291	4	0	\N
127092	2144	100000000	16317	8291	0	0	\N
127093	1397	1345600694000	16317	8291	1	0	\N
127094	2134	98532602000	16317	8291	2	0	\N
127095	2132	148875876000	16317	8291	3	0	\N
127096	2133	98515032000	16317	8291	4	0	\N
127102	2144	100000000	16319	8291	0	0	\N
127103	1397	1345600694000	16319	8291	1	0	\N
127104	2134	98532602000	16319	8291	2	0	\N
127105	2132	148875876000	16319	8291	3	0	\N
127106	2133	98515032000	16319	8291	4	0	\N
127125	1397	1345530687000	16326	8298	0	0	\N
127126	2132	148873874000	16326	8298	1	0	\N
127127	2134	98525581000	16326	8298	2	0	\N
127128	2133	98509020000	16326	8298	3	0	\N
127160	495	66719920000000	16330	8300	0	0	\N
127038	2133	98522046000	16307	8286	2	0	477
127067	1397	1345660700000	16312	8287	0	0	9317
127068	1397	1345650699000	16312	8287	1	0	9318
127069	2132	148877878000	16312	8287	2	0	122
127070	2134	98538620000	16312	8287	3	0	460
127072	2133	98521044000	16312	8287	5	0	478
127073	2133	98520042000	16312	8287	6	0	479
127074	1397	1345640698000	16313	8288	0	0	9319
127075	2133	98519040000	16313	8288	1	0	480
127076	2134	98536614000	16313	8288	2	0	462
127078	2134	98535611000	16314	8289	1	0	463
127079	2132	148876877000	16314	8289	2	0	123
127080	2133	98518038000	16314	8289	3	0	481
127081	1397	1345620696000	16315	8290	0	0	9321
127083	2133	98517036000	16315	8290	2	0	482
127084	2133	98516034000	16315	8290	3	0	483
127085	2134	98534608000	16315	8290	4	0	464
127086	2134	98533605000	16315	8290	5	0	465
127097	2144	100000000	16318	8291	0	0	1
127099	2134	98532602000	16318	8291	2	0	466
127100	2132	148875876000	16318	8291	3	0	124
127101	2133	98515032000	16318	8291	4	0	484
127107	1397	1345590693000	16320	8292	0	0	9324
127108	2133	98514030000	16320	8292	1	0	485
127110	1397	1345580692000	16321	8293	0	0	9325
127111	2134	98530596000	16321	8293	1	0	468
127112	1397	1345570691000	16322	8294	0	0	9326
127113	2133	98513028000	16322	8294	1	0	486
127115	1397	1345560690000	16323	8295	0	0	9327
127116	2134	98528590000	16323	8295	1	0	470
127117	2132	148874875000	16323	8295	2	0	125
127118	2133	98512026000	16323	8295	3	0	487
127119	1397	1345550689000	16324	8296	0	0	9328
127121	2134	98527587000	16324	8296	2	0	471
127122	1397	1345540688000	16325	8297	0	0	9329
127123	2133	98510022000	16325	8297	1	0	489
127124	2134	98526584000	16325	8297	2	0	472
127129	1397	1345530687000	16327	8298	0	0	9330
127131	2134	98525581000	16327	8298	2	0	473
127132	2133	98509020000	16327	8298	3	0	490
127133	1397	1345520686000	16328	8299	0	0	9331
127134	1397	1345510685000	16328	8299	1	0	9332
127136	2133	98507016000	16328	8299	3	0	492
127137	2134	98524578000	16328	8299	4	0	474
127138	2134	98523575000	16328	8299	5	0	475
127139	495	66719920000000	16329	8300	0	0	1
127140	1397	1345500684000	16329	8300	1	0	9333
127142	1397	1345480682000	16329	8300	3	0	9335
127143	1397	1345470681000	16329	8300	4	0	9336
127144	1397	1345460680000	16329	8300	5	0	9337
127145	1397	1345450679000	16329	8300	6	0	9338
127146	2133	98506014000	16329	8300	7	0	493
127148	2134	98521569000	16329	8300	9	0	477
127149	2134	98520566000	16329	8300	10	0	478
127150	2134	98519563000	16329	8300	11	0	479
127151	2134	98518560000	16329	8300	12	0	480
127153	2133	98505012000	16329	8300	14	0	494
127154	2133	98504010000	16329	8300	15	0	495
127155	2133	98503008000	16329	8300	16	0	496
127156	2133	98502006000	16329	8300	17	0	497
127157	2133	98501004000	16329	8300	18	0	498
127159	2132	148871872000	16329	8300	20	0	128
127161	1397	1345500684000	16330	8300	1	0	\N
127162	1397	1345490683000	16330	8300	2	0	\N
127163	1397	1345480682000	16330	8300	3	0	\N
127164	1397	1345470681000	16330	8300	4	0	\N
127165	1397	1345460680000	16330	8300	5	0	\N
127166	1397	1345450679000	16330	8300	6	0	\N
127167	2133	98506014000	16330	8300	7	0	\N
127168	2134	98522572000	16330	8300	8	0	\N
127169	2134	98521569000	16330	8300	9	0	\N
127170	2134	98520566000	16330	8300	10	0	\N
127171	2134	98519563000	16330	8300	11	0	\N
127172	2134	98518560000	16330	8300	12	0	\N
127173	2134	98517557000	16330	8300	13	0	\N
127174	2133	98505012000	16330	8300	14	0	\N
127175	2133	98504010000	16330	8300	15	0	\N
127176	2133	98503008000	16330	8300	16	0	\N
127177	2133	98502006000	16330	8300	17	0	\N
127178	2133	98501004000	16330	8300	18	0	\N
127179	2132	148872873000	16330	8300	19	0	\N
127180	2132	148871872000	16330	8300	20	0	\N
127184	1397	1345430677000	16332	8302	0	0	\N
127185	2134	98515551000	16332	8302	1	0	\N
127186	2132	148870871000	16332	8302	2	0	\N
127187	2133	98499000000	16332	8302	3	0	\N
127188	1397	1345430677000	16333	8302	0	0	\N
127189	2134	98515551000	16333	8302	1	0	\N
127190	2132	148870871000	16333	8302	2	0	\N
127191	2133	98499000000	16333	8302	3	0	\N
127226	1397	1345340668000	16343	8310	0	0	\N
127227	2133	98489982000	16343	8310	1	0	\N
127228	2134	98507527000	16343	8310	2	0	\N
127236	1397	1345320666000	16346	8312	0	0	\N
127237	2133	98487978000	16346	8312	1	0	\N
127238	2134	98505521000	16346	8312	2	0	\N
127242	1397	1345310665000	16348	8313	0	0	\N
127243	2134	98504518000	16348	8313	1	0	\N
127244	2133	98486976000	16348	8313	2	0	\N
127245	1397	1345310665000	16349	8313	0	0	\N
127246	2134	98504518000	16349	8313	1	0	\N
127247	2133	98486976000	16349	8313	2	0	\N
127251	1397	1345300664000	16351	8314	0	0	\N
127252	2133	98485974000	16351	8314	1	0	\N
127253	2134	98503515000	16351	8314	2	0	\N
127287	1397	1345190653000	16356	8319	0	0	\N
127288	2133	98474952000	16356	8319	1	0	\N
127289	2134	98492482000	16356	8319	2	0	\N
127290	2132	148863864000	16356	8319	3	0	\N
127291	1397	1345190653000	16357	8319	0	0	\N
127292	2133	98474952000	16357	8319	1	0	\N
127293	2134	98492482000	16357	8319	2	0	\N
127294	2132	148863864000	16357	8319	3	0	\N
127183	2134	98516554000	16331	8301	2	0	482
127192	1397	1345430677000	16334	8302	0	0	9340
127193	2134	98515551000	16334	8302	1	0	483
127194	2132	148870871000	16334	8302	2	0	129
127195	2133	98499000000	16334	8302	3	0	500
127197	1397	1345420676000	16335	8303	1	0	9341
127198	1397	1345410675000	16335	8303	2	0	9342
127199	2133	98497998000	16335	8303	3	0	501
127200	2133	98496996000	16335	8303	4	0	502
127201	2134	98514548000	16335	8303	5	0	484
127203	2133	98495994000	16336	8304	1	0	503
127204	2132	148869870000	16336	8304	2	0	130
127205	2134	98513545000	16336	8304	3	0	485
127206	1397	1345390673000	16337	8305	0	0	9344
127208	2133	98494992000	16337	8305	2	0	504
127209	1397	1345380672000	16338	8306	0	0	9345
127210	2133	98493990000	16338	8306	1	0	505
127211	2134	98511539000	16338	8306	2	0	487
127212	495	66709720000000	16339	8307	0	0	3
127214	2133	98492988000	16339	8307	2	0	506
127215	2134	98510536000	16339	8307	3	0	488
127216	1397	1345360670000	16340	8308	0	0	9347
127217	2134	98509533000	16340	8308	1	0	489
127218	2132	148868869000	16340	8308	2	0	131
127220	1397	1345350669000	16341	8309	0	0	9348
127221	2133	98490984000	16341	8309	1	0	508
127222	2134	98508530000	16341	8309	2	0	490
127223	1397	1345340668000	16342	8310	0	0	9349
127225	2134	98507527000	16342	8310	2	0	491
127229	1397	1345330667000	16344	8311	0	0	9350
127230	2134	98506524000	16344	8311	1	0	492
127231	2132	148867868000	16344	8311	2	0	132
127232	2133	98488980000	16344	8311	3	0	510
127234	2133	98487978000	16345	8312	1	0	511
127235	2134	98505521000	16345	8312	2	0	493
127239	1397	1345310665000	16347	8313	0	0	9352
127240	2134	98504518000	16347	8313	1	0	494
127241	2133	98486976000	16347	8313	2	0	512
127249	2133	98485974000	16350	8314	1	0	513
127250	2134	98503515000	16350	8314	2	0	495
127254	1397	1345290663000	16352	8315	0	0	9354
127255	1397	1345280662000	16352	8315	1	0	9355
127257	1397	1345260660000	16352	8315	3	0	9357
127258	2132	148866867000	16352	8315	4	0	133
127259	2132	148865866000	16352	8315	5	0	134
127260	2134	98502512000	16352	8315	6	0	496
127261	2134	98501509000	16352	8315	7	0	497
127263	2134	98499503000	16352	8315	9	0	499
127264	2133	98484972000	16352	8315	10	0	514
127265	2133	98483970000	16352	8315	11	0	515
127266	2133	98482968000	16352	8315	12	0	516
127267	2133	98481966000	16352	8315	13	0	517
127269	1397	1345240658000	16353	8316	1	0	9359
127270	1397	1345230657000	16353	8316	2	0	9360
127271	2133	98480964000	16353	8316	3	0	518
127272	2133	98479962000	16353	8316	4	0	519
127274	2132	148864865000	16353	8316	6	0	135
127275	2134	98498500000	16353	8316	7	0	500
127276	2134	98497497000	16353	8316	8	0	501
127277	2134	98496494000	16353	8316	9	0	502
127278	1397	1345220656000	16354	8317	0	0	9361
127280	2133	98477958000	16354	8317	2	0	521
127281	2133	98476956000	16354	8317	3	0	522
127282	2134	98495491000	16354	8317	4	0	503
127283	2134	98494488000	16354	8317	5	0	504
127284	1397	1345200654000	16355	8318	0	0	9363
127286	2134	98493485000	16355	8318	2	0	505
127295	1397	1345190653000	16358	8319	0	0	9364
127296	2133	98474952000	16358	8319	1	0	524
127305	1397	1345160650000	16360	8321	0	0	\N
127306	2133	98471946000	16360	8321	1	0	\N
127307	2134	98489473000	16360	8321	2	0	\N
127308	2132	148862863000	16360	8321	3	0	\N
127316	1397	1345150649000	16363	8322	0	0	\N
127317	2134	98488470000	16363	8322	1	0	\N
127322	369	97346510000000	16365	8323	0	0	\N
127323	369	92607910000000	16365	8323	1	0	\N
127324	369	89410610000000	16365	8323	2	0	\N
127325	1397	1345140648000	16365	8323	3	0	\N
127326	1397	1345130647000	16365	8323	4	0	\N
127327	563	66000617000000	16365	8323	5	0	\N
127328	2133	98469942000	16365	8323	6	0	\N
127329	2132	148861862000	16365	8323	7	0	\N
127330	2133	98468940000	16365	8323	8	0	\N
127331	2134	98487467000	16365	8323	9	0	\N
127332	2134	98486464000	16365	8323	10	0	\N
127344	2134	98484458000	16367	8325	0	0	\N
127345	2133	98466936000	16367	8325	1	0	\N
127348	2134	98484458000	16369	8325	0	0	\N
127349	2133	98466936000	16369	8325	1	0	\N
127353	1397	1345110645000	16371	8326	0	0	\N
127354	2134	98483455000	16371	8326	1	0	\N
127364	495	66719920000000	16374	8233	0	0	\N
127365	369	97346510000000	16374	8233	1	0	\N
127366	369	92607910000000	16374	8233	2	0	\N
127367	369	89410610000000	16374	8233	3	0	\N
127368	369	80501410000000	16374	8233	4	0	\N
127369	495	66709820000000	16374	8233	5	0	\N
127370	495	66709720000000	16374	8233	6	0	\N
127371	1724	7148325000000	16374	8233	7	0	\N
127372	1724	7147319000000	16374	8233	8	0	\N
127373	563	66000617000000	16374	8233	9	0	\N
127374	1729	18203081000000	16374	8233	10	0	\N
127375	1729	18091975279700	16374	8233	11	0	\N
127376	1729	18000749223850	16374	8233	12	0	\N
127377	1729	17835943880750	16374	8233	13	0	\N
127378	1729	17280942880750	16374	8233	14	0	\N
127379	1769	1700900000	16374	8233	15	0	\N
127380	1769	1699900000	16374	8233	16	0	\N
127391	1397	1345050639000	16377	8330	0	0	\N
127392	2134	98477437000	16377	8330	1	0	\N
127393	2133	98460924000	16377	8330	2	0	\N
127394	1397	1345050639000	16378	8330	0	0	\N
127395	2134	98477437000	16378	8330	1	0	\N
127396	2133	98460924000	16378	8330	2	0	\N
127397	1397	1345050639000	16379	8330	0	0	\N
127398	2134	98477437000	16379	8330	1	0	\N
127399	2133	98460924000	16379	8330	2	0	\N
127409	1397	1345010635000	16382	8333	0	0	\N
127410	2133	98456916000	16382	8333	1	0	\N
127411	2134	98474428000	16382	8333	2	0	\N
127415	1397	1345010635000	16384	8333	0	0	\N
127416	2133	98456916000	16384	8333	1	0	\N
127417	2134	98474428000	16384	8333	2	0	\N
127425	1397	1344990633000	16387	8335	0	0	\N
127426	2133	98454912000	16387	8335	1	0	\N
127427	2134	98472422000	16387	8335	2	0	\N
127299	1397	1345180652000	16359	8320	0	0	9365
127300	1397	1345170651000	16359	8320	1	0	9366
127301	2134	98491479000	16359	8320	2	0	507
127302	2134	98490476000	16359	8320	3	0	508
127303	2133	98473950000	16359	8320	4	0	525
127309	1397	1345160650000	16361	8321	0	0	9367
127310	2133	98471946000	16361	8321	1	0	527
127311	2134	98489473000	16361	8321	2	0	509
127312	2132	148862863000	16361	8321	3	0	137
127313	1397	1345150649000	16362	8322	0	0	9368
127315	2133	98470944000	16362	8322	2	0	528
127318	369	97346510000000	16364	8323	0	0	1
127319	1397	1345140648000	16364	8323	1	0	9369
127320	2133	98469942000	16364	8323	2	0	529
127333	369	92607910000000	16366	8324	0	0	2
127334	369	89410610000000	16366	8324	1	0	3
127335	369	80501410000000	16366	8324	2	0	4
127336	1397	1345130647000	16366	8324	3	0	9370
127337	1397	1345120646000	16366	8324	4	0	9371
127339	2132	148861862000	16366	8324	6	0	138
127340	2134	98486464000	16366	8324	7	0	512
127341	2134	98485461000	16366	8324	8	0	513
127342	2133	98468940000	16366	8324	9	0	530
127343	2133	98467938000	16366	8324	10	0	531
127347	2133	98466936000	16368	8325	1	0	532
127350	1397	1345110645000	16370	8326	0	0	9372
127351	2133	98465934000	16370	8326	1	0	533
127352	2134	98483455000	16370	8326	2	0	515
127356	2132	148860861000	16372	8327	1	0	139
127357	2134	98482452000	16372	8327	2	0	516
127358	2133	98464932000	16372	8327	3	0	534
127359	1397	1345090643000	16373	8328	0	0	9374
127360	1397	1345080642000	16373	8328	1	0	9375
127362	2134	98481449000	16373	8328	3	0	517
127363	2134	98480446000	16373	8328	4	0	518
127381	1397	1345070641000	16375	8329	0	0	9376
127382	1397	1345060640000	16375	8329	1	0	9377
127383	2133	98462928000	16375	8329	2	0	536
127385	2134	98478440000	16375	8329	4	0	520
127386	2133	98461926000	16375	8329	5	0	537
127387	2132	148859860000	16375	8329	6	0	140
127388	1397	1345050639000	16376	8330	0	0	9378
127390	2133	98460924000	16376	8330	2	0	538
127400	1397	1345040638000	16380	8331	0	0	9379
127401	1397	1345030637000	16380	8331	1	0	9380
127402	2134	98476434000	16380	8331	2	0	522
127403	2133	98459922000	16380	8331	3	0	539
127405	2132	148858859000	16380	8331	5	0	141
127406	1397	1345020636000	16381	8332	0	0	9381
127407	2134	98475431000	16381	8332	1	0	523
127408	2133	98457918000	16381	8332	2	0	541
127412	1397	1345010635000	16383	8333	0	0	9382
127414	2134	98474428000	16383	8333	2	0	524
127418	1397	1345000634000	16385	8334	0	0	9383
127419	2133	98455914000	16385	8334	1	0	543
127420	2132	148857858000	16385	8334	2	0	142
127422	1397	1344990633000	16386	8335	0	0	9384
127423	2133	98454912000	16386	8335	1	0	544
127424	2134	98472422000	16386	8335	2	0	526
127428	1397	1344980632000	16388	8336	0	0	9385
127429	1397	1344970631000	16388	8336	1	0	9386
127431	2134	98470416000	16388	8336	3	0	528
127432	2132	148856857000	16388	8336	4	0	143
127446	1397	1344930627000	16390	8338	0	0	\N
127447	2133	98448900000	16390	8338	1	0	\N
127448	2134	98466404000	16390	8338	2	0	\N
127449	1769	1697900000	16390	8338	3	0	\N
127454	1397	1344930627000	16392	8338	0	0	\N
127455	1397	1344920626000	16392	8338	1	0	\N
127456	2133	98448900000	16392	8338	2	0	\N
127457	2134	98466404000	16392	8338	3	0	\N
127458	2133	98447898000	16392	8338	4	0	\N
127459	1769	1697900000	16392	8338	5	0	\N
127460	2134	98465401000	16392	8338	6	0	\N
127461	1769	1698900000	16393	8334	0	0	\N
127462	1769	1697900000	16393	8334	1	0	\N
127473	1397	1344920626000	16395	8339	0	0	\N
127474	1397	1344910625000	16395	8339	1	0	\N
127475	1397	1344900624000	16395	8339	2	0	\N
127476	2133	98447898000	16395	8339	3	0	\N
127477	2133	98446896000	16395	8339	4	0	\N
127478	2132	148854855000	16395	8339	5	0	\N
127479	2133	98445894000	16395	8339	6	0	\N
127480	2134	98465401000	16395	8339	7	0	\N
127481	2134	98464398000	16395	8339	8	0	\N
127482	2134	98463395000	16395	8339	9	0	\N
127483	1397	1344890623000	16396	8340	0	0	\N
127484	2134	98462392000	16396	8340	1	0	\N
127485	2133	98444892000	16396	8340	2	0	\N
127497	1397	1344860620000	16399	8342	0	0	\N
127498	2134	98459383000	16399	8342	1	0	\N
127499	2133	98441886000	16399	8342	2	0	\N
127503	1397	1344850619000	16401	8343	0	0	\N
127504	1397	1344840618000	16401	8343	1	0	\N
127505	2134	98458380000	16401	8343	3	0	\N
127506	2134	98457377000	16401	8343	4	0	\N
127507	2133	98440884000	16401	8343	5	0	\N
127508	2132	148852853000	16401	8343	6	0	\N
127509	2133	98439882000	16401	8343	7	0	\N
127520	1397	1344830617000	16404	8344	0	0	\N
127521	2133	98438880000	16404	8344	1	0	\N
127522	2134	98456374000	16404	8344	2	0	\N
127529	1397	1344800614000	16407	8347	0	0	\N
127530	2132	148851852000	16407	8347	1	0	\N
127531	1397	1344800614000	16408	8347	0	0	\N
127532	2134	98453365000	16408	8347	1	0	\N
127533	2132	148851852000	16408	8347	2	0	\N
127537	1397	1344800614000	16410	8347	0	0	\N
127538	2134	98453365000	16410	8347	1	0	\N
127539	2132	148851852000	16410	8347	2	0	\N
127546	1397	1344770611000	16412	8349	0	0	\N
127547	2132	148850851000	16412	8349	1	0	\N
127548	2133	98433870000	16412	8349	2	0	\N
127549	2134	98450356000	16412	8349	3	0	\N
127550	1397	1344770611000	16413	8349	0	0	\N
127551	2132	148850851000	16413	8349	1	0	\N
127552	2133	98433870000	16413	8349	2	0	\N
127553	2134	98450356000	16413	8349	3	0	\N
127554	1397	1344770611000	16414	8349	0	0	\N
127555	2132	148850851000	16414	8349	1	0	\N
127556	2133	98433870000	16414	8349	2	0	\N
127557	2134	98450356000	16414	8349	3	0	\N
127562	1397	1344760610000	16416	8350	0	0	\N
127563	2134	98449353000	16416	8350	1	0	\N
127564	2133	98432868000	16416	8350	2	0	\N
127567	1397	1344760610000	16418	8350	0	0	\N
127568	2134	98449353000	16418	8350	1	0	\N
127435	1397	1344960630000	16389	8337	0	0	9387
127436	1397	1344950629000	16389	8337	1	0	9388
127437	1397	1344940628000	16389	8337	2	0	9389
127438	2132	148855856000	16389	8337	3	0	144
127439	2134	98469413000	16389	8337	4	0	529
127441	1769	1698900000	16389	8337	6	0	35
127442	2134	98468410000	16389	8337	7	0	530
127443	2134	98467407000	16389	8337	8	0	531
127444	2133	98450904000	16389	8337	9	0	548
127445	2133	98449902000	16389	8337	10	0	549
127451	2133	98448900000	16391	8338	1	0	550
127452	2134	98466404000	16391	8338	2	0	532
127453	1769	1697900000	16391	8338	3	0	36
127463	1397	1344920626000	16394	8339	0	0	9391
127465	1397	1344900624000	16394	8339	2	0	9393
127466	2133	98447898000	16394	8339	3	0	551
127467	2133	98446896000	16394	8339	4	0	552
127468	2132	148854855000	16394	8339	5	0	145
127469	2133	98445894000	16394	8339	6	0	553
127471	2134	98464398000	16394	8339	8	0	534
127472	2134	98463395000	16394	8339	9	0	535
127486	1397	1344890623000	16397	8340	0	0	9394
127487	2134	98462392000	16397	8340	1	0	536
127488	2133	98444892000	16397	8340	2	0	554
127490	1726	133805109000	16398	8341	1	0	8175
127491	1397	1344870621000	16398	8341	2	0	9396
127492	2133	98443890000	16398	8341	3	0	555
127493	2134	98461389000	16398	8341	4	0	537
127495	2132	148853854000	16398	8341	6	0	146
127496	2133	98442888000	16398	8341	7	0	556
127500	1397	1344860620000	16400	8342	0	0	9397
127501	2134	98459383000	16400	8342	1	0	539
127502	2133	98441886000	16400	8342	2	0	557
127511	1397	1344840618000	16402	8343	1	0	9399
127512	2134	98458380000	16402	8343	3	0	540
127513	2134	98457377000	16402	8343	4	0	541
127514	2133	98440884000	16402	8343	5	0	558
127515	2132	148852853000	16402	8343	6	0	147
127517	1397	1344830617000	16403	8344	0	0	9400
127518	2133	98438880000	16403	8344	1	0	560
127519	2134	98456374000	16403	8344	2	0	542
127523	1397	1344820616000	16405	8345	0	0	9401
127525	2134	98455371000	16405	8345	2	0	543
127526	1397	1344810615000	16406	8346	0	0	9402
127527	2133	98436876000	16406	8346	1	0	562
127528	2134	98454368000	16406	8346	2	0	544
127534	1397	1344800614000	16409	8347	0	0	9403
127536	2132	148851852000	16409	8347	2	0	148
127540	1397	1344790613000	16411	8348	0	0	9404
127541	1397	1344780612000	16411	8348	1	0	9405
127542	2133	98435874000	16411	8348	2	0	563
127543	2134	98452362000	16411	8348	3	0	546
127545	2133	98434872000	16411	8348	5	0	564
127558	1397	1344770611000	16415	8349	0	0	9406
127559	2132	148850851000	16415	8349	1	0	149
127560	2133	98433870000	16415	8349	2	0	565
127565	2134	98449353000	16417	8350	0	0	549
127566	2133	98432868000	16417	8350	1	0	566
127569	2133	98432868000	16418	8350	2	0	\N
127574	1397	1344740608000	16420	8352	0	0	\N
127575	2134	98447347000	16420	8352	1	0	\N
127576	2132	148849850000	16420	8352	2	0	\N
127577	2133	98430864000	16420	8352	3	0	\N
127582	1397	1344740608000	16422	8352	0	0	\N
127583	2134	98447347000	16422	8352	1	0	\N
127584	2132	148849850000	16422	8352	2	0	\N
127585	2133	98430864000	16422	8352	3	0	\N
127586	1397	1344730607000	16423	8353	0	0	\N
127587	1397	1344720606000	16423	8353	1	0	\N
127588	2133	98429862000	16423	8353	2	0	\N
127589	2133	98428860000	16423	8353	3	0	\N
127590	2134	98446344000	16423	8353	4	0	\N
127591	2134	98445341000	16423	8353	5	0	\N
127598	1397	1344730607000	16425	8353	0	0	\N
127599	1397	1344720606000	16425	8353	1	0	\N
127600	2133	98429862000	16425	8353	2	0	\N
127601	2133	98428860000	16425	8353	3	0	\N
127602	2134	98446344000	16425	8353	4	0	\N
127603	2134	98445341000	16425	8353	5	0	\N
127608	1397	1344710605000	16427	8354	0	0	\N
127609	1769	1696900000	16427	8354	1	0	\N
127610	2133	98427858000	16427	8354	2	0	\N
127611	2134	98444338000	16427	8354	3	0	\N
127612	1397	1344700604000	16428	8355	0	0	\N
127613	2132	148848849000	16428	8355	1	0	\N
127614	2134	98443335000	16428	8355	2	0	\N
127615	2133	98426856000	16428	8355	3	0	\N
127620	1397	1344700604000	16430	8355	0	0	\N
127621	2132	148848849000	16430	8355	1	0	\N
127622	2134	98443335000	16430	8355	2	0	\N
127623	2133	98426856000	16430	8355	3	0	\N
127624	1397	1344690603000	16431	8356	0	0	\N
127625	1397	1344680602000	16431	8356	1	0	\N
127626	2134	98442332000	16431	8356	2	0	\N
127627	1769	1695900000	16431	8356	3	0	\N
127628	2133	98425854000	16431	8356	4	0	\N
127629	1769	1694900000	16431	8356	5	0	\N
127630	2133	98424852000	16431	8356	6	0	\N
127631	1397	1344690603000	16432	8356	0	0	\N
127632	1397	1344680602000	16432	8356	1	0	\N
127633	2134	98442332000	16432	8356	2	0	\N
127634	1769	1695900000	16432	8356	3	0	\N
127635	2133	98425854000	16432	8356	4	0	\N
127636	1769	1694900000	16432	8356	5	0	\N
127637	2133	98424852000	16432	8356	6	0	\N
127657	1397	1344640598000	16435	8358	0	0	\N
127658	2132	148846847000	16435	8358	1	0	\N
127659	1769	1692900000	16435	8358	2	0	\N
127660	2134	98438320000	16435	8358	3	0	\N
127665	1397	1344630597000	16437	8359	0	0	\N
127666	2133	98420844000	16437	8359	1	0	\N
127667	2134	98437317000	16437	8359	2	0	\N
127670	1397	1344630597000	16439	8360	0	0	\N
127671	2134	98436314000	16439	8360	1	0	\N
127672	2133	98419842000	16439	8360	2	0	\N
127676	2134	98436314000	16441	8360	0	0	\N
127677	2133	98419842000	16441	8360	1	0	\N
127698	1397	1344590593000	16446	8364	0	0	\N
127699	1397	1344580592000	16446	8364	1	0	\N
127700	1397	1344570591000	16446	8364	2	0	\N
127701	2133	98415834000	16446	8364	3	0	\N
127702	2134	98432302000	16446	8364	4	0	\N
127703	2132	148844845000	16446	8364	5	0	\N
127704	2133	98414832000	16446	8364	6	0	\N
127572	2134	98448350000	16419	8351	2	0	550
127573	2133	98431866000	16419	8351	3	0	567
127578	1397	1344740608000	16421	8352	0	0	9409
127579	2134	98447347000	16421	8352	1	0	551
127580	2132	148849850000	16421	8352	2	0	150
127592	1397	1344730607000	16424	8353	0	0	9410
127593	1397	1344720606000	16424	8353	1	0	9411
127594	2133	98429862000	16424	8353	2	0	569
127595	2133	98428860000	16424	8353	3	0	570
127596	2134	98446344000	16424	8353	4	0	552
127604	1397	1344710605000	16426	8354	0	0	9412
127605	1769	1696900000	16426	8354	1	0	37
127606	2133	98427858000	16426	8354	2	0	571
127607	2134	98444338000	16426	8354	3	0	554
127617	2132	148848849000	16429	8355	1	0	151
127618	2134	98443335000	16429	8355	2	0	555
127619	2133	98426856000	16429	8355	3	0	572
127638	1397	1344690603000	16433	8356	0	0	9414
127639	1397	1344680602000	16433	8356	1	0	9415
127641	1769	1695900000	16433	8356	3	0	38
127642	2133	98425854000	16433	8356	4	0	573
127643	1769	1694900000	16433	8356	5	0	39
127644	2133	98424852000	16433	8356	6	0	574
127645	1397	1344670601000	16434	8357	0	0	9416
127647	1692	13459946719999	16434	8357	2	0	5
127648	1397	1344650599000	16434	8357	3	0	9418
127649	2134	98441329000	16434	8357	4	0	557
127650	2133	98423850000	16434	8357	5	0	575
127652	2134	98440326000	16434	8357	7	0	558
127653	2133	98422848000	16434	8357	8	0	576
127654	2133	98421846000	16434	8357	9	0	577
127655	2132	148847848000	16434	8357	10	0	152
127656	2134	98439323000	16434	8357	11	0	559
127662	2132	148846847000	16436	8358	1	0	153
127663	1769	1692900000	16436	8358	2	0	41
127664	2134	98438320000	16436	8358	3	0	560
127668	2133	98420844000	16438	8359	0	0	578
127669	2134	98437317000	16438	8359	1	0	561
127674	2134	98436314000	16440	8360	1	0	562
127675	2133	98419842000	16440	8360	2	0	579
127678	1397	1344620596000	16442	8361	0	0	9421
127679	2134	98435311000	16442	8361	1	0	563
127681	1397	1344610595000	16443	8362	0	0	9422
127682	2133	98417838000	16443	8362	1	0	581
127683	2132	148845846000	16443	8362	2	0	154
127684	2134	98434308000	16443	8362	3	0	564
127685	1397	1344600594000	16444	8363	0	0	9423
127687	2133	98416836000	16444	8363	3	0	582
127688	1397	1344590593000	16445	8364	0	0	9424
127689	1397	1344580592000	16445	8364	1	0	9425
127690	1397	1344570591000	16445	8364	2	0	9426
127691	2133	98415834000	16445	8364	3	0	583
127693	2132	148844845000	16445	8364	5	0	155
127694	2133	98414832000	16445	8364	6	0	584
127695	2133	98413830000	16445	8364	7	0	585
127696	2134	98431299000	16445	8364	8	0	567
127705	2133	98413830000	16446	8364	7	0	\N
127706	2134	98431299000	16446	8364	8	0	\N
127707	2134	98430296000	16446	8364	9	0	\N
127717	1397	1344550589000	16449	8366	0	0	\N
127718	1397	1344540588000	16449	8366	1	0	\N
127719	2134	98428290000	16449	8366	2	0	\N
127720	2134	98427287000	16449	8366	3	0	\N
127721	2133	98412828000	16449	8366	4	0	\N
127722	2133	98411826000	16449	8366	5	0	\N
127723	2132	148843844000	16449	8366	6	0	\N
127735	1397	1344520586000	16452	8368	0	0	\N
127736	1397	1344510585000	16452	8368	1	0	\N
127737	1726	132595109000	16452	8368	2	0	\N
127738	2133	98409822000	16452	8368	3	0	\N
127739	2134	98425281000	16452	8368	4	0	\N
127740	2134	98424278000	16452	8368	5	0	\N
127741	2132	148842843000	16452	8368	6	0	\N
127742	2133	98408820000	16452	8368	7	0	\N
127743	1397	1344520586000	16453	8368	0	0	\N
127744	1397	1344510585000	16453	8368	1	0	\N
127745	1726	132595109000	16453	8368	2	0	\N
127746	2133	98409822000	16453	8368	3	0	\N
127747	2134	98425281000	16453	8368	4	0	\N
127748	2134	98424278000	16453	8368	5	0	\N
127749	2132	148842843000	16453	8368	6	0	\N
127750	2133	98408820000	16453	8368	7	0	\N
127751	1397	1344910625000	16454	8339	0	0	\N
127752	1397	1344900624000	16454	8339	1	0	\N
127753	1397	1344890623000	16454	8339	2	0	\N
127754	1397	1344880622000	16454	8339	3	0	\N
127755	1726	133805109000	16454	8339	4	0	\N
127756	1726	132595109000	16454	8339	5	0	\N
127757	1692	13459946719999	16454	8339	6	0	\N
127758	1397	1344870621000	16454	8339	7	0	\N
127759	1397	1344860620000	16454	8339	8	0	\N
127760	1397	1344850619000	16454	8339	9	0	\N
127761	1397	1344840618000	16454	8339	10	0	\N
127762	1397	1344830617000	16454	8339	11	0	\N
127763	1397	1344820616000	16454	8339	12	0	\N
127764	1397	1344810615000	16454	8339	13	0	\N
127765	1397	1344800614000	16454	8339	14	0	\N
127766	1397	1344790613000	16454	8339	15	0	\N
127767	1397	1344780612000	16454	8339	16	0	\N
127768	1397	1344770611000	16454	8339	17	0	\N
127769	1397	1344760610000	16454	8339	18	0	\N
127770	1397	1344750609000	16454	8339	19	0	\N
127771	1397	1344740608000	16454	8339	20	0	\N
127772	1397	1344730607000	16454	8339	21	0	\N
127773	1397	1344720606000	16454	8339	22	0	\N
127774	1397	1344710605000	16454	8339	23	0	\N
127775	1397	1344700604000	16454	8339	24	0	\N
127776	1397	1344690603000	16454	8339	25	0	\N
127777	1397	1344680602000	16454	8339	26	0	\N
127778	1397	1344670601000	16454	8339	27	0	\N
127779	1397	1344660600000	16454	8339	28	0	\N
127780	1397	1344650599000	16454	8339	29	0	\N
127781	1397	1344640598000	16454	8339	30	0	\N
127782	1397	1344630597000	16454	8339	32	0	\N
127783	1397	1344620596000	16454	8339	33	0	\N
127784	1397	1344610595000	16454	8339	34	0	\N
127785	1397	1344600594000	16454	8339	35	0	\N
127786	1397	1344590593000	16454	8339	36	0	\N
127787	1397	1344580592000	16454	8339	37	0	\N
127788	1397	1344570591000	16454	8339	38	0	\N
127789	1397	1344560590000	16454	8339	39	0	\N
127790	1397	1344550589000	16454	8339	40	0	\N
127791	1397	1344540588000	16454	8339	41	0	\N
127792	1397	1344530587000	16454	8339	42	0	\N
127793	1397	1344520586000	16454	8339	43	0	\N
127794	1397	1344510585000	16454	8339	44	0	\N
127795	2133	98446896000	16454	8339	45	0	\N
127796	1769	1696900000	16454	8339	46	0	\N
127797	1769	1695900000	16454	8339	47	0	\N
127798	2134	98464398000	16454	8339	48	0	\N
127799	2132	148854855000	16454	8339	49	0	\N
127800	2132	148853854000	16454	8339	50	0	\N
127801	2134	98463395000	16454	8339	51	0	\N
127802	2134	98462392000	16454	8339	52	0	\N
127803	2134	98461389000	16454	8339	53	0	\N
127804	2134	98460386000	16454	8339	54	0	\N
127805	2134	98459383000	16454	8339	55	0	\N
127806	2134	98458380000	16454	8339	56	0	\N
127807	2134	98457377000	16454	8339	57	0	\N
127808	2133	98445894000	16454	8339	58	0	\N
127809	2133	98444892000	16454	8339	59	0	\N
127810	2133	98443890000	16454	8339	60	0	\N
127811	1769	1694900000	16454	8339	61	0	\N
127812	1769	1693900000	16454	8339	62	0	\N
127813	1769	1692900000	16454	8339	63	0	\N
127814	2134	98456374000	16454	8339	64	0	\N
127815	2134	98455371000	16454	8339	65	0	\N
127816	2132	148852853000	16454	8339	66	0	\N
127817	2132	148851852000	16454	8339	67	0	\N
127818	2132	148850851000	16454	8339	68	0	\N
127819	2132	148849850000	16454	8339	69	0	\N
127820	2132	148848849000	16454	8339	70	0	\N
127821	2132	148847848000	16454	8339	71	0	\N
127822	2132	148846847000	16454	8339	72	0	\N
127823	2132	148845846000	16454	8339	73	0	\N
127824	2132	148844845000	16454	8339	74	0	\N
127825	2132	148843844000	16454	8339	75	0	\N
127826	2132	148842843000	16454	8339	76	0	\N
127827	2134	98454368000	16454	8339	77	0	\N
127828	2134	98453365000	16454	8339	78	0	\N
127829	2134	98452362000	16454	8339	79	0	\N
127830	2134	98451359000	16454	8339	80	0	\N
127831	2134	98450356000	16454	8339	81	0	\N
127832	2134	98449353000	16454	8339	82	0	\N
127833	2134	98448350000	16454	8339	83	0	\N
127834	2134	98447347000	16454	8339	84	0	\N
127835	2134	98446344000	16454	8339	85	0	\N
127836	2134	98445341000	16454	8339	86	0	\N
127837	2134	98444338000	16454	8339	87	0	\N
127838	2134	98443335000	16454	8339	88	0	\N
127839	2134	98442332000	16454	8339	89	0	\N
127840	2134	98441329000	16454	8339	90	0	\N
127710	1397	1344550589000	16448	8366	0	0	9428
127711	1397	1344540588000	16448	8366	1	0	9429
127712	2134	98428290000	16448	8366	2	0	570
127713	2134	98427287000	16448	8366	3	0	571
127714	2133	98412828000	16448	8366	4	0	586
127716	2132	148843844000	16448	8366	6	0	156
127724	1397	1344530587000	16450	8367	0	0	9430
127725	2133	98410824000	16450	8367	1	0	588
127726	2134	98426284000	16450	8367	2	0	572
127727	1397	1344520586000	16451	8368	0	0	9431
127729	1726	132595109000	16451	8368	2	0	8176
127730	2133	98409822000	16451	8368	3	0	589
127731	2134	98425281000	16451	8368	4	0	573
127732	2134	98424278000	16451	8368	5	0	574
127734	2133	98408820000	16451	8368	7	0	590
127841	2134	98440326000	16454	8339	91	0	\N
127842	2134	98439323000	16454	8339	92	0	\N
127843	2134	98438320000	16454	8339	93	0	\N
127844	2134	98437317000	16454	8339	94	0	\N
127845	2134	98436314000	16454	8339	95	0	\N
127846	2134	98435311000	16454	8339	96	0	\N
127847	2134	98434308000	16454	8339	97	0	\N
127848	2134	98433305000	16454	8339	98	0	\N
127849	2134	98432302000	16454	8339	99	0	\N
127850	2134	98431299000	16454	8339	100	0	\N
127851	2134	98430296000	16454	8339	101	0	\N
127852	2134	98429293000	16454	8339	102	0	\N
127853	2134	98428290000	16454	8339	103	0	\N
127854	2134	98427287000	16454	8339	104	0	\N
127855	2134	98426284000	16454	8339	105	0	\N
127856	2134	98425281000	16454	8339	106	0	\N
127857	2134	98424278000	16454	8339	107	0	\N
127858	2133	98442888000	16454	8339	108	0	\N
127859	2133	98441886000	16454	8339	109	0	\N
127860	2133	98440884000	16454	8339	110	0	\N
127861	2133	98439882000	16454	8339	111	0	\N
127862	2133	98438880000	16454	8339	112	0	\N
127863	2133	98437878000	16454	8339	113	0	\N
127864	2133	98436876000	16454	8339	114	0	\N
127865	2133	98435874000	16454	8339	115	0	\N
127866	2133	98434872000	16454	8339	116	0	\N
127867	2133	98433870000	16454	8339	117	0	\N
127868	2133	98432868000	16454	8339	118	0	\N
127869	2133	98431866000	16454	8339	119	0	\N
127870	2133	98430864000	16454	8339	120	0	\N
127871	2133	98429862000	16454	8339	121	0	\N
127872	2133	98428860000	16454	8339	122	0	\N
127873	2133	98427858000	16454	8339	123	0	\N
127874	2133	98426856000	16454	8339	124	0	\N
127875	2133	98425854000	16454	8339	125	0	\N
127882	1397	1344490583000	16457	8370	0	0	\N
127883	2133	98406816000	16457	8370	1	0	\N
127884	2134	98422272000	16457	8370	2	0	\N
127899	1397	1344450579000	16460	8372	0	0	\N
127900	2133	98402808000	16460	8372	1	0	\N
127901	2134	98418260000	16460	8372	2	0	\N
127902	2132	148840841000	16460	8372	3	0	\N
127903	1397	1344440578000	16461	8373	0	0	\N
127904	2133	98401806000	16461	8373	1	0	\N
127905	2134	98417257000	16461	8373	2	0	\N
127911	1397	1344430577000	16464	8374	0	0	\N
127912	2133	98400804000	16464	8374	1	0	\N
127916	1397	1344410575000	16466	8376	0	0	\N
127917	2132	148839840000	16466	8376	1	0	\N
127918	2134	98415251000	16466	8376	2	0	\N
127919	2133	98398800000	16466	8376	3	0	\N
127920	1397	1344410575000	16467	8376	0	0	\N
127921	2132	148839840000	16467	8376	1	0	\N
127922	2134	98415251000	16467	8376	2	0	\N
127923	2133	98398800000	16467	8376	3	0	\N
127928	1397	1344410575000	16469	8376	0	0	\N
127929	2132	148839840000	16469	8376	1	0	\N
127930	2134	98415251000	16469	8376	2	0	\N
127931	2133	98398800000	16469	8376	3	0	\N
127935	1397	1344400574000	16471	8377	0	0	\N
127936	2134	98414248000	16471	8377	1	0	\N
127937	2133	98397798000	16471	8377	2	0	\N
127938	1726	133805109000	16472	8331	0	0	\N
127939	1726	132595109000	16472	8331	1	0	\N
127940	1692	14179958719999	16472	8331	2	0	\N
127941	1769	1698900000	16472	8331	3	0	\N
127942	1769	1697900000	16472	8331	4	0	\N
127943	1769	1696900000	16472	8331	5	0	\N
127944	1769	1695900000	16472	8331	6	0	\N
127945	1769	1694900000	16472	8331	7	0	\N
127946	1769	1693900000	16472	8331	8	0	\N
127947	1769	1692900000	16472	8331	9	0	\N
127948	1397	1344390573000	16473	8378	0	0	\N
127949	2134	98413245000	16473	8378	1	0	\N
127950	2133	98396796000	16473	8378	2	0	\N
127954	1397	1344390573000	16475	8378	0	0	\N
127955	2134	98413245000	16475	8378	1	0	\N
127956	2133	98396796000	16475	8378	2	0	\N
127964	1397	1344360570000	16478	8381	0	0	\N
127965	2133	98393790000	16478	8381	1	0	\N
127966	2134	98410236000	16478	8381	2	0	\N
127970	1397	1344360570000	16480	8381	0	0	\N
127971	2133	98393790000	16480	8381	1	0	\N
127972	2134	98410236000	16480	8381	2	0	\N
127973	1397	1344360570000	16481	8381	0	0	\N
127974	2133	98393790000	16481	8381	1	0	\N
127975	2134	98410236000	16481	8381	2	0	\N
127878	2134	98423275000	16455	8369	2	0	575
127879	1397	1344490583000	16456	8370	0	0	9434
127880	2133	98406816000	16456	8370	1	0	592
127881	2134	98422272000	16456	8370	2	0	576
127885	1397	1344480582000	16458	8371	0	0	9435
127887	1397	1344460580000	16458	8371	2	0	9437
127888	2132	148841842000	16458	8371	3	0	158
127889	2133	98405814000	16458	8371	4	0	593
127890	2133	98404812000	16458	8371	5	0	594
127891	2133	98403810000	16458	8371	6	0	595
127893	2134	98420266000	16458	8371	8	0	578
127894	2134	98419263000	16458	8371	9	0	579
127895	1397	1344450579000	16459	8372	0	0	9438
127896	2133	98402808000	16459	8372	1	0	596
127898	2132	148840841000	16459	8372	3	0	159
127906	1397	1344440578000	16462	8373	0	0	9439
127907	2133	98401806000	16462	8373	1	0	597
127908	2134	98417257000	16462	8373	2	0	581
127909	1397	1344430577000	16463	8374	0	0	9440
127913	1397	1344420576000	16465	8375	0	0	9441
127914	2133	98399802000	16465	8375	1	0	599
127915	2134	98416254000	16465	8375	2	0	582
127924	1397	1344410575000	16468	8376	0	0	9442
127925	2132	148839840000	16468	8376	1	0	160
127927	2133	98398800000	16468	8376	3	0	600
127932	1397	1344400574000	16470	8377	0	0	9443
127933	2134	98414248000	16470	8377	1	0	584
127934	2133	98397798000	16470	8377	2	0	601
127952	2134	98413245000	16474	8378	1	0	585
127953	2133	98396796000	16474	8378	2	0	602
127957	1397	1344380572000	16476	8379	0	0	9445
127958	2133	98395794000	16476	8379	1	0	603
127959	2132	148838839000	16476	8379	2	0	161
127961	1397	1344370571000	16477	8380	0	0	9446
127962	2134	98411239000	16477	8380	1	0	587
127963	2133	98394792000	16477	8380	2	0	604
127967	1397	1344360570000	16479	8381	0	0	9447
127968	2133	98393790000	16479	8381	1	0	605
127976	1397	1344350569000	16482	8382	0	0	9448
127994	1397	1344300564000	16484	8384	0	0	\N
127995	2134	98404218000	16484	8384	1	0	\N
127996	2133	98387778000	16484	8384	2	0	\N
127997	1397	1344300564000	16485	8384	0	0	\N
127998	2134	98404218000	16485	8384	1	0	\N
127999	2133	98387778000	16485	8384	2	0	\N
128000	1397	1344300564000	16486	8384	0	0	\N
128001	2134	98404218000	16486	8384	1	0	\N
128002	2133	98387778000	16486	8384	2	0	\N
128003	1397	1344300564000	16487	8384	0	0	\N
128004	2134	98404218000	16487	8384	1	0	\N
128005	2133	98387778000	16487	8384	2	0	\N
128020	2152	1300000	16492	8387	0	0	\N
128021	1397	1344270561000	16492	8387	1	0	\N
128022	2134	98401209000	16492	8387	2	0	\N
128023	2133	98384772000	16492	8387	3	0	\N
128030	1397	1344240558000	16494	8389	0	0	\N
128031	2133	98381766000	16494	8389	1	0	\N
128032	2134	98398200000	16494	8389	2	0	\N
128033	2132	148834835000	16494	8389	3	0	\N
128062	1397	1344170551000	16500	8394	0	0	\N
128063	2134	98390176000	16500	8394	1	0	\N
128064	2133	98373750000	16500	8394	2	0	\N
128068	1397	1344160550000	16502	8395	0	0	\N
128069	1397	1344150549000	16502	8395	1	0	\N
128070	1397	1344140548000	16502	8395	2	0	\N
128071	2133	98372748000	16502	8395	3	0	\N
128072	2134	98389173000	16502	8395	4	0	\N
128073	2133	98371746000	16502	8395	5	0	\N
128074	2134	98388170000	16502	8395	6	0	\N
128075	2132	148831832000	16502	8395	7	0	\N
128084	1397	1344160550000	16504	8395	0	0	\N
128085	1397	1344150549000	16504	8395	1	0	\N
128086	1397	1344140548000	16504	8395	2	0	\N
128087	2133	98372748000	16504	8395	3	0	\N
128088	2134	98389173000	16504	8395	4	0	\N
128089	2133	98371746000	16504	8395	5	0	\N
128090	2134	98388170000	16504	8395	6	0	\N
128091	2132	148831832000	16504	8395	7	0	\N
128092	1397	1344130547000	16505	8396	0	0	\N
128093	2134	98387167000	16505	8396	1	0	\N
128094	2133	98370744000	16505	8396	2	0	\N
127979	2133	98392788000	16482	8382	3	0	606
127980	1397	1344340568000	16483	8383	0	0	9449
127981	1860	107499987700000	16483	8383	1	0	3
127982	1397	1344330567000	16483	8383	2	0	9450
127983	1397	1344320566000	16483	8383	4	0	9451
127985	2133	98391786000	16483	8383	6	0	607
127986	2132	148836837000	16483	8383	7	0	163
127987	2133	98390784000	16483	8383	8	0	608
127988	2134	98408230000	16483	8383	9	0	590
127989	2134	98407227000	16483	8383	10	0	591
127991	2134	98405221000	16483	8383	12	0	593
127992	2133	98389782000	16483	8383	13	0	609
127993	2133	98388780000	16483	8383	14	0	610
128006	1397	1344300564000	16488	8384	0	0	9453
128008	2133	98387778000	16488	8384	2	0	611
128009	1397	1344290563000	16489	8385	0	0	9454
128010	2133	98386776000	16489	8385	1	0	612
128011	2134	98403215000	16489	8385	2	0	595
128012	1397	1344280562000	16490	8386	0	0	9455
128014	2132	148835836000	16490	8386	2	0	164
128015	2133	98385774000	16490	8386	3	0	613
128016	2152	1300000	16491	8387	0	0	1
128017	1397	1344270561000	16491	8387	1	0	9456
128018	2134	98401209000	16491	8387	2	0	597
128024	1397	1344260560000	16493	8388	0	0	9457
128025	1397	1344250559000	16493	8388	1	0	9458
128026	2133	98383770000	16493	8388	2	0	615
128027	2134	98400206000	16493	8388	3	0	598
128029	2134	98399203000	16493	8388	5	0	599
128034	1397	1344240558000	16495	8389	0	0	9459
128035	2133	98381766000	16495	8389	1	0	617
128036	2134	98398200000	16495	8389	2	0	600
128037	2132	148834835000	16495	8389	3	0	165
128039	1397	1344230557000	16496	8390	1	0	9460
128040	1397	1344220556000	16496	8390	2	0	9461
128041	1397	1344210555000	16496	8390	3	0	9462
128042	2133	98380764000	16496	8390	4	0	618
128043	2132	148833834000	16496	8390	5	0	166
128045	2133	98378760000	16496	8390	7	0	620
128046	2133	98377758000	16496	8390	8	0	621
128047	2134	98397197000	16496	8390	9	0	601
128048	2134	98396194000	16496	8390	10	0	602
128050	2134	98394188000	16496	8390	12	0	604
128051	1397	1344200554000	16497	8391	0	0	9463
128052	2134	98393185000	16497	8391	1	0	605
128053	2133	98376756000	16497	8391	2	0	622
128054	1397	1344190553000	16498	8392	0	0	9464
128056	2132	148832833000	16498	8392	2	0	167
128057	2133	98375754000	16498	8392	3	0	623
128058	1726	131385109000	16499	8393	0	0	8177
128059	1397	1344180552000	16499	8393	1	0	9465
128060	2133	98374752000	16499	8393	2	0	624
128065	1397	1344170551000	16501	8394	0	0	9466
128066	2134	98390176000	16501	8394	1	0	608
128067	2133	98373750000	16501	8394	2	0	625
128076	1397	1344160550000	16503	8395	0	0	9467
128078	1397	1344140548000	16503	8395	2	0	9469
128079	2133	98372748000	16503	8395	3	0	626
128080	2134	98389173000	16503	8395	4	0	609
128081	2133	98371746000	16503	8395	5	0	627
128082	2134	98388170000	16503	8395	6	0	610
128095	1397	1344130547000	16506	8396	0	0	9470
128096	2134	98387167000	16506	8396	1	0	611
128097	2133	98370744000	16506	8396	2	0	628
128098	1397	1344120546000	16507	8397	0	0	9471
128099	1397	1344110545000	16507	8397	1	0	9472
128101	1726	130175109000	16507	8397	3	0	8178
128102	2134	98386164000	16507	8397	4	0	612
128103	2134	98385161000	16507	8397	5	0	613
128104	2134	98384158000	16507	8397	6	0	614
128106	2133	98368740000	16507	8397	8	0	630
128107	2133	98367738000	16507	8397	9	0	631
128108	2132	148830831000	16507	8397	10	0	169
128109	1397	1344090543000	16508	8398	0	0	9474
128110	1397	1344080542000	16508	8398	1	0	9475
128112	2133	98366736000	16508	8398	3	0	632
128116	1397	1344090543000	16509	8398	0	0	\N
128117	1397	1344080542000	16509	8398	1	0	\N
128118	2132	148829830000	16509	8398	2	0	\N
128119	2133	98366736000	16509	8398	3	0	\N
128120	2133	98365734000	16509	8398	4	0	\N
128121	2134	98383155000	16509	8398	5	0	\N
128122	2134	98382152000	16509	8398	6	0	\N
128139	1397	1344020536000	16511	8400	0	0	\N
128140	2132	148827828000	16511	8400	1	0	\N
128141	2134	98376134000	16511	8400	2	0	\N
128142	2133	98359722000	16511	8400	3	0	\N
128143	1397	1344020536000	16512	8400	0	0	\N
128144	2132	148827828000	16512	8400	1	0	\N
128145	2134	98376134000	16512	8400	2	0	\N
128146	2133	98359722000	16512	8400	3	0	\N
128151	1397	1344020536000	16514	8400	0	0	\N
128152	2132	148827828000	16514	8400	1	0	\N
128153	2134	98376134000	16514	8400	2	0	\N
128154	2133	98359722000	16514	8400	3	0	\N
128155	1397	1344020536000	16515	8400	0	0	\N
128156	2132	148827828000	16515	8400	1	0	\N
128157	2134	98376134000	16515	8400	2	0	\N
128158	2133	98359722000	16515	8400	3	0	\N
128159	1397	1344010535000	16516	8401	0	0	\N
128160	2133	98358720000	16516	8401	1	0	\N
128161	2134	98375131000	16516	8401	2	0	\N
128162	1397	1344010535000	16517	8401	0	0	\N
128163	2133	98358720000	16517	8401	1	0	\N
128164	2134	98375131000	16517	8401	2	0	\N
128167	1397	1344000534000	16519	8402	0	0	\N
128168	2134	98374128000	16519	8402	1	0	\N
128169	2133	98358720000	16519	8402	2	0	\N
128170	2133	98357718000	16519	8402	3	0	\N
128179	1397	1343990533000	16522	8403	0	0	\N
128180	2133	98356716000	16522	8403	1	0	\N
128181	2134	98373125000	16522	8403	2	0	\N
128182	2132	148826827000	16522	8403	3	0	\N
128183	1860	43896955400000	16523	8234	0	0	\N
128184	1692	13459946719999	16523	8234	1	0	\N
128185	1769	1698900000	16523	8234	2	0	\N
128186	1769	1697900000	16523	8234	3	0	\N
128187	1769	1696900000	16523	8234	4	0	\N
128188	1769	1695900000	16523	8234	5	0	\N
128189	1769	1694900000	16523	8234	6	0	\N
128190	1769	1693900000	16523	8234	7	0	\N
128191	1769	1692900000	16523	8234	8	0	\N
128192	1397	1343990533000	16524	8403	0	0	\N
128193	2133	98356716000	16524	8403	1	0	\N
128194	2134	98373125000	16524	8403	2	0	\N
128195	2132	148826827000	16524	8403	3	0	\N
128214	1397	1343930527000	16529	8407	0	0	\N
128215	2133	98351706000	16529	8407	1	0	\N
128216	2134	98368110000	16529	8407	2	0	\N
128217	1397	1343930527000	16530	8407	0	0	\N
128218	2133	98351706000	16530	8407	1	0	\N
128219	2134	98368110000	16530	8407	2	0	\N
128220	1397	1343920526000	16531	8408	0	0	\N
128221	1397	1343910525000	16531	8408	1	0	\N
128222	2134	98367107000	16531	8408	2	0	\N
128223	2134	98366104000	16531	8408	3	0	\N
128224	2133	98350704000	16531	8408	4	0	\N
128225	2132	148824825000	16531	8408	5	0	\N
128226	2133	98349702000	16531	8408	6	0	\N
128234	1397	1343900524000	16533	8409	0	0	\N
128235	2133	98348700000	16533	8409	1	0	\N
128236	2134	98365101000	16533	8409	2	0	\N
128237	1397	1343900524000	16534	8409	0	0	\N
128238	2133	98348700000	16534	8409	1	0	\N
128239	2134	98365101000	16534	8409	2	0	\N
128240	1397	1343900524000	16535	8409	0	0	\N
128241	2133	98348700000	16535	8409	1	0	\N
128242	2134	98365101000	16535	8409	2	0	\N
128246	1397	1343900524000	16537	8409	0	0	\N
128247	2133	98348700000	16537	8409	1	0	\N
128248	2134	98365101000	16537	8409	2	0	\N
128115	2134	98382152000	16508	8398	6	0	616
128123	1397	1344070541000	16510	8399	0	0	9476
128124	1397	1344060540000	16510	8399	1	0	9477
128125	1397	1344050539000	16510	8399	2	0	9478
128126	1397	1344040538000	16510	8399	3	0	9479
128128	2132	148828829000	16510	8399	6	0	171
128129	2133	98364732000	16510	8399	7	0	634
128130	2134	98381149000	16510	8399	8	0	617
128131	2133	98363730000	16510	8399	9	0	635
128132	2133	98362728000	16510	8399	10	0	636
128134	2134	98379143000	16510	8399	12	0	619
128135	2134	98378140000	16510	8399	13	0	620
128136	2134	98377137000	16510	8399	14	0	621
128137	2133	98361726000	16510	8399	15	0	637
128147	1397	1344020536000	16513	8400	0	0	9481
128148	2132	148827828000	16513	8400	1	0	172
128149	2134	98376134000	16513	8400	2	0	622
128150	2133	98359722000	16513	8400	3	0	639
128165	1397	1344010535000	16518	8401	0	0	9482
128171	1397	1344000534000	16520	8402	0	0	9483
128172	2134	98374128000	16520	8402	1	0	624
128173	2133	98358720000	16520	8402	2	0	640
128174	2133	98357718000	16520	8402	3	0	641
128175	1397	1343990533000	16521	8403	0	0	9484
128177	2134	98373125000	16521	8403	2	0	625
128178	2132	148826827000	16521	8403	3	0	173
128196	1397	1343980532000	16525	8404	0	0	9485
128197	2133	98355714000	16525	8404	1	0	643
128199	1397	1343970531000	16526	8405	0	0	9486
128200	1397	1343960530000	16526	8405	1	0	9487
128201	2134	98371119000	16526	8405	2	0	627
128202	2133	98354712000	16526	8405	3	0	644
128203	2134	98370116000	16526	8405	4	0	628
128205	1397	1343940528000	16527	8406	1	0	9489
128206	2152	107496991300000	16527	8406	2	0	2
128207	2133	98353710000	16527	8406	3	0	645
128208	2133	98352708000	16527	8406	4	0	646
128209	2132	148825826000	16527	8406	5	0	174
128211	1397	1343930527000	16528	8407	0	0	9490
128212	2133	98351706000	16528	8407	1	0	647
128213	2134	98368110000	16528	8407	2	0	630
128227	1397	1343920526000	16532	8408	0	0	9491
128229	2134	98367107000	16532	8408	2	0	631
128230	2134	98366104000	16532	8408	3	0	632
128231	2133	98350704000	16532	8408	4	0	648
128232	2132	148824825000	16532	8408	5	0	175
128233	2133	98349702000	16532	8408	6	0	649
128244	2133	98348700000	16536	8409	1	0	650
128245	2134	98365101000	16536	8409	2	0	633
128249	2133	98348700000	16538	8409	0	0	\N
128250	2134	98365101000	16538	8409	1	0	\N
128265	1397	1343890523000	16544	8410	0	0	\N
128266	2152	29748981300000	16544	8410	1	0	\N
128267	1397	1343880522000	16544	8410	2	0	\N
128268	1397	1343870521000	16544	8410	3	0	\N
128269	1397	1343860520000	16544	8410	4	0	\N
128270	2132	148823824000	16544	8410	5	0	\N
128271	2133	98347698000	16544	8410	6	0	\N
128272	2133	98346696000	16544	8410	7	0	\N
128273	2133	98345694000	16544	8410	8	0	\N
128274	2133	98344692000	16544	8410	9	0	\N
128275	2134	98364098000	16544	8410	10	0	\N
128276	2134	98363095000	16544	8410	11	0	\N
128277	2134	98362092000	16544	8410	12	0	\N
128278	2134	98361089000	16544	8410	13	0	\N
128279	1397	1343890523000	16545	8410	0	0	\N
128280	2152	29748981300000	16545	8410	1	0	\N
128281	1397	1343880522000	16545	8410	2	0	\N
128282	1397	1343870521000	16545	8410	3	0	\N
128283	1397	1343860520000	16545	8410	4	0	\N
128284	2132	148823824000	16545	8410	5	0	\N
128285	2133	98347698000	16545	8410	6	0	\N
128286	2133	98346696000	16545	8410	7	0	\N
128287	2133	98345694000	16545	8410	8	0	\N
128288	2133	98344692000	16545	8410	9	0	\N
128289	2134	98364098000	16545	8410	10	0	\N
128290	2134	98363095000	16545	8410	11	0	\N
128291	2134	98362092000	16545	8410	12	0	\N
128292	2134	98361089000	16545	8410	13	0	\N
128293	1397	1343890523000	16546	8410	0	0	\N
128294	2152	29748981300000	16546	8410	1	0	\N
128295	1397	1343880522000	16546	8410	2	0	\N
128296	1397	1343870521000	16546	8410	3	0	\N
128297	1397	1343860520000	16546	8410	4	0	\N
128298	2132	148823824000	16546	8410	5	0	\N
128299	2133	98347698000	16546	8410	6	0	\N
128300	2133	98346696000	16546	8410	7	0	\N
128301	2133	98345694000	16546	8410	8	0	\N
128302	2133	98344692000	16546	8410	9	0	\N
128303	2134	98364098000	16546	8410	10	0	\N
128304	2134	98363095000	16546	8410	11	0	\N
128305	2134	98362092000	16546	8410	12	0	\N
128306	2134	98361089000	16546	8410	13	0	\N
128307	1397	1343890523000	16547	8410	0	0	\N
128308	2152	29748981300000	16547	8410	1	0	\N
128309	1397	1343880522000	16547	8410	2	0	\N
128310	1397	1343870521000	16547	8410	3	0	\N
128311	1397	1343860520000	16547	8410	4	0	\N
128312	2132	148823824000	16547	8410	5	0	\N
128313	1397	1343850519000	16550	8411	0	0	\N
128314	2133	98343690000	16550	8411	1	0	\N
128315	2132	148822823000	16550	8411	2	0	\N
128316	2134	98360086000	16550	8411	3	0	\N
128317	1397	1343850519000	16551	8411	0	0	\N
128318	2133	98343690000	16551	8411	1	0	\N
128319	2132	148822823000	16551	8411	2	0	\N
128320	2134	98360086000	16551	8411	3	0	\N
128347	1397	1343780512000	16557	8415	0	0	\N
128348	2134	98353065000	16557	8415	1	0	\N
128349	2132	148820821000	16557	8415	2	0	\N
128350	1397	1343780512000	16558	8415	0	0	\N
128351	2134	98353065000	16558	8415	1	0	\N
128352	2132	148820821000	16558	8415	2	0	\N
128356	1397	1343770511000	16560	8416	0	0	\N
128357	2133	98336676000	16560	8416	1	0	\N
128358	2134	98352062000	16560	8416	2	0	\N
128371	2152	29748981300000	16564	8408	0	0	\N
128372	1397	1343920526000	16564	8408	1	0	\N
128373	1597	2160034000000	16564	8408	2	0	\N
128374	1397	1343910525000	16564	8408	3	0	\N
128375	1397	1343900524000	16564	8408	4	0	\N
128376	1397	1343890523000	16564	8408	5	0	\N
128377	1397	1343880522000	16564	8408	6	0	\N
128378	1397	1343870521000	16564	8408	7	0	\N
128379	1397	1343860520000	16564	8408	8	0	\N
128380	1397	1343850519000	16564	8408	9	0	\N
128381	1397	1343840518000	16564	8408	10	0	\N
128382	1397	1343830517000	16564	8408	11	0	\N
128383	1397	1343820516000	16564	8408	12	0	\N
128384	1397	1343810515000	16564	8408	13	0	\N
128253	1397	1343880522000	16542	8410	2	0	9495
128254	1397	1343870521000	16542	8410	3	0	9496
128255	1397	1343860520000	16542	8410	4	0	9497
128256	2132	148823824000	16542	8410	5	0	176
128257	2133	98347698000	16542	8410	6	0	651
128259	2133	98345694000	16542	8410	8	0	653
128260	2133	98344692000	16542	8410	9	0	654
128261	2134	98364098000	16542	8410	10	0	634
128262	2134	98363095000	16542	8410	11	0	635
128263	2134	98362092000	16542	8410	12	0	636
128321	1397	1343850519000	16552	8411	0	0	9498
128322	2133	98343690000	16552	8411	1	0	655
128323	2132	148822823000	16552	8411	2	0	177
128324	2134	98360086000	16552	8411	3	0	638
128326	1397	1343840518000	16554	8413	0	0	9499
128327	1397	1343830517000	16554	8413	1	0	9500
128328	2133	98342688000	16554	8413	2	0	656
128329	2133	98341686000	16554	8413	3	0	657
128330	2134	98358080000	16554	8413	4	0	640
128332	1397	1343810515000	16555	8414	1	0	9502
128333	1397	1343800514000	16555	8414	2	0	9503
128334	1397	1343790513000	16555	8414	3	0	9504
128335	2133	98340684000	16555	8414	4	0	658
128336	2133	98339682000	16555	8414	5	0	659
128338	2134	98357077000	16555	8414	7	0	641
128339	2134	98356074000	16555	8414	8	0	642
128340	2134	98355071000	16555	8414	9	0	643
128341	2134	98354068000	16555	8414	10	0	644
128343	2133	98337678000	16555	8414	12	0	661
128344	1397	1343780512000	16556	8415	0	0	9505
128345	2134	98353065000	16556	8415	1	0	645
128346	2132	148820821000	16556	8415	2	0	179
128353	1397	1343770511000	16559	8416	0	0	9506
128355	2134	98352062000	16559	8416	2	0	646
128359	1397	1343760510000	16561	8417	0	0	9507
128360	2134	98351059000	16561	8417	1	0	647
128361	2133	98335674000	16561	8417	2	0	663
128362	1397	1343750509000	16562	8418	0	0	9508
128364	2134	98350056000	16562	8418	2	0	648
128365	2133	98334672000	16562	8418	3	0	664
128366	2132	148819820000	16562	8418	4	0	180
128367	2133	98333670000	16562	8418	5	0	665
128369	2133	98332668000	16563	8419	1	0	666
128370	2134	98349053000	16563	8419	2	0	649
128385	1397	1343800514000	16564	8408	14	0	\N
128386	1397	1343790513000	16564	8408	15	0	\N
128387	1397	1343780512000	16564	8408	16	0	\N
128388	1397	1343770511000	16564	8408	17	0	\N
128389	1397	1343760510000	16564	8408	18	0	\N
128390	1397	1343750509000	16564	8408	19	0	\N
128391	1397	1343740508000	16564	8408	20	0	\N
128392	1397	1343730507000	16564	8408	21	0	\N
128393	2134	98367107000	16564	8408	22	0	\N
128394	2134	98366104000	16564	8408	23	0	\N
128395	2133	98350704000	16564	8408	24	0	\N
128396	2132	148824825000	16564	8408	25	0	\N
128397	2132	148823824000	16564	8408	26	0	\N
128398	2132	148822823000	16564	8408	27	0	\N
128399	2132	148821822000	16564	8408	28	0	\N
128400	2133	98349702000	16564	8408	29	0	\N
128401	2133	98348700000	16564	8408	30	0	\N
128402	2133	98347698000	16564	8408	31	0	\N
128403	2133	98346696000	16564	8408	32	0	\N
128404	2133	98345694000	16564	8408	33	0	\N
128405	2133	98344692000	16564	8408	34	0	\N
128406	2133	98343690000	16564	8408	35	0	\N
128407	2133	98342688000	16564	8408	36	0	\N
128408	2133	98341686000	16564	8408	37	0	\N
128409	2133	98340684000	16564	8408	38	0	\N
128410	2133	98339682000	16564	8408	39	0	\N
128411	2134	98365101000	16564	8408	40	0	\N
128412	2134	98364098000	16564	8408	41	0	\N
128413	2134	98363095000	16564	8408	42	0	\N
128414	2134	98362092000	16564	8408	43	0	\N
128415	2134	98361089000	16564	8408	44	0	\N
128416	2134	98360086000	16564	8408	45	0	\N
128417	2134	98359083000	16564	8408	46	0	\N
128418	2133	98338680000	16564	8408	47	0	\N
128419	2133	98337678000	16564	8408	48	0	\N
128420	2133	98336676000	16564	8408	49	0	\N
128421	2133	98335674000	16564	8408	50	0	\N
128422	2133	98334672000	16564	8408	51	0	\N
128423	2133	98333670000	16564	8408	52	0	\N
128424	2133	98332668000	16564	8408	53	0	\N
128425	2133	98331666000	16564	8408	54	0	\N
128426	2134	98358080000	16564	8408	55	0	\N
128427	2134	98357077000	16564	8408	56	0	\N
128428	2134	98356074000	16564	8408	57	0	\N
128429	2134	98355071000	16564	8408	58	0	\N
128430	2134	98354068000	16564	8408	59	0	\N
128431	2134	98353065000	16564	8408	60	0	\N
128432	2134	98352062000	16564	8408	61	0	\N
128433	2134	98351059000	16564	8408	62	0	\N
128434	2134	98350056000	16564	8408	63	0	\N
128435	2134	98349053000	16564	8408	64	0	\N
128436	2134	98348050000	16564	8408	66	0	\N
128437	2132	148820821000	16564	8408	67	0	\N
128438	2132	148819820000	16564	8408	68	0	\N
128439	2132	148818819000	16564	8408	69	0	\N
128454	1397	1343700504000	16568	8422	0	0	\N
128455	1597	2159014000000	16568	8422	1	0	\N
128456	2134	98345041000	16568	8422	2	0	\N
128457	2133	98328660000	16568	8422	3	0	\N
128458	1397	1343700504000	16569	8422	0	0	\N
128459	1597	2159014000000	16569	8422	1	0	\N
128460	2134	98345041000	16569	8422	2	0	\N
128461	2133	98328660000	16569	8422	3	0	\N
128462	1397	1343720506000	16570	8421	0	0	\N
128463	1397	1343710505000	16570	8421	1	0	\N
128464	1397	1343700504000	16570	8421	2	0	\N
128465	1397	1343690503000	16570	8421	3	0	\N
128466	1597	2159014000000	16570	8421	4	0	\N
128467	2133	98330664000	16570	8421	5	0	\N
128468	2134	98347047000	16570	8421	6	0	\N
128469	2134	98346044000	16570	8421	7	0	\N
128470	2134	98345041000	16570	8421	8	0	\N
128471	2134	98344038000	16570	8421	9	0	\N
128472	2132	148817818000	16570	8421	10	0	\N
128473	2133	98329662000	16570	8421	11	0	\N
128474	2133	98328660000	16570	8421	12	0	\N
128475	2133	98327658000	16570	8421	13	0	\N
128476	1397	1343690503000	16571	8423	0	0	\N
128477	1397	1343680502000	16571	8423	1	0	\N
128478	1597	2159004000000	16571	8423	2	0	\N
128479	2134	98344038000	16571	8423	3	0	\N
128480	2134	98343035000	16571	8423	4	0	\N
128481	2132	148817818000	16571	8423	5	0	\N
128482	2133	98327658000	16571	8423	6	0	\N
128483	2133	98326656000	16571	8423	7	0	\N
128484	1397	1343690503000	16572	8423	0	0	\N
128485	1397	1343680502000	16572	8423	1	0	\N
128486	1597	2159004000000	16572	8423	2	0	\N
128487	2134	98344038000	16572	8423	3	0	\N
128488	2134	98343035000	16572	8423	4	0	\N
128489	2132	148817818000	16572	8423	5	0	\N
128490	2133	98327658000	16572	8423	6	0	\N
128491	2133	98326656000	16572	8423	7	0	\N
128507	2144	100000000	16576	8211	0	0	\N
128508	495	66719920000000	16576	8211	1	0	\N
128509	369	97346510000000	16576	8211	2	0	\N
128510	369	92607910000000	16576	8211	3	0	\N
128511	369	89410610000000	16576	8211	4	0	\N
128512	369	80501410000000	16576	8211	5	0	\N
128513	495	66709820000000	16576	8211	6	0	\N
128514	495	66709720000000	16576	8211	7	0	\N
128515	1726	133805109000	16576	8211	8	0	\N
128516	1860	43896955400000	16576	8211	9	0	\N
128517	1726	132595109000	16576	8211	10	0	\N
128518	1726	131385109000	16576	8211	11	0	\N
128519	1726	130175109000	16576	8211	12	0	\N
128520	1692	13459946719999	16576	8211	13	0	\N
128442	2132	148818819000	16565	8420	2	0	181
128443	2133	98331666000	16565	8420	3	0	667
128444	1397	1343720506000	16566	8421	0	0	9511
128445	1397	1343710505000	16566	8421	1	0	9512
128446	2133	98330664000	16566	8421	2	0	668
128448	2134	98346044000	16566	8421	4	0	652
128449	2133	98329662000	16566	8421	5	0	669
128450	1397	1343700504000	16567	8422	0	0	9513
128451	1597	2159014000000	16567	8422	1	0	2
128452	2134	98345041000	16567	8422	2	0	653
128492	1397	1343690503000	16573	8423	0	0	9514
128493	1397	1343680502000	16573	8423	1	0	9515
128494	2134	98344038000	16573	8423	2	0	654
128495	2134	98343035000	16573	8423	3	0	655
128497	2133	98327658000	16573	8423	5	0	671
128498	1397	1343670501000	16574	8424	0	0	9516
128499	1597	2159004000000	16574	8424	1	0	3
128500	2134	98342032000	16574	8424	2	0	656
128501	2133	98326656000	16574	8424	3	0	672
128503	1397	1343660500000	16575	8425	0	0	9517
128504	2134	98341029000	16575	8425	1	0	657
128505	2133	98324652000	16575	8425	2	0	674
128506	2132	148816817000	16575	8425	3	0	183
128521	1597	1440010000000	16576	8211	14	0	\N
128522	1597	1438990000000	16576	8211	15	0	\N
128523	1597	1438980000000	16576	8211	16	0	\N
128524	1724	7147319000000	16576	8211	17	0	\N
128525	563	66000617000000	16576	8211	18	0	\N
128526	1769	1700900000	16576	8211	19	0	\N
128527	1769	1699900000	16576	8211	20	0	\N
128528	1769	1698900000	16576	8211	21	0	\N
128529	1769	1697900000	16576	8211	22	0	\N
128530	1769	1696900000	16576	8211	23	0	\N
128531	1769	1695900000	16576	8211	24	0	\N
128532	1769	1694900000	16576	8211	25	0	\N
128533	1769	1693900000	16576	8211	26	0	\N
128534	1769	1692900000	16576	8211	27	0	\N
128545	1397	1343650499000	16578	8426	0	0	\N
128546	1397	1343640498000	16578	8426	1	0	\N
128547	1397	1343630497000	16578	8426	2	0	\N
128548	2132	148815816000	16578	8426	3	0	\N
128549	2133	98323650000	16578	8426	4	0	\N
128550	2134	98340026000	16578	8426	5	0	\N
128551	2133	98322648000	16578	8426	6	0	\N
128552	2133	98321646000	16578	8426	7	0	\N
128553	2134	98339023000	16578	8426	8	0	\N
128554	2134	98338020000	16578	8426	9	0	\N
128555	1397	1343650499000	16579	8426	0	0	\N
128556	1397	1343640498000	16579	8426	1	0	\N
128557	1397	1343630497000	16579	8426	2	0	\N
128558	2132	148815816000	16579	8426	3	0	\N
128559	2133	98323650000	16579	8426	4	0	\N
128560	2134	98340026000	16579	8426	5	0	\N
128561	2133	98322648000	16579	8426	6	0	\N
128562	2133	98321646000	16579	8426	7	0	\N
128563	2134	98339023000	16579	8426	8	0	\N
128564	2134	98338020000	16579	8426	9	0	\N
128569	1397	1343620496000	16581	8427	0	0	\N
128570	1397	1343610495000	16581	8427	1	0	\N
128571	2134	98337017000	16581	8427	2	0	\N
128572	2133	98320644000	16581	8427	3	0	\N
128573	2133	98319642000	16581	8427	4	0	\N
128574	2134	98336014000	16581	8427	5	0	\N
128575	1397	1343620496000	16582	8427	0	0	\N
128576	1397	1343610495000	16582	8427	1	0	\N
128577	2134	98337017000	16582	8427	2	0	\N
128578	2133	98320644000	16582	8427	3	0	\N
128579	2133	98319642000	16582	8427	4	0	\N
128580	2134	98336014000	16582	8427	5	0	\N
128581	1397	1343620496000	16583	8427	0	0	\N
128582	1397	1343610495000	16583	8427	1	0	\N
128583	2134	98337017000	16583	8427	2	0	\N
128584	2133	98320644000	16583	8427	3	0	\N
128585	2133	98319642000	16583	8427	4	0	\N
128586	2134	98336014000	16583	8427	5	0	\N
128587	1397	1343650499000	16584	8426	0	0	\N
128588	1397	1343640498000	16584	8426	1	0	\N
128589	1397	1343630497000	16584	8426	2	0	\N
128590	1397	1343620496000	16584	8426	3	0	\N
128591	1397	1343610495000	16584	8426	4	0	\N
128592	2132	148815816000	16584	8426	5	0	\N
128593	2133	98323650000	16584	8426	6	0	\N
128594	2134	98340026000	16584	8426	7	0	\N
128595	2133	98322648000	16584	8426	8	0	\N
128596	2133	98321646000	16584	8426	9	0	\N
128597	2133	98320644000	16584	8426	10	0	\N
128598	2133	98319642000	16584	8426	11	0	\N
128607	2144	100000000	16586	8277	0	0	\N
128608	495	66719920000000	16586	8277	1	0	\N
128609	369	97346510000000	16586	8277	2	0	\N
128610	369	92607910000000	16586	8277	3	0	\N
128611	369	89410610000000	16586	8277	4	0	\N
128612	369	80501410000000	16586	8277	5	0	\N
128613	495	66709820000000	16586	8277	6	0	\N
128614	495	66709720000000	16586	8277	7	0	\N
128615	1726	133805109000	16586	8277	8	0	\N
128616	1860	43896955400000	16586	8277	9	0	\N
128617	1397	1345770711000	16586	8277	10	0	\N
128618	1397	1345760710000	16586	8277	11	0	\N
128619	1397	1345750709000	16586	8277	12	0	\N
128620	1397	1345740708000	16586	8277	13	0	\N
128621	1397	1345730707000	16586	8277	14	0	\N
128622	1397	1345720706000	16586	8277	15	0	\N
128623	1397	1345710705000	16586	8277	16	0	\N
128624	1397	1345700704000	16586	8277	17	0	\N
128625	1397	1345690703000	16586	8277	18	0	\N
128626	1397	1345680702000	16586	8277	19	0	\N
128627	1397	1345670701000	16586	8277	20	0	\N
128628	1397	1345660700000	16586	8277	21	0	\N
128629	1397	1345650699000	16586	8277	22	0	\N
128630	1726	132595109000	16586	8277	23	0	\N
128631	1726	131385109000	16586	8277	24	0	\N
128632	1726	130175109000	16586	8277	25	0	\N
128633	1692	13459946719999	16586	8277	26	0	\N
128634	1597	1440010000000	16586	8277	27	0	\N
128635	1397	1345640698000	16586	8277	28	0	\N
128636	1397	1345630697000	16586	8277	29	0	\N
128637	1397	1345620696000	16586	8277	30	0	\N
128638	1597	1438990000000	16586	8277	31	0	\N
128639	1597	1438980000000	16586	8277	32	0	\N
128640	1397	1345610695000	16586	8277	33	0	\N
128641	1397	1345600694000	16586	8277	34	0	\N
128642	1397	1345590693000	16586	8277	35	0	\N
128643	1397	1345580692000	16586	8277	36	0	\N
128644	1397	1345570691000	16586	8277	37	0	\N
128645	1397	1345560690000	16586	8277	38	0	\N
128646	1397	1345550689000	16586	8277	39	0	\N
128647	1397	1345540688000	16586	8277	40	0	\N
128648	1397	1345530687000	16586	8277	41	0	\N
128649	1397	1345520686000	16586	8277	42	0	\N
128650	1397	1345510685000	16586	8277	43	0	\N
128651	1397	1345500684000	16586	8277	44	0	\N
128652	1397	1345490683000	16586	8277	45	0	\N
128653	1397	1345480682000	16586	8277	46	0	\N
128654	1397	1345470681000	16586	8277	47	0	\N
128655	1397	1345460680000	16586	8277	48	0	\N
128656	1397	1345450679000	16586	8277	49	0	\N
128537	1397	1343630497000	16577	8426	2	0	9520
128538	2132	148815816000	16577	8426	3	0	184
128539	2133	98323650000	16577	8426	4	0	675
128540	2134	98340026000	16577	8426	5	0	658
128541	2133	98322648000	16577	8426	6	0	676
128543	2134	98339023000	16577	8426	8	0	659
128544	2134	98338020000	16577	8426	9	0	660
128565	1397	1343620496000	16580	8427	0	0	9521
128566	1397	1343610495000	16580	8427	1	0	9522
128567	2133	98320644000	16580	8427	2	0	678
128599	1397	1343600494000	16585	8428	0	0	9523
128600	1397	1343590493000	16585	8428	1	0	9524
128601	2134	98337017000	16585	8428	2	0	661
128602	2132	148814815000	16585	8428	3	0	185
128604	2134	98336014000	16585	8428	5	0	662
128605	2134	98335011000	16585	8428	6	0	663
128606	2134	98334008000	16585	8428	7	0	664
128657	1397	1345440678000	16586	8277	50	0	\N
128658	1397	1345430677000	16586	8277	51	0	\N
128659	1397	1345420676000	16586	8277	52	0	\N
128660	1397	1345410675000	16586	8277	53	0	\N
128661	1397	1345400674000	16586	8277	54	0	\N
128662	1397	1345390673000	16586	8277	55	0	\N
128663	1397	1345380672000	16586	8277	56	0	\N
128664	1397	1345370671000	16586	8277	57	0	\N
128665	1397	1345360670000	16586	8277	58	0	\N
128666	1397	1345350669000	16586	8277	59	0	\N
128667	1397	1345340668000	16586	8277	60	0	\N
128668	1397	1345330667000	16586	8277	61	0	\N
128669	1397	1345320666000	16586	8277	62	0	\N
128670	1397	1345310665000	16586	8277	64	0	\N
128671	1397	1345300664000	16586	8277	65	0	\N
128672	1397	1345290663000	16586	8277	66	0	\N
128673	1397	1345280662000	16586	8277	67	0	\N
128674	1397	1345270661000	16586	8277	68	0	\N
128675	1397	1345260660000	16586	8277	69	0	\N
128676	1397	1345250659000	16586	8277	70	0	\N
128677	1397	1345240658000	16586	8277	71	0	\N
128678	1397	1345230657000	16586	8277	72	0	\N
128679	1397	1345220656000	16586	8277	73	0	\N
128680	1397	1345210655000	16586	8277	74	0	\N
128681	1397	1345200654000	16586	8277	75	0	\N
128682	1397	1345190653000	16586	8277	76	0	\N
128683	1397	1345180652000	16586	8277	77	0	\N
128684	1397	1345170651000	16586	8277	78	0	\N
128685	1397	1345160650000	16586	8277	79	0	\N
128686	1397	1345150649000	16586	8277	80	0	\N
128687	1397	1345140648000	16586	8277	81	0	\N
128688	1397	1345130647000	16586	8277	82	0	\N
128689	1397	1345120646000	16586	8277	83	0	\N
128690	1397	1345110645000	16586	8277	84	0	\N
128691	1397	1345100644000	16586	8277	85	0	\N
128692	1397	1345090643000	16586	8277	86	0	\N
128693	1397	1345080642000	16586	8277	87	0	\N
128694	1397	1345070641000	16586	8277	88	0	\N
128695	1397	1345060640000	16586	8277	89	0	\N
128696	1397	1345050639000	16586	8277	90	0	\N
128697	1397	1345040638000	16586	8277	91	0	\N
128698	1397	1345030637000	16586	8277	92	0	\N
128699	1397	1345020636000	16586	8277	93	0	\N
128700	1397	1345010635000	16586	8277	94	0	\N
128701	1397	1345000634000	16586	8277	95	0	\N
128702	1397	1344990633000	16586	8277	96	0	\N
128703	1397	1344980632000	16586	8277	97	0	\N
128704	1397	1344970631000	16586	8277	98	0	\N
128705	1397	1344960630000	16586	8277	99	0	\N
128706	1397	1344950629000	16586	8277	100	0	\N
128707	1397	1344940628000	16586	8277	101	0	\N
128708	1397	1344930627000	16586	8277	102	0	\N
128709	1397	1344920626000	16586	8277	103	0	\N
128710	1397	1344910625000	16586	8277	104	0	\N
128711	1397	1344900624000	16586	8277	105	0	\N
128712	1397	1344890623000	16586	8277	106	0	\N
128713	1397	1344880622000	16586	8277	107	0	\N
128714	1397	1344870621000	16586	8277	108	0	\N
128715	1397	1344860620000	16586	8277	109	0	\N
128716	1397	1344850619000	16586	8277	110	0	\N
128717	1397	1344840618000	16586	8277	111	0	\N
128718	1397	1344830617000	16586	8277	112	0	\N
128719	1397	1344820616000	16586	8277	113	0	\N
128720	1397	1344810615000	16586	8277	114	0	\N
128721	1397	1344800614000	16586	8277	115	0	\N
128722	1397	1344790613000	16586	8277	116	0	\N
128723	1397	1344780612000	16586	8277	117	0	\N
128724	1397	1344770611000	16586	8277	118	0	\N
128725	1397	1344760610000	16586	8277	119	0	\N
128726	1397	1344750609000	16586	8277	120	0	\N
128727	1397	1344740608000	16586	8277	121	0	\N
128728	1397	1344730607000	16586	8277	122	0	\N
128729	1397	1344720606000	16586	8277	123	0	\N
128730	1397	1344710605000	16586	8277	124	0	\N
128731	1397	1344700604000	16586	8277	125	0	\N
128732	1397	1343580492000	16587	8429	0	0	\N
128733	1397	1343570491000	16587	8429	1	0	\N
128734	2133	98317638000	16587	8429	2	0	\N
128735	2134	98333005000	16587	8429	3	0	\N
128736	2134	98332002000	16587	8429	4	0	\N
128737	2133	98316636000	16587	8429	5	0	\N
128754	632	77969934000000	16591	8431	0	0	\N
128755	632	72677914000000	16591	8431	1	0	\N
128759	1397	1343540488000	16593	8432	0	0	\N
128760	2134	98328993000	16593	8432	1	0	\N
128761	2133	98313630000	16593	8432	2	0	\N
128762	1397	1343540488000	16594	8432	0	0	\N
128763	2134	98328993000	16594	8432	1	0	\N
128764	2133	98313630000	16594	8432	2	0	\N
128765	632	85813954000000	16595	8212	0	0	\N
128766	632	77969934000000	16595	8212	1	0	\N
128767	632	72677914000000	16595	8212	2	0	\N
128768	632	68300894000000	16595	8212	3	0	\N
128774	632	72677894000000	16597	8433	0	0	\N
128775	1397	1343530487000	16597	8433	1	0	\N
128776	2132	148812813000	16597	8433	2	0	\N
128777	2133	98312628000	16597	8433	3	0	\N
128778	2134	98327990000	16597	8433	4	0	\N
128779	1397	1343520486000	16598	8434	0	0	\N
128780	2133	98311626000	16598	8434	2	0	\N
128781	2134	98326987000	16598	8434	3	0	\N
128782	1397	1343520486000	16599	8434	0	0	\N
128783	2133	98311626000	16599	8434	2	0	\N
128784	2134	98326987000	16599	8434	3	0	\N
128792	1397	1343500484000	16603	8436	0	0	\N
128740	2133	98317638000	16588	8429	2	0	681
128741	2134	98333005000	16588	8429	3	0	665
128742	2134	98332002000	16588	8429	4	0	666
128743	2133	98316636000	16588	8429	5	0	682
128744	632	85813954000000	16589	8430	0	0	1
128746	2132	148813814000	16589	8430	2	0	186
128747	2133	98315634000	16589	8430	3	0	683
128748	2134	98330999000	16589	8430	4	0	667
128749	632	77969934000000	16590	8431	0	0	2
128750	632	72677914000000	16590	8431	1	0	3
128752	2133	98314632000	16590	8431	3	0	684
128753	2134	98329996000	16590	8431	4	0	668
128756	1397	1343540488000	16592	8432	0	0	9529
128757	2134	98328993000	16592	8432	1	0	669
128769	632	72677894000000	16596	8433	0	0	4
128770	1397	1343530487000	16596	8433	1	0	9530
128771	2132	148812813000	16596	8433	2	0	187
128772	2133	98312628000	16596	8433	3	0	686
128773	2134	98327990000	16596	8433	4	0	670
128786	2133	98311626000	16600	8434	2	0	687
128787	2134	98326987000	16600	8434	3	0	671
128788	1397	1343510485000	16601	8435	0	0	9532
128789	2134	98325984000	16601	8435	1	0	672
128790	2133	98310624000	16601	8435	2	0	688
128793	2133	98309622000	16603	8436	1	0	\N
128794	2134	98324981000	16603	8436	2	0	\N
128795	1397	1343500484000	16604	8436	0	0	\N
128796	2133	98309622000	16604	8436	1	0	\N
128797	2134	98324981000	16604	8436	2	0	\N
128798	1397	1343500484000	16605	8436	0	0	\N
128799	2133	98309622000	16605	8436	1	0	\N
128800	2134	98324981000	16605	8436	2	0	\N
128801	1397	1343500484000	16606	8436	0	0	\N
128802	2133	98309622000	16606	8436	1	0	\N
128803	2134	98324981000	16606	8436	2	0	\N
128804	1397	1343500484000	16607	8436	0	0	\N
128805	2133	98309622000	16607	8436	1	0	\N
128806	2134	98324981000	16607	8436	2	0	\N
128807	1397	1343500484000	16608	8436	0	0	\N
128808	2133	98309622000	16608	8436	1	0	\N
128809	2134	98324981000	16608	8436	2	0	\N
128810	1397	1343500484000	16609	8436	0	0	\N
128811	2133	98309622000	16609	8436	1	0	\N
128812	2134	98324981000	16609	8436	2	0	\N
128813	632	85813954000000	16610	8427	0	0	\N
128814	632	77969934000000	16610	8427	1	0	\N
128815	632	72677914000000	16610	8427	2	0	\N
128816	632	68300894000000	16610	8427	3	0	\N
128817	1397	1343600494000	16610	8427	4	0	\N
128818	1397	1343590493000	16610	8427	5	0	\N
128819	1397	1343580492000	16610	8427	6	0	\N
128820	1397	1343570491000	16610	8427	7	0	\N
128821	1397	1343560490000	16610	8427	8	0	\N
128822	1397	1343550489000	16610	8427	9	0	\N
128823	1397	1343540488000	16610	8427	10	0	\N
128824	1397	1343530487000	16610	8427	11	0	\N
128825	1397	1343520486000	16610	8427	12	0	\N
128826	1397	1343510485000	16610	8427	13	0	\N
128827	1397	1343500484000	16610	8427	14	0	\N
128828	2132	148814815000	16610	8427	15	0	\N
128829	2132	148813814000	16610	8427	16	0	\N
128830	2132	148812813000	16610	8427	17	0	\N
128831	2133	98318640000	16610	8427	18	0	\N
128832	2133	98317638000	16610	8427	19	0	\N
128833	2133	98316636000	16610	8427	20	0	\N
128834	2133	98315634000	16610	8427	21	0	\N
128835	2133	98314632000	16610	8427	22	0	\N
128836	2133	98313630000	16610	8427	23	0	\N
128837	2133	98312628000	16610	8427	24	0	\N
128838	2133	98311626000	16610	8427	25	0	\N
128839	2133	98310624000	16610	8427	26	0	\N
128840	2133	98309622000	16610	8427	27	0	\N
128864	1397	1343430477000	16620	8443	0	0	\N
128865	2134	98317960000	16620	8443	1	0	\N
128866	2133	98302608000	16620	8443	2	0	\N
128870	1397	1343430477000	16622	8443	0	0	\N
128871	2134	98317960000	16622	8443	1	0	\N
128872	2133	98302608000	16622	8443	2	0	\N
128873	632	85813954000000	16623	8389	0	0	\N
128874	632	77969934000000	16623	8389	1	0	\N
128875	632	72677914000000	16623	8389	2	0	\N
128876	632	68300894000000	16623	8389	3	0	\N
128877	1860	978700000	16623	8389	4	0	\N
128878	1726	131385109000	16623	8389	5	0	\N
128879	1726	130175109000	16623	8389	6	0	\N
128880	1397	1344240558000	16623	8389	7	0	\N
128881	1397	1344230557000	16623	8389	8	0	\N
128882	1397	1344220556000	16623	8389	9	0	\N
128883	1397	1344210555000	16623	8389	10	0	\N
128884	1397	1344200554000	16623	8389	11	0	\N
128885	1397	1344190553000	16623	8389	12	0	\N
128886	1397	1344180552000	16623	8389	13	0	\N
128887	1397	1344170551000	16623	8389	14	0	\N
128888	1397	1344160550000	16623	8389	15	0	\N
128889	1397	1344150549000	16623	8389	16	0	\N
128890	1397	1344140548000	16623	8389	17	0	\N
128891	1397	1344130547000	16623	8389	18	0	\N
128892	1397	1344120546000	16623	8389	19	0	\N
128893	1397	1344110545000	16623	8389	20	0	\N
128894	1397	1344100544000	16623	8389	21	0	\N
128895	1397	1344090543000	16623	8389	22	0	\N
128896	1397	1344080542000	16623	8389	23	0	\N
128897	1597	2160034000000	16623	8389	24	0	\N
128898	1397	1344070541000	16623	8389	25	0	\N
128899	1397	1344060540000	16623	8389	26	0	\N
128900	1397	1344050539000	16623	8389	27	0	\N
128901	1397	1344040538000	16623	8389	28	0	\N
128902	1397	1344030537000	16623	8389	29	0	\N
128903	1397	1344020536000	16623	8389	30	0	\N
128904	1397	1344010535000	16623	8389	31	0	\N
128905	1397	1344000534000	16623	8389	32	0	\N
128906	1397	1343990533000	16623	8389	33	0	\N
128907	1397	1343980532000	16623	8389	34	0	\N
128908	1397	1343970531000	16623	8389	35	0	\N
128909	1397	1343960530000	16623	8389	36	0	\N
128910	1397	1343950529000	16623	8389	37	0	\N
128911	1397	1343940528000	16623	8389	38	0	\N
128912	1397	1343930527000	16623	8389	39	0	\N
128913	1397	1343920526000	16623	8389	40	0	\N
128914	1397	1343910525000	16623	8389	41	0	\N
128915	1597	2159014000000	16623	8389	42	0	\N
128916	1597	2159004000000	16623	8389	43	0	\N
128917	1397	1343900524000	16623	8389	44	0	\N
128918	1397	1343890523000	16623	8389	45	0	\N
128919	1397	1343880522000	16623	8389	46	0	\N
128920	1397	1343870521000	16623	8389	47	0	\N
128921	1397	1343860520000	16623	8389	48	0	\N
128922	1397	1343850519000	16623	8389	49	0	\N
128923	1397	1343840518000	16623	8389	50	0	\N
128924	1397	1343830517000	16623	8389	51	0	\N
128925	1397	1343820516000	16623	8389	52	0	\N
128926	1397	1343810515000	16623	8389	53	0	\N
128927	1397	1343800514000	16623	8389	54	0	\N
128928	1397	1343790513000	16623	8389	55	0	\N
128843	2132	148811812000	16611	8437	2	0	188
128844	2133	98309622000	16611	8437	3	0	689
128845	2133	98308620000	16611	8437	4	0	690
128846	2134	98323978000	16611	8437	5	0	674
128847	1397	1343480482000	16612	8438	0	0	9535
128849	2134	98322975000	16612	8438	2	0	675
128850	1397	1343470481000	16613	8439	0	0	9536
128851	2133	98306616000	16613	8439	1	0	692
128852	2134	98321972000	16613	8439	2	0	676
128853	1397	1343460480000	16614	8440	0	0	9537
128855	2133	98305614000	16614	8440	2	0	693
128856	2132	148810811000	16614	8440	3	0	189
128857	1397	1343450479000	16616	8441	0	0	9538
128858	2133	98304612000	16616	8441	1	0	694
128860	632	68300874000000	16619	8442	0	0	5
128861	1397	1343440478000	16619	8442	1	0	9539
128862	2134	98318963000	16619	8442	2	0	679
128863	2133	98303610000	16619	8442	3	0	695
128867	1397	1343430477000	16621	8443	0	0	9540
128869	2133	98302608000	16621	8443	2	0	696
128929	1397	1343780512000	16623	8389	56	0	\N
128930	1397	1343770511000	16623	8389	57	0	\N
128931	1397	1343760510000	16623	8389	58	0	\N
128932	1397	1343750509000	16623	8389	59	0	\N
128933	1397	1343740508000	16623	8389	60	0	\N
128934	1397	1343730507000	16623	8389	61	0	\N
128935	1397	1343720506000	16623	8389	62	0	\N
128936	1397	1343710505000	16623	8389	63	0	\N
128937	1397	1343700504000	16623	8389	64	0	\N
128938	1397	1343690503000	16623	8389	65	0	\N
128939	1397	1343680502000	16623	8389	66	0	\N
128940	1397	1343670501000	16623	8389	67	0	\N
128941	1397	1343660500000	16623	8389	68	0	\N
128942	1397	1343650499000	16623	8389	69	0	\N
128943	1397	1343640498000	16623	8389	70	0	\N
128944	1397	1343630497000	16623	8389	71	0	\N
128945	1397	1343620496000	16623	8389	72	0	\N
128946	1397	1343610495000	16623	8389	73	0	\N
128947	1397	1343600494000	16623	8389	74	0	\N
128948	1397	1343590493000	16623	8389	75	0	\N
128949	1397	1343580492000	16623	8389	76	0	\N
128950	1397	1343570491000	16623	8389	77	0	\N
128951	1397	1343560490000	16623	8389	78	0	\N
128952	1397	1343550489000	16623	8389	79	0	\N
128953	1397	1343540488000	16623	8389	80	0	\N
128954	1397	1343530487000	16623	8389	81	0	\N
128955	1397	1343520486000	16623	8389	82	0	\N
128956	1397	1343510485000	16623	8389	83	0	\N
128957	1397	1343500484000	16623	8389	85	0	\N
128958	1397	1343490483000	16623	8389	86	0	\N
128959	1397	1343480482000	16623	8389	87	0	\N
128960	1397	1343470481000	16623	8389	88	0	\N
128961	1397	1343460480000	16623	8389	89	0	\N
128962	1397	1343450479000	16623	8389	90	0	\N
128963	1397	1343440478000	16623	8389	91	0	\N
128964	2133	98381766000	16623	8389	92	0	\N
128965	2134	98398200000	16623	8389	93	0	\N
128966	2133	98380764000	16623	8389	94	0	\N
128967	2132	148834835000	16623	8389	95	0	\N
128968	2132	148833834000	16623	8389	96	0	\N
128969	2132	148832833000	16623	8389	97	0	\N
128970	2132	148831832000	16623	8389	98	0	\N
128971	2132	148830831000	16623	8389	99	0	\N
128972	2132	148829830000	16623	8389	100	0	\N
128973	2132	148828829000	16623	8389	101	0	\N
128976	1397	1343410475000	16625	8445	0	0	\N
128977	2134	98316957000	16625	8445	1	0	\N
128978	2133	98301606000	16625	8445	2	0	\N
128992	632	85813954000000	16629	8409	0	0	\N
128993	632	77969934000000	16629	8409	1	0	\N
128994	632	72677914000000	16629	8409	2	0	\N
128995	632	68300894000000	16629	8409	3	0	\N
128996	1397	1343720506000	16629	8409	4	0	\N
128997	1397	1343710505000	16629	8409	5	0	\N
128998	1397	1343700504000	16629	8409	6	0	\N
128999	1397	1343690503000	16629	8409	7	0	\N
129000	1397	1343680502000	16629	8409	8	0	\N
129001	1397	1343670501000	16629	8409	9	0	\N
129002	1397	1343660500000	16629	8409	10	0	\N
129003	1397	1343650499000	16629	8409	11	0	\N
129004	1597	2159014000000	16629	8409	12	0	\N
129005	1597	2159004000000	16629	8409	13	0	\N
129006	1397	1343640498000	16629	8409	14	0	\N
129007	1397	1343630497000	16629	8409	15	0	\N
129008	1397	1343620496000	16629	8409	16	0	\N
129009	1397	1343610495000	16629	8409	17	0	\N
129010	1397	1343600494000	16629	8409	18	0	\N
129011	1397	1343590493000	16629	8409	19	0	\N
129012	1397	1343580492000	16629	8409	20	0	\N
129013	1397	1343570491000	16629	8409	21	0	\N
129014	1397	1343560490000	16629	8409	22	0	\N
129015	1397	1343550489000	16629	8409	23	0	\N
129016	1397	1343540488000	16629	8409	24	0	\N
129017	1397	1343530487000	16629	8409	25	0	\N
129018	1397	1343520486000	16629	8409	26	0	\N
129019	1397	1343510485000	16629	8409	27	0	\N
129020	1397	1343500484000	16629	8409	28	0	\N
129021	1397	1343490483000	16629	8409	29	0	\N
129022	1397	1343480482000	16629	8409	30	0	\N
129023	1397	1343470481000	16629	8409	31	0	\N
129024	1397	1343460480000	16629	8409	32	0	\N
129025	1397	1343450479000	16629	8409	33	0	\N
129026	1397	1343440478000	16629	8409	34	0	\N
129027	1397	1343430477000	16629	8409	35	0	\N
129028	1397	1343420476000	16629	8409	36	0	\N
129029	1397	1343410475000	16629	8409	37	0	\N
129030	1397	1343400474000	16629	8409	38	0	\N
129031	1397	1343390473000	16629	8409	39	0	\N
129032	1397	1343380472000	16629	8409	40	0	\N
129033	1397	1343370471000	16629	8409	41	0	\N
129034	2133	98330664000	16629	8409	42	0	\N
129035	2134	98347047000	16629	8409	43	0	\N
129036	2134	98346044000	16629	8409	44	0	\N
129037	2134	98345041000	16629	8409	45	0	\N
129038	2134	98344038000	16629	8409	46	0	\N
129039	2134	98343035000	16629	8409	47	0	\N
129040	2132	148817818000	16629	8409	48	0	\N
129041	2132	148816817000	16629	8409	49	0	\N
129042	2132	148815816000	16629	8409	50	0	\N
129043	2132	148814815000	16629	8409	51	0	\N
129044	2132	148813814000	16629	8409	52	0	\N
129045	2132	148812813000	16629	8409	53	0	\N
129046	2132	148811812000	16629	8409	54	0	\N
129047	2133	98329662000	16629	8409	55	0	\N
129048	2133	98328660000	16629	8409	56	0	\N
129049	2134	98342032000	16629	8409	57	0	\N
129050	2134	98341029000	16629	8409	58	0	\N
129051	2134	98340026000	16629	8409	59	0	\N
129052	2132	148810811000	16629	8409	60	0	\N
129053	2132	148809810000	16629	8409	61	0	\N
129054	2132	148808809000	16629	8409	62	0	\N
129055	2133	98327658000	16629	8409	63	0	\N
129056	2133	98326656000	16629	8409	64	0	\N
129057	2133	98325654000	16629	8409	65	0	\N
129058	2133	98324652000	16629	8409	66	0	\N
129059	2133	98323650000	16629	8409	67	0	\N
129060	2133	98322648000	16629	8409	68	0	\N
129061	2133	98321646000	16629	8409	69	0	\N
129062	2133	98320644000	16629	8409	70	0	\N
129063	2133	98319642000	16629	8409	71	0	\N
129064	2133	98318640000	16629	8409	72	0	\N
128979	1397	1343410475000	16626	8445	0	0	9542
128980	2134	98316957000	16626	8445	1	0	681
128981	2133	98301606000	16626	8445	2	0	697
128982	1397	1343400474000	16627	8446	0	0	9543
128983	1397	1343390473000	16627	8446	1	0	9544
128985	2132	148808809000	16627	8446	3	0	191
128986	2134	98315954000	16627	8446	4	0	682
128987	2134	98314951000	16627	8446	5	0	683
128988	2133	98299602000	16627	8446	6	0	699
128989	1397	1343380472000	16628	8447	0	0	9545
128991	2133	98298600000	16628	8447	2	0	700
129065	2133	98317638000	16629	8409	73	0	\N
129066	2133	98316636000	16629	8409	74	0	\N
129067	2133	98315634000	16629	8409	75	0	\N
129068	2133	98314632000	16629	8409	76	0	\N
129069	2133	98313630000	16629	8409	77	0	\N
129070	2133	98312628000	16629	8409	78	0	\N
129071	2133	98311626000	16629	8409	79	0	\N
129072	2133	98310624000	16629	8409	80	0	\N
129073	2133	98309622000	16629	8409	81	0	\N
129074	2133	98308620000	16629	8409	82	0	\N
129075	2133	98307618000	16629	8409	83	0	\N
129076	2133	98306616000	16629	8409	84	0	\N
129077	2133	98305614000	16629	8409	85	0	\N
129078	2133	98304612000	16629	8409	86	0	\N
129079	2133	98303610000	16629	8409	87	0	\N
129080	2133	98302608000	16629	8409	88	0	\N
129081	2133	98301606000	16629	8409	89	0	\N
129082	2133	98300604000	16629	8409	90	0	\N
129083	2133	98299602000	16629	8409	91	0	\N
129084	2134	98339023000	16629	8409	92	0	\N
129085	2134	98338020000	16629	8409	93	0	\N
129086	2134	98337017000	16629	8409	94	0	\N
129087	2134	98336014000	16629	8409	95	0	\N
129088	2134	98335011000	16629	8409	96	0	\N
129089	2134	98334008000	16629	8409	97	0	\N
129090	2134	98333005000	16629	8409	98	0	\N
129091	2134	98332002000	16629	8409	99	0	\N
129092	2134	98330999000	16629	8409	100	0	\N
129093	2134	98329996000	16629	8409	101	0	\N
129094	2134	98328993000	16629	8409	102	0	\N
129095	2134	98327990000	16629	8409	103	0	\N
129096	2134	98326987000	16629	8409	104	0	\N
129097	2134	98325984000	16629	8409	105	0	\N
129098	2134	98324981000	16629	8409	106	0	\N
129099	2134	98323978000	16629	8409	107	0	\N
129100	2134	98322975000	16629	8409	108	0	\N
129101	2134	98321972000	16629	8409	109	0	\N
129102	2134	98320969000	16629	8409	110	0	\N
129103	2134	98319966000	16629	8409	111	0	\N
129104	2134	98318963000	16629	8409	112	0	\N
129105	2134	98317960000	16629	8409	113	0	\N
129106	2134	98316957000	16629	8409	114	0	\N
129107	2134	98315954000	16629	8409	115	0	\N
129108	2134	98314951000	16629	8409	116	0	\N
129109	2134	98313948000	16629	8409	117	0	\N
129110	2134	98312945000	16629	8409	118	0	\N
129111	2133	98298600000	16629	8409	119	0	\N
129112	2133	98297598000	16629	8409	120	0	\N
129122	484	82098806000000	16632	8449	0	0	\N
129123	1397	1343360470000	16632	8449	1	0	\N
129124	2132	148807808000	16632	8449	2	0	\N
129125	2133	98296596000	16632	8449	3	0	\N
129126	2134	98311942000	16632	8449	4	0	\N
129127	1397	1343350469000	16633	8450	0	0	\N
129128	2133	98295594000	16633	8450	1	0	\N
129129	2134	98310939000	16633	8450	2	0	\N
129130	2086	2159067000000	16633	8450	3	0	\N
129131	1397	1343350469000	16634	8450	0	0	\N
129132	2133	98295594000	16634	8450	1	0	\N
129133	2134	98310939000	16634	8450	2	0	\N
129134	2086	2159067000000	16634	8450	3	0	\N
129155	1397	1343320466000	16639	8453	0	0	\N
129156	1397	1343310465000	16639	8453	1	0	\N
129157	2132	148806807000	16639	8453	2	0	\N
129158	2134	98307930000	16639	8453	3	0	\N
129159	2133	98292588000	16639	8453	4	0	\N
129160	2133	98291586000	16639	8453	5	0	\N
129161	2134	98306927000	16639	8453	6	0	\N
129181	1397	1343280462000	16645	8457	0	0	\N
129182	1397	1343270461000	16645	8457	1	0	\N
129183	1397	1343260460000	16645	8457	2	0	\N
129184	1397	1343250459000	16645	8457	3	0	\N
129185	1397	1343240458000	16645	8457	4	0	\N
129186	2132	148804805000	16645	8457	5	0	\N
129187	2133	98288580000	16645	8457	6	0	\N
129188	2134	98303918000	16645	8457	7	0	\N
129189	2134	98302915000	16645	8457	8	0	\N
129190	2134	98301912000	16645	8457	9	0	\N
129191	2134	98300909000	16645	8457	10	0	\N
129192	2134	98299906000	16645	8457	11	0	\N
129193	2133	98287578000	16645	8457	12	0	\N
129194	2133	98286576000	16645	8457	13	0	\N
129195	2133	98285574000	16645	8457	14	0	\N
129199	1397	1343230457000	16647	8458	0	0	\N
129200	2133	98284572000	16647	8458	1	0	\N
129115	2134	98312945000	16630	8448	2	0	685
129116	484	82098806000000	16631	8449	0	0	1
129117	1397	1343360470000	16631	8449	1	0	9547
129118	2087	2879070000000	16631	8449	2	0	1
129119	2132	148807808000	16631	8449	3	0	192
129121	2134	98311942000	16631	8449	5	0	686
129135	1397	1343350469000	16635	8450	0	0	9548
129136	2133	98295594000	16635	8450	1	0	703
129137	2134	98310939000	16635	8450	2	0	687
129138	2086	2159067000000	16635	8450	3	0	1
129140	484	71425766000000	16636	8451	1	0	3
129141	484	67868746000000	16636	8451	2	0	4
129142	1397	1343340468000	16636	8451	3	0	9549
129143	2133	98294592000	16636	8451	4	0	704
129145	1397	1343330467000	16637	8452	0	0	9550
129146	2133	98293590000	16637	8452	1	0	705
129147	2134	98308933000	16637	8452	2	0	689
129148	1397	1343320466000	16638	8453	0	0	9551
129149	1397	1343310465000	16638	8453	1	0	9552
129151	2134	98307930000	16638	8453	3	0	690
129152	2133	98292588000	16638	8453	4	0	706
129153	2133	98291586000	16638	8453	5	0	707
129154	2134	98306927000	16638	8453	6	0	691
129162	1397	1343300464000	16640	8454	0	0	9553
129164	2134	98305924000	16640	8454	2	0	692
129165	1397	1343290463000	16641	8455	0	0	9554
129166	2133	98289582000	16641	8455	1	0	709
129167	2132	148805806000	16641	8455	2	0	194
129169	1397	1343280462000	16644	8457	0	0	9555
129170	1397	1343270461000	16644	8457	1	0	9556
129171	1397	1343260460000	16644	8457	2	0	9557
129172	1397	1343250459000	16644	8457	3	0	9558
129173	2132	148804805000	16644	8457	4	0	195
129175	2134	98303918000	16644	8457	6	0	694
129176	2134	98302915000	16644	8457	7	0	695
129177	2134	98301912000	16644	8457	8	0	696
129178	2134	98300909000	16644	8457	9	0	697
129179	2133	98287578000	16644	8457	10	0	711
129196	1397	1343240458000	16646	8458	0	0	9559
129197	2134	98299906000	16646	8458	1	0	698
129198	2133	98285574000	16646	8458	2	0	713
129201	2134	98298903000	16647	8458	2	0	\N
129205	1397	1343230457000	16649	8459	0	0	\N
129206	2133	98284572000	16649	8459	1	0	\N
129207	2134	98298903000	16649	8459	2	0	\N
129214	1397	1343220456000	16651	8460	0	0	\N
129215	1397	1343210455000	16651	8460	1	0	\N
129216	2134	98297900000	16651	8460	2	0	\N
129217	2132	148803804000	16651	8460	3	0	\N
129218	2133	98283570000	16651	8460	4	0	\N
129219	2133	98282568000	16651	8460	5	0	\N
129220	1397	1343200454000	16652	8461	0	0	\N
129221	1397	1343190453000	16652	8461	1	0	\N
129222	2132	148802803000	16652	8461	2	0	\N
129223	2133	98281566000	16652	8461	3	0	\N
129224	2134	98296897000	16652	8461	4	0	\N
129225	2133	98280564000	16652	8461	5	0	\N
129226	2134	98295894000	16652	8461	6	0	\N
129227	1397	1343200454000	16653	8461	0	0	\N
129228	1397	1343190453000	16653	8461	1	0	\N
129229	2132	148802803000	16653	8461	2	0	\N
129230	2133	98281566000	16653	8461	3	0	\N
129231	2134	98296897000	16653	8461	4	0	\N
129232	2133	98280564000	16653	8461	5	0	\N
129233	2134	98295894000	16653	8461	6	0	\N
129234	1397	1343200454000	16654	8461	0	0	\N
129235	1397	1343190453000	16654	8461	1	0	\N
129236	2132	148802803000	16654	8461	2	0	\N
129237	2133	98281566000	16654	8461	3	0	\N
129238	2134	98296897000	16654	8461	4	0	\N
129239	2133	98280564000	16654	8461	5	0	\N
129240	2134	98295894000	16654	8461	6	0	\N
129241	1397	1343200454000	16655	8461	0	0	\N
129242	1397	1343190453000	16655	8461	1	0	\N
129243	2132	148802803000	16655	8461	2	0	\N
129244	2133	98281566000	16655	8461	3	0	\N
129245	2134	98296897000	16655	8461	4	0	\N
129246	2133	98280564000	16655	8461	5	0	\N
129247	2134	98295894000	16655	8461	6	0	\N
129261	1397	1343160450000	16659	8464	0	0	\N
129262	1397	1343150449000	16659	8464	1	0	\N
129263	1397	1343140448000	16659	8464	2	0	\N
129264	2132	148801802000	16659	8464	3	0	\N
129265	2134	98292885000	16659	8464	4	0	\N
129266	2133	98277558000	16659	8464	5	0	\N
129267	2133	98276556000	16659	8464	6	0	\N
129268	2134	98291882000	16659	8464	7	0	\N
129269	2134	98290879000	16659	8464	8	0	\N
129270	1397	1343160450000	16660	8464	0	0	\N
129271	1397	1343150449000	16660	8464	1	0	\N
129272	1397	1343140448000	16660	8464	2	0	\N
129273	2132	148801802000	16660	8464	3	0	\N
129274	2134	98292885000	16660	8464	4	0	\N
129275	2133	98277558000	16660	8464	5	0	\N
129276	2133	98276556000	16660	8464	6	0	\N
129277	2134	98291882000	16660	8464	7	0	\N
129278	2134	98290879000	16660	8464	8	0	\N
129288	632	85813954000000	16662	8335	0	0	\N
129289	484	82098806000000	16662	8335	1	0	\N
129290	484	75725786000000	16662	8335	2	0	\N
129291	484	71425766000000	16662	8335	3	0	\N
129292	484	67868746000000	16662	8335	4	0	\N
129293	632	77969934000000	16662	8335	5	0	\N
129294	632	72677914000000	16662	8335	6	0	\N
129295	632	68300894000000	16662	8335	7	0	\N
129296	1726	133805109000	16662	8335	8	0	\N
129297	1860	43896955400000	16662	8335	9	0	\N
129298	1726	132595109000	16662	8335	10	0	\N
129299	1726	131385109000	16662	8335	11	0	\N
129300	1726	130175109000	16662	8335	12	0	\N
129301	1692	13459946719999	16662	8335	13	0	\N
129302	1597	1440010000000	16662	8335	14	0	\N
129303	1597	1438990000000	16662	8335	15	0	\N
129304	1597	1438980000000	16662	8335	16	0	\N
129305	2087	2879070000000	16662	8335	17	0	\N
129306	1769	1696900000	16662	8335	18	0	\N
129307	1769	1695900000	16662	8335	19	0	\N
129308	1769	1694900000	16662	8335	20	0	\N
129309	1769	1693900000	16662	8335	21	0	\N
129310	1769	1692900000	16662	8335	22	0	\N
129311	2086	2159067000000	16662	8335	23	0	\N
129312	1397	1343130447000	16663	8465	0	0	\N
129313	2133	98275554000	16663	8465	1	0	\N
129314	2134	98289876000	16663	8465	2	0	\N
129315	1397	1343130447000	16664	8465	0	0	\N
129316	2133	98275554000	16664	8465	1	0	\N
129317	2134	98289876000	16664	8465	2	0	\N
129328	1397	1343120446000	16668	8466	0	0	\N
129329	1397	1343110445000	16668	8466	1	0	\N
129330	2134	98288873000	16668	8466	2	0	\N
129331	2134	98287870000	16668	8466	3	0	\N
129332	2132	148800801000	16668	8466	4	0	\N
129333	2133	98274552000	16668	8466	5	0	\N
129334	2133	98273550000	16668	8466	6	0	\N
129335	1397	1343100444000	16669	8468	0	0	\N
129336	2133	98272548000	16669	8468	1	0	\N
129204	2134	98298903000	16648	8459	2	0	699
129208	1397	1343220456000	16650	8460	0	0	9561
129209	1397	1343210455000	16650	8460	1	0	9562
129210	2134	98297900000	16650	8460	2	0	700
129211	2132	148803804000	16650	8460	3	0	196
129213	2133	98282568000	16650	8460	5	0	716
129248	1397	1343200454000	16656	8461	0	0	9563
129249	1397	1343190453000	16656	8461	1	0	9564
129250	2132	148802803000	16656	8461	2	0	197
129251	2133	98281566000	16656	8461	3	0	717
129253	2133	98280564000	16656	8461	5	0	718
129254	2134	98295894000	16656	8461	6	0	702
129255	1397	1343180452000	16657	8462	0	0	9565
129256	2133	98279562000	16657	8462	1	0	719
129258	1397	1343170451000	16658	8463	0	0	9566
129259	2134	98293888000	16658	8463	1	0	704
129260	2133	98278560000	16658	8463	2	0	720
129279	1397	1343160450000	16661	8464	0	0	9567
129280	1397	1343150449000	16661	8464	1	0	9568
129282	2132	148801802000	16661	8464	3	0	198
129283	2134	98292885000	16661	8464	4	0	705
129284	2133	98277558000	16661	8464	5	0	721
129285	2133	98276556000	16661	8464	6	0	722
129286	2134	98291882000	16661	8464	7	0	706
129318	1397	1343130447000	16665	8465	0	0	9570
129319	2133	98275554000	16665	8465	1	0	723
129320	2134	98289876000	16665	8465	2	0	708
129321	1397	1343120446000	16666	8466	0	0	9571
129323	2132	148800801000	16666	8466	2	0	199
129324	2133	98274552000	16666	8466	3	0	724
129325	1397	1343110445000	16667	8467	0	0	9572
129326	2134	98287870000	16667	8467	1	0	710
129327	2133	98273550000	16667	8467	2	0	725
129337	2134	98286867000	16669	8468	2	0	\N
129341	1397	1343100444000	16671	8468	0	0	\N
129342	2133	98272548000	16671	8468	1	0	\N
129343	2134	98286867000	16671	8468	2	0	\N
129344	1397	1343090443000	16672	8469	0	0	\N
129345	1397	1343080442000	16672	8469	1	0	\N
129346	2133	98271546000	16672	8469	2	0	\N
129347	2134	98285864000	16672	8469	3	0	\N
129348	2132	148799800000	16672	8469	4	0	\N
129349	2133	98270544000	16672	8469	5	0	\N
129356	1397	1343070441000	16674	8470	0	0	\N
129357	1397	1343060440000	16674	8470	1	0	\N
129358	2132	148798799000	16674	8470	2	0	\N
129359	2134	98284861000	16674	8470	3	0	\N
129360	2134	98283858000	16674	8470	4	0	\N
129361	2133	98269542000	16674	8470	5	0	\N
129362	2133	98268540000	16674	8470	6	0	\N
129363	1397	1343070441000	16675	8470	0	0	\N
129364	1397	1343060440000	16675	8470	1	0	\N
129365	2132	148798799000	16675	8470	2	0	\N
129366	2134	98284861000	16675	8470	3	0	\N
129367	2134	98283858000	16675	8470	4	0	\N
129368	2133	98269542000	16675	8470	5	0	\N
129369	2133	98268540000	16675	8470	6	0	\N
129377	1397	1343070441000	16677	8470	0	0	\N
129378	1397	1343060440000	16677	8470	1	0	\N
129379	2132	148798799000	16677	8470	2	0	\N
129380	2134	98284861000	16677	8470	3	0	\N
129381	2134	98283858000	16677	8470	4	0	\N
129382	2133	98269542000	16677	8470	5	0	\N
129383	2133	98268540000	16677	8470	6	0	\N
129384	1397	1343050439000	16678	8471	0	0	\N
129385	2133	98267538000	16678	8471	1	0	\N
129386	2134	98282855000	16678	8471	2	0	\N
129403	1397	1343000434000	16682	8474	0	0	\N
129404	1397	1342990433000	16682	8474	1	0	\N
129405	2132	148796797000	16682	8474	2	0	\N
129406	2133	98262528000	16682	8474	3	0	\N
129407	2133	98261526000	16682	8474	4	0	\N
129408	2134	98277840000	16682	8474	6	0	\N
129409	2134	98276837000	16682	8474	7	0	\N
129417	1397	1342980432000	16684	8475	0	0	\N
129418	2134	98275834000	16684	8475	1	0	\N
129421	632	85813954000000	16687	8383	0	0	\N
129422	484	82098806000000	16687	8383	1	0	\N
129423	484	75725786000000	16687	8383	2	0	\N
129424	484	71425766000000	16687	8383	4	0	\N
129425	484	67868746000000	16687	8383	5	0	\N
129426	632	77969934000000	16687	8383	6	0	\N
129427	632	72677914000000	16687	8383	7	0	\N
129428	632	68300894000000	16687	8383	8	0	\N
129429	1726	131385109000	16687	8383	9	0	\N
129430	1726	130175109000	16687	8383	10	0	\N
129431	1397	1344340568000	16687	8383	11	0	\N
129432	1860	107499987700000	16687	8383	12	0	\N
129433	1860	977700000	16687	8383	13	0	\N
129434	1397	1344330567000	16687	8383	14	0	\N
129435	1397	1344320566000	16687	8383	15	0	\N
129436	1397	1344310565000	16687	8383	16	0	\N
129437	1397	1344300564000	16687	8383	17	0	\N
129438	1397	1344290563000	16687	8383	18	0	\N
129439	1397	1344280562000	16687	8383	19	0	\N
129440	1397	1344270561000	16687	8383	20	0	\N
129441	1397	1344260560000	16687	8383	21	0	\N
129442	1397	1344250559000	16687	8383	22	0	\N
129443	1397	1344240558000	16687	8383	23	0	\N
129444	1397	1344230557000	16687	8383	24	0	\N
129445	1397	1344220556000	16687	8383	25	0	\N
129446	1397	1344210555000	16687	8383	26	0	\N
129447	1397	1344200554000	16687	8383	27	0	\N
129448	1397	1344190553000	16687	8383	28	0	\N
129449	1397	1344180552000	16687	8383	29	0	\N
129450	1397	1344170551000	16687	8383	30	0	\N
129451	1397	1344160550000	16687	8383	31	0	\N
129452	1397	1344150549000	16687	8383	32	0	\N
129453	1397	1344140548000	16687	8383	33	0	\N
129454	1397	1344130547000	16687	8383	34	0	\N
129455	1397	1344120546000	16687	8383	35	0	\N
129456	1397	1344110545000	16687	8383	36	0	\N
129457	1397	1344100544000	16687	8383	37	0	\N
129458	1397	1344090543000	16687	8383	38	0	\N
129459	1397	1344080542000	16687	8383	39	0	\N
129460	1597	2160034000000	16687	8383	40	0	\N
129461	1397	1344070541000	16687	8383	41	0	\N
129462	1397	1344060540000	16687	8383	42	0	\N
129463	1397	1344050539000	16687	8383	43	0	\N
129464	1397	1344040538000	16687	8383	44	0	\N
129465	1397	1344030537000	16687	8383	45	0	\N
129466	1397	1344020536000	16687	8383	46	0	\N
129467	1397	1344010535000	16687	8383	47	0	\N
129468	1397	1344000534000	16687	8383	48	0	\N
129469	1397	1343990533000	16687	8383	49	0	\N
129470	1397	1343980532000	16687	8383	50	0	\N
129471	1397	1343970531000	16687	8383	51	0	\N
129472	1397	1343960530000	16687	8383	52	0	\N
129340	2134	98286867000	16670	8468	2	0	711
129350	1397	1343090443000	16673	8469	0	0	9574
129351	1397	1343080442000	16673	8469	1	0	9575
129352	2133	98271546000	16673	8469	2	0	727
129353	2134	98285864000	16673	8469	3	0	712
129355	2133	98270544000	16673	8469	5	0	728
129370	1397	1343070441000	16676	8470	0	0	9576
129371	1397	1343060440000	16676	8470	1	0	9577
129372	2132	148798799000	16676	8470	2	0	201
129373	2134	98284861000	16676	8470	3	0	713
129375	2133	98269542000	16676	8470	5	0	729
129376	2133	98268540000	16676	8470	6	0	730
129387	1397	1343050439000	16679	8471	0	0	9578
129388	2133	98267538000	16679	8471	1	0	731
129390	1397	1343040438000	16680	8472	0	0	9579
129391	2133	98266536000	16680	8472	1	0	732
129392	2134	98281852000	16680	8472	2	0	716
129393	1397	1343030437000	16681	8473	0	0	9580
129394	1397	1343020436000	16681	8473	1	0	9581
129396	2132	148797798000	16681	8473	3	0	202
129397	2134	98280849000	16681	8473	4	0	717
129398	2134	98279846000	16681	8473	5	0	718
129399	2134	98278843000	16681	8473	6	0	719
129400	2133	98265534000	16681	8473	7	0	733
129402	2133	98263530000	16681	8473	9	0	735
129410	1397	1343000434000	16683	8474	0	0	9583
129411	1397	1342990433000	16683	8474	1	0	9584
129412	2132	148796797000	16683	8474	2	0	203
129414	2133	98261526000	16683	8474	4	0	737
129415	2134	98277840000	16683	8474	6	0	720
129416	2134	98276837000	16683	8474	7	0	721
129419	1397	1342980432000	16685	8475	0	0	9585
129420	2134	98275834000	16685	8475	1	0	722
129473	1397	1343950529000	16687	8383	53	0	\N
129474	1397	1343940528000	16687	8383	54	0	\N
129475	1397	1343930527000	16687	8383	55	0	\N
129476	1397	1343920526000	16687	8383	56	0	\N
129477	1397	1343910525000	16687	8383	57	0	\N
129478	1597	2159014000000	16687	8383	58	0	\N
129479	1597	2159004000000	16687	8383	59	0	\N
129480	1397	1343900524000	16687	8383	60	0	\N
129481	1397	1343890523000	16687	8383	61	0	\N
129482	1397	1343880522000	16687	8383	62	0	\N
129483	1397	1343870521000	16687	8383	63	0	\N
129484	1397	1343860520000	16687	8383	64	0	\N
129485	1397	1343850519000	16687	8383	65	0	\N
129486	1397	1343840518000	16687	8383	66	0	\N
129487	1397	1343830517000	16687	8383	67	0	\N
129488	1397	1343820516000	16687	8383	68	0	\N
129489	1397	1343810515000	16687	8383	69	0	\N
129490	1397	1343800514000	16687	8383	70	0	\N
129491	1397	1343790513000	16687	8383	71	0	\N
129492	1397	1343780512000	16687	8383	72	0	\N
129493	1397	1343770511000	16687	8383	73	0	\N
129494	1397	1343760510000	16687	8383	74	0	\N
129495	1397	1343750509000	16687	8383	75	0	\N
129496	1397	1343740508000	16687	8383	76	0	\N
129497	1397	1343730507000	16687	8383	77	0	\N
129498	1397	1343720506000	16687	8383	78	0	\N
129499	1397	1343710505000	16687	8383	79	0	\N
129500	1397	1343700504000	16687	8383	80	0	\N
129501	1397	1343690503000	16687	8383	81	0	\N
129502	1397	1343680502000	16687	8383	82	0	\N
129503	1397	1343670501000	16687	8383	83	0	\N
129504	1397	1343660500000	16687	8383	84	0	\N
129505	1397	1343650499000	16687	8383	85	0	\N
129506	1397	1343640498000	16687	8383	86	0	\N
129507	1397	1343630497000	16687	8383	87	0	\N
129508	1397	1343620496000	16687	8383	88	0	\N
129509	1397	1343610495000	16687	8383	89	0	\N
129510	1397	1343600494000	16687	8383	90	0	\N
129511	1397	1343590493000	16687	8383	91	0	\N
129512	1397	1343580492000	16687	8383	92	0	\N
129513	1397	1343570491000	16687	8383	93	0	\N
129514	1397	1343560490000	16687	8383	94	0	\N
129515	1397	1343550489000	16687	8383	95	0	\N
129516	1397	1343540488000	16687	8383	96	0	\N
129517	1397	1343530487000	16687	8383	97	0	\N
129518	1397	1343520486000	16687	8383	98	0	\N
129519	1397	1343510485000	16687	8383	99	0	\N
129520	1397	1343500484000	16687	8383	100	0	\N
129521	1397	1343490483000	16687	8383	101	0	\N
129522	1397	1343480482000	16687	8383	102	0	\N
129523	1397	1343470481000	16687	8383	103	0	\N
129524	1397	1343460480000	16687	8383	104	0	\N
129525	1397	1343450479000	16687	8383	105	0	\N
129526	1397	1343440478000	16687	8383	106	0	\N
129527	1397	1343430477000	16687	8383	107	0	\N
129528	1397	1343420476000	16687	8383	108	0	\N
129529	1397	1343410475000	16687	8383	109	0	\N
129530	1397	1343400474000	16687	8383	110	0	\N
129531	1397	1343390473000	16687	8383	111	0	\N
129532	1397	1343380472000	16687	8383	112	0	\N
129533	1397	1343370471000	16687	8383	113	0	\N
129534	1397	1343360470000	16687	8383	114	0	\N
129535	1397	1343350469000	16687	8383	115	0	\N
129536	1397	1343340468000	16687	8383	116	0	\N
129537	1397	1343330467000	16687	8383	117	0	\N
129538	1397	1343320466000	16687	8383	118	0	\N
129539	1397	1343310465000	16687	8383	119	0	\N
129540	1397	1343300464000	16687	8383	120	0	\N
129541	1397	1343290463000	16687	8383	121	0	\N
129542	1397	1343280462000	16687	8383	122	0	\N
129543	1397	1343270461000	16687	8383	123	0	\N
129544	1397	1343260460000	16687	8383	124	0	\N
129545	1397	1343250459000	16687	8383	125	0	\N
129569	1397	1342900424000	16690	8478	0	0	\N
129570	1397	1342890423000	16690	8478	1	0	\N
129571	2133	98253510000	16690	8478	2	0	\N
129572	2133	98252508000	16690	8478	3	0	\N
129573	2132	148793794000	16690	8478	4	0	\N
129574	2134	98267810000	16690	8478	5	0	\N
129575	2134	98266807000	16690	8478	6	0	\N
129576	1397	1342900424000	16691	8478	0	0	\N
129577	1397	1342890423000	16691	8478	1	0	\N
129578	2133	98253510000	16691	8478	2	0	\N
129579	2133	98252508000	16691	8478	3	0	\N
129580	2132	148793794000	16691	8478	4	0	\N
129581	2134	98267810000	16691	8478	5	0	\N
129582	2134	98266807000	16691	8478	6	0	\N
129593	1397	1342870421000	16694	8480	0	0	\N
129594	2134	98264801000	16694	8480	1	0	\N
129548	1397	1342950429000	16688	8476	2	0	9588
129549	1397	1342940428000	16688	8476	3	0	9589
129550	1397	1342930427000	16688	8476	4	0	9590
129551	2132	148795796000	16688	8476	5	0	204
129552	2134	98274831000	16688	8476	6	0	723
129554	2134	98272825000	16688	8476	8	0	725
129555	2133	98260524000	16688	8476	9	0	738
129556	2133	98259522000	16688	8476	10	0	739
129557	2133	98258520000	16688	8476	11	0	740
129558	2133	98257518000	16688	8476	12	0	741
129560	2134	98270819000	16688	8476	14	0	727
129561	2133	98256516000	16688	8476	15	0	742
129562	1397	1342920426000	16689	8477	0	0	9591
129563	1397	1342910425000	16689	8477	1	0	9592
129565	2133	98254512000	16689	8477	3	0	744
129566	2132	148794795000	16689	8477	4	0	205
129567	2134	98269816000	16689	8477	5	0	728
129568	2134	98268813000	16689	8477	6	0	729
129583	1397	1342900424000	16692	8478	0	0	9593
129585	2133	98253510000	16692	8478	2	0	745
129586	2133	98252508000	16692	8478	3	0	746
129587	2132	148793794000	16692	8478	4	0	206
129588	2134	98267810000	16692	8478	5	0	730
129589	2134	98266807000	16692	8478	6	0	731
129591	2134	98265804000	16693	8479	1	0	732
129592	2133	98251506000	16693	8479	2	0	747
129595	1397	1342870421000	16695	8480	0	0	9596
129596	2134	98264801000	16695	8480	1	0	733
129598	1397	1342850419000	16696	8481	1	0	9598
129599	2134	98263798000	16696	8481	2	0	734
129600	2134	98262795000	16696	8481	3	0	735
129601	2132	148792793000	16696	8481	4	0	207
129602	2133	98250504000	16696	8481	5	0	748
129604	2133	98248500000	16696	8481	7	0	750
129605	2134	98261792000	16696	8481	8	0	736
129606	1397	1342840418000	16697	8482	0	0	9599
129607	2133	98247498000	16697	8482	1	0	751
129608	2134	98260789000	16697	8482	2	0	737
129622	1397	1342800414000	16702	8486	0	0	\N
129623	2134	98257780000	16702	8486	1	0	\N
129624	2133	98243490000	16702	8486	2	0	\N
129625	2132	148790791000	16702	8486	3	0	\N
129626	1397	1342790413000	16703	8487	0	0	\N
129627	2133	98242488000	16703	8487	1	0	\N
129628	2134	98256777000	16703	8487	2	0	\N
129639	1397	1342780412000	16706	8488	0	0	\N
129640	1397	1342770411000	16706	8488	1	0	\N
129641	2134	98255774000	16706	8488	2	0	\N
129642	2134	98254771000	16706	8488	3	0	\N
129643	2133	98241486000	16706	8488	4	0	\N
129644	2133	98240484000	16706	8488	5	0	\N
129645	2132	148789790000	16706	8488	6	0	\N
129646	484	82098806000000	16707	8428	0	0	\N
129647	484	75725786000000	16707	8428	1	0	\N
129648	484	71425766000000	16707	8428	2	0	\N
129649	484	67868746000000	16707	8428	3	0	\N
129650	1397	1343490483000	16707	8428	4	0	\N
129651	1397	1343480482000	16707	8428	5	0	\N
129652	1397	1343470481000	16707	8428	6	0	\N
129653	1397	1343460480000	16707	8428	7	0	\N
129654	1397	1343450479000	16707	8428	8	0	\N
129655	1397	1343440478000	16707	8428	9	0	\N
129656	1397	1343430477000	16707	8428	10	0	\N
129657	1397	1343420476000	16707	8428	11	0	\N
129658	1397	1343410475000	16707	8428	12	0	\N
129659	1397	1343400474000	16707	8428	13	0	\N
129660	1397	1343390473000	16707	8428	14	0	\N
129661	1397	1343380472000	16707	8428	15	0	\N
129662	1397	1343370471000	16707	8428	16	0	\N
129663	1397	1343360470000	16707	8428	17	0	\N
129664	1397	1343350469000	16707	8428	18	0	\N
129665	1397	1343340468000	16707	8428	20	0	\N
129666	1397	1343330467000	16707	8428	21	0	\N
129667	1397	1343320466000	16707	8428	22	0	\N
129668	1397	1343310465000	16707	8428	23	0	\N
129669	1397	1343300464000	16707	8428	24	0	\N
129670	1397	1343290463000	16707	8428	25	0	\N
129671	1397	1343280462000	16707	8428	26	0	\N
129672	1397	1343270461000	16707	8428	27	0	\N
129673	1397	1343260460000	16707	8428	28	0	\N
129674	1397	1343250459000	16707	8428	29	0	\N
129675	1397	1343240458000	16707	8428	30	0	\N
129676	1397	1343230457000	16707	8428	31	0	\N
129677	1397	1343220456000	16707	8428	32	0	\N
129678	1397	1343210455000	16707	8428	33	0	\N
129679	1397	1343200454000	16707	8428	34	0	\N
129680	1397	1343190453000	16707	8428	35	0	\N
129681	1397	1343180452000	16707	8428	36	0	\N
129682	1397	1343170451000	16707	8428	37	0	\N
129683	1397	1343160450000	16707	8428	38	0	\N
129684	1397	1343150449000	16707	8428	39	0	\N
129685	1397	1343140448000	16707	8428	40	0	\N
129686	1397	1343130447000	16707	8428	41	0	\N
129687	1397	1343120446000	16707	8428	42	0	\N
129688	1397	1343110445000	16707	8428	43	0	\N
129689	1397	1343100444000	16707	8428	44	0	\N
129690	1397	1343090443000	16707	8428	45	0	\N
129691	1397	1343080442000	16707	8428	46	0	\N
129692	1397	1343070441000	16707	8428	47	0	\N
129693	1397	1343060440000	16707	8428	48	0	\N
129694	1397	1343050439000	16707	8428	49	0	\N
129695	1397	1343040438000	16707	8428	50	0	\N
129696	1397	1343030437000	16707	8428	51	0	\N
129697	1397	1343020436000	16707	8428	52	0	\N
129698	1397	1343010435000	16707	8428	53	0	\N
129699	1397	1343000434000	16707	8428	54	0	\N
129700	1397	1342990433000	16707	8428	55	0	\N
129701	1397	1342980432000	16707	8428	56	0	\N
129702	1397	1342970431000	16707	8428	57	0	\N
129703	1397	1342960430000	16707	8428	58	0	\N
129704	1397	1342950429000	16707	8428	59	0	\N
129705	1397	1342940428000	16707	8428	60	0	\N
129706	1397	1342930427000	16707	8428	61	0	\N
129707	1397	1342920426000	16707	8428	62	0	\N
129708	1397	1342910425000	16707	8428	63	0	\N
129709	1397	1342900424000	16707	8428	64	0	\N
129710	1397	1342890423000	16707	8428	65	0	\N
129711	1397	1342880422000	16707	8428	66	0	\N
129712	1397	1342870421000	16707	8428	67	0	\N
129713	1397	1342860420000	16707	8428	68	0	\N
129714	1397	1342850419000	16707	8428	69	0	\N
129715	1397	1342840418000	16707	8428	70	0	\N
129716	1397	1342830417000	16707	8428	71	0	\N
129717	1397	1342820416000	16707	8428	72	0	\N
129718	1397	1342810415000	16707	8428	73	0	\N
129719	1397	1342800414000	16707	8428	74	0	\N
129720	1397	1342790413000	16707	8428	75	0	\N
129721	1397	1342780412000	16707	8428	76	0	\N
129722	1397	1342770411000	16707	8428	77	0	\N
129723	2087	2879070000000	16707	8428	78	0	\N
129724	2133	98308620000	16707	8428	79	0	\N
129725	2132	148811812000	16707	8428	80	0	\N
129726	2133	98307618000	16707	8428	81	0	\N
129727	2133	98306616000	16707	8428	82	0	\N
129728	2133	98305614000	16707	8428	83	0	\N
129729	2133	98304612000	16707	8428	84	0	\N
129730	2133	98303610000	16707	8428	85	0	\N
129731	2086	2159067000000	16707	8428	86	0	\N
129732	2132	148810811000	16707	8428	87	0	\N
129733	2132	148809810000	16707	8428	88	0	\N
129734	2132	148808809000	16707	8428	89	0	\N
129735	2132	148807808000	16707	8428	90	0	\N
129736	2132	148806807000	16707	8428	91	0	\N
129737	2132	148805806000	16707	8428	92	0	\N
129738	2132	148804805000	16707	8428	93	0	\N
129739	2132	148803804000	16707	8428	94	0	\N
129740	2132	148802803000	16707	8428	95	0	\N
129741	2132	148801802000	16707	8428	96	0	\N
129742	2132	148800801000	16707	8428	97	0	\N
129743	2132	148799800000	16707	8428	98	0	\N
129744	2132	148798799000	16707	8428	99	0	\N
129611	2134	98259786000	16698	8483	2	0	738
129612	2132	148791792000	16698	8483	3	0	208
129613	1397	1342820416000	16699	8484	0	0	9601
129614	2133	98245494000	16699	8484	1	0	753
129615	2134	98258783000	16699	8484	2	0	739
129617	2133	98244492000	16700	8485	1	0	754
129618	1397	1342800414000	16701	8486	0	0	9603
129619	2134	98257780000	16701	8486	1	0	740
129620	2133	98243490000	16701	8486	2	0	755
129621	2132	148790791000	16701	8486	3	0	209
129630	2133	98242488000	16704	8487	1	0	756
129631	2134	98256777000	16704	8487	2	0	741
129632	1397	1342780412000	16705	8488	0	0	9605
129633	1397	1342770411000	16705	8488	1	0	9606
129635	2134	98254771000	16705	8488	3	0	743
129636	2133	98241486000	16705	8488	4	0	757
129637	2133	98240484000	16705	8488	5	0	758
129638	2132	148789790000	16705	8488	6	0	210
129745	2132	148797798000	16707	8428	100	0	\N
129746	2132	148796797000	16707	8428	101	0	\N
129747	2132	148795796000	16707	8428	102	0	\N
129748	2132	148794795000	16707	8428	103	0	\N
129749	2132	148793794000	16707	8428	104	0	\N
129750	2132	148792793000	16707	8428	105	0	\N
129751	2132	148791792000	16707	8428	106	0	\N
129752	2132	148790791000	16707	8428	107	0	\N
129753	2132	148789790000	16707	8428	108	0	\N
129754	2133	98302608000	16707	8428	109	0	\N
129755	2133	98301606000	16707	8428	110	0	\N
129756	2133	98300604000	16707	8428	111	0	\N
129757	2133	98299602000	16707	8428	112	0	\N
129758	2133	98298600000	16707	8428	113	0	\N
129759	2133	98297598000	16707	8428	114	0	\N
129760	2133	98296596000	16707	8428	115	0	\N
129761	2133	98295594000	16707	8428	116	0	\N
129762	2133	98294592000	16707	8428	117	0	\N
129763	2133	98293590000	16707	8428	118	0	\N
129764	2133	98292588000	16707	8428	119	0	\N
129765	2133	98291586000	16707	8428	120	0	\N
129766	2133	98290584000	16707	8428	121	0	\N
129767	2133	98289582000	16707	8428	122	0	\N
129771	632	85813954000000	16709	8426	0	0	\N
129772	484	82098806000000	16709	8426	1	0	\N
129773	484	75725786000000	16709	8426	2	0	\N
129774	484	71425766000000	16709	8426	3	0	\N
129775	484	67868746000000	16709	8426	4	0	\N
129776	632	77969934000000	16709	8426	5	0	\N
129777	632	72677914000000	16709	8426	6	0	\N
129778	632	68300894000000	16709	8426	7	0	\N
129779	1397	1343650499000	16709	8426	8	0	\N
129780	1397	1343640498000	16709	8426	9	0	\N
129781	1397	1343630497000	16709	8426	10	0	\N
129782	1397	1343620496000	16709	8426	11	0	\N
129783	1397	1343610495000	16709	8426	12	0	\N
129784	1397	1343600494000	16709	8426	13	0	\N
129785	1397	1343590493000	16709	8426	14	0	\N
129786	1397	1343580492000	16709	8426	15	0	\N
129787	1397	1343570491000	16709	8426	16	0	\N
129788	1397	1343560490000	16709	8426	17	0	\N
129789	1397	1343550489000	16709	8426	18	0	\N
129790	1397	1343540488000	16709	8426	19	0	\N
129791	1397	1343530487000	16709	8426	20	0	\N
129792	1397	1343520486000	16709	8426	21	0	\N
129793	1397	1343510485000	16709	8426	22	0	\N
129794	1397	1343500484000	16709	8426	23	0	\N
129795	1397	1343490483000	16709	8426	24	0	\N
129796	1397	1343480482000	16709	8426	25	0	\N
129797	1397	1343470481000	16709	8426	26	0	\N
129798	1397	1343460480000	16709	8426	27	0	\N
129799	1397	1343450479000	16709	8426	28	0	\N
129800	1397	1343440478000	16709	8426	29	0	\N
129801	1397	1343430477000	16709	8426	30	0	\N
129802	1397	1343420476000	16709	8426	31	0	\N
129803	1397	1343410475000	16709	8426	32	0	\N
129804	1397	1343400474000	16709	8426	33	0	\N
129805	1397	1343390473000	16709	8426	34	0	\N
129806	1397	1343380472000	16709	8426	35	0	\N
129807	1397	1343370471000	16709	8426	36	0	\N
129808	1397	1343360470000	16709	8426	37	0	\N
129809	1397	1343350469000	16709	8426	38	0	\N
129810	1397	1343340468000	16709	8426	39	0	\N
129811	1397	1343330467000	16709	8426	40	0	\N
129812	1397	1343320466000	16709	8426	41	0	\N
129813	1397	1343310465000	16709	8426	42	0	\N
129814	1397	1343300464000	16709	8426	43	0	\N
129815	1397	1343290463000	16709	8426	44	0	\N
129816	1397	1343280462000	16709	8426	45	0	\N
129817	1397	1343270461000	16709	8426	46	0	\N
129818	1397	1343260460000	16709	8426	47	0	\N
129819	1397	1343250459000	16709	8426	48	0	\N
129820	1397	1343240458000	16709	8426	49	0	\N
129821	1397	1343230457000	16709	8426	50	0	\N
129822	1397	1343220456000	16709	8426	51	0	\N
129823	1397	1343210455000	16709	8426	52	0	\N
129824	1397	1343200454000	16709	8426	53	0	\N
129825	1397	1343190453000	16709	8426	54	0	\N
129826	1397	1343180452000	16709	8426	55	0	\N
129827	1397	1343170451000	16709	8426	56	0	\N
129828	1397	1343160450000	16709	8426	57	0	\N
129829	1397	1343150449000	16709	8426	58	0	\N
129830	1397	1343140448000	16709	8426	59	0	\N
129831	1397	1343130447000	16709	8426	60	0	\N
129832	1397	1343120446000	16709	8426	61	0	\N
129833	1397	1343110445000	16709	8426	62	0	\N
129834	1397	1343100444000	16709	8426	64	0	\N
129835	1397	1343090443000	16709	8426	65	0	\N
129836	1397	1343080442000	16709	8426	66	0	\N
129837	1397	1343070441000	16709	8426	67	0	\N
129838	1397	1343060440000	16709	8426	68	0	\N
129839	1397	1343050439000	16709	8426	69	0	\N
129840	1397	1343040438000	16709	8426	70	0	\N
129841	1397	1343030437000	16709	8426	71	0	\N
129842	1397	1343020436000	16709	8426	72	0	\N
129843	1397	1343010435000	16709	8426	73	0	\N
129844	1397	1343000434000	16709	8426	74	0	\N
129845	1397	1342990433000	16709	8426	75	0	\N
129846	1397	1342980432000	16709	8426	76	0	\N
129847	1397	1342970431000	16709	8426	77	0	\N
129848	1397	1342960430000	16709	8426	78	0	\N
129849	1397	1342950429000	16709	8426	79	0	\N
129850	1397	1342940428000	16709	8426	80	0	\N
129851	1397	1342930427000	16709	8426	81	0	\N
129852	1397	1342920426000	16709	8426	82	0	\N
129853	1397	1342910425000	16709	8426	83	0	\N
129854	1397	1342900424000	16709	8426	84	0	\N
129855	1397	1342890423000	16709	8426	85	0	\N
129856	1397	1342880422000	16709	8426	86	0	\N
129857	1397	1342870421000	16709	8426	87	0	\N
129858	1397	1342860420000	16709	8426	88	0	\N
129859	1397	1342850419000	16709	8426	89	0	\N
129860	1397	1342840418000	16709	8426	90	0	\N
129861	1397	1342830417000	16709	8426	91	0	\N
129862	1397	1342820416000	16709	8426	92	0	\N
129863	1397	1342810415000	16709	8426	93	0	\N
129864	1397	1342800414000	16709	8426	94	0	\N
129865	1397	1342790413000	16709	8426	95	0	\N
129866	1397	1342780412000	16709	8426	96	0	\N
129867	1397	1342770411000	16709	8426	97	0	\N
129868	1397	1342760410000	16709	8426	98	0	\N
129869	2087	2879070000000	16709	8426	99	0	\N
129870	2132	148815816000	16709	8426	100	0	\N
129871	2132	148814815000	16709	8426	101	0	\N
129872	2132	148813814000	16709	8426	102	0	\N
129873	2132	148812813000	16709	8426	103	0	\N
129874	2132	148811812000	16709	8426	104	0	\N
129875	2133	98323650000	16709	8426	105	0	\N
129876	2134	98340026000	16709	8426	106	0	\N
129877	2133	98322648000	16709	8426	107	0	\N
129878	2133	98321646000	16709	8426	108	0	\N
129879	2133	98320644000	16709	8426	109	0	\N
129880	2133	98319642000	16709	8426	110	0	\N
129770	2133	98239482000	16708	8489	2	0	759
129881	2133	98318640000	16709	8426	111	0	\N
129882	2133	98317638000	16709	8426	112	0	\N
129883	2133	98316636000	16709	8426	113	0	\N
129884	2133	98315634000	16709	8426	114	0	\N
129885	2133	98314632000	16709	8426	115	0	\N
129886	2133	98313630000	16709	8426	116	0	\N
129887	2133	98312628000	16709	8426	117	0	\N
129888	2133	98311626000	16709	8426	118	0	\N
129889	2086	2159067000000	16709	8426	119	0	\N
129890	2132	148810811000	16709	8426	120	0	\N
129891	2132	148809810000	16709	8426	121	0	\N
129892	2132	148808809000	16709	8426	122	0	\N
129893	2132	148807808000	16709	8426	123	0	\N
129894	2132	148806807000	16709	8426	124	0	\N
129895	2132	148805806000	16709	8426	125	0	\N
129909	1397	1342710405000	16712	8492	0	0	\N
129910	2133	98234472000	16712	8492	2	0	\N
129911	2134	98248753000	16712	8492	3	0	\N
129912	1397	1342710405000	16713	8492	0	0	\N
129913	1397	1342710405000	16714	8492	0	0	\N
129914	2133	98234472000	16714	8492	2	0	\N
129915	2134	98248753000	16714	8492	3	0	\N
129916	1397	1342710405000	16715	8492	0	0	\N
129917	2133	98234472000	16715	8492	2	0	\N
129918	2134	98248753000	16715	8492	3	0	\N
129919	1397	1342710405000	16716	8492	0	0	\N
129920	2133	98234472000	16716	8492	2	0	\N
129921	2134	98248753000	16716	8492	3	0	\N
129922	1397	1342710405000	16717	8492	0	0	\N
129923	2133	98234472000	16717	8492	2	0	\N
129924	2134	98248753000	16717	8492	3	0	\N
129928	1397	1342710405000	16719	8492	0	0	\N
129929	2133	98234472000	16719	8492	2	0	\N
129930	2134	98248753000	16719	8492	3	0	\N
129938	632	85813954000000	16721	8355	0	0	\N
129939	484	82098806000000	16721	8355	1	0	\N
129940	484	75725786000000	16721	8355	2	0	\N
129941	484	71425766000000	16721	8355	3	0	\N
129942	484	67868746000000	16721	8355	4	0	\N
129943	632	77969934000000	16721	8355	5	0	\N
129944	632	72677914000000	16721	8355	6	0	\N
129945	632	68300894000000	16721	8355	7	0	\N
129946	1397	1344700604000	16721	8355	8	0	\N
129947	1397	1344690603000	16721	8355	9	0	\N
129948	1860	43896955400000	16721	8355	10	0	\N
129949	1726	132595109000	16721	8355	11	0	\N
129950	1726	131385109000	16721	8355	12	0	\N
129951	1726	130175109000	16721	8355	13	0	\N
129952	1692	13459946719999	16721	8355	14	0	\N
129953	1597	2160034000000	16721	8355	15	0	\N
129954	1397	1344680602000	16721	8355	16	0	\N
129955	1397	1344670601000	16721	8355	17	0	\N
129956	1397	1344660600000	16721	8355	18	0	\N
129957	1397	1344650599000	16721	8355	19	0	\N
129958	1397	1344640598000	16721	8355	20	0	\N
129959	1397	1344630597000	16721	8355	21	0	\N
129960	1397	1344620596000	16721	8355	22	0	\N
129961	1397	1344610595000	16721	8355	23	0	\N
129962	1397	1344600594000	16721	8355	24	0	\N
129963	1397	1344590593000	16721	8355	25	0	\N
129964	1397	1344580592000	16721	8355	26	0	\N
129965	1397	1344570591000	16721	8355	27	0	\N
129966	1397	1344560590000	16721	8355	28	0	\N
129967	1397	1344550589000	16721	8355	29	0	\N
129968	1397	1344540588000	16721	8355	30	0	\N
129969	1397	1344530587000	16721	8355	31	0	\N
129970	1397	1344520586000	16721	8355	32	0	\N
129971	1397	1344510585000	16721	8355	33	0	\N
129972	1397	1344500584000	16721	8355	34	0	\N
129973	1397	1344490583000	16721	8355	35	0	\N
129974	1397	1344480582000	16721	8355	36	0	\N
129975	1397	1344470581000	16721	8355	37	0	\N
129976	1397	1344460580000	16721	8355	38	0	\N
129977	1397	1344450579000	16721	8355	39	0	\N
129978	1397	1344440578000	16721	8355	40	0	\N
129979	1397	1344430577000	16721	8355	41	0	\N
129980	1397	1344420576000	16721	8355	42	0	\N
129981	1397	1344410575000	16721	8355	43	0	\N
129982	1397	1344400574000	16721	8355	44	0	\N
129983	1397	1344390573000	16721	8355	45	0	\N
129984	1397	1344380572000	16721	8355	46	0	\N
129985	1397	1344370571000	16721	8355	47	0	\N
129986	1397	1344360570000	16721	8355	48	0	\N
129987	1397	1344350569000	16721	8355	49	0	\N
129988	1397	1344340568000	16721	8355	50	0	\N
129989	1397	1344330567000	16721	8355	51	0	\N
129990	1397	1344320566000	16721	8355	52	0	\N
129991	1397	1344310565000	16721	8355	53	0	\N
129992	1397	1344300564000	16721	8355	54	0	\N
129993	1397	1344290563000	16721	8355	55	0	\N
129994	1397	1344280562000	16721	8355	57	0	\N
129995	1397	1344270561000	16721	8355	58	0	\N
129996	1397	1344260560000	16721	8355	59	0	\N
129997	1397	1344250559000	16721	8355	60	0	\N
129998	1397	1344240558000	16721	8355	61	0	\N
129999	1397	1344230557000	16721	8355	62	0	\N
130000	1397	1344220556000	16721	8355	63	0	\N
130001	1397	1344210555000	16721	8355	64	0	\N
130002	1397	1344200554000	16721	8355	65	0	\N
130003	1397	1344190553000	16721	8355	66	0	\N
130004	1397	1344180552000	16721	8355	67	0	\N
130005	1397	1344170551000	16721	8355	68	0	\N
130006	1397	1344160550000	16721	8355	69	0	\N
130007	1397	1344150549000	16721	8355	70	0	\N
130008	1397	1344140548000	16721	8355	71	0	\N
130009	1397	1344130547000	16721	8355	72	0	\N
130010	1397	1344120546000	16721	8355	73	0	\N
130011	1397	1344110545000	16721	8355	74	0	\N
130012	1397	1344100544000	16721	8355	75	0	\N
130013	1397	1344090543000	16721	8355	76	0	\N
130014	1397	1344080542000	16721	8355	77	0	\N
130015	1397	1344070541000	16721	8355	78	0	\N
130016	1397	1344060540000	16721	8355	79	0	\N
129898	1397	1342730407000	16710	8490	2	0	9610
129899	2133	98238480000	16710	8490	3	0	760
129900	2133	98237478000	16710	8490	4	0	761
129901	2132	148788789000	16710	8490	5	0	211
129902	2133	98236476000	16710	8490	6	0	762
129904	2134	98251762000	16710	8490	8	0	746
129905	2134	98250759000	16710	8490	9	0	747
129906	1397	1342720406000	16711	8491	0	0	9611
129907	2134	98249756000	16711	8491	1	0	748
129908	2133	98235474000	16711	8491	2	0	763
129926	2133	98234472000	16718	8492	2	0	764
129927	2134	98248753000	16718	8492	3	0	749
129931	1397	1342700404000	16720	8493	0	0	9613
129932	1397	1342690403000	16720	8493	1	0	9614
129934	2134	98246747000	16720	8493	3	0	751
129935	2133	98233470000	16720	8493	4	0	765
129936	2133	98232468000	16720	8493	5	0	766
129937	2132	148787788000	16720	8493	6	0	212
130017	1397	1344050539000	16721	8355	80	0	\N
130018	1397	1344040538000	16721	8355	81	0	\N
130019	1397	1344030537000	16721	8355	82	0	\N
130020	1397	1344020536000	16721	8355	83	0	\N
130021	1397	1344010535000	16721	8355	84	0	\N
130022	1397	1344000534000	16721	8355	85	0	\N
130023	1397	1343990533000	16721	8355	86	0	\N
130024	1397	1343980532000	16721	8355	87	0	\N
130025	1397	1343970531000	16721	8355	88	0	\N
130026	1397	1343960530000	16721	8355	89	0	\N
130027	1397	1343950529000	16721	8355	90	0	\N
130028	1397	1343940528000	16721	8355	91	0	\N
130029	1397	1343930527000	16721	8355	92	0	\N
130030	1397	1343920526000	16721	8355	93	0	\N
130031	1397	1343910525000	16721	8355	94	0	\N
130032	1597	2159014000000	16721	8355	95	0	\N
130033	1597	2159004000000	16721	8355	96	0	\N
130034	1397	1343900524000	16721	8355	97	0	\N
130035	1397	1343890523000	16721	8355	98	0	\N
130036	1397	1343880522000	16721	8355	99	0	\N
130037	1397	1343870521000	16721	8355	100	0	\N
130038	1397	1343860520000	16721	8355	101	0	\N
130039	1397	1343850519000	16721	8355	102	0	\N
130040	1397	1343840518000	16721	8355	103	0	\N
130041	1397	1343830517000	16721	8355	104	0	\N
130042	1397	1343820516000	16721	8355	105	0	\N
130043	1397	1343810515000	16721	8355	106	0	\N
130044	1397	1343800514000	16721	8355	107	0	\N
130045	1397	1343790513000	16721	8355	108	0	\N
130046	1397	1343780512000	16721	8355	109	0	\N
130047	1397	1343770511000	16721	8355	110	0	\N
130048	1397	1343760510000	16721	8355	111	0	\N
130049	1397	1343750509000	16721	8355	112	0	\N
130050	1397	1343740508000	16721	8355	113	0	\N
130051	1397	1343730507000	16721	8355	114	0	\N
130052	1397	1343720506000	16721	8355	115	0	\N
130053	1397	1343710505000	16721	8355	116	0	\N
130054	1397	1343700504000	16721	8355	117	0	\N
130055	1397	1343690503000	16721	8355	118	0	\N
130056	1397	1343680502000	16721	8355	119	0	\N
130057	1397	1343670501000	16721	8355	120	0	\N
130058	1397	1343660500000	16721	8355	121	0	\N
130059	1397	1343650499000	16721	8355	122	0	\N
130060	1397	1343640498000	16721	8355	123	0	\N
130061	1397	1343630497000	16721	8355	124	0	\N
130062	1397	1343620496000	16721	8355	125	0	\N
130063	1397	1342800414000	16722	8486	0	0	\N
130064	1397	1342790413000	16722	8486	1	0	\N
130065	1397	1342780412000	16722	8486	2	0	\N
130066	1397	1342770411000	16722	8486	3	0	\N
130067	1397	1342760410000	16722	8486	4	0	\N
130068	1397	1342750409000	16722	8486	5	0	\N
130069	1397	1342740408000	16722	8486	6	0	\N
130070	1397	1342730407000	16722	8486	7	0	\N
130071	1397	1342720406000	16722	8486	8	0	\N
130072	1397	1342710405000	16722	8486	9	0	\N
130073	1397	1342700404000	16722	8486	10	0	\N
130074	1397	1342690403000	16722	8486	11	0	\N
130075	1397	1342680402000	16722	8486	12	0	\N
130076	2134	98257780000	16722	8486	13	0	\N
130077	2133	98243490000	16722	8486	14	0	\N
130078	2133	98242488000	16722	8486	15	0	\N
130079	2134	98256777000	16722	8486	16	0	\N
130080	2134	98255774000	16722	8486	17	0	\N
130081	2134	98254771000	16722	8486	18	0	\N
130082	2133	98241486000	16722	8486	19	0	\N
130083	2133	98240484000	16722	8486	20	0	\N
130084	2134	98253768000	16722	8486	21	0	\N
130085	2132	148790791000	16722	8486	22	0	\N
130086	2132	148789790000	16722	8486	23	0	\N
130087	2132	148788789000	16722	8486	24	0	\N
130088	2132	148787788000	16722	8486	25	0	\N
130089	2134	98252765000	16722	8486	26	0	\N
130090	2134	98251762000	16722	8486	27	0	\N
130091	2134	98250759000	16722	8486	28	0	\N
130092	2134	98249756000	16722	8486	29	0	\N
130093	2134	98248753000	16722	8486	30	0	\N
130094	2134	98247750000	16722	8486	31	0	\N
130095	2134	98246747000	16722	8486	32	0	\N
130096	2134	98245744000	16722	8486	33	0	\N
130097	2133	98239482000	16722	8486	34	0	\N
130098	2133	98238480000	16722	8486	35	0	\N
130099	2133	98237478000	16722	8486	36	0	\N
130100	2133	98236476000	16722	8486	37	0	\N
130101	2133	98235474000	16722	8486	38	0	\N
130102	2133	98234472000	16722	8486	39	0	\N
130103	2133	98233470000	16722	8486	40	0	\N
130104	2133	98232468000	16722	8486	41	0	\N
130105	2133	98231466000	16722	8486	42	0	\N
130106	1397	1342680402000	16723	8494	0	0	\N
130107	1397	1342670401000	16723	8494	1	0	\N
130108	2133	98231466000	16723	8494	2	0	\N
130109	2133	98230464000	16723	8494	3	0	\N
130110	2132	148786787000	16723	8494	4	0	\N
130111	2134	98245744000	16723	8494	5	0	\N
130112	2134	98244741000	16723	8494	6	0	\N
130120	1397	1342660400000	16725	8495	0	0	\N
130121	1397	1342650399000	16725	8495	1	0	\N
130122	2133	98229462000	16725	8495	2	0	\N
130123	2134	98243738000	16725	8495	3	0	\N
130124	2134	98242735000	16725	8495	4	0	\N
130130	1397	1342660400000	16727	8495	0	0	\N
130131	1397	1342650399000	16727	8495	1	0	\N
130132	2133	98229462000	16727	8495	2	0	\N
130133	2134	98243738000	16727	8495	3	0	\N
130134	2134	98242735000	16727	8495	4	0	\N
130138	1397	1342630397000	16730	8497	0	0	\N
130139	2132	148785786000	16730	8497	1	0	\N
130142	1397	1342620396000	16732	8498	0	0	\N
130143	2133	98227458000	16732	8498	1	0	\N
130144	2134	98240729000	16732	8498	2	0	\N
130148	1397	1342610395000	16734	8499	0	0	\N
130149	2133	98226456000	16734	8499	1	0	\N
130150	2134	98239726000	16734	8499	2	0	\N
130151	1769	1691900000	16734	8499	3	0	\N
130115	2133	98231466000	16724	8494	2	0	767
130116	2133	98230464000	16724	8494	3	0	768
130117	2132	148786787000	16724	8494	4	0	213
130118	2134	98245744000	16724	8494	5	0	752
130119	2134	98244741000	16724	8494	6	0	753
130126	1397	1342650399000	16726	8495	1	0	9618
130127	2133	98229462000	16726	8495	2	0	769
130128	2134	98243738000	16726	8495	3	0	754
130129	2134	98242735000	16726	8495	4	0	755
130135	1397	1342640398000	16728	8496	0	0	9619
130137	2133	98228460000	16728	8496	2	0	770
130140	1397	1342630397000	16731	8497	0	0	9620
130141	2132	148785786000	16731	8497	1	0	214
130145	1397	1342620396000	16733	8498	0	0	9621
130147	2134	98240729000	16733	8498	2	0	757
130152	1397	1342610395000	16735	8499	0	0	9622
130156	1397	1342600394000	16736	8500	0	0	\N
130157	1654	15407148999798	16736	8500	1	0	\N
130158	2133	98225454000	16736	8500	2	0	\N
130159	2134	98238723000	16736	8500	3	0	\N
130160	2132	148784785000	16736	8500	4	0	\N
130161	1397	1342600394000	16737	8500	0	0	\N
130162	1654	15407148999798	16737	8500	1	0	\N
130163	2133	98225454000	16737	8500	2	0	\N
130164	2134	98238723000	16737	8500	3	0	\N
130165	2132	148784785000	16737	8500	4	0	\N
130171	1397	1342600394000	16739	8500	0	0	\N
130172	1654	15407148999798	16739	8500	1	0	\N
130173	2133	98225454000	16739	8500	2	0	\N
130174	2134	98238723000	16739	8500	3	0	\N
130175	2132	148784785000	16739	8500	4	0	\N
130176	1654	15406138999798	16740	8501	0	0	\N
130177	1397	1342590393000	16740	8501	1	0	\N
130178	1397	1342580392000	16740	8501	2	0	\N
130179	1769	1690900000	16740	8501	3	0	\N
130180	2133	98224452000	16740	8501	4	0	\N
130181	2133	98223450000	16740	8501	5	0	\N
130182	2134	98237720000	16740	8501	6	0	\N
130183	2134	98236717000	16740	8501	7	0	\N
130184	1654	15406138999798	16741	8501	0	0	\N
130185	1397	1342590393000	16741	8501	1	0	\N
130186	1397	1342580392000	16741	8501	2	0	\N
130187	1769	1690900000	16741	8501	3	0	\N
130188	2133	98224452000	16741	8501	4	0	\N
130189	2133	98223450000	16741	8501	5	0	\N
130190	2134	98237720000	16741	8501	6	0	\N
130191	2134	98236717000	16741	8501	7	0	\N
130200	495	66719920000000	16743	8215	0	0	\N
130201	369	97346510000000	16743	8215	1	0	\N
130202	369	92607910000000	16743	8215	2	0	\N
130203	369	89410610000000	16743	8215	3	0	\N
130204	369	80501410000000	16743	8215	4	0	\N
130205	495	66709820000000	16743	8215	5	0	\N
130206	495	66709720000000	16743	8215	6	0	\N
130207	632	85813954000000	16743	8215	7	0	\N
130208	484	82098806000000	16743	8215	8	0	\N
130209	484	75725786000000	16743	8215	9	0	\N
130210	484	71425766000000	16743	8215	10	0	\N
130211	484	67868746000000	16743	8215	11	0	\N
130212	632	77969934000000	16743	8215	12	0	\N
130213	632	72677914000000	16743	8215	13	0	\N
130214	632	68300894000000	16743	8215	14	0	\N
130215	1726	138645109000	16743	8215	15	0	\N
130216	1726	137435109000	16743	8215	16	0	\N
130217	1397	1346540788000	16743	8215	17	0	\N
130218	1397	1346530787000	16743	8215	18	0	\N
130219	1397	1346520786000	16743	8215	19	0	\N
130220	1860	43896955400000	16743	8215	20	0	\N
130221	1654	14687123999798	16743	8215	21	0	\N
130222	1654	14686113999798	16743	8215	22	0	\N
130223	1397	1346510785000	16743	8215	23	0	\N
130224	1397	1346500784000	16743	8215	24	0	\N
130225	1397	1346490783000	16743	8215	25	0	\N
130226	1397	1346480782000	16743	8215	26	0	\N
130227	1397	1346470781000	16743	8215	27	0	\N
130228	1397	1346460780000	16743	8215	28	0	\N
130229	1397	1346450779000	16743	8215	29	0	\N
130230	1692	13459946719999	16743	8215	30	0	\N
130231	1726	136225109000	16743	8215	31	0	\N
130232	1726	135015109000	16743	8215	32	0	\N
130233	1726	133805109000	16743	8215	33	0	\N
130234	1726	132595109000	16743	8215	34	0	\N
130235	1726	131385109000	16743	8215	35	0	\N
130236	1726	130175109000	16743	8215	36	0	\N
130237	1597	1440010000000	16743	8215	37	0	\N
130238	1397	1346440778000	16743	8215	38	0	\N
130239	1397	1346430777000	16743	8215	39	0	\N
130240	1397	1346420776000	16743	8215	40	0	\N
130241	1397	1346410775000	16743	8215	41	0	\N
130242	1397	1346400774000	16743	8215	42	0	\N
130243	1397	1346390773000	16743	8215	43	0	\N
130244	1397	1346380772000	16743	8215	44	0	\N
130245	1397	1346370771000	16743	8215	45	0	\N
130246	1397	1346360770000	16743	8215	46	0	\N
130247	1397	1346350769000	16743	8215	47	0	\N
130248	1397	1346340768000	16743	8215	48	0	\N
130249	1397	1346330767000	16743	8215	49	0	\N
130250	1397	1346320766000	16743	8215	50	0	\N
130251	1397	1346310765000	16743	8215	51	0	\N
130252	1397	1346300764000	16743	8215	52	0	\N
130253	1397	1346290763000	16743	8215	53	0	\N
130254	1397	1346280762000	16743	8215	54	0	\N
130255	1397	1346270761000	16743	8215	55	0	\N
130256	1397	1346260760000	16743	8215	56	0	\N
130257	1397	1346250759000	16743	8215	57	0	\N
130258	1397	1346240758000	16743	8215	58	0	\N
130259	1397	1346230757000	16743	8215	59	0	\N
130260	1397	1346220756000	16743	8215	60	0	\N
130261	1397	1346210755000	16743	8215	61	0	\N
130262	1397	1346200754000	16743	8215	62	0	\N
130263	1397	1346190753000	16743	8215	63	0	\N
130264	1397	1346180752000	16743	8215	64	0	\N
130265	1397	1346170751000	16743	8215	65	0	\N
130266	1397	1346160750000	16743	8215	66	0	\N
130267	1397	1346150749000	16743	8215	67	0	\N
130268	1397	1346140748000	16743	8215	69	0	\N
130269	1397	1346130747000	16743	8215	70	0	\N
130270	1397	1346120746000	16743	8215	71	0	\N
130271	1397	1346110745000	16743	8215	72	0	\N
130272	1397	1346100744000	16743	8215	73	0	\N
130273	1397	1346090743000	16743	8215	74	0	\N
130274	1397	1346080742000	16743	8215	75	0	\N
130275	1397	1346070741000	16743	8215	76	0	\N
130276	1397	1346060740000	16743	8215	77	0	\N
130277	1397	1346050739000	16743	8215	78	0	\N
130278	1397	1346040738000	16743	8215	79	0	\N
130279	1397	1346030737000	16743	8215	80	0	\N
130280	1397	1346020736000	16743	8215	81	0	\N
130281	1397	1346010735000	16743	8215	82	0	\N
130282	1397	1346000734000	16743	8215	83	0	\N
130283	1397	1345990733000	16743	8215	84	0	\N
130284	1397	1345980732000	16743	8215	85	0	\N
130285	1397	1345970731000	16743	8215	86	0	\N
130286	1397	1345960730000	16743	8215	87	0	\N
130287	1397	1345950729000	16743	8215	88	0	\N
130288	1397	1345940728000	16743	8215	89	0	\N
130155	1769	1691900000	16735	8499	3	0	42
130166	1397	1342600394000	16738	8500	0	0	9623
130167	1654	15407148999798	16738	8500	1	0	5
130168	2133	98225454000	16738	8500	2	0	773
130169	2134	98238723000	16738	8500	3	0	759
130192	1654	15406138999798	16742	8501	0	0	6
130193	1397	1342590393000	16742	8501	1	0	9624
130194	1397	1342580392000	16742	8501	2	0	9625
130195	1769	1690900000	16742	8501	3	0	43
130196	2133	98224452000	16742	8501	4	0	774
130198	2134	98237720000	16742	8501	6	0	760
130199	2134	98236717000	16742	8501	7	0	761
130289	1397	1345930727000	16743	8215	90	0	\N
130290	1397	1345920726000	16743	8215	91	0	\N
130291	1397	1345910725000	16743	8215	92	0	\N
130292	1397	1345900724000	16743	8215	93	0	\N
130293	1397	1345890723000	16743	8215	94	0	\N
130294	1397	1345880722000	16743	8215	95	0	\N
130295	1397	1345870721000	16743	8215	96	0	\N
130296	1397	1345860720000	16743	8215	97	0	\N
130297	1397	1345850719000	16743	8215	98	0	\N
130298	1397	1345840718000	16743	8215	99	0	\N
130299	1397	1345830717000	16743	8215	100	0	\N
130300	1397	1345820716000	16743	8215	101	0	\N
130301	1397	1345810715000	16743	8215	102	0	\N
130302	1397	1345800714000	16743	8215	103	0	\N
130303	1397	1345790713000	16743	8215	104	0	\N
130304	1397	1345780712000	16743	8215	105	0	\N
130305	1397	1345770711000	16743	8215	106	0	\N
130306	1397	1345760710000	16743	8215	107	0	\N
130307	1397	1345750709000	16743	8215	108	0	\N
130308	1397	1345740708000	16743	8215	109	0	\N
130309	1397	1345730707000	16743	8215	110	0	\N
130310	1397	1345720706000	16743	8215	111	0	\N
130311	1397	1345710705000	16743	8215	112	0	\N
130312	1397	1345700704000	16743	8215	113	0	\N
130313	1397	1345690703000	16743	8215	114	0	\N
130314	1397	1345680702000	16743	8215	115	0	\N
130315	1397	1345670701000	16743	8215	116	0	\N
130316	1397	1345660700000	16743	8215	117	0	\N
130317	1397	1345650699000	16743	8215	118	0	\N
130318	1397	1345640698000	16743	8215	119	0	\N
130319	1397	1345630697000	16743	8215	120	0	\N
130320	1397	1345620696000	16743	8215	121	0	\N
130321	1597	1438990000000	16743	8215	122	0	\N
130322	1597	1438980000000	16743	8215	123	0	\N
130323	1397	1345610695000	16743	8215	124	0	\N
130324	1397	1345600694000	16743	8215	125	0	\N
130325	1654	14687123999798	16744	8404	0	0	\N
130326	1397	1342570391000	16745	8502	0	0	\N
130327	1397	1342560390000	16745	8502	1	0	\N
130328	1397	1342550389000	16745	8502	2	0	\N
130329	2134	98235714000	16745	8502	3	0	\N
130330	2134	98234711000	16745	8502	4	0	\N
130331	2132	148783784000	16745	8502	5	0	\N
130332	2134	98233708000	16745	8502	6	0	\N
130333	2133	98222448000	16745	8502	7	0	\N
130334	2133	98221446000	16745	8502	8	0	\N
130335	2133	98220444000	16745	8502	9	0	\N
130336	1397	1342570391000	16746	8502	0	0	\N
130337	1397	1342560390000	16746	8502	1	0	\N
130338	1397	1342550389000	16746	8502	2	0	\N
130339	2134	98235714000	16746	8502	3	0	\N
130340	2134	98234711000	16746	8502	4	0	\N
130341	2132	148783784000	16746	8502	5	0	\N
130342	2134	98233708000	16746	8502	6	0	\N
130343	2133	98222448000	16746	8502	7	0	\N
130344	2133	98221446000	16746	8502	8	0	\N
130345	2133	98220444000	16746	8502	9	0	\N
130346	1397	1342570391000	16747	8502	0	0	\N
130347	1397	1342560390000	16747	8502	1	0	\N
130348	1397	1342550389000	16747	8502	2	0	\N
130349	2134	98235714000	16747	8502	3	0	\N
130350	2134	98234711000	16747	8502	4	0	\N
130351	2132	148783784000	16747	8502	5	0	\N
130352	2134	98233708000	16747	8502	6	0	\N
130353	2133	98222448000	16747	8502	7	0	\N
130354	2133	98221446000	16747	8502	8	0	\N
130355	2133	98220444000	16747	8502	9	0	\N
130366	1397	1342540388000	16749	8503	0	0	\N
130367	1654	15405128999798	16749	8503	1	0	\N
130368	2134	98232705000	16749	8503	2	0	\N
130369	2133	98219442000	16749	8503	3	0	\N
130370	1397	1342540388000	16750	8503	0	0	\N
130371	1654	15405128999798	16750	8503	1	0	\N
130372	2134	98232705000	16750	8503	2	0	\N
130373	2133	98219442000	16750	8503	3	0	\N
130384	1397	1342520386000	16754	8505	0	0	\N
130385	2134	98230699000	16754	8505	1	0	\N
130386	2133	98218440000	16754	8505	2	0	\N
130390	1397	1343240458000	16756	8384	0	0	\N
130391	1397	1343230457000	16756	8384	1	0	\N
130392	1397	1343220456000	16756	8384	2	0	\N
130393	1397	1343210455000	16756	8384	4	0	\N
130394	1397	1343200454000	16756	8384	5	0	\N
130395	1397	1343190453000	16756	8384	6	0	\N
130396	1397	1343180452000	16756	8384	7	0	\N
130397	1397	1343170451000	16756	8384	8	0	\N
130398	1397	1343160450000	16756	8384	9	0	\N
130399	1397	1343150449000	16756	8384	10	0	\N
130400	1397	1343140448000	16756	8384	11	0	\N
130401	1397	1343130447000	16756	8384	12	0	\N
130402	1397	1343120446000	16756	8384	13	0	\N
130403	1397	1343110445000	16756	8384	14	0	\N
130404	1397	1343100444000	16756	8384	15	0	\N
130405	1397	1343090443000	16756	8384	16	0	\N
130406	1397	1343080442000	16756	8384	17	0	\N
130407	1397	1343070441000	16756	8384	18	0	\N
130408	1397	1343060440000	16756	8384	19	0	\N
130409	1397	1343050439000	16756	8384	20	0	\N
130410	1397	1343040438000	16756	8384	21	0	\N
130411	1397	1343030437000	16756	8384	22	0	\N
130412	1397	1343020436000	16756	8384	23	0	\N
130413	1654	14687123999798	16756	8384	24	0	\N
130414	1654	14686113999798	16756	8384	25	0	\N
130415	1654	14685103999798	16756	8384	26	0	\N
130416	1397	1343010435000	16756	8384	27	0	\N
130417	1397	1343000434000	16756	8384	28	0	\N
130418	1397	1342990433000	16756	8384	29	0	\N
130419	1397	1342980432000	16756	8384	30	0	\N
130420	1397	1342970431000	16756	8384	31	0	\N
130421	1397	1342960430000	16756	8384	32	0	\N
130422	1397	1342950429000	16756	8384	33	0	\N
130423	1397	1342940428000	16756	8384	34	0	\N
130424	1397	1342930427000	16756	8384	35	0	\N
130358	1397	1342550389000	16748	8502	2	0	9628
130359	2134	98235714000	16748	8502	3	0	762
130360	2134	98234711000	16748	8502	4	0	763
130361	2132	148783784000	16748	8502	5	0	216
130362	2134	98233708000	16748	8502	6	0	764
130364	2133	98221446000	16748	8502	8	0	777
130365	2133	98220444000	16748	8502	9	0	778
130374	1397	1342540388000	16751	8503	0	0	9629
130375	1654	15405128999798	16751	8503	1	0	7
130376	2134	98232705000	16751	8503	2	0	765
130378	1397	1342530387000	16752	8504	0	0	9630
130379	2134	98231702000	16752	8504	1	0	766
130380	2132	148782783000	16752	8504	2	0	217
130381	1397	1342520386000	16753	8505	0	0	9631
130383	2133	98218440000	16753	8505	2	0	780
130387	1397	1342510385000	16755	8506	0	0	9632
130388	2133	98217438000	16755	8506	1	0	781
130389	2134	98229696000	16755	8506	2	0	768
130425	1397	1342920426000	16756	8384	36	0	\N
130426	1397	1342910425000	16756	8384	37	0	\N
130427	1397	1342900424000	16756	8384	38	0	\N
130428	1397	1342890423000	16756	8384	39	0	\N
130429	1397	1342880422000	16756	8384	40	0	\N
130430	1397	1342870421000	16756	8384	41	0	\N
130431	1397	1342860420000	16756	8384	42	0	\N
130432	1397	1342850419000	16756	8384	43	0	\N
130433	1397	1342840418000	16756	8384	44	0	\N
130434	1397	1342830417000	16756	8384	45	0	\N
130435	1397	1342820416000	16756	8384	46	0	\N
130436	1397	1342810415000	16756	8384	47	0	\N
130437	1397	1342800414000	16756	8384	48	0	\N
130438	1397	1342790413000	16756	8384	49	0	\N
130439	1397	1342780412000	16756	8384	50	0	\N
130440	1397	1342770411000	16756	8384	51	0	\N
130441	1397	1342760410000	16756	8384	52	0	\N
130442	1397	1342750409000	16756	8384	53	0	\N
130443	1397	1342740408000	16756	8384	54	0	\N
130444	1397	1342730407000	16756	8384	55	0	\N
130445	1397	1342720406000	16756	8384	56	0	\N
130446	1397	1342710405000	16756	8384	57	0	\N
130447	1397	1342700404000	16756	8384	58	0	\N
130448	1397	1342690403000	16756	8384	59	0	\N
130449	1397	1342680402000	16756	8384	60	0	\N
130450	1397	1342670401000	16756	8384	61	0	\N
130451	1397	1342660400000	16756	8384	62	0	\N
130452	1397	1342650399000	16756	8384	63	0	\N
130453	1397	1342640398000	16756	8384	64	0	\N
130454	1397	1342630397000	16756	8384	65	0	\N
130455	1397	1342620396000	16756	8384	66	0	\N
130456	1397	1342610395000	16756	8384	67	0	\N
130457	1397	1342600394000	16756	8384	68	0	\N
130458	1397	1342590393000	16756	8384	69	0	\N
130459	1397	1342580392000	16756	8384	70	0	\N
130460	1397	1342570391000	16756	8384	71	0	\N
130461	1397	1342560390000	16756	8384	72	0	\N
130462	1397	1342550389000	16756	8384	73	0	\N
130463	1397	1342540388000	16756	8384	74	0	\N
130464	1397	1342530387000	16756	8384	75	0	\N
130465	1397	1342520386000	16756	8384	76	0	\N
130466	2087	2879070000000	16756	8384	77	0	\N
130467	2133	98391786000	16756	8384	78	0	\N
130468	2132	148836837000	16756	8384	79	0	\N
130469	2133	98390784000	16756	8384	80	0	\N
130470	2132	148835836000	16756	8384	81	0	\N
130471	2132	148834835000	16756	8384	82	0	\N
130472	2132	148833834000	16756	8384	83	0	\N
130473	2132	148832833000	16756	8384	84	0	\N
130474	2132	148831832000	16756	8384	85	0	\N
130475	2134	98408230000	16756	8384	86	0	\N
130476	2134	98407227000	16756	8384	87	0	\N
130477	2134	98406224000	16756	8384	88	0	\N
130478	2086	2159067000000	16756	8384	89	0	\N
130479	2132	148830831000	16756	8384	90	0	\N
130480	2132	148829830000	16756	8384	91	0	\N
130481	2132	148828829000	16756	8384	92	0	\N
130482	2132	148827828000	16756	8384	93	0	\N
130483	1769	1691900000	16756	8384	94	0	\N
130484	1769	1690900000	16756	8384	95	0	\N
130485	2134	98405221000	16756	8384	96	0	\N
130486	2134	98404218000	16756	8384	97	0	\N
130487	2134	98403215000	16756	8384	98	0	\N
130488	2134	98402212000	16756	8384	99	0	\N
130489	2134	98401209000	16756	8384	100	0	\N
130490	2134	98400206000	16756	8384	101	0	\N
130491	2133	98389782000	16756	8384	102	0	\N
130492	2133	98388780000	16756	8384	103	0	\N
130493	2133	98387778000	16756	8384	104	0	\N
130494	2133	98386776000	16756	8384	105	0	\N
130495	2133	98385774000	16756	8384	106	0	\N
130496	2133	98384772000	16756	8384	107	0	\N
130497	2133	98383770000	16756	8384	108	0	\N
130498	2133	98382768000	16756	8384	109	0	\N
130499	2133	98381766000	16756	8384	110	0	\N
130500	2133	98380764000	16756	8384	111	0	\N
130501	2133	98379762000	16756	8384	112	0	\N
130502	2133	98378760000	16756	8384	113	0	\N
130503	2133	98377758000	16756	8384	114	0	\N
130504	2133	98376756000	16756	8384	115	0	\N
130505	2133	98375754000	16756	8384	116	0	\N
130506	2133	98374752000	16756	8384	117	0	\N
130507	2133	98373750000	16756	8384	118	0	\N
130508	2133	98372748000	16756	8384	119	0	\N
130509	2133	98371746000	16756	8384	120	0	\N
130510	2133	98370744000	16756	8384	121	0	\N
130511	2133	98369742000	16756	8384	122	0	\N
130512	2133	98368740000	16756	8384	123	0	\N
130513	2133	98367738000	16756	8384	124	0	\N
130514	2133	98366736000	16756	8384	125	0	\N
130515	2132	148781782000	16757	8507	0	0	\N
130516	2133	98216436000	16757	8507	1	0	\N
130517	2134	98228693000	16757	8507	2	0	\N
130518	2132	148781782000	16758	8507	0	0	\N
130519	2133	98216436000	16758	8507	1	0	\N
130520	2134	98228693000	16758	8507	2	0	\N
130521	2132	148781782000	16759	8507	0	0	\N
130522	2133	98216436000	16759	8507	1	0	\N
130523	2134	98228693000	16759	8507	2	0	\N
130527	1397	1342500384000	16761	8508	0	0	\N
130528	2133	98215434000	16761	8508	1	0	\N
130529	2134	98227690000	16761	8508	2	0	\N
130533	1397	1342500384000	16763	8508	0	0	\N
130534	2133	98215434000	16763	8508	1	0	\N
130535	2134	98227690000	16763	8508	2	0	\N
130541	1397	1342480382000	16766	8510	0	0	\N
130542	2133	98213430000	16766	8510	1	0	\N
130543	1397	1342510385000	16767	8385	0	0	\N
130544	1397	1342500384000	16767	8385	1	0	\N
130545	1397	1342490383000	16767	8385	2	0	\N
130546	1397	1342480382000	16767	8385	4	0	\N
130547	2133	98365734000	16767	8385	5	0	\N
130548	2133	98364732000	16767	8385	6	0	\N
130549	2133	98363730000	16767	8385	7	0	\N
130550	2133	98362728000	16767	8385	8	0	\N
130551	2133	98361726000	16767	8385	9	0	\N
130552	2132	148826827000	16767	8385	10	0	\N
130553	2132	148825826000	16767	8385	11	0	\N
130554	2132	148824825000	16767	8385	12	0	\N
130555	2132	148823824000	16767	8385	13	0	\N
130556	2132	148822823000	16767	8385	14	0	\N
130557	2132	148821822000	16767	8385	15	0	\N
130558	2133	98360724000	16767	8385	16	0	\N
130559	2133	98359722000	16767	8385	17	0	\N
130560	2133	98358720000	16767	8385	18	0	\N
130526	2134	98228693000	16760	8507	2	0	769
130530	1397	1342500384000	16762	8508	0	0	9633
130531	2133	98215434000	16762	8508	1	0	783
130532	2134	98227690000	16762	8508	2	0	770
130536	1397	1342490383000	16764	8509	0	0	9634
130538	2133	98214432000	16764	8509	2	0	784
130539	1397	1342480382000	16765	8510	0	0	9635
130540	2133	98213430000	16765	8510	1	0	785
130561	2133	98357718000	16767	8385	19	0	\N
130562	2133	98356716000	16767	8385	20	0	\N
130563	2133	98355714000	16767	8385	21	0	\N
130564	2133	98354712000	16767	8385	22	0	\N
130565	2133	98353710000	16767	8385	23	0	\N
130566	2133	98352708000	16767	8385	24	0	\N
130567	2133	98351706000	16767	8385	25	0	\N
130568	2133	98350704000	16767	8385	26	0	\N
130569	2133	98349702000	16767	8385	27	0	\N
130570	2133	98348700000	16767	8385	28	0	\N
130571	2133	98347698000	16767	8385	29	0	\N
130572	2133	98346696000	16767	8385	30	0	\N
130573	2133	98345694000	16767	8385	31	0	\N
130574	2133	98344692000	16767	8385	32	0	\N
130575	2133	98343690000	16767	8385	33	0	\N
130576	2133	98342688000	16767	8385	34	0	\N
130577	2133	98341686000	16767	8385	35	0	\N
130578	2133	98340684000	16767	8385	36	0	\N
130579	2133	98339682000	16767	8385	37	0	\N
130580	2133	98338680000	16767	8385	38	0	\N
130581	2133	98337678000	16767	8385	39	0	\N
130582	2133	98336676000	16767	8385	40	0	\N
130583	2133	98335674000	16767	8385	41	0	\N
130584	2133	98334672000	16767	8385	42	0	\N
130585	2133	98333670000	16767	8385	43	0	\N
130586	2133	98332668000	16767	8385	44	0	\N
130587	2133	98331666000	16767	8385	45	0	\N
130588	2133	98330664000	16767	8385	46	0	\N
130589	2133	98329662000	16767	8385	47	0	\N
130590	2133	98328660000	16767	8385	48	0	\N
130591	2133	98327658000	16767	8385	49	0	\N
130592	2133	98326656000	16767	8385	50	0	\N
130593	2133	98325654000	16767	8385	51	0	\N
130594	2133	98324652000	16767	8385	52	0	\N
130595	2133	98323650000	16767	8385	53	0	\N
130596	2133	98322648000	16767	8385	54	0	\N
130597	2133	98321646000	16767	8385	55	0	\N
130598	2133	98320644000	16767	8385	56	0	\N
130599	2133	98319642000	16767	8385	57	0	\N
130600	2133	98318640000	16767	8385	58	0	\N
130601	2133	98317638000	16767	8385	59	0	\N
130602	2133	98316636000	16767	8385	60	0	\N
130603	2133	98315634000	16767	8385	61	0	\N
130604	2133	98314632000	16767	8385	62	0	\N
130605	2133	98313630000	16767	8385	63	0	\N
130620	1397	1342450379000	16771	8513	0	0	\N
130621	1397	1342440378000	16771	8513	1	0	\N
130622	2134	98223678000	16771	8513	2	0	\N
130623	2133	98210424000	16771	8513	3	0	\N
130624	2133	98209422000	16771	8513	4	0	\N
130625	2134	98222675000	16771	8513	5	0	\N
130626	2132	148779780000	16771	8513	6	0	\N
130627	484	82098806000000	16772	8410	0	0	\N
130628	484	75725786000000	16772	8410	1	0	\N
130629	484	71425766000000	16772	8410	2	0	\N
130630	484	67868746000000	16772	8410	3	0	\N
130631	1397	1343360470000	16772	8410	4	0	\N
130632	1397	1343350469000	16772	8410	5	0	\N
130633	1397	1343340468000	16772	8410	6	0	\N
130634	1397	1343330467000	16772	8410	7	0	\N
130635	1397	1343320466000	16772	8410	8	0	\N
130636	1397	1343310465000	16772	8410	9	0	\N
130637	1397	1343300464000	16772	8410	10	0	\N
130638	1397	1343290463000	16772	8410	11	0	\N
130639	1654	14687123999798	16772	8410	12	0	\N
130640	1654	14686113999798	16772	8410	13	0	\N
130641	1654	14685103999798	16772	8410	14	0	\N
130642	1397	1343280462000	16772	8410	15	0	\N
130643	1397	1343270461000	16772	8410	16	0	\N
130644	1397	1343260460000	16772	8410	17	0	\N
130645	1397	1343250459000	16772	8410	18	0	\N
130646	1397	1343240458000	16772	8410	19	0	\N
130647	1397	1343230457000	16772	8410	20	0	\N
130648	1397	1343220456000	16772	8410	21	0	\N
130649	1397	1343210455000	16772	8410	22	0	\N
130650	1397	1343200454000	16772	8410	23	0	\N
130651	1397	1343190453000	16772	8410	24	0	\N
130652	1397	1343180452000	16772	8410	25	0	\N
130653	1397	1343170451000	16772	8410	26	0	\N
130654	1397	1343160450000	16772	8410	27	0	\N
130655	1397	1343150449000	16772	8410	28	0	\N
130656	1397	1343140448000	16772	8410	29	0	\N
130657	1397	1343130447000	16772	8410	30	0	\N
130658	1397	1343120446000	16772	8410	31	0	\N
130659	1397	1343110445000	16772	8410	32	0	\N
130660	1397	1343100444000	16772	8410	33	0	\N
130661	1397	1343090443000	16772	8410	34	0	\N
130662	1397	1343080442000	16772	8410	35	0	\N
130663	1397	1343070441000	16772	8410	36	0	\N
130664	1397	1343060440000	16772	8410	37	0	\N
130665	1397	1343050439000	16772	8410	38	0	\N
130666	1397	1343040438000	16772	8410	39	0	\N
130667	1397	1343030437000	16772	8410	40	0	\N
130668	1397	1343020436000	16772	8410	41	0	\N
130669	1397	1343010435000	16772	8410	42	0	\N
130670	1397	1343000434000	16772	8410	43	0	\N
130671	1397	1342990433000	16772	8410	44	0	\N
130672	1397	1342980432000	16772	8410	45	0	\N
130673	1397	1342970431000	16772	8410	46	0	\N
130674	1397	1342960430000	16772	8410	47	0	\N
130675	1397	1342950429000	16772	8410	48	0	\N
130676	1397	1342940428000	16772	8410	49	0	\N
130677	1397	1342930427000	16772	8410	50	0	\N
130678	1397	1342920426000	16772	8410	51	0	\N
130679	1397	1342910425000	16772	8410	52	0	\N
130680	1397	1342900424000	16772	8410	53	0	\N
130681	1397	1342890423000	16772	8410	54	0	\N
130682	1397	1342880422000	16772	8410	55	0	\N
130683	1397	1342870421000	16772	8410	56	0	\N
130684	1397	1342860420000	16772	8410	57	0	\N
130685	1397	1342850419000	16772	8410	58	0	\N
130686	1397	1342840418000	16772	8410	59	0	\N
130687	1397	1342830417000	16772	8410	60	0	\N
130688	1397	1342820416000	16772	8410	61	0	\N
130689	1397	1342810415000	16772	8410	62	0	\N
130690	1397	1342800414000	16772	8410	63	0	\N
130691	1397	1342790413000	16772	8410	64	0	\N
130692	1397	1342780412000	16772	8410	65	0	\N
130693	1397	1342770411000	16772	8410	66	0	\N
130694	1397	1342760410000	16772	8410	67	0	\N
130695	1397	1342750409000	16772	8410	68	0	\N
130696	1397	1342740408000	16772	8410	69	0	\N
130608	2132	148780781000	16768	8511	2	0	219
130609	2134	98225684000	16768	8511	3	0	772
130610	1397	1342460380000	16769	8512	0	0	9637
130611	2133	98211426000	16769	8512	1	0	787
130612	2134	98224681000	16769	8512	2	0	773
130614	1397	1342440378000	16770	8513	1	0	9639
130615	2134	98223678000	16770	8513	2	0	774
130616	2133	98210424000	16770	8513	3	0	788
130617	2133	98209422000	16770	8513	4	0	789
130618	2134	98222675000	16770	8513	5	0	775
130697	1397	1342730407000	16772	8410	70	0	\N
130698	1397	1342720406000	16772	8410	71	0	\N
130699	1397	1342710405000	16772	8410	72	0	\N
130700	1397	1342700404000	16772	8410	73	0	\N
130701	1397	1342690403000	16772	8410	74	0	\N
130702	1397	1342680402000	16772	8410	75	0	\N
130703	1397	1342670401000	16772	8410	76	0	\N
130704	1397	1342660400000	16772	8410	77	0	\N
130705	1397	1342650399000	16772	8410	78	0	\N
130706	1397	1342640398000	16772	8410	79	0	\N
130707	1397	1342630397000	16772	8410	80	0	\N
130708	1397	1342620396000	16772	8410	81	0	\N
130709	1397	1342610395000	16772	8410	82	0	\N
130710	1397	1342600394000	16772	8410	83	0	\N
130711	1397	1342590393000	16772	8410	84	0	\N
130712	1397	1342580392000	16772	8410	85	0	\N
130713	1397	1342570391000	16772	8410	86	0	\N
130714	1397	1342560390000	16772	8410	87	0	\N
130715	1397	1342550389000	16772	8410	88	0	\N
130716	1397	1342540388000	16772	8410	89	0	\N
130717	1397	1342530387000	16772	8410	90	0	\N
130718	1397	1342520386000	16772	8410	91	0	\N
130719	1397	1342510385000	16772	8410	92	0	\N
130720	1397	1342500384000	16772	8410	93	0	\N
130721	1397	1342490383000	16772	8410	94	0	\N
130722	1397	1342480382000	16772	8410	95	0	\N
130723	1397	1342470381000	16772	8410	96	0	\N
130724	1397	1342460380000	16772	8410	97	0	\N
130725	1397	1342450379000	16772	8410	98	0	\N
130726	1397	1342440378000	16772	8410	99	0	\N
130727	2087	2879070000000	16772	8410	100	0	\N
130728	2132	148807808000	16772	8410	101	0	\N
130729	2132	148806807000	16772	8410	102	0	\N
130730	2133	98296596000	16772	8410	103	0	\N
130731	2133	98295594000	16772	8410	104	0	\N
130732	2133	98294592000	16772	8410	105	0	\N
130733	2134	98311942000	16772	8410	106	0	\N
130734	2132	148805806000	16772	8410	107	0	\N
130735	2132	148804805000	16772	8410	108	0	\N
130736	2132	148803804000	16772	8410	109	0	\N
130737	2132	148802803000	16772	8410	110	0	\N
130738	2132	148801802000	16772	8410	111	0	\N
130739	2132	148800801000	16772	8410	112	0	\N
130740	2132	148799800000	16772	8410	113	0	\N
130741	2132	148798799000	16772	8410	114	0	\N
130742	2132	148797798000	16772	8410	115	0	\N
130743	2132	148796797000	16772	8410	116	0	\N
130744	2132	148795796000	16772	8410	117	0	\N
130745	2133	98293590000	16772	8410	118	0	\N
130746	2133	98292588000	16772	8410	119	0	\N
130747	2133	98291586000	16772	8410	120	0	\N
130748	2133	98290584000	16772	8410	121	0	\N
130749	2133	98289582000	16772	8410	122	0	\N
130750	2133	98288580000	16772	8410	123	0	\N
130751	2134	98310939000	16772	8410	124	0	\N
130752	2134	98309936000	16772	8410	125	0	\N
130753	1397	1342430377000	16773	8514	0	0	\N
130754	1397	1342420376000	16773	8514	1	0	\N
130755	1397	1342410375000	16773	8514	2	0	\N
130756	1397	1342400374000	16773	8514	3	0	\N
130757	2134	98221672000	16773	8514	4	0	\N
130758	2134	98220669000	16773	8514	5	0	\N
130759	2133	98208420000	16773	8514	6	0	\N
130760	2133	98207418000	16773	8514	7	0	\N
130761	2133	98206416000	16773	8514	8	0	\N
130762	2133	98205414000	16773	8514	9	0	\N
130763	2132	148778779000	16773	8514	10	0	\N
130764	2134	98219666000	16773	8514	11	0	\N
130765	2134	98218663000	16773	8514	12	0	\N
130782	1397	1342390373000	16776	8515	0	0	\N
130783	2133	98204412000	16776	8515	1	0	\N
130784	2134	98217660000	16776	8515	2	0	\N
130795	1397	1342360370000	16779	8517	0	0	\N
130796	2133	98201406000	16779	8517	1	0	\N
130797	2134	98214651000	16779	8517	2	0	\N
130801	1397	1342340368000	16781	8519	0	0	\N
130802	1397	1342330367000	16781	8519	1	0	\N
130803	2133	98199402000	16781	8519	2	0	\N
130804	2132	148776777000	16781	8519	3	0	\N
130805	2134	98212645000	16781	8519	4	0	\N
130806	2134	98211642000	16781	8519	5	0	\N
130807	2133	98198400000	16781	8519	6	0	\N
130808	1397	1342340368000	16782	8519	0	0	\N
130809	1397	1342330367000	16782	8519	1	0	\N
130810	2133	98199402000	16782	8519	2	0	\N
130811	2132	148776777000	16782	8519	3	0	\N
130812	2134	98212645000	16782	8519	4	0	\N
130813	2134	98211642000	16782	8519	5	0	\N
130814	2133	98198400000	16782	8519	6	0	\N
130822	1397	1342760410000	16784	8429	0	0	\N
130823	1397	1342750409000	16784	8429	1	0	\N
130824	1397	1342740408000	16784	8429	2	0	\N
130825	1397	1342730407000	16784	8429	3	0	\N
130826	1397	1342720406000	16784	8429	4	0	\N
130827	1397	1342710405000	16784	8429	5	0	\N
130828	1654	14687123999798	16784	8429	6	0	\N
130829	1654	14686113999798	16784	8429	7	0	\N
130830	1654	14685103999798	16784	8429	8	0	\N
130831	1397	1342700404000	16784	8429	9	0	\N
130832	1397	1342690403000	16784	8429	10	0	\N
130768	1397	1342410375000	16774	8514	2	0	9642
130769	1397	1342400374000	16774	8514	3	0	9643
130770	2134	98221672000	16774	8514	4	0	776
130771	2134	98220669000	16774	8514	5	0	777
130772	2133	98208420000	16774	8514	6	0	790
130774	2133	98206416000	16774	8514	8	0	792
130775	2133	98205414000	16774	8514	9	0	793
130776	2132	148778779000	16774	8514	10	0	221
130777	2134	98219666000	16774	8514	11	0	778
130778	2134	98218663000	16774	8514	12	0	779
130780	2133	98204412000	16775	8515	1	0	794
130781	2134	98217660000	16775	8515	2	0	780
130785	1397	1342380372000	16777	8516	0	0	9645
130786	1397	1342370371000	16777	8516	1	0	9646
130788	2134	98216657000	16777	8516	3	0	781
130789	2134	98215654000	16777	8516	4	0	782
130790	2133	98203410000	16777	8516	5	0	795
130791	2133	98202408000	16777	8516	6	0	796
130792	1397	1342360370000	16778	8517	0	0	9647
130794	2134	98214651000	16778	8517	2	0	783
130798	1397	1342350369000	16780	8518	0	0	9648
130799	2133	98200404000	16780	8518	1	0	798
130800	2134	98213648000	16780	8518	2	0	784
130815	1397	1342340368000	16783	8519	0	0	9649
130817	2133	98199402000	16783	8519	2	0	799
130818	2132	148776777000	16783	8519	3	0	223
130819	2134	98212645000	16783	8519	4	0	785
130820	2134	98211642000	16783	8519	5	0	786
130833	1397	1342680402000	16784	8429	11	0	\N
130834	1397	1342670401000	16784	8429	12	0	\N
130835	1397	1342660400000	16784	8429	13	0	\N
130836	1397	1342650399000	16784	8429	14	0	\N
130837	1397	1342640398000	16784	8429	15	0	\N
130838	1397	1342630397000	16784	8429	16	0	\N
130839	1397	1342620396000	16784	8429	17	0	\N
130840	1397	1342610395000	16784	8429	20	0	\N
130841	1397	1342600394000	16784	8429	21	0	\N
130842	1397	1342590393000	16784	8429	22	0	\N
130843	1397	1342580392000	16784	8429	23	0	\N
130844	1397	1342570391000	16784	8429	24	0	\N
130845	1397	1342560390000	16784	8429	25	0	\N
130846	1397	1342550389000	16784	8429	26	0	\N
130847	1397	1342540388000	16784	8429	27	0	\N
130848	1397	1342530387000	16784	8429	28	0	\N
130849	1397	1342520386000	16784	8429	29	0	\N
130850	1397	1342510385000	16784	8429	30	0	\N
130851	1397	1342500384000	16784	8429	31	0	\N
130852	1397	1342490383000	16784	8429	32	0	\N
130853	1397	1342480382000	16784	8429	33	0	\N
130854	1397	1342470381000	16784	8429	34	0	\N
130855	1397	1342460380000	16784	8429	35	0	\N
130856	1397	1342450379000	16784	8429	36	0	\N
130857	1397	1342440378000	16784	8429	37	0	\N
130858	1397	1342430377000	16784	8429	38	0	\N
130859	1397	1342420376000	16784	8429	39	0	\N
130860	1397	1342410375000	16784	8429	40	0	\N
130861	1397	1342400374000	16784	8429	41	0	\N
130862	1397	1342390373000	16784	8429	42	0	\N
130863	1397	1342380372000	16784	8429	43	0	\N
130864	1397	1342370371000	16784	8429	44	0	\N
130865	1397	1342360370000	16784	8429	45	0	\N
130866	1397	1342350369000	16784	8429	46	0	\N
130867	1397	1342340368000	16784	8429	47	0	\N
130868	1397	1342330367000	16784	8429	48	0	\N
130869	2132	148788789000	16784	8429	49	0	\N
130870	2133	98288580000	16784	8429	50	0	\N
130871	2132	148787788000	16784	8429	51	0	\N
130872	2132	148786787000	16784	8429	52	0	\N
130873	2132	148785786000	16784	8429	53	0	\N
130874	1769	1691900000	16784	8429	54	0	\N
130875	1769	1690900000	16784	8429	55	0	\N
130876	2133	98287578000	16784	8429	56	0	\N
130877	2133	98286576000	16784	8429	57	0	\N
130878	2132	148784785000	16784	8429	58	0	\N
130879	2132	148783784000	16784	8429	59	0	\N
130880	2132	148782783000	16784	8429	60	0	\N
130881	2132	148781782000	16784	8429	61	0	\N
130882	2132	148780781000	16784	8429	62	0	\N
130883	2132	148779780000	16784	8429	63	0	\N
130884	2132	148778779000	16784	8429	64	0	\N
130885	2132	148777778000	16784	8429	65	0	\N
130886	1397	1342320366000	16785	8520	0	0	\N
130887	2134	98210639000	16785	8520	1	0	\N
130888	2133	98197398000	16785	8520	2	0	\N
130889	632	85813954000000	16786	8235	0	0	\N
130890	484	82098806000000	16786	8235	1	0	\N
130891	484	75725786000000	16786	8235	2	0	\N
130892	484	71425766000000	16786	8235	3	0	\N
130893	484	67868746000000	16786	8235	4	0	\N
130894	632	77969934000000	16786	8235	5	0	\N
130895	632	72677914000000	16786	8235	6	0	\N
130896	632	68300894000000	16786	8235	7	0	\N
130897	1654	14687123999798	16786	8235	8	0	\N
130898	1654	14686113999798	16786	8235	9	0	\N
130899	1654	14685103999798	16786	8235	10	0	\N
130900	1597	1440010000000	16786	8235	11	0	\N
130901	1597	1438990000000	16786	8235	12	0	\N
130902	1597	1438980000000	16786	8235	13	0	\N
130903	2087	2879070000000	16786	8235	14	0	\N
130904	2086	2159067000000	16786	8235	15	0	\N
130905	1769	1691900000	16786	8235	16	0	\N
130906	1769	1690900000	16786	8235	17	0	\N
130910	1397	1342320366000	16788	8520	0	0	\N
130911	2134	98210639000	16788	8520	1	0	\N
130912	2133	98197398000	16788	8520	2	0	\N
130913	1397	1342320366000	16789	8520	0	0	\N
130914	2134	98210639000	16789	8520	1	0	\N
130915	2133	98197398000	16789	8520	2	0	\N
130922	1397	1342300364000	16792	8522	0	0	\N
130923	2134	98208633000	16792	8522	1	0	\N
130924	2132	148775776000	16792	8522	2	0	\N
130925	1397	1342290363000	16793	8523	0	0	\N
130926	2133	98195394000	16793	8523	1	0	\N
130927	2134	98207630000	16793	8523	2	0	\N
130935	2156	718800000000	16796	8525	0	0	\N
130936	1397	1342270361000	16796	8525	1	0	\N
130937	1397	1342260360000	16796	8525	2	0	\N
130938	1643	2649064862100	16796	8525	3	0	\N
130939	1643	2219163054300	16796	8525	4	0	\N
130940	1643	1928771205300	16796	8525	5	0	\N
130941	1643	1688423114700	16796	8525	6	0	\N
130942	2133	98193390000	16796	8525	7	0	\N
130943	2132	148774775000	16796	8525	8	0	\N
130944	2134	98205624000	16796	8525	9	0	\N
130945	2134	98204621000	16796	8525	10	0	\N
130946	2156	718800000000	16797	8525	0	0	\N
130947	1397	1342270361000	16797	8525	1	0	\N
130948	1397	1342260360000	16797	8525	2	0	\N
130949	1643	2649064862100	16797	8525	3	0	\N
130950	1643	2219163054300	16797	8525	4	0	\N
130951	1643	1928771205300	16797	8525	5	0	\N
130952	1643	1688423114700	16797	8525	6	0	\N
130953	2133	98193390000	16797	8525	7	0	\N
130954	2132	148774775000	16797	8525	8	0	\N
130955	2134	98205624000	16797	8525	9	0	\N
130956	2134	98204621000	16797	8525	10	0	\N
130909	2133	98197398000	16787	8520	2	0	801
130916	1397	1342310365000	16790	8521	0	0	9652
130917	2133	98196396000	16790	8521	1	0	802
130918	2134	98209636000	16790	8521	2	0	788
130919	1397	1342300364000	16791	8522	0	0	9653
130921	2132	148775776000	16791	8522	2	0	224
130928	1397	1342290363000	16794	8523	0	0	9654
130929	2133	98195394000	16794	8523	1	0	803
130930	2134	98207630000	16794	8523	2	0	790
130931	414	66000011000000	16795	8524	0	0	1
130933	2133	98194392000	16795	8524	2	0	804
130934	2134	98206627000	16795	8524	3	0	791
130957	2156	718800000000	16798	8525	0	0	1
130958	1397	1342270361000	16798	8525	1	0	9656
130960	1643	2649064862100	16798	8525	3	0	14
130961	1643	2219163054300	16798	8525	4	0	15
130962	1643	1928771205300	16798	8525	5	0	16
130963	1643	1688423114700	16798	8525	6	0	17
130964	2133	98193390000	16798	8525	7	0	805
130966	2134	98205624000	16798	8525	9	0	792
130967	2134	98204621000	16798	8525	10	0	793
130968	1397	1342250359000	16799	8526	0	0	9658
130971	1397	1342240358000	16800	8527	0	0	\N
130972	2133	98191386000	16800	8527	1	0	\N
130973	2134	98202615000	16800	8527	2	0	\N
130974	2132	148773774000	16800	8527	3	0	\N
130982	1397	1342230357000	16803	8528	0	0	\N
130983	2134	98201612000	16803	8528	1	0	\N
130984	2133	98190384000	16803	8528	2	0	\N
130985	1397	1342220356000	16804	8529	0	0	\N
130986	2133	98189382000	16804	8529	1	0	\N
130987	2134	98200609000	16804	8529	2	0	\N
130991	1397	1342210355000	16806	8530	0	0	\N
130992	2134	98199606000	16806	8530	1	0	\N
130998	414	66000011000000	16810	8337	0	0	\N
130999	1654	14687123999798	16810	8337	1	0	\N
131000	1654	14686113999798	16810	8337	2	0	\N
131001	1654	14685103999798	16810	8337	3	0	\N
131002	1643	488991862100	16810	8337	4	0	\N
131003	1643	59090054300	16810	8337	5	0	\N
131004	1769	1691900000	16810	8337	6	0	\N
131005	1769	1690900000	16810	8337	7	0	\N
131006	1397	1342190353000	16812	8533	0	0	\N
131007	1397	1342180352000	16812	8533	1	0	\N
131008	1397	1342170351000	16812	8533	2	0	\N
131009	2132	148771772000	16812	8533	3	0	\N
131010	2133	98187378000	16812	8533	4	0	\N
131011	2133	98186376000	16812	8533	5	0	\N
131012	2133	98185374000	16812	8533	6	0	\N
131013	2134	98198603000	16812	8533	7	0	\N
131014	2134	98197600000	16812	8533	8	0	\N
131015	2134	98196597000	16812	8533	9	0	\N
131016	2134	98195594000	16812	8533	10	0	\N
131028	1397	1342190353000	16814	8533	0	0	\N
131029	1397	1342180352000	16814	8533	1	0	\N
131030	1397	1342170351000	16814	8533	2	0	\N
131031	2132	148771772000	16814	8533	3	0	\N
131032	2133	98187378000	16814	8533	4	0	\N
131033	2133	98186376000	16814	8533	5	0	\N
131034	2133	98185374000	16814	8533	6	0	\N
131035	2134	98198603000	16814	8533	7	0	\N
131036	2134	98197600000	16814	8533	8	0	\N
131037	2134	98196597000	16814	8533	9	0	\N
131038	2134	98195594000	16814	8533	10	0	\N
131039	1397	1342160350000	16815	8534	0	0	\N
131040	2134	98194591000	16815	8534	1	0	\N
131052	1397	1342130347000	16820	8537	0	0	\N
131053	2134	98191582000	16820	8537	1	0	\N
131054	1397	1342120346000	16821	8538	0	0	\N
131055	2134	98190579000	16821	8538	1	0	\N
131056	2133	98182368000	16821	8538	2	0	\N
131060	1397	1342110345000	16823	8539	0	0	\N
131061	2133	98181366000	16823	8539	1	0	\N
131064	1397	1342110345000	16825	8539	0	0	\N
131065	2133	98181366000	16825	8539	1	0	\N
131070	1397	1342090343000	16827	8541	0	0	\N
131071	2134	98187570000	16827	8541	1	0	\N
131072	2133	98180364000	16827	8541	2	0	\N
131076	1397	1342090343000	16829	8541	0	0	\N
131077	2134	98187570000	16829	8541	1	0	\N
131078	2133	98180364000	16829	8541	2	0	\N
131082	1397	1342080342000	16831	8542	0	0	\N
131083	2133	98179362000	16831	8542	1	0	\N
131084	2134	98186567000	16831	8542	2	0	\N
131085	1397	1342080342000	16832	8542	0	0	\N
131086	2133	98179362000	16832	8542	1	0	\N
131087	2134	98186567000	16832	8542	2	0	\N
131088	2144	100000000	16833	8259	0	0	\N
131089	495	66719920000000	16833	8259	1	0	\N
131090	369	97346510000000	16833	8259	2	0	\N
131091	414	66000011000000	16833	8259	3	0	\N
131092	369	92607910000000	16833	8259	4	0	\N
131093	369	89410610000000	16833	8259	5	0	\N
131094	369	80501410000000	16833	8259	6	0	\N
131095	495	66709820000000	16833	8259	7	0	\N
131096	495	66709720000000	16833	8259	8	0	\N
131097	632	85813954000000	16833	8259	9	0	\N
131098	484	82098806000000	16833	8259	10	0	\N
131099	484	75725786000000	16833	8259	11	0	\N
131100	484	71425766000000	16833	8259	12	0	\N
131101	484	67868746000000	16833	8259	13	0	\N
131102	632	77969934000000	16833	8259	14	0	\N
131103	632	72677914000000	16833	8259	15	0	\N
131104	632	68300894000000	16833	8259	16	0	\N
130975	1397	1342240358000	16801	8527	0	0	9659
130976	2133	98191386000	16801	8527	1	0	807
130977	2134	98202615000	16801	8527	2	0	795
130978	2132	148773774000	16801	8527	3	0	226
130979	1397	1342230357000	16802	8528	0	0	9660
130981	2133	98190384000	16802	8528	2	0	808
130988	1397	1342220356000	16805	8529	0	0	9661
130989	2133	98189382000	16805	8529	1	0	809
130990	2134	98200609000	16805	8529	2	0	797
130993	1397	1342210355000	16807	8530	0	0	9662
130995	1397	1342200354000	16808	8531	0	0	9663
130996	2133	98188380000	16808	8531	1	0	810
130997	2132	148772773000	16808	8531	2	0	227
131017	1397	1342190353000	16813	8533	0	0	9664
131019	1397	1342170351000	16813	8533	2	0	9666
131020	2132	148771772000	16813	8533	3	0	228
131021	2133	98187378000	16813	8533	4	0	811
131022	2133	98186376000	16813	8533	5	0	812
131023	2133	98185374000	16813	8533	6	0	813
131025	2134	98197600000	16813	8533	8	0	800
131026	2134	98196597000	16813	8533	9	0	801
131027	2134	98195594000	16813	8533	10	0	802
131041	1397	1342160350000	16816	8534	0	0	9667
131042	2134	98194591000	16816	8534	1	0	803
131044	2133	98184372000	16817	8535	1	0	814
131045	1397	1342140348000	16818	8536	0	0	9669
131046	2132	148770771000	16818	8536	1	0	229
131047	2133	98183370000	16818	8536	2	0	815
131049	2134	98192585000	16818	8536	4	0	805
131050	1397	1342130347000	16819	8537	0	0	9670
131051	2134	98191582000	16819	8537	1	0	806
131057	1397	1342120346000	16822	8538	0	0	9671
131058	2134	98190579000	16822	8538	1	0	807
131062	1397	1342110345000	16824	8539	0	0	9672
131063	2133	98181366000	16824	8539	1	0	817
131066	1397	1342100344000	16826	8540	0	0	9673
131067	2134	98189576000	16826	8540	1	0	808
131068	2132	148769770000	16826	8540	2	0	230
131073	1397	1342090343000	16828	8541	0	0	9674
131074	2134	98187570000	16828	8541	1	0	810
131075	2133	98180364000	16828	8541	2	0	818
131079	1397	1342080342000	16830	8542	0	0	9675
131081	2134	98186567000	16830	8542	2	0	811
131105	1726	133805109000	16833	8259	17	0	\N
131106	1860	43896955400000	16833	8259	18	0	\N
131107	1654	14687123999798	16833	8259	19	0	\N
131108	1654	14686113999798	16833	8259	20	0	\N
131109	1654	14685103999798	16833	8259	21	0	\N
131110	1726	132595109000	16833	8259	22	0	\N
131111	1726	131385109000	16833	8259	23	0	\N
131112	1726	130175109000	16833	8259	24	0	\N
131113	1692	13459946719999	16833	8259	25	0	\N
131114	1597	1440010000000	16833	8259	26	0	\N
131115	1597	1438990000000	16833	8259	27	0	\N
131116	1597	1438980000000	16833	8259	28	0	\N
131117	1643	488991862100	16833	8259	29	0	\N
131118	1643	59090054300	16833	8259	30	0	\N
131119	2087	2879070000000	16833	8259	31	0	\N
131120	563	66000617000000	16833	8259	32	0	\N
131121	2086	2159067000000	16833	8259	33	0	\N
131122	1769	1700900000	16833	8259	34	0	\N
131123	1769	1699900000	16833	8259	35	0	\N
131124	1769	1698900000	16833	8259	36	0	\N
131125	1769	1697900000	16833	8259	37	0	\N
131126	1769	1696900000	16833	8259	38	0	\N
131127	1769	1695900000	16833	8259	39	0	\N
131128	1769	1694900000	16833	8259	40	0	\N
131129	1769	1693900000	16833	8259	41	0	\N
131130	1769	1692900000	16833	8259	42	0	\N
131131	1769	1691900000	16833	8259	43	0	\N
131132	1769	1690900000	16833	8259	44	0	\N
131137	1397	1342070341000	16835	8543	0	0	\N
131138	2133	98178360000	16835	8543	1	0	\N
131139	2134	98185564000	16835	8543	2	0	\N
131140	2132	148768769000	16835	8543	3	0	\N
131141	414	66000011000000	16836	8413	0	0	\N
131142	632	85813954000000	16836	8413	1	0	\N
131143	484	82098806000000	16836	8413	2	0	\N
131144	484	75725786000000	16836	8413	3	0	\N
131145	484	71425766000000	16836	8413	4	0	\N
131146	484	67868746000000	16836	8413	5	0	\N
131147	632	77969934000000	16836	8413	6	0	\N
131148	632	72677914000000	16836	8413	7	0	\N
131149	632	68300894000000	16836	8413	8	0	\N
131150	1654	14687123999798	16836	8413	9	0	\N
131151	1654	14686113999798	16836	8413	10	0	\N
131152	1654	14685103999798	16836	8413	11	0	\N
131153	1597	2160034000000	16836	8413	12	0	\N
131154	1397	1343840518000	16836	8413	13	0	\N
131155	1397	1343830517000	16836	8413	14	0	\N
131156	1397	1343820516000	16836	8413	15	0	\N
131157	1397	1343810515000	16836	8413	16	0	\N
131158	1397	1343800514000	16836	8413	17	0	\N
131159	1397	1343790513000	16836	8413	18	0	\N
131160	1397	1343780512000	16836	8413	19	0	\N
131161	1397	1343770511000	16836	8413	20	0	\N
131162	1397	1343760510000	16836	8413	21	0	\N
131163	1397	1343750509000	16836	8413	22	0	\N
131164	1397	1343740508000	16836	8413	23	0	\N
131165	1397	1343730507000	16836	8413	24	0	\N
131166	1397	1343720506000	16836	8413	25	0	\N
131167	1397	1343710505000	16836	8413	27	0	\N
131168	1397	1343700504000	16836	8413	28	0	\N
131169	1397	1343690503000	16836	8413	29	0	\N
131170	1397	1343680502000	16836	8413	30	0	\N
131171	1397	1343670501000	16836	8413	31	0	\N
131172	1397	1343660500000	16836	8413	32	0	\N
131173	1397	1343650499000	16836	8413	33	0	\N
131174	1597	2159014000000	16836	8413	34	0	\N
131175	1597	2159004000000	16836	8413	35	0	\N
131176	1397	1343640498000	16836	8413	36	0	\N
131177	1397	1343630497000	16836	8413	37	0	\N
131178	1397	1343620496000	16836	8413	38	0	\N
131179	1397	1343610495000	16836	8413	39	0	\N
131180	1397	1343600494000	16836	8413	40	0	\N
131181	1397	1343590493000	16836	8413	41	0	\N
131182	1397	1343580492000	16836	8413	42	0	\N
131183	1397	1343570491000	16836	8413	43	0	\N
131184	1397	1343560490000	16836	8413	44	0	\N
131185	1397	1343550489000	16836	8413	45	0	\N
131186	1397	1343540488000	16836	8413	46	0	\N
131187	1397	1343530487000	16836	8413	47	0	\N
131188	1397	1343520486000	16836	8413	48	0	\N
131189	1397	1343510485000	16836	8413	49	0	\N
131190	1397	1343500484000	16836	8413	50	0	\N
131191	1397	1343490483000	16836	8413	51	0	\N
131192	1397	1343480482000	16836	8413	52	0	\N
131193	1397	1343470481000	16836	8413	53	0	\N
131194	1397	1343460480000	16836	8413	54	0	\N
131195	1397	1343450479000	16836	8413	55	0	\N
131196	1397	1343440478000	16836	8413	56	0	\N
131197	1397	1343430477000	16836	8413	57	0	\N
131198	1397	1343420476000	16836	8413	58	0	\N
131199	1397	1343410475000	16836	8413	59	0	\N
131200	1397	1343400474000	16836	8413	60	0	\N
131201	1397	1343390473000	16836	8413	61	0	\N
131202	1397	1343380472000	16836	8413	62	0	\N
131203	1397	1343370471000	16836	8413	63	0	\N
131204	1397	1343360470000	16836	8413	64	0	\N
131205	1397	1343350469000	16836	8413	65	0	\N
131206	1397	1343340468000	16836	8413	66	0	\N
131207	1397	1343330467000	16836	8413	67	0	\N
131208	1397	1343320466000	16836	8413	68	0	\N
131209	1397	1343310465000	16836	8413	69	0	\N
131212	1397	1342060340000	16838	8544	0	0	\N
131213	2134	98184561000	16838	8544	1	0	\N
131214	1397	1342060340000	16839	8544	0	0	\N
131215	2134	98184561000	16839	8544	1	0	\N
131216	1397	1342050339000	16840	8545	0	0	\N
131217	2133	98177358000	16840	8545	1	0	\N
131218	2134	98183558000	16840	8545	2	0	\N
131219	1397	1342050339000	16841	8545	0	0	\N
131220	2133	98177358000	16841	8545	1	0	\N
131221	2134	98183558000	16841	8545	2	0	\N
131232	1397	1342020336000	16844	8547	0	0	\N
131233	2134	98180549000	16844	8547	1	0	\N
131234	2133	98174352000	16844	8547	2	0	\N
131238	1397	1342010335000	16846	8548	0	0	\N
131239	2133	98173350000	16846	8548	1	0	\N
131240	2134	98179546000	16846	8548	2	0	\N
131135	2134	98185564000	16834	8543	2	0	812
131136	2132	148768769000	16834	8543	3	0	231
131210	1397	1342060340000	16837	8544	0	0	9677
131211	2134	98184561000	16837	8544	1	0	813
131222	1397	1342050339000	16842	8545	0	0	9678
131224	2134	98183558000	16842	8545	2	0	814
131225	1397	1342040338000	16843	8546	0	0	9679
131226	1397	1342030337000	16843	8546	1	0	9680
131227	2134	98182555000	16843	8546	2	0	815
131228	2133	98176356000	16843	8546	3	0	822
131230	2134	98181552000	16843	8546	5	0	816
131231	2133	98175354000	16843	8546	6	0	823
131235	1397	1342020336000	16845	8547	0	0	9681
131236	2134	98180549000	16845	8547	1	0	817
131251	1397	1341980332000	16850	8551	0	0	\N
131252	2134	98176537000	16850	8551	1	0	\N
131253	2133	98170344000	16850	8551	2	0	\N
131254	1397	1341980332000	16851	8551	0	0	\N
131255	2134	98176537000	16851	8551	1	0	\N
131256	2133	98170344000	16851	8551	2	0	\N
131257	1397	1341980332000	16852	8551	0	0	\N
131258	2134	98176537000	16852	8551	1	0	\N
131259	2133	98170344000	16852	8551	2	0	\N
131260	1397	1341980332000	16853	8551	0	0	\N
131261	2134	98176537000	16853	8551	1	0	\N
131262	2133	98170344000	16853	8551	2	0	\N
131266	1397	1342230357000	16855	8528	0	0	\N
131267	1397	1342220356000	16855	8528	1	0	\N
131268	1397	1342210355000	16855	8528	2	0	\N
131269	1397	1342200354000	16855	8528	3	0	\N
131270	1397	1342190353000	16855	8528	4	0	\N
131271	1397	1342180352000	16855	8528	5	0	\N
131272	1397	1342170351000	16855	8528	6	0	\N
131273	1397	1342160350000	16855	8528	7	0	\N
131274	1397	1342150349000	16855	8528	8	0	\N
131275	1397	1342140348000	16855	8528	9	0	\N
131276	1397	1342130347000	16855	8528	10	0	\N
131277	1397	1342120346000	16855	8528	11	0	\N
131278	1397	1342110345000	16855	8528	12	0	\N
131279	1397	1342100344000	16855	8528	13	0	\N
131280	1397	1342090343000	16855	8528	14	0	\N
131281	1397	1342080342000	16855	8528	15	0	\N
131282	1397	1342070341000	16855	8528	16	0	\N
131283	1397	1342060340000	16855	8528	17	0	\N
131284	1397	1342050339000	16855	8528	18	0	\N
131285	1397	1342040338000	16855	8528	20	0	\N
131286	1397	1342030337000	16855	8528	21	0	\N
131287	1397	1342020336000	16855	8528	22	0	\N
131288	1397	1342010335000	16855	8528	23	0	\N
131289	1397	1342000334000	16855	8528	24	0	\N
131290	1397	1341990333000	16855	8528	25	0	\N
131291	1397	1341980332000	16855	8528	26	0	\N
131292	2132	148772773000	16855	8528	27	0	\N
131293	2132	148771772000	16855	8528	28	0	\N
131294	2132	148770771000	16855	8528	29	0	\N
131295	2132	148769770000	16855	8528	30	0	\N
131296	2134	98201612000	16855	8528	31	0	\N
131297	2132	148768769000	16855	8528	32	0	\N
131298	2132	148767768000	16855	8528	33	0	\N
131299	2132	148766767000	16855	8528	34	0	\N
131300	2134	98200609000	16855	8528	35	0	\N
131301	2134	98199606000	16855	8528	36	0	\N
131302	2134	98198603000	16855	8528	37	0	\N
131303	2134	98197600000	16855	8528	38	0	\N
131304	2134	98196597000	16855	8528	39	0	\N
131305	2134	98195594000	16855	8528	40	0	\N
131306	2134	98194591000	16855	8528	41	0	\N
131307	2134	98193588000	16855	8528	42	0	\N
131308	2134	98192585000	16855	8528	43	0	\N
131309	2134	98191582000	16855	8528	44	0	\N
131310	2134	98190579000	16855	8528	45	0	\N
131311	2134	98189576000	16855	8528	46	0	\N
131312	2134	98188573000	16855	8528	47	0	\N
131313	2134	98187570000	16855	8528	48	0	\N
131314	2134	98186567000	16855	8528	49	0	\N
131315	2134	98185564000	16855	8528	50	0	\N
131316	2134	98184561000	16855	8528	51	0	\N
131317	2134	98183558000	16855	8528	52	0	\N
131318	2134	98182555000	16855	8528	53	0	\N
131319	2134	98181552000	16855	8528	54	0	\N
131320	2134	98180549000	16855	8528	55	0	\N
131321	2134	98179546000	16855	8528	56	0	\N
131322	2134	98178543000	16855	8528	57	0	\N
131323	2134	98177540000	16855	8528	58	0	\N
131324	2134	98176537000	16855	8528	59	0	\N
131325	2133	98190384000	16855	8528	60	0	\N
131326	2133	98189382000	16855	8528	61	0	\N
131327	2133	98188380000	16855	8528	62	0	\N
131328	2133	98187378000	16855	8528	63	0	\N
131329	2133	98186376000	16855	8528	64	0	\N
131330	2133	98185374000	16855	8528	65	0	\N
131331	2133	98184372000	16855	8528	66	0	\N
131332	2133	98183370000	16855	8528	67	0	\N
131333	2133	98182368000	16855	8528	68	0	\N
131334	2133	98181366000	16855	8528	69	0	\N
131335	2133	98180364000	16855	8528	70	0	\N
131336	2133	98179362000	16855	8528	71	0	\N
131337	2133	98178360000	16855	8528	72	0	\N
131338	2133	98177358000	16855	8528	73	0	\N
131339	2133	98176356000	16855	8528	74	0	\N
131340	2133	98175354000	16855	8528	75	0	\N
131341	2133	98174352000	16855	8528	76	0	\N
131342	2133	98173350000	16855	8528	77	0	\N
131343	2133	98172348000	16855	8528	78	0	\N
131344	2133	98171346000	16855	8528	79	0	\N
131345	2133	98170344000	16855	8528	80	0	\N
131353	1397	1341950329000	16863	8553	0	0	\N
131354	2133	98167338000	16863	8553	1	0	\N
131355	2134	98173528000	16863	8553	2	0	\N
131359	1397	1341950329000	16865	8553	0	0	\N
131360	2133	98167338000	16865	8553	1	0	\N
131361	2134	98173528000	16865	8553	2	0	\N
131366	414	66000011000000	16868	8427	0	0	\N
131367	1397	1342750409000	16868	8427	1	0	\N
131368	1397	1342740408000	16868	8427	2	0	\N
131369	1397	1342730407000	16868	8427	3	0	\N
131370	1397	1342720406000	16868	8427	4	0	\N
131371	1397	1342710405000	16868	8427	5	0	\N
131372	1654	14687123999798	16868	8427	6	0	\N
131373	1654	14686113999798	16868	8427	7	0	\N
131374	1654	14685103999798	16868	8427	8	0	\N
131375	1397	1342700404000	16868	8427	9	0	\N
131376	1397	1342690403000	16868	8427	10	0	\N
131243	2134	98179546000	16847	8548	2	0	818
131244	1397	1342000334000	16848	8549	0	0	9683
131245	2134	98178543000	16848	8549	1	0	819
131246	2132	148766767000	16848	8549	2	0	233
131247	2133	98172348000	16848	8549	3	0	826
131249	2133	98171346000	16849	8550	1	0	827
131250	2134	98177540000	16849	8550	2	0	820
131263	1397	1341980332000	16854	8551	0	0	9685
131264	2134	98176537000	16854	8551	1	0	821
131265	2133	98170344000	16854	8551	2	0	828
131347	1397	1341960330000	16857	8552	1	0	9687
131348	2133	98169342000	16857	8552	2	0	829
131349	2133	98168340000	16857	8552	3	0	830
131350	2132	148765766000	16857	8552	4	0	234
131352	2134	98174531000	16857	8552	6	0	823
131356	1397	1341950329000	16864	8553	0	0	9688
131357	2133	98167338000	16864	8553	1	0	831
131358	2134	98173528000	16864	8553	2	0	824
131362	1397	1341940328000	16866	8554	0	0	9689
131364	2133	98166336000	16866	8554	2	0	832
131365	2134	98172525000	16866	8554	3	0	825
131377	1397	1342680402000	16868	8427	11	0	\N
131378	1397	1342670401000	16868	8427	12	0	\N
131379	1397	1342660400000	16868	8427	13	0	\N
131380	1397	1342650399000	16868	8427	14	0	\N
131381	1397	1342640398000	16868	8427	15	0	\N
131382	1397	1342630397000	16868	8427	16	0	\N
131383	1397	1342620396000	16868	8427	17	0	\N
131384	1397	1342610395000	16868	8427	18	0	\N
131385	1397	1342600394000	16868	8427	19	0	\N
131386	1397	1342590393000	16868	8427	20	0	\N
131387	1397	1342580392000	16868	8427	21	0	\N
131388	1397	1342570391000	16868	8427	22	0	\N
131389	1397	1342560390000	16868	8427	23	0	\N
131390	1397	1342550389000	16868	8427	24	0	\N
131391	1397	1342540388000	16868	8427	25	0	\N
131392	1397	1342530387000	16868	8427	26	0	\N
131393	1397	1342520386000	16868	8427	27	0	\N
131394	1397	1342510385000	16868	8427	28	0	\N
131395	1397	1342500384000	16868	8427	29	0	\N
131396	1397	1342490383000	16868	8427	30	0	\N
131397	1397	1342480382000	16868	8427	31	0	\N
131398	1397	1342470381000	16868	8427	32	0	\N
131399	1397	1342460380000	16868	8427	33	0	\N
131400	1397	1342450379000	16868	8427	34	0	\N
131401	1397	1342440378000	16868	8427	35	0	\N
131402	1397	1342430377000	16868	8427	36	0	\N
131403	1397	1342420376000	16868	8427	37	0	\N
131404	1397	1342410375000	16868	8427	38	0	\N
131405	1397	1342400374000	16868	8427	39	0	\N
131406	1397	1342390373000	16868	8427	40	0	\N
131407	1397	1342380372000	16868	8427	41	0	\N
131408	1397	1342370371000	16868	8427	42	0	\N
131409	1397	1342360370000	16868	8427	43	0	\N
131410	1397	1342350369000	16868	8427	44	0	\N
131411	1397	1342340368000	16868	8427	45	0	\N
131412	1397	1342330367000	16868	8427	46	0	\N
131413	1397	1342320366000	16868	8427	47	0	\N
131414	1397	1342310365000	16868	8427	48	0	\N
131415	1397	1342300364000	16868	8427	49	0	\N
131416	1397	1342290363000	16868	8427	50	0	\N
131417	1397	1342280362000	16868	8427	51	0	\N
131418	1397	1342270361000	16868	8427	52	0	\N
131419	1397	1342260360000	16868	8427	53	0	\N
131420	1397	1342250359000	16868	8427	54	0	\N
131421	1397	1342240358000	16868	8427	55	0	\N
131422	1397	1342230357000	16868	8427	56	0	\N
131423	1397	1342220356000	16868	8427	57	0	\N
131424	1397	1342210355000	16868	8427	58	0	\N
131425	1397	1342200354000	16868	8427	59	0	\N
131426	1397	1342190353000	16868	8427	60	0	\N
131427	1397	1342180352000	16868	8427	61	0	\N
131428	1397	1342170351000	16868	8427	62	0	\N
131429	1397	1342160350000	16868	8427	64	0	\N
131430	1397	1342150349000	16868	8427	65	0	\N
131431	1397	1342140348000	16868	8427	66	0	\N
131432	1397	1342130347000	16868	8427	67	0	\N
131433	1397	1342120346000	16868	8427	68	0	\N
131434	1397	1342110345000	16868	8427	69	0	\N
131435	1397	1342100344000	16868	8427	70	0	\N
131436	1397	1342090343000	16868	8427	71	0	\N
131437	1397	1342080342000	16868	8427	72	0	\N
131438	1397	1342070341000	16868	8427	73	0	\N
131439	1397	1342060340000	16868	8427	74	0	\N
131440	1397	1342050339000	16868	8427	75	0	\N
131441	1397	1342040338000	16868	8427	76	0	\N
131442	1397	1342030337000	16868	8427	77	0	\N
131443	1397	1342020336000	16868	8427	78	0	\N
131444	1397	1342010335000	16868	8427	79	0	\N
131445	1397	1342000334000	16868	8427	80	0	\N
131446	1397	1341990333000	16868	8427	81	0	\N
131447	1397	1341980332000	16868	8427	82	0	\N
131448	1397	1341970331000	16868	8427	83	0	\N
131449	1397	1341960330000	16868	8427	84	0	\N
131450	1397	1341950329000	16868	8427	85	0	\N
131451	1397	1341940328000	16868	8427	86	0	\N
131452	1397	1341930327000	16868	8427	87	0	\N
131453	1397	1341920326000	16868	8427	88	0	\N
131454	1397	1341910325000	16868	8427	89	0	\N
131455	1397	1341900324000	16868	8427	90	0	\N
131456	1643	1929028862100	16868	8427	91	0	\N
131457	1643	1499127054300	16868	8427	92	0	\N
131458	1643	1208735205300	16868	8427	93	0	\N
131459	1643	968387114700	16868	8427	94	0	\N
131460	2132	148804805000	16868	8427	95	0	\N
131461	2132	148803804000	16868	8427	96	0	\N
131462	2132	148802803000	16868	8427	97	0	\N
131463	2132	148801802000	16868	8427	98	0	\N
131464	2132	148800801000	16868	8427	99	0	\N
131465	2132	148799800000	16868	8427	100	0	\N
131466	2132	148798799000	16868	8427	101	0	\N
131467	2132	148797798000	16868	8427	102	0	\N
131468	2132	148796797000	16868	8427	103	0	\N
131469	2132	148795796000	16868	8427	104	0	\N
131470	2132	148794795000	16868	8427	105	0	\N
131471	2132	148793794000	16868	8427	106	0	\N
131472	2132	148792793000	16868	8427	107	0	\N
131473	2132	148791792000	16868	8427	108	0	\N
131474	2132	148790791000	16868	8427	109	0	\N
131475	2132	148789790000	16868	8427	110	0	\N
131476	2132	148788789000	16868	8427	111	0	\N
131477	2132	148787788000	16868	8427	112	0	\N
131478	2132	148786787000	16868	8427	113	0	\N
131479	2132	148785786000	16868	8427	114	0	\N
131480	1769	1691900000	16868	8427	115	0	\N
131481	1769	1690900000	16868	8427	116	0	\N
131482	2132	148784785000	16868	8427	117	0	\N
131483	2132	148783784000	16868	8427	118	0	\N
131484	2132	148782783000	16868	8427	119	0	\N
131485	2132	148781782000	16868	8427	120	0	\N
131486	2132	148780781000	16868	8427	121	0	\N
131487	2132	148779780000	16868	8427	122	0	\N
131488	2132	148778779000	16868	8427	123	0	\N
131489	2132	148777778000	16868	8427	124	0	\N
131490	2132	148776777000	16868	8427	125	0	\N
131504	1397	1341930327000	16870	8556	0	0	\N
131505	1397	1341920326000	16870	8556	1	0	\N
131506	1397	1341910325000	16870	8556	2	0	\N
131507	1397	1341900324000	16870	8556	3	0	\N
131508	2133	98165334000	16870	8556	4	0	\N
131509	2132	148763764000	16870	8556	5	0	\N
131510	2133	98164332000	16870	8556	6	0	\N
131511	2133	98163330000	16870	8556	7	0	\N
131512	2133	98162328000	16870	8556	8	0	\N
131493	1397	1341910325000	16869	8556	2	0	9692
131494	1397	1341900324000	16869	8556	3	0	9693
131495	2133	98165334000	16869	8556	4	0	833
131496	2132	148763764000	16869	8556	5	0	236
131497	2133	98164332000	16869	8556	6	0	834
131499	2133	98162328000	16869	8556	8	0	836
131500	2134	98171522000	16869	8556	9	0	826
131501	2134	98170519000	16869	8556	10	0	827
131502	2134	98169516000	16869	8556	11	0	828
131503	2134	98168513000	16869	8556	12	0	829
131513	2134	98171522000	16870	8556	9	0	\N
131514	2134	98170519000	16870	8556	10	0	\N
131515	2134	98169516000	16870	8556	11	0	\N
131516	2134	98168513000	16870	8556	12	0	\N
131517	1397	1341930327000	16871	8556	0	0	\N
131518	1397	1341920326000	16871	8556	1	0	\N
131519	1397	1341910325000	16871	8556	2	0	\N
131520	1397	1341900324000	16871	8556	3	0	\N
131521	2133	98165334000	16871	8556	4	0	\N
131522	2132	148763764000	16871	8556	5	0	\N
131523	2133	98164332000	16871	8556	6	0	\N
131524	2133	98163330000	16871	8556	7	0	\N
131525	2133	98162328000	16871	8556	8	0	\N
131526	2134	98171522000	16871	8556	9	0	\N
131527	2134	98170519000	16871	8556	10	0	\N
131528	2134	98169516000	16871	8556	11	0	\N
131529	2134	98168513000	16871	8556	12	0	\N
131532	1397	1341880322000	16873	8558	0	0	\N
131533	2134	98167510000	16873	8558	1	0	\N
131534	2133	98160324000	16873	8558	2	0	\N
131535	2134	98166507000	16873	8558	3	0	\N
131536	1397	1341880322000	16874	8558	0	0	\N
131537	2134	98167510000	16874	8558	1	0	\N
131538	2133	98160324000	16874	8558	2	0	\N
131539	2134	98166507000	16874	8558	3	0	\N
131568	1397	1341800314000	16880	8562	0	0	\N
131569	2134	98158483000	16880	8562	1	0	\N
131570	2133	98152308000	16880	8562	2	0	\N
131574	1397	1341800314000	16882	8562	0	0	\N
131575	2134	98158483000	16882	8562	1	0	\N
131576	2133	98152308000	16882	8562	2	0	\N
131584	414	66000011000000	16885	8487	0	0	\N
131585	1397	1342670401000	16885	8487	1	0	\N
131586	1654	14687123999798	16885	8487	2	0	\N
131587	1654	14686113999798	16885	8487	3	0	\N
131588	1654	14685103999798	16885	8487	4	0	\N
131589	1397	1342660400000	16885	8487	5	0	\N
131590	1397	1342650399000	16885	8487	6	0	\N
131591	1397	1342640398000	16885	8487	7	0	\N
131592	1397	1342630397000	16885	8487	8	0	\N
131593	1397	1342620396000	16885	8487	9	0	\N
131594	1397	1342610395000	16885	8487	10	0	\N
131595	1397	1342600394000	16885	8487	11	0	\N
131596	1397	1342590393000	16885	8487	12	0	\N
131597	1397	1342580392000	16885	8487	13	0	\N
131598	1397	1342570391000	16885	8487	14	0	\N
131599	1397	1342560390000	16885	8487	15	0	\N
131600	1397	1342550389000	16885	8487	16	0	\N
131601	1397	1342540388000	16885	8487	17	0	\N
131602	1397	1342530387000	16885	8487	18	0	\N
131603	1397	1342520386000	16885	8487	19	0	\N
131604	1397	1342510385000	16885	8487	20	0	\N
131605	1397	1342500384000	16885	8487	21	0	\N
131606	1397	1342490383000	16885	8487	22	0	\N
131607	1397	1342480382000	16885	8487	23	0	\N
131608	1397	1342470381000	16885	8487	24	0	\N
131609	1397	1342460380000	16885	8487	25	0	\N
131610	1397	1342450379000	16885	8487	26	0	\N
131611	1397	1342440378000	16885	8487	27	0	\N
131612	1397	1342430377000	16885	8487	28	0	\N
131613	1397	1342420376000	16885	8487	29	0	\N
131614	1397	1342410375000	16885	8487	30	0	\N
131615	1397	1342400374000	16885	8487	31	0	\N
131616	1397	1342390373000	16885	8487	32	0	\N
131617	1397	1342380372000	16885	8487	33	0	\N
131618	1397	1342370371000	16885	8487	34	0	\N
131619	1397	1342360370000	16885	8487	35	0	\N
131620	1397	1342350369000	16885	8487	36	0	\N
131621	1397	1342340368000	16885	8487	37	0	\N
131622	1397	1342330367000	16885	8487	38	0	\N
131623	1397	1342320366000	16885	8487	39	0	\N
131624	1397	1342310365000	16885	8487	40	0	\N
131625	1397	1342300364000	16885	8487	41	0	\N
131626	1397	1342290363000	16885	8487	42	0	\N
131627	1397	1342280362000	16885	8487	43	0	\N
131628	1397	1342270361000	16885	8487	44	0	\N
131629	1397	1342260360000	16885	8487	45	0	\N
131630	1397	1342250359000	16885	8487	46	0	\N
131631	1397	1342240358000	16885	8487	47	0	\N
131632	1397	1342230357000	16885	8487	48	0	\N
131633	1397	1342220356000	16885	8487	49	0	\N
131634	1397	1342210355000	16885	8487	50	0	\N
131635	1397	1342200354000	16885	8487	51	0	\N
131636	1397	1342190353000	16885	8487	52	0	\N
131637	1397	1342180352000	16885	8487	53	0	\N
131638	1397	1342170351000	16885	8487	54	0	\N
131639	1397	1342160350000	16885	8487	55	0	\N
131640	1397	1342150349000	16885	8487	56	0	\N
131641	1397	1342140348000	16885	8487	57	0	\N
131642	1397	1342130347000	16885	8487	58	0	\N
131643	1397	1342120346000	16885	8487	59	0	\N
131644	1397	1342110345000	16885	8487	60	0	\N
131645	1397	1342100344000	16885	8487	61	0	\N
131646	1397	1342090343000	16885	8487	62	0	\N
131647	1397	1342080342000	16885	8487	63	0	\N
131648	1397	1342070341000	16885	8487	64	0	\N
131540	1397	1341880322000	16875	8558	0	0	9695
131541	2134	98167510000	16875	8558	1	0	830
131542	2133	98160324000	16875	8558	2	0	838
131543	2134	98166507000	16875	8558	3	0	831
131544	1397	1341870321000	16876	8559	0	0	9696
131546	1397	1341850319000	16876	8559	2	0	9698
131547	2134	98165504000	16876	8559	3	0	832
131548	2133	98159322000	16876	8559	4	0	839
131549	2133	98158320000	16876	8559	5	0	840
131550	2132	148762763000	16876	8559	6	0	237
131552	2133	98157318000	16876	8559	8	0	841
131553	1397	1341840318000	16877	8560	0	0	9699
131554	2132	148761762000	16877	8560	1	0	238
131555	2134	98163498000	16877	8560	2	0	834
131557	1397	1341830317000	16879	8561	0	0	9700
131558	1397	1341820316000	16879	8561	1	0	9701
131559	1397	1341810315000	16879	8561	2	0	9702
131560	2133	98155314000	16879	8561	3	0	843
131561	2133	98154312000	16879	8561	4	0	844
131563	2134	98161492000	16879	8561	6	0	836
131564	2132	148760761000	16879	8561	7	0	239
131565	2134	98160489000	16879	8561	8	0	837
131566	2133	98153310000	16879	8561	9	0	845
131567	2134	98159486000	16879	8561	10	0	838
131572	2134	98158483000	16881	8562	1	0	839
131573	2133	98152308000	16881	8562	2	0	846
131577	1397	1341790313000	16883	8563	0	0	9704
131578	2133	98151306000	16883	8563	1	0	847
131580	1397	1341780312000	16884	8564	0	0	9705
131581	2132	148759760000	16884	8564	1	0	240
131582	2133	98150304000	16884	8564	2	0	848
131583	2134	98156477000	16884	8564	3	0	841
131649	1397	1342060340000	16885	8487	65	0	\N
131650	1397	1342050339000	16885	8487	66	0	\N
131651	1397	1342040338000	16885	8487	67	0	\N
131652	1397	1342030337000	16885	8487	68	0	\N
131653	1397	1342020336000	16885	8487	69	0	\N
131654	1397	1342010335000	16885	8487	70	0	\N
131655	1397	1342000334000	16885	8487	71	0	\N
131656	1397	1341990333000	16885	8487	72	0	\N
131657	1397	1341980332000	16885	8487	73	0	\N
131658	1397	1341970331000	16885	8487	74	0	\N
131659	1397	1341960330000	16885	8487	75	0	\N
131660	1397	1341950329000	16885	8487	76	0	\N
131661	1397	1341940328000	16885	8487	77	0	\N
131662	1397	1341930327000	16885	8487	78	0	\N
131663	1397	1341920326000	16885	8487	79	0	\N
131664	1397	1341910325000	16885	8487	80	0	\N
131665	1397	1341900324000	16885	8487	81	0	\N
131666	1397	1341890323000	16885	8487	82	0	\N
131667	1397	1341880322000	16885	8487	83	0	\N
131668	1397	1341870321000	16885	8487	84	0	\N
131669	1397	1341860320000	16885	8487	85	0	\N
131670	1397	1341850319000	16885	8487	86	0	\N
131671	1397	1341840318000	16885	8487	87	0	\N
131672	1397	1341830317000	16885	8487	88	0	\N
131673	1397	1341820316000	16885	8487	89	0	\N
131674	1397	1341810315000	16885	8487	90	0	\N
131675	1397	1341800314000	16885	8487	91	0	\N
131676	1397	1341790313000	16885	8487	92	0	\N
131677	1397	1341780312000	16885	8487	93	0	\N
131678	1643	2649064862100	16885	8487	94	0	\N
131679	1643	2219163054300	16885	8487	95	0	\N
131680	1643	1928771205300	16885	8487	96	0	\N
131681	1643	1688423114700	16885	8487	97	0	\N
131682	2133	98230464000	16885	8487	98	0	\N
131683	2133	98229462000	16885	8487	99	0	\N
131684	2134	98244741000	16885	8487	100	0	\N
131685	2134	98243738000	16885	8487	101	0	\N
131686	2134	98242735000	16885	8487	102	0	\N
131687	2134	98241732000	16885	8487	103	0	\N
131688	2133	98228460000	16885	8487	104	0	\N
131689	2133	98227458000	16885	8487	105	0	\N
131690	2133	98226456000	16885	8487	106	0	\N
131691	2133	98225454000	16885	8487	107	0	\N
131692	2134	98240729000	16885	8487	108	0	\N
131693	2134	98239726000	16885	8487	109	0	\N
131694	2134	98238723000	16885	8487	110	0	\N
131695	2132	148786787000	16885	8487	111	0	\N
131696	2132	148785786000	16885	8487	112	0	\N
131697	1769	1691900000	16885	8487	113	0	\N
131698	1769	1690900000	16885	8487	114	0	\N
131699	2132	148784785000	16885	8487	115	0	\N
131700	2132	148783784000	16885	8487	116	0	\N
131701	2132	148782783000	16885	8487	117	0	\N
131702	2132	148781782000	16885	8487	118	0	\N
131703	2132	148780781000	16885	8487	119	0	\N
131704	2132	148779780000	16885	8487	120	0	\N
131705	2132	148778779000	16885	8487	121	0	\N
131706	2132	148777778000	16885	8487	122	0	\N
131707	2132	148776777000	16885	8487	123	0	\N
131708	2132	148775776000	16885	8487	124	0	\N
131709	2132	148774775000	16885	8487	125	0	\N
131713	1397	1341770311000	16887	8565	0	0	\N
131714	2133	98149302000	16887	8565	1	0	\N
131715	2134	98155474000	16887	8565	2	0	\N
131716	1397	1341760310000	16888	8566	0	0	\N
131717	2133	98148300000	16888	8566	1	0	\N
131718	2134	98154471000	16888	8566	2	0	\N
131719	414	66000011000000	16889	8460	0	0	\N
131720	1397	1343220456000	16889	8460	1	0	\N
131721	1397	1343210455000	16889	8460	2	0	\N
131722	1397	1343200454000	16889	8460	3	0	\N
131723	1397	1343190453000	16889	8460	4	0	\N
131724	1397	1343180452000	16889	8460	5	0	\N
131725	1397	1343170451000	16889	8460	6	0	\N
131726	1397	1343160450000	16889	8460	7	0	\N
131727	1397	1343150449000	16889	8460	8	0	\N
131728	1397	1343140448000	16889	8460	9	0	\N
131729	1397	1343130447000	16889	8460	10	0	\N
131730	1397	1343120446000	16889	8460	11	0	\N
131731	1397	1343110445000	16889	8460	12	0	\N
131732	1397	1343100444000	16889	8460	13	0	\N
131733	1397	1343090443000	16889	8460	14	0	\N
131734	1397	1343080442000	16889	8460	15	0	\N
131735	1397	1343070441000	16889	8460	16	0	\N
131736	1397	1343060440000	16889	8460	17	0	\N
131737	1397	1343050439000	16889	8460	18	0	\N
131738	1397	1343040438000	16889	8460	19	0	\N
131739	1397	1343030437000	16889	8460	20	0	\N
131740	1397	1343020436000	16889	8460	21	0	\N
131741	1654	14687123999798	16889	8460	22	0	\N
131742	1654	14686113999798	16889	8460	23	0	\N
131743	1654	14685103999798	16889	8460	24	0	\N
131744	1397	1343010435000	16889	8460	25	0	\N
131745	1397	1343000434000	16889	8460	26	0	\N
131746	1397	1342990433000	16889	8460	27	0	\N
131747	1397	1342980432000	16889	8460	28	0	\N
131748	1397	1342970431000	16889	8460	29	0	\N
131749	1397	1342960430000	16889	8460	30	0	\N
131750	1397	1342950429000	16889	8460	31	0	\N
131751	1397	1342940428000	16889	8460	32	0	\N
131752	1397	1342930427000	16889	8460	33	0	\N
131753	1397	1342920426000	16889	8460	34	0	\N
131754	1397	1342910425000	16889	8460	35	0	\N
131755	1397	1342900424000	16889	8460	36	0	\N
131756	1397	1342890423000	16889	8460	37	0	\N
131757	1397	1342880422000	16889	8460	38	0	\N
131758	1397	1342870421000	16889	8460	39	0	\N
131759	1397	1342860420000	16889	8460	40	0	\N
131760	1397	1342850419000	16889	8460	41	0	\N
131761	1397	1342840418000	16889	8460	42	0	\N
131762	1397	1342830417000	16889	8460	43	0	\N
131763	1397	1342820416000	16889	8460	44	0	\N
131764	1397	1342810415000	16889	8460	45	0	\N
131765	1397	1342800414000	16889	8460	46	0	\N
131766	1397	1342790413000	16889	8460	47	0	\N
131767	1397	1342780412000	16889	8460	48	0	\N
131768	1397	1342770411000	16889	8460	49	0	\N
131769	1397	1342760410000	16889	8460	50	0	\N
131770	1397	1342750409000	16889	8460	51	0	\N
131771	1397	1342740408000	16889	8460	52	0	\N
131772	1397	1342730407000	16889	8460	53	0	\N
131773	1397	1342720406000	16889	8460	54	0	\N
131774	1397	1342710405000	16889	8460	55	0	\N
131775	1397	1342700404000	16889	8460	56	0	\N
131776	1397	1342690403000	16889	8460	57	0	\N
131777	1397	1342680402000	16889	8460	58	0	\N
131778	1397	1342670401000	16889	8460	59	0	\N
131779	1397	1342660400000	16889	8460	60	0	\N
131780	1397	1342650399000	16889	8460	61	0	\N
131781	1397	1342640398000	16889	8460	62	0	\N
131782	1397	1342630397000	16889	8460	63	0	\N
131783	1397	1342620396000	16889	8460	64	0	\N
131784	1397	1342610395000	16889	8460	65	0	\N
131712	2134	98155474000	16886	8565	2	0	842
131785	1397	1342600394000	16889	8460	66	0	\N
131786	1397	1342590393000	16889	8460	67	0	\N
131787	1397	1342580392000	16889	8460	68	0	\N
131788	1397	1342570391000	16889	8460	69	0	\N
131789	1397	1342560390000	16889	8460	70	0	\N
131790	1397	1342550389000	16889	8460	71	0	\N
131791	1397	1342540388000	16889	8460	72	0	\N
131792	1397	1342530387000	16889	8460	73	0	\N
131793	1397	1342520386000	16889	8460	74	0	\N
131794	1397	1342510385000	16889	8460	75	0	\N
131795	1397	1342500384000	16889	8460	76	0	\N
131796	1397	1342490383000	16889	8460	77	0	\N
131797	1397	1342480382000	16889	8460	78	0	\N
131798	1397	1342470381000	16889	8460	79	0	\N
131799	1397	1342460380000	16889	8460	80	0	\N
131800	1397	1342450379000	16889	8460	81	0	\N
131801	1397	1342440378000	16889	8460	82	0	\N
131802	1397	1342430377000	16889	8460	83	0	\N
131803	1397	1342420376000	16889	8460	84	0	\N
131804	1397	1342410375000	16889	8460	85	0	\N
131805	1397	1342400374000	16889	8460	86	0	\N
131806	1397	1342390373000	16889	8460	87	0	\N
131807	1397	1342380372000	16889	8460	88	0	\N
131808	1397	1342370371000	16889	8460	89	0	\N
131809	1397	1342360370000	16889	8460	90	0	\N
131810	1397	1342350369000	16889	8460	91	0	\N
131811	1397	1342340368000	16889	8460	92	0	\N
131812	1397	1342330367000	16889	8460	93	0	\N
131813	1397	1342320366000	16889	8460	94	0	\N
131814	1397	1342310365000	16889	8460	95	0	\N
131815	1397	1342300364000	16889	8460	96	0	\N
131816	1397	1342290363000	16889	8460	97	0	\N
131817	1397	1342280362000	16889	8460	98	0	\N
131818	1397	1342270361000	16889	8460	99	0	\N
131819	1397	1342260360000	16889	8460	100	0	\N
131820	1397	1342250359000	16889	8460	101	0	\N
131821	1397	1342240358000	16889	8460	102	0	\N
131822	1397	1342230357000	16889	8460	104	0	\N
131823	1397	1342220356000	16889	8460	105	0	\N
131824	1397	1342210355000	16889	8460	106	0	\N
131825	1397	1342200354000	16889	8460	107	0	\N
131826	1397	1342190353000	16889	8460	108	0	\N
131827	1397	1342180352000	16889	8460	109	0	\N
131828	1397	1342170351000	16889	8460	110	0	\N
131829	1397	1342160350000	16889	8460	111	0	\N
131830	1397	1342150349000	16889	8460	112	0	\N
131831	1397	1342140348000	16889	8460	113	0	\N
131832	1397	1342130347000	16889	8460	114	0	\N
131833	1397	1342120346000	16889	8460	115	0	\N
131834	1397	1342110345000	16889	8460	116	0	\N
131835	1397	1342100344000	16889	8460	117	0	\N
131836	1397	1342090343000	16889	8460	118	0	\N
131837	1397	1342080342000	16889	8460	119	0	\N
131838	1397	1342070341000	16889	8460	120	0	\N
131839	1397	1342060340000	16889	8460	121	0	\N
131840	1397	1342050339000	16889	8460	122	0	\N
131841	1397	1342040338000	16889	8460	123	0	\N
131842	1397	1342030337000	16889	8460	124	0	\N
131843	1397	1342020336000	16889	8460	125	0	\N
131844	1397	1341760310000	16890	8566	0	0	\N
131845	2133	98148300000	16890	8566	1	0	\N
131846	2134	98154471000	16890	8566	2	0	\N
131857	1397	1341740308000	16894	8568	0	0	\N
131858	2132	148758759000	16894	8568	1	0	\N
131859	2133	98146296000	16894	8568	2	0	\N
131860	2134	98152465000	16894	8568	3	0	\N
131861	1397	1341740308000	16895	8568	0	0	\N
131862	2132	148758759000	16895	8568	1	0	\N
131863	2133	98146296000	16895	8568	2	0	\N
131864	2134	98152465000	16895	8568	3	0	\N
131865	1397	1341730307000	16896	8569	0	0	\N
131866	1397	1341720306000	16896	8569	1	0	\N
131867	238	66000186000000	16896	8569	2	0	\N
131868	2134	98151462000	16896	8569	3	0	\N
131869	2134	98150459000	16896	8569	4	0	\N
131870	2133	98145294000	16896	8569	5	0	\N
131871	2133	98144292000	16896	8569	6	0	\N
131875	238	66000186000000	16898	8548	0	0	\N
131876	238	66000186000000	16899	8557	0	0	\N
131877	1397	1341730307000	16900	8569	0	0	\N
131878	1397	1341720306000	16900	8569	1	0	\N
131879	238	66000186000000	16900	8569	2	0	\N
131880	2134	98151462000	16900	8569	3	0	\N
131881	2134	98150459000	16900	8569	4	0	\N
131882	2133	98145294000	16900	8569	5	0	\N
131883	2133	98144292000	16900	8569	6	0	\N
131884	238	66000186000000	16901	8566	0	0	\N
131895	1397	1341700304000	16904	8571	0	0	\N
131896	2133	98143290000	16904	8571	1	0	\N
131897	2134	98148453000	16904	8571	2	0	\N
131898	1397	1341690303000	16905	8572	0	0	\N
131899	2133	98142288000	16905	8572	1	0	\N
131900	2134	98147450000	16905	8572	2	0	\N
131849	2134	98154471000	16891	8566	2	0	843
131850	1397	1341750309000	16892	8567	0	0	9708
131851	2134	98153468000	16892	8567	1	0	844
131852	2133	98147298000	16892	8567	2	0	851
131853	1397	1341740308000	16893	8568	0	0	9709
131855	2133	98146296000	16893	8568	2	0	852
131856	2134	98152465000	16893	8568	3	0	845
131872	238	66000186000000	16897	8569	0	0	4
131873	2133	98145294000	16897	8569	1	0	853
131874	2133	98144292000	16897	8569	2	0	854
131886	1397	1341720306000	16902	8570	1	0	9711
131887	1397	1341710305000	16902	8570	2	0	9712
131888	2132	148757758000	16902	8570	3	0	242
131889	2134	98151462000	16902	8570	4	0	846
131891	2134	98149456000	16902	8570	6	0	848
131892	1397	1341700304000	16903	8571	0	0	9713
131893	2133	98143290000	16903	8571	1	0	855
131894	2134	98148453000	16903	8571	2	0	849
131901	1397	1341690303000	16906	8572	0	0	9714
131903	2134	98147450000	16906	8572	2	0	850
131904	1397	1341680302000	16907	8573	0	0	9715
131905	1397	1341670301000	16907	8573	1	0	9716
131906	1397	1341660300000	16907	8573	2	0	9717
131907	2134	98146447000	16907	8573	3	0	851
131909	2133	98141286000	16907	8573	5	0	857
131910	2133	98140284000	16907	8573	6	0	858
131911	2133	98139282000	16907	8573	7	0	859
131912	2134	98145444000	16907	8573	8	0	852
131914	1397	1341650299000	16908	8574	0	0	9718
131915	1397	1341640298000	16908	8574	1	0	9719
131916	2132	148755756000	16908	8574	2	0	244
131917	2134	98143438000	16908	8574	3	0	854
131918	2133	98138280000	16908	8574	4	0	860
131920	2134	98142435000	16908	8574	6	0	855
131921	1397	1341650299000	16909	8574	0	0	\N
131922	1397	1341640298000	16909	8574	1	0	\N
131923	2132	148755756000	16909	8574	2	0	\N
131924	2134	98143438000	16909	8574	3	0	\N
131925	2133	98138280000	16909	8574	4	0	\N
131926	2133	98137278000	16909	8574	5	0	\N
131927	2134	98142435000	16909	8574	6	0	\N
131928	1397	1341650299000	16910	8574	0	0	\N
131929	1397	1341640298000	16910	8574	1	0	\N
131930	2132	148755756000	16910	8574	2	0	\N
131931	2134	98143438000	16910	8574	3	0	\N
131932	2133	98138280000	16910	8574	4	0	\N
131933	2133	98137278000	16910	8574	5	0	\N
131934	2134	98142435000	16910	8574	6	0	\N
131935	1397	1341650299000	16911	8574	0	0	\N
131936	1397	1341640298000	16911	8574	1	0	\N
131937	2132	148755756000	16911	8574	2	0	\N
131938	2134	98143438000	16911	8574	3	0	\N
131939	2133	98138280000	16911	8574	4	0	\N
131940	2133	98137278000	16911	8574	5	0	\N
131941	2134	98142435000	16911	8574	6	0	\N
131942	1397	1341650299000	16912	8574	0	0	\N
131943	1397	1341640298000	16912	8574	1	0	\N
131944	2132	148755756000	16912	8574	2	0	\N
131945	2134	98143438000	16912	8574	3	0	\N
131946	2133	98138280000	16912	8574	4	0	\N
131947	2133	98137278000	16912	8574	5	0	\N
131948	2134	98142435000	16912	8574	6	0	\N
131949	1397	1341630297000	16913	8575	0	0	\N
131950	2134	98141432000	16913	8575	1	0	\N
131951	2133	98136276000	16913	8575	2	0	\N
131952	1397	1341630297000	16914	8575	0	0	\N
131953	2134	98141432000	16914	8575	1	0	\N
131954	2133	98136276000	16914	8575	2	0	\N
131955	1397	1341630297000	16915	8575	0	0	\N
131956	2134	98141432000	16915	8575	1	0	\N
131957	2133	98136276000	16915	8575	2	0	\N
131964	1397	1341620296000	16918	8576	0	0	\N
131965	2133	98135274000	16918	8576	1	0	\N
131966	2134	98140429000	16918	8576	2	0	\N
131967	1397	1341610295000	16919	8577	0	0	\N
131968	2133	98134272000	16919	8577	1	0	\N
131969	2134	98139426000	16919	8577	2	0	\N
131970	2132	148754755000	16919	8577	3	0	\N
131971	1397	1341610295000	16920	8577	0	0	\N
131972	2133	98134272000	16920	8577	1	0	\N
131973	2134	98139426000	16920	8577	2	0	\N
131974	2132	148754755000	16920	8577	3	0	\N
131979	1397	1341610295000	16922	8577	0	0	\N
131980	2133	98134272000	16922	8577	1	0	\N
131981	2134	98139426000	16922	8577	2	0	\N
131982	2132	148754755000	16922	8577	3	0	\N
131983	1397	1341610295000	16923	8577	0	0	\N
131984	2133	98134272000	16923	8577	1	0	\N
131985	2134	98139426000	16923	8577	2	0	\N
131986	2132	148754755000	16923	8577	3	0	\N
131987	1397	1341600294000	16924	8578	0	0	\N
131988	1397	1341590293000	16924	8578	1	0	\N
131989	1397	1341580292000	16924	8578	2	0	\N
131990	1397	1341570291000	16924	8578	3	0	\N
131991	2134	98138423000	16924	8578	4	0	\N
131992	2134	98137420000	16924	8578	5	0	\N
131993	2133	98133270000	16924	8578	6	0	\N
131994	2134	98136417000	16924	8578	7	0	\N
131995	2132	148753754000	16924	8578	8	0	\N
131996	2133	98132268000	16924	8578	9	0	\N
131997	2133	98131266000	16924	8578	10	0	\N
131998	2134	98135414000	16924	8578	11	0	\N
132015	1397	1341550289000	16927	8580	0	0	\N
132016	2133	98129262000	16927	8580	1	0	\N
132017	2134	98133408000	16927	8580	2	0	\N
132021	1726	128965109000	16929	8578	0	0	\N
132022	1397	1341600294000	16929	8578	1	0	\N
132023	1397	1341590293000	16929	8578	2	0	\N
132024	1397	1341580292000	16929	8578	3	0	\N
132025	1397	1341570291000	16929	8578	4	0	\N
132026	1397	1341560290000	16929	8578	5	0	\N
132027	1397	1341550289000	16929	8578	6	0	\N
132028	2134	98138423000	16929	8578	7	0	\N
132029	2134	98137420000	16929	8578	8	0	\N
132030	2133	98133270000	16929	8578	9	0	\N
132031	2134	98136417000	16929	8578	10	0	\N
132032	2132	148753754000	16929	8578	11	0	\N
132033	2132	148752753000	16929	8578	12	0	\N
132034	2133	98132268000	16929	8578	13	0	\N
132035	2133	98131266000	16929	8578	14	0	\N
132036	2133	98130264000	16929	8578	15	0	\N
132037	2133	98129262000	16929	8578	16	0	\N
132038	2134	98135414000	16929	8578	17	0	\N
132039	2134	98134411000	16929	8578	18	0	\N
132040	2134	98133408000	16929	8578	19	0	\N
132041	2134	98132405000	16929	8578	20	0	\N
132045	1397	1341540288000	16931	8582	0	0	\N
132046	2134	98131402000	16931	8582	1	0	\N
132047	2133	98127258000	16931	8582	2	0	\N
132054	1397	1341530287000	16934	8583	0	0	\N
132055	2134	98130399000	16934	8583	1	0	\N
132056	2133	98126256000	16934	8583	2	0	\N
131960	2133	98136276000	16916	8575	2	0	862
131961	1397	1341620296000	16917	8576	0	0	9721
131962	2133	98135274000	16917	8576	1	0	863
131963	2134	98140429000	16917	8576	2	0	857
131975	1397	1341610295000	16921	8577	0	0	9722
131977	2134	98139426000	16921	8577	2	0	858
131978	2132	148754755000	16921	8577	3	0	245
131999	1397	1341600294000	16925	8578	0	0	9723
132000	1397	1341590293000	16925	8578	1	0	9724
132001	1397	1341580292000	16925	8578	2	0	9725
132003	2134	98138423000	16925	8578	4	0	859
132004	2134	98137420000	16925	8578	5	0	860
132005	2133	98133270000	16925	8578	6	0	865
132006	2134	98136417000	16925	8578	7	0	861
132008	2133	98132268000	16925	8578	9	0	866
132009	2133	98131266000	16925	8578	10	0	867
132010	2134	98135414000	16925	8578	11	0	862
132011	1397	1341560290000	16926	8579	0	0	9727
132012	1726	128965109000	16926	8579	1	0	8179
132014	2134	98134411000	16926	8579	3	0	863
132018	1397	1341550289000	16928	8580	0	0	9728
132019	2133	98129262000	16928	8580	1	0	869
132020	2134	98133408000	16928	8580	2	0	864
132042	2132	148752753000	16930	8581	0	0	247
132044	2134	98132405000	16930	8581	2	0	865
132048	1397	1341540288000	16932	8582	0	0	9729
132049	2134	98131402000	16932	8582	1	0	866
132050	2133	98127258000	16932	8582	2	0	871
132052	2134	98130399000	16933	8583	1	0	867
132053	2133	98126256000	16933	8583	2	0	872
132066	1397	1341510285000	16937	8585	0	0	\N
132067	1397	1341500284000	16937	8585	1	0	\N
132068	2133	98125254000	16937	8585	2	0	\N
132069	2134	98129396000	16937	8585	3	0	\N
132070	2134	98128393000	16937	8585	4	0	\N
132071	2134	98127390000	16937	8585	5	0	\N
132072	2133	98124252000	16937	8585	6	0	\N
132073	1397	1341510285000	16938	8585	0	0	\N
132074	1397	1341500284000	16938	8585	1	0	\N
132075	2133	98125254000	16938	8585	2	0	\N
132076	2134	98129396000	16938	8585	3	0	\N
132077	2134	98128393000	16938	8585	4	0	\N
132078	2134	98127390000	16938	8585	5	0	\N
132079	2133	98124252000	16938	8585	6	0	\N
132086	1397	1341480282000	16941	8587	0	0	\N
132087	2133	98122248000	16941	8587	1	0	\N
132088	2132	148750751000	16941	8587	2	0	\N
132090	1397	1341470281000	16943	8588	0	0	\N
132093	1397	1341460280000	16945	8589	0	0	\N
132094	2133	98121246000	16945	8589	1	0	\N
132095	1397	1341460280000	16946	8589	0	0	\N
132096	2133	98121246000	16946	8589	1	0	\N
132097	1397	1342010335000	16947	8461	0	0	\N
132098	1397	1342000334000	16947	8461	1	0	\N
132099	1397	1341990333000	16947	8461	2	0	\N
132100	1397	1341980332000	16947	8461	3	0	\N
132101	1397	1341970331000	16947	8461	4	0	\N
132102	1726	128965109000	16947	8461	5	0	\N
132103	1397	1341960330000	16947	8461	6	0	\N
132104	1397	1341950329000	16947	8461	7	0	\N
132105	1397	1341940328000	16947	8461	8	0	\N
132106	1397	1341930327000	16947	8461	9	0	\N
132107	1397	1341920326000	16947	8461	10	0	\N
132108	1397	1341910325000	16947	8461	11	0	\N
132109	1397	1341900324000	16947	8461	12	0	\N
132110	1397	1341890323000	16947	8461	13	0	\N
132111	1397	1341880322000	16947	8461	14	0	\N
132112	1397	1341870321000	16947	8461	15	0	\N
132113	1397	1341860320000	16947	8461	16	0	\N
132114	1397	1341850319000	16947	8461	17	0	\N
132115	1397	1341840318000	16947	8461	18	0	\N
132116	1397	1341830317000	16947	8461	19	0	\N
132117	1397	1341820316000	16947	8461	20	0	\N
132118	1397	1341810315000	16947	8461	21	0	\N
132119	1397	1341800314000	16947	8461	22	0	\N
132120	1397	1341790313000	16947	8461	23	0	\N
132121	1397	1341780312000	16947	8461	24	0	\N
132122	1397	1341770311000	16947	8461	25	0	\N
132123	1397	1341760310000	16947	8461	26	0	\N
132124	1397	1341750309000	16947	8461	27	0	\N
132125	1397	1341740308000	16947	8461	28	0	\N
132126	1397	1341730307000	16947	8461	29	0	\N
132127	1397	1341720306000	16947	8461	30	0	\N
132128	1397	1341710305000	16947	8461	31	0	\N
132129	1397	1341700304000	16947	8461	32	0	\N
132130	1397	1341690303000	16947	8461	33	0	\N
132131	1397	1341680302000	16947	8461	34	0	\N
132132	238	66000186000000	16947	8461	35	0	\N
132133	1397	1341670301000	16947	8461	36	0	\N
132134	1397	1341660300000	16947	8461	37	0	\N
132135	1397	1341650299000	16947	8461	38	0	\N
132136	1397	1341640298000	16947	8461	39	0	\N
132137	1397	1341630297000	16947	8461	40	0	\N
132138	1397	1341620296000	16947	8461	41	0	\N
132139	1397	1341610295000	16947	8461	42	0	\N
132140	1397	1341600294000	16947	8461	43	0	\N
132141	1397	1341590293000	16947	8461	44	0	\N
132142	1397	1341580292000	16947	8461	45	0	\N
132143	1397	1341570291000	16947	8461	46	0	\N
132144	1397	1341560290000	16947	8461	47	0	\N
132145	1397	1341550289000	16947	8461	48	0	\N
132146	1397	1341540288000	16947	8461	49	0	\N
132147	1397	1341530287000	16947	8461	50	0	\N
132148	1397	1341520286000	16947	8461	51	0	\N
132149	1397	1341510285000	16947	8461	52	0	\N
132150	1397	1341500284000	16947	8461	53	0	\N
132151	1397	1341490283000	16947	8461	54	0	\N
132152	1397	1341480282000	16947	8461	55	0	\N
132153	1397	1341470281000	16947	8461	56	0	\N
132154	1397	1341460280000	16947	8461	57	0	\N
132155	1643	1929028862100	16947	8461	58	0	\N
132156	1643	1499127054300	16947	8461	59	0	\N
132157	1643	1208735205300	16947	8461	60	0	\N
132158	1643	968387114700	16947	8461	61	0	\N
132159	2134	98297900000	16947	8461	62	0	\N
132160	2132	148803804000	16947	8461	63	0	\N
132161	2132	148802803000	16947	8461	64	0	\N
132162	2132	148801802000	16947	8461	65	0	\N
132163	2132	148800801000	16947	8461	66	0	\N
132164	2132	148799800000	16947	8461	67	0	\N
132165	2132	148798799000	16947	8461	68	0	\N
132166	2132	148797798000	16947	8461	69	0	\N
132167	2132	148796797000	16947	8461	70	0	\N
132168	2132	148795796000	16947	8461	71	0	\N
132169	2134	98296897000	16947	8461	72	0	\N
132170	2132	148794795000	16947	8461	73	0	\N
132171	2133	98283570000	16947	8461	74	0	\N
132172	2133	98282568000	16947	8461	75	0	\N
132173	2133	98281566000	16947	8461	76	0	\N
132174	2132	148793794000	16947	8461	77	0	\N
132175	2132	148792793000	16947	8461	78	0	\N
132176	2132	148791792000	16947	8461	79	0	\N
132177	2132	148790791000	16947	8461	80	0	\N
132178	2132	148789790000	16947	8461	81	0	\N
132179	2132	148788789000	16947	8461	82	0	\N
132180	2132	148787788000	16947	8461	83	0	\N
132181	2132	148786787000	16947	8461	84	0	\N
132182	2132	148785786000	16947	8461	85	0	\N
132183	1769	1691900000	16947	8461	86	0	\N
132184	1769	1690900000	16947	8461	87	0	\N
132185	2132	148784785000	16947	8461	88	0	\N
132186	2132	148783784000	16947	8461	89	0	\N
132187	2132	148782783000	16947	8461	90	0	\N
132188	2132	148781782000	16947	8461	91	0	\N
132189	2132	148780781000	16947	8461	92	0	\N
132190	2133	98280564000	16947	8461	93	0	\N
132191	2133	98279562000	16947	8461	94	0	\N
132192	2133	98278560000	16947	8461	95	0	\N
132059	1397	1341510285000	16936	8585	0	0	9732
132060	1397	1341500284000	16936	8585	1	0	9733
132061	2133	98125254000	16936	8585	2	0	873
132062	2134	98129396000	16936	8585	3	0	868
132063	2134	98128393000	16936	8585	4	0	869
132065	2133	98124252000	16936	8585	6	0	874
132080	1397	1341490283000	16939	8586	0	0	9734
132081	2133	98123250000	16939	8586	1	0	875
132082	2134	98126387000	16939	8586	2	0	871
132083	1397	1341480282000	16940	8587	0	0	9735
132085	2132	148750751000	16940	8587	2	0	249
132089	1397	1341470281000	16942	8588	0	0	9736
132091	1397	1341460280000	16944	8589	0	0	9737
132092	2133	98121246000	16944	8589	1	0	877
132193	2133	98277558000	16947	8461	96	0	\N
132194	2133	98276556000	16947	8461	97	0	\N
132195	2133	98275554000	16947	8461	98	0	\N
132196	2133	98274552000	16947	8461	99	0	\N
132197	2133	98273550000	16947	8461	100	0	\N
132198	2133	98272548000	16947	8461	101	0	\N
132199	2133	98271546000	16947	8461	102	0	\N
132200	2133	98270544000	16947	8461	104	0	\N
132201	2133	98269542000	16947	8461	105	0	\N
132202	2133	98268540000	16947	8461	106	0	\N
132203	2133	98267538000	16947	8461	107	0	\N
132204	2133	98266536000	16947	8461	108	0	\N
132205	2133	98265534000	16947	8461	109	0	\N
132206	2133	98264532000	16947	8461	110	0	\N
132207	2133	98263530000	16947	8461	111	0	\N
132208	2133	98262528000	16947	8461	112	0	\N
132209	2133	98261526000	16947	8461	113	0	\N
132210	2133	98260524000	16947	8461	114	0	\N
132211	2133	98259522000	16947	8461	115	0	\N
132212	2133	98258520000	16947	8461	116	0	\N
132213	2133	98257518000	16947	8461	117	0	\N
132214	2132	148779780000	16947	8461	118	0	\N
132215	2132	148778779000	16947	8461	119	0	\N
132216	2132	148777778000	16947	8461	120	0	\N
132217	2132	148776777000	16947	8461	121	0	\N
132218	2132	148775776000	16947	8461	122	0	\N
132219	2132	148774775000	16947	8461	123	0	\N
132220	2132	148773774000	16947	8461	124	0	\N
132221	2132	148772773000	16947	8461	125	0	\N
132236	1397	1341410275000	16954	8593	0	0	\N
132237	1397	1341400274000	16954	8593	1	0	\N
132238	2133	98116236000	16954	8593	2	0	\N
132239	2133	98115234000	16954	8593	3	0	\N
132240	1397	1341390273000	16955	8594	0	0	\N
132241	1397	1341380272000	16955	8594	1	0	\N
132242	1726	127755109000	16955	8594	2	0	\N
132243	2133	98114232000	16955	8594	3	0	\N
132244	2133	98113230000	16955	8594	4	0	\N
132245	2132	148747748000	16955	8594	5	0	\N
132246	1397	1341390273000	16956	8594	0	0	\N
132247	1397	1341380272000	16956	8594	1	0	\N
132248	1726	127755109000	16956	8594	2	0	\N
132249	2133	98114232000	16956	8594	3	0	\N
132250	2133	98113230000	16956	8594	4	0	\N
132251	2132	148747748000	16956	8594	5	0	\N
132252	1397	1341390273000	16957	8594	0	0	\N
132253	1397	1341380272000	16957	8594	1	0	\N
132254	1726	127755109000	16957	8594	2	0	\N
132255	2133	98114232000	16957	8594	3	0	\N
132256	2133	98113230000	16957	8594	4	0	\N
132257	2132	148747748000	16957	8594	5	0	\N
132267	1397	1341350269000	16961	8597	0	0	\N
132268	2132	148746747000	16961	8597	1	0	\N
132269	2133	98111226000	16961	8597	2	0	\N
132273	1397	1341340268000	16963	8598	0	0	\N
132274	1397	1341330267000	16963	8598	1	0	\N
132275	1397	1341320266000	16963	8598	2	0	\N
132276	2133	98110224000	16963	8598	3	0	\N
132277	2133	98109222000	16963	8598	4	0	\N
132278	2133	98108220000	16963	8598	5	0	\N
132279	414	66000011000000	16964	8523	0	0	\N
132280	1726	128965109000	16964	8523	1	0	\N
132281	1726	127755109000	16964	8523	2	0	\N
132282	238	66000186000000	16964	8523	3	0	\N
132283	1643	2649064862100	16964	8523	4	0	\N
132284	1643	2219163054300	16964	8523	5	0	\N
132285	1643	1928771205300	16964	8523	6	0	\N
132286	1643	1688423114700	16964	8523	7	0	\N
132293	1397	1341340268000	16966	8598	0	0	\N
132294	1397	1341330267000	16966	8598	1	0	\N
132295	1397	1341320266000	16966	8598	2	0	\N
132296	2133	98110224000	16966	8598	3	0	\N
132297	2133	98109222000	16966	8598	4	0	\N
132298	2133	98108220000	16966	8598	5	0	\N
132299	1397	1341340268000	16967	8598	0	0	\N
132300	1397	1341330267000	16967	8598	1	0	\N
132301	1397	1341320266000	16967	8598	2	0	\N
132302	2133	98110224000	16967	8598	3	0	\N
132303	2133	98109222000	16967	8598	4	0	\N
132304	2133	98108220000	16967	8598	5	0	\N
132305	1397	1341340268000	16968	8598	0	0	\N
132306	1397	1341330267000	16968	8598	1	0	\N
132307	1397	1341320266000	16968	8598	2	0	\N
132308	2133	98110224000	16968	8598	3	0	\N
132309	2133	98109222000	16968	8598	4	0	\N
132310	2133	98108220000	16968	8598	5	0	\N
132311	1726	128965109000	16969	8538	0	0	\N
132312	1726	127755109000	16969	8538	1	0	\N
132313	238	66000186000000	16969	8538	2	0	\N
132317	1397	1341310265000	16971	8599	0	0	\N
132318	2132	148745746000	16971	8599	1	0	\N
132319	2133	98107218000	16971	8599	2	0	\N
132320	1397	1341300264000	16972	8600	0	0	\N
132321	2133	98106216000	16972	8600	1	0	\N
132322	1397	1341300264000	16973	8600	0	0	\N
132323	2133	98106216000	16973	8600	1	0	\N
132324	1397	1341300264000	16974	8600	0	0	\N
132325	2133	98106216000	16974	8600	1	0	\N
132328	1397	1341300264000	16976	8600	0	0	\N
132224	2133	98120244000	16948	8590	2	0	878
132225	1397	1341440278000	16949	8591	0	0	9739
132226	2133	98119242000	16949	8591	1	0	879
132227	1397	1341430277000	16951	8592	0	0	9740
132228	1397	1341420276000	16951	8592	1	0	9741
132230	2133	98117238000	16951	8592	3	0	881
132231	2132	148748749000	16951	8592	4	0	251
132232	1397	1341410275000	16953	8593	0	0	9742
132233	1397	1341400274000	16953	8593	1	0	9743
132234	2133	98116236000	16953	8593	2	0	882
132258	1397	1341390273000	16958	8594	0	0	9744
132259	1397	1341380272000	16958	8594	1	0	9745
132260	1726	127755109000	16958	8594	2	0	8180
132261	2133	98114232000	16958	8594	3	0	884
132263	2132	148747748000	16958	8594	5	0	252
132264	1397	1341370271000	16959	8595	0	0	9746
132265	2133	98112228000	16959	8595	1	0	886
132266	1397	1341360270000	16960	8596	0	0	9747
132270	1397	1341350269000	16962	8597	0	0	9748
132272	2133	98111226000	16962	8597	2	0	887
132287	1397	1341340268000	16965	8598	0	0	9749
132288	1397	1341330267000	16965	8598	1	0	9750
132289	1397	1341320266000	16965	8598	2	0	9751
132290	2133	98110224000	16965	8598	3	0	888
132292	2133	98108220000	16965	8598	5	0	890
132314	1397	1341310265000	16970	8599	0	0	9752
132315	2132	148745746000	16970	8599	1	0	254
132316	2133	98107218000	16970	8599	2	0	891
132327	2133	98106216000	16975	8600	1	0	892
132329	2133	98106216000	16976	8600	1	0	\N
132330	1397	1341290263000	16978	8601	0	0	\N
132335	1397	1341270261000	16981	8603	0	0	\N
132336	2133	98104212000	16981	8603	1	0	\N
132337	1397	1341270261000	16982	8603	0	0	\N
132338	2133	98104212000	16982	8603	1	0	\N
132341	1397	1341260260000	16984	8604	0	0	\N
132342	1397	1341250259000	16984	8604	1	0	\N
132343	2132	148743744000	16984	8604	2	0	\N
132344	2133	98103210000	16984	8604	3	0	\N
132345	2133	98102208000	16984	8604	4	0	\N
132351	1397	1341260260000	16986	8604	0	0	\N
132352	1397	1341250259000	16986	8604	1	0	\N
132353	2132	148743744000	16986	8604	2	0	\N
132354	2133	98103210000	16986	8604	3	0	\N
132355	2133	98102208000	16986	8604	4	0	\N
132358	1397	1341240258000	16988	8605	0	0	\N
132359	2133	98101206000	16988	8605	1	0	\N
132360	1397	1341240258000	16989	8605	0	0	\N
132361	2133	98101206000	16989	8605	1	0	\N
132376	1397	1341180252000	17000	8610	0	0	\N
132377	2133	98095194000	17000	8610	1	0	\N
132378	1397	1341180252000	17001	8610	0	0	\N
132379	2133	98095194000	17001	8610	1	0	\N
132389	1397	1341150249000	17005	8613	0	0	\N
132390	1397	1341140248000	17005	8613	1	0	\N
132391	2133	98092188000	17005	8613	2	0	\N
132392	2133	98091186000	17005	8613	3	0	\N
132393	1397	1341150249000	17006	8613	0	0	\N
132394	1397	1341140248000	17006	8613	1	0	\N
132395	2133	98092188000	17006	8613	2	0	\N
132396	2133	98091186000	17006	8613	3	0	\N
132409	1397	1341100244000	17010	8616	0	0	\N
132410	1397	1341090243000	17010	8616	1	0	\N
132411	2132	148738739000	17010	8616	2	0	\N
132412	2133	98087178000	17010	8616	3	0	\N
132413	2133	98086176000	17010	8616	4	0	\N
132420	1397	1341070241000	17013	8618	0	0	\N
132421	2134	98124381000	17013	8618	1	0	\N
132429	1397	1341040238000	17015	8620	0	0	\N
132430	2134	98121372000	17015	8620	1	0	\N
132431	2133	98082168000	17015	8620	3	0	\N
132435	1397	1341030237000	17017	8621	0	0	\N
132436	2134	98120369000	17017	8621	1	0	\N
132437	2133	98081166000	17017	8621	2	0	\N
132438	1397	1341030237000	17018	8621	0	0	\N
132439	2134	98120369000	17018	8621	1	0	\N
132440	2133	98081166000	17018	8621	2	0	\N
132444	1397	1341020236000	17020	8622	0	0	\N
132445	1397	1341010235000	17020	8622	1	0	\N
132446	2134	98119366000	17020	8622	2	0	\N
132447	2134	98118363000	17020	8622	3	0	\N
132448	2132	148736737000	17020	8622	4	0	\N
132449	2133	98080164000	17020	8622	5	0	\N
132450	2133	98079162000	17020	8622	6	0	\N
132451	1397	1341020236000	17021	8622	0	0	\N
132452	1397	1341010235000	17021	8622	1	0	\N
132453	2134	98119366000	17021	8622	2	0	\N
132454	2134	98118363000	17021	8622	3	0	\N
132455	2132	148736737000	17021	8622	4	0	\N
132456	2133	98080164000	17021	8622	5	0	\N
132457	2133	98079162000	17021	8622	6	0	\N
132333	2132	148744745000	16980	8602	1	0	255
132334	2133	98105214000	16980	8602	2	0	893
132339	1397	1341270261000	16983	8603	0	0	9756
132340	2133	98104212000	16983	8603	1	0	894
132346	1397	1341260260000	16985	8604	0	0	9757
132348	2132	148743744000	16985	8604	2	0	256
132349	2133	98103210000	16985	8604	3	0	895
132350	2133	98102208000	16985	8604	4	0	896
132356	1397	1341240258000	16987	8605	0	0	9759
132357	2133	98101206000	16987	8605	1	0	897
132363	2133	98100204000	16990	8606	1	0	898
132364	1397	1341220256000	16991	8607	0	0	9761
132365	2132	148742743000	16991	8607	1	0	257
132366	2133	98099202000	16991	8607	2	0	899
132368	2133	98098200000	16994	8608	1	0	900
132369	1397	1341200254000	16998	8609	0	0	9763
132370	1397	1341190253000	16998	8609	1	0	9764
132371	2132	148741742000	16998	8609	2	0	258
132372	2133	98097198000	16998	8609	3	0	901
132374	1397	1341180252000	16999	8610	0	0	9765
132375	2133	98095194000	16999	8610	1	0	903
132380	1397	1341170251000	17002	8611	0	0	9766
132381	2133	98094192000	17002	8611	1	0	904
132382	1397	1341160250000	17003	8612	0	0	9767
132384	2133	98093190000	17003	8612	2	0	905
132385	1397	1341150249000	17004	8613	0	0	9768
132386	1397	1341140248000	17004	8613	1	0	9769
132387	2133	98092188000	17004	8613	2	0	906
132397	1397	1341130247000	17007	8614	0	0	9770
132398	1397	1341120246000	17007	8614	1	0	9771
132399	2133	98090184000	17007	8614	2	0	908
132400	2133	98089182000	17007	8614	3	0	909
132401	2132	148739740000	17007	8614	4	0	260
132403	2133	98088180000	17008	8615	1	0	910
132404	1397	1341100244000	17009	8616	0	0	9773
132405	1397	1341090243000	17009	8616	1	0	9774
132406	2132	148738739000	17009	8616	2	0	261
132407	2133	98087178000	17009	8616	3	0	911
132414	1397	1341080242000	17011	8617	0	0	9775
132415	1726	126545109000	17011	8617	1	0	8181
132416	2133	98085174000	17011	8617	2	0	913
132417	2134	98125384000	17011	8617	3	0	872
132419	2134	98124381000	17012	8618	1	0	873
132422	1397	1341060240000	17014	8619	0	0	9777
132423	1397	1341050239000	17014	8619	1	0	9778
132424	2132	148737738000	17014	8619	2	0	262
132425	2134	98123378000	17014	8619	3	0	874
132427	2133	98084172000	17014	8619	5	0	914
132428	2133	98083170000	17014	8619	6	0	915
132432	1397	1341040238000	17016	8620	0	0	9779
132433	2134	98121372000	17016	8620	1	0	876
132434	2133	98082168000	17016	8620	3	0	916
132442	2134	98120369000	17019	8621	1	0	877
132443	2133	98081166000	17019	8621	2	0	917
132458	1397	1341020236000	17022	8622	0	0	9781
132459	1397	1341010235000	17022	8622	1	0	9782
132461	2134	98118363000	17022	8622	3	0	879
132462	2132	148736737000	17022	8622	4	0	263
132463	2133	98080164000	17022	8622	5	0	918
132464	2133	98079162000	17022	8622	6	0	919
132465	1397	1341020236000	17023	8622	0	0	\N
132466	1397	1341010235000	17023	8622	1	0	\N
132467	2134	98119366000	17023	8622	2	0	\N
132468	2134	98118363000	17023	8622	3	0	\N
132469	2132	148736737000	17023	8622	4	0	\N
132470	2133	98080164000	17023	8622	5	0	\N
132471	2133	98079162000	17023	8622	6	0	\N
132472	1397	1341000234000	17024	8623	0	0	\N
132473	2133	98078160000	17024	8623	1	0	\N
132474	2134	98117360000	17024	8623	2	0	\N
132475	2133	98078160000	17025	8623	0	0	\N
132476	2134	98117360000	17025	8623	1	0	\N
132480	1397	1341430277000	17027	8592	0	0	\N
132481	1397	1341420276000	17027	8592	1	0	\N
132482	1397	1341410275000	17027	8592	2	0	\N
132483	1397	1341400274000	17027	8592	3	0	\N
132484	1397	1341390273000	17027	8592	4	0	\N
132485	1397	1341380272000	17027	8592	5	0	\N
132486	1726	127755109000	17027	8592	6	0	\N
132487	1726	126545109000	17027	8592	7	0	\N
132488	1397	1341370271000	17027	8592	8	0	\N
132489	1397	1341360270000	17027	8592	9	0	\N
132490	1397	1341350269000	17027	8592	10	0	\N
132491	1397	1341340268000	17027	8592	11	0	\N
132492	1397	1341330267000	17027	8592	12	0	\N
132493	1397	1341320266000	17027	8592	13	0	\N
132494	1397	1341310265000	17027	8592	14	0	\N
132495	1397	1341300264000	17027	8592	15	0	\N
132496	1397	1341290263000	17027	8592	16	0	\N
132497	1397	1341280262000	17027	8592	17	0	\N
132498	1397	1341270261000	17027	8592	18	0	\N
132499	1397	1341260260000	17027	8592	19	0	\N
132500	1397	1341250259000	17027	8592	20	0	\N
132501	1397	1341240258000	17027	8592	21	0	\N
132502	1397	1341230257000	17027	8592	22	0	\N
132503	1397	1341220256000	17027	8592	24	0	\N
132504	1397	1341210255000	17027	8592	25	0	\N
132505	1397	1341200254000	17027	8592	26	0	\N
132506	1397	1341190253000	17027	8592	27	0	\N
132507	1397	1341180252000	17027	8592	28	0	\N
132508	1397	1341170251000	17027	8592	29	0	\N
132509	1397	1341160250000	17027	8592	30	0	\N
132510	1397	1341150249000	17027	8592	31	0	\N
132511	1397	1341140248000	17027	8592	32	0	\N
132512	1397	1341130247000	17027	8592	33	0	\N
132513	1397	1341120246000	17027	8592	34	0	\N
132514	1397	1341110245000	17027	8592	35	0	\N
132515	1397	1341100244000	17027	8592	36	0	\N
132516	1397	1341090243000	17027	8592	37	0	\N
132517	1397	1341080242000	17027	8592	38	0	\N
132518	1397	1341070241000	17027	8592	39	0	\N
132519	1397	1341060240000	17027	8592	40	0	\N
132520	1397	1341050239000	17027	8592	41	0	\N
132521	1397	1341040238000	17027	8592	42	0	\N
132522	1397	1341030237000	17027	8592	43	0	\N
132523	1397	1341020236000	17027	8592	44	0	\N
132524	1397	1341010235000	17027	8592	45	0	\N
132525	1397	1341000234000	17027	8592	46	0	\N
132526	2133	98118240000	17027	8592	47	0	\N
132527	2133	98117238000	17027	8592	48	0	\N
132528	2133	98116236000	17027	8592	49	0	\N
132529	2133	98115234000	17027	8592	50	0	\N
132530	2133	98114232000	17027	8592	51	0	\N
132531	2133	98113230000	17027	8592	52	0	\N
132532	2133	98112228000	17027	8592	53	0	\N
132533	2133	98111226000	17027	8592	54	0	\N
132534	2133	98110224000	17027	8592	55	0	\N
132535	2134	98125384000	17027	8592	56	0	\N
132536	2134	98124381000	17027	8592	57	0	\N
132537	2134	98123378000	17027	8592	58	0	\N
132538	2134	98122375000	17027	8592	59	0	\N
132539	2134	98121372000	17027	8592	60	0	\N
132540	2134	98120369000	17027	8592	61	0	\N
132541	2134	98119366000	17027	8592	62	0	\N
132542	2134	98118363000	17027	8592	63	0	\N
132543	2134	98117360000	17027	8592	64	0	\N
132544	2133	98109222000	17027	8592	65	0	\N
132545	2133	98108220000	17027	8592	66	0	\N
132546	2133	98107218000	17027	8592	67	0	\N
132547	2133	98106216000	17027	8592	68	0	\N
132548	2133	98105214000	17027	8592	69	0	\N
132549	2133	98104212000	17027	8592	70	0	\N
132550	2133	98103210000	17027	8592	71	0	\N
132551	2133	98102208000	17027	8592	72	0	\N
132552	2132	148748749000	17027	8592	73	0	\N
132553	2132	148747748000	17027	8592	74	0	\N
132554	2132	148746747000	17027	8592	75	0	\N
132555	2132	148745746000	17027	8592	76	0	\N
132556	2132	148744745000	17027	8592	77	0	\N
132557	2132	148743744000	17027	8592	78	0	\N
132558	2132	148742743000	17027	8592	79	0	\N
132559	2132	148741742000	17027	8592	80	0	\N
132560	2132	148740741000	17027	8592	81	0	\N
132561	2132	148739740000	17027	8592	82	0	\N
132562	2132	148738739000	17027	8592	83	0	\N
132563	2132	148737738000	17027	8592	84	0	\N
132564	2132	148736737000	17027	8592	85	0	\N
132565	2133	98101206000	17027	8592	86	0	\N
132566	2133	98100204000	17027	8592	87	0	\N
132567	2133	98099202000	17027	8592	88	0	\N
132568	2133	98098200000	17027	8592	89	0	\N
132569	2133	98097198000	17027	8592	90	0	\N
132570	2133	98096196000	17027	8592	91	0	\N
132571	2133	98095194000	17027	8592	92	0	\N
132572	2133	98094192000	17027	8592	93	0	\N
132573	2133	98093190000	17027	8592	94	0	\N
132574	2133	98092188000	17027	8592	95	0	\N
132575	2133	98091186000	17027	8592	96	0	\N
132576	2133	98090184000	17027	8592	97	0	\N
132577	2133	98089182000	17027	8592	98	0	\N
132578	2133	98088180000	17027	8592	99	0	\N
132579	2133	98087178000	17027	8592	100	0	\N
132580	2133	98086176000	17027	8592	101	0	\N
132581	2133	98085174000	17027	8592	102	0	\N
132582	2133	98084172000	17027	8592	103	0	\N
132583	2133	98083170000	17027	8592	104	0	\N
132584	2133	98082168000	17027	8592	105	0	\N
132585	2133	98081166000	17027	8592	106	0	\N
132586	2133	98080164000	17027	8592	107	0	\N
132587	2133	98079162000	17027	8592	108	0	\N
132588	2133	98078160000	17027	8592	109	0	\N
132589	2133	98077158000	17028	8624	0	0	\N
132590	2132	148735736000	17028	8624	1	0	\N
132593	1397	1341000234000	17030	8623	0	0	\N
132594	2133	98078160000	17030	8623	1	0	\N
132595	2133	98077158000	17030	8623	2	0	\N
132596	2134	98117360000	17030	8623	3	0	\N
132597	2132	148735736000	17030	8623	4	0	\N
132598	2133	98077158000	17031	8624	0	0	\N
132599	2132	148735736000	17031	8624	1	0	\N
132600	2132	148735736000	17032	8624	0	0	\N
132479	2134	98117360000	17026	8623	2	0	880
132591	2133	98077158000	17029	8624	0	0	921
132592	2132	148735736000	17029	8624	1	0	264
132601	1397	1340990233000	17033	8625	0	0	\N
132602	2133	98077158000	17033	8625	1	0	\N
132603	2134	98116357000	17033	8625	2	0	\N
132604	2133	98076156000	17033	8625	3	0	\N
132607	1397	1340980232000	17035	8626	0	0	\N
132608	2134	98115354000	17035	8626	1	0	\N
132609	2133	98076156000	17035	8626	2	0	\N
132616	1397	1340970231000	17038	8627	0	0	\N
132617	2133	98075154000	17038	8627	1	0	\N
132618	2134	98114351000	17038	8627	2	0	\N
132638	1397	1340920226000	17044	8632	0	0	\N
132639	1397	1340910225000	17044	8632	1	0	\N
132640	2134	98109336000	17044	8632	2	0	\N
132641	2134	98108333000	17044	8632	3	0	\N
132642	2133	98071146000	17044	8632	4	0	\N
132643	2133	98070144000	17044	8632	5	0	\N
132648	1397	1340900224000	17047	8633	0	0	\N
132649	2134	98107330000	17047	8633	1	0	\N
132650	2133	98069142000	17047	8633	2	0	\N
132651	2132	148732733000	17047	8633	3	0	\N
132655	2134	98106327000	17049	8634	0	0	\N
132656	2133	98068140000	17049	8634	1	0	\N
132663	1397	1341750309000	17052	8567	0	0	\N
132664	1397	1341740308000	17052	8567	1	0	\N
132665	1726	128965109000	17052	8567	2	0	\N
132666	1726	127755109000	17052	8567	3	0	\N
132667	1726	126545109000	17052	8567	4	0	\N
132668	1397	1341730307000	17052	8567	5	0	\N
132669	1397	1341720306000	17052	8567	6	0	\N
132670	1397	1341710305000	17052	8567	7	0	\N
132671	1397	1341700304000	17052	8567	8	0	\N
132672	1397	1341690303000	17052	8567	9	0	\N
132673	1397	1341680302000	17052	8567	10	0	\N
132674	238	66000186000000	17052	8567	11	0	\N
132675	1397	1341670301000	17052	8567	12	0	\N
132676	1397	1341660300000	17052	8567	13	0	\N
132677	1397	1341650299000	17052	8567	14	0	\N
132678	1397	1341640298000	17052	8567	15	0	\N
132679	1397	1341630297000	17052	8567	16	0	\N
132680	1397	1341620296000	17052	8567	17	0	\N
132681	1397	1341610295000	17052	8567	18	0	\N
132682	1397	1341600294000	17052	8567	19	0	\N
132683	1397	1341590293000	17052	8567	20	0	\N
132684	1397	1341580292000	17052	8567	21	0	\N
132685	1397	1341570291000	17052	8567	22	0	\N
132686	1397	1341560290000	17052	8567	23	0	\N
132687	1397	1341550289000	17052	8567	24	0	\N
132688	1397	1341540288000	17052	8567	25	0	\N
132689	1397	1341530287000	17052	8567	26	0	\N
132690	1397	1341520286000	17052	8567	27	0	\N
132691	1397	1341510285000	17052	8567	28	0	\N
132692	1397	1341500284000	17052	8567	29	0	\N
132693	1397	1341490283000	17052	8567	30	0	\N
132694	1397	1341480282000	17052	8567	31	0	\N
132695	1397	1341470281000	17052	8567	32	0	\N
132696	1397	1341460280000	17052	8567	33	0	\N
132697	1397	1341450279000	17052	8567	34	0	\N
132698	1397	1341440278000	17052	8567	35	0	\N
132699	1397	1341430277000	17052	8567	36	0	\N
132700	1397	1341420276000	17052	8567	37	0	\N
132701	1397	1341410275000	17052	8567	38	0	\N
132702	1397	1341400274000	17052	8567	39	0	\N
132703	1397	1341390273000	17052	8567	40	0	\N
132704	1397	1341380272000	17052	8567	41	0	\N
132705	1397	1341370271000	17052	8567	42	0	\N
132706	1397	1341360270000	17052	8567	43	0	\N
132707	1397	1341350269000	17052	8567	44	0	\N
132708	1397	1341340268000	17052	8567	45	0	\N
132709	1397	1341330267000	17052	8567	47	0	\N
132710	1397	1341320266000	17052	8567	48	0	\N
132711	1397	1341310265000	17052	8567	49	0	\N
132712	1397	1341300264000	17052	8567	50	0	\N
132713	1397	1341290263000	17052	8567	51	0	\N
132714	1397	1341280262000	17052	8567	52	0	\N
132715	1397	1341270261000	17052	8567	53	0	\N
132716	1397	1341260260000	17052	8567	54	0	\N
132717	1397	1341250259000	17052	8567	55	0	\N
132718	1397	1341240258000	17052	8567	56	0	\N
132719	1397	1341230257000	17052	8567	57	0	\N
132720	1397	1341220256000	17052	8567	58	0	\N
132721	1397	1341210255000	17052	8567	59	0	\N
132722	1397	1341200254000	17052	8567	60	0	\N
132723	1397	1341190253000	17052	8567	61	0	\N
132724	1397	1341180252000	17052	8567	62	0	\N
132725	1397	1341170251000	17052	8567	63	0	\N
132726	1397	1341160250000	17052	8567	64	0	\N
132727	1397	1341150249000	17052	8567	65	0	\N
132728	1397	1341140248000	17052	8567	66	0	\N
132729	1397	1341130247000	17052	8567	67	0	\N
132730	1397	1341120246000	17052	8567	68	0	\N
132731	1397	1341110245000	17052	8567	69	0	\N
132732	1397	1341100244000	17052	8567	70	0	\N
132733	1397	1341090243000	17052	8567	71	0	\N
132734	1397	1341080242000	17052	8567	72	0	\N
132735	1397	1341070241000	17052	8567	73	0	\N
132736	1397	1341060240000	17052	8567	74	0	\N
132610	1397	1340980232000	17036	8626	0	0	9785
132611	2134	98115354000	17036	8626	1	0	882
132612	2133	98076156000	17036	8626	2	0	922
132613	1397	1340970231000	17037	8627	0	0	9786
132614	2133	98075154000	17037	8627	1	0	923
132619	1397	1340960230000	17039	8628	0	0	9787
132620	2132	148734735000	17039	8628	1	0	265
132621	2133	98074152000	17039	8628	2	0	924
132622	2134	98113348000	17039	8628	3	0	884
132623	1397	1340950229000	17040	8629	0	0	9788
132625	2133	98073150000	17040	8629	2	0	925
132626	1397	1340940228000	17041	8630	0	0	9789
132627	2134	98111342000	17041	8630	1	0	886
132628	2133	98072148000	17041	8630	2	0	926
132630	2132	148733734000	17042	8631	1	0	266
132631	2134	98110339000	17042	8631	2	0	887
132632	1397	1340920226000	17043	8632	0	0	9791
132633	1397	1340910225000	17043	8632	1	0	9792
132634	2134	98109336000	17043	8632	2	0	888
132636	2133	98071146000	17043	8632	4	0	927
132637	2133	98070144000	17043	8632	5	0	928
132644	1397	1340900224000	17046	8633	0	0	9793
132645	2134	98107330000	17046	8633	1	0	890
132646	2133	98069142000	17046	8633	2	0	929
132652	1397	1340890223000	17048	8634	0	0	9794
132653	2134	98106327000	17048	8634	1	0	891
132654	2133	98068140000	17048	8634	2	0	930
132657	1397	1340880222000	17050	8635	0	0	9795
132659	2133	98067138000	17050	8635	2	0	931
132660	1397	1340870221000	17051	8636	0	0	9796
132661	2134	98104321000	17051	8636	1	0	893
132662	2133	98066136000	17051	8636	2	0	932
132737	1397	1341050239000	17052	8567	75	0	\N
132738	1397	1341040238000	17052	8567	76	0	\N
132739	1397	1341030237000	17052	8567	77	0	\N
132740	1397	1341020236000	17052	8567	78	0	\N
132741	1397	1341010235000	17052	8567	79	0	\N
132742	1397	1341000234000	17052	8567	80	0	\N
132743	1397	1340990233000	17052	8567	81	0	\N
132744	1397	1340980232000	17052	8567	82	0	\N
132745	1397	1340970231000	17052	8567	83	0	\N
132746	1397	1340960230000	17052	8567	84	0	\N
132747	1397	1340950229000	17052	8567	85	0	\N
132748	1397	1340940228000	17052	8567	86	0	\N
132749	1397	1340930227000	17052	8567	87	0	\N
132750	1397	1340920226000	17052	8567	88	0	\N
132751	1397	1340910225000	17052	8567	89	0	\N
132752	1397	1340900224000	17052	8567	90	0	\N
132753	1397	1340890223000	17052	8567	91	0	\N
132754	1397	1340880222000	17052	8567	92	0	\N
132755	1397	1340870221000	17052	8567	93	0	\N
132756	2132	148758759000	17052	8567	94	0	\N
132757	2134	98153468000	17052	8567	95	0	\N
132758	2133	98147298000	17052	8567	96	0	\N
132759	2132	148757758000	17052	8567	97	0	\N
132760	2132	148756757000	17052	8567	98	0	\N
132761	2132	148755756000	17052	8567	99	0	\N
132762	2133	98146296000	17052	8567	100	0	\N
132763	2134	98152465000	17052	8567	101	0	\N
132764	2134	98151462000	17052	8567	102	0	\N
132765	2134	98150459000	17052	8567	103	0	\N
132766	2134	98149456000	17052	8567	104	0	\N
132767	2133	98145294000	17052	8567	105	0	\N
132768	2133	98144292000	17052	8567	106	0	\N
132769	2133	98143290000	17052	8567	107	0	\N
132770	2133	98142288000	17052	8567	108	0	\N
132771	2133	98141286000	17052	8567	109	0	\N
132772	2133	98140284000	17052	8567	110	0	\N
132773	2133	98139282000	17052	8567	111	0	\N
132774	2133	98138280000	17052	8567	112	0	\N
132775	2133	98137278000	17052	8567	113	0	\N
132776	2134	98148453000	17052	8567	114	0	\N
132777	2134	98147450000	17052	8567	115	0	\N
132778	2134	98146447000	17052	8567	116	0	\N
132779	2134	98145444000	17052	8567	117	0	\N
132780	2134	98144441000	17052	8567	118	0	\N
132781	2134	98143438000	17052	8567	119	0	\N
132782	2134	98142435000	17052	8567	120	0	\N
132783	2134	98141432000	17052	8567	121	0	\N
132784	2134	98140429000	17052	8567	122	0	\N
132785	2134	98139426000	17052	8567	123	0	\N
132786	2134	98138423000	17052	8567	124	0	\N
132787	2134	98137420000	17052	8567	125	0	\N
132788	1726	126545109000	17053	8539	0	0	\N
132789	1726	125335109000	17053	8539	1	0	\N
132790	1397	1340860220000	17054	8637	0	0	\N
132791	1726	125335109000	17054	8637	1	0	\N
132792	2133	98065134000	17054	8637	2	0	\N
132793	2132	148731732000	17054	8637	3	0	\N
132794	1397	1340860220000	17055	8637	0	0	\N
132795	1726	125335109000	17055	8637	1	0	\N
132796	2134	98103318000	17055	8637	2	0	\N
132797	2133	98065134000	17055	8637	3	0	\N
132798	2132	148731732000	17055	8637	4	0	\N
132820	1397	1340800214000	17061	8642	0	0	\N
132821	2133	98059122000	17061	8642	1	0	\N
132822	2134	98097300000	17061	8642	2	0	\N
132823	2132	148729730000	17061	8642	3	0	\N
132828	414	66000011000000	17063	8411	0	0	\N
132829	1397	1342430377000	17063	8411	1	0	\N
132830	1726	128965109000	17063	8411	2	0	\N
132831	1397	1342420376000	17063	8411	3	0	\N
132832	1726	127755109000	17063	8411	4	0	\N
132833	1726	126545109000	17063	8411	5	0	\N
132834	1726	125335109000	17063	8411	6	0	\N
132835	1397	1342410375000	17063	8411	7	0	\N
132836	1397	1342400374000	17063	8411	8	0	\N
132837	1397	1342390373000	17063	8411	9	0	\N
132838	1397	1342380372000	17063	8411	10	0	\N
132839	1397	1342370371000	17063	8411	11	0	\N
132840	1397	1342360370000	17063	8411	12	0	\N
132841	1397	1342350369000	17063	8411	13	0	\N
132842	1397	1342340368000	17063	8411	14	0	\N
132843	1397	1342330367000	17063	8411	15	0	\N
132844	1397	1342320366000	17063	8411	16	0	\N
132845	1397	1342310365000	17063	8411	17	0	\N
132846	1397	1342300364000	17063	8411	18	0	\N
132847	1397	1342290363000	17063	8411	19	0	\N
132848	1397	1342280362000	17063	8411	20	0	\N
132849	1397	1342270361000	17063	8411	21	0	\N
132850	1397	1342260360000	17063	8411	22	0	\N
132851	1397	1342250359000	17063	8411	23	0	\N
132852	1397	1342240358000	17063	8411	24	0	\N
132853	2132	148728729000	17065	8644	0	0	\N
132867	1726	128965109000	17067	8541	0	0	\N
132868	1726	127755109000	17067	8541	1	0	\N
132869	1726	126545109000	17067	8541	2	0	\N
132870	1726	125335109000	17067	8541	3	0	\N
132871	238	66000186000000	17067	8541	4	0	\N
132801	2134	98103318000	17056	8637	2	0	894
132802	2133	98065134000	17056	8637	3	0	933
132803	2132	148731732000	17056	8637	4	0	268
132804	1397	1340850219000	17057	8638	0	0	9798
132805	2133	98064132000	17057	8638	1	0	934
132807	1397	1340840218000	17058	8639	0	0	9799
132808	1397	1340830217000	17058	8639	1	0	9800
132809	2132	148730731000	17058	8639	2	0	269
132810	2133	98063130000	17058	8639	3	0	935
132811	2133	98062128000	17058	8639	4	0	936
132813	2134	98100309000	17058	8639	6	0	897
132814	1397	1340820216000	17059	8640	0	0	9801
132815	2133	98061126000	17059	8640	1	0	937
132816	2134	98099306000	17059	8640	2	0	898
132818	2134	98098303000	17060	8641	1	0	899
132819	2133	98060124000	17060	8641	2	0	938
132824	1397	1340800214000	17062	8642	0	0	9803
132825	2133	98059122000	17062	8642	1	0	939
132826	2134	98097300000	17062	8642	2	0	900
132854	1397	1340790213000	17066	8644	0	0	9804
132855	1397	1340780212000	17066	8644	1	0	9805
132856	1397	1340770211000	17066	8644	2	0	9806
132857	1397	1340760210000	17066	8644	3	0	9807
132858	2132	148728729000	17066	8644	4	0	271
132860	2133	98057118000	17066	8644	6	0	941
132861	2133	98056116000	17066	8644	7	0	942
132862	2133	98055114000	17066	8644	8	0	943
132863	2134	98096297000	17066	8644	9	0	901
132865	2134	98094291000	17066	8644	11	0	903
132866	2134	98093288000	17066	8644	12	0	904
132872	1397	1340750209000	17068	8645	0	0	9808
132878	1397	1340730207000	17070	8647	0	0	\N
132879	2133	98052108000	17070	8647	1	0	\N
132880	2134	98090279000	17070	8647	2	0	\N
132881	2132	148727728000	17070	8647	3	0	\N
132886	1397	1340730207000	17072	8647	0	0	\N
132887	2133	98052108000	17072	8647	1	0	\N
132888	2132	148727728000	17072	8647	2	0	\N
132889	1397	1340720206000	17073	8648	0	0	\N
132890	2134	98089276000	17073	8648	1	0	\N
132891	1397	1340720206000	17074	8648	0	0	\N
132892	2134	98089276000	17074	8648	1	0	\N
132898	1397	1340710205000	17077	8649	0	0	\N
132899	2134	98089276000	17077	8649	1	0	\N
132900	2134	98088273000	17077	8649	2	0	\N
132901	2133	98051106000	17077	8649	3	0	\N
132928	1598	1200008000000	17082	8653	0	0	\N
132929	1397	1340640198000	17082	8653	1	0	\N
132930	2133	98044092000	17082	8653	2	0	\N
132931	2134	98081252000	17082	8653	3	0	\N
132945	1598	1200008000000	17086	8593	0	0	\N
132946	1397	1340990233000	17086	8593	1	0	\N
132947	1397	1340980232000	17086	8593	2	0	\N
132948	1726	125335109000	17086	8593	3	0	\N
132949	1397	1340970231000	17086	8593	4	0	\N
132950	1397	1340960230000	17086	8593	5	0	\N
132951	1397	1340950229000	17086	8593	6	0	\N
132952	1397	1340940228000	17086	8593	7	0	\N
132953	1397	1340930227000	17086	8593	8	0	\N
132954	1397	1340920226000	17086	8593	9	0	\N
132955	1397	1340910225000	17086	8593	10	0	\N
132956	1397	1340900224000	17086	8593	11	0	\N
132957	1397	1340890223000	17086	8593	12	0	\N
132958	1397	1340880222000	17086	8593	13	0	\N
132959	1726	124125109000	17086	8593	14	0	\N
132960	1397	1340870221000	17086	8593	15	0	\N
132961	1397	1340860220000	17086	8593	16	0	\N
132962	1397	1340850219000	17086	8593	17	0	\N
132963	1397	1340840218000	17086	8593	18	0	\N
132964	1397	1340830217000	17086	8593	19	0	\N
132965	1397	1340820216000	17086	8593	20	0	\N
132966	1397	1340810215000	17086	8593	21	0	\N
132967	1397	1340800214000	17086	8593	22	0	\N
132968	1397	1340790213000	17086	8593	23	0	\N
132969	1397	1340780212000	17086	8593	24	0	\N
132970	1397	1340770211000	17086	8593	25	0	\N
132971	1397	1340760210000	17086	8593	26	0	\N
132972	1397	1340750209000	17086	8593	27	0	\N
132973	1397	1340740208000	17086	8593	28	0	\N
132974	1397	1340730207000	17086	8593	29	0	\N
132975	1397	1340720206000	17086	8593	30	0	\N
132976	1397	1340710205000	17086	8593	31	0	\N
132977	1397	1340700204000	17086	8593	32	0	\N
132978	1397	1340690203000	17086	8593	33	0	\N
132979	1397	1340680202000	17086	8593	34	0	\N
132980	1397	1340670201000	17086	8593	35	0	\N
132981	1397	1340660200000	17086	8593	36	0	\N
132982	1397	1340650199000	17086	8593	37	0	\N
132983	1397	1340640198000	17086	8593	38	0	\N
132984	1397	1340630197000	17086	8593	40	0	\N
132985	1397	1340620196000	17086	8593	41	0	\N
132986	1397	1340610195000	17086	8593	42	0	\N
132987	1397	1340600194000	17086	8593	43	0	\N
132988	2133	98077158000	17086	8593	44	0	\N
132989	497	66000011000000	17086	8593	45	0	\N
132990	2134	98116357000	17086	8593	46	0	\N
132991	2134	98115354000	17086	8593	47	0	\N
132992	2133	98076156000	17086	8593	48	0	\N
132993	2133	98075154000	17086	8593	49	0	\N
132994	2133	98074152000	17086	8593	50	0	\N
132995	2133	98073150000	17086	8593	51	0	\N
132996	2132	148735736000	17086	8593	52	0	\N
132997	2132	148734735000	17086	8593	53	0	\N
132998	2132	148733734000	17086	8593	54	0	\N
132999	2133	98072148000	17086	8593	55	0	\N
133000	2133	98071146000	17086	8593	56	0	\N
133001	2133	98070144000	17086	8593	57	0	\N
133002	2133	98069142000	17086	8593	58	0	\N
133003	2133	98068140000	17086	8593	59	0	\N
133004	2133	98067138000	17086	8593	60	0	\N
133005	2133	98066136000	17086	8593	61	0	\N
133006	2133	98065134000	17086	8593	62	0	\N
133007	2133	98064132000	17086	8593	63	0	\N
133008	2133	98063130000	17086	8593	64	0	\N
132875	1397	1340740208000	17069	8646	0	0	9809
132876	2133	98053110000	17069	8646	1	0	945
132877	2134	98091282000	17069	8646	2	0	906
132882	1397	1340730207000	17071	8647	0	0	9810
132883	2133	98052108000	17071	8647	1	0	946
132885	2132	148727728000	17071	8647	3	0	272
132893	1397	1340720206000	17075	8648	0	0	9811
132894	1397	1340710205000	17076	8649	0	0	9812
132895	2134	98089276000	17076	8649	1	0	908
132896	2134	98088273000	17076	8649	2	0	909
132902	1397	1340700204000	17078	8650	0	0	9813
132903	2133	98050104000	17078	8650	1	0	948
132904	2134	98087270000	17078	8650	2	0	910
132905	1397	1340690203000	17079	8651	0	0	9814
132907	1726	124125109000	17079	8651	2	0	8183
132908	2133	98049102000	17079	8651	3	0	949
132909	2134	98086267000	17079	8651	4	0	911
132910	2134	98085264000	17079	8651	5	0	912
132911	2133	98048100000	17079	8651	6	0	950
132913	1397	1340670201000	17080	8652	0	0	9816
132914	1397	1340660200000	17080	8652	1	0	9817
132915	1397	1340650199000	17080	8652	2	0	9818
132916	497	66000011000000	17080	8652	3	0	2
132917	2133	98047098000	17080	8652	4	0	951
132919	2133	98046096000	17080	8652	6	0	952
132920	2133	98045094000	17080	8652	7	0	953
132921	2134	98084261000	17080	8652	8	0	913
132922	2134	98083258000	17080	8652	9	0	914
132924	1598	1200008000000	17081	8653	0	0	2
132925	1397	1340640198000	17081	8653	1	0	9819
132926	2133	98044092000	17081	8653	2	0	954
132927	2134	98081252000	17081	8653	3	0	916
132932	1397	1340630197000	17083	8654	0	0	9820
132934	2132	148724725000	17083	8654	2	0	275
132935	2134	98080249000	17083	8654	3	0	917
132936	1397	1340620196000	17084	8655	0	0	9821
132937	2134	98079246000	17084	8655	1	0	918
132938	2133	98042088000	17084	8655	2	0	956
132940	1397	1340600194000	17085	8656	1	0	9823
132941	2134	98078243000	17085	8656	2	0	919
132942	2133	98041086000	17085	8656	3	0	957
132943	2133	98040084000	17085	8656	4	0	958
133009	2133	98062128000	17086	8593	65	0	\N
133010	2133	98061126000	17086	8593	66	0	\N
133011	2133	98060124000	17086	8593	67	0	\N
133012	2133	98059122000	17086	8593	68	0	\N
133013	2133	98058120000	17086	8593	69	0	\N
133014	2133	98057118000	17086	8593	70	0	\N
133015	2133	98056116000	17086	8593	71	0	\N
133016	2133	98055114000	17086	8593	72	0	\N
133017	2133	98054112000	17086	8593	73	0	\N
133018	2133	98053110000	17086	8593	74	0	\N
133019	2133	98052108000	17086	8593	75	0	\N
133020	2133	98051106000	17086	8593	76	0	\N
133021	2133	98050104000	17086	8593	77	0	\N
133022	2133	98049102000	17086	8593	78	0	\N
133023	2133	98048100000	17086	8593	79	0	\N
133024	2133	98047098000	17086	8593	80	0	\N
133025	2133	98046096000	17086	8593	81	0	\N
133026	2133	98045094000	17086	8593	82	0	\N
133027	2133	98044092000	17086	8593	83	0	\N
133028	2133	98043090000	17086	8593	84	0	\N
133029	2133	98042088000	17086	8593	85	0	\N
133030	2133	98041086000	17086	8593	86	0	\N
133031	2133	98040084000	17086	8593	87	0	\N
133032	2134	98114351000	17086	8593	88	0	\N
133033	2134	98113348000	17086	8593	89	0	\N
133034	2134	98112345000	17086	8593	90	0	\N
133035	2134	98111342000	17086	8593	91	0	\N
133036	2134	98110339000	17086	8593	92	0	\N
133037	2134	98109336000	17086	8593	93	0	\N
133038	2134	98108333000	17086	8593	94	0	\N
133039	2134	98107330000	17086	8593	95	0	\N
133040	2134	98106327000	17086	8593	96	0	\N
133041	2134	98105324000	17086	8593	97	0	\N
133042	2134	98104321000	17086	8593	98	0	\N
133043	2134	98103318000	17086	8593	99	0	\N
133044	2134	98102315000	17086	8593	100	0	\N
133045	2132	148732733000	17086	8593	101	0	\N
133046	2132	148731732000	17086	8593	102	0	\N
133047	2132	148730731000	17086	8593	103	0	\N
133048	2132	148729730000	17086	8593	104	0	\N
133049	2132	148728729000	17086	8593	105	0	\N
133050	2132	148727728000	17086	8593	106	0	\N
133051	2132	148726727000	17086	8593	107	0	\N
133052	2132	148725726000	17086	8593	108	0	\N
133053	2132	148724725000	17086	8593	109	0	\N
133054	2134	98101312000	17086	8593	110	0	\N
133055	2134	98100309000	17086	8593	111	0	\N
133056	2134	98099306000	17086	8593	112	0	\N
133057	2134	98098303000	17086	8593	113	0	\N
133058	2134	98097300000	17086	8593	114	0	\N
133059	2134	98096297000	17086	8593	115	0	\N
133060	2134	98095294000	17086	8593	116	0	\N
133061	2134	98094291000	17086	8593	117	0	\N
133062	2134	98093288000	17086	8593	118	0	\N
133063	2134	98092285000	17086	8593	119	0	\N
133064	2134	98091282000	17086	8593	120	0	\N
133065	2134	98090279000	17086	8593	121	0	\N
133066	2134	98089276000	17086	8593	122	0	\N
133067	2134	98088273000	17086	8593	123	0	\N
133068	2134	98087270000	17086	8593	124	0	\N
133069	2134	98086267000	17086	8593	125	0	\N
133079	1397	1340570191000	17090	8659	0	0	\N
133080	2134	98074231000	17090	8659	1	0	\N
133081	2133	98038080000	17090	8659	2	0	\N
133089	1397	1340530187000	17095	8663	0	0	\N
133090	1397	1340520186000	17095	8663	1	0	\N
133091	2133	98034072000	17095	8663	2	0	\N
133092	2133	98033070000	17095	8663	3	0	\N
133093	2132	148721722000	17095	8663	4	0	\N
133094	1397	1340530187000	17096	8663	0	0	\N
133095	1397	1340520186000	17096	8663	1	0	\N
133096	2133	98034072000	17096	8663	2	0	\N
133097	2133	98033070000	17096	8663	3	0	\N
133098	2132	148721722000	17096	8663	4	0	\N
133104	1397	1340590193000	17098	8594	0	0	\N
133105	1397	1340580192000	17098	8594	1	0	\N
133106	1397	1340570191000	17098	8594	2	0	\N
133107	1397	1340560190000	17098	8594	3	0	\N
133108	1397	1340550189000	17098	8594	4	0	\N
133109	1397	1340540188000	17098	8594	5	0	\N
133110	1397	1340530187000	17098	8594	6	0	\N
133111	1397	1340520186000	17098	8594	7	0	\N
133112	2133	98039082000	17098	8594	8	0	\N
133113	2134	98085264000	17098	8594	9	0	\N
133114	2133	98038080000	17098	8594	10	0	\N
133115	2134	98084261000	17098	8594	11	0	\N
133116	2134	98083258000	17098	8594	12	0	\N
133117	2134	98082255000	17098	8594	13	0	\N
133118	2134	98081252000	17098	8594	14	0	\N
133119	2133	98037078000	17098	8594	15	0	\N
133120	2134	98080249000	17098	8594	16	0	\N
133121	2134	98079246000	17098	8594	17	0	\N
133122	2134	98078243000	17098	8594	18	0	\N
133123	2132	148723724000	17098	8594	19	0	\N
133124	2132	148722723000	17098	8594	20	0	\N
133125	2133	98036076000	17098	8594	21	0	\N
133126	2133	98035074000	17098	8594	22	0	\N
133127	2133	98034072000	17098	8594	23	0	\N
133128	2133	98033070000	17098	8594	24	0	\N
133129	2132	148721722000	17098	8594	25	0	\N
133130	2134	98077240000	17098	8594	26	0	\N
133131	2134	98076237000	17098	8594	27	0	\N
133132	2134	98075234000	17098	8594	28	0	\N
133133	2134	98074231000	17098	8594	29	0	\N
133134	1397	1340510185000	17100	8664	0	0	\N
133135	2133	98032068000	17100	8664	1	0	\N
133136	1598	1200008000000	17101	8618	0	0	\N
133137	1726	125335109000	17101	8618	1	0	\N
133138	1726	124125109000	17101	8618	2	0	\N
133139	497	66000011000000	17101	8618	3	0	\N
133144	1397	1340510185000	17103	8665	0	0	\N
133072	2132	148723724000	17087	8657	2	0	276
133073	1397	1340580192000	17088	8658	0	0	9825
133074	2133	98039082000	17088	8658	1	0	959
133075	2134	98075234000	17088	8658	2	0	922
133076	1397	1340570191000	17089	8659	0	0	9826
133078	2133	98038080000	17089	8659	2	0	960
133082	1397	1340560190000	17091	8660	0	0	9827
133083	2132	148722723000	17091	8660	1	0	277
133084	2133	98037078000	17091	8660	2	0	961
133085	1397	1340550189000	17093	8661	0	0	9828
133087	1397	1340540188000	17094	8662	0	0	9829
133088	2133	98035074000	17094	8662	1	0	963
133099	1397	1340530187000	17097	8663	0	0	9830
133100	1397	1340520186000	17097	8663	1	0	9831
133102	2133	98033070000	17097	8663	3	0	965
133103	2132	148721722000	17097	8663	4	0	278
133140	1397	1340510185000	17102	8665	0	0	9832
133141	1397	1340500184000	17102	8665	1	0	9833
133142	2133	98032068000	17102	8665	2	0	966
133145	1397	1340500184000	17103	8665	1	0	\N
133146	2133	98032068000	17103	8665	2	0	\N
133147	2133	98031066000	17103	8665	3	0	\N
133148	1397	1340490183000	17104	8666	0	0	\N
133149	2132	148720721000	17104	8666	1	0	\N
133150	2133	98030064000	17104	8666	2	0	\N
133156	1397	1340470181000	17107	8668	0	0	\N
133157	2133	98028060000	17107	8668	1	0	\N
133164	2133	98027058000	17110	8669	0	0	\N
133165	2132	148719720000	17110	8669	1	0	\N
133166	1749	4885269930000	17110	8669	2	0	\N
133169	1397	1340440178000	17112	8671	0	0	\N
133170	2133	98025054000	17112	8671	1	0	\N
133171	1397	1340440178000	17113	8671	0	0	\N
133172	2133	98025054000	17113	8671	1	0	\N
133175	1598	1200008000000	17115	8648	0	0	\N
133176	1397	1340720206000	17115	8648	1	0	\N
133177	1397	1340710205000	17115	8648	2	0	\N
133178	1397	1340700204000	17115	8648	3	0	\N
133179	1397	1340690203000	17115	8648	4	0	\N
133180	1397	1340680202000	17115	8648	5	0	\N
133181	1397	1340670201000	17115	8648	6	0	\N
133182	1397	1340660200000	17115	8648	7	0	\N
133183	1397	1340650199000	17115	8648	8	0	\N
133184	1397	1340640198000	17115	8648	9	0	\N
133185	1726	124125109000	17115	8648	10	0	\N
133186	1397	1340630197000	17115	8648	11	0	\N
133187	1397	1340620196000	17115	8648	12	0	\N
133188	1397	1340610195000	17115	8648	13	0	\N
133189	1397	1340600194000	17115	8648	14	0	\N
133190	1397	1340590193000	17115	8648	15	0	\N
133191	1397	1340580192000	17115	8648	16	0	\N
133192	1397	1340570191000	17115	8648	17	0	\N
133193	1397	1340560190000	17115	8648	18	0	\N
133194	1397	1340550189000	17115	8648	19	0	\N
133195	1397	1340540188000	17115	8648	20	0	\N
133196	1397	1340530187000	17115	8648	21	0	\N
133197	1397	1340520186000	17115	8648	22	0	\N
133198	1397	1340510185000	17115	8648	23	0	\N
133199	1397	1340500184000	17115	8648	24	0	\N
133200	1397	1340490183000	17115	8648	25	0	\N
133201	1397	1340480182000	17115	8648	26	0	\N
133202	1397	1340470181000	17115	8648	27	0	\N
133203	1397	1340460180000	17115	8648	28	0	\N
133204	1397	1340450179000	17115	8648	29	0	\N
133205	1397	1340440178000	17115	8648	30	0	\N
133206	497	66000011000000	17115	8648	31	0	\N
133207	2134	98089276000	17115	8648	32	0	\N
133208	2134	98088273000	17115	8648	33	0	\N
133209	2134	98087270000	17115	8648	34	0	\N
133210	2134	98086267000	17115	8648	35	0	\N
133211	2134	98085264000	17115	8648	36	0	\N
133212	1749	4885269930000	17115	8648	37	0	\N
133213	2133	98051106000	17115	8648	38	0	\N
133214	2133	98050104000	17115	8648	39	0	\N
133215	2133	98049102000	17115	8648	40	0	\N
133216	2133	98048100000	17115	8648	41	0	\N
133217	2133	98047098000	17115	8648	42	0	\N
133218	2133	98046096000	17115	8648	43	0	\N
133219	2133	98045094000	17115	8648	44	0	\N
133220	2133	98044092000	17115	8648	45	0	\N
133221	2133	98043090000	17115	8648	46	0	\N
133222	2133	98042088000	17115	8648	47	0	\N
133223	2133	98041086000	17115	8648	48	0	\N
133224	2133	98040084000	17115	8648	49	0	\N
133225	2133	98039082000	17115	8648	50	0	\N
133226	2133	98038080000	17115	8648	51	0	\N
133227	2134	98084261000	17115	8648	52	0	\N
133228	2134	98083258000	17115	8648	53	0	\N
133229	2134	98082255000	17115	8648	54	0	\N
133230	2134	98081252000	17115	8648	55	0	\N
133231	2132	148726727000	17115	8648	56	0	\N
133232	2132	148725726000	17115	8648	57	0	\N
133233	2132	148724725000	17115	8648	58	0	\N
133234	2133	98037078000	17115	8648	59	0	\N
133235	2134	98080249000	17115	8648	60	0	\N
133236	2134	98079246000	17115	8648	61	0	\N
133237	2134	98078243000	17115	8648	62	0	\N
133238	2132	148723724000	17115	8648	63	0	\N
133239	2132	148722723000	17115	8648	64	0	\N
133240	2133	98036076000	17115	8648	65	0	\N
133241	2133	98035074000	17115	8648	66	0	\N
133242	2133	98034072000	17115	8648	67	0	\N
133243	2133	98033070000	17115	8648	68	0	\N
133244	2133	98032068000	17115	8648	69	0	\N
133245	2133	98031066000	17115	8648	70	0	\N
133246	2132	148721722000	17115	8648	71	0	\N
133247	2132	148720721000	17115	8648	72	0	\N
133248	2132	148719720000	17115	8648	73	0	\N
133249	2133	98030064000	17115	8648	74	0	\N
133250	2133	98029062000	17115	8648	75	0	\N
133251	2133	98028060000	17115	8648	76	0	\N
133252	2133	98027058000	17115	8648	77	0	\N
133253	2133	98026056000	17115	8648	78	0	\N
133254	2133	98025054000	17115	8648	79	0	\N
133255	2134	98077240000	17115	8648	80	0	\N
133256	2134	98076237000	17115	8648	81	0	\N
133257	2134	98075234000	17115	8648	82	0	\N
133258	2134	98074231000	17115	8648	83	0	\N
133262	1397	1340420176000	17118	8673	0	0	\N
133263	2133	98023050000	17118	8673	1	0	\N
133271	1397	1340390173000	17122	8676	0	0	\N
133272	2133	98020044000	17122	8676	1	0	\N
133277	1397	1340380172000	17125	8677	0	0	\N
133278	2133	98019042000	17125	8677	1	0	\N
133153	2133	98030064000	17105	8666	2	0	968
133154	1397	1340480182000	17106	8667	0	0	9835
133155	2133	98029062000	17106	8667	1	0	969
133158	1397	1340470181000	17108	8668	0	0	9836
133159	2133	98028060000	17108	8668	1	0	970
133161	2133	98027058000	17109	8669	1	0	971
133162	2132	148719720000	17109	8669	2	0	280
133163	1749	4885269930000	17109	8669	3	0	18
133167	1397	1340450179000	17111	8670	0	0	9838
133168	2133	98026056000	17111	8670	1	0	972
133174	2133	98025054000	17114	8671	1	0	973
133259	1397	1340430177000	17117	8672	0	0	9840
133260	2133	98024052000	17117	8672	1	0	974
133261	2132	148718719000	17117	8672	2	0	281
133265	2133	98023050000	17119	8673	1	0	975
133266	1397	1340410175000	17120	8674	0	0	9842
133267	2133	98022048000	17120	8674	1	0	976
133268	1397	1340400174000	17121	8675	0	0	9843
133269	2133	98021046000	17121	8675	1	0	977
133273	1397	1340390173000	17123	8676	0	0	9844
133274	2133	98020044000	17123	8676	1	0	978
133275	1397	1340380172000	17124	8677	0	0	9845
133276	2133	98019042000	17124	8677	1	0	979
133279	1397	1340370171000	17126	8678	0	0	9846
133282	1397	1340510185000	17127	8595	0	0	\N
133283	1397	1340500184000	17127	8595	1	0	\N
133284	1397	1340490183000	17127	8595	2	0	\N
133285	1397	1340480182000	17127	8595	3	0	\N
133286	1397	1340470181000	17127	8595	4	0	\N
133287	1397	1340460180000	17127	8595	5	0	\N
133288	1397	1340450179000	17127	8595	6	0	\N
133289	1397	1340440178000	17127	8595	8	0	\N
133290	1397	1340430177000	17127	8595	9	0	\N
133291	1397	1340420176000	17127	8595	10	0	\N
133292	1397	1340410175000	17127	8595	11	0	\N
133293	1397	1340400174000	17127	8595	12	0	\N
133294	1397	1340390173000	17127	8595	13	0	\N
133295	1397	1340380172000	17127	8595	14	0	\N
133296	1397	1340370171000	17127	8595	15	0	\N
133297	2133	98032068000	17127	8595	16	0	\N
133298	2133	98031066000	17127	8595	17	0	\N
133299	1749	4885269930000	17127	8595	18	0	\N
133300	2132	148720721000	17127	8595	19	0	\N
133301	2132	148719720000	17127	8595	20	0	\N
133302	2132	148718719000	17127	8595	21	0	\N
133303	2132	148717718000	17127	8595	22	0	\N
133304	2132	148716717000	17127	8595	23	0	\N
133305	2133	98030064000	17127	8595	24	0	\N
133306	2133	98029062000	17127	8595	25	0	\N
133307	2133	98028060000	17127	8595	26	0	\N
133308	2133	98027058000	17127	8595	27	0	\N
133309	2133	98026056000	17127	8595	28	0	\N
133310	2133	98025054000	17127	8595	29	0	\N
133311	2133	98024052000	17127	8595	30	0	\N
133312	2133	98023050000	17127	8595	31	0	\N
133313	2133	98022048000	17127	8595	32	0	\N
133314	2133	98021046000	17127	8595	33	0	\N
133315	2133	98020044000	17127	8595	34	0	\N
133316	2133	98019042000	17127	8595	35	0	\N
133321	1397	1340340168000	17130	8681	0	0	\N
133322	2132	148715716000	17130	8681	1	0	\N
133323	2133	98016036000	17130	8681	2	0	\N
133327	1397	1340340168000	17132	8681	0	0	\N
133328	2132	148715716000	17132	8681	1	0	\N
133329	2133	98016036000	17132	8681	2	0	\N
133330	1397	1340330167000	17133	8682	0	0	\N
133331	1397	1340320166000	17133	8682	1	0	\N
133332	2133	98015034000	17133	8682	2	0	\N
133333	2133	98014032000	17133	8682	3	0	\N
133340	1397	1340310165000	17136	8683	0	0	\N
133341	2133	98013030000	17136	8683	1	0	\N
133346	1397	1340290163000	17139	8685	0	0	\N
133347	2133	98012028000	17139	8685	1	0	\N
133364	1397	1340230157000	17143	8689	0	0	\N
133365	2133	98006016000	17143	8689	1	0	\N
133366	2134	98069216000	17143	8689	2	0	\N
133390	1397	1340170151000	17150	8694	0	0	\N
133391	2134	98063198000	17150	8694	1	0	\N
133392	2133	98001006000	17150	8694	2	0	\N
133393	2132	148711712000	17150	8694	3	0	\N
133394	1598	1200008000000	17151	8601	0	0	\N
133395	1726	126545109000	17151	8601	1	0	\N
133396	1397	1341290263000	17151	8601	2	0	\N
133397	1397	1341280262000	17151	8601	3	0	\N
133398	1726	125335109000	17151	8601	4	0	\N
133399	1726	124125109000	17151	8601	5	0	\N
133400	1726	124105109000	17151	8601	6	0	\N
133401	1726	122895109000	17151	8601	7	0	\N
133402	1726	121685109000	17151	8601	8	0	\N
133403	1397	1341270261000	17151	8601	9	0	\N
133404	1397	1341260260000	17151	8601	10	0	\N
133405	1397	1341250259000	17151	8601	11	0	\N
133406	1397	1341240258000	17151	8601	12	0	\N
133407	1397	1341230257000	17151	8601	13	0	\N
133408	1397	1341220256000	17151	8601	14	0	\N
133409	1397	1341210255000	17151	8601	15	0	\N
133410	1397	1341200254000	17151	8601	16	0	\N
133411	1397	1341190253000	17151	8601	17	0	\N
133412	1397	1341180252000	17151	8601	18	0	\N
133413	1397	1341170251000	17151	8601	19	0	\N
133414	1397	1341160250000	17151	8601	20	0	\N
133415	1397	1341150249000	17151	8601	21	0	\N
133416	1397	1341140248000	17151	8601	22	0	\N
133318	1726	124105109000	17129	8680	0	0	8184
133319	1397	1340350169000	17129	8680	1	0	9848
133320	2133	98017038000	17129	8680	2	0	981
133324	1397	1340340168000	17131	8681	0	0	9849
133325	2132	148715716000	17131	8681	1	0	284
133334	1397	1340330167000	17134	8682	0	0	9850
133335	1397	1340320166000	17134	8682	1	0	9851
133336	2133	98015034000	17134	8682	2	0	983
133337	2133	98014032000	17134	8682	3	0	984
133338	1397	1340310165000	17135	8683	0	0	9852
133342	1397	1340300164000	17137	8684	0	0	9853
133343	2132	148714715000	17137	8684	1	0	285
133344	1397	1340290163000	17138	8685	0	0	9854
133345	2133	98012028000	17138	8685	1	0	986
133349	1397	1340280162000	17140	8686	1	0	9855
133350	2133	98011026000	17140	8686	2	0	987
133351	1397	1340270161000	17141	8687	0	0	9856
133352	2132	148713714000	17141	8687	1	0	286
133353	2133	98010024000	17141	8687	2	0	988
133355	1397	1340260160000	17142	8688	0	0	9857
133356	1397	1340250159000	17142	8688	1	0	9858
133357	1397	1340240158000	17142	8688	2	0	9859
133358	2133	98009022000	17142	8688	3	0	989
133359	2133	98008020000	17142	8688	4	0	990
133361	2133	98007018000	17142	8688	6	0	991
133362	2134	98071222000	17142	8688	7	0	926
133363	2134	98070219000	17142	8688	8	0	927
133367	1397	1340230157000	17144	8689	0	0	9860
133369	2134	98069216000	17144	8689	2	0	928
133370	1397	1340220156000	17145	8690	0	0	9861
133371	2134	98068213000	17145	8690	1	0	929
133372	2133	98005014000	17145	8690	2	0	993
133373	1397	1340210155000	17147	8692	0	0	9862
133375	1726	121685109000	17147	8692	2	0	8186
133376	2132	148712713000	17147	8692	3	0	287
133377	2133	98004012000	17147	8692	4	0	994
133378	2133	98003010000	17147	8692	5	0	995
133379	2134	98067210000	17147	8692	6	0	930
133381	1397	1340190153000	17148	8693	0	0	9864
133382	1397	1340180152000	17148	8693	1	0	9865
133383	2134	98065204000	17148	8693	2	0	932
133384	2134	98064201000	17148	8693	3	0	933
133386	1397	1340170151000	17149	8694	0	0	9866
133387	2134	98063198000	17149	8694	1	0	934
133388	2133	98001006000	17149	8694	2	0	997
133389	2132	148711712000	17149	8694	3	0	288
133417	1397	1341130247000	17151	8601	23	0	\N
133418	1397	1341120246000	17151	8601	24	0	\N
133419	1397	1341110245000	17151	8601	25	0	\N
133420	1397	1341100244000	17151	8601	26	0	\N
133421	1397	1341090243000	17151	8601	27	0	\N
133422	1397	1341080242000	17151	8601	28	0	\N
133423	1397	1341070241000	17151	8601	29	0	\N
133424	1397	1341060240000	17151	8601	30	0	\N
133425	1397	1341050239000	17151	8601	31	0	\N
133426	1397	1341040238000	17151	8601	32	0	\N
133427	1397	1341030237000	17151	8601	33	0	\N
133428	1397	1341020236000	17151	8601	34	0	\N
133429	1397	1341010235000	17151	8601	35	0	\N
133430	1397	1341000234000	17151	8601	36	0	\N
133431	1397	1340990233000	17151	8601	37	0	\N
133432	1397	1340980232000	17151	8601	38	0	\N
133433	1397	1340970231000	17151	8601	39	0	\N
133434	1397	1340960230000	17151	8601	40	0	\N
133435	1397	1340950229000	17151	8601	41	0	\N
133436	1397	1340940228000	17151	8601	42	0	\N
133437	1397	1340930227000	17151	8601	43	0	\N
133438	1397	1340920226000	17151	8601	44	0	\N
133439	1397	1340910225000	17151	8601	45	0	\N
133440	1397	1340900224000	17151	8601	46	0	\N
133441	1397	1340890223000	17151	8601	47	0	\N
133442	1397	1340880222000	17151	8601	48	0	\N
133443	1397	1340870221000	17151	8601	49	0	\N
133444	1397	1340860220000	17151	8601	50	0	\N
133445	1397	1340850219000	17151	8601	51	0	\N
133446	1397	1340840218000	17151	8601	52	0	\N
133447	1397	1340830217000	17151	8601	53	0	\N
133448	1397	1340820216000	17151	8601	54	0	\N
133449	1397	1340810215000	17151	8601	55	0	\N
133450	1397	1340800214000	17151	8601	56	0	\N
133451	1397	1340790213000	17151	8601	57	0	\N
133452	1397	1340780212000	17151	8601	58	0	\N
133453	1397	1340770211000	17151	8601	59	0	\N
133454	1397	1340760210000	17151	8601	60	0	\N
133455	1397	1340750209000	17151	8601	61	0	\N
133456	1397	1340740208000	17151	8601	62	0	\N
133457	1397	1340730207000	17151	8601	63	0	\N
133458	1397	1340720206000	17151	8601	64	0	\N
133459	1397	1340710205000	17151	8601	65	0	\N
133460	1397	1340700204000	17151	8601	66	0	\N
133461	1397	1340690203000	17151	8601	67	0	\N
133462	1397	1340680202000	17151	8601	68	0	\N
133463	1397	1340670201000	17151	8601	69	0	\N
133464	1397	1340660200000	17151	8601	70	0	\N
133465	1397	1340650199000	17151	8601	71	0	\N
133466	1397	1340640198000	17151	8601	72	0	\N
133467	1397	1340630197000	17151	8601	73	0	\N
133468	1397	1340620196000	17151	8601	74	0	\N
133469	1397	1340610195000	17151	8601	75	0	\N
133470	1397	1340600194000	17151	8601	76	0	\N
133471	1397	1340590193000	17151	8601	77	0	\N
133472	1397	1340580192000	17151	8601	78	0	\N
133473	1397	1340570191000	17151	8601	79	0	\N
133474	1397	1340560190000	17151	8601	80	0	\N
133475	1397	1340550189000	17151	8601	81	0	\N
133476	1397	1340540188000	17151	8601	82	0	\N
133477	1397	1340530187000	17151	8601	83	0	\N
133478	1397	1340520186000	17151	8601	84	0	\N
133479	1397	1340510185000	17151	8601	85	0	\N
133480	1397	1340500184000	17151	8601	86	0	\N
133481	1397	1340490183000	17151	8601	87	0	\N
133482	1397	1340480182000	17151	8601	88	0	\N
133483	1397	1340470181000	17151	8601	89	0	\N
133484	1397	1340460180000	17151	8601	90	0	\N
133485	1397	1340450179000	17151	8601	91	0	\N
133486	1397	1340440178000	17151	8601	92	0	\N
133487	1397	1340430177000	17151	8601	93	0	\N
133488	1397	1340420176000	17151	8601	94	0	\N
133489	1397	1340410175000	17151	8601	95	0	\N
133490	1397	1340400174000	17151	8601	96	0	\N
133491	1397	1340390173000	17151	8601	97	0	\N
133492	1397	1340380172000	17151	8601	98	0	\N
133493	1397	1340370171000	17151	8601	99	0	\N
133494	1397	1340360170000	17151	8601	100	0	\N
133495	1397	1340350169000	17151	8601	102	0	\N
133496	1397	1340340168000	17151	8601	103	0	\N
133497	1397	1340330167000	17151	8601	104	0	\N
133498	1397	1340320166000	17151	8601	105	0	\N
133499	1397	1340310165000	17151	8601	106	0	\N
133500	1397	1340300164000	17151	8601	107	0	\N
133501	1397	1340290163000	17151	8601	108	0	\N
133502	1397	1340280162000	17151	8601	109	0	\N
133503	1397	1340270161000	17151	8601	110	0	\N
133504	1397	1340260160000	17151	8601	111	0	\N
133505	1397	1340250159000	17151	8601	112	0	\N
133506	1397	1340240158000	17151	8601	113	0	\N
133507	1397	1340230157000	17151	8601	114	0	\N
133508	1397	1340220156000	17151	8601	115	0	\N
133509	1397	1340210155000	17151	8601	116	0	\N
133510	1397	1340200154000	17151	8601	117	0	\N
133511	1397	1340190153000	17151	8601	118	0	\N
133512	1397	1340180152000	17151	8601	119	0	\N
133513	1397	1340170151000	17151	8601	120	0	\N
133514	497	66000011000000	17151	8601	121	0	\N
133515	1749	4885269930000	17151	8601	122	0	\N
133516	2132	148744745000	17151	8601	123	0	\N
133517	2132	148743744000	17151	8601	124	0	\N
133518	2132	148742743000	17151	8601	125	0	\N
133522	1397	1340150149000	17153	8696	0	0	\N
133523	1397	1340140148000	17153	8696	1	0	\N
133524	1474	12513412000023	17153	8696	2	0	\N
133525	2132	148710711000	17153	8696	3	0	\N
133526	2134	98061192000	17153	8696	4	0	\N
133527	2133	97999002000	17153	8696	5	0	\N
133528	2133	97998000000	17153	8696	6	0	\N
133529	2133	97996998000	17153	8696	7	0	\N
133530	2134	98060189000	17153	8696	8	0	\N
133531	2134	98059186000	17153	8696	9	0	\N
133542	1397	1340150149000	17155	8696	0	0	\N
133543	1397	1340140148000	17155	8696	1	0	\N
133544	1474	12513412000023	17155	8696	2	0	\N
133545	2132	148710711000	17155	8696	3	0	\N
133546	2134	98061192000	17155	8696	4	0	\N
133547	2133	97999002000	17155	8696	5	0	\N
133548	2133	97998000000	17155	8696	6	0	\N
133549	2133	97996998000	17155	8696	7	0	\N
133550	2134	98060189000	17155	8696	8	0	\N
133551	2134	98059186000	17155	8696	9	0	\N
133552	1397	1340150149000	17156	8696	0	0	\N
133521	2133	98000004000	17152	8695	2	0	998
133532	1397	1340150149000	17154	8696	0	0	9868
133533	1397	1340140148000	17154	8696	1	0	9869
133534	1474	12513412000023	17154	8696	2	0	15
133535	2132	148710711000	17154	8696	3	0	289
133537	2133	97999002000	17154	8696	5	0	999
133538	2133	97998000000	17154	8696	6	0	1000
133539	2133	97996998000	17154	8696	7	0	1001
133540	2134	98060189000	17154	8696	8	0	937
133541	2134	98059186000	17154	8696	9	0	938
133553	1397	1340140148000	17156	8696	1	0	\N
133554	1474	12513412000023	17156	8696	2	0	\N
133555	2132	148710711000	17156	8696	3	0	\N
133556	2134	98061192000	17156	8696	4	0	\N
133557	2133	97999002000	17156	8696	5	0	\N
133558	2133	97998000000	17156	8696	6	0	\N
133559	2133	97996998000	17156	8696	7	0	\N
133560	2134	98060189000	17156	8696	8	0	\N
133561	2134	98059186000	17156	8696	9	0	\N
133562	1598	1200008000000	17157	8627	0	0	\N
133563	1726	125335109000	17157	8627	1	0	\N
133564	1726	124125109000	17157	8627	2	0	\N
133565	1726	124105109000	17157	8627	3	0	\N
133566	1726	122895109000	17157	8627	4	0	\N
133567	1726	121685109000	17157	8627	5	0	\N
133568	1474	11793412000023	17157	8627	6	0	\N
133569	497	66000011000000	17157	8627	7	0	\N
133570	1749	4885269930000	17157	8627	8	0	\N
133578	188	66000900000000	17159	8697	0	0	\N
133579	1397	1340130147000	17159	8697	1	0	\N
133580	1397	1340120146000	17159	8697	2	0	\N
133581	2133	97995996000	17159	8697	3	0	\N
133582	2134	98058183000	17159	8697	4	0	\N
133583	2134	98057180000	17159	8697	5	0	\N
133584	2133	97994994000	17159	8697	6	0	\N
133585	188	66000900000000	17160	8697	0	0	\N
133586	1397	1340130147000	17160	8697	1	0	\N
133587	1397	1340120146000	17160	8697	2	0	\N
133588	2133	97995996000	17160	8697	3	0	\N
133589	2134	98058183000	17160	8697	4	0	\N
133590	2134	98057180000	17160	8697	5	0	\N
133591	2133	97994994000	17160	8697	6	0	\N
133592	188	66000900000000	17161	8697	0	0	\N
133593	1397	1340130147000	17161	8697	1	0	\N
133594	1397	1340120146000	17161	8697	2	0	\N
133595	2133	97995996000	17161	8697	3	0	\N
133596	2134	98058183000	17161	8697	4	0	\N
133597	2134	98057180000	17161	8697	5	0	\N
133598	2133	97994994000	17161	8697	6	0	\N
133619	1598	1200008000000	17166	8644	0	0	\N
133620	1726	124125109000	17166	8644	1	0	\N
133621	1726	124105109000	17166	8644	2	0	\N
133622	1726	122895109000	17166	8644	3	0	\N
133623	1726	121685109000	17166	8644	4	0	\N
133624	1474	11793412000023	17166	8644	5	0	\N
133625	1397	1340790213000	17166	8644	6	0	\N
133626	1397	1340780212000	17166	8644	7	0	\N
133627	1397	1340770211000	17166	8644	8	0	\N
133628	1397	1340760210000	17166	8644	9	0	\N
133629	1397	1340750209000	17166	8644	10	0	\N
133630	1397	1340740208000	17166	8644	11	0	\N
133631	1397	1340730207000	17166	8644	12	0	\N
133632	1397	1340720206000	17166	8644	13	0	\N
133633	1397	1340710205000	17166	8644	14	0	\N
133634	1397	1340700204000	17166	8644	15	0	\N
133635	1397	1340690203000	17166	8644	16	0	\N
133636	1397	1340680202000	17166	8644	17	0	\N
133637	1397	1340670201000	17166	8644	18	0	\N
133638	1397	1340660200000	17166	8644	19	0	\N
133639	1397	1340650199000	17166	8644	20	0	\N
133640	1397	1340640198000	17166	8644	21	0	\N
133641	1397	1340630197000	17166	8644	22	0	\N
133642	1397	1340620196000	17166	8644	23	0	\N
133643	1397	1340610195000	17166	8644	24	0	\N
133644	1397	1340600194000	17166	8644	25	0	\N
133645	1397	1340590193000	17166	8644	26	0	\N
133646	1397	1340580192000	17166	8644	27	0	\N
133647	1397	1340570191000	17166	8644	28	0	\N
133648	1397	1340560190000	17166	8644	29	0	\N
133649	1397	1340550189000	17166	8644	30	0	\N
133650	1397	1340540188000	17166	8644	31	0	\N
133651	1397	1340530187000	17166	8644	32	0	\N
133652	1397	1340520186000	17166	8644	33	0	\N
133653	1397	1340510185000	17166	8644	34	0	\N
133654	1397	1340500184000	17166	8644	35	0	\N
133655	1397	1340490183000	17166	8644	36	0	\N
133656	1397	1340480182000	17166	8644	37	0	\N
133657	1397	1340470181000	17166	8644	38	0	\N
133658	1397	1340460180000	17166	8644	39	0	\N
133659	1397	1340450179000	17166	8644	40	0	\N
133660	1397	1340440178000	17166	8644	41	0	\N
133661	1397	1340430177000	17166	8644	42	0	\N
133662	1397	1340420176000	17166	8644	43	0	\N
133663	1397	1340410175000	17166	8644	44	0	\N
133664	1397	1340400174000	17166	8644	45	0	\N
133665	1397	1340390173000	17166	8644	46	0	\N
133666	1397	1340380172000	17166	8644	47	0	\N
133667	1397	1340370171000	17166	8644	48	0	\N
133668	1397	1340360170000	17166	8644	49	0	\N
133669	1397	1340350169000	17166	8644	50	0	\N
133670	1397	1340340168000	17166	8644	51	0	\N
133671	1397	1340330167000	17166	8644	52	0	\N
133672	1397	1340320166000	17166	8644	53	0	\N
133673	1397	1340310165000	17166	8644	54	0	\N
133674	1397	1340300164000	17166	8644	55	0	\N
133675	1397	1340290163000	17166	8644	56	0	\N
133676	1397	1340280162000	17166	8644	57	0	\N
133677	1397	1340270161000	17166	8644	58	0	\N
133678	1397	1340260160000	17166	8644	59	0	\N
133679	1397	1340250159000	17166	8644	60	0	\N
133680	1397	1340240158000	17166	8644	61	0	\N
133681	1397	1340230157000	17166	8644	62	0	\N
133682	1397	1340220156000	17166	8644	63	0	\N
133683	1397	1340210155000	17166	8644	64	0	\N
133684	1397	1340200154000	17166	8644	65	0	\N
133685	1397	1340190153000	17166	8644	66	0	\N
133686	1397	1340180152000	17166	8644	67	0	\N
133687	1397	1340170151000	17166	8644	68	0	\N
133688	1397	1340160150000	17166	8644	69	0	\N
133573	1397	1340120146000	17158	8697	2	0	9871
133574	2133	97995996000	17158	8697	3	0	1002
133575	2134	98058183000	17158	8697	4	0	939
133576	2134	98057180000	17158	8697	5	0	940
133577	2133	97994994000	17158	8697	6	0	1003
133600	2134	98056177000	17162	8698	1	0	941
133601	2133	97993992000	17162	8698	2	0	1004
133602	2132	148709710000	17162	8698	3	0	290
133603	1397	1340100144000	17163	8699	0	0	9873
133604	1397	1340090143000	17163	8699	1	0	9874
133606	2134	98055174000	17163	8699	3	0	942
133607	2134	98054171000	17163	8699	4	0	943
133608	2134	98053168000	17163	8699	5	0	944
133609	2132	148708709000	17163	8699	6	0	291
133611	2133	97991988000	17163	8699	8	0	1006
133612	2133	97990986000	17163	8699	9	0	1007
133613	1397	1340070141000	17164	8700	0	0	9876
133614	2133	97989984000	17164	8700	1	0	1008
133615	2134	98052165000	17164	8700	2	0	945
133617	2133	97988982000	17165	8701	1	0	1009
133618	2134	98051162000	17165	8701	2	0	946
133689	1397	1340150149000	17166	8644	70	0	\N
133690	1397	1340140148000	17166	8644	71	0	\N
133691	1397	1340130147000	17166	8644	72	0	\N
133692	1397	1340120146000	17166	8644	73	0	\N
133693	1397	1340110145000	17166	8644	74	0	\N
133694	1397	1340100144000	17166	8644	75	0	\N
133695	1397	1340090143000	17166	8644	76	0	\N
133696	1397	1340080142000	17166	8644	77	0	\N
133697	1397	1340070141000	17166	8644	78	0	\N
133698	1397	1340060140000	17166	8644	79	0	\N
133699	1397	1340050139000	17166	8644	80	0	\N
133700	1397	1340040138000	17166	8644	81	0	\N
133701	497	66000011000000	17166	8644	82	0	\N
133702	2132	148728729000	17166	8644	83	0	\N
133703	2133	98058120000	17166	8644	84	0	\N
133704	1749	4885269930000	17166	8644	85	0	\N
133705	2133	98057118000	17166	8644	86	0	\N
133706	2133	98056116000	17166	8644	87	0	\N
133707	2133	98055114000	17166	8644	88	0	\N
133708	2133	98054112000	17166	8644	89	0	\N
133709	2133	98053110000	17166	8644	90	0	\N
133710	2133	98052108000	17166	8644	91	0	\N
133711	2133	98051106000	17166	8644	92	0	\N
133712	2133	98050104000	17166	8644	93	0	\N
133713	2133	98049102000	17166	8644	94	0	\N
133714	2133	98048100000	17166	8644	95	0	\N
133715	2133	98047098000	17166	8644	96	0	\N
133716	2133	98046096000	17166	8644	97	0	\N
133717	2133	98045094000	17166	8644	98	0	\N
133718	2133	98044092000	17166	8644	99	0	\N
133719	2133	98043090000	17166	8644	100	0	\N
133720	2133	98042088000	17166	8644	101	0	\N
133721	2133	98041086000	17166	8644	102	0	\N
133722	2133	98040084000	17166	8644	103	0	\N
133723	2133	98039082000	17166	8644	104	0	\N
133724	2133	98038080000	17166	8644	105	0	\N
133725	2134	98096297000	17166	8644	106	0	\N
133726	2134	98095294000	17166	8644	107	0	\N
133727	2134	98094291000	17166	8644	108	0	\N
133728	2134	98093288000	17166	8644	109	0	\N
133729	2134	98092285000	17166	8644	110	0	\N
133730	2134	98091282000	17166	8644	111	0	\N
133731	2134	98090279000	17166	8644	112	0	\N
133732	2134	98089276000	17166	8644	113	0	\N
133733	2134	98088273000	17166	8644	114	0	\N
133734	2134	98087270000	17166	8644	115	0	\N
133735	2134	98086267000	17166	8644	116	0	\N
133736	2134	98085264000	17166	8644	117	0	\N
133737	2134	98084261000	17166	8644	118	0	\N
133738	2134	98083258000	17166	8644	119	0	\N
133739	2134	98082255000	17166	8644	120	0	\N
133740	2134	98081252000	17166	8644	121	0	\N
133741	2133	98037078000	17166	8644	122	0	\N
133742	2134	98080249000	17166	8644	123	0	\N
133743	2134	98079246000	17166	8644	124	0	\N
133744	2134	98078243000	17166	8644	125	0	\N
133755	1397	1340050139000	17168	8702	0	0	\N
133756	1397	1340040138000	17168	8702	1	0	\N
133757	1397	1340030137000	17168	8702	2	0	\N
133758	2134	98050159000	17168	8702	3	0	\N
133759	2132	148707708000	17168	8702	4	0	\N
133760	2134	98049156000	17168	8702	5	0	\N
133761	2134	98048153000	17168	8702	6	0	\N
133762	2133	97987980000	17168	8702	7	0	\N
133763	2133	97986978000	17168	8702	8	0	\N
133764	2133	97985976000	17168	8702	9	0	\N
133765	1598	1200008000000	17169	8586	0	0	\N
133766	1726	127755109000	17169	8586	1	0	\N
133767	1726	126545109000	17169	8586	2	0	\N
133768	1726	125335109000	17169	8586	3	0	\N
133769	1726	124125109000	17169	8586	4	0	\N
133770	1726	124105109000	17169	8586	5	0	\N
133771	1726	122895109000	17169	8586	6	0	\N
133772	1726	121685109000	17169	8586	7	0	\N
133773	1474	11793412000023	17169	8586	8	0	\N
133774	497	66000011000000	17169	8586	9	0	\N
133775	1749	4885269930000	17169	8586	10	0	\N
133783	1397	1340000134000	17171	8704	0	0	\N
133784	2133	97982970000	17171	8704	1	0	\N
133785	2134	98045144000	17171	8704	2	0	\N
133792	1397	1339980132000	17174	8706	0	0	\N
133793	2134	98043138000	17174	8706	1	0	\N
133794	2132	148705706000	17174	8706	2	0	\N
133795	2133	97980966000	17174	8706	3	0	\N
133800	1397	1339980132000	17176	8706	0	0	\N
133801	2134	98043138000	17176	8706	1	0	\N
133802	2132	148705706000	17176	8706	2	0	\N
133803	2133	97980966000	17176	8706	3	0	\N
133804	1397	1339980132000	17177	8706	0	0	\N
133805	2134	98043138000	17177	8706	1	0	\N
133806	2132	148705706000	17177	8706	2	0	\N
133807	2133	97980966000	17177	8706	3	0	\N
133808	1397	1339970131000	17178	8707	0	0	\N
133809	2133	97979964000	17178	8707	1	0	\N
133810	2134	98042135000	17178	8707	2	0	\N
133820	1397	1339960130000	17181	8708	0	0	\N
133821	2142	2850001000000	17181	8708	1	0	\N
133822	2132	148704705000	17181	8708	2	0	\N
133823	2133	97978962000	17181	8708	3	0	\N
133824	2134	98041132000	17181	8708	4	0	\N
133747	1397	1340030137000	17167	8702	2	0	9880
133748	2134	98050159000	17167	8702	3	0	947
133749	2132	148707708000	17167	8702	4	0	292
133750	2134	98049156000	17167	8702	5	0	948
133751	2134	98048153000	17167	8702	6	0	949
133753	2133	97986978000	17167	8702	8	0	1011
133754	2133	97985976000	17167	8702	9	0	1012
133776	1397	1340020136000	17170	8703	0	0	9881
133777	1397	1340010135000	17170	8703	1	0	9882
133778	2132	148706707000	17170	8703	2	0	293
133780	2134	98047150000	17170	8703	4	0	950
133781	2134	98046147000	17170	8703	5	0	951
133782	2133	97983972000	17170	8703	6	0	1014
133786	1397	1340000134000	17172	8704	0	0	9883
133788	2134	98045144000	17172	8704	2	0	952
133789	1397	1339990133000	17173	8705	0	0	9884
133790	2134	98044141000	17173	8705	1	0	953
133791	2133	97981968000	17173	8705	2	0	1016
133796	1397	1339980132000	17175	8706	0	0	9885
133798	2132	148705706000	17175	8706	2	0	294
133799	2133	97980966000	17175	8706	3	0	1017
133811	1397	1339970131000	17179	8707	0	0	9886
133812	2133	97979964000	17179	8707	1	0	1018
133813	2134	98042135000	17179	8707	2	0	955
133815	2142	2850001000000	17180	8708	1	0	2
133816	2132	148704705000	17180	8708	2	0	295
133817	2133	97978962000	17180	8708	3	0	1019
133818	2134	98041132000	17180	8708	4	0	956
133825	2134	98040129000	17181	8708	5	0	\N
133826	1397	1339960130000	17182	8708	0	0	\N
133827	2142	2850001000000	17182	8708	1	0	\N
133828	2132	148704705000	17182	8708	2	0	\N
133829	2133	97978962000	17182	8708	3	0	\N
133830	2134	98041132000	17182	8708	4	0	\N
133831	2134	98040129000	17182	8708	5	0	\N
133832	2142	2850001000000	17183	8685	0	0	\N
133833	2142	2850001000000	17184	8696	0	0	\N
133834	2142	2850001000000	17185	8706	0	0	\N
133844	1397	1339950129000	17189	8710	0	0	\N
133845	1397	1339940128000	17189	8710	1	0	\N
133846	1397	1339930127000	17189	8710	2	0	\N
133847	2134	98039126000	17189	8710	3	0	\N
133848	2134	98038123000	17189	8710	4	0	\N
133849	2134	98037120000	17189	8710	5	0	\N
133850	2133	97977960000	17189	8710	6	0	\N
133851	2133	97976958000	17189	8710	7	0	\N
133852	2133	97975956000	17189	8710	8	0	\N
133863	2142	2850001000000	17193	8628	0	0	\N
133864	1397	1339890123000	17194	8714	0	0	\N
133865	2134	98033108000	17194	8714	1	0	\N
133866	2132	148702703000	17194	8714	2	0	\N
133867	2133	97971948000	17194	8714	3	0	\N
133872	1397	1339890123000	17196	8714	0	0	\N
133873	2132	148702703000	17196	8714	1	0	\N
133874	2133	97971948000	17196	8714	2	0	\N
133875	1397	1339890123000	17197	8714	0	0	\N
133876	2134	98033108000	17197	8714	1	0	\N
133877	2132	148702703000	17197	8714	2	0	\N
133878	2133	97971948000	17197	8714	3	0	\N
133891	1397	1339850119000	17201	8717	0	0	\N
133892	2134	98029096000	17201	8717	1	0	\N
133893	2133	97968942000	17201	8717	2	0	\N
133894	1397	1339850119000	17202	8717	0	0	\N
133895	2134	98029096000	17202	8717	1	0	\N
133896	2133	97968942000	17202	8717	2	0	\N
133900	1397	1339840118000	17204	8718	0	0	\N
133901	2134	98028093000	17204	8718	1	0	\N
133902	2133	97967940000	17204	8718	2	0	\N
133903	1598	1200008000000	17205	8524	0	0	\N
133904	1726	126545109000	17205	8524	1	0	\N
133905	1726	125335109000	17205	8524	2	0	\N
133906	1726	124125109000	17205	8524	3	0	\N
133907	1726	124105109000	17205	8524	4	0	\N
133908	1726	122895109000	17205	8524	5	0	\N
133909	1726	121685109000	17205	8524	6	0	\N
133910	1474	11793412000023	17205	8524	7	0	\N
133911	497	66000011000000	17205	8524	8	0	\N
133912	2142	2850001000000	17205	8524	9	0	\N
133913	1749	3445220000000	17205	8524	10	0	\N
133914	1397	1339840118000	17206	8718	0	0	\N
133915	2134	98028093000	17206	8718	1	0	\N
133916	2133	97967940000	17206	8718	2	0	\N
133917	1397	1339830117000	17207	8719	0	0	\N
133918	2134	98027090000	17207	8719	1	0	\N
133919	1397	1339830117000	17208	8719	0	0	\N
133920	2134	98027090000	17208	8719	1	0	\N
133921	2133	97966938000	17208	8719	2	0	\N
133925	1397	1339830117000	17210	8719	0	0	\N
133926	2134	98027090000	17210	8719	1	0	\N
133927	2133	97966938000	17210	8719	2	0	\N
133935	1397	1339800114000	17213	8722	0	0	\N
133936	2133	97963932000	17213	8722	1	0	\N
133937	2134	98024081000	17213	8722	2	0	\N
133938	1397	1339800114000	17214	8722	0	0	\N
133939	2133	97963932000	17214	8722	1	0	\N
133940	2134	98024081000	17214	8722	2	0	\N
133944	2133	97963932000	17216	8722	0	0	\N
133945	1397	1339790113000	17217	8723	0	0	\N
133946	1397	1339780112000	17217	8723	1	0	\N
133947	2132	148699700000	17217	8723	2	0	\N
133948	2134	98023078000	17217	8723	3	0	\N
133949	2133	97962930000	17217	8723	4	0	\N
133950	2133	97961928000	17217	8723	5	0	\N
133951	2134	98022075000	17217	8723	6	0	\N
133959	1397	1339790113000	17219	8723	0	0	\N
133960	1397	1339780112000	17219	8723	1	0	\N
133837	1397	1339930127000	17188	8710	2	0	9890
133838	2134	98039126000	17188	8710	3	0	958
133839	2134	98038123000	17188	8710	4	0	959
133840	2134	98037120000	17188	8710	5	0	960
133841	2133	97977960000	17188	8710	6	0	1020
133843	2133	97975956000	17188	8710	8	0	1022
133853	1397	1339920126000	17190	8711	0	0	9891
133854	2133	97974954000	17190	8711	1	0	1023
133855	2132	148703704000	17190	8711	2	0	296
133856	2134	98036117000	17190	8711	3	0	961
133858	2134	98035114000	17191	8712	1	0	962
133859	2133	97973952000	17191	8712	2	0	1024
133860	1397	1339900124000	17192	8713	0	0	9893
133861	2134	98034111000	17192	8713	1	0	963
133868	1397	1339890123000	17195	8714	0	0	9894
133869	2134	98033108000	17195	8714	1	0	964
133870	2132	148702703000	17195	8714	2	0	297
133871	2133	97971948000	17195	8714	3	0	1026
133879	1397	1339880122000	17198	8715	0	0	9895
133881	2133	97970946000	17198	8715	2	0	1027
133882	1397	1339870121000	17199	8716	0	0	9896
133883	1397	1339860120000	17199	8716	1	0	9897
133884	2133	97969944000	17199	8716	2	0	1028
133885	2134	98031102000	17199	8716	3	0	966
133887	2132	148701702000	17199	8716	5	0	298
133888	1397	1339850119000	17200	8717	0	0	9898
133889	2134	98029096000	17200	8717	1	0	968
133890	2133	97968942000	17200	8717	2	0	1029
133898	2134	98028093000	17203	8718	1	0	969
133899	2133	97967940000	17203	8718	2	0	1030
133922	1397	1339830117000	17209	8719	0	0	9900
133923	2134	98027090000	17209	8719	1	0	970
133924	2133	97966938000	17209	8719	2	0	1031
133929	2133	97965936000	17211	8720	1	0	1032
133930	2132	148700701000	17211	8720	2	0	299
133931	2134	98026087000	17211	8720	3	0	971
133932	1397	1339810115000	17212	8721	0	0	9902
133933	2134	98025084000	17212	8721	1	0	972
133941	1397	1339800114000	17215	8722	0	0	9903
133942	2133	97963932000	17215	8722	1	0	1034
133943	2134	98024081000	17215	8722	2	0	973
133952	1397	1339790113000	17218	8723	0	0	9904
133954	2132	148699700000	17218	8723	2	0	300
133955	2134	98023078000	17218	8723	3	0	974
133956	2133	97962930000	17218	8723	4	0	1035
133957	2133	97961928000	17218	8723	5	0	1036
133958	2134	98022075000	17218	8723	6	0	975
133961	2132	148699700000	17219	8723	2	0	\N
133962	2134	98023078000	17219	8723	3	0	\N
133963	2133	97962930000	17219	8723	4	0	\N
133964	2133	97961928000	17219	8723	5	0	\N
133965	2134	98022075000	17219	8723	6	0	\N
133975	1397	1339750109000	17223	8725	0	0	\N
133976	2133	97959924000	17223	8725	1	0	\N
133977	2134	98019066000	17223	8725	2	0	\N
133978	1397	1339750109000	17224	8725	0	0	\N
133979	2133	97959924000	17224	8725	1	0	\N
133980	2134	98019066000	17224	8725	2	0	\N
133991	1397	1339710105000	17228	8729	0	0	\N
133992	1397	1339700104000	17228	8729	1	0	\N
133993	2133	97955916000	17228	8729	2	0	\N
133994	2133	97954914000	17228	8729	3	0	\N
133995	2134	98015054000	17228	8729	4	0	\N
133996	2134	98014051000	17228	8729	5	0	\N
134003	1397	1339690103000	17230	8730	0	0	\N
134004	1397	1339680102000	17230	8730	1	0	\N
134005	2133	97953912000	17230	8730	3	0	\N
134006	2133	97952910000	17230	8730	4	0	\N
134007	2134	98013048000	17230	8730	5	0	\N
134008	2132	148696697000	17230	8730	6	0	\N
134009	2134	98012045000	17230	8730	7	0	\N
134017	1397	1339690103000	17232	8730	0	0	\N
134018	1397	1339680102000	17232	8730	1	0	\N
134019	2133	97953912000	17232	8730	3	0	\N
134020	2133	97952910000	17232	8730	4	0	\N
134021	2134	98013048000	17232	8730	5	0	\N
134022	2132	148696697000	17232	8730	6	0	\N
134023	2134	98012045000	17232	8730	7	0	\N
134024	1397	1339690103000	17233	8730	0	0	\N
134025	1397	1339680102000	17233	8730	1	0	\N
134026	2133	97953912000	17233	8730	3	0	\N
134027	2133	97952910000	17233	8730	4	0	\N
134028	2134	98013048000	17233	8730	5	0	\N
134029	2132	148696697000	17233	8730	6	0	\N
134030	2134	98012045000	17233	8730	7	0	\N
134041	1397	1339650099000	17236	8732	0	0	\N
134042	2134	98009036000	17236	8732	1	0	\N
134043	2133	97949904000	17236	8732	2	0	\N
134044	1397	1339640098000	17237	8733	0	0	\N
134045	2134	98008033000	17237	8733	1	0	\N
134055	1397	1339630097000	17241	8734	0	0	\N
134056	1397	1339620096000	17241	8734	1	0	\N
134057	2134	98007030000	17241	8734	2	0	\N
134058	2132	148694695000	17241	8734	3	0	\N
134059	2133	97948902000	17241	8734	4	0	\N
134060	2133	97947900000	17241	8734	5	0	\N
134061	2134	98006027000	17241	8734	6	0	\N
134062	1397	1339630097000	17242	8734	0	0	\N
134063	1397	1339620096000	17242	8734	1	0	\N
134064	2134	98007030000	17242	8734	2	0	\N
134065	2132	148694695000	17242	8734	3	0	\N
134066	2133	97948902000	17242	8734	4	0	\N
134067	2133	97947900000	17242	8734	5	0	\N
134068	2134	98006027000	17242	8734	6	0	\N
134072	1397	1339610095000	17244	8735	0	0	\N
134073	2134	98005024000	17244	8735	1	0	\N
134074	2133	97946898000	17244	8735	2	0	\N
134075	1397	1339610095000	17245	8735	0	0	\N
134076	2134	98005024000	17245	8735	1	0	\N
134077	2133	97946898000	17245	8735	2	0	\N
134080	2142	2850001000000	17247	8703	0	0	\N
134081	1598	1200008000000	17248	8624	0	0	\N
134082	1397	1341000234000	17248	8624	1	0	\N
134083	1397	1340990233000	17248	8624	2	0	\N
134084	1397	1340980232000	17248	8624	3	0	\N
134085	1726	125335109000	17248	8624	4	0	\N
134086	1397	1340970231000	17248	8624	5	0	\N
134087	1397	1340960230000	17248	8624	6	0	\N
134088	1397	1340950229000	17248	8624	7	0	\N
134089	1397	1340940228000	17248	8624	8	0	\N
134090	1397	1340930227000	17248	8624	9	0	\N
134091	1397	1340920226000	17248	8624	10	0	\N
134092	1397	1340910225000	17248	8624	11	0	\N
134093	1397	1340900224000	17248	8624	12	0	\N
134094	1397	1340890223000	17248	8624	13	0	\N
134095	1397	1340880222000	17248	8624	14	0	\N
134096	1726	124125109000	17248	8624	15	0	\N
133968	2133	97960926000	17220	8724	2	0	1037
133969	2132	148698699000	17220	8724	3	0	301
133970	2134	98021072000	17220	8724	4	0	976
133971	2134	98020069000	17220	8724	5	0	977
133972	1397	1339750109000	17222	8725	0	0	9908
133974	2134	98019066000	17222	8725	2	0	978
133981	1397	1339740108000	17225	8726	0	0	9909
133982	2133	97958922000	17225	8726	1	0	1039
133983	2134	98018063000	17225	8726	2	0	979
133984	1397	1339730107000	17226	8727	0	0	9910
133986	2133	97957920000	17226	8727	2	0	1040
133987	1397	1339720106000	17227	8728	0	0	9911
133988	2133	97956918000	17227	8728	1	0	1041
133989	2132	148697698000	17227	8728	2	0	302
133997	1397	1339710105000	17229	8729	0	0	9912
133998	1397	1339700104000	17229	8729	1	0	9913
133999	2133	97955916000	17229	8729	2	0	1042
134000	2133	97954914000	17229	8729	3	0	1043
134001	2134	98015054000	17229	8729	4	0	982
134010	1397	1339690103000	17231	8730	0	0	9914
134011	1397	1339680102000	17231	8730	1	0	9915
134012	2133	97953912000	17231	8730	3	0	1044
134013	2133	97952910000	17231	8730	4	0	1045
134014	2134	98013048000	17231	8730	5	0	984
134016	2134	98012045000	17231	8730	7	0	985
134031	1397	1339670101000	17234	8731	0	0	9916
134032	1397	1339660100000	17234	8731	1	0	9917
134033	2134	98011042000	17234	8731	2	0	986
134035	2132	148695696000	17234	8731	4	0	304
134036	2133	97951908000	17234	8731	5	0	1046
134037	2133	97950906000	17234	8731	6	0	1047
134038	1397	1339650099000	17235	8732	0	0	9918
134039	2134	98009036000	17235	8732	1	0	988
134046	1397	1339640098000	17238	8733	0	0	9919
134047	2134	98008033000	17238	8733	1	0	989
134048	1397	1339630097000	17240	8734	0	0	9920
134049	1397	1339620096000	17240	8734	1	0	9921
134050	2134	98007030000	17240	8734	2	0	990
134052	2133	97948902000	17240	8734	4	0	1049
134053	2133	97947900000	17240	8734	5	0	1050
134054	2134	98006027000	17240	8734	6	0	991
134069	1397	1339610095000	17243	8735	0	0	9922
134071	2133	97946898000	17243	8735	2	0	1051
134078	2134	98004021000	17246	8736	0	0	993
134079	2133	97945896000	17246	8736	1	0	1052
134097	1726	124105109000	17248	8624	16	0	\N
134098	1726	122895109000	17248	8624	17	0	\N
134099	1726	121685109000	17248	8624	18	0	\N
134100	1474	11793412000023	17248	8624	19	0	\N
134101	1397	1340870221000	17248	8624	20	0	\N
134102	1397	1340860220000	17248	8624	21	0	\N
134103	1397	1340850219000	17248	8624	22	0	\N
134104	1397	1340840218000	17248	8624	23	0	\N
134105	1397	1340830217000	17248	8624	24	0	\N
134106	1397	1340820216000	17248	8624	25	0	\N
134107	1397	1340810215000	17248	8624	26	0	\N
134108	1397	1340800214000	17248	8624	27	0	\N
134109	1397	1340790213000	17248	8624	28	0	\N
134110	1397	1340780212000	17248	8624	29	0	\N
134111	1397	1340770211000	17248	8624	30	0	\N
134112	1397	1340760210000	17248	8624	31	0	\N
134113	1397	1340750209000	17248	8624	32	0	\N
134114	1397	1340740208000	17248	8624	33	0	\N
134115	1397	1340730207000	17248	8624	34	0	\N
134116	1397	1340720206000	17248	8624	35	0	\N
134117	1397	1340710205000	17248	8624	36	0	\N
134118	1397	1340700204000	17248	8624	37	0	\N
134119	1397	1340690203000	17248	8624	38	0	\N
134120	1397	1340680202000	17248	8624	39	0	\N
134121	1397	1340670201000	17248	8624	40	0	\N
134122	1397	1340660200000	17248	8624	41	0	\N
134123	1397	1340650199000	17248	8624	42	0	\N
134124	1397	1340640198000	17248	8624	43	0	\N
134125	1397	1340630197000	17248	8624	44	0	\N
134126	1397	1340620196000	17248	8624	45	0	\N
134127	1397	1340610195000	17248	8624	46	0	\N
134128	1397	1340600194000	17248	8624	47	0	\N
134129	1397	1340590193000	17248	8624	48	0	\N
134130	1397	1340580192000	17248	8624	49	0	\N
134131	1397	1340570191000	17248	8624	50	0	\N
134132	1397	1340560190000	17248	8624	51	0	\N
134133	1397	1340550189000	17248	8624	52	0	\N
134134	1397	1340540188000	17248	8624	53	0	\N
134135	1397	1340530187000	17248	8624	54	0	\N
134136	1397	1340520186000	17248	8624	55	0	\N
134137	1397	1340510185000	17248	8624	56	0	\N
134138	1397	1340500184000	17248	8624	57	0	\N
134139	1397	1340490183000	17248	8624	58	0	\N
134140	1397	1340480182000	17248	8624	59	0	\N
134141	1397	1340470181000	17248	8624	60	0	\N
134142	1397	1340460180000	17248	8624	61	0	\N
134143	1397	1340450179000	17248	8624	62	0	\N
134144	1397	1340440178000	17248	8624	63	0	\N
134145	1397	1340430177000	17248	8624	64	0	\N
134146	1397	1340420176000	17248	8624	65	0	\N
134147	1397	1340410175000	17248	8624	66	0	\N
134148	1397	1340400174000	17248	8624	67	0	\N
134149	1397	1340390173000	17248	8624	68	0	\N
134150	1397	1340380172000	17248	8624	69	0	\N
134151	1397	1340370171000	17248	8624	70	0	\N
134152	1397	1340360170000	17248	8624	71	0	\N
134153	1397	1340350169000	17248	8624	72	0	\N
134154	1397	1340340168000	17248	8624	73	0	\N
134155	1397	1340330167000	17248	8624	74	0	\N
134156	1397	1340320166000	17248	8624	75	0	\N
134157	1397	1340310165000	17248	8624	76	0	\N
134158	1397	1340300164000	17248	8624	77	0	\N
134159	1397	1340290163000	17248	8624	78	0	\N
134160	1397	1340280162000	17248	8624	79	0	\N
134161	1397	1340270161000	17248	8624	80	0	\N
134162	1397	1340260160000	17248	8624	81	0	\N
134163	1397	1340250159000	17248	8624	82	0	\N
134164	1397	1340240158000	17248	8624	83	0	\N
134165	1397	1340230157000	17248	8624	84	0	\N
134166	1397	1340220156000	17248	8624	85	0	\N
134167	1397	1340210155000	17248	8624	86	0	\N
134168	1397	1340200154000	17248	8624	87	0	\N
134169	1397	1340190153000	17248	8624	88	0	\N
134170	1397	1340180152000	17248	8624	89	0	\N
134171	1397	1340170151000	17248	8624	90	0	\N
134172	1397	1340160150000	17248	8624	91	0	\N
134173	1397	1340150149000	17248	8624	92	0	\N
134174	1397	1340140148000	17248	8624	93	0	\N
134175	1397	1340130147000	17248	8624	94	0	\N
134176	1397	1340120146000	17248	8624	95	0	\N
134177	1397	1340110145000	17248	8624	96	0	\N
134178	1397	1340100144000	17248	8624	97	0	\N
134179	1397	1340090143000	17248	8624	98	0	\N
134180	1397	1340080142000	17248	8624	99	0	\N
134181	1397	1340070141000	17248	8624	100	0	\N
134182	1397	1340060140000	17248	8624	101	0	\N
134183	1397	1340050139000	17248	8624	102	0	\N
134184	1397	1340040138000	17248	8624	103	0	\N
134185	1397	1340030137000	17248	8624	104	0	\N
134186	1397	1340020136000	17248	8624	105	0	\N
134187	1397	1340010135000	17248	8624	107	0	\N
134188	1397	1340000134000	17248	8624	108	0	\N
134189	1397	1339990133000	17248	8624	109	0	\N
134190	1397	1339980132000	17248	8624	110	0	\N
134191	1397	1339970131000	17248	8624	111	0	\N
134192	1397	1339960130000	17248	8624	112	0	\N
134193	1397	1339950129000	17248	8624	113	0	\N
134194	1397	1339940128000	17248	8624	114	0	\N
134195	1397	1339930127000	17248	8624	115	0	\N
134196	1397	1339920126000	17248	8624	116	0	\N
134197	1397	1339910125000	17248	8624	117	0	\N
134198	1397	1339900124000	17248	8624	118	0	\N
134199	1397	1339890123000	17248	8624	119	0	\N
134200	1397	1339880122000	17248	8624	120	0	\N
134201	1397	1339870121000	17248	8624	121	0	\N
134202	1397	1339860120000	17248	8624	122	0	\N
134203	1397	1339850119000	17248	8624	123	0	\N
134204	1397	1339840118000	17248	8624	124	0	\N
134205	1397	1339830117000	17248	8624	125	0	\N
134212	1397	1339580092000	17250	8738	0	0	\N
134213	2133	97942890000	17250	8738	1	0	\N
134214	2134	98001012000	17250	8738	2	0	\N
134218	1397	1339570091000	17252	8739	0	0	\N
134219	1397	1339560090000	17252	8739	1	0	\N
134220	2133	97941888000	17252	8739	2	0	\N
134221	2134	98000009000	17252	8739	3	0	\N
134222	2134	97999006000	17252	8739	4	0	\N
134223	2133	97940886000	17252	8739	5	0	\N
134230	1397	1339570091000	17254	8739	0	0	\N
134231	1397	1339560090000	17254	8739	1	0	\N
134232	2133	97941888000	17254	8739	2	0	\N
134208	2133	97944894000	17249	8737	2	0	1053
134209	2133	97943892000	17249	8737	3	0	1054
134210	2134	98003018000	17249	8737	4	0	994
134211	2134	98002015000	17249	8737	5	0	995
134215	1397	1339580092000	17251	8738	0	0	9925
134217	2134	98001012000	17251	8738	2	0	996
134224	1397	1339570091000	17253	8739	0	0	9926
134225	1397	1339560090000	17253	8739	1	0	9927
134226	2133	97941888000	17253	8739	2	0	1056
134227	2134	98000009000	17253	8739	3	0	997
134229	2133	97940886000	17253	8739	5	0	1057
134233	2134	98000009000	17254	8739	3	0	\N
134234	2134	97999006000	17254	8739	4	0	\N
134235	2133	97940886000	17254	8739	5	0	\N
134236	1397	1339550089000	17255	8740	0	0	\N
134237	2133	97939884000	17255	8740	1	0	\N
134238	2134	97998003000	17255	8740	2	0	\N
134239	1397	1339550089000	17256	8740	0	0	\N
134240	2133	97939884000	17256	8740	1	0	\N
134241	2134	97998003000	17256	8740	2	0	\N
134243	1397	1339550089000	17258	8741	0	0	\N
134244	1397	1339540088000	17258	8741	1	0	\N
134245	2134	97997000000	17258	8741	2	0	\N
134246	2133	97939884000	17258	8741	3	0	\N
134247	2133	97938882000	17258	8741	4	0	\N
134268	1397	1339490083000	17266	8745	0	0	\N
134269	2133	97933872000	17266	8745	1	0	\N
134270	2134	97991985000	17266	8745	2	0	\N
134284	1397	1339440078000	17275	8750	0	0	\N
134285	2134	97987973000	17275	8750	1	0	\N
134286	2133	97929864000	17275	8750	2	0	\N
134290	1397	1339420076000	17278	8752	0	0	\N
134291	2133	97927860000	17278	8752	1	0	\N
134292	2134	97985967000	17278	8752	3	0	\N
134293	1397	1339420076000	17279	8752	0	0	\N
134294	2133	97927860000	17279	8752	1	0	\N
134295	2134	97985967000	17279	8752	3	0	\N
134296	1397	1339420076000	17280	8752	0	0	\N
134297	2133	97927860000	17280	8752	1	0	\N
134298	2134	97985967000	17280	8752	3	0	\N
134302	1397	1339420076000	17282	8752	0	0	\N
134303	2133	97927860000	17282	8752	1	0	\N
134304	2134	97985967000	17282	8752	3	0	\N
134314	1397	1339400074000	17285	8754	0	0	\N
134315	1397	1339390073000	17285	8754	1	0	\N
134316	2134	97983961000	17285	8754	2	0	\N
134317	2134	97982958000	17285	8754	3	0	\N
134318	2133	97925856000	17285	8754	4	0	\N
134319	2133	97924854000	17285	8754	5	0	\N
134320	1397	1339400074000	17286	8754	0	0	\N
134321	1397	1339390073000	17286	8754	1	0	\N
134322	2134	97983961000	17286	8754	2	0	\N
134323	2134	97982958000	17286	8754	3	0	\N
134324	2133	97925856000	17286	8754	4	0	\N
134325	2133	97924854000	17286	8754	5	0	\N
134345	1397	1339320066000	17291	8758	0	0	\N
134346	2134	97975937000	17291	8758	1	0	\N
134347	1397	1339320066000	17292	8758	0	0	\N
134348	2134	97975937000	17292	8758	1	0	\N
134353	1397	1339300064000	17295	8760	0	0	\N
134354	1397	1339290063000	17295	8760	1	0	\N
134355	1397	1339280062000	17295	8760	2	0	\N
134356	2133	97916838000	17295	8760	3	0	\N
134357	2134	97973931000	17295	8760	4	0	\N
134358	2134	97972928000	17295	8760	5	0	\N
134359	2134	97971925000	17295	8760	6	0	\N
134360	2133	97915836000	17295	8760	7	0	\N
134361	2133	97914834000	17295	8760	8	0	\N
134249	1397	1339540088000	17259	8741	1	0	9929
134250	2133	97939884000	17259	8741	2	0	1058
134251	2133	97938882000	17259	8741	3	0	1059
134252	1397	1339530087000	17260	8742	0	0	9930
134253	1397	1339520086000	17260	8742	1	0	9931
134255	2133	97937880000	17260	8742	3	0	1060
134256	2134	97995997000	17260	8742	4	0	1001
134257	2133	97936878000	17260	8742	5	0	1061
134258	2134	97994994000	17260	8742	6	0	1002
134259	1397	1339510085000	17262	8743	0	0	9932
134261	2134	97993991000	17262	8743	2	0	1003
134262	1397	1339500084000	17263	8744	0	0	9933
134263	2134	97992988000	17263	8744	1	0	1004
134264	2133	97934874000	17263	8744	2	0	1063
134266	2133	97933872000	17265	8745	1	0	1064
134267	2134	97991985000	17265	8745	2	0	1005
134271	2133	97932870000	17267	8746	0	0	1065
134272	1397	1339480082000	17268	8747	0	0	9935
134273	1397	1339470081000	17268	8747	1	0	9936
134275	2133	97931868000	17268	8747	3	0	1066
134276	1397	1339460080000	17270	8748	0	0	9937
134277	2134	97989979000	17270	8748	1	0	1007
134278	1397	1339450079000	17272	8749	0	0	9938
134279	2134	97988976000	17272	8749	1	0	1008
134281	1397	1339440078000	17274	8750	0	0	9939
134282	2134	97987973000	17274	8750	1	0	1009
134283	2133	97929864000	17274	8750	2	0	1068
134287	1397	1339430077000	17277	8751	0	0	9940
134289	2133	97928862000	17277	8751	2	0	1069
134299	1397	1339420076000	17281	8752	0	0	9941
134300	2133	97927860000	17281	8752	1	0	1070
134301	2134	97985967000	17281	8752	3	0	1011
134305	1397	1339410075000	17283	8753	0	0	9942
134307	2134	97984964000	17283	8753	2	0	1012
134308	1397	1339400074000	17284	8754	0	0	9943
134309	1397	1339390073000	17284	8754	1	0	9944
134310	2134	97983961000	17284	8754	2	0	1013
134311	2134	97982958000	17284	8754	3	0	1014
134313	2133	97924854000	17284	8754	5	0	1073
134326	1397	1339380072000	17287	8755	0	0	9945
134327	1397	1339370071000	17287	8755	1	0	9946
134328	1397	1339360070000	17287	8755	2	0	9947
134330	2134	97980952000	17287	8755	4	0	1016
134331	2133	97923852000	17287	8755	5	0	1074
134332	2133	97922850000	17287	8755	6	0	1075
134333	2134	97979949000	17287	8755	7	0	1017
134334	2133	97921848000	17287	8755	8	0	1076
134336	1397	1339340068000	17288	8756	1	0	9949
134337	2134	97978946000	17288	8756	2	0	1018
134338	2133	97920846000	17288	8756	3	0	1077
134339	2133	97919844000	17288	8756	4	0	1078
134340	2134	97977943000	17288	8756	5	0	1019
134342	2133	97918842000	17289	8757	1	0	1079
134343	2134	97976940000	17289	8757	2	0	1020
134344	1397	1339320066000	17290	8758	0	0	9951
134349	1397	1339310065000	17294	8759	0	0	9952
134351	2134	97975937000	17294	8759	2	0	1021
134352	2134	97974934000	17294	8759	3	0	1022
134362	1397	1339300064000	17296	8760	0	0	9953
134363	1397	1339290063000	17296	8760	1	0	9954
134364	1397	1339280062000	17296	8760	2	0	9955
134366	2134	97973931000	17296	8760	4	0	1023
134367	2134	97972928000	17296	8760	5	0	1024
134368	2134	97971925000	17296	8760	6	0	1025
134389	1397	1339210055000	17300	8764	0	0	\N
134390	1397	1339200054000	17300	8764	1	0	\N
134391	2134	97964904000	17300	8764	2	0	\N
134392	2133	97907820000	17300	8764	3	0	\N
134393	2133	97906818000	17300	8764	4	0	\N
134394	2134	97963901000	17300	8764	5	0	\N
134395	1598	1200008000000	17301	8540	0	0	\N
134396	1726	124125109000	17301	8540	1	0	\N
134397	1726	124105109000	17301	8540	2	0	\N
134398	1726	122895109000	17301	8540	3	0	\N
134399	1726	121685109000	17301	8540	4	0	\N
134400	1474	11793412000023	17301	8540	5	0	\N
134401	497	66000011000000	17301	8540	6	0	\N
134402	2142	2850001000000	17301	8540	7	0	\N
134403	1749	4165257930000	17301	8540	8	0	\N
134410	1397	1339210055000	17303	8764	0	0	\N
134411	1397	1339200054000	17303	8764	1	0	\N
134412	2134	97964904000	17303	8764	2	0	\N
134413	2133	97907820000	17303	8764	3	0	\N
134414	2133	97906818000	17303	8764	4	0	\N
134415	2134	97963901000	17303	8764	5	0	\N
134429	1397	1339160050000	17307	8767	0	0	\N
134430	2134	97959889000	17307	8767	1	0	\N
134431	2133	97902810000	17307	8767	2	0	\N
134437	1397	1339140048000	17310	8769	0	0	\N
134438	2133	97901808000	17310	8769	1	0	\N
134439	2134	97957883000	17310	8769	2	0	\N
134441	1397	1339130047000	17312	8770	0	0	\N
134442	2133	97900806000	17312	8770	1	0	\N
134443	2134	97956880000	17312	8770	2	0	\N
134444	1397	1339130047000	17313	8771	0	0	\N
134445	1397	1339120046000	17313	8771	1	0	\N
134446	2133	97899804000	17313	8771	2	0	\N
134447	2134	97956880000	17313	8771	3	0	\N
134448	2134	97955877000	17313	8771	5	0	\N
134454	1397	1339110045000	17315	8772	0	0	\N
134455	2134	97954874000	17315	8772	1	0	\N
134466	1397	1339070041000	17320	8776	0	0	\N
134467	2134	97950862000	17320	8776	1	0	\N
134468	2133	97896798000	17320	8776	2	0	\N
134469	1397	1339070041000	17321	8776	0	0	\N
134470	2134	97950862000	17321	8776	1	0	\N
134471	2133	97896798000	17321	8776	2	0	\N
134475	1687	3500031223172	17323	8777	0	0	\N
134476	1397	1339060040000	17323	8777	1	0	\N
134477	1397	1339050039000	17323	8777	2	0	\N
134478	2133	97895796000	17323	8777	3	0	\N
134479	2133	97894794000	17323	8777	4	0	\N
134480	2134	97949859000	17323	8777	5	0	\N
134481	2134	97948856000	17323	8777	6	0	\N
134489	1687	3500031223172	17325	8777	0	0	\N
134490	1397	1339060040000	17325	8777	1	0	\N
134491	1397	1339050039000	17325	8777	2	0	\N
134492	2133	97895796000	17325	8777	3	0	\N
134493	2133	97894794000	17325	8777	4	0	\N
134494	2134	97949859000	17325	8777	5	0	\N
134495	2134	97948856000	17325	8777	6	0	\N
134496	1687	3500031223172	17326	8777	0	0	\N
134497	1397	1339060040000	17326	8777	1	0	\N
134498	1397	1339050039000	17326	8777	2	0	\N
134499	2133	97895796000	17326	8777	3	0	\N
134500	2133	97894794000	17326	8777	4	0	\N
134501	2134	97949859000	17326	8777	5	0	\N
134502	2134	97948856000	17326	8777	6	0	\N
134371	1397	1339270061000	17297	8761	0	0	9956
134372	2134	97970922000	17297	8761	1	0	1026
134373	2133	97913832000	17297	8761	2	0	1084
134374	1397	1339260060000	17298	8762	0	0	9957
134375	1397	1339250059000	17298	8762	1	0	9958
134377	1397	1339230057000	17298	8762	3	0	9960
134378	2134	97969919000	17298	8762	4	0	1027
134379	2133	97912830000	17298	8762	5	0	1085
134380	2134	97968916000	17298	8762	6	0	1028
134381	2134	97967913000	17298	8762	7	0	1029
134383	2133	97911828000	17298	8762	9	0	1086
134384	2133	97910826000	17298	8762	10	0	1087
134385	2133	97909824000	17298	8762	11	0	1088
134386	1397	1339220056000	17299	8763	0	0	9961
134388	2133	97908822000	17299	8763	2	0	1089
134404	1397	1339210055000	17302	8764	0	0	9962
134405	1397	1339200054000	17302	8764	1	0	9963
134406	2134	97964904000	17302	8764	2	0	1032
134407	2133	97907820000	17302	8764	3	0	1090
134409	2134	97963901000	17302	8764	5	0	1033
134416	1397	1339190053000	17304	8765	0	0	9964
134417	2135	719027000000	17304	8765	1	0	1
134418	2133	97905816000	17304	8765	2	0	1092
134419	2134	97962898000	17304	8765	3	0	1034
134421	1397	1339170051000	17305	8766	1	0	9966
134422	2134	97961895000	17305	8766	2	0	1035
134423	2133	97904814000	17305	8766	3	0	1093
134424	2133	97903812000	17305	8766	4	0	1094
134426	1397	1339160050000	17306	8767	0	0	9967
134427	2134	97959889000	17306	8767	1	0	1037
134428	2133	97902810000	17306	8767	2	0	1095
134432	1397	1339150049000	17308	8768	0	0	9968
134433	2134	97958886000	17308	8768	1	0	1038
134435	2133	97901808000	17309	8769	1	0	1096
134436	2134	97957883000	17309	8769	2	0	1039
134440	2133	97900806000	17311	8770	0	0	1097
134449	1397	1339130047000	17314	8771	0	0	9970
134450	1397	1339120046000	17314	8771	1	0	9971
134452	2134	97956880000	17314	8771	3	0	1040
134453	2134	97955877000	17314	8771	5	0	1041
134456	1397	1339110045000	17316	8772	0	0	9972
134457	2134	97954874000	17316	8772	1	0	1042
134459	2134	97953871000	17317	8773	1	0	1043
134460	2133	97898802000	17317	8773	2	0	1099
134461	1397	1339090043000	17318	8774	0	0	9974
134462	2134	97952868000	17318	8774	1	0	1044
134463	2133	97897800000	17318	8774	2	0	1100
134465	2134	97951865000	17319	8775	1	0	1045
134472	1397	1339070041000	17322	8776	0	0	9976
134473	2134	97950862000	17322	8776	1	0	1046
134474	2133	97896798000	17322	8776	2	0	1101
134482	1687	3500031223172	17324	8777	0	0	6
134484	1397	1339050039000	17324	8777	2	0	9978
134485	2133	97895796000	17324	8777	3	0	1102
134486	2133	97894794000	17324	8777	4	0	1103
134487	2134	97949859000	17324	8777	5	0	1047
134503	1397	1339040038000	17327	8778	0	0	9979
134504	2134	97947853000	17327	8778	1	0	1049
134505	1687	3500031223172	17328	8762	0	0	\N
134506	1397	1339260060000	17328	8762	1	0	\N
134507	2135	719027000000	17328	8762	2	0	\N
134508	1397	1339250059000	17328	8762	3	0	\N
134509	1397	1339240058000	17328	8762	4	0	\N
134510	1397	1339230057000	17328	8762	5	0	\N
134511	1397	1339220056000	17328	8762	6	0	\N
134512	1397	1339210055000	17328	8762	7	0	\N
134513	1397	1339200054000	17328	8762	8	0	\N
134514	1397	1339190053000	17328	8762	9	0	\N
134515	1397	1339180052000	17328	8762	10	0	\N
134516	1397	1339170051000	17328	8762	11	0	\N
134517	1397	1339160050000	17328	8762	12	0	\N
134518	1397	1339150049000	17328	8762	13	0	\N
134519	1397	1339140048000	17328	8762	14	0	\N
134520	1397	1339130047000	17328	8762	15	0	\N
134521	1397	1339120046000	17328	8762	16	0	\N
134522	1397	1339110045000	17328	8762	17	0	\N
134523	1397	1339100044000	17328	8762	18	0	\N
134524	1397	1339090043000	17328	8762	19	0	\N
134525	1397	1339080042000	17328	8762	20	0	\N
134526	1397	1339070041000	17328	8762	21	0	\N
134527	1397	1339060040000	17328	8762	22	0	\N
134528	1397	1339050039000	17328	8762	23	0	\N
134529	1397	1339040038000	17328	8762	24	0	\N
134530	2134	97969919000	17328	8762	25	0	\N
134531	2133	97912830000	17328	8762	26	0	\N
134532	2134	97968916000	17328	8762	27	0	\N
134533	2134	97967913000	17328	8762	28	0	\N
134534	2134	97966910000	17328	8762	29	0	\N
134535	2134	97965907000	17328	8762	30	0	\N
134536	2134	97964904000	17328	8762	31	0	\N
134537	2134	97963901000	17328	8762	32	0	\N
134538	2134	97962898000	17328	8762	33	0	\N
134539	2134	97961895000	17328	8762	34	0	\N
134540	2134	97960892000	17328	8762	35	0	\N
134541	2134	97959889000	17328	8762	36	0	\N
134542	2134	97958886000	17328	8762	37	0	\N
134543	2134	97957883000	17328	8762	38	0	\N
134544	2134	97956880000	17328	8762	39	0	\N
134545	2133	97911828000	17328	8762	40	0	\N
134546	2133	97910826000	17328	8762	41	0	\N
134547	2133	97909824000	17328	8762	42	0	\N
134548	2133	97908822000	17328	8762	43	0	\N
134549	2133	97907820000	17328	8762	44	0	\N
134550	2133	97906818000	17328	8762	45	0	\N
134551	2133	97905816000	17328	8762	46	0	\N
134552	2133	97904814000	17328	8762	47	0	\N
134553	2133	97903812000	17328	8762	48	0	\N
134554	2133	97902810000	17328	8762	49	0	\N
134555	2133	97901808000	17328	8762	50	0	\N
134556	2133	97900806000	17328	8762	51	0	\N
134557	2133	97899804000	17328	8762	52	0	\N
134558	2133	97898802000	17328	8762	53	0	\N
134559	2133	97897800000	17328	8762	54	0	\N
134560	2133	97896798000	17328	8762	55	0	\N
134561	2133	97895796000	17328	8762	56	0	\N
134562	2133	97894794000	17328	8762	57	0	\N
134563	2134	97955877000	17328	8762	58	0	\N
134564	2134	97954874000	17328	8762	59	0	\N
134565	2134	97953871000	17328	8762	60	0	\N
134566	2134	97952868000	17328	8762	61	0	\N
134567	2134	97951865000	17328	8762	63	0	\N
134568	2134	97950862000	17328	8762	64	0	\N
134569	2134	97949859000	17328	8762	65	0	\N
134570	2134	97948856000	17328	8762	66	0	\N
134571	2134	97947853000	17328	8762	67	0	\N
134572	1866	9330827500718	17329	8779	0	0	\N
134573	1866	9327039506772	17329	8779	1	0	\N
134574	1866	8269714569740	17329	8779	2	0	\N
134575	1866	7212389632708	17329	8779	3	0	\N
134576	1866	6233772723170	17329	8779	4	0	\N
134577	1866	4480178805218	17329	8779	5	0	\N
134578	1866	3296961517936	17329	8779	6	0	\N
134579	1866	0	17329	8779	7	0	\N
134580	1397	1339030037000	17329	8779	8	0	\N
134581	2133	97893792000	17329	8779	9	0	\N
134582	2134	97946850000	17329	8779	10	0	\N
134594	1866	9330827500718	17331	8779	0	0	\N
134595	1866	9327039506772	17331	8779	1	0	\N
134596	1866	8269714569740	17331	8779	2	0	\N
134597	1866	7212389632708	17331	8779	3	0	\N
134598	1866	6233772723170	17331	8779	4	0	\N
134599	1866	4480178805218	17331	8779	5	0	\N
134600	1397	1339030037000	17331	8779	6	0	\N
134601	2133	97893792000	17331	8779	7	0	\N
134602	2134	97946850000	17331	8779	8	0	\N
134607	1397	1339020036000	17333	8780	0	0	\N
134608	1397	1339010035000	17333	8780	1	0	\N
134609	2134	97945847000	17333	8780	2	0	\N
134610	2134	97944844000	17333	8780	3	0	\N
134611	2133	97892790000	17333	8780	4	0	\N
134612	2133	97891788000	17333	8780	5	0	\N
134614	1687	3500031223172	17335	8777	0	0	\N
134633	1397	1338960030000	17340	8785	0	0	\N
134634	2134	97938826000	17340	8785	1	0	\N
134635	2133	97885776000	17340	8785	2	0	\N
134639	1397	1338940028000	17342	8787	0	0	\N
134640	2134	97936820000	17342	8787	1	0	\N
134585	1866	8269714569740	17330	8779	2	0	19
134586	1866	7212389632708	17330	8779	3	0	20
134587	1866	6233772723170	17330	8779	4	0	21
134588	1866	4480178805218	17330	8779	5	0	22
134589	1866	3296961517936	17330	8779	6	0	23
134591	1397	1339030037000	17330	8779	8	0	9980
134592	2133	97893792000	17330	8779	9	0	1104
134593	2134	97946850000	17330	8779	10	0	1050
134603	1397	1339020036000	17332	8780	0	0	9981
134604	1397	1339010035000	17332	8780	1	0	9982
134606	2133	97891788000	17332	8780	3	0	1106
134613	2133	97890786000	17334	8781	0	0	1107
134615	1397	1339000034000	17336	8782	0	0	9983
134616	1397	1338990033000	17336	8782	1	0	9984
134618	2134	97945847000	17336	8782	3	0	1051
134619	2133	97888782000	17336	8782	4	0	1109
134620	2134	97944844000	17336	8782	5	0	1052
134621	2134	97943841000	17336	8782	6	0	1053
134622	2134	97942838000	17336	8782	7	0	1054
134624	1397	1338980032000	17337	8783	0	0	9985
134625	2134	97940832000	17337	8783	1	0	1056
134626	2133	97887780000	17337	8783	2	0	1110
134627	1397	1338970031000	17338	8784	0	0	9986
134628	2134	97939829000	17338	8784	1	0	1057
134630	1397	1338960030000	17339	8785	0	0	9987
134631	2134	97938826000	17339	8785	1	0	1058
134632	2133	97885776000	17339	8785	2	0	1112
134636	1397	1338950029000	17341	8786	0	0	9988
134638	2134	97937823000	17341	8786	2	0	1059
134641	2133	97883772000	17342	8787	2	0	\N
134645	1397	1338930027000	17344	8788	0	0	\N
134646	2134	97935817000	17344	8788	1	0	\N
134647	2133	97882770000	17344	8788	2	0	\N
134648	1397	1338930027000	17345	8788	0	0	\N
134649	2134	97935817000	17345	8788	1	0	\N
134650	2133	97882770000	17345	8788	2	0	\N
134654	1397	1338920026000	17348	8789	0	0	\N
134655	2134	97934814000	17348	8789	1	0	\N
134656	2133	97881768000	17348	8789	2	0	\N
134657	1397	1338920026000	17349	8789	0	0	\N
134658	2133	97881768000	17349	8789	1	0	\N
134659	1397	1338920026000	17350	8789	0	0	\N
134660	2134	97934814000	17350	8789	1	0	\N
134661	2133	97881768000	17350	8789	2	0	\N
134672	1397	1338880022000	17354	8793	0	0	\N
134673	1397	1338870021000	17354	8793	1	0	\N
134674	1397	1338860020000	17354	8793	2	0	\N
134675	2134	97930802000	17354	8793	3	0	\N
134676	2134	97929799000	17354	8793	4	0	\N
134677	2134	97928796000	17354	8793	5	0	\N
134678	2133	97879764000	17354	8793	6	0	\N
134679	2133	97878762000	17354	8793	7	0	\N
134680	2133	97877760000	17354	8793	9	0	\N
134681	1397	1338880022000	17355	8793	0	0	\N
134682	1397	1338870021000	17355	8793	1	0	\N
134683	1397	1338860020000	17355	8793	2	0	\N
134684	2134	97930802000	17355	8793	3	0	\N
134685	2134	97929799000	17355	8793	4	0	\N
134686	2134	97928796000	17355	8793	5	0	\N
134687	2133	97879764000	17355	8793	6	0	\N
134688	2133	97878762000	17355	8793	7	0	\N
134689	2133	97877760000	17355	8793	9	0	\N
134699	1687	3500031223172	17357	8698	0	0	\N
134700	2135	719027000000	17357	8698	1	0	\N
134701	2142	2850001000000	17357	8698	2	0	\N
134702	1397	1338850019000	17358	8794	0	0	\N
134703	2134	97927793000	17358	8794	1	0	\N
134704	2133	97876758000	17358	8794	2	0	\N
134705	1397	1338850019000	17359	8794	0	0	\N
134706	2134	97927793000	17359	8794	1	0	\N
134707	2133	97876758000	17359	8794	2	0	\N
134711	1397	1338850019000	17361	8794	0	0	\N
134712	2134	97927793000	17361	8794	1	0	\N
134713	2133	97876758000	17361	8794	2	0	\N
134714	1397	1338850019000	17362	8794	0	0	\N
134715	2134	97927793000	17362	8794	1	0	\N
134716	2133	97876758000	17362	8794	2	0	\N
134720	1397	1338830017000	17364	8796	0	0	\N
134721	1397	1338820016000	17364	8796	1	0	\N
134722	2133	97874754000	17364	8796	2	0	\N
134723	2134	97925787000	17364	8796	3	0	\N
134724	2134	97924784000	17364	8796	4	0	\N
134725	1397	1338830017000	17365	8796	0	0	\N
134726	1397	1338820016000	17365	8796	1	0	\N
134727	2133	97874754000	17365	8796	2	0	\N
134728	2134	97925787000	17365	8796	3	0	\N
134729	2134	97924784000	17365	8796	4	0	\N
134730	1397	1338830017000	17366	8796	0	0	\N
134731	1397	1338820016000	17366	8796	1	0	\N
134732	2133	97874754000	17366	8796	2	0	\N
134733	2134	97925787000	17366	8796	3	0	\N
134734	2134	97924784000	17366	8796	4	0	\N
134746	1397	1338790013000	17369	8798	0	0	\N
134747	2134	97921775000	17369	8798	1	0	\N
134750	1397	1338780012000	17371	8799	0	0	\N
134751	2134	97920772000	17371	8799	1	0	\N
134752	2133	97871748000	17371	8799	2	0	\N
134756	1397	1338780012000	17373	8799	0	0	\N
134757	2134	97920772000	17373	8799	1	0	\N
134758	2133	97871748000	17373	8799	2	0	\N
134759	1397	1338780012000	17374	8799	0	0	\N
134760	2134	97920772000	17374	8799	1	0	\N
134761	2133	97871748000	17374	8799	2	0	\N
134762	2134	97920772000	17375	8799	0	0	\N
134763	2133	97871748000	17375	8799	1	0	\N
134776	1397	1338750009000	17379	8802	0	0	\N
134644	2133	97883772000	17343	8787	2	0	1114
134651	1397	1338930027000	17346	8788	0	0	9990
134652	2134	97935817000	17346	8788	1	0	1061
134653	2133	97882770000	17346	8788	2	0	1115
134662	1397	1338920026000	17351	8790	0	0	9991
134664	2134	97934814000	17351	8790	2	0	1062
134665	2134	97933811000	17351	8790	3	0	1063
134666	2133	97881768000	17351	8790	4	0	1116
134667	1397	1338900024000	17352	8791	0	0	9993
134668	2134	97932808000	17352	8791	1	0	1064
134670	1397	1338890023000	17353	8792	0	0	9994
134671	2134	97931805000	17353	8792	1	0	1065
134690	1397	1338880022000	17356	8793	0	0	9995
134691	1397	1338870021000	17356	8793	1	0	9996
134693	2134	97930802000	17356	8793	3	0	1066
134694	2134	97929799000	17356	8793	4	0	1067
134695	2134	97928796000	17356	8793	5	0	1068
134696	2133	97879764000	17356	8793	6	0	1118
134697	2133	97878762000	17356	8793	7	0	1119
134708	1397	1338850019000	17360	8794	0	0	9998
134709	2134	97927793000	17360	8794	1	0	1069
134710	2133	97876758000	17360	8794	2	0	1121
134717	1397	1338840018000	17363	8795	0	0	9999
134718	2134	97926790000	17363	8795	1	0	1070
134735	1397	1338830017000	17367	8796	0	0	10000
134736	2133	97874754000	17367	8796	1	0	1123
134737	2134	97925787000	17367	8796	2	0	1071
134738	2134	97924784000	17367	8796	3	0	1072
134740	1397	1338810015000	17368	8797	1	0	10002
134741	1397	1338800014000	17368	8797	2	0	10003
134742	2133	97873752000	17368	8797	3	0	1124
134743	2133	97872750000	17368	8797	4	0	1125
134744	2134	97923781000	17368	8797	5	0	1073
134748	1397	1338790013000	17370	8798	0	0	10004
134749	2134	97921775000	17370	8798	1	0	1075
134753	1397	1338780012000	17372	8799	0	0	10005
134754	2134	97920772000	17372	8799	1	0	1076
134755	2133	97871748000	17372	8799	2	0	1126
134765	2133	97870746000	17376	8800	1	0	1127
134766	2134	97919769000	17376	8800	2	0	1077
134767	1397	1338760010000	17377	8801	0	0	10007
134768	2133	97869744000	17377	8801	1	0	1128
134770	1397	1338750009000	17378	8802	0	0	10008
134771	1397	1338740008000	17378	8802	1	0	10009
134772	2134	97917763000	17378	8802	2	0	1079
134773	2134	97916760000	17378	8802	3	0	1080
134774	2133	97868742000	17378	8802	4	0	1129
134777	1397	1338740008000	17379	8802	1	0	\N
134778	2134	97917763000	17379	8802	2	0	\N
134779	2134	97916760000	17379	8802	3	0	\N
134780	2133	97868742000	17379	8802	4	0	\N
134781	2133	97867740000	17379	8802	5	0	\N
134796	1397	1338700004000	17382	8804	0	0	\N
134797	1397	1338690003000	17382	8804	1	0	\N
134798	2134	97912748000	17382	8804	2	0	\N
134799	2134	97911745000	17382	8804	3	0	\N
134800	2133	97864734000	17382	8804	4	0	\N
134801	2133	97863732000	17382	8804	5	0	\N
134806	1397	1338670001000	17385	8806	0	0	\N
134807	2134	97909739000	17385	8806	1	0	\N
134808	2133	97861728000	17385	8806	2	0	\N
134809	1397	1338670001000	17386	8806	0	0	\N
134810	2134	97909739000	17386	8806	1	0	\N
134811	2133	97861728000	17386	8806	2	0	\N
134817	1687	3500031223172	17388	8772	0	0	\N
134818	1397	1339110045000	17388	8772	1	0	\N
134819	1397	1339100044000	17388	8772	2	0	\N
134820	1397	1339090043000	17388	8772	3	0	\N
134821	1397	1339080042000	17388	8772	4	0	\N
134822	1397	1339070041000	17388	8772	5	0	\N
134823	1397	1339060040000	17388	8772	6	0	\N
134824	1397	1339050039000	17388	8772	7	0	\N
134825	1397	1339040038000	17388	8772	8	0	\N
134826	1397	1339030037000	17388	8772	9	0	\N
134827	1397	1339020036000	17388	8772	10	0	\N
134828	1397	1339010035000	17388	8772	11	0	\N
134829	1397	1339000034000	17388	8772	12	0	\N
134830	1397	1338990033000	17388	8772	13	0	\N
134831	1397	1338980032000	17388	8772	14	0	\N
134832	1397	1338970031000	17388	8772	15	0	\N
134833	1397	1338960030000	17388	8772	16	0	\N
134834	1397	1338950029000	17388	8772	17	0	\N
134835	1397	1338940028000	17388	8772	18	0	\N
134836	1397	1338930027000	17388	8772	19	0	\N
134837	1397	1338920026000	17388	8772	20	0	\N
134838	1397	1338910025000	17388	8772	21	0	\N
134839	1397	1338900024000	17388	8772	22	0	\N
134840	1397	1338890023000	17388	8772	23	0	\N
134841	1397	1338880022000	17388	8772	24	0	\N
134842	1397	1338870021000	17388	8772	25	0	\N
134843	1397	1338860020000	17388	8772	26	0	\N
134844	1397	1338850019000	17388	8772	27	0	\N
134845	1397	1338840018000	17388	8772	28	0	\N
134846	1397	1338830017000	17388	8772	29	0	\N
134847	1397	1338820016000	17388	8772	30	0	\N
134848	1397	1338810015000	17388	8772	31	0	\N
134849	1397	1338800014000	17388	8772	32	0	\N
134850	1397	1338790013000	17388	8772	33	0	\N
134851	1397	1338780012000	17388	8772	34	0	\N
134852	1397	1338770011000	17388	8772	35	0	\N
134853	1397	1338760010000	17388	8772	36	0	\N
134854	1397	1338750009000	17388	8772	37	0	\N
134855	1397	1338740008000	17388	8772	38	0	\N
134856	1397	1338730007000	17388	8772	39	0	\N
134857	1397	1338720006000	17388	8772	40	0	\N
134858	1397	1338710005000	17388	8772	41	0	\N
134859	1397	1338700004000	17388	8772	42	0	\N
134860	1397	1338690003000	17388	8772	43	0	\N
134861	1397	1338680002000	17388	8772	44	0	\N
134862	1397	1338670001000	17388	8772	45	0	\N
134863	1397	1338660000000	17388	8772	46	0	\N
134864	1397	1338649999000	17388	8772	47	0	\N
134865	1397	1338639998000	17388	8772	48	0	\N
134866	1397	1338629997000	17388	8772	49	0	\N
134867	1397	1338619996000	17388	8772	50	0	\N
134868	1598	0	17388	8772	51	0	\N
134869	2133	97898802000	17388	8772	52	0	\N
134870	2133	97897800000	17388	8772	53	0	\N
134871	2133	97896798000	17388	8772	54	0	\N
134872	2133	97895796000	17388	8772	55	0	\N
134873	2133	97894794000	17388	8772	56	0	\N
134874	2133	97893792000	17388	8772	57	0	\N
134875	2133	97892790000	17388	8772	58	0	\N
134876	2133	97891788000	17388	8772	59	0	\N
134877	2133	97890786000	17388	8772	60	0	\N
134878	2133	97889784000	17388	8772	61	0	\N
134879	2133	97888782000	17388	8772	62	0	\N
134880	2133	97887780000	17388	8772	63	0	\N
134881	2133	97886778000	17388	8772	64	0	\N
134882	2133	97885776000	17388	8772	65	0	\N
134883	2133	97884774000	17388	8772	66	0	\N
134884	2133	97883772000	17388	8772	67	0	\N
134885	2133	97882770000	17388	8772	68	0	\N
134886	2133	97881768000	17388	8772	69	0	\N
134887	2133	97880766000	17388	8772	70	0	\N
134888	2133	97879764000	17388	8772	71	0	\N
134889	2133	97878762000	17388	8772	72	0	\N
134890	2133	97877760000	17388	8772	73	0	\N
134891	2133	97876758000	17388	8772	74	0	\N
134892	2133	97875756000	17388	8772	75	0	\N
134893	2133	97874754000	17388	8772	76	0	\N
134894	2133	97873752000	17388	8772	77	0	\N
134895	2133	97872750000	17388	8772	78	0	\N
134896	2133	97871748000	17388	8772	79	0	\N
134897	2133	97870746000	17388	8772	80	0	\N
134898	2133	97869744000	17388	8772	81	0	\N
134899	2133	97868742000	17388	8772	82	0	\N
134900	2133	97867740000	17388	8772	83	0	\N
134901	2133	97866738000	17388	8772	84	0	\N
134902	2133	97865736000	17388	8772	85	0	\N
134903	2133	97864734000	17388	8772	86	0	\N
134904	2133	97863732000	17388	8772	87	0	\N
134905	2133	97862730000	17388	8772	88	0	\N
134906	2133	97861728000	17388	8772	89	0	\N
134907	2133	97860726000	17388	8772	90	0	\N
134908	2133	97859724000	17388	8772	91	0	\N
134909	2133	97858722000	17388	8772	92	0	\N
134910	2133	97857720000	17388	8772	93	0	\N
134911	2133	97856718000	17388	8772	94	0	\N
134912	2134	97954874000	17388	8772	95	0	\N
134784	1397	1338710005000	17380	8803	2	0	10012
134785	2134	97915757000	17380	8803	3	0	1081
134786	2133	97866738000	17380	8803	4	0	1131
134787	2133	97865736000	17380	8803	5	0	1132
134788	2134	97914754000	17380	8803	6	0	1082
134790	1397	1338700004000	17381	8804	0	0	10013
134791	1397	1338690003000	17381	8804	1	0	10014
134792	2134	97912748000	17381	8804	2	0	1084
134793	2134	97911745000	17381	8804	3	0	1085
134794	2133	97864734000	17381	8804	4	0	1133
134802	1397	1338680002000	17383	8805	0	0	10015
134803	2134	97910742000	17383	8805	1	0	1086
134804	2133	97862730000	17383	8805	2	0	1135
134805	2134	97909739000	17384	8806	0	0	1087
134813	1397	1338660000000	17387	8807	1	0	10017
134814	2133	97861728000	17387	8807	2	0	1136
134815	2133	97860726000	17387	8807	3	0	1137
134816	2134	97908736000	17387	8807	4	0	1088
134913	2134	97953871000	17388	8772	96	0	\N
134914	2134	97952868000	17388	8772	97	0	\N
134915	2134	97951865000	17388	8772	98	0	\N
134916	2134	97950862000	17388	8772	99	0	\N
134917	2134	97949859000	17388	8772	100	0	\N
134918	2134	97948856000	17388	8772	101	0	\N
134919	2134	97947853000	17388	8772	102	0	\N
134920	2134	97946850000	17388	8772	103	0	\N
134921	2134	97945847000	17388	8772	104	0	\N
134922	2134	97944844000	17388	8772	105	0	\N
134923	2134	97943841000	17388	8772	106	0	\N
134924	2134	97942838000	17388	8772	107	0	\N
134925	2134	97941835000	17388	8772	108	0	\N
134926	2134	97940832000	17388	8772	109	0	\N
134927	2134	97939829000	17388	8772	110	0	\N
134928	2134	97938826000	17388	8772	111	0	\N
134929	2134	97937823000	17388	8772	112	0	\N
134930	2134	97936820000	17388	8772	113	0	\N
134931	2134	97935817000	17388	8772	114	0	\N
134932	2134	97934814000	17388	8772	115	0	\N
134933	2134	97933811000	17388	8772	116	0	\N
134934	2134	97932808000	17388	8772	117	0	\N
134935	2134	97931805000	17388	8772	118	0	\N
134936	2134	97930802000	17388	8772	119	0	\N
134937	2134	97929799000	17388	8772	120	0	\N
134938	2134	97928796000	17388	8772	121	0	\N
134939	2134	97927793000	17388	8772	122	0	\N
134940	2134	97926790000	17388	8772	123	0	\N
134941	2134	97925787000	17388	8772	125	0	\N
134942	1397	1338649999000	17389	8808	0	0	\N
134943	1397	1338639998000	17389	8808	1	0	\N
134944	1397	1338629997000	17389	8808	2	0	\N
134945	1397	1338619996000	17389	8808	3	0	\N
134946	1598	0	17389	8808	4	0	\N
134947	2134	97907733000	17389	8808	5	0	\N
134948	2134	97906730000	17389	8808	6	0	\N
134949	2133	97859724000	17389	8808	7	0	\N
134950	2134	97905727000	17389	8808	8	0	\N
134951	2133	97858722000	17389	8808	9	0	\N
134952	2133	97857720000	17389	8808	10	0	\N
134953	2133	97856718000	17389	8808	11	0	\N
134966	1687	3500032223172	17391	8644	0	0	\N
134967	1598	1200008000000	17391	8644	1	0	\N
134968	1726	124125109000	17391	8644	2	0	\N
134969	1726	124105109000	17391	8644	3	0	\N
134970	1726	122895109000	17391	8644	4	0	\N
134971	1726	121685109000	17391	8644	5	0	\N
134972	1474	11793412000023	17391	8644	6	0	\N
134973	1397	1340790213000	17391	8644	7	0	\N
134974	1397	1340780212000	17391	8644	8	0	\N
134975	1397	1338609995000	17392	8809	0	0	\N
134976	1397	1338599994000	17392	8809	1	0	\N
134977	850	1155015381824210	17392	8809	2	0	\N
134978	2133	97855716000	17392	8809	3	0	\N
134979	2133	97854714000	17392	8809	4	0	\N
134980	2134	97904724000	17392	8809	5	0	\N
134981	2134	97903721000	17392	8809	6	0	\N
134990	1397	1338589993000	17394	8810	0	0	\N
134991	1397	1338579992000	17394	8810	1	0	\N
134992	2133	97853712000	17394	8810	2	0	\N
134993	2133	97852710000	17394	8810	3	0	\N
134994	2134	97901715000	17394	8810	4	0	\N
135020	1397	1338529987000	17399	8813	0	0	\N
135021	1397	1338519986000	17399	8813	1	0	\N
135022	1397	1338509985000	17399	8813	2	0	\N
135023	2133	97848702000	17399	8813	3	0	\N
135024	2133	97847700000	17399	8813	4	0	\N
135025	2134	97896700000	17399	8813	5	0	\N
135026	2134	97895697000	17399	8813	6	0	\N
135027	2134	97894694000	17399	8813	7	0	\N
135028	2133	97846698000	17399	8813	8	0	\N
135029	1397	1338529987000	17400	8813	0	0	\N
135030	1397	1338519986000	17400	8813	1	0	\N
135031	1397	1338509985000	17400	8813	2	0	\N
135032	2133	97848702000	17400	8813	3	0	\N
135033	2133	97847700000	17400	8813	4	0	\N
135034	2134	97896700000	17400	8813	5	0	\N
135035	2134	97895697000	17400	8813	6	0	\N
135036	2134	97894694000	17400	8813	7	0	\N
135037	2133	97846698000	17400	8813	8	0	\N
135038	2133	97845696000	17401	8814	0	0	\N
135039	2134	97893691000	17401	8814	1	0	\N
135048	1397	1338479982000	17405	8817	0	0	\N
134956	1397	1338629997000	17390	8808	2	0	10020
134957	1397	1338619996000	17390	8808	3	0	10021
134958	1598	0	17390	8808	4	0	3
134959	2134	97907733000	17390	8808	5	0	1089
134960	2134	97906730000	17390	8808	6	0	1090
134962	2134	97905727000	17390	8808	8	0	1091
134963	2133	97858722000	17390	8808	9	0	1139
134964	2133	97857720000	17390	8808	10	0	1140
134965	2133	97856718000	17390	8808	11	0	1141
134982	1397	1338609995000	17393	8809	0	0	10022
134984	850	1155015381824210	17393	8809	2	0	1
134985	2133	97855716000	17393	8809	3	0	1142
134986	2133	97854714000	17393	8809	4	0	1143
134987	2134	97904724000	17393	8809	5	0	1092
134989	2134	97902718000	17393	8809	7	0	1094
134995	1397	1338589993000	17395	8810	0	0	10024
134996	1397	1338579992000	17395	8810	1	0	10025
134997	2133	97853712000	17395	8810	2	0	1144
134998	2133	97852710000	17395	8810	3	0	1145
135000	1397	1338569991000	17396	8811	0	0	10026
135001	2134	97900712000	17396	8811	1	0	1096
135002	1397	1338559990000	17397	8812	0	0	10027
135003	1397	1338549989000	17397	8812	1	0	10028
135004	1397	1338539988000	17397	8812	2	0	10029
135006	2134	97899709000	17397	8812	5	0	1097
135007	2134	97898706000	17397	8812	6	0	1098
135008	2134	97897703000	17397	8812	7	0	1099
135009	2133	97850706000	17397	8812	8	0	1147
135011	1397	1338529987000	17398	8813	0	0	10030
135012	1397	1338519986000	17398	8813	1	0	10031
135013	1397	1338509985000	17398	8813	2	0	10032
135014	2133	97848702000	17398	8813	3	0	1149
135015	2133	97847700000	17398	8813	4	0	1150
135017	2134	97895697000	17398	8813	6	0	1101
135018	2134	97894694000	17398	8813	7	0	1102
135019	2133	97846698000	17398	8813	8	0	1151
135040	2133	97845696000	17402	8814	0	0	1152
135041	2134	97893691000	17402	8814	1	0	1103
135043	2133	97844694000	17403	8815	1	0	1153
135044	2134	97892688000	17403	8815	2	0	1104
135045	1397	1338489983000	17404	8816	0	0	10034
135046	2133	97843692000	17404	8816	1	0	1154
135049	2133	97842690000	17405	8817	1	0	\N
135050	2134	97890682000	17405	8817	2	0	\N
135060	1397	1338469981000	17408	8818	0	0	\N
135061	1397	1338459980000	17408	8818	1	0	\N
135062	2133	97841688000	17408	8818	2	0	\N
135063	2133	97840686000	17408	8818	3	0	\N
135064	2134	97889679000	17408	8818	4	0	\N
135065	2134	97888676000	17408	8818	5	0	\N
135071	1397	1338429977000	17410	8820	0	0	\N
135072	2133	97838682000	17410	8820	1	0	\N
135073	2134	97885667000	17410	8820	2	0	\N
135074	1397	1338429977000	17411	8820	0	0	\N
135075	2133	97838682000	17411	8820	1	0	\N
135076	2134	97885667000	17411	8820	2	0	\N
135080	1397	1338429977000	17413	8820	0	0	\N
135081	2133	97838682000	17413	8820	1	0	\N
135082	2134	97885667000	17413	8820	2	0	\N
135083	2134	97884664000	17414	8821	0	0	\N
135084	2133	97837680000	17414	8821	1	0	\N
135085	2134	97884664000	17415	8821	0	0	\N
135086	2133	97837680000	17415	8821	1	0	\N
135096	2133	97834674000	17420	8824	0	0	\N
135097	2134	97881655000	17420	8824	1	0	\N
135098	1397	1338419976000	17421	8825	0	0	\N
135099	1397	1338409975000	17421	8825	1	0	\N
135100	2133	97833672000	17421	8825	2	0	\N
135101	2134	97880652000	17421	8825	3	0	\N
135102	2134	97879649000	17421	8825	4	0	\N
135103	2133	97832670000	17421	8825	5	0	\N
135110	1397	1338419976000	17423	8825	0	0	\N
135111	1397	1338409975000	17423	8825	1	0	\N
135112	2133	97833672000	17423	8825	2	0	\N
135113	2134	97880652000	17423	8825	3	0	\N
135114	2134	97879649000	17423	8825	4	0	\N
135115	2133	97832670000	17423	8825	5	0	\N
135120	1516	1122313550000	17425	8826	0	0	\N
135121	1516	946060810000	17425	8826	1	0	\N
135122	1397	1338399974000	17425	8826	2	0	\N
135123	2134	97878646000	17425	8826	3	0	\N
135132	1397	1338369971000	17427	8828	0	0	\N
135133	2134	97875637000	17427	8828	1	0	\N
135143	1397	1338349969000	17431	8830	0	0	\N
135144	1756	6193109545609	17431	8830	1	0	\N
135145	2134	97873631000	17431	8830	2	0	\N
135146	2133	97828662000	17431	8830	3	0	\N
135147	1687	3500031223172	17432	8766	0	0	\N
135148	1397	1339180052000	17432	8766	1	0	\N
135149	1756	6369272285609	17432	8766	2	0	\N
135150	1397	1339170051000	17432	8766	3	0	\N
135151	1397	1339160050000	17432	8766	4	0	\N
135152	1397	1339150049000	17432	8766	5	0	\N
135153	1397	1339140048000	17432	8766	6	0	\N
135154	1397	1339130047000	17432	8766	7	0	\N
135155	1397	1339120046000	17432	8766	8	0	\N
135156	1756	6193109545609	17432	8766	9	0	\N
135157	1397	1339110045000	17432	8766	10	0	\N
135158	1397	1339100044000	17432	8766	11	0	\N
135159	1397	1339090043000	17432	8766	12	0	\N
135160	1397	1339080042000	17432	8766	13	0	\N
135161	1397	1339070041000	17432	8766	14	0	\N
135162	1397	1339060040000	17432	8766	15	0	\N
135163	1397	1339050039000	17432	8766	16	0	\N
135164	1397	1339040038000	17432	8766	17	0	\N
135165	1397	1339030037000	17432	8766	18	0	\N
135166	1397	1339020036000	17432	8766	19	0	\N
135167	1397	1339010035000	17432	8766	20	0	\N
135168	1397	1339000034000	17432	8766	21	0	\N
135169	1397	1338990033000	17432	8766	22	0	\N
135170	1397	1338980032000	17432	8766	23	0	\N
135171	1397	1338970031000	17432	8766	24	0	\N
135172	1397	1338960030000	17432	8766	25	0	\N
135173	1397	1338950029000	17432	8766	26	0	\N
135174	1397	1338940028000	17432	8766	27	0	\N
135175	1397	1338930027000	17432	8766	28	0	\N
135176	1397	1338920026000	17432	8766	30	0	\N
135177	1397	1338910025000	17432	8766	31	0	\N
135178	1397	1338900024000	17432	8766	32	0	\N
135179	1397	1338890023000	17432	8766	33	0	\N
135180	1397	1338880022000	17432	8766	34	0	\N
135181	1397	1338870021000	17432	8766	35	0	\N
135182	1397	1338860020000	17432	8766	36	0	\N
135183	1397	1338850019000	17432	8766	37	0	\N
135184	1397	1338840018000	17432	8766	38	0	\N
135053	2134	97890682000	17406	8817	2	0	1106
135054	1397	1338469981000	17407	8818	0	0	10036
135055	1397	1338459980000	17407	8818	1	0	10037
135056	2133	97841688000	17407	8818	2	0	1156
135057	2133	97840686000	17407	8818	3	0	1157
135059	2134	97888676000	17407	8818	5	0	1108
135066	1397	1338449979000	17409	8819	0	0	10038
135067	1397	1338439978000	17409	8819	1	0	10039
135068	2134	97887673000	17409	8819	2	0	1109
135069	2134	97886670000	17409	8819	3	0	1110
135077	1397	1338429977000	17412	8820	0	0	10040
135078	2133	97838682000	17412	8820	1	0	1159
135079	2134	97885667000	17412	8820	2	0	1111
135087	2134	97884664000	17416	8821	0	0	1112
135089	2133	97836678000	17417	8822	0	0	1161
135090	2134	97883661000	17417	8822	1	0	1113
135091	1756	6369272285609	17418	8823	0	0	4
135092	2134	97882658000	17418	8823	1	0	1114
135093	2133	97835676000	17418	8823	2	0	1162
135095	2134	97881655000	17419	8824	1	0	1115
135104	1397	1338419976000	17422	8825	0	0	10041
135105	1397	1338409975000	17422	8825	1	0	10042
135106	2133	97833672000	17422	8825	2	0	1164
135107	2134	97880652000	17422	8825	3	0	1116
135109	2133	97832670000	17422	8825	5	0	1165
135116	1516	1122313550000	17424	8826	0	0	8
135117	1516	946060810000	17424	8826	1	0	9
135118	1397	1338399974000	17424	8826	2	0	10043
135124	1516	630325800000	17426	8827	0	0	10
135125	1516	417211780000	17426	8827	1	0	11
135126	1397	1338389973000	17426	8827	2	0	10044
135127	1397	1338379972000	17426	8827	3	0	10045
135128	2134	97877643000	17426	8827	4	0	1119
135130	2133	97831668000	17426	8827	6	0	1166
135131	2133	97830666000	17426	8827	7	0	1167
135134	1397	1338369971000	17428	8828	0	0	10046
135135	2134	97875637000	17428	8828	1	0	1121
135136	1397	1338359970000	17429	8829	0	0	10047
135138	2134	97874634000	17429	8829	2	0	1122
135139	1397	1338349969000	17430	8830	0	0	10048
135140	1756	6193109545609	17430	8830	1	0	5
135141	2134	97873631000	17430	8830	2	0	1123
135185	1397	1338830017000	17432	8766	39	0	\N
135186	1397	1338820016000	17432	8766	40	0	\N
135187	1397	1338810015000	17432	8766	41	0	\N
135188	1397	1338800014000	17432	8766	42	0	\N
135189	1397	1338790013000	17432	8766	43	0	\N
135190	1397	1338780012000	17432	8766	44	0	\N
135191	1397	1338770011000	17432	8766	45	0	\N
135192	1397	1338760010000	17432	8766	46	0	\N
135193	1397	1338750009000	17432	8766	47	0	\N
135194	1397	1338740008000	17432	8766	48	0	\N
135195	1397	1338730007000	17432	8766	49	0	\N
135196	1397	1338720006000	17432	8766	50	0	\N
135197	1397	1338710005000	17432	8766	51	0	\N
135198	1397	1338700004000	17432	8766	52	0	\N
135199	1397	1338690003000	17432	8766	53	0	\N
135200	1397	1338680002000	17432	8766	54	0	\N
135201	1397	1338670001000	17432	8766	55	0	\N
135202	1397	1338660000000	17432	8766	56	0	\N
135203	1397	1338649999000	17432	8766	57	0	\N
135204	1397	1338639998000	17432	8766	58	0	\N
135205	1397	1338629997000	17432	8766	59	0	\N
135206	1397	1338619996000	17432	8766	60	0	\N
135207	1397	1338609995000	17432	8766	61	0	\N
135208	1397	1338599994000	17432	8766	62	0	\N
135209	1397	1338589993000	17432	8766	63	0	\N
135210	1397	1338579992000	17432	8766	64	0	\N
135211	1397	1338569991000	17432	8766	65	0	\N
135212	1397	1338559990000	17432	8766	66	0	\N
135213	1397	1338549989000	17432	8766	67	0	\N
135214	1397	1338539988000	17432	8766	68	0	\N
135215	1397	1338529987000	17432	8766	69	0	\N
135216	1397	1338519986000	17432	8766	70	0	\N
135217	1397	1338509985000	17432	8766	71	0	\N
135218	1397	1338499984000	17432	8766	72	0	\N
135219	1397	1338489983000	17432	8766	73	0	\N
135220	1397	1338479982000	17432	8766	74	0	\N
135221	1397	1338469981000	17432	8766	75	0	\N
135222	1397	1338459980000	17432	8766	76	0	\N
135223	1397	1338449979000	17432	8766	77	0	\N
135224	1397	1338439978000	17432	8766	78	0	\N
135225	1397	1338429977000	17432	8766	79	0	\N
135226	1397	1338419976000	17432	8766	80	0	\N
135227	1397	1338409975000	17432	8766	81	0	\N
135228	1397	1338399974000	17432	8766	82	0	\N
135229	1397	1338389973000	17432	8766	83	0	\N
135230	1397	1338379972000	17432	8766	84	0	\N
135231	1397	1338369971000	17432	8766	85	0	\N
135232	1397	1338359970000	17432	8766	86	0	\N
135233	1397	1338349969000	17432	8766	87	0	\N
135234	1598	0	17432	8766	88	0	\N
135235	2134	97961895000	17432	8766	89	0	\N
135236	2133	97904814000	17432	8766	90	0	\N
135237	2133	97903812000	17432	8766	91	0	\N
135238	2133	97902810000	17432	8766	92	0	\N
135239	2133	97901808000	17432	8766	93	0	\N
135240	2133	97900806000	17432	8766	94	0	\N
135241	2133	97899804000	17432	8766	95	0	\N
135242	2133	97898802000	17432	8766	96	0	\N
135243	2133	97897800000	17432	8766	97	0	\N
135244	2133	97896798000	17432	8766	98	0	\N
135245	2133	97895796000	17432	8766	99	0	\N
135246	2133	97894794000	17432	8766	100	0	\N
135247	2133	97893792000	17432	8766	101	0	\N
135248	850	1155015381824210	17432	8766	102	0	\N
135249	2134	97960892000	17432	8766	103	0	\N
135250	2134	97959889000	17432	8766	104	0	\N
135251	2134	97958886000	17432	8766	105	0	\N
135252	2134	97957883000	17432	8766	106	0	\N
135253	2134	97956880000	17432	8766	107	0	\N
135254	2133	97892790000	17432	8766	108	0	\N
135255	2133	97891788000	17432	8766	109	0	\N
135256	2133	97890786000	17432	8766	110	0	\N
135257	2133	97889784000	17432	8766	111	0	\N
135258	2133	97888782000	17432	8766	112	0	\N
135259	2133	97887780000	17432	8766	113	0	\N
135260	2133	97886778000	17432	8766	114	0	\N
135261	2133	97885776000	17432	8766	115	0	\N
135262	2133	97884774000	17432	8766	116	0	\N
135263	2133	97883772000	17432	8766	117	0	\N
135264	2133	97882770000	17432	8766	118	0	\N
135265	2133	97881768000	17432	8766	119	0	\N
135266	2133	97880766000	17432	8766	120	0	\N
135267	2133	97879764000	17432	8766	121	0	\N
135268	2133	97878762000	17432	8766	122	0	\N
135269	2133	97877760000	17432	8766	123	0	\N
135270	2133	97876758000	17432	8766	124	0	\N
135271	2133	97875756000	17432	8766	125	0	\N
135272	1397	1338339968000	17433	8831	0	0	\N
135273	2134	97872628000	17433	8831	1	0	\N
135274	2133	97827660000	17433	8831	2	0	\N
135278	1397	1338339968000	17435	8831	0	0	\N
135279	2134	97872628000	17435	8831	1	0	\N
135280	2133	97827660000	17435	8831	2	0	\N
135284	1516	0	17437	8832	0	0	\N
135285	1397	1338329967000	17437	8832	1	0	\N
135286	2134	97871625000	17437	8832	2	0	\N
135287	1397	1338319966000	17438	8833	0	0	\N
135288	1397	1338309965000	17438	8833	1	0	\N
135289	2133	97826658000	17438	8833	2	0	\N
135290	2133	97825656000	17438	8833	3	0	\N
135291	2134	97870622000	17438	8833	5	0	\N
135292	2134	97869619000	17438	8833	6	0	\N
135293	1397	1338319966000	17439	8833	0	0	\N
135294	1397	1338309965000	17439	8833	1	0	\N
135295	2133	97826658000	17439	8833	2	0	\N
135296	2133	97825656000	17439	8833	3	0	\N
135297	2134	97870622000	17439	8833	5	0	\N
135298	2134	97869619000	17439	8833	6	0	\N
135299	1397	1338319966000	17440	8833	0	0	\N
135300	1397	1338309965000	17440	8833	1	0	\N
135301	2133	97826658000	17440	8833	2	0	\N
135302	2133	97825656000	17440	8833	3	0	\N
135303	2134	97870622000	17440	8833	5	0	\N
135304	2134	97869619000	17440	8833	6	0	\N
135311	1397	1338319966000	17442	8833	0	0	\N
135312	1397	1338309965000	17442	8833	1	0	\N
135313	2133	97826658000	17442	8833	2	0	\N
135314	2133	97825656000	17442	8833	3	0	\N
135315	2134	97870622000	17442	8833	5	0	\N
135316	2134	97869619000	17442	8833	6	0	\N
135317	1397	1338319966000	17443	8833	0	0	\N
135318	1397	1338309965000	17443	8833	1	0	\N
135319	2133	97826658000	17443	8833	2	0	\N
135320	2133	97825656000	17443	8833	3	0	\N
135277	2133	97827660000	17434	8831	2	0	1170
135281	1516	0	17436	8832	0	0	12
135282	1397	1338329967000	17436	8832	1	0	10050
135283	2134	97871625000	17436	8832	2	0	1125
135305	1397	1338319966000	17441	8833	0	0	10051
135307	2133	97826658000	17441	8833	2	0	1171
135308	2133	97825656000	17441	8833	3	0	1172
135309	2134	97870622000	17441	8833	5	0	1126
135310	2134	97869619000	17441	8833	6	0	1127
135321	2134	97870622000	17443	8833	5	0	\N
135322	2134	97869619000	17443	8833	6	0	\N
135325	1397	1338289963000	17445	8835	0	0	\N
135326	1397	1338279962000	17445	8835	1	0	\N
135327	2134	97867613000	17445	8835	2	0	\N
135328	2134	97866610000	17445	8835	3	0	\N
135329	2133	97824654000	17445	8835	4	0	\N
135330	2133	97823652000	17445	8835	5	0	\N
135337	1397	1338289963000	17447	8835	0	0	\N
135338	1397	1338279962000	17447	8835	1	0	\N
135339	2134	97867613000	17447	8835	2	0	\N
135340	2134	97866610000	17447	8835	3	0	\N
135341	2133	97824654000	17447	8835	4	0	\N
135342	2133	97823652000	17447	8835	5	0	\N
135345	1397	1338269961000	17449	8836	0	0	\N
135346	2134	97865607000	17449	8836	1	0	\N
135365	1687	2060007223172	17451	8568	0	0	\N
135366	420	66529373005524	17451	8568	1	0	\N
135367	1598	1200008000000	17451	8568	2	0	\N
135368	1397	1340860220000	17451	8568	3	0	\N
135369	1397	1340850219000	17451	8568	4	0	\N
135370	1693	11577607218470	17451	8568	5	0	\N
135371	1693	11494632030097	17451	8568	6	0	\N
135372	1693	11411656841724	17451	8568	7	0	\N
135373	1693	10647518778944	17451	8568	8	0	\N
135374	1693	10420507224236	17451	8568	9	0	\N
135375	1693	10337532035863	17451	8568	10	0	\N
135376	1693	10254556847490	17451	8568	11	0	\N
135377	1756	4929248285609	17451	8568	12	0	\N
135378	1726	125335109000	17451	8568	13	0	\N
135379	1693	10171581659117	17451	8568	14	0	\N
135380	1693	10088606470744	17451	8568	15	0	\N
135381	1693	10005631282371	17451	8568	16	0	\N
135382	1693	9922656093998	17451	8568	17	0	\N
135383	1397	1340840218000	17451	8568	18	0	\N
135384	1726	124125109000	17451	8568	19	0	\N
135385	1726	124105109000	17451	8568	20	0	\N
135386	1726	122895109000	17451	8568	21	0	\N
135387	1726	121685109000	17451	8568	22	0	\N
135388	1397	1340830217000	17451	8568	23	0	\N
135389	1397	1340820216000	17451	8568	24	0	\N
135390	1397	1340810215000	17451	8568	25	0	\N
135391	1397	1340800214000	17451	8568	26	0	\N
135392	1474	11793412000023	17451	8568	27	0	\N
135393	1397	1340790213000	17451	8568	28	0	\N
135394	1397	1340780212000	17451	8568	29	0	\N
135395	1397	1340770211000	17451	8568	30	0	\N
135396	1397	1340760210000	17451	8568	31	0	\N
135397	1397	1340750209000	17451	8568	32	0	\N
135398	1397	1340740208000	17451	8568	33	0	\N
135399	1397	1340730207000	17451	8568	34	0	\N
135400	1397	1340720206000	17451	8568	35	0	\N
135401	1397	1340710205000	17451	8568	36	0	\N
135402	1397	1340700204000	17451	8568	37	0	\N
135403	1397	1340690203000	17451	8568	38	0	\N
135404	1397	1340680202000	17451	8568	39	0	\N
135405	1397	1340670201000	17451	8568	40	0	\N
135406	1397	1340660200000	17451	8568	41	0	\N
135407	1397	1340650199000	17451	8568	42	0	\N
135408	1397	1340640198000	17451	8568	43	0	\N
135409	1397	1340630197000	17451	8568	44	0	\N
135410	1756	4753085545609	17451	8568	45	0	\N
135411	1397	1340620196000	17451	8568	47	0	\N
135412	1397	1340610195000	17451	8568	48	0	\N
135413	1397	1340600194000	17451	8568	49	0	\N
135414	1397	1340590193000	17451	8568	50	0	\N
135415	1397	1340580192000	17451	8568	51	0	\N
135416	1397	1340570191000	17451	8568	52	0	\N
135417	1397	1340560190000	17451	8568	53	0	\N
135418	1397	1340550189000	17451	8568	54	0	\N
135419	1397	1340540188000	17451	8568	55	0	\N
135420	1397	1340530187000	17451	8568	56	0	\N
135421	1397	1340520186000	17451	8568	57	0	\N
135422	1397	1340510185000	17451	8568	58	0	\N
135423	1397	1340500184000	17451	8568	59	0	\N
135424	1397	1340490183000	17451	8568	60	0	\N
135425	2135	719027000000	17451	8568	61	0	\N
135426	1397	1340480182000	17451	8568	62	0	\N
135427	1397	1340470181000	17451	8568	63	0	\N
135428	1397	1340460180000	17451	8568	64	0	\N
135429	1397	1340450179000	17451	8568	65	0	\N
135430	1397	1340440178000	17451	8568	66	0	\N
135431	1397	1340430177000	17451	8568	67	0	\N
135432	1397	1340420176000	17451	8568	68	0	\N
135433	1397	1340410175000	17451	8568	69	0	\N
135434	1397	1340400174000	17451	8568	70	0	\N
135435	1397	1340390173000	17451	8568	71	0	\N
135436	1397	1340380172000	17451	8568	72	0	\N
135437	1397	1340370171000	17451	8568	73	0	\N
135438	1397	1340360170000	17451	8568	74	0	\N
135439	1397	1340350169000	17451	8568	75	0	\N
135440	1397	1340340168000	17451	8568	76	0	\N
135441	1397	1340330167000	17451	8568	77	0	\N
135442	1397	1340320166000	17451	8568	78	0	\N
135443	1397	1340310165000	17451	8568	79	0	\N
135444	1397	1340300164000	17451	8568	80	0	\N
135445	1397	1340290163000	17451	8568	81	0	\N
135446	1397	1340280162000	17451	8568	82	0	\N
135447	1397	1340270161000	17451	8568	83	0	\N
135448	1397	1340260160000	17451	8568	84	0	\N
135449	1397	1340250159000	17451	8568	85	0	\N
135450	1397	1340240158000	17451	8568	86	0	\N
135451	1397	1340230157000	17451	8568	87	0	\N
135452	1397	1340220156000	17451	8568	88	0	\N
135453	1397	1340210155000	17451	8568	89	0	\N
135454	1397	1340200154000	17451	8568	90	0	\N
135455	1397	1340190153000	17451	8568	91	0	\N
135456	1397	1340180152000	17451	8568	92	0	\N
135331	1397	1338289963000	17446	8835	0	0	10054
135332	1397	1338279962000	17446	8835	1	0	10055
135333	2134	97867613000	17446	8835	2	0	1129
135334	2134	97866610000	17446	8835	3	0	1130
135335	2133	97824654000	17446	8835	4	0	1173
135343	1397	1338269961000	17448	8836	0	0	10056
135344	2134	97865607000	17448	8836	1	0	1131
135347	420	66529373005524	17450	8837	0	0	1
135348	1693	14457697218470	17450	8837	1	0	773
135349	1693	14374722030097	17450	8837	2	0	774
135351	1693	13527608778944	17450	8837	4	0	776
135352	1693	13300597224236	17450	8837	5	0	777
135353	1693	13217622035863	17450	8837	6	0	778
135354	1693	13134646847490	17450	8837	7	0	779
135356	1693	12968696470744	17450	8837	9	0	781
135357	1693	12885721282371	17450	8837	10	0	782
135358	1693	12802746093998	17450	8837	11	0	783
135359	1397	1338259960000	17450	8837	12	0	10057
135360	1397	1338249959000	17450	8837	13	0	10058
135362	2133	97822650000	17450	8837	15	0	1175
135363	2133	97821648000	17450	8837	16	0	1176
135364	2134	97863601000	17450	8837	17	0	1133
135457	1397	1340170151000	17451	8568	93	0	\N
135458	1397	1340160150000	17451	8568	94	0	\N
135459	1397	1340150149000	17451	8568	95	0	\N
135460	1397	1340140148000	17451	8568	96	0	\N
135461	1397	1340130147000	17451	8568	97	0	\N
135462	1397	1340120146000	17451	8568	98	0	\N
135463	1397	1340110145000	17451	8568	99	0	\N
135464	1397	1340100144000	17451	8568	100	0	\N
135465	1397	1340090143000	17451	8568	101	0	\N
135466	1397	1340080142000	17451	8568	102	0	\N
135467	1397	1340070141000	17451	8568	103	0	\N
135468	1397	1340060140000	17451	8568	104	0	\N
135469	1397	1340050139000	17451	8568	105	0	\N
135470	1397	1340040138000	17451	8568	106	0	\N
135471	1397	1340030137000	17451	8568	107	0	\N
135472	1397	1340020136000	17451	8568	108	0	\N
135473	1397	1340010135000	17451	8568	109	0	\N
135474	1397	1340000134000	17451	8568	110	0	\N
135475	1397	1339990133000	17451	8568	111	0	\N
135476	1397	1339980132000	17451	8568	112	0	\N
135477	1397	1339970131000	17451	8568	113	0	\N
135478	1397	1339960130000	17451	8568	114	0	\N
135479	1397	1339950129000	17451	8568	115	0	\N
135480	1397	1339940128000	17451	8568	116	0	\N
135481	1397	1339930127000	17451	8568	117	0	\N
135482	1397	1339920126000	17451	8568	118	0	\N
135483	1397	1339910125000	17451	8568	119	0	\N
135484	1397	1339900124000	17451	8568	120	0	\N
135485	1397	1339890123000	17451	8568	121	0	\N
135486	1397	1339880122000	17451	8568	122	0	\N
135487	1397	1339870121000	17451	8568	123	0	\N
135488	1397	1339860120000	17451	8568	124	0	\N
135489	1397	1339850119000	17451	8568	125	0	\N
135503	1397	1338229957000	17454	8839	0	0	\N
135504	1693	12387870152133	17454	8839	1	0	\N
135505	1693	12304894963760	17454	8839	2	0	\N
135506	1693	12221919775387	17454	8839	3	0	\N
135507	1693	12138944587014	17454	8839	4	0	\N
135508	1693	12055969398641	17454	8839	5	0	\N
135509	2133	97820646000	17454	8839	6	0	\N
135537	1693	11128074080782	17457	8841	0	0	\N
135538	1693	11045098892409	17457	8841	1	0	\N
135539	1397	1338209955000	17457	8841	2	0	\N
135540	1397	1338199954000	17457	8841	3	0	\N
135541	1693	10962123704036	17457	8841	4	0	\N
135542	1397	1338189953000	17457	8841	5	0	\N
135543	1397	1338179952000	17457	8841	6	0	\N
135544	420	66000263005524	17457	8841	7	0	\N
135545	1693	10879148515663	17457	8841	8	0	\N
135546	1693	10796173327290	17457	8841	9	0	\N
135547	1693	10713198138917	17457	8841	10	0	\N
135548	1693	10630222950544	17457	8841	11	0	\N
135549	1693	10621413612395	17457	8841	12	0	\N
135550	1693	10538438424022	17457	8841	13	0	\N
135551	1693	9906443549402	17457	8841	14	0	\N
135552	1693	9823468361029	17457	8841	15	0	\N
135553	1693	9740493172656	17457	8841	16	0	\N
135554	1693	9657517984283	17457	8841	17	0	\N
135555	1693	9574542795910	17457	8841	18	0	\N
135556	1693	9491567607537	17457	8841	19	0	\N
135557	1693	9408592419164	17457	8841	20	0	\N
135558	1693	9325617230791	17457	8841	21	0	\N
135559	1693	9242642042418	17457	8841	22	0	\N
135560	1693	9159666854045	17457	8841	23	0	\N
135561	1693	9076691665672	17457	8841	24	0	\N
135562	1693	6947370876272	17457	8841	25	0	\N
135563	1693	6864395687899	17457	8841	26	0	\N
135564	1693	6781420499526	17457	8841	27	0	\N
135565	2133	97818642000	17457	8841	28	0	\N
135566	2133	97817640000	17457	8841	29	0	\N
135567	2133	97816638000	17457	8841	30	0	\N
135568	2134	97860592000	17457	8841	31	0	\N
135569	2134	97859589000	17457	8841	32	0	\N
135570	2133	97815636000	17457	8841	33	0	\N
135571	2134	97858586000	17457	8841	34	0	\N
135572	2134	97857583000	17457	8841	35	0	\N
135573	1693	11128074080782	17458	8841	0	0	\N
135574	1693	11045098892409	17458	8841	1	0	\N
135575	1397	1338209955000	17458	8841	2	0	\N
135576	1397	1338199954000	17458	8841	3	0	\N
135577	1693	10962123704036	17458	8841	4	0	\N
135578	1397	1338189953000	17458	8841	5	0	\N
135579	1397	1338179952000	17458	8841	6	0	\N
135580	420	66000263005524	17458	8841	7	0	\N
135581	1693	10879148515663	17458	8841	8	0	\N
135582	1693	10796173327290	17458	8841	9	0	\N
135583	1693	10713198138917	17458	8841	10	0	\N
135584	1693	10630222950544	17458	8841	11	0	\N
135585	1693	10621413612395	17458	8841	12	0	\N
135586	1693	10538438424022	17458	8841	13	0	\N
135587	1693	9906443549402	17458	8841	14	0	\N
135588	1693	9823468361029	17458	8841	15	0	\N
135589	1693	9740493172656	17458	8841	16	0	\N
135590	1693	9657517984283	17458	8841	17	0	\N
135591	1693	9574542795910	17458	8841	18	0	\N
135592	1693	9491567607537	17458	8841	19	0	\N
135492	1693	12636795717252	17452	8838	2	0	785
135493	1693	12553820528879	17452	8838	3	0	786
135494	1693	12470845340506	17452	8838	4	0	787
135495	2134	97862598000	17452	8838	5	0	1134
135496	1397	1338229957000	17453	8839	0	0	10060
135498	1693	12304894963760	17453	8839	2	0	789
135499	1693	12221919775387	17453	8839	3	0	790
135500	1693	12138944587014	17453	8839	4	0	791
135501	1693	12055969398641	17453	8839	5	0	792
135502	2133	97820646000	17453	8839	6	0	1177
135511	1693	11972994210268	17455	8840	1	0	793
135512	1693	11890019021895	17455	8840	2	0	794
135513	1693	11887494925287	17455	8840	3	0	795
135514	1693	11804519736914	17455	8840	4	0	796
135516	2133	97819644000	17455	8840	6	0	1178
135517	2134	97861595000	17455	8840	7	0	1135
135518	1693	11128074080782	17456	8841	0	0	798
135519	1693	11045098892409	17456	8841	1	0	799
135520	1397	1338209955000	17456	8841	2	0	10062
135522	1693	10962123704036	17456	8841	4	0	800
135523	420	66000263005524	17456	8841	5	0	2
135524	1693	10879148515663	17456	8841	6	0	801
135525	1693	10796173327290	17456	8841	7	0	802
135526	1693	10713198138917	17456	8841	8	0	803
135528	1693	10621413612395	17456	8841	10	0	805
135529	1693	10538438424022	17456	8841	11	0	806
135530	1693	9906443549402	17456	8841	12	0	807
135531	1693	9823468361029	17456	8841	13	0	808
135533	2133	97818642000	17456	8841	15	0	1179
135534	2133	97817640000	17456	8841	16	0	1180
135535	2134	97860592000	17456	8841	17	0	1136
135536	2134	97859589000	17456	8841	18	0	1137
135593	1693	9408592419164	17458	8841	20	0	\N
135594	1693	9325617230791	17458	8841	21	0	\N
135595	1693	9242642042418	17458	8841	22	0	\N
135596	1693	9159666854045	17458	8841	23	0	\N
135597	1693	9076691665672	17458	8841	24	0	\N
135598	1693	6947370876272	17458	8841	25	0	\N
135599	1693	6864395687899	17458	8841	26	0	\N
135600	1693	6781420499526	17458	8841	27	0	\N
135601	2133	97818642000	17458	8841	28	0	\N
135602	2133	97817640000	17458	8841	29	0	\N
135603	2133	97816638000	17458	8841	30	0	\N
135604	2134	97860592000	17458	8841	31	0	\N
135605	2134	97859589000	17458	8841	32	0	\N
135606	2133	97815636000	17458	8841	33	0	\N
135607	2134	97858586000	17458	8841	34	0	\N
135608	2134	97857583000	17458	8841	35	0	\N
135635	1693	6698445311153	17461	8843	0	0	\N
135636	1693	6615470122780	17461	8843	1	0	\N
135637	1693	6532494934407	17461	8843	2	0	\N
135638	1693	6449519746034	17461	8843	3	0	\N
135639	1693	6366544557661	17461	8843	4	0	\N
135640	1693	6283569369288	17461	8843	5	0	\N
135641	1397	1338169951000	17461	8843	6	0	\N
135642	2133	97814634000	17461	8843	7	0	\N
135643	2134	97856580000	17461	8843	8	0	\N
135644	1397	1338189953000	17462	8842	0	0	\N
135645	1397	1338179952000	17462	8842	1	0	\N
135646	1693	9657517984283	17462	8842	2	0	\N
135647	1693	9574542795910	17462	8842	3	0	\N
135648	1693	9491567607537	17462	8842	4	0	\N
135649	1693	9408592419164	17462	8842	5	0	\N
135650	1693	9325617230791	17462	8842	6	0	\N
135651	1693	9242642042418	17462	8842	7	0	\N
135652	1693	9159666854045	17462	8842	8	0	\N
135653	1693	9076691665672	17462	8842	9	0	\N
135654	1693	6947370876272	17462	8842	10	0	\N
135655	1693	6864395687899	17462	8842	11	0	\N
135656	1693	6781420499526	17462	8842	12	0	\N
135657	1693	6698445311153	17462	8842	13	0	\N
135658	1693	6615470122780	17462	8842	14	0	\N
135659	1693	6532494934407	17462	8842	15	0	\N
135660	1693	6449519746034	17462	8842	16	0	\N
135661	1693	6366544557661	17462	8842	17	0	\N
135662	2133	97816638000	17462	8842	18	0	\N
135663	2133	97815636000	17462	8842	19	0	\N
135664	2133	97814634000	17462	8842	20	0	\N
135665	2134	97858586000	17462	8842	21	0	\N
135666	2134	97857583000	17462	8842	22	0	\N
135667	2134	97856580000	17462	8842	23	0	\N
135668	1397	1338189953000	17463	8842	0	0	\N
135669	1397	1338179952000	17463	8842	1	0	\N
135670	1397	1338169951000	17463	8842	2	0	\N
135671	1693	9657517984283	17463	8842	3	0	\N
135672	1693	9574542795910	17463	8842	4	0	\N
135673	1693	9491567607537	17463	8842	5	0	\N
135674	1693	9408592419164	17463	8842	6	0	\N
135675	1693	9325617230791	17463	8842	7	0	\N
135676	1693	9242642042418	17463	8842	8	0	\N
135677	1693	9159666854045	17463	8842	9	0	\N
135678	1693	9076691665672	17463	8842	10	0	\N
135679	1693	6947370876272	17463	8842	11	0	\N
135680	1693	6864395687899	17463	8842	12	0	\N
135681	1693	6781420499526	17463	8842	13	0	\N
135682	1693	6698445311153	17463	8842	14	0	\N
135683	1693	6615470122780	17463	8842	15	0	\N
135684	1693	6532494934407	17463	8842	16	0	\N
135685	1693	6449519746034	17463	8842	17	0	\N
135686	1693	6366544557661	17463	8842	18	0	\N
135687	2133	97816638000	17463	8842	19	0	\N
135688	2133	97815636000	17463	8842	20	0	\N
135689	2133	97814634000	17463	8842	21	0	\N
135690	2134	97858586000	17463	8842	22	0	\N
135691	2134	97857583000	17463	8842	23	0	\N
135692	2134	97856580000	17463	8842	24	0	\N
135693	1693	6200594180915	17464	8844	0	0	\N
135694	1693	6194298939379	17464	8844	1	0	\N
135695	1693	6111323751006	17464	8844	2	0	\N
135696	1693	6108799654398	17464	8844	3	0	\N
135697	1693	6025824466025	17464	8844	4	0	\N
135698	1693	5942849277652	17464	8844	5	0	\N
135699	1397	1338159950000	17464	8844	6	0	\N
135700	1397	1338149949000	17464	8844	7	0	\N
135701	1693	5557148049236	17464	8844	8	0	\N
135702	1693	5474172860863	17464	8844	10	0	\N
135703	2133	97813632000	17464	8844	11	0	\N
135704	2134	97855577000	17464	8844	12	0	\N
135705	2134	97854574000	17464	8844	13	0	\N
135711	1687	3500031223172	17466	8745	0	0	\N
135712	420	66529373005524	17466	8745	1	0	\N
135713	1693	13737662218470	17466	8745	2	0	\N
135714	1693	13654687030097	17466	8745	3	0	\N
135715	1693	13571711841724	17466	8745	4	0	\N
135716	1693	12807573778944	17466	8745	5	0	\N
135717	1693	12580562224236	17466	8745	6	0	\N
135718	1693	12497587035863	17466	8745	7	0	\N
135719	1693	12414611847490	17466	8745	8	0	\N
135720	1756	6369272285609	17466	8745	9	0	\N
135721	1397	1339490083000	17466	8745	10	0	\N
135722	1397	1339480082000	17466	8745	11	0	\N
135723	1397	1339470081000	17466	8745	12	0	\N
135724	1397	1339460080000	17466	8745	13	0	\N
135725	1397	1339450079000	17466	8745	14	0	\N
135726	1397	1339440078000	17466	8745	15	0	\N
135727	1693	12331636659117	17466	8745	16	0	\N
135728	1693	12248661470744	17466	8745	17	0	\N
135611	1693	9657517984283	17459	8842	2	0	810
135612	1693	9574542795910	17459	8842	3	0	811
135613	1693	9491567607537	17459	8842	4	0	812
135614	1693	9408592419164	17459	8842	5	0	813
135615	1693	9325617230791	17459	8842	6	0	814
135617	1693	9159666854045	17459	8842	8	0	816
135618	1693	9076691665672	17459	8842	9	0	817
135619	1693	6947370876272	17459	8842	10	0	818
135620	1693	6864395687899	17459	8842	11	0	819
135621	1693	6781420499526	17459	8842	12	0	820
135623	2133	97815636000	17459	8842	14	0	1182
135624	2134	97858586000	17459	8842	15	0	1138
135625	2134	97857583000	17459	8842	16	0	1139
135626	1693	6698445311153	17460	8843	0	0	821
135628	1693	6532494934407	17460	8843	2	0	823
135629	1693	6449519746034	17460	8843	3	0	824
135630	1693	6366544557661	17460	8843	4	0	825
135631	1693	6283569369288	17460	8843	5	0	826
135632	1397	1338169951000	17460	8843	6	0	10066
135634	2134	97856580000	17460	8843	8	0	1140
135706	1397	1338159950000	17465	8844	0	0	10067
135707	1397	1338149949000	17465	8844	1	0	10068
135708	2133	97813632000	17465	8844	2	0	1184
135709	2134	97855577000	17465	8844	3	0	1141
135729	1693	12165686282371	17466	8745	18	0	\N
135730	1693	12082711093998	17466	8745	19	0	\N
135731	1693	11999735905625	17466	8745	20	0	\N
135732	1693	11916760717252	17466	8745	21	0	\N
135733	1693	11833785528879	17466	8745	22	0	\N
135734	420	66000263005524	17466	8745	23	0	\N
135735	1693	11750810340506	17466	8745	24	0	\N
135736	1693	11667835152133	17466	8745	25	0	\N
135737	1693	11584859963760	17466	8745	26	0	\N
135738	1693	11501884775387	17466	8745	27	0	\N
135739	1693	11418909587014	17466	8745	28	0	\N
135740	1693	11335934398641	17466	8745	29	0	\N
135741	1693	11252959210268	17466	8745	30	0	\N
135742	1693	11169984021895	17466	8745	31	0	\N
135743	1693	11167459925287	17466	8745	32	0	\N
135744	1693	11084484736914	17466	8745	33	0	\N
135745	1693	10491014269155	17466	8745	34	0	\N
135746	1693	10408039080782	17466	8745	36	0	\N
135747	1693	10325063892409	17466	8745	37	0	\N
135748	1693	10242088704036	17466	8745	38	0	\N
135749	1756	6193109545609	17466	8745	39	0	\N
135750	1397	1339430077000	17466	8745	40	0	\N
135751	1397	1339420076000	17466	8745	41	0	\N
135752	1397	1339410075000	17466	8745	42	0	\N
135753	1397	1339400074000	17466	8745	43	0	\N
135754	1397	1339390073000	17466	8745	44	0	\N
135755	1397	1339380072000	17466	8745	45	0	\N
135756	1397	1339370071000	17466	8745	46	0	\N
135757	1397	1339360070000	17466	8745	47	0	\N
135758	1397	1339350069000	17466	8745	48	0	\N
135759	1397	1339340068000	17466	8745	49	0	\N
135760	1397	1339330067000	17466	8745	50	0	\N
135761	1397	1339320066000	17466	8745	51	0	\N
135762	1397	1339310065000	17466	8745	52	0	\N
135763	1397	1339300064000	17466	8745	53	0	\N
135764	1397	1339290063000	17466	8745	54	0	\N
135765	1397	1339280062000	17466	8745	55	0	\N
135766	1397	1339270061000	17466	8745	56	0	\N
135767	1397	1339260060000	17466	8745	57	0	\N
135768	2135	719027000000	17466	8745	58	0	\N
135769	1693	10159113515663	17466	8745	59	0	\N
135770	1693	10076138327290	17466	8745	60	0	\N
135771	1693	9993163138917	17466	8745	61	0	\N
135772	1693	9910187950544	17466	8745	62	0	\N
135773	1693	9901378612395	17466	8745	63	0	\N
135774	1693	9818403424022	17466	8745	64	0	\N
135775	1693	9186408549402	17466	8745	65	0	\N
135776	1693	9103433361029	17466	8745	66	0	\N
135777	1693	9020458172656	17466	8745	67	0	\N
135778	1693	8937482984283	17466	8745	68	0	\N
135779	1693	8854507795910	17466	8745	69	0	\N
135780	1693	8771532607537	17466	8745	70	0	\N
135781	1693	8688557419164	17466	8745	71	0	\N
135782	1693	8605582230791	17466	8745	72	0	\N
135783	1693	8522607042418	17466	8745	73	0	\N
135784	1693	8439631854045	17466	8745	74	0	\N
135785	1693	8356656665672	17466	8745	75	0	\N
135786	1693	6227335876272	17466	8745	76	0	\N
135787	1693	6144360687899	17466	8745	77	0	\N
135788	1693	6061385499526	17466	8745	78	0	\N
135789	1693	5978410311153	17466	8745	79	0	\N
135790	1693	5895435122780	17466	8745	80	0	\N
135791	1693	5812459934407	17466	8745	81	0	\N
135792	1693	5729484746034	17466	8745	82	0	\N
135793	1693	5646509557661	17466	8745	83	0	\N
135794	1693	5563534369288	17466	8745	84	0	\N
135795	1693	5480559180915	17466	8745	85	0	\N
135796	1693	5474263939379	17466	8745	86	0	\N
135797	1693	5391288751006	17466	8745	87	0	\N
135798	1693	5388764654398	17466	8745	88	0	\N
135799	1693	5305789466025	17466	8745	89	0	\N
135800	1693	5222814277652	17466	8745	90	0	\N
135801	1693	4837113049236	17466	8745	91	0	\N
135802	1693	4754137860863	17466	8745	92	0	\N
135803	1397	1339250059000	17466	8745	93	0	\N
135804	1397	1339240058000	17466	8745	94	0	\N
135805	1397	1339230057000	17466	8745	95	0	\N
135806	1397	1339220056000	17466	8745	96	0	\N
135807	1397	1339210055000	17466	8745	97	0	\N
135808	1397	1339200054000	17466	8745	98	0	\N
135809	1397	1339190053000	17466	8745	99	0	\N
135810	1397	1339180052000	17466	8745	100	0	\N
135811	1397	1339170051000	17466	8745	101	0	\N
135812	1397	1339160050000	17466	8745	102	0	\N
135813	1397	1339150049000	17466	8745	103	0	\N
135814	1397	1339140048000	17466	8745	104	0	\N
135815	1397	1339130047000	17466	8745	105	0	\N
135816	1397	1339120046000	17466	8745	106	0	\N
135817	1397	1339110045000	17466	8745	107	0	\N
135818	1397	1339100044000	17466	8745	108	0	\N
135819	1397	1339090043000	17466	8745	109	0	\N
135820	1397	1339080042000	17466	8745	110	0	\N
135821	1397	1339070041000	17466	8745	111	0	\N
135822	1397	1339060040000	17466	8745	112	0	\N
135823	1397	1339050039000	17466	8745	113	0	\N
135824	1397	1339040038000	17466	8745	114	0	\N
135825	1397	1339030037000	17466	8745	115	0	\N
135826	1397	1339020036000	17466	8745	116	0	\N
135827	1397	1339010035000	17466	8745	117	0	\N
135828	1397	1339000034000	17466	8745	118	0	\N
135829	1397	1338990033000	17466	8745	119	0	\N
135830	1397	1338980032000	17466	8745	120	0	\N
135831	1397	1338970031000	17466	8745	121	0	\N
135832	1397	1338960030000	17466	8745	122	0	\N
135833	1397	1338950029000	17466	8745	123	0	\N
135834	1397	1338940028000	17466	8745	124	0	\N
135835	1397	1338930027000	17466	8745	125	0	\N
135836	1693	6200594180915	17467	8845	0	0	\N
135837	1693	6194298939379	17467	8845	1	0	\N
135838	1693	6111323751006	17467	8845	3	0	\N
135839	1693	6108799654398	17467	8845	4	0	\N
135840	1693	6025824466025	17467	8845	5	0	\N
135841	1693	5942849277652	17467	8845	6	0	\N
135842	1397	1338139948000	17467	8845	7	0	\N
135843	1397	1338129947000	17467	8845	8	0	\N
135844	1693	5557148049236	17467	8845	9	0	\N
135845	1693	5474172860863	17467	8845	10	0	\N
135846	2164	529599000000	17467	8845	11	0	\N
135847	2133	97812630000	17467	8845	12	0	\N
135848	1693	6200594180915	17468	8845	0	0	\N
135849	1693	6194298939379	17468	8845	1	0	\N
135850	1693	6111323751006	17468	8845	3	0	\N
135851	1693	6108799654398	17468	8845	4	0	\N
135852	1693	6025824466025	17468	8845	5	0	\N
135853	1693	5942849277652	17468	8845	6	0	\N
135854	1397	1338139948000	17468	8845	7	0	\N
135855	1397	1338129947000	17468	8845	8	0	\N
135856	1693	5557148049236	17468	8845	9	0	\N
135857	1693	5474172860863	17468	8845	10	0	\N
135858	1693	5450027533343	17468	8845	11	0	\N
135859	1693	5367052344970	17468	8845	12	0	\N
135860	1693	5284077156597	17468	8845	13	0	\N
135861	1693	4151555676097	17468	8845	14	0	\N
135862	1693	4068580487724	17468	8845	15	0	\N
135863	1693	3985605299351	17468	8845	16	0	\N
135864	1693	3902630110978	17468	8845	17	0	\N
135865	1693	3819654922605	17468	8845	18	0	\N
135866	1693	3433953694189	17468	8845	19	0	\N
135867	1693	3350978505816	17468	8845	20	0	\N
135868	1693	3268003317443	17468	8845	21	0	\N
135869	1693	3185028129070	17468	8845	22	0	\N
135870	2134	97853571000	17468	8845	23	0	\N
135871	2164	529599000000	17468	8845	24	0	\N
135872	2134	97852568000	17468	8845	25	0	\N
135873	2133	97812630000	17468	8845	26	0	\N
135907	1693	6025824466025	17474	8846	0	0	\N
135908	1693	5942849277652	17474	8846	1	0	\N
135909	1397	1338139948000	17474	8846	2	0	\N
135910	1397	1338129947000	17474	8846	3	0	\N
135911	1397	1338119946000	17474	8846	4	0	\N
135912	1693	5557148049236	17474	8846	5	0	\N
135913	1693	5474172860863	17474	8846	6	0	\N
135914	1693	5450027533343	17474	8846	7	0	\N
135915	1693	5367052344970	17474	8846	8	0	\N
135916	1693	5284077156597	17474	8846	9	0	\N
135917	1693	4151555676097	17474	8846	10	0	\N
135918	1693	4068580487724	17474	8846	11	0	\N
135919	1693	3985605299351	17474	8846	12	0	\N
135920	1693	3902630110978	17474	8846	13	0	\N
135921	1693	3819654922605	17474	8846	14	0	\N
135922	1693	3433953694189	17474	8846	15	0	\N
135923	1693	3350978505816	17474	8846	16	0	\N
135924	1693	3268003317443	17474	8846	17	0	\N
135925	1693	3185028129070	17474	8846	18	0	\N
135926	1693	3102052940697	17474	8846	19	0	\N
135927	1693	3019077752324	17474	8846	20	0	\N
135928	1693	2936102563951	17474	8846	21	0	\N
135929	1693	2853127375578	17474	8846	22	0	\N
135930	2134	97853571000	17474	8846	23	0	\N
135931	2164	529599000000	17474	8846	24	0	\N
135932	2134	97852568000	17474	8846	25	0	\N
135933	2133	97812630000	17474	8846	26	0	\N
135934	2133	97811628000	17474	8846	27	0	\N
135935	2134	97851565000	17474	8846	28	0	\N
135951	1397	1338069941000	17478	8850	0	0	\N
135952	1693	2604201810459	17478	8850	1	0	\N
135953	1693	2521226622086	17478	8850	2	0	\N
135954	1693	2438251433713	17478	8850	3	0	\N
135955	1693	2355276245340	17478	8850	4	0	\N
135956	1693	2272301056967	17478	8850	5	0	\N
135957	2133	97806618000	17478	8850	6	0	\N
135958	2134	97846550000	17478	8850	7	0	\N
135959	1397	1338069941000	17479	8850	0	0	\N
135960	1693	2604201810459	17479	8850	1	0	\N
135961	1693	2521226622086	17479	8850	2	0	\N
135962	1693	2438251433713	17479	8850	3	0	\N
135963	1693	2355276245340	17479	8850	4	0	\N
135964	1693	2272301056967	17479	8850	5	0	\N
135965	2133	97806618000	17479	8850	6	0	\N
135966	2134	97846550000	17479	8850	7	0	\N
135975	1693	2189325868594	17481	8851	0	0	\N
135976	1397	1338059940000	17481	8851	1	0	\N
135977	1693	2106350680221	17481	8851	2	0	\N
135978	1693	2023375491848	17481	8851	3	0	\N
135979	1693	1940400303475	17481	8851	4	0	\N
135980	1693	1857425115102	17481	8851	5	0	\N
135981	2134	97845547000	17481	8851	6	0	\N
135982	2133	97805616000	17481	8851	7	0	\N
135990	1693	2189325868594	17483	8851	0	0	\N
135991	1397	1338059940000	17483	8851	1	0	\N
135992	1693	2106350680221	17483	8851	2	0	\N
135993	1693	2023375491848	17483	8851	3	0	\N
135994	1693	1940400303475	17483	8851	4	0	\N
135995	1693	1857425115102	17483	8851	5	0	\N
135996	2134	97845547000	17483	8851	6	0	\N
135997	2133	97805616000	17483	8851	7	0	\N
135998	1693	1774449926729	17484	8852	0	0	\N
135999	1693	1691474738356	17484	8852	1	0	\N
136000	1397	1338049939000	17484	8852	2	0	\N
135876	1693	6111323751006	17469	8845	3	0	829
135877	1693	6108799654398	17469	8845	4	0	830
135878	1693	6025824466025	17472	8846	0	0	831
135879	1693	5942849277652	17472	8846	1	0	832
135880	1397	1338139948000	17472	8846	2	0	10069
135882	1397	1338119946000	17472	8846	4	0	10071
135883	1693	5557148049236	17472	8846	5	0	833
135884	1693	5474172860863	17472	8846	6	0	834
135885	1693	5450027533343	17472	8846	7	0	835
135886	1693	5367052344970	17472	8846	8	0	836
135888	1693	4151555676097	17472	8846	10	0	838
135889	1693	4068580487724	17472	8846	11	0	839
135890	1693	3985605299351	17472	8846	12	0	840
135891	1693	3902630110978	17472	8846	13	0	841
135893	1693	3433953694189	17472	8846	15	0	843
135894	1693	3350978505816	17472	8846	16	0	844
135895	1693	3268003317443	17472	8846	17	0	845
135896	1693	3185028129070	17472	8846	18	0	846
135897	1693	3102052940697	17472	8846	19	0	847
135899	1693	2936102563951	17472	8846	21	0	849
135900	1693	2853127375578	17472	8846	22	0	850
135901	2134	97853571000	17472	8846	23	0	1143
135902	2164	529599000000	17472	8846	24	0	1
135903	2134	97852568000	17472	8846	25	0	1144
135905	2133	97811628000	17472	8846	27	0	1186
135906	2134	97851565000	17472	8846	28	0	1145
135936	1397	1338109945000	17475	8847	0	0	10072
135937	2134	97850562000	17475	8847	1	0	1146
135939	1397	1338099944000	17476	8848	0	0	10073
135940	2134	97849559000	17476	8848	1	0	1147
135941	2133	97809624000	17476	8848	2	0	1188
135942	1693	2770152187205	17477	8849	0	0	851
135943	1673	22646014000000	17477	8849	1	0	9
135945	1397	1338079942000	17477	8849	3	0	10075
135946	1693	2687176998832	17477	8849	4	0	852
135947	2133	97808622000	17477	8849	5	0	1189
135948	2134	97848556000	17477	8849	6	0	1148
135949	2134	97847553000	17477	8849	7	0	1149
135967	1397	1338069941000	17480	8850	0	0	10076
135968	1693	2604201810459	17480	8850	1	0	853
135969	1693	2521226622086	17480	8850	2	0	854
135970	1693	2438251433713	17480	8850	3	0	855
135972	1693	2272301056967	17480	8850	5	0	857
135973	2133	97806618000	17480	8850	6	0	1191
135974	2134	97846550000	17480	8850	7	0	1150
135983	1693	2189325868594	17482	8851	0	0	858
135984	1397	1338059940000	17482	8851	1	0	10077
135986	1693	2023375491848	17482	8851	3	0	860
135987	1693	1940400303475	17482	8851	4	0	861
135988	1693	1857425115102	17482	8851	5	0	862
135989	2133	97805616000	17482	8851	6	0	1192
136001	1693	1688950641748	17484	8852	3	0	\N
136002	1693	1605975453375	17484	8852	4	0	\N
136003	2134	97845547000	17484	8852	5	0	\N
136004	2134	97844544000	17484	8852	6	0	\N
136005	2133	97804614000	17484	8852	7	0	\N
136006	1693	1774449926729	17485	8852	0	0	\N
136007	1693	1691474738356	17485	8852	1	0	\N
136008	1397	1338049939000	17485	8852	2	0	\N
136009	1693	1688950641748	17485	8852	3	0	\N
136010	1693	1605975453375	17485	8852	4	0	\N
136011	2133	97804614000	17485	8852	5	0	\N
136012	1693	1774449926729	17486	8852	0	0	\N
136013	1693	1691474738356	17486	8852	1	0	\N
136014	1397	1338049939000	17486	8852	2	0	\N
136015	1693	1688950641748	17486	8852	3	0	\N
136016	1693	1605975453375	17486	8852	4	0	\N
136017	2134	97845547000	17486	8852	5	0	\N
136018	2134	97844544000	17486	8852	6	0	\N
136019	2133	97804614000	17486	8852	7	0	\N
136020	1693	1774449926729	17487	8852	0	0	\N
136021	1693	1691474738356	17487	8852	1	0	\N
136022	1397	1338049939000	17487	8852	2	0	\N
136023	1693	1688950641748	17487	8852	3	0	\N
136024	1693	1605975453375	17487	8852	4	0	\N
136025	2134	97845547000	17487	8852	5	0	\N
136026	2134	97844544000	17487	8852	6	0	\N
136027	2133	97804614000	17487	8852	7	0	\N
136045	1397	1338029937000	17490	8854	0	0	\N
136046	1693	1191099511510	17490	8854	1	0	\N
136047	1693	1108124323137	17490	8854	2	0	\N
136048	1693	1025149134764	17490	8854	3	0	\N
136049	1693	942173946391	17490	8854	4	0	\N
136050	1693	859198758018	17490	8854	5	0	\N
136051	2133	97802610000	17490	8854	6	0	\N
136052	2134	97842538000	17490	8854	7	0	\N
136053	1397	1338029937000	17491	8854	0	0	\N
136054	1693	1191099511510	17491	8854	1	0	\N
136055	1693	1108124323137	17491	8854	2	0	\N
136056	1693	1025149134764	17491	8854	3	0	\N
136057	1693	942173946391	17491	8854	4	0	\N
136058	1693	859198758018	17491	8854	5	0	\N
136059	2133	97802610000	17491	8854	6	0	\N
136060	2134	97842538000	17491	8854	7	0	\N
136071	1397	1338009935000	17494	8856	0	0	\N
136072	2134	97840532000	17494	8856	1	0	\N
136081	1397	1337979932000	17499	8859	0	0	\N
136082	2134	97837523000	17499	8859	1	0	\N
136083	1397	1337979932000	17500	8859	0	0	\N
136084	2134	97837523000	17500	8859	1	0	\N
136097	1397	1337939928000	17504	8863	0	0	\N
136098	1397	1337929927000	17504	8863	1	0	\N
136099	2133	97795596000	17504	8863	2	0	\N
136100	2134	97833511000	17504	8863	3	0	\N
136101	2134	97832508000	17504	8863	4	0	\N
136102	2133	97794594000	17504	8863	5	0	\N
136109	1397	1337939928000	17506	8863	0	0	\N
136110	1397	1337929927000	17506	8863	1	0	\N
136111	2133	97795596000	17506	8863	2	0	\N
136112	2134	97833511000	17506	8863	3	0	\N
136113	2134	97832508000	17506	8863	4	0	\N
136114	2133	97794594000	17506	8863	5	0	\N
136115	1397	1337919926000	17507	8864	0	0	\N
136116	2133	97793592000	17507	8864	1	0	\N
136117	2134	97831505000	17507	8864	2	0	\N
136133	1397	1337919926000	17511	8865	0	0	\N
136134	1397	1337909925000	17511	8865	1	0	\N
136135	1397	1337899924000	17511	8865	2	0	\N
136136	1397	1337889923000	17511	8865	3	0	\N
136030	1397	1338049939000	17488	8852	2	0	10078
136031	1693	1688950641748	17488	8852	3	0	865
136032	1693	1605975453375	17488	8852	4	0	866
136033	2134	97845547000	17488	8852	5	0	1151
136034	2134	97844544000	17488	8852	6	0	1152
136036	1673	22645484000000	17489	8853	0	0	10
136037	1693	1523000265002	17489	8853	1	0	867
136038	1397	1338039938000	17489	8853	2	0	10079
136039	1693	1440025076629	17489	8853	3	0	868
136040	1693	1357049888256	17489	8853	4	0	869
136042	2133	97803612000	17489	8853	6	0	1194
136043	2134	97843541000	17489	8853	7	0	1153
136044	1926	1193000000	17489	8853	8	0	7
136061	1397	1338029937000	17492	8854	0	0	10080
136063	1693	1108124323137	17492	8854	2	0	872
136064	1693	1025149134764	17492	8854	3	0	873
136065	1693	942173946391	17492	8854	4	0	874
136066	1693	859198758018	17492	8854	5	0	875
136067	2133	97802610000	17492	8854	6	0	1195
136069	1397	1338019936000	17493	8855	0	0	10081
136070	2134	97841535000	17493	8855	1	0	1155
136073	1397	1338009935000	17495	8856	0	0	10082
136074	2134	97840532000	17495	8856	1	0	1156
136075	1397	1337999934000	17496	8857	0	0	10083
136077	1397	1337989933000	17497	8858	0	0	10084
136078	2134	97838526000	17497	8858	1	0	1158
136079	1397	1337979932000	17498	8859	0	0	10085
136080	2134	97837523000	17498	8859	1	0	1159
136086	2134	97836520000	17501	8860	2	0	1160
136087	2133	97801608000	17501	8860	3	0	1196
136088	2133	97800606000	17501	8860	4	0	1197
136089	2133	97799604000	17501	8860	5	0	1198
136090	2133	97798602000	17501	8860	6	0	1199
136092	2134	97835517000	17502	8861	1	0	1161
136093	2133	97797600000	17502	8861	2	0	1200
136094	1397	1337949929000	17503	8862	0	0	10088
136095	2133	97796598000	17503	8862	1	0	1201
136096	2134	97834514000	17503	8862	2	0	1162
136104	1397	1337929927000	17505	8863	1	0	10090
136105	2133	97795596000	17505	8863	2	0	1202
136106	2134	97833511000	17505	8863	3	0	1163
136107	2134	97832508000	17505	8863	4	0	1164
136118	2134	97831505000	17508	8864	0	0	1165
136119	1397	1337919926000	17509	8865	0	0	10091
136120	1397	1337909925000	17509	8865	1	0	10092
136121	2133	97793592000	17509	8865	2	0	1204
136122	2134	97830502000	17509	8865	3	0	1166
136124	1397	1337899924000	17510	8866	0	0	10093
136125	1397	1337889923000	17510	8866	1	0	10094
136126	1397	1337879922000	17510	8866	2	0	10095
136127	2133	97791588000	17510	8866	3	0	1206
136128	2133	97790586000	17510	8866	4	0	1207
136130	2134	97828496000	17510	8866	6	0	1168
136131	2134	97827493000	17510	8866	7	0	1169
136132	2133	97789584000	17510	8866	8	0	1208
136137	1397	1337879922000	17511	8865	4	0	\N
136138	2133	97793592000	17511	8865	5	0	\N
136139	2134	97830502000	17511	8865	6	0	\N
136140	2134	97829499000	17511	8865	7	0	\N
136141	2134	97828496000	17511	8865	8	0	\N
136142	2133	97792590000	17511	8865	9	0	\N
136143	2133	97791588000	17511	8865	10	0	\N
136144	2133	97790586000	17511	8865	11	0	\N
136145	2134	97827493000	17511	8865	12	0	\N
136146	2133	97789584000	17511	8865	13	0	\N
136147	1397	1337899924000	17512	8866	0	0	\N
136148	1397	1337889923000	17512	8866	1	0	\N
136149	1397	1337879922000	17512	8866	2	0	\N
136150	2133	97791588000	17512	8866	3	0	\N
136151	2133	97790586000	17512	8866	4	0	\N
136152	2134	97829499000	17512	8866	5	0	\N
136153	2134	97828496000	17512	8866	6	0	\N
136154	2134	97827493000	17512	8866	7	0	\N
136155	2133	97789584000	17512	8866	8	0	\N
136161	1397	1337859920000	17515	8868	0	0	\N
136162	2134	97825487000	17515	8868	1	0	\N
136163	2133	97788582000	17515	8868	2	0	\N
136166	1397	1337839918000	17517	8870	0	0	\N
136167	1924	1195000000	17517	8870	1	0	\N
136168	2134	97823481000	17517	8870	2	0	\N
136172	1397	1337839918000	17519	8870	0	0	\N
136173	1924	1195000000	17519	8870	1	0	\N
136174	2134	97823481000	17519	8870	2	0	\N
136177	1397	1337829917000	17521	8871	0	0	\N
136178	2134	97822478000	17521	8871	1	0	\N
136179	1397	1337829917000	17522	8871	0	0	\N
136180	2134	97822478000	17522	8871	1	0	\N
136183	1397	1337819916000	17524	8872	0	0	\N
136184	2134	97821475000	17524	8872	1	0	\N
136210	1397	1337749909000	17529	8876	0	0	\N
136211	2133	97779564000	17529	8876	1	0	\N
136212	2133	97778562000	17529	8876	2	0	\N
136213	2134	97814454000	17529	8876	3	0	\N
136214	2134	97813451000	17529	8876	4	0	\N
136215	1397	1337749909000	17530	8876	0	0	\N
136216	2133	97779564000	17530	8876	1	0	\N
136217	2133	97778562000	17530	8876	2	0	\N
136218	2134	97814454000	17530	8876	3	0	\N
136219	2134	97813451000	17530	8876	4	0	\N
136229	1397	1337709905000	17534	8880	0	0	\N
136230	1397	1337699904000	17534	8880	1	0	\N
136231	1397	1337689903000	17534	8880	2	0	\N
136232	1397	1337679902000	17534	8880	3	0	\N
136233	2134	97809439000	17534	8880	4	0	\N
136234	2134	97808436000	17534	8880	5	0	\N
136235	2133	97774554000	17534	8880	6	0	\N
136236	2133	97773552000	17534	8880	8	0	\N
136237	2133	97772550000	17534	8880	9	0	\N
136238	2133	97771548000	17534	8880	10	0	\N
136239	2134	97807433000	17534	8880	11	0	\N
136240	2134	97806430000	17534	8880	12	0	\N
136256	1397	1337669901000	17537	8881	0	0	\N
136257	2134	97805427000	17537	8881	1	0	\N
136258	2133	97770546000	17537	8881	2	0	\N
136259	1924	1195000000	17538	8852	0	0	\N
136260	2134	97845547000	17538	8852	1	0	\N
136261	1926	1193000000	17538	8852	2	0	\N
136265	1397	1337659900000	17540	8882	0	0	\N
136266	2134	97804424000	17540	8882	1	0	\N
136267	2133	97769544000	17540	8882	2	0	\N
136268	1397	1337649899000	17541	8883	0	0	\N
136269	1397	1337639898000	17541	8883	1	0	\N
136270	2134	97803421000	17541	8883	2	0	\N
136271	2134	97802418000	17541	8883	3	0	\N
136272	2133	97768542000	17541	8883	4	0	\N
136158	1397	1337859920000	17514	8868	0	0	10097
136159	2134	97825487000	17514	8868	1	0	1171
136160	2133	97788582000	17514	8868	2	0	1209
136164	1397	1337849919000	17516	8869	0	0	10098
136165	2134	97824484000	17516	8869	1	0	1172
136170	1924	1195000000	17518	8870	1	0	5
136171	2134	97823481000	17518	8870	2	0	1173
136175	1397	1337829917000	17520	8871	0	0	10100
136176	2134	97822478000	17520	8871	1	0	1174
136181	1397	1337819916000	17523	8872	0	0	10101
136185	1397	1337809915000	17525	8873	0	0	10102
136186	1397	1337799914000	17525	8873	1	0	10103
136187	2133	97787580000	17525	8873	2	0	1210
136188	2133	97786578000	17525	8873	3	0	1211
136190	2134	97819469000	17525	8873	5	0	1177
136191	2133	97785576000	17525	8873	6	0	1212
136192	2133	97784574000	17525	8873	7	0	1213
136193	1397	1337789913000	17526	8874	0	0	10104
136194	1397	1337779912000	17526	8874	1	0	10105
136196	2134	97818466000	17526	8874	3	0	1178
136197	2134	97817463000	17526	8874	4	0	1179
136198	2133	97783572000	17526	8874	5	0	1214
136199	2133	97782570000	17526	8874	6	0	1215
136200	2133	97781568000	17526	8874	7	0	1216
136202	1397	1337759910000	17527	8875	0	0	10107
136203	2133	97780566000	17527	8875	1	0	1217
136204	2134	97815457000	17527	8875	2	0	1181
136205	1397	1337749909000	17528	8876	0	0	10108
136207	2133	97778562000	17528	8876	2	0	1219
136208	2134	97814454000	17528	8876	3	0	1182
136209	2134	97813451000	17528	8876	4	0	1183
136220	1397	1337739908000	17531	8877	0	0	10109
136221	2134	97812448000	17531	8877	1	0	1184
136223	1397	1337729907000	17532	8878	0	0	10110
136224	2134	97811445000	17532	8878	1	0	1185
136225	2133	97776558000	17532	8878	2	0	1221
136226	1397	1337719906000	17533	8879	0	0	10111
136227	2133	97775556000	17533	8879	1	0	1222
136241	1397	1337709905000	17535	8880	0	0	10112
136242	1397	1337699904000	17535	8880	1	0	10113
136243	1397	1337689903000	17535	8880	2	0	10114
136244	1397	1337679902000	17535	8880	3	0	10115
136246	2134	97808436000	17535	8880	5	0	1188
136247	2133	97774554000	17535	8880	6	0	1223
136248	2133	97773552000	17535	8880	8	0	1224
136249	2133	97772550000	17535	8880	9	0	1225
136250	2133	97771548000	17535	8880	10	0	1226
136252	2134	97806430000	17535	8880	12	0	1190
136253	1397	1337669901000	17536	8881	0	0	10116
136254	2134	97805427000	17536	8881	1	0	1191
136255	2133	97770546000	17536	8881	2	0	1227
136262	1397	1337659900000	17539	8882	0	0	10117
136264	2133	97769544000	17539	8882	2	0	1228
136279	1397	1337649899000	17543	8883	0	0	\N
136280	1397	1337639898000	17543	8883	1	0	\N
136281	2134	97803421000	17543	8883	2	0	\N
136282	2134	97802418000	17543	8883	3	0	\N
136283	2133	97768542000	17543	8883	4	0	\N
136284	1397	1337649899000	17544	8883	0	0	\N
136285	1397	1337639898000	17544	8883	1	0	\N
136286	2134	97803421000	17544	8883	2	0	\N
136287	2134	97802418000	17544	8883	3	0	\N
136288	2133	97768542000	17544	8883	4	0	\N
136291	1397	1337619896000	17546	8885	0	0	\N
136292	2134	97800412000	17546	8885	1	0	\N
136293	2133	97766538000	17546	8885	2	0	\N
136297	1397	1337619896000	17548	8885	0	0	\N
136298	2134	97800412000	17548	8885	1	0	\N
136299	2133	97766538000	17548	8885	2	0	\N
136303	1397	1337609895000	17550	8886	0	0	\N
136304	2133	97765536000	17550	8886	1	0	\N
136305	2134	97799409000	17550	8886	2	0	\N
136309	1397	1337599894000	17552	8887	0	0	\N
136310	2134	97798406000	17552	8887	1	0	\N
136311	2133	97764534000	17552	8887	2	0	\N
136312	1397	1337599894000	17553	8887	0	0	\N
136313	2134	97798406000	17553	8887	1	0	\N
136314	2133	97764534000	17553	8887	2	0	\N
136315	1397	1337589893000	17554	8888	0	0	\N
136316	2133	97763532000	17554	8888	1	0	\N
136317	2134	97797403000	17554	8888	2	0	\N
136318	1397	1337589893000	17555	8888	0	0	\N
136319	2133	97763532000	17555	8888	1	0	\N
136320	2134	97797403000	17555	8888	2	0	\N
136321	1397	1337589893000	17556	8888	0	0	\N
136322	2133	97763532000	17556	8888	1	0	\N
136323	2134	97797403000	17556	8888	2	0	\N
136324	1397	1337589893000	17557	8888	0	0	\N
136325	2133	97763532000	17557	8888	1	0	\N
136326	2134	97797403000	17557	8888	2	0	\N
136330	1397	1337579892000	17559	8889	0	0	\N
136331	2133	97762530000	17559	8889	1	0	\N
136332	2134	97796400000	17559	8889	2	0	\N
136333	1397	1337579892000	17560	8889	0	0	\N
136334	2133	97762530000	17560	8889	1	0	\N
136335	2134	97796400000	17560	8889	2	0	\N
136339	1397	1337569891000	17562	8890	0	0	\N
136340	2133	97761528000	17562	8890	1	0	\N
136341	2134	97795397000	17562	8890	2	0	\N
136345	1397	1337559890000	17564	8891	0	0	\N
136346	1397	1337549889000	17564	8891	1	0	\N
136347	2134	97794394000	17564	8891	2	0	\N
136348	2133	97760526000	17564	8891	3	0	\N
136349	2133	97759524000	17564	8891	4	0	\N
136350	2134	97793391000	17564	8891	5	0	\N
136360	1397	1337539888000	17567	8892	0	0	\N
136361	2134	97792388000	17567	8892	1	0	\N
136362	2133	97758522000	17567	8892	2	0	\N
136363	1397	1337539888000	17569	8892	0	0	\N
136364	2134	97792388000	17569	8892	1	0	\N
136365	2133	97758522000	17569	8892	2	0	\N
136366	1397	1337539888000	17570	8892	0	0	\N
136367	2134	97792388000	17570	8892	1	0	\N
136368	2133	97758522000	17570	8892	2	0	\N
136375	1397	1337529887000	17572	8893	0	0	\N
136376	1397	1337519886000	17572	8893	1	0	\N
136377	2133	97757520000	17572	8893	2	0	\N
136378	2133	97756518000	17572	8893	3	0	\N
136379	2134	97791385000	17572	8893	4	0	\N
136380	2134	97790382000	17572	8893	5	0	\N
136381	1397	1337649899000	17573	8883	0	0	\N
136382	1397	1337639898000	17573	8883	1	0	\N
136383	1397	1337629897000	17573	8883	2	0	\N
136384	1397	1337619896000	17573	8883	3	0	\N
136385	1397	1337609895000	17573	8883	4	0	\N
136386	1397	1337599894000	17573	8883	5	0	\N
136387	1397	1337589893000	17573	8883	6	0	\N
136388	1397	1337579892000	17573	8883	7	0	\N
136389	1397	1337569891000	17573	8883	8	0	\N
136390	1397	1337559890000	17573	8883	9	0	\N
136391	1397	1337549889000	17573	8883	10	0	\N
136392	1397	1337539888000	17573	8883	11	0	\N
136393	1397	1337529887000	17573	8883	12	0	\N
136394	2134	97803421000	17573	8883	13	0	\N
136395	2134	97802418000	17573	8883	14	0	\N
136396	2133	97768542000	17573	8883	15	0	\N
136397	2133	97767540000	17573	8883	16	0	\N
136398	2133	97766538000	17573	8883	17	0	\N
136399	2133	97765536000	17573	8883	18	0	\N
136400	2133	97764534000	17573	8883	19	0	\N
136401	2133	97763532000	17573	8883	20	0	\N
136402	2133	97762530000	17573	8883	21	0	\N
136403	2133	97761528000	17573	8883	22	0	\N
136404	2133	97760526000	17573	8883	23	0	\N
136405	2133	97759524000	17573	8883	24	0	\N
136406	2134	97801415000	17573	8883	25	0	\N
136407	2134	97800412000	17573	8883	26	0	\N
136408	2134	97799409000	17573	8883	27	0	\N
136275	2134	97803421000	17542	8883	2	0	1193
136276	2134	97802418000	17542	8883	3	0	1194
136277	2133	97768542000	17542	8883	4	0	1229
136278	2133	97767540000	17542	8883	5	0	1230
136289	1397	1337629897000	17545	8884	0	0	10120
136294	1397	1337619896000	17547	8885	0	0	10121
136295	2134	97800412000	17547	8885	1	0	1196
136296	2133	97766538000	17547	8885	2	0	1231
136300	1397	1337609895000	17549	8886	0	0	10122
136301	2133	97765536000	17549	8886	1	0	1232
136306	1397	1337599894000	17551	8887	0	0	10123
136307	2134	97798406000	17551	8887	1	0	1198
136308	2133	97764534000	17551	8887	2	0	1233
136327	1397	1337589893000	17558	8888	0	0	10124
136329	2134	97797403000	17558	8888	2	0	1199
136336	1397	1337579892000	17561	8889	0	0	10125
136337	2133	97762530000	17561	8889	1	0	1235
136338	2134	97796400000	17561	8889	2	0	1200
136342	1397	1337569891000	17563	8890	0	0	10126
136344	2134	97795397000	17563	8890	2	0	1201
136351	1397	1337559890000	17565	8891	0	0	10127
136352	1397	1337549889000	17565	8891	1	0	10128
136353	2134	97794394000	17565	8891	2	0	1202
136354	2133	97760526000	17565	8891	3	0	1237
136356	2134	97793391000	17565	8891	5	0	1203
136357	1397	1337539888000	17566	8892	0	0	10129
136358	2134	97792388000	17566	8892	1	0	1204
136359	2133	97758522000	17566	8892	2	0	1239
136370	1397	1337519886000	17571	8893	1	0	10131
136371	2133	97757520000	17571	8893	2	0	1240
136372	2133	97756518000	17571	8893	3	0	1241
136373	2134	97791385000	17571	8893	4	0	1205
136374	2134	97790382000	17571	8893	5	0	1206
136409	2134	97798406000	17573	8883	28	0	\N
136410	2134	97797403000	17573	8883	29	0	\N
136411	2134	97796400000	17573	8883	30	0	\N
136412	2134	97795397000	17573	8883	31	0	\N
136413	2134	97794394000	17573	8883	32	0	\N
136414	2133	97758522000	17573	8883	33	0	\N
136415	2133	97757520000	17573	8883	34	0	\N
136416	2134	97793391000	17573	8883	35	0	\N
136417	2134	97792388000	17573	8883	36	0	\N
136418	1397	1337509885000	17574	8894	0	0	\N
136419	2134	97789379000	17574	8894	1	0	\N
136420	2133	97755516000	17574	8894	2	0	\N
136424	1397	1337509885000	17576	8894	0	0	\N
136425	2134	97789379000	17576	8894	1	0	\N
136426	2133	97755516000	17576	8894	2	0	\N
136430	1397	1337509885000	17580	8894	0	0	\N
136431	1397	1337499884000	17580	8894	1	0	\N
136432	1397	1337489883000	17580	8894	2	0	\N
136433	2134	97789379000	17580	8894	3	0	\N
136434	2134	97788376000	17580	8894	4	0	\N
136435	2134	97787373000	17580	8894	5	0	\N
136436	2133	97755516000	17580	8894	6	0	\N
136437	2133	97754514000	17580	8894	7	0	\N
136438	2133	97753512000	17580	8894	8	0	\N
136442	1397	1337479882000	17583	8897	0	0	\N
136443	1397	1337469881000	17583	8897	1	0	\N
136444	1397	1337459880000	17583	8897	2	0	\N
136445	2133	97752510000	17583	8897	3	0	\N
136446	2134	97786370000	17583	8897	4	0	\N
136447	2134	97785367000	17583	8897	5	0	\N
136448	2133	97751508000	17583	8897	6	0	\N
136449	2134	97784364000	17583	8897	7	0	\N
136450	2133	97750506000	17583	8897	8	0	\N
136451	1397	1337479882000	17584	8897	0	0	\N
136452	1397	1337469881000	17584	8897	1	0	\N
136453	1397	1337459880000	17584	8897	2	0	\N
136454	2133	97752510000	17584	8897	3	0	\N
136455	2134	97786370000	17584	8897	4	0	\N
136456	2134	97785367000	17584	8897	5	0	\N
136457	2133	97751508000	17584	8897	6	0	\N
136458	2134	97784364000	17584	8897	7	0	\N
136459	2133	97750506000	17584	8897	8	0	\N
136460	1397	1337479882000	17585	8897	0	0	\N
136461	1397	1337469881000	17585	8897	1	0	\N
136462	1397	1337459880000	17585	8897	2	0	\N
136463	2133	97752510000	17585	8897	3	0	\N
136464	2134	97786370000	17585	8897	4	0	\N
136465	2134	97785367000	17585	8897	5	0	\N
136466	2133	97751508000	17585	8897	6	0	\N
136467	2134	97784364000	17585	8897	7	0	\N
136468	2133	97750506000	17585	8897	8	0	\N
136484	1494	144000000	17588	8899	0	0	\N
136485	1397	1337429877000	17588	8899	1	0	\N
136486	2133	97747500000	17588	8899	2	0	\N
136487	2134	97781355000	17588	8899	3	0	\N
136488	1494	144000000	17589	8899	0	0	\N
136489	1397	1337429877000	17589	8899	1	0	\N
136490	2133	97747500000	17589	8899	2	0	\N
136491	2134	97781355000	17589	8899	3	0	\N
136494	1494	144000000	17591	8899	0	0	\N
136495	1397	1337429877000	17591	8899	1	0	\N
136496	2133	97747500000	17591	8899	2	0	\N
136497	2134	97781355000	17591	8899	3	0	\N
136498	1687	3500031223172	17592	8765	0	0	\N
136499	420	66529373005524	17592	8765	1	0	\N
136500	1693	13737662218470	17592	8765	2	0	\N
136501	1693	13654687030097	17592	8765	3	0	\N
136502	1693	13571711841724	17592	8765	4	0	\N
136503	1693	12807573778944	17592	8765	5	0	\N
136504	1693	12580562224236	17592	8765	6	0	\N
136505	1693	12497587035863	17592	8765	7	0	\N
136506	1693	12414611847490	17592	8765	8	0	\N
136507	1756	6369272285609	17592	8765	9	0	\N
136508	1673	22646014000000	17592	8765	10	0	\N
136509	1673	22645484000000	17592	8765	11	0	\N
136510	1693	12331636659117	17592	8765	12	0	\N
136511	1693	12248661470744	17592	8765	13	0	\N
136512	1693	12165686282371	17592	8765	14	0	\N
136513	1693	12082711093998	17592	8765	15	0	\N
136514	1693	11999735905625	17592	8765	16	0	\N
136515	1693	11916760717252	17592	8765	17	0	\N
136516	1693	11833785528879	17592	8765	18	0	\N
136517	420	66000263005524	17592	8765	19	0	\N
136518	1693	11750810340506	17592	8765	20	0	\N
136519	1693	11667835152133	17592	8765	21	0	\N
136520	1693	11584859963760	17592	8765	22	0	\N
136521	1693	11501884775387	17592	8765	23	0	\N
136522	1693	11418909587014	17592	8765	24	0	\N
136523	1693	11335934398641	17592	8765	25	0	\N
136524	1693	11252959210268	17592	8765	26	0	\N
136525	1693	11169984021895	17592	8765	27	0	\N
136526	1693	11167459925287	17592	8765	28	0	\N
136527	1693	11084484736914	17592	8765	29	0	\N
136528	1693	10491014269155	17592	8765	30	0	\N
136529	1693	10408039080782	17592	8765	31	0	\N
136530	1693	10325063892409	17592	8765	32	0	\N
136531	1693	10242088704036	17592	8765	33	0	\N
136532	1756	6193109545609	17592	8765	34	0	\N
136533	1397	1337419876000	17593	8900	0	0	\N
136534	2133	97746498000	17593	8900	1	0	\N
136535	2134	97780352000	17593	8900	2	0	\N
136544	420	66529373005524	17596	8819	0	0	\N
136423	2133	97755516000	17575	8894	2	0	1242
136427	1397	1337499884000	17579	8895	0	0	10133
136428	2133	97754514000	17579	8895	1	0	1243
136429	2134	97788376000	17579	8895	2	0	1208
136439	1397	1337489883000	17581	8896	0	0	10134
136441	2134	97787373000	17581	8896	2	0	1209
136469	1397	1337479882000	17586	8897	0	0	10135
136470	1397	1337469881000	17586	8897	1	0	10136
136471	1397	1337459880000	17586	8897	2	0	10137
136472	2133	97752510000	17586	8897	3	0	1245
136474	2134	97785367000	17586	8897	5	0	1211
136475	2133	97751508000	17586	8897	6	0	1246
136476	2134	97784364000	17586	8897	7	0	1212
136477	2133	97750506000	17586	8897	8	0	1247
136479	1397	1337439878000	17587	8898	1	0	10139
136480	2133	97749504000	17587	8898	2	0	1248
136481	2133	97748502000	17587	8898	3	0	1249
136482	2134	97783361000	17587	8898	4	0	1213
136483	2134	97782358000	17587	8898	5	0	1214
136493	2134	97781355000	17590	8899	1	0	1215
136536	1397	1337429877000	17594	8900	0	0	10140
136537	1397	1337419876000	17594	8900	1	0	10141
136538	2133	97747500000	17594	8900	2	0	1250
136539	2133	97746498000	17594	8900	3	0	1251
136541	1397	1337409875000	17595	8901	0	0	10142
136542	2134	97779349000	17595	8901	1	0	1217
136543	2133	97745496000	17595	8901	3	0	1252
136545	1693	14457697218470	17596	8819	1	0	\N
136546	1693	14374722030097	17596	8819	2	0	\N
136547	1693	14291746841724	17596	8819	3	0	\N
136548	1693	13527608778944	17596	8819	4	0	\N
136549	1693	13300597224236	17596	8819	5	0	\N
136550	1693	13217622035863	17596	8819	6	0	\N
136551	1693	13134646847490	17596	8819	7	0	\N
136552	1756	6369272285609	17596	8819	8	0	\N
136553	1673	22646014000000	17596	8819	9	0	\N
136554	1673	22645484000000	17596	8819	10	0	\N
136555	1693	13051671659117	17596	8819	11	0	\N
136556	1693	12968696470744	17596	8819	12	0	\N
136557	1693	12885721282371	17596	8819	13	0	\N
136558	1693	12802746093998	17596	8819	14	0	\N
136559	1693	12719770905625	17596	8819	15	0	\N
136560	1693	12636795717252	17596	8819	16	0	\N
136561	1693	12553820528879	17596	8819	17	0	\N
136562	1397	1338449979000	17596	8819	18	0	\N
136563	1397	1338439978000	17596	8819	19	0	\N
136564	1397	1338429977000	17596	8819	20	0	\N
136565	1397	1338419976000	17596	8819	21	0	\N
136566	420	66000263005524	17596	8819	22	0	\N
136567	1693	12470845340506	17596	8819	23	0	\N
136568	1693	12387870152133	17596	8819	24	0	\N
136569	1693	12304894963760	17596	8819	25	0	\N
136570	1693	12221919775387	17596	8819	26	0	\N
136571	1693	12138944587014	17596	8819	27	0	\N
136572	1693	12055969398641	17596	8819	28	0	\N
136573	1693	11972994210268	17596	8819	29	0	\N
136574	1693	11890019021895	17596	8819	30	0	\N
136575	1693	11887494925287	17596	8819	31	0	\N
136576	1693	11804519736914	17596	8819	32	0	\N
136577	1693	11211049269155	17596	8819	33	0	\N
136578	1693	11128074080782	17596	8819	34	0	\N
136579	1693	11045098892409	17596	8819	35	0	\N
136580	1693	10962123704036	17596	8819	36	0	\N
136581	1756	6193109545609	17596	8819	37	0	\N
136582	1397	1338409975000	17596	8819	38	0	\N
136583	1397	1338399974000	17596	8819	39	0	\N
136584	1397	1338389973000	17596	8819	40	0	\N
136585	1397	1338379972000	17596	8819	41	0	\N
136586	1397	1338369971000	17596	8819	42	0	\N
136587	1397	1338359970000	17596	8819	43	0	\N
136588	1397	1338349969000	17596	8819	44	0	\N
136589	1397	1338339968000	17596	8819	45	0	\N
136590	1397	1338329967000	17596	8819	46	0	\N
136591	1397	1338319966000	17596	8819	47	0	\N
136592	1397	1338309965000	17596	8819	48	0	\N
136593	1397	1338299964000	17596	8819	49	0	\N
136594	1397	1338289963000	17596	8819	50	0	\N
136595	1397	1338279962000	17596	8819	51	0	\N
136596	1397	1338269961000	17596	8819	52	0	\N
136597	1397	1338259960000	17596	8819	53	0	\N
136598	1397	1338249959000	17596	8819	54	0	\N
136599	1397	1338239958000	17596	8819	55	0	\N
136600	1397	1338229957000	17596	8819	56	0	\N
136601	1397	1338219956000	17596	8819	57	0	\N
136602	1397	1338209955000	17596	8819	58	0	\N
136603	1397	1338199954000	17596	8819	59	0	\N
136604	1397	1338189953000	17596	8819	60	0	\N
136605	1397	1338179952000	17596	8819	61	0	\N
136606	1397	1338169951000	17596	8819	62	0	\N
136607	1397	1338159950000	17596	8819	63	0	\N
136608	1397	1338149949000	17596	8819	64	0	\N
136609	1397	1338139948000	17596	8819	65	0	\N
136610	1397	1338129947000	17596	8819	66	0	\N
136611	1397	1338119946000	17596	8819	67	0	\N
136612	1397	1338109945000	17596	8819	68	0	\N
136613	1397	1338099944000	17596	8819	69	0	\N
136614	1397	1338089943000	17596	8819	70	0	\N
136615	1397	1338079942000	17596	8819	71	0	\N
136616	1397	1338069941000	17596	8819	72	0	\N
136617	1397	1338059940000	17596	8819	73	0	\N
136618	1397	1338049939000	17596	8819	74	0	\N
136619	1397	1338039938000	17596	8819	75	0	\N
136620	1397	1338029937000	17596	8819	76	0	\N
136621	1397	1338019936000	17596	8819	77	0	\N
136622	1397	1338009935000	17596	8819	78	0	\N
136623	1397	1337999934000	17596	8819	79	0	\N
136624	1397	1337989933000	17596	8819	80	0	\N
136625	1397	1337979932000	17596	8819	81	0	\N
136626	1397	1337969931000	17596	8819	83	0	\N
136627	1397	1337959930000	17596	8819	84	0	\N
136628	1397	1337949929000	17596	8819	85	0	\N
136629	1397	1337939928000	17596	8819	86	0	\N
136630	1397	1337929927000	17596	8819	87	0	\N
136631	1397	1337919926000	17596	8819	88	0	\N
136632	1397	1337909925000	17596	8819	89	0	\N
136633	1397	1337899924000	17596	8819	90	0	\N
136634	1397	1337889923000	17596	8819	91	0	\N
136635	1397	1337879922000	17596	8819	92	0	\N
136636	1397	1337869921000	17596	8819	93	0	\N
136637	1397	1337859920000	17596	8819	94	0	\N
136638	1397	1337849919000	17596	8819	95	0	\N
136639	1397	1337839918000	17596	8819	96	0	\N
136640	1397	1337829917000	17596	8819	97	0	\N
136641	1397	1337819916000	17596	8819	98	0	\N
136642	1397	1337809915000	17596	8819	99	0	\N
136643	1397	1337799914000	17596	8819	100	0	\N
136644	1397	1337789913000	17596	8819	101	0	\N
136645	1397	1337779912000	17596	8819	102	0	\N
136646	1397	1337769911000	17596	8819	103	0	\N
136647	1397	1337759910000	17596	8819	104	0	\N
136648	1397	1337749909000	17596	8819	105	0	\N
136649	1693	10879148515663	17596	8819	106	0	\N
136650	1693	10796173327290	17596	8819	107	0	\N
136651	1693	10713198138917	17596	8819	108	0	\N
136652	1693	10630222950544	17596	8819	109	0	\N
136653	1693	10621413612395	17596	8819	110	0	\N
136654	1693	10538438424022	17596	8819	111	0	\N
136655	1693	9906443549402	17596	8819	112	0	\N
136656	1693	9823468361029	17596	8819	113	0	\N
136657	1693	9740493172656	17596	8819	114	0	\N
136658	1693	9657517984283	17596	8819	115	0	\N
136659	1693	9574542795910	17596	8819	116	0	\N
136660	1693	9491567607537	17596	8819	117	0	\N
136661	1693	9408592419164	17596	8819	118	0	\N
136662	1693	9325617230791	17596	8819	119	0	\N
136663	1693	9242642042418	17596	8819	120	0	\N
136664	1693	9159666854045	17596	8819	121	0	\N
136665	1693	9076691665672	17596	8819	122	0	\N
136666	1693	6947370876272	17596	8819	123	0	\N
136667	1693	6864395687899	17596	8819	124	0	\N
136668	1693	6781420499526	17596	8819	125	0	\N
136672	1494	144000000	17598	8890	0	0	\N
136673	2133	97761528000	17598	8890	1	0	\N
136674	2133	97760526000	17598	8890	2	0	\N
136675	2133	97759524000	17598	8890	3	0	\N
136676	2133	97758522000	17598	8890	4	0	\N
136677	2133	97757520000	17598	8890	5	0	\N
136678	2133	97756518000	17598	8890	6	0	\N
136679	2133	97755516000	17598	8890	7	0	\N
136680	2133	97754514000	17598	8890	8	0	\N
136671	2133	97744494000	17597	8902	2	0	1253
136681	2133	97753512000	17598	8890	9	0	\N
136682	2133	97752510000	17598	8890	10	0	\N
136683	2133	97751508000	17598	8890	11	0	\N
136684	2133	97750506000	17598	8890	12	0	\N
136685	2133	97749504000	17598	8890	13	0	\N
136686	2133	97748502000	17598	8890	14	0	\N
136687	2133	97747500000	17598	8890	15	0	\N
136688	2133	97746498000	17598	8890	16	0	\N
136689	2133	97745496000	17598	8890	17	0	\N
136690	2133	97744494000	17598	8890	18	0	\N
136691	2133	97743492000	17598	8890	19	0	\N
136692	1687	2780019223172	17599	8619	0	0	\N
136693	420	66529373005524	17599	8619	1	0	\N
136694	1726	124105109000	17599	8619	2	0	\N
136695	1726	122895109000	17599	8619	3	0	\N
136696	1693	13017651218470	17599	8619	4	0	\N
136697	1693	12934676030097	17599	8619	5	0	\N
136698	1693	12851700841724	17599	8619	6	0	\N
136699	1693	12087562778944	17599	8619	7	0	\N
136700	1693	11860551224236	17599	8619	8	0	\N
136701	1693	11777576035863	17599	8619	10	0	\N
136702	1693	11694600847490	17599	8619	11	0	\N
136703	1756	5649259285609	17599	8619	12	0	\N
136704	1494	144000000	17600	8897	0	0	\N
136705	1397	1337479882000	17600	8897	1	0	\N
136706	1397	1337469881000	17600	8897	2	0	\N
136707	1397	1337459880000	17600	8897	3	0	\N
136708	1397	1337449879000	17600	8897	4	0	\N
136709	1397	1337439878000	17600	8897	5	0	\N
136710	1397	1337429877000	17600	8897	6	0	\N
136711	1397	1337419876000	17600	8897	7	0	\N
136712	1397	1337409875000	17600	8897	8	0	\N
136713	1397	1337399874000	17600	8897	9	0	\N
136714	1397	1337389873000	17600	8897	10	0	\N
136715	2134	97786370000	17600	8897	11	0	\N
136716	2134	97785367000	17600	8897	12	0	\N
136717	2134	97784364000	17600	8897	13	0	\N
136718	2134	97783361000	17600	8897	14	0	\N
136719	2134	97782358000	17600	8897	15	0	\N
136720	2134	97781355000	17600	8897	16	0	\N
136721	2134	97780352000	17600	8897	17	0	\N
136722	2134	97779349000	17600	8897	18	0	\N
136723	2134	97778346000	17600	8897	19	0	\N
136724	2134	97777343000	17600	8897	20	0	\N
136725	1687	3500031223172	17601	8745	0	0	\N
136726	420	66529373005524	17601	8745	1	0	\N
136727	1693	13737662218470	17601	8745	2	0	\N
136728	1693	13654687030097	17601	8745	3	0	\N
136729	1693	13571711841724	17601	8745	4	0	\N
136730	1693	12807573778944	17601	8745	5	0	\N
136731	1693	12580562224236	17601	8745	6	0	\N
136732	1693	12497587035863	17601	8745	7	0	\N
136733	1693	12414611847490	17601	8745	8	0	\N
136734	1756	6369272285609	17601	8745	9	0	\N
136735	1673	22646014000000	17601	8745	10	0	\N
136736	1673	22645484000000	17601	8745	11	0	\N
136737	1397	1339490083000	17601	8745	12	0	\N
136738	1397	1339480082000	17601	8745	13	0	\N
136739	1397	1339470081000	17601	8745	14	0	\N
136740	1397	1339460080000	17601	8745	15	0	\N
136741	1397	1339450079000	17601	8745	16	0	\N
136742	1397	1339440078000	17601	8745	17	0	\N
136743	1693	12331636659117	17601	8745	18	0	\N
136744	1693	12248661470744	17601	8745	19	0	\N
136745	1693	12165686282371	17601	8745	20	0	\N
136746	1693	12082711093998	17601	8745	21	0	\N
136747	1693	11999735905625	17601	8745	22	0	\N
136748	1693	11916760717252	17601	8745	23	0	\N
136749	1693	11833785528879	17601	8745	24	0	\N
136750	420	66000263005524	17601	8745	25	0	\N
136751	1693	11750810340506	17601	8745	26	0	\N
136752	1693	11667835152133	17601	8745	27	0	\N
136753	1693	11584859963760	17601	8745	28	0	\N
136754	1693	11501884775387	17601	8745	29	0	\N
136755	1693	11418909587014	17601	8745	30	0	\N
136756	1693	11335934398641	17601	8745	31	0	\N
136757	1693	11252959210268	17601	8745	32	0	\N
136758	1693	11169984021895	17601	8745	33	0	\N
136759	1693	11167459925287	17601	8745	34	0	\N
136760	1693	11084484736914	17601	8745	36	0	\N
136761	1693	10491014269155	17601	8745	37	0	\N
136762	1693	10408039080782	17601	8745	38	0	\N
136763	1693	10325063892409	17601	8745	39	0	\N
136764	1693	10242088704036	17601	8745	40	0	\N
136765	1756	6193109545609	17601	8745	41	0	\N
136766	1397	1339430077000	17601	8745	42	0	\N
136767	1397	1339420076000	17601	8745	43	0	\N
136768	1397	1339410075000	17601	8745	44	0	\N
136769	1397	1339400074000	17601	8745	45	0	\N
136770	1397	1339390073000	17601	8745	46	0	\N
136771	1397	1339380072000	17601	8745	47	0	\N
136772	1397	1339370071000	17601	8745	48	0	\N
136773	1397	1339360070000	17601	8745	49	0	\N
136774	1397	1339350069000	17601	8745	50	0	\N
136775	1397	1339340068000	17601	8745	51	0	\N
136776	1397	1339330067000	17601	8745	52	0	\N
136777	1397	1339320066000	17601	8745	53	0	\N
136778	1397	1339310065000	17601	8745	54	0	\N
136779	1397	1339300064000	17601	8745	55	0	\N
136780	1397	1339290063000	17601	8745	56	0	\N
136781	1397	1339280062000	17601	8745	57	0	\N
136782	1397	1339270061000	17601	8745	58	0	\N
136783	1397	1339260060000	17601	8745	59	0	\N
136784	2135	719027000000	17601	8745	60	0	\N
136785	1693	10159113515663	17601	8745	61	0	\N
136786	1693	10076138327290	17601	8745	62	0	\N
136787	1693	9993163138917	17601	8745	63	0	\N
136788	1693	9910187950544	17601	8745	64	0	\N
136789	1693	9901378612395	17601	8745	65	0	\N
136790	1693	9818403424022	17601	8745	66	0	\N
136791	1693	9186408549402	17601	8745	67	0	\N
136792	1693	9103433361029	17601	8745	68	0	\N
136793	1693	9020458172656	17601	8745	69	0	\N
136794	1693	8937482984283	17601	8745	70	0	\N
136795	1693	8854507795910	17601	8745	71	0	\N
136796	1693	8771532607537	17601	8745	72	0	\N
136797	1693	8688557419164	17601	8745	73	0	\N
136798	1693	8605582230791	17601	8745	74	0	\N
136799	1693	8522607042418	17601	8745	75	0	\N
136800	1693	8439631854045	17601	8745	76	0	\N
136801	1693	8356656665672	17601	8745	77	0	\N
136802	1693	6227335876272	17601	8745	78	0	\N
136803	1693	6144360687899	17601	8745	79	0	\N
136804	1693	6061385499526	17601	8745	80	0	\N
136805	1693	5978410311153	17601	8745	81	0	\N
136806	1693	5895435122780	17601	8745	82	0	\N
136807	1693	5812459934407	17601	8745	83	0	\N
136808	1693	5729484746034	17601	8745	84	0	\N
136809	1693	5646509557661	17601	8745	85	0	\N
136810	1693	5563534369288	17601	8745	86	0	\N
136811	1693	5480559180915	17601	8745	87	0	\N
136812	1693	5474263939379	17601	8745	88	0	\N
136813	1693	5391288751006	17601	8745	89	0	\N
136814	1693	5388764654398	17601	8745	90	0	\N
136815	1693	5305789466025	17601	8745	91	0	\N
136816	1693	5222814277652	17601	8745	92	0	\N
136817	1693	4837113049236	17601	8745	93	0	\N
136818	1693	4754137860863	17601	8745	94	0	\N
136819	1693	4729992533343	17601	8745	95	0	\N
136820	1693	4647017344970	17601	8745	96	0	\N
136821	1693	4564042156597	17601	8745	97	0	\N
136822	1693	3431520676097	17601	8745	98	0	\N
136823	1693	3348545487724	17601	8745	99	0	\N
136824	1693	3265570299351	17601	8745	100	0	\N
136825	1693	3182595110978	17601	8745	101	0	\N
136826	1693	3099619922605	17601	8745	102	0	\N
136827	1693	2713918694189	17601	8745	103	0	\N
136828	1693	2630943505816	17601	8745	104	0	\N
136829	1397	1339250059000	17601	8745	105	0	\N
136830	1397	1339240058000	17601	8745	106	0	\N
136831	1397	1339230057000	17601	8745	107	0	\N
136832	1397	1339220056000	17601	8745	108	0	\N
136833	1397	1339210055000	17601	8745	109	0	\N
136834	1397	1339200054000	17601	8745	110	0	\N
136835	1397	1339190053000	17601	8745	111	0	\N
136836	1397	1339180052000	17601	8745	112	0	\N
136837	1397	1339170051000	17601	8745	113	0	\N
136838	1397	1339160050000	17601	8745	114	0	\N
136839	1397	1339150049000	17601	8745	115	0	\N
136840	1397	1339140048000	17601	8745	116	0	\N
136841	1397	1339130047000	17601	8745	117	0	\N
136842	1397	1339120046000	17601	8745	118	0	\N
136843	1693	2547968317443	17601	8745	119	0	\N
136844	1693	2464993129070	17601	8745	120	0	\N
136845	1693	2382017940697	17601	8745	121	0	\N
136846	1693	2299042752324	17601	8745	122	0	\N
136847	1693	2216067563951	17601	8745	123	0	\N
136848	1693	2133092375578	17601	8745	124	0	\N
136849	1693	2050117187205	17601	8745	125	0	\N
136854	1397	1337379872000	17604	8904	0	0	\N
136855	1397	1337369871000	17604	8904	1	0	\N
136856	1397	1337359870000	17604	8904	2	0	\N
136857	2134	97776340000	17604	8904	3	0	\N
136858	2134	97775337000	17604	8904	4	0	\N
136859	1397	1337379872000	17605	8904	0	0	\N
136860	1397	1337369871000	17605	8904	1	0	\N
136861	1397	1337359870000	17605	8904	2	0	\N
136862	2134	97776340000	17605	8904	3	0	\N
136863	2134	97775337000	17605	8904	4	0	\N
136864	2133	97743492000	17605	8904	5	0	\N
136865	2133	97742490000	17605	8904	6	0	\N
136866	2133	97741488000	17605	8904	7	0	\N
136867	2133	97740486000	17605	8904	8	0	\N
136868	1397	1337379872000	17606	8905	0	0	\N
136869	1397	1337369871000	17606	8905	1	0	\N
136870	1397	1337359870000	17606	8905	2	0	\N
136871	1397	1337349869000	17606	8905	3	0	\N
136872	2134	97774334000	17606	8905	4	0	\N
136885	1397	1337329867000	17609	8907	0	0	\N
136886	2134	97772328000	17609	8907	1	0	\N
136887	2133	97738482000	17609	8907	2	0	\N
136888	2133	97737480000	17609	8907	3	0	\N
136889	1397	1337329867000	17610	8907	0	0	\N
136890	2134	97772328000	17610	8907	1	0	\N
136891	2133	97738482000	17610	8907	2	0	\N
136892	2133	97737480000	17610	8907	3	0	\N
136893	1397	1337329867000	17611	8907	0	0	\N
136894	2134	97772328000	17611	8907	1	0	\N
136895	2133	97738482000	17611	8907	2	0	\N
136896	2133	97737480000	17611	8907	3	0	\N
136904	1397	1337319866000	17614	8908	0	0	\N
136905	2133	97736478000	17614	8908	1	0	\N
136906	2134	97771325000	17614	8908	2	0	\N
136907	1397	1337319866000	17615	8908	0	0	\N
136908	2133	97736478000	17615	8908	1	0	\N
136909	2134	97771325000	17615	8908	2	0	\N
136913	1397	1337309865000	17617	8909	0	0	\N
136914	2133	97735476000	17617	8909	1	0	\N
136915	2134	97770322000	17617	8909	2	0	\N
136919	1397	1337299864000	17619	8910	0	0	\N
136920	2134	97769319000	17619	8910	1	0	\N
136921	2133	97734474000	17619	8910	2	0	\N
136922	1397	1337299864000	17620	8910	0	0	\N
136923	2134	97769319000	17620	8910	1	0	\N
136924	2133	97734474000	17620	8910	2	0	\N
136925	2134	97769319000	17621	8910	0	0	\N
136932	1397	1337279862000	17624	8912	0	0	\N
136933	2134	97767313000	17624	8912	1	0	\N
136934	2133	97732470000	17624	8912	2	0	\N
136935	1397	1337279862000	17625	8912	0	0	\N
136936	2134	97767313000	17625	8912	1	0	\N
136937	2133	97732470000	17625	8912	2	0	\N
136944	1397	1337269861000	17627	8913	0	0	\N
136945	1397	1337259860000	17627	8913	1	0	\N
136946	2134	97766310000	17627	8913	2	0	\N
136947	2133	97731468000	17627	8913	3	0	\N
136948	2133	97730466000	17627	8913	4	0	\N
136949	2134	97765307000	17627	8913	5	0	\N
136950	1397	1337269861000	17628	8913	0	0	\N
136951	1397	1337259860000	17628	8913	1	0	\N
136952	2134	97766310000	17628	8913	2	0	\N
136852	2134	97776340000	17603	8904	0	0	1220
136853	2134	97775337000	17603	8904	1	0	1221
136873	1397	1337379872000	17607	8905	0	0	10145
136874	1397	1337369871000	17607	8905	1	0	10146
136875	1397	1337359870000	17607	8905	2	0	10147
136877	2134	97774334000	17607	8905	4	0	1222
136878	2133	97743492000	17607	8905	5	0	1254
136879	2133	97742490000	17607	8905	6	0	1255
136880	2133	97741488000	17607	8905	7	0	1256
136881	2133	97740486000	17607	8905	8	0	1257
136883	1397	1337339868000	17608	8906	0	0	10149
136884	2134	97773331000	17608	8906	1	0	1223
136897	1397	1337329867000	17612	8907	0	0	10150
136898	2134	97772328000	17612	8907	1	0	1224
136900	2133	97737480000	17612	8907	3	0	1260
136901	1397	1337319866000	17613	8908	0	0	10151
136902	2133	97736478000	17613	8908	1	0	1261
136903	2134	97771325000	17613	8908	2	0	1225
136910	1397	1337309865000	17616	8909	0	0	10152
136912	2134	97770322000	17616	8909	2	0	1226
136916	1397	1337299864000	17618	8910	0	0	10153
136917	2134	97769319000	17618	8910	1	0	1227
136918	2133	97734474000	17618	8910	2	0	1263
136926	1397	1337289863000	17622	8911	0	0	10154
136928	2133	97733472000	17622	8911	2	0	1264
136929	1397	1337279862000	17623	8912	0	0	10155
136930	2134	97767313000	17623	8912	1	0	1229
136931	2133	97732470000	17623	8912	2	0	1265
136939	1397	1337259860000	17626	8913	1	0	10157
136940	2134	97766310000	17626	8913	2	0	1230
136941	2133	97731468000	17626	8913	3	0	1266
136942	2133	97730466000	17626	8913	4	0	1267
136943	2134	97765307000	17626	8913	5	0	1231
136953	2133	97731468000	17628	8913	3	0	\N
136954	2133	97730466000	17628	8913	4	0	\N
136955	2134	97765307000	17628	8913	5	0	\N
136956	1397	1337249859000	17629	8914	0	0	\N
136957	2134	97764304000	17629	8914	1	0	\N
136958	2133	97729464000	17629	8914	2	0	\N
136959	1397	1337249859000	17630	8914	0	0	\N
136960	2134	97764304000	17630	8914	1	0	\N
136961	2133	97729464000	17630	8914	2	0	\N
136965	1687	3500031223172	17632	8702	0	0	\N
136966	420	66529373005524	17632	8702	1	0	\N
136967	1397	1340050139000	17632	8702	2	0	\N
136968	1397	1340040138000	17632	8702	3	0	\N
136969	1397	1340030137000	17632	8702	4	0	\N
136970	1693	13017651218470	17632	8702	5	0	\N
136971	1693	12934676030097	17632	8702	6	0	\N
136972	1693	12851700841724	17632	8702	7	0	\N
136973	1693	12087562778944	17632	8702	8	0	\N
136974	1693	11860551224236	17632	8702	9	0	\N
136975	1693	11777576035863	17632	8702	10	0	\N
136976	1693	11694600847490	17632	8702	11	0	\N
136977	1397	1340020136000	17632	8702	12	0	\N
136978	1397	1340010135000	17632	8702	13	0	\N
136979	1397	1340000134000	17632	8702	14	0	\N
136980	1756	6369272285609	17632	8702	15	0	\N
136981	1673	22646014000000	17632	8702	16	0	\N
136982	1673	22645484000000	17632	8702	17	0	\N
136983	1693	11611625659117	17632	8702	18	0	\N
136984	1693	11528650470744	17632	8702	19	0	\N
136985	1693	11445675282371	17632	8702	20	0	\N
136986	1693	11362700093998	17632	8702	21	0	\N
136987	1693	11279724905625	17632	8702	22	0	\N
136988	1693	11196749717252	17632	8702	23	0	\N
136989	1693	11113774528879	17632	8702	24	0	\N
136990	1397	1339990133000	17632	8702	25	0	\N
136991	1397	1339980132000	17632	8702	26	0	\N
136992	420	66000263005524	17632	8702	27	0	\N
136993	1693	11030799340506	17632	8702	28	0	\N
136994	1693	10947824152133	17632	8702	29	0	\N
136995	1693	10864848963760	17632	8702	30	0	\N
136996	1693	10781873775387	17632	8702	31	0	\N
136997	1693	10698898587014	17632	8702	32	0	\N
136998	1693	10615923398641	17632	8702	33	0	\N
136999	1693	10532948210268	17632	8702	34	0	\N
137000	1693	10449973021895	17632	8702	35	0	\N
137001	1693	10447448925287	17632	8702	36	0	\N
137002	1693	10364473736914	17632	8702	37	0	\N
137003	1693	9771003269155	17632	8702	38	0	\N
137004	1693	9688028080782	17632	8702	39	0	\N
137005	1693	9605052892409	17632	8702	40	0	\N
137006	1693	9522077704036	17632	8702	41	0	\N
137007	1397	1339970131000	17632	8702	42	0	\N
137008	1397	1339960130000	17632	8702	43	0	\N
137009	1397	1339950129000	17632	8702	44	0	\N
137010	1397	1339940128000	17632	8702	45	0	\N
137011	1397	1339930127000	17632	8702	46	0	\N
137012	1397	1339920126000	17632	8702	47	0	\N
137013	1397	1339910125000	17632	8702	48	0	\N
137014	1397	1339900124000	17632	8702	49	0	\N
137015	1397	1339890123000	17632	8702	51	0	\N
137016	1397	1339880122000	17632	8702	52	0	\N
137017	1397	1339870121000	17632	8702	53	0	\N
137018	1397	1339860120000	17632	8702	54	0	\N
137019	1397	1339850119000	17632	8702	55	0	\N
137020	1397	1339840118000	17632	8702	56	0	\N
137021	1397	1339830117000	17632	8702	57	0	\N
137022	1397	1339820116000	17632	8702	58	0	\N
137023	1397	1339810115000	17632	8702	59	0	\N
137024	1397	1339800114000	17632	8702	60	0	\N
137025	1397	1339790113000	17632	8702	61	0	\N
137026	1756	6193109545609	17632	8702	62	0	\N
137027	2135	719027000000	17632	8702	63	0	\N
137028	1693	9439102515663	17632	8702	64	0	\N
137029	1693	9356127327290	17632	8702	65	0	\N
137030	1693	9273152138917	17632	8702	66	0	\N
137031	1693	9190176950544	17632	8702	67	0	\N
137032	1693	9181367612395	17632	8702	68	0	\N
137033	1693	9098392424022	17632	8702	69	0	\N
137034	1693	8466397549402	17632	8702	70	0	\N
137035	1693	8383422361029	17632	8702	71	0	\N
137036	1693	8300447172656	17632	8702	72	0	\N
137037	1693	8217471984283	17632	8702	73	0	\N
137038	1693	8134496795910	17632	8702	74	0	\N
137039	1693	8051521607537	17632	8702	75	0	\N
137040	1693	7968546419164	17632	8702	76	0	\N
137041	1693	7885571230791	17632	8702	77	0	\N
137042	1693	7802596042418	17632	8702	78	0	\N
137043	1693	7719620854045	17632	8702	79	0	\N
137044	1693	7636645665672	17632	8702	80	0	\N
137045	1693	5507324876272	17632	8702	81	0	\N
137046	1693	5424349687899	17632	8702	82	0	\N
137047	1693	5341374499526	17632	8702	83	0	\N
137048	1693	5258399311153	17632	8702	84	0	\N
137049	1693	5175424122780	17632	8702	85	0	\N
137050	1693	5092448934407	17632	8702	86	0	\N
137051	1693	5009473746034	17632	8702	87	0	\N
137052	1693	4926498557661	17632	8702	88	0	\N
137053	1693	4843523369288	17632	8702	89	0	\N
137054	1693	4760548180915	17632	8702	90	0	\N
137055	1693	4754252939379	17632	8702	91	0	\N
137056	1693	4671277751006	17632	8702	92	0	\N
137057	1693	4668753654398	17632	8702	93	0	\N
137058	1693	4585778466025	17632	8702	94	0	\N
137059	1693	4502803277652	17632	8702	95	0	\N
137060	1693	4117102049236	17632	8702	96	0	\N
137061	1693	4034126860863	17632	8702	97	0	\N
137062	1693	4009981533343	17632	8702	98	0	\N
137063	1693	3927006344970	17632	8702	99	0	\N
137064	1693	3844031156597	17632	8702	100	0	\N
137065	1693	2711509676097	17632	8702	101	0	\N
137066	1693	2628534487724	17632	8702	102	0	\N
137067	1693	2545559299351	17632	8702	103	0	\N
137068	1693	2462584110978	17632	8702	104	0	\N
137069	1693	2379608922605	17632	8702	105	0	\N
137070	1693	1993907694189	17632	8702	106	0	\N
137071	1693	1910932505816	17632	8702	107	0	\N
137072	1397	1339780112000	17632	8702	108	0	\N
137073	1397	1339770111000	17632	8702	109	0	\N
137074	1397	1339760110000	17632	8702	110	0	\N
137075	1397	1339750109000	17632	8702	111	0	\N
137076	1397	1339740108000	17632	8702	112	0	\N
137077	1397	1339730107000	17632	8702	113	0	\N
137078	1397	1339720106000	17632	8702	114	0	\N
137079	1397	1339710105000	17632	8702	115	0	\N
137080	1397	1339700104000	17632	8702	116	0	\N
137081	1397	1339690103000	17632	8702	117	0	\N
137082	1397	1339680102000	17632	8702	118	0	\N
137083	1397	1339670101000	17632	8702	119	0	\N
137084	1397	1339660100000	17632	8702	120	0	\N
137085	1397	1339650099000	17632	8702	121	0	\N
137086	1397	1339640098000	17632	8702	122	0	\N
137087	1397	1339630097000	17632	8702	123	0	\N
137088	1397	1339620096000	17632	8702	124	0	\N
136964	2133	97729464000	17631	8914	2	0	1268
137089	1397	1339610095000	17632	8702	125	0	\N
137093	1397	1337229857000	17634	8916	0	0	\N
137094	2133	97727460000	17634	8916	1	0	\N
137095	2134	97762298000	17634	8916	2	0	\N
137102	1397	1337219856000	17637	8917	0	0	\N
137103	2133	97726458000	17637	8917	1	0	\N
137104	2134	97761295000	17637	8917	2	0	\N
137105	1397	1337219856000	17638	8917	0	0	\N
137106	2133	97726458000	17638	8917	1	0	\N
137107	2134	97761295000	17638	8917	2	0	\N
137108	1494	144000000	17639	8843	0	0	\N
137109	1693	6698445311153	17639	8843	1	0	\N
137110	1693	6615470122780	17639	8843	2	0	\N
137111	1693	6532494934407	17639	8843	3	0	\N
137112	1673	22646014000000	17639	8843	4	0	\N
137113	1673	22645484000000	17639	8843	5	0	\N
137114	1693	6449519746034	17639	8843	6	0	\N
137115	1693	6366544557661	17639	8843	7	0	\N
137116	1693	6283569369288	17639	8843	8	0	\N
137117	1693	6200594180915	17639	8843	9	0	\N
137118	1693	6194298939379	17639	8843	10	0	\N
137119	1693	6111323751006	17639	8843	11	0	\N
137120	1693	6108799654398	17639	8843	12	0	\N
137121	1693	6025824466025	17639	8843	13	0	\N
137122	1693	5942849277652	17639	8843	14	0	\N
137123	1397	1338169951000	17639	8843	15	0	\N
137124	1397	1338159950000	17639	8843	16	0	\N
137125	1397	1338149949000	17639	8843	17	0	\N
137126	1397	1338139948000	17639	8843	18	0	\N
137127	1397	1338129947000	17639	8843	19	0	\N
137128	1397	1338119946000	17639	8843	21	0	\N
137129	1397	1338109945000	17639	8843	22	0	\N
137130	1397	1338099944000	17639	8843	23	0	\N
137131	1397	1338089943000	17639	8843	24	0	\N
137132	1397	1338079942000	17639	8843	25	0	\N
137133	1397	1338069941000	17639	8843	26	0	\N
137134	1397	1338059940000	17639	8843	27	0	\N
137135	1397	1338049939000	17639	8843	28	0	\N
137136	1397	1338039938000	17639	8843	29	0	\N
137137	1397	1338029937000	17639	8843	30	0	\N
137138	1397	1338019936000	17639	8843	31	0	\N
137139	1397	1338009935000	17639	8843	32	0	\N
137140	1397	1337999934000	17639	8843	33	0	\N
137141	1397	1337989933000	17639	8843	34	0	\N
137142	1397	1337979932000	17639	8843	35	0	\N
137143	1397	1337969931000	17639	8843	36	0	\N
137144	1397	1337959930000	17639	8843	37	0	\N
137145	1397	1337949929000	17639	8843	38	0	\N
137146	1397	1337939928000	17639	8843	39	0	\N
137147	1397	1337929927000	17639	8843	40	0	\N
137148	1397	1337919926000	17639	8843	41	0	\N
137149	1397	1337909925000	17639	8843	42	0	\N
137150	1397	1337899924000	17639	8843	43	0	\N
137151	1397	1337889923000	17639	8843	44	0	\N
137152	1397	1337879922000	17639	8843	45	0	\N
137153	1397	1337869921000	17639	8843	46	0	\N
137154	1397	1337859920000	17639	8843	47	0	\N
137155	1397	1337849919000	17639	8843	48	0	\N
137156	1397	1337839918000	17639	8843	49	0	\N
137157	1397	1337829917000	17639	8843	50	0	\N
137158	1397	1337819916000	17639	8843	51	0	\N
137159	1397	1337809915000	17639	8843	52	0	\N
137160	1397	1337799914000	17639	8843	53	0	\N
137161	1397	1337789913000	17639	8843	54	0	\N
137162	1397	1337779912000	17639	8843	55	0	\N
137163	1397	1337769911000	17639	8843	56	0	\N
137164	1397	1337759910000	17639	8843	57	0	\N
137165	1397	1337749909000	17639	8843	58	0	\N
137166	1693	5557148049236	17639	8843	59	0	\N
137167	1693	5474172860863	17639	8843	60	0	\N
137168	1693	5450027533343	17639	8843	61	0	\N
137169	1693	5367052344970	17639	8843	62	0	\N
137170	1693	5284077156597	17639	8843	63	0	\N
137171	1693	4151555676097	17639	8843	64	0	\N
137172	1693	4068580487724	17639	8843	65	0	\N
137173	1693	3985605299351	17639	8843	66	0	\N
137174	1693	3902630110978	17639	8843	67	0	\N
137175	1693	3819654922605	17639	8843	68	0	\N
137176	1693	3433953694189	17639	8843	69	0	\N
137177	1693	3350978505816	17639	8843	70	0	\N
137178	1397	1337739908000	17639	8843	71	0	\N
137179	1397	1337729907000	17639	8843	72	0	\N
137180	1397	1337719906000	17639	8843	73	0	\N
137181	1397	1337709905000	17639	8843	74	0	\N
137182	1397	1337699904000	17639	8843	75	0	\N
137183	1397	1337689903000	17639	8843	76	0	\N
137184	1397	1337679902000	17639	8843	77	0	\N
137185	1397	1337669901000	17639	8843	78	0	\N
137186	1397	1337659900000	17639	8843	79	0	\N
137187	1397	1337649899000	17639	8843	80	0	\N
137188	1397	1337639898000	17639	8843	81	0	\N
137189	1397	1337629897000	17639	8843	82	0	\N
137190	1397	1337619896000	17639	8843	83	0	\N
137191	1397	1337609895000	17639	8843	84	0	\N
137192	1397	1337599894000	17639	8843	85	0	\N
137193	1397	1337589893000	17639	8843	86	0	\N
137194	1397	1337579892000	17639	8843	87	0	\N
137195	1397	1337569891000	17639	8843	88	0	\N
137196	1397	1337559890000	17639	8843	89	0	\N
137197	1397	1337549889000	17639	8843	90	0	\N
137198	1397	1337539888000	17639	8843	91	0	\N
137199	1397	1337529887000	17639	8843	92	0	\N
137200	1397	1337519886000	17639	8843	93	0	\N
137201	1397	1337509885000	17639	8843	94	0	\N
137202	1397	1337499884000	17639	8843	95	0	\N
137203	1397	1337489883000	17639	8843	96	0	\N
137204	1693	3268003317443	17639	8843	97	0	\N
137205	1693	3185028129070	17639	8843	98	0	\N
137206	1693	3102052940697	17639	8843	99	0	\N
137207	1693	3019077752324	17639	8843	100	0	\N
137208	1693	2936102563951	17639	8843	101	0	\N
137209	1693	2853127375578	17639	8843	102	0	\N
137210	1693	2770152187205	17639	8843	103	0	\N
137211	1693	2687176998832	17639	8843	104	0	\N
137212	1693	2604201810459	17639	8843	105	0	\N
137213	1693	2521226622086	17639	8843	106	0	\N
137214	1693	2438251433713	17639	8843	107	0	\N
137215	1693	2355276245340	17639	8843	108	0	\N
137216	1693	2272301056967	17639	8843	109	0	\N
137217	1693	2189325868594	17639	8843	110	0	\N
137218	1693	2106350680221	17639	8843	111	0	\N
137219	1693	2023375491848	17639	8843	112	0	\N
137220	1693	1940400303475	17639	8843	113	0	\N
137221	1693	1857425115102	17639	8843	114	0	\N
137222	1693	1774449926729	17639	8843	115	0	\N
137223	1693	1691474738356	17639	8843	116	0	\N
137224	1693	1688950641748	17639	8843	117	0	\N
137092	2133	97728462000	17633	8915	2	0	1269
137096	1397	1337229857000	17635	8916	0	0	10160
137097	2133	97727460000	17635	8916	1	0	1270
137098	2134	97762298000	17635	8916	2	0	1234
137099	1397	1337219856000	17636	8917	0	0	10161
137101	2134	97761295000	17636	8917	2	0	1235
137225	1693	1605975453375	17639	8843	118	0	\N
137226	1693	1523000265002	17639	8843	119	0	\N
137227	1693	1440025076629	17639	8843	120	0	\N
137228	1693	1357049888256	17639	8843	121	0	\N
137229	1693	1274074699883	17639	8843	122	0	\N
137230	1693	1191099511510	17639	8843	123	0	\N
137231	1693	1108124323137	17639	8843	124	0	\N
137232	1693	1025149134764	17639	8843	125	0	\N
137236	1397	1337209855000	17641	8918	0	0	\N
137237	2133	97725456000	17641	8918	1	0	\N
137238	2134	97760292000	17641	8918	2	0	\N
137247	1726	119265109000	17644	8921	0	0	\N
137248	1397	1337179852000	17644	8921	1	0	\N
137249	1726	118055109000	17644	8921	2	0	\N
137250	1726	116845109000	17644	8921	3	0	\N
137251	1726	115635109000	17644	8921	4	0	\N
137252	2133	97722450000	17644	8921	5	0	\N
137253	2134	97757283000	17644	8921	6	0	\N
137254	1726	119265109000	17645	8921	0	0	\N
137255	1397	1337179852000	17645	8921	1	0	\N
137256	1726	118055109000	17645	8921	2	0	\N
137257	1726	116845109000	17645	8921	3	0	\N
137258	1726	115635109000	17645	8921	4	0	\N
137259	2133	97722450000	17645	8921	5	0	\N
137260	2134	97757283000	17645	8921	6	0	\N
137261	1726	119265109000	17646	8921	0	0	\N
137262	1397	1337179852000	17646	8921	1	0	\N
137263	1726	118055109000	17646	8921	2	0	\N
137264	1726	116845109000	17646	8921	3	0	\N
137265	1726	115635109000	17646	8921	4	0	\N
137266	2133	97722450000	17646	8921	5	0	\N
137267	2134	97757283000	17646	8921	6	0	\N
137282	1397	1337139848000	17649	8923	0	0	\N
137283	2134	97753271000	17649	8923	2	0	\N
137286	1397	1339600094000	17651	8703	0	0	\N
137287	1397	1339590093000	17651	8703	1	0	\N
137288	1397	1339580092000	17651	8703	2	0	\N
137289	1726	120475109000	17651	8703	3	0	\N
137290	1726	119265109000	17651	8703	4	0	\N
137291	1397	1339570091000	17651	8703	5	0	\N
137292	1397	1339560090000	17651	8703	6	0	\N
137293	1397	1339550089000	17651	8703	7	0	\N
137294	1397	1339540088000	17651	8703	8	0	\N
137295	1397	1339530087000	17651	8703	9	0	\N
137296	1397	1339520086000	17651	8703	10	0	\N
137297	1397	1339510085000	17651	8703	11	0	\N
137298	1397	1339500084000	17651	8703	12	0	\N
137299	1397	1339490083000	17651	8703	13	0	\N
137300	1397	1339480082000	17651	8703	14	0	\N
137301	1397	1339470081000	17651	8703	15	0	\N
137302	1397	1339460080000	17651	8703	16	0	\N
137303	1397	1339450079000	17651	8703	17	0	\N
137304	1397	1339440078000	17651	8703	18	0	\N
137305	1397	1339430077000	17651	8703	19	0	\N
137306	1397	1339420076000	17651	8703	20	0	\N
137307	1397	1339410075000	17651	8703	21	0	\N
137308	1397	1339400074000	17651	8703	22	0	\N
137309	1397	1339390073000	17651	8703	23	0	\N
137310	1397	1339380072000	17651	8703	24	0	\N
137311	1397	1339370071000	17651	8703	25	0	\N
137312	1397	1339360070000	17651	8703	26	0	\N
137313	1397	1339350069000	17651	8703	27	0	\N
137314	1397	1339340068000	17651	8703	28	0	\N
137315	1397	1339330067000	17651	8703	29	0	\N
137316	1397	1339320066000	17651	8703	30	0	\N
137317	1397	1339310065000	17651	8703	31	0	\N
137318	1397	1339300064000	17651	8703	32	0	\N
137319	1397	1339290063000	17651	8703	33	0	\N
137320	1397	1339280062000	17651	8703	34	0	\N
137321	1397	1339270061000	17651	8703	35	0	\N
137322	1397	1339260060000	17651	8703	36	0	\N
137323	1726	118055109000	17651	8703	37	0	\N
137324	1726	116845109000	17651	8703	38	0	\N
137325	1726	115635109000	17651	8703	39	0	\N
137326	1397	1339250059000	17651	8703	40	0	\N
137327	1397	1339240058000	17651	8703	41	0	\N
137328	1397	1339230057000	17651	8703	42	0	\N
137329	1397	1339220056000	17651	8703	43	0	\N
137330	1397	1339210055000	17651	8703	44	0	\N
137331	1397	1339200054000	17651	8703	45	0	\N
137332	1397	1339190053000	17651	8703	46	0	\N
137333	1397	1339180052000	17651	8703	47	0	\N
137334	1397	1339170051000	17651	8703	48	0	\N
137335	1397	1339160050000	17651	8703	49	0	\N
137336	1397	1339150049000	17651	8703	51	0	\N
137337	1397	1339140048000	17651	8703	52	0	\N
137338	1397	1339130047000	17651	8703	53	0	\N
137339	1397	1339120046000	17651	8703	54	0	\N
137340	1397	1339110045000	17651	8703	55	0	\N
137341	1397	1339100044000	17651	8703	56	0	\N
137342	1397	1339090043000	17651	8703	57	0	\N
137343	1397	1339080042000	17651	8703	58	0	\N
137344	1397	1339070041000	17651	8703	59	0	\N
137345	1397	1339060040000	17651	8703	60	0	\N
137346	1397	1339050039000	17651	8703	61	0	\N
137347	1397	1339040038000	17651	8703	62	0	\N
137348	1397	1339030037000	17651	8703	63	0	\N
137349	1397	1339020036000	17651	8703	64	0	\N
137350	1397	1339010035000	17651	8703	65	0	\N
137351	1397	1339000034000	17651	8703	66	0	\N
137352	1397	1338990033000	17651	8703	67	0	\N
137353	1397	1338980032000	17651	8703	68	0	\N
137354	1397	1338970031000	17651	8703	69	0	\N
137355	1397	1338960030000	17651	8703	70	0	\N
137356	1397	1338950029000	17651	8703	71	0	\N
137357	1397	1338940028000	17651	8703	72	0	\N
137358	1397	1338930027000	17651	8703	73	0	\N
137359	1397	1338920026000	17651	8703	74	0	\N
137360	1397	1338910025000	17651	8703	75	0	\N
137235	2134	97760292000	17640	8918	2	0	1236
137239	1397	1337199854000	17642	8919	0	0	10163
137240	2134	97759289000	17642	8919	1	0	1237
137241	2133	97724454000	17642	8919	2	0	1273
137242	1726	120475109000	17643	8920	0	0	8187
137244	2132	148693694000	17643	8920	2	0	306
137245	2134	97758286000	17643	8920	3	0	1238
137246	2133	97723452000	17643	8920	4	0	1274
137268	1726	119265109000	17647	8921	0	0	8188
137269	1397	1337179852000	17647	8921	1	0	10165
137271	1726	116845109000	17647	8921	3	0	8190
137272	1726	115635109000	17647	8921	4	0	8191
137273	2133	97722450000	17647	8921	5	0	1275
137274	2134	97757283000	17647	8921	6	0	1239
137276	1397	1337159850000	17648	8922	1	0	10167
137277	1397	1337149849000	17648	8922	2	0	10168
137278	2134	97756280000	17648	8922	3	0	1240
137279	2134	97755277000	17648	8922	4	0	1241
137280	2134	97754274000	17648	8922	5	0	1242
137284	1397	1337139848000	17650	8923	0	0	10169
137285	2134	97753271000	17650	8923	2	0	1243
137361	1397	1338900024000	17651	8703	76	0	\N
137362	1397	1338890023000	17651	8703	77	0	\N
137363	1397	1338880022000	17651	8703	78	0	\N
137364	1397	1338870021000	17651	8703	79	0	\N
137365	1397	1338860020000	17651	8703	80	0	\N
137366	1397	1338850019000	17651	8703	81	0	\N
137367	1397	1338840018000	17651	8703	82	0	\N
137368	1397	1338830017000	17651	8703	83	0	\N
137369	1397	1338820016000	17651	8703	84	0	\N
137370	1397	1338810015000	17651	8703	85	0	\N
137371	1397	1338800014000	17651	8703	86	0	\N
137372	1397	1338790013000	17651	8703	87	0	\N
137373	1397	1338780012000	17651	8703	88	0	\N
137374	1397	1338770011000	17651	8703	89	0	\N
137375	1397	1338760010000	17651	8703	90	0	\N
137376	1397	1338750009000	17651	8703	91	0	\N
137377	1397	1338740008000	17651	8703	92	0	\N
137378	1397	1338730007000	17651	8703	93	0	\N
137379	1397	1338720006000	17651	8703	94	0	\N
137380	1397	1338710005000	17651	8703	95	0	\N
137381	1397	1338700004000	17651	8703	96	0	\N
137382	1397	1338690003000	17651	8703	97	0	\N
137383	1397	1338680002000	17651	8703	98	0	\N
137384	1397	1338670001000	17651	8703	99	0	\N
137385	1397	1338660000000	17651	8703	100	0	\N
137386	1397	1338649999000	17651	8703	101	0	\N
137387	1397	1338639998000	17651	8703	102	0	\N
137388	1397	1338629997000	17651	8703	103	0	\N
137389	1397	1338619996000	17651	8703	104	0	\N
137390	1397	1338609995000	17651	8703	105	0	\N
137391	1397	1338599994000	17651	8703	106	0	\N
137392	1397	1338589993000	17651	8703	107	0	\N
137393	1397	1338579992000	17651	8703	108	0	\N
137394	1397	1338569991000	17651	8703	109	0	\N
137395	1397	1338559990000	17651	8703	110	0	\N
137396	1397	1338549989000	17651	8703	111	0	\N
137397	1397	1338539988000	17651	8703	112	0	\N
137398	1397	1338529987000	17651	8703	113	0	\N
137399	1397	1338519986000	17651	8703	114	0	\N
137400	1397	1338509985000	17651	8703	115	0	\N
137401	1397	1338499984000	17651	8703	116	0	\N
137402	1397	1338489983000	17651	8703	117	0	\N
137403	1397	1338479982000	17651	8703	118	0	\N
137404	1397	1338469981000	17651	8703	119	0	\N
137405	1397	1338459980000	17651	8703	120	0	\N
137406	1397	1338449979000	17651	8703	121	0	\N
137407	1397	1338439978000	17651	8703	122	0	\N
137408	1397	1338429977000	17651	8703	123	0	\N
137409	1397	1338419976000	17651	8703	124	0	\N
137410	1397	1338409975000	17651	8703	125	0	\N
137413	1726	120475109000	17653	8911	0	0	\N
137414	1726	119265109000	17653	8911	1	0	\N
137415	1726	118055109000	17653	8911	2	0	\N
137416	1726	116845109000	17653	8911	3	0	\N
137417	1726	115635109000	17653	8911	4	0	\N
137418	2132	148693694000	17653	8911	5	0	\N
137421	1397	1337129847000	17655	8924	0	0	\N
137422	1397	1337119846000	17655	8924	1	0	\N
137423	2134	97752268000	17655	8924	2	0	\N
137424	2134	97751265000	17655	8924	3	0	\N
137425	1397	1337109845000	17656	8926	0	0	\N
137426	2134	97750262000	17656	8926	1	0	\N
137427	1397	1337109845000	17657	8926	0	0	\N
137428	2134	97750262000	17657	8926	1	0	\N
137431	1397	1337099844000	17659	8927	0	0	\N
137432	2134	97749259000	17659	8927	1	0	\N
137439	1397	1337069841000	17662	8929	0	0	\N
137440	1397	1337059840000	17662	8929	1	0	\N
137441	2134	97746250000	17662	8929	2	0	\N
137442	2134	97745247000	17662	8929	3	0	\N
137447	1397	1337049839000	17664	8930	0	0	\N
137448	2134	97744244000	17664	8930	1	0	\N
137451	1397	1337049839000	17666	8930	0	0	\N
137452	2134	97744244000	17666	8930	1	0	\N
137453	1397	1337049839000	17667	8930	0	0	\N
137454	2134	97744244000	17667	8930	1	0	\N
137459	1726	120475109000	17670	8746	0	0	\N
137460	1726	119265109000	17670	8746	1	0	\N
137461	1726	118055109000	17670	8746	2	0	\N
137462	1726	116845109000	17670	8746	3	0	\N
137463	1726	115635109000	17670	8746	4	0	\N
137464	1397	1339110045000	17670	8746	5	0	\N
137465	1397	1339100044000	17670	8746	6	0	\N
137466	1397	1339090043000	17670	8746	7	0	\N
137467	1397	1339080042000	17670	8746	8	0	\N
137468	1397	1339070041000	17670	8746	9	0	\N
137469	1397	1339060040000	17670	8746	10	0	\N
137470	1397	1339050039000	17670	8746	11	0	\N
137471	1397	1339040038000	17670	8746	12	0	\N
137472	1397	1339030037000	17670	8746	13	0	\N
137473	1397	1339020036000	17670	8746	14	0	\N
137474	1397	1339010035000	17670	8746	15	0	\N
137475	1397	1339000034000	17670	8746	16	0	\N
137476	1397	1338990033000	17670	8746	17	0	\N
137477	1397	1338980032000	17670	8746	18	0	\N
137478	1397	1338970031000	17670	8746	19	0	\N
137479	1397	1338960030000	17670	8746	20	0	\N
137480	1397	1338950029000	17670	8746	21	0	\N
137481	1397	1338940028000	17670	8746	22	0	\N
137482	1397	1338930027000	17670	8746	23	0	\N
137483	1397	1338920026000	17670	8746	24	0	\N
137484	1397	1338910025000	17670	8746	25	0	\N
137485	1397	1338900024000	17670	8746	26	0	\N
137486	1397	1338890023000	17670	8746	27	0	\N
137487	1397	1338880022000	17670	8746	28	0	\N
137488	1397	1338870021000	17670	8746	29	0	\N
137489	1397	1338860020000	17670	8746	30	0	\N
137490	1397	1338850019000	17670	8746	31	0	\N
137491	1397	1338840018000	17670	8746	32	0	\N
137492	1397	1338830017000	17670	8746	33	0	\N
137493	1397	1338820016000	17670	8746	34	0	\N
137494	1397	1338810015000	17670	8746	36	0	\N
137495	1397	1338800014000	17670	8746	37	0	\N
137496	1397	1338790013000	17670	8746	38	0	\N
137419	1397	1337119846000	17654	8925	0	0	10171
137420	2134	97751265000	17654	8925	1	0	1245
137429	1397	1337109845000	17658	8926	0	0	10172
137430	2134	97750262000	17658	8926	1	0	1246
137433	1397	1337099844000	17660	8927	0	0	10173
137435	1397	1337089843000	17661	8928	0	0	10174
137436	1397	1337079842000	17661	8928	1	0	10175
137437	2134	97748256000	17661	8928	2	0	1248
137438	2134	97747253000	17661	8928	3	0	1249
137443	1397	1337069841000	17663	8929	0	0	10176
137445	2134	97746250000	17663	8929	2	0	1250
137446	2134	97745247000	17663	8929	3	0	1251
137449	1397	1337049839000	17665	8930	0	0	10178
137450	2134	97744244000	17665	8930	1	0	1252
137456	2134	97743241000	17668	8931	1	0	1253
137457	1397	1337029837000	17669	8932	0	0	10180
137458	2134	97742238000	17669	8932	1	0	1254
137497	1397	1338780012000	17670	8746	39	0	\N
137498	1397	1338770011000	17670	8746	40	0	\N
137499	1397	1338760010000	17670	8746	41	0	\N
137500	1397	1338750009000	17670	8746	42	0	\N
137501	1397	1338740008000	17670	8746	43	0	\N
137502	1397	1338730007000	17670	8746	44	0	\N
137503	1397	1338720006000	17670	8746	45	0	\N
137504	1397	1338710005000	17670	8746	46	0	\N
137505	1397	1338700004000	17670	8746	47	0	\N
137506	1397	1338690003000	17670	8746	48	0	\N
137507	1397	1338680002000	17670	8746	49	0	\N
137508	1397	1338670001000	17670	8746	50	0	\N
137509	1397	1338660000000	17670	8746	51	0	\N
137510	1397	1338649999000	17670	8746	52	0	\N
137511	1397	1338639998000	17670	8746	53	0	\N
137512	1397	1338629997000	17670	8746	54	0	\N
137513	1397	1338619996000	17670	8746	55	0	\N
137514	1397	1338609995000	17670	8746	56	0	\N
137515	1397	1338599994000	17670	8746	57	0	\N
137516	1397	1338589993000	17670	8746	58	0	\N
137517	1397	1338579992000	17670	8746	59	0	\N
137518	1397	1338569991000	17670	8746	60	0	\N
137519	1397	1338559990000	17670	8746	61	0	\N
137520	1397	1338549989000	17670	8746	62	0	\N
137521	1397	1338539988000	17670	8746	63	0	\N
137522	1397	1338529987000	17670	8746	64	0	\N
137523	1397	1338519986000	17670	8746	65	0	\N
137524	1397	1338509985000	17670	8746	66	0	\N
137525	1397	1338499984000	17670	8746	67	0	\N
137526	1397	1338489983000	17670	8746	68	0	\N
137527	1397	1338479982000	17670	8746	69	0	\N
137528	1397	1338469981000	17670	8746	70	0	\N
137529	1397	1338459980000	17670	8746	71	0	\N
137530	1397	1338449979000	17670	8746	72	0	\N
137531	1397	1338439978000	17670	8746	73	0	\N
137532	1397	1338429977000	17670	8746	74	0	\N
137533	1397	1338419976000	17670	8746	75	0	\N
137534	1397	1338409975000	17670	8746	76	0	\N
137535	1397	1338399974000	17670	8746	77	0	\N
137536	1397	1338389973000	17670	8746	78	0	\N
137537	1397	1338379972000	17670	8746	79	0	\N
137538	1397	1338369971000	17670	8746	80	0	\N
137539	1397	1338359970000	17670	8746	81	0	\N
137540	1397	1338349969000	17670	8746	82	0	\N
137541	1397	1338339968000	17670	8746	83	0	\N
137542	1397	1338329967000	17670	8746	84	0	\N
137543	1397	1338319966000	17670	8746	85	0	\N
137544	1397	1338309965000	17670	8746	86	0	\N
137545	1397	1338299964000	17670	8746	87	0	\N
137546	1397	1338289963000	17670	8746	88	0	\N
137547	1397	1338279962000	17670	8746	89	0	\N
137548	1397	1338269961000	17670	8746	90	0	\N
137549	1397	1338259960000	17670	8746	91	0	\N
137550	1397	1338249959000	17670	8746	92	0	\N
137551	1397	1338239958000	17670	8746	93	0	\N
137552	1397	1338229957000	17670	8746	94	0	\N
137553	1397	1338219956000	17670	8746	95	0	\N
137554	1397	1338209955000	17670	8746	96	0	\N
137555	1397	1338199954000	17670	8746	97	0	\N
137556	1397	1338189953000	17670	8746	98	0	\N
137557	1397	1338179952000	17670	8746	99	0	\N
137558	1397	1338169951000	17670	8746	100	0	\N
137559	1397	1338159950000	17670	8746	101	0	\N
137560	1397	1338149949000	17670	8746	102	0	\N
137561	1397	1338139948000	17670	8746	103	0	\N
137562	1397	1338129947000	17670	8746	104	0	\N
137563	1397	1338119946000	17670	8746	105	0	\N
137564	1397	1338109945000	17670	8746	106	0	\N
137565	1397	1338099944000	17670	8746	107	0	\N
137566	1397	1338089943000	17670	8746	108	0	\N
137567	1397	1338079942000	17670	8746	109	0	\N
137568	1397	1338069941000	17670	8746	110	0	\N
137569	1397	1338059940000	17670	8746	111	0	\N
137570	1397	1338049939000	17670	8746	112	0	\N
137571	1397	1338039938000	17670	8746	113	0	\N
137572	1397	1338029937000	17670	8746	114	0	\N
137573	1397	1338019936000	17670	8746	115	0	\N
137574	1397	1338009935000	17670	8746	116	0	\N
137575	1397	1337999934000	17670	8746	117	0	\N
137576	1397	1337989933000	17670	8746	118	0	\N
137577	1397	1337979932000	17670	8746	119	0	\N
137578	1397	1337969931000	17670	8746	120	0	\N
137579	1397	1337959930000	17670	8746	121	0	\N
137580	1397	1337949929000	17670	8746	122	0	\N
137581	1397	1337939928000	17670	8746	123	0	\N
137582	1397	1337929927000	17670	8746	124	0	\N
137583	1397	1337919926000	17670	8746	125	0	\N
137584	1397	1337019836000	17671	8933	0	0	\N
137585	2134	97741235000	17671	8933	1	0	\N
137588	1397	1337009835000	17673	8934	0	0	\N
137589	1397	1336999834000	17673	8934	1	0	\N
137590	1397	1336989833000	17673	8934	2	0	\N
137591	1397	1336979832000	17673	8934	3	0	\N
137592	1397	1336969831000	17673	8934	4	0	\N
137593	2134	97740232000	17673	8934	5	0	\N
137594	2134	97739229000	17673	8934	6	0	\N
137595	2134	97738226000	17673	8934	7	0	\N
137596	2134	97737223000	17673	8934	8	0	\N
137597	2134	97736220000	17673	8934	9	0	\N
137608	1397	1336959830000	17675	8935	0	0	\N
137609	2134	97735217000	17675	8935	1	0	\N
137610	1397	1336959830000	17676	8935	0	0	\N
137611	2134	97735217000	17676	8935	1	0	\N
137614	1726	120475109000	17678	8915	0	0	\N
137615	1726	119265109000	17678	8915	1	0	\N
137616	1726	118055109000	17678	8915	2	0	\N
137617	1726	116845109000	17678	8915	3	0	\N
137618	1726	115635109000	17678	8915	4	0	\N
137619	2132	148693694000	17678	8915	5	0	\N
137626	1397	1336929827000	17682	8938	0	0	\N
137627	2134	97732208000	17682	8938	1	0	\N
137628	1726	114425109000	17683	8939	0	0	\N
137629	1397	1336919826000	17683	8939	1	0	\N
137630	2134	97731205000	17683	8939	2	0	\N
137598	1397	1337009835000	17674	8934	0	0	10182
137599	1397	1336999834000	17674	8934	1	0	10183
137600	1397	1336989833000	17674	8934	2	0	10184
137601	1397	1336979832000	17674	8934	3	0	10185
137602	1397	1336969831000	17674	8934	4	0	10186
137604	2134	97739229000	17674	8934	6	0	1257
137605	2134	97738226000	17674	8934	7	0	1258
137606	2134	97737223000	17674	8934	8	0	1259
137607	2134	97736220000	17674	8934	9	0	1260
137612	1397	1336959830000	17677	8935	0	0	10187
137620	1397	1336949829000	17679	8936	0	0	10188
137621	2134	97734214000	17679	8936	1	0	1262
137622	1397	1336939828000	17680	8937	0	0	10189
137623	2134	97733211000	17680	8937	1	0	1263
137625	2134	97732208000	17681	8938	1	0	1264
137631	1726	114425109000	17684	8939	0	0	8192
137632	1397	1336919826000	17684	8939	1	0	10191
137636	1494	144000000	17686	8863	0	0	\N
137637	1726	120475109000	17686	8863	1	0	\N
137638	1726	119265109000	17686	8863	2	0	\N
137639	1726	118055109000	17686	8863	3	0	\N
137640	1726	116845109000	17686	8863	4	0	\N
137641	1726	115635109000	17686	8863	5	0	\N
137642	1726	114425109000	17686	8863	6	0	\N
137643	1924	1195000000	17686	8863	7	0	\N
137644	2132	148693694000	17686	8863	8	0	\N
137645	1397	1336909825000	17687	8940	0	0	\N
137646	2134	97730202000	17687	8940	1	0	\N
137647	1494	144000000	17688	8854	0	0	\N
137648	1726	120475109000	17688	8854	1	0	\N
137649	1726	119265109000	17688	8854	2	0	\N
137650	1726	118055109000	17688	8854	3	0	\N
137651	1726	116845109000	17688	8854	4	0	\N
137652	1726	115635109000	17688	8854	5	0	\N
137653	1726	114425109000	17688	8854	6	0	\N
137654	2132	148693694000	17688	8854	7	0	\N
137671	1397	1336899824000	17690	8941	0	0	\N
137672	1397	1336889823000	17690	8941	1	0	\N
137673	1397	1336879822000	17690	8941	2	0	\N
137674	1397	1336869821000	17690	8941	3	0	\N
137675	1397	1336859820000	17690	8941	4	0	\N
137676	1397	1336849819000	17690	8941	5	0	\N
137677	1397	1336839818000	17690	8941	6	0	\N
137678	1397	1336829817000	17690	8941	7	0	\N
137679	2134	97729199000	17690	8941	8	0	\N
137680	2134	97728196000	17690	8941	9	0	\N
137681	2134	97727193000	17690	8941	10	0	\N
137682	2134	97726190000	17690	8941	11	0	\N
137683	2134	97725187000	17690	8941	12	0	\N
137684	2134	97724184000	17690	8941	13	0	\N
137685	2134	97723181000	17690	8941	14	0	\N
137686	2134	97722178000	17690	8941	15	0	\N
137687	1397	1336819816000	17691	8942	0	0	\N
137688	2134	97721175000	17691	8942	1	0	\N
137691	1397	1336809815000	17693	8943	0	0	\N
137692	1397	1336799814000	17693	8943	1	0	\N
137693	2134	97720172000	17693	8943	2	0	\N
137694	2134	97719169000	17693	8943	3	0	\N
137709	1397	1336739808000	17698	8947	0	0	\N
137710	2134	97713151000	17698	8947	1	0	\N
137712	1397	1336739808000	17700	8947	0	0	\N
137713	2134	97713151000	17700	8947	1	0	\N
137714	1397	1336739808000	17701	8947	0	0	\N
137715	2134	97713151000	17701	8947	1	0	\N
137719	1726	114425109000	17703	8916	0	0	\N
137720	1397	1336739808000	17704	8948	0	0	\N
137721	1397	1336729807000	17704	8948	1	0	\N
137722	1397	1336739808000	17705	8948	0	0	\N
137723	1397	1336729807000	17705	8948	1	0	\N
137724	2134	97712148000	17705	8948	2	0	\N
137725	1397	1336729807000	17706	8948	0	0	\N
137726	2134	97712148000	17706	8948	1	0	\N
137731	1397	1336699804000	17709	8951	0	0	\N
137732	2134	97709139000	17709	8951	1	0	\N
137735	1397	1336689803000	17711	8952	0	0	\N
137736	1397	1336679802000	17711	8952	1	0	\N
137737	2134	97708136000	17711	8952	2	0	\N
137738	2134	97707133000	17711	8952	3	0	\N
137739	1726	114425109000	17712	8912	0	0	\N
137748	1397	1336669801000	17715	8953	0	0	\N
137749	1397	1336659800000	17715	8953	1	0	\N
137750	2134	97706130000	17715	8953	2	0	\N
137751	2134	97705127000	17715	8953	3	0	\N
137752	1397	1336669801000	17716	8953	0	0	\N
137753	1397	1336659800000	17716	8953	1	0	\N
137754	2134	97706130000	17716	8953	2	0	\N
137755	2134	97705127000	17716	8953	3	0	\N
137760	1726	113215109000	17718	8955	0	0	\N
137761	1397	1336629797000	17718	8955	1	0	\N
137762	1397	1336619796000	17718	8955	2	0	\N
137763	2132	148692693000	17718	8955	3	0	\N
137764	2134	97702118000	17718	8955	4	0	\N
137765	2133	97720446000	17718	8955	5	0	\N
137766	2134	97701115000	17718	8955	6	0	\N
137767	1726	113215109000	17719	8955	0	0	\N
137768	1397	1336629797000	17719	8955	1	0	\N
137635	2134	97730202000	17685	8940	1	0	1266
137655	1397	1336899824000	17689	8941	0	0	10193
137656	1397	1336889823000	17689	8941	1	0	10194
137657	1397	1336879822000	17689	8941	2	0	10195
137658	1397	1336869821000	17689	8941	3	0	10196
137660	1397	1336849819000	17689	8941	5	0	10198
137661	1397	1336839818000	17689	8941	6	0	10199
137662	1397	1336829817000	17689	8941	7	0	10200
137663	2134	97729199000	17689	8941	8	0	1267
137664	2134	97728196000	17689	8941	9	0	1268
137666	2134	97726190000	17689	8941	11	0	1270
137667	2134	97725187000	17689	8941	12	0	1271
137668	2134	97724184000	17689	8941	13	0	1272
137669	2134	97723181000	17689	8941	14	0	1273
137689	1397	1336819816000	17692	8942	0	0	10201
137690	2134	97721175000	17692	8942	1	0	1275
137695	1397	1336809815000	17694	8943	0	0	10202
137696	1397	1336799814000	17694	8943	1	0	10203
137697	2134	97720172000	17694	8943	2	0	1276
137699	1397	1336789813000	17695	8944	0	0	10204
137700	2134	97718166000	17695	8944	1	0	1278
137701	1397	1336779812000	17696	8945	0	0	10205
137702	2134	97717163000	17696	8945	1	0	1279
137703	1397	1336769811000	17697	8946	0	0	10206
137705	1397	1336749809000	17697	8946	2	0	10208
137706	2134	97716160000	17697	8946	3	0	1280
137707	2134	97715157000	17697	8946	4	0	1281
137708	2134	97714154000	17697	8946	5	0	1282
137716	1397	1336739808000	17702	8948	0	0	10209
137717	1397	1336729807000	17702	8948	1	0	10210
137718	2134	97712148000	17702	8948	2	0	1284
137727	1397	1336719806000	17707	8949	0	0	10211
137728	2134	97711145000	17707	8949	1	0	1285
137730	2134	97710142000	17708	8950	1	0	1286
137733	1397	1336699804000	17710	8951	0	0	10213
137734	2134	97709139000	17710	8951	1	0	1287
137740	1397	1336689803000	17713	8952	0	0	10214
137741	1397	1336679802000	17713	8952	1	0	10215
137743	2134	97707133000	17713	8952	3	0	1289
137744	1397	1336669801000	17714	8953	0	0	10216
137745	1397	1336659800000	17714	8953	1	0	10217
137746	2134	97706130000	17714	8953	2	0	1290
137756	1397	1336649799000	17717	8954	0	0	10218
137757	1397	1336639798000	17717	8954	1	0	10219
137758	2134	97704124000	17717	8954	2	0	1292
137759	2134	97703121000	17717	8954	3	0	1293
137769	1397	1336619796000	17719	8955	2	0	\N
137770	2132	148692693000	17719	8955	3	0	\N
137771	2134	97702118000	17719	8955	4	0	\N
137772	2133	97720446000	17719	8955	5	0	\N
137773	2134	97701115000	17719	8955	6	0	\N
137781	1726	113215109000	17721	8955	0	0	\N
137782	1397	1336629797000	17721	8955	1	0	\N
137783	1397	1336619796000	17721	8955	2	0	\N
137784	2132	148692693000	17721	8955	3	0	\N
137785	2134	97702118000	17721	8955	4	0	\N
137786	2133	97720446000	17721	8955	5	0	\N
137787	2134	97701115000	17721	8955	6	0	\N
137793	1397	1336599794000	17724	8957	0	0	\N
137794	2133	97718442000	17724	8957	1	0	\N
137795	2134	97700112000	17724	8957	2	0	\N
137796	1397	1336589793000	17725	8958	0	0	\N
137797	2133	97717440000	17725	8958	1	0	\N
137798	2134	97699109000	17725	8958	2	0	\N
137812	2132	148692693000	17729	8939	0	0	\N
137813	2133	97720446000	17729	8939	1	0	\N
137814	2133	97719444000	17729	8939	2	0	\N
137815	2133	97718442000	17729	8939	3	0	\N
137816	2133	97717440000	17729	8939	4	0	\N
137817	2133	97716438000	17729	8939	5	0	\N
137818	2133	97715436000	17729	8939	6	0	\N
137819	2132	148691692000	17729	8939	7	0	\N
137820	2132	148690691000	17729	8939	8	0	\N
137821	2133	97714434000	17729	8939	9	0	\N
137822	2133	97713432000	17729	8939	10	0	\N
137827	1397	1336549789000	17731	8961	0	0	\N
137828	2134	97695097000	17731	8961	1	0	\N
137829	2133	97713432000	17731	8961	2	0	\N
137830	2132	148690691000	17731	8961	3	0	\N
137852	1397	1336499784000	17735	8964	0	0	\N
137853	329	67444612000000	17735	8964	1	0	\N
137854	1397	1336489783000	17735	8964	2	0	\N
137855	2134	97690082000	17735	8964	3	0	\N
137856	2134	97689079000	17735	8964	4	0	\N
137857	2133	97708422000	17735	8964	5	0	\N
137858	2133	97707420000	17735	8964	6	0	\N
137877	1397	1336449779000	17738	8966	0	0	\N
137878	1397	1336439778000	17738	8966	1	0	\N
137879	2133	97703412000	17738	8966	2	0	\N
137880	2132	148687688000	17738	8966	3	0	\N
137881	2133	97702410000	17738	8966	4	0	\N
137882	2133	97703412000	17739	8966	0	0	\N
137883	2133	97702410000	17739	8966	1	0	\N
137884	1397	1336449779000	17740	8966	0	0	\N
137885	1397	1336439778000	17740	8966	1	0	\N
137886	2134	97685067000	17740	8966	2	0	\N
137887	2134	97684064000	17740	8966	3	0	\N
137888	2133	97703412000	17740	8966	4	0	\N
137889	2132	148687688000	17740	8966	6	0	\N
137890	2133	97702410000	17740	8966	7	0	\N
137891	1397	1336449779000	17741	8966	0	0	\N
137892	1397	1336439778000	17741	8966	1	0	\N
137893	2134	97685067000	17741	8966	2	0	\N
137894	2134	97684064000	17741	8966	3	0	\N
137895	2133	97703412000	17741	8966	4	0	\N
137896	2132	148687688000	17741	8966	6	0	\N
137897	2133	97702410000	17741	8966	7	0	\N
137898	1397	1336449779000	17742	8966	0	0	\N
137899	1397	1336439778000	17742	8966	1	0	\N
137900	2134	97685067000	17742	8966	2	0	\N
137901	2134	97684064000	17742	8966	3	0	\N
137902	2133	97703412000	17742	8966	4	0	\N
137903	2132	148687688000	17742	8966	6	0	\N
137904	2133	97702410000	17742	8966	7	0	\N
137776	1397	1336619796000	17720	8955	2	0	10221
137777	2132	148692693000	17720	8955	3	0	307
137778	2134	97702118000	17720	8955	4	0	1294
137779	2133	97720446000	17720	8955	5	0	1277
137780	2134	97701115000	17720	8955	6	0	1295
137789	2133	97719444000	17722	8956	1	0	1278
137790	1397	1336599794000	17723	8957	0	0	10223
137791	2133	97718442000	17723	8957	1	0	1279
137792	2134	97700112000	17723	8957	2	0	1296
137799	1397	1336589793000	17726	8958	0	0	10224
137801	2134	97699109000	17726	8958	2	0	1297
137802	1397	1336579792000	17727	8959	0	0	10225
137803	1397	1336569791000	17727	8959	1	0	10226
137804	2134	97698106000	17727	8959	2	0	1298
137806	2133	97715436000	17727	8959	4	0	1282
137807	2134	97697103000	17727	8959	5	0	1299
137808	2132	148691692000	17727	8959	6	0	308
137809	1397	1336559790000	17728	8960	0	0	10227
137810	2134	97696100000	17728	8960	1	0	1300
137823	1397	1336549789000	17730	8961	0	0	10228
137824	2134	97695097000	17730	8961	1	0	1301
137825	2133	97713432000	17730	8961	2	0	1284
137826	2132	148690691000	17730	8961	3	0	309
137831	1397	1336539788000	17732	8962	0	0	10229
137833	2133	97712430000	17732	8962	2	0	1285
137834	2133	97711428000	17732	8962	3	0	1286
137835	2134	97694094000	17732	8962	4	0	1302
137836	2134	97693091000	17732	8962	5	0	1303
137838	1397	1336519786000	17733	8963	1	0	10231
137839	1397	1336509785000	17733	8963	2	0	10232
137840	2133	97710426000	17733	8963	3	0	1287
137841	2134	97692088000	17733	8963	4	0	1304
137842	2134	97691085000	17733	8963	5	0	1305
137844	2132	148689690000	17733	8963	7	0	310
137845	1397	1336499784000	17734	8964	0	0	10233
137846	329	67444612000000	17734	8964	1	0	5
137847	1397	1336489783000	17734	8964	2	0	10234
137848	2134	97690082000	17734	8964	3	0	1306
137850	2133	97708422000	17734	8964	5	0	1289
137851	2133	97707420000	17734	8964	6	0	1290
137859	1789	712990000000	17736	8965	0	0	1
137860	1397	1336479782000	17736	8965	1	0	10235
137862	1397	1336459780000	17736	8965	3	0	10237
137863	2134	97688076000	17736	8965	4	0	1308
137864	2134	97687073000	17736	8965	5	0	1309
137865	2132	148688689000	17736	8965	6	0	311
137866	2133	97706418000	17736	8965	7	0	1291
137868	2133	97704414000	17736	8965	9	0	1293
137869	2134	97686070000	17736	8965	10	0	1310
137870	1397	1336449779000	17737	8966	0	0	10238
137871	1397	1336439778000	17737	8966	1	0	10239
137872	2134	97685067000	17737	8966	2	0	1311
137874	2133	97703412000	17737	8966	4	0	1294
137875	2132	148687688000	17737	8966	6	0	312
137876	2133	97702410000	17737	8966	7	0	1295
137905	1397	1336449779000	17743	8966	0	0	\N
137906	1397	1336439778000	17743	8966	1	0	\N
137907	2134	97685067000	17743	8966	2	0	\N
137908	2134	97684064000	17743	8966	3	0	\N
137909	2133	97703412000	17743	8966	4	0	\N
137910	2132	148687688000	17743	8966	6	0	\N
137911	2133	97702410000	17743	8966	7	0	\N
137912	1397	1336449779000	17744	8966	0	0	\N
137913	1397	1336439778000	17744	8966	1	0	\N
137914	2134	97685067000	17744	8966	2	0	\N
137915	2134	97684064000	17744	8966	3	0	\N
137916	2133	97703412000	17744	8966	4	0	\N
137917	2132	148687688000	17744	8966	6	0	\N
137918	2133	97702410000	17744	8966	7	0	\N
137919	1397	1336449779000	17745	8966	0	0	\N
137920	1397	1336439778000	17745	8966	1	0	\N
137921	2133	97703412000	17745	8966	2	0	\N
137922	2132	148687688000	17745	8966	3	0	\N
137923	2133	97702410000	17745	8966	4	0	\N
137924	1397	1336429777000	17746	8967	0	0	\N
137925	1397	1336419776000	17746	8967	1	0	\N
137926	2133	97701408000	17746	8967	2	0	\N
137927	2133	97700406000	17746	8967	3	0	\N
137928	2134	97683061000	17746	8967	4	0	\N
137929	2134	97682058000	17746	8967	5	0	\N
137936	1397	1336429777000	17748	8967	0	0	\N
137937	1397	1336419776000	17748	8967	1	0	\N
137938	2133	97701408000	17748	8967	2	0	\N
137939	2133	97700406000	17748	8967	3	0	\N
137940	2134	97683061000	17748	8967	4	0	\N
137941	2134	97682058000	17748	8967	5	0	\N
137946	1397	1336409775000	17750	8968	0	0	\N
137947	2134	97681055000	17750	8968	1	0	\N
137948	2132	148686687000	17750	8968	2	0	\N
137949	2133	97699404000	17750	8968	3	0	\N
137950	1397	1337379872000	17751	8898	0	0	\N
137951	1397	1337369871000	17751	8898	1	0	\N
137952	1789	712990000000	17751	8898	2	0	\N
137953	329	67444612000000	17751	8898	3	0	\N
137954	338	66720014000000	17751	8898	4	0	\N
137955	1726	120475109000	17751	8898	5	0	\N
137956	1726	119265109000	17751	8898	6	0	\N
137957	1397	1337359870000	17751	8898	7	0	\N
137958	1726	118055109000	17751	8898	8	0	\N
137959	1726	116845109000	17751	8898	10	0	\N
137960	1726	115635109000	17751	8898	11	0	\N
137961	1726	114425109000	17751	8898	12	0	\N
137962	1726	113215109000	17751	8898	13	0	\N
137963	1397	1337349869000	17751	8898	14	0	\N
137964	1397	1337339868000	17751	8898	15	0	\N
137965	1397	1337329867000	17751	8898	16	0	\N
137966	1397	1337319866000	17751	8898	17	0	\N
137967	1397	1337309865000	17751	8898	18	0	\N
137968	1397	1337299864000	17751	8898	19	0	\N
137969	1397	1337289863000	17751	8898	20	0	\N
137970	1397	1337279862000	17751	8898	21	0	\N
137971	1397	1337269861000	17751	8898	22	0	\N
137972	1397	1337259860000	17751	8898	23	0	\N
137973	1397	1337249859000	17751	8898	24	0	\N
137974	1397	1337239858000	17751	8898	25	0	\N
137975	1397	1337229857000	17751	8898	26	0	\N
137976	1397	1337219856000	17751	8898	27	0	\N
137977	1397	1337209855000	17751	8898	28	0	\N
137978	1397	1337199854000	17751	8898	29	0	\N
137979	1397	1337189853000	17751	8898	30	0	\N
137980	1397	1337179852000	17751	8898	31	0	\N
137981	1397	1337169851000	17751	8898	32	0	\N
137982	1397	1337159850000	17751	8898	33	0	\N
137983	1397	1337149849000	17751	8898	34	0	\N
137984	1397	1337139848000	17751	8898	35	0	\N
137985	1397	1337129847000	17751	8898	36	0	\N
137986	1397	1337119846000	17751	8898	37	0	\N
137987	1397	1337109845000	17751	8898	38	0	\N
137988	1397	1337099844000	17751	8898	39	0	\N
137989	1397	1337089843000	17751	8898	40	0	\N
137990	1397	1337079842000	17751	8898	41	0	\N
137991	1397	1337069841000	17751	8898	42	0	\N
137992	1397	1337059840000	17751	8898	43	0	\N
137993	1397	1337049839000	17751	8898	44	0	\N
137994	1397	1337039838000	17751	8898	45	0	\N
137995	1397	1337029837000	17751	8898	46	0	\N
137996	1397	1337019836000	17751	8898	47	0	\N
137997	1397	1337009835000	17751	8898	48	0	\N
137998	1397	1336999834000	17751	8898	49	0	\N
137999	1397	1336989833000	17751	8898	50	0	\N
138000	1397	1336979832000	17751	8898	51	0	\N
138001	1397	1336969831000	17751	8898	52	0	\N
138002	1397	1336959830000	17751	8898	53	0	\N
138003	1397	1336949829000	17751	8898	54	0	\N
138004	1397	1336939828000	17751	8898	55	0	\N
138005	1397	1336929827000	17751	8898	56	0	\N
138006	1397	1336919826000	17751	8898	57	0	\N
138007	1397	1336909825000	17751	8898	58	0	\N
138008	1397	1336899824000	17751	8898	59	0	\N
138009	1397	1336889823000	17751	8898	60	0	\N
138010	1397	1336879822000	17751	8898	61	0	\N
138011	1397	1336869821000	17751	8898	62	0	\N
138012	1397	1336859820000	17751	8898	63	0	\N
138013	1397	1336849819000	17751	8898	64	0	\N
138014	1397	1336839818000	17751	8898	65	0	\N
138015	1397	1336829817000	17751	8898	66	0	\N
138016	1397	1336819816000	17751	8898	67	0	\N
138017	1397	1336809815000	17751	8898	68	0	\N
138018	1397	1336799814000	17751	8898	69	0	\N
138022	1397	1336399774000	17753	8969	0	0	\N
138023	2134	97680052000	17753	8969	1	0	\N
138024	2133	97698402000	17753	8969	2	0	\N
137932	2133	97701408000	17747	8967	2	0	1296
137933	2133	97700406000	17747	8967	3	0	1297
137934	2134	97683061000	17747	8967	4	0	1313
137935	2134	97682058000	17747	8967	5	0	1314
137942	1397	1336409775000	17749	8968	0	0	10242
137944	2132	148686687000	17749	8968	2	0	313
137945	2133	97699404000	17749	8968	3	0	1298
138019	1397	1336399774000	17752	8969	0	0	10243
138020	2134	97680052000	17752	8969	1	0	1316
138021	2133	97698402000	17752	8969	2	0	1299
138026	2134	97679049000	17754	8970	1	0	1317
138027	2133	97697400000	17754	8970	2	0	1300
138028	1397	1336379772000	17755	8971	0	0	10245
138029	2134	97678046000	17755	8971	1	0	1318
138031	2132	148685686000	17755	8971	3	0	314
138032	1397	1336369771000	17756	8972	0	0	10246
138033	1397	1336359770000	17756	8972	1	0	10247
138034	1397	1336349769000	17756	8972	2	0	10248
138035	1397	1336339768000	17756	8972	3	0	10249
138037	2133	97694394000	17756	8972	5	0	1303
138038	2133	97693392000	17756	8972	6	0	1304
138039	2134	97677043000	17756	8972	7	0	1319
138040	2134	97676040000	17756	8972	8	0	1320
138044	1397	1336369771000	17757	8972	0	0	\N
138045	1397	1336359770000	17757	8972	1	0	\N
138046	1397	1336349769000	17757	8972	2	0	\N
138047	1397	1336339768000	17757	8972	3	0	\N
138048	2133	97695396000	17757	8972	4	0	\N
138049	2133	97694394000	17757	8972	5	0	\N
138050	2133	97693392000	17757	8972	6	0	\N
138051	2134	97677043000	17757	8972	7	0	\N
138052	2134	97676040000	17757	8972	8	0	\N
138053	2134	97675037000	17757	8972	9	0	\N
138054	2134	97674034000	17757	8972	10	0	\N
138055	2132	148684685000	17757	8972	11	0	\N
138056	1397	1336369771000	17758	8972	0	0	\N
138057	1397	1336359770000	17758	8972	1	0	\N
138058	1397	1336349769000	17758	8972	2	0	\N
138059	1397	1336339768000	17758	8972	3	0	\N
138060	2133	97695396000	17758	8972	4	0	\N
138061	2133	97694394000	17758	8972	5	0	\N
138062	2133	97693392000	17758	8972	6	0	\N
138063	2134	97677043000	17758	8972	7	0	\N
138064	2134	97676040000	17758	8972	8	0	\N
138065	2134	97675037000	17758	8972	9	0	\N
138066	2134	97674034000	17758	8972	10	0	\N
138067	2132	148684685000	17758	8972	11	0	\N
138071	1397	1336329767000	17760	8973	0	0	\N
138072	2134	97673031000	17760	8973	1	0	\N
138073	2133	97692390000	17760	8973	2	0	\N
138074	1397	1336319766000	17761	8974	0	0	\N
138075	2134	97672028000	17761	8974	1	0	\N
138076	2133	97691388000	17761	8974	2	0	\N
138077	1397	1336319766000	17762	8974	0	0	\N
138078	2134	97672028000	17762	8974	1	0	\N
138079	2133	97691388000	17762	8974	2	0	\N
138080	1397	1336319766000	17763	8974	0	0	\N
138081	2134	97672028000	17763	8974	1	0	\N
138082	2133	97691388000	17763	8974	2	0	\N
138083	1397	1336319766000	17764	8974	0	0	\N
138084	2134	97672028000	17764	8974	1	0	\N
138085	2133	97691388000	17764	8974	2	0	\N
138103	1397	1336289763000	17768	8976	0	0	\N
138104	1397	1336279762000	17768	8976	1	0	\N
138105	2134	97669019000	17768	8976	2	0	\N
138106	2133	97688382000	17768	8976	3	0	\N
138107	2133	97687380000	17768	8976	4	0	\N
138108	2132	148682683000	17768	8976	5	0	\N
138109	2134	97668016000	17768	8976	6	0	\N
138113	1397	1336259760000	17770	8978	0	0	\N
138114	1397	1336249759000	17770	8978	1	0	\N
138115	1397	1336239758000	17770	8978	2	0	\N
138116	1397	1336229757000	17770	8978	3	0	\N
138117	2131	199000000	17770	8978	4	0	\N
138118	2131	198000000	17770	8978	5	0	\N
138119	2134	97666010000	17770	8978	6	0	\N
138120	2133	97685376000	17770	8978	7	0	\N
138121	2133	97684374000	17770	8978	8	0	\N
138122	2134	97665007000	17770	8978	9	0	\N
138123	2134	97664004000	17770	8978	10	0	\N
138124	2134	97663001000	17770	8978	11	0	\N
138125	2132	148681682000	17770	8978	12	0	\N
138126	2133	97683372000	17770	8978	13	0	\N
138127	2133	97682370000	17770	8978	14	0	\N
138147	1397	1336219756000	17773	8979	0	0	\N
138148	2133	97681368000	17773	8979	1	0	\N
138149	2131	196999000	17773	8979	2	0	\N
138150	2134	97661998000	17773	8979	3	0	\N
138161	1397	1336209755000	17775	8980	0	0	\N
138162	1397	1336199754000	17775	8980	1	0	\N
138163	1397	1336189753000	17775	8980	2	0	\N
138164	2133	97680366000	17775	8980	3	0	\N
138165	2132	148680681000	17775	8980	4	0	\N
138166	2133	97679364000	17775	8980	5	0	\N
138167	2133	97678362000	17775	8980	6	0	\N
138168	2134	97660995000	17775	8980	7	0	\N
138169	2134	97659992000	17775	8980	8	0	\N
138170	2134	97658989000	17775	8980	9	0	\N
138043	2132	148684685000	17756	8972	11	0	315
138068	1397	1336329767000	17759	8973	0	0	10250
138069	2134	97673031000	17759	8973	1	0	1323
138070	2133	97692390000	17759	8973	2	0	1305
138086	1397	1336319766000	17765	8974	0	0	10251
138088	2133	97691388000	17765	8974	2	0	1306
138089	1397	1336309765000	17766	8975	0	0	10252
138090	1397	1336299764000	17766	8975	1	0	10253
138091	2133	97690386000	17766	8975	2	0	1307
138092	2132	148683684000	17766	8975	3	0	316
138094	2134	97671025000	17766	8975	5	0	1325
138095	2134	97670022000	17766	8975	6	0	1326
138096	1397	1336289763000	17767	8976	0	0	10254
138097	1397	1336279762000	17767	8976	1	0	10255
138099	2133	97688382000	17767	8976	3	0	1309
138100	2133	97687380000	17767	8976	4	0	1310
138101	2132	148682683000	17767	8976	5	0	317
138102	2134	97668016000	17767	8976	6	0	1328
138110	1397	1336269761000	17769	8977	0	0	10256
138112	2133	97686378000	17769	8977	2	0	1311
138128	1397	1336259760000	17771	8978	0	0	10257
138129	1397	1336249759000	17771	8978	1	0	10258
138130	1397	1336239758000	17771	8978	2	0	10259
138131	1397	1336229757000	17771	8978	3	0	10260
138133	2131	198000000	17771	8978	5	0	2
138134	2134	97666010000	17771	8978	6	0	1330
138135	2133	97685376000	17771	8978	7	0	1312
138136	2133	97684374000	17771	8978	8	0	1313
138138	2134	97664004000	17771	8978	10	0	1332
138139	2134	97663001000	17771	8978	11	0	1333
138140	2132	148681682000	17771	8978	12	0	318
138141	2133	97683372000	17771	8978	13	0	1314
138142	2133	97682370000	17771	8978	14	0	1315
138144	2133	97681368000	17772	8979	1	0	1316
138145	2131	196999000	17772	8979	2	0	3
138146	2134	97661998000	17772	8979	3	0	1334
138151	1397	1336209755000	17774	8980	0	0	10262
138152	1397	1336199754000	17774	8980	1	0	10263
138154	2133	97680366000	17774	8980	3	0	1317
138155	2132	148680681000	17774	8980	4	0	319
138156	2133	97679364000	17774	8980	5	0	1318
138157	2133	97678362000	17774	8980	6	0	1319
138159	2134	97659992000	17774	8980	8	0	1336
138160	2134	97658989000	17774	8980	9	0	1337
138171	1397	1336179752000	17776	8981	0	0	10265
138172	2132	148679680000	17776	8981	1	0	320
138173	2134	97657986000	17776	8981	2	0	1338
138175	1397	1336169751000	17777	8982	0	0	10266
138176	2133	97676358000	17777	8982	1	0	1321
138190	1397	1336129747000	17783	8986	0	0	\N
138191	2134	97653974000	17783	8986	1	0	\N
138192	2133	97672350000	17783	8986	2	0	\N
138193	1397	1336119746000	17785	8987	0	0	\N
138194	2134	97652971000	17785	8987	1	0	\N
138195	2133	97671348000	17785	8987	2	0	\N
138196	1397	1336119746000	17786	8987	0	0	\N
138197	2134	97652971000	17786	8987	1	0	\N
138198	2133	97671348000	17786	8987	2	0	\N
138199	1397	1336119746000	17788	8987	0	0	\N
138200	2134	97652971000	17788	8987	1	0	\N
138201	2133	97671348000	17788	8987	2	0	\N
138205	1397	1336109745000	17793	8988	0	0	\N
138206	1397	1336099744000	17793	8988	1	0	\N
138207	2133	97670346000	17793	8988	2	0	\N
138208	2133	97669344000	17793	8988	3	0	\N
138209	2132	148677678000	17793	8988	4	0	\N
138210	2134	97651968000	17793	8988	5	0	\N
138211	2134	97650965000	17793	8988	6	0	\N
138212	1397	1336109745000	17794	8988	0	0	\N
138213	1397	1336099744000	17794	8988	1	0	\N
138214	2133	97670346000	17794	8988	2	0	\N
138215	2133	97669344000	17794	8988	3	0	\N
138216	2132	148677678000	17794	8988	4	0	\N
138217	2134	97651968000	17794	8988	5	0	\N
138218	2134	97650965000	17794	8988	6	0	\N
138236	1397	1336059740000	17799	8992	0	0	\N
138237	2134	97646953000	17799	8992	1	0	\N
138238	2133	97665336000	17799	8992	2	0	\N
138239	1397	1336059740000	17800	8992	0	0	\N
138240	2134	97646953000	17800	8992	1	0	\N
138241	2133	97665336000	17800	8992	2	0	\N
138242	1397	1336059740000	17801	8992	0	0	\N
138243	2134	97646953000	17801	8992	1	0	\N
138244	2133	97665336000	17801	8992	2	0	\N
138248	1397	1336059740000	17803	8992	0	0	\N
138249	1397	1336059740000	17804	8992	0	0	\N
138250	2134	97646953000	17804	8992	1	0	\N
138251	2133	97665336000	17804	8992	2	0	\N
138252	2133	97664334000	17804	8992	3	0	\N
138253	2134	97645950000	17804	8992	4	0	\N
138254	1397	1336049739000	17805	8993	0	0	\N
138255	2118	1399000000	17805	8993	1	0	\N
138256	2133	97664334000	17805	8993	2	0	\N
138257	2132	148675676000	17805	8993	3	0	\N
138258	2134	97645950000	17805	8993	4	0	\N
138259	1397	1336049739000	17806	8993	0	0	\N
138260	2118	1399000000	17806	8993	1	0	\N
138261	2133	97664334000	17806	8993	2	0	\N
138262	2132	148675676000	17806	8993	3	0	\N
138263	2134	97645950000	17806	8993	4	0	\N
138271	1397	1336039738000	17808	8994	0	0	\N
138286	2134	97639932000	17812	8996	0	0	\N
138287	2133	97658322000	17812	8996	1	0	\N
138288	2134	97638929000	17813	8997	0	0	\N
138289	2132	148673674000	17813	8997	1	0	\N
138290	2133	97657320000	17813	8997	2	0	\N
138291	2134	97638929000	17814	8997	0	0	\N
138292	2132	148673674000	17814	8997	1	0	\N
138293	2133	97657320000	17814	8997	2	0	\N
138294	2134	97638929000	17815	8997	0	0	\N
138295	2132	148673674000	17815	8997	1	0	\N
138296	2133	97657320000	17815	8997	2	0	\N
138303	1397	1336019736000	17819	8998	0	0	\N
138304	2134	97637926000	17819	8998	1	0	\N
138305	2133	97656318000	17819	8998	2	0	\N
138179	1397	1336149749000	17780	8984	1	0	10268
138180	2134	97655980000	17780	8984	2	0	1340
138181	2133	97675356000	17780	8984	3	0	1322
138182	2132	148678679000	17780	8984	4	0	321
138183	2133	97674354000	17780	8984	5	0	1323
138185	2134	97654977000	17781	8985	1	0	1341
138186	2133	97673352000	17781	8985	2	0	1324
138187	1397	1336129747000	17782	8986	0	0	10270
138188	2134	97653974000	17782	8986	1	0	1342
138189	2133	97672350000	17782	8986	2	0	1325
138203	2134	97652971000	17789	8987	1	0	1343
138204	2133	97671348000	17789	8987	2	0	1326
138219	1397	1336109745000	17795	8988	0	0	10272
138220	1397	1336099744000	17795	8988	1	0	10273
138222	2133	97669344000	17795	8988	3	0	1328
138223	2132	148677678000	17795	8988	4	0	322
138224	2134	97651968000	17795	8988	5	0	1344
138225	2134	97650965000	17795	8988	6	0	1345
138226	2134	97649962000	17796	8989	0	0	1346
138228	1397	1336089743000	17797	8990	0	0	10274
138229	1397	1336079742000	17797	8990	1	0	10275
138230	2132	148676677000	17797	8990	2	0	323
138231	2133	97667340000	17797	8990	3	0	1330
138232	2134	97648959000	17797	8990	4	0	1347
138234	2133	97666338000	17798	8991	1	0	1331
138235	2134	97647956000	17798	8991	2	0	1348
138245	1397	1336059740000	17802	8992	0	0	10277
138246	2134	97646953000	17802	8992	1	0	1349
138264	1397	1336049739000	17807	8993	0	0	10278
138265	2118	1399000000	17807	8993	1	0	1
138266	2133	97664334000	17807	8993	2	0	1333
138267	2133	97663332000	17807	8993	3	0	1334
138268	2132	148675676000	17807	8993	4	0	324
138270	2134	97644947000	17807	8993	6	0	1351
138272	1726	112005110000	17809	8994	0	0	8194
138273	1397	1336039738000	17809	8994	1	0	10279
138274	1397	1336029737000	17809	8994	2	0	10280
138275	2134	97643944000	17809	8994	3	0	1352
138277	2134	97642941000	17809	8994	5	0	1353
138278	2134	97641938000	17809	8994	6	0	1354
138279	2133	97662330000	17809	8994	7	0	1335
138280	2133	97661328000	17809	8994	8	0	1336
138282	2134	97640935000	17810	8995	0	0	1355
138283	2133	97659324000	17810	8995	1	0	1338
138284	2134	97639932000	17811	8996	0	0	1356
138285	2133	97658322000	17811	8996	1	0	1339
138297	2134	97638929000	17816	8997	0	0	1357
138299	2133	97657320000	17816	8997	2	0	1340
138300	1397	1336019736000	17818	8998	0	0	10281
138301	2134	97637926000	17818	8998	1	0	1358
138302	2133	97656318000	17818	8998	2	0	1341
138306	1397	1336009735000	17820	8999	0	0	10282
138308	2134	97636923000	17820	8999	2	0	1359
138309	1397	1335999734000	17821	9000	0	0	10283
138310	2132	148672673000	17821	9000	1	0	327
138311	2133	97654314000	17821	9000	2	0	1343
138313	1397	1335999734000	17822	9000	0	0	\N
138314	2132	148672673000	17822	9000	1	0	\N
138315	2133	97654314000	17822	9000	2	0	\N
138316	2134	97635920000	17822	9000	3	0	\N
138326	1397	1335979732000	17825	9002	0	0	\N
138327	1397	1335969731000	17825	9002	1	0	\N
138328	2133	97652310000	17825	9002	2	0	\N
138329	2133	97651308000	17825	9002	3	0	\N
138330	2134	97633914000	17825	9002	4	0	\N
138331	2134	97632911000	17825	9002	5	0	\N
138336	1397	1335959730000	17827	9003	0	0	\N
138337	2133	97650306000	17827	9003	1	0	\N
138338	2134	97631908000	17827	9003	2	0	\N
138339	2132	148671672000	17827	9003	3	0	\N
138340	1397	1335949729000	17828	9004	0	0	\N
138341	2133	97649304000	17828	9004	1	0	\N
138342	2134	97630905000	17828	9004	2	0	\N
138343	1397	1335949729000	17829	9004	0	0	\N
138344	2133	97649304000	17829	9004	1	0	\N
138345	2134	97630905000	17829	9004	2	0	\N
138346	1397	1335949729000	17830	9004	0	0	\N
138347	2133	97649304000	17830	9004	1	0	\N
138348	2134	97630905000	17830	9004	2	0	\N
138352	1397	1335939728000	17833	9006	0	0	\N
138353	1397	1335929727000	17833	9006	1	0	\N
138354	2132	148670671000	17833	9006	2	0	\N
138355	2133	97648302000	17833	9006	3	0	\N
138356	2133	97647300000	17833	9006	4	0	\N
138357	2134	97629902000	17833	9006	5	0	\N
138358	2134	97628899000	17833	9006	6	0	\N
138359	1397	1335939728000	17834	9006	0	0	\N
138360	1397	1335929727000	17834	9006	1	0	\N
138361	2132	148670671000	17834	9006	2	0	\N
138362	2133	97648302000	17834	9006	3	0	\N
138363	2133	97647300000	17834	9006	4	0	\N
138364	2134	97629902000	17834	9006	5	0	\N
138365	2134	97628899000	17834	9006	6	0	\N
138373	1397	1335919726000	17836	9007	0	0	\N
138374	1397	1335909725000	17836	9007	1	0	\N
138375	2133	97646298000	17836	9007	2	0	\N
138376	2133	97645296000	17836	9007	3	0	\N
138377	1397	1335919726000	17837	9007	0	0	\N
138378	1397	1335909725000	17837	9007	1	0	\N
138379	2134	97627896000	17837	9007	2	0	\N
138380	2134	97626893000	17837	9007	3	0	\N
138381	2133	97646298000	17837	9007	4	0	\N
138382	2133	97645296000	17837	9007	5	0	\N
138383	1397	1335919726000	17838	9007	0	0	\N
138384	1397	1335909725000	17838	9007	1	0	\N
138385	2134	97627896000	17838	9007	2	0	\N
138386	2134	97626893000	17838	9007	3	0	\N
138387	2133	97646298000	17838	9007	4	0	\N
138388	2133	97645296000	17838	9007	5	0	\N
138389	1397	1335919726000	17839	9007	0	0	\N
138390	1397	1335909725000	17839	9007	1	0	\N
138391	2134	97627896000	17839	9007	2	0	\N
138392	2134	97626893000	17839	9007	3	0	\N
138393	2133	97646298000	17839	9007	4	0	\N
138394	2133	97645296000	17839	9007	5	0	\N
138395	1397	1335919726000	17841	9007	0	0	\N
138396	1397	1335909725000	17841	9007	1	0	\N
138397	2134	97627896000	17841	9007	2	0	\N
138398	2134	97626893000	17841	9007	3	0	\N
138399	2133	97646298000	17841	9007	4	0	\N
138400	2133	97645296000	17841	9007	5	0	\N
138401	2133	97644294000	17841	9007	6	0	\N
138412	1397	1335899724000	17844	9008	0	0	\N
138413	2133	97644294000	17844	9008	1	0	\N
138414	2132	148669670000	17844	9008	2	0	\N
138415	2134	97625890000	17844	9008	3	0	\N
138416	1397	1335899724000	17845	9008	0	0	\N
138417	2133	97644294000	17845	9008	1	0	\N
138418	2134	97625890000	17845	9008	2	0	\N
138419	1397	1335919726000	17846	9007	0	0	\N
138420	1397	1335909725000	17846	9007	1	0	\N
138421	1397	1335899724000	17846	9007	2	0	\N
138422	2134	97627896000	17846	9007	3	0	\N
138423	2134	97626893000	17846	9007	4	0	\N
138424	2134	97625890000	17846	9007	5	0	\N
138425	2133	97646298000	17846	9007	6	0	\N
138426	2133	97645296000	17846	9007	7	0	\N
138427	2133	97644294000	17846	9007	8	0	\N
138428	1397	1335899724000	17847	9008	0	0	\N
138429	2133	97644294000	17847	9008	1	0	\N
138430	2132	148669670000	17847	9008	2	0	\N
138431	2134	97625890000	17847	9008	3	0	\N
138432	1397	1335889723000	17848	9009	0	0	\N
138433	2133	97643292000	17848	9009	1	0	\N
138434	2134	97624887000	17848	9009	2	0	\N
138438	1397	1335889723000	17850	9009	0	0	\N
138439	2133	97643292000	17850	9009	1	0	\N
138443	1397	1335869721000	17852	9011	0	0	\N
138444	2118	1398000000	17852	9011	1	0	\N
138445	2133	97641288000	17852	9011	2	0	\N
138446	2134	97622881000	17852	9011	3	0	\N
138319	2134	97634917000	17823	9001	2	0	1361
138320	1397	1335979732000	17824	9002	0	0	10285
138321	1397	1335969731000	17824	9002	1	0	10286
138322	2133	97652310000	17824	9002	2	0	1345
138323	2133	97651308000	17824	9002	3	0	1346
138325	2134	97632911000	17824	9002	5	0	1363
138332	1397	1335959730000	17826	9003	0	0	10287
138333	2133	97650306000	17826	9003	1	0	1347
138334	2134	97631908000	17826	9003	2	0	1364
138335	2132	148671672000	17826	9003	3	0	328
138350	2133	97649304000	17831	9004	1	0	1348
138351	2134	97630905000	17831	9004	2	0	1365
138366	1397	1335939728000	17835	9006	0	0	10289
138367	1397	1335929727000	17835	9006	1	0	10290
138369	2133	97648302000	17835	9006	3	0	1349
138370	2133	97647300000	17835	9006	4	0	1350
138371	2134	97629902000	17835	9006	5	0	1366
138372	2134	97628899000	17835	9006	6	0	1367
138402	1397	1335919726000	17842	9007	0	0	10291
138404	2134	97627896000	17842	9007	2	0	1368
138405	2134	97626893000	17842	9007	3	0	1369
138406	2133	97646298000	17842	9007	4	0	1351
138407	2133	97645296000	17842	9007	5	0	1352
138408	1397	1335899724000	17843	9008	0	0	10293
138410	2132	148669670000	17843	9008	2	0	330
138411	2134	97625890000	17843	9008	3	0	1370
138435	1397	1335889723000	17849	9009	0	0	10294
138436	2133	97643292000	17849	9009	1	0	1354
138440	1397	1335879722000	17851	9010	0	0	10295
138441	2134	97623884000	17851	9010	1	0	1372
138442	2133	97642290000	17851	9010	2	0	1355
138447	1397	1335869721000	17853	9011	0	0	10296
138448	2118	1398000000	17853	9011	1	0	2
138451	1397	1335859720000	17854	9012	0	0	\N
138452	2133	97640286000	17854	9012	1	0	\N
138453	2132	148668669000	17854	9012	2	0	\N
138454	1789	712990000000	17855	8921	0	0	\N
138455	1726	119265109000	17855	8921	1	0	\N
138456	1397	1337179852000	17855	8921	2	0	\N
138457	329	67444612000000	17855	8921	3	0	\N
138458	1397	1337169851000	17855	8921	4	0	\N
138459	1397	1337159850000	17855	8921	5	0	\N
138460	1397	1337149849000	17855	8921	6	0	\N
138461	1397	1337139848000	17855	8921	7	0	\N
138462	338	66720014000000	17855	8921	8	0	\N
138463	1397	1337129847000	17855	8921	9	0	\N
138464	1397	1337119846000	17855	8921	10	0	\N
138465	1397	1337109845000	17855	8921	11	0	\N
138466	1397	1337099844000	17855	8921	12	0	\N
138467	1397	1337089843000	17855	8921	13	0	\N
138468	1397	1337079842000	17855	8921	14	0	\N
138469	1397	1337069841000	17855	8921	15	0	\N
138470	1397	1337059840000	17855	8921	16	0	\N
138471	1397	1337049839000	17855	8921	17	0	\N
138472	1397	1337039838000	17855	8921	18	0	\N
138473	1397	1337029837000	17855	8921	20	0	\N
138474	1726	118055109000	17855	8921	21	0	\N
138475	1726	116845109000	17855	8921	22	0	\N
138476	1726	115635109000	17855	8921	23	0	\N
138477	1726	114425109000	17855	8921	24	0	\N
138478	1726	113215109000	17855	8921	25	0	\N
138479	1726	112005109000	17855	8921	26	0	\N
138480	1397	1337019836000	17855	8921	27	0	\N
138481	1397	1337009835000	17855	8921	28	0	\N
138482	1397	1336999834000	17855	8921	29	0	\N
138483	1397	1336989833000	17855	8921	30	0	\N
138484	1397	1336979832000	17855	8921	31	0	\N
138485	1397	1336969831000	17855	8921	32	0	\N
138486	1397	1336959830000	17855	8921	33	0	\N
138487	1397	1336949829000	17855	8921	34	0	\N
138488	1397	1336939828000	17855	8921	35	0	\N
138489	1397	1336929827000	17855	8921	36	0	\N
138490	1397	1336919826000	17855	8921	37	0	\N
138491	1397	1336909825000	17855	8921	38	0	\N
138492	1397	1336899824000	17855	8921	39	0	\N
138493	1397	1336889823000	17855	8921	40	0	\N
138494	1397	1336879822000	17855	8921	41	0	\N
138495	1397	1336869821000	17855	8921	42	0	\N
138496	1397	1336859820000	17855	8921	43	0	\N
138497	1397	1336849819000	17855	8921	44	0	\N
138498	1397	1336839818000	17855	8921	45	0	\N
138499	1397	1336829817000	17855	8921	46	0	\N
138500	1397	1336819816000	17855	8921	47	0	\N
138501	1397	1336809815000	17855	8921	48	0	\N
138502	1397	1336799814000	17855	8921	49	0	\N
138503	1397	1336789813000	17855	8921	50	0	\N
138504	1397	1336779812000	17855	8921	51	0	\N
138505	1397	1336769811000	17855	8921	52	0	\N
138506	1397	1336759810000	17855	8921	53	0	\N
138507	1397	1336749809000	17855	8921	54	0	\N
138508	1397	1336739808000	17855	8921	55	0	\N
138509	1397	1336729807000	17855	8921	56	0	\N
138510	1397	1336719806000	17855	8921	57	0	\N
138511	1397	1336709805000	17855	8921	58	0	\N
138512	1397	1336699804000	17855	8921	59	0	\N
138513	1397	1336689803000	17855	8921	60	0	\N
138514	1397	1336679802000	17855	8921	61	0	\N
138515	1397	1336669801000	17855	8921	62	0	\N
138516	1397	1336659800000	17855	8921	63	0	\N
138517	1397	1336649799000	17855	8921	64	0	\N
138518	1397	1336639798000	17855	8921	65	0	\N
138519	1397	1336629797000	17855	8921	66	0	\N
138520	1397	1336619796000	17855	8921	67	0	\N
138521	1397	1336609795000	17855	8921	68	0	\N
138522	1397	1336599794000	17855	8921	69	0	\N
138523	1397	1336589793000	17855	8921	70	0	\N
138524	1397	1336579792000	17855	8921	71	0	\N
138525	1397	1336569791000	17855	8921	72	0	\N
138526	1397	1336559790000	17855	8921	73	0	\N
138527	1397	1336549789000	17855	8921	74	0	\N
138528	1397	1336539788000	17855	8921	75	0	\N
138529	1397	1336529787000	17855	8921	76	0	\N
138530	1397	1336519786000	17855	8921	77	0	\N
138531	1397	1336509785000	17855	8921	78	0	\N
138532	1397	1336499784000	17855	8921	79	0	\N
138533	1397	1336489783000	17855	8921	80	0	\N
138534	1397	1336479782000	17855	8921	81	0	\N
138535	1397	1336469781000	17855	8921	82	0	\N
138536	1397	1336459780000	17855	8921	83	0	\N
138537	1397	1336449779000	17855	8921	84	0	\N
138538	1397	1336439778000	17855	8921	85	0	\N
138539	1397	1336429777000	17855	8921	86	0	\N
138540	1397	1336419776000	17855	8921	87	0	\N
138541	1397	1336409775000	17855	8921	88	0	\N
138542	1397	1336399774000	17855	8921	89	0	\N
138543	1397	1336389773000	17855	8921	90	0	\N
138544	1397	1336379772000	17855	8921	91	0	\N
138545	1397	1336369771000	17855	8921	92	0	\N
138546	1397	1336359770000	17855	8921	93	0	\N
138547	1397	1336349769000	17855	8921	94	0	\N
138548	1397	1336339768000	17855	8921	95	0	\N
138549	1397	1336329767000	17855	8921	96	0	\N
138550	1397	1336319766000	17855	8921	97	0	\N
138551	1397	1336309765000	17855	8921	98	0	\N
138552	1397	1336299764000	17855	8921	99	0	\N
138553	1397	1336289763000	17855	8921	100	0	\N
138554	1397	1336279762000	17855	8921	101	0	\N
138555	1397	1336269761000	17855	8921	102	0	\N
138556	1397	1336259760000	17855	8921	103	0	\N
138557	1397	1336249759000	17855	8921	104	0	\N
138558	1397	1336239758000	17855	8921	105	0	\N
138559	1397	1336229757000	17855	8921	106	0	\N
138560	1397	1336219756000	17855	8921	107	0	\N
138561	1397	1336209755000	17855	8921	108	0	\N
138562	1397	1336199754000	17855	8921	109	0	\N
138563	1397	1336189753000	17855	8921	110	0	\N
138564	1397	1336179752000	17855	8921	111	0	\N
138565	1397	1336169751000	17855	8921	112	0	\N
138566	1397	1336159750000	17855	8921	113	0	\N
138567	1397	1336149749000	17855	8921	114	0	\N
138568	1397	1336139748000	17855	8921	115	0	\N
138569	1397	1336129747000	17855	8921	116	0	\N
138570	1397	1336119746000	17855	8921	117	0	\N
138571	1397	1336109745000	17855	8921	118	0	\N
138572	1397	1336099744000	17855	8921	119	0	\N
138573	1397	1336089743000	17855	8921	120	0	\N
138574	1397	1336079742000	17855	8921	121	0	\N
138575	1397	1336069741000	17855	8921	122	0	\N
138576	1397	1336059740000	17855	8921	123	0	\N
138577	1397	1336049739000	17855	8921	124	0	\N
138578	1397	1336039738000	17855	8921	125	0	\N
138582	1397	1335859720000	17857	9012	0	0	\N
138583	2133	97640286000	17857	9012	1	0	\N
138584	2132	148668669000	17857	9012	2	0	\N
138579	1397	1335859720000	17856	9012	0	0	10297
138580	2133	97640286000	17856	9012	1	0	1357
138581	2132	148668669000	17856	9012	2	0	331
138588	1397	1335839718000	17859	9014	0	0	\N
138589	2134	97620875000	17859	9014	1	0	\N
138590	2133	97638282000	17859	9014	2	0	\N
138591	1397	1335839718000	17860	9014	0	0	\N
138592	2134	97620875000	17860	9014	1	0	\N
138593	2133	97638282000	17860	9014	2	0	\N
138597	1397	1335829717000	17862	9015	0	0	\N
138598	2132	148667668000	17862	9015	1	0	\N
138599	2133	97637280000	17862	9015	2	0	\N
138600	2134	97619872000	17862	9015	3	0	\N
138605	1397	1335829717000	17864	9015	0	0	\N
138606	2132	148667668000	17864	9015	1	0	\N
138607	2133	97637280000	17864	9015	2	0	\N
138608	2134	97619872000	17864	9015	3	0	\N
138612	1789	712990000000	17866	8855	0	0	\N
138613	329	67444612000000	17866	8855	1	0	\N
138614	1726	113215109000	17866	8855	2	0	\N
138615	1726	112005109000	17866	8855	3	0	\N
138616	2131	199000000	17866	8855	4	0	\N
138617	2118	1399000000	17866	8855	5	0	\N
138618	2118	1398000000	17866	8855	6	0	\N
138619	2131	198000000	17866	8855	7	0	\N
138620	2131	196999000	17866	8855	8	0	\N
138621	2132	148692693000	17866	8855	9	0	\N
138622	2141	719012000000	17866	8855	10	0	\N
138623	2132	148691692000	17866	8855	11	0	\N
138624	2132	148690691000	17866	8855	12	0	\N
138625	2132	148689690000	17866	8855	13	0	\N
138626	2132	148688689000	17866	8855	14	0	\N
138627	2132	148687688000	17866	8855	15	0	\N
138628	2132	148686687000	17866	8855	16	0	\N
138629	2132	148685686000	17866	8855	17	0	\N
138630	2132	148684685000	17866	8855	18	0	\N
138631	2132	148683684000	17866	8855	19	0	\N
138632	2132	148682683000	17866	8855	20	0	\N
138633	2132	148681682000	17866	8855	21	0	\N
138634	2132	148680681000	17866	8855	22	0	\N
138635	2132	148679680000	17866	8855	23	0	\N
138636	2132	148678679000	17866	8855	24	0	\N
138637	2132	148677678000	17866	8855	25	0	\N
138638	2132	148676677000	17866	8855	26	0	\N
138639	2132	148675676000	17866	8855	27	0	\N
138640	2132	148674675000	17866	8855	28	0	\N
138641	2132	148673674000	17866	8855	29	0	\N
138642	2132	148672673000	17866	8855	30	0	\N
138643	2132	148671672000	17866	8855	31	0	\N
138644	2132	148670671000	17866	8855	32	0	\N
138645	2132	148669670000	17866	8855	33	0	\N
138646	2132	148668669000	17866	8855	34	0	\N
138647	2132	148667668000	17866	8855	35	0	\N
138665	2141	719012000000	17869	9010	0	0	\N
138666	1397	1335759710000	17870	9019	0	0	\N
138667	2132	148665666000	17870	9019	1	0	\N
138668	2134	97612851000	17870	9019	2	0	\N
138669	2133	97630266000	17870	9019	3	0	\N
138680	1397	1335729707000	17874	9022	0	0	\N
138681	2134	97609842000	17874	9022	1	0	\N
138682	2132	148664665000	17874	9022	2	0	\N
138683	2133	97627260000	17874	9022	3	0	\N
138688	1397	1335729707000	17876	9022	0	0	\N
138689	2134	97609842000	17876	9022	1	0	\N
138690	2132	148664665000	17876	9022	2	0	\N
138691	2133	97627260000	17876	9022	3	0	\N
138695	1397	1335719706000	17878	9023	0	0	\N
138696	2133	97626258000	17878	9023	1	0	\N
138697	2134	97608839000	17878	9023	2	0	\N
138708	1397	1335679702000	17880	9025	0	0	\N
138709	2133	97622250000	17880	9025	1	0	\N
138710	2134	97604827000	17880	9025	3	0	\N
138711	1397	1335679702000	17881	9025	0	0	\N
138712	2133	97622250000	17881	9025	1	0	\N
138713	2134	97604827000	17881	9025	3	0	\N
138717	1397	1335679702000	17883	9025	0	0	\N
138718	2133	97622250000	17883	9025	1	0	\N
138719	2134	97604827000	17883	9025	3	0	\N
138587	2133	97639284000	17858	9013	2	0	1358
138594	1397	1335839718000	17861	9014	0	0	10299
138595	2134	97620875000	17861	9014	1	0	1375
138596	2133	97638282000	17861	9014	2	0	1359
138601	1397	1335829717000	17863	9015	0	0	10300
138603	2133	97637280000	17863	9015	2	0	1360
138604	2134	97619872000	17863	9015	3	0	1376
138609	1397	1335819716000	17865	9016	0	0	10301
138610	2133	97636278000	17865	9016	1	0	1361
138611	2134	97618869000	17865	9016	2	0	1377
138649	1397	1335799714000	17867	9017	1	0	10303
138650	2133	97635276000	17867	9017	2	0	1362
138651	2132	148666667000	17867	9017	3	0	333
138652	2141	719012000000	17867	9017	4	0	1
138654	2134	97617866000	17867	9017	6	0	1378
138655	2134	97616863000	17867	9017	7	0	1379
138656	1397	1335789713000	17868	9018	0	0	10304
138657	1397	1335779712000	17868	9018	1	0	10305
138658	1397	1335769711000	17868	9018	2	0	10306
138660	2133	97633272000	17868	9018	4	0	1364
138661	2133	97632270000	17868	9018	5	0	1365
138662	2133	97631268000	17868	9018	6	0	1366
138663	2134	97614857000	17868	9018	7	0	1381
138664	2134	97613854000	17868	9018	8	0	1382
138671	2132	148665666000	17871	9019	1	0	334
138672	2134	97612851000	17871	9019	2	0	1383
138673	2133	97630266000	17871	9019	3	0	1367
138674	1397	1335749709000	17872	9020	0	0	10308
138676	2133	97629264000	17872	9020	2	0	1368
138677	1397	1335739708000	17873	9021	0	0	10309
138678	2133	97628262000	17873	9021	1	0	1369
138679	2134	97610845000	17873	9021	2	0	1385
138684	1397	1335729707000	17875	9022	0	0	10310
138686	2132	148664665000	17875	9022	2	0	335
138687	2133	97627260000	17875	9022	3	0	1370
138692	1397	1335719706000	17877	9023	0	0	10311
138693	2133	97626258000	17877	9023	1	0	1371
138694	2134	97608839000	17877	9023	2	0	1387
138699	1397	1335699704000	17879	9024	1	0	10313
138700	1397	1335689703000	17879	9024	2	0	10314
138701	2133	97625256000	17879	9024	3	0	1372
138702	2132	148663664000	17879	9024	4	0	336
138704	2134	97606833000	17879	9024	6	0	1389
138705	2134	97605830000	17879	9024	7	0	1390
138706	2133	97624254000	17879	9024	8	0	1373
138707	2133	97623252000	17879	9024	9	0	1374
138714	1397	1335679702000	17882	9025	0	0	10315
138716	2134	97604827000	17882	9025	3	0	1391
138720	1397	1335669701000	17884	9026	0	0	10316
138727	1397	1335669701000	17885	9026	0	0	\N
138728	1397	1335659700000	17885	9026	1	0	\N
138729	2133	97621248000	17885	9026	2	0	\N
138730	2133	97620246000	17885	9026	3	0	\N
138731	2132	148662663000	17885	9026	4	0	\N
138732	2134	97603824000	17885	9026	5	0	\N
138733	2134	97602821000	17885	9026	6	0	\N
138734	1397	1335649699000	17887	9027	0	0	\N
138735	1397	1335639698000	17887	9027	1	0	\N
138736	2133	97619244000	17887	9027	2	0	\N
138737	2133	97618242000	17887	9027	3	0	\N
138738	2134	97601818000	17887	9027	4	0	\N
138739	2134	97600815000	17887	9027	5	0	\N
138744	1397	1335629697000	17889	9028	0	0	\N
138745	2132	148661662000	17889	9028	1	0	\N
138746	2134	97599812000	17889	9028	2	0	\N
138747	2133	97619244000	17889	9028	3	0	\N
138748	2133	97618242000	17889	9028	4	0	\N
138749	2133	97617240000	17889	9028	5	0	\N
138750	1397	1335629697000	17890	9028	0	0	\N
138751	2132	148661662000	17890	9028	1	0	\N
138752	2134	97599812000	17890	9028	2	0	\N
138753	2133	97619244000	17890	9028	3	0	\N
138754	2133	97618242000	17890	9028	4	0	\N
138755	2133	97617240000	17890	9028	5	0	\N
138762	1397	1335629697000	17892	9028	0	0	\N
138763	2132	148661662000	17892	9028	1	0	\N
138764	2134	97599812000	17892	9028	2	0	\N
138765	2133	97617240000	17892	9028	3	0	\N
138766	1397	1335619696000	17893	9029	0	0	\N
138767	2134	97598809000	17893	9029	1	0	\N
138768	2133	97616238000	17893	9029	2	0	\N
138772	1397	1335619696000	17895	9029	0	0	\N
138773	2134	97598809000	17895	9029	1	0	\N
138774	2133	97616238000	17895	9029	2	0	\N
138775	1726	112005110000	17896	8988	0	0	\N
138776	1397	1336109745000	17896	8988	1	0	\N
138777	1397	1336099744000	17896	8988	2	0	\N
138778	1397	1336089743000	17896	8988	3	0	\N
138779	1397	1336079742000	17896	8988	4	0	\N
138780	1397	1336069741000	17896	8988	5	0	\N
138781	1397	1336059740000	17896	8988	6	0	\N
138782	1397	1336049739000	17896	8988	7	0	\N
138783	1397	1336039738000	17896	8988	8	0	\N
138784	1397	1336029737000	17896	8988	9	0	\N
138785	1397	1336019736000	17896	8988	10	0	\N
138786	1397	1336009735000	17896	8988	11	0	\N
138787	1397	1335999734000	17896	8988	12	0	\N
138788	1397	1335989733000	17896	8988	13	0	\N
138789	1397	1335979732000	17896	8988	14	0	\N
138790	1397	1335969731000	17896	8988	15	0	\N
138791	1397	1335959730000	17896	8988	16	0	\N
138792	1397	1335949729000	17896	8988	17	0	\N
138793	1397	1335939728000	17896	8988	18	0	\N
138794	1397	1335929727000	17896	8988	19	0	\N
138795	1397	1335919726000	17896	8988	20	0	\N
138796	1397	1335909725000	17896	8988	21	0	\N
138797	1397	1335899724000	17896	8988	22	0	\N
138798	1397	1335889723000	17896	8988	23	0	\N
138799	1397	1335879722000	17896	8988	24	0	\N
138800	1397	1335869721000	17896	8988	25	0	\N
138801	1397	1335859720000	17896	8988	26	0	\N
138802	1397	1335849719000	17896	8988	27	0	\N
138803	1397	1335839718000	17896	8988	28	0	\N
138804	1397	1335829717000	17896	8988	29	0	\N
138805	1397	1335819716000	17896	8988	30	0	\N
138806	1397	1335809715000	17896	8988	31	0	\N
138807	1397	1335799714000	17896	8988	32	0	\N
138808	1397	1335789713000	17896	8988	33	0	\N
138809	1397	1335779712000	17896	8988	34	0	\N
138810	1397	1335769711000	17896	8988	35	0	\N
138811	1397	1335759710000	17896	8988	36	0	\N
138812	1397	1335749709000	17896	8988	37	0	\N
138813	1397	1335739708000	17896	8988	38	0	\N
138814	1397	1335729707000	17896	8988	39	0	\N
138815	1397	1335719706000	17896	8988	40	0	\N
138816	1397	1335709705000	17896	8988	41	0	\N
138817	1397	1335699704000	17896	8988	42	0	\N
138818	1397	1335689703000	17896	8988	43	0	\N
138819	1397	1335679702000	17896	8988	44	0	\N
138820	1397	1335669701000	17896	8988	45	0	\N
138821	1397	1335659700000	17896	8988	46	0	\N
138822	1397	1335649699000	17896	8988	47	0	\N
138823	1397	1335639698000	17896	8988	48	0	\N
138824	1397	1335629697000	17896	8988	49	0	\N
138825	1397	1335619696000	17896	8988	50	0	\N
138826	2118	1399000000	17896	8988	51	0	\N
138827	2118	1398000000	17896	8988	52	0	\N
138828	2141	719012000000	17896	8988	53	0	\N
138829	2133	97670346000	17896	8988	54	0	\N
138830	2133	97669344000	17896	8988	55	0	\N
138831	2133	97668342000	17896	8988	56	0	\N
138832	2133	97667340000	17896	8988	57	0	\N
138833	2133	97666338000	17896	8988	58	0	\N
138834	2132	148677678000	17896	8988	59	0	\N
138835	2132	148676677000	17896	8988	60	0	\N
138836	2132	148675676000	17896	8988	61	0	\N
138837	2132	148674675000	17896	8988	62	0	\N
138838	2132	148673674000	17896	8988	63	0	\N
138839	2132	148672673000	17896	8988	64	0	\N
138840	2134	97651968000	17896	8988	65	0	\N
138841	2134	97650965000	17896	8988	66	0	\N
138842	2134	97649962000	17896	8988	67	0	\N
138843	2134	97648959000	17896	8988	68	0	\N
138844	2134	97647956000	17896	8988	69	0	\N
138845	2134	97646953000	17896	8988	70	0	\N
138846	2133	97665336000	17896	8988	71	0	\N
138847	2133	97664334000	17896	8988	72	0	\N
138848	2133	97663332000	17896	8988	73	0	\N
138849	2133	97662330000	17896	8988	74	0	\N
138850	2133	97661328000	17896	8988	75	0	\N
138851	2134	97645950000	17896	8988	76	0	\N
138852	2134	97644947000	17896	8988	77	0	\N
138853	2134	97643944000	17896	8988	78	0	\N
138854	2134	97642941000	17896	8988	79	0	\N
138855	2134	97641938000	17896	8988	80	0	\N
138856	2134	97640935000	17896	8988	81	0	\N
138723	2133	97620246000	17884	9026	3	0	1377
138724	2132	148662663000	17884	9026	4	0	337
138725	2134	97603824000	17884	9026	5	0	1392
138726	2134	97602821000	17884	9026	6	0	1393
138740	1397	1335649699000	17888	9027	0	0	10318
138742	2134	97601818000	17888	9027	2	0	1394
138743	2134	97600815000	17888	9027	3	0	1395
138756	1397	1335629697000	17891	9028	0	0	10320
138757	2132	148661662000	17891	9028	1	0	338
138758	2134	97599812000	17891	9028	2	0	1396
138760	2133	97618242000	17891	9028	4	0	1379
138761	2133	97617240000	17891	9028	5	0	1380
138769	1397	1335619696000	17894	9029	0	0	10321
138770	2134	97598809000	17894	9029	1	0	1397
138857	2134	97639932000	17896	8988	82	0	\N
138858	2134	97638929000	17896	8988	83	0	\N
138859	2134	97637926000	17896	8988	84	0	\N
138860	2134	97636923000	17896	8988	85	0	\N
138861	2134	97635920000	17896	8988	86	0	\N
138862	2133	97660326000	17896	8988	87	0	\N
138863	2133	97659324000	17896	8988	88	0	\N
138864	2133	97658322000	17896	8988	89	0	\N
138865	2133	97657320000	17896	8988	90	0	\N
138866	2133	97656318000	17896	8988	91	0	\N
138867	2133	97655316000	17896	8988	92	0	\N
138868	2133	97654314000	17896	8988	93	0	\N
138869	2133	97653312000	17896	8988	94	0	\N
138870	2133	97652310000	17896	8988	95	0	\N
138871	2133	97651308000	17896	8988	96	0	\N
138872	2133	97650306000	17896	8988	97	0	\N
138873	2133	97649304000	17896	8988	98	0	\N
138874	2134	97634917000	17896	8988	99	0	\N
138875	2132	148671672000	17896	8988	100	0	\N
138876	2132	148670671000	17896	8988	101	0	\N
138877	2132	148669670000	17896	8988	102	0	\N
138878	2132	148668669000	17896	8988	103	0	\N
138879	2132	148667668000	17896	8988	105	0	\N
138880	2132	148666667000	17896	8988	106	0	\N
138881	2132	148665666000	17896	8988	107	0	\N
138882	2132	148664665000	17896	8988	108	0	\N
138883	2132	148663664000	17896	8988	109	0	\N
138884	2132	148662663000	17896	8988	110	0	\N
138885	2132	148661662000	17896	8988	111	0	\N
138886	2134	97633914000	17896	8988	112	0	\N
138887	2134	97632911000	17896	8988	113	0	\N
138888	2134	97631908000	17896	8988	114	0	\N
138889	2134	97630905000	17896	8988	115	0	\N
138890	2133	97648302000	17896	8988	116	0	\N
138891	2133	97647300000	17896	8988	117	0	\N
138892	2133	97646298000	17896	8988	118	0	\N
138893	2133	97645296000	17896	8988	119	0	\N
138894	2133	97644294000	17896	8988	120	0	\N
138895	2133	97643292000	17896	8988	121	0	\N
138896	2133	97642290000	17896	8988	122	0	\N
138897	2133	97641288000	17896	8988	123	0	\N
138898	2133	97640286000	17896	8988	124	0	\N
138899	2133	97639284000	17896	8988	125	0	\N
138917	1726	110795110000	17898	9030	0	0	\N
138918	1397	1335609695000	17898	9030	1	0	\N
138919	1397	1335599694000	17898	9030	2	0	\N
138920	1397	1335589693000	17898	9030	3	0	\N
138921	1397	1335579692000	17898	9030	4	0	\N
138922	1397	1335569691000	17898	9030	5	0	\N
138923	2132	148660661000	17898	9030	6	0	\N
138924	2134	97597806000	17898	9030	7	0	\N
138925	2134	97596803000	17898	9030	8	0	\N
138926	2133	97615236000	17898	9030	9	0	\N
138927	2133	97614234000	17898	9030	10	0	\N
138928	2133	97613232000	17898	9030	11	0	\N
138929	2133	97612230000	17898	9030	12	0	\N
138930	2133	97611228000	17898	9030	13	0	\N
138931	2134	97595800000	17898	9030	14	0	\N
138932	2134	97594797000	17898	9030	15	0	\N
138933	2134	97593794000	17898	9030	16	0	\N
138941	1397	1335559690000	17900	9031	0	0	\N
138942	1397	1335549689000	17900	9031	1	0	\N
138943	2134	97592791000	17900	9031	2	0	\N
138944	2132	148659660000	17900	9031	3	0	\N
138945	2134	97591788000	17900	9031	4	0	\N
138946	2133	97610226000	17900	9031	5	0	\N
138947	2133	97609224000	17900	9031	6	0	\N
138955	1397	1335539688000	17902	9032	0	0	\N
138956	1397	1335529687000	17902	9032	1	0	\N
138957	2133	97608222000	17902	9032	2	0	\N
138958	2133	97607220000	17902	9032	3	0	\N
138959	2132	148658659000	17902	9032	4	0	\N
138960	2134	97590785000	17902	9032	5	0	\N
138961	2134	97589782000	17902	9032	6	0	\N
138962	1397	1335539688000	17903	9032	0	0	\N
138963	1397	1335529687000	17903	9032	1	0	\N
138964	2133	97608222000	17903	9032	2	0	\N
138965	2133	97607220000	17903	9032	3	0	\N
138966	2132	148658659000	17903	9032	4	0	\N
138967	2134	97590785000	17903	9032	5	0	\N
138968	2134	97589782000	17903	9032	6	0	\N
138969	1397	1335539688000	17904	9032	0	0	\N
138970	1397	1335529687000	17904	9032	1	0	\N
138971	2133	97608222000	17904	9032	2	0	\N
138972	2133	97607220000	17904	9032	3	0	\N
138973	2132	148658659000	17904	9032	4	0	\N
138974	2134	97590785000	17904	9032	5	0	\N
138975	2134	97589782000	17904	9032	6	0	\N
138976	1397	1335559690000	17905	9031	0	0	\N
138977	1397	1335549689000	17905	9031	1	0	\N
138978	1397	1335539688000	17905	9031	2	0	\N
138979	1397	1335529687000	17905	9031	3	0	\N
138980	2134	97592791000	17905	9031	4	0	\N
138981	2132	148659660000	17905	9031	5	0	\N
138982	2132	148658659000	17905	9031	6	0	\N
138983	2134	97591788000	17905	9031	7	0	\N
138984	2134	97590785000	17905	9031	8	0	\N
138985	2134	97589782000	17905	9031	9	0	\N
138988	2133	97606218000	17907	9033	0	0	\N
138989	2134	97588779000	17907	9033	1	0	\N
138990	2133	97606218000	17908	9033	0	0	\N
138991	2134	97588779000	17908	9033	1	0	\N
138992	2134	97587776000	17909	9034	0	0	\N
138902	1397	1335599694000	17897	9030	2	0	10323
138903	1397	1335589693000	17897	9030	3	0	10324
138904	1397	1335579692000	17897	9030	4	0	10325
138905	1397	1335569691000	17897	9030	5	0	10326
138906	2132	148660661000	17897	9030	6	0	339
138908	2134	97596803000	17897	9030	8	0	1399
138909	2133	97615236000	17897	9030	9	0	1382
138910	2133	97614234000	17897	9030	10	0	1383
138911	2133	97613232000	17897	9030	11	0	1384
138912	2133	97612230000	17897	9030	12	0	1385
138914	2134	97595800000	17897	9030	14	0	1400
138915	2134	97594797000	17897	9030	15	0	1401
138916	2134	97593794000	17897	9030	16	0	1402
138934	1397	1335559690000	17899	9031	0	0	10327
138936	2134	97592791000	17899	9031	2	0	1403
138937	2132	148659660000	17899	9031	3	0	340
138938	2134	97591788000	17899	9031	4	0	1404
138939	2133	97610226000	17899	9031	5	0	1387
138940	2133	97609224000	17899	9031	6	0	1388
138949	1397	1335529687000	17901	9032	1	0	10330
138950	2133	97608222000	17901	9032	2	0	1389
138951	2133	97607220000	17901	9032	3	0	1390
138952	2132	148658659000	17901	9032	4	0	341
138953	2134	97590785000	17901	9032	5	0	1405
138986	2133	97606218000	17906	9033	0	0	1391
138987	2134	97588779000	17906	9033	1	0	1407
138993	2133	97605216000	17909	9034	1	0	\N
138996	1397	1335519686000	17911	9035	0	0	\N
138997	2133	97604214000	17911	9035	1	0	\N
138998	2132	148657658000	17911	9035	2	0	\N
138999	2133	97603212000	17911	9035	3	0	\N
139000	2134	97586773000	17911	9035	4	0	\N
139001	2134	97585770000	17911	9035	5	0	\N
139002	1397	1335519686000	17912	9035	0	0	\N
139003	2133	97604214000	17912	9035	1	0	\N
139004	2132	148657658000	17912	9035	2	0	\N
139005	2133	97603212000	17912	9035	3	0	\N
139006	2134	97586773000	17912	9035	4	0	\N
139007	2134	97585770000	17912	9035	5	0	\N
139014	1397	1335519686000	17914	9035	0	0	\N
139015	2133	97604214000	17914	9035	1	0	\N
139016	2132	148657658000	17914	9035	2	0	\N
139017	2133	97603212000	17914	9035	3	0	\N
139018	2134	97586773000	17914	9035	4	0	\N
139019	2134	97585770000	17914	9035	5	0	\N
139030	1397	1335479682000	17917	9038	0	0	\N
139031	2133	97599204000	17917	9038	1	0	\N
139032	2134	97581758000	17917	9038	2	0	\N
139048	1397	1335439678000	17924	9042	0	0	\N
139049	2133	97595196000	17924	9042	1	0	\N
139050	2134	97578749000	17924	9042	2	0	\N
139051	1397	1335439678000	17925	9042	0	0	\N
139052	2133	97595196000	17925	9042	1	0	\N
139053	2134	97578749000	17925	9042	2	0	\N
139058	1397	1335429677000	17927	9043	0	0	\N
139059	1769	1689900000	17927	9043	1	0	\N
139060	2133	97594194000	17927	9043	2	0	\N
139061	2134	97577746000	17927	9043	3	0	\N
139066	1397	1335419676000	17929	9044	0	0	\N
139067	2133	97593192000	17929	9044	1	0	\N
139068	2134	97576743000	17929	9044	2	0	\N
139069	2132	148654655000	17929	9044	3	0	\N
139070	1397	1335419676000	17930	9044	0	0	\N
139071	2133	97593192000	17930	9044	1	0	\N
139072	2134	97576743000	17930	9044	2	0	\N
139073	2132	148654655000	17930	9044	3	0	\N
139074	1397	1335419676000	17931	9044	0	0	\N
139075	2133	97593192000	17931	9044	1	0	\N
139076	2134	97576743000	17931	9044	2	0	\N
139077	2132	148654655000	17931	9044	3	0	\N
139089	1397	1335379672000	17934	9047	0	0	\N
139090	2133	97589184000	17934	9047	1	0	\N
139091	1397	1335379672000	17935	9047	0	0	\N
139092	2134	97572731000	17935	9047	1	0	\N
139093	2133	97589184000	17935	9047	2	0	\N
139094	1397	1335379672000	17936	9047	0	0	\N
139095	2134	97572731000	17936	9047	1	0	\N
139096	2133	97589184000	17936	9047	2	0	\N
139100	1397	1335369671000	17938	9048	0	0	\N
139101	2133	97588182000	17938	9048	1	0	\N
139102	2134	97571728000	17938	9048	2	0	\N
139107	1397	1335359670000	17940	9049	0	0	\N
139108	2132	148652653000	17940	9049	1	0	\N
139109	2133	97587180000	17940	9049	2	0	\N
139117	1397	1335349669000	17943	9050	0	0	\N
139118	2133	97586178000	17943	9050	1	0	\N
139119	2134	97569722000	17943	9050	2	0	\N
139123	1397	1335329667000	17945	9052	0	0	\N
139124	1397	1335319666000	17945	9052	1	0	\N
139125	2134	97567716000	17945	9052	2	0	\N
139126	2133	97584174000	17945	9052	3	0	\N
139127	2133	97583172000	17945	9052	4	0	\N
139128	2132	148651652000	17945	9052	5	0	\N
139008	1397	1335519686000	17913	9035	0	0	10331
139009	2133	97604214000	17913	9035	1	0	1393
139010	2132	148657658000	17913	9035	2	0	342
139011	2133	97603212000	17913	9035	3	0	1394
139012	2134	97586773000	17913	9035	4	0	1409
139020	1397	1335509685000	17915	9036	0	0	10332
139021	2134	97584767000	17915	9036	1	0	1411
139022	2133	97602210000	17915	9036	2	0	1395
139023	1397	1335499684000	17916	9037	0	0	10333
139024	1397	1335489683000	17916	9037	1	0	10334
139026	2132	148656657000	17916	9037	3	0	343
139027	2134	97583764000	17916	9037	4	0	1412
139028	2134	97582761000	17916	9037	5	0	1413
139029	2133	97600206000	17916	9037	6	0	1397
139034	2133	97599204000	17918	9038	1	0	1398
139035	2134	97581758000	17918	9038	2	0	1414
139036	1397	1335469681000	17920	9039	0	0	10336
139037	2133	97598202000	17920	9039	1	0	1399
139038	1397	1335459680000	17921	9040	0	0	10337
139040	2134	97580755000	17921	9040	2	0	1415
139041	2133	97597200000	17921	9040	3	0	1400
139042	1397	1335449679000	17922	9041	0	0	10338
139043	2133	97596198000	17922	9041	1	0	1401
139044	2134	97579752000	17922	9041	2	0	1416
139046	2133	97595196000	17923	9042	1	0	1402
139047	2134	97578749000	17923	9042	2	0	1417
139054	1397	1335429677000	17926	9043	0	0	10340
139055	1769	1689900000	17926	9043	1	0	44
139057	2134	97577746000	17926	9043	3	0	1418
139062	1397	1335419676000	17928	9044	0	0	10341
139063	2133	97593192000	17928	9044	1	0	1404
139064	2134	97576743000	17928	9044	2	0	1419
139065	2132	148654655000	17928	9044	3	0	345
139079	1397	1335399674000	17932	9045	1	0	10343
139080	1769	1688900000	17932	9045	2	0	45
139081	2133	97592190000	17932	9045	3	0	1405
139082	2133	97591188000	17932	9045	4	0	1406
139083	2134	97575740000	17932	9045	5	0	1420
139085	1397	1335389673000	17933	9046	0	0	10344
139086	2132	148653654000	17933	9046	1	0	346
139087	2133	97590186000	17933	9046	2	0	1407
139088	2134	97573734000	17933	9046	3	0	1422
139098	2134	97572731000	17937	9047	1	0	1423
139099	2133	97589184000	17937	9047	2	0	1408
139103	1397	1335369671000	17939	9048	0	0	10346
139104	2133	97588182000	17939	9048	1	0	1409
139105	1769	1687900000	17939	9048	2	0	46
139110	1397	1335359670000	17941	9049	0	0	10347
139111	2132	148652653000	17941	9049	1	0	347
139112	2134	97570725000	17941	9049	2	0	1425
139113	2133	97587180000	17941	9049	3	0	1410
139114	1397	1335349669000	17942	9050	0	0	10348
139116	2134	97569722000	17942	9050	2	0	1426
139120	1397	1335339668000	17944	9051	0	0	10349
139121	2134	97568719000	17944	9051	1	0	1427
139122	2133	97585176000	17944	9051	2	0	1412
139129	2134	97566713000	17945	9052	6	0	\N
139130	1397	1335329667000	17946	9052	0	0	\N
139131	1397	1335319666000	17946	9052	1	0	\N
139132	2134	97567716000	17946	9052	2	0	\N
139133	2133	97584174000	17946	9052	3	0	\N
139134	2133	97583172000	17946	9052	4	0	\N
139135	2132	148651652000	17946	9052	5	0	\N
139136	2134	97566713000	17946	9052	6	0	\N
139137	1397	1335329667000	17947	9052	0	0	\N
139138	1397	1335319666000	17947	9052	1	0	\N
139139	2134	97567716000	17947	9052	2	0	\N
139140	2133	97584174000	17947	9052	3	0	\N
139141	2133	97583172000	17947	9052	4	0	\N
139142	2132	148651652000	17947	9052	5	0	\N
139143	2134	97566713000	17947	9052	6	0	\N
139164	1397	1336029737000	17953	8995	0	0	\N
139165	1397	1336019736000	17953	8995	1	0	\N
139166	1397	1336009735000	17953	8995	2	0	\N
139167	1726	112005110000	17953	8995	3	0	\N
139168	1726	110795110000	17953	8995	4	0	\N
139169	1397	1335999734000	17953	8995	5	0	\N
139170	1397	1335989733000	17953	8995	6	0	\N
139171	1397	1335979732000	17953	8995	7	0	\N
139172	1397	1335969731000	17953	8995	8	0	\N
139173	1397	1335959730000	17953	8995	9	0	\N
139174	1397	1335949729000	17953	8995	10	0	\N
139175	1397	1335939728000	17953	8995	11	0	\N
139176	1397	1335929727000	17953	8995	12	0	\N
139177	1397	1335919726000	17953	8995	13	0	\N
139178	1397	1335909725000	17953	8995	14	0	\N
139179	1397	1335899724000	17953	8995	15	0	\N
139180	1397	1335889723000	17953	8995	16	0	\N
139181	1397	1335879722000	17953	8995	17	0	\N
139182	1397	1335869721000	17953	8995	18	0	\N
139183	1397	1335859720000	17953	8995	19	0	\N
139184	1397	1335849719000	17953	8995	20	0	\N
139185	1397	1335839718000	17953	8995	21	0	\N
139186	1397	1335829717000	17953	8995	22	0	\N
139187	1397	1335819716000	17953	8995	23	0	\N
139188	1397	1335809715000	17953	8995	24	0	\N
139189	1397	1335799714000	17953	8995	25	0	\N
139190	1397	1335789713000	17953	8995	26	0	\N
139191	1397	1335779712000	17953	8995	27	0	\N
139192	1397	1335769711000	17953	8995	28	0	\N
139193	1397	1335759710000	17953	8995	29	0	\N
139194	1397	1335749709000	17953	8995	30	0	\N
139195	1397	1335739708000	17953	8995	31	0	\N
139196	1397	1335729707000	17953	8995	32	0	\N
139197	1397	1335719706000	17953	8995	33	0	\N
139198	1397	1335709705000	17953	8995	34	0	\N
139199	1397	1335699704000	17953	8995	35	0	\N
139200	1397	1335689703000	17953	8995	36	0	\N
139201	1397	1335679702000	17953	8995	37	0	\N
139202	1397	1335669701000	17953	8995	38	0	\N
139203	1397	1335659700000	17953	8995	39	0	\N
139204	1397	1335649699000	17953	8995	40	0	\N
139205	1397	1335639698000	17953	8995	41	0	\N
139206	1397	1335629697000	17953	8995	42	0	\N
139207	1397	1335619696000	17953	8995	43	0	\N
139208	1397	1335609695000	17953	8995	44	0	\N
139209	1397	1335599694000	17953	8995	45	0	\N
139210	1397	1335589693000	17953	8995	46	0	\N
139211	1397	1335579692000	17953	8995	47	0	\N
139212	1397	1335569691000	17953	8995	48	0	\N
139213	1397	1335559690000	17953	8995	49	0	\N
139214	1397	1335549689000	17953	8995	50	0	\N
139215	1397	1335539688000	17953	8995	51	0	\N
139216	1397	1335529687000	17953	8995	52	0	\N
139217	1397	1335519686000	17953	8995	53	0	\N
139218	1397	1335509685000	17953	8995	54	0	\N
139219	1397	1335499684000	17953	8995	55	0	\N
139220	1397	1335489683000	17953	8995	56	0	\N
139221	1397	1335479682000	17953	8995	57	0	\N
139222	1397	1335469681000	17953	8995	58	0	\N
139223	1397	1335459680000	17953	8995	59	0	\N
139224	1397	1335449679000	17953	8995	60	0	\N
139225	1397	1335439678000	17953	8995	61	0	\N
139226	1397	1335429677000	17953	8995	63	0	\N
139227	1397	1335419676000	17953	8995	64	0	\N
139228	1397	1335409675000	17953	8995	65	0	\N
139229	1397	1335399674000	17953	8995	66	0	\N
139230	1397	1335389673000	17953	8995	67	0	\N
139231	1397	1335379672000	17953	8995	68	0	\N
139232	1397	1335369671000	17953	8995	69	0	\N
139233	1397	1335359670000	17953	8995	70	0	\N
139234	1397	1335349669000	17953	8995	71	0	\N
139235	1397	1335339668000	17953	8995	72	0	\N
139236	1397	1335329667000	17953	8995	73	0	\N
139237	1397	1335319666000	17953	8995	74	0	\N
139238	1397	1335309665000	17953	8995	75	0	\N
139239	1397	1335299664000	17953	8995	76	0	\N
139240	1397	1335289663000	17953	8995	77	0	\N
139241	1397	1335279662000	17953	8995	78	0	\N
139242	2118	1398000000	17953	8995	79	0	\N
139243	2134	97643944000	17953	8995	80	0	\N
139244	1769	1689900000	17953	8995	81	0	\N
139245	1769	1688900000	17953	8995	82	0	\N
139246	1769	1687900000	17953	8995	83	0	\N
139247	2132	148674675000	17953	8995	84	0	\N
139248	2132	148673674000	17953	8995	85	0	\N
139249	2132	148672673000	17953	8995	86	0	\N
139250	2141	719012000000	17953	8995	87	0	\N
139251	2134	97642941000	17953	8995	88	0	\N
139252	2134	97641938000	17953	8995	89	0	\N
139253	2134	97640935000	17953	8995	90	0	\N
139254	2134	97639932000	17953	8995	91	0	\N
139255	2134	97638929000	17953	8995	92	0	\N
139256	2134	97637926000	17953	8995	93	0	\N
139257	2134	97636923000	17953	8995	94	0	\N
139258	2134	97635920000	17953	8995	95	0	\N
139259	2133	97662330000	17953	8995	96	0	\N
139260	2133	97661328000	17953	8995	97	0	\N
139261	2133	97660326000	17953	8995	98	0	\N
139262	2133	97659324000	17953	8995	99	0	\N
139263	2133	97658322000	17953	8995	100	0	\N
139264	2133	97657320000	17953	8995	101	0	\N
139146	2134	97567716000	17948	9052	2	0	1428
139147	2133	97584174000	17948	9052	3	0	1413
139148	2133	97583172000	17948	9052	4	0	1414
139149	2132	148651652000	17948	9052	5	0	348
139150	2134	97566713000	17948	9052	6	0	1429
139152	2133	97582170000	17949	9053	1	0	1415
139153	2134	97565710000	17949	9053	2	0	1430
139154	1397	1335299664000	17950	9054	0	0	10353
139155	2134	97564707000	17950	9054	1	0	1431
139156	2133	97581168000	17950	9054	2	0	1416
139158	2134	97563704000	17951	9055	1	0	1432
139159	2133	97580166000	17951	9055	2	0	1417
139160	2132	148650651000	17951	9055	3	0	349
139161	1397	1335279662000	17952	9056	0	0	10355
139163	2134	97562701000	17952	9056	2	0	1433
139265	2133	97656318000	17953	8995	102	0	\N
139266	2133	97655316000	17953	8995	103	0	\N
139267	2133	97654314000	17953	8995	104	0	\N
139268	2133	97653312000	17953	8995	105	0	\N
139269	2133	97652310000	17953	8995	106	0	\N
139270	2133	97651308000	17953	8995	107	0	\N
139271	2133	97650306000	17953	8995	108	0	\N
139272	2133	97649304000	17953	8995	109	0	\N
139273	2134	97634917000	17953	8995	110	0	\N
139274	2132	148671672000	17953	8995	111	0	\N
139275	2132	148670671000	17953	8995	112	0	\N
139276	2132	148669670000	17953	8995	113	0	\N
139277	2132	148668669000	17953	8995	114	0	\N
139278	2132	148667668000	17953	8995	115	0	\N
139279	2132	148666667000	17953	8995	116	0	\N
139280	2132	148665666000	17953	8995	117	0	\N
139281	2132	148664665000	17953	8995	118	0	\N
139282	2132	148663664000	17953	8995	119	0	\N
139283	2132	148662663000	17953	8995	120	0	\N
139284	2132	148661662000	17953	8995	121	0	\N
139285	2132	148660661000	17953	8995	122	0	\N
139286	2132	148659660000	17953	8995	123	0	\N
139287	2132	148658659000	17953	8995	124	0	\N
139288	2132	148657658000	17953	8995	125	0	\N
139289	1397	1335269661000	17954	9057	0	0	\N
139290	2134	97561698000	17954	9057	1	0	\N
139291	2133	97578162000	17954	9057	2	0	\N
139295	1397	1335269661000	17956	9057	0	0	\N
139296	2134	97561698000	17956	9057	1	0	\N
139297	2133	97578162000	17956	9057	2	0	\N
139302	1397	1335259660000	17958	9058	0	0	\N
139303	2134	97560695000	17958	9058	1	0	\N
139304	2132	148649650000	17958	9058	2	0	\N
139305	2133	97577160000	17958	9058	3	0	\N
139306	1789	712990000000	17959	8913	0	0	\N
139307	329	67444612000000	17959	8913	1	0	\N
139308	338	66720014000000	17959	8913	2	0	\N
139309	1726	113215109000	17959	8913	3	0	\N
139310	1726	112005109000	17959	8913	4	0	\N
139311	1726	110795109000	17959	8913	5	0	\N
139312	2131	199000000	17959	8913	6	0	\N
139313	1769	1689900000	17959	8913	7	0	\N
139314	2118	1399000000	17959	8913	8	0	\N
139315	2118	1398000000	17959	8913	9	0	\N
139316	2131	198000000	17959	8913	10	0	\N
139317	2131	196999000	17959	8913	11	0	\N
139318	2132	148692693000	17959	8913	12	0	\N
139319	1769	1688900000	17959	8913	13	0	\N
139320	1769	1687900000	17959	8913	14	0	\N
139321	2141	719012000000	17959	8913	15	0	\N
139322	2132	148691692000	17959	8913	16	0	\N
139323	2132	148690691000	17959	8913	17	0	\N
139324	2132	148689690000	17959	8913	18	0	\N
139325	2132	148688689000	17959	8913	19	0	\N
139326	2132	148687688000	17959	8913	20	0	\N
139327	2132	148686687000	17959	8913	21	0	\N
139328	2132	148685686000	17959	8913	22	0	\N
139329	2132	148684685000	17959	8913	23	0	\N
139330	2132	148683684000	17959	8913	24	0	\N
139331	2132	148682683000	17959	8913	25	0	\N
139332	2132	148681682000	17959	8913	26	0	\N
139333	2132	148680681000	17959	8913	27	0	\N
139334	2132	148679680000	17959	8913	28	0	\N
139335	2132	148678679000	17959	8913	29	0	\N
139336	2132	148677678000	17959	8913	30	0	\N
139337	2132	148676677000	17959	8913	31	0	\N
139338	2132	148675676000	17959	8913	32	0	\N
139339	2132	148674675000	17959	8913	33	0	\N
139340	2132	148673674000	17959	8913	34	0	\N
139341	2132	148672673000	17959	8913	35	0	\N
139342	2132	148671672000	17959	8913	36	0	\N
139343	2132	148670671000	17959	8913	37	0	\N
139344	2132	148669670000	17959	8913	38	0	\N
139345	2132	148668669000	17959	8913	39	0	\N
139346	2132	148667668000	17959	8913	40	0	\N
139347	2132	148666667000	17959	8913	41	0	\N
139348	2132	148665666000	17959	8913	42	0	\N
139349	2132	148664665000	17959	8913	43	0	\N
139350	2132	148663664000	17959	8913	44	0	\N
139351	2132	148662663000	17959	8913	45	0	\N
139352	2132	148661662000	17959	8913	46	0	\N
139353	2132	148660661000	17959	8913	47	0	\N
139354	2132	148659660000	17959	8913	48	0	\N
139355	2132	148658659000	17959	8913	49	0	\N
139356	2132	148657658000	17959	8913	50	0	\N
139357	2132	148656657000	17959	8913	51	0	\N
139358	2132	148655656000	17959	8913	52	0	\N
139359	2132	148654655000	17959	8913	53	0	\N
139360	2132	148653654000	17959	8913	54	0	\N
139361	2132	148652653000	17959	8913	55	0	\N
139362	2132	148651652000	17959	8913	56	0	\N
139363	2132	148650651000	17959	8913	57	0	\N
139364	2132	148649650000	17959	8913	58	0	\N
139371	1789	712990000000	17961	8954	0	0	\N
139372	329	67444612000000	17961	8954	1	0	\N
139373	338	66720014000000	17961	8954	2	0	\N
139374	1726	113215109000	17961	8954	3	0	\N
139375	1726	112005109000	17961	8954	4	0	\N
139376	1726	110795109000	17961	8954	5	0	\N
139377	2131	199000000	17961	8954	6	0	\N
139378	1769	1689900000	17961	8954	7	0	\N
139379	2118	1399000000	17961	8954	8	0	\N
139380	2118	1398000000	17961	8954	9	0	\N
139381	2131	198000000	17961	8954	10	0	\N
139382	2131	196999000	17961	8954	11	0	\N
139383	2132	148692693000	17961	8954	12	0	\N
139384	1769	1688900000	17961	8954	13	0	\N
139385	1769	1687900000	17961	8954	14	0	\N
139386	2141	719012000000	17961	8954	15	0	\N
139387	2133	97720446000	17961	8954	16	0	\N
139388	2133	97719444000	17961	8954	17	0	\N
139389	2133	97718442000	17961	8954	18	0	\N
139390	2133	97717440000	17961	8954	19	0	\N
139391	2133	97716438000	17961	8954	20	0	\N
139392	2133	97715436000	17961	8954	21	0	\N
139393	2132	148691692000	17961	8954	22	0	\N
139394	2132	148690691000	17961	8954	23	0	\N
139395	2132	148689690000	17961	8954	24	0	\N
139396	2132	148688689000	17961	8954	25	0	\N
139397	2132	148687688000	17961	8954	26	0	\N
139398	2132	148686687000	17961	8954	27	0	\N
139399	2132	148685686000	17961	8954	28	0	\N
139400	2133	97714434000	17961	8954	29	0	\N
139294	2133	97578162000	17955	9057	2	0	1419
139298	1397	1335259660000	17957	9058	0	0	10357
139299	2134	97560695000	17957	9058	1	0	1435
139300	2132	148649650000	17957	9058	2	0	350
139301	2133	97577160000	17957	9058	3	0	1420
139366	1397	1335239658000	17960	9059	1	0	10359
139367	2133	97576158000	17960	9059	2	0	1421
139368	2134	97559692000	17960	9059	3	0	1436
139369	2134	97558689000	17960	9059	4	0	1437
139370	2133	97575156000	17960	9059	5	0	1422
139401	2133	97713432000	17961	8954	30	0	\N
139402	2133	97712430000	17961	8954	31	0	\N
139403	2133	97711428000	17961	8954	32	0	\N
139404	2133	97710426000	17961	8954	33	0	\N
139405	2133	97709424000	17961	8954	34	0	\N
139406	2133	97708422000	17961	8954	35	0	\N
139407	2133	97707420000	17961	8954	36	0	\N
139408	2133	97706418000	17961	8954	37	0	\N
139409	2133	97705416000	17961	8954	38	0	\N
139410	2133	97704414000	17961	8954	39	0	\N
139411	2133	97703412000	17961	8954	40	0	\N
139412	2133	97702410000	17961	8954	41	0	\N
139413	2133	97701408000	17961	8954	42	0	\N
139414	2133	97700406000	17961	8954	43	0	\N
139415	2133	97699404000	17961	8954	44	0	\N
139416	2133	97698402000	17961	8954	45	0	\N
139417	2133	97697400000	17961	8954	46	0	\N
139418	2133	97696398000	17961	8954	47	0	\N
139419	2133	97695396000	17961	8954	48	0	\N
139420	2133	97694394000	17961	8954	49	0	\N
139421	2133	97693392000	17961	8954	50	0	\N
139422	2133	97692390000	17961	8954	51	0	\N
139423	2133	97691388000	17961	8954	52	0	\N
139424	2133	97690386000	17961	8954	53	0	\N
139425	2133	97689384000	17961	8954	54	0	\N
139426	2133	97688382000	17961	8954	55	0	\N
139427	2133	97687380000	17961	8954	56	0	\N
139428	2133	97686378000	17961	8954	57	0	\N
139429	2133	97685376000	17961	8954	58	0	\N
139430	2133	97684374000	17961	8954	59	0	\N
139431	2133	97683372000	17961	8954	60	0	\N
139432	2133	97682370000	17961	8954	61	0	\N
139433	2133	97681368000	17961	8954	62	0	\N
139434	2133	97680366000	17961	8954	63	0	\N
139435	2133	97679364000	17961	8954	64	0	\N
139436	2133	97678362000	17961	8954	65	0	\N
139437	2133	97677360000	17961	8954	66	0	\N
139438	2133	97676358000	17961	8954	67	0	\N
139439	2133	97675356000	17961	8954	68	0	\N
139440	2133	97674354000	17961	8954	69	0	\N
139441	2133	97673352000	17961	8954	70	0	\N
139442	2132	148684685000	17961	8954	71	0	\N
139443	2132	148683684000	17961	8954	72	0	\N
139444	2132	148682683000	17961	8954	73	0	\N
139445	2132	148681682000	17961	8954	74	0	\N
139446	2132	148680681000	17961	8954	75	0	\N
139447	2132	148679680000	17961	8954	76	0	\N
139448	2132	148678679000	17961	8954	77	0	\N
139449	2132	148677678000	17961	8954	78	0	\N
139450	2132	148676677000	17961	8954	79	0	\N
139451	2132	148675676000	17961	8954	80	0	\N
139452	2132	148674675000	17961	8954	81	0	\N
139453	2132	148673674000	17961	8954	82	0	\N
139454	2132	148672673000	17961	8954	83	0	\N
139455	2132	148671672000	17961	8954	84	0	\N
139456	2132	148670671000	17961	8954	85	0	\N
139457	2132	148669670000	17961	8954	86	0	\N
139458	2132	148668669000	17961	8954	87	0	\N
139459	2132	148667668000	17961	8954	88	0	\N
139460	2132	148666667000	17961	8954	89	0	\N
139461	2132	148665666000	17961	8954	90	0	\N
139462	2132	148664665000	17961	8954	91	0	\N
139463	2132	148663664000	17961	8954	92	0	\N
139464	2132	148662663000	17961	8954	93	0	\N
139475	1397	1335199654000	17964	9062	0	0	\N
139476	1397	1335189653000	17964	9062	1	0	\N
139477	1397	1335179652000	17964	9062	2	0	\N
139478	2133	97571148000	17964	9062	3	0	\N
139479	2134	97554677000	17964	9062	4	0	\N
139480	2132	148647648000	17964	9062	5	0	\N
139481	2133	97570146000	17964	9062	6	0	\N
139482	2134	97553674000	17964	9062	7	0	\N
139483	2134	97552671000	17964	9062	8	0	\N
139484	2133	97569144000	17964	9062	9	0	\N
139485	1397	1335199654000	17965	9062	0	0	\N
139486	1397	1335189653000	17965	9062	1	0	\N
139487	1397	1335179652000	17965	9062	2	0	\N
139488	2133	97571148000	17965	9062	3	0	\N
139489	2134	97554677000	17965	9062	4	0	\N
139490	2132	148647648000	17965	9062	5	0	\N
139491	2133	97570146000	17965	9062	6	0	\N
139492	2134	97553674000	17965	9062	7	0	\N
139493	2134	97552671000	17965	9062	8	0	\N
139494	2133	97569144000	17965	9062	9	0	\N
139505	1397	1335169651000	17967	9063	0	0	\N
139506	2133	97568142000	17967	9063	1	0	\N
139509	1397	1335169651000	17969	9063	0	0	\N
139510	2133	97568142000	17969	9063	1	0	\N
139511	1397	1335169651000	17970	9063	0	0	\N
139512	2133	97568142000	17970	9063	1	0	\N
139515	1397	1335159650000	17972	9064	0	0	\N
139516	1397	1335149649000	17972	9064	1	0	\N
139517	2133	97567140000	17972	9064	2	0	\N
139518	2134	97551668000	17972	9064	3	0	\N
139519	2132	148646647000	17972	9064	4	0	\N
139520	2133	97566138000	17972	9064	5	0	\N
139521	2134	97550665000	17972	9064	6	0	\N
139522	1397	1335139648000	17973	9065	0	0	\N
139523	2133	97567140000	17973	9065	1	0	\N
139524	2134	97551668000	17973	9065	2	0	\N
139525	2132	148646647000	17973	9065	3	0	\N
139526	2133	97566138000	17973	9065	4	0	\N
139527	2133	97565136000	17973	9065	5	0	\N
139528	2134	97550665000	17973	9065	6	0	\N
139529	2134	97549662000	17973	9065	7	0	\N
139467	2133	97574154000	17962	9060	2	0	1423
139468	2133	97573152000	17962	9060	3	0	1424
139469	2134	97557686000	17962	9060	4	0	1438
139470	2134	97556683000	17962	9060	5	0	1439
139471	2132	148648649000	17962	9060	6	0	351
139473	2134	97555680000	17963	9061	1	0	1440
139474	2133	97572150000	17963	9061	2	0	1425
139495	1397	1335199654000	17966	9062	0	0	10363
139496	1397	1335189653000	17966	9062	1	0	10364
139497	1397	1335179652000	17966	9062	2	0	10365
139499	2134	97554677000	17966	9062	4	0	1441
139500	2132	148647648000	17966	9062	5	0	352
139501	2133	97570146000	17966	9062	6	0	1427
139502	2134	97553674000	17966	9062	7	0	1442
139504	2133	97569144000	17966	9062	9	0	1428
139507	1397	1335169651000	17968	9063	0	0	10366
139508	2133	97568142000	17968	9063	1	0	1429
139513	1397	1335159650000	17971	9064	0	0	10367
139514	1397	1335149649000	17971	9064	1	0	10368
139531	2133	97567140000	17974	9065	1	0	1430
139532	2134	97551668000	17974	9065	2	0	1444
139533	2132	148646647000	17974	9065	3	0	353
139534	2133	97566138000	17974	9065	4	0	1431
139535	2133	97565136000	17974	9065	5	0	1432
139538	1397	1335139648000	17975	9065	0	0	\N
139539	2133	97567140000	17975	9065	1	0	\N
139540	2134	97551668000	17975	9065	2	0	\N
139541	2132	148646647000	17975	9065	3	0	\N
139542	2133	97566138000	17975	9065	4	0	\N
139543	2133	97565136000	17975	9065	5	0	\N
139544	2134	97550665000	17975	9065	6	0	\N
139545	2134	97549662000	17975	9065	7	0	\N
139546	1688	43559771908000	17976	9066	0	0	\N
139547	1397	1335129647000	17976	9066	1	0	\N
139548	2133	97564134000	17976	9066	2	0	\N
139549	2134	97548659000	17976	9066	3	0	\N
139558	1397	1335119646000	17979	9067	0	0	\N
139559	2134	97547656000	17979	9067	1	0	\N
139560	2132	148645646000	17979	9067	2	0	\N
139561	1397	1335109645000	17980	9068	0	0	\N
139562	1397	1335099644000	17980	9068	1	0	\N
139563	2133	97562130000	17980	9068	2	0	\N
139564	2133	97561128000	17980	9068	3	0	\N
139565	2134	97546653000	17980	9068	4	0	\N
139566	2134	97545650000	17980	9068	5	0	\N
139608	1397	1334999634000	17988	9075	0	0	\N
139609	2134	97535620000	17988	9075	1	0	\N
139610	2133	97552110000	17988	9075	2	0	\N
139614	1397	1334989633000	17990	9076	0	0	\N
139615	1726	109585110000	17990	9076	1	0	\N
139616	2134	97534617000	17990	9076	2	0	\N
139617	2132	148641642000	17990	9076	3	0	\N
139618	2133	97551108000	17990	9076	4	0	\N
139639	1397	1335209655000	17994	9061	0	0	\N
139640	1677	0	17994	9061	1	0	\N
139641	1726	109585110000	17994	9061	2	0	\N
139642	1726	108375110000	17994	9061	3	0	\N
139643	1683	0	17994	9061	4	0	\N
139644	1726	107165110000	17994	9061	5	0	\N
139645	1688	42839751908000	17994	9061	6	0	\N
139646	1688	29519341908000	17994	9061	7	0	\N
139647	1397	1335199654000	17994	9061	8	0	\N
139648	1397	1335189653000	17994	9061	9	0	\N
139649	1397	1335179652000	17994	9061	10	0	\N
139650	1397	1335169651000	17994	9061	11	0	\N
139651	1397	1335159650000	17994	9061	12	0	\N
139652	1397	1335149649000	17994	9061	13	0	\N
139653	1397	1335139648000	17994	9061	14	0	\N
139654	1679	15226896653000	17994	9061	15	0	\N
139655	1679	11518786653000	17994	9061	16	0	\N
139656	1397	1335129647000	17994	9061	17	0	\N
139657	1397	1335119646000	17994	9061	18	0	\N
139658	1397	1335109645000	17994	9061	19	0	\N
139659	1397	1335099644000	17994	9061	21	0	\N
139660	1397	1335089643000	17994	9061	22	0	\N
139661	1397	1335079642000	17994	9061	23	0	\N
139662	1397	1335069641000	17994	9061	24	0	\N
139663	1397	1335059640000	17994	9061	25	0	\N
139664	1397	1335049639000	17994	9061	26	0	\N
139665	1397	1335039638000	17994	9061	27	0	\N
139666	1397	1335029637000	17994	9061	28	0	\N
139667	1397	1335019636000	17994	9061	29	0	\N
139668	1397	1335009635000	17994	9061	30	0	\N
139669	1397	1334999634000	17994	9061	31	0	\N
139670	1397	1334989633000	17994	9061	32	0	\N
139671	1397	1334979632000	17994	9061	33	0	\N
139672	1397	1334969631000	17994	9061	34	0	\N
139551	1397	1335129647000	17977	9066	1	0	10370
139552	2133	97564134000	17977	9066	2	0	1433
139553	2134	97548659000	17977	9066	3	0	1447
139554	1397	1335119646000	17978	9067	0	0	10371
139555	2134	97547656000	17978	9067	1	0	1448
139557	2133	97563132000	17978	9067	3	0	1434
139567	1397	1335109645000	17981	9068	0	0	10372
139568	1397	1335099644000	17981	9068	1	0	10373
139569	2133	97562130000	17981	9068	2	0	1435
139570	2133	97561128000	17981	9068	3	0	1436
139572	2134	97545650000	17981	9068	5	0	1450
139573	1397	1335089643000	17982	9069	0	0	10374
139574	1688	30959385908000	17982	9069	1	0	38
139575	1397	1335079642000	17982	9069	2	0	10375
139577	2133	97560126000	17982	9069	4	0	1437
139578	2134	97544647000	17982	9069	5	0	1451
139579	2134	97543644000	17982	9069	6	0	1452
139580	2133	97559124000	17982	9069	7	0	1438
139581	1397	1335069641000	17983	9070	0	0	10376
139583	1679	15226896653000	17983	9070	2	0	49
139584	2133	97558122000	17983	9070	3	0	1439
139585	2134	97542641000	17983	9070	4	0	1453
139586	2132	148643644000	17983	9070	5	0	356
139587	2134	97541638000	17983	9070	6	0	1454
139589	1679	11518786653000	17984	9071	0	0	50
139590	1397	1335049639000	17984	9071	1	0	10378
139591	1397	1335039638000	17984	9071	2	0	10379
139592	2157	199000000	17984	9071	3	0	1
139594	2134	97539632000	17984	9071	5	0	1456
139595	2133	97556118000	17984	9071	6	0	1441
139596	2133	97555116000	17984	9071	7	0	1442
139597	1397	1335029637000	17985	9072	0	0	10380
139598	2133	97554114000	17985	9072	1	0	1443
139600	1397	1335019636000	17986	9073	0	0	10381
139601	1683	0	17986	9073	1	0	3
139602	2133	97553112000	17986	9073	2	0	1444
139603	2132	148642643000	17986	9073	3	0	357
139604	1397	1335009635000	17987	9074	0	0	10382
139606	2134	97537626000	17987	9074	2	0	1458
139607	2134	97536623000	17987	9074	3	0	1459
139611	1397	1334999634000	17989	9075	0	0	10383
139612	2134	97535620000	17989	9075	1	0	1460
139619	1397	1334989633000	17991	9076	0	0	10384
139620	1726	109585110000	17991	9076	1	0	8196
139621	2134	97534617000	17991	9076	2	0	1461
139622	2132	148641642000	17991	9076	3	0	358
139623	2133	97551108000	17991	9076	4	0	1446
139625	1397	1334979632000	17992	9077	1	0	10385
139626	1397	1334969631000	17992	9077	2	0	10386
139627	1397	1334959630000	17992	9077	3	0	10387
139628	1726	107165110000	17992	9077	4	0	8198
139629	2132	148640641000	17992	9077	5	0	359
139631	2134	97532611000	17992	9077	7	0	1463
139632	2134	97531608000	17992	9077	8	0	1464
139633	2133	97550106000	17992	9077	9	0	1447
139634	2133	97549104000	17992	9077	10	0	1448
139636	1397	1334949629000	17993	9078	0	0	10388
139637	2134	97530605000	17993	9078	1	0	1465
139638	2133	97547100000	17993	9078	2	0	1450
139673	1397	1334959630000	17994	9061	35	0	\N
139674	1397	1334949629000	17994	9061	36	0	\N
139675	2134	97555680000	17994	9061	37	0	\N
139676	2134	97554677000	17994	9061	38	0	\N
139677	2132	148647648000	17994	9061	39	0	\N
139678	2157	199000000	17994	9061	40	0	\N
139679	2133	97572150000	17994	9061	41	0	\N
139680	2133	97571148000	17994	9061	42	0	\N
139681	2133	97570146000	17994	9061	43	0	\N
139682	2134	97553674000	17994	9061	44	0	\N
139683	2134	97552671000	17994	9061	45	0	\N
139684	2134	97551668000	17994	9061	46	0	\N
139685	2133	97569144000	17994	9061	47	0	\N
139686	2133	97568142000	17994	9061	48	0	\N
139687	2133	97567140000	17994	9061	49	0	\N
139688	2132	148646647000	17994	9061	50	0	\N
139689	2132	148645646000	17994	9061	51	0	\N
139690	2132	148644645000	17994	9061	52	0	\N
139691	2132	148643644000	17994	9061	53	0	\N
139692	2133	97566138000	17994	9061	54	0	\N
139693	2133	97565136000	17994	9061	55	0	\N
139694	2133	97564134000	17994	9061	56	0	\N
139695	2133	97563132000	17994	9061	57	0	\N
139696	2133	97562130000	17994	9061	58	0	\N
139697	2133	97561128000	17994	9061	59	0	\N
139698	2133	97560126000	17994	9061	60	0	\N
139699	2133	97559124000	17994	9061	61	0	\N
139700	2133	97558122000	17994	9061	62	0	\N
139701	2133	97557120000	17994	9061	63	0	\N
139702	2133	97556118000	17994	9061	64	0	\N
139703	2133	97555116000	17994	9061	65	0	\N
139704	2133	97554114000	17994	9061	66	0	\N
139705	2133	97553112000	17994	9061	67	0	\N
139706	2132	148642643000	17994	9061	68	0	\N
139707	2133	97552110000	17994	9061	69	0	\N
139708	2132	148641642000	17994	9061	70	0	\N
139709	2132	148640641000	17994	9061	71	0	\N
139710	2134	97550665000	17994	9061	72	0	\N
139711	2134	97549662000	17994	9061	73	0	\N
139712	2134	97548659000	17994	9061	74	0	\N
139713	2134	97547656000	17994	9061	75	0	\N
139714	2134	97546653000	17994	9061	76	0	\N
139715	2134	97545650000	17994	9061	77	0	\N
139716	2134	97544647000	17994	9061	78	0	\N
139717	2134	97543644000	17994	9061	79	0	\N
139718	2134	97542641000	17994	9061	80	0	\N
139719	2134	97541638000	17994	9061	81	0	\N
139720	2134	97540635000	17994	9061	82	0	\N
139721	2134	97539632000	17994	9061	83	0	\N
139722	2134	97538629000	17994	9061	84	0	\N
139723	2134	97537626000	17994	9061	85	0	\N
139724	2134	97536623000	17994	9061	86	0	\N
139725	2134	97535620000	17994	9061	87	0	\N
139726	2134	97534617000	17994	9061	88	0	\N
139727	2134	97533614000	17994	9061	89	0	\N
139728	2134	97532611000	17994	9061	90	0	\N
139729	2134	97531608000	17994	9061	91	0	\N
139730	2134	97530605000	17994	9061	92	0	\N
139731	2133	97551108000	17994	9061	93	0	\N
139732	2133	97550106000	17994	9061	94	0	\N
139733	2133	97549104000	17994	9061	95	0	\N
139734	2133	97548102000	17994	9061	96	0	\N
139735	2133	97547100000	17994	9061	97	0	\N
139736	1397	1334939628000	17995	9079	0	0	\N
139737	2133	97546098000	17995	9079	1	0	\N
139738	2134	97529602000	17995	9079	2	0	\N
139739	1397	1334939628000	17996	9079	0	0	\N
139740	2133	97546098000	17996	9079	1	0	\N
139741	2134	97529602000	17996	9079	2	0	\N
139747	1397	1334919626000	17999	9081	0	0	\N
139748	420	66083218193897	17999	9081	1	0	\N
139749	2133	97544094000	17999	9081	2	0	\N
139750	2134	97528599000	17999	9081	3	0	\N
139751	2132	148639640000	17999	9081	4	0	\N
139752	1397	1334919626000	18000	9081	0	0	\N
139753	420	66083218193897	18000	9081	1	0	\N
139754	2133	97544094000	18000	9081	2	0	\N
139755	2134	97528599000	18000	9081	3	0	\N
139756	2132	148639640000	18000	9081	4	0	\N
139762	1397	1334909625000	18002	9082	0	0	\N
139763	2133	97543092000	18002	9082	1	0	\N
139764	2134	97527596000	18002	9082	2	0	\N
139765	1397	1334909625000	18004	9082	0	0	\N
139766	2133	97543092000	18004	9082	1	0	\N
139767	2134	97527596000	18004	9082	2	0	\N
139774	1397	1334909625000	18006	9083	0	0	\N
139775	1397	1334899624000	18006	9083	1	0	\N
139776	2133	97543092000	18006	9083	2	0	\N
139777	2134	97527596000	18006	9083	3	0	\N
139778	2133	97542090000	18006	9083	4	0	\N
139779	2134	97526593000	18006	9083	5	0	\N
139780	1397	1334909625000	18007	9083	0	0	\N
139781	1397	1334899624000	18007	9083	1	0	\N
139782	1397	1334889623000	18007	9083	2	0	\N
139783	2132	148638639000	18007	9083	3	0	\N
139784	2133	97543092000	18007	9083	4	0	\N
139785	2134	97527596000	18007	9083	5	0	\N
139786	2133	97542090000	18007	9083	6	0	\N
139787	2134	97526593000	18007	9083	7	0	\N
139788	2133	97541088000	18007	9083	8	0	\N
139789	2134	97525590000	18007	9083	9	0	\N
139794	1397	1334889623000	18009	9084	0	0	\N
139795	2132	148638639000	18009	9084	1	0	\N
139796	2133	97541088000	18009	9084	2	0	\N
139797	2134	97525590000	18009	9084	3	0	\N
139798	1397	1334879622000	18010	9084	0	0	\N
139799	2133	97540086000	18010	9084	1	0	\N
139800	2134	97524587000	18010	9084	2	0	\N
139801	420	66000217193897	18010	9084	3	0	\N
139744	2134	97529602000	17997	9079	2	0	1466
139745	1397	1334929627000	17998	9080	0	0	10390
139746	2133	97545096000	17998	9080	1	0	1452
139757	1397	1334919626000	18001	9081	0	0	10391
139758	420	66083218193897	18001	9081	1	0	3
139760	2134	97528599000	18001	9081	3	0	1467
139761	2132	148639640000	18001	9081	4	0	360
139768	1397	1334909625000	18005	9083	0	0	10392
139769	1397	1334899624000	18005	9083	1	0	10393
139770	2133	97543092000	18005	9083	2	0	1454
139772	2133	97542090000	18005	9083	4	0	1455
139773	2134	97526593000	18005	9083	5	0	1469
139790	1397	1334889623000	18008	9084	0	0	10394
139791	2132	148638639000	18008	9084	1	0	361
139793	2134	97525590000	18008	9084	3	0	1470
139802	1397	1334879622000	18011	9085	0	0	10395
139803	2133	97540086000	18011	9085	1	0	1457
139804	2133	97539084000	18011	9085	2	0	1458
139805	2134	97524587000	18011	9085	3	0	1471
139807	1397	1334869621000	18012	9086	0	0	10396
139808	2134	97523584000	18012	9086	1	0	1472
139809	1397	1334879622000	18013	9085	0	0	\N
139810	1397	1334869621000	18013	9085	1	0	\N
139811	2133	97540086000	18013	9085	2	0	\N
139812	2133	97539084000	18013	9085	3	0	\N
139813	2134	97524587000	18013	9085	4	0	\N
139814	2134	97523584000	18013	9085	5	0	\N
139815	420	66000217193897	18013	9085	6	0	\N
139816	1397	1334879622000	18014	9085	0	0	\N
139817	1397	1334869621000	18014	9085	1	0	\N
139818	2133	97540086000	18014	9085	2	0	\N
139819	2133	97539084000	18014	9085	3	0	\N
139820	2134	97524587000	18014	9085	4	0	\N
139821	2134	97523584000	18014	9085	5	0	\N
139822	420	66000217193897	18014	9085	6	0	\N
139830	1397	1334839618000	18017	9089	0	0	\N
139831	2133	97536078000	18017	9089	1	0	\N
139832	2134	97520575000	18017	9089	2	0	\N
139836	1397	1334839618000	18019	9089	0	0	\N
139837	2134	97520575000	18019	9089	1	0	\N
139838	1397	1334829617000	18020	9090	0	0	\N
139839	2134	97519572000	18020	9090	1	0	\N
139840	2133	97535076000	18020	9090	2	0	\N
139841	1804	1400000000	18020	9090	3	0	\N
139859	1397	1334779612000	18025	9094	0	0	\N
139860	2134	97515560000	18025	9094	1	0	\N
139868	1397	1334759610000	18029	9096	0	0	\N
139869	2132	148634635000	18029	9096	1	0	\N
139870	2134	97513554000	18029	9096	2	0	\N
139871	1397	1334759610000	18030	9096	0	0	\N
139872	2132	148634635000	18030	9096	1	0	\N
139873	2134	97513554000	18030	9096	2	0	\N
139874	1397	1334759610000	18031	9096	0	0	\N
139875	2132	148634635000	18031	9096	1	0	\N
139876	2134	97513554000	18031	9096	2	0	\N
139879	1397	1334739608000	18033	9098	0	0	\N
139880	1397	1334729607000	18033	9098	1	0	\N
139881	2134	97511548000	18033	9098	2	0	\N
139882	2134	97510545000	18033	9098	3	0	\N
139883	1677	0	18034	9044	0	0	\N
139884	1726	109585110000	18034	9044	1	0	\N
139885	1726	108375110000	18034	9044	2	0	\N
139886	420	66083218193897	18034	9044	3	0	\N
139887	1683	0	18034	9044	4	0	\N
139888	1726	107165110000	18034	9044	5	0	\N
139889	1688	42839751908000	18034	9044	6	0	\N
139890	1688	29519341908000	18034	9044	7	0	\N
139891	1679	15226896653000	18034	9044	8	0	\N
139892	1679	11518786653000	18034	9044	9	0	\N
139893	2157	199000000	18034	9044	10	0	\N
139894	1769	1688900000	18034	9044	11	0	\N
139895	1769	1687900000	18034	9044	12	0	\N
139896	420	66000217193897	18034	9044	13	0	\N
139897	1804	1400000000	18034	9044	14	0	\N
139902	1397	1334719606000	18036	9099	0	0	\N
139903	2132	148633634000	18036	9099	1	0	\N
139904	2134	97509542000	18036	9099	2	0	\N
139910	1397	1334709605000	18039	9100	0	0	\N
139911	2134	97508539000	18039	9100	1	0	\N
139914	1397	1334699604000	18041	9101	0	0	\N
139915	2134	97507536000	18041	9101	1	0	\N
139916	1726	110795110000	18042	8999	0	0	\N
139917	1677	0	18042	8999	1	0	\N
139918	1726	109585110000	18042	8999	2	0	\N
139919	1726	108375110000	18042	8999	3	0	\N
139920	420	66083218193897	18042	8999	4	0	\N
139921	1683	0	18042	8999	5	0	\N
139922	1726	107165110000	18042	8999	6	0	\N
139923	1688	42119739908000	18042	8999	7	0	\N
139924	1688	28799329908000	18042	8999	8	0	\N
139925	1679	14506884653000	18042	8999	9	0	\N
139926	1679	10798774653000	18042	8999	10	0	\N
139927	2118	1398000000	18042	8999	11	0	\N
139928	1769	1689900000	18042	8999	12	0	\N
139929	2157	199000000	18042	8999	13	0	\N
139930	1769	1688900000	18042	8999	14	0	\N
139931	1769	1687900000	18042	8999	15	0	\N
139932	2141	719012000000	18042	8999	16	0	\N
139933	420	66000217193897	18042	8999	17	0	\N
139934	1804	1400000000	18042	8999	18	0	\N
139938	1397	1334689603000	18044	9102	0	0	\N
139939	2134	97506533000	18044	9102	1	0	\N
139940	2132	148632633000	18044	9102	2	0	\N
139941	1397	1334689603000	18045	9102	0	0	\N
139942	2134	97506533000	18045	9102	1	0	\N
139943	2132	148632633000	18045	9102	2	0	\N
139825	2132	148637638000	18015	9087	2	0	362
139826	2134	97522581000	18015	9087	3	0	1473
139827	1397	1334849619000	18016	9088	0	0	10398
139828	2133	97537080000	18016	9088	1	0	1460
139829	2134	97521578000	18016	9088	2	0	1474
139834	2133	97536078000	18018	9089	1	0	1461
139835	2134	97520575000	18018	9089	2	0	1475
139842	1397	1334829617000	18021	9090	0	0	10400
139843	2134	97519572000	18021	9090	1	0	1476
139844	2133	97535076000	18021	9090	2	0	1462
139846	1397	1334819616000	18022	9091	0	0	10401
139847	1397	1334809615000	18022	9091	1	0	10402
139848	2133	97534074000	18022	9091	2	0	1463
139849	2132	148636637000	18022	9091	3	0	363
139851	2134	97518569000	18022	9091	5	0	1477
139852	1397	1334799614000	18023	9092	0	0	10403
139853	2133	97532070000	18023	9092	1	0	1465
139854	2134	97517566000	18023	9092	2	0	1478
139855	1397	1334789613000	18024	9093	0	0	10404
139857	2133	97531068000	18024	9093	2	0	1466
139858	2134	97516563000	18024	9093	3	0	1479
139861	1397	1334779612000	18026	9094	0	0	10405
139862	2134	97515560000	18026	9094	1	0	1480
139863	1397	1334769611000	18027	9095	0	0	10406
139865	1397	1334759610000	18028	9096	0	0	10407
139866	2132	148634635000	18028	9096	1	0	365
139867	2134	97513554000	18028	9096	2	0	1482
139877	1397	1334749609000	18032	9097	0	0	10408
139898	1397	1334739608000	18035	9098	0	0	10409
139899	1397	1334729607000	18035	9098	1	0	10410
139900	2134	97511548000	18035	9098	2	0	1484
139901	2134	97510545000	18035	9098	3	0	1485
139905	1397	1334719606000	18037	9099	0	0	10411
139907	2134	97509542000	18037	9099	2	0	1486
139908	1397	1334709605000	18038	9100	0	0	10412
139909	2134	97508539000	18038	9100	1	0	1487
139912	1397	1334699604000	18040	9101	0	0	10413
139913	2134	97507536000	18040	9101	1	0	1488
139936	2134	97506533000	18043	9102	1	0	1489
139937	2132	148632633000	18043	9102	2	0	367
139944	397	66612728193897	18046	9103	0	0	1
139949	1397	1334669601000	18048	9104	0	0	\N
139950	2134	97504527000	18048	9104	1	0	\N
139951	1397	1334669601000	18049	9104	0	0	\N
139952	2134	97504527000	18049	9104	1	0	\N
139953	1397	1334659600000	18050	9105	0	0	\N
139954	2134	97503524000	18050	9105	1	0	\N
139955	2132	148631632000	18050	9105	2	0	\N
139966	397	66000718193897	18055	9107	0	0	\N
139967	1397	1334629597000	18055	9107	1	0	\N
139968	2134	97500515000	18055	9107	2	0	\N
139969	397	66000718193897	18056	9107	0	0	\N
139970	1397	1334629597000	18056	9107	1	0	\N
139971	2134	97500515000	18056	9107	2	0	\N
139972	397	66612728193897	18057	8914	0	0	\N
139973	397	66000718193897	18057	8914	1	0	\N
139974	1677	0	18057	8914	3	0	\N
139975	1397	1334619596000	18058	9108	0	0	\N
139976	2181	612190000000	18058	9108	1	0	\N
139977	1397	1334609595000	18058	9108	2	0	\N
139978	2132	148630631000	18058	9108	3	0	\N
139979	2134	97499512000	18058	9108	4	0	\N
139980	2134	97498509000	18058	9108	5	0	\N
139987	1397	1334599594000	18060	9109	0	0	\N
139988	1397	1334589593000	18060	9109	1	0	\N
139989	397	66000708193897	18060	9109	2	0	\N
139990	2134	97497506000	18060	9109	3	0	\N
139991	2134	97496503000	18060	9109	4	0	\N
139992	2132	148629630000	18060	9109	5	0	\N
139993	1397	1334599594000	18061	9109	0	0	\N
139994	1397	1334589593000	18061	9109	1	0	\N
139995	397	66000708193897	18061	9109	2	0	\N
139996	2134	97497506000	18061	9109	3	0	\N
139997	2134	97496503000	18061	9109	4	0	\N
139998	2132	148629630000	18061	9109	5	0	\N
140005	1397	1334579592000	18063	9110	0	0	\N
140006	1397	1334579592000	18064	9110	0	0	\N
140014	1397	1334549589000	18068	9113	0	0	\N
140015	2134	97493494000	18068	9113	1	0	\N
140016	1397	1334549589000	18069	9113	0	0	\N
140017	2134	97493494000	18069	9113	1	0	\N
140020	1397	1334549589000	18071	9113	0	0	\N
140021	2134	97493494000	18071	9113	1	0	\N
140022	1397	1334549589000	18072	9113	0	0	\N
140023	2134	97493494000	18072	9113	1	0	\N
140024	1397	1334539588000	18073	9114	0	0	\N
140025	1397	1334529587000	18073	9114	1	0	\N
140026	2134	97492491000	18073	9114	2	0	\N
140027	2134	97491488000	18073	9114	3	0	\N
140046	1397	1334469581000	18078	9117	0	0	\N
140047	2134	97485470000	18078	9117	1	0	\N
140048	1397	1334459580000	18079	9118	0	0	\N
140049	2134	97484467000	18079	9118	1	0	\N
140050	2132	148625626000	18079	9118	2	0	\N
140054	1397	1334459580000	18081	9118	0	0	\N
140055	2134	97484467000	18081	9118	1	0	\N
140056	2132	148625626000	18081	9118	2	0	\N
140066	397	66612728193897	18085	9084	0	0	\N
140067	397	66000718193897	18085	9084	1	0	\N
140068	2139	190000000	18085	9084	2	0	\N
140069	397	66000708193897	18085	9084	3	0	\N
140070	2132	148637638000	18085	9084	4	0	\N
140071	2132	148636637000	18085	9084	5	0	\N
140072	2132	148635636000	18085	9084	6	0	\N
140073	2132	148634635000	18085	9084	7	0	\N
140074	2132	148633634000	18085	9084	8	0	\N
140075	2132	148632633000	18085	9084	9	0	\N
140076	2132	148631632000	18085	9084	10	0	\N
140077	2132	148630631000	18085	9084	11	0	\N
140078	2132	148629630000	18085	9084	12	0	\N
140079	2132	148628629000	18085	9084	13	0	\N
140080	2132	148627628000	18085	9084	14	0	\N
139947	1397	1334669601000	18047	9104	0	0	10416
139948	2134	97504527000	18047	9104	1	0	1491
139956	1397	1334659600000	18051	9105	0	0	10417
139957	2134	97503524000	18051	9105	1	0	1492
139958	2132	148631632000	18051	9105	2	0	368
139960	1397	1334639598000	18052	9106	1	0	10419
139961	2134	97502521000	18052	9106	2	0	1493
139962	2134	97501518000	18052	9106	3	0	1494
139963	397	66000718193897	18054	9107	0	0	2
139964	1397	1334629597000	18054	9107	1	0	10420
139981	1397	1334619596000	18059	9108	0	0	10421
139982	2181	612190000000	18059	9108	1	0	1
139983	1397	1334609595000	18059	9108	2	0	10422
139984	2132	148630631000	18059	9108	3	0	369
139986	2134	97498509000	18059	9108	5	0	1497
139999	1397	1334599594000	18062	9109	0	0	10423
140000	1397	1334589593000	18062	9109	1	0	10424
140001	397	66000708193897	18062	9109	2	0	3
140002	2134	97497506000	18062	9109	3	0	1498
140004	2132	148629630000	18062	9109	5	0	370
140007	2139	190000000	18065	9110	0	0	1
140008	1397	1334579592000	18065	9110	1	0	10425
140009	2134	97495500000	18065	9110	2	0	1500
140010	1397	1334569591000	18066	9111	0	0	10426
140012	2134	97494497000	18067	9112	1	0	1501
140013	2132	148628629000	18067	9112	2	0	371
140018	1397	1334549589000	18070	9113	0	0	10428
140019	2134	97493494000	18070	9113	1	0	1502
140029	1397	1334529587000	18074	9114	1	0	10430
140030	2134	97492491000	18074	9114	2	0	1503
140031	2134	97491488000	18074	9114	3	0	1504
140032	1397	1334519586000	18075	9115	0	0	10431
140033	1397	1334509585000	18075	9115	1	0	10432
140035	2134	97490485000	18075	9115	3	0	1505
140036	2134	97489482000	18075	9115	4	0	1506
140037	2134	97488479000	18075	9115	5	0	1507
140038	2132	148627628000	18075	9115	6	0	372
140039	1397	1334489583000	18076	9116	0	0	10434
140041	2132	148626627000	18076	9116	2	0	373
140042	2134	97487476000	18076	9116	3	0	1508
140043	2134	97486473000	18076	9116	4	0	1509
140044	1397	1334469581000	18077	9117	0	0	10436
140051	1397	1334459580000	18080	9118	0	0	10437
140052	2134	97484467000	18080	9118	1	0	1511
140053	2132	148625626000	18080	9118	2	0	374
140057	1397	1334449579000	18082	9119	0	0	10438
140058	2134	97483464000	18082	9119	1	0	1512
140060	1397	1334429577000	18084	9120	1	0	10440
140061	1397	1334419576000	18084	9120	2	0	10441
140062	2132	148624625000	18084	9120	3	0	375
140063	2134	97482461000	18084	9120	4	0	1513
140064	2134	97481458000	18084	9120	5	0	1514
140081	2132	148626627000	18085	9084	15	0	\N
140082	2132	148625626000	18085	9084	16	0	\N
140083	2132	148624625000	18085	9084	17	0	\N
140084	1804	1400000000	18085	9084	18	0	\N
140085	1397	1334439578000	18086	9120	0	0	\N
140086	1397	1334429577000	18086	9120	1	0	\N
140087	1397	1334419576000	18086	9120	2	0	\N
140088	2132	148624625000	18086	9120	3	0	\N
140089	2134	97482461000	18086	9120	4	0	\N
140090	2134	97481458000	18086	9120	5	0	\N
140091	2134	97480455000	18086	9120	6	0	\N
140092	1397	1334409575000	18087	9121	0	0	\N
140093	2134	97479452000	18087	9121	1	0	\N
140096	397	66612728193897	18089	8996	0	0	\N
140097	397	66000718193897	18089	8996	1	0	\N
140098	2139	190000000	18089	8996	2	0	\N
140099	397	66000708193897	18089	8996	3	0	\N
140100	1677	0	18089	8996	4	0	\N
140101	1397	1335269661000	18089	8996	5	0	\N
140102	1397	1335259660000	18089	8996	6	0	\N
140103	1726	109585110000	18089	8996	7	0	\N
140104	1726	108375110000	18089	8996	8	0	\N
140105	1397	1335249659000	18089	8996	9	0	\N
140106	1397	1335239658000	18089	8996	10	0	\N
140107	1397	1335229657000	18089	8996	11	0	\N
140108	1397	1335219656000	18089	8996	12	0	\N
140109	1397	1335209655000	18089	8996	13	0	\N
140110	420	66083218193897	18089	8996	14	0	\N
140111	1683	0	18089	8996	15	0	\N
140112	1726	107165110000	18089	8996	16	0	\N
140113	1688	42119739908000	18089	8996	17	0	\N
140114	1688	28799329908000	18089	8996	18	0	\N
140115	1397	1335199654000	18089	8996	19	0	\N
140116	1397	1335189653000	18089	8996	20	0	\N
140117	1397	1335179652000	18089	8996	21	0	\N
140118	1397	1335169651000	18089	8996	22	0	\N
140119	1397	1335159650000	18089	8996	23	0	\N
140120	1397	1335149649000	18089	8996	24	0	\N
140121	1397	1335139648000	18089	8996	25	0	\N
140122	1679	14506884653000	18089	8996	26	0	\N
140123	1679	10798774653000	18089	8996	27	0	\N
140124	1397	1335129647000	18089	8996	28	0	\N
140125	1397	1335119646000	18089	8996	29	0	\N
140126	1397	1335109645000	18089	8996	30	0	\N
140127	1397	1335099644000	18089	8996	31	0	\N
140128	1397	1335089643000	18089	8996	32	0	\N
140129	1397	1335079642000	18089	8996	33	0	\N
140130	1397	1335069641000	18089	8996	34	0	\N
140131	1397	1335059640000	18089	8996	35	0	\N
140132	1397	1335049639000	18089	8996	36	0	\N
140133	1397	1335039638000	18089	8996	37	0	\N
140134	1397	1335029637000	18089	8996	38	0	\N
140135	1397	1335019636000	18089	8996	39	0	\N
140136	1397	1335009635000	18089	8996	40	0	\N
140137	1397	1334999634000	18089	8996	41	0	\N
140138	1397	1334989633000	18089	8996	42	0	\N
140139	1397	1334979632000	18089	8996	43	0	\N
140140	1397	1334969631000	18089	8996	44	0	\N
140141	1397	1334959630000	18089	8996	45	0	\N
140142	1397	1334949629000	18089	8996	46	0	\N
140143	1397	1334939628000	18089	8996	47	0	\N
140144	1397	1334929627000	18089	8996	48	0	\N
140145	1397	1334919626000	18089	8996	49	0	\N
140146	1397	1334909625000	18089	8996	50	0	\N
140147	1397	1334899624000	18089	8996	51	0	\N
140148	1397	1334889623000	18089	8996	52	0	\N
140149	1397	1334879622000	18089	8996	53	0	\N
140150	1397	1334869621000	18089	8996	54	0	\N
140151	1397	1334859620000	18089	8996	55	0	\N
140152	1397	1334849619000	18089	8996	56	0	\N
140153	1397	1334839618000	18089	8996	57	0	\N
140154	1397	1334829617000	18089	8996	58	0	\N
140155	1397	1334819616000	18089	8996	59	0	\N
140156	1397	1334809615000	18089	8996	60	0	\N
140157	1397	1334799614000	18089	8996	61	0	\N
140158	1397	1334789613000	18089	8996	63	0	\N
140159	1397	1334779612000	18089	8996	64	0	\N
140160	1397	1334769611000	18089	8996	65	0	\N
140161	1397	1334759610000	18089	8996	66	0	\N
140162	1397	1334749609000	18089	8996	67	0	\N
140163	1397	1334739608000	18089	8996	68	0	\N
140164	1397	1334729607000	18089	8996	69	0	\N
140165	1397	1334719606000	18089	8996	70	0	\N
140166	1397	1334709605000	18089	8996	71	0	\N
140167	1397	1334699604000	18089	8996	72	0	\N
140168	1397	1334689603000	18089	8996	73	0	\N
140169	1397	1334679602000	18089	8996	74	0	\N
140170	1397	1334669601000	18089	8996	75	0	\N
140171	1397	1334659600000	18089	8996	76	0	\N
140172	1397	1334649599000	18089	8996	77	0	\N
140173	1397	1334639598000	18089	8996	78	0	\N
140174	1397	1334629597000	18089	8996	79	0	\N
140175	1397	1334619596000	18089	8996	80	0	\N
140176	1397	1334609595000	18089	8996	81	0	\N
140177	1397	1334599594000	18089	8996	82	0	\N
140178	1397	1334589593000	18089	8996	83	0	\N
140179	1397	1334579592000	18089	8996	84	0	\N
140180	1397	1334569591000	18089	8996	85	0	\N
140181	1397	1334559590000	18089	8996	86	0	\N
140182	1397	1334549589000	18089	8996	87	0	\N
140183	1397	1334539588000	18089	8996	88	0	\N
140184	1397	1334529587000	18089	8996	89	0	\N
140185	1397	1334519586000	18089	8996	90	0	\N
140186	1397	1334509585000	18089	8996	91	0	\N
140187	1397	1334499584000	18089	8996	92	0	\N
140188	1397	1334489583000	18089	8996	93	0	\N
140189	1397	1334479582000	18089	8996	94	0	\N
140190	1397	1334469581000	18089	8996	95	0	\N
140191	1397	1334459580000	18089	8996	96	0	\N
140192	1397	1334449579000	18089	8996	97	0	\N
140193	1397	1334439578000	18089	8996	98	0	\N
140194	1397	1334429577000	18089	8996	99	0	\N
140195	1397	1334419576000	18089	8996	100	0	\N
140196	1397	1334409575000	18089	8996	101	0	\N
140197	2132	148656657000	18089	8996	102	0	\N
140198	2132	148655656000	18089	8996	103	0	\N
140199	2157	199000000	18089	8996	104	0	\N
140200	420	66000217193897	18089	8996	105	0	\N
140201	1804	1400000000	18089	8996	106	0	\N
140202	2132	148654655000	18089	8996	107	0	\N
140203	2132	148653654000	18089	8996	108	0	\N
140204	2132	148652653000	18089	8996	109	0	\N
140205	2132	148651652000	18089	8996	110	0	\N
140206	2132	148650651000	18089	8996	111	0	\N
140207	2132	148649650000	18089	8996	112	0	\N
140208	2132	148648649000	18089	8996	113	0	\N
140209	2132	148647648000	18089	8996	114	0	\N
140210	2132	148646647000	18089	8996	115	0	\N
140211	2132	148645646000	18089	8996	116	0	\N
140212	2132	148644645000	18089	8996	117	0	\N
140213	2132	148643644000	18089	8996	118	0	\N
140214	2132	148642643000	18089	8996	119	0	\N
140215	2132	148641642000	18089	8996	120	0	\N
140216	2132	148640641000	18089	8996	121	0	\N
140217	2132	148639640000	18089	8996	122	0	\N
140218	2132	148638639000	18089	8996	123	0	\N
140219	2132	148637638000	18089	8996	124	0	\N
140220	2132	148636637000	18089	8996	125	0	\N
140222	1397	1334389573000	18091	9123	0	0	\N
140223	2134	97478449000	18091	9123	1	0	\N
140224	2132	148623624000	18091	9123	2	0	\N
140225	1397	1334389573000	18092	9123	0	0	\N
140226	2134	97478449000	18092	9123	1	0	\N
140227	2132	148623624000	18092	9123	2	0	\N
140235	1397	1334369571000	18096	9125	0	0	\N
140236	2134	97476443000	18096	9125	1	0	\N
140256	1397	1334289563000	18104	9132	0	0	\N
140257	2132	148620621000	18104	9132	1	0	\N
140258	2134	97469422000	18104	9132	2	0	\N
140259	2134	97468419000	18104	9132	3	0	\N
140260	1397	1334289563000	18105	9132	0	0	\N
140261	2132	148620621000	18105	9132	1	0	\N
140262	2134	97469422000	18105	9132	2	0	\N
140263	2134	97468419000	18105	9132	3	0	\N
140264	1397	1334279562000	18106	9133	0	0	\N
140265	2134	97467416000	18106	9133	1	0	\N
140269	1397	1334339568000	18109	9128	0	0	\N
140270	1397	1334329567000	18109	9128	1	0	\N
140271	1397	1334319566000	18109	9128	2	0	\N
140272	1397	1334309565000	18109	9128	3	0	\N
140273	1397	1334299564000	18109	9128	4	0	\N
140274	1397	1334289563000	18109	9128	5	0	\N
140275	1397	1334279562000	18109	9128	6	0	\N
140276	2134	97473434000	18109	9128	7	0	\N
140277	2134	97472431000	18109	9128	8	0	\N
140278	2132	148621622000	18109	9128	9	0	\N
140279	2132	148620621000	18109	9128	10	0	\N
140280	2134	97471428000	18109	9128	11	0	\N
140281	2134	97470425000	18109	9128	12	0	\N
140282	2134	97469422000	18109	9128	13	0	\N
140283	2134	97468419000	18109	9128	14	0	\N
140284	2134	97467416000	18109	9128	15	0	\N
140290	1397	1334249559000	18112	9136	0	0	\N
140291	2134	97465410000	18112	9136	1	0	\N
140292	1397	1334249559000	18113	9136	0	0	\N
140293	2134	97465410000	18113	9136	1	0	\N
140294	1397	1334249559000	18114	9136	0	0	\N
140295	2134	97465410000	18114	9136	1	0	\N
140296	1397	1334399574000	18115	9122	0	0	\N
140297	1397	1334389573000	18115	9122	1	0	\N
140298	1397	1334379572000	18115	9122	2	0	\N
140299	1397	1334369571000	18115	9122	3	0	\N
140300	1397	1334359570000	18115	9122	4	0	\N
140301	1397	1334349569000	18115	9122	5	0	\N
140302	1397	1334339568000	18115	9122	6	0	\N
140303	1397	1334329567000	18115	9122	7	0	\N
140304	1397	1334319566000	18115	9122	8	0	\N
140305	1397	1334309565000	18115	9122	9	0	\N
140306	1397	1334299564000	18115	9122	10	0	\N
140307	1397	1334289563000	18115	9122	11	0	\N
140308	1397	1334279562000	18115	9122	12	0	\N
140309	1397	1334269561000	18115	9122	13	0	\N
140310	1397	1334259560000	18115	9122	14	0	\N
140311	1397	1334249559000	18115	9122	15	0	\N
140312	2134	97478449000	18115	9122	16	0	\N
140313	2134	97477446000	18115	9122	17	0	\N
140314	2134	97476443000	18115	9122	18	0	\N
140315	2132	148623624000	18115	9122	19	0	\N
140316	2134	97475440000	18115	9122	20	0	\N
140317	2134	97474437000	18115	9122	21	0	\N
140318	2134	97473434000	18115	9122	22	0	\N
140319	2134	97472431000	18115	9122	23	0	\N
140320	2134	97471428000	18115	9122	24	0	\N
140321	2132	148622623000	18115	9122	25	0	\N
140322	2132	148621622000	18115	9122	26	0	\N
140323	2132	148620621000	18115	9122	27	0	\N
140324	2132	148619620000	18115	9122	28	0	\N
140325	2134	97470425000	18115	9122	29	0	\N
140326	2134	97469422000	18115	9122	30	0	\N
140327	2134	97468419000	18115	9122	31	0	\N
140328	2134	97467416000	18115	9122	32	0	\N
140329	2134	97466413000	18115	9122	33	0	\N
140330	2134	97465410000	18115	9122	34	0	\N
140342	1397	1334239558000	18118	9137	0	0	\N
140343	1397	1334229557000	18118	9137	1	0	\N
140344	1397	1334219556000	18118	9137	2	0	\N
140345	1397	1334209555000	18118	9137	3	0	\N
140346	1397	1334199554000	18118	9137	4	0	\N
140347	2134	97464407000	18118	9137	5	0	\N
140348	2134	97463404000	18118	9137	6	0	\N
140349	2132	148618619000	18118	9137	7	0	\N
140350	2134	97462401000	18118	9137	8	0	\N
140351	2134	97461398000	18118	9137	9	0	\N
140352	2134	97460395000	18118	9137	10	0	\N
140229	2134	97478449000	18093	9123	1	0	1517
140230	2132	148623624000	18093	9123	2	0	376
140231	1397	1334379572000	18094	9124	0	0	10445
140232	2134	97477446000	18094	9124	1	0	1518
140233	1397	1334369571000	18095	9125	0	0	10446
140237	1397	1334359570000	18097	9126	0	0	10447
140238	2134	97475440000	18097	9126	1	0	1520
140239	2132	148622623000	18097	9126	2	0	377
140240	1397	1334349569000	18098	9127	0	0	10448
140241	2134	97474437000	18098	9127	1	0	1521
140243	2134	97473434000	18099	9128	1	0	1522
140244	1397	1334329567000	18100	9129	0	0	10450
140245	2134	97472431000	18100	9129	1	0	1523
140246	1397	1334319566000	18101	9130	0	0	10451
140248	2134	97471428000	18101	9130	2	0	1524
140249	2134	97470425000	18101	9130	3	0	1525
140250	1397	1334299564000	18102	9131	0	0	10453
140251	2132	148621622000	18102	9131	1	0	378
140252	1397	1334289563000	18103	9132	0	0	10454
140254	2134	97469422000	18103	9132	2	0	1526
140255	2134	97468419000	18103	9132	3	0	1527
140266	1397	1334279562000	18108	9134	0	0	10455
140267	1397	1334269561000	18108	9134	1	0	10456
140268	2134	97467416000	18108	9134	2	0	1528
140286	2132	148619620000	18110	9135	1	0	380
140287	2134	97466413000	18110	9135	2	0	1529
140288	1397	1334249559000	18111	9136	0	0	10458
140289	2134	97465410000	18111	9136	1	0	1530
140332	1397	1334229557000	18117	9137	1	0	10460
140333	1397	1334219556000	18117	9137	2	0	10461
140334	1397	1334209555000	18117	9137	3	0	10462
140335	1397	1334199554000	18117	9137	4	0	10463
140336	2134	97464407000	18117	9137	5	0	1531
140338	2132	148618619000	18117	9137	7	0	381
140339	2134	97462401000	18117	9137	8	0	1533
140340	2134	97461398000	18117	9137	9	0	1534
140341	2134	97460395000	18117	9137	10	0	1535
140353	1397	1334189553000	18119	9138	0	0	\N
140354	2132	148617618000	18119	9138	1	0	\N
140355	2134	97459392000	18119	9138	2	0	\N
140356	1397	1334189553000	18120	9138	0	0	\N
140357	2132	148617618000	18120	9138	1	0	\N
140358	2134	97459392000	18120	9138	2	0	\N
140366	1397	1334159550000	18124	9140	0	0	\N
140367	1397	1334149549000	18124	9140	1	0	\N
140368	2132	148616617000	18124	9140	2	0	\N
140369	2134	97456383000	18124	9140	3	0	\N
140370	2134	97455380000	18124	9140	4	0	\N
140376	2139	190000000	18126	9111	0	0	\N
140377	1397	1334569591000	18126	9111	1	0	\N
140378	1397	1334559590000	18126	9111	2	0	\N
140379	1397	1334549589000	18126	9111	3	0	\N
140380	1397	1334539588000	18126	9111	4	0	\N
140381	1397	1334529587000	18126	9111	5	0	\N
140382	1397	1334519586000	18126	9111	6	0	\N
140383	1397	1334509585000	18126	9111	7	0	\N
140384	1397	1334499584000	18126	9111	8	0	\N
140385	1397	1334489583000	18126	9111	9	0	\N
140386	1397	1334479582000	18126	9111	10	0	\N
140387	1397	1334469581000	18126	9111	11	0	\N
140388	1397	1334459580000	18126	9111	12	0	\N
140389	1397	1334449579000	18126	9111	13	0	\N
140390	1397	1334439578000	18126	9111	14	0	\N
140391	1397	1334429577000	18126	9111	15	0	\N
140392	1397	1334419576000	18126	9111	16	0	\N
140393	1397	1334409575000	18126	9111	17	0	\N
140394	1397	1334399574000	18126	9111	18	0	\N
140395	1397	1334389573000	18126	9111	19	0	\N
140396	1397	1334379572000	18126	9111	20	0	\N
140397	1397	1334369571000	18126	9111	21	0	\N
140398	1397	1334359570000	18126	9111	22	0	\N
140399	1397	1334349569000	18126	9111	23	0	\N
140400	1397	1334339568000	18126	9111	24	0	\N
140401	1397	1334329567000	18126	9111	25	0	\N
140402	1397	1334319566000	18126	9111	26	0	\N
140403	1397	1334309565000	18126	9111	27	0	\N
140404	1397	1334299564000	18126	9111	28	0	\N
140405	1397	1334289563000	18126	9111	29	0	\N
140406	1397	1334279562000	18126	9111	30	0	\N
140407	1397	1334269561000	18126	9111	31	0	\N
140408	1397	1334259560000	18126	9111	32	0	\N
140409	1397	1334249559000	18126	9111	33	0	\N
140410	1397	1334239558000	18126	9111	34	0	\N
140411	1397	1334229557000	18126	9111	35	0	\N
140412	1397	1334219556000	18126	9111	36	0	\N
140413	1397	1334209555000	18126	9111	37	0	\N
140414	1397	1334199554000	18126	9111	38	0	\N
140415	1397	1334189553000	18126	9111	39	0	\N
140416	1397	1334179552000	18126	9111	40	0	\N
140417	1397	1334169551000	18126	9111	41	0	\N
140418	1397	1334159550000	18126	9111	42	0	\N
140419	1397	1334149549000	18126	9111	43	0	\N
140420	2134	97495500000	18126	9111	44	0	\N
140421	2132	148628629000	18126	9111	45	0	\N
140422	2132	148627628000	18126	9111	46	0	\N
140423	2132	148626627000	18126	9111	47	0	\N
140424	2132	148625626000	18126	9111	48	0	\N
140425	2132	148624625000	18126	9111	49	0	\N
140426	2132	148623624000	18126	9111	50	0	\N
140427	2132	148622623000	18126	9111	51	0	\N
140428	2132	148621622000	18126	9111	52	0	\N
140429	2132	148620621000	18126	9111	53	0	\N
140430	2132	148619620000	18126	9111	54	0	\N
140431	2132	148618619000	18126	9111	55	0	\N
140432	2132	148617618000	18126	9111	56	0	\N
140433	2132	148616617000	18126	9111	57	0	\N
140441	1397	1334139548000	18128	9141	0	0	\N
140442	1397	1334129547000	18128	9141	1	0	\N
140443	1397	1334119546000	18128	9141	2	0	\N
140444	2132	148615616000	18128	9141	3	0	\N
140445	2134	97454377000	18128	9141	4	0	\N
140446	2134	97453374000	18128	9141	5	0	\N
140447	2134	97452371000	18128	9141	6	0	\N
140452	1397	1334089543000	18130	9143	0	0	\N
140453	2134	97449362000	18130	9143	1	0	\N
140454	2132	148614615000	18130	9143	2	0	\N
140458	1397	1334089543000	18132	9143	0	0	\N
140459	2134	97449362000	18132	9143	1	0	\N
140460	2132	148614615000	18132	9143	2	0	\N
140461	1397	1334079542000	18133	9144	0	0	\N
140462	2134	97448359000	18133	9144	1	0	\N
140465	397	66612728193897	18135	8917	0	0	\N
140466	1789	712990000000	18135	8917	1	0	\N
140467	397	66000718193897	18135	8917	2	0	\N
140468	2139	190000000	18135	8917	3	0	\N
140469	329	67444612000000	18135	8917	4	0	\N
140470	397	66000708193897	18135	8917	5	0	\N
140471	338	66720014000000	18135	8917	6	0	\N
140472	1677	0	18135	8917	7	0	\N
140473	420	66083218193897	18135	8917	8	0	\N
140474	1726	113215109000	18135	8917	9	0	\N
140475	1726	112005109000	18135	8917	10	0	\N
140476	1726	110795109000	18135	8917	11	0	\N
140477	1726	109585109000	18135	8917	12	0	\N
140478	1726	108375109000	18135	8917	13	0	\N
140479	1683	0	18135	8917	14	0	\N
140480	1726	107165109000	18135	8917	15	0	\N
140481	1688	41399714908000	18135	8917	16	0	\N
140482	1688	28079304908000	18135	8917	17	0	\N
140483	1679	14506884653000	18135	8917	18	0	\N
140484	1679	10798774653000	18135	8917	19	0	\N
140485	2131	199000000	18135	8917	20	0	\N
140486	1769	1689900000	18135	8917	21	0	\N
140487	2118	1399000000	18135	8917	22	0	\N
140488	2118	1398000000	18135	8917	23	0	\N
140361	2134	97459392000	18121	9138	2	0	1536
140362	1397	1334179552000	18122	9139	0	0	10465
140363	1397	1334169551000	18122	9139	1	0	10466
140364	2134	97458389000	18122	9139	2	0	1537
140365	2134	97457386000	18122	9139	3	0	1538
140372	1397	1334149549000	18125	9140	1	0	10468
140373	2132	148616617000	18125	9140	2	0	383
140374	2134	97456383000	18125	9140	3	0	1539
140375	2134	97455380000	18125	9140	4	0	1540
140434	1397	1334139548000	18127	9141	0	0	10469
140436	1397	1334119546000	18127	9141	2	0	10471
140437	2132	148615616000	18127	9141	3	0	384
140438	2134	97454377000	18127	9141	4	0	1541
140439	2134	97453374000	18127	9141	5	0	1542
140448	1397	1334109545000	18129	9142	0	0	10472
140449	1397	1334099544000	18129	9142	1	0	10473
140450	2134	97451368000	18129	9142	2	0	1544
140451	2134	97450365000	18129	9142	3	0	1545
140455	1397	1334089543000	18131	9143	0	0	10474
140457	2132	148614615000	18131	9143	2	0	385
140463	1397	1334079542000	18134	9144	0	0	10475
140464	2134	97448359000	18134	9144	1	0	1547
140489	2157	199000000	18135	8917	24	0	\N
140490	2131	198000000	18135	8917	25	0	\N
140491	2131	196999000	18135	8917	26	0	\N
140492	2132	148692693000	18135	8917	27	0	\N
140493	1769	1688900000	18135	8917	28	0	\N
140494	1769	1687900000	18135	8917	29	0	\N
140495	2141	719012000000	18135	8917	30	0	\N
140496	420	66000217193897	18135	8917	31	0	\N
140497	1804	1400000000	18135	8917	32	0	\N
140498	2132	148691692000	18135	8917	33	0	\N
140499	2132	148690691000	18135	8917	34	0	\N
140500	2132	148689690000	18135	8917	35	0	\N
140501	2132	148688689000	18135	8917	36	0	\N
140502	2132	148687688000	18135	8917	37	0	\N
140503	2132	148686687000	18135	8917	38	0	\N
140504	2132	148685686000	18135	8917	39	0	\N
140505	2132	148684685000	18135	8917	41	0	\N
140506	2132	148683684000	18135	8917	42	0	\N
140507	2132	148682683000	18135	8917	43	0	\N
140508	2132	148681682000	18135	8917	44	0	\N
140509	2132	148680681000	18135	8917	45	0	\N
140510	2132	148679680000	18135	8917	46	0	\N
140511	2132	148678679000	18135	8917	47	0	\N
140512	2132	148677678000	18135	8917	48	0	\N
140513	2132	148676677000	18135	8917	49	0	\N
140514	2132	148675676000	18135	8917	50	0	\N
140515	2132	148674675000	18135	8917	51	0	\N
140516	2132	148673674000	18135	8917	52	0	\N
140517	2132	148672673000	18135	8917	53	0	\N
140518	2132	148671672000	18135	8917	54	0	\N
140519	2132	148670671000	18135	8917	55	0	\N
140520	2132	148669670000	18135	8917	56	0	\N
140521	2132	148668669000	18135	8917	57	0	\N
140522	2132	148667668000	18135	8917	58	0	\N
140523	2132	148666667000	18135	8917	59	0	\N
140524	2132	148665666000	18135	8917	60	0	\N
140525	2132	148664665000	18135	8917	61	0	\N
140526	2132	148663664000	18135	8917	62	0	\N
140527	2132	148662663000	18135	8917	63	0	\N
140528	2132	148661662000	18135	8917	64	0	\N
140529	2132	148660661000	18135	8917	65	0	\N
140530	2132	148659660000	18135	8917	66	0	\N
140531	2132	148658659000	18135	8917	67	0	\N
140532	2132	148657658000	18135	8917	68	0	\N
140533	2132	148656657000	18135	8917	69	0	\N
140534	2132	148655656000	18135	8917	70	0	\N
140535	2132	148654655000	18135	8917	71	0	\N
140536	2132	148653654000	18135	8917	72	0	\N
140537	2132	148652653000	18135	8917	73	0	\N
140538	2132	148651652000	18135	8917	74	0	\N
140539	2132	148650651000	18135	8917	75	0	\N
140540	2132	148649650000	18135	8917	76	0	\N
140541	2132	148648649000	18135	8917	77	0	\N
140542	2132	148647648000	18135	8917	78	0	\N
140543	2132	148646647000	18135	8917	79	0	\N
140544	2132	148645646000	18135	8917	80	0	\N
140545	2132	148644645000	18135	8917	81	0	\N
140546	2132	148643644000	18135	8917	82	0	\N
140547	2132	148642643000	18135	8917	83	0	\N
140548	2132	148641642000	18135	8917	84	0	\N
140549	2132	148640641000	18135	8917	85	0	\N
140550	2132	148639640000	18135	8917	86	0	\N
140551	2132	148638639000	18135	8917	87	0	\N
140552	2132	148637638000	18135	8917	88	0	\N
140553	2132	148636637000	18135	8917	89	0	\N
140554	2132	148635636000	18135	8917	90	0	\N
140555	2132	148634635000	18135	8917	91	0	\N
140556	2132	148633634000	18135	8917	92	0	\N
140557	2132	148632633000	18135	8917	93	0	\N
140558	2132	148631632000	18135	8917	94	0	\N
140559	2132	148630631000	18135	8917	95	0	\N
140560	2132	148629630000	18135	8917	96	0	\N
140561	2132	148628629000	18135	8917	97	0	\N
140562	2132	148627628000	18135	8917	98	0	\N
140563	2132	148626627000	18135	8917	99	0	\N
140564	2132	148625626000	18135	8917	100	0	\N
140565	2132	148624625000	18135	8917	101	0	\N
140566	2132	148623624000	18135	8917	102	0	\N
140567	2132	148622623000	18135	8917	103	0	\N
140568	2132	148621622000	18135	8917	104	0	\N
140569	2132	148620621000	18135	8917	105	0	\N
140570	2132	148619620000	18135	8917	106	0	\N
140571	2132	148618619000	18135	8917	107	0	\N
140572	2132	148617618000	18135	8917	108	0	\N
140573	2132	148616617000	18135	8917	109	0	\N
140574	2132	148615616000	18135	8917	110	0	\N
140575	2132	148614615000	18135	8917	111	0	\N
140576	1397	1334069541000	18136	9145	0	0	\N
140577	1397	1334059540000	18136	9145	1	0	\N
140578	1397	1334049539000	18136	9145	2	0	\N
140579	2134	97447356000	18136	9145	3	0	\N
140580	2132	148613614000	18136	9145	4	0	\N
140581	2134	97446353000	18136	9145	5	0	\N
140582	2134	97445350000	18136	9145	6	0	\N
140590	1397	1334069541000	18138	9145	0	0	\N
140591	1397	1334059540000	18138	9145	1	0	\N
140592	1397	1334049539000	18138	9145	2	0	\N
140593	2134	97447356000	18138	9145	3	0	\N
140594	2132	148613614000	18138	9145	4	0	\N
140595	2134	97446353000	18138	9145	5	0	\N
140596	2134	97445350000	18138	9145	6	0	\N
140599	1397	1334039538000	18140	9146	0	0	\N
140600	2134	97444347000	18140	9146	1	0	\N
140603	1397	1334019536000	18142	9148	0	0	\N
140604	1397	1334009535000	18142	9148	1	0	\N
140605	2134	97442341000	18142	9148	2	0	\N
140606	2134	97441338000	18142	9148	3	0	\N
140607	2132	148612613000	18142	9148	4	0	\N
140615	1397	1333989533000	18145	9150	0	0	\N
140616	2132	148611612000	18145	9150	1	0	\N
140617	1397	1333989533000	18146	9150	0	0	\N
140618	2132	148611612000	18146	9150	1	0	\N
140624	2165	190000000	18150	9152	0	0	\N
140585	1397	1334049539000	18137	9145	2	0	10478
140586	2134	97447356000	18137	9145	3	0	1548
140587	2132	148613614000	18137	9145	4	0	386
140588	2134	97446353000	18137	9145	5	0	1549
140589	2134	97445350000	18137	9145	6	0	1550
140598	2134	97444347000	18139	9146	1	0	1551
140601	1397	1334029537000	18141	9147	0	0	10480
140602	2134	97443344000	18141	9147	1	0	1552
140608	1397	1334019536000	18143	9148	0	0	10481
140609	1397	1334009535000	18143	9148	1	0	10482
140611	2134	97441338000	18143	9148	3	0	1554
140612	2132	148612613000	18143	9148	4	0	387
140613	1397	1333999534000	18144	9149	0	0	10483
140614	2134	97440335000	18144	9149	1	0	1555
140620	2132	148611612000	18147	9150	1	0	388
140621	1397	1333979532000	18148	9151	0	0	10485
140622	2134	97439332000	18148	9151	1	0	1556
140623	2133	97530066000	18148	9151	2	0	1467
140625	1397	1333969531000	18150	9152	1	0	\N
140626	1397	1333959530000	18150	9152	2	0	\N
140627	1397	1333949529000	18150	9152	3	0	\N
140628	1397	1333939528000	18150	9152	4	0	\N
140629	1726	105955110000	18150	9152	5	0	\N
140630	2134	97438329000	18150	9152	6	0	\N
140631	2133	97529064000	18150	9152	7	0	\N
140632	2133	97528062000	18150	9152	8	0	\N
140633	2132	148610611000	18150	9152	9	0	\N
140634	2134	97437326000	18150	9152	10	0	\N
140635	2133	97527060000	18150	9152	11	0	\N
140636	2133	97526058000	18150	9152	12	0	\N
140637	2134	97436323000	18150	9152	14	0	\N
140638	2134	97435320000	18150	9152	15	0	\N
140639	2165	190000000	18151	9152	0	0	\N
140640	1397	1333969531000	18151	9152	1	0	\N
140641	1397	1333959530000	18151	9152	2	0	\N
140642	1397	1333949529000	18151	9152	3	0	\N
140643	1397	1333939528000	18151	9152	4	0	\N
140644	1726	105955110000	18151	9152	5	0	\N
140645	2134	97438329000	18151	9152	6	0	\N
140646	2133	97529064000	18151	9152	7	0	\N
140647	2133	97528062000	18151	9152	8	0	\N
140648	2132	148610611000	18151	9152	9	0	\N
140649	2134	97437326000	18151	9152	10	0	\N
140650	2133	97527060000	18151	9152	11	0	\N
140651	2133	97526058000	18151	9152	12	0	\N
140652	2134	97436323000	18151	9152	14	0	\N
140653	2134	97435320000	18151	9152	15	0	\N
140654	2165	190000000	18152	9152	0	0	\N
140655	1397	1333969531000	18152	9152	1	0	\N
140656	1397	1333959530000	18152	9152	2	0	\N
140657	1397	1333949529000	18152	9152	3	0	\N
140658	1397	1333939528000	18152	9152	4	0	\N
140659	1726	105955110000	18152	9152	5	0	\N
140660	2134	97438329000	18152	9152	6	0	\N
140661	2133	97529064000	18152	9152	7	0	\N
140662	2133	97528062000	18152	9152	8	0	\N
140663	2132	148610611000	18152	9152	9	0	\N
140664	2134	97437326000	18152	9152	10	0	\N
140665	2133	97527060000	18152	9152	11	0	\N
140666	2133	97526058000	18152	9152	12	0	\N
140667	2134	97436323000	18152	9152	14	0	\N
140668	2134	97435320000	18152	9152	15	0	\N
140669	1397	1334459580000	18153	9118	0	0	\N
140670	2165	190000000	18153	9118	1	0	\N
140671	1726	105955110000	18153	9118	2	0	\N
140672	1397	1334449579000	18153	9118	3	0	\N
140673	1397	1334439578000	18153	9118	4	0	\N
140674	1397	1334429577000	18153	9118	5	0	\N
140675	1397	1334419576000	18153	9118	6	0	\N
140676	1397	1334409575000	18153	9118	7	0	\N
140677	1397	1334399574000	18153	9118	8	0	\N
140678	1397	1334389573000	18153	9118	9	0	\N
140679	1397	1334379572000	18153	9118	10	0	\N
140680	1397	1334369571000	18153	9118	11	0	\N
140681	1397	1334359570000	18153	9118	12	0	\N
140682	1397	1334349569000	18153	9118	13	0	\N
140683	1397	1334339568000	18153	9118	14	0	\N
140684	1397	1334329567000	18153	9118	15	0	\N
140685	1397	1334319566000	18153	9118	16	0	\N
140686	1397	1334309565000	18153	9118	17	0	\N
140687	1397	1334299564000	18153	9118	18	0	\N
140688	1397	1334289563000	18153	9118	19	0	\N
140689	1397	1334279562000	18153	9118	20	0	\N
140690	1397	1334269561000	18153	9118	21	0	\N
140691	1397	1334259560000	18153	9118	22	0	\N
140692	1397	1334249559000	18153	9118	23	0	\N
140693	1397	1334239558000	18153	9118	24	0	\N
140694	1397	1334229557000	18153	9118	25	0	\N
140695	1397	1334219556000	18153	9118	26	0	\N
140696	1397	1334209555000	18153	9118	27	0	\N
140697	1397	1334199554000	18153	9118	28	0	\N
140698	1397	1334189553000	18153	9118	29	0	\N
140699	1397	1334179552000	18153	9118	30	0	\N
140700	1397	1334169551000	18153	9118	31	0	\N
140701	1397	1334159550000	18153	9118	32	0	\N
140702	1397	1334149549000	18153	9118	33	0	\N
140703	1397	1334139548000	18153	9118	34	0	\N
140704	1397	1334129547000	18153	9118	35	0	\N
140705	1397	1334119546000	18153	9118	36	0	\N
140706	1397	1334109545000	18153	9118	37	0	\N
140707	1397	1334099544000	18153	9118	38	0	\N
140708	1397	1334089543000	18153	9118	39	0	\N
140709	1397	1334079542000	18153	9118	40	0	\N
140710	1397	1334069541000	18153	9118	41	0	\N
140711	1397	1334059540000	18153	9118	42	0	\N
140712	1397	1334049539000	18153	9118	43	0	\N
140713	1397	1334039538000	18153	9118	44	0	\N
140714	1397	1334029537000	18153	9118	45	0	\N
140715	1397	1334019536000	18153	9118	46	0	\N
140716	1397	1334009535000	18153	9118	47	0	\N
140717	1397	1333999534000	18153	9118	48	0	\N
140718	1397	1333989533000	18153	9118	49	0	\N
140719	1397	1333979532000	18153	9118	50	0	\N
140720	1397	1333969531000	18153	9118	51	0	\N
140721	1397	1333959530000	18153	9118	52	0	\N
140722	1397	1333949529000	18153	9118	53	0	\N
140723	1397	1333939528000	18153	9118	54	0	\N
140724	2134	97484467000	18153	9118	55	0	\N
140725	2133	97530066000	18153	9118	56	0	\N
140726	2133	97529064000	18153	9118	57	0	\N
140727	2133	97528062000	18153	9118	58	0	\N
140728	2133	97527060000	18153	9118	59	0	\N
140729	2133	97526058000	18153	9118	60	0	\N
140730	2132	148625626000	18153	9118	61	0	\N
140731	2132	148624625000	18153	9118	62	0	\N
140732	2132	148623624000	18153	9118	64	0	\N
140733	2134	97483464000	18153	9118	65	0	\N
140734	2134	97482461000	18153	9118	66	0	\N
140735	2134	97481458000	18153	9118	67	0	\N
140736	2134	97480455000	18153	9118	68	0	\N
140737	2134	97479452000	18153	9118	69	0	\N
140738	2134	97478449000	18153	9118	70	0	\N
140739	2134	97477446000	18153	9118	71	0	\N
140740	2134	97476443000	18153	9118	72	0	\N
140741	2134	97475440000	18153	9118	73	0	\N
140742	2134	97474437000	18153	9118	74	0	\N
140743	2134	97473434000	18153	9118	75	0	\N
140744	2134	97472431000	18153	9118	76	0	\N
140745	2134	97471428000	18153	9118	77	0	\N
140746	2132	148622623000	18153	9118	78	0	\N
140747	2132	148621622000	18153	9118	79	0	\N
140748	2132	148620621000	18153	9118	80	0	\N
140749	2132	148619620000	18153	9118	81	0	\N
140750	2132	148618619000	18153	9118	82	0	\N
140751	2132	148617618000	18153	9118	83	0	\N
140752	2132	148616617000	18153	9118	84	0	\N
140753	2132	148615616000	18153	9118	85	0	\N
140754	2132	148614615000	18153	9118	86	0	\N
140755	2132	148613614000	18153	9118	87	0	\N
140756	2132	148612613000	18153	9118	88	0	\N
140757	2132	148611612000	18153	9118	89	0	\N
140758	2132	148610611000	18153	9118	90	0	\N
140759	2134	97470425000	18153	9118	91	0	\N
140760	2134	97469422000	18153	9118	92	0	\N
140761	2134	97468419000	18153	9118	93	0	\N
140762	2134	97467416000	18153	9118	94	0	\N
140763	2134	97466413000	18153	9118	95	0	\N
140764	2134	97465410000	18153	9118	96	0	\N
140765	2134	97464407000	18153	9118	97	0	\N
140766	2134	97463404000	18153	9118	98	0	\N
140767	2134	97462401000	18153	9118	99	0	\N
140768	2134	97461398000	18153	9118	100	0	\N
140769	2134	97460395000	18153	9118	101	0	\N
140770	2134	97459392000	18153	9118	102	0	\N
140771	2134	97458389000	18153	9118	103	0	\N
140772	2134	97457386000	18153	9118	104	0	\N
140773	2134	97456383000	18153	9118	105	0	\N
140774	2134	97455380000	18153	9118	106	0	\N
140775	2134	97454377000	18153	9118	107	0	\N
140776	2134	97453374000	18153	9118	108	0	\N
140777	2134	97452371000	18153	9118	109	0	\N
140778	2134	97451368000	18153	9118	110	0	\N
140779	2134	97450365000	18153	9118	111	0	\N
140780	2134	97449362000	18153	9118	112	0	\N
140781	2134	97448359000	18153	9118	113	0	\N
140782	2134	97447356000	18153	9118	114	0	\N
140783	2134	97446353000	18153	9118	115	0	\N
140784	2134	97445350000	18153	9118	116	0	\N
140785	2134	97444347000	18153	9118	117	0	\N
140786	2134	97443344000	18153	9118	118	0	\N
140787	2134	97442341000	18153	9118	119	0	\N
140788	2134	97441338000	18153	9118	120	0	\N
140789	2134	97440335000	18153	9118	121	0	\N
140790	2134	97439332000	18153	9118	122	0	\N
140791	2134	97438329000	18153	9118	123	0	\N
140792	2134	97437326000	18153	9118	124	0	\N
140793	2134	97436323000	18153	9118	125	0	\N
140809	2165	90000000	18155	9153	0	0	\N
140810	1397	1333929527000	18155	9153	1	0	\N
140811	1397	1333919526000	18155	9153	2	0	\N
140812	1397	1333909525000	18155	9153	3	0	\N
140813	1397	1333899524000	18155	9153	4	0	\N
140814	2132	148609610000	18155	9153	5	0	\N
140815	2134	97434317000	18155	9153	6	0	\N
140816	2134	97433314000	18155	9153	7	0	\N
140817	2134	97432311000	18155	9153	8	0	\N
140818	2134	97431308000	18155	9153	9	0	\N
140819	2133	97525056000	18155	9153	10	0	\N
140820	2133	97524054000	18155	9153	11	0	\N
140821	2133	97523052000	18155	9153	12	0	\N
140822	2133	97522050000	18155	9153	13	0	\N
140837	1397	1333889523000	18157	9154	0	0	\N
140838	1397	1333879522000	18157	9154	1	0	\N
140839	2134	97430305000	18157	9154	2	0	\N
140840	2134	97429302000	18157	9154	3	0	\N
140841	2133	97521048000	18157	9154	4	0	\N
140842	2133	97520046000	18157	9154	5	0	\N
140843	2132	148608609000	18157	9154	6	0	\N
140851	1397	1333889523000	18159	9154	0	0	\N
140852	1397	1333879522000	18159	9154	1	0	\N
140853	2134	97430305000	18159	9154	2	0	\N
140854	2134	97429302000	18159	9154	3	0	\N
140855	2133	97521048000	18159	9154	4	0	\N
140856	2133	97520046000	18159	9154	5	0	\N
140857	2132	148608609000	18159	9154	6	0	\N
140864	1397	1333849519000	18161	9156	0	0	\N
140865	2133	97517040000	18161	9156	1	0	\N
140866	2134	97426293000	18161	9156	2	0	\N
140867	2132	148607608000	18161	9156	3	0	\N
140872	1397	1333849519000	18163	9156	0	0	\N
140873	2133	97517040000	18163	9156	1	0	\N
140874	2134	97426293000	18163	9156	2	0	\N
140875	2132	148607608000	18163	9156	3	0	\N
140796	1397	1333959530000	18154	9152	2	0	10487
140797	1397	1333949529000	18154	9152	3	0	10488
140798	1397	1333939528000	18154	9152	4	0	10489
140799	1726	105955110000	18154	9152	5	0	8199
140800	2134	97438329000	18154	9152	6	0	1557
140802	2133	97528062000	18154	9152	8	0	1469
140803	2132	148610611000	18154	9152	9	0	389
140804	2134	97437326000	18154	9152	10	0	1558
140805	2133	97527060000	18154	9152	11	0	1470
140806	2133	97526058000	18154	9152	12	0	1471
140808	2134	97435320000	18154	9152	15	0	1560
140823	2165	90000000	18156	9153	0	0	2
140824	1397	1333929527000	18156	9153	1	0	10490
140825	1397	1333919526000	18156	9153	2	0	10491
140827	1397	1333899524000	18156	9153	4	0	10493
140828	2132	148609610000	18156	9153	5	0	390
140829	2134	97434317000	18156	9153	6	0	1561
140830	2134	97433314000	18156	9153	7	0	1562
140831	2134	97432311000	18156	9153	8	0	1563
140833	2133	97525056000	18156	9153	10	0	1472
140834	2133	97524054000	18156	9153	11	0	1473
140835	2133	97523052000	18156	9153	12	0	1474
140836	2133	97522050000	18156	9153	13	0	1475
140844	1397	1333889523000	18158	9154	0	0	10494
140846	2134	97430305000	18158	9154	2	0	1565
140847	2134	97429302000	18158	9154	3	0	1566
140848	2133	97521048000	18158	9154	4	0	1476
140849	2133	97520046000	18158	9154	5	0	1477
140858	1397	1333869521000	18160	9155	0	0	10496
140859	1397	1333859520000	18160	9155	1	0	10497
140860	2133	97519044000	18160	9155	2	0	1478
140861	2133	97518042000	18160	9155	3	0	1479
140862	2134	97428299000	18160	9155	4	0	1567
140868	1397	1333849519000	18162	9156	0	0	10498
140869	2133	97517040000	18162	9156	1	0	1480
140870	2134	97426293000	18162	9156	2	0	1569
140871	2132	148607608000	18162	9156	3	0	392
140876	1397	1333839518000	18164	9157	0	0	10499
140878	2165	70000000	18164	9157	2	0	4
140879	2165	60000000	18164	9157	3	0	5
140880	2165	50000000	18164	9157	4	0	6
140881	2133	97516038000	18164	9157	5	0	1481
140883	2134	97425290000	18165	9158	1	0	1570
140884	2133	97515036000	18165	9158	2	0	1482
140885	1397	1333819516000	18166	9159	0	0	10501
140886	2132	148606607000	18166	9159	1	0	393
140887	2134	97424287000	18166	9159	2	0	1571
140889	1397	1333809515000	18167	9160	0	0	10502
140890	2133	97513032000	18167	9160	1	0	1484
140891	2134	97423284000	18167	9160	2	0	1572
140892	1397	1333799514000	18168	9161	0	0	10503
140893	1397	1333789513000	18168	9161	1	0	10504
140895	2132	148605606000	18168	9161	3	0	394
140896	2134	97422281000	18168	9161	4	0	1573
140902	1397	1333769511000	18169	9162	0	0	\N
140903	2134	97419272000	18169	9162	1	0	\N
140904	2133	97509024000	18169	9162	2	0	\N
140914	1397	1333759510000	18172	9163	0	0	\N
140915	1397	1333749509000	18172	9163	1	0	\N
140916	2133	97508022000	18172	9163	2	0	\N
140917	2132	148604605000	18172	9163	3	0	\N
140918	2134	97418269000	18172	9163	4	0	\N
140919	2134	97417266000	18172	9163	5	0	\N
140924	1397	1333719506000	18174	9165	0	0	\N
140925	1397	1333709505000	18174	9165	1	0	\N
140926	2132	148603604000	18174	9165	2	0	\N
140927	2134	97414257000	18174	9165	3	0	\N
140928	2134	97413254000	18174	9165	4	0	\N
140945	1397	1333659500000	18178	9167	0	0	\N
140946	2134	97408239000	18178	9167	1	0	\N
140952	1397	1333649499000	18181	9168	0	0	\N
140953	2132	148601602000	18181	9168	1	0	\N
140954	2134	97407236000	18181	9168	2	0	\N
140955	1397	1333649499000	18182	9168	0	0	\N
140956	2132	148601602000	18182	9168	1	0	\N
140957	2134	97407236000	18182	9168	2	0	\N
140958	1397	1333639498000	18185	9170	0	0	\N
140959	1397	1333629497000	18185	9170	1	0	\N
140960	2134	97406233000	18185	9170	2	0	\N
140961	2132	148600601000	18185	9170	3	0	\N
140962	2134	97405230000	18185	9170	4	0	\N
140963	1397	1333639498000	18186	9170	0	0	\N
140964	1397	1333629497000	18186	9170	1	0	\N
140965	2134	97406233000	18186	9170	2	0	\N
140966	2132	148600601000	18186	9170	3	0	\N
140967	2134	97405230000	18186	9170	4	0	\N
140968	1397	1333639498000	18187	9170	0	0	\N
140969	1397	1333629497000	18187	9170	1	0	\N
140970	2134	97406233000	18187	9170	2	0	\N
140971	2132	148600601000	18187	9170	3	0	\N
140972	2134	97405230000	18187	9170	4	0	\N
140973	1397	1333639498000	18188	9170	0	0	\N
140974	1397	1333629497000	18188	9170	1	0	\N
140975	2134	97406233000	18188	9170	2	0	\N
140976	2132	148600601000	18188	9170	3	0	\N
140977	2134	97405230000	18188	9170	4	0	\N
140983	1397	1333639498000	18190	9170	0	0	\N
140984	1397	1333629497000	18190	9170	1	0	\N
140985	2134	97406233000	18190	9170	2	0	\N
140986	2132	148600601000	18190	9170	3	0	\N
140987	2134	97405230000	18190	9170	4	0	\N
140988	1397	1333639498000	18192	9170	0	0	\N
140989	1397	1333629497000	18192	9170	1	0	\N
140990	2134	97406233000	18192	9170	2	0	\N
140991	2132	148600601000	18192	9170	3	0	\N
140992	2134	97405230000	18192	9170	4	0	\N
140993	1397	1333639498000	18193	9170	0	0	\N
140994	1397	1333629497000	18193	9170	1	0	\N
140995	2134	97406233000	18193	9170	2	0	\N
140996	2132	148600601000	18193	9170	3	0	\N
140997	2134	97405230000	18193	9170	4	0	\N
140998	1397	1333639498000	18194	9170	0	0	\N
140999	1397	1333629497000	18194	9170	1	0	\N
141000	2134	97406233000	18194	9170	2	0	\N
141001	2132	148600601000	18194	9170	3	0	\N
141002	2134	97405230000	18194	9170	4	0	\N
141003	1397	1333639498000	18195	9170	0	0	\N
141004	1397	1333629497000	18195	9170	1	0	\N
141005	2134	97406233000	18195	9170	2	0	\N
141006	2132	148600601000	18195	9170	3	0	\N
141007	2134	97405230000	18195	9170	4	0	\N
141008	1397	1333639498000	18196	9170	0	0	\N
141009	1397	1333629497000	18196	9170	1	0	\N
141010	2134	97406233000	18196	9170	2	0	\N
141011	2132	148600601000	18196	9170	3	0	\N
141012	2134	97405230000	18196	9170	4	0	\N
141013	1397	1333619496000	18197	9171	0	0	\N
141014	2134	97404227000	18197	9171	1	0	\N
141015	1397	1333619496000	18198	9171	0	0	\N
141016	2134	97404227000	18198	9171	1	0	\N
141017	1397	1333619496000	18199	9171	0	0	\N
141018	1397	1333609495000	18199	9171	1	0	\N
141019	2134	97404227000	18199	9171	2	0	\N
141020	2134	97403224000	18199	9171	3	0	\N
141027	1397	1333619496000	18202	9171	0	0	\N
141028	1397	1333609495000	18202	9171	1	0	\N
141029	1397	1333599494000	18202	9171	2	0	\N
141030	2134	97404227000	18202	9171	3	0	\N
141031	2134	97403224000	18202	9171	4	0	\N
141032	2134	97402221000	18202	9171	5	0	\N
140899	2133	97510026000	18168	9161	7	0	1487
140900	2134	97421278000	18168	9161	8	0	1574
140901	2134	97420275000	18168	9161	9	0	1575
140905	1397	1333769511000	18170	9162	0	0	10506
140906	2134	97419272000	18170	9162	1	0	1576
140908	1397	1333759510000	18171	9163	0	0	10507
140909	1397	1333749509000	18171	9163	1	0	10508
140910	2133	97508022000	18171	9163	2	0	1489
140911	2132	148604605000	18171	9163	3	0	395
140912	2134	97418269000	18171	9163	4	0	1577
140920	1397	1333739508000	18173	9164	0	0	10509
140921	1397	1333729507000	18173	9164	1	0	10510
140922	2134	97416263000	18173	9164	2	0	1579
140923	2134	97415260000	18173	9164	3	0	1580
140930	1397	1333709505000	18175	9165	1	0	10512
140931	2132	148603604000	18175	9165	2	0	396
140932	2134	97414257000	18175	9165	3	0	1581
140933	2134	97413254000	18175	9165	4	0	1582
140934	2165	40000000	18176	9166	0	0	7
140936	1397	1333699504000	18176	9166	2	0	10513
140937	1397	1333689503000	18176	9166	3	0	10514
140938	1397	1333679502000	18176	9166	4	0	10515
140939	1397	1333669501000	18176	9166	5	0	10516
140940	2132	148602603000	18176	9166	6	0	397
140942	2134	97411248000	18176	9166	8	0	1584
140943	2134	97410245000	18176	9166	9	0	1585
140944	2134	97409242000	18176	9166	10	0	1586
140947	1397	1333659500000	18179	9167	0	0	10517
140949	1397	1333649499000	18180	9168	0	0	10518
140950	2132	148601602000	18180	9168	1	0	398
140951	2134	97407236000	18180	9168	2	0	1588
140978	1397	1333639498000	18189	9170	0	0	10519
140979	1397	1333629497000	18189	9170	1	0	10520
140981	2132	148600601000	18189	9170	3	0	399
140982	2134	97405230000	18189	9170	4	0	1590
141021	1397	1333619496000	18200	9171	0	0	10521
141022	1397	1333609495000	18200	9171	1	0	10522
141023	2134	97404227000	18200	9171	2	0	1591
141025	1397	1333599494000	18201	9172	0	0	10523
141026	2134	97402221000	18201	9172	1	0	1593
141033	1397	1333589493000	18203	9173	0	0	\N
141034	1740	15765332000000	18203	9173	1	0	\N
141035	1899	1997000000	18203	9173	2	0	\N
141036	563	66000615000000	18203	9173	3	0	\N
141037	2134	97401218000	18203	9173	4	0	\N
141038	2132	148599600000	18203	9173	5	0	\N
141039	1397	1333589493000	18204	9173	0	0	\N
141040	1740	15765332000000	18204	9173	1	0	\N
141041	1899	1997000000	18204	9173	2	0	\N
141042	563	66000615000000	18204	9173	3	0	\N
141043	2134	97401218000	18204	9173	4	0	\N
141044	2132	148599600000	18204	9173	5	0	\N
141051	1397	1333589493000	18206	9173	0	0	\N
141052	1740	15765332000000	18206	9173	1	0	\N
141053	1899	1997000000	18206	9173	2	0	\N
141054	563	66000615000000	18206	9173	3	0	\N
141055	2134	97401218000	18206	9173	4	0	\N
141056	2132	148599600000	18206	9173	5	0	\N
141058	1397	1333579492000	18209	9174	0	0	\N
141059	1397	1333569491000	18209	9174	1	0	\N
141060	2134	97400215000	18209	9174	2	0	\N
141061	1397	1333579492000	18210	9174	0	0	\N
141062	1397	1333569491000	18210	9174	1	0	\N
141063	2134	97400215000	18210	9174	2	0	\N
141074	1397	1333579492000	18212	9175	0	0	\N
141075	1397	1333569491000	18212	9175	1	0	\N
141076	2157	198000000	18212	9175	2	0	\N
141077	1397	1333579492000	18213	9175	0	0	\N
141078	1397	1333569491000	18213	9175	1	0	\N
141079	1397	1333559490000	18213	9175	2	0	\N
141080	1397	1333549489000	18213	9175	3	0	\N
141081	1397	1333539488000	18213	9175	4	0	\N
141082	2132	148598599000	18213	9175	5	0	\N
141083	2134	97399212000	18213	9175	6	0	\N
141084	2134	97398209000	18213	9175	7	0	\N
141085	2134	97397206000	18213	9175	8	0	\N
141086	2157	198000000	18213	9175	9	0	\N
141087	1397	1333529487000	18214	9176	0	0	\N
141088	2132	148597598000	18214	9176	1	0	\N
141089	2157	197000000	18214	9176	2	0	\N
141090	2134	97396203000	18214	9176	3	0	\N
141095	1397	1333529487000	18216	9176	0	0	\N
141096	2132	148597598000	18216	9176	1	0	\N
141097	2157	197000000	18216	9176	2	0	\N
141098	2134	97396203000	18216	9176	3	0	\N
141099	1397	1333519486000	18218	9177	0	0	\N
141100	2134	97395200000	18218	9177	1	0	\N
141101	2157	196000000	18218	9177	2	0	\N
141102	2157	195000000	18218	9177	3	0	\N
141103	2157	194000000	18218	9177	4	0	\N
141109	1397	1333509485000	18220	9178	0	0	\N
141110	2134	97394197000	18220	9178	1	0	\N
141113	397	66612728193897	18222	9000	0	0	\N
141114	397	66000718193897	18222	9000	1	0	\N
141115	2139	190000000	18222	9000	2	0	\N
141116	397	66000708193897	18222	9000	3	0	\N
141117	2165	190000000	18222	9000	4	0	\N
141118	1726	105955110000	18222	9000	5	0	\N
141119	1740	15045310000000	18222	9000	6	0	\N
141120	1899	1997000000	18222	9000	7	0	\N
141121	563	66000615000000	18222	9000	8	0	\N
141122	2157	198000000	18222	9000	9	0	\N
141123	2157	197000000	18222	9000	10	0	\N
141124	2157	196000000	18222	9000	11	0	\N
141125	2157	195000000	18222	9000	12	0	\N
141126	2157	194000000	18222	9000	13	0	\N
141127	1397	1334269561000	18223	9129	0	0	\N
141128	2165	190000000	18223	9129	1	0	\N
141129	1726	105955110000	18223	9129	2	0	\N
141130	1397	1334259560000	18223	9129	3	0	\N
141131	1397	1334249559000	18223	9129	4	0	\N
141132	1397	1334239558000	18223	9129	5	0	\N
141133	1397	1334229557000	18223	9129	6	0	\N
141134	1397	1334219556000	18223	9129	7	0	\N
141135	1397	1334209555000	18223	9129	8	0	\N
141136	1397	1334199554000	18223	9129	9	0	\N
141137	1397	1334189553000	18223	9129	10	0	\N
141138	1397	1334179552000	18223	9129	11	0	\N
141139	1397	1334169551000	18223	9129	12	0	\N
141140	1397	1334159550000	18223	9129	13	0	\N
141141	1397	1334149549000	18223	9129	14	0	\N
141142	1397	1334139548000	18223	9129	15	0	\N
141143	1397	1334129547000	18223	9129	16	0	\N
141144	1397	1334119546000	18223	9129	17	0	\N
141145	1397	1334109545000	18223	9129	18	0	\N
141146	1397	1334099544000	18223	9129	19	0	\N
141147	1397	1334089543000	18223	9129	20	0	\N
141148	1397	1334079542000	18223	9129	21	0	\N
141149	1397	1334069541000	18223	9129	22	0	\N
141150	1397	1334059540000	18223	9129	23	0	\N
141151	1397	1334049539000	18223	9129	24	0	\N
141152	1397	1334039538000	18223	9129	25	0	\N
141153	1397	1334029537000	18223	9129	26	0	\N
141154	1397	1334019536000	18223	9129	27	0	\N
141155	1397	1334009535000	18223	9129	28	0	\N
141156	1397	1333999534000	18223	9129	29	0	\N
141157	1397	1333989533000	18223	9129	30	0	\N
141158	1397	1333979532000	18223	9129	31	0	\N
141159	1397	1333969531000	18223	9129	32	0	\N
141160	1397	1333959530000	18223	9129	33	0	\N
141161	1397	1333949529000	18223	9129	34	0	\N
141162	1397	1333939528000	18223	9129	35	0	\N
141163	1397	1333929527000	18223	9129	36	0	\N
141164	1397	1333919526000	18223	9129	37	0	\N
141165	1397	1333909525000	18223	9129	38	0	\N
141166	1397	1333899524000	18223	9129	39	0	\N
141167	1397	1333889523000	18223	9129	40	0	\N
141168	1397	1333879522000	18223	9129	41	0	\N
141047	1899	1997000000	18205	9173	2	0	2
141048	563	66000615000000	18205	9173	3	0	11
141049	2134	97401218000	18205	9173	4	0	1594
141050	2132	148599600000	18205	9173	5	0	400
141057	2134	97400215000	18208	9174	0	0	1595
141065	1397	1333569491000	18211	9175	1	0	10526
141066	1397	1333559490000	18211	9175	2	0	10527
141067	1397	1333549489000	18211	9175	3	0	10528
141068	1397	1333539488000	18211	9175	4	0	10529
141069	2132	148598599000	18211	9175	5	0	401
141071	2134	97398209000	18211	9175	7	0	1597
141072	2134	97397206000	18211	9175	8	0	1598
141073	2157	198000000	18211	9175	9	0	2
141091	1397	1333529487000	18215	9176	0	0	10530
141093	2157	197000000	18215	9176	2	0	3
141094	2134	97396203000	18215	9176	3	0	1599
141104	1397	1333519486000	18219	9177	0	0	10531
141105	2134	97395200000	18219	9177	1	0	1600
141106	2157	196000000	18219	9177	2	0	4
141108	2157	194000000	18219	9177	4	0	6
141111	1397	1333509485000	18221	9178	0	0	10532
141112	2134	97394197000	18221	9178	1	0	1601
141169	1397	1333869521000	18223	9129	42	0	\N
141170	1397	1333859520000	18223	9129	43	0	\N
141171	1397	1333849519000	18223	9129	44	0	\N
141172	1397	1333839518000	18223	9129	45	0	\N
141173	1397	1333829517000	18223	9129	46	0	\N
141174	1397	1333819516000	18223	9129	47	0	\N
141175	1397	1333809515000	18223	9129	48	0	\N
141176	1397	1333799514000	18223	9129	49	0	\N
141177	1397	1333789513000	18223	9129	50	0	\N
141178	1397	1333779512000	18223	9129	51	0	\N
141179	1397	1333769511000	18223	9129	52	0	\N
141180	1397	1333759510000	18223	9129	53	0	\N
141181	1397	1333749509000	18223	9129	54	0	\N
141182	1397	1333739508000	18223	9129	55	0	\N
141183	1397	1333729507000	18223	9129	56	0	\N
141184	1397	1333719506000	18223	9129	57	0	\N
141185	1397	1333709505000	18223	9129	58	0	\N
141186	1397	1333699504000	18223	9129	59	0	\N
141195	1397	1333479482000	18226	9180	0	0	\N
141196	2134	97391188000	18226	9180	1	0	\N
141197	2157	191000000	18226	9180	2	0	\N
141198	2165	190000000	18227	9152	0	0	\N
141199	1397	1333969531000	18227	9152	1	0	\N
141200	1397	1333959530000	18227	9152	2	0	\N
141201	1397	1333949529000	18227	9152	3	0	\N
141202	1397	1333939528000	18227	9152	4	0	\N
141203	1726	105955110000	18227	9152	5	0	\N
141204	1397	1333929527000	18227	9152	6	0	\N
141205	1397	1333919526000	18227	9152	7	0	\N
141206	1397	1333909525000	18227	9152	8	0	\N
141207	1397	1333899524000	18227	9152	9	0	\N
141208	1397	1333889523000	18227	9152	10	0	\N
141209	1397	1333879522000	18227	9152	11	0	\N
141210	1397	1333869521000	18227	9152	12	0	\N
141211	1397	1333859520000	18227	9152	14	0	\N
141212	1397	1333849519000	18227	9152	15	0	\N
141213	1397	1333839518000	18227	9152	16	0	\N
141214	1397	1333829517000	18227	9152	17	0	\N
141215	1397	1333819516000	18227	9152	18	0	\N
141216	1397	1333809515000	18227	9152	19	0	\N
141217	1397	1333799514000	18227	9152	20	0	\N
141218	1397	1333789513000	18227	9152	21	0	\N
141219	1397	1333779512000	18227	9152	22	0	\N
141220	1397	1333769511000	18227	9152	23	0	\N
141221	1397	1333759510000	18227	9152	24	0	\N
141222	1397	1333749509000	18227	9152	25	0	\N
141223	1397	1333739508000	18227	9152	26	0	\N
141224	1397	1333729507000	18227	9152	27	0	\N
141225	1397	1333719506000	18227	9152	28	0	\N
141226	1397	1333709505000	18227	9152	29	0	\N
141227	1397	1333699504000	18227	9152	30	0	\N
141228	1397	1333689503000	18227	9152	31	0	\N
141229	1397	1333679502000	18227	9152	32	0	\N
141230	1397	1333669501000	18227	9152	33	0	\N
141231	1397	1333659500000	18227	9152	34	0	\N
141232	1397	1333649499000	18227	9152	35	0	\N
141233	1397	1333639498000	18227	9152	36	0	\N
141234	1397	1333629497000	18227	9152	37	0	\N
141235	1397	1333619496000	18227	9152	38	0	\N
141236	1397	1333609495000	18227	9152	39	0	\N
141237	1397	1333599494000	18227	9152	40	0	\N
141238	1397	1333589493000	18227	9152	41	0	\N
141239	1397	1333579492000	18227	9152	42	0	\N
141240	1397	1333569491000	18227	9152	43	0	\N
141241	1397	1333559490000	18227	9152	44	0	\N
141242	1397	1333549489000	18227	9152	45	0	\N
141243	1397	1333539488000	18227	9152	46	0	\N
141244	1397	1333529487000	18227	9152	47	0	\N
141245	1397	1333519486000	18227	9152	48	0	\N
141246	1397	1333509485000	18227	9152	49	0	\N
141247	1397	1333499484000	18227	9152	50	0	\N
141248	1397	1333489483000	18227	9152	51	0	\N
141249	1397	1333479482000	18227	9152	52	0	\N
141250	1740	15765332000000	18227	9152	53	0	\N
141251	1899	1997000000	18227	9152	54	0	\N
141252	563	66000615000000	18227	9152	55	0	\N
141253	2134	97438329000	18227	9152	56	0	\N
141254	2133	97529064000	18227	9152	57	0	\N
141255	2133	97528062000	18227	9152	58	0	\N
141256	2132	148610611000	18227	9152	59	0	\N
141257	2132	148609610000	18227	9152	60	0	\N
141258	2134	97437326000	18227	9152	61	0	\N
141259	2133	97527060000	18227	9152	62	0	\N
141260	2133	97526058000	18227	9152	63	0	\N
141261	2133	97525056000	18227	9152	64	0	\N
141262	2133	97524054000	18227	9152	65	0	\N
141263	2134	97436323000	18227	9152	66	0	\N
141264	2134	97435320000	18227	9152	67	0	\N
141265	2134	97434317000	18227	9152	68	0	\N
141266	2134	97433314000	18227	9152	69	0	\N
141267	2134	97432311000	18227	9152	70	0	\N
141268	2134	97431308000	18227	9152	71	0	\N
141269	2134	97430305000	18227	9152	72	0	\N
141270	2134	97429302000	18227	9152	73	0	\N
141271	2134	97428299000	18227	9152	74	0	\N
141272	2134	97427296000	18227	9152	75	0	\N
141273	2134	97426293000	18227	9152	76	0	\N
141274	2134	97425290000	18227	9152	77	0	\N
141275	2134	97424287000	18227	9152	78	0	\N
141276	2133	97523052000	18227	9152	79	0	\N
141277	2133	97522050000	18227	9152	80	0	\N
141278	2133	97521048000	18227	9152	81	0	\N
141279	2133	97520046000	18227	9152	82	0	\N
141280	2133	97519044000	18227	9152	83	0	\N
141281	2133	97518042000	18227	9152	84	0	\N
141282	2133	97517040000	18227	9152	85	0	\N
141283	2133	97516038000	18227	9152	86	0	\N
141284	2133	97515036000	18227	9152	87	0	\N
141285	2132	148608609000	18227	9152	88	0	\N
141286	2132	148607608000	18227	9152	89	0	\N
141287	2132	148606607000	18227	9152	90	0	\N
141288	2132	148605606000	18227	9152	91	0	\N
141289	2132	148604605000	18227	9152	92	0	\N
141290	2132	148603604000	18227	9152	93	0	\N
141291	2132	148602603000	18227	9152	94	0	\N
141292	2132	148601602000	18227	9152	95	0	\N
141293	2132	148600601000	18227	9152	96	0	\N
141294	2132	148599600000	18227	9152	97	0	\N
141295	2132	148598599000	18227	9152	98	0	\N
141296	2132	148597598000	18227	9152	99	0	\N
141297	2132	148596597000	18227	9152	100	0	\N
141298	2133	97514034000	18227	9152	101	0	\N
141299	2133	97513032000	18227	9152	102	0	\N
141300	2133	97512030000	18227	9152	103	0	\N
141301	2133	97511028000	18227	9152	104	0	\N
141302	2133	97510026000	18227	9152	105	0	\N
141303	2133	97509024000	18227	9152	106	0	\N
141304	2133	97508022000	18227	9152	107	0	\N
141189	2132	148596597000	18224	9179	2	0	403
141190	2134	97393194000	18224	9179	3	0	1602
141191	2134	97392191000	18224	9179	4	0	1603
141192	1397	1333479482000	18225	9180	0	0	10535
141193	2134	97391188000	18225	9180	1	0	1604
141305	2134	97423284000	18227	9152	108	0	\N
141306	2134	97422281000	18227	9152	109	0	\N
141307	2134	97421278000	18227	9152	110	0	\N
141308	2134	97420275000	18227	9152	111	0	\N
141309	2134	97419272000	18227	9152	112	0	\N
141310	2134	97418269000	18227	9152	113	0	\N
141311	2134	97417266000	18227	9152	114	0	\N
141312	2134	97416263000	18227	9152	115	0	\N
141313	2134	97415260000	18227	9152	116	0	\N
141314	2157	198000000	18227	9152	117	0	\N
141315	2157	197000000	18227	9152	118	0	\N
141316	2157	196000000	18227	9152	119	0	\N
141317	2157	195000000	18227	9152	120	0	\N
141318	2157	194000000	18227	9152	121	0	\N
141319	2157	191000000	18227	9152	122	0	\N
141320	2134	97414257000	18227	9152	123	0	\N
141321	2134	97413254000	18227	9152	124	0	\N
141322	2134	97412251000	18227	9152	125	0	\N
141332	1397	1333439478000	18231	9184	0	0	\N
141333	2134	97387176000	18231	9184	1	0	\N
141336	1397	1333869521000	18233	9155	0	0	\N
141337	2165	80000000	18233	9155	1	0	\N
141338	2165	70000000	18233	9155	2	0	\N
141339	2165	60000000	18233	9155	3	0	\N
141340	2165	50000000	18233	9155	4	0	\N
141341	1397	1333859520000	18233	9155	5	0	\N
141342	1397	1333849519000	18233	9155	6	0	\N
141343	1397	1333839518000	18233	9155	7	0	\N
141344	1397	1333829517000	18233	9155	8	0	\N
141345	1397	1333819516000	18233	9155	9	0	\N
141346	1397	1333809515000	18233	9155	10	0	\N
141347	1397	1333799514000	18233	9155	11	0	\N
141348	1397	1333789513000	18233	9155	12	0	\N
141349	1397	1333779512000	18233	9155	13	0	\N
141350	1397	1333769511000	18233	9155	14	0	\N
141351	1397	1333759510000	18233	9155	15	0	\N
141352	1397	1333749509000	18233	9155	16	0	\N
141353	1397	1333739508000	18233	9155	17	0	\N
141354	1397	1333729507000	18233	9155	18	0	\N
141355	1397	1333719506000	18233	9155	19	0	\N
141356	1397	1333709505000	18233	9155	20	0	\N
141357	1397	1333699504000	18233	9155	21	0	\N
141358	1397	1333689503000	18233	9155	22	0	\N
141359	1397	1333679502000	18233	9155	23	0	\N
141360	1397	1333669501000	18233	9155	24	0	\N
141361	1397	1333659500000	18233	9155	25	0	\N
141362	1397	1333649499000	18233	9155	26	0	\N
141363	1397	1333639498000	18233	9155	27	0	\N
141364	1397	1333629497000	18233	9155	28	0	\N
141365	1397	1333619496000	18233	9155	29	0	\N
141366	1397	1333609495000	18233	9155	30	0	\N
141367	1397	1333599494000	18233	9155	31	0	\N
141368	1397	1333589493000	18233	9155	32	0	\N
141369	1397	1333579492000	18233	9155	33	0	\N
141370	1397	1333569491000	18233	9155	34	0	\N
141371	1397	1333559490000	18233	9155	35	0	\N
141372	1397	1333549489000	18233	9155	36	0	\N
141373	1397	1333539488000	18233	9155	37	0	\N
141374	1397	1333529487000	18233	9155	38	0	\N
141375	1397	1333519486000	18233	9155	39	0	\N
141376	1397	1333509485000	18233	9155	40	0	\N
141377	1397	1333499484000	18233	9155	41	0	\N
141378	1397	1333489483000	18233	9155	42	0	\N
141379	1397	1333479482000	18233	9155	43	0	\N
141380	1397	1333469481000	18233	9155	44	0	\N
141381	1397	1333459480000	18233	9155	45	0	\N
141382	1397	1333449479000	18233	9155	46	0	\N
141383	1397	1333439478000	18233	9155	47	0	\N
141384	1740	15765332000000	18233	9155	48	0	\N
141385	1899	1997000000	18233	9155	49	0	\N
141386	563	66000615000000	18233	9155	50	0	\N
141387	2133	97519044000	18233	9155	51	0	\N
141388	2133	97518042000	18233	9155	52	0	\N
141389	2133	97517040000	18233	9155	53	0	\N
141390	2133	97516038000	18233	9155	54	0	\N
141391	2133	97515036000	18233	9155	55	0	\N
141392	2132	148607608000	18233	9155	56	0	\N
141393	2132	148606607000	18233	9155	57	0	\N
141394	2132	148605606000	18233	9155	58	0	\N
141395	2132	148604605000	18233	9155	59	0	\N
141396	2132	148603604000	18233	9155	60	0	\N
141397	2132	148602603000	18233	9155	61	0	\N
141398	2132	148601602000	18233	9155	62	0	\N
141399	2132	148600601000	18233	9155	63	0	\N
141400	2132	148599600000	18233	9155	64	0	\N
141401	2132	148598599000	18233	9155	65	0	\N
141402	2132	148597598000	18233	9155	66	0	\N
141403	2132	148596597000	18233	9155	67	0	\N
141404	2133	97514034000	18233	9155	68	0	\N
141405	2133	97513032000	18233	9155	69	0	\N
141406	2133	97512030000	18233	9155	70	0	\N
141407	2133	97511028000	18233	9155	71	0	\N
141408	2133	97510026000	18233	9155	72	0	\N
141409	2133	97509024000	18233	9155	73	0	\N
141410	2133	97508022000	18233	9155	74	0	\N
141411	2132	148595596000	18233	9155	75	0	\N
141412	2157	198000000	18233	9155	76	0	\N
141413	2157	197000000	18233	9155	77	0	\N
141414	2157	196000000	18233	9155	78	0	\N
141415	2157	195000000	18233	9155	79	0	\N
141416	2157	194000000	18233	9155	80	0	\N
141417	2157	191000000	18233	9155	81	0	\N
141418	2157	189960000	18233	9155	82	0	\N
141419	2157	188957000	18233	9155	83	0	\N
141422	2134	97386173000	18235	9186	0	0	\N
141423	1397	1333419476000	18236	9186	0	0	\N
141424	2134	97386173000	18236	9186	1	0	\N
141427	1397	1333409475000	18238	9187	0	0	\N
141428	2134	97385170000	18238	9187	1	0	\N
141431	1397	1333409475000	18240	9187	0	0	\N
141432	2134	97385170000	18240	9187	1	0	\N
141433	1397	1333399474000	18241	9188	0	0	\N
141434	1397	1333389473000	18241	9188	1	0	\N
141435	2132	148593594000	18241	9188	2	0	\N
141436	2134	97384167000	18241	9188	3	0	\N
141437	2134	97383164000	18241	9188	4	0	\N
141325	2157	188957000	18228	9181	2	0	9
141326	2134	97390185000	18228	9181	3	0	1605
141327	1397	1333459480000	18229	9182	0	0	10537
141328	2134	97389182000	18229	9182	1	0	1606
141329	2132	148595596000	18229	9182	2	0	404
141331	2134	97388179000	18230	9183	1	0	1607
141334	1397	1333439478000	18232	9184	0	0	10539
141335	2134	97387176000	18232	9184	1	0	1608
141420	1397	1333429477000	18234	9185	0	0	10540
141421	2132	148594595000	18234	9185	1	0	405
141426	2134	97386173000	18237	9186	1	0	1609
141429	1397	1333409475000	18239	9187	0	0	10542
141430	2134	97385170000	18239	9187	1	0	1610
141438	1397	1333399474000	18242	9188	0	0	10543
141440	2132	148593594000	18242	9188	2	0	406
141443	1397	1333399474000	18243	9188	0	0	\N
141444	1397	1333389473000	18243	9188	1	0	\N
141445	2132	148593594000	18243	9188	2	0	\N
141446	2134	97384167000	18243	9188	3	0	\N
141447	2134	97383164000	18243	9188	4	0	\N
141448	1397	1333379472000	18244	9189	0	0	\N
141449	2134	97382161000	18244	9189	1	0	\N
141464	1397	1333319466000	18249	9193	0	0	\N
141465	2134	97376143000	18249	9193	1	0	\N
141466	1397	1333429477000	18250	9185	0	0	\N
141467	1397	1333419476000	18250	9185	1	0	\N
141468	1397	1333409475000	18250	9185	2	0	\N
141469	1397	1333399474000	18250	9185	3	0	\N
141470	1397	1333389473000	18250	9185	4	0	\N
141471	1397	1333379472000	18250	9185	5	0	\N
141472	1397	1333369471000	18250	9185	6	0	\N
141473	1397	1333359470000	18250	9185	7	0	\N
141474	1397	1333349469000	18250	9185	8	0	\N
141475	1397	1333339468000	18250	9185	9	0	\N
141476	1397	1333329467000	18250	9185	10	0	\N
141477	1397	1333319466000	18250	9185	11	0	\N
141478	2134	97386173000	18250	9185	12	0	\N
141479	2132	148594595000	18250	9185	13	0	\N
141480	2132	148593594000	18250	9185	14	0	\N
141481	2132	148592593000	18250	9185	15	0	\N
141482	2132	148591592000	18250	9185	16	0	\N
141483	2134	97385170000	18250	9185	17	0	\N
141484	2134	97384167000	18250	9185	18	0	\N
141485	2134	97383164000	18250	9185	19	0	\N
141486	2134	97382161000	18250	9185	20	0	\N
141487	2134	97381158000	18250	9185	21	0	\N
141488	2134	97380155000	18250	9185	22	0	\N
141489	2134	97379152000	18250	9185	23	0	\N
141490	2134	97378149000	18250	9185	24	0	\N
141491	2134	97377146000	18250	9185	25	0	\N
141492	2134	97376143000	18250	9185	26	0	\N
141493	1397	1333319466000	18251	9193	0	0	\N
141494	2134	97376143000	18251	9193	1	0	\N
141497	1397	1333319466000	18253	9193	0	0	\N
141498	2134	97376143000	18253	9193	1	0	\N
141503	1397	1333309465000	18256	9194	0	0	\N
141504	1397	1333299464000	18256	9194	1	0	\N
141505	2134	97375140000	18256	9194	2	0	\N
141506	2134	97374137000	18256	9194	3	0	\N
141507	2132	148590591000	18257	9196	0	0	\N
141511	1397	1333289463000	18259	9196	0	0	\N
141512	2132	148590591000	18259	9196	1	0	\N
141513	2134	97373134000	18259	9196	2	0	\N
141514	1397	1333289463000	18260	9196	0	0	\N
141515	2132	148590591000	18260	9196	1	0	\N
141516	2134	97373134000	18260	9196	2	0	\N
141528	1397	1333239458000	18265	9200	0	0	\N
141529	2134	97368119000	18265	9200	1	0	\N
141533	1397	1333219456000	18267	9202	0	0	\N
141534	2134	97366113000	18267	9202	1	0	\N
141545	1397	1333169451000	18272	9206	0	0	\N
141546	1397	1333159450000	18272	9206	1	0	\N
141547	2134	97362101000	18272	9206	2	0	\N
141548	2134	97361098000	18272	9206	3	0	\N
141549	2132	148586587000	18272	9206	4	0	\N
141550	1397	1333169451000	18273	9206	0	0	\N
141551	1397	1333159450000	18273	9206	1	0	\N
141552	2134	97362101000	18273	9206	2	0	\N
141553	2134	97361098000	18273	9206	3	0	\N
141554	2132	148586587000	18273	9206	4	0	\N
141567	1397	1333119446000	18277	9209	0	0	\N
141568	2134	97357086000	18277	9209	1	0	\N
141569	1397	1333119446000	18278	9209	0	0	\N
141570	2134	97357086000	18278	9209	1	0	\N
141450	1397	1333379472000	18245	9189	0	0	10545
141451	2134	97382161000	18245	9189	1	0	1613
141452	1397	1333369471000	18246	9190	0	0	10546
141453	2134	97381158000	18246	9190	1	0	1614
141454	1397	1333359470000	18247	9191	0	0	10547
141456	1397	1333339468000	18247	9191	2	0	10549
141457	2132	148592593000	18247	9191	3	0	407
141458	2134	97380155000	18247	9191	4	0	1615
141459	2134	97379152000	18247	9191	5	0	1616
141460	2134	97378149000	18247	9191	6	0	1617
141462	2132	148591592000	18248	9192	1	0	408
141463	2134	97377146000	18248	9192	2	0	1618
141495	1397	1333319466000	18252	9193	0	0	10551
141496	2134	97376143000	18252	9193	1	0	1619
141500	2134	97375140000	18254	9194	1	0	1620
141501	1397	1333299464000	18255	9195	0	0	10553
141502	2134	97374137000	18255	9195	1	0	1621
141508	1397	1333289463000	18258	9196	0	0	10554
141509	2132	148590591000	18258	9196	1	0	409
141517	1397	1333279462000	18261	9197	0	0	10555
141518	2134	97372131000	18261	9197	1	0	1623
141519	1397	1333269461000	18262	9198	0	0	10556
141520	2134	97371128000	18262	9198	1	0	1624
141521	1397	1333259460000	18263	9199	0	0	10557
141523	2132	148589590000	18263	9199	2	0	410
141524	2134	97370125000	18263	9199	3	0	1625
141525	2134	97369122000	18263	9199	4	0	1626
141526	1397	1333239458000	18264	9200	0	0	10559
141530	1397	1333229457000	18266	9201	0	0	10560
141531	2134	97367116000	18266	9201	1	0	1628
141532	2132	148588589000	18266	9201	2	0	411
141535	1397	1333219456000	18268	9202	0	0	10561
141536	2134	97366113000	18268	9202	1	0	1629
141538	1397	1333199454000	18270	9204	0	0	10563
141539	2134	97365110000	18270	9204	1	0	1630
141540	1397	1333189453000	18271	9205	0	0	10564
141541	1397	1333179452000	18271	9205	1	0	10565
141542	2132	148587588000	18271	9205	2	0	412
141544	2134	97363104000	18271	9205	4	0	1632
141555	1397	1333169451000	18274	9206	0	0	10566
141556	1397	1333159450000	18274	9206	1	0	10567
141557	2134	97362101000	18274	9206	2	0	1633
141559	2132	148586587000	18274	9206	4	0	413
141560	1397	1333149449000	18275	9207	0	0	10568
141561	1397	1333139448000	18275	9207	1	0	10569
141562	2134	97360095000	18275	9207	2	0	1635
141563	2134	97359092000	18275	9207	3	0	1636
141565	2134	97358089000	18276	9208	1	0	1637
141566	2132	148585586000	18276	9208	2	0	414
141571	1397	1333119446000	18279	9209	0	0	10571
141572	2134	97357086000	18279	9209	1	0	1638
141573	1397	1333109445000	18280	9210	0	0	10572
141575	1397	1333099444000	18281	9211	0	0	10573
141576	2134	97355080000	18281	9211	1	0	1640
141584	1397	1333409475000	18284	9187	0	0	\N
141585	1397	1333399474000	18284	9187	1	0	\N
141586	1397	1333389473000	18284	9187	2	0	\N
141587	1397	1333379472000	18284	9187	3	0	\N
141588	1397	1333369471000	18284	9187	4	0	\N
141589	1397	1333359470000	18284	9187	5	0	\N
141590	1397	1333349469000	18284	9187	6	0	\N
141591	1397	1333339468000	18284	9187	7	0	\N
141592	1397	1333329467000	18284	9187	8	0	\N
141593	1397	1333319466000	18284	9187	9	0	\N
141594	1397	1333309465000	18284	9187	10	0	\N
141595	1397	1333299464000	18284	9187	11	0	\N
141596	1397	1333289463000	18284	9187	12	0	\N
141597	1397	1333279462000	18284	9187	13	0	\N
141598	1397	1333269461000	18284	9187	14	0	\N
141599	1397	1333259460000	18284	9187	15	0	\N
141600	1397	1333249459000	18284	9187	16	0	\N
141601	1397	1333239458000	18284	9187	17	0	\N
141602	1397	1333229457000	18284	9187	18	0	\N
141603	1397	1333219456000	18284	9187	19	0	\N
141604	1397	1333209455000	18284	9187	20	0	\N
141605	1397	1333199454000	18284	9187	21	0	\N
141606	1397	1333189453000	18284	9187	22	0	\N
141607	1397	1333179452000	18284	9187	23	0	\N
141608	1397	1333169451000	18284	9187	24	0	\N
141609	1397	1333159450000	18284	9187	25	0	\N
141610	1397	1333149449000	18284	9187	26	0	\N
141611	1397	1333139448000	18284	9187	27	0	\N
141612	1397	1333129447000	18284	9187	28	0	\N
141613	1397	1333119446000	18284	9187	29	0	\N
141614	1397	1333109445000	18284	9187	30	0	\N
141615	1397	1333099444000	18284	9187	32	0	\N
141616	1397	1333089443000	18284	9187	33	0	\N
141617	1397	1333079442000	18284	9187	34	0	\N
141618	1397	1333069441000	18284	9187	35	0	\N
141619	2132	148593594000	18284	9187	36	0	\N
141620	2132	148592593000	18284	9187	37	0	\N
141621	2132	148591592000	18284	9187	38	0	\N
141622	2132	148590591000	18284	9187	39	0	\N
141623	2132	148589590000	18284	9187	40	0	\N
141624	2132	148588589000	18284	9187	41	0	\N
141625	2132	148587588000	18284	9187	42	0	\N
141626	2132	148586587000	18284	9187	43	0	\N
141627	2132	148585586000	18284	9187	44	0	\N
141628	2132	148584585000	18284	9187	45	0	\N
141629	2134	97385170000	18284	9187	46	0	\N
141630	2134	97384167000	18284	9187	47	0	\N
141631	2134	97383164000	18284	9187	48	0	\N
141632	2134	97382161000	18284	9187	49	0	\N
141633	2134	97381158000	18284	9187	50	0	\N
141634	2134	97380155000	18284	9187	51	0	\N
141635	2134	97379152000	18284	9187	52	0	\N
141636	2134	97378149000	18284	9187	53	0	\N
141637	2134	97377146000	18284	9187	54	0	\N
141638	2134	97376143000	18284	9187	55	0	\N
141639	2134	97375140000	18284	9187	56	0	\N
141640	2134	97374137000	18284	9187	57	0	\N
141641	2134	97373134000	18284	9187	58	0	\N
141642	2134	97372131000	18284	9187	59	0	\N
141643	2134	97371128000	18284	9187	60	0	\N
141644	2134	97370125000	18284	9187	61	0	\N
141645	2134	97369122000	18284	9187	62	0	\N
141646	2134	97368119000	18284	9187	63	0	\N
141647	2134	97367116000	18284	9187	64	0	\N
141648	2134	97366113000	18284	9187	65	0	\N
141649	2134	97365110000	18284	9187	66	0	\N
141650	2134	97364107000	18284	9187	67	0	\N
141651	2134	97363104000	18284	9187	68	0	\N
141652	2134	97362101000	18284	9187	69	0	\N
141653	2134	97361098000	18284	9187	70	0	\N
141654	2134	97360095000	18284	9187	71	0	\N
141655	2134	97359092000	18284	9187	72	0	\N
141656	2134	97358089000	18284	9187	73	0	\N
141657	2134	97357086000	18284	9187	74	0	\N
141658	2134	97356083000	18284	9187	75	0	\N
141659	2134	97355080000	18284	9187	76	0	\N
141660	2134	97354077000	18284	9187	77	0	\N
141661	2134	97353074000	18284	9187	78	0	\N
141662	2134	97352071000	18284	9187	79	0	\N
141666	1397	1333059440000	18286	9214	0	0	\N
141667	2132	148583584000	18286	9214	1	0	\N
141668	2134	97351068000	18286	9214	2	0	\N
141669	1397	1333059440000	18287	9214	0	0	\N
141670	1397	1333049439000	18287	9214	1	0	\N
141671	2132	148583584000	18287	9214	2	0	\N
141672	2134	97351068000	18287	9214	3	0	\N
141689	1397	1333019436000	18291	9217	0	0	\N
141690	2134	97347056000	18291	9217	1	0	\N
141691	1924	1194000000	18291	9217	2	0	\N
141692	1397	1333019436000	18292	9217	0	0	\N
141693	2134	97347056000	18292	9217	1	0	\N
141694	1924	1194000000	18292	9217	2	0	\N
141698	1397	1333009435000	18294	9218	0	0	\N
141699	2134	97346053000	18294	9218	1	0	\N
141700	2157	182957000	18294	9218	2	0	\N
141701	1397	1333009435000	18295	9218	0	0	\N
141702	2134	97346053000	18295	9218	1	0	\N
141703	2157	182957000	18295	9218	2	0	\N
141706	1397	1332999434000	18297	9219	0	0	\N
141707	2134	97345050000	18297	9219	1	0	\N
141708	1397	1332999434000	18298	9219	0	0	\N
141709	2134	97345050000	18298	9219	1	0	\N
141710	1397	1332999434000	18299	9219	0	0	\N
141711	2134	97345050000	18299	9219	1	0	\N
141712	1397	1332999434000	18300	9219	0	0	\N
141579	2132	148584585000	18282	9212	2	0	415
141580	2134	97354077000	18282	9212	3	0	1641
141581	2134	97353074000	18282	9212	4	0	1642
141582	1397	1333069441000	18283	9213	0	0	10576
141583	2134	97352071000	18283	9213	1	0	1643
141664	2132	148583584000	18285	9214	1	0	416
141665	2134	97351068000	18285	9214	2	0	1644
141673	1643	1783113314700	18288	9215	0	0	18
141674	1643	1450542514700	18288	9215	1	0	19
141675	1397	1333049439000	18288	9215	2	0	10578
141677	1926	1192000000	18288	9215	4	0	8
141678	2134	97350065000	18288	9215	5	0	1645
141679	2134	97349062000	18288	9215	6	0	1646
141680	1397	1333029437000	18289	9216	0	0	10580
141682	1643	1040532914700	18289	9216	2	0	21
141683	2132	148582583000	18289	9216	3	0	417
141684	1925	1193000000	18289	9216	4	0	7
141685	2134	97348059000	18289	9216	5	0	1647
141686	1397	1333019436000	18290	9217	0	0	10581
141688	1924	1194000000	18290	9217	2	0	6
141695	1397	1333009435000	18293	9218	0	0	10582
141696	2134	97346053000	18293	9218	1	0	1649
141697	2157	182957000	18293	9218	2	0	10
141704	1397	1332999434000	18296	9219	0	0	10583
141713	1397	1332989433000	18301	9220	0	0	\N
141714	2132	148581582000	18301	9220	1	0	\N
141715	2157	177756999	18301	9220	2	0	\N
141719	1397	1332989433000	18303	9220	0	0	\N
141720	2132	148581582000	18303	9220	1	0	\N
141721	2157	177756999	18303	9220	2	0	\N
141722	1397	1332979432000	18304	9221	0	0	\N
141723	2134	97344047000	18304	9221	1	0	\N
141724	1397	1332979432000	18305	9221	0	0	\N
141725	2134	97344047000	18305	9221	1	0	\N
141731	369	83969132000000	18308	9223	0	0	\N
141732	369	83732032000000	18308	9223	1	0	\N
141733	369	83571932000000	18308	9223	2	0	\N
141734	369	83125832000000	18308	9223	3	0	\N
141735	1397	1332959430000	18308	9223	4	0	\N
141736	1397	1332949429000	18308	9223	5	0	\N
141737	1397	1332939428000	18308	9223	6	0	\N
141738	1397	1332929427000	18308	9223	7	0	\N
141739	1397	1332919426000	18308	9223	8	0	\N
141740	2134	97342041000	18308	9223	9	0	\N
141741	2134	97341038000	18308	9223	10	0	\N
141742	2134	97340035000	18308	9223	11	0	\N
141743	2134	97339032000	18308	9223	12	0	\N
141744	2134	97338029000	18308	9223	13	0	\N
141745	1750	4167000000	18308	9223	14	0	\N
141746	2132	148580581000	18308	9223	15	0	\N
141747	2132	148579580000	18308	9223	16	0	\N
141748	2131	195998000	18308	9223	17	0	\N
141749	2131	194997000	18308	9223	18	0	\N
141750	369	83969132000000	18309	9223	0	0	\N
141751	369	83732032000000	18309	9223	1	0	\N
141752	369	83571932000000	18309	9223	2	0	\N
141753	369	83125832000000	18309	9223	3	0	\N
141754	1397	1332959430000	18309	9223	4	0	\N
141755	1397	1332949429000	18309	9223	5	0	\N
141756	1397	1332939428000	18309	9223	6	0	\N
141757	1397	1332929427000	18309	9223	7	0	\N
141758	1397	1332919426000	18309	9223	8	0	\N
141759	2134	97342041000	18309	9223	9	0	\N
141760	2134	97341038000	18309	9223	10	0	\N
141761	2134	97340035000	18309	9223	11	0	\N
141762	2134	97339032000	18309	9223	12	0	\N
141763	2134	97338029000	18309	9223	13	0	\N
141764	1750	4167000000	18309	9223	14	0	\N
141765	2132	148580581000	18309	9223	15	0	\N
141766	2132	148579580000	18309	9223	16	0	\N
141767	2131	195998000	18309	9223	17	0	\N
141768	2131	194997000	18309	9223	18	0	\N
141790	1397	1332899424000	18312	9225	0	0	\N
141791	2118	1396000000	18312	9225	1	0	\N
141792	2134	97336023000	18312	9225	2	0	\N
141793	1397	1332899424000	18313	9225	0	0	\N
141794	2118	1396000000	18313	9225	1	0	\N
141795	2134	97336023000	18313	9225	2	0	\N
141799	369	83969132000000	18315	9188	0	0	\N
141800	369	83732032000000	18315	9188	1	0	\N
141801	369	83571932000000	18315	9188	2	0	\N
141802	369	83125832000000	18315	9188	3	0	\N
141803	1397	1333059440000	18315	9188	4	0	\N
141804	1643	1783113314700	18315	9188	5	0	\N
141805	1643	1450542514700	18315	9188	6	0	\N
141806	1397	1333049439000	18315	9188	7	0	\N
141807	1397	1333039438000	18315	9188	8	0	\N
141808	1397	1333029437000	18315	9188	9	0	\N
141809	1397	1333019436000	18315	9188	10	0	\N
141810	1397	1333009435000	18315	9188	11	0	\N
141811	1643	1226180514700	18315	9188	12	0	\N
141812	1643	1040532914700	18315	9188	13	0	\N
141813	1397	1332999434000	18315	9188	14	0	\N
141814	1397	1332989433000	18315	9188	15	0	\N
141815	1397	1332979432000	18315	9188	16	0	\N
141816	1397	1332969431000	18315	9188	17	0	\N
141817	1397	1332959430000	18315	9188	18	0	\N
141818	1397	1332949429000	18315	9188	19	0	\N
141819	1397	1332939428000	18315	9188	20	0	\N
141820	1397	1332929427000	18315	9188	21	0	\N
141821	1397	1332919426000	18315	9188	22	0	\N
141822	1397	1332909425000	18315	9188	23	0	\N
141823	1397	1332899424000	18315	9188	24	0	\N
141824	2118	1396000000	18315	9188	25	0	\N
141825	2132	148583584000	18315	9188	26	0	\N
141826	2132	148582583000	18315	9188	27	0	\N
141827	2134	97351068000	18315	9188	28	0	\N
141828	2157	182957000	18315	9188	29	0	\N
141829	1926	1192000000	18315	9188	30	0	\N
141830	1925	1193000000	18315	9188	31	0	\N
141831	1924	1194000000	18315	9188	32	0	\N
141832	2132	148581582000	18315	9188	33	0	\N
141833	1750	4167000000	18315	9188	34	0	\N
141834	2134	97350065000	18315	9188	35	0	\N
141835	2134	97349062000	18315	9188	36	0	\N
141836	2134	97348059000	18315	9188	37	0	\N
141837	2134	97347056000	18315	9188	38	0	\N
141838	2134	97346053000	18315	9188	39	0	\N
141839	2134	97345050000	18315	9188	40	0	\N
141840	2134	97344047000	18315	9188	41	0	\N
141841	2134	97343044000	18315	9188	42	0	\N
141842	2134	97342041000	18315	9188	43	0	\N
141843	2134	97341038000	18315	9188	44	0	\N
141844	2134	97340035000	18315	9188	45	0	\N
141845	2134	97339032000	18315	9188	46	0	\N
141846	2134	97338029000	18315	9188	47	0	\N
141847	2134	97337026000	18315	9188	48	0	\N
141848	2134	97336023000	18315	9188	49	0	\N
141718	2157	177756999	18302	9220	2	0	11
141726	1397	1332979432000	18306	9221	0	0	10585
141727	2134	97344047000	18306	9221	1	0	1651
141728	1397	1332969431000	18307	9222	0	0	10586
141729	2134	97343044000	18307	9222	1	0	1652
141769	369	83969132000000	18310	9223	0	0	5
141770	369	83732032000000	18310	9223	1	0	6
141771	369	83571932000000	18310	9223	2	0	7
141772	369	83125832000000	18310	9223	3	0	8
141773	1397	1332959430000	18310	9223	4	0	10587
141775	1397	1332939428000	18310	9223	6	0	10589
141776	1397	1332929427000	18310	9223	7	0	10590
141777	1397	1332919426000	18310	9223	8	0	10591
141778	2134	97342041000	18310	9223	9	0	1653
141780	2134	97340035000	18310	9223	11	0	1655
141781	2134	97339032000	18310	9223	12	0	1656
141782	2134	97338029000	18310	9223	13	0	1657
141783	1750	4167000000	18310	9223	14	0	33
141784	2132	148580581000	18310	9223	15	0	419
141786	2131	195998000	18310	9223	17	0	4
141787	2131	194997000	18310	9223	18	0	5
141788	1397	1332909425000	18311	9224	0	0	10592
141789	2134	97337026000	18311	9224	1	0	1658
141796	1397	1332899424000	18314	9225	0	0	10593
141798	2134	97336023000	18314	9225	2	0	1659
141849	2132	148580581000	18315	9188	50	0	\N
141850	2132	148579580000	18315	9188	51	0	\N
141851	2157	177756999	18315	9188	52	0	\N
141852	2157	172256999	18315	9188	53	0	\N
141853	2131	195998000	18315	9188	54	0	\N
141854	2131	194997000	18315	9188	55	0	\N
141855	1397	1332899424000	18316	9225	0	0	\N
141856	2118	1396000000	18316	9225	1	0	\N
141857	2134	97336023000	18316	9225	2	0	\N
141867	1397	1332869421000	18318	9227	0	0	\N
141868	2134	97333014000	18318	9227	1	0	\N
141871	1397	1332869421000	18320	9227	0	0	\N
141872	2134	97333014000	18320	9227	1	0	\N
141873	1397	1332859420000	18321	9228	0	0	\N
141874	2132	148577578000	18321	9228	1	0	\N
141883	1397	1332829417000	18326	9231	0	0	\N
141884	2134	97330005000	18326	9231	1	0	\N
141885	2132	148576577000	18326	9231	2	0	\N
141886	1397	1332829417000	18327	9231	0	0	\N
141887	2134	97330005000	18327	9231	1	0	\N
141888	2132	148576577000	18327	9231	2	0	\N
141889	1397	1332829417000	18328	9232	0	0	\N
141890	1397	1332819416000	18328	9232	1	0	\N
141891	1397	1332809415000	18328	9232	2	0	\N
141892	2134	97329002000	18328	9232	3	0	\N
141893	2134	97327999000	18328	9232	4	0	\N
141899	1397	1332799414000	18330	9233	0	0	\N
141900	1397	1332789413000	18330	9233	1	0	\N
141901	2134	97326996000	18330	9233	2	0	\N
141902	2134	97325993000	18330	9233	3	0	\N
141903	2132	148575576000	18330	9233	4	0	\N
141924	1397	1332729407000	18337	9238	0	0	\N
141925	1397	1332719406000	18337	9238	1	0	\N
141926	2132	148573574000	18337	9238	2	0	\N
141927	2134	97320978000	18337	9238	3	0	\N
141928	2134	97319975000	18337	9238	4	0	\N
141940	1397	1332669401000	18343	9242	0	0	\N
141941	2134	97314960000	18343	9242	1	0	\N
141949	1397	1332649399000	18346	9244	0	0	\N
141950	1397	1332639398000	18346	9244	1	0	\N
141951	1397	1332629397000	18346	9244	2	0	\N
141952	2134	97312954000	18346	9244	3	0	\N
141953	2157	167256999	18346	9244	4	0	\N
141954	2134	97311951000	18346	9244	5	0	\N
141955	2134	97310948000	18346	9244	6	0	\N
141956	1397	1332649399000	18347	9244	0	0	\N
141957	1397	1332639398000	18347	9244	1	0	\N
141958	1397	1332629397000	18347	9244	2	0	\N
141959	2157	167256999	18347	9244	3	0	\N
141967	1397	1332649399000	18349	9244	0	0	\N
141968	1397	1332639398000	18349	9244	1	0	\N
141969	1397	1332629397000	18349	9244	2	0	\N
141970	2134	97312954000	18349	9244	3	0	\N
141971	2157	167256999	18349	9244	4	0	\N
141972	2134	97311951000	18349	9244	5	0	\N
141973	2134	97310948000	18349	9244	6	0	\N
141860	369	83099062000000	18317	9226	2	0	11
141861	369	83076662000000	18317	9226	3	0	12
141862	1397	1332889423000	18317	9226	4	0	10594
141863	1397	1332879422000	18317	9226	5	0	10595
141864	2132	148578579000	18317	9226	6	0	421
141866	2134	97334017000	18317	9226	8	0	1661
141869	1397	1332869421000	18319	9227	0	0	10596
141870	2134	97333014000	18319	9227	1	0	1662
141875	1397	1332859420000	18322	9228	0	0	10597
141876	2132	148577578000	18322	9228	1	0	422
141878	2134	97332011000	18323	9229	1	0	1663
141879	1397	1332839418000	18324	9230	0	0	10599
141880	2134	97331008000	18324	9230	1	0	1664
141881	2134	97330005000	18325	9231	0	0	1665
141894	1397	1332829417000	18329	9232	0	0	10600
141895	1397	1332819416000	18329	9232	1	0	10601
141896	1397	1332809415000	18329	9232	2	0	10602
141897	2134	97329002000	18329	9232	3	0	1666
141898	2134	97327999000	18329	9232	4	0	1667
141905	1397	1332789413000	18331	9233	1	0	10604
141906	2134	97326996000	18331	9233	2	0	1668
141907	2134	97325993000	18331	9233	3	0	1669
141908	2132	148575576000	18331	9233	4	0	424
141909	1397	1332779412000	18332	9234	0	0	10605
141911	1397	1332769411000	18333	9235	0	0	10606
141912	1397	1332759410000	18333	9235	1	0	10607
141913	2134	97323987000	18333	9235	2	0	1671
141914	2134	97322984000	18333	9235	3	0	1672
141916	1397	1332749409000	18334	9236	0	0	10608
141917	2134	97321981000	18334	9236	1	0	1673
141918	1397	1332739408000	18335	9237	0	0	10609
141919	1397	1332729407000	18336	9238	0	0	10610
141920	1397	1332719406000	18336	9238	1	0	10611
141922	2134	97320978000	18336	9238	3	0	1674
141923	2134	97319975000	18336	9238	4	0	1675
141929	1397	1332709405000	18338	9239	0	0	10612
141930	2134	97318972000	18338	9239	1	0	1676
141931	1397	1332699404000	18342	9241	0	0	10613
141933	1397	1332679402000	18342	9241	2	0	10615
141934	2132	148572573000	18342	9241	3	0	427
141935	2134	97317969000	18342	9241	4	0	1677
141936	2157	171256999	18342	9241	5	0	13
141938	2134	97316966000	18342	9241	7	0	1678
141939	2134	97315963000	18342	9241	8	0	1679
141942	1397	1332669401000	18344	9242	0	0	10616
141943	2134	97314960000	18344	9242	1	0	1680
141944	1397	1332659400000	18345	9243	0	0	10617
141946	2132	148571572000	18345	9243	2	0	428
141947	2157	169256999	18345	9243	3	0	15
141948	2157	168256999	18345	9243	4	0	16
141960	1397	1332649399000	18348	9244	0	0	10618
141961	1397	1332639398000	18348	9244	1	0	10619
141963	2134	97312954000	18348	9244	3	0	1682
141964	2157	167256999	18348	9244	4	0	17
141965	2134	97311951000	18348	9244	5	0	1683
141966	2134	97310948000	18348	9244	6	0	1684
141975	2132	148570571000	18350	9245	1	0	429
141976	2157	166256999	18350	9245	2	0	18
141977	2157	165256999	18350	9245	3	0	19
141978	2157	164256999	18350	9245	4	0	20
141979	2157	163256999	18350	9245	5	0	21
141981	1397	1332609395000	18351	9246	0	0	10622
141982	2134	97308942000	18351	9246	1	0	1686
141983	1397	1332599394000	18352	9247	0	0	10623
141984	1397	1332589393000	18352	9247	1	0	10624
141995	1397	1332559390000	18356	9250	0	0	\N
141996	2132	148568569000	18356	9250	1	0	\N
141997	2134	97303927000	18356	9250	2	0	\N
142006	1397	1332519386000	18360	9253	0	0	\N
142007	2132	148567568000	18360	9253	1	0	\N
142008	1397	1332519386000	18361	9253	0	0	\N
142009	2132	148567568000	18361	9253	1	0	\N
142010	1397	1332519386000	18362	9253	0	0	\N
142011	2132	148567568000	18362	9253	1	0	\N
142014	1397	1332509385000	18364	9254	0	0	\N
142015	2134	97299915000	18364	9254	1	0	\N
142023	369	83969132000000	18367	9112	0	0	\N
142024	369	83732032000000	18367	9112	1	0	\N
142025	369	83571932000000	18367	9112	2	0	\N
142026	369	83125832000000	18367	9112	3	0	\N
142027	369	83119112000000	18367	9112	4	0	\N
142028	369	83107162000000	18367	9112	5	0	\N
142029	369	83099062000000	18367	9112	6	0	\N
142030	369	83076662000000	18367	9112	7	0	\N
142031	2165	190000000	18367	9112	8	0	\N
142032	1726	105955110000	18367	9112	9	0	\N
142033	1397	1334139548000	18367	9112	10	0	\N
142034	1397	1334129547000	18367	9112	11	0	\N
142035	1397	1334119546000	18367	9112	12	0	\N
142036	1397	1334109545000	18367	9112	13	0	\N
142037	1397	1334099544000	18367	9112	14	0	\N
142038	1397	1334089543000	18367	9112	15	0	\N
142039	1397	1334079542000	18367	9112	16	0	\N
142040	1397	1334069541000	18367	9112	17	0	\N
142041	1643	1783113314700	18367	9112	18	0	\N
142042	1643	1450542514700	18367	9112	19	0	\N
142043	1643	1226180514700	18367	9112	20	0	\N
142044	1397	1334059540000	18367	9112	21	0	\N
142045	1643	1040532914700	18367	9112	22	0	\N
142046	1397	1334049539000	18367	9112	23	0	\N
142047	1397	1334039538000	18367	9112	24	0	\N
142048	1397	1334029537000	18367	9112	25	0	\N
142049	1397	1334019536000	18367	9112	26	0	\N
142050	1397	1334009535000	18367	9112	27	0	\N
142051	1397	1333999534000	18367	9112	28	0	\N
142052	1397	1333989533000	18367	9112	29	0	\N
142053	1397	1333979532000	18367	9112	30	0	\N
142054	1397	1333969531000	18367	9112	31	0	\N
142055	1397	1333959530000	18367	9112	32	0	\N
142056	1397	1333949529000	18367	9112	33	0	\N
142057	1397	1333939528000	18367	9112	34	0	\N
142058	1397	1333929527000	18367	9112	35	0	\N
142059	1397	1333919526000	18367	9112	36	0	\N
142060	1397	1333909525000	18367	9112	37	0	\N
142061	1397	1333899524000	18367	9112	38	0	\N
142062	1397	1333889523000	18367	9112	39	0	\N
142063	1397	1333879522000	18367	9112	40	0	\N
142064	1397	1333869521000	18367	9112	41	0	\N
142065	1397	1333859520000	18367	9112	42	0	\N
142066	1397	1333849519000	18367	9112	44	0	\N
142067	1397	1333839518000	18367	9112	45	0	\N
142068	1397	1333829517000	18367	9112	46	0	\N
142069	1397	1333819516000	18367	9112	47	0	\N
142070	1397	1333809515000	18367	9112	48	0	\N
142071	1397	1333799514000	18367	9112	49	0	\N
142072	1397	1333789513000	18367	9112	50	0	\N
142073	1397	1333779512000	18367	9112	51	0	\N
142074	1397	1333769511000	18367	9112	52	0	\N
142075	1397	1333759510000	18367	9112	53	0	\N
142076	1397	1333749509000	18367	9112	54	0	\N
142077	1397	1333739508000	18367	9112	55	0	\N
142078	1397	1333729507000	18367	9112	56	0	\N
142079	1397	1333719506000	18367	9112	57	0	\N
142080	1397	1333709505000	18367	9112	58	0	\N
142081	1397	1333699504000	18367	9112	59	0	\N
142082	1397	1333689503000	18367	9112	60	0	\N
142083	1397	1333679502000	18367	9112	61	0	\N
142084	1397	1333669501000	18367	9112	62	0	\N
142085	1397	1333659500000	18367	9112	63	0	\N
142086	1397	1333649499000	18367	9112	64	0	\N
142087	1397	1333639498000	18367	9112	65	0	\N
142088	1397	1333629497000	18367	9112	66	0	\N
142089	1397	1333619496000	18367	9112	67	0	\N
142090	1397	1333609495000	18367	9112	68	0	\N
142091	1397	1333599494000	18367	9112	69	0	\N
142092	1397	1333589493000	18367	9112	70	0	\N
142093	1397	1333579492000	18367	9112	71	0	\N
142094	1397	1333569491000	18367	9112	72	0	\N
142095	1397	1333559490000	18367	9112	73	0	\N
142096	1397	1333549489000	18367	9112	74	0	\N
142097	1397	1333539488000	18367	9112	75	0	\N
142098	1397	1333529487000	18367	9112	76	0	\N
142099	1397	1333519486000	18367	9112	77	0	\N
142100	1397	1333509485000	18367	9112	78	0	\N
142101	1397	1333499484000	18367	9112	79	0	\N
142102	1397	1333489483000	18367	9112	80	0	\N
142103	1397	1333479482000	18367	9112	81	0	\N
142104	1397	1333469481000	18367	9112	82	0	\N
142105	1397	1333459480000	18367	9112	83	0	\N
142106	1397	1333449479000	18367	9112	84	0	\N
142107	1397	1333439478000	18367	9112	85	0	\N
142108	1397	1333429477000	18367	9112	86	0	\N
142109	1397	1333419476000	18367	9112	87	0	\N
142110	1397	1333409475000	18367	9112	88	0	\N
142111	1397	1333399474000	18367	9112	89	0	\N
142112	1397	1333389473000	18367	9112	90	0	\N
142113	1397	1333379472000	18367	9112	91	0	\N
142114	1397	1333369471000	18367	9112	92	0	\N
142115	1397	1333359470000	18367	9112	93	0	\N
142116	1397	1333349469000	18367	9112	94	0	\N
142117	1397	1333339468000	18367	9112	95	0	\N
142118	1397	1333329467000	18367	9112	96	0	\N
142119	1397	1333319466000	18367	9112	97	0	\N
142120	1397	1333309465000	18367	9112	98	0	\N
141987	2134	97306936000	18352	9247	4	0	1688
141988	1397	1332579392000	18353	9248	0	0	10625
141989	2134	97305933000	18353	9248	1	0	1689
141990	1397	1332569391000	18354	9249	0	0	10626
141991	2134	97304930000	18354	9249	1	0	1690
141993	2132	148568569000	18355	9250	1	0	431
141994	2134	97303927000	18355	9250	2	0	1691
141998	1397	1332549389000	18357	9251	0	0	10628
141999	1397	1332539388000	18357	9251	1	0	10629
142000	2134	97302924000	18357	9251	2	0	1692
142002	1397	1332529387000	18358	9252	0	0	10630
142003	2134	97300918000	18358	9252	1	0	1694
142004	1397	1332519386000	18359	9253	0	0	10631
142005	2132	148567568000	18359	9253	1	0	432
142013	2134	97299915000	18363	9254	1	0	1695
142016	1397	1332499384000	18365	9255	0	0	10633
142017	1397	1332489383000	18365	9255	1	0	10634
142018	2132	148566567000	18365	9255	2	0	433
142019	2134	97298912000	18365	9255	3	0	1696
142021	1397	1332479382000	18366	9256	0	0	10635
142022	2134	97296906000	18366	9256	1	0	1698
142121	1397	1333299464000	18367	9112	99	0	\N
142122	1397	1333289463000	18367	9112	100	0	\N
142123	1397	1333279462000	18367	9112	101	0	\N
142124	1397	1333269461000	18367	9112	102	0	\N
142125	1397	1333259460000	18367	9112	103	0	\N
142126	1397	1333249459000	18367	9112	104	0	\N
142127	1397	1333239458000	18367	9112	105	0	\N
142128	1397	1333229457000	18367	9112	106	0	\N
142129	1397	1333219456000	18367	9112	107	0	\N
142130	1397	1333209455000	18367	9112	108	0	\N
142131	1397	1333199454000	18367	9112	109	0	\N
142132	1397	1333189453000	18367	9112	110	0	\N
142133	1397	1333179452000	18367	9112	111	0	\N
142134	1397	1333169451000	18367	9112	112	0	\N
142135	1397	1333159450000	18367	9112	113	0	\N
142136	1397	1333149449000	18367	9112	114	0	\N
142137	1397	1333139448000	18367	9112	115	0	\N
142138	1397	1333129447000	18367	9112	116	0	\N
142139	1397	1333119446000	18367	9112	117	0	\N
142140	1397	1333109445000	18367	9112	118	0	\N
142141	1397	1333099444000	18367	9112	119	0	\N
142142	1397	1333089443000	18367	9112	120	0	\N
142143	1397	1333079442000	18367	9112	121	0	\N
142144	1397	1333069441000	18367	9112	122	0	\N
142145	1397	1333059440000	18367	9112	123	0	\N
142146	1397	1333049439000	18367	9112	124	0	\N
142147	1397	1332469381000	18368	9257	0	0	\N
142148	1397	1332459380000	18368	9257	1	0	\N
142149	2132	148565566000	18368	9257	2	0	\N
142150	2134	97295903000	18368	9257	3	0	\N
142151	2134	97294900000	18368	9257	4	0	\N
142157	369	83969132000000	18370	9186	0	0	\N
142158	369	83732032000000	18370	9186	1	0	\N
142159	369	83571932000000	18370	9186	2	0	\N
142160	369	83125832000000	18370	9186	3	0	\N
142161	369	83119112000000	18370	9186	4	0	\N
142162	369	83107162000000	18370	9186	5	0	\N
142163	369	83099062000000	18370	9186	6	0	\N
142164	369	83076662000000	18370	9186	7	0	\N
142165	1643	1783113314700	18370	9186	8	0	\N
142166	1643	1450542514700	18370	9186	9	0	\N
142167	1643	1226180514700	18370	9186	11	0	\N
142168	1643	1040532914700	18370	9186	12	0	\N
142169	1397	1333309465000	18370	9186	13	0	\N
142170	1397	1333299464000	18370	9186	14	0	\N
142171	1397	1333289463000	18370	9186	15	0	\N
142172	1397	1333279462000	18370	9186	16	0	\N
142173	1397	1333269461000	18370	9186	17	0	\N
142174	1397	1333259460000	18370	9186	18	0	\N
142175	1397	1333249459000	18370	9186	19	0	\N
142176	1397	1333239458000	18370	9186	20	0	\N
142177	1397	1333229457000	18370	9186	21	0	\N
142178	1397	1333219456000	18370	9186	22	0	\N
142179	1397	1333209455000	18370	9186	23	0	\N
142180	1397	1333199454000	18370	9186	24	0	\N
142181	1397	1333189453000	18370	9186	25	0	\N
142182	1397	1333179452000	18370	9186	26	0	\N
142183	1397	1333169451000	18370	9186	27	0	\N
142184	1397	1333159450000	18370	9186	28	0	\N
142185	1397	1333149449000	18370	9186	29	0	\N
142186	1397	1333139448000	18370	9186	30	0	\N
142187	1397	1333129447000	18370	9186	31	0	\N
142188	1397	1333119446000	18370	9186	32	0	\N
142189	1397	1333109445000	18370	9186	33	0	\N
142190	1397	1333099444000	18370	9186	34	0	\N
142191	1397	1333089443000	18370	9186	35	0	\N
142192	1397	1333079442000	18370	9186	36	0	\N
142193	1397	1333069441000	18370	9186	37	0	\N
142194	1397	1333059440000	18370	9186	38	0	\N
142195	1397	1333049439000	18370	9186	39	0	\N
142196	1397	1333039438000	18370	9186	40	0	\N
142197	1397	1333029437000	18370	9186	41	0	\N
142198	1397	1333019436000	18370	9186	42	0	\N
142199	1397	1333009435000	18370	9186	43	0	\N
142200	1397	1332999434000	18370	9186	44	0	\N
142201	1397	1332989433000	18370	9186	45	0	\N
142202	1397	1332979432000	18370	9186	46	0	\N
142203	1397	1332969431000	18370	9186	47	0	\N
142204	1397	1332959430000	18370	9186	48	0	\N
142205	1397	1332949429000	18370	9186	49	0	\N
142206	1397	1332939428000	18370	9186	50	0	\N
142207	1397	1332929427000	18370	9186	51	0	\N
142208	1397	1332919426000	18370	9186	52	0	\N
142209	1397	1332909425000	18370	9186	53	0	\N
142210	1397	1332899424000	18370	9186	54	0	\N
142211	1397	1332889423000	18370	9186	55	0	\N
142212	1397	1332879422000	18370	9186	56	0	\N
142213	1397	1332869421000	18370	9186	57	0	\N
142214	1397	1332859420000	18370	9186	58	0	\N
142215	1397	1332849419000	18370	9186	59	0	\N
142216	1397	1332839418000	18370	9186	60	0	\N
142217	1397	1332829417000	18370	9186	61	0	\N
142218	1397	1332819416000	18370	9186	62	0	\N
142219	1397	1332809415000	18370	9186	63	0	\N
142220	1397	1332799414000	18370	9186	64	0	\N
142221	1397	1332789413000	18370	9186	65	0	\N
142222	1397	1332779412000	18370	9186	66	0	\N
142223	1397	1332769411000	18370	9186	67	0	\N
142224	1397	1332759410000	18370	9186	68	0	\N
142225	1397	1332749409000	18370	9186	69	0	\N
142226	1397	1332739408000	18370	9186	70	0	\N
142227	1397	1332729407000	18370	9186	71	0	\N
142228	1397	1332719406000	18370	9186	72	0	\N
142229	1397	1332709405000	18370	9186	73	0	\N
142230	1397	1332699404000	18370	9186	74	0	\N
142231	1397	1332689403000	18370	9186	75	0	\N
142232	1397	1332679402000	18370	9186	76	0	\N
142233	1397	1332669401000	18370	9186	77	0	\N
142234	1397	1332659400000	18370	9186	78	0	\N
142235	1397	1332649399000	18370	9186	79	0	\N
142236	1397	1332639398000	18370	9186	80	0	\N
142237	1397	1332629397000	18370	9186	81	0	\N
142238	1397	1332619396000	18370	9186	82	0	\N
142239	1397	1332609395000	18370	9186	83	0	\N
142240	1397	1332599394000	18370	9186	84	0	\N
142241	1397	1332589393000	18370	9186	85	0	\N
142242	1397	1332579392000	18370	9186	86	0	\N
142243	1397	1332569391000	18370	9186	87	0	\N
142244	1397	1332559390000	18370	9186	88	0	\N
142245	1397	1332549389000	18370	9186	89	0	\N
142246	1397	1332539388000	18370	9186	90	0	\N
142247	1397	1332529387000	18370	9186	91	0	\N
142248	1397	1332519386000	18370	9186	92	0	\N
142249	1397	1332509385000	18370	9186	93	0	\N
142250	1397	1332499384000	18370	9186	94	0	\N
142251	1397	1332489383000	18370	9186	95	0	\N
142252	1397	1332479382000	18370	9186	96	0	\N
142253	1397	1332469381000	18370	9186	97	0	\N
142254	1397	1332459380000	18370	9186	98	0	\N
142255	2118	1396000000	18370	9186	99	0	\N
142256	2157	182957000	18370	9186	100	0	\N
142154	2132	148565566000	18369	9257	2	0	434
142155	2134	97295903000	18369	9257	3	0	1699
142156	2134	97294900000	18369	9257	4	0	1700
142257	1926	1192000000	18370	9186	101	0	\N
142258	1925	1193000000	18370	9186	102	0	\N
142259	1924	1194000000	18370	9186	103	0	\N
142260	2134	97375140000	18370	9186	104	0	\N
142261	2132	148590591000	18370	9186	105	0	\N
142262	2132	148589590000	18370	9186	106	0	\N
142263	1750	4167000000	18370	9186	107	0	\N
142264	2157	177756999	18370	9186	108	0	\N
142265	2157	172256999	18370	9186	109	0	\N
142266	2157	171256999	18370	9186	110	0	\N
142267	2157	170256999	18370	9186	111	0	\N
142268	2157	169256999	18370	9186	112	0	\N
142269	2157	168256999	18370	9186	113	0	\N
142270	2157	167256999	18370	9186	114	0	\N
142271	2132	148588589000	18370	9186	115	0	\N
142272	2132	148587588000	18370	9186	116	0	\N
142273	2132	148586587000	18370	9186	117	0	\N
142274	2132	148585586000	18370	9186	118	0	\N
142275	2132	148584585000	18370	9186	119	0	\N
142276	2132	148583584000	18370	9186	120	0	\N
142277	2132	148582583000	18370	9186	121	0	\N
142278	2132	148581582000	18370	9186	122	0	\N
142279	2132	148580581000	18370	9186	123	0	\N
142280	2132	148579580000	18370	9186	124	0	\N
142281	2132	148578579000	18370	9186	125	0	\N
142284	1397	1332449379000	18372	9258	0	0	\N
142285	2134	97293897000	18372	9258	1	0	\N
142290	1397	1332419376000	18375	9261	0	0	\N
142291	2134	97290888000	18375	9261	1	0	\N
142292	2132	148564565000	18375	9261	2	0	\N
142300	1397	1332389373000	18380	9264	0	0	\N
142301	1397	1332379372000	18380	9264	2	0	\N
142302	2134	97287879000	18380	9264	3	0	\N
142303	2134	97286876000	18380	9264	4	0	\N
142304	2132	148563564000	18380	9264	5	0	\N
142305	1397	1332449379000	18381	9187	0	0	\N
142306	1397	1332439378000	18381	9187	1	0	\N
142307	1397	1332429377000	18381	9187	2	0	\N
142308	1397	1332419376000	18381	9187	3	0	\N
142309	1397	1332409375000	18381	9187	4	0	\N
142310	1397	1332399374000	18381	9187	5	0	\N
142311	1397	1332389373000	18381	9187	6	0	\N
142312	1397	1332379372000	18381	9187	7	0	\N
142313	2132	148577578000	18381	9187	8	0	\N
142314	2132	148576577000	18381	9187	9	0	\N
142315	2132	148575576000	18381	9187	11	0	\N
142316	2132	148574575000	18381	9187	12	0	\N
142317	2132	148573574000	18381	9187	13	0	\N
142318	2132	148572573000	18381	9187	14	0	\N
142319	2132	148571572000	18381	9187	15	0	\N
142320	2132	148570571000	18381	9187	16	0	\N
142321	2132	148569570000	18381	9187	17	0	\N
142322	2132	148568569000	18381	9187	18	0	\N
142323	2132	148567568000	18381	9187	19	0	\N
142324	2132	148566567000	18381	9187	20	0	\N
142325	2132	148565566000	18381	9187	21	0	\N
142326	2132	148564565000	18381	9187	22	0	\N
142327	2132	148563564000	18381	9187	23	0	\N
142328	2157	166256999	18381	9187	24	0	\N
142329	2157	165256999	18381	9187	25	0	\N
142330	2157	164256999	18381	9187	26	0	\N
142331	2157	163256999	18381	9187	27	0	\N
142332	2131	195998000	18381	9187	28	0	\N
142333	2131	194997000	18381	9187	29	0	\N
142334	2134	97374137000	18381	9187	30	0	\N
142335	2134	97373134000	18381	9187	31	0	\N
142336	2134	97372131000	18381	9187	32	0	\N
142337	2134	97371128000	18381	9187	33	0	\N
142338	2134	97370125000	18381	9187	34	0	\N
142339	2134	97369122000	18381	9187	35	0	\N
142340	2134	97368119000	18381	9187	36	0	\N
142341	2134	97367116000	18381	9187	37	0	\N
142342	2134	97366113000	18381	9187	38	0	\N
142343	2134	97365110000	18381	9187	39	0	\N
142344	2134	97364107000	18381	9187	40	0	\N
142345	2134	97363104000	18381	9187	41	0	\N
142346	2134	97362101000	18381	9187	42	0	\N
142347	2134	97361098000	18381	9187	43	0	\N
142348	2134	97360095000	18381	9187	44	0	\N
142349	2134	97359092000	18381	9187	45	0	\N
142350	2134	97358089000	18381	9187	46	0	\N
142351	2134	97357086000	18381	9187	47	0	\N
142352	2134	97356083000	18381	9187	48	0	\N
142353	2134	97355080000	18381	9187	49	0	\N
142354	2134	97354077000	18381	9187	50	0	\N
142355	2134	97353074000	18381	9187	51	0	\N
142356	2134	97352071000	18381	9187	52	0	\N
142357	2134	97351068000	18381	9187	53	0	\N
142358	2134	97350065000	18381	9187	54	0	\N
142359	2134	97349062000	18381	9187	55	0	\N
142360	2134	97348059000	18381	9187	56	0	\N
142361	2134	97347056000	18381	9187	57	0	\N
142362	2134	97346053000	18381	9187	58	0	\N
142363	2134	97345050000	18381	9187	59	0	\N
142364	2134	97344047000	18381	9187	60	0	\N
142365	2134	97343044000	18381	9187	61	0	\N
142366	2134	97342041000	18381	9187	62	0	\N
142367	2134	97341038000	18381	9187	63	0	\N
142368	2134	97340035000	18381	9187	64	0	\N
142369	2134	97339032000	18381	9187	65	0	\N
142370	2134	97338029000	18381	9187	66	0	\N
142371	2134	97337026000	18381	9187	67	0	\N
142372	2134	97336023000	18381	9187	68	0	\N
142373	2134	97335020000	18381	9187	69	0	\N
142374	2134	97334017000	18381	9187	70	0	\N
142375	2134	97333014000	18381	9187	71	0	\N
142376	2134	97332011000	18381	9187	72	0	\N
142377	2134	97331008000	18381	9187	73	0	\N
142378	2134	97330005000	18381	9187	74	0	\N
142379	2134	97329002000	18381	9187	75	0	\N
142380	2134	97327999000	18381	9187	76	0	\N
142381	2134	97326996000	18381	9187	77	0	\N
142382	2134	97325993000	18381	9187	78	0	\N
142383	2134	97324990000	18381	9187	79	0	\N
142384	2134	97323987000	18381	9187	80	0	\N
142385	2134	97322984000	18381	9187	81	0	\N
142386	2134	97321981000	18381	9187	82	0	\N
142387	2134	97320978000	18381	9187	83	0	\N
142388	2134	97319975000	18381	9187	84	0	\N
142389	2134	97318972000	18381	9187	85	0	\N
142390	2134	97317969000	18381	9187	86	0	\N
142391	2134	97316966000	18381	9187	87	0	\N
142392	2134	97315963000	18381	9187	88	0	\N
142286	1397	1332439378000	18373	9259	0	0	10639
142287	2134	97292894000	18373	9259	1	0	1702
142288	1397	1332429377000	18374	9260	0	0	10640
142289	2134	97291891000	18374	9260	1	0	1703
142293	1397	1332419376000	18376	9261	0	0	10641
142295	2132	148564565000	18376	9261	2	0	435
142296	1397	1332409375000	18377	9262	0	0	10642
142297	2134	97289885000	18377	9262	1	0	1705
142298	1397	1332399374000	18378	9263	0	0	10643
142299	2134	97288882000	18378	9263	1	0	1706
142393	2134	97314960000	18381	9187	89	0	\N
142394	2134	97313957000	18381	9187	90	0	\N
142395	2134	97312954000	18381	9187	91	0	\N
142396	2134	97311951000	18381	9187	92	0	\N
142397	2134	97310948000	18381	9187	93	0	\N
142398	2134	97309945000	18381	9187	94	0	\N
142399	2134	97308942000	18381	9187	95	0	\N
142400	2134	97307939000	18381	9187	96	0	\N
142401	2134	97306936000	18381	9187	97	0	\N
142402	2134	97305933000	18381	9187	98	0	\N
142403	2134	97304930000	18381	9187	99	0	\N
142404	2134	97303927000	18381	9187	100	0	\N
142405	2134	97302924000	18381	9187	101	0	\N
142406	2134	97301921000	18381	9187	102	0	\N
142407	2134	97300918000	18381	9187	103	0	\N
142408	2134	97299915000	18381	9187	104	0	\N
142409	2134	97298912000	18381	9187	105	0	\N
142410	2134	97297909000	18381	9187	106	0	\N
142411	2134	97296906000	18381	9187	107	0	\N
142412	2134	97295903000	18381	9187	108	0	\N
142413	2134	97294900000	18381	9187	109	0	\N
142414	2134	97293897000	18381	9187	110	0	\N
142415	2134	97292894000	18381	9187	111	0	\N
142416	2134	97291891000	18381	9187	112	0	\N
142417	2134	97290888000	18381	9187	113	0	\N
142418	2134	97289885000	18381	9187	114	0	\N
142419	2134	97288882000	18381	9187	115	0	\N
142420	2134	97287879000	18381	9187	116	0	\N
142421	2134	97286876000	18381	9187	117	0	\N
142438	1397	1332319366000	18387	9268	0	0	\N
142439	2134	97280858000	18387	9268	1	0	\N
142440	2132	148561562000	18387	9268	2	0	\N
142444	1397	1332319366000	18389	9268	0	0	\N
142445	2134	97280858000	18389	9268	1	0	\N
142446	2132	148561562000	18389	9268	2	0	\N
142449	1397	1332309365000	18391	9269	0	0	\N
142450	2134	97279855000	18391	9269	1	0	\N
142451	1397	1332309365000	18392	9269	0	0	\N
142452	2134	97279855000	18392	9269	1	0	\N
142455	1397	1332299364000	18394	9270	0	0	\N
142456	2134	97278852000	18394	9270	1	0	\N
142467	1397	1332249359000	18399	9275	0	0	\N
142468	1397	1332239358000	18399	9275	1	0	\N
142469	2134	97273837000	18399	9275	2	0	\N
142470	2134	97272834000	18399	9275	3	0	\N
142477	1397	1332219356000	18402	9277	0	0	\N
142478	2134	97270828000	18402	9277	1	0	\N
142479	2132	148558559000	18402	9277	2	0	\N
142480	1397	1332219356000	18403	9277	0	0	\N
142481	2134	97270828000	18403	9277	1	0	\N
142482	2132	148558559000	18403	9277	2	0	\N
142489	1397	1332209355000	18406	9278	0	0	\N
142490	1397	1332199354000	18406	9278	1	0	\N
142491	2134	97269825000	18406	9278	2	0	\N
142503	1397	1332149349000	18411	9283	0	0	\N
142504	2133	97507020000	18411	9283	1	0	\N
142505	2134	97264810000	18411	9283	2	0	\N
142506	1397	1332149349000	18412	9283	0	0	\N
142507	2133	97507020000	18412	9283	1	0	\N
142508	2134	97264810000	18412	9283	2	0	\N
142512	1397	1332139348000	18414	9284	0	0	\N
142513	1397	1332129347000	18414	9284	1	0	\N
142514	1397	1332119346000	18414	9284	2	0	\N
142515	2132	148555556000	18414	9284	3	0	\N
142516	2134	97263807000	18414	9284	4	0	\N
142517	2133	97506018000	18414	9284	5	0	\N
142518	2133	97505016000	18414	9284	6	0	\N
142519	2134	97262804000	18414	9284	7	0	\N
142520	2133	97504014000	18414	9284	8	0	\N
142521	2134	97261801000	18414	9284	9	0	\N
142424	2134	97287879000	18382	9264	3	0	1707
142425	2134	97286876000	18382	9264	4	0	1708
142426	2132	148563564000	18382	9264	5	0	436
142427	1397	1332369371000	18383	9265	0	0	10646
142428	1397	1332359370000	18383	9265	1	0	10647
142430	2134	97285873000	18383	9265	3	0	1709
142431	2134	97284870000	18383	9265	4	0	1710
142432	1397	1332349369000	18385	9266	0	0	10648
142433	2134	97283867000	18385	9266	1	0	1711
142434	1397	1332339368000	18386	9267	0	0	10649
142436	2134	97282864000	18386	9267	2	0	1712
142437	2134	97281861000	18386	9267	3	0	1713
142441	1397	1332319366000	18388	9268	0	0	10651
142442	2134	97280858000	18388	9268	1	0	1714
142447	1397	1332309365000	18390	9269	0	0	10652
142448	2134	97279855000	18390	9269	1	0	1715
142453	1397	1332299364000	18393	9270	0	0	10653
142454	2134	97278852000	18393	9270	1	0	1716
142457	1397	1332289363000	18395	9271	0	0	10654
142459	2132	148560561000	18395	9271	2	0	439
142460	1397	1332279362000	18396	9272	0	0	10655
142461	2134	97276846000	18396	9272	1	0	1718
142462	1397	1332269361000	18397	9273	0	0	10656
142463	2134	97275843000	18397	9273	1	0	1719
142465	2134	97274840000	18398	9274	1	0	1720
142466	2132	148559560000	18398	9274	2	0	440
142471	1397	1332249359000	18400	9275	0	0	10658
142472	1397	1332239358000	18400	9275	1	0	10659
142474	2134	97272834000	18400	9275	3	0	1722
142475	1397	1332229357000	18401	9276	0	0	10660
142476	2134	97271831000	18401	9276	1	0	1723
142483	1397	1332219356000	18404	9277	0	0	10661
142484	2134	97270828000	18404	9277	1	0	1724
142486	1397	1332209355000	18405	9278	0	0	10662
142487	1397	1332199354000	18405	9278	1	0	10663
142488	2134	97269825000	18405	9278	2	0	1725
142492	1397	1332189353000	18407	9279	0	0	10664
142493	2134	97268822000	18407	9279	1	0	1726
142495	1397	1332179352000	18408	9280	0	0	10665
142496	2134	97267819000	18408	9280	1	0	1727
142497	1397	1332169351000	18409	9281	0	0	10666
142498	2134	97266816000	18409	9281	1	0	1728
142500	1397	1332159350000	18410	9282	0	0	10667
142501	2132	148556557000	18410	9282	1	0	443
142502	2134	97265813000	18410	9282	2	0	1729
142509	1397	1332149349000	18413	9283	0	0	10668
142510	2133	97507020000	18413	9283	1	0	1490
142522	1397	1332139348000	18415	9284	0	0	10669
142523	1397	1332129347000	18415	9284	1	0	10670
142524	1397	1332119346000	18415	9284	2	0	10671
142525	2132	148555556000	18415	9284	3	0	444
142526	2134	97263807000	18415	9284	4	0	1731
142528	2133	97505016000	18415	9284	6	0	1492
142532	1397	1332139348000	18416	9284	0	0	\N
142533	1397	1332129347000	18416	9284	1	0	\N
142534	1397	1332119346000	18416	9284	2	0	\N
142535	2132	148555556000	18416	9284	3	0	\N
142536	2133	97506018000	18416	9284	4	0	\N
142537	2133	97505016000	18416	9284	5	0	\N
142538	2133	97504014000	18416	9284	6	0	\N
142542	2133	97507020000	18418	9270	0	0	\N
142543	1926	1191000000	18418	9270	1	0	\N
142544	2133	97506018000	18418	9270	2	0	\N
142545	2133	97505016000	18418	9270	3	0	\N
142546	2133	97504014000	18418	9270	4	0	\N
142547	2133	97503012000	18418	9270	5	0	\N
142548	2133	97502010000	18418	9270	6	0	\N
142549	1397	1332099344000	18419	9286	0	0	\N
142550	2134	97259795000	18419	9286	1	0	\N
142551	2133	97502010000	18419	9286	2	0	\N
142559	1397	1332209355000	18422	9278	0	0	\N
142560	1397	1332199354000	18422	9278	1	0	\N
142561	1397	1332189353000	18422	9278	2	0	\N
142562	1397	1332179352000	18422	9278	3	0	\N
142563	1397	1332169351000	18422	9278	4	0	\N
142564	1397	1332159350000	18422	9278	5	0	\N
142565	1397	1332149349000	18422	9278	6	0	\N
142566	1397	1332139348000	18422	9278	7	0	\N
142567	1397	1332129347000	18422	9278	8	0	\N
142568	1397	1332119346000	18422	9278	9	0	\N
142569	1397	1332109345000	18422	9278	10	0	\N
142570	1397	1332099344000	18422	9278	11	0	\N
142571	2133	97507020000	18422	9278	12	0	\N
142572	2134	97269825000	18422	9278	13	0	\N
142573	2134	97268822000	18422	9278	14	0	\N
142574	2134	97267819000	18422	9278	15	0	\N
142575	2134	97266816000	18422	9278	16	0	\N
142576	1926	1191000000	18422	9278	17	0	\N
142577	2133	97506018000	18422	9278	18	0	\N
142578	2133	97505016000	18422	9278	19	0	\N
142579	2132	148557558000	18422	9278	20	0	\N
142580	2132	148556557000	18422	9278	21	0	\N
142581	2132	148555556000	18422	9278	22	0	\N
142582	2133	97504014000	18422	9278	23	0	\N
142583	2134	97265813000	18422	9278	24	0	\N
142584	2134	97264810000	18422	9278	25	0	\N
142585	2134	97263807000	18422	9278	26	0	\N
142586	2134	97262804000	18422	9278	27	0	\N
142587	2134	97261801000	18422	9278	28	0	\N
142588	2134	97260798000	18422	9278	29	0	\N
142589	2134	97259795000	18422	9278	30	0	\N
142590	2133	97503012000	18422	9278	31	0	\N
142591	2133	97502010000	18422	9278	32	0	\N
142592	2133	97501008000	18422	9278	33	0	\N
142596	1397	1332079342000	18424	9288	0	0	\N
142597	2133	97500006000	18424	9288	2	0	\N
142598	2134	97257789000	18424	9288	3	0	\N
142604	1397	1332229357000	18427	9276	0	0	\N
142605	1397	1332219356000	18427	9276	1	0	\N
142606	1397	1332209355000	18427	9276	2	0	\N
142607	1397	1332199354000	18427	9276	3	0	\N
142608	1397	1332189353000	18427	9276	4	0	\N
142609	1397	1332179352000	18427	9276	5	0	\N
142610	1397	1332169351000	18427	9276	6	0	\N
142611	1397	1332159350000	18427	9276	7	0	\N
142612	1397	1332149349000	18427	9276	8	0	\N
142613	1397	1332139348000	18427	9276	9	0	\N
142614	1397	1332129347000	18427	9276	10	0	\N
142615	1397	1332119346000	18427	9276	11	0	\N
142616	1397	1332109345000	18427	9276	12	0	\N
142617	1397	1332099344000	18427	9276	13	0	\N
142618	1397	1332089343000	18427	9276	14	0	\N
142619	1397	1332079342000	18427	9276	15	0	\N
142620	1397	1332069341000	18427	9276	16	0	\N
142621	1397	1332059340000	18427	9276	17	0	\N
142622	1397	1332049339000	18427	9276	18	0	\N
142623	2134	97271831000	18427	9276	19	0	\N
142624	2133	97507020000	18427	9276	20	0	\N
142625	1926	1191000000	18427	9276	21	0	\N
142626	2133	97506018000	18427	9276	22	0	\N
142627	2134	97270828000	18427	9276	23	0	\N
142628	2134	97269825000	18427	9276	24	0	\N
142629	2134	97268822000	18427	9276	25	0	\N
142630	2134	97267819000	18427	9276	26	0	\N
142631	2134	97266816000	18427	9276	27	0	\N
142632	2133	97505016000	18427	9276	28	0	\N
142633	2132	148558559000	18427	9276	29	0	\N
142634	2132	148557558000	18427	9276	30	0	\N
142635	2132	148556557000	18427	9276	31	0	\N
142636	2132	148555556000	18427	9276	32	0	\N
142637	2132	148554555000	18427	9276	33	0	\N
142638	2132	148553554000	18427	9276	34	0	\N
142639	2133	97504014000	18427	9276	35	0	\N
142640	2134	97265813000	18427	9276	36	0	\N
142641	2134	97264810000	18427	9276	37	0	\N
142642	2134	97263807000	18427	9276	38	0	\N
142643	2134	97262804000	18427	9276	39	0	\N
142644	2134	97261801000	18427	9276	40	0	\N
142645	2134	97260798000	18427	9276	41	0	\N
142646	2134	97259795000	18427	9276	42	0	\N
142647	2134	97258792000	18427	9276	43	0	\N
142648	2134	97257789000	18427	9276	44	0	\N
142649	2134	97256786000	18427	9276	45	0	\N
142650	2133	97503012000	18427	9276	46	0	\N
142651	2133	97502010000	18427	9276	47	0	\N
142652	2133	97501008000	18427	9276	48	0	\N
142653	2133	97500006000	18427	9276	49	0	\N
142654	2133	97499004000	18427	9276	50	0	\N
142655	2133	97498002000	18427	9276	51	0	\N
142656	2133	97497000000	18427	9276	52	0	\N
142657	2134	97255783000	18427	9276	53	0	\N
142662	1397	1332039338000	18429	9292	0	0	\N
142663	2133	97495998000	18429	9292	1	0	\N
142664	2134	97254780000	18429	9292	2	0	\N
142531	2134	97261801000	18415	9284	9	0	1733
142539	1397	1332109345000	18417	9285	0	0	10672
142540	2134	97260798000	18417	9285	1	0	1734
142541	2133	97503012000	18417	9285	2	0	1494
142552	1397	1332099344000	18420	9286	0	0	10673
142554	2133	97502010000	18420	9286	2	0	1495
142555	1397	1332089343000	18421	9287	0	0	10674
142556	2133	97501008000	18421	9287	1	0	1496
142557	2132	148554555000	18421	9287	2	0	445
142558	2134	97258792000	18421	9287	3	0	1736
142594	2133	97500006000	18423	9288	2	0	1497
142595	2134	97257789000	18423	9288	3	0	1737
142599	1397	1332069341000	18425	9289	0	0	10676
142600	2133	97499004000	18425	9289	1	0	1498
142602	2133	97498002000	18426	9290	1	0	1499
142603	2134	97256786000	18426	9290	2	0	1738
142658	1397	1332049339000	18428	9291	0	0	10678
142659	2132	148553554000	18428	9291	1	0	446
142660	2133	97497000000	18428	9291	2	0	1500
142668	1397	1332029337000	18431	9293	0	0	\N
142669	1397	1332019336000	18431	9293	1	0	\N
142670	2132	148552553000	18431	9293	2	0	\N
142671	2134	97253777000	18431	9293	3	0	\N
142672	2134	97252774000	18431	9293	4	0	\N
142673	2133	97494996000	18431	9293	5	0	\N
142674	2133	97493994000	18431	9293	6	0	\N
142675	1397	1332029337000	18432	9293	0	0	\N
142676	1397	1332019336000	18432	9293	1	0	\N
142677	2132	148552553000	18432	9293	2	0	\N
142678	2134	97253777000	18432	9293	3	0	\N
142679	2134	97252774000	18432	9293	4	0	\N
142680	2133	97494996000	18432	9293	5	0	\N
142681	2133	97493994000	18432	9293	6	0	\N
142682	1397	1332029337000	18433	9293	0	0	\N
142683	1397	1332019336000	18433	9293	1	0	\N
142684	2132	148552553000	18433	9293	2	0	\N
142685	2134	97253777000	18433	9293	3	0	\N
142686	2134	97252774000	18433	9293	4	0	\N
142687	2133	97494996000	18433	9293	5	0	\N
142688	2133	97493994000	18433	9293	6	0	\N
142696	369	83969132000000	18435	9119	0	0	\N
142697	2165	90000000	18435	9119	1	0	\N
142698	369	83732032000000	18435	9119	2	0	\N
142699	369	83571932000000	18435	9119	3	0	\N
142700	369	83125832000000	18435	9119	4	0	\N
142701	369	83119112000000	18435	9119	5	0	\N
142702	369	83107162000000	18435	9119	6	0	\N
142703	369	83099062000000	18435	9119	7	0	\N
142704	369	83076662000000	18435	9119	8	0	\N
142705	1643	1783113314700	18435	9119	9	0	\N
142706	1643	1450542514700	18435	9119	10	0	\N
142707	1643	1226180514700	18435	9119	11	0	\N
142708	1643	1040532914700	18435	9119	12	0	\N
142709	2165	80000000	18435	9119	13	0	\N
142710	2165	70000000	18435	9119	14	0	\N
142711	2165	60000000	18435	9119	15	0	\N
142712	2165	50000000	18435	9119	16	0	\N
142713	1397	1333929527000	18435	9119	17	0	\N
142714	1397	1333919526000	18435	9119	18	0	\N
142715	1397	1333909525000	18435	9119	19	0	\N
142716	1397	1333899524000	18435	9119	20	0	\N
142717	1397	1333889523000	18435	9119	21	0	\N
142718	1397	1333879522000	18435	9119	22	0	\N
142719	1397	1333869521000	18435	9119	23	0	\N
142720	1397	1333859520000	18435	9119	24	0	\N
142721	1397	1333849519000	18435	9119	25	0	\N
142722	1397	1333839518000	18435	9119	26	0	\N
142723	1397	1333829517000	18435	9119	27	0	\N
142724	1397	1333819516000	18435	9119	28	0	\N
142725	1397	1333809515000	18435	9119	29	0	\N
142726	1397	1333799514000	18435	9119	30	0	\N
142727	1397	1333789513000	18435	9119	31	0	\N
142728	1397	1333779512000	18435	9119	32	0	\N
142729	1397	1333769511000	18435	9119	33	0	\N
142730	1397	1333759510000	18435	9119	34	0	\N
142731	1397	1333749509000	18435	9119	35	0	\N
142732	1397	1333739508000	18435	9119	36	0	\N
142733	1397	1333729507000	18435	9119	37	0	\N
142734	1397	1333719506000	18435	9119	38	0	\N
142735	1397	1333709505000	18435	9119	39	0	\N
142736	1397	1333699504000	18435	9119	40	0	\N
142737	1397	1333689503000	18435	9119	41	0	\N
142738	1397	1333679502000	18435	9119	42	0	\N
142739	1397	1333669501000	18435	9119	43	0	\N
142740	1397	1333659500000	18435	9119	44	0	\N
142741	1397	1333649499000	18435	9119	45	0	\N
142742	1397	1333639498000	18435	9119	46	0	\N
142743	1397	1333629497000	18435	9119	47	0	\N
142744	1397	1333619496000	18435	9119	48	0	\N
142745	1397	1333609495000	18435	9119	49	0	\N
142746	1397	1333599494000	18435	9119	50	0	\N
142747	1397	1333589493000	18435	9119	51	0	\N
142748	1397	1333579492000	18435	9119	52	0	\N
142749	1397	1333569491000	18435	9119	53	0	\N
142750	1397	1333559490000	18435	9119	54	0	\N
142751	1397	1333549489000	18435	9119	55	0	\N
142752	1397	1333539488000	18435	9119	56	0	\N
142753	1397	1333529487000	18435	9119	57	0	\N
142754	1397	1333519486000	18435	9119	58	0	\N
142755	1397	1333509485000	18435	9119	59	0	\N
142756	1397	1333499484000	18435	9119	60	0	\N
142757	1397	1333489483000	18435	9119	61	0	\N
142758	1397	1333479482000	18435	9119	62	0	\N
142759	1397	1333469481000	18435	9119	64	0	\N
142760	1397	1333459480000	18435	9119	65	0	\N
142761	1397	1333449479000	18435	9119	66	0	\N
142762	1397	1333439478000	18435	9119	67	0	\N
142763	1397	1333429477000	18435	9119	68	0	\N
142764	1397	1333419476000	18435	9119	69	0	\N
142765	1397	1333409475000	18435	9119	70	0	\N
142766	1397	1333399474000	18435	9119	71	0	\N
142767	1397	1333389473000	18435	9119	72	0	\N
142768	1397	1333379472000	18435	9119	73	0	\N
142769	1397	1333369471000	18435	9119	74	0	\N
142770	1397	1333359470000	18435	9119	75	0	\N
142771	1397	1333349469000	18435	9119	76	0	\N
142772	1397	1333339468000	18435	9119	77	0	\N
142773	1397	1333329467000	18435	9119	78	0	\N
142774	1397	1333319466000	18435	9119	79	0	\N
142775	1397	1333309465000	18435	9119	80	0	\N
142776	1397	1333299464000	18435	9119	81	0	\N
142777	1397	1333289463000	18435	9119	82	0	\N
142778	1397	1333279462000	18435	9119	83	0	\N
142779	1397	1333269461000	18435	9119	84	0	\N
142780	1397	1333259460000	18435	9119	85	0	\N
142781	1397	1333249459000	18435	9119	86	0	\N
142782	1397	1333239458000	18435	9119	87	0	\N
142783	1397	1333229457000	18435	9119	88	0	\N
142784	1397	1333219456000	18435	9119	89	0	\N
142785	1397	1333209455000	18435	9119	90	0	\N
142786	1397	1333199454000	18435	9119	91	0	\N
142787	1397	1333189453000	18435	9119	92	0	\N
142788	1397	1333179452000	18435	9119	93	0	\N
142789	1397	1333169451000	18435	9119	94	0	\N
142790	1397	1333159450000	18435	9119	95	0	\N
142791	1397	1333149449000	18435	9119	96	0	\N
142792	1397	1333139448000	18435	9119	97	0	\N
142793	1397	1333129447000	18435	9119	98	0	\N
142794	1397	1333119446000	18435	9119	99	0	\N
142795	1397	1333109445000	18435	9119	100	0	\N
142796	1397	1333099444000	18435	9119	101	0	\N
142797	1397	1333089443000	18435	9119	102	0	\N
142798	1397	1333079442000	18435	9119	103	0	\N
142799	1397	1333069441000	18435	9119	104	0	\N
142800	1397	1333059440000	18435	9119	105	0	\N
142667	2134	97254780000	18430	9292	2	0	1740
142689	1397	1332029337000	18434	9293	0	0	10680
142690	1397	1332019336000	18434	9293	1	0	10681
142691	2132	148552553000	18434	9293	2	0	447
142692	2134	97253777000	18434	9293	3	0	1741
142694	2133	97494996000	18434	9293	5	0	1502
142695	2133	97493994000	18434	9293	6	0	1503
142801	1397	1333049439000	18435	9119	106	0	\N
142802	1397	1333039438000	18435	9119	107	0	\N
142803	1397	1333029437000	18435	9119	108	0	\N
142804	1397	1333019436000	18435	9119	109	0	\N
142805	1397	1333009435000	18435	9119	110	0	\N
142806	1397	1332999434000	18435	9119	111	0	\N
142807	1397	1332989433000	18435	9119	112	0	\N
142808	1397	1332979432000	18435	9119	113	0	\N
142809	1397	1332969431000	18435	9119	114	0	\N
142810	1397	1332959430000	18435	9119	115	0	\N
142811	1397	1332949429000	18435	9119	116	0	\N
142812	1397	1332939428000	18435	9119	117	0	\N
142813	1397	1332929427000	18435	9119	118	0	\N
142814	1397	1332919426000	18435	9119	119	0	\N
142815	1397	1332909425000	18435	9119	120	0	\N
142816	1397	1332899424000	18435	9119	121	0	\N
142817	1397	1332889423000	18435	9119	122	0	\N
142818	1397	1332879422000	18435	9119	123	0	\N
142819	1397	1332869421000	18435	9119	124	0	\N
142820	1397	1332859420000	18435	9119	125	0	\N
142824	1397	1332009335000	18437	9294	0	0	\N
142825	2134	97251771000	18437	9294	1	0	\N
142826	2133	97492992000	18437	9294	2	0	\N
142827	2134	97251771000	18438	9294	0	0	\N
142828	2133	97492992000	18438	9294	1	0	\N
142829	2134	97251771000	18439	9294	0	0	\N
142830	2133	97492992000	18439	9294	1	0	\N
142831	1397	1332009335000	18440	9294	0	0	\N
142832	2134	97251771000	18440	9294	1	0	\N
142833	2133	97492992000	18440	9294	2	0	\N
142840	1397	1331979332000	18442	9296	0	0	\N
142841	2133	97489986000	18442	9296	1	0	\N
142842	2134	97249765000	18442	9296	2	0	\N
142849	1397	1331959330000	18445	9298	0	0	\N
142850	2133	97487982000	18445	9298	1	0	\N
142851	2134	97247759000	18445	9298	2	0	\N
142859	1397	1331949329000	18448	9299	0	0	\N
142860	2132	148550551000	18448	9299	1	0	\N
142861	2134	97246756000	18448	9299	2	0	\N
142862	2133	97486980000	18448	9299	3	0	\N
142863	1397	1331949329000	18449	9299	0	0	\N
142864	2132	148550551000	18449	9299	1	0	\N
142865	2134	97246756000	18449	9299	2	0	\N
142866	2133	97486980000	18449	9299	3	0	\N
142867	1397	1331939328000	18450	9300	0	0	\N
142868	2133	97485978000	18450	9300	1	0	\N
142869	2134	97245753000	18450	9300	2	0	\N
142870	1397	1331939328000	18451	9300	0	0	\N
142871	2133	97485978000	18451	9300	1	0	\N
142872	2134	97245753000	18451	9300	2	0	\N
142876	1397	1332369371000	18453	9265	0	0	\N
142877	1397	1332359370000	18453	9265	1	0	\N
142878	1397	1332349369000	18453	9265	2	0	\N
142879	1397	1332339368000	18453	9265	3	0	\N
142880	1397	1332329367000	18453	9265	4	0	\N
142881	1397	1332319366000	18453	9265	5	0	\N
142882	1397	1332309365000	18453	9265	6	0	\N
142883	1397	1332299364000	18453	9265	7	0	\N
142884	1397	1332289363000	18453	9265	8	0	\N
142885	1397	1332279362000	18453	9265	9	0	\N
142886	1397	1332269361000	18453	9265	10	0	\N
142887	1397	1332259360000	18453	9265	11	0	\N
142888	1397	1332249359000	18453	9265	12	0	\N
142889	1397	1332239358000	18453	9265	13	0	\N
142890	1397	1332229357000	18453	9265	14	0	\N
142891	1397	1332219356000	18453	9265	15	0	\N
142892	1397	1332209355000	18453	9265	16	0	\N
142893	1397	1332199354000	18453	9265	17	0	\N
142894	1397	1332189353000	18453	9265	18	0	\N
142895	1397	1332179352000	18453	9265	19	0	\N
142896	1397	1332169351000	18453	9265	20	0	\N
142897	1397	1332159350000	18453	9265	21	0	\N
142898	1397	1332149349000	18453	9265	22	0	\N
142899	1397	1332139348000	18453	9265	23	0	\N
142900	1397	1332129347000	18453	9265	24	0	\N
142901	1397	1332119346000	18453	9265	25	0	\N
142902	1397	1332109345000	18453	9265	26	0	\N
142903	1397	1332099344000	18453	9265	27	0	\N
142904	1397	1332089343000	18453	9265	28	0	\N
142905	1397	1332079342000	18453	9265	29	0	\N
142906	1397	1332069341000	18453	9265	30	0	\N
142907	1397	1332059340000	18453	9265	31	0	\N
142908	1397	1332049339000	18453	9265	32	0	\N
142909	1397	1332039338000	18453	9265	33	0	\N
142910	1397	1332029337000	18453	9265	34	0	\N
142911	1397	1332019336000	18453	9265	35	0	\N
142912	1397	1332009335000	18453	9265	36	0	\N
142913	1397	1331999334000	18453	9265	37	0	\N
142914	1397	1331989333000	18453	9265	38	0	\N
142915	1397	1331979332000	18453	9265	39	0	\N
142916	1397	1331969331000	18453	9265	40	0	\N
142917	1397	1331959330000	18453	9265	41	0	\N
142918	1397	1331949329000	18453	9265	42	0	\N
142919	1397	1331939328000	18453	9265	43	0	\N
142920	2132	148562563000	18453	9265	44	0	\N
142921	2133	97507020000	18453	9265	45	0	\N
142922	1926	1191000000	18453	9265	46	0	\N
142923	2133	97506018000	18453	9265	47	0	\N
142924	2133	97505016000	18453	9265	48	0	\N
142925	2133	97504014000	18453	9265	49	0	\N
142926	2134	97285873000	18453	9265	50	0	\N
142927	2134	97284870000	18453	9265	51	0	\N
142928	2134	97283867000	18453	9265	52	0	\N
142929	2134	97282864000	18453	9265	53	0	\N
142930	2132	148561562000	18453	9265	54	0	\N
142931	2132	148560561000	18453	9265	55	0	\N
142932	2133	97503012000	18453	9265	56	0	\N
142933	2133	97502010000	18453	9265	57	0	\N
142934	2133	97501008000	18453	9265	58	0	\N
142935	2133	97500006000	18453	9265	59	0	\N
142936	2133	97499004000	18453	9265	60	0	\N
142823	2133	97492992000	18436	9294	2	0	1504
142834	1397	1331999334000	18441	9295	0	0	10683
142835	1397	1331989333000	18441	9295	1	0	10684
142836	2133	97491990000	18441	9295	2	0	1505
142837	2134	97250768000	18441	9295	3	0	1744
142839	2133	97490988000	18441	9295	5	0	1506
142843	1397	1331979332000	18443	9296	0	0	10685
142844	2133	97489986000	18443	9296	1	0	1507
142845	2134	97249765000	18443	9296	2	0	1745
142846	1397	1331969331000	18444	9297	0	0	10686
142848	2133	97488984000	18444	9297	2	0	1508
142852	1397	1331959330000	18446	9298	0	0	10687
142853	2133	97487982000	18446	9298	1	0	1509
142854	2134	97247759000	18446	9298	2	0	1747
142856	2132	148550551000	18447	9299	1	0	449
142857	2134	97246756000	18447	9299	2	0	1748
142858	2133	97486980000	18447	9299	3	0	1510
142873	1397	1331939328000	18452	9300	0	0	10689
142874	2133	97485978000	18452	9300	1	0	1511
142937	2133	97498002000	18453	9265	61	0	\N
142938	2133	97497000000	18453	9265	62	0	\N
142939	2133	97495998000	18453	9265	63	0	\N
142940	2133	97494996000	18453	9265	64	0	\N
142941	2133	97493994000	18453	9265	65	0	\N
142942	2133	97492992000	18453	9265	66	0	\N
142943	2133	97491990000	18453	9265	67	0	\N
142944	2133	97490988000	18453	9265	68	0	\N
142945	2133	97489986000	18453	9265	69	0	\N
142946	2133	97488984000	18453	9265	70	0	\N
142947	2133	97487982000	18453	9265	71	0	\N
142948	2132	148559560000	18453	9265	72	0	\N
142949	2132	148558559000	18453	9265	73	0	\N
142950	2132	148557558000	18453	9265	74	0	\N
142951	2132	148556557000	18453	9265	75	0	\N
142952	2132	148555556000	18453	9265	76	0	\N
142953	2132	148554555000	18453	9265	77	0	\N
142954	2132	148553554000	18453	9265	78	0	\N
142955	2132	148552553000	18453	9265	79	0	\N
142956	2132	148551552000	18453	9265	80	0	\N
142957	2132	148550551000	18453	9265	81	0	\N
142958	2134	97281861000	18453	9265	82	0	\N
142959	2134	97280858000	18453	9265	83	0	\N
142960	2134	97279855000	18453	9265	84	0	\N
142961	2134	97278852000	18453	9265	85	0	\N
142962	2134	97277849000	18453	9265	86	0	\N
142963	2134	97276846000	18453	9265	87	0	\N
142964	2134	97275843000	18453	9265	88	0	\N
142965	2134	97274840000	18453	9265	89	0	\N
142966	2134	97273837000	18453	9265	90	0	\N
142967	2134	97272834000	18453	9265	91	0	\N
142968	2134	97271831000	18453	9265	92	0	\N
142969	2134	97270828000	18453	9265	93	0	\N
142970	2134	97269825000	18453	9265	94	0	\N
142971	2134	97268822000	18453	9265	95	0	\N
142972	2134	97267819000	18453	9265	96	0	\N
142973	2134	97266816000	18453	9265	97	0	\N
142974	2134	97265813000	18453	9265	98	0	\N
142975	2134	97264810000	18453	9265	99	0	\N
142976	2134	97263807000	18453	9265	100	0	\N
142977	2134	97262804000	18453	9265	101	0	\N
142978	2134	97261801000	18453	9265	102	0	\N
142979	2134	97260798000	18453	9265	103	0	\N
142980	2134	97259795000	18453	9265	104	0	\N
142981	2134	97258792000	18453	9265	105	0	\N
142982	2134	97257789000	18453	9265	106	0	\N
142983	2134	97256786000	18453	9265	107	0	\N
142984	2134	97255783000	18453	9265	108	0	\N
142985	2134	97254780000	18453	9265	109	0	\N
142986	2134	97253777000	18453	9265	110	0	\N
142987	2134	97252774000	18453	9265	111	0	\N
142988	2134	97251771000	18453	9265	112	0	\N
142989	2134	97250768000	18453	9265	113	0	\N
142990	2134	97249765000	18453	9265	114	0	\N
142991	2134	97248762000	18453	9265	115	0	\N
142992	2134	97247759000	18453	9265	116	0	\N
142993	2134	97246756000	18453	9265	117	0	\N
142997	1397	1331929327000	18455	9301	0	0	\N
142998	2133	97484976000	18455	9301	1	0	\N
142999	2134	97244750000	18455	9301	2	0	\N
143000	1397	1331919326000	18456	9302	0	0	\N
143001	2134	97243747000	18456	9302	1	0	\N
143002	2132	148549550000	18456	9302	2	0	\N
143007	1397	1331919326000	18458	9302	0	0	\N
143008	2133	97483974000	18458	9302	1	0	\N
143009	2134	97243747000	18458	9302	2	0	\N
143010	2132	148549550000	18458	9302	3	0	\N
143011	1397	1331919326000	18459	9302	0	0	\N
143012	2133	97483974000	18459	9302	1	0	\N
143013	2134	97243747000	18459	9302	2	0	\N
143014	2132	148549550000	18459	9302	3	0	\N
143015	1397	1331919326000	18460	9302	0	0	\N
143016	2133	97483974000	18460	9302	1	0	\N
143017	2134	97243747000	18460	9302	2	0	\N
143018	2132	148549550000	18460	9302	3	0	\N
143022	1397	1331899324000	18463	9304	0	0	\N
143023	2133	97481970000	18463	9304	1	0	\N
143026	1397	1331899324000	18465	9304	0	0	\N
143027	2133	97481970000	18465	9304	1	0	\N
143028	1397	1331899324000	18466	9304	0	0	\N
143029	2133	97481970000	18466	9304	1	0	\N
143037	1397	1331889323000	18468	9305	0	0	\N
143038	1397	1331879322000	18468	9305	1	0	\N
143039	2132	148548549000	18468	9305	2	0	\N
143040	2134	97241741000	18468	9305	3	0	\N
143041	2134	97240738000	18468	9305	4	0	\N
143042	2133	97480968000	18468	9305	5	0	\N
143043	2133	97479966000	18468	9305	6	0	\N
143055	1397	1331839318000	18470	9307	0	0	\N
143056	2134	97236726000	18470	9307	1	0	\N
143057	1397	1331839318000	18471	9307	0	0	\N
143058	2133	97475958000	18471	9307	1	0	\N
143059	2134	97236726000	18471	9307	2	0	\N
143063	1397	1331839318000	18473	9307	0	0	\N
143064	2133	97475958000	18473	9307	1	0	\N
143065	2134	97236726000	18473	9307	2	0	\N
143066	1397	1331829317000	18474	9308	0	0	\N
143067	1397	1331819316000	18474	9308	1	0	\N
143068	2133	97474956000	18474	9308	2	0	\N
143069	2132	148546547000	18474	9308	3	0	\N
143070	2134	97235723000	18474	9308	4	0	\N
143071	2134	97234720000	18474	9308	5	0	\N
143072	2133	97473954000	18474	9308	6	0	\N
142996	2134	97244750000	18454	9301	2	0	1750
143003	1397	1331919326000	18457	9302	0	0	10691
143004	2133	97483974000	18457	9302	1	0	1513
143005	2134	97243747000	18457	9302	2	0	1751
143006	2132	148549550000	18457	9302	3	0	450
143020	2133	97482972000	18462	9303	1	0	1514
143021	2134	97242744000	18462	9303	2	0	1752
143024	1397	1331899324000	18464	9304	0	0	10693
143025	2133	97481970000	18464	9304	1	0	1515
143030	1397	1331889323000	18467	9305	0	0	10694
143032	2132	148548549000	18467	9305	2	0	451
143033	2134	97241741000	18467	9305	3	0	1753
143034	2134	97240738000	18467	9305	4	0	1754
143035	2133	97480968000	18467	9305	5	0	1516
143044	1397	1331869321000	18469	9306	0	0	10696
143045	1397	1331859320000	18469	9306	1	0	10697
143046	1397	1331849319000	18469	9306	2	0	10698
143047	1726	104746112000	18469	9306	3	0	8200
143048	2133	97478964000	18469	9306	4	0	1518
143050	2134	97238732000	18469	9306	6	0	1756
143051	2134	97237729000	18469	9306	7	0	1757
143052	2133	97477962000	18469	9306	8	0	1519
143053	2133	97476960000	18469	9306	9	0	1520
143054	2132	148547548000	18469	9306	10	0	452
143061	2133	97475958000	18472	9307	1	0	1521
143062	2134	97236726000	18472	9307	2	0	1758
143073	2172	198999000	18474	9308	7	0	\N
143074	1397	1331829317000	18475	9308	0	0	\N
143075	1397	1331819316000	18475	9308	1	0	\N
143076	2133	97474956000	18475	9308	2	0	\N
143077	2132	148546547000	18475	9308	3	0	\N
143078	2134	97235723000	18475	9308	4	0	\N
143079	2134	97234720000	18475	9308	5	0	\N
143080	2133	97473954000	18475	9308	6	0	\N
143081	2172	198999000	18475	9308	7	0	\N
143082	1397	1331829317000	18476	9308	0	0	\N
143083	1397	1331819316000	18476	9308	1	0	\N
143084	2133	97474956000	18476	9308	2	0	\N
143085	2132	148546547000	18476	9308	3	0	\N
143086	2134	97235723000	18476	9308	4	0	\N
143087	2134	97234720000	18476	9308	5	0	\N
143088	2133	97473954000	18476	9308	6	0	\N
143089	2172	198999000	18476	9308	7	0	\N
143090	1397	1331829317000	18477	9308	0	0	\N
143091	1397	1331819316000	18477	9308	1	0	\N
143092	2133	97474956000	18477	9308	2	0	\N
143093	2132	148546547000	18477	9308	3	0	\N
143094	2134	97235723000	18477	9308	4	0	\N
143095	2134	97234720000	18477	9308	5	0	\N
143096	2133	97473954000	18477	9308	6	0	\N
143097	2172	198999000	18477	9308	7	0	\N
143098	1397	1331829317000	18478	9308	0	0	\N
143099	1397	1331819316000	18478	9308	1	0	\N
143100	2133	97474956000	18478	9308	2	0	\N
143101	2132	148546547000	18478	9308	3	0	\N
143102	2134	97235723000	18478	9308	4	0	\N
143103	2134	97234720000	18478	9308	5	0	\N
143104	2133	97473954000	18478	9308	6	0	\N
143105	2172	198999000	18478	9308	7	0	\N
143106	1397	1331829317000	18479	9308	0	0	\N
143107	1397	1331819316000	18479	9308	1	0	\N
143108	2133	97474956000	18479	9308	2	0	\N
143109	2132	148546547000	18479	9308	3	0	\N
143110	2134	97235723000	18479	9308	4	0	\N
143111	2134	97234720000	18479	9308	5	0	\N
143112	2133	97473954000	18479	9308	6	0	\N
143113	2172	198999000	18479	9308	7	0	\N
143114	1397	1331829317000	18480	9308	0	0	\N
143115	1397	1331819316000	18480	9308	1	0	\N
143116	2133	97474956000	18480	9308	2	0	\N
143117	2132	148546547000	18480	9308	3	0	\N
143118	2134	97235723000	18480	9308	4	0	\N
143119	2134	97234720000	18480	9308	5	0	\N
143120	2133	97473954000	18480	9308	6	0	\N
143121	2172	198999000	18480	9308	7	0	\N
143122	1397	1331829317000	18481	9308	0	0	\N
143123	1397	1331819316000	18481	9308	1	0	\N
143124	2133	97474956000	18481	9308	2	0	\N
143125	2132	148546547000	18481	9308	3	0	\N
143126	2134	97235723000	18481	9308	4	0	\N
143127	2134	97234720000	18481	9308	5	0	\N
143128	2133	97473954000	18481	9308	6	0	\N
143129	2172	198999000	18481	9308	7	0	\N
143130	1397	1331829317000	18482	9308	0	0	\N
143131	1397	1331819316000	18482	9308	1	0	\N
143132	2133	97474956000	18482	9308	2	0	\N
143133	2132	148546547000	18482	9308	3	0	\N
143134	2134	97235723000	18482	9308	4	0	\N
143135	2134	97234720000	18482	9308	5	0	\N
143136	2133	97473954000	18482	9308	6	0	\N
143137	2172	198999000	18482	9308	7	0	\N
143164	1397	1331769311000	18486	9310	0	0	\N
143165	2133	97472952000	18486	9310	1	0	\N
143166	2134	97228702000	18486	9310	2	0	\N
143167	2133	97471950000	18486	9310	3	0	\N
143168	2133	97470948000	18486	9310	4	0	\N
143169	2133	97469946000	18486	9310	5	0	\N
143170	2133	97468944000	18486	9310	6	0	\N
143171	2133	97467942000	18486	9310	7	0	\N
143172	1397	1331769311000	18487	9310	0	0	\N
143173	2133	97472952000	18487	9310	1	0	\N
143174	2134	97228702000	18487	9310	2	0	\N
143175	2133	97471950000	18487	9310	3	0	\N
143176	2133	97470948000	18487	9310	4	0	\N
143177	2133	97469946000	18487	9310	5	0	\N
143178	2133	97468944000	18487	9310	6	0	\N
143179	2133	97467942000	18487	9310	7	0	\N
143189	1397	1331739308000	18491	9313	0	0	\N
143190	2134	97226696000	18491	9313	1	0	\N
143191	2133	97464936000	18491	9313	2	0	\N
143192	1397	1331729307000	18492	9314	0	0	\N
143193	2133	97463934000	18492	9314	1	0	\N
143194	2132	148543544000	18492	9314	2	0	\N
143195	2134	97225693000	18492	9314	3	0	\N
143204	1397	1331719306000	18495	9315	0	0	\N
143205	1726	103536112000	18495	9315	1	0	\N
143206	2134	97224690000	18495	9315	2	0	\N
143207	2133	97462932000	18495	9315	3	0	\N
143208	1397	1331719306000	18496	9315	0	0	\N
143140	2133	97474956000	18483	9308	2	0	1522
143141	2132	148546547000	18483	9308	3	0	453
143142	2134	97235723000	18483	9308	4	0	1759
143143	2134	97234720000	18483	9308	5	0	1760
143144	2133	97473954000	18483	9308	6	0	1523
143146	1397	1331809315000	18484	9309	0	0	10702
143147	1397	1331799314000	18484	9309	1	0	10703
143148	1397	1331789313000	18484	9309	2	0	10704
143149	1397	1331779312000	18484	9309	3	0	10705
143150	2132	148545546000	18484	9309	4	0	454
143152	2134	97232714000	18484	9309	6	0	1762
143153	2134	97231711000	18484	9309	7	0	1763
143154	2134	97230708000	18484	9309	8	0	1764
143155	2134	97229705000	18484	9309	9	0	1765
143157	2133	97472952000	18485	9310	1	0	1524
143158	2134	97228702000	18485	9310	2	0	1766
143159	2133	97471950000	18485	9310	3	0	1525
143160	2133	97470948000	18485	9310	4	0	1526
143161	2133	97469946000	18485	9310	5	0	1527
143163	2133	97467942000	18485	9310	7	0	1529
143180	1397	1331759310000	18488	9311	0	0	10707
143181	2132	148544545000	18488	9311	1	0	455
143182	2133	97466940000	18488	9311	2	0	1530
143183	2134	97227699000	18488	9311	3	0	1767
143185	2133	97465938000	18489	9312	1	0	1531
143186	1397	1331739308000	18490	9313	0	0	10709
143187	2134	97226696000	18490	9313	1	0	1768
143188	2133	97464936000	18490	9313	2	0	1532
143197	2133	97463934000	18493	9314	1	0	1533
143198	2132	148543544000	18493	9314	2	0	456
143199	2134	97225693000	18493	9314	3	0	1769
143200	1397	1331719306000	18494	9315	0	0	10711
143201	1726	103536112000	18494	9315	1	0	8201
143203	2133	97462932000	18494	9315	3	0	1534
143209	1726	103536112000	18496	9315	1	0	\N
143210	2134	97224690000	18496	9315	2	0	\N
143211	2133	97462932000	18496	9315	3	0	\N
143227	369	83969132000000	18500	9153	0	0	\N
143228	369	83732032000000	18500	9153	1	0	\N
143229	369	83571932000000	18500	9153	2	0	\N
143230	369	83125832000000	18500	9153	3	0	\N
143231	369	83119112000000	18500	9153	4	0	\N
143232	369	83107162000000	18500	9153	5	0	\N
143233	369	83099062000000	18500	9153	6	0	\N
143234	369	83076662000000	18500	9153	7	0	\N
143235	1643	1783113314700	18500	9153	8	0	\N
143236	1643	1450542514700	18500	9153	9	0	\N
143237	1643	1226180514700	18500	9153	10	0	\N
143238	1643	1040532914700	18500	9153	11	0	\N
143239	1397	1333469481000	18500	9153	12	0	\N
143240	1397	1333459480000	18500	9153	14	0	\N
143241	1397	1333449479000	18500	9153	15	0	\N
143242	1397	1333439478000	18500	9153	16	0	\N
143243	1397	1333429477000	18500	9153	17	0	\N
143244	1397	1333419476000	18500	9153	18	0	\N
143245	1397	1333409475000	18500	9153	19	0	\N
143246	1397	1333399474000	18500	9153	20	0	\N
143247	1397	1333389473000	18500	9153	21	0	\N
143248	1397	1333379472000	18500	9153	22	0	\N
143249	1397	1333369471000	18500	9153	23	0	\N
143250	1397	1333359470000	18500	9153	24	0	\N
143251	1397	1333349469000	18500	9153	25	0	\N
143252	1397	1333339468000	18500	9153	26	0	\N
143253	1397	1333329467000	18500	9153	27	0	\N
143254	1397	1333319466000	18500	9153	28	0	\N
143255	1726	104745110000	18500	9153	29	0	\N
143256	1726	103535110000	18500	9153	30	0	\N
143257	1397	1333309465000	18500	9153	31	0	\N
143258	1397	1333299464000	18500	9153	32	0	\N
143259	1397	1333289463000	18500	9153	33	0	\N
143260	1397	1333279462000	18500	9153	34	0	\N
143261	1397	1333269461000	18500	9153	35	0	\N
143262	1397	1333259460000	18500	9153	36	0	\N
143263	1397	1333249459000	18500	9153	37	0	\N
143264	1397	1333239458000	18500	9153	38	0	\N
143265	1397	1333229457000	18500	9153	39	0	\N
143266	1397	1333219456000	18500	9153	40	0	\N
143267	1397	1333209455000	18500	9153	41	0	\N
143268	1397	1333199454000	18500	9153	42	0	\N
143269	1397	1333189453000	18500	9153	43	0	\N
143270	1397	1333179452000	18500	9153	44	0	\N
143271	1397	1333169451000	18500	9153	45	0	\N
143272	1397	1333159450000	18500	9153	46	0	\N
143273	1397	1333149449000	18500	9153	47	0	\N
143274	1397	1333139448000	18500	9153	48	0	\N
143275	1397	1333129447000	18500	9153	49	0	\N
143276	1397	1333119446000	18500	9153	50	0	\N
143277	1397	1333109445000	18500	9153	51	0	\N
143278	1397	1333099444000	18500	9153	52	0	\N
143279	1397	1333089443000	18500	9153	53	0	\N
143280	1397	1333079442000	18500	9153	54	0	\N
143281	1397	1333069441000	18500	9153	55	0	\N
143282	1397	1333059440000	18500	9153	56	0	\N
143283	1397	1333049439000	18500	9153	57	0	\N
143284	1397	1333039438000	18500	9153	58	0	\N
143285	1397	1333029437000	18500	9153	59	0	\N
143286	1397	1333019436000	18500	9153	60	0	\N
143287	1397	1333009435000	18500	9153	61	0	\N
143288	1397	1332999434000	18500	9153	62	0	\N
143289	1397	1332989433000	18500	9153	63	0	\N
143290	1397	1332979432000	18500	9153	64	0	\N
143291	1397	1332969431000	18500	9153	65	0	\N
143292	1397	1332959430000	18500	9153	66	0	\N
143293	1397	1332949429000	18500	9153	67	0	\N
143294	1397	1332939428000	18500	9153	68	0	\N
143295	1397	1332929427000	18500	9153	69	0	\N
143296	1397	1332919426000	18500	9153	70	0	\N
143297	1397	1332909425000	18500	9153	71	0	\N
143298	1397	1332899424000	18500	9153	72	0	\N
143299	1397	1332889423000	18500	9153	73	0	\N
143300	1397	1332879422000	18500	9153	74	0	\N
143301	1397	1332869421000	18500	9153	75	0	\N
143302	1397	1332859420000	18500	9153	76	0	\N
143303	1397	1332849419000	18500	9153	77	0	\N
143304	1397	1332839418000	18500	9153	78	0	\N
143305	1397	1332829417000	18500	9153	79	0	\N
143306	1397	1332819416000	18500	9153	80	0	\N
143307	1397	1332809415000	18500	9153	81	0	\N
143308	1397	1332799414000	18500	9153	82	0	\N
143309	1397	1332789413000	18500	9153	83	0	\N
143310	1397	1332779412000	18500	9153	84	0	\N
143311	1397	1332769411000	18500	9153	85	0	\N
143312	1397	1332759410000	18500	9153	86	0	\N
143313	1397	1332749409000	18500	9153	87	0	\N
143314	1397	1332739408000	18500	9153	88	0	\N
143315	1397	1332729407000	18500	9153	89	0	\N
143316	1397	1332719406000	18500	9153	90	0	\N
143317	1397	1332709405000	18500	9153	91	0	\N
143318	1397	1332699404000	18500	9153	92	0	\N
143319	1397	1332689403000	18500	9153	93	0	\N
143320	1397	1332679402000	18500	9153	94	0	\N
143321	1397	1332669401000	18500	9153	95	0	\N
143322	1397	1332659400000	18500	9153	96	0	\N
143323	1397	1332649399000	18500	9153	97	0	\N
143324	1397	1332639398000	18500	9153	98	0	\N
143325	1397	1332629397000	18500	9153	99	0	\N
143326	1397	1332619396000	18500	9153	100	0	\N
143327	1397	1332609395000	18500	9153	101	0	\N
143328	1397	1332599394000	18500	9153	102	0	\N
143329	1397	1332589393000	18500	9153	103	0	\N
143330	1397	1332579392000	18500	9153	104	0	\N
143331	1397	1332569391000	18500	9153	105	0	\N
143332	1397	1332559390000	18500	9153	106	0	\N
143333	1397	1332549389000	18500	9153	107	0	\N
143334	1397	1332539388000	18500	9153	108	0	\N
143335	1397	1332529387000	18500	9153	109	0	\N
143336	1397	1332519386000	18500	9153	110	0	\N
143337	1397	1332509385000	18500	9153	111	0	\N
143338	1397	1332499384000	18500	9153	112	0	\N
143339	1397	1332489383000	18500	9153	113	0	\N
143340	1397	1332479382000	18500	9153	114	0	\N
143341	1397	1332469381000	18500	9153	115	0	\N
143342	1397	1332459380000	18500	9153	116	0	\N
143343	1397	1332449379000	18500	9153	117	0	\N
143344	1397	1332439378000	18500	9153	118	0	\N
143214	2134	97223687000	18497	9316	2	0	1771
143215	2133	97461930000	18497	9316	3	0	1535
143216	1397	1331699304000	18498	9317	0	0	10713
143217	2133	97460928000	18498	9317	1	0	1536
143218	2132	148542543000	18498	9317	2	0	457
143220	1397	1331689303000	18499	9318	0	0	10714
143221	1397	1331679302000	18499	9318	1	0	10715
143222	2184	199000000	18499	9318	2	0	1
143223	2133	97459926000	18499	9318	3	0	1537
143224	2133	97458924000	18499	9318	4	0	1538
143226	2134	97220678000	18499	9318	6	0	1774
143345	1397	1332429377000	18500	9153	119	0	\N
143346	1397	1332419376000	18500	9153	120	0	\N
143347	1397	1332409375000	18500	9153	121	0	\N
143348	1397	1332399374000	18500	9153	122	0	\N
143349	1397	1332389373000	18500	9153	123	0	\N
143350	1397	1332379372000	18500	9153	124	0	\N
143351	1397	1332369371000	18500	9153	125	0	\N
143355	1397	1331669301000	18502	9319	0	0	\N
143356	2134	97219675000	18502	9319	1	0	\N
143357	2133	97457922000	18502	9319	2	0	\N
143365	1397	1331649299000	18505	9321	0	0	\N
143366	2134	97217669000	18505	9321	1	0	\N
143367	2133	97455918000	18505	9321	2	0	\N
143375	1397	1331619296000	18509	9323	0	0	\N
143376	2133	97452912000	18509	9323	1	0	\N
143377	2134	97214660000	18509	9323	2	0	\N
143378	2133	97452912000	18510	9323	0	0	\N
143379	2134	97214660000	18510	9323	1	0	\N
143386	2035	150000000	18513	9324	0	0	\N
143387	1397	1331609295000	18513	9324	1	0	\N
143388	2133	97451910000	18513	9324	2	0	\N
143389	2035	150000000	18514	9271	0	0	\N
143390	1726	104746112000	18514	9271	1	0	\N
143391	1726	103536112000	18514	9271	2	0	\N
143392	1726	102326112000	18514	9271	3	0	\N
143393	2131	193996000	18514	9271	4	0	\N
143394	2133	97501008000	18514	9271	5	0	\N
143395	2133	97500006000	18514	9271	6	0	\N
143396	2133	97499004000	18514	9271	7	0	\N
143397	2133	97498002000	18514	9271	8	0	\N
143398	2133	97497000000	18514	9271	9	0	\N
143399	2133	97495998000	18514	9271	10	0	\N
143400	2133	97494996000	18514	9271	11	0	\N
143401	2133	97493994000	18514	9271	12	0	\N
143402	2133	97492992000	18514	9271	13	0	\N
143403	2133	97491990000	18514	9271	14	0	\N
143404	2133	97490988000	18514	9271	15	0	\N
143405	2133	97489986000	18514	9271	16	0	\N
143406	2133	97488984000	18514	9271	17	0	\N
143407	2133	97487982000	18514	9271	18	0	\N
143408	2133	97486980000	18514	9271	19	0	\N
143409	2133	97485978000	18514	9271	20	0	\N
143410	2133	97484976000	18514	9271	21	0	\N
143411	2133	97483974000	18514	9271	22	0	\N
143412	2133	97482972000	18514	9271	23	0	\N
143413	2133	97481970000	18514	9271	24	0	\N
143414	2133	97480968000	18514	9271	25	0	\N
143415	2133	97479966000	18514	9271	26	0	\N
143416	2133	97478964000	18514	9271	27	0	\N
143417	2133	97477962000	18514	9271	28	0	\N
143418	2133	97476960000	18514	9271	29	0	\N
143419	2133	97475958000	18514	9271	30	0	\N
143420	2133	97474956000	18514	9271	31	0	\N
143421	2133	97473954000	18514	9271	32	0	\N
143422	2133	97472952000	18514	9271	33	0	\N
143423	2133	97471950000	18514	9271	34	0	\N
143424	2133	97470948000	18514	9271	35	0	\N
143425	2133	97469946000	18514	9271	36	0	\N
143426	2133	97468944000	18514	9271	37	0	\N
143427	2133	97467942000	18514	9271	38	0	\N
143428	2133	97466940000	18514	9271	39	0	\N
143429	2133	97465938000	18514	9271	40	0	\N
143430	2133	97464936000	18514	9271	41	0	\N
143431	2133	97463934000	18514	9271	42	0	\N
143432	2133	97462932000	18514	9271	43	0	\N
143433	2133	97461930000	18514	9271	44	0	\N
143434	2133	97460928000	18514	9271	45	0	\N
143435	2133	97459926000	18514	9271	46	0	\N
143436	2133	97458924000	18514	9271	47	0	\N
143437	2133	97457922000	18514	9271	48	0	\N
143438	2133	97456920000	18514	9271	49	0	\N
143439	2133	97455918000	18514	9271	50	0	\N
143440	2133	97454916000	18514	9271	51	0	\N
143441	2133	97453914000	18514	9271	52	0	\N
143442	2133	97452912000	18514	9271	53	0	\N
143443	2133	97451910000	18514	9271	54	0	\N
143444	2133	97450908000	18514	9271	55	0	\N
143457	2185	199000000	18517	9272	0	0	\N
143458	2133	97449906000	18517	9272	1	0	\N
143459	2133	97448904000	18517	9272	2	0	\N
143460	2133	97447902000	18517	9272	3	0	\N
143464	1397	1331569291000	18519	9327	0	0	\N
143465	2134	97210648000	18519	9327	1	0	\N
143466	2133	97447902000	18519	9327	2	0	\N
143478	1397	1331529287000	18524	9331	0	0	\N
143479	2132	148537538000	18524	9331	1	0	\N
143480	2133	97443894000	18524	9331	2	0	\N
143354	2133	97457922000	18501	9319	2	0	1539
143358	1397	1331659300000	18503	9320	0	0	10717
143359	2133	97456920000	18503	9320	1	0	1540
143360	2134	97218672000	18503	9320	2	0	1776
143361	2132	148541542000	18503	9320	3	0	458
143363	2134	97217669000	18504	9321	1	0	1777
143364	2133	97455918000	18504	9321	2	0	1541
143368	1397	1331639298000	18506	9322	0	0	10719
143369	1397	1331629297000	18506	9322	1	0	10720
143370	2132	148540541000	18506	9322	2	0	459
143372	2134	97216666000	18506	9322	4	0	1778
143373	2134	97215663000	18506	9322	5	0	1779
143374	2133	97453914000	18506	9322	6	0	1543
143380	1397	1331619296000	18511	9323	0	0	10721
143382	2134	97214660000	18511	9323	2	0	1780
143383	2035	150000000	18512	9324	0	0	1
143384	1397	1331609295000	18512	9324	1	0	10722
143385	2133	97451910000	18512	9324	2	0	1545
143445	1397	1331599294000	18515	9325	0	0	10723
143447	2133	97450908000	18515	9325	2	0	1546
143448	2134	97213657000	18515	9325	3	0	1781
143449	2132	148539540000	18515	9325	4	0	460
143450	1397	1331589293000	18516	9326	0	0	10724
143451	1397	1331579292000	18516	9326	1	0	10725
143453	2134	97212654000	18516	9326	3	0	1782
143454	2134	97211651000	18516	9326	4	0	1783
143455	2133	97449906000	18516	9326	5	0	1547
143456	2133	97448904000	18516	9326	6	0	1548
143462	2134	97210648000	18518	9327	1	0	1784
143463	2133	97447902000	18518	9327	2	0	1549
143467	1397	1331559290000	18522	9329	0	0	10727
143468	1397	1331549289000	18522	9329	1	0	10728
143469	2134	97209645000	18522	9329	2	0	1785
143471	2133	97446900000	18522	9329	4	0	1550
143472	2133	97445898000	18522	9329	5	0	1551
143473	2134	97208642000	18522	9329	6	0	1786
143474	1715	43200715990002	18523	9330	0	0	1
143475	1397	1331539288000	18523	9330	1	0	10729
143477	2133	97444896000	18523	9330	3	0	1552
143481	2134	97206636000	18524	9331	3	0	\N
143482	1397	1331529287000	18525	9331	0	0	\N
143483	2132	148537538000	18525	9331	1	0	\N
143484	2133	97443894000	18525	9331	2	0	\N
143485	2134	97206636000	18525	9331	3	0	\N
143519	1397	1331439278000	18534	9338	0	0	\N
143520	2133	97434876000	18534	9338	1	0	\N
143521	2134	97198612000	18534	9338	2	0	\N
143522	1397	1331439278000	18535	9338	0	0	\N
143523	2133	97434876000	18535	9338	1	0	\N
143524	2134	97198612000	18535	9338	2	0	\N
143525	1715	42480703990002	18536	9299	0	0	\N
143526	1715	42479503990002	18536	9299	1	0	\N
143527	2035	150000000	18536	9299	2	0	\N
143528	1726	104746112000	18536	9299	3	0	\N
143529	1726	103536112000	18536	9299	4	0	\N
143530	1726	102326112000	18536	9299	5	0	\N
143531	2131	193996000	18536	9299	6	0	\N
143545	1397	1331399274000	18540	9341	0	0	\N
143546	2133	97430868000	18540	9341	1	0	\N
143547	2134	97194600000	18540	9341	2	0	\N
143548	1397	1331399274000	18541	9341	0	0	\N
143549	2133	97430868000	18541	9341	1	0	\N
143550	2134	97194600000	18541	9341	2	0	\N
143558	1397	1331369271000	18544	9344	0	0	\N
143559	2133	97427862000	18544	9344	1	0	\N
143560	2134	97191591000	18544	9344	2	0	\N
143561	1397	1331369271000	18545	9344	0	0	\N
143562	2133	97427862000	18545	9344	1	0	\N
143563	2134	97191591000	18545	9344	2	0	\N
143567	1715	43395483296216	18547	9345	0	0	\N
143568	1397	1331359270000	18547	9345	1	0	\N
143569	2134	97190588000	18547	9345	2	0	\N
143570	2132	148532533000	18547	9345	3	0	\N
143575	1715	43395483296216	18549	9345	0	0	\N
143576	1397	1331359270000	18549	9345	1	0	\N
143577	2134	97190588000	18549	9345	2	0	\N
143578	2132	148532533000	18549	9345	3	0	\N
143608	1397	1331299264000	18555	9350	0	0	\N
143609	1397	1331289263000	18555	9350	1	0	\N
143610	1397	1331279262000	18555	9350	2	0	\N
143611	1397	1331269261000	18555	9350	3	0	\N
143612	2134	97185573000	18555	9350	4	0	\N
143613	2134	97184570000	18555	9350	5	0	\N
143614	2134	97183567000	18555	9350	6	0	\N
143615	2134	97182564000	18555	9350	7	0	\N
143616	2133	97421850000	18555	9350	8	0	\N
143488	2133	97443894000	18526	9331	2	0	1553
143489	2134	97206636000	18526	9331	3	0	1788
143490	1397	1331519286000	18527	9332	0	0	10731
143491	2133	97442892000	18527	9332	1	0	1554
143492	2134	97205633000	18527	9332	2	0	1789
143494	2133	97441890000	18528	9333	1	0	1555
143495	2134	97204630000	18528	9333	2	0	1790
143496	1397	1331499284000	18529	9334	0	0	10733
143497	2133	97440888000	18529	9334	1	0	1556
143498	2134	97203627000	18529	9334	2	0	1791
143500	2132	148536537000	18530	9335	1	0	463
143501	2133	97439886000	18530	9335	2	0	1557
143502	1715	43199515990002	18531	9336	0	0	2
143503	1397	1331479282000	18531	9336	1	0	10735
143505	2133	97438884000	18531	9336	3	0	1558
143506	2134	97202624000	18531	9336	4	0	1792
143507	2134	97201621000	18531	9336	5	0	1793
143508	2133	97437882000	18531	9336	6	0	1559
143509	1397	1331459280000	18532	9337	0	0	10737
143511	2133	97436880000	18532	9337	2	0	1560
143512	2133	97435878000	18532	9337	3	0	1561
143513	2134	97200618000	18532	9337	4	0	1794
143514	2134	97199615000	18532	9337	5	0	1795
143515	2132	148535536000	18532	9337	6	0	464
143517	2133	97434876000	18533	9338	1	0	1562
143518	2134	97198612000	18533	9338	2	0	1796
143532	1397	1331429277000	18537	9339	0	0	10740
143533	1397	1331419276000	18537	9339	1	0	10741
143535	2134	97197609000	18537	9339	3	0	1797
143536	2134	97196606000	18537	9339	4	0	1798
143537	2133	97432872000	18537	9339	5	0	1564
143538	2132	148534535000	18537	9339	6	0	465
143539	1397	1331409275000	18538	9340	0	0	10742
143541	2134	97195603000	18538	9340	2	0	1799
143542	1397	1331399274000	18539	9341	0	0	10743
143543	2133	97430868000	18539	9341	1	0	1566
143544	2134	97194600000	18539	9341	2	0	1800
143551	1397	1331389273000	18542	9342	0	0	10744
143553	2133	97429866000	18542	9342	2	0	1567
143554	2134	97193597000	18542	9342	3	0	1801
143555	1397	1331379272000	18543	9343	0	0	10745
143556	2134	97192594000	18543	9343	1	0	1802
143564	1397	1331369271000	18546	9344	0	0	10746
143565	2133	97427862000	18546	9344	1	0	1569
143566	2134	97191591000	18546	9344	2	0	1803
143571	1715	43395483296216	18548	9345	0	0	3
143572	1397	1331359270000	18548	9345	1	0	10747
143574	2132	148532533000	18548	9345	3	0	467
143579	1397	1331349269000	18550	9346	0	0	10748
143580	2133	97426860000	18550	9346	1	0	1570
143581	1397	1331339268000	18551	9347	0	0	10749
143582	1397	1331329267000	18551	9347	1	0	10750
143584	2133	97425858000	18551	9347	3	0	1571
143585	2133	97424856000	18551	9347	4	0	1572
143586	2132	148531532000	18551	9347	5	0	468
143587	2134	97189585000	18551	9347	6	0	1805
143589	2134	97188582000	18551	9347	8	0	1806
143590	2134	97187579000	18551	9347	9	0	1807
143591	1715	42871425602430	18552	9348	0	0	4
143592	1397	1331309265000	18552	9348	1	0	10752
143593	2134	97186576000	18552	9348	2	0	1808
143595	1397	1331299264000	18554	9350	0	0	10753
143596	1397	1331289263000	18554	9350	1	0	10754
143597	1397	1331279262000	18554	9350	2	0	10755
143598	1397	1331269261000	18554	9350	3	0	10756
143599	2134	97185573000	18554	9350	4	0	1809
143601	2134	97183567000	18554	9350	6	0	1811
143602	2134	97182564000	18554	9350	7	0	1812
143603	2133	97421850000	18554	9350	8	0	1575
143604	2133	97420848000	18554	9350	9	0	1576
143606	2133	97418844000	18554	9350	11	0	1578
143607	2132	148530531000	18554	9350	12	0	469
143617	2133	97420848000	18555	9350	9	0	\N
143618	2133	97419846000	18555	9350	10	0	\N
143619	2133	97418844000	18555	9350	11	0	\N
143620	2132	148530531000	18555	9350	12	0	\N
143629	1715	43067367908644	18558	9352	0	0	\N
143630	1397	1331249259000	18558	9352	1	0	\N
143631	2133	97416840000	18558	9352	2	0	\N
143632	2134	97180558000	18558	9352	3	0	\N
143633	1397	1331239258000	18559	9353	0	0	\N
143634	2134	97179555000	18559	9353	1	0	\N
143635	2133	97415838000	18559	9353	2	0	\N
143648	1397	1331209255000	18563	9355	0	0	\N
143649	1397	1331199254000	18563	9355	1	0	\N
143650	2134	97177549000	18563	9355	2	0	\N
143651	2134	97176546000	18563	9355	3	0	\N
143652	2133	97412832000	18563	9355	4	0	\N
143653	1715	32490586272631	18564	9356	0	0	\N
143654	1397	1331189253000	18564	9356	1	0	\N
143655	2132	148527528000	18564	9356	2	0	\N
143663	1715	32490586272631	18566	9356	0	0	\N
143664	1397	1331189253000	18566	9356	1	0	\N
143665	2132	148527528000	18566	9356	2	0	\N
143666	2134	97177549000	18566	9356	3	0	\N
143667	2134	97176546000	18566	9356	4	0	\N
143668	2134	97175543000	18566	9356	5	0	\N
143669	2133	97412832000	18566	9356	6	0	\N
143672	1397	1331179252000	18568	9357	0	0	\N
143673	2134	97174540000	18568	9357	1	0	\N
143677	1715	15146801436096	18571	9359	0	0	\N
143678	1397	1331159250000	18571	9359	1	0	\N
143679	2134	97172534000	18571	9359	2	0	\N
143680	2132	148526527000	18571	9359	3	0	\N
143686	1397	1331149249000	18577	9360	0	0	\N
143711	1397	1331059240000	18584	9366	0	0	\N
143712	1397	1331049239000	18584	9366	1	0	\N
143713	2134	97163507000	18584	9366	2	0	\N
143714	2132	148523524000	18584	9366	3	0	\N
143715	1397	1331059240000	18585	9366	0	0	\N
143716	1397	1331049239000	18585	9366	1	0	\N
143717	2134	97163507000	18585	9366	2	0	\N
143718	2132	148523524000	18585	9366	3	0	\N
143719	1397	1331059240000	18586	9366	0	0	\N
143720	1397	1331049239000	18586	9366	1	0	\N
143721	2134	97163507000	18586	9366	2	0	\N
143722	2132	148523524000	18586	9366	3	0	\N
143731	1397	1331009235000	18589	9369	0	0	\N
143732	2134	97159495000	18589	9369	1	0	\N
143733	1397	1331009235000	18590	9369	0	0	\N
143734	2134	97159495000	18590	9369	1	0	\N
143737	1397	1330999234000	18592	9370	0	0	\N
143738	1397	1330989233000	18592	9370	1	0	\N
143739	2132	148521522000	18592	9370	2	0	\N
143740	2134	97158492000	18592	9370	4	0	\N
143741	2134	97157489000	18592	9370	5	0	\N
143742	1397	1330999234000	18593	9370	0	0	\N
143743	1397	1330989233000	18593	9370	1	0	\N
143744	2132	148521522000	18593	9370	2	0	\N
143745	2134	97158492000	18593	9370	4	0	\N
143746	2134	97157489000	18593	9370	5	0	\N
143747	1397	1330999234000	18594	9370	0	0	\N
143748	1397	1330989233000	18594	9370	1	0	\N
143749	2132	148521522000	18594	9370	2	0	\N
143750	2134	97158492000	18594	9370	4	0	\N
143751	2134	97157489000	18594	9370	5	0	\N
143752	1397	1330999234000	18595	9370	0	0	\N
143623	2134	97181561000	18556	9351	2	0	1813
143624	2132	148529530000	18556	9351	3	0	470
143625	1715	43067367908644	18557	9352	0	0	5
143626	1397	1331249259000	18557	9352	1	0	10758
143627	2133	97416840000	18557	9352	2	0	1580
143636	1397	1331239258000	18560	9353	0	0	10759
143637	2134	97179555000	18560	9353	1	0	1815
143638	2133	97415838000	18560	9353	2	0	1581
143639	1715	39279082345189	18561	9354	0	0	6
143640	1397	1331229257000	18561	9354	1	0	10760
143642	2134	97178552000	18561	9354	3	0	1816
143643	2132	148528529000	18561	9354	4	0	471
143644	2133	97414836000	18561	9354	5	0	1582
143645	2133	97413834000	18561	9354	6	0	1583
143647	1397	1331199254000	18562	9355	1	0	10763
143656	1715	32490586272631	18565	9356	0	0	7
143657	1397	1331189253000	18565	9356	1	0	10764
143658	2132	148527528000	18565	9356	2	0	472
143659	2134	97177549000	18565	9356	3	0	1817
143661	2134	97175543000	18565	9356	5	0	1819
143662	2133	97412832000	18565	9356	6	0	1584
143670	1397	1331179252000	18567	9357	0	0	10765
143671	2134	97174540000	18567	9357	1	0	1820
143674	1715	27910220174139	18569	9358	0	0	8
143676	2134	97173537000	18569	9358	2	0	1821
143681	1715	15146801436096	18572	9359	0	0	9
143682	1397	1331159250000	18572	9359	1	0	10767
143683	2134	97172534000	18572	9359	2	0	1822
143685	1397	1331149249000	18576	9360	0	0	10768
143687	1397	1331139248000	18578	9361	0	0	10769
143688	2134	97171531000	18578	9361	1	0	1823
143689	1397	1331129247000	18579	9362	0	0	10770
143690	1397	1331119246000	18579	9362	1	0	10771
143692	2134	97170528000	18579	9362	3	0	1824
143693	2134	97169525000	18579	9362	4	0	1825
143694	1397	1331109245000	18580	9363	0	0	10772
143695	2134	97168522000	18580	9363	1	0	1826
143696	1726	101116112000	18581	9364	0	0	8203
143698	2134	97167519000	18581	9364	2	0	1827
143699	849	1158280730361640	18581	9364	3	0	2
143700	1397	1331089243000	18582	9365	0	0	10774
143701	1397	1331079242000	18582	9365	1	0	10775
143703	2134	97166516000	18582	9365	3	0	1828
143704	2134	97165513000	18582	9365	4	0	1829
143705	2134	97164510000	18582	9365	5	0	1830
143706	2132	148524525000	18582	9365	6	0	475
143707	1397	1331059240000	18583	9366	0	0	10777
143709	2134	97163507000	18583	9366	2	0	1831
143710	2132	148523524000	18583	9366	3	0	476
143723	1397	1331039238000	18587	9367	0	0	10779
143724	2134	97162504000	18587	9367	1	0	1832
143725	1726	99906112000	18588	9368	0	0	8204
143727	1397	1331019236000	18588	9368	2	0	10781
143728	2134	97161501000	18588	9368	3	0	1833
143729	2134	97160498000	18588	9368	4	0	1834
143730	2132	148522523000	18588	9368	5	0	477
143736	2134	97159495000	18591	9369	1	0	1835
143753	1397	1330989233000	18595	9370	1	0	\N
143754	2132	148521522000	18595	9370	2	0	\N
143755	2134	97158492000	18595	9370	4	0	\N
143756	2134	97157489000	18595	9370	5	0	\N
143757	1397	1330999234000	18596	9370	0	0	\N
143758	1397	1330989233000	18596	9370	1	0	\N
143759	2132	148521522000	18596	9370	2	0	\N
143760	2134	97158492000	18596	9370	4	0	\N
143761	2134	97157489000	18596	9370	5	0	\N
143762	1397	1330999234000	18597	9370	0	0	\N
143763	1397	1330989233000	18597	9370	1	0	\N
143764	2132	148521522000	18597	9370	2	0	\N
143765	2134	97158492000	18597	9370	4	0	\N
143766	2134	97157489000	18597	9370	5	0	\N
143772	2132	148521522000	18599	9370	0	0	\N
143773	1397	1330979232000	18600	9371	0	0	\N
143774	2134	97156486000	18600	9371	1	0	\N
143783	1397	1330939228000	18605	9375	0	0	\N
143784	2134	97153477000	18605	9375	1	0	\N
143787	1397	1330929227000	18607	9376	0	0	\N
143788	2134	97152474000	18607	9376	1	0	\N
143789	1397	1330929227000	18608	9376	0	0	\N
143790	2134	97152474000	18608	9376	1	0	\N
143791	1397	1330929227000	18609	9376	0	0	\N
143792	2134	97152474000	18609	9376	1	0	\N
143795	1397	1330919226000	18611	9377	0	0	\N
143796	2134	97151471000	18611	9377	1	0	\N
143797	2132	148519520000	18611	9377	2	0	\N
143801	1726	98696112000	18613	9378	0	0	\N
143802	1397	1330909225000	18613	9378	1	0	\N
143803	1397	1330899224000	18613	9378	2	0	\N
143804	1397	1330889223000	18613	9378	3	0	\N
143805	1397	1330879222000	18613	9378	4	0	\N
143806	1397	1330869221000	18613	9378	5	0	\N
143807	1397	1330859220000	18613	9378	6	0	\N
143808	1397	1330849219000	18613	9378	7	0	\N
143809	2132	148518519000	18613	9378	8	0	\N
143810	2134	97150468000	18613	9378	9	0	\N
143811	2134	97149465000	18613	9378	10	0	\N
143812	2132	148517518000	18613	9378	11	0	\N
143813	2134	97148462000	18613	9378	12	0	\N
143814	2134	97147459000	18613	9378	13	0	\N
143815	2134	97146456000	18613	9378	14	0	\N
143816	2134	97145453000	18613	9378	15	0	\N
143817	2134	97144450000	18613	9378	16	0	\N
143837	1397	1330829217000	18616	9380	0	0	\N
143841	1397	1330819216000	18619	9381	0	0	\N
143842	2132	148516517000	18619	9381	1	0	\N
143846	1397	1330809215000	18621	9382	0	0	\N
143847	2134	97142444000	18621	9382	1	0	\N
143848	2134	97141441000	18621	9382	2	0	\N
143851	1397	1330789213000	18623	9384	0	0	\N
143852	2134	97139435000	18623	9384	1	0	\N
143853	2132	148515516000	18623	9384	2	0	\N
143864	1397	1330749209000	18627	9387	0	0	\N
143865	1397	1330739208000	18627	9387	1	0	\N
143866	2134	97135423000	18627	9387	2	0	\N
143867	2132	148514515000	18627	9387	3	0	\N
143868	2134	97134420000	18627	9387	4	0	\N
143874	1397	1330749209000	18629	9387	0	0	\N
143875	1397	1330739208000	18629	9387	1	0	\N
143876	2134	97135423000	18629	9387	2	0	\N
143877	2132	148514515000	18629	9387	3	0	\N
143878	2134	97134420000	18629	9387	4	0	\N
143884	1397	1330729207000	18631	9388	0	0	\N
143885	1397	1330719206000	18631	9388	1	0	\N
143886	2134	97133417000	18631	9388	2	0	\N
143887	2134	97132414000	18631	9388	3	0	\N
143888	2132	148513514000	18631	9388	4	0	\N
143769	2132	148521522000	18598	9370	2	0	478
143770	2134	97158492000	18598	9370	4	0	1836
143771	2134	97157489000	18598	9370	5	0	1837
143775	1397	1330979232000	18601	9371	0	0	10785
143776	2134	97156486000	18601	9371	1	0	1838
143778	2134	97155483000	18602	9372	1	0	1839
143779	1397	1330959230000	18603	9373	0	0	10787
143780	1397	1330949229000	18604	9374	0	0	10788
143781	2134	97154480000	18604	9374	1	0	1840
143782	2132	148520521000	18604	9374	2	0	479
143786	2134	97153477000	18606	9375	1	0	1841
143793	1397	1330929227000	18610	9376	0	0	10790
143794	2134	97152474000	18610	9376	1	0	1842
143798	1397	1330919226000	18612	9377	0	0	10791
143800	2132	148519520000	18612	9377	2	0	480
143818	1726	98696112000	18614	9378	0	0	8205
143819	1397	1330909225000	18614	9378	1	0	10792
143820	1397	1330899224000	18614	9378	2	0	10793
143821	1397	1330889223000	18614	9378	3	0	10794
143823	1397	1330869221000	18614	9378	5	0	10796
143824	1397	1330859220000	18614	9378	6	0	10797
143825	1397	1330849219000	18614	9378	7	0	10798
143826	2132	148518519000	18614	9378	8	0	481
143827	2134	97150468000	18614	9378	9	0	1844
143829	2132	148517518000	18614	9378	11	0	482
143830	2134	97148462000	18614	9378	12	0	1846
143831	2134	97147459000	18614	9378	13	0	1847
143832	2134	97146456000	18614	9378	14	0	1848
143834	2134	97144450000	18614	9378	16	0	1850
143835	1397	1330839218000	18615	9379	0	0	10799
143836	2134	97143447000	18615	9379	1	0	1851
143838	1397	1330829217000	18617	9380	0	0	10800
143839	1397	1330819216000	18618	9381	0	0	10801
143843	1397	1330809215000	18620	9382	0	0	10802
143844	2134	97142444000	18620	9382	1	0	1852
143845	2134	97141441000	18620	9382	2	0	1853
143849	1397	1330799214000	18622	9383	0	0	10803
143850	2134	97140438000	18622	9383	1	0	1854
143855	2134	97139435000	18624	9384	1	0	1855
143856	2132	148515516000	18624	9384	2	0	484
143857	1397	1330779212000	18625	9385	0	0	10805
143858	1397	1330769211000	18625	9385	1	0	10806
143860	2134	97138432000	18625	9385	3	0	1856
143861	2134	97137429000	18625	9385	4	0	1857
143862	1397	1330759210000	18626	9386	0	0	10807
143863	2134	97136426000	18626	9386	1	0	1858
143869	1397	1330749209000	18628	9387	0	0	10808
143871	2134	97135423000	18628	9387	2	0	1859
143872	2132	148514515000	18628	9387	3	0	485
143873	2134	97134420000	18628	9387	4	0	1860
143879	1397	1330729207000	18630	9388	0	0	10810
143880	1397	1330719206000	18630	9388	1	0	10811
143882	2134	97132414000	18630	9388	3	0	1862
143883	2132	148513514000	18630	9388	4	0	486
143889	1397	1330729207000	18632	9388	0	0	\N
143890	1397	1330719206000	18632	9388	1	0	\N
143891	2134	97133417000	18632	9388	2	0	\N
143892	2134	97132414000	18632	9388	3	0	\N
143893	2132	148513514000	18632	9388	4	0	\N
143898	1397	1330689203000	18634	9390	0	0	\N
143899	1397	1330679202000	18634	9390	1	0	\N
143900	2132	148512513000	18634	9390	2	0	\N
143901	2134	97129405000	18634	9390	3	0	\N
143902	2134	97128402000	18634	9390	4	0	\N
143918	42	85265954400000	18638	9393	0	0	\N
143919	42	81344072000000	18638	9393	1	0	\N
143920	1397	1330629197000	18638	9393	2	0	\N
143921	2134	97123387000	18638	9393	3	0	\N
143933	42	78697712800000	18641	9394	0	0	\N
143934	42	76509360000000	18641	9394	1	0	\N
143935	1397	1330619196000	18641	9394	2	0	\N
143936	1397	1330609195000	18641	9394	3	0	\N
143937	2134	97122384000	18641	9394	4	0	\N
143938	2134	97121381000	18641	9394	5	0	\N
143939	2132	148510511000	18641	9394	6	0	\N
143940	1397	1330599194000	18642	9395	0	0	\N
143941	2134	97120378000	18642	9395	1	0	\N
143942	1397	1330599194000	18643	9395	0	0	\N
143943	2134	97120378000	18643	9395	1	0	\N
143944	1397	1330599194000	18644	9395	0	0	\N
143945	2134	97120378000	18644	9395	1	0	\N
143948	1397	1330599194000	18646	9395	0	0	\N
143949	2134	97120378000	18646	9395	1	0	\N
143950	1397	1330589193000	18647	9396	0	0	\N
143951	1397	1330579192000	18647	9396	1	0	\N
143952	2134	97119375000	18647	9396	2	0	\N
143953	2134	97118372000	18647	9396	3	0	\N
143954	2132	148509510000	18647	9396	4	0	\N
143960	1397	1330569191000	18649	9397	0	0	\N
143961	2134	97117369000	18649	9397	1	0	\N
143972	1397	1330549189000	18654	9400	0	0	\N
143973	1397	1330539188000	18654	9400	1	0	\N
143974	2134	97114360000	18654	9400	2	0	\N
143975	2134	97113357000	18654	9400	3	0	\N
143976	1397	1330529187000	18655	9401	0	0	\N
143977	1397	1330519186000	18655	9401	1	0	\N
143978	2132	148507508000	18655	9401	2	0	\N
143979	554	67450022000000	18655	9401	3	0	\N
143980	2134	97112354000	18655	9401	4	0	\N
143981	2134	97111351000	18655	9401	5	0	\N
143982	1397	1330529187000	18656	9401	0	0	\N
143983	1397	1330519186000	18656	9401	1	0	\N
143984	2132	148507508000	18656	9401	2	0	\N
143985	554	67450022000000	18656	9401	3	0	\N
143986	2134	97112354000	18656	9401	4	0	\N
143987	2134	97111351000	18656	9401	5	0	\N
143994	1397	1330529187000	18658	9401	0	0	\N
143995	1397	1330519186000	18658	9401	1	0	\N
143996	2132	148507508000	18658	9401	2	0	\N
143997	554	67450022000000	18658	9401	3	0	\N
143998	2134	97112354000	18658	9401	4	0	\N
143999	2134	97111351000	18658	9401	5	0	\N
144000	1397	1330529187000	18659	9401	0	0	\N
144001	1397	1330519186000	18659	9401	1	0	\N
144002	2132	148507508000	18659	9401	2	0	\N
144003	554	67450022000000	18659	9401	3	0	\N
144004	2134	97112354000	18659	9401	4	0	\N
144005	2134	97111351000	18659	9401	5	0	\N
144015	42	85265954400000	18663	9379	0	0	\N
144016	42	81344072000000	18663	9379	1	0	\N
144017	42	78697712800000	18663	9379	2	0	\N
144018	42	76509360000000	18663	9379	3	0	\N
144019	2157	1999	18663	9379	4	0	\N
144020	1597	2157003000000	18663	9379	5	0	\N
144021	2134	97143447000	18663	9379	6	0	\N
144022	2134	97142444000	18663	9379	7	0	\N
144023	2134	97141441000	18663	9379	8	0	\N
144024	2134	97140438000	18663	9379	9	0	\N
143896	2134	97131411000	18633	9389	2	0	1863
143897	2134	97130408000	18633	9389	3	0	1864
143903	1397	1330689203000	18635	9390	0	0	10814
143904	1397	1330679202000	18635	9390	1	0	10815
143905	2132	148512513000	18635	9390	2	0	487
143907	2134	97128402000	18635	9390	4	0	1866
143908	1397	1330669201000	18636	9391	0	0	10816
143909	2134	97127399000	18636	9391	1	0	1867
143910	1397	1330659200000	18637	9392	0	0	10817
143911	1397	1330649199000	18637	9392	1	0	10818
143913	2134	97126396000	18637	9392	3	0	1868
143914	2134	97125393000	18637	9392	4	0	1869
143915	2132	148511512000	18637	9392	5	0	488
143916	1597	2157003000000	18637	9392	6	0	4
143922	42	85265954400000	18639	9393	0	0	5
143923	42	81344072000000	18639	9393	1	0	6
143924	1397	1330629197000	18639	9393	2	0	10820
143925	2134	97123387000	18639	9393	3	0	1871
143926	42	78697712800000	18640	9394	0	0	7
143928	1397	1330619196000	18640	9394	2	0	10821
143929	1397	1330609195000	18640	9394	3	0	10822
143930	2134	97122384000	18640	9394	4	0	1872
143931	2134	97121381000	18640	9394	5	0	1873
143932	2132	148510511000	18640	9394	6	0	489
143947	2134	97120378000	18645	9395	1	0	1874
143955	1397	1330589193000	18648	9396	0	0	10824
143956	1397	1330579192000	18648	9396	1	0	10825
143957	2134	97119375000	18648	9396	2	0	1875
143959	2132	148509510000	18648	9396	4	0	490
143962	2134	97117369000	18650	9397	0	0	1877
143963	1397	1330569191000	18651	9398	0	0	10826
143964	2134	97116366000	18651	9398	1	0	1878
143965	1397	1330559190000	18652	9399	0	0	10827
143967	2132	148508509000	18652	9399	2	0	491
143968	1397	1330549189000	18653	9400	0	0	10828
143969	1397	1330539188000	18653	9400	1	0	10829
143970	2134	97114360000	18653	9400	2	0	1880
143971	2134	97113357000	18653	9400	3	0	1881
143989	1397	1330519186000	18657	9401	1	0	10831
143990	2132	148507508000	18657	9401	2	0	492
143991	554	67450022000000	18657	9401	3	0	1
143992	2134	97112354000	18657	9401	4	0	1882
144006	1397	1330509185000	18660	9402	0	0	10832
144007	2134	97110348000	18660	9402	1	0	1884
144008	2190	989000000	18660	9402	2	0	1
144009	1397	1330499184000	18661	9403	0	0	10833
144010	2134	97109345000	18661	9403	1	0	1885
144012	1397	1330489183000	18662	9404	0	0	10834
144013	2132	148506507000	18662	9404	1	0	493
144014	2134	97108342000	18662	9404	2	0	1886
144025	2134	97139435000	18663	9379	10	0	\N
144026	2134	97138432000	18663	9379	11	0	\N
144027	2134	97137429000	18663	9379	12	0	\N
144028	2134	97136426000	18663	9379	13	0	\N
144029	2134	97135423000	18663	9379	14	0	\N
144030	554	67450022000000	18663	9379	15	0	\N
144031	2134	97134420000	18663	9379	16	0	\N
144032	2134	97133417000	18663	9379	17	0	\N
144033	2134	97132414000	18663	9379	18	0	\N
144034	2134	97131411000	18663	9379	19	0	\N
144035	2134	97130408000	18663	9379	20	0	\N
144036	2134	97129405000	18663	9379	21	0	\N
144037	2134	97128402000	18663	9379	22	0	\N
144038	2134	97127399000	18663	9379	23	0	\N
144039	2134	97126396000	18663	9379	24	0	\N
144040	2134	97125393000	18663	9379	25	0	\N
144041	2134	97124390000	18663	9379	26	0	\N
144042	2134	97123387000	18663	9379	27	0	\N
144043	2134	97122384000	18663	9379	28	0	\N
144044	2134	97121381000	18663	9379	29	0	\N
144045	2134	97120378000	18663	9379	30	0	\N
144046	2134	97119375000	18663	9379	31	0	\N
144047	2134	97118372000	18663	9379	32	0	\N
144048	2134	97117369000	18663	9379	33	0	\N
144049	2134	97116366000	18663	9379	34	0	\N
144050	2134	97115363000	18663	9379	35	0	\N
144051	2134	97114360000	18663	9379	36	0	\N
144052	2134	97113357000	18663	9379	37	0	\N
144053	2134	97112354000	18663	9379	38	0	\N
144054	2134	97111351000	18663	9379	39	0	\N
144055	2134	97110348000	18663	9379	40	0	\N
144056	2134	97109345000	18663	9379	41	0	\N
144057	2134	97108342000	18663	9379	42	0	\N
144061	1397	1330469181000	18665	9406	0	0	\N
144062	2134	97106336000	18665	9406	1	0	\N
144065	1397	1330469181000	18667	9406	0	0	\N
144066	2134	97106336000	18667	9406	1	0	\N
144067	1397	1330469181000	18668	9406	0	0	\N
144068	2134	97106336000	18668	9406	1	0	\N
144073	1397	1330459180000	18671	9407	0	0	\N
144074	1474	13231414000023	18671	9407	1	0	\N
144075	2134	97105333000	18671	9407	2	0	\N
144076	2132	148505506000	18671	9407	3	0	\N
144077	1397	1330459180000	18672	9407	0	0	\N
144078	1474	13231414000023	18672	9407	1	0	\N
144079	2134	97105333000	18672	9407	2	0	\N
144080	2132	148505506000	18672	9407	3	0	\N
144081	1715	42480703990002	18673	9276	0	0	\N
144082	1715	42479503990002	18673	9276	1	0	\N
144083	1715	41955446296216	18673	9276	2	0	\N
144084	1715	41431388602430	18673	9276	3	0	\N
144085	1715	40907330908644	18673	9276	4	0	\N
144086	1715	37119045345189	18673	9276	5	0	\N
144087	1715	30330549272631	18673	9276	6	0	\N
144088	1715	25750183174139	18673	9276	7	0	\N
144089	1715	12986764436096	18673	9276	8	0	\N
144090	42	85265954400000	18673	9276	9	0	\N
144091	42	81344072000000	18673	9276	10	0	\N
144092	42	78697712800000	18673	9276	11	0	\N
144093	42	76509360000000	18673	9276	12	0	\N
144094	2035	150000000	18673	9276	13	0	\N
144095	1726	104746112000	18673	9276	14	0	\N
144096	1726	103536112000	18673	9276	15	0	\N
144097	1726	102326112000	18673	9276	16	0	\N
144098	1726	101116112000	18673	9276	17	0	\N
144099	1726	99906112000	18673	9276	18	0	\N
144100	1726	98696112000	18673	9276	19	0	\N
144101	1397	1332229357000	18673	9276	20	0	\N
144102	1397	1332219356000	18673	9276	21	0	\N
144103	1397	1332209355000	18673	9276	22	0	\N
144104	1397	1332199354000	18673	9276	23	0	\N
144105	1397	1332189353000	18673	9276	24	0	\N
144106	1397	1332179352000	18673	9276	25	0	\N
144107	1397	1332169351000	18673	9276	26	0	\N
144108	1397	1332159350000	18673	9276	27	0	\N
144109	1397	1332149349000	18673	9276	28	0	\N
144110	1397	1332139348000	18673	9276	29	0	\N
144111	1397	1332129347000	18673	9276	30	0	\N
144112	1397	1332119346000	18673	9276	31	0	\N
144113	1397	1332109345000	18673	9276	32	0	\N
144114	1397	1332099344000	18673	9276	33	0	\N
144115	1397	1332089343000	18673	9276	34	0	\N
144116	1397	1332079342000	18673	9276	35	0	\N
144117	1397	1332069341000	18673	9276	36	0	\N
144118	1397	1332059340000	18673	9276	37	0	\N
144119	1397	1332049339000	18673	9276	38	0	\N
144120	1397	1332039338000	18673	9276	39	0	\N
144121	1397	1332029337000	18673	9276	40	0	\N
144122	1397	1332019336000	18673	9276	41	0	\N
144123	1397	1332009335000	18673	9276	42	0	\N
144124	1397	1331999334000	18673	9276	43	0	\N
144125	1397	1331989333000	18673	9276	44	0	\N
144126	1397	1331979332000	18673	9276	45	0	\N
144127	1397	1331969331000	18673	9276	46	0	\N
144128	1397	1331959330000	18673	9276	47	0	\N
144129	1397	1331949329000	18673	9276	48	0	\N
144130	1397	1331939328000	18673	9276	49	0	\N
144131	1397	1331929327000	18673	9276	50	0	\N
144132	1397	1331919326000	18673	9276	51	0	\N
144133	1397	1331909325000	18673	9276	52	0	\N
144134	1397	1331899324000	18673	9276	53	0	\N
144135	1397	1331889323000	18673	9276	54	0	\N
144136	1397	1331879322000	18673	9276	55	0	\N
144137	1397	1331869321000	18673	9276	56	0	\N
144138	1397	1331859320000	18673	9276	57	0	\N
144139	1397	1331849319000	18673	9276	58	0	\N
144140	1397	1331839318000	18673	9276	59	0	\N
144141	1397	1331829317000	18673	9276	60	0	\N
144142	1397	1331819316000	18673	9276	61	0	\N
144143	1397	1331809315000	18673	9276	62	0	\N
144144	1397	1331799314000	18673	9276	63	0	\N
144145	1397	1331789313000	18673	9276	64	0	\N
144146	1397	1331779312000	18673	9276	65	0	\N
144147	1397	1331769311000	18673	9276	66	0	\N
144148	1397	1331759310000	18673	9276	68	0	\N
144149	1397	1331749309000	18673	9276	69	0	\N
144150	1397	1331739308000	18673	9276	70	0	\N
144151	1397	1331729307000	18673	9276	71	0	\N
144152	1397	1331719306000	18673	9276	72	0	\N
144153	1397	1331709305000	18673	9276	73	0	\N
144154	1397	1331699304000	18673	9276	74	0	\N
144155	1397	1331689303000	18673	9276	75	0	\N
144156	1397	1331679302000	18673	9276	76	0	\N
144157	1397	1331669301000	18673	9276	77	0	\N
144158	1397	1331659300000	18673	9276	78	0	\N
144159	1397	1331649299000	18673	9276	79	0	\N
144160	1397	1331639298000	18673	9276	80	0	\N
144060	1597	7012000000	18664	9405	2	0	5
144063	1397	1330469181000	18666	9406	0	0	10836
144064	2134	97106336000	18666	9406	1	0	1888
144069	1397	1330459180000	18670	9407	0	0	10837
144070	1474	13231414000023	18670	9407	1	0	16
144072	2132	148505506000	18670	9407	3	0	494
144161	1397	1331629297000	18673	9276	81	0	\N
144162	1397	1331619296000	18673	9276	82	0	\N
144163	1397	1331609295000	18673	9276	83	0	\N
144164	1397	1331599294000	18673	9276	84	0	\N
144165	1397	1331589293000	18673	9276	85	0	\N
144166	1397	1331579292000	18673	9276	86	0	\N
144167	1397	1331569291000	18673	9276	87	0	\N
144168	1397	1331559290000	18673	9276	88	0	\N
144169	1397	1331549289000	18673	9276	89	0	\N
144170	1397	1331539288000	18673	9276	90	0	\N
144171	1397	1331529287000	18673	9276	91	0	\N
144172	1397	1331519286000	18673	9276	92	0	\N
144173	1397	1331509285000	18673	9276	93	0	\N
144174	1397	1331499284000	18673	9276	94	0	\N
144175	1397	1331489283000	18673	9276	95	0	\N
144176	1397	1331479282000	18673	9276	96	0	\N
144177	1397	1331469281000	18673	9276	97	0	\N
144178	1397	1331459280000	18673	9276	98	0	\N
144179	1397	1331449279000	18673	9276	99	0	\N
144180	1397	1331439278000	18673	9276	100	0	\N
144181	1397	1331429277000	18673	9276	101	0	\N
144182	1397	1331419276000	18673	9276	102	0	\N
144183	1397	1331409275000	18673	9276	103	0	\N
144184	1397	1331399274000	18673	9276	104	0	\N
144185	1397	1331389273000	18673	9276	105	0	\N
144186	1397	1331379272000	18673	9276	106	0	\N
144187	1397	1331369271000	18673	9276	107	0	\N
144188	1397	1331359270000	18673	9276	108	0	\N
144189	1397	1331349269000	18673	9276	109	0	\N
144190	1397	1331339268000	18673	9276	110	0	\N
144191	1397	1331329267000	18673	9276	111	0	\N
144192	1397	1331319266000	18673	9276	112	0	\N
144193	1397	1331309265000	18673	9276	113	0	\N
144194	1474	13229404000023	18674	9408	0	0	\N
144195	1397	1330449179000	18674	9408	1	0	\N
144196	2134	97104330000	18674	9408	2	0	\N
144200	1474	13229404000023	18676	9408	0	0	\N
144201	1397	1330449179000	18676	9408	1	0	\N
144202	2134	97104330000	18676	9408	2	0	\N
144203	1474	13229404000023	18677	9408	0	0	\N
144204	2134	97104330000	18677	9408	1	0	\N
144224	42	85265954400000	18681	9372	0	0	\N
144225	42	81344072000000	18681	9372	1	0	\N
144226	42	78697712800000	18681	9372	2	0	\N
144227	42	76509360000000	18681	9372	3	0	\N
144228	1474	13231414000023	18681	9372	4	0	\N
144229	1726	98696112000	18681	9372	5	0	\N
144230	1474	13229404000023	18681	9372	6	0	\N
144231	1474	13227394000023	18681	9372	7	0	\N
144232	1474	13225384000023	18681	9372	8	0	\N
144233	1474	13223374000023	18681	9372	9	0	\N
144234	2157	1999	18681	9372	10	0	\N
144235	2134	97155483000	18681	9372	11	0	\N
144236	2134	97154480000	18681	9372	12	0	\N
144237	1597	2157003000000	18681	9372	13	0	\N
144238	1611	26029312550000	18681	9372	14	0	\N
144239	2132	148520521000	18681	9372	15	0	\N
144240	2132	148519520000	18681	9372	16	0	\N
144241	2132	148518519000	18681	9372	17	0	\N
144242	1597	7002000000	18681	9372	18	0	\N
144243	2132	148517518000	18681	9372	19	0	\N
144244	2134	97153477000	18681	9372	20	0	\N
144245	2134	97152474000	18681	9372	21	0	\N
144246	2134	97151471000	18681	9372	22	0	\N
144247	2134	97150468000	18681	9372	23	0	\N
144248	2134	97149465000	18681	9372	24	0	\N
144249	2132	148516517000	18681	9372	25	0	\N
144250	2132	148515516000	18681	9372	26	0	\N
144251	554	67450022000000	18681	9372	27	0	\N
144252	2132	148514515000	18681	9372	28	0	\N
144253	2132	148513514000	18681	9372	29	0	\N
144254	2132	148512513000	18681	9372	30	0	\N
144255	2132	148511512000	18681	9372	31	0	\N
144256	2132	148510511000	18681	9372	32	0	\N
144257	2134	97148462000	18681	9372	33	0	\N
144258	2134	97147459000	18681	9372	34	0	\N
144259	2134	97146456000	18681	9372	35	0	\N
144260	2134	97145453000	18681	9372	36	0	\N
144261	2134	97144450000	18681	9372	37	0	\N
144262	2134	97143447000	18681	9372	38	0	\N
144263	2134	97142444000	18681	9372	39	0	\N
144264	2134	97141441000	18681	9372	40	0	\N
144265	2134	97140438000	18681	9372	41	0	\N
144266	2134	97139435000	18681	9372	42	0	\N
144267	2134	97138432000	18681	9372	43	0	\N
144268	2134	97137429000	18681	9372	44	0	\N
144269	2134	97136426000	18681	9372	45	0	\N
144270	2134	97135423000	18681	9372	46	0	\N
144271	2132	148509510000	18681	9372	47	0	\N
144272	2132	148508509000	18681	9372	48	0	\N
144273	2132	148507508000	18681	9372	49	0	\N
144274	2132	148506507000	18681	9372	50	0	\N
144275	2132	148505506000	18681	9372	51	0	\N
144276	2132	148504505000	18681	9372	52	0	\N
144277	2132	148503504000	18681	9372	53	0	\N
144278	2134	97134420000	18681	9372	54	0	\N
144279	2134	97133417000	18681	9372	55	0	\N
144280	2134	97132414000	18681	9372	56	0	\N
144281	2134	97131411000	18681	9372	57	0	\N
144282	2134	97130408000	18681	9372	58	0	\N
144283	2134	97129405000	18681	9372	59	0	\N
144284	2134	97128402000	18681	9372	60	0	\N
144285	2134	97127399000	18681	9372	61	0	\N
144286	2134	97126396000	18681	9372	62	0	\N
144287	2134	97125393000	18681	9372	63	0	\N
144288	2134	97124390000	18681	9372	64	0	\N
144289	2134	97123387000	18681	9372	65	0	\N
144290	2134	97122384000	18681	9372	66	0	\N
144291	2134	97121381000	18681	9372	67	0	\N
144292	2134	97120378000	18681	9372	68	0	\N
144293	2134	97119375000	18681	9372	69	0	\N
144294	2134	97118372000	18681	9372	70	0	\N
144295	2134	97117369000	18681	9372	71	0	\N
144296	2134	97116366000	18681	9372	72	0	\N
144199	2134	97104330000	18675	9408	2	0	1890
144205	1397	1330439178000	18678	9409	0	0	10839
144206	1474	13227394000023	18678	9409	1	0	18
144207	1474	13225384000023	18678	9409	2	0	19
144208	1474	13223374000023	18678	9409	3	0	20
144210	1397	1330429177000	18679	9410	0	0	10840
144211	2132	148504505000	18679	9410	1	0	495
144212	2134	97102324000	18679	9410	2	0	1892
144213	1397	1330419176000	18680	9411	0	0	10841
144214	1397	1330409175000	18680	9411	1	0	10842
144216	1397	1330389173000	18680	9411	3	0	10844
144217	1397	1330379172000	18680	9411	4	0	10845
144218	2134	97101321000	18680	9411	5	0	1893
144219	2132	148503504000	18680	9411	6	0	496
144221	2134	97099315000	18680	9411	8	0	1895
144222	2134	97098312000	18680	9411	9	0	1896
144223	2134	97097309000	18680	9411	10	0	1897
144297	2134	97115363000	18681	9372	73	0	\N
144298	2134	97114360000	18681	9372	74	0	\N
144299	2134	97113357000	18681	9372	75	0	\N
144300	2134	97112354000	18681	9372	76	0	\N
144301	2134	97111351000	18681	9372	77	0	\N
144302	2134	97110348000	18681	9372	78	0	\N
144303	2134	97109345000	18681	9372	79	0	\N
144304	2134	97108342000	18681	9372	80	0	\N
144305	2134	97107339000	18681	9372	81	0	\N
144306	2134	97106336000	18681	9372	82	0	\N
144307	2134	97105333000	18681	9372	83	0	\N
144308	2134	97104330000	18681	9372	84	0	\N
144309	2134	97103327000	18681	9372	85	0	\N
144310	2134	97102324000	18681	9372	86	0	\N
144311	2134	97101321000	18681	9372	87	0	\N
144312	2134	97100318000	18681	9372	88	0	\N
144313	2134	97099315000	18681	9372	89	0	\N
144314	2134	97098312000	18681	9372	90	0	\N
144315	2134	97097309000	18681	9372	91	0	\N
144322	1932	38809152658	18683	9413	0	0	\N
144323	2134	97094300000	18683	9413	1	0	\N
144324	1397	1330349169000	18684	9413	0	0	\N
144325	1932	38809152658	18684	9413	1	0	\N
144326	2134	97094300000	18684	9413	2	0	\N
144330	1397	1330339168000	18686	9414	0	0	\N
144331	2134	97093297000	18686	9414	2	0	\N
144332	1397	1330339168000	18687	9414	0	0	\N
144333	2134	97093297000	18687	9414	2	0	\N
144334	1397	1330339168000	18688	9414	0	0	\N
144335	2134	97093297000	18688	9414	2	0	\N
144343	1397	1330339168000	18692	9416	0	0	\N
144344	1397	1330329167000	18692	9416	1	0	\N
144345	1397	1330319166000	18692	9416	2	0	\N
144346	2132	148501502000	18692	9416	3	0	\N
144347	2134	97093297000	18692	9416	4	0	\N
144348	2134	97092294000	18692	9416	5	0	\N
144349	2134	97091291000	18692	9416	6	0	\N
144354	1397	1330309165000	18694	9417	0	0	\N
144355	1397	1330299164000	18694	9417	1	0	\N
144356	2134	97090288000	18694	9417	2	0	\N
144357	2134	97089285000	18694	9417	3	0	\N
144358	1397	1330289163000	18695	9418	0	0	\N
144359	2134	97088282000	18695	9418	1	0	\N
144360	2132	148500501000	18695	9418	2	0	\N
144361	1397	1330289163000	18696	9418	0	0	\N
144362	2134	97088282000	18696	9418	1	0	\N
144363	2132	148500501000	18696	9418	2	0	\N
144364	1397	1330289163000	18697	9418	0	0	\N
144365	2134	97088282000	18697	9418	1	0	\N
144366	2132	148500501000	18697	9418	2	0	\N
144370	1932	636819152658	18699	9410	0	0	\N
144371	1397	1330429177000	18699	9410	1	0	\N
144372	1397	1330419176000	18699	9410	2	0	\N
144373	1397	1330409175000	18699	9410	3	0	\N
144374	1397	1330399174000	18699	9410	4	0	\N
144375	1397	1330389173000	18699	9410	5	0	\N
144376	1397	1330379172000	18699	9410	6	0	\N
144377	1397	1330369171000	18699	9410	7	0	\N
144378	1397	1330359170000	18699	9410	8	0	\N
144379	1397	1330349169000	18699	9410	9	0	\N
144380	1397	1330339168000	18699	9410	10	0	\N
144381	1397	1330329167000	18699	9410	11	0	\N
144382	1397	1330319166000	18699	9410	12	0	\N
144383	1397	1330309165000	18699	9410	13	0	\N
144384	1397	1330299164000	18699	9410	14	0	\N
144385	1397	1330289163000	18699	9410	15	0	\N
144386	1932	38809152658	18699	9410	16	0	\N
144387	2132	148504505000	18699	9410	17	0	\N
144388	2132	148503504000	18699	9410	18	0	\N
144389	2132	148502503000	18699	9410	19	0	\N
144390	2132	148501502000	18699	9410	20	0	\N
144391	2132	148500501000	18699	9410	21	0	\N
144392	2134	97102324000	18699	9410	22	0	\N
144393	2134	97101321000	18699	9410	23	0	\N
144394	2134	97100318000	18699	9410	24	0	\N
144395	2134	97099315000	18699	9410	25	0	\N
144396	2134	97098312000	18699	9410	26	0	\N
144397	2134	97097309000	18699	9410	27	0	\N
144398	2134	97096306000	18699	9410	28	0	\N
144399	2134	97095303000	18699	9410	29	0	\N
144400	2134	97094300000	18699	9410	30	0	\N
144401	2134	97093297000	18699	9410	31	0	\N
144402	2134	97092294000	18699	9410	33	0	\N
144403	2134	97091291000	18699	9410	34	0	\N
144404	2134	97090288000	18699	9410	35	0	\N
144405	2134	97089285000	18699	9410	36	0	\N
144406	2134	97088282000	18699	9410	37	0	\N
144407	1397	1330279162000	18700	9419	0	0	\N
144408	1397	1330269161000	18700	9419	1	0	\N
144409	2134	97087279000	18700	9419	2	0	\N
144410	2134	97086276000	18700	9419	3	0	\N
144422	1397	1330229157000	18704	9422	0	0	\N
144423	2134	97082264000	18704	9422	1	0	\N
144424	1397	1330229157000	18705	9422	0	0	\N
144425	2134	97082264000	18705	9422	1	0	\N
144318	1397	1330359170000	18682	9412	2	0	10847
144319	2134	97096306000	18682	9412	3	0	1898
144320	2134	97095303000	18682	9412	4	0	1899
144321	2132	148502503000	18682	9412	5	0	497
144327	1397	1330349169000	18685	9413	0	0	10848
144329	2134	97094300000	18685	9413	2	0	1900
144336	1397	1330339168000	18691	9416	0	0	10849
144337	1397	1330329167000	18691	9416	1	0	10850
144338	1397	1330319166000	18691	9416	2	0	10851
144339	2132	148501502000	18691	9416	3	0	498
144341	2134	97092294000	18691	9416	5	0	1902
144342	2134	97091291000	18691	9416	6	0	1903
144350	1397	1330309165000	18693	9417	0	0	10852
144351	1397	1330299164000	18693	9417	1	0	10853
144353	2134	97089285000	18693	9417	3	0	1905
144367	1397	1330289163000	18698	9418	0	0	10854
144368	2134	97088282000	18698	9418	1	0	1906
144369	2132	148500501000	18698	9418	2	0	499
144411	1397	1330279162000	18701	9419	0	0	10855
144413	2134	97087279000	18701	9419	2	0	1907
144414	2134	97086276000	18701	9419	3	0	1908
144415	1397	1330259160000	18702	9420	0	0	10857
144416	1397	1330249159000	18702	9420	1	0	10858
144417	2134	97085273000	18702	9420	2	0	1909
144419	2134	97084270000	18702	9420	4	0	1910
144420	1397	1330239158000	18703	9421	0	0	10859
144421	2134	97083267000	18703	9421	1	0	1911
144426	1397	1330229157000	18706	9422	0	0	10860
144428	1397	1330219156000	18707	9423	0	0	10861
144429	1397	1330209155000	18707	9423	1	0	10862
144430	1397	1330199154000	18707	9423	2	0	10863
144431	2132	148498499000	18707	9423	3	0	501
144432	2134	97081261000	18707	9423	4	0	1913
144441	1397	1330169151000	18710	9425	0	0	\N
144442	1715	41955446296216	18711	9300	0	0	\N
144443	1715	41431388602430	18711	9300	1	0	\N
144444	1715	40907330908644	18711	9300	2	0	\N
144445	1715	37119045345189	18711	9300	3	0	\N
144446	1715	30330549272631	18711	9300	4	0	\N
144447	1715	25750183174139	18711	9300	5	0	\N
144448	1715	12986764436096	18711	9300	6	0	\N
144449	42	85265954400000	18711	9300	7	0	\N
144450	42	81344072000000	18711	9300	8	0	\N
144451	42	78697712800000	18711	9300	9	0	\N
144452	42	76509360000000	18711	9300	10	0	\N
144453	1932	636819152658	18711	9300	11	0	\N
144454	1726	101116112000	18711	9300	12	0	\N
144455	1474	13231414000023	18711	9300	13	0	\N
144456	1726	99906112000	18711	9300	14	0	\N
144457	1726	98696112000	18711	9300	15	0	\N
144458	1474	13229404000023	18711	9300	16	0	\N
144459	1474	13227394000023	18711	9300	17	0	\N
144460	1474	13225384000023	18711	9300	18	0	\N
144461	1474	13223374000023	18711	9300	19	0	\N
144462	1932	38809152658	18711	9300	20	0	\N
144463	2157	1999	18711	9300	21	0	\N
144464	1597	2157003000000	18711	9300	22	0	\N
144465	1611	26029312550000	18711	9300	23	0	\N
144466	1597	7002000000	18711	9300	24	0	\N
144467	554	67450022000000	18711	9300	25	0	\N
144468	849	1158280730361640	18711	9300	26	0	\N
144479	1397	1330159150000	18713	9426	0	0	\N
144480	1397	1330149149000	18713	9426	1	0	\N
144481	1397	1330139148000	18713	9426	2	0	\N
144482	1397	1330129147000	18713	9426	3	0	\N
144483	2132	148496497000	18713	9426	4	0	\N
144484	2134	97076246000	18713	9426	5	0	\N
144485	2190	2150988000000	18713	9426	6	0	\N
144486	2134	97075243000	18713	9426	7	0	\N
144487	2134	97074240000	18713	9426	8	0	\N
144488	2134	97073237000	18713	9426	9	0	\N
144496	1397	1330099144000	18717	9429	0	0	\N
144497	2134	97070228000	18717	9429	1	0	\N
144507	1397	1330049139000	18721	9433	0	0	\N
144508	2132	148493494000	18721	9433	1	0	\N
144509	2134	97065213000	18721	9433	2	0	\N
144519	1397	1330019136000	18724	9435	0	0	\N
144520	2134	97062204000	18724	9435	1	0	\N
144521	2132	148492493000	18724	9435	2	0	\N
144522	1397	1330019136000	18725	9435	0	0	\N
144523	2134	97062204000	18725	9435	1	0	\N
144524	2132	148492493000	18725	9435	2	0	\N
144530	1397	1330009135000	18728	9436	0	0	\N
144531	2134	97061201000	18728	9436	1	0	\N
144534	1397	1329989133000	18731	9439	0	0	\N
144535	1397	1329979132000	18731	9439	1	0	\N
144536	2132	148491492000	18731	9439	2	0	\N
144537	2134	97059195000	18731	9439	3	0	\N
144538	2134	97058192000	18731	9439	4	0	\N
144548	1397	1329949129000	18734	9441	0	0	\N
144549	1397	1329939128000	18734	9441	1	0	\N
144550	1397	1329929127000	18734	9441	2	0	\N
144551	2132	148490491000	18734	9441	3	0	\N
144552	2134	97055183000	18734	9441	4	0	\N
144553	2134	97054180000	18734	9441	5	0	\N
144554	2134	97053177000	18734	9441	6	0	\N
144555	1397	1329949129000	18735	9441	0	0	\N
144556	1397	1329939128000	18735	9441	1	0	\N
144557	1397	1329929127000	18735	9441	2	0	\N
144565	1397	1329949129000	18737	9441	0	0	\N
144566	1397	1329939128000	18737	9441	1	0	\N
144567	1397	1329929127000	18737	9441	2	0	\N
144568	2132	148490491000	18737	9441	3	0	\N
144435	1397	1330189153000	18708	9424	0	0	10864
144436	1397	1330179152000	18708	9424	1	0	10865
144437	2134	97078252000	18708	9424	2	0	1916
144438	2134	97077249000	18708	9424	3	0	1917
144439	2132	148497498000	18708	9424	4	0	502
144469	1397	1330159150000	18712	9426	0	0	10867
144470	1397	1330149149000	18712	9426	1	0	10868
144471	1397	1330139148000	18712	9426	2	0	10869
144472	1397	1330129147000	18712	9426	3	0	10870
144473	2132	148496497000	18712	9426	4	0	503
144475	2190	2150988000000	18712	9426	6	0	2
144476	2134	97075243000	18712	9426	7	0	1919
144477	2134	97074240000	18712	9426	8	0	1920
144478	2134	97073237000	18712	9426	9	0	1921
144490	2134	97072234000	18714	9427	1	0	1922
144491	2132	148495496000	18714	9427	2	0	504
144492	1397	1330109145000	18715	9428	0	0	10872
144493	2134	97071231000	18715	9428	1	0	1923
144494	1397	1330099144000	18716	9429	0	0	10873
144498	1397	1330089143000	18718	9430	0	0	10874
144499	2134	97069225000	18718	9430	1	0	1925
144500	2132	148494495000	18718	9430	2	0	505
144501	1397	1330079142000	18719	9431	0	0	10875
144502	1397	1330069141000	18719	9431	1	0	10876
144504	2134	97067219000	18719	9431	3	0	1927
144505	1397	1330059140000	18720	9432	0	0	10877
144506	2134	97066216000	18720	9432	1	0	1928
144510	1397	1330049139000	18722	9433	0	0	10878
144512	2134	97065213000	18722	9433	2	0	1929
144513	1397	1330039138000	18723	9434	0	0	10879
144514	1397	1330029137000	18723	9434	1	0	10880
144515	1726	97486112000	18723	9434	2	0	8206
144516	1726	96276112000	18723	9434	3	0	8207
144518	2134	97063207000	18723	9434	5	0	1931
144525	1397	1330019136000	18726	9435	0	0	10881
144526	2134	97062204000	18726	9435	1	0	1932
144527	2132	148492493000	18726	9435	2	0	507
144528	1397	1330009135000	18727	9436	0	0	10882
144532	1397	1329999134000	18729	9437	0	0	10883
144533	2134	97060198000	18729	9437	1	0	1934
144539	1397	1329989133000	18732	9439	0	0	10884
144540	1397	1329979132000	18732	9439	1	0	10885
144542	2134	97059195000	18732	9439	3	0	1935
144543	2134	97058192000	18732	9439	4	0	1936
144544	1397	1329969131000	18733	9440	0	0	10886
144545	1397	1329959130000	18733	9440	1	0	10887
144546	2134	97057189000	18733	9440	2	0	1937
144558	1397	1329949129000	18736	9441	0	0	10888
144559	1397	1329939128000	18736	9441	1	0	10889
144560	1397	1329929127000	18736	9441	2	0	10890
144561	2132	148490491000	18736	9441	3	0	509
144562	2134	97055183000	18736	9441	4	0	1939
144564	2134	97053177000	18736	9441	6	0	1941
144569	2134	97055183000	18737	9441	4	0	\N
144570	2134	97054180000	18737	9441	5	0	\N
144571	2134	97053177000	18737	9441	6	0	\N
144576	1397	1329919126000	18739	9442	0	0	\N
144577	2132	148489490000	18739	9442	1	0	\N
144578	1821	527489000000	18739	9442	2	0	\N
144579	2134	97052174000	18739	9442	3	0	\N
144580	1397	1329919126000	18740	9442	0	0	\N
144581	2132	148489490000	18740	9442	1	0	\N
144582	1821	527489000000	18740	9442	2	0	\N
144592	1397	1329889123000	18743	9444	0	0	\N
144593	112	66001905193897	18743	9444	1	0	\N
144594	2134	97049165000	18743	9444	2	0	\N
144595	112	66000000193897	18743	9444	3	0	\N
144608	266	66000928193897	18748	9437	0	0	\N
144609	112	66001905193897	18748	9437	1	0	\N
144610	2132	148491492000	18748	9437	2	0	\N
144622	1726	95066112000	18753	9453	0	0	\N
144623	1397	1329779112000	18753	9453	1	0	\N
144624	2132	148485486000	18753	9453	2	0	\N
144625	2134	97038132000	18753	9453	3	0	\N
144630	1397	1329769111000	18755	9454	0	0	\N
144631	2134	97037129000	18755	9454	1	0	\N
144634	1397	1329759110000	18757	9455	0	0	\N
144635	2134	97036126000	18757	9455	1	0	\N
144641	1397	1329739108000	18760	9457	0	0	\N
144642	849	1153280729361640	18760	9457	1	0	\N
144643	2134	97034120000	18760	9457	2	0	\N
144644	1397	1329739108000	18761	9457	0	0	\N
144645	849	1153280729361640	18761	9457	1	0	\N
144646	2134	97034120000	18761	9457	2	0	\N
144647	1397	1329739108000	18762	9457	0	0	\N
144648	849	1153280729361640	18762	9457	1	0	\N
144649	2134	97034120000	18762	9457	2	0	\N
144650	1397	1329739108000	18763	9457	0	0	\N
144651	849	1153280729361640	18763	9457	1	0	\N
144652	2134	97034120000	18763	9457	2	0	\N
144653	1397	1329739108000	18764	9457	0	0	\N
144654	849	1153280729361640	18764	9457	1	0	\N
144655	2134	97034120000	18764	9457	2	0	\N
144662	2198	100000000	18767	9458	0	0	\N
144663	1397	1329729107000	18767	9458	1	0	\N
144664	2134	97033117000	18767	9458	2	0	\N
144665	1397	1329719106000	18768	9459	0	0	\N
144666	2134	97032114000	18768	9459	1	0	\N
144667	1397	1329719106000	18769	9459	0	0	\N
144668	2134	97032114000	18769	9459	1	0	\N
144671	1397	1329719106000	18771	9459	0	0	\N
144672	2134	97032114000	18771	9459	1	0	\N
144676	1397	1329699104000	18773	9461	0	0	\N
144677	2134	97030108000	18773	9461	1	0	\N
144680	1397	1329699104000	18775	9461	0	0	\N
144681	2134	97030108000	18775	9461	1	0	\N
144695	1397	1329649099000	18778	9463	0	0	\N
144696	2132	148481482000	18778	9463	1	0	\N
144697	2134	97025093000	18778	9463	2	0	\N
144698	1397	1329649099000	18779	9463	0	0	\N
144699	2132	148481482000	18779	9463	1	0	\N
144700	2134	97025093000	18779	9463	2	0	\N
144701	1397	1329639098000	18780	9464	0	0	\N
144702	2134	97024090000	18780	9464	1	0	\N
144703	1397	1329639098000	18781	9464	0	0	\N
144704	2134	97024090000	18781	9464	1	0	\N
144574	1821	527489000000	18738	9442	2	0	2
144575	2134	97052174000	18738	9442	3	0	1942
144583	1397	1329909125000	18741	9443	0	0	10892
144584	1397	1329899124000	18741	9443	1	0	10893
144585	266	66000928193897	18741	9443	2	0	1
144587	2134	97050168000	18741	9443	4	0	1944
144588	1397	1329889123000	18742	9444	0	0	10894
144589	112	66001905193897	18742	9444	1	0	6
144590	2134	97049165000	18742	9444	2	0	1945
144591	112	66000000193897	18742	9444	3	0	7
144597	2134	97048162000	18744	9445	1	0	1946
144598	2132	148488489000	18744	9445	2	0	511
144599	1397	1329869121000	18745	9446	0	0	10896
144600	2134	97047159000	18745	9446	1	0	1947
144602	2134	97046156000	18746	9447	1	0	1948
144603	1397	1329849119000	18747	9448	0	0	10898
144604	1397	1329839118000	18747	9448	1	0	10899
144605	2134	97045153000	18747	9448	2	0	1949
144606	2134	97044150000	18747	9448	3	0	1950
144611	1397	1329829117000	18749	9449	0	0	10900
144612	2134	97043147000	18749	9449	1	0	1951
144613	1397	1329819116000	18750	9450	0	0	10901
144614	1397	1329809115000	18750	9450	1	0	10902
144615	2134	97042144000	18750	9450	2	0	1952
144617	2132	148486487000	18750	9450	4	0	513
144618	1397	1329799114000	18751	9451	0	0	10903
144619	2134	97040138000	18751	9451	1	0	1954
144620	1397	1329789113000	18752	9452	0	0	10904
144626	1726	95066112000	18754	9453	0	0	8208
144627	1397	1329779112000	18754	9453	1	0	10905
144628	2132	148485486000	18754	9453	2	0	514
144629	2134	97038132000	18754	9453	3	0	1956
144632	1397	1329769111000	18756	9454	0	0	10906
144636	1397	1329759110000	18758	9455	0	0	10907
144637	2134	97036126000	18758	9455	1	0	1958
144638	1397	1329749109000	18759	9456	0	0	10908
144639	2132	148484485000	18759	9456	1	0	515
144640	2134	97035123000	18759	9456	2	0	1959
144657	849	1153280729361640	18765	9457	1	0	3
144658	2134	97034120000	18765	9457	2	0	1960
144659	2198	100000000	18766	9458	0	0	1
144660	1397	1329729107000	18766	9458	1	0	10910
144669	1397	1329719106000	18770	9459	0	0	10911
144670	2134	97032114000	18770	9459	1	0	1962
144673	1397	1329709105000	18772	9460	0	0	10912
144674	2132	148483484000	18772	9460	1	0	516
144675	2134	97031111000	18772	9460	2	0	1963
144679	2134	97030108000	18774	9461	1	0	1964
144682	1397	1329689103000	18776	9462	0	0	10914
144683	1397	1329679102000	18776	9462	1	0	10915
144684	1397	1329669101000	18776	9462	2	0	10916
144685	1397	1329659100000	18776	9462	3	0	10917
144687	2132	148482483000	18776	9462	6	0	517
144688	2134	97029105000	18776	9462	7	0	1965
144689	2134	97028102000	18776	9462	8	0	1966
144690	2134	97027099000	18776	9462	9	0	1967
144692	1397	1329649099000	18777	9463	0	0	10918
144693	2132	148481482000	18777	9463	1	0	518
144694	2134	97025093000	18777	9463	2	0	1969
144710	1397	1329629097000	18784	9465	0	0	\N
144711	2134	97023087000	18784	9465	1	0	\N
144712	2134	97022084000	18784	9465	2	0	\N
144718	1397	1329619096000	18786	9466	0	0	\N
144719	1397	1329609095000	18786	9466	1	0	\N
144720	2132	148480481000	18786	9466	2	0	\N
144721	2134	97021081000	18786	9466	3	0	\N
144722	2134	97020078000	18786	9466	4	0	\N
144730	1397	1329589093000	18789	9468	0	0	\N
144731	1397	1329579092000	18789	9468	1	0	\N
144732	2134	97018072000	18789	9468	2	0	\N
144733	2134	97017069000	18789	9468	3	0	\N
144734	2132	148479480000	18789	9468	4	0	\N
144735	2134	97018072000	18790	9468	0	0	\N
144736	2134	97017069000	18790	9468	1	0	\N
144737	2132	148479480000	18790	9468	2	0	\N
144738	1397	1329569091000	18791	9469	0	0	\N
144739	2134	97016066000	18791	9469	1	0	\N
144742	504	66610888193897	18793	9470	0	0	\N
144743	1397	1329559090000	18793	9470	1	0	\N
144744	1397	1329549089000	18793	9470	2	0	\N
144745	2134	97015063000	18793	9470	3	0	\N
144746	2134	97014060000	18793	9470	4	0	\N
144747	2132	148478479000	18793	9470	5	0	\N
144768	1397	1329489083000	18797	9472	0	0	\N
144769	2134	97008042000	18797	9472	1	0	\N
144770	2132	148476477000	18797	9472	2	0	\N
144771	1397	1329489083000	18798	9472	0	0	\N
144772	2134	97008042000	18798	9472	1	0	\N
144773	2132	148476477000	18798	9472	2	0	\N
144774	1397	1329489083000	18799	9472	0	0	\N
144775	2134	97008042000	18799	9472	1	0	\N
144776	2132	148476477000	18799	9472	2	0	\N
144786	1397	1329459080000	18803	9475	0	0	\N
144787	1397	1329449079000	18803	9475	1	0	\N
144788	2134	97005033000	18803	9475	2	0	\N
144789	2134	97004030000	18803	9475	3	0	\N
144790	2132	148475476000	18803	9475	4	0	\N
144795	1397	1329419076000	18806	9478	0	0	\N
144796	2132	148474475000	18806	9478	1	0	\N
144797	2134	97001021000	18806	9478	2	0	\N
144801	1397	1329419076000	18808	9478	0	0	\N
144802	2132	148474475000	18808	9478	1	0	\N
144803	2134	97001021000	18808	9478	2	0	\N
144804	1397	1329409075000	18809	9479	0	0	\N
144805	2134	97000018000	18809	9479	1	0	\N
144808	1397	1329409075000	18811	9479	0	0	\N
144809	2134	97000018000	18811	9479	1	0	\N
144810	1397	1329399074000	18812	9480	0	0	\N
144811	1397	1329389073000	18812	9480	1	0	\N
144812	1397	1329379072000	18812	9480	2	0	\N
144813	2134	96999015000	18812	9480	3	0	\N
144814	2132	148473474000	18812	9480	4	0	\N
144815	1397	1329399074000	18813	9480	0	0	\N
144816	1397	1329389073000	18813	9480	1	0	\N
144817	1397	1329379072000	18813	9480	2	0	\N
144818	2134	96999015000	18813	9480	3	0	\N
144819	2132	148473474000	18813	9480	4	0	\N
144826	1397	1329359070000	18816	9482	0	0	\N
144830	1397	1329339068000	18820	9484	0	0	\N
144833	1397	1329319066000	18823	9486	0	0	\N
144834	2132	148471472000	18823	9486	1	0	\N
144837	1397	1329319066000	18825	9486	0	0	\N
144838	2132	148471472000	18825	9486	1	0	\N
144840	1397	1329299064000	18827	9488	0	0	\N
144707	1397	1329629097000	18783	9465	0	0	10920
144708	2134	97023087000	18783	9465	1	0	1971
144709	2134	97022084000	18783	9465	2	0	1972
144713	1397	1329619096000	18785	9466	0	0	10921
144714	1397	1329609095000	18785	9466	1	0	10922
144716	2134	97021081000	18785	9466	3	0	1973
144717	2134	97020078000	18785	9466	4	0	1974
144723	1397	1329599094000	18787	9467	0	0	10923
144724	2134	97019075000	18787	9467	1	0	1975
144725	1397	1329589093000	18788	9468	0	0	10924
144727	2134	97018072000	18788	9468	2	0	1976
144728	2134	97017069000	18788	9468	3	0	1977
144729	2132	148479480000	18788	9468	4	0	520
144740	1397	1329569091000	18792	9469	0	0	10926
144748	504	66610888193897	18794	9470	0	0	1
144749	1397	1329559090000	18794	9470	1	0	10927
144750	1397	1329549089000	18794	9470	2	0	10928
144751	2134	97015063000	18794	9470	3	0	1979
144752	2134	97014060000	18794	9470	4	0	1980
144754	1397	1329539088000	18795	9471	0	0	10929
144755	1397	1329529087000	18795	9471	1	0	10930
144756	1397	1329519086000	18795	9471	2	0	10931
144757	1397	1329509085000	18795	9471	3	0	10932
144758	1397	1329499084000	18795	9471	4	0	10933
144760	2134	97013057000	18795	9471	6	0	1981
144761	2134	97012054000	18795	9471	7	0	1982
144762	2134	97011051000	18795	9471	8	0	1983
144763	2134	97010048000	18795	9471	9	0	1984
144765	1397	1329489083000	18796	9472	0	0	10934
144766	2134	97008042000	18796	9472	1	0	1986
144767	2132	148476477000	18796	9472	2	0	523
144777	1397	1329479082000	18800	9473	0	0	10935
144778	2134	97007039000	18800	9473	1	0	1987
144780	2134	97006036000	18801	9474	1	0	1988
144781	1397	1329459080000	18802	9475	0	0	10937
144782	1397	1329449079000	18802	9475	1	0	10938
144783	2134	97005033000	18802	9475	2	0	1989
144784	2134	97004030000	18802	9475	3	0	1990
144791	1397	1329439078000	18804	9476	0	0	10939
144792	2134	97003027000	18804	9476	1	0	1991
144793	1397	1329429077000	18805	9477	0	0	10940
144794	2134	97002024000	18805	9477	1	0	1992
144799	2132	148474475000	18807	9478	1	0	525
144800	2134	97001021000	18807	9478	2	0	1993
144806	1397	1329409075000	18810	9479	0	0	10942
144807	2134	97000018000	18810	9479	1	0	1994
144820	1397	1329399074000	18814	9480	0	0	10943
144822	1397	1329379072000	18814	9480	2	0	10945
144823	2134	96999015000	18814	9480	3	0	1995
144824	2132	148473474000	18814	9480	4	0	526
144825	1397	1329369071000	18815	9481	0	0	10946
144827	1397	1329359070000	18817	9482	0	0	10947
144829	2132	148472473000	18818	9483	1	0	527
144831	1397	1329339068000	18821	9484	0	0	10949
144832	1397	1329329067000	18822	9485	0	0	10950
144835	1397	1329319066000	18824	9486	0	0	10951
144839	1397	1329309065000	18826	9487	0	0	10952
144841	1397	1329299064000	18828	9488	0	0	\N
144842	1397	1329299064000	18829	9488	0	0	\N
144852	1397	1329229057000	18836	9494	0	0	\N
144857	1397	1329199054000	18839	9496	0	0	\N
144870	1397	1329129047000	18846	9501	0	0	\N
144871	1397	1329119046000	18846	9501	1	0	\N
144872	2132	148465466000	18846	9501	2	0	\N
144877	1397	1329079042000	18850	9505	0	0	\N
144878	1397	1329079042000	18851	9505	0	0	\N
144879	1397	1329079042000	18852	9505	0	0	\N
144881	1397	1329079042000	18854	9505	0	0	\N
144887	1397	1329029037000	18858	9509	0	0	\N
144892	1397	1329019036000	18861	9510	0	0	\N
144893	1397	1329009035000	18861	9510	1	0	\N
144894	2132	148462463000	18861	9510	2	0	\N
144895	1397	1328999034000	18862	9511	0	0	\N
144896	2132	148461462000	18862	9511	1	0	\N
144901	1397	1328989033000	18865	9512	0	0	\N
144902	1397	1328979032000	18865	9512	1	0	\N
144907	1397	1328939028000	18869	9516	0	0	\N
144908	1397	1328929027000	18869	9516	1	0	\N
144909	2132	148459460000	18869	9516	2	0	\N
144910	1397	1328939028000	18870	9516	0	0	\N
144911	1397	1328929027000	18870	9516	1	0	\N
144912	2132	148459460000	18870	9516	2	0	\N
144917	1397	1328909025000	18873	9518	0	0	\N
144918	1397	1328909025000	18874	9518	0	0	\N
144919	1397	1328909025000	18875	9518	0	0	\N
144920	1397	1329419076000	18876	9478	0	0	\N
144921	1397	1329409075000	18876	9478	1	0	\N
144922	1397	1329399074000	18876	9478	2	0	\N
144923	1397	1329389073000	18876	9478	3	0	\N
144924	1397	1329379072000	18876	9478	4	0	\N
144925	1397	1329369071000	18876	9478	5	0	\N
144926	1397	1329359070000	18876	9478	6	0	\N
144927	1397	1329349069000	18876	9478	7	0	\N
144928	1397	1329339068000	18876	9478	8	0	\N
144929	1397	1329329067000	18876	9478	9	0	\N
144930	1397	1329319066000	18876	9478	10	0	\N
144931	1397	1329309065000	18876	9478	11	0	\N
144932	1397	1329299064000	18876	9478	12	0	\N
144933	1397	1329289063000	18876	9478	13	0	\N
144934	1397	1329279062000	18876	9478	14	0	\N
144935	1397	1329269061000	18876	9478	15	0	\N
144936	1397	1329259060000	18876	9478	16	0	\N
144937	1397	1329249059000	18876	9478	17	0	\N
144938	1397	1329239058000	18876	9478	18	0	\N
144939	1397	1329229057000	18876	9478	19	0	\N
144940	1397	1329219056000	18876	9478	20	0	\N
144941	1397	1329209055000	18876	9478	21	0	\N
144942	1397	1329199054000	18876	9478	22	0	\N
144943	1397	1329189053000	18876	9478	23	0	\N
144944	1397	1329179052000	18876	9478	24	0	\N
144945	1397	1329169051000	18876	9478	25	0	\N
144946	1397	1329159050000	18876	9478	26	0	\N
144947	1397	1329149049000	18876	9478	27	0	\N
144948	1397	1329139048000	18876	9478	28	0	\N
144949	1397	1329129047000	18876	9478	29	0	\N
144950	1397	1329119046000	18876	9478	30	0	\N
144951	1397	1329109045000	18876	9478	31	0	\N
144952	1397	1329099044000	18876	9478	32	0	\N
144953	1397	1329089043000	18876	9478	33	0	\N
144954	1397	1329079042000	18876	9478	34	0	\N
144955	1397	1329069041000	18876	9478	36	0	\N
144956	1397	1329059040000	18876	9478	37	0	\N
144957	1397	1329049039000	18876	9478	38	0	\N
144958	1397	1329039038000	18876	9478	39	0	\N
144959	1397	1329029037000	18876	9478	40	0	\N
144960	1397	1329019036000	18876	9478	41	0	\N
144961	1397	1329009035000	18876	9478	42	0	\N
144962	1397	1328999034000	18876	9478	43	0	\N
144963	1397	1328989033000	18876	9478	44	0	\N
144964	1397	1328979032000	18876	9478	45	0	\N
144965	1397	1328969031000	18876	9478	46	0	\N
144966	1397	1328959030000	18876	9478	47	0	\N
144967	1397	1328949029000	18876	9478	48	0	\N
144968	1397	1328939028000	18876	9478	49	0	\N
144969	1397	1328929027000	18876	9478	50	0	\N
144970	1397	1328919026000	18876	9478	51	0	\N
144971	1397	1328909025000	18876	9478	52	0	\N
144972	2132	148474475000	18876	9478	53	0	\N
144973	2134	97001021000	18876	9478	54	0	\N
144974	2132	148473474000	18876	9478	55	0	\N
144975	2132	148472473000	18876	9478	56	0	\N
144976	2132	148471472000	18876	9478	57	0	\N
144845	1397	1329279062000	18831	9489	1	0	10955
144846	2132	148470471000	18831	9489	2	0	529
144847	1397	1329269061000	18832	9490	0	0	10956
144848	1397	1329259060000	18833	9491	0	0	10957
144849	1397	1329249059000	18834	9492	0	0	10958
144851	1397	1329239058000	18835	9493	0	0	10959
144853	1397	1329229057000	18837	9494	0	0	10960
144854	1397	1329219056000	18838	9495	0	0	10961
144855	1397	1329209055000	18838	9495	1	0	10962
144856	2132	148468469000	18838	9495	2	0	531
144859	1397	1329189053000	18841	9497	0	0	10964
144860	2132	148467468000	18841	9497	1	0	532
144861	1397	1329179052000	18842	9498	0	0	10965
144862	1397	1329169051000	18842	9498	1	0	10966
144864	1397	1329149049000	18843	9499	1	0	10968
144865	2132	148466467000	18843	9499	2	0	533
144866	1397	1329139048000	18844	9500	0	0	10969
144867	1397	1329129047000	18845	9501	0	0	10970
144868	1397	1329119046000	18845	9501	1	0	10971
144873	1397	1329109045000	18847	9502	0	0	10972
144874	1397	1329099044000	18848	9503	0	0	10973
144875	1397	1329089043000	18849	9504	0	0	10974
144876	2132	148464465000	18849	9504	1	0	535
144880	1397	1329079042000	18853	9505	0	0	10975
144883	1397	1329059040000	18855	9506	1	0	10977
144884	1397	1329049039000	18856	9507	0	0	10978
144885	2132	148463464000	18856	9507	1	0	536
144886	1397	1329039038000	18857	9508	0	0	10979
144889	1397	1329019036000	18860	9510	0	0	10981
144890	1397	1329009035000	18860	9510	1	0	10982
144891	2132	148462463000	18860	9510	2	0	537
144897	1397	1328999034000	18863	9511	0	0	10983
144898	2132	148461462000	18863	9511	1	0	538
144900	1397	1328979032000	18864	9512	1	0	10985
144903	1397	1328969031000	18866	9513	0	0	10986
144904	1397	1328959030000	18867	9514	0	0	10987
144905	2132	148460461000	18867	9514	1	0	539
144906	1397	1328949029000	18868	9515	0	0	10988
144914	1397	1328929027000	18871	9516	1	0	10990
144915	2132	148459460000	18871	9516	2	0	540
144916	1397	1328919026000	18872	9517	0	0	10991
144977	2132	148470471000	18876	9478	58	0	\N
144978	2132	148469470000	18876	9478	59	0	\N
144979	2132	148468469000	18876	9478	60	0	\N
144980	2132	148467468000	18876	9478	61	0	\N
144981	2132	148466467000	18876	9478	62	0	\N
144982	2132	148465466000	18876	9478	63	0	\N
144983	2132	148464465000	18876	9478	64	0	\N
144984	2134	97000018000	18876	9478	65	0	\N
144985	2134	96999015000	18876	9478	66	0	\N
144986	2132	148463464000	18876	9478	67	0	\N
144987	2132	148462463000	18876	9478	68	0	\N
144988	2132	148461462000	18876	9478	69	0	\N
144989	2132	148460461000	18876	9478	70	0	\N
144990	2132	148459460000	18876	9478	71	0	\N
145000	1397	1328839018000	18883	9524	0	0	\N
145009	1397	1328779012000	18889	9529	0	0	\N
145010	1397	1328769011000	18889	9529	1	0	\N
145015	1397	1328759010000	18892	9530	0	0	\N
145016	2132	148454455000	18892	9530	1	0	\N
145017	1397	1328759010000	18893	9530	0	0	\N
145018	2132	148454455000	18893	9530	1	0	\N
145019	1397	1328759010000	18894	9530	0	0	\N
145020	2132	148454455000	18894	9530	1	0	\N
145021	1397	1328759010000	18895	9530	0	0	\N
145022	2132	148454455000	18895	9530	1	0	\N
145023	1397	1328779012000	18896	9529	0	0	\N
145024	1397	1328769011000	18896	9529	1	0	\N
145025	1397	1328759010000	18896	9529	2	0	\N
145026	2132	148454455000	18896	9529	3	0	\N
145029	1397	1328729007000	18899	9533	0	0	\N
145030	2132	148453454000	18899	9533	1	0	\N
145034	1715	42480703990002	18902	9287	0	0	\N
145035	1715	42479503990002	18902	9287	1	0	\N
145036	1715	41955446296216	18902	9287	2	0	\N
145037	1715	41431388602430	18902	9287	3	0	\N
145038	1715	40907330908644	18902	9287	4	0	\N
145039	1715	37119045345189	18902	9287	5	0	\N
145043	1397	1328719006000	18904	9534	0	0	\N
145044	1397	1328709005000	18904	9534	1	0	\N
145045	1397	1328699004000	18904	9534	2	0	\N
145046	2132	148452453000	18904	9534	3	0	\N
145047	1397	1328689003000	18905	9536	0	0	\N
145059	1397	1328618996000	18913	9540	0	0	\N
145060	1397	1328608995000	18913	9540	1	0	\N
145061	1397	1328598994000	18914	9541	0	0	\N
145062	2132	148449450000	18914	9541	1	0	\N
145065	1397	1328598994000	18916	9541	0	0	\N
145066	2132	148449450000	18916	9541	1	0	\N
145072	1397	1328899024000	18920	9479	0	0	\N
145073	1397	1328889023000	18920	9479	1	0	\N
145074	1397	1328879022000	18920	9479	2	0	\N
145075	1397	1328869021000	18920	9479	3	0	\N
145076	1397	1328859020000	18920	9479	4	0	\N
145077	1397	1328849019000	18920	9479	5	0	\N
145078	1397	1328839018000	18920	9479	6	0	\N
145079	1397	1328829017000	18920	9479	7	0	\N
145080	1397	1328819016000	18920	9479	8	0	\N
145081	1397	1328809015000	18920	9479	9	0	\N
145082	1397	1328799014000	18920	9479	10	0	\N
145083	1397	1328789013000	18920	9479	11	0	\N
145084	1397	1328779012000	18920	9479	12	0	\N
145085	1397	1328769011000	18920	9479	13	0	\N
145086	1397	1328759010000	18920	9479	14	0	\N
145087	1397	1328749009000	18920	9479	15	0	\N
145088	1397	1328739008000	18920	9479	16	0	\N
145089	1397	1328729007000	18920	9479	17	0	\N
145090	1397	1328719006000	18920	9479	18	0	\N
145091	1397	1328709005000	18920	9479	19	0	\N
145092	1397	1328699004000	18920	9479	20	0	\N
145093	1397	1328689003000	18920	9479	21	0	\N
145094	1397	1328679002000	18920	9479	22	0	\N
145095	1397	1328669001000	18920	9479	23	0	\N
145096	1397	1328659000000	18920	9479	24	0	\N
145097	1397	1328648999000	18920	9479	25	0	\N
145098	1397	1328638998000	18920	9479	26	0	\N
145099	1397	1328628997000	18920	9479	27	0	\N
145100	1397	1328618996000	18920	9479	28	0	\N
145101	1397	1328608995000	18920	9479	29	0	\N
145102	1397	1328598994000	18920	9479	30	0	\N
145103	1397	1328588993000	18920	9479	31	0	\N
145104	1397	1328578992000	18920	9479	32	0	\N
145105	1397	1328568991000	18920	9479	33	0	\N
145106	1397	1328558990000	18920	9479	34	0	\N
145107	2132	148458459000	18920	9479	35	0	\N
145108	2132	148457458000	18920	9479	36	0	\N
145109	2132	148456457000	18920	9479	37	0	\N
145110	2132	148455456000	18920	9479	38	0	\N
145111	2132	148454455000	18920	9479	39	0	\N
145112	2132	148453454000	18920	9479	40	0	\N
144993	1397	1328889023000	18878	9519	1	0	10994
144994	2132	148458459000	18878	9519	2	0	541
144995	1397	1328879022000	18879	9520	0	0	10995
144996	1397	1328869021000	18880	9521	0	0	10996
144997	1397	1328859020000	18881	9522	0	0	10997
144999	1397	1328849019000	18882	9523	0	0	10998
145001	1397	1328839018000	18884	9524	0	0	10999
145002	1397	1328829017000	18885	9525	0	0	11000
145003	2132	148456457000	18885	9525	1	0	543
145004	1397	1328819016000	18886	9526	0	0	11001
145006	1397	1328799014000	18887	9527	1	0	11003
145007	2132	148455456000	18887	9527	2	0	544
145008	1397	1328789013000	18888	9528	0	0	11004
145011	1397	1328779012000	18890	9529	0	0	11005
145013	1397	1328759010000	18891	9530	0	0	11007
145014	2132	148454455000	18891	9530	1	0	545
145027	1397	1328749009000	18897	9531	0	0	11008
145028	1397	1328739008000	18898	9532	0	0	11009
145031	1397	1328729007000	18900	9533	0	0	11010
145033	1397	1328719006000	18901	9534	0	0	11011
145040	1397	1328709005000	18903	9535	0	0	11012
145041	1397	1328699004000	18903	9535	1	0	11013
145042	2132	148452453000	18903	9535	2	0	547
145048	1397	1328689003000	18906	9536	0	0	11014
145050	1397	1328669001000	18907	9537	1	0	11016
145051	1397	1328659000000	18907	9537	2	0	11017
145052	1397	1328648999000	18907	9537	3	0	11018
145053	2132	148451452000	18907	9537	4	0	548
145055	1397	1328628997000	18911	9539	0	0	11020
145056	2132	148450451000	18911	9539	1	0	549
145057	1397	1328618996000	18912	9540	0	0	11021
145058	1397	1328608995000	18912	9540	1	0	11022
145063	1397	1328598994000	18915	9541	0	0	11023
145067	1397	1328588993000	18917	9542	0	0	11024
145068	1397	1328578992000	18918	9543	0	0	11025
145069	1397	1328568991000	18918	9543	1	0	11026
145070	1397	1328558990000	18919	9544	0	0	11027
145071	2132	148448449000	18919	9544	1	0	551
145113	2132	148452453000	18920	9479	41	0	\N
145114	2132	148451452000	18920	9479	42	0	\N
145115	2132	148450451000	18920	9479	43	0	\N
145116	2132	148449450000	18920	9479	44	0	\N
145117	2132	148448449000	18920	9479	45	0	\N
145119	1397	1328548989000	18922	9545	0	0	\N
145120	1397	1328548989000	18923	9545	0	0	\N
145124	1397	1328518986000	18926	9548	0	0	\N
145126	1397	1328518986000	18928	9548	0	0	\N
145127	1397	1328518986000	18929	9548	0	0	\N
145129	1397	1328498984000	18931	9550	0	0	\N
145130	2132	148446447000	18931	9550	1	0	\N
145133	1397	1328498984000	18933	9550	0	0	\N
145134	2132	148446447000	18933	9550	1	0	\N
145136	1397	1328478982000	18935	9552	0	0	\N
145141	1397	1328458980000	18939	9554	0	0	\N
145142	2132	148445446000	18939	9554	1	0	\N
145144	1397	1328438978000	18941	9556	0	0	\N
145145	1397	1328428977000	18941	9556	1	0	\N
145146	1397	1328418976000	18941	9556	2	0	\N
145147	2132	148444445000	18941	9556	3	0	\N
145152	1474	13213364000023	18943	9557	0	0	\N
145153	1397	1328408975000	18943	9557	1	0	\N
145154	1474	13213364000023	18944	9557	0	0	\N
145155	1397	1328408975000	18944	9557	1	0	\N
145158	1474	13213364000023	18946	9557	0	0	\N
145159	1397	1328398974000	18947	9558	0	0	\N
145160	1397	1328388973000	18947	9558	1	0	\N
145161	2132	148443444000	18947	9558	2	0	\N
145165	1397	1328378972000	18949	9559	0	0	\N
145169	1397	1328368971000	18953	9560	0	0	\N
145170	526	69500075000000	18953	9560	1	0	\N
145175	1397	1328348969000	18956	9562	0	0	\N
145177	1397	1328338968000	18958	9563	0	0	\N
145178	1397	1328328967000	18960	9564	0	0	\N
145179	2118	1394000000	18960	9564	1	0	\N
145180	2132	148441442000	18960	9564	2	0	\N
145184	1397	1328328967000	18962	9564	0	0	\N
145185	2118	1394000000	18962	9564	1	0	\N
145186	2132	148441442000	18962	9564	2	0	\N
145187	1397	1328318966000	18963	9565	0	0	\N
145190	1397	1328298964000	18966	9567	0	0	\N
145191	2132	148440441000	18966	9567	1	0	\N
145192	1397	1328298964000	18967	9567	0	0	\N
145193	2132	148440441000	18967	9567	1	0	\N
145196	1397	1328298964000	18969	9567	0	0	\N
145197	2132	148440441000	18969	9567	1	0	\N
145201	1397	1328258960000	18972	9570	0	0	\N
145202	2132	148439440000	18972	9570	1	0	\N
145203	1397	1328258960000	18973	9570	0	0	\N
145204	2132	148439440000	18973	9570	1	0	\N
145205	1397	1328258960000	18974	9570	0	0	\N
145206	2132	148439440000	18974	9570	1	0	\N
145209	1397	1328258960000	18976	9570	0	0	\N
145210	2132	148439440000	18976	9570	1	0	\N
145216	1397	1328208955000	18978	9572	0	0	\N
145218	1397	1328208955000	18980	9572	0	0	\N
145221	1397	1328198954000	18983	9573	0	0	\N
145222	2132	148437438000	18983	9573	1	0	\N
145224	1397	1328188953000	18985	9574	0	0	\N
145225	1397	1328178952000	18986	9575	0	0	\N
145226	1611	22370601840000	18986	9575	1	0	\N
145227	1611	19901996500000	18986	9575	2	0	\N
145228	1611	13023010000000	18986	9575	3	0	\N
145229	1397	1328178952000	18987	9575	0	0	\N
145230	1611	22370601840000	18987	9575	1	0	\N
145231	1611	19901996500000	18987	9575	2	0	\N
145232	1611	13023010000000	18987	9575	3	0	\N
145237	1397	1328168951000	18989	9576	0	0	\N
145239	1397	1328158950000	18991	9577	0	0	\N
145240	2132	148436437000	18991	9577	1	0	\N
145241	1397	1328158950000	18992	9577	0	0	\N
145242	2132	148436437000	18992	9577	1	0	\N
145243	1397	1328158950000	18993	9577	0	0	\N
145244	2132	148436437000	18993	9577	1	0	\N
145248	1397	1328148949000	18996	9578	0	0	\N
145122	1397	1328528987000	18925	9547	0	0	11030
145123	2132	148447448000	18925	9547	1	0	552
145125	1397	1328518986000	18927	9548	0	0	11031
145128	1397	1328508985000	18930	9549	0	0	11032
145131	1397	1328498984000	18932	9550	0	0	11033
145135	1397	1328488983000	18934	9551	0	0	11034
145137	1397	1328478982000	18936	9552	0	0	11035
145138	1397	1328468981000	18937	9553	0	0	11036
145139	1397	1328458980000	18938	9554	0	0	11037
145140	2132	148445446000	18938	9554	1	0	554
145148	1397	1328438978000	18942	9556	0	0	11039
145149	1397	1328428977000	18942	9556	1	0	11040
145150	1397	1328418976000	18942	9556	2	0	11041
145151	2132	148444445000	18942	9556	3	0	555
145157	1397	1328408975000	18945	9557	1	0	11042
145162	1397	1328398974000	18948	9558	0	0	11043
145163	1397	1328388973000	18948	9558	1	0	11044
145164	2132	148443444000	18948	9558	2	0	556
145166	1397	1328378972000	18950	9559	0	0	11045
145168	526	69500075000000	18952	9560	1	0	1
145171	1397	1328358970000	18954	9561	0	0	11047
145172	526	66000065000000	18954	9561	1	0	2
145173	2132	148442443000	18954	9561	2	0	557
145174	1397	1328348969000	18955	9562	0	0	11048
145181	1397	1328328967000	18961	9564	0	0	11050
145182	2118	1394000000	18961	9564	1	0	4
145183	2132	148441442000	18961	9564	2	0	558
145188	1397	1328318966000	18964	9565	0	0	11051
145194	1397	1328298964000	18968	9567	0	0	11053
145195	2132	148440441000	18968	9567	1	0	559
145198	1397	1328288963000	18970	9568	0	0	11054
145199	1397	1328278962000	18970	9568	1	0	11055
145200	1397	1328268961000	18971	9569	0	0	11056
145208	2132	148439440000	18975	9570	1	0	560
145211	1397	1328248959000	18977	9571	0	0	11058
145212	1397	1328238958000	18977	9571	1	0	11059
145213	1397	1328228957000	18977	9571	2	0	11060
145214	1397	1328218956000	18977	9571	3	0	11061
145217	1397	1328208955000	18979	9572	0	0	11062
145219	1397	1328198954000	18982	9573	0	0	11063
145220	2132	148437438000	18982	9573	1	0	562
145223	1397	1328188953000	18984	9574	0	0	11064
145234	1611	22370601840000	18988	9575	1	0	3
145235	1611	19901996500000	18988	9575	2	0	4
145236	1611	13023010000000	18988	9575	3	0	5
145238	1397	1328168951000	18990	9576	0	0	11066
145245	1397	1328158950000	18994	9577	0	0	11067
145247	1397	1328148949000	18995	9578	0	0	11068
145252	1397	1328128947000	18999	9580	0	0	\N
145253	2132	148435436000	18999	9580	1	0	\N
145254	1397	1328118946000	19000	9581	0	0	\N
145256	1397	1328308965000	19005	9566	0	0	\N
145257	1397	1328298964000	19005	9566	1	0	\N
145258	1397	1328288963000	19005	9566	2	0	\N
145259	1397	1328278962000	19005	9566	3	0	\N
145260	1397	1328268961000	19005	9566	4	0	\N
145261	1397	1328258960000	19005	9566	5	0	\N
145262	1397	1328248959000	19005	9566	6	0	\N
145263	1397	1328238958000	19005	9566	7	0	\N
145264	1397	1328228957000	19005	9566	8	0	\N
145265	1397	1328218956000	19005	9566	9	0	\N
145266	1397	1328208955000	19005	9566	10	0	\N
145267	1397	1328198954000	19005	9566	11	0	\N
145268	1397	1328188953000	19005	9566	12	0	\N
145269	1397	1328178952000	19005	9566	13	0	\N
145270	1397	1328168951000	19005	9566	14	0	\N
145271	1397	1328158950000	19005	9566	15	0	\N
145272	1397	1328148949000	19005	9566	16	0	\N
145273	1397	1328138948000	19005	9566	17	0	\N
145274	1397	1328128947000	19005	9566	18	0	\N
145275	1397	1328118946000	19005	9566	19	0	\N
145276	1397	1328108945000	19005	9566	20	0	\N
145277	2132	148440441000	19005	9566	21	0	\N
145278	2132	148439440000	19005	9566	22	0	\N
145279	2132	148438439000	19005	9566	23	0	\N
145280	2132	148437438000	19005	9566	24	0	\N
145281	2132	148436437000	19005	9566	25	0	\N
145282	1611	22370601840000	19005	9566	26	0	\N
145283	1611	19901996500000	19005	9566	27	0	\N
145284	1611	13023010000000	19005	9566	28	0	\N
145285	2132	148435436000	19005	9566	29	0	\N
145289	1397	1328088943000	19008	9585	0	0	\N
145291	1397	1328088943000	19010	9585	0	0	\N
145292	1397	1328078942000	19011	9586	0	0	\N
145293	2172	197999000	19011	9586	1	0	\N
145296	1397	1328078942000	19013	9586	0	0	\N
145297	2172	197999000	19013	9586	1	0	\N
145298	1397	1328068941000	19014	9587	0	0	\N
145299	2132	148433434000	19014	9587	1	0	\N
145300	1397	1328068941000	19015	9587	0	0	\N
145301	2132	148433434000	19015	9587	1	0	\N
145302	1397	1328068941000	19016	9587	0	0	\N
145303	2132	148433434000	19016	9587	1	0	\N
145308	1397	1328048939000	19020	9589	0	0	\N
145309	1397	1328038938000	19020	9589	1	0	\N
145310	2131	191998000	19020	9589	2	0	\N
145311	2132	148432433000	19020	9589	3	0	\N
145317	1397	1328028937000	19023	9590	0	0	\N
145318	1397	1328028937000	19024	9590	0	0	\N
145333	1397	1327918926000	19032	9597	0	0	\N
145334	1397	1327918926000	19033	9597	0	0	\N
145340	1397	1327868921000	19038	9602	0	0	\N
145341	2132	148427428000	19038	9602	1	0	\N
145351	1397	1327848919000	19043	9604	0	0	\N
145352	1397	1327838918000	19043	9604	1	0	\N
145353	1397	1327828917000	19043	9604	2	0	\N
145354	1397	1327818916000	19043	9604	3	0	\N
145355	2132	148426427000	19043	9604	4	0	\N
145356	1769	1586900000	19043	9604	5	0	\N
145361	1397	1327778912000	19045	9606	0	0	\N
145362	1397	1327778912000	19046	9606	0	0	\N
145371	1397	1327758910000	19050	9608	0	0	\N
145372	1397	1327748909000	19050	9608	1	0	\N
145373	1397	1327738908000	19050	9608	2	0	\N
145374	1397	1327728907000	19050	9608	3	0	\N
145375	2132	148423424000	19050	9608	4	0	\N
145377	1397	1327708905000	19052	9610	0	0	\N
145378	1397	1327698904000	19052	9610	1	0	\N
145379	2132	148422423000	19052	9610	2	0	\N
145251	2132	148435436000	18998	9580	1	0	564
145255	1397	1328118946000	19001	9581	0	0	11071
145286	1397	1328108945000	19006	9583	0	0	11072
145287	2132	148434435000	19006	9583	1	0	565
145288	1397	1328098944000	19007	9584	0	0	11073
145294	1397	1328078942000	19012	9586	0	0	11075
145295	2172	197999000	19012	9586	1	0	2
145304	1397	1328068941000	19017	9587	0	0	11076
145305	2132	148433434000	19017	9587	1	0	566
145306	1397	1328058940000	19018	9588	0	0	11077
145312	1397	1328048939000	19021	9589	0	0	11078
145313	1397	1328038938000	19021	9589	1	0	11079
145314	2131	191998000	19021	9589	2	0	7
145315	2132	148432433000	19021	9589	3	0	567
145319	1397	1328018936000	19025	9591	0	0	11081
145320	1397	1328008935000	19026	9592	0	0	11082
145321	1397	1327998934000	19026	9592	1	0	11083
145322	1397	1327988933000	19026	9592	2	0	11084
145323	1397	1327978932000	19026	9592	3	0	11085
145325	1397	1327968931000	19027	9593	0	0	11086
145326	2132	148430431000	19027	9593	1	0	569
145327	1397	1327958930000	19028	9594	0	0	11087
145328	1397	1327948929000	19029	9595	0	0	11088
145329	1397	1327938928000	19029	9595	1	0	11089
145331	1397	1327928927000	19030	9596	0	0	11090
145332	1397	1327918926000	19031	9597	0	0	11091
145335	1397	1327908925000	19034	9598	0	0	11092
145336	2132	148428429000	19034	9598	1	0	571
145338	1397	1327888923000	19036	9600	0	0	11094
145339	1397	1327878922000	19037	9601	0	0	11095
145342	1397	1327868921000	19039	9602	0	0	11096
145343	2132	148427428000	19039	9602	1	0	572
145344	1397	1327858920000	19040	9603	0	0	11097
145346	1397	1327838918000	19042	9604	1	0	11099
145347	1397	1327828917000	19042	9604	2	0	11100
145348	1397	1327818916000	19042	9604	3	0	11101
145349	2132	148426427000	19042	9604	4	0	573
145350	1769	1586900000	19042	9604	5	0	47
145358	1397	1327798914000	19044	9605	1	0	11103
145359	1397	1327788913000	19044	9605	2	0	11104
145360	2132	148425426000	19044	9605	3	0	574
145363	1397	1327778912000	19047	9606	0	0	11105
145365	2132	148424425000	19048	9607	1	0	575
145366	1397	1327758910000	19049	9608	0	0	11107
145367	1397	1327748909000	19049	9608	1	0	11108
145368	1397	1327738908000	19049	9608	2	0	11109
145369	1397	1327728907000	19049	9608	3	0	11110
145376	1397	1327718906000	19051	9609	0	0	11111
145380	1397	1327708905000	19053	9610	0	0	11112
145381	1397	1327698904000	19053	9610	1	0	11113
145382	2132	148422423000	19053	9610	2	0	577
145383	1397	1327688903000	19054	9611	0	0	11114
145389	1397	1327638898000	19055	9612	0	0	\N
145390	2132	148420421000	19055	9612	1	0	\N
145391	1397	1327638898000	19056	9612	0	0	\N
145392	2132	148420421000	19056	9612	1	0	\N
145393	1397	1327638898000	19057	9612	0	0	\N
145394	2132	148420421000	19057	9612	1	0	\N
145397	1397	1327638898000	19059	9612	0	0	\N
145398	2132	148420421000	19059	9612	1	0	\N
145399	1397	1327638898000	19060	9612	0	0	\N
145400	2132	148420421000	19060	9612	1	0	\N
145401	1397	1327638898000	19061	9612	0	0	\N
145402	2132	148420421000	19061	9612	1	0	\N
145403	1726	93857112000	19062	9613	0	0	\N
145404	1397	1327628897000	19062	9613	1	0	\N
145405	1726	92647112000	19062	9613	2	0	\N
145406	1726	91437112000	19062	9613	3	0	\N
145407	1726	90227112000	19062	9613	4	0	\N
145408	1726	89017112000	19062	9613	5	0	\N
145409	1726	87807112000	19062	9613	6	0	\N
145410	1726	86597112000	19062	9613	7	0	\N
145411	1726	85387112000	19062	9613	8	0	\N
145412	579	66000095000000	19062	9613	9	0	\N
145428	2207	100000000	19066	9616	0	0	\N
145429	1397	1327598894000	19066	9616	1	0	\N
145432	1397	1327588893000	19068	9617	0	0	\N
145435	1397	1327568891000	19071	9619	0	0	\N
145436	2132	148418419000	19071	9619	1	0	\N
145437	1397	1327568891000	19072	9619	0	0	\N
145438	2132	148418419000	19072	9619	1	0	\N
145441	1397	1327568891000	19074	9619	0	0	\N
145442	2132	148418419000	19074	9619	1	0	\N
145447	1397	1327538888000	19078	9622	0	0	\N
145448	2132	148417418000	19078	9622	1	0	\N
145450	1397	1327518886000	19080	9624	0	0	\N
145457	1397	1327478882000	19084	9627	0	0	\N
145458	1397	1327468881000	19084	9627	1	0	\N
145459	1397	1327458880000	19084	9627	2	0	\N
145460	2203	190000000	19084	9627	3	0	\N
145461	2203	180000000	19084	9627	4	0	\N
145462	2203	170000000	19084	9627	5	0	\N
145463	2132	148415416000	19084	9627	6	0	\N
145464	2200	801999000000	19084	9627	7	0	\N
145473	1397	1327478882000	19086	9627	0	0	\N
145474	1397	1327468881000	19086	9627	1	0	\N
145475	1397	1327458880000	19086	9627	2	0	\N
145476	2203	190000000	19086	9627	3	0	\N
145477	2203	180000000	19086	9627	4	0	\N
145478	2203	170000000	19086	9627	5	0	\N
145479	2132	148415416000	19086	9627	6	0	\N
145480	2200	801999000000	19086	9627	7	0	\N
145481	1397	1327448879000	19087	9628	0	0	\N
145490	2204	100000000	19090	9623	0	0	\N
145491	1726	84177112000	19090	9623	1	0	\N
145492	1726	82967112000	19090	9623	2	0	\N
145493	1397	1327528887000	19090	9623	3	0	\N
145494	1397	1327518886000	19090	9623	4	0	\N
145495	2203	190000000	19090	9623	5	0	\N
145496	2203	180000000	19090	9623	6	0	\N
145497	2203	170000000	19090	9623	7	0	\N
145498	2203	160000000	19090	9623	8	0	\N
145499	1397	1327508885000	19090	9623	9	0	\N
145500	1397	1327498884000	19090	9623	10	0	\N
145501	1397	1327488883000	19090	9623	11	0	\N
145502	1397	1327478882000	19090	9623	12	0	\N
145503	1397	1327468881000	19090	9623	13	0	\N
145504	1397	1327458880000	19090	9623	14	0	\N
145505	1397	1327448879000	19090	9623	15	0	\N
145506	1397	1327438878000	19090	9623	16	0	\N
145507	1397	1327428877000	19090	9623	17	0	\N
145508	1397	1327418876000	19090	9623	18	0	\N
145509	1397	1327408875000	19090	9623	19	0	\N
145510	1397	1327398874000	19090	9623	20	0	\N
145511	2200	801999000000	19090	9623	21	0	\N
145512	2133	97411830000	19090	9623	22	0	\N
145513	2134	96998012000	19090	9623	23	0	\N
145514	2132	148416417000	19090	9623	24	0	\N
145515	2132	148415416000	19090	9623	25	0	\N
145516	2132	148414415000	19090	9623	26	0	\N
145517	2132	148413414000	19090	9623	27	0	\N
145518	2134	96997009000	19090	9623	28	0	\N
145387	1397	1327648899000	19054	9611	4	0	11118
145388	2132	148421422000	19054	9611	5	0	578
145395	1397	1327638898000	19058	9612	0	0	11119
145396	2132	148420421000	19058	9612	1	0	579
145413	1726	93857112000	19063	9613	0	0	8209
145415	1726	92647112000	19063	9613	2	0	8210
145416	1726	91437112000	19063	9613	3	0	8211
145417	1726	90227112000	19063	9613	4	0	8212
145418	1726	89017112000	19063	9613	5	0	8213
145419	1726	87807112000	19063	9613	6	0	8214
145421	1726	85387112000	19063	9613	8	0	8216
145422	579	66000095000000	19063	9613	9	0	1
145423	1397	1327618896000	19064	9614	0	0	11121
145424	1397	1327608895000	19065	9615	0	0	11122
145426	2132	148419420000	19065	9615	2	0	580
145427	2206	199000000	19065	9615	3	0	1
145430	2207	100000000	19067	9616	0	0	1
145431	1397	1327598894000	19067	9616	1	0	11123
145433	1397	1327588893000	19069	9617	0	0	11124
145439	1397	1327568891000	19073	9619	0	0	11126
145440	2132	148418419000	19073	9619	1	0	581
145443	1397	1327558890000	19075	9620	0	0	11127
145444	1397	1327548889000	19076	9621	0	0	11128
145445	1397	1327538888000	19077	9622	0	0	11129
145449	1397	1327528887000	19079	9623	0	0	11130
145451	1397	1327518886000	19081	9624	0	0	11131
145452	1397	1327508885000	19082	9625	0	0	11132
145453	2132	148416417000	19082	9625	1	0	583
145455	1397	1327498884000	19083	9626	1	0	11133
145456	1397	1327488883000	19083	9626	2	0	11134
145465	1397	1327478882000	19085	9627	0	0	11135
145466	1397	1327468881000	19085	9627	1	0	11136
145467	1397	1327458880000	19085	9627	2	0	11137
145469	2203	180000000	19085	9627	4	0	2
145470	2203	170000000	19085	9627	5	0	3
145471	2132	148415416000	19085	9627	6	0	584
145472	2200	801999000000	19085	9627	7	0	1
145482	1397	1327448879000	19088	9628	0	0	11138
145484	1726	82967112000	19089	9629	1	0	8218
145485	1397	1327438878000	19089	9629	2	0	11139
145486	1397	1327428877000	19089	9629	3	0	11140
145487	1397	1327418876000	19089	9629	4	0	11141
145489	2132	148414415000	19089	9629	6	0	585
145519	1397	1327408875000	19091	9630	0	0	11142
145520	1397	1327398874000	19091	9630	1	0	11143
145525	1397	1327388873000	19092	9631	0	0	\N
145526	2134	96996006000	19092	9631	1	0	\N
145527	2133	97410828000	19092	9631	2	0	\N
145531	1397	1327378872000	19094	9632	0	0	\N
145532	2134	96995003000	19094	9632	1	0	\N
145533	2133	97409826000	19094	9632	2	0	\N
145534	1397	1327378872000	19095	9632	0	0	\N
145535	2134	96995003000	19095	9632	1	0	\N
145536	2133	97409826000	19095	9632	2	0	\N
145537	1726	93857112000	19096	9565	0	0	\N
145538	1474	15311354000023	19096	9565	1	0	\N
145539	1726	92647112000	19096	9565	2	0	\N
145540	1726	91437112000	19096	9565	3	0	\N
145541	1726	90227112000	19096	9565	4	0	\N
145542	1726	89017112000	19096	9565	5	0	\N
145543	1726	87807112000	19096	9565	6	0	\N
145544	1726	86597112000	19096	9565	7	0	\N
145545	1726	85387112000	19096	9565	8	0	\N
145546	1726	84177112000	19096	9565	9	0	\N
145547	1726	82967112000	19096	9565	10	0	\N
145548	2172	197999000	19096	9565	11	0	\N
145549	2131	191998000	19096	9565	12	0	\N
145550	2133	97411830000	19096	9565	13	0	\N
145551	1769	1586900000	19096	9565	14	0	\N
145552	2134	96998012000	19096	9565	15	0	\N
145553	2133	97410828000	19096	9565	16	0	\N
145554	2133	97409826000	19096	9565	17	0	\N
145555	1611	22370601840000	19096	9565	18	0	\N
145556	1611	19901996500000	19096	9565	19	0	\N
145557	1611	13023010000000	19096	9565	20	0	\N
145558	2134	96997009000	19096	9565	21	0	\N
145559	2134	96996006000	19096	9565	22	0	\N
145560	2134	96995003000	19096	9565	23	0	\N
145561	1397	1327378872000	19097	9632	0	0	\N
145562	2134	96995003000	19097	9632	1	0	\N
145563	2133	97409826000	19097	9632	2	0	\N
145570	1397	1327358870000	19100	9634	0	0	\N
145571	1397	1327348869000	19100	9634	1	0	\N
145572	2134	96992997000	19100	9634	2	0	\N
145573	2134	96991994000	19100	9634	3	0	\N
145574	2133	97407822000	19100	9634	4	0	\N
145575	2133	97406820000	19100	9634	5	0	\N
145576	1397	1327358870000	19101	9634	0	0	\N
145577	1397	1327348869000	19101	9634	1	0	\N
145578	2134	96992997000	19101	9634	2	0	\N
145579	2134	96991994000	19101	9634	3	0	\N
145580	2133	97407822000	19101	9634	4	0	\N
145581	2133	97406820000	19101	9634	5	0	\N
145588	1397	1327358870000	19103	9634	0	0	\N
145589	1397	1327348869000	19103	9634	1	0	\N
145590	2134	96992997000	19103	9634	2	0	\N
145591	2134	96991994000	19103	9634	3	0	\N
145592	2133	97407822000	19103	9634	4	0	\N
145593	2133	97406820000	19103	9634	5	0	\N
145608	1397	1327298864000	19107	9638	0	0	\N
145609	1397	1327288863000	19107	9638	1	0	\N
145610	2203	130000000	19107	9638	2	0	\N
145611	2134	96986979000	19107	9638	3	0	\N
145612	2134	96985976000	19107	9638	4	0	\N
145613	2133	97401810000	19107	9638	5	0	\N
145628	2134	96981964000	19112	9642	0	0	\N
145636	1397	1327218856000	19117	9645	0	0	\N
145637	2134	96977952000	19117	9645	1	0	\N
145638	1397	1327218856000	19118	9645	0	0	\N
145639	2134	96977952000	19118	9645	1	0	\N
145640	1397	1327218856000	19119	9645	0	0	\N
145641	2134	96977952000	19119	9645	1	0	\N
145644	1726	93856112000	19121	9549	0	0	\N
145645	1474	13213364000023	19121	9549	1	0	\N
145646	1474	11711354000023	19121	9549	2	0	\N
145647	1726	92646112000	19121	9549	3	0	\N
145648	1726	91436112000	19121	9549	4	0	\N
145649	1726	90226112000	19121	9549	5	0	\N
145650	526	68780064000000	19121	9549	6	0	\N
145651	1726	89016112000	19121	9549	7	0	\N
145652	1726	87806112000	19121	9549	8	0	\N
145653	1726	86596112000	19121	9549	9	0	\N
145654	1726	85386112000	19121	9549	10	0	\N
145655	1726	84176112000	19121	9549	11	0	\N
145656	1726	82966112000	19121	9549	12	0	\N
145523	2134	96998012000	19091	9630	4	0	1996
145524	2134	96997009000	19091	9630	5	0	1997
145528	1397	1327388873000	19093	9631	0	0	11144
145529	2134	96996006000	19093	9631	1	0	1998
145530	2133	97410828000	19093	9631	2	0	1586
145565	2134	96995003000	19098	9632	1	0	1999
145566	2133	97409826000	19098	9632	2	0	1587
145567	1397	1327368871000	19099	9633	0	0	11146
145568	2134	96994000000	19099	9633	1	0	2000
145569	2133	97408824000	19099	9633	2	0	1588
145583	1397	1327348869000	19102	9634	1	0	11148
145584	2134	96992997000	19102	9634	2	0	2001
145585	2134	96991994000	19102	9634	3	0	2002
145586	2133	97407822000	19102	9634	4	0	1589
145594	2133	97405818000	19104	9635	0	0	1591
145595	2134	96990991000	19104	9635	1	0	2003
145596	1397	1327338868000	19105	9636	0	0	11149
145597	1397	1327328867000	19105	9636	1	0	11150
145598	2133	97404816000	19105	9636	2	0	1592
145600	2203	150000000	19106	9637	0	0	5
145601	1397	1327318866000	19106	9637	1	0	11151
145602	2203	140000000	19106	9637	2	0	6
145603	1397	1327308865000	19106	9637	3	0	11152
145604	2133	97403814000	19106	9637	4	0	1593
145606	2134	96988985000	19106	9637	6	0	2005
145607	2134	96987982000	19106	9637	7	0	2006
145614	1397	1327298864000	19108	9638	0	0	11153
145615	1397	1327288863000	19108	9638	1	0	11154
145617	2134	96986979000	19108	9638	3	0	2007
145618	2134	96985976000	19108	9638	4	0	2008
145619	2133	97401810000	19108	9638	5	0	1595
145620	1397	1327278862000	19109	9639	0	0	11155
145621	2134	96984973000	19109	9639	1	0	2009
145623	2203	110000000	19110	9640	0	0	8
145624	1397	1327268861000	19110	9640	1	0	11156
145625	2134	96983970000	19110	9640	2	0	2010
145626	1397	1327258860000	19111	9641	0	0	11157
145627	2134	96982967000	19111	9641	1	0	2011
145630	1397	1327248859000	19116	9644	0	0	11158
145631	1397	1327238858000	19116	9644	1	0	11159
145632	1397	1327228857000	19116	9644	2	0	11160
145633	2134	96980961000	19116	9644	3	0	2013
145635	2134	96978955000	19116	9644	5	0	2015
145642	1397	1327218856000	19120	9645	0	0	11161
145643	2134	96977952000	19120	9645	1	0	2016
145657	2172	197999000	19121	9549	13	0	\N
145658	2131	191998000	19121	9549	14	0	\N
145659	2132	148446447000	19121	9549	15	0	\N
145660	2133	97411830000	19121	9549	16	0	\N
145661	1769	1586900000	19121	9549	17	0	\N
145662	2134	96998012000	19121	9549	18	0	\N
145663	2133	97410828000	19121	9549	19	0	\N
145664	2133	97409826000	19121	9549	20	0	\N
145665	2133	97408824000	19121	9549	21	0	\N
145666	2133	97407822000	19121	9549	22	0	\N
145667	2133	97406820000	19121	9549	23	0	\N
145668	2133	97405818000	19121	9549	24	0	\N
145669	2133	97404816000	19121	9549	25	0	\N
145670	2133	97403814000	19121	9549	26	0	\N
145671	2133	97402812000	19121	9549	28	0	\N
145676	1397	1327208855000	19123	9646	0	0	\N
145677	1397	1327198854000	19123	9646	1	0	\N
145678	2134	96976949000	19123	9646	2	0	\N
145679	2134	96975946000	19123	9646	3	0	\N
145682	1397	1327188853000	19125	9647	0	0	\N
145683	2134	96974943000	19125	9647	1	0	\N
145684	1397	1327178852000	19126	9648	0	0	\N
145685	2134	96973940000	19126	9648	1	0	\N
145686	1397	1327178852000	19127	9648	0	0	\N
145687	2134	96973940000	19127	9648	1	0	\N
145688	1397	1327178852000	19128	9648	0	0	\N
145689	2134	96973940000	19128	9648	1	0	\N
145692	1726	93857112000	19130	9591	0	0	\N
145693	1726	92647112000	19130	9591	1	0	\N
145694	1726	91437112000	19130	9591	2	0	\N
145695	1726	90227112000	19130	9591	3	0	\N
145696	1726	89017112000	19130	9591	4	0	\N
145697	1726	87807112000	19130	9591	5	0	\N
145698	1726	86597112000	19130	9591	6	0	\N
145699	1726	85387112000	19130	9591	7	0	\N
145700	1726	84177112000	19130	9591	8	0	\N
145701	1726	82967112000	19130	9591	9	0	\N
145702	2200	801999000000	19130	9591	10	0	\N
145703	1726	81766112000	19130	9591	11	0	\N
145704	2133	97411830000	19130	9591	12	0	\N
145705	1726	80565112000	19130	9591	13	0	\N
145706	1769	1586900000	19130	9591	14	0	\N
145707	2134	96998012000	19130	9591	15	0	\N
145708	2133	97410828000	19130	9591	16	0	\N
145709	2133	97409826000	19130	9591	17	0	\N
145710	2133	97408824000	19130	9591	18	0	\N
145711	2133	97407822000	19130	9591	19	0	\N
145712	2133	97406820000	19130	9591	20	0	\N
145713	2133	97405818000	19130	9591	21	0	\N
145714	2133	97404816000	19130	9591	22	0	\N
145715	2133	97403814000	19130	9591	23	0	\N
145716	2133	97402812000	19130	9591	24	0	\N
145717	2133	97401810000	19130	9591	25	0	\N
145718	2134	96997009000	19130	9591	26	0	\N
145719	2134	96996006000	19130	9591	27	0	\N
145720	2134	96995003000	19130	9591	28	0	\N
145721	2134	96994000000	19130	9591	29	0	\N
145722	2134	96992997000	19130	9591	30	0	\N
145723	2134	96991994000	19130	9591	31	0	\N
145724	2134	96990991000	19130	9591	32	0	\N
145725	2134	96989988000	19130	9591	33	0	\N
145726	2134	96988985000	19130	9591	34	0	\N
145727	2134	96987982000	19130	9591	35	0	\N
145728	2134	96986979000	19130	9591	36	0	\N
145729	2134	96985976000	19130	9591	37	0	\N
145730	2134	96984973000	19130	9591	38	0	\N
145731	2134	96983970000	19130	9591	39	0	\N
145732	2134	96982967000	19130	9591	40	0	\N
145733	2134	96981964000	19130	9591	41	0	\N
145734	2134	96980961000	19130	9591	42	0	\N
145735	2134	96979958000	19130	9591	43	0	\N
145736	2134	96978955000	19130	9591	44	0	\N
145737	2134	96977952000	19130	9591	45	0	\N
145738	2134	96976949000	19130	9591	46	0	\N
145739	2134	96975946000	19130	9591	47	0	\N
145740	2134	96974943000	19130	9591	48	0	\N
145741	2134	96973940000	19130	9591	49	0	\N
145742	2134	96972937000	19130	9591	50	0	\N
145743	2134	96971934000	19130	9591	51	0	\N
145744	2200	801998000000	19130	9591	52	0	\N
145751	1397	1327168851000	19132	9649	0	0	\N
145752	1397	1327158850000	19132	9649	1	0	\N
145753	1726	81766112000	19132	9649	2	0	\N
145754	2134	96972937000	19132	9649	3	0	\N
145755	1726	80565112000	19132	9649	4	0	\N
145756	2134	96971934000	19132	9649	5	0	\N
145779	1397	1327078842000	19137	9654	0	0	\N
145780	2134	96963910000	19137	9654	1	0	\N
145781	2133	97394796000	19137	9654	2	0	\N
145782	2132	148410411000	19137	9654	3	0	\N
145783	1397	1327078842000	19138	9654	0	0	\N
145784	2133	97394796000	19138	9654	1	0	\N
145785	2132	148410411000	19138	9654	2	0	\N
145674	2134	96976949000	19122	9646	2	0	2017
145675	2134	96975946000	19122	9646	3	0	2018
145680	1397	1327188853000	19124	9647	0	0	11164
145681	2134	96974943000	19124	9647	1	0	2019
145690	1397	1327178852000	19129	9648	0	0	11165
145745	1397	1327168851000	19131	9649	0	0	11166
145746	1397	1327158850000	19131	9649	1	0	11167
145747	1726	81766112000	19131	9649	2	0	8219
145748	2134	96972937000	19131	9649	3	0	2021
145749	1726	80565112000	19131	9649	4	0	8220
145757	1397	1327148849000	19133	9650	0	0	11168
145758	1397	1327138848000	19133	9650	1	0	11169
145759	2134	96970931000	19133	9650	2	0	2023
145760	2134	96969928000	19133	9650	3	0	2024
145762	2133	97400808000	19133	9650	5	0	1596
145763	1397	1327128847000	19134	9651	0	0	11170
145764	1397	1327118846000	19134	9651	1	0	11171
145765	1397	1327108845000	19134	9651	2	0	11172
145766	2132	148411412000	19134	9651	3	0	588
145768	2134	96968925000	19134	9651	5	0	2025
145769	2134	96967922000	19134	9651	6	0	2026
145770	2134	96966919000	19134	9651	7	0	2027
145771	2133	97398804000	19134	9651	8	0	1598
145772	2133	97397802000	19134	9651	9	0	1599
145774	2134	96965916000	19135	9652	1	0	2028
145775	2133	97396800000	19135	9652	2	0	1600
145776	1397	1327088843000	19136	9653	0	0	11174
145777	2133	97395798000	19136	9653	1	0	1601
145786	1397	1327078842000	19139	9654	0	0	11175
145787	2134	96963910000	19139	9654	1	0	2030
145788	2133	97394796000	19139	9654	2	0	1602
145789	2132	148410411000	19139	9654	3	0	589
145790	1397	1327068841000	19140	9655	0	0	11176
145792	2133	97393794000	19140	9655	2	0	1603
145793	1397	1327068841000	19141	9655	0	0	\N
145794	2134	96962907000	19141	9655	1	0	\N
145795	2133	97393794000	19141	9655	2	0	\N
145803	1397	1327058840000	19143	9656	0	0	\N
145804	1397	1327048839000	19143	9656	1	0	\N
145805	2132	148409410000	19143	9656	2	0	\N
145806	2133	97392792000	19143	9656	3	0	\N
145807	2133	97391790000	19143	9656	4	0	\N
145808	1397	1327038838000	19144	9657	0	0	\N
145809	2133	97390788000	19144	9657	1	0	\N
145810	2134	96959898000	19144	9657	2	0	\N
145820	1397	1327008835000	19148	9660	0	0	\N
145821	2133	97387782000	19148	9660	1	0	\N
145822	2134	96956889000	19148	9660	2	0	\N
145823	2132	148408409000	19148	9660	3	0	\N
145847	1397	1326948829000	19151	9662	0	0	\N
145848	2134	96950871000	19151	9662	2	0	\N
145849	2133	97381770000	19151	9662	3	0	\N
145850	2132	148406407000	19151	9662	4	0	\N
145855	1397	1326948829000	19153	9662	0	0	\N
145856	2134	96950871000	19153	9662	2	0	\N
145857	2133	97381770000	19153	9662	3	0	\N
145858	2132	148406407000	19153	9662	4	0	\N
145859	1397	1326948829000	19154	9662	0	0	\N
145860	2134	96950871000	19154	9662	2	0	\N
145861	2133	97381770000	19154	9662	3	0	\N
145862	2132	148406407000	19154	9662	4	0	\N
145863	1397	1326948829000	19155	9662	0	0	\N
145864	2134	96950871000	19155	9662	2	0	\N
145865	2133	97381770000	19155	9662	3	0	\N
145866	2132	148406407000	19155	9662	4	0	\N
145874	1397	1326928827000	19158	9664	0	0	\N
145875	2134	96948865000	19158	9664	1	0	\N
145876	2133	97379766000	19158	9664	2	0	\N
145881	1397	1326908825000	19160	9666	0	0	\N
145882	1397	1326898824000	19160	9666	1	0	\N
145883	2133	97377762000	19160	9666	2	0	\N
145884	2132	148405406000	19160	9666	3	0	\N
145885	2133	97376760000	19160	9666	4	0	\N
145886	2148	4880750	19160	9666	5	0	\N
145895	1397	1326888823000	19162	9667	0	0	\N
145896	2134	96944853000	19162	9667	1	0	\N
145897	2133	97375758000	19162	9667	2	0	\N
145898	1397	1326888823000	19163	9667	0	0	\N
145899	2134	96944853000	19163	9667	1	0	\N
145900	2133	97375758000	19163	9667	2	0	\N
145904	1397	1326888823000	19165	9667	0	0	\N
145905	2134	96944853000	19165	9667	1	0	\N
145906	2133	97375758000	19165	9667	2	0	\N
145907	1397	1326878822000	19166	9668	0	0	\N
145908	1397	1326868821000	19166	9668	1	0	\N
145909	2133	97374756000	19166	9668	2	0	\N
145910	2134	96943850000	19166	9668	3	0	\N
145911	2132	148404405000	19166	9668	4	0	\N
145912	2134	96942847000	19166	9668	5	0	\N
145913	2133	97373754000	19166	9668	6	0	\N
145798	2132	148409410000	19142	9656	2	0	590
145799	2133	97392792000	19142	9656	3	0	1604
145800	2133	97391790000	19142	9656	4	0	1605
145801	2134	96961904000	19142	9656	5	0	2032
145802	2134	96960901000	19142	9656	6	0	2033
145812	2133	97390788000	19145	9657	1	0	1606
145813	2134	96959898000	19145	9657	2	0	2034
145814	1397	1327028837000	19146	9658	0	0	11180
145815	2134	96958895000	19146	9658	1	0	2035
145816	2133	97389786000	19146	9658	2	0	1607
145818	2133	97388784000	19147	9659	1	0	1608
145819	2134	96957892000	19147	9659	2	0	2036
145824	1397	1327008835000	19149	9660	0	0	11182
145825	2133	97387782000	19149	9660	1	0	1609
145827	2132	148408409000	19149	9660	3	0	591
145828	1397	1326998834000	19150	9661	0	0	11183
145829	1397	1326988833000	19150	9661	1	0	11184
145830	1397	1326978832000	19150	9661	2	0	11185
145831	1397	1326968831000	19150	9661	3	0	11186
145833	2132	148407408000	19150	9661	5	0	592
145834	1729	14775141880750	19150	9661	6	0	10
145835	1729	10284840880750	19150	9661	7	0	11
145836	1729	1842439880750	19150	9661	8	0	12
145837	2134	96955886000	19150	9661	9	0	2038
145839	2134	96953880000	19150	9661	11	0	2040
145840	2134	96952877000	19150	9661	12	0	2041
145841	2134	96951874000	19150	9661	13	0	2042
145842	2133	97386780000	19150	9661	14	0	1610
145844	2133	97384776000	19150	9661	16	0	1612
145845	2133	97383774000	19150	9661	17	0	1613
145846	2133	97382772000	19150	9661	18	0	1614
145851	1397	1326948829000	19152	9662	0	0	11188
145852	2134	96950871000	19152	9662	2	0	2043
145854	2132	148406407000	19152	9662	4	0	593
145867	1397	1326938828000	19156	9663	0	0	11189
145868	1729	0	19156	9663	1	0	13
145869	2134	96949868000	19156	9663	2	0	2044
145870	2133	97380768000	19156	9663	3	0	1616
145872	2134	96948865000	19157	9664	1	0	2045
145873	2133	97379766000	19157	9664	2	0	1617
145877	1397	1326918826000	19159	9665	0	0	11191
145878	2134	96947862000	19159	9665	1	0	2046
145880	2148	971805880750	19159	9665	3	0	1
145887	1397	1326908825000	19161	9666	0	0	11192
145888	1397	1326898824000	19161	9666	1	0	11193
145889	2134	96946859000	19161	9666	2	0	2047
145890	2133	97377762000	19161	9666	3	0	1619
145892	2132	148405406000	19161	9666	5	0	594
145893	2133	97376760000	19161	9666	6	0	1620
145894	2148	4880750	19161	9666	7	0	2
145901	1397	1326888823000	19164	9667	0	0	11194
145902	2134	96944853000	19164	9667	1	0	2049
145914	1397	1326878822000	19167	9668	0	0	11195
145915	1397	1326868821000	19167	9668	1	0	11196
145916	2133	97374756000	19167	9668	2	0	1622
145917	2134	96943850000	19167	9668	3	0	2050
145919	2134	96942847000	19167	9668	5	0	2051
145920	2133	97373754000	19167	9668	6	0	1623
145921	1397	1326858820000	19168	9669	0	0	11197
145922	1397	1326848819000	19168	9669	1	0	11198
145923	2133	97372752000	19168	9669	2	0	1624
145925	2134	96940841000	19168	9669	4	0	2053
145926	2132	148403404000	19168	9669	5	0	596
145927	2133	97371750000	19168	9669	6	0	1625
145928	1397	1326838818000	19169	9670	0	0	11199
145931	1397	1326828817000	19170	9671	0	0	\N
145932	2134	96938835000	19170	9671	1	0	\N
145933	2133	97369746000	19170	9671	2	0	\N
145958	1397	1326768811000	19175	9675	0	0	\N
145959	2133	97363734000	19175	9675	1	0	\N
145960	2134	96932817000	19175	9675	2	0	\N
145964	1397	1326758810000	19177	9676	0	0	\N
145965	2134	96931814000	19177	9676	1	0	\N
145966	2133	97362732000	19177	9676	2	0	\N
145975	1726	93857112000	19180	9610	0	0	\N
145976	1397	1327708905000	19180	9610	1	0	\N
145977	1397	1327698904000	19180	9610	2	0	\N
145978	1397	1327688903000	19180	9610	3	0	\N
145979	470	74670493000000	19180	9610	4	0	\N
145980	470	71239483000000	19180	9610	5	0	\N
145981	470	68924473000000	19180	9610	6	0	\N
145982	470	67009463000000	19180	9610	7	0	\N
145983	470	66000053000000	19180	9610	8	0	\N
145984	1726	92647112000	19180	9610	9	0	\N
145985	1726	91437112000	19180	9610	10	0	\N
145986	1726	90227112000	19180	9610	11	0	\N
145987	1397	1327678902000	19180	9610	12	0	\N
145988	1397	1327668901000	19180	9610	13	0	\N
145989	1397	1327658900000	19180	9610	14	0	\N
145990	1397	1327648899000	19180	9610	15	0	\N
145991	1397	1327638898000	19180	9610	16	0	\N
145992	1397	1327628897000	19180	9610	17	0	\N
145993	1397	1327618896000	19180	9610	18	0	\N
145994	1397	1327608895000	19180	9610	19	0	\N
145995	1397	1327598894000	19180	9610	20	0	\N
145996	1397	1327588893000	19180	9610	21	0	\N
145997	1397	1327578892000	19180	9610	22	0	\N
145998	1397	1327568891000	19180	9610	23	0	\N
145999	1397	1327558890000	19180	9610	24	0	\N
146000	1397	1327548889000	19180	9610	25	0	\N
146001	1397	1327538888000	19180	9610	26	0	\N
146002	1397	1327528887000	19180	9610	27	0	\N
146003	1397	1327518886000	19180	9610	28	0	\N
146004	1397	1327508885000	19180	9610	29	0	\N
146005	1397	1327498884000	19180	9610	30	0	\N
146006	1397	1327488883000	19180	9610	31	0	\N
146007	1397	1327478882000	19180	9610	32	0	\N
146008	1397	1327468881000	19180	9610	33	0	\N
146009	1397	1327458880000	19180	9610	34	0	\N
146010	1397	1327448879000	19180	9610	35	0	\N
146011	1397	1327438878000	19180	9610	36	0	\N
146012	1397	1327428877000	19180	9610	37	0	\N
146013	1397	1327418876000	19180	9610	38	0	\N
146014	1397	1327408875000	19180	9610	39	0	\N
146015	1397	1327398874000	19180	9610	40	0	\N
146016	1397	1327388873000	19180	9610	41	0	\N
146017	1397	1327378872000	19180	9610	42	0	\N
146018	1397	1327368871000	19180	9610	43	0	\N
146019	1397	1327358870000	19180	9610	44	0	\N
146020	1397	1327348869000	19180	9610	45	0	\N
146021	1397	1327338868000	19180	9610	46	0	\N
146022	1397	1327328867000	19180	9610	48	0	\N
146023	1397	1327318866000	19180	9610	49	0	\N
146024	1397	1327308865000	19180	9610	50	0	\N
146025	1397	1327298864000	19180	9610	51	0	\N
146026	1397	1327288863000	19180	9610	52	0	\N
146027	1397	1327278862000	19180	9610	53	0	\N
146028	1397	1327268861000	19180	9610	54	0	\N
146029	1397	1327258860000	19180	9610	55	0	\N
146030	1397	1327248859000	19180	9610	56	0	\N
146031	1397	1327238858000	19180	9610	57	0	\N
146032	1397	1327228857000	19180	9610	58	0	\N
146033	1397	1327218856000	19180	9610	59	0	\N
146034	1397	1327208855000	19180	9610	60	0	\N
146035	1397	1327198854000	19180	9610	61	0	\N
146036	1397	1327188853000	19180	9610	62	0	\N
146037	1397	1327178852000	19180	9610	63	0	\N
146038	1397	1327168851000	19180	9610	64	0	\N
146039	1397	1327158850000	19180	9610	65	0	\N
146040	1397	1327148849000	19180	9610	66	0	\N
146041	1397	1327138848000	19180	9610	67	0	\N
146042	1397	1327128847000	19180	9610	68	0	\N
146043	1397	1327118846000	19180	9610	69	0	\N
146044	1397	1327108845000	19180	9610	70	0	\N
146045	1397	1327098844000	19180	9610	71	0	\N
146046	1397	1327088843000	19180	9610	72	0	\N
146047	1397	1327078842000	19180	9610	73	0	\N
146048	1397	1327068841000	19180	9610	74	0	\N
146049	1397	1327058840000	19180	9610	75	0	\N
146050	1397	1327048839000	19180	9610	76	0	\N
146051	1397	1327038838000	19180	9610	77	0	\N
146052	1397	1327028837000	19180	9610	78	0	\N
146053	1397	1327018836000	19180	9610	79	0	\N
146054	1397	1327008835000	19180	9610	80	0	\N
146055	1397	1326998834000	19180	9610	81	0	\N
146056	1397	1326988833000	19180	9610	82	0	\N
146057	1397	1326978832000	19180	9610	83	0	\N
146058	1397	1326968831000	19180	9610	84	0	\N
146059	1397	1326958830000	19180	9610	85	0	\N
146060	1726	89017112000	19180	9610	86	0	\N
146061	1726	87807112000	19180	9610	87	0	\N
146062	1726	86597112000	19180	9610	88	0	\N
146063	1726	85387112000	19180	9610	89	0	\N
146064	1726	84177112000	19180	9610	90	0	\N
145934	1397	1326828817000	19171	9671	0	0	11200
145935	2134	96938835000	19171	9671	1	0	2055
145936	2133	97369746000	19171	9671	2	0	1627
145937	1397	1326818816000	19172	9672	0	0	11201
145938	2134	96937832000	19172	9672	1	0	2056
145940	1397	1326808815000	19173	9673	0	0	11202
145941	470	74670493000000	19173	9673	1	0	7
145942	470	71239483000000	19173	9673	2	0	8
145943	470	68924473000000	19173	9673	3	0	9
145944	1397	1326798814000	19173	9673	4	0	11203
145946	470	67009463000000	19173	9673	6	0	10
145947	2134	96936829000	19173	9673	7	0	2057
145948	2133	97367742000	19173	9673	8	0	1629
145949	2132	148402403000	19173	9673	9	0	597
145951	2133	97366740000	19173	9673	11	0	1630
145952	2133	97365738000	19173	9673	12	0	1631
145953	2134	96934823000	19173	9673	13	0	2059
145954	1397	1326778812000	19174	9674	0	0	11205
145955	2133	97364736000	19174	9674	1	0	1632
145957	2132	148401402000	19174	9674	3	0	598
145961	1397	1326768811000	19176	9675	0	0	11206
145962	2133	97363734000	19176	9675	1	0	1633
145963	2134	96932817000	19176	9675	2	0	2061
145967	1397	1326758810000	19178	9676	0	0	11207
145969	2133	97362732000	19178	9676	2	0	1634
145970	1397	1326748809000	19179	9677	0	0	11208
145971	470	66000053000000	19179	9677	1	0	11
145972	2132	148400401000	19179	9677	2	0	599
145974	2133	97361730000	19179	9677	4	0	1635
146065	1726	82967112000	19180	9610	91	0	\N
146066	1397	1326948829000	19180	9610	92	0	\N
146067	1397	1326938828000	19180	9610	93	0	\N
146068	1397	1326928827000	19180	9610	94	0	\N
146069	1397	1326918826000	19180	9610	95	0	\N
146070	1397	1326908825000	19180	9610	96	0	\N
146071	1397	1326898824000	19180	9610	97	0	\N
146072	1397	1326888823000	19180	9610	98	0	\N
146073	1397	1326878822000	19180	9610	99	0	\N
146074	1397	1326868821000	19180	9610	100	0	\N
146075	1397	1326858820000	19180	9610	101	0	\N
146076	1397	1326848819000	19180	9610	102	0	\N
146077	1397	1326838818000	19180	9610	103	0	\N
146078	1397	1326828817000	19180	9610	104	0	\N
146079	1397	1326818816000	19180	9610	105	0	\N
146080	1397	1326808815000	19180	9610	106	0	\N
146081	1397	1326798814000	19180	9610	107	0	\N
146082	1397	1326788813000	19180	9610	108	0	\N
146083	1397	1326778812000	19180	9610	109	0	\N
146084	1397	1326768811000	19180	9610	110	0	\N
146085	1397	1326758810000	19180	9610	111	0	\N
146086	1397	1326748809000	19180	9610	112	0	\N
146087	579	66000095000000	19180	9610	113	0	\N
146088	2200	801999000000	19180	9610	114	0	\N
146089	1726	81766112000	19180	9610	115	0	\N
146090	2133	97411830000	19180	9610	116	0	\N
146091	1729	14775141880750	19180	9610	117	0	\N
146092	1726	80565112000	19180	9610	118	0	\N
146093	1729	10284840880750	19180	9610	119	0	\N
146094	1729	1842439880750	19180	9610	120	0	\N
146095	1729	0	19180	9610	121	0	\N
146096	2134	96998012000	19180	9610	122	0	\N
146097	2133	97410828000	19180	9610	123	0	\N
146098	2132	148422423000	19180	9610	124	0	\N
146099	2133	97409826000	19180	9610	125	0	\N
146100	1397	1326748809000	19181	9677	0	0	\N
146101	470	66000053000000	19181	9677	1	0	\N
146102	2132	148400401000	19181	9677	2	0	\N
146103	2134	96930811000	19181	9677	3	0	\N
146104	2133	97361730000	19181	9677	4	0	\N
146109	1502	1439910000000	19183	9678	0	0	\N
146110	1397	1326738808000	19183	9678	1	0	\N
146111	2134	96929808000	19183	9678	2	0	\N
146112	2133	97360728000	19183	9678	3	0	\N
146113	1397	1326728807000	19184	9679	0	0	\N
146114	2134	96928805000	19184	9679	1	0	\N
146115	2133	97359726000	19184	9679	2	0	\N
146127	1502	1439810000000	19187	9680	0	0	\N
146128	1397	1326718806000	19187	9680	1	0	\N
146129	1397	1326708805000	19187	9680	2	0	\N
146130	2134	96927802000	19187	9680	3	0	\N
146131	2134	96926799000	19187	9680	4	0	\N
146132	2133	97359726000	19187	9680	5	0	\N
146133	2132	148399400000	19187	9680	6	0	\N
146134	2133	97358724000	19187	9680	7	0	\N
146135	2133	97357722000	19187	9680	9	0	\N
146136	1397	1326698804000	19188	9681	0	0	\N
146137	2133	97356720000	19188	9681	1	0	\N
146138	2134	96925796000	19188	9681	2	0	\N
146152	1397	1326678802000	19192	9683	0	0	\N
146153	1397	1326668801000	19192	9683	1	0	\N
146154	2133	97354716000	19192	9683	2	0	\N
146155	2134	96923790000	19192	9683	3	0	\N
146156	2132	148398399000	19192	9683	4	0	\N
146157	2134	96922787000	19192	9683	5	0	\N
146158	2133	97353714000	19192	9683	6	0	\N
146159	1397	1326658800000	19193	9684	0	0	\N
146160	2134	96921784000	19193	9684	1	0	\N
146161	2133	97352712000	19193	9684	2	0	\N
146162	1397	1326658800000	19194	9684	0	0	\N
146163	2134	96921784000	19194	9684	1	0	\N
146164	2133	97352712000	19194	9684	2	0	\N
146178	1397	1326638798000	19198	9686	0	0	\N
146179	1397	1326628797000	19198	9686	1	0	\N
146180	2134	96919778000	19198	9686	2	0	\N
146181	2132	148397398000	19198	9686	3	0	\N
146182	2133	97350708000	19198	9686	4	0	\N
146183	2133	97349706000	19198	9686	5	0	\N
146184	2134	96918775000	19198	9686	6	0	\N
146185	1397	1326638798000	19199	9686	0	0	\N
146186	1397	1326628797000	19199	9686	1	0	\N
146187	2134	96919778000	19199	9686	2	0	\N
146188	2132	148397398000	19199	9686	3	0	\N
146189	2133	97350708000	19199	9686	4	0	\N
146190	2133	97349706000	19199	9686	5	0	\N
146191	2134	96918775000	19199	9686	6	0	\N
146192	1502	1439910000000	19200	9473	0	0	\N
146193	1502	1439810000000	19200	9473	1	0	\N
146194	1726	93856112000	19200	9473	2	0	\N
146195	1474	13213364000023	19200	9473	3	0	\N
146196	1397	1329479082000	19200	9473	4	0	\N
146197	1397	1329469081000	19200	9473	5	0	\N
146198	1474	11711354000023	19200	9473	6	0	\N
146199	470	73950472000000	19200	9473	7	0	\N
146200	470	70519462000000	19200	9473	8	0	\N
146107	2134	96929808000	19182	9678	2	0	2064
146108	2133	97360728000	19182	9678	3	0	1636
146116	1397	1326728807000	19185	9679	0	0	11210
146117	2134	96928805000	19185	9679	1	0	2065
146118	1502	1439810000000	19186	9680	0	0	2
146120	1397	1326708805000	19186	9680	2	0	11212
146121	2134	96927802000	19186	9680	3	0	2066
146122	2134	96926799000	19186	9680	4	0	2067
146123	2133	97359726000	19186	9680	5	0	1637
146124	2132	148399400000	19186	9680	6	0	600
146126	2133	97357722000	19186	9680	9	0	1639
146139	1397	1326698804000	19189	9681	0	0	11213
146140	2133	97356720000	19189	9681	1	0	1640
146141	2134	96925796000	19189	9681	2	0	2068
146143	2133	97355718000	19190	9682	1	0	1641
146144	2134	96924793000	19190	9682	2	0	2069
146145	1397	1326678802000	19191	9683	0	0	11215
146146	1397	1326668801000	19191	9683	1	0	11216
146147	2133	97354716000	19191	9683	2	0	1642
146149	2132	148398399000	19191	9683	4	0	601
146150	2134	96922787000	19191	9683	5	0	2071
146151	2133	97353714000	19191	9683	6	0	1643
146165	1397	1326658800000	19195	9684	0	0	11217
146166	2134	96921784000	19195	9684	1	0	2072
146168	1397	1326648799000	19196	9685	0	0	11218
146169	2134	96920781000	19196	9685	1	0	2073
146170	2133	97351710000	19196	9685	2	0	1645
146171	1397	1326638798000	19197	9686	0	0	11219
146173	2134	96919778000	19197	9686	2	0	2074
146174	2132	148397398000	19197	9686	3	0	602
146175	2133	97350708000	19197	9686	4	0	1646
146176	2133	97349706000	19197	9686	5	0	1647
146177	2134	96918775000	19197	9686	6	0	2075
146201	470	68204452000000	19200	9473	9	0	\N
146202	470	66289442000000	19200	9473	10	0	\N
146203	1397	1329459080000	19200	9473	11	0	\N
146204	1397	1329449079000	19200	9473	12	0	\N
146205	1397	1329439078000	19200	9473	13	0	\N
146206	1726	92646112000	19200	9473	14	0	\N
146207	1726	91436112000	19200	9473	15	0	\N
146208	1726	90226112000	19200	9473	16	0	\N
146209	1397	1329429077000	19200	9473	17	0	\N
146210	1397	1329419076000	19200	9473	18	0	\N
146211	1397	1329409075000	19200	9473	19	0	\N
146212	1397	1329399074000	19200	9473	20	0	\N
146213	1397	1329389073000	19200	9473	21	0	\N
146214	1397	1329379072000	19200	9473	22	0	\N
146215	1397	1329369071000	19200	9473	23	0	\N
146216	1397	1329359070000	19200	9473	24	0	\N
146217	1397	1329349069000	19200	9473	25	0	\N
146218	1397	1329339068000	19200	9473	26	0	\N
146219	1397	1329329067000	19200	9473	27	0	\N
146220	1397	1329319066000	19200	9473	28	0	\N
146221	1397	1329309065000	19200	9473	29	0	\N
146222	1397	1329299064000	19200	9473	30	0	\N
146223	1397	1329289063000	19200	9473	31	0	\N
146224	1397	1329279062000	19200	9473	32	0	\N
146225	1397	1329269061000	19200	9473	33	0	\N
146226	1397	1329259060000	19200	9473	34	0	\N
146227	1397	1329249059000	19200	9473	35	0	\N
146228	1397	1329239058000	19200	9473	36	0	\N
146229	1397	1329229057000	19200	9473	37	0	\N
146230	1397	1329219056000	19200	9473	38	0	\N
146231	1397	1329209055000	19200	9473	39	0	\N
146232	526	68780064000000	19200	9473	40	0	\N
146233	1397	1329199054000	19200	9473	41	0	\N
146234	1397	1329189053000	19200	9473	42	0	\N
146235	1397	1329179052000	19200	9473	43	0	\N
146236	1397	1329169051000	19200	9473	44	0	\N
146237	1397	1329159050000	19200	9473	45	0	\N
146238	1397	1329149049000	19200	9473	46	0	\N
146239	1397	1329139048000	19200	9473	47	0	\N
146240	1397	1329129047000	19200	9473	48	0	\N
146241	1397	1329119046000	19200	9473	49	0	\N
146242	1397	1329109045000	19200	9473	50	0	\N
146243	1397	1329099044000	19200	9473	51	0	\N
146244	1397	1329089043000	19200	9473	52	0	\N
146245	1397	1329079042000	19200	9473	53	0	\N
146246	1397	1329069041000	19200	9473	54	0	\N
146247	1397	1329059040000	19200	9473	55	0	\N
146248	1397	1329049039000	19200	9473	56	0	\N
146249	1397	1329039038000	19200	9473	57	0	\N
146250	1397	1329029037000	19200	9473	59	0	\N
146251	1397	1329019036000	19200	9473	60	0	\N
146252	1397	1329009035000	19200	9473	61	0	\N
146253	1397	1328999034000	19200	9473	62	0	\N
146254	1397	1328989033000	19200	9473	63	0	\N
146255	1397	1328979032000	19200	9473	64	0	\N
146256	1397	1328969031000	19200	9473	65	0	\N
146257	1397	1328959030000	19200	9473	66	0	\N
146258	1397	1328949029000	19200	9473	67	0	\N
146259	1397	1328939028000	19200	9473	68	0	\N
146260	1397	1328929027000	19200	9473	69	0	\N
146261	1397	1328919026000	19200	9473	70	0	\N
146262	1397	1328909025000	19200	9473	71	0	\N
146263	1397	1328899024000	19200	9473	72	0	\N
146264	1397	1328889023000	19200	9473	73	0	\N
146265	1397	1328879022000	19200	9473	74	0	\N
146266	1397	1328869021000	19200	9473	75	0	\N
146267	1397	1328859020000	19200	9473	76	0	\N
146268	1397	1328849019000	19200	9473	77	0	\N
146269	1397	1328839018000	19200	9473	78	0	\N
146270	1397	1328829017000	19200	9473	79	0	\N
146271	1397	1328819016000	19200	9473	80	0	\N
146272	1397	1328809015000	19200	9473	81	0	\N
146273	1397	1328799014000	19200	9473	82	0	\N
146274	1397	1328789013000	19200	9473	83	0	\N
146275	1397	1328779012000	19200	9473	84	0	\N
146276	1397	1328769011000	19200	9473	85	0	\N
146277	1397	1328759010000	19200	9473	86	0	\N
146278	1726	89016112000	19200	9473	87	0	\N
146279	1726	87806112000	19200	9473	88	0	\N
146280	1726	86596112000	19200	9473	89	0	\N
146281	1726	85386112000	19200	9473	90	0	\N
146282	1726	84176112000	19200	9473	91	0	\N
146283	1726	82966112000	19200	9473	92	0	\N
146284	1397	1328749009000	19200	9473	93	0	\N
146285	1397	1328739008000	19200	9473	94	0	\N
146286	1397	1328729007000	19200	9473	95	0	\N
146287	1397	1328719006000	19200	9473	96	0	\N
146288	1397	1328709005000	19200	9473	97	0	\N
146289	1397	1328699004000	19200	9473	98	0	\N
146290	1397	1328689003000	19200	9473	99	0	\N
146291	1397	1328679002000	19200	9473	100	0	\N
146292	1397	1328669001000	19200	9473	101	0	\N
146293	1397	1328659000000	19200	9473	102	0	\N
146294	1397	1328648999000	19200	9473	103	0	\N
146295	1397	1328638998000	19200	9473	104	0	\N
146296	1397	1328628997000	19200	9473	105	0	\N
146297	1397	1328618996000	19200	9473	106	0	\N
146298	1397	1328608995000	19200	9473	107	0	\N
146299	1397	1328598994000	19200	9473	108	0	\N
146300	1397	1328588993000	19200	9473	109	0	\N
146301	1397	1328578992000	19200	9473	110	0	\N
146302	1397	1328568991000	19200	9473	111	0	\N
146303	1397	1328558990000	19200	9473	112	0	\N
146304	1397	1328548989000	19200	9473	113	0	\N
146305	1397	1328538988000	19200	9473	114	0	\N
146306	1397	1328528987000	19200	9473	115	0	\N
146307	1397	1328518986000	19200	9473	116	0	\N
146308	1397	1328508985000	19200	9473	117	0	\N
146309	1397	1328498984000	19200	9473	118	0	\N
146310	1397	1328488983000	19200	9473	119	0	\N
146311	1397	1328478982000	19200	9473	120	0	\N
146312	1397	1328468981000	19200	9473	121	0	\N
146313	1397	1328458980000	19200	9473	122	0	\N
146314	1397	1328448979000	19200	9473	123	0	\N
146315	1397	1328438978000	19200	9473	124	0	\N
146316	1397	1328428977000	19200	9473	125	0	\N
146324	1397	1326618796000	19202	9687	0	0	\N
146325	1397	1326608795000	19202	9687	1	0	\N
146326	2134	96917772000	19202	9687	2	0	\N
146327	2134	96916769000	19202	9687	3	0	\N
146328	2132	148396397000	19202	9687	4	0	\N
146329	1397	1326598794000	19203	9688	0	0	\N
146330	1397	1326588793000	19203	9688	1	0	\N
146331	2133	97346700000	19203	9688	2	0	\N
146332	2133	97345698000	19203	9688	3	0	\N
146333	2134	96915766000	19203	9688	4	0	\N
146334	2134	96914763000	19203	9688	5	0	\N
146319	2133	97348704000	19201	9687	2	0	1648
146320	2133	97347702000	19201	9687	3	0	1649
146321	2134	96917772000	19201	9687	4	0	2076
146322	2134	96916769000	19201	9687	5	0	2077
146323	2132	148396397000	19201	9687	6	0	603
146336	1397	1326588793000	19204	9688	1	0	11224
146361	1397	1326528787000	19207	9690	0	0	\N
146362	2134	96909748000	19207	9690	1	0	\N
146363	1397	1326518786000	19208	9691	0	0	\N
146364	2134	96908745000	19208	9691	1	0	\N
146365	2133	97338684000	19208	9691	2	0	\N
146373	1397	1326508785000	19211	9692	0	0	\N
146374	2134	96907742000	19211	9692	1	0	\N
146375	2133	97337682000	19211	9692	2	0	\N
146376	2132	148393394000	19211	9692	3	0	\N
146377	1397	1326508785000	19212	9692	0	0	\N
146378	2134	96907742000	19212	9692	1	0	\N
146379	2132	148393394000	19212	9692	2	0	\N
146383	1397	1326488783000	19214	9694	0	0	\N
146384	1397	1326478782000	19214	9694	1	0	\N
146385	1397	1326468781000	19214	9694	2	0	\N
146386	1397	1326458780000	19214	9694	3	0	\N
146387	1397	1326448779000	19214	9694	4	0	\N
146388	1397	1326438778000	19214	9694	5	0	\N
146389	2133	97335678000	19214	9694	6	0	\N
146390	2132	148392393000	19214	9694	7	0	\N
146391	2134	96905736000	19214	9694	8	0	\N
146392	2134	96904733000	19214	9694	9	0	\N
146393	2132	148391392000	19214	9694	10	0	\N
146394	2133	97334676000	19214	9694	11	0	\N
146395	2134	96903730000	19214	9694	12	0	\N
146396	2134	96902727000	19214	9694	13	0	\N
146397	2134	96901724000	19214	9694	14	0	\N
146398	2134	96900721000	19214	9694	15	0	\N
146399	2133	97333674000	19214	9694	16	0	\N
146400	2133	97332672000	19214	9694	17	0	\N
146401	2133	97331670000	19214	9694	18	0	\N
146402	2133	97330668000	19214	9694	19	0	\N
146403	1397	1326488783000	19215	9694	0	0	\N
146404	1397	1326478782000	19215	9694	1	0	\N
146405	1397	1326468781000	19215	9694	2	0	\N
146406	1397	1326458780000	19215	9694	3	0	\N
146407	1397	1326448779000	19215	9694	4	0	\N
146408	1397	1326438778000	19215	9694	5	0	\N
146409	2132	148392393000	19215	9694	6	0	\N
146410	2134	96905736000	19215	9694	7	0	\N
146411	2134	96904733000	19215	9694	8	0	\N
146412	2132	148391392000	19215	9694	9	0	\N
146413	2134	96903730000	19215	9694	10	0	\N
146414	2134	96902727000	19215	9694	11	0	\N
146415	2134	96901724000	19215	9694	12	0	\N
146416	2134	96900721000	19215	9694	13	0	\N
146437	1397	1326428777000	19217	9695	0	0	\N
146438	1397	1326418776000	19217	9695	1	0	\N
146439	1397	1326408775000	19217	9695	2	0	\N
146440	2132	148390391000	19217	9695	3	0	\N
146441	2133	97329666000	19217	9695	4	0	\N
146442	2133	97328664000	19217	9695	5	0	\N
146443	2133	97327662000	19217	9695	6	0	\N
146444	2134	96899718000	19217	9695	8	0	\N
146445	2134	96898715000	19217	9695	9	0	\N
146446	2134	96897712000	19217	9695	10	0	\N
146447	1397	1326428777000	19218	9695	0	0	\N
146448	1397	1326418776000	19218	9695	1	0	\N
146449	1397	1326408775000	19218	9695	2	0	\N
146450	2132	148390391000	19218	9695	3	0	\N
146451	2133	97329666000	19218	9695	4	0	\N
146452	2133	97328664000	19218	9695	5	0	\N
146453	2133	97327662000	19218	9695	6	0	\N
146454	2134	96899718000	19218	9695	8	0	\N
146455	2134	96898715000	19218	9695	9	0	\N
146456	2134	96897712000	19218	9695	10	0	\N
146467	1397	1326428777000	19220	9695	0	0	\N
146468	1397	1326418776000	19220	9695	1	0	\N
146469	1397	1326408775000	19220	9695	2	0	\N
146470	2132	148390391000	19220	9695	3	0	\N
146471	2133	97329666000	19220	9695	4	0	\N
146472	2133	97328664000	19220	9695	5	0	\N
146339	2134	96915766000	19204	9688	4	0	2078
146340	2134	96914763000	19204	9688	5	0	2079
146341	1397	1326578792000	19205	9689	0	0	11225
146342	1397	1326568791000	19205	9689	1	0	11226
146343	1397	1326558790000	19205	9689	2	0	11227
146345	1397	1326538788000	19205	9689	4	0	11229
146346	2133	97344696000	19205	9689	5	0	1652
146347	2132	148395396000	19205	9689	6	0	604
146348	2133	97343694000	19205	9689	7	0	1653
146349	2132	148394395000	19205	9689	8	0	605
146351	2134	96913760000	19205	9689	10	0	2080
146352	2134	96912757000	19205	9689	11	0	2081
146353	2134	96911754000	19205	9689	12	0	2082
146354	2134	96910751000	19205	9689	13	0	2083
146356	2133	97341690000	19205	9689	15	0	1655
146357	2133	97340688000	19205	9689	16	0	1656
146358	1397	1326528787000	19206	9690	0	0	11230
146359	2133	97339686000	19206	9690	1	0	1657
146360	2134	96909748000	19206	9690	2	0	2084
146367	2134	96908745000	19209	9691	1	0	2085
146368	2133	97338684000	19209	9691	2	0	1658
146369	1397	1326508785000	19210	9692	0	0	11232
146370	2134	96907742000	19210	9692	1	0	2086
146371	2133	97337682000	19210	9692	2	0	1659
146380	1397	1326498784000	19213	9693	0	0	11233
146381	2134	96906739000	19213	9693	1	0	2087
146382	2133	97336680000	19213	9693	2	0	1660
146417	1397	1326488783000	19216	9694	0	0	11234
146419	1397	1326468781000	19216	9694	2	0	11236
146420	1397	1326458780000	19216	9694	3	0	11237
146421	1397	1326448779000	19216	9694	4	0	11238
146422	1397	1326438778000	19216	9694	5	0	11239
146423	2133	97335678000	19216	9694	6	0	1661
146425	2134	96905736000	19216	9694	8	0	2088
146426	2134	96904733000	19216	9694	9	0	2089
146427	2132	148391392000	19216	9694	10	0	608
146428	2133	97334676000	19216	9694	11	0	1662
146429	2134	96903730000	19216	9694	12	0	2090
146431	2134	96901724000	19216	9694	14	0	2092
146432	2134	96900721000	19216	9694	15	0	2093
146433	2133	97333674000	19216	9694	16	0	1663
146434	2133	97332672000	19216	9694	17	0	1664
146436	2133	97330668000	19216	9694	19	0	1666
146457	1397	1326428777000	19219	9695	0	0	11240
146458	1397	1326418776000	19219	9695	1	0	11241
146459	1397	1326408775000	19219	9695	2	0	11242
146460	2132	148390391000	19219	9695	3	0	609
146462	2133	97328664000	19219	9695	5	0	1668
146463	2133	97327662000	19219	9695	6	0	1669
146464	2134	96899718000	19219	9695	8	0	2094
146465	2134	96898715000	19219	9695	9	0	2095
146466	2134	96897712000	19219	9695	10	0	2096
146473	2133	97327662000	19220	9695	6	0	\N
146474	2134	96899718000	19220	9695	8	0	\N
146475	2134	96898715000	19220	9695	9	0	\N
146476	2134	96897712000	19220	9695	10	0	\N
146477	1397	1326398774000	19221	9696	0	0	\N
146478	1397	1326388773000	19221	9696	1	0	\N
146479	2133	97326660000	19221	9696	2	0	\N
146480	2133	97325658000	19221	9696	3	0	\N
146481	1397	1326398774000	19222	9696	0	0	\N
146482	1397	1326388773000	19222	9696	1	0	\N
146483	2134	96896709000	19222	9696	2	0	\N
146484	2133	97326660000	19222	9696	3	0	\N
146485	2133	97325658000	19222	9696	4	0	\N
146486	2134	96895706000	19222	9696	5	0	\N
146493	1502	1439910000000	19224	9675	0	0	\N
146494	1502	1439810000000	19224	9675	1	0	\N
146495	353	66612718193897	19224	9675	2	0	\N
146496	2163	1198999000000	19224	9675	3	0	\N
146497	353	66612718193897	19225	9697	0	0	\N
146498	1397	1326378772000	19225	9697	1	0	\N
146499	2132	148389390000	19225	9697	2	0	\N
146500	2134	96894703000	19225	9697	3	0	\N
146501	2133	97324656000	19225	9697	4	0	\N
146502	353	66612718193897	19226	9697	0	0	\N
146503	1397	1326378772000	19226	9697	1	0	\N
146504	2132	148389390000	19226	9697	2	0	\N
146505	2134	96894703000	19226	9697	3	0	\N
146506	2133	97324656000	19226	9697	4	0	\N
146507	353	66612718193897	19227	9697	0	0	\N
146508	1397	1326378772000	19227	9697	1	0	\N
146509	2132	148389390000	19227	9697	2	0	\N
146510	2134	96894703000	19227	9697	3	0	\N
146511	2133	97324656000	19227	9697	4	0	\N
146512	353	66612718193897	19228	9697	0	0	\N
146513	1397	1326378772000	19228	9697	1	0	\N
146514	2132	148389390000	19228	9697	2	0	\N
146515	2134	96894703000	19228	9697	3	0	\N
146516	2133	97324656000	19228	9697	4	0	\N
146517	353	66612718193897	19229	9697	0	0	\N
146518	1397	1326378772000	19229	9697	1	0	\N
146519	2132	148389390000	19229	9697	2	0	\N
146520	2134	96894703000	19229	9697	3	0	\N
146521	2133	97324656000	19229	9697	4	0	\N
146522	353	66612718193897	19230	9697	0	0	\N
146523	1397	1326378772000	19230	9697	1	0	\N
146524	2132	148389390000	19230	9697	2	0	\N
146525	2134	96894703000	19230	9697	3	0	\N
146526	2133	97324656000	19230	9697	4	0	\N
146532	2133	97324656000	19232	9697	0	0	\N
146536	1397	1326368771000	19234	9698	0	0	\N
146537	2134	96893700000	19234	9698	1	0	\N
146538	2133	97323654000	19234	9698	2	0	\N
146542	1397	1326358770000	19236	9699	0	0	\N
146543	2134	96892697000	19236	9699	1	0	\N
146544	2133	97322652000	19236	9699	2	0	\N
146545	1397	1326358770000	19237	9699	0	0	\N
146546	2134	96892697000	19237	9699	1	0	\N
146547	2133	97322652000	19237	9699	2	0	\N
146548	2134	96892697000	19238	9699	0	0	\N
146549	2133	97322652000	19238	9699	1	0	\N
146550	1397	1326348769000	19239	9700	0	0	\N
146551	2133	97321650000	19239	9700	1	0	\N
146552	2134	96891694000	19239	9700	2	0	\N
146553	1397	1326348769000	19240	9700	0	0	\N
146554	2133	97321650000	19240	9700	1	0	\N
146555	2134	96891694000	19240	9700	2	0	\N
146556	1397	1326348769000	19241	9700	0	0	\N
146557	2133	97321650000	19241	9700	1	0	\N
146558	2134	96891694000	19241	9700	2	0	\N
146578	1444	19294281159999	19246	9704	0	0	\N
146579	2133	97316640000	19246	9704	1	0	\N
146580	2134	96886679000	19246	9704	2	0	\N
146584	1444	19294281159999	19248	9704	0	0	\N
146585	2133	97316640000	19248	9704	1	0	\N
146586	2134	96886679000	19248	9704	2	0	\N
146597	1397	1326278762000	19251	9706	0	0	\N
146598	2133	97313634000	19251	9706	1	0	\N
146599	2134	96883670000	19251	9706	2	0	\N
146600	1397	1326268761000	19252	9707	0	0	\N
146601	2133	97312632000	19252	9707	1	0	\N
146602	2134	96882667000	19252	9707	2	0	\N
146489	2134	96896709000	19223	9696	2	0	2097
146490	2133	97326660000	19223	9696	3	0	1670
146491	2133	97325658000	19223	9696	4	0	1671
146492	2134	96895706000	19223	9696	5	0	2098
146527	353	66612718193897	19231	9697	0	0	2
146529	2132	148389390000	19231	9697	2	0	610
146530	2134	96894703000	19231	9697	3	0	2099
146531	2133	97324656000	19231	9697	4	0	1672
146533	1397	1326368771000	19233	9698	0	0	11246
146534	2134	96893700000	19233	9698	1	0	2100
146539	1397	1326358770000	19235	9699	0	0	11247
146540	2134	96892697000	19235	9699	1	0	2101
146541	2133	97322652000	19235	9699	2	0	1674
146559	1397	1326348769000	19242	9700	0	0	11248
146561	2134	96891694000	19242	9700	2	0	2102
146562	1397	1326338768000	19243	9701	0	0	11249
146563	1993	1668401389290	19243	9701	1	0	1
146564	2132	148388389000	19243	9701	2	0	611
146565	2134	96890691000	19243	9701	3	0	2103
146567	2213	190000000	19244	9702	0	0	1
146568	1397	1326328767000	19244	9702	1	0	11250
146569	1397	1326318766000	19244	9702	2	0	11251
146570	2134	96889688000	19244	9702	3	0	2104
146571	2134	96888685000	19244	9702	4	0	2105
146573	2133	97318644000	19244	9702	6	0	1678
146574	1397	1326308765000	19245	9703	0	0	11252
146575	2133	97317642000	19245	9703	1	0	1679
146576	2134	96887682000	19245	9703	2	0	2106
146581	1444	19294281159999	19247	9704	0	0	6
146582	2133	97316640000	19247	9704	1	0	1680
146583	2134	96886679000	19247	9704	2	0	2107
146587	1397	1326298764000	19249	9705	0	0	11253
146588	1397	1326288763000	19249	9705	1	0	11254
146590	2134	96885676000	19249	9705	3	0	2108
146591	2134	96884673000	19249	9705	4	0	2109
146592	2132	148386387000	19249	9705	5	0	613
146593	2133	97314636000	19249	9705	6	0	1682
146594	1397	1326278762000	19250	9706	0	0	11255
146596	2134	96883670000	19250	9706	2	0	2110
146603	1397	1326268761000	19253	9707	0	0	11256
146604	2133	97312632000	19253	9707	1	0	1684
146605	2134	96882667000	19253	9707	2	0	2111
146607	1397	1326248759000	19254	9708	1	0	11258
146608	2132	148385386000	19254	9708	2	0	614
146614	1397	1326258760000	19255	9708	0	0	\N
146615	1397	1326248759000	19255	9708	1	0	\N
146616	2132	148385386000	19255	9708	2	0	\N
146617	1592	33000000	19255	9708	3	0	\N
146618	2134	96881664000	19255	9708	4	0	\N
146619	2134	96880661000	19255	9708	5	0	\N
146620	2133	97311630000	19255	9708	6	0	\N
146621	2133	97310628000	19255	9708	7	0	\N
146622	1502	1439910000000	19256	9604	0	0	\N
146623	1502	1439810000000	19256	9604	1	0	\N
146624	353	66612718193897	19256	9604	2	0	\N
146625	1726	93857112000	19256	9604	3	0	\N
146626	1993	1668401389290	19256	9604	4	0	\N
146627	470	74670493000000	19256	9604	5	0	\N
146628	470	71239483000000	19256	9604	6	0	\N
146629	470	68924473000000	19256	9604	7	0	\N
146630	1444	19294281159999	19256	9604	8	0	\N
146631	470	67009463000000	19256	9604	9	0	\N
146632	470	66000053000000	19256	9604	10	0	\N
146633	1726	92647112000	19256	9604	11	0	\N
146634	1726	91437112000	19256	9604	12	0	\N
146635	1726	90227112000	19256	9604	13	0	\N
146636	1726	89017112000	19256	9604	14	0	\N
146637	1726	87807112000	19256	9604	15	0	\N
146638	1726	86597112000	19256	9604	16	0	\N
146639	1726	85387112000	19256	9604	17	0	\N
146640	1726	84177112000	19256	9604	18	0	\N
146641	1726	82967112000	19256	9604	19	0	\N
146642	2200	801999000000	19256	9604	20	0	\N
146643	1726	81766112000	19256	9604	21	0	\N
146644	2133	97411830000	19256	9604	22	0	\N
146645	1729	14775141880750	19256	9604	23	0	\N
146646	1726	80565112000	19256	9604	24	0	\N
146647	1729	10284840880750	19256	9604	25	0	\N
146648	1729	1842439880750	19256	9604	26	0	\N
146649	1729	0	19256	9604	27	0	\N
146650	2134	96998012000	19256	9604	28	0	\N
146651	2133	97410828000	19256	9604	29	0	\N
146652	2133	97409826000	19256	9604	30	0	\N
146653	2133	97408824000	19256	9604	31	0	\N
146654	2133	97407822000	19256	9604	32	0	\N
146655	2133	97406820000	19256	9604	33	0	\N
146656	2133	97405818000	19256	9604	34	0	\N
146657	2133	97404816000	19256	9604	35	0	\N
146658	2133	97403814000	19256	9604	36	0	\N
146659	2133	97402812000	19256	9604	37	0	\N
146660	2133	97401810000	19256	9604	38	0	\N
146661	2133	97400808000	19256	9604	39	0	\N
146662	2133	97399806000	19256	9604	40	0	\N
146663	1592	33000000	19256	9604	41	0	\N
146664	2163	1198999000000	19256	9604	42	0	\N
146665	2133	97398804000	19256	9604	43	0	\N
146666	2133	97397802000	19256	9604	44	0	\N
146667	2134	96997009000	19256	9604	45	0	\N
146668	2134	96996006000	19256	9604	46	0	\N
146669	2134	96995003000	19256	9604	47	0	\N
146670	2134	96994000000	19256	9604	48	0	\N
146671	2134	96992997000	19256	9604	49	0	\N
146672	2134	96991994000	19256	9604	50	0	\N
146673	2134	96990991000	19256	9604	51	0	\N
146674	2134	96989988000	19256	9604	52	0	\N
146675	2134	96988985000	19256	9604	53	0	\N
146676	2134	96987982000	19256	9604	54	0	\N
146677	2134	96986979000	19256	9604	55	0	\N
146678	2134	96985976000	19256	9604	56	0	\N
146679	2134	96984973000	19256	9604	57	0	\N
146680	2133	97396800000	19256	9604	58	0	\N
146681	2133	97395798000	19256	9604	59	0	\N
146682	2133	97394796000	19256	9604	60	0	\N
146683	2133	97393794000	19256	9604	61	0	\N
146684	2133	97392792000	19256	9604	62	0	\N
146685	2133	97391790000	19256	9604	63	0	\N
146686	2133	97390788000	19256	9604	64	0	\N
146687	2133	97389786000	19256	9604	65	0	\N
146688	2133	97388784000	19256	9604	66	0	\N
146689	2133	97387782000	19256	9604	67	0	\N
146690	2134	96983970000	19256	9604	68	0	\N
146691	2134	96982967000	19256	9604	69	0	\N
146692	2134	96981964000	19256	9604	70	0	\N
146693	2134	96980961000	19256	9604	71	0	\N
146694	2134	96979958000	19256	9604	72	0	\N
146695	2134	96978955000	19256	9604	73	0	\N
146696	2134	96977952000	19256	9604	74	0	\N
146697	2134	96976949000	19256	9604	75	0	\N
146698	2134	96975946000	19256	9604	76	0	\N
146699	2134	96974943000	19256	9604	77	0	\N
146700	2134	96973940000	19256	9604	79	0	\N
146701	2134	96972937000	19256	9604	80	0	\N
146702	2134	96971934000	19256	9604	81	0	\N
146703	2134	96970931000	19256	9604	82	0	\N
146704	2134	96969928000	19256	9604	83	0	\N
146705	2134	96968925000	19256	9604	84	0	\N
146706	1397	1326238758000	19257	9709	0	0	\N
146707	1397	1326228757000	19257	9709	1	0	\N
146708	1397	1326218756000	19257	9709	2	0	\N
146709	2133	97309626000	19257	9709	3	0	\N
146710	2133	97308624000	19257	9709	4	0	\N
146711	2133	97307622000	19257	9709	5	0	\N
146712	2132	148384385000	19257	9709	6	0	\N
146713	2134	96879658000	19257	9709	7	0	\N
146714	2134	96878655000	19257	9709	8	0	\N
146715	2134	96877652000	19257	9709	9	0	\N
146716	1397	1326238758000	19258	9709	0	0	\N
146717	1397	1326228757000	19258	9709	1	0	\N
146718	1397	1326218756000	19258	9709	2	0	\N
146719	2133	97309626000	19258	9709	3	0	\N
146720	2133	97308624000	19258	9709	4	0	\N
146721	2133	97307622000	19258	9709	5	0	\N
146722	2132	148384385000	19258	9709	6	0	\N
146723	2134	96879658000	19258	9709	7	0	\N
146724	2134	96878655000	19258	9709	8	0	\N
146725	2134	96877652000	19258	9709	9	0	\N
146726	1397	1326238758000	19259	9709	0	0	\N
146727	1397	1326228757000	19259	9709	1	0	\N
146728	1397	1326218756000	19259	9709	2	0	\N
146729	2133	97309626000	19259	9709	3	0	\N
146730	2133	97308624000	19259	9709	4	0	\N
146731	2133	97307622000	19259	9709	5	0	\N
146732	2132	148384385000	19259	9709	6	0	\N
146733	2134	96879658000	19259	9709	7	0	\N
146734	2134	96878655000	19259	9709	8	0	\N
146735	2134	96877652000	19259	9709	9	0	\N
146736	1397	1326238758000	19260	9709	0	0	\N
146737	1397	1326228757000	19260	9709	1	0	\N
146738	1397	1326218756000	19260	9709	2	0	\N
146739	2133	97309626000	19260	9709	3	0	\N
146740	2133	97308624000	19260	9709	4	0	\N
146741	2133	97307622000	19260	9709	5	0	\N
146742	2132	148384385000	19260	9709	6	0	\N
146743	2134	96879658000	19260	9709	7	0	\N
146744	2134	96878655000	19260	9709	8	0	\N
146611	2134	96880661000	19254	9708	5	0	2113
146612	2133	97311630000	19254	9708	6	0	1685
146613	2133	97310628000	19254	9708	7	0	1686
146745	2134	96877652000	19260	9709	9	0	\N
146769	1397	1326208755000	19266	9710	0	0	\N
146770	1397	1326198754000	19266	9710	1	0	\N
146771	1397	1326188753000	19266	9710	2	0	\N
146772	1397	1326178752000	19266	9710	3	0	\N
146773	1397	1326168751000	19266	9710	4	0	\N
146774	2133	97306620000	19266	9710	5	0	\N
146775	2133	97305618000	19266	9710	6	0	\N
146776	2132	148383384000	19266	9710	7	0	\N
146777	2134	96876649000	19266	9710	8	0	\N
146778	2134	96875646000	19266	9710	9	0	\N
146779	2134	96874643000	19266	9710	10	0	\N
146780	2134	96873640000	19266	9710	11	0	\N
146781	2134	96872637000	19266	9710	12	0	\N
146782	2133	97304616000	19266	9710	13	0	\N
146783	2133	97303614000	19266	9710	14	0	\N
146784	2133	97302612000	19266	9710	15	0	\N
146788	1397	1326168751000	19268	9714	0	0	\N
146789	2134	96872637000	19268	9714	1	0	\N
146790	2133	97302612000	19268	9714	2	0	\N
146791	1397	1326168751000	19269	9714	0	0	\N
146792	2134	96872637000	19269	9714	1	0	\N
146793	2133	97302612000	19269	9714	2	0	\N
146794	1397	1326168751000	19270	9714	0	0	\N
146795	2134	96872637000	19270	9714	1	0	\N
146796	2133	97302612000	19270	9714	2	0	\N
146807	1397	1326138748000	19274	9717	0	0	\N
146808	2133	97299606000	19274	9717	1	0	\N
146809	2134	96869628000	19274	9717	2	0	\N
146810	1397	1326138748000	19275	9717	0	0	\N
146811	2133	97299606000	19275	9717	1	0	\N
146812	2134	96869628000	19275	9717	2	0	\N
146813	1397	1326138748000	19276	9717	0	0	\N
146814	2133	97299606000	19276	9717	1	0	\N
146815	2134	96869628000	19276	9717	2	0	\N
146826	1397	1326118746000	19279	9719	0	0	\N
146827	1397	1326108745000	19279	9719	1	0	\N
146828	2133	97297602000	19279	9719	2	0	\N
146829	2134	96867622000	19279	9719	3	0	\N
146830	2133	97296600000	19279	9719	4	0	\N
146831	2132	148381382000	19279	9719	5	0	\N
146832	1397	1326098744000	19280	9720	0	0	\N
146833	2134	96866619000	19280	9720	1	0	\N
146834	2133	97295598000	19280	9720	2	0	\N
146849	504	66000868193897	19284	9722	0	0	\N
146850	1397	1326078742000	19284	9722	1	0	\N
146851	1397	1326068741000	19284	9722	2	0	\N
146852	2134	96864613000	19284	9722	3	0	\N
146853	2134	96863610000	19284	9722	4	0	\N
146854	2133	97293594000	19284	9722	5	0	\N
146855	2133	97292592000	19284	9722	6	0	\N
146856	1397	1326058740000	19285	9723	0	0	\N
146857	1571	22236649623166	19285	9723	1	0	\N
146858	1571	21598375595030	19285	9723	2	0	\N
146859	1571	20454601925254	19285	9723	3	0	\N
146860	1571	19682871786155	19285	9723	4	0	\N
146861	1571	17532395001031	19285	9723	5	0	\N
146862	2133	97291590000	19285	9723	6	0	\N
146863	2134	96862607000	19285	9723	7	0	\N
146872	1397	1326058740000	19287	9723	0	0	\N
146873	1571	22236649623166	19287	9723	1	0	\N
146874	1571	21598375595030	19287	9723	2	0	\N
146875	1571	20454601925254	19287	9723	3	0	\N
146876	1571	19682871786155	19287	9723	4	0	\N
146877	1571	17532395001031	19287	9723	5	0	\N
146878	2133	97291590000	19287	9723	6	0	\N
146879	2134	96862607000	19287	9723	7	0	\N
146748	1397	1326218756000	19261	9709	2	0	11261
146749	2133	97309626000	19261	9709	3	0	1687
146750	2133	97308624000	19261	9709	4	0	1688
146751	2133	97307622000	19261	9709	5	0	1689
146752	2132	148384385000	19261	9709	6	0	615
146754	2134	96878655000	19261	9709	8	0	2115
146755	2134	96877652000	19261	9709	9	0	2116
146756	1397	1326208755000	19262	9710	0	0	11262
146757	2133	97306620000	19262	9710	1	0	1690
146758	2134	96876649000	19262	9710	2	0	2117
146760	2134	96875646000	19263	9711	1	0	2118
146761	2133	97305618000	19263	9711	2	0	1691
146762	1397	1326188753000	19264	9712	0	0	11264
146763	2134	96874643000	19264	9712	1	0	2119
146765	2133	97304616000	19264	9712	3	0	1692
146766	1397	1326178752000	19265	9713	0	0	11265
146767	2133	97303614000	19265	9713	1	0	1693
146768	2134	96873640000	19265	9713	2	0	2120
146785	1397	1326168751000	19267	9714	0	0	11266
146787	2133	97302612000	19267	9714	2	0	1694
146797	1397	1326158750000	19271	9715	0	0	11267
146798	2134	96871634000	19271	9715	1	0	2122
146799	2133	97301610000	19271	9715	2	0	1695
146800	1397	1326148749000	19272	9716	0	0	11268
146802	2133	97300608000	19272	9716	2	0	1696
146803	2134	96870631000	19272	9716	3	0	2123
146804	1397	1326138748000	19273	9717	0	0	11269
146805	2133	97299606000	19273	9717	1	0	1697
146816	504	66301878193897	19277	9718	0	0	2
146817	1397	1326128747000	19277	9718	1	0	11270
146818	2133	97298604000	19277	9718	2	0	1698
146819	2134	96868625000	19277	9718	3	0	2125
146820	1397	1326118746000	19278	9719	0	0	11271
146822	2133	97297602000	19278	9719	2	0	1699
146823	2134	96867622000	19278	9719	3	0	2126
146824	2133	97296600000	19278	9719	4	0	1700
146825	2132	148381382000	19278	9719	5	0	618
146835	1397	1326098744000	19281	9720	0	0	11273
146837	2133	97295598000	19281	9720	2	0	1701
146838	1397	1326088743000	19282	9721	0	0	11274
146839	2133	97294596000	19282	9721	1	0	1702
146840	2132	148380381000	19282	9721	2	0	619
146842	504	66000868193897	19283	9722	0	0	3
146843	1397	1326078742000	19283	9722	1	0	11275
146844	1397	1326068741000	19283	9722	2	0	11276
146845	2134	96864613000	19283	9722	3	0	2129
146846	2134	96863610000	19283	9722	4	0	2130
146848	2133	97292592000	19283	9722	6	0	1704
146864	1397	1326058740000	19286	9723	0	0	11277
146865	1571	22236649623166	19286	9723	1	0	2
146866	1571	21598375595030	19286	9723	2	0	3
146867	1571	20454601925254	19286	9723	3	0	4
146869	1571	17532395001031	19286	9723	5	0	6
146870	2133	97291590000	19286	9723	6	0	1705
146871	2134	96862607000	19286	9723	7	0	2131
146880	1397	1326048739000	19288	9724	0	0	11278
146905	1397	1326018736000	19291	9726	0	0	\N
146906	1397	1326008735000	19291	9726	1	0	\N
146907	2134	96858595000	19291	9726	2	0	\N
146908	2132	148378379000	19291	9726	3	0	\N
146909	2133	97287582000	19291	9726	4	0	\N
146910	2134	96857592000	19291	9726	5	0	\N
146911	2133	97286580000	19291	9726	6	0	\N
146912	1397	1326018736000	19292	9726	0	0	\N
146913	1397	1326008735000	19292	9726	1	0	\N
146914	2134	96858595000	19292	9726	2	0	\N
146915	2132	148378379000	19292	9726	3	0	\N
146916	2133	97287582000	19292	9726	4	0	\N
146917	2134	96857592000	19292	9726	5	0	\N
146918	2133	97286580000	19292	9726	6	0	\N
146922	1397	1325998734000	19294	9727	0	0	\N
146923	2133	97285578000	19294	9727	1	0	\N
146924	2134	96856589000	19294	9727	2	0	\N
146925	1397	1325998734000	19295	9727	0	0	\N
146926	2133	97285578000	19295	9727	1	0	\N
146927	2134	96856589000	19295	9727	2	0	\N
146935	1397	1325968731000	19297	9729	0	0	\N
146936	2134	96853580000	19297	9729	1	0	\N
146937	2133	97282572000	19297	9729	2	0	\N
146951	1571	18216450031949	19303	9734	0	0	\N
146952	1397	1325928727000	19303	9734	1	0	\N
146953	1397	1325918726000	19303	9734	2	0	\N
146954	1571	17942898305605	19303	9734	3	0	\N
146955	1571	17452703875701	19303	9734	4	0	\N
146956	1571	17121956673230	19303	9734	5	0	\N
146957	1571	16200318051034	19303	9734	6	0	\N
146958	1397	1325908725000	19303	9734	7	0	\N
146959	1397	1325898724000	19303	9734	8	0	\N
146960	532	66010043000000	19303	9734	9	0	\N
146961	2133	97278564000	19303	9734	10	0	\N
146962	2134	96849568000	19303	9734	11	0	\N
146963	2133	97277562000	19303	9734	12	0	\N
146964	2134	96848565000	19303	9734	13	0	\N
146965	2134	96847562000	19303	9734	14	0	\N
146966	2134	96846559000	19303	9734	15	0	\N
146967	2133	97276560000	19303	9734	16	0	\N
146968	2132	148375376000	19303	9734	17	0	\N
146969	1769	1585900000	19303	9734	18	0	\N
146970	2133	97275558000	19303	9734	19	0	\N
146971	1571	18216450031949	19304	9734	0	0	\N
146972	1397	1325928727000	19304	9734	1	0	\N
146973	1397	1325918726000	19304	9734	2	0	\N
146974	1571	17942898305605	19304	9734	3	0	\N
146975	1571	17452703875701	19304	9734	4	0	\N
146976	1571	17121956673230	19304	9734	5	0	\N
146977	1571	16200318051034	19304	9734	6	0	\N
146978	1397	1325908725000	19304	9734	7	0	\N
146979	1397	1325898724000	19304	9734	8	0	\N
146980	532	66010043000000	19304	9734	9	0	\N
146981	2133	97278564000	19304	9734	10	0	\N
146982	2134	96849568000	19304	9734	11	0	\N
146983	2133	97277562000	19304	9734	12	0	\N
146984	2134	96848565000	19304	9734	13	0	\N
146985	2134	96847562000	19304	9734	14	0	\N
146986	2134	96846559000	19304	9734	15	0	\N
146987	2133	97276560000	19304	9734	16	0	\N
146988	2132	148375376000	19304	9734	17	0	\N
146989	1769	1585900000	19304	9734	18	0	\N
146990	2133	97275558000	19304	9734	19	0	\N
147011	1571	18216450031949	19306	9734	0	0	\N
147012	1397	1325928727000	19306	9734	1	0	\N
147013	1397	1325918726000	19306	9734	2	0	\N
147014	1571	17942898305605	19306	9734	3	0	\N
147015	1571	17452703875701	19306	9734	4	0	\N
147016	1571	17121956673230	19306	9734	5	0	\N
146883	2132	148379380000	19288	9724	3	0	620
146884	1397	1326038738000	19289	9725	0	0	11279
146885	1397	1326028737000	19289	9725	1	0	11280
146886	1749	8645381930000	19289	9725	2	0	19
146887	2134	96860601000	19289	9725	3	0	2133
146889	1726	79364112000	19289	9725	5	0	8221
146890	1726	78163112000	19289	9725	6	0	8222
146891	1726	76962112000	19289	9725	7	0	8223
146892	2133	97289586000	19289	9725	8	0	1707
146893	2133	97288584000	19289	9725	9	0	1708
146895	1726	74560112000	19289	9725	11	0	8225
146896	1726	73359112000	19289	9725	12	0	8226
146897	1726	72158112000	19289	9725	13	0	8227
146898	1397	1326018736000	19290	9726	0	0	11281
146900	2134	96858595000	19290	9726	2	0	2135
146901	2132	148378379000	19290	9726	3	0	621
146902	2133	97287582000	19290	9726	4	0	1709
146903	2134	96857592000	19290	9726	5	0	2136
146904	2133	97286580000	19290	9726	6	0	1710
146920	2133	97285578000	19293	9727	1	0	1711
146921	2134	96856589000	19293	9727	2	0	2137
146928	1397	1325988733000	19296	9728	0	0	11284
146929	1397	1325978732000	19296	9728	1	0	11285
146930	2132	148377378000	19296	9728	2	0	622
146932	2133	97283574000	19296	9728	4	0	1713
146933	2134	96855586000	19296	9728	5	0	2138
146934	2134	96854583000	19296	9728	6	0	2139
146938	1397	1325968731000	19298	9729	0	0	11286
146940	2133	97282572000	19298	9729	2	0	1714
146941	1397	1325958730000	19299	9730	0	0	11287
146942	2133	97281570000	19299	9730	1	0	1715
146943	2134	96852577000	19299	9730	2	0	2141
146944	1397	1325948729000	19300	9731	0	0	11288
146946	2133	97280568000	19300	9731	2	0	1716
146947	2134	96851574000	19300	9731	3	0	2142
146948	1397	1325938728000	19301	9732	0	0	11289
146949	2134	96850571000	19301	9732	1	0	2143
146950	2133	97279566000	19301	9732	2	0	1717
146992	1397	1325928727000	19305	9734	1	0	11290
146993	1397	1325918726000	19305	9734	2	0	11291
146994	1571	17942898305605	19305	9734	3	0	8
146995	1571	17452703875701	19305	9734	4	0	9
146997	1571	16200318051034	19305	9734	6	0	11
146998	1397	1325908725000	19305	9734	7	0	11292
146999	1397	1325898724000	19305	9734	8	0	11293
147000	532	66010043000000	19305	9734	9	0	1
147001	2133	97278564000	19305	9734	10	0	1718
147003	2133	97277562000	19305	9734	12	0	1719
147004	2134	96848565000	19305	9734	13	0	2145
147005	2134	96847562000	19305	9734	14	0	2146
147006	2134	96846559000	19305	9734	15	0	2147
147007	2133	97276560000	19305	9734	16	0	1720
147009	1769	1585900000	19305	9734	18	0	48
147010	2133	97275558000	19305	9734	19	0	1721
147017	1571	16200318051034	19306	9734	6	0	\N
147018	1397	1325908725000	19306	9734	7	0	\N
147019	1397	1325898724000	19306	9734	8	0	\N
147020	532	66010043000000	19306	9734	9	0	\N
147021	2133	97278564000	19306	9734	10	0	\N
147022	2134	96849568000	19306	9734	11	0	\N
147023	2133	97277562000	19306	9734	12	0	\N
147024	2134	96848565000	19306	9734	13	0	\N
147025	2134	96847562000	19306	9734	14	0	\N
147026	2134	96846559000	19306	9734	15	0	\N
147027	2133	97276560000	19306	9734	16	0	\N
147028	2132	148375376000	19306	9734	17	0	\N
147029	1769	1585900000	19306	9734	18	0	\N
147030	2133	97275558000	19306	9734	19	0	\N
147038	1397	1325888723000	19308	9735	0	0	\N
147039	1397	1325878722000	19308	9735	1	0	\N
147040	2132	148374375000	19308	9735	2	0	\N
147041	2134	96845556000	19308	9735	3	0	\N
147042	2133	97274556000	19308	9735	4	0	\N
147043	2133	97273554000	19308	9735	5	0	\N
147044	2134	96844553000	19308	9735	6	0	\N
147064	1397	1325848719000	19313	9739	0	0	\N
147065	2134	96840541000	19313	9739	1	0	\N
147066	2133	97269546000	19313	9739	2	0	\N
147067	1397	1325848719000	19314	9739	0	0	\N
147068	2134	96840541000	19314	9739	1	0	\N
147069	2133	97269546000	19314	9739	2	0	\N
147070	1397	1325848719000	19315	9739	0	0	\N
147071	2134	96840541000	19315	9739	1	0	\N
147072	2133	97269546000	19315	9739	2	0	\N
147088	1397	1325818716000	19318	9741	0	0	\N
147089	1571	12084241211346	19318	9741	1	0	\N
147090	1571	11993050635898	19318	9741	2	0	\N
147091	1571	11829645825930	19318	9741	3	0	\N
147092	1571	11719390091773	19318	9741	4	0	\N
147093	1571	11412170551041	19318	9741	5	0	\N
147094	2134	96837532000	19318	9741	6	0	\N
147095	2133	97266540000	19318	9741	7	0	\N
147103	1502	1439910000000	19321	9655	0	0	\N
147104	1502	1439810000000	19321	9655	1	0	\N
147105	504	66301878193897	19321	9655	2	0	\N
147106	353	66612718193897	19321	9655	3	0	\N
147107	504	66000868193897	19321	9655	4	0	\N
147108	1993	1668401389290	19321	9655	5	0	\N
147109	470	74670493000000	19321	9655	6	0	\N
147110	470	71239483000000	19321	9655	7	0	\N
147111	470	68924473000000	19321	9655	8	0	\N
147112	1444	19294281159999	19321	9655	9	0	\N
147113	1571	21516627623166	19321	9655	10	0	\N
147114	1571	20878353595030	19321	9655	11	0	\N
147115	470	67009463000000	19321	9655	12	0	\N
147116	470	66000053000000	19321	9655	13	0	\N
147117	1571	19734579925254	19321	9655	14	0	\N
147118	1571	18962849786155	19321	9655	15	0	\N
147119	1571	16812373001031	19321	9655	16	0	\N
147120	1571	16776416031949	19321	9655	17	0	\N
147121	1571	16502864305605	19321	9655	18	0	\N
147122	1571	16012669875701	19321	9655	19	0	\N
147123	1571	15681922673230	19321	9655	20	0	\N
147124	1571	14760284051034	19321	9655	21	0	\N
147125	1571	14688420012870	19321	9655	22	0	\N
147126	1571	14141326560182	19321	9655	23	0	\N
147127	1571	13160947700374	19321	9655	24	0	\N
147128	1571	12499463295432	19321	9655	25	0	\N
147129	1571	10656196051040	19321	9655	26	0	\N
147130	1571	10644207211346	19321	9655	27	0	\N
147131	1571	10553016635898	19321	9655	28	0	\N
147132	1571	10389611825930	19321	9655	29	0	\N
147133	1571	10279356091773	19321	9655	30	0	\N
147134	1571	9972136551041	19321	9655	31	0	\N
147135	532	66010043000000	19321	9655	32	0	\N
147136	1749	7925369930000	19321	9655	33	0	\N
147137	1726	79364112000	19321	9655	34	0	\N
147138	1726	78163112000	19321	9655	35	0	\N
147139	1726	76962112000	19321	9655	36	0	\N
147140	1592	33000000	19321	9655	37	0	\N
147141	2163	1198999000000	19321	9655	38	0	\N
147142	1726	75761112000	19321	9655	39	0	\N
147143	1726	74560112000	19321	9655	40	0	\N
147144	1726	73359112000	19321	9655	41	0	\N
147145	1726	72158112000	19321	9655	42	0	\N
147146	1726	70957112000	19321	9655	43	0	\N
147147	1726	69756112000	19321	9655	44	0	\N
147148	1769	1585900000	19321	9655	45	0	\N
147149	504	66301878193897	19322	9684	0	0	\N
147150	353	66612718193897	19322	9684	1	0	\N
147151	504	66000868193897	19322	9684	2	0	\N
147152	1993	1668401389290	19322	9684	3	0	\N
147033	2132	148374375000	19307	9735	2	0	625
147034	2134	96845556000	19307	9735	3	0	2148
147035	2133	97274556000	19307	9735	4	0	1722
147036	2133	97273554000	19307	9735	5	0	1723
147037	2134	96844553000	19307	9735	6	0	2149
147046	2133	97272552000	19309	9736	1	0	1724
147047	1397	1325868721000	19310	9737	0	0	11296
147048	2134	96842547000	19310	9737	1	0	2151
147049	2133	97271550000	19310	9737	2	0	1725
147050	1571	16128454012870	19311	9738	0	0	12
147052	1571	14600981700374	19311	9738	2	0	14
147053	1397	1325858720000	19311	9738	3	0	11297
147054	1571	13939497295432	19311	9738	4	0	15
147055	1571	12096230051040	19311	9738	5	0	16
147057	1726	70957112000	19311	9738	7	0	8228
147058	1726	69756112000	19311	9738	8	0	8229
147059	2134	96841544000	19311	9738	9	0	2152
147060	2133	97270548000	19311	9738	10	0	1726
147061	1397	1325848719000	19312	9739	0	0	11298
147063	2133	97269546000	19312	9739	2	0	1727
147073	1397	1325838718000	19316	9740	0	0	11299
147074	1397	1325828717000	19316	9740	1	0	11300
147075	2132	148372373000	19316	9740	2	0	627
147076	2133	97268544000	19316	9740	3	0	1728
147078	2134	96839538000	19316	9740	5	0	2154
147079	2134	96838535000	19316	9740	6	0	2155
147080	1397	1325818716000	19317	9741	0	0	11301
147081	1571	12084241211346	19317	9741	1	0	17
147083	1571	11829645825930	19317	9741	3	0	19
147084	1571	11719390091773	19317	9741	4	0	20
147085	1571	11412170551041	19317	9741	5	0	21
147086	2134	96837532000	19317	9741	6	0	2156
147087	2133	97266540000	19317	9741	7	0	1730
147097	2134	96836529000	19319	9742	1	0	2157
147098	2133	97265538000	19319	9742	2	0	1731
147099	1397	1325798714000	19320	9743	0	0	11303
147100	2134	96835526000	19320	9743	1	0	2158
147101	2133	97264536000	19320	9743	2	0	1732
147153	1444	19294281159999	19322	9684	4	0	\N
147154	1571	21516627623166	19322	9684	5	0	\N
147155	1571	20878353595030	19322	9684	6	0	\N
147156	1571	19734579925254	19322	9684	7	0	\N
147157	1397	1326658800000	19322	9684	8	0	\N
147158	1397	1326648799000	19322	9684	9	0	\N
147159	1397	1326638798000	19322	9684	10	0	\N
147160	1397	1326628797000	19322	9684	11	0	\N
147161	1397	1326618796000	19322	9684	12	0	\N
147162	1397	1326608795000	19322	9684	13	0	\N
147163	1397	1326598794000	19322	9684	14	0	\N
147164	1397	1326588793000	19322	9684	15	0	\N
147165	1397	1326578792000	19322	9684	16	0	\N
147166	1397	1326568791000	19322	9684	17	0	\N
147167	1397	1326558790000	19322	9684	18	0	\N
147168	1397	1326548789000	19322	9684	19	0	\N
147169	1397	1326538788000	19322	9684	20	0	\N
147170	1397	1326528787000	19322	9684	21	0	\N
147171	1397	1326518786000	19322	9684	22	0	\N
147172	1397	1326508785000	19322	9684	23	0	\N
147173	1397	1326498784000	19322	9684	24	0	\N
147174	1397	1326488783000	19322	9684	25	0	\N
147175	1397	1326478782000	19322	9684	26	0	\N
147176	1397	1326468781000	19322	9684	27	0	\N
147177	1397	1326458780000	19322	9684	28	0	\N
147178	1397	1326448779000	19322	9684	29	0	\N
147179	1397	1326438778000	19322	9684	30	0	\N
147180	1397	1326428777000	19322	9684	31	0	\N
147181	1397	1326418776000	19322	9684	32	0	\N
147182	1397	1326408775000	19322	9684	33	0	\N
147183	1397	1326398774000	19322	9684	34	0	\N
147184	1397	1326388773000	19322	9684	35	0	\N
147185	1397	1326378772000	19322	9684	36	0	\N
147186	1397	1326368771000	19322	9684	37	0	\N
147187	1397	1326358770000	19322	9684	38	0	\N
147188	1397	1326348769000	19322	9684	39	0	\N
147189	1397	1326338768000	19322	9684	40	0	\N
147190	1397	1326328767000	19322	9684	41	0	\N
147191	1397	1326318766000	19322	9684	42	0	\N
147192	1397	1326308765000	19322	9684	43	0	\N
147193	1397	1326298764000	19322	9684	44	0	\N
147194	1397	1326288763000	19322	9684	45	0	\N
147195	1397	1326278762000	19322	9684	46	0	\N
147196	1397	1326268761000	19322	9684	47	0	\N
147197	1397	1326258760000	19322	9684	48	0	\N
147198	1397	1326248759000	19322	9684	49	0	\N
147199	1397	1326238758000	19322	9684	50	0	\N
147200	1397	1326228757000	19322	9684	51	0	\N
147201	1397	1326218756000	19322	9684	52	0	\N
147202	1397	1326208755000	19322	9684	53	0	\N
147203	1397	1326198754000	19322	9684	54	0	\N
147204	1397	1326188753000	19322	9684	55	0	\N
147205	1397	1326178752000	19322	9684	56	0	\N
147206	1397	1326168751000	19322	9684	57	0	\N
147207	1397	1326158750000	19322	9684	58	0	\N
147208	1397	1326148749000	19322	9684	59	0	\N
147209	1397	1326138748000	19322	9684	60	0	\N
147210	1397	1326128747000	19322	9684	61	0	\N
147211	1397	1326118746000	19322	9684	62	0	\N
147212	1397	1326108745000	19322	9684	63	0	\N
147213	1397	1326098744000	19322	9684	64	0	\N
147214	1397	1326088743000	19322	9684	65	0	\N
147215	1397	1326078742000	19322	9684	66	0	\N
147216	1397	1326068741000	19322	9684	67	0	\N
147217	1397	1326058740000	19322	9684	68	0	\N
147218	1397	1326048739000	19322	9684	69	0	\N
147219	1397	1326038738000	19322	9684	70	0	\N
147220	1397	1326028737000	19322	9684	71	0	\N
147221	1397	1326018736000	19322	9684	72	0	\N
147222	1397	1326008735000	19322	9684	73	0	\N
147223	1397	1325998734000	19322	9684	74	0	\N
147224	1397	1325988733000	19322	9684	75	0	\N
147225	1397	1325978732000	19322	9684	76	0	\N
147226	1397	1325968731000	19322	9684	77	0	\N
147227	1397	1325958730000	19322	9684	78	0	\N
147228	1397	1325948729000	19322	9684	79	0	\N
147229	1397	1325938728000	19322	9684	80	0	\N
147230	1397	1325928727000	19322	9684	81	0	\N
147231	1397	1325918726000	19322	9684	82	0	\N
147232	1397	1325908725000	19322	9684	83	0	\N
147233	1397	1325898724000	19322	9684	84	0	\N
147234	1397	1325888723000	19322	9684	85	0	\N
147235	1397	1325878722000	19322	9684	86	0	\N
147236	1397	1325868721000	19322	9684	87	0	\N
147237	1397	1325858720000	19322	9684	88	0	\N
147238	1397	1325848719000	19322	9684	89	0	\N
147239	1397	1325838718000	19322	9684	90	0	\N
147240	1397	1325828717000	19322	9684	91	0	\N
147241	1397	1325818716000	19322	9684	92	0	\N
147242	1397	1325808715000	19322	9684	93	0	\N
147243	1397	1325798714000	19322	9684	94	0	\N
147244	1397	1325788713000	19322	9684	95	0	\N
147245	1397	1325778712000	19322	9684	96	0	\N
147246	1397	1325768711000	19322	9684	97	0	\N
147247	1571	18962849786155	19322	9684	98	0	\N
147248	1571	16812373001031	19322	9684	99	0	\N
147249	1571	16776416031949	19322	9684	100	0	\N
147250	1571	16502864305605	19322	9684	101	0	\N
147251	1571	16012669875701	19322	9684	102	0	\N
147252	1571	15681922673230	19322	9684	103	0	\N
147253	1571	14760284051034	19322	9684	104	0	\N
147254	1571	14688420012870	19322	9684	106	0	\N
147255	1571	14141326560182	19322	9684	107	0	\N
147256	1571	13160947700374	19322	9684	108	0	\N
147257	1571	12499463295432	19322	9684	109	0	\N
147258	1571	10656196051040	19322	9684	110	0	\N
147259	1571	10644207211346	19322	9684	111	0	\N
147260	1571	10553016635898	19322	9684	112	0	\N
147261	1571	10389611825930	19322	9684	113	0	\N
147262	1571	10279356091773	19322	9684	114	0	\N
147263	1571	9972136551041	19322	9684	115	0	\N
147264	532	66010043000000	19322	9684	116	0	\N
147265	2134	96921784000	19322	9684	117	0	\N
147266	1749	7925369930000	19322	9684	118	0	\N
147267	2132	148397398000	19322	9684	119	0	\N
147268	2133	97352712000	19322	9684	120	0	\N
147269	2134	96920781000	19322	9684	121	0	\N
147270	2134	96919778000	19322	9684	122	0	\N
147271	1726	79364112000	19322	9684	123	0	\N
147272	1726	78163112000	19322	9684	124	0	\N
147273	1726	76962112000	19322	9684	125	0	\N
147276	1397	1325768711000	19323	9744	2	0	11306
147277	2133	97263534000	19323	9744	3	0	1733
147278	2133	97262532000	19323	9744	4	0	1734
147279	2133	97261530000	19323	9744	5	0	1735
147280	2134	96834523000	19323	9744	6	0	2159
147282	2134	96832517000	19323	9744	8	0	2161
147283	1571	11352180852571	19324	9745	0	0	22
147284	1571	10896267975331	19324	9745	1	0	23
147285	1397	1325758710000	19324	9745	2	0	11307
147286	1571	10079283925491	19324	9745	3	0	24
147288	1571	7991987551046	19324	9745	5	0	26
147292	1571	11352180852571	19325	9745	0	0	\N
147293	1571	10896267975331	19325	9745	1	0	\N
147294	1397	1325758710000	19325	9745	2	0	\N
147295	1571	10079283925491	19325	9745	3	0	\N
147296	1571	9528045254706	19325	9745	4	0	\N
147297	1571	7991987551046	19325	9745	5	0	\N
147298	2133	97260528000	19325	9745	6	0	\N
147299	2134	96831514000	19325	9745	7	0	\N
147300	2132	148370371000	19325	9745	8	0	\N
147301	2216	100000000	19326	9746	0	0	\N
147302	1397	1325748709000	19326	9746	1	0	\N
147303	1397	1325738708000	19326	9746	2	0	\N
147304	1397	1325728707000	19326	9746	3	0	\N
147305	2134	96830511000	19326	9746	4	0	\N
147306	2133	97259526000	19326	9746	5	0	\N
147307	2133	97258524000	19326	9746	6	0	\N
147308	2133	97257522000	19326	9746	7	0	\N
147309	2132	148369370000	19326	9746	8	0	\N
147310	2134	96829508000	19326	9746	9	0	\N
147311	2134	96828505000	19326	9746	10	0	\N
147312	2216	100000000	19327	9746	0	0	\N
147313	1397	1325748709000	19327	9746	1	0	\N
147314	1397	1325738708000	19327	9746	2	0	\N
147315	1397	1325728707000	19327	9746	3	0	\N
147316	2134	96830511000	19327	9746	4	0	\N
147317	2133	97259526000	19327	9746	5	0	\N
147318	2133	97258524000	19327	9746	6	0	\N
147319	2133	97257522000	19327	9746	7	0	\N
147320	2132	148369370000	19327	9746	8	0	\N
147321	2134	96829508000	19327	9746	9	0	\N
147322	2134	96828505000	19327	9746	10	0	\N
147334	2216	100000000	19329	9746	0	0	\N
147335	1397	1325748709000	19329	9746	1	0	\N
147336	1397	1325738708000	19329	9746	2	0	\N
147337	1397	1325728707000	19329	9746	3	0	\N
147338	2134	96830511000	19329	9746	4	0	\N
147339	2133	97259526000	19329	9746	5	0	\N
147340	2133	97258524000	19329	9746	6	0	\N
147341	2133	97257522000	19329	9746	7	0	\N
147342	2132	148369370000	19329	9746	8	0	\N
147343	2134	96829508000	19329	9746	9	0	\N
147344	2134	96828505000	19329	9746	10	0	\N
147355	1397	1325718706000	19331	9747	0	0	\N
147356	1397	1325708705000	19331	9747	1	0	\N
147357	1571	7944048892270	19331	9747	2	0	\N
147358	1571	7579316590478	19331	9747	3	0	\N
147359	1571	6925727350606	19331	9747	5	0	\N
147360	1571	6484734413978	19331	9747	6	0	\N
147361	1571	5255886251050	19331	9747	7	0	\N
147362	2133	97256520000	19331	9747	8	0	\N
147363	2133	97255518000	19331	9747	9	0	\N
147364	2134	96827502000	19331	9747	10	0	\N
147369	1397	1325698704000	19333	9748	0	0	\N
147370	2132	148368369000	19333	9748	1	0	\N
147371	2134	96826499000	19333	9748	2	0	\N
147372	2133	97254516000	19333	9748	3	0	\N
147373	1397	1325698704000	19334	9748	0	0	\N
147374	2132	148368369000	19334	9748	1	0	\N
147375	2134	96826499000	19334	9748	2	0	\N
147376	2133	97254516000	19334	9748	3	0	\N
147396	1397	1325658700000	19337	9750	0	0	\N
147397	2132	148367368000	19337	9750	1	0	\N
147398	2134	96822487000	19337	9750	2	0	\N
147403	1397	1325638698000	19339	9752	0	0	\N
147404	1397	1325628697000	19339	9752	1	0	\N
147405	1769	1582900000	19339	9752	2	0	\N
147406	2132	148366367000	19339	9752	3	0	\N
147407	1769	1581900000	19339	9752	4	0	\N
147408	2133	97248504000	19339	9752	5	0	\N
147409	1769	1580900000	19339	9752	6	0	\N
147410	2134	96820481000	19339	9752	7	0	\N
147411	2134	96819478000	19339	9752	8	0	\N
147412	2133	97247502000	19339	9752	9	0	\N
147413	1397	1325638698000	19340	9752	0	0	\N
147414	1397	1325628697000	19340	9752	1	0	\N
147415	1769	1582900000	19340	9752	2	0	\N
147416	2132	148366367000	19340	9752	3	0	\N
147417	1769	1581900000	19340	9752	4	0	\N
147418	2133	97248504000	19340	9752	5	0	\N
147419	1769	1580900000	19340	9752	6	0	\N
147420	2134	96820481000	19340	9752	7	0	\N
147421	2134	96819478000	19340	9752	8	0	\N
147422	2133	97247502000	19340	9752	9	0	\N
147291	2132	148370371000	19324	9745	8	0	629
147323	2216	100000000	19328	9746	0	0	1
147324	1397	1325748709000	19328	9746	1	0	11308
147325	1397	1325738708000	19328	9746	2	0	11309
147326	1397	1325728707000	19328	9746	3	0	11310
147328	2133	97259526000	19328	9746	5	0	1737
147329	2133	97258524000	19328	9746	6	0	1738
147330	2133	97257522000	19328	9746	7	0	1739
147331	2132	148369370000	19328	9746	8	0	630
147332	2134	96829508000	19328	9746	9	0	2164
147345	1397	1325718706000	19330	9747	0	0	11311
147346	1397	1325708705000	19330	9747	1	0	11312
147347	1571	7944048892270	19330	9747	2	0	27
147348	1571	7579316590478	19330	9747	3	0	28
147350	1571	6484734413978	19330	9747	6	0	30
147351	1571	5255886251050	19330	9747	7	0	31
147352	2133	97256520000	19330	9747	8	0	1740
147353	2133	97255518000	19330	9747	9	0	1741
147354	2134	96827502000	19330	9747	10	0	2166
147366	2132	148368369000	19332	9748	1	0	631
147367	2134	96826499000	19332	9748	2	0	2167
147368	2133	97254516000	19332	9748	3	0	1742
147377	1571	5231835921662	19335	9749	0	0	32
147378	1571	5049464770766	19335	9749	1	0	33
147380	1571	4502163682516	19335	9749	3	0	35
147381	1571	3887734601052	19335	9749	4	0	36
147382	1397	1325688703000	19335	9749	5	0	11314
147383	1397	1325678702000	19335	9749	6	0	11315
147385	2134	96825496000	19335	9749	8	0	2168
147386	2134	96824493000	19335	9749	9	0	2169
147387	2133	97253514000	19335	9749	10	0	1743
147388	2133	97252512000	19335	9749	11	0	1744
147389	2133	97251510000	19335	9749	12	0	1745
147391	1769	1584900000	19335	9749	14	0	49
147392	1397	1325658700000	19336	9750	0	0	11317
147393	2132	148367368000	19336	9750	1	0	632
147394	2133	97250508000	19336	9750	2	0	1746
147395	2134	96822487000	19336	9750	3	0	2171
147400	2134	96821484000	19338	9751	1	0	2172
147401	2133	97249506000	19338	9751	2	0	1747
147402	1769	1583900000	19338	9751	3	0	50
147423	1397	1325638698000	19341	9752	0	0	11319
147433	1397	1325638698000	19342	9752	0	0	\N
147434	1397	1325628697000	19342	9752	1	0	\N
147435	1769	1582900000	19342	9752	2	0	\N
147436	2132	148366367000	19342	9752	3	0	\N
147437	1769	1581900000	19342	9752	4	0	\N
147438	2133	97248504000	19342	9752	5	0	\N
147439	1769	1580900000	19342	9752	6	0	\N
147440	2134	96820481000	19342	9752	7	0	\N
147441	2134	96819478000	19342	9752	8	0	\N
147442	2133	97247502000	19342	9752	9	0	\N
147443	1397	1325638698000	19343	9752	0	0	\N
147444	1397	1325628697000	19343	9752	1	0	\N
147445	1769	1582900000	19343	9752	2	0	\N
147446	2132	148366367000	19343	9752	3	0	\N
147447	1769	1581900000	19343	9752	4	0	\N
147448	2133	97248504000	19343	9752	5	0	\N
147449	1769	1580900000	19343	9752	6	0	\N
147450	2134	96820481000	19343	9752	7	0	\N
147451	2134	96819478000	19343	9752	8	0	\N
147452	2133	97247502000	19343	9752	9	0	\N
147463	1397	1325598694000	19347	9755	0	0	\N
147464	2132	148365366000	19347	9755	1	0	\N
147465	2133	97244496000	19347	9755	2	0	\N
147466	2134	96816469000	19347	9755	3	0	\N
147467	2216	100000000	19349	9656	0	0	\N
147468	1571	9912146852571	19349	9656	1	0	\N
147469	1571	9456233975331	19349	9656	2	0	\N
147470	1571	8639249925491	19349	9656	3	0	\N
147471	1571	8088011254706	19349	9656	4	0	\N
147472	1571	6551953551046	19349	9656	5	0	\N
147473	1571	6504014892270	19349	9656	6	0	\N
147474	1571	6139282590478	19349	9656	7	0	\N
147475	1571	5485693350606	19349	9656	8	0	\N
147476	1571	5044700413978	19349	9656	10	0	\N
147477	1571	3815852251050	19349	9656	11	0	\N
147478	1571	3791801921662	19349	9656	12	0	\N
147479	1571	3609430770766	19349	9656	13	0	\N
147480	1571	3282631150830	19349	9656	14	0	\N
147481	1571	3062129682516	19349	9656	15	0	\N
147482	1571	2447700601052	19349	9656	16	0	\N
147483	1769	1584900000	19349	9656	17	0	\N
147484	1769	1583900000	19349	9656	18	0	\N
147485	1769	1582900000	19349	9656	19	0	\N
147486	1769	1581900000	19349	9656	20	0	\N
147487	1769	1580900000	19349	9656	21	0	\N
147491	1397	1325578692000	19351	9757	0	0	\N
147492	2133	97242492000	19351	9757	1	0	\N
147493	2134	96814463000	19351	9757	2	0	\N
147494	1397	1325578692000	19352	9757	0	0	\N
147495	2133	97242492000	19352	9757	1	0	\N
147496	2134	96814463000	19352	9757	2	0	\N
147525	2216	100000000	19356	9731	0	0	\N
147526	1601	11989435620000	19356	9731	1	0	\N
147527	1601	8829425620000	19356	9731	2	0	\N
147528	1601	6697415620000	19356	9731	3	0	\N
147529	1601	4933405620000	19356	9731	4	0	\N
147530	532	66010043000000	19356	9731	5	0	\N
147531	1726	70957112000	19356	9731	6	0	\N
147532	1726	69756112000	19356	9731	7	0	\N
147533	1726	68555112000	19356	9731	8	0	\N
147534	1769	1585900000	19356	9731	9	0	\N
147535	1769	1584900000	19356	9731	10	0	\N
147536	1397	1325538688000	19357	9759	0	0	\N
147537	1397	1325528687000	19357	9759	1	0	\N
147538	1397	1325518686000	19357	9759	2	0	\N
147539	1601	11989435620000	19357	9759	3	0	\N
147540	1601	8829425620000	19357	9759	4	0	\N
147541	1601	6697415620000	19357	9759	5	0	\N
147542	1601	4933405620000	19357	9759	6	0	\N
147543	2132	148363364000	19357	9759	7	0	\N
147544	1726	68555112000	19357	9759	8	0	\N
147545	2134	96810451000	19357	9759	9	0	\N
147546	2134	96809448000	19357	9759	10	0	\N
147547	2134	96808445000	19357	9759	11	0	\N
147548	2133	97238484000	19357	9759	12	0	\N
147549	2133	97237482000	19357	9759	13	0	\N
147550	2133	97236480000	19357	9759	14	0	\N
147551	1397	1325538688000	19358	9759	0	0	\N
147552	1397	1325528687000	19358	9759	1	0	\N
147553	1397	1325518686000	19358	9759	2	0	\N
147554	1601	11989435620000	19358	9759	3	0	\N
147555	1601	8829425620000	19358	9759	4	0	\N
147556	1601	6697415620000	19358	9759	5	0	\N
147557	1601	4933405620000	19358	9759	6	0	\N
147558	2132	148363364000	19358	9759	7	0	\N
147559	1726	68555112000	19358	9759	8	0	\N
147560	2134	96810451000	19358	9759	9	0	\N
147427	1769	1581900000	19341	9752	4	0	52
147428	2133	97248504000	19341	9752	5	0	1748
147429	1769	1580900000	19341	9752	6	0	53
147430	2134	96820481000	19341	9752	7	0	2173
147431	2134	96819478000	19341	9752	8	0	2174
147453	1397	1325618696000	19344	9753	0	0	11321
147454	2134	96818475000	19344	9753	1	0	2175
147455	2133	97246500000	19344	9753	2	0	1750
147456	1397	1325608695000	19345	9754	0	0	11322
147457	2134	96817472000	19345	9754	1	0	2176
147459	1397	1325598694000	19346	9755	0	0	11323
147460	2132	148365366000	19346	9755	1	0	634
147461	2133	97244496000	19346	9755	2	0	1752
147462	2134	96816469000	19346	9755	3	0	2177
147489	2134	96815466000	19350	9756	1	0	2178
147490	2133	97243494000	19350	9756	2	0	1753
147497	2133	97242492000	19353	9757	0	0	1754
147498	1397	1325578692000	19354	9758	0	0	11325
147499	1397	1325568691000	19354	9758	1	0	11326
147501	1397	1325548689000	19354	9758	3	0	11328
147502	2133	97241490000	19354	9758	4	0	1755
147503	2133	97240488000	19354	9758	5	0	1756
147504	2133	97239486000	19354	9758	6	0	1757
147505	2134	96814463000	19354	9758	7	0	2179
147507	2134	96812457000	19354	9758	9	0	2181
147508	2134	96811454000	19354	9758	10	0	2182
147509	2132	148364365000	19354	9758	11	0	635
147510	1397	1325538688000	19355	9759	0	0	11329
147512	1397	1325518686000	19355	9759	2	0	11331
147513	1601	11989435620000	19355	9759	3	0	14
147514	1601	8829425620000	19355	9759	4	0	15
147515	1601	6697415620000	19355	9759	5	0	16
147516	1601	4933405620000	19355	9759	6	0	17
147518	1726	68555112000	19355	9759	8	0	8230
147519	2134	96810451000	19355	9759	9	0	2183
147520	2134	96809448000	19355	9759	10	0	2184
147521	2134	96808445000	19355	9759	11	0	2185
147522	2133	97238484000	19355	9759	12	0	1758
147524	2133	97236480000	19355	9759	14	0	1760
147561	2134	96809448000	19358	9759	10	0	\N
147562	2134	96808445000	19358	9759	11	0	\N
147563	2133	97238484000	19358	9759	12	0	\N
147564	2133	97237482000	19358	9759	13	0	\N
147565	2133	97236480000	19358	9759	14	0	\N
147566	1397	1325538688000	19359	9759	0	0	\N
147567	1397	1325528687000	19359	9759	1	0	\N
147568	1397	1325518686000	19359	9759	2	0	\N
147569	1601	11989435620000	19359	9759	3	0	\N
147570	1601	8829425620000	19359	9759	4	0	\N
147571	1601	6697415620000	19359	9759	5	0	\N
147572	1601	4933405620000	19359	9759	6	0	\N
147573	2132	148363364000	19359	9759	7	0	\N
147574	1726	68555112000	19359	9759	8	0	\N
147575	2134	96810451000	19359	9759	9	0	\N
147576	2134	96809448000	19359	9759	10	0	\N
147577	2134	96808445000	19359	9759	11	0	\N
147578	2133	97238484000	19359	9759	12	0	\N
147579	2133	97237482000	19359	9759	13	0	\N
147580	2133	97236480000	19359	9759	14	0	\N
147584	1397	1325498684000	19361	9761	0	0	\N
147585	2132	148362363000	19361	9761	1	0	\N
147586	2134	96806439000	19361	9761	2	0	\N
147587	2133	97234476000	19361	9761	3	0	\N
147597	1397	1325468681000	19364	9763	0	0	\N
147598	2133	97232472000	19364	9763	1	0	\N
147599	2134	96803430000	19364	9763	2	0	\N
147600	1397	1325468681000	19365	9763	0	0	\N
147601	2133	97232472000	19365	9763	1	0	\N
147602	2134	96803430000	19365	9763	2	0	\N
147613	1397	1325458680000	19368	9764	0	0	\N
147614	1397	1325448679000	19368	9764	1	0	\N
147615	2134	96802427000	19368	9764	2	0	\N
147616	2134	96801424000	19368	9764	3	0	\N
147617	2133	97231470000	19368	9764	4	0	\N
147618	2133	97230468000	19368	9764	5	0	\N
147619	2132	148361362000	19368	9764	6	0	\N
147628	1397	1325428677000	19371	9766	0	0	\N
147629	2132	148360361000	19371	9766	1	0	\N
147630	2134	96799418000	19371	9766	2	0	\N
147631	2222	199000000	19371	9766	3	0	\N
147632	2133	97228464000	19371	9766	4	0	\N
147636	1397	1325418676000	19373	9767	0	0	\N
147637	2134	96798415000	19373	9767	1	0	\N
147638	2133	97227462000	19373	9767	2	0	\N
147639	1397	1325408675000	19374	9768	0	0	\N
147640	2133	97226460000	19374	9768	1	0	\N
147641	2134	96797412000	19374	9768	2	0	\N
147642	1397	1325408675000	19375	9768	0	0	\N
147643	2133	97226460000	19375	9768	1	0	\N
147644	2134	96797412000	19375	9768	2	0	\N
147645	1397	1325408675000	19376	9768	0	0	\N
147646	2133	97226460000	19376	9768	1	0	\N
147647	2134	96797412000	19376	9768	2	0	\N
147648	1397	1325408675000	19377	9768	0	0	\N
147649	2133	97226460000	19377	9768	1	0	\N
147650	2134	96797412000	19377	9768	2	0	\N
147654	1601	11989435620000	19379	9657	0	0	\N
147655	1601	8829425620000	19379	9657	1	0	\N
147656	1601	6697415620000	19379	9657	2	0	\N
147657	1601	4933405620000	19379	9657	3	0	\N
147658	1726	68555112000	19379	9657	4	0	\N
147659	1397	1325408675000	19380	9768	0	0	\N
147660	2133	97226460000	19380	9768	1	0	\N
147663	1397	1325398674000	19382	9769	0	0	\N
147664	2133	97225458000	19382	9769	1	0	\N
147665	1397	1325388673000	19383	9770	0	0	\N
147666	2132	148359360000	19383	9770	1	0	\N
147667	2134	96796409000	19383	9770	2	0	\N
147668	2133	97224456000	19383	9770	3	0	\N
147673	1397	1325388673000	19385	9770	0	0	\N
147674	2132	148359360000	19385	9770	1	0	\N
147675	2134	96796409000	19385	9770	2	0	\N
147676	2133	97224456000	19385	9770	3	0	\N
147694	1397	1325328667000	19388	9773	0	0	\N
147695	417	66000000000000	19388	9773	1	0	\N
147696	2134	96790391000	19388	9773	2	0	\N
147583	2134	96807442000	19360	9760	2	0	2186
147588	1397	1325498684000	19362	9761	0	0	11333
147589	2132	148362363000	19362	9761	1	0	637
147590	2134	96806439000	19362	9761	2	0	2187
147591	2133	97234476000	19362	9761	3	0	1762
147593	1397	1325478682000	19363	9762	1	0	11335
147594	2133	97233474000	19363	9762	2	0	1763
147595	2134	96805436000	19363	9762	3	0	2188
147596	2134	96804433000	19363	9762	4	0	2189
147603	1397	1325468681000	19366	9763	0	0	11336
147605	2134	96803430000	19366	9763	2	0	2190
147606	1397	1325458680000	19367	9764	0	0	11337
147607	1397	1325448679000	19367	9764	1	0	11338
147608	2134	96802427000	19367	9764	2	0	2191
147610	2133	97231470000	19367	9764	4	0	1765
147611	2133	97230468000	19367	9764	5	0	1766
147612	2132	148361362000	19367	9764	6	0	638
147620	1397	1325438678000	19369	9765	0	0	11339
147621	2133	97229466000	19369	9765	1	0	1767
147623	1397	1325428677000	19370	9766	0	0	11340
147624	2132	148360361000	19370	9766	1	0	639
147625	2134	96799418000	19370	9766	2	0	2194
147626	2222	199000000	19370	9766	3	0	1
147627	2133	97228464000	19370	9766	4	0	1768
147634	2134	96798415000	19372	9767	1	0	2195
147635	2133	97227462000	19372	9767	2	0	1769
147651	1397	1325408675000	19378	9768	0	0	11342
147652	2133	97226460000	19378	9768	1	0	1770
147661	1397	1325398674000	19381	9769	0	0	11343
147662	2133	97225458000	19381	9769	1	0	1771
147669	1397	1325388673000	19384	9770	0	0	11344
147670	2132	148359360000	19384	9770	1	0	640
147671	2134	96796409000	19384	9770	2	0	2197
147677	1397	1325378672000	19386	9771	0	0	11345
147678	2133	97223454000	19386	9771	1	0	1773
147679	2134	96795406000	19386	9771	2	0	2198
147680	1397	1325368671000	19387	9772	0	0	11346
147681	1397	1325358670000	19387	9772	1	0	11347
147683	1397	1325338668000	19387	9772	3	0	11349
147684	1726	67354112000	19387	9772	4	0	8231
147685	2134	96794403000	19387	9772	5	0	2199
147686	2134	96793400000	19387	9772	6	0	2200
147688	2133	97222452000	19387	9772	8	0	1774
147689	2133	97221450000	19387	9772	9	0	1775
147690	2133	97220448000	19387	9772	10	0	1776
147691	2133	97219446000	19387	9772	11	0	1777
147692	2134	96791394000	19387	9772	12	0	2202
147697	2133	97218444000	19388	9773	3	0	\N
147698	2132	148357358000	19388	9773	4	0	\N
147699	1397	1325328667000	19389	9773	0	0	\N
147700	417	66000000000000	19389	9773	1	0	\N
147701	2134	96790391000	19389	9773	2	0	\N
147702	2133	97218444000	19389	9773	3	0	\N
147703	2132	148357358000	19389	9773	4	0	\N
147704	1397	1325328667000	19390	9773	0	0	\N
147705	417	66000000000000	19390	9773	1	0	\N
147706	2134	96790391000	19390	9773	2	0	\N
147707	2133	97218444000	19390	9773	3	0	\N
147708	2132	148357358000	19390	9773	4	0	\N
147716	2133	97217442000	19393	9774	0	0	\N
147717	2134	96789388000	19393	9774	1	0	\N
147726	1397	1325308665000	19397	9776	0	0	\N
147727	2134	96787382000	19397	9776	1	0	\N
147728	1504	657246000000	19397	9776	2	0	\N
147729	2133	97215438000	19397	9776	3	0	\N
147730	1397	1325308665000	19398	9776	0	0	\N
147731	2134	96787382000	19398	9776	1	0	\N
147732	1504	657246000000	19398	9776	2	0	\N
147733	2133	97215438000	19398	9776	3	0	\N
147734	1397	1325308665000	19399	9776	0	0	\N
147735	2134	96787382000	19399	9776	1	0	\N
147736	1504	657246000000	19399	9776	2	0	\N
147737	2133	97215438000	19399	9776	3	0	\N
147742	1726	67354112000	19401	9658	0	0	\N
147743	1397	1325288663000	19402	9778	0	0	\N
147744	1504	157245000000	19402	9778	1	0	\N
147745	2133	97213434000	19402	9778	2	0	\N
147746	2134	96785376000	19402	9778	3	0	\N
147749	1397	1325288663000	19404	9778	0	0	\N
147750	1504	157245000000	19404	9778	1	0	\N
147751	2133	97213434000	19404	9778	2	0	\N
147752	2134	96785376000	19404	9778	3	0	\N
147758	1397	1325278662000	19406	9779	0	0	\N
147759	2134	96784373000	19406	9779	1	0	\N
147760	2133	97212432000	19406	9779	2	0	\N
147765	1502	1439910000000	19408	9627	0	0	\N
147766	1502	1439810000000	19408	9627	1	0	\N
147767	504	66301878193897	19408	9627	2	0	\N
147768	1726	84177112000	19408	9627	3	0	\N
147769	1397	1327478882000	19408	9627	4	0	\N
147770	353	66612718193897	19408	9627	5	0	\N
147771	1726	82967112000	19408	9627	6	0	\N
147772	1397	1327468881000	19408	9627	7	0	\N
147773	504	66000868193897	19408	9627	8	0	\N
147774	1993	1668401389290	19408	9627	9	0	\N
147775	1397	1327458880000	19408	9627	10	0	\N
147776	1397	1327448879000	19408	9627	11	0	\N
147777	1397	1327438878000	19408	9627	12	0	\N
147778	1397	1327428877000	19408	9627	13	0	\N
147779	1397	1327418876000	19408	9627	14	0	\N
147780	470	74670493000000	19408	9627	15	0	\N
147781	470	71239483000000	19408	9627	16	0	\N
147782	470	68924473000000	19408	9627	17	0	\N
147783	1444	19294281159999	19408	9627	18	0	\N
147784	1571	21516627623166	19408	9627	19	0	\N
147785	1571	20878353595030	19408	9627	20	0	\N
147786	1397	1327408875000	19408	9627	21	0	\N
147787	1397	1327398874000	19408	9627	22	0	\N
147788	1397	1327388873000	19408	9627	23	0	\N
147789	1397	1327378872000	19408	9627	24	0	\N
147790	1397	1327368871000	19408	9627	25	0	\N
147791	1397	1327358870000	19408	9627	26	0	\N
147792	1397	1327348869000	19408	9627	27	0	\N
147793	1397	1327338868000	19408	9627	28	0	\N
147794	1397	1327328867000	19408	9627	29	0	\N
147795	1397	1327318866000	19408	9627	30	0	\N
147796	470	67009463000000	19408	9627	31	0	\N
147797	470	66000053000000	19408	9627	32	0	\N
147798	1571	19734579925254	19408	9627	33	0	\N
147799	2203	190000000	19408	9627	34	0	\N
147800	1601	11989435620000	19408	9627	35	0	\N
147801	1601	8829425620000	19408	9627	36	0	\N
147802	1601	6697415620000	19408	9627	37	0	\N
147803	1601	4933405620000	19408	9627	38	0	\N
147804	1397	1327308865000	19408	9627	39	0	\N
147805	1397	1327298864000	19408	9627	40	0	\N
147806	1397	1327288863000	19408	9627	41	0	\N
147807	1397	1327278862000	19408	9627	42	0	\N
147808	1397	1327268861000	19408	9627	43	0	\N
147809	1397	1327258860000	19408	9627	44	0	\N
147810	1397	1327248859000	19408	9627	45	0	\N
147811	1397	1327238858000	19408	9627	46	0	\N
147812	1397	1327228857000	19408	9627	47	0	\N
147813	1397	1327218856000	19408	9627	48	0	\N
147814	1397	1327208855000	19408	9627	49	0	\N
147815	1397	1327198854000	19408	9627	50	0	\N
147816	1397	1327188853000	19408	9627	51	0	\N
147817	1397	1327178852000	19408	9627	52	0	\N
147818	1397	1327168851000	19408	9627	53	0	\N
147819	1397	1327158850000	19408	9627	54	0	\N
147820	1397	1327148849000	19408	9627	55	0	\N
147821	1397	1327138848000	19408	9627	56	0	\N
147822	1397	1327128847000	19408	9627	57	0	\N
147823	1397	1327118846000	19408	9627	58	0	\N
147824	1397	1327108845000	19408	9627	59	0	\N
147825	1397	1327098844000	19408	9627	60	0	\N
147826	1397	1327088843000	19408	9627	61	0	\N
147827	1397	1327078842000	19408	9627	62	0	\N
147828	2203	180000000	19408	9627	63	0	\N
147829	2203	170000000	19408	9627	64	0	\N
147830	2203	160000000	19408	9627	65	0	\N
147831	2203	150000000	19408	9627	66	0	\N
147832	2203	140000000	19408	9627	67	0	\N
147711	2134	96790391000	19391	9773	2	0	2203
147712	2133	97218444000	19391	9773	3	0	1778
147713	2132	148357358000	19391	9773	4	0	642
147714	2133	97217442000	19392	9774	0	0	1779
147715	2134	96789388000	19392	9774	1	0	2204
147719	1397	1325318666000	19395	9775	1	0	11351
147720	2133	97216440000	19395	9775	2	0	1780
147721	2134	96788385000	19395	9775	3	0	2205
147722	1397	1325308665000	19396	9776	0	0	11352
147723	2134	96787382000	19396	9776	1	0	2206
147725	2133	97215438000	19396	9776	3	0	1781
147738	1397	1325298664000	19400	9777	0	0	11353
147739	2133	97214436000	19400	9777	1	0	1782
147740	2134	96786379000	19400	9777	2	0	2207
147747	1397	1325288663000	19403	9778	0	0	11354
147748	1504	157245000000	19403	9778	1	0	11
147753	1397	1325278662000	19405	9779	0	0	11355
147754	2133	97213434000	19405	9779	1	0	1783
147755	2133	97212432000	19405	9779	2	0	1784
147757	2134	96784373000	19405	9779	4	0	2209
147761	1397	1325268661000	19407	9780	0	0	11356
147762	2133	97211430000	19407	9780	1	0	1785
147763	2132	148355356000	19407	9780	2	0	644
147764	2134	96783370000	19407	9780	3	0	2210
147833	1397	1327068841000	19408	9627	68	0	\N
147834	1397	1327058840000	19408	9627	69	0	\N
147835	1397	1327048839000	19408	9627	70	0	\N
147836	1397	1327038838000	19408	9627	71	0	\N
147837	1397	1327028837000	19408	9627	72	0	\N
147838	1397	1327018836000	19408	9627	73	0	\N
147839	1397	1327008835000	19408	9627	74	0	\N
147840	1397	1326998834000	19408	9627	75	0	\N
147841	1397	1326988833000	19408	9627	76	0	\N
147842	1397	1326978832000	19408	9627	77	0	\N
147843	1397	1326968831000	19408	9627	78	0	\N
147844	1397	1326958830000	19408	9627	79	0	\N
147845	2203	130000000	19408	9627	80	0	\N
147846	2203	110000000	19408	9627	81	0	\N
147847	1397	1326948829000	19408	9627	82	0	\N
147848	1397	1326938828000	19408	9627	83	0	\N
147849	1397	1326928827000	19408	9627	84	0	\N
147850	1397	1326918826000	19408	9627	85	0	\N
147851	1397	1326908825000	19408	9627	86	0	\N
147852	1397	1326898824000	19408	9627	87	0	\N
147853	1397	1326888823000	19408	9627	88	0	\N
147854	1397	1326878822000	19408	9627	89	0	\N
147855	1397	1326868821000	19408	9627	90	0	\N
147856	1397	1326858820000	19408	9627	91	0	\N
147857	1397	1326848819000	19408	9627	92	0	\N
147858	1397	1326838818000	19408	9627	93	0	\N
147859	1397	1326828817000	19408	9627	94	0	\N
147860	1397	1326818816000	19408	9627	95	0	\N
147861	1397	1326808815000	19408	9627	96	0	\N
147862	1397	1326798814000	19408	9627	97	0	\N
147863	1397	1326788813000	19408	9627	99	0	\N
147864	1397	1326778812000	19408	9627	100	0	\N
147865	1397	1326768811000	19408	9627	101	0	\N
147866	1397	1326758810000	19408	9627	102	0	\N
147867	1397	1326748809000	19408	9627	103	0	\N
147868	1397	1326738808000	19408	9627	104	0	\N
147869	1397	1326728807000	19408	9627	105	0	\N
147870	1397	1326718806000	19408	9627	106	0	\N
147871	1397	1326708805000	19408	9627	107	0	\N
147872	1397	1326698804000	19408	9627	108	0	\N
147873	1397	1326688803000	19408	9627	109	0	\N
147874	1397	1326678802000	19408	9627	110	0	\N
147875	1397	1326668801000	19408	9627	111	0	\N
147876	1397	1326658800000	19408	9627	112	0	\N
147877	1397	1326648799000	19408	9627	113	0	\N
147878	1397	1326638798000	19408	9627	114	0	\N
147879	1397	1326628797000	19408	9627	115	0	\N
147880	1397	1326618796000	19408	9627	116	0	\N
147881	1397	1326608795000	19408	9627	117	0	\N
147882	1397	1326598794000	19408	9627	118	0	\N
147883	1397	1326588793000	19408	9627	119	0	\N
147884	1397	1326578792000	19408	9627	120	0	\N
147885	1397	1326568791000	19408	9627	121	0	\N
147886	1397	1326558790000	19408	9627	122	0	\N
147887	1397	1326548789000	19408	9627	123	0	\N
147888	1397	1326538788000	19408	9627	124	0	\N
147889	1397	1326528787000	19408	9627	125	0	\N
147893	1397	1325258660000	19410	9781	0	0	\N
147894	2134	96782367000	19410	9781	1	0	\N
147895	2133	97210428000	19410	9781	2	0	\N
147912	1397	1325208655000	19415	9785	0	0	\N
147913	2133	97205418000	19415	9785	1	0	\N
147914	2134	96777352000	19415	9785	2	0	\N
147919	1397	1325198654000	19417	9786	0	0	\N
147920	2133	97204416000	19417	9786	1	0	\N
147921	2134	96776349000	19417	9786	2	0	\N
147922	2132	148353354000	19417	9786	3	0	\N
147926	1502	1439910000000	19419	9550	0	0	\N
147927	1502	1439810000000	19419	9550	1	0	\N
147928	504	66301878193897	19419	9550	2	0	\N
147929	1397	1325178652000	19420	9788	0	0	\N
147930	1397	1325168651000	19420	9788	1	0	\N
147931	2134	96774343000	19420	9788	2	0	\N
147932	2132	148352353000	19420	9788	3	0	\N
147933	2133	97202412000	19420	9788	4	0	\N
147934	2133	97201410000	19420	9788	5	0	\N
147935	2134	96773340000	19420	9788	6	0	\N
147943	2134	96774343000	19422	9788	0	0	\N
147944	2132	148352353000	19422	9788	1	0	\N
147945	2134	96773340000	19422	9788	2	0	\N
147946	1397	1325178652000	19423	9788	0	0	\N
147947	1397	1325168651000	19423	9788	1	0	\N
147948	2134	96774343000	19423	9788	2	0	\N
147949	2132	148352353000	19423	9788	3	0	\N
147950	2133	97202412000	19423	9788	4	0	\N
147951	2133	97201410000	19423	9788	5	0	\N
147952	2134	96773340000	19423	9788	6	0	\N
147959	1397	1325138648000	19425	9790	0	0	\N
147960	2134	96770331000	19425	9790	1	0	\N
147961	2133	97198404000	19425	9790	2	0	\N
147962	2132	148351352000	19425	9790	3	0	\N
147892	2133	97210428000	19409	9781	2	0	1786
147896	1397	1325248659000	19411	9782	0	0	11358
147897	1397	1325238658000	19411	9782	1	0	11359
147898	2133	97209426000	19411	9782	2	0	1787
147899	2132	148354355000	19411	9782	3	0	645
147901	2134	96780361000	19411	9782	5	0	2213
147902	2133	97208424000	19411	9782	6	0	1788
147903	1397	1325228657000	19413	9784	0	0	11360
147904	1397	1325218656000	19413	9784	1	0	11361
147905	2134	96779358000	19413	9784	2	0	2214
147907	2133	97207422000	19413	9784	4	0	1789
147908	2133	97206420000	19413	9784	5	0	1790
147909	1397	1325208655000	19414	9785	0	0	11362
147910	2133	97205418000	19414	9785	1	0	1791
147915	1397	1325198654000	19416	9786	0	0	11363
147916	2133	97204416000	19416	9786	1	0	1792
147917	2134	96776349000	19416	9786	2	0	2217
147918	2132	148353354000	19416	9786	3	0	646
147923	1397	1325188653000	19418	9787	0	0	11364
147925	2133	97203414000	19418	9787	2	0	1793
147936	1397	1325178652000	19421	9788	0	0	11365
147937	1397	1325168651000	19421	9788	1	0	11366
147938	2134	96774343000	19421	9788	2	0	2219
147939	2132	148352353000	19421	9788	3	0	647
147941	2133	97201410000	19421	9788	5	0	1795
147942	2134	96773340000	19421	9788	6	0	2220
147953	1397	1325158650000	19424	9789	0	0	11367
147954	1397	1325148649000	19424	9789	1	0	11368
147956	2133	97199406000	19424	9789	3	0	1797
147957	2134	96772337000	19424	9789	4	0	2221
147958	2134	96771334000	19424	9789	5	0	2222
147963	1397	1325138648000	19426	9790	0	0	11369
147964	2134	96770331000	19426	9790	1	0	2223
147966	2132	148351352000	19426	9790	3	0	648
147967	1397	1325128647000	19427	9791	0	0	11370
147968	2211	718023000000	19427	9791	1	0	1
147971	1397	1325118646000	19428	9792	0	0	\N
147972	2134	96768325000	19428	9792	1	0	\N
147973	2133	97196400000	19428	9792	2	0	\N
147990	1397	1325088643000	19432	9794	0	0	\N
147991	2133	97193394000	19432	9794	1	0	\N
147992	2134	96765316000	19432	9794	2	0	\N
148001	1397	1325078642000	19435	9795	0	0	\N
148002	1397	1325068641000	19435	9795	1	0	\N
148003	2134	96764313000	19435	9795	2	0	\N
148004	2132	148349350000	19435	9795	3	0	\N
148005	2133	97192392000	19435	9795	4	0	\N
148006	2133	97191390000	19435	9795	5	0	\N
148007	2211	1021000000	19435	9795	6	0	\N
148008	2134	96763310000	19435	9795	7	0	\N
148012	1397	1325058640000	19437	9796	0	0	\N
148013	2134	96762307000	19437	9796	1	0	\N
148014	2133	97190388000	19437	9796	2	0	\N
148015	1397	1325048639000	19439	9797	0	0	\N
148016	1397	1325038638000	19439	9797	1	0	\N
148017	1397	1325028637000	19439	9797	2	0	\N
148018	1397	1325018636000	19439	9797	3	0	\N
148019	1397	1325008635000	19439	9797	4	0	\N
148020	2132	148348349000	19439	9797	5	0	\N
148021	2211	920000000	19439	9797	6	0	\N
148022	2134	96761304000	19439	9797	7	0	\N
148023	1726	66153112000	19439	9797	8	0	\N
148024	2133	97189386000	19439	9797	9	0	\N
148025	2134	96760301000	19439	9797	10	0	\N
148026	2134	96759298000	19439	9797	11	0	\N
148027	2134	96758295000	19439	9797	12	0	\N
148028	2134	96757292000	19439	9797	13	0	\N
148029	2133	97188384000	19439	9797	14	0	\N
148030	2133	97187382000	19439	9797	15	0	\N
148031	2133	97186380000	19439	9797	16	0	\N
148032	2133	97185378000	19439	9797	17	0	\N
148067	1397	1324968631000	19447	9802	0	0	\N
148068	1397	1324958630000	19447	9802	1	0	\N
148069	2132	148346347000	19447	9802	2	0	\N
148070	2133	97181370000	19447	9802	3	0	\N
148071	2133	97180368000	19447	9802	4	0	\N
148072	2134	96753280000	19447	9802	5	0	\N
148073	2134	96752277000	19447	9802	6	0	\N
148074	1397	1324968631000	19448	9802	0	0	\N
148075	1397	1324958630000	19448	9802	1	0	\N
148076	2132	148346347000	19448	9802	2	0	\N
148077	2133	97181370000	19448	9802	3	0	\N
148078	2133	97180368000	19448	9802	4	0	\N
148079	2134	96753280000	19448	9802	5	0	\N
148080	2134	96752277000	19448	9802	6	0	\N
148081	1397	1324968631000	19449	9802	0	0	\N
148082	1397	1324958630000	19449	9802	1	0	\N
148083	2132	148346347000	19449	9802	2	0	\N
148084	2133	97181370000	19449	9802	3	0	\N
148085	2133	97180368000	19449	9802	4	0	\N
148086	2134	96753280000	19449	9802	5	0	\N
148087	2134	96752277000	19449	9802	6	0	\N
148088	1397	1324948629000	19450	9803	0	0	\N
148089	2133	97181370000	19450	9803	1	0	\N
148090	2133	97180368000	19450	9803	2	0	\N
148091	2134	96751274000	19450	9803	3	0	\N
148092	2133	97179366000	19450	9803	4	0	\N
148095	1397	1324948629000	19452	9803	0	0	\N
148096	2133	97181370000	19452	9803	1	0	\N
148097	2133	97180368000	19452	9803	2	0	\N
148098	2134	96751274000	19452	9803	3	0	\N
148099	2133	97179366000	19452	9803	4	0	\N
147974	1397	1325118646000	19429	9792	0	0	11371
147975	2134	96768325000	19429	9792	1	0	2225
147976	2133	97196400000	19429	9792	2	0	1800
147977	391	66612338193897	19430	9793	0	0	1
147978	266	66000918193897	19430	9793	1	0	2
147980	1397	1325098644000	19430	9793	3	0	11373
147981	2132	148350351000	19430	9793	4	0	649
147982	2211	717022000000	19430	9793	5	0	2
147983	2134	96767322000	19430	9793	6	0	2226
147984	2134	96766319000	19430	9793	7	0	2227
147986	2133	97194396000	19430	9793	9	0	1802
147987	1397	1325088643000	19431	9794	0	0	11374
147988	2133	97193394000	19431	9794	1	0	1803
147989	2134	96765316000	19431	9794	2	0	2228
147994	1397	1325068641000	19433	9795	1	0	11376
147995	2134	96764313000	19433	9795	2	0	2229
147996	2132	148349350000	19433	9795	3	0	650
147997	2133	97192392000	19433	9795	4	0	1804
147998	2133	97191390000	19433	9795	5	0	1805
148000	2134	96763310000	19433	9795	7	0	2230
148009	1397	1325058640000	19436	9796	0	0	11377
148010	2134	96762307000	19436	9796	1	0	2231
148011	2133	97190388000	19436	9796	2	0	1806
148033	1397	1325048639000	19440	9797	0	0	11378
148035	1397	1325028637000	19440	9797	2	0	11380
148036	1397	1325018636000	19440	9797	3	0	11381
148037	1397	1325008635000	19440	9797	4	0	11382
148038	2132	148348349000	19440	9797	5	0	651
148040	2134	96761304000	19440	9797	7	0	2232
148041	1726	66153112000	19440	9797	8	0	8232
148042	2133	97189386000	19440	9797	9	0	1807
148043	2134	96760301000	19440	9797	10	0	2233
148044	2134	96759298000	19440	9797	11	0	2234
148046	2134	96757292000	19440	9797	13	0	2236
148047	2133	97188384000	19440	9797	14	0	1808
148048	2133	97187382000	19440	9797	15	0	1809
148049	2133	97186380000	19440	9797	16	0	1810
148050	2133	97185378000	19440	9797	17	0	1811
148052	2134	96756289000	19441	9798	1	0	2237
148053	2132	148347348000	19441	9798	2	0	652
148054	2133	97184376000	19441	9798	3	0	1812
148055	1397	1324988633000	19442	9799	0	0	11384
148057	2134	96755286000	19442	9799	2	0	2238
148058	2133	97183374000	19442	9799	3	0	1813
148059	1397	1324978632000	19443	9800	0	0	11385
148060	2134	96754283000	19443	9800	1	0	2239
148061	2133	97182372000	19443	9800	2	0	1814
148063	1397	1324958630000	19446	9802	1	0	11387
148064	2132	148346347000	19446	9802	2	0	653
148065	2134	96753280000	19446	9802	3	0	2240
148066	2134	96752277000	19446	9802	4	0	2241
148093	1397	1324948629000	19451	9803	0	0	11388
148100	1397	1324938628000	19453	9804	0	0	11389
148101	1397	1324928627000	19453	9804	1	0	11390
148102	2133	97181370000	19453	9804	2	0	1815
148103	2133	97180368000	19453	9804	3	0	1816
148113	1397	1324908625000	19455	9806	0	0	\N
148114	2133	97175358000	19455	9806	1	0	\N
148115	2134	96747262000	19455	9806	2	0	\N
148133	1397	1324858620000	19459	9809	0	0	\N
148134	2133	97170348000	19459	9809	1	0	\N
148135	2134	96742247000	19459	9809	2	0	\N
148136	1397	1324858620000	19460	9809	0	0	\N
148137	2133	97170348000	19460	9809	1	0	\N
148143	1397	1324848619000	19463	9810	0	0	\N
148144	2133	97169346000	19463	9810	1	0	\N
148149	1397	1324838618000	19465	9811	0	0	\N
148150	2132	148342343000	19465	9811	1	0	\N
148151	2134	96741244000	19465	9811	2	0	\N
148152	2133	97168344000	19465	9811	3	0	\N
148170	1397	1324778612000	19469	9815	0	0	\N
148171	1397	1324778612000	19470	9815	0	0	\N
148172	2133	97162332000	19470	9815	1	0	\N
148173	2134	96735226000	19470	9815	2	0	\N
148191	1397	1324738608000	19475	9819	0	0	\N
148192	2133	97158324000	19475	9819	1	0	\N
148193	2134	96731214000	19475	9819	2	0	\N
148194	2132	148339340000	19475	9819	3	0	\N
148195	1726	60148112000	19475	9819	4	0	\N
148200	1397	1324738608000	19477	9819	0	0	\N
148201	2133	97158324000	19477	9819	1	0	\N
148202	2134	96731214000	19477	9819	2	0	\N
148203	2132	148339340000	19477	9819	3	0	\N
148204	1726	60148112000	19477	9819	4	0	\N
148205	1397	1324728607000	19478	9820	0	0	\N
148206	1397	1324718606000	19478	9820	1	0	\N
148207	2133	97158324000	19478	9820	2	0	\N
148208	2134	96730211000	19478	9820	3	0	\N
148209	2134	96729208000	19478	9820	4	0	\N
148210	1444	18232370159999	19478	9820	5	0	\N
148211	2133	97157322000	19478	9820	6	0	\N
148212	2133	97156320000	19478	9820	8	0	\N
148221	2133	97155318000	19480	9821	0	0	\N
148224	1397	1324708605000	19482	9821	0	0	\N
148225	2133	97155318000	19482	9821	1	0	\N
148226	2134	96728205000	19482	9821	2	0	\N
148227	1397	1324708605000	19483	9821	0	0	\N
148228	2133	97155318000	19483	9821	1	0	\N
148229	2134	96728205000	19483	9821	2	0	\N
148230	2132	148338339000	19484	9822	0	0	\N
148231	2133	97154316000	19484	9822	1	0	\N
148232	2134	96728205000	19484	9822	2	0	\N
148239	1397	1324698604000	19487	9823	0	0	\N
148240	2214	2501990000000	19487	9823	1	0	\N
148107	2134	96749268000	19453	9804	7	0	2244
148108	2132	148345346000	19453	9804	8	0	654
148109	2133	97177362000	19453	9804	9	0	1819
148110	1397	1324918626000	19454	9805	0	0	11391
148111	2134	96748265000	19454	9805	1	0	2245
148116	1397	1324908625000	19456	9806	0	0	11392
148117	2133	97175358000	19456	9806	1	0	1821
148118	2134	96747262000	19456	9806	2	0	2246
148119	1397	1324898624000	19457	9807	0	0	11393
148120	2133	97174356000	19457	9807	1	0	1822
148122	2134	96746259000	19457	9807	3	0	2247
148123	1397	1324888623000	19458	9808	0	0	11394
148124	1397	1324878622000	19458	9808	1	0	11395
148125	1397	1324868621000	19458	9808	2	0	11396
148127	2134	96744253000	19458	9808	4	0	2249
148128	2134	96743250000	19458	9808	5	0	2250
148129	2132	148343344000	19458	9808	6	0	656
148130	2133	97173354000	19458	9808	7	0	1823
148131	2133	97172352000	19458	9808	8	0	1824
148138	1397	1324858620000	19461	9809	0	0	11397
148139	2133	97170348000	19461	9809	1	0	1826
148140	2134	96742247000	19461	9809	2	0	2251
148141	1397	1324848619000	19462	9810	0	0	11398
148142	2133	97169346000	19462	9810	1	0	1827
148146	2132	148342343000	19464	9811	1	0	657
148147	2134	96741244000	19464	9811	2	0	2252
148148	2133	97168344000	19464	9811	3	0	1828
148153	1397	1324828617000	19466	9812	0	0	11400
148155	2133	97167342000	19466	9812	2	0	1829
148156	1397	1324818616000	19467	9813	0	0	11401
148157	1397	1324808615000	19467	9813	1	0	11402
148158	1397	1324798614000	19467	9813	2	0	11403
148159	1726	64952112000	19467	9813	3	0	8233
148161	2134	96739238000	19467	9813	5	0	2254
148162	2134	96738235000	19467	9813	6	0	2255
148163	2134	96737232000	19467	9813	7	0	2256
148164	2133	97166340000	19467	9813	8	0	1830
148165	2133	97165338000	19467	9813	9	0	1831
148167	1397	1324788613000	19468	9814	0	0	11404
148168	2133	97163334000	19468	9814	1	0	1833
148169	2134	96736229000	19468	9814	2	0	2257
148174	1397	1324778612000	19471	9815	0	0	11405
148176	2134	96735226000	19471	9815	2	0	2258
148177	1397	1324768611000	19472	9816	0	0	11406
148178	2132	148340341000	19472	9816	1	0	659
148179	2133	97161330000	19472	9816	2	0	1835
148180	2134	96734223000	19472	9816	3	0	2259
148182	2133	97160328000	19473	9817	1	0	1836
148183	2134	96733220000	19473	9817	2	0	2260
148184	1397	1324748609000	19474	9818	0	0	11408
148185	1444	20012358159999	19474	9818	1	0	7
148186	2133	97159326000	19474	9818	2	0	1837
148188	1726	62550112000	19474	9818	4	0	8235
148189	1726	61349112000	19474	9818	5	0	8236
148190	2134	96732217000	19474	9818	6	0	2261
148196	1397	1324738608000	19476	9819	0	0	11409
148198	2132	148339340000	19476	9819	2	0	660
148199	1726	60148112000	19476	9819	3	0	8237
148213	1397	1324728607000	19479	9820	0	0	11410
148214	1397	1324718606000	19479	9820	1	0	11411
148215	2133	97158324000	19479	9820	2	0	1838
148217	2134	96729208000	19479	9820	4	0	2264
148218	1444	18232370159999	19479	9820	5	0	8
148219	2133	97157322000	19479	9820	6	0	1839
148220	2133	97156320000	19479	9820	8	0	1840
148222	1397	1324708605000	19481	9821	0	0	11412
148233	2132	148338339000	19485	9822	0	0	661
148234	2133	97154316000	19485	9822	1	0	1842
148235	2134	96728205000	19485	9822	2	0	2265
148236	1397	1324698604000	19486	9823	0	0	11413
148238	2134	96727202000	19486	9823	2	0	2266
148241	2133	97153314000	19487	9823	2	0	\N
148242	2134	96727202000	19487	9823	3	0	\N
148247	2214	2501990000000	19489	9824	0	0	\N
148248	1397	1324688603000	19489	9824	1	0	\N
148249	2134	96726199000	19489	9824	2	0	\N
148250	2133	97152312000	19489	9824	3	0	\N
148251	1447	15993600943000	19490	9825	0	0	\N
148252	1397	1324678602000	19490	9825	1	0	\N
148253	2132	148337338000	19490	9825	2	0	\N
148254	2134	96725196000	19490	9825	3	0	\N
148255	1447	15993600943000	19491	9825	0	0	\N
148256	1397	1324678602000	19491	9825	1	0	\N
148257	2133	97151310000	19491	9825	2	0	\N
148258	2132	148337338000	19491	9825	3	0	\N
148259	2134	96725196000	19491	9825	4	0	\N
148265	1397	1324678602000	19493	9825	0	0	\N
148266	2133	97151310000	19493	9825	1	0	\N
148267	2132	148337338000	19493	9825	2	0	\N
148268	2134	96725196000	19493	9825	3	0	\N
148285	1397	1324628597000	19497	9828	0	0	\N
148286	2134	96720181000	19497	9828	1	0	\N
148287	2133	97146300000	19497	9828	2	0	\N
148291	1397	1324608595000	19499	9830	0	0	\N
148292	2134	96718175000	19499	9830	1	0	\N
148293	2132	148335336000	19499	9830	2	0	\N
148294	2133	97144296000	19499	9830	3	0	\N
148295	1397	1324608595000	19500	9830	0	0	\N
148296	2134	96718175000	19500	9830	1	0	\N
148297	2132	148335336000	19500	9830	2	0	\N
148298	2133	97144296000	19500	9830	3	0	\N
148299	1397	1324608595000	19501	9830	0	0	\N
148300	2134	96718175000	19501	9830	1	0	\N
148301	2132	148335336000	19501	9830	2	0	\N
148302	2133	97144296000	19501	9830	3	0	\N
148307	1397	1324608595000	19503	9830	0	0	\N
148308	2134	96718175000	19503	9830	1	0	\N
148309	2132	148335336000	19503	9830	2	0	\N
148310	2133	97144296000	19503	9830	3	0	\N
148311	1397	1324598594000	19504	9831	0	0	\N
148312	1397	1324588593000	19504	9831	1	0	\N
148313	2133	97143294000	19504	9831	2	0	\N
148314	2133	97142292000	19504	9831	3	0	\N
148315	2134	96717172000	19504	9831	4	0	\N
148316	2134	96716169000	19504	9831	5	0	\N
148317	1397	1324598594000	19505	9831	0	0	\N
148318	1397	1324588593000	19505	9831	1	0	\N
148319	2133	97143294000	19505	9831	2	0	\N
148320	2133	97142292000	19505	9831	3	0	\N
148321	2134	96717172000	19505	9831	4	0	\N
148322	2134	96716169000	19505	9831	5	0	\N
148323	1397	1324598594000	19506	9831	0	0	\N
148324	1397	1324588593000	19506	9831	1	0	\N
148325	2133	97143294000	19506	9831	2	0	\N
148326	2133	97142292000	19506	9831	3	0	\N
148327	2134	96717172000	19506	9831	4	0	\N
148328	2134	96716169000	19506	9831	5	0	\N
148335	1397	1324578592000	19508	9832	0	0	\N
148336	2134	96715166000	19508	9832	1	0	\N
148337	2133	97141290000	19508	9832	2	0	\N
148338	2132	148334335000	19508	9832	3	0	\N
148343	1397	1324578592000	19510	9832	0	0	\N
148344	2134	96715166000	19510	9832	1	0	\N
148345	2133	97141290000	19510	9832	2	0	\N
148346	2132	148334335000	19510	9832	3	0	\N
148347	1397	1324578592000	19511	9832	0	0	\N
148348	2134	96715166000	19511	9832	1	0	\N
148349	2133	97141290000	19511	9832	2	0	\N
148350	2132	148334335000	19511	9832	3	0	\N
148351	1397	1324578592000	19512	9832	0	0	\N
148352	2134	96715166000	19512	9832	1	0	\N
148353	2133	97141290000	19512	9832	2	0	\N
148354	2132	148334335000	19512	9832	3	0	\N
148355	1397	1324578592000	19513	9832	0	0	\N
148356	2134	96715166000	19513	9832	1	0	\N
148357	2133	97141290000	19513	9832	2	0	\N
148358	2132	148334335000	19513	9832	3	0	\N
148359	1397	1324568591000	19514	9833	0	0	\N
148360	2134	96714163000	19514	9833	1	0	\N
148361	2133	97140288000	19514	9833	2	0	\N
148368	1397	1324548589000	19516	9834	0	0	\N
148369	2133	97138284000	19516	9834	1	0	\N
148370	2134	96712157000	19516	9834	2	0	\N
148371	2132	148333334000	19516	9834	3	0	\N
148376	1447	15993600943000	19518	9806	0	0	\N
148245	2134	96726199000	19488	9824	2	0	2267
148246	2133	97152312000	19488	9824	3	0	1844
148260	1447	15993600943000	19492	9825	0	0	6
148261	1397	1324678602000	19492	9825	1	0	11415
148262	2133	97151310000	19492	9825	2	0	1845
148264	2134	96725196000	19492	9825	4	0	2268
148269	1397	1324668601000	19494	9826	0	0	11416
148270	2134	96724193000	19494	9826	1	0	2269
148271	2133	97150308000	19494	9826	2	0	1846
148272	1397	1324658600000	19495	9827	0	0	11417
148274	1397	1324638598000	19495	9827	2	0	11419
148275	2133	97149306000	19495	9827	3	0	1847
148276	2134	96723190000	19495	9827	4	0	2270
148277	2134	96722187000	19495	9827	5	0	2271
148279	2133	97148304000	19495	9827	7	0	1848
148280	2133	97147302000	19495	9827	8	0	1849
148281	2132	148336337000	19495	9827	9	0	663
148282	1397	1324628597000	19496	9828	0	0	11420
148283	2134	96720181000	19496	9828	1	0	2273
148288	1397	1324618596000	19498	9829	0	0	11421
148289	2134	96719178000	19498	9829	1	0	2274
148290	2133	97145298000	19498	9829	2	0	1851
148303	1397	1324608595000	19502	9830	0	0	11422
148304	2134	96718175000	19502	9830	1	0	2275
148306	2133	97144296000	19502	9830	3	0	1852
148329	1397	1324598594000	19507	9831	0	0	11423
148330	1397	1324588593000	19507	9831	1	0	11424
148331	2133	97143294000	19507	9831	2	0	1853
148333	2134	96717172000	19507	9831	4	0	2276
148334	2134	96716169000	19507	9831	5	0	2277
148339	1397	1324578592000	19509	9832	0	0	11425
148340	2134	96715166000	19509	9832	1	0	2278
148341	2133	97141290000	19509	9832	2	0	1855
148362	1397	1324568591000	19515	9833	0	0	11426
148363	1397	1324558590000	19515	9833	1	0	11427
148364	2134	96714163000	19515	9833	2	0	2279
148365	2133	97140288000	19515	9833	3	0	1856
148366	2133	97139286000	19515	9833	4	0	1857
148372	1397	1324548589000	19517	9834	0	0	11428
148373	2133	97138284000	19517	9834	1	0	1858
148374	2134	96712157000	19517	9834	2	0	2281
148375	2132	148333334000	19517	9834	3	0	666
148377	1444	20012358159999	19518	9806	1	0	\N
148378	1726	64952112000	19518	9806	2	0	\N
148379	1726	63751112000	19518	9806	3	0	\N
148380	1726	62550112000	19518	9806	4	0	\N
148381	1726	61349112000	19518	9806	5	0	\N
148382	1444	17512357159999	19518	9806	6	0	\N
148383	1726	60148112000	19518	9806	7	0	\N
148387	1397	1324538588000	19520	9835	0	0	\N
148388	2133	97137282000	19520	9835	1	0	\N
148389	2134	96711154000	19520	9835	2	0	\N
148390	1397	1324538588000	19521	9835	0	0	\N
148391	2133	97137282000	19521	9835	1	0	\N
148392	2134	96711154000	19521	9835	2	0	\N
148393	1397	1324528587000	19522	9836	0	0	\N
148394	2134	96710151000	19522	9836	1	0	\N
148395	2133	97136280000	19522	9836	2	0	\N
148399	1397	1324518586000	19524	9837	0	0	\N
148400	2134	96709148000	19524	9837	1	0	\N
148404	1397	1324518586000	19526	9837	0	0	\N
148405	2134	96709148000	19526	9837	1	0	\N
148406	2133	97135278000	19526	9837	2	0	\N
148407	1397	1324508585000	19527	9838	0	0	\N
148408	2133	97134276000	19527	9838	1	0	\N
148409	2132	148332333000	19527	9838	2	0	\N
148410	2134	96708145000	19527	9838	3	0	\N
148411	1397	1324508585000	19528	9838	0	0	\N
148412	2133	97134276000	19528	9838	1	0	\N
148413	2132	148332333000	19528	9838	2	0	\N
148414	2134	96708145000	19528	9838	3	0	\N
148415	1397	1324508585000	19529	9838	0	0	\N
148416	2133	97134276000	19529	9838	1	0	\N
148417	2132	148332333000	19529	9838	2	0	\N
148418	2134	96708145000	19529	9838	3	0	\N
148433	1397	1324468581000	19533	9841	0	0	\N
148434	2133	97130268000	19533	9841	2	0	\N
148435	2134	96704133000	19533	9841	3	0	\N
148439	1397	1324458580000	19536	9842	0	0	\N
148440	2134	96703130000	19536	9842	1	0	\N
148441	2133	97129266000	19536	9842	2	0	\N
148445	1397	1324558590000	19538	9834	0	0	\N
148446	1397	1324548589000	19538	9834	1	0	\N
148447	1397	1324538588000	19538	9834	2	0	\N
148448	1397	1324528587000	19538	9834	3	0	\N
148449	1397	1324518586000	19538	9834	4	0	\N
148450	1397	1324508585000	19538	9834	5	0	\N
148451	1397	1324498584000	19538	9834	6	0	\N
148452	1397	1324488583000	19538	9834	7	0	\N
148453	1397	1324478582000	19538	9834	8	0	\N
148454	1397	1324468581000	19538	9834	9	0	\N
148455	1397	1324458580000	19538	9834	10	0	\N
148456	2133	97139286000	19538	9834	11	0	\N
148457	2133	97138284000	19538	9834	12	0	\N
148458	2133	97137282000	19538	9834	13	0	\N
148459	2132	148333334000	19538	9834	14	0	\N
148460	2132	148332333000	19538	9834	15	0	\N
148461	2133	97136280000	19538	9834	16	0	\N
148462	2134	96713160000	19538	9834	17	0	\N
148463	2134	96712157000	19538	9834	18	0	\N
148464	2134	96711154000	19538	9834	19	0	\N
148465	2134	96710151000	19538	9834	20	0	\N
148466	2134	96709148000	19538	9834	21	0	\N
148467	2134	96708145000	19538	9834	22	0	\N
148468	2134	96707142000	19538	9834	23	0	\N
148469	2134	96706139000	19538	9834	24	0	\N
148470	2134	96705136000	19538	9834	25	0	\N
148471	2134	96704133000	19538	9834	26	0	\N
148472	2134	96703130000	19538	9834	27	0	\N
148473	2132	148331332000	19538	9834	28	0	\N
148474	2133	97135278000	19538	9834	29	0	\N
148475	2133	97134276000	19538	9834	30	0	\N
148476	2133	97133274000	19538	9834	31	0	\N
148477	2133	97132272000	19538	9834	32	0	\N
148478	2133	97131270000	19538	9834	33	0	\N
148479	2133	97130268000	19538	9834	34	0	\N
148480	2133	97129266000	19538	9834	35	0	\N
148485	1397	1324448579000	19540	9843	0	0	\N
148486	2132	148330331000	19540	9843	1	0	\N
148487	2134	96702127000	19540	9843	2	0	\N
148488	1397	1324448579000	19541	9843	0	0	\N
148489	2132	148330331000	19541	9843	1	0	\N
148490	2134	96702127000	19541	9843	2	0	\N
148491	2133	97128264000	19541	9843	3	0	\N
148495	1397	1324428577000	19543	9845	0	0	\N
148496	1397	1324418576000	19543	9845	1	0	\N
148497	1397	1324408575000	19543	9845	2	0	\N
148498	2132	148329330000	19543	9845	3	0	\N
148499	2134	96700121000	19543	9845	4	0	\N
148500	2134	96699118000	19543	9845	5	0	\N
148501	2134	96698115000	19543	9845	6	0	\N
148502	1397	1324428577000	19544	9845	0	0	\N
148503	1397	1324418576000	19544	9845	1	0	\N
148504	1397	1324408575000	19544	9845	2	0	\N
148505	2133	97126260000	19544	9845	3	0	\N
148506	2132	148329330000	19544	9845	4	0	\N
148507	2133	97125258000	19544	9845	5	0	\N
148508	2133	97124256000	19544	9845	6	0	\N
148509	2134	96700121000	19544	9845	7	0	\N
148510	2134	96699118000	19544	9845	8	0	\N
148511	2134	96698115000	19544	9845	9	0	\N
148386	2134	96711154000	19519	9835	2	0	2282
148396	1397	1324528587000	19523	9836	0	0	11430
148397	2134	96710151000	19523	9836	1	0	2283
148398	2133	97136280000	19523	9836	2	0	1860
148401	1397	1324518586000	19525	9837	0	0	11431
148403	2133	97135278000	19525	9837	2	0	1861
148419	1397	1324508585000	19530	9838	0	0	11432
148420	2133	97134276000	19530	9838	1	0	1862
148421	2132	148332333000	19530	9838	2	0	667
148422	2134	96708145000	19530	9838	3	0	2285
148424	2133	97133274000	19531	9839	1	0	1863
148425	2134	96707142000	19531	9839	2	0	2286
148426	1397	1324488583000	19532	9840	0	0	11434
148427	1397	1324478582000	19532	9840	1	0	11435
148429	2134	96705136000	19532	9840	3	0	2288
148430	2133	97132272000	19532	9840	4	0	1864
148431	2133	97131270000	19532	9840	5	0	1865
148432	2132	148331332000	19532	9840	6	0	668
148436	1397	1324468581000	19534	9841	0	0	11436
148438	2134	96704133000	19534	9841	3	0	2289
148442	1397	1324458580000	19537	9842	0	0	11437
148443	2134	96703130000	19537	9842	1	0	2290
148444	2133	97129266000	19537	9842	2	0	1867
148481	1397	1324448579000	19539	9843	0	0	11438
148483	2134	96702127000	19539	9843	2	0	2291
148484	2133	97128264000	19539	9843	3	0	1868
148492	1397	1324438578000	19542	9844	0	0	11439
148493	2133	97127262000	19542	9844	1	0	1869
148512	1397	1324428577000	19545	9845	0	0	11440
148522	1397	1324428577000	19546	9845	0	0	\N
148523	1397	1324418576000	19546	9845	1	0	\N
148524	1397	1324408575000	19546	9845	2	0	\N
148525	2133	97126260000	19546	9845	3	0	\N
148526	2132	148329330000	19546	9845	4	0	\N
148527	2133	97125258000	19546	9845	5	0	\N
148528	2133	97124256000	19546	9845	6	0	\N
148529	2134	96700121000	19546	9845	7	0	\N
148530	2134	96699118000	19546	9845	8	0	\N
148531	2134	96698115000	19546	9845	9	0	\N
148532	1397	1324398574000	19547	9846	0	0	\N
148533	2133	97123254000	19547	9846	1	0	\N
148534	2134	96697112000	19547	9846	2	0	\N
148538	1397	1324388573000	19549	9847	0	0	\N
148539	1397	1324378572000	19549	9847	1	0	\N
148540	2133	97122252000	19549	9847	2	0	\N
148541	2133	97121250000	19549	9847	3	0	\N
148542	2132	148328329000	19549	9847	4	0	\N
148543	2134	96696109000	19549	9847	5	0	\N
148544	2134	96695106000	19549	9847	6	0	\N
148552	391	66612338193897	19551	9681	0	0	\N
148553	504	66301878193897	19551	9681	1	0	\N
148554	353	66612718193897	19551	9681	2	0	\N
148555	504	66000868193897	19551	9681	3	0	\N
148556	1993	1668401389290	19551	9681	4	0	\N
148557	1447	15993600943000	19551	9681	5	0	\N
148558	1444	19294281159999	19551	9681	6	0	\N
148559	1571	21516627623166	19551	9681	7	0	\N
148560	1571	20878353595030	19551	9681	8	0	\N
148561	1571	19734579925254	19551	9681	9	0	\N
148562	1601	11989435620000	19551	9681	10	0	\N
148563	1601	8829425620000	19551	9681	11	0	\N
148564	1601	6697415620000	19551	9681	12	0	\N
148565	1601	4933405620000	19551	9681	13	0	\N
148566	2211	718023000000	19551	9681	14	0	\N
148567	1571	18962849786155	19551	9681	15	0	\N
148568	1571	16812373001031	19551	9681	16	0	\N
148569	1571	16776416031949	19551	9681	17	0	\N
148570	1571	16502864305605	19551	9681	18	0	\N
148571	1571	16012669875701	19551	9681	19	0	\N
148572	1571	15681922673230	19551	9681	20	0	\N
148573	1571	14760284051034	19551	9681	21	0	\N
148574	1571	14688420012870	19551	9681	22	0	\N
148575	1571	14141326560182	19551	9681	23	0	\N
148576	1571	13160947700374	19551	9681	24	0	\N
148577	1571	12499463295432	19551	9681	25	0	\N
148578	1571	10656196051040	19551	9681	26	0	\N
148579	1571	10644207211346	19551	9681	27	0	\N
148580	1571	10553016635898	19551	9681	28	0	\N
148581	1571	10389611825930	19551	9681	29	0	\N
148582	1571	10279356091773	19551	9681	30	0	\N
148583	1571	9972136551041	19551	9681	31	0	\N
148584	1571	9912146852571	19551	9681	32	0	\N
148585	1571	9456233975331	19551	9681	33	0	\N
148586	1571	8639249925491	19551	9681	34	0	\N
148587	1571	8088011254706	19551	9681	35	0	\N
148588	1571	6551953551046	19551	9681	36	0	\N
148589	1571	6504014892270	19551	9681	37	0	\N
148590	1571	6139282590478	19551	9681	38	0	\N
148591	1571	5485693350606	19551	9681	39	0	\N
148592	1571	5044700413978	19551	9681	40	0	\N
148593	1571	3815852251050	19551	9681	41	0	\N
148594	1571	3791801921662	19551	9681	42	0	\N
148595	1571	3609430770766	19551	9681	43	0	\N
148596	1571	3282631150830	19551	9681	44	0	\N
148597	1571	3062129682516	19551	9681	45	0	\N
148598	1571	2447700601052	19551	9681	46	0	\N
148599	532	66010043000000	19551	9681	47	0	\N
148600	1444	19292280159999	19551	9681	48	0	\N
148601	1749	7925369930000	19551	9681	49	0	\N
148602	2211	717022000000	19551	9681	50	0	\N
148603	2211	1021000000	19551	9681	51	0	\N
148604	2211	920000000	19551	9681	52	0	\N
148605	1444	16792279159999	19551	9681	53	0	\N
148606	1726	79364112000	19551	9681	54	0	\N
148607	1726	78163112000	19551	9681	55	0	\N
148608	1726	76962112000	19551	9681	56	0	\N
148609	1592	33000000	19551	9681	57	0	\N
148610	2163	1198999000000	19551	9681	58	0	\N
148611	1726	75761112000	19551	9681	59	0	\N
148612	1726	74560112000	19551	9681	60	0	\N
148613	1726	73359112000	19551	9681	61	0	\N
148614	1726	72158112000	19551	9681	62	0	\N
148615	1726	70957112000	19551	9681	63	0	\N
148616	1726	69756112000	19551	9681	64	0	\N
148617	1726	68555112000	19551	9681	65	0	\N
148618	1726	67354112000	19551	9681	66	0	\N
148619	1726	66153112000	19551	9681	67	0	\N
148620	1726	64952112000	19551	9681	68	0	\N
148621	1726	63751112000	19551	9681	69	0	\N
148622	1726	62550112000	19551	9681	70	0	\N
148623	1726	61349112000	19551	9681	71	0	\N
148624	1726	60148112000	19551	9681	72	0	\N
148625	1769	1585900000	19551	9681	73	0	\N
148626	1769	1584900000	19551	9681	74	0	\N
148627	1769	1583900000	19551	9681	75	0	\N
148628	1769	1582900000	19551	9681	76	0	\N
148629	1769	1581900000	19551	9681	77	0	\N
148630	1769	1580900000	19551	9681	78	0	\N
148640	1397	1324348569000	19554	9849	0	0	\N
148641	2132	148327328000	19554	9849	1	0	\N
148642	2133	97118244000	19554	9849	2	0	\N
148643	2134	96692097000	19554	9849	3	0	\N
148644	1397	1324348569000	19555	9849	0	0	\N
148645	2132	148327328000	19555	9849	1	0	\N
148646	2133	97118244000	19555	9849	2	0	\N
148647	2134	96692097000	19555	9849	3	0	\N
148648	1397	1324348569000	19556	9849	0	0	\N
148515	2133	97126260000	19545	9845	3	0	1870
148516	2132	148329330000	19545	9845	4	0	670
148517	2133	97125258000	19545	9845	5	0	1871
148518	2133	97124256000	19545	9845	6	0	1872
148519	2134	96700121000	19545	9845	7	0	2293
148521	2134	96698115000	19545	9845	9	0	2295
148535	1397	1324398574000	19548	9846	0	0	11443
148536	2133	97123254000	19548	9846	1	0	1873
148537	2134	96697112000	19548	9846	2	0	2296
148545	1397	1324388573000	19550	9847	0	0	11444
148547	2133	97122252000	19550	9847	2	0	1874
148548	2133	97121250000	19550	9847	3	0	1875
148549	2132	148328329000	19550	9847	4	0	671
148550	2134	96696109000	19550	9847	5	0	2297
148631	1397	1324368571000	19552	9848	0	0	11446
148632	1397	1324358570000	19552	9848	1	0	11447
148633	2134	96694103000	19552	9848	2	0	2299
148634	2133	97120248000	19552	9848	3	0	1876
148635	2133	97119246000	19552	9848	4	0	1877
148637	1397	1324348569000	19553	9849	0	0	11448
148638	2132	148327328000	19553	9849	1	0	672
148639	2134	96692097000	19553	9849	2	0	2301
148649	2132	148327328000	19556	9849	1	0	\N
148650	2133	97118244000	19556	9849	2	0	\N
148651	2134	96692097000	19556	9849	3	0	\N
148652	1397	1324448579000	19557	9835	0	0	\N
148653	1397	1324438578000	19557	9835	1	0	\N
148654	1397	1324428577000	19557	9835	2	0	\N
148655	1397	1324418576000	19557	9835	3	0	\N
148656	1397	1324408575000	19557	9835	4	0	\N
148657	1397	1324398574000	19557	9835	5	0	\N
148658	1397	1324388573000	19557	9835	6	0	\N
148659	1397	1324378572000	19557	9835	8	0	\N
148660	1397	1324368571000	19557	9835	9	0	\N
148661	1397	1324358570000	19557	9835	10	0	\N
148662	1397	1324348569000	19557	9835	11	0	\N
148663	2132	148330331000	19557	9835	12	0	\N
148664	2134	96702127000	19557	9835	13	0	\N
148665	2134	96701124000	19557	9835	14	0	\N
148666	2132	148329330000	19557	9835	15	0	\N
148667	2133	97128264000	19557	9835	16	0	\N
148668	2133	97127262000	19557	9835	17	0	\N
148669	2133	97126260000	19557	9835	18	0	\N
148670	2133	97125258000	19557	9835	19	0	\N
148671	2133	97124256000	19557	9835	20	0	\N
148672	2133	97123254000	19557	9835	21	0	\N
148673	2133	97122252000	19557	9835	22	0	\N
148674	2133	97121250000	19557	9835	23	0	\N
148675	2133	97120248000	19557	9835	24	0	\N
148676	2133	97119246000	19557	9835	25	0	\N
148677	2133	97118244000	19557	9835	26	0	\N
148678	2134	96700121000	19557	9835	27	0	\N
148679	2134	96699118000	19557	9835	28	0	\N
148680	2134	96698115000	19557	9835	29	0	\N
148681	2134	96697112000	19557	9835	30	0	\N
148682	2132	148328329000	19557	9835	31	0	\N
148683	2132	148327328000	19557	9835	32	0	\N
148684	2134	96696109000	19557	9835	33	0	\N
148685	2134	96695106000	19557	9835	34	0	\N
148686	2134	96694103000	19557	9835	35	0	\N
148687	2134	96693100000	19557	9835	36	0	\N
148688	2134	96692097000	19557	9835	37	0	\N
148693	1397	1324338568000	19559	9850	0	0	\N
148694	2134	96691094000	19559	9850	1	0	\N
148711	1397	1324278562000	19565	9856	0	0	\N
148712	2134	96685076000	19565	9856	1	0	\N
148713	2132	148325326000	19565	9856	2	0	\N
148718	1397	1324268561000	19567	9857	0	0	\N
148719	2134	96684073000	19567	9857	1	0	\N
148720	2133	97110228000	19567	9857	2	0	\N
148721	391	66612338193897	19568	9790	0	0	\N
148722	1397	1325138648000	19568	9790	1	0	\N
148723	1447	15993600943000	19568	9790	2	0	\N
148724	1397	1325128647000	19568	9790	3	0	\N
148725	266	66000918193897	19568	9790	4	0	\N
148726	1397	1325118646000	19568	9790	5	0	\N
148727	2211	718023000000	19568	9790	6	0	\N
148728	1397	1325108645000	19568	9790	7	0	\N
148729	1397	1325098644000	19568	9790	8	0	\N
148730	1397	1325088643000	19568	9790	9	0	\N
148731	1397	1325078642000	19568	9790	10	0	\N
148732	1397	1325068641000	19568	9790	11	0	\N
148733	1397	1325058640000	19568	9790	12	0	\N
148734	1397	1325048639000	19568	9790	13	0	\N
148735	1397	1325038638000	19568	9790	14	0	\N
148736	1397	1325028637000	19568	9790	15	0	\N
148737	1397	1325018636000	19568	9790	16	0	\N
148738	1397	1325008635000	19568	9790	17	0	\N
148739	1397	1324998634000	19568	9790	18	0	\N
148740	1397	1324988633000	19568	9790	19	0	\N
148741	1397	1324978632000	19568	9790	20	0	\N
148742	1397	1324968631000	19568	9790	21	0	\N
148743	1397	1324958630000	19568	9790	22	0	\N
148744	1397	1324948629000	19568	9790	23	0	\N
148745	1397	1324938628000	19568	9790	24	0	\N
148746	1397	1324928627000	19568	9790	25	0	\N
148747	1397	1324918626000	19568	9790	26	0	\N
148748	1397	1324908625000	19568	9790	27	0	\N
148749	1397	1324898624000	19568	9790	28	0	\N
148750	1397	1324888623000	19568	9790	29	0	\N
148751	1397	1324878622000	19568	9790	30	0	\N
148752	1397	1324868621000	19568	9790	31	0	\N
148753	1397	1324858620000	19568	9790	32	0	\N
148754	1397	1324848619000	19568	9790	33	0	\N
148755	1397	1324838618000	19568	9790	34	0	\N
148756	1397	1324828617000	19568	9790	35	0	\N
148757	1397	1324818616000	19568	9790	36	0	\N
148758	1397	1324808615000	19568	9790	37	0	\N
148759	1397	1324798614000	19568	9790	38	0	\N
148760	1397	1324788613000	19568	9790	39	0	\N
148761	1397	1324778612000	19568	9790	40	0	\N
148762	1397	1324768611000	19568	9790	41	0	\N
148763	1397	1324758610000	19568	9790	42	0	\N
148764	1397	1324748609000	19568	9790	43	0	\N
148765	1397	1324738608000	19568	9790	44	0	\N
148766	1397	1324728607000	19568	9790	45	0	\N
148767	1397	1324718606000	19568	9790	46	0	\N
148768	1397	1324708605000	19568	9790	47	0	\N
148769	1397	1324698604000	19568	9790	48	0	\N
148770	1397	1324688603000	19568	9790	49	0	\N
148771	1397	1324678602000	19568	9790	50	0	\N
148772	1397	1324668601000	19568	9790	51	0	\N
148773	1397	1324658600000	19568	9790	52	0	\N
148774	1397	1324648599000	19568	9790	53	0	\N
148775	1397	1324638598000	19568	9790	54	0	\N
148776	1397	1324628597000	19568	9790	55	0	\N
148777	1397	1324618596000	19568	9790	56	0	\N
148778	1397	1324608595000	19568	9790	57	0	\N
148779	1397	1324598594000	19568	9790	58	0	\N
148780	1397	1324588593000	19568	9790	59	0	\N
148781	1397	1324578592000	19568	9790	60	0	\N
148782	1397	1324568591000	19568	9790	61	0	\N
148783	1397	1324558590000	19568	9790	62	0	\N
148784	1397	1324548589000	19568	9790	63	0	\N
148691	2133	97118244000	19558	9850	2	0	1878
148692	2133	97117242000	19558	9850	3	0	1879
148695	1397	1324328567000	19560	9851	0	0	11450
148696	2134	96690091000	19560	9851	1	0	2303
148697	1397	1324318566000	19561	9852	0	0	11451
148699	2133	97116240000	19561	9852	2	0	1880
148700	2133	97115238000	19561	9852	3	0	1881
148701	1397	1324308565000	19562	9853	0	0	11452
148702	2134	96688085000	19562	9853	1	0	2305
148703	2133	97114236000	19562	9853	2	0	1882
148705	1397	1324298564000	19563	9854	0	0	11453
148706	2133	97113234000	19563	9854	1	0	1883
148707	2134	96687082000	19563	9854	2	0	2306
148708	1397	1324288563000	19564	9855	0	0	11454
148710	2133	97112232000	19564	9855	2	0	1884
148714	1397	1324278562000	19566	9856	0	0	11455
148715	2134	96685076000	19566	9856	1	0	2308
148716	2133	97111230000	19566	9856	2	0	1885
148717	2132	148325326000	19566	9856	3	0	674
148785	1397	1324538588000	19568	9790	64	0	\N
148786	1397	1324528587000	19568	9790	65	0	\N
148787	1397	1324518586000	19568	9790	66	0	\N
148788	1397	1324508585000	19568	9790	67	0	\N
148789	1397	1324498584000	19568	9790	68	0	\N
148790	1397	1324488583000	19568	9790	69	0	\N
148791	1397	1324478582000	19568	9790	70	0	\N
148792	1397	1324468581000	19568	9790	71	0	\N
148793	1397	1324458580000	19568	9790	72	0	\N
148794	1397	1324448579000	19568	9790	73	0	\N
148795	1397	1324438578000	19568	9790	74	0	\N
148796	1397	1324428577000	19568	9790	75	0	\N
148797	1397	1324418576000	19568	9790	76	0	\N
148798	1397	1324408575000	19568	9790	77	0	\N
148799	1397	1324398574000	19568	9790	78	0	\N
148800	1397	1324388573000	19568	9790	79	0	\N
148801	1397	1324378572000	19568	9790	80	0	\N
148802	1397	1324368571000	19568	9790	81	0	\N
148803	1397	1324358570000	19568	9790	82	0	\N
148804	1397	1324348569000	19568	9790	83	0	\N
148805	1397	1324338568000	19568	9790	84	0	\N
148806	1397	1324328567000	19568	9790	85	0	\N
148807	1397	1324318566000	19568	9790	87	0	\N
148808	1397	1324308565000	19568	9790	88	0	\N
148809	1397	1324298564000	19568	9790	89	0	\N
148810	1397	1324288563000	19568	9790	90	0	\N
148811	1397	1324278562000	19568	9790	91	0	\N
148812	1397	1324268561000	19568	9790	92	0	\N
148813	1444	20012358159999	19568	9790	93	0	\N
148814	2134	96770331000	19568	9790	94	0	\N
148815	2133	97198404000	19568	9790	95	0	\N
148816	2211	717022000000	19568	9790	96	0	\N
148817	2211	1021000000	19568	9790	97	0	\N
148818	2211	920000000	19568	9790	98	0	\N
148819	2132	148351352000	19568	9790	99	0	\N
148820	2132	148350351000	19568	9790	100	0	\N
148821	2132	148349350000	19568	9790	101	0	\N
148822	2132	148348349000	19568	9790	102	0	\N
148823	2132	148347348000	19568	9790	103	0	\N
148824	2132	148346347000	19568	9790	104	0	\N
148825	1726	66153112000	19568	9790	105	0	\N
148826	1726	64952112000	19568	9790	106	0	\N
148827	1726	63751112000	19568	9790	107	0	\N
148828	1726	62550112000	19568	9790	108	0	\N
148829	1726	61349112000	19568	9790	109	0	\N
148830	1444	17512357159999	19568	9790	110	0	\N
148831	2134	96769328000	19568	9790	111	0	\N
148832	2134	96768325000	19568	9790	112	0	\N
148833	2134	96767322000	19568	9790	113	0	\N
148834	1726	60148112000	19568	9790	114	0	\N
148835	2133	97197402000	19568	9790	115	0	\N
148836	2133	97196400000	19568	9790	116	0	\N
148837	2134	96766319000	19568	9790	117	0	\N
148838	2134	96765316000	19568	9790	118	0	\N
148839	2134	96764313000	19568	9790	119	0	\N
148840	2134	96763310000	19568	9790	120	0	\N
148841	2134	96762307000	19568	9790	121	0	\N
148842	2134	96761304000	19568	9790	122	0	\N
148843	2133	97195398000	19568	9790	123	0	\N
148844	2133	97194396000	19568	9790	124	0	\N
148845	2133	97193394000	19568	9790	125	0	\N
148849	2133	97110228000	19570	9857	0	0	\N
148850	1397	1324268561000	19571	9858	0	0	\N
148851	1397	1324258560000	19571	9858	1	0	\N
148852	2134	96684073000	19571	9858	2	0	\N
148853	2133	97109226000	19571	9858	3	0	\N
148854	1397	1324268561000	19572	9858	0	0	\N
148855	1397	1324258560000	19572	9858	1	0	\N
148856	2134	96684073000	19572	9858	2	0	\N
148857	2133	97109226000	19572	9858	3	0	\N
148858	1397	1324258560000	19573	9858	0	0	\N
148859	2133	97109226000	19573	9858	1	0	\N
148879	2134	96678055000	19579	9863	0	0	\N
148885	1397	1324198554000	19582	9864	0	0	\N
148886	2133	97102212000	19582	9864	1	0	\N
148887	2134	96677052000	19582	9864	2	0	\N
148888	1397	1324188553000	19583	9865	0	0	\N
148889	2132	148322323000	19583	9865	1	0	\N
148890	2133	97101210000	19583	9865	2	0	\N
148891	2134	96676049000	19583	9865	3	0	\N
148896	1397	1324188553000	19585	9865	0	0	\N
148897	2132	148322323000	19585	9865	1	0	\N
148898	2133	97101210000	19585	9865	2	0	\N
148899	2134	96676049000	19585	9865	3	0	\N
148903	1397	1324178552000	19587	9866	0	0	\N
148904	2134	96675046000	19587	9866	1	0	\N
148905	2133	97100208000	19587	9866	2	0	\N
148906	1397	1324178552000	19588	9866	0	0	\N
148907	2134	96675046000	19588	9866	1	0	\N
148908	2133	97100208000	19588	9866	2	0	\N
148909	1397	1324178552000	19590	9866	0	0	\N
148910	2134	96675046000	19590	9866	1	0	\N
148911	2133	97100208000	19590	9866	2	0	\N
148915	1397	1324168551000	19592	9867	0	0	\N
148916	2133	97099206000	19592	9867	1	0	\N
148917	2134	96674043000	19592	9867	2	0	\N
148918	1397	1324168551000	19594	9867	0	0	\N
148919	2133	97099206000	19594	9867	1	0	\N
148920	2134	96674043000	19594	9867	2	0	\N
148848	2133	97110228000	19569	9857	2	0	1886
148860	2133	97109226000	19574	9858	0	0	1887
148861	1397	1324258560000	19575	9859	0	0	11457
148862	1397	1324248559000	19575	9859	1	0	11458
148863	2133	97108224000	19575	9859	2	0	1888
148865	1397	1324238558000	19576	9860	0	0	11459
148866	2132	148324325000	19576	9860	1	0	675
148867	2133	97107222000	19576	9860	2	0	1889
148868	2134	96682067000	19576	9860	3	0	2311
148869	1397	1324228557000	19577	9861	0	0	11460
148871	2134	96681064000	19577	9861	2	0	2312
148872	2134	96680061000	19577	9861	3	0	2313
148873	1397	1324208555000	19578	9862	0	0	11462
148874	2134	96679058000	19578	9862	1	0	2314
148876	2133	97106220000	19578	9862	3	0	1890
148877	2133	97105218000	19578	9862	5	0	1891
148878	2133	97104216000	19578	9862	6	0	1892
148880	2133	97103214000	19580	9863	0	0	1893
148881	2134	96678055000	19580	9863	1	0	2315
148883	2133	97102212000	19581	9864	1	0	1894
148884	2134	96677052000	19581	9864	2	0	2316
148892	1397	1324188553000	19584	9865	0	0	11464
148893	2132	148322323000	19584	9865	1	0	677
148894	2133	97101210000	19584	9865	2	0	1895
148900	1397	1324178552000	19586	9866	0	0	11465
148901	2134	96675046000	19586	9866	1	0	2318
148902	2133	97100208000	19586	9866	2	0	1896
148912	1397	1324168551000	19591	9867	0	0	11466
148914	2134	96674043000	19591	9867	2	0	2319
148941	1397	1324108545000	19599	9871	0	0	\N
148942	2133	97093194000	19599	9871	1	0	\N
148943	2134	96668025000	19599	9871	2	0	\N
148944	1397	1324098544000	19600	9872	0	0	\N
148945	1397	1324088543000	19600	9872	1	0	\N
148946	2132	148319320000	19600	9872	2	0	\N
148947	2134	96667022000	19600	9872	3	0	\N
148948	2134	96666019000	19600	9872	4	0	\N
148949	2133	97092192000	19600	9872	5	0	\N
148950	2133	97091190000	19600	9872	6	0	\N
148964	1397	1324058540000	19604	9875	0	0	\N
148965	2134	96663010000	19604	9875	1	0	\N
148966	2133	97088184000	19604	9875	2	0	\N
148970	1397	1324058540000	19606	9875	0	0	\N
148971	2134	96663010000	19606	9875	1	0	\N
148972	2133	97088184000	19606	9875	2	0	\N
148973	391	66612338193897	19607	9772	0	0	\N
148974	1447	15993600943000	19607	9772	1	0	\N
148975	266	66000918193897	19607	9772	2	0	\N
148976	2211	718023000000	19607	9772	3	0	\N
148977	1444	20012358159999	19607	9772	4	0	\N
148978	2211	717022000000	19607	9772	5	0	\N
148979	2211	1021000000	19607	9772	6	0	\N
148980	2211	920000000	19607	9772	7	0	\N
148981	1444	17512357159999	19607	9772	8	0	\N
148982	1504	657246000000	19607	9772	9	0	\N
148983	1504	157245000000	19607	9772	10	0	\N
148991	391	66612338193897	19609	9770	0	0	\N
148992	1447	15993600943000	19609	9770	1	0	\N
148993	417	66000000000000	19609	9770	2	0	\N
148994	266	66000918193897	19609	9770	3	0	\N
148995	2211	718023000000	19609	9770	4	0	\N
148996	1726	67354112000	19609	9770	5	0	\N
148997	1444	20012358159999	19609	9770	6	0	\N
148998	2211	717022000000	19609	9770	7	0	\N
148999	2211	1021000000	19609	9770	8	0	\N
149000	2211	920000000	19609	9770	9	0	\N
149001	1726	66153112000	19609	9770	10	0	\N
149002	1726	64952112000	19609	9770	11	0	\N
149003	1726	63751112000	19609	9770	12	0	\N
149004	1726	62550112000	19609	9770	13	0	\N
149005	1726	61349112000	19609	9770	14	0	\N
149006	1444	17512357159999	19609	9770	15	0	\N
149007	1726	60148112000	19609	9770	16	0	\N
149008	1504	657246000000	19609	9770	17	0	\N
149009	1504	157245000000	19609	9770	18	0	\N
149020	1397	1323998534000	19612	9879	0	0	\N
149021	1397	1323988533000	19612	9879	1	0	\N
149022	2134	96656992000	19612	9879	2	0	\N
149023	2132	148316317000	19612	9879	3	0	\N
149024	2134	96655989000	19612	9879	4	0	\N
149025	2133	97082172000	19612	9879	5	0	\N
149026	2133	97081170000	19612	9879	6	0	\N
149043	1397	1323978532000	19615	9880	0	0	\N
149044	1397	1323968531000	19615	9880	1	0	\N
149045	1397	1323958530000	19615	9880	2	0	\N
149046	2133	97080168000	19615	9880	3	0	\N
149047	2134	96654986000	19615	9880	4	0	\N
149048	2134	96653983000	19615	9880	5	0	\N
149049	2134	96652980000	19615	9880	6	0	\N
149050	2133	97079166000	19615	9880	7	0	\N
149051	2133	97078164000	19615	9880	8	0	\N
149052	1397	1323978532000	19616	9880	0	0	\N
149053	1397	1323968531000	19616	9880	1	0	\N
149054	1397	1323958530000	19616	9880	2	0	\N
149055	2133	97080168000	19616	9880	3	0	\N
149056	2134	96654986000	19616	9880	4	0	\N
148923	2133	97098204000	19595	9868	2	0	1898
148924	1397	1324148549000	19596	9869	0	0	11468
148925	2134	96672037000	19596	9869	1	0	2321
148926	2132	148321322000	19596	9869	2	0	678
148927	2133	97097202000	19596	9869	3	0	1899
148929	1397	1324128547000	19597	9870	1	0	11470
148930	1397	1324118546000	19597	9870	2	0	11471
148931	2133	97096200000	19597	9870	3	0	1900
148932	2132	148320321000	19597	9870	4	0	679
148933	2134	96671034000	19597	9870	5	0	2322
148935	2134	96669028000	19597	9870	7	0	2324
148936	2133	97095198000	19597	9870	8	0	1901
148937	2133	97094196000	19597	9870	9	0	1902
148938	1397	1324108545000	19598	9871	0	0	11472
148940	2134	96668025000	19598	9871	2	0	2325
148951	1397	1324098544000	19601	9872	0	0	11473
148952	1397	1324088543000	19601	9872	1	0	11474
148953	2132	148319320000	19601	9872	2	0	680
148954	2134	96667022000	19601	9872	3	0	2326
148956	2133	97092192000	19601	9872	5	0	1904
148957	2133	97091190000	19601	9872	6	0	1905
148958	1397	1324078542000	19602	9873	0	0	11475
148959	2134	96665016000	19602	9873	1	0	2328
148960	2133	97090188000	19602	9873	2	0	1906
148962	2133	97089186000	19603	9874	1	0	1907
148963	2134	96664013000	19603	9874	2	0	2329
148967	1397	1324058540000	19605	9875	0	0	11477
148968	2134	96663010000	19605	9875	1	0	2330
148984	1397	1324048539000	19608	9876	0	0	11478
148985	1397	1324038538000	19608	9876	1	0	11479
148986	2132	148318319000	19608	9876	2	0	681
148987	2134	96662007000	19608	9876	3	0	2331
148988	2134	96661004000	19608	9876	4	0	2332
148990	2133	97086180000	19608	9876	6	0	1910
149010	1397	1324028537000	19610	9877	0	0	11480
149011	2134	96660001000	19610	9877	1	0	2333
149012	2133	97085178000	19610	9877	2	0	1911
149013	1397	1324018536000	19611	9878	0	0	11481
149015	2134	96658998000	19611	9878	2	0	2334
149016	2133	97084176000	19611	9878	3	0	1912
149017	2134	96657995000	19611	9878	4	0	2335
149018	2133	97083174000	19611	9878	5	0	1913
149027	1397	1323998534000	19613	9879	0	0	11483
149028	1397	1323988533000	19613	9879	1	0	11484
149029	2134	96656992000	19613	9879	2	0	2336
149030	2132	148316317000	19613	9879	3	0	683
149031	2134	96655989000	19613	9879	4	0	2337
149033	2133	97081170000	19613	9879	6	0	1915
149034	1397	1323978532000	19614	9880	0	0	11485
149035	1397	1323968531000	19614	9880	1	0	11486
149036	1397	1323958530000	19614	9880	2	0	11487
149037	2133	97080168000	19614	9880	3	0	1916
149039	2134	96653983000	19614	9880	5	0	2339
149040	2134	96652980000	19614	9880	6	0	2340
149041	2133	97079166000	19614	9880	7	0	1917
149042	2133	97078164000	19614	9880	8	0	1918
149057	2134	96653983000	19616	9880	5	0	\N
149058	2134	96652980000	19616	9880	6	0	\N
149059	2133	97079166000	19616	9880	7	0	\N
149060	2133	97078164000	19616	9880	8	0	\N
149070	1397	1323948529000	19618	9881	0	0	\N
149071	1397	1323938528000	19618	9881	1	0	\N
149072	1397	1323928527000	19618	9881	2	0	\N
149073	2133	97077162000	19618	9881	4	0	\N
149074	2133	97076160000	19618	9881	5	0	\N
149075	2134	96651977000	19618	9881	6	0	\N
149076	2134	96650974000	19618	9881	7	0	\N
149077	2132	148315316000	19618	9881	8	0	\N
149078	2133	97075158000	19618	9881	9	0	\N
149079	1397	1323948529000	19619	9881	0	0	\N
149080	1397	1323938528000	19619	9881	1	0	\N
149081	1397	1323928527000	19619	9881	2	0	\N
149082	2133	97077162000	19619	9881	4	0	\N
149083	2133	97076160000	19619	9881	5	0	\N
149084	2134	96651977000	19619	9881	6	0	\N
149085	2134	96650974000	19619	9881	7	0	\N
149086	2132	148315316000	19619	9881	8	0	\N
149087	2133	97075158000	19619	9881	9	0	\N
149088	1397	1324338568000	19620	9836	0	0	\N
149089	1397	1324328567000	19620	9836	1	0	\N
149090	1397	1324318566000	19620	9836	2	0	\N
149091	1397	1324308565000	19620	9836	3	0	\N
149092	1397	1324298564000	19620	9836	4	0	\N
149093	1397	1324288563000	19620	9836	5	0	\N
149094	1397	1324278562000	19620	9836	6	0	\N
149095	1397	1324268561000	19620	9836	7	0	\N
149096	1397	1324258560000	19620	9836	8	0	\N
149097	1397	1324248559000	19620	9836	9	0	\N
149098	1397	1324238558000	19620	9836	10	0	\N
149099	1397	1324228557000	19620	9836	11	0	\N
149100	1397	1324218556000	19620	9836	12	0	\N
149101	1397	1324208555000	19620	9836	13	0	\N
149102	1397	1324198554000	19620	9836	14	0	\N
149103	1397	1324188553000	19620	9836	15	0	\N
149104	1397	1324178552000	19620	9836	16	0	\N
149105	1397	1324168551000	19620	9836	17	0	\N
149106	1397	1324158550000	19620	9836	18	0	\N
149107	1397	1324148549000	19620	9836	19	0	\N
149108	1397	1324138548000	19620	9836	20	0	\N
149109	1397	1324128547000	19620	9836	21	0	\N
149110	1397	1324118546000	19620	9836	22	0	\N
149111	1397	1324108545000	19620	9836	23	0	\N
149112	1397	1324098544000	19620	9836	24	0	\N
149113	1397	1324088543000	19620	9836	25	0	\N
149114	1397	1324078542000	19620	9836	26	0	\N
149115	1397	1324068541000	19620	9836	27	0	\N
149116	1397	1324058540000	19620	9836	28	0	\N
149117	1397	1324048539000	19620	9836	29	0	\N
149118	1397	1324038538000	19620	9836	30	0	\N
149119	1397	1324028537000	19620	9836	31	0	\N
149120	1397	1324018536000	19620	9836	32	0	\N
149121	1397	1324008535000	19620	9836	33	0	\N
149122	1397	1323998534000	19620	9836	34	0	\N
149123	1397	1323988533000	19620	9836	35	0	\N
149124	1397	1323978532000	19620	9836	36	0	\N
149125	1397	1323968531000	19620	9836	37	0	\N
149126	1397	1323958530000	19620	9836	38	0	\N
149127	1397	1323948529000	19620	9836	39	0	\N
149128	1397	1323938528000	19620	9836	40	0	\N
149129	1397	1323928527000	19620	9836	41	0	\N
149130	2134	96691094000	19620	9836	42	0	\N
149131	2134	96690091000	19620	9836	43	0	\N
149132	2134	96689088000	19620	9836	44	0	\N
149133	2134	96688085000	19620	9836	45	0	\N
149134	2133	97117242000	19620	9836	46	0	\N
149135	2134	96687082000	19620	9836	47	0	\N
149136	2134	96686079000	19620	9836	48	0	\N
149137	2134	96685076000	19620	9836	49	0	\N
149138	2134	96684073000	19620	9836	50	0	\N
149139	2134	96683070000	19620	9836	51	0	\N
149140	2133	97116240000	19620	9836	52	0	\N
149141	2133	97115238000	19620	9836	53	0	\N
149142	2133	97114236000	19620	9836	54	0	\N
149143	2133	97113234000	19620	9836	55	0	\N
149144	2134	96682067000	19620	9836	56	0	\N
149145	2134	96681064000	19620	9836	57	0	\N
149146	2134	96680061000	19620	9836	58	0	\N
149147	2134	96679058000	19620	9836	59	0	\N
149148	2134	96678055000	19620	9836	60	0	\N
149149	2132	148326327000	19620	9836	61	0	\N
149150	2132	148325326000	19620	9836	62	0	\N
149151	2132	148324325000	19620	9836	63	0	\N
149152	2132	148323324000	19620	9836	64	0	\N
149153	2132	148322323000	19620	9836	65	0	\N
149154	2132	148321322000	19620	9836	66	0	\N
149155	2132	148320321000	19620	9836	67	0	\N
149156	2132	148319320000	19620	9836	68	0	\N
149157	2132	148318319000	19620	9836	69	0	\N
149158	2134	96677052000	19620	9836	70	0	\N
149159	2134	96676049000	19620	9836	71	0	\N
149160	2134	96675046000	19620	9836	72	0	\N
149161	2134	96674043000	19620	9836	73	0	\N
149162	2134	96673040000	19620	9836	74	0	\N
149163	2134	96672037000	19620	9836	75	0	\N
149164	2134	96671034000	19620	9836	76	0	\N
149165	2134	96670031000	19620	9836	77	0	\N
149166	2134	96669028000	19620	9836	78	0	\N
149167	2134	96668025000	19620	9836	79	0	\N
149168	2134	96667022000	19620	9836	80	0	\N
149169	2134	96666019000	19620	9836	81	0	\N
149170	2134	96665016000	19620	9836	82	0	\N
149171	2134	96664013000	19620	9836	83	0	\N
149172	2134	96663010000	19620	9836	84	0	\N
149173	2134	96662007000	19620	9836	85	0	\N
149174	2134	96661004000	19620	9836	86	0	\N
149175	2134	96660001000	19620	9836	87	0	\N
149176	2134	96658998000	19620	9836	88	0	\N
149177	2134	96657995000	19620	9836	89	0	\N
149178	2134	96656992000	19620	9836	90	0	\N
149179	2134	96655989000	19620	9836	91	0	\N
149180	2134	96654986000	19620	9836	92	0	\N
149181	2134	96653983000	19620	9836	93	0	\N
149182	2134	96652980000	19620	9836	94	0	\N
149183	2134	96651977000	19620	9836	96	0	\N
149184	2134	96650974000	19620	9836	97	0	\N
149185	2132	148317318000	19620	9836	98	0	\N
149186	2132	148316317000	19620	9836	99	0	\N
149187	2132	148315316000	19620	9836	100	0	\N
149188	2133	97112232000	19620	9836	101	0	\N
149189	2133	97111230000	19620	9836	102	0	\N
149190	2133	97110228000	19620	9836	103	0	\N
149191	2133	97109226000	19620	9836	104	0	\N
149192	2133	97108224000	19620	9836	105	0	\N
149063	1397	1323928527000	19617	9881	2	0	11490
149064	2133	97077162000	19617	9881	4	0	1919
149065	2133	97076160000	19617	9881	5	0	1920
149066	2134	96651977000	19617	9881	6	0	2341
149067	2134	96650974000	19617	9881	7	0	2342
149069	2133	97075158000	19617	9881	9	0	1921
149193	2133	97107222000	19620	9836	106	0	\N
149194	2133	97106220000	19620	9836	107	0	\N
149195	2133	97105218000	19620	9836	108	0	\N
149196	2133	97104216000	19620	9836	109	0	\N
149197	2133	97103214000	19620	9836	110	0	\N
149198	2133	97102212000	19620	9836	111	0	\N
149199	2133	97101210000	19620	9836	112	0	\N
149200	2133	97100208000	19620	9836	113	0	\N
149201	2133	97099206000	19620	9836	114	0	\N
149202	2133	97098204000	19620	9836	115	0	\N
149203	2133	97097202000	19620	9836	116	0	\N
149204	2133	97096200000	19620	9836	117	0	\N
149205	2133	97095198000	19620	9836	118	0	\N
149206	2133	97094196000	19620	9836	119	0	\N
149207	2133	97093194000	19620	9836	120	0	\N
149208	2133	97092192000	19620	9836	121	0	\N
149209	2133	97091190000	19620	9836	122	0	\N
149210	2133	97090188000	19620	9836	123	0	\N
149211	2133	97089186000	19620	9836	124	0	\N
149212	2133	97088184000	19620	9836	125	0	\N
149220	1397	1323918526000	19622	9882	0	0	\N
149221	1397	1323908525000	19622	9882	1	0	\N
149222	2134	96649971000	19622	9882	2	0	\N
149223	2134	96648968000	19622	9882	3	0	\N
149224	2133	97074156000	19622	9882	4	0	\N
149225	2133	97073154000	19622	9882	5	0	\N
149226	2132	148314315000	19622	9882	6	0	\N
149250	1397	1323868521000	19626	9885	0	0	\N
149251	1397	1323858520000	19626	9885	1	0	\N
149252	1397	1323848519000	19626	9885	2	0	\N
149253	1397	1323838518000	19626	9885	3	0	\N
149254	2132	148312313000	19626	9885	4	0	\N
149255	2133	97069146000	19626	9885	5	0	\N
149256	2133	97068144000	19626	9885	6	0	\N
149257	2133	97067142000	19626	9885	7	0	\N
149258	2133	97066140000	19626	9885	8	0	\N
149259	2134	96644956000	19626	9885	9	0	\N
149260	2134	96643953000	19626	9885	10	0	\N
149261	2134	96642950000	19626	9885	11	0	\N
149262	2134	96641947000	19626	9885	12	0	\N
149263	1397	1323868521000	19627	9885	0	0	\N
149264	1397	1323858520000	19627	9885	1	0	\N
149265	1397	1323848519000	19627	9885	2	0	\N
149266	1397	1323838518000	19627	9885	3	0	\N
149267	2132	148312313000	19627	9885	4	0	\N
149268	2133	97069146000	19627	9885	5	0	\N
149269	2133	97068144000	19627	9885	6	0	\N
149270	2133	97067142000	19627	9885	7	0	\N
149271	2133	97066140000	19627	9885	8	0	\N
149272	2134	96644956000	19627	9885	9	0	\N
149273	2134	96643953000	19627	9885	10	0	\N
149274	2134	96642950000	19627	9885	11	0	\N
149275	2134	96641947000	19627	9885	12	0	\N
149289	1397	1323788513000	19631	9889	0	0	\N
149290	1397	1323778512000	19631	9889	1	0	\N
149291	2134	96636932000	19631	9889	2	0	\N
149292	2134	96635929000	19631	9889	3	0	\N
149293	2133	97061130000	19631	9889	4	0	\N
149294	2133	97060128000	19631	9889	5	0	\N
149295	2132	148310311000	19631	9889	6	0	\N
149303	1397	1323978532000	19633	9880	0	0	\N
149304	1397	1323968531000	19633	9880	1	0	\N
149305	1397	1323958530000	19633	9880	2	0	\N
149306	1397	1323948529000	19633	9880	3	0	\N
149307	1397	1323938528000	19633	9880	4	0	\N
149308	1397	1323928527000	19633	9880	5	0	\N
149309	1397	1323918526000	19633	9880	6	0	\N
149310	1397	1323908525000	19633	9880	7	0	\N
149311	1397	1323898524000	19633	9880	8	0	\N
149312	1397	1323888523000	19633	9880	9	0	\N
149313	1397	1323878522000	19633	9880	10	0	\N
149314	1397	1323868521000	19633	9880	11	0	\N
149315	1397	1323858520000	19633	9880	12	0	\N
149316	1397	1323848519000	19633	9880	13	0	\N
149317	1397	1323838518000	19633	9880	15	0	\N
149318	1397	1323828517000	19633	9880	16	0	\N
149319	1397	1323818516000	19633	9880	17	0	\N
149320	1397	1323808515000	19633	9880	18	0	\N
149321	1397	1323798514000	19633	9880	19	0	\N
149322	1397	1323788513000	19633	9880	20	0	\N
149323	1397	1323778512000	19633	9880	21	0	\N
149324	2133	97080168000	19633	9880	22	0	\N
149325	2134	96654986000	19633	9880	23	0	\N
149326	2134	96653983000	19633	9880	24	0	\N
149327	2134	96652980000	19633	9880	25	0	\N
149328	2134	96651977000	19633	9880	26	0	\N
149215	2134	96649971000	19621	9882	2	0	2343
149216	2134	96648968000	19621	9882	3	0	2344
149217	2133	97074156000	19621	9882	4	0	1922
149218	2133	97073154000	19621	9882	5	0	1923
149219	2132	148314315000	19621	9882	6	0	685
149228	2134	96647965000	19623	9883	1	0	2345
149229	2133	97072152000	19623	9883	2	0	1924
149230	1397	1323888523000	19624	9884	0	0	11494
149231	1397	1323878522000	19624	9884	1	0	11495
149232	2133	97071150000	19624	9884	2	0	1925
149234	2134	96646962000	19624	9884	4	0	2346
149235	2134	96645959000	19624	9884	5	0	2347
149236	2132	148313314000	19624	9884	6	0	686
149237	1397	1323868521000	19625	9885	0	0	11496
149239	1397	1323848519000	19625	9885	2	0	11498
149240	1397	1323838518000	19625	9885	3	0	11499
149241	2132	148312313000	19625	9885	4	0	687
149242	2133	97069146000	19625	9885	5	0	1927
149243	2133	97068144000	19625	9885	6	0	1928
149245	2133	97066140000	19625	9885	8	0	1930
149246	2134	96644956000	19625	9885	9	0	2348
149247	2134	96643953000	19625	9885	10	0	2349
149248	2134	96642950000	19625	9885	11	0	2350
149249	2134	96641947000	19625	9885	12	0	2351
149277	1397	1323818516000	19628	9886	1	0	11501
149278	2132	148311312000	19628	9886	2	0	688
149279	2134	96640944000	19628	9886	3	0	2352
149280	2133	97065138000	19628	9886	4	0	1931
149282	2134	96639941000	19628	9886	6	0	2353
149283	1397	1323808515000	19629	9887	0	0	11502
149284	2133	97063134000	19629	9887	1	0	1933
149285	2134	96638938000	19629	9887	2	0	2354
149286	1397	1323798514000	19630	9888	0	0	11503
149288	2133	97062132000	19630	9888	2	0	1934
149296	1397	1323788513000	19632	9889	0	0	11504
149297	1397	1323778512000	19632	9889	1	0	11505
149298	2134	96636932000	19632	9889	2	0	2356
149299	2134	96635929000	19632	9889	3	0	2357
149301	2133	97060128000	19632	9889	5	0	1936
149302	2132	148310311000	19632	9889	6	0	689
149329	2134	96650974000	19633	9880	27	0	\N
149330	2134	96649971000	19633	9880	28	0	\N
149331	2134	96648968000	19633	9880	29	0	\N
149332	2134	96647965000	19633	9880	30	0	\N
149333	2134	96646962000	19633	9880	31	0	\N
149334	2134	96645959000	19633	9880	32	0	\N
149335	2132	148315316000	19633	9880	33	0	\N
149336	2134	96644956000	19633	9880	34	0	\N
149337	2134	96643953000	19633	9880	35	0	\N
149338	2134	96642950000	19633	9880	36	0	\N
149339	2134	96641947000	19633	9880	37	0	\N
149340	2134	96640944000	19633	9880	38	0	\N
149341	2134	96639941000	19633	9880	39	0	\N
149342	2134	96638938000	19633	9880	40	0	\N
149343	2134	96637935000	19633	9880	41	0	\N
149344	2134	96636932000	19633	9880	42	0	\N
149345	2134	96635929000	19633	9880	43	0	\N
149346	2133	97079166000	19633	9880	44	0	\N
149347	2133	97078164000	19633	9880	45	0	\N
149348	2133	97077162000	19633	9880	46	0	\N
149349	2133	97076160000	19633	9880	47	0	\N
149350	2133	97075158000	19633	9880	48	0	\N
149351	2133	97074156000	19633	9880	49	0	\N
149352	2133	97073154000	19633	9880	50	0	\N
149353	2133	97072152000	19633	9880	51	0	\N
149354	2133	97071150000	19633	9880	52	0	\N
149355	2133	97070148000	19633	9880	53	0	\N
149356	2133	97069146000	19633	9880	54	0	\N
149357	2133	97068144000	19633	9880	55	0	\N
149358	2133	97067142000	19633	9880	56	0	\N
149359	2133	97066140000	19633	9880	57	0	\N
149360	2133	97065138000	19633	9880	58	0	\N
149361	2133	97064136000	19633	9880	59	0	\N
149362	2133	97063134000	19633	9880	60	0	\N
149363	2133	97062132000	19633	9880	61	0	\N
149364	2133	97061130000	19633	9880	62	0	\N
149365	2133	97060128000	19633	9880	63	0	\N
149366	2132	148314315000	19633	9880	64	0	\N
149367	2132	148313314000	19633	9880	65	0	\N
149368	2132	148312313000	19633	9880	66	0	\N
149369	2132	148311312000	19633	9880	67	0	\N
149370	2132	148310311000	19633	9880	68	0	\N
149381	1397	1323738508000	19636	9892	0	0	\N
149382	2134	96631917000	19636	9892	1	0	\N
149383	2133	97056120000	19636	9892	2	0	\N
149384	1397	1323738508000	19637	9892	0	0	\N
149385	2134	96631917000	19637	9892	1	0	\N
149386	2133	97056120000	19637	9892	2	0	\N
149387	1397	1323738508000	19638	9892	0	0	\N
149388	2134	96631917000	19638	9892	1	0	\N
149389	2133	97056120000	19638	9892	2	0	\N
149390	1397	1323738508000	19639	9892	0	0	\N
149391	2134	96631917000	19639	9892	1	0	\N
149392	2133	97056120000	19639	9892	2	0	\N
149393	1397	1323738508000	19640	9892	0	0	\N
149394	2134	96631917000	19640	9892	1	0	\N
149395	2133	97056120000	19640	9892	2	0	\N
149399	1397	1323738508000	19642	9892	0	0	\N
149400	2134	96631917000	19642	9892	1	0	\N
149401	2133	97056120000	19642	9892	2	0	\N
149402	1397	1323728507000	19643	9893	0	0	\N
149403	1397	1323718506000	19643	9893	1	0	\N
149404	2132	148308309000	19643	9893	2	0	\N
149405	2134	96630914000	19643	9893	3	0	\N
149406	2134	96629911000	19643	9893	4	0	\N
149407	2133	97055118000	19643	9893	5	0	\N
149408	2133	97054116000	19643	9893	6	0	\N
149416	1397	1323708505000	19645	9894	0	0	\N
149417	1397	1323698504000	19645	9894	1	0	\N
149418	2134	96628908000	19645	9894	2	0	\N
149419	2134	96627905000	19645	9894	3	0	\N
149420	2133	97053114000	19645	9894	4	0	\N
149421	2133	97052112000	19645	9894	5	0	\N
149428	1397	1324018536000	19647	9878	0	0	\N
149429	1397	1324008535000	19647	9878	1	0	\N
149430	1397	1323998534000	19647	9878	2	0	\N
149431	1397	1323988533000	19647	9878	3	0	\N
149432	1397	1323978532000	19647	9878	4	0	\N
149433	1397	1323968531000	19647	9878	5	0	\N
149434	1397	1323958530000	19647	9878	6	0	\N
149435	1397	1323948529000	19647	9878	7	0	\N
149436	1397	1323938528000	19647	9878	8	0	\N
149437	1397	1323928527000	19647	9878	9	0	\N
149438	1397	1323918526000	19647	9878	10	0	\N
149439	1397	1323908525000	19647	9878	11	0	\N
149440	1397	1323898524000	19647	9878	12	0	\N
149441	1397	1323888523000	19647	9878	13	0	\N
149442	1397	1323878522000	19647	9878	14	0	\N
149443	1397	1323868521000	19647	9878	15	0	\N
149444	1397	1323858520000	19647	9878	16	0	\N
149445	1397	1323848519000	19647	9878	17	0	\N
149446	1397	1323838518000	19647	9878	18	0	\N
149447	1397	1323828517000	19647	9878	19	0	\N
149448	1397	1323818516000	19647	9878	20	0	\N
149449	1397	1323808515000	19647	9878	21	0	\N
149450	1397	1323798514000	19647	9878	22	0	\N
149451	1397	1323788513000	19647	9878	23	0	\N
149452	1397	1323778512000	19647	9878	24	0	\N
149453	1397	1323768511000	19647	9878	25	0	\N
149454	1397	1323758510000	19647	9878	26	0	\N
149455	1397	1323748509000	19647	9878	27	0	\N
149456	1397	1323738508000	19647	9878	28	0	\N
149457	1397	1323728507000	19647	9878	29	0	\N
149458	1397	1323718506000	19647	9878	30	0	\N
149459	1397	1323708505000	19647	9878	31	0	\N
149460	1397	1323698504000	19647	9878	33	0	\N
149461	2134	96658998000	19647	9878	34	0	\N
149462	2133	97084176000	19647	9878	35	0	\N
149463	2134	96657995000	19647	9878	36	0	\N
149464	2134	96656992000	19647	9878	37	0	\N
149373	2134	96634926000	19634	9890	2	0	2358
149374	1397	1323758510000	19635	9891	0	0	11507
149375	1397	1323748509000	19635	9891	1	0	11508
149376	2132	148309310000	19635	9891	2	0	690
149377	2133	97058124000	19635	9891	3	0	1938
149379	2133	97057122000	19635	9891	5	0	1939
149380	2134	96632920000	19635	9891	6	0	2360
149396	1397	1323738508000	19641	9892	0	0	11509
149397	2134	96631917000	19641	9892	1	0	2361
149398	2133	97056120000	19641	9892	2	0	1940
149410	1397	1323718506000	19644	9893	1	0	11511
149411	2132	148308309000	19644	9893	2	0	691
149412	2134	96630914000	19644	9893	3	0	2362
149413	2134	96629911000	19644	9893	4	0	2363
149415	2133	97054116000	19644	9893	6	0	1942
149422	1397	1323708505000	19646	9894	0	0	11512
149423	1397	1323698504000	19646	9894	1	0	11513
149424	2134	96628908000	19646	9894	2	0	2364
149425	2134	96627905000	19646	9894	3	0	2365
149427	2133	97052112000	19646	9894	5	0	1944
149465	2134	96655989000	19647	9878	38	0	\N
149466	2134	96654986000	19647	9878	39	0	\N
149467	2133	97083174000	19647	9878	40	0	\N
149468	2134	96653983000	19647	9878	41	0	\N
149469	2134	96652980000	19647	9878	42	0	\N
149470	2134	96651977000	19647	9878	43	0	\N
149471	2134	96650974000	19647	9878	44	0	\N
149472	2134	96649971000	19647	9878	45	0	\N
149473	2134	96648968000	19647	9878	46	0	\N
149474	2134	96647965000	19647	9878	47	0	\N
149475	2134	96646962000	19647	9878	48	0	\N
149476	2134	96645959000	19647	9878	49	0	\N
149477	2133	97082172000	19647	9878	50	0	\N
149478	2134	96644956000	19647	9878	51	0	\N
149479	2134	96643953000	19647	9878	52	0	\N
149480	2134	96642950000	19647	9878	53	0	\N
149481	2134	96641947000	19647	9878	54	0	\N
149482	2134	96640944000	19647	9878	55	0	\N
149483	2134	96639941000	19647	9878	56	0	\N
149484	2133	97081170000	19647	9878	57	0	\N
149485	2133	97080168000	19647	9878	58	0	\N
149486	2134	96638938000	19647	9878	59	0	\N
149487	2134	96637935000	19647	9878	60	0	\N
149488	2134	96636932000	19647	9878	61	0	\N
149489	2134	96635929000	19647	9878	62	0	\N
149490	2134	96634926000	19647	9878	63	0	\N
149491	2134	96633923000	19647	9878	64	0	\N
149492	2132	148317318000	19647	9878	65	0	\N
149493	2132	148316317000	19647	9878	66	0	\N
149494	2132	148315316000	19647	9878	67	0	\N
149495	2134	96632920000	19647	9878	68	0	\N
149496	2134	96631917000	19647	9878	69	0	\N
149497	2134	96630914000	19647	9878	70	0	\N
149498	2134	96629911000	19647	9878	71	0	\N
149499	2134	96628908000	19647	9878	72	0	\N
149500	2134	96627905000	19647	9878	73	0	\N
149501	2133	97079166000	19647	9878	74	0	\N
149502	2133	97078164000	19647	9878	75	0	\N
149503	2133	97077162000	19647	9878	76	0	\N
149504	2133	97076160000	19647	9878	77	0	\N
149505	2133	97075158000	19647	9878	78	0	\N
149506	2133	97074156000	19647	9878	79	0	\N
149507	2133	97073154000	19647	9878	80	0	\N
149508	2133	97072152000	19647	9878	81	0	\N
149509	2133	97071150000	19647	9878	82	0	\N
149510	2133	97070148000	19647	9878	83	0	\N
149511	2133	97069146000	19647	9878	84	0	\N
149512	2133	97068144000	19647	9878	85	0	\N
149513	2133	97067142000	19647	9878	86	0	\N
149514	2133	97066140000	19647	9878	87	0	\N
149515	2133	97065138000	19647	9878	88	0	\N
149516	2133	97064136000	19647	9878	89	0	\N
149517	2133	97063134000	19647	9878	90	0	\N
149518	2133	97062132000	19647	9878	91	0	\N
149519	2133	97061130000	19647	9878	92	0	\N
149520	2133	97060128000	19647	9878	93	0	\N
149521	2133	97059126000	19647	9878	94	0	\N
149522	2133	97058124000	19647	9878	95	0	\N
149523	2133	97057122000	19647	9878	96	0	\N
149524	2133	97056120000	19647	9878	97	0	\N
149525	2133	97055118000	19647	9878	98	0	\N
149526	2133	97054116000	19647	9878	99	0	\N
149527	2133	97053114000	19647	9878	100	0	\N
149528	2133	97052112000	19647	9878	101	0	\N
149529	2132	148314315000	19647	9878	102	0	\N
149530	2132	148313314000	19647	9878	103	0	\N
149531	2132	148312313000	19647	9878	104	0	\N
149532	2132	148311312000	19647	9878	105	0	\N
149533	2132	148310311000	19647	9878	106	0	\N
149534	2132	148309310000	19647	9878	107	0	\N
149535	2132	148308309000	19647	9878	108	0	\N
149549	1397	1323658500000	19651	9897	0	0	\N
149550	2133	97048104000	19651	9897	1	0	\N
149551	2134	96623893000	19651	9897	2	0	\N
149552	1397	1323648499000	19652	9898	0	0	\N
149553	1397	1323638498000	19652	9898	1	0	\N
149554	2133	97047102000	19652	9898	2	0	\N
149555	2134	96622890000	19652	9898	3	0	\N
149556	2133	97046100000	19652	9898	4	0	\N
149557	2134	96621887000	19652	9898	5	0	\N
149567	1397	1323618496000	19655	9900	0	0	\N
149568	2134	96619881000	19655	9900	1	0	\N
149569	2133	97044096000	19655	9900	2	0	\N
149583	1397	1323588493000	19659	9902	0	0	\N
149584	2134	96616872000	19659	9902	1	0	\N
149585	2133	97041090000	19659	9902	2	0	\N
149592	1693	7302017834936	19662	9905	0	0	\N
149593	1693	7264673912054	19662	9905	1	0	\N
149594	1693	6997609647826	19662	9905	2	0	\N
149595	1397	1323558490000	19662	9905	3	0	\N
149596	2133	97038084000	19662	9905	4	0	\N
149597	1693	7302017834936	19663	9905	0	0	\N
149598	1693	7264673912054	19663	9905	1	0	\N
149599	1397	1323558490000	19663	9905	2	0	\N
149538	2132	148307308000	19648	9895	2	0	692
149539	2134	96626902000	19648	9895	3	0	2366
149540	2133	97051110000	19648	9895	4	0	1945
149541	2133	97050108000	19648	9895	5	0	1946
149542	2134	96625899000	19648	9895	6	0	2367
149544	2133	97049106000	19649	9896	1	0	1947
149545	2134	96624896000	19649	9896	2	0	2368
149546	1397	1323658500000	19650	9897	0	0	11517
149547	2133	97048104000	19650	9897	1	0	1948
149548	2134	96623893000	19650	9897	2	0	2369
149559	1397	1323638498000	19653	9898	1	0	11519
149560	2133	97047102000	19653	9898	2	0	1949
149561	2134	96622890000	19653	9898	3	0	2370
149562	2133	97046100000	19653	9898	4	0	1950
149564	1397	1323628497000	19654	9899	0	0	11520
149565	2133	97045098000	19654	9899	1	0	1951
149566	2134	96620884000	19654	9899	2	0	2372
149570	1397	1323618496000	19656	9900	0	0	11521
149571	2134	96619881000	19656	9900	1	0	2373
149573	1397	1323608495000	19657	9901	0	0	11522
149574	1397	1323598494000	19657	9901	1	0	11523
149575	2133	97043094000	19657	9901	2	0	1953
149576	1769	1579900000	19657	9901	3	0	54
149577	2133	97042092000	19657	9901	4	0	1954
149579	2134	96617875000	19657	9901	6	0	2375
149580	1397	1323588493000	19658	9902	0	0	11524
149581	2134	96616872000	19658	9902	1	0	2376
149582	2133	97041090000	19658	9902	2	0	1955
149587	2134	96615869000	19660	9903	1	0	2377
149588	2133	97040088000	19660	9903	2	0	1956
149589	1397	1323568491000	19661	9904	0	0	11526
149590	2133	97039086000	19661	9904	1	0	1957
149591	2134	96614866000	19661	9904	2	0	2378
149612	1693	6769709201471	19666	9907	0	0	\N
149613	1397	1323548489000	19666	9907	1	0	\N
149614	1397	1323538488000	19666	9907	2	0	\N
149615	1693	6732365278589	19666	9907	3	0	\N
149616	1693	6695021355707	19666	9907	4	0	\N
149617	1693	6521452217703	19666	9907	5	0	\N
149618	1693	6484108294821	19666	9907	6	0	\N
149619	1693	5974468128596	19666	9907	7	0	\N
149620	2134	96612860000	19666	9907	8	0	\N
149621	2133	97036080000	19666	9907	9	0	\N
149632	1693	6769709201471	19668	9907	0	0	\N
149633	1397	1323548489000	19668	9907	1	0	\N
149634	1397	1323538488000	19668	9907	2	0	\N
149635	1693	6732365278589	19668	9907	3	0	\N
149636	1693	6695021355707	19668	9907	4	0	\N
149637	1693	6521452217703	19668	9907	5	0	\N
149638	1693	6484108294821	19668	9907	6	0	\N
149639	1693	5974468128596	19668	9907	7	0	\N
149640	2134	96612860000	19668	9907	8	0	\N
149641	2133	97036080000	19668	9907	9	0	\N
149642	1693	5937124205714	19669	9908	0	0	\N
149643	1693	5899780282832	19669	9908	1	0	\N
149644	1693	5862436359950	19669	9908	2	0	\N
149645	1693	5688867221946	19669	9908	3	0	\N
149646	1693	5651523299064	19669	9908	4	0	\N
149647	1693	5614179376182	19669	9908	5	0	\N
149648	2134	96611857000	19669	9908	6	0	\N
149649	2133	97035078000	19669	9908	7	0	\N
149658	1693	5937124205714	19671	9908	0	0	\N
149659	1693	5899780282832	19671	9908	1	0	\N
149660	1693	5862436359950	19671	9908	2	0	\N
149661	1693	5688867221946	19671	9908	3	0	\N
149662	1693	5651523299064	19671	9908	4	0	\N
149663	1693	5614179376182	19671	9908	5	0	\N
149664	2134	96611857000	19671	9908	6	0	\N
149665	2133	97035078000	19671	9908	7	0	\N
149666	1693	5937124205714	19672	9908	0	0	\N
149667	1693	5899780282832	19672	9908	1	0	\N
149668	1693	5862436359950	19672	9908	2	0	\N
149669	1693	5688867221946	19672	9908	3	0	\N
149670	2134	96611857000	19672	9908	4	0	\N
149689	1397	1323528487000	19674	9909	0	0	\N
149690	1397	1323518486000	19674	9909	1	0	\N
149691	1693	5576835453300	19674	9909	2	0	\N
149692	1693	5539491530418	19674	9909	3	0	\N
149693	1693	5502147607536	19674	9909	4	0	\N
149694	1693	5464803684654	19674	9909	5	0	\N
149695	1693	5427459761772	19674	9909	6	0	\N
149696	1693	5390115838890	19674	9909	7	0	\N
149697	1693	5352771916008	19674	9909	8	0	\N
149698	1693	5315427993126	19674	9909	9	0	\N
149699	1693	5278084070244	19674	9909	10	0	\N
149700	1693	5240740147362	19674	9909	11	0	\N
149701	1693	5203396224480	19674	9909	12	0	\N
149702	1693	5166052301598	19674	9909	13	0	\N
149703	2134	96610854000	19674	9909	14	0	\N
149704	2134	96609851000	19674	9909	15	0	\N
149705	2133	97034076000	19674	9909	16	0	\N
149706	2133	97033074000	19674	9909	17	0	\N
149707	1693	5128708378716	19675	9910	0	0	\N
149708	1693	5091364455834	19675	9910	1	0	\N
149709	1693	5054020532952	19675	9910	2	0	\N
149710	1693	5016676610070	19675	9910	3	0	\N
149711	1693	4979332687188	19675	9910	4	0	\N
149712	1693	4941988764306	19675	9910	5	0	\N
149713	1397	1323508485000	19675	9910	6	0	\N
149714	1397	1323498484000	19675	9910	7	0	\N
149715	1693	4904644841424	19675	9910	8	0	\N
149716	1693	4867300918542	19675	9910	9	0	\N
149717	1693	4829956995660	19675	9910	10	0	\N
149718	1693	4828815664668	19675	9910	11	0	\N
149719	1693	4791471741786	19675	9910	12	0	\N
149720	1693	4754127818904	19675	9910	13	0	\N
149721	2134	96608848000	19675	9910	14	0	\N
149722	2134	96607845000	19675	9910	15	0	\N
149723	2133	97032072000	19675	9910	16	0	\N
149724	2133	97031070000	19675	9910	17	0	\N
149603	1693	6997609647826	19665	9906	0	0	878
149604	1693	6960265724944	19665	9906	1	0	879
149605	1693	6957427397456	19665	9906	2	0	880
149606	1693	6855267824799	19665	9906	3	0	881
149607	1693	6817923901917	19665	9906	4	0	882
149609	2133	97038084000	19665	9906	6	0	1958
149610	2133	97037082000	19665	9906	7	0	1959
149611	2134	96613863000	19665	9906	8	0	2379
149622	1693	6769709201471	19667	9907	0	0	884
149623	1397	1323548489000	19667	9907	1	0	11528
149625	1693	6732365278589	19667	9907	3	0	885
149626	1693	6695021355707	19667	9907	4	0	886
149627	1693	6521452217703	19667	9907	5	0	887
149628	1693	6484108294821	19667	9907	6	0	888
149630	2134	96612860000	19667	9907	8	0	2380
149631	2133	97036080000	19667	9907	9	0	1960
149650	1693	5937124205714	19670	9908	0	0	890
149651	1693	5899780282832	19670	9908	1	0	891
149652	1693	5862436359950	19670	9908	2	0	892
149654	1693	5651523299064	19670	9908	4	0	894
149655	1693	5614179376182	19670	9908	5	0	895
149656	2134	96611857000	19670	9908	6	0	2381
149657	2133	97035078000	19670	9908	7	0	1961
149671	1397	1323528487000	19673	9909	0	0	11530
149673	1693	5576835453300	19673	9909	2	0	896
149674	1693	5539491530418	19673	9909	3	0	897
149675	1693	5502147607536	19673	9909	4	0	898
149676	1693	5464803684654	19673	9909	5	0	899
149678	1693	5390115838890	19673	9909	7	0	901
149679	1693	5352771916008	19673	9909	8	0	902
149680	1693	5315427993126	19673	9909	9	0	903
149681	1693	5278084070244	19673	9909	10	0	904
149682	1693	5240740147362	19673	9909	11	0	905
149684	1693	5166052301598	19673	9909	13	0	907
149685	2134	96610854000	19673	9909	14	0	2382
149686	2134	96609851000	19673	9909	15	0	2383
149687	2133	97034076000	19673	9909	16	0	1962
149688	2133	97033074000	19673	9909	17	0	1963
149726	1693	5091364455834	19676	9910	1	0	909
149727	1693	5054020532952	19676	9910	2	0	910
149728	1693	5016676610070	19676	9910	3	0	911
149729	1693	4979332687188	19676	9910	4	0	912
149731	1397	1323508485000	19676	9910	6	0	11532
149732	1397	1323498484000	19676	9910	7	0	11533
149733	1693	4904644841424	19676	9910	8	0	914
149734	1693	4867300918542	19676	9910	9	0	915
149735	1693	4829956995660	19676	9910	10	0	916
149743	1693	5128708378716	19677	9910	0	0	\N
149744	1693	5091364455834	19677	9910	1	0	\N
149745	1693	5054020532952	19677	9910	2	0	\N
149746	1693	5016676610070	19677	9910	3	0	\N
149747	1693	4979332687188	19677	9910	4	0	\N
149748	1693	4941988764306	19677	9910	5	0	\N
149749	1397	1323508485000	19677	9910	6	0	\N
149750	1397	1323498484000	19677	9910	7	0	\N
149751	1693	4904644841424	19677	9910	8	0	\N
149752	1693	4867300918542	19677	9910	9	0	\N
149753	1693	4829956995660	19677	9910	10	0	\N
149754	1693	4828815664668	19677	9910	11	0	\N
149755	1693	4791471741786	19677	9910	12	0	\N
149756	1693	4754127818904	19677	9910	13	0	\N
149757	2134	96608848000	19677	9910	14	0	\N
149758	2134	96607845000	19677	9910	15	0	\N
149759	2133	97032072000	19677	9910	16	0	\N
149760	2133	97031070000	19677	9910	17	0	\N
149769	1693	4530064281612	19679	9912	0	0	\N
149770	1693	4492720358730	19679	9912	1	0	\N
149771	1693	4455376435848	19679	9912	2	0	\N
149772	1693	4418032512966	19679	9912	3	0	\N
149773	1693	4074164884715	19679	9912	4	0	\N
149774	1693	4036820961833	19679	9912	5	0	\N
149775	1397	1323478482000	19679	9912	6	0	\N
149776	2133	97029066000	19679	9912	7	0	\N
149777	2134	96605839000	19679	9912	8	0	\N
149786	1693	3999477038951	19681	9913	0	0	\N
149787	1397	1323468481000	19681	9913	1	0	\N
149788	1693	3962133116069	19681	9913	2	0	\N
149789	1693	3924789193187	19681	9913	3	0	\N
149790	1693	3887445270305	19681	9913	4	0	\N
149791	1693	3850101347423	19681	9913	5	0	\N
149792	1693	3812757424541	19681	9913	6	0	\N
149793	2133	97029066000	19681	9913	7	0	\N
149794	2133	97028064000	19681	9913	8	0	\N
149795	2134	96604836000	19681	9913	9	0	\N
149796	1693	3999477038951	19682	9913	0	0	\N
149797	1397	1323468481000	19682	9913	1	0	\N
149798	1693	3962133116069	19682	9913	2	0	\N
149799	1693	3924789193187	19682	9913	3	0	\N
149800	1693	3887445270305	19682	9913	4	0	\N
149801	1693	3850101347423	19682	9913	5	0	\N
149802	1693	3812757424541	19682	9913	6	0	\N
149803	2133	97029066000	19682	9913	7	0	\N
149804	2134	96604836000	19682	9913	8	0	\N
149805	1693	3999477038951	19683	9913	0	0	\N
149806	1397	1323468481000	19683	9913	1	0	\N
149807	1693	3962133116069	19683	9913	2	0	\N
149808	1693	3924789193187	19683	9913	3	0	\N
149809	1693	3887445270305	19683	9913	4	0	\N
149810	1693	3850101347423	19683	9913	5	0	\N
149811	1693	3812757424541	19683	9913	6	0	\N
149812	2133	97028064000	19683	9913	7	0	\N
149813	2134	96604836000	19683	9913	8	0	\N
149822	1397	1323458480000	19685	9914	0	0	\N
149823	1693	3812757424541	19685	9914	1	0	\N
149824	1693	3775413501659	19685	9914	2	0	\N
149825	1693	3738069578777	19685	9914	3	0	\N
149826	1693	3700725655895	19685	9914	4	0	\N
149827	1693	3663381733013	19685	9914	5	0	\N
149828	1693	3626037810131	19685	9914	6	0	\N
149829	1693	3588693887249	19685	9914	7	0	\N
149830	2134	96603833000	19685	9914	8	0	\N
149831	2133	97028064000	19685	9914	9	0	\N
149832	1397	1323458480000	19686	9914	0	0	\N
149833	1693	3812757424541	19686	9914	1	0	\N
149834	1693	3775413501659	19686	9914	2	0	\N
149835	1693	3738069578777	19686	9914	3	0	\N
149836	1693	3700725655895	19686	9914	4	0	\N
149837	1693	3663381733013	19686	9914	5	0	\N
149838	1693	3626037810131	19686	9914	6	0	\N
149839	1693	3588693887249	19686	9914	7	0	\N
149840	2134	96603833000	19686	9914	8	0	\N
149841	2133	97028064000	19686	9914	9	0	\N
149842	1397	1323458480000	19687	9914	0	0	\N
149843	1693	3812757424541	19687	9914	1	0	\N
149844	1693	3775413501659	19687	9914	2	0	\N
149845	1693	3738069578777	19687	9914	3	0	\N
149846	1693	3700725655895	19687	9914	4	0	\N
149847	1693	3663381733013	19687	9914	5	0	\N
149848	1693	3626037810131	19687	9914	6	0	\N
149849	2134	96603833000	19687	9914	7	0	\N
149850	2133	97028064000	19687	9914	8	0	\N
149851	1397	1323458480000	19688	9914	0	0	\N
149852	1693	3812757424541	19688	9914	1	0	\N
149853	1693	3775413501659	19688	9914	2	0	\N
149854	1693	3738069578777	19688	9914	3	0	\N
149855	1693	3700725655895	19688	9914	4	0	\N
149856	1693	3663381733013	19688	9914	5	0	\N
149857	1693	3626037810131	19688	9914	6	0	\N
149858	2134	96603833000	19688	9914	7	0	\N
149859	2133	97028064000	19688	9914	8	0	\N
149870	1397	1323458480000	19690	9914	0	0	\N
149871	1693	3775413501659	19690	9914	1	0	\N
149872	1693	3738069578777	19690	9914	2	0	\N
149739	2134	96608848000	19676	9910	14	0	2384
149740	2134	96607845000	19676	9910	15	0	2385
149741	2133	97032072000	19676	9910	16	0	1964
149742	2133	97031070000	19676	9910	17	0	1965
149761	1397	1323488483000	19678	9911	0	0	11534
149763	1693	4679439973140	19678	9911	2	0	921
149764	1693	4642096050258	19678	9911	3	0	922
149765	1693	4604752127376	19678	9911	4	0	923
149766	1693	4567408204494	19678	9911	5	0	924
149767	2133	97030068000	19678	9911	7	0	1966
149778	1693	4530064281612	19680	9912	0	0	925
149779	1693	4492720358730	19680	9912	1	0	926
149780	1693	4455376435848	19680	9912	2	0	927
149781	1693	4418032512966	19680	9912	3	0	928
149783	1693	4036820961833	19680	9912	5	0	930
149784	1397	1323478482000	19680	9912	6	0	11535
149785	2134	96605839000	19680	9912	7	0	2387
149814	1693	3999477038951	19684	9913	0	0	931
149815	1397	1323468481000	19684	9913	1	0	11536
149817	1693	3924789193187	19684	9913	3	0	933
149818	1693	3887445270305	19684	9913	4	0	934
149819	1693	3850101347423	19684	9913	5	0	935
149820	2133	97029066000	19684	9913	6	0	1967
149821	2134	96604836000	19684	9913	7	0	2388
149861	1693	3812757424541	19689	9914	1	0	936
149862	1693	3775413501659	19689	9914	2	0	937
149863	1693	3738069578777	19689	9914	3	0	938
149864	1693	3700725655895	19689	9914	4	0	939
149866	1693	3626037810131	19689	9914	6	0	941
149867	1693	3588693887249	19689	9914	7	0	942
149868	2134	96603833000	19689	9914	8	0	2389
149869	2133	97028064000	19689	9914	9	0	1968
149873	1693	3700725655895	19690	9914	3	0	\N
149874	1693	3663381733013	19690	9914	4	0	\N
149875	1693	3626037810131	19690	9914	5	0	\N
149876	2134	96603833000	19690	9914	6	0	\N
149885	1693	3551349964367	19692	9915	0	0	\N
149886	1693	3514006041485	19692	9915	1	0	\N
149887	1397	1323448479000	19692	9915	2	0	\N
149888	1693	3476662118603	19692	9915	3	0	\N
149889	1693	3439318195721	19692	9915	4	0	\N
149890	1693	3401974272839	19692	9915	5	0	\N
149891	2134	96602830000	19692	9915	6	0	\N
149892	2133	97027062000	19692	9915	7	0	\N
149893	1693	3551349964367	19693	9915	0	0	\N
149894	1693	3514006041485	19693	9915	1	0	\N
149895	1397	1323448479000	19693	9915	2	0	\N
149896	1693	3476662118603	19693	9915	3	0	\N
149897	1693	3439318195721	19693	9915	4	0	\N
149898	1693	3401974272839	19693	9915	5	0	\N
149899	2134	96602830000	19693	9915	6	0	\N
149900	2133	97027062000	19693	9915	7	0	\N
149901	1397	1323688503000	19694	9879	0	0	\N
149902	1693	6581992834936	19694	9879	1	0	\N
149903	1693	6544648912054	19694	9879	2	0	\N
149904	1693	6277584647826	19694	9879	3	0	\N
149905	1693	6240240724944	19694	9879	4	0	\N
149906	1693	6237402397456	19694	9879	5	0	\N
149907	1693	6135242824799	19694	9879	6	0	\N
149908	1693	6097898901917	19694	9879	7	0	\N
149909	1693	6060554979035	19694	9879	8	0	\N
149910	1693	6049684201471	19694	9879	9	0	\N
149911	1693	6012340278589	19694	9879	10	0	\N
149912	1693	5974996355707	19694	9879	11	0	\N
149913	1693	5801427217703	19694	9879	12	0	\N
149914	1693	5764083294821	19694	9879	13	0	\N
149915	1693	5254443128596	19694	9879	14	0	\N
149916	1693	5217099205714	19694	9879	15	0	\N
149917	1693	5179755282832	19694	9879	16	0	\N
149918	1693	5142411359950	19694	9879	17	0	\N
149919	1693	4968842221946	19694	9879	18	0	\N
149920	1693	4931498299064	19694	9879	19	0	\N
149921	1693	4894154376182	19694	9879	20	0	\N
149922	1693	4856810453300	19694	9879	21	0	\N
149923	1693	4819466530418	19694	9879	22	0	\N
149924	1693	4782122607536	19694	9879	23	0	\N
149925	1693	4744778684654	19694	9879	24	0	\N
149926	1693	4707434761772	19694	9879	25	0	\N
149927	1693	4670090838890	19694	9879	26	0	\N
149928	1693	4632746916008	19694	9879	27	0	\N
149929	1693	4595402993126	19694	9879	28	0	\N
149930	1693	4558059070244	19694	9879	29	0	\N
149931	1693	4520715147362	19694	9879	30	0	\N
149932	1693	4483371224480	19694	9879	31	0	\N
149933	1693	4446027301598	19694	9879	32	0	\N
149934	1693	4408683378716	19694	9879	33	0	\N
149935	1693	4371339455834	19694	9879	34	0	\N
149936	1693	4333995532952	19694	9879	35	0	\N
149937	1693	4296651610070	19694	9879	36	0	\N
149938	1693	4259307687188	19694	9879	37	0	\N
149939	1693	4221963764306	19694	9879	38	0	\N
149940	1693	4184619841424	19694	9879	39	0	\N
149941	1693	4147275918542	19694	9879	40	0	\N
149942	1693	4109931995660	19694	9879	41	0	\N
149943	1693	4108790664668	19694	9879	42	0	\N
149944	1693	4071446741786	19694	9879	43	0	\N
149945	1693	4034102818904	19694	9879	44	0	\N
149946	1693	3996758896022	19694	9879	45	0	\N
149947	1693	3959414973140	19694	9879	46	0	\N
149948	1693	3922071050258	19694	9879	47	0	\N
149949	1693	3884727127376	19694	9879	48	0	\N
149950	1693	3847383204494	19694	9879	50	0	\N
149951	1693	3810039281612	19694	9879	51	0	\N
149952	1693	3772695358730	19694	9879	52	0	\N
149953	1693	3735351435848	19694	9879	53	0	\N
149954	1693	3698007512966	19694	9879	54	0	\N
149955	1693	3354139884715	19694	9879	55	0	\N
149956	1693	3316795961833	19694	9879	56	0	\N
149957	1693	3279452038951	19694	9879	57	0	\N
149958	1693	3242108116069	19694	9879	58	0	\N
149959	1693	3204764193187	19694	9879	59	0	\N
149960	1693	3167420270305	19694	9879	60	0	\N
149961	1693	3130076347423	19694	9879	61	0	\N
149962	1693	3092732424541	19694	9879	62	0	\N
149963	1693	3055388501659	19694	9879	63	0	\N
149964	1693	3018044578777	19694	9879	64	0	\N
149965	1693	2980700655895	19694	9879	65	0	\N
149966	1693	2943356733013	19694	9879	66	0	\N
149967	1693	2906012810131	19694	9879	67	0	\N
149968	1693	2868668887249	19694	9879	68	0	\N
149969	1693	2831324964367	19694	9879	69	0	\N
149970	1693	2793981041485	19694	9879	70	0	\N
149971	1397	1323678502000	19694	9879	71	0	\N
149972	1397	1323668501000	19694	9879	72	0	\N
149973	1397	1323658500000	19694	9879	73	0	\N
149974	1397	1323648499000	19694	9879	74	0	\N
149975	1397	1323638498000	19694	9879	75	0	\N
149976	1397	1323628497000	19694	9879	76	0	\N
149977	1397	1323618496000	19694	9879	77	0	\N
149978	1397	1323608495000	19694	9879	78	0	\N
149979	1397	1323598494000	19694	9879	79	0	\N
149980	1397	1323588493000	19694	9879	80	0	\N
149981	1397	1323578492000	19694	9879	81	0	\N
149982	1397	1323568491000	19694	9879	82	0	\N
149983	1397	1323558490000	19694	9879	83	0	\N
149984	1397	1323548489000	19694	9879	84	0	\N
149985	1397	1323538488000	19694	9879	85	0	\N
149986	1397	1323528487000	19694	9879	86	0	\N
149987	1397	1323518486000	19694	9879	87	0	\N
149988	1397	1323508485000	19694	9879	88	0	\N
149989	1397	1323498484000	19694	9879	89	0	\N
149990	1397	1323488483000	19694	9879	90	0	\N
149991	1397	1323478482000	19694	9879	91	0	\N
149992	1397	1323468481000	19694	9879	92	0	\N
149993	1397	1323458480000	19694	9879	93	0	\N
149994	1397	1323448479000	19694	9879	94	0	\N
149995	2132	148307308000	19694	9879	95	0	\N
149996	2134	96626902000	19694	9879	96	0	\N
149997	1769	1579900000	19694	9879	97	0	\N
149998	2133	97051110000	19694	9879	98	0	\N
149999	2133	97050108000	19694	9879	99	0	\N
150000	2133	97049106000	19694	9879	100	0	\N
150001	2133	97048104000	19694	9879	101	0	\N
150002	2133	97047102000	19694	9879	102	0	\N
150003	2133	97046100000	19694	9879	103	0	\N
150004	2133	97045098000	19694	9879	104	0	\N
150005	2133	97044096000	19694	9879	105	0	\N
150006	2133	97043094000	19694	9879	106	0	\N
150007	2133	97042092000	19694	9879	107	0	\N
150008	2133	97041090000	19694	9879	108	0	\N
149879	1397	1323448479000	19691	9915	2	0	11538
149880	1693	3476662118603	19691	9915	3	0	945
149881	1693	3439318195721	19691	9915	4	0	946
149882	1693	3401974272839	19691	9915	5	0	947
149883	2134	96602830000	19691	9915	6	0	2390
150009	2133	97040088000	19694	9879	109	0	\N
150010	2133	97039086000	19694	9879	110	0	\N
150011	2133	97038084000	19694	9879	111	0	\N
150012	2133	97037082000	19694	9879	112	0	\N
150013	2133	97036080000	19694	9879	113	0	\N
150014	2133	97035078000	19694	9879	114	0	\N
150015	2133	97034076000	19694	9879	115	0	\N
150016	2133	97033074000	19694	9879	116	0	\N
150017	2133	97032072000	19694	9879	117	0	\N
150018	2133	97031070000	19694	9879	118	0	\N
150019	2133	97030068000	19694	9879	119	0	\N
150020	2133	97029066000	19694	9879	120	0	\N
150021	2133	97028064000	19694	9879	121	0	\N
150022	2133	97027062000	19694	9879	122	0	\N
150023	2134	96625899000	19694	9879	123	0	\N
150024	2134	96624896000	19694	9879	124	0	\N
150025	2134	96623893000	19694	9879	125	0	\N
150026	1693	3400832941847	19695	9916	0	0	\N
150027	1397	1323438478000	19695	9916	1	0	\N
150028	1693	3363489018965	19695	9916	2	0	\N
150029	1693	3326145096083	19695	9916	3	0	\N
150030	1693	3288801173201	19695	9916	4	0	\N
150031	1693	3251457250319	19695	9916	5	0	\N
150032	1693	3214113327437	19695	9916	6	0	\N
150033	2134	96601827000	19695	9916	7	0	\N
150034	2133	97026060000	19695	9916	8	0	\N
150082	1397	1323378472000	19700	9920	0	0	\N
150083	2134	96595809000	19700	9920	1	0	\N
150084	2133	97020048000	19700	9920	2	0	\N
150085	1397	1323378472000	19701	9920	0	0	\N
150086	2134	96595809000	19701	9920	1	0	\N
150087	2133	97020048000	19701	9920	2	0	\N
150088	1693	7302017834936	19702	9886	0	0	\N
150089	1693	7264673912054	19702	9886	1	0	\N
150090	1693	6997609647826	19702	9886	2	0	\N
150091	1693	6960265724944	19702	9886	3	0	\N
150092	1397	1323828517000	19702	9886	4	0	\N
150093	1397	1323818516000	19702	9886	5	0	\N
150094	1397	1323808515000	19702	9886	6	0	\N
150095	1397	1323798514000	19702	9886	7	0	\N
150096	1397	1323788513000	19702	9886	8	0	\N
150097	1397	1323778512000	19702	9886	9	0	\N
150098	1397	1323768511000	19702	9886	10	0	\N
150099	1397	1323758510000	19702	9886	11	0	\N
150100	1397	1323748509000	19702	9886	12	0	\N
150101	1693	6957427397456	19702	9886	13	0	\N
150102	1397	1323738508000	19702	9886	14	0	\N
150103	1397	1323728507000	19702	9886	15	0	\N
150104	1397	1323718506000	19702	9886	16	0	\N
150105	1397	1323708505000	19702	9886	17	0	\N
150106	1397	1323698504000	19702	9886	18	0	\N
150107	1397	1323688503000	19702	9886	19	0	\N
150108	1693	6855267824799	19702	9886	20	0	\N
150109	1693	6817923901917	19702	9886	21	0	\N
150110	1693	6780579979035	19702	9886	22	0	\N
150111	1693	6769709201471	19702	9886	23	0	\N
150112	1693	6732365278589	19702	9886	24	0	\N
150113	1693	6695021355707	19702	9886	25	0	\N
150114	1693	6521452217703	19702	9886	26	0	\N
150115	1693	6484108294821	19702	9886	27	0	\N
150116	1693	5974468128596	19702	9886	28	0	\N
150117	1693	5937124205714	19702	9886	29	0	\N
150118	1693	5899780282832	19702	9886	30	0	\N
150119	1693	5862436359950	19702	9886	31	0	\N
150120	1693	5688867221946	19702	9886	32	0	\N
150121	1693	5651523299064	19702	9886	33	0	\N
150122	1693	5614179376182	19702	9886	34	0	\N
150123	1693	5576835453300	19702	9886	35	0	\N
150124	1693	5539491530418	19702	9886	36	0	\N
150125	1693	5502147607536	19702	9886	37	0	\N
150126	1693	5464803684654	19702	9886	38	0	\N
150127	1693	5427459761772	19702	9886	39	0	\N
150128	1693	5390115838890	19702	9886	40	0	\N
150129	1693	5352771916008	19702	9886	41	0	\N
150130	1693	5315427993126	19702	9886	42	0	\N
150131	1693	5278084070244	19702	9886	43	0	\N
150132	1693	5240740147362	19702	9886	44	0	\N
150133	1693	5203396224480	19702	9886	45	0	\N
150134	1693	5166052301598	19702	9886	46	0	\N
150135	1693	5128708378716	19702	9886	47	0	\N
150136	1693	5091364455834	19702	9886	48	0	\N
150137	1693	5054020532952	19702	9886	49	0	\N
150138	1693	5016676610070	19702	9886	50	0	\N
150139	1693	4979332687188	19702	9886	51	0	\N
150140	1693	4941988764306	19702	9886	52	0	\N
150141	1693	4904644841424	19702	9886	53	0	\N
150142	1693	4867300918542	19702	9886	54	0	\N
150143	1693	4829956995660	19702	9886	55	0	\N
150144	1693	4828815664668	19702	9886	56	0	\N
150037	1693	3363489018965	19696	9916	2	0	949
150038	1693	3326145096083	19696	9916	3	0	950
150039	1693	3288801173201	19696	9916	4	0	951
150040	1693	3251457250319	19696	9916	5	0	952
150041	1693	3214113327437	19696	9916	6	0	953
150043	2133	97026060000	19696	9916	8	0	1970
150044	1693	3176769404555	19697	9917	0	0	954
150045	1397	1323428477000	19697	9917	1	0	11540
150046	1397	1323418476000	19697	9917	2	0	11541
150047	1693	3139425481673	19697	9917	3	0	955
150049	1693	3098111900309	19697	9917	5	0	957
150050	1693	3060767977427	19697	9917	6	0	958
150051	1693	3023424054545	19697	9917	7	0	959
150052	1693	2986080131663	19697	9917	8	0	960
150054	1693	2664333015202	19697	9917	10	0	962
150055	1693	2626989092320	19697	9917	11	0	963
150056	1693	2589645169438	19697	9917	12	0	964
150057	2133	97025058000	19697	9917	13	0	1971
150058	2133	97024056000	19697	9917	14	0	1972
150060	2134	96599821000	19697	9917	16	0	2393
150061	1693	2552301246556	19698	9918	0	0	965
150062	1693	2514957323674	19698	9918	1	0	966
150063	1693	2477613400792	19698	9918	2	0	967
150064	1693	2440269477910	19698	9918	3	0	968
150066	1397	1323408475000	19698	9918	5	0	11542
150067	1397	1323398474000	19698	9918	6	0	11543
150068	1693	1444725699798	19698	9918	7	0	970
150069	1693	1407381776916	19698	9918	8	0	971
150071	1693	1332693931152	19698	9918	10	0	973
150072	1693	1295350008270	19698	9918	11	0	974
150073	1693	1258006085388	19698	9918	12	0	975
150074	1693	1256864754396	19698	9918	13	0	976
150075	2134	96598818000	19698	9918	14	0	2394
150077	2134	96597815000	19698	9918	16	0	2395
150078	2133	97022052000	19698	9918	17	0	1974
150079	1397	1323388473000	19699	9919	0	0	11544
150080	2133	97021050000	19699	9919	1	0	1975
150081	2134	96596812000	19699	9919	2	0	2396
150145	1693	4791471741786	19702	9886	57	0	\N
150146	1693	4754127818904	19702	9886	58	0	\N
150147	1693	4716783896022	19702	9886	59	0	\N
150148	1693	4679439973140	19702	9886	60	0	\N
150149	1693	4642096050258	19702	9886	61	0	\N
150150	1693	4604752127376	19702	9886	62	0	\N
150151	1693	4567408204494	19702	9886	63	0	\N
150152	1693	4530064281612	19702	9886	64	0	\N
150153	1693	4492720358730	19702	9886	65	0	\N
150154	1693	4455376435848	19702	9886	66	0	\N
150155	1693	4418032512966	19702	9886	67	0	\N
150156	1693	4074164884715	19702	9886	68	0	\N
150157	1693	4036820961833	19702	9886	69	0	\N
150158	1693	3999477038951	19702	9886	70	0	\N
150159	1693	3962133116069	19702	9886	71	0	\N
150160	1693	3924789193187	19702	9886	72	0	\N
150161	1693	3887445270305	19702	9886	73	0	\N
150162	1693	3850101347423	19702	9886	74	0	\N
150163	1693	3812757424541	19702	9886	75	0	\N
150164	1693	3775413501659	19702	9886	76	0	\N
150165	1693	3738069578777	19702	9886	77	0	\N
150166	1693	3700725655895	19702	9886	78	0	\N
150167	1693	3663381733013	19702	9886	79	0	\N
150168	1693	3626037810131	19702	9886	80	0	\N
150169	1693	3588693887249	19702	9886	82	0	\N
150170	1693	3551349964367	19702	9886	83	0	\N
150171	1693	3514006041485	19702	9886	84	0	\N
150172	1693	3476662118603	19702	9886	85	0	\N
150173	1693	3439318195721	19702	9886	86	0	\N
150174	1693	3401974272839	19702	9886	87	0	\N
150175	1693	3400832941847	19702	9886	88	0	\N
150176	1693	3363489018965	19702	9886	89	0	\N
150177	1693	3326145096083	19702	9886	90	0	\N
150178	1693	3288801173201	19702	9886	91	0	\N
150179	1693	3251457250319	19702	9886	92	0	\N
150180	1693	3214113327437	19702	9886	93	0	\N
150181	1693	3176769404555	19702	9886	94	0	\N
150182	1693	3139425481673	19702	9886	95	0	\N
150183	1693	3135455823191	19702	9886	96	0	\N
150184	1693	3098111900309	19702	9886	97	0	\N
150185	1693	3060767977427	19702	9886	98	0	\N
150186	1693	3023424054545	19702	9886	99	0	\N
150187	1693	2986080131663	19702	9886	100	0	\N
150188	1693	2701676938084	19702	9886	101	0	\N
150189	1693	2664333015202	19702	9886	102	0	\N
150190	1693	2626989092320	19702	9886	103	0	\N
150191	1693	2589645169438	19702	9886	104	0	\N
150192	1693	2552301246556	19702	9886	105	0	\N
150193	1693	2514957323674	19702	9886	106	0	\N
150194	1693	2477613400792	19702	9886	107	0	\N
150195	1693	2440269477910	19702	9886	108	0	\N
150196	1693	2402925555028	19702	9886	109	0	\N
150197	1693	1444725699798	19702	9886	110	0	\N
150198	1693	1407381776916	19702	9886	111	0	\N
150199	1693	1370037854034	19702	9886	112	0	\N
150200	1693	1332693931152	19702	9886	113	0	\N
150201	1693	1295350008270	19702	9886	114	0	\N
150202	1693	1258006085388	19702	9886	115	0	\N
150203	1693	1256864754396	19702	9886	116	0	\N
150204	1693	1219520831514	19702	9886	117	0	\N
150205	1693	1182176908632	19702	9886	118	0	\N
150206	1397	1323678502000	19702	9886	119	0	\N
150207	1397	1323668501000	19702	9886	120	0	\N
150208	1397	1323658500000	19702	9886	121	0	\N
150209	1397	1323648499000	19702	9886	122	0	\N
150210	1397	1323638498000	19702	9886	123	0	\N
150211	1397	1323628497000	19702	9886	124	0	\N
150212	1397	1323618496000	19702	9886	125	0	\N
150228	1397	1323328467000	19706	9923	0	0	\N
150229	1693	1219520831514	19706	9923	1	0	\N
150230	1693	1182176908632	19706	9923	2	0	\N
150231	2133	97015038000	19706	9923	3	0	\N
150232	2134	96590794000	19706	9923	4	0	\N
150233	1397	1323328467000	19707	9923	0	0	\N
150234	1693	1219520831514	19707	9923	1	0	\N
150235	1693	1182176908632	19707	9923	2	0	\N
150236	2133	97015038000	19707	9923	3	0	\N
150237	2134	96590794000	19707	9923	4	0	\N
150238	1397	1323328467000	19708	9923	0	0	\N
150239	1693	1219520831514	19708	9923	1	0	\N
150240	1693	1182176908632	19708	9923	2	0	\N
150241	2133	97015038000	19708	9923	3	0	\N
150242	2134	96590794000	19708	9923	4	0	\N
150248	1397	1323318466000	19710	9924	0	0	\N
150249	2133	97014036000	19710	9924	1	0	\N
150250	2134	96589791000	19710	9924	2	0	\N
150251	1397	1323318466000	19711	9924	0	0	\N
150252	2133	97014036000	19711	9924	1	0	\N
150253	2134	96589791000	19711	9924	2	0	\N
150257	1397	1323308465000	19713	9925	0	0	\N
150258	2133	97013034000	19713	9925	1	0	\N
150262	1447	15993600943000	19715	9824	0	0	\N
150263	1693	5861968834936	19715	9824	1	0	\N
150264	1693	5824624912054	19715	9824	2	0	\N
150265	1693	5557560647826	19715	9824	3	0	\N
150266	1693	5520216724944	19715	9824	4	0	\N
150267	1397	1324688603000	19715	9824	5	0	\N
150268	1693	5517378397456	19715	9824	6	0	\N
150269	1397	1324678602000	19715	9824	7	0	\N
150270	1397	1324668601000	19715	9824	8	0	\N
150271	1397	1324658600000	19715	9824	9	0	\N
150272	1397	1324648599000	19715	9824	10	0	\N
150273	1397	1324638598000	19715	9824	11	0	\N
150274	1397	1324628597000	19715	9824	12	0	\N
150275	1397	1324618596000	19715	9824	13	0	\N
150276	1397	1324608595000	19715	9824	14	0	\N
150277	1397	1324598594000	19715	9824	15	0	\N
150278	1397	1324588593000	19715	9824	16	0	\N
150279	1397	1324578592000	19715	9824	17	0	\N
150280	1397	1324568591000	19715	9824	18	0	\N
150215	2133	97020048000	19703	9920	2	0	1976
150216	1397	1323368471000	19704	9921	0	0	11546
150217	1397	1323358470000	19704	9921	1	0	11547
150218	2133	97019046000	19704	9921	2	0	1977
150219	2134	96594806000	19704	9921	3	0	2398
150221	2133	97018044000	19704	9921	5	0	1978
150222	1397	1323348469000	19705	9922	0	0	11548
150223	1397	1323338468000	19705	9922	1	0	11549
150224	2133	97017042000	19705	9922	2	0	1979
150225	2134	96592800000	19705	9922	3	0	2400
150227	2133	97016040000	19705	9922	5	0	1980
150243	1397	1323328467000	19709	9923	0	0	11550
150244	1693	1219520831514	19709	9923	1	0	977
150245	1693	1182176908632	19709	9923	2	0	978
150247	2134	96590794000	19709	9923	4	0	2402
150254	1397	1323318466000	19712	9924	0	0	11551
150255	2133	97014036000	19712	9924	1	0	1982
150256	2134	96589791000	19712	9924	2	0	2403
150259	1397	1323308465000	19714	9925	0	0	11552
150261	2133	97013034000	19714	9925	2	0	1983
150281	1693	5415218824799	19715	9824	19	0	\N
150282	1693	5377874901917	19715	9824	20	0	\N
150283	1693	5340530979035	19715	9824	21	0	\N
150284	1693	5329660201471	19715	9824	22	0	\N
150285	1693	5292316278589	19715	9824	23	0	\N
150286	1693	5254972355707	19715	9824	24	0	\N
150287	1693	5081403217703	19715	9824	25	0	\N
150288	1693	5044059294821	19715	9824	26	0	\N
150289	1693	4534419128596	19715	9824	27	0	\N
150290	1693	4497075205714	19715	9824	28	0	\N
150291	1693	4459731282832	19715	9824	29	0	\N
150292	1693	4422387359950	19715	9824	30	0	\N
150293	1693	4248818221946	19715	9824	31	0	\N
150294	1693	4211474299064	19715	9824	32	0	\N
150295	1693	4174130376182	19715	9824	33	0	\N
150296	1693	4136786453300	19715	9824	34	0	\N
150297	1693	4099442530418	19715	9824	35	0	\N
150298	1693	4062098607536	19715	9824	36	0	\N
150299	1693	4024754684654	19715	9824	37	0	\N
150300	1693	3987410761772	19715	9824	38	0	\N
150301	1693	3950066838890	19715	9824	39	0	\N
150302	1693	3912722916008	19715	9824	40	0	\N
150303	1693	3875378993126	19715	9824	41	0	\N
150304	1693	3838035070244	19715	9824	42	0	\N
150305	1693	3800691147362	19715	9824	43	0	\N
150306	1693	3763347224480	19715	9824	44	0	\N
150307	1693	3726003301598	19715	9824	45	0	\N
150308	1693	3688659378716	19715	9824	46	0	\N
150309	1693	3651315455834	19715	9824	47	0	\N
150310	1693	3613971532952	19715	9824	48	0	\N
150311	1693	3576627610070	19715	9824	49	0	\N
150312	1693	3539283687188	19715	9824	50	0	\N
150313	1693	3501939764306	19715	9824	51	0	\N
150314	1397	1324558590000	19715	9824	52	0	\N
150315	1397	1324548589000	19715	9824	53	0	\N
150316	1397	1324538588000	19715	9824	54	0	\N
150317	1397	1324528587000	19715	9824	55	0	\N
150318	1397	1324518586000	19715	9824	56	0	\N
150319	1397	1324508585000	19715	9824	57	0	\N
150320	1397	1324498584000	19715	9824	58	0	\N
150321	1397	1324488583000	19715	9824	59	0	\N
150322	1397	1324478582000	19715	9824	60	0	\N
150323	1397	1324468581000	19715	9824	61	0	\N
150324	1397	1324458580000	19715	9824	62	0	\N
150325	1397	1324448579000	19715	9824	63	0	\N
150326	1397	1324438578000	19715	9824	64	0	\N
150327	1397	1324428577000	19715	9824	65	0	\N
150328	1397	1324418576000	19715	9824	66	0	\N
150329	1397	1324408575000	19715	9824	67	0	\N
150330	1397	1324398574000	19715	9824	68	0	\N
150331	1397	1324388573000	19715	9824	69	0	\N
150332	1397	1324378572000	19715	9824	70	0	\N
150333	1397	1324368571000	19715	9824	71	0	\N
150334	1397	1324358570000	19715	9824	72	0	\N
150335	1397	1324348569000	19715	9824	73	0	\N
150336	1397	1324338568000	19715	9824	74	0	\N
150337	1397	1324328567000	19715	9824	75	0	\N
150338	1397	1324318566000	19715	9824	76	0	\N
150339	1397	1324308565000	19715	9824	77	0	\N
150340	1397	1324298564000	19715	9824	78	0	\N
150341	1397	1324288563000	19715	9824	79	0	\N
150342	1397	1324278562000	19715	9824	80	0	\N
150343	1397	1324268561000	19715	9824	81	0	\N
150344	1397	1324258560000	19715	9824	82	0	\N
150345	1397	1324248559000	19715	9824	83	0	\N
150346	1397	1324238558000	19715	9824	84	0	\N
150347	1397	1324228557000	19715	9824	85	0	\N
150348	1397	1324218556000	19715	9824	86	0	\N
150349	1397	1324208555000	19715	9824	87	0	\N
150350	1397	1324198554000	19715	9824	88	0	\N
150351	1397	1324188553000	19715	9824	89	0	\N
150352	1397	1324178552000	19715	9824	90	0	\N
150353	1397	1324168551000	19715	9824	91	0	\N
150354	1397	1324158550000	19715	9824	92	0	\N
150355	1397	1324148549000	19715	9824	93	0	\N
150356	1397	1324138548000	19715	9824	94	0	\N
150357	1397	1324128547000	19715	9824	95	0	\N
150358	1397	1324118546000	19715	9824	96	0	\N
150359	1397	1324108545000	19715	9824	97	0	\N
150360	1397	1324098544000	19715	9824	98	0	\N
150361	1397	1324088543000	19715	9824	99	0	\N
150362	1397	1324078542000	19715	9824	100	0	\N
150363	1397	1324068541000	19715	9824	101	0	\N
150364	1397	1324058540000	19715	9824	102	0	\N
150365	1397	1324048539000	19715	9824	103	0	\N
150366	1397	1324038538000	19715	9824	104	0	\N
150367	1397	1324028537000	19715	9824	105	0	\N
150368	1397	1324018536000	19715	9824	106	0	\N
150369	1397	1324008535000	19715	9824	107	0	\N
150370	1397	1323998534000	19715	9824	108	0	\N
150371	1397	1323988533000	19715	9824	110	0	\N
150372	1397	1323978532000	19715	9824	111	0	\N
150373	1397	1323968531000	19715	9824	112	0	\N
150374	1397	1323958530000	19715	9824	113	0	\N
150375	1397	1323948529000	19715	9824	114	0	\N
150376	1397	1323938528000	19715	9824	115	0	\N
150377	1397	1323928527000	19715	9824	116	0	\N
150378	1397	1323918526000	19715	9824	117	0	\N
150379	1397	1323908525000	19715	9824	118	0	\N
150380	1397	1323898524000	19715	9824	119	0	\N
150381	1397	1323888523000	19715	9824	120	0	\N
150382	1397	1323878522000	19715	9824	121	0	\N
150383	1397	1323868521000	19715	9824	122	0	\N
150384	1397	1323858520000	19715	9824	123	0	\N
150385	1397	1323848519000	19715	9824	124	0	\N
150386	1397	1323838518000	19715	9824	125	0	\N
150402	1397	1323248459000	19719	9929	0	0	\N
150403	1397	1323238458000	19719	9929	1	0	\N
150404	2134	96583773000	19719	9929	2	0	\N
150405	2134	96582770000	19719	9929	3	0	\N
150412	1397	1323228457000	19721	9930	0	0	\N
150413	2133	97005018000	19721	9930	1	0	\N
150414	2134	96581767000	19721	9930	2	0	\N
150389	1397	1323278462000	19716	9926	2	0	11555
150390	1693	182166908632	19716	9926	3	0	979
150391	2134	96587785000	19716	9926	4	0	2405
150392	2134	96586782000	19716	9926	5	0	2406
150393	2133	97012032000	19716	9926	6	0	1984
150395	2133	97010028000	19716	9926	8	0	1986
150396	1397	1323268461000	19717	9927	0	0	11556
150397	2134	96585779000	19717	9927	1	0	2407
150398	2133	97009026000	19717	9927	2	0	1987
150399	1397	1323258460000	19718	9928	0	0	11557
150401	2134	96584776000	19718	9928	2	0	2408
150406	1397	1323248459000	19720	9929	0	0	11558
150407	1397	1323238458000	19720	9929	1	0	11559
150408	2133	97007022000	19720	9929	2	0	1989
150410	2134	96583773000	19720	9929	4	0	2409
150411	2134	96582770000	19720	9929	5	0	2410
150415	1397	1323228457000	19722	9930	0	0	11560
150416	2133	97005018000	19722	9930	1	0	1991
150418	1693	5861968834936	19723	9846	0	0	\N
150419	1693	5824624912054	19723	9846	1	0	\N
150420	1693	5557560647826	19723	9846	2	0	\N
150421	1693	5520216724944	19723	9846	3	0	\N
150422	1693	5517378397456	19723	9846	4	0	\N
150423	1693	5415218824799	19723	9846	5	0	\N
150424	1693	5377874901917	19723	9846	6	0	\N
150425	1693	5340530979035	19723	9846	7	0	\N
150426	1693	5329660201471	19723	9846	8	0	\N
150427	1693	5292316278589	19723	9846	9	0	\N
150428	1693	5254972355707	19723	9846	10	0	\N
150429	1693	5081403217703	19723	9846	11	0	\N
150430	1693	5044059294821	19723	9846	12	0	\N
150431	1693	4534419128596	19723	9846	13	0	\N
150432	1693	4497075205714	19723	9846	14	0	\N
150433	1693	4459731282832	19723	9846	15	0	\N
150434	1693	4422387359950	19723	9846	16	0	\N
150435	1693	4248818221946	19723	9846	17	0	\N
150436	1693	4211474299064	19723	9846	18	0	\N
150437	1693	4174130376182	19723	9846	19	0	\N
150438	1693	4136786453300	19723	9846	20	0	\N
150439	1693	4099442530418	19723	9846	21	0	\N
150440	1693	4062098607536	19723	9846	22	0	\N
150441	1693	4024754684654	19723	9846	23	0	\N
150442	1693	3987410761772	19723	9846	24	0	\N
150443	1693	3950066838890	19723	9846	25	0	\N
150444	1693	3912722916008	19723	9846	26	0	\N
150445	1693	3875378993126	19723	9846	27	0	\N
150446	1693	3838035070244	19723	9846	28	0	\N
150447	1693	3800691147362	19723	9846	29	0	\N
150448	1693	3763347224480	19723	9846	30	0	\N
150449	1693	3726003301598	19723	9846	31	0	\N
150450	1693	3688659378716	19723	9846	32	0	\N
150451	1693	3651315455834	19723	9846	33	0	\N
150452	1693	3613971532952	19723	9846	34	0	\N
150453	1693	3576627610070	19723	9846	35	0	\N
150454	1693	3539283687188	19723	9846	36	0	\N
150455	1693	3501939764306	19723	9846	37	0	\N
150456	1693	3464595841424	19723	9846	38	0	\N
150457	1693	3427251918542	19723	9846	39	0	\N
150458	1693	3389907995660	19723	9846	40	0	\N
150459	1693	3388766664668	19723	9846	41	0	\N
150460	1693	3351422741786	19723	9846	42	0	\N
150461	1693	3314078818904	19723	9846	43	0	\N
150462	1693	3276734896022	19723	9846	44	0	\N
150463	1693	3239390973140	19723	9846	45	0	\N
150464	1693	3202047050258	19723	9846	46	0	\N
150465	1693	3164703127376	19723	9846	47	0	\N
150466	1693	3127359204494	19723	9846	48	0	\N
150467	1693	3090015281612	19723	9846	49	0	\N
150468	1693	3052671358730	19723	9846	50	0	\N
150469	1693	3015327435848	19723	9846	51	0	\N
150470	1693	2977983512966	19723	9846	52	0	\N
150471	1693	2634115884715	19723	9846	53	0	\N
150472	1693	2596771961833	19723	9846	54	0	\N
150473	1693	2559428038951	19723	9846	55	0	\N
150474	1693	2522084116069	19723	9846	56	0	\N
150475	1693	2484740193187	19723	9846	57	0	\N
150476	1693	2447396270305	19723	9846	58	0	\N
150477	1693	2410052347423	19723	9846	59	0	\N
150478	1693	2372708424541	19723	9846	60	0	\N
150479	1693	2335364501659	19723	9846	61	0	\N
150480	1693	2298020578777	19723	9846	62	0	\N
150481	1693	2260676655895	19723	9846	63	0	\N
150482	1693	2223332733013	19723	9846	64	0	\N
150483	1693	2185988810131	19723	9846	65	0	\N
150484	1693	2148644887249	19723	9846	66	0	\N
150485	1693	2111300964367	19723	9846	67	0	\N
150486	1693	2073957041485	19723	9846	68	0	\N
150487	1693	2036613118603	19723	9846	69	0	\N
150488	1693	1999269195721	19723	9846	70	0	\N
150489	1693	1961925272839	19723	9846	71	0	\N
150490	1693	1960783941847	19723	9846	72	0	\N
150491	1693	1923440018965	19723	9846	73	0	\N
150492	1693	1886096096083	19723	9846	74	0	\N
150493	1693	1848752173201	19723	9846	75	0	\N
150494	1693	1811408250319	19723	9846	76	0	\N
150495	1693	1774064327437	19723	9846	77	0	\N
150496	1693	1736720404555	19723	9846	78	0	\N
150497	1693	1699376481673	19723	9846	79	0	\N
150498	1693	1695406823191	19723	9846	80	0	\N
150499	1693	1658062900309	19723	9846	81	0	\N
150500	1693	1620718977427	19723	9846	82	0	\N
150501	1693	1583375054545	19723	9846	83	0	\N
150502	1693	1546031131663	19723	9846	84	0	\N
150503	1693	1261627938084	19723	9846	85	0	\N
150504	1693	1224284015202	19723	9846	86	0	\N
150505	1693	1186940092320	19723	9846	87	0	\N
150506	1693	1149596169438	19723	9846	88	0	\N
150507	1693	1112252246556	19723	9846	89	0	\N
150508	1693	1074908323674	19723	9846	90	0	\N
150509	1693	1037564400792	19723	9846	91	0	\N
150510	1693	1000220477910	19723	9846	92	0	\N
150511	1693	962876555028	19723	9846	93	0	\N
150512	1693	4676699798	19723	9846	94	0	\N
150513	1769	1579900000	19723	9846	95	0	\N
150514	1397	1323258460000	19724	9928	0	0	\N
150515	1397	1323248459000	19724	9928	1	0	\N
150516	1397	1323238458000	19724	9928	2	0	\N
150517	1397	1323228457000	19724	9928	3	0	\N
150518	2133	97008024000	19724	9928	4	0	\N
150519	2133	97007022000	19724	9928	5	0	\N
150520	2133	97006020000	19724	9928	6	0	\N
150521	2133	97005018000	19724	9928	7	0	\N
150522	2134	96584776000	19724	9928	8	0	\N
150523	2134	96583773000	19724	9928	9	0	\N
150524	2134	96582770000	19724	9928	10	0	\N
150525	2134	96581767000	19724	9928	11	0	\N
150526	1397	1323228457000	19725	9930	0	0	\N
150527	2134	96581767000	19725	9930	1	0	\N
150528	1397	1323218456000	19726	9931	0	0	\N
150529	1397	1323208455000	19726	9931	1	0	\N
150530	2134	96580764000	19726	9931	2	0	\N
150531	2134	96579761000	19726	9931	3	0	\N
150532	2133	97004016000	19726	9931	4	0	\N
150533	2133	97003014000	19726	9931	5	0	\N
150538	1397	1323218456000	19728	9931	0	0	\N
150539	1397	1323208455000	19728	9931	1	0	\N
150540	2134	96580764000	19728	9931	2	0	\N
150541	2134	96579761000	19728	9931	3	0	\N
150542	2133	97004016000	19728	9931	4	0	\N
150543	2133	97003014000	19728	9931	5	0	\N
150544	1397	1323198454000	19729	9932	0	0	\N
150545	2134	96578758000	19729	9932	1	0	\N
150535	1397	1323208455000	19727	9931	1	0	11562
150536	2134	96580764000	19727	9931	2	0	2412
150537	2134	96579761000	19727	9931	3	0	2413
150546	1397	1323198454000	19730	9932	0	0	11563
150547	2133	97004016000	19730	9932	1	0	1992
150549	2133	97002012000	19730	9932	3	0	1994
150550	2134	96578758000	19730	9932	4	0	2414
150551	1397	1323188453000	19731	9933	0	0	11564
150552	2134	96577755000	19731	9933	1	0	2415
150554	1397	1323188453000	19732	9933	0	0	\N
150555	2134	96577755000	19732	9933	1	0	\N
150556	2133	97001010000	19732	9933	2	0	\N
150566	1397	1323158450000	19735	9935	0	0	\N
150567	2133	96998004000	19735	9935	1	0	\N
150568	2134	96574746000	19735	9935	2	0	\N
150569	2133	96998004000	19736	9935	0	0	\N
150570	2134	96574746000	19736	9935	1	0	\N
150571	2133	96998004000	19737	9935	0	0	\N
150572	2134	96574746000	19737	9935	1	0	\N
150573	1397	1323438478000	19738	9880	0	0	\N
150574	1397	1323428477000	19738	9880	1	0	\N
150575	1397	1323418476000	19738	9880	2	0	\N
150576	1397	1323408475000	19738	9880	3	0	\N
150577	1397	1323398474000	19738	9880	4	0	\N
150578	1397	1323388473000	19738	9880	5	0	\N
150579	1397	1323378472000	19738	9880	6	0	\N
150580	1397	1323368471000	19738	9880	7	0	\N
150581	1397	1323358470000	19738	9880	8	0	\N
150582	1397	1323348469000	19738	9880	9	0	\N
150583	1397	1323338468000	19738	9880	10	0	\N
150584	1397	1323328467000	19738	9880	11	0	\N
150585	1397	1323318466000	19738	9880	12	0	\N
150586	1397	1323308465000	19738	9880	13	0	\N
150587	1397	1323298464000	19738	9880	14	0	\N
150588	1397	1323288463000	19738	9880	15	0	\N
150589	1397	1323278462000	19738	9880	16	0	\N
150590	1397	1323268461000	19738	9880	17	0	\N
150591	1397	1323258460000	19738	9880	18	0	\N
150592	1397	1323248459000	19738	9880	19	0	\N
150593	1397	1323238458000	19738	9880	20	0	\N
150594	1397	1323228457000	19738	9880	21	0	\N
150595	1397	1323218456000	19738	9880	22	0	\N
150596	1397	1323208455000	19738	9880	23	0	\N
150597	1397	1323198454000	19738	9880	24	0	\N
150598	1397	1323188453000	19738	9880	25	0	\N
150599	1397	1323178452000	19738	9880	26	0	\N
150600	1397	1323168451000	19738	9880	27	0	\N
150601	1397	1323158450000	19738	9880	28	0	\N
150602	2134	96622890000	19738	9880	29	0	\N
150603	2133	97026060000	19738	9880	30	0	\N
150604	2133	97025058000	19738	9880	31	0	\N
150605	2133	97024056000	19738	9880	32	0	\N
150606	2133	97023054000	19738	9880	33	0	\N
150607	2134	96621887000	19738	9880	34	0	\N
150608	2134	96620884000	19738	9880	35	0	\N
150609	2134	96619881000	19738	9880	36	0	\N
150610	2133	97022052000	19738	9880	37	0	\N
150611	2133	97021050000	19738	9880	38	0	\N
150612	2133	97020048000	19738	9880	39	0	\N
150613	2133	97019046000	19738	9880	40	0	\N
150614	2133	97018044000	19738	9880	41	0	\N
150615	2133	97017042000	19738	9880	42	0	\N
150616	2133	97016040000	19738	9880	43	0	\N
150617	2133	97015038000	19738	9880	44	0	\N
150618	2133	97014036000	19738	9880	45	0	\N
150619	2134	96618878000	19738	9880	46	0	\N
150620	2134	96617875000	19738	9880	47	0	\N
150621	2134	96616872000	19738	9880	48	0	\N
150622	2134	96615869000	19738	9880	50	0	\N
150623	2134	96614866000	19738	9880	51	0	\N
150624	2134	96613863000	19738	9880	52	0	\N
150625	2134	96612860000	19738	9880	53	0	\N
150626	2134	96611857000	19738	9880	54	0	\N
150627	2134	96610854000	19738	9880	55	0	\N
150628	2134	96609851000	19738	9880	56	0	\N
150629	2134	96608848000	19738	9880	57	0	\N
150630	2134	96607845000	19738	9880	58	0	\N
150631	2134	96606842000	19738	9880	59	0	\N
150632	2134	96605839000	19738	9880	60	0	\N
150633	2134	96604836000	19738	9880	61	0	\N
150634	2134	96603833000	19738	9880	62	0	\N
150635	2134	96602830000	19738	9880	63	0	\N
150636	2134	96601827000	19738	9880	64	0	\N
150637	2134	96600824000	19738	9880	65	0	\N
150638	2134	96599821000	19738	9880	66	0	\N
150639	2134	96598818000	19738	9880	67	0	\N
150640	2134	96597815000	19738	9880	68	0	\N
150641	2134	96596812000	19738	9880	69	0	\N
150642	2134	96595809000	19738	9880	70	0	\N
150643	2134	96594806000	19738	9880	71	0	\N
150644	2134	96593803000	19738	9880	72	0	\N
150645	2134	96592800000	19738	9880	73	0	\N
150646	2134	96591797000	19738	9880	74	0	\N
150647	2134	96590794000	19738	9880	75	0	\N
150648	2134	96589791000	19738	9880	76	0	\N
150649	2134	96588788000	19738	9880	77	0	\N
150650	2134	96587785000	19738	9880	78	0	\N
150651	2134	96586782000	19738	9880	79	0	\N
150652	2134	96585779000	19738	9880	80	0	\N
150653	2134	96584776000	19738	9880	81	0	\N
150654	2134	96583773000	19738	9880	82	0	\N
150655	2134	96582770000	19738	9880	83	0	\N
150656	2133	97013034000	19738	9880	84	0	\N
150657	2133	97012032000	19738	9880	85	0	\N
150658	2133	97011030000	19738	9880	86	0	\N
150659	2133	97010028000	19738	9880	87	0	\N
150660	2133	97009026000	19738	9880	88	0	\N
150661	2133	97008024000	19738	9880	89	0	\N
150662	2133	97007022000	19738	9880	90	0	\N
150663	2133	97006020000	19738	9880	91	0	\N
150664	2133	97005018000	19738	9880	92	0	\N
150665	2133	97004016000	19738	9880	93	0	\N
150666	2133	97003014000	19738	9880	94	0	\N
150667	1397	1323148449000	19739	9936	0	0	\N
150668	2133	96997002000	19739	9936	1	0	\N
150669	2134	96573743000	19739	9936	2	0	\N
150673	1397	1323138448000	19741	9937	0	0	\N
150674	2133	96996000000	19741	9937	1	0	\N
150675	2134	96572740000	19741	9937	2	0	\N
150558	1397	1323168451000	19733	9934	1	0	11566
150559	2133	97000008000	19733	9934	2	0	1996
150560	2133	96999006000	19733	9934	3	0	1997
150561	2134	96576752000	19733	9934	4	0	2416
150562	2134	96575749000	19733	9934	5	0	2417
150564	2133	96998004000	19734	9935	1	0	1998
150565	2134	96574746000	19734	9935	2	0	2418
150670	1397	1323148449000	19740	9936	0	0	11568
150671	2133	96997002000	19740	9936	1	0	1999
150672	2134	96573743000	19740	9936	2	0	2419
150677	2133	96996000000	19742	9937	1	0	2000
150678	2134	96572740000	19742	9937	2	0	2420
150679	1397	1323128447000	19743	9938	0	0	11570
150680	2134	96571737000	19743	9938	1	0	2421
150682	1397	1323108445000	19744	9939	1	0	11572
150683	2133	96994998000	19744	9939	2	0	2001
150684	2134	96570734000	19744	9939	3	0	2422
150685	2134	96569731000	19744	9939	4	0	2423
150686	2133	96993996000	19744	9939	5	0	2002
150688	1397	1323098444000	19745	9940	0	0	11573
150706	1397	1323048439000	19748	9942	0	0	\N
150707	2133	96986982000	19748	9942	1	0	\N
150708	2134	96563713000	19748	9942	2	0	\N
150709	1397	1323308465000	19749	9925	0	0	\N
150710	1397	1323298464000	19749	9925	1	0	\N
150711	1397	1323288463000	19749	9925	2	0	\N
150712	1397	1323278462000	19749	9925	3	0	\N
150713	1397	1323268461000	19749	9925	4	0	\N
150714	1693	182166908632	19749	9925	5	0	\N
150715	1397	1323258460000	19749	9925	6	0	\N
150716	1397	1323248459000	19749	9925	7	0	\N
150717	1397	1323238458000	19749	9925	8	0	\N
150718	1397	1323228457000	19749	9925	9	0	\N
150719	1397	1323218456000	19749	9925	10	0	\N
150720	1397	1323208455000	19749	9925	11	0	\N
150721	1397	1323198454000	19749	9925	12	0	\N
150722	1397	1323188453000	19749	9925	13	0	\N
150723	1397	1323178452000	19749	9925	14	0	\N
150724	1397	1323168451000	19749	9925	15	0	\N
150725	1397	1323158450000	19749	9925	16	0	\N
150726	1397	1323148449000	19749	9925	17	0	\N
150727	1397	1323138448000	19749	9925	18	0	\N
150728	1397	1323128447000	19749	9925	19	0	\N
150729	1397	1323118446000	19749	9925	20	0	\N
150730	1397	1323108445000	19749	9925	21	0	\N
150731	1397	1323098444000	19749	9925	22	0	\N
150732	1397	1323088443000	19749	9925	23	0	\N
150733	1397	1323078442000	19749	9925	24	0	\N
150734	1397	1323068441000	19749	9925	25	0	\N
150735	1397	1323058440000	19749	9925	26	0	\N
150736	1397	1323048439000	19749	9925	27	0	\N
150737	1397	1323038438000	19749	9925	28	0	\N
150738	2134	96588788000	19749	9925	29	0	\N
150739	2134	96587785000	19749	9925	30	0	\N
150740	2134	96586782000	19749	9925	31	0	\N
150741	2134	96585779000	19749	9925	32	0	\N
150742	2134	96584776000	19749	9925	33	0	\N
150743	2134	96583773000	19749	9925	34	0	\N
150744	2134	96582770000	19749	9925	35	0	\N
150745	2133	97013034000	19749	9925	36	0	\N
150746	2133	97012032000	19749	9925	37	0	\N
150747	2133	97011030000	19749	9925	38	0	\N
150748	2133	97010028000	19749	9925	39	0	\N
150749	2133	97009026000	19749	9925	40	0	\N
150750	2133	97008024000	19749	9925	41	0	\N
150751	2133	97007022000	19749	9925	42	0	\N
150752	2133	97006020000	19749	9925	43	0	\N
150753	2133	97005018000	19749	9925	44	0	\N
150754	2133	97004016000	19749	9925	45	0	\N
150755	2133	97003014000	19749	9925	46	0	\N
150756	2133	97002012000	19749	9925	47	0	\N
150757	2133	97001010000	19749	9925	48	0	\N
150758	2133	97000008000	19749	9925	49	0	\N
150759	2133	96999006000	19749	9925	50	0	\N
150760	2133	96998004000	19749	9925	51	0	\N
150761	2133	96997002000	19749	9925	52	0	\N
150762	2133	96996000000	19749	9925	53	0	\N
150763	2133	96994998000	19749	9925	54	0	\N
150764	2133	96993996000	19749	9925	55	0	\N
150765	2133	96992994000	19749	9925	56	0	\N
150766	2133	96991992000	19749	9925	57	0	\N
150767	2133	96990990000	19749	9925	58	0	\N
150768	2133	96989988000	19749	9925	59	0	\N
150769	2133	96988986000	19749	9925	60	0	\N
150770	2133	96987984000	19749	9925	61	0	\N
150771	2133	96986982000	19749	9925	62	0	\N
150772	2133	96985980000	19749	9925	63	0	\N
150773	2134	96581767000	19749	9925	64	0	\N
150774	2134	96580764000	19749	9925	65	0	\N
150775	2134	96579761000	19749	9925	66	0	\N
150776	2134	96578758000	19749	9925	67	0	\N
150777	2134	96577755000	19749	9925	68	0	\N
150778	2134	96576752000	19749	9925	69	0	\N
150779	2134	96575749000	19749	9925	70	0	\N
150780	2134	96574746000	19749	9925	71	0	\N
150781	2134	96573743000	19749	9925	72	0	\N
150782	2134	96572740000	19749	9925	73	0	\N
150783	2134	96571737000	19749	9925	74	0	\N
150784	2134	96570734000	19749	9925	75	0	\N
150785	2134	96569731000	19749	9925	76	0	\N
150786	2134	96568728000	19749	9925	77	0	\N
150787	2134	96567725000	19749	9925	78	0	\N
150788	2134	96566722000	19749	9925	79	0	\N
150789	2134	96565719000	19749	9925	80	0	\N
150790	2134	96564716000	19749	9925	81	0	\N
150791	2134	96563713000	19749	9925	82	0	\N
150792	2134	96562710000	19749	9925	83	0	\N
150799	1397	1323028437000	19753	9944	0	0	\N
150800	2134	96561707000	19753	9944	1	0	\N
150801	2133	96984978000	19753	9944	2	0	\N
150805	2134	96560704000	19755	9945	0	0	\N
150806	2133	96983976000	19755	9945	1	0	\N
150813	1397	1322998434000	19759	9947	0	0	\N
150814	2133	96981972000	19759	9947	1	0	\N
150815	2134	96558698000	19759	9947	2	0	\N
150691	1397	1323068441000	19745	9940	3	0	11576
150692	2133	96991992000	19745	9940	4	0	2004
150693	2134	96568728000	19745	9940	5	0	2424
150694	2134	96567725000	19745	9940	6	0	2425
150695	2134	96566722000	19745	9940	7	0	2426
150697	2133	96990990000	19745	9940	9	0	2005
150698	2133	96989988000	19745	9940	10	0	2006
150699	2133	96988986000	19745	9940	11	0	2007
150700	1397	1323058440000	19746	9941	0	0	11577
150701	2133	96987984000	19746	9941	1	0	2008
150703	1397	1323048439000	19747	9942	0	0	11578
150704	2133	96986982000	19747	9942	1	0	2009
150705	2134	96563713000	19747	9942	2	0	2429
150793	1397	1323038438000	19750	9943	0	0	11579
150795	2133	96985980000	19750	9943	2	0	2010
150796	1397	1323028437000	19751	9944	0	0	11580
150797	2134	96561707000	19751	9944	1	0	2431
150798	2133	96984978000	19751	9944	2	0	2011
150802	1397	1323018436000	19754	9945	0	0	11581
150804	2133	96983976000	19754	9945	2	0	2012
150807	1397	1323008435000	19756	9946	0	0	11582
150808	2133	96982974000	19756	9946	1	0	2013
150809	2134	96559701000	19756	9946	2	0	2433
150810	1397	1322998434000	19758	9947	0	0	11583
150812	2134	96558698000	19758	9947	2	0	2434
150816	1397	1322988433000	19760	9948	0	0	11584
150817	2133	96980970000	19760	9948	1	0	2015
150818	1397	1322978432000	19761	9949	0	0	11585
150820	2133	96979968000	19761	9949	2	0	2016
150821	2133	96978966000	19761	9949	3	0	2017
150822	2134	96557695000	19761	9949	4	0	2435
150823	2134	96556692000	19761	9949	5	0	2436
150824	1397	1322958430000	19762	9950	0	0	11587
150830	1397	1322938428000	19765	9952	0	0	\N
150831	2133	96975960000	19765	9952	1	0	\N
150832	1726	58947112000	19765	9952	2	0	\N
150833	2134	96553683000	19765	9952	3	0	\N
150834	2132	148306307000	19765	9952	4	0	\N
150835	1726	57746112000	19765	9952	5	0	\N
150836	1726	56545112000	19765	9952	6	0	\N
150837	1726	55344112000	19765	9952	7	0	\N
150838	1726	54143112000	19765	9952	8	0	\N
150839	1726	52942112000	19765	9952	9	0	\N
150840	1726	58947112000	19766	9847	0	0	\N
150841	1726	57746112000	19766	9847	1	0	\N
150842	1726	56545112000	19766	9847	2	0	\N
150843	1726	55344112000	19766	9847	3	0	\N
150844	1726	54143112000	19766	9847	4	0	\N
150845	1726	52942112000	19766	9847	5	0	\N
150856	1397	1323218456000	19768	9929	0	0	\N
150857	1397	1323208455000	19768	9929	1	0	\N
150858	1397	1323198454000	19768	9929	2	0	\N
150859	1397	1323188453000	19768	9929	3	0	\N
150860	1397	1323178452000	19768	9929	4	0	\N
150861	1397	1323168451000	19768	9929	5	0	\N
150862	1397	1323158450000	19768	9929	6	0	\N
150863	1397	1323148449000	19768	9929	7	0	\N
150864	1397	1323138448000	19768	9929	8	0	\N
150865	1397	1323128447000	19768	9929	9	0	\N
150866	1397	1323118446000	19768	9929	10	0	\N
150867	1397	1323108445000	19768	9929	11	0	\N
150868	1397	1323098444000	19768	9929	12	0	\N
150869	1397	1323088443000	19768	9929	13	0	\N
150870	1397	1323078442000	19768	9929	14	0	\N
150871	1397	1323068441000	19768	9929	15	0	\N
150872	1397	1323058440000	19768	9929	16	0	\N
150873	1397	1323048439000	19768	9929	17	0	\N
150874	1397	1323038438000	19768	9929	18	0	\N
150875	1397	1323028437000	19768	9929	19	0	\N
150876	1397	1323018436000	19768	9929	20	0	\N
150877	1397	1323008435000	19768	9929	21	0	\N
150878	1397	1322998434000	19768	9929	22	0	\N
150879	1397	1322988433000	19768	9929	23	0	\N
150880	1397	1322978432000	19768	9929	24	0	\N
150881	1397	1322968431000	19768	9929	25	0	\N
150882	1397	1322958430000	19768	9929	26	0	\N
150883	1397	1322948429000	19768	9929	27	0	\N
150884	1397	1322938428000	19768	9929	28	0	\N
150885	1726	58947112000	19768	9929	29	0	\N
150886	2134	96580764000	19768	9929	30	0	\N
150887	2132	148306307000	19768	9929	31	0	\N
150888	2134	96579761000	19768	9929	32	0	\N
150889	1726	57746112000	19768	9929	33	0	\N
150890	1726	56545112000	19768	9929	34	0	\N
150891	1726	55344112000	19768	9929	35	0	\N
150892	1726	54143112000	19768	9929	36	0	\N
150893	2133	97004016000	19768	9929	37	0	\N
150894	2133	97003014000	19768	9929	38	0	\N
150895	2133	97002012000	19768	9929	39	0	\N
150896	2133	97001010000	19768	9929	40	0	\N
150897	2133	97000008000	19768	9929	41	0	\N
150898	2133	96999006000	19768	9929	42	0	\N
150899	2133	96998004000	19768	9929	43	0	\N
150900	2133	96997002000	19768	9929	44	0	\N
150901	2133	96996000000	19768	9929	45	0	\N
150902	2133	96994998000	19768	9929	46	0	\N
150903	2134	96578758000	19768	9929	47	0	\N
150904	2134	96577755000	19768	9929	48	0	\N
150905	2134	96576752000	19768	9929	49	0	\N
150906	2134	96575749000	19768	9929	50	0	\N
150907	1726	52942112000	19768	9929	51	0	\N
150908	2133	96993996000	19768	9929	52	0	\N
150909	2133	96992994000	19768	9929	53	0	\N
150910	2133	96991992000	19768	9929	54	0	\N
150911	2133	96990990000	19768	9929	55	0	\N
150912	2133	96989988000	19768	9929	56	0	\N
150913	2133	96988986000	19768	9929	57	0	\N
150914	2133	96987984000	19768	9929	58	0	\N
150915	2133	96986982000	19768	9929	59	0	\N
150916	2133	96985980000	19768	9929	60	0	\N
150917	2134	96574746000	19768	9929	61	0	\N
150918	2133	96984978000	19768	9929	62	0	\N
150919	2133	96983976000	19768	9929	63	0	\N
150920	2133	96982974000	19768	9929	64	0	\N
150921	2133	96981972000	19768	9929	65	0	\N
150922	2133	96980970000	19768	9929	66	0	\N
150923	2133	96979968000	19768	9929	67	0	\N
150924	2133	96978966000	19768	9929	68	0	\N
150925	2133	96977964000	19768	9929	69	0	\N
150926	2133	96976962000	19768	9929	70	0	\N
150927	2133	96975960000	19768	9929	71	0	\N
150928	2134	96573743000	19768	9929	72	0	\N
150929	2134	96572740000	19768	9929	73	0	\N
150930	2134	96571737000	19768	9929	74	0	\N
150931	2134	96570734000	19768	9929	75	0	\N
150932	2134	96569731000	19768	9929	76	0	\N
150933	2134	96568728000	19768	9929	77	0	\N
150934	2134	96567725000	19768	9929	78	0	\N
150935	2134	96566722000	19768	9929	79	0	\N
150936	2134	96565719000	19768	9929	80	0	\N
150937	2134	96564716000	19768	9929	81	0	\N
150938	2134	96563713000	19768	9929	82	0	\N
150939	2134	96562710000	19768	9929	83	0	\N
150940	2134	96561707000	19768	9929	84	0	\N
150941	2134	96560704000	19768	9929	85	0	\N
150942	2134	96559701000	19768	9929	87	0	\N
150943	2134	96558698000	19768	9929	88	0	\N
150944	2134	96557695000	19768	9929	89	0	\N
150945	2134	96556692000	19768	9929	90	0	\N
150946	2134	96555689000	19768	9929	91	0	\N
150947	2134	96554686000	19768	9929	92	0	\N
150948	2134	96553683000	19768	9929	93	0	\N
150949	1397	1322928427000	19769	9953	0	0	\N
150950	2134	96552680000	19769	9953	1	0	\N
150951	2133	96974958000	19769	9953	2	0	\N
150827	1397	1322948429000	19764	9951	0	0	11588
150828	2134	96554686000	19764	9951	1	0	2438
150829	2133	96976962000	19764	9951	2	0	2019
150846	1397	1322938428000	19767	9952	0	0	11589
150847	2133	96975960000	19767	9952	1	0	2020
150849	2134	96553683000	19767	9952	3	0	2439
150850	2132	148306307000	19767	9952	4	0	693
150851	1726	57746112000	19767	9952	5	0	8239
150852	1726	56545112000	19767	9952	6	0	8240
150853	1726	55344112000	19767	9952	7	0	8241
150855	1726	52942112000	19767	9952	9	0	8243
150952	1397	1322928427000	19770	9953	0	0	11590
150953	2134	96552680000	19770	9953	1	0	2440
150954	2133	96974958000	19770	9953	2	0	2021
150956	2134	96551677000	19771	9954	1	0	2441
150957	2133	96973956000	19771	9954	2	0	2022
150958	1397	1322908425000	19772	9955	0	0	11592
150959	2133	96972954000	19772	9955	1	0	2023
150960	2134	96550674000	19772	9955	2	0	2442
150977	1397	1322868421000	19776	9958	0	0	\N
150978	2134	96545659000	19776	9958	1	0	\N
150979	2133	96967944000	19776	9958	2	0	\N
150983	1397	1322848419000	19778	9960	0	0	\N
150984	1397	1322838418000	19778	9960	1	0	\N
150985	2132	148303304000	19778	9960	2	0	\N
150986	2134	96543653000	19778	9960	3	0	\N
150987	2134	96542650000	19778	9960	4	0	\N
150988	2133	96965940000	19778	9960	5	0	\N
150989	2133	96964938000	19778	9960	6	0	\N
150990	1397	1322848419000	19779	9960	0	0	\N
150991	1397	1322838418000	19779	9960	1	0	\N
150992	2132	148303304000	19779	9960	2	0	\N
150993	2134	96543653000	19779	9960	3	0	\N
150994	2134	96542650000	19779	9960	4	0	\N
150995	2133	96965940000	19779	9960	5	0	\N
150996	2133	96964938000	19779	9960	6	0	\N
151013	1397	1322798414000	19783	9962	0	0	\N
151014	2133	96960930000	19783	9962	1	0	\N
151015	2134	96539641000	19783	9962	2	0	\N
151033	1397	1322768411000	19787	9964	0	0	\N
151034	1397	1322758410000	19787	9964	1	0	\N
151035	2134	96536632000	19787	9964	2	0	\N
151036	1726	51741112000	19787	9964	3	0	\N
151037	2134	96535629000	19787	9964	4	0	\N
151038	2133	96957924000	19787	9964	5	0	\N
151039	2133	96956922000	19787	9964	6	0	\N
151047	1397	1322728407000	19790	9967	0	0	\N
151048	2134	96532620000	19790	9967	1	0	\N
151049	2133	96953916000	19790	9967	2	0	\N
151057	1397	1322708405000	19793	9969	0	0	\N
151058	2133	96951912000	19793	9969	1	0	\N
151059	1397	1322708405000	19794	9969	0	0	\N
151060	2133	96951912000	19794	9969	1	0	\N
151061	2134	96530614000	19794	9969	2	0	\N
151062	1397	1322708405000	19795	9969	0	0	\N
151063	2133	96951912000	19795	9969	1	0	\N
151064	2134	96530614000	19795	9969	2	0	\N
151071	1695	9742230999000	19798	9971	0	0	\N
151072	1695	7434130999000	19798	9971	1	0	\N
151073	1695	4014030999000	19798	9971	2	0	\N
151074	1695	2104930999000	19798	9971	3	0	\N
151075	1397	1322688403000	19798	9971	4	0	\N
151076	2134	96528608000	19798	9971	5	0	\N
151077	2132	148298299000	19798	9971	6	0	\N
151078	2133	96949908000	19798	9971	7	0	\N
151079	1695	9742230999000	19799	9971	0	0	\N
151080	1695	7434130999000	19799	9971	1	0	\N
151081	1695	4014030999000	19799	9971	2	0	\N
151082	1695	2104930999000	19799	9971	3	0	\N
151083	1397	1322688403000	19799	9971	4	0	\N
151084	2134	96528608000	19799	9971	5	0	\N
151085	2132	148298299000	19799	9971	6	0	\N
151086	2133	96949908000	19799	9971	7	0	\N
151095	1695	9742230999000	19801	9971	0	0	\N
151096	1695	7434130999000	19801	9971	1	0	\N
150963	2132	148305306000	19772	9955	5	0	694
150964	1397	1322898424000	19773	9956	0	0	11593
150965	1397	1322888423000	19773	9956	1	0	11594
150966	2132	148304305000	19773	9956	2	0	695
150967	2134	96548668000	19773	9956	3	0	2444
150969	2133	96970950000	19773	9956	5	0	2025
150970	2133	96969948000	19773	9956	6	0	2026
150971	1397	1322878422000	19774	9957	0	0	11595
150972	2134	96546662000	19774	9957	1	0	2446
150973	2133	96968946000	19774	9957	2	0	2027
150975	2134	96545659000	19775	9958	1	0	2447
150976	2133	96967944000	19775	9958	2	0	2028
150980	1397	1322858420000	19777	9959	0	0	11597
150981	2134	96544656000	19777	9959	1	0	2448
150997	1397	1322848419000	19780	9960	0	0	11598
150998	1397	1322838418000	19780	9960	1	0	11599
150999	2132	148303304000	19780	9960	2	0	696
151000	2134	96543653000	19780	9960	3	0	2449
151001	2134	96542650000	19780	9960	4	0	2450
151003	2133	96964938000	19780	9960	6	0	2031
151004	1397	1322828417000	19781	9961	0	0	11600
151005	1397	1322818416000	19781	9961	1	0	11601
151006	1397	1322808415000	19781	9961	2	0	11602
151007	2133	96963936000	19781	9961	3	0	2032
151009	2133	96961932000	19781	9961	5	0	2034
151010	2134	96541647000	19781	9961	6	0	2451
151011	2134	96540644000	19781	9961	7	0	2452
151012	2132	148302303000	19781	9961	8	0	697
151017	2133	96960930000	19784	9962	1	0	2035
151018	2134	96539641000	19784	9962	2	0	2453
151019	1397	1322788413000	19785	9963	0	0	11604
151020	1397	1322778412000	19785	9963	1	0	11605
151021	2132	148301302000	19785	9963	2	0	698
151023	2133	96958926000	19785	9963	4	0	2037
151024	2134	96538638000	19785	9963	5	0	2454
151025	2134	96537635000	19785	9963	7	0	2455
151026	1397	1322768411000	19786	9964	0	0	11606
151027	1397	1322758410000	19786	9964	1	0	11607
151029	1726	51741112000	19786	9964	3	0	8244
151030	2134	96535629000	19786	9964	4	0	2457
151031	2133	96957924000	19786	9964	5	0	2038
151032	2133	96956922000	19786	9964	6	0	2039
151041	2132	148300301000	19788	9965	1	0	699
151042	2133	96955920000	19788	9965	2	0	2040
151043	2134	96534626000	19788	9965	3	0	2458
151044	1397	1322738408000	19789	9966	0	0	11609
151045	2133	96954918000	19789	9966	1	0	2041
151050	1397	1322728407000	19791	9967	0	0	11610
151051	2134	96532620000	19791	9967	1	0	2460
151052	2133	96953916000	19791	9967	2	0	2042
151053	1397	1322718406000	19792	9968	0	0	11611
151054	2134	96531617000	19792	9968	1	0	2461
151056	2132	148299300000	19792	9968	3	0	700
151065	1397	1322708405000	19796	9969	0	0	11612
151066	2133	96951912000	19796	9969	1	0	2044
151067	2134	96530614000	19796	9969	2	0	2462
151069	2133	96950910000	19797	9970	1	0	2045
151070	2134	96529611000	19797	9970	2	0	2463
151087	1695	9742230999000	19800	9971	0	0	6
151088	1695	7434130999000	19800	9971	1	0	7
151089	1695	4014030999000	19800	9971	2	0	8
151091	1397	1322688403000	19800	9971	4	0	11614
151092	2134	96528608000	19800	9971	5	0	2464
151093	2132	148298299000	19800	9971	6	0	701
151094	2133	96949908000	19800	9971	7	0	2046
151097	1695	4014030999000	19801	9971	2	0	\N
151098	1695	2104930999000	19801	9971	3	0	\N
151099	1397	1322688403000	19801	9971	4	0	\N
151100	2134	96528608000	19801	9971	5	0	\N
151101	2132	148298299000	19801	9971	6	0	\N
151102	2133	96949908000	19801	9971	7	0	\N
151117	1397	1322658400000	19804	9973	0	0	\N
151118	1397	1322648399000	19804	9973	1	0	\N
151119	1397	1322638398000	19804	9973	2	0	\N
151120	1397	1322628397000	19804	9973	3	0	\N
151121	1605	57000000	19804	9973	4	0	\N
151122	2132	148297298000	19804	9973	5	0	\N
151123	2134	96525599000	19804	9973	6	0	\N
151124	2134	96524596000	19804	9973	7	0	\N
151125	2134	96523593000	19804	9973	8	0	\N
151126	2134	96522590000	19804	9973	9	0	\N
151134	1397	1322588393000	19807	9976	0	0	\N
151135	2132	148295296000	19807	9976	1	0	\N
151136	2134	96518578000	19807	9976	2	0	\N
151140	1397	1322588393000	19809	9976	0	0	\N
151141	2132	148295296000	19809	9976	1	0	\N
151142	2134	96518578000	19809	9976	2	0	\N
151143	1397	1322588393000	19810	9976	0	0	\N
151144	2132	148295296000	19810	9976	1	0	\N
151145	2134	96518578000	19810	9976	2	0	\N
151149	1397	1322558390000	19813	9979	0	0	\N
151150	2134	96516572000	19813	9979	1	0	\N
151165	1397	1322498384000	19817	9982	0	0	\N
151166	2134	96510554000	19817	9982	1	0	\N
151179	1695	9742230999000	19821	9955	0	0	\N
151180	1695	7434130999000	19821	9955	1	0	\N
151181	1695	4014030999000	19821	9955	2	0	\N
151182	1695	2104930999000	19821	9955	3	0	\N
151183	1726	51741112000	19821	9955	4	0	\N
151196	1397	1322428377000	19826	9988	0	0	\N
151197	2133	96946902000	19826	9988	1	0	\N
151198	2133	96945900000	19827	9989	0	0	\N
151199	2132	148290291000	19827	9989	1	0	\N
151200	2134	96503533000	19827	9989	2	0	\N
151204	2133	96945900000	19829	9989	0	0	\N
151205	2132	148290291000	19829	9989	1	0	\N
151206	2134	96503533000	19829	9989	2	0	\N
151207	2133	96945900000	19830	9989	0	0	\N
151208	2132	148290291000	19830	9989	1	0	\N
151209	2134	96503533000	19830	9989	2	0	\N
151210	2133	96945900000	19831	9989	0	0	\N
151211	2132	148290291000	19831	9989	1	0	\N
151212	2134	96503533000	19831	9989	2	0	\N
151216	1397	1322408375000	19833	9991	0	0	\N
151217	2133	96943896000	19833	9991	1	0	\N
151218	2134	96501527000	19833	9991	2	0	\N
151232	1397	1322378372000	19838	9994	0	0	\N
151105	2134	96527605000	19802	9972	2	0	2465
151106	2134	96526602000	19802	9972	3	0	2466
151107	1397	1322658400000	19803	9973	0	0	11617
151108	1397	1322648399000	19803	9973	1	0	11618
151109	1397	1322638398000	19803	9973	2	0	11619
151111	1605	57000000	19803	9973	4	0	1
151112	2132	148297298000	19803	9973	5	0	702
151113	2134	96525599000	19803	9973	6	0	2467
151114	2134	96524596000	19803	9973	7	0	2468
151115	2134	96523593000	19803	9973	8	0	2469
151127	1397	1322618396000	19805	9974	0	0	11621
151128	2132	148296297000	19805	9974	1	0	703
151129	2134	96521587000	19805	9974	2	0	2471
151130	1397	1322608395000	19806	9975	0	0	11622
151132	2134	96520584000	19806	9975	2	0	2472
151133	2134	96519581000	19806	9975	3	0	2473
151137	1397	1322588393000	19808	9976	0	0	11624
151138	2132	148295296000	19808	9976	1	0	704
151139	2134	96518578000	19808	9976	2	0	2474
151147	1397	1322568391000	19812	9978	0	0	11626
151148	2134	96517575000	19812	9978	1	0	2475
151151	1397	1322558390000	19814	9979	0	0	11627
151152	2134	96516572000	19814	9979	1	0	2476
151153	1397	1322548389000	19815	9980	0	0	11628
151155	1397	1322528387000	19815	9980	2	0	11630
151156	2134	96515569000	19815	9980	3	0	2477
151157	2132	148294295000	19815	9980	4	0	705
151158	2134	96514566000	19815	9980	5	0	2478
151160	1397	1322518386000	19816	9981	0	0	11631
151161	1397	1322508385000	19816	9981	1	0	11632
151162	2132	148293294000	19816	9981	2	0	706
151163	2134	96512560000	19816	9981	3	0	2480
151164	2134	96511557000	19816	9981	4	0	2481
151168	2134	96510554000	19818	9982	1	0	2482
151169	2233	180000000	19819	9983	0	0	1
151170	1397	1322488383000	19819	9983	1	0	11634
151171	2134	96509551000	19819	9983	2	0	2483
151172	2132	148292293000	19819	9983	3	0	707
151174	2233	160000000	19820	9984	1	0	3
151175	1397	1322478382000	19820	9984	3	0	11635
151176	1397	1322468381000	19820	9984	4	0	11636
151177	2134	96508548000	19820	9984	5	0	2484
151184	1397	1322458380000	19822	9985	0	0	11637
151185	2134	96506542000	19822	9985	1	0	2486
151186	1397	1322448379000	19823	9986	0	0	11638
151187	2233	149999999	19823	9986	1	0	4
151188	2133	96948906000	19823	9986	2	0	2047
151190	2134	96505539000	19823	9986	4	0	2487
151191	1397	1322438378000	19824	9987	0	0	11639
151192	2134	96504536000	19824	9987	1	0	2488
151193	2133	96947904000	19824	9987	2	0	2048
151194	1397	1322428377000	19825	9988	0	0	11640
151201	2133	96945900000	19828	9989	0	0	2050
151202	2132	148290291000	19828	9989	1	0	709
151203	2134	96503533000	19828	9989	2	0	2489
151213	1397	1322418376000	19832	9990	0	0	11641
151215	2133	96944898000	19832	9990	2	0	2051
151219	1397	1322408375000	19834	9991	0	0	11642
151220	2133	96943896000	19834	9991	1	0	2052
151221	2134	96501527000	19834	9991	2	0	2491
151222	1397	1322398374000	19835	9992	0	0	11643
151224	2133	96942894000	19835	9992	2	0	2053
151225	2132	148289290000	19835	9992	3	0	710
151226	1397	1322388373000	19836	9993	0	0	11644
151227	2133	96941892000	19836	9993	1	0	2054
151228	2134	96499521000	19836	9993	2	0	2493
151230	2134	96498518000	19837	9994	1	0	2494
151231	2133	96940890000	19837	9994	2	0	2055
151233	2134	96498518000	19838	9994	1	0	\N
151234	2133	96940890000	19838	9994	2	0	\N
151238	1397	1322358370000	19840	9996	0	0	\N
151239	2132	148288289000	19840	9996	1	0	\N
151240	2133	96938886000	19840	9996	2	0	\N
151241	2134	96496512000	19840	9996	3	0	\N
151249	1397	1322348369000	19843	9997	0	0	\N
151250	2133	96937884000	19843	9997	1	0	\N
151251	2134	96495509000	19843	9997	2	0	\N
151252	1397	1322348369000	19844	9997	0	0	\N
151253	2133	96937884000	19844	9997	1	0	\N
151254	2134	96495509000	19844	9997	2	0	\N
151255	1397	1322348369000	19845	9997	0	0	\N
151256	2133	96937884000	19845	9997	1	0	\N
151257	2134	96495509000	19845	9997	2	0	\N
151265	1695	9022218999000	19847	9838	0	0	\N
151266	1695	6714118999000	19847	9838	1	0	\N
151267	1695	3294018999000	19847	9838	2	0	\N
151268	1695	1384918999000	19847	9838	3	0	\N
151269	1693	5861968834936	19847	9838	4	0	\N
151270	1693	5824624912054	19847	9838	5	0	\N
151271	1693	5557560647826	19847	9838	6	0	\N
151272	1693	5520216724944	19847	9838	7	0	\N
151273	1693	5517378397456	19847	9838	8	0	\N
151274	1693	5415218824799	19847	9838	9	0	\N
151275	1693	5377874901917	19847	9838	10	0	\N
151276	1693	5340530979035	19847	9838	11	0	\N
151277	1693	5329660201471	19847	9838	12	0	\N
151278	1693	5292316278589	19847	9838	13	0	\N
151279	1693	5254972355707	19847	9838	14	0	\N
151280	1693	5081403217703	19847	9838	15	0	\N
151281	1693	5044059294821	19847	9838	16	0	\N
151282	1693	4534419128596	19847	9838	17	0	\N
151283	1693	4497075205714	19847	9838	18	0	\N
151284	1693	4459731282832	19847	9838	19	0	\N
151285	1693	4422387359950	19847	9838	20	0	\N
151286	1693	4248818221946	19847	9838	21	0	\N
151287	1693	4211474299064	19847	9838	22	0	\N
151288	1693	4174130376182	19847	9838	23	0	\N
151289	1693	4136786453300	19847	9838	24	0	\N
151299	1397	1322308365000	19850	10000	0	0	\N
151300	2134	96492500000	19850	10000	1	0	\N
151301	2134	96491497000	19850	10000	2	0	\N
151302	1726	50540112000	19850	10000	3	0	\N
151303	1701	11893806916880	19850	10000	4	0	\N
151304	2133	96933876000	19850	10000	5	0	\N
151305	1397	1322298364000	19851	10001	0	0	\N
151306	1985	1196990000000	19851	10001	1	0	\N
151307	1701	8952581783976	19851	10001	2	0	\N
151308	2132	148286287000	19851	10001	3	0	\N
151309	2133	96932874000	19851	10001	4	0	\N
151310	1397	1322298364000	19852	10001	0	0	\N
151311	1985	1196990000000	19852	10001	1	0	\N
151312	2134	96490494000	19852	10001	2	0	\N
151313	1701	8952581783976	19852	10001	3	0	\N
151314	2132	148286287000	19852	10001	4	0	\N
151315	2133	96932874000	19852	10001	5	0	\N
151322	1397	1322298364000	19854	10001	0	0	\N
151323	1985	1196990000000	19854	10001	1	0	\N
151324	2134	96490494000	19854	10001	2	0	\N
151325	1701	8952581783976	19854	10001	3	0	\N
151326	2132	148286287000	19854	10001	4	0	\N
151327	2133	96932874000	19854	10001	5	0	\N
151334	1397	1322288363000	19857	10002	0	0	\N
151335	2133	96931872000	19857	10002	1	0	\N
151336	2134	96489491000	19857	10002	2	0	\N
151337	1726	49339112000	19857	10002	3	0	\N
151338	1701	6968078253479	19857	10002	4	0	\N
151339	1701	1438084500103	19857	10002	5	0	\N
151349	1397	1322258360000	19860	10005	0	0	\N
151350	1727	9943379999999	19860	10005	1	0	\N
151351	2133	96928866000	19860	10005	2	0	\N
151352	2134	96486482000	19860	10005	4	0	\N
151353	2132	148285286000	19860	10005	5	0	\N
151354	1397	1322258360000	19861	10005	0	0	\N
151355	1727	9943379999999	19861	10005	1	0	\N
151356	2133	96928866000	19861	10005	2	0	\N
151357	2134	96486482000	19861	10005	4	0	\N
151358	2132	148285286000	19861	10005	5	0	\N
151359	1397	1322258360000	19862	10005	0	0	\N
151360	1727	9943379999999	19862	10005	1	0	\N
151361	2133	96928866000	19862	10005	2	0	\N
151362	2134	96486482000	19862	10005	4	0	\N
151363	2132	148285286000	19862	10005	5	0	\N
151237	2133	96939888000	19839	9995	2	0	2056
151242	1397	1322358370000	19841	9996	0	0	11647
151243	2132	148288289000	19841	9996	1	0	711
151244	2133	96938886000	19841	9996	2	0	2057
151245	2134	96496512000	19841	9996	3	0	2496
151247	2133	96937884000	19842	9997	1	0	2058
151248	2134	96495509000	19842	9997	2	0	2497
151258	1397	1322338368000	19846	9998	0	0	11649
151259	1397	1322328367000	19846	9998	1	0	11650
151260	2134	96494506000	19846	9998	2	0	2498
151262	2133	96936882000	19846	9998	4	0	2059
151263	2133	96935880000	19846	9998	5	0	2060
151264	2132	148287288000	19846	9998	6	0	712
151290	1397	1322318366000	19848	9999	0	0	11651
151292	1701	13535123874296	19848	9999	2	0	10
151293	1397	1322308365000	19849	10000	0	0	11652
151294	2134	96492500000	19849	10000	1	0	2500
151295	2134	96491497000	19849	10000	2	0	2501
151296	1726	50540112000	19849	10000	3	0	8245
151298	2133	96933876000	19849	10000	5	0	2062
151316	1397	1322298364000	19853	10001	0	0	11653
151317	1985	1196990000000	19853	10001	1	0	1
151318	2134	96490494000	19853	10001	2	0	2502
151319	1701	8952581783976	19853	10001	3	0	12
151321	2133	96932874000	19853	10001	5	0	2063
151328	1397	1322288363000	19856	10002	0	0	11654
151329	2133	96931872000	19856	10002	1	0	2064
151330	2134	96489491000	19856	10002	2	0	2503
151332	1701	6968078253479	19856	10002	4	0	13
151333	1701	1438084500103	19856	10002	5	0	14
151340	623	66719940000000	19858	10003	0	0	1
151341	1397	1322278362000	19858	10003	1	0	11655
151342	2133	96930870000	19858	10003	2	0	2065
151344	1397	1322268361000	19859	10004	0	0	11656
151345	2134	96487485000	19859	10004	1	0	2505
151346	1727	16666881999999	19859	10004	2	0	8
151347	1727	12652180999999	19859	10004	3	0	9
151348	2133	96929868000	19859	10004	4	0	2066
151365	1727	9943379999999	19863	10005	1	0	10
151366	2133	96928866000	19863	10005	2	0	2067
151367	2134	96486482000	19863	10005	4	0	2506
151368	2132	148285286000	19863	10005	5	0	714
151396	1727	2395169999999	19867	10008	0	0	\N
151397	1727	2101059999999	19867	10008	1	0	\N
151398	2233	89999999	19867	10008	2	0	\N
151399	1397	1322228357000	19867	10008	3	0	\N
151400	1397	1322218356000	19867	10008	4	0	\N
151401	1397	1322208355000	19867	10008	5	0	\N
151402	1397	1322198354000	19867	10008	6	0	\N
151403	1397	1322188353000	19867	10008	7	0	\N
151404	2132	148284285000	19867	10008	8	0	\N
151405	2134	96483473000	19867	10008	9	0	\N
151406	2132	148283284000	19867	10008	10	0	\N
151407	2133	96925860000	19867	10008	11	0	\N
151408	2133	96924858000	19867	10008	12	0	\N
151409	2133	96923856000	19867	10008	13	0	\N
151410	2133	96922854000	19867	10008	14	0	\N
151411	2133	96921852000	19867	10008	15	0	\N
151412	2134	96482470000	19867	10008	16	0	\N
151413	2134	96481467000	19867	10008	17	0	\N
151414	2134	96480464000	19867	10008	18	0	\N
151415	2134	96479461000	19867	10008	19	0	\N
151416	1727	2395169999999	19868	10008	0	0	\N
151417	1727	2101059999999	19868	10008	1	0	\N
151418	2233	89999999	19868	10008	2	0	\N
151419	1397	1322228357000	19868	10008	3	0	\N
151420	1397	1322218356000	19868	10008	4	0	\N
151421	1397	1322208355000	19868	10008	5	0	\N
151422	1397	1322198354000	19868	10008	6	0	\N
151423	1397	1322188353000	19868	10008	7	0	\N
151424	2132	148284285000	19868	10008	8	0	\N
151425	2134	96483473000	19868	10008	9	0	\N
151426	2132	148283284000	19868	10008	10	0	\N
151427	2133	96925860000	19868	10008	11	0	\N
151428	2133	96924858000	19868	10008	12	0	\N
151429	2133	96923856000	19868	10008	13	0	\N
151430	2133	96922854000	19868	10008	14	0	\N
151431	2133	96921852000	19868	10008	15	0	\N
151432	2134	96482470000	19868	10008	16	0	\N
151433	2134	96481467000	19868	10008	17	0	\N
151434	2134	96480464000	19868	10008	18	0	\N
151435	2134	96479461000	19868	10008	19	0	\N
151436	1397	1322178352000	19869	10009	0	0	\N
151437	2133	96920850000	19869	10009	1	0	\N
151438	2134	96478458000	19869	10009	2	0	\N
151442	1397	1322178352000	19871	10009	0	0	\N
151443	2133	96920850000	19871	10009	1	0	\N
151444	2134	96478458000	19871	10009	2	0	\N
151448	1397	1322168351000	19873	10010	0	0	\N
151449	2134	96477455000	19873	10010	1	0	\N
151450	1397	1322158350000	19874	10011	0	0	\N
151451	2133	96918846000	19874	10011	1	0	\N
151452	2132	148282283000	19874	10011	2	0	\N
151453	2134	96476452000	19874	10011	3	0	\N
151454	623	66719940000000	19875	9992	0	0	\N
151455	2233	119999999	19875	9992	1	0	\N
151456	2233	89999999	19875	9992	2	0	\N
151457	1985	1196990000000	19875	9992	3	0	\N
151458	1727	16666881999999	19875	9992	4	0	\N
151459	1727	12652180999999	19875	9992	5	0	\N
151460	1727	9943379999999	19875	9992	6	0	\N
151461	1727	2395178999999	19875	9992	7	0	\N
151462	1727	2101077999999	19875	9992	8	0	\N
151463	1701	13535123874296	19875	9992	9	0	\N
151464	1726	50540112000	19875	9992	10	0	\N
151465	1726	49339112000	19875	9992	11	0	\N
151466	1701	11893806916880	19875	9992	12	0	\N
151467	1701	8952581783976	19875	9992	13	0	\N
151468	1701	6968078253479	19875	9992	14	0	\N
151469	1701	1438084500103	19875	9992	15	0	\N
151486	623	66719940000000	19880	9935	0	0	\N
151487	1695	9742230999000	19880	9935	1	0	\N
151488	1695	7434130999000	19880	9935	2	0	\N
151489	1695	4014030999000	19880	9935	3	0	\N
151490	1695	2104930999000	19880	9935	4	0	\N
151491	1985	1196990000000	19880	9935	5	0	\N
151492	1727	15946869999999	19880	9935	6	0	\N
151493	1726	58947112000	19880	9935	7	0	\N
151494	2132	148306307000	19880	9935	8	0	\N
151495	1727	11932168999999	19880	9935	9	0	\N
151496	1727	9223367999999	19880	9935	10	0	\N
151497	1727	1675166999999	19880	9935	11	0	\N
151498	1727	1381065999999	19880	9935	12	0	\N
151499	1701	13535123874296	19880	9935	13	0	\N
151500	1726	57746112000	19880	9935	14	0	\N
151501	1726	56545112000	19880	9935	15	0	\N
151502	1726	55344112000	19880	9935	16	0	\N
151503	1726	54143112000	19880	9935	17	0	\N
151504	1701	11893806916880	19880	9935	18	0	\N
151371	2133	96927864000	19864	10006	2	0	2068
151372	1397	1322238358000	19865	10007	0	0	11659
151373	2233	119999999	19865	10007	1	0	5
151374	2134	96484476000	19865	10007	2	0	2508
151375	2133	96926862000	19865	10007	3	0	2069
151377	1727	2101059999999	19866	10008	1	0	12
151378	2233	89999999	19866	10008	2	0	6
151379	1397	1322228357000	19866	10008	3	0	11660
151380	1397	1322218356000	19866	10008	4	0	11661
151381	1397	1322208355000	19866	10008	5	0	11662
151383	1397	1322188353000	19866	10008	7	0	11664
151384	2132	148284285000	19866	10008	8	0	715
151385	2134	96483473000	19866	10008	9	0	2509
151386	2132	148283284000	19866	10008	10	0	716
151388	2133	96924858000	19866	10008	12	0	2071
151389	2133	96923856000	19866	10008	13	0	2072
151390	2133	96922854000	19866	10008	14	0	2073
151391	2133	96921852000	19866	10008	15	0	2074
151392	2134	96482470000	19866	10008	16	0	2510
151394	2134	96480464000	19866	10008	18	0	2512
151395	2134	96479461000	19866	10008	19	0	2513
151439	1397	1322178352000	19870	10009	0	0	11665
151440	2133	96920850000	19870	10009	1	0	2075
151441	2134	96478458000	19870	10009	2	0	2514
151446	2133	96919848000	19872	10010	1	0	2076
151447	2134	96477455000	19872	10010	2	0	2515
151470	1397	1322158350000	19876	10011	0	0	11667
151471	2133	96918846000	19876	10011	1	0	2077
151473	2134	96476452000	19876	10011	3	0	2516
151474	1397	1322148349000	19877	10012	0	0	11668
151475	2133	96917844000	19877	10012	1	0	2078
151476	1397	1322138348000	19878	10013	0	0	11669
151477	2133	96916842000	19878	10013	1	0	2079
151479	1397	1322128347000	19879	10014	0	0	11670
151480	1397	1322118346000	19879	10014	1	0	11671
151481	2132	148281282000	19879	10014	2	0	718
151482	2133	96915840000	19879	10014	3	0	2080
151483	2133	96914838000	19879	10014	4	0	2081
151485	2134	96473443000	19879	10014	6	0	2519
151505	1701	8952581783976	19880	9935	19	0	\N
151506	2132	148305306000	19880	9935	20	0	\N
151507	2132	148304305000	19880	9935	21	0	\N
151508	2132	148303304000	19880	9935	22	0	\N
151509	1701	6968078253479	19880	9935	23	0	\N
151510	1701	1438084500103	19880	9935	24	0	\N
151511	1726	52942112000	19880	9935	25	0	\N
151512	1726	51741112000	19880	9935	26	0	\N
151513	1726	50540112000	19880	9935	27	0	\N
151514	1726	49339112000	19880	9935	28	0	\N
151515	2132	148302303000	19880	9935	29	0	\N
151516	2132	148301302000	19880	9935	30	0	\N
151517	2132	148300301000	19880	9935	31	0	\N
151518	2132	148299300000	19880	9935	32	0	\N
151519	2132	148298299000	19880	9935	33	0	\N
151520	2132	148297298000	19880	9935	34	0	\N
151521	2132	148296297000	19880	9935	35	0	\N
151522	2132	148295296000	19880	9935	36	0	\N
151523	2132	148294295000	19880	9935	37	0	\N
151524	2132	148293294000	19880	9935	38	0	\N
151525	2132	148292293000	19880	9935	39	0	\N
151526	2132	148291292000	19880	9935	40	0	\N
151527	2132	148290291000	19880	9935	41	0	\N
151528	2132	148289290000	19880	9935	42	0	\N
151529	2132	148288289000	19880	9935	43	0	\N
151530	2132	148287288000	19880	9935	44	0	\N
151531	2132	148286287000	19880	9935	45	0	\N
151532	2132	148285286000	19880	9935	46	0	\N
151533	2132	148284285000	19880	9935	47	0	\N
151534	2132	148283284000	19880	9935	48	0	\N
151535	2132	148282283000	19880	9935	49	0	\N
151536	2132	148281282000	19880	9935	50	0	\N
151540	1397	1322108345000	19882	10015	0	0	\N
151541	2133	96913836000	19882	10015	1	0	\N
151542	2134	96472440000	19882	10015	2	0	\N
151543	1397	1322108345000	19883	10015	0	0	\N
151544	2134	96472440000	19883	10015	1	0	\N
151552	1397	1322078342000	19885	10017	0	0	\N
151553	2133	96910830000	19885	10017	1	0	\N
151554	1397	1322078342000	19886	10017	0	0	\N
151555	2134	96469431000	19886	10017	1	0	\N
151556	2133	96910830000	19886	10017	2	0	\N
151581	1397	1322038338000	19891	10020	0	0	\N
151582	1711	18851854000000	19891	10020	1	0	\N
151583	1711	15764344000000	19891	10020	2	0	\N
151584	1711	11188834000000	19891	10020	3	0	\N
151585	1397	1322028337000	19891	10020	4	0	\N
151586	1711	2586324000000	19891	10020	5	0	\N
151587	2133	96906822000	19891	10020	6	0	\N
151588	2134	96465419000	19891	10020	7	0	\N
151589	2134	96464416000	19891	10020	8	0	\N
151590	2133	96905820000	19891	10020	9	0	\N
151591	2132	148278279000	19891	10020	10	0	\N
151596	1397	1322018336000	19893	10021	0	0	\N
151597	2233	88969999	19893	10021	1	0	\N
151598	2133	96904818000	19893	10021	2	0	\N
151599	2134	96463413000	19893	10021	3	0	\N
151600	1397	1322018336000	19894	10021	0	0	\N
151601	2233	88969999	19894	10021	1	0	\N
151602	2133	96904818000	19894	10021	2	0	\N
151603	2134	96463413000	19894	10021	3	0	\N
151604	1397	1322018336000	19895	10021	0	0	\N
151605	2233	88969999	19895	10021	1	0	\N
151606	2133	96904818000	19895	10021	2	0	\N
151607	2134	96463413000	19895	10021	3	0	\N
151608	1397	1322018336000	19896	10021	0	0	\N
151609	2233	88969999	19896	10021	1	0	\N
151610	2133	96904818000	19896	10021	2	0	\N
151611	2134	96463413000	19896	10021	3	0	\N
151612	1397	1322008335000	19897	10022	0	0	\N
151613	2133	96903816000	19897	10022	1	0	\N
151614	1727	0	19897	10022	2	0	\N
151615	2134	96462410000	19897	10022	3	0	\N
151616	1397	1322008335000	19898	10022	0	0	\N
151617	2133	96903816000	19898	10022	1	0	\N
151618	1727	0	19898	10022	2	0	\N
151619	2134	96462410000	19898	10022	3	0	\N
151620	1397	1322008335000	19899	10022	0	0	\N
151621	2133	96903816000	19899	10022	1	0	\N
151622	1727	0	19899	10022	2	0	\N
151623	2134	96462410000	19899	10022	3	0	\N
151635	1397	1321998334000	19902	10023	0	0	\N
151636	1397	1321988333000	19902	10023	1	0	\N
151637	2134	96461407000	19902	10023	2	0	\N
151638	2134	96460404000	19902	10023	3	0	\N
151639	2133	96902814000	19902	10023	4	0	\N
151640	2133	96901812000	19902	10023	5	0	\N
151539	2134	96472440000	19881	10015	2	0	2520
151545	1397	1322098344000	19884	10016	0	0	11673
151546	1397	1322088343000	19884	10016	1	0	11674
151547	2134	96471437000	19884	10016	2	0	2521
151548	2134	96470434000	19884	10016	3	0	2522
151550	2133	96912834000	19884	10016	5	0	2083
151551	2133	96911832000	19884	10016	6	0	2084
151557	1397	1322078342000	19887	10017	0	0	11675
151558	2134	96469431000	19887	10017	1	0	2523
151559	2133	96910830000	19887	10017	2	0	2085
151561	2134	96468428000	19888	10018	1	0	2524
151562	2133	96909828000	19888	10018	2	0	2086
151563	1397	1322058340000	19889	10019	0	0	11677
151564	1397	1322048339000	19889	10019	1	0	11678
151566	2133	96908826000	19889	10019	3	0	2087
151567	2133	96907824000	19889	10019	4	0	2088
151568	2134	96467425000	19889	10019	5	0	2525
151569	2134	96466422000	19889	10019	6	0	2526
151570	1397	1322038338000	19890	10020	0	0	11679
151572	1711	15764344000000	19890	10020	2	0	11
151573	1711	11188834000000	19890	10020	3	0	12
151574	1397	1322028337000	19890	10020	4	0	11680
151575	1711	2586324000000	19890	10020	5	0	13
151576	2133	96906822000	19890	10020	6	0	2089
151578	2134	96464416000	19890	10020	8	0	2528
151579	2133	96905820000	19890	10020	9	0	2090
151580	2132	148278279000	19890	10020	10	0	721
151592	1397	1322018336000	19892	10021	0	0	11681
151594	2133	96904818000	19892	10021	2	0	2091
151595	2134	96463413000	19892	10021	3	0	2529
151624	1397	1322008335000	19900	10022	0	0	11682
151625	2133	96903816000	19900	10022	1	0	2092
151626	1727	0	19900	10022	2	0	13
151628	1397	1321998334000	19901	10023	0	0	11683
151629	1397	1321988333000	19901	10023	1	0	11684
151630	2134	96461407000	19901	10023	2	0	2531
151631	2134	96460404000	19901	10023	3	0	2532
151632	2133	96902814000	19901	10023	4	0	2093
151634	2132	148277278000	19901	10023	6	0	722
151641	2132	148277278000	19902	10023	6	0	\N
151642	1397	1321978332000	19903	10024	0	0	\N
151643	2133	96900810000	19903	10024	1	0	\N
151644	2134	96459401000	19903	10024	2	0	\N
151648	1397	1321968331000	19905	10025	0	0	\N
151649	1397	1321958330000	19905	10025	1	0	\N
151650	1397	1321948329000	19905	10025	2	0	\N
151651	2132	148276277000	19905	10025	3	0	\N
151652	2134	96458398000	19905	10025	4	0	\N
151653	2134	96457395000	19905	10025	5	0	\N
151654	2134	96456392000	19905	10025	6	0	\N
151655	2133	96899808000	19905	10025	7	0	\N
151656	2133	96898806000	19905	10025	8	0	\N
151657	2133	96897804000	19905	10025	9	0	\N
151668	1397	1321968331000	19907	10025	0	0	\N
151669	1397	1321958330000	19907	10025	1	0	\N
151670	1397	1321948329000	19907	10025	2	0	\N
151671	2132	148276277000	19907	10025	3	0	\N
151672	2134	96458398000	19907	10025	4	0	\N
151673	2134	96457395000	19907	10025	5	0	\N
151674	2134	96456392000	19907	10025	6	0	\N
151675	2133	96899808000	19907	10025	7	0	\N
151676	2133	96898806000	19907	10025	8	0	\N
151677	2133	96897804000	19907	10025	9	0	\N
151678	1455	10978017000000	19908	10026	0	0	\N
151679	1397	1321938328000	19908	10026	1	0	\N
151680	2133	96896802000	19908	10026	2	0	\N
151681	2134	96455389000	19908	10026	3	0	\N
151686	1455	10978017000000	19910	10026	0	0	\N
151687	1397	1321938328000	19910	10026	1	0	\N
151688	2133	96896802000	19910	10026	2	0	\N
151689	2134	96455389000	19910	10026	3	0	\N
151690	1455	9492917000000	19911	10027	0	0	\N
151691	1455	6831817000000	19911	10027	1	0	\N
151692	1397	1321928327000	19911	10027	2	0	\N
151693	2134	96454386000	19911	10027	3	0	\N
151694	2132	148275276000	19911	10027	4	0	\N
151695	2133	96895800000	19911	10027	5	0	\N
151706	1455	5035717000000	19914	10028	0	0	\N
151707	1397	1321918326000	19914	10028	1	0	\N
151708	2133	96894798000	19914	10028	2	0	\N
151709	2134	96453383000	19914	10028	3	0	\N
151730	1643	1148524914700	19919	10032	0	0	\N
151731	1397	1321878322000	19919	10032	1	0	\N
151732	1397	1321868321000	19919	10032	2	0	\N
151733	2134	96449371000	19919	10032	3	0	\N
151734	2134	96448368000	19919	10032	4	0	\N
151735	2133	96890790000	19919	10032	5	0	\N
151736	2133	96889788000	19919	10032	6	0	\N
151737	1397	1321858320000	19920	10033	0	0	\N
151738	2133	96888786000	19920	10033	1	0	\N
151739	2132	148273274000	19920	10033	2	0	\N
151740	2134	96447365000	19920	10033	3	0	\N
151741	1455	10978017000000	19921	9993	0	0	\N
151742	1455	9492917000000	19921	9993	1	0	\N
151743	1455	6831817000000	19921	9993	2	0	\N
151744	1455	5035717000000	19921	9993	3	0	\N
151745	1455	31617000000	19921	9993	4	0	\N
151746	1643	2262511437200	19921	9993	5	0	\N
151747	1711	18851854000000	19921	9993	6	0	\N
151748	1711	15764344000000	19921	9993	7	0	\N
151749	1711	11188834000000	19921	9993	8	0	\N
151750	1643	1763586477100	19921	9993	9	0	\N
151751	1643	1426948612000	19921	9993	10	0	\N
151752	1643	1148524914700	19921	9993	11	0	\N
151753	1711	2586324000000	19921	9993	12	0	\N
151754	2233	88969999	19921	9993	13	0	\N
151755	1727	18000000	19921	9993	14	0	\N
151761	2133	96887784000	19924	10034	0	0	\N
151762	1397	1321848319000	19925	10035	0	0	\N
151763	2133	96886782000	19925	10035	1	0	\N
151764	2134	96446362000	19925	10035	2	0	\N
151772	1397	1321828317000	19928	10037	0	0	\N
151773	2134	96444356000	19928	10037	1	0	\N
151774	2133	96884778000	19928	10037	2	0	\N
151647	2134	96459401000	19904	10024	2	0	2533
151658	1397	1321968331000	19906	10025	0	0	11686
151659	1397	1321958330000	19906	10025	1	0	11687
151660	1397	1321948329000	19906	10025	2	0	11688
151661	2132	148276277000	19906	10025	3	0	723
151663	2134	96457395000	19906	10025	5	0	2535
151664	2134	96456392000	19906	10025	6	0	2536
151665	2133	96899808000	19906	10025	7	0	2096
151666	2133	96898806000	19906	10025	8	0	2097
151667	2133	96897804000	19906	10025	9	0	2098
151683	1397	1321938328000	19909	10026	1	0	11689
151684	2133	96896802000	19909	10026	2	0	2099
151685	2134	96455389000	19909	10026	3	0	2537
151696	1455	9492917000000	19912	10027	0	0	7
151698	1397	1321928327000	19912	10027	2	0	11690
151699	2134	96454386000	19912	10027	3	0	2538
151700	2132	148275276000	19912	10027	4	0	724
151701	2133	96895800000	19912	10027	5	0	2100
151702	1455	5035717000000	19913	10028	0	0	9
151704	2133	96894798000	19913	10028	2	0	2101
151705	2134	96453383000	19913	10028	3	0	2539
151710	1397	1321908325000	19915	10029	0	0	11692
151711	2134	96452380000	19915	10029	1	0	2540
151712	2133	96893796000	19915	10029	2	0	2102
151714	1397	1321898324000	19916	10030	1	0	11693
151715	2134	96451377000	19916	10030	2	0	2541
151716	2133	96892794000	19916	10030	3	0	2103
151717	2132	148274275000	19916	10030	4	0	725
151719	1643	1763586477100	19917	10031	1	0	23
151720	1643	1426948612000	19917	10031	2	0	24
151721	2133	96891792000	19917	10031	3	0	2104
151722	2134	96450374000	19917	10031	4	0	2542
151723	1643	1148524914700	19918	10032	0	0	25
151725	1397	1321868321000	19918	10032	2	0	11696
151726	2134	96449371000	19918	10032	3	0	2543
151727	2134	96448368000	19918	10032	4	0	2544
151728	2133	96890790000	19918	10032	5	0	2105
151729	2133	96889788000	19918	10032	6	0	2106
151757	2133	96888786000	19922	10033	1	0	2107
151758	2132	148273274000	19922	10033	2	0	726
151759	2134	96447365000	19922	10033	3	0	2545
151760	2133	96887784000	19923	10034	0	0	2108
151766	2133	96886782000	19926	10035	1	0	2109
151767	2134	96446362000	19926	10035	2	0	2546
151768	1397	1321838318000	19927	10036	0	0	11699
151769	2134	96445359000	19927	10036	1	0	2547
151770	2132	148272273000	19927	10036	2	0	727
151775	2133	96884778000	19929	10037	0	0	2111
151776	1397	1321828317000	19930	10038	0	0	11700
151781	1397	1321828317000	19931	10038	0	0	\N
151782	1397	1321818316000	19931	10038	1	0	\N
151783	2133	96883776000	19931	10038	2	0	\N
151784	2134	96444356000	19931	10038	3	0	\N
151785	2134	96443353000	19931	10038	4	0	\N
151786	1397	1321828317000	19932	10038	0	0	\N
151787	1397	1321818316000	19932	10038	1	0	\N
151788	2133	96883776000	19932	10038	2	0	\N
151789	2134	96444356000	19932	10038	3	0	\N
151790	2134	96443353000	19932	10038	4	0	\N
151795	1397	1321808315000	19934	10039	0	0	\N
151796	2134	96442350000	19934	10039	1	0	\N
151797	2132	148271272000	19934	10039	2	0	\N
151798	2133	96882774000	19934	10039	3	0	\N
151801	1397	1321798314000	19936	10040	0	0	\N
151802	2134	96441347000	19936	10040	1	0	\N
151803	1397	1321798314000	19937	10040	0	0	\N
151804	2134	96441347000	19937	10040	1	0	\N
151805	1397	1321788313000	19938	10041	0	0	\N
151806	2133	96881772000	19938	10041	1	0	\N
151807	2134	96440344000	19938	10041	2	0	\N
151808	1397	1321788313000	19939	10041	0	0	\N
151809	2133	96881772000	19939	10041	1	0	\N
151810	2134	96440344000	19939	10041	2	0	\N
151814	1397	1321788313000	19941	10041	0	0	\N
151815	2133	96881772000	19941	10041	1	0	\N
151816	2134	96440344000	19941	10041	2	0	\N
151817	1397	1321788313000	19942	10041	0	0	\N
151818	2133	96881772000	19942	10041	1	0	\N
151819	2134	96440344000	19942	10041	2	0	\N
151820	1397	1321788313000	19943	10041	0	0	\N
151821	2133	96881772000	19943	10041	1	0	\N
151822	2134	96440344000	19943	10041	2	0	\N
151823	1455	10978017000000	19944	9926	0	0	\N
151824	623	66719940000000	19944	9926	1	0	\N
151825	1695	9742230999000	19944	9926	2	0	\N
151826	1695	7434130999000	19944	9926	3	0	\N
151827	1695	4014030999000	19944	9926	4	0	\N
151828	1695	2104930999000	19944	9926	5	0	\N
151829	1455	9492917000000	19944	9926	6	0	\N
151830	1455	6831817000000	19944	9926	7	0	\N
151831	1455	5035717000000	19944	9926	8	0	\N
151832	1455	31617000000	19944	9926	9	0	\N
151833	1643	2262511437200	19944	9926	10	0	\N
151834	1711	18131842000000	19944	9926	11	0	\N
151835	1711	15044332000000	19944	9926	12	0	\N
151836	1397	1323028437000	19944	9926	13	0	\N
151837	1711	10468822000000	19944	9926	14	0	\N
151838	1397	1323018436000	19944	9926	15	0	\N
151839	1397	1323008435000	19944	9926	16	0	\N
151840	1397	1322998434000	19944	9926	17	0	\N
151841	1397	1322988433000	19944	9926	18	0	\N
151842	1643	1763586477100	19944	9926	19	0	\N
151843	1643	1426948612000	19944	9926	20	0	\N
151844	1643	1148524914700	19944	9926	21	0	\N
151845	1397	1322978432000	19944	9926	22	0	\N
151846	1397	1322968431000	19944	9926	23	0	\N
151847	1397	1322958430000	19944	9926	24	0	\N
151848	1397	1322948429000	19944	9926	25	0	\N
151849	1397	1322938428000	19944	9926	26	0	\N
151850	1397	1322928427000	19944	9926	27	0	\N
151851	1397	1322918426000	19944	9926	28	0	\N
151852	1985	1196990000000	19944	9926	29	0	\N
151853	1397	1322908425000	19944	9926	30	0	\N
151854	1397	1322898424000	19944	9926	31	0	\N
151855	1397	1322888423000	19944	9926	32	0	\N
151856	1397	1322878422000	19944	9926	33	0	\N
151857	1397	1322868421000	19944	9926	34	0	\N
151858	1397	1322858420000	19944	9926	36	0	\N
151859	1397	1322848419000	19944	9926	37	0	\N
151860	1397	1322838418000	19944	9926	38	0	\N
151861	1397	1322828417000	19944	9926	39	0	\N
151862	1397	1322818416000	19944	9926	40	0	\N
151863	1397	1322808415000	19944	9926	41	0	\N
151864	1397	1322798414000	19944	9926	42	0	\N
151865	1397	1322788413000	19944	9926	43	0	\N
151866	1397	1322778412000	19944	9926	44	0	\N
151867	1397	1322768411000	19944	9926	45	0	\N
151868	1397	1322758410000	19944	9926	46	0	\N
151869	1397	1322748409000	19944	9926	47	0	\N
151870	1397	1322738408000	19944	9926	48	0	\N
151871	1397	1322728407000	19944	9926	49	0	\N
151872	1397	1322718406000	19944	9926	50	0	\N
151873	1397	1322708405000	19944	9926	51	0	\N
151874	1397	1322698404000	19944	9926	52	0	\N
151875	1397	1322688403000	19944	9926	53	0	\N
151876	1397	1322678402000	19944	9926	54	0	\N
151877	1397	1322668401000	19944	9926	55	0	\N
151878	1397	1322658400000	19944	9926	56	0	\N
151879	1397	1322648399000	19944	9926	57	0	\N
151880	1397	1322638398000	19944	9926	58	0	\N
151881	1397	1322628397000	19944	9926	59	0	\N
151882	1397	1322618396000	19944	9926	60	0	\N
151883	1397	1322608395000	19944	9926	61	0	\N
151884	1397	1322598394000	19944	9926	62	0	\N
151885	1397	1322588393000	19944	9926	63	0	\N
151886	1397	1322578392000	19944	9926	64	0	\N
151887	1397	1322568391000	19944	9926	65	0	\N
151888	1711	1866312000000	19944	9926	66	0	\N
151889	1397	1322558390000	19944	9926	67	0	\N
151890	1397	1322548389000	19944	9926	68	0	\N
151891	1397	1322538388000	19944	9926	69	0	\N
151892	1397	1322528387000	19944	9926	70	0	\N
151893	1397	1322518386000	19944	9926	71	0	\N
151894	1397	1322508385000	19944	9926	72	0	\N
151895	1397	1322498384000	19944	9926	73	0	\N
151896	1397	1322488383000	19944	9926	74	0	\N
151897	1397	1322478382000	19944	9926	75	0	\N
151898	1397	1322468381000	19944	9926	76	0	\N
151899	1397	1322458380000	19944	9926	77	0	\N
151900	1397	1322448379000	19944	9926	78	0	\N
151901	1397	1322438378000	19944	9926	79	0	\N
151902	1397	1322428377000	19944	9926	80	0	\N
151903	1397	1322418376000	19944	9926	81	0	\N
151904	1397	1322408375000	19944	9926	82	0	\N
151905	1397	1322398374000	19944	9926	83	0	\N
151906	1397	1322388373000	19944	9926	84	0	\N
151907	1397	1322378372000	19944	9926	85	0	\N
151908	1397	1322368371000	19944	9926	86	0	\N
151909	1397	1322358370000	19944	9926	87	0	\N
151910	1397	1322348369000	19944	9926	88	0	\N
151911	1397	1322338368000	19944	9926	89	0	\N
151912	1397	1322328367000	19944	9926	90	0	\N
151779	2134	96444356000	19930	10038	3	0	2548
151780	2134	96443353000	19930	10038	4	0	2549
151791	1397	1321808315000	19933	10039	0	0	11702
151792	2134	96442350000	19933	10039	1	0	2550
151793	2132	148271272000	19933	10039	2	0	728
151799	1397	1321798314000	19935	10040	0	0	11703
151800	2134	96441347000	19935	10040	1	0	2551
151811	1397	1321788313000	19940	10041	0	0	11704
151812	2133	96881772000	19940	10041	1	0	2114
151813	2134	96440344000	19940	10041	2	0	2552
151913	1397	1322318366000	19944	9926	91	0	\N
151914	1397	1322308365000	19944	9926	92	0	\N
151915	1397	1322298364000	19944	9926	93	0	\N
151916	1397	1322288363000	19944	9926	94	0	\N
151917	1397	1322278362000	19944	9926	95	0	\N
151918	1397	1322268361000	19944	9926	96	0	\N
151919	1397	1322258360000	19944	9926	97	0	\N
151920	1397	1322248359000	19944	9926	98	0	\N
151921	1397	1322238358000	19944	9926	99	0	\N
151922	1397	1322228357000	19944	9926	100	0	\N
151923	1397	1322218356000	19944	9926	101	0	\N
151924	1397	1322208355000	19944	9926	102	0	\N
151925	1397	1322198354000	19944	9926	103	0	\N
151926	1397	1322188353000	19944	9926	104	0	\N
151927	1397	1322178352000	19944	9926	105	0	\N
151928	1397	1322168351000	19944	9926	106	0	\N
151929	1397	1322158350000	19944	9926	107	0	\N
151930	1397	1322148349000	19944	9926	108	0	\N
151931	1397	1322138348000	19944	9926	109	0	\N
151932	1397	1322128347000	19944	9926	110	0	\N
151933	1397	1322118346000	19944	9926	111	0	\N
151934	1397	1322108345000	19944	9926	112	0	\N
151935	1397	1322098344000	19944	9926	113	0	\N
151936	1397	1322088343000	19944	9926	114	0	\N
151937	1397	1322078342000	19944	9926	115	0	\N
151938	1397	1322068341000	19944	9926	116	0	\N
151939	1397	1322058340000	19944	9926	117	0	\N
151940	1397	1322048339000	19944	9926	118	0	\N
151941	1397	1322038338000	19944	9926	119	0	\N
151942	1397	1322028337000	19944	9926	120	0	\N
151943	1397	1322018336000	19944	9926	121	0	\N
151944	1397	1322008335000	19944	9926	122	0	\N
151945	1397	1321998334000	19944	9926	123	0	\N
151946	1397	1321988333000	19944	9926	124	0	\N
151947	1397	1321978332000	19944	9926	125	0	\N
151965	1397	1321728307000	19948	10045	0	0	\N
151966	1397	1321718306000	19948	10045	1	0	\N
151967	1571	3839779792276	19948	10045	2	0	\N
151968	1571	3475047490484	19948	10045	3	0	\N
151969	1397	1321708305000	19948	10045	4	0	\N
151970	1571	2821458250612	19948	10045	5	0	\N
151971	1571	2380465313984	19948	10045	6	0	\N
151972	1571	1151617151056	19948	10045	7	0	\N
151973	2133	96875760000	19948	10045	8	0	\N
151974	2134	96434326000	19948	10045	9	0	\N
151975	2134	96433323000	19948	10045	10	0	\N
151976	2134	96432320000	19948	10045	11	0	\N
151977	2132	148268269000	19948	10045	12	0	\N
151978	2133	96874758000	19948	10045	13	0	\N
151979	2133	96873756000	19948	10045	14	0	\N
151998	1397	1321698304000	19951	10046	0	0	\N
151999	2133	96872754000	19951	10046	1	0	\N
152000	2134	96431317000	19951	10046	2	0	\N
152001	1397	1321698304000	19952	10046	0	0	\N
152002	2133	96872754000	19952	10046	1	0	\N
152003	2134	96431317000	19952	10046	2	0	\N
152014	1397	1321658300000	19954	10048	0	0	\N
152015	1397	1321648299000	19954	10048	1	0	\N
152016	1397	1321638298000	19954	10048	2	0	\N
152017	1397	1321628297000	19954	10048	3	0	\N
152018	2133	96868746000	19954	10048	4	0	\N
152019	2134	96427305000	19954	10048	5	0	\N
152020	2134	96426302000	19954	10048	6	0	\N
152021	2134	96425299000	19954	10048	7	0	\N
152022	2134	96424296000	19954	10048	8	0	\N
152023	2133	96867744000	19954	10048	9	0	\N
152024	2133	96866742000	19954	10048	10	0	\N
152025	2133	96865740000	19954	10048	11	0	\N
152026	2132	148266267000	19954	10048	12	0	\N
152047	1455	10978017000000	19958	9961	0	0	\N
152048	623	66719940000000	19958	9961	1	0	\N
151950	2134	96439341000	19945	10042	2	0	2553
151951	2132	148270271000	19945	10042	3	0	729
151952	2134	96438338000	19945	10042	4	0	2554
151953	2133	96880770000	19945	10042	5	0	2115
151954	2133	96879768000	19945	10042	6	0	2116
151956	2134	96437335000	19946	10043	1	0	2555
151957	2133	96878766000	19946	10043	2	0	2117
151958	1397	1321748309000	19947	10044	0	0	11708
151959	1397	1321738308000	19947	10044	1	0	11709
151960	2133	96877764000	19947	10044	2	0	2118
151962	2134	96435329000	19947	10044	4	0	2557
151963	2133	96876762000	19947	10044	5	0	2119
151964	2132	148269270000	19947	10044	6	0	730
151980	1397	1321728307000	19949	10045	0	0	11710
151982	1571	3839779792276	19949	10045	2	0	37
151983	1571	3475047490484	19949	10045	3	0	38
151984	1397	1321708305000	19949	10045	4	0	11712
151985	1571	2821458250612	19949	10045	5	0	39
151986	1571	2380465313984	19949	10045	6	0	40
151988	2133	96875760000	19949	10045	8	0	2120
151989	2134	96434326000	19949	10045	9	0	2558
151990	2134	96433323000	19949	10045	10	0	2559
151991	2134	96432320000	19949	10045	11	0	2560
151992	2132	148268269000	19949	10045	12	0	731
151994	2133	96873756000	19949	10045	14	0	2122
151995	1397	1321698304000	19950	10046	0	0	11713
151996	2133	96872754000	19950	10046	1	0	2123
151997	2134	96431317000	19950	10046	2	0	2561
152005	1397	1321678302000	19953	10047	1	0	11715
152006	1397	1321668301000	19953	10047	2	0	11716
152007	2132	148267268000	19953	10047	3	0	732
152008	2133	96871752000	19953	10047	4	0	2124
152009	2133	96870750000	19953	10047	5	0	2125
152011	2134	96430314000	19953	10047	7	0	2562
152012	2134	96429311000	19953	10047	8	0	2563
152013	2134	96428308000	19953	10047	9	0	2564
152027	1397	1321658300000	19955	10048	0	0	11717
152028	1397	1321648299000	19955	10048	1	0	11718
152030	1397	1321628297000	19955	10048	3	0	11720
152031	2132	148266267000	19955	10048	4	0	733
152032	1397	1321618296000	19956	10049	0	0	11721
152033	2133	96868746000	19956	10049	1	0	2127
152035	2134	96426302000	19956	10049	3	0	2566
152036	2134	96425299000	19956	10049	4	0	2567
152037	2134	96424296000	19956	10049	5	0	2568
152038	2134	96423293000	19956	10049	6	0	2569
152039	2133	96867744000	19956	10049	7	0	2128
152041	2133	96865740000	19956	10049	9	0	2130
152042	2133	96864738000	19956	10049	10	0	2131
152043	1397	1321608295000	19957	10050	0	0	11722
152044	2134	96422290000	19957	10050	1	0	2570
152045	2132	148265266000	19957	10050	2	0	734
152049	1695	9742230999000	19958	9961	2	0	\N
152050	1695	7434130999000	19958	9961	3	0	\N
152051	1695	4014030999000	19958	9961	4	0	\N
152052	1695	2104930999000	19958	9961	5	0	\N
152053	1455	9492917000000	19958	9961	6	0	\N
152054	1455	6831817000000	19958	9961	7	0	\N
152055	1455	5035717000000	19958	9961	8	0	\N
152056	1455	31617000000	19958	9961	9	0	\N
152057	1643	2262511437200	19958	9961	10	0	\N
152058	1711	18851854000000	19958	9961	11	0	\N
152059	1711	15764344000000	19958	9961	12	0	\N
152060	1711	11188834000000	19958	9961	13	0	\N
152061	1571	3839779792276	19958	9961	14	0	\N
152062	1571	3475047490484	19958	9961	15	0	\N
152063	1643	1763586477100	19958	9961	16	0	\N
152064	1643	1426948612000	19958	9961	17	0	\N
152065	1643	1148524914700	19958	9961	18	0	\N
152066	1571	2821458250612	19958	9961	19	0	\N
152067	1571	2380465313984	19958	9961	20	0	\N
152068	1985	1196990000000	19958	9961	21	0	\N
152069	1397	1322828417000	19958	9961	23	0	\N
152070	1397	1322818416000	19958	9961	24	0	\N
152071	1397	1322808415000	19958	9961	25	0	\N
152072	1397	1322798414000	19958	9961	26	0	\N
152073	1397	1322788413000	19958	9961	27	0	\N
152074	1397	1322778412000	19958	9961	28	0	\N
152075	1397	1322768411000	19958	9961	29	0	\N
152076	1397	1322758410000	19958	9961	30	0	\N
152077	1397	1322748409000	19958	9961	31	0	\N
152078	1397	1322738408000	19958	9961	32	0	\N
152079	1397	1322728407000	19958	9961	33	0	\N
152080	1397	1322718406000	19958	9961	34	0	\N
152081	1397	1322708405000	19958	9961	35	0	\N
152082	1397	1322698404000	19958	9961	36	0	\N
152083	1397	1322688403000	19958	9961	37	0	\N
152084	1397	1322678402000	19958	9961	38	0	\N
152085	1397	1322668401000	19958	9961	39	0	\N
152086	1397	1322658400000	19958	9961	40	0	\N
152087	1397	1322648399000	19958	9961	41	0	\N
152088	1397	1322638398000	19958	9961	42	0	\N
152089	1397	1322628397000	19958	9961	43	0	\N
152090	1397	1322618396000	19958	9961	44	0	\N
152091	1397	1322608395000	19958	9961	45	0	\N
152092	1397	1322598394000	19958	9961	46	0	\N
152093	1397	1322588393000	19958	9961	47	0	\N
152094	1397	1322578392000	19958	9961	48	0	\N
152095	1397	1322568391000	19958	9961	49	0	\N
152096	1571	1151617151056	19958	9961	50	0	\N
152097	1711	2586324000000	19958	9961	51	0	\N
152098	1397	1322558390000	19958	9961	52	0	\N
152099	1397	1322548389000	19958	9961	53	0	\N
152100	1397	1322538388000	19958	9961	54	0	\N
152101	1397	1322528387000	19958	9961	55	0	\N
152102	1397	1322518386000	19958	9961	56	0	\N
152103	1397	1322508385000	19958	9961	57	0	\N
152104	1397	1322498384000	19958	9961	58	0	\N
152105	1397	1322488383000	19958	9961	59	0	\N
152106	1397	1322478382000	19958	9961	60	0	\N
152107	1397	1322468381000	19958	9961	61	0	\N
152108	1397	1322458380000	19958	9961	62	0	\N
152109	1397	1322448379000	19958	9961	63	0	\N
152110	1397	1322438378000	19958	9961	64	0	\N
152111	1397	1322428377000	19958	9961	65	0	\N
152112	1397	1322418376000	19958	9961	66	0	\N
152113	1397	1322408375000	19958	9961	67	0	\N
152114	1397	1322398374000	19958	9961	68	0	\N
152115	1397	1322388373000	19958	9961	69	0	\N
152116	1397	1322378372000	19958	9961	70	0	\N
152117	1397	1322368371000	19958	9961	71	0	\N
152118	1397	1322358370000	19958	9961	72	0	\N
152119	1397	1322348369000	19958	9961	73	0	\N
152120	1397	1322338368000	19958	9961	74	0	\N
152121	1397	1322328367000	19958	9961	75	0	\N
152122	1397	1322318366000	19958	9961	76	0	\N
152123	1397	1322308365000	19958	9961	77	0	\N
152124	1397	1322298364000	19958	9961	78	0	\N
152125	1397	1322288363000	19958	9961	79	0	\N
152126	1397	1322278362000	19958	9961	80	0	\N
152127	1397	1322268361000	19958	9961	81	0	\N
152128	1397	1322258360000	19958	9961	82	0	\N
152129	1397	1322248359000	19958	9961	83	0	\N
152130	1397	1322238358000	19958	9961	84	0	\N
152131	1397	1322228357000	19958	9961	85	0	\N
152132	1397	1322218356000	19958	9961	86	0	\N
152133	1397	1322208355000	19958	9961	87	0	\N
152134	1397	1322198354000	19958	9961	88	0	\N
152135	1397	1322188353000	19958	9961	89	0	\N
152136	1397	1322178352000	19958	9961	90	0	\N
152137	1397	1322168351000	19958	9961	91	0	\N
152138	1397	1322158350000	19958	9961	92	0	\N
152139	1397	1322148349000	19958	9961	93	0	\N
152140	1397	1322138348000	19958	9961	94	0	\N
152141	1397	1322128347000	19958	9961	95	0	\N
152142	1397	1322118346000	19958	9961	96	0	\N
152143	1397	1322108345000	19958	9961	97	0	\N
152144	1397	1322098344000	19958	9961	98	0	\N
152145	1397	1322088343000	19958	9961	99	0	\N
152146	1397	1322078342000	19958	9961	100	0	\N
152147	1397	1322068341000	19958	9961	101	0	\N
152148	1397	1322058340000	19958	9961	102	0	\N
152149	1397	1322048339000	19958	9961	103	0	\N
152150	1397	1322038338000	19958	9961	104	0	\N
152151	1397	1322028337000	19958	9961	105	0	\N
152152	1397	1322018336000	19958	9961	106	0	\N
152153	1397	1322008335000	19958	9961	107	0	\N
152154	1397	1321998334000	19958	9961	108	0	\N
152155	1397	1321988333000	19958	9961	109	0	\N
152156	1397	1321978332000	19958	9961	110	0	\N
152157	1397	1321968331000	19958	9961	111	0	\N
152158	1397	1321958330000	19958	9961	112	0	\N
152159	1397	1321948329000	19958	9961	113	0	\N
152160	1397	1321938328000	19958	9961	114	0	\N
152161	1397	1321928327000	19958	9961	115	0	\N
152162	1397	1321918326000	19958	9961	116	0	\N
152163	1397	1321908325000	19958	9961	117	0	\N
152164	1397	1321898324000	19958	9961	118	0	\N
152165	1397	1321888323000	19958	9961	119	0	\N
152166	1397	1321878322000	19958	9961	120	0	\N
152167	1397	1321868321000	19958	9961	121	0	\N
152168	1397	1321858320000	19958	9961	122	0	\N
152169	1397	1321848319000	19958	9961	123	0	\N
152170	1397	1321838318000	19958	9961	124	0	\N
152171	1397	1321828317000	19958	9961	125	0	\N
152175	1397	1321588293000	19960	10052	0	0	\N
152176	2133	96861732000	19960	10052	1	0	\N
152177	2134	96420284000	19960	10052	2	0	\N
152184	1397	1321578292000	19963	10053	0	0	\N
152174	2133	96862734000	19959	10051	2	0	2133
152178	1397	1321588293000	19961	10052	0	0	11724
152179	2133	96861732000	19961	10052	1	0	2134
152180	2134	96420284000	19961	10052	2	0	2572
152181	1397	1321578292000	19962	10053	0	0	11725
152183	2133	96860730000	19962	10053	2	0	2135
152185	2134	96419281000	19963	10053	1	0	\N
152186	2133	96860730000	19963	10053	2	0	\N
152187	1455	10978017000000	19964	9936	0	0	\N
152188	1455	9492917000000	19964	9936	1	0	\N
152189	1455	6831817000000	19964	9936	2	0	\N
152190	1455	5035717000000	19964	9936	3	0	\N
152191	1455	31617000000	19964	9936	4	0	\N
152192	1643	2262511437200	19964	9936	5	0	\N
152193	1711	18851854000000	19964	9936	6	0	\N
152194	1711	15764344000000	19964	9936	7	0	\N
152195	1711	11188834000000	19964	9936	8	0	\N
152196	1571	3839779792276	19964	9936	9	0	\N
152201	1397	1321568291000	19966	10054	0	0	\N
152202	2134	96418278000	19966	10054	1	0	\N
152203	2133	96859728000	19966	10054	2	0	\N
152204	2132	148264265000	19966	10054	3	0	\N
152218	1397	1321518286000	19969	10057	0	0	\N
152219	2134	96413263000	19969	10057	1	0	\N
152220	2133	96854718000	19969	10057	2	0	\N
152224	1397	1321508285000	19971	10058	0	0	\N
152225	1397	1321498284000	19971	10058	1	0	\N
152226	2133	96853716000	19971	10058	2	0	\N
152227	2132	148262263000	19971	10058	3	0	\N
152228	2134	96412260000	19971	10058	4	0	\N
152229	2134	96411257000	19971	10058	5	0	\N
152230	2133	96852714000	19971	10058	6	0	\N
152238	1397	1321508285000	19973	10058	0	0	\N
152239	1397	1321498284000	19973	10058	1	0	\N
152240	2133	96853716000	19973	10058	2	0	\N
152241	2132	148262263000	19973	10058	3	0	\N
152242	2134	96412260000	19973	10058	4	0	\N
152243	2134	96411257000	19973	10058	5	0	\N
152244	2133	96852714000	19973	10058	6	0	\N
152245	1397	1321508285000	19974	10058	0	0	\N
152246	1397	1321498284000	19974	10058	1	0	\N
152247	2133	96853716000	19974	10058	2	0	\N
152248	2132	148262263000	19974	10058	3	0	\N
152249	2134	96412260000	19974	10058	4	0	\N
152250	2134	96411257000	19974	10058	5	0	\N
152251	2133	96852714000	19974	10058	6	0	\N
152252	1397	1321508285000	19975	10058	0	0	\N
152253	1397	1321498284000	19975	10058	1	0	\N
152254	2133	96853716000	19975	10058	2	0	\N
152255	2132	148262263000	19975	10058	3	0	\N
152256	2134	96412260000	19975	10058	4	0	\N
152257	2134	96411257000	19975	10058	5	0	\N
152258	2133	96852714000	19975	10058	6	0	\N
152259	1397	1321508285000	19976	10058	0	0	\N
152260	1397	1321498284000	19976	10058	1	0	\N
152261	2133	96853716000	19976	10058	2	0	\N
152262	2132	148262263000	19976	10058	3	0	\N
152263	2134	96412260000	19976	10058	4	0	\N
152264	2134	96411257000	19976	10058	5	0	\N
152265	2133	96852714000	19976	10058	6	0	\N
152266	1397	1321488283000	19978	10060	0	0	\N
152267	1397	1321478282000	19978	10060	1	0	\N
152268	1397	1321468281000	19978	10060	2	0	\N
152269	2132	148261262000	19978	10060	3	0	\N
152270	2134	96410254000	19978	10060	4	0	\N
152271	2134	96409251000	19978	10060	5	0	\N
152272	2133	96851712000	19978	10060	6	0	\N
152273	2133	96850710000	19978	10060	7	0	\N
152274	2133	96849708000	19978	10060	8	0	\N
152296	2134	96405239000	19982	10063	0	0	\N
152297	2119	198000000	19982	10063	1	0	\N
152298	2133	96845700000	19982	10063	2	0	\N
152299	2134	96405239000	19983	10063	0	0	\N
152300	2119	198000000	19983	10063	1	0	\N
152301	2133	96845700000	19983	10063	2	0	\N
152306	2133	96844698000	19985	10064	0	0	\N
152307	2238	1998000000	19985	10064	1	0	\N
152308	2134	96404236000	19985	10064	2	0	\N
152312	1397	1321418276000	19987	10065	0	0	\N
152313	606	80835194812962	19987	10065	1	0	\N
152314	2133	96843696000	19987	10065	2	0	\N
152315	2134	96403233000	19987	10065	3	0	\N
152316	2132	148259260000	19987	10065	4	0	\N
152199	2133	96859728000	19965	10054	2	0	2136
152200	2132	148264265000	19965	10054	3	0	735
152205	1397	1321558290000	19967	10055	0	0	11727
152206	1397	1321548289000	19967	10055	1	0	11728
152207	2133	96858726000	19967	10055	2	0	2137
152209	2134	96417275000	19967	10055	4	0	2575
152210	2134	96416272000	19967	10055	5	0	2576
152211	1397	1321538288000	19968	10056	0	0	11729
152212	1397	1321528287000	19968	10056	1	0	11730
152213	2132	148263264000	19968	10056	2	0	736
152215	2133	96856722000	19968	10056	4	0	2139
152216	2133	96855720000	19968	10056	5	0	2140
152217	2134	96414266000	19968	10056	6	0	2578
152221	1397	1321518286000	19970	10057	0	0	11731
152223	2133	96854718000	19970	10057	2	0	2141
152231	1397	1321508285000	19972	10058	0	0	11732
152232	1397	1321498284000	19972	10058	1	0	11733
152233	2133	96853716000	19972	10058	2	0	2142
152234	2132	148262263000	19972	10058	3	0	737
152236	2134	96411257000	19972	10058	5	0	2581
152237	2133	96852714000	19972	10058	6	0	2143
152275	1397	1321488283000	19979	10060	0	0	11734
152276	1397	1321478282000	19979	10060	1	0	11735
152277	1397	1321468281000	19979	10060	2	0	11736
152279	2134	96410254000	19979	10060	4	0	2582
152280	2134	96409251000	19979	10060	5	0	2583
152281	2133	96851712000	19979	10060	6	0	2144
152282	2133	96850710000	19979	10060	7	0	2145
152284	1397	1321458280000	19980	10061	0	0	11737
152285	1397	1321448279000	19980	10061	1	0	11738
152286	2133	96848706000	19980	10061	2	0	2147
152287	2134	96408248000	19980	10061	3	0	2584
152288	2134	96407245000	19980	10061	4	0	2585
152290	1397	1321438278000	19981	10062	0	0	11739
152291	606	81835203812962	19981	10062	1	0	13
152292	2134	96406242000	19981	10062	2	0	2586
152293	1709	9000000	19981	10062	3	0	8
152294	2132	148260261000	19981	10062	4	0	739
152302	1397	1321428277000	19984	10063	0	0	11740
152303	2134	96405239000	19984	10063	1	0	2587
152304	2119	198000000	19984	10063	2	0	2
152305	2133	96845700000	19984	10063	3	0	2150
152310	2238	1998000000	19986	10064	1	0	1
152311	2134	96404236000	19986	10064	2	0	2588
152317	1397	1321418276000	19988	10065	0	0	11741
152318	606	80835194812962	19988	10065	1	0	14
152319	2133	96843696000	19988	10065	2	0	2152
152322	1397	1321418276000	19989	10065	0	0	\N
152323	606	80835194812962	19989	10065	1	0	\N
152324	2133	96843696000	19989	10065	2	0	\N
152325	2134	96403233000	19989	10065	3	0	\N
152326	2132	148259260000	19989	10065	4	0	\N
152342	1670	12626193000000	19992	10067	0	0	\N
152343	1397	1321398274000	19992	10067	1	0	\N
152344	1397	1321388273000	19992	10067	2	0	\N
152345	1397	1321378272000	19992	10067	3	0	\N
152346	2132	148258259000	19992	10067	4	0	\N
152347	2238	1001997000000	19992	10067	5	0	\N
152348	2134	96401227000	19992	10067	6	0	\N
152349	2134	96400224000	19992	10067	7	0	\N
152350	2134	96399221000	19992	10067	8	0	\N
152351	1397	1321368271000	19993	10068	0	0	\N
152352	2134	96398218000	19993	10068	1	0	\N
152353	2133	96838686000	19993	10068	2	0	\N
152354	1397	1321368271000	19994	10068	0	0	\N
152355	2134	96398218000	19994	10068	1	0	\N
152356	2133	96838686000	19994	10068	2	0	\N
152357	1397	1321368271000	19995	10068	0	0	\N
152358	2134	96398218000	19995	10068	1	0	\N
152359	2133	96838686000	19995	10068	2	0	\N
152368	1670	7469093000000	19998	10069	0	0	\N
152369	1594	16802327000000	19998	10069	1	0	\N
152370	1397	1321358270000	19998	10069	2	0	\N
152371	2134	96397215000	19998	10069	3	0	\N
152372	2133	96837684000	19998	10069	4	0	\N
152378	1670	12626193000000	20000	10048	0	0	\N
152379	1670	7469093000000	20000	10048	1	0	\N
152380	1594	16082303000000	20000	10048	2	0	\N
152381	1397	1321658300000	20000	10048	3	0	\N
152382	606	81115162812962	20000	10048	4	0	\N
152383	606	80115152812962	20000	10048	5	0	\N
152384	1397	1321648299000	20000	10048	6	0	\N
152385	1397	1321638298000	20000	10048	7	0	\N
152386	1397	1321628297000	20000	10048	8	0	\N
152387	1397	1321618296000	20000	10048	9	0	\N
152388	1397	1321608295000	20000	10048	10	0	\N
152389	1397	1321598294000	20000	10048	11	0	\N
152390	1397	1321588293000	20000	10048	12	0	\N
152391	1397	1321578292000	20000	10048	13	0	\N
152392	1397	1321568291000	20000	10048	14	0	\N
152393	1397	1321558290000	20000	10048	15	0	\N
152394	1397	1321548289000	20000	10048	16	0	\N
152395	1397	1321538288000	20000	10048	17	0	\N
152396	1397	1321528287000	20000	10048	18	0	\N
152397	1397	1321518286000	20000	10048	19	0	\N
152398	1397	1321508285000	20000	10048	20	0	\N
152399	1397	1321498284000	20000	10048	21	0	\N
152400	1397	1321488283000	20000	10048	22	0	\N
152401	1397	1321478282000	20000	10048	23	0	\N
152402	1397	1321468281000	20000	10048	24	0	\N
152403	1397	1321458280000	20000	10048	25	0	\N
152404	1397	1321448279000	20000	10048	26	0	\N
152405	1397	1321438278000	20000	10048	27	0	\N
152406	1397	1321428277000	20000	10048	28	0	\N
152407	1397	1321418276000	20000	10048	29	0	\N
152408	1397	1321408275000	20000	10048	30	0	\N
152409	1397	1321398274000	20000	10048	31	0	\N
152410	1397	1321388273000	20000	10048	32	0	\N
152411	1397	1321378272000	20000	10048	33	0	\N
152412	1397	1321368271000	20000	10048	34	0	\N
152413	1397	1321358270000	20000	10048	35	0	\N
152414	1397	1321348269000	20000	10048	36	0	\N
152415	2119	198000000	20000	10048	37	0	\N
152416	2133	96868746000	20000	10048	38	0	\N
152417	1709	9000000	20000	10048	39	0	\N
152418	2134	96427305000	20000	10048	40	0	\N
152419	2134	96426302000	20000	10048	41	0	\N
152420	2134	96425299000	20000	10048	42	0	\N
152421	2134	96424296000	20000	10048	43	0	\N
152422	2134	96423293000	20000	10048	44	0	\N
152423	2134	96422290000	20000	10048	45	0	\N
152424	2134	96421287000	20000	10048	46	0	\N
152425	2133	96867744000	20000	10048	47	0	\N
152426	2133	96866742000	20000	10048	48	0	\N
152427	2133	96865740000	20000	10048	49	0	\N
152428	2132	148266267000	20000	10048	50	0	\N
152429	2132	148265266000	20000	10048	51	0	\N
152430	2132	148264265000	20000	10048	52	0	\N
152431	2132	148263264000	20000	10048	53	0	\N
152432	2132	148262263000	20000	10048	54	0	\N
152433	2132	148261262000	20000	10048	55	0	\N
152434	2132	148260261000	20000	10048	56	0	\N
152435	2133	96864738000	20000	10048	57	0	\N
152436	2133	96863736000	20000	10048	58	0	\N
152437	2133	96862734000	20000	10048	59	0	\N
152438	2133	96861732000	20000	10048	60	0	\N
152439	2133	96860730000	20000	10048	61	0	\N
152440	2133	96859728000	20000	10048	62	0	\N
152441	2133	96858726000	20000	10048	63	0	\N
152442	2133	96857724000	20000	10048	64	0	\N
152443	2133	96856722000	20000	10048	65	0	\N
152444	2133	96855720000	20000	10048	66	0	\N
152445	2133	96854718000	20000	10048	67	0	\N
152446	2133	96853716000	20000	10048	68	0	\N
152447	2133	96852714000	20000	10048	69	0	\N
152448	2133	96851712000	20000	10048	70	0	\N
152449	2133	96850710000	20000	10048	71	0	\N
152450	2133	96849708000	20000	10048	72	0	\N
152451	2133	96848706000	20000	10048	73	0	\N
152452	2133	96847704000	20000	10048	74	0	\N
152453	2133	96846702000	20000	10048	75	0	\N
152454	2133	96845700000	20000	10048	76	0	\N
152455	2133	96844698000	20000	10048	77	0	\N
152456	2133	96843696000	20000	10048	79	0	\N
152328	2133	96842694000	19990	10066	1	0	2153
152329	2134	96402230000	19990	10066	2	0	2590
152330	1670	12626193000000	19991	10067	0	0	7
152331	1397	1321398274000	19991	10067	1	0	11743
152332	1397	1321388273000	19991	10067	2	0	11744
152334	2132	148258259000	19991	10067	4	0	741
152335	2238	1001997000000	19991	10067	5	0	2
152336	2134	96401227000	19991	10067	6	0	2591
152337	2133	96841692000	19991	10067	7	0	2154
152338	2133	96840690000	19991	10067	8	0	2155
152340	2134	96400224000	19991	10067	10	0	2592
152341	2134	96399221000	19991	10067	11	0	2593
152360	1397	1321368271000	19996	10068	0	0	11746
152361	2134	96398218000	19996	10068	1	0	2594
152363	1670	7469093000000	19997	10069	0	0	8
152364	1594	16802327000000	19997	10069	1	0	6
152365	1397	1321358270000	19997	10069	2	0	11747
152366	2134	96397215000	19997	10069	3	0	2595
152367	2133	96837684000	19997	10069	4	0	2158
152374	1397	1321348269000	19999	10070	1	0	11748
152375	2134	96396212000	19999	10070	2	0	2596
152376	2133	96836682000	19999	10070	3	0	2159
152377	2132	148257258000	19999	10070	4	0	742
152457	2133	96842694000	20000	10048	80	0	\N
152458	2133	96841692000	20000	10048	81	0	\N
152459	2133	96840690000	20000	10048	82	0	\N
152460	2133	96839688000	20000	10048	83	0	\N
152461	2133	96838686000	20000	10048	84	0	\N
152462	2133	96837684000	20000	10048	85	0	\N
152463	2133	96836682000	20000	10048	86	0	\N
152464	2132	148259260000	20000	10048	87	0	\N
152465	2132	148258259000	20000	10048	88	0	\N
152466	2134	96420284000	20000	10048	89	0	\N
152467	2134	96419281000	20000	10048	90	0	\N
152468	2134	96418278000	20000	10048	91	0	\N
152469	2134	96417275000	20000	10048	92	0	\N
152470	2134	96416272000	20000	10048	93	0	\N
152471	2134	96415269000	20000	10048	94	0	\N
152472	2134	96414266000	20000	10048	95	0	\N
152473	2134	96413263000	20000	10048	96	0	\N
152474	2134	96412260000	20000	10048	97	0	\N
152475	2134	96411257000	20000	10048	98	0	\N
152476	2134	96410254000	20000	10048	99	0	\N
152477	2134	96409251000	20000	10048	100	0	\N
152478	2134	96408248000	20000	10048	101	0	\N
152479	2134	96407245000	20000	10048	102	0	\N
152480	2134	96406242000	20000	10048	103	0	\N
152481	2134	96405239000	20000	10048	104	0	\N
152482	2134	96404236000	20000	10048	105	0	\N
152483	2134	96403233000	20000	10048	106	0	\N
152484	2134	96402230000	20000	10048	107	0	\N
152485	2134	96401227000	20000	10048	108	0	\N
152486	2134	96400224000	20000	10048	109	0	\N
152487	2134	96399221000	20000	10048	110	0	\N
152488	2134	96398218000	20000	10048	111	0	\N
152489	2134	96397215000	20000	10048	112	0	\N
152490	1670	3988993000000	20001	10070	0	0	\N
152491	1397	1321348269000	20001	10070	1	0	\N
152492	2134	96396212000	20001	10070	2	0	\N
152493	2133	96836682000	20001	10070	3	0	\N
152494	2132	148257258000	20001	10070	4	0	\N
152500	1397	1321338268000	20003	10071	0	0	\N
152501	1594	9122077000000	20003	10071	1	0	\N
152502	1594	6365917000000	20003	10071	2	0	\N
152503	2134	96395209000	20003	10071	3	0	\N
152504	2133	96835680000	20003	10071	4	0	\N
152505	1670	1110893000000	20004	10072	0	0	\N
152506	1594	2281027000000	20004	10072	1	0	\N
152507	1397	1321328267000	20004	10072	2	0	\N
152508	2134	96394206000	20004	10072	3	0	\N
152509	2133	96834678000	20004	10072	4	0	\N
152510	1670	1110893000000	20005	10072	0	0	\N
152511	1594	2281027000000	20005	10072	1	0	\N
152512	1397	1321328267000	20005	10072	2	0	\N
152513	2134	96394206000	20005	10072	3	0	\N
152514	2133	96834678000	20005	10072	4	0	\N
152515	1670	1110893000000	20006	10072	0	0	\N
152516	1594	2281027000000	20006	10072	1	0	\N
152517	1397	1321328267000	20006	10072	2	0	\N
152518	2134	96394206000	20006	10072	3	0	\N
152519	2133	96834678000	20006	10072	4	0	\N
152524	1670	1110893000000	20008	10072	0	0	\N
152525	1594	2281027000000	20008	10072	1	0	\N
152526	1397	1321328267000	20008	10072	2	0	\N
152527	2134	96394206000	20008	10072	3	0	\N
152528	2133	96834678000	20008	10072	4	0	\N
152546	1397	1321288263000	20011	10075	0	0	\N
152547	2134	96391197000	20011	10075	1	0	\N
152548	2133	96830670000	20011	10075	2	0	\N
152552	1397	1321288263000	20013	10075	0	0	\N
152553	2134	96391197000	20013	10075	1	0	\N
152554	2133	96830670000	20013	10075	2	0	\N
152555	1397	1321288263000	20014	10075	0	0	\N
152556	2134	96391197000	20014	10075	1	0	\N
152557	2133	96830670000	20014	10075	2	0	\N
152558	1397	1321288263000	20015	10075	0	0	\N
152559	2134	96391197000	20015	10075	1	0	\N
152560	2133	96830670000	20015	10075	2	0	\N
152561	1397	1321288263000	20016	10075	0	0	\N
152562	2134	96391197000	20016	10075	1	0	\N
152563	2133	96830670000	20016	10075	2	0	\N
152564	1397	1321278262000	20017	10076	0	0	\N
152565	2132	148255256000	20017	10076	1	0	\N
152566	2134	96390194000	20017	10076	2	0	\N
152567	2133	96829668000	20017	10076	3	0	\N
152572	1397	1321268261000	20019	10077	0	0	\N
152573	1716	0	20019	10077	1	0	\N
152574	2133	96828666000	20019	10077	2	0	\N
152575	2134	96389191000	20019	10077	3	0	\N
152497	1594	6365917000000	20002	10071	2	0	8
152498	2134	96395209000	20002	10071	3	0	2597
152499	2133	96835680000	20002	10071	4	0	2160
152520	1670	1110893000000	20007	10072	0	0	10
152521	1594	2281027000000	20007	10072	1	0	9
152523	2133	96834678000	20007	10072	3	0	2161
152529	1670	793000000	20009	10073	0	0	11
152530	1397	1321328267000	20009	10073	1	0	11750
152531	1397	1321318266000	20009	10073	2	0	11751
152532	1979	14161444550095	20009	10073	3	0	10
152534	1397	1321308265000	20009	10073	5	0	11752
152535	1716	18465060000000	20009	10073	6	0	5
152536	2134	96393203000	20009	10073	7	0	2599
152537	2132	148256257000	20009	10073	8	0	743
152539	2133	96832674000	20009	10073	10	0	2163
152540	1397	1321298264000	20010	10074	0	0	11753
152541	2134	96392200000	20010	10074	1	0	2600
152542	1716	14053359000000	20010	10074	2	0	6
152543	1716	11076658000000	20010	10074	3	0	7
152545	2133	96831672000	20010	10074	5	0	2164
152549	1397	1321288263000	20012	10075	0	0	11754
152550	2134	96391197000	20012	10075	1	0	2601
152551	2133	96830670000	20012	10075	2	0	2165
152568	1397	1321278262000	20018	10076	0	0	11755
152570	2134	96390194000	20018	10076	2	0	2602
152571	2133	96829668000	20018	10076	3	0	2166
152576	1397	1321268261000	20020	10077	0	0	11756
152577	1716	0	20020	10077	1	0	9
152579	2134	96389191000	20020	10077	3	0	2603
152580	1397	1321258260000	20021	10078	0	0	11757
152581	1726	48138112000	20021	10078	1	0	8247
152582	2133	96827664000	20021	10078	2	0	2168
152583	2134	96388188000	20021	10078	3	0	2604
152585	1397	1321238258000	20022	10079	1	0	11759
152586	1726	46937112000	20022	10079	2	0	8248
152587	2133	96826662000	20022	10079	3	0	2169
152588	2133	96825660000	20022	10079	4	0	2170
152589	2134	96387185000	20022	10079	5	0	2605
152591	2132	148254255000	20022	10079	7	0	745
152592	1726	45736112000	20022	10079	8	0	8249
152612	1397	1321208255000	20027	10082	0	0	\N
152613	2133	96822654000	20027	10082	1	0	\N
152614	2133	96821652000	20027	10082	2	0	\N
152615	2134	96383173000	20027	10082	3	0	\N
152616	2134	96382170000	20027	10082	4	0	\N
152628	1397	1321168251000	20034	10086	0	0	\N
152629	2133	96817644000	20034	10086	1	0	\N
152630	2134	96378158000	20034	10086	2	0	\N
152634	1397	1321168251000	20036	10086	0	0	\N
152635	2133	96817644000	20036	10086	1	0	\N
152636	2134	96378158000	20036	10086	2	0	\N
152642	1455	31517000000	20038	10087	0	0	\N
152643	1397	1321158250000	20038	10087	1	0	\N
152644	353	66000000000000	20038	10087	2	0	\N
152645	2133	96816642000	20038	10087	3	0	\N
152646	2132	148251252000	20038	10087	4	0	\N
152650	1397	1321148249000	20041	10088	0	0	\N
152651	2133	96815640000	20041	10088	1	0	\N
152652	2134	96377155000	20041	10088	2	0	\N
152656	1397	1321128247000	20043	10090	0	0	\N
152657	2134	96375149000	20043	10090	1	0	\N
152658	2119	197000000	20043	10090	2	0	\N
152659	2133	96813636000	20043	10090	3	0	\N
152664	1397	1321128247000	20045	10090	0	0	\N
152665	2134	96375149000	20045	10090	1	0	\N
152666	2119	197000000	20045	10090	2	0	\N
152667	2133	96813636000	20045	10090	3	0	\N
152678	1397	1321098244000	20049	10092	0	0	\N
152679	2134	96372140000	20049	10092	1	0	\N
152680	2133	96810630000	20049	10092	2	0	\N
152681	1397	1321098244000	20050	10092	0	0	\N
152682	2134	96372140000	20050	10092	1	0	\N
152683	2133	96810630000	20050	10092	2	0	\N
152726	1694	24364166263738	20055	10043	0	0	\N
152727	1694	24103503366853	20055	10043	1	0	\N
152728	1694	23842840469968	20055	10043	2	0	\N
152595	1979	12306431912086	20023	10080	1	0	12
152596	1979	9047116952589	20023	10080	2	0	13
152597	1979	6847988951379	20023	10080	3	0	14
152598	1979	719941102856	20023	10080	4	0	15
152599	1979	990000000	20023	10080	5	0	16
152601	2133	96824658000	20023	10080	7	0	2171
152602	2134	96385179000	20023	10080	8	0	2607
152603	1397	1321218256000	20024	10081	0	0	11761
152604	2134	96384176000	20024	10081	1	0	2608
152605	2132	148253254000	20024	10081	2	0	746
152607	1397	1321208255000	20026	10082	0	0	11762
152608	2133	96822654000	20026	10082	1	0	2173
152609	2133	96821652000	20026	10082	2	0	2174
152610	2134	96383173000	20026	10082	3	0	2609
152617	1397	1321198254000	20031	10083	0	0	11763
152618	2133	96820650000	20031	10083	1	0	2175
152619	2134	96381167000	20031	10083	2	0	2611
152620	1726	43334112000	20031	10083	3	0	8251
152621	1397	1321188253000	20032	10084	0	0	11764
152623	2133	96819648000	20032	10084	2	0	2176
152624	2132	148252253000	20032	10084	3	0	747
152625	1397	1321178252000	20033	10085	0	0	11765
152626	2133	96818646000	20033	10085	1	0	2177
152627	2134	96379161000	20033	10085	2	0	2613
152632	2133	96817644000	20035	10086	1	0	2178
152633	2134	96378158000	20035	10086	2	0	2614
152637	1455	31517000000	20037	10087	0	0	10
152638	1397	1321158250000	20037	10087	1	0	11767
152640	2133	96816642000	20037	10087	3	0	2179
152641	2132	148251252000	20037	10087	4	0	748
152647	1397	1321148249000	20040	10088	0	0	11768
152648	2133	96815640000	20040	10088	1	0	2180
152649	2134	96377155000	20040	10088	2	0	2615
152654	2133	96814638000	20042	10089	1	0	2181
152655	2134	96376152000	20042	10089	2	0	2616
152660	1397	1321128247000	20044	10090	0	0	11770
152661	2134	96375149000	20044	10090	1	0	2617
152662	2119	197000000	20044	10090	2	0	3
152668	1397	1321118246000	20046	10091	0	0	11771
152669	1397	1321108245000	20046	10091	1	0	11772
152670	2133	96812634000	20046	10091	2	0	2183
152671	2133	96811632000	20046	10091	3	0	2184
152673	2134	96373143000	20046	10091	5	0	2619
152674	2132	148250251000	20046	10091	6	0	749
152675	1397	1321098244000	20048	10092	0	0	11773
152676	2134	96372140000	20048	10092	1	0	2620
152677	2133	96810630000	20048	10092	2	0	2185
152685	2134	96371137000	20051	10093	1	0	2621
152686	2133	96809628000	20051	10093	2	0	2186
152687	2132	148249250000	20051	10093	3	0	750
152688	1397	1321078242000	20052	10094	0	0	11775
152689	1694	24364166263738	20052	10094	1	0	35
152691	1694	23842840469968	20052	10094	3	0	37
152692	1694	23582177573083	20052	10094	4	0	38
152693	1694	23321514676198	20052	10094	5	0	39
152694	1694	23060851779313	20052	10094	6	0	40
152696	1694	22539525985543	20052	10094	8	0	42
152697	1694	22278863088658	20052	10094	9	0	43
152698	1694	22018200191773	20052	10094	10	0	44
152699	1694	21757537294888	20052	10094	11	0	45
152700	1694	21496874398003	20052	10094	12	0	46
152702	1694	20975548604233	20052	10094	15	0	48
152703	1694	20714885707348	20052	10094	16	0	49
152704	1694	20454222810463	20052	10094	17	0	50
152705	1694	20193559913578	20052	10094	18	0	51
152706	1694	19932897016693	20052	10094	19	0	52
152708	1694	19411571222923	20052	10094	21	0	54
152709	1694	19150908326038	20052	10094	22	0	55
152710	1694	18890245429153	20052	10094	23	0	56
152711	1694	18629582532268	20052	10094	24	0	57
152713	1694	16340398011715	20052	10094	26	0	59
152714	1694	12705467233893	20052	10094	27	0	60
152715	1694	10252840458117	20052	10094	28	0	61
152716	1694	3418747197225	20052	10094	29	0	62
152717	2134	96370134000	20052	10094	30	0	2622
152719	1397	1321068241000	20053	10095	0	0	11776
152720	2134	96369131000	20053	10095	1	0	2623
152721	2133	96807624000	20053	10095	2	0	2188
152722	1397	1321058240000	20054	10096	0	0	11777
152723	2132	148248249000	20054	10096	1	0	751
152725	2133	96806622000	20054	10096	3	0	2189
152729	1694	23582177573083	20055	10043	3	0	\N
152730	1694	23321514676198	20055	10043	4	0	\N
152731	1694	23060851779313	20055	10043	5	0	\N
152732	1694	22800188882428	20055	10043	6	0	\N
152733	1694	22539525985543	20055	10043	7	0	\N
152734	1694	22278863088658	20055	10043	8	0	\N
152735	1694	22018200191773	20055	10043	9	0	\N
152736	1694	21757537294888	20055	10043	10	0	\N
152737	1694	21496874398003	20055	10043	11	0	\N
152738	1694	21236211501118	20055	10043	12	0	\N
152739	1694	20975548604233	20055	10043	13	0	\N
152740	1694	20714885707348	20055	10043	14	0	\N
152741	1694	20454222810463	20055	10043	15	0	\N
152742	1694	20193559913578	20055	10043	16	0	\N
152743	1694	19932897016693	20055	10043	17	0	\N
152744	1694	19672234119808	20055	10043	18	0	\N
152745	1694	19411571222923	20055	10043	19	0	\N
152746	1694	19150908326038	20055	10043	20	0	\N
152747	1694	18890245429153	20055	10043	21	0	\N
152748	1694	18629582532268	20055	10043	22	0	\N
152749	1694	18368919635383	20055	10043	23	0	\N
152750	1694	16340398011715	20055	10043	24	0	\N
152751	1694	12705467233893	20055	10043	25	0	\N
152752	1694	10252840458117	20055	10043	26	0	\N
152753	1694	3418747197225	20055	10043	27	0	\N
152757	1694	24364166263738	20057	10052	0	0	\N
152758	1694	24103503366853	20057	10052	1	0	\N
152759	1694	23842840469968	20057	10052	2	0	\N
152760	1694	23582177573083	20057	10052	3	0	\N
152761	1694	23321514676198	20057	10052	4	0	\N
152762	1694	23060851779313	20057	10052	5	0	\N
152763	1694	22800188882428	20057	10052	6	0	\N
152764	1694	22539525985543	20057	10052	7	0	\N
152765	1694	22278863088658	20057	10052	8	0	\N
152766	1694	22018200191773	20057	10052	9	0	\N
152767	1694	21757537294888	20057	10052	10	0	\N
152768	1694	21496874398003	20057	10052	11	0	\N
152769	1694	21236211501118	20057	10052	12	0	\N
152770	1694	20975548604233	20057	10052	13	0	\N
152771	1694	20714885707348	20057	10052	14	0	\N
152772	1694	20454222810463	20057	10052	15	0	\N
152773	1694	20193559913578	20057	10052	16	0	\N
152774	1694	19932897016693	20057	10052	17	0	\N
152775	1694	19672234119808	20057	10052	18	0	\N
152776	1694	19411571222923	20057	10052	19	0	\N
152777	1694	19150908326038	20057	10052	20	0	\N
152778	1694	18890245429153	20057	10052	21	0	\N
152779	1694	18629582532268	20057	10052	22	0	\N
152780	1694	18368919635383	20057	10052	23	0	\N
152781	1694	16340398011715	20057	10052	24	0	\N
152782	1694	12705467233893	20057	10052	25	0	\N
152783	1694	10252840458117	20057	10052	26	0	\N
152784	1694	3418747197225	20057	10052	27	0	\N
152788	1397	1321038238000	20059	10098	0	0	\N
152789	2133	96804618000	20059	10098	1	0	\N
152790	2134	96367125000	20059	10098	2	0	\N
152820	1397	1320958230000	20062	10101	0	0	\N
152821	2134	96359101000	20062	10101	1	0	\N
152822	2133	96796602000	20062	10101	2	0	\N
152823	1397	1320958230000	20063	10101	0	0	\N
152824	2134	96359101000	20063	10101	1	0	\N
152825	2133	96796602000	20063	10101	2	0	\N
152829	1397	1320958230000	20065	10101	0	0	\N
152830	2134	96359101000	20065	10101	1	0	\N
152831	1397	1320958230000	20066	10101	0	0	\N
152832	2134	96359101000	20066	10101	1	0	\N
152833	2133	96796602000	20066	10101	2	0	\N
152834	1455	31517000000	20067	10083	0	0	\N
152835	353	66000000000000	20067	10083	1	0	\N
152836	1397	1321198254000	20067	10083	2	0	\N
152837	1694	24364166263738	20067	10083	3	0	\N
152838	1694	24103503366853	20067	10083	4	0	\N
152839	1694	23842840469968	20067	10083	5	0	\N
152840	1694	23582177573083	20067	10083	6	0	\N
152841	1694	23321514676198	20067	10083	7	0	\N
152842	1694	23060851779313	20067	10083	8	0	\N
152843	1694	22800188882428	20067	10083	9	0	\N
152844	1694	22539525985543	20067	10083	10	0	\N
152845	1694	22278863088658	20067	10083	11	0	\N
152846	1694	22018200191773	20067	10083	12	0	\N
152847	1694	21757537294888	20067	10083	13	0	\N
152848	1694	21496874398003	20067	10083	14	0	\N
152849	1694	21236211501118	20067	10083	15	0	\N
152850	1694	20975548604233	20067	10083	16	0	\N
152851	1694	20714885707348	20067	10083	17	0	\N
152852	1694	20454222810463	20067	10083	18	0	\N
152853	1694	20193559913578	20067	10083	19	0	\N
152854	1694	19932897016693	20067	10083	20	0	\N
152855	1694	19672234119808	20067	10083	21	0	\N
152856	1694	19411571222923	20067	10083	22	0	\N
152857	1694	19150908326038	20067	10083	23	0	\N
152858	1694	18890245429153	20067	10083	24	0	\N
152859	1694	18629582532268	20067	10083	25	0	\N
152860	1694	18368919635383	20067	10083	26	0	\N
152861	1694	16340398011715	20067	10083	27	0	\N
152862	1694	12705467233893	20067	10083	28	0	\N
152863	1694	10252840458117	20067	10083	29	0	\N
152864	1694	3418747197225	20067	10083	30	0	\N
152756	2133	96805620000	20056	10097	2	0	2190
152785	1397	1321038238000	20058	10098	0	0	11779
152786	2133	96804618000	20058	10098	1	0	2191
152787	2134	96367125000	20058	10098	2	0	2625
152791	1397	1321028237000	20060	10099	0	0	11780
152793	1397	1321008235000	20060	10099	2	0	11782
152794	1397	1320998234000	20060	10099	3	0	11783
152795	2133	96803616000	20060	10099	4	0	2192
152796	2134	96366122000	20060	10099	5	0	2626
152797	2134	96365119000	20060	10099	6	0	2627
152799	2134	96363113000	20060	10099	8	0	2629
152800	2133	96802614000	20060	10099	9	0	2193
152801	2133	96801612000	20060	10099	10	0	2194
152802	167	66000000100200	20060	10099	11	0	1
152804	2132	148247248000	20060	10099	13	0	752
152805	1397	1320988233000	20061	10100	0	0	11784
152806	1397	1320978232000	20061	10100	1	0	11785
152807	1397	1320968231000	20061	10100	2	0	11786
152808	1689	13206745029108	20061	10100	3	0	8
152810	2134	96361107000	20061	10100	5	0	2631
152811	1704	4068312000000	20061	10100	6	0	2
152812	1704	3750311000000	20061	10100	7	0	3
152813	2134	96360104000	20061	10100	8	0	2632
152814	1704	3725310000000	20061	10100	9	0	4
152816	2133	96798606000	20061	10100	11	0	2197
152817	2133	96797604000	20061	10100	12	0	2198
152818	2119	195000000	20061	10100	13	0	5
152819	1689	9777271579089	20061	10100	14	0	9
152827	2134	96359101000	20064	10101	1	0	2633
152828	2133	96796602000	20064	10101	2	0	2199
152865	2133	96820650000	20067	10083	31	0	\N
152866	1689	13206745029108	20067	10083	32	0	\N
152867	1704	4068312000000	20067	10083	33	0	\N
152868	1704	3750311000000	20067	10083	34	0	\N
152869	2119	197000000	20067	10083	35	0	\N
152870	2119	196000000	20067	10083	36	0	\N
152871	167	66000000100200	20067	10083	37	0	\N
152872	1704	3725310000000	20067	10083	38	0	\N
152873	2133	96819648000	20067	10083	39	0	\N
152874	2133	96818646000	20067	10083	40	0	\N
152875	2133	96817644000	20067	10083	41	0	\N
152876	2133	96816642000	20067	10083	42	0	\N
152877	2133	96815640000	20067	10083	43	0	\N
152878	2133	96814638000	20067	10083	44	0	\N
152879	2134	96381167000	20067	10083	45	0	\N
152880	2134	96380164000	20067	10083	46	0	\N
152881	2134	96379161000	20067	10083	47	0	\N
152882	1726	43334112000	20067	10083	48	0	\N
152883	2119	195000000	20067	10083	49	0	\N
152884	2132	148252253000	20067	10083	50	0	\N
152885	2132	148251252000	20067	10083	51	0	\N
152886	1689	9777271579089	20067	10083	52	0	\N
152887	2134	96378158000	20067	10083	53	0	\N
152888	2134	96377155000	20067	10083	54	0	\N
152889	2133	96813636000	20067	10083	55	0	\N
152890	2133	96812634000	20067	10083	56	0	\N
152891	2133	96811632000	20067	10083	57	0	\N
152892	2133	96810630000	20067	10083	58	0	\N
152893	2133	96809628000	20067	10083	59	0	\N
152894	2133	96808626000	20067	10083	60	0	\N
152895	2133	96807624000	20067	10083	61	0	\N
152896	2133	96806622000	20067	10083	62	0	\N
152897	2133	96805620000	20067	10083	63	0	\N
152898	2133	96804618000	20067	10083	64	0	\N
152899	2133	96803616000	20067	10083	65	0	\N
152900	2133	96802614000	20067	10083	66	0	\N
152901	2133	96801612000	20067	10083	67	0	\N
152902	2133	96800610000	20067	10083	68	0	\N
152903	2133	96799608000	20067	10083	69	0	\N
152904	2133	96798606000	20067	10083	70	0	\N
152905	2133	96797604000	20067	10083	71	0	\N
152906	2133	96796602000	20067	10083	72	0	\N
152907	2134	96376152000	20067	10083	73	0	\N
152908	2134	96375149000	20067	10083	74	0	\N
152909	2134	96374146000	20067	10083	75	0	\N
152910	2134	96373143000	20067	10083	76	0	\N
152911	2134	96372140000	20067	10083	77	0	\N
152912	2134	96371137000	20067	10083	78	0	\N
152913	2134	96370134000	20067	10083	80	0	\N
152914	2134	96369131000	20067	10083	81	0	\N
152915	2134	96368128000	20067	10083	82	0	\N
152916	2134	96367125000	20067	10083	83	0	\N
152917	2134	96366122000	20067	10083	84	0	\N
152918	2134	96365119000	20067	10083	85	0	\N
152919	2134	96364116000	20067	10083	86	0	\N
152920	2134	96363113000	20067	10083	87	0	\N
152921	2134	96362110000	20067	10083	88	0	\N
152922	2134	96361107000	20067	10083	89	0	\N
152923	2134	96360104000	20067	10083	90	0	\N
152924	2134	96359101000	20067	10083	91	0	\N
152925	2132	148250251000	20067	10083	92	0	\N
152926	2132	148249250000	20067	10083	93	0	\N
152927	2132	148248249000	20067	10083	94	0	\N
152928	2132	148247248000	20067	10083	95	0	\N
152929	1397	1320958230000	20068	10101	0	0	\N
152930	2133	96796602000	20068	10101	1	0	\N
152935	1397	1320948229000	20070	10102	0	0	\N
152936	1689	7463337179995	20070	10102	1	0	\N
152937	2134	96358098000	20070	10102	2	0	\N
152938	2133	96795600000	20070	10102	3	0	\N
152943	1397	1320938228000	20072	10103	0	0	\N
152944	2134	96357095000	20072	10103	1	0	\N
152945	2133	96794598000	20072	10103	2	0	\N
152946	1689	1015355019933	20072	10103	3	0	\N
152947	1397	1320938228000	20073	10103	0	0	\N
152948	2134	96357095000	20073	10103	1	0	\N
152949	2133	96794598000	20073	10103	2	0	\N
152950	1689	1015355019933	20073	10103	3	0	\N
152951	1397	1320938228000	20074	10103	0	0	\N
152952	2134	96357095000	20074	10103	1	0	\N
152953	2133	96794598000	20074	10103	2	0	\N
152954	1689	1015355019933	20074	10103	3	0	\N
152958	1397	1320918226000	20076	10105	0	0	\N
152959	2133	96792594000	20076	10105	1	0	\N
152960	2134	96355089000	20076	10105	2	0	\N
152972	1607	323786504217	20080	10108	0	0	\N
152973	2112	5077984563820	20080	10108	1	0	\N
152974	2112	3323654080099	20080	10108	2	0	\N
152975	1397	1320888223000	20080	10108	3	0	\N
152976	1607	83789133619	20080	10108	4	0	\N
152977	2134	96353083000	20080	10108	5	0	\N
152978	2133	96789588000	20080	10108	6	0	\N
152933	2134	96358098000	20069	10102	2	0	2634
152934	2133	96795600000	20069	10102	3	0	2200
152939	1397	1320938228000	20071	10103	0	0	11789
152940	2134	96357095000	20071	10103	1	0	2635
152941	2133	96794598000	20071	10103	2	0	2201
152955	1397	1320928227000	20075	10104	0	0	11790
152956	2134	96356092000	20075	10104	1	0	2636
152957	2133	96793596000	20075	10104	2	0	2202
152961	1397	1320918226000	20077	10105	0	0	11791
152962	2133	96792594000	20077	10105	1	0	2203
152964	1397	1320908225000	20078	10106	0	0	11792
152965	1607	3707521150625	20078	10106	1	0	10
152966	2133	96791592000	20078	10106	2	0	2204
152967	1607	563783874815	20079	10107	0	0	11
152969	2134	96354086000	20079	10107	2	0	2638
152970	1689	23287617	20079	10107	3	0	12
152971	2133	96790590000	20079	10107	4	0	2205
152979	1607	323786504217	20081	10108	0	0	12
152980	2112	5077984563820	20081	10108	1	0	1
152982	1397	1320888223000	20081	10108	3	0	11794
152983	1607	83789133619	20081	10108	4	0	13
152984	2134	96353083000	20081	10108	5	0	2639
152985	2133	96789588000	20081	10108	6	0	2206
152986	2112	3083656709501	20082	10109	0	0	3
152988	2112	2603661968305	20082	10109	2	0	5
152989	1397	1320878222000	20082	10109	3	0	11795
152990	2133	96788586000	20082	10109	4	0	2207
152991	1726	42133112000	20082	10109	5	0	8252
152993	1981	100880000000	20083	10110	0	0	2
152994	1607	0	20083	10110	1	0	14
152995	1397	1320868221000	20083	10110	2	0	11796
152996	1684	25129834847948	20083	10110	3	0	71
152997	1684	24920399059336	20083	10110	4	0	72
152999	2134	96351077000	20083	10110	6	0	2641
153000	2133	96787584000	20083	10110	7	0	2208
153001	1981	100880000000	20084	10110	0	0	\N
153002	1607	0	20084	10110	1	0	\N
153003	1397	1320868221000	20084	10110	2	0	\N
153004	1684	25129834847948	20084	10110	3	0	\N
153005	1684	24920399059336	20084	10110	4	0	\N
153006	2132	148246247000	20084	10110	5	0	\N
153007	2134	96351077000	20084	10110	6	0	\N
153008	2133	96787584000	20084	10110	7	0	\N
153009	1981	100880000000	20085	10110	0	0	\N
153010	1607	0	20085	10110	1	0	\N
153011	1397	1320868221000	20085	10110	2	0	\N
153012	1684	25129834847948	20085	10110	3	0	\N
153013	1684	24920399059336	20085	10110	4	0	\N
153014	2132	148246247000	20085	10110	5	0	\N
153015	2134	96351077000	20085	10110	6	0	\N
153016	2133	96787584000	20085	10110	7	0	\N
153017	1684	24710963270724	20086	10111	0	0	\N
153018	1684	24501527482112	20086	10111	1	0	\N
153019	2112	0	20086	10111	2	0	\N
153020	1397	1320858220000	20086	10111	3	0	\N
153021	1684	24292091693500	20086	10111	4	0	\N
153022	1684	24082655904888	20086	10111	5	0	\N
153023	1684	23873220116276	20086	10111	6	0	\N
153024	1684	23663784327664	20086	10111	7	0	\N
153025	1684	23454348539052	20086	10111	8	0	\N
153026	1684	23244912750440	20086	10111	9	0	\N
153027	2134	96350074000	20086	10111	10	0	\N
153028	2133	96786582000	20086	10111	11	0	\N
153094	1895	1439936000000	20090	10113	0	0	\N
153095	1397	1320818216000	20090	10113	1	0	\N
153096	2134	96346062000	20090	10113	2	0	\N
153097	361	66001270116779	20090	10113	3	0	\N
153117	1587	15469565000000	20092	10114	0	0	\N
153118	1397	1320808215000	20092	10114	1	0	\N
153119	1587	9527915000000	20092	10114	2	0	\N
153120	1587	5518965000000	20092	10114	3	0	\N
153121	1587	2203285000000	20092	10114	4	0	\N
153122	1587	1768025000000	20092	10114	5	0	\N
153123	1587	1332765000000	20092	10114	6	0	\N
153124	1684	15495788571796	20092	10114	7	0	\N
153125	1684	15286352783184	20092	10114	8	0	\N
153126	1684	15076916994572	20092	10114	9	0	\N
153127	1684	14867481205960	20092	10114	10	0	\N
153128	1684	14658045417348	20092	10114	11	0	\N
153129	1684	14448609628736	20092	10114	12	0	\N
153130	1684	14239173840124	20092	10114	13	0	\N
153131	1684	14029738051512	20092	10114	14	0	\N
153132	1684	13820302262900	20092	10114	15	0	\N
153133	2132	148244245000	20092	10114	16	0	\N
153134	2133	96782574000	20092	10114	17	0	\N
153135	2134	96345059000	20092	10114	18	0	\N
153031	1684	24501527482112	20087	10111	2	0	74
153032	2112	0	20087	10111	3	0	6
153033	1397	1320858220000	20087	10111	4	0	11797
153034	1397	1320848219000	20087	10111	5	0	11798
153035	1397	1320838218000	20087	10111	6	0	11799
153037	1684	24082655904888	20087	10111	8	0	76
153038	1684	23873220116276	20087	10111	9	0	77
153039	1684	23663784327664	20087	10111	10	0	78
153040	1684	23454348539052	20087	10111	11	0	79
153041	1684	23244912750440	20087	10111	12	0	80
153043	1684	22826041173216	20087	10111	14	0	82
153044	1684	22616605384604	20087	10111	15	0	83
153045	1684	22407169595992	20087	10111	16	0	84
153046	1684	22197733807380	20087	10111	17	0	85
153048	1684	21778862230156	20087	10111	19	0	87
153049	1684	21569426441544	20087	10111	20	0	88
153050	1684	21359990652932	20087	10111	21	0	89
153051	1684	21150554864320	20087	10111	22	0	90
153052	1684	20941119075708	20087	10111	23	0	91
153054	1684	20522247498484	20087	10111	25	0	93
153055	1684	20312811709872	20087	10111	26	0	94
153056	1684	20103375921260	20087	10111	27	0	95
153057	1684	19893940132648	20087	10111	28	0	96
153058	1684	19684504344036	20087	10111	29	0	97
153060	2134	96350074000	20087	10111	31	0	2642
153061	2134	96349071000	20087	10111	32	0	2643
153062	2134	96348068000	20087	10111	33	0	2644
153063	361	66641271116779	20087	10111	34	0	1
153065	2133	96786582000	20087	10111	36	0	2209
153066	2133	96785580000	20087	10111	37	0	2210
153067	2133	96784578000	20087	10111	38	0	2211
153068	2246	2686421101924	20088	10112	0	0	1
153069	1684	19265632766812	20088	10112	1	0	99
153071	1684	18846761189588	20088	10112	3	0	101
153072	1684	18637325400976	20088	10112	4	0	102
153073	1684	18427889612364	20088	10112	5	0	103
153074	1684	18218453823752	20088	10112	6	0	104
153075	1684	18009018035140	20088	10112	7	0	105
153077	1684	17590146457916	20088	10112	9	0	107
153078	1397	1320828217000	20088	10112	10	0	11800
153079	2133	96783576000	20088	10112	11	0	2212
153080	2134	96347065000	20088	10112	12	0	2645
153082	1684	17380710669304	20089	10113	1	0	108
153083	1684	17171274880692	20089	10113	2	0	109
153084	1684	16961839092080	20089	10113	3	0	110
153085	1684	16752403303468	20089	10113	4	0	111
153086	1397	1320818216000	20089	10113	5	0	11801
153088	1684	16333531726244	20089	10113	7	0	113
153089	1684	16124095937632	20089	10113	8	0	114
153090	1684	15914660149020	20089	10113	9	0	115
153091	1684	15705224360408	20089	10113	10	0	116
153092	2134	96346062000	20089	10113	11	0	2646
153098	1587	15469565000000	20091	10114	0	0	8
153099	1397	1320808215000	20091	10114	1	0	11802
153100	1587	9527915000000	20091	10114	2	0	9
153101	1587	5518965000000	20091	10114	3	0	10
153103	1587	1768025000000	20091	10114	5	0	12
153104	1587	1332765000000	20091	10114	6	0	13
153105	1684	15495788571796	20091	10114	7	0	117
153106	1684	15286352783184	20091	10114	8	0	118
153107	1684	15076916994572	20091	10114	9	0	119
153109	1684	14658045417348	20091	10114	11	0	121
153110	1684	14448609628736	20091	10114	12	0	122
153111	1684	14239173840124	20091	10114	13	0	123
153112	1684	14029738051512	20091	10114	14	0	124
153113	1684	13820302262900	20091	10114	15	0	125
153115	2133	96782574000	20091	10114	17	0	2213
153116	2134	96345059000	20091	10114	18	0	2647
153136	1587	0	20093	10115	0	0	14
153153	1981	100880000000	20094	10110	0	0	\N
153154	271	66651395291044	20094	10110	1	0	\N
153155	1684	25129834847948	20094	10110	2	0	\N
153156	1684	24920399059336	20094	10110	3	0	\N
153157	1684	24710963270724	20094	10110	4	0	\N
153158	1684	24501527482112	20094	10110	5	0	\N
153159	1684	24292091693500	20094	10110	6	0	\N
153160	1684	24082655904888	20094	10110	7	0	\N
153161	1684	23873220116276	20094	10110	8	0	\N
153162	1684	23663784327664	20094	10110	9	0	\N
153163	1684	23454348539052	20094	10110	10	0	\N
153164	1684	23244912750440	20094	10110	11	0	\N
153165	1684	23035476961828	20094	10110	12	0	\N
153166	1684	22826041173216	20094	10110	13	0	\N
153167	1684	22616605384604	20094	10110	14	0	\N
153168	1684	22407169595992	20094	10110	15	0	\N
153169	1684	22197733807380	20094	10110	16	0	\N
153170	1587	0	20095	10115	0	0	\N
153171	1684	13813946026882	20095	10115	1	0	\N
153172	1684	13807589790864	20095	10115	2	0	\N
153173	1684	13804406672855	20095	10115	3	0	\N
153174	1684	13801223554846	20095	10115	4	0	\N
153175	1684	13798040436837	20095	10115	5	0	\N
153176	1684	13794857318828	20095	10115	6	0	\N
153177	1684	12164967517017	20095	10115	7	0	\N
153178	1684	9244382280923	20095	10115	8	0	\N
153179	1684	7273738330602	20095	10115	9	0	\N
153180	1397	1320798214000	20095	10115	10	0	\N
153181	1397	1320788213000	20095	10115	11	0	\N
153182	1684	1782734219748	20095	10115	12	0	\N
153183	2133	96781572000	20095	10115	13	0	\N
153184	2133	96780570000	20095	10115	14	0	\N
153185	2134	96344056000	20095	10115	15	0	\N
153186	2134	96343053000	20095	10115	16	0	\N
153187	1397	1320778212000	20096	10116	0	0	\N
153188	2133	96779568000	20096	10116	1	0	\N
153189	2134	96342050000	20096	10116	3	0	\N
153197	1397	1320778212000	20098	10116	0	0	\N
153198	1397	1320768211000	20098	10116	1	0	\N
153199	2132	148243244000	20098	10116	3	0	\N
153200	2133	96779568000	20098	10116	4	0	\N
153201	2133	96778566000	20098	10116	5	0	\N
153202	2134	96342050000	20098	10116	6	0	\N
153203	2134	96341047000	20098	10116	7	0	\N
153216	1882	719910000000	20100	10117	0	0	\N
153217	1684	2724219748	20100	10117	1	0	\N
153218	1397	1320758210000	20100	10117	2	0	\N
153219	1397	1320748209000	20100	10117	3	0	\N
153220	1397	1320738208000	20100	10117	4	0	\N
153221	2133	96777564000	20100	10117	5	0	\N
153222	2132	148242243000	20100	10117	6	0	\N
153223	2133	96776562000	20100	10117	7	0	\N
153224	2133	96775560000	20100	10117	8	0	\N
153225	2134	96340044000	20100	10117	9	0	\N
153226	2134	96339041000	20100	10117	10	0	\N
153227	2134	96338038000	20100	10117	11	0	\N
153239	2142	4629991000000	20102	10118	0	0	\N
153240	1675	15914426999977	20102	10118	1	0	\N
153241	1675	11922416999977	20102	10118	2	0	\N
153242	1675	9228406999977	20102	10118	3	0	\N
153243	1675	1723396999977	20102	10118	4	0	\N
153244	1397	1320728207000	20102	10118	5	0	\N
153245	1397	1320718206000	20102	10118	6	0	\N
153246	2133	96774558000	20102	10118	7	0	\N
153247	2134	96337035000	20102	10118	8	0	\N
153248	2134	96336032000	20102	10118	9	0	\N
153249	2133	96773556000	20102	10118	10	0	\N
153250	1476	11558487000000	20103	10119	0	0	\N
153251	1397	1320708205000	20103	10119	1	0	\N
153252	1476	6983377000000	20103	10119	2	0	\N
153253	1476	3896467000000	20103	10119	3	0	\N
153254	1476	1343357000000	20103	10119	4	0	\N
153255	1476	1008147000000	20103	10119	5	0	\N
153256	2133	96772554000	20103	10119	6	0	\N
153257	2134	96335029000	20103	10119	7	0	\N
153258	2132	148241242000	20103	10119	8	0	\N
153268	1476	11558487000000	20105	10119	0	0	\N
153269	1397	1320708205000	20105	10119	1	0	\N
153270	1476	6983377000000	20105	10119	2	0	\N
153271	1476	3896467000000	20105	10119	3	0	\N
153272	1476	1343357000000	20105	10119	4	0	\N
153139	1684	13804406672855	20093	10115	3	0	128
153140	1684	13801223554846	20093	10115	4	0	129
153141	1684	13798040436837	20093	10115	5	0	130
153142	1684	13794857318828	20093	10115	6	0	131
153143	1684	12164967517017	20093	10115	7	0	132
153145	1684	7273738330602	20093	10115	9	0	134
153146	1397	1320798214000	20093	10115	10	0	11803
153147	1397	1320788213000	20093	10115	11	0	11804
153148	1684	1782734219748	20093	10115	12	0	135
153149	2133	96781572000	20093	10115	13	0	2214
153151	2134	96344056000	20093	10115	15	0	2648
153152	2134	96343053000	20093	10115	16	0	2649
153190	1397	1320778212000	20097	10116	0	0	11805
153191	1397	1320768211000	20097	10116	1	0	11806
153193	2133	96779568000	20097	10116	4	0	2216
153194	2133	96778566000	20097	10116	5	0	2217
153195	2134	96342050000	20097	10116	6	0	2650
153196	2134	96341047000	20097	10116	7	0	2651
153204	1882	719910000000	20099	10117	0	0	1
153206	1397	1320758210000	20099	10117	2	0	11807
153207	1397	1320748209000	20099	10117	3	0	11808
153208	1397	1320738208000	20099	10117	4	0	11809
153209	2133	96777564000	20099	10117	5	0	2218
153210	2132	148242243000	20099	10117	6	0	757
153212	2133	96775560000	20099	10117	8	0	2220
153213	2134	96340044000	20099	10117	9	0	2652
153214	2134	96339041000	20099	10117	10	0	2653
153215	2134	96338038000	20099	10117	11	0	2654
153229	1675	15914426999977	20101	10118	1	0	5
153230	1675	11922416999977	20101	10118	2	0	6
153231	1675	9228406999977	20101	10118	3	0	7
153232	1675	1723396999977	20101	10118	4	0	8
153233	1397	1320728207000	20101	10118	5	0	11810
153235	2133	96774558000	20101	10118	7	0	2221
153236	2134	96337035000	20101	10118	8	0	2655
153237	2134	96336032000	20101	10118	9	0	2656
153238	2133	96773556000	20101	10118	10	0	2222
153259	1476	11558487000000	20104	10119	0	0	6
153261	1476	6983377000000	20104	10119	2	0	7
153262	1476	3896467000000	20104	10119	3	0	8
153263	1476	1343357000000	20104	10119	4	0	9
153264	1476	1008147000000	20104	10119	5	0	10
153266	2134	96335029000	20104	10119	7	0	2657
153267	2132	148241242000	20104	10119	8	0	758
153273	1476	1008147000000	20105	10119	5	0	\N
153274	2133	96772554000	20105	10119	6	0	\N
153275	2134	96335029000	20105	10119	7	0	\N
153276	2132	148241242000	20105	10119	8	0	\N
153277	1476	11558487000000	20106	10119	0	0	\N
153278	1397	1320708205000	20106	10119	1	0	\N
153279	1476	6983377000000	20106	10119	2	0	\N
153280	1476	3896467000000	20106	10119	3	0	\N
153281	1476	1343357000000	20106	10119	4	0	\N
153282	1476	1008147000000	20106	10119	5	0	\N
153283	2133	96772554000	20106	10119	6	0	\N
153284	2134	96335029000	20106	10119	7	0	\N
153285	2132	148241242000	20106	10119	8	0	\N
153286	1476	0	20107	10120	0	0	\N
153287	1397	1320698204000	20107	10120	1	0	\N
153288	2134	96334026000	20107	10120	2	0	\N
153289	2133	96771552000	20107	10120	3	0	\N
153311	1671	10569939634395	20114	10126	0	0	\N
153312	1671	6975243815095	20114	10126	1	0	\N
153313	1671	4549827663645	20114	10126	2	0	\N
153314	1397	1320648199000	20114	10126	3	0	\N
153315	2132	148239240000	20114	10126	4	0	\N
153316	2134	96329011000	20114	10126	5	0	\N
153317	2133	96765540000	20114	10126	6	0	\N
153318	632	73255261000000	20116	9969	0	0	\N
153319	632	71294241000000	20116	9969	1	0	\N
153320	632	69971221000000	20116	9969	2	0	\N
153321	632	68877201000000	20116	9969	3	0	\N
153322	1671	10569939634395	20116	9969	4	0	\N
153340	632	68877201000000	20120	10129	0	0	\N
153341	1397	1320618196000	20120	10129	1	0	\N
153342	1397	1320608195000	20120	10129	2	0	\N
153343	2134	96326002000	20120	10129	3	0	\N
153344	2134	96324999000	20120	10129	4	0	\N
153345	2133	96762534000	20120	10129	5	0	\N
153346	2133	96761532000	20120	10129	6	0	\N
153362	2138	900000000	20123	10130	0	0	\N
153363	1397	1320598194000	20123	10130	1	0	\N
153364	1397	1320588193000	20123	10130	2	0	\N
153365	2133	96760530000	20123	10130	3	0	\N
153366	2133	96759528000	20123	10130	4	0	\N
153367	1719	835689000000	20123	10130	5	0	\N
153368	2134	96323996000	20123	10130	6	0	\N
153369	2134	96322993000	20123	10130	7	0	\N
153384	2138	0	20126	10132	0	0	\N
153385	1397	1320578192000	20126	10132	1	0	\N
153386	1397	1320568191000	20126	10132	2	0	\N
153387	1397	1320558190000	20126	10132	3	0	\N
153388	2134	96321990000	20126	10132	4	0	\N
153389	1719	0	20126	10132	5	0	\N
153390	2133	96758526000	20126	10132	6	0	\N
153391	2133	96757524000	20126	10132	7	0	\N
153392	2133	96756522000	20126	10132	8	0	\N
153393	2134	96320987000	20126	10132	9	0	\N
153394	2134	96319984000	20126	10132	10	0	\N
153395	2138	0	20127	10132	0	0	\N
153396	1397	1320578192000	20127	10132	1	0	\N
153397	1397	1320568191000	20127	10132	2	0	\N
153398	1397	1320558190000	20127	10132	3	0	\N
153399	2134	96321990000	20127	10132	4	0	\N
153400	1719	0	20127	10132	5	0	\N
153401	2133	96758526000	20127	10132	6	0	\N
153402	2133	96757524000	20127	10132	7	0	\N
153403	2133	96756522000	20127	10132	8	0	\N
153404	2134	96320987000	20127	10132	9	0	\N
153405	2134	96319984000	20127	10132	10	0	\N
153406	1397	1320548189000	20128	10133	0	0	\N
153407	1522	16145291000000	20128	10133	1	0	\N
153408	2134	96318981000	20128	10133	2	0	\N
153292	2134	96334026000	20108	10120	2	0	2658
153293	2133	96771552000	20108	10120	3	0	2224
153294	1397	1320688203000	20109	10121	0	0	11814
153295	2133	96770550000	20109	10121	1	0	2225
153296	2133	96769548000	20110	10122	0	0	2226
153298	632	73255261000000	20111	10123	0	0	6
153299	632	71294241000000	20111	10123	1	0	7
153300	632	69971221000000	20111	10123	2	0	8
153301	1397	1320678202000	20111	10123	3	0	11815
153302	2133	96768546000	20111	10123	4	0	2227
153304	2132	148240241000	20111	10123	6	0	759
153305	1397	1320668201000	20112	10124	0	0	11816
153306	2134	96331017000	20112	10124	1	0	2661
153307	1397	1320658200000	20113	10125	0	0	11817
153309	2133	96767544000	20113	10125	2	0	2228
153310	2133	96766542000	20113	10125	3	0	2229
153323	1671	10569939634395	20117	10126	0	0	5
153324	1671	6975243815095	20117	10126	1	0	6
153325	1671	4549827663645	20117	10126	2	0	7
153327	2132	148239240000	20117	10126	4	0	760
153328	2134	96329011000	20117	10126	5	0	2663
153329	2133	96765540000	20117	10126	6	0	2230
153330	1397	1320638198000	20118	10127	0	0	11819
153331	1671	2543845003785	20118	10127	1	0	8
153333	1719	14194391000000	20118	10127	3	0	7
153334	1719	10666490000000	20118	10127	4	0	8
153335	2133	96764538000	20118	10127	5	0	2231
153336	2134	96328008000	20118	10127	6	0	2664
153338	2133	96763536000	20119	10128	1	0	2232
153339	2134	96327005000	20119	10128	2	0	2665
153347	632	68877201000000	20121	10129	0	0	9
153348	1397	1320618196000	20121	10129	1	0	11821
153349	1397	1320608195000	20121	10129	2	0	11822
153351	2134	96324999000	20121	10129	4	0	2667
153352	2133	96762534000	20121	10129	5	0	2233
153353	2133	96761532000	20121	10129	6	0	2234
153354	2138	900000000	20122	10130	0	0	1
153355	1397	1320598194000	20122	10130	1	0	11823
153357	2133	96760530000	20122	10130	3	0	2235
153358	2133	96759528000	20122	10130	4	0	2236
153359	1719	835689000000	20122	10130	5	0	9
153360	2134	96323996000	20122	10130	6	0	2668
153370	2137	900000000	20124	10131	0	0	1
153371	2137	100000000	20124	10131	1	0	2
153372	1536	9907860999959	20124	10131	2	0	7
153373	1536	5986370999959	20124	10131	3	0	8
153374	1536	3340460999959	20124	10131	4	0	9
153376	2138	0	20125	10132	0	0	2
153377	1397	1320578192000	20125	10132	1	0	11825
153378	1397	1320568191000	20125	10132	2	0	11826
153379	1397	1320558190000	20125	10132	3	0	11827
153380	2134	96321990000	20125	10132	4	0	2670
153382	2134	96320987000	20125	10132	6	0	2671
153383	2134	96319984000	20125	10132	7	0	2672
153409	2133	96758526000	20128	10133	3	0	\N
153410	2133	96757524000	20128	10133	4	0	\N
153411	2133	96756522000	20128	10133	5	0	\N
153412	2133	96755520000	20128	10133	6	0	\N
153413	1397	1320548189000	20129	10133	0	0	\N
153414	1522	16145291000000	20129	10133	1	0	\N
153415	2134	96318981000	20129	10133	2	0	\N
153416	2133	96758526000	20129	10133	3	0	\N
153417	2133	96757524000	20129	10133	4	0	\N
153418	2133	96756522000	20129	10133	5	0	\N
153419	2133	96755520000	20129	10133	6	0	\N
153420	1397	1320548189000	20130	10133	0	0	\N
153421	1522	16145291000000	20130	10133	1	0	\N
153422	2134	96318981000	20130	10133	2	0	\N
153423	2133	96758526000	20130	10133	3	0	\N
153424	2133	96757524000	20130	10133	4	0	\N
153425	2133	96756522000	20130	10133	5	0	\N
153426	2133	96755520000	20130	10133	6	0	\N
153440	1397	1320538188000	20133	10134	0	0	\N
153441	1522	12223281000000	20133	10134	1	0	\N
153442	1522	9577271000000	20133	10134	2	0	\N
153443	1522	2203261000000	20133	10134	3	0	\N
153444	2133	96754518000	20133	10134	4	0	\N
153445	2134	96317978000	20133	10134	5	0	\N
153446	1397	1320528187000	20134	10135	0	0	\N
153447	1536	0	20134	10135	1	0	\N
153448	1397	1320518186000	20134	10135	2	0	\N
153449	1397	1320508185000	20134	10135	3	0	\N
153450	2133	96753516000	20134	10135	4	0	\N
153451	2133	96752514000	20134	10135	5	0	\N
153452	2133	96751512000	20134	10135	6	0	\N
153453	2134	96316975000	20134	10135	7	0	\N
153454	2134	96315972000	20134	10135	8	0	\N
153455	2134	96314969000	20134	10135	9	0	\N
153456	1397	1320528187000	20135	10135	0	0	\N
153457	1536	0	20135	10135	1	0	\N
153458	1397	1320518186000	20135	10135	2	0	\N
153459	1397	1320508185000	20135	10135	3	0	\N
153460	2133	96753516000	20135	10135	4	0	\N
153461	2133	96752514000	20135	10135	5	0	\N
153462	2133	96751512000	20135	10135	6	0	\N
153463	2134	96316975000	20135	10135	7	0	\N
153464	2134	96315972000	20135	10135	8	0	\N
153465	2134	96314969000	20135	10135	9	0	\N
153481	1397	1320488183000	20139	10137	0	0	\N
153482	2134	96313966000	20139	10137	1	0	\N
153483	2133	96749508000	20139	10137	2	0	\N
153484	1397	1320488183000	20140	10137	0	0	\N
153485	2134	96313966000	20140	10137	1	0	\N
153486	2133	96749508000	20140	10137	2	0	\N
153487	1397	1320488183000	20141	10137	0	0	\N
153488	2134	96313966000	20141	10137	1	0	\N
153489	2133	96749508000	20141	10137	2	0	\N
153501	1650	7111916000000	20144	10139	0	0	\N
153502	1397	1320468181000	20144	10139	1	0	\N
153503	2242	190000000	20144	10139	2	0	\N
153504	2133	96747504000	20144	10139	3	0	\N
153505	2134	96311960000	20144	10139	4	0	\N
153506	1650	7111916000000	20145	10139	0	0	\N
153507	1397	1320468181000	20145	10139	1	0	\N
153508	2242	190000000	20145	10139	2	0	\N
153509	2133	96747504000	20145	10139	3	0	\N
153510	2134	96311960000	20145	10139	4	0	\N
153511	1650	7111916000000	20146	10139	0	0	\N
153512	1397	1320468181000	20146	10139	1	0	\N
153513	2242	190000000	20146	10139	2	0	\N
153514	2133	96747504000	20146	10139	3	0	\N
153515	2134	96311960000	20146	10139	4	0	\N
153516	1650	12064136000000	20147	10123	0	0	\N
153517	1650	9107026000000	20147	10123	1	0	\N
153518	1650	7111916000000	20147	10123	2	0	\N
153519	1650	1552806000000	20147	10123	3	0	\N
153520	2137	900000000	20147	10123	4	0	\N
153521	2137	100000000	20147	10123	5	0	\N
153522	2138	900000000	20147	10123	6	0	\N
153523	2138	0	20147	10123	7	0	\N
153524	632	73255261000000	20147	10123	8	0	\N
153525	632	71294241000000	20147	10123	9	0	\N
153526	632	69971221000000	20147	10123	10	0	\N
153527	632	68877201000000	20147	10123	11	0	\N
153528	1671	10569939634395	20147	10123	12	0	\N
153529	1536	9187847999959	20147	10123	13	0	\N
153530	1536	5266357999959	20147	10123	14	0	\N
153531	1397	1320678202000	20147	10123	15	0	\N
153532	1397	1320668201000	20147	10123	16	0	\N
153533	1671	6975243815095	20147	10123	17	0	\N
153534	1671	4549827663645	20147	10123	18	0	\N
153535	1536	2620447999959	20147	10123	19	0	\N
153536	1536	432097999959	20147	10123	20	0	\N
153537	1536	144817999959	20147	10123	21	0	\N
153538	2242	190000000	20147	10123	22	0	\N
153539	1671	2543845003785	20147	10123	23	0	\N
153540	1397	1320658200000	20147	10123	24	0	\N
153541	1397	1320648199000	20147	10123	25	0	\N
153542	1397	1320638198000	20147	10123	26	0	\N
153543	1397	1320628197000	20147	10123	27	0	\N
153544	1397	1320618196000	20147	10123	28	0	\N
153429	2134	96318981000	20131	10133	2	0	2673
153430	2133	96758526000	20131	10133	3	0	2237
153431	2133	96757524000	20131	10133	4	0	2238
153432	2133	96756522000	20131	10133	5	0	2239
153433	2133	96755520000	20131	10133	6	0	2240
153435	1522	12223281000000	20132	10134	1	0	12
153436	1522	9577271000000	20132	10134	2	0	13
153437	1522	2203261000000	20132	10134	3	0	14
153438	2133	96754518000	20132	10134	4	0	2241
153439	2134	96317978000	20132	10134	5	0	2674
153467	1536	0	20136	10135	1	0	11
153468	1397	1320518186000	20136	10135	2	0	11831
153469	1397	1320508185000	20136	10135	3	0	11832
153470	2133	96753516000	20136	10135	4	0	2242
153472	2133	96751512000	20136	10135	6	0	2244
153473	2134	96316975000	20136	10135	7	0	2675
153474	2134	96315972000	20136	10135	8	0	2676
153475	2134	96314969000	20136	10135	9	0	2677
153476	1397	1320498184000	20137	10136	0	0	11833
153478	1397	1320488183000	20138	10137	0	0	11834
153479	2134	96313966000	20138	10137	1	0	2678
153480	2133	96749508000	20138	10137	2	0	2246
153490	1650	12064136000000	20142	10138	0	0	6
153491	1650	9107026000000	20142	10138	1	0	7
153493	2134	96312963000	20142	10138	3	0	2679
153494	2133	96748506000	20142	10138	4	0	2247
153495	1650	7111916000000	20143	10139	0	0	8
153496	1650	1552806000000	20143	10139	1	0	9
153498	2242	190000000	20143	10139	3	0	1
153499	2133	96747504000	20143	10139	4	0	2248
153500	2134	96311960000	20143	10139	5	0	2680
153545	1397	1320608195000	20147	10123	29	0	\N
153546	1397	1320598194000	20147	10123	30	0	\N
153547	1397	1320588193000	20147	10123	31	0	\N
153548	1397	1320578192000	20147	10123	32	0	\N
153549	1397	1320568191000	20147	10123	33	0	\N
153550	1397	1320558190000	20147	10123	34	0	\N
153551	1397	1320548189000	20147	10123	35	0	\N
153552	1397	1320538188000	20147	10123	36	0	\N
153553	1397	1320528187000	20147	10123	37	0	\N
153554	1397	1320518186000	20147	10123	38	0	\N
153555	1397	1320508185000	20147	10123	39	0	\N
153556	1397	1320498184000	20147	10123	40	0	\N
153557	1397	1320488183000	20147	10123	41	0	\N
153558	1397	1320478182000	20147	10123	42	0	\N
153559	1397	1320468181000	20147	10123	43	0	\N
153560	1522	16145291000000	20147	10123	44	0	\N
153561	1522	12223281000000	20147	10123	45	0	\N
153562	1522	9577271000000	20147	10123	46	0	\N
153563	1522	2203261000000	20147	10123	47	0	\N
153564	2133	96768546000	20147	10123	48	0	\N
153565	1719	19423092000000	20147	10123	49	0	\N
153566	1719	14194391000000	20147	10123	50	0	\N
153567	1719	10666490000000	20147	10123	51	0	\N
153568	1719	835689000000	20147	10123	52	0	\N
153569	1719	0	20147	10123	53	0	\N
153570	2134	96332020000	20147	10123	54	0	\N
153571	2134	96331017000	20147	10123	55	0	\N
153572	2134	96330014000	20147	10123	56	0	\N
153573	2134	96329011000	20147	10123	57	0	\N
153574	2134	96328008000	20147	10123	58	0	\N
153575	2132	148240241000	20147	10123	59	0	\N
153576	2132	148239240000	20147	10123	60	0	\N
153577	2133	96767544000	20147	10123	61	0	\N
153578	2133	96766542000	20147	10123	62	0	\N
153579	2133	96765540000	20147	10123	63	0	\N
153580	2133	96764538000	20147	10123	64	0	\N
153581	2133	96763536000	20147	10123	65	0	\N
153582	2134	96327005000	20147	10123	66	0	\N
153583	2134	96326002000	20147	10123	67	0	\N
153584	2134	96324999000	20147	10123	69	0	\N
153585	2134	96323996000	20147	10123	70	0	\N
153586	2134	96322993000	20147	10123	71	0	\N
153587	2134	96321990000	20147	10123	72	0	\N
153588	2134	96320987000	20147	10123	73	0	\N
153589	2134	96319984000	20147	10123	74	0	\N
153590	2134	96318981000	20147	10123	75	0	\N
153591	2134	96317978000	20147	10123	76	0	\N
153592	2134	96316975000	20147	10123	77	0	\N
153593	2134	96315972000	20147	10123	78	0	\N
153594	2134	96314969000	20147	10123	79	0	\N
153595	2134	96313966000	20147	10123	80	0	\N
153596	2134	96312963000	20147	10123	81	0	\N
153597	2134	96311960000	20147	10123	82	0	\N
153598	2133	96762534000	20147	10123	83	0	\N
153599	2133	96761532000	20147	10123	84	0	\N
153600	2133	96760530000	20147	10123	85	0	\N
153601	2133	96759528000	20147	10123	86	0	\N
153602	2133	96758526000	20147	10123	87	0	\N
153603	2133	96757524000	20147	10123	88	0	\N
153604	2133	96756522000	20147	10123	89	0	\N
153605	2133	96755520000	20147	10123	90	0	\N
153606	2133	96754518000	20147	10123	91	0	\N
153607	2133	96753516000	20147	10123	92	0	\N
153608	2133	96752514000	20147	10123	93	0	\N
153609	2133	96751512000	20147	10123	94	0	\N
153610	2133	96750510000	20147	10123	95	0	\N
153611	2133	96749508000	20147	10123	96	0	\N
153612	2133	96748506000	20147	10123	97	0	\N
153613	2133	96747504000	20147	10123	98	0	\N
153617	1397	1320448179000	20149	10141	0	0	\N
153618	2134	96309954000	20149	10141	1	0	\N
153619	2133	96745500000	20149	10141	2	0	\N
153642	1397	1320388173000	20156	10146	0	0	\N
153643	2133	96739488000	20156	10146	1	0	\N
153644	2134	96303936000	20156	10146	2	0	\N
153645	1397	1320378172000	20157	10147	0	0	\N
153646	1397	1320368171000	20157	10147	1	0	\N
153647	2134	96302933000	20157	10147	2	0	\N
153648	2134	96301930000	20157	10147	3	0	\N
153649	2133	96738486000	20157	10147	4	0	\N
153650	2133	96737484000	20157	10147	5	0	\N
153616	2134	96310957000	20148	10140	2	0	2681
153620	1397	1320448179000	20150	10141	0	0	11838
153621	2134	96309954000	20150	10141	1	0	2682
153622	2133	96745500000	20150	10141	2	0	2250
153623	1397	1320438178000	20151	10142	0	0	11839
153625	2134	96308951000	20151	10142	2	0	2683
153626	1397	1320428177000	20152	10143	0	0	11840
153627	1659	82999990	20152	10143	1	0	1
153628	2134	96307948000	20152	10143	2	0	2684
153629	2133	96743496000	20152	10143	3	0	2252
153631	1397	1320408175000	20153	10144	1	0	11842
153632	2133	96742494000	20153	10144	2	0	2253
153633	2134	96306945000	20153	10144	3	0	2685
153634	2134	96305942000	20153	10144	4	0	2686
153636	1397	1320398174000	20154	10145	0	0	11843
153637	2134	96304939000	20154	10145	1	0	2687
153638	2133	96740490000	20154	10145	2	0	2255
153639	1397	1320388173000	20155	10146	0	0	11844
153640	2133	96739488000	20155	10146	1	0	2256
153651	1397	1320378172000	20158	10147	0	0	11845
153652	1397	1320368171000	20158	10147	1	0	11846
153653	2134	96302933000	20158	10147	2	0	2689
153654	2134	96301930000	20158	10147	3	0	2690
153655	2133	96738486000	20158	10147	4	0	2257
153657	1439	12989863548477	20159	10148	0	0	7
153658	1397	1320358170000	20159	10148	1	0	11847
153659	1397	1320348169000	20159	10148	2	0	11848
153660	1397	1320338168000	20159	10148	3	0	11849
153662	1699	250750126	20159	10148	5	0	7
153663	2087	193000000	20159	10148	6	0	2
153664	2134	96300927000	20159	10148	7	0	2691
153665	2134	96299924000	20159	10148	8	0	2692
153666	2134	96298921000	20159	10148	9	0	2693
153668	2133	96735480000	20159	10148	11	0	2260
153669	2133	96734478000	20159	10148	12	0	2261
153670	2133	96733476000	20159	10148	13	0	2262
153671	2134	96297918000	20159	10148	14	0	2694
153672	1610	18327886889950	20160	10149	0	0	7
153674	1610	10665931609950	20160	10149	2	0	9
153675	1610	2064054449950	20160	10149	3	0	10
153676	1397	1320318166000	20160	10149	4	0	11851
153677	1439	10931217888477	20160	10149	5	0	8
153679	2133	96732474000	20160	10149	7	0	2263
153680	2086	2335254300069	20160	10149	8	0	2
153681	1610	18327886889950	20161	10149	0	0	\N
153682	1610	13752822189950	20161	10149	1	0	\N
153683	1610	10665931609950	20161	10149	2	0	\N
153684	1610	2064054449950	20161	10149	3	0	\N
153685	1397	1320318166000	20161	10149	4	0	\N
153686	1439	10931217888477	20161	10149	5	0	\N
153687	2134	96296915000	20161	10149	6	0	\N
153688	2133	96732474000	20161	10149	7	0	\N
153689	2086	2335254300069	20161	10149	8	0	\N
153690	1882	719910000000	20162	10084	0	0	\N
153691	1895	1439936000000	20162	10084	1	0	\N
153692	1650	12064136000000	20162	10084	2	0	\N
153693	1650	9107026000000	20162	10084	3	0	\N
153694	1650	7111916000000	20162	10084	4	0	\N
153695	1650	1552806000000	20162	10084	5	0	\N
153696	2137	900000000	20162	10084	6	0	\N
153697	2137	100000000	20162	10084	7	0	\N
153698	2138	900000000	20162	10084	8	0	\N
153699	2138	0	20162	10084	9	0	\N
153700	1981	100880000000	20162	10084	10	0	\N
153701	632	73255261000000	20162	10084	11	0	\N
153702	632	71294241000000	20162	10084	12	0	\N
153703	632	69971221000000	20162	10084	13	0	\N
153704	632	68877201000000	20162	10084	14	0	\N
153705	1587	15469565000000	20162	10084	15	0	\N
153706	1671	10569939634395	20162	10084	16	0	\N
153707	1439	12989863548477	20162	10084	17	0	\N
153708	2142	2849991000000	20162	10084	18	0	\N
153709	1675	15914426999977	20162	10084	19	0	\N
153710	2112	5077984563820	20162	10084	20	0	\N
153711	1610	16887582889950	20162	10084	21	0	\N
153712	1610	12312518189950	20162	10084	22	0	\N
153713	1536	9187847999959	20162	10084	23	0	\N
153714	1536	5266357999959	20162	10084	24	0	\N
153715	1671	6975243815095	20162	10084	25	0	\N
153716	1671	4549827663645	20162	10084	26	0	\N
153717	1587	9527915000000	20162	10084	27	0	\N
153718	1587	5518965000000	20162	10084	28	0	\N
153719	1587	2203285000000	20162	10084	29	0	\N
153720	1587	1768025000000	20162	10084	30	0	\N
153721	1587	1332765000000	20162	10084	31	0	\N
153722	1587	0	20162	10084	32	0	\N
153723	1675	11922416999977	20162	10084	33	0	\N
153724	1675	9228406999977	20162	10084	34	0	\N
153725	1675	1723396999977	20162	10084	35	0	\N
153726	1476	11558487000000	20162	10084	36	0	\N
153727	1610	9225627609950	20162	10084	37	0	\N
153728	1610	623750449950	20162	10084	38	0	\N
153729	271	66411407920446	20162	10084	39	0	\N
153730	1607	3707521150625	20162	10084	40	0	\N
153731	2112	3323654080099	20162	10084	41	0	\N
153732	2112	3083656709501	20162	10084	42	0	\N
153733	2112	2843659338903	20162	10084	43	0	\N
153734	2112	2603661968305	20162	10084	44	0	\N
153735	2112	0	20162	10084	45	0	\N
153736	1607	563783874815	20162	10084	46	0	\N
153737	1607	323786504217	20162	10084	47	0	\N
153738	1536	2620447999959	20162	10084	48	0	\N
153739	1536	432097999959	20162	10084	49	0	\N
153740	1536	144817999959	20162	10084	50	0	\N
153741	2242	190000000	20162	10084	51	0	\N
153742	1684	25129834847948	20162	10084	52	0	\N
153743	1684	24920399059336	20162	10084	53	0	\N
153744	1684	24710963270724	20162	10084	54	0	\N
153745	1684	24501527482112	20162	10084	55	0	\N
153746	1671	2543845003785	20162	10084	56	0	\N
153747	1684	24292091693500	20162	10084	57	0	\N
153748	1684	24082655904888	20162	10084	58	0	\N
153749	1684	23873220116276	20162	10084	59	0	\N
153750	1684	23663784327664	20162	10084	60	0	\N
153751	1684	23454348539052	20162	10084	61	0	\N
153752	1684	23244912750440	20162	10084	62	0	\N
153753	1684	23035476961828	20162	10084	63	0	\N
153754	1684	22826041173216	20162	10084	64	0	\N
153755	1684	22616605384604	20162	10084	65	0	\N
153756	1684	22407169595992	20162	10084	66	0	\N
153757	1684	22197733807380	20162	10084	67	0	\N
153758	1684	21988298018768	20162	10084	68	0	\N
153759	1684	21778862230156	20162	10084	69	0	\N
153760	1684	21569426441544	20162	10084	70	0	\N
153761	1684	21359990652932	20162	10084	71	0	\N
153762	1684	21150554864320	20162	10084	72	0	\N
153763	1684	20941119075708	20162	10084	73	0	\N
153764	1684	20731683287096	20162	10084	74	0	\N
153765	1684	20522247498484	20162	10084	75	0	\N
153766	1684	20312811709872	20162	10084	76	0	\N
153767	1684	20103375921260	20162	10084	77	0	\N
153768	1684	19893940132648	20162	10084	78	0	\N
153769	1684	19684504344036	20162	10084	79	0	\N
153770	1684	19475068555424	20162	10084	80	0	\N
153771	1684	19265632766812	20162	10084	81	0	\N
153772	1684	19056196978200	20162	10084	82	0	\N
153773	1684	18846761189588	20162	10084	83	0	\N
153774	1684	18637325400976	20162	10084	84	0	\N
153775	1684	18427889612364	20162	10084	85	0	\N
153776	1684	18218453823752	20162	10084	86	0	\N
153777	1684	18009018035140	20162	10084	87	0	\N
153778	1684	17799582246528	20162	10084	88	0	\N
153779	1684	17590146457916	20162	10084	89	0	\N
153780	1684	17380710669304	20162	10084	90	0	\N
153781	1684	17171274880692	20162	10084	91	0	\N
153782	1684	16961839092080	20162	10084	92	0	\N
153783	1684	16752403303468	20162	10084	93	0	\N
153784	1684	16542967514856	20162	10084	94	0	\N
153785	1684	16333531726244	20162	10084	95	0	\N
153786	1684	16124095937632	20162	10084	96	0	\N
153787	1684	15914660149020	20162	10084	97	0	\N
153788	1684	15705224360408	20162	10084	98	0	\N
153789	1684	15495788571796	20162	10084	99	0	\N
153790	1684	15286352783184	20162	10084	100	0	\N
153791	1684	15076916994572	20162	10084	101	0	\N
153792	1684	14867481205960	20162	10084	102	0	\N
153793	1684	14658045417348	20162	10084	103	0	\N
153794	1684	14448609628736	20162	10084	104	0	\N
153795	1684	14239173840124	20162	10084	105	0	\N
153796	1684	14029738051512	20162	10084	106	0	\N
153797	1684	13820302262900	20162	10084	107	0	\N
153798	1684	13813946026882	20162	10084	108	0	\N
153799	1684	13807589790864	20162	10084	110	0	\N
153800	1684	13804406672855	20162	10084	111	0	\N
153801	1684	13801223554846	20162	10084	112	0	\N
153802	1684	13798040436837	20162	10084	113	0	\N
153803	1684	13794857318828	20162	10084	114	0	\N
153804	1684	12164967517017	20162	10084	115	0	\N
153805	1684	9244382280923	20162	10084	116	0	\N
153806	1684	7273738330602	20162	10084	117	0	\N
153807	1684	1782734219748	20162	10084	118	0	\N
153808	1684	2724219748	20162	10084	119	0	\N
153809	1607	83789133619	20162	10084	120	0	\N
153810	1607	0	20162	10084	121	0	\N
153811	1476	6983377000000	20162	10084	122	0	\N
153812	1476	3896467000000	20162	10084	123	0	\N
153813	1476	1343357000000	20162	10084	124	0	\N
153814	1773	15460243628123	20163	10150	0	0	\N
153815	1397	1320308165000	20163	10150	1	0	\N
153816	1773	15278506246910	20163	10150	2	0	\N
153817	1773	13205526326577	20163	10150	3	0	\N
153818	1773	9490771990539	20163	10150	4	0	\N
153819	1773	6984349965506	20163	10150	5	0	\N
153820	1773	0	20163	10150	6	0	\N
153821	2133	96731472000	20163	10150	7	0	\N
153822	2134	96295912000	20163	10150	8	0	\N
153823	2134	96294909000	20163	10150	9	0	\N
153824	1439	7880106968477	20163	10150	10	0	\N
153825	1439	2143509578477	20163	10150	11	0	\N
153826	2133	96730470000	20163	10150	12	0	\N
153866	1668	16428284000000	20166	10152	0	0	\N
153867	1397	1320258160000	20166	10152	1	0	\N
153868	1540	367206120000	20166	10152	2	0	\N
153869	2133	96725460000	20166	10152	3	0	\N
153870	2132	148238239000	20166	10152	4	0	\N
153871	2134	96289894000	20166	10152	5	0	\N
153887	1423	571750023	20169	10153	0	0	\N
153888	1668	13446953000000	20169	10153	1	0	\N
153889	1397	1320248159000	20169	10153	2	0	\N
153890	1397	1320238158000	20169	10153	3	0	\N
153891	1540	0	20169	10153	4	0	\N
153892	2134	96288891000	20169	10153	5	0	\N
153893	2134	96287888000	20169	10153	6	0	\N
153894	2133	96724458000	20169	10153	7	0	\N
153895	2133	96723456000	20169	10153	8	0	\N
153921	1397	1320208155000	20176	10159	0	0	\N
153922	2133	96717444000	20176	10159	1	0	\N
153923	2133	96716442000	20176	10159	2	0	\N
153924	2134	96282873000	20176	10159	3	0	\N
153925	2134	96281870000	20176	10159	4	0	\N
153936	1397	1320168151000	20178	10161	0	0	\N
153937	2134	96277858000	20178	10161	1	0	\N
153938	2133	96712434000	20178	10161	2	0	\N
153939	2132	148234235000	20178	10161	3	0	\N
153947	1895	1439936000000	20181	9899	0	0	\N
153948	1650	10624110000000	20181	9899	1	0	\N
153949	1650	7667000000000	20181	9899	2	0	\N
153950	2137	900000000	20181	9899	3	0	\N
153951	1455	10258005000000	20181	9899	4	0	\N
153952	623	66719940000000	20181	9899	5	0	\N
153829	1773	15278506246910	20164	10150	2	0	32
153830	1773	13205526326577	20164	10150	3	0	33
153831	1773	9490771990539	20164	10150	4	0	34
153832	1773	6984349965506	20164	10150	5	0	35
153833	1773	0	20164	10150	6	0	36
153835	2134	96295912000	20164	10150	8	0	2696
153836	2134	96294909000	20164	10150	9	0	2697
153837	1439	7880106968477	20164	10150	10	0	9
153838	1439	2143509578477	20164	10150	11	0	10
153839	2133	96730470000	20164	10150	12	0	2265
153841	1423	4336576653837	20165	10151	1	0	17
153842	1423	3968213480763	20165	10151	2	0	18
153843	1423	3599850307689	20165	10151	3	0	19
153844	1423	3231487134615	20165	10151	4	0	20
153846	1423	2494760788467	20165	10151	6	0	22
153847	1423	2126397615393	20165	10151	7	0	23
153848	1423	1758034442319	20165	10151	8	0	24
153849	1423	1389671269245	20165	10151	9	0	25
153850	1423	1021308096171	20165	10151	10	0	26
153852	1423	284581750023	20165	10151	12	0	28
153853	1397	1320298164000	20165	10151	13	0	11853
153854	1610	720011999950	20165	10151	14	0	11
153855	1397	1320288163000	20165	10151	15	0	11854
153856	1397	1320278162000	20165	10151	16	0	11855
153858	2133	96729468000	20165	10151	18	0	2266
153859	2134	96293906000	20165	10151	19	0	2698
153860	2134	96292903000	20165	10151	20	0	2699
153861	2134	96291900000	20165	10151	21	0	2700
153863	2133	96727464000	20165	10151	23	0	2268
153864	2133	96726462000	20165	10151	24	0	2269
153865	2134	96290897000	20165	10151	25	0	2701
153872	1668	16428284000000	20167	10152	0	0	6
153873	1397	1320258160000	20167	10152	1	0	11857
153875	2133	96725460000	20167	10152	3	0	2270
153876	2132	148238239000	20167	10152	4	0	761
153877	2134	96289894000	20167	10152	5	0	2702
153878	1423	571750023	20168	10153	0	0	29
153879	1668	13446953000000	20168	10153	1	0	7
153881	1397	1320238158000	20168	10153	3	0	11859
153882	1540	0	20168	10153	4	0	6
153883	2134	96288891000	20168	10153	5	0	2703
153884	2134	96287888000	20168	10153	6	0	2704
153886	2133	96723456000	20168	10153	8	0	2272
153896	1668	5139227000000	20170	10154	0	0	8
153897	1397	1320228157000	20170	10154	1	0	11860
153898	2133	96722454000	20170	10154	2	0	2273
153899	2132	148237238000	20170	10154	3	0	762
153901	1726	40932112000	20170	10154	5	0	8253
153902	1397	1320218156000	20171	10155	0	0	11861
153903	2134	96285882000	20171	10155	1	0	2706
153904	2133	96721452000	20171	10155	2	0	2274
153905	1726	39731112000	20171	10155	3	0	8254
153907	2133	96720450000	20172	10156	1	0	2275
153908	1668	2673466000000	20173	10157	0	0	9
153909	1419	36121144987898	20173	10157	1	0	4
153910	2133	96719448000	20173	10157	2	0	2276
153912	1419	33555042482725	20174	10158	1	0	5
153913	1419	5327949560130	20174	10158	2	0	6
153914	2134	96283876000	20174	10158	3	0	2708
153915	2132	148236237000	20174	10158	4	0	763
153916	1397	1320208155000	20175	10159	0	0	11862
153918	2133	96716442000	20175	10159	2	0	2279
153919	2134	96282873000	20175	10159	3	0	2709
153920	2134	96281870000	20175	10159	4	0	2710
153926	1397	1320198154000	20177	10160	0	0	11863
153927	1397	1320188153000	20177	10160	1	0	11864
153929	2132	148235236000	20177	10160	3	0	764
153930	2134	96280867000	20177	10160	4	0	2711
153931	2133	96715440000	20177	10160	5	0	2280
153932	2133	96714438000	20177	10160	6	0	2281
153934	2134	96279864000	20177	10160	8	0	2712
153935	2134	96278861000	20177	10160	9	0	2713
153940	1397	1320168151000	20179	10161	0	0	11866
153941	2134	96277858000	20179	10161	1	0	2714
153942	2133	96712434000	20179	10161	2	0	2283
153944	1397	1320158150000	20180	10162	0	0	11867
153945	2133	96711432000	20180	10162	1	0	2284
153946	2134	96276855000	20180	10162	2	0	2715
153953	2138	900000000	20181	9899	6	0	\N
153954	1455	8772905000000	20181	9899	7	0	\N
153955	632	72535249000000	20181	9899	8	0	\N
153956	632	70574229000000	20181	9899	9	0	\N
153957	632	69251209000000	20181	9899	10	0	\N
153958	632	68157189000000	20181	9899	11	0	\N
153959	1587	15469565000000	20181	9899	12	0	\N
153960	1643	2262511437200	20181	9899	13	0	\N
153961	1594	16082303000000	20181	9899	14	0	\N
153962	1439	11549840548477	20181	9899	15	0	\N
153963	2142	2849991000000	20181	9899	16	0	\N
153964	1675	15194313999977	20181	9899	17	0	\N
153965	2112	5077984563820	20181	9899	18	0	\N
153966	1536	7747723999959	20181	9899	19	0	\N
153967	1536	3826233999959	20181	9899	20	0	\N
153968	1668	16428284000000	20181	9899	21	0	\N
153969	1693	7302017834936	20181	9899	22	0	\N
153970	1587	9527915000000	20181	9899	23	0	\N
153971	1587	5518965000000	20181	9899	24	0	\N
153972	1587	2203285000000	20181	9899	25	0	\N
153973	1587	1768025000000	20181	9899	26	0	\N
153974	606	79675027812962	20181	9899	27	0	\N
153975	1675	11202303999977	20181	9899	28	0	\N
153976	1675	8508293999977	20181	9899	29	0	\N
153977	1675	1003283999977	20181	9899	30	0	\N
153978	1476	10838451000000	20181	9899	31	0	\N
153979	1607	3707521150625	20181	9899	32	0	\N
153980	2112	3323654080099	20181	9899	33	0	\N
153981	2112	3083656709501	20181	9899	34	0	\N
153982	2112	2843659338903	20181	9899	35	0	\N
153983	2112	2603661968305	20181	9899	36	0	\N
153984	2112	0	20181	9899	37	0	\N
153985	1571	3839779792276	20181	9899	38	0	\N
153986	1571	3475047490484	20181	9899	39	0	\N
153987	1643	1763586477100	20181	9899	40	0	\N
153988	1643	1426948612000	20181	9899	41	0	\N
153989	1536	1180323999959	20181	9899	42	0	\N
153990	1397	1323628497000	20181	9899	43	0	\N
153991	1397	1323618496000	20181	9899	44	0	\N
153992	1571	2821458250612	20181	9899	45	0	\N
153993	1571	2380465313984	20181	9899	46	0	\N
153994	1684	24409822847948	20181	9899	47	0	\N
153995	1684	24200387059336	20181	9899	48	0	\N
153996	1684	23990951270724	20181	9899	49	0	\N
153997	1684	23781515482112	20181	9899	50	0	\N
153998	1985	2299990000000	20181	9899	51	0	\N
153999	1684	23572079693500	20181	9899	52	0	\N
154000	1684	23362643904888	20181	9899	53	0	\N
154001	1571	1151617151056	20181	9899	54	0	\N
154002	1694	22924142263738	20181	9899	55	0	\N
154003	1694	22663479366853	20181	9899	56	0	\N
154004	1540	367206120000	20181	9899	57	0	\N
154005	1439	9491194888477	20181	9899	58	0	\N
154006	2133	97045098000	20181	9899	59	0	\N
154007	1727	15226845999999	20181	9899	60	0	\N
154008	1704	4068312000000	20181	9899	61	0	\N
154009	1704	3750311000000	20181	9899	62	0	\N
154010	1419	33961118987898	20181	9899	63	0	\N
154011	1419	31395016482725	20181	9899	64	0	\N
154012	1419	3167923560130	20181	9899	65	0	\N
154013	1726	58947112000	20181	9899	66	0	\N
154014	1709	9000000	20181	9899	67	0	\N
154015	1769	1579900000	20181	9899	68	0	\N
154016	361	66603937193897	20181	9899	69	0	\N
154017	1704	3725310000000	20181	9899	70	0	\N
154018	2132	148306307000	20181	9899	71	0	\N
154019	1719	16543029000000	20181	9899	72	0	\N
154020	2133	97044096000	20181	9899	73	0	\N
154021	2133	97043094000	20181	9899	74	0	\N
154022	1727	11212144999999	20181	9899	75	0	\N
154023	1727	8503343999999	20181	9899	76	0	\N
154024	1727	955142999999	20181	9899	77	0	\N
154025	1727	661032999999	20181	9899	78	0	\N
154026	1701	12814989874296	20181	9899	79	0	\N
154027	1726	57746112000	20181	9899	80	0	\N
154028	1726	56545112000	20181	9899	81	0	\N
154029	1719	11314328000000	20181	9899	82	0	\N
154030	1719	7786427000000	20181	9899	83	0	\N
154031	1701	11173672916880	20181	9899	84	0	\N
154032	1701	8232447783976	20181	9899	85	0	\N
154033	2132	148305306000	20181	9899	86	0	\N
154034	2132	148304305000	20181	9899	87	0	\N
154035	2132	148303304000	20181	9899	88	0	\N
154036	2133	97042092000	20181	9899	89	0	\N
154037	2133	97041090000	20181	9899	90	0	\N
154038	1701	6247944253479	20181	9899	91	0	\N
154039	1701	717950500103	20181	9899	92	0	\N
154040	2133	97040088000	20181	9899	93	0	\N
154041	2133	97039086000	20181	9899	94	0	\N
154042	2133	97038084000	20181	9899	95	0	\N
154043	2086	2335254300069	20181	9899	96	0	\N
154044	2132	148302303000	20181	9899	97	0	\N
154045	2132	148301302000	20181	9899	98	0	\N
154046	1423	4704939826911	20182	10085	0	0	\N
154047	1423	4336576653837	20182	10085	1	0	\N
154048	1423	3968213480763	20182	10085	2	0	\N
154049	1423	3599850307689	20182	10085	3	0	\N
154050	1423	3231487134615	20182	10085	4	0	\N
154051	1423	2863123961541	20182	10085	5	0	\N
154052	1423	2494760788467	20182	10085	6	0	\N
154053	1423	2126397615393	20182	10085	7	0	\N
154054	1423	1758034442319	20182	10085	8	0	\N
154055	1423	1389671269245	20182	10085	9	0	\N
154056	1423	1021308096171	20182	10085	10	0	\N
154057	1423	652944923097	20182	10085	11	0	\N
154058	1423	284581750023	20182	10085	12	0	\N
154059	1668	16428284000000	20182	10085	13	0	\N
154060	1423	571750023	20182	10085	14	0	\N
154061	1668	13446953000000	20182	10085	15	0	\N
154062	1668	5139227000000	20182	10085	16	0	\N
154063	1668	2673466000000	20182	10085	17	0	\N
154064	1522	16145291000000	20182	10085	18	0	\N
154065	1522	12223281000000	20182	10085	19	0	\N
154066	1522	9577271000000	20182	10085	20	0	\N
154067	1522	2203261000000	20182	10085	21	0	\N
154068	1540	367206120000	20182	10085	22	0	\N
154069	1540	0	20182	10085	23	0	\N
154070	1439	10931217888477	20182	10085	24	0	\N
154071	1699	250750126	20182	10085	25	0	\N
154072	2132	148246247000	20182	10085	26	0	\N
154073	1689	7463337179995	20182	10085	27	0	\N
154074	2134	96358098000	20182	10085	28	0	\N
154075	2134	96357095000	20182	10085	29	0	\N
154076	1726	42133112000	20182	10085	30	0	\N
154077	2087	193000000	20182	10085	31	0	\N
154078	2133	96795600000	20182	10085	32	0	\N
154079	2133	96794598000	20182	10085	33	0	\N
154080	1419	34681121987898	20182	10085	34	0	\N
154081	1419	32115019482725	20182	10085	35	0	\N
154082	1419	3887926560130	20182	10085	36	0	\N
154083	361	66641271116779	20182	10085	37	0	\N
154084	1726	40932112000	20182	10085	38	0	\N
154085	1719	17983066000000	20182	10085	39	0	\N
154086	1439	7880106968477	20182	10085	40	0	\N
154087	1439	2143509578477	20182	10085	41	0	\N
154088	2132	148245246000	20182	10085	42	0	\N
154102	1882	719910000000	20185	9927	0	0	\N
154103	1895	1439936000000	20185	9927	1	0	\N
154104	1650	10624110000000	20185	9927	2	0	\N
154105	1650	7667000000000	20185	9927	3	0	\N
154106	1650	5671890000000	20185	9927	4	0	\N
154107	1650	112780000000	20185	9927	5	0	\N
154108	2137	900000000	20185	9927	6	0	\N
154109	2137	100000000	20185	9927	7	0	\N
154110	2138	900000000	20185	9927	8	0	\N
154111	2138	0	20185	9927	9	0	\N
154112	1670	11906159000000	20185	9927	10	0	\N
154113	1670	6749059000000	20185	9927	11	0	\N
154114	1670	3268959000000	20185	9927	12	0	\N
154115	1670	390859000000	20185	9927	13	0	\N
154116	1423	3984936826911	20185	9927	14	0	\N
154117	1423	3616573653837	20185	9927	15	0	\N
154118	1423	3248210480763	20185	9927	16	0	\N
154119	1423	2879847307689	20185	9927	17	0	\N
154120	1423	2511484134615	20185	9927	18	0	\N
154121	1423	2143120961541	20185	9927	19	0	\N
154122	1423	1774757788467	20185	9927	20	0	\N
154123	1423	1406394615393	20185	9927	21	0	\N
154124	1423	1038031442319	20185	9927	22	0	\N
154125	1423	669668269245	20185	9927	23	0	\N
154126	1423	301305096171	20185	9927	24	0	\N
154127	1981	100880000000	20185	9927	25	0	\N
154128	632	73977744000000	20185	9927	26	0	\N
154129	632	72016724000000	20185	9927	27	0	\N
154130	632	70693704000000	20185	9927	28	0	\N
154131	632	69599684000000	20185	9927	29	0	\N
154132	1587	15469565000000	20185	9927	30	0	\N
154133	1594	16082303000000	20185	9927	31	0	\N
154134	1671	10569939634395	20185	9927	32	0	\N
154135	1439	11549840548477	20185	9927	33	0	\N
154136	2142	2849991000000	20185	9927	34	0	\N
154137	1675	15194313999977	20185	9927	36	0	\N
154138	353	66000000000000	20185	9927	37	0	\N
154139	2112	5077984563820	20185	9927	38	0	\N
154140	1610	16887582889950	20185	9927	39	0	\N
154141	1610	12312518189950	20185	9927	40	0	\N
154142	1536	7747723999959	20185	9927	41	0	\N
154143	1536	3826233999959	20185	9927	42	0	\N
154144	1668	16428284000000	20185	9927	43	0	\N
154145	1671	6975243815095	20185	9927	44	0	\N
154146	1671	4549827663645	20185	9927	45	0	\N
154147	1587	9527915000000	20185	9927	46	0	\N
154148	1587	5518965000000	20185	9927	47	0	\N
154149	1587	2203285000000	20185	9927	48	0	\N
154150	1587	1768025000000	20185	9927	49	0	\N
154151	1587	1332765000000	20185	9927	50	0	\N
154152	1587	0	20185	9927	51	0	\N
154153	1594	8402053000000	20185	9927	52	0	\N
154154	606	79675027812962	20185	9927	53	0	\N
154155	606	78675017812962	20185	9927	54	0	\N
154156	1675	11202303999977	20185	9927	55	0	\N
154157	1675	8508293999977	20185	9927	56	0	\N
154158	1675	1003283999977	20185	9927	57	0	\N
154159	1476	10838451000000	20185	9927	58	0	\N
154160	1610	9225627609950	20185	9927	59	0	\N
154161	1610	623750449950	20185	9927	60	0	\N
154162	271	66411407920446	20185	9927	61	0	\N
154163	1607	3707521150625	20185	9927	62	0	\N
154164	1668	13446953000000	20185	9927	63	0	\N
154165	1668	5139227000000	20185	9927	64	0	\N
154166	1668	2673466000000	20185	9927	65	0	\N
154167	2112	3323654080099	20185	9927	66	0	\N
154168	2112	3083656709501	20185	9927	67	0	\N
154169	2112	2843659338903	20185	9927	68	0	\N
154170	2112	2603661968305	20185	9927	69	0	\N
154171	2112	0	20185	9927	70	0	\N
154172	1607	563783874815	20185	9927	71	0	\N
154173	1607	323786504217	20185	9927	72	0	\N
154174	1571	3839779792276	20185	9927	73	0	\N
154175	1571	3475047490484	20185	9927	74	0	\N
154176	1536	1180323999959	20185	9927	75	0	\N
154177	1397	1321968331000	20185	9927	76	0	\N
154178	1397	1321958330000	20185	9927	77	0	\N
154179	1397	1321948329000	20185	9927	78	0	\N
154180	1397	1321938328000	20185	9927	79	0	\N
154181	1397	1321928327000	20185	9927	80	0	\N
154182	1397	1321918326000	20185	9927	81	0	\N
154183	1397	1321908325000	20185	9927	82	0	\N
154184	1397	1321898324000	20185	9927	83	0	\N
154185	1397	1321888323000	20185	9927	84	0	\N
154186	1571	2821458250612	20185	9927	85	0	\N
154187	1571	2380465313984	20185	9927	86	0	\N
154188	1684	24409822847948	20185	9927	87	0	\N
154189	1684	24200387059336	20185	9927	88	0	\N
154190	1684	23990951270724	20185	9927	89	0	\N
154191	1684	23781515482112	20185	9927	90	0	\N
154192	1594	5645893000000	20185	9927	91	0	\N
154193	1594	1561003000000	20185	9927	92	0	\N
154194	1671	2543845003785	20185	9927	93	0	\N
154195	1397	1321878322000	20185	9927	94	0	\N
154196	1397	1321868321000	20185	9927	95	0	\N
154197	1397	1321858320000	20185	9927	96	0	\N
154198	1397	1321848319000	20185	9927	97	0	\N
154199	1397	1321838318000	20185	9927	98	0	\N
154200	1684	23572079693500	20185	9927	99	0	\N
154201	1684	23362643904888	20185	9927	100	0	\N
154202	1684	23153208116276	20185	9927	101	0	\N
154203	1684	22943772327664	20185	9927	102	0	\N
154204	1684	22734336539052	20185	9927	103	0	\N
154205	1684	22524900750440	20185	9927	104	0	\N
154206	1684	22315464961828	20185	9927	105	0	\N
154207	1684	22106029173216	20185	9927	106	0	\N
154208	1684	21896593384604	20185	9927	107	0	\N
154209	1684	21687157595992	20185	9927	108	0	\N
154210	1684	21477721807380	20185	9927	109	0	\N
154211	1684	21268286018768	20185	9927	110	0	\N
154212	1684	21058850230156	20185	9927	111	0	\N
154213	1684	20849414441544	20185	9927	112	0	\N
154214	1684	20639978652932	20185	9927	113	0	\N
154215	1684	20430542864320	20185	9927	114	0	\N
154216	1684	20221107075708	20185	9927	115	0	\N
154217	1684	20011671287096	20185	9927	116	0	\N
154218	1684	19802235498484	20185	9927	117	0	\N
154219	1684	19592799709872	20185	9927	118	0	\N
154220	1684	19383363921260	20185	9927	119	0	\N
154221	1684	19173928132648	20185	9927	120	0	\N
154222	1684	18964492344036	20185	9927	121	0	\N
154223	1684	18755056555424	20185	9927	122	0	\N
154224	1684	18545620766812	20185	9927	123	0	\N
154091	1397	1320128147000	20183	10163	2	0	11870
154092	2133	96710430000	20183	10163	3	0	2285
154093	2134	96275852000	20183	10163	4	0	2716
154094	2134	96274849000	20183	10163	5	0	2717
154095	2134	96273846000	20183	10163	6	0	2718
154097	2133	96709428000	20183	10163	8	0	2286
154098	2133	96708426000	20183	10163	9	0	2287
154099	1397	1320118146000	20184	10164	0	0	11871
154100	2133	96707424000	20184	10164	1	0	2288
154101	2134	96272843000	20184	10164	2	0	2719
154225	1684	18336184978200	20185	9927	124	0	\N
154236	1397	1320078142000	20187	10166	0	0	\N
154237	2133	96703416000	20187	10166	1	0	\N
154238	2134	96268831000	20187	10166	2	0	\N
154239	1397	1320078142000	20188	10166	0	0	\N
154240	2133	96703416000	20188	10166	1	0	\N
154241	2134	96268831000	20188	10166	2	0	\N
154267	1397	1319998134000	20194	10171	0	0	\N
154268	1700	13315653400429	20194	10171	1	0	\N
154269	1700	10232849655741	20194	10171	2	0	\N
154270	2132	148229230000	20194	10171	3	0	\N
154271	2133	96695400000	20194	10171	4	0	\N
154272	2134	96261810000	20194	10171	5	0	\N
154273	1397	1319998134000	20195	10171	0	0	\N
154274	1700	13315653400429	20195	10171	1	0	\N
154275	1700	10232849655741	20195	10171	2	0	\N
154276	2132	148229230000	20195	10171	3	0	\N
154277	2133	96695400000	20195	10171	4	0	\N
154278	2134	96261810000	20195	10171	5	0	\N
154289	1397	1319988133000	20198	10172	0	0	\N
154290	1700	5663842025733	20198	10172	1	0	\N
154291	2133	96694398000	20198	10172	2	0	\N
154292	2134	96260807000	20198	10172	3	0	\N
154301	1397	1319958130000	20200	10174	0	0	\N
154302	2133	96691392000	20200	10174	1	0	\N
154303	2134	96257798000	20200	10174	2	0	\N
154310	1397	1319938128000	20203	10176	0	0	\N
154311	2134	96255792000	20203	10176	1	0	\N
154312	2133	96689388000	20203	10176	2	0	\N
154316	1397	1319938128000	20205	10176	0	0	\N
154317	2134	96255792000	20205	10176	1	0	\N
154318	2133	96689388000	20205	10176	2	0	\N
154319	1397	1320148149000	20206	10163	0	0	\N
154320	1700	13315653400429	20206	10163	1	0	\N
154321	1700	10232849655741	20206	10163	2	0	\N
154322	1700	5663842025733	20206	10163	3	0	\N
154323	1700	3114155979053	20206	10163	4	0	\N
154324	1397	1320138148000	20206	10163	5	0	\N
154325	1397	1320128147000	20206	10163	6	0	\N
154326	1397	1320118146000	20206	10163	7	0	\N
154327	1397	1320108145000	20206	10163	8	0	\N
154328	1397	1320098144000	20206	10163	9	0	\N
154329	1397	1320088143000	20206	10163	10	0	\N
154330	1397	1320078142000	20206	10163	11	0	\N
154331	1397	1320068141000	20206	10163	12	0	\N
154332	1397	1320058140000	20206	10163	13	0	\N
154333	1397	1320048139000	20206	10163	14	0	\N
154334	1397	1320038138000	20206	10163	15	0	\N
154335	1397	1320028137000	20206	10163	16	0	\N
154336	1397	1320018136000	20206	10163	17	0	\N
154337	1397	1320008135000	20206	10163	18	0	\N
154338	1397	1319998134000	20206	10163	19	0	\N
154339	1397	1319988133000	20206	10163	20	0	\N
154340	1397	1319978132000	20206	10163	21	0	\N
154341	1397	1319968131000	20206	10163	22	0	\N
154342	1397	1319958130000	20206	10163	23	0	\N
154343	1397	1319948129000	20206	10163	24	0	\N
154344	1397	1319938128000	20206	10163	25	0	\N
154345	2133	96710430000	20206	10163	26	0	\N
154346	2134	96275852000	20206	10163	27	0	\N
154347	2134	96274849000	20206	10163	28	0	\N
154348	2134	96273846000	20206	10163	29	0	\N
154349	2132	148233234000	20206	10163	30	0	\N
154350	2132	148232233000	20206	10163	31	0	\N
154351	2132	148231232000	20206	10163	32	0	\N
154352	2132	148230231000	20206	10163	33	0	\N
154353	2132	148229230000	20206	10163	34	0	\N
154354	2133	96709428000	20206	10163	35	0	\N
154355	2133	96708426000	20206	10163	36	0	\N
154356	2133	96707424000	20206	10163	37	0	\N
154357	2133	96706422000	20206	10163	38	0	\N
154358	2133	96705420000	20206	10163	39	0	\N
154359	2133	96704418000	20206	10163	40	0	\N
154360	2133	96703416000	20206	10163	41	0	\N
154228	1397	1320088143000	20186	10165	2	0	11874
154229	2133	96706422000	20186	10165	3	0	2289
154230	2133	96705420000	20186	10165	4	0	2290
154231	2133	96704418000	20186	10165	5	0	2291
154232	2134	96271840000	20186	10165	6	0	2720
154234	2134	96269834000	20186	10165	8	0	2722
154235	2132	148232233000	20186	10165	9	0	767
154242	1397	1320078142000	20189	10166	0	0	11875
154243	2133	96703416000	20189	10166	1	0	2292
154244	2134	96268831000	20189	10166	2	0	2723
154246	2133	96702414000	20190	10167	1	0	2293
154247	2132	148231232000	20190	10167	2	0	768
154248	2134	96267828000	20190	10167	3	0	2724
154249	1397	1320058140000	20191	10168	0	0	11877
154251	1397	1320038138000	20191	10168	2	0	11879
154252	2133	96701412000	20191	10168	3	0	2294
154253	2134	96266825000	20191	10168	4	0	2725
154254	2134	96265822000	20191	10168	5	0	2726
154255	2134	96264819000	20191	10168	6	0	2727
154257	2133	96699408000	20191	10168	8	0	2296
154258	1397	1320028137000	20192	10169	0	0	11880
154259	2134	96263816000	20192	10169	1	0	2728
154260	2132	148230231000	20192	10169	2	0	769
154261	2133	96698406000	20192	10169	3	0	2297
154263	1397	1320008135000	20193	10170	1	0	11882
154264	2133	96697404000	20193	10170	2	0	2298
154265	2133	96696402000	20193	10170	3	0	2299
154266	2134	96262813000	20193	10170	4	0	2729
154280	1700	13315653400429	20196	10171	1	0	7
154281	1700	10232849655741	20196	10171	2	0	8
154282	2132	148229230000	20196	10171	3	0	770
154283	2133	96695400000	20196	10171	4	0	2300
154284	2134	96261810000	20196	10171	5	0	2730
154286	1700	5663842025733	20197	10172	1	0	9
154287	2133	96694398000	20197	10172	2	0	2301
154288	2134	96260807000	20197	10172	3	0	2731
154293	1700	3114155979053	20199	10173	0	0	10
154294	1397	1319978132000	20199	10173	1	0	11885
154296	2133	96693396000	20199	10173	3	0	2302
154297	2133	96692394000	20199	10173	4	0	2303
154298	2134	96259804000	20199	10173	5	0	2732
154299	2134	96258801000	20199	10173	6	0	2733
154304	1397	1319958130000	20201	10174	0	0	11887
154305	2133	96691392000	20201	10174	1	0	2304
154306	2134	96257798000	20201	10174	2	0	2734
154307	1397	1319948129000	20202	10175	0	0	11888
154308	2134	96256795000	20202	10175	1	0	2735
154313	1397	1319938128000	20204	10176	0	0	11889
154314	2134	96255792000	20204	10176	1	0	2736
154315	2133	96689388000	20204	10176	2	0	2306
154361	2133	96702414000	20206	10163	42	0	\N
154362	2133	96701412000	20206	10163	43	0	\N
154363	2133	96700410000	20206	10163	44	0	\N
154364	2133	96699408000	20206	10163	45	0	\N
154365	2133	96698406000	20206	10163	46	0	\N
154366	2133	96697404000	20206	10163	47	0	\N
154367	2133	96696402000	20206	10163	48	0	\N
154368	2133	96695400000	20206	10163	49	0	\N
154369	2133	96694398000	20206	10163	50	0	\N
154370	2133	96693396000	20206	10163	51	0	\N
154371	2133	96692394000	20206	10163	52	0	\N
154372	2133	96691392000	20206	10163	53	0	\N
154373	2133	96690390000	20206	10163	54	0	\N
154374	2134	96272843000	20206	10163	55	0	\N
154375	2134	96271840000	20206	10163	56	0	\N
154376	2134	96270837000	20206	10163	57	0	\N
154377	2134	96269834000	20206	10163	58	0	\N
154378	2134	96268831000	20206	10163	59	0	\N
154379	2134	96267828000	20206	10163	60	0	\N
154380	2134	96266825000	20206	10163	61	0	\N
154381	2134	96265822000	20206	10163	62	0	\N
154382	2134	96264819000	20206	10163	63	0	\N
154383	2134	96263816000	20206	10163	64	0	\N
154384	2134	96262813000	20206	10163	65	0	\N
154385	2134	96261810000	20206	10163	66	0	\N
154386	2134	96260807000	20206	10163	67	0	\N
154387	2134	96259804000	20206	10163	68	0	\N
154388	2134	96258801000	20206	10163	69	0	\N
154389	2134	96257798000	20206	10163	70	0	\N
154390	2134	96256795000	20206	10163	71	0	\N
154391	2134	96255792000	20206	10163	72	0	\N
154392	2132	148228229000	20206	10163	73	0	\N
154393	2133	96689388000	20206	10163	74	0	\N
154397	1397	1319918126000	20208	10178	0	0	\N
154398	2134	96254789000	20208	10178	1	0	\N
154399	2133	96687384000	20208	10178	2	0	\N
154400	1397	1319918126000	20209	10178	0	0	\N
154401	2134	96254789000	20209	10178	1	0	\N
154402	2133	96687384000	20209	10178	2	0	\N
154403	1397	1319918126000	20210	10178	0	0	\N
154404	2134	96254789000	20210	10178	1	0	\N
154405	2133	96687384000	20210	10178	2	0	\N
154409	1397	1319928127000	20212	10164	0	0	\N
154410	1397	1319918126000	20212	10164	1	0	\N
154411	2133	96688386000	20212	10164	2	0	\N
154412	2134	96254789000	20212	10164	3	0	\N
154413	2133	96687384000	20212	10164	4	0	\N
154414	2132	148227228000	20212	10164	5	0	\N
154426	1397	1319878122000	20215	10181	0	0	\N
154427	1397	1319868121000	20215	10181	1	0	\N
154428	2132	148225226000	20215	10181	2	0	\N
154429	2134	96250777000	20215	10181	3	0	\N
154430	2133	96683376000	20215	10181	4	0	\N
154431	2133	96682374000	20215	10181	5	0	\N
154432	2134	96249774000	20215	10181	6	0	\N
154433	1397	1319878122000	20216	10181	0	0	\N
154434	1397	1319868121000	20216	10181	1	0	\N
154435	2132	148225226000	20216	10181	2	0	\N
154436	2134	96250777000	20216	10181	3	0	\N
154437	2133	96683376000	20216	10181	4	0	\N
154438	2133	96682374000	20216	10181	5	0	\N
154439	2134	96249774000	20216	10181	6	0	\N
154445	1397	1319878122000	20218	10181	0	0	\N
154446	1397	1319868121000	20218	10181	1	0	\N
154447	2132	148225226000	20218	10181	2	0	\N
154448	2134	96250777000	20218	10181	3	0	\N
154449	2133	96683376000	20218	10181	4	0	\N
154450	2133	96682374000	20218	10181	5	0	\N
154451	2134	96249774000	20218	10181	6	0	\N
154452	1397	1319878122000	20219	10181	0	0	\N
154453	1397	1319868121000	20219	10181	1	0	\N
154454	2132	148225226000	20219	10181	2	0	\N
154455	2134	96250777000	20219	10181	3	0	\N
154456	2133	96683376000	20219	10181	4	0	\N
154457	2133	96682374000	20219	10181	5	0	\N
154458	2134	96249774000	20219	10181	6	0	\N
154459	1397	1319858120000	20220	10182	0	0	\N
154460	1397	1319848119000	20220	10182	1	0	\N
154461	1397	1319838118000	20220	10182	2	0	\N
154462	2133	96681372000	20220	10182	3	0	\N
154463	2133	96680370000	20220	10182	4	0	\N
154464	2133	96679368000	20220	10182	5	0	\N
154465	2134	96250777000	20220	10182	6	0	\N
154466	2134	96249774000	20220	10182	7	0	\N
154467	2134	96248771000	20220	10182	8	0	\N
154468	2134	96247768000	20220	10182	9	0	\N
154469	1397	1319858120000	20221	10182	0	0	\N
154470	1397	1319848119000	20221	10182	1	0	\N
154471	1397	1319838118000	20221	10182	2	0	\N
154472	2133	96681372000	20221	10182	3	0	\N
154473	2133	96680370000	20221	10182	4	0	\N
154474	2133	96679368000	20221	10182	5	0	\N
154475	2134	96250777000	20221	10182	6	0	\N
154476	2134	96249774000	20221	10182	7	0	\N
154477	2134	96248771000	20221	10182	8	0	\N
154478	2134	96247768000	20221	10182	9	0	\N
154479	1397	1319858120000	20222	10182	0	0	\N
154480	1397	1319848119000	20222	10182	1	0	\N
154481	1397	1319838118000	20222	10182	2	0	\N
154482	2133	96681372000	20222	10182	3	0	\N
154483	2133	96680370000	20222	10182	4	0	\N
154484	2133	96679368000	20222	10182	5	0	\N
154485	2134	96250777000	20222	10182	6	0	\N
154486	2134	96249774000	20222	10182	7	0	\N
154487	2134	96248771000	20222	10182	8	0	\N
154488	2134	96247768000	20222	10182	9	0	\N
154396	2132	148227228000	20207	10177	2	0	772
154406	1397	1319918126000	20211	10178	0	0	11891
154407	2134	96254789000	20211	10178	1	0	2737
154408	2133	96687384000	20211	10178	2	0	2308
154415	1397	1319908125000	20213	10179	0	0	11892
154417	2226	9000000	20213	10179	2	0	1
154418	2133	96686382000	20213	10179	3	0	2309
154419	2134	96253786000	20213	10179	4	0	2738
154420	2134	96252783000	20213	10179	5	0	2739
154421	2132	148226227000	20213	10179	6	0	773
154423	1397	1319888123000	20214	10180	0	0	11894
154424	2133	96684378000	20214	10180	1	0	2311
154425	2134	96251780000	20214	10180	2	0	2740
154440	1397	1319878122000	20217	10181	0	0	11895
154442	2132	148225226000	20217	10181	2	0	774
154443	2133	96683376000	20217	10181	3	0	2312
154444	2133	96682374000	20217	10181	4	0	2313
154489	1397	1319858120000	20223	10182	0	0	11897
154490	1397	1319848119000	20223	10182	1	0	11898
154492	2133	96681372000	20223	10182	3	0	2314
154493	2133	96680370000	20223	10182	4	0	2315
154494	2133	96679368000	20223	10182	5	0	2316
154495	2134	96250777000	20223	10182	6	0	2741
154496	2134	96249774000	20223	10182	7	0	2742
154499	1397	1319828117000	20224	10183	0	0	\N
154500	2132	148224225000	20224	10183	1	0	\N
154501	2134	96246765000	20224	10183	2	0	\N
154505	1397	1319828117000	20226	10183	0	0	\N
154506	2132	148224225000	20226	10183	1	0	\N
154507	2134	96246765000	20226	10183	2	0	\N
154508	1397	1319818116000	20227	10184	0	0	\N
154509	1397	1319808115000	20227	10184	1	0	\N
154510	2133	96678366000	20227	10184	2	0	\N
154511	2133	96677364000	20227	10184	3	0	\N
154512	2134	96245762000	20227	10184	4	0	\N
154513	2134	96244759000	20227	10184	5	0	\N
154527	1397	1319788113000	20231	10186	0	0	\N
154528	2134	96242753000	20231	10186	1	0	\N
154529	2133	96675360000	20231	10186	2	0	\N
154536	1397	1319768111000	20233	10188	0	0	\N
154537	2134	96240747000	20233	10188	1	0	\N
154538	2133	96673356000	20233	10188	2	0	\N
154539	2132	148222223000	20233	10188	3	0	\N
154544	1397	1319768111000	20235	10188	0	0	\N
154545	2134	96240747000	20235	10188	1	0	\N
154546	2133	96673356000	20235	10188	2	0	\N
154547	2132	148222223000	20235	10188	3	0	\N
154548	1397	1319908125000	20236	10165	0	0	\N
154549	1710	19819405209850	20236	10165	1	0	\N
154550	1710	14917550910810	20236	10165	2	0	\N
154551	1710	11610168886100	20236	10165	3	0	\N
154552	1397	1319898124000	20236	10165	4	0	\N
154553	1397	1319888123000	20236	10165	5	0	\N
154554	1397	1319878122000	20236	10165	6	0	\N
154555	1710	2393872664140	20236	10165	7	0	\N
154556	1397	1319868121000	20236	10165	8	0	\N
154557	1397	1319858120000	20236	10165	9	0	\N
154558	1397	1319848119000	20236	10165	10	0	\N
154559	1397	1319838118000	20236	10165	11	0	\N
154560	1397	1319828117000	20236	10165	12	0	\N
154561	1397	1319818116000	20236	10165	13	0	\N
154562	1397	1319808115000	20236	10165	14	0	\N
154563	1397	1319798114000	20236	10165	15	0	\N
154564	1397	1319788113000	20236	10165	16	0	\N
154565	1397	1319778112000	20236	10165	17	0	\N
154566	1397	1319768111000	20236	10165	18	0	\N
154567	2226	9000000	20236	10165	19	0	\N
154568	2133	96686382000	20236	10165	20	0	\N
154569	2134	96253786000	20236	10165	21	0	\N
154570	2134	96252783000	20236	10165	22	0	\N
154571	2134	96251780000	20236	10165	23	0	\N
154572	2134	96250777000	20236	10165	24	0	\N
154573	2132	148226227000	20236	10165	25	0	\N
154574	2132	148225226000	20236	10165	26	0	\N
154575	2132	148224225000	20236	10165	27	0	\N
154576	2132	148223224000	20236	10165	28	0	\N
154577	2132	148222223000	20236	10165	29	0	\N
154578	2134	96249774000	20236	10165	30	0	\N
154579	2134	96248771000	20236	10165	31	0	\N
154580	2134	96247768000	20236	10165	32	0	\N
154581	2134	96246765000	20236	10165	33	0	\N
154582	2134	96245762000	20236	10165	34	0	\N
154583	2134	96244759000	20236	10165	35	0	\N
154584	2134	96243756000	20236	10165	36	0	\N
154585	2134	96242753000	20236	10165	38	0	\N
154586	2134	96241750000	20236	10165	39	0	\N
154587	2134	96240747000	20236	10165	40	0	\N
154588	2133	96685380000	20236	10165	41	0	\N
154589	2133	96684378000	20236	10165	42	0	\N
154590	2133	96683376000	20236	10165	43	0	\N
154591	2133	96682374000	20236	10165	44	0	\N
154592	2133	96681372000	20236	10165	45	0	\N
154593	2133	96680370000	20236	10165	46	0	\N
154594	2133	96679368000	20236	10165	47	0	\N
154595	2133	96678366000	20236	10165	48	0	\N
154596	2133	96677364000	20236	10165	49	0	\N
154597	2133	96676362000	20236	10165	50	0	\N
154598	2133	96675360000	20236	10165	51	0	\N
154599	2133	96674358000	20236	10165	52	0	\N
154600	2133	96673356000	20236	10165	53	0	\N
154611	606	74795607916843	20240	10191	0	0	\N
154612	1397	1319738108000	20240	10191	1	0	\N
154613	2133	96670350000	20240	10191	2	0	\N
154614	2134	96237738000	20240	10191	3	0	\N
154615	606	74795607916843	20241	10191	0	0	\N
154616	1397	1319738108000	20241	10191	1	0	\N
154617	2133	96670350000	20241	10191	2	0	\N
154618	2134	96237738000	20241	10191	3	0	\N
154502	1397	1319828117000	20225	10183	0	0	11900
154503	2132	148224225000	20225	10183	1	0	775
154504	2134	96246765000	20225	10183	2	0	2745
154514	1397	1319818116000	20228	10184	0	0	11901
154515	1397	1319808115000	20228	10184	1	0	11902
154517	2133	96677364000	20228	10184	3	0	2318
154518	2134	96245762000	20228	10184	4	0	2746
154519	2134	96244759000	20228	10184	5	0	2747
154520	1397	1319798114000	20229	10185	0	0	11903
154521	2134	96243756000	20229	10185	1	0	2748
154523	2132	148223224000	20229	10185	3	0	776
154524	1397	1319788113000	20230	10186	0	0	11904
154525	2134	96242753000	20230	10186	1	0	2749
154526	2133	96675360000	20230	10186	2	0	2320
154531	1710	19819405209850	20232	10187	1	0	7
154532	1710	14917550910810	20232	10187	2	0	8
154533	1710	11610168886100	20232	10187	3	0	9
154534	2134	96241750000	20232	10187	4	0	2750
154535	2133	96674358000	20232	10187	5	0	2321
154541	2134	96240747000	20234	10188	1	0	2751
154542	2133	96673356000	20234	10188	2	0	2322
154543	2132	148222223000	20234	10188	3	0	777
154601	1397	1319758110000	20237	10189	0	0	11907
154602	2133	96672354000	20237	10189	1	0	2323
154604	1397	1319748109000	20238	10190	0	0	11908
154605	2134	96238741000	20238	10190	1	0	2753
154606	2133	96671352000	20238	10190	2	0	2324
154607	606	74795607916843	20239	10191	0	0	15
154609	2133	96670350000	20239	10191	2	0	2325
154610	2134	96237738000	20239	10191	3	0	2754
154619	1397	1319728107000	20242	10192	0	0	11910
154620	606	71199912097546	20242	10192	1	0	16
154621	606	68773495946091	20242	10192	2	0	17
154623	2134	96236735000	20242	10192	4	0	2755
154624	2132	148221222000	20242	10192	5	0	778
154625	2133	96669348000	20242	10192	6	0	2326
154626	1397	1319718106000	20243	10193	0	0	11911
154627	2133	96668346000	20243	10193	1	0	2327
154629	1710	2393862664140	20244	10194	0	0	10
154630	1397	1319708105000	20244	10194	1	0	11912
154631	1397	1319698104000	20244	10194	2	0	11913
154632	2134	96234729000	20244	10194	3	0	2757
154659	1397	1319648099000	20248	10197	0	0	\N
154660	1397	1319638098000	20248	10197	1	0	\N
154661	1397	1319628097000	20248	10197	2	0	\N
154662	2133	96661332000	20248	10197	3	0	\N
154663	2134	96228711000	20248	10197	4	0	\N
154664	2132	148218219000	20248	10197	5	0	\N
154665	2133	96660330000	20248	10197	6	0	\N
154666	2134	96227708000	20248	10197	7	0	\N
154667	2133	96659328000	20248	10197	9	0	\N
154674	1397	1319598094000	20251	10200	0	0	\N
154675	1397	1319588093000	20251	10200	1	0	\N
154676	2134	96224699000	20251	10200	2	0	\N
154677	2134	96223696000	20251	10200	3	0	\N
154678	2133	96656322000	20251	10200	4	0	\N
154679	2133	96655320000	20251	10200	5	0	\N
154680	2132	148217218000	20251	10200	6	0	\N
154688	1397	1319578092000	20253	10201	0	0	\N
154689	1397	1319568091000	20253	10201	1	0	\N
154690	1397	1319558090000	20253	10201	2	0	\N
154691	1397	1319548089000	20253	10201	3	0	\N
154692	2133	96654318000	20253	10201	4	0	\N
154693	2134	96222693000	20253	10201	5	0	\N
154694	2133	96653316000	20253	10201	6	0	\N
154695	2133	96652314000	20253	10201	7	0	\N
154696	2133	96651312000	20253	10201	8	0	\N
154697	2132	148216217000	20253	10201	9	0	\N
154698	2134	96221690000	20253	10201	10	0	\N
154699	2134	96220687000	20253	10201	11	0	\N
154700	2134	96219684000	20253	10201	12	0	\N
154717	1397	1319538088000	20256	10202	0	0	\N
154718	2134	96218681000	20256	10202	1	0	\N
154719	1397	1319538088000	20257	10202	0	0	\N
154720	2133	96650310000	20257	10202	1	0	\N
154721	2134	96218681000	20257	10202	2	0	\N
154735	1397	1319498084000	20261	10205	0	0	\N
154736	2133	96646302000	20261	10205	1	0	\N
154737	2134	96214669000	20261	10205	2	0	\N
154738	2132	148214215000	20261	10205	3	0	\N
154739	1397	1319498084000	20262	10205	0	0	\N
154740	2133	96646302000	20262	10205	1	0	\N
154741	2134	96214669000	20262	10205	2	0	\N
154742	2132	148214215000	20262	10205	3	0	\N
154743	1397	1319498084000	20263	10205	0	0	\N
154744	2133	96646302000	20263	10205	1	0	\N
154745	2134	96214669000	20263	10205	2	0	\N
154746	2132	148214215000	20263	10205	3	0	\N
154747	1397	1319488083000	20264	10206	0	0	\N
154748	1397	1319478082000	20264	10206	1	0	\N
154749	2133	96646302000	20264	10206	2	0	\N
154750	2133	96645300000	20264	10206	3	0	\N
154751	2133	96644298000	20264	10206	4	0	\N
154752	2134	96213666000	20264	10206	5	0	\N
154753	2134	96212663000	20264	10206	6	0	\N
154764	1397	1319468081000	20267	10207	0	0	\N
154765	2132	148213214000	20267	10207	1	0	\N
154766	2133	96643296000	20267	10207	2	0	\N
154767	1397	1319458080000	20268	10208	0	0	\N
154768	2134	96211660000	20268	10208	1	0	\N
154635	2133	96666342000	20244	10194	6	0	2329
154636	2134	96233726000	20244	10194	7	0	2758
154637	1397	1319688103000	20245	10195	0	0	11914
154638	1397	1319678102000	20245	10195	1	0	11915
154639	2133	96665340000	20245	10195	2	0	2330
154641	2133	96664338000	20245	10195	4	0	2331
154642	2134	96231720000	20245	10195	5	0	2760
154643	1397	1319668101000	20246	10196	0	0	11916
154644	1397	1319658100000	20246	10196	1	0	11917
154645	2132	148219220000	20246	10196	2	0	780
154647	2133	96662334000	20246	10196	4	0	2333
154648	2134	96230717000	20246	10196	5	0	2761
154649	2134	96229714000	20246	10196	6	0	2762
154650	1397	1319648099000	20247	10197	0	0	11918
154652	1397	1319628097000	20247	10197	2	0	11920
154653	2133	96661332000	20247	10197	3	0	2334
154654	2134	96228711000	20247	10197	4	0	2763
154655	2132	148218219000	20247	10197	5	0	781
154656	2133	96660330000	20247	10197	6	0	2335
154658	2133	96659328000	20247	10197	9	0	2336
154668	1397	1319618096000	20249	10198	0	0	11921
154669	2134	96226705000	20249	10198	1	0	2765
154670	2133	96658326000	20249	10198	2	0	2337
154671	1397	1319608095000	20250	10199	0	0	11922
154673	2134	96225702000	20250	10199	2	0	2766
154681	1397	1319598094000	20252	10200	0	0	11923
154682	1397	1319588093000	20252	10200	1	0	11924
154683	2134	96224699000	20252	10200	2	0	2767
154685	2133	96656322000	20252	10200	4	0	2339
154686	2133	96655320000	20252	10200	5	0	2340
154687	2132	148217218000	20252	10200	6	0	782
154701	1397	1319578092000	20254	10201	0	0	11925
154702	1397	1319568091000	20254	10201	1	0	11926
154704	1397	1319548089000	20254	10201	3	0	11928
154705	2133	96654318000	20254	10201	4	0	2341
154706	2134	96222693000	20254	10201	5	0	2769
154707	2133	96653316000	20254	10201	6	0	2342
154708	2133	96652314000	20254	10201	7	0	2343
154710	2132	148216217000	20254	10201	9	0	783
154711	2134	96221690000	20254	10201	10	0	2770
154712	2134	96220687000	20254	10201	11	0	2771
154713	2134	96219684000	20254	10201	12	0	2772
154715	2133	96650310000	20255	10202	1	0	2345
154716	2134	96218681000	20255	10202	2	0	2773
154722	1397	1319528087000	20258	10203	0	0	11930
154723	1397	1319518086000	20258	10203	1	0	11931
154724	2132	148215216000	20258	10203	2	0	784
154726	2134	96216675000	20258	10203	4	0	2775
154727	2133	96649308000	20258	10203	5	0	2346
154728	2133	96648306000	20258	10203	6	0	2347
154729	1397	1319508085000	20259	10204	0	0	11932
154730	2134	96215672000	20259	10204	1	0	2776
154732	1397	1319498084000	20260	10205	0	0	11933
154733	2134	96214669000	20260	10205	1	0	2777
154734	2132	148214215000	20260	10205	2	0	785
154754	1397	1319488083000	20265	10206	0	0	11934
154756	2133	96646302000	20265	10206	2	0	2349
154757	2133	96645300000	20265	10206	3	0	2350
154758	2133	96644298000	20265	10206	4	0	2351
154759	2134	96213666000	20265	10206	5	0	2778
154760	2134	96212663000	20265	10206	6	0	2779
154762	2132	148213214000	20266	10207	1	0	786
154763	2133	96643296000	20266	10207	2	0	2352
154769	2133	96642294000	20268	10208	2	0	\N
154778	1397	1319448079000	20271	10209	0	0	\N
154779	2134	96210657000	20271	10209	1	0	\N
154780	2134	96209654000	20271	10209	2	0	\N
154781	1397	1319448079000	20272	10209	0	0	\N
154782	2133	96641292000	20272	10209	1	0	\N
154783	2134	96210657000	20272	10209	2	0	\N
154784	2133	96640290000	20272	10209	3	0	\N
154785	2134	96209654000	20272	10209	4	0	\N
154786	1397	1319438078000	20273	10210	0	0	\N
154787	1397	1319428077000	20273	10210	1	0	\N
154788	2132	148212213000	20273	10210	2	0	\N
154789	2133	96639288000	20273	10210	3	0	\N
154790	2133	96638286000	20273	10210	4	0	\N
154791	2134	96208651000	20273	10210	5	0	\N
154792	2134	96207648000	20273	10210	6	0	\N
154813	1397	1319398074000	20277	10212	0	0	\N
154814	1397	1319388073000	20277	10212	1	0	\N
154815	2134	96204639000	20277	10212	2	0	\N
154816	2134	96203636000	20277	10212	3	0	\N
154817	2133	96635280000	20277	10212	4	0	\N
154818	2133	96634278000	20277	10212	5	0	\N
154819	1882	719910000000	20278	9953	0	0	\N
154820	1895	1439936000000	20278	9953	1	0	\N
154821	1650	10624110000000	20278	9953	2	0	\N
154822	1650	7667000000000	20278	9953	3	0	\N
154823	1650	5671890000000	20278	9953	4	0	\N
154824	1650	112780000000	20278	9953	5	0	\N
154825	2137	900000000	20278	9953	6	0	\N
154826	1455	10978017000000	20278	9953	7	0	\N
154827	623	66719940000000	20278	9953	8	0	\N
154828	2137	100000000	20278	9953	9	0	\N
154829	2138	900000000	20278	9953	10	0	\N
154830	2138	0	20278	9953	11	0	\N
154831	1670	11906159000000	20278	9953	12	0	\N
154832	1670	6749059000000	20278	9953	13	0	\N
154833	1670	3268959000000	20278	9953	14	0	\N
154834	1670	390859000000	20278	9953	15	0	\N
154835	1695	9742230999000	20278	9953	16	0	\N
154836	1695	7434130999000	20278	9953	17	0	\N
154837	1695	4014030999000	20278	9953	18	0	\N
154838	1695	2104930999000	20278	9953	19	0	\N
154839	1455	9492917000000	20278	9953	20	0	\N
154840	1455	6831817000000	20278	9953	21	0	\N
154841	1455	5035717000000	20278	9953	22	0	\N
154842	1455	31617000000	20278	9953	23	0	\N
154843	1423	3984936826911	20278	9953	24	0	\N
154844	1423	3616573653837	20278	9953	25	0	\N
154845	1423	3248210480763	20278	9953	26	0	\N
154846	1423	2879847307689	20278	9953	27	0	\N
154847	1423	2511484134615	20278	9953	28	0	\N
154848	1423	2143120961541	20278	9953	29	0	\N
154849	1423	1774757788467	20278	9953	30	0	\N
154850	1423	1406394615393	20278	9953	31	0	\N
154851	1423	1038031442319	20278	9953	32	0	\N
154852	1423	669668269245	20278	9953	33	0	\N
154853	1423	301305096171	20278	9953	34	0	\N
154854	1981	100880000000	20278	9953	35	0	\N
154855	632	73255261000000	20278	9953	36	0	\N
154856	632	71294241000000	20278	9953	37	0	\N
154857	632	69971221000000	20278	9953	38	0	\N
154858	632	68877201000000	20278	9953	39	0	\N
154859	1587	15469565000000	20278	9953	40	0	\N
154860	1643	2262511437200	20278	9953	41	0	\N
154861	1594	16082303000000	20278	9953	42	0	\N
154862	1671	10569939634395	20278	9953	43	0	\N
154863	1397	1322928427000	20278	9953	44	0	\N
154864	1439	11549840548477	20278	9953	45	0	\N
154865	2142	2849991000000	20278	9953	46	0	\N
154866	1675	15194313999977	20278	9953	47	0	\N
154867	353	66000000000000	20278	9953	48	0	\N
154868	2112	5077984563820	20278	9953	49	0	\N
154869	1710	19819405209850	20278	9953	50	0	\N
154870	1710	14917550910810	20278	9953	51	0	\N
154871	1710	11610168886100	20278	9953	52	0	\N
154872	1610	16887582889950	20278	9953	53	0	\N
154873	1610	12312518189950	20278	9953	54	0	\N
154874	1536	8467735999959	20278	9953	55	0	\N
154875	1536	4546245999959	20278	9953	56	0	\N
154876	1668	16428284000000	20278	9953	57	0	\N
154877	1711	18851854000000	20278	9953	58	0	\N
154878	1711	15764344000000	20278	9953	59	0	\N
154879	1710	2393872664140	20278	9953	60	0	\N
154880	1397	1322918426000	20278	9953	61	0	\N
154881	1700	12595641400429	20278	9953	62	0	\N
154882	1700	9512837655741	20278	9953	63	0	\N
154883	1700	4943830025733	20278	9953	64	0	\N
154884	1700	2394143979053	20278	9953	65	0	\N
154885	1671	6975243815095	20278	9953	66	0	\N
154886	1671	4549827663645	20278	9953	67	0	\N
154887	1587	9527915000000	20278	9953	68	0	\N
154888	1587	5518965000000	20278	9953	69	0	\N
154889	1587	2203285000000	20278	9953	70	0	\N
154890	1587	1768025000000	20278	9953	71	0	\N
154891	1587	1332765000000	20278	9953	72	0	\N
154892	1587	0	20278	9953	74	0	\N
154893	1711	11188834000000	20278	9953	75	0	\N
154894	1594	8402053000000	20278	9953	76	0	\N
154895	606	79675027812962	20278	9953	77	0	\N
154896	606	78675017812962	20278	9953	78	0	\N
154897	606	71915397916843	20278	9953	79	0	\N
154898	1675	11202303999977	20278	9953	80	0	\N
154899	1675	8508293999977	20278	9953	81	0	\N
154900	1675	1003283999977	20278	9953	82	0	\N
154901	1476	10838451000000	20278	9953	83	0	\N
154902	1610	9225627609950	20278	9953	84	0	\N
154903	1610	623750449950	20278	9953	85	0	\N
154904	271	66411407920446	20278	9953	86	0	\N
154772	2133	96642294000	20269	10208	2	0	2353
154773	1397	1319448079000	20270	10209	0	0	11938
154774	2133	96641292000	20270	10209	1	0	2354
154775	2134	96210657000	20270	10209	2	0	2781
154776	2133	96640290000	20270	10209	3	0	2355
154793	1397	1319438078000	20274	10210	0	0	11939
154794	1397	1319428077000	20274	10210	1	0	11940
154795	2132	148212213000	20274	10210	2	0	787
154796	2133	96639288000	20274	10210	3	0	2356
154797	2133	96638286000	20274	10210	4	0	2357
154799	2134	96207648000	20274	10210	6	0	2784
154800	1397	1319418076000	20275	10211	0	0	11941
154801	1397	1319408075000	20275	10211	1	0	11942
154802	2134	96206645000	20275	10211	2	0	2785
154804	2133	96637284000	20275	10211	4	0	2358
154805	2133	96636282000	20275	10211	5	0	2359
154806	2134	96205642000	20275	10211	6	0	2786
154807	1397	1319398074000	20276	10212	0	0	11943
154808	1397	1319388073000	20276	10212	1	0	11944
154810	2134	96203636000	20276	10212	3	0	2788
154811	2133	96635280000	20276	10212	4	0	2360
154812	2133	96634278000	20276	10212	5	0	2361
154905	1607	3707521150625	20278	9953	87	0	\N
154906	1668	13446953000000	20278	9953	88	0	\N
154907	1668	5139227000000	20278	9953	89	0	\N
154908	1668	2673466000000	20278	9953	90	0	\N
154909	2112	3323654080099	20278	9953	91	0	\N
154910	2112	3083656709501	20278	9953	92	0	\N
154911	2112	2843659338903	20278	9953	93	0	\N
154912	2112	2603661968305	20278	9953	94	0	\N
154913	2112	0	20278	9953	95	0	\N
154914	1607	563783874815	20278	9953	96	0	\N
154915	1607	323786504217	20278	9953	97	0	\N
154916	1571	3839779792276	20278	9953	98	0	\N
154917	1571	3475047490484	20278	9953	99	0	\N
154918	1643	1763586477100	20278	9953	100	0	\N
154919	1643	1426948612000	20278	9953	101	0	\N
154920	1643	1148524914700	20278	9953	102	0	\N
154921	606	68319702097546	20278	9953	103	0	\N
154922	1536	1900335999959	20278	9953	104	0	\N
154923	1571	2821458250612	20278	9953	105	0	\N
154924	1571	2380465313984	20278	9953	106	0	\N
154925	1684	24409822847948	20278	9953	107	0	\N
154926	1684	24200387059336	20278	9953	108	0	\N
154927	1684	23990951270724	20278	9953	109	0	\N
154928	1684	23781515482112	20278	9953	110	0	\N
154929	1985	2299990000000	20278	9953	111	0	\N
154930	1594	5645893000000	20278	9953	112	0	\N
154931	1594	1561003000000	20278	9953	113	0	\N
154932	1671	2543845003785	20278	9953	114	0	\N
154933	1684	23572079693500	20278	9953	115	0	\N
154934	1684	23362643904888	20278	9953	116	0	\N
154935	1684	23153208116276	20278	9953	117	0	\N
154936	1684	22943772327664	20278	9953	118	0	\N
154937	1684	22734336539052	20278	9953	119	0	\N
154938	1684	22524900750440	20278	9953	120	0	\N
154939	1684	22315464961828	20278	9953	121	0	\N
154940	1684	22106029173216	20278	9953	122	0	\N
154941	1684	21896593384604	20278	9953	123	0	\N
154942	1684	21687157595992	20278	9953	124	0	\N
154943	1684	21477721807380	20278	9953	125	0	\N
154944	1397	1319378072000	20279	10213	0	0	\N
154945	2134	96202633000	20279	10213	1	0	\N
154946	2133	96633276000	20279	10213	2	0	\N
154947	2132	148210211000	20279	10213	3	0	\N
154948	1397	1319378072000	20280	10213	0	0	\N
154949	2134	96202633000	20280	10213	1	0	\N
154950	2133	96633276000	20280	10213	2	0	\N
154951	2132	148210211000	20280	10213	3	0	\N
154959	1397	1319378072000	20283	10214	0	0	\N
154960	1397	1319368071000	20283	10214	1	0	\N
154961	2134	96202633000	20283	10214	2	0	\N
154962	2134	96201630000	20283	10214	3	0	\N
154963	2133	96633276000	20283	10214	4	0	\N
154964	2133	96632274000	20283	10214	5	0	\N
154965	1397	1319358070000	20284	10215	0	0	\N
154966	1397	1319348069000	20284	10215	1	0	\N
154967	2133	96631272000	20284	10215	2	0	\N
154968	2133	96630270000	20284	10215	4	0	\N
154969	2134	96200627000	20284	10215	5	0	\N
154970	2134	96199624000	20284	10215	6	0	\N
154977	1397	1319358070000	20286	10215	0	0	\N
154978	1397	1319348069000	20286	10215	1	0	\N
154979	2133	96631272000	20286	10215	2	0	\N
154980	2133	96630270000	20286	10215	4	0	\N
154981	2134	96200627000	20286	10215	5	0	\N
154982	2134	96199624000	20286	10215	6	0	\N
154983	1397	1319338068000	20287	10216	0	0	\N
154984	1397	1319328067000	20287	10216	1	0	\N
154985	2134	96198621000	20287	10216	2	0	\N
154986	2134	96197618000	20287	10216	3	0	\N
154987	2132	148209210000	20287	10216	4	0	\N
154988	1397	1319338068000	20288	10216	0	0	\N
154989	1397	1319328067000	20288	10216	1	0	\N
154990	2133	96629268000	20288	10216	2	0	\N
154991	2134	96198621000	20288	10216	3	0	\N
154992	2134	96197618000	20288	10216	4	0	\N
154993	2133	96628266000	20288	10216	5	0	\N
154994	2132	148209210000	20288	10216	6	0	\N
154995	1397	1319338068000	20289	10216	0	0	\N
154996	1397	1319328067000	20289	10216	1	0	\N
154997	2133	96629268000	20289	10216	2	0	\N
154998	2134	96198621000	20289	10216	3	0	\N
154999	2134	96197618000	20289	10216	4	0	\N
155000	2133	96628266000	20289	10216	5	0	\N
155001	2132	148209210000	20289	10216	6	0	\N
155009	1397	1319338068000	20291	10216	0	0	\N
155010	1397	1319328067000	20291	10216	1	0	\N
155011	2133	96629268000	20291	10216	2	0	\N
155012	2134	96198621000	20291	10216	3	0	\N
155013	2134	96197618000	20291	10216	4	0	\N
155014	2133	96628266000	20291	10216	5	0	\N
155015	2132	148209210000	20291	10216	6	0	\N
155016	1397	1319338068000	20292	10216	0	0	\N
155017	1397	1319328067000	20292	10216	1	0	\N
155018	2133	96629268000	20292	10216	2	0	\N
155019	2134	96198621000	20292	10216	3	0	\N
155020	2134	96197618000	20292	10216	4	0	\N
155021	2133	96628266000	20292	10216	5	0	\N
155022	2132	148209210000	20292	10216	6	0	\N
155023	1397	1319338068000	20293	10216	0	0	\N
155024	1397	1319328067000	20293	10216	1	0	\N
155025	2133	96629268000	20293	10216	2	0	\N
155026	2134	96198621000	20293	10216	3	0	\N
155027	2134	96197618000	20293	10216	4	0	\N
155028	2133	96628266000	20293	10216	5	0	\N
155029	2132	148209210000	20293	10216	6	0	\N
155030	1397	1319318066000	20294	10217	0	0	\N
155031	2133	96627264000	20294	10217	1	0	\N
155032	2134	96196615000	20294	10217	2	0	\N
154954	1397	1319368071000	20282	10214	1	0	11946
154955	2134	96202633000	20282	10214	2	0	2789
154956	2134	96201630000	20282	10214	3	0	2790
154957	2133	96633276000	20282	10214	4	0	2362
154958	2133	96632274000	20282	10214	5	0	2363
154972	1397	1319348069000	20285	10215	1	0	11948
154973	2133	96631272000	20285	10215	2	0	2364
154974	2133	96630270000	20285	10215	4	0	2365
154975	2134	96200627000	20285	10215	5	0	2791
154976	2134	96199624000	20285	10215	6	0	2792
155003	1397	1319328067000	20290	10216	1	0	11950
155004	2133	96629268000	20290	10216	2	0	2366
155005	2134	96198621000	20290	10216	3	0	2793
155006	2134	96197618000	20290	10216	4	0	2794
155008	2132	148209210000	20290	10216	6	0	790
155033	1397	1319318066000	20295	10217	0	0	11951
155034	2133	96627264000	20295	10217	1	0	2368
155035	2134	96196615000	20295	10217	2	0	2795
155036	1397	1319308065000	20296	10218	0	0	11952
155038	1397	1319288063000	20296	10218	2	0	11954
155039	2134	96195612000	20296	10218	3	0	2796
155040	2133	96626262000	20296	10218	4	0	2369
155052	1397	1319258060000	20298	10220	0	0	\N
155053	2134	96191600000	20298	10220	1	0	\N
155054	2133	96621252000	20298	10220	2	0	\N
155071	1397	1319218056000	20303	10223	0	0	\N
155072	2134	96187588000	20303	10223	1	0	\N
155073	2133	96617244000	20303	10223	2	0	\N
155088	1397	1319168051000	20307	10227	0	0	\N
155089	2133	96612234000	20307	10227	1	0	\N
155090	2134	96182573000	20307	10227	2	0	\N
155107	1397	1319128047000	20312	10230	0	0	\N
155108	2133	96608226000	20312	10230	1	0	\N
155109	2134	96178561000	20312	10230	2	0	\N
155110	1397	1319128047000	20313	10230	0	0	\N
155111	2134	96178561000	20313	10230	1	0	\N
155115	1397	1319108045000	20315	10232	0	0	\N
155116	2134	96176555000	20315	10232	1	0	\N
155117	2132	148202203000	20315	10232	2	0	\N
155118	2133	96606222000	20315	10232	3	0	\N
155121	1397	1319108045000	20317	10232	0	0	\N
155122	2134	96176555000	20317	10232	1	0	\N
155123	2132	148202203000	20317	10232	2	0	\N
155124	2133	96606222000	20317	10232	3	0	\N
155133	1397	1319108045000	20319	10233	0	0	\N
155134	1397	1319098044000	20319	10233	1	0	\N
155135	1397	1319088043000	20319	10233	2	0	\N
155136	1397	1319078042000	20319	10233	3	0	\N
155137	2133	96606222000	20319	10233	4	0	\N
155138	2133	96605220000	20319	10233	5	0	\N
155139	2133	96604218000	20319	10233	6	0	\N
155140	2133	96603216000	20319	10233	7	0	\N
155141	2132	148201202000	20319	10233	8	0	\N
155142	2134	96175552000	20319	10233	9	0	\N
155143	2134	96174549000	20319	10233	10	0	\N
155144	2134	96173546000	20319	10233	12	0	\N
155163	1397	1319038038000	20322	10236	0	0	\N
155164	2134	96169534000	20322	10236	1	0	\N
155165	2132	148200201000	20322	10236	2	0	\N
155166	2133	96599208000	20322	10236	3	0	\N
155167	1397	1319038038000	20323	10236	0	0	\N
155168	2134	96169534000	20323	10236	1	0	\N
155169	2132	148200201000	20323	10236	2	0	\N
155170	2133	96599208000	20323	10236	3	0	\N
155171	1397	1319038038000	20324	10236	0	0	\N
155172	2134	96169534000	20324	10236	1	0	\N
155173	2132	148200201000	20324	10236	2	0	\N
155174	2133	96599208000	20324	10236	3	0	\N
155175	1397	1319038038000	20325	10236	0	0	\N
155176	2134	96169534000	20325	10236	1	0	\N
155043	2134	96194609000	20296	10218	7	0	2797
155044	2132	148208209000	20296	10218	8	0	791
155045	1397	1319278062000	20297	10219	0	0	11955
155046	1397	1319268061000	20297	10219	1	0	11956
155047	2134	96193606000	20297	10219	2	0	2798
155049	2133	96622254000	20297	10219	4	0	2373
155050	2134	96192603000	20297	10219	5	0	2799
155051	2132	148207208000	20297	10219	6	0	792
155055	1397	1319258060000	20299	10220	0	0	11957
155056	2134	96191600000	20299	10220	1	0	2800
155058	1397	1319248059000	20300	10221	0	0	11958
155059	1397	1319238058000	20300	10221	1	0	11959
155060	2134	96190597000	20300	10221	2	0	2801
155061	2133	96620250000	20300	10221	3	0	2375
155063	2134	96189594000	20300	10221	5	0	2802
155064	2132	148206207000	20300	10221	6	0	793
155065	1397	1319228057000	20301	10222	0	0	11960
155066	2134	96188591000	20301	10222	1	0	2803
155067	2133	96618246000	20301	10222	2	0	2377
155069	2134	96187588000	20302	10223	1	0	2804
155070	2133	96617244000	20302	10223	2	0	2378
155074	1397	1319208055000	20304	10224	0	0	11962
155075	2134	96186585000	20304	10224	1	0	2805
155076	2132	148205206000	20304	10224	2	0	794
155078	1397	1319198054000	20305	10225	0	0	11963
155079	2133	96615240000	20305	10225	1	0	2380
155080	2134	96185582000	20305	10225	2	0	2806
155081	1397	1319188053000	20306	10226	0	0	11964
155083	2134	96184579000	20306	10226	2	0	2807
155084	2132	148204205000	20306	10226	3	0	795
155085	2133	96614238000	20306	10226	4	0	2381
155086	2133	96613236000	20306	10226	5	0	2382
155087	2134	96183576000	20306	10226	6	0	2808
155092	2133	96612234000	20308	10227	1	0	2383
155093	2134	96182573000	20308	10227	2	0	2809
155094	1397	1319158050000	20309	10228	0	0	11967
155095	2134	96181570000	20309	10228	1	0	2810
155096	2133	96611232000	20309	10228	2	0	2384
155098	1397	1319138048000	20310	10229	1	0	11969
155099	2132	148203204000	20310	10229	2	0	796
155100	2134	96180567000	20310	10229	3	0	2811
155101	2134	96179564000	20310	10229	4	0	2812
155103	2133	96609228000	20310	10229	6	0	2386
155104	1397	1319128047000	20311	10230	0	0	11970
155105	2133	96608226000	20311	10230	1	0	2387
155106	2134	96178561000	20311	10230	2	0	2813
155112	1397	1319118046000	20314	10231	0	0	11971
155114	2133	96607224000	20314	10231	2	0	2388
155119	2134	96176555000	20316	10232	0	0	2815
155120	2132	148202203000	20316	10232	1	0	797
155125	1397	1319108045000	20318	10233	0	0	11972
155126	1397	1319098044000	20318	10233	1	0	11973
155128	1397	1319078042000	20318	10233	3	0	11975
155129	2132	148201202000	20318	10233	4	0	798
155130	2134	96175552000	20318	10233	5	0	2816
155131	2134	96174549000	20318	10233	6	0	2817
155145	1397	1319068041000	20320	10234	0	0	11976
155146	1681	18947743296868	20320	10234	2	0	7
155147	2134	96172543000	20320	10234	3	0	2819
155148	2133	96606222000	20320	10234	4	0	2389
155149	2133	96605220000	20320	10234	5	0	2390
155151	2133	96603216000	20320	10234	7	0	2392
155152	2133	96602214000	20320	10234	8	0	2393
155153	1681	16850589061564	20320	10234	9	0	8
155154	1681	13092507432300	20320	10234	10	0	9
155155	1681	10556854546689	20320	10234	11	0	10
155157	1397	1319058040000	20321	10235	0	0	11977
155158	1397	1319048039000	20321	10235	1	0	11978
155159	2134	96171540000	20321	10235	2	0	2820
155160	2134	96170537000	20321	10235	3	0	2821
155162	2133	96600210000	20321	10235	5	0	2395
155177	2132	148200201000	20325	10236	2	0	\N
155178	2133	96599208000	20325	10236	3	0	\N
155188	1397	1319028037000	20328	10237	0	0	\N
155189	1397	1319018036000	20328	10237	1	0	\N
155190	2133	96598206000	20328	10237	2	0	\N
155191	2134	96168531000	20328	10237	3	0	\N
155192	2133	96597204000	20328	10237	4	0	\N
155193	606	74795607916843	20329	10185	0	0	\N
155194	1710	19819405209850	20329	10185	1	0	\N
155195	1710	14917550910810	20329	10185	2	0	\N
155196	1710	11610168886100	20329	10185	3	0	\N
155197	1397	1319798114000	20329	10185	4	0	\N
155198	1710	2393872664140	20329	10185	5	0	\N
155199	1397	1319788113000	20329	10185	6	0	\N
155200	1397	1319778112000	20329	10185	7	0	\N
155201	606	71199912097546	20329	10185	8	0	\N
155202	606	68773495946091	20329	10185	9	0	\N
155203	606	66766513286230	20329	10185	10	0	\N
155204	1397	1319768111000	20329	10185	11	0	\N
155205	1397	1319758110000	20329	10185	12	0	\N
155206	1397	1319748109000	20329	10185	13	0	\N
155207	1397	1319738108000	20329	10185	14	0	\N
155208	1397	1319728107000	20329	10185	15	0	\N
155209	1397	1319718106000	20329	10185	16	0	\N
155210	1397	1319708105000	20329	10185	17	0	\N
155211	1397	1319698104000	20329	10185	18	0	\N
155212	1397	1319688103000	20329	10185	19	0	\N
155213	1397	1319678102000	20329	10185	20	0	\N
155214	1397	1319668101000	20329	10185	21	0	\N
155215	1397	1319658100000	20329	10185	22	0	\N
155216	1397	1319648099000	20329	10185	23	0	\N
155217	1397	1319638098000	20329	10185	24	0	\N
155218	1397	1319628097000	20329	10185	25	0	\N
155219	1397	1319618096000	20329	10185	26	0	\N
155220	1397	1319608095000	20329	10185	27	0	\N
155221	1397	1319598094000	20329	10185	28	0	\N
155222	1397	1319588093000	20329	10185	29	0	\N
155223	1397	1319578092000	20329	10185	30	0	\N
155224	1397	1319568091000	20329	10185	31	0	\N
155225	1397	1319558090000	20329	10185	32	0	\N
155226	1397	1319548089000	20329	10185	33	0	\N
155227	1397	1319538088000	20329	10185	34	0	\N
155228	1397	1319528087000	20329	10185	35	0	\N
155229	1397	1319518086000	20329	10185	36	0	\N
155230	1397	1319508085000	20329	10185	37	0	\N
155231	1397	1319498084000	20329	10185	38	0	\N
155232	1397	1319488083000	20329	10185	39	0	\N
155233	1397	1319478082000	20329	10185	40	0	\N
155234	1397	1319468081000	20329	10185	41	0	\N
155235	1397	1319458080000	20329	10185	42	0	\N
155236	1397	1319448079000	20329	10185	43	0	\N
155237	1397	1319438078000	20329	10185	44	0	\N
155238	1397	1319428077000	20329	10185	45	0	\N
155239	1397	1319418076000	20329	10185	46	0	\N
155240	1397	1319408075000	20329	10185	47	0	\N
155241	1397	1319398074000	20329	10185	48	0	\N
155242	1397	1319388073000	20329	10185	49	0	\N
155243	1397	1319378072000	20329	10185	50	0	\N
155244	1397	1319368071000	20329	10185	51	0	\N
155245	1397	1319358070000	20329	10185	52	0	\N
155246	1397	1319348069000	20329	10185	53	0	\N
155247	1397	1319338068000	20329	10185	54	0	\N
155248	1397	1319328067000	20329	10185	55	0	\N
155249	1397	1319318066000	20329	10185	56	0	\N
155250	1397	1319308065000	20329	10185	57	0	\N
155251	1397	1319298064000	20329	10185	58	0	\N
155252	1397	1319288063000	20329	10185	59	0	\N
155253	1397	1319278062000	20329	10185	60	0	\N
155254	1397	1319268061000	20329	10185	61	0	\N
155255	1397	1319258060000	20329	10185	62	0	\N
155256	1397	1319248059000	20329	10185	63	0	\N
155257	1397	1319238058000	20329	10185	64	0	\N
155258	1397	1319228057000	20329	10185	65	0	\N
155259	1397	1319218056000	20329	10185	66	0	\N
155260	1397	1319208055000	20329	10185	67	0	\N
155261	1397	1319198054000	20329	10185	68	0	\N
155262	1397	1319188053000	20329	10185	69	0	\N
155263	1397	1319178052000	20329	10185	70	0	\N
155264	1397	1319168051000	20329	10185	71	0	\N
155265	1397	1319158050000	20329	10185	72	0	\N
155266	1397	1319148049000	20329	10185	73	0	\N
155267	1397	1319138048000	20329	10185	74	0	\N
155268	1397	1319128047000	20329	10185	75	0	\N
155269	1397	1319118046000	20329	10185	76	0	\N
155270	1397	1319108045000	20329	10185	77	0	\N
155271	1397	1319098044000	20329	10185	78	0	\N
155272	1397	1319088043000	20329	10185	79	0	\N
155273	1397	1319078042000	20329	10185	80	0	\N
155274	1397	1319068041000	20329	10185	81	0	\N
155275	1397	1319058040000	20329	10185	82	0	\N
155276	1397	1319048039000	20329	10185	83	0	\N
155277	1397	1319038038000	20329	10185	84	0	\N
155278	1397	1319028037000	20329	10185	85	0	\N
155279	1397	1319018036000	20329	10185	86	0	\N
155280	1681	17507697296868	20329	10185	87	0	\N
155281	2134	96243756000	20329	10185	88	0	\N
155282	2134	96242753000	20329	10185	89	0	\N
155283	2134	96241750000	20329	10185	91	0	\N
155284	2134	96240747000	20329	10185	92	0	\N
155285	2134	96239744000	20329	10185	93	0	\N
155286	2134	96238741000	20329	10185	94	0	\N
155287	2133	96676362000	20329	10185	95	0	\N
155288	2133	96675360000	20329	10185	96	0	\N
155289	2133	96674358000	20329	10185	97	0	\N
155290	2133	96673356000	20329	10185	98	0	\N
155291	2133	96672354000	20329	10185	99	0	\N
155292	2133	96671352000	20329	10185	100	0	\N
155293	2133	96670350000	20329	10185	101	0	\N
155294	2132	148223224000	20329	10185	102	0	\N
155295	2132	148222223000	20329	10185	103	0	\N
155296	2132	148221222000	20329	10185	104	0	\N
155297	2132	148220221000	20329	10185	105	0	\N
155298	2132	148219220000	20329	10185	106	0	\N
155299	2132	148218219000	20329	10185	107	0	\N
155300	1681	15410543061564	20329	10185	108	0	\N
155301	1681	11652461432300	20329	10185	109	0	\N
155302	1681	9116808546689	20329	10185	110	0	\N
155303	1681	2050988109853	20329	10185	111	0	\N
155304	2133	96669348000	20329	10185	112	0	\N
155305	2133	96668346000	20329	10185	113	0	\N
155306	2133	96667344000	20329	10185	114	0	\N
155307	2133	96666342000	20329	10185	115	0	\N
155308	2133	96665340000	20329	10185	116	0	\N
155309	2133	96664338000	20329	10185	117	0	\N
155310	2133	96663336000	20329	10185	118	0	\N
155311	2133	96662334000	20329	10185	119	0	\N
155312	2133	96661332000	20329	10185	120	0	\N
155181	2132	148200201000	20326	10236	2	0	799
155182	2133	96599208000	20326	10236	3	0	2396
155183	1397	1319028037000	20327	10237	0	0	11980
155184	1397	1319018036000	20327	10237	1	0	11981
155185	2133	96598206000	20327	10237	2	0	2397
155187	2133	96597204000	20327	10237	4	0	2398
155313	2133	96660330000	20329	10185	121	0	\N
155314	2133	96659328000	20329	10185	122	0	\N
155315	2133	96658326000	20329	10185	123	0	\N
155316	2133	96657324000	20329	10185	124	0	\N
155317	2133	96656322000	20329	10185	125	0	\N
155318	1397	1319008035000	20330	10238	0	0	\N
155319	2133	96596202000	20330	10238	1	0	\N
155320	2134	96167528000	20330	10238	2	0	\N
155321	2132	148199200000	20330	10238	3	0	\N
155345	1397	1318958030000	20336	10242	0	0	\N
155346	1397	1318948029000	20336	10242	1	0	\N
155347	2133	96591192000	20336	10242	2	0	\N
155348	2134	96162513000	20336	10242	3	0	\N
155349	2133	96590190000	20336	10242	4	0	\N
155350	2134	96161510000	20336	10242	5	0	\N
155355	1397	1318928027000	20338	10244	0	0	\N
155356	2134	96159504000	20338	10244	1	0	\N
155357	2133	96588186000	20338	10244	2	0	\N
155358	369	86101373736560	20338	10244	3	0	\N
155359	369	81199528437520	20338	10244	4	0	\N
155360	369	77892155412810	20338	10244	5	0	\N
155367	1397	1318928027000	20340	10244	0	0	\N
155368	2134	96159504000	20340	10244	1	0	\N
155369	2133	96588186000	20340	10244	2	0	\N
155370	369	86101373736560	20340	10244	3	0	\N
155371	369	81199528437520	20340	10244	4	0	\N
155372	369	77892155412810	20340	10244	5	0	\N
155373	1397	1319028037000	20341	10237	0	0	\N
155374	1397	1319018036000	20341	10237	1	0	\N
155375	1397	1319008035000	20341	10237	2	0	\N
155376	1397	1318998034000	20341	10237	3	0	\N
155377	1397	1318988033000	20341	10237	4	0	\N
155378	1397	1318978032000	20341	10237	5	0	\N
155379	1397	1318968031000	20341	10237	6	0	\N
155380	1397	1318958030000	20341	10237	7	0	\N
155381	1397	1318948029000	20341	10237	8	0	\N
155382	1397	1318938028000	20341	10237	9	0	\N
155383	1397	1318928027000	20341	10237	10	0	\N
155384	2133	96598206000	20341	10237	11	0	\N
155385	2134	96168531000	20341	10237	12	0	\N
155386	2133	96597204000	20341	10237	13	0	\N
155387	2133	96596202000	20341	10237	14	0	\N
155388	2133	96595200000	20341	10237	15	0	\N
155389	2133	96594198000	20341	10237	16	0	\N
155390	2133	96593196000	20341	10237	17	0	\N
155391	2133	96592194000	20341	10237	18	0	\N
155392	2133	96591192000	20341	10237	19	0	\N
155393	2133	96590190000	20341	10237	20	0	\N
155394	2133	96589188000	20341	10237	21	0	\N
155395	2133	96588186000	20341	10237	22	0	\N
155396	2134	96167528000	20341	10237	23	0	\N
155397	2132	148199200000	20341	10237	24	0	\N
155398	2132	148198199000	20341	10237	25	0	\N
155399	2132	148197198000	20341	10237	26	0	\N
155400	369	86101373736560	20341	10237	27	0	\N
155401	369	81199528437520	20341	10237	28	0	\N
155402	369	77892155412810	20341	10237	29	0	\N
155403	2134	96166525000	20341	10237	30	0	\N
155404	2134	96165522000	20341	10237	31	0	\N
155405	2134	96164519000	20341	10237	32	0	\N
155406	2134	96163516000	20341	10237	33	0	\N
155407	2134	96162513000	20341	10237	34	0	\N
155408	2134	96161510000	20341	10237	35	0	\N
155409	2134	96160507000	20341	10237	36	0	\N
155410	2134	96159504000	20341	10237	37	0	\N
155411	1397	1318918026000	20342	10245	0	0	\N
155412	1397	1318908025000	20342	10245	1	0	\N
155413	2134	96158501000	20342	10245	2	0	\N
155414	2133	96587184000	20342	10245	3	0	\N
155415	2133	96586182000	20342	10245	4	0	\N
155427	1397	1318878022000	20345	10247	0	0	\N
155428	2134	96155492000	20345	10247	1	0	\N
155429	2133	96583176000	20345	10247	2	0	\N
155445	1397	1318828017000	20349	10250	0	0	\N
155446	2133	96578166000	20349	10250	1	0	\N
155447	2134	96150477000	20349	10250	2	0	\N
155324	2134	96167528000	20331	10238	2	0	2824
155325	2132	148199200000	20331	10238	3	0	800
155326	1397	1318998034000	20332	10239	0	0	11983
155327	2133	96595200000	20332	10239	1	0	2400
155328	2134	96166525000	20332	10239	2	0	2825
155330	2134	96165522000	20333	10240	1	0	2826
155331	2133	96594198000	20333	10240	2	0	2401
155332	1397	1318978032000	20334	10241	0	0	11985
155333	1397	1318968031000	20334	10241	1	0	11986
155334	2132	148198199000	20334	10241	2	0	801
155336	2133	96592194000	20334	10241	4	0	2403
155337	2134	96164519000	20334	10241	5	0	2827
155338	2134	96163516000	20334	10241	6	0	2828
155339	1397	1318958030000	20335	10242	0	0	11987
155341	2133	96591192000	20335	10242	2	0	2404
155342	2134	96162513000	20335	10242	3	0	2829
155343	2133	96590190000	20335	10242	4	0	2405
155344	2134	96161510000	20335	10242	5	0	2830
155351	1397	1318938028000	20337	10243	0	0	11989
155353	2134	96160507000	20337	10243	2	0	2831
155354	2132	148197198000	20337	10243	3	0	802
155361	1397	1318928027000	20339	10244	0	0	11990
155362	2134	96159504000	20339	10244	1	0	2832
155363	2133	96588186000	20339	10244	2	0	2407
155365	369	81199528437520	20339	10244	4	0	14
155366	369	77892155412810	20339	10244	5	0	15
155416	1397	1318918026000	20343	10245	0	0	11991
155417	1397	1318908025000	20343	10245	1	0	11992
155419	2133	96587184000	20343	10245	3	0	2408
155420	2133	96586182000	20343	10245	4	0	2409
155421	1397	1318898024000	20344	10246	0	0	11993
155422	1397	1318888023000	20344	10246	1	0	11994
155423	2134	96157498000	20344	10246	2	0	2834
155425	2133	96584178000	20344	10246	4	0	2411
155426	2134	96156495000	20344	10246	5	0	2835
155430	1397	1318878022000	20346	10247	0	0	11995
155431	2134	96155492000	20346	10247	1	0	2836
155432	2133	96583176000	20346	10247	2	0	2412
155434	1397	1318858020000	20347	10248	1	0	11997
155435	1397	1318848019000	20347	10248	2	0	11998
155436	2133	96582174000	20347	10248	3	0	2413
155437	2134	96154489000	20347	10248	4	0	2837
155439	2134	96152483000	20347	10248	6	0	2839
155440	2133	96581172000	20347	10248	7	0	2414
155441	2133	96580170000	20347	10248	8	0	2415
155442	1397	1318838018000	20348	10249	0	0	11999
155443	2134	96151480000	20348	10249	1	0	2840
155448	1397	1318828017000	20350	10250	0	0	12000
155451	1397	1318828017000	20351	10250	0	0	\N
155452	2133	96578166000	20351	10250	1	0	\N
155453	2134	96150477000	20351	10250	2	0	\N
155454	1397	1318828017000	20352	10250	0	0	\N
155455	2133	96578166000	20352	10250	1	0	\N
155456	2134	96150477000	20352	10250	2	0	\N
155457	1397	1318828017000	20353	10250	0	0	\N
155458	2133	96578166000	20353	10250	1	0	\N
155459	2134	96150477000	20353	10250	2	0	\N
155465	1397	1318808015000	20356	10252	0	0	\N
155466	2133	96576162000	20356	10252	2	0	\N
155467	2134	96149474000	20356	10252	3	0	\N
155477	1397	1318918026000	20359	10245	0	0	\N
155478	1397	1318908025000	20359	10245	1	0	\N
155479	1397	1318898024000	20359	10245	2	0	\N
155480	1397	1318888023000	20359	10245	3	0	\N
155481	1397	1318878022000	20359	10245	4	0	\N
155482	1397	1318868021000	20359	10245	5	0	\N
155483	1397	1318858020000	20359	10245	6	0	\N
155484	1397	1318848019000	20359	10245	7	0	\N
155485	1397	1318838018000	20359	10245	8	0	\N
155486	1397	1318828017000	20359	10245	9	0	\N
155487	1397	1318818016000	20359	10245	10	0	\N
155488	1397	1318808015000	20359	10245	11	0	\N
155489	1397	1318798014000	20359	10245	12	0	\N
155490	1397	1318788013000	20359	10245	13	0	\N
155491	1397	1318778012000	20359	10245	14	0	\N
155492	1397	1318768011000	20359	10245	15	0	\N
155493	2134	96158501000	20359	10245	16	0	\N
155494	2134	96157498000	20359	10245	17	0	\N
155495	2134	96156495000	20359	10245	18	0	\N
155496	2134	96155492000	20359	10245	19	0	\N
155497	2134	96154489000	20359	10245	20	0	\N
155498	2134	96153486000	20359	10245	21	0	\N
155499	2134	96152483000	20359	10245	22	0	\N
155500	2134	96151480000	20359	10245	23	0	\N
155501	2134	96150477000	20359	10245	24	0	\N
155502	2134	96149474000	20359	10245	25	0	\N
155503	2134	96148471000	20359	10245	26	0	\N
155504	2134	96147468000	20359	10245	27	0	\N
155505	2134	96146465000	20359	10245	28	0	\N
155506	2134	96145462000	20359	10245	29	0	\N
155507	2133	96587184000	20359	10245	30	0	\N
155508	2133	96586182000	20359	10245	31	0	\N
155509	2133	96585180000	20359	10245	32	0	\N
155510	2133	96584178000	20359	10245	33	0	\N
155511	2133	96583176000	20359	10245	34	0	\N
155512	2133	96582174000	20359	10245	35	0	\N
155513	2133	96581172000	20359	10245	36	0	\N
155514	2133	96580170000	20359	10245	37	0	\N
155515	2133	96579168000	20359	10245	38	0	\N
155516	2133	96578166000	20359	10245	39	0	\N
155517	2133	96577164000	20359	10245	40	0	\N
155518	2133	96576162000	20359	10245	41	0	\N
155519	2133	96575160000	20359	10245	42	0	\N
155520	2133	96574158000	20359	10245	43	0	\N
155521	2133	96573156000	20359	10245	44	0	\N
155522	2133	96572154000	20359	10245	45	0	\N
155536	1397	1318748009000	20363	10257	0	0	\N
155537	1596	7704086180381	20363	10257	1	0	\N
155538	1596	4617200623985	20363	10257	2	0	\N
155539	1596	2064139511435	20363	10257	3	0	\N
155540	2134	96143456000	20363	10257	4	0	\N
155541	2133	96570150000	20363	10257	5	0	\N
155548	1397	1318728007000	20366	10259	0	0	\N
155549	2133	96568146000	20366	10259	1	0	\N
155550	2134	96141450000	20366	10259	2	0	\N
155560	1397	1318688003000	20369	10262	0	0	\N
155561	2133	96565140000	20369	10262	1	0	\N
155562	1560	21889679986418	20369	10262	2	0	\N
155563	1560	21584845695835	20369	10262	3	0	\N
155564	1560	21280011405252	20369	10262	4	0	\N
155565	1560	20975177114669	20369	10262	5	0	\N
155566	1560	20670342824086	20369	10262	6	0	\N
155567	1560	20365508533503	20369	10262	7	0	\N
155568	1560	20060674242920	20369	10262	8	0	\N
155569	1560	19755839952337	20369	10262	9	0	\N
155570	1560	19451005661754	20369	10262	10	0	\N
155571	1560	19146171371171	20369	10262	11	0	\N
155572	1560	16940489787155	20369	10262	12	0	\N
155573	1560	12987928078835	20369	10262	13	0	\N
155574	1560	10321055608607	20369	10262	14	0	\N
155575	1560	2889580131803	20369	10262	15	0	\N
155460	1397	1318818016000	20354	10251	0	0	12001
155461	2133	96577164000	20354	10251	1	0	2418
155462	1397	1318808015000	20355	10252	0	0	12002
155463	2133	96576162000	20355	10252	2	0	2419
155464	2134	96149474000	20355	10252	3	0	2842
155469	2134	96148471000	20357	10253	1	0	2843
155470	2133	96575160000	20357	10253	2	0	2420
155471	1397	1318788013000	20358	10254	0	0	12004
155472	1397	1318778012000	20358	10254	1	0	12005
155473	2133	96574158000	20358	10254	2	0	2421
155475	2134	96146465000	20358	10254	4	0	2845
155476	2133	96573156000	20358	10254	5	0	2422
155523	1397	1318768011000	20360	10255	0	0	12006
155524	2133	96572154000	20360	10255	1	0	2423
155526	1397	1318758010000	20361	10256	0	0	12007
155527	1596	12279145859486	20361	10256	1	0	12
155528	2133	96571152000	20361	10256	2	0	2424
155529	2134	96144459000	20361	10256	3	0	2847
155530	1397	1318748009000	20362	10257	0	0	12008
155532	1596	4617200623985	20362	10257	2	0	14
155533	1596	2064139511435	20362	10257	3	0	15
155534	2134	96143456000	20362	10257	4	0	2848
155535	2133	96570150000	20362	10257	5	0	2425
155542	1397	1318738008000	20364	10258	0	0	12009
155544	2134	96142453000	20364	10258	2	0	2849
155545	1397	1318728007000	20365	10259	0	0	12010
155546	2133	96568146000	20365	10259	1	0	2427
155547	2134	96141450000	20365	10259	2	0	2850
155552	1397	1318718006000	20367	10260	1	0	12011
155553	2134	96140447000	20367	10260	2	0	2851
155554	1397	1318708005000	20368	10261	0	0	12012
155555	1397	1318698004000	20368	10261	1	0	12013
155556	2133	96567144000	20368	10261	2	0	2428
155558	2134	96139444000	20368	10261	4	0	2852
155559	2134	96138441000	20368	10261	5	0	2853
155576	1397	1318688003000	20370	10262	0	0	12014
155577	2133	96565140000	20370	10262	1	0	2430
155578	2134	96137438000	20370	10262	2	0	2854
155580	1560	21584845695835	20370	10262	4	0	17
155581	1560	21280011405252	20370	10262	5	0	18
155582	1560	20975177114669	20370	10262	6	0	19
155583	1560	20670342824086	20370	10262	7	0	20
155593	1397	1318688003000	20371	10262	0	0	\N
155594	2133	96565140000	20371	10262	1	0	\N
155595	2134	96137438000	20371	10262	2	0	\N
155596	1560	21889679986418	20371	10262	3	0	\N
155597	1560	21584845695835	20371	10262	4	0	\N
155598	1560	21280011405252	20371	10262	5	0	\N
155599	1560	20975177114669	20371	10262	6	0	\N
155600	1560	20670342824086	20371	10262	7	0	\N
155601	1560	20365508533503	20371	10262	8	0	\N
155602	1560	20060674242920	20371	10262	9	0	\N
155603	1560	19755839952337	20371	10262	10	0	\N
155604	1560	19451005661754	20371	10262	11	0	\N
155605	1560	19146171371171	20371	10262	12	0	\N
155606	1560	16940489787155	20371	10262	13	0	\N
155607	1560	12987928078835	20371	10262	14	0	\N
155608	1560	10321055608607	20371	10262	15	0	\N
155609	1560	2889580131803	20371	10262	16	0	\N
155617	1397	1318658000000	20374	10265	0	0	\N
155618	2133	96562134000	20374	10265	1	0	\N
155619	2134	96134429000	20374	10265	2	0	\N
155620	1397	1318658000000	20375	10265	0	0	\N
155621	2133	96562134000	20375	10265	1	0	\N
155622	2134	96134429000	20375	10265	2	0	\N
155626	1397	1318658000000	20377	10265	0	0	\N
155627	2133	96562134000	20377	10265	1	0	\N
155628	2134	96134429000	20377	10265	2	0	\N
155629	1397	1318758010000	20378	10246	0	0	\N
155630	1932	38799152658	20378	10246	1	0	\N
155631	1397	1318748009000	20378	10246	2	0	\N
155632	1397	1318738008000	20378	10246	3	0	\N
155633	1397	1318728007000	20378	10246	4	0	\N
155634	1397	1318718006000	20378	10246	5	0	\N
155635	1397	1318708005000	20378	10246	6	0	\N
155636	1397	1318698004000	20378	10246	7	0	\N
155637	1397	1318688003000	20378	10246	8	0	\N
155638	1397	1318678002000	20378	10246	9	0	\N
155639	1397	1318668001000	20378	10246	10	0	\N
155640	1397	1318658000000	20378	10246	11	0	\N
155641	1397	1318647999000	20378	10246	12	0	\N
155642	1397	1318637998000	20378	10246	13	0	\N
155643	1596	12279145859486	20378	10246	14	0	\N
155644	1596	7704086180381	20378	10246	15	0	\N
155645	1596	4617200623985	20378	10246	16	0	\N
155646	1596	2064139511435	20378	10246	17	0	\N
155647	1596	720000000000	20378	10246	18	0	\N
155648	1560	21169652986418	20378	10246	19	0	\N
155649	2133	96571152000	20378	10246	20	0	\N
155650	1560	20864818695835	20378	10246	21	0	\N
155651	1560	20559984405252	20378	10246	22	0	\N
155652	2134	96144459000	20378	10246	23	0	\N
155653	2134	96143456000	20378	10246	24	0	\N
155654	2134	96142453000	20378	10246	25	0	\N
155655	2134	96141450000	20378	10246	26	0	\N
155656	2134	96140447000	20378	10246	27	0	\N
155657	2134	96139444000	20378	10246	28	0	\N
155658	2134	96138441000	20378	10246	29	0	\N
155659	2134	96137438000	20378	10246	30	0	\N
155660	2133	96570150000	20378	10246	31	0	\N
155661	2133	96569148000	20378	10246	32	0	\N
155662	2133	96568146000	20378	10246	33	0	\N
155663	2133	96567144000	20378	10246	34	0	\N
155664	2133	96566142000	20378	10246	35	0	\N
155665	2133	96565140000	20378	10246	36	0	\N
155666	2133	96564138000	20378	10246	37	0	\N
155667	2133	96563136000	20378	10246	38	0	\N
155668	2133	96562134000	20378	10246	39	0	\N
155669	2133	96561132000	20378	10246	40	0	\N
155670	2134	96136435000	20378	10246	41	0	\N
155671	2134	96135432000	20378	10246	42	0	\N
155672	1560	20255150114669	20378	10246	43	0	\N
155673	1560	19950315824086	20378	10246	44	0	\N
155674	1560	19645481533503	20378	10246	45	0	\N
155675	1560	19340647242920	20378	10246	46	0	\N
155676	1560	19035812952337	20378	10246	47	0	\N
155677	1560	18730978661754	20378	10246	48	0	\N
155678	2134	96134429000	20378	10246	49	0	\N
155679	2134	96133426000	20378	10246	50	0	\N
155680	2134	96132423000	20378	10246	51	0	\N
155681	1560	18426144371171	20378	10246	52	0	\N
155682	1560	16220462787155	20378	10246	53	0	\N
155683	1560	12267901078835	20378	10246	54	0	\N
155684	1560	9601028608607	20378	10246	55	0	\N
155685	1560	2169553131803	20378	10246	56	0	\N
155686	2133	96560130000	20378	10246	57	0	\N
155696	1397	1318617996000	20381	10268	0	0	\N
155697	2133	96558126000	20381	10268	1	0	\N
155698	2134	96130417000	20381	10268	2	0	\N
155707	1932	38799152658	20385	10227	0	0	\N
155708	1596	11559133859486	20385	10227	1	0	\N
155709	1596	6984074180381	20385	10227	2	0	\N
155710	1596	3897188623985	20385	10227	3	0	\N
155711	1596	1344127511435	20385	10227	4	0	\N
155712	1681	17507697296868	20385	10227	5	0	\N
155713	1560	21169652986418	20385	10227	6	0	\N
155714	1560	20864818695835	20385	10227	7	0	\N
155715	1560	20559984405252	20385	10227	8	0	\N
155716	1681	15410543061564	20385	10227	9	0	\N
155717	1681	11652461432300	20385	10227	10	0	\N
155718	1681	9116808546689	20385	10227	11	0	\N
155719	1681	2050988109853	20385	10227	12	0	\N
155720	1560	20255150114669	20385	10227	13	0	\N
155587	1560	19451005661754	20370	10262	11	0	24
155588	1560	19146171371171	20370	10262	12	0	25
155589	1560	16940489787155	20370	10262	13	0	26
155590	1560	12987928078835	20370	10262	14	0	27
155591	1560	10321055608607	20370	10262	15	0	28
155610	1397	1318678002000	20372	10263	0	0	12015
155611	1932	1382928664093	20372	10263	1	0	5
155612	2133	96564138000	20372	10263	2	0	2431
155613	2134	96136435000	20372	10263	3	0	2855
155614	1397	1318668001000	20373	10264	0	0	12016
155616	2133	96563136000	20373	10264	2	0	2432
155623	1397	1318658000000	20376	10265	0	0	12017
155624	2133	96562134000	20376	10265	1	0	2433
155625	2134	96134429000	20376	10265	2	0	2857
155688	1397	1318637998000	20379	10266	1	0	12019
155689	2134	96133426000	20379	10266	2	0	2858
155690	2133	96561132000	20379	10266	3	0	2434
155691	2134	96132423000	20379	10266	4	0	2859
155692	2133	96560130000	20379	10266	5	0	2435
155694	2134	96131420000	20380	10267	1	0	2860
155695	2133	96559128000	20380	10267	2	0	2436
155699	1397	1318617996000	20382	10268	0	0	12021
155700	2133	96558126000	20382	10268	1	0	2437
155701	2134	96130417000	20382	10268	2	0	2861
155703	2133	96557124000	20383	10269	1	0	2438
155704	1397	1318597994000	20384	10270	0	0	12023
155705	2134	96129414000	20384	10270	1	0	2862
155706	2133	96556122000	20384	10270	2	0	2439
155721	1560	19950315824086	20385	10227	14	0	\N
155722	1560	19645481533503	20385	10227	15	0	\N
155723	1560	19340647242920	20385	10227	16	0	\N
155724	1560	19035812952337	20385	10227	17	0	\N
155725	1560	18730978661754	20385	10227	18	0	\N
155726	369	86101373736560	20385	10227	19	0	\N
155727	369	81199528437520	20385	10227	20	0	\N
155728	369	77892155412810	20385	10227	21	0	\N
155729	369	68675868190850	20385	10227	22	0	\N
155730	1560	18426144371171	20385	10227	23	0	\N
155731	1560	16220462787155	20385	10227	24	0	\N
155732	1560	12267901078835	20385	10227	25	0	\N
155733	1560	9601028608607	20385	10227	26	0	\N
155734	1560	2169553131803	20385	10227	27	0	\N
155738	1397	1318587993000	20387	10271	0	0	\N
155739	2133	96555120000	20387	10271	1	0	\N
155740	2134	96128411000	20387	10271	2	0	\N
155762	1397	1318537988000	20392	10275	0	0	\N
155763	1397	1318527987000	20392	10275	1	0	\N
155764	1397	1318517986000	20392	10275	2	0	\N
155765	2133	96550110000	20392	10275	3	0	\N
155766	2134	96123396000	20392	10275	4	0	\N
155767	2134	96122393000	20392	10275	5	0	\N
155768	2134	96121390000	20392	10275	6	0	\N
155769	2133	96549108000	20392	10275	7	0	\N
155770	2133	96548106000	20392	10275	8	0	\N
155771	1397	1318507985000	20393	10276	0	0	\N
155772	2134	96120387000	20393	10276	1	0	\N
155773	2133	96547104000	20393	10276	2	0	\N
155774	1397	1318507985000	20394	10276	0	0	\N
155775	1397	1318507985000	20395	10276	0	0	\N
155776	2134	96120387000	20395	10276	1	0	\N
155777	2133	96547104000	20395	10276	2	0	\N
155781	1397	1318507985000	20397	10276	0	0	\N
155782	2134	96120387000	20397	10276	1	0	\N
155783	2133	96547104000	20397	10276	2	0	\N
155786	1932	38799152658	20399	10186	0	0	\N
155787	1397	1319008035000	20399	10186	1	0	\N
155788	1397	1318998034000	20399	10186	2	0	\N
155789	1397	1318988033000	20399	10186	3	0	\N
155790	1397	1318978032000	20399	10186	4	0	\N
155791	1397	1318968031000	20399	10186	5	0	\N
155792	1397	1318958030000	20399	10186	6	0	\N
155793	1397	1318948029000	20399	10186	7	0	\N
155794	1397	1318938028000	20399	10186	8	0	\N
155795	1397	1318928027000	20399	10186	9	0	\N
155796	1397	1318918026000	20399	10186	10	0	\N
155797	1397	1318908025000	20399	10186	11	0	\N
155798	1397	1318898024000	20399	10186	12	0	\N
155799	1397	1318888023000	20399	10186	13	0	\N
155800	1397	1318878022000	20399	10186	14	0	\N
155801	1397	1318868021000	20399	10186	15	0	\N
155802	1397	1318858020000	20399	10186	16	0	\N
155803	1397	1318848019000	20399	10186	17	0	\N
155804	1397	1318838018000	20399	10186	18	0	\N
155805	1397	1318828017000	20399	10186	19	0	\N
155806	1397	1318818016000	20399	10186	20	0	\N
155807	1397	1318808015000	20399	10186	21	0	\N
155808	1397	1318798014000	20399	10186	22	0	\N
155809	1397	1318788013000	20399	10186	23	0	\N
155810	1397	1318778012000	20399	10186	24	0	\N
155811	1397	1318768011000	20399	10186	25	0	\N
155812	1397	1318758010000	20399	10186	26	0	\N
155813	1397	1318748009000	20399	10186	27	0	\N
155814	1397	1318738008000	20399	10186	28	0	\N
155815	1397	1318728007000	20399	10186	29	0	\N
155816	1397	1318718006000	20399	10186	30	0	\N
155817	1397	1318708005000	20399	10186	31	0	\N
155818	1397	1318698004000	20399	10186	32	0	\N
155819	1397	1318688003000	20399	10186	33	0	\N
155820	1397	1318678002000	20399	10186	34	0	\N
155821	1397	1318668001000	20399	10186	35	0	\N
155822	1397	1318658000000	20399	10186	36	0	\N
155823	1397	1318647999000	20399	10186	37	0	\N
155824	1397	1318637998000	20399	10186	38	0	\N
155825	1397	1318627997000	20399	10186	39	0	\N
155826	1397	1318617996000	20399	10186	40	0	\N
155827	1397	1318607995000	20399	10186	41	0	\N
155828	1397	1318597994000	20399	10186	42	0	\N
155829	1397	1318587993000	20399	10186	43	0	\N
155830	1397	1318577992000	20399	10186	44	0	\N
155831	1397	1318567991000	20399	10186	45	0	\N
155832	1397	1318557990000	20399	10186	46	0	\N
155833	1397	1318547989000	20399	10186	47	0	\N
155834	1397	1318537988000	20399	10186	48	0	\N
155835	1397	1318527987000	20399	10186	49	0	\N
155836	1397	1318517986000	20399	10186	50	0	\N
155837	1397	1318507985000	20399	10186	51	0	\N
155838	1596	11559133859486	20399	10186	52	0	\N
155839	1596	6984074180381	20399	10186	53	0	\N
155840	1596	3897188623985	20399	10186	54	0	\N
155841	1596	1344127511435	20399	10186	55	0	\N
155842	2133	96655320000	20399	10186	56	0	\N
155843	2133	96654318000	20399	10186	57	0	\N
155844	1560	21169652986418	20399	10186	58	0	\N
155845	2133	96653316000	20399	10186	59	0	\N
155846	2133	96652314000	20399	10186	60	0	\N
155847	2133	96651312000	20399	10186	61	0	\N
155848	2133	96650310000	20399	10186	62	0	\N
155849	1560	20864818695835	20399	10186	63	0	\N
155850	1560	20559984405252	20399	10186	64	0	\N
155851	2133	96649308000	20399	10186	65	0	\N
155852	2133	96648306000	20399	10186	66	0	\N
155853	2133	96647304000	20399	10186	67	0	\N
155854	2133	96646302000	20399	10186	68	0	\N
155855	2133	96645300000	20399	10186	69	0	\N
155856	2133	96644298000	20399	10186	70	0	\N
155737	2134	96128411000	20386	10271	2	0	2863
155741	1397	1318577992000	20389	10273	0	0	12025
155742	1397	1318567991000	20389	10273	1	0	12026
155743	1397	1318557990000	20389	10273	2	0	12027
155744	2133	96554118000	20389	10273	3	0	2441
155746	2134	96126405000	20389	10273	5	0	2865
155747	2134	96125402000	20389	10273	6	0	2866
155748	2133	96553116000	20389	10273	7	0	2442
155749	2133	96552114000	20389	10273	8	0	2443
155750	1397	1318547989000	20390	10274	0	0	12028
155752	2133	96551112000	20390	10274	2	0	2444
155753	1397	1318537988000	20391	10275	0	0	12029
155754	1397	1318527987000	20391	10275	1	0	12030
155755	1397	1318517986000	20391	10275	2	0	12031
155757	2134	96123396000	20391	10275	4	0	2868
155758	2134	96122393000	20391	10275	5	0	2869
155759	2134	96121390000	20391	10275	6	0	2870
155760	2133	96549108000	20391	10275	7	0	2446
155761	2133	96548106000	20391	10275	8	0	2447
155779	2134	96120387000	20396	10276	1	0	2871
155780	2133	96547104000	20396	10276	2	0	2448
155784	1397	1318497984000	20398	10277	0	0	12033
155785	2133	96546102000	20398	10277	1	0	2449
155857	2133	96643296000	20399	10186	71	0	\N
155858	2133	96642294000	20399	10186	72	0	\N
155859	2133	96641292000	20399	10186	73	0	\N
155860	2133	96640290000	20399	10186	74	0	\N
155861	2133	96639288000	20399	10186	75	0	\N
155862	2133	96638286000	20399	10186	76	0	\N
155863	2133	96637284000	20399	10186	77	0	\N
155864	2133	96636282000	20399	10186	78	0	\N
155865	1560	20255150114669	20399	10186	79	0	\N
155866	1560	19950315824086	20399	10186	80	0	\N
155867	1560	19645481533503	20399	10186	81	0	\N
155868	1560	19340647242920	20399	10186	82	0	\N
155869	1560	19035812952337	20399	10186	83	0	\N
155870	1560	18730978661754	20399	10186	84	0	\N
155871	2133	96635280000	20399	10186	85	0	\N
155872	2133	96634278000	20399	10186	86	0	\N
155873	2133	96633276000	20399	10186	87	0	\N
155874	2133	96632274000	20399	10186	88	0	\N
155875	2133	96631272000	20399	10186	91	0	\N
155876	2133	96630270000	20399	10186	92	0	\N
155877	2133	96629268000	20399	10186	93	0	\N
155878	2133	96628266000	20399	10186	94	0	\N
155879	2133	96627264000	20399	10186	95	0	\N
155880	2133	96626262000	20399	10186	96	0	\N
155881	2133	96625260000	20399	10186	97	0	\N
155882	2133	96624258000	20399	10186	98	0	\N
155883	2133	96623256000	20399	10186	99	0	\N
155884	2133	96622254000	20399	10186	100	0	\N
155885	2133	96621252000	20399	10186	101	0	\N
155886	2133	96620250000	20399	10186	102	0	\N
155887	2133	96619248000	20399	10186	103	0	\N
155888	2133	96618246000	20399	10186	104	0	\N
155889	2133	96617244000	20399	10186	105	0	\N
155890	2133	96616242000	20399	10186	106	0	\N
155891	2133	96615240000	20399	10186	107	0	\N
155892	2133	96614238000	20399	10186	108	0	\N
155893	2133	96613236000	20399	10186	109	0	\N
155894	2133	96612234000	20399	10186	110	0	\N
155895	2134	96237738000	20399	10186	111	0	\N
155896	2134	96236735000	20399	10186	112	0	\N
155897	2134	96235732000	20399	10186	113	0	\N
155898	2134	96234729000	20399	10186	114	0	\N
155899	2134	96233726000	20399	10186	115	0	\N
155900	2134	96232723000	20399	10186	116	0	\N
155901	2134	96231720000	20399	10186	117	0	\N
155902	2134	96230717000	20399	10186	118	0	\N
155903	2134	96229714000	20399	10186	119	0	\N
155904	2134	96228711000	20399	10186	120	0	\N
155905	2134	96227708000	20399	10186	121	0	\N
155906	2134	96226705000	20399	10186	122	0	\N
155907	2134	96225702000	20399	10186	123	0	\N
155908	2134	96224699000	20399	10186	124	0	\N
155909	2134	96223696000	20399	10186	125	0	\N
155913	1397	1318487983000	20401	10278	0	0	\N
155914	2133	96545100000	20401	10278	1	0	\N
155915	2134	96119384000	20401	10278	2	0	\N
155916	1397	1318647999000	20402	10266	0	0	\N
155917	1397	1318637998000	20402	10266	1	0	\N
155918	1397	1318627997000	20402	10266	2	0	\N
155919	1397	1318617996000	20402	10266	3	0	\N
155920	1397	1318607995000	20402	10266	4	0	\N
155921	1397	1318597994000	20402	10266	5	0	\N
155922	1397	1318587993000	20402	10266	6	0	\N
155923	1397	1318577992000	20402	10266	7	0	\N
155924	1397	1318567991000	20402	10266	8	0	\N
155925	1397	1318557990000	20402	10266	9	0	\N
155926	1397	1318547989000	20402	10266	10	0	\N
155927	1397	1318537988000	20402	10266	11	0	\N
155928	1397	1318527987000	20402	10266	12	0	\N
155929	1397	1318517986000	20402	10266	13	0	\N
155930	1397	1318507985000	20402	10266	14	0	\N
155931	1397	1318497984000	20402	10266	15	0	\N
155932	1397	1318487983000	20402	10266	16	0	\N
155933	1397	1318477982000	20402	10266	17	0	\N
155934	2133	96561132000	20402	10266	18	0	\N
155935	2133	96560130000	20402	10266	19	0	\N
155936	2133	96559128000	20402	10266	20	0	\N
155937	2133	96558126000	20402	10266	21	0	\N
155938	2133	96557124000	20402	10266	22	0	\N
155939	2133	96556122000	20402	10266	23	0	\N
155940	2133	96555120000	20402	10266	24	0	\N
155941	2133	96554118000	20402	10266	25	0	\N
155942	2133	96553116000	20402	10266	26	0	\N
155943	2133	96552114000	20402	10266	27	0	\N
155944	2133	96551112000	20402	10266	28	0	\N
155945	2133	96550110000	20402	10266	29	0	\N
155946	2133	96549108000	20402	10266	30	0	\N
155950	1397	1318467981000	20404	10280	0	0	\N
155951	1397	1318457980000	20404	10280	1	0	\N
155952	1397	1318447979000	20404	10280	2	0	\N
155953	1397	1318437978000	20404	10280	3	0	\N
155954	2133	96543096000	20404	10280	4	0	\N
155955	2134	96117378000	20404	10280	5	0	\N
155956	2133	96542094000	20404	10280	6	0	\N
155957	2133	96541092000	20404	10280	7	0	\N
155958	2133	96540090000	20404	10280	8	0	\N
155959	2134	96116375000	20404	10280	9	0	\N
155960	2134	96115372000	20404	10280	10	0	\N
155961	2134	96114369000	20404	10280	11	0	\N
155988	1397	1318397974000	20409	10283	0	0	\N
155989	2133	96536082000	20409	10283	1	0	\N
155990	1680	17721802346879	20409	10283	2	0	\N
155991	1680	15533467536127	20409	10283	3	0	\N
155992	1680	11611991096895	20409	10283	4	0	\N
155912	2134	96119384000	20400	10278	2	0	2872
155947	1397	1318477982000	20403	10279	0	0	12035
155948	2133	96544098000	20403	10279	1	0	2451
155949	2134	96118381000	20403	10279	2	0	2873
155962	1397	1318467981000	20405	10280	0	0	12036
155964	1397	1318447979000	20405	10280	2	0	12038
155965	1397	1318437978000	20405	10280	3	0	12039
155966	2133	96543096000	20405	10280	4	0	2452
155967	2134	96117378000	20405	10280	5	0	2874
155968	2133	96542094000	20405	10280	6	0	2453
155970	2133	96540090000	20405	10280	8	0	2455
155971	2134	96116375000	20405	10280	9	0	2875
155972	2134	96115372000	20405	10280	10	0	2876
155973	2134	96114369000	20405	10280	11	0	2877
155975	2133	96539088000	20406	10281	1	0	2456
155976	2134	96113366000	20406	10281	2	0	2878
155977	1397	1318417976000	20407	10282	0	0	12041
155978	1397	1318407975000	20407	10282	1	0	12042
155979	2134	96112363000	20407	10282	2	0	2879
155981	2133	96538086000	20407	10282	4	0	2457
155982	2133	96537084000	20407	10282	5	0	2458
155983	1397	1318397974000	20408	10283	0	0	12043
155984	1680	17721802346879	20408	10283	1	0	7
155985	1680	15533467536127	20408	10283	2	0	8
155987	2134	96110357000	20408	10283	4	0	2881
155993	2134	96110357000	20409	10283	5	0	\N
155994	1397	1318397974000	20410	10283	0	0	\N
155995	2133	96536082000	20410	10283	1	0	\N
155996	1680	17721802346879	20410	10283	2	0	\N
155997	1680	15533467536127	20410	10283	3	0	\N
155998	1680	11611991096895	20410	10283	4	0	\N
155999	2134	96110357000	20410	10283	5	0	\N
156000	1397	1318397974000	20411	10283	0	0	\N
156001	2133	96536082000	20411	10283	1	0	\N
156002	1680	17721802346879	20411	10283	2	0	\N
156003	1680	15533467536127	20411	10283	3	0	\N
156004	1680	11611991096895	20411	10283	4	0	\N
156005	2134	96110357000	20411	10283	5	0	\N
156012	1397	1318387973000	20413	10284	0	0	\N
156013	1397	1318377972000	20413	10284	1	0	\N
156014	1397	1318367971000	20413	10284	2	0	\N
156015	1680	8966092477127	20413	10284	3	0	\N
156016	2133	96536082000	20413	10284	4	0	\N
156017	1680	8106091477127	20413	10284	5	0	\N
156018	2134	96109354000	20413	10284	6	0	\N
156019	2132	148196197000	20413	10284	7	0	\N
156020	2133	96535080000	20413	10284	8	0	\N
156021	2133	96534078000	20413	10284	9	0	\N
156022	2133	96533076000	20413	10284	10	0	\N
156023	1726	38530112000	20413	10284	11	0	\N
156024	1726	37329112000	20413	10284	12	0	\N
156025	1726	36128112000	20413	10284	13	0	\N
156026	2134	96108351000	20413	10284	14	0	\N
156027	2134	96107348000	20413	10284	15	0	\N
156038	1397	1318377972000	20415	10285	0	0	\N
156039	1397	1318367971000	20415	10285	1	0	\N
156040	2133	96534078000	20415	10285	2	0	\N
156041	2133	96533076000	20415	10285	3	0	\N
156042	2132	148196197000	20415	10285	4	0	\N
156043	1726	38530112000	20415	10285	5	0	\N
156044	1726	37329112000	20415	10285	6	0	\N
156045	1726	36128112000	20415	10285	7	0	\N
156046	2134	96108351000	20415	10285	8	0	\N
156047	2134	96107348000	20415	10285	9	0	\N
156048	1397	1318357970000	20416	10286	0	0	\N
156049	2133	96532074000	20416	10286	1	0	\N
156050	1726	34927112000	20416	10286	2	0	\N
156051	2134	96106345000	20416	10286	3	0	\N
156052	1726	33726112000	20416	10286	4	0	\N
156058	1397	1318357970000	20418	10286	0	0	\N
156059	2133	96532074000	20418	10286	1	0	\N
156060	1726	34927112000	20418	10286	2	0	\N
156061	2134	96106345000	20418	10286	3	0	\N
156062	1726	33726112000	20418	10286	4	0	\N
156063	1397	1318347969000	20419	10287	0	0	\N
156064	1397	1318337968000	20419	10287	1	0	\N
156065	2133	96531072000	20419	10287	2	0	\N
156066	2134	96105342000	20419	10287	3	0	\N
156067	2134	96104339000	20419	10287	4	0	\N
156068	2133	96530070000	20419	10287	5	0	\N
156075	1397	1318347969000	20421	10287	0	0	\N
156076	1397	1318337968000	20421	10287	1	0	\N
156077	2133	96531072000	20421	10287	2	0	\N
156078	2134	96105342000	20421	10287	3	0	\N
156079	2134	96104339000	20421	10287	4	0	\N
156080	2133	96530070000	20421	10287	5	0	\N
156087	1397	1318307965000	20424	10290	0	0	\N
156088	2134	96102333000	20424	10290	1	0	\N
156089	2133	96527064000	20424	10290	3	0	\N
156090	1397	1318307965000	20425	10290	0	0	\N
156091	2134	96102333000	20425	10290	1	0	\N
156092	2133	96527064000	20425	10290	3	0	\N
156093	1397	1318307965000	20426	10290	0	0	\N
156094	2134	96102333000	20426	10290	1	0	\N
156095	2133	96527064000	20426	10290	3	0	\N
156096	1397	1318307965000	20427	10290	0	0	\N
156097	2134	96102333000	20427	10290	1	0	\N
156098	2133	96527064000	20427	10290	3	0	\N
156102	1680	733061499559	20429	10286	0	0	\N
156103	1397	1318297964000	20430	10291	0	0	\N
156104	1397	1318287963000	20430	10291	1	0	\N
156105	1680	733061499559	20430	10291	2	0	\N
156106	2134	96101330000	20430	10291	3	0	\N
156107	2132	148194195000	20430	10291	4	0	\N
156108	2134	96100327000	20430	10291	5	0	\N
156109	2133	96526062000	20430	10291	6	0	\N
156110	2133	96525060000	20430	10291	7	0	\N
156119	1397	1318277962000	20432	10292	0	0	\N
156120	1991	23188695338131	20432	10292	1	0	\N
156121	2133	96524058000	20432	10292	2	0	\N
156122	1991	22861225234787	20432	10292	3	0	\N
156123	1991	22533755131443	20432	10292	4	0	\N
156124	2134	96099324000	20432	10292	5	0	\N
156125	1397	1318277962000	20433	10292	0	0	\N
156126	1991	23188695338131	20433	10292	1	0	\N
156127	2133	96524058000	20433	10292	2	0	\N
156128	1991	22861225234787	20433	10292	3	0	\N
156008	2133	96536082000	20412	10284	2	0	2459
156009	1680	8106091477127	20412	10284	3	0	11
156010	2134	96109354000	20412	10284	4	0	2882
156011	2133	96535080000	20412	10284	5	0	2460
156028	1397	1318377972000	20414	10285	0	0	12045
156030	2133	96534078000	20414	10285	2	0	2461
156031	2133	96533076000	20414	10285	3	0	2462
156032	2132	148196197000	20414	10285	4	0	803
156033	1726	38530112000	20414	10285	5	0	8255
156034	1726	37329112000	20414	10285	6	0	8256
156036	2134	96108351000	20414	10285	8	0	2883
156037	2134	96107348000	20414	10285	9	0	2884
156053	1397	1318357970000	20417	10286	0	0	12047
156054	2133	96532074000	20417	10286	1	0	2463
156056	2134	96106345000	20417	10286	3	0	2885
156057	1726	33726112000	20417	10286	4	0	8259
156069	1397	1318347969000	20420	10287	0	0	12048
156070	1397	1318337968000	20420	10287	1	0	12049
156071	2133	96531072000	20420	10287	2	0	2464
156073	2134	96104339000	20420	10287	4	0	2887
156074	2133	96530070000	20420	10287	5	0	2465
156081	1397	1318327967000	20422	10288	0	0	12050
156082	2132	148195196000	20422	10288	1	0	804
156083	2133	96529068000	20422	10288	2	0	2466
156085	2134	96103336000	20423	10289	1	0	2888
156086	2133	96528066000	20423	10289	2	0	2467
156099	1397	1318307965000	20428	10290	0	0	12052
156100	2134	96102333000	20428	10290	1	0	2889
156111	1397	1318297964000	20431	10291	0	0	12053
156112	1397	1318287963000	20431	10291	1	0	12054
156113	1680	733061499559	20431	10291	2	0	12
156114	2134	96101330000	20431	10291	3	0	2890
156115	2132	148194195000	20431	10291	4	0	805
156117	2133	96526062000	20431	10291	6	0	2469
156118	2133	96525060000	20431	10291	7	0	2470
156129	1991	22533755131443	20433	10292	4	0	\N
156130	2134	96099324000	20433	10292	5	0	\N
156136	1397	1318267961000	20435	10293	0	0	\N
156137	2132	148193194000	20435	10293	1	0	\N
156138	1991	22533755131443	20435	10293	2	0	\N
156139	1991	22206285028099	20435	10293	3	0	\N
156140	1991	21878814924755	20435	10293	4	0	\N
156141	1991	19385361533665	20435	10293	5	0	\N
156142	2134	96098321000	20435	10293	6	0	\N
156143	1991	14917115212725	20435	10293	7	0	\N
156144	1991	11902300058615	20435	10293	8	0	\N
156145	1991	3501251355805	20435	10293	9	0	\N
156157	1397	1318267961000	20437	10293	0	0	\N
156158	2132	148193194000	20437	10293	1	0	\N
156159	2133	96523056000	20437	10293	2	0	\N
156160	1991	22533755131443	20437	10293	3	0	\N
156161	1991	22206285028099	20437	10293	4	0	\N
156162	1991	21878814924755	20437	10293	5	0	\N
156163	1991	19385361533665	20437	10293	6	0	\N
156164	2134	96098321000	20437	10293	7	0	\N
156165	1991	14917115212725	20437	10293	8	0	\N
156166	1991	11902300058615	20437	10293	9	0	\N
156167	1991	3501251355805	20437	10293	10	0	\N
156168	1397	1318267961000	20438	10293	0	0	\N
156169	2132	148193194000	20438	10293	1	0	\N
156170	2133	96523056000	20438	10293	2	0	\N
156171	1991	22206285028099	20438	10293	3	0	\N
156172	1991	21878814924755	20438	10293	4	0	\N
156173	1991	19385361533665	20438	10293	5	0	\N
156174	2134	96098321000	20438	10293	6	0	\N
156175	1991	14917115212725	20438	10293	7	0	\N
156176	1991	11902300058615	20438	10293	8	0	\N
156177	1991	3501251355805	20438	10293	9	0	\N
156181	1397	1318257960000	20440	10294	0	0	\N
156182	2134	96097318000	20440	10294	1	0	\N
156183	2133	96522054000	20440	10294	2	0	\N
156184	1397	1318257960000	20441	10294	0	0	\N
156185	2134	96097318000	20441	10294	1	0	\N
156189	1397	1318237958000	20443	10296	0	0	\N
156190	2133	96520050000	20443	10296	1	0	\N
156193	1397	1318237958000	20445	10296	0	0	\N
156194	2133	96520050000	20445	10296	1	0	\N
156199	1397	1318217956000	20447	10298	0	0	\N
156200	2133	96518046000	20447	10298	1	0	\N
156201	2134	96094309000	20447	10298	2	0	\N
156205	1397	1318217956000	20449	10298	0	0	\N
156206	2133	96518046000	20449	10298	1	0	\N
156207	2134	96094309000	20449	10298	2	0	\N
156208	1397	1318217956000	20450	10298	0	0	\N
156209	2133	96518046000	20450	10298	1	0	\N
156210	2134	96094309000	20450	10298	2	0	\N
156214	1397	1318197954000	20452	10300	0	0	\N
156215	2224	717943000000	20452	10300	1	0	\N
156216	1993	2816348532446	20452	10300	2	0	\N
156217	2133	96516042000	20452	10300	3	0	\N
156218	2134	96092303000	20452	10300	4	0	\N
156219	2132	148191192000	20452	10300	5	0	\N
156226	1397	1318197954000	20454	10300	0	0	\N
156227	2224	717943000000	20454	10300	1	0	\N
156228	1993	2816348532446	20454	10300	2	0	\N
156229	2133	96516042000	20454	10300	3	0	\N
156230	2134	96092303000	20454	10300	4	0	\N
156231	2132	148191192000	20454	10300	5	0	\N
156232	1397	1318197954000	20455	10300	0	0	\N
156233	2224	717943000000	20455	10300	1	0	\N
156234	1993	2816348532446	20455	10300	2	0	\N
156235	2133	96516042000	20455	10300	3	0	\N
156236	2134	96092303000	20455	10300	4	0	\N
156237	2132	148191192000	20455	10300	5	0	\N
156241	1397	1318177952000	20457	10302	0	0	\N
156242	2134	96090297000	20457	10302	1	0	\N
156243	2133	96514038000	20457	10302	2	0	\N
156247	1397	1318177952000	20459	10302	0	0	\N
156248	2134	96090297000	20459	10302	1	0	\N
156249	2133	96514038000	20459	10302	2	0	\N
156250	1397	1318177952000	20460	10302	0	0	\N
156251	2134	96090297000	20460	10302	1	0	\N
156255	1397	1318157950000	20462	10304	0	0	\N
156256	2133	96512034000	20462	10304	1	0	\N
156257	2134	96089294000	20462	10304	2	0	\N
156263	1397	1318147949000	20465	10305	0	0	\N
156264	2134	96088291000	20465	10305	1	0	\N
156133	2133	96524058000	20434	10292	2	0	2471
156134	1991	22861225234787	20434	10292	3	0	14
156135	2134	96099324000	20434	10292	4	0	2892
156146	1397	1318267961000	20436	10293	0	0	12056
156147	2132	148193194000	20436	10293	1	0	806
156149	1991	22533755131443	20436	10293	3	0	15
156150	1991	22206285028099	20436	10293	4	0	16
156151	1991	21878814924755	20436	10293	5	0	17
156152	1991	19385361533665	20436	10293	6	0	18
156153	2134	96098321000	20436	10293	7	0	2893
156155	1991	11902300058615	20436	10293	9	0	20
156156	1991	3501251355805	20436	10293	10	0	21
156178	1397	1318257960000	20439	10294	0	0	12057
156179	2134	96097318000	20439	10294	1	0	2894
156186	1397	1318247959000	20442	10295	0	0	12058
156187	2133	96521052000	20442	10295	1	0	2474
156188	2134	96096315000	20442	10295	2	0	2895
156191	1397	1318237958000	20444	10296	0	0	12059
156192	2133	96520050000	20444	10296	1	0	2475
156196	2132	148192193000	20446	10297	1	0	807
156197	2134	96095312000	20446	10297	2	0	2896
156198	2133	96519048000	20446	10297	3	0	2476
156202	1397	1318217956000	20448	10298	0	0	12061
156203	2133	96518046000	20448	10298	1	0	2477
156211	1397	1318207955000	20451	10299	0	0	12062
156212	2133	96517044000	20451	10299	1	0	2478
156213	2134	96093306000	20451	10299	2	0	2898
156220	1397	1318197954000	20453	10300	0	0	12063
156222	1993	2816348532446	20453	10300	2	0	2
156223	2133	96516042000	20453	10300	3	0	2479
156224	2134	96092303000	20453	10300	4	0	2899
156225	2132	148191192000	20453	10300	5	0	808
156238	1397	1318187953000	20456	10301	0	0	12064
156240	2133	96515040000	20456	10301	2	0	2480
156244	1397	1318177952000	20458	10302	0	0	12065
156245	2134	96090297000	20458	10302	1	0	2901
156246	2133	96514038000	20458	10302	2	0	2481
156252	1397	1318167951000	20461	10303	0	0	12066
156254	2132	148190191000	20461	10303	2	0	809
156258	1397	1318157950000	20463	10304	0	0	12067
156259	2133	96512034000	20463	10304	1	0	2483
156260	2134	96089294000	20463	10304	2	0	2902
156262	2134	96088291000	20464	10305	1	0	2903
156265	2133	96511032000	20465	10305	2	0	\N
156271	2224	717943000000	20467	10276	0	0	\N
156272	1397	1318507985000	20467	10276	1	0	\N
156273	1397	1318497984000	20467	10276	2	0	\N
156274	1397	1318487983000	20467	10276	3	0	\N
156275	1397	1318477982000	20467	10276	4	0	\N
156276	1397	1318467981000	20467	10276	5	0	\N
156277	1397	1318457980000	20467	10276	6	0	\N
156278	1397	1318447979000	20467	10276	7	0	\N
156279	1397	1318437978000	20467	10276	8	0	\N
156280	1397	1318427977000	20467	10276	9	0	\N
156281	1397	1318417976000	20467	10276	10	0	\N
156282	1397	1318407975000	20467	10276	11	0	\N
156283	1397	1318397974000	20467	10276	12	0	\N
156284	1397	1318387973000	20467	10276	13	0	\N
156285	1397	1318377972000	20467	10276	14	0	\N
156286	1397	1318367971000	20467	10276	15	0	\N
156287	1397	1318357970000	20467	10276	16	0	\N
156288	1397	1318347969000	20467	10276	17	0	\N
156289	1397	1318337968000	20467	10276	18	0	\N
156290	1397	1318327967000	20467	10276	19	0	\N
156291	1397	1318317966000	20467	10276	20	0	\N
156292	1397	1318307965000	20467	10276	21	0	\N
156293	1397	1318297964000	20467	10276	22	0	\N
156294	1397	1318287963000	20467	10276	23	0	\N
156295	1397	1318277962000	20467	10276	24	0	\N
156296	1397	1318267961000	20467	10276	25	0	\N
156297	1397	1318257960000	20467	10276	26	0	\N
156298	1397	1318247959000	20467	10276	27	0	\N
156299	1397	1318237958000	20467	10276	28	0	\N
156300	1397	1318227957000	20467	10276	29	0	\N
156301	1397	1318217956000	20467	10276	30	0	\N
156302	1397	1318207955000	20467	10276	31	0	\N
156303	1397	1318197954000	20467	10276	32	0	\N
156304	1397	1318187953000	20467	10276	33	0	\N
156305	1397	1318177952000	20467	10276	34	0	\N
156306	1397	1318167951000	20467	10276	35	0	\N
156307	1397	1318157950000	20467	10276	36	0	\N
156308	1397	1318147949000	20467	10276	37	0	\N
156309	1991	23188695338131	20467	10276	38	0	\N
156310	1993	1668400389290	20467	10276	39	0	\N
156311	1680	17721802346879	20467	10276	40	0	\N
156312	1991	22861225234787	20467	10276	41	0	\N
156313	2132	148196197000	20467	10276	42	0	\N
156314	2132	148195196000	20467	10276	43	0	\N
156315	2132	148194195000	20467	10276	44	0	\N
156316	2132	148193194000	20467	10276	45	0	\N
156317	2132	148192193000	20467	10276	46	0	\N
156318	2134	96120387000	20467	10276	47	0	\N
156319	2133	96547104000	20467	10276	48	0	\N
156320	2133	96546102000	20467	10276	49	0	\N
156321	2133	96545100000	20467	10276	50	0	\N
156322	2133	96544098000	20467	10276	51	0	\N
156323	2133	96543096000	20467	10276	52	0	\N
156324	1726	38530112000	20467	10276	53	0	\N
156325	1726	37329112000	20467	10276	54	0	\N
156326	1726	36128112000	20467	10276	55	0	\N
156327	1726	34927112000	20467	10276	56	0	\N
156328	1726	33726112000	20467	10276	57	0	\N
156329	1991	22533755131443	20467	10276	58	0	\N
156330	1991	22206285028099	20467	10276	59	0	\N
156331	1991	21878814924755	20467	10276	60	0	\N
156332	1991	19385361533665	20467	10276	61	0	\N
156333	1991	14917115212725	20467	10276	62	0	\N
156334	1991	11902300058615	20467	10276	63	0	\N
156335	2133	96542094000	20467	10276	64	0	\N
156336	2132	148191192000	20467	10276	65	0	\N
156337	2132	148190191000	20467	10276	66	0	\N
156338	2134	96119384000	20467	10276	67	0	\N
156339	2133	96541092000	20467	10276	68	0	\N
156340	2133	96540090000	20467	10276	69	0	\N
156341	2133	96539088000	20467	10276	70	0	\N
156342	1680	15533467536127	20467	10276	71	0	\N
156343	1680	11611991096895	20467	10276	72	0	\N
156344	1680	8966092477127	20467	10276	73	0	\N
156345	1680	1593062499559	20467	10276	74	0	\N
156346	2133	96538086000	20467	10276	75	0	\N
156347	2133	96537084000	20467	10276	76	0	\N
156348	2133	96536082000	20467	10276	77	0	\N
156349	2133	96535080000	20467	10276	78	0	\N
156350	2133	96534078000	20467	10276	79	0	\N
156351	2133	96533076000	20467	10276	80	0	\N
156352	2133	96532074000	20467	10276	81	0	\N
156353	2133	96531072000	20467	10276	82	0	\N
156354	2133	96530070000	20467	10276	83	0	\N
156355	2133	96529068000	20467	10276	84	0	\N
156356	2133	96528066000	20467	10276	85	0	\N
156357	2133	96527064000	20467	10276	86	0	\N
156358	2133	96526062000	20467	10276	87	0	\N
156359	2133	96525060000	20467	10276	88	0	\N
156360	2133	96524058000	20467	10276	89	0	\N
156361	2133	96523056000	20467	10276	90	0	\N
156362	2133	96522054000	20467	10276	91	0	\N
156363	2133	96521052000	20467	10276	92	0	\N
156364	2133	96520050000	20467	10276	93	0	\N
156365	2133	96519048000	20467	10276	94	0	\N
156366	2133	96518046000	20467	10276	95	0	\N
156367	2133	96517044000	20467	10276	96	0	\N
156368	2133	96516042000	20467	10276	97	0	\N
156369	2133	96515040000	20467	10276	98	0	\N
156370	2133	96514038000	20467	10276	99	0	\N
156371	2133	96513036000	20467	10276	101	0	\N
156372	2133	96512034000	20467	10276	102	0	\N
156373	2133	96511032000	20467	10276	103	0	\N
156374	2133	96510030000	20467	10276	104	0	\N
156375	1991	3501251355805	20467	10276	105	0	\N
156376	2134	96118381000	20467	10276	106	0	\N
156377	2134	96117378000	20467	10276	107	0	\N
156378	2134	96116375000	20467	10276	108	0	\N
156379	2134	96115372000	20467	10276	109	0	\N
156380	2134	96114369000	20467	10276	110	0	\N
156381	2134	96113366000	20467	10276	111	0	\N
156382	2134	96112363000	20467	10276	112	0	\N
156383	2134	96111360000	20467	10276	113	0	\N
156384	2134	96110357000	20467	10276	114	0	\N
156385	2134	96109354000	20467	10276	115	0	\N
156386	2134	96108351000	20467	10276	116	0	\N
156387	2134	96107348000	20467	10276	117	0	\N
156388	2134	96106345000	20467	10276	118	0	\N
156389	2134	96105342000	20467	10276	119	0	\N
156390	2134	96104339000	20467	10276	120	0	\N
156391	2134	96103336000	20467	10276	121	0	\N
156392	2134	96102333000	20467	10276	122	0	\N
156393	2134	96101330000	20467	10276	123	0	\N
156394	2134	96100327000	20467	10276	124	0	\N
156395	2134	96099324000	20467	10276	125	0	\N
156400	1397	1318127947000	20469	10307	0	0	\N
156268	2134	96087288000	20466	10306	2	0	2904
156269	2133	96511032000	20466	10306	3	0	2484
156270	2133	96510030000	20466	10306	4	0	2485
156396	1397	1318127947000	20468	10307	0	0	12070
156397	2132	148189190000	20468	10307	1	0	810
156399	2134	96086285000	20468	10307	3	0	2905
156401	2132	148189190000	20469	10307	1	0	\N
156402	2133	96509028000	20469	10307	2	0	\N
156403	2134	96086285000	20469	10307	3	0	\N
156410	1397	1318097944000	20472	10310	0	0	\N
156411	2133	96506022000	20472	10310	1	0	\N
156412	2134	96083276000	20472	10310	2	0	\N
156413	2132	148188189000	20472	10310	3	0	\N
156418	2133	96505020000	20474	10311	0	0	\N
156421	1397	1318077942000	20476	10312	0	0	\N
156422	1703	10080817000000	20476	10312	1	0	\N
156423	2133	96504018000	20476	10312	2	0	\N
156424	2134	96082273000	20476	10312	3	0	\N
156429	2224	717943000000	20478	10247	0	0	\N
156430	1397	1318627997000	20478	10247	1	0	\N
156431	1397	1318617996000	20478	10247	2	0	\N
156432	1397	1318607995000	20478	10247	3	0	\N
156433	1397	1318597994000	20478	10247	4	0	\N
156434	1397	1318587993000	20478	10247	5	0	\N
156435	1397	1318577992000	20478	10247	6	0	\N
156436	1397	1318567991000	20478	10247	7	0	\N
156437	1397	1318557990000	20478	10247	8	0	\N
156438	1397	1318547989000	20478	10247	9	0	\N
156439	1397	1318537988000	20478	10247	10	0	\N
156440	1397	1318527987000	20478	10247	11	0	\N
156441	1397	1318517986000	20478	10247	12	0	\N
156442	1397	1318507985000	20478	10247	13	0	\N
156443	1397	1318497984000	20478	10247	14	0	\N
156444	1397	1318487983000	20478	10247	15	0	\N
156445	1397	1318477982000	20478	10247	16	0	\N
156446	1397	1318467981000	20478	10247	17	0	\N
156447	1397	1318457980000	20478	10247	18	0	\N
156448	1397	1318447979000	20478	10247	19	0	\N
156449	1397	1318437978000	20478	10247	20	0	\N
156450	1397	1318427977000	20478	10247	21	0	\N
156451	1703	10080817000000	20478	10247	22	0	\N
156452	1397	1318417976000	20478	10247	23	0	\N
156453	1397	1318407975000	20478	10247	24	0	\N
156454	1397	1318397974000	20478	10247	25	0	\N
156455	1397	1318387973000	20478	10247	26	0	\N
156456	1397	1318377972000	20478	10247	27	0	\N
156457	1397	1318367971000	20478	10247	28	0	\N
156458	1397	1318357970000	20478	10247	29	0	\N
156459	1397	1318347969000	20478	10247	30	0	\N
156460	1397	1318337968000	20478	10247	31	0	\N
156461	1397	1318327967000	20478	10247	32	0	\N
156462	1397	1318317966000	20478	10247	33	0	\N
156463	1397	1318307965000	20478	10247	34	0	\N
156464	1397	1318297964000	20478	10247	35	0	\N
156465	1397	1318287963000	20478	10247	36	0	\N
156466	1397	1318277962000	20478	10247	37	0	\N
156467	1397	1318267961000	20478	10247	38	0	\N
156468	1397	1318257960000	20478	10247	39	0	\N
156469	1397	1318247959000	20478	10247	40	0	\N
156470	1397	1318237958000	20478	10247	41	0	\N
156471	1397	1318227957000	20478	10247	42	0	\N
156472	1397	1318217956000	20478	10247	43	0	\N
156473	1397	1318207955000	20478	10247	44	0	\N
156474	1397	1318197954000	20478	10247	45	0	\N
156475	1397	1318187953000	20478	10247	46	0	\N
156476	1397	1318177952000	20478	10247	47	0	\N
156477	1397	1318167951000	20478	10247	48	0	\N
156478	1397	1318157950000	20478	10247	49	0	\N
156479	1397	1318147949000	20478	10247	50	0	\N
156480	1397	1318137948000	20478	10247	51	0	\N
156481	1397	1318127947000	20478	10247	52	0	\N
156482	1397	1318117946000	20478	10247	53	0	\N
156483	1397	1318107945000	20478	10247	54	0	\N
156484	1397	1318097944000	20478	10247	55	0	\N
156485	1397	1318087943000	20478	10247	56	0	\N
156486	1991	22468659338131	20478	10247	57	0	\N
156487	1993	1668400389290	20478	10247	58	0	\N
156488	1680	17001790346879	20478	10247	59	0	\N
156489	1991	22141189234787	20478	10247	60	0	\N
156490	2132	148196197000	20478	10247	61	0	\N
156491	2132	148195196000	20478	10247	62	0	\N
156492	2132	148194195000	20478	10247	63	0	\N
156493	2132	148193194000	20478	10247	64	0	\N
156494	2132	148192193000	20478	10247	65	0	\N
156495	2134	96131420000	20478	10247	67	0	\N
156496	2134	96130417000	20478	10247	68	0	\N
156497	2134	96129414000	20478	10247	69	0	\N
156498	2133	96559128000	20478	10247	70	0	\N
156499	2133	96558126000	20478	10247	71	0	\N
156500	1726	38530112000	20478	10247	72	0	\N
156501	1726	37329112000	20478	10247	73	0	\N
156502	1726	36128112000	20478	10247	74	0	\N
156503	1726	34927112000	20478	10247	75	0	\N
156504	1726	33726112000	20478	10247	76	0	\N
156505	1991	21813719131443	20478	10247	77	0	\N
156506	1991	21486249028099	20478	10247	78	0	\N
156507	1991	21158778924755	20478	10247	79	0	\N
156508	1991	18665325533665	20478	10247	80	0	\N
156509	1991	14197079212725	20478	10247	81	0	\N
156510	1991	11182264058615	20478	10247	82	0	\N
156511	2134	96128411000	20478	10247	83	0	\N
156512	2134	96127408000	20478	10247	84	0	\N
156513	2134	96126405000	20478	10247	85	0	\N
156514	2134	96125402000	20478	10247	86	0	\N
156515	2134	96124399000	20478	10247	87	0	\N
156516	2134	96123396000	20478	10247	88	0	\N
156517	2134	96122393000	20478	10247	89	0	\N
156518	2134	96121390000	20478	10247	90	0	\N
156519	2134	96120387000	20478	10247	91	0	\N
156520	2132	148191192000	20478	10247	92	0	\N
156521	2132	148190191000	20478	10247	93	0	\N
156522	2132	148189190000	20478	10247	94	0	\N
156523	2132	148188189000	20478	10247	95	0	\N
156524	2134	96119384000	20478	10247	96	0	\N
156525	2133	96557124000	20478	10247	97	0	\N
156526	2133	96556122000	20478	10247	98	0	\N
156527	2133	96555120000	20478	10247	99	0	\N
156528	2133	96554118000	20478	10247	100	0	\N
156529	2133	96553116000	20478	10247	101	0	\N
156530	2133	96552114000	20478	10247	102	0	\N
156531	2133	96551112000	20478	10247	103	0	\N
156532	2133	96550110000	20478	10247	104	0	\N
156533	2133	96549108000	20478	10247	105	0	\N
156534	2133	96548106000	20478	10247	106	0	\N
156535	2133	96547104000	20478	10247	107	0	\N
156536	2133	96546102000	20478	10247	108	0	\N
156406	2133	96508026000	20470	10308	2	0	2487
156407	1397	1318107945000	20471	10309	0	0	12072
156408	2134	96084279000	20471	10309	1	0	2907
156409	2133	96507024000	20471	10309	2	0	2488
156414	1397	1318097944000	20473	10310	0	0	12073
156416	2134	96083276000	20473	10310	2	0	2908
156417	2132	148188189000	20473	10310	3	0	811
156419	1397	1318087943000	20475	10311	0	0	12074
156420	2133	96505020000	20475	10311	1	0	2490
156425	1397	1318077942000	20477	10312	0	0	12075
156427	2133	96504018000	20477	10312	2	0	2491
156428	2134	96082273000	20477	10312	3	0	2909
156537	2133	96545100000	20478	10247	109	0	\N
156538	2133	96544098000	20478	10247	110	0	\N
156539	2133	96543096000	20478	10247	111	0	\N
156540	2133	96542094000	20478	10247	112	0	\N
156541	2133	96541092000	20478	10247	113	0	\N
156542	2133	96540090000	20478	10247	114	0	\N
156543	2133	96539088000	20478	10247	115	0	\N
156544	1680	14813455536127	20478	10247	116	0	\N
156545	1680	10891979096895	20478	10247	117	0	\N
156546	1680	8246080477127	20478	10247	118	0	\N
156547	1680	873050499559	20478	10247	119	0	\N
156548	2133	96538086000	20478	10247	120	0	\N
156549	2133	96537084000	20478	10247	121	0	\N
156550	2133	96536082000	20478	10247	122	0	\N
156551	2133	96535080000	20478	10247	123	0	\N
156552	2133	96534078000	20478	10247	124	0	\N
156553	2133	96533076000	20478	10247	125	0	\N
156582	1397	1318007935000	20482	10314	0	0	\N
156583	2133	96497004000	20482	10314	1	0	\N
156584	1702	1044352000000	20483	10315	0	0	\N
156585	1397	1317997934000	20483	10315	1	0	\N
156586	2134	96075252000	20483	10315	2	0	\N
156587	2132	148185186000	20483	10315	3	0	\N
156588	2133	96496002000	20483	10315	4	0	\N
156589	1702	1044352000000	20484	10315	0	0	\N
156590	1397	1317997934000	20484	10315	1	0	\N
156591	2134	96075252000	20484	10315	2	0	\N
156592	2132	148185186000	20484	10315	3	0	\N
156593	2133	96496002000	20484	10315	4	0	\N
156599	633	78456198900000	20486	10313	0	0	\N
156600	633	74037178900000	20486	10313	1	0	\N
156601	633	71055158900000	20486	10313	2	0	\N
156602	633	68589138900000	20486	10313	3	0	\N
156603	1397	1318067941000	20486	10313	4	0	\N
156604	1397	1318057940000	20486	10313	5	0	\N
156605	1703	807000000	20486	10313	6	0	\N
156606	1397	1318047939000	20486	10313	7	0	\N
156607	1397	1318037938000	20486	10313	8	0	\N
156608	1397	1318027937000	20486	10313	9	0	\N
156609	1397	1318017936000	20486	10313	10	0	\N
156610	1397	1318007935000	20486	10313	11	0	\N
156611	2132	148187188000	20486	10313	12	0	\N
156612	1726	32525112000	20486	10313	13	0	\N
156613	2134	96081270000	20486	10313	14	0	\N
156614	2134	96080267000	20486	10313	15	0	\N
156615	2134	96079264000	20486	10313	16	0	\N
156616	2134	96078261000	20486	10313	17	0	\N
156617	2133	96503016000	20486	10313	18	0	\N
156618	2133	96502014000	20486	10313	19	0	\N
156619	2132	148186187000	20486	10313	20	0	\N
156620	2132	148185186000	20486	10313	21	0	\N
156621	2134	96077258000	20486	10313	22	0	\N
156622	2134	96076255000	20486	10313	23	0	\N
156623	2134	96075252000	20486	10313	24	0	\N
156624	2133	96501012000	20486	10313	25	0	\N
156625	2133	96500010000	20486	10313	26	0	\N
156626	2133	96499008000	20486	10313	27	0	\N
156627	2133	96498006000	20486	10313	28	0	\N
156628	2133	96497004000	20486	10313	29	0	\N
156629	1397	1317987933000	20487	10316	0	0	\N
156630	1397	1317977932000	20487	10316	1	0	\N
156631	2133	96495000000	20487	10316	2	0	\N
156632	2133	96493998000	20487	10316	3	0	\N
156633	2134	96074249000	20487	10316	4	0	\N
156634	2134	96073246000	20487	10316	5	0	\N
156641	2133	96495000000	20489	10316	0	0	\N
156642	2133	96493998000	20489	10316	1	0	\N
156643	2134	96074249000	20489	10316	2	0	\N
156644	2134	96073246000	20489	10316	3	0	\N
156645	1397	1317967931000	20490	10317	0	0	\N
156646	2132	148184185000	20490	10317	1	0	\N
156647	2134	96072243000	20490	10317	2	0	\N
156669	1397	1317907925000	20496	10321	0	0	\N
156670	2133	96487986000	20496	10321	1	0	\N
156671	2133	96487986000	20497	10321	0	0	\N
156672	1397	1317907925000	20498	10321	0	0	\N
156556	633	71055158900000	20479	10313	2	0	8
156557	633	68589138900000	20479	10313	3	0	9
156558	1397	1318067941000	20479	10313	4	0	12076
156559	1397	1318057940000	20479	10313	5	0	12077
156560	1703	807000000	20479	10313	6	0	5
156562	1397	1318037938000	20479	10313	8	0	12079
156563	1397	1318027937000	20479	10313	9	0	12080
156564	1397	1318017936000	20479	10313	10	0	12081
156565	2132	148187188000	20479	10313	11	0	812
156566	1726	32525112000	20479	10313	12	0	8260
156568	2134	96080267000	20479	10313	14	0	2911
156569	2134	96079264000	20479	10313	15	0	2912
156570	2134	96078261000	20479	10313	16	0	2913
156571	2133	96503016000	20479	10313	17	0	2492
156573	2132	148186187000	20479	10313	19	0	813
156574	2134	96077258000	20479	10313	20	0	2914
156575	2134	96076255000	20479	10313	21	0	2915
156576	2133	96501012000	20479	10313	22	0	2494
156577	2133	96500010000	20479	10313	23	0	2495
156579	2133	96498006000	20479	10313	25	0	2497
156580	1397	1318007935000	20481	10314	0	0	12082
156581	2133	96497004000	20481	10314	1	0	2498
156594	1702	1044352000000	20485	10315	0	0	4
156595	1397	1317997934000	20485	10315	1	0	12083
156597	2132	148185186000	20485	10315	3	0	814
156598	2133	96496002000	20485	10315	4	0	2499
156635	1397	1317987933000	20488	10316	0	0	12084
156636	1397	1317977932000	20488	10316	1	0	12085
156638	2133	96493998000	20488	10316	3	0	2501
156639	2134	96074249000	20488	10316	4	0	2917
156640	2134	96073246000	20488	10316	5	0	2918
156648	1397	1317967931000	20491	10317	0	0	12086
156649	2132	148184185000	20491	10317	1	0	815
156651	1397	1317957930000	20492	10318	0	0	12087
156652	1397	1317947929000	20492	10318	1	0	12088
156653	1397	1317937928000	20492	10318	2	0	12089
156654	2134	96071240000	20492	10318	3	0	2920
156655	2134	96070237000	20492	10318	4	0	2921
156657	2133	96492996000	20492	10318	6	0	2502
156658	2133	96491994000	20492	10318	7	0	2503
156659	2133	96490992000	20492	10318	8	0	2504
156660	1397	1317927927000	20493	10319	0	0	12090
156662	2133	96489990000	20493	10319	2	0	2505
156663	2132	148183184000	20493	10319	3	0	816
156664	1397	1317917926000	20494	10320	0	0	12091
156665	2134	96067228000	20494	10320	1	0	2924
156666	2133	96488988000	20494	10320	2	0	2506
156668	2133	96487986000	20495	10321	1	0	2507
156673	2133	96487986000	20498	10321	1	0	\N
156678	1397	1317897924000	20500	10322	0	0	\N
156679	2132	148182183000	20500	10322	1	0	\N
156680	2133	96486984000	20500	10322	2	0	\N
156681	2134	96066225000	20500	10322	3	0	\N
156682	1397	1317897924000	20501	10322	0	0	\N
156683	2132	148182183000	20501	10322	1	0	\N
156684	2133	96486984000	20501	10322	2	0	\N
156685	2134	96066225000	20501	10322	3	0	\N
156692	1397	1317877922000	20505	10324	0	0	\N
156693	2133	96484980000	20505	10324	1	0	\N
156694	2134	96064219000	20505	10324	2	0	\N
156699	633	77736186900000	20508	10231	0	0	\N
156700	633	73317166900000	20508	10231	1	0	\N
156701	633	70335146900000	20508	10231	2	0	\N
156702	633	67869126900000	20508	10231	3	0	\N
156703	2224	717943000000	20508	10231	4	0	\N
156704	1932	38799152658	20508	10231	5	0	\N
156705	1702	1044352000000	20508	10231	6	0	\N
156706	1397	1319118046000	20508	10231	7	0	\N
156707	1397	1319108045000	20508	10231	8	0	\N
156708	1397	1319098044000	20508	10231	9	0	\N
156709	1397	1319088043000	20508	10231	10	0	\N
156710	1397	1319078042000	20508	10231	11	0	\N
156711	1397	1319068041000	20508	10231	12	0	\N
156712	1397	1319058040000	20508	10231	13	0	\N
156713	1397	1319048039000	20508	10231	14	0	\N
156714	1397	1319038038000	20508	10231	15	0	\N
156715	1397	1319028037000	20508	10231	16	0	\N
156716	1397	1319018036000	20508	10231	17	0	\N
156717	1397	1319008035000	20508	10231	18	0	\N
156718	1703	10080817000000	20508	10231	19	0	\N
156719	1703	807000000	20508	10231	21	0	\N
156720	1397	1318998034000	20508	10231	22	0	\N
156721	1397	1318988033000	20508	10231	23	0	\N
156722	1397	1318978032000	20508	10231	24	0	\N
156723	1397	1318968031000	20508	10231	25	0	\N
156724	1397	1318958030000	20508	10231	26	0	\N
156725	1397	1318948029000	20508	10231	27	0	\N
156726	1397	1318938028000	20508	10231	28	0	\N
156727	1397	1318928027000	20508	10231	29	0	\N
156728	1397	1318918026000	20508	10231	30	0	\N
156729	1397	1318908025000	20508	10231	31	0	\N
156730	1397	1318898024000	20508	10231	32	0	\N
156731	1397	1318888023000	20508	10231	33	0	\N
156732	1397	1318878022000	20508	10231	34	0	\N
156733	1397	1318868021000	20508	10231	35	0	\N
156734	1397	1318858020000	20508	10231	36	0	\N
156735	1397	1318848019000	20508	10231	37	0	\N
156736	1397	1318838018000	20508	10231	38	0	\N
156737	1397	1318828017000	20508	10231	39	0	\N
156738	1397	1318818016000	20508	10231	40	0	\N
156739	1397	1318808015000	20508	10231	41	0	\N
156740	1397	1318798014000	20508	10231	42	0	\N
156741	1397	1318788013000	20508	10231	43	0	\N
156742	1397	1318778012000	20508	10231	44	0	\N
156743	1397	1318768011000	20508	10231	45	0	\N
156744	1397	1318758010000	20508	10231	46	0	\N
156745	1397	1318748009000	20508	10231	47	0	\N
156746	1397	1318738008000	20508	10231	48	0	\N
156747	1397	1318728007000	20508	10231	49	0	\N
156748	1397	1318718006000	20508	10231	50	0	\N
156749	1397	1318708005000	20508	10231	51	0	\N
156750	1397	1318698004000	20508	10231	52	0	\N
156751	1397	1318688003000	20508	10231	53	0	\N
156752	1397	1318678002000	20508	10231	54	0	\N
156753	1397	1318668001000	20508	10231	55	0	\N
156754	1397	1318658000000	20508	10231	56	0	\N
156755	1397	1318647999000	20508	10231	57	0	\N
156756	1397	1318637998000	20508	10231	58	0	\N
156757	1397	1318627997000	20508	10231	59	0	\N
156758	1397	1318617996000	20508	10231	60	0	\N
156759	1397	1318607995000	20508	10231	61	0	\N
156760	1397	1318597994000	20508	10231	62	0	\N
156761	1397	1318587993000	20508	10231	63	0	\N
156762	1397	1318577992000	20508	10231	64	0	\N
156763	1397	1318567991000	20508	10231	65	0	\N
156764	1397	1318557990000	20508	10231	66	0	\N
156765	1397	1318547989000	20508	10231	67	0	\N
156766	1397	1318537988000	20508	10231	68	0	\N
156767	1397	1318527987000	20508	10231	69	0	\N
156768	1397	1318517986000	20508	10231	70	0	\N
156769	1397	1318507985000	20508	10231	71	0	\N
156770	1397	1318497984000	20508	10231	72	0	\N
156771	1397	1318487983000	20508	10231	73	0	\N
156772	1397	1318477982000	20508	10231	74	0	\N
156773	1397	1318467981000	20508	10231	75	0	\N
156774	1397	1318457980000	20508	10231	76	0	\N
156775	1397	1318447979000	20508	10231	77	0	\N
156776	1397	1318437978000	20508	10231	78	0	\N
156777	1397	1318427977000	20508	10231	79	0	\N
156778	1397	1318417976000	20508	10231	80	0	\N
156779	1397	1318407975000	20508	10231	81	0	\N
156780	1397	1318397974000	20508	10231	82	0	\N
156781	1397	1318387973000	20508	10231	83	0	\N
156782	1397	1318377972000	20508	10231	84	0	\N
156783	1397	1318367971000	20508	10231	85	0	\N
156784	1397	1318357970000	20508	10231	86	0	\N
156785	1397	1318347969000	20508	10231	87	0	\N
156786	1397	1318337968000	20508	10231	88	0	\N
156787	1397	1318327967000	20508	10231	89	0	\N
156788	1397	1318317966000	20508	10231	90	0	\N
156789	1397	1318307965000	20508	10231	91	0	\N
156790	1397	1318297964000	20508	10231	92	0	\N
156791	1397	1318287963000	20508	10231	93	0	\N
156792	1397	1318277962000	20508	10231	94	0	\N
156793	1397	1318267961000	20508	10231	95	0	\N
156794	1397	1318257960000	20508	10231	96	0	\N
156795	1397	1318247959000	20508	10231	97	0	\N
156796	1397	1318237958000	20508	10231	98	0	\N
156797	1397	1318227957000	20508	10231	99	0	\N
156798	1397	1318217956000	20508	10231	100	0	\N
156799	1397	1318207955000	20508	10231	101	0	\N
156800	1397	1318197954000	20508	10231	102	0	\N
156801	1397	1318187953000	20508	10231	103	0	\N
156802	1397	1318177952000	20508	10231	104	0	\N
156803	1397	1318167951000	20508	10231	105	0	\N
156804	1397	1318157950000	20508	10231	106	0	\N
156805	1397	1318147949000	20508	10231	107	0	\N
156806	1397	1318137948000	20508	10231	108	0	\N
156807	1397	1318127947000	20508	10231	109	0	\N
156808	1397	1318117946000	20508	10231	110	0	\N
156676	2133	96486984000	20499	10322	2	0	2508
156677	2134	96066225000	20499	10322	3	0	2925
156686	1397	1317887923000	20502	10323	0	0	12094
156687	2134	96065222000	20502	10323	1	0	2926
156688	2133	96485982000	20502	10323	2	0	2509
156690	2133	96484980000	20503	10324	1	0	2510
156691	2134	96064219000	20503	10324	2	0	2927
156695	1397	1317867921000	20507	10325	0	0	12096
156696	2132	148181182000	20507	10325	1	0	818
156697	2133	96483978000	20507	10325	2	0	2511
156809	1397	1318107945000	20508	10231	111	0	\N
156810	1397	1318097944000	20508	10231	112	0	\N
156811	1397	1318087943000	20508	10231	113	0	\N
156812	1397	1318077942000	20508	10231	114	0	\N
156813	1397	1318067941000	20508	10231	115	0	\N
156814	1397	1318057940000	20508	10231	116	0	\N
156815	1397	1318047939000	20508	10231	117	0	\N
156816	1397	1318037938000	20508	10231	118	0	\N
156817	1397	1318027937000	20508	10231	119	0	\N
156818	1397	1318017936000	20508	10231	120	0	\N
156819	1397	1318007935000	20508	10231	121	0	\N
156820	1397	1317997934000	20508	10231	122	0	\N
156821	1397	1317987933000	20508	10231	123	0	\N
156822	1397	1317977932000	20508	10231	124	0	\N
156823	1397	1317967931000	20508	10231	125	0	\N
156824	2133	96483978000	20509	10325	0	0	\N
156825	2134	96063216000	20509	10325	1	0	\N
156829	2134	96062213000	20511	10326	0	0	\N
156830	2133	96482976000	20511	10326	1	0	\N
156831	1397	1317847919000	20512	10327	0	0	\N
156832	2134	96061210000	20512	10327	1	0	\N
156833	1397	1317847919000	20513	10327	0	0	\N
156834	2133	96481974000	20513	10327	1	0	\N
156835	2134	96061210000	20513	10327	2	0	\N
156839	1397	1317837918000	20515	10328	0	0	\N
156840	1397	1317827917000	20515	10328	1	0	\N
156841	1397	1317817916000	20515	10328	2	0	\N
156842	1397	1317807915000	20515	10328	3	0	\N
156843	1397	1317797914000	20515	10328	4	0	\N
156844	2132	148180181000	20515	10328	5	0	\N
156845	2132	148179180000	20515	10328	6	0	\N
156846	1726	31324112000	20515	10328	7	0	\N
156847	2134	96060207000	20515	10328	8	0	\N
156848	2134	96059204000	20515	10328	9	0	\N
156849	2134	96058201000	20515	10328	10	0	\N
156850	2134	96057198000	20515	10328	12	0	\N
156851	2134	96056195000	20515	10328	13	0	\N
156852	2133	96480972000	20515	10328	14	0	\N
156853	2133	96479970000	20515	10328	15	0	\N
156854	2133	96478968000	20515	10328	16	0	\N
156855	2133	96477966000	20515	10328	17	0	\N
156856	2133	96476964000	20515	10328	18	0	\N
156857	1726	30123112000	20515	10328	19	0	\N
156858	1726	28922112000	20515	10328	20	0	\N
156859	1726	27721112000	20515	10328	21	0	\N
156860	1726	26520112000	20515	10328	22	0	\N
156861	1397	1317837918000	20516	10328	0	0	\N
156862	1397	1317827917000	20516	10328	1	0	\N
156863	1397	1317817916000	20516	10328	2	0	\N
156864	1397	1317807915000	20516	10328	3	0	\N
156865	1397	1317797914000	20516	10328	4	0	\N
156866	2132	148180181000	20516	10328	5	0	\N
156867	2132	148179180000	20516	10328	6	0	\N
156868	1726	31324112000	20516	10328	7	0	\N
156869	2134	96060207000	20516	10328	8	0	\N
156870	2134	96059204000	20516	10328	9	0	\N
156871	2134	96058201000	20516	10328	10	0	\N
156872	2134	96057198000	20516	10328	12	0	\N
156873	2134	96056195000	20516	10328	13	0	\N
156874	2133	96480972000	20516	10328	14	0	\N
156875	2133	96479970000	20516	10328	15	0	\N
156876	2133	96478968000	20516	10328	16	0	\N
156877	2133	96477966000	20516	10328	17	0	\N
156878	2133	96476964000	20516	10328	18	0	\N
156879	1726	30123112000	20516	10328	19	0	\N
156880	1726	28922112000	20516	10328	20	0	\N
156881	1726	27721112000	20516	10328	21	0	\N
156882	1726	26520112000	20516	10328	22	0	\N
156905	1397	1317787913000	20518	10329	0	0	\N
156906	1397	1317777912000	20518	10329	1	0	\N
156907	2134	96055192000	20518	10329	2	0	\N
156908	2134	96054189000	20518	10329	3	0	\N
156909	1397	1317787913000	20519	10329	0	0	\N
156910	1397	1317777912000	20519	10329	1	0	\N
156911	2133	96475962000	20519	10329	2	0	\N
156912	2133	96474960000	20519	10329	3	0	\N
156913	2134	96055192000	20519	10329	4	0	\N
156914	2134	96054189000	20519	10329	5	0	\N
156921	1397	1317787913000	20521	10329	0	0	\N
156922	1397	1317777912000	20521	10329	1	0	\N
156923	2133	96475962000	20521	10329	2	0	\N
156924	2133	96474960000	20521	10329	3	0	\N
156925	2134	96055192000	20521	10329	4	0	\N
156926	2134	96054189000	20521	10329	5	0	\N
156931	1397	1317767911000	20523	10330	0	0	\N
156932	2134	96053186000	20523	10330	1	0	\N
156933	2133	96473958000	20523	10330	2	0	\N
156934	2132	148178179000	20523	10330	3	0	\N
156935	1397	1317767911000	20524	10330	0	0	\N
156936	2134	96053186000	20524	10330	1	0	\N
156937	2133	96473958000	20524	10330	2	0	\N
156938	2132	148178179000	20524	10330	3	0	\N
156828	2133	96482976000	20510	10326	2	0	2512
156836	1397	1317847919000	20514	10327	0	0	12098
156837	2133	96481974000	20514	10327	1	0	2513
156838	2134	96061210000	20514	10327	2	0	2930
156883	1397	1317837918000	20517	10328	0	0	12099
156885	1397	1317817916000	20517	10328	2	0	12101
156886	1397	1317807915000	20517	10328	3	0	12102
156887	1397	1317797914000	20517	10328	4	0	12103
156888	2132	148180181000	20517	10328	5	0	819
156889	2132	148179180000	20517	10328	6	0	820
156891	2134	96060207000	20517	10328	8	0	2931
156892	2134	96059204000	20517	10328	9	0	2932
156893	2134	96058201000	20517	10328	10	0	2933
156894	2134	96057198000	20517	10328	12	0	2934
156896	2133	96480972000	20517	10328	14	0	2514
156897	2133	96479970000	20517	10328	15	0	2515
156898	2133	96478968000	20517	10328	16	0	2516
156899	2133	96477966000	20517	10328	17	0	2517
156900	2133	96476964000	20517	10328	18	0	2518
156902	1726	28922112000	20517	10328	20	0	8263
156903	1726	27721112000	20517	10328	21	0	8264
156904	1726	26520112000	20517	10328	22	0	8265
156915	1397	1317787913000	20520	10329	0	0	12104
156916	1397	1317777912000	20520	10329	1	0	12105
156918	2133	96474960000	20520	10329	3	0	2520
156919	2134	96055192000	20520	10329	4	0	2936
156920	2134	96054189000	20520	10329	5	0	2937
156927	1397	1317767911000	20522	10330	0	0	12106
156929	2133	96473958000	20522	10330	2	0	2521
156930	2132	148178179000	20522	10330	3	0	821
156939	1397	1317757910000	20525	10331	0	0	12107
156940	1474	14175263684843	20525	10331	1	0	23
156941	1651	19491731809512	20525	10331	2	0	7
156943	1651	16842910956157	20525	10331	4	0	9
156944	1651	12105707471846	20525	10331	5	0	10
156964	484	69864854000000	20528	10334	0	0	\N
156965	2133	96469950000	20528	10334	1	0	\N
156966	2132	148177178000	20528	10334	2	0	\N
156967	2134	96050177000	20528	10334	3	0	\N
156975	1397	1317727907000	20531	10335	0	0	\N
156976	2134	96049174000	20531	10335	1	0	\N
156977	2133	96468948000	20531	10335	2	0	\N
156978	484	68982834000000	20532	10336	0	0	\N
156979	484	68253814000000	20532	10336	1	0	\N
156980	1397	1317717906000	20532	10336	2	0	\N
156981	2133	96467946000	20532	10336	3	0	\N
156982	2134	96048171000	20532	10336	4	0	\N
156983	484	68982834000000	20533	10336	0	0	\N
156984	484	68253814000000	20533	10336	1	0	\N
156985	1397	1317717906000	20533	10336	2	0	\N
156986	2133	96467946000	20533	10336	3	0	\N
156987	2134	96048171000	20533	10336	4	0	\N
156988	484	68982834000000	20534	10336	0	0	\N
156989	484	68253814000000	20534	10336	1	0	\N
156990	1397	1317717906000	20534	10336	2	0	\N
156991	2133	96467946000	20534	10336	3	0	\N
156992	2134	96048171000	20534	10336	4	0	\N
156998	633	77016161900000	20536	10187	0	0	\N
156999	633	72597141900000	20536	10187	1	0	\N
157000	633	69615121900000	20536	10187	2	0	\N
157001	633	67149101900000	20536	10187	3	0	\N
157002	484	71171874000000	20536	10187	4	0	\N
157003	484	69864854000000	20536	10187	5	0	\N
157004	484	68982834000000	20536	10187	6	0	\N
157005	484	68253814000000	20536	10187	7	0	\N
157006	2224	717943000000	20536	10187	8	0	\N
157007	1474	14175263684843	20536	10187	9	0	\N
157008	1397	1318497984000	20536	10187	10	0	\N
157009	1397	1318487983000	20536	10187	11	0	\N
157010	1397	1318477982000	20536	10187	12	0	\N
157011	1397	1318467981000	20536	10187	13	0	\N
157012	1702	1044352000000	20536	10187	14	0	\N
157013	1397	1318457980000	20536	10187	15	0	\N
157014	1397	1318447979000	20536	10187	16	0	\N
157015	1397	1318437978000	20536	10187	17	0	\N
157016	1397	1318427977000	20536	10187	18	0	\N
157017	1703	10080817000000	20536	10187	19	0	\N
157018	1703	807000000	20536	10187	20	0	\N
157019	1397	1317707905000	20537	10337	0	0	\N
157020	1397	1317697904000	20537	10337	1	0	\N
157021	2132	148176177000	20537	10337	2	0	\N
157022	2134	96047168000	20537	10337	3	0	\N
157023	2133	96466944000	20537	10337	4	0	\N
157024	2133	96465942000	20537	10337	5	0	\N
157057	1397	1317617896000	20545	10344	0	0	\N
157058	2134	96040147000	20545	10344	1	0	\N
157059	2133	96457926000	20545	10344	2	0	\N
157063	1397	1317617896000	20547	10344	0	0	\N
157064	2134	96040147000	20547	10344	1	0	\N
157065	2133	96457926000	20547	10344	2	0	\N
157073	1397	1317587893000	20552	10347	0	0	\N
157074	2134	96037138000	20552	10347	1	0	\N
157075	2133	96454920000	20552	10347	2	0	\N
157076	1397	1317587893000	20553	10347	0	0	\N
157077	2134	96037138000	20553	10347	1	0	\N
157078	2133	96454920000	20553	10347	2	0	\N
156947	641	80581888200000	20525	10331	8	0	13
156948	641	78484811600000	20525	10331	9	0	14
156949	641	71419569400000	20525	10331	10	0	15
156950	1718	9110300707068	20525	10331	11	0	10
156951	641	68883570000000	20525	10331	12	0	16
156953	1397	1317747909000	20526	10332	1	0	12108
156954	1651	8909418632720	20526	10332	2	0	11
156955	2133	96471954000	20526	10332	3	0	2523
156956	1718	6822772367516	20526	10332	4	0	11
156957	1718	5279331089318	20526	10332	5	0	12
156959	2134	96052183000	20526	10332	7	0	2939
156960	484	71171874000000	20527	10333	0	0	5
156961	1397	1317737908000	20527	10333	1	0	12109
156962	2134	96051180000	20527	10333	2	0	2940
156968	484	69864854000000	20529	10334	0	0	6
156969	2133	96469950000	20529	10334	1	0	2525
156970	2132	148177178000	20529	10334	2	0	822
156971	2134	96050177000	20529	10334	3	0	2941
156972	1397	1317727907000	20530	10335	0	0	12110
156974	2133	96468948000	20530	10335	2	0	2526
156993	484	68982834000000	20535	10336	0	0	7
156994	484	68253814000000	20535	10336	1	0	8
156995	1397	1317717906000	20535	10336	2	0	12111
156996	2133	96467946000	20535	10336	3	0	2527
157025	1397	1317707905000	20538	10337	0	0	12112
157026	1397	1317697904000	20538	10337	1	0	12113
157027	2132	148176177000	20538	10337	2	0	823
157028	2134	96047168000	20538	10337	3	0	2944
157030	2133	96465942000	20538	10337	5	0	2529
157031	1397	1317687903000	20539	10338	0	0	12114
157032	2134	96046165000	20539	10338	1	0	2945
157033	2133	96464940000	20539	10338	2	0	2530
157034	1397	1317677902000	20540	10339	0	0	12115
157036	2133	96463938000	20540	10339	2	0	2531
157037	2134	96045162000	20540	10339	3	0	2946
157038	2132	148175176000	20540	10339	4	0	824
157039	1397	1317667901000	20541	10340	0	0	12116
157040	2133	96462936000	20541	10340	1	0	2532
157042	2134	96044159000	20542	10341	1	0	2947
157043	1958	3599186000000	20542	10341	2	0	3
157044	2133	96461934000	20542	10341	3	0	2533
157045	1651	2693450231	20543	10342	0	0	12
157047	1397	1317647899000	20543	10342	2	0	12118
157048	1397	1317637898000	20543	10342	3	0	12119
157049	2134	96043156000	20543	10342	4	0	2948
157050	2132	148174175000	20543	10342	5	0	825
157051	2133	96460932000	20543	10342	6	0	2534
157053	2133	96459930000	20543	10342	8	0	2535
157054	1397	1317627897000	20544	10343	0	0	12120
157055	2133	96458928000	20544	10343	1	0	2536
157056	2134	96041150000	20544	10343	2	0	2950
157060	1397	1317617896000	20546	10344	0	0	12121
157062	2133	96457926000	20546	10344	2	0	2537
157066	1397	1317607895000	20551	10346	0	0	12122
157067	1397	1317597894000	20551	10346	1	0	12123
157068	2132	148173174000	20551	10346	2	0	826
157070	2134	96038141000	20551	10346	4	0	2953
157071	2133	96456924000	20551	10346	5	0	2538
157072	2133	96455922000	20551	10346	6	0	2539
157079	1397	1317587893000	20554	10347	0	0	12124
157080	2134	96037138000	20554	10347	1	0	2954
157086	1397	1317577892000	20556	10348	0	0	\N
157087	2134	96036135000	20556	10348	1	0	\N
157088	2133	96453918000	20556	10348	2	0	\N
157089	2132	148172173000	20556	10348	3	0	\N
157090	1397	1317577892000	20557	10348	0	0	\N
157091	2134	96036135000	20557	10348	1	0	\N
157092	2132	148172173000	20557	10348	2	0	\N
157107	633	77736186900000	20559	10228	0	0	\N
157108	633	73317166900000	20559	10228	1	0	\N
157109	633	70335146900000	20559	10228	2	0	\N
157110	633	67869126900000	20559	10228	3	0	\N
157111	484	71171874000000	20559	10228	4	0	\N
157112	484	69864854000000	20559	10228	5	0	\N
157113	484	68982834000000	20559	10228	6	0	\N
157114	484	68253814000000	20559	10228	7	0	\N
157115	2179	190000000	20559	10228	8	0	\N
157116	2224	717943000000	20559	10228	9	0	\N
157117	1474	14175263684843	20559	10228	10	0	\N
157118	1702	1044352000000	20559	10228	11	0	\N
157119	1634	20330625710383	20559	10228	12	0	\N
157120	1634	20319748909139	20559	10228	13	0	\N
157121	1634	20011394591144	20559	10228	15	0	\N
157122	1634	19703040273149	20559	10228	16	0	\N
157123	1634	19394685955154	20559	10228	17	0	\N
157124	1703	10080817000000	20559	10228	18	0	\N
157125	1703	807000000	20559	10228	19	0	\N
157126	1474	10849153951023	20559	10228	20	0	\N
157127	1474	8604958183403	20559	10228	21	0	\N
157128	1474	2351325000043	20559	10228	22	0	\N
157129	1634	17108231728828	20559	10228	23	0	\N
157130	1634	13010933265508	20559	10228	24	0	\N
157131	1634	10246401095072	20559	10228	25	0	\N
157132	1634	2542804259504	20559	10228	26	0	\N
157133	1958	3599186000000	20559	10228	27	0	\N
157134	1991	22468659338131	20559	10228	28	0	\N
157135	1993	1668400389290	20559	10228	29	0	\N
157136	1680	17001790346879	20559	10228	30	0	\N
157137	1991	22141189234787	20559	10228	31	0	\N
157138	1726	38530112000	20559	10228	32	0	\N
157139	1726	37329112000	20559	10228	33	0	\N
157140	1726	36128112000	20559	10228	34	0	\N
157141	1726	34927112000	20559	10228	35	0	\N
157142	1726	33726112000	20559	10228	36	0	\N
157143	1726	32525112000	20559	10228	37	0	\N
157144	1726	31324112000	20559	10228	38	0	\N
157145	641	80581888200000	20559	10228	39	0	\N
157146	641	78484811600000	20559	10228	40	0	\N
157147	641	71419569400000	20559	10228	41	0	\N
157148	1991	21813719131443	20559	10228	42	0	\N
157149	1991	21486249028099	20559	10228	43	0	\N
157150	1991	21158778924755	20559	10228	44	0	\N
157151	1991	18665325533665	20559	10228	45	0	\N
157152	1991	14197079212725	20559	10228	46	0	\N
157153	1991	11182264058615	20559	10228	47	0	\N
157154	1718	9110300707068	20559	10228	48	0	\N
157155	1718	6822772367516	20559	10228	49	0	\N
157156	1718	5279331089318	20559	10228	50	0	\N
157157	1718	978396519070	20559	10228	51	0	\N
157158	1680	14813455536127	20559	10228	52	0	\N
157159	1680	10891979096895	20559	10228	53	0	\N
157160	1680	8246080477127	20559	10228	54	0	\N
157161	1680	873050499559	20559	10228	55	0	\N
157162	1726	30123112000	20559	10228	56	0	\N
157163	1726	28922112000	20559	10228	57	0	\N
157164	1726	27721112000	20559	10228	58	0	\N
157165	1726	26520112000	20559	10228	59	0	\N
157166	641	68883570000000	20559	10228	60	0	\N
157167	1991	2781215355805	20559	10228	61	0	\N
157168	1397	1317567891000	20560	10349	0	0	\N
157169	1634	22490692710383	20560	10349	1	0	\N
157170	1634	22479815909139	20560	10349	2	0	\N
157171	1634	22171461591144	20560	10349	3	0	\N
157172	1634	21863107273149	20560	10349	4	0	\N
157173	1634	21554752955154	20560	10349	5	0	\N
157174	1634	19268298728828	20560	10349	6	0	\N
157175	1634	15171000265508	20560	10349	7	0	\N
157176	1634	12406468095072	20560	10349	8	0	\N
157177	1634	4702871259504	20560	10349	9	0	\N
157178	1397	1317557890000	20560	10349	10	0	\N
157179	2134	96035132000	20560	10349	11	0	\N
157180	2133	96452916000	20560	10349	12	0	\N
157181	2133	96451914000	20560	10349	13	0	\N
157185	2134	96034129000	20562	10350	0	0	\N
157186	2133	96450912000	20562	10350	1	0	\N
157187	1397	1317547889000	20563	10350	0	0	\N
157188	2134	96034129000	20563	10350	1	0	\N
157189	2133	96450912000	20563	10350	2	0	\N
157198	1702	720354000000	20566	10351	0	0	\N
157199	1397	1317537888000	20566	10351	1	0	\N
157200	1397	1317527887000	20566	10351	2	0	\N
157201	2132	148171172000	20566	10351	3	0	\N
157202	2133	96449910000	20566	10351	4	0	\N
157203	2134	96033126000	20566	10351	5	0	\N
157204	2134	96032123000	20566	10351	6	0	\N
157205	2133	96448908000	20566	10351	7	0	\N
157206	1702	720354000000	20567	10351	0	0	\N
157207	1397	1317537888000	20567	10351	1	0	\N
157208	1397	1317527887000	20567	10351	2	0	\N
157209	2132	148171172000	20567	10351	3	0	\N
157210	2133	96449910000	20567	10351	4	0	\N
157211	2134	96033126000	20567	10351	5	0	\N
157212	2134	96032123000	20567	10351	6	0	\N
157213	2133	96448908000	20567	10351	7	0	\N
157214	1702	720354000000	20568	10351	0	0	\N
157215	1397	1317537888000	20568	10351	1	0	\N
157216	1397	1317527887000	20568	10351	2	0	\N
157083	2134	96036135000	20555	10348	1	0	2955
157084	2133	96453918000	20555	10348	2	0	2541
157085	2132	148172173000	20555	10348	3	0	827
157093	1397	1317567891000	20558	10349	0	0	12126
157094	1634	22490692710383	20558	10349	1	0	10
157096	1634	22171461591144	20558	10349	3	0	12
157097	1634	21863107273149	20558	10349	4	0	13
157098	1634	21554752955154	20558	10349	5	0	14
157099	1634	19268298728828	20558	10349	6	0	15
157100	1634	15171000265508	20558	10349	7	0	16
157102	1634	4702871259504	20558	10349	9	0	18
157103	1397	1317557890000	20558	10349	10	0	12127
157104	2134	96035132000	20558	10349	11	0	2956
157105	2133	96452916000	20558	10349	12	0	2542
157182	1397	1317547889000	20561	10350	0	0	12128
157183	2134	96034129000	20561	10350	1	0	2957
157184	2133	96450912000	20561	10350	2	0	2544
157190	1702	720354000000	20565	10351	0	0	5
157191	1397	1317537888000	20565	10351	1	0	12129
157193	2132	148171172000	20565	10351	3	0	828
157194	2133	96449910000	20565	10351	4	0	2545
157195	2134	96033126000	20565	10351	5	0	2958
157196	2134	96032123000	20565	10351	6	0	2959
157197	2133	96448908000	20565	10351	7	0	2546
157217	2132	148171172000	20568	10351	3	0	\N
157218	2133	96449910000	20568	10351	4	0	\N
157219	2134	96033126000	20568	10351	5	0	\N
157220	2134	96032123000	20568	10351	6	0	\N
157221	2133	96448908000	20568	10351	7	0	\N
157222	1702	720354000000	20569	10351	0	0	\N
157223	1397	1317537888000	20569	10351	1	0	\N
157224	1397	1317527887000	20569	10351	2	0	\N
157225	2132	148171172000	20569	10351	3	0	\N
157226	2133	96449910000	20569	10351	4	0	\N
157227	2134	96033126000	20569	10351	5	0	\N
157228	2134	96032123000	20569	10351	6	0	\N
157229	2133	96448908000	20569	10351	7	0	\N
157230	1702	720354000000	20570	10351	0	0	\N
157231	1397	1317537888000	20570	10351	1	0	\N
157232	1397	1317527887000	20570	10351	2	0	\N
157233	2132	148171172000	20570	10351	3	0	\N
157234	2133	96449910000	20570	10351	4	0	\N
157235	2134	96033126000	20570	10351	5	0	\N
157236	2134	96032123000	20570	10351	6	0	\N
157237	2133	96448908000	20570	10351	7	0	\N
157238	1702	720354000000	20571	10351	0	0	\N
157239	2132	148171172000	20571	10351	1	0	\N
157240	2133	96449910000	20571	10351	2	0	\N
157241	2134	96033126000	20571	10351	3	0	\N
157242	2134	96032123000	20571	10351	4	0	\N
157243	2133	96448908000	20571	10351	5	0	\N
157244	1702	720354000000	20572	10351	0	0	\N
157245	1397	1317537888000	20572	10351	1	0	\N
157246	1397	1317527887000	20572	10351	2	0	\N
157247	2132	148171172000	20572	10351	3	0	\N
157248	2133	96449910000	20572	10351	4	0	\N
157249	2134	96033126000	20572	10351	5	0	\N
157250	2134	96032123000	20572	10351	6	0	\N
157251	2133	96448908000	20572	10351	7	0	\N
157252	484	71171874000000	20573	10314	0	0	\N
157253	484	69864854000000	20573	10314	1	0	\N
157254	484	68982834000000	20573	10314	2	0	\N
157255	484	68253814000000	20573	10314	3	0	\N
157256	2179	190000000	20573	10314	4	0	\N
157257	1474	14175263684843	20573	10314	5	0	\N
157258	1702	1044352000000	20573	10314	6	0	\N
157259	1702	342000000	20573	10314	7	0	\N
157260	1634	21770660710383	20573	10314	8	0	\N
157261	1634	21759783909139	20573	10314	9	0	\N
157262	1634	21451429591144	20573	10314	10	0	\N
157263	1634	21143075273149	20573	10314	11	0	\N
157264	1634	20834720955154	20573	10314	12	0	\N
157265	1651	19491731809512	20573	10314	13	0	\N
157266	1651	19486456745295	20573	10314	14	0	\N
157267	1651	16842910956157	20573	10314	15	0	\N
157268	1651	12105707471846	20573	10314	16	0	\N
157269	1474	10849153951023	20573	10314	17	0	\N
157270	1474	8604958183403	20573	10314	18	0	\N
157271	1474	2351325000043	20573	10314	19	0	\N
157272	1634	18548266728828	20573	10314	20	0	\N
157273	1634	14450968265508	20573	10314	21	0	\N
157274	1634	11686436095072	20573	10314	22	0	\N
157275	1634	3982839259504	20573	10314	23	0	\N
157276	1397	1317997934000	20573	10314	24	0	\N
157277	1397	1317987933000	20573	10314	25	0	\N
157278	1397	1317977932000	20573	10314	26	0	\N
157279	1397	1317967931000	20573	10314	27	0	\N
157280	1397	1317957930000	20573	10314	28	0	\N
157281	1397	1317947929000	20573	10314	29	0	\N
157282	1397	1317937928000	20573	10314	30	0	\N
157283	1397	1317927927000	20573	10314	31	0	\N
157284	1397	1317917926000	20573	10314	32	0	\N
157285	1397	1317907925000	20573	10314	33	0	\N
157286	1397	1317897924000	20573	10314	34	0	\N
157287	1397	1317887923000	20573	10314	35	0	\N
157288	1397	1317877922000	20573	10314	36	0	\N
157289	1397	1317867921000	20573	10314	37	0	\N
157290	1397	1317857920000	20573	10314	38	0	\N
157291	1397	1317847919000	20573	10314	39	0	\N
157292	1397	1317837918000	20573	10314	40	0	\N
157293	1397	1317827917000	20573	10314	41	0	\N
157294	1397	1317817916000	20573	10314	42	0	\N
157295	1397	1317807915000	20573	10314	43	0	\N
157296	1397	1317797914000	20573	10314	44	0	\N
157297	1397	1317787913000	20573	10314	45	0	\N
157298	1397	1317777912000	20573	10314	46	0	\N
157299	1397	1317767911000	20573	10314	47	0	\N
157300	1397	1317757910000	20573	10314	48	0	\N
157301	1397	1317747909000	20573	10314	49	0	\N
157302	1397	1317737908000	20573	10314	50	0	\N
157303	1397	1317727907000	20573	10314	51	0	\N
157304	1397	1317717906000	20573	10314	52	0	\N
157305	1397	1317707905000	20573	10314	53	0	\N
157306	1397	1317697904000	20573	10314	54	0	\N
157307	1397	1317687903000	20573	10314	55	0	\N
157308	1397	1317677902000	20573	10314	56	0	\N
157309	1397	1317667901000	20573	10314	57	0	\N
157310	1397	1317657900000	20573	10314	58	0	\N
157311	1397	1317647899000	20573	10314	59	0	\N
157312	1397	1317637898000	20573	10314	60	0	\N
157313	1397	1317627897000	20573	10314	61	0	\N
157314	1397	1317617896000	20573	10314	62	0	\N
157315	1397	1317607895000	20573	10314	63	0	\N
157316	1397	1317597894000	20573	10314	64	0	\N
157317	1397	1317587893000	20573	10314	65	0	\N
157318	1397	1317577892000	20573	10314	66	0	\N
157319	1397	1317567891000	20573	10314	67	0	\N
157320	1397	1317557890000	20573	10314	68	0	\N
157321	1397	1317547889000	20573	10314	69	0	\N
157322	1397	1317537888000	20573	10314	70	0	\N
157323	1397	1317527887000	20573	10314	71	0	\N
157324	1958	3599186000000	20573	10314	72	0	\N
157325	1726	31324112000	20573	10314	73	0	\N
157326	2132	148184185000	20573	10314	74	0	\N
157327	2132	148183184000	20573	10314	75	0	\N
157328	2132	148182183000	20573	10314	76	0	\N
157329	2132	148181182000	20573	10314	77	0	\N
157330	2132	148180181000	20573	10314	78	0	\N
157331	2132	148179180000	20573	10314	79	0	\N
157332	641	80581888200000	20573	10314	80	0	\N
157333	641	78484811600000	20573	10314	81	0	\N
157334	641	71419569400000	20573	10314	82	0	\N
157335	1718	9110300707068	20573	10314	83	0	\N
157336	1718	6822772367516	20573	10314	84	0	\N
157337	1718	5279331089318	20573	10314	85	0	\N
157338	1718	978396519070	20573	10314	86	0	\N
157339	2133	96496002000	20573	10314	87	0	\N
157340	2133	96495000000	20573	10314	88	0	\N
157341	2133	96493998000	20573	10314	90	0	\N
157342	2133	96492996000	20573	10314	91	0	\N
157343	2134	96074249000	20573	10314	92	0	\N
157344	2134	96073246000	20573	10314	93	0	\N
157345	2134	96072243000	20573	10314	94	0	\N
157346	2134	96071240000	20573	10314	95	0	\N
157347	2134	96070237000	20573	10314	96	0	\N
157348	2134	96069234000	20573	10314	97	0	\N
157349	2134	96068231000	20573	10314	98	0	\N
157352	2134	96031120000	20574	10352	2	0	2960
157354	2179	90000000	20575	10353	0	0	\N
157355	1397	1317507885000	20575	10353	1	0	\N
157356	2132	148170171000	20575	10353	2	0	\N
157357	2133	96446904000	20575	10353	3	0	\N
157362	1397	1317497884000	20577	10354	0	0	\N
157363	2134	96030117000	20577	10354	1	0	\N
157364	2133	96445902000	20577	10354	2	0	\N
157365	1397	1317497884000	20578	10354	0	0	\N
157366	2134	96030117000	20578	10354	1	0	\N
157367	2133	96445902000	20578	10354	2	0	\N
157368	633	77736186900000	20579	10248	0	0	\N
157369	633	73317166900000	20579	10248	1	0	\N
157370	633	70335146900000	20579	10248	2	0	\N
157371	633	67869126900000	20579	10248	3	0	\N
157372	484	71171874000000	20579	10248	4	0	\N
157373	484	69864854000000	20579	10248	5	0	\N
157374	484	68982834000000	20579	10248	6	0	\N
157375	484	68253814000000	20579	10248	7	0	\N
157376	1397	1318077942000	20579	10248	8	0	\N
157377	2179	190000000	20579	10248	9	0	\N
157378	1397	1318067941000	20579	10248	10	0	\N
157379	1397	1318057940000	20579	10248	11	0	\N
157380	1474	14175263684843	20579	10248	12	0	\N
157381	1702	1044352000000	20579	10248	13	0	\N
157382	1702	342000000	20579	10248	14	0	\N
157383	1634	21050649710383	20579	10248	15	0	\N
157384	1634	21039772909139	20579	10248	16	0	\N
157385	1634	20731418591144	20579	10248	17	0	\N
157386	1634	20423064273149	20579	10248	18	0	\N
157387	1634	20114709955154	20579	10248	19	0	\N
157388	1703	807000000	20579	10248	20	0	\N
157389	1397	1318047939000	20579	10248	21	0	\N
157390	1397	1318037938000	20579	10248	22	0	\N
157391	1397	1318027937000	20579	10248	23	0	\N
157392	1397	1318017936000	20579	10248	24	0	\N
157393	1397	1318007935000	20579	10248	25	0	\N
157394	1474	10849153951023	20579	10248	26	0	\N
157395	1474	8604958183403	20579	10248	27	0	\N
157396	1474	2351325000043	20579	10248	28	0	\N
157397	1634	17828255728828	20579	10248	29	0	\N
157398	1634	13730957265508	20579	10248	30	0	\N
157399	1634	10966425095072	20579	10248	31	0	\N
157400	1634	3262828259504	20579	10248	32	0	\N
157401	1397	1317997934000	20579	10248	33	0	\N
157402	1397	1317987933000	20579	10248	34	0	\N
157403	1397	1317977932000	20579	10248	35	0	\N
157404	1397	1317967931000	20579	10248	36	0	\N
157405	1397	1317957930000	20579	10248	37	0	\N
157406	1397	1317947929000	20579	10248	38	0	\N
157407	1397	1317937928000	20579	10248	39	0	\N
157408	1397	1317927927000	20579	10248	40	0	\N
157409	1397	1317917926000	20579	10248	41	0	\N
157410	1397	1317907925000	20579	10248	42	0	\N
157411	1397	1317897924000	20579	10248	43	0	\N
157412	1397	1317887923000	20579	10248	44	0	\N
157413	1397	1317877922000	20579	10248	45	0	\N
157414	1397	1317867921000	20579	10248	46	0	\N
157415	1397	1317857920000	20579	10248	47	0	\N
157416	1397	1317847919000	20579	10248	48	0	\N
157417	1397	1317837918000	20579	10248	49	0	\N
157418	1397	1317827917000	20579	10248	50	0	\N
157419	1397	1317817916000	20579	10248	51	0	\N
157420	1397	1317807915000	20579	10248	52	0	\N
157421	1397	1317797914000	20579	10248	53	0	\N
157422	1397	1317787913000	20579	10248	54	0	\N
157423	1397	1317777912000	20579	10248	55	0	\N
157424	1397	1317767911000	20579	10248	56	0	\N
157425	1397	1317757910000	20579	10248	57	0	\N
157426	1397	1317747909000	20579	10248	58	0	\N
157427	1397	1317737908000	20579	10248	59	0	\N
157428	1397	1317727907000	20579	10248	60	0	\N
157429	1397	1317717906000	20579	10248	61	0	\N
157430	1397	1317707905000	20579	10248	62	0	\N
157431	1397	1317697904000	20579	10248	63	0	\N
157432	1397	1317687903000	20579	10248	64	0	\N
157433	1397	1317677902000	20579	10248	65	0	\N
157434	1397	1317667901000	20579	10248	67	0	\N
157435	1397	1317657900000	20579	10248	68	0	\N
157436	1397	1317647899000	20579	10248	69	0	\N
157437	1397	1317637898000	20579	10248	70	0	\N
157438	1397	1317627897000	20579	10248	71	0	\N
157439	1397	1317617896000	20579	10248	72	0	\N
157440	1397	1317607895000	20579	10248	73	0	\N
157441	1397	1317597894000	20579	10248	74	0	\N
157442	1397	1317587893000	20579	10248	75	0	\N
157443	1397	1317577892000	20579	10248	76	0	\N
157444	1397	1317567891000	20579	10248	77	0	\N
157445	1397	1317557890000	20579	10248	78	0	\N
157446	1397	1317547889000	20579	10248	79	0	\N
157447	1397	1317537888000	20579	10248	80	0	\N
157448	1397	1317527887000	20579	10248	81	0	\N
157449	1397	1317517886000	20579	10248	82	0	\N
157450	1397	1317507885000	20579	10248	83	0	\N
157451	1397	1317497884000	20579	10248	84	0	\N
157452	2132	148187188000	20579	10248	85	0	\N
157453	1958	3599186000000	20579	10248	86	0	\N
157454	2133	96532074000	20579	10248	87	0	\N
157455	2133	96531072000	20579	10248	88	0	\N
157456	1726	32525112000	20579	10248	89	0	\N
157457	1726	31324112000	20579	10248	90	0	\N
157458	641	80581888200000	20579	10248	91	0	\N
157459	641	78484811600000	20579	10248	92	0	\N
157460	641	71419569400000	20579	10248	93	0	\N
157461	2132	148186187000	20579	10248	94	0	\N
157462	2132	148185186000	20579	10248	95	0	\N
157463	2132	148184185000	20579	10248	96	0	\N
157464	2132	148183184000	20579	10248	97	0	\N
157465	2132	148182183000	20579	10248	98	0	\N
157466	2132	148181182000	20579	10248	99	0	\N
157467	2132	148180181000	20579	10248	100	0	\N
157468	1397	1317497884000	20580	10354	0	0	\N
157469	2134	96030117000	20580	10354	1	0	\N
157470	2133	96445902000	20580	10354	2	0	\N
157474	171	79968490851086	20582	10355	0	0	\N
157475	1397	1317487883000	20582	10355	1	0	\N
157476	1397	1317477882000	20582	10355	2	0	\N
157477	2132	148169170000	20582	10355	3	0	\N
157478	2134	96029114000	20582	10355	4	0	\N
157479	2133	96444900000	20582	10355	5	0	\N
157480	2133	96443898000	20582	10355	6	0	\N
157481	2134	96028111000	20582	10355	7	0	\N
157359	1397	1317507885000	20576	10353	1	0	12132
157360	2132	148170171000	20576	10353	2	0	829
157361	2133	96446904000	20576	10353	3	0	2548
157471	1397	1317497884000	20581	10354	0	0	12133
157472	2134	96030117000	20581	10354	1	0	2961
157482	171	79968490851086	20583	10355	0	0	5
157483	1397	1317487883000	20583	10355	1	0	12134
157484	1397	1317477882000	20583	10355	2	0	12135
157485	2132	148169170000	20583	10355	3	0	830
157486	2134	96029114000	20583	10355	4	0	2962
157488	2134	96028111000	20583	10355	6	0	2963
157499	1397	1317467881000	20585	10356	0	0	\N
157500	1506	12997246967172	20585	10356	1	0	\N
157501	171	76631714541976	20585	10356	2	0	\N
157502	171	74380321823457	20585	10356	3	0	\N
157503	171	68106633696494	20585	10356	4	0	\N
157504	1506	7159736967172	20585	10356	5	0	\N
157505	1506	4054926967172	20585	10356	6	0	\N
157506	1506	1960016967172	20585	10356	7	0	\N
157507	2134	96027108000	20585	10356	8	0	\N
157508	2133	96443898000	20585	10356	9	0	\N
157509	1397	1317467881000	20586	10356	0	0	\N
157510	1506	12997246967172	20586	10356	1	0	\N
157511	171	76631714541976	20586	10356	2	0	\N
157512	171	74380321823457	20586	10356	3	0	\N
157513	171	68106633696494	20586	10356	4	0	\N
157514	1506	7159736967172	20586	10356	5	0	\N
157515	1506	4054926967172	20586	10356	6	0	\N
157516	1506	1960016967172	20586	10356	7	0	\N
157517	2134	96027108000	20586	10356	8	0	\N
157518	2133	96443898000	20586	10356	9	0	\N
157519	1397	1317457880000	20587	10357	0	0	\N
157520	1506	1732576967172	20587	10357	1	0	\N
157521	2133	96442896000	20587	10357	2	0	\N
157522	2134	96026105000	20587	10357	3	0	\N
157527	1397	1317457880000	20589	10357	0	0	\N
157528	1506	1732576967172	20589	10357	1	0	\N
157529	2133	96442896000	20589	10357	2	0	\N
157530	2134	96026105000	20589	10357	3	0	\N
157531	1397	1317457880000	20590	10357	0	0	\N
157532	2133	96442896000	20590	10357	1	0	\N
157533	2134	96026105000	20590	10357	2	0	\N
157534	1397	1317447879000	20591	10358	0	0	\N
157535	2134	96025102000	20591	10358	1	0	\N
157536	2133	96441894000	20591	10358	2	0	\N
157546	1440	17819353045924	20594	10359	0	0	\N
157547	1397	1317437878000	20594	10359	1	0	\N
157548	2132	148168169000	20594	10359	2	0	\N
157549	2133	96440892000	20594	10359	3	0	\N
157550	1440	17819353045924	20595	10359	0	0	\N
157551	1440	10002643045924	20595	10359	1	0	\N
157552	1397	1317437878000	20595	10359	2	0	\N
157553	2134	96024099000	20595	10359	3	0	\N
157554	2132	148168169000	20595	10359	4	0	\N
157555	2133	96440892000	20595	10359	5	0	\N
157556	484	71171874000000	20596	10332	0	0	\N
157557	484	69864854000000	20596	10332	1	0	\N
157558	484	68982834000000	20596	10332	2	0	\N
157559	484	68253814000000	20596	10332	3	0	\N
157560	1440	17819353045924	20596	10332	4	0	\N
157561	171	79968490851086	20596	10332	5	0	\N
157562	2179	190000000	20596	10332	6	0	\N
157563	1702	342000000	20596	10332	7	0	\N
157564	1440	10002643045924	20596	10332	8	0	\N
157565	1506	12997246967172	20596	10332	9	0	\N
157566	171	76631714541976	20596	10332	10	0	\N
157567	171	74380321823457	20596	10332	11	0	\N
157568	171	68106633696494	20596	10332	12	0	\N
157569	1474	8604958183403	20596	10332	13	0	\N
157570	1634	21770660710383	20596	10332	14	0	\N
157571	1634	21759783909139	20596	10332	15	0	\N
157572	1634	21451429591144	20596	10332	16	0	\N
157573	1634	21143075273149	20596	10332	17	0	\N
157574	1634	20834720955154	20596	10332	18	0	\N
157575	1440	5845133045924	20596	10332	19	0	\N
157576	1440	3039923045924	20596	10332	20	0	\N
157577	1506	7159736967172	20596	10332	21	0	\N
157578	1506	4054926967172	20596	10332	22	0	\N
157579	1506	1960016967172	20596	10332	23	0	\N
157580	1506	227406967172	20596	10332	24	0	\N
157581	1440	719883045924	20596	10332	25	0	\N
157582	1397	1317747909000	20596	10332	26	0	\N
157583	1397	1317737908000	20596	10332	27	0	\N
157584	1397	1317727907000	20596	10332	28	0	\N
157585	1397	1317717906000	20596	10332	29	0	\N
157586	1397	1317707905000	20596	10332	30	0	\N
157587	1397	1317697904000	20596	10332	31	0	\N
157588	1397	1317687903000	20596	10332	32	0	\N
157589	1397	1317677902000	20596	10332	33	0	\N
157590	1397	1317667901000	20596	10332	34	0	\N
157591	1397	1317657900000	20596	10332	35	0	\N
157592	1397	1317647899000	20596	10332	36	0	\N
157593	1397	1317637898000	20596	10332	37	0	\N
157594	1397	1317627897000	20596	10332	38	0	\N
157595	1397	1317617896000	20596	10332	39	0	\N
157596	1397	1317607895000	20596	10332	40	0	\N
157597	1397	1317597894000	20596	10332	41	0	\N
157598	1474	2350325000043	20596	10332	42	0	\N
157599	1634	18548266728828	20596	10332	43	0	\N
157600	1634	14450968265508	20596	10332	44	0	\N
157601	1634	11686436095072	20596	10332	45	0	\N
157602	1634	3982839259504	20596	10332	46	0	\N
157603	1651	8909418632720	20596	10332	47	0	\N
157604	1651	2693450231	20596	10332	48	0	\N
157605	1397	1317587893000	20596	10332	49	0	\N
157606	1397	1317577892000	20596	10332	50	0	\N
157607	1397	1317567891000	20596	10332	51	0	\N
157608	1397	1317557890000	20596	10332	52	0	\N
157609	1397	1317547889000	20596	10332	53	0	\N
157610	1397	1317537888000	20596	10332	54	0	\N
157611	1397	1317527887000	20596	10332	55	0	\N
157612	1397	1317517886000	20596	10332	56	0	\N
157613	1397	1317507885000	20596	10332	57	0	\N
157614	1397	1317497884000	20596	10332	58	0	\N
157615	1397	1317487883000	20596	10332	59	0	\N
157616	1397	1317477882000	20596	10332	60	0	\N
157617	1397	1317467881000	20596	10332	61	0	\N
157618	1397	1317457880000	20596	10332	62	0	\N
157619	1397	1317447879000	20596	10332	63	0	\N
157620	1397	1317437878000	20596	10332	64	0	\N
157621	1397	1317427877000	20596	10332	65	0	\N
157622	2133	96471954000	20596	10332	66	0	\N
157623	1958	3599186000000	20596	10332	67	0	\N
157624	1718	6822772367516	20596	10332	68	0	\N
157491	171	76631714541976	20584	10356	2	0	6
157492	171	74380321823457	20584	10356	3	0	7
157493	171	68106633696494	20584	10356	4	0	8
157494	1506	7159736967172	20584	10356	5	0	19
157495	1506	4054926967172	20584	10356	6	0	20
157497	2134	96027108000	20584	10356	8	0	2964
157498	2133	96443898000	20584	10356	9	0	2551
157523	1397	1317457880000	20588	10357	0	0	12137
157524	1506	1732576967172	20588	10357	1	0	22
157525	2133	96442896000	20588	10357	2	0	2552
157537	1397	1317447879000	20592	10358	0	0	12138
157538	2134	96025102000	20592	10358	1	0	2966
157539	2133	96441894000	20592	10358	2	0	2553
157540	1440	17819353045924	20593	10359	0	0	7
157542	1397	1317437878000	20593	10359	2	0	12139
157543	2134	96024099000	20593	10359	3	0	2967
157544	2132	148168169000	20593	10359	4	0	831
157545	2133	96440892000	20593	10359	5	0	2554
157625	1718	5279331089318	20596	10332	69	0	\N
157626	1718	978396519070	20596	10332	70	0	\N
157627	2133	96470952000	20596	10332	71	0	\N
157628	2133	96469950000	20596	10332	72	0	\N
157629	2134	96052183000	20596	10332	73	0	\N
157630	2134	96051180000	20596	10332	74	0	\N
157631	2132	148177178000	20596	10332	75	0	\N
157632	2132	148176177000	20596	10332	76	0	\N
157633	2132	148175176000	20596	10332	77	0	\N
157634	2132	148174175000	20596	10332	78	0	\N
157635	2132	148173174000	20596	10332	79	0	\N
157636	2132	148172173000	20596	10332	80	0	\N
157637	2132	148171172000	20596	10332	81	0	\N
157638	2132	148170171000	20596	10332	82	0	\N
157639	2132	148169170000	20596	10332	83	0	\N
157640	2132	148168169000	20596	10332	84	0	\N
157641	2245	199000000	20596	10332	86	0	\N
157642	2133	96468948000	20596	10332	87	0	\N
157643	2133	96467946000	20596	10332	88	0	\N
157644	2133	96466944000	20596	10332	89	0	\N
157645	2133	96465942000	20596	10332	90	0	\N
157646	2133	96464940000	20596	10332	91	0	\N
157647	2133	96463938000	20596	10332	92	0	\N
157648	2133	96462936000	20596	10332	93	0	\N
157649	2133	96461934000	20596	10332	94	0	\N
157650	2133	96460932000	20596	10332	95	0	\N
157651	2133	96459930000	20596	10332	96	0	\N
157652	2133	96458928000	20596	10332	97	0	\N
157653	2133	96457926000	20596	10332	98	0	\N
157654	2133	96456924000	20596	10332	99	0	\N
157655	2133	96455922000	20596	10332	100	0	\N
157656	2133	96454920000	20596	10332	101	0	\N
157657	2133	96453918000	20596	10332	102	0	\N
157658	2133	96452916000	20596	10332	103	0	\N
157659	2133	96451914000	20596	10332	104	0	\N
157660	2133	96450912000	20596	10332	105	0	\N
157661	2133	96449910000	20596	10332	106	0	\N
157662	2134	96050177000	20596	10332	107	0	\N
157663	2134	96049174000	20596	10332	108	0	\N
157664	2134	96048171000	20596	10332	109	0	\N
157665	2134	96047168000	20596	10332	110	0	\N
157666	2134	96046165000	20596	10332	111	0	\N
157667	2134	96045162000	20596	10332	112	0	\N
157668	2134	96044159000	20596	10332	113	0	\N
157669	2134	96043156000	20596	10332	114	0	\N
157670	2134	96042153000	20596	10332	115	0	\N
157671	2134	96041150000	20596	10332	116	0	\N
157672	2134	96040147000	20596	10332	117	0	\N
157673	2134	96039144000	20596	10332	118	0	\N
157674	2134	96038141000	20596	10332	119	0	\N
157675	2134	96037138000	20596	10332	120	0	\N
157676	2134	96036135000	20596	10332	121	0	\N
157677	2134	96035132000	20596	10332	122	0	\N
157678	2134	96034129000	20596	10332	123	0	\N
157679	2134	96033126000	20596	10332	124	0	\N
157680	2134	96032123000	20596	10332	125	0	\N
157690	1397	1317397874000	20600	10363	0	0	\N
157691	2133	96436884000	20600	10363	1	0	\N
157692	2134	96021090000	20600	10363	2	0	\N
157696	1397	1317387873000	20602	10364	0	0	\N
157697	2133	96435882000	20602	10364	1	0	\N
157698	1397	1317387873000	20603	10364	0	0	\N
157699	2133	96435882000	20603	10364	1	0	\N
157702	2133	96435882000	20605	10364	0	0	\N
157703	1397	1317387873000	20606	10364	0	0	\N
157704	2133	96435882000	20606	10364	1	0	\N
157705	1397	1317387873000	20607	10364	0	0	\N
157706	2133	96435882000	20607	10364	1	0	\N
157707	633	77736186900000	20608	10287	0	0	\N
157708	633	73317166900000	20608	10287	1	0	\N
157709	633	70335146900000	20608	10287	2	0	\N
157710	633	67869126900000	20608	10287	3	0	\N
157711	484	71171874000000	20608	10287	4	0	\N
157712	484	69864854000000	20608	10287	5	0	\N
157713	484	68982834000000	20608	10287	6	0	\N
157714	484	68253814000000	20608	10287	7	0	\N
157715	1440	17819353045924	20608	10287	8	0	\N
157716	171	79248478851086	20608	10287	9	0	\N
157717	2179	190000000	20608	10287	10	0	\N
157718	2224	717943000000	20608	10287	11	0	\N
157719	1440	10002643045924	20608	10287	12	0	\N
157720	1506	12997246967172	20608	10287	13	0	\N
157721	171	75911702541976	20608	10287	14	0	\N
157722	171	73660309823457	20608	10287	15	0	\N
157723	171	67386621696494	20608	10287	16	0	\N
157724	1474	14175263684843	20608	10287	17	0	\N
157725	1702	1044352000000	20608	10287	18	0	\N
157726	1702	342000000	20608	10287	19	0	\N
157727	1634	21050649710383	20608	10287	20	0	\N
157728	1634	21039772909139	20608	10287	21	0	\N
157729	1634	20731418591144	20608	10287	22	0	\N
157746	1397	1317357870000	20611	10366	0	0	\N
157747	1397	1317347869000	20611	10366	1	0	\N
157748	1397	1317337868000	20611	10366	2	0	\N
157749	2132	148165166000	20611	10366	3	0	\N
157750	2134	96019084000	20611	10366	4	0	\N
157751	2134	96018081000	20611	10366	5	0	\N
157752	2133	96432876000	20611	10366	6	0	\N
157753	2133	96431874000	20611	10366	7	0	\N
157754	2133	96430872000	20611	10366	8	0	\N
157755	2134	96017078000	20611	10366	9	0	\N
157759	1397	1317327867000	20613	10367	0	0	\N
157760	2133	96429870000	20613	10367	1	0	\N
157683	1397	1317417876000	20598	10361	0	0	12141
157684	2134	96023096000	20598	10361	1	0	2968
157685	2133	96438888000	20598	10361	2	0	2556
157686	1397	1317407875000	20599	10362	0	0	12142
157687	2133	96437886000	20599	10362	1	0	2557
157689	2134	96022093000	20599	10362	3	0	2969
157693	1397	1317397874000	20601	10363	0	0	12143
157694	2133	96436884000	20601	10363	1	0	2558
157695	2134	96021090000	20601	10363	2	0	2970
157700	1397	1317387873000	20604	10364	0	0	12144
157730	1397	1317377872000	20609	10365	0	0	12145
157731	1397	1317367871000	20609	10365	1	0	12146
157732	2134	96020087000	20609	10365	2	0	2971
157733	2132	148166167000	20609	10365	3	0	833
157735	2133	96433878000	20609	10365	5	0	2561
157736	1397	1317357870000	20610	10366	0	0	12147
157737	1397	1317347869000	20610	10366	1	0	12148
157738	1397	1317337868000	20610	10366	2	0	12149
157739	2132	148165166000	20610	10366	3	0	834
157741	2134	96018081000	20610	10366	5	0	2973
157742	2133	96432876000	20610	10366	6	0	2562
157743	2133	96431874000	20610	10366	7	0	2563
157744	2133	96430872000	20610	10366	8	0	2564
157745	2134	96017078000	20610	10366	9	0	2974
157757	2133	96429870000	20612	10367	1	0	2565
157758	2134	96016075000	20612	10367	2	0	2975
157761	2134	96016075000	20613	10367	2	0	\N
157765	1397	1317317866000	20615	10368	0	0	\N
157766	2133	96428868000	20615	10368	1	0	\N
157767	2134	96015072000	20615	10368	2	0	\N
157790	1440	17819353045924	20620	10341	0	0	\N
157791	171	79968490851086	20620	10341	1	0	\N
157792	2179	190000000	20620	10341	2	0	\N
157793	1440	10002643045924	20620	10341	3	0	\N
157794	1506	12997246967172	20620	10341	4	0	\N
157795	171	76631714541976	20620	10341	5	0	\N
157796	171	74380321823457	20620	10341	6	0	\N
157797	171	68106633696494	20620	10341	7	0	\N
157798	1440	5845133045924	20620	10341	8	0	\N
157799	1440	3039923045924	20620	10341	9	0	\N
157800	1506	7159736967172	20620	10341	10	0	\N
157801	1506	4054926967172	20620	10341	11	0	\N
157802	1506	1960016967172	20620	10341	12	0	\N
157803	1506	227406967172	20620	10341	13	0	\N
157804	1440	719883045924	20620	10341	14	0	\N
157805	1958	3599186000000	20620	10341	15	0	\N
157806	1726	25319112000	20620	10341	16	0	\N
157807	1726	24118112000	20620	10341	17	0	\N
157808	1726	22917112000	20620	10341	18	0	\N
157809	2157	1199001999	20620	10341	19	0	\N
157810	2157	1198001999	20620	10341	20	0	\N
157811	2157	1197001999	20620	10341	21	0	\N
157812	2245	199000000	20620	10341	22	0	\N
157818	2179	0	20622	10374	0	0	\N
157819	2133	96421854000	20622	10374	1	0	\N
157820	2133	96420852000	20622	10374	2	0	\N
157821	2132	148162163000	20622	10374	3	0	\N
157822	2157	1195001999	20622	10374	4	0	\N
157823	2134	96009054000	20622	10374	5	0	\N
157824	2134	96008051000	20622	10374	6	0	\N
157825	1440	17819353045924	20623	10359	0	0	\N
157826	1440	10002643045924	20623	10359	1	0	\N
157827	2179	80000000	20623	10359	2	0	\N
157828	1440	5845133045924	20623	10359	3	0	\N
157829	1440	3039923045924	20623	10359	4	0	\N
157830	1440	719883045924	20623	10359	5	0	\N
157831	1397	1317437878000	20623	10359	6	0	\N
157832	1397	1317427877000	20623	10359	7	0	\N
157833	1397	1317417876000	20623	10359	8	0	\N
157834	1397	1317407875000	20623	10359	9	0	\N
157835	1397	1317397874000	20623	10359	10	0	\N
157836	1397	1317387873000	20623	10359	11	0	\N
157837	1397	1317377872000	20623	10359	12	0	\N
157838	1397	1317367871000	20623	10359	13	0	\N
157839	1397	1317357870000	20623	10359	14	0	\N
157840	1397	1317347869000	20623	10359	15	0	\N
157841	1397	1317337868000	20623	10359	16	0	\N
157842	1397	1317327867000	20623	10359	17	0	\N
157843	1397	1317317866000	20623	10359	18	0	\N
157844	1397	1317307865000	20623	10359	19	0	\N
157845	1397	1317297864000	20623	10359	20	0	\N
157846	1397	1317287863000	20623	10359	21	0	\N
157847	1397	1317277862000	20623	10359	22	0	\N
157848	1726	25319112000	20623	10359	23	0	\N
157849	1726	24118112000	20623	10359	24	0	\N
157850	1726	22917112000	20623	10359	25	0	\N
157851	2134	96024099000	20623	10359	26	0	\N
157852	2134	96023096000	20623	10359	28	0	\N
157853	2157	1199001999	20623	10359	29	0	\N
157854	2157	1198001999	20623	10359	30	0	\N
157855	2157	1197001999	20623	10359	31	0	\N
157856	2157	1196001999	20623	10359	32	0	\N
157857	2157	1195001999	20623	10359	33	0	\N
157858	1726	21716112000	20623	10359	34	0	\N
157859	1726	20515112000	20623	10359	35	0	\N
157860	1726	19314112000	20623	10359	36	0	\N
157861	2132	148168169000	20623	10359	37	0	\N
157862	2132	148167168000	20623	10359	38	0	\N
157863	2132	148166167000	20623	10359	39	0	\N
157864	2132	148165166000	20623	10359	40	0	\N
157865	2132	148164165000	20623	10359	41	0	\N
157866	2132	148163164000	20623	10359	42	0	\N
157867	2132	148162163000	20623	10359	43	0	\N
157868	2134	96022093000	20623	10359	44	0	\N
157869	2134	96021090000	20623	10359	45	0	\N
157870	2134	96020087000	20623	10359	46	0	\N
157871	2134	96019084000	20623	10359	47	0	\N
157872	2134	96018081000	20623	10359	48	0	\N
157873	2134	96017078000	20623	10359	49	0	\N
157874	2134	96016075000	20623	10359	50	0	\N
157875	2134	96015072000	20623	10359	51	0	\N
157876	2134	96014069000	20623	10359	52	0	\N
157877	2134	96013066000	20623	10359	53	0	\N
157878	2134	96012063000	20623	10359	54	0	\N
157879	2134	96011060000	20623	10359	55	0	\N
157880	2134	96010057000	20623	10359	56	0	\N
157881	2134	96009054000	20623	10359	57	0	\N
157882	2134	96008051000	20623	10359	58	0	\N
157883	2133	96440892000	20623	10359	59	0	\N
157884	2133	96439890000	20623	10359	60	0	\N
157885	2133	96438888000	20623	10359	61	0	\N
157886	2133	96437886000	20623	10359	62	0	\N
157887	2133	96436884000	20623	10359	63	0	\N
157888	2133	96435882000	20623	10359	64	0	\N
157889	2133	96434880000	20623	10359	65	0	\N
157890	2133	96433878000	20623	10359	66	0	\N
157891	2133	96432876000	20623	10359	67	0	\N
157892	2133	96431874000	20623	10359	68	0	\N
157893	2133	96430872000	20623	10359	69	0	\N
157894	2133	96429870000	20623	10359	70	0	\N
157895	2133	96428868000	20623	10359	71	0	\N
157896	2133	96427866000	20623	10359	72	0	\N
157764	2134	96015072000	20614	10368	2	0	2976
157768	1397	1317307865000	20616	10369	0	0	12152
157769	2132	148164165000	20616	10369	1	0	835
157770	2133	96427866000	20616	10369	2	0	2567
157771	2157	1199001999	20616	10369	3	0	23
157773	1397	1317297864000	20617	10370	0	0	12153
157774	1397	1317287863000	20617	10370	1	0	12154
157775	2157	1198001999	20617	10370	2	0	24
157776	2134	96013066000	20617	10370	3	0	2978
157777	2134	96012063000	20617	10370	4	0	2979
157779	2134	96011060000	20618	10371	1	0	2980
157780	2133	96426864000	20618	10371	2	0	2568
157781	2157	1197001999	20618	10371	3	0	25
157782	2133	96425862000	20618	10371	4	0	2569
157784	2132	148163164000	20618	10371	6	0	836
157785	1726	25319112000	20619	10372	0	0	8266
157786	1726	24118112000	20619	10372	1	0	8267
157787	1726	22917112000	20619	10372	2	0	8268
157788	2133	96423858000	20619	10372	3	0	2571
157813	2133	96422856000	20621	10373	0	0	2572
157814	2157	1196001999	20621	10373	1	0	26
157815	1726	21716112000	20621	10373	2	0	8269
157816	1726	20515112000	20621	10373	3	0	8270
157817	1726	19314112000	20621	10373	4	0	8271
157897	2133	96426864000	20623	10359	73	0	\N
157898	2133	96425862000	20623	10359	74	0	\N
157899	2133	96424860000	20623	10359	75	0	\N
157900	2133	96423858000	20623	10359	76	0	\N
157901	2133	96422856000	20623	10359	77	0	\N
157902	2133	96421854000	20623	10359	78	0	\N
157903	2133	96420852000	20623	10359	79	0	\N
157965	1762	8031302994000	20632	10381	0	0	\N
157966	1762	4777132994000	20632	10381	1	0	\N
157967	1762	2085282994000	20632	10381	2	0	\N
157968	1397	1317157850000	20632	10381	3	0	\N
157969	149	78978258000341	20632	10381	4	0	\N
157970	149	74820618000341	20632	10381	5	0	\N
157971	149	72015368000341	20632	10381	6	0	\N
157972	149	69695238000341	20632	10381	7	0	\N
157973	2134	95996015000	20632	10381	8	0	\N
157974	2132	148158159000	20632	10381	9	0	\N
157975	2133	96407826000	20632	10381	10	0	\N
157990	1397	1317147849000	20635	10382	0	0	\N
157991	2133	96406824000	20635	10382	1	0	\N
157992	2134	95995012000	20635	10382	2	0	\N
157999	1397	1317127847000	20638	10384	0	0	\N
158000	2133	96404820000	20638	10384	1	0	\N
158001	2132	148157158000	20638	10384	2	0	\N
158002	2134	95994009000	20638	10384	3	0	\N
158018	1397	1317067841000	20643	10389	0	0	\N
158019	2134	95988994000	20643	10389	1	0	\N
158020	2133	96398808000	20643	10389	2	0	\N
158021	1397	1317067841000	20644	10389	0	0	\N
158022	2134	95988994000	20644	10389	1	0	\N
158023	2133	96398808000	20644	10389	2	0	\N
158027	1762	12854252994000	20646	10357	0	0	\N
158028	1768	13453800110000	20646	10357	1	0	\N
158029	1768	9572000110000	20646	10357	2	0	\N
158030	1768	6953200110000	20646	10357	3	0	\N
158031	1762	8031302994000	20646	10357	4	0	\N
158032	1762	4777132994000	20646	10357	5	0	\N
157906	2133	96420852000	20625	10374	2	0	2574
157907	2132	148162163000	20625	10374	3	0	837
157908	2157	1195001999	20625	10374	4	0	27
157909	2134	96009054000	20625	10374	5	0	2982
157910	2134	96008051000	20625	10374	6	0	2983
157912	2157	1194001999	20626	10375	1	0	28
157913	2133	96419850000	20626	10375	2	0	2575
157914	2134	96007048000	20626	10375	3	0	2984
157915	2134	96006045000	20626	10375	4	0	2985
157916	2133	96418848000	20626	10375	5	0	2576
157918	2132	148161162000	20627	10376	1	0	838
157919	2134	96005042000	20627	10376	2	0	2986
157920	1602	17699144460000	20627	10376	3	0	6
157921	2133	96417846000	20627	10376	4	0	2577
157923	1397	1317237858000	20628	10377	1	0	12159
157924	1397	1317227857000	20628	10377	2	0	12160
157925	1602	13287483590000	20628	10377	3	0	7
157926	2133	96416844000	20628	10377	4	0	2578
157927	2133	96415842000	20628	10377	5	0	2579
157929	1602	10310847770000	20628	10377	7	0	8
157930	1602	2016189170000	20628	10377	8	0	9
157931	2134	96004039000	20628	10377	9	0	2987
157932	2134	96003036000	20628	10377	10	0	2988
157933	2132	148160161000	20628	10377	11	0	839
157935	1397	1317207855000	20629	10378	1	0	12162
157936	2133	96413838000	20629	10378	2	0	2581
157937	2133	96412836000	20629	10378	3	0	2582
157938	1726	18113112000	20629	10378	4	0	8272
157940	2134	96001030000	20629	10378	6	0	2990
157941	1768	13453800110000	20630	10379	0	0	7
157942	1768	9572000110000	20630	10379	1	0	8
157943	1768	6953200110000	20630	10379	2	0	9
157944	1768	4786500110000	20630	10379	3	0	10
157946	1397	1317187853000	20630	10379	5	0	12164
157947	2133	96411834000	20630	10379	6	0	2583
157948	2133	96410832000	20630	10379	7	0	2584
157949	2134	96000027000	20630	10379	8	0	2991
157950	2134	95999024000	20630	10379	10	0	2992
157952	1726	16912112000	20630	10379	12	0	8273
157953	1762	12854252994000	20631	10380	0	0	5
157954	58	90782016999641	20631	10380	1	0	8
157955	58	81422296999641	20631	10380	2	0	9
157957	1397	1317167851000	20631	10380	4	0	12166
157958	58	76444156999641	20631	10380	5	0	10
157959	58	73085296999641	20631	10380	6	0	11
157960	58	70307296999641	20631	10380	7	0	12
157961	2134	95998021000	20631	10380	8	0	2993
157963	2133	96408828000	20631	10380	10	0	2586
157964	2134	95997018000	20631	10380	11	0	2994
157976	1762	8031302994000	20633	10381	0	0	6
157977	1762	4777132994000	20633	10381	1	0	7
157978	1762	2085282994000	20633	10381	2	0	8
157980	149	78978258000341	20633	10381	4	0	6
157981	149	74820618000341	20633	10381	5	0	7
157982	149	72015368000341	20633	10381	6	0	8
157983	149	69695238000341	20633	10381	7	0	9
157985	2132	148158159000	20633	10381	9	0	841
157986	2133	96407826000	20633	10381	10	0	2587
157987	1397	1317147849000	20634	10382	0	0	12168
157988	2133	96406824000	20634	10382	1	0	2588
157989	2134	95995012000	20634	10382	2	0	2996
157994	2133	96405822000	20636	10383	1	0	2589
157995	1397	1317127847000	20637	10384	0	0	12170
157996	2133	96404820000	20637	10384	1	0	2590
157997	2132	148157158000	20637	10384	2	0	842
157998	2134	95994009000	20637	10384	3	0	2997
158004	2134	95993006000	20639	10385	1	0	2998
158005	2133	96403818000	20639	10385	2	0	2591
158006	1397	1317107845000	20640	10386	0	0	12172
158007	2134	95992003000	20640	10386	1	0	2999
158009	1397	1317097844000	20641	10387	0	0	12173
158010	1397	1317087843000	20641	10387	1	0	12174
158011	2134	95991000000	20641	10387	2	0	3000
158012	2133	96401814000	20641	10387	3	0	2593
158013	2133	96400812000	20641	10387	4	0	2594
158015	1397	1317077842000	20642	10388	0	0	12175
158016	2133	96399810000	20642	10388	1	0	2595
158017	2134	95989997000	20642	10388	2	0	3001
158024	1397	1317067841000	20645	10389	0	0	12176
158025	2134	95988994000	20645	10389	1	0	3002
158033	1762	2085282994000	20646	10357	6	0	\N
158034	1768	4786500110000	20646	10357	7	0	\N
158035	1440	17819353045924	20646	10357	8	0	\N
158036	1440	10002643045924	20646	10357	9	0	\N
158037	58	90782016999641	20646	10357	10	0	\N
158038	2179	80000000	20646	10357	11	0	\N
158039	58	81422296999641	20646	10357	12	0	\N
158040	149	78978258000341	20646	10357	13	0	\N
158041	149	74820618000341	20646	10357	14	0	\N
158042	149	72015368000341	20646	10357	15	0	\N
158043	149	69695238000341	20646	10357	16	0	\N
158044	1397	1317457880000	20646	10357	17	0	\N
158045	1397	1317447879000	20646	10357	18	0	\N
158046	1440	5845133045924	20646	10357	19	0	\N
158047	1440	3039923045924	20646	10357	20	0	\N
158048	58	76444156999641	20646	10357	21	0	\N
158049	58	73085296999641	20646	10357	22	0	\N
158050	58	70307296999641	20646	10357	23	0	\N
158051	1440	719883045924	20646	10357	24	0	\N
158052	1397	1317437878000	20646	10357	25	0	\N
158053	1397	1317427877000	20646	10357	26	0	\N
158054	1397	1317417876000	20646	10357	27	0	\N
158055	1397	1317407875000	20646	10357	28	0	\N
158056	1397	1317397874000	20646	10357	29	0	\N
158057	1397	1317387873000	20646	10357	30	0	\N
158058	1397	1317377872000	20646	10357	31	0	\N
158059	1397	1317367871000	20646	10357	32	0	\N
158060	1397	1317357870000	20646	10357	33	0	\N
158061	1397	1317347869000	20646	10357	34	0	\N
158062	1397	1317337868000	20646	10357	35	0	\N
158063	1397	1317327867000	20646	10357	36	0	\N
158064	1397	1317317866000	20646	10357	37	0	\N
158065	1397	1317307865000	20646	10357	39	0	\N
158066	1397	1317297864000	20646	10357	40	0	\N
158067	1397	1317287863000	20646	10357	41	0	\N
158068	1397	1317277862000	20646	10357	42	0	\N
158069	1397	1317267861000	20646	10357	43	0	\N
158070	1397	1317257860000	20646	10357	44	0	\N
158071	1397	1317247859000	20646	10357	45	0	\N
158072	1397	1317237858000	20646	10357	46	0	\N
158073	1397	1317227857000	20646	10357	47	0	\N
158074	1397	1317217856000	20646	10357	48	0	\N
158075	1397	1317207855000	20646	10357	49	0	\N
158076	1397	1317197854000	20646	10357	50	0	\N
158077	1397	1317187853000	20646	10357	51	0	\N
158078	1397	1317177852000	20646	10357	52	0	\N
158079	1397	1317167851000	20646	10357	53	0	\N
158080	1397	1317157850000	20646	10357	54	0	\N
158081	1397	1317147849000	20646	10357	55	0	\N
158082	1397	1317137848000	20646	10357	56	0	\N
158083	1397	1317127847000	20646	10357	57	0	\N
158084	1397	1317117846000	20646	10357	58	0	\N
158085	1397	1317107845000	20646	10357	59	0	\N
158086	1397	1317097844000	20646	10357	60	0	\N
158087	1397	1317087843000	20646	10357	61	0	\N
158088	1397	1317077842000	20646	10357	62	0	\N
158089	1397	1317067841000	20646	10357	63	0	\N
158090	1726	25319112000	20646	10357	64	0	\N
158091	1726	24118112000	20646	10357	65	0	\N
158092	1726	22917112000	20646	10357	66	0	\N
158093	2157	1199001999	20646	10357	67	0	\N
158094	2157	1198001999	20646	10357	68	0	\N
158095	2133	96442896000	20646	10357	69	0	\N
158096	2157	1197001999	20646	10357	70	0	\N
158097	2157	1196001999	20646	10357	71	0	\N
158098	1602	17699144460000	20646	10357	72	0	\N
158099	1602	13287483590000	20646	10357	73	0	\N
158100	2157	1195001999	20646	10357	74	0	\N
158101	2157	1194001999	20646	10357	75	0	\N
158102	1602	10310847770000	20646	10357	76	0	\N
158103	1602	2016189170000	20646	10357	77	0	\N
158104	1726	21716112000	20646	10357	78	0	\N
158105	1726	20515112000	20646	10357	79	0	\N
158106	1726	19314112000	20646	10357	80	0	\N
158107	2134	96026105000	20646	10357	81	0	\N
158108	2134	96025102000	20646	10357	82	0	\N
158109	2134	96024099000	20646	10357	83	0	\N
158110	2134	96023096000	20646	10357	84	0	\N
158111	2132	148168169000	20646	10357	85	0	\N
158112	2133	96441894000	20646	10357	86	0	\N
158113	2132	148167168000	20646	10357	87	0	\N
158114	2132	148166167000	20646	10357	88	0	\N
158115	2132	148165166000	20646	10357	89	0	\N
158116	2132	148164165000	20646	10357	90	0	\N
158117	2132	148163164000	20646	10357	91	0	\N
158118	2132	148162163000	20646	10357	92	0	\N
158119	2132	148161162000	20646	10357	93	0	\N
158120	1726	18113112000	20646	10357	94	0	\N
158121	1726	16912112000	20646	10357	95	0	\N
158122	2132	148160161000	20646	10357	96	0	\N
158123	2132	148159160000	20646	10357	97	0	\N
158124	2132	148158159000	20646	10357	98	0	\N
158125	2132	148157158000	20646	10357	99	0	\N
158126	2132	148156157000	20646	10357	100	0	\N
158127	2134	96022093000	20646	10357	101	0	\N
158128	2134	96021090000	20646	10357	102	0	\N
158129	2134	96020087000	20646	10357	103	0	\N
158130	2134	96019084000	20646	10357	104	0	\N
158131	2134	96018081000	20646	10357	105	0	\N
158132	2134	96017078000	20646	10357	106	0	\N
158133	2134	96016075000	20646	10357	107	0	\N
158134	2134	96015072000	20646	10357	108	0	\N
158135	2134	96014069000	20646	10357	109	0	\N
158136	2134	96013066000	20646	10357	110	0	\N
158137	2134	96012063000	20646	10357	111	0	\N
158138	2134	96011060000	20646	10357	112	0	\N
158139	2134	96010057000	20646	10357	113	0	\N
158140	2134	96009054000	20646	10357	114	0	\N
158141	2134	96008051000	20646	10357	115	0	\N
158142	2134	96007048000	20646	10357	116	0	\N
158143	2134	96006045000	20646	10357	117	0	\N
158144	2134	96005042000	20646	10357	118	0	\N
158145	2134	96004039000	20646	10357	119	0	\N
158146	2134	96003036000	20646	10357	120	0	\N
158147	2134	96002033000	20646	10357	121	0	\N
158148	2134	96001030000	20646	10357	122	0	\N
158153	1397	1317057840000	20649	10390	0	0	\N
158154	2132	148155156000	20649	10390	1	0	\N
158155	2133	96397806000	20649	10390	2	0	\N
158156	2134	95987991000	20649	10390	3	0	\N
158157	1762	12854252994000	20651	10317	0	0	\N
158158	1768	13453800110000	20651	10317	1	0	\N
158159	1768	9572000110000	20651	10317	2	0	\N
158160	1768	6953200110000	20651	10317	3	0	\N
158161	1762	8031302994000	20651	10317	4	0	\N
158162	1762	4777132994000	20651	10317	5	0	\N
158163	1762	2085282994000	20651	10317	6	0	\N
158164	1768	4786500110000	20651	10317	7	0	\N
158165	484	71171874000000	20651	10317	8	0	\N
158166	484	69864854000000	20651	10317	9	0	\N
158167	484	68982834000000	20651	10317	10	0	\N
158168	484	68253814000000	20651	10317	11	0	\N
158151	2133	96397806000	20648	10390	2	0	2597
158152	2134	95987991000	20648	10390	3	0	3003
158169	1440	17819353045924	20651	10317	12	0	\N
158170	171	79248478851086	20651	10317	13	0	\N
158171	2179	190000000	20651	10317	14	0	\N
158172	1397	1317967931000	20651	10317	15	0	\N
158173	1702	342000000	20651	10317	16	0	\N
158174	1440	10002643045924	20651	10317	17	0	\N
158175	58	90062004999641	20651	10317	18	0	\N
158176	58	80702284999641	20651	10317	19	0	\N
158177	1506	12997246967172	20651	10317	20	0	\N
158178	171	75911702541976	20651	10317	21	0	\N
158179	171	73660309823457	20651	10317	22	0	\N
158180	171	67386621696494	20651	10317	23	0	\N
158181	149	78258246000341	20651	10317	24	0	\N
158182	149	74100606000341	20651	10317	25	0	\N
158183	149	71295356000341	20651	10317	26	0	\N
158184	149	68975226000341	20651	10317	27	0	\N
158185	1397	1317957930000	20651	10317	28	0	\N
158186	1397	1317947929000	20651	10317	29	0	\N
158187	1397	1317937928000	20651	10317	30	0	\N
158188	1474	14175263684843	20651	10317	31	0	\N
158189	1397	1317927927000	20651	10317	32	0	\N
158190	1397	1317917926000	20651	10317	33	0	\N
158191	1634	21770660710383	20651	10317	34	0	\N
158192	1634	21759783909139	20651	10317	35	0	\N
158193	1634	21451429591144	20651	10317	36	0	\N
158194	1634	21143075273149	20651	10317	37	0	\N
158195	1634	20834720955154	20651	10317	38	0	\N
158196	1397	1317907925000	20651	10317	39	0	\N
158197	1440	5845133045924	20651	10317	40	0	\N
158198	1440	3039923045924	20651	10317	41	0	\N
158199	1651	19491731809512	20651	10317	42	0	\N
158200	1651	19486456745295	20651	10317	43	0	\N
158201	1651	16842910956157	20651	10317	44	0	\N
158202	1651	12105707471846	20651	10317	45	0	\N
158203	1506	7159736967172	20651	10317	46	0	\N
158204	1506	4054926967172	20651	10317	47	0	\N
158205	1506	1960016967172	20651	10317	48	0	\N
158206	1506	227406967172	20651	10317	49	0	\N
158207	1474	10849153951023	20651	10317	50	0	\N
158208	1474	8604958183403	20651	10317	51	0	\N
158209	1474	2351325000043	20651	10317	52	0	\N
158210	58	75724144999641	20651	10317	53	0	\N
158211	58	72365284999641	20651	10317	54	0	\N
158212	58	69587284999641	20651	10317	55	0	\N
158213	1440	719883045924	20651	10317	56	0	\N
158214	1397	1317897924000	20651	10317	57	0	\N
158215	1397	1317887923000	20651	10317	58	0	\N
158216	1397	1317877922000	20651	10317	59	0	\N
158217	1397	1317867921000	20651	10317	60	0	\N
158218	1397	1317857920000	20651	10317	61	0	\N
158219	1397	1317847919000	20651	10317	62	0	\N
158220	1397	1317837918000	20651	10317	63	0	\N
158221	1397	1317827917000	20651	10317	64	0	\N
158222	1397	1317817916000	20651	10317	65	0	\N
158223	1397	1317807915000	20651	10317	66	0	\N
158224	1397	1317797914000	20651	10317	67	0	\N
158225	1397	1317787913000	20651	10317	68	0	\N
158226	1397	1317777912000	20651	10317	69	0	\N
158227	1397	1317767911000	20651	10317	70	0	\N
158228	1397	1317757910000	20651	10317	71	0	\N
158229	1397	1317747909000	20651	10317	72	0	\N
158230	1397	1317737908000	20651	10317	73	0	\N
158231	1397	1317727907000	20651	10317	75	0	\N
158232	1397	1317717906000	20651	10317	76	0	\N
158233	1397	1317707905000	20651	10317	77	0	\N
158234	1397	1317697904000	20651	10317	78	0	\N
158235	1397	1317687903000	20651	10317	79	0	\N
158236	1397	1317677902000	20651	10317	80	0	\N
158237	1397	1317667901000	20651	10317	81	0	\N
158238	1397	1317657900000	20651	10317	82	0	\N
158239	1397	1317647899000	20651	10317	83	0	\N
158240	1397	1317637898000	20651	10317	84	0	\N
158241	1397	1317627897000	20651	10317	85	0	\N
158242	1397	1317617896000	20651	10317	86	0	\N
158243	1397	1317607895000	20651	10317	87	0	\N
158244	1397	1317597894000	20651	10317	88	0	\N
158245	1634	18548266728828	20651	10317	89	0	\N
158246	1634	14450968265508	20651	10317	90	0	\N
158247	1634	11686436095072	20651	10317	91	0	\N
158248	1634	3982839259504	20651	10317	92	0	\N
158249	1651	8909418632720	20651	10317	93	0	\N
158250	1651	2693450231	20651	10317	94	0	\N
158251	1397	1317587893000	20651	10317	95	0	\N
158252	1397	1317577892000	20651	10317	96	0	\N
158253	1397	1317567891000	20651	10317	97	0	\N
158254	1397	1317557890000	20651	10317	98	0	\N
158255	1397	1317547889000	20651	10317	99	0	\N
158256	1397	1317537888000	20651	10317	100	0	\N
158257	1397	1317527887000	20651	10317	101	0	\N
158258	1397	1317517886000	20651	10317	102	0	\N
158259	1397	1317507885000	20651	10317	103	0	\N
158260	1397	1317497884000	20651	10317	104	0	\N
158261	1397	1317487883000	20651	10317	105	0	\N
158262	1397	1317477882000	20651	10317	106	0	\N
158263	1397	1317467881000	20651	10317	107	0	\N
158264	1397	1317457880000	20651	10317	108	0	\N
158265	1397	1317447879000	20651	10317	109	0	\N
158266	1397	1317437878000	20651	10317	110	0	\N
158267	1397	1317427877000	20651	10317	111	0	\N
158268	1397	1317417876000	20651	10317	112	0	\N
158269	1397	1317407875000	20651	10317	113	0	\N
158270	1397	1317397874000	20651	10317	114	0	\N
158271	1397	1317387873000	20651	10317	115	0	\N
158272	1397	1317377872000	20651	10317	116	0	\N
158273	1397	1317367871000	20651	10317	117	0	\N
158274	1397	1317357870000	20651	10317	118	0	\N
158275	1397	1317347869000	20651	10317	119	0	\N
158276	1397	1317337868000	20651	10317	120	0	\N
158277	1397	1317327867000	20651	10317	121	0	\N
158278	1397	1317317866000	20651	10317	122	0	\N
158279	1397	1317307865000	20651	10317	123	0	\N
158280	1397	1317297864000	20651	10317	124	0	\N
158281	1397	1317287863000	20651	10317	125	0	\N
158288	1397	1317037838000	20655	10392	0	0	\N
158289	2134	95985985000	20655	10392	1	0	\N
158290	2133	96395802000	20655	10392	2	0	\N
158291	1397	1317027837000	20656	10393	0	0	\N
158292	2134	95984982000	20656	10393	1	0	\N
158293	2133	96394800000	20656	10393	2	0	\N
158294	2132	148154155000	20656	10393	3	0	\N
158295	1397	1317027837000	20657	10393	0	0	\N
158296	2134	95984982000	20657	10393	1	0	\N
158297	2133	96394800000	20657	10393	2	0	\N
158298	2132	148154155000	20657	10393	3	0	\N
158299	1397	1317027837000	20658	10393	0	0	\N
158300	2134	95984982000	20658	10393	1	0	\N
158301	2133	96394800000	20658	10393	2	0	\N
158302	2132	148154155000	20658	10393	3	0	\N
158284	2133	96396804000	20653	10391	2	0	2598
158285	1397	1317037838000	20654	10392	0	0	12179
158286	2134	95985985000	20654	10392	1	0	3005
158287	2133	96395802000	20654	10392	2	0	2599
158303	1397	1317027837000	20659	10393	0	0	12180
158307	1397	1317017836000	20660	10394	0	0	\N
158308	2134	95983979000	20660	10394	1	0	\N
158309	2133	96393798000	20660	10394	2	0	\N
158313	2133	96393798000	20662	10394	0	0	\N
158314	1397	1317007835000	20663	10395	0	0	\N
158315	2133	96392796000	20663	10395	1	0	\N
158318	1397	1316997834000	20665	10396	0	0	\N
158319	1397	1316987833000	20665	10396	1	0	\N
158320	1397	1316977832000	20665	10396	2	0	\N
158321	1397	1316967831000	20665	10396	3	0	\N
158322	2133	96391794000	20665	10396	4	0	\N
158323	2133	96390792000	20665	10396	5	0	\N
158324	2133	96389790000	20665	10396	6	0	\N
158325	2132	148153154000	20665	10396	7	0	\N
158326	2133	96388788000	20665	10396	8	0	\N
158327	2134	95982976000	20665	10396	9	0	\N
158328	2134	95981973000	20665	10396	10	0	\N
158329	2134	95980970000	20665	10396	11	0	\N
158330	2134	95979967000	20665	10396	12	0	\N
158344	1397	1316997834000	20667	10396	0	0	\N
158345	1397	1316987833000	20667	10396	1	0	\N
158346	1397	1316977832000	20667	10396	2	0	\N
158347	1397	1316967831000	20667	10396	3	0	\N
158348	2133	96391794000	20667	10396	4	0	\N
158349	2133	96390792000	20667	10396	5	0	\N
158350	2133	96389790000	20667	10396	6	0	\N
158351	2132	148153154000	20667	10396	7	0	\N
158352	2133	96388788000	20667	10396	8	0	\N
158353	2134	95982976000	20667	10396	9	0	\N
158354	2134	95981973000	20667	10396	10	0	\N
158355	2134	95980970000	20667	10396	11	0	\N
158356	2134	95979967000	20667	10396	12	0	\N
158360	1397	1316957830000	20669	10397	0	0	\N
158361	2133	96387786000	20669	10397	1	0	\N
158362	2132	148152153000	20669	10397	2	0	\N
158366	1397	1316947829000	20671	10398	0	0	\N
158367	2134	95978964000	20671	10398	2	0	\N
158368	2133	96386784000	20671	10398	3	0	\N
158369	1397	1316937828000	20672	10399	0	0	\N
158370	2133	96385782000	20672	10399	1	0	\N
158371	2134	95977961000	20672	10399	2	0	\N
158375	1397	1316927827000	20674	10400	0	0	\N
158376	1397	1316917826000	20674	10400	1	0	\N
158377	1397	1316907825000	20674	10400	2	0	\N
158378	2133	96384780000	20674	10400	3	0	\N
158379	2133	96383778000	20674	10400	4	0	\N
158380	2132	148151152000	20674	10400	5	0	\N
158381	2134	95976958000	20674	10400	6	0	\N
158382	2134	95975955000	20674	10400	7	0	\N
158383	2134	95974952000	20674	10400	8	0	\N
158393	1397	1316927827000	20676	10400	0	0	\N
158394	1397	1316917826000	20676	10400	1	0	\N
158395	1397	1316907825000	20676	10400	2	0	\N
158396	2133	96384780000	20676	10400	3	0	\N
158397	2133	96383778000	20676	10400	4	0	\N
158398	2132	148151152000	20676	10400	5	0	\N
158399	2134	95976958000	20676	10400	6	0	\N
158400	2134	95975955000	20676	10400	7	0	\N
158401	2134	95974952000	20676	10400	8	0	\N
158402	1397	1316927827000	20677	10400	0	0	\N
158403	1397	1316917826000	20677	10400	1	0	\N
158404	1397	1316907825000	20677	10400	2	0	\N
158405	2133	96384780000	20677	10400	3	0	\N
158406	2133	96383778000	20677	10400	4	0	\N
158407	2132	148151152000	20677	10400	5	0	\N
158408	2134	95976958000	20677	10400	6	0	\N
158409	2134	95975955000	20677	10400	7	0	\N
158410	2134	95974952000	20677	10400	8	0	\N
158411	1397	1316897824000	20678	10401	0	0	\N
158412	2134	95973949000	20678	10401	1	0	\N
158413	2133	96382776000	20678	10401	2	0	\N
158417	1397	1316997834000	20680	10396	0	0	\N
158418	1397	1316987833000	20680	10396	1	0	\N
158419	1397	1316977832000	20680	10396	2	0	\N
158420	1397	1316967831000	20680	10396	3	0	\N
158421	1397	1316957830000	20680	10396	4	0	\N
158422	1397	1316947829000	20680	10396	5	0	\N
158423	1397	1316937828000	20680	10396	6	0	\N
158424	1397	1316927827000	20680	10396	7	0	\N
158425	1397	1316917826000	20680	10396	8	0	\N
158426	1397	1316907825000	20680	10396	9	0	\N
158427	2133	96391794000	20680	10396	10	0	\N
158428	2133	96390792000	20680	10396	11	0	\N
158429	2133	96389790000	20680	10396	12	0	\N
158430	2132	148153154000	20680	10396	13	0	\N
158431	2132	148152153000	20680	10396	14	0	\N
158432	2132	148151152000	20680	10396	15	0	\N
158433	2133	96388788000	20680	10396	16	0	\N
158434	2133	96387786000	20680	10396	17	0	\N
158435	2133	96386784000	20680	10396	18	0	\N
158436	2133	96385782000	20680	10396	19	0	\N
158437	2133	96384780000	20680	10396	20	0	\N
158438	2133	96383778000	20680	10396	22	0	\N
158439	2133	96382776000	20680	10396	23	0	\N
158440	2134	95982976000	20680	10396	24	0	\N
158310	1397	1317017836000	20661	10394	0	0	12181
158311	2134	95983979000	20661	10394	1	0	3007
158312	2133	96393798000	20661	10394	2	0	2601
158316	1397	1317007835000	20664	10395	0	0	12182
158317	2133	96392796000	20664	10395	1	0	2602
158332	1397	1316987833000	20666	10396	1	0	12184
158333	1397	1316977832000	20666	10396	2	0	12185
158334	1397	1316967831000	20666	10396	3	0	12186
158335	2133	96391794000	20666	10396	4	0	2603
158336	2133	96390792000	20666	10396	5	0	2604
158338	2132	148153154000	20666	10396	7	0	846
158339	2133	96388788000	20666	10396	8	0	2606
158340	2134	95982976000	20666	10396	9	0	3008
158341	2134	95981973000	20666	10396	10	0	3009
158343	2134	95979967000	20666	10396	12	0	3011
158357	1397	1316957830000	20668	10397	0	0	12187
158358	2133	96387786000	20668	10397	1	0	2607
158359	2132	148152153000	20668	10397	2	0	847
158363	1397	1316947829000	20670	10398	0	0	12188
158365	2133	96386784000	20670	10398	3	0	2608
158372	1397	1316937828000	20673	10399	0	0	12189
158373	2133	96385782000	20673	10399	1	0	2609
158374	2134	95977961000	20673	10399	2	0	3013
158384	1397	1316927827000	20675	10400	0	0	12190
158386	1397	1316907825000	20675	10400	2	0	12192
158387	2133	96384780000	20675	10400	3	0	2610
158388	2133	96383778000	20675	10400	4	0	2611
158389	2132	148151152000	20675	10400	5	0	848
158391	2134	95975955000	20675	10400	7	0	3015
158392	2134	95974952000	20675	10400	8	0	3016
158414	1397	1316897824000	20679	10401	0	0	12193
158415	2134	95973949000	20679	10401	1	0	3017
158416	2133	96382776000	20679	10401	2	0	2612
158441	2134	95981973000	20680	10396	25	0	\N
158442	2134	95980970000	20680	10396	26	0	\N
158443	2134	95979967000	20680	10396	27	0	\N
158444	2134	95978964000	20680	10396	28	0	\N
158445	2134	95977961000	20680	10396	29	0	\N
158446	2134	95976958000	20680	10396	30	0	\N
158447	2134	95975955000	20680	10396	31	0	\N
158448	2134	95974952000	20680	10396	32	0	\N
158452	1397	1316887823000	20682	10402	0	0	\N
158453	2132	148150151000	20682	10402	1	0	\N
158454	2133	96381774000	20682	10402	2	0	\N
158455	1762	12854252994000	20683	10360	0	0	\N
158456	1768	13453800110000	20683	10360	1	0	\N
158457	1768	9572000110000	20683	10360	2	0	\N
158458	1768	6953200110000	20683	10360	3	0	\N
158459	1762	8031302994000	20683	10360	4	0	\N
158460	1762	4777132994000	20683	10360	5	0	\N
158461	1762	2085282994000	20683	10360	6	0	\N
158462	1768	4786500110000	20683	10360	7	0	\N
158463	58	90782016999641	20683	10360	8	0	\N
158464	58	81422296999641	20683	10360	9	0	\N
158465	149	78978258000341	20683	10360	10	0	\N
158466	149	74820618000341	20683	10360	11	0	\N
158467	149	72015368000341	20683	10360	12	0	\N
158468	149	69695238000341	20683	10360	13	0	\N
158469	1397	1317267861000	20683	10360	14	0	\N
158470	1397	1317257860000	20683	10360	15	0	\N
158471	1397	1317247859000	20683	10360	16	0	\N
158472	1397	1317237858000	20683	10360	17	0	\N
158473	58	76444156999641	20683	10360	18	0	\N
158474	58	73085296999641	20683	10360	19	0	\N
158475	58	70307296999641	20683	10360	20	0	\N
158476	1397	1317227857000	20683	10360	21	0	\N
158477	1397	1317217856000	20683	10360	22	0	\N
158478	1397	1317207855000	20683	10360	23	0	\N
158479	1397	1317197854000	20683	10360	24	0	\N
158480	1397	1317187853000	20683	10360	25	0	\N
158481	1397	1317177852000	20683	10360	26	0	\N
158482	1397	1317167851000	20683	10360	27	0	\N
158483	1397	1317157850000	20683	10360	28	0	\N
158484	1397	1317147849000	20683	10360	29	0	\N
158485	1397	1317137848000	20683	10360	30	0	\N
158486	1397	1317127847000	20683	10360	31	0	\N
158487	1397	1317117846000	20683	10360	32	0	\N
158488	1397	1317107845000	20683	10360	33	0	\N
158489	1397	1317097844000	20683	10360	34	0	\N
158490	1397	1317087843000	20683	10360	35	0	\N
158491	1397	1317077842000	20683	10360	36	0	\N
158492	1397	1317067841000	20683	10360	37	0	\N
158493	1397	1317057840000	20683	10360	38	0	\N
158494	1397	1317047839000	20683	10360	39	0	\N
158495	1397	1317037838000	20683	10360	40	0	\N
158496	1397	1317027837000	20683	10360	41	0	\N
158497	1397	1317017836000	20683	10360	42	0	\N
158498	1397	1317007835000	20683	10360	43	0	\N
158499	1397	1316997834000	20683	10360	44	0	\N
158500	1397	1316987833000	20683	10360	45	0	\N
158501	1397	1316977832000	20683	10360	46	0	\N
158502	1397	1316967831000	20683	10360	47	0	\N
158503	1397	1316957830000	20683	10360	48	0	\N
158504	1397	1316947829000	20683	10360	49	0	\N
158505	1397	1316937828000	20683	10360	50	0	\N
158506	1397	1316927827000	20683	10360	51	0	\N
158507	1397	1316917826000	20683	10360	52	0	\N
158508	1397	1316907825000	20683	10360	53	0	\N
158509	2132	148161162000	20683	10360	54	0	\N
158510	2157	1194001999	20683	10360	55	0	\N
158511	1602	17699144460000	20683	10360	56	0	\N
158512	1602	13287483590000	20683	10360	57	0	\N
158513	2133	96419850000	20683	10360	58	0	\N
158514	1602	10310847770000	20683	10360	59	0	\N
158515	1602	2016189170000	20683	10360	60	0	\N
158516	2134	96007048000	20683	10360	61	0	\N
158517	2134	96006045000	20683	10360	62	0	\N
158518	2134	96005042000	20683	10360	63	0	\N
158519	2133	96418848000	20683	10360	64	0	\N
158520	2133	96417846000	20683	10360	65	0	\N
158521	2133	96416844000	20683	10360	66	0	\N
158522	2133	96415842000	20683	10360	67	0	\N
158523	2133	96414840000	20683	10360	68	0	\N
158524	2133	96413838000	20683	10360	69	0	\N
158525	2133	96412836000	20683	10360	70	0	\N
158526	2133	96411834000	20683	10360	71	0	\N
158527	2133	96410832000	20683	10360	72	0	\N
158528	2133	96409830000	20683	10360	74	0	\N
158529	2133	96408828000	20683	10360	75	0	\N
158530	2133	96407826000	20683	10360	76	0	\N
158531	2133	96406824000	20683	10360	77	0	\N
158532	2133	96405822000	20683	10360	78	0	\N
158533	2133	96404820000	20683	10360	79	0	\N
158534	2133	96403818000	20683	10360	80	0	\N
158535	2133	96402816000	20683	10360	81	0	\N
158536	2133	96401814000	20683	10360	82	0	\N
158537	2133	96400812000	20683	10360	83	0	\N
158538	2133	96399810000	20683	10360	84	0	\N
158539	2133	96398808000	20683	10360	85	0	\N
158540	2133	96397806000	20683	10360	86	0	\N
158541	2133	96396804000	20683	10360	87	0	\N
158542	2133	96395802000	20683	10360	88	0	\N
158543	2133	96394800000	20683	10360	89	0	\N
158544	2133	96393798000	20683	10360	90	0	\N
158545	2133	96392796000	20683	10360	91	0	\N
158546	2133	96391794000	20683	10360	92	0	\N
158547	2133	96390792000	20683	10360	93	0	\N
158548	2133	96389790000	20683	10360	94	0	\N
158549	2134	96004039000	20683	10360	95	0	\N
158550	2134	96003036000	20683	10360	96	0	\N
158551	2133	96388788000	20683	10360	97	0	\N
158552	2133	96387786000	20683	10360	98	0	\N
158553	2133	96386784000	20683	10360	99	0	\N
158554	2133	96385782000	20683	10360	100	0	\N
158555	2133	96384780000	20683	10360	101	0	\N
158556	2133	96383778000	20683	10360	102	0	\N
158557	2133	96382776000	20683	10360	103	0	\N
158558	1726	18113112000	20683	10360	104	0	\N
158559	1726	16912112000	20683	10360	105	0	\N
158560	2134	96002033000	20683	10360	106	0	\N
158561	2134	96001030000	20683	10360	107	0	\N
158562	2134	96000027000	20683	10360	108	0	\N
158563	2134	95999024000	20683	10360	109	0	\N
158564	2134	95998021000	20683	10360	110	0	\N
158565	2134	95997018000	20683	10360	111	0	\N
158566	2134	95996015000	20683	10360	112	0	\N
158567	2134	95995012000	20683	10360	113	0	\N
158568	2134	95994009000	20683	10360	114	0	\N
158569	2134	95993006000	20683	10360	115	0	\N
158570	2134	95992003000	20683	10360	116	0	\N
158571	2134	95991000000	20683	10360	117	0	\N
158572	2134	95989997000	20683	10360	118	0	\N
158573	2134	95988994000	20683	10360	119	0	\N
158574	2134	95987991000	20683	10360	120	0	\N
158575	2134	95986988000	20683	10360	121	0	\N
158576	2134	95985985000	20683	10360	122	0	\N
158451	2133	96381774000	20681	10402	2	0	2613
158577	2134	95984982000	20683	10360	123	0	\N
158578	2134	95983979000	20683	10360	124	0	\N
158579	2134	95982976000	20683	10360	125	0	\N
158580	1397	1316877822000	20684	10403	0	0	\N
158581	2134	95972946000	20684	10403	1	0	\N
158582	2133	96380772000	20684	10403	2	0	\N
158589	1397	1316867821000	20687	10404	0	0	\N
158590	2133	96379770000	20687	10404	1	0	\N
158591	2134	95971943000	20687	10404	2	0	\N
158599	1397	1316837818000	20690	10407	0	0	\N
158600	2134	95968934000	20690	10407	1	0	\N
158601	1397	1316837818000	20691	10407	0	0	\N
158602	2134	95968934000	20691	10407	1	0	\N
158603	2133	96376764000	20691	10407	2	0	\N
158615	1656	14166643999990	20694	10408	0	0	\N
158616	1397	1316827817000	20694	10408	1	0	\N
158617	1397	1316817816000	20694	10408	2	0	\N
158618	2134	95967931000	20694	10408	3	0	\N
158619	2134	95966928000	20694	10408	4	0	\N
158620	2132	148148149000	20694	10408	5	0	\N
158621	2133	96375762000	20694	10408	6	0	\N
158622	2133	96374760000	20694	10408	7	0	\N
158623	1656	13446631999990	20695	10325	0	0	\N
158624	1656	9034511999990	20695	10325	1	0	\N
158625	1656	6057391999990	20695	10325	2	0	\N
158626	1656	3595271999990	20695	10325	3	0	\N
158627	1762	12854252994000	20695	10325	4	0	\N
158628	1768	13453800110000	20695	10325	5	0	\N
158629	1768	9572000110000	20695	10325	6	0	\N
158630	1768	6953200110000	20695	10325	7	0	\N
158631	1762	8031302994000	20695	10325	8	0	\N
158632	1762	4777132994000	20695	10325	9	0	\N
158633	1762	2085282994000	20695	10325	10	0	\N
158634	1768	4786500110000	20695	10325	11	0	\N
158635	484	71171874000000	20695	10325	12	0	\N
158636	484	69864854000000	20695	10325	13	0	\N
158637	484	68982834000000	20695	10325	14	0	\N
158638	484	68253814000000	20695	10325	15	0	\N
158639	1440	17819353045924	20695	10325	16	0	\N
158640	171	79248478851086	20695	10325	17	0	\N
158641	2179	190000000	20695	10325	18	0	\N
158642	1702	342000000	20695	10325	19	0	\N
158643	1440	10002643045924	20695	10325	20	0	\N
158644	58	90782016999641	20695	10325	21	0	\N
158645	58	81422296999641	20695	10325	22	0	\N
158646	1506	12997246967172	20695	10325	23	0	\N
158647	171	75911702541976	20695	10325	24	0	\N
158648	171	73660309823457	20695	10325	25	0	\N
158649	171	67386621696494	20695	10325	26	0	\N
158650	149	78258246000341	20695	10325	28	0	\N
158657	1656	9754523999990	20697	10409	0	0	\N
158658	1656	6777403999990	20697	10409	1	0	\N
158659	1656	4315283999990	20697	10409	2	0	\N
158660	1397	1316807815000	20697	10409	3	0	\N
158661	1726	15711112000	20697	10409	4	0	\N
158662	2133	96373758000	20697	10409	5	0	\N
158665	1397	1316797814000	20699	10411	0	0	\N
158666	1397	1316787813000	20699	10411	1	0	\N
158667	1397	1316777812000	20699	10411	2	0	\N
158668	2132	148147148000	20699	10411	3	0	\N
158669	2134	95964922000	20699	10411	4	0	\N
158670	2134	95963919000	20699	10411	5	0	\N
158671	2133	96371754000	20699	10411	6	0	\N
158672	2133	96370752000	20699	10411	7	0	\N
158681	1397	1316797814000	20701	10411	0	0	\N
158682	1397	1316787813000	20701	10411	1	0	\N
158683	1397	1316777812000	20701	10411	2	0	\N
158684	2132	148147148000	20701	10411	3	0	\N
158685	2134	95964922000	20701	10411	4	0	\N
158686	2134	95963919000	20701	10411	5	0	\N
158687	2133	96371754000	20701	10411	6	0	\N
158688	2133	96370752000	20701	10411	7	0	\N
158689	1397	1316797814000	20702	10411	0	0	\N
158690	1397	1316787813000	20702	10411	1	0	\N
158691	1397	1316777812000	20702	10411	2	0	\N
158692	2132	148147148000	20702	10411	3	0	\N
158693	2134	95964922000	20702	10411	4	0	\N
158694	2134	95963919000	20702	10411	5	0	\N
158695	2133	96371754000	20702	10411	6	0	\N
158696	2133	96370752000	20702	10411	7	0	\N
158697	1397	1316767811000	20703	10412	0	0	\N
158698	2133	96369750000	20703	10412	1	0	\N
158699	2134	95962916000	20703	10412	2	0	\N
158585	2133	96380772000	20685	10403	2	0	2614
158586	1397	1316867821000	20686	10404	0	0	12196
158587	2133	96379770000	20686	10404	1	0	2615
158588	2134	95971943000	20686	10404	2	0	3019
158592	1397	1316857820000	20688	10405	0	0	12197
158594	2132	148149150000	20688	10405	2	0	850
158595	2133	96378768000	20688	10405	3	0	2616
158596	1397	1316847819000	20689	10406	0	0	12198
158597	2133	96377766000	20689	10406	1	0	2617
158598	2134	95969937000	20689	10406	2	0	3021
158605	2134	95968934000	20692	10407	1	0	3022
158606	2133	96376764000	20692	10407	2	0	2618
158607	1656	14166643999990	20693	10408	0	0	5
158608	1397	1316827817000	20693	10408	1	0	12200
158610	2134	95967931000	20693	10408	3	0	3023
158611	2134	95966928000	20693	10408	4	0	3024
158612	2132	148148149000	20693	10408	5	0	851
158613	2133	96375762000	20693	10408	6	0	2619
158614	2133	96374760000	20693	10408	7	0	2620
158652	1656	6777403999990	20696	10409	1	0	7
158653	1656	4315283999990	20696	10409	2	0	8
158654	1397	1316807815000	20696	10409	3	0	12202
158655	1726	15711112000	20696	10409	4	0	8274
158656	2133	96373758000	20696	10409	5	0	2621
158664	2133	96372756000	20698	10410	1	0	2622
158673	1397	1316797814000	20700	10411	0	0	12203
158674	1397	1316787813000	20700	10411	1	0	12204
158675	1397	1316777812000	20700	10411	2	0	12205
158677	2134	95964922000	20700	10411	4	0	3026
158678	2134	95963919000	20700	10411	5	0	3027
158679	2133	96371754000	20700	10411	6	0	2623
158680	2133	96370752000	20700	10411	7	0	2624
158700	1397	1316767811000	20704	10412	0	0	12206
158702	2134	95962916000	20704	10412	2	0	3028
158703	1397	1316757810000	20705	10413	0	0	12207
158704	1397	1316747809000	20705	10413	1	0	12208
158705	579	66000004000000	20705	10413	2	0	2
158706	2134	95961913000	20705	10413	3	0	3029
158708	2132	148146147000	20705	10413	5	0	853
158709	2133	96368748000	20705	10413	6	0	2626
158710	2133	96367746000	20705	10413	7	0	2627
158711	1397	1316737808000	20706	10414	0	0	12209
158713	1397	1316737808000	20707	10414	0	0	\N
158714	2133	96366744000	20707	10414	1	0	\N
158715	1397	1316727807000	20710	10415	0	0	\N
158716	2133	96365742000	20710	10415	1	0	\N
158717	2132	148145146000	20710	10415	2	0	\N
158718	2134	95959907000	20710	10415	3	0	\N
158723	1397	1316727807000	20712	10415	0	0	\N
158724	2133	96365742000	20712	10415	1	0	\N
158725	2132	148145146000	20712	10415	2	0	\N
158726	2134	95959907000	20712	10415	3	0	\N
158727	1397	1316717806000	20713	10416	0	0	\N
158728	2134	95958904000	20713	10416	1	0	\N
158729	2133	96364740000	20713	10416	2	0	\N
158730	1397	1316717806000	20714	10416	0	0	\N
158731	2134	95958904000	20714	10416	1	0	\N
158732	2133	96364740000	20714	10416	2	0	\N
158736	1656	13446644999990	20716	10188	0	0	\N
158737	1656	9034524999990	20716	10188	1	0	\N
158738	1656	6057404999990	20716	10188	2	0	\N
158739	1656	3595284999990	20716	10188	3	0	\N
158740	1762	12854252994000	20716	10188	4	0	\N
158741	1768	13453800110000	20716	10188	5	0	\N
158742	1768	9572000110000	20716	10188	6	0	\N
158743	1768	6953200110000	20716	10188	7	0	\N
158744	1762	8031302994000	20716	10188	8	0	\N
158745	1762	4777132994000	20716	10188	9	0	\N
158746	1762	2085282994000	20716	10188	10	0	\N
158747	1768	4786500110000	20716	10188	11	0	\N
158748	1440	17099341045924	20716	10188	12	0	\N
158749	171	79248478851086	20716	10188	13	0	\N
158750	2179	190000000	20716	10188	14	0	\N
158751	1702	342000000	20716	10188	15	0	\N
158752	1440	9282631045924	20716	10188	16	0	\N
158753	58	89341980999641	20716	10188	17	0	\N
158754	58	79982260999641	20716	10188	18	0	\N
158755	1506	12997246967172	20716	10188	19	0	\N
158756	171	75911702541976	20716	10188	20	0	\N
158757	171	73660309823457	20716	10188	21	0	\N
158758	171	67386621696494	20716	10188	22	0	\N
158759	149	77538231000341	20716	10188	23	0	\N
158760	149	73380591000341	20716	10188	24	0	\N
158761	149	70575341000341	20716	10188	25	0	\N
158762	149	68255211000341	20716	10188	26	0	\N
158763	1634	19610613710383	20716	10188	27	0	\N
158764	1634	19599736909139	20716	10188	28	0	\N
158765	1634	19291382591144	20716	10188	29	0	\N
158766	1634	18983028273149	20716	10188	30	0	\N
158767	1634	18674673955154	20716	10188	31	0	\N
158768	1440	5125121045924	20716	10188	32	0	\N
158769	1440	2319911045924	20716	10188	33	0	\N
158770	1506	7159736967172	20716	10188	34	0	\N
158771	1506	4054926967172	20716	10188	35	0	\N
158772	1506	1960016967172	20716	10188	36	0	\N
158773	1506	227406967172	20716	10188	37	0	\N
158774	1474	10849153951023	20716	10188	38	0	\N
158775	1474	8604958183403	20716	10188	39	0	\N
158776	1474	2351325000043	20716	10188	40	0	\N
158777	58	75004120999641	20716	10188	41	0	\N
158778	58	71645260999641	20716	10188	42	0	\N
158779	58	68867260999641	20716	10188	43	0	\N
158780	1397	1318417976000	20716	10188	44	0	\N
158781	1397	1318407975000	20716	10188	45	0	\N
158782	1397	1318397974000	20716	10188	46	0	\N
158783	1397	1318387973000	20716	10188	47	0	\N
158784	1397	1318377972000	20716	10188	48	0	\N
158785	1397	1318367971000	20716	10188	49	0	\N
158786	1397	1318357970000	20716	10188	50	0	\N
158787	1397	1318347969000	20716	10188	51	0	\N
158788	1634	16388219728828	20716	10188	52	0	\N
158789	1634	12290921265508	20716	10188	53	0	\N
158790	1634	9526389095072	20716	10188	54	0	\N
158791	1634	1822792259504	20716	10188	55	0	\N
158792	1397	1318337968000	20716	10188	56	0	\N
158793	1397	1318327967000	20716	10188	57	0	\N
158794	1397	1318317966000	20716	10188	58	0	\N
158795	1397	1318307965000	20716	10188	59	0	\N
158796	1397	1318297964000	20716	10188	60	0	\N
158797	1397	1318287963000	20716	10188	61	0	\N
158798	1397	1318277962000	20716	10188	62	0	\N
158799	1397	1318267961000	20716	10188	63	0	\N
158800	1397	1318257960000	20716	10188	64	0	\N
158801	1397	1318247959000	20716	10188	65	0	\N
158802	1397	1318237958000	20716	10188	68	0	\N
158803	1397	1318227957000	20716	10188	69	0	\N
158804	1397	1318217956000	20716	10188	70	0	\N
158805	1397	1318207955000	20716	10188	71	0	\N
158806	1397	1318197954000	20716	10188	72	0	\N
158807	1397	1318187953000	20716	10188	73	0	\N
158808	1397	1318177952000	20716	10188	74	0	\N
158809	1397	1318167951000	20716	10188	75	0	\N
158810	1397	1318157950000	20716	10188	76	0	\N
158811	1397	1318147949000	20716	10188	77	0	\N
158812	1397	1318137948000	20716	10188	78	0	\N
158813	1397	1316707805000	20717	10417	0	0	\N
158814	2134	95957901000	20717	10417	1	0	\N
158815	2133	96363738000	20717	10417	2	0	\N
158821	1656	14166643999990	20721	10382	0	0	\N
158822	1656	9754523999990	20721	10382	1	0	\N
158823	1656	6777403999990	20721	10382	2	0	\N
158824	1656	4315283999990	20721	10382	3	0	\N
158825	1397	1317147849000	20721	10382	4	0	\N
158826	1397	1317137848000	20721	10382	5	0	\N
158827	1397	1317127847000	20721	10382	6	0	\N
158828	1397	1317117846000	20721	10382	7	0	\N
158829	1397	1317107845000	20721	10382	8	0	\N
158830	1397	1317097844000	20721	10382	9	0	\N
158831	1397	1317087843000	20721	10382	10	0	\N
158832	1397	1317077842000	20721	10382	11	0	\N
158833	1397	1317067841000	20721	10382	12	0	\N
158834	1397	1317057840000	20721	10382	13	0	\N
158835	1397	1317047839000	20721	10382	14	0	\N
158836	1397	1317037838000	20721	10382	15	0	\N
158837	1397	1317027837000	20721	10382	16	0	\N
158838	1397	1317017836000	20721	10382	17	0	\N
158839	1397	1317007835000	20721	10382	18	0	\N
158840	1397	1316997834000	20721	10382	19	0	\N
158841	1397	1316987833000	20721	10382	20	0	\N
158842	1397	1316977832000	20721	10382	21	0	\N
158843	1397	1316967831000	20721	10382	22	0	\N
158844	1397	1316957830000	20721	10382	23	0	\N
158845	1397	1316947829000	20721	10382	24	0	\N
158846	1397	1316937828000	20721	10382	25	0	\N
158847	1397	1316927827000	20721	10382	26	0	\N
158848	1397	1316917826000	20721	10382	27	0	\N
158721	2132	148145146000	20711	10415	2	0	854
158722	2134	95959907000	20711	10415	3	0	3031
158733	1397	1316717806000	20715	10416	0	0	12211
158734	2134	95958904000	20715	10416	1	0	3032
158735	2133	96364740000	20715	10416	2	0	2630
158817	2134	95957901000	20718	10417	1	0	3033
158818	2133	96363738000	20718	10417	2	0	2631
158819	1397	1316697804000	20720	10418	0	0	12213
158820	2133	96362736000	20720	10418	1	0	2632
158849	1397	1316907825000	20721	10382	28	0	\N
158850	1397	1316897824000	20721	10382	29	0	\N
158851	1397	1316887823000	20721	10382	30	0	\N
158852	1397	1316877822000	20721	10382	31	0	\N
158853	1397	1316867821000	20721	10382	32	0	\N
158854	1397	1316857820000	20721	10382	33	0	\N
158855	1397	1316847819000	20721	10382	34	0	\N
158856	1397	1316837818000	20721	10382	35	0	\N
158857	1397	1316827817000	20721	10382	36	0	\N
158858	1397	1316817816000	20721	10382	37	0	\N
158859	1397	1316807815000	20721	10382	38	0	\N
158860	1397	1316797814000	20721	10382	39	0	\N
158861	1397	1316787813000	20721	10382	40	0	\N
158862	1397	1316777812000	20721	10382	41	0	\N
158863	1397	1316767811000	20721	10382	42	0	\N
158864	1397	1316757810000	20721	10382	43	0	\N
158865	1397	1316747809000	20721	10382	44	0	\N
158866	1397	1316737808000	20721	10382	45	0	\N
158867	1397	1316727807000	20721	10382	46	0	\N
158868	1397	1316717806000	20721	10382	47	0	\N
158869	1397	1316707805000	20721	10382	48	0	\N
158870	2133	96406824000	20721	10382	49	0	\N
158871	1726	15711112000	20721	10382	50	0	\N
158872	579	66000004000000	20721	10382	51	0	\N
158873	2133	96405822000	20721	10382	52	0	\N
158874	2133	96404820000	20721	10382	53	0	\N
158875	2132	148157158000	20721	10382	54	0	\N
158876	2132	148156157000	20721	10382	55	0	\N
158877	2132	148155156000	20721	10382	56	0	\N
158878	2134	95995012000	20721	10382	57	0	\N
158879	2133	96403818000	20721	10382	58	0	\N
158880	2134	95994009000	20721	10382	59	0	\N
158881	2134	95993006000	20721	10382	60	0	\N
158882	2134	95992003000	20721	10382	61	0	\N
158883	2134	95991000000	20721	10382	62	0	\N
158884	2134	95989997000	20721	10382	63	0	\N
158885	2134	95988994000	20721	10382	64	0	\N
158886	2134	95987991000	20721	10382	65	0	\N
158887	2134	95986988000	20721	10382	66	0	\N
158888	2134	95985985000	20721	10382	67	0	\N
158889	2134	95984982000	20721	10382	68	0	\N
158890	2134	95983979000	20721	10382	69	0	\N
158891	2133	96402816000	20721	10382	70	0	\N
158892	2133	96401814000	20721	10382	71	0	\N
158893	2133	96400812000	20721	10382	72	0	\N
158894	2133	96399810000	20721	10382	73	0	\N
158895	2133	96398808000	20721	10382	74	0	\N
158896	2133	96397806000	20721	10382	75	0	\N
158897	2133	96396804000	20721	10382	76	0	\N
158898	2133	96395802000	20721	10382	77	0	\N
158899	2133	96394800000	20721	10382	78	0	\N
158900	2133	96393798000	20721	10382	79	0	\N
158901	2133	96392796000	20721	10382	80	0	\N
158902	2133	96391794000	20721	10382	81	0	\N
158903	2133	96390792000	20721	10382	82	0	\N
158904	2133	96389790000	20721	10382	83	0	\N
158905	2132	148154155000	20721	10382	84	0	\N
158906	2132	148153154000	20721	10382	85	0	\N
158907	2132	148152153000	20721	10382	86	0	\N
158908	2132	148151152000	20721	10382	87	0	\N
158909	2132	148150151000	20721	10382	88	0	\N
158910	2132	148149150000	20721	10382	89	0	\N
158911	2133	96388788000	20721	10382	90	0	\N
158912	2133	96387786000	20721	10382	91	0	\N
158913	2133	96386784000	20721	10382	92	0	\N
158914	2133	96385782000	20721	10382	93	0	\N
158915	2133	96384780000	20721	10382	94	0	\N
158916	2133	96383778000	20721	10382	96	0	\N
158917	2133	96382776000	20721	10382	97	0	\N
158918	2133	96381774000	20721	10382	98	0	\N
158919	2133	96380772000	20721	10382	99	0	\N
158920	2133	96379770000	20721	10382	100	0	\N
158921	2133	96378768000	20721	10382	101	0	\N
158922	2133	96377766000	20721	10382	102	0	\N
158923	2133	96376764000	20721	10382	103	0	\N
158924	2134	95982976000	20721	10382	104	0	\N
158925	2134	95981973000	20721	10382	105	0	\N
158926	2134	95980970000	20721	10382	106	0	\N
158927	2134	95979967000	20721	10382	107	0	\N
158928	2134	95978964000	20721	10382	108	0	\N
158929	2134	95977961000	20721	10382	109	0	\N
158930	2134	95976958000	20721	10382	110	0	\N
158931	2134	95975955000	20721	10382	111	0	\N
158932	2134	95974952000	20721	10382	112	0	\N
158933	2134	95973949000	20721	10382	113	0	\N
158934	2134	95972946000	20721	10382	114	0	\N
158935	2134	95971943000	20721	10382	115	0	\N
158936	2134	95970940000	20721	10382	116	0	\N
158937	2134	95969937000	20721	10382	117	0	\N
158938	2134	95968934000	20721	10382	118	0	\N
158939	2134	95967931000	20721	10382	119	0	\N
158940	2134	95966928000	20721	10382	120	0	\N
158941	2134	95965925000	20721	10382	121	0	\N
158942	2134	95964922000	20721	10382	122	0	\N
158943	2132	148148149000	20721	10382	123	0	\N
158944	2132	148147148000	20721	10382	124	0	\N
158945	2132	148146147000	20721	10382	125	0	\N
158946	1397	1316687803000	20724	10420	0	0	\N
158947	1397	1316677802000	20724	10420	1	0	\N
158948	1397	1316667801000	20724	10420	2	0	\N
158949	2134	95956898000	20724	10420	3	0	\N
158950	2134	95955895000	20724	10420	4	0	\N
158951	2132	148144145000	20724	10420	5	0	\N
158952	2134	95954892000	20724	10420	6	0	\N
158953	2133	96361734000	20724	10420	7	0	\N
158954	2133	96360732000	20724	10420	8	0	\N
158955	2133	96359730000	20724	10420	9	0	\N
158956	1397	1316687803000	20725	10420	0	0	\N
158957	1397	1316677802000	20725	10420	1	0	\N
158958	1397	1316667801000	20725	10420	2	0	\N
158959	2134	95956898000	20725	10420	3	0	\N
158960	2134	95955895000	20725	10420	4	0	\N
158961	2132	148144145000	20725	10420	5	0	\N
158962	2134	95954892000	20725	10420	6	0	\N
158963	2133	96361734000	20725	10420	7	0	\N
158964	2133	96360732000	20725	10420	8	0	\N
158965	2133	96359730000	20725	10420	9	0	\N
158966	1397	1316687803000	20726	10420	0	0	\N
158967	1397	1316677802000	20726	10420	1	0	\N
158968	1397	1316667801000	20726	10420	2	0	\N
158969	2134	95956898000	20726	10420	3	0	\N
158970	2134	95955895000	20726	10420	4	0	\N
158971	2132	148144145000	20726	10420	5	0	\N
158972	2134	95954892000	20726	10420	6	0	\N
158973	2133	96361734000	20726	10420	7	0	\N
158974	2133	96360732000	20726	10420	8	0	\N
158975	2133	96359730000	20726	10420	9	0	\N
158976	1397	1316687803000	20727	10420	0	0	\N
158977	1397	1316677802000	20727	10420	1	0	\N
158978	1397	1316667801000	20727	10420	2	0	\N
158979	2134	95956898000	20727	10420	3	0	\N
158980	2134	95955895000	20727	10420	4	0	\N
158981	2132	148144145000	20727	10420	5	0	\N
158982	2134	95954892000	20727	10420	6	0	\N
158983	2133	96361734000	20727	10420	7	0	\N
158984	2133	96360732000	20727	10420	8	0	\N
158985	2133	96359730000	20727	10420	9	0	\N
158986	1397	1316687803000	20728	10420	0	0	\N
158987	1397	1316677802000	20728	10420	1	0	\N
158988	1397	1316667801000	20728	10420	2	0	\N
158989	2134	95956898000	20728	10420	3	0	\N
158990	2134	95955895000	20728	10420	4	0	\N
158991	2132	148144145000	20728	10420	5	0	\N
158992	2134	95954892000	20728	10420	6	0	\N
158993	2133	96361734000	20728	10420	7	0	\N
158994	2133	96360732000	20728	10420	8	0	\N
158995	2133	96359730000	20728	10420	9	0	\N
159016	1397	1316657800000	20731	10421	0	0	\N
159017	1397	1316647799000	20731	10421	1	0	\N
159018	1397	1316637798000	20731	10421	2	0	\N
159019	2258	199000000	20731	10421	3	0	\N
159020	2133	96358728000	20731	10421	4	0	\N
159021	2133	96357726000	20731	10421	5	0	\N
159022	2134	95953889000	20731	10421	6	0	\N
159023	2133	96356724000	20731	10421	7	0	\N
159024	2132	148143144000	20731	10421	8	0	\N
159025	2134	95952886000	20731	10421	9	0	\N
159036	1397	1316607795000	20734	10423	0	0	\N
159037	2134	95949877000	20734	10423	1	0	\N
159038	2133	96353718000	20734	10423	2	0	\N
159039	1397	1316627797000	20735	10422	0	0	\N
159040	1397	1316617796000	20735	10422	1	0	\N
159041	1397	1316607795000	20735	10422	2	0	\N
159042	2132	148142143000	20735	10422	3	0	\N
159046	1397	1316597794000	20737	10424	0	0	\N
159047	2133	96352716000	20737	10424	1	0	\N
159048	2134	95948874000	20737	10424	2	0	\N
159053	1397	1316577792000	20739	10426	0	0	\N
159054	1397	1316567791000	20739	10426	1	0	\N
159055	1688	71388075113200	20739	10426	2	0	\N
159056	1688	71233243531200	20739	10426	3	0	\N
159057	1688	71094449872200	20739	10426	4	0	\N
159058	1688	71036028319200	20739	10426	5	0	\N
159059	2134	95946868000	20739	10426	6	0	\N
159060	2133	96350712000	20739	10426	7	0	\N
159061	2133	96349710000	20739	10426	8	0	\N
159062	2134	95945865000	20739	10426	9	0	\N
159080	1688	70393491800200	20742	10427	0	0	\N
159081	1688	65253373610200	20742	10427	1	0	\N
159082	1397	1316557790000	20742	10427	2	0	\N
159083	1688	64786080640200	20742	10427	3	0	\N
159084	2134	95944862000	20742	10427	4	0	\N
159085	2133	96348708000	20742	10427	5	0	\N
159086	2132	148140141000	20742	10427	6	0	\N
159087	1688	59645962450200	20743	10428	0	0	\N
159088	1688	59529129345200	20743	10428	1	0	\N
159089	1688	58244066307200	20743	10428	2	0	\N
159090	1397	1316547789000	20743	10428	3	0	\N
159091	2133	96347706000	20743	10428	4	0	\N
159092	2134	95943859000	20743	10428	5	0	\N
159104	1688	57864390111200	20746	10430	0	0	\N
159105	1688	57543086204200	20746	10430	1	0	\N
159106	1397	1316527787000	20746	10430	2	0	\N
159107	1688	57317026881200	20746	10430	3	0	\N
159108	2133	96345702000	20746	10430	4	0	\N
159109	2132	148139140000	20746	10430	5	0	\N
159110	2134	95941853000	20746	10430	6	0	\N
159118	1688	54830476494200	20748	10431	0	0	\N
159119	1397	1316517786000	20748	10431	1	0	\N
159120	1688	51203162402200	20748	10431	2	0	\N
158998	1397	1316667801000	20729	10420	2	0	12216
158999	2134	95956898000	20729	10420	3	0	3034
159000	2134	95955895000	20729	10420	4	0	3035
159001	2132	148144145000	20729	10420	5	0	855
159002	2134	95954892000	20729	10420	6	0	3036
159004	2133	96360732000	20729	10420	8	0	2634
159005	2133	96359730000	20729	10420	9	0	2635
159006	1397	1316657800000	20730	10421	0	0	12217
159007	1397	1316647799000	20730	10421	1	0	12218
159008	1397	1316637798000	20730	10421	2	0	12219
159010	2133	96358728000	20730	10421	4	0	2636
159011	2133	96357726000	20730	10421	5	0	2637
159012	2134	95953889000	20730	10421	6	0	3037
159013	2133	96356724000	20730	10421	7	0	2638
159015	2134	95952886000	20730	10421	9	0	3038
159026	1397	1316627797000	20732	10422	0	0	12220
159027	1397	1316617796000	20732	10422	1	0	12221
159028	2134	95951883000	20732	10422	2	0	3039
159029	2133	96355722000	20732	10422	3	0	2639
159031	2132	148142143000	20732	10422	5	0	857
159032	2134	95950880000	20732	10422	6	0	3040
159033	1397	1316607795000	20733	10423	0	0	12222
159034	2134	95949877000	20733	10423	1	0	3041
159035	2133	96353718000	20733	10423	2	0	2641
159044	2133	96352716000	20736	10424	1	0	2642
159045	2134	95948874000	20736	10424	2	0	3042
159049	1397	1316587793000	20738	10425	0	0	12224
159050	2133	96351714000	20738	10425	1	0	2643
159052	2134	95947871000	20738	10425	3	0	3043
159063	1397	1316577792000	20740	10426	0	0	12225
159064	1397	1316567791000	20740	10426	1	0	12226
159065	1688	71388075113200	20740	10426	2	0	39
159066	1688	71233243531200	20740	10426	3	0	40
159068	1688	71036028319200	20740	10426	5	0	42
159069	2134	95946868000	20740	10426	6	0	3044
159070	2133	96350712000	20740	10426	7	0	2644
159071	2133	96349710000	20740	10426	8	0	2645
159072	2134	95945865000	20740	10426	9	0	3045
159074	1688	65253373610200	20741	10427	1	0	44
159075	1397	1316557790000	20741	10427	2	0	12227
159076	1688	64786080640200	20741	10427	3	0	45
159077	2134	95944862000	20741	10427	4	0	3046
159079	2132	148140141000	20741	10427	6	0	859
159093	1688	59645962450200	20744	10428	0	0	46
159094	1688	59529129345200	20744	10428	1	0	47
159095	1688	58244066307200	20744	10428	2	0	48
159096	1397	1316547789000	20744	10428	3	0	12228
159098	2134	95943859000	20744	10428	5	0	3047
159099	1688	58214853148200	20745	10429	0	0	49
159100	1688	57893608673200	20745	10429	1	0	50
159101	1397	1316537788000	20745	10429	2	0	12229
159102	2134	95942856000	20745	10429	3	0	3048
159111	1688	57864390111200	20747	10430	0	0	51
159112	1688	57543086204200	20747	10430	1	0	52
159113	1397	1316527787000	20747	10430	2	0	12230
159114	1688	57317026881200	20747	10430	3	0	53
159116	2132	148139140000	20747	10430	5	0	860
159117	2134	95941853000	20747	10430	6	0	3049
159121	1688	11302842210200	20748	10431	3	0	\N
159122	2134	95940850000	20748	10431	4	0	\N
159123	2133	96344700000	20748	10431	5	0	\N
159124	1688	54830476494200	20749	10431	0	0	\N
159125	1397	1316517786000	20749	10431	1	0	\N
159126	1688	51203162402200	20749	10431	2	0	\N
159127	1688	11302842210200	20749	10431	3	0	\N
159128	2134	95940850000	20749	10431	4	0	\N
159129	2133	96344700000	20749	10431	5	0	\N
159149	1397	1316497784000	20753	10433	0	0	\N
159150	2133	96342696000	20753	10433	1	0	\N
159151	2134	95938844000	20753	10433	2	0	\N
159152	1726	14510112000	20753	10433	3	0	\N
159153	2132	148138139000	20753	10433	4	0	\N
159154	1397	1316497784000	20754	10433	0	0	\N
159155	2133	96342696000	20754	10433	1	0	\N
159156	2134	95938844000	20754	10433	2	0	\N
159157	1726	14510112000	20754	10433	3	0	\N
159158	2132	148138139000	20754	10433	4	0	\N
159159	1397	1316487783000	20755	10434	0	0	\N
159160	1679	28128547709000	20755	10434	1	0	\N
159161	1679	27978365513000	20755	10434	2	0	\N
159162	1679	27698380388000	20755	10434	3	0	\N
159163	2133	96341694000	20755	10434	4	0	\N
159164	2134	95937841000	20755	10434	5	0	\N
159171	1646	1438913000000	20760	10422	0	0	\N
159172	1646	1437813000000	20760	10422	1	0	\N
159173	1397	1316627797000	20760	10422	2	0	\N
159174	1397	1316617796000	20760	10422	3	0	\N
159175	1397	1316607795000	20760	10422	4	0	\N
159176	1679	28128547709000	20760	10422	5	0	\N
159177	1688	71388075113200	20760	10422	6	0	\N
159178	1688	71233243531200	20760	10422	7	0	\N
159179	1698	21813639378297	20760	10422	8	0	\N
159180	1679	27978365513000	20760	10422	9	0	\N
159181	1679	27698380388000	20760	10422	10	0	\N
159182	1679	25625486252000	20760	10422	11	0	\N
159183	1679	21609986866000	20760	10422	12	0	\N
159184	1698	19351753841201	20760	10422	13	0	\N
159185	1698	14940083972065	20760	10422	14	0	\N
159186	1698	11963439149826	20760	10422	15	0	\N
159187	1688	71094449872200	20760	10422	16	0	\N
159188	1688	71036028319200	20760	10422	17	0	\N
159189	1688	70393491800200	20760	10422	18	0	\N
159190	1688	65253373610200	20760	10422	19	0	\N
159191	1688	64786080640200	20760	10422	20	0	\N
159192	1688	59645962450200	20760	10422	21	0	\N
159193	1688	59529129345200	20760	10422	22	0	\N
159194	1688	58244066307200	20760	10422	23	0	\N
159195	1688	58214853148200	20760	10422	24	0	\N
159196	1688	57893608673200	20760	10422	25	0	\N
159197	1688	57864390111200	20760	10422	26	0	\N
159198	1688	57543086204200	20760	10422	27	0	\N
159199	1698	3668771550062	20760	10422	28	0	\N
159200	1397	1316597794000	20760	10422	29	0	\N
159201	1397	1316587793000	20760	10422	30	0	\N
159202	1397	1316577792000	20760	10422	31	0	\N
159203	1397	1316567791000	20760	10422	32	0	\N
159204	1397	1316557790000	20760	10422	33	0	\N
159205	1397	1316547789000	20760	10422	34	0	\N
159206	1397	1316537788000	20760	10422	35	0	\N
159207	1397	1316527787000	20760	10422	36	0	\N
159208	1397	1316517786000	20760	10422	37	0	\N
159209	1679	21167204552000	20760	10422	38	0	\N
159210	1397	1316507785000	20760	10422	39	0	\N
159211	1397	1316497784000	20760	10422	40	0	\N
159212	1397	1316487783000	20760	10422	41	0	\N
159213	1397	1316477782000	20760	10422	42	0	\N
159214	1397	1316467781000	20760	10422	43	0	\N
159215	1397	1316457780000	20760	10422	44	0	\N
159216	1679	20932984592000	20760	10422	45	0	\N
159217	1679	20342417677000	20760	10422	46	0	\N
159218	1679	19526710919000	20760	10422	47	0	\N
159219	1688	57317026881200	20760	10422	48	0	\N
159220	1688	54830476494200	20760	10422	49	0	\N
159221	1688	51203162402200	20760	10422	50	0	\N
159222	1688	11302842210200	20760	10422	51	0	\N
159223	1688	4318631910200	20760	10422	52	0	\N
159224	2132	148142143000	20760	10422	53	0	\N
159225	2132	148141142000	20760	10422	54	0	\N
159226	2132	148140141000	20760	10422	55	0	\N
159227	2132	148139140000	20760	10422	56	0	\N
159228	1726	14510112000	20760	10422	57	0	\N
159229	2132	148138139000	20760	10422	58	0	\N
159230	2132	148137138000	20760	10422	59	0	\N
159245	1656	13446631999990	20762	10361	0	0	\N
159246	1656	9034511999990	20762	10361	1	0	\N
159247	1656	6057391999990	20762	10361	2	0	\N
159248	1656	3595271999990	20762	10361	3	0	\N
159249	1679	28128547709000	20762	10361	4	0	\N
159250	1688	70668064113200	20762	10361	5	0	\N
159251	1688	70513232531200	20762	10361	6	0	\N
159252	1698	21093634378297	20762	10361	7	0	\N
159253	1679	27978365513000	20762	10361	8	0	\N
159254	1679	27698380388000	20762	10361	9	0	\N
159255	1679	25625486252000	20762	10361	10	0	\N
159256	1679	21609986866000	20762	10361	11	0	\N
159132	1688	51203162402200	20750	10431	2	0	55
159133	1688	11302842210200	20750	10431	3	0	56
159134	2134	95940850000	20750	10431	4	0	3050
159135	2133	96344700000	20750	10431	5	0	2650
159136	1698	21813639378297	20751	10432	0	0	8
159138	1698	14940083972065	20751	10432	2	0	10
159139	1698	11963439149826	20751	10432	3	0	11
159140	1698	3668771550062	20751	10432	4	0	12
159141	1397	1316507785000	20751	10432	5	0	12232
159142	2133	96343698000	20751	10432	6	0	2651
159144	1397	1316497784000	20752	10433	0	0	12233
159145	2133	96342696000	20752	10433	1	0	2652
159146	2134	95938844000	20752	10433	2	0	3052
159147	1726	14510112000	20752	10433	3	0	8275
159165	1397	1316487783000	20756	10434	0	0	12234
159166	1679	28128547709000	20756	10434	1	0	51
159167	1679	27978365513000	20756	10434	2	0	52
159168	1679	27698380388000	20756	10434	3	0	53
159169	2133	96341694000	20756	10434	4	0	2653
159231	1646	1438913000000	20761	10436	0	0	1
159232	1646	1437813000000	20761	10436	1	0	2
159233	1679	25625486252000	20761	10436	2	0	54
159234	1679	21609986866000	20761	10436	3	0	55
159235	1397	1316477782000	20761	10436	4	0	12235
159237	1679	21167204552000	20761	10436	6	0	56
159238	1679	20932984592000	20761	10436	7	0	57
159239	1679	20342417677000	20761	10436	8	0	58
159240	1679	19526710919000	20761	10436	9	0	59
159242	2133	96340692000	20761	10436	11	0	2654
159243	2134	95936838000	20761	10436	12	0	3054
159244	2133	96339690000	20761	10436	13	0	2655
159257	1698	18631748841201	20762	10361	12	0	\N
159258	1698	14220078972065	20762	10361	13	0	\N
159259	1698	11243434149826	20762	10361	14	0	\N
159260	1688	70374438872200	20762	10361	15	0	\N
159261	1688	70316017319200	20762	10361	16	0	\N
159262	1688	69673480800200	20762	10361	17	0	\N
159263	1688	64533362610200	20762	10361	18	0	\N
159264	1688	64066069640200	20762	10361	19	0	\N
159265	1688	58925951450200	20762	10361	20	0	\N
159266	1688	58809118345200	20762	10361	21	0	\N
159267	1688	57524055307200	20762	10361	22	0	\N
159268	1688	57494842148200	20762	10361	23	0	\N
159269	1688	57173597673200	20762	10361	24	0	\N
159270	1688	57144379111200	20762	10361	25	0	\N
159271	1688	56823075204200	20762	10361	26	0	\N
159272	1698	2948766550062	20762	10361	27	0	\N
159273	1397	1316897824000	20762	10361	28	0	\N
159274	1397	1316887823000	20762	10361	29	0	\N
159275	1397	1316877822000	20762	10361	30	0	\N
159276	1397	1316867821000	20762	10361	31	0	\N
159277	1397	1316857820000	20762	10361	32	0	\N
159278	1397	1316847819000	20762	10361	33	0	\N
159279	1397	1316837818000	20762	10361	34	0	\N
159280	1397	1316827817000	20762	10361	35	0	\N
159281	1397	1316817816000	20762	10361	36	0	\N
159282	1397	1316807815000	20762	10361	37	0	\N
159283	1679	21167204552000	20762	10361	38	0	\N
159284	1679	20932984592000	20762	10361	39	0	\N
159285	1688	56597015881200	20762	10361	40	0	\N
159286	1688	54110465494200	20762	10361	41	0	\N
159287	1688	50483151402200	20762	10361	42	0	\N
159288	1688	10582831210200	20762	10361	43	0	\N
159289	1688	3598620910200	20762	10361	44	0	\N
159290	1397	1316797814000	20762	10361	45	0	\N
159291	1397	1316787813000	20762	10361	46	0	\N
159292	1397	1316777812000	20762	10361	47	0	\N
159293	1397	1316767811000	20762	10361	48	0	\N
159294	1397	1316757810000	20762	10361	49	0	\N
159295	1397	1316747809000	20762	10361	50	0	\N
159296	1397	1316737808000	20762	10361	51	0	\N
159297	1397	1316727807000	20762	10361	52	0	\N
159298	1397	1316717806000	20762	10361	53	0	\N
159299	1397	1316707805000	20762	10361	54	0	\N
159300	1397	1316697804000	20762	10361	55	0	\N
159301	1397	1316687803000	20762	10361	56	0	\N
159302	1397	1316677802000	20762	10361	57	0	\N
159303	1397	1316667801000	20762	10361	58	0	\N
159304	1397	1316657800000	20762	10361	59	0	\N
159305	1397	1316647799000	20762	10361	60	0	\N
159306	1397	1316637798000	20762	10361	61	0	\N
159307	1397	1316627797000	20762	10361	62	0	\N
159308	1397	1316617796000	20762	10361	63	0	\N
159309	1397	1316607795000	20762	10361	64	0	\N
159310	1397	1316597794000	20762	10361	65	0	\N
159311	1397	1316587793000	20762	10361	66	0	\N
159312	1397	1316577792000	20762	10361	67	0	\N
159313	1397	1316567791000	20762	10361	68	0	\N
159314	1397	1316557790000	20762	10361	69	0	\N
159315	1397	1316547789000	20762	10361	70	0	\N
159316	1397	1316537788000	20762	10361	71	0	\N
159317	1397	1316527787000	20762	10361	72	0	\N
159318	1397	1316517786000	20762	10361	74	0	\N
159319	1397	1316507785000	20762	10361	75	0	\N
159320	1397	1316497784000	20762	10361	76	0	\N
159321	1397	1316487783000	20762	10361	77	0	\N
159322	1397	1316477782000	20762	10361	78	0	\N
159323	1397	1316467781000	20762	10361	79	0	\N
159324	2258	199000000	20762	10361	80	0	\N
159325	1726	15711112000	20762	10361	81	0	\N
159326	579	66000004000000	20762	10361	82	0	\N
159327	2133	96381774000	20762	10361	83	0	\N
159328	2133	96380772000	20762	10361	84	0	\N
159329	2133	96379770000	20762	10361	85	0	\N
159330	1726	14510112000	20762	10361	86	0	\N
159331	2133	96378768000	20762	10361	87	0	\N
159332	2133	96377766000	20762	10361	88	0	\N
159333	2133	96376764000	20762	10361	89	0	\N
159334	2134	95981973000	20762	10361	90	0	\N
159335	2134	95980970000	20762	10361	91	0	\N
159336	2134	95979967000	20762	10361	92	0	\N
159337	2134	95978964000	20762	10361	93	0	\N
159338	2134	95977961000	20762	10361	94	0	\N
159339	2134	95976958000	20762	10361	95	0	\N
159340	2134	95975955000	20762	10361	96	0	\N
159341	2134	95974952000	20762	10361	97	0	\N
159342	2134	95973949000	20762	10361	98	0	\N
159343	2134	95972946000	20762	10361	99	0	\N
159344	2134	95971943000	20762	10361	100	0	\N
159345	2134	95970940000	20762	10361	101	0	\N
159346	2134	95969937000	20762	10361	102	0	\N
159347	2134	95968934000	20762	10361	103	0	\N
159348	2134	95967931000	20762	10361	104	0	\N
159349	2134	95966928000	20762	10361	105	0	\N
159350	2134	95965925000	20762	10361	106	0	\N
159351	2134	95964922000	20762	10361	107	0	\N
159352	2133	96375762000	20762	10361	108	0	\N
159353	2133	96374760000	20762	10361	109	0	\N
159354	2133	96373758000	20762	10361	110	0	\N
159355	2133	96372756000	20762	10361	111	0	\N
159356	2134	95963919000	20762	10361	112	0	\N
159357	2133	96371754000	20762	10361	113	0	\N
159358	2133	96370752000	20762	10361	114	0	\N
159359	2133	96369750000	20762	10361	115	0	\N
159360	2132	148160161000	20762	10361	116	0	\N
159361	2132	148159160000	20762	10361	117	0	\N
159362	2132	148158159000	20762	10361	118	0	\N
159363	1646	1438913000000	20763	10416	0	0	\N
159364	1646	1437813000000	20763	10416	1	0	\N
159365	1679	28128547709000	20763	10416	2	0	\N
159366	1688	71388075113200	20763	10416	3	0	\N
159367	1688	71233243531200	20763	10416	4	0	\N
159368	1698	21813639378297	20763	10416	5	0	\N
159369	1679	27978365513000	20763	10416	6	0	\N
159370	1679	27698380388000	20763	10416	7	0	\N
159371	1679	25625486252000	20763	10416	8	0	\N
159372	1679	21609986866000	20763	10416	9	0	\N
159373	1698	19351753841201	20763	10416	10	0	\N
159374	1698	14940083972065	20763	10416	11	0	\N
159375	1698	11963439149826	20763	10416	12	0	\N
159376	1688	71094449872200	20763	10416	13	0	\N
159377	1688	71036028319200	20763	10416	15	0	\N
159378	1688	70393491800200	20763	10416	16	0	\N
159379	1688	65253373610200	20763	10416	17	0	\N
159380	1688	64786080640200	20763	10416	18	0	\N
159381	1688	59645962450200	20763	10416	19	0	\N
159382	1688	59529129345200	20763	10416	20	0	\N
159383	1688	58244066307200	20763	10416	21	0	\N
159384	1688	58214853148200	20763	10416	22	0	\N
159385	1688	57893608673200	20763	10416	23	0	\N
159386	1688	57864390111200	20763	10416	24	0	\N
159387	1688	57543086204200	20763	10416	25	0	\N
159388	1698	3668771550062	20763	10416	26	0	\N
159389	1679	21167204552000	20763	10416	27	0	\N
159390	1679	20932984592000	20763	10416	28	0	\N
159391	1679	20342417677000	20763	10416	29	0	\N
159392	1679	19526710919000	20763	10416	30	0	\N
159393	1688	57317026881200	20763	10416	31	0	\N
159394	1688	54830476494200	20763	10416	32	0	\N
159395	1688	51203162402200	20763	10416	33	0	\N
159396	1688	11302842210200	20763	10416	34	0	\N
159397	1688	4318631910200	20763	10416	35	0	\N
159398	2258	199000000	20763	10416	36	0	\N
159399	1726	14510112000	20763	10416	37	0	\N
159400	1646	1438913000000	20764	10436	0	0	\N
159401	1679	25625486252000	20764	10436	1	0	\N
159402	1679	21609986866000	20764	10436	2	0	\N
159403	1397	1316477782000	20764	10436	3	0	\N
159404	1397	1316467781000	20764	10436	4	0	\N
159405	1679	21167204552000	20764	10436	5	0	\N
159406	1679	20932984592000	20764	10436	6	0	\N
159407	1679	20342417677000	20764	10436	7	0	\N
159408	2132	148137138000	20764	10436	8	0	\N
159409	2133	96340692000	20764	10436	9	0	\N
159410	2134	95936838000	20764	10436	10	0	\N
159411	2133	96339690000	20764	10436	11	0	\N
159412	1646	1437813000000	20765	10437	0	0	\N
159413	1679	19526710919000	20765	10437	1	0	\N
159414	1679	18810610696000	20765	10437	2	0	\N
159415	1679	14449449713000	20765	10437	3	0	\N
159416	1679	13983048536000	20765	10437	4	0	\N
159417	1397	1316457780000	20765	10437	5	0	\N
159418	2133	96338688000	20765	10437	6	0	\N
159424	1646	1438913000000	20767	10436	0	0	\N
159425	1646	1437813000000	20767	10436	1	0	\N
159426	1679	25625486252000	20767	10436	2	0	\N
159427	1679	21609986866000	20767	10436	3	0	\N
159428	1397	1316477782000	20767	10436	4	0	\N
159429	1397	1316467781000	20767	10436	5	0	\N
159430	1679	21167204552000	20767	10436	6	0	\N
159431	1679	20932984592000	20767	10436	7	0	\N
159432	1679	20342417677000	20767	10436	8	0	\N
159433	1679	19526710919000	20767	10436	9	0	\N
159434	2132	148137138000	20767	10436	10	0	\N
159435	2133	96340692000	20767	10436	11	0	\N
159436	2134	95936838000	20767	10436	12	0	\N
159437	2133	96339690000	20767	10436	13	0	\N
159438	1679	18810610696000	20768	10437	0	0	\N
159439	1679	14449449713000	20768	10437	1	0	\N
159440	1679	13983048536000	20768	10437	2	0	\N
159441	1397	1316457780000	20768	10437	3	0	\N
159442	2133	96338688000	20768	10437	4	0	\N
159446	1397	1316447779000	20770	10438	0	0	\N
159447	2133	96337686000	20770	10438	1	0	\N
159448	1646	1713000000	20771	10439	0	0	\N
159449	1679	12690835652000	20771	10439	1	0	\N
159450	1679	12529301542000	20771	10439	2	0	\N
159451	1679	12047208297000	20771	10439	3	0	\N
159452	1679	11642515252000	20771	10439	4	0	\N
159453	1679	10754122645000	20771	10439	5	0	\N
159454	1679	10636923672000	20771	10439	6	0	\N
159455	1397	1316437778000	20771	10439	7	0	\N
159456	1397	1316427777000	20771	10439	8	0	\N
159457	2133	96336684000	20771	10439	9	0	\N
159458	2133	96335682000	20771	10439	10	0	\N
159459	2132	148136137000	20771	10439	11	0	\N
159460	1646	1713000000	20772	10439	0	0	\N
159461	1679	12690835652000	20772	10439	1	0	\N
159462	1679	12529301542000	20772	10439	2	0	\N
159463	1679	12047208297000	20772	10439	3	0	\N
159464	1679	11642515252000	20772	10439	4	0	\N
159465	1679	10754122645000	20772	10439	5	0	\N
159466	1679	10636923672000	20772	10439	6	0	\N
159467	1397	1316437778000	20772	10439	7	0	\N
159468	1397	1316427777000	20772	10439	8	0	\N
159469	2133	96336684000	20772	10439	9	0	\N
159470	2133	96335682000	20772	10439	10	0	\N
159471	2132	148136137000	20772	10439	11	0	\N
159484	1646	1713000000	20774	10439	0	0	\N
159485	1679	12690835652000	20774	10439	1	0	\N
159486	1679	12529301542000	20774	10439	2	0	\N
159487	1679	12047208297000	20774	10439	3	0	\N
159488	1679	11642515252000	20774	10439	4	0	\N
159489	1679	10754122645000	20774	10439	5	0	\N
159490	1679	10636923672000	20774	10439	6	0	\N
159491	1397	1316437778000	20774	10439	7	0	\N
159492	1397	1316427777000	20774	10439	8	0	\N
159493	2133	96336684000	20774	10439	9	0	\N
159494	2133	96335682000	20774	10439	10	0	\N
159495	2132	148136137000	20774	10439	11	0	\N
159496	1646	1713000000	20775	10439	0	0	\N
159497	1397	1316437778000	20775	10439	1	0	\N
159498	1397	1316427777000	20775	10439	2	0	\N
159499	2133	96336684000	20775	10439	3	0	\N
159500	2133	96335682000	20775	10439	4	0	\N
159501	2132	148136137000	20775	10439	5	0	\N
159513	1397	1316407775000	20778	10441	0	0	\N
159514	1397	1316397774000	20778	10441	1	0	\N
159515	2132	148135136000	20778	10441	2	0	\N
159516	2133	96333678000	20778	10441	3	0	\N
159517	2133	96332676000	20778	10441	4	0	\N
159421	1679	13983048536000	20766	10437	2	0	62
159422	1397	1316457780000	20766	10437	3	0	12237
159423	2133	96338688000	20766	10437	4	0	2656
159443	1679	13740752370000	20769	10438	0	0	63
159444	1397	1316447779000	20769	10438	1	0	12238
159472	1646	1713000000	20773	10439	0	0	3
159473	1679	12690835652000	20773	10439	1	0	64
159474	1679	12529301542000	20773	10439	2	0	65
159475	1679	12047208297000	20773	10439	3	0	66
159476	1679	11642515252000	20773	10439	4	0	67
159478	1679	10636923672000	20773	10439	6	0	69
159479	1397	1316437778000	20773	10439	7	0	12239
159480	1397	1316427777000	20773	10439	8	0	12240
159481	2133	96336684000	20773	10439	9	0	2658
159483	2132	148136137000	20773	10439	11	0	863
159502	1679	10567057725000	20776	10440	0	0	70
159503	1397	1316417776000	20776	10440	1	0	12241
159504	1679	10357066381000	20776	10440	2	0	71
159505	1679	9601931165000	20776	10440	3	0	72
159507	1679	8341882365000	20777	10441	0	0	73
159508	1397	1316407775000	20777	10441	1	0	12242
159509	1397	1316397774000	20777	10441	2	0	12243
159510	2132	148135136000	20777	10441	3	0	864
159511	2133	96333678000	20777	10441	4	0	2661
159518	1397	1316387773000	20779	10442	0	0	12244
159519	2133	96331674000	20779	10442	1	0	2663
159520	1440	5845163045924	20780	10443	0	0	9
159521	1397	1316377772000	20780	10443	1	0	12245
159523	1397	1316357770000	20780	10443	3	0	12247
159524	2133	96330672000	20780	10443	4	0	2664
159525	2132	148134135000	20780	10443	5	0	865
159526	2133	96329670000	20780	10443	6	0	2665
159527	2133	96328668000	20780	10443	7	0	2666
159536	1440	3040153045924	20783	10445	0	0	\N
159537	596	67094752000000	20783	10445	1	0	\N
159538	1397	1316337768000	20783	10445	2	0	\N
159539	1688	5038675910100	20783	10445	3	0	\N
159540	2132	148133134000	20783	10445	4	0	\N
159541	2133	96326664000	20783	10445	5	0	\N
159542	1440	3040153045924	20785	10445	0	0	\N
159543	596	67094752000000	20785	10445	1	0	\N
159544	1397	1316337768000	20785	10445	2	0	\N
159545	1688	5038675910100	20785	10445	3	0	\N
159546	2132	148133134000	20785	10445	4	0	\N
159547	2133	96326664000	20785	10445	5	0	\N
159548	1656	13446631999990	20786	10358	0	0	\N
159549	1656	9034511999990	20786	10358	1	0	\N
159550	1656	6057391999990	20786	10358	2	0	\N
159551	1656	3595271999990	20786	10358	3	0	\N
159552	1646	1438913000000	20786	10358	4	0	\N
159553	1646	1437813000000	20786	10358	5	0	\N
159554	1646	1713000000	20786	10358	6	0	\N
159555	596	67094752000000	20786	10358	7	0	\N
159556	1679	28128547709000	20786	10358	8	0	\N
159557	1688	70668064113200	20786	10358	9	0	\N
159558	1688	70513232531200	20786	10358	10	0	\N
159559	1698	21093634378297	20786	10358	11	0	\N
159560	1679	27978365513000	20786	10358	12	0	\N
159561	1679	27698380388000	20786	10358	13	0	\N
159562	1679	25625486252000	20786	10358	14	0	\N
159563	1679	21609986866000	20786	10358	15	0	\N
159564	1698	18631748841201	20786	10358	16	0	\N
159565	1698	14220078972065	20786	10358	17	0	\N
159566	1698	11243434149826	20786	10358	18	0	\N
159567	1688	70374438872200	20786	10358	19	0	\N
159568	1688	70316017319200	20786	10358	20	0	\N
159569	1688	69673480800200	20786	10358	21	0	\N
159570	1688	64533362610200	20786	10358	22	0	\N
159571	1397	1317057840000	20786	10358	23	0	\N
159572	1397	1317047839000	20786	10358	24	0	\N
159573	1688	64066069640200	20786	10358	25	0	\N
159574	1688	58925951450200	20786	10358	26	0	\N
159575	1688	58809118345200	20786	10358	27	0	\N
159576	1688	57524055307200	20786	10358	28	0	\N
159577	1688	57494842148200	20786	10358	29	0	\N
159578	1688	57173597673200	20786	10358	30	0	\N
159579	1688	57144379111200	20786	10358	31	0	\N
159580	1688	56823075204200	20786	10358	32	0	\N
159581	1698	2948766550062	20786	10358	33	0	\N
159582	1679	21167204552000	20786	10358	34	0	\N
159583	1397	1317037838000	20786	10358	35	0	\N
159584	1679	20932984592000	20786	10358	36	0	\N
159585	1679	20342417677000	20786	10358	37	0	\N
159586	1397	1316327767000	20787	10446	0	0	\N
159587	2133	96325662000	20787	10446	1	0	\N
159597	596	67094432000000	20791	10449	0	0	\N
159598	1397	1316297764000	20791	10449	1	0	\N
159599	2132	148132133000	20791	10449	2	0	\N
159600	2133	96323658000	20791	10449	3	0	\N
159620	1397	1316267761000	20796	10452	0	0	\N
159621	1706	12183326489116	20796	10452	1	0	\N
159622	1706	9800864302936	20796	10452	2	0	\N
159623	1706	3161939450256	20796	10452	3	0	\N
159624	2132	148131132000	20796	10452	4	0	\N
159625	2133	96320652000	20796	10452	5	0	\N
159641	1397	1316187753000	20803	10458	0	0	\N
159642	2133	96312636000	20803	10458	1	0	\N
159654	1397	1316167751000	20807	10460	0	0	\N
159655	2133	96310632000	20807	10460	1	0	\N
159656	2132	148128129000	20807	10460	2	0	\N
159662	1397	1316147749000	20810	10462	0	0	\N
159663	2133	96308628000	20810	10462	1	0	\N
159664	1397	1316147749000	20811	10462	0	0	\N
159531	596	67094752000000	20782	10445	1	0	6
159532	1397	1316337768000	20782	10445	2	0	12249
159533	1688	5038675910100	20782	10445	3	0	57
159534	2132	148133134000	20782	10445	4	0	866
159535	2133	96326664000	20782	10445	5	0	2668
159589	1440	720143045924	20789	10447	0	0	11
159590	1679	3980721382000	20789	10447	1	0	74
159591	1397	1316317766000	20789	10447	2	0	12251
159592	596	67094642000000	20789	10447	3	0	7
159593	2133	96325662000	20789	10447	4	0	2669
159595	1679	3598437654000	20790	10448	1	0	75
159596	2133	96324660000	20790	10448	2	0	2670
159601	596	67094432000000	20792	10449	0	0	8
159602	1397	1316297764000	20792	10449	1	0	12253
159604	2133	96323658000	20792	10449	3	0	2671
159605	1397	1316287763000	20793	10450	0	0	12254
159606	2133	96322656000	20793	10450	1	0	2672
159607	1397	1316277762000	20794	10451	0	0	12255
159608	1706	17951519221216	20794	10451	1	0	21
159610	1706	17684817255072	20794	10451	3	0	23
159611	1706	15714360389476	20794	10451	4	0	24
159612	2133	96321654000	20794	10451	5	0	2673
159613	1397	1316267761000	20795	10452	0	0	12256
159614	1706	12183326489116	20795	10452	1	0	25
159616	1706	3161939450256	20795	10452	3	0	27
159617	2132	148131132000	20795	10452	4	0	868
159618	2133	96320652000	20795	10452	5	0	2674
159619	2133	96319650000	20795	10452	6	0	2675
159627	1397	1316247759000	20798	10454	0	0	12258
159628	2133	96318648000	20798	10454	1	0	2676
159629	1397	1316237758000	20800	10455	0	0	12259
159630	2133	96317646000	20800	10455	1	0	2677
159631	2132	148130131000	20800	10455	2	0	869
159633	2133	96316644000	20801	10456	1	0	2678
159634	1397	1316217756000	20802	10457	0	0	12261
159635	1397	1316207755000	20802	10457	1	0	12262
159636	1397	1316197754000	20802	10457	2	0	12263
159637	2133	96315642000	20802	10457	3	0	2679
159639	2132	148129130000	20802	10457	5	0	870
159640	2133	96313638000	20802	10457	6	0	2681
159643	1397	1316187753000	20804	10458	0	0	12264
159644	2133	96312636000	20804	10458	1	0	2682
159646	576	74187819517990	20805	10459	1	0	6
159647	576	71719195173600	20805	10459	2	0	7
159648	576	69677474726897	20805	10459	3	0	8
159649	576	69677454726897	20805	10459	4	0	9
159650	1397	1316177752000	20805	10459	5	0	12265
159652	1397	1316167751000	20806	10460	0	0	12266
159653	2132	148128129000	20806	10460	1	0	871
159657	1397	1316157750000	20808	10461	0	0	12267
159658	2133	96310632000	20808	10461	1	0	2684
159659	2133	96309630000	20808	10461	2	0	2685
159661	2133	96308628000	20809	10462	1	0	2686
159665	2133	96308628000	20811	10462	1	0	\N
159666	1397	1316147749000	20812	10462	0	0	\N
159667	2133	96308628000	20812	10462	1	0	\N
159673	1397	1316127747000	20815	10464	0	0	\N
159674	2133	96306624000	20815	10464	1	0	\N
159675	1397	1316127747000	20816	10464	0	0	\N
159676	2133	96306624000	20816	10464	1	0	\N
159677	1397	1316127747000	20817	10464	0	0	\N
159678	2133	96306624000	20817	10464	1	0	\N
159679	1646	1438913000000	20818	10423	0	0	\N
159680	1646	1437813000000	20818	10423	1	0	\N
159681	1646	1713000000	20818	10423	2	0	\N
159682	576	77126366225192	20818	10423	3	0	\N
159683	576	73467636517990	20818	10423	4	0	\N
159684	576	70999012173600	20818	10423	5	0	\N
159685	576	68957291726897	20818	10423	6	0	\N
159686	576	68957271726897	20818	10423	7	0	\N
159687	596	67094752000000	20818	10423	8	0	\N
159688	1440	5845163045924	20818	10423	9	0	\N
159689	1440	3040153045924	20818	10423	10	0	\N
159690	1440	720143045924	20818	10423	11	0	\N
159691	1679	28128547709000	20818	10423	12	0	\N
159692	1688	71388075113200	20818	10423	13	0	\N
159693	1688	71233243531200	20818	10423	14	0	\N
159694	1698	21813639378297	20818	10423	15	0	\N
159695	1679	27978365513000	20818	10423	16	0	\N
159696	1679	27698380388000	20818	10423	17	0	\N
159697	1679	25625486252000	20818	10423	18	0	\N
159698	1679	21609986866000	20818	10423	19	0	\N
159699	1698	19351753841201	20818	10423	20	0	\N
159700	1698	14940083972065	20818	10423	21	0	\N
159701	1698	11963439149826	20818	10423	22	0	\N
159702	1688	71094449872200	20818	10423	23	0	\N
159703	1688	71036028319200	20818	10423	24	0	\N
159704	1688	70393491800200	20818	10423	25	0	\N
159705	1688	65253373610200	20818	10423	26	0	\N
159706	1688	64786080640200	20818	10423	27	0	\N
159707	1688	59645962450200	20818	10423	28	0	\N
159708	1688	59529129345200	20818	10423	29	0	\N
159709	1688	58244066307200	20818	10423	30	0	\N
159710	1688	58214853148200	20818	10423	31	0	\N
159711	1688	57893608673200	20818	10423	32	0	\N
159712	1688	57864390111200	20818	10423	33	0	\N
159713	1688	57543086204200	20818	10423	34	0	\N
159714	1698	3668771550062	20818	10423	35	0	\N
159715	1397	1316597794000	20818	10423	36	0	\N
159716	1397	1316587793000	20818	10423	37	0	\N
159717	1397	1316577792000	20818	10423	38	0	\N
159718	1397	1316567791000	20818	10423	39	0	\N
159719	1397	1316557790000	20818	10423	40	0	\N
159720	1706	17231508221216	20818	10423	41	0	\N
159721	1706	16972659842297	20818	10423	42	0	\N
159722	1706	16964806255072	20818	10423	43	0	\N
159723	1706	14994349389476	20818	10423	44	0	\N
159724	1706	11463315489116	20818	10423	45	0	\N
159725	1397	1316547789000	20818	10423	46	0	\N
159726	1397	1316537788000	20818	10423	47	0	\N
159727	1397	1316527787000	20818	10423	48	0	\N
159728	1397	1316517786000	20818	10423	49	0	\N
159729	1679	21167204552000	20818	10423	50	0	\N
159730	1397	1316507785000	20818	10423	51	0	\N
159731	1397	1316497784000	20818	10423	52	0	\N
159732	1397	1316487783000	20818	10423	53	0	\N
159733	1397	1316477782000	20818	10423	54	0	\N
159734	1397	1316467781000	20818	10423	55	0	\N
159735	1397	1316457780000	20818	10423	56	0	\N
159736	1679	20932984592000	20818	10423	57	0	\N
159737	1679	20342417677000	20818	10423	58	0	\N
159738	1679	19526710919000	20818	10423	59	0	\N
159739	1679	18810610696000	20818	10423	60	0	\N
159740	1679	14449449713000	20818	10423	61	0	\N
159741	1679	13983048536000	20818	10423	62	0	\N
159742	1679	9621887553000	20818	10423	63	0	\N
159743	1679	9239603825000	20818	10423	64	0	\N
159744	1679	9078069715000	20818	10423	65	0	\N
159745	1679	8595976470000	20818	10423	66	0	\N
159746	1679	8191283425000	20818	10423	67	0	\N
159747	1679	7302890818000	20818	10423	68	0	\N
159748	1679	7185691845000	20818	10423	69	0	\N
159749	1679	7115825898000	20818	10423	70	0	\N
159750	1679	6905834554000	20818	10423	71	0	\N
159751	1679	6150699338000	20818	10423	72	0	\N
159752	1679	4890650538000	20818	10423	73	0	\N
159753	1679	529489555000	20818	10423	74	0	\N
159754	1679	147205827000	20818	10423	75	0	\N
159755	1706	9080853302936	20818	10423	76	0	\N
159756	1706	2441928450256	20818	10423	77	0	\N
159757	1397	1316447779000	20818	10423	78	0	\N
159758	1397	1316437778000	20818	10423	79	0	\N
159759	1397	1316427777000	20818	10423	80	0	\N
159760	1397	1316417776000	20818	10423	81	0	\N
159761	1397	1316407775000	20818	10423	82	0	\N
159762	1397	1316397774000	20818	10423	83	0	\N
159763	1397	1316387773000	20818	10423	84	0	\N
159764	1397	1316377772000	20818	10423	85	0	\N
159765	1397	1316367771000	20818	10423	86	0	\N
159766	1397	1316357770000	20818	10423	87	0	\N
159767	1397	1316347769000	20818	10423	88	0	\N
159768	1397	1316337768000	20818	10423	89	0	\N
159769	1397	1316327767000	20818	10423	90	0	\N
159770	1397	1316317766000	20818	10423	91	0	\N
159771	1397	1316307765000	20818	10423	92	0	\N
159772	1397	1316297764000	20818	10423	93	0	\N
159773	1397	1316287763000	20818	10423	94	0	\N
159774	1397	1316277762000	20818	10423	95	0	\N
159775	1397	1316267761000	20818	10423	96	0	\N
159776	1397	1316257760000	20818	10423	98	0	\N
159777	1397	1316247759000	20818	10423	99	0	\N
159778	1397	1316237758000	20818	10423	100	0	\N
159779	1397	1316227757000	20818	10423	101	0	\N
159780	1397	1316217756000	20818	10423	102	0	\N
159781	1397	1316207755000	20818	10423	103	0	\N
159782	1397	1316197754000	20818	10423	104	0	\N
159783	1397	1316187753000	20818	10423	105	0	\N
159784	1397	1316177752000	20818	10423	106	0	\N
159785	1397	1316167751000	20818	10423	107	0	\N
159786	1397	1316157750000	20818	10423	108	0	\N
159787	1397	1316147749000	20818	10423	109	0	\N
159788	1397	1316137748000	20818	10423	110	0	\N
159789	1397	1316127747000	20818	10423	111	0	\N
159790	1688	57317026881200	20818	10423	112	0	\N
159791	1688	54830476494200	20818	10423	113	0	\N
159792	1688	51203162402200	20818	10423	114	0	\N
159793	1688	11302842210200	20818	10423	115	0	\N
159794	1688	4318631910200	20818	10423	116	0	\N
159795	596	67094642000000	20818	10423	117	0	\N
159796	596	67094432000000	20818	10423	118	0	\N
159797	2132	148141142000	20818	10423	119	0	\N
159798	2132	148140141000	20818	10423	120	0	\N
159799	2132	148139140000	20818	10423	121	0	\N
159800	1726	14510112000	20818	10423	122	0	\N
159670	2133	96307626000	20813	10463	2	0	2687
159671	1397	1316127747000	20814	10464	0	0	12270
159672	2133	96306624000	20814	10464	1	0	2688
159801	2132	148138139000	20818	10423	123	0	\N
159802	2132	148137138000	20818	10423	124	0	\N
159803	2132	148136137000	20818	10423	125	0	\N
159808	1397	1316107745000	20822	10466	0	0	\N
159809	2133	96304620000	20822	10466	1	0	\N
159810	2132	148126127000	20823	10467	0	0	\N
159814	1397	1316097744000	20825	10467	0	0	\N
159815	2132	148126127000	20825	10467	1	0	\N
159816	1397	1316097744000	20826	10467	0	0	\N
159817	2133	96303618000	20826	10467	1	0	\N
159818	2132	148126127000	20826	10467	2	0	\N
159826	1397	1316067741000	20830	10470	0	0	\N
159827	2133	96300612000	20830	10470	1	0	\N
159828	2132	148125126000	20830	10470	2	0	\N
159829	1397	1316067741000	20831	10470	0	0	\N
159830	2133	96300612000	20831	10470	1	0	\N
159831	2132	148125126000	20831	10470	2	0	\N
159832	1397	1316067741000	20832	10470	0	0	\N
159833	2133	96300612000	20832	10470	1	0	\N
159834	2132	148125126000	20832	10470	2	0	\N
159835	1992	20668550990000	20833	10471	0	0	\N
159836	1397	1316057740000	20833	10471	1	0	\N
159837	2268	199000000	20833	10471	2	0	\N
159844	1646	1713000000	20836	10417	0	0	\N
159845	576	77126366225192	20836	10417	1	0	\N
159846	576	73467636517990	20836	10417	2	0	\N
159847	576	70999012173600	20836	10417	3	0	\N
159848	576	68957291726897	20836	10417	4	0	\N
159849	576	68957271726897	20836	10417	5	0	\N
159850	596	67094752000000	20836	10417	6	0	\N
159851	1992	19948539990000	20836	10417	7	0	\N
159852	1440	5845163045924	20836	10417	8	0	\N
159853	1440	3040153045924	20836	10417	9	0	\N
159854	1440	720143045924	20836	10417	10	0	\N
159855	1679	18810610696000	20836	10417	11	0	\N
159856	1679	14449449713000	20836	10417	12	0	\N
159857	1679	13983048536000	20836	10417	13	0	\N
159858	1679	9621887553000	20836	10417	14	0	\N
159859	1679	9239603825000	20836	10417	15	0	\N
159860	1679	9078069715000	20836	10417	16	0	\N
159861	1679	8595976470000	20836	10417	17	0	\N
159862	1679	8191283425000	20836	10417	18	0	\N
159863	1679	7302890818000	20836	10417	19	0	\N
159864	1679	7185691845000	20836	10417	20	0	\N
159865	1679	7115825898000	20836	10417	21	0	\N
159866	1706	17231508221216	20836	10417	22	0	\N
159867	1706	16972659842297	20836	10417	23	0	\N
159868	1706	16964806255072	20836	10417	24	0	\N
159869	1706	14994349389476	20836	10417	25	0	\N
159870	1706	11463315489116	20836	10417	26	0	\N
159871	1679	6905834554000	20836	10417	27	0	\N
159872	1679	6150699338000	20836	10417	28	0	\N
159873	1679	4890650538000	20836	10417	29	0	\N
159874	1679	529489555000	20836	10417	30	0	\N
159875	1679	147205827000	20836	10417	31	0	\N
159876	1706	9080853302936	20836	10417	32	0	\N
159877	1706	2441928450256	20836	10417	33	0	\N
159878	596	67094642000000	20836	10417	34	0	\N
159879	596	67094432000000	20836	10417	35	0	\N
159880	2268	199000000	20836	10417	36	0	\N
159881	1397	1316047739000	20837	10472	0	0	\N
159882	2133	96298608000	20837	10472	1	0	\N
159888	1397	1316037738000	20839	10473	0	0	\N
159889	1992	16419540990000	20839	10473	1	0	\N
159890	1992	13552530990000	20839	10473	2	0	\N
159891	2133	96297606000	20839	10473	3	0	\N
159892	2132	148124125000	20839	10473	4	0	\N
159893	1992	5564520990000	20840	10474	0	0	\N
159894	1397	1316027737000	20840	10474	1	0	\N
159895	2133	96296604000	20840	10474	2	0	\N
159896	1992	5564520990000	20841	10474	0	0	\N
159897	1397	1316027737000	20841	10474	1	0	\N
159898	2133	96296604000	20841	10474	2	0	\N
159905	1397	1316007735000	20845	10476	0	0	\N
159906	2133	96294600000	20845	10476	1	0	\N
159907	1397	1316007735000	20846	10476	0	0	\N
159908	2133	96294600000	20846	10476	1	0	\N
159913	1992	15699529990000	20848	10418	0	0	\N
159914	1992	12832519990000	20848	10418	1	0	\N
159915	1992	4844509990000	20848	10418	2	0	\N
159916	1992	3600499990000	20848	10418	3	0	\N
159925	1397	1315967731000	20851	10479	0	0	\N
159926	2132	148122123000	20851	10479	2	0	\N
159927	2133	96290592000	20851	10479	3	0	\N
159932	1705	16147086490145	20853	10481	0	0	\N
159933	1397	1315937728000	20853	10481	1	0	\N
159934	1397	1315927727000	20853	10481	2	0	\N
159935	1397	1315917726000	20853	10481	3	0	\N
159936	1397	1315907725000	20853	10481	4	0	\N
159806	1397	1316107745000	20821	10466	0	0	12272
159807	2133	96304620000	20821	10466	1	0	2690
159811	1397	1316097744000	20824	10467	0	0	12273
159812	2133	96303618000	20824	10467	1	0	2691
159813	2132	148126127000	20824	10467	2	0	873
159820	2133	96302616000	20827	10468	1	0	2692
159821	1397	1316077742000	20828	10469	0	0	12275
159822	2133	96301614000	20828	10469	1	0	2693
159823	1397	1316067741000	20829	10470	0	0	12276
159824	2133	96300612000	20829	10470	1	0	2694
159838	1992	20668550990000	20834	10471	0	0	1
159839	1397	1316057740000	20834	10471	1	0	12277
159840	2268	199000000	20834	10471	2	0	1
159841	2133	96299610000	20834	10471	3	0	2695
159843	2133	96298608000	20835	10472	1	0	2696
159883	1397	1316037738000	20838	10473	0	0	12279
159884	1992	16419540990000	20838	10473	1	0	2
159885	1992	13552530990000	20838	10473	2	0	3
159886	2133	96297606000	20838	10473	3	0	2697
159899	1992	5564520990000	20842	10474	0	0	4
159900	1397	1316027737000	20842	10474	1	0	12280
159901	2133	96296604000	20842	10474	2	0	2698
159902	1397	1316017736000	20843	10475	0	0	12281
159903	2133	96295602000	20843	10475	1	0	2699
159909	1397	1315997734000	20847	10477	0	0	12283
159910	2132	148123124000	20847	10477	1	0	876
159911	2133	96294600000	20847	10477	2	0	2700
159912	2133	96293598000	20847	10477	3	0	2701
159918	1397	1315987733000	20849	10478	1	0	12284
159919	1397	1315977732000	20849	10478	2	0	12285
159920	2133	96292596000	20849	10478	3	0	2702
159921	2133	96291594000	20849	10478	4	0	2703
159922	1397	1315967731000	20850	10479	0	0	12286
159924	2133	96290592000	20850	10479	3	0	2704
159928	1397	1315957730000	20852	10480	0	0	12287
159929	1397	1315947729000	20852	10480	1	0	12288
159930	2133	96289590000	20852	10480	2	0	2705
159931	2133	96288588000	20852	10480	3	0	2706
159937	2132	148121122000	20853	10481	5	0	\N
159938	2133	96287586000	20853	10481	6	0	\N
159939	2133	96286584000	20853	10481	7	0	\N
159940	2133	96285582000	20853	10481	8	0	\N
159941	2133	96284580000	20853	10481	9	0	\N
159952	1705	12977771140145	20855	10482	0	0	\N
159953	1397	1315897724000	20855	10482	1	0	\N
159954	2132	148120121000	20855	10482	2	0	\N
159955	2133	96283578000	20855	10482	3	0	\N
159960	1705	12977771140145	20857	10482	0	0	\N
159961	1397	1315897724000	20857	10482	1	0	\N
159962	2132	148120121000	20857	10482	2	0	\N
159963	2133	96283578000	20857	10482	3	0	\N
159992	1705	4880489580140	20863	10487	0	0	\N
159993	1397	1315817716000	20863	10487	1	0	\N
159994	1397	1315807715000	20863	10487	2	0	\N
159995	2133	96275562000	20863	10487	3	0	\N
159996	2133	96274560000	20863	10487	4	0	\N
160004	1397	1315777712000	20866	10489	0	0	\N
160005	2133	96271554000	20866	10489	1	0	\N
160006	1705	16147086490145	20867	10461	0	0	\N
160007	1705	12977771140145	20867	10461	1	0	\N
160008	1705	10839355040145	20867	10461	2	0	\N
160009	1705	10839335040140	20867	10461	3	0	\N
160010	1705	4880489580140	20867	10461	4	0	\N
160011	1992	20668550990000	20867	10461	5	0	\N
160012	1992	16419540990000	20867	10461	6	0	\N
160013	1992	13552530990000	20867	10461	7	0	\N
160014	1992	5564520990000	20867	10461	8	0	\N
160015	1992	4320510990000	20867	10461	9	0	\N
160016	1397	1316157750000	20867	10461	10	0	\N
160017	1397	1316147749000	20867	10461	11	0	\N
160018	1397	1316137748000	20867	10461	12	0	\N
160019	1397	1316127747000	20867	10461	13	0	\N
160020	1397	1316117746000	20867	10461	14	0	\N
160021	1397	1316107745000	20867	10461	15	0	\N
160022	1397	1316097744000	20867	10461	16	0	\N
160023	1397	1316087743000	20867	10461	17	0	\N
160024	1397	1316077742000	20867	10461	18	0	\N
160025	1397	1316067741000	20867	10461	19	0	\N
160026	1397	1316057740000	20867	10461	20	0	\N
160027	1397	1316047739000	20867	10461	21	0	\N
160028	1397	1316037738000	20867	10461	22	0	\N
160029	1397	1316027737000	20867	10461	23	0	\N
160030	1397	1316017736000	20867	10461	24	0	\N
160031	1397	1316007735000	20867	10461	25	0	\N
160032	1397	1315997734000	20867	10461	26	0	\N
160033	1397	1315987733000	20867	10461	27	0	\N
160034	1397	1315977732000	20867	10461	28	0	\N
160035	1397	1315967731000	20867	10461	29	0	\N
160036	1397	1315957730000	20867	10461	30	0	\N
160037	1397	1315947729000	20867	10461	31	0	\N
160038	1932	1382918664093	20867	10461	32	0	\N
160039	1397	1315937728000	20867	10461	33	0	\N
160040	1397	1315927727000	20867	10461	34	0	\N
160041	1397	1315917726000	20867	10461	35	0	\N
160042	1397	1315907725000	20867	10461	36	0	\N
160043	1397	1315897724000	20867	10461	37	0	\N
160044	1397	1315887723000	20867	10461	38	0	\N
160045	1397	1315877722000	20867	10461	39	0	\N
160046	1397	1315867721000	20867	10461	40	0	\N
160047	1397	1315857720000	20867	10461	41	0	\N
160048	1397	1315847719000	20867	10461	42	0	\N
160049	1397	1315837718000	20867	10461	43	0	\N
160050	1397	1315827717000	20867	10461	44	0	\N
160051	1397	1315817716000	20867	10461	45	0	\N
160052	1397	1315807715000	20867	10461	46	0	\N
160053	1397	1315797714000	20867	10461	47	0	\N
160054	1397	1315787713000	20867	10461	48	0	\N
160055	1397	1315777712000	20867	10461	49	0	\N
160056	2268	199000000	20867	10461	50	0	\N
160057	2132	148127128000	20867	10461	51	0	\N
160058	2133	96310632000	20867	10461	52	0	\N
160059	1444	10657736559999	20867	10461	53	0	\N
160060	1444	6246075689999	20867	10461	54	0	\N
160061	2133	96309630000	20867	10461	55	0	\N
160062	2133	96308628000	20867	10461	56	0	\N
160063	1444	3269439869999	20867	10461	57	0	\N
160064	1444	807563329999	20867	10461	58	0	\N
160065	2132	148126127000	20867	10461	59	0	\N
160066	2132	148125126000	20867	10461	60	0	\N
160067	2132	148124125000	20867	10461	61	0	\N
160068	2132	148123124000	20867	10461	62	0	\N
160069	2132	148122123000	20867	10461	63	0	\N
160070	2132	148121122000	20867	10461	64	0	\N
160071	2132	148120121000	20867	10461	65	0	\N
160072	2132	148119120000	20867	10461	66	0	\N
159944	1397	1315927727000	20854	10481	2	0	12290
159945	1397	1315917726000	20854	10481	3	0	12291
159946	1397	1315907725000	20854	10481	4	0	12292
159947	2132	148121122000	20854	10481	5	0	878
159948	2133	96287586000	20854	10481	6	0	2707
159950	2133	96285582000	20854	10481	8	0	2709
159951	2133	96284580000	20854	10481	9	0	2710
159956	1705	12977771140145	20856	10482	0	0	22
159957	1397	1315897724000	20856	10482	1	0	12293
159958	2132	148120121000	20856	10482	2	0	879
159964	1397	1315887723000	20858	10483	0	0	12294
159965	2133	96282576000	20858	10483	1	0	2712
159966	1705	10839355040145	20859	10484	0	0	23
159967	1705	10839335040140	20859	10484	1	0	24
159969	1397	1315867721000	20859	10484	3	0	12296
159970	1397	1315857720000	20859	10484	4	0	12297
159971	1397	1315847719000	20859	10484	5	0	12298
159972	2132	148119120000	20859	10484	6	0	880
159973	1444	10657736559999	20859	10484	7	0	9
159975	1444	3269439869999	20859	10484	9	0	11
159976	1444	807563329999	20859	10484	10	0	12
159977	2133	96281574000	20859	10484	11	0	2713
159978	2133	96280572000	20859	10484	12	0	2714
159979	2133	96279570000	20859	10484	13	0	2715
159981	1397	1315837718000	20860	10485	0	0	12299
159982	2133	96277566000	20860	10485	1	0	2717
159983	2132	148118119000	20860	10485	2	0	881
159984	1397	1315827717000	20861	10486	0	0	12300
159986	2133	96276564000	20861	10486	2	0	2718
159987	1705	4880489580140	20862	10487	0	0	25
159988	1397	1315817716000	20862	10487	1	0	12301
159989	1397	1315807715000	20862	10487	2	0	12302
159990	2133	96275562000	20862	10487	3	0	2719
159997	1397	1315797714000	20864	10488	0	0	12303
159998	1397	1315787713000	20864	10488	1	0	12304
159999	2133	96273558000	20864	10488	2	0	2721
160000	2133	96272556000	20864	10488	3	0	2722
160001	2132	148117118000	20864	10488	4	0	882
160003	2133	96271554000	20865	10489	1	0	2723
160073	2132	148118119000	20867	10461	67	0	\N
160074	2133	96307626000	20867	10461	68	0	\N
160075	2133	96306624000	20867	10461	69	0	\N
160076	2133	96305622000	20867	10461	70	0	\N
160077	2133	96304620000	20867	10461	71	0	\N
160078	2133	96303618000	20867	10461	72	0	\N
160079	2132	148117118000	20867	10461	73	0	\N
160080	2133	96302616000	20867	10461	74	0	\N
160081	2133	96301614000	20867	10461	75	0	\N
160082	2133	96300612000	20867	10461	76	0	\N
160083	2133	96299610000	20867	10461	77	0	\N
160084	2133	96298608000	20867	10461	78	0	\N
160085	2133	96297606000	20867	10461	79	0	\N
160086	2133	96296604000	20867	10461	80	0	\N
160087	2133	96295602000	20867	10461	81	0	\N
160088	2133	96294600000	20867	10461	82	0	\N
160089	2133	96293598000	20867	10461	83	0	\N
160090	2133	96292596000	20867	10461	84	0	\N
160091	2133	96291594000	20867	10461	85	0	\N
160092	2133	96290592000	20867	10461	86	0	\N
160093	2133	96289590000	20867	10461	88	0	\N
160094	2133	96288588000	20867	10461	89	0	\N
160095	2133	96287586000	20867	10461	90	0	\N
160096	2133	96286584000	20867	10461	91	0	\N
160097	2133	96285582000	20867	10461	92	0	\N
160098	2133	96284580000	20867	10461	93	0	\N
160099	2133	96283578000	20867	10461	94	0	\N
160100	2133	96282576000	20867	10461	95	0	\N
160101	2133	96281574000	20867	10461	96	0	\N
160102	2133	96280572000	20867	10461	97	0	\N
160103	2133	96279570000	20867	10461	98	0	\N
160104	2133	96278568000	20867	10461	99	0	\N
160105	2133	96277566000	20867	10461	100	0	\N
160106	2133	96276564000	20867	10461	101	0	\N
160107	2133	96275562000	20867	10461	102	0	\N
160108	2133	96274560000	20867	10461	103	0	\N
160109	2133	96273558000	20867	10461	104	0	\N
160110	2133	96272556000	20867	10461	105	0	\N
160111	2133	96271554000	20867	10461	106	0	\N
160112	1397	1315767711000	20868	10490	0	0	\N
160113	2132	148116117000	20868	10490	1	0	\N
160114	2133	96270552000	20868	10490	2	0	\N
160115	1397	1315767711000	20869	10490	0	0	\N
160116	2132	148116117000	20869	10490	1	0	\N
160117	2133	96270552000	20869	10490	2	0	\N
160125	1397	1315737708000	20872	10492	0	0	\N
160126	2133	96267546000	20872	10492	1	0	\N
160132	1397	1315717706000	20875	10494	0	0	\N
160133	1397	1315707705000	20875	10494	1	0	\N
160134	2133	96265542000	20875	10494	2	0	\N
160135	2133	96264540000	20875	10494	3	0	\N
160140	1705	16147086490145	20877	10470	0	0	\N
160141	1705	12977771140145	20877	10470	1	0	\N
160142	1705	10839355040145	20877	10470	2	0	\N
160143	1705	10839335040140	20877	10470	3	0	\N
160144	1705	4880489580140	20877	10470	4	0	\N
160145	1992	20668550990000	20877	10470	5	0	\N
160146	1992	16419540990000	20877	10470	6	0	\N
160147	1992	13552530990000	20877	10470	7	0	\N
160148	1992	5564520990000	20877	10470	8	0	\N
160149	1992	4320510990000	20877	10470	9	0	\N
160150	1397	1316067741000	20877	10470	10	0	\N
160151	1397	1316057740000	20877	10470	11	0	\N
160152	1397	1316047739000	20877	10470	12	0	\N
160153	1397	1316037738000	20877	10470	13	0	\N
160154	1397	1316027737000	20877	10470	14	0	\N
160155	1397	1316017736000	20877	10470	15	0	\N
160156	1397	1316007735000	20877	10470	16	0	\N
160157	1397	1315997734000	20877	10470	17	0	\N
160158	1397	1315987733000	20877	10470	18	0	\N
160159	1397	1315977732000	20877	10470	19	0	\N
160160	1397	1315967731000	20877	10470	20	0	\N
160161	1397	1315957730000	20877	10470	21	0	\N
160162	1397	1315947729000	20877	10470	22	0	\N
160163	1932	1382918664093	20877	10470	23	0	\N
160164	1397	1315937728000	20877	10470	24	0	\N
160165	1397	1315927727000	20877	10470	25	0	\N
160166	1397	1315917726000	20877	10470	26	0	\N
160167	1397	1315907725000	20877	10470	27	0	\N
160168	1397	1315897724000	20877	10470	28	0	\N
160169	1397	1315887723000	20877	10470	29	0	\N
160170	1397	1315877722000	20877	10470	30	0	\N
160171	1397	1315867721000	20877	10470	31	0	\N
160172	1397	1315857720000	20877	10470	32	0	\N
160173	1397	1315847719000	20877	10470	33	0	\N
160174	1397	1315837718000	20877	10470	34	0	\N
160175	1397	1315827717000	20877	10470	35	0	\N
160176	1397	1315817716000	20877	10470	36	0	\N
160177	1397	1315807715000	20877	10470	37	0	\N
160178	1397	1315797714000	20877	10470	38	0	\N
160179	1397	1315787713000	20877	10470	39	0	\N
160180	1397	1315777712000	20877	10470	40	0	\N
160181	1397	1315767711000	20877	10470	41	0	\N
160182	1397	1315757710000	20877	10470	42	0	\N
160183	1397	1315747709000	20877	10470	43	0	\N
160184	1397	1315737708000	20877	10470	44	0	\N
160185	1397	1315727707000	20877	10470	45	0	\N
160186	1397	1315717706000	20877	10470	46	0	\N
160187	1397	1315707705000	20877	10470	47	0	\N
160188	2268	199000000	20877	10470	49	0	\N
160189	2133	96300612000	20877	10470	50	0	\N
160190	2133	96299610000	20877	10470	51	0	\N
160191	2132	148125126000	20877	10470	52	0	\N
160192	2132	148124125000	20877	10470	53	0	\N
160193	2132	148123124000	20877	10470	54	0	\N
160194	2132	148122123000	20877	10470	55	0	\N
160195	2132	148121122000	20877	10470	56	0	\N
160196	2132	148120121000	20877	10470	57	0	\N
160197	2132	148119120000	20877	10470	58	0	\N
160198	1444	10657736559999	20877	10470	59	0	\N
160199	1444	6246075689999	20877	10470	60	0	\N
160200	1444	3269439869999	20877	10470	61	0	\N
160201	1444	807563329999	20877	10470	62	0	\N
160202	2132	148118119000	20877	10470	63	0	\N
160203	2133	96298608000	20877	10470	64	0	\N
160204	2133	96297606000	20877	10470	65	0	\N
160205	2132	148117118000	20877	10470	66	0	\N
160206	2132	148116117000	20877	10470	67	0	\N
160207	2132	148115116000	20877	10470	68	0	\N
160208	2133	96296604000	20877	10470	69	0	\N
160120	2133	96270552000	20870	10490	2	0	2724
160121	1397	1315757710000	20871	10491	0	0	12307
160122	1397	1315747709000	20871	10491	1	0	12308
160123	2133	96269550000	20871	10491	2	0	2725
160124	2133	96268548000	20871	10491	3	0	2726
160128	2133	96267546000	20873	10492	1	0	2727
160129	1397	1315727707000	20874	10493	0	0	12310
160130	2132	148115116000	20874	10493	1	0	884
160131	2133	96266544000	20874	10493	2	0	2728
160136	1397	1315717706000	20876	10494	0	0	12311
160138	2133	96265542000	20876	10494	2	0	2729
160139	2133	96264540000	20876	10494	3	0	2730
160209	2133	96295602000	20877	10470	70	0	\N
160210	2133	96294600000	20877	10470	71	0	\N
160211	2133	96293598000	20877	10470	72	0	\N
160212	2133	96292596000	20877	10470	73	0	\N
160213	2133	96291594000	20877	10470	74	0	\N
160214	2133	96290592000	20877	10470	75	0	\N
160215	2133	96289590000	20877	10470	76	0	\N
160216	2133	96288588000	20877	10470	77	0	\N
160217	2133	96287586000	20877	10470	78	0	\N
160218	2133	96286584000	20877	10470	79	0	\N
160219	2133	96285582000	20877	10470	80	0	\N
160220	2133	96284580000	20877	10470	81	0	\N
160221	2133	96283578000	20877	10470	82	0	\N
160222	2133	96282576000	20877	10470	83	0	\N
160223	2133	96281574000	20877	10470	84	0	\N
160224	2133	96280572000	20877	10470	85	0	\N
160225	2133	96279570000	20877	10470	86	0	\N
160226	2133	96278568000	20877	10470	87	0	\N
160227	2133	96277566000	20877	10470	88	0	\N
160228	2133	96276564000	20877	10470	89	0	\N
160229	2133	96275562000	20877	10470	90	0	\N
160230	2133	96274560000	20877	10470	91	0	\N
160231	2133	96273558000	20877	10470	92	0	\N
160232	2133	96272556000	20877	10470	93	0	\N
160233	2133	96271554000	20877	10470	94	0	\N
160234	2133	96270552000	20877	10470	95	0	\N
160235	2133	96269550000	20877	10470	96	0	\N
160236	2133	96268548000	20877	10470	97	0	\N
160237	2133	96267546000	20877	10470	98	0	\N
160238	2133	96266544000	20877	10470	99	0	\N
160239	2133	96265542000	20877	10470	100	0	\N
160240	2133	96264540000	20877	10470	101	0	\N
160246	1705	16147086490145	20880	10475	0	0	\N
160247	1705	12977771140145	20880	10475	1	0	\N
160248	1705	10839355040145	20880	10475	2	0	\N
160249	1705	10839335040140	20880	10475	3	0	\N
160250	1705	4880489580140	20880	10475	4	0	\N
160251	1992	4320510990000	20880	10475	5	0	\N
160252	1397	1316017736000	20880	10475	6	0	\N
160253	1397	1316007735000	20880	10475	7	0	\N
160254	1397	1315997734000	20880	10475	8	0	\N
160255	1397	1315987733000	20880	10475	9	0	\N
160256	1397	1315977732000	20880	10475	10	0	\N
160257	1397	1315967731000	20880	10475	11	0	\N
160258	1397	1315957730000	20880	10475	12	0	\N
160259	1397	1315947729000	20880	10475	13	0	\N
160260	1932	1382918664093	20880	10475	14	0	\N
160261	1397	1315937728000	20880	10475	15	0	\N
160262	1397	1315927727000	20880	10475	16	0	\N
160263	1397	1315917726000	20880	10475	17	0	\N
160264	1397	1315907725000	20880	10475	18	0	\N
160265	1397	1315897724000	20880	10475	19	0	\N
160266	1397	1315887723000	20880	10475	20	0	\N
160267	1397	1315877722000	20880	10475	22	0	\N
160268	1397	1315867721000	20880	10475	23	0	\N
160269	1397	1315857720000	20880	10475	24	0	\N
160270	1397	1315847719000	20880	10475	25	0	\N
160271	1397	1315837718000	20880	10475	26	0	\N
160272	1397	1315827717000	20880	10475	27	0	\N
160273	1397	1315817716000	20880	10475	28	0	\N
160274	1397	1315807715000	20880	10475	29	0	\N
160275	1397	1315797714000	20880	10475	30	0	\N
160276	1397	1315787713000	20880	10475	31	0	\N
160277	1397	1315777712000	20880	10475	32	0	\N
160278	1397	1315767711000	20880	10475	33	0	\N
160279	1397	1315757710000	20880	10475	34	0	\N
160280	1397	1315747709000	20880	10475	35	0	\N
160281	1397	1315737708000	20880	10475	36	0	\N
160282	1397	1315727707000	20880	10475	37	0	\N
160283	1397	1315717706000	20880	10475	38	0	\N
160284	1397	1315707705000	20880	10475	39	0	\N
160285	1397	1315697704000	20880	10475	40	0	\N
160286	1397	1315687703000	20880	10475	41	0	\N
160287	2133	96295602000	20880	10475	42	0	\N
160288	2132	148123124000	20880	10475	43	0	\N
160289	2132	148122123000	20880	10475	44	0	\N
160290	2132	148121122000	20880	10475	45	0	\N
160291	2132	148120121000	20880	10475	46	0	\N
160292	2132	148119120000	20880	10475	47	0	\N
160293	1444	10657736559999	20880	10475	48	0	\N
160294	1444	6246075689999	20880	10475	49	0	\N
160295	1444	3269439869999	20880	10475	50	0	\N
160296	1444	807563329999	20880	10475	51	0	\N
160297	2132	148118119000	20880	10475	52	0	\N
160298	2133	96294600000	20880	10475	53	0	\N
160299	2133	96293598000	20880	10475	54	0	\N
160300	2133	96292596000	20880	10475	55	0	\N
160301	2133	96291594000	20880	10475	56	0	\N
160302	2133	96290592000	20880	10475	57	0	\N
160303	2132	148117118000	20880	10475	58	0	\N
160304	2132	148116117000	20880	10475	59	0	\N
160305	2132	148115116000	20880	10475	60	0	\N
160306	2132	148114115000	20880	10475	61	0	\N
160307	2133	96289590000	20880	10475	62	0	\N
160308	2133	96288588000	20880	10475	63	0	\N
160309	2133	96287586000	20880	10475	64	0	\N
160310	2133	96286584000	20880	10475	65	0	\N
160311	2133	96285582000	20880	10475	66	0	\N
160312	2133	96284580000	20880	10475	67	0	\N
160313	2133	96283578000	20880	10475	68	0	\N
160314	2133	96282576000	20880	10475	69	0	\N
160315	2133	96281574000	20880	10475	70	0	\N
160316	2133	96280572000	20880	10475	71	0	\N
160317	2133	96279570000	20880	10475	72	0	\N
160318	2133	96278568000	20880	10475	73	0	\N
160319	2133	96277566000	20880	10475	74	0	\N
160320	2133	96276564000	20880	10475	75	0	\N
160321	2133	96275562000	20880	10475	76	0	\N
160322	2133	96274560000	20880	10475	77	0	\N
160323	2133	96273558000	20880	10475	78	0	\N
160324	2133	96272556000	20880	10475	79	0	\N
160325	2133	96271554000	20880	10475	80	0	\N
160326	2133	96270552000	20880	10475	81	0	\N
160327	2133	96269550000	20880	10475	82	0	\N
160328	2133	96268548000	20880	10475	83	0	\N
160329	2133	96267546000	20880	10475	84	0	\N
160330	2133	96266544000	20880	10475	85	0	\N
160331	2133	96265542000	20880	10475	86	0	\N
160332	2133	96264540000	20880	10475	87	0	\N
160333	2133	96263538000	20880	10475	88	0	\N
160334	2133	96262536000	20880	10475	89	0	\N
160336	1397	1315667701000	20882	10498	0	0	\N
160337	149	69695228000341	20882	10498	1	0	\N
160338	2133	96261534000	20882	10498	2	0	\N
160339	2132	148113114000	20882	10498	3	0	\N
160340	1397	1315667701000	20883	10498	0	0	\N
160341	149	69695228000341	20883	10498	1	0	\N
160342	2133	96261534000	20883	10498	2	0	\N
160343	2132	148113114000	20883	10498	3	0	\N
160243	2132	148114115000	20878	10495	2	0	885
160244	1397	1315687703000	20879	10496	0	0	12314
160245	2133	96262536000	20879	10496	1	0	2732
160335	1397	1315677702000	20881	10497	0	0	12315
160344	1397	1315667701000	20884	10498	0	0	12316
160350	1397	1315657700000	20887	10499	0	0	\N
160351	2133	96260532000	20887	10499	1	0	\N
160354	1397	1315647699000	20889	10500	0	0	\N
160355	2133	96259530000	20889	10500	1	0	\N
160356	1397	1315647699000	20891	10500	0	0	\N
160357	2133	96259530000	20891	10500	1	0	\N
160360	1397	1315627697000	20893	10502	0	0	\N
160361	2133	96257526000	20893	10502	1	0	\N
160362	2132	148112113000	20893	10502	2	0	\N
160370	1397	1315597694000	20897	10505	0	0	\N
160371	2133	96254520000	20897	10505	1	0	\N
160372	2132	148111112000	20897	10505	2	0	\N
160376	1397	1315587693000	20899	10506	0	0	\N
160377	2133	96253518000	20899	10506	1	0	\N
160380	1397	1315587693000	20901	10506	0	0	\N
160381	2133	96253518000	20901	10506	1	0	\N
160382	1397	1315587693000	20902	10506	0	0	\N
160383	2133	96253518000	20902	10506	1	0	\N
160384	1397	1315587693000	20903	10506	0	0	\N
160385	2133	96253518000	20903	10506	1	0	\N
160388	1397	1315567691000	20905	10508	0	0	\N
160389	1397	1315557690000	20905	10508	1	0	\N
160390	2133	96251514000	20905	10508	2	0	\N
160391	2132	148110111000	20905	10508	3	0	\N
160392	2133	96250512000	20905	10508	4	0	\N
160398	1397	1315567691000	20907	10508	0	0	\N
160399	1397	1315557690000	20907	10508	1	0	\N
160400	2133	96251514000	20907	10508	2	0	\N
160401	2132	148110111000	20907	10508	3	0	\N
160402	2133	96250512000	20907	10508	4	0	\N
160421	1705	16147086490145	20912	10467	0	0	\N
160422	1705	12977771140145	20912	10467	1	0	\N
160423	1705	10839355040145	20912	10467	2	0	\N
160424	1705	10839335040140	20912	10467	3	0	\N
160425	1705	4880489580140	20912	10467	4	0	\N
160426	1397	1316097744000	20912	10467	5	0	\N
160427	1992	20668550990000	20912	10467	6	0	\N
160428	1992	16419540990000	20912	10467	7	0	\N
160429	1992	13552530990000	20912	10467	8	0	\N
160430	1992	5564520990000	20912	10467	9	0	\N
160431	1992	4320510990000	20912	10467	10	0	\N
160432	1397	1316087743000	20912	10467	11	0	\N
160433	1397	1316077742000	20912	10467	12	0	\N
160434	1397	1316067741000	20912	10467	13	0	\N
160435	1397	1316057740000	20912	10467	14	0	\N
160436	1397	1316047739000	20912	10467	15	0	\N
160437	1397	1316037738000	20912	10467	16	0	\N
160438	1397	1316027737000	20912	10467	17	0	\N
160439	1397	1316017736000	20912	10467	18	0	\N
160440	1397	1316007735000	20912	10467	19	0	\N
160441	1397	1315997734000	20912	10467	20	0	\N
160442	1397	1315987733000	20912	10467	21	0	\N
160443	1397	1315977732000	20912	10467	22	0	\N
160444	1397	1315967731000	20912	10467	23	0	\N
160445	1397	1315957730000	20912	10467	24	0	\N
160446	1397	1315947729000	20912	10467	25	0	\N
160447	149	69695228000341	20912	10467	26	0	\N
160448	1932	1382918664093	20912	10467	27	0	\N
160449	1397	1315937728000	20912	10467	28	0	\N
160450	1397	1315927727000	20912	10467	29	0	\N
160451	1397	1315917726000	20912	10467	30	0	\N
160452	1397	1315907725000	20912	10467	31	0	\N
160453	1397	1315897724000	20912	10467	32	0	\N
160454	1397	1315887723000	20912	10467	33	0	\N
160455	1397	1315877722000	20912	10467	34	0	\N
160456	1397	1315867721000	20912	10467	35	0	\N
160457	1397	1315857720000	20912	10467	36	0	\N
160458	1397	1315847719000	20912	10467	37	0	\N
160459	1397	1315837718000	20912	10467	38	0	\N
160460	1397	1315827717000	20912	10467	39	0	\N
160461	1397	1315817716000	20912	10467	40	0	\N
160462	1397	1315807715000	20912	10467	41	0	\N
160463	1397	1315797714000	20912	10467	42	0	\N
160464	1397	1315787713000	20912	10467	43	0	\N
160465	1397	1315777712000	20912	10467	44	0	\N
160466	1397	1315767711000	20912	10467	45	0	\N
160467	1397	1315757710000	20912	10467	46	0	\N
160468	1397	1315747709000	20912	10467	47	0	\N
160469	1397	1315737708000	20912	10467	48	0	\N
160470	1397	1315727707000	20912	10467	49	0	\N
160471	1397	1315717706000	20912	10467	50	0	\N
160472	1397	1315707705000	20912	10467	51	0	\N
160473	1397	1315697704000	20912	10467	52	0	\N
160474	1397	1315687703000	20912	10467	53	0	\N
160475	1397	1315677702000	20912	10467	54	0	\N
160476	1397	1315667701000	20912	10467	55	0	\N
160477	1397	1315657700000	20912	10467	56	0	\N
160478	1397	1315647699000	20912	10467	57	0	\N
160479	1397	1315637698000	20912	10467	58	0	\N
160480	1397	1315627697000	20912	10467	59	0	\N
160347	2132	148113114000	20884	10498	3	0	886
160348	1397	1315657700000	20886	10499	0	0	12317
160349	2133	96260532000	20886	10499	1	0	2734
160352	1397	1315647699000	20888	10500	0	0	12318
160353	2133	96259530000	20888	10500	1	0	2735
160359	2133	96258528000	20892	10501	1	0	2736
160363	1397	1315627697000	20894	10502	0	0	12320
160364	2133	96257526000	20894	10502	1	0	2737
160365	2132	148112113000	20894	10502	2	0	887
160366	1397	1315617696000	20895	10503	0	0	12321
160368	1397	1315607695000	20896	10504	0	0	12322
160369	2133	96255522000	20896	10504	1	0	2739
160373	1397	1315597694000	20898	10505	0	0	12323
160374	2133	96254520000	20898	10505	1	0	2740
160378	1397	1315587693000	20900	10506	0	0	12324
160379	2133	96253518000	20900	10506	1	0	2741
160386	1397	1315577692000	20904	10507	0	0	12325
160387	2133	96252516000	20904	10507	1	0	2742
160393	1397	1315567691000	20906	10508	0	0	12326
160395	2133	96251514000	20906	10508	2	0	2743
160396	2132	148110111000	20906	10508	3	0	889
160397	2133	96250512000	20906	10508	4	0	2744
160403	1397	1315547689000	20908	10509	0	0	12328
160404	2133	96249510000	20908	10509	1	0	2745
160406	1397	1315527687000	20909	10510	1	0	12330
160407	1397	1315517686000	20909	10510	2	0	12331
160408	2133	96248508000	20909	10510	3	0	2746
160409	2132	148109110000	20909	10510	4	0	890
160411	2133	96246504000	20909	10510	6	0	2748
160412	1397	1315507685000	20910	10511	0	0	12332
160413	1397	1315497684000	20910	10511	1	0	12333
160414	1397	1315487683000	20910	10511	2	0	12334
160415	2133	96245502000	20910	10511	3	0	2749
160417	2133	96244500000	20910	10511	5	0	2750
160418	2133	96243498000	20910	10511	6	0	2751
160419	1397	1315477682000	20911	10512	0	0	12335
160420	2133	96242496000	20911	10512	1	0	2752
160481	1397	1315617696000	20912	10467	60	0	\N
160482	1397	1315607695000	20912	10467	62	0	\N
160483	1397	1315597694000	20912	10467	63	0	\N
160484	1397	1315587693000	20912	10467	64	0	\N
160485	1397	1315577692000	20912	10467	65	0	\N
160486	1397	1315567691000	20912	10467	66	0	\N
160487	1397	1315557690000	20912	10467	67	0	\N
160488	1397	1315547689000	20912	10467	68	0	\N
160489	1397	1315537688000	20912	10467	69	0	\N
160490	1397	1315527687000	20912	10467	70	0	\N
160491	1397	1315517686000	20912	10467	71	0	\N
160492	1397	1315507685000	20912	10467	72	0	\N
160493	1397	1315497684000	20912	10467	73	0	\N
160494	1397	1315487683000	20912	10467	74	0	\N
160495	1397	1315477682000	20912	10467	75	0	\N
160496	2268	199000000	20912	10467	76	0	\N
160497	1444	10657736559999	20912	10467	77	0	\N
160498	1444	6246075689999	20912	10467	78	0	\N
160499	2133	96303618000	20912	10467	79	0	\N
160500	1444	3269439869999	20912	10467	80	0	\N
160501	1444	807563329999	20912	10467	81	0	\N
160502	2132	148126127000	20912	10467	82	0	\N
160503	2132	148125126000	20912	10467	83	0	\N
160504	2132	148124125000	20912	10467	84	0	\N
160505	2132	148123124000	20912	10467	85	0	\N
160506	2132	148122123000	20912	10467	86	0	\N
160507	2132	148121122000	20912	10467	87	0	\N
160508	2132	148120121000	20912	10467	88	0	\N
160509	2132	148119120000	20912	10467	89	0	\N
160510	2132	148118119000	20912	10467	90	0	\N
160511	2132	148117118000	20912	10467	91	0	\N
160512	2132	148116117000	20912	10467	92	0	\N
160513	2132	148115116000	20912	10467	93	0	\N
160514	2132	148114115000	20912	10467	94	0	\N
160515	2132	148113114000	20912	10467	95	0	\N
160516	2132	148112113000	20912	10467	96	0	\N
160517	2132	148111112000	20912	10467	97	0	\N
160518	2132	148110111000	20912	10467	98	0	\N
160519	2132	148109110000	20912	10467	99	0	\N
160520	2132	148108109000	20912	10467	100	0	\N
160521	2133	96302616000	20912	10467	101	0	\N
160522	2133	96301614000	20912	10467	102	0	\N
160523	2133	96300612000	20912	10467	103	0	\N
160524	2133	96299610000	20912	10467	104	0	\N
160525	2133	96298608000	20912	10467	105	0	\N
160526	2133	96297606000	20912	10467	106	0	\N
160527	2133	96296604000	20912	10467	107	0	\N
160528	2133	96295602000	20912	10467	108	0	\N
160529	2133	96294600000	20912	10467	109	0	\N
160530	2133	96293598000	20912	10467	110	0	\N
160531	2133	96292596000	20912	10467	111	0	\N
160532	2133	96291594000	20912	10467	112	0	\N
160533	2133	96290592000	20912	10467	113	0	\N
160534	2133	96289590000	20912	10467	114	0	\N
160535	2133	96288588000	20912	10467	115	0	\N
160536	2133	96287586000	20912	10467	116	0	\N
160537	2133	96286584000	20912	10467	117	0	\N
160538	2133	96285582000	20912	10467	118	0	\N
160539	2133	96284580000	20912	10467	119	0	\N
160540	2133	96283578000	20912	10467	120	0	\N
160541	2133	96282576000	20912	10467	121	0	\N
160542	2133	96281574000	20912	10467	122	0	\N
160543	2133	96280572000	20912	10467	123	0	\N
160544	2133	96279570000	20912	10467	124	0	\N
160545	2133	96278568000	20912	10467	125	0	\N
160546	242	66648395291044	20913	10513	0	0	\N
160547	1397	1315467681000	20913	10513	1	0	\N
160548	2132	148107108000	20913	10513	2	0	\N
160549	2133	96241494000	20913	10513	3	0	\N
160554	242	66648395291044	20915	10513	0	0	\N
160555	1397	1315467681000	20915	10513	1	0	\N
160556	2132	148107108000	20915	10513	2	0	\N
160557	2133	96241494000	20915	10513	3	0	\N
160558	1397	1315457680000	20916	10514	0	0	\N
160559	1397	1315447679000	20916	10514	1	0	\N
160560	242	66001385291044	20916	10514	2	0	\N
160561	2133	96240492000	20916	10514	3	0	\N
160562	2133	96239490000	20916	10514	4	0	\N
160570	1397	1315437678000	20919	10515	0	0	\N
160571	2133	96238488000	20919	10515	1	0	\N
160578	1397	1315417676000	20922	10517	0	0	\N
160579	2133	96236484000	20922	10517	1	0	\N
160593	1397	1315377672000	20927	10521	0	0	\N
160594	2133	96232476000	20927	10521	1	0	\N
160600	1397	1315347669000	20930	10524	0	0	\N
160601	1397	1315337668000	20930	10524	1	0	\N
160602	1397	1315327667000	20930	10524	2	0	\N
160603	2269	648990000000	20930	10524	3	0	\N
160604	2133	96229470000	20930	10524	4	0	\N
160605	2133	96228468000	20930	10524	5	0	\N
160606	2133	96227466000	20930	10524	7	0	\N
160607	2132	148103104000	20930	10524	8	0	\N
160552	2132	148107108000	20914	10513	2	0	892
160553	2133	96241494000	20914	10513	3	0	2753
160563	1397	1315457680000	20917	10514	0	0	12337
160564	1397	1315447679000	20917	10514	1	0	12338
160565	242	66001385291044	20917	10514	2	0	2
160567	2133	96239490000	20917	10514	4	0	2755
160568	1397	1315437678000	20918	10515	0	0	12339
160569	2133	96238488000	20918	10515	1	0	2756
160572	1397	1315427677000	20920	10516	0	0	12340
160573	2039	20879545000000	20920	10516	1	0	2
160575	2132	148106107000	20920	10516	3	0	893
160576	1397	1315417676000	20921	10517	0	0	12341
160577	2133	96236484000	20921	10517	1	0	2758
160580	1397	1315407675000	20923	10518	0	0	12342
160582	2133	96235482000	20923	10518	2	0	2759
160583	2039	15238175000000	20924	10519	0	0	4
160584	2039	10662265000000	20924	10519	1	0	5
160585	1397	1315397674000	20924	10519	2	0	12343
160586	2133	96234480000	20924	10519	3	0	2760
160588	1397	1315387673000	20925	10520	0	0	12344
160589	2039	2059255000000	20925	10520	1	0	6
160590	2133	96233478000	20925	10520	2	0	2761
160591	1397	1315377672000	20926	10521	0	0	12345
160592	2133	96232476000	20926	10521	1	0	2762
160596	2132	148104105000	20928	10522	1	0	895
160597	2133	96231474000	20928	10522	2	0	2763
160598	1397	1315357670000	20929	10523	0	0	12347
160599	2133	96230472000	20929	10523	1	0	2764
160609	1397	1315337668000	20931	10524	1	0	12349
160610	1397	1315327667000	20931	10524	2	0	12350
160611	2269	648990000000	20931	10524	3	0	1
160612	2133	96229470000	20931	10524	4	0	2765
160613	2133	96228468000	20931	10524	5	0	2766
160615	2132	148103104000	20931	10524	8	0	896
160616	1397	1315317666000	20932	10525	0	0	12351
160618	1397	1315317666000	20933	10525	0	0	\N
160619	2133	96226464000	20933	10525	1	0	\N
160629	1564	10961600000000	20935	10526	0	0	\N
160630	1564	7693580000000	20935	10526	1	0	\N
160631	1564	5488560000000	20935	10526	2	0	\N
160632	1564	4026540000000	20935	10526	3	0	\N
160633	1397	1315307665000	20935	10526	4	0	\N
160634	1397	1315297664000	20935	10526	5	0	\N
160635	2133	96225462000	20935	10526	6	0	\N
160636	2133	96224460000	20935	10526	7	0	\N
160637	2132	148102103000	20935	10526	8	0	\N
160638	1564	10961600000000	20936	10526	0	0	\N
160639	1564	7693580000000	20936	10526	1	0	\N
160640	1564	5488560000000	20936	10526	2	0	\N
160641	1564	4026540000000	20936	10526	3	0	\N
160642	1397	1315307665000	20936	10526	4	0	\N
160643	1397	1315297664000	20936	10526	5	0	\N
160644	2133	96225462000	20936	10526	6	0	\N
160645	2133	96224460000	20936	10526	7	0	\N
160646	2132	148102103000	20936	10526	8	0	\N
160647	1564	10961600000000	20937	10526	0	0	\N
160648	1564	7693580000000	20937	10526	1	0	\N
160649	1564	5488560000000	20937	10526	2	0	\N
160650	1564	4026540000000	20937	10526	3	0	\N
160651	1397	1315307665000	20937	10526	4	0	\N
160652	1397	1315297664000	20937	10526	5	0	\N
160653	2133	96225462000	20937	10526	6	0	\N
160654	2133	96224460000	20937	10526	7	0	\N
160655	2132	148102103000	20937	10526	8	0	\N
160685	1397	1315197654000	20945	10534	0	0	\N
160686	1397	1315187653000	20945	10534	1	0	\N
160687	1397	1315177652000	20945	10534	2	0	\N
160688	2133	96214440000	20945	10534	3	0	\N
160689	2132	148099100000	20945	10534	4	0	\N
160690	2133	96213438000	20945	10534	5	0	\N
160691	2133	96212436000	20945	10534	6	0	\N
160699	1397	1315197654000	20947	10534	0	0	\N
160700	1397	1315187653000	20947	10534	1	0	\N
160701	1397	1315177652000	20947	10534	2	0	\N
160702	2133	96214440000	20947	10534	3	0	\N
160703	2132	148099100000	20947	10534	4	0	\N
160704	2133	96213438000	20947	10534	5	0	\N
160705	2133	96212436000	20947	10534	6	0	\N
160711	1397	1315157650000	20950	10536	0	0	\N
160712	2133	96210432000	20950	10536	1	0	\N
160715	1397	1315137648000	20952	10538	0	0	\N
160716	2133	96208428000	20952	10538	1	0	\N
160722	1397	1315117646000	20955	10540	0	0	\N
160723	2133	96206424000	20955	10540	1	0	\N
160733	2100	2930000000	20958	10542	0	0	\N
160734	1397	1315077642000	20958	10542	1	0	\N
160735	2133	96202416000	20958	10542	2	0	\N
160736	2100	2930000000	20959	10542	0	0	\N
160737	1397	1315077642000	20959	10542	1	0	\N
160738	2133	96202416000	20959	10542	2	0	\N
160742	2100	2930000000	20961	10542	0	0	\N
160743	1397	1315077642000	20961	10542	1	0	\N
160744	2133	96202416000	20961	10542	2	0	\N
160751	365	66017201000000	20964	10504	0	0	\N
160752	1564	10961600000000	20964	10504	1	0	\N
160621	1564	7693580000000	20934	10526	1	0	7
160622	1564	5488560000000	20934	10526	2	0	8
160623	1564	4026540000000	20934	10526	3	0	9
160624	1397	1315307665000	20934	10526	4	0	12352
160625	1397	1315297664000	20934	10526	5	0	12353
160627	2133	96224460000	20934	10526	7	0	2770
160628	2132	148102103000	20934	10526	8	0	897
160656	365	66017201000000	20938	10527	0	0	3
160657	1397	1315287663000	20938	10527	1	0	12354
160658	2133	96223458000	20938	10527	2	0	2771
160660	1756	3440720195609	20939	10528	1	0	6
160661	1397	1315267661000	20939	10528	2	0	12356
160662	2133	96222456000	20939	10528	3	0	2772
160663	2133	96221454000	20939	10528	4	0	2773
160665	2270	698900000000	20940	10529	0	0	1
160666	2100	1434860000000	20940	10529	1	0	3
160667	1397	1315257660000	20940	10529	2	0	12357
160668	2133	96220452000	20940	10529	3	0	2774
160669	1397	1315247659000	20941	10530	0	0	12358
160671	1516	6735106290000	20942	10531	0	0	13
160672	1516	4840470180000	20942	10531	1	0	14
160673	1397	1315237658000	20942	10531	2	0	12359
160674	2271	1899000000	20942	10531	3	0	1
160675	2133	96218448000	20942	10531	4	0	2776
160677	1516	0	20943	10532	1	0	16
160678	1397	1315227657000	20943	10532	2	0	12360
160679	2132	148100101000	20943	10532	3	0	899
160680	2133	96217446000	20943	10532	4	0	2777
160682	1397	1315207655000	20944	10533	1	0	12362
160683	2133	96216444000	20944	10533	2	0	2778
160684	2133	96215442000	20944	10533	3	0	2779
160692	1397	1315197654000	20946	10534	0	0	12363
160693	1397	1315187653000	20946	10534	1	0	12364
160695	2133	96214440000	20946	10534	3	0	2780
160696	2132	148099100000	20946	10534	4	0	900
160697	2133	96213438000	20946	10534	5	0	2781
160698	2133	96212436000	20946	10534	6	0	2782
160706	1397	1315167651000	20948	10535	0	0	12366
160708	2133	96211434000	20948	10535	2	0	2783
160709	1397	1315157650000	20949	10536	0	0	12367
160710	2133	96210432000	20949	10536	1	0	2784
160713	1397	1315147649000	20951	10537	0	0	12368
160717	1397	1315137648000	20953	10538	0	0	12369
160718	2133	96208428000	20953	10538	1	0	2786
160719	1397	1315127647000	20954	10539	0	0	12370
160720	2132	148097098000	20954	10539	1	0	902
160721	2133	96207426000	20954	10539	2	0	2787
160725	2133	96206424000	20956	10540	1	0	2788
160726	1397	1315107645000	20957	10541	0	0	12372
160727	1397	1315097644000	20957	10541	1	0	12373
160728	1397	1315087643000	20957	10541	2	0	12374
160729	2132	148096097000	20957	10541	3	0	903
160731	2133	96204420000	20957	10541	5	0	2790
160732	2133	96203418000	20957	10541	6	0	2791
160739	2100	2930000000	20960	10542	0	0	4
160740	1397	1315077642000	20960	10542	1	0	12375
160745	1397	1315067641000	20962	10543	0	0	12376
160746	1397	1315057640000	20962	10543	1	0	12377
160747	2132	148095096000	20962	10543	2	0	904
160748	2133	96201414000	20962	10543	3	0	2793
160749	1397	1315047639000	20963	10544	0	0	12378
160753	1564	7693580000000	20964	10504	2	0	\N
160754	2100	1434860000000	20964	10504	3	0	\N
160755	2100	2830000000	20964	10504	4	0	\N
160756	1564	5488560000000	20964	10504	5	0	\N
160757	1564	4026540000000	20964	10504	6	0	\N
160758	1564	3558520000000	20964	10504	7	0	\N
160759	242	66648395291044	20964	10504	8	0	\N
160760	1756	3440720195609	20964	10504	9	0	\N
160761	2039	20879545000000	20964	10504	10	0	\N
160762	2039	18325785000000	20964	10504	11	0	\N
160763	2039	15238175000000	20964	10504	12	0	\N
160764	2039	10662265000000	20964	10504	13	0	\N
160765	2039	2059255000000	20964	10504	14	0	\N
160766	242	66001385291044	20964	10504	15	0	\N
160772	1397	1315017636000	20966	10546	0	0	\N
160773	2133	96197406000	20966	10546	1	0	\N
160776	1397	1315017636000	20968	10546	0	0	\N
160777	2133	96197406000	20968	10546	1	0	\N
160778	1397	1315017636000	20969	10546	0	0	\N
160779	2133	96197406000	20969	10546	1	0	\N
160780	1397	1315017636000	20970	10546	0	0	\N
160781	2133	96197406000	20970	10546	1	0	\N
160784	365	66017201000000	20972	10424	0	0	\N
160785	1564	10241589000000	20972	10424	1	0	\N
160786	1705	15427043490145	20972	10424	2	0	\N
160787	1564	6973569000000	20972	10424	3	0	\N
160796	1672	721214000000	20975	10550	0	0	\N
160797	1397	1314987633000	20975	10550	1	0	\N
160798	2133	96193398000	20975	10550	2	0	\N
160805	1397	1314977632000	20978	10551	0	0	\N
160806	2132	148092093000	20978	10551	1	0	\N
160807	2133	96192396000	20978	10551	2	0	\N
160810	1397	1314957630000	20980	10553	0	0	\N
160811	2133	96190392000	20980	10553	1	0	\N
160814	1397	1314957630000	20982	10553	0	0	\N
160815	2133	96190392000	20982	10553	1	0	\N
160816	1397	1314947629000	20983	10554	0	0	\N
160817	2133	96189390000	20983	10554	1	0	\N
160823	1397	1314927627000	20986	10556	0	0	\N
160824	2133	96187386000	20986	10556	1	0	\N
160825	1397	1314927627000	20987	10556	0	0	\N
160826	2133	96187386000	20987	10556	1	0	\N
160831	1397	1314917626000	20990	10557	0	0	\N
160832	2133	96186384000	20990	10557	1	0	\N
160833	1397	1314917626000	20991	10557	0	0	\N
160834	2133	96186384000	20991	10557	1	0	\N
160838	1397	1314897624000	20993	10559	0	0	\N
160839	1397	1314887623000	20993	10559	1	0	\N
160840	1397	1314897624000	20994	10559	0	0	\N
160841	1397	1314887623000	20994	10559	1	0	\N
160842	2133	96184380000	20994	10559	2	0	\N
160843	2133	96183378000	20994	10559	3	0	\N
160844	1397	1314897624000	20995	10559	0	0	\N
160845	1397	1314887623000	20995	10559	1	0	\N
160846	2133	96184380000	20995	10559	2	0	\N
160847	2133	96183378000	20995	10559	3	0	\N
160852	1714	11638176439708	20997	10560	0	0	\N
160853	1714	9295374638556	20997	10560	1	0	\N
160854	1714	5823121253616	20997	10560	2	0	\N
160855	1714	3885466171760	20997	10560	3	0	\N
160856	1397	1314877622000	20997	10560	4	0	\N
160857	1397	1314867621000	20997	10560	5	0	\N
160858	1397	1314857620000	20997	10560	6	0	\N
160859	1397	1314847619000	20997	10560	7	0	\N
160860	2133	96182376000	20997	10560	8	0	\N
160861	2133	96181374000	20997	10560	9	0	\N
160862	2133	96180372000	20997	10560	10	0	\N
160863	2133	96179370000	20997	10560	11	0	\N
160864	2132	148089090000	20997	10560	12	0	\N
160865	1714	11638176439708	20998	10560	0	0	\N
160866	1714	9295374638556	20998	10560	1	0	\N
160867	1714	5823121253616	20998	10560	2	0	\N
160868	1714	3885466171760	20998	10560	3	0	\N
160869	1397	1314877622000	20998	10560	4	0	\N
160870	1397	1314867621000	20998	10560	5	0	\N
160871	1397	1314857620000	20998	10560	6	0	\N
160872	1397	1314847619000	20998	10560	7	0	\N
160873	2133	96182376000	20998	10560	8	0	\N
160874	2133	96181374000	20998	10560	9	0	\N
160875	2133	96180372000	20998	10560	10	0	\N
160876	2133	96179370000	20998	10560	11	0	\N
160877	2132	148089090000	20998	10560	12	0	\N
160769	2133	96199410000	20965	10545	2	0	2795
160770	2133	96198408000	20965	10545	3	0	2796
160771	2132	148094095000	20965	10545	4	0	905
160774	1397	1315017636000	20967	10546	0	0	12381
160775	2133	96197406000	20967	10546	1	0	2797
160783	2133	96196404000	20971	10547	1	0	2798
160788	1672	15791254000000	20973	10548	0	0	6
160789	1672	9637244000000	20973	10548	1	0	7
160790	1672	5484234000000	20973	10548	2	0	8
160791	1672	2049224000000	20973	10548	3	0	9
160793	2133	96195402000	20973	10548	5	0	2799
160794	1397	1314997634000	20974	10549	0	0	12383
160795	2133	96194400000	20974	10549	1	0	2800
160799	1672	721214000000	20976	10550	0	0	10
160801	2133	96193398000	20976	10550	2	0	2801
160802	1397	1314977632000	20977	10551	0	0	12385
160803	2132	148092093000	20977	10551	1	0	907
160804	2133	96192396000	20977	10551	2	0	2802
160808	1397	1314967631000	20979	10552	0	0	12386
160812	1397	1314957630000	20981	10553	0	0	12387
160813	2133	96190392000	20981	10553	1	0	2804
160818	1397	1314947629000	20984	10554	0	0	12388
160819	2133	96189390000	20984	10554	1	0	2805
160820	1397	1314937628000	20985	10555	0	0	12389
160822	2132	148091092000	20985	10555	2	0	908
160827	1397	1314927627000	20988	10556	0	0	12390
160828	2133	96187386000	20988	10556	1	0	2807
160829	1397	1314917626000	20989	10557	0	0	12391
160835	1397	1314907625000	20992	10558	0	0	12392
160836	2133	96185382000	20992	10558	1	0	2809
160837	2132	148090091000	20992	10558	2	0	909
160848	1397	1314897624000	20996	10559	0	0	12393
160849	1397	1314887623000	20996	10559	1	0	12394
160851	2133	96183378000	20996	10559	3	0	2811
160878	1714	11638176439708	20999	10560	0	0	8
160879	1714	9295374638556	20999	10560	1	0	9
160880	1714	5823121253616	20999	10560	2	0	10
160881	1714	3885466171760	20999	10560	3	0	11
160883	1397	1314867621000	20999	10560	5	0	12396
160884	1397	1314857620000	20999	10560	6	0	12397
160885	1397	1314847619000	20999	10560	7	0	12398
160886	2133	96182376000	20999	10560	8	0	2812
160888	2133	96180372000	20999	10560	10	0	2814
160891	365	66017201000000	21000	10518	0	0	\N
160892	1564	10961600000000	21000	10518	1	0	\N
160893	1564	7693580000000	21000	10518	2	0	\N
160894	2100	1434860000000	21000	10518	3	0	\N
160895	2100	2830000000	21000	10518	4	0	\N
160896	1564	5488560000000	21000	10518	5	0	\N
160897	1564	4026540000000	21000	10518	6	0	\N
160898	1564	3558520000000	21000	10518	7	0	\N
160899	1397	1315407675000	21000	10518	8	0	\N
160900	2039	18325785000000	21000	10518	9	0	\N
160901	2039	15238175000000	21000	10518	10	0	\N
160902	2039	10662265000000	21000	10518	11	0	\N
160903	2039	2059255000000	21000	10518	12	0	\N
160904	2269	648990000000	21000	10518	13	0	\N
160905	1756	3440720195609	21000	10518	14	0	\N
160906	1714	11638176439708	21000	10518	15	0	\N
160907	1714	9295374638556	21000	10518	16	0	\N
160908	1714	5823121253616	21000	10518	17	0	\N
160909	1714	3885466171760	21000	10518	18	0	\N
160910	1397	1315397674000	21000	10518	19	0	\N
160911	1397	1315387673000	21000	10518	20	0	\N
160912	1397	1315377672000	21000	10518	21	0	\N
160913	1397	1315367671000	21000	10518	22	0	\N
160914	1397	1315357670000	21000	10518	23	0	\N
160915	1397	1315347669000	21000	10518	24	0	\N
160916	1397	1315337668000	21000	10518	25	0	\N
160917	1397	1315327667000	21000	10518	26	0	\N
160918	1397	1315317666000	21000	10518	27	0	\N
160919	1397	1315307665000	21000	10518	28	0	\N
160920	1397	1315297664000	21000	10518	29	0	\N
160921	1397	1315287663000	21000	10518	30	0	\N
160922	1397	1315277662000	21000	10518	31	0	\N
160923	1397	1315267661000	21000	10518	32	0	\N
160924	1397	1315257660000	21000	10518	33	0	\N
160925	1397	1315247659000	21000	10518	34	0	\N
160926	1397	1315237658000	21000	10518	35	0	\N
160927	1397	1315227657000	21000	10518	37	0	\N
160928	1397	1315217656000	21000	10518	38	0	\N
160929	1397	1315207655000	21000	10518	39	0	\N
160930	1397	1315197654000	21000	10518	40	0	\N
160931	1397	1315187653000	21000	10518	41	0	\N
160932	1397	1315177652000	21000	10518	42	0	\N
160933	1397	1315167651000	21000	10518	43	0	\N
160934	1397	1315157650000	21000	10518	44	0	\N
160935	1397	1315147649000	21000	10518	45	0	\N
160936	1397	1315137648000	21000	10518	46	0	\N
160937	1397	1315127647000	21000	10518	47	0	\N
160938	1397	1315117646000	21000	10518	48	0	\N
160939	1397	1315107645000	21000	10518	49	0	\N
160940	1672	15791254000000	21000	10518	50	0	\N
160941	1672	9637244000000	21000	10518	51	0	\N
160942	1672	5484234000000	21000	10518	52	0	\N
160943	1672	2049224000000	21000	10518	53	0	\N
160944	1672	721214000000	21000	10518	54	0	\N
160945	1397	1315097644000	21000	10518	55	0	\N
160946	1397	1315087643000	21000	10518	56	0	\N
160947	1397	1315077642000	21000	10518	57	0	\N
160948	1397	1315067641000	21000	10518	58	0	\N
160949	1397	1315057640000	21000	10518	59	0	\N
160950	1397	1315047639000	21000	10518	60	0	\N
160951	1397	1315037638000	21000	10518	61	0	\N
160952	1397	1315027637000	21000	10518	62	0	\N
160953	1397	1315017636000	21000	10518	63	0	\N
160954	1397	1315007635000	21000	10518	64	0	\N
160955	1397	1314997634000	21000	10518	65	0	\N
160956	1397	1314987633000	21000	10518	66	0	\N
160957	1397	1314977632000	21000	10518	67	0	\N
160958	1397	1314967631000	21000	10518	68	0	\N
160959	1397	1314957630000	21000	10518	69	0	\N
160960	1397	1314947629000	21000	10518	70	0	\N
160961	1397	1314937628000	21000	10518	71	0	\N
160962	1397	1314927627000	21000	10518	72	0	\N
160963	1397	1314917626000	21000	10518	73	0	\N
160964	1397	1314907625000	21000	10518	74	0	\N
160965	1397	1314897624000	21000	10518	75	0	\N
160966	1397	1314887623000	21000	10518	76	0	\N
160967	1397	1314877622000	21000	10518	77	0	\N
160968	1397	1314867621000	21000	10518	78	0	\N
160969	1397	1314857620000	21000	10518	79	0	\N
160970	1397	1314847619000	21000	10518	80	0	\N
160971	2132	148105106000	21000	10518	81	0	\N
160972	2132	148104105000	21000	10518	82	0	\N
160973	2132	148103104000	21000	10518	83	0	\N
160974	2132	148102103000	21000	10518	84	0	\N
160975	2132	148101102000	21000	10518	85	0	\N
160976	2132	148100101000	21000	10518	86	0	\N
160977	2132	148099100000	21000	10518	87	0	\N
160978	2132	148098099000	21000	10518	88	0	\N
160979	2132	148097098000	21000	10518	89	0	\N
160980	2132	148096097000	21000	10518	90	0	\N
160981	2132	148095096000	21000	10518	91	0	\N
160982	2133	96235482000	21000	10518	92	0	\N
160983	2133	96234480000	21000	10518	93	0	\N
160984	2133	96233478000	21000	10518	94	0	\N
160985	2133	96232476000	21000	10518	95	0	\N
160986	2133	96231474000	21000	10518	96	0	\N
160987	2133	96230472000	21000	10518	97	0	\N
160988	2133	96229470000	21000	10518	98	0	\N
160989	2133	96228468000	21000	10518	99	0	\N
160990	2133	96227466000	21000	10518	100	0	\N
160991	2132	148094095000	21000	10518	101	0	\N
160992	2132	148093094000	21000	10518	102	0	\N
160993	2132	148092093000	21000	10518	103	0	\N
160994	2132	148091092000	21000	10518	104	0	\N
160995	2132	148090091000	21000	10518	105	0	\N
160996	2132	148089090000	21000	10518	106	0	\N
160997	2133	96226464000	21000	10518	107	0	\N
160998	2133	96225462000	21000	10518	108	0	\N
160999	2133	96224460000	21000	10518	109	0	\N
161000	2133	96223458000	21000	10518	110	0	\N
161001	2133	96222456000	21000	10518	111	0	\N
161002	2133	96221454000	21000	10518	112	0	\N
161003	2133	96220452000	21000	10518	113	0	\N
161004	2133	96219450000	21000	10518	114	0	\N
161005	2133	96218448000	21000	10518	115	0	\N
161006	2133	96217446000	21000	10518	116	0	\N
161007	2133	96216444000	21000	10518	117	0	\N
161008	2133	96215442000	21000	10518	118	0	\N
161009	2133	96214440000	21000	10518	119	0	\N
161010	2133	96213438000	21000	10518	120	0	\N
161011	2133	96212436000	21000	10518	121	0	\N
161012	2133	96211434000	21000	10518	122	0	\N
161013	2133	96210432000	21000	10518	123	0	\N
161014	2133	96209430000	21000	10518	124	0	\N
161015	2133	96208428000	21000	10518	125	0	\N
161021	1397	1314837618000	21002	10561	0	0	\N
161022	1397	1314827617000	21002	10561	1	0	\N
161023	2133	96178368000	21002	10561	2	0	\N
161024	2133	96177366000	21002	10561	3	0	\N
161016	1397	1314837618000	21001	10561	0	0	12399
161017	1397	1314827617000	21001	10561	1	0	12400
161018	2133	96178368000	21001	10561	2	0	2816
161019	2133	96177366000	21001	10561	3	0	2817
161020	2132	148088089000	21001	10561	4	0	911
161025	2132	148088089000	21002	10561	4	0	\N
161026	1397	1314817616000	21003	10562	0	0	\N
161027	2133	96176364000	21003	10562	1	0	\N
161028	1397	1314817616000	21004	10562	0	0	\N
161029	2133	96176364000	21004	10562	1	0	\N
161030	1397	1314817616000	21005	10562	0	0	\N
161031	2133	96176364000	21005	10562	1	0	\N
161034	1397	1314807615000	21007	10563	0	0	\N
161035	1397	1314797614000	21007	10563	1	0	\N
161036	2132	148087088000	21007	10563	2	0	\N
161037	2133	96175362000	21007	10563	3	0	\N
161038	2133	96174360000	21007	10563	4	0	\N
161044	1397	1314807615000	21009	10563	0	0	\N
161045	1397	1314797614000	21009	10563	1	0	\N
161046	2132	148087088000	21009	10563	2	0	\N
161049	365	66017201000000	21011	10383	0	0	\N
161050	1646	1438913000000	21011	10383	1	0	\N
161051	1646	1437813000000	21011	10383	2	0	\N
161052	1646	1713000000	21011	10383	3	0	\N
161053	1564	9521576000000	21011	10383	4	0	\N
161054	576	77126366225192	21011	10383	5	0	\N
161055	1705	14707017490145	21011	10383	6	0	\N
161056	1564	6253556000000	21011	10383	7	0	\N
161057	2100	1434860000000	21011	10383	8	0	\N
161058	2100	2830000000	21011	10383	9	0	\N
161059	1705	11537702140145	21011	10383	10	0	\N
161060	576	73467636517990	21011	10383	11	0	\N
161061	576	70999012173600	21011	10383	12	0	\N
161062	576	68957291726897	21011	10383	13	0	\N
161063	576	68957271726897	21011	10383	14	0	\N
161064	1564	4048536000000	21011	10383	15	0	\N
161065	1564	2586516000000	21011	10383	16	0	\N
161066	1564	2118496000000	21011	10383	17	0	\N
161067	1705	9399286040145	21011	10383	18	0	\N
161068	1705	9399266040140	21011	10383	19	0	\N
161069	1705	3440420580140	21011	10383	20	0	\N
161070	596	67094752000000	21011	10383	21	0	\N
161071	1992	19228527990000	21011	10383	22	0	\N
161072	1992	14979517990000	21011	10383	23	0	\N
161073	1440	5845163045924	21011	10383	24	0	\N
161074	1440	3040153045924	21011	10383	25	0	\N
161075	1440	720143045924	21011	10383	26	0	\N
161076	242	66648395291044	21011	10383	27	0	\N
161077	1679	28128547709000	21011	10383	28	0	\N
161078	1688	70668064113200	21011	10383	29	0	\N
161079	1688	70513232531200	21011	10383	30	0	\N
161080	1698	21813639378297	21011	10383	31	0	\N
161081	1679	27978365513000	21011	10383	32	0	\N
161082	1679	27698380388000	21011	10383	33	0	\N
161083	1679	25625486252000	21011	10383	34	0	\N
161084	1679	21609986866000	21011	10383	35	0	\N
161085	1992	12112507990000	21011	10383	36	0	\N
161086	1992	4124497990000	21011	10383	37	0	\N
161087	1992	2880487990000	21011	10383	38	0	\N
161088	1698	19351753841201	21011	10383	39	0	\N
161089	1698	14940083972065	21011	10383	40	0	\N
161090	1698	11963439149826	21011	10383	41	0	\N
161091	1688	70374438872200	21011	10383	42	0	\N
161092	1688	70316017319200	21011	10383	43	0	\N
161093	1688	69673480800200	21011	10383	44	0	\N
161094	1688	64533362610200	21011	10383	45	0	\N
161095	1397	1316697804000	21011	10383	46	0	\N
161096	1397	1316687803000	21011	10383	47	0	\N
161097	1397	1316677802000	21011	10383	48	0	\N
161098	1397	1316667801000	21011	10383	49	0	\N
161099	1756	2720708195609	21011	10383	50	0	\N
161100	2039	20879545000000	21011	10383	51	0	\N
161101	2039	18325785000000	21011	10383	52	0	\N
161102	2039	15238175000000	21011	10383	53	0	\N
161103	2039	10662265000000	21011	10383	54	0	\N
161104	2039	2059255000000	21011	10383	55	0	\N
161105	1397	1316657800000	21011	10383	56	0	\N
161106	1714	11638176439708	21011	10383	57	0	\N
161107	1714	9295374638556	21011	10383	58	0	\N
161108	1714	5823121253616	21011	10383	59	0	\N
161109	1714	3885466171760	21011	10383	60	0	\N
161110	1688	64066069640200	21011	10383	61	0	\N
161111	1688	58925951450200	21011	10383	62	0	\N
161112	1688	58809118345200	21011	10383	63	0	\N
161113	1688	57524055307200	21011	10383	64	0	\N
161114	1688	57494842148200	21011	10383	65	0	\N
161115	1688	57173597673200	21011	10383	66	0	\N
161116	1688	57144379111200	21011	10383	67	0	\N
161117	1688	56823075204200	21011	10383	68	0	\N
161118	1397	1316647799000	21011	10383	69	0	\N
161119	1397	1316637798000	21011	10383	70	0	\N
161120	1397	1316627797000	21011	10383	71	0	\N
161121	1397	1316617796000	21011	10383	72	0	\N
161122	1397	1316607795000	21011	10383	73	0	\N
161123	149	69695228000341	21011	10383	74	0	\N
161124	1698	3668771550062	21011	10383	75	0	\N
161125	1397	1316597794000	21011	10383	76	0	\N
161126	1397	1316587793000	21011	10383	77	0	\N
161127	1397	1316577792000	21011	10383	78	0	\N
161128	1397	1316567791000	21011	10383	79	0	\N
161129	1397	1316557790000	21011	10383	80	0	\N
161130	1706	17231508221216	21011	10383	81	0	\N
161131	1706	16972659842297	21011	10383	82	0	\N
161132	1706	16964806255072	21011	10383	83	0	\N
161133	1706	14994349389476	21011	10383	84	0	\N
161134	1706	11463315489116	21011	10383	85	0	\N
161135	1397	1316547789000	21011	10383	86	0	\N
161136	1397	1316537788000	21011	10383	87	0	\N
161137	1397	1316527787000	21011	10383	88	0	\N
161138	1397	1316517786000	21011	10383	89	0	\N
161139	1679	21167204552000	21011	10383	90	0	\N
161140	1397	1316507785000	21011	10383	91	0	\N
161141	1397	1316497784000	21011	10383	92	0	\N
161142	1397	1316487783000	21011	10383	93	0	\N
161143	1397	1316477782000	21011	10383	94	0	\N
161144	1397	1316467781000	21011	10383	96	0	\N
161145	1397	1316457780000	21011	10383	97	0	\N
161146	1932	1382918664093	21011	10383	98	0	\N
161147	1679	20932984592000	21011	10383	99	0	\N
161148	1679	20342417677000	21011	10383	100	0	\N
161149	1679	19526710919000	21011	10383	101	0	\N
161150	1679	18810610696000	21011	10383	102	0	\N
161151	1679	14449449713000	21011	10383	103	0	\N
161152	1679	13983048536000	21011	10383	104	0	\N
161153	1679	9621887553000	21011	10383	105	0	\N
161154	1679	9239603825000	21011	10383	106	0	\N
161155	1679	9078069715000	21011	10383	107	0	\N
161156	1679	8595976470000	21011	10383	108	0	\N
161157	1679	8191283425000	21011	10383	109	0	\N
161158	1679	7302890818000	21011	10383	110	0	\N
161159	1679	7185691845000	21011	10383	111	0	\N
161160	1679	7115825898000	21011	10383	112	0	\N
161039	1397	1314807615000	21008	10563	0	0	12402
161040	1397	1314797614000	21008	10563	1	0	12403
161041	2132	148087088000	21008	10563	2	0	912
161042	2133	96175362000	21008	10563	3	0	2819
161043	2133	96174360000	21008	10563	4	0	2820
161048	2133	96173358000	21010	10564	1	0	2821
161161	1679	6905834554000	21011	10383	113	0	\N
161162	1679	6150699338000	21011	10383	114	0	\N
161163	1679	4890650538000	21011	10383	115	0	\N
161164	1679	529489555000	21011	10383	116	0	\N
161165	1679	147205827000	21011	10383	117	0	\N
161166	1706	9080853302936	21011	10383	118	0	\N
161167	1706	2441928450256	21011	10383	119	0	\N
161168	1397	1316447779000	21011	10383	120	0	\N
161169	1397	1316437778000	21011	10383	121	0	\N
161170	1397	1316427777000	21011	10383	122	0	\N
161171	1397	1316417776000	21011	10383	123	0	\N
161172	1397	1316407775000	21011	10383	124	0	\N
161173	1397	1316397774000	21011	10383	125	0	\N
161177	1397	1314777612000	21013	10565	0	0	\N
161178	2133	96172356000	21013	10565	1	0	\N
161179	2132	148086087000	21013	10565	2	0	\N
161192	1397	1314747609000	21016	10567	0	0	\N
161193	1397	1314737608000	21016	10567	1	0	\N
161194	2133	96169350000	21016	10567	2	0	\N
161195	2133	96168348000	21016	10567	3	0	\N
161196	2132	148085086000	21016	10567	4	0	\N
161197	1397	1314727607000	21018	10568	0	0	\N
161198	2133	96167346000	21018	10568	1	0	\N
161201	1397	1314727607000	21020	10568	0	0	\N
161202	2133	96167346000	21020	10568	1	0	\N
161203	1397	1314717606000	21021	10569	0	0	\N
161204	1397	1314707605000	21021	10569	1	0	\N
161205	1397	1314697604000	21021	10569	2	0	\N
161206	2133	96166344000	21021	10569	3	0	\N
161207	2132	148084085000	21021	10569	4	0	\N
161208	2133	96165342000	21021	10569	5	0	\N
161209	1397	1314717606000	21022	10569	0	0	\N
161210	1397	1314707605000	21022	10569	1	0	\N
161211	1397	1314697604000	21022	10569	2	0	\N
161212	2133	96166344000	21022	10569	3	0	\N
161213	2132	148084085000	21022	10569	4	0	\N
161214	2133	96165342000	21022	10569	5	0	\N
161221	1397	1314717606000	21024	10569	0	0	\N
161222	1397	1314707605000	21024	10569	1	0	\N
161223	1397	1314697604000	21024	10569	2	0	\N
161224	2133	96166344000	21024	10569	3	0	\N
161225	2132	148084085000	21024	10569	4	0	\N
161226	2133	96165342000	21024	10569	5	0	\N
161227	1397	1314717606000	21025	10569	0	0	\N
161228	1397	1314707605000	21025	10569	1	0	\N
161229	1397	1314697604000	21025	10569	2	0	\N
161230	2133	96166344000	21025	10569	3	0	\N
161231	2132	148084085000	21025	10569	4	0	\N
161232	2133	96165342000	21025	10569	5	0	\N
161233	1397	1314717606000	21026	10569	0	0	\N
161234	1397	1314707605000	21026	10569	1	0	\N
161235	1397	1314697604000	21026	10569	2	0	\N
161236	2133	96166344000	21026	10569	3	0	\N
161237	2132	148084085000	21026	10569	4	0	\N
161238	2133	96165342000	21026	10569	5	0	\N
161239	1397	1314717606000	21027	10569	0	0	\N
161240	1397	1314707605000	21027	10569	1	0	\N
161241	1397	1314697604000	21027	10569	2	0	\N
161242	2133	96166344000	21027	10569	3	0	\N
161243	2132	148084085000	21027	10569	4	0	\N
161244	2133	96165342000	21027	10569	5	0	\N
161245	1397	1314717606000	21028	10569	0	0	\N
161246	1397	1314707605000	21028	10569	1	0	\N
161247	1397	1314697604000	21028	10569	2	0	\N
161248	2133	96166344000	21028	10569	3	0	\N
161249	2132	148084085000	21028	10569	4	0	\N
161250	2133	96165342000	21028	10569	5	0	\N
161253	1397	1314687603000	21030	10570	0	0	\N
161254	2133	96164340000	21030	10570	1	0	\N
161255	1397	1314677602000	21031	10571	0	0	\N
161256	2132	148083084000	21031	10571	1	0	\N
161257	2133	96163338000	21031	10571	2	0	\N
161261	1397	1314687603000	21033	10570	0	0	\N
161262	1397	1314677602000	21033	10570	1	0	\N
161263	2133	96164340000	21033	10570	2	0	\N
161264	2133	96163338000	21033	10570	3	0	\N
161265	1397	1314667601000	21034	10572	0	0	\N
161266	2133	96162336000	21034	10572	1	0	\N
161269	1397	1314667601000	21038	10572	0	0	\N
161270	2133	96162336000	21038	10572	1	0	\N
161275	1397	1314647599000	21041	10574	0	0	\N
161276	2133	96161334000	21041	10574	1	0	\N
161277	2133	96160332000	21041	10574	2	0	\N
161278	1397	1314647599000	21042	10574	0	0	\N
161279	2133	96161334000	21042	10574	1	0	\N
161280	2133	96160332000	21042	10574	2	0	\N
161288	1397	1314617596000	21045	10576	0	0	\N
161289	2133	96157326000	21045	10576	1	0	\N
161290	1397	1314617596000	21046	10576	0	0	\N
161291	2133	96157326000	21046	10576	1	0	\N
161292	1397	1314607595000	21047	10577	0	0	\N
161293	2133	96156324000	21047	10577	1	0	\N
161294	2132	148081082000	21047	10577	2	0	\N
161176	2132	148086087000	21012	10565	2	0	913
161180	1397	1314767611000	21014	10566	0	0	12406
161181	1397	1314757610000	21014	10566	1	0	12407
161182	1608	12149912000000	21014	10566	2	0	5
161183	1608	7737612000000	21014	10566	3	0	6
161185	2133	96171354000	21014	10566	5	0	2823
161186	2133	96170352000	21014	10566	6	0	2824
161187	1397	1314747609000	21015	10567	0	0	12408
161188	1397	1314737608000	21015	10567	1	0	12409
161189	2133	96169350000	21015	10567	2	0	2825
161191	2132	148085086000	21015	10567	4	0	914
161199	1397	1314727607000	21019	10568	0	0	12410
161200	2133	96167346000	21019	10568	1	0	2827
161215	1397	1314717606000	21023	10569	0	0	12411
161217	1397	1314697604000	21023	10569	2	0	12413
161218	2133	96166344000	21023	10569	3	0	2828
161219	2132	148084085000	21023	10569	4	0	915
161220	2133	96165342000	21023	10569	5	0	2829
161251	1397	1314687603000	21029	10570	0	0	12414
161258	1397	1314677602000	21032	10571	0	0	12415
161259	2132	148083084000	21032	10571	1	0	916
161260	2133	96163338000	21032	10571	2	0	2831
161267	1397	1314667601000	21035	10572	0	0	12416
161268	2133	96162336000	21035	10572	1	0	2832
161272	1397	1314647599000	21040	10574	0	0	12418
161273	2133	96161334000	21040	10574	1	0	2833
161274	2133	96160332000	21040	10574	2	0	2834
161281	1397	1314637598000	21043	10575	0	0	12419
161283	2133	96159330000	21043	10575	2	0	2835
161284	2133	96158328000	21043	10575	3	0	2836
161285	2132	148082083000	21043	10575	4	0	917
161286	1397	1314617596000	21044	10576	0	0	12421
161287	2133	96157326000	21044	10576	1	0	2837
161296	2133	96156324000	21048	10577	1	0	2838
161298	1397	1314607595000	21049	10577	0	0	\N
161299	2133	96156324000	21049	10577	1	0	\N
161300	2132	148081082000	21049	10577	2	0	\N
161301	1397	1314597594000	21050	10578	0	0	\N
161302	2133	96155322000	21050	10578	1	0	\N
161305	1397	1314597594000	21052	10578	0	0	\N
161306	2133	96155322000	21052	10578	1	0	\N
161307	1397	1314597594000	21053	10578	0	0	\N
161308	2133	96155322000	21053	10578	1	0	\N
161309	1397	1314587593000	21054	10579	0	0	\N
161310	1397	1314577592000	21054	10579	1	0	\N
161311	2133	96154320000	21054	10579	2	0	\N
161312	2132	148080081000	21054	10579	3	0	\N
161317	1397	1314567591000	21056	10580	0	0	\N
161318	2133	96153318000	21056	10580	1	0	\N
161332	1682	10341000000	21061	10507	0	0	\N
161333	365	66017201000000	21061	10507	1	0	\N
161334	1564	10961600000000	21061	10507	2	0	\N
161335	1564	7693580000000	21061	10507	3	0	\N
161336	2100	1434860000000	21061	10507	4	0	\N
161337	2100	2830000000	21061	10507	5	0	\N
161338	1564	5488560000000	21061	10507	6	0	\N
161339	1564	4026540000000	21061	10507	7	0	\N
161340	1564	3558520000000	21061	10507	8	0	\N
161341	1682	9331000000	21061	10507	9	0	\N
161342	242	66648395291044	21061	10507	10	0	\N
161343	1608	12149912000000	21061	10507	11	0	\N
161344	1608	7737612000000	21061	10507	12	0	\N
161345	1850	14038008949999	21061	10507	13	0	\N
161346	1850	9674898949999	21061	10507	14	0	\N
161347	1850	6730988949999	21061	10507	15	0	\N
161348	1850	4296178949999	21061	10507	16	0	\N
161349	1608	4760542000000	21061	10507	17	0	\N
161350	1608	2298302000000	21061	10507	18	0	\N
161351	1756	3440720195609	21061	10507	19	0	\N
161352	2039	20879545000000	21061	10507	20	0	\N
161353	2039	18325785000000	21061	10507	21	0	\N
161354	2039	15238175000000	21061	10507	22	0	\N
161355	2039	10662265000000	21061	10507	23	0	\N
161356	2039	2059255000000	21061	10507	24	0	\N
161357	1714	11638176439708	21061	10507	25	0	\N
161358	1714	9295374638556	21061	10507	26	0	\N
161359	1714	5823121253616	21061	10507	27	0	\N
161360	1714	3885466171760	21061	10507	28	0	\N
161361	1672	15791254000000	21061	10507	29	0	\N
161362	1672	9637244000000	21061	10507	30	0	\N
161363	1672	5484234000000	21061	10507	31	0	\N
161364	1672	2049224000000	21061	10507	32	0	\N
161365	1672	721214000000	21061	10507	33	0	\N
161366	242	66001385291044	21061	10507	34	0	\N
161367	2132	148110111000	21061	10507	35	0	\N
161368	2132	148109110000	21061	10507	36	0	\N
161369	2132	148108109000	21061	10507	37	0	\N
161370	2132	148107108000	21061	10507	38	0	\N
161371	2132	148106107000	21061	10507	39	0	\N
161372	2132	148105106000	21061	10507	40	0	\N
161373	2132	148104105000	21061	10507	41	0	\N
161374	2132	148103104000	21061	10507	42	0	\N
161375	2132	148102103000	21061	10507	43	0	\N
161376	2132	148101102000	21061	10507	44	0	\N
161377	2132	148100101000	21061	10507	45	0	\N
161378	2132	148099100000	21061	10507	46	0	\N
161379	2132	148098099000	21061	10507	47	0	\N
161380	2132	148097098000	21061	10507	48	0	\N
161381	2132	148096097000	21061	10507	49	0	\N
161382	2132	148095096000	21061	10507	50	0	\N
161383	2132	148094095000	21061	10507	51	0	\N
161384	2132	148093094000	21061	10507	52	0	\N
161385	2132	148092093000	21061	10507	53	0	\N
161386	2132	148091092000	21061	10507	54	0	\N
161387	2132	148090091000	21061	10507	55	0	\N
161388	2132	148089090000	21061	10507	56	0	\N
161389	2132	148088089000	21061	10507	57	0	\N
161390	2132	148087088000	21061	10507	58	0	\N
161391	2132	148086087000	21061	10507	59	0	\N
161392	2132	148085086000	21061	10507	60	0	\N
161393	2132	148084085000	21061	10507	61	0	\N
161394	2132	148083084000	21061	10507	62	0	\N
161395	2132	148082083000	21061	10507	63	0	\N
161396	2132	148081082000	21061	10507	64	0	\N
161397	2132	148080081000	21061	10507	65	0	\N
161398	2132	148079080000	21061	10507	66	0	\N
161399	1397	1314517586000	21062	10584	0	0	\N
161400	1850	14038008949999	21062	10584	1	0	\N
161401	1850	9674898949999	21062	10584	2	0	\N
161402	1850	6730988949999	21062	10584	3	0	\N
161403	1850	4296178949999	21062	10584	4	0	\N
161404	2133	96148308000	21062	10584	5	0	\N
161405	1682	10341000000	21063	10583	0	0	\N
161406	1682	9331000000	21063	10583	1	0	\N
161407	1397	1314527587000	21063	10583	2	0	\N
161408	1397	1314517586000	21063	10583	3	0	\N
161409	1850	14038008949999	21063	10583	4	0	\N
161410	1850	9674898949999	21063	10583	5	0	\N
161411	1850	6730988949999	21063	10583	6	0	\N
161412	1850	4296178949999	21063	10583	7	0	\N
161413	2133	96149310000	21063	10583	8	0	\N
161414	2133	96148308000	21063	10583	9	0	\N
161421	1682	10341000000	21065	10476	0	0	\N
161422	365	66017201000000	21065	10476	1	0	\N
161423	1564	10241589000000	21065	10476	2	0	\N
161424	1564	6973569000000	21065	10476	3	0	\N
161425	2100	1434860000000	21065	10476	4	0	\N
161426	2100	2830000000	21065	10476	5	0	\N
161427	1564	4768549000000	21065	10476	6	0	\N
161428	1564	3306529000000	21065	10476	7	0	\N
161429	1564	2838509000000	21065	10476	8	0	\N
161430	1682	9331000000	21065	10476	9	0	\N
161431	242	66648395291044	21065	10476	10	0	\N
161432	1608	12149912000000	21065	10476	11	0	\N
161304	2133	96155322000	21051	10578	1	0	2839
161313	1397	1314587593000	21055	10579	0	0	12424
161314	1397	1314577592000	21055	10579	1	0	12425
161315	2133	96154320000	21055	10579	2	0	2840
161316	2132	148080081000	21055	10579	3	0	919
161320	2133	96153318000	21057	10580	1	0	2841
161321	1397	1314557590000	21058	10581	0	0	12427
161322	2133	96152316000	21058	10581	1	0	2842
161323	1397	1314547589000	21059	10582	0	0	12428
161324	1397	1314537588000	21059	10582	1	0	12429
161326	2132	148079080000	21059	10582	3	0	920
161327	2133	96150312000	21059	10582	4	0	2844
161328	1682	10341000000	21060	10583	0	0	7
161329	1682	9331000000	21060	10583	1	0	8
161331	2133	96149310000	21060	10583	3	0	2845
161415	1397	1314517586000	21064	10584	0	0	12431
161416	1850	14038008949999	21064	10584	1	0	6
161417	1850	9674898949999	21064	10584	2	0	7
161418	1850	6730988949999	21064	10584	3	0	8
161420	2133	96148308000	21064	10584	5	0	2846
161433	1608	7737612000000	21065	10476	12	0	\N
161434	1850	14038008949999	21065	10476	13	0	\N
161435	1850	9674898949999	21065	10476	14	0	\N
161436	1850	6730988949999	21065	10476	15	0	\N
161437	1850	4296178949999	21065	10476	16	0	\N
161438	1608	4760542000000	21065	10476	17	0	\N
161439	1608	2298302000000	21065	10476	18	0	\N
161440	1756	3440720195609	21065	10476	19	0	\N
161441	2039	20879545000000	21065	10476	20	0	\N
161442	2039	18325785000000	21065	10476	21	0	\N
161443	2039	15238175000000	21065	10476	22	0	\N
161444	2039	10662265000000	21065	10476	23	0	\N
161445	2039	2059255000000	21065	10476	24	0	\N
161446	1714	11638176439708	21065	10476	25	0	\N
161447	1714	9295374638556	21065	10476	26	0	\N
161448	1714	5823121253616	21065	10476	27	0	\N
161449	1714	3885466171760	21065	10476	28	0	\N
161450	149	69695228000341	21065	10476	29	0	\N
161451	1397	1315677702000	21065	10476	30	0	\N
161452	1397	1315667701000	21065	10476	31	0	\N
161453	1397	1315657700000	21065	10476	32	0	\N
161454	1397	1315647699000	21065	10476	33	0	\N
161455	1397	1315637698000	21065	10476	34	0	\N
161456	1397	1315627697000	21065	10476	35	0	\N
161457	1397	1315617696000	21065	10476	36	0	\N
161458	1397	1315607695000	21065	10476	37	0	\N
161459	1397	1315597694000	21065	10476	38	0	\N
161460	1397	1315587693000	21065	10476	39	0	\N
161461	1397	1315577692000	21065	10476	40	0	\N
161462	1397	1315567691000	21065	10476	41	0	\N
161463	1397	1315557690000	21065	10476	42	0	\N
161464	1397	1315547689000	21065	10476	43	0	\N
161465	1397	1315537688000	21065	10476	44	0	\N
161466	1397	1315527687000	21065	10476	45	0	\N
161467	1397	1315517686000	21065	10476	46	0	\N
161468	1397	1315507685000	21065	10476	47	0	\N
161469	1397	1315497684000	21065	10476	48	0	\N
161470	1397	1315487683000	21065	10476	49	0	\N
161471	1397	1315477682000	21065	10476	50	0	\N
161472	1397	1315467681000	21065	10476	51	0	\N
161473	1397	1315457680000	21065	10476	52	0	\N
161474	1397	1315447679000	21065	10476	53	0	\N
161475	1397	1315437678000	21065	10476	54	0	\N
161476	1397	1315427677000	21065	10476	55	0	\N
161477	1397	1315417676000	21065	10476	56	0	\N
161478	1397	1315407675000	21065	10476	58	0	\N
161479	1397	1315397674000	21065	10476	59	0	\N
161480	1397	1315387673000	21065	10476	60	0	\N
161481	1397	1315377672000	21065	10476	61	0	\N
161482	1397	1315367671000	21065	10476	62	0	\N
161483	1397	1315357670000	21065	10476	63	0	\N
161484	1397	1315347669000	21065	10476	64	0	\N
161485	1397	1315337668000	21065	10476	65	0	\N
161486	1397	1315327667000	21065	10476	66	0	\N
161487	1397	1315317666000	21065	10476	67	0	\N
161488	1397	1315307665000	21065	10476	68	0	\N
161489	1397	1315297664000	21065	10476	69	0	\N
161490	1397	1315287663000	21065	10476	70	0	\N
161491	1397	1315277662000	21065	10476	71	0	\N
161492	1397	1315267661000	21065	10476	72	0	\N
161493	1397	1315257660000	21065	10476	73	0	\N
161494	1397	1315247659000	21065	10476	74	0	\N
161495	1397	1315237658000	21065	10476	75	0	\N
161496	1397	1315227657000	21065	10476	76	0	\N
161497	1397	1315217656000	21065	10476	77	0	\N
161498	1397	1315207655000	21065	10476	78	0	\N
161499	1397	1315197654000	21065	10476	79	0	\N
161500	1397	1315187653000	21065	10476	80	0	\N
161501	1397	1315177652000	21065	10476	81	0	\N
161502	1397	1315167651000	21065	10476	82	0	\N
161503	1397	1315157650000	21065	10476	83	0	\N
161504	1397	1315147649000	21065	10476	84	0	\N
161505	1397	1315137648000	21065	10476	85	0	\N
161506	1397	1315127647000	21065	10476	86	0	\N
161507	1397	1315117646000	21065	10476	87	0	\N
161508	1397	1315107645000	21065	10476	88	0	\N
161509	1672	15791254000000	21065	10476	89	0	\N
161510	1672	9637244000000	21065	10476	90	0	\N
161511	1672	5484234000000	21065	10476	91	0	\N
161512	1672	2049224000000	21065	10476	92	0	\N
161513	1672	721214000000	21065	10476	93	0	\N
161514	242	66001385291044	21065	10476	94	0	\N
161515	1397	1315097644000	21065	10476	95	0	\N
161516	1397	1315087643000	21065	10476	96	0	\N
161517	1397	1315077642000	21065	10476	97	0	\N
161518	1397	1315067641000	21065	10476	98	0	\N
161519	1397	1315057640000	21065	10476	99	0	\N
161520	1397	1315047639000	21065	10476	100	0	\N
161521	1397	1315037638000	21065	10476	101	0	\N
161522	1397	1315027637000	21065	10476	102	0	\N
161523	1397	1315017636000	21065	10476	103	0	\N
161524	1397	1315007635000	21065	10476	104	0	\N
161525	1397	1314997634000	21065	10476	105	0	\N
161526	1397	1314987633000	21065	10476	106	0	\N
161527	1397	1314977632000	21065	10476	107	0	\N
161528	1397	1314967631000	21065	10476	108	0	\N
161529	1397	1314957630000	21065	10476	109	0	\N
161530	1397	1314947629000	21065	10476	110	0	\N
161531	1397	1314937628000	21065	10476	111	0	\N
161532	1397	1314927627000	21065	10476	112	0	\N
161533	1397	1314917626000	21065	10476	113	0	\N
161534	1397	1314907625000	21065	10476	114	0	\N
161535	1397	1314897624000	21065	10476	115	0	\N
161536	1397	1314887623000	21065	10476	116	0	\N
161537	1397	1314877622000	21065	10476	117	0	\N
161538	1397	1314867621000	21065	10476	118	0	\N
161539	1397	1314857620000	21065	10476	119	0	\N
161540	1397	1314847619000	21065	10476	120	0	\N
161541	1397	1314837618000	21065	10476	121	0	\N
161542	1397	1314827617000	21065	10476	122	0	\N
161543	1397	1314817616000	21065	10476	123	0	\N
161544	1397	1314807615000	21065	10476	124	0	\N
161545	1397	1314797614000	21065	10476	125	0	\N
161546	1397	1314507585000	21066	10585	0	0	\N
161547	2132	148078079000	21066	10585	1	0	\N
161551	1397	1314507585000	21068	10585	0	0	\N
161552	2133	96147306000	21068	10585	1	0	\N
161553	2132	148078079000	21068	10585	2	0	\N
161554	1397	1314507585000	21069	10585	0	0	\N
161555	2133	96147306000	21069	10585	1	0	\N
161556	2132	148078079000	21069	10585	2	0	\N
161563	1397	1314467581000	21071	10587	0	0	\N
161564	2132	148077078000	21071	10587	1	0	\N
161565	2133	96143298000	21071	10587	2	0	\N
161550	2132	148078079000	21067	10585	2	0	921
161557	1397	1314497584000	21070	10586	0	0	12433
161558	1397	1314487583000	21070	10586	1	0	12434
161559	1397	1314477582000	21070	10586	2	0	12435
161560	2133	96146304000	21070	10586	3	0	2848
161562	2133	96144300000	21070	10586	5	0	2850
161566	1397	1314467581000	21072	10587	0	0	12436
161567	2132	148077078000	21072	10587	1	0	922
161568	2133	96143298000	21072	10587	2	0	2851
161571	1397	1314457580000	21074	10588	0	0	\N
161572	2133	96142296000	21074	10588	1	0	\N
161573	1397	1314457580000	21075	10588	0	0	\N
161574	2133	96142296000	21075	10588	1	0	\N
161575	1397	1314457580000	21076	10588	0	0	\N
161576	2133	96142296000	21076	10588	1	0	\N
161579	1397	1314437578000	21078	10590	0	0	\N
161580	2132	148076077000	21078	10590	1	0	\N
161581	2133	96140292000	21078	10590	2	0	\N
161585	1397	1314427577000	21080	10591	0	0	\N
161586	2133	96139290000	21080	10591	1	0	\N
161596	1397	1314407575000	21084	10593	0	0	\N
161597	1397	1314397574000	21084	10593	1	0	\N
161598	2132	148075076000	21084	10593	2	0	\N
161599	2133	96137286000	21084	10593	3	0	\N
161600	2133	96136284000	21084	10593	5	0	\N
161601	1397	1314407575000	21085	10593	0	0	\N
161602	1397	1314397574000	21085	10593	1	0	\N
161603	2132	148075076000	21085	10593	2	0	\N
161604	2133	96137286000	21085	10593	3	0	\N
161605	2133	96136284000	21085	10593	5	0	\N
161606	1397	1314387573000	21086	10594	0	0	\N
161607	2133	96135282000	21086	10594	1	0	\N
161608	1397	1314387573000	21087	10594	0	0	\N
161609	2133	96135282000	21087	10594	1	0	\N
161610	1397	1314387573000	21088	10594	0	0	\N
161611	2133	96135282000	21088	10594	1	0	\N
161614	1397	1314387573000	21090	10594	0	0	\N
161615	2133	96135282000	21090	10594	1	0	\N
161621	1682	10341000000	21092	10579	0	0	\N
161622	1682	9331000000	21092	10579	1	0	\N
161623	1850	14038008949999	21092	10579	2	0	\N
161624	1850	9674898949999	21092	10579	3	0	\N
161625	1850	6730988949999	21092	10579	4	0	\N
161626	1850	4296178949999	21092	10579	5	0	\N
161627	1397	1314357570000	21093	10596	0	0	\N
161628	1397	1314347569000	21093	10596	1	0	\N
161629	2133	96132276000	21093	10596	2	0	\N
161630	2133	96131274000	21093	10596	3	0	\N
161631	1397	1314357570000	21094	10596	0	0	\N
161632	1397	1314347569000	21094	10596	1	0	\N
161633	2133	96132276000	21094	10596	2	0	\N
161634	2133	96131274000	21094	10596	3	0	\N
161635	1397	1314357570000	21095	10596	0	0	\N
161636	1397	1314347569000	21095	10596	1	0	\N
161637	2133	96132276000	21095	10596	2	0	\N
161638	2133	96131274000	21095	10596	3	0	\N
161639	1397	1314357570000	21096	10596	0	0	\N
161640	1397	1314347569000	21096	10596	1	0	\N
161641	2133	96132276000	21096	10596	2	0	\N
161642	2133	96131274000	21096	10596	3	0	\N
161647	1397	1314337568000	21098	10597	0	0	\N
161648	2132	148073074000	21098	10597	1	0	\N
161649	2133	96130272000	21098	10597	2	0	\N
161650	1397	1314337568000	21099	10597	0	0	\N
161651	2132	148073074000	21099	10597	1	0	\N
161652	2133	96130272000	21099	10597	2	0	\N
161657	1397	1314327567000	21102	10598	0	0	\N
161663	1397	1314307565000	21105	10600	0	0	\N
161664	2132	148072073000	21105	10600	1	0	\N
161665	2133	96128268000	21105	10600	2	0	\N
161666	1397	1314317566000	21106	10599	0	0	\N
161667	1397	1314307565000	21106	10599	1	0	\N
161668	1397	1314297564000	21106	10599	2	0	\N
161669	2132	148072073000	21106	10599	3	0	\N
161670	2133	96129270000	21106	10599	4	0	\N
161671	2133	96128268000	21106	10599	5	0	\N
161672	2133	96127266000	21106	10599	6	0	\N
161673	1397	1314307565000	21107	10600	0	0	\N
161674	1397	1314297564000	21107	10600	1	0	\N
161675	2132	148072073000	21107	10600	2	0	\N
161676	2133	96128268000	21107	10600	3	0	\N
161677	2133	96127266000	21107	10600	4	0	\N
161678	1397	1314297564000	21108	10601	0	0	\N
161679	1397	1314287563000	21108	10601	1	0	\N
161680	2133	96127266000	21108	10601	2	0	\N
161681	2133	96126264000	21108	10601	3	0	\N
161687	1397	1314277562000	21111	10602	0	0	\N
161688	1397	1314267561000	21112	10603	0	0	\N
161689	2132	148071072000	21112	10603	1	0	\N
161690	2133	96125262000	21112	10603	2	0	\N
161691	1397	1314267561000	21113	10603	0	0	\N
161692	2132	148071072000	21113	10603	1	0	\N
161693	2133	96125262000	21113	10603	2	0	\N
161697	1397	1314257560000	21115	10604	0	0	\N
161698	2133	96124260000	21115	10604	1	0	\N
161577	1397	1314447579000	21077	10589	0	0	12438
161578	2133	96141294000	21077	10589	1	0	2853
161582	1397	1314437578000	21079	10590	0	0	12439
161583	2132	148076077000	21079	10590	1	0	923
161584	2133	96140292000	21079	10590	2	0	2854
161588	2133	96139290000	21081	10591	1	0	2855
161589	1397	1314417576000	21082	10592	0	0	12441
161590	2133	96138288000	21082	10592	1	0	2856
161591	1397	1314407575000	21083	10593	0	0	12442
161592	1397	1314397574000	21083	10593	1	0	12443
161594	2133	96137286000	21083	10593	3	0	2857
161595	2133	96136284000	21083	10593	5	0	2858
161612	1397	1314387573000	21089	10594	0	0	12444
161613	2133	96135282000	21089	10594	1	0	2859
161617	1397	1314367571000	21091	10595	1	0	12446
161618	2133	96134280000	21091	10595	2	0	2860
161619	2133	96133278000	21091	10595	3	0	2861
161620	2132	148074075000	21091	10595	4	0	925
161643	1397	1314357570000	21097	10596	0	0	12447
161645	2133	96132276000	21097	10596	2	0	2862
161646	2133	96131274000	21097	10596	3	0	2863
161653	1397	1314337568000	21100	10597	0	0	12449
161654	2132	148073074000	21100	10597	1	0	926
161655	2133	96130272000	21100	10597	2	0	2864
161658	1397	1314317566000	21103	10599	0	0	12451
161659	2133	96129270000	21103	10599	1	0	2865
161660	1397	1314307565000	21104	10600	0	0	12452
161661	2132	148072073000	21104	10600	1	0	927
161682	1397	1314297564000	21109	10601	0	0	12453
161683	1397	1314287563000	21109	10601	1	0	12454
161684	2133	96127266000	21109	10601	2	0	2867
161685	2133	96126264000	21109	10601	3	0	2868
161686	1397	1314277562000	21110	10602	0	0	12455
161695	2132	148071072000	21114	10603	1	0	928
161696	2133	96125262000	21114	10603	2	0	2869
161699	1397	1314257560000	21116	10604	0	0	12457
161700	2133	96124260000	21116	10604	1	0	2870
161701	1397	1314247559000	21117	10605	0	0	12458
161703	1397	1314237558000	21118	10606	0	0	12459
161704	2133	96122256000	21118	10606	1	0	2872
161710	1397	1314207555000	21120	10608	0	0	\N
161711	2132	148069070000	21120	10608	1	0	\N
161712	2133	96119250000	21120	10608	2	0	\N
161722	2132	148068069000	21123	10610	0	0	\N
161723	2133	96115242000	21123	10610	1	0	\N
161724	1397	1314167551000	21124	10610	0	0	\N
161725	2132	148068069000	21124	10610	1	0	\N
161726	2133	96115242000	21124	10610	2	0	\N
161731	1397	1314167551000	21127	10611	0	0	\N
161732	2133	96114240000	21127	10611	1	0	\N
161735	1397	1314157550000	21129	10612	0	0	\N
161736	2133	96113238000	21129	10612	1	0	\N
161737	1397	1314147549000	21130	10613	0	0	\N
161738	2132	148067068000	21130	10613	1	0	\N
161739	2133	96112236000	21130	10613	2	0	\N
161743	1397	1314147549000	21132	10613	0	0	\N
161744	2132	148067068000	21132	10613	1	0	\N
161745	2133	96112236000	21132	10613	2	0	\N
161746	1397	1314147549000	21133	10613	0	0	\N
161747	2132	148067068000	21133	10613	1	0	\N
161748	2133	96112236000	21133	10613	2	0	\N
161749	1397	1314137548000	21134	10614	0	0	\N
161750	1397	1314127547000	21134	10614	1	0	\N
161751	2133	96111234000	21134	10614	2	0	\N
161752	2133	96110232000	21134	10614	3	0	\N
161753	1397	1314137548000	21135	10614	0	0	\N
161754	1397	1314127547000	21135	10614	1	0	\N
161755	2133	96111234000	21135	10614	2	0	\N
161756	2133	96110232000	21135	10614	3	0	\N
161757	1397	1314137548000	21137	10614	0	0	\N
161758	1397	1314127547000	21137	10614	1	0	\N
161759	1397	1314137548000	21138	10614	0	0	\N
161760	1397	1314127547000	21138	10614	1	0	\N
161761	2133	96111234000	21138	10614	2	0	\N
161762	2133	96110232000	21138	10614	3	0	\N
161763	1397	1314137548000	21139	10614	0	0	\N
161764	1397	1314127547000	21139	10614	1	0	\N
161765	2133	96111234000	21139	10614	2	0	\N
161766	2133	96110232000	21139	10614	3	0	\N
161776	1397	1314107545000	21142	10616	0	0	\N
161777	2133	96108228000	21142	10616	1	0	\N
161778	1397	1314107545000	21143	10616	0	0	\N
161779	2133	96108228000	21143	10616	1	0	\N
161797	1397	1314027537000	21148	10620	0	0	\N
161798	2133	96100212000	21148	10620	1	0	\N
161799	1397	1314027537000	21149	10621	0	0	\N
161800	1397	1314017536000	21149	10621	1	0	\N
161801	1397	1314007535000	21149	10621	2	0	\N
161802	2133	96100212000	21149	10621	3	0	\N
161803	2133	96099210000	21149	10621	4	0	\N
161804	2133	96098208000	21149	10621	5	0	\N
161816	1397	1313977532000	21152	10623	0	0	\N
161817	2133	96095202000	21152	10623	1	0	\N
161822	1397	1313967531000	21155	10624	0	0	\N
161823	2133	96094200000	21155	10624	1	0	\N
161826	1397	1313957530000	21157	10625	0	0	\N
161827	2133	96093198000	21157	10625	1	0	\N
161836	1397	1313907525000	21160	10628	0	0	\N
161837	2133	96088188000	21160	10628	1	0	\N
161840	1397	1313907525000	21162	10628	0	0	\N
161707	1397	1314217556000	21119	10607	1	0	12461
161708	2133	96121254000	21119	10607	2	0	2873
161709	2133	96120252000	21119	10607	3	0	2874
161713	1397	1314207555000	21121	10608	0	0	12462
161714	2132	148069070000	21121	10608	1	0	930
161716	1397	1314197554000	21122	10609	0	0	12463
161717	1397	1314187553000	21122	10609	1	0	12464
161718	1397	1314177552000	21122	10609	2	0	12465
161719	2133	96118248000	21122	10609	3	0	2876
161720	2133	96117246000	21122	10609	4	0	2877
161727	2132	148068069000	21125	10610	0	0	931
161728	2133	96115242000	21125	10610	1	0	2879
161729	1397	1314167551000	21126	10611	0	0	12466
161730	2133	96114240000	21126	10611	1	0	2880
161734	2133	96113238000	21128	10612	1	0	2881
161740	1397	1314147549000	21131	10613	0	0	12468
161741	2132	148067068000	21131	10613	1	0	932
161742	2133	96112236000	21131	10613	2	0	2882
161767	1397	1314137548000	21140	10615	0	0	12469
161769	1397	1314117546000	21140	10615	2	0	12471
161770	2132	148066067000	21140	10615	3	0	933
161771	2133	96111234000	21140	10615	4	0	2883
161772	2133	96110232000	21140	10615	5	0	2884
161773	2133	96109230000	21140	10615	6	0	2885
161775	2133	96108228000	21141	10616	1	0	2886
161780	1397	1314097544000	21144	10617	0	0	12473
161781	1397	1314087543000	21144	10617	1	0	12474
161782	2133	96107226000	21144	10617	2	0	2887
161784	1397	1314077542000	21145	10618	0	0	12475
161785	2132	148065066000	21145	10618	1	0	934
161786	2133	96105222000	21145	10618	2	0	2889
161787	1932	1372908664093	21146	10619	0	0	7
161788	1397	1314067541000	21146	10619	1	0	12476
161790	1397	1314047539000	21146	10619	4	0	12478
161791	1397	1314037538000	21146	10619	5	0	12479
161792	2132	148064065000	21146	10619	6	0	935
161793	2133	96104220000	21146	10619	7	0	2890
161794	2133	96103218000	21146	10619	8	0	2891
161796	2133	96101214000	21146	10619	10	0	2893
161805	1397	1314027537000	21150	10621	0	0	12480
161806	1397	1314017536000	21150	10621	1	0	12481
161807	1397	1314007535000	21150	10621	2	0	12482
161809	2133	96099210000	21150	10621	4	0	2895
161810	2133	96098208000	21150	10621	5	0	2896
161811	1397	1313997534000	21151	10622	0	0	12483
161812	1397	1313987533000	21151	10622	1	0	12484
161813	1932	1372906664093	21151	10622	2	0	8
161815	2133	96096204000	21151	10622	4	0	2898
161818	1397	1313977532000	21153	10623	0	0	12485
161819	2133	96095202000	21153	10623	1	0	2899
161820	1397	1313967531000	21154	10624	0	0	12486
161821	2133	96094200000	21154	10624	1	0	2900
161825	2133	96093198000	21156	10625	1	0	2901
161828	1397	1313947529000	21158	10626	0	0	12488
161829	2133	96092196000	21158	10626	1	0	2902
161830	1397	1313937528000	21159	10627	0	0	12489
161832	1397	1313917526000	21159	10627	2	0	12491
161833	2133	96091194000	21159	10627	3	0	2903
161834	2133	96090192000	21159	10627	4	0	2904
161835	2133	96089190000	21159	10627	5	0	2905
161838	1397	1313907525000	21161	10628	0	0	12492
161841	2133	96088188000	21162	10628	1	0	\N
161846	1397	1313887523000	21165	10630	0	0	\N
161847	2133	96086184000	21165	10630	1	0	\N
161852	1397	1313867521000	21168	10632	0	0	\N
161853	2133	96084180000	21168	10632	1	0	\N
161854	1682	10341000000	21169	10471	0	0	\N
161855	365	66017201000000	21169	10471	1	0	\N
161856	1564	10241589000000	21169	10471	2	0	\N
161857	1564	6973569000000	21169	10471	3	0	\N
161858	2100	1434860000000	21169	10471	4	0	\N
161859	2100	2830000000	21169	10471	5	0	\N
161860	1564	4768549000000	21169	10471	6	0	\N
161861	1564	3306529000000	21169	10471	7	0	\N
161862	1564	2838509000000	21169	10471	8	0	\N
161863	1682	9331000000	21169	10471	9	0	\N
161864	1932	1372908664093	21169	10471	10	0	\N
161865	242	66648395291044	21169	10471	11	0	\N
161866	1608	12149912000000	21169	10471	12	0	\N
161867	1608	7737612000000	21169	10471	13	0	\N
161868	1397	1315697704000	21169	10471	14	0	\N
161869	1850	14038008949999	21169	10471	15	0	\N
161870	1850	9674898949999	21169	10471	16	0	\N
161871	1850	6730988949999	21169	10471	17	0	\N
161872	1850	4296178949999	21169	10471	18	0	\N
161873	1608	4760542000000	21169	10471	19	0	\N
161874	1608	2298302000000	21169	10471	20	0	\N
161875	1397	1315687703000	21169	10471	21	0	\N
161876	1756	3440720195609	21169	10471	22	0	\N
161877	2039	20879545000000	21169	10471	23	0	\N
161878	2039	18325785000000	21169	10471	24	0	\N
161879	2039	15238175000000	21169	10471	25	0	\N
161880	2039	10662265000000	21169	10471	26	0	\N
161881	2039	2059255000000	21169	10471	27	0	\N
161882	1714	11638176439708	21169	10471	28	0	\N
161883	1714	9295374638556	21169	10471	29	0	\N
161884	1714	5823121253616	21169	10471	30	0	\N
161885	1714	3885466171760	21169	10471	31	0	\N
161886	149	69695228000341	21169	10471	32	0	\N
161887	1397	1315677702000	21169	10471	33	0	\N
161888	1397	1315667701000	21169	10471	34	0	\N
161889	1397	1315657700000	21169	10471	35	0	\N
161890	1397	1315647699000	21169	10471	36	0	\N
161891	1397	1315637698000	21169	10471	37	0	\N
161892	1397	1315627697000	21169	10471	38	0	\N
161893	1397	1315617696000	21169	10471	39	0	\N
161894	1397	1315607695000	21169	10471	40	0	\N
161895	1397	1315597694000	21169	10471	41	0	\N
161896	1397	1315587693000	21169	10471	42	0	\N
161897	1397	1315577692000	21169	10471	43	0	\N
161898	1397	1315567691000	21169	10471	44	0	\N
161899	1397	1315557690000	21169	10471	45	0	\N
161900	1397	1315547689000	21169	10471	46	0	\N
161901	1397	1315537688000	21169	10471	47	0	\N
161902	1397	1315527687000	21169	10471	48	0	\N
161903	1397	1315517686000	21169	10471	49	0	\N
161904	1397	1315507685000	21169	10471	50	0	\N
161905	1397	1315497684000	21169	10471	51	0	\N
161906	1397	1315487683000	21169	10471	52	0	\N
161907	1397	1315477682000	21169	10471	53	0	\N
161908	1397	1315467681000	21169	10471	54	0	\N
161909	1397	1315457680000	21169	10471	55	0	\N
161910	1397	1315447679000	21169	10471	56	0	\N
161911	1397	1315437678000	21169	10471	57	0	\N
161912	1397	1315427677000	21169	10471	58	0	\N
161913	1397	1315417676000	21169	10471	59	0	\N
161914	1397	1315407675000	21169	10471	60	0	\N
161915	1397	1315397674000	21169	10471	61	0	\N
161916	1397	1315387673000	21169	10471	62	0	\N
161917	1397	1315377672000	21169	10471	63	0	\N
161918	1397	1315367671000	21169	10471	64	0	\N
161919	1397	1315357670000	21169	10471	65	0	\N
161920	1397	1315347669000	21169	10471	66	0	\N
161921	1397	1315337668000	21169	10471	67	0	\N
161922	1397	1315327667000	21169	10471	68	0	\N
161923	1397	1315317666000	21169	10471	69	0	\N
161924	1397	1315307665000	21169	10471	70	0	\N
161925	1397	1315297664000	21169	10471	71	0	\N
161926	1397	1315287663000	21169	10471	73	0	\N
161927	1397	1315277662000	21169	10471	74	0	\N
161928	1397	1315267661000	21169	10471	75	0	\N
161929	1397	1315257660000	21169	10471	76	0	\N
161930	1397	1315247659000	21169	10471	77	0	\N
161931	1397	1315237658000	21169	10471	78	0	\N
161932	1397	1315227657000	21169	10471	79	0	\N
161933	1397	1315217656000	21169	10471	80	0	\N
161934	1397	1315207655000	21169	10471	81	0	\N
161935	1397	1315197654000	21169	10471	82	0	\N
161936	1397	1315187653000	21169	10471	83	0	\N
161937	1397	1315177652000	21169	10471	84	0	\N
161938	1397	1315167651000	21169	10471	85	0	\N
161939	1397	1315157650000	21169	10471	86	0	\N
161940	1397	1315147649000	21169	10471	87	0	\N
161941	1397	1315137648000	21169	10471	88	0	\N
161942	1397	1315127647000	21169	10471	89	0	\N
161943	1397	1315117646000	21169	10471	90	0	\N
161944	1397	1315107645000	21169	10471	91	0	\N
161945	1672	15791254000000	21169	10471	92	0	\N
161946	1672	9637244000000	21169	10471	93	0	\N
161947	1672	5484234000000	21169	10471	94	0	\N
161948	1672	2049224000000	21169	10471	95	0	\N
161949	1672	721214000000	21169	10471	96	0	\N
161950	242	66001385291044	21169	10471	97	0	\N
161951	1397	1315097644000	21169	10471	98	0	\N
161952	1397	1315087643000	21169	10471	99	0	\N
161953	1397	1315077642000	21169	10471	100	0	\N
161954	1397	1315067641000	21169	10471	101	0	\N
161955	1397	1315057640000	21169	10471	102	0	\N
161956	1397	1315047639000	21169	10471	103	0	\N
161957	1397	1315037638000	21169	10471	104	0	\N
161958	1397	1315027637000	21169	10471	105	0	\N
161959	1397	1315017636000	21169	10471	106	0	\N
161960	1397	1315007635000	21169	10471	107	0	\N
161961	1397	1314997634000	21169	10471	108	0	\N
161962	1397	1314987633000	21169	10471	109	0	\N
161963	1397	1314977632000	21169	10471	110	0	\N
161964	1397	1314967631000	21169	10471	111	0	\N
161965	1397	1314957630000	21169	10471	112	0	\N
161966	1397	1314947629000	21169	10471	113	0	\N
161967	1397	1314937628000	21169	10471	114	0	\N
161968	1397	1314927627000	21169	10471	115	0	\N
161969	1397	1314917626000	21169	10471	116	0	\N
161970	1397	1314907625000	21169	10471	117	0	\N
161971	1397	1314897624000	21169	10471	118	0	\N
161972	1397	1314887623000	21169	10471	119	0	\N
161973	1397	1314877622000	21169	10471	120	0	\N
161974	1397	1314867621000	21169	10471	121	0	\N
161975	1397	1314857620000	21169	10471	122	0	\N
161976	1397	1314847619000	21169	10471	123	0	\N
161844	1397	1313887523000	21164	10630	0	0	12494
161845	2133	96086184000	21164	10630	1	0	2908
161848	1397	1313877522000	21166	10631	0	0	12495
161849	2133	96085182000	21166	10631	1	0	2909
161850	1397	1313867521000	21167	10632	0	0	12496
161977	1397	1314837618000	21169	10471	124	0	\N
161978	1397	1314827617000	21169	10471	125	0	\N
161979	1397	1313857520000	21170	10633	0	0	\N
161980	2133	96083178000	21170	10633	1	0	\N
161981	1682	10341000000	21171	10575	0	0	\N
161982	1682	9331000000	21171	10575	1	0	\N
161983	1932	1372908664093	21171	10575	2	0	\N
161984	1850	14038008949999	21171	10575	3	0	\N
161985	1850	9674898949999	21171	10575	4	0	\N
161986	1850	6730988949999	21171	10575	5	0	\N
161987	1850	4296178949999	21171	10575	6	0	\N
161988	1932	1372906664093	21171	10575	7	0	\N
161989	1397	1313857520000	21172	10633	0	0	\N
161990	2133	96083178000	21172	10633	1	0	\N
161991	1397	1313857520000	21173	10633	0	0	\N
161992	2133	96083178000	21173	10633	1	0	\N
161995	1397	1313857520000	21175	10633	0	0	\N
161996	2133	96083178000	21175	10633	1	0	\N
161997	1397	1313847519000	21176	10634	0	0	\N
161998	1397	1313837518000	21176	10634	1	0	\N
161999	1397	1313827517000	21176	10634	2	0	\N
162000	2133	96082176000	21176	10634	3	0	\N
162001	2133	96081174000	21176	10634	4	0	\N
162002	1397	1313847519000	21177	10634	0	0	\N
162003	1397	1313837518000	21177	10634	1	0	\N
162004	1397	1313827517000	21177	10634	2	0	\N
162005	2133	96082176000	21177	10634	3	0	\N
162006	2133	96081174000	21177	10634	4	0	\N
162014	1397	1313817516000	21180	10635	0	0	\N
162015	2133	96080172000	21180	10635	1	0	\N
162020	1397	1313787513000	21182	10637	0	0	\N
162021	2133	96077166000	21182	10637	1	0	\N
162030	1397	1313777512000	21185	10638	0	0	\N
162031	1397	1313767511000	21185	10638	1	0	\N
162032	1397	1313757510000	21185	10638	2	0	\N
162033	2133	96076164000	21185	10638	3	0	\N
162034	2133	96075162000	21185	10638	4	0	\N
162035	2133	96074160000	21185	10638	5	0	\N
162036	1397	1313747509000	21186	10639	0	0	\N
162037	1740	4050615000000	21186	10639	1	0	\N
162040	1932	1372908664093	21188	10477	0	0	\N
162041	1397	1314787613000	21188	10477	1	0	\N
162042	1397	1314777612000	21188	10477	2	0	\N
162043	1397	1314767611000	21188	10477	3	0	\N
162044	1397	1314757610000	21188	10477	4	0	\N
162045	1397	1314747609000	21188	10477	5	0	\N
162046	1397	1314737608000	21188	10477	6	0	\N
162047	1397	1314727607000	21188	10477	7	0	\N
162048	1397	1314717606000	21188	10477	8	0	\N
162049	1397	1314707605000	21188	10477	9	0	\N
162050	1397	1314697604000	21188	10477	10	0	\N
162051	1397	1314687603000	21188	10477	11	0	\N
162052	1397	1314677602000	21188	10477	12	0	\N
162053	1397	1314667601000	21188	10477	13	0	\N
162054	1397	1314657600000	21188	10477	14	0	\N
162055	1397	1314647599000	21188	10477	15	0	\N
162056	1397	1314637598000	21188	10477	16	0	\N
162057	1397	1314627597000	21188	10477	17	0	\N
162058	1397	1314617596000	21188	10477	18	0	\N
162059	1397	1314607595000	21188	10477	19	0	\N
162060	1397	1314597594000	21188	10477	20	0	\N
162061	1397	1314587593000	21188	10477	21	0	\N
162062	1397	1314577592000	21188	10477	22	0	\N
162063	1397	1314567591000	21188	10477	23	0	\N
162064	1397	1314557590000	21188	10477	24	0	\N
162065	1397	1314547589000	21188	10477	25	0	\N
162066	1397	1314537588000	21188	10477	26	0	\N
162067	1397	1314527587000	21188	10477	27	0	\N
162068	1397	1314517586000	21188	10477	28	0	\N
162069	1397	1314507585000	21188	10477	29	0	\N
162070	1397	1314497584000	21188	10477	30	0	\N
162071	1397	1314487583000	21188	10477	31	0	\N
162072	1397	1314477582000	21188	10477	32	0	\N
162073	1397	1314467581000	21188	10477	33	0	\N
162074	1397	1314457580000	21188	10477	34	0	\N
162075	1397	1314447579000	21188	10477	35	0	\N
162076	1397	1314437578000	21188	10477	36	0	\N
162077	1397	1314427577000	21188	10477	37	0	\N
162078	1397	1314417576000	21188	10477	38	0	\N
162079	1397	1314407575000	21188	10477	39	0	\N
162080	1397	1314397574000	21188	10477	40	0	\N
162081	1397	1314387573000	21188	10477	41	0	\N
162082	1397	1314377572000	21188	10477	42	0	\N
162083	1397	1314367571000	21188	10477	43	0	\N
162084	1397	1314357570000	21188	10477	44	0	\N
162085	1397	1314347569000	21188	10477	45	0	\N
162086	1397	1314337568000	21188	10477	46	0	\N
162087	1397	1314327567000	21188	10477	47	0	\N
162088	1397	1314317566000	21188	10477	48	0	\N
162089	1397	1314307565000	21188	10477	49	0	\N
162090	1397	1314297564000	21188	10477	50	0	\N
162091	1397	1314287563000	21188	10477	51	0	\N
162092	1397	1314277562000	21188	10477	52	0	\N
162093	1397	1314267561000	21188	10477	53	0	\N
162094	1397	1314257560000	21188	10477	54	0	\N
162095	1397	1314247559000	21188	10477	55	0	\N
162096	1397	1314237558000	21188	10477	56	0	\N
162097	1397	1314227557000	21188	10477	58	0	\N
162098	1397	1314217556000	21188	10477	59	0	\N
162099	1397	1314207555000	21188	10477	60	0	\N
162100	1397	1314197554000	21188	10477	61	0	\N
162101	1397	1314187553000	21188	10477	62	0	\N
162102	1397	1314177552000	21188	10477	63	0	\N
162103	1397	1314167551000	21188	10477	64	0	\N
162104	1397	1314157550000	21188	10477	65	0	\N
162105	1397	1314147549000	21188	10477	66	0	\N
162106	1397	1314137548000	21188	10477	67	0	\N
162107	1397	1314127547000	21188	10477	68	0	\N
162108	1397	1314117546000	21188	10477	69	0	\N
162109	1397	1314107545000	21188	10477	70	0	\N
162110	1397	1314097544000	21188	10477	71	0	\N
162111	1397	1314087543000	21188	10477	72	0	\N
162112	1397	1314077542000	21188	10477	73	0	\N
162007	1397	1313847519000	21178	10634	0	0	12498
162008	1397	1313837518000	21178	10634	1	0	12499
162009	1397	1313827517000	21178	10634	2	0	12500
162010	2133	96082176000	21178	10634	3	0	2912
162011	2133	96081174000	21178	10634	4	0	2913
162013	2133	96080172000	21179	10635	1	0	2914
162016	1397	1313807515000	21181	10636	0	0	12502
162017	1397	1313797514000	21181	10636	1	0	12503
162018	2133	96079170000	21181	10636	2	0	2915
162019	2133	96078168000	21181	10636	3	0	2916
162023	2133	96077166000	21183	10637	1	0	2917
162024	1397	1313777512000	21184	10638	0	0	12505
162025	1397	1313767511000	21184	10638	1	0	12506
162026	1397	1313757510000	21184	10638	2	0	12507
162028	2133	96075162000	21184	10638	4	0	2919
162029	2133	96074160000	21184	10638	5	0	2920
162038	1397	1313747509000	21187	10639	0	0	12508
162039	1740	4050615000000	21187	10639	1	0	13
162113	1397	1314067541000	21188	10477	74	0	\N
162114	1397	1314057540000	21188	10477	75	0	\N
162115	1397	1314047539000	21188	10477	76	0	\N
162116	1397	1314037538000	21188	10477	77	0	\N
162117	1397	1314027537000	21188	10477	78	0	\N
162118	1397	1314017536000	21188	10477	79	0	\N
162119	1397	1314007535000	21188	10477	80	0	\N
162120	1397	1313997534000	21188	10477	81	0	\N
162121	1397	1313987533000	21188	10477	82	0	\N
162122	1397	1313977532000	21188	10477	83	0	\N
162123	1397	1313967531000	21188	10477	84	0	\N
162124	1397	1313957530000	21188	10477	85	0	\N
162125	1397	1313947529000	21188	10477	86	0	\N
162126	1397	1313937528000	21188	10477	87	0	\N
162127	1397	1313927527000	21188	10477	88	0	\N
162128	1397	1313917526000	21188	10477	89	0	\N
162129	1397	1313907525000	21188	10477	90	0	\N
162130	1397	1313897524000	21188	10477	91	0	\N
162131	1397	1313887523000	21188	10477	92	0	\N
162132	1397	1313877522000	21188	10477	93	0	\N
162133	1397	1313867521000	21188	10477	94	0	\N
162134	1397	1313857520000	21188	10477	95	0	\N
162135	1397	1313847519000	21188	10477	96	0	\N
162136	1397	1313837518000	21188	10477	97	0	\N
162137	1397	1313827517000	21188	10477	98	0	\N
162138	1397	1313817516000	21188	10477	99	0	\N
162139	1397	1313807515000	21188	10477	100	0	\N
162140	1397	1313797514000	21188	10477	101	0	\N
162141	1397	1313787513000	21188	10477	102	0	\N
162142	1397	1313777512000	21188	10477	103	0	\N
162143	1397	1313767511000	21188	10477	104	0	\N
162144	1397	1313757510000	21188	10477	105	0	\N
162145	1397	1313747509000	21188	10477	106	0	\N
162146	1397	1313737508000	21188	10477	107	0	\N
162147	1682	10341000000	21189	10557	0	0	\N
162148	1682	9331000000	21189	10557	1	0	\N
162149	1932	1372908664093	21189	10557	2	0	\N
162150	1608	12149912000000	21189	10557	3	0	\N
162151	1608	7737612000000	21189	10557	4	0	\N
162152	1850	14038008949999	21189	10557	5	0	\N
162153	1850	9674898949999	21189	10557	6	0	\N
162154	1850	6730988949999	21189	10557	7	0	\N
162155	1850	4296178949999	21189	10557	8	0	\N
162156	1608	4760542000000	21189	10557	9	0	\N
162157	1608	2298302000000	21189	10557	10	0	\N
162158	1397	1314917626000	21189	10557	11	0	\N
162159	1714	11638176439708	21189	10557	12	0	\N
162160	1714	9295374638556	21189	10557	13	0	\N
162161	1714	5823121253616	21189	10557	14	0	\N
162162	1714	3885466171760	21189	10557	15	0	\N
162163	1397	1314907625000	21189	10557	16	0	\N
162164	1397	1314897624000	21189	10557	17	0	\N
162165	1397	1314887623000	21189	10557	18	0	\N
162166	1397	1314877622000	21189	10557	19	0	\N
162167	1397	1314867621000	21189	10557	20	0	\N
162168	1397	1314857620000	21189	10557	21	0	\N
162169	1397	1314847619000	21189	10557	22	0	\N
162170	1397	1314837618000	21189	10557	23	0	\N
162171	1397	1314827617000	21189	10557	24	0	\N
162172	1397	1314817616000	21189	10557	25	0	\N
162173	1397	1314807615000	21189	10557	26	0	\N
162174	1397	1314797614000	21189	10557	27	0	\N
162175	1397	1314787613000	21189	10557	28	0	\N
162176	1397	1314777612000	21189	10557	29	0	\N
162177	1397	1314767611000	21189	10557	30	0	\N
162178	1397	1314757610000	21189	10557	31	0	\N
162179	1397	1314747609000	21189	10557	32	0	\N
162180	1397	1314737608000	21189	10557	33	0	\N
162181	1397	1314727607000	21189	10557	34	0	\N
162182	1397	1314717606000	21189	10557	35	0	\N
162183	1397	1314707605000	21189	10557	36	0	\N
162184	1397	1314697604000	21189	10557	37	0	\N
162185	1397	1314687603000	21189	10557	38	0	\N
162186	1397	1314677602000	21189	10557	39	0	\N
162187	1397	1314667601000	21189	10557	40	0	\N
162188	1397	1314657600000	21189	10557	41	0	\N
162189	1397	1314647599000	21189	10557	42	0	\N
162190	1397	1314637598000	21189	10557	43	0	\N
162191	1397	1314627597000	21189	10557	44	0	\N
162192	1397	1314617596000	21189	10557	45	0	\N
162193	1397	1314607595000	21189	10557	46	0	\N
162194	1397	1314597594000	21189	10557	47	0	\N
162195	1397	1314587593000	21189	10557	48	0	\N
162196	1397	1314577592000	21189	10557	49	0	\N
162197	1397	1314567591000	21189	10557	50	0	\N
162198	1397	1314557590000	21189	10557	51	0	\N
162199	1397	1314547589000	21189	10557	52	0	\N
162200	1397	1314537588000	21189	10557	53	0	\N
162201	1397	1314527587000	21189	10557	54	0	\N
162202	1397	1314517586000	21189	10557	55	0	\N
162203	1397	1314507585000	21189	10557	56	0	\N
162204	1397	1314497584000	21189	10557	57	0	\N
162205	1397	1314487583000	21189	10557	58	0	\N
162206	1397	1314477582000	21189	10557	59	0	\N
162207	1397	1314467581000	21189	10557	60	0	\N
162208	1397	1314457580000	21189	10557	61	0	\N
162209	1397	1314447579000	21189	10557	62	0	\N
162210	1397	1314437578000	21189	10557	63	0	\N
162211	1397	1314427577000	21189	10557	64	0	\N
162212	1397	1314417576000	21189	10557	65	0	\N
162213	1397	1314407575000	21189	10557	66	0	\N
162214	1397	1314397574000	21189	10557	67	0	\N
162215	1397	1314387573000	21189	10557	68	0	\N
162216	1397	1314377572000	21189	10557	69	0	\N
162217	1397	1314367571000	21189	10557	70	0	\N
162218	1397	1314357570000	21189	10557	71	0	\N
162219	1397	1314347569000	21189	10557	72	0	\N
162220	1397	1314337568000	21189	10557	73	0	\N
162221	1397	1314327567000	21189	10557	74	0	\N
162222	1397	1314317566000	21189	10557	75	0	\N
162223	1397	1314307565000	21189	10557	77	0	\N
162224	1397	1314297564000	21189	10557	78	0	\N
162225	1397	1314287563000	21189	10557	79	0	\N
162226	1397	1314277562000	21189	10557	80	0	\N
162227	1397	1314267561000	21189	10557	81	0	\N
162228	1397	1314257560000	21189	10557	82	0	\N
162229	1397	1314247559000	21189	10557	83	0	\N
162230	1397	1314237558000	21189	10557	84	0	\N
162231	1397	1314227557000	21189	10557	85	0	\N
162232	1397	1314217556000	21189	10557	86	0	\N
162233	1397	1314207555000	21189	10557	87	0	\N
162234	1397	1314197554000	21189	10557	88	0	\N
162235	1397	1314187553000	21189	10557	89	0	\N
162236	1397	1314177552000	21189	10557	90	0	\N
162237	1397	1314167551000	21189	10557	91	0	\N
162238	1397	1314157550000	21189	10557	92	0	\N
162239	1397	1314147549000	21189	10557	93	0	\N
162240	1397	1314137548000	21189	10557	94	0	\N
162241	1397	1314127547000	21189	10557	95	0	\N
162242	1397	1314117546000	21189	10557	96	0	\N
162243	1397	1314107545000	21189	10557	97	0	\N
162244	1397	1314097544000	21189	10557	98	0	\N
162245	1397	1314087543000	21189	10557	99	0	\N
162246	1397	1314077542000	21189	10557	100	0	\N
162247	1397	1314067541000	21189	10557	101	0	\N
162248	1397	1314057540000	21189	10557	102	0	\N
162249	1397	1314047539000	21189	10557	103	0	\N
162250	1397	1314037538000	21189	10557	104	0	\N
162251	1397	1314027537000	21189	10557	105	0	\N
162252	1397	1314017536000	21189	10557	106	0	\N
162253	1397	1314007535000	21189	10557	107	0	\N
162254	1397	1313997534000	21189	10557	108	0	\N
162255	1397	1313987533000	21189	10557	109	0	\N
162256	1397	1313977532000	21189	10557	110	0	\N
162257	1397	1313967531000	21189	10557	111	0	\N
162258	1397	1313957530000	21189	10557	112	0	\N
162259	1397	1313947529000	21189	10557	113	0	\N
162260	1397	1313937528000	21189	10557	114	0	\N
162261	1397	1313927527000	21189	10557	115	0	\N
162262	1397	1313917526000	21189	10557	116	0	\N
162263	1397	1313907525000	21189	10557	117	0	\N
162264	1397	1313897524000	21189	10557	118	0	\N
162265	1397	1313887523000	21189	10557	119	0	\N
162266	1397	1313877522000	21189	10557	120	0	\N
162267	1397	1313867521000	21189	10557	121	0	\N
162268	1397	1313857520000	21189	10557	122	0	\N
162269	1397	1313847519000	21189	10557	123	0	\N
162270	1397	1313837518000	21189	10557	124	0	\N
162271	1397	1313827517000	21189	10557	125	0	\N
162272	1397	1313737508000	21190	10640	0	0	\N
162273	1397	1313727507000	21190	10640	1	0	\N
162274	1397	1313717506000	21190	10640	2	0	\N
162275	1397	1313707505000	21190	10640	3	0	\N
162276	2133	96073158000	21190	10640	4	0	\N
162277	2133	96072156000	21190	10640	5	0	\N
162278	2133	96071154000	21190	10640	6	0	\N
162279	2133	96070152000	21190	10640	7	0	\N
162291	1397	1313697504000	21193	10641	0	0	\N
162292	563	75487613000000	21193	10641	1	0	\N
162293	2133	96069150000	21193	10641	2	0	\N
162296	1397	1313677502000	21195	10643	0	0	\N
162297	2133	96067146000	21195	10643	2	0	\N
162300	1397	1313677502000	21197	10643	0	0	\N
162301	2133	96067146000	21197	10643	2	0	\N
162314	2247	648999000000	21200	10596	0	0	\N
162315	2247	648999000000	21201	10587	0	0	\N
162316	1397	1313627497000	21202	10646	0	0	\N
162317	1397	1313617496000	21202	10646	1	0	\N
162318	1397	1313607495000	21202	10646	2	0	\N
162319	2133	96062136000	21202	10646	3	0	\N
162320	2133	96061134000	21202	10646	4	0	\N
162321	2133	96060132000	21202	10646	5	0	\N
162330	1682	10341000000	21205	10462	0	0	\N
162331	365	66017201000000	21205	10462	1	0	\N
162332	1564	10241589000000	21205	10462	2	0	\N
162333	1564	6973569000000	21205	10462	3	0	\N
162334	2100	1434860000000	21205	10462	4	0	\N
162335	2100	2830000000	21205	10462	5	0	\N
162336	1564	4768549000000	21205	10462	6	0	\N
162337	1564	3306529000000	21205	10462	7	0	\N
162338	1564	2838509000000	21205	10462	8	0	\N
162339	1682	9331000000	21205	10462	9	0	\N
162340	1397	1315767711000	21205	10462	10	0	\N
162341	1932	1372908664093	21205	10462	11	0	\N
162342	242	66648395291044	21205	10462	12	0	\N
162343	1608	12149912000000	21205	10462	13	0	\N
162344	1608	7737612000000	21205	10462	14	0	\N
162345	1850	14038008949999	21205	10462	15	0	\N
162346	1850	9674898949999	21205	10462	16	0	\N
162347	1850	6730988949999	21205	10462	17	0	\N
162348	1850	4296178949999	21205	10462	18	0	\N
162349	1608	4760542000000	21205	10462	19	0	\N
162350	1608	2298302000000	21205	10462	20	0	\N
162351	1756	3440720195609	21205	10462	21	0	\N
162352	2039	20879545000000	21205	10462	22	0	\N
162353	2039	18325785000000	21205	10462	23	0	\N
162354	2039	15238175000000	21205	10462	24	0	\N
162355	2039	10662265000000	21205	10462	25	0	\N
162356	2039	2059255000000	21205	10462	26	0	\N
162357	1714	11638176439708	21205	10462	27	0	\N
162358	1714	9295374638556	21205	10462	28	0	\N
162359	1714	5823121253616	21205	10462	29	0	\N
162360	1714	3885466171760	21205	10462	30	0	\N
162361	149	69695228000341	21205	10462	31	0	\N
162362	1672	15791254000000	21205	10462	32	0	\N
162363	1672	9637244000000	21205	10462	33	0	\N
162364	1672	5484234000000	21205	10462	34	0	\N
162365	1672	2049224000000	21205	10462	35	0	\N
162366	1672	721214000000	21205	10462	36	0	\N
162367	242	66001385291044	21205	10462	37	0	\N
162368	1397	1315757710000	21205	10462	38	0	\N
162369	1397	1315747709000	21205	10462	39	0	\N
162370	1397	1315737708000	21205	10462	40	0	\N
162371	1397	1315727707000	21205	10462	41	0	\N
162372	1397	1315717706000	21205	10462	42	0	\N
162373	1397	1315707705000	21205	10462	43	0	\N
162374	1397	1315697704000	21205	10462	44	0	\N
162375	1397	1315687703000	21205	10462	45	0	\N
162376	1397	1315677702000	21205	10462	46	0	\N
162377	1397	1315667701000	21205	10462	47	0	\N
162378	1397	1315657700000	21205	10462	48	0	\N
162379	1397	1315647699000	21205	10462	49	0	\N
162380	1397	1315637698000	21205	10462	50	0	\N
162381	1397	1315627697000	21205	10462	51	0	\N
162382	1397	1315617696000	21205	10462	52	0	\N
162383	1397	1315607695000	21205	10462	53	0	\N
162384	1397	1315597694000	21205	10462	54	0	\N
162282	1397	1313717506000	21191	10640	2	0	12511
162283	1397	1313707505000	21191	10640	3	0	12512
162284	2133	96073158000	21191	10640	4	0	2921
162285	2133	96072156000	21191	10640	5	0	2922
162286	2133	96071154000	21191	10640	6	0	2923
162288	1397	1313697504000	21192	10641	0	0	12513
162289	563	75487613000000	21192	10641	1	0	12
162290	2133	96069150000	21192	10641	2	0	2925
162294	1397	1313687503000	21194	10642	0	0	12514
162295	2133	96068148000	21194	10642	1	0	2926
162299	2133	96067146000	21196	10643	2	0	2927
162302	1397	1313667501000	21198	10644	0	0	12516
162303	2133	96066144000	21198	10644	1	0	2928
162304	1397	1313657500000	21199	10645	0	0	12517
162306	1397	1313637498000	21199	10645	2	0	12519
162307	563	71238611000000	21199	10645	3	0	13
162308	563	68371609000000	21199	10645	4	0	14
162309	563	66000607000000	21199	10645	5	0	15
162310	2133	96065142000	21199	10645	6	0	2929
162312	2133	96064140000	21199	10645	8	0	2930
162313	2133	96063138000	21199	10645	9	0	2931
162322	1397	1313627497000	21203	10646	0	0	12520
162323	1397	1313617496000	21203	10646	1	0	12521
162324	1397	1313607495000	21203	10646	2	0	12522
162326	2133	96061134000	21203	10646	4	0	2933
162327	2133	96060132000	21203	10646	5	0	2934
162328	1397	1313597494000	21204	10647	0	0	12523
162329	2133	96059130000	21204	10647	1	0	2935
162385	1397	1315587693000	21205	10462	55	0	\N
162386	1397	1315577692000	21205	10462	56	0	\N
162387	1397	1315567691000	21205	10462	57	0	\N
162388	1397	1315557690000	21205	10462	58	0	\N
162389	1397	1315547689000	21205	10462	59	0	\N
162390	1397	1315537688000	21205	10462	60	0	\N
162391	1397	1315527687000	21205	10462	61	0	\N
162392	1397	1315517686000	21205	10462	62	0	\N
162393	1397	1315507685000	21205	10462	63	0	\N
162394	1397	1315497684000	21205	10462	64	0	\N
162395	1397	1315487683000	21205	10462	65	0	\N
162396	1397	1315477682000	21205	10462	66	0	\N
162397	1397	1315467681000	21205	10462	67	0	\N
162398	1397	1315457680000	21205	10462	68	0	\N
162399	1397	1315447679000	21205	10462	69	0	\N
162400	1397	1315437678000	21205	10462	70	0	\N
162401	1397	1315427677000	21205	10462	71	0	\N
162402	1397	1315417676000	21205	10462	72	0	\N
162403	1397	1315407675000	21205	10462	73	0	\N
162404	1397	1315397674000	21205	10462	74	0	\N
162405	1397	1315387673000	21205	10462	75	0	\N
162406	1397	1315377672000	21205	10462	76	0	\N
162407	1397	1315367671000	21205	10462	77	0	\N
162408	1397	1315357670000	21205	10462	78	0	\N
162409	1397	1315347669000	21205	10462	79	0	\N
162410	1397	1315337668000	21205	10462	80	0	\N
162411	1397	1315327667000	21205	10462	81	0	\N
162412	1397	1315317666000	21205	10462	82	0	\N
162413	1397	1315307665000	21205	10462	83	0	\N
162414	1397	1315297664000	21205	10462	84	0	\N
162415	1397	1315287663000	21205	10462	85	0	\N
162416	1397	1315277662000	21205	10462	86	0	\N
162417	1397	1315267661000	21205	10462	87	0	\N
162418	1397	1315257660000	21205	10462	88	0	\N
162419	1397	1315247659000	21205	10462	89	0	\N
162420	1397	1315237658000	21205	10462	90	0	\N
162421	1397	1315227657000	21205	10462	91	0	\N
162422	1397	1315217656000	21205	10462	92	0	\N
162423	1397	1315207655000	21205	10462	93	0	\N
162424	1397	1315197654000	21205	10462	94	0	\N
162425	1397	1315187653000	21205	10462	95	0	\N
162426	1397	1315177652000	21205	10462	96	0	\N
162427	1397	1315167651000	21205	10462	97	0	\N
162428	1397	1315157650000	21205	10462	98	0	\N
162429	1397	1315147649000	21205	10462	99	0	\N
162430	1397	1315137648000	21205	10462	100	0	\N
162431	1397	1315127647000	21205	10462	101	0	\N
162432	1397	1315117646000	21205	10462	102	0	\N
162433	1397	1315107645000	21205	10462	103	0	\N
162434	1397	1315097644000	21205	10462	104	0	\N
162435	1397	1315087643000	21205	10462	105	0	\N
162436	1397	1315077642000	21205	10462	107	0	\N
162437	1397	1315067641000	21205	10462	108	0	\N
162438	1397	1315057640000	21205	10462	109	0	\N
162439	1397	1315047639000	21205	10462	110	0	\N
162440	1397	1315037638000	21205	10462	111	0	\N
162441	1397	1315027637000	21205	10462	112	0	\N
162442	1397	1315017636000	21205	10462	113	0	\N
162443	1397	1315007635000	21205	10462	114	0	\N
162444	1397	1314997634000	21205	10462	115	0	\N
162445	1397	1314987633000	21205	10462	116	0	\N
162446	1397	1314977632000	21205	10462	117	0	\N
162447	1397	1314967631000	21205	10462	118	0	\N
162448	1397	1314957630000	21205	10462	119	0	\N
162449	1397	1314947629000	21205	10462	120	0	\N
162450	1397	1314937628000	21205	10462	121	0	\N
162451	1397	1314927627000	21205	10462	122	0	\N
162452	1397	1314917626000	21205	10462	123	0	\N
162453	1397	1314907625000	21205	10462	124	0	\N
162454	1397	1314897624000	21205	10462	125	0	\N
162455	1740	4050615000000	21206	10629	0	0	\N
162456	2247	648999000000	21206	10629	1	0	\N
162461	1397	1313577492000	21209	10649	0	0	\N
162462	2133	96057126000	21209	10649	1	0	\N
162467	1397	1313557490000	21212	10651	0	0	\N
162468	2133	96055122000	21212	10651	1	0	\N
162469	1397	1313557490000	21213	10651	0	0	\N
162470	2133	96055122000	21213	10651	1	0	\N
162473	1397	1313547489000	21215	10652	0	0	\N
162474	2133	96054120000	21215	10652	1	0	\N
162481	1397	1313527487000	21219	10654	0	0	\N
162482	1397	1313517486000	21219	10654	1	0	\N
162493	1397	1313467481000	21224	10657	0	0	\N
162494	2133	96046104000	21224	10657	1	0	\N
162501	1397	1313427477000	21227	10660	0	0	\N
162502	1397	1313417476000	21227	10660	1	0	\N
162503	2133	96042096000	21227	10660	2	0	\N
162504	2133	96041094000	21227	10660	3	0	\N
162509	1397	1313427477000	21229	10660	0	0	\N
162510	1397	1313417476000	21229	10660	1	0	\N
162511	2133	96042096000	21229	10660	2	0	\N
162512	2133	96041094000	21229	10660	3	0	\N
162520	1397	1313377472000	21233	10663	0	0	\N
162459	1397	1313577492000	21208	10649	0	0	12525
162460	2133	96057126000	21208	10649	1	0	2937
162463	1397	1313567491000	21210	10650	0	0	12526
162464	2133	96056124000	21210	10650	1	0	2938
162465	1397	1313557490000	21211	10651	0	0	12527
162471	1397	1313547489000	21214	10652	0	0	12528
162472	2133	96054120000	21214	10652	1	0	2940
162475	1397	1313537488000	21216	10653	0	0	12529
162476	2133	96053118000	21216	10653	1	0	2941
162477	1397	1313527487000	21218	10654	0	0	12530
162479	2133	96052116000	21218	10654	2	0	2942
162480	2133	96051114000	21218	10654	3	0	2943
162483	1397	1313507485000	21221	10655	0	0	12532
162484	1397	1313497484000	21221	10655	1	0	12533
162486	2133	96050112000	21221	10655	3	0	2944
162487	2133	96049110000	21221	10655	4	0	2945
162488	2133	96048108000	21221	10655	5	0	2946
162489	1397	1313477482000	21222	10656	0	0	12535
162490	2133	96047106000	21222	10656	1	0	2947
162492	2133	96046104000	21223	10657	1	0	2948
162495	1397	1313457480000	21225	10658	0	0	12537
162496	2133	96045102000	21225	10658	1	0	2949
162497	1397	1313447479000	21226	10659	0	0	12538
162498	1397	1313437478000	21226	10659	1	0	12539
162500	2133	96043098000	21226	10659	3	0	2951
162505	1397	1313427477000	21228	10660	0	0	12540
162506	1397	1313417476000	21228	10660	1	0	12541
162507	2133	96042096000	21228	10660	2	0	2952
162513	1397	1313407475000	21230	10661	0	0	12542
162514	1397	1313397474000	21231	10662	0	0	12543
162515	1397	1313387473000	21231	10662	1	0	12544
162516	2133	96040092000	21231	10662	2	0	2954
162517	2133	96039090000	21231	10662	3	0	2955
162519	2133	96038088000	21232	10663	1	0	2956
162521	2133	96038088000	21233	10663	1	0	\N
162522	1397	1313367471000	21234	10664	0	0	\N
162523	2133	96037086000	21234	10664	1	0	\N
162528	1471	14856185900000	21237	10576	0	0	\N
162529	1471	9790175900000	21237	10576	1	0	\N
162530	1471	6372165900000	21237	10576	2	0	\N
162531	1471	3545155900000	21237	10576	3	0	\N
162532	1740	4050615000000	21237	10576	4	0	\N
162533	2247	648999000000	21237	10576	5	0	\N
162534	1611	14581365550000	21237	10576	6	0	\N
162535	1611	10922654840000	21237	10576	7	0	\N
162536	1611	8454049500000	21237	10576	8	0	\N
162537	1611	1575063000000	21237	10576	9	0	\N
162538	1471	14856185900000	21238	10666	0	0	\N
162539	1471	9790175900000	21238	10666	1	0	\N
162540	1471	6372165900000	21238	10666	2	0	\N
162541	1397	1313347469000	21238	10666	3	0	\N
162542	1471	3545155900000	21238	10666	4	0	\N
162543	2133	96035082000	21238	10666	5	0	\N
162544	1611	16021387550000	21238	10666	6	0	\N
162545	1611	12362676840000	21238	10666	7	0	\N
162546	1611	9894071500000	21238	10666	8	0	\N
162547	1611	3015085000000	21238	10666	9	0	\N
162560	1397	1313337468000	21241	10667	0	0	\N
162561	2133	96034080000	21241	10667	2	0	\N
162562	1397	1313337468000	21242	10667	0	0	\N
162563	2133	96034080000	21242	10667	2	0	\N
162564	1682	10341000000	21243	10571	0	0	\N
162565	1682	9331000000	21243	10571	1	0	\N
162566	1471	14856185900000	21243	10571	2	0	\N
162567	1932	1372908664093	21243	10571	3	0	\N
162568	1471	9790175900000	21243	10571	4	0	\N
162569	1471	6372165900000	21243	10571	5	0	\N
162570	1850	14038008949999	21243	10571	6	0	\N
162571	1850	9674898949999	21243	10571	7	0	\N
162572	1850	6730988949999	21243	10571	8	0	\N
162573	1850	4296178949999	21243	10571	9	0	\N
162574	1471	3545155900000	21243	10571	10	0	\N
162575	1932	1372906664093	21243	10571	11	0	\N
162576	1740	4050615000000	21243	10571	12	0	\N
162577	2247	648999000000	21243	10571	13	0	\N
162578	1611	14581365550000	21243	10571	14	0	\N
162579	1611	10922654840000	21243	10571	15	0	\N
162580	1611	8454049500000	21243	10571	16	0	\N
162581	1611	1575063000000	21243	10571	17	0	\N
162582	1397	1313327467000	21244	10668	0	0	\N
162583	2133	96033078000	21244	10668	1	0	\N
162584	1397	1313327467000	21245	10668	0	0	\N
162585	2133	96033078000	21245	10668	1	0	\N
162596	1649	17198479999992	21249	10671	0	0	\N
162597	1649	11642469999992	21249	10671	1	0	\N
162598	1649	7893459999992	21249	10671	2	0	\N
162599	1649	4792449999992	21249	10671	3	0	\N
162600	1397	1313297464000	21249	10671	4	0	\N
162601	1397	1313287463000	21249	10671	5	0	\N
162602	2133	96030072000	21249	10671	6	0	\N
162603	2133	96029070000	21249	10671	7	0	\N
162604	1649	17198479999992	21250	10671	0	0	\N
162605	1649	11642469999992	21250	10671	1	0	\N
162606	1649	7893459999992	21250	10671	2	0	\N
162607	1649	4792449999992	21250	10671	3	0	\N
162608	1397	1313297464000	21250	10671	4	0	\N
162609	1397	1313287463000	21250	10671	5	0	\N
162610	2133	96030072000	21250	10671	6	0	\N
162611	2133	96029070000	21250	10671	7	0	\N
162620	1649	17198479999992	21252	10671	0	0	\N
162621	1649	11642469999992	21252	10671	1	0	\N
162622	1649	7893459999992	21252	10671	2	0	\N
162623	1649	4792449999992	21252	10671	3	0	\N
162624	1397	1313297464000	21252	10671	4	0	\N
162625	1397	1313287463000	21252	10671	5	0	\N
162626	2133	96030072000	21252	10671	6	0	\N
162627	2133	96029070000	21252	10671	7	0	\N
162629	1397	1313277462000	21254	10672	0	0	\N
162630	1397	1313267461000	21255	10673	0	0	\N
162631	2133	96028068000	21255	10673	1	0	\N
162642	1397	1313217456000	21261	10678	0	0	\N
162643	1397	1313207455000	21261	10678	1	0	\N
162644	1397	1313197454000	21261	10678	2	0	\N
162645	1397	1313187453000	21261	10678	3	0	\N
162646	2133	96023058000	21261	10678	4	0	\N
162647	2133	96022056000	21261	10678	5	0	\N
162648	2133	96021054000	21261	10678	6	0	\N
162649	2133	96020052000	21261	10678	7	0	\N
162526	1397	1313357470000	21236	10665	0	0	12547
162527	2133	96036084000	21236	10665	1	0	2958
162548	1471	14856185900000	21239	10666	0	0	5
162549	1471	9790175900000	21239	10666	1	0	6
162550	1471	6372165900000	21239	10666	2	0	7
162552	1471	3545155900000	21239	10666	4	0	8
162553	2133	96035082000	21239	10666	5	0	2959
162554	1611	16021387550000	21239	10666	6	0	6
162555	1611	12362676840000	21239	10666	7	0	7
162556	1611	9894071500000	21239	10666	8	0	8
162558	1397	1313337468000	21240	10667	0	0	12549
162559	2133	96034080000	21240	10667	2	0	2960
162586	1397	1313327467000	21246	10668	0	0	12550
162587	2133	96033078000	21246	10668	1	0	2961
162589	2133	96032076000	21247	10669	1	0	2962
162590	1426	15961288000000	21248	10670	0	0	5
162591	1426	10895278000000	21248	10670	1	0	6
162592	1397	1313307465000	21248	10670	2	0	12552
162593	1426	7477268000000	21248	10670	3	0	7
162595	2133	96031074000	21248	10670	5	0	2963
162612	1649	17198479999992	21251	10671	0	0	5
162613	1649	11642469999992	21251	10671	1	0	6
162614	1649	7893459999992	21251	10671	2	0	7
162615	1649	4792449999992	21251	10671	3	0	8
162617	1397	1313287463000	21251	10671	5	0	12554
162618	2133	96030072000	21251	10671	6	0	2964
162619	2133	96029070000	21251	10671	7	0	2965
162628	1397	1313277462000	21253	10672	0	0	12555
162633	2133	96028068000	21256	10673	1	0	2966
162634	1397	1313257460000	21257	10674	0	0	12557
162635	2133	96027066000	21257	10674	1	0	2967
162636	1397	1313247459000	21258	10675	0	0	12558
162637	2133	96026064000	21258	10675	1	0	2968
162639	2133	96025062000	21259	10676	1	0	2969
162640	1397	1313227457000	21260	10677	0	0	12560
162641	2133	96024060000	21260	10677	1	0	2970
162650	1397	1313217456000	21262	10678	0	0	12561
162651	1397	1313207455000	21262	10678	1	0	12562
162653	1397	1313187453000	21262	10678	3	0	12564
162654	2133	96023058000	21262	10678	4	0	2971
162655	2133	96022056000	21262	10678	5	0	2972
162656	2133	96021054000	21262	10678	6	0	2973
162658	1397	1313217456000	21263	10678	0	0	\N
162659	1397	1313207455000	21263	10678	1	0	\N
162660	1397	1313197454000	21263	10678	2	0	\N
162661	1397	1313187453000	21263	10678	3	0	\N
162662	2133	96023058000	21263	10678	4	0	\N
162663	2133	96022056000	21263	10678	5	0	\N
162664	2133	96021054000	21263	10678	6	0	\N
162665	2133	96020052000	21263	10678	7	0	\N
162666	1397	1313177452000	21264	10679	0	0	\N
162667	1397	1313167451000	21264	10679	1	0	\N
162668	2133	96019050000	21264	10679	2	0	\N
162669	2133	96018048000	21264	10679	3	0	\N
162670	1397	1313177452000	21265	10679	0	0	\N
162671	1397	1313167451000	21265	10679	1	0	\N
162672	2133	96019050000	21265	10679	2	0	\N
162673	2133	96018048000	21265	10679	3	0	\N
162674	1397	1313177452000	21266	10679	0	0	\N
162675	1397	1313167451000	21266	10679	1	0	\N
162676	2133	96019050000	21266	10679	2	0	\N
162677	2133	96018048000	21266	10679	3	0	\N
162678	1397	1313177452000	21267	10679	0	0	\N
162679	1397	1313167451000	21267	10679	1	0	\N
162680	2133	96019050000	21267	10679	2	0	\N
162681	2133	96018048000	21267	10679	3	0	\N
162688	2133	96017046000	21270	10680	0	0	\N
162698	1608	3018303000000	21272	10682	0	0	\N
162699	1397	1313117446000	21272	10682	1	0	\N
162700	1726	9706112000	21272	10682	2	0	\N
162701	2133	96014040000	21272	10682	3	0	\N
162702	1726	8505112000	21272	10682	4	0	\N
162703	1726	7304112000	21272	10682	5	0	\N
162704	1726	6103112000	21272	10682	6	0	\N
162705	1726	4902112000	21272	10682	7	0	\N
162706	1726	3701112000	21272	10682	8	0	\N
162707	1726	2500112000	21272	10682	9	0	\N
162741	1426	15961288000000	21277	10577	0	0	\N
162742	1608	2298292000000	21277	10577	1	0	\N
162743	1649	15758407999992	21277	10577	2	0	\N
162744	1426	10895278000000	21277	10577	3	0	\N
162745	1649	10202397999992	21277	10577	4	0	\N
162746	1649	6453387999992	21277	10577	5	0	\N
162747	1649	3352377999992	21277	10577	6	0	\N
162748	1426	7477268000000	21277	10577	7	0	\N
162749	1426	4650258000000	21277	10577	8	0	\N
162750	2134	95935835000	21277	10577	9	0	\N
162751	2134	94734835000	21277	10577	10	0	\N
162752	2134	93533835000	21277	10577	11	0	\N
162753	2134	92332835000	21277	10577	12	0	\N
162754	2134	91131835000	21277	10577	13	0	\N
162755	2134	89930835000	21277	10577	14	0	\N
162756	1726	13309112000	21277	10577	15	0	\N
162757	1726	12108112000	21277	10577	16	0	\N
162758	1726	10907112000	21277	10577	17	0	\N
162759	1726	9706112000	21277	10577	18	0	\N
162760	1726	8505112000	21277	10577	19	0	\N
162761	1726	7304112000	21277	10577	20	0	\N
162762	1726	6103112000	21277	10577	21	0	\N
162763	1726	4902112000	21277	10577	22	0	\N
162764	1726	3701112000	21277	10577	23	0	\N
162765	1726	2500112000	21277	10577	24	0	\N
162766	1726	1299112000	21277	10577	25	0	\N
162767	1726	98112000	21277	10577	26	0	\N
162768	2134	89919835000	21277	10577	27	0	\N
162769	2134	88718835000	21277	10577	28	0	\N
162770	2134	88717832000	21277	10577	29	0	\N
162771	2134	87516832000	21277	10577	30	0	\N
162772	2134	87515829000	21277	10577	31	0	\N
162773	1397	1313077442000	21278	10684	0	0	\N
162774	2133	96010032000	21278	10684	1	0	\N
162775	2134	87515829000	21278	10684	2	0	\N
162776	2132	148061062000	21278	10684	3	0	\N
162777	1608	3018303000000	21280	10678	0	0	\N
162778	1397	1313217456000	21280	10678	1	0	\N
162779	1397	1313207455000	21280	10678	2	0	\N
162780	1397	1313197454000	21280	10678	3	0	\N
162781	1397	1313187453000	21280	10678	4	0	\N
162782	1397	1313177452000	21280	10678	5	0	\N
162783	1397	1313167451000	21280	10678	6	0	\N
162784	1397	1313157450000	21280	10678	7	0	\N
162785	1397	1313147449000	21280	10678	8	0	\N
162786	1397	1313137448000	21280	10678	9	0	\N
162787	1397	1313127447000	21280	10678	10	0	\N
162788	1397	1313117446000	21280	10678	11	0	\N
162789	1397	1313107445000	21280	10678	12	0	\N
162790	1397	1313097444000	21280	10678	13	0	\N
162791	1397	1313087443000	21280	10678	14	0	\N
162792	1397	1313077442000	21280	10678	15	0	\N
162683	1397	1313167451000	21268	10679	1	0	12566
162684	2133	96019050000	21268	10679	2	0	2975
162685	2133	96018048000	21268	10679	3	0	2976
162686	1397	1313157450000	21269	10680	0	0	12567
162687	2133	96017046000	21269	10680	1	0	2977
162690	1397	1313137448000	21271	10681	1	0	12569
162691	1397	1313127447000	21271	10681	2	0	12570
162692	2132	148063064000	21271	10681	3	0	936
162693	2133	96016044000	21271	10681	4	0	2978
162694	2133	96015042000	21271	10681	5	0	2979
162696	1726	12108112000	21271	10681	7	0	8277
162697	1726	10907112000	21271	10681	8	0	8278
162708	1608	3018303000000	21273	10682	0	0	8
162709	1397	1313117446000	21273	10682	1	0	12571
162711	1397	1313097444000	21274	10683	1	0	12573
162712	1397	1313087443000	21274	10683	2	0	12574
162713	2134	95935835000	21274	10683	3	0	3055
162714	2134	94734835000	21274	10683	4	0	3056
162715	1726	9706112000	21274	10683	5	0	8279
162717	2134	92332835000	21274	10683	7	0	3058
162718	2134	91131835000	21274	10683	8	0	3059
162719	2134	89930835000	21274	10683	9	0	3060
162720	2133	96014040000	21274	10683	10	0	2980
162721	2133	96013038000	21274	10683	11	0	2981
162723	1726	8505112000	21274	10683	13	0	8280
162724	1726	7304112000	21274	10683	14	0	8281
162725	1726	6103112000	21274	10683	15	0	8282
162726	1726	4902112000	21274	10683	16	0	8283
162728	1726	2500112000	21274	10683	18	0	8285
162729	1726	1299112000	21274	10683	19	0	8286
162730	1726	98112000	21274	10683	20	0	8287
162731	2134	89919835000	21274	10683	21	0	3061
162732	2134	88718835000	21274	10683	22	0	3062
162734	2134	87516832000	21274	10683	24	0	3064
162735	2133	96012036000	21274	10683	25	0	2982
162736	2133	96011034000	21274	10683	26	0	2983
162737	1397	1313077442000	21275	10684	0	0	12575
162738	2133	96010032000	21275	10684	1	0	2984
162740	2132	148061062000	21275	10684	3	0	938
162793	2132	148063064000	21280	10678	16	0	\N
162794	2134	95935835000	21280	10678	17	0	\N
162795	2134	94734835000	21280	10678	18	0	\N
162796	2133	96023058000	21280	10678	19	0	\N
162797	2134	93533835000	21280	10678	20	0	\N
162798	2134	92332835000	21280	10678	21	0	\N
162799	2134	91131835000	21280	10678	22	0	\N
162800	2134	89930835000	21280	10678	23	0	\N
162801	2133	96022056000	21280	10678	24	0	\N
162802	2132	148062063000	21280	10678	25	0	\N
162803	2132	148061062000	21280	10678	26	0	\N
162804	1726	13309112000	21280	10678	27	0	\N
162805	1726	12108112000	21280	10678	28	0	\N
162806	1726	10907112000	21280	10678	29	0	\N
162807	1726	9706112000	21280	10678	30	0	\N
162808	2133	96021054000	21280	10678	31	0	\N
162809	2133	96020052000	21280	10678	32	0	\N
162810	2133	96019050000	21280	10678	33	0	\N
162811	2133	96018048000	21280	10678	34	0	\N
162812	2133	96017046000	21280	10678	35	0	\N
162813	2133	96016044000	21280	10678	36	0	\N
162814	2133	96015042000	21280	10678	37	0	\N
162815	2133	96014040000	21280	10678	38	0	\N
162816	2133	96013038000	21280	10678	39	0	\N
162817	1726	8505112000	21280	10678	40	0	\N
162818	1726	7304112000	21280	10678	41	0	\N
162819	1726	6103112000	21280	10678	42	0	\N
162820	1726	4902112000	21280	10678	43	0	\N
162821	1726	3701112000	21280	10678	44	0	\N
162822	1726	2500112000	21280	10678	45	0	\N
162823	1726	1299112000	21280	10678	46	0	\N
162824	1726	98112000	21280	10678	47	0	\N
162825	2134	89919835000	21280	10678	48	0	\N
162826	2134	88718835000	21280	10678	49	0	\N
162827	2134	88717832000	21280	10678	50	0	\N
162828	2134	87516832000	21280	10678	51	0	\N
162829	2134	87515829000	21280	10678	52	0	\N
162830	2133	96012036000	21280	10678	53	0	\N
162831	2133	96011034000	21280	10678	54	0	\N
162832	2133	96010032000	21280	10678	55	0	\N
162839	1397	1313067441000	21283	10685	0	0	\N
162840	1397	1313057440000	21283	10685	1	0	\N
162841	2133	96009030000	21283	10685	2	0	\N
162842	2133	96008028000	21283	10685	3	0	\N
162843	2134	87514826000	21283	10685	4	0	\N
162844	2134	87513823000	21283	10685	6	0	\N
162862	1397	1313007435000	21289	10690	0	0	\N
162863	2132	148059060000	21289	10690	1	0	\N
162864	2133	96003018000	21289	10690	2	0	\N
162865	2134	87508808000	21289	10690	3	0	\N
162872	1397	1312997434000	21291	10691	0	0	\N
162873	1397	1312987433000	21291	10691	1	0	\N
162874	2133	96002016000	21291	10691	2	0	\N
162875	2134	87507805000	21291	10691	3	0	\N
162876	2134	87506802000	21291	10691	4	0	\N
162877	2133	96001014000	21291	10691	5	0	\N
162878	1397	1312977432000	21292	10692	0	0	\N
162879	2132	148058059000	21292	10692	1	0	\N
162880	2134	87505799000	21292	10692	2	0	\N
162881	2133	96000012000	21292	10692	3	0	\N
162886	1397	1312967431000	21294	10693	0	0	\N
162887	1397	1312957430000	21294	10693	1	0	\N
162888	2134	87504796000	21294	10693	2	0	\N
162889	2134	87503793000	21294	10693	3	0	\N
162890	2133	95999010000	21294	10693	4	0	\N
162891	2133	95998008000	21294	10693	5	0	\N
162892	1397	1312967431000	21295	10693	0	0	\N
162893	1397	1312957430000	21295	10693	1	0	\N
162894	2134	87504796000	21295	10693	2	0	\N
162895	2134	87503793000	21295	10693	3	0	\N
162896	2133	95999010000	21295	10693	4	0	\N
162897	2133	95998008000	21295	10693	5	0	\N
162904	1397	1312947429000	21297	10694	0	0	\N
162905	2133	95997006000	21297	10694	1	0	\N
162906	2134	87502790000	21297	10694	2	0	\N
162907	1397	1312947429000	21298	10694	0	0	\N
162908	2133	95997006000	21298	10694	1	0	\N
162909	2134	87502790000	21298	10694	2	0	\N
162917	1397	1312937428000	21301	10695	0	0	\N
162918	2132	148057058000	21301	10695	1	0	\N
162919	2134	87501787000	21301	10695	2	0	\N
162920	2133	95996004000	21301	10695	3	0	\N
162921	1682	10341000000	21302	10573	0	0	\N
162922	1426	15961288000000	21302	10573	1	0	\N
162923	1608	2298292000000	21302	10573	2	0	\N
162924	1397	1314657600000	21302	10573	3	0	\N
162925	1682	9331000000	21302	10573	4	0	\N
162926	1471	14856185900000	21302	10573	5	0	\N
162927	1932	1372908664093	21302	10573	6	0	\N
162928	1649	15758407999992	21302	10573	7	0	\N
162835	2133	96009030000	21282	10685	2	0	2985
162836	2133	96008028000	21282	10685	3	0	2986
162837	2134	87514826000	21282	10685	4	0	3066
162838	2134	87513823000	21282	10685	6	0	3067
162845	1397	1313047439000	21284	10686	0	0	12578
162847	2133	96007026000	21284	10686	2	0	2987
162848	1397	1313037438000	21285	10687	0	0	12579
162849	2132	148060061000	21285	10687	1	0	939
162850	2133	96006024000	21285	10687	2	0	2988
162851	2134	87511817000	21285	10687	3	0	3069
162853	2134	87510814000	21286	10688	1	0	3070
162854	2133	96005022000	21286	10688	2	0	2989
162855	1397	1313017436000	21287	10689	0	0	12581
162856	2134	87509811000	21287	10689	1	0	3071
162858	1397	1313007435000	21288	10690	0	0	12582
162859	2132	148059060000	21288	10690	1	0	940
162860	2133	96003018000	21288	10690	2	0	2991
162861	2134	87508808000	21288	10690	3	0	3072
162866	1397	1312997434000	21290	10691	0	0	12583
162868	2133	96002016000	21290	10691	2	0	2992
162869	2134	87507805000	21290	10691	3	0	3073
162870	2134	87506802000	21290	10691	4	0	3074
162871	2133	96001014000	21290	10691	5	0	2993
162882	1397	1312977432000	21293	10692	0	0	12585
162884	2134	87505799000	21293	10692	2	0	3075
162885	2133	96000012000	21293	10692	3	0	2994
162898	1397	1312967431000	21296	10693	0	0	12586
162899	1397	1312957430000	21296	10693	1	0	12587
162901	2134	87503793000	21296	10693	3	0	3077
162902	2133	95999010000	21296	10693	4	0	2995
162903	2133	95998008000	21296	10693	5	0	2996
162910	1397	1312947429000	21299	10694	0	0	12588
162911	2133	95997006000	21299	10694	1	0	2997
162913	1397	1312937428000	21300	10695	0	0	12589
162914	2132	148057058000	21300	10695	1	0	942
162915	2134	87501787000	21300	10695	2	0	3079
162916	2133	95996004000	21300	10695	3	0	2998
162929	1426	10895278000000	21302	10573	8	0	\N
162930	1471	9790175900000	21302	10573	9	0	\N
162931	1649	10202397999992	21302	10573	10	0	\N
162932	1649	6453387999992	21302	10573	11	0	\N
162933	1649	3352377999992	21302	10573	12	0	\N
162934	1471	6372165900000	21302	10573	13	0	\N
162935	1850	14038008949999	21302	10573	14	0	\N
162936	1850	9674898949999	21302	10573	15	0	\N
162937	1850	6730988949999	21302	10573	16	0	\N
162938	1850	4296178949999	21302	10573	17	0	\N
162939	1426	7477268000000	21302	10573	18	0	\N
162940	1426	4650258000000	21302	10573	19	0	\N
162941	1397	1314647599000	21302	10573	20	0	\N
162942	1397	1314637598000	21302	10573	21	0	\N
162943	1397	1314627597000	21302	10573	22	0	\N
162944	1397	1314617596000	21302	10573	23	0	\N
162945	1397	1314607595000	21302	10573	24	0	\N
162946	1397	1314597594000	21302	10573	25	0	\N
162947	1397	1314587593000	21302	10573	26	0	\N
162948	1397	1314577592000	21302	10573	27	0	\N
162949	1397	1314567591000	21302	10573	28	0	\N
162950	1397	1314557590000	21302	10573	29	0	\N
162951	1397	1314547589000	21302	10573	30	0	\N
162952	1397	1314537588000	21302	10573	31	0	\N
162953	1397	1314527587000	21302	10573	32	0	\N
162954	1397	1314517586000	21302	10573	33	0	\N
162955	1397	1314507585000	21302	10573	34	0	\N
162956	1397	1314497584000	21302	10573	35	0	\N
162957	1397	1314487583000	21302	10573	36	0	\N
162958	1397	1314477582000	21302	10573	37	0	\N
162959	1397	1314467581000	21302	10573	38	0	\N
162960	1397	1314457580000	21302	10573	39	0	\N
162961	1397	1314447579000	21302	10573	40	0	\N
162962	1397	1314437578000	21302	10573	41	0	\N
162963	1397	1314427577000	21302	10573	42	0	\N
162964	1397	1314417576000	21302	10573	43	0	\N
162965	1397	1314407575000	21302	10573	44	0	\N
162966	1397	1314397574000	21302	10573	45	0	\N
162967	1397	1314387573000	21302	10573	46	0	\N
162968	1397	1314377572000	21302	10573	47	0	\N
162969	1397	1314367571000	21302	10573	48	0	\N
162970	1397	1314357570000	21302	10573	49	0	\N
162971	1397	1314347569000	21302	10573	50	0	\N
162972	1397	1314337568000	21302	10573	51	0	\N
162973	1397	1314327567000	21302	10573	52	0	\N
162974	1397	1314317566000	21302	10573	53	0	\N
162975	1397	1314307565000	21302	10573	54	0	\N
162976	1397	1314297564000	21302	10573	55	0	\N
162977	1397	1314287563000	21302	10573	56	0	\N
162978	1397	1314277562000	21302	10573	57	0	\N
162979	1397	1314267561000	21302	10573	58	0	\N
162980	1397	1314257560000	21302	10573	59	0	\N
162981	1397	1314247559000	21302	10573	60	0	\N
162982	1397	1314237558000	21302	10573	61	0	\N
162983	1397	1314227557000	21302	10573	62	0	\N
162984	1397	1314217556000	21302	10573	63	0	\N
162985	1397	1314207555000	21302	10573	64	0	\N
162986	1397	1314197554000	21302	10573	65	0	\N
162987	1397	1314187553000	21302	10573	66	0	\N
162988	1397	1314177552000	21302	10573	67	0	\N
162989	1397	1314167551000	21302	10573	68	0	\N
162990	1397	1314157550000	21302	10573	69	0	\N
162991	1397	1314147549000	21302	10573	70	0	\N
162992	1397	1314137548000	21302	10573	71	0	\N
162993	1397	1314127547000	21302	10573	72	0	\N
162994	1397	1314117546000	21302	10573	73	0	\N
162995	1397	1314107545000	21302	10573	74	0	\N
162996	1397	1314097544000	21302	10573	75	0	\N
162997	1397	1314087543000	21302	10573	76	0	\N
162998	1397	1314077542000	21302	10573	77	0	\N
162999	1397	1314067541000	21302	10573	78	0	\N
163000	1397	1314057540000	21302	10573	79	0	\N
163001	1397	1314047539000	21302	10573	80	0	\N
163002	1397	1314037538000	21302	10573	81	0	\N
163003	1397	1314027537000	21302	10573	82	0	\N
163004	1397	1314017536000	21302	10573	83	0	\N
163005	1397	1314007535000	21302	10573	84	0	\N
163006	1397	1313997534000	21302	10573	85	0	\N
163007	1397	1313987533000	21302	10573	86	0	\N
163008	1397	1313977532000	21302	10573	87	0	\N
163009	1397	1313967531000	21302	10573	88	0	\N
163010	1397	1313957530000	21302	10573	89	0	\N
163011	1397	1313947529000	21302	10573	90	0	\N
163012	1397	1313937528000	21302	10573	91	0	\N
163013	1397	1313927527000	21302	10573	92	0	\N
163014	1397	1313917526000	21302	10573	93	0	\N
163015	1397	1313907525000	21302	10573	94	0	\N
163016	1397	1313897524000	21302	10573	95	0	\N
163017	1397	1313887523000	21302	10573	96	0	\N
163018	1397	1313877522000	21302	10573	97	0	\N
163019	1397	1313867521000	21302	10573	98	0	\N
163020	1397	1313857520000	21302	10573	99	0	\N
163021	1397	1313847519000	21302	10573	100	0	\N
163022	1397	1313837518000	21302	10573	101	0	\N
163023	1397	1313827517000	21302	10573	102	0	\N
163024	1397	1313817516000	21302	10573	103	0	\N
163025	1397	1313807515000	21302	10573	104	0	\N
163026	1397	1313797514000	21302	10573	105	0	\N
163027	1397	1313787513000	21302	10573	107	0	\N
163028	1397	1313777512000	21302	10573	108	0	\N
163029	1397	1313767511000	21302	10573	109	0	\N
163030	1397	1313757510000	21302	10573	110	0	\N
163031	1397	1313747509000	21302	10573	111	0	\N
163032	1397	1313737508000	21302	10573	112	0	\N
163033	1397	1313727507000	21302	10573	113	0	\N
163034	1397	1313717506000	21302	10573	114	0	\N
163035	1397	1313707505000	21302	10573	115	0	\N
163036	1397	1313697504000	21302	10573	116	0	\N
163037	1397	1313687503000	21302	10573	117	0	\N
163038	1397	1313677502000	21302	10573	118	0	\N
163039	1397	1313667501000	21302	10573	119	0	\N
163040	1397	1313657500000	21302	10573	120	0	\N
163041	1397	1313647499000	21302	10573	121	0	\N
163042	1397	1313637498000	21302	10573	122	0	\N
163043	1397	1313627497000	21302	10573	123	0	\N
163044	1397	1313617496000	21302	10573	124	0	\N
163045	1397	1313607495000	21302	10573	125	0	\N
163046	1397	1312927427000	21303	10696	0	0	\N
163047	2133	95995002000	21303	10696	1	0	\N
163048	2134	87500784000	21303	10696	2	0	\N
163049	1397	1312927427000	21304	10696	0	0	\N
163050	2133	95995002000	21304	10696	1	0	\N
163051	2134	87500784000	21304	10696	2	0	\N
163055	1397	1312917426000	21306	10697	0	0	\N
163056	2134	87499781000	21306	10697	1	0	\N
163057	2133	95994000000	21306	10697	2	0	\N
163061	2134	87499781000	21308	10697	0	0	\N
163062	1397	1312917426000	21309	10697	0	0	\N
163063	2134	87499781000	21309	10697	1	0	\N
163064	2133	95994000000	21309	10697	2	0	\N
163054	2134	87500784000	21305	10696	2	0	3080
163058	1397	1312917426000	21307	10697	0	0	12591
163059	2134	87499781000	21307	10697	1	0	3081
163060	2133	95994000000	21307	10697	2	0	3000
163065	1682	10341000000	21310	10516	0	0	\N
163066	365	66017201000000	21310	10516	1	0	\N
163067	1564	10961600000000	21310	10516	2	0	\N
163068	1564	7693580000000	21310	10516	3	0	\N
163069	2100	1434860000000	21310	10516	4	0	\N
163070	2100	2830000000	21310	10516	5	0	\N
163071	1564	5488560000000	21310	10516	6	0	\N
163072	1564	4026540000000	21310	10516	7	0	\N
163073	1564	3558520000000	21310	10516	8	0	\N
163074	1426	15961288000000	21310	10516	9	0	\N
163075	1682	9331000000	21310	10516	10	0	\N
163076	1471	14856185900000	21310	10516	11	0	\N
163077	1932	1372908664093	21310	10516	12	0	\N
163078	1649	15758407999992	21310	10516	13	0	\N
163079	1426	10895278000000	21310	10516	14	0	\N
163080	1471	9790175900000	21310	10516	15	0	\N
163081	1649	10202397999992	21310	10516	16	0	\N
163082	1649	6453387999992	21310	10516	17	0	\N
163083	1649	3352377999992	21310	10516	18	0	\N
163084	1608	12149912000000	21310	10516	19	0	\N
163085	1608	7737612000000	21310	10516	20	0	\N
163086	1471	6372165900000	21310	10516	21	0	\N
163087	1397	1315427677000	21310	10516	22	0	\N
163088	1850	14038008949999	21310	10516	23	0	\N
163089	1850	9674898949999	21310	10516	24	0	\N
163090	1850	6730988949999	21310	10516	25	0	\N
163091	1850	4296178949999	21310	10516	26	0	\N
163092	2269	648990000000	21310	10516	27	0	\N
163093	1608	4760542000000	21310	10516	28	0	\N
163094	1608	2298302000000	21310	10516	29	0	\N
163095	1756	3440720195609	21310	10516	30	0	\N
163096	2039	20879545000000	21310	10516	31	0	\N
163097	2039	18325785000000	21310	10516	32	0	\N
163098	2039	15238175000000	21310	10516	33	0	\N
163099	2039	10662265000000	21310	10516	34	0	\N
163100	2039	2059255000000	21310	10516	35	0	\N
163101	1426	7477268000000	21310	10516	36	0	\N
163102	1426	4650258000000	21310	10516	37	0	\N
163103	1397	1315417676000	21310	10516	38	0	\N
163104	1397	1315407675000	21310	10516	39	0	\N
163105	1714	11638176439708	21310	10516	40	0	\N
163106	1714	9295374638556	21310	10516	41	0	\N
163107	1714	5823121253616	21310	10516	42	0	\N
163108	1714	3885466171760	21310	10516	43	0	\N
163109	1397	1315397674000	21310	10516	44	0	\N
163110	1397	1315387673000	21310	10516	45	0	\N
163111	1397	1315377672000	21310	10516	47	0	\N
163112	1397	1315367671000	21310	10516	48	0	\N
163113	1397	1315357670000	21310	10516	49	0	\N
163114	1397	1315347669000	21310	10516	50	0	\N
163115	1397	1315337668000	21310	10516	51	0	\N
163116	1397	1315327667000	21310	10516	52	0	\N
163117	1397	1315317666000	21310	10516	53	0	\N
163118	1397	1315307665000	21310	10516	54	0	\N
163119	1397	1315297664000	21310	10516	55	0	\N
163120	1397	1315287663000	21310	10516	56	0	\N
163121	1397	1315277662000	21310	10516	57	0	\N
163122	1397	1315267661000	21310	10516	58	0	\N
163123	1397	1315257660000	21310	10516	59	0	\N
163124	1397	1315247659000	21310	10516	60	0	\N
163125	1397	1315237658000	21310	10516	61	0	\N
163126	1397	1315227657000	21310	10516	62	0	\N
163127	1397	1315217656000	21310	10516	63	0	\N
163128	1397	1315207655000	21310	10516	64	0	\N
163129	1397	1315197654000	21310	10516	65	0	\N
163130	1397	1315187653000	21310	10516	66	0	\N
163131	1397	1315177652000	21310	10516	67	0	\N
163132	1397	1315167651000	21310	10516	68	0	\N
163133	1397	1315157650000	21310	10516	69	0	\N
163134	1397	1315147649000	21310	10516	70	0	\N
163135	1397	1315137648000	21310	10516	71	0	\N
163136	1397	1315127647000	21310	10516	72	0	\N
163137	1397	1315117646000	21310	10516	73	0	\N
163138	1397	1315107645000	21310	10516	74	0	\N
163139	1672	15791254000000	21310	10516	75	0	\N
163140	1672	9637244000000	21310	10516	76	0	\N
163141	1672	5484234000000	21310	10516	77	0	\N
163142	1672	2049224000000	21310	10516	78	0	\N
163143	1672	721214000000	21310	10516	79	0	\N
163144	1397	1315097644000	21310	10516	80	0	\N
163145	1397	1315087643000	21310	10516	81	0	\N
163146	1397	1315077642000	21310	10516	82	0	\N
163147	1397	1315067641000	21310	10516	83	0	\N
163148	1397	1315057640000	21310	10516	84	0	\N
163149	1397	1315047639000	21310	10516	85	0	\N
163150	1471	3545155900000	21310	10516	86	0	\N
163151	1397	1315037638000	21310	10516	87	0	\N
163152	1397	1315027637000	21310	10516	88	0	\N
163153	1397	1315017636000	21310	10516	89	0	\N
163154	1397	1315007635000	21310	10516	90	0	\N
163155	1397	1314997634000	21310	10516	91	0	\N
163156	1397	1314987633000	21310	10516	92	0	\N
163157	1397	1314977632000	21310	10516	93	0	\N
163158	1397	1314967631000	21310	10516	94	0	\N
163159	1397	1314957630000	21310	10516	95	0	\N
163160	1397	1314947629000	21310	10516	96	0	\N
163161	1397	1314937628000	21310	10516	97	0	\N
163162	1397	1314927627000	21310	10516	98	0	\N
163163	1397	1314917626000	21310	10516	99	0	\N
163164	1397	1314907625000	21310	10516	100	0	\N
163165	1397	1314897624000	21310	10516	101	0	\N
163166	1397	1314887623000	21310	10516	102	0	\N
163167	1397	1314877622000	21310	10516	103	0	\N
163168	1397	1314867621000	21310	10516	104	0	\N
163169	1397	1314857620000	21310	10516	105	0	\N
163170	1397	1314847619000	21310	10516	106	0	\N
163171	1397	1314837618000	21310	10516	107	0	\N
163172	1397	1314827617000	21310	10516	108	0	\N
163173	1397	1314817616000	21310	10516	109	0	\N
163174	1397	1314807615000	21310	10516	110	0	\N
163175	1397	1314797614000	21310	10516	111	0	\N
163176	1397	1314787613000	21310	10516	112	0	\N
163177	1397	1314777612000	21310	10516	113	0	\N
163178	1397	1314767611000	21310	10516	114	0	\N
163179	1397	1314757610000	21310	10516	115	0	\N
163180	1397	1314747609000	21310	10516	116	0	\N
163181	1397	1314737608000	21310	10516	117	0	\N
163182	1397	1314727607000	21310	10516	118	0	\N
163183	1397	1314717606000	21310	10516	119	0	\N
163184	1397	1314707605000	21310	10516	120	0	\N
163185	1397	1314697604000	21310	10516	121	0	\N
163186	1397	1314687603000	21310	10516	122	0	\N
163187	1397	1314677602000	21310	10516	123	0	\N
163188	1397	1314667601000	21310	10516	124	0	\N
163189	1397	1314657600000	21310	10516	125	0	\N
163190	1397	1312917426000	21311	10697	0	0	\N
163191	2134	87499781000	21311	10697	1	0	\N
163192	2133	95994000000	21311	10697	2	0	\N
163193	1397	1312917426000	21312	10697	0	0	\N
163194	2134	87499781000	21312	10697	1	0	\N
163195	2133	95994000000	21312	10697	2	0	\N
163198	1397	1312907425000	21314	10699	0	0	\N
163199	1397	1312897424000	21314	10699	1	0	\N
163200	2133	95992998000	21314	10699	2	0	\N
163201	2134	87497775000	21314	10699	3	0	\N
163209	1397	1312877422000	21317	10701	0	0	\N
163210	1397	1312867421000	21317	10701	1	0	\N
163211	1397	1312857420000	21317	10701	2	0	\N
163212	1397	1312847419000	21317	10701	3	0	\N
163213	2132	148055056000	21317	10701	4	0	\N
163214	2134	87495769000	21317	10701	5	0	\N
163215	2133	95990994000	21317	10701	6	0	\N
163216	2133	95989992000	21317	10701	7	0	\N
163217	2134	87494766000	21317	10701	8	0	\N
163218	2134	87493763000	21317	10701	9	0	\N
163219	2134	87492760000	21317	10701	10	0	\N
163220	2133	95988990000	21317	10701	11	0	\N
163221	2133	95987988000	21317	10701	12	0	\N
163222	1397	1312877422000	21318	10701	0	0	\N
163223	1397	1312867421000	21318	10701	1	0	\N
163224	1397	1312857420000	21318	10701	2	0	\N
163225	1397	1312847419000	21318	10701	3	0	\N
163226	2132	148055056000	21318	10701	4	0	\N
163227	2134	87495769000	21318	10701	5	0	\N
163228	2133	95990994000	21318	10701	6	0	\N
163229	2133	95989992000	21318	10701	7	0	\N
163230	2134	87494766000	21318	10701	8	0	\N
163231	2134	87493763000	21318	10701	9	0	\N
163232	2134	87492760000	21318	10701	10	0	\N
163233	2133	95988990000	21318	10701	11	0	\N
163234	2133	95987988000	21318	10701	12	0	\N
163256	1397	1312817416000	21322	10704	0	0	\N
163257	2134	87489751000	21322	10704	1	0	\N
163258	2133	95984982000	21322	10704	2	0	\N
163269	1397	1312797414000	21326	10706	0	0	\N
163270	2133	95982978000	21326	10706	2	0	\N
163271	2134	87487745000	21326	10706	3	0	\N
163272	1397	1312787413000	21327	10707	0	0	\N
163273	2133	95981976000	21327	10707	1	0	\N
163274	2134	87486742000	21327	10707	2	0	\N
163275	1397	1312787413000	21328	10707	0	0	\N
163276	2133	95981976000	21328	10707	1	0	\N
163277	2134	87486742000	21328	10707	2	0	\N
163281	2133	95981976000	21330	10707	0	0	\N
163282	2134	87486742000	21330	10707	1	0	\N
163283	1458	22110672908540	21331	10708	0	0	\N
163284	1397	1312777412000	21331	10708	1	0	\N
163285	2133	95980974000	21331	10708	2	0	\N
163286	2134	87485739000	21331	10708	3	0	\N
163287	2132	148052053000	21331	10708	4	0	\N
163293	2133	95980974000	21333	10708	0	0	\N
163294	2134	87485739000	21333	10708	1	0	\N
163295	2132	148052053000	21333	10708	2	0	\N
163298	1458	22110672908540	21335	10709	0	0	\N
163299	1397	1312777412000	21335	10709	1	0	\N
163300	2134	87484736000	21335	10709	2	0	\N
163301	2133	95979972000	21335	10709	3	0	\N
163302	1397	1312767411000	21336	10710	0	0	\N
163303	2133	95978970000	21336	10710	1	0	\N
163304	2134	87483733000	21336	10710	2	0	\N
163308	1397	1312767411000	21338	10710	0	0	\N
163309	2133	95978970000	21338	10710	1	0	\N
163310	2134	87483733000	21338	10710	2	0	\N
163311	1397	1312767411000	21339	10710	0	0	\N
163312	2133	95978970000	21339	10710	1	0	\N
163313	2134	87483733000	21339	10710	2	0	\N
163322	1397	1312747409000	21342	10712	0	0	\N
163323	2132	148051052000	21342	10712	1	0	\N
163324	2134	87481727000	21342	10712	2	0	\N
163325	1397	1312737408000	21343	10713	0	0	\N
163326	1397	1312727407000	21343	10713	1	0	\N
163327	2134	87480724000	21343	10713	2	0	\N
163328	2133	95976966000	21343	10713	3	0	\N
163329	2134	87479721000	21343	10713	4	0	\N
163330	2133	95975964000	21343	10713	5	0	\N
163331	1397	1312737408000	21344	10713	0	0	\N
163332	1397	1312727407000	21344	10713	1	0	\N
163333	2134	87480724000	21344	10713	2	0	\N
163334	2133	95976966000	21344	10713	3	0	\N
163335	2134	87479721000	21344	10713	4	0	\N
163336	2133	95975964000	21344	10713	5	0	\N
163204	2133	95992998000	21315	10699	2	0	3001
163205	2134	87497775000	21315	10699	3	0	3083
163206	1397	1312887423000	21316	10700	0	0	12594
163207	2134	87496772000	21316	10700	1	0	3084
163208	2133	95991996000	21316	10700	2	0	3002
163236	1397	1312867421000	21319	10701	1	0	12596
163237	1397	1312857420000	21319	10701	2	0	12597
163238	1397	1312847419000	21319	10701	3	0	12598
163239	2132	148055056000	21319	10701	4	0	944
163240	2134	87495769000	21319	10701	5	0	3085
163242	2133	95989992000	21319	10701	7	0	3004
163243	2134	87494766000	21319	10701	8	0	3086
163244	2134	87493763000	21319	10701	9	0	3087
163245	2134	87492760000	21319	10701	10	0	3088
163247	2133	95987988000	21319	10701	12	0	3006
163248	2134	87491757000	21320	10702	0	0	3089
163249	259	66009999000000	21320	10702	1	0	1
163250	2133	95986986000	21320	10702	2	0	3007
163251	2132	148054055000	21320	10702	3	0	945
163253	1397	1312827417000	21321	10703	1	0	12600
163254	2133	95985984000	21321	10703	2	0	3008
163255	2134	87490754000	21321	10703	3	0	3090
163259	1397	1312817416000	21323	10704	0	0	12601
163260	2134	87489751000	21323	10704	1	0	3091
163262	1397	1312807415000	21324	10705	0	0	12602
163263	2132	148053054000	21324	10705	1	0	946
163264	2133	95983980000	21324	10705	2	0	3010
163265	2134	87488748000	21324	10705	3	0	3092
163267	2133	95982978000	21325	10706	2	0	3011
163268	2134	87487745000	21325	10706	3	0	3093
163278	1397	1312787413000	21329	10707	0	0	12604
163279	2133	95981976000	21329	10707	1	0	3012
163280	2134	87486742000	21329	10707	2	0	3094
163289	1397	1312777412000	21332	10708	1	0	12605
163290	2133	95980974000	21332	10708	2	0	3013
163291	2134	87485739000	21332	10708	3	0	3095
163292	2132	148052053000	21332	10708	4	0	947
163296	2134	87484736000	21334	10709	0	0	3096
163305	1397	1312767411000	21337	10710	0	0	12606
163306	2133	95978970000	21337	10710	1	0	3015
163307	2134	87483733000	21337	10710	2	0	3097
163314	1458	19133472908540	21340	10711	0	0	6
163316	1397	1312757410000	21340	10711	2	0	12607
163317	2134	87482730000	21340	10711	3	0	3098
163318	2133	95977968000	21340	10711	4	0	3016
163319	1397	1312747409000	21341	10712	0	0	12608
163320	2132	148051052000	21341	10712	1	0	948
163337	1397	1312737408000	21345	10713	0	0	\N
163338	1397	1312727407000	21345	10713	1	0	\N
163339	2134	87480724000	21345	10713	2	0	\N
163340	2133	95976966000	21345	10713	3	0	\N
163341	2134	87479721000	21345	10713	4	0	\N
163342	2133	95975964000	21345	10713	5	0	\N
163361	1397	1312687403000	21349	10715	0	0	\N
163362	2132	148049050000	21349	10715	1	0	\N
163363	2133	95971956000	21349	10715	2	0	\N
163364	2134	87475709000	21349	10715	3	0	\N
163369	1397	1312677402000	21351	10716	0	0	\N
163370	1397	1312667401000	21351	10716	1	0	\N
163371	2133	95970954000	21351	10716	2	0	\N
163372	2133	95969952000	21351	10716	3	0	\N
163373	2134	87474706000	21351	10716	4	0	\N
163374	2134	87473703000	21351	10716	5	0	\N
163389	1397	1312647399000	21355	10718	0	0	\N
163390	2132	148048049000	21355	10718	1	0	\N
163391	2133	95967948000	21355	10718	2	0	\N
163392	2134	87471697000	21355	10718	3	0	\N
163406	1458	22110672908540	21358	10700	0	0	\N
163407	1458	19133472908540	21358	10700	1	0	\N
163408	1458	14721272908540	21358	10700	2	0	\N
163409	1458	6425072908540	21358	10700	3	0	\N
163410	259	66009999000000	21358	10700	4	0	\N
163411	1514	700010030400	21358	10700	5	0	\N
163412	1514	9030400	21358	10700	6	0	\N
163413	1397	1312597394000	21359	10721	0	0	\N
163414	1397	1312587393000	21359	10721	1	0	\N
163415	1397	1312577392000	21359	10721	2	0	\N
163416	1397	1312567391000	21359	10721	3	0	\N
163417	1397	1312557390000	21359	10721	4	0	\N
163418	1397	1312547389000	21359	10721	5	0	\N
163419	2134	87466682000	21359	10721	6	0	\N
163420	2132	148046047000	21359	10721	7	0	\N
163421	2132	148045046000	21359	10721	8	0	\N
163422	2134	87465679000	21359	10721	9	0	\N
163423	2134	87464676000	21359	10721	10	0	\N
163424	2134	87463673000	21359	10721	11	0	\N
163425	2134	87462670000	21359	10721	12	0	\N
163426	2134	87461667000	21359	10721	13	0	\N
163427	2133	95962938000	21359	10721	14	0	\N
163428	2133	95961936000	21359	10721	15	0	\N
163429	2133	95960934000	21359	10721	16	0	\N
163430	2133	95959932000	21359	10721	17	0	\N
163431	2133	95958930000	21359	10721	18	0	\N
163451	1397	1312537388000	21361	10722	0	0	\N
163452	1397	1312527387000	21361	10722	1	0	\N
163453	2133	95957928000	21361	10722	2	0	\N
163454	2134	87460664000	21361	10722	3	0	\N
163455	2134	87459661000	21361	10722	5	0	\N
163456	2133	95956926000	21361	10722	6	0	\N
163463	1397	1312537388000	21363	10722	0	0	\N
163464	1397	1312527387000	21363	10722	1	0	\N
163465	2133	95957928000	21363	10722	2	0	\N
163466	2134	87460664000	21363	10722	3	0	\N
163467	2134	87459661000	21363	10722	5	0	\N
163468	2133	95956926000	21363	10722	6	0	\N
163469	1397	1312537388000	21364	10722	0	0	\N
163470	1397	1312527387000	21364	10722	1	0	\N
163471	2133	95957928000	21364	10722	2	0	\N
163472	2134	87460664000	21364	10722	3	0	\N
163345	2134	87480724000	21346	10713	2	0	3100
163346	2133	95976966000	21346	10713	3	0	3017
163347	2134	87479721000	21346	10713	4	0	3101
163348	2133	95975964000	21346	10713	5	0	3018
163349	1458	6425072908540	21348	10714	0	0	8
163351	1397	1312707405000	21348	10714	2	0	12612
163352	1397	1312697404000	21348	10714	3	0	12613
163353	2134	87478718000	21348	10714	4	0	3102
163354	2134	87477715000	21348	10714	5	0	3103
163355	2134	87476712000	21348	10714	6	0	3104
163357	2133	95974962000	21348	10714	8	0	3019
163358	2133	95973960000	21348	10714	9	0	3020
163359	2133	95972958000	21348	10714	10	0	3021
163360	2132	148050051000	21348	10714	11	0	949
163366	2132	148049050000	21350	10715	1	0	950
163367	2133	95971956000	21350	10715	2	0	3022
163368	2134	87475709000	21350	10715	3	0	3105
163375	1397	1312677402000	21352	10716	0	0	12615
163376	1397	1312667401000	21352	10716	1	0	12616
163378	2133	95969952000	21352	10716	3	0	3024
163379	2134	87474706000	21352	10716	4	0	3106
163380	2134	87473703000	21352	10716	5	0	3107
163381	1397	1312657400000	21353	10717	0	0	12617
163382	2134	87472700000	21353	10717	1	0	3108
163384	2133	95968950000	21353	10717	3	0	3025
163385	1397	1312647399000	21354	10718	0	0	12618
163386	2132	148048049000	21354	10718	1	0	951
163387	2133	95967948000	21354	10718	2	0	3026
163393	1397	1312637398000	21356	10719	0	0	12619
163394	2133	95966946000	21356	10719	1	0	3027
163395	2134	87470694000	21356	10719	2	0	3110
163396	1397	1312627397000	21357	10720	0	0	12620
163397	1397	1312617396000	21357	10720	1	0	12621
163399	2133	95965944000	21357	10720	3	0	3028
163400	2134	87469691000	21357	10720	4	0	3111
163401	2134	87468688000	21357	10720	5	0	3112
163402	2134	87467685000	21357	10720	6	0	3113
163403	2133	95964942000	21357	10720	7	0	3029
163405	2132	148047048000	21357	10720	9	0	952
163432	1397	1312597394000	21360	10721	0	0	12623
163433	1397	1312587393000	21360	10721	1	0	12624
163434	1397	1312577392000	21360	10721	2	0	12625
163436	1397	1312557390000	21360	10721	4	0	12627
163437	1397	1312547389000	21360	10721	5	0	12628
163438	2134	87466682000	21360	10721	6	0	3114
163439	2132	148046047000	21360	10721	7	0	953
163440	2132	148045046000	21360	10721	8	0	954
163442	2134	87464676000	21360	10721	10	0	3116
163443	2134	87463673000	21360	10721	11	0	3117
163444	2134	87462670000	21360	10721	12	0	3118
163445	2134	87461667000	21360	10721	13	0	3119
163446	2133	95962938000	21360	10721	14	0	3031
163448	2133	95960934000	21360	10721	16	0	3033
163449	2133	95959932000	21360	10721	17	0	3034
163450	2133	95958930000	21360	10721	18	0	3035
163457	1397	1312537388000	21362	10722	0	0	12629
163459	2133	95957928000	21362	10722	2	0	3036
163460	2134	87460664000	21362	10722	3	0	3120
163461	2134	87459661000	21362	10722	5	0	3121
163462	2133	95956926000	21362	10722	6	0	3037
163473	2134	87459661000	21364	10722	5	0	\N
163474	2133	95956926000	21364	10722	6	0	\N
163475	1397	1312537388000	21365	10722	0	0	\N
163476	1397	1312527387000	21365	10722	1	0	\N
163477	2133	95957928000	21365	10722	2	0	\N
163478	2134	87460664000	21365	10722	3	0	\N
163479	2134	87459661000	21365	10722	5	0	\N
163480	2133	95956926000	21365	10722	6	0	\N
163481	1397	1312537388000	21366	10722	0	0	\N
163482	1397	1312527387000	21366	10722	1	0	\N
163483	2133	95957928000	21366	10722	2	0	\N
163484	2134	87460664000	21366	10722	3	0	\N
163485	2134	87459661000	21366	10722	5	0	\N
163486	2133	95956926000	21366	10722	6	0	\N
163491	1397	1312517386000	21368	10723	0	0	\N
163492	2132	148044045000	21368	10723	1	0	\N
163493	2133	95955924000	21368	10723	2	0	\N
163494	2134	87458658000	21368	10723	3	0	\N
163495	1397	1312517386000	21369	10723	0	0	\N
163496	2132	148044045000	21369	10723	1	0	\N
163497	2133	95955924000	21369	10723	2	0	\N
163498	2134	87458658000	21369	10723	3	0	\N
163499	1397	1312507385000	21370	10724	0	0	\N
163500	1397	1312497384000	21370	10724	1	0	\N
163501	2134	87457655000	21370	10724	2	0	\N
163502	2134	87456652000	21370	10724	3	0	\N
163503	2133	95954922000	21370	10724	4	0	\N
163504	2133	95953920000	21370	10724	5	0	\N
163511	1397	1312487383000	21372	10725	0	0	\N
163512	2134	87455649000	21372	10725	1	0	\N
163513	2133	95952918000	21372	10725	2	0	\N
163514	2132	148043044000	21372	10725	3	0	\N
163515	1397	1312487383000	21373	10725	0	0	\N
163516	2134	87455649000	21373	10725	1	0	\N
163517	2133	95952918000	21373	10725	2	0	\N
163518	2132	148043044000	21373	10725	3	0	\N
163519	1397	1312487383000	21374	10725	0	0	\N
163520	2134	87455649000	21374	10725	1	0	\N
163521	2133	95952918000	21374	10725	2	0	\N
163522	2132	148043044000	21374	10725	3	0	\N
163523	1397	1312487383000	21375	10725	0	0	\N
163524	2134	87455649000	21375	10725	1	0	\N
163525	2133	95952918000	21375	10725	2	0	\N
163526	2132	148043044000	21375	10725	3	0	\N
163527	1397	1312487383000	21376	10725	0	0	\N
163528	2134	87455649000	21376	10725	1	0	\N
163529	2133	95952918000	21376	10725	2	0	\N
163530	2132	148043044000	21376	10725	3	0	\N
163552	1397	1312447379000	21383	10728	0	0	\N
163553	1397	1312437378000	21383	10728	1	0	\N
163554	2134	87451637000	21383	10728	2	0	\N
163555	2134	87450634000	21383	10728	3	0	\N
163556	2132	148042043000	21383	10728	4	0	\N
163557	2133	95948910000	21383	10728	5	0	\N
163558	2133	95947908000	21383	10728	6	0	\N
163559	1397	1312427377000	21384	10729	0	0	\N
163560	2133	95946906000	21384	10729	1	0	\N
163561	2134	87449631000	21384	10729	2	0	\N
163565	1397	1312427377000	21386	10729	0	0	\N
163566	2133	95946906000	21386	10729	1	0	\N
163567	2134	87449631000	21386	10729	2	0	\N
163568	1397	1312427377000	21387	10729	0	0	\N
163569	2133	95946906000	21387	10729	1	0	\N
163570	2134	87449631000	21387	10729	2	0	\N
163571	1397	1312417376000	21388	10730	0	0	\N
163572	694	66522947693786	21388	10730	1	0	\N
163573	2132	148041042000	21388	10730	2	0	\N
163574	2134	87448628000	21388	10730	3	0	\N
163585	1458	19133472908540	21392	10709	0	0	\N
163586	1458	14721272908540	21392	10709	1	0	\N
163587	1458	6425072908540	21392	10709	2	0	\N
163588	1397	1312767411000	21392	10709	3	0	\N
163589	694	66522947693786	21392	10709	4	0	\N
163590	1397	1312757410000	21392	10709	5	0	\N
163591	1397	1312747409000	21392	10709	6	0	\N
163592	1397	1312737408000	21392	10709	7	0	\N
163593	1397	1312727407000	21392	10709	8	0	\N
163594	1397	1312717406000	21392	10709	9	0	\N
163595	1397	1312707405000	21392	10709	10	0	\N
163596	1397	1312697404000	21392	10709	11	0	\N
163597	1397	1312687403000	21392	10709	12	0	\N
163598	1397	1312677402000	21392	10709	13	0	\N
163599	1397	1312667401000	21392	10709	14	0	\N
163600	1397	1312657400000	21392	10709	15	0	\N
163601	1397	1312647399000	21392	10709	16	0	\N
163602	1397	1312637398000	21392	10709	17	0	\N
163603	1397	1312627397000	21392	10709	18	0	\N
163604	1397	1312617396000	21392	10709	19	0	\N
163605	1397	1312607395000	21392	10709	20	0	\N
163606	1397	1312597394000	21392	10709	21	0	\N
163607	1397	1312587393000	21392	10709	22	0	\N
163608	1397	1312577392000	21392	10709	23	0	\N
163489	2133	95955924000	21367	10723	2	0	3038
163490	2134	87458658000	21367	10723	3	0	3122
163505	1397	1312507385000	21371	10724	0	0	12632
163506	1397	1312497384000	21371	10724	1	0	12633
163507	2134	87457655000	21371	10724	2	0	3123
163509	2133	95954922000	21371	10724	4	0	3039
163510	2133	95953920000	21371	10724	5	0	3040
163531	1397	1312487383000	21377	10725	0	0	12634
163532	2134	87455649000	21377	10725	1	0	3125
163533	2133	95952918000	21377	10725	2	0	3041
163535	1397	1312477382000	21380	10726	0	0	12635
163536	2134	87454646000	21380	10726	1	0	3126
163537	2133	95951916000	21380	10726	2	0	3042
163538	2287	718999000000	21380	10726	3	0	1
163540	1397	1312457380000	21381	10727	1	0	12637
163541	2133	95950914000	21381	10727	2	0	3043
163542	2133	95949912000	21381	10727	3	0	3044
163543	2134	87453643000	21381	10727	4	0	3127
163544	2134	87452640000	21381	10727	5	0	3128
163546	1397	1312437378000	21382	10728	1	0	12639
163547	2134	87451637000	21382	10728	2	0	3129
163548	2134	87450634000	21382	10728	3	0	3130
163549	2132	148042043000	21382	10728	4	0	957
163550	2133	95948910000	21382	10728	5	0	3045
163562	1397	1312427377000	21385	10729	0	0	12640
163563	2133	95946906000	21385	10729	1	0	3047
163564	2134	87449631000	21385	10729	2	0	3131
163575	1397	1312417376000	21389	10730	0	0	12641
163577	2132	148041042000	21389	10730	2	0	958
163578	2134	87448628000	21389	10730	3	0	3132
163579	1397	1312407375000	21390	10731	0	0	12642
163580	2133	95945904000	21390	10731	1	0	3048
163581	2134	87447625000	21390	10731	2	0	3133
163583	2133	95944902000	21391	10732	1	0	3049
163584	2134	87446622000	21391	10732	2	0	3134
163609	1397	1312567391000	21392	10709	24	0	\N
163610	1397	1312557390000	21392	10709	25	0	\N
163611	1397	1312547389000	21392	10709	26	0	\N
163612	1397	1312537388000	21392	10709	27	0	\N
163613	1397	1312527387000	21392	10709	28	0	\N
163614	1397	1312517386000	21392	10709	29	0	\N
163615	1397	1312507385000	21392	10709	30	0	\N
163616	1397	1312497384000	21392	10709	31	0	\N
163617	1397	1312487383000	21392	10709	32	0	\N
163618	1397	1312477382000	21392	10709	33	0	\N
163619	1397	1312467381000	21392	10709	34	0	\N
163620	1397	1312457380000	21392	10709	35	0	\N
163621	1397	1312447379000	21392	10709	36	0	\N
163622	1397	1312437378000	21392	10709	37	0	\N
163623	1397	1312427377000	21392	10709	38	0	\N
163624	1397	1312417376000	21392	10709	39	0	\N
163625	1397	1312407375000	21392	10709	40	0	\N
163626	1397	1312397374000	21392	10709	41	0	\N
163627	2132	148051052000	21392	10709	42	0	\N
163628	2134	87484736000	21392	10709	43	0	\N
163629	1514	700010030400	21392	10709	44	0	\N
163630	1514	9030400	21392	10709	45	0	\N
163631	2133	95979972000	21392	10709	46	0	\N
163632	2133	95978970000	21392	10709	47	0	\N
163633	2134	87483733000	21392	10709	48	0	\N
163634	2134	87482730000	21392	10709	49	0	\N
163635	2134	87481727000	21392	10709	50	0	\N
163636	2134	87480724000	21392	10709	51	0	\N
163637	2134	87479721000	21392	10709	52	0	\N
163638	2134	87478718000	21392	10709	53	0	\N
163639	2134	87477715000	21392	10709	54	0	\N
163640	2134	87476712000	21392	10709	55	0	\N
163641	2134	87475709000	21392	10709	56	0	\N
163642	2133	95977968000	21392	10709	57	0	\N
163643	2133	95976966000	21392	10709	58	0	\N
163644	2133	95975964000	21392	10709	59	0	\N
163645	2133	95974962000	21392	10709	60	0	\N
163646	2133	95973960000	21392	10709	61	0	\N
163647	2133	95972958000	21392	10709	62	0	\N
163648	2133	95971956000	21392	10709	63	0	\N
163649	2133	95970954000	21392	10709	64	0	\N
163650	2133	95969952000	21392	10709	65	0	\N
163651	2133	95968950000	21392	10709	66	0	\N
163652	2133	95967948000	21392	10709	67	0	\N
163653	2133	95966946000	21392	10709	68	0	\N
163654	2133	95965944000	21392	10709	69	0	\N
163655	2133	95964942000	21392	10709	70	0	\N
163656	2133	95963940000	21392	10709	71	0	\N
163657	2134	87474706000	21392	10709	72	0	\N
163658	2134	87473703000	21392	10709	73	0	\N
163659	2134	87472700000	21392	10709	74	0	\N
163660	2134	87471697000	21392	10709	75	0	\N
163661	2134	87470694000	21392	10709	76	0	\N
163662	2134	87469691000	21392	10709	77	0	\N
163663	2134	87468688000	21392	10709	78	0	\N
163664	2134	87467685000	21392	10709	79	0	\N
163665	2134	87466682000	21392	10709	80	0	\N
163666	2134	87465679000	21392	10709	81	0	\N
163667	2134	87464676000	21392	10709	82	0	\N
163668	2134	87463673000	21392	10709	83	0	\N
163669	2134	87462670000	21392	10709	84	0	\N
163670	2134	87461667000	21392	10709	85	0	\N
163671	2134	87460664000	21392	10709	86	0	\N
163672	2134	87459661000	21392	10709	87	0	\N
163673	2134	87458658000	21392	10709	88	0	\N
163674	2134	87457655000	21392	10709	89	0	\N
163675	2134	87456652000	21392	10709	90	0	\N
163676	2134	87455649000	21392	10709	91	0	\N
163677	2134	87454646000	21392	10709	92	0	\N
163678	2134	87453643000	21392	10709	93	0	\N
163679	2134	87452640000	21392	10709	94	0	\N
163680	2134	87451637000	21392	10709	95	0	\N
163681	2134	87450634000	21392	10709	96	0	\N
163682	2134	87449631000	21392	10709	97	0	\N
163683	2134	87448628000	21392	10709	98	0	\N
163684	2134	87447625000	21392	10709	99	0	\N
163685	2134	87446622000	21392	10709	100	0	\N
163686	2133	95962938000	21392	10709	101	0	\N
163687	2133	95961936000	21392	10709	102	0	\N
163688	2133	95960934000	21392	10709	103	0	\N
163689	2133	95959932000	21392	10709	104	0	\N
163690	2133	95958930000	21392	10709	105	0	\N
163691	2133	95957928000	21392	10709	106	0	\N
163692	2133	95956926000	21392	10709	107	0	\N
163693	2133	95955924000	21392	10709	108	0	\N
163694	2132	148050051000	21392	10709	109	0	\N
163695	2132	148049050000	21392	10709	110	0	\N
163696	2132	148048049000	21392	10709	112	0	\N
163697	2132	148047048000	21392	10709	113	0	\N
163698	2132	148046047000	21392	10709	114	0	\N
163699	2132	148045046000	21392	10709	115	0	\N
163700	2132	148044045000	21392	10709	116	0	\N
163701	2132	148043044000	21392	10709	117	0	\N
163702	2132	148042043000	21392	10709	118	0	\N
163703	2132	148041042000	21392	10709	119	0	\N
163704	2133	95954922000	21392	10709	120	0	\N
163705	2133	95953920000	21392	10709	121	0	\N
163706	2133	95952918000	21392	10709	122	0	\N
163707	2133	95951916000	21392	10709	123	0	\N
163708	2133	95950914000	21392	10709	124	0	\N
163709	1397	1312387373000	21393	10733	0	0	\N
163710	2134	87445619000	21393	10733	1	0	\N
163711	2133	95943900000	21393	10733	2	0	\N
163712	2132	148040041000	21393	10733	3	0	\N
163717	1397	1312387373000	21395	10733	0	0	\N
163718	2134	87445619000	21395	10733	1	0	\N
163719	2133	95943900000	21395	10733	2	0	\N
163720	2132	148040041000	21395	10733	3	0	\N
163724	694	66522947693786	21397	10701	0	0	\N
163725	2287	718999000000	21397	10701	1	0	\N
163726	1397	1312377372000	21398	10734	0	0	\N
163727	2133	95942898000	21398	10734	1	0	\N
163728	1547	22892809000000	21399	10735	0	0	\N
163729	1397	1312367371000	21399	10735	1	0	\N
163730	1397	1312357370000	21399	10735	2	0	\N
163731	1397	1312347369000	21399	10735	3	0	\N
163732	2134	87443613000	21399	10735	4	0	\N
163733	2134	87442610000	21399	10735	5	0	\N
163734	2134	87441607000	21399	10735	6	0	\N
163735	2133	95941896000	21399	10735	7	0	\N
163736	2133	95940894000	21399	10735	8	0	\N
163737	2132	148039040000	21399	10735	9	0	\N
163738	2133	95939892000	21399	10735	10	0	\N
163739	1547	22892809000000	21400	10735	0	0	\N
163740	1397	1312367371000	21400	10735	1	0	\N
163741	1397	1312357370000	21400	10735	2	0	\N
163742	1397	1312347369000	21400	10735	3	0	\N
163743	2134	87443613000	21400	10735	4	0	\N
163744	2134	87442610000	21400	10735	5	0	\N
163715	2133	95943900000	21394	10733	2	0	3050
163716	2132	148040041000	21394	10733	3	0	959
163721	1397	1312377372000	21396	10734	0	0	12645
163722	2134	87444616000	21396	10734	1	0	3136
163723	2133	95942898000	21396	10734	2	0	3051
163745	2134	87441607000	21400	10735	6	0	\N
163746	2133	95941896000	21400	10735	7	0	\N
163747	2133	95940894000	21400	10735	8	0	\N
163748	2132	148039040000	21400	10735	9	0	\N
163749	2133	95939892000	21400	10735	10	0	\N
163750	1547	22892809000000	21401	10735	0	0	\N
163751	1397	1312367371000	21401	10735	1	0	\N
163752	1397	1312357370000	21401	10735	2	0	\N
163753	1397	1312347369000	21401	10735	3	0	\N
163754	2134	87443613000	21401	10735	4	0	\N
163755	2134	87442610000	21401	10735	5	0	\N
163756	2134	87441607000	21401	10735	6	0	\N
163757	2133	95941896000	21401	10735	7	0	\N
163758	2133	95940894000	21401	10735	8	0	\N
163759	2132	148039040000	21401	10735	9	0	\N
163760	2133	95939892000	21401	10735	10	0	\N
163772	1547	22605789000000	21403	10736	0	0	\N
163773	1397	1312337368000	21403	10736	1	0	\N
163774	1397	1312327367000	21403	10736	2	0	\N
163775	2133	95938890000	21403	10736	3	0	\N
163776	2133	95937888000	21403	10736	4	0	\N
163777	2134	87440604000	21403	10736	5	0	\N
163778	2134	87439601000	21403	10736	6	0	\N
163786	1397	1312317366000	21405	10737	0	0	\N
163787	2134	87438598000	21405	10737	1	0	\N
163788	2133	95936886000	21405	10737	2	0	\N
163789	2132	148038039000	21405	10737	3	0	\N
163790	1397	1312317366000	21406	10737	0	0	\N
163791	2134	87438598000	21406	10737	1	0	\N
163792	2133	95936886000	21406	10737	2	0	\N
163793	2132	148038039000	21406	10737	3	0	\N
163803	1547	20416769000000	21409	10738	0	0	\N
163804	1547	17769749000000	21409	10738	1	0	\N
163805	1397	1312307365000	21409	10738	2	0	\N
163806	2133	95935884000	21409	10738	3	0	\N
163807	2134	87437595000	21409	10738	4	0	\N
163808	1547	20416769000000	21410	10738	0	0	\N
163809	1547	17769749000000	21410	10738	1	0	\N
163810	2133	95935884000	21410	10738	2	0	\N
163811	1458	21390661908540	21411	10463	0	0	\N
163812	1458	18413461908540	21411	10463	1	0	\N
163813	1458	14001261908540	21411	10463	2	0	\N
163814	1458	5705061908540	21411	10463	3	0	\N
163815	1547	21452745000000	21411	10463	4	0	\N
163816	1547	21165725000000	21411	10463	5	0	\N
163817	1547	18976705000000	21411	10463	6	0	\N
163818	1547	16329685000000	21411	10463	7	0	\N
163819	1426	15961288000000	21411	10463	8	0	\N
163820	1471	14856185900000	21411	10463	9	0	\N
163821	1649	15038396999992	21411	10463	10	0	\N
163822	1426	10895278000000	21411	10463	11	0	\N
163823	1471	9790175900000	21411	10463	12	0	\N
163824	694	66522947693786	21411	10463	13	0	\N
163825	1649	9482386999992	21411	10463	14	0	\N
163826	1649	5733376999992	21411	10463	15	0	\N
163827	1649	2632366999992	21411	10463	16	0	\N
163828	1471	6372165900000	21411	10463	17	0	\N
163829	1397	1314887623000	21411	10463	18	0	\N
163830	1426	7477268000000	21411	10463	19	0	\N
163831	1426	4650258000000	21411	10463	20	0	\N
163832	1397	1314877622000	21411	10463	21	0	\N
163833	1397	1314867621000	21411	10463	22	0	\N
163834	1397	1314857620000	21411	10463	23	0	\N
163835	1397	1314847619000	21411	10463	24	0	\N
163836	1397	1314837618000	21411	10463	25	0	\N
163837	1397	1314827617000	21411	10463	26	0	\N
163838	1397	1314817616000	21411	10463	27	0	\N
163839	1397	1314807615000	21411	10463	28	0	\N
163840	1397	1314797614000	21411	10463	29	0	\N
163841	1397	1314787613000	21411	10463	30	0	\N
163842	1397	1314777612000	21411	10463	31	0	\N
163843	1397	1314767611000	21411	10463	32	0	\N
163844	1397	1314757610000	21411	10463	33	0	\N
163845	1397	1314747609000	21411	10463	34	0	\N
163846	1397	1314737608000	21411	10463	35	0	\N
163847	1397	1314727607000	21411	10463	36	0	\N
163848	1397	1314717606000	21411	10463	37	0	\N
163849	1397	1314707605000	21411	10463	38	0	\N
163850	1397	1314697604000	21411	10463	39	0	\N
163851	1397	1314687603000	21411	10463	40	0	\N
163852	1397	1314677602000	21411	10463	41	0	\N
163853	1397	1314667601000	21411	10463	42	0	\N
163854	1397	1314657600000	21411	10463	43	0	\N
163855	1397	1314647599000	21411	10463	44	0	\N
163856	1397	1314637598000	21411	10463	45	0	\N
163857	1397	1314627597000	21411	10463	46	0	\N
163858	1397	1314617596000	21411	10463	47	0	\N
163859	1397	1314607595000	21411	10463	48	0	\N
163860	1397	1314597594000	21411	10463	49	0	\N
163861	1397	1314587593000	21411	10463	50	0	\N
163862	1397	1314577592000	21411	10463	51	0	\N
163863	1397	1314567591000	21411	10463	52	0	\N
163864	1397	1314557590000	21411	10463	53	0	\N
163865	1397	1314547589000	21411	10463	54	0	\N
163866	1397	1314537588000	21411	10463	55	0	\N
163867	1397	1314527587000	21411	10463	56	0	\N
163868	1397	1314517586000	21411	10463	57	0	\N
163869	1397	1314507585000	21411	10463	58	0	\N
163870	1397	1314497584000	21411	10463	59	0	\N
163871	1397	1314487583000	21411	10463	60	0	\N
163872	1397	1314477582000	21411	10463	61	0	\N
163873	1397	1314467581000	21411	10463	62	0	\N
163874	1397	1314457580000	21411	10463	63	0	\N
163875	1397	1314447579000	21411	10463	64	0	\N
163876	1397	1314437578000	21411	10463	65	0	\N
163877	1397	1314427577000	21411	10463	66	0	\N
163878	1397	1314417576000	21411	10463	67	0	\N
163879	1397	1314407575000	21411	10463	68	0	\N
163880	1397	1314397574000	21411	10463	69	0	\N
163763	1397	1312357370000	21402	10735	2	0	12647
163764	1397	1312347369000	21402	10735	3	0	12648
163765	2134	87443613000	21402	10735	4	0	3137
163766	2134	87442610000	21402	10735	5	0	3138
163767	2134	87441607000	21402	10735	6	0	3139
163769	2133	95940894000	21402	10735	8	0	3053
163770	2132	148039040000	21402	10735	9	0	960
163771	2133	95939892000	21402	10735	10	0	3054
163779	1547	22605789000000	21404	10736	0	0	8
163780	1397	1312337368000	21404	10736	1	0	12649
163782	2133	95938890000	21404	10736	3	0	3055
163783	2133	95937888000	21404	10736	4	0	3056
163784	2134	87440604000	21404	10736	5	0	3140
163785	2134	87439601000	21404	10736	6	0	3141
163795	2134	87438598000	21407	10737	1	0	3142
163796	2133	95936886000	21407	10737	2	0	3057
163797	2132	148038039000	21407	10737	3	0	961
163798	1547	20416769000000	21408	10738	0	0	9
163799	1547	17769749000000	21408	10738	1	0	10
163801	2133	95935884000	21408	10738	3	0	3058
163802	2134	87437595000	21408	10738	4	0	3143
163881	1397	1314387573000	21411	10463	70	0	\N
163882	1397	1314377572000	21411	10463	71	0	\N
163883	1397	1314367571000	21411	10463	72	0	\N
163884	1397	1314357570000	21411	10463	73	0	\N
163885	1397	1314347569000	21411	10463	74	0	\N
163886	1397	1314337568000	21411	10463	75	0	\N
163887	1397	1314327567000	21411	10463	76	0	\N
163888	1397	1314317566000	21411	10463	77	0	\N
163889	1397	1314307565000	21411	10463	78	0	\N
163890	1397	1314297564000	21411	10463	79	0	\N
163891	1397	1314287563000	21411	10463	80	0	\N
163892	1397	1314277562000	21411	10463	81	0	\N
163893	1397	1314267561000	21411	10463	82	0	\N
163894	1397	1314257560000	21411	10463	83	0	\N
163895	1397	1314247559000	21411	10463	84	0	\N
163896	1397	1314237558000	21411	10463	85	0	\N
163897	1397	1314227557000	21411	10463	86	0	\N
163898	1397	1314217556000	21411	10463	87	0	\N
163899	1397	1314207555000	21411	10463	88	0	\N
163900	1397	1314197554000	21411	10463	89	0	\N
163901	1397	1314187553000	21411	10463	90	0	\N
163902	1397	1314177552000	21411	10463	91	0	\N
163903	1397	1314167551000	21411	10463	92	0	\N
163904	1397	1314157550000	21411	10463	93	0	\N
163905	1397	1314147549000	21411	10463	94	0	\N
163906	1397	1314137548000	21411	10463	95	0	\N
163907	1397	1314127547000	21411	10463	96	0	\N
163908	1397	1314117546000	21411	10463	97	0	\N
163909	1397	1314107545000	21411	10463	98	0	\N
163910	1397	1314097544000	21411	10463	99	0	\N
163911	1397	1314087543000	21411	10463	100	0	\N
163912	1397	1314077542000	21411	10463	101	0	\N
163913	1397	1314067541000	21411	10463	102	0	\N
163914	1397	1314057540000	21411	10463	103	0	\N
163915	1397	1314047539000	21411	10463	104	0	\N
163916	1397	1314037538000	21411	10463	105	0	\N
163917	1397	1314027537000	21411	10463	107	0	\N
163918	1397	1314017536000	21411	10463	108	0	\N
163919	1397	1314007535000	21411	10463	109	0	\N
163920	1397	1313997534000	21411	10463	110	0	\N
163921	1397	1313987533000	21411	10463	111	0	\N
163922	1397	1313977532000	21411	10463	112	0	\N
163923	1397	1313967531000	21411	10463	113	0	\N
163924	1397	1313957530000	21411	10463	114	0	\N
163925	1397	1313947529000	21411	10463	115	0	\N
163926	1397	1313937528000	21411	10463	116	0	\N
163927	1397	1313927527000	21411	10463	117	0	\N
163928	1397	1313917526000	21411	10463	118	0	\N
163929	1397	1313907525000	21411	10463	119	0	\N
163930	1397	1313897524000	21411	10463	120	0	\N
163931	1397	1313887523000	21411	10463	121	0	\N
163932	1397	1313877522000	21411	10463	122	0	\N
163936	1397	1312297364000	21413	10739	0	0	\N
163937	2133	95934882000	21413	10739	1	0	\N
163938	2134	87436592000	21413	10739	2	0	\N
163939	1397	1312297364000	21414	10739	0	0	\N
163940	2133	95934882000	21414	10739	1	0	\N
163941	2134	87436592000	21414	10739	2	0	\N
163953	1547	13847729000000	21416	10740	0	0	\N
163954	1547	6474709000000	21416	10740	1	0	\N
163955	1397	1312287363000	21416	10740	2	0	\N
163956	1397	1312277362000	21416	10740	3	0	\N
163957	2134	87435589000	21416	10740	4	0	\N
163958	2133	95933880000	21416	10740	5	0	\N
163959	2132	148037038000	21416	10740	6	0	\N
163960	2134	87434586000	21416	10740	7	0	\N
163961	2134	87433583000	21416	10740	9	0	\N
163962	2133	95932878000	21416	10740	10	0	\N
163963	2133	95931876000	21416	10740	11	0	\N
163964	1547	13847729000000	21417	10740	0	0	\N
163965	1547	6474709000000	21417	10740	1	0	\N
163966	1397	1312287363000	21417	10740	2	0	\N
163967	1397	1312277362000	21417	10740	3	0	\N
163968	1397	1312267361000	21417	10740	4	0	\N
163969	2134	87435589000	21417	10740	5	0	\N
163970	2133	95933880000	21417	10740	6	0	\N
163971	2132	148037038000	21417	10740	7	0	\N
163972	2134	87434586000	21417	10740	9	0	\N
163973	2134	87433583000	21417	10740	10	0	\N
163974	2133	95932878000	21417	10740	11	0	\N
163975	2133	95931876000	21417	10740	12	0	\N
163976	1547	13847729000000	21418	10740	0	0	\N
163977	1547	6474709000000	21418	10740	1	0	\N
163978	1397	1312287363000	21418	10740	2	0	\N
163979	1397	1312277362000	21418	10740	3	0	\N
163980	2134	87435589000	21418	10740	4	0	\N
163981	2133	95933880000	21418	10740	5	0	\N
163982	2132	148037038000	21418	10740	6	0	\N
163983	2134	87434586000	21418	10740	7	0	\N
163984	2134	87433583000	21418	10740	9	0	\N
163985	2133	95932878000	21418	10740	10	0	\N
163986	2133	95931876000	21418	10740	11	0	\N
163993	1397	1312247359000	21421	10743	0	0	\N
163994	2133	95929872000	21421	10743	1	0	\N
163995	694	66521946693786	21421	10743	2	0	\N
163999	1397	1312237358000	21423	10744	0	0	\N
164000	2134	87430574000	21423	10744	1	0	\N
164001	2133	95928870000	21423	10744	2	0	\N
164005	1397	1312227357000	21425	10745	0	0	\N
164006	2134	87429571000	21425	10745	1	0	\N
164007	2132	148035036000	21425	10745	2	0	\N
164008	2133	95927868000	21425	10745	3	0	\N
163935	2134	87436592000	21412	10739	2	0	3144
163942	1547	13847729000000	21415	10740	0	0	11
163943	1547	6474709000000	21415	10740	1	0	12
163944	1397	1312287363000	21415	10740	2	0	12654
163945	1397	1312277362000	21415	10740	3	0	12655
163947	2133	95933880000	21415	10740	5	0	3060
163948	2132	148037038000	21415	10740	6	0	962
163949	2134	87434586000	21415	10740	7	0	3146
163950	2134	87433583000	21415	10740	9	0	3147
163951	2133	95932878000	21415	10740	10	0	3061
163987	1397	1312267361000	21419	10741	0	0	12656
163988	2133	95930874000	21419	10741	1	0	3063
163989	2134	87432580000	21419	10741	2	0	3148
163990	1397	1312257360000	21420	10742	0	0	12657
163992	2132	148036037000	21420	10742	2	0	963
163996	1397	1312247359000	21422	10743	0	0	12658
163997	2133	95929872000	21422	10743	1	0	3064
163998	694	66521946693786	21422	10743	2	0	2
164002	1397	1312237358000	21424	10744	0	0	12659
164004	2133	95928870000	21424	10744	2	0	3065
164009	1397	1312227357000	21426	10745	0	0	12660
164010	2134	87429571000	21426	10745	1	0	3151
164011	2132	148035036000	21426	10745	2	0	964
164012	2133	95927868000	21426	10745	3	0	3066
164014	1397	1312207355000	21427	10746	1	0	12662
164015	2133	95926866000	21427	10746	2	0	3067
164016	2133	95925864000	21427	10746	3	0	3068
164019	1397	1312197354000	21428	10747	0	0	\N
164020	1397	1312187353000	21428	10747	1	0	\N
164021	1397	1312177352000	21428	10747	2	0	\N
164022	2134	87426562000	21428	10747	3	0	\N
164023	2133	95924862000	21428	10747	4	0	\N
164024	2134	87425559000	21428	10747	5	0	\N
164025	2134	87424556000	21428	10747	6	0	\N
164026	2132	148034035000	21428	10747	7	0	\N
164027	2133	95923860000	21428	10747	8	0	\N
164028	2133	95922858000	21428	10747	9	0	\N
164039	1397	1312167351000	21430	10748	0	0	\N
164040	2133	95921856000	21430	10748	1	0	\N
164041	2134	87423553000	21430	10748	2	0	\N
164045	1397	1312167351000	21432	10748	0	0	\N
164046	2133	95921856000	21432	10748	1	0	\N
164047	2134	87423553000	21432	10748	2	0	\N
164057	1397	1312147349000	21435	10750	0	0	\N
164058	1397	1312137348000	21435	10750	1	0	\N
164059	2133	95920854000	21435	10750	2	0	\N
164060	2134	87421547000	21435	10750	3	0	\N
164061	2134	87420544000	21435	10750	4	0	\N
164062	2133	95919852000	21435	10750	5	0	\N
164070	694	66521946693786	21437	10741	0	0	\N
164086	1397	1312097344000	21441	10754	0	0	\N
164087	1397	1312087343000	21441	10754	1	0	\N
164088	1686	20940604289347	21441	10754	2	0	\N
164089	2134	87416532000	21441	10754	3	0	\N
164090	2134	87415529000	21441	10754	4	0	\N
164091	2133	95914842000	21441	10754	5	0	\N
164109	1397	1312047339000	21446	10757	0	0	\N
164110	2134	87411517000	21446	10757	1	0	\N
164111	2133	95910834000	21446	10757	2	0	\N
164127	1771	304905534083	21450	10742	0	0	\N
164128	1686	21518995869379	21450	10742	1	0	\N
164129	1686	21229800079363	21450	10742	2	0	\N
164130	1686	20940604289347	21450	10742	3	0	\N
164131	1686	18738685403647	21450	10742	4	0	\N
164132	1686	14792873546422	21450	10742	5	0	\N
164133	1686	12130552407697	21450	10742	6	0	\N
164134	1686	4711775700122	21450	10742	7	0	\N
164135	1686	4711765700122	21450	10742	8	0	\N
164136	694	66511945693786	21450	10742	9	0	\N
164137	694	66001944693786	21450	10742	10	0	\N
164145	1547	22892809000000	21453	10702	0	0	\N
164146	1547	22605789000000	21453	10702	1	0	\N
164147	1547	20416769000000	21453	10702	2	0	\N
164148	1547	17769749000000	21453	10702	3	0	\N
164149	1547	13847729000000	21453	10702	4	0	\N
164150	1547	6474709000000	21453	10702	5	0	\N
164151	1771	304905534083	21453	10702	6	0	\N
164152	1686	20078957869379	21453	10702	7	0	\N
164029	1397	1312197354000	21429	10747	0	0	12663
164030	1397	1312187353000	21429	10747	1	0	12664
164031	1397	1312177352000	21429	10747	2	0	12665
164032	2134	87426562000	21429	10747	3	0	3154
164033	2133	95924862000	21429	10747	4	0	3069
164035	2134	87424556000	21429	10747	6	0	3156
164036	2132	148034035000	21429	10747	7	0	965
164037	2133	95923860000	21429	10747	8	0	3070
164038	2133	95922858000	21429	10747	9	0	3071
164042	1397	1312167351000	21431	10748	0	0	12666
164044	2134	87423553000	21431	10748	2	0	3157
164048	1397	1312157350000	21433	10749	0	0	12667
164049	2132	148033034000	21433	10749	1	0	966
164050	2134	87422550000	21433	10749	2	0	3158
164052	1397	1312137348000	21434	10750	1	0	12669
164053	2133	95920854000	21434	10750	2	0	3073
164054	2134	87421547000	21434	10750	3	0	3159
164055	2134	87420544000	21434	10750	4	0	3160
164056	2133	95919852000	21434	10750	5	0	3074
164064	1397	1312117346000	21436	10751	1	0	12671
164065	2134	87419541000	21436	10751	2	0	3161
164066	2134	87418538000	21436	10751	3	0	3162
164067	2133	95918850000	21436	10751	4	0	3075
164068	2132	148032033000	21436	10751	5	0	967
164071	1397	1312107345000	21438	10752	0	0	12672
164072	2134	87417535000	21438	10752	1	0	3163
164073	2133	95916846000	21438	10752	2	0	3077
164074	694	66511945693786	21438	10752	3	0	3
164076	1686	21229800079363	21439	10753	1	0	11
164077	2132	148031032000	21439	10753	2	0	968
164078	2133	95915844000	21439	10753	3	0	3078
164079	694	66001944693786	21439	10753	4	0	4
164080	1397	1312097344000	21440	10754	0	0	12673
164082	1686	20940604289347	21440	10754	2	0	12
164083	2134	87416532000	21440	10754	3	0	3164
164084	2134	87415529000	21440	10754	4	0	3165
164085	2133	95914842000	21440	10754	5	0	3079
164092	1686	18738685403647	21443	10755	0	0	13
164094	1397	1312077342000	21443	10755	2	0	12675
164095	1397	1312067341000	21443	10755	3	0	12676
164096	2134	87414526000	21443	10755	4	0	3166
164097	2134	87413523000	21443	10755	5	0	3167
164099	2133	95912838000	21443	10755	7	0	3081
164100	1397	1312057340000	21444	10756	0	0	12677
164101	1686	12130552407697	21444	10756	1	0	15
164102	1686	4711775700122	21444	10756	2	0	16
164103	2134	87412520000	21444	10756	3	0	3168
164105	2132	148030031000	21444	10756	5	0	969
164106	1397	1312047339000	21445	10757	0	0	12678
164107	2134	87411517000	21445	10757	1	0	3169
164108	2133	95910834000	21445	10757	2	0	3083
164112	1397	1312037338000	21447	10758	0	0	12679
164114	2134	87410514000	21447	10758	2	0	3170
164115	2133	95909832000	21447	10758	3	0	3084
164116	2132	148029030000	21447	10758	4	0	970
164117	2134	87409511000	21447	10758	6	0	3171
164119	1686	4711765700122	21448	10759	0	0	17
164120	1397	1312017336000	21448	10759	1	0	12681
164121	2134	87408508000	21448	10759	2	0	3172
164122	2133	95907828000	21448	10759	3	0	3086
164123	1397	1312007335000	21449	10760	0	0	12682
164125	2134	87407505000	21449	10760	2	0	3173
164126	2133	95906826000	21449	10760	3	0	3087
164138	1397	1311997334000	21451	10761	0	0	12683
164139	2134	87406502000	21451	10761	1	0	3174
164140	2132	148028029000	21451	10761	2	0	971
164142	1397	1311987333000	21452	10762	0	0	12684
164143	2134	87405499000	21452	10762	1	0	3175
164144	2133	95904822000	21452	10762	2	0	3089
164153	1686	19789762079363	21453	10702	8	0	\N
164154	1686	19500566289347	21453	10702	9	0	\N
164155	1686	17298647403647	21453	10702	10	0	\N
164156	1686	13352835546422	21453	10702	11	0	\N
164157	1686	10690514407697	21453	10702	12	0	\N
164158	1686	3271737700122	21453	10702	13	0	\N
164159	1686	3271727700122	21453	10702	14	0	\N
164160	694	66521946693786	21453	10702	15	0	\N
164161	694	66511945693786	21453	10702	16	0	\N
164162	694	66001944693786	21453	10702	17	0	\N
164169	1458	22110672908540	21456	10578	0	0	\N
164170	1458	19133472908540	21456	10578	1	0	\N
164171	1458	14721272908540	21456	10578	2	0	\N
164172	1458	6425072908540	21456	10578	3	0	\N
164173	1547	21452745000000	21456	10578	4	0	\N
164174	1547	21165725000000	21456	10578	5	0	\N
164175	1547	18976705000000	21456	10578	6	0	\N
164176	1547	16329685000000	21456	10578	7	0	\N
164177	1547	12407665000000	21456	10578	8	0	\N
164178	1547	5034645000000	21456	10578	9	0	\N
164179	694	66522947693786	21456	10578	10	0	\N
164180	1771	304905534083	21456	10578	11	0	\N
164181	1686	20078957869379	21456	10578	12	0	\N
164182	1686	19789762079363	21456	10578	13	0	\N
164183	1686	19500566289347	21456	10578	14	0	\N
164184	1686	17298647403647	21456	10578	15	0	\N
164185	1686	13352835546422	21456	10578	16	0	\N
164186	1686	10690514407697	21456	10578	17	0	\N
164187	1686	3271737700122	21456	10578	18	0	\N
164188	1686	3271727700122	21456	10578	19	0	\N
164189	259	66009999000000	21456	10578	20	0	\N
164190	2134	87514826000	21456	10578	21	0	\N
164191	1514	700010030400	21456	10578	22	0	\N
164192	1514	9030400	21456	10578	23	0	\N
164193	2134	87513823000	21456	10578	24	0	\N
164194	2134	87512820000	21456	10578	25	0	\N
164195	2134	87511817000	21456	10578	26	0	\N
164196	2134	87510814000	21456	10578	27	0	\N
164197	2134	87509811000	21456	10578	28	0	\N
164198	2134	87508808000	21456	10578	29	0	\N
164199	2134	87507805000	21456	10578	30	0	\N
164200	2134	87506802000	21456	10578	31	0	\N
164201	2134	87505799000	21456	10578	32	0	\N
164202	2134	87504796000	21456	10578	33	0	\N
164203	2134	87503793000	21456	10578	34	0	\N
164204	2134	87502790000	21456	10578	35	0	\N
164205	2134	87501787000	21456	10578	36	0	\N
164206	2134	87500784000	21456	10578	37	0	\N
164207	2134	87499781000	21456	10578	38	0	\N
164208	2134	87498778000	21456	10578	39	0	\N
164209	694	66521946693786	21456	10578	40	0	\N
164210	2134	87497775000	21456	10578	41	0	\N
164228	1397	1311917326000	21460	10767	0	0	\N
164229	2133	95897808000	21460	10767	1	0	\N
164230	2134	87398478000	21460	10767	2	0	\N
164231	1397	1311907325000	21461	10768	0	0	\N
164232	2133	95896806000	21461	10768	1	0	\N
164233	2134	87397475000	21461	10768	2	0	\N
164234	1397	1311907325000	21462	10768	0	0	\N
164235	2133	95896806000	21462	10768	1	0	\N
164236	2134	87397475000	21462	10768	2	0	\N
164237	1397	1311907325000	21463	10768	0	0	\N
164238	2133	95896806000	21463	10768	1	0	\N
164239	2134	87397475000	21463	10768	2	0	\N
164243	1397	1311897324000	21465	10769	0	0	\N
164244	1397	1311887323000	21465	10769	1	0	\N
164245	1397	1311877322000	21465	10769	2	0	\N
164246	2133	95895804000	21465	10769	3	0	\N
164247	2132	148025026000	21465	10769	4	0	\N
164248	2133	95894802000	21465	10769	5	0	\N
164249	2134	87396472000	21465	10769	6	0	\N
164250	2134	87395469000	21465	10769	7	0	\N
164251	2134	87394466000	21465	10769	8	0	\N
164252	2133	95893800000	21465	10769	9	0	\N
164263	1397	1311897324000	21467	10769	0	0	\N
164264	1397	1311887323000	21467	10769	1	0	\N
164265	1397	1311877322000	21467	10769	2	0	\N
164266	2133	95895804000	21467	10769	3	0	\N
164267	2132	148025026000	21467	10769	4	0	\N
164268	2133	95894802000	21467	10769	5	0	\N
164269	2134	87396472000	21467	10769	6	0	\N
164270	2134	87395469000	21467	10769	7	0	\N
164271	2134	87394466000	21467	10769	8	0	\N
164272	2133	95893800000	21467	10769	9	0	\N
164273	1397	1311897324000	21468	10769	0	0	\N
164274	1397	1311887323000	21468	10769	1	0	\N
164275	1397	1311877322000	21468	10769	2	0	\N
164276	2133	95895804000	21468	10769	3	0	\N
164277	2132	148025026000	21468	10769	4	0	\N
164278	2133	95894802000	21468	10769	5	0	\N
164279	2134	87396472000	21468	10769	6	0	\N
164280	2134	87395469000	21468	10769	7	0	\N
164281	2134	87394466000	21468	10769	8	0	\N
164282	2133	95893800000	21468	10769	9	0	\N
164283	1397	1311867321000	21469	10770	0	0	\N
164284	2134	87393463000	21469	10770	1	0	\N
164285	2133	95892798000	21469	10770	2	0	\N
164286	1397	1311867321000	21470	10770	0	0	\N
164287	2134	87393463000	21470	10770	1	0	\N
164288	2133	95892798000	21470	10770	2	0	\N
164165	2134	87404496000	21454	10763	2	0	3176
164166	1397	1311967331000	21455	10764	0	0	12686
164167	2133	95902818000	21455	10764	1	0	3091
164168	2134	87403493000	21455	10764	2	0	3177
164211	1397	1311957330000	21457	10765	0	0	12687
164213	2133	95901816000	21457	10765	2	0	3092
164214	2134	87402490000	21457	10765	3	0	3178
164215	2133	95900814000	21457	10765	4	0	3093
164216	2132	148027028000	21457	10765	5	0	972
164217	2134	87401487000	21457	10765	6	0	3179
164219	1397	1311927327000	21458	10766	1	0	12690
164220	2133	95899812000	21458	10766	2	0	3094
164221	2133	95898810000	21458	10766	3	0	3095
164222	2132	148026027000	21458	10766	4	0	973
164224	2134	87399481000	21458	10766	6	0	3181
164225	1397	1311917326000	21459	10767	0	0	12691
164226	2133	95897808000	21459	10767	1	0	3096
164227	2134	87398478000	21459	10767	2	0	3182
164240	1397	1311907325000	21464	10768	0	0	12692
164242	2134	87397475000	21464	10768	2	0	3183
164253	1397	1311897324000	21466	10769	0	0	12693
164254	1397	1311887323000	21466	10769	1	0	12694
164255	1397	1311877322000	21466	10769	2	0	12695
164256	2133	95895804000	21466	10769	3	0	3098
164258	2133	95894802000	21466	10769	5	0	3099
164259	2134	87396472000	21466	10769	6	0	3184
164260	2134	87395469000	21466	10769	7	0	3185
164261	2134	87394466000	21466	10769	8	0	3186
164292	1397	1311867321000	21472	10770	0	0	\N
164293	2134	87393463000	21472	10770	1	0	\N
164294	2133	95892798000	21472	10770	2	0	\N
164305	1397	1311827317000	21477	10772	0	0	\N
164306	2134	87389451000	21477	10772	1	0	\N
164307	2132	148023024000	21477	10772	2	0	\N
164308	2133	95888790000	21477	10772	3	0	\N
164309	1397	1311827317000	21478	10772	0	0	\N
164310	2134	87389451000	21478	10772	1	0	\N
164311	2132	148023024000	21478	10772	2	0	\N
164312	2133	95888790000	21478	10772	3	0	\N
164313	1397	1311827317000	21479	10772	0	0	\N
164314	2134	87389451000	21479	10772	1	0	\N
164315	2132	148023024000	21479	10772	2	0	\N
164316	2133	95888790000	21479	10772	3	0	\N
164317	1397	1311827317000	21480	10772	0	0	\N
164318	2134	87389451000	21480	10772	1	0	\N
164319	2132	148023024000	21480	10772	2	0	\N
164320	2133	95888790000	21480	10772	3	0	\N
164325	1397	1311827317000	21482	10772	0	0	\N
164326	2134	87389451000	21482	10772	1	0	\N
164327	2132	148023024000	21482	10772	2	0	\N
164328	2133	95888790000	21482	10772	3	0	\N
164329	1397	1311827317000	21483	10772	0	0	\N
164330	2134	87389451000	21483	10772	1	0	\N
164331	2132	148023024000	21483	10772	2	0	\N
164332	2133	95888790000	21483	10772	3	0	\N
164345	1397	1311777312000	21487	10776	0	0	\N
164346	2133	95884782000	21487	10776	1	0	\N
164347	2134	87384436000	21487	10776	2	0	\N
164358	1397	1311747309000	21492	10779	0	0	\N
164359	2134	87381427000	21492	10779	1	0	\N
164360	885	63455021096354	21493	10703	0	0	\N
164361	1397	1311747309000	21494	10779	0	0	\N
164362	2134	87381427000	21494	10779	1	0	\N
164366	1397	1311727307000	21496	10781	0	0	\N
164367	886	63455031096354	21496	10781	1	0	\N
164368	1397	1311717306000	21496	10781	2	0	\N
164369	2134	87379421000	21496	10781	3	0	\N
164370	2134	87378418000	21496	10781	4	0	\N
164382	1397	1311687303000	21501	10784	0	0	\N
164383	2134	87375409000	21501	10784	1	0	\N
164384	1397	1311687303000	21502	10784	0	0	\N
164385	2134	87375409000	21502	10784	1	0	\N
164392	1397	1311647299000	21505	10787	0	0	\N
164393	1397	1311637298000	21505	10787	1	0	\N
164394	1397	1311627297000	21505	10787	2	0	\N
164395	2134	87371397000	21505	10787	3	0	\N
164396	2134	87370394000	21505	10787	4	0	\N
164397	2134	87369391000	21505	10787	5	0	\N
164408	1397	1311617296000	21508	10788	0	0	\N
164409	2133	95882778000	21508	10788	1	0	\N
164410	2134	87368388000	21508	10788	2	0	\N
164411	2132	148021022000	21508	10788	3	0	\N
164291	2133	95892798000	21471	10770	2	0	3101
164295	1397	1311857320000	21476	10771	0	0	12697
164296	1397	1311847319000	21476	10771	1	0	12698
164297	1397	1311837318000	21476	10771	2	0	12699
164298	2133	95891796000	21476	10771	3	0	3102
164300	2134	87392460000	21476	10771	5	0	3188
164301	2134	87391457000	21476	10771	6	0	3189
164302	2134	87390454000	21476	10771	7	0	3190
164303	2132	148024025000	21476	10771	8	0	975
164304	2133	95889792000	21476	10771	9	0	3104
164322	2134	87389451000	21481	10772	1	0	3191
164323	2132	148023024000	21481	10772	2	0	976
164324	2133	95888790000	21481	10772	3	0	3105
164333	1397	1311817316000	21484	10773	0	0	12701
164335	1397	1311807315000	21485	10774	0	0	12702
164336	1397	1311797314000	21485	10774	1	0	12703
164337	2134	87387445000	21485	10774	2	0	3193
164338	2133	95887788000	21485	10774	3	0	3106
164339	2132	148022023000	21485	10774	4	0	977
164341	2133	95886786000	21485	10774	6	0	3107
164342	1397	1311787313000	21486	10775	0	0	12704
164343	2133	95885784000	21486	10775	1	0	3108
164344	2134	87385439000	21486	10775	2	0	3195
164348	1397	1311777312000	21488	10776	0	0	12705
164350	2134	87384436000	21488	10776	2	0	3196
164351	1397	1311767311000	21489	10777	0	0	12706
164352	885	63455021096354	21489	10777	1	0	5
164353	2134	87383433000	21489	10777	2	0	3197
164355	1397	1311757310000	21490	10778	0	0	12707
164356	2134	87382430000	21490	10778	1	0	3198
164357	1397	1311747309000	21491	10779	0	0	12708
164363	1397	1311737308000	21495	10780	0	0	12709
164364	2134	87381427000	21495	10780	1	0	3199
164371	1397	1311727307000	21497	10781	0	0	12710
164372	886	63455031096354	21497	10781	1	0	4
164373	1397	1311717306000	21497	10781	2	0	12711
164374	2134	87379421000	21497	10781	3	0	3201
164375	2134	87378418000	21497	10781	4	0	3202
164377	2134	87377415000	21498	10782	1	0	3203
164378	1397	1311697304000	21499	10783	0	0	12713
164379	2134	87376412000	21499	10783	1	0	3204
164380	1397	1311687303000	21500	10784	0	0	12714
164386	1397	1311677302000	21503	10785	0	0	12715
164387	1397	1311667301000	21503	10785	1	0	12716
164388	2134	87374406000	21503	10785	2	0	3206
164389	2134	87373403000	21503	10785	3	0	3207
164390	1397	1311657300000	21504	10786	0	0	12717
164398	1397	1311647299000	21506	10787	0	0	12718
164399	1397	1311637298000	21506	10787	1	0	12719
164400	1397	1311627297000	21506	10787	2	0	12720
164401	2134	87371397000	21506	10787	3	0	3209
164402	2134	87370394000	21506	10787	4	0	3210
164404	1397	1311617296000	21507	10788	0	0	12721
164405	2133	95882778000	21507	10788	1	0	3111
164406	2134	87368388000	21507	10788	2	0	3212
164407	2132	148021022000	21507	10788	3	0	978
164413	2133	95881776000	21509	10789	1	0	3112
164414	2134	87367385000	21509	10789	2	0	3213
164415	1397	1311597294000	21510	10790	0	0	12723
164416	1397	1311587293000	21510	10790	1	0	12724
164417	2134	87366382000	21510	10790	2	0	3214
164419	2133	95879772000	21510	10790	4	0	3114
164420	2132	148020021000	21510	10790	5	0	979
164421	2134	87365379000	21510	10790	6	0	3215
164422	1397	1311577292000	21511	10791	0	0	12725
164423	1397	1311567291000	21511	10791	1	0	12726
164428	1397	1311557290000	21512	10792	0	0	\N
164429	2133	95876766000	21512	10792	1	0	\N
164430	2134	87362370000	21512	10792	2	0	\N
164431	2132	148019020000	21512	10792	3	0	\N
164439	1458	21390661908540	21515	10527	0	0	\N
164440	1458	18413461908540	21515	10527	1	0	\N
164441	1458	14001261908540	21515	10527	2	0	\N
164442	1458	5705061908540	21515	10527	3	0	\N
164443	1682	10341000000	21515	10527	4	0	\N
164444	365	66017201000000	21515	10527	5	0	\N
164445	2100	1434860000000	21515	10527	6	0	\N
164446	2100	2830000000	21515	10527	7	0	\N
164447	1547	21452745000000	21515	10527	8	0	\N
164448	1547	21165725000000	21515	10527	9	0	\N
164449	1547	18976705000000	21515	10527	10	0	\N
164450	1547	16329685000000	21515	10527	11	0	\N
164451	1547	12407665000000	21515	10527	12	0	\N
164452	1547	5034645000000	21515	10527	13	0	\N
164453	1426	15961288000000	21515	10527	14	0	\N
164454	1682	9331000000	21515	10527	15	0	\N
164455	1471	14856185900000	21515	10527	16	0	\N
164456	1932	1372908664093	21515	10527	17	0	\N
164457	885	63455021096354	21515	10527	18	0	\N
164458	1649	15758407999992	21515	10527	19	0	\N
164459	886	63455031096354	21515	10527	20	0	\N
164460	1426	10895278000000	21515	10527	21	0	\N
164461	1471	9790175900000	21515	10527	22	0	\N
164462	694	66522947693786	21515	10527	23	0	\N
164463	1649	10202397999992	21515	10527	24	0	\N
164464	1649	6453387999992	21515	10527	25	0	\N
164465	1649	3352377999992	21515	10527	26	0	\N
164466	1608	12149912000000	21515	10527	27	0	\N
164467	1608	7737612000000	21515	10527	28	0	\N
164468	1471	6372165900000	21515	10527	29	0	\N
164469	1850	14758111949999	21515	10527	30	0	\N
164470	1850	10395001949999	21515	10527	31	0	\N
164471	1850	7451091949999	21515	10527	32	0	\N
164472	1850	5016281949999	21515	10527	33	0	\N
164473	1608	4760542000000	21515	10527	34	0	\N
164474	1608	2298302000000	21515	10527	35	0	\N
164475	1756	3440720195609	21515	10527	36	0	\N
164476	1426	7477268000000	21515	10527	37	0	\N
164477	1426	4650258000000	21515	10527	38	0	\N
164478	1714	11638176439708	21515	10527	39	0	\N
164479	1714	9295374638556	21515	10527	40	0	\N
164480	1714	5823121253616	21515	10527	41	0	\N
164481	1714	3885466171760	21515	10527	42	0	\N
164482	1771	304905534083	21515	10527	43	0	\N
164483	1672	15791254000000	21515	10527	44	0	\N
164484	1672	9637244000000	21515	10527	45	0	\N
164485	1672	5484234000000	21515	10527	46	0	\N
164486	1672	2049224000000	21515	10527	47	0	\N
164487	1672	721214000000	21515	10527	48	0	\N
164488	1686	20078957869379	21515	10527	49	0	\N
164489	1686	19789762079363	21515	10527	50	0	\N
164490	1686	19500566289347	21515	10527	51	0	\N
164491	1686	17298647403647	21515	10527	52	0	\N
164492	1686	13352835546422	21515	10527	53	0	\N
164493	1686	10690514407697	21515	10527	54	0	\N
164494	1686	3271737700122	21515	10527	55	0	\N
164495	1686	3271727700122	21515	10527	56	0	\N
164496	1471	3545155900000	21515	10527	57	0	\N
164497	1932	1372906664093	21515	10527	58	0	\N
164498	1740	4050615000000	21515	10527	59	0	\N
164499	2247	648999000000	21515	10527	60	0	\N
164500	2134	95935835000	21515	10527	61	0	\N
164501	2134	94734835000	21515	10527	62	0	\N
164502	2134	93533835000	21515	10527	63	0	\N
164503	2134	92332835000	21515	10527	64	0	\N
164504	2134	91131835000	21515	10527	65	0	\N
164505	2134	89930835000	21515	10527	66	0	\N
164506	1514	700010030400	21515	10527	67	0	\N
164507	1514	9030400	21515	10527	68	0	\N
164508	694	66521946693786	21515	10527	69	0	\N
164509	694	66511945693786	21515	10527	70	0	\N
164510	1611	14581365550000	21515	10527	71	0	\N
164511	1611	10922654840000	21515	10527	72	0	\N
164512	1611	8454049500000	21515	10527	73	0	\N
164513	1611	1575063000000	21515	10527	74	0	\N
164514	1726	13309112000	21515	10527	75	0	\N
164515	1726	12108112000	21515	10527	76	0	\N
164516	1726	10907112000	21515	10527	77	0	\N
164517	1726	9706112000	21515	10527	78	0	\N
164518	694	66001944693786	21515	10527	79	0	\N
164519	1726	8505112000	21515	10527	80	0	\N
164520	1726	7304112000	21515	10527	81	0	\N
164521	1726	6103112000	21515	10527	82	0	\N
164522	1726	4902112000	21515	10527	83	0	\N
164523	1726	3701112000	21515	10527	84	0	\N
164524	1726	2500112000	21515	10527	85	0	\N
164525	1726	1299112000	21515	10527	86	0	\N
164526	1726	98112000	21515	10527	87	0	\N
164527	2134	89919835000	21515	10527	88	0	\N
164528	2134	88718835000	21515	10527	89	0	\N
164529	2134	88717832000	21515	10527	90	0	\N
164530	2134	87516832000	21515	10527	91	0	\N
164531	2134	87515829000	21515	10527	92	0	\N
164532	2134	87514826000	21515	10527	93	0	\N
164533	2134	87513823000	21515	10527	94	0	\N
164534	2134	87512820000	21515	10527	95	0	\N
164535	2134	87511817000	21515	10527	96	0	\N
164536	2134	87510814000	21515	10527	97	0	\N
164537	2134	87509811000	21515	10527	98	0	\N
164538	2134	87508808000	21515	10527	99	0	\N
164539	2134	87507805000	21515	10527	100	0	\N
164540	2134	87506802000	21515	10527	101	0	\N
164541	2134	87505799000	21515	10527	102	0	\N
164542	2134	87504796000	21515	10527	103	0	\N
164543	2134	87503793000	21515	10527	104	0	\N
164544	2134	87502790000	21515	10527	105	0	\N
164545	2134	87501787000	21515	10527	106	0	\N
164546	2134	87500784000	21515	10527	107	0	\N
164547	2134	87499781000	21515	10527	109	0	\N
164548	2134	87498778000	21515	10527	110	0	\N
164549	2134	87497775000	21515	10527	111	0	\N
164550	2134	87496772000	21515	10527	112	0	\N
164551	2134	87495769000	21515	10527	113	0	\N
164552	2134	87494766000	21515	10527	114	0	\N
164553	2134	87493763000	21515	10527	115	0	\N
164554	2134	87492760000	21515	10527	116	0	\N
164555	2134	87491757000	21515	10527	117	0	\N
164556	2134	87490754000	21515	10527	118	0	\N
164557	2134	87489751000	21515	10527	119	0	\N
164558	2134	87488748000	21515	10527	120	0	\N
164559	2134	87487745000	21515	10527	121	0	\N
164560	2134	87486742000	21515	10527	122	0	\N
164427	2134	87363373000	21511	10791	5	0	3217
164432	1397	1311557290000	21513	10792	0	0	12727
164433	2133	95876766000	21513	10792	1	0	3117
164434	2134	87362370000	21513	10792	2	0	3218
164435	2132	148019020000	21513	10792	3	0	980
164437	2134	87361367000	21514	10793	1	0	3219
164438	2133	95875764000	21514	10793	2	0	3118
164561	2134	87485739000	21515	10527	123	0	\N
164562	2134	87484736000	21515	10527	124	0	\N
164563	2134	87483733000	21515	10527	125	0	\N
164567	1397	1311527287000	21517	10795	0	0	\N
164568	2133	95873760000	21517	10795	1	0	\N
164569	2134	87359361000	21517	10795	2	0	\N
164570	1458	21390661908540	21518	10517	0	0	\N
164571	1458	18413461908540	21518	10517	1	0	\N
164572	1458	14001261908540	21518	10517	2	0	\N
164573	1458	5705061908540	21518	10517	3	0	\N
164574	1547	21452745000000	21518	10517	4	0	\N
164575	1547	21165725000000	21518	10517	5	0	\N
164576	1547	18976705000000	21518	10517	6	0	\N
164577	1547	16329685000000	21518	10517	7	0	\N
164578	1547	12407665000000	21518	10517	8	0	\N
164579	1547	5034645000000	21518	10517	9	0	\N
164580	885	63455021096354	21518	10517	10	0	\N
164581	886	63455031096354	21518	10517	11	0	\N
164582	694	66522947693786	21518	10517	12	0	\N
164583	1771	304905534083	21518	10517	13	0	\N
164584	1397	1314647599000	21518	10517	14	0	\N
164585	1397	1314637598000	21518	10517	15	0	\N
164586	1397	1314627597000	21518	10517	16	0	\N
164587	1397	1314617596000	21518	10517	17	0	\N
164588	1686	20078957869379	21518	10517	18	0	\N
164589	1686	19789762079363	21518	10517	19	0	\N
164590	1686	19500566289347	21518	10517	20	0	\N
164591	1686	17298647403647	21518	10517	21	0	\N
164592	1686	13352835546422	21518	10517	22	0	\N
164593	1686	10690514407697	21518	10517	23	0	\N
164594	1686	3271737700122	21518	10517	24	0	\N
164595	1686	3271727700122	21518	10517	25	0	\N
164596	1397	1314607595000	21518	10517	26	0	\N
164597	1397	1314597594000	21518	10517	27	0	\N
164598	1397	1314587593000	21518	10517	28	0	\N
164599	1397	1314577592000	21518	10517	29	0	\N
164600	1397	1314567591000	21518	10517	30	0	\N
164601	1397	1314557590000	21518	10517	31	0	\N
164602	1397	1314547589000	21518	10517	32	0	\N
164603	1397	1314537588000	21518	10517	33	0	\N
164604	1397	1314527587000	21518	10517	34	0	\N
164605	1397	1314517586000	21518	10517	35	0	\N
164606	1397	1314507585000	21518	10517	36	0	\N
164607	1397	1314497584000	21518	10517	37	0	\N
164608	1397	1314487583000	21518	10517	38	0	\N
164609	1397	1314477582000	21518	10517	39	0	\N
164610	1397	1314467581000	21518	10517	40	0	\N
164611	1397	1314457580000	21518	10517	41	0	\N
164612	1397	1314447579000	21518	10517	42	0	\N
164613	1397	1314437578000	21518	10517	43	0	\N
164614	1397	1314427577000	21518	10517	44	0	\N
164615	1397	1314417576000	21518	10517	45	0	\N
164616	1397	1314407575000	21518	10517	47	0	\N
164617	1397	1314397574000	21518	10517	48	0	\N
164618	1397	1314387573000	21518	10517	49	0	\N
164619	1397	1314377572000	21518	10517	50	0	\N
164620	1397	1314367571000	21518	10517	51	0	\N
164621	1397	1314357570000	21518	10517	52	0	\N
164622	1397	1314347569000	21518	10517	53	0	\N
164623	1397	1314337568000	21518	10517	54	0	\N
164624	1397	1314327567000	21518	10517	55	0	\N
164625	1397	1314317566000	21518	10517	56	0	\N
164626	1397	1314307565000	21518	10517	57	0	\N
164627	1397	1314297564000	21518	10517	58	0	\N
164628	1397	1314287563000	21518	10517	59	0	\N
164629	1397	1314277562000	21518	10517	60	0	\N
164630	1397	1314267561000	21518	10517	61	0	\N
164631	1397	1314257560000	21518	10517	62	0	\N
164632	1397	1314247559000	21518	10517	63	0	\N
164633	1397	1314237558000	21518	10517	64	0	\N
164634	1397	1314227557000	21518	10517	65	0	\N
164635	1397	1314217556000	21518	10517	66	0	\N
164636	1397	1314207555000	21518	10517	67	0	\N
164637	1397	1314197554000	21518	10517	68	0	\N
164638	1397	1314187553000	21518	10517	69	0	\N
164639	1397	1314177552000	21518	10517	70	0	\N
164640	1397	1314167551000	21518	10517	71	0	\N
164641	1397	1314157550000	21518	10517	72	0	\N
164642	1397	1314147549000	21518	10517	73	0	\N
164643	1397	1314137548000	21518	10517	74	0	\N
164644	1397	1314127547000	21518	10517	75	0	\N
164645	1397	1314117546000	21518	10517	76	0	\N
164646	1397	1314107545000	21518	10517	77	0	\N
164647	1397	1314097544000	21518	10517	78	0	\N
164648	1397	1314087543000	21518	10517	79	0	\N
164649	1397	1314077542000	21518	10517	80	0	\N
164650	1397	1314067541000	21518	10517	81	0	\N
164651	1397	1314057540000	21518	10517	82	0	\N
164652	1397	1314047539000	21518	10517	83	0	\N
164653	1397	1314037538000	21518	10517	84	0	\N
164654	1397	1314027537000	21518	10517	85	0	\N
164655	1397	1314017536000	21518	10517	86	0	\N
164656	1397	1314007535000	21518	10517	87	0	\N
164657	1397	1313997534000	21518	10517	88	0	\N
164658	1397	1313987533000	21518	10517	89	0	\N
164659	1397	1313977532000	21518	10517	90	0	\N
164660	1397	1313967531000	21518	10517	91	0	\N
164661	1397	1313957530000	21518	10517	92	0	\N
164662	1397	1313947529000	21518	10517	93	0	\N
164663	1397	1313937528000	21518	10517	94	0	\N
164664	1397	1313927527000	21518	10517	95	0	\N
164665	1397	1313917526000	21518	10517	96	0	\N
164666	1397	1313907525000	21518	10517	97	0	\N
164667	1397	1313897524000	21518	10517	98	0	\N
164668	1397	1313887523000	21518	10517	99	0	\N
164669	1397	1313877522000	21518	10517	100	0	\N
164670	1397	1313867521000	21518	10517	101	0	\N
164671	1397	1313857520000	21518	10517	102	0	\N
164672	1397	1313847519000	21518	10517	103	0	\N
164673	1397	1313837518000	21518	10517	104	0	\N
164674	1397	1313827517000	21518	10517	105	0	\N
164675	1397	1313817516000	21518	10517	106	0	\N
164676	1397	1313807515000	21518	10517	107	0	\N
164677	1397	1313797514000	21518	10517	108	0	\N
164678	1397	1313787513000	21518	10517	109	0	\N
164679	1397	1313777512000	21518	10517	110	0	\N
164680	1397	1313767511000	21518	10517	111	0	\N
164681	1397	1313757510000	21518	10517	112	0	\N
164682	1397	1313747509000	21518	10517	113	0	\N
164683	1397	1313737508000	21518	10517	114	0	\N
164684	1397	1313727507000	21518	10517	115	0	\N
164685	1397	1313717506000	21518	10517	116	0	\N
164686	1397	1313707505000	21518	10517	117	0	\N
164687	1397	1313697504000	21518	10517	118	0	\N
164688	1397	1313687503000	21518	10517	119	0	\N
164689	1397	1313677502000	21518	10517	120	0	\N
164690	1397	1313667501000	21518	10517	121	0	\N
164691	1397	1313657500000	21518	10517	122	0	\N
164692	1397	1313647499000	21518	10517	123	0	\N
164693	1397	1313637498000	21518	10517	124	0	\N
164694	1397	1313627497000	21518	10517	125	0	\N
164566	2134	87360364000	21516	10794	2	0	3220
164695	1397	1311527287000	21519	10795	0	0	12730
164696	2133	95873760000	21519	10795	1	0	3120
164702	1397	1311507285000	21521	10797	0	0	\N
164703	2133	95871756000	21521	10797	1	0	\N
164704	2134	87357355000	21521	10797	2	0	\N
164708	1397	1311507285000	21523	10797	0	0	\N
164709	2134	87357355000	21523	10797	1	0	\N
164710	1397	1311507285000	21524	10797	0	0	\N
164711	2133	95871756000	21524	10797	1	0	\N
164712	2134	87357355000	21524	10797	2	0	\N
164716	886	63455031096354	21526	10704	0	0	\N
164723	1397	1311467281000	21528	10800	0	0	\N
164724	2134	87353343000	21528	10800	1	0	\N
164725	1397	1311467281000	21529	10800	0	0	\N
164726	2134	87353343000	21529	10800	1	0	\N
164727	2133	95867748000	21529	10800	2	0	\N
164731	1397	1311457280000	21532	10801	0	0	\N
164732	2134	87352340000	21532	10801	1	0	\N
164733	2133	95866746000	21532	10801	2	0	\N
164734	1397	1311457280000	21533	10801	0	0	\N
164735	2134	87352340000	21533	10801	1	0	\N
164736	2133	95866746000	21533	10801	2	0	\N
164740	1397	1311457280000	21535	10801	0	0	\N
164741	2134	87352340000	21535	10801	1	0	\N
164742	2133	95866746000	21535	10801	2	0	\N
164743	1397	1311457280000	21536	10801	0	0	\N
164744	2134	87352340000	21536	10801	1	0	\N
164745	2133	95866746000	21536	10801	2	0	\N
164746	1397	1311447279000	21537	10802	0	0	\N
164747	2134	87351337000	21537	10802	1	0	\N
164748	2133	95865744000	21537	10802	2	0	\N
164749	885	63455021096354	21538	10774	0	0	\N
164753	1397	1311447279000	21540	10802	0	0	\N
164754	2133	95865744000	21540	10802	1	0	\N
164755	1458	22110672908540	21541	10622	0	0	\N
164756	1458	19133472908540	21541	10622	1	0	\N
164757	1458	14721272908540	21541	10622	2	0	\N
164758	1458	6425072908540	21541	10622	3	0	\N
164759	1547	21452745000000	21541	10622	4	0	\N
164760	1547	21165725000000	21541	10622	5	0	\N
164761	1547	18976705000000	21541	10622	6	0	\N
164762	1547	16329685000000	21541	10622	7	0	\N
164763	1547	12407665000000	21541	10622	8	0	\N
164764	1547	5034645000000	21541	10622	9	0	\N
164765	1426	15961288000000	21541	10622	10	0	\N
164766	1608	2298292000000	21541	10622	11	0	\N
164767	1397	1313997534000	21541	10622	12	0	\N
164768	1471	14856185900000	21541	10622	13	0	\N
164769	885	63455021096354	21541	10622	14	0	\N
164770	1649	15758407999992	21541	10622	15	0	\N
164771	886	63455031096354	21541	10622	16	0	\N
164772	1426	10895278000000	21541	10622	17	0	\N
164773	1471	9790175900000	21541	10622	18	0	\N
164774	694	66522947693786	21541	10622	19	0	\N
164775	1649	10202397999992	21541	10622	20	0	\N
164776	1649	6453387999992	21541	10622	21	0	\N
164777	1649	3352377999992	21541	10622	22	0	\N
164778	1471	6372165900000	21541	10622	23	0	\N
164779	1426	7477268000000	21541	10622	24	0	\N
164780	1426	4650258000000	21541	10622	25	0	\N
164781	1771	304905534083	21541	10622	26	0	\N
164782	1686	20078957869379	21541	10622	27	0	\N
164783	1686	19789762079363	21541	10622	28	0	\N
164784	1686	19500566289347	21541	10622	29	0	\N
164785	1686	17298647403647	21541	10622	30	0	\N
164786	1686	13352835546422	21541	10622	31	0	\N
164787	1686	10690514407697	21541	10622	32	0	\N
164788	1686	3271737700122	21541	10622	33	0	\N
164789	1686	3271727700122	21541	10622	34	0	\N
164790	1471	3545155900000	21541	10622	35	0	\N
164791	1932	1372906664093	21541	10622	36	0	\N
164792	1740	4050615000000	21541	10622	37	0	\N
164793	2133	96097206000	21541	10622	38	0	\N
164794	259	66009999000000	21541	10622	39	0	\N
164795	2132	148063064000	21541	10622	40	0	\N
164796	2247	648999000000	21541	10622	41	0	\N
164797	2134	95935835000	21541	10622	42	0	\N
164798	2134	94734835000	21541	10622	43	0	\N
164799	2134	93533835000	21541	10622	44	0	\N
164800	2134	92332835000	21541	10622	45	0	\N
164801	2134	91131835000	21541	10622	46	0	\N
164802	2134	89930835000	21541	10622	47	0	\N
164803	1514	700010030400	21541	10622	48	0	\N
164804	1514	9030400	21541	10622	49	0	\N
164805	694	66521946693786	21541	10622	50	0	\N
164806	2132	148062063000	21541	10622	51	0	\N
164807	2132	148061062000	21541	10622	52	0	\N
164808	2132	148060061000	21541	10622	53	0	\N
164809	2132	148059060000	21541	10622	54	0	\N
164810	2132	148058059000	21541	10622	55	0	\N
164811	2132	148057058000	21541	10622	56	0	\N
164812	694	66511945693786	21541	10622	57	0	\N
164813	1611	15301365550000	21541	10622	58	0	\N
164814	1611	11642654840000	21541	10622	59	0	\N
164815	1611	9174049500000	21541	10622	60	0	\N
164816	1611	2295063000000	21541	10622	61	0	\N
164817	1726	13309112000	21541	10622	62	0	\N
164818	1726	12108112000	21541	10622	63	0	\N
164819	1726	10907112000	21541	10622	64	0	\N
164820	1726	9706112000	21541	10622	65	0	\N
164821	694	66001944693786	21541	10622	66	0	\N
164822	2133	96096204000	21541	10622	67	0	\N
164823	1726	8505112000	21541	10622	68	0	\N
164824	1726	7304112000	21541	10622	69	0	\N
164825	1726	6103112000	21541	10622	70	0	\N
164826	1726	4902112000	21541	10622	71	0	\N
164827	1726	3701112000	21541	10622	72	0	\N
164828	1726	2500112000	21541	10622	73	0	\N
164829	1726	1299112000	21541	10622	74	0	\N
164830	1726	98112000	21541	10622	75	0	\N
164831	2132	148056057000	21541	10622	76	0	\N
164832	2132	148055056000	21541	10622	77	0	\N
164699	2133	95872758000	21520	10796	1	0	3121
164700	2134	87358358000	21520	10796	2	0	3222
164701	2132	148018019000	21520	10796	3	0	981
164705	1397	1311507285000	21522	10797	0	0	12732
164706	2133	95871756000	21522	10797	1	0	3122
164713	1397	1311497284000	21525	10798	0	0	12733
164714	2134	87356352000	21525	10798	1	0	3224
164715	2133	95870754000	21525	10798	2	0	3123
164717	1397	1311487283000	21527	10799	0	0	12734
164718	1397	1311477282000	21527	10799	1	0	12735
164720	2134	87354346000	21527	10799	3	0	3226
164721	2133	95869752000	21527	10799	4	0	3124
164722	2133	95868750000	21527	10799	5	0	3125
164728	1397	1311467281000	21530	10800	0	0	12736
164730	2133	95867748000	21530	10800	2	0	3126
164737	1397	1311457280000	21534	10801	0	0	12737
164738	2134	87352340000	21534	10801	1	0	3228
164739	2133	95866746000	21534	10801	2	0	3127
164750	1397	1311447279000	21539	10802	0	0	12738
164752	2133	95865744000	21539	10802	2	0	3128
164833	2132	148054055000	21541	10622	78	0	\N
164834	2132	148053054000	21541	10622	79	0	\N
164835	2132	148052053000	21541	10622	80	0	\N
164836	2132	148051052000	21541	10622	81	0	\N
164837	2134	89919835000	21541	10622	82	0	\N
164838	2134	88718835000	21541	10622	83	0	\N
164839	2134	88717832000	21541	10622	84	0	\N
164840	2134	87516832000	21541	10622	85	0	\N
164841	2134	87515829000	21541	10622	86	0	\N
164842	2134	87514826000	21541	10622	87	0	\N
164843	2134	87513823000	21541	10622	88	0	\N
164844	2134	87512820000	21541	10622	89	0	\N
164845	2134	87511817000	21541	10622	90	0	\N
164846	2134	87510814000	21541	10622	91	0	\N
164847	2134	87509811000	21541	10622	92	0	\N
164848	2134	87508808000	21541	10622	93	0	\N
164849	2134	87507805000	21541	10622	94	0	\N
164850	2134	87506802000	21541	10622	95	0	\N
164851	2134	87505799000	21541	10622	96	0	\N
164852	2134	87504796000	21541	10622	97	0	\N
164853	2134	87503793000	21541	10622	98	0	\N
164854	2134	87502790000	21541	10622	99	0	\N
164855	2134	87501787000	21541	10622	100	0	\N
164856	2134	87500784000	21541	10622	101	0	\N
164857	2134	87499781000	21541	10622	102	0	\N
164858	2134	87498778000	21541	10622	103	0	\N
164859	2134	87497775000	21541	10622	104	0	\N
164860	2134	87496772000	21541	10622	105	0	\N
164861	2134	87495769000	21541	10622	106	0	\N
164862	2134	87494766000	21541	10622	107	0	\N
164863	2134	87493763000	21541	10622	109	0	\N
164864	2134	87492760000	21541	10622	110	0	\N
164865	2134	87491757000	21541	10622	111	0	\N
164866	2134	87490754000	21541	10622	112	0	\N
164867	2134	87489751000	21541	10622	113	0	\N
164868	2134	87488748000	21541	10622	114	0	\N
164869	2134	87487745000	21541	10622	115	0	\N
164870	2134	87486742000	21541	10622	116	0	\N
164871	2134	87485739000	21541	10622	117	0	\N
164872	2134	87484736000	21541	10622	118	0	\N
164873	2134	87483733000	21541	10622	119	0	\N
164874	2134	87482730000	21541	10622	120	0	\N
164875	2134	87481727000	21541	10622	121	0	\N
164876	2134	87480724000	21541	10622	122	0	\N
164877	2134	87479721000	21541	10622	123	0	\N
164878	2134	87478718000	21541	10622	124	0	\N
164879	2134	87477715000	21541	10622	125	0	\N
164880	1397	1311437278000	21542	10803	0	0	\N
164881	1397	1311427277000	21542	10803	1	0	\N
164882	1397	1311417276000	21542	10803	2	0	\N
164883	2134	87351337000	21542	10803	3	0	\N
164884	2133	95864742000	21542	10803	4	0	\N
164885	2133	95863740000	21542	10803	5	0	\N
164886	2133	95862738000	21542	10803	6	0	\N
164887	2134	87350334000	21542	10803	7	0	\N
164888	2134	87349331000	21542	10803	8	0	\N
164889	2134	87348328000	21542	10803	9	0	\N
164890	2134	87351337000	21543	10803	0	0	\N
164891	2133	95864742000	21543	10803	1	0	\N
164892	2133	95863740000	21543	10803	2	0	\N
164893	2133	95862738000	21543	10803	3	0	\N
164894	2134	87350334000	21543	10803	4	0	\N
164895	2134	87349331000	21543	10803	5	0	\N
164896	2134	87348328000	21543	10803	6	0	\N
164909	1397	1311437278000	21546	10804	0	0	\N
164910	1397	1311427277000	21546	10804	1	0	\N
164911	1397	1311417276000	21546	10804	2	0	\N
164912	1397	1311407275000	21548	10804	0	0	\N
164913	2133	95861736000	21548	10804	1	0	\N
164921	2133	95857728000	21552	10807	0	0	\N
164922	2134	87344316000	21552	10807	1	0	\N
164923	2133	95857728000	21553	10807	0	0	\N
164924	2134	87344316000	21553	10807	1	0	\N
164925	1547	22892809000000	21554	10725	0	0	\N
164926	1547	22605789000000	21554	10725	1	0	\N
164927	1547	20416769000000	21554	10725	2	0	\N
164928	1547	17769749000000	21554	10725	3	0	\N
164929	1547	13847729000000	21554	10725	4	0	\N
164930	1547	6474709000000	21554	10725	5	0	\N
164931	1397	1312487383000	21554	10725	6	0	\N
164932	1397	1312477382000	21554	10725	7	0	\N
164933	885	63455021096354	21554	10725	8	0	\N
164934	886	63455031096354	21554	10725	9	0	\N
164935	694	66522947693786	21554	10725	10	0	\N
164936	1397	1312467381000	21554	10725	11	0	\N
164937	1397	1312457380000	21554	10725	12	0	\N
164938	1397	1312447379000	21554	10725	13	0	\N
164939	1397	1312437378000	21554	10725	14	0	\N
164940	1397	1312427377000	21554	10725	15	0	\N
164941	1397	1312417376000	21554	10725	16	0	\N
164942	1397	1312407375000	21554	10725	17	0	\N
164943	1397	1312397374000	21554	10725	18	0	\N
164944	1397	1312387373000	21554	10725	19	0	\N
164945	1397	1312377372000	21554	10725	20	0	\N
164946	1397	1312367371000	21554	10725	21	0	\N
164947	1771	304905534083	21554	10725	22	0	\N
164948	1397	1312357370000	21554	10725	23	0	\N
164949	1397	1312347369000	21554	10725	24	0	\N
164950	1397	1312337368000	21554	10725	25	0	\N
164951	1397	1312327367000	21554	10725	26	0	\N
164952	1397	1312317366000	21554	10725	27	0	\N
164953	1686	20798970869379	21554	10725	28	0	\N
164954	1686	20509775079363	21554	10725	29	0	\N
164955	1686	20220579289347	21554	10725	30	0	\N
164956	1686	18018660403647	21554	10725	31	0	\N
164957	1686	14072848546422	21554	10725	32	0	\N
164958	1686	11410527407697	21554	10725	33	0	\N
164959	1686	3991750700122	21554	10725	34	0	\N
164960	1686	3991740700122	21554	10725	35	0	\N
164961	1397	1312307365000	21554	10725	36	0	\N
164962	1397	1312297364000	21554	10725	37	0	\N
164963	1397	1312287363000	21554	10725	38	0	\N
164964	1397	1312277362000	21554	10725	39	0	\N
164965	1397	1312267361000	21554	10725	40	0	\N
164966	1397	1312257360000	21554	10725	41	0	\N
164967	1397	1312247359000	21554	10725	42	0	\N
164968	1397	1312237358000	21554	10725	43	0	\N
164899	1397	1311417276000	21544	10803	2	0	12741
164900	2133	95864742000	21544	10803	3	0	3129
164901	2133	95863740000	21544	10803	4	0	3130
164902	2133	95862738000	21544	10803	5	0	3131
164903	2134	87350334000	21544	10803	6	0	3230
164905	2134	87348328000	21544	10803	8	0	3232
164906	1397	1311407275000	21545	10804	0	0	12742
164907	2134	87347325000	21545	10804	1	0	3233
164908	2133	95861736000	21545	10804	2	0	3132
164914	2133	95860734000	21549	10805	0	0	3133
164916	2133	95859732000	21550	10806	0	0	3134
164917	2133	95858730000	21550	10806	1	0	3135
164918	2134	87345319000	21550	10806	2	0	3235
164919	2133	95857728000	21551	10807	0	0	3136
164969	1397	1312227357000	21554	10725	44	0	\N
164970	1397	1312217356000	21554	10725	45	0	\N
164971	1397	1312207355000	21554	10725	46	0	\N
164972	1397	1312197354000	21554	10725	47	0	\N
164973	1397	1312187353000	21554	10725	48	0	\N
164974	1397	1312177352000	21554	10725	49	0	\N
164975	1397	1312167351000	21554	10725	50	0	\N
164976	1397	1312157350000	21554	10725	51	0	\N
164977	1397	1312147349000	21554	10725	52	0	\N
164978	1397	1312137348000	21554	10725	53	0	\N
164979	1397	1312127347000	21554	10725	54	0	\N
164980	1397	1312117346000	21554	10725	55	0	\N
164981	1397	1312107345000	21554	10725	56	0	\N
164982	1397	1312097344000	21554	10725	57	0	\N
164983	1397	1312087343000	21554	10725	58	0	\N
164984	1397	1312077342000	21554	10725	59	0	\N
164985	1397	1312067341000	21554	10725	60	0	\N
164986	1397	1312057340000	21554	10725	61	0	\N
164987	1397	1312047339000	21554	10725	62	0	\N
164988	1397	1312037338000	21554	10725	63	0	\N
164989	1397	1312027337000	21554	10725	64	0	\N
164990	1397	1312017336000	21554	10725	65	0	\N
164991	1397	1312007335000	21554	10725	66	0	\N
164992	1397	1311997334000	21554	10725	67	0	\N
164993	1397	1311987333000	21554	10725	68	0	\N
164994	1397	1311977332000	21554	10725	69	0	\N
164995	1397	1311967331000	21554	10725	70	0	\N
164996	1397	1311957330000	21554	10725	71	0	\N
164997	1397	1311947329000	21554	10725	72	0	\N
164998	1397	1311937328000	21554	10725	73	0	\N
164999	1397	1311927327000	21554	10725	74	0	\N
165000	1397	1311917326000	21554	10725	75	0	\N
165001	1397	1311907325000	21554	10725	76	0	\N
165002	1397	1311897324000	21554	10725	77	0	\N
165003	1397	1311887323000	21554	10725	78	0	\N
165004	1397	1311877322000	21554	10725	79	0	\N
165005	1397	1311867321000	21554	10725	80	0	\N
165006	1397	1311857320000	21554	10725	81	0	\N
165007	1397	1311847319000	21554	10725	82	0	\N
165008	1397	1311837318000	21554	10725	83	0	\N
165009	1397	1311827317000	21554	10725	84	0	\N
165010	1397	1311817316000	21554	10725	85	0	\N
165011	1397	1311807315000	21554	10725	86	0	\N
165012	1397	1311797314000	21554	10725	87	0	\N
165013	1397	1311787313000	21554	10725	88	0	\N
165014	1397	1311777312000	21554	10725	89	0	\N
165015	1397	1311767311000	21554	10725	90	0	\N
165016	1397	1311757310000	21554	10725	91	0	\N
165017	1397	1311747309000	21554	10725	92	0	\N
165018	1397	1311737308000	21554	10725	93	0	\N
165019	1397	1311727307000	21554	10725	94	0	\N
165020	1397	1311717306000	21554	10725	95	0	\N
165021	1397	1311707305000	21554	10725	96	0	\N
165022	1397	1311697304000	21554	10725	97	0	\N
165023	1397	1311687303000	21554	10725	98	0	\N
165024	1397	1311677302000	21554	10725	99	0	\N
165025	1397	1311667301000	21554	10725	100	0	\N
165026	1397	1311657300000	21554	10725	101	0	\N
165027	1397	1311647299000	21554	10725	102	0	\N
165028	1397	1311637298000	21554	10725	103	0	\N
165029	1397	1311627297000	21554	10725	104	0	\N
165030	1397	1311617296000	21554	10725	105	0	\N
165031	1397	1311607295000	21554	10725	106	0	\N
165032	1397	1311597294000	21554	10725	107	0	\N
165033	1397	1311587293000	21554	10725	108	0	\N
165034	1397	1311577292000	21554	10725	110	0	\N
165035	1397	1311567291000	21554	10725	111	0	\N
165036	1397	1311557290000	21554	10725	112	0	\N
165037	1397	1311547289000	21554	10725	113	0	\N
165038	1397	1311537288000	21554	10725	114	0	\N
165039	1397	1311527287000	21554	10725	115	0	\N
165040	1397	1311517286000	21554	10725	116	0	\N
165041	1397	1311507285000	21554	10725	117	0	\N
165042	1397	1311497284000	21554	10725	118	0	\N
165043	1397	1311487283000	21554	10725	119	0	\N
165044	1397	1311477282000	21554	10725	120	0	\N
165045	1397	1311467281000	21554	10725	121	0	\N
165046	1397	1311457280000	21554	10725	122	0	\N
165047	1397	1311447279000	21554	10725	123	0	\N
165048	1397	1311437278000	21554	10725	124	0	\N
165049	1397	1311427277000	21554	10725	125	0	\N
165053	1397	1311387273000	21556	10809	0	0	\N
165054	2134	87342310000	21556	10809	1	0	\N
165055	2133	95855724000	21556	10809	2	0	\N
165062	1397	1311377272000	21559	10810	0	0	\N
165063	2133	95854722000	21559	10810	1	0	\N
165064	2134	87341307000	21559	10810	2	0	\N
165068	1397	1311357270000	21561	10812	0	0	\N
165069	2134	87339301000	21561	10812	1	0	\N
165070	2133	95852718000	21561	10812	2	0	\N
165071	1397	1311357270000	21562	10812	0	0	\N
165072	2134	87339301000	21562	10812	1	0	\N
165073	2133	95852718000	21562	10812	2	0	\N
165080	1397	1311347269000	21565	10813	0	0	\N
165081	2133	95852718000	21565	10813	1	0	\N
165082	2133	95851716000	21565	10813	2	0	\N
165083	2134	87338298000	21565	10813	3	0	\N
165084	1397	1311347269000	21566	10813	0	0	\N
165085	2133	95852718000	21566	10813	1	0	\N
165086	2133	95851716000	21566	10813	2	0	\N
165087	2134	87338298000	21566	10813	3	0	\N
165090	1397	1311337268000	21568	10814	0	0	\N
165091	2134	87337295000	21568	10814	1	0	\N
165092	2133	95850714000	21568	10814	2	0	\N
165093	1397	1311337268000	21569	10814	0	0	\N
165094	2134	87337295000	21569	10814	1	0	\N
165095	2133	95850714000	21569	10814	2	0	\N
165096	1397	1311337268000	21570	10814	0	0	\N
165097	2134	87337295000	21570	10814	1	0	\N
165098	2133	95850714000	21570	10814	2	0	\N
165099	2134	87337295000	21571	10814	0	0	\N
165100	2133	95850714000	21571	10814	1	0	\N
165052	2133	95856726000	21555	10808	2	0	3137
165056	1397	1311387273000	21557	10809	0	0	12744
165057	2134	87342310000	21557	10809	1	0	3238
165058	2133	95855724000	21557	10809	2	0	3138
165059	1397	1311377272000	21558	10810	0	0	12745
165061	2134	87341307000	21558	10810	2	0	3239
165065	1397	1311367271000	21560	10811	0	0	12746
165066	2133	95853720000	21560	10811	1	0	3140
165067	2134	87340304000	21560	10811	2	0	3240
165074	1397	1311357270000	21563	10812	0	0	12747
165076	1397	1311347269000	21564	10813	0	0	12748
165077	2133	95852718000	21564	10813	1	0	3141
165078	2133	95851716000	21564	10813	2	0	3142
165079	2134	87338298000	21564	10813	3	0	3242
165089	2134	87337295000	21567	10814	1	0	3243
165101	1397	1311327267000	21572	10815	0	0	12750
165102	2134	87336292000	21572	10815	1	0	3244
165103	2133	95850714000	21572	10815	2	0	3143
165104	2133	95849712000	21572	10815	3	0	3144
165108	1397	1311337268000	21574	10814	0	0	\N
165109	1397	1311327267000	21574	10814	1	0	\N
165110	2134	87337295000	21574	10814	2	0	\N
165111	2134	87336292000	21574	10814	3	0	\N
165112	2133	95850714000	21574	10814	4	0	\N
165113	2133	95849712000	21574	10814	5	0	\N
165117	1397	1311307265000	21576	10817	0	0	\N
165118	2134	87334286000	21576	10817	1	0	\N
165119	2133	95847708000	21576	10817	2	0	\N
165120	1397	1311307265000	21577	10817	0	0	\N
165121	2134	87334286000	21577	10817	1	0	\N
165122	2133	95847708000	21577	10817	2	0	\N
165124	1397	1311297264000	21579	10818	0	0	\N
165125	2134	87333283000	21579	10818	1	0	\N
165126	2133	95846706000	21579	10818	2	0	\N
165127	1397	1311317266000	21580	10815	0	0	\N
165128	1397	1311307265000	21580	10815	1	0	\N
165129	2133	95848710000	21580	10815	2	0	\N
165130	2134	87335289000	21580	10815	3	0	\N
165131	2134	87334286000	21580	10815	4	0	\N
165132	2133	95847708000	21580	10815	5	0	\N
165133	2134	87333283000	21580	10815	6	0	\N
165134	2133	95846706000	21580	10815	7	0	\N
165136	1397	1311277262000	21582	10820	0	0	\N
165137	1397	1311267261000	21582	10820	1	0	\N
165138	2134	87333283000	21582	10820	2	0	\N
165139	2284	199000000	21582	10820	3	0	\N
165140	2134	87332280000	21582	10820	4	0	\N
165141	2134	87331277000	21582	10820	5	0	\N
165142	2134	87330274000	21582	10820	6	0	\N
165143	2133	95846706000	21582	10820	7	0	\N
165144	2133	95845704000	21582	10820	8	0	\N
165145	2133	95844702000	21582	10820	9	0	\N
165146	2133	95843700000	21582	10820	10	0	\N
165161	1397	1311257260000	21585	10821	0	0	\N
165162	2133	95842698000	21585	10821	1	0	\N
165163	2134	87329271000	21585	10821	2	0	\N
165167	1397	1311237258000	21587	10823	0	0	\N
165168	2133	95840694000	21587	10823	1	0	\N
165169	2134	87327265000	21587	10823	2	0	\N
165173	1397	1311237258000	21589	10823	0	0	\N
165174	2133	95840694000	21589	10823	1	0	\N
165175	2134	87327265000	21589	10823	2	0	\N
165183	1458	22110672908540	21591	10574	0	0	\N
165184	1458	19133472908540	21591	10574	1	0	\N
165185	1458	14721272908540	21591	10574	2	0	\N
165186	1458	6425072908540	21591	10574	3	0	\N
165187	1547	21452745000000	21591	10574	4	0	\N
165188	1547	21165725000000	21591	10574	5	0	\N
165189	1547	18976705000000	21591	10574	6	0	\N
165190	1547	16329685000000	21591	10574	7	0	\N
165191	1547	12407665000000	21591	10574	8	0	\N
165192	1547	5034645000000	21591	10574	9	0	\N
165193	885	63455021096354	21591	10574	10	0	\N
165194	886	63455031096354	21591	10574	11	0	\N
165195	694	66522947693786	21591	10574	12	0	\N
165196	1771	304905534083	21591	10574	13	0	\N
165197	1686	20078957869379	21591	10574	14	0	\N
165198	1686	19789762079363	21591	10574	15	0	\N
165199	1686	19500566289347	21591	10574	16	0	\N
165200	1686	17298647403647	21591	10574	17	0	\N
165201	1686	13352835546422	21591	10574	18	0	\N
165202	1686	10690514407697	21591	10574	19	0	\N
165203	1686	3271737700122	21591	10574	20	0	\N
165204	1686	3271727700122	21591	10574	21	0	\N
165205	1397	1313597494000	21591	10574	22	0	\N
165206	1397	1313587493000	21591	10574	23	0	\N
165207	1397	1313577492000	21591	10574	24	0	\N
165208	1397	1313567491000	21591	10574	25	0	\N
165209	1397	1313557490000	21591	10574	26	0	\N
165210	1397	1313547489000	21591	10574	27	0	\N
165211	1397	1313537488000	21591	10574	28	0	\N
165212	1397	1313527487000	21591	10574	29	0	\N
165213	1397	1313517486000	21591	10574	30	0	\N
165214	1397	1313507485000	21591	10574	31	0	\N
165215	1397	1313497484000	21591	10574	32	0	\N
165216	1397	1313487483000	21591	10574	33	0	\N
165217	1397	1313477482000	21591	10574	34	0	\N
165218	1397	1313467481000	21591	10574	35	0	\N
165219	1397	1313457480000	21591	10574	36	0	\N
165220	1397	1313447479000	21591	10574	37	0	\N
165221	1397	1313437478000	21591	10574	38	0	\N
165222	1397	1313427477000	21591	10574	39	0	\N
165223	1397	1313417476000	21591	10574	40	0	\N
165224	1397	1313407475000	21591	10574	41	0	\N
165225	1397	1313397474000	21591	10574	42	0	\N
165226	1397	1313387473000	21591	10574	43	0	\N
165227	1397	1313377472000	21591	10574	44	0	\N
165228	1397	1313367471000	21591	10574	45	0	\N
165229	1397	1313357470000	21591	10574	46	0	\N
165230	1397	1313347469000	21591	10574	47	0	\N
165231	1397	1313337468000	21591	10574	48	0	\N
165232	1397	1313327467000	21591	10574	49	0	\N
165233	1397	1313317466000	21591	10574	50	0	\N
165234	1397	1313307465000	21591	10574	51	0	\N
165235	1397	1313297464000	21591	10574	52	0	\N
165236	1397	1313287463000	21591	10574	53	0	\N
165237	1397	1313277462000	21591	10574	54	0	\N
165238	1397	1313267461000	21591	10574	55	0	\N
165239	1397	1313257460000	21591	10574	56	0	\N
165240	1397	1313247459000	21591	10574	57	0	\N
165107	2134	87335289000	21573	10816	2	0	3245
165114	1397	1311307265000	21575	10817	0	0	12752
165115	2134	87334286000	21575	10817	1	0	3246
165116	2133	95847708000	21575	10817	2	0	3146
165123	1397	1311297264000	21578	10818	0	0	12753
165147	1397	1311277262000	21583	10820	0	0	12755
165148	1397	1311267261000	21583	10820	1	0	12756
165149	2134	87333283000	21583	10820	2	0	3247
165150	2284	199000000	21583	10820	3	0	1
165151	2134	87332280000	21583	10820	4	0	3248
165153	2134	87330274000	21583	10820	6	0	3250
165154	2133	95846706000	21583	10820	7	0	3147
165155	2133	95845704000	21583	10820	8	0	3148
165156	2133	95844702000	21583	10820	9	0	3149
165158	1397	1311257260000	21584	10821	0	0	12757
165159	2133	95842698000	21584	10821	1	0	3151
165160	2134	87329271000	21584	10821	2	0	3251
165164	1397	1311247259000	21586	10822	0	0	12758
165165	2133	95841696000	21586	10822	1	0	3152
165170	1397	1311237258000	21588	10823	0	0	12759
165171	2133	95840694000	21588	10823	1	0	3153
165172	2134	87327265000	21588	10823	2	0	3253
165176	1397	1311227257000	21590	10824	0	0	12760
165177	1397	1311217256000	21590	10824	1	0	12761
165179	2134	87325259000	21590	10824	3	0	3255
165180	2133	95839692000	21590	10824	5	0	3154
165181	2133	95838690000	21590	10824	6	0	3155
165182	2284	198000000	21590	10824	7	0	2
165241	1397	1313237458000	21591	10574	58	0	\N
165242	1397	1313227457000	21591	10574	59	0	\N
165243	1397	1313217456000	21591	10574	60	0	\N
165244	1397	1313207455000	21591	10574	61	0	\N
165245	1397	1313197454000	21591	10574	62	0	\N
165246	1397	1313187453000	21591	10574	63	0	\N
165247	1397	1313177452000	21591	10574	64	0	\N
165248	1397	1313167451000	21591	10574	65	0	\N
165249	1397	1313157450000	21591	10574	66	0	\N
165250	1397	1313147449000	21591	10574	67	0	\N
165251	1397	1313137448000	21591	10574	68	0	\N
165252	1397	1313127447000	21591	10574	69	0	\N
165253	1397	1313117446000	21591	10574	70	0	\N
165254	1397	1313107445000	21591	10574	71	0	\N
165255	1397	1313097444000	21591	10574	72	0	\N
165256	1397	1313087443000	21591	10574	73	0	\N
165257	1397	1313077442000	21591	10574	74	0	\N
165258	1397	1313067441000	21591	10574	75	0	\N
165259	1397	1313057440000	21591	10574	76	0	\N
165260	1397	1313047439000	21591	10574	77	0	\N
165261	1397	1313037438000	21591	10574	78	0	\N
165262	1397	1313027437000	21591	10574	79	0	\N
165263	1397	1313017436000	21591	10574	80	0	\N
165264	1397	1313007435000	21591	10574	81	0	\N
165265	1397	1312997434000	21591	10574	82	0	\N
165266	1397	1312987433000	21591	10574	83	0	\N
165267	1397	1312977432000	21591	10574	84	0	\N
165268	1397	1312967431000	21591	10574	85	0	\N
165269	1397	1312957430000	21591	10574	86	0	\N
165270	1397	1312947429000	21591	10574	87	0	\N
165271	1397	1312937428000	21591	10574	88	0	\N
165272	1397	1312927427000	21591	10574	89	0	\N
165273	1397	1312917426000	21591	10574	90	0	\N
165274	1397	1312907425000	21591	10574	91	0	\N
165275	1397	1312897424000	21591	10574	92	0	\N
165276	1397	1312887423000	21591	10574	93	0	\N
165277	1397	1312877422000	21591	10574	94	0	\N
165278	1397	1312867421000	21591	10574	95	0	\N
165279	1397	1312857420000	21591	10574	96	0	\N
165280	1397	1312847419000	21591	10574	97	0	\N
165281	1397	1312837418000	21591	10574	98	0	\N
165282	1397	1312827417000	21591	10574	99	0	\N
165283	1397	1312817416000	21591	10574	100	0	\N
165284	1397	1312807415000	21591	10574	101	0	\N
165285	1397	1312797414000	21591	10574	102	0	\N
165286	1397	1312787413000	21591	10574	103	0	\N
165287	1397	1312777412000	21591	10574	104	0	\N
165288	1397	1312767411000	21591	10574	105	0	\N
165289	1397	1312757410000	21591	10574	107	0	\N
165290	1397	1312747409000	21591	10574	108	0	\N
165291	1397	1312737408000	21591	10574	109	0	\N
165292	1397	1312727407000	21591	10574	110	0	\N
165293	1397	1312717406000	21591	10574	111	0	\N
165294	1397	1312707405000	21591	10574	112	0	\N
165295	1397	1312697404000	21591	10574	113	0	\N
165296	1397	1312687403000	21591	10574	114	0	\N
165297	1397	1312677402000	21591	10574	115	0	\N
165298	1397	1312667401000	21591	10574	116	0	\N
165299	1397	1312657400000	21591	10574	117	0	\N
165300	1397	1312647399000	21591	10574	118	0	\N
165301	1397	1312637398000	21591	10574	119	0	\N
165302	1397	1312627397000	21591	10574	120	0	\N
165303	1397	1312617396000	21591	10574	121	0	\N
165304	1397	1312607395000	21591	10574	122	0	\N
165305	1397	1312597394000	21591	10574	123	0	\N
165306	1397	1312587393000	21591	10574	124	0	\N
165307	1397	1312577392000	21591	10574	125	0	\N
165308	1397	1311227257000	21592	10824	0	0	\N
165309	1397	1311217256000	21592	10824	1	0	\N
165310	2134	87326262000	21592	10824	2	0	\N
165311	2134	87325259000	21592	10824	3	0	\N
165312	2133	95839692000	21592	10824	5	0	\N
165313	2133	95838690000	21592	10824	6	0	\N
165314	2284	198000000	21592	10824	7	0	\N
165315	1397	1311207255000	21593	10825	0	0	\N
165316	1397	1311197254000	21593	10825	1	0	\N
165317	2133	95837688000	21593	10825	2	0	\N
165318	2133	95836686000	21593	10825	3	0	\N
165319	2134	87324256000	21593	10825	4	0	\N
165320	2134	87323253000	21593	10825	5	0	\N
165321	2284	199000000	21594	10705	0	0	\N
165322	2284	198000000	21594	10705	1	0	\N
165329	1397	1311207255000	21596	10825	0	0	\N
165330	1397	1311197254000	21596	10825	1	0	\N
165331	2133	95837688000	21596	10825	2	0	\N
165332	2133	95836686000	21596	10825	3	0	\N
165333	2134	87324256000	21596	10825	4	0	\N
165334	2134	87323253000	21596	10825	5	0	\N
165338	1397	1311187253000	21598	10826	0	0	\N
165339	2133	95835684000	21598	10826	1	0	\N
165340	2134	87322250000	21598	10826	2	0	\N
165341	1397	1311177252000	21599	10827	0	0	\N
165342	2134	87321247000	21599	10827	1	0	\N
165343	2133	95834682000	21599	10827	2	0	\N
165347	1397	1311177252000	21601	10827	0	0	\N
165348	2134	87321247000	21601	10827	1	0	\N
165349	2133	95834682000	21601	10827	2	0	\N
165350	1397	1311177252000	21602	10827	0	0	\N
165351	2134	87321247000	21602	10827	1	0	\N
165352	2133	95834682000	21602	10827	2	0	\N
165353	1397	1311167251000	21603	10828	0	0	\N
165354	2133	95833680000	21603	10828	1	0	\N
165355	1397	1311167251000	21604	10828	0	0	\N
165356	2134	87320244000	21604	10828	1	0	\N
165357	2133	95833680000	21604	10828	2	0	\N
165358	1397	1311167251000	21605	10828	0	0	\N
165359	2134	87320244000	21605	10828	1	0	\N
165360	2133	95833680000	21605	10828	2	0	\N
165365	1397	1311157250000	21609	10829	0	0	\N
165366	2133	95832678000	21609	10829	1	0	\N
165367	2134	87319241000	21609	10829	2	0	\N
165373	1397	1311137248000	21611	10831	0	0	\N
165374	2134	87317235000	21611	10831	1	0	\N
165375	2133	95830674000	21611	10831	2	0	\N
165325	2133	95837688000	21595	10825	2	0	3156
165326	2133	95836686000	21595	10825	3	0	3157
165327	2134	87324256000	21595	10825	4	0	3256
165328	2134	87323253000	21595	10825	5	0	3257
165335	1397	1311187253000	21597	10826	0	0	12764
165337	2134	87322250000	21597	10826	2	0	3258
165344	1397	1311177252000	21600	10827	0	0	12765
165345	2134	87321247000	21600	10827	1	0	3259
165346	2133	95834682000	21600	10827	2	0	3159
165361	1397	1311167251000	21607	10828	0	0	12766
165363	2133	95833680000	21607	10828	2	0	3160
165364	1397	1311157250000	21608	10829	0	0	12767
165368	1397	1311147249000	21610	10830	0	0	12768
165369	2133	95832678000	21610	10830	1	0	3161
165371	2134	87319241000	21610	10830	3	0	3261
165372	2134	87318238000	21610	10830	4	0	3262
165376	1397	1311137248000	21612	10831	0	0	12769
165379	1397	1311127247000	21613	10832	0	0	\N
165380	2133	95829672000	21613	10832	1	0	\N
165381	2134	87316232000	21613	10832	2	0	\N
165385	1397	1311117246000	21615	10833	0	0	\N
165386	2134	87315229000	21615	10833	1	0	\N
165387	2133	95828670000	21615	10833	2	0	\N
165391	1397	1311117246000	21617	10833	0	0	\N
165392	2134	87315229000	21617	10833	1	0	\N
165393	2133	95828670000	21617	10833	2	0	\N
165394	1547	22892809000000	21618	10716	0	0	\N
165395	1547	22605789000000	21618	10716	1	0	\N
165396	1547	20416769000000	21618	10716	2	0	\N
165397	1547	17769749000000	21618	10716	3	0	\N
165398	1547	13847729000000	21618	10716	4	0	\N
165399	1547	6474709000000	21618	10716	5	0	\N
165400	885	63455021096354	21618	10716	6	0	\N
165401	886	63455031096354	21618	10716	7	0	\N
165402	694	66522947693786	21618	10716	8	0	\N
165403	1397	1312677402000	21618	10716	9	0	\N
165404	1771	304905534083	21618	10716	10	0	\N
165405	1397	1312667401000	21618	10716	11	0	\N
165406	1397	1312657400000	21618	10716	12	0	\N
165407	1397	1312647399000	21618	10716	13	0	\N
165408	1397	1312637398000	21618	10716	14	0	\N
165409	1397	1312627397000	21618	10716	15	0	\N
165410	1397	1312617396000	21618	10716	16	0	\N
165411	1397	1312607395000	21618	10716	17	0	\N
165412	1397	1312597394000	21618	10716	18	0	\N
165413	1397	1312587393000	21618	10716	19	0	\N
165414	1397	1312577392000	21618	10716	20	0	\N
165415	1397	1312567391000	21618	10716	21	0	\N
165416	1397	1312557390000	21618	10716	22	0	\N
165417	1397	1312547389000	21618	10716	23	0	\N
165418	1397	1312537388000	21618	10716	24	0	\N
165419	1397	1312527387000	21618	10716	25	0	\N
165420	1397	1312517386000	21618	10716	26	0	\N
165421	1397	1312507385000	21618	10716	27	0	\N
165422	1397	1312497384000	21618	10716	28	0	\N
165423	1397	1312487383000	21618	10716	29	0	\N
165424	1397	1312477382000	21618	10716	30	0	\N
165425	1397	1312467381000	21618	10716	31	0	\N
165426	1397	1312457380000	21618	10716	32	0	\N
165427	1397	1312447379000	21618	10716	33	0	\N
165428	1397	1312437378000	21618	10716	34	0	\N
165429	1397	1312427377000	21618	10716	35	0	\N
165430	1397	1312417376000	21618	10716	36	0	\N
165431	1397	1312407375000	21618	10716	37	0	\N
165432	1397	1312397374000	21618	10716	38	0	\N
165433	1397	1312387373000	21618	10716	39	0	\N
165434	1397	1312377372000	21618	10716	40	0	\N
165435	1397	1312367371000	21618	10716	41	0	\N
165436	1397	1312357370000	21618	10716	42	0	\N
165437	1397	1312347369000	21618	10716	43	0	\N
165438	1397	1312337368000	21618	10716	44	0	\N
165439	1397	1312327367000	21618	10716	45	0	\N
165440	1397	1312317366000	21618	10716	46	0	\N
165441	1686	20798970869379	21618	10716	47	0	\N
165442	1686	20509775079363	21618	10716	48	0	\N
165443	1686	20220579289347	21618	10716	49	0	\N
165444	1686	18018660403647	21618	10716	50	0	\N
165445	1686	14072848546422	21618	10716	51	0	\N
165446	1686	11410527407697	21618	10716	52	0	\N
165447	1686	3991750700122	21618	10716	53	0	\N
165448	1686	3991740700122	21618	10716	54	0	\N
165449	1397	1312307365000	21618	10716	55	0	\N
165450	1397	1312297364000	21618	10716	56	0	\N
165451	1397	1312287363000	21618	10716	57	0	\N
165452	1397	1312277362000	21618	10716	58	0	\N
165453	1397	1312267361000	21618	10716	59	0	\N
165454	1397	1312257360000	21618	10716	60	0	\N
165455	1397	1312247359000	21618	10716	61	0	\N
165456	1397	1312237358000	21618	10716	63	0	\N
165457	1397	1312227357000	21618	10716	64	0	\N
165458	1397	1312217356000	21618	10716	65	0	\N
165459	1397	1312207355000	21618	10716	66	0	\N
165460	1397	1312197354000	21618	10716	67	0	\N
165461	1397	1312187353000	21618	10716	68	0	\N
165462	1397	1312177352000	21618	10716	69	0	\N
165463	1397	1312167351000	21618	10716	70	0	\N
165464	1397	1312157350000	21618	10716	71	0	\N
165465	1397	1312147349000	21618	10716	72	0	\N
165466	1397	1312137348000	21618	10716	73	0	\N
165467	1397	1312127347000	21618	10716	74	0	\N
165468	1397	1312117346000	21618	10716	75	0	\N
165469	1397	1312107345000	21618	10716	76	0	\N
165470	1397	1312097344000	21618	10716	77	0	\N
165471	1397	1312087343000	21618	10716	78	0	\N
165472	1397	1312077342000	21618	10716	79	0	\N
165473	1397	1312067341000	21618	10716	80	0	\N
165474	1397	1312057340000	21618	10716	81	0	\N
165475	1397	1312047339000	21618	10716	82	0	\N
165476	1397	1312037338000	21618	10716	83	0	\N
165477	1397	1312027337000	21618	10716	84	0	\N
165478	1397	1312017336000	21618	10716	85	0	\N
165479	1397	1312007335000	21618	10716	86	0	\N
165480	1397	1311997334000	21618	10716	87	0	\N
165481	1397	1311987333000	21618	10716	88	0	\N
165482	1397	1311977332000	21618	10716	89	0	\N
165483	1397	1311967331000	21618	10716	90	0	\N
165484	1397	1311957330000	21618	10716	91	0	\N
165485	1397	1311947329000	21618	10716	92	0	\N
165486	1397	1311937328000	21618	10716	93	0	\N
165487	1397	1311927327000	21618	10716	94	0	\N
165488	1397	1311917326000	21618	10716	95	0	\N
165489	1397	1311907325000	21618	10716	96	0	\N
165490	1397	1311897324000	21618	10716	97	0	\N
165491	1397	1311887323000	21618	10716	98	0	\N
165492	1397	1311877322000	21618	10716	99	0	\N
165493	1397	1311867321000	21618	10716	100	0	\N
165494	1397	1311857320000	21618	10716	101	0	\N
165495	1397	1311847319000	21618	10716	102	0	\N
165496	1397	1311837318000	21618	10716	103	0	\N
165497	1397	1311827317000	21618	10716	104	0	\N
165498	1397	1311817316000	21618	10716	105	0	\N
165499	1397	1311807315000	21618	10716	106	0	\N
165500	1397	1311797314000	21618	10716	107	0	\N
165501	1397	1311787313000	21618	10716	108	0	\N
165502	1397	1311777312000	21618	10716	109	0	\N
165503	1397	1311767311000	21618	10716	110	0	\N
165504	1397	1311757310000	21618	10716	111	0	\N
165505	1397	1311747309000	21618	10716	112	0	\N
165506	1397	1311737308000	21618	10716	113	0	\N
165507	1397	1311727307000	21618	10716	114	0	\N
165508	1397	1311717306000	21618	10716	115	0	\N
165509	1397	1311707305000	21618	10716	116	0	\N
165510	1397	1311697304000	21618	10716	117	0	\N
165511	1397	1311687303000	21618	10716	118	0	\N
165512	1397	1311677302000	21618	10716	119	0	\N
165382	1397	1311127247000	21614	10832	0	0	12770
165383	2133	95829672000	21614	10832	1	0	3164
165384	2134	87316232000	21614	10832	2	0	3264
165388	1397	1311117246000	21616	10833	0	0	12771
165389	2134	87315229000	21616	10833	1	0	3265
165513	1397	1311667301000	21618	10716	120	0	\N
165514	1397	1311657300000	21618	10716	121	0	\N
165515	1397	1311647299000	21618	10716	122	0	\N
165516	1397	1311637298000	21618	10716	123	0	\N
165517	1397	1311627297000	21618	10716	124	0	\N
165518	1397	1311617296000	21618	10716	125	0	\N
165519	1397	1311107245000	21621	10834	0	0	\N
165520	1397	1311097244000	21621	10834	1	0	\N
165521	2133	95827668000	21621	10834	2	0	\N
165522	2133	95826666000	21621	10834	3	0	\N
165523	1397	1311107245000	21622	10834	0	0	\N
165524	1397	1311097244000	21622	10834	1	0	\N
165525	2133	95827668000	21622	10834	2	0	\N
165526	2133	95826666000	21622	10834	3	0	\N
165527	2134	87314226000	21622	10834	4	0	\N
165528	2134	87313223000	21622	10834	5	0	\N
165529	1397	1311107245000	21623	10834	0	0	\N
165530	1397	1311097244000	21623	10834	1	0	\N
165531	2133	95827668000	21623	10834	2	0	\N
165532	2133	95826666000	21623	10834	3	0	\N
165539	1397	1311107245000	21625	10834	0	0	\N
165540	1397	1311097244000	21625	10834	1	0	\N
165541	2133	95827668000	21625	10834	2	0	\N
165542	2133	95826666000	21625	10834	3	0	\N
165543	2134	87314226000	21625	10834	4	0	\N
165544	2134	87313223000	21625	10834	5	0	\N
165545	1397	1311707305000	21626	10782	0	0	\N
165546	1397	1311697304000	21626	10782	1	0	\N
165547	1397	1311687303000	21626	10782	2	0	\N
165548	1397	1311677302000	21626	10782	3	0	\N
165549	1397	1311667301000	21626	10782	4	0	\N
165550	1397	1311657300000	21626	10782	5	0	\N
165551	1397	1311647299000	21626	10782	6	0	\N
165552	1397	1311637298000	21626	10782	7	0	\N
165553	1397	1311627297000	21626	10782	8	0	\N
165554	1397	1311617296000	21626	10782	9	0	\N
165555	1397	1311607295000	21626	10782	10	0	\N
165556	1397	1311597294000	21626	10782	11	0	\N
165557	1397	1311587293000	21626	10782	12	0	\N
165558	1397	1311577292000	21626	10782	13	0	\N
165559	1397	1311567291000	21626	10782	14	0	\N
165560	1397	1311557290000	21626	10782	15	0	\N
165561	1397	1311547289000	21626	10782	16	0	\N
165562	1397	1311537288000	21626	10782	17	0	\N
165563	1397	1311527287000	21626	10782	18	0	\N
165564	1397	1311517286000	21626	10782	19	0	\N
165565	1397	1311507285000	21626	10782	20	0	\N
165566	1397	1311497284000	21626	10782	21	0	\N
165567	1397	1311487283000	21626	10782	22	0	\N
165568	1397	1311477282000	21626	10782	23	0	\N
165569	1397	1311467281000	21626	10782	24	0	\N
165570	1397	1311457280000	21626	10782	25	0	\N
165571	1397	1311447279000	21626	10782	26	0	\N
165572	1397	1311437278000	21626	10782	27	0	\N
165573	1397	1311427277000	21626	10782	28	0	\N
165574	1397	1311417276000	21626	10782	29	0	\N
165575	1397	1311407275000	21626	10782	30	0	\N
165576	1397	1311397274000	21626	10782	31	0	\N
165577	1397	1311387273000	21626	10782	32	0	\N
165578	1397	1311377272000	21626	10782	33	0	\N
165579	1397	1311367271000	21626	10782	34	0	\N
165580	1397	1311357270000	21626	10782	35	0	\N
165581	1397	1311347269000	21626	10782	36	0	\N
165582	1397	1311337268000	21626	10782	37	0	\N
165583	1397	1311327267000	21626	10782	38	0	\N
165584	1397	1311317266000	21626	10782	39	0	\N
165585	1397	1311307265000	21626	10782	40	0	\N
165586	1397	1311297264000	21626	10782	41	0	\N
165587	1397	1311287263000	21626	10782	42	0	\N
165588	1397	1311277262000	21626	10782	43	0	\N
165589	1397	1311267261000	21626	10782	44	0	\N
165590	1397	1311257260000	21626	10782	45	0	\N
165591	1397	1311247259000	21626	10782	46	0	\N
165592	1397	1311237258000	21626	10782	47	0	\N
165593	1397	1311227257000	21626	10782	48	0	\N
165594	1397	1311217256000	21626	10782	49	0	\N
165595	1397	1311207255000	21626	10782	50	0	\N
165596	1397	1311197254000	21626	10782	51	0	\N
165597	1397	1311187253000	21626	10782	52	0	\N
165598	1397	1311177252000	21626	10782	53	0	\N
165599	1397	1311167251000	21626	10782	54	0	\N
165600	1397	1311157250000	21626	10782	55	0	\N
165601	1397	1311147249000	21626	10782	56	0	\N
165602	1397	1311137248000	21626	10782	57	0	\N
165603	1397	1311127247000	21626	10782	58	0	\N
165604	1397	1311117246000	21626	10782	59	0	\N
165605	1397	1311107245000	21626	10782	60	0	\N
165606	2134	87377415000	21626	10782	61	0	\N
165607	2134	87376412000	21626	10782	62	0	\N
165608	2134	87375409000	21626	10782	63	0	\N
165609	2134	87374406000	21626	10782	64	0	\N
165610	2134	87373403000	21626	10782	65	0	\N
165611	2133	95882778000	21626	10782	66	0	\N
165612	2133	95881776000	21626	10782	67	0	\N
165613	2133	95880774000	21626	10782	68	0	\N
165614	2133	95879772000	21626	10782	69	0	\N
165615	2133	95878770000	21626	10782	70	0	\N
165616	2134	87372400000	21626	10782	71	0	\N
165617	2133	95877768000	21626	10782	72	0	\N
165618	2133	95876766000	21626	10782	73	0	\N
165619	2133	95875764000	21626	10782	74	0	\N
165620	2133	95874762000	21626	10782	75	0	\N
165621	2133	95873760000	21626	10782	76	0	\N
165622	2133	95872758000	21626	10782	77	0	\N
165623	2133	95871756000	21626	10782	78	0	\N
165624	2133	95870754000	21626	10782	79	0	\N
165625	2133	95869752000	21626	10782	80	0	\N
165626	2133	95868750000	21626	10782	81	0	\N
165627	2133	95867748000	21626	10782	82	0	\N
165628	2133	95866746000	21626	10782	83	0	\N
165629	2133	95865744000	21626	10782	84	0	\N
165630	2133	95864742000	21626	10782	85	0	\N
165631	2133	95863740000	21626	10782	86	0	\N
165632	2133	95862738000	21626	10782	87	0	\N
165633	2133	95861736000	21626	10782	88	0	\N
165634	2133	95860734000	21626	10782	89	0	\N
165635	2133	95859732000	21626	10782	90	0	\N
165636	2133	95858730000	21626	10782	91	0	\N
165637	2133	95857728000	21626	10782	92	0	\N
165638	2133	95856726000	21626	10782	93	0	\N
165639	2133	95855724000	21626	10782	94	0	\N
165640	2133	95854722000	21626	10782	95	0	\N
165641	2284	199000000	21626	10782	96	0	\N
165642	2284	198000000	21626	10782	97	0	\N
165643	2133	95853720000	21626	10782	98	0	\N
165644	2133	95852718000	21626	10782	99	0	\N
165645	2133	95851716000	21626	10782	100	0	\N
165646	2133	95850714000	21626	10782	101	0	\N
165647	2133	95849712000	21626	10782	102	0	\N
165648	2133	95848710000	21626	10782	103	0	\N
165535	2133	95827668000	21624	10834	2	0	3166
165536	2133	95826666000	21624	10834	3	0	3167
165537	2134	87314226000	21624	10834	4	0	3266
165538	2134	87313223000	21624	10834	5	0	3267
165649	2133	95847708000	21626	10782	104	0	\N
165650	2132	148021022000	21626	10782	105	0	\N
165651	2132	148020021000	21626	10782	106	0	\N
165652	2132	148019020000	21626	10782	108	0	\N
165653	2132	148018019000	21626	10782	109	0	\N
165654	2134	87371397000	21626	10782	110	0	\N
165655	2134	87370394000	21626	10782	111	0	\N
165656	2134	87369391000	21626	10782	112	0	\N
165657	2134	87368388000	21626	10782	113	0	\N
165658	2134	87367385000	21626	10782	114	0	\N
165659	2134	87366382000	21626	10782	115	0	\N
165660	2134	87365379000	21626	10782	116	0	\N
165661	2134	87364376000	21626	10782	117	0	\N
165662	2134	87363373000	21626	10782	118	0	\N
165663	2134	87362370000	21626	10782	119	0	\N
165664	2134	87361367000	21626	10782	120	0	\N
165665	2134	87360364000	21626	10782	121	0	\N
165666	2134	87359361000	21626	10782	122	0	\N
165667	2134	87358358000	21626	10782	123	0	\N
165668	2134	87357355000	21626	10782	124	0	\N
165669	2134	87356352000	21626	10782	125	0	\N
165672	1397	1311087243000	21628	10835	0	0	\N
165673	2134	87312220000	21628	10835	1	0	\N
165674	2133	95825664000	21628	10835	2	0	\N
165686	1508	22684405117393	21631	10838	0	0	\N
165687	1397	1311047239000	21631	10838	1	0	\N
165688	2133	94611656000	21631	10838	2	0	\N
165689	1508	22684405117393	21632	10838	0	0	\N
165690	1397	1311047239000	21632	10838	1	0	\N
165691	2133	94611656000	21632	10838	2	0	\N
165696	1508	22684405117393	21634	10838	0	0	\N
165697	1397	1311047239000	21634	10838	1	0	\N
165698	2134	87308208000	21634	10838	2	0	\N
165699	2133	94611656000	21634	10838	3	0	\N
165700	1397	1311037238000	21635	10839	0	0	\N
165701	1508	18110553132541	21635	10839	1	0	\N
165702	1508	15024480805109	21635	10839	2	0	\N
165703	1508	6424883732361	21635	10839	3	0	\N
165704	2133	94610654000	21635	10839	4	0	\N
165705	1397	1311037238000	21636	10839	0	0	\N
165706	1508	18110553132541	21636	10839	1	0	\N
165707	1508	15024480805109	21636	10839	2	0	\N
165708	1508	6424883732361	21636	10839	3	0	\N
165709	2134	87307205000	21636	10839	4	0	\N
165710	2133	94610654000	21636	10839	5	0	\N
165719	1397	1311027237000	21639	10840	0	0	\N
165720	2134	87307205000	21639	10840	1	0	\N
165721	2134	87306202000	21639	10840	2	0	\N
165722	2133	94610654000	21639	10840	3	0	\N
165723	2133	94609652000	21639	10840	4	0	\N
165731	1397	1311007235000	21642	10842	0	0	\N
165732	2133	94607648000	21642	10842	1	0	\N
165733	2134	87304196000	21642	10842	2	0	\N
165737	1397	1310997234000	21644	10843	0	0	\N
165738	2134	87303193000	21644	10843	1	0	\N
165739	2133	94606646000	21644	10843	2	0	\N
165740	2134	87302190000	21644	10843	3	0	\N
165741	2133	94605644000	21644	10843	4	0	\N
165755	1397	1310977232000	21647	10845	0	0	\N
165756	1397	1310967231000	21647	10845	1	0	\N
165757	773	1000000000000	21647	10845	2	0	\N
165758	478	66000000000000	21647	10845	3	0	\N
165759	2133	94603640000	21647	10845	5	0	\N
165760	2133	94602638000	21647	10845	6	0	\N
165761	2134	87300184000	21647	10845	7	0	\N
165762	2134	87299181000	21647	10845	8	0	\N
165763	1397	1310957230000	21648	10846	0	0	\N
165764	2134	87298178000	21648	10846	1	0	\N
165765	2133	94601636000	21648	10846	2	0	\N
165766	1397	1310957230000	21649	10846	0	0	\N
165767	2134	87298178000	21649	10846	1	0	\N
165768	2133	94601636000	21649	10846	2	0	\N
165769	1397	1310957230000	21650	10846	0	0	\N
165770	2134	87298178000	21650	10846	1	0	\N
165771	2133	94601636000	21650	10846	2	0	\N
165775	1397	1310957230000	21652	10846	0	0	\N
165776	2134	87298178000	21652	10846	1	0	\N
165777	2133	94601636000	21652	10846	2	0	\N
165778	1458	22110672908540	21653	10674	0	0	\N
165779	1458	19133472908540	21653	10674	1	0	\N
165780	1458	14721272908540	21653	10674	2	0	\N
165781	1458	6425072908540	21653	10674	3	0	\N
165782	1547	22172796000000	21653	10674	4	0	\N
165783	1547	21885776000000	21653	10674	5	0	\N
165784	1547	19696756000000	21653	10674	6	0	\N
165675	1397	1311077242000	21629	10836	0	0	12775
165676	1397	1311067241000	21629	10836	1	0	12776
165677	2134	87312220000	21629	10836	2	0	3268
165678	2133	95824662000	21629	10836	3	0	3169
165679	2133	94614662000	21629	10836	4	0	3170
165681	2134	87311217000	21629	10836	6	0	3269
165682	2134	87310214000	21629	10836	7	0	3270
165683	1397	1311057240000	21630	10837	0	0	12777
165684	2134	87309211000	21630	10837	1	0	3271
165685	2133	94612658000	21630	10837	2	0	3172
165693	1397	1311047239000	21633	10838	1	0	12778
165694	2134	87308208000	21633	10838	2	0	3272
165695	2133	94611656000	21633	10838	3	0	3173
165711	1397	1311037238000	21637	10839	0	0	12779
165713	1508	15024480805109	21637	10839	2	0	9
165714	1508	6424883732361	21637	10839	3	0	10
165715	1397	1311027237000	21638	10840	0	0	12780
165716	2134	87307205000	21638	10840	1	0	3273
165717	2134	87306202000	21638	10840	2	0	3274
165724	1397	1311017236000	21640	10841	0	0	12781
165725	2133	94609652000	21640	10841	1	0	3175
165726	2134	87305199000	21640	10841	2	0	3275
165727	2133	94608650000	21640	10841	3	0	3176
165728	1397	1311007235000	21641	10842	0	0	12782
165730	2134	87304196000	21641	10842	2	0	3276
165734	1397	1310997234000	21643	10843	0	0	12783
165735	2133	94606646000	21643	10843	1	0	3178
165736	2133	94605644000	21643	10843	2	0	3179
165743	2134	87303193000	21645	10844	1	0	3277
165744	2133	94604642000	21645	10844	2	0	3180
165745	2134	87302190000	21645	10844	3	0	3278
165746	2134	87301187000	21645	10844	4	0	3279
165747	1397	1310977232000	21646	10845	0	0	12785
165749	773	1000000000000	21646	10845	2	0	1
165750	478	66000000000000	21646	10845	3	0	1
165751	2133	94603640000	21646	10845	5	0	3181
165752	2133	94602638000	21646	10845	6	0	3182
165753	2134	87300184000	21646	10845	7	0	3280
165772	1397	1310957230000	21651	10846	0	0	12787
165773	2134	87298178000	21651	10846	1	0	3282
165774	2133	94601636000	21651	10846	2	0	3183
165785	1547	17049736000000	21653	10674	7	0	\N
165786	1547	13127716000000	21653	10674	8	0	\N
165787	1547	5754696000000	21653	10674	9	0	\N
165788	1608	3018303000000	21653	10674	10	0	\N
165789	885	63455021096354	21653	10674	11	0	\N
165790	1397	1313257460000	21653	10674	12	0	\N
165791	886	63455031096354	21653	10674	13	0	\N
165792	1508	19804356117393	21653	10674	14	0	\N
165793	694	66522947693786	21653	10674	15	0	\N
165794	1397	1313247459000	21653	10674	16	0	\N
165795	773	1000000000000	21653	10674	17	0	\N
165796	478	66000000000000	21653	10674	18	0	\N
165797	1771	304905534083	21653	10674	19	0	\N
165798	1397	1313237458000	21653	10674	20	0	\N
165799	1397	1313227457000	21653	10674	21	0	\N
165800	1397	1313217456000	21653	10674	22	0	\N
165801	1397	1313207455000	21653	10674	23	0	\N
165802	1397	1313197454000	21653	10674	24	0	\N
165803	1397	1313187453000	21653	10674	25	0	\N
165804	1397	1313177452000	21653	10674	26	0	\N
165805	1397	1313167451000	21653	10674	27	0	\N
165806	1397	1313157450000	21653	10674	28	0	\N
165807	1397	1313147449000	21653	10674	29	0	\N
165808	1397	1313137448000	21653	10674	30	0	\N
165809	1397	1313127447000	21653	10674	31	0	\N
165810	1397	1313117446000	21653	10674	32	0	\N
165811	1397	1313107445000	21653	10674	33	0	\N
165812	1397	1313097444000	21653	10674	34	0	\N
165813	1397	1313087443000	21653	10674	35	0	\N
165814	1397	1313077442000	21653	10674	36	0	\N
165815	1397	1313067441000	21653	10674	37	0	\N
165816	1397	1313057440000	21653	10674	38	0	\N
165817	1397	1313047439000	21653	10674	39	0	\N
165818	1397	1313037438000	21653	10674	40	0	\N
165819	1397	1313027437000	21653	10674	41	0	\N
165820	1508	15485875556796	21653	10674	42	0	\N
165821	1508	12399803229364	21653	10674	43	0	\N
165822	1508	3800206156616	21653	10674	44	0	\N
165823	1686	20078957869379	21653	10674	45	0	\N
165824	1686	19789762079363	21653	10674	46	0	\N
165825	1686	19500566289347	21653	10674	47	0	\N
165826	1686	17298647403647	21653	10674	48	0	\N
165827	1686	13352835546422	21653	10674	49	0	\N
165828	1686	10690514407697	21653	10674	50	0	\N
165829	1686	3271737700122	21653	10674	51	0	\N
165830	1686	3271727700122	21653	10674	52	0	\N
165831	1397	1313017436000	21653	10674	53	0	\N
165832	1397	1313007435000	21653	10674	54	0	\N
165833	1397	1312997434000	21653	10674	55	0	\N
165834	1397	1312987433000	21653	10674	56	0	\N
165835	1397	1312977432000	21653	10674	57	0	\N
165836	1397	1312967431000	21653	10674	58	0	\N
165837	1397	1312957430000	21653	10674	59	0	\N
165838	1397	1312947429000	21653	10674	60	0	\N
165839	1397	1312937428000	21653	10674	61	0	\N
165840	1397	1312927427000	21653	10674	62	0	\N
165841	1397	1312917426000	21653	10674	63	0	\N
165842	1397	1312907425000	21653	10674	64	0	\N
165843	1397	1312897424000	21653	10674	65	0	\N
165844	1397	1312887423000	21653	10674	66	0	\N
165845	1397	1312877422000	21653	10674	67	0	\N
165846	1397	1312867421000	21653	10674	68	0	\N
165847	1397	1312857420000	21653	10674	69	0	\N
165848	1397	1312847419000	21653	10674	70	0	\N
165849	1397	1312837418000	21653	10674	71	0	\N
165850	1397	1312827417000	21653	10674	72	0	\N
165851	1397	1312817416000	21653	10674	73	0	\N
165852	1397	1312807415000	21653	10674	74	0	\N
165853	1397	1312797414000	21653	10674	75	0	\N
165854	1397	1312787413000	21653	10674	76	0	\N
165855	1397	1312777412000	21653	10674	77	0	\N
165856	1397	1312767411000	21653	10674	78	0	\N
165857	1397	1312757410000	21653	10674	79	0	\N
165858	1397	1312747409000	21653	10674	80	0	\N
165859	1397	1312737408000	21653	10674	81	0	\N
165860	1397	1312727407000	21653	10674	82	0	\N
165861	1397	1312717406000	21653	10674	83	0	\N
165862	1397	1312707405000	21653	10674	84	0	\N
165863	1397	1312697404000	21653	10674	85	0	\N
165864	1397	1312687403000	21653	10674	86	0	\N
165865	1397	1312677402000	21653	10674	87	0	\N
165866	1397	1312667401000	21653	10674	88	0	\N
165867	1397	1312657400000	21653	10674	89	0	\N
165868	1397	1312647399000	21653	10674	90	0	\N
165869	1397	1312637398000	21653	10674	92	0	\N
165870	1397	1312627397000	21653	10674	93	0	\N
165871	1397	1312617396000	21653	10674	94	0	\N
165872	1397	1312607395000	21653	10674	95	0	\N
165873	1397	1312597394000	21653	10674	96	0	\N
165874	1397	1312587393000	21653	10674	97	0	\N
165875	1397	1312577392000	21653	10674	98	0	\N
165876	1397	1312567391000	21653	10674	99	0	\N
165877	1397	1312557390000	21653	10674	100	0	\N
165878	1397	1312547389000	21653	10674	101	0	\N
165879	1397	1312537388000	21653	10674	102	0	\N
165880	1397	1312527387000	21653	10674	103	0	\N
165881	1397	1312517386000	21653	10674	104	0	\N
165882	1397	1312507385000	21653	10674	105	0	\N
165883	1397	1312497384000	21653	10674	106	0	\N
165884	1397	1312487383000	21653	10674	107	0	\N
165885	1397	1312477382000	21653	10674	108	0	\N
165886	1397	1312467381000	21653	10674	109	0	\N
165887	1397	1312457380000	21653	10674	110	0	\N
165888	1397	1312447379000	21653	10674	111	0	\N
165889	1397	1312437378000	21653	10674	112	0	\N
165890	1397	1312427377000	21653	10674	113	0	\N
165891	1397	1312417376000	21653	10674	114	0	\N
165892	1397	1312407375000	21653	10674	115	0	\N
165893	1397	1312397374000	21653	10674	116	0	\N
165894	1397	1312387373000	21653	10674	117	0	\N
165895	1397	1312377372000	21653	10674	118	0	\N
165896	1397	1312367371000	21653	10674	119	0	\N
165897	1397	1312357370000	21653	10674	120	0	\N
165898	1397	1312347369000	21653	10674	121	0	\N
165899	1397	1312337368000	21653	10674	122	0	\N
165900	1397	1312327367000	21653	10674	123	0	\N
165901	1397	1312317366000	21653	10674	124	0	\N
165902	1397	1312307365000	21653	10674	125	0	\N
165912	1397	1310947229000	21655	10847	0	0	\N
165913	1397	1310937228000	21655	10847	1	0	\N
165914	1397	1310927227000	21655	10847	2	0	\N
165915	2133	94600634000	21655	10847	3	0	\N
165916	2133	94599632000	21655	10847	4	0	\N
165917	2133	94598630000	21655	10847	5	0	\N
165918	2134	87297175000	21655	10847	6	0	\N
165919	2134	87296172000	21655	10847	7	0	\N
165920	2134	87295169000	21655	10847	8	0	\N
165905	1397	1310927227000	21654	10847	2	0	12790
165906	2133	94600634000	21654	10847	3	0	3184
165907	2133	94599632000	21654	10847	4	0	3185
165908	2133	94598630000	21654	10847	5	0	3186
165909	2134	87297175000	21654	10847	6	0	3283
165911	2134	87295169000	21654	10847	8	0	3285
165935	1397	1310877222000	21660	10852	0	0	\N
165936	2133	94593620000	21660	10852	1	0	\N
165937	1397	1310877222000	21661	10852	0	0	\N
165938	2134	87290154000	21661	10852	1	0	\N
165939	2133	94593620000	21661	10852	2	0	\N
165948	1397	1310857220000	21665	10854	0	0	\N
165949	2134	87288148000	21665	10854	1	0	\N
165950	2133	94591616000	21665	10854	2	0	\N
165951	1458	22110672908540	21666	10626	0	0	\N
165952	1458	19133472908540	21666	10626	1	0	\N
165953	1458	14721272908540	21666	10626	2	0	\N
165954	1458	6425072908540	21666	10626	3	0	\N
165955	1547	21452745000000	21666	10626	4	0	\N
165956	1547	21165725000000	21666	10626	5	0	\N
165957	1547	18976705000000	21666	10626	6	0	\N
165958	1547	16329685000000	21666	10626	7	0	\N
165959	1547	12407665000000	21666	10626	8	0	\N
165960	1547	5034645000000	21666	10626	9	0	\N
165961	1426	15961288000000	21666	10626	10	0	\N
165962	1608	2298292000000	21666	10626	11	0	\N
165963	1397	1313947529000	21666	10626	12	0	\N
165964	1471	14856185900000	21666	10626	13	0	\N
165965	885	63455021096354	21666	10626	14	0	\N
165966	1649	15758407999992	21666	10626	15	0	\N
165967	886	63455031096354	21666	10626	16	0	\N
165968	1426	10895278000000	21666	10626	17	0	\N
165969	1471	9790175900000	21666	10626	18	0	\N
165970	1508	19804356117393	21666	10626	19	0	\N
165971	694	66522947693786	21666	10626	20	0	\N
165972	1397	1313937528000	21666	10626	21	0	\N
165973	886	63455021096354	21666	10626	22	0	\N
165974	1649	10202397999992	21666	10626	23	0	\N
165975	1649	6453387999992	21666	10626	24	0	\N
165976	1649	3352377999992	21666	10626	25	0	\N
165977	1471	6372165900000	21666	10626	26	0	\N
165978	885	63455011096354	21666	10626	27	0	\N
165979	773	1000000000000	21666	10626	28	0	\N
165980	1693	5221526908632	21666	10626	29	0	\N
165981	478	66000000000000	21666	10626	30	0	\N
165982	1426	7477268000000	21666	10626	31	0	\N
165983	1426	4650258000000	21666	10626	32	0	\N
165984	1397	1313927527000	21666	10626	33	0	\N
165985	1397	1313917526000	21666	10626	34	0	\N
165986	1397	1313907525000	21666	10626	35	0	\N
165987	1397	1313897524000	21666	10626	36	0	\N
165988	1771	304905534083	21666	10626	37	0	\N
165989	1397	1313887523000	21666	10626	38	0	\N
165990	1397	1313877522000	21666	10626	39	0	\N
165991	1508	15485875556796	21666	10626	40	0	\N
165992	1508	12399803229364	21666	10626	41	0	\N
165993	1508	3800206156616	21666	10626	42	0	\N
165994	1397	1313867521000	21666	10626	43	0	\N
165995	1397	1313857520000	21666	10626	44	0	\N
165996	1397	1313847519000	21666	10626	45	0	\N
165997	1397	1313837518000	21666	10626	46	0	\N
165998	1397	1313827517000	21666	10626	47	0	\N
165999	1397	1313817516000	21666	10626	48	0	\N
166000	1397	1313807515000	21666	10626	49	0	\N
166001	1397	1313797514000	21666	10626	50	0	\N
166002	1397	1313787513000	21666	10626	51	0	\N
166003	1397	1313777512000	21666	10626	52	0	\N
166004	1397	1313767511000	21666	10626	53	0	\N
166005	1397	1313757510000	21666	10626	54	0	\N
166006	1397	1313747509000	21666	10626	55	0	\N
166007	1397	1313737508000	21666	10626	56	0	\N
166008	1397	1313727507000	21666	10626	57	0	\N
166009	1397	1313717506000	21666	10626	58	0	\N
166010	1397	1313707505000	21666	10626	59	0	\N
166011	1397	1313697504000	21666	10626	60	0	\N
166012	1397	1313687503000	21666	10626	61	0	\N
166013	1397	1313677502000	21666	10626	62	0	\N
166014	1686	20078957869379	21666	10626	63	0	\N
166015	1686	19789762079363	21666	10626	64	0	\N
166016	1686	19500566289347	21666	10626	65	0	\N
166017	1686	17298647403647	21666	10626	66	0	\N
166018	1686	13352835546422	21666	10626	67	0	\N
166019	1686	10690514407697	21666	10626	68	0	\N
166020	1686	3271737700122	21666	10626	69	0	\N
166021	1686	3271727700122	21666	10626	70	0	\N
166022	1397	1313667501000	21666	10626	71	0	\N
166023	1397	1313657500000	21666	10626	72	0	\N
166024	1397	1313647499000	21666	10626	73	0	\N
166025	1397	1313637498000	21666	10626	74	0	\N
166026	1397	1313627497000	21666	10626	75	0	\N
166027	1397	1313617496000	21666	10626	76	0	\N
166028	1397	1313607495000	21666	10626	77	0	\N
166029	1471	3545155900000	21666	10626	78	0	\N
166030	1397	1313597494000	21666	10626	79	0	\N
166031	1397	1313587493000	21666	10626	80	0	\N
166032	1397	1313577492000	21666	10626	81	0	\N
166033	1397	1313567491000	21666	10626	82	0	\N
166034	1397	1313557490000	21666	10626	83	0	\N
166035	1397	1313547489000	21666	10626	84	0	\N
166036	1397	1313537488000	21666	10626	85	0	\N
166037	1397	1313527487000	21666	10626	86	0	\N
166038	1397	1313517486000	21666	10626	87	0	\N
166039	1397	1313507485000	21666	10626	88	0	\N
166040	1397	1313497484000	21666	10626	90	0	\N
166041	1397	1313487483000	21666	10626	91	0	\N
166042	1397	1313477482000	21666	10626	92	0	\N
166043	1397	1313467481000	21666	10626	93	0	\N
166044	1397	1313457480000	21666	10626	94	0	\N
166045	1397	1313447479000	21666	10626	95	0	\N
166046	1397	1313437478000	21666	10626	96	0	\N
166047	1397	1313427477000	21666	10626	97	0	\N
166048	1397	1313417476000	21666	10626	98	0	\N
166049	1397	1313407475000	21666	10626	99	0	\N
166050	1397	1313397474000	21666	10626	100	0	\N
166051	1397	1313387473000	21666	10626	101	0	\N
166052	1397	1313377472000	21666	10626	102	0	\N
166053	1397	1313367471000	21666	10626	103	0	\N
166054	1397	1313357470000	21666	10626	104	0	\N
166055	1397	1313347469000	21666	10626	105	0	\N
166056	1397	1313337468000	21666	10626	106	0	\N
165923	2134	87294166000	21656	10848	2	0	3286
165924	1397	1310907225000	21657	10849	0	0	12792
165925	885	63455011096354	21657	10849	1	0	6
165926	2133	94596626000	21657	10849	2	0	3188
165927	2134	87293163000	21657	10849	3	0	3287
165929	1397	1310897224000	21658	10850	1	0	12793
165930	2133	94595624000	21658	10850	2	0	3189
165931	2134	87292160000	21658	10850	3	0	3288
165932	1397	1310887223000	21659	10851	0	0	12794
165933	2134	87291157000	21659	10851	1	0	3289
165940	1397	1310877222000	21662	10852	0	0	12795
165941	2134	87290154000	21662	10852	1	0	3290
165942	2133	94593620000	21662	10852	2	0	3191
165943	1397	1310867221000	21663	10853	0	0	12796
165945	2133	94592618000	21663	10853	2	0	3192
165946	2134	87289151000	21663	10853	3	0	3291
165947	1397	1310857220000	21664	10854	0	0	12797
166057	1397	1313327467000	21666	10626	107	0	\N
166058	1397	1313317466000	21666	10626	108	0	\N
166059	1397	1313307465000	21666	10626	109	0	\N
166060	1397	1313297464000	21666	10626	110	0	\N
166061	1397	1313287463000	21666	10626	111	0	\N
166062	1397	1313277462000	21666	10626	112	0	\N
166063	1397	1313267461000	21666	10626	113	0	\N
166064	1397	1313257460000	21666	10626	114	0	\N
166065	1397	1313247459000	21666	10626	115	0	\N
166066	1397	1313237458000	21666	10626	116	0	\N
166067	1397	1313227457000	21666	10626	117	0	\N
166068	1397	1313217456000	21666	10626	118	0	\N
166069	1397	1313207455000	21666	10626	119	0	\N
166070	1397	1313197454000	21666	10626	120	0	\N
166071	1397	1313187453000	21666	10626	121	0	\N
166072	1397	1313177452000	21666	10626	122	0	\N
166073	1397	1313167451000	21666	10626	123	0	\N
166074	1397	1313157450000	21666	10626	124	0	\N
166075	1397	1313147449000	21666	10626	125	0	\N
166076	2290	90000000	21667	10855	0	0	\N
166077	1397	1310847219000	21667	10855	1	0	\N
166078	2133	94591616000	21667	10855	2	0	\N
166079	2133	94590614000	21667	10855	3	0	\N
166080	2290	90000000	21668	10855	0	0	\N
166081	1397	1310847219000	21668	10855	1	0	\N
166082	2134	87288148000	21668	10855	2	0	\N
166083	2134	87287145000	21668	10855	3	0	\N
166084	2133	94591616000	21668	10855	4	0	\N
166085	2133	94590614000	21668	10855	5	0	\N
166092	2290	90000000	21670	10855	0	0	\N
166093	1397	1310847219000	21670	10855	1	0	\N
166094	2134	87288148000	21670	10855	2	0	\N
166095	2134	87287145000	21670	10855	3	0	\N
166096	2133	94591616000	21670	10855	4	0	\N
166097	2133	94590614000	21670	10855	5	0	\N
166107	1397	1310807215000	21674	10858	0	0	\N
166108	2133	94586606000	21674	10858	1	0	\N
166109	2134	87283133000	21674	10858	2	0	\N
166123	885	63455021096354	21680	10765	0	0	\N
166124	886	63455031096354	21680	10765	1	0	\N
166125	1508	22684405117393	21680	10765	2	0	\N
166126	1573	14899271000000	21680	10765	3	0	\N
166127	886	63455021096354	21680	10765	4	0	\N
166128	885	63455011096354	21680	10765	5	0	\N
166129	773	1000000000000	21680	10765	6	0	\N
166130	1693	6661561908632	21680	10765	7	0	\N
166131	478	66000000000000	21680	10765	8	0	\N
166132	1508	18365924556796	21680	10765	9	0	\N
166133	1508	15279852229364	21680	10765	10	0	\N
166134	1508	6680255156616	21680	10765	11	0	\N
166135	2284	199000000	21680	10765	12	0	\N
166136	2284	198000000	21680	10765	13	0	\N
166137	1397	1311297264000	21681	10816	0	0	\N
166138	1508	22684405117393	21681	10816	1	0	\N
166139	1573	14899271000000	21681	10816	2	0	\N
166140	886	63455021096354	21681	10816	3	0	\N
166141	1397	1311287263000	21681	10816	4	0	\N
166142	885	63455011096354	21681	10816	5	0	\N
166143	773	1000000000000	21681	10816	6	0	\N
166144	1693	7381573908632	21681	10816	7	0	\N
166145	478	66000000000000	21681	10816	8	0	\N
166146	1397	1311277262000	21681	10816	9	0	\N
166147	1397	1311267261000	21681	10816	10	0	\N
166148	1397	1311257260000	21681	10816	11	0	\N
166149	1397	1311247259000	21681	10816	12	0	\N
166150	1397	1311237258000	21681	10816	13	0	\N
166151	1397	1311227257000	21681	10816	14	0	\N
166152	1397	1311217256000	21681	10816	15	0	\N
166153	1397	1311207255000	21681	10816	16	0	\N
166154	1397	1311197254000	21681	10816	17	0	\N
166155	1397	1311187253000	21681	10816	18	0	\N
166156	1397	1311177252000	21681	10816	19	0	\N
166157	1397	1311167251000	21681	10816	20	0	\N
166158	1397	1311157250000	21681	10816	21	0	\N
166159	1397	1311147249000	21681	10816	22	0	\N
166160	1397	1311137248000	21681	10816	23	0	\N
166161	1397	1311127247000	21681	10816	24	0	\N
166162	1397	1311117246000	21681	10816	25	0	\N
166163	1397	1311107245000	21681	10816	26	0	\N
166164	1397	1311097244000	21681	10816	27	0	\N
166165	1397	1311087243000	21681	10816	28	0	\N
166166	1397	1311077242000	21681	10816	29	0	\N
166167	1397	1311067241000	21681	10816	30	0	\N
166168	1397	1311057240000	21681	10816	31	0	\N
166169	1397	1311047239000	21681	10816	32	0	\N
166170	1397	1311037238000	21681	10816	33	0	\N
166171	1397	1311027237000	21681	10816	34	0	\N
166172	1397	1311017236000	21681	10816	35	0	\N
166173	1397	1311007235000	21681	10816	36	0	\N
166174	1397	1310997234000	21681	10816	37	0	\N
166175	1397	1310987233000	21681	10816	38	0	\N
166176	1397	1310977232000	21681	10816	39	0	\N
166177	1397	1310967231000	21681	10816	41	0	\N
166178	1397	1310957230000	21681	10816	42	0	\N
166179	1397	1310947229000	21681	10816	43	0	\N
166180	1397	1310937228000	21681	10816	44	0	\N
166181	1397	1310927227000	21681	10816	45	0	\N
166182	1397	1310917226000	21681	10816	46	0	\N
166183	1397	1310907225000	21681	10816	47	0	\N
166184	1397	1310897224000	21681	10816	48	0	\N
166185	1397	1310887223000	21681	10816	49	0	\N
166186	1397	1310877222000	21681	10816	50	0	\N
166187	1397	1310867221000	21681	10816	51	0	\N
166188	1397	1310857220000	21681	10816	52	0	\N
166189	1397	1310847219000	21681	10816	53	0	\N
166190	1397	1310837218000	21681	10816	54	0	\N
166191	1397	1310827217000	21681	10816	55	0	\N
166192	1397	1310817216000	21681	10816	56	0	\N
166088	2134	87288148000	21669	10855	2	0	3292
166089	2134	87287145000	21669	10855	3	0	3293
166090	2133	94591616000	21669	10855	4	0	3193
166091	2133	94590614000	21669	10855	5	0	3194
166098	1397	1310837218000	21671	10856	0	0	12799
166100	2133	94589612000	21671	10856	2	0	3195
166101	2133	94588610000	21671	10856	3	0	3196
166102	2134	87286142000	21671	10856	4	0	3294
166103	2134	87285139000	21671	10856	5	0	3295
166104	1397	1310817216000	21673	10857	0	0	12801
166106	2133	94587608000	21673	10857	2	0	3197
166110	1397	1310807215000	21675	10858	0	0	12802
166111	2133	94586606000	21675	10858	1	0	3198
166112	2134	87283133000	21675	10858	2	0	3297
166114	1397	1310797214000	21677	10859	1	0	12803
166115	2133	94585604000	21677	10859	2	0	3199
166116	2134	87282130000	21677	10859	3	0	3298
166117	1397	1310787213000	21678	10860	0	0	12804
166118	2133	94584602000	21678	10860	1	0	3200
166120	1397	1310777212000	21679	10861	0	0	12805
166121	2134	87280124000	21679	10861	1	0	3300
166122	2133	94583600000	21679	10861	2	0	3201
166193	1397	1310807215000	21681	10816	57	0	\N
166194	1397	1310797214000	21681	10816	58	0	\N
166195	1397	1310787213000	21681	10816	59	0	\N
166196	1397	1310777212000	21681	10816	60	0	\N
166197	1397	1310767211000	21681	10816	61	0	\N
166198	1508	18365924556796	21681	10816	62	0	\N
166199	1508	15279852229364	21681	10816	63	0	\N
166200	1508	6680255156616	21681	10816	64	0	\N
166201	2133	95845704000	21681	10816	65	0	\N
166202	2133	95844702000	21681	10816	66	0	\N
166203	2133	95843700000	21681	10816	67	0	\N
166204	2133	95842698000	21681	10816	68	0	\N
166205	2133	95841696000	21681	10816	69	0	\N
166206	2133	95840694000	21681	10816	70	0	\N
166207	2133	95839692000	21681	10816	71	0	\N
166208	2133	95838690000	21681	10816	72	0	\N
166209	2133	95837688000	21681	10816	73	0	\N
166210	2133	95836686000	21681	10816	74	0	\N
166211	2284	199000000	21681	10816	75	0	\N
166212	2284	198000000	21681	10816	76	0	\N
166213	2134	87332280000	21681	10816	77	0	\N
166214	2134	87331277000	21681	10816	78	0	\N
166215	2134	87330274000	21681	10816	79	0	\N
166216	2134	87329271000	21681	10816	80	0	\N
166217	2134	87328268000	21681	10816	81	0	\N
166218	2134	87327265000	21681	10816	82	0	\N
166219	2134	87326262000	21681	10816	83	0	\N
166220	2134	87325259000	21681	10816	84	0	\N
166221	2134	87324256000	21681	10816	85	0	\N
166222	2134	87323253000	21681	10816	86	0	\N
166223	2133	95835684000	21681	10816	87	0	\N
166224	2133	95834682000	21681	10816	88	0	\N
166225	2133	95833680000	21681	10816	89	0	\N
166226	2133	95832678000	21681	10816	90	0	\N
166227	2133	95831676000	21681	10816	91	0	\N
166228	2133	95830674000	21681	10816	92	0	\N
166229	2133	95829672000	21681	10816	93	0	\N
166230	2133	95828670000	21681	10816	94	0	\N
166231	2133	95827668000	21681	10816	95	0	\N
166232	2133	95826666000	21681	10816	96	0	\N
166233	2133	95825664000	21681	10816	97	0	\N
166234	2133	95824662000	21681	10816	98	0	\N
166235	2133	94614662000	21681	10816	99	0	\N
166236	2134	87322250000	21681	10816	100	0	\N
166237	2134	87321247000	21681	10816	101	0	\N
166238	2134	87320244000	21681	10816	102	0	\N
166239	2134	87319241000	21681	10816	103	0	\N
166240	2134	87318238000	21681	10816	104	0	\N
166241	2134	87317235000	21681	10816	105	0	\N
166242	2134	87316232000	21681	10816	106	0	\N
166243	2134	87315229000	21681	10816	107	0	\N
166244	2134	87314226000	21681	10816	108	0	\N
166245	2134	87313223000	21681	10816	109	0	\N
166246	2134	87312220000	21681	10816	110	0	\N
166247	2133	94613660000	21681	10816	111	0	\N
166248	2133	94612658000	21681	10816	112	0	\N
166249	2133	94611656000	21681	10816	113	0	\N
166250	2133	94610654000	21681	10816	114	0	\N
166251	2133	94609652000	21681	10816	115	0	\N
166252	2134	87311217000	21681	10816	116	0	\N
166253	2134	87310214000	21681	10816	117	0	\N
166254	2134	87309211000	21681	10816	118	0	\N
166255	2134	87308208000	21681	10816	119	0	\N
166256	2134	87307205000	21681	10816	120	0	\N
166257	2134	87306202000	21681	10816	121	0	\N
166258	2134	87305199000	21681	10816	122	0	\N
166259	2134	87304196000	21681	10816	123	0	\N
166260	2134	87303193000	21681	10816	124	0	\N
166261	2134	87302190000	21681	10816	125	0	\N
166265	1564	3966553000000	21683	10863	0	0	\N
166266	1397	1310757210000	21683	10863	1	0	\N
166267	2133	94581596000	21683	10863	2	0	\N
166268	2134	87278118000	21683	10863	3	0	\N
166269	1564	3966553000000	21684	10863	0	0	\N
166270	1397	1310757210000	21684	10863	1	0	\N
166271	2133	94581596000	21684	10863	2	0	\N
166272	2134	87278118000	21684	10863	3	0	\N
166277	1564	3966553000000	21686	10863	0	0	\N
166278	1564	3966553000000	21687	10863	0	0	\N
166279	1564	3966553000000	21688	10863	0	0	\N
166280	1397	1310757210000	21688	10863	1	0	\N
166281	1397	1310747209000	21688	10863	2	0	\N
166282	2133	94581596000	21688	10863	3	0	\N
166283	2133	94580594000	21688	10863	4	0	\N
166284	2134	87278118000	21688	10863	5	0	\N
166285	2134	87277115000	21688	10863	6	0	\N
166291	1546	10685356000000	21690	10865	0	0	\N
166292	1546	3312316000000	21690	10865	1	0	\N
166293	1397	1310737208000	21690	10865	2	0	\N
166294	1397	1310727207000	21690	10865	3	0	\N
166295	1397	1310717206000	21690	10865	4	0	\N
166296	2133	94579592000	21690	10865	5	0	\N
166297	2133	94578590000	21690	10865	6	0	\N
166298	2133	94577588000	21690	10865	7	0	\N
166299	2134	87276112000	21690	10865	8	0	\N
166300	2134	87275109000	21690	10865	10	0	\N
166301	2134	87274106000	21690	10865	11	0	\N
166302	1546	10685356000000	21691	10865	0	0	\N
166303	1546	3312316000000	21691	10865	1	0	\N
166304	1397	1310737208000	21691	10865	2	0	\N
166305	1397	1310727207000	21691	10865	3	0	\N
166306	1397	1310717206000	21691	10865	4	0	\N
166307	2133	94579592000	21691	10865	5	0	\N
166308	2133	94578590000	21691	10865	6	0	\N
166309	2133	94577588000	21691	10865	7	0	\N
166310	2134	87276112000	21691	10865	8	0	\N
166311	2134	87275109000	21691	10865	10	0	\N
166312	2134	87274106000	21691	10865	11	0	\N
166327	1397	1310697204000	21694	10867	0	0	\N
166328	1397	1310687203000	21694	10867	1	0	\N
166264	2134	87279121000	21682	10862	2	0	3301
166273	1564	3966553000000	21685	10863	0	0	10
166274	1397	1310757210000	21685	10863	1	0	12807
166275	2133	94581596000	21685	10863	2	0	3203
166276	2134	87278118000	21685	10863	3	0	3302
166287	1546	17252756000000	21689	10864	1	0	7
166288	1546	14606846000000	21689	10864	2	0	8
166289	2134	87277115000	21689	10864	3	0	3303
166290	2133	94580594000	21689	10864	4	0	3204
166313	1546	10685356000000	21692	10865	0	0	9
166315	1397	1310737208000	21692	10865	2	0	12809
166316	1397	1310727207000	21692	10865	3	0	12810
166317	1397	1310717206000	21692	10865	4	0	12811
166318	2133	94579592000	21692	10865	5	0	3205
166320	2133	94577588000	21692	10865	7	0	3207
166321	2134	87276112000	21692	10865	8	0	3304
166322	2134	87275109000	21692	10865	10	0	3305
166323	2134	87274106000	21692	10865	11	0	3306
166324	1397	1310707205000	21693	10866	0	0	12812
166326	2134	87273103000	21693	10866	2	0	3307
166329	2134	87272100000	21694	10867	2	0	\N
166330	2134	87271097000	21694	10867	3	0	\N
166331	2133	94575584000	21694	10867	4	0	\N
166332	2133	94574582000	21694	10867	5	0	\N
166337	1397	1310697204000	21696	10867	0	0	\N
166338	1397	1310687203000	21696	10867	1	0	\N
166339	2134	87272100000	21696	10867	2	0	\N
166340	2134	87271097000	21696	10867	3	0	\N
166341	2133	94575584000	21696	10867	4	0	\N
166342	2133	94574582000	21696	10867	5	0	\N
166348	1397	1310667201000	21698	10869	0	0	\N
166349	2134	87269091000	21698	10869	1	0	\N
166350	2133	94572578000	21698	10869	2	0	\N
166354	1397	1310667201000	21700	10869	0	0	\N
166355	2134	87269091000	21700	10869	1	0	\N
166356	1397	1310667201000	21701	10869	0	0	\N
166357	2134	87269091000	21701	10869	1	0	\N
166358	2133	94572578000	21701	10869	2	0	\N
166376	1397	1310607195000	21705	10872	0	0	\N
166377	2133	94566566000	21705	10872	1	0	\N
166378	2134	87263073000	21705	10872	2	0	\N
166379	2186	522957693786	21706	10873	0	0	\N
166380	1397	1310597194000	21706	10873	1	0	\N
166381	1397	1310587193000	21706	10873	2	0	\N
166382	2134	87262070000	21706	10873	3	0	\N
166383	2134	87261067000	21706	10873	4	0	\N
166395	1397	1310567191000	21709	10875	0	0	\N
166396	1397	1310557190000	21709	10875	1	0	\N
166397	2133	94562558000	21709	10875	2	0	\N
166398	2133	94561556000	21709	10875	3	0	\N
166399	2134	87259061000	21709	10875	4	0	\N
166405	1397	1310567191000	21711	10875	0	0	\N
166406	1397	1310557190000	21711	10875	1	0	\N
166407	2134	87259061000	21711	10875	2	0	\N
166411	1397	1310547189000	21713	10876	0	0	\N
166412	2134	87258058000	21713	10876	1	0	\N
166413	1397	1310537188000	21714	10877	0	0	\N
166414	1397	1310527187000	21714	10877	1	0	\N
166415	2133	94559552000	21714	10877	2	0	\N
166416	2134	87257055000	21714	10877	3	0	\N
166417	2134	87256052000	21714	10877	4	0	\N
166418	2133	94558550000	21714	10877	5	0	\N
166419	1397	1310537188000	21715	10877	0	0	\N
166420	1397	1310527187000	21715	10877	1	0	\N
166421	2133	94559552000	21715	10877	2	0	\N
166422	2134	87257055000	21715	10877	3	0	\N
166423	2134	87256052000	21715	10877	4	0	\N
166424	2133	94558550000	21715	10877	5	0	\N
166452	1397	1310457180000	21721	10881	0	0	\N
166453	2134	87249031000	21721	10881	1	0	\N
166454	2133	94551536000	21721	10881	2	0	\N
166458	1397	1310447179000	21723	10882	0	0	\N
166459	2133	94550534000	21723	10882	1	0	\N
166460	2134	87248028000	21723	10882	2	0	\N
166461	1397	1310447179000	21724	10882	0	0	\N
166462	2133	94550534000	21724	10882	1	0	\N
166463	2134	87248028000	21724	10882	2	0	\N
166464	2134	87247025000	21725	10883	0	0	\N
166335	2134	87272100000	21695	10867	2	0	3308
166336	2134	87271097000	21695	10867	3	0	3309
166343	1397	1310677202000	21697	10868	0	0	12815
166344	2133	94575584000	21697	10868	1	0	3209
166345	2133	94574582000	21697	10868	2	0	3210
166347	2134	87270094000	21697	10868	4	0	3310
166351	1397	1310667201000	21699	10869	0	0	12816
166352	2134	87269091000	21699	10869	1	0	3311
166353	2133	94572578000	21699	10869	2	0	3212
166359	1397	1310657200000	21702	10870	0	0	12817
166361	2133	94571576000	21702	10870	2	0	3213
166362	1397	1310647199000	21703	10871	0	0	12818
166363	1397	1310637198000	21703	10871	1	0	12819
166364	1397	1310627197000	21703	10871	2	0	12820
166366	2133	94570574000	21703	10871	4	0	3214
166367	2133	94569572000	21703	10871	5	0	3215
166368	2133	94568570000	21703	10871	6	0	3216
166369	2133	94567568000	21703	10871	7	0	3217
166370	2134	87267085000	21703	10871	8	0	3313
166372	2134	87265079000	21703	10871	10	0	3315
166373	2134	87264076000	21703	10871	11	0	3316
166374	1397	1310607195000	21704	10872	0	0	12822
166375	2134	87263073000	21704	10872	1	0	3317
166384	2186	522957693786	21707	10873	0	0	1
166386	1397	1310587193000	21707	10873	2	0	12824
166387	2134	87262070000	21707	10873	3	0	3318
166388	2133	94566566000	21707	10873	4	0	3218
166389	2133	94565564000	21707	10873	5	0	3219
166391	2134	87261067000	21707	10873	7	0	3319
166392	1397	1310577192000	21708	10874	0	0	12825
166393	2133	94563560000	21708	10874	1	0	3221
166394	2134	87260064000	21708	10874	2	0	3320
166400	1397	1310567191000	21710	10875	0	0	12826
166402	2133	94562558000	21710	10875	2	0	3222
166403	2133	94561556000	21710	10875	3	0	3223
166404	2134	87259061000	21710	10875	4	0	3321
166408	1397	1310547189000	21712	10876	0	0	12828
166409	2133	94560554000	21712	10876	1	0	3224
166425	1397	1310537188000	21716	10877	0	0	12829
166426	1397	1310527187000	21716	10877	1	0	12830
166427	2133	94559552000	21716	10877	2	0	3225
166428	2134	87257055000	21716	10877	3	0	3323
166430	2133	94558550000	21716	10877	5	0	3226
166431	1397	1310517186000	21717	10878	0	0	12831
166432	1397	1310507185000	21717	10878	1	0	12832
166433	1397	1310497184000	21717	10878	2	0	12833
166434	1397	1310487183000	21717	10878	3	0	12834
166436	2134	87255049000	21717	10878	5	0	3325
166437	2134	87254046000	21717	10878	6	0	3326
166438	2134	87253043000	21717	10878	7	0	3327
166439	2133	94556546000	21717	10878	8	0	3228
166440	2133	94555544000	21717	10878	9	0	3229
166442	2133	94554542000	21717	10878	11	0	3230
166443	1397	1310477182000	21718	10879	0	0	12835
166444	2134	87251037000	21718	10879	1	0	3329
166445	2133	94553540000	21718	10879	2	0	3231
166447	2133	94552538000	21719	10880	1	0	3232
166448	2134	87250034000	21719	10880	2	0	3330
166449	1397	1310457180000	21720	10881	0	0	12837
166450	2134	87249031000	21720	10881	1	0	3331
166451	2133	94551536000	21720	10881	2	0	3233
166456	2133	94550534000	21722	10882	1	0	3234
166457	2134	87248028000	21722	10882	2	0	3332
166465	2133	94549532000	21725	10883	1	0	\N
166468	2134	87247025000	21727	10883	0	0	\N
166469	2133	94549532000	21727	10883	1	0	\N
166472	2186	522957693786	21733	10817	0	0	\N
166473	1564	3966553000000	21733	10817	1	0	\N
166474	1397	1310757210000	21733	10817	2	0	\N
166475	1397	1310747209000	21733	10817	3	0	\N
166476	1397	1310737208000	21733	10817	4	0	\N
166477	1546	17252756000000	21733	10817	5	0	\N
166478	1397	1310727207000	21733	10817	6	0	\N
166479	1397	1310717206000	21733	10817	7	0	\N
166480	1397	1310707205000	21733	10817	8	0	\N
166481	1397	1310697204000	21733	10817	9	0	\N
166482	1397	1310687203000	21733	10817	10	0	\N
166483	1397	1310677202000	21733	10817	11	0	\N
166484	1397	1310667201000	21733	10817	12	0	\N
166485	1397	1310657200000	21733	10817	13	0	\N
166486	1397	1310647199000	21733	10817	14	0	\N
166487	1397	1310637198000	21733	10817	15	0	\N
166488	1397	1310627197000	21733	10817	16	0	\N
166489	1397	1310617196000	21733	10817	17	0	\N
166490	1397	1310607195000	21733	10817	18	0	\N
166491	1397	1310597194000	21733	10817	19	0	\N
166492	1397	1310587193000	21733	10817	20	0	\N
166493	1397	1310577192000	21733	10817	21	0	\N
166494	1397	1310567191000	21733	10817	22	0	\N
166495	1397	1310557190000	21733	10817	23	0	\N
166496	1397	1310547189000	21733	10817	24	0	\N
166497	1397	1310537188000	21733	10817	25	0	\N
166498	1397	1310527187000	21733	10817	26	0	\N
166499	1397	1310517186000	21733	10817	27	0	\N
166500	1397	1310507185000	21733	10817	28	0	\N
166501	1397	1310497184000	21733	10817	29	0	\N
166502	1397	1310487183000	21733	10817	30	0	\N
166503	1397	1310477182000	21733	10817	31	0	\N
166504	1397	1310467181000	21733	10817	32	0	\N
166505	1397	1310457180000	21733	10817	33	0	\N
166506	1397	1310447179000	21733	10817	34	0	\N
166507	1546	14606846000000	21733	10817	35	0	\N
166508	1546	10685356000000	21733	10817	36	0	\N
166509	1546	3312316000000	21733	10817	37	0	\N
166510	2134	87301187000	21733	10817	38	0	\N
166511	2134	87300184000	21733	10817	39	0	\N
166512	2134	87299181000	21733	10817	41	0	\N
166513	2134	87298178000	21733	10817	42	0	\N
166514	2134	87297175000	21733	10817	43	0	\N
166515	2134	87296172000	21733	10817	44	0	\N
166516	2134	87295169000	21733	10817	45	0	\N
166517	2134	87294166000	21733	10817	46	0	\N
166518	2134	87293163000	21733	10817	47	0	\N
166519	2134	87292160000	21733	10817	48	0	\N
166520	2134	87291157000	21733	10817	49	0	\N
166521	2134	87290154000	21733	10817	50	0	\N
166522	2134	87289151000	21733	10817	51	0	\N
166523	2134	87288148000	21733	10817	52	0	\N
166524	2134	87287145000	21733	10817	53	0	\N
166525	2134	87286142000	21733	10817	54	0	\N
166526	2134	87285139000	21733	10817	55	0	\N
166527	2134	87284136000	21733	10817	56	0	\N
166528	2134	87283133000	21733	10817	57	0	\N
166529	2134	87282130000	21733	10817	58	0	\N
166530	2134	87281127000	21733	10817	59	0	\N
166531	2134	87280124000	21733	10817	60	0	\N
166532	2134	87279121000	21733	10817	61	0	\N
166533	2134	87278118000	21733	10817	62	0	\N
166534	2134	87277115000	21733	10817	63	0	\N
166535	2134	87276112000	21733	10817	64	0	\N
166536	2134	87275109000	21733	10817	65	0	\N
166537	2134	87274106000	21733	10817	66	0	\N
166538	2134	87273103000	21733	10817	67	0	\N
166539	2134	87272100000	21733	10817	68	0	\N
166540	2134	87271097000	21733	10817	69	0	\N
166541	2134	87270094000	21733	10817	70	0	\N
166542	2134	87269091000	21733	10817	71	0	\N
166543	2134	87268088000	21733	10817	72	0	\N
166544	2134	87267085000	21733	10817	73	0	\N
166545	2134	87266082000	21733	10817	74	0	\N
166546	2134	87265079000	21733	10817	75	0	\N
166547	2134	87264076000	21733	10817	76	0	\N
166548	2134	87263073000	21733	10817	77	0	\N
166549	2134	87262070000	21733	10817	78	0	\N
166550	2134	87261067000	21733	10817	79	0	\N
166551	2134	87260064000	21733	10817	80	0	\N
166552	2134	87259061000	21733	10817	81	0	\N
166553	2134	87258058000	21733	10817	82	0	\N
166554	2134	87257055000	21733	10817	83	0	\N
166555	2134	87256052000	21733	10817	84	0	\N
166556	2134	87255049000	21733	10817	85	0	\N
166557	2134	87254046000	21733	10817	86	0	\N
166558	2134	87253043000	21733	10817	87	0	\N
166559	2134	87252040000	21733	10817	88	0	\N
166560	2134	87251037000	21733	10817	89	0	\N
166561	2134	87250034000	21733	10817	90	0	\N
166562	2134	87249031000	21733	10817	91	0	\N
166563	2134	87248028000	21733	10817	92	0	\N
166564	2134	87247025000	21733	10817	93	0	\N
166565	2134	87246022000	21733	10817	94	0	\N
166566	2134	87245019000	21733	10817	95	0	\N
166567	2133	94608650000	21733	10817	96	0	\N
166568	2133	94607648000	21733	10817	97	0	\N
166569	2133	94606646000	21733	10817	98	0	\N
166570	2133	94605644000	21733	10817	99	0	\N
166571	2133	94604642000	21733	10817	100	0	\N
166572	2133	94603640000	21733	10817	101	0	\N
166573	2133	94602638000	21733	10817	102	0	\N
166574	2133	94601636000	21733	10817	103	0	\N
166575	2133	94600634000	21733	10817	104	0	\N
166576	2133	94599632000	21733	10817	105	0	\N
166577	2133	94598630000	21733	10817	106	0	\N
166578	2133	94597628000	21733	10817	107	0	\N
166579	2133	94596626000	21733	10817	108	0	\N
166580	2133	94595624000	21733	10817	109	0	\N
166581	2133	94594622000	21733	10817	110	0	\N
166582	2133	94593620000	21733	10817	111	0	\N
166583	2133	94592618000	21733	10817	112	0	\N
166584	2133	94591616000	21733	10817	113	0	\N
166585	2133	94590614000	21733	10817	114	0	\N
166586	2133	94589612000	21733	10817	115	0	\N
166587	2133	94588610000	21733	10817	116	0	\N
166588	2133	94587608000	21733	10817	117	0	\N
166589	2133	94586606000	21733	10817	118	0	\N
166590	2133	94585604000	21733	10817	119	0	\N
166591	2133	94584602000	21733	10817	120	0	\N
166592	2133	94583600000	21733	10817	121	0	\N
166593	2133	94582598000	21733	10817	122	0	\N
166594	2133	94581596000	21733	10817	123	0	\N
166595	2133	94580594000	21733	10817	124	0	\N
166596	2133	94579592000	21733	10817	125	0	\N
166470	2134	87246022000	21728	10884	0	0	3334
166471	2133	94548530000	21728	10884	1	0	3236
166597	2134	87245019000	21734	10886	0	0	3335
166598	1877	719010000000	21734	10886	1	0	1
166599	2134	87244016000	21734	10886	2	0	3336
166606	2134	87245019000	21735	10886	0	0	\N
166607	1877	719010000000	21735	10886	1	0	\N
166608	2134	87244016000	21735	10886	2	0	\N
166609	2134	87243013000	21735	10886	3	0	\N
166610	2134	87242010000	21735	10886	4	0	\N
166611	2133	94547528000	21735	10886	5	0	\N
166612	2133	94546526000	21735	10886	6	0	\N
166613	2133	94545524000	21735	10886	7	0	\N
166614	2133	94544522000	21735	10886	8	0	\N
166615	2134	87245019000	21736	10886	0	0	\N
166616	1877	719010000000	21736	10886	1	0	\N
166617	2134	87244016000	21736	10886	2	0	\N
166618	2134	87243013000	21736	10886	3	0	\N
166619	2134	87242010000	21736	10886	4	0	\N
166620	2133	94547528000	21736	10886	5	0	\N
166621	2133	94546526000	21736	10886	6	0	\N
166622	2133	94545524000	21736	10886	7	0	\N
166623	2133	94544522000	21736	10886	8	0	\N
166624	2186	522957693786	21737	10717	0	0	\N
166625	1564	4687863000000	21737	10717	1	0	\N
166626	1397	1311607295000	21737	10717	2	0	\N
166627	1508	21964393117393	21737	10717	3	0	\N
166628	1573	14899271000000	21737	10717	4	0	\N
166629	886	63455021096354	21737	10717	5	0	\N
166630	885	63455011096354	21737	10717	6	0	\N
166631	1397	1311597294000	21737	10717	7	0	\N
166632	1397	1311587293000	21737	10717	8	0	\N
166633	773	1000000000000	21737	10717	9	0	\N
166634	1693	5941537908632	21737	10717	10	0	\N
166635	1397	1311577292000	21737	10717	11	0	\N
166636	1397	1311567291000	21737	10717	12	0	\N
166637	1397	1311557290000	21737	10717	13	0	\N
166638	1397	1311547289000	21737	10717	14	0	\N
166639	1397	1311537288000	21737	10717	15	0	\N
166640	478	66000000000000	21737	10717	16	0	\N
166641	1397	1311527287000	21737	10717	17	0	\N
166642	1508	17645912556796	21737	10717	18	0	\N
166643	1508	14559840229364	21737	10717	19	0	\N
166644	1508	5960243156616	21737	10717	20	0	\N
166645	1546	17252756000000	21737	10717	21	0	\N
166646	1397	1311517286000	21737	10717	22	0	\N
166647	1397	1311507285000	21737	10717	23	0	\N
166648	1397	1311497284000	21737	10717	24	0	\N
166649	1397	1311487283000	21737	10717	25	0	\N
166650	1397	1311477282000	21737	10717	26	0	\N
166651	1397	1311467281000	21737	10717	27	0	\N
166652	1397	1311457280000	21737	10717	28	0	\N
166653	1397	1311447279000	21737	10717	29	0	\N
166654	1397	1311437278000	21737	10717	30	0	\N
166655	1397	1311427277000	21737	10717	31	0	\N
166656	1397	1311417276000	21737	10717	32	0	\N
166657	1397	1311407275000	21737	10717	33	0	\N
166658	1397	1311397274000	21737	10717	34	0	\N
166659	1397	1311387273000	21737	10717	35	0	\N
166660	1397	1311377272000	21737	10717	36	0	\N
166661	1397	1311367271000	21737	10717	37	0	\N
166662	1397	1311357270000	21737	10717	38	0	\N
166663	1397	1311347269000	21737	10717	39	0	\N
166664	1397	1311337268000	21737	10717	40	0	\N
166665	1397	1311327267000	21737	10717	41	0	\N
166666	1397	1311317266000	21737	10717	42	0	\N
166667	1397	1311307265000	21737	10717	43	0	\N
166668	1397	1311297264000	21737	10717	44	0	\N
166669	1397	1311287263000	21737	10717	45	0	\N
166670	1397	1311277262000	21737	10717	46	0	\N
166671	1397	1311267261000	21737	10717	47	0	\N
166672	1397	1311257260000	21737	10717	48	0	\N
166673	1397	1311247259000	21737	10717	49	0	\N
166674	1397	1311237258000	21737	10717	50	0	\N
166675	1397	1311227257000	21737	10717	51	0	\N
166676	1397	1311217256000	21737	10717	52	0	\N
166677	1397	1311207255000	21737	10717	53	0	\N
166678	1397	1311197254000	21737	10717	54	0	\N
166679	1397	1311187253000	21737	10717	55	0	\N
166680	1397	1311177252000	21737	10717	56	0	\N
166681	1397	1311167251000	21737	10717	57	0	\N
166682	1397	1311157250000	21737	10717	58	0	\N
166683	1397	1311147249000	21737	10717	59	0	\N
166684	1397	1311137248000	21737	10717	60	0	\N
166685	1397	1311127247000	21737	10717	61	0	\N
166686	1397	1311117246000	21737	10717	63	0	\N
166687	1397	1311107245000	21737	10717	64	0	\N
166688	1397	1311097244000	21737	10717	65	0	\N
166689	1397	1311087243000	21737	10717	66	0	\N
166690	1397	1311077242000	21737	10717	67	0	\N
166691	1397	1311067241000	21737	10717	68	0	\N
166692	1397	1311057240000	21737	10717	69	0	\N
166693	1397	1311047239000	21737	10717	70	0	\N
166694	1397	1311037238000	21737	10717	71	0	\N
166695	1397	1311027237000	21737	10717	72	0	\N
166696	1397	1311017236000	21737	10717	73	0	\N
166697	1397	1311007235000	21737	10717	74	0	\N
166698	1397	1310997234000	21737	10717	75	0	\N
166699	1397	1310987233000	21737	10717	76	0	\N
166700	1397	1310977232000	21737	10717	77	0	\N
166701	1397	1310967231000	21737	10717	78	0	\N
166702	1397	1310957230000	21737	10717	79	0	\N
166703	1397	1310947229000	21737	10717	80	0	\N
166704	1397	1310937228000	21737	10717	81	0	\N
166705	1397	1310927227000	21737	10717	82	0	\N
166706	1397	1310917226000	21737	10717	83	0	\N
166707	1397	1310907225000	21737	10717	84	0	\N
166708	1397	1310897224000	21737	10717	85	0	\N
166709	1397	1310887223000	21737	10717	86	0	\N
166710	1397	1310877222000	21737	10717	87	0	\N
166711	1397	1310867221000	21737	10717	88	0	\N
166712	1397	1310857220000	21737	10717	89	0	\N
166713	1397	1310847219000	21737	10717	90	0	\N
166714	1397	1310837218000	21737	10717	91	0	\N
166715	1397	1310827217000	21737	10717	92	0	\N
166716	1397	1310817216000	21737	10717	93	0	\N
166717	1397	1310807215000	21737	10717	94	0	\N
166718	1397	1310797214000	21737	10717	95	0	\N
166719	1397	1310787213000	21737	10717	96	0	\N
166720	1397	1310777212000	21737	10717	97	0	\N
166721	1397	1310767211000	21737	10717	98	0	\N
166722	1397	1310757210000	21737	10717	99	0	\N
166723	1397	1310747209000	21737	10717	100	0	\N
166724	1397	1310737208000	21737	10717	101	0	\N
166725	1397	1310727207000	21737	10717	102	0	\N
166726	1397	1310717206000	21737	10717	103	0	\N
166727	1397	1310707205000	21737	10717	104	0	\N
166728	1397	1310697204000	21737	10717	105	0	\N
166729	1397	1310687203000	21737	10717	106	0	\N
166730	1397	1310677202000	21737	10717	107	0	\N
166731	1397	1310667201000	21737	10717	108	0	\N
166732	1397	1310657200000	21737	10717	109	0	\N
166733	1397	1310647199000	21737	10717	110	0	\N
166734	1397	1310637198000	21737	10717	111	0	\N
166735	1397	1310627197000	21737	10717	112	0	\N
166736	1397	1310617196000	21737	10717	113	0	\N
166603	2133	94546526000	21734	10886	6	0	3238
166604	2133	94545524000	21734	10886	7	0	3239
166605	2133	94544522000	21734	10886	8	0	3240
166737	1397	1310607195000	21737	10717	114	0	\N
166738	1397	1310597194000	21737	10717	115	0	\N
166739	1397	1310587193000	21737	10717	116	0	\N
166740	1397	1310577192000	21737	10717	117	0	\N
166741	1397	1310567191000	21737	10717	118	0	\N
166742	1397	1310557190000	21737	10717	119	0	\N
166743	1397	1310547189000	21737	10717	120	0	\N
166744	1397	1310537188000	21737	10717	121	0	\N
166745	1397	1310527187000	21737	10717	122	0	\N
166746	1397	1310517186000	21737	10717	123	0	\N
166747	1397	1310507185000	21737	10717	124	0	\N
166748	1397	1310497184000	21737	10717	125	0	\N
166755	1397	1310437178000	21739	10887	0	0	\N
166756	1397	1310427177000	21739	10887	1	0	\N
166757	2134	87241007000	21739	10887	2	0	\N
166758	2134	87240004000	21739	10887	3	0	\N
166759	2133	94543520000	21739	10887	4	0	\N
166760	2133	94542518000	21739	10887	5	0	\N
166761	1397	1310437178000	21740	10887	0	0	\N
166762	1397	1310427177000	21740	10887	1	0	\N
166763	2134	87241007000	21740	10887	2	0	\N
166764	2134	87240004000	21740	10887	3	0	\N
166765	2133	94543520000	21740	10887	4	0	\N
166766	2133	94542518000	21740	10887	5	0	\N
166767	1397	1310437178000	21741	10887	0	0	\N
166768	1397	1310427177000	21741	10887	1	0	\N
166769	2134	87241007000	21741	10887	2	0	\N
166770	2134	87240004000	21741	10887	3	0	\N
166771	2133	94543520000	21741	10887	4	0	\N
166772	2133	94542518000	21741	10887	5	0	\N
166773	1397	1310417176000	21742	10888	0	0	\N
166774	2134	87239001000	21742	10888	1	0	\N
166775	2133	94541516000	21742	10888	2	0	\N
166776	1397	1310417176000	21743	10888	0	0	\N
166777	2134	87239001000	21743	10888	1	0	\N
166778	2133	94541516000	21743	10888	2	0	\N
166779	1397	1310417176000	21744	10888	0	0	\N
166780	2134	87239001000	21744	10888	1	0	\N
166781	2133	94541516000	21744	10888	2	0	\N
166791	1397	1310397174000	21748	10890	0	0	\N
166792	2134	87236995000	21748	10890	1	0	\N
166793	2133	94539512000	21748	10890	2	0	\N
166797	1397	1310387173000	21750	10891	0	0	\N
166798	2133	94538510000	21750	10891	1	0	\N
166799	2134	87235992000	21750	10891	2	0	\N
166803	1397	1310377172000	21752	10892	0	0	\N
166804	2134	87234989000	21752	10892	1	0	\N
166805	2133	94537508000	21752	10892	2	0	\N
166806	2186	522957693786	21753	10870	0	0	\N
166807	1397	1310657200000	21753	10870	1	0	\N
166808	1397	1310647199000	21753	10870	2	0	\N
166809	1397	1310637198000	21753	10870	3	0	\N
166810	1397	1310627197000	21753	10870	4	0	\N
166811	1397	1310617196000	21753	10870	5	0	\N
166812	1397	1310607195000	21753	10870	6	0	\N
166813	1397	1310597194000	21753	10870	7	0	\N
166814	1397	1310587193000	21753	10870	8	0	\N
166815	1397	1310577192000	21753	10870	9	0	\N
166816	1397	1310567191000	21753	10870	10	0	\N
166817	1397	1310557190000	21753	10870	11	0	\N
166818	1397	1310547189000	21753	10870	12	0	\N
166819	1397	1310537188000	21753	10870	13	0	\N
166820	1397	1310527187000	21753	10870	14	0	\N
166821	1397	1310517186000	21753	10870	15	0	\N
166822	1397	1310507185000	21753	10870	16	0	\N
166823	1397	1310497184000	21753	10870	17	0	\N
166824	1397	1310487183000	21753	10870	18	0	\N
166825	1397	1310477182000	21753	10870	19	0	\N
166826	1397	1310467181000	21753	10870	20	0	\N
166827	1397	1310457180000	21753	10870	21	0	\N
166828	1397	1310447179000	21753	10870	22	0	\N
166829	1397	1310437178000	21753	10870	23	0	\N
166830	1397	1310427177000	21753	10870	24	0	\N
166831	1397	1310417176000	21753	10870	25	0	\N
166832	1397	1310407175000	21753	10870	26	0	\N
166833	1397	1310397174000	21753	10870	27	0	\N
166834	1397	1310387173000	21753	10870	28	0	\N
166835	1397	1310377172000	21753	10870	29	0	\N
166836	2134	87268088000	21753	10870	30	0	\N
166837	1877	719010000000	21753	10870	31	0	\N
166838	2134	87267085000	21753	10870	32	0	\N
166839	2134	87266082000	21753	10870	33	0	\N
166840	2134	87265079000	21753	10870	34	0	\N
166841	2134	87264076000	21753	10870	35	0	\N
166842	2134	87263073000	21753	10870	36	0	\N
166843	2134	87262070000	21753	10870	37	0	\N
166844	2134	87261067000	21753	10870	38	0	\N
166845	2134	87260064000	21753	10870	39	0	\N
166846	2134	87259061000	21753	10870	40	0	\N
166847	2134	87258058000	21753	10870	41	0	\N
166848	2134	87257055000	21753	10870	42	0	\N
166849	2134	87256052000	21753	10870	43	0	\N
166850	2134	87255049000	21753	10870	44	0	\N
166851	2134	87254046000	21753	10870	45	0	\N
166852	2134	87253043000	21753	10870	46	0	\N
166853	2134	87252040000	21753	10870	47	0	\N
166854	2134	87251037000	21753	10870	48	0	\N
166855	2134	87250034000	21753	10870	49	0	\N
166856	2134	87249031000	21753	10870	50	0	\N
166857	2134	87248028000	21753	10870	51	0	\N
166858	2134	87247025000	21753	10870	52	0	\N
166859	2134	87246022000	21753	10870	53	0	\N
166860	2134	87245019000	21753	10870	54	0	\N
166861	2134	87244016000	21753	10870	55	0	\N
166862	2134	87243013000	21753	10870	56	0	\N
166863	2134	87242010000	21753	10870	57	0	\N
166864	2134	87241007000	21753	10870	58	0	\N
166865	2134	87240004000	21753	10870	59	0	\N
166866	2134	87239001000	21753	10870	60	0	\N
166867	2134	87237998000	21753	10870	61	0	\N
166868	2134	87236995000	21753	10870	62	0	\N
166869	2134	87235992000	21753	10870	63	0	\N
166870	2134	87234989000	21753	10870	64	0	\N
166871	2133	94571576000	21753	10870	65	0	\N
166872	2133	94570574000	21753	10870	66	0	\N
166751	2134	87241007000	21738	10887	2	0	3339
166752	2134	87240004000	21738	10887	3	0	3340
166753	2133	94543520000	21738	10887	4	0	3241
166754	2133	94542518000	21738	10887	5	0	3242
166782	1397	1310417176000	21745	10888	0	0	12841
166784	2133	94541516000	21745	10888	2	0	3243
166785	1397	1310407175000	21746	10889	0	0	12842
166786	2134	87237998000	21746	10889	1	0	3342
166787	2133	94540514000	21746	10889	2	0	3244
166788	1397	1310397174000	21747	10890	0	0	12843
166790	2133	94539512000	21747	10890	2	0	3245
166794	1397	1310387173000	21749	10891	0	0	12844
166795	2133	94538510000	21749	10891	1	0	3246
166796	2134	87235992000	21749	10891	2	0	3344
166801	2134	87234989000	21751	10892	1	0	3345
166802	2133	94537508000	21751	10892	2	0	3247
166873	2133	94569572000	21753	10870	67	0	\N
166874	2133	94568570000	21753	10870	68	0	\N
166875	2133	94567568000	21753	10870	69	0	\N
166876	2133	94566566000	21753	10870	70	0	\N
166877	2133	94565564000	21753	10870	71	0	\N
166878	2133	94564562000	21753	10870	72	0	\N
166879	2133	94563560000	21753	10870	73	0	\N
166880	2133	94562558000	21753	10870	74	0	\N
166881	2133	94561556000	21753	10870	75	0	\N
166882	2133	94560554000	21753	10870	76	0	\N
166883	2133	94559552000	21753	10870	77	0	\N
166884	2133	94558550000	21753	10870	78	0	\N
166885	2133	94557548000	21753	10870	79	0	\N
166886	2133	94556546000	21753	10870	80	0	\N
166887	2133	94555544000	21753	10870	81	0	\N
166888	2133	94554542000	21753	10870	82	0	\N
166889	2133	94553540000	21753	10870	83	0	\N
166890	2133	94552538000	21753	10870	84	0	\N
166891	2133	94551536000	21753	10870	85	0	\N
166892	2133	94550534000	21753	10870	86	0	\N
166893	2133	94549532000	21753	10870	87	0	\N
166894	2133	94548530000	21753	10870	88	0	\N
166895	2133	94547528000	21753	10870	89	0	\N
166896	2133	94546526000	21753	10870	90	0	\N
166897	2133	94545524000	21753	10870	91	0	\N
166898	2133	94544522000	21753	10870	92	0	\N
166899	2133	94543520000	21753	10870	93	0	\N
166900	2133	94542518000	21753	10870	94	0	\N
166901	2133	94541516000	21753	10870	95	0	\N
166902	2133	94540514000	21753	10870	96	0	\N
166903	2133	94539512000	21753	10870	97	0	\N
166904	2133	94538510000	21753	10870	98	0	\N
166905	2133	94537508000	21753	10870	99	0	\N
166906	2186	522957693786	21754	10766	0	0	\N
166907	1564	3966553000000	21754	10766	1	0	\N
166908	1546	17252756000000	21754	10766	2	0	\N
166909	1546	14606846000000	21754	10766	3	0	\N
166910	1546	10685356000000	21754	10766	4	0	\N
166911	1546	3312316000000	21754	10766	5	0	\N
166912	1877	719010000000	21754	10766	6	0	\N
166916	1397	1310367171000	21756	10893	0	0	\N
166917	2133	94536506000	21756	10893	1	0	\N
166918	2134	87233986000	21756	10893	2	0	\N
166925	1397	1310367171000	21759	10871	0	0	\N
166926	1397	1310357170000	21759	10871	1	0	\N
166927	1397	1310347169000	21759	10871	2	0	\N
166928	2133	94536506000	21759	10871	3	0	\N
166929	2133	94535504000	21759	10871	4	0	\N
166930	2133	94534502000	21759	10871	5	0	\N
166931	2134	87233986000	21759	10871	6	0	\N
166932	2134	87232983000	21759	10871	7	0	\N
166933	2134	87231980000	21759	10871	8	0	\N
166936	1397	1310337168000	21761	10896	0	0	\N
166937	2134	87230977000	21761	10896	1	0	\N
166938	2133	94533500000	21761	10896	2	0	\N
166939	1397	1310337168000	21762	10896	0	0	\N
166940	2134	87230977000	21762	10896	1	0	\N
166941	2133	94533500000	21762	10896	2	0	\N
166949	1397	1310317166000	21766	10898	0	0	\N
166950	2134	87228971000	21766	10898	1	0	\N
166951	2133	94531496000	21766	10898	2	0	\N
166952	1397	1310307165000	21767	10899	0	0	\N
166953	1397	1310297164000	21767	10899	1	0	\N
166954	2134	87227968000	21767	10899	2	0	\N
166955	2133	94530494000	21767	10899	3	0	\N
166956	2133	94529492000	21767	10899	4	0	\N
166957	2134	87226965000	21767	10899	5	0	\N
166964	1397	1310307165000	21769	10899	0	0	\N
166965	1397	1310297164000	21769	10899	1	0	\N
166966	2134	87227968000	21769	10899	2	0	\N
166967	2133	94530494000	21769	10899	3	0	\N
166968	2133	94529492000	21769	10899	4	0	\N
166969	2134	87226965000	21769	10899	5	0	\N
166970	1397	1310287163000	21770	10900	0	0	\N
166971	2134	87225962000	21770	10900	1	0	\N
166972	2133	94528490000	21770	10900	2	0	\N
166979	1397	1310277162000	21773	10901	0	0	\N
166980	2134	87224959000	21773	10901	1	0	\N
166981	2133	94527488000	21773	10901	2	0	\N
166994	1397	1310437178000	21776	10818	0	0	\N
166995	1397	1310427177000	21776	10818	1	0	\N
166996	1397	1310417176000	21776	10818	2	0	\N
166997	1397	1310407175000	21776	10818	3	0	\N
166998	1397	1310397174000	21776	10818	4	0	\N
166999	1397	1310387173000	21776	10818	5	0	\N
167000	1397	1310377172000	21776	10818	6	0	\N
167001	1397	1310367171000	21776	10818	7	0	\N
167002	1397	1310357170000	21776	10818	8	0	\N
167003	1397	1310347169000	21776	10818	9	0	\N
167004	1397	1310337168000	21776	10818	10	0	\N
167005	1397	1310327167000	21776	10818	11	0	\N
167006	1397	1310317166000	21776	10818	12	0	\N
167007	1397	1310307165000	21776	10818	13	0	\N
167008	1397	1310297164000	21776	10818	14	0	\N
166915	2134	87233986000	21755	10893	2	0	3346
166919	1397	1310357170000	21757	10894	0	0	12847
166920	2133	94535504000	21757	10894	1	0	3249
166921	2134	87232983000	21757	10894	2	0	3347
166922	1397	1310347169000	21758	10895	0	0	12848
166924	2133	94534502000	21758	10895	2	0	3250
166934	1397	1310337168000	21760	10896	0	0	12849
166935	2134	87230977000	21760	10896	1	0	3349
166942	1397	1310327167000	21763	10897	0	0	12850
166943	2133	94533500000	21763	10897	1	0	3251
166945	2133	94532498000	21763	10897	3	0	3252
166946	1397	1310317166000	21765	10898	0	0	12851
166947	2134	87228971000	21765	10898	1	0	3351
166948	2133	94531496000	21765	10898	2	0	3253
166959	1397	1310297164000	21768	10899	1	0	12853
166960	2134	87227968000	21768	10899	2	0	3352
166961	2133	94530494000	21768	10899	3	0	3254
166962	2133	94529492000	21768	10899	4	0	3255
166963	2134	87226965000	21768	10899	5	0	3353
166974	2134	87225962000	21771	10900	1	0	3354
166975	2133	94528490000	21771	10900	2	0	3256
166976	1397	1310277162000	21772	10901	0	0	12855
166977	2134	87224959000	21772	10901	1	0	3355
166978	2133	94527488000	21772	10901	2	0	3257
166983	2134	87223956000	21774	10902	1	0	3356
166984	2133	94526486000	21774	10902	2	0	3258
166985	1397	1310257160000	21775	10903	0	0	12857
166986	1397	1310247159000	21775	10903	1	0	12858
166988	2133	94525484000	21775	10903	3	0	3259
166989	2133	94524482000	21775	10903	4	0	3260
166990	2133	94523480000	21775	10903	5	0	3261
166991	2134	87222953000	21775	10903	6	0	3357
166992	2134	87221950000	21775	10903	7	0	3358
167009	1397	1310287163000	21776	10818	15	0	\N
167010	1397	1310277162000	21776	10818	16	0	\N
167011	1397	1310267161000	21776	10818	17	0	\N
167012	1397	1310257160000	21776	10818	18	0	\N
167013	1397	1310247159000	21776	10818	19	0	\N
167014	1397	1310237158000	21776	10818	20	0	\N
167015	1397	1310227157000	21776	10818	21	0	\N
167016	2133	94578590000	21776	10818	22	0	\N
167017	2133	94577588000	21776	10818	23	0	\N
167018	1877	719010000000	21776	10818	24	0	\N
167019	2134	87244016000	21776	10818	25	0	\N
167020	2134	87243013000	21776	10818	26	0	\N
167021	2134	87242010000	21776	10818	27	0	\N
167022	2134	87241007000	21776	10818	28	0	\N
167023	2133	94576586000	21776	10818	29	0	\N
167024	2133	94575584000	21776	10818	30	0	\N
167025	2133	94574582000	21776	10818	31	0	\N
167026	2133	94573580000	21776	10818	32	0	\N
167027	2133	94572578000	21776	10818	33	0	\N
167028	2134	87240004000	21776	10818	34	0	\N
167029	2134	87239001000	21776	10818	35	0	\N
167030	2134	87237998000	21776	10818	36	0	\N
167031	2134	87236995000	21776	10818	37	0	\N
167032	2134	87235992000	21776	10818	38	0	\N
167033	2134	87234989000	21776	10818	39	0	\N
167034	2134	87233986000	21776	10818	41	0	\N
167035	2134	87232983000	21776	10818	42	0	\N
167036	2134	87231980000	21776	10818	43	0	\N
167037	2134	87230977000	21776	10818	44	0	\N
167038	2134	87229974000	21776	10818	45	0	\N
167039	2134	87228971000	21776	10818	46	0	\N
167040	2134	87227968000	21776	10818	47	0	\N
167041	2134	87226965000	21776	10818	48	0	\N
167042	2134	87225962000	21776	10818	49	0	\N
167043	2134	87224959000	21776	10818	50	0	\N
167044	2134	87223956000	21776	10818	51	0	\N
167045	2133	94571576000	21776	10818	52	0	\N
167046	2133	94570574000	21776	10818	53	0	\N
167047	2133	94569572000	21776	10818	54	0	\N
167048	2133	94568570000	21776	10818	55	0	\N
167049	2133	94567568000	21776	10818	56	0	\N
167050	2133	94566566000	21776	10818	57	0	\N
167051	2133	94565564000	21776	10818	58	0	\N
167052	2133	94564562000	21776	10818	59	0	\N
167053	2133	94563560000	21776	10818	60	0	\N
167054	2133	94562558000	21776	10818	61	0	\N
167055	2133	94561556000	21776	10818	62	0	\N
167056	2133	94560554000	21776	10818	63	0	\N
167057	2133	94559552000	21776	10818	64	0	\N
167058	2134	87222953000	21776	10818	65	0	\N
167059	2134	87221950000	21776	10818	66	0	\N
167060	2134	87220947000	21776	10818	67	0	\N
167061	2134	87219944000	21776	10818	68	0	\N
167062	2133	94558550000	21776	10818	69	0	\N
167072	1397	1310197154000	21780	10906	0	0	\N
167073	2133	94519472000	21780	10906	1	0	\N
167074	2134	87216935000	21780	10906	2	0	\N
167075	1397	1310197154000	21781	10906	0	0	\N
167076	2133	94519472000	21781	10906	1	0	\N
167077	2134	87216935000	21781	10906	2	0	\N
167078	1397	1310197154000	21783	10906	0	0	\N
167079	2133	94519472000	21783	10906	1	0	\N
167080	2134	87216935000	21783	10906	2	0	\N
167083	1397	1310197154000	21785	10906	0	0	\N
167084	2133	94519472000	21785	10906	1	0	\N
167085	2134	87216935000	21785	10906	2	0	\N
167092	1397	1310177152000	21788	10908	0	0	\N
167093	2133	94517468000	21788	10908	1	0	\N
167094	2134	87215932000	21788	10908	2	0	\N
167095	1397	1310167151000	21789	10909	0	0	\N
167096	1397	1310157150000	21789	10909	1	0	\N
167097	2134	87214929000	21789	10909	2	0	\N
167098	2133	94516466000	21789	10909	3	0	\N
167099	2133	94515464000	21789	10909	4	0	\N
167100	2133	94514462000	21789	10909	5	0	\N
167101	2134	87213926000	21789	10909	6	0	\N
167102	2134	87212923000	21789	10909	7	0	\N
167111	1397	1310147149000	21791	10910	0	0	\N
167112	1573	8682270000000	21791	10910	1	0	\N
167113	1573	5375269000000	21791	10910	2	0	\N
167114	1573	3144268000000	21791	10910	3	0	\N
167115	2133	94513460000	21791	10910	4	0	\N
167116	1573	1299267000000	21791	10910	5	0	\N
167117	2134	87211920000	21791	10910	6	0	\N
167118	1397	1310347169000	21792	10895	0	0	\N
167119	1397	1310337168000	21792	10895	1	0	\N
167120	1397	1310327167000	21792	10895	2	0	\N
167121	1397	1310317166000	21792	10895	3	0	\N
167122	1397	1310307165000	21792	10895	4	0	\N
167123	1397	1310297164000	21792	10895	5	0	\N
167124	1397	1310287163000	21792	10895	6	0	\N
167125	1397	1310277162000	21792	10895	7	0	\N
167126	1397	1310267161000	21792	10895	8	0	\N
167127	1397	1310257160000	21792	10895	9	0	\N
167128	1397	1310247159000	21792	10895	10	0	\N
167129	1397	1310237158000	21792	10895	11	0	\N
167130	1397	1310227157000	21792	10895	12	0	\N
167131	1397	1310217156000	21792	10895	13	0	\N
167132	1397	1310207155000	21792	10895	14	0	\N
167133	1397	1310197154000	21792	10895	15	0	\N
167134	1397	1310187153000	21792	10895	16	0	\N
167135	1397	1310177152000	21792	10895	17	0	\N
167136	1397	1310167151000	21792	10895	18	0	\N
167137	1397	1310157150000	21792	10895	19	0	\N
167138	1397	1310147149000	21792	10895	20	0	\N
167139	2134	87231980000	21792	10895	21	0	\N
167140	2134	87230977000	21792	10895	22	0	\N
167141	2134	87229974000	21792	10895	23	0	\N
167142	2134	87228971000	21792	10895	24	0	\N
167143	2134	87227968000	21792	10895	25	0	\N
167144	1573	8682270000000	21792	10895	26	0	\N
167065	2134	87219944000	21777	10904	2	0	3360
167066	2134	87218941000	21777	10904	3	0	3361
167067	2133	94522478000	21777	10904	4	0	3262
167068	2133	94521476000	21777	10904	5	0	3263
167069	1397	1310207155000	21779	10905	0	0	12862
167071	2133	94520474000	21779	10905	2	0	3264
167081	1397	1310197154000	21784	10906	0	0	12863
167082	2134	87216935000	21784	10906	1	0	3363
167086	1397	1310187153000	21786	10907	0	0	12864
167087	2133	94519472000	21786	10907	1	0	3265
167089	1397	1310177152000	21787	10908	0	0	12865
167090	2133	94517468000	21787	10908	1	0	3267
167091	2134	87215932000	21787	10908	2	0	3364
167103	1397	1310167151000	21790	10909	0	0	12866
167105	2134	87214929000	21790	10909	2	0	3365
167106	2133	94516466000	21790	10909	3	0	3268
167107	2133	94515464000	21790	10909	4	0	3269
167108	2133	94514462000	21790	10909	5	0	3270
167109	2134	87213926000	21790	10909	6	0	3366
167145	1573	5375269000000	21792	10895	27	0	\N
167146	1573	3144268000000	21792	10895	28	0	\N
167147	1573	1299267000000	21792	10895	29	0	\N
167148	2133	94534502000	21792	10895	30	0	\N
167149	2133	94533500000	21792	10895	31	0	\N
167150	2134	87226965000	21792	10895	32	0	\N
167151	2134	87225962000	21792	10895	33	0	\N
167152	2134	87224959000	21792	10895	34	0	\N
167153	2134	87223956000	21792	10895	35	0	\N
167154	2133	94532498000	21792	10895	36	0	\N
167155	2133	94531496000	21792	10895	37	0	\N
167156	2133	94530494000	21792	10895	38	0	\N
167157	2133	94529492000	21792	10895	39	0	\N
167158	2133	94528490000	21792	10895	40	0	\N
167159	2133	94527488000	21792	10895	41	0	\N
167160	2134	87222953000	21792	10895	42	0	\N
167161	2134	87221950000	21792	10895	43	0	\N
167162	2134	87220947000	21792	10895	44	0	\N
167163	2134	87219944000	21792	10895	45	0	\N
167164	2134	87218941000	21792	10895	46	0	\N
167165	2134	87217938000	21792	10895	47	0	\N
167166	2134	87216935000	21792	10895	48	0	\N
167167	2134	87215932000	21792	10895	49	0	\N
167168	2134	87214929000	21792	10895	50	0	\N
167169	2134	87213926000	21792	10895	51	0	\N
167170	2134	87212923000	21792	10895	52	0	\N
167171	2134	87211920000	21792	10895	53	0	\N
167172	2133	94526486000	21792	10895	54	0	\N
167173	2133	94525484000	21792	10895	55	0	\N
167174	2133	94524482000	21792	10895	56	0	\N
167175	2133	94523480000	21792	10895	57	0	\N
167176	2133	94522478000	21792	10895	58	0	\N
167177	2133	94521476000	21792	10895	59	0	\N
167178	2133	94520474000	21792	10895	60	0	\N
167179	2133	94519472000	21792	10895	61	0	\N
167180	2133	94518470000	21792	10895	62	0	\N
167181	2133	94517468000	21792	10895	63	0	\N
167182	2133	94516466000	21792	10895	64	0	\N
167183	2133	94515464000	21792	10895	65	0	\N
167184	2133	94514462000	21792	10895	66	0	\N
167185	2133	94513460000	21792	10895	67	0	\N
167199	2186	522957693786	21795	10839	0	0	\N
167200	1564	3966553000000	21795	10839	1	0	\N
167201	1573	14899271000000	21795	10839	2	0	\N
167202	886	63455021096354	21795	10839	3	0	\N
167203	885	63455011096354	21795	10839	4	0	\N
167204	773	1000000000000	21795	10839	5	0	\N
167205	1693	7381573908632	21795	10839	6	0	\N
167206	478	66000000000000	21795	10839	7	0	\N
167207	1397	1311037238000	21795	10839	8	0	\N
167208	1397	1311027237000	21795	10839	9	0	\N
167209	1397	1311017236000	21795	10839	10	0	\N
167210	1397	1311007235000	21795	10839	11	0	\N
167211	1397	1310997234000	21795	10839	12	0	\N
167212	1397	1310987233000	21795	10839	13	0	\N
167213	1397	1310977232000	21795	10839	14	0	\N
167214	1397	1310967231000	21795	10839	15	0	\N
167215	1397	1310957230000	21795	10839	16	0	\N
167216	1397	1310947229000	21795	10839	17	0	\N
167217	1397	1310937228000	21795	10839	18	0	\N
167218	1397	1310927227000	21795	10839	19	0	\N
167219	1397	1310917226000	21795	10839	20	0	\N
167220	1397	1310907225000	21795	10839	21	0	\N
167221	1397	1310897224000	21795	10839	22	0	\N
167222	1397	1310887223000	21795	10839	23	0	\N
167223	1397	1310877222000	21795	10839	24	0	\N
167224	1397	1310867221000	21795	10839	25	0	\N
167225	1397	1310857220000	21795	10839	26	0	\N
167226	1397	1310847219000	21795	10839	27	0	\N
167227	1397	1310837218000	21795	10839	28	0	\N
167228	1397	1310827217000	21795	10839	29	0	\N
167229	1397	1310817216000	21795	10839	30	0	\N
167230	1397	1310807215000	21795	10839	31	0	\N
167231	1397	1310797214000	21795	10839	32	0	\N
167232	1397	1310787213000	21795	10839	33	0	\N
167233	1397	1310777212000	21795	10839	34	0	\N
167234	1397	1310767211000	21795	10839	35	0	\N
167235	1397	1310757210000	21795	10839	36	0	\N
167236	1397	1310747209000	21795	10839	37	0	\N
167237	1508	18365924556796	21795	10839	38	0	\N
167238	1508	15279852229364	21795	10839	40	0	\N
167239	1508	6680255156616	21795	10839	41	0	\N
167240	1397	1310737208000	21795	10839	42	0	\N
167241	1546	17252756000000	21795	10839	43	0	\N
167242	1397	1310727207000	21795	10839	44	0	\N
167243	1397	1310717206000	21795	10839	45	0	\N
167244	1397	1310707205000	21795	10839	46	0	\N
167245	1397	1310697204000	21795	10839	47	0	\N
167246	1397	1310687203000	21795	10839	48	0	\N
167247	1397	1310677202000	21795	10839	49	0	\N
167248	1397	1310667201000	21795	10839	50	0	\N
167249	1397	1310657200000	21795	10839	51	0	\N
167250	1397	1310647199000	21795	10839	52	0	\N
167251	1397	1310637198000	21795	10839	53	0	\N
167252	1397	1310627197000	21795	10839	54	0	\N
167253	1397	1310617196000	21795	10839	55	0	\N
167254	1397	1310607195000	21795	10839	56	0	\N
167255	1397	1310597194000	21795	10839	57	0	\N
167256	1397	1310587193000	21795	10839	58	0	\N
167257	1397	1310577192000	21795	10839	59	0	\N
167258	1397	1310567191000	21795	10839	60	0	\N
167259	1397	1310557190000	21795	10839	61	0	\N
167260	1397	1310547189000	21795	10839	62	0	\N
167261	1397	1310537188000	21795	10839	63	0	\N
167262	1397	1310527187000	21795	10839	64	0	\N
167263	1397	1310517186000	21795	10839	65	0	\N
167264	1397	1310507185000	21795	10839	66	0	\N
167265	1397	1310497184000	21795	10839	67	0	\N
167266	1397	1310487183000	21795	10839	68	0	\N
167267	1397	1310477182000	21795	10839	69	0	\N
167268	1397	1310467181000	21795	10839	70	0	\N
167269	1397	1310457180000	21795	10839	71	0	\N
167270	1397	1310447179000	21795	10839	72	0	\N
167271	1397	1310437178000	21795	10839	73	0	\N
167272	1397	1310427177000	21795	10839	74	0	\N
167273	1397	1310417176000	21795	10839	75	0	\N
167274	1397	1310407175000	21795	10839	76	0	\N
167275	1397	1310397174000	21795	10839	77	0	\N
167276	1397	1310387173000	21795	10839	78	0	\N
167277	1397	1310377172000	21795	10839	79	0	\N
167278	1397	1310367171000	21795	10839	80	0	\N
167279	1397	1310357170000	21795	10839	81	0	\N
167280	1397	1310347169000	21795	10839	82	0	\N
167188	1573	5375269000000	21793	10910	2	0	8
167189	1573	3144268000000	21793	10910	3	0	9
167190	2133	94513460000	21793	10910	4	0	3271
167191	1573	1299267000000	21793	10910	5	0	10
167192	2134	87211920000	21793	10910	6	0	3368
167194	1397	1310127147000	21794	10911	1	0	12870
167195	2133	94512458000	21794	10911	2	0	3272
167196	2133	94511456000	21794	10911	3	0	3273
167197	2134	87210917000	21794	10911	4	0	3369
167198	2134	87209914000	21794	10911	5	0	3370
167281	1397	1310337168000	21795	10839	83	0	\N
167282	1397	1310327167000	21795	10839	84	0	\N
167283	1397	1310317166000	21795	10839	85	0	\N
167284	1397	1310307165000	21795	10839	86	0	\N
167285	1397	1310297164000	21795	10839	87	0	\N
167286	1397	1310287163000	21795	10839	88	0	\N
167287	1397	1310277162000	21795	10839	89	0	\N
167288	1397	1310267161000	21795	10839	90	0	\N
167289	1397	1310257160000	21795	10839	91	0	\N
167290	1397	1310247159000	21795	10839	92	0	\N
167291	1397	1310237158000	21795	10839	93	0	\N
167292	1397	1310227157000	21795	10839	94	0	\N
167293	1397	1310217156000	21795	10839	95	0	\N
167294	1397	1310207155000	21795	10839	96	0	\N
167295	1397	1310197154000	21795	10839	97	0	\N
167296	1397	1310187153000	21795	10839	98	0	\N
167297	1397	1310177152000	21795	10839	99	0	\N
167298	1397	1310167151000	21795	10839	100	0	\N
167299	1397	1310157150000	21795	10839	101	0	\N
167300	1397	1310147149000	21795	10839	102	0	\N
167301	1397	1310137148000	21795	10839	103	0	\N
167302	1397	1310127147000	21795	10839	104	0	\N
167303	1397	1310117146000	21795	10839	105	0	\N
167304	1546	14606846000000	21795	10839	106	0	\N
167305	1546	10685356000000	21795	10839	107	0	\N
167306	1546	3312316000000	21795	10839	108	0	\N
167307	2134	87307205000	21795	10839	109	0	\N
167308	2134	87306202000	21795	10839	110	0	\N
167309	1877	719010000000	21795	10839	111	0	\N
167310	1573	8682270000000	21795	10839	112	0	\N
167311	1573	5375269000000	21795	10839	113	0	\N
167312	1573	3144268000000	21795	10839	114	0	\N
167313	2133	94610654000	21795	10839	115	0	\N
167314	2133	94609652000	21795	10839	116	0	\N
167315	1573	1299267000000	21795	10839	117	0	\N
167316	2134	87305199000	21795	10839	118	0	\N
167317	2134	87304196000	21795	10839	119	0	\N
167318	2134	87303193000	21795	10839	120	0	\N
167319	2134	87302190000	21795	10839	121	0	\N
167320	2134	87301187000	21795	10839	122	0	\N
167321	2134	87300184000	21795	10839	123	0	\N
167322	2134	87299181000	21795	10839	124	0	\N
167323	2134	87298178000	21795	10839	125	0	\N
167324	1397	1310447179000	21796	10882	0	0	\N
167325	1397	1310437178000	21796	10882	1	0	\N
167326	1397	1310427177000	21796	10882	2	0	\N
167327	1397	1310417176000	21796	10882	3	0	\N
167328	1397	1310407175000	21796	10882	4	0	\N
167329	1397	1310397174000	21796	10882	5	0	\N
167330	1397	1310387173000	21796	10882	6	0	\N
167331	1397	1310377172000	21796	10882	7	0	\N
167332	1397	1310367171000	21796	10882	8	0	\N
167333	1397	1310357170000	21796	10882	9	0	\N
167334	1397	1310347169000	21796	10882	10	0	\N
167335	1397	1310337168000	21796	10882	11	0	\N
167336	1397	1310327167000	21796	10882	12	0	\N
167337	1397	1310317166000	21796	10882	14	0	\N
167338	1397	1310307165000	21796	10882	15	0	\N
167339	1397	1310297164000	21796	10882	16	0	\N
167340	1397	1310287163000	21796	10882	17	0	\N
167341	1397	1310277162000	21796	10882	18	0	\N
167342	1397	1310267161000	21796	10882	19	0	\N
167343	1397	1310257160000	21796	10882	20	0	\N
167344	1397	1310247159000	21796	10882	21	0	\N
167345	1397	1310237158000	21796	10882	22	0	\N
167346	1397	1310227157000	21796	10882	23	0	\N
167347	1397	1310217156000	21796	10882	24	0	\N
167348	1397	1310207155000	21796	10882	25	0	\N
167349	1397	1310197154000	21796	10882	26	0	\N
167350	1397	1310187153000	21796	10882	27	0	\N
167351	1397	1310177152000	21796	10882	28	0	\N
167352	1397	1310167151000	21796	10882	29	0	\N
167353	1397	1310157150000	21796	10882	30	0	\N
167354	1397	1310147149000	21796	10882	31	0	\N
167355	1397	1310137148000	21796	10882	32	0	\N
167356	1397	1310127147000	21796	10882	33	0	\N
167357	1397	1310117146000	21796	10882	34	0	\N
167358	2133	94550534000	21796	10882	35	0	\N
167359	1877	719010000000	21796	10882	36	0	\N
167360	1573	8682270000000	21796	10882	37	0	\N
167361	1573	5375269000000	21796	10882	38	0	\N
167362	1573	3144268000000	21796	10882	39	0	\N
167363	1573	1299267000000	21796	10882	40	0	\N
167364	2134	87248028000	21796	10882	41	0	\N
167365	2134	87247025000	21796	10882	42	0	\N
167366	2134	87246022000	21796	10882	43	0	\N
167367	2134	87245019000	21796	10882	44	0	\N
167368	2134	87244016000	21796	10882	45	0	\N
167369	2134	87243013000	21796	10882	46	0	\N
167370	2134	87242010000	21796	10882	47	0	\N
167371	2134	87241007000	21796	10882	48	0	\N
167372	2134	87240004000	21796	10882	49	0	\N
167373	2134	87239001000	21796	10882	50	0	\N
167374	2134	87237998000	21796	10882	51	0	\N
167375	2134	87236995000	21796	10882	52	0	\N
167376	2134	87235992000	21796	10882	53	0	\N
167377	2134	87234989000	21796	10882	54	0	\N
167378	2134	87233986000	21796	10882	55	0	\N
167379	2134	87232983000	21796	10882	56	0	\N
167380	2134	87231980000	21796	10882	57	0	\N
167381	2134	87230977000	21796	10882	58	0	\N
167382	2134	87229974000	21796	10882	59	0	\N
167383	2134	87228971000	21796	10882	60	0	\N
167384	2134	87227968000	21796	10882	61	0	\N
167385	2134	87226965000	21796	10882	62	0	\N
167386	2134	87225962000	21796	10882	63	0	\N
167387	2134	87224959000	21796	10882	64	0	\N
167388	2134	87223956000	21796	10882	65	0	\N
167389	2134	87222953000	21796	10882	66	0	\N
167390	2134	87221950000	21796	10882	67	0	\N
167391	2134	87220947000	21796	10882	68	0	\N
167392	2134	87219944000	21796	10882	69	0	\N
167393	2134	87218941000	21796	10882	70	0	\N
167394	2134	87217938000	21796	10882	71	0	\N
167395	2134	87216935000	21796	10882	72	0	\N
167396	2134	87215932000	21796	10882	73	0	\N
167397	2134	87214929000	21796	10882	74	0	\N
167398	2134	87213926000	21796	10882	75	0	\N
167399	2134	87212923000	21796	10882	76	0	\N
167400	2134	87211920000	21796	10882	77	0	\N
167401	2134	87210917000	21796	10882	78	0	\N
167402	2134	87209914000	21796	10882	79	0	\N
167403	2134	87208911000	21796	10882	80	0	\N
167404	2133	94549532000	21796	10882	81	0	\N
167405	2133	94548530000	21796	10882	82	0	\N
167406	2133	94547528000	21796	10882	83	0	\N
167407	2133	94546526000	21796	10882	84	0	\N
167408	2133	94545524000	21796	10882	85	0	\N
167409	2133	94544522000	21796	10882	86	0	\N
167410	2133	94543520000	21796	10882	87	0	\N
167411	2133	94542518000	21796	10882	88	0	\N
167412	2133	94541516000	21796	10882	89	0	\N
167413	2133	94540514000	21796	10882	90	0	\N
167414	2133	94539512000	21796	10882	91	0	\N
167415	2133	94538510000	21796	10882	92	0	\N
167416	2133	94537508000	21796	10882	93	0	\N
167417	2133	94536506000	21796	10882	94	0	\N
167418	2133	94535504000	21796	10882	95	0	\N
167419	2133	94534502000	21796	10882	96	0	\N
167420	2133	94533500000	21796	10882	97	0	\N
167421	2133	94532498000	21796	10882	98	0	\N
167422	2133	94531496000	21796	10882	99	0	\N
167423	2133	94530494000	21796	10882	100	0	\N
167424	2133	94529492000	21796	10882	101	0	\N
167425	2133	94528490000	21796	10882	102	0	\N
167426	2133	94527488000	21796	10882	103	0	\N
167427	2133	94526486000	21796	10882	104	0	\N
167428	2133	94525484000	21796	10882	105	0	\N
167429	2133	94524482000	21796	10882	106	0	\N
167430	2133	94523480000	21796	10882	107	0	\N
167431	2133	94522478000	21796	10882	108	0	\N
167432	2133	94521476000	21796	10882	109	0	\N
167433	2133	94520474000	21796	10882	110	0	\N
167434	2133	94519472000	21796	10882	111	0	\N
167435	2133	94518470000	21796	10882	112	0	\N
167436	2133	94517468000	21796	10882	113	0	\N
167437	2133	94516466000	21796	10882	114	0	\N
167438	2133	94515464000	21796	10882	115	0	\N
167439	2133	94514462000	21796	10882	116	0	\N
167440	2133	94513460000	21796	10882	117	0	\N
167441	2133	94512458000	21796	10882	118	0	\N
167442	2133	94511456000	21796	10882	119	0	\N
167443	2133	94510454000	21796	10882	120	0	\N
167444	1397	1310117146000	21797	10912	0	0	\N
167445	1397	1310107145000	21797	10912	1	0	\N
167446	2133	94510454000	21797	10912	2	0	\N
167447	2134	87208911000	21797	10912	3	0	\N
167448	2134	87207908000	21797	10912	4	0	\N
167449	2133	94509452000	21797	10912	5	0	\N
167456	1397	1310117146000	21799	10912	0	0	\N
167457	1397	1310107145000	21799	10912	1	0	\N
167458	2133	94510454000	21799	10912	2	0	\N
167459	2134	87208911000	21799	10912	3	0	\N
167460	2134	87207908000	21799	10912	4	0	\N
167461	2133	94509452000	21799	10912	5	0	\N
167465	1397	1310087143000	21802	10914	0	0	\N
167466	1397	1310077142000	21802	10914	1	0	\N
167467	2133	94507448000	21802	10914	2	0	\N
167468	2133	94506446000	21802	10914	3	0	\N
167469	2134	87205902000	21802	10914	4	0	\N
167470	2134	87204899000	21802	10914	5	0	\N
167471	1397	1310087143000	21803	10914	0	0	\N
167472	1397	1310077142000	21803	10914	1	0	\N
167473	2133	94507448000	21803	10914	2	0	\N
167474	2133	94506446000	21803	10914	3	0	\N
167475	2134	87205902000	21803	10914	4	0	\N
167476	2134	87204899000	21803	10914	5	0	\N
167477	1397	1310087143000	21804	10914	0	0	\N
167478	1397	1310077142000	21804	10914	1	0	\N
167479	2133	94507448000	21804	10914	2	0	\N
167480	2133	94506446000	21804	10914	3	0	\N
167481	2134	87205902000	21804	10914	4	0	\N
167482	2134	87204899000	21804	10914	5	0	\N
167489	2186	522957693786	21806	10859	0	0	\N
167490	1564	3966553000000	21806	10859	1	0	\N
167491	1573	14899271000000	21806	10859	2	0	\N
167492	1546	17972768000000	21806	10859	3	0	\N
167493	1546	15326858000000	21806	10859	4	0	\N
167494	1546	11405368000000	21806	10859	5	0	\N
167495	1546	4032328000000	21806	10859	6	0	\N
167496	1877	719010000000	21806	10859	7	0	\N
167497	1573	8682270000000	21806	10859	8	0	\N
167498	1573	5375269000000	21806	10859	9	0	\N
167499	1573	3144268000000	21806	10859	10	0	\N
167500	1573	1299267000000	21806	10859	11	0	\N
167507	1397	1310067141000	21808	10915	0	0	\N
167508	1397	1310057140000	21808	10915	1	0	\N
167509	2134	87203896000	21808	10915	2	0	\N
167510	2133	94505444000	21808	10915	3	0	\N
167511	2133	94504442000	21808	10915	4	0	\N
167512	2134	87202893000	21808	10915	5	0	\N
167516	1397	1310037138000	21810	10917	0	0	\N
167517	2134	87200887000	21810	10917	1	0	\N
167518	2133	94502438000	21810	10917	2	0	\N
167519	1397	1310037138000	21811	10917	0	0	\N
167520	2134	87200887000	21811	10917	1	0	\N
167521	2133	94502438000	21811	10917	2	0	\N
167525	1397	1310027137000	21813	10918	0	0	\N
167526	1397	1310017136000	21813	10918	1	0	\N
167527	2133	94501436000	21813	10918	2	0	\N
167528	2133	94500434000	21813	10918	3	0	\N
167529	2134	87199884000	21813	10918	4	0	\N
167530	2134	87198881000	21813	10918	5	0	\N
167543	1397	1310007135000	21817	10919	0	0	\N
167544	1397	1309997134000	21817	10919	1	0	\N
167545	2134	87197878000	21817	10919	2	0	\N
167546	2134	87196875000	21817	10919	3	0	\N
167547	2133	94499432000	21817	10919	4	0	\N
167548	2133	94498430000	21817	10919	5	0	\N
167452	2133	94510454000	21798	10912	2	0	3274
167453	2134	87208911000	21798	10912	3	0	3371
167454	2134	87207908000	21798	10912	4	0	3372
167455	2133	94509452000	21798	10912	5	0	3275
167462	1397	1310097144000	21801	10913	0	0	12873
167464	2134	87206905000	21801	10913	2	0	3373
167483	1397	1310087143000	21805	10914	0	0	12874
167484	1397	1310077142000	21805	10914	1	0	12875
167485	2133	94507448000	21805	10914	2	0	3277
167486	2133	94506446000	21805	10914	3	0	3278
167488	2134	87204899000	21805	10914	5	0	3375
167501	1397	1310067141000	21807	10915	0	0	12876
167502	1397	1310057140000	21807	10915	1	0	12877
167503	2134	87203896000	21807	10915	2	0	3376
167505	2133	94504442000	21807	10915	4	0	3280
167506	2134	87202893000	21807	10915	5	0	3377
167513	1397	1310047139000	21809	10916	0	0	12878
167514	2133	94503440000	21809	10916	1	0	3281
167515	2134	87201890000	21809	10916	2	0	3378
167523	2134	87200887000	21812	10917	1	0	3379
167524	2133	94502438000	21812	10917	2	0	3282
167531	1397	1310027137000	21814	10918	0	0	12880
167532	1397	1310017136000	21814	10918	1	0	12881
167533	2133	94501436000	21814	10918	2	0	3283
167535	2134	87199884000	21814	10918	4	0	3380
167536	2134	87198881000	21814	10918	5	0	3381
167537	1397	1310007135000	21816	10919	0	0	12882
167538	1397	1309997134000	21816	10919	1	0	12883
167540	2134	87196875000	21816	10919	3	0	3383
167541	2133	94499432000	21816	10919	4	0	3285
167542	2133	94498430000	21816	10919	5	0	3286
167549	1397	1309987133000	21818	10920	0	0	12884
167550	1397	1309977132000	21818	10920	1	0	12885
167552	2133	94497428000	21818	10920	3	0	3287
167555	1397	1309967131000	21819	10921	0	0	\N
167556	1397	1309957130000	21819	10921	1	0	\N
167557	2133	94495424000	21819	10921	2	0	\N
167558	2133	94494422000	21819	10921	3	0	\N
167559	2134	87193866000	21819	10921	4	0	\N
167560	2134	87192863000	21819	10921	5	0	\N
167579	1397	1309947129000	21823	10922	0	0	\N
167580	1397	1309937128000	21823	10922	1	0	\N
167581	1397	1309927127000	21823	10922	2	0	\N
167582	1397	1309917126000	21823	10922	3	0	\N
167583	2133	94493420000	21823	10922	4	0	\N
167584	2133	94492418000	21823	10922	5	0	\N
167585	2133	94491416000	21823	10922	6	0	\N
167586	2133	94490414000	21823	10922	7	0	\N
167587	2134	87191860000	21823	10922	8	0	\N
167588	2134	87190857000	21823	10922	9	0	\N
167589	2134	87189854000	21823	10922	10	0	\N
167590	2134	87188851000	21823	10922	11	0	\N
167603	1397	1309887123000	21826	10924	0	0	\N
167604	1397	1309877122000	21826	10924	1	0	\N
167605	2134	87185842000	21826	10924	2	0	\N
167606	2134	87184839000	21826	10924	3	0	\N
167607	2133	94487408000	21826	10924	4	0	\N
167608	2133	94486406000	21826	10924	5	0	\N
167609	1397	1309887123000	21827	10924	0	0	\N
167610	1397	1309877122000	21827	10924	1	0	\N
167611	2134	87185842000	21827	10924	2	0	\N
167612	2134	87184839000	21827	10924	3	0	\N
167613	2133	94487408000	21827	10924	4	0	\N
167614	2133	94486406000	21827	10924	5	0	\N
167615	2134	87183836000	21828	10925	0	0	\N
167616	2134	87182833000	21828	10925	1	0	\N
167632	1397	1309817116000	21832	10927	0	0	\N
167633	2133	94480394000	21832	10927	1	0	\N
167636	1397	1309817116000	21834	10927	0	0	\N
167637	2133	94480394000	21834	10927	1	0	\N
167644	2186	522957693786	21836	10868	0	0	\N
167645	1397	1310677202000	21836	10868	1	0	\N
167646	1397	1310667201000	21836	10868	2	0	\N
167647	1397	1310657200000	21836	10868	3	0	\N
167648	1397	1310647199000	21836	10868	4	0	\N
167649	1397	1310637198000	21836	10868	5	0	\N
167650	1397	1310627197000	21836	10868	6	0	\N
167651	1397	1310617196000	21836	10868	7	0	\N
167652	1397	1310607195000	21836	10868	8	0	\N
167653	1397	1310597194000	21836	10868	9	0	\N
167654	1397	1310587193000	21836	10868	10	0	\N
167655	1397	1310577192000	21836	10868	11	0	\N
167656	1397	1310567191000	21836	10868	12	0	\N
167657	1397	1310557190000	21836	10868	13	0	\N
167658	1397	1310547189000	21836	10868	14	0	\N
167659	1397	1310537188000	21836	10868	15	0	\N
167660	1397	1310527187000	21836	10868	16	0	\N
167661	1397	1310517186000	21836	10868	17	0	\N
167662	1397	1310507185000	21836	10868	18	0	\N
167663	1397	1310497184000	21836	10868	19	0	\N
167664	1397	1310487183000	21836	10868	20	0	\N
167665	1397	1310477182000	21836	10868	21	0	\N
167666	1397	1310467181000	21836	10868	22	0	\N
167667	1397	1310457180000	21836	10868	23	0	\N
167668	1397	1310447179000	21836	10868	24	0	\N
167669	1397	1310437178000	21836	10868	25	0	\N
167670	1397	1310427177000	21836	10868	26	0	\N
167671	1397	1310417176000	21836	10868	27	0	\N
167672	1397	1310407175000	21836	10868	28	0	\N
167673	1397	1310397174000	21836	10868	29	0	\N
167674	1397	1310387173000	21836	10868	30	0	\N
167675	1397	1310377172000	21836	10868	31	0	\N
167676	1397	1310367171000	21836	10868	32	0	\N
167677	1397	1310357170000	21836	10868	33	0	\N
167678	1397	1310347169000	21836	10868	34	0	\N
167679	1397	1310337168000	21836	10868	35	0	\N
167680	1397	1310327167000	21836	10868	36	0	\N
167681	1397	1310317166000	21836	10868	37	0	\N
167682	1397	1310307165000	21836	10868	38	0	\N
167683	1397	1310297164000	21836	10868	39	0	\N
167684	1397	1310287163000	21836	10868	40	0	\N
167685	1397	1310277162000	21836	10868	41	0	\N
167686	1397	1310267161000	21836	10868	42	0	\N
167687	1397	1310257160000	21836	10868	43	0	\N
167688	1397	1310247159000	21836	10868	44	0	\N
167561	1397	1309967131000	21820	10921	0	0	12886
167562	1397	1309957130000	21820	10921	1	0	12887
167563	2133	94495424000	21820	10921	2	0	3289
167564	2133	94494422000	21820	10921	3	0	3290
167565	2134	87193866000	21820	10921	4	0	3386
167567	1397	1309947129000	21822	10922	0	0	12888
167568	1397	1309937128000	21822	10922	1	0	12889
167569	1397	1309927127000	21822	10922	2	0	12890
167570	1397	1309917126000	21822	10922	3	0	12891
167571	2133	94493420000	21822	10922	4	0	3291
167573	2133	94491416000	21822	10922	6	0	3293
167574	2133	94490414000	21822	10922	7	0	3294
167575	2134	87191860000	21822	10922	8	0	3388
167576	2134	87190857000	21822	10922	9	0	3389
167578	2134	87188851000	21822	10922	11	0	3391
167591	1397	1309907125000	21824	10923	0	0	12892
167592	1397	1309897124000	21824	10923	1	0	12893
167593	2133	94489412000	21824	10923	2	0	3295
167594	2133	94488410000	21824	10923	3	0	3296
167596	2134	87186845000	21824	10923	5	0	3393
167597	1397	1309887123000	21825	10924	0	0	12894
167598	1397	1309877122000	21825	10924	1	0	12895
167599	2134	87185842000	21825	10924	2	0	3394
167600	2134	87184839000	21825	10924	3	0	3395
167602	2133	94486406000	21825	10924	5	0	3298
167617	1397	1309867121000	21829	10925	0	0	12896
167618	1397	1309857120000	21829	10925	1	0	12897
167619	2133	94485404000	21829	10925	2	0	3299
167621	2134	87183836000	21829	10925	4	0	3396
167622	2134	87182833000	21829	10925	5	0	3397
167623	1397	1309847119000	21831	10926	0	0	12898
167624	1397	1309837118000	21831	10926	1	0	12899
167625	1397	1309827117000	21831	10926	2	0	12900
167627	2133	94482398000	21831	10926	4	0	3302
167628	2133	94481396000	21831	10926	5	0	3303
167629	2134	87181830000	21831	10926	6	0	3398
167630	2134	87180827000	21831	10926	7	0	3399
167631	2134	87179824000	21831	10926	8	0	3400
167635	2133	94480394000	21833	10927	1	0	3304
167638	1397	1309807115000	21835	10928	0	0	12902
167639	1397	1309797114000	21835	10928	1	0	12903
167640	2133	94479392000	21835	10928	2	0	3305
167642	2134	87178821000	21835	10928	4	0	3401
167643	2134	87177818000	21835	10928	5	0	3402
167689	1397	1310237158000	21836	10868	45	0	\N
167690	1397	1310227157000	21836	10868	46	0	\N
167691	1397	1310217156000	21836	10868	47	0	\N
167692	1397	1310207155000	21836	10868	48	0	\N
167693	1397	1310197154000	21836	10868	49	0	\N
167694	1397	1310187153000	21836	10868	50	0	\N
167695	1397	1310177152000	21836	10868	51	0	\N
167696	1397	1310167151000	21836	10868	52	0	\N
167697	1397	1310157150000	21836	10868	53	0	\N
167698	1397	1310147149000	21836	10868	54	0	\N
167699	1397	1310137148000	21836	10868	55	0	\N
167700	1397	1310127147000	21836	10868	56	0	\N
167701	1397	1310117146000	21836	10868	57	0	\N
167702	1397	1310107145000	21836	10868	58	0	\N
167703	1397	1310097144000	21836	10868	59	0	\N
167704	1397	1310087143000	21836	10868	60	0	\N
167705	1397	1310077142000	21836	10868	61	0	\N
167706	1397	1310067141000	21836	10868	62	0	\N
167707	1397	1310057140000	21836	10868	63	0	\N
167708	1397	1310047139000	21836	10868	64	0	\N
167709	1397	1310037138000	21836	10868	65	0	\N
167710	1397	1310027137000	21836	10868	66	0	\N
167711	1397	1310017136000	21836	10868	67	0	\N
167712	1397	1310007135000	21836	10868	68	0	\N
167713	1397	1309997134000	21836	10868	69	0	\N
167714	1397	1309987133000	21836	10868	70	0	\N
167715	1397	1309977132000	21836	10868	71	0	\N
167716	1397	1309967131000	21836	10868	72	0	\N
167717	1397	1309957130000	21836	10868	73	0	\N
167718	1397	1309947129000	21836	10868	74	0	\N
167719	1397	1309937128000	21836	10868	75	0	\N
167720	1397	1309927127000	21836	10868	76	0	\N
167721	1397	1309917126000	21836	10868	77	0	\N
167722	1397	1309907125000	21836	10868	78	0	\N
167723	1397	1309897124000	21836	10868	79	0	\N
167724	1397	1309887123000	21836	10868	80	0	\N
167725	1397	1309877122000	21836	10868	81	0	\N
167726	1397	1309867121000	21836	10868	82	0	\N
167727	1397	1309857120000	21836	10868	83	0	\N
167728	1397	1309847119000	21836	10868	84	0	\N
167729	1397	1309837118000	21836	10868	85	0	\N
167730	1397	1309827117000	21836	10868	86	0	\N
167731	1397	1309817116000	21836	10868	87	0	\N
167732	1397	1309807115000	21836	10868	88	0	\N
167733	1397	1309797114000	21836	10868	89	0	\N
167734	1397	1309787113000	21836	10868	90	0	\N
167735	1877	719010000000	21836	10868	91	0	\N
167736	1573	8682270000000	21836	10868	92	0	\N
167737	1573	5375269000000	21836	10868	93	0	\N
167738	1573	3144268000000	21836	10868	94	0	\N
167739	1573	1299267000000	21836	10868	95	0	\N
167740	2133	94575584000	21836	10868	96	0	\N
167741	2133	94574582000	21836	10868	97	0	\N
167742	2133	94573580000	21836	10868	98	0	\N
167743	2133	94572578000	21836	10868	99	0	\N
167744	2134	87270094000	21836	10868	100	0	\N
167745	2134	87269091000	21836	10868	101	0	\N
167746	2134	87268088000	21836	10868	102	0	\N
167747	2134	87267085000	21836	10868	103	0	\N
167748	2134	87266082000	21836	10868	104	0	\N
167749	2134	87265079000	21836	10868	105	0	\N
167750	2134	87264076000	21836	10868	106	0	\N
167751	2134	87263073000	21836	10868	107	0	\N
167752	2134	87262070000	21836	10868	108	0	\N
167753	2134	87261067000	21836	10868	109	0	\N
167754	2134	87260064000	21836	10868	110	0	\N
167755	2134	87259061000	21836	10868	111	0	\N
167756	2134	87258058000	21836	10868	113	0	\N
167757	2134	87257055000	21836	10868	114	0	\N
167758	2134	87256052000	21836	10868	115	0	\N
167759	2134	87255049000	21836	10868	116	0	\N
167760	2134	87254046000	21836	10868	117	0	\N
167761	2134	87253043000	21836	10868	118	0	\N
167768	1397	1309767111000	21839	10931	0	0	\N
167769	2134	87174809000	21839	10931	1	0	\N
167770	2133	94475384000	21839	10931	2	0	\N
167774	1397	1309767111000	21841	10931	0	0	\N
167775	2134	87174809000	21841	10931	1	0	\N
167776	2133	94475384000	21841	10931	2	0	\N
167777	1397	1309767111000	21842	10931	0	0	\N
167778	2134	87174809000	21842	10931	1	0	\N
167779	2133	94475384000	21842	10931	2	0	\N
167789	1397	1309747109000	21845	10933	0	0	\N
167790	1397	1309737108000	21845	10933	1	0	\N
167791	2134	87172803000	21845	10933	2	0	\N
167792	2133	94473380000	21845	10933	3	0	\N
167793	2134	87171800000	21845	10933	4	0	\N
167794	2133	94472378000	21845	10933	5	0	\N
167795	2186	522957693786	21846	10675	0	0	\N
167796	1564	3966553000000	21846	10675	1	0	\N
167797	1573	14899271000000	21846	10675	2	0	\N
167798	886	63455021096354	21846	10675	3	0	\N
167799	885	63455011096354	21846	10675	4	0	\N
167800	1693	5221526908632	21846	10675	5	0	\N
167801	1397	1312297364000	21846	10675	6	0	\N
167802	1397	1312287363000	21846	10675	7	0	\N
167803	1397	1312277362000	21846	10675	8	0	\N
167804	1397	1312267361000	21846	10675	9	0	\N
167805	1397	1312257360000	21846	10675	10	0	\N
167806	1397	1312247359000	21846	10675	11	0	\N
167807	1397	1312237358000	21846	10675	12	0	\N
167808	1397	1312227357000	21846	10675	13	0	\N
167809	1397	1312217356000	21846	10675	14	0	\N
167810	1397	1312207355000	21846	10675	15	0	\N
167811	1546	17252756000000	21846	10675	16	0	\N
167812	1397	1312197354000	21846	10675	17	0	\N
167813	1397	1312187353000	21846	10675	18	0	\N
167814	1397	1312177352000	21846	10675	19	0	\N
167815	1397	1312167351000	21846	10675	20	0	\N
167816	1397	1312157350000	21846	10675	21	0	\N
167817	1397	1312147349000	21846	10675	22	0	\N
167818	1397	1312137348000	21846	10675	23	0	\N
167819	1397	1312127347000	21846	10675	24	0	\N
167820	1397	1312117346000	21846	10675	25	0	\N
167821	1397	1312107345000	21846	10675	26	0	\N
167822	1397	1312097344000	21846	10675	27	0	\N
167823	1397	1312087343000	21846	10675	28	0	\N
167824	1397	1312077342000	21846	10675	29	0	\N
167764	2133	94477388000	21837	10929	2	0	3307
167765	1397	1309777112000	21838	10930	0	0	12905
167766	2133	94476386000	21838	10930	1	0	3308
167767	2134	87175812000	21838	10930	2	0	3404
167771	1397	1309767111000	21840	10931	0	0	12906
167773	2133	94475384000	21840	10931	2	0	3309
167780	1397	1309757110000	21843	10932	0	0	12907
167781	2133	94474382000	21843	10932	1	0	3310
167782	2134	87173806000	21843	10932	2	0	3406
167783	1397	1309747109000	21844	10933	0	0	12908
167785	2134	87172803000	21844	10933	2	0	3407
167786	2133	94473380000	21844	10933	3	0	3311
167787	2134	87171800000	21844	10933	4	0	3408
167788	2133	94472378000	21844	10933	5	0	3312
167825	1397	1312067341000	21846	10675	30	0	\N
167826	1397	1312057340000	21846	10675	31	0	\N
167827	1397	1312047339000	21846	10675	32	0	\N
167828	1397	1312037338000	21846	10675	33	0	\N
167829	1397	1312027337000	21846	10675	34	0	\N
167830	1397	1312017336000	21846	10675	35	0	\N
167831	1397	1312007335000	21846	10675	36	0	\N
167832	1397	1311997334000	21846	10675	37	0	\N
167833	1397	1311987333000	21846	10675	38	0	\N
167834	1397	1311977332000	21846	10675	39	0	\N
167835	1546	14606846000000	21846	10675	40	0	\N
167836	1546	10685356000000	21846	10675	41	0	\N
167837	1546	3312316000000	21846	10675	42	0	\N
167838	1397	1311967331000	21846	10675	43	0	\N
167839	1397	1311957330000	21846	10675	44	0	\N
167840	1397	1311947329000	21846	10675	45	0	\N
167841	1397	1311937328000	21846	10675	46	0	\N
167842	1397	1311927327000	21846	10675	47	0	\N
167843	1397	1311917326000	21846	10675	48	0	\N
167844	1397	1311907325000	21846	10675	49	0	\N
167845	1397	1311897324000	21846	10675	50	0	\N
167846	1397	1311887323000	21846	10675	51	0	\N
167847	1397	1311877322000	21846	10675	52	0	\N
167848	1397	1311867321000	21846	10675	53	0	\N
167849	1397	1311857320000	21846	10675	54	0	\N
167850	1397	1311847319000	21846	10675	55	0	\N
167851	1397	1311837318000	21846	10675	56	0	\N
167852	1397	1311827317000	21846	10675	57	0	\N
167853	1397	1311817316000	21846	10675	58	0	\N
167854	1397	1311807315000	21846	10675	59	0	\N
167855	1397	1311797314000	21846	10675	60	0	\N
167856	1397	1311787313000	21846	10675	61	0	\N
167857	1397	1311777312000	21846	10675	62	0	\N
167858	1397	1311767311000	21846	10675	63	0	\N
167859	1397	1311757310000	21846	10675	64	0	\N
167860	1397	1311747309000	21846	10675	65	0	\N
167861	1397	1311737308000	21846	10675	66	0	\N
167862	1397	1311727307000	21846	10675	67	0	\N
167863	1397	1311717306000	21846	10675	68	0	\N
167864	1397	1311707305000	21846	10675	69	0	\N
167865	1397	1311697304000	21846	10675	70	0	\N
167866	1397	1311687303000	21846	10675	71	0	\N
167867	1397	1311677302000	21846	10675	72	0	\N
167868	1397	1311667301000	21846	10675	73	0	\N
167869	1397	1311657300000	21846	10675	74	0	\N
167870	1397	1311647299000	21846	10675	75	0	\N
167871	1397	1311637298000	21846	10675	76	0	\N
167872	1397	1311627297000	21846	10675	77	0	\N
167873	1397	1311617296000	21846	10675	78	0	\N
167874	1397	1311607295000	21846	10675	79	0	\N
167875	1397	1311597294000	21846	10675	80	0	\N
167876	1397	1311587293000	21846	10675	81	0	\N
167877	1397	1311577292000	21846	10675	82	0	\N
167878	1397	1311567291000	21846	10675	83	0	\N
167879	1397	1311557290000	21846	10675	84	0	\N
167880	1397	1311547289000	21846	10675	85	0	\N
167881	1397	1311537288000	21846	10675	86	0	\N
167882	1397	1311527287000	21846	10675	87	0	\N
167883	1397	1311517286000	21846	10675	88	0	\N
167884	1397	1311507285000	21846	10675	89	0	\N
167885	1397	1311497284000	21846	10675	90	0	\N
167886	1397	1311487283000	21846	10675	92	0	\N
167887	1397	1311477282000	21846	10675	93	0	\N
167888	1397	1311467281000	21846	10675	94	0	\N
167889	1397	1311457280000	21846	10675	95	0	\N
167890	1397	1311447279000	21846	10675	96	0	\N
167891	1397	1311437278000	21846	10675	97	0	\N
167892	1397	1311427277000	21846	10675	98	0	\N
167893	1397	1311417276000	21846	10675	99	0	\N
167894	1397	1311407275000	21846	10675	100	0	\N
167895	1397	1311397274000	21846	10675	101	0	\N
167896	1397	1311387273000	21846	10675	102	0	\N
167897	1397	1311377272000	21846	10675	103	0	\N
167898	1397	1311367271000	21846	10675	104	0	\N
167899	1397	1311357270000	21846	10675	105	0	\N
167900	1397	1311347269000	21846	10675	106	0	\N
167901	1397	1311337268000	21846	10675	107	0	\N
167902	1397	1311327267000	21846	10675	108	0	\N
167903	1397	1311317266000	21846	10675	109	0	\N
167904	1397	1311307265000	21846	10675	110	0	\N
167905	1397	1311297264000	21846	10675	111	0	\N
167906	1397	1311287263000	21846	10675	112	0	\N
167907	1397	1311277262000	21846	10675	113	0	\N
167908	1397	1311267261000	21846	10675	114	0	\N
167909	1397	1311257260000	21846	10675	115	0	\N
167910	1397	1311247259000	21846	10675	116	0	\N
167911	1397	1311237258000	21846	10675	117	0	\N
167912	1397	1311227257000	21846	10675	118	0	\N
167913	1397	1311217256000	21846	10675	119	0	\N
167914	1397	1311207255000	21846	10675	120	0	\N
167915	1397	1311197254000	21846	10675	121	0	\N
167916	1397	1311187253000	21846	10675	122	0	\N
167917	1397	1311177252000	21846	10675	123	0	\N
167918	1397	1311167251000	21846	10675	124	0	\N
167919	1397	1311157250000	21846	10675	125	0	\N
167920	1397	1309727107000	21847	10934	0	0	\N
167921	1397	1309717106000	21847	10934	1	0	\N
167922	1397	1309707105000	21847	10934	2	0	\N
167923	2133	94471376000	21847	10934	3	0	\N
167924	2133	94470374000	21847	10934	4	0	\N
167925	2134	87170797000	21847	10934	5	0	\N
167926	2134	87169794000	21847	10934	6	0	\N
167927	2134	87168791000	21847	10934	7	0	\N
167928	2133	94469372000	21847	10934	8	0	\N
167929	1397	1309727107000	21848	10934	0	0	\N
167930	1397	1309717106000	21848	10934	1	0	\N
167931	1397	1309707105000	21848	10934	2	0	\N
167932	2133	94471376000	21848	10934	3	0	\N
167933	2133	94470374000	21848	10934	4	0	\N
167934	2134	87170797000	21848	10934	5	0	\N
167935	2134	87169794000	21848	10934	6	0	\N
167936	2134	87168791000	21848	10934	7	0	\N
167937	2133	94469372000	21848	10934	8	0	\N
167947	1397	1309697104000	21850	10935	0	0	\N
167948	2133	94468370000	21850	10935	1	0	\N
167949	2134	87167788000	21850	10935	2	0	\N
167940	1397	1309707105000	21849	10934	2	0	12912
167941	2133	94471376000	21849	10934	3	0	3313
167942	2133	94470374000	21849	10934	4	0	3314
167943	2134	87170797000	21849	10934	5	0	3409
167944	2134	87169794000	21849	10934	6	0	3410
167946	2133	94469372000	21849	10934	8	0	3315
167950	1397	1309697104000	21851	10935	0	0	12913
167951	2133	94468370000	21851	10935	1	0	3316
167952	2134	87167788000	21851	10935	2	0	3412
167953	1397	1309687103000	21852	10936	0	0	12914
167955	2134	87166785000	21852	10936	2	0	3413
167956	1397	1309677102000	21853	10937	0	0	12915
167957	1397	1309667101000	21853	10937	1	0	12916
167958	1397	1309657100000	21853	10937	2	0	12917
167960	2134	87165782000	21853	10937	4	0	3414
167965	1397	1309677102000	21854	10937	0	0	\N
167966	1397	1309667101000	21854	10937	1	0	\N
167967	1397	1309657100000	21854	10937	2	0	\N
167968	2133	94466366000	21854	10937	3	0	\N
167969	2134	87165782000	21854	10937	4	0	\N
167970	2133	94465364000	21854	10937	5	0	\N
167971	2133	94464362000	21854	10937	6	0	\N
167972	2134	87164779000	21854	10937	7	0	\N
167973	2134	87163776000	21854	10937	8	0	\N
167974	1397	1309677102000	21855	10937	0	0	\N
167975	1397	1309667101000	21855	10937	1	0	\N
167976	1397	1309657100000	21855	10937	2	0	\N
167977	2133	94466366000	21855	10937	3	0	\N
167978	2134	87165782000	21855	10937	4	0	\N
167979	2133	94465364000	21855	10937	5	0	\N
167980	2133	94464362000	21855	10937	6	0	\N
167981	2134	87164779000	21855	10937	7	0	\N
167982	2134	87163776000	21855	10937	8	0	\N
167983	1397	1309677102000	21856	10937	0	0	\N
167984	1397	1309667101000	21856	10937	1	0	\N
167985	1397	1309657100000	21856	10937	2	0	\N
167986	2133	94466366000	21856	10937	3	0	\N
167987	2134	87165782000	21856	10937	4	0	\N
167988	2133	94465364000	21856	10937	5	0	\N
167989	2133	94464362000	21856	10937	6	0	\N
167990	2134	87164779000	21856	10937	7	0	\N
167991	2134	87163776000	21856	10937	8	0	\N
167992	1397	1309647099000	21857	10938	0	0	\N
167993	2133	94463360000	21857	10938	1	0	\N
167994	2134	87162773000	21857	10938	2	0	\N
167995	1397	1309647099000	21858	10938	0	0	\N
167996	2133	94463360000	21858	10938	1	0	\N
167997	2134	87162773000	21858	10938	2	0	\N
168013	1397	1309597094000	21864	10943	0	0	\N
168014	2134	87157758000	21864	10943	1	0	\N
168015	2133	94458350000	21864	10943	2	0	\N
168016	1397	1309597094000	21865	10943	0	0	\N
168017	2134	87157758000	21865	10943	1	0	\N
168018	2133	94458350000	21865	10943	2	0	\N
168020	1397	1309597094000	21867	10943	0	0	\N
168021	2134	87157758000	21867	10943	1	0	\N
168022	2133	94458350000	21867	10943	2	0	\N
168023	1397	1309597094000	21868	10943	0	0	\N
168024	2134	87157758000	21868	10943	1	0	\N
168025	2133	94458350000	21868	10943	2	0	\N
168026	1564	3966553000000	21870	10799	0	0	\N
168027	1508	22684405117393	21870	10799	1	0	\N
168028	1573	14899271000000	21870	10799	2	0	\N
168029	886	63455021096354	21870	10799	3	0	\N
168030	1397	1311487283000	21870	10799	4	0	\N
168031	885	63455011096354	21870	10799	5	0	\N
168032	773	1000000000000	21870	10799	6	0	\N
168033	1693	7381573908632	21870	10799	7	0	\N
168034	1397	1311477282000	21870	10799	8	0	\N
168035	1397	1311467281000	21870	10799	9	0	\N
168036	478	66000000000000	21870	10799	10	0	\N
168037	1397	1311457280000	21870	10799	11	0	\N
168038	1397	1311447279000	21870	10799	13	0	\N
168039	1508	18365924556796	21870	10799	14	0	\N
168040	1508	15279852229364	21870	10799	15	0	\N
168041	1508	6680255156616	21870	10799	16	0	\N
168042	1546	17252756000000	21870	10799	17	0	\N
168043	1397	1311437278000	21870	10799	18	0	\N
168044	1397	1311427277000	21870	10799	19	0	\N
168045	1397	1311417276000	21870	10799	20	0	\N
168046	1397	1311407275000	21870	10799	21	0	\N
168047	1397	1311397274000	21870	10799	22	0	\N
168048	1397	1311387273000	21870	10799	23	0	\N
168049	1397	1311377272000	21870	10799	24	0	\N
168050	1397	1311367271000	21870	10799	25	0	\N
168051	1397	1311357270000	21870	10799	26	0	\N
168052	1397	1311347269000	21870	10799	27	0	\N
168053	1397	1311337268000	21870	10799	28	0	\N
168054	1397	1311327267000	21870	10799	29	0	\N
168055	1397	1311317266000	21870	10799	30	0	\N
168056	1397	1311307265000	21870	10799	31	0	\N
168057	1397	1311297264000	21870	10799	32	0	\N
168058	1397	1311287263000	21870	10799	33	0	\N
168059	1397	1311277262000	21870	10799	34	0	\N
168060	1397	1311267261000	21870	10799	35	0	\N
168061	1397	1311257260000	21870	10799	36	0	\N
168062	1397	1311247259000	21870	10799	37	0	\N
168063	1397	1311237258000	21870	10799	38	0	\N
168064	1397	1311227257000	21870	10799	39	0	\N
168065	1397	1311217256000	21870	10799	40	0	\N
168066	1397	1311207255000	21870	10799	41	0	\N
168067	1397	1311197254000	21870	10799	42	0	\N
168068	1397	1311187253000	21870	10799	43	0	\N
168069	1397	1311177252000	21870	10799	44	0	\N
168070	1397	1311167251000	21870	10799	45	0	\N
168071	1397	1311157250000	21870	10799	46	0	\N
168072	1397	1311147249000	21870	10799	47	0	\N
168073	1397	1311137248000	21870	10799	48	0	\N
168074	1397	1311127247000	21870	10799	49	0	\N
168075	1397	1311117246000	21870	10799	50	0	\N
168076	1397	1311107245000	21870	10799	51	0	\N
168077	1397	1311097244000	21870	10799	52	0	\N
168078	1397	1311087243000	21870	10799	53	0	\N
168079	1397	1311077242000	21870	10799	54	0	\N
168080	1397	1311067241000	21870	10799	55	0	\N
168081	1397	1311057240000	21870	10799	56	0	\N
168082	1397	1311047239000	21870	10799	57	0	\N
168083	1397	1311037238000	21870	10799	58	0	\N
168084	1397	1311027237000	21870	10799	59	0	\N
168085	1397	1311017236000	21870	10799	60	0	\N
168086	1397	1311007235000	21870	10799	61	0	\N
168087	1397	1310997234000	21870	10799	62	0	\N
168088	1397	1310987233000	21870	10799	63	0	\N
168089	1397	1310977232000	21870	10799	64	0	\N
168090	1397	1310967231000	21870	10799	65	0	\N
168091	1397	1310957230000	21870	10799	66	0	\N
168092	1397	1310947229000	21870	10799	67	0	\N
168093	1397	1310937228000	21870	10799	68	0	\N
168094	1397	1310927227000	21870	10799	69	0	\N
168095	1397	1310917226000	21870	10799	70	0	\N
168096	1397	1310907225000	21870	10799	71	0	\N
167963	2134	87164779000	21853	10937	7	0	3415
167964	2134	87163776000	21853	10937	8	0	3416
167998	1397	1309647099000	21859	10938	0	0	12918
167999	2133	94463360000	21859	10938	1	0	3321
168000	2134	87162773000	21859	10938	2	0	3417
168002	2133	94462358000	21860	10939	1	0	3322
168003	2134	87161770000	21860	10939	2	0	3418
168004	1397	1309627097000	21861	10940	0	0	12920
168005	2134	87160767000	21861	10940	1	0	3419
168006	2133	94461356000	21861	10940	2	0	3323
168008	2134	87159764000	21862	10941	1	0	3420
168009	2133	94460354000	21862	10941	2	0	3324
168010	1397	1309607095000	21863	10942	0	0	12922
168011	2133	94459352000	21863	10942	1	0	3325
168019	2133	94458350000	21866	10943	0	0	3326
168097	1397	1310897224000	21870	10799	72	0	\N
168098	1397	1310887223000	21870	10799	73	0	\N
168099	1397	1310877222000	21870	10799	74	0	\N
168100	1397	1310867221000	21870	10799	75	0	\N
168101	1397	1310857220000	21870	10799	76	0	\N
168102	1397	1310847219000	21870	10799	77	0	\N
168103	1397	1310837218000	21870	10799	78	0	\N
168104	1397	1310827217000	21870	10799	79	0	\N
168105	1397	1310817216000	21870	10799	80	0	\N
168106	1397	1310807215000	21870	10799	81	0	\N
168107	1397	1310797214000	21870	10799	82	0	\N
168108	1397	1310787213000	21870	10799	83	0	\N
168109	1397	1310777212000	21870	10799	84	0	\N
168110	1397	1310767211000	21870	10799	85	0	\N
168111	1397	1310757210000	21870	10799	86	0	\N
168112	1397	1310747209000	21870	10799	87	0	\N
168113	1397	1310737208000	21870	10799	88	0	\N
168114	1397	1310727207000	21870	10799	89	0	\N
168115	1397	1310717206000	21870	10799	90	0	\N
168116	1546	14606846000000	21870	10799	91	0	\N
168117	1546	10685356000000	21870	10799	92	0	\N
168118	1546	3312316000000	21870	10799	93	0	\N
168119	2134	87355349000	21870	10799	94	0	\N
168120	2134	87354346000	21870	10799	95	0	\N
168121	2134	87353343000	21870	10799	96	0	\N
168122	2134	87352340000	21870	10799	97	0	\N
168123	2134	87351337000	21870	10799	98	0	\N
168124	2133	95869752000	21870	10799	99	0	\N
168125	2133	95868750000	21870	10799	100	0	\N
168126	2133	95867748000	21870	10799	101	0	\N
168127	2133	95866746000	21870	10799	102	0	\N
168128	2134	87350334000	21870	10799	103	0	\N
168129	2134	87349331000	21870	10799	104	0	\N
168130	2134	87348328000	21870	10799	105	0	\N
168131	2134	87347325000	21870	10799	106	0	\N
168132	2134	87346322000	21870	10799	107	0	\N
168133	2134	87345319000	21870	10799	108	0	\N
168134	2134	87344316000	21870	10799	109	0	\N
168135	2134	87343313000	21870	10799	110	0	\N
168136	2134	87342310000	21870	10799	111	0	\N
168137	2133	95865744000	21870	10799	112	0	\N
168138	2133	95864742000	21870	10799	113	0	\N
168139	2133	95863740000	21870	10799	114	0	\N
168140	2133	95862738000	21870	10799	115	0	\N
168141	2133	95861736000	21870	10799	116	0	\N
168142	2133	95860734000	21870	10799	117	0	\N
168143	2133	95859732000	21870	10799	118	0	\N
168144	2133	95858730000	21870	10799	119	0	\N
168145	2133	95857728000	21870	10799	120	0	\N
168146	2133	95856726000	21870	10799	121	0	\N
168147	2133	95855724000	21870	10799	122	0	\N
168148	2186	522957693786	21871	10800	0	0	\N
168149	1397	1310707205000	21871	10800	1	0	\N
168150	1397	1310697204000	21871	10800	2	0	\N
168151	1397	1310687203000	21871	10800	3	0	\N
168152	1397	1310677202000	21871	10800	4	0	\N
168153	1397	1310667201000	21871	10800	5	0	\N
168154	1397	1310657200000	21871	10800	6	0	\N
168155	1397	1310647199000	21871	10800	7	0	\N
168156	1397	1310637198000	21871	10800	8	0	\N
168157	1397	1310627197000	21871	10800	9	0	\N
168158	1397	1310617196000	21871	10800	10	0	\N
168159	1397	1310607195000	21871	10800	13	0	\N
168160	1397	1310597194000	21871	10800	14	0	\N
168161	1397	1310587193000	21871	10800	15	0	\N
168162	1397	1310577192000	21871	10800	16	0	\N
168163	1397	1310567191000	21871	10800	17	0	\N
168164	1397	1310557190000	21871	10800	18	0	\N
168165	1397	1310547189000	21871	10800	19	0	\N
168166	1397	1310537188000	21871	10800	20	0	\N
168167	1397	1310527187000	21871	10800	21	0	\N
168168	1397	1310517186000	21871	10800	22	0	\N
168169	1397	1310507185000	21871	10800	23	0	\N
168170	1397	1310497184000	21871	10800	24	0	\N
168171	1397	1310487183000	21871	10800	25	0	\N
168172	1397	1310477182000	21871	10800	26	0	\N
168173	1397	1310467181000	21871	10800	27	0	\N
168174	1397	1310457180000	21871	10800	28	0	\N
168175	1397	1310447179000	21871	10800	29	0	\N
168176	1397	1310437178000	21871	10800	30	0	\N
168177	1397	1310427177000	21871	10800	31	0	\N
168178	1397	1310417176000	21871	10800	32	0	\N
168179	1397	1310407175000	21871	10800	33	0	\N
168188	1397	1309597094000	21874	10945	0	0	\N
168189	1397	1309587093000	21874	10945	1	0	\N
168190	1397	1309577092000	21874	10945	2	0	\N
168191	2134	87157758000	21874	10945	3	0	\N
168192	2134	87156755000	21874	10945	4	0	\N
168193	2134	87155752000	21874	10945	5	0	\N
168194	2133	94457348000	21874	10945	6	0	\N
168195	2133	94456346000	21874	10945	7	0	\N
168196	1397	1309627097000	21875	10940	0	0	\N
168197	1397	1309617096000	21875	10940	1	0	\N
168198	1397	1309607095000	21875	10940	2	0	\N
168199	1397	1309597094000	21875	10940	3	0	\N
168200	1397	1309587093000	21875	10940	4	0	\N
168201	1397	1309577092000	21875	10940	5	0	\N
168202	2134	87160767000	21875	10940	6	0	\N
168203	2134	87159764000	21875	10940	7	0	\N
168204	2133	94461356000	21875	10940	8	0	\N
168205	2134	87158761000	21875	10940	9	0	\N
168206	2134	87157758000	21875	10940	10	0	\N
168207	2134	87156755000	21875	10940	11	0	\N
168208	2134	87155752000	21875	10940	12	0	\N
168209	2133	94460354000	21875	10940	13	0	\N
168210	2133	94459352000	21875	10940	14	0	\N
168211	2133	94458350000	21875	10940	15	0	\N
168212	2133	94457348000	21875	10940	16	0	\N
168213	2133	94456346000	21875	10940	17	0	\N
168217	1397	1309567091000	21877	10946	0	0	\N
168218	2133	94455344000	21877	10946	1	0	\N
168219	2134	87154749000	21877	10946	2	0	\N
168229	1397	1309547089000	21880	10948	0	0	\N
168230	1397	1309537088000	21880	10948	1	0	\N
168231	2134	87152743000	21880	10948	2	0	\N
168232	2134	87151740000	21880	10948	3	0	\N
168182	1397	1309577092000	21873	10945	2	0	12925
168183	2134	87157758000	21873	10945	3	0	3422
168184	2134	87156755000	21873	10945	4	0	3423
168185	2134	87155752000	21873	10945	5	0	3424
168186	2133	94457348000	21873	10945	6	0	3327
168214	1397	1309567091000	21876	10946	0	0	12926
168215	2133	94455344000	21876	10946	1	0	3329
168216	2134	87154749000	21876	10946	2	0	3425
168220	1397	1309557090000	21878	10947	0	0	12927
168221	2134	87153746000	21878	10947	1	0	3426
168223	1397	1309547089000	21879	10948	0	0	12928
168224	1397	1309537088000	21879	10948	1	0	12929
168225	2134	87152743000	21879	10948	2	0	3427
168226	2134	87151740000	21879	10948	3	0	3428
168228	2133	94452338000	21879	10948	5	0	3332
168233	2133	94453340000	21880	10948	4	0	\N
168234	2133	94452338000	21880	10948	5	0	\N
168241	1397	1309507085000	21883	10950	0	0	\N
168242	2133	94449332000	21883	10950	1	0	\N
168243	2134	87148731000	21883	10950	2	0	\N
168259	1397	1309467081000	21889	10954	0	0	\N
168260	2134	87144719000	21889	10954	1	0	\N
168261	2133	94445324000	21889	10954	2	0	\N
168264	1397	1309457080000	21892	10955	0	0	\N
168265	2133	94444322000	21892	10955	1	0	\N
168266	2134	87143716000	21892	10955	2	0	\N
168267	1397	1309457080000	21893	10955	0	0	\N
168268	2133	94444322000	21893	10955	1	0	\N
168269	2134	87143716000	21893	10955	2	0	\N
168270	1397	1309457080000	21894	10955	0	0	\N
168271	2133	94444322000	21894	10955	1	0	\N
168272	2134	87143716000	21894	10955	2	0	\N
168277	1397	1309437078000	21896	10957	0	0	\N
168278	2133	94442318000	21896	10957	1	0	\N
168279	2134	87141710000	21896	10957	2	0	\N
168289	1397	1309427077000	21899	10958	0	0	\N
168290	1397	1309417076000	21899	10958	1	0	\N
168291	2133	94441316000	21899	10958	2	0	\N
168292	2134	87140707000	21899	10958	3	0	\N
168293	2134	87139704000	21899	10958	4	0	\N
168294	2133	94440314000	21899	10958	5	0	\N
168295	1397	1309407075000	21900	10959	0	0	\N
168296	2134	87138701000	21900	10959	1	0	\N
168297	2133	94439312000	21900	10959	2	0	\N
168298	1397	1309407075000	21901	10959	0	0	\N
168299	2134	87138701000	21901	10959	1	0	\N
168300	2133	94439312000	21901	10959	2	0	\N
168307	1397	1309397074000	21904	10960	0	0	\N
168308	2133	94438310000	21904	10960	1	0	\N
168309	2134	87137698000	21904	10960	2	0	\N
168310	1397	1310137148000	21905	10896	0	0	\N
168311	1397	1310127147000	21905	10896	1	0	\N
168312	1397	1310117146000	21905	10896	2	0	\N
168313	1397	1310107145000	21905	10896	4	0	\N
168314	1397	1310097144000	21905	10896	5	0	\N
168315	1397	1310087143000	21905	10896	6	0	\N
168316	1397	1310077142000	21905	10896	7	0	\N
168317	1397	1310067141000	21905	10896	8	0	\N
168318	1397	1310057140000	21905	10896	9	0	\N
168319	1397	1310047139000	21905	10896	10	0	\N
168320	1397	1310037138000	21905	10896	11	0	\N
168321	1397	1310027137000	21905	10896	12	0	\N
168322	1397	1310017136000	21905	10896	13	0	\N
168323	1397	1310007135000	21905	10896	14	0	\N
168324	1397	1309997134000	21905	10896	15	0	\N
168325	1397	1309987133000	21905	10896	16	0	\N
168326	1397	1309977132000	21905	10896	17	0	\N
168327	1397	1309967131000	21905	10896	18	0	\N
168328	1397	1309957130000	21905	10896	19	0	\N
168329	1397	1309947129000	21905	10896	20	0	\N
168330	1397	1309937128000	21905	10896	21	0	\N
168331	1397	1309927127000	21905	10896	22	0	\N
168332	1397	1309917126000	21905	10896	23	0	\N
168333	1397	1309907125000	21905	10896	24	0	\N
168334	1397	1309897124000	21905	10896	25	0	\N
168335	1397	1309887123000	21905	10896	26	0	\N
168336	1397	1309877122000	21905	10896	27	0	\N
168337	1397	1309867121000	21905	10896	28	0	\N
168338	1397	1309857120000	21905	10896	29	0	\N
168339	1397	1309847119000	21905	10896	30	0	\N
168340	1397	1309837118000	21905	10896	31	0	\N
168341	1397	1309827117000	21905	10896	32	0	\N
168342	1397	1309817116000	21905	10896	33	0	\N
168343	1397	1309807115000	21905	10896	34	0	\N
168344	1397	1309797114000	21905	10896	35	0	\N
168345	1397	1309787113000	21905	10896	36	0	\N
168346	1397	1309777112000	21905	10896	37	0	\N
168347	1397	1309767111000	21905	10896	38	0	\N
168348	1397	1309757110000	21905	10896	39	0	\N
168349	1397	1309747109000	21905	10896	40	0	\N
168350	1397	1309737108000	21905	10896	41	0	\N
168351	1397	1309727107000	21905	10896	42	0	\N
168352	1397	1309717106000	21905	10896	43	0	\N
168353	1397	1309707105000	21905	10896	44	0	\N
168354	1397	1309697104000	21905	10896	45	0	\N
168355	1397	1309687103000	21905	10896	46	0	\N
168356	1397	1309677102000	21905	10896	47	0	\N
168357	1397	1309667101000	21905	10896	48	0	\N
168358	1397	1309657100000	21905	10896	49	0	\N
168359	1397	1309647099000	21905	10896	50	0	\N
168360	1397	1309637098000	21905	10896	51	0	\N
168361	1397	1309627097000	21905	10896	52	0	\N
168362	1397	1309617096000	21905	10896	53	0	\N
168363	1397	1309607095000	21905	10896	54	0	\N
168364	1397	1309597094000	21905	10896	55	0	\N
168365	1397	1309587093000	21905	10896	56	0	\N
168366	1397	1309577092000	21905	10896	57	0	\N
168367	1397	1309567091000	21905	10896	58	0	\N
168368	1397	1309557090000	21905	10896	59	0	\N
168237	2133	94451336000	21882	10949	2	0	3333
168238	2133	94450334000	21882	10949	3	0	3334
168239	2134	87150737000	21882	10949	4	0	3429
168240	2134	87149734000	21882	10949	5	0	3430
168244	1397	1309507085000	21884	10950	0	0	12932
168246	2134	87148731000	21884	10950	2	0	3431
168247	1397	1309497084000	21885	10951	0	0	12933
168248	2134	87147728000	21885	10951	1	0	3432
168249	2133	94448330000	21885	10951	2	0	3336
168250	1397	1309487083000	21886	10952	0	0	12934
168252	2134	87146725000	21886	10952	2	0	3433
168253	1397	1309477082000	21887	10953	0	0	12935
168254	2134	87145722000	21887	10953	1	0	3434
168255	2133	94446326000	21887	10953	2	0	3338
168257	2134	87144719000	21888	10954	1	0	3435
168258	2133	94445324000	21888	10954	2	0	3339
168262	2133	94444322000	21891	10955	0	0	3340
168263	2134	87143716000	21891	10955	1	0	3436
168273	1397	1309457080000	21895	10956	0	0	12937
168275	2133	94443320000	21895	10956	2	0	3341
168276	2134	87142713000	21895	10956	3	0	3437
168280	1397	1309437078000	21897	10957	0	0	12939
168281	2133	94442318000	21897	10957	1	0	3342
168282	2134	87141710000	21897	10957	2	0	3438
168284	1397	1309417076000	21898	10958	1	0	12941
168285	2133	94441316000	21898	10958	2	0	3343
168286	2134	87140707000	21898	10958	3	0	3439
168287	2134	87139704000	21898	10958	4	0	3440
168301	1397	1309407075000	21902	10959	0	0	12942
168302	2134	87138701000	21902	10959	1	0	3441
168303	2133	94439312000	21902	10959	2	0	3345
168304	1397	1309397074000	21903	10960	0	0	12943
168305	2133	94438310000	21903	10960	1	0	3346
168369	1397	1309547089000	21905	10896	60	0	\N
168370	1397	1309537088000	21905	10896	61	0	\N
168371	1397	1309527087000	21905	10896	62	0	\N
168372	1397	1309517086000	21905	10896	63	0	\N
168373	1397	1309507085000	21905	10896	64	0	\N
168374	1397	1309497084000	21905	10896	65	0	\N
168375	1397	1309487083000	21905	10896	66	0	\N
168376	1397	1309477082000	21905	10896	67	0	\N
168377	1397	1309467081000	21905	10896	68	0	\N
168378	1397	1309457080000	21905	10896	69	0	\N
168379	1397	1309447079000	21905	10896	70	0	\N
168380	1397	1309437078000	21905	10896	71	0	\N
168381	1397	1309427077000	21905	10896	72	0	\N
168382	1397	1309417076000	21905	10896	73	0	\N
168383	1397	1309407075000	21905	10896	74	0	\N
168384	1397	1309397074000	21905	10896	75	0	\N
168385	2133	94512458000	21905	10896	76	0	\N
168386	2133	94511456000	21905	10896	77	0	\N
168387	2134	87210917000	21905	10896	78	0	\N
168388	2134	87209914000	21905	10896	79	0	\N
168389	2133	94510454000	21905	10896	80	0	\N
168390	2134	87208911000	21905	10896	81	0	\N
168391	2134	87207908000	21905	10896	82	0	\N
168392	2134	87206905000	21905	10896	83	0	\N
168393	2134	87205902000	21905	10896	84	0	\N
168394	2134	87204899000	21905	10896	85	0	\N
168395	2134	87203896000	21905	10896	86	0	\N
168396	2134	87202893000	21905	10896	87	0	\N
168397	2134	87201890000	21905	10896	88	0	\N
168398	2134	87200887000	21905	10896	89	0	\N
168399	2134	87199884000	21905	10896	90	0	\N
168400	2134	87198881000	21905	10896	91	0	\N
168401	2134	87197878000	21905	10896	92	0	\N
168402	2134	87196875000	21905	10896	93	0	\N
168403	2134	87195872000	21905	10896	94	0	\N
168404	2134	87194869000	21905	10896	95	0	\N
168405	2134	87193866000	21905	10896	96	0	\N
168406	2134	87192863000	21905	10896	97	0	\N
168407	2134	87191860000	21905	10896	98	0	\N
168408	2134	87190857000	21905	10896	99	0	\N
168409	2134	87189854000	21905	10896	100	0	\N
168410	2134	87188851000	21905	10896	101	0	\N
168411	2134	87187848000	21905	10896	102	0	\N
168412	2134	87186845000	21905	10896	103	0	\N
168413	2134	87185842000	21905	10896	104	0	\N
168414	2134	87184839000	21905	10896	105	0	\N
168415	2134	87183836000	21905	10896	106	0	\N
168416	2134	87182833000	21905	10896	107	0	\N
168417	2134	87181830000	21905	10896	108	0	\N
168418	2134	87180827000	21905	10896	109	0	\N
168419	2134	87179824000	21905	10896	110	0	\N
168420	2134	87178821000	21905	10896	111	0	\N
168421	2134	87177818000	21905	10896	112	0	\N
168422	2134	87176815000	21905	10896	113	0	\N
168423	2134	87175812000	21905	10896	114	0	\N
168424	2134	87174809000	21905	10896	115	0	\N
168425	2134	87173806000	21905	10896	116	0	\N
168426	2134	87172803000	21905	10896	117	0	\N
168427	2134	87171800000	21905	10896	118	0	\N
168428	2134	87170797000	21905	10896	119	0	\N
168429	2134	87169794000	21905	10896	120	0	\N
168430	2134	87168791000	21905	10896	121	0	\N
168431	2134	87167788000	21905	10896	122	0	\N
168432	2134	87166785000	21905	10896	123	0	\N
168433	2134	87165782000	21905	10896	124	0	\N
168434	2133	94509452000	21905	10896	125	0	\N
168444	1397	1309377072000	21908	10962	0	0	\N
168445	1397	1309367071000	21908	10962	1	0	\N
168446	2133	94436306000	21908	10962	2	0	\N
168447	2133	94435304000	21908	10962	3	0	\N
168448	2134	87135692000	21908	10962	4	0	\N
168449	2134	87134689000	21908	10962	5	0	\N
168450	1397	1309377072000	21909	10962	0	0	\N
168451	1397	1309367071000	21909	10962	1	0	\N
168452	2133	94436306000	21909	10962	2	0	\N
168453	2133	94435304000	21909	10962	3	0	\N
168454	2134	87135692000	21909	10962	4	0	\N
168455	2134	87134689000	21909	10962	5	0	\N
168472	1397	1309327067000	21916	10967	0	0	\N
168473	1397	1309317066000	21916	10967	1	0	\N
168474	1932	1362904664093	21916	10967	3	0	\N
168475	2133	94430294000	21916	10967	4	0	\N
168476	2134	87130677000	21916	10967	5	0	\N
168477	2134	87129674000	21916	10967	6	0	\N
168478	1932	1362904664093	21917	10967	0	0	\N
168479	2133	94430294000	21917	10967	1	0	\N
168486	1397	1309287063000	21919	10969	0	0	\N
168487	1397	1309277062000	21919	10969	1	0	\N
168488	2134	87126665000	21919	10969	2	0	\N
168489	2134	87125662000	21919	10969	3	0	\N
168490	2133	94427288000	21919	10969	4	0	\N
168491	2133	94426286000	21919	10969	5	0	\N
168498	2134	87126665000	21921	10969	0	0	\N
168499	2134	87125662000	21921	10969	1	0	\N
168500	2133	94427288000	21921	10969	2	0	\N
168501	2133	94426286000	21921	10969	3	0	\N
168437	2133	94437308000	21906	10961	2	0	3347
168438	1397	1309377072000	21907	10962	0	0	12945
168439	1397	1309367071000	21907	10962	1	0	12946
168440	2133	94436306000	21907	10962	2	0	3348
168441	2133	94435304000	21907	10962	3	0	3349
168443	2134	87134689000	21907	10962	5	0	3445
168456	1397	1309357070000	21910	10963	0	0	12947
168457	2134	87133686000	21910	10963	1	0	3446
168458	2133	94434302000	21910	10963	2	0	3350
168459	1397	1309347069000	21911	10964	0	0	12948
168461	2134	87132683000	21911	10964	2	0	3447
168462	1397	1309337068000	21913	10965	0	0	12949
168463	2134	87131680000	21913	10965	1	0	3448
168464	2133	94432298000	21913	10965	2	0	3352
168466	1397	1309327067000	21915	10967	0	0	12950
168467	1397	1309317066000	21915	10967	1	0	12951
168468	1932	1362904664093	21915	10967	3	0	9
168469	2133	94430294000	21915	10967	4	0	3354
168470	2134	87130677000	21915	10967	5	0	3449
168480	1397	1309307065000	21918	10968	0	0	12952
168481	1397	1309297064000	21918	10968	1	0	12953
168482	2133	94429292000	21918	10968	2	0	3355
168483	2133	94428290000	21918	10968	3	0	3356
168484	2134	87128671000	21918	10968	4	0	3451
168492	1397	1309287063000	21920	10969	0	0	12954
168493	1397	1309277062000	21920	10969	1	0	12955
168494	2134	87126665000	21920	10969	2	0	3453
168495	2134	87125662000	21920	10969	3	0	3454
168497	2133	94426286000	21920	10969	5	0	3358
168502	1397	1309267061000	21923	10970	0	0	12956
168503	1397	1309257060000	21923	10970	1	0	12957
168504	1397	1309247059000	21923	10970	2	0	12958
168526	1397	1309187053000	21925	10972	0	0	\N
168527	2134	87116635000	21925	10972	1	0	\N
168528	2133	94417268000	21925	10972	2	0	\N
168529	1397	1309187053000	21926	10972	0	0	\N
168530	2134	87116635000	21926	10972	1	0	\N
168531	2133	94417268000	21926	10972	2	0	\N
168535	1397	1309187053000	21928	10972	0	0	\N
168536	2134	87116635000	21928	10972	1	0	\N
168537	2133	94417268000	21928	10972	2	0	\N
168538	1397	1309187053000	21929	10972	0	0	\N
168539	2134	87116635000	21929	10972	1	0	\N
168540	1397	1309187053000	21930	10972	0	0	\N
168541	2134	87116635000	21930	10972	1	0	\N
168542	2133	94417268000	21930	10972	2	0	\N
168548	1397	1309157050000	21932	10974	0	0	\N
168549	2133	94415264000	21932	10974	1	0	\N
168552	1397	1309157050000	21934	10974	0	0	\N
168553	2133	94415264000	21934	10974	1	0	\N
168554	1397	1309147049000	21936	10975	0	0	\N
168555	2133	94414262000	21936	10975	1	0	\N
168556	2134	87113626000	21936	10975	2	0	\N
168557	1397	1309147049000	21937	10975	0	0	\N
168558	2133	94414262000	21937	10975	1	0	\N
168559	2134	87113626000	21937	10975	2	0	\N
168560	1397	1309147049000	21938	10975	0	0	\N
168561	2133	94414262000	21938	10975	1	0	\N
168562	2134	87113626000	21938	10975	2	0	\N
168563	1397	1309147049000	21939	10975	0	0	\N
168564	2133	94414262000	21939	10975	1	0	\N
168565	2134	87113626000	21939	10975	2	0	\N
168572	1397	1309137048000	21942	10976	0	0	\N
168573	2134	87112623000	21942	10976	1	0	\N
168574	2133	94413260000	21942	10976	2	0	\N
168588	1397	1309097044000	21946	10979	0	0	\N
168589	2134	87108611000	21946	10979	1	0	\N
168590	2133	94409252000	21946	10979	2	0	\N
168591	1397	1309097044000	21947	10979	0	0	\N
168592	2134	87108611000	21947	10979	1	0	\N
168593	2133	94409252000	21947	10979	2	0	\N
168606	1397	1309077042000	21951	10981	0	0	\N
168607	1397	1309067041000	21951	10981	1	0	\N
168608	1397	1309057040000	21951	10981	2	0	\N
168609	2133	94407248000	21951	10981	3	0	\N
168610	2133	94406246000	21951	10981	4	0	\N
168611	2133	94405244000	21951	10981	5	0	\N
168612	2134	87106605000	21951	10981	6	0	\N
168613	2134	87105602000	21951	10981	7	0	\N
168614	2134	87104599000	21951	10981	8	0	\N
168627	1397	1309007035000	21955	10985	0	0	\N
168628	1397	1308997034000	21955	10985	1	0	\N
168629	1397	1308987033000	21955	10985	2	0	\N
168630	2133	94400234000	21955	10985	3	0	\N
168631	2133	94399232000	21955	10985	4	0	\N
168632	2133	94398230000	21955	10985	5	0	\N
168633	2134	87099584000	21955	10985	6	0	\N
168634	2134	87098581000	21955	10985	7	0	\N
168635	2134	87097578000	21955	10985	8	0	\N
168636	1397	1309007035000	21956	10985	0	0	\N
168637	1397	1308997034000	21956	10985	1	0	\N
168638	1397	1308987033000	21956	10985	2	0	\N
168639	2133	94400234000	21956	10985	3	0	\N
168640	2133	94399232000	21956	10985	4	0	\N
168507	1397	1309217056000	21923	10970	5	0	12961
168508	1397	1309207055000	21923	10970	6	0	12962
168509	2134	87124659000	21923	10970	7	0	3455
168510	2134	87123656000	21923	10970	8	0	3456
168511	2134	87122653000	21923	10970	9	0	3457
168513	2134	87120647000	21923	10970	11	0	3459
168514	2134	87119644000	21923	10970	12	0	3460
168515	2134	87118641000	21923	10970	13	0	3461
168516	2133	94425284000	21923	10970	14	0	3359
168517	2133	94424282000	21923	10970	15	0	3360
168519	2133	94422278000	21923	10970	17	0	3362
168520	2133	94421276000	21923	10970	18	0	3363
168521	2133	94420274000	21923	10970	19	0	3364
168522	2133	94419272000	21923	10970	20	0	3365
168524	2134	87117638000	21924	10971	1	0	3462
168525	2133	94418270000	21924	10971	2	0	3366
168532	1397	1309187053000	21927	10972	0	0	12964
168533	2134	87116635000	21927	10972	1	0	3463
168534	2133	94417268000	21927	10972	2	0	3367
168544	1397	1309167051000	21931	10973	1	0	12966
168545	2133	94416266000	21931	10973	2	0	3368
168546	2134	87115632000	21931	10973	3	0	3464
168547	2134	87114629000	21931	10973	4	0	3465
168550	1397	1309157050000	21933	10974	0	0	12967
168566	1397	1309147049000	21940	10975	0	0	12968
168567	2133	94414262000	21940	10975	1	0	3370
168568	2134	87113626000	21940	10975	2	0	3466
168569	1397	1309137048000	21941	10976	0	0	12969
168571	2133	94413260000	21941	10976	2	0	3371
168575	1397	1309127047000	21943	10977	0	0	12970
168576	1397	1309117046000	21943	10977	1	0	12971
168577	1932	1362902664093	21943	10977	2	0	10
168578	2133	94412258000	21943	10977	3	0	3372
168580	2134	87111620000	21943	10977	5	0	3468
168581	2134	87110617000	21943	10977	6	0	3469
168582	1397	1309107045000	21944	10978	0	0	12972
168583	2134	87109614000	21944	10978	1	0	3470
168584	2133	94410254000	21944	10978	2	0	3374
168586	2134	87108611000	21945	10979	1	0	3471
168587	2133	94409252000	21945	10979	2	0	3375
168594	1397	1309087043000	21949	10980	0	0	12974
168595	2134	87107608000	21949	10980	1	0	3472
168597	1397	1309077042000	21950	10981	0	0	12975
168598	1397	1309067041000	21950	10981	1	0	12976
168599	1397	1309057040000	21950	10981	2	0	12977
168600	2133	94407248000	21950	10981	3	0	3377
168601	2133	94406246000	21950	10981	4	0	3378
168603	2134	87106605000	21950	10981	6	0	3473
168604	2134	87105602000	21950	10981	7	0	3474
168605	2134	87104599000	21950	10981	8	0	3475
168615	1397	1309047039000	21952	10982	0	0	12978
168616	1397	1309037038000	21952	10982	1	0	12979
168618	2134	87102593000	21952	10982	3	0	3477
168619	2133	94404242000	21952	10982	4	0	3380
168620	2133	94403240000	21952	10982	5	0	3381
168621	1397	1309027037000	21953	10983	0	0	12980
168623	2133	94402238000	21953	10983	2	0	3382
168624	2134	87101590000	21953	10983	3	0	3478
168625	2133	94401236000	21953	10983	4	0	3383
168626	2134	87100587000	21953	10983	5	0	3479
168641	2133	94398230000	21956	10985	5	0	\N
168642	2134	87099584000	21956	10985	6	0	\N
168643	2134	87098581000	21956	10985	7	0	\N
168644	2134	87097578000	21956	10985	8	0	\N
168645	1397	1309007035000	21957	10985	0	0	\N
168646	1397	1308997034000	21957	10985	1	0	\N
168647	1397	1308987033000	21957	10985	2	0	\N
168648	2133	94400234000	21957	10985	3	0	\N
168649	2133	94399232000	21957	10985	4	0	\N
168650	2133	94398230000	21957	10985	5	0	\N
168651	2134	87099584000	21957	10985	6	0	\N
168652	2134	87098581000	21957	10985	7	0	\N
168653	2134	87097578000	21957	10985	8	0	\N
168663	1397	1309007035000	21959	10985	0	0	\N
168664	1397	1308997034000	21959	10985	1	0	\N
168665	1397	1308987033000	21959	10985	2	0	\N
168666	2133	94400234000	21959	10985	3	0	\N
168667	2133	94399232000	21959	10985	4	0	\N
168668	2133	94398230000	21959	10985	5	0	\N
168669	2134	87099584000	21959	10985	6	0	\N
168670	2134	87098581000	21959	10985	7	0	\N
168671	2134	87097578000	21959	10985	8	0	\N
168675	1397	1308977032000	21961	10986	0	0	\N
168676	2133	94397228000	21961	10986	1	0	\N
168677	2134	87096575000	21961	10986	2	0	\N
168678	1397	1308967031000	21962	10987	0	0	\N
168679	2134	87095572000	21962	10987	1	0	\N
168680	2133	94396226000	21962	10987	2	0	\N
168681	1397	1308967031000	21963	10987	0	0	\N
168682	2134	87095572000	21963	10987	1	0	\N
168683	2133	94396226000	21963	10987	2	0	\N
168687	1397	1308967031000	21965	10987	0	0	\N
168688	2134	87095572000	21965	10987	1	0	\N
168689	2133	94396226000	21965	10987	2	0	\N
168690	1397	1308967031000	21966	10987	0	0	\N
168691	2134	87095572000	21966	10987	1	0	\N
168692	2133	94396226000	21966	10987	2	0	\N
168693	1932	1362904664093	21967	10912	0	0	\N
168694	1932	1362902664093	21967	10912	1	0	\N
168695	1397	1308977032000	21968	10986	0	0	\N
168696	1397	1308967031000	21968	10986	1	0	\N
168697	2133	94397228000	21968	10986	2	0	\N
168698	2133	94396226000	21968	10986	3	0	\N
168699	2134	87096575000	21968	10986	4	0	\N
168700	2134	87095572000	21968	10986	5	0	\N
168701	1397	1308957030000	21972	10988	0	0	\N
168702	1397	1308947029000	21972	10988	1	0	\N
168703	2133	94395224000	21972	10988	2	0	\N
168704	2133	94394222000	21972	10988	3	0	\N
168705	2134	87094569000	21972	10988	4	0	\N
168706	2134	87093566000	21972	10988	5	0	\N
168707	1397	1308957030000	21973	10988	0	0	\N
168708	1397	1308947029000	21973	10988	1	0	\N
168709	2134	87094569000	21973	10988	2	0	\N
168710	2134	87093566000	21973	10988	3	0	\N
168717	1397	1308957030000	21975	10988	0	0	\N
168718	1397	1308947029000	21975	10988	1	0	\N
168719	2133	94395224000	21975	10988	2	0	\N
168720	2133	94394222000	21975	10988	3	0	\N
168721	2134	87094569000	21975	10988	4	0	\N
168722	2134	87093566000	21975	10988	5	0	\N
168723	1397	1308957030000	21976	10988	0	0	\N
168724	1397	1308947029000	21976	10988	1	0	\N
168725	2133	94395224000	21976	10988	2	0	\N
168726	2133	94394222000	21976	10988	3	0	\N
168727	2134	87094569000	21976	10988	4	0	\N
168728	2134	87093566000	21976	10988	5	0	\N
168729	1397	1308937028000	21977	10989	0	0	\N
168730	2134	87092563000	21977	10989	1	0	\N
168731	2133	94393220000	21977	10989	2	0	\N
168732	1397	1308937028000	21978	10989	0	0	\N
168733	2134	87092563000	21978	10989	1	0	\N
168734	2133	94393220000	21978	10989	2	0	\N
168735	1397	1308937028000	21979	10989	0	0	\N
168736	2134	87092563000	21979	10989	1	0	\N
168737	2133	94393220000	21979	10989	2	0	\N
168741	2186	522957693786	21981	10813	0	0	\N
168742	1564	3966553000000	21981	10813	1	0	\N
168743	1397	1311347269000	21981	10813	2	0	\N
168744	1508	22684405117393	21981	10813	3	0	\N
168745	1573	14899271000000	21981	10813	4	0	\N
168746	886	63455021096354	21981	10813	5	0	\N
168747	885	63455011096354	21981	10813	6	0	\N
168748	1397	1311337268000	21981	10813	7	0	\N
168749	773	1000000000000	21981	10813	8	0	\N
168750	1693	7381573908632	21981	10813	9	0	\N
168751	1397	1311327267000	21981	10813	10	0	\N
168752	1397	1311317266000	21981	10813	11	0	\N
168753	1397	1311307265000	21981	10813	12	0	\N
168754	1397	1311297264000	21981	10813	13	0	\N
168755	1397	1311287263000	21981	10813	14	0	\N
168756	478	66000000000000	21981	10813	15	0	\N
168757	1397	1311277262000	21981	10813	16	0	\N
168758	1397	1311267261000	21981	10813	17	0	\N
168759	1397	1311257260000	21981	10813	18	0	\N
168760	1397	1311247259000	21981	10813	19	0	\N
168761	1397	1311237258000	21981	10813	20	0	\N
168762	1397	1311227257000	21981	10813	21	0	\N
168763	1397	1311217256000	21981	10813	22	0	\N
168764	1397	1311207255000	21981	10813	23	0	\N
168765	1397	1311197254000	21981	10813	24	0	\N
168766	1397	1311187253000	21981	10813	25	0	\N
168767	1397	1311177252000	21981	10813	26	0	\N
168768	1397	1311167251000	21981	10813	27	0	\N
168769	1397	1311157250000	21981	10813	28	0	\N
168770	1397	1311147249000	21981	10813	29	0	\N
168771	1397	1311137248000	21981	10813	30	0	\N
168772	1397	1311127247000	21981	10813	31	0	\N
168773	1397	1311117246000	21981	10813	32	0	\N
168774	1397	1311107245000	21981	10813	33	0	\N
168775	1397	1311097244000	21981	10813	34	0	\N
168776	1397	1311087243000	21981	10813	35	0	\N
168656	1397	1308987033000	21958	10985	2	0	12984
168657	2133	94400234000	21958	10985	3	0	3384
168658	2133	94399232000	21958	10985	4	0	3385
168659	2133	94398230000	21958	10985	5	0	3386
168660	2134	87099584000	21958	10985	6	0	3480
168662	2134	87097578000	21958	10985	8	0	3482
168672	1397	1308977032000	21960	10986	0	0	12985
168673	2133	94397228000	21960	10986	1	0	3387
168674	2134	87096575000	21960	10986	2	0	3483
168684	1397	1308967031000	21964	10987	0	0	12986
168686	2133	94396226000	21964	10987	2	0	3388
168711	1397	1308957030000	21974	10988	0	0	12987
168712	1397	1308947029000	21974	10988	1	0	12988
168713	2133	94395224000	21974	10988	2	0	3389
168715	2134	87094569000	21974	10988	4	0	3485
168716	2134	87093566000	21974	10988	5	0	3486
168738	1397	1308937028000	21980	10989	0	0	12989
168739	2134	87092563000	21980	10989	1	0	3487
168740	2133	94393220000	21980	10989	2	0	3391
168777	1397	1311077242000	21981	10813	36	0	\N
168778	1397	1311067241000	21981	10813	37	0	\N
168779	1397	1311057240000	21981	10813	38	0	\N
168780	1397	1311047239000	21981	10813	39	0	\N
168781	1397	1311037238000	21981	10813	40	0	\N
168782	1397	1311027237000	21981	10813	41	0	\N
168783	1397	1311017236000	21981	10813	42	0	\N
168784	1397	1311007235000	21981	10813	43	0	\N
168785	1397	1310997234000	21981	10813	44	0	\N
168786	1397	1310987233000	21981	10813	45	0	\N
168787	1397	1310977232000	21981	10813	46	0	\N
168788	1397	1310967231000	21981	10813	47	0	\N
168789	1397	1310957230000	21981	10813	48	0	\N
168790	1397	1310947229000	21981	10813	49	0	\N
168791	1397	1310937228000	21981	10813	50	0	\N
168792	1397	1310927227000	21981	10813	51	0	\N
168793	1397	1310917226000	21981	10813	52	0	\N
168794	1397	1310907225000	21981	10813	53	0	\N
168795	1397	1310897224000	21981	10813	54	0	\N
168796	1397	1310887223000	21981	10813	55	0	\N
168797	1397	1310877222000	21981	10813	56	0	\N
168798	1397	1310867221000	21981	10813	57	0	\N
168799	1397	1310857220000	21981	10813	58	0	\N
168800	1397	1310847219000	21981	10813	59	0	\N
168801	1397	1310837218000	21981	10813	60	0	\N
168802	1397	1310827217000	21981	10813	61	0	\N
168803	1397	1310817216000	21981	10813	62	0	\N
168804	1397	1310807215000	21981	10813	63	0	\N
168805	1397	1310797214000	21981	10813	65	0	\N
168806	1397	1310787213000	21981	10813	66	0	\N
168807	1397	1310777212000	21981	10813	67	0	\N
168808	1397	1310767211000	21981	10813	68	0	\N
168809	1397	1310757210000	21981	10813	69	0	\N
168810	1397	1310747209000	21981	10813	70	0	\N
168811	1508	18365924556796	21981	10813	71	0	\N
168812	1508	15279852229364	21981	10813	72	0	\N
168813	1508	6680255156616	21981	10813	73	0	\N
168814	1397	1310737208000	21981	10813	74	0	\N
168815	1546	17252756000000	21981	10813	75	0	\N
168816	1397	1310727207000	21981	10813	76	0	\N
168817	1397	1310717206000	21981	10813	77	0	\N
168818	1397	1310707205000	21981	10813	78	0	\N
168819	1397	1310697204000	21981	10813	79	0	\N
168820	1397	1310687203000	21981	10813	80	0	\N
168821	1397	1310677202000	21981	10813	81	0	\N
168822	1397	1310667201000	21981	10813	82	0	\N
168823	1397	1310657200000	21981	10813	83	0	\N
168824	1397	1310647199000	21981	10813	84	0	\N
168825	1397	1310637198000	21981	10813	85	0	\N
168826	1397	1310627197000	21981	10813	86	0	\N
168827	1397	1310617196000	21981	10813	87	0	\N
168828	1397	1310607195000	21981	10813	88	0	\N
168829	1397	1310597194000	21981	10813	89	0	\N
168830	1397	1310587193000	21981	10813	90	0	\N
168831	1397	1310577192000	21981	10813	91	0	\N
168832	1397	1310567191000	21981	10813	92	0	\N
168833	1397	1310557190000	21981	10813	93	0	\N
168834	1397	1310547189000	21981	10813	94	0	\N
168835	1397	1310537188000	21981	10813	95	0	\N
168836	1397	1310527187000	21981	10813	96	0	\N
168837	1397	1310517186000	21981	10813	97	0	\N
168838	1397	1310507185000	21981	10813	98	0	\N
168839	1397	1310497184000	21981	10813	99	0	\N
168840	1397	1310487183000	21981	10813	100	0	\N
168841	1397	1310477182000	21981	10813	101	0	\N
168842	1397	1310467181000	21981	10813	102	0	\N
168843	1397	1310457180000	21981	10813	103	0	\N
168844	1397	1310447179000	21981	10813	104	0	\N
168845	1397	1310437178000	21981	10813	105	0	\N
168846	1397	1310427177000	21981	10813	106	0	\N
168847	1397	1310417176000	21981	10813	107	0	\N
168848	1397	1310407175000	21981	10813	108	0	\N
168849	1397	1310397174000	21981	10813	109	0	\N
168850	1397	1310387173000	21981	10813	110	0	\N
168851	1397	1310377172000	21981	10813	111	0	\N
168852	1397	1310367171000	21981	10813	112	0	\N
168853	1397	1310357170000	21981	10813	113	0	\N
168854	1397	1310347169000	21981	10813	114	0	\N
168855	1397	1310337168000	21981	10813	115	0	\N
168856	1397	1310327167000	21981	10813	116	0	\N
168857	1397	1310317166000	21981	10813	117	0	\N
168858	1397	1310307165000	21981	10813	118	0	\N
168859	1397	1310297164000	21981	10813	119	0	\N
168860	1397	1310287163000	21981	10813	120	0	\N
168861	1397	1310277162000	21981	10813	121	0	\N
168862	1397	1310267161000	21981	10813	122	0	\N
168863	1397	1310257160000	21981	10813	123	0	\N
168864	1397	1310247159000	21981	10813	124	0	\N
168865	1397	1310237158000	21981	10813	125	0	\N
168866	1397	1308937028000	21982	10989	0	0	\N
168867	2134	87092563000	21982	10989	1	0	\N
168868	2133	94393220000	21982	10989	2	0	\N
168878	1397	1308897024000	21985	10992	0	0	\N
168879	2134	87088551000	21985	10992	1	0	\N
168880	2133	94389212000	21985	10992	2	0	\N
168898	1397	1308847019000	21991	10996	0	0	\N
168899	2133	94384202000	21991	10996	1	0	\N
168900	2134	87084539000	21991	10996	2	0	\N
168901	1397	1308847019000	21992	10996	0	0	\N
168902	2133	94384202000	21992	10996	1	0	\N
168903	2134	87084539000	21992	10996	2	0	\N
168904	1397	1308847019000	21993	10996	0	0	\N
168905	2133	94384202000	21993	10996	1	0	\N
168906	2134	87084539000	21993	10996	2	0	\N
168871	2133	94392218000	21983	10990	2	0	3392
168872	2133	94391216000	21983	10990	3	0	3393
168873	2134	87091560000	21983	10990	4	0	3488
168874	2134	87090557000	21983	10990	5	0	3489
168875	1397	1308907025000	21984	10991	0	0	12992
168877	2134	87089554000	21984	10991	2	0	3490
168881	1397	1308897024000	21986	10992	0	0	12993
168882	2134	87088551000	21986	10992	1	0	3491
168883	2133	94389212000	21986	10992	2	0	3395
168884	1397	1308887023000	21987	10993	0	0	12994
168886	2133	94388210000	21987	10993	2	0	3396
168887	1397	1308877022000	21988	10994	0	0	12995
168888	2133	94387208000	21988	10994	1	0	3397
168889	1397	1308867021000	21989	10995	0	0	12996
168891	2133	94386206000	21989	10995	2	0	3398
168892	2134	87086545000	21989	10995	3	0	3493
168893	2133	94385204000	21989	10995	4	0	3399
168894	2134	87085542000	21989	10995	5	0	3494
168895	1397	1308847019000	21990	10996	0	0	12998
168897	2134	87084539000	21990	10996	2	0	3495
168907	1397	1308837018000	21994	10997	0	0	12999
168908	1397	1308827017000	21994	10997	1	0	13000
168909	2134	87083536000	21994	10997	2	0	3496
168910	2134	87082533000	21994	10997	3	0	3497
168912	2133	94382198000	21994	10997	5	0	3402
168922	1397	1308797014000	21998	11000	0	0	\N
168923	2134	87079524000	21998	11000	1	0	\N
168924	2133	94379192000	21998	11000	2	0	\N
168925	1397	1309387073000	21999	10897	0	0	\N
168926	1397	1309377072000	21999	10897	1	0	\N
168927	1397	1309367071000	21999	10897	2	0	\N
168928	1397	1309357070000	21999	10897	4	0	\N
168929	1397	1309347069000	21999	10897	5	0	\N
168930	1397	1309337068000	21999	10897	6	0	\N
168931	1397	1309327067000	21999	10897	7	0	\N
168932	1397	1309317066000	21999	10897	8	0	\N
168933	1397	1309307065000	21999	10897	9	0	\N
168934	1397	1309297064000	21999	10897	10	0	\N
168935	1397	1309287063000	21999	10897	11	0	\N
168936	1397	1309277062000	21999	10897	12	0	\N
168937	1397	1309267061000	21999	10897	13	0	\N
168938	1397	1309257060000	21999	10897	14	0	\N
168939	1397	1309247059000	21999	10897	15	0	\N
168940	1397	1309237058000	21999	10897	16	0	\N
168941	1397	1309227057000	21999	10897	17	0	\N
168942	1397	1309217056000	21999	10897	18	0	\N
168943	1397	1309207055000	21999	10897	19	0	\N
168944	1397	1309197054000	21999	10897	20	0	\N
168945	1397	1309187053000	21999	10897	21	0	\N
168946	1397	1309177052000	21999	10897	22	0	\N
168947	1397	1309167051000	21999	10897	23	0	\N
168948	1397	1309157050000	21999	10897	24	0	\N
168949	1397	1309147049000	21999	10897	25	0	\N
168950	1397	1309137048000	21999	10897	26	0	\N
168951	1397	1309127047000	21999	10897	27	0	\N
168952	1397	1309117046000	21999	10897	28	0	\N
168953	1397	1309107045000	21999	10897	29	0	\N
168954	1397	1309097044000	21999	10897	30	0	\N
168955	1397	1309087043000	21999	10897	31	0	\N
168956	1397	1309077042000	21999	10897	32	0	\N
168957	1397	1309067041000	21999	10897	33	0	\N
168958	1397	1309057040000	21999	10897	34	0	\N
168959	1397	1309047039000	21999	10897	35	0	\N
168960	1397	1309037038000	21999	10897	36	0	\N
168961	1397	1309027037000	21999	10897	37	0	\N
168962	1397	1309017036000	21999	10897	38	0	\N
168963	1397	1309007035000	21999	10897	39	0	\N
168964	1397	1308997034000	21999	10897	40	0	\N
168965	1397	1308987033000	21999	10897	41	0	\N
168966	1397	1308977032000	21999	10897	42	0	\N
168967	1397	1308967031000	21999	10897	43	0	\N
168968	1397	1308957030000	21999	10897	44	0	\N
168969	1397	1308947029000	21999	10897	45	0	\N
168970	1397	1308937028000	21999	10897	46	0	\N
168971	1397	1308927027000	21999	10897	47	0	\N
168972	1397	1308917026000	21999	10897	48	0	\N
168973	1397	1308907025000	21999	10897	49	0	\N
168974	1397	1308897024000	21999	10897	50	0	\N
168975	1397	1308887023000	21999	10897	51	0	\N
168976	1397	1308877022000	21999	10897	52	0	\N
168977	1397	1308867021000	21999	10897	53	0	\N
168978	1397	1308857020000	21999	10897	54	0	\N
168979	1397	1308847019000	21999	10897	55	0	\N
168980	1397	1308837018000	21999	10897	56	0	\N
168981	1397	1308827017000	21999	10897	57	0	\N
168982	1397	1308817016000	21999	10897	58	0	\N
168983	1397	1308807015000	21999	10897	59	0	\N
168984	1397	1308797014000	21999	10897	60	0	\N
168985	1932	1362904664093	21999	10897	61	0	\N
168986	1932	1362902664093	21999	10897	62	0	\N
168987	2133	94508450000	21999	10897	63	0	\N
168988	2133	94507448000	21999	10897	64	0	\N
168989	2133	94506446000	21999	10897	65	0	\N
168990	2133	94505444000	21999	10897	66	0	\N
168991	2133	94504442000	21999	10897	67	0	\N
168992	2133	94503440000	21999	10897	68	0	\N
168993	2133	94502438000	21999	10897	69	0	\N
168994	2133	94501436000	21999	10897	70	0	\N
168995	2133	94500434000	21999	10897	71	0	\N
168996	2133	94499432000	21999	10897	72	0	\N
168997	2133	94498430000	21999	10897	73	0	\N
168998	2133	94497428000	21999	10897	74	0	\N
168999	2133	94496426000	21999	10897	75	0	\N
169000	2133	94495424000	21999	10897	76	0	\N
169001	2133	94494422000	21999	10897	77	0	\N
169002	2133	94493420000	21999	10897	78	0	\N
169003	2133	94492418000	21999	10897	79	0	\N
169004	2133	94491416000	21999	10897	80	0	\N
169005	2133	94490414000	21999	10897	81	0	\N
169006	2133	94489412000	21999	10897	82	0	\N
169007	2133	94488410000	21999	10897	83	0	\N
169008	2133	94487408000	21999	10897	84	0	\N
169009	2133	94486406000	21999	10897	85	0	\N
169010	2133	94485404000	21999	10897	86	0	\N
169011	2133	94484402000	21999	10897	87	0	\N
169012	2133	94483400000	21999	10897	88	0	\N
169013	2133	94482398000	21999	10897	89	0	\N
169014	2133	94481396000	21999	10897	90	0	\N
169015	2133	94480394000	21999	10897	91	0	\N
169016	2133	94479392000	21999	10897	92	0	\N
169017	2133	94478390000	21999	10897	93	0	\N
169018	2133	94477388000	21999	10897	94	0	\N
169019	2133	94476386000	21999	10897	95	0	\N
169020	2133	94475384000	21999	10897	96	0	\N
169021	2133	94474382000	21999	10897	97	0	\N
169022	2133	94473380000	21999	10897	98	0	\N
169023	2133	94472378000	21999	10897	99	0	\N
169024	2133	94471376000	21999	10897	100	0	\N
169025	2133	94470374000	21999	10897	101	0	\N
169026	2133	94469372000	21999	10897	102	0	\N
169027	2133	94468370000	21999	10897	103	0	\N
169028	2133	94467368000	21999	10897	104	0	\N
169029	2133	94466366000	21999	10897	105	0	\N
169030	2133	94465364000	21999	10897	106	0	\N
169031	2133	94464362000	21999	10897	107	0	\N
169032	2133	94463360000	21999	10897	108	0	\N
169033	2133	94462358000	21999	10897	109	0	\N
169034	2133	94461356000	21999	10897	110	0	\N
169035	2133	94460354000	21999	10897	111	0	\N
169036	2133	94459352000	21999	10897	112	0	\N
169037	2133	94458350000	21999	10897	113	0	\N
169038	2133	94457348000	21999	10897	114	0	\N
169039	2133	94456346000	21999	10897	115	0	\N
169040	2133	94455344000	21999	10897	116	0	\N
169041	2133	94454342000	21999	10897	117	0	\N
169042	2133	94453340000	21999	10897	118	0	\N
169043	2133	94452338000	21999	10897	119	0	\N
169044	2133	94451336000	21999	10897	120	0	\N
169045	2133	94450334000	21999	10897	121	0	\N
169046	2133	94449332000	21999	10897	122	0	\N
169047	2133	94448330000	21999	10897	123	0	\N
169048	2133	94447328000	21999	10897	124	0	\N
168915	2133	94381196000	21995	10998	2	0	3403
168916	1397	1308807015000	21996	10999	0	0	13002
168917	2133	94380194000	21996	10999	1	0	3404
168918	2134	87080527000	21996	10999	2	0	3499
168919	1397	1308797014000	21997	11000	0	0	13003
168921	2133	94379192000	21997	11000	2	0	3405
169049	2133	94446326000	21999	10897	125	0	\N
169053	1397	1308787013000	22001	11001	0	0	\N
169054	2134	87078521000	22001	11001	1	0	\N
169055	2133	94378190000	22001	11001	2	0	\N
169056	1397	1308787013000	22002	11001	0	0	\N
169057	2134	87078521000	22002	11001	1	0	\N
169058	2133	94378190000	22002	11001	2	0	\N
169072	1397	1308737008000	22006	11005	0	0	\N
169073	2134	87073506000	22006	11005	1	0	\N
169074	2133	94373180000	22006	11005	2	0	\N
169075	1397	1308737008000	22007	11005	0	0	\N
169076	2134	87073506000	22007	11005	1	0	\N
169077	2133	94373180000	22007	11005	2	0	\N
169084	1397	1308727007000	22010	11006	0	0	\N
169085	2134	87072503000	22010	11006	2	0	\N
169086	1397	1308727007000	22011	11006	0	0	\N
169087	2133	94372178000	22011	11006	2	0	\N
169088	2134	87072503000	22011	11006	3	0	\N
169089	1397	1308717006000	22012	11007	0	0	\N
169090	2134	87071500000	22012	11007	1	0	\N
169091	2133	94371176000	22012	11007	2	0	\N
169097	1397	1308707005000	22015	11008	0	0	\N
169098	2133	94370174000	22015	11008	1	0	\N
169099	2134	87070497000	22015	11008	2	0	\N
169104	1397	1308697004000	22017	11009	0	0	\N
169105	2134	87069494000	22017	11009	1	0	\N
169106	2133	94370174000	22017	11009	2	0	\N
169107	2133	94369172000	22017	11009	3	0	\N
169108	1397	1308697004000	22018	11009	0	0	\N
169109	2134	87069494000	22018	11009	1	0	\N
169110	2133	94370174000	22018	11009	2	0	\N
169111	2133	94369172000	22018	11009	3	0	\N
169112	1397	1308697004000	22019	11009	0	0	\N
169113	2134	87069494000	22019	11009	1	0	\N
169114	2133	94370174000	22019	11009	2	0	\N
169115	2133	94369172000	22019	11009	3	0	\N
169116	1397	1308697004000	22020	11009	0	0	\N
169117	2134	87069494000	22020	11009	1	0	\N
169118	2133	94370174000	22020	11009	2	0	\N
169119	2133	94369172000	22020	11009	3	0	\N
169120	1397	1308697004000	22021	11009	0	0	\N
169121	2134	87069494000	22021	11009	1	0	\N
169122	2133	94370174000	22021	11009	2	0	\N
169123	2133	94369172000	22021	11009	3	0	\N
169124	1397	1308687003000	22022	11010	0	0	\N
169125	2134	87068491000	22022	11010	1	0	\N
169126	2133	94368170000	22022	11010	2	0	\N
169133	1397	1308677002000	22025	11011	0	0	\N
169140	1397	1308657000000	22028	11013	0	0	\N
169141	2134	87065482000	22028	11013	1	0	\N
169142	2133	94365164000	22028	11013	2	0	\N
169145	1724	15296685500000	22030	11015	0	0	\N
169146	1724	11211675500000	22030	11015	1	0	\N
169147	1724	8454665500000	22030	11015	2	0	\N
169148	1724	6174655500000	22030	11015	3	0	\N
169149	2132	148017018000	22030	11015	4	0	\N
169150	2134	87063476000	22030	11015	5	0	\N
169151	2134	87062473000	22030	11015	6	0	\N
169166	1397	1308606995000	22032	11016	0	0	\N
169167	2134	87061470000	22032	11016	1	0	\N
169168	1397	1308606995000	22033	11016	0	0	\N
169169	2133	94360154000	22033	11016	1	0	\N
169170	2134	87061470000	22033	11016	2	0	\N
169178	2186	522957693786	22036	10783	0	0	\N
169179	1564	3966553000000	22036	10783	1	0	\N
169180	1397	1311097244000	22036	10783	2	0	\N
169181	1397	1311087243000	22036	10783	3	0	\N
169182	1397	1311077242000	22036	10783	4	0	\N
169183	1397	1311067241000	22036	10783	5	0	\N
169184	1397	1311057240000	22036	10783	6	0	\N
169052	2133	94378190000	22000	11001	2	0	3406
169059	1397	1308777012000	22003	11002	0	0	13005
169060	2133	94377188000	22003	11002	1	0	3407
169061	2134	87077518000	22003	11002	2	0	3502
169062	1397	1308767011000	22004	11003	0	0	13006
169064	2133	94376186000	22004	11003	2	0	3408
169065	1397	1308757010000	22005	11004	0	0	13007
169066	1397	1308747009000	22005	11004	1	0	13008
169067	2133	94375184000	22005	11004	2	0	3409
169068	2133	94374182000	22005	11004	3	0	3410
169070	2134	87075512000	22005	11004	5	0	3504
169071	2134	87074509000	22005	11004	6	0	3505
169078	1397	1308737008000	22008	11005	0	0	13009
169079	2134	87073506000	22008	11005	1	0	3506
169081	1397	1308727007000	22009	11006	0	0	13010
169082	2133	94372178000	22009	11006	2	0	3412
169083	2134	87072503000	22009	11006	3	0	3507
169092	1397	1308717006000	22013	11007	0	0	13011
169093	2134	87071500000	22013	11007	1	0	3508
169095	1397	1308707005000	22014	11008	0	0	13012
169096	2134	87070497000	22014	11008	1	0	3509
169100	1397	1308697004000	22016	11009	0	0	13013
169101	2134	87069494000	22016	11009	1	0	3510
169102	2133	94370174000	22016	11009	2	0	3414
169127	1397	1308687003000	22023	11010	0	0	13014
169128	2134	87068491000	22023	11010	1	0	3511
169129	2133	94368170000	22023	11010	2	0	3416
169130	1397	1308677002000	22024	11011	0	0	13015
169132	2133	94367168000	22024	11011	2	0	3417
169134	1397	1308667001000	22026	11012	0	0	13016
169135	2133	94366166000	22026	11012	1	0	3418
169136	2134	87066485000	22026	11012	2	0	3513
169137	1397	1308657000000	22027	11013	0	0	13017
169139	2133	94365164000	22027	11013	2	0	3419
169143	1397	1308646999000	22029	11014	0	0	13018
169144	2134	87064479000	22029	11014	1	0	3515
169152	1724	15296685500000	22031	11015	0	0	10
169153	1724	11211675500000	22031	11015	1	0	11
169155	1397	1308636998000	22031	11015	3	0	13019
169156	1724	6174655500000	22031	11015	4	0	13
169157	1397	1308626997000	22031	11015	5	0	13020
169158	1397	1308616996000	22031	11015	6	0	13021
169160	2134	87063476000	22031	11015	8	0	3516
169161	2134	87062473000	22031	11015	9	0	3517
169162	2133	94364162000	22031	11015	10	0	3420
169163	2133	94363160000	22031	11015	11	0	3421
169164	2133	94362158000	22031	11015	12	0	3422
169171	1397	1308606995000	22034	11016	0	0	13022
169172	2133	94360154000	22034	11016	1	0	3424
169173	2134	87061470000	22034	11016	2	0	3518
169174	1397	1308596994000	22035	11017	0	0	13023
169175	2132	148016017000	22035	11017	1	0	983
169177	2133	94359152000	22035	11017	3	0	3425
169185	1508	22684405117393	22036	10783	7	0	\N
169186	1573	14899271000000	22036	10783	8	0	\N
169187	886	63455021096354	22036	10783	9	0	\N
169188	1724	14576661500000	22036	10783	10	0	\N
169189	1724	10491651500000	22036	10783	11	0	\N
169190	1724	7734641500000	22036	10783	12	0	\N
169191	885	63455011096354	22036	10783	13	0	\N
169192	773	1000000000000	22036	10783	14	0	\N
169193	1693	6661561908632	22036	10783	15	0	\N
169194	1397	1311047239000	22036	10783	16	0	\N
169195	478	66000000000000	22036	10783	17	0	\N
169196	1397	1311037238000	22036	10783	18	0	\N
169197	1397	1311027237000	22036	10783	19	0	\N
169198	1397	1311017236000	22036	10783	20	0	\N
169199	1397	1311007235000	22036	10783	21	0	\N
169200	1397	1310997234000	22036	10783	22	0	\N
169201	1397	1310987233000	22036	10783	23	0	\N
169202	1397	1310977232000	22036	10783	24	0	\N
169203	1397	1310967231000	22036	10783	25	0	\N
169204	1397	1310957230000	22036	10783	26	0	\N
169205	1397	1310947229000	22036	10783	27	0	\N
169206	1397	1310937228000	22036	10783	28	0	\N
169207	1397	1310927227000	22036	10783	29	0	\N
169208	1397	1310917226000	22036	10783	30	0	\N
169209	1397	1310907225000	22036	10783	31	0	\N
169210	1397	1310897224000	22036	10783	32	0	\N
169211	1397	1310887223000	22036	10783	33	0	\N
169212	1397	1310877222000	22036	10783	34	0	\N
169213	1397	1310867221000	22036	10783	35	0	\N
169214	1397	1310857220000	22036	10783	36	0	\N
169215	1397	1310847219000	22036	10783	37	0	\N
169216	1397	1310837218000	22036	10783	38	0	\N
169217	1397	1310827217000	22036	10783	39	0	\N
169218	1397	1310817216000	22036	10783	40	0	\N
169219	1397	1310807215000	22036	10783	41	0	\N
169220	1397	1310797214000	22036	10783	42	0	\N
169221	1397	1310787213000	22036	10783	43	0	\N
169222	1397	1310777212000	22036	10783	44	0	\N
169223	1397	1310767211000	22036	10783	45	0	\N
169224	1397	1310757210000	22036	10783	46	0	\N
169225	1397	1310747209000	22036	10783	47	0	\N
169226	1508	18365924556796	22036	10783	48	0	\N
169227	1508	15279852229364	22036	10783	49	0	\N
169228	1508	6680255156616	22036	10783	50	0	\N
169229	1397	1310737208000	22036	10783	51	0	\N
169230	1546	17252756000000	22036	10783	52	0	\N
169231	1397	1310727207000	22036	10783	53	0	\N
169232	1397	1310717206000	22036	10783	54	0	\N
169233	1724	5454631500000	22036	10783	55	0	\N
169234	1397	1310707205000	22036	10783	56	0	\N
169235	1397	1310697204000	22036	10783	57	0	\N
169236	1397	1310687203000	22036	10783	58	0	\N
169237	1397	1310677202000	22036	10783	59	0	\N
169238	1397	1310667201000	22036	10783	60	0	\N
169239	1397	1310657200000	22036	10783	61	0	\N
169240	1397	1310647199000	22036	10783	62	0	\N
169241	1397	1310637198000	22036	10783	63	0	\N
169242	1397	1310627197000	22036	10783	64	0	\N
169243	1397	1310617196000	22036	10783	65	0	\N
169244	1397	1310607195000	22036	10783	66	0	\N
169245	1397	1310597194000	22036	10783	67	0	\N
169246	1397	1310587193000	22036	10783	68	0	\N
169247	1397	1310577192000	22036	10783	69	0	\N
169248	1397	1310567191000	22036	10783	70	0	\N
169249	1397	1310557190000	22036	10783	71	0	\N
169250	1397	1310547189000	22036	10783	72	0	\N
169251	1397	1310537188000	22036	10783	73	0	\N
169252	1397	1310527187000	22036	10783	74	0	\N
169253	1397	1310517186000	22036	10783	75	0	\N
169254	1397	1310507185000	22036	10783	76	0	\N
169255	1397	1310497184000	22036	10783	77	0	\N
169256	1397	1310487183000	22036	10783	78	0	\N
169257	1397	1310477182000	22036	10783	79	0	\N
169258	1397	1310467181000	22036	10783	80	0	\N
169259	1397	1310457180000	22036	10783	81	0	\N
169260	1397	1310447179000	22036	10783	82	0	\N
169261	1397	1310437178000	22036	10783	83	0	\N
169262	1397	1310427177000	22036	10783	84	0	\N
169263	1397	1310417176000	22036	10783	85	0	\N
169264	1397	1310407175000	22036	10783	86	0	\N
169265	1397	1310397174000	22036	10783	87	0	\N
169266	1397	1310387173000	22036	10783	88	0	\N
169267	1397	1310377172000	22036	10783	89	0	\N
169268	1397	1310367171000	22036	10783	90	0	\N
169269	1397	1310357170000	22036	10783	91	0	\N
169270	1397	1310347169000	22036	10783	92	0	\N
169271	1397	1310337168000	22036	10783	93	0	\N
169272	1397	1310327167000	22036	10783	94	0	\N
169273	1397	1310317166000	22036	10783	95	0	\N
169274	1397	1310307165000	22036	10783	96	0	\N
169275	1397	1310297164000	22036	10783	97	0	\N
169276	1397	1310287163000	22036	10783	98	0	\N
169277	1397	1310277162000	22036	10783	99	0	\N
169278	1397	1310267161000	22036	10783	100	0	\N
169279	1397	1310257160000	22036	10783	101	0	\N
169280	1397	1310247159000	22036	10783	102	0	\N
169281	1397	1310237158000	22036	10783	103	0	\N
169282	1397	1310227157000	22036	10783	104	0	\N
169283	1397	1310217156000	22036	10783	105	0	\N
169284	1397	1310207155000	22036	10783	106	0	\N
169285	1397	1310197154000	22036	10783	108	0	\N
169286	1397	1310187153000	22036	10783	109	0	\N
169287	1397	1310177152000	22036	10783	110	0	\N
169288	1397	1310167151000	22036	10783	111	0	\N
169289	1397	1310157150000	22036	10783	112	0	\N
169290	1397	1310147149000	22036	10783	113	0	\N
169291	1397	1310137148000	22036	10783	114	0	\N
169292	1397	1310127147000	22036	10783	115	0	\N
169293	1397	1310117146000	22036	10783	116	0	\N
169294	1397	1310107145000	22036	10783	117	0	\N
169295	1397	1310097144000	22036	10783	118	0	\N
169296	1397	1310087143000	22036	10783	119	0	\N
169297	1397	1310077142000	22036	10783	120	0	\N
169298	1397	1310067141000	22036	10783	121	0	\N
169299	1397	1310057140000	22036	10783	122	0	\N
169300	1397	1310047139000	22036	10783	123	0	\N
169301	1397	1310037138000	22036	10783	124	0	\N
169302	1397	1310027137000	22036	10783	125	0	\N
169305	1397	1308566991000	22037	11018	2	0	13026
169306	2133	94358150000	22037	11018	3	0	3426
169307	2134	87059464000	22037	11018	4	0	3520
169308	2133	94357148000	22037	11018	5	0	3427
169309	2133	94356146000	22037	11018	6	0	3428
169311	2134	87057458000	22037	11018	8	0	3522
169312	1397	1308556990000	22038	11019	0	0	13027
169313	2133	94355144000	22038	11019	1	0	3429
169314	2134	87056455000	22038	11019	2	0	3523
169315	2132	148015016000	22038	11019	3	0	984
169317	2134	87055452000	22039	11020	1	0	3524
169318	1397	1308536988000	22040	11021	0	0	13029
169319	2133	94354142000	22040	11021	1	0	3430
169320	2133	94353140000	22040	11021	2	0	3431
169326	1397	1308526987000	22042	11022	0	0	\N
169327	2132	148014015000	22042	11022	1	0	\N
169328	2134	87053446000	22042	11022	2	0	\N
169329	2133	94352138000	22042	11022	3	0	\N
169332	1397	1308506985000	22044	11024	0	0	\N
169333	1397	1308496984000	22044	11024	1	0	\N
169334	1397	1308486983000	22044	11024	2	0	\N
169335	1397	1308476982000	22044	11024	3	0	\N
169336	2133	94351136000	22044	11024	4	0	\N
169337	2132	148013014000	22044	11024	5	0	\N
169338	2133	94350134000	22044	11024	6	0	\N
169339	2134	87051440000	22044	11024	7	0	\N
169340	2134	87050437000	22044	11024	8	0	\N
169341	2134	87049434000	22044	11024	9	0	\N
169342	2134	87048431000	22044	11024	10	0	\N
169343	2133	94349132000	22044	11024	11	0	\N
169344	2133	94348130000	22044	11024	12	0	\N
169345	2133	94347128000	22044	11024	13	0	\N
169363	1397	1308466981000	22047	11025	0	0	\N
169364	2133	94346126000	22047	11025	1	0	\N
169365	2134	87047428000	22047	11025	2	0	\N
169366	1397	1308466981000	22048	11025	0	0	\N
169367	2133	94346126000	22048	11025	1	0	\N
169368	2134	87047428000	22048	11025	2	0	\N
169369	1397	1308456980000	22049	11026	0	0	\N
169370	2132	148012013000	22049	11026	1	0	\N
169371	2133	94345124000	22049	11026	2	0	\N
169372	2134	87046425000	22049	11026	3	0	\N
169380	1397	1308436978000	22054	11028	0	0	\N
169381	2133	94343120000	22054	11028	1	0	\N
169382	2134	87044419000	22054	11028	2	0	\N
169390	1397	1308416976000	22058	11030	0	0	\N
169391	2133	94341116000	22058	11030	1	0	\N
169392	2134	87042413000	22058	11030	2	0	\N
169396	1397	1308416976000	22060	11030	0	0	\N
169397	2133	94341116000	22060	11030	1	0	\N
169398	2134	87042413000	22060	11030	2	0	\N
169409	1397	1308376972000	22062	11032	0	0	\N
169410	2134	87038401000	22062	11032	1	0	\N
169411	2133	94337108000	22062	11032	2	0	\N
169415	1397	1308376972000	22064	11032	0	0	\N
169416	2134	87038401000	22064	11032	1	0	\N
169417	2133	94337108000	22064	11032	2	0	\N
169425	1397	1308356970000	22067	11034	0	0	\N
169426	2134	87036395000	22067	11034	1	0	\N
169427	2132	148009010000	22067	11034	2	0	\N
169434	1397	1308346969000	22069	11035	0	0	\N
169435	1397	1308336968000	22069	11035	1	0	\N
169436	2134	87035392000	22069	11035	2	0	\N
169437	2134	87034389000	22069	11035	3	0	\N
169438	2133	94334102000	22069	11035	4	0	\N
169439	2133	94333100000	22069	11035	5	0	\N
169444	1724	14576661500000	22071	10767	0	0	\N
169445	1724	10491651500000	22071	10767	1	0	\N
169446	1724	7734641500000	22071	10767	2	0	\N
169447	1724	5454631500000	22071	10767	3	0	\N
169448	1932	1362904664093	22071	10767	4	0	\N
169449	1932	1362902664093	22071	10767	5	0	\N
169450	1573	8682270000000	22071	10767	6	0	\N
169451	1573	5375269000000	22071	10767	7	0	\N
169452	1573	3144268000000	22071	10767	8	0	\N
169453	1573	1299267000000	22071	10767	9	0	\N
169454	369	69395980190850	22071	10767	10	0	\N
169455	1654	15750361999798	22072	11037	0	0	\N
169456	1397	1308316966000	22072	11037	1	0	\N
169323	2132	148014015000	22041	11022	1	0	985
169324	2134	87053446000	22041	11022	2	0	3526
169325	2133	94352138000	22041	11022	3	0	3432
169330	1397	1308516986000	22043	11023	0	0	13031
169331	2134	87052443000	22043	11023	1	0	3527
169347	1397	1308496984000	22045	11024	1	0	13033
169348	1397	1308486983000	22045	11024	2	0	13034
169349	1397	1308476982000	22045	11024	3	0	13035
169350	2133	94351136000	22045	11024	4	0	3433
169351	2132	148013014000	22045	11024	5	0	986
169353	2134	87051440000	22045	11024	7	0	3528
169354	2134	87050437000	22045	11024	8	0	3529
169355	2134	87049434000	22045	11024	9	0	3530
169356	2134	87048431000	22045	11024	10	0	3531
169358	2133	94348130000	22045	11024	12	0	3436
169359	2133	94347128000	22045	11024	13	0	3437
169360	1397	1308466981000	22046	11025	0	0	13036
169361	2133	94346126000	22046	11025	1	0	3438
169362	2134	87047428000	22046	11025	2	0	3532
169374	2132	148012013000	22052	11026	1	0	987
169375	2133	94345124000	22052	11026	2	0	3439
169376	2134	87046425000	22052	11026	3	0	3533
169377	1397	1308446979000	22053	11027	0	0	13038
169378	2133	94344122000	22053	11027	1	0	3440
169383	1397	1308436978000	22055	11028	0	0	13039
169384	2133	94343120000	22055	11028	1	0	3441
169385	2134	87044419000	22055	11028	2	0	3535
169386	1397	1308426977000	22057	11029	0	0	13040
169388	2132	148011012000	22057	11029	2	0	988
169389	2134	87043416000	22057	11029	3	0	3536
169393	1397	1308416976000	22059	11030	0	0	13041
169394	2133	94341116000	22059	11030	1	0	3443
169395	2134	87042413000	22059	11030	2	0	3537
169400	1397	1308396974000	22061	11031	1	0	13043
169401	1397	1308386973000	22061	11031	2	0	13044
169402	2132	148010011000	22061	11031	3	0	989
169403	2133	94340114000	22061	11031	4	0	3444
169404	2133	94339112000	22061	11031	5	0	3445
169406	2134	87041410000	22061	11031	7	0	3538
169407	2134	87040407000	22061	11031	8	0	3539
169408	2134	87039404000	22061	11031	9	0	3540
169412	1397	1308376972000	22063	11032	0	0	13045
169414	2133	94337108000	22063	11032	2	0	3447
169418	1397	1308366971000	22065	11033	0	0	13046
169419	2133	94336106000	22065	11033	1	0	3448
169420	2134	87037398000	22065	11033	2	0	3542
169421	1397	1308356970000	22066	11034	0	0	13047
169423	2133	94335104000	22066	11034	2	0	3449
169424	2132	148009010000	22066	11034	3	0	990
169428	1397	1308346969000	22068	11035	0	0	13048
169429	1397	1308336968000	22068	11035	1	0	13049
169430	2134	87035392000	22068	11035	2	0	3544
169432	2133	94334102000	22068	11035	4	0	3450
169433	2133	94333100000	22068	11035	5	0	3451
169440	1397	1308326967000	22070	11036	0	0	13050
169441	2133	94332098000	22070	11036	1	0	3452
169443	2132	148008009000	22070	11036	3	0	991
169457	1654	11337351999798	22072	11037	2	0	\N
169458	1654	8359341999798	22072	11037	3	0	\N
169459	2134	87032383000	22072	11037	4	0	\N
169460	2133	94331096000	22072	11037	5	0	\N
169461	1654	15750361999798	22073	11037	0	0	\N
169462	1397	1308316966000	22073	11037	1	0	\N
169463	1654	11337351999798	22073	11037	2	0	\N
169464	1654	8359341999798	22073	11037	3	0	\N
169465	2134	87032383000	22073	11037	4	0	\N
169466	2133	94331096000	22073	11037	5	0	\N
169467	1654	15750361999798	22074	11037	0	0	\N
169468	1397	1308316966000	22074	11037	1	0	\N
169469	1654	11337351999798	22074	11037	2	0	\N
169470	1654	8359341999798	22074	11037	3	0	\N
169471	2134	87032383000	22074	11037	4	0	\N
169472	2133	94331096000	22074	11037	5	0	\N
169473	1654	15750361999798	22075	11037	0	0	\N
169474	1397	1308316966000	22075	11037	1	0	\N
169475	1654	11337351999798	22075	11037	2	0	\N
169476	1654	8359341999798	22075	11037	3	0	\N
169477	2134	87032383000	22075	11037	4	0	\N
169478	2133	94331096000	22075	11037	5	0	\N
169491	1397	1308286963000	22078	11039	0	0	\N
169492	2133	94328090000	22078	11039	1	0	\N
169493	2134	87030377000	22078	11039	2	0	\N
169503	1654	15750361999798	22082	11027	0	0	\N
169504	1397	1308446979000	22082	11027	1	0	\N
169505	1397	1308436978000	22082	11027	2	0	\N
169506	1397	1308426977000	22082	11027	3	0	\N
169507	1397	1308416976000	22082	11027	4	0	\N
169508	1397	1308406975000	22082	11027	5	0	\N
169509	1397	1308396974000	22082	11027	6	0	\N
169510	1654	11337351999798	22082	11027	7	0	\N
169511	1654	8359341999798	22082	11027	8	0	\N
169512	1654	5897331999798	22082	11027	9	0	\N
169513	1397	1308386973000	22082	11027	10	0	\N
169514	1397	1308376972000	22082	11027	11	0	\N
169515	1397	1308366971000	22082	11027	12	0	\N
169516	1397	1308356970000	22082	11027	13	0	\N
169517	1397	1308346969000	22082	11027	14	0	\N
169518	1397	1308336968000	22082	11027	15	0	\N
169519	1397	1308326967000	22082	11027	16	0	\N
169520	1397	1308316966000	22082	11027	17	0	\N
169521	1397	1308306965000	22082	11027	18	0	\N
169522	1397	1308296964000	22082	11027	19	0	\N
169523	1397	1308286963000	22082	11027	20	0	\N
169524	1397	1308276962000	22082	11027	21	0	\N
169525	1397	1308266961000	22082	11027	22	0	\N
169526	1397	1308256960000	22082	11027	23	0	\N
169527	2133	94344122000	22082	11027	24	0	\N
169528	2133	94343120000	22082	11027	25	0	\N
169529	2134	87045422000	22082	11027	26	0	\N
169530	2134	87044419000	22082	11027	27	0	\N
169531	2133	94342118000	22082	11027	28	0	\N
169532	2132	148011012000	22082	11027	29	0	\N
169533	2132	148010011000	22082	11027	30	0	\N
169534	2132	148009010000	22082	11027	31	0	\N
169535	2133	94341116000	22082	11027	32	0	\N
169536	2133	94340114000	22082	11027	33	0	\N
169537	2133	94339112000	22082	11027	34	0	\N
169538	2133	94338110000	22082	11027	35	0	\N
169539	2133	94337108000	22082	11027	36	0	\N
169540	2133	94336106000	22082	11027	37	0	\N
169541	2133	94335104000	22082	11027	38	0	\N
169542	2132	148008009000	22082	11027	39	0	\N
169543	2132	148007008000	22082	11027	40	0	\N
169544	2132	148006007000	22082	11027	41	0	\N
169545	2134	87043416000	22082	11027	42	0	\N
169546	2133	94334102000	22082	11027	43	0	\N
169547	2133	94333100000	22082	11027	44	0	\N
169548	2133	94332098000	22082	11027	45	0	\N
169549	2133	94331096000	22082	11027	46	0	\N
169550	2133	94330094000	22082	11027	47	0	\N
169551	2133	94329092000	22082	11027	48	0	\N
169552	2133	94328090000	22082	11027	49	0	\N
169553	2133	94327088000	22082	11027	50	0	\N
169554	2133	94326086000	22082	11027	51	0	\N
169555	2133	94325084000	22082	11027	52	0	\N
169556	2134	87042413000	22082	11027	53	0	\N
169557	2134	87041410000	22082	11027	54	0	\N
169558	2134	87040407000	22082	11027	55	0	\N
169559	2134	87039404000	22082	11027	56	0	\N
169560	2134	87038401000	22082	11027	57	0	\N
169561	2134	87037398000	22082	11027	58	0	\N
169562	2134	87036395000	22082	11027	59	0	\N
169563	2134	87035392000	22082	11027	60	0	\N
169564	2134	87034389000	22082	11027	61	0	\N
169565	2134	87033386000	22082	11027	62	0	\N
169566	2134	87032383000	22082	11027	63	0	\N
169567	2134	87031380000	22082	11027	64	0	\N
169568	2134	87030377000	22082	11027	65	0	\N
169569	2134	87029374000	22082	11027	66	0	\N
169570	2134	87028371000	22082	11027	67	0	\N
169571	2134	87027368000	22082	11027	68	0	\N
169572	1397	1308256960000	22083	11042	0	0	\N
169573	1397	1308246959000	22083	11042	1	0	\N
169574	2134	87027368000	22083	11042	2	0	\N
169575	2134	87026365000	22083	11042	3	0	\N
169576	2132	148006007000	22083	11042	4	0	\N
169577	1397	1308256960000	22084	11042	0	0	\N
169578	1397	1308246959000	22084	11042	1	0	\N
169579	2133	94325084000	22084	11042	2	0	\N
169580	2134	87027368000	22084	11042	3	0	\N
169581	2134	87026365000	22084	11042	4	0	\N
169582	2133	94324082000	22084	11042	5	0	\N
169583	2132	148006007000	22084	11042	6	0	\N
169584	1397	1308256960000	22085	11042	0	0	\N
169585	1397	1308246959000	22085	11042	1	0	\N
169586	2133	94325084000	22085	11042	2	0	\N
169587	2134	87027368000	22085	11042	3	0	\N
169588	2134	87026365000	22085	11042	4	0	\N
169589	2133	94324082000	22085	11042	5	0	\N
169590	2132	148006007000	22085	11042	6	0	\N
169591	1397	1308246959000	22086	11028	0	0	\N
169592	2134	87026365000	22086	11028	1	0	\N
169481	1654	11337351999798	22076	11037	2	0	9
169482	1654	8359341999798	22076	11037	3	0	10
169483	2134	87032383000	22076	11037	4	0	3547
169484	2133	94331096000	22076	11037	5	0	3453
169485	1397	1308306965000	22077	11038	0	0	13052
169487	2134	87031380000	22077	11038	2	0	3548
169488	2132	148007008000	22077	11038	3	0	992
169489	2133	94330094000	22077	11038	4	0	3454
169490	2133	94329092000	22077	11038	5	0	3455
169494	2133	94328090000	22079	11039	0	0	3456
169496	1397	1308286963000	22080	11040	0	0	13054
169497	1397	1308276962000	22080	11040	1	0	13055
169498	2133	94327088000	22080	11040	2	0	3457
169499	2134	87029374000	22080	11040	3	0	3550
169501	2133	94326086000	22081	11041	1	0	3458
169502	2134	87028371000	22081	11041	2	0	3551
169593	2133	94324082000	22086	11028	2	0	\N
169604	1397	1308236958000	22089	11043	0	0	\N
169605	2133	94323080000	22089	11043	1	0	\N
169606	2134	87025362000	22089	11043	2	0	\N
169607	1397	1308226957000	22090	11044	0	0	\N
169608	2132	148005006000	22090	11044	1	0	\N
169628	1397	1308186953000	22094	11046	0	0	\N
169629	2133	94317068000	22094	11046	1	0	\N
169630	2134	87019344000	22094	11046	2	0	\N
169641	1397	1308146949000	22098	11050	0	0	\N
169642	1397	1308136948000	22098	11050	1	0	\N
169643	2134	87015332000	22098	11050	2	0	\N
169644	2132	148002003000	22098	11050	3	0	\N
169645	2134	87014329000	22098	11050	4	0	\N
169646	2133	94313060000	22098	11050	5	0	\N
169647	2133	94312058000	22098	11050	6	0	\N
169655	1397	1308146949000	22100	11050	0	0	\N
169656	1397	1308136948000	22100	11050	1	0	\N
169657	2134	87015332000	22100	11050	2	0	\N
169658	2132	148002003000	22100	11050	3	0	\N
169659	2134	87014329000	22100	11050	4	0	\N
169660	2133	94313060000	22100	11050	5	0	\N
169661	2133	94312058000	22100	11050	6	0	\N
169685	1397	1308056940000	22105	11055	0	0	\N
169686	1723	15683622085979	22105	11055	1	0	\N
169687	2134	87006305000	22105	11055	2	0	\N
169688	2133	94304042000	22105	11055	3	0	\N
169701	1397	1308026937000	22108	11057	0	0	\N
169702	2133	94301036000	22108	11057	1	0	\N
169703	2134	87003296000	22108	11057	2	0	\N
169704	1397	1308026937000	22109	11057	0	0	\N
169705	2133	94301036000	22109	11057	1	0	\N
169706	2134	87003296000	22109	11057	2	0	\N
169715	604	66714579919853	22112	11029	0	0	\N
169716	1397	1308236958000	22112	11029	1	0	\N
169717	1397	1308226957000	22112	11029	2	0	\N
169718	1397	1308216956000	22112	11029	3	0	\N
169719	1397	1308206955000	22112	11029	4	0	\N
169720	1397	1308196954000	22112	11029	5	0	\N
169721	1397	1308186953000	22112	11029	6	0	\N
169722	1397	1308176952000	22112	11029	7	0	\N
169723	1397	1308166951000	22112	11029	8	0	\N
169724	1397	1308156950000	22112	11029	9	0	\N
169725	1397	1308146949000	22112	11029	10	0	\N
169726	1397	1308136948000	22112	11029	11	0	\N
169727	1723	15683622085979	22112	11029	12	0	\N
169728	1723	11196612085979	22112	11029	13	0	\N
169596	2133	94325084000	22087	11042	2	0	3459
169597	2134	87027368000	22087	11042	3	0	3552
169598	2134	87026365000	22087	11042	4	0	3553
169599	2133	94324082000	22087	11042	5	0	3460
169600	2132	148006007000	22087	11042	6	0	993
169602	2133	94323080000	22088	11043	1	0	3461
169603	2134	87025362000	22088	11043	2	0	3554
169609	2133	94322078000	22091	11044	0	0	3462
169610	2134	87024359000	22091	11044	1	0	3555
169611	1397	1308226957000	22092	11045	0	0	13060
169613	1397	1308206955000	22092	11045	2	0	13062
169614	1397	1308196954000	22092	11045	3	0	13063
169615	2134	87023356000	22092	11045	4	0	3556
169616	2134	87022353000	22092	11045	5	0	3557
169618	2134	87020347000	22092	11045	7	0	3559
169619	2133	94321076000	22092	11045	8	0	3463
169620	2133	94320074000	22092	11045	10	0	3464
169621	2133	94319072000	22092	11045	11	0	3465
169622	2133	94318070000	22092	11045	12	0	3466
169624	2132	148004005000	22092	11045	14	0	995
169625	1397	1308186953000	22093	11046	0	0	13064
169626	2133	94317068000	22093	11046	1	0	3467
169627	2134	87019344000	22093	11046	2	0	3560
169631	1397	1308176952000	22095	11047	0	0	13065
169633	2134	87018341000	22095	11047	2	0	3561
169634	1397	1308166951000	22096	11048	0	0	13066
169635	2133	94315064000	22096	11048	1	0	3469
169636	2134	87017338000	22096	11048	2	0	3562
169638	1397	1308156950000	22097	11049	0	0	13067
169639	2134	87016335000	22097	11049	1	0	3563
169640	2133	94314062000	22097	11049	2	0	3470
169648	1397	1308146949000	22099	11050	0	0	13068
169649	1397	1308136948000	22099	11050	1	0	13069
169651	2132	148002003000	22099	11050	3	0	997
169652	2134	87014329000	22099	11050	4	0	3565
169653	2133	94313060000	22099	11050	5	0	3471
169654	2133	94312058000	22099	11050	6	0	3472
169662	1397	1308126947000	22101	11051	0	0	13070
169664	2134	87013326000	22101	11051	2	0	3566
169665	1397	1308116946000	22102	11052	0	0	13071
169666	2133	94310054000	22102	11052	1	0	3474
169667	2134	87012323000	22102	11052	2	0	3567
169669	1397	1308096944000	22103	11053	1	0	13073
169670	1397	1308086943000	22103	11053	2	0	13074
169671	2134	87011320000	22103	11053	3	0	3568
169672	2132	148001002000	22103	11053	4	0	998
169673	2134	87010317000	22103	11053	5	0	3569
169675	2133	94309052000	22103	11053	7	0	3475
169676	2133	94308050000	22103	11053	8	0	3476
169677	2133	94307048000	22103	11053	9	0	3477
169678	1397	1308076942000	22104	11054	0	0	13075
169679	1397	1308066941000	22104	11054	1	0	13076
169681	2133	94305044000	22104	11054	3	0	3479
169682	2132	148000001000	22104	11054	4	0	999
169683	2134	87008311000	22104	11054	5	0	3571
169684	2134	87007308000	22104	11054	6	0	3572
169690	1723	15683622085979	22106	11055	1	0	7
169691	2134	87006305000	22106	11055	2	0	3573
169692	2133	94304042000	22106	11055	3	0	3480
169693	1397	1308046939000	22107	11056	0	0	13078
169694	1723	11196612085979	22107	11056	1	0	8
169696	2133	94303040000	22107	11056	3	0	3481
169697	2133	94302038000	22107	11056	4	0	3482
169698	2134	87005302000	22107	11056	5	0	3574
169699	2134	87004299000	22107	11056	6	0	3575
169700	2132	147999000000	22107	11056	7	0	1000
169708	2133	94301036000	22110	11057	1	0	3483
169709	2134	87003296000	22110	11057	2	0	3576
169710	604	66714579919853	22111	11058	0	0	1
169711	1723	8168602085979	22111	11058	1	0	9
169713	2134	87002293000	22111	11058	3	0	3577
169714	2133	94300034000	22111	11058	4	0	3484
169729	1723	8168602085979	22112	11029	14	0	\N
169730	1397	1308126947000	22112	11029	15	0	\N
169731	1397	1308116946000	22112	11029	16	0	\N
169732	1397	1308106945000	22112	11029	17	0	\N
169733	1397	1308096944000	22112	11029	18	0	\N
169734	1397	1308086943000	22112	11029	19	0	\N
169735	1397	1308076942000	22112	11029	20	0	\N
169736	1397	1308066941000	22112	11029	21	0	\N
169737	1397	1308056940000	22112	11029	22	0	\N
169738	1397	1308046939000	22112	11029	23	0	\N
169739	1397	1308036938000	22112	11029	24	0	\N
169740	1397	1308026937000	22112	11029	25	0	\N
169741	1397	1308016936000	22112	11029	26	0	\N
169742	2133	94323080000	22112	11029	27	0	\N
169743	2134	87025362000	22112	11029	28	0	\N
169744	2133	94322078000	22112	11029	29	0	\N
169745	2134	87024359000	22112	11029	30	0	\N
169746	2134	87023356000	22112	11029	31	0	\N
169747	2134	87022353000	22112	11029	32	0	\N
169748	2134	87021350000	22112	11029	33	0	\N
169749	2134	87020347000	22112	11029	34	0	\N
169750	2133	94321076000	22112	11029	35	0	\N
169751	2133	94320074000	22112	11029	36	0	\N
169752	2133	94319072000	22112	11029	37	0	\N
169753	2133	94318070000	22112	11029	38	0	\N
169754	2133	94317068000	22112	11029	39	0	\N
169755	2133	94316066000	22112	11029	40	0	\N
169756	2133	94315064000	22112	11029	41	0	\N
169757	2132	148005006000	22112	11029	42	0	\N
169758	2132	148004005000	22112	11029	43	0	\N
169759	2132	148003004000	22112	11029	44	0	\N
169760	2132	148002003000	22112	11029	46	0	\N
169761	2132	148001002000	22112	11029	47	0	\N
169762	2132	148000001000	22112	11029	48	0	\N
169763	2132	147999000000	22112	11029	49	0	\N
169764	2134	87019344000	22112	11029	50	0	\N
169765	2134	87018341000	22112	11029	51	0	\N
169766	2134	87017338000	22112	11029	52	0	\N
169767	2134	87016335000	22112	11029	53	0	\N
169768	2134	87015332000	22112	11029	54	0	\N
169769	2134	87014329000	22112	11029	55	0	\N
169770	2134	87013326000	22112	11029	56	0	\N
169771	2134	87012323000	22112	11029	57	0	\N
169772	2134	87011320000	22112	11029	58	0	\N
169773	2134	87010317000	22112	11029	59	0	\N
169777	1397	1308006935000	22114	11059	0	0	\N
169778	2133	94299032000	22114	11059	1	0	\N
169779	2134	87001290000	22114	11059	2	0	\N
169780	2132	147997999000	22114	11059	3	0	\N
169781	1397	1308006935000	22115	11059	0	0	\N
169782	2133	94299032000	22115	11059	1	0	\N
169783	2134	87001290000	22115	11059	2	0	\N
169784	2132	147997999000	22115	11059	3	0	\N
169800	1397	1307956930000	22118	11062	0	0	\N
169801	1723	5649582085979	22118	11062	1	0	\N
169802	1397	1307946929000	22118	11062	2	0	\N
169803	2133	94294022000	22118	11062	3	0	\N
169804	2134	86996275000	22118	11062	4	0	\N
169805	2134	86995272000	22118	11062	5	0	\N
169806	2133	94293020000	22118	11062	6	0	\N
169807	1397	1307956930000	22119	11062	0	0	\N
169808	1723	5649582085979	22119	11062	1	0	\N
169809	1397	1307946929000	22119	11062	2	0	\N
169810	2133	94294022000	22119	11062	3	0	\N
169811	2134	86996275000	22119	11062	4	0	\N
169812	2134	86995272000	22119	11062	5	0	\N
169813	2133	94293020000	22119	11062	6	0	\N
169829	1397	1307916926000	22123	11065	0	0	\N
169830	2134	86992263000	22123	11065	1	0	\N
169831	2133	94290014000	22123	11065	2	0	\N
169835	1397	1307916926000	22125	11065	0	0	\N
169836	2134	86992263000	22125	11065	1	0	\N
169837	2133	94290014000	22125	11065	2	0	\N
169855	1397	1307856920000	22130	11070	0	0	\N
169856	1397	1307846919000	22130	11070	1	0	\N
169857	2134	86987248000	22130	11070	2	0	\N
169858	2134	86986245000	22130	11070	3	0	\N
169859	2133	94284002000	22130	11070	4	0	\N
169860	2133	94283000000	22130	11070	5	0	\N
169776	2132	147997999000	22113	11059	2	0	1001
169785	1723	5664592085979	22116	11060	0	0	10
169786	1397	1308006935000	22116	11060	1	0	13082
169787	1397	1307996934000	22116	11060	2	0	13083
169788	2134	87000287000	22116	11060	3	0	3579
169790	1397	1307986933000	22117	11061	0	0	13084
169791	1397	1307976932000	22117	11061	1	0	13085
169792	1397	1307966931000	22117	11061	2	0	13086
169793	2132	147996998000	22117	11061	3	0	1002
169794	2134	86999284000	22117	11061	4	0	3580
169796	2133	94296026000	22117	11061	6	0	3488
169797	2133	94295024000	22117	11061	7	0	3489
169798	2134	86998281000	22117	11061	8	0	3581
169799	2134	86997278000	22117	11061	9	0	3582
169815	1723	5649582085979	22120	11062	1	0	11
169816	1397	1307946929000	22120	11062	2	0	13088
169817	2133	94294022000	22120	11062	3	0	3490
169818	2134	86996275000	22120	11062	4	0	3583
169819	2134	86995272000	22120	11062	5	0	3584
169821	1397	1307936928000	22121	11063	0	0	13089
169822	1723	3601572085979	22121	11063	1	0	12
169823	2134	86994269000	22121	11063	2	0	3585
169824	2133	94292018000	22121	11063	3	0	3492
169825	2132	147995997000	22121	11063	4	0	1003
169827	2133	94291016000	22122	11064	1	0	3493
169828	2134	86993266000	22122	11064	2	0	3586
169832	1397	1307916926000	22124	11065	0	0	13091
169833	2134	86992263000	22124	11065	1	0	3587
169838	1397	1307906925000	22126	11066	0	0	13092
169839	2133	94289012000	22126	11066	1	0	3495
169840	2132	147994996000	22126	11066	2	0	1004
169841	2134	86991260000	22126	11066	3	0	3588
169842	1397	1307896924000	22127	11067	0	0	13093
169844	2133	94288010000	22127	11067	2	0	3496
169845	1397	1307886923000	22128	11068	0	0	13094
169846	257	66000000000000	22128	11068	1	0	1
169847	2133	94287008000	22128	11068	2	0	3497
169848	1397	1307876922000	22129	11069	0	0	13095
169850	2132	147993995000	22129	11069	2	0	1005
169851	2134	86989254000	22129	11069	3	0	3590
169852	2134	86988251000	22129	11069	4	0	3591
169853	2133	94286006000	22129	11069	5	0	3498
169861	1397	1307856920000	22131	11070	0	0	13097
169862	1397	1307846919000	22131	11070	1	0	13098
169863	2134	86987248000	22131	11070	2	0	3592
169864	2134	86986245000	22131	11070	3	0	3593
169867	1397	1307856920000	22132	11070	0	0	\N
169868	1397	1307846919000	22132	11070	1	0	\N
169869	2134	86987248000	22132	11070	2	0	\N
169870	2134	86986245000	22132	11070	3	0	\N
169871	2133	94284002000	22132	11070	4	0	\N
169872	2133	94283000000	22132	11070	5	0	\N
169877	1397	1307836918000	22135	11071	0	0	\N
169878	2133	94281998000	22135	11071	1	0	\N
169879	2134	86985242000	22135	11071	2	0	\N
169880	2132	147992994000	22135	11071	3	0	\N
169881	1397	1307836918000	22136	11071	0	0	\N
169882	2133	94281998000	22136	11071	1	0	\N
169883	2134	86985242000	22136	11071	2	0	\N
169884	2132	147992994000	22136	11071	3	0	\N
169904	1397	1307766911000	22140	11075	0	0	\N
169905	1397	1307756910000	22140	11075	1	0	\N
169906	1397	1307746909000	22140	11075	2	0	\N
169907	2132	147990992000	22140	11075	3	0	\N
169908	1885	9000000	22140	11075	4	0	\N
169909	2133	94274984000	22140	11075	5	0	\N
169910	2133	94273982000	22140	11075	6	0	\N
169911	2133	94272980000	22140	11075	7	0	\N
169912	2134	86978221000	22140	11075	8	0	\N
169913	2134	86977218000	22140	11075	9	0	\N
169914	2134	86976215000	22140	11075	10	0	\N
169915	1397	1307766911000	22141	11075	0	0	\N
169916	1397	1307756910000	22141	11075	1	0	\N
169917	1397	1307746909000	22141	11075	2	0	\N
169918	2132	147990992000	22141	11075	3	0	\N
169919	1885	9000000	22141	11075	4	0	\N
169920	2133	94274984000	22141	11075	5	0	\N
169921	2133	94273982000	22141	11075	6	0	\N
169922	2133	94272980000	22141	11075	7	0	\N
169923	2134	86978221000	22141	11075	8	0	\N
169924	2134	86977218000	22141	11075	9	0	\N
169925	2134	86976215000	22141	11075	10	0	\N
169930	1397	1307756910000	22143	11076	0	0	\N
169931	1397	1307746909000	22143	11076	1	0	\N
169932	1885	9000000	22143	11076	2	0	\N
169933	2134	86977218000	22143	11076	3	0	\N
169934	2134	86976215000	22143	11076	4	0	\N
169935	2133	94273982000	22143	11076	5	0	\N
169936	2133	94272980000	22143	11076	6	0	\N
169944	1397	1307756910000	22145	11076	0	0	\N
169945	1397	1307746909000	22145	11076	1	0	\N
169946	1885	9000000	22145	11076	2	0	\N
169947	2134	86977218000	22145	11076	3	0	\N
169948	2134	86976215000	22145	11076	4	0	\N
169949	2133	94273982000	22145	11076	5	0	\N
169950	2133	94272980000	22145	11076	6	0	\N
169971	1397	1307676902000	22152	11083	0	0	\N
169972	1397	1307666901000	22152	11083	1	0	\N
169973	1397	1307656900000	22152	11083	2	0	\N
169974	2134	86969194000	22152	11083	3	0	\N
169975	2132	147987989000	22152	11083	4	0	\N
169976	2133	94265966000	22152	11083	5	0	\N
169977	2133	94264964000	22152	11083	6	0	\N
169978	2133	94263962000	22152	11083	7	0	\N
169979	2134	86968191000	22152	11083	8	0	\N
169980	2134	86967188000	22152	11083	9	0	\N
169991	1397	1307676902000	22154	11083	0	0	\N
169992	1397	1307666901000	22154	11083	1	0	\N
169993	1397	1307656900000	22154	11083	2	0	\N
169994	2134	86969194000	22154	11083	3	0	\N
169995	2132	147987989000	22154	11083	4	0	\N
169996	2133	94265966000	22154	11083	5	0	\N
169997	2133	94264964000	22154	11083	6	0	\N
169998	2133	94263962000	22154	11083	7	0	\N
169999	2134	86968191000	22154	11083	8	0	\N
170000	2134	86967188000	22154	11083	9	0	\N
169873	1397	1307836918000	22134	11071	0	0	13099
169874	2133	94281998000	22134	11071	1	0	3502
169875	2134	86985242000	22134	11071	2	0	3594
169876	2132	147992994000	22134	11071	3	0	1006
169885	1397	1307826917000	22137	11072	0	0	13100
169887	1397	1307806915000	22137	11072	2	0	13102
169888	2132	147991993000	22137	11072	3	0	1007
169889	2134	86984239000	22137	11072	4	0	3595
169890	2134	86983236000	22137	11072	5	0	3596
169891	2134	86982233000	22137	11072	6	0	3597
169893	2133	94279994000	22137	11072	8	0	3504
169894	2133	94278992000	22137	11072	9	0	3505
169895	1397	1307796914000	22138	11073	0	0	13103
169896	1397	1307786913000	22138	11073	1	0	13104
169898	2133	94277990000	22138	11073	3	0	3506
169899	2133	94276988000	22138	11073	4	0	3507
169900	2134	86980227000	22138	11073	5	0	3599
169901	1397	1307776912000	22139	11074	0	0	13105
169902	2133	94275986000	22139	11074	1	0	3508
169926	1397	1307766911000	22142	11075	0	0	13106
169927	2132	147990992000	22142	11075	1	0	1008
169928	2133	94274984000	22142	11075	2	0	3509
169929	2134	86978221000	22142	11075	3	0	3601
169937	1397	1307756910000	22144	11076	0	0	13107
169939	1885	9000000	22144	11076	2	0	3
169940	2134	86977218000	22144	11076	3	0	3602
169941	2134	86976215000	22144	11076	4	0	3603
169942	2133	94273982000	22144	11076	5	0	3510
169951	1397	1307736908000	22146	11077	0	0	13109
169952	2133	94271978000	22146	11077	1	0	3512
169953	2132	147989991000	22146	11077	2	0	1009
169954	2134	86975212000	22146	11077	3	0	3604
169955	1397	1307726907000	22147	11078	0	0	13110
169957	2133	94270976000	22147	11078	2	0	3513
169958	1397	1307716906000	22148	11079	0	0	13111
169959	1397	1307706905000	22148	11079	1	0	13112
169960	2132	147988990000	22148	11079	2	0	1010
169961	2134	86973206000	22148	11079	3	0	3606
169963	2133	94269974000	22148	11079	5	0	3514
169964	2133	94268972000	22148	11079	6	0	3515
169965	1397	1307696904000	22149	11080	0	0	13113
169966	2134	86971200000	22149	11080	1	0	3608
169968	1397	1307686903000	22150	11081	0	0	13114
169969	2134	86970197000	22150	11081	1	0	3609
169970	2133	94266968000	22150	11081	2	0	3517
169981	1397	1307676902000	22153	11083	0	0	13115
169982	1397	1307666901000	22153	11083	1	0	13116
169984	2134	86969194000	22153	11083	3	0	3610
169985	2132	147987989000	22153	11083	4	0	1011
169986	2133	94265966000	22153	11083	5	0	3518
169987	2133	94264964000	22153	11083	6	0	3519
169988	2133	94263962000	22153	11083	7	0	3520
169990	2134	86967188000	22153	11083	9	0	3612
170001	1397	1307676902000	22155	11083	0	0	\N
170002	1397	1307666901000	22155	11083	1	0	\N
170003	1397	1307656900000	22155	11083	2	0	\N
170004	2134	86969194000	22155	11083	3	0	\N
170005	2132	147987989000	22155	11083	4	0	\N
170006	2133	94265966000	22155	11083	5	0	\N
170007	2133	94264964000	22155	11083	6	0	\N
170008	2133	94263962000	22155	11083	7	0	\N
170009	2134	86968191000	22155	11083	8	0	\N
170010	2134	86967188000	22155	11083	9	0	\N
170011	1397	1307676902000	22157	11083	0	0	\N
170012	1397	1307666901000	22157	11083	1	0	\N
170013	1397	1307656900000	22157	11083	2	0	\N
170014	2134	86969194000	22157	11083	3	0	\N
170015	2132	147987989000	22157	11083	4	0	\N
170016	2133	94265966000	22157	11083	5	0	\N
170017	2133	94264964000	22157	11083	6	0	\N
170018	2133	94263962000	22157	11083	7	0	\N
170019	2134	86968191000	22157	11083	8	0	\N
170020	2134	86967188000	22157	11083	9	0	\N
170028	1397	1307636898000	22160	11085	0	0	\N
170029	2134	86966185000	22160	11085	1	0	\N
170030	2132	147986988000	22160	11085	2	0	\N
170031	2133	94261958000	22160	11085	3	0	\N
170032	1635	11000000	22160	11085	4	0	\N
170036	1397	1307626897000	22162	11086	0	0	\N
170037	2133	94260956000	22162	11086	1	0	\N
170038	2134	86965182000	22162	11086	2	0	\N
170039	1397	1307646899000	22163	11084	0	0	\N
170040	1397	1307636898000	22163	11084	1	0	\N
170041	1397	1307626897000	22163	11084	2	0	\N
170042	1397	1307616896000	22163	11084	3	0	\N
170043	2134	86966185000	22163	11084	4	0	\N
170044	2133	94262960000	22163	11084	5	0	\N
170045	2132	147986988000	22163	11084	6	0	\N
170046	2133	94261958000	22163	11084	7	0	\N
170047	2133	94260956000	22163	11084	8	0	\N
170048	2133	94259954000	22163	11084	9	0	\N
170049	1635	11000000	22163	11084	10	0	\N
170050	2134	86965182000	22163	11084	11	0	\N
170051	2134	86964179000	22163	11084	12	0	\N
170052	1397	1307616896000	22164	11087	0	0	\N
170053	2133	94259954000	22164	11087	1	0	\N
170054	2134	86964179000	22164	11087	2	0	\N
170063	1696	27043433305104	22167	11088	0	0	\N
170064	1397	1307606895000	22167	11088	1	0	\N
170065	2134	86963176000	22167	11088	2	0	\N
170066	2133	94258952000	22167	11088	3	0	\N
170067	2132	147985987000	22167	11088	4	0	\N
170068	1696	27043433305104	22168	11088	0	0	\N
170069	1397	1307606895000	22168	11088	1	0	\N
170070	2134	86963176000	22168	11088	2	0	\N
170071	2133	94258952000	22168	11088	3	0	\N
170072	2132	147985987000	22168	11088	4	0	\N
170104	1397	1307546889000	22175	11094	0	0	\N
170105	1397	1307536888000	22175	11094	1	0	\N
170106	2134	86957158000	22175	11094	2	0	\N
170107	2134	86956155000	22175	11094	3	0	\N
170108	2132	147983985000	22175	11094	4	0	\N
170109	2133	94253942000	22175	11094	5	0	\N
170110	2133	94252940000	22175	11094	6	0	\N
170121	1397	1307496884000	22178	11097	0	0	\N
170122	1397	1307486883000	22178	11097	1	0	\N
170123	2133	94248932000	22178	11097	2	0	\N
170124	2133	94247930000	22178	11097	3	0	\N
170125	2134	86952143000	22178	11097	4	0	\N
170126	2134	86951140000	22178	11097	5	0	\N
170023	1397	1307636898000	22159	11085	0	0	13119
170024	2134	86966185000	22159	11085	1	0	3613
170025	2132	147986988000	22159	11085	2	0	1012
170026	2133	94261958000	22159	11085	3	0	3522
170027	1635	11000000	22159	11085	4	0	1
170034	2133	94260956000	22161	11086	1	0	3523
170035	2134	86965182000	22161	11086	2	0	3614
170055	1397	1307616896000	22165	11087	0	0	13121
170056	2133	94259954000	22165	11087	1	0	3524
170057	2134	86964179000	22165	11087	2	0	3615
170059	1397	1307606895000	22166	11088	1	0	13122
170060	2134	86963176000	22166	11088	2	0	3616
170061	2133	94258952000	22166	11088	3	0	3525
170062	2132	147985987000	22166	11088	4	0	1013
170074	1696	20278350325104	22169	11089	1	0	8
170075	1397	1307596894000	22169	11089	2	0	13123
170076	2294	718999000000	22169	11089	3	0	1
170077	2134	86962173000	22169	11089	4	0	3617
170078	2133	94257950000	22169	11089	5	0	3526
170080	1509	22243913540403	22170	11090	1	0	6
170081	1509	18322338101171	22170	11090	2	0	7
170082	1509	15676340481403	22170	11090	3	0	8
170083	1509	8303211503835	22170	11090	4	0	9
170084	1397	1307586893000	22170	11090	5	0	13124
170086	2134	86961170000	22170	11090	7	0	3618
170087	1397	1307576892000	22171	11091	0	0	13125
170088	2133	94256948000	22171	11091	1	0	3527
170089	2134	86960167000	22171	11091	2	0	3619
170091	2133	94255946000	22172	11092	1	0	3528
170092	2134	86959164000	22172	11092	2	0	3620
170093	2132	147984986000	22172	11092	3	0	1014
170094	1397	1307556890000	22173	11093	0	0	13127
170095	2133	94254944000	22173	11093	1	0	3529
170097	1397	1307546889000	22174	11094	0	0	13128
170098	1397	1307536888000	22174	11094	1	0	13129
170099	2134	86957158000	22174	11094	2	0	3622
170100	2134	86956155000	22174	11094	3	0	3623
170101	2132	147983985000	22174	11094	4	0	1015
170103	2133	94252940000	22174	11094	6	0	3531
170111	1397	1307526887000	22176	11095	0	0	13130
170112	2134	86955152000	22176	11095	1	0	3624
170113	2133	94251938000	22176	11095	2	0	3532
170115	1397	1307506885000	22177	11096	1	0	13132
170116	2134	86954149000	22177	11096	2	0	3625
170117	2133	94250936000	22177	11096	3	0	3533
170118	2134	86953146000	22177	11096	4	0	3626
170119	2132	147982984000	22177	11096	5	0	1016
170127	1397	1307496884000	22179	11097	0	0	13133
170128	1397	1307486883000	22179	11097	1	0	13134
170129	2133	94248932000	22179	11097	2	0	3535
170130	2133	94247930000	22179	11097	3	0	3536
170131	2134	86952143000	22179	11097	4	0	3627
170133	1397	1307476882000	22180	11098	0	0	13135
170134	2134	86950137000	22180	11098	1	0	3629
170135	2133	94246928000	22180	11098	2	0	3537
170136	1397	1307466881000	22181	11099	0	0	13136
170146	1397	1307456880000	22183	11100	0	0	\N
170147	1397	1307446879000	22183	11100	1	0	\N
170148	2134	86948131000	22183	11100	2	0	\N
170149	2133	94244924000	22183	11100	3	0	\N
170150	2134	86947128000	22183	11100	4	0	\N
170151	2133	94243922000	22183	11100	5	0	\N
170152	1696	25603417305104	22184	11005	0	0	\N
170153	1696	21563925195104	22184	11005	1	0	\N
170154	1696	18838334325104	22184	11005	2	0	\N
170155	1696	11243590335104	22184	11005	3	0	\N
170156	604	66714579919853	22184	11005	4	0	\N
170157	1509	20803854540403	22184	11005	5	0	\N
170158	1509	16882279101171	22184	11005	7	0	\N
170159	1509	14236281481403	22184	11005	8	0	\N
170160	1509	6863152503835	22184	11005	9	0	\N
170161	1654	15030284999798	22184	11005	10	0	\N
170162	257	66000000000000	22184	11005	11	0	\N
170163	1724	15296685500000	22184	11005	12	0	\N
170164	1724	11211675500000	22184	11005	13	0	\N
170165	1724	8454665500000	22184	11005	14	0	\N
170166	1397	1308737008000	22184	11005	15	0	\N
170167	1723	15683622085979	22184	11005	16	0	\N
170168	1723	11196612085979	22184	11005	17	0	\N
170169	1723	8168602085979	22184	11005	18	0	\N
170170	1723	5664592085979	22184	11005	19	0	\N
170171	1723	5649582085979	22184	11005	20	0	\N
170172	1723	3601572085979	22184	11005	21	0	\N
170173	1397	1308727007000	22184	11005	22	0	\N
170174	1397	1308717006000	22184	11005	23	0	\N
170175	1397	1308707005000	22184	11005	24	0	\N
170176	1397	1308697004000	22184	11005	25	0	\N
170177	1397	1308687003000	22184	11005	26	0	\N
170178	1397	1308677002000	22184	11005	27	0	\N
170179	1397	1308667001000	22184	11005	28	0	\N
170180	1397	1308657000000	22184	11005	29	0	\N
170181	1397	1308646999000	22184	11005	30	0	\N
170182	1397	1308636998000	22184	11005	31	0	\N
170183	1654	10617274999798	22184	11005	32	0	\N
170184	1654	7639264999798	22184	11005	33	0	\N
170185	1654	5177254999798	22184	11005	34	0	\N
170186	1724	6174655500000	22184	11005	35	0	\N
170187	1397	1308626997000	22184	11005	36	0	\N
170188	1397	1308616996000	22184	11005	37	0	\N
170189	1397	1308606995000	22184	11005	38	0	\N
170190	1397	1308596994000	22184	11005	39	0	\N
170191	1397	1308586993000	22184	11005	40	0	\N
170192	1397	1308576992000	22184	11005	41	0	\N
170193	1397	1308566991000	22184	11005	42	0	\N
170194	1397	1308556990000	22184	11005	43	0	\N
170195	1397	1308546989000	22184	11005	44	0	\N
170196	1397	1308536988000	22184	11005	45	0	\N
170197	1397	1308526987000	22184	11005	46	0	\N
170198	1397	1308516986000	22184	11005	47	0	\N
170199	1397	1308506985000	22184	11005	48	0	\N
170200	1397	1308496984000	22184	11005	49	0	\N
170201	1397	1308486983000	22184	11005	50	0	\N
170202	1397	1308476982000	22184	11005	51	0	\N
170203	1397	1308466981000	22184	11005	52	0	\N
170204	1397	1308456980000	22184	11005	53	0	\N
170205	1397	1308446979000	22184	11005	54	0	\N
170206	1397	1308436978000	22184	11005	55	0	\N
170207	1397	1308426977000	22184	11005	56	0	\N
170208	1397	1308416976000	22184	11005	57	0	\N
170209	1397	1308406975000	22184	11005	58	0	\N
170210	1397	1308396974000	22184	11005	59	0	\N
170211	1397	1308386973000	22184	11005	60	0	\N
170212	1397	1308376972000	22184	11005	61	0	\N
170213	1397	1308366971000	22184	11005	62	0	\N
170214	1397	1308356970000	22184	11005	63	0	\N
170215	1397	1308346969000	22184	11005	64	0	\N
170216	1397	1308336968000	22184	11005	65	0	\N
170217	1397	1308326967000	22184	11005	66	0	\N
170218	1397	1308316966000	22184	11005	67	0	\N
170219	1397	1308306965000	22184	11005	68	0	\N
170220	1397	1308296964000	22184	11005	69	0	\N
170221	1397	1308286963000	22184	11005	70	0	\N
170222	1397	1308276962000	22184	11005	71	0	\N
170223	1397	1308266961000	22184	11005	72	0	\N
170224	1397	1308256960000	22184	11005	73	0	\N
170225	1397	1308246959000	22184	11005	74	0	\N
170226	1397	1308236958000	22184	11005	75	0	\N
170227	1397	1308226957000	22184	11005	76	0	\N
170228	1397	1308216956000	22184	11005	77	0	\N
170229	1397	1308206955000	22184	11005	78	0	\N
170230	1397	1308196954000	22184	11005	79	0	\N
170231	1397	1308186953000	22184	11005	80	0	\N
170232	1397	1308176952000	22184	11005	81	0	\N
170233	1397	1308166951000	22184	11005	82	0	\N
170234	1397	1308156950000	22184	11005	83	0	\N
170235	1397	1308146949000	22184	11005	84	0	\N
170236	1397	1308136948000	22184	11005	85	0	\N
170237	1397	1308126947000	22184	11005	86	0	\N
170238	1397	1308116946000	22184	11005	87	0	\N
170239	1397	1308106945000	22184	11005	88	0	\N
170240	1397	1308096944000	22184	11005	89	0	\N
170241	1397	1308086943000	22184	11005	90	0	\N
170242	1397	1308076942000	22184	11005	91	0	\N
170243	1397	1308066941000	22184	11005	92	0	\N
170244	1397	1308056940000	22184	11005	93	0	\N
170245	1397	1308046939000	22184	11005	94	0	\N
170246	1397	1308036938000	22184	11005	95	0	\N
170247	1397	1308026937000	22184	11005	96	0	\N
170248	1397	1308016936000	22184	11005	97	0	\N
170249	1397	1308006935000	22184	11005	98	0	\N
170250	1397	1307996934000	22184	11005	99	0	\N
170251	1397	1307986933000	22184	11005	100	0	\N
170252	1397	1307976932000	22184	11005	101	0	\N
170253	1397	1307966931000	22184	11005	102	0	\N
170254	1397	1307956930000	22184	11005	103	0	\N
170255	1397	1307946929000	22184	11005	104	0	\N
170256	1397	1307936928000	22184	11005	105	0	\N
170257	1397	1307926927000	22184	11005	106	0	\N
170258	1397	1307916926000	22184	11005	107	0	\N
170259	1397	1307906925000	22184	11005	108	0	\N
170260	1397	1307896924000	22184	11005	109	0	\N
170261	1397	1307886923000	22184	11005	110	0	\N
170262	1397	1307876922000	22184	11005	111	0	\N
170263	1397	1307866921000	22184	11005	112	0	\N
170264	1397	1307856920000	22184	11005	113	0	\N
170265	1397	1307846919000	22184	11005	114	0	\N
170266	1397	1307836918000	22184	11005	115	0	\N
170267	1397	1307826917000	22184	11005	116	0	\N
170268	1397	1307816916000	22184	11005	117	0	\N
170269	1397	1307806915000	22184	11005	118	0	\N
170270	1397	1307796914000	22184	11005	119	0	\N
170271	1397	1307786913000	22184	11005	120	0	\N
170272	1397	1307776912000	22184	11005	121	0	\N
170139	2132	147981983000	22181	11099	3	0	1017
170140	1397	1307456880000	22182	11100	0	0	13137
170141	1397	1307446879000	22182	11100	1	0	13138
170142	2134	86948131000	22182	11100	2	0	3631
170143	2133	94244924000	22182	11100	3	0	3539
170145	2133	94243922000	22182	11100	5	0	3540
170273	1397	1307766911000	22184	11005	122	0	\N
170274	1397	1307756910000	22184	11005	123	0	\N
170275	1397	1307746909000	22184	11005	124	0	\N
170276	1397	1307736908000	22184	11005	125	0	\N
170305	1397	1307366871000	22192	11107	0	0	\N
170306	2134	86939104000	22192	11107	1	0	\N
170307	2133	94235906000	22192	11107	2	0	\N
170308	2132	147978980000	22192	11107	3	0	\N
170320	1397	1307336868000	22195	11109	0	0	\N
170321	2133	94232900000	22195	11109	1	0	\N
170322	2134	86936095000	22195	11109	2	0	\N
170323	2132	147977979000	22195	11109	3	0	\N
170337	1397	1307726907000	22199	11006	0	0	\N
170338	1397	1307716906000	22199	11006	1	0	\N
170339	1397	1307706905000	22199	11006	2	0	\N
170340	1397	1307696904000	22199	11006	3	0	\N
170341	1397	1307686903000	22199	11006	4	0	\N
170342	1397	1307676902000	22199	11006	5	0	\N
170343	1397	1307666901000	22199	11006	7	0	\N
170344	1397	1307656900000	22199	11006	8	0	\N
170345	1397	1307646899000	22199	11006	9	0	\N
170346	1397	1307636898000	22199	11006	10	0	\N
170347	1397	1307626897000	22199	11006	11	0	\N
170348	1397	1307616896000	22199	11006	12	0	\N
170349	1397	1307606895000	22199	11006	13	0	\N
170350	1397	1307596894000	22199	11006	14	0	\N
170351	1397	1307586893000	22199	11006	15	0	\N
170352	1397	1307576892000	22199	11006	16	0	\N
170353	1397	1307566891000	22199	11006	17	0	\N
170354	1397	1307556890000	22199	11006	18	0	\N
170355	1397	1307546889000	22199	11006	19	0	\N
170356	1397	1307536888000	22199	11006	20	0	\N
170357	1397	1307526887000	22199	11006	21	0	\N
170358	1397	1307516886000	22199	11006	22	0	\N
170359	1397	1307506885000	22199	11006	23	0	\N
170360	1397	1307496884000	22199	11006	24	0	\N
170361	1397	1307486883000	22199	11006	25	0	\N
170362	1397	1307476882000	22199	11006	26	0	\N
170363	1397	1307466881000	22199	11006	27	0	\N
170364	1397	1307456880000	22199	11006	28	0	\N
170365	1397	1307446879000	22199	11006	29	0	\N
170366	1397	1307436878000	22199	11006	30	0	\N
170367	1397	1307426877000	22199	11006	31	0	\N
170368	1397	1307416876000	22199	11006	32	0	\N
170369	1397	1307406875000	22199	11006	33	0	\N
170370	1397	1307396874000	22199	11006	34	0	\N
170371	1397	1307386873000	22199	11006	35	0	\N
170372	1397	1307376872000	22199	11006	36	0	\N
170373	1397	1307366871000	22199	11006	37	0	\N
170374	1397	1307356870000	22199	11006	38	0	\N
170375	1397	1307346869000	22199	11006	39	0	\N
170376	1397	1307336868000	22199	11006	40	0	\N
170377	1397	1307326867000	22199	11006	41	0	\N
170378	1397	1307316866000	22199	11006	42	0	\N
170379	1397	1307306865000	22199	11006	43	0	\N
170380	1899	1995000000	22199	11006	44	0	\N
170381	1740	8370693000000	22199	11006	45	0	\N
170382	563	66000605000000	22199	11006	46	0	\N
170383	733	3439024000000	22199	11006	47	0	\N
170384	1885	9000000	22199	11006	48	0	\N
170385	2134	87073506000	22199	11006	49	0	\N
170386	2133	94373180000	22199	11006	50	0	\N
170387	2132	148017018000	22199	11006	51	0	\N
170388	2133	94372178000	22199	11006	52	0	\N
170389	2133	94371176000	22199	11006	53	0	\N
170390	2132	148016017000	22199	11006	54	0	\N
170391	2132	148015016000	22199	11006	55	0	\N
170392	2132	148014015000	22199	11006	56	0	\N
170393	2132	148013014000	22199	11006	57	0	\N
170394	2132	148012013000	22199	11006	58	0	\N
170395	2132	148011012000	22199	11006	59	0	\N
170396	2132	148010011000	22199	11006	60	0	\N
170397	2132	148009010000	22199	11006	61	0	\N
170398	733	2720025000000	22199	11006	62	0	\N
170399	733	2719775000000	22199	11006	63	0	\N
170400	2133	94370174000	22199	11006	64	0	\N
170401	2133	94369172000	22199	11006	65	0	\N
170402	2132	148008009000	22199	11006	66	0	\N
170403	2132	148007008000	22199	11006	67	0	\N
170404	1635	11000000	22199	11006	68	0	\N
170405	2132	148006007000	22199	11006	69	0	\N
170406	2132	148005006000	22199	11006	70	0	\N
170407	2132	148004005000	22199	11006	71	0	\N
170408	2134	87072503000	22199	11006	72	0	\N
170279	2132	147980982000	22185	11101	3	0	1018
170280	2134	86946125000	22185	11101	4	0	3633
170281	2134	86945122000	22185	11101	5	0	3634
170282	2133	94242920000	22185	11101	6	0	3541
170283	2133	94241918000	22185	11101	7	0	3542
170285	2133	94240916000	22186	11102	1	0	3543
170286	2134	86944119000	22186	11102	2	0	3635
170287	1397	1307406875000	22187	11103	0	0	13142
170288	733	3439024000000	22187	11103	1	0	1
170289	2132	147979981000	22187	11103	2	0	1019
170291	2133	94239914000	22187	11103	4	0	3544
170292	1397	1307396874000	22188	11104	0	0	13143
170293	2134	86942113000	22188	11104	1	0	3637
170294	2133	94238912000	22188	11104	2	0	3545
170296	2134	86941110000	22189	11105	1	0	3638
170297	2133	94237910000	22189	11105	2	0	3546
170298	1397	1307376872000	22190	11106	0	0	13145
170299	2134	86940107000	22190	11106	1	0	3639
170300	2133	94236908000	22190	11106	2	0	3547
170302	2134	86939104000	22191	11107	1	0	3640
170303	2133	94235906000	22191	11107	2	0	3548
170304	2132	147978980000	22191	11107	3	0	1020
170309	1397	1307356870000	22193	11108	0	0	13147
170310	1397	1307346869000	22193	11108	1	0	13148
170312	2133	94233902000	22193	11108	3	0	3550
170313	733	2720025000000	22193	11108	4	0	2
170314	2134	86938101000	22193	11108	5	0	3641
170315	2134	86937098000	22193	11108	6	0	3642
170317	2133	94232900000	22194	11109	1	0	3551
170318	2134	86936095000	22194	11109	2	0	3643
170319	2132	147977979000	22194	11109	3	0	1021
170324	733	2719775000000	22196	11110	0	0	3
170325	1397	1307326867000	22196	11110	1	0	13150
170327	1899	1995000000	22196	11110	3	0	3
170328	1740	9090705000000	22196	11110	4	0	14
170329	563	66000605000000	22196	11110	5	0	16
170330	2134	86935092000	22196	11110	6	0	3644
170331	2133	94231898000	22196	11110	7	0	3552
170333	2134	86934089000	22196	11110	9	0	3645
170334	2134	86933086000	22198	11111	0	0	3646
170335	2132	147976978000	22198	11111	1	0	1022
170336	2133	94229894000	22198	11111	2	0	3554
170409	2134	87071500000	22199	11006	73	0	\N
170410	2134	87070497000	22199	11006	74	0	\N
170411	2134	87069494000	22199	11006	75	0	\N
170412	2134	87068491000	22199	11006	76	0	\N
170413	2134	87067488000	22199	11006	77	0	\N
170414	2133	94368170000	22199	11006	78	0	\N
170415	2133	94367168000	22199	11006	79	0	\N
170416	2133	94366166000	22199	11006	80	0	\N
170417	2132	148003004000	22199	11006	81	0	\N
170418	2132	148002003000	22199	11006	82	0	\N
170419	2132	148001002000	22199	11006	83	0	\N
170420	2132	148000001000	22199	11006	84	0	\N
170421	2132	147999000000	22199	11006	85	0	\N
170422	2132	147997999000	22199	11006	86	0	\N
170423	2132	147996998000	22199	11006	87	0	\N
170424	2132	147995997000	22199	11006	88	0	\N
170425	2132	147994996000	22199	11006	89	0	\N
170426	2132	147993995000	22199	11006	90	0	\N
170427	2132	147992994000	22199	11006	91	0	\N
170428	2132	147991993000	22199	11006	92	0	\N
170429	2132	147990992000	22199	11006	93	0	\N
170430	2132	147989991000	22199	11006	94	0	\N
170431	2132	147988990000	22199	11006	95	0	\N
170432	2132	147987989000	22199	11006	96	0	\N
170433	2132	147986988000	22199	11006	97	0	\N
170434	2132	147985987000	22199	11006	98	0	\N
170435	2132	147984986000	22199	11006	99	0	\N
170436	2132	147983985000	22199	11006	100	0	\N
170437	2132	147982984000	22199	11006	101	0	\N
170438	2132	147981983000	22199	11006	102	0	\N
170439	2132	147980982000	22199	11006	103	0	\N
170440	2132	147979981000	22199	11006	104	0	\N
170441	2132	147978980000	22199	11006	105	0	\N
170442	2132	147977979000	22199	11006	106	0	\N
170443	2132	147976978000	22199	11006	107	0	\N
170444	2133	94365164000	22199	11006	108	0	\N
170445	2133	94364162000	22199	11006	109	0	\N
170446	2133	94363160000	22199	11006	110	0	\N
170447	2133	94362158000	22199	11006	111	0	\N
170448	2133	94361156000	22199	11006	112	0	\N
170449	2133	94360154000	22199	11006	113	0	\N
170450	2133	94359152000	22199	11006	114	0	\N
170451	2133	94358150000	22199	11006	115	0	\N
170452	2133	94357148000	22199	11006	116	0	\N
170453	2133	94356146000	22199	11006	117	0	\N
170454	2133	94355144000	22199	11006	118	0	\N
170455	2133	94354142000	22199	11006	119	0	\N
170456	2133	94353140000	22199	11006	120	0	\N
170457	2133	94352138000	22199	11006	121	0	\N
170458	2133	94351136000	22199	11006	122	0	\N
170459	2133	94350134000	22199	11006	123	0	\N
170460	2133	94349132000	22199	11006	124	0	\N
170461	2133	94348130000	22199	11006	125	0	\N
170468	1397	1307306865000	22201	11112	0	0	\N
170469	1397	1307296864000	22201	11112	1	0	\N
170470	2134	86932083000	22201	11112	2	0	\N
170471	2133	94228892000	22201	11112	3	0	\N
170472	2134	86931080000	22201	11112	4	0	\N
170473	2133	94227890000	22201	11112	5	0	\N
170481	1397	1307276862000	22204	11114	0	0	\N
170482	2133	94225886000	22204	11114	1	0	\N
170483	2134	86929074000	22204	11114	2	0	\N
170484	2132	147975977000	22204	11114	3	0	\N
170496	1397	1307296864000	22208	11007	0	0	\N
170497	1397	1307286863000	22208	11007	1	0	\N
170498	1397	1307276862000	22208	11007	2	0	\N
170499	1397	1307266861000	22208	11007	3	0	\N
170500	1397	1307256860000	22208	11007	4	0	\N
170501	1397	1307246859000	22208	11007	5	0	\N
170502	2133	94347128000	22208	11007	7	0	\N
170503	2133	94346126000	22208	11007	8	0	\N
170504	2133	94345124000	22208	11007	9	0	\N
170505	2133	94344122000	22208	11007	10	0	\N
170506	2133	94343120000	22208	11007	11	0	\N
170507	2133	94342118000	22208	11007	12	0	\N
170508	2132	147975977000	22208	11007	13	0	\N
170509	2133	94341116000	22208	11007	14	0	\N
170510	2133	94340114000	22208	11007	15	0	\N
170511	2133	94339112000	22208	11007	16	0	\N
170512	2133	94338110000	22208	11007	17	0	\N
170513	2133	94337108000	22208	11007	18	0	\N
170514	2133	94336106000	22208	11007	19	0	\N
170515	2133	94335104000	22208	11007	20	0	\N
170516	2132	147974976000	22208	11007	21	0	\N
170517	733	2717775000000	22208	11007	22	0	\N
170518	2133	94334102000	22208	11007	23	0	\N
170519	2133	94333100000	22208	11007	24	0	\N
170520	2133	94332098000	22208	11007	25	0	\N
170521	2133	94331096000	22208	11007	26	0	\N
170522	2133	94330094000	22208	11007	27	0	\N
170523	2133	94329092000	22208	11007	28	0	\N
170524	2133	94328090000	22208	11007	29	0	\N
170525	2133	94327088000	22208	11007	30	0	\N
170526	2133	94326086000	22208	11007	31	0	\N
170527	2133	94325084000	22208	11007	32	0	\N
170528	2133	94324082000	22208	11007	33	0	\N
170529	2133	94323080000	22208	11007	34	0	\N
170530	2133	94322078000	22208	11007	35	0	\N
170531	2133	94321076000	22208	11007	36	0	\N
170532	2133	94320074000	22208	11007	37	0	\N
170533	2133	94319072000	22208	11007	38	0	\N
170534	2133	94318070000	22208	11007	39	0	\N
170535	2133	94317068000	22208	11007	40	0	\N
170536	2133	94316066000	22208	11007	41	0	\N
170537	2133	94315064000	22208	11007	42	0	\N
170538	2133	94314062000	22208	11007	43	0	\N
170539	2133	94313060000	22208	11007	44	0	\N
170540	2133	94312058000	22208	11007	45	0	\N
170541	2133	94311056000	22208	11007	46	0	\N
170542	2133	94310054000	22208	11007	47	0	\N
170543	2133	94309052000	22208	11007	48	0	\N
170544	2133	94308050000	22208	11007	49	0	\N
170464	2134	86932083000	22200	11112	2	0	3647
170465	2133	94228892000	22200	11112	3	0	3555
170466	2134	86931080000	22200	11112	4	0	3648
170467	2133	94227890000	22200	11112	5	0	3556
170474	1397	1307286863000	22202	11113	0	0	13154
170476	2134	86930077000	22202	11113	2	0	3649
170477	1397	1307276862000	22203	11114	0	0	13155
170478	2133	94225886000	22203	11114	1	0	3558
170479	2134	86929074000	22203	11114	2	0	3650
170480	2132	147975977000	22203	11114	3	0	1023
170486	2134	86928071000	22205	11115	1	0	3651
170487	2133	94224884000	22205	11115	2	0	3559
170488	733	2717775000000	22205	11115	3	0	4
170489	1397	1307256860000	22206	11116	0	0	13157
170491	2134	86927068000	22206	11116	2	0	3652
170492	1397	1307246859000	22207	11117	0	0	13158
170493	2133	94222880000	22207	11117	1	0	3561
170494	2134	86926065000	22207	11117	2	0	3653
170495	2132	147974976000	22207	11117	3	0	1024
170545	2133	94307048000	22208	11007	50	0	\N
170546	2133	94306046000	22208	11007	51	0	\N
170547	2133	94305044000	22208	11007	52	0	\N
170548	2133	94304042000	22208	11007	53	0	\N
170549	2133	94303040000	22208	11007	54	0	\N
170550	2133	94302038000	22208	11007	55	0	\N
170551	2133	94301036000	22208	11007	56	0	\N
170552	2133	94300034000	22208	11007	57	0	\N
170553	2133	94299032000	22208	11007	58	0	\N
170554	2133	94298030000	22208	11007	59	0	\N
170555	2133	94297028000	22208	11007	60	0	\N
170566	1397	1307236858000	22210	11118	0	0	\N
170567	1397	1307226857000	22210	11118	1	0	\N
170568	1397	1307216856000	22210	11118	2	0	\N
170569	2134	86925062000	22210	11118	3	0	\N
170570	2133	94221878000	22210	11118	4	0	\N
170571	2133	94220876000	22210	11118	5	0	\N
170572	2132	147973975000	22210	11118	6	0	\N
170573	2134	86924059000	22210	11118	7	0	\N
170574	2134	86923056000	22210	11118	8	0	\N
170575	2133	94219874000	22210	11118	9	0	\N
170582	1397	1307186853000	22212	11120	0	0	\N
170583	1397	1307176852000	22212	11120	1	0	\N
170584	1397	1307166851000	22212	11120	2	0	\N
170585	2134	86920047000	22212	11120	3	0	\N
170586	2134	86919044000	22212	11120	4	0	\N
170587	2133	94216868000	22212	11120	5	0	\N
170588	2133	94215866000	22212	11120	6	0	\N
170589	2133	94214864000	22212	11120	7	0	\N
170590	2132	147972974000	22212	11120	8	0	\N
170600	1397	1307186853000	22214	11120	0	0	\N
170601	1397	1307176852000	22214	11120	1	0	\N
170602	1397	1307166851000	22214	11120	2	0	\N
170603	2134	86920047000	22214	11120	3	0	\N
170604	2134	86919044000	22214	11120	4	0	\N
170605	2133	94216868000	22214	11120	5	0	\N
170606	2133	94215866000	22214	11120	6	0	\N
170607	2133	94214864000	22214	11120	7	0	\N
170608	2132	147972974000	22214	11120	8	0	\N
170631	1397	1307126847000	22224	11125	0	0	\N
170632	2133	94206848000	22224	11125	1	0	\N
170633	2134	86911020000	22224	11125	2	0	\N
170634	1397	1307126847000	22225	11125	0	0	\N
170635	2133	94206848000	22225	11125	1	0	\N
170636	2134	86911020000	22225	11125	2	0	\N
170637	1397	1307126847000	22226	11125	0	0	\N
170638	2134	86911020000	22226	11125	1	0	\N
170639	1397	1307126847000	22227	11125	0	0	\N
170640	2133	94206848000	22227	11125	1	0	\N
170641	2134	86911020000	22227	11125	2	0	\N
170642	1397	1307116846000	22228	11126	0	0	\N
170643	2133	94206848000	22228	11126	1	0	\N
170644	2132	147969971000	22228	11126	2	0	\N
170645	2133	94205846000	22228	11126	3	0	\N
170646	2134	86910017000	22228	11126	4	0	\N
170647	1397	1307116846000	22229	11126	0	0	\N
170648	2133	94206848000	22229	11126	1	0	\N
170649	2132	147969971000	22229	11126	2	0	\N
170650	2133	94205846000	22229	11126	3	0	\N
170651	2134	86910017000	22229	11126	4	0	\N
170652	1397	1307116846000	22230	11126	0	0	\N
170653	2133	94206848000	22230	11126	1	0	\N
170654	2132	147969971000	22230	11126	2	0	\N
170655	2134	86910017000	22230	11126	3	0	\N
170656	1654	5897241999798	22231	11113	0	0	\N
170657	1397	1307286863000	22231	11113	1	0	\N
170658	1397	1307276862000	22231	11113	2	0	\N
170659	1397	1307266861000	22231	11113	3	0	\N
170660	1397	1307256860000	22231	11113	4	0	\N
170661	1397	1307246859000	22231	11113	5	0	\N
170662	1397	1307236858000	22231	11113	6	0	\N
170663	1397	1307226857000	22231	11113	7	0	\N
170664	1397	1307216856000	22231	11113	8	0	\N
170665	1397	1307206855000	22231	11113	9	0	\N
170666	1397	1307196854000	22231	11113	10	0	\N
170667	1397	1307186853000	22231	11113	11	0	\N
170668	1397	1307176852000	22231	11113	12	0	\N
170669	1397	1307166851000	22231	11113	13	0	\N
170670	1397	1307156850000	22231	11113	14	0	\N
170671	1397	1307146849000	22231	11113	15	0	\N
170672	1397	1307136848000	22231	11113	16	0	\N
170673	1397	1307126847000	22231	11113	17	0	\N
170674	2133	94226888000	22231	11113	18	0	\N
170675	2133	94225886000	22231	11113	19	0	\N
170676	2133	94224884000	22231	11113	20	0	\N
170677	2133	94223882000	22231	11113	21	0	\N
170678	2133	94222880000	22231	11113	22	0	\N
170679	2133	94221878000	22231	11113	23	0	\N
170680	2133	94220876000	22231	11113	24	0	\N
170558	1397	1307216856000	22209	11118	2	0	13161
170559	2134	86925062000	22209	11118	3	0	3654
170560	2133	94221878000	22209	11118	4	0	3562
170561	2133	94220876000	22209	11118	5	0	3563
170562	2132	147973975000	22209	11118	6	0	1025
170564	2134	86923056000	22209	11118	8	0	3656
170565	2133	94219874000	22209	11118	9	0	3564
170576	1397	1307206855000	22211	11119	0	0	13162
170577	1397	1307196854000	22211	11119	1	0	13163
170578	2134	86922053000	22211	11119	2	0	3657
170580	2133	94218872000	22211	11119	4	0	3565
170581	2133	94217870000	22211	11119	5	0	3566
170591	1397	1307186853000	22213	11120	0	0	13164
170592	1397	1307176852000	22213	11120	1	0	13165
170594	2134	86920047000	22213	11120	3	0	3659
170595	2134	86919044000	22213	11120	4	0	3660
170596	2133	94216868000	22213	11120	5	0	3567
170597	2133	94215866000	22213	11120	6	0	3568
170598	2133	94214864000	22213	11120	7	0	3569
170609	1397	1307156850000	22215	11121	0	0	13167
170610	2134	86918041000	22215	11121	1	0	3661
170611	2133	94213862000	22215	11121	2	0	3570
170612	1397	1307146849000	22217	11122	0	0	13168
170613	2134	86917038000	22217	11122	1	0	3662
170615	2134	86916035000	22217	11122	3	0	3663
170616	2133	94212860000	22217	11122	4	0	3571
170617	2134	86915032000	22217	11122	5	0	3664
170618	2133	94211858000	22217	11122	6	0	3572
170620	2134	86914029000	22221	11123	0	0	3665
170621	2132	147970972000	22221	11123	1	0	1028
170622	2133	94209854000	22221	11123	2	0	3574
170623	2133	94208852000	22221	11123	3	0	3575
170624	2134	86913026000	22221	11123	4	0	3666
170626	1397	1307136848000	22222	11124	1	0	13169
170627	2133	94207850000	22222	11124	2	0	3576
170628	2134	86912023000	22222	11124	3	0	3667
170629	1397	1307126847000	22223	11125	0	0	13170
170630	2134	86911020000	22223	11125	1	0	3668
170681	2132	147975977000	22231	11113	25	0	\N
170682	2132	147974976000	22231	11113	26	0	\N
170683	2132	147973975000	22231	11113	27	0	\N
170684	2133	94219874000	22231	11113	28	0	\N
170685	2133	94218872000	22231	11113	29	0	\N
170686	2133	94217870000	22231	11113	30	0	\N
170687	2133	94216868000	22231	11113	31	0	\N
170688	2133	94215866000	22231	11113	32	0	\N
170689	2133	94214864000	22231	11113	33	0	\N
170690	2133	94213862000	22231	11113	34	0	\N
170691	2133	94212860000	22231	11113	35	0	\N
170692	2132	147972974000	22231	11113	36	0	\N
170693	2132	147971973000	22231	11113	37	0	\N
170694	2132	147970972000	22231	11113	38	0	\N
170695	2132	147969971000	22231	11113	39	0	\N
170696	2133	94211858000	22231	11113	40	0	\N
170697	2133	94210856000	22231	11113	41	0	\N
170698	2133	94209854000	22231	11113	42	0	\N
170699	2133	94208852000	22231	11113	43	0	\N
170700	2133	94207850000	22231	11113	44	0	\N
170701	2133	94206848000	22231	11113	45	0	\N
170702	2133	94205846000	22231	11113	46	0	\N
170703	733	2717775000000	22231	11113	48	0	\N
170704	2134	86930077000	22231	11113	49	0	\N
170705	2134	86929074000	22231	11113	50	0	\N
170706	2134	86928071000	22231	11113	51	0	\N
170707	2134	86927068000	22231	11113	52	0	\N
170708	2134	86926065000	22231	11113	53	0	\N
170709	2134	86925062000	22231	11113	54	0	\N
170710	2134	86924059000	22231	11113	55	0	\N
170711	2134	86923056000	22231	11113	56	0	\N
170712	2134	86922053000	22231	11113	57	0	\N
170713	2134	86921050000	22231	11113	58	0	\N
170714	2134	86920047000	22231	11113	59	0	\N
170715	2134	86919044000	22231	11113	60	0	\N
170716	2134	86918041000	22231	11113	61	0	\N
170717	2134	86917038000	22231	11113	62	0	\N
170718	2134	86916035000	22231	11113	63	0	\N
170719	2134	86915032000	22231	11113	64	0	\N
170720	2134	86914029000	22231	11113	65	0	\N
170721	2134	86913026000	22231	11113	66	0	\N
170722	2134	86912023000	22231	11113	67	0	\N
170723	2134	86911020000	22231	11113	68	0	\N
170724	2134	86910017000	22231	11113	69	0	\N
170742	1708	16813509885983	22235	11129	0	0	\N
170743	1397	1307066841000	22235	11129	1	0	\N
170744	1708	14122167478972	22235	11129	2	0	\N
170745	1708	10868088115923	22235	11129	3	0	\N
170746	2133	94202840000	22235	11129	4	0	\N
170747	2134	86905002000	22235	11129	5	0	\N
170748	2133	94201838000	22235	11129	6	0	\N
170749	2133	94200836000	22235	11129	7	0	\N
170750	1708	16813509885983	22236	11129	0	0	\N
170751	1397	1307066841000	22236	11129	1	0	\N
170752	1708	14122167478972	22236	11129	2	0	\N
170753	1708	10868088115923	22236	11129	3	0	\N
170754	2133	94202840000	22236	11129	4	0	\N
170755	2134	86905002000	22236	11129	5	0	\N
170756	2133	94201838000	22236	11129	6	0	\N
170757	2133	94200836000	22236	11129	7	0	\N
170769	1717	21619243895735	22239	11131	0	0	\N
170770	1397	1307046839000	22239	11131	1	0	\N
170771	1717	16297474321623	22239	11131	2	0	\N
170772	1717	12706767093431	22239	11131	3	0	\N
170773	1717	2700960000055	22239	11131	4	0	\N
170774	2134	86903999000	22239	11131	5	0	\N
170775	2133	94198832000	22239	11131	6	0	\N
170786	1717	20898631895735	22242	10935	0	0	\N
170787	1717	15576862321623	22242	10935	1	0	\N
170788	1717	11986155093431	22242	10935	2	0	\N
170789	1717	1980348000055	22242	10935	3	0	\N
170790	1717	20898631895735	22243	10948	0	0	\N
170791	1717	15576862321623	22243	10948	1	0	\N
170792	1717	11986155093431	22243	10948	2	0	\N
170793	1717	1980348000055	22243	10948	3	0	\N
170802	1717	20898631895735	22245	10990	0	0	\N
170803	1691	24047998090117	22245	10990	1	0	\N
170804	1691	21039029100333	22245	10990	2	0	\N
170805	1691	15646990371389	22245	10990	3	0	\N
170806	1717	15576862321623	22245	10990	4	0	\N
170807	1691	5509065527233	22245	10990	5	0	\N
170808	1691	1870946300052	22245	10990	6	0	\N
170809	1717	11986155093431	22245	10990	7	0	\N
170810	1717	1980348000055	22245	10990	8	0	\N
170811	1717	20898631895735	22246	11003	0	0	\N
170812	1691	24047998090117	22246	11003	1	0	\N
170813	1691	21039029100333	22246	11003	2	0	\N
170814	1691	15646990371389	22246	11003	3	0	\N
170815	1717	15576862321623	22246	11003	4	0	\N
170816	1691	5509065527233	22246	11003	5	0	\N
170727	2132	147969971000	22232	11126	2	0	1029
170728	2133	94205846000	22232	11126	3	0	3578
170729	2134	86910017000	22232	11126	4	0	3669
170730	1397	1307106845000	22233	11127	0	0	13172
170731	1397	1307096844000	22233	11127	1	0	13173
170733	2133	94204844000	22233	11127	3	0	3579
170734	2133	94203842000	22233	11127	4	0	3580
170735	2134	86908011000	22233	11127	5	0	3671
170736	1397	1307086843000	22234	11128	0	0	13174
170737	1397	1307076842000	22234	11128	1	0	13175
170739	2134	86907008000	22234	11128	3	0	3672
170740	2134	86906005000	22234	11128	4	0	3673
170741	1865	199000000	22234	11128	5	0	1
170758	1708	16813509885983	22237	11129	0	0	5
170760	1708	14122167478972	22237	11129	2	0	6
170761	1708	10868088115923	22237	11129	3	0	7
170762	2133	94202840000	22237	11129	4	0	3581
170763	2134	86905002000	22237	11129	5	0	3674
170764	2133	94201838000	22237	11129	6	0	3582
170766	1397	1307056840000	22238	11130	0	0	13177
170767	2133	94199834000	22238	11130	1	0	3584
170768	2132	147967969000	22238	11130	2	0	1031
170776	1717	21619243895735	22240	11131	0	0	5
170777	1397	1307046839000	22240	11131	1	0	13178
170779	1717	12706767093431	22240	11131	3	0	7
170780	1717	2700960000055	22240	11131	4	0	8
170781	2134	86903999000	22240	11131	5	0	3675
170782	2133	94198832000	22240	11131	6	0	3585
170784	2133	94197830000	22241	11132	1	0	3586
170785	2134	86902996000	22241	11132	2	0	3676
170794	1691	24047998090117	22244	11133	0	0	6
170795	1691	21039029100333	22244	11133	1	0	7
170796	1691	15646990371389	22244	11133	2	0	8
170798	1691	5509065527233	22244	11133	4	0	9
170799	1691	1870946300052	22244	11133	5	0	10
170800	2133	94196828000	22244	11133	6	0	3587
170801	2134	86901993000	22244	11133	7	0	3677
170817	1691	1870946300052	22246	11003	6	0	\N
170818	1717	11986155093431	22246	11003	7	0	\N
170819	1717	1980348000055	22246	11003	8	0	\N
170824	1397	1307016836000	22248	11134	0	0	\N
170825	2134	86900990000	22248	11134	1	0	\N
170826	2133	94195826000	22248	11134	2	0	\N
170827	2132	147966968000	22248	11134	3	0	\N
170828	1397	1307006835000	22250	11135	0	0	\N
170829	1397	1306996834000	22250	11135	1	0	\N
170830	2133	94194824000	22250	11135	2	0	\N
170831	2134	86899987000	22250	11135	3	0	\N
170832	2133	94193822000	22250	11135	4	0	\N
170833	2134	86898984000	22250	11135	5	0	\N
170840	1397	1306986833000	22252	11136	0	0	\N
170841	1397	1306976832000	22252	11136	1	0	\N
170842	2134	86897981000	22252	11136	2	0	\N
170843	2132	147965967000	22252	11136	3	0	\N
170844	2133	94192820000	22252	11136	4	0	\N
170845	2133	94191818000	22252	11136	5	0	\N
170846	2134	86896978000	22252	11136	6	0	\N
170860	1397	1306956830000	22256	11138	0	0	\N
170861	2133	94189814000	22256	11138	1	0	\N
170862	2134	86894972000	22256	11138	2	0	\N
170863	1397	1306946829000	22257	11139	0	0	\N
170864	2134	86893969000	22257	11139	1	0	\N
170865	2133	94188812000	22257	11139	2	0	\N
170866	2132	147964966000	22257	11139	3	0	\N
170867	1397	1306946829000	22258	11139	0	0	\N
170868	2134	86893969000	22258	11139	1	0	\N
170869	2133	94188812000	22258	11139	2	0	\N
170870	2132	147964966000	22258	11139	3	0	\N
170878	1397	1306936828000	22261	11140	0	0	\N
170879	2134	86892966000	22261	11140	1	0	\N
170883	1397	1306926827000	22263	11141	0	0	\N
170884	2134	86891963000	22263	11141	1	0	\N
170885	2133	94186808000	22263	11141	2	0	\N
170902	1397	1306906825000	22266	11143	0	0	\N
170903	1397	1306896824000	22266	11143	1	0	\N
170904	1397	1306886823000	22266	11143	2	0	\N
170905	2133	94184804000	22266	11143	3	0	\N
170906	2132	147962964000	22266	11143	4	0	\N
170907	1559	16413867000000	22266	11143	5	0	\N
170908	2133	94183802000	22266	11143	6	0	\N
170909	2133	94182800000	22266	11143	7	0	\N
170910	2134	86889957000	22266	11143	8	0	\N
170911	2134	86888954000	22266	11143	9	0	\N
170912	2134	86887951000	22266	11143	10	0	\N
170916	1397	1306866821000	22268	11145	0	0	\N
170917	2133	94180796000	22268	11145	1	0	\N
170918	2134	86885945000	22268	11145	2	0	\N
170944	1397	1306806815000	22274	11149	0	0	\N
170945	2134	86879927000	22274	11149	1	0	\N
170946	2133	94174784000	22274	11149	2	0	\N
170822	2133	94195826000	22247	11134	2	0	3588
170823	2132	147966968000	22247	11134	3	0	1032
170834	1397	1307006835000	22251	11135	0	0	13182
170835	1397	1306996834000	22251	11135	1	0	13183
170836	2133	94194824000	22251	11135	2	0	3589
170838	2133	94193822000	22251	11135	4	0	3590
170839	2134	86898984000	22251	11135	5	0	3680
170847	1397	1306986833000	22253	11136	0	0	13184
170848	1397	1306976832000	22253	11136	1	0	13185
170849	2134	86897981000	22253	11136	2	0	3681
170851	2133	94192820000	22253	11136	4	0	3591
170852	2133	94191818000	22253	11136	5	0	3592
170853	2134	86896978000	22253	11136	6	0	3682
170854	1397	1306966831000	22254	11137	0	0	13186
170856	2133	94190816000	22254	11137	2	0	3593
170857	1397	1306956830000	22255	11138	0	0	13187
170858	2133	94189814000	22255	11138	1	0	3594
170859	2134	86894972000	22255	11138	2	0	3684
170871	1397	1306946829000	22259	11139	0	0	13188
170873	2133	94188812000	22259	11139	2	0	3595
170874	2132	147964966000	22259	11139	3	0	1034
170875	1397	1306936828000	22260	11140	0	0	13189
170876	2134	86892966000	22260	11140	1	0	3686
170877	2133	94187810000	22260	11140	2	0	3596
170881	2134	86891963000	22262	11141	1	0	3687
170882	2133	94186808000	22262	11141	2	0	3597
170886	1397	1306916826000	22264	11142	0	0	13191
170887	2132	147963965000	22264	11142	1	0	1035
170889	2133	94185806000	22264	11142	3	0	3598
170890	1559	18837998000000	22264	11142	4	0	5
170891	1397	1306906825000	22265	11143	0	0	13192
170892	1397	1306896824000	22265	11143	1	0	13193
170893	1397	1306886823000	22265	11143	2	0	13194
170895	2132	147962964000	22265	11143	4	0	1036
170896	1559	16413867000000	22265	11143	5	0	6
170897	2133	94183802000	22265	11143	6	0	3600
170898	2133	94182800000	22265	11143	7	0	3601
170899	2134	86889957000	22265	11143	8	0	3689
170901	2134	86887951000	22265	11143	10	0	3691
170913	1397	1306876822000	22267	11144	0	0	13195
170914	2133	94181798000	22267	11144	1	0	3602
170915	2134	86886948000	22267	11144	2	0	3692
170920	2133	94180796000	22269	11145	1	0	3603
170921	2134	86885945000	22269	11145	2	0	3693
170922	1397	1306856820000	22270	11146	0	0	13197
170923	1397	1306846819000	22270	11146	1	0	13198
170924	2134	86884942000	22270	11146	2	0	3694
170926	2133	94179794000	22270	11146	4	0	3604
170927	2133	94178792000	22270	11146	5	0	3605
170928	1559	12821076000000	22270	11146	6	0	7
170929	2132	147961963000	22270	11146	7	0	1037
170930	1397	1306836818000	22271	11147	0	0	13199
170932	2134	86882936000	22271	11147	2	0	3696
170933	1397	1306826817000	22272	11148	0	0	13200
170934	1397	1306816816000	22272	11148	1	0	13201
170935	2133	94176788000	22272	11148	2	0	3607
170937	2134	86881933000	22272	11148	4	0	3697
170938	2134	86880930000	22272	11148	5	0	3698
170939	1559	6066035000000	22272	11148	6	0	8
170940	2132	147960962000	22272	11148	7	0	1038
170941	1397	1306806815000	22273	11149	0	0	13202
170943	2133	94174784000	22273	11149	2	0	3609
170947	1397	1306796814000	22275	11150	0	0	13203
170948	1397	1306786813000	22275	11150	1	0	13204
170949	2134	86878924000	22275	11150	2	0	3700
170950	2132	147959961000	22275	11150	3	0	1039
170952	2133	94172780000	22275	11150	5	0	3611
170956	1397	1306776812000	22277	11151	0	0	\N
170957	2134	86877921000	22277	11151	1	0	\N
170958	2133	94171778000	22277	11151	2	0	\N
170964	2133	94169774000	22281	11153	0	0	\N
170965	2134	86875915000	22281	11153	1	0	\N
170970	1397	1306756810000	22283	11154	0	0	\N
170971	2132	147958960000	22283	11154	1	0	\N
170972	2133	94168772000	22283	11154	2	0	\N
170973	2134	86874912000	22283	11154	3	0	\N
170974	1696	25603417305104	22284	10919	0	0	\N
170975	1696	21563925195104	22284	10919	1	0	\N
170976	1696	18838334325104	22284	10919	2	0	\N
170977	1696	11243590335104	22284	10919	3	0	\N
170978	604	66714579919853	22284	10919	4	0	\N
170979	1509	20083830540403	22284	10919	5	0	\N
170980	1509	16162255101171	22284	10919	6	0	\N
170981	1509	13516257481403	22284	10919	7	0	\N
170982	1509	6143128503835	22284	10919	8	0	\N
170983	1717	20898631895735	22284	10919	9	0	\N
170984	1708	16813509885983	22284	10919	10	0	\N
170985	1397	1310007135000	22284	10919	11	0	\N
170986	1691	24047998090117	22284	10919	12	0	\N
170987	1691	21039029100333	22284	10919	13	0	\N
170988	1654	14310272999798	22284	10919	14	0	\N
170989	1691	15646990371389	22284	10919	15	0	\N
170990	1708	14122167478972	22284	10919	16	0	\N
170991	257	66000000000000	22284	10919	17	0	\N
170992	1724	15296685500000	22284	10919	18	0	\N
170993	1724	11211675500000	22284	10919	19	0	\N
170994	1724	8454665500000	22284	10919	20	0	\N
170995	1717	15576862321623	22284	10919	21	0	\N
170996	1708	10868088115923	22284	10919	22	0	\N
170997	1723	14963610085979	22284	10919	23	0	\N
170998	1723	10476600085979	22284	10919	24	0	\N
170999	1723	7448590085979	22284	10919	25	0	\N
171000	1723	4944580085979	22284	10919	26	0	\N
171001	1691	5509065527233	22284	10919	27	0	\N
171002	1691	1870946300052	22284	10919	28	0	\N
171003	1717	11986155093431	22284	10919	29	0	\N
171004	1717	1980348000055	22284	10919	30	0	\N
171005	1723	4929570085979	22284	10919	31	0	\N
171006	1723	2881560085979	22284	10919	32	0	\N
171007	1397	1309997134000	22284	10919	33	0	\N
171008	1397	1309987133000	22284	10919	34	0	\N
171009	1397	1309977132000	22284	10919	35	0	\N
171010	1397	1309967131000	22284	10919	36	0	\N
171011	1397	1309957130000	22284	10919	37	0	\N
171012	1397	1309947129000	22284	10919	38	0	\N
171013	1397	1309937128000	22284	10919	39	0	\N
171014	1397	1309927127000	22284	10919	40	0	\N
171015	1397	1309917126000	22284	10919	41	0	\N
171016	1654	9897262999798	22284	10919	42	0	\N
171017	1654	6919252999798	22284	10919	43	0	\N
171018	1654	4457242999798	22284	10919	44	0	\N
171019	1397	1309907125000	22284	10919	46	0	\N
171020	1397	1309897124000	22284	10919	47	0	\N
171021	1397	1309887123000	22284	10919	48	0	\N
171022	1397	1309877122000	22284	10919	49	0	\N
171023	1397	1309867121000	22284	10919	50	0	\N
171024	1397	1309857120000	22284	10919	51	0	\N
171025	1397	1309847119000	22284	10919	52	0	\N
171026	1397	1309837118000	22284	10919	53	0	\N
171027	1397	1309827117000	22284	10919	54	0	\N
171028	1397	1309817116000	22284	10919	55	0	\N
171029	1397	1309807115000	22284	10919	56	0	\N
171030	1397	1309797114000	22284	10919	57	0	\N
171031	1397	1309787113000	22284	10919	58	0	\N
171032	1724	6174655500000	22284	10919	59	0	\N
171033	1708	1800324500051	22284	10919	60	0	\N
171034	1397	1309777112000	22284	10919	61	0	\N
171035	1397	1309767111000	22284	10919	62	0	\N
171036	1397	1309757110000	22284	10919	63	0	\N
171037	1397	1309747109000	22284	10919	64	0	\N
171038	1397	1309737108000	22284	10919	65	0	\N
171039	1397	1309727107000	22284	10919	66	0	\N
171040	1397	1309717106000	22284	10919	67	0	\N
171041	1397	1309707105000	22284	10919	68	0	\N
171042	1397	1309697104000	22284	10919	69	0	\N
171043	1397	1309687103000	22284	10919	70	0	\N
171044	1397	1309677102000	22284	10919	71	0	\N
171045	1397	1309667101000	22284	10919	72	0	\N
171046	1397	1309657100000	22284	10919	73	0	\N
171047	1397	1309647099000	22284	10919	74	0	\N
171048	1397	1309637098000	22284	10919	75	0	\N
171049	1397	1309627097000	22284	10919	76	0	\N
171050	1397	1309617096000	22284	10919	77	0	\N
171051	1397	1309607095000	22284	10919	78	0	\N
171052	1397	1309597094000	22284	10919	79	0	\N
171053	1397	1309587093000	22284	10919	80	0	\N
171054	1397	1309577092000	22284	10919	81	0	\N
171055	1397	1309567091000	22284	10919	82	0	\N
171056	1397	1309557090000	22284	10919	83	0	\N
171057	1397	1309547089000	22284	10919	84	0	\N
171058	1397	1309537088000	22284	10919	85	0	\N
171059	1397	1309527087000	22284	10919	86	0	\N
171060	1397	1309517086000	22284	10919	87	0	\N
171061	1397	1309507085000	22284	10919	88	0	\N
171062	1397	1309497084000	22284	10919	89	0	\N
171063	1397	1309487083000	22284	10919	90	0	\N
171064	1397	1309477082000	22284	10919	91	0	\N
171065	1397	1309467081000	22284	10919	92	0	\N
171066	1397	1309457080000	22284	10919	93	0	\N
171067	1397	1309447079000	22284	10919	94	0	\N
171068	1397	1309437078000	22284	10919	95	0	\N
171069	1397	1309427077000	22284	10919	96	0	\N
171070	1397	1309417076000	22284	10919	97	0	\N
171071	1397	1309407075000	22284	10919	98	0	\N
171072	1397	1309397074000	22284	10919	99	0	\N
171073	1397	1309387073000	22284	10919	100	0	\N
171074	1397	1309377072000	22284	10919	101	0	\N
171075	1397	1309367071000	22284	10919	102	0	\N
171076	1397	1309357070000	22284	10919	103	0	\N
171077	1397	1309347069000	22284	10919	104	0	\N
171078	1397	1309337068000	22284	10919	105	0	\N
171079	1397	1309327067000	22284	10919	106	0	\N
171080	1397	1309317066000	22284	10919	107	0	\N
171081	1397	1309307065000	22284	10919	108	0	\N
171082	1397	1309297064000	22284	10919	109	0	\N
171083	1397	1309287063000	22284	10919	110	0	\N
171084	1397	1309277062000	22284	10919	111	0	\N
171085	1397	1309267061000	22284	10919	112	0	\N
171086	1397	1309257060000	22284	10919	113	0	\N
171087	1397	1309247059000	22284	10919	114	0	\N
171088	1397	1309237058000	22284	10919	115	0	\N
170955	2133	94171778000	22276	11151	2	0	3612
170959	1397	1306766811000	22278	11152	0	0	13206
170960	2133	94170776000	22278	11152	1	0	3613
170961	2134	86876918000	22278	11152	2	0	3702
170962	2133	94169774000	22280	11153	0	0	3614
170966	1397	1306756810000	22282	11154	0	0	13207
170967	2132	147958960000	22282	11154	1	0	1040
170968	2133	94168772000	22282	11154	2	0	3615
170969	2134	86874912000	22282	11154	3	0	3704
171089	1397	1309227057000	22284	10919	116	0	\N
171090	1397	1309217056000	22284	10919	117	0	\N
171091	1397	1309207055000	22284	10919	118	0	\N
171092	1397	1309197054000	22284	10919	119	0	\N
171093	1397	1309187053000	22284	10919	120	0	\N
171094	1397	1309177052000	22284	10919	121	0	\N
171095	1397	1309167051000	22284	10919	122	0	\N
171096	1397	1309157050000	22284	10919	123	0	\N
171097	1397	1309147049000	22284	10919	124	0	\N
171098	1397	1309137048000	22284	10919	125	0	\N
171102	1397	1306736808000	22286	11156	0	0	\N
171103	2134	86872906000	22286	11156	1	0	\N
171104	2133	94166768000	22286	11156	2	0	\N
171108	1397	1306736808000	22288	11156	0	0	\N
171109	2134	86872906000	22288	11156	1	0	\N
171110	2133	94166768000	22288	11156	2	0	\N
171118	1397	1306726807000	22290	11157	0	0	\N
171119	1397	1306716806000	22290	11157	1	0	\N
171120	2133	94165766000	22290	11157	2	0	\N
171121	2133	94164764000	22290	11157	4	0	\N
171122	2134	86871903000	22290	11157	5	0	\N
171123	2132	147957959000	22290	11157	6	0	\N
171124	2134	86870900000	22290	11157	7	0	\N
171125	1397	1306726807000	22291	11157	0	0	\N
171126	1397	1306716806000	22291	11157	1	0	\N
171127	2133	94165766000	22291	11157	2	0	\N
171128	2133	94164764000	22291	11157	4	0	\N
171129	2134	86871903000	22291	11157	5	0	\N
171130	2132	147957959000	22291	11157	6	0	\N
171131	2134	86870900000	22291	11157	7	0	\N
171145	1397	1306686803000	22295	11160	0	0	\N
171146	1397	1306676802000	22295	11160	1	0	\N
171147	2134	86867891000	22295	11160	2	0	\N
171148	2134	86866888000	22295	11160	3	0	\N
171149	1654	5897241999798	22296	11092	0	0	\N
171150	1717	21619243895735	22296	11092	1	0	\N
171151	1708	16813509885983	22296	11092	2	0	\N
171152	1397	1307566891000	22296	11092	3	0	\N
171153	1691	24047998090117	22296	11092	4	0	\N
171154	1691	21039029100333	22296	11092	5	0	\N
171155	1691	15646990371389	22296	11092	6	0	\N
171156	1708	14122167478972	22296	11092	7	0	\N
171157	1397	1307556890000	22296	11092	8	0	\N
171158	1397	1307546889000	22296	11092	9	0	\N
171159	1397	1307536888000	22296	11092	10	0	\N
171160	1397	1307526887000	22296	11092	11	0	\N
171161	1717	16297474321623	22296	11092	12	0	\N
171162	1708	10868088115923	22296	11092	13	0	\N
171163	1397	1307516886000	22296	11092	14	0	\N
171164	1397	1307506885000	22296	11092	15	0	\N
171165	1397	1307496884000	22296	11092	16	0	\N
171166	1397	1307486883000	22296	11092	17	0	\N
171167	1397	1307476882000	22296	11092	18	0	\N
171168	1397	1307466881000	22296	11092	19	0	\N
171169	1397	1307456880000	22296	11092	20	0	\N
171170	1397	1307446879000	22296	11092	21	0	\N
171171	1397	1307436878000	22296	11092	22	0	\N
171172	1397	1307426877000	22296	11092	23	0	\N
171173	1397	1307416876000	22296	11092	24	0	\N
171174	1691	5509065527233	22296	11092	25	0	\N
171175	1691	1870946300052	22296	11092	26	0	\N
171176	1717	12706767093431	22296	11092	27	0	\N
171177	1717	2700960000055	22296	11092	28	0	\N
171178	1397	1307406875000	22296	11092	29	0	\N
171179	1397	1307396874000	22296	11092	30	0	\N
171180	1397	1307386873000	22296	11092	31	0	\N
171181	1397	1307376872000	22296	11092	32	0	\N
171182	1397	1307366871000	22296	11092	33	0	\N
171183	1397	1307356870000	22296	11092	34	0	\N
171184	1397	1307346869000	22296	11092	35	0	\N
171185	1397	1307336868000	22296	11092	36	0	\N
171186	1397	1307326867000	22296	11092	37	0	\N
171187	1397	1307316866000	22296	11092	38	0	\N
171188	1397	1307306865000	22296	11092	39	0	\N
171189	1397	1307296864000	22296	11092	40	0	\N
171190	1397	1307286863000	22296	11092	41	0	\N
171191	1397	1307276862000	22296	11092	42	0	\N
171192	1397	1307266861000	22296	11092	43	0	\N
171193	1397	1307256860000	22296	11092	44	0	\N
171194	1397	1307246859000	22296	11092	45	0	\N
171195	1397	1307236858000	22296	11092	46	0	\N
171196	1397	1307226857000	22296	11092	47	0	\N
171197	1397	1307216856000	22296	11092	48	0	\N
171198	1397	1307206855000	22296	11092	49	0	\N
171199	1397	1307196854000	22296	11092	50	0	\N
171200	1397	1307186853000	22296	11092	51	0	\N
171201	1397	1307176852000	22296	11092	52	0	\N
171202	1397	1307166851000	22296	11092	53	0	\N
171203	1397	1307156850000	22296	11092	54	0	\N
171204	1397	1307146849000	22296	11092	55	0	\N
171205	1397	1307136848000	22296	11092	56	0	\N
171206	1397	1307126847000	22296	11092	57	0	\N
171207	1397	1307116846000	22296	11092	58	0	\N
171208	1397	1307106845000	22296	11092	59	0	\N
171209	1397	1307096844000	22296	11092	60	0	\N
171210	1397	1307086843000	22296	11092	61	0	\N
171211	1397	1307076842000	22296	11092	62	0	\N
171212	1397	1307066841000	22296	11092	64	0	\N
171213	1397	1307056840000	22296	11092	65	0	\N
171214	1397	1307046839000	22296	11092	66	0	\N
171215	1397	1307036838000	22296	11092	67	0	\N
171216	1397	1307026837000	22296	11092	68	0	\N
171217	1397	1307016836000	22296	11092	69	0	\N
171218	1397	1307006835000	22296	11092	70	0	\N
171219	1397	1306996834000	22296	11092	71	0	\N
171220	1397	1306986833000	22296	11092	72	0	\N
171221	1397	1306976832000	22296	11092	73	0	\N
171222	1397	1306966831000	22296	11092	74	0	\N
171223	1397	1306956830000	22296	11092	75	0	\N
171224	1397	1306946829000	22296	11092	76	0	\N
171101	2133	94167770000	22285	11155	2	0	3616
171105	1397	1306736808000	22287	11156	0	0	13209
171106	2134	86872906000	22287	11156	1	0	3706
171107	2133	94166768000	22287	11156	2	0	3617
171111	1397	1306726807000	22289	11157	0	0	13210
171113	2133	94165766000	22289	11157	2	0	3618
171114	2133	94164764000	22289	11157	4	0	3619
171115	2134	86871903000	22289	11157	5	0	3707
171116	2132	147957959000	22289	11157	6	0	1041
171117	2134	86870900000	22289	11157	7	0	3708
171133	1397	1306696804000	22293	11159	1	0	13213
171134	2134	86869897000	22293	11159	2	0	3709
171135	2134	86868894000	22293	11159	3	0	3710
171136	2133	94163762000	22293	11159	4	0	3620
171138	2132	147956958000	22293	11159	6	0	1042
171139	1397	1306686803000	22294	11160	0	0	13214
171140	1397	1306676802000	22294	11160	1	0	13215
171141	2133	94161758000	22294	11160	2	0	3622
171142	2133	94160756000	22294	11160	3	0	3623
171144	2134	86866888000	22294	11160	5	0	3712
171225	1397	1306936828000	22296	11092	77	0	\N
171226	1397	1306926827000	22296	11092	78	0	\N
171227	1397	1306916826000	22296	11092	79	0	\N
171228	1397	1306906825000	22296	11092	80	0	\N
171229	1397	1306896824000	22296	11092	81	0	\N
171230	1397	1306886823000	22296	11092	82	0	\N
171231	1397	1306876822000	22296	11092	83	0	\N
171232	1397	1306866821000	22296	11092	84	0	\N
171233	1397	1306856820000	22296	11092	85	0	\N
171234	1397	1306846819000	22296	11092	86	0	\N
171235	1397	1306836818000	22296	11092	87	0	\N
171236	1397	1306826817000	22296	11092	88	0	\N
171237	1397	1306816816000	22296	11092	89	0	\N
171238	1397	1306806815000	22296	11092	90	0	\N
171239	1708	1800324500051	22296	11092	91	0	\N
171240	1397	1306796814000	22296	11092	92	0	\N
171241	1397	1306786813000	22296	11092	93	0	\N
171242	1397	1306776812000	22296	11092	94	0	\N
171243	1397	1306766811000	22296	11092	95	0	\N
171244	1397	1306756810000	22296	11092	96	0	\N
171245	1397	1306746809000	22296	11092	97	0	\N
171246	1397	1306736808000	22296	11092	98	0	\N
171247	1397	1306726807000	22296	11092	99	0	\N
171248	1397	1306716806000	22296	11092	100	0	\N
171249	1397	1306706805000	22296	11092	101	0	\N
171250	1397	1306696804000	22296	11092	102	0	\N
171251	1397	1306686803000	22296	11092	103	0	\N
171252	1397	1306676802000	22296	11092	104	0	\N
171253	1899	1995000000	22296	11092	105	0	\N
171254	1740	9090705000000	22296	11092	106	0	\N
171255	563	66000605000000	22296	11092	107	0	\N
171256	2133	94255946000	22296	11092	108	0	\N
171257	733	3439024000000	22296	11092	109	0	\N
171258	2134	86959164000	22296	11092	110	0	\N
171259	2133	94254944000	22296	11092	111	0	\N
171260	2132	147984986000	22296	11092	112	0	\N
171261	2132	147983985000	22296	11092	113	0	\N
171262	733	2720025000000	22296	11092	114	0	\N
171263	733	2719775000000	22296	11092	115	0	\N
171264	2134	86958161000	22296	11092	116	0	\N
171265	2134	86957158000	22296	11092	117	0	\N
171266	2134	86956155000	22296	11092	118	0	\N
171267	2134	86955152000	22296	11092	119	0	\N
171268	2134	86954149000	22296	11092	120	0	\N
171269	2134	86953146000	22296	11092	121	0	\N
171270	2132	147982984000	22296	11092	122	0	\N
171271	2132	147981983000	22296	11092	123	0	\N
171272	2132	147980982000	22296	11092	124	0	\N
171273	2132	147979981000	22296	11092	125	0	\N
171277	1397	1306666801000	22298	11161	0	0	\N
171278	2133	94159754000	22298	11161	1	0	\N
171279	2134	86865885000	22298	11161	2	0	\N
171294	1397	1306616796000	22300	11163	0	0	\N
171295	2133	94154744000	22300	11163	1	0	\N
171296	2134	86860870000	22300	11163	2	0	\N
171300	1397	1306606795000	22302	11164	0	0	\N
171301	2133	94153742000	22302	11164	1	0	\N
171302	2134	86859867000	22302	11164	2	0	\N
171317	1397	1306566791000	22305	11166	0	0	\N
171318	2133	94149734000	22305	11166	1	0	\N
171319	2134	86855855000	22305	11166	2	0	\N
171323	1397	1306566791000	22307	11166	0	0	\N
171324	2133	94149734000	22307	11166	1	0	\N
171325	2134	86855855000	22307	11166	2	0	\N
171326	1397	1306566791000	22308	11166	0	0	\N
171327	2133	94149734000	22308	11166	1	0	\N
171328	2134	86855855000	22308	11166	2	0	\N
171329	1555	15296924474753	22309	11146	0	0	\N
171330	1397	1306856820000	22309	11146	1	0	\N
171331	1397	1306846819000	22309	11146	2	0	\N
171332	1397	1306836818000	22309	11146	3	0	\N
171333	1397	1306826817000	22309	11146	4	0	\N
171334	1397	1306816816000	22309	11146	5	0	\N
171335	1397	1306806815000	22309	11146	6	0	\N
171336	1397	1306796814000	22309	11146	7	0	\N
171337	1397	1306786813000	22309	11146	8	0	\N
171338	1397	1306776812000	22309	11146	9	0	\N
171339	1397	1306766811000	22309	11146	10	0	\N
171340	1397	1306756810000	22309	11146	11	0	\N
171341	1397	1306746809000	22309	11146	12	0	\N
171342	1397	1306736808000	22309	11146	13	0	\N
171343	1397	1306726807000	22309	11146	14	0	\N
171344	1397	1306716806000	22309	11146	15	0	\N
171345	1397	1306706805000	22309	11146	16	0	\N
171346	1397	1306696804000	22309	11146	17	0	\N
171347	1397	1306686803000	22309	11146	18	0	\N
171348	1397	1306676802000	22309	11146	19	0	\N
171349	1397	1306666801000	22309	11146	20	0	\N
171350	1397	1306656800000	22309	11146	21	0	\N
171351	1397	1306646799000	22309	11146	22	0	\N
171352	1397	1306636798000	22309	11146	23	0	\N
171353	1397	1306626797000	22309	11146	24	0	\N
171354	1397	1306616796000	22309	11146	25	0	\N
171355	1397	1306606795000	22309	11146	26	0	\N
171356	1397	1306596794000	22309	11146	27	0	\N
171357	1397	1306586793000	22309	11146	28	0	\N
171358	1397	1306576792000	22309	11146	29	0	\N
171359	1397	1306566791000	22309	11146	30	0	\N
171360	2134	86884942000	22309	11146	31	0	\N
171276	2134	86865885000	22297	11161	2	0	3713
171280	1397	1306656800000	22299	11162	0	0	13217
171281	1397	1306646799000	22299	11162	1	0	13218
171282	1397	1306636798000	22299	11162	2	0	13219
171283	1397	1306626797000	22299	11162	3	0	13220
171285	2132	147954956000	22299	11162	5	0	1044
171286	2133	94158752000	22299	11162	6	0	3625
171287	2133	94157750000	22299	11162	7	0	3626
171288	2133	94156748000	22299	11162	8	0	3627
171289	2133	94155746000	22299	11162	9	0	3628
171291	2134	86863879000	22299	11162	11	0	3715
171292	2134	86862876000	22299	11162	12	0	3716
171293	2134	86861873000	22299	11162	13	0	3717
171297	1397	1306616796000	22301	11163	0	0	13221
171299	2134	86860870000	22301	11163	2	0	3718
171303	1397	1306606795000	22303	11164	0	0	13222
171304	2133	94153742000	22303	11164	1	0	3630
171305	2134	86859867000	22303	11164	2	0	3719
171306	1397	1306596794000	22304	11165	0	0	13223
171308	1397	1306576792000	22304	11165	2	0	13225
171309	1555	15296924474753	22304	11165	3	0	5
171310	2134	86858864000	22304	11165	4	0	3720
171311	2133	94152740000	22304	11165	5	0	3631
171312	2134	86857861000	22304	11165	6	0	3721
171314	2132	147953955000	22304	11165	8	0	1045
171315	2133	94151738000	22304	11165	9	0	3632
171316	2133	94150736000	22304	11165	10	0	3633
171320	1397	1306566791000	22306	11166	0	0	13226
171322	2134	86855855000	22306	11166	2	0	3723
171361	2134	86883939000	22309	11146	32	0	\N
171362	2133	94179794000	22309	11146	33	0	\N
171363	2133	94178792000	22309	11146	34	0	\N
171364	2133	94177790000	22309	11146	35	0	\N
171365	2133	94176788000	22309	11146	36	0	\N
171366	2133	94175786000	22309	11146	37	0	\N
171367	1559	12821076000000	22309	11146	38	0	\N
171368	1559	6066035000000	22309	11146	39	0	\N
171369	2132	147961963000	22309	11146	40	0	\N
171370	2132	147960962000	22309	11146	41	0	\N
171371	2132	147959961000	22309	11146	42	0	\N
171372	2132	147958960000	22309	11146	43	0	\N
171373	2132	147957959000	22309	11146	44	0	\N
171374	2132	147956958000	22309	11146	45	0	\N
171375	2132	147955957000	22309	11146	46	0	\N
171376	2132	147954956000	22309	11146	47	0	\N
171377	2132	147953955000	22309	11146	48	0	\N
171378	2133	94174784000	22309	11146	49	0	\N
171379	2133	94173782000	22309	11146	50	0	\N
171380	2133	94172780000	22309	11146	51	0	\N
171381	2133	94171778000	22309	11146	52	0	\N
171382	2133	94170776000	22309	11146	53	0	\N
171383	2133	94169774000	22309	11146	54	0	\N
171384	2133	94168772000	22309	11146	55	0	\N
171385	2133	94167770000	22309	11146	56	0	\N
171386	2133	94166768000	22309	11146	57	0	\N
171387	2133	94165766000	22309	11146	58	0	\N
171388	2133	94164764000	22309	11146	59	0	\N
171389	2133	94163762000	22309	11146	60	0	\N
171390	2133	94162760000	22309	11146	61	0	\N
171391	2133	94161758000	22309	11146	62	0	\N
171392	2133	94160756000	22309	11146	63	0	\N
171393	2133	94159754000	22309	11146	64	0	\N
171394	2133	94158752000	22309	11146	65	0	\N
171395	2133	94157750000	22309	11146	66	0	\N
171396	2133	94156748000	22309	11146	67	0	\N
171397	2133	94155746000	22309	11146	68	0	\N
171398	2133	94154744000	22309	11146	69	0	\N
171399	2133	94153742000	22309	11146	70	0	\N
171400	2133	94152740000	22309	11146	72	0	\N
171401	2133	94151738000	22309	11146	73	0	\N
171402	2133	94150736000	22309	11146	74	0	\N
171403	2133	94149734000	22309	11146	75	0	\N
171404	2134	86882936000	22309	11146	76	0	\N
171405	2134	86881933000	22309	11146	77	0	\N
171406	2134	86880930000	22309	11146	78	0	\N
171407	2134	86879927000	22309	11146	79	0	\N
171408	2134	86878924000	22309	11146	80	0	\N
171409	2134	86877921000	22309	11146	81	0	\N
171410	2134	86876918000	22309	11146	82	0	\N
171411	2134	86875915000	22309	11146	83	0	\N
171412	2134	86874912000	22309	11146	84	0	\N
171413	2134	86873909000	22309	11146	85	0	\N
171414	2134	86872906000	22309	11146	86	0	\N
171415	2134	86871903000	22309	11146	87	0	\N
171416	2134	86870900000	22309	11146	88	0	\N
171417	2134	86869897000	22309	11146	89	0	\N
171418	2134	86868894000	22309	11146	90	0	\N
171419	2134	86867891000	22309	11146	91	0	\N
171420	2134	86866888000	22309	11146	92	0	\N
171421	2134	86865885000	22309	11146	93	0	\N
171422	2134	86864882000	22309	11146	94	0	\N
171423	2134	86863879000	22309	11146	95	0	\N
171424	2134	86862876000	22309	11146	96	0	\N
171425	2134	86861873000	22309	11146	97	0	\N
171426	2134	86860870000	22309	11146	98	0	\N
171427	2134	86859867000	22309	11146	99	0	\N
171428	2134	86858864000	22309	11146	100	0	\N
171429	2134	86857861000	22309	11146	101	0	\N
171430	2134	86856858000	22309	11146	102	0	\N
171431	2134	86855855000	22309	11146	103	0	\N
171442	1397	1306526787000	22313	11170	0	0	\N
171443	2133	94145726000	22313	11170	1	0	\N
171444	2134	86851843000	22313	11170	2	0	\N
171445	2132	147951953000	22313	11170	3	0	\N
171458	1397	1306516786000	22317	11171	0	0	\N
171459	1397	1306506785000	22317	11171	1	0	\N
171460	1555	12683290483409	22317	11171	2	0	\N
171461	1657	15284551990100	22317	11171	3	0	\N
171462	2134	86850840000	22317	11171	4	0	\N
171463	2134	86849837000	22317	11171	5	0	\N
171464	2133	94144724000	22317	11171	6	0	\N
171465	2133	94143722000	22317	11171	7	0	\N
171478	1397	1306476782000	22319	11173	0	0	\N
171479	1397	1306466781000	22319	11173	1	0	\N
171480	1397	1306456780000	22319	11173	2	0	\N
171481	2134	86846828000	22319	11173	3	0	\N
171482	2134	86845825000	22319	11173	4	0	\N
171483	1657	2563168990100	22319	11173	5	0	\N
171484	2134	86844822000	22319	11173	6	0	\N
171485	2132	147949951000	22319	11173	8	0	\N
171486	2133	94140716000	22319	11173	9	0	\N
171487	2133	94139714000	22319	11173	10	0	\N
171488	2133	94138712000	22319	11173	11	0	\N
171434	2134	86854852000	22310	11167	2	0	3724
171435	2133	94148732000	22310	11167	3	0	3635
171436	1397	1306546789000	22311	11168	0	0	13228
171437	2133	94147730000	22311	11168	1	0	3636
171438	2134	86853849000	22311	11168	2	0	3725
171440	2133	94146728000	22312	11169	1	0	3637
171441	2134	86852846000	22312	11169	2	0	3726
171446	1397	1306526787000	22314	11170	0	0	13230
171447	2133	94145726000	22314	11170	1	0	3638
171448	2134	86851843000	22314	11170	2	0	3727
171450	1397	1306516786000	22316	11171	0	0	13231
171451	1397	1306506785000	22316	11171	1	0	13232
171452	1555	12683290483409	22316	11171	2	0	6
171453	1657	15284551990100	22316	11171	3	0	7
171455	2134	86849837000	22316	11171	5	0	3729
171456	2133	94144724000	22316	11171	6	0	3639
171457	2133	94143722000	22316	11171	7	0	3640
171466	1397	1306496784000	22318	11172	0	0	13233
171467	1397	1306486783000	22318	11172	1	0	13234
171469	1555	6005756540449	22318	11172	3	0	8
171470	2133	94142720000	22318	11172	4	0	3641
171471	2132	147950952000	22318	11172	5	0	1048
171472	733	2000074000000	22318	11172	6	0	5
171473	2134	86848834000	22318	11172	7	0	3730
171475	1657	9291459990100	22318	11172	9	0	9
171476	2134	86847831000	22318	11172	10	0	3731
171477	2133	94141718000	22318	11172	11	0	3642
171489	1397	1306476782000	22320	11173	0	0	13235
171491	1397	1306456780000	22320	11173	2	0	13237
171492	2134	86846828000	22320	11173	3	0	3732
171493	2134	86845825000	22320	11173	4	0	3733
171494	1657	2563168990100	22320	11173	5	0	10
171495	2134	86844822000	22320	11173	6	0	3734
171500	1397	1306476782000	22321	11173	0	0	\N
171501	1397	1306466781000	22321	11173	1	0	\N
171502	1397	1306456780000	22321	11173	2	0	\N
171503	2134	86846828000	22321	11173	3	0	\N
171504	2134	86845825000	22321	11173	4	0	\N
171505	1657	2563168990100	22321	11173	5	0	\N
171506	2134	86844822000	22321	11173	6	0	\N
171507	2132	147949951000	22321	11173	8	0	\N
171508	2133	94140716000	22321	11173	9	0	\N
171509	2133	94139714000	22321	11173	10	0	\N
171510	2133	94138712000	22321	11173	11	0	\N
171511	1397	1306446779000	22322	11174	0	0	\N
171512	1397	1306436778000	22322	11174	1	0	\N
171513	2133	94137710000	22322	11174	2	0	\N
171514	2133	94136708000	22322	11174	3	0	\N
171515	2134	86843819000	22322	11174	4	0	\N
171516	2134	86842816000	22322	11174	5	0	\N
171517	1657	1441167990100	22322	11174	6	0	\N
171523	1397	1306446779000	22324	11174	0	0	\N
171524	1397	1306436778000	22324	11174	1	0	\N
171525	2133	94137710000	22324	11174	2	0	\N
171526	2133	94136708000	22324	11174	3	0	\N
171527	2134	86843819000	22324	11174	4	0	\N
171528	2134	86842816000	22324	11174	5	0	\N
171529	1657	1441167990100	22324	11174	6	0	\N
171530	1397	1306446779000	22325	11174	0	0	\N
171531	1397	1306436778000	22325	11174	1	0	\N
171532	2133	94137710000	22325	11174	2	0	\N
171533	2133	94136708000	22325	11174	3	0	\N
171534	2134	86843819000	22325	11174	4	0	\N
171535	2134	86842816000	22325	11174	5	0	\N
171536	1657	1441167990100	22325	11174	6	0	\N
171537	1397	1306446779000	22326	11174	0	0	\N
171538	1397	1306436778000	22326	11174	1	0	\N
171539	2133	94137710000	22326	11174	2	0	\N
171540	2133	94136708000	22326	11174	3	0	\N
171541	2134	86843819000	22326	11174	4	0	\N
171542	2134	86842816000	22326	11174	5	0	\N
171543	1657	1441167990100	22326	11174	6	0	\N
171544	1397	1306446779000	22327	11174	0	0	\N
171545	1397	1306436778000	22327	11174	1	0	\N
171546	2133	94137710000	22327	11174	2	0	\N
171547	2133	94136708000	22327	11174	3	0	\N
171548	2134	86843819000	22327	11174	4	0	\N
171549	2134	86842816000	22327	11174	5	0	\N
171550	1657	1441167990100	22327	11174	6	0	\N
171551	1397	1306426777000	22328	11175	0	0	\N
171552	2133	94135706000	22328	11175	1	0	\N
171553	2132	147948950000	22328	11175	2	0	\N
171557	1397	1306426777000	22330	11175	0	0	\N
171558	2133	94135706000	22330	11175	1	0	\N
171559	2134	86843819000	22330	11175	2	0	\N
171560	2134	86842816000	22330	11175	3	0	\N
171561	2134	86841813000	22330	11175	4	0	\N
171562	2132	147948950000	22330	11175	5	0	\N
171572	1397	1306416776000	22333	11177	0	0	\N
171573	1397	1306406775000	22333	11177	1	0	\N
171574	1397	1306396774000	22333	11177	2	0	\N
171575	2134	86841813000	22333	11177	3	0	\N
171576	2133	94134704000	22333	11177	4	0	\N
171577	2134	86840810000	22333	11177	5	0	\N
171578	2134	86839807000	22333	11177	6	0	\N
171579	2134	86838804000	22333	11177	7	0	\N
171580	2132	147947949000	22333	11177	8	0	\N
171581	2133	94133702000	22333	11177	9	0	\N
171582	2133	94132700000	22333	11177	10	0	\N
171600	1397	1306346769000	22336	11180	0	0	\N
171601	2133	94127690000	22336	11180	1	0	\N
171602	2134	86833789000	22336	11180	2	0	\N
171613	1397	1306316766000	22340	11183	0	0	\N
171614	1397	1306306765000	22340	11183	1	0	\N
171615	1397	1306296764000	22340	11183	2	0	\N
171616	2133	94124684000	22340	11183	3	0	\N
171617	2132	147944946000	22340	11183	4	0	\N
171618	2133	94123682000	22340	11183	5	0	\N
171619	2133	94122680000	22340	11183	6	0	\N
171620	2134	86830780000	22340	11183	7	0	\N
171621	2134	86829777000	22340	11183	8	0	\N
171622	2134	86828774000	22340	11183	9	0	\N
171623	1397	1306316766000	22341	11183	0	0	\N
171624	1397	1306306765000	22341	11183	1	0	\N
171625	1397	1306296764000	22341	11183	2	0	\N
171626	2133	94124684000	22341	11183	3	0	\N
171627	2132	147944946000	22341	11183	4	0	\N
171628	2133	94123682000	22341	11183	5	0	\N
171629	2133	94122680000	22341	11183	6	0	\N
171630	2134	86830780000	22341	11183	7	0	\N
171631	2134	86829777000	22341	11183	8	0	\N
171632	2134	86828774000	22341	11183	9	0	\N
171499	2133	94138712000	22320	11173	11	0	3645
171518	1397	1306446779000	22323	11174	0	0	13238
171519	1397	1306436778000	22323	11174	1	0	13239
171520	2133	94137710000	22323	11174	2	0	3646
171521	2133	94136708000	22323	11174	3	0	3647
171554	1397	1306426777000	22329	11175	0	0	13240
171555	2133	94135706000	22329	11175	1	0	3648
171556	2132	147948950000	22329	11175	2	0	1050
171563	2134	86843819000	22331	11176	0	0	3735
171564	2134	86842816000	22331	11176	1	0	3736
171566	1397	1306406775000	22332	11177	1	0	13242
171567	1397	1306396774000	22332	11177	2	0	13243
171568	2133	94134704000	22332	11177	3	0	3649
171569	2132	147947949000	22332	11177	4	0	1051
171571	2133	94132700000	22332	11177	6	0	3651
171583	1397	1306386773000	22334	11178	0	0	13244
171584	1397	1306376772000	22334	11178	1	0	13245
171585	2134	86841813000	22334	11178	2	0	3737
171586	2133	94131698000	22334	11178	3	0	3652
171588	2134	86840810000	22334	11178	5	0	3738
171589	2134	86839807000	22334	11178	6	0	3739
171590	2134	86838804000	22334	11178	7	0	3740
171591	2134	86837801000	22334	11178	8	0	3741
171592	2134	86836798000	22334	11178	9	0	3742
171594	1397	1306356770000	22335	11179	1	0	13247
171595	2134	86835795000	22335	11179	2	0	3743
171596	2134	86834792000	22335	11179	3	0	3744
171597	2132	147946948000	22335	11179	4	0	1052
171599	2133	94128692000	22335	11179	6	0	3655
171603	1397	1306346769000	22337	11180	0	0	13248
171604	2133	94127690000	22337	11180	1	0	3656
171605	2134	86833789000	22337	11180	2	0	3745
171606	1397	1306336768000	22338	11181	0	0	13249
171608	2133	94126688000	22338	11181	2	0	3657
171609	1397	1306326767000	22339	11182	0	0	13250
171610	2134	86831783000	22339	11182	1	0	3747
171611	2132	147945947000	22339	11182	2	0	1053
171612	2133	94125686000	22339	11182	3	0	3658
171647	1397	1306286763000	22344	11184	0	0	\N
171648	1397	1306276762000	22344	11184	1	0	\N
171649	2133	94121678000	22344	11184	2	0	\N
171650	2133	94120676000	22344	11184	3	0	\N
171651	2134	86830780000	22344	11184	4	0	\N
171652	2134	86829777000	22344	11184	5	0	\N
171653	2134	86828774000	22344	11184	6	0	\N
171654	2134	86827771000	22344	11184	7	0	\N
171655	2134	86826768000	22344	11184	8	0	\N
171661	1397	1306256760000	22346	11186	0	0	\N
171662	2133	94118672000	22346	11186	1	0	\N
171663	2132	147943945000	22346	11186	2	0	\N
171664	2134	86824762000	22346	11186	3	0	\N
171665	1397	1306256760000	22347	11186	0	0	\N
171666	2133	94118672000	22347	11186	1	0	\N
171667	2132	147943945000	22347	11186	2	0	\N
171668	2134	86824762000	22347	11186	3	0	\N
171675	1397	1306426777000	22350	11175	0	0	\N
171676	1397	1306416776000	22350	11175	1	0	\N
171677	1397	1306406775000	22350	11175	2	0	\N
171678	1397	1306396774000	22350	11175	3	0	\N
171679	1397	1306386773000	22350	11175	4	0	\N
171680	1397	1306376772000	22350	11175	5	0	\N
171681	1397	1306366771000	22350	11175	6	0	\N
171682	1397	1306356770000	22350	11175	7	0	\N
171683	1397	1306346769000	22350	11175	8	0	\N
171684	1397	1306336768000	22350	11175	9	0	\N
171685	1397	1306326767000	22350	11175	10	0	\N
171686	1397	1306316766000	22350	11175	11	0	\N
171687	1397	1306306765000	22350	11175	12	0	\N
171688	1397	1306296764000	22350	11175	13	0	\N
171689	1397	1306286763000	22350	11175	14	0	\N
171690	1397	1306276762000	22350	11175	15	0	\N
171691	1397	1306266761000	22350	11175	16	0	\N
171692	1397	1306256760000	22350	11175	17	0	\N
171693	1397	1306246759000	22350	11175	18	0	\N
171694	2133	94135706000	22350	11175	19	0	\N
171695	2133	94134704000	22350	11175	20	0	\N
171696	2134	86843819000	22350	11175	21	0	\N
171697	2134	86842816000	22350	11175	22	0	\N
171698	2134	86841813000	22350	11175	23	0	\N
171699	2134	86840810000	22350	11175	24	0	\N
171700	2134	86839807000	22350	11175	25	0	\N
171701	2134	86838804000	22350	11175	26	0	\N
171702	2134	86837801000	22350	11175	27	0	\N
171703	2134	86836798000	22350	11175	28	0	\N
171704	2134	86835795000	22350	11175	29	0	\N
171705	2134	86834792000	22350	11175	30	0	\N
171706	2134	86833789000	22350	11175	31	0	\N
171707	2134	86832786000	22350	11175	32	0	\N
171708	2134	86831783000	22350	11175	33	0	\N
171709	2132	147948950000	22350	11175	34	0	\N
171710	2132	147947949000	22350	11175	35	0	\N
171711	2132	147946948000	22350	11175	36	0	\N
171712	2132	147945947000	22350	11175	37	0	\N
171713	2132	147944946000	22350	11175	38	0	\N
171714	2132	147943945000	22350	11175	39	0	\N
171715	2134	86830780000	22350	11175	40	0	\N
171716	2134	86829777000	22350	11175	41	0	\N
171717	2134	86828774000	22350	11175	42	0	\N
171718	2134	86827771000	22350	11175	43	0	\N
171719	2134	86826768000	22350	11175	44	0	\N
171720	2134	86825765000	22350	11175	45	0	\N
171721	2134	86824762000	22350	11175	46	0	\N
171722	2133	94133702000	22350	11175	47	0	\N
171723	2133	94132700000	22350	11175	48	0	\N
171724	2133	94131698000	22350	11175	49	0	\N
171725	2133	94130696000	22350	11175	50	0	\N
171726	2133	94129694000	22350	11175	51	0	\N
171727	2133	94128692000	22350	11175	52	0	\N
171728	2133	94127690000	22350	11175	53	0	\N
171729	2133	94126688000	22350	11175	54	0	\N
171730	2133	94125686000	22350	11175	55	0	\N
171731	2133	94124684000	22350	11175	56	0	\N
171732	2133	94123682000	22350	11175	57	0	\N
171733	2133	94122680000	22350	11175	58	0	\N
171734	2133	94121678000	22350	11175	59	0	\N
171735	2133	94120676000	22350	11175	60	0	\N
171736	2133	94119674000	22350	11175	61	0	\N
171737	2133	94118672000	22350	11175	62	0	\N
171738	2133	94117670000	22350	11175	63	0	\N
171746	1555	15296924474753	22354	11162	0	0	\N
171747	1555	12683290483409	22354	11162	1	0	\N
171748	1555	10919816296305	22354	11162	2	0	\N
171749	1555	6005756540449	22354	11162	3	0	\N
171750	1657	15284551990100	22354	11162	4	0	\N
171751	733	2000074000000	22354	11162	5	0	\N
171752	1657	11705990990100	22354	11162	6	0	\N
171753	1657	9291459990100	22354	11162	7	0	\N
171754	1657	2563168990100	22354	11162	8	0	\N
171755	1657	1441167990100	22354	11162	9	0	\N
171756	1397	1306216756000	22355	11190	0	0	\N
171757	2134	86821753000	22355	11190	1	0	\N
171758	2133	94114664000	22355	11190	2	0	\N
171759	1397	1306216756000	22356	11190	0	0	\N
171760	2134	86821753000	22356	11190	1	0	\N
171761	2133	94114664000	22356	11190	2	0	\N
171765	1397	1306216756000	22358	11190	0	0	\N
171766	2134	86821753000	22358	11190	1	0	\N
171767	2133	94114664000	22358	11190	2	0	\N
171635	1397	1306296764000	22342	11183	2	0	13253
171636	2133	94124684000	22342	11183	3	0	3659
171637	2132	147944946000	22342	11183	4	0	1054
171638	2133	94123682000	22342	11183	5	0	3660
171639	2133	94122680000	22342	11183	6	0	3661
171641	1397	1306276762000	22343	11184	1	0	13255
171642	2133	94121678000	22343	11184	2	0	3662
171643	2133	94120676000	22343	11184	3	0	3663
171644	2134	86830780000	22343	11184	4	0	3748
171645	2134	86829777000	22343	11184	5	0	3749
171656	1397	1306266761000	22345	11185	0	0	13256
171657	2133	94119674000	22345	11185	1	0	3664
171658	2134	86827771000	22345	11185	2	0	3751
171659	2134	86826768000	22345	11185	3	0	3752
171669	1397	1306256760000	22348	11186	0	0	13257
171670	2133	94118672000	22348	11186	1	0	3665
171671	2132	147943945000	22348	11186	2	0	1055
171672	2134	86824762000	22348	11186	3	0	3754
171673	1397	1306246759000	22349	11187	0	0	13258
171739	1397	1306236758000	22351	11188	0	0	13259
171740	2133	94116668000	22351	11188	1	0	3667
171741	2134	86823759000	22351	11188	2	0	3755
171742	1397	1306226757000	22353	11189	0	0	13260
171743	2134	86822756000	22353	11189	1	0	3756
171745	2133	94115666000	22353	11189	3	0	3668
171762	1397	1306216756000	22357	11190	0	0	13261
171763	2134	86821753000	22357	11190	1	0	3757
171764	2133	94114664000	22357	11190	2	0	3669
171771	1397	1306196754000	22360	11192	0	0	\N
171772	2134	86819747000	22360	11192	1	0	\N
171773	2132	147941943000	22360	11192	3	0	\N
171774	2133	94112660000	22360	11192	4	0	\N
171775	1397	1306196754000	22361	11192	0	0	\N
171776	2134	86819747000	22361	11192	1	0	\N
171777	2132	147941943000	22361	11192	3	0	\N
171778	2133	94112660000	22361	11192	4	0	\N
171796	1397	1306156750000	22365	11194	0	0	\N
171797	2133	94108652000	22365	11194	1	0	\N
171798	2134	86815735000	22365	11194	2	0	\N
171799	2132	147940942000	22365	11194	3	0	\N
171810	1397	1306136748000	22368	11196	0	0	\N
171811	1397	1306126747000	22368	11196	1	0	\N
171812	2134	86813729000	22368	11196	2	0	\N
171813	2132	147939941000	22368	11196	3	0	\N
171814	2134	86812726000	22368	11196	4	0	\N
171815	2133	94106648000	22368	11196	5	0	\N
171816	2133	94105646000	22368	11196	6	0	\N
171817	1397	1306136748000	22369	11196	0	0	\N
171818	1397	1306126747000	22369	11196	1	0	\N
171819	2134	86813729000	22369	11196	2	0	\N
171820	2132	147939941000	22369	11196	3	0	\N
171821	2134	86812726000	22369	11196	4	0	\N
171822	2133	94106648000	22369	11196	5	0	\N
171823	2133	94105646000	22369	11196	6	0	\N
171824	1397	1306136748000	22370	11196	0	0	\N
171825	1397	1306126747000	22370	11196	1	0	\N
171826	2134	86813729000	22370	11196	2	0	\N
171827	2132	147939941000	22370	11196	3	0	\N
171828	2134	86812726000	22370	11196	4	0	\N
171829	2133	94106648000	22370	11196	5	0	\N
171830	2133	94105646000	22370	11196	6	0	\N
171852	1397	1306066741000	22376	11201	0	0	\N
171853	1397	1306056740000	22376	11201	1	0	\N
171854	2134	86807711000	22376	11201	2	0	\N
171855	2132	147937939000	22376	11201	3	0	\N
171856	2134	86806708000	22376	11201	4	0	\N
171857	2133	94100636000	22376	11201	5	0	\N
171858	2133	94099634000	22376	11201	6	0	\N
171872	1397	1306016736000	22380	11204	0	0	\N
171873	2133	94095626000	22380	11204	1	0	\N
171874	2134	86802696000	22380	11204	2	0	\N
171879	1560	5768587131803	22382	11163	0	0	\N
171887	1397	1305976732000	22385	11208	0	0	\N
171888	2134	86798684000	22385	11208	1	0	\N
171889	2133	94091618000	22385	11208	2	0	\N
171893	1397	1305976732000	22387	11208	0	0	\N
171894	2134	86798684000	22387	11208	1	0	\N
171895	2133	94091618000	22387	11208	2	0	\N
171896	1397	1306216756000	22388	11190	0	0	\N
171897	1397	1306206755000	22388	11190	1	0	\N
171898	1397	1306196754000	22388	11190	2	0	\N
171899	1397	1306186753000	22388	11190	3	0	\N
171900	1397	1306176752000	22388	11190	4	0	\N
171901	1397	1306166751000	22388	11190	5	0	\N
171902	1397	1306156750000	22388	11190	6	0	\N
171903	1397	1306146749000	22388	11190	7	0	\N
171904	1397	1306136748000	22388	11190	8	0	\N
171779	1397	1306196754000	22362	11192	0	0	13263
171780	2134	86819747000	22362	11192	1	0	3759
171781	2132	147941943000	22362	11192	3	0	1057
171782	2133	94112660000	22362	11192	4	0	3671
171783	1397	1306186753000	22363	11193	0	0	13264
171785	1397	1306166751000	22363	11193	2	0	13266
171786	2134	86818744000	22363	11193	3	0	3760
171787	2134	86817741000	22363	11193	4	0	3761
171788	2134	86816738000	22363	11193	5	0	3762
171789	2133	94111658000	22363	11193	6	0	3672
171791	2133	94109654000	22363	11193	8	0	3674
171792	1397	1306156750000	22364	11194	0	0	13267
171793	2133	94108652000	22364	11194	1	0	3675
171794	2134	86815735000	22364	11194	2	0	3763
171800	1397	1306146749000	22366	11195	0	0	13268
171801	2133	94107650000	22366	11195	1	0	3676
171802	2134	86814732000	22366	11195	2	0	3764
171803	1397	1306136748000	22367	11196	0	0	13269
171804	1397	1306126747000	22367	11196	1	0	13270
171806	2132	147939941000	22367	11196	3	0	1059
171807	2134	86812726000	22367	11196	4	0	3766
171808	2133	94106648000	22367	11196	5	0	3677
171809	2133	94105646000	22367	11196	6	0	3678
171831	1397	1306116746000	22371	11197	0	0	13271
171833	2133	94104644000	22372	11198	1	0	3679
171834	2134	86811723000	22372	11198	2	0	3767
171835	1397	1306096744000	22373	11199	0	0	13273
171836	1397	1306086743000	22373	11199	1	0	13274
171838	2132	147938940000	22373	11199	3	0	1060
171839	2134	86810720000	22373	11199	4	0	3768
171840	2134	86809717000	22373	11199	5	0	3769
171841	2133	94102640000	22373	11199	6	0	3681
171842	1397	1306076742000	22374	11200	0	0	13275
171844	2134	86808714000	22374	11200	2	0	3770
171845	1397	1306066741000	22375	11201	0	0	13276
171846	1397	1306056740000	22375	11201	1	0	13277
171847	2134	86807711000	22375	11201	2	0	3771
171848	2132	147937939000	22375	11201	3	0	1061
171850	2133	94100636000	22375	11201	5	0	3683
171851	2133	94099634000	22375	11201	6	0	3684
171859	1397	1306046739000	22377	11202	0	0	13278
171860	1397	1306036738000	22377	11202	1	0	13279
171862	2133	94098632000	22377	11202	3	0	3685
171863	2133	94097630000	22377	11202	4	0	3686
171864	2134	86804702000	22377	11202	5	0	3774
171865	1397	1306026737000	22378	11203	0	0	13280
171866	2132	147936938000	22378	11203	1	0	1062
171868	2133	94096628000	22378	11203	3	0	3687
171869	1397	1306016736000	22379	11204	0	0	13281
171870	2133	94095626000	22379	11204	1	0	3688
171871	2134	86802696000	22379	11204	2	0	3776
171875	1397	1306006735000	22381	11205	0	0	13282
171877	2133	94094624000	22381	11205	2	0	3689
171878	2134	86801693000	22381	11205	3	0	3777
171880	1397	1305996734000	22383	11206	0	0	13283
171881	2132	147935937000	22383	11206	1	0	1063
171883	2134	86800690000	22383	11206	3	0	3778
171884	1397	1305986733000	22384	11207	0	0	13284
171885	2133	94092620000	22384	11207	1	0	3691
171886	2134	86799687000	22384	11207	2	0	3779
171890	1397	1305976732000	22386	11208	0	0	13285
171892	2133	94091618000	22386	11208	2	0	3692
171905	1397	1306126747000	22388	11190	9	0	\N
171906	1397	1306116746000	22388	11190	10	0	\N
171907	1397	1306106745000	22388	11190	11	0	\N
171908	1397	1306096744000	22388	11190	13	0	\N
171909	1397	1306086743000	22388	11190	14	0	\N
171910	1397	1306076742000	22388	11190	15	0	\N
171911	1397	1306066741000	22388	11190	16	0	\N
171912	1397	1306056740000	22388	11190	17	0	\N
171913	1397	1306046739000	22388	11190	18	0	\N
171914	1397	1306036738000	22388	11190	19	0	\N
171915	1397	1306026737000	22388	11190	20	0	\N
171916	1397	1306016736000	22388	11190	21	0	\N
171917	1397	1306006735000	22388	11190	22	0	\N
171918	1397	1305996734000	22388	11190	23	0	\N
171919	1397	1305986733000	22388	11190	24	0	\N
171920	1397	1305976732000	22388	11190	25	0	\N
171921	2134	86821753000	22388	11190	26	0	\N
171922	1560	5768587131803	22388	11190	27	0	\N
171923	2134	86820750000	22388	11190	28	0	\N
171924	2134	86819747000	22388	11190	29	0	\N
171925	2134	86818744000	22388	11190	30	0	\N
171926	2134	86817741000	22388	11190	31	0	\N
171927	2132	147941943000	22388	11190	32	0	\N
171928	2134	86816738000	22388	11190	33	0	\N
171929	2134	86815735000	22388	11190	34	0	\N
171930	2132	147940942000	22388	11190	35	0	\N
171931	2134	86814732000	22388	11190	36	0	\N
171932	2134	86813729000	22388	11190	37	0	\N
171933	2132	147939941000	22388	11190	38	0	\N
171934	2132	147938940000	22388	11190	39	0	\N
171935	2134	86812726000	22388	11190	40	0	\N
171936	2134	86811723000	22388	11190	41	0	\N
171937	2134	86810720000	22388	11190	42	0	\N
171938	2134	86809717000	22388	11190	43	0	\N
171939	2133	94114664000	22388	11190	44	0	\N
171940	2133	94113662000	22388	11190	45	0	\N
171941	2133	94112660000	22388	11190	46	0	\N
171942	2133	94111658000	22388	11190	47	0	\N
171943	2133	94110656000	22388	11190	48	0	\N
171944	2133	94109654000	22388	11190	49	0	\N
171945	2133	94108652000	22388	11190	50	0	\N
171946	2133	94107650000	22388	11190	51	0	\N
171947	2134	86808714000	22388	11190	52	0	\N
171948	2134	86807711000	22388	11190	53	0	\N
171949	2132	147937939000	22388	11190	54	0	\N
171950	2132	147936938000	22388	11190	55	0	\N
171951	2132	147935937000	22388	11190	56	0	\N
171952	2133	94106648000	22388	11190	57	0	\N
171953	2133	94105646000	22388	11190	58	0	\N
171954	2133	94104644000	22388	11190	59	0	\N
171955	2133	94103642000	22388	11190	60	0	\N
171956	2134	86806708000	22388	11190	61	0	\N
171957	2134	86805705000	22388	11190	62	0	\N
171958	2134	86804702000	22388	11190	63	0	\N
171959	2134	86803699000	22388	11190	64	0	\N
171960	2134	86802696000	22388	11190	65	0	\N
171961	2134	86801693000	22388	11190	66	0	\N
171962	2134	86800690000	22388	11190	67	0	\N
171963	2134	86799687000	22388	11190	68	0	\N
171964	2134	86798684000	22388	11190	69	0	\N
171965	2133	94102640000	22388	11190	70	0	\N
171966	2133	94101638000	22388	11190	71	0	\N
171967	2133	94100636000	22388	11190	72	0	\N
171968	2133	94099634000	22388	11190	73	0	\N
171969	2133	94098632000	22388	11190	74	0	\N
171970	2133	94097630000	22388	11190	75	0	\N
171971	2133	94096628000	22388	11190	76	0	\N
171972	2133	94095626000	22388	11190	77	0	\N
171973	2133	94094624000	22388	11190	78	0	\N
171974	2133	94093622000	22388	11190	79	0	\N
171975	2133	94092620000	22388	11190	80	0	\N
171976	2133	94091618000	22388	11190	81	0	\N
171977	1397	1305966731000	22389	11209	0	0	\N
171978	2134	86797681000	22389	11209	1	0	\N
171979	2133	94090616000	22389	11209	2	0	\N
171980	1397	1305966731000	22390	11209	0	0	\N
171981	2134	86797681000	22390	11209	1	0	\N
171982	2133	94090616000	22390	11209	2	0	\N
171990	1397	1305956730000	22393	11210	0	0	\N
171991	2132	147934936000	22393	11210	1	0	\N
171992	2134	86796678000	22393	11210	2	0	\N
171993	2133	94089614000	22393	11210	3	0	\N
172004	1397	1305916726000	22397	11214	0	0	\N
172005	1397	1305906725000	22397	11214	1	0	\N
172006	2133	94085606000	22397	11214	2	0	\N
172007	2133	94084604000	22397	11214	3	0	\N
172008	2134	86792666000	22397	11214	4	0	\N
172009	2134	86791663000	22397	11214	5	0	\N
172010	1397	1305916726000	22398	11214	0	0	\N
172011	1397	1305906725000	22398	11214	1	0	\N
172012	2133	94085606000	22398	11214	2	0	\N
172013	2133	94084604000	22398	11214	3	0	\N
172014	2134	86792666000	22398	11214	4	0	\N
172015	2134	86791663000	22398	11214	5	0	\N
172016	1397	1305916726000	22400	11214	0	0	\N
172017	1397	1305906725000	22400	11214	1	0	\N
172018	2133	94085606000	22400	11214	2	0	\N
172019	2133	94084604000	22400	11214	3	0	\N
172020	2134	86792666000	22400	11214	4	0	\N
172021	2134	86791663000	22400	11214	5	0	\N
172028	1397	1305896724000	22402	11215	0	0	\N
172029	1397	1305886723000	22402	11215	1	0	\N
172030	2133	94083602000	22402	11215	2	0	\N
172031	2132	147932934000	22402	11215	3	0	\N
172032	2134	86790660000	22402	11215	4	0	\N
172033	2134	86789657000	22402	11215	5	0	\N
172034	2133	94082600000	22402	11215	6	0	\N
171985	2133	94090616000	22391	11209	2	0	3693
171986	1397	1305956730000	22392	11210	0	0	13287
171987	2132	147934936000	22392	11210	1	0	1064
171988	2134	86796678000	22392	11210	2	0	3782
171989	2133	94089614000	22392	11210	3	0	3694
171995	2133	94088612000	22394	11211	1	0	3695
171996	2134	86795675000	22394	11211	2	0	3783
171997	1397	1305936728000	22395	11212	0	0	13289
171998	2133	94087610000	22395	11212	1	0	3696
171999	2134	86794672000	22395	11212	2	0	3784
172001	2134	86793669000	22396	11213	1	0	3785
172002	2133	94086608000	22396	11213	2	0	3697
172003	2132	147933935000	22396	11213	3	0	1065
172022	1397	1305916726000	22401	11214	0	0	13291
172024	2133	94085606000	22401	11214	2	0	3698
172025	2133	94084604000	22401	11214	3	0	3699
172026	2134	86792666000	22401	11214	4	0	3786
172027	2134	86791663000	22401	11214	5	0	3787
172035	1397	1305896724000	22403	11215	0	0	13293
172037	2133	94083602000	22403	11215	2	0	3700
172038	2132	147932934000	22403	11215	3	0	1066
172039	2134	86790660000	22403	11215	4	0	3788
172040	2134	86789657000	22403	11215	5	0	3789
172042	1397	1305966731000	22404	11191	0	0	\N
172043	1397	1305956730000	22404	11191	1	0	\N
172044	1397	1305946729000	22404	11191	2	0	\N
172045	1397	1305936728000	22404	11191	3	0	\N
172046	1397	1305926727000	22404	11191	4	0	\N
172047	1397	1305916726000	22404	11191	5	0	\N
172048	1397	1305906725000	22404	11191	6	0	\N
172049	1397	1305896724000	22404	11191	7	0	\N
172050	2132	147934936000	22404	11191	8	0	\N
172051	2134	86797681000	22404	11191	9	0	\N
172052	2134	86796678000	22404	11191	10	0	\N
172053	2133	94090616000	22404	11191	11	0	\N
172054	2133	94089614000	22404	11191	12	0	\N
172055	2133	94088612000	22404	11191	13	0	\N
172056	2133	94087610000	22404	11191	14	0	\N
172057	2133	94086608000	22404	11191	15	0	\N
172058	2133	94085606000	22404	11191	16	0	\N
172059	2133	94084604000	22404	11191	17	0	\N
172060	2133	94083602000	22404	11191	18	0	\N
172061	2134	86795675000	22404	11191	19	0	\N
172062	2134	86794672000	22404	11191	20	0	\N
172063	2134	86793669000	22404	11191	21	0	\N
172064	2134	86792666000	22404	11191	22	0	\N
172065	2132	147933935000	22404	11191	23	0	\N
172066	2134	86791663000	22404	11191	24	0	\N
172067	2134	86790660000	22404	11191	25	0	\N
172070	1397	1305876722000	22406	11216	0	0	\N
172071	2133	94081598000	22406	11216	1	0	\N
172072	1397	1305866721000	22407	11217	0	0	\N
172073	2134	86788654000	22407	11217	1	0	\N
172074	1397	1305866721000	22408	11217	0	0	\N
172075	2133	94080596000	22408	11217	1	0	\N
172076	2134	86788654000	22408	11217	2	0	\N
172077	1397	1305866721000	22409	11217	0	0	\N
172078	2133	94080596000	22409	11217	1	0	\N
172079	2134	86788654000	22409	11217	2	0	\N
172083	1397	1305856720000	22411	11218	0	0	\N
172084	1397	1305846719000	22411	11218	1	0	\N
172085	1397	1305836718000	22411	11218	2	0	\N
172086	2132	147931933000	22411	11218	3	0	\N
172087	2133	94079594000	22411	11218	4	0	\N
172088	2133	94078592000	22411	11218	5	0	\N
172089	2133	94077590000	22411	11218	6	0	\N
172090	2134	86787651000	22411	11218	7	0	\N
172091	2134	86786648000	22411	11218	8	0	\N
172092	2134	86785645000	22411	11218	9	0	\N
172110	1397	1305806715000	22415	11221	0	0	\N
172111	2134	86782636000	22415	11221	1	0	\N
172112	1397	1305806715000	22416	11221	0	0	\N
172113	2133	94074584000	22416	11221	1	0	\N
172114	2134	86782636000	22416	11221	2	0	\N
172118	1397	1305856720000	22418	11218	0	0	\N
172119	1397	1305846719000	22418	11218	1	0	\N
172120	1397	1305836718000	22418	11218	2	0	\N
172121	1397	1305826717000	22418	11218	3	0	\N
172122	1397	1305816716000	22418	11218	4	0	\N
172123	1397	1305806715000	22418	11218	5	0	\N
172124	2132	147931933000	22418	11218	6	0	\N
172125	2133	94080596000	22418	11218	7	0	\N
172126	2132	147930932000	22418	11218	8	0	\N
172127	2133	94079594000	22418	11218	9	0	\N
172128	2134	86787651000	22418	11218	10	0	\N
172129	2134	86786648000	22418	11218	11	0	\N
172130	2134	86785645000	22418	11218	12	0	\N
172131	2134	86784642000	22418	11218	13	0	\N
172132	2134	86783639000	22418	11218	14	0	\N
172133	2134	86782636000	22418	11218	15	0	\N
172134	1397	1305796714000	22419	11222	0	0	\N
172135	2133	94073582000	22419	11222	1	0	\N
172138	1397	1305786713000	22421	11223	0	0	\N
172139	1397	1305776712000	22421	11223	1	0	\N
172140	2134	86781633000	22421	11223	2	0	\N
172141	2132	147929931000	22421	11223	3	0	\N
172142	2134	86780630000	22421	11223	4	0	\N
172143	2133	94072580000	22421	11223	5	0	\N
172144	2133	94071578000	22421	11223	6	0	\N
172145	1397	1305786713000	22422	11223	0	0	\N
172146	1397	1305776712000	22422	11223	1	0	\N
172147	2134	86781633000	22422	11223	2	0	\N
172148	2132	147929931000	22422	11223	3	0	\N
172149	2134	86780630000	22422	11223	4	0	\N
172150	1397	1305786713000	22423	11223	0	0	\N
172151	1397	1305776712000	22423	11223	1	0	\N
172152	2134	86781633000	22423	11223	2	0	\N
172153	2132	147929931000	22423	11223	3	0	\N
172154	2134	86780630000	22423	11223	4	0	\N
172155	2133	94072580000	22423	11223	5	0	\N
172156	2133	94071578000	22423	11223	6	0	\N
172174	1397	1305746709000	22429	11225	0	0	\N
172175	2134	86777621000	22429	11225	1	0	\N
172176	2133	94068572000	22429	11225	2	0	\N
172069	2133	94081598000	22405	11216	1	0	3702
172080	1397	1305866721000	22410	11217	0	0	13296
172081	2133	94080596000	22410	11217	1	0	3703
172082	2134	86788654000	22410	11217	2	0	3790
172093	1397	1305856720000	22412	11218	0	0	13297
172095	1397	1305836718000	22412	11218	2	0	13299
172096	2132	147931933000	22412	11218	3	0	1067
172097	2133	94079594000	22412	11218	4	0	3704
172098	2133	94078592000	22412	11218	5	0	3705
172099	2133	94077590000	22412	11218	6	0	3706
172101	2134	86786648000	22412	11218	8	0	3792
172102	2134	86785645000	22412	11218	9	0	3793
172103	1397	1305826717000	22413	11219	0	0	13300
172104	2133	94076588000	22413	11219	1	0	3707
172106	2132	147930932000	22413	11219	3	0	1068
172107	1397	1305816716000	22414	11220	0	0	13301
172108	2134	86783639000	22414	11220	1	0	3795
172109	2133	94075586000	22414	11220	2	0	3708
172115	1397	1305806715000	22417	11221	0	0	13302
172117	2134	86782636000	22417	11221	2	0	3796
172136	1397	1305796714000	22420	11222	0	0	13303
172137	2133	94073582000	22420	11222	1	0	3710
172157	1397	1305786713000	22424	11223	0	0	13304
172158	1397	1305776712000	22424	11223	1	0	13305
172160	2132	147929931000	22424	11223	3	0	1069
172161	2134	86780630000	22424	11223	4	0	3798
172162	2133	94072580000	22424	11223	5	0	3711
172163	2133	94071578000	22424	11223	6	0	3712
172165	1397	1305756710000	22426	11224	1	0	13307
172166	2132	147928930000	22426	11224	2	0	1070
172167	2133	94070576000	22426	11224	3	0	3713
172168	2133	94069574000	22426	11224	4	0	3714
172169	2134	86779627000	22426	11224	5	0	3799
172171	1397	1305746709000	22428	11225	0	0	13308
172172	2134	86777621000	22428	11225	1	0	3801
172173	2133	94068572000	22428	11225	2	0	3715
172188	1397	1305716706000	22433	11228	0	0	\N
172189	2133	94065566000	22433	11228	1	0	\N
172190	1673	32293199000000	22433	11228	2	0	\N
172191	2134	86774612000	22433	11228	3	0	\N
172192	1397	1305716706000	22434	11228	0	0	\N
172193	2133	94065566000	22434	11228	1	0	\N
172194	1673	32293199000000	22434	11228	2	0	\N
172195	2134	86774612000	22434	11228	3	0	\N
172196	1397	1306236758000	22435	11176	0	0	\N
172197	1397	1306226757000	22435	11176	1	0	\N
172198	1397	1306216756000	22435	11176	2	0	\N
172199	1397	1306206755000	22435	11176	3	0	\N
172200	1397	1306196754000	22435	11176	4	0	\N
172201	1397	1306186753000	22435	11176	5	0	\N
172202	1397	1306176752000	22435	11176	6	0	\N
172203	1397	1306166751000	22435	11176	7	0	\N
172204	1397	1306156750000	22435	11176	8	0	\N
172205	1397	1306146749000	22435	11176	9	0	\N
172206	1397	1306136748000	22435	11176	10	0	\N
172207	1397	1306126747000	22435	11176	11	0	\N
172211	1555	12683290483409	22437	11147	0	0	\N
172212	1555	10919816296305	22437	11147	1	0	\N
172213	1555	6005756540449	22437	11147	2	0	\N
172214	1397	1306556790000	22437	11147	3	0	\N
172215	1397	1306546789000	22437	11147	4	0	\N
172216	1397	1306536788000	22437	11147	5	0	\N
172217	1397	1306526787000	22437	11147	6	0	\N
172218	1397	1306516786000	22437	11147	7	0	\N
172219	1397	1306506785000	22437	11147	8	0	\N
172220	1397	1306496784000	22437	11147	9	0	\N
172221	1397	1306486783000	22437	11147	10	0	\N
172222	1397	1306476782000	22437	11147	11	0	\N
172223	1397	1306466781000	22437	11147	12	0	\N
172224	1397	1306456780000	22437	11147	13	0	\N
172225	1397	1306446779000	22437	11147	14	0	\N
172226	1397	1306436778000	22437	11147	15	0	\N
172227	1397	1306426777000	22437	11147	16	0	\N
172228	1397	1306416776000	22437	11147	17	0	\N
172229	1397	1306406775000	22437	11147	18	0	\N
172230	1397	1306396774000	22437	11147	19	0	\N
172231	1397	1306386773000	22437	11147	20	0	\N
172232	1397	1306376772000	22437	11147	21	0	\N
172233	1397	1306366771000	22437	11147	22	0	\N
172234	1397	1306356770000	22437	11147	23	0	\N
172235	1397	1306346769000	22437	11147	24	0	\N
172236	1397	1306336768000	22437	11147	25	0	\N
172237	1397	1306326767000	22437	11147	26	0	\N
172238	1397	1306316766000	22437	11147	27	0	\N
172239	1397	1306306765000	22437	11147	28	0	\N
172240	1397	1306296764000	22437	11147	29	0	\N
172241	1397	1306286763000	22437	11147	30	0	\N
172242	1397	1306276762000	22437	11147	31	0	\N
172243	1397	1306266761000	22437	11147	32	0	\N
172244	1397	1306256760000	22437	11147	33	0	\N
172245	1397	1306246759000	22437	11147	34	0	\N
172246	1397	1306236758000	22437	11147	35	0	\N
172247	1397	1306226757000	22437	11147	36	0	\N
172248	1397	1306216756000	22437	11147	37	0	\N
172249	1397	1306206755000	22437	11147	38	0	\N
172250	1397	1306196754000	22437	11147	39	0	\N
172251	1397	1306186753000	22437	11147	40	0	\N
172252	1397	1306176752000	22437	11147	41	0	\N
172253	1397	1306166751000	22437	11147	42	0	\N
172254	1397	1306156750000	22437	11147	43	0	\N
172255	1397	1306146749000	22437	11147	44	0	\N
172256	1397	1306136748000	22437	11147	45	0	\N
172257	1397	1306126747000	22437	11147	46	0	\N
172258	1397	1306116746000	22437	11147	47	0	\N
172259	1397	1306106745000	22437	11147	48	0	\N
172260	1397	1306096744000	22437	11147	49	0	\N
172261	1397	1306086743000	22437	11147	50	0	\N
172262	1397	1306076742000	22437	11147	51	0	\N
172263	1397	1306066741000	22437	11147	52	0	\N
172264	1397	1306056740000	22437	11147	53	0	\N
172265	1397	1306046739000	22437	11147	54	0	\N
172266	1397	1306036738000	22437	11147	55	0	\N
172267	1397	1306026737000	22437	11147	56	0	\N
172268	1397	1306016736000	22437	11147	57	0	\N
172269	1397	1306006735000	22437	11147	58	0	\N
172270	1397	1305996734000	22437	11147	59	0	\N
172271	1397	1305986733000	22437	11147	60	0	\N
172272	1397	1305976732000	22437	11147	61	0	\N
172273	1397	1305966731000	22437	11147	62	0	\N
172274	1397	1305956730000	22437	11147	63	0	\N
172275	1397	1305946729000	22437	11147	64	0	\N
172276	1397	1305936728000	22437	11147	65	0	\N
172277	1397	1305926727000	22437	11147	66	0	\N
172278	1397	1305916726000	22437	11147	67	0	\N
172279	1397	1305906725000	22437	11147	68	0	\N
172280	1397	1305896724000	22437	11147	69	0	\N
172281	1397	1305886723000	22437	11147	70	0	\N
172282	1397	1305876722000	22437	11147	71	0	\N
172283	1397	1305866721000	22437	11147	72	0	\N
172284	1397	1305856720000	22437	11147	73	0	\N
172285	1397	1305846719000	22437	11147	74	0	\N
172286	1397	1305836718000	22437	11147	75	0	\N
172287	1397	1305826717000	22437	11147	76	0	\N
172288	1397	1305816716000	22437	11147	77	0	\N
172289	1397	1305806715000	22437	11147	78	0	\N
172290	1397	1305796714000	22437	11147	79	0	\N
172291	1397	1305786713000	22437	11147	80	0	\N
172292	1397	1305776712000	22437	11147	81	0	\N
172293	1397	1305766711000	22437	11147	82	0	\N
172294	1397	1305756710000	22437	11147	83	0	\N
172295	1397	1305746709000	22437	11147	84	0	\N
172296	1397	1305736708000	22437	11147	85	0	\N
172297	1397	1305726707000	22437	11147	86	0	\N
172298	1397	1305716706000	22437	11147	87	0	\N
172299	1397	1305706705000	22437	11147	88	0	\N
172300	1560	5768587131803	22437	11147	89	0	\N
172301	2132	147952954000	22437	11147	90	0	\N
172302	1657	15284551990100	22437	11147	91	0	\N
172303	2134	86854852000	22437	11147	92	0	\N
172304	733	2000074000000	22437	11147	94	0	\N
172305	2134	86853849000	22437	11147	95	0	\N
172306	2134	86852846000	22437	11147	96	0	\N
172307	2134	86851843000	22437	11147	97	0	\N
172308	2134	86850840000	22437	11147	98	0	\N
172309	2134	86849837000	22437	11147	99	0	\N
172310	2132	147951953000	22437	11147	100	0	\N
172311	2132	147950952000	22437	11147	101	0	\N
172312	2132	147949951000	22437	11147	102	0	\N
172179	2133	94067570000	22430	11226	2	0	3716
172180	1397	1305726707000	22431	11227	0	0	13310
172181	2134	86775615000	22431	11227	1	0	3803
172182	2132	147927929000	22431	11227	2	0	1071
172183	2133	94066568000	22431	11227	3	0	3717
172185	2133	94065566000	22432	11228	1	0	3718
172186	1673	32293199000000	22432	11228	2	0	11
172187	2134	86774612000	22432	11228	3	0	3804
172208	1397	1305706705000	22436	11229	0	0	13312
172209	2134	86773609000	22436	11229	1	0	3805
172313	2134	86848834000	22437	11147	103	0	\N
172314	2133	94148732000	22437	11147	104	0	\N
172315	2133	94147730000	22437	11147	105	0	\N
172316	2133	94146728000	22437	11147	106	0	\N
172317	2133	94145726000	22437	11147	107	0	\N
172318	1657	11705990990100	22437	11147	108	0	\N
172319	1657	9291459990100	22437	11147	109	0	\N
172320	1657	2563168990100	22437	11147	110	0	\N
172321	2134	86847831000	22437	11147	111	0	\N
172322	2134	86846828000	22437	11147	112	0	\N
172323	2134	86845825000	22437	11147	113	0	\N
172324	2134	86844822000	22437	11147	114	0	\N
172325	2134	86843819000	22437	11147	115	0	\N
172326	2134	86842816000	22437	11147	116	0	\N
172327	2134	86841813000	22437	11147	117	0	\N
172328	2134	86840810000	22437	11147	118	0	\N
172329	2134	86839807000	22437	11147	119	0	\N
172330	2134	86838804000	22437	11147	120	0	\N
172331	2134	86837801000	22437	11147	121	0	\N
172332	2134	86836798000	22437	11147	122	0	\N
172333	2134	86835795000	22437	11147	123	0	\N
172334	2134	86834792000	22437	11147	124	0	\N
172335	2134	86833789000	22437	11147	125	0	\N
172336	1397	1305696704000	22438	11230	0	0	\N
172337	1397	1305686703000	22438	11230	1	0	\N
172338	1673	31860688000000	22438	11230	2	0	\N
172339	2132	147926928000	22438	11230	3	0	\N
172340	2133	94063562000	22438	11230	4	0	\N
172341	2133	94062560000	22438	11230	5	0	\N
172342	2134	86772606000	22438	11230	6	0	\N
172343	2134	86771603000	22438	11230	7	0	\N
172352	1397	1305966731000	22440	11209	0	0	\N
172353	1397	1305956730000	22440	11209	1	0	\N
172354	1397	1305946729000	22440	11209	2	0	\N
172355	1397	1305936728000	22440	11209	3	0	\N
172356	1397	1305926727000	22440	11209	4	0	\N
172357	1397	1305916726000	22440	11209	5	0	\N
172358	1397	1305906725000	22440	11209	6	0	\N
172359	1397	1305896724000	22440	11209	7	0	\N
172360	1397	1305886723000	22440	11209	8	0	\N
172361	1397	1305876722000	22440	11209	9	0	\N
172362	1397	1305866721000	22440	11209	10	0	\N
172363	1397	1305856720000	22440	11209	11	0	\N
172364	1397	1305846719000	22440	11209	12	0	\N
172365	1397	1305836718000	22440	11209	13	0	\N
172366	1397	1305826717000	22440	11209	14	0	\N
172367	1397	1305816716000	22440	11209	15	0	\N
172368	1397	1305806715000	22440	11209	16	0	\N
172369	1397	1305796714000	22440	11209	17	0	\N
172370	1397	1305786713000	22440	11209	18	0	\N
172371	1397	1305776712000	22440	11209	19	0	\N
172372	1397	1305766711000	22440	11209	21	0	\N
172373	1397	1305756710000	22440	11209	22	0	\N
172374	1397	1305746709000	22440	11209	23	0	\N
172375	1397	1305736708000	22440	11209	24	0	\N
172376	1397	1305726707000	22440	11209	25	0	\N
172377	1397	1305716706000	22440	11209	26	0	\N
172378	1397	1305706705000	22440	11209	27	0	\N
172379	1397	1305696704000	22440	11209	28	0	\N
172380	1397	1305686703000	22440	11209	29	0	\N
172381	2132	147934936000	22440	11209	30	0	\N
172382	2134	86797681000	22440	11209	31	0	\N
172383	2134	86796678000	22440	11209	32	0	\N
172384	2133	94090616000	22440	11209	33	0	\N
172385	2133	94089614000	22440	11209	34	0	\N
172386	2133	94088612000	22440	11209	35	0	\N
172387	2133	94087610000	22440	11209	36	0	\N
172388	2133	94086608000	22440	11209	37	0	\N
172389	2133	94085606000	22440	11209	38	0	\N
172390	2133	94084604000	22440	11209	39	0	\N
172391	2133	94083602000	22440	11209	40	0	\N
172392	2133	94082600000	22440	11209	41	0	\N
172393	2133	94081598000	22440	11209	42	0	\N
172394	2133	94080596000	22440	11209	43	0	\N
172395	2134	86795675000	22440	11209	44	0	\N
172396	2134	86794672000	22440	11209	45	0	\N
172397	2134	86793669000	22440	11209	46	0	\N
172398	2134	86792666000	22440	11209	47	0	\N
172399	2133	94079594000	22440	11209	48	0	\N
172400	2133	94078592000	22440	11209	49	0	\N
172401	2133	94077590000	22440	11209	50	0	\N
172402	2133	94076588000	22440	11209	51	0	\N
172403	2133	94075586000	22440	11209	52	0	\N
172404	2133	94074584000	22440	11209	53	0	\N
172405	2133	94073582000	22440	11209	54	0	\N
172406	2132	147933935000	22440	11209	55	0	\N
172407	2132	147932934000	22440	11209	56	0	\N
172408	2132	147931933000	22440	11209	57	0	\N
172409	2132	147930932000	22440	11209	58	0	\N
172410	2132	147929931000	22440	11209	59	0	\N
172411	2132	147928930000	22440	11209	60	0	\N
172412	2132	147927929000	22440	11209	61	0	\N
172413	2132	147926928000	22440	11209	62	0	\N
172414	1673	32293199000000	22440	11209	63	0	\N
172415	1673	31860688000000	22440	11209	64	0	\N
172416	2133	94072580000	22440	11209	65	0	\N
172417	2133	94071578000	22440	11209	66	0	\N
172418	2133	94070576000	22440	11209	67	0	\N
172419	2133	94069574000	22440	11209	68	0	\N
172420	2133	94068572000	22440	11209	69	0	\N
172421	2133	94067570000	22440	11209	70	0	\N
172422	2133	94066568000	22440	11209	71	0	\N
172423	2133	94065566000	22440	11209	72	0	\N
172424	2133	94064564000	22440	11209	73	0	\N
172425	2133	94063562000	22440	11209	74	0	\N
172426	2133	94062560000	22440	11209	75	0	\N
172427	2134	86791663000	22440	11209	76	0	\N
172428	2134	86790660000	22440	11209	77	0	\N
172429	2134	86789657000	22440	11209	78	0	\N
172430	2134	86788654000	22440	11209	79	0	\N
172431	2134	86787651000	22440	11209	80	0	\N
172432	2134	86786648000	22440	11209	81	0	\N
172433	2134	86785645000	22440	11209	82	0	\N
172434	2134	86784642000	22440	11209	83	0	\N
172435	2134	86783639000	22440	11209	84	0	\N
172436	2134	86782636000	22440	11209	85	0	\N
172437	2134	86781633000	22440	11209	86	0	\N
172438	2134	86780630000	22440	11209	87	0	\N
172439	2134	86779627000	22440	11209	88	0	\N
172440	2134	86778624000	22440	11209	89	0	\N
172441	2134	86777621000	22440	11209	90	0	\N
172442	2134	86776618000	22440	11209	91	0	\N
172443	2134	86775615000	22440	11209	92	0	\N
172444	2134	86774612000	22440	11209	93	0	\N
172445	2134	86773609000	22440	11209	94	0	\N
172446	2134	86772606000	22440	11209	95	0	\N
172447	2134	86771603000	22440	11209	96	0	\N
172448	1397	1305676702000	22441	11231	0	0	\N
172346	1673	31860688000000	22439	11230	2	0	12
172347	2132	147926928000	22439	11230	3	0	1072
172348	2133	94063562000	22439	11230	4	0	3720
172349	2133	94062560000	22439	11230	5	0	3721
172350	2134	86772606000	22439	11230	6	0	3806
172449	2134	86770600000	22441	11231	1	0	\N
172450	1397	1305676702000	22442	11231	0	0	\N
172451	2134	86770600000	22442	11231	1	0	\N
172452	2133	94061558000	22442	11231	2	0	\N
172456	1397	1305666701000	22444	11232	0	0	\N
172457	2134	86769597000	22444	11232	1	0	\N
172458	2133	94060556000	22444	11232	2	0	\N
172466	1397	1305656700000	22447	11233	0	0	\N
172467	2134	86768594000	22447	11233	1	0	\N
172468	2132	147925927000	22447	11233	2	0	\N
172469	2133	94059554000	22447	11233	3	0	\N
172473	1397	1305646699000	22449	11234	0	0	\N
172474	2134	86767591000	22449	11234	1	0	\N
172475	2133	94058552000	22449	11234	2	0	\N
172476	1397	1305646699000	22450	11234	0	0	\N
172477	2134	86767591000	22450	11234	1	0	\N
172478	2133	94058552000	22450	11234	2	0	\N
172485	1397	1305616696000	22452	11236	0	0	\N
172486	2133	94055546000	22452	11236	1	0	\N
172487	2134	86765585000	22452	11236	2	0	\N
172488	1397	1305616696000	22453	11236	0	0	\N
172489	2133	94055546000	22453	11236	1	0	\N
172490	2134	86765585000	22453	11236	2	0	\N
172497	1397	1305606695000	22456	11237	0	0	\N
172498	2133	94055546000	22456	11237	1	0	\N
172499	2133	94054544000	22456	11237	2	0	\N
172500	2134	86764582000	22456	11237	3	0	\N
172501	1397	1305606695000	22457	11237	0	0	\N
172502	2133	94055546000	22457	11237	1	0	\N
172503	2133	94054544000	22457	11237	2	0	\N
172504	2134	86764582000	22457	11237	3	0	\N
172505	1397	1305596694000	22458	11238	0	0	\N
172506	2133	94053542000	22458	11238	1	0	\N
172507	2134	86763579000	22458	11238	2	0	\N
172511	1397	1305586693000	22460	11239	0	0	\N
172512	2134	86762576000	22460	11239	1	0	\N
172513	2132	147923925000	22460	11239	2	0	\N
172524	1397	1305566691000	22464	11241	0	0	\N
172525	2134	86760570000	22464	11241	1	0	\N
172526	2133	94050536000	22464	11241	2	0	\N
172531	1397	1305556690000	22466	11242	0	0	\N
172532	2133	94049534000	22466	11242	1	0	\N
172533	2132	147922924000	22466	11242	2	0	\N
172534	2134	86759567000	22466	11242	3	0	\N
172535	1555	15296924474753	22467	11093	0	0	\N
172536	1397	1306666801000	22467	11093	1	0	\N
172537	1397	1306656800000	22467	11093	2	0	\N
172538	1397	1306646799000	22467	11093	3	0	\N
172539	1397	1306636798000	22467	11093	4	0	\N
172540	1397	1306626797000	22467	11093	5	0	\N
172541	1397	1306616796000	22467	11093	6	0	\N
172542	1397	1306606795000	22467	11093	7	0	\N
172543	1397	1306596794000	22467	11093	8	0	\N
172544	1397	1306586793000	22467	11093	9	0	\N
172545	1397	1306576792000	22467	11093	10	0	\N
172546	1555	12683290483409	22467	11093	11	0	\N
172547	1397	1306566791000	22467	11093	12	0	\N
172548	1555	10919816296305	22467	11093	13	0	\N
172549	1555	6005756540449	22467	11093	14	0	\N
172550	1397	1306556790000	22467	11093	15	0	\N
172551	1397	1306546789000	22467	11093	16	0	\N
172552	1397	1306536788000	22467	11093	17	0	\N
172553	1397	1306526787000	22467	11093	18	0	\N
172554	1397	1306516786000	22467	11093	19	0	\N
172555	1397	1306506785000	22467	11093	20	0	\N
172556	1397	1306496784000	22467	11093	21	0	\N
172557	1397	1306486783000	22467	11093	22	0	\N
172558	1397	1306476782000	22467	11093	23	0	\N
172559	1397	1306466781000	22467	11093	24	0	\N
172560	1397	1306456780000	22467	11093	25	0	\N
172561	1397	1306446779000	22467	11093	26	0	\N
172562	1397	1306436778000	22467	11093	27	0	\N
172563	1397	1306426777000	22467	11093	28	0	\N
172564	1397	1306416776000	22467	11093	29	0	\N
172565	1397	1306406775000	22467	11093	30	0	\N
172566	1397	1306396774000	22467	11093	31	0	\N
172567	1397	1306386773000	22467	11093	32	0	\N
172568	1397	1306376772000	22467	11093	33	0	\N
172569	1397	1306366771000	22467	11093	34	0	\N
172570	1397	1306356770000	22467	11093	35	0	\N
172571	1397	1306346769000	22467	11093	36	0	\N
172572	1397	1306336768000	22467	11093	37	0	\N
172573	1397	1306326767000	22467	11093	38	0	\N
172574	1397	1306316766000	22467	11093	39	0	\N
172575	1397	1306306765000	22467	11093	40	0	\N
172576	1397	1306296764000	22467	11093	41	0	\N
172577	1397	1306286763000	22467	11093	42	0	\N
172578	1397	1306276762000	22467	11093	43	0	\N
172579	1397	1306266761000	22467	11093	44	0	\N
172580	1397	1306256760000	22467	11093	45	0	\N
172581	1397	1306246759000	22467	11093	46	0	\N
172582	1397	1306236758000	22467	11093	47	0	\N
172583	1397	1306226757000	22467	11093	48	0	\N
172584	1397	1306216756000	22467	11093	49	0	\N
172455	2133	94061558000	22443	11231	2	0	3722
172459	1397	1305666701000	22445	11232	0	0	13316
172460	2134	86769597000	22445	11232	1	0	3809
172461	2133	94060556000	22445	11232	2	0	3723
172462	1397	1305656700000	22446	11233	0	0	13317
172464	2132	147925927000	22446	11233	2	0	1073
172465	2133	94059554000	22446	11233	3	0	3724
172470	1397	1305646699000	22448	11234	0	0	13318
172471	2134	86767591000	22448	11234	1	0	3811
172472	2133	94058552000	22448	11234	2	0	3725
172480	1397	1305626697000	22451	11235	1	0	13320
172481	2134	86766588000	22451	11235	2	0	3812
172482	2133	94057550000	22451	11235	3	0	3726
172483	2133	94056548000	22451	11235	4	0	3727
172491	1397	1305616696000	22454	11236	0	0	13321
172492	2134	86765585000	22454	11236	1	0	3813
172493	1397	1305606695000	22455	11237	0	0	13322
172494	2133	94055546000	22455	11237	1	0	3728
172495	2133	94054544000	22455	11237	2	0	3729
172508	1397	1305596694000	22459	11238	0	0	13323
172509	2133	94053542000	22459	11238	1	0	3730
172510	2134	86763579000	22459	11238	2	0	3815
172514	1397	1305586693000	22461	11239	0	0	13324
172515	2133	94052540000	22461	11239	1	0	3731
172517	2132	147923925000	22461	11239	3	0	1075
172518	1397	1305576692000	22462	11240	0	0	13325
172519	2133	94051538000	22462	11240	1	0	3732
172520	2134	86761573000	22462	11240	2	0	3817
172522	2134	86760570000	22463	11241	1	0	3818
172523	2133	94050536000	22463	11241	2	0	3733
172527	1397	1305556690000	22465	11242	0	0	13327
172528	2133	94049534000	22465	11242	1	0	3734
172529	2132	147922924000	22465	11242	2	0	1076
172585	1397	1306206755000	22467	11093	50	0	\N
172586	1397	1306196754000	22467	11093	51	0	\N
172587	1397	1306186753000	22467	11093	52	0	\N
172588	1397	1306176752000	22467	11093	53	0	\N
172589	1397	1306166751000	22467	11093	54	0	\N
172590	1397	1306156750000	22467	11093	55	0	\N
172591	1397	1306146749000	22467	11093	56	0	\N
172592	1397	1306136748000	22467	11093	57	0	\N
172593	1397	1306126747000	22467	11093	58	0	\N
172594	1397	1306116746000	22467	11093	59	0	\N
172595	1397	1306106745000	22467	11093	60	0	\N
172596	1397	1306096744000	22467	11093	61	0	\N
172597	1397	1306086743000	22467	11093	62	0	\N
172598	1397	1306076742000	22467	11093	64	0	\N
172599	1397	1306066741000	22467	11093	65	0	\N
172600	1397	1306056740000	22467	11093	66	0	\N
172601	1397	1306046739000	22467	11093	67	0	\N
172602	1397	1306036738000	22467	11093	68	0	\N
172603	1397	1306026737000	22467	11093	69	0	\N
172604	1397	1306016736000	22467	11093	70	0	\N
172605	1397	1306006735000	22467	11093	71	0	\N
172606	1397	1305996734000	22467	11093	72	0	\N
172607	1397	1305986733000	22467	11093	73	0	\N
172608	1397	1305976732000	22467	11093	74	0	\N
172609	1397	1305966731000	22467	11093	75	0	\N
172610	1397	1305956730000	22467	11093	76	0	\N
172611	1397	1305946729000	22467	11093	77	0	\N
172612	1397	1305936728000	22467	11093	78	0	\N
172613	1397	1305926727000	22467	11093	79	0	\N
172614	1397	1305916726000	22467	11093	80	0	\N
172615	1397	1305906725000	22467	11093	81	0	\N
172616	1397	1305896724000	22467	11093	82	0	\N
172617	1397	1305886723000	22467	11093	83	0	\N
172618	1397	1305876722000	22467	11093	84	0	\N
172619	1397	1305866721000	22467	11093	85	0	\N
172620	1397	1305856720000	22467	11093	86	0	\N
172621	1397	1305846719000	22467	11093	87	0	\N
172622	1397	1305836718000	22467	11093	88	0	\N
172623	1397	1305826717000	22467	11093	89	0	\N
172624	1397	1305816716000	22467	11093	90	0	\N
172625	1397	1305806715000	22467	11093	91	0	\N
172626	1397	1305796714000	22467	11093	92	0	\N
172627	1397	1305786713000	22467	11093	93	0	\N
172628	1397	1305776712000	22467	11093	94	0	\N
172629	1397	1305766711000	22467	11093	95	0	\N
172630	1397	1305756710000	22467	11093	96	0	\N
172631	1397	1305746709000	22467	11093	97	0	\N
172632	1397	1305736708000	22467	11093	98	0	\N
172633	1397	1305726707000	22467	11093	99	0	\N
172634	1397	1305716706000	22467	11093	100	0	\N
172635	1397	1305706705000	22467	11093	101	0	\N
172636	1397	1305696704000	22467	11093	102	0	\N
172637	1397	1305686703000	22467	11093	103	0	\N
172638	1397	1305676702000	22467	11093	104	0	\N
172639	1397	1305666701000	22467	11093	105	0	\N
172640	1397	1305656700000	22467	11093	106	0	\N
172641	1397	1305646699000	22467	11093	107	0	\N
172642	1397	1305636698000	22467	11093	108	0	\N
172643	1397	1305626697000	22467	11093	109	0	\N
172644	1397	1305616696000	22467	11093	110	0	\N
172645	1397	1305606695000	22467	11093	111	0	\N
172646	1397	1305596694000	22467	11093	112	0	\N
172647	1397	1305586693000	22467	11093	113	0	\N
172648	1397	1305576692000	22467	11093	114	0	\N
172649	1397	1305566691000	22467	11093	115	0	\N
172650	1397	1305556690000	22467	11093	116	0	\N
172651	1560	5048535131803	22467	11093	117	0	\N
172652	1657	15284551990100	22467	11093	118	0	\N
172653	2132	147978980000	22467	11093	119	0	\N
172654	2132	147977979000	22467	11093	120	0	\N
172655	2132	147976978000	22467	11093	121	0	\N
172656	2132	147975977000	22467	11093	122	0	\N
172657	2132	147974976000	22467	11093	123	0	\N
172658	2132	147973975000	22467	11093	124	0	\N
172659	1657	11705990990100	22467	11093	125	0	\N
172660	1397	1305546689000	22468	11243	0	0	\N
172661	2134	86758564000	22468	11243	1	0	\N
172662	1397	1305546689000	22469	11243	0	0	\N
172663	2134	86758564000	22469	11243	1	0	\N
172664	2133	94048532000	22469	11243	2	0	\N
172675	1397	1305536688000	22472	11244	0	0	\N
172676	1397	1305526687000	22472	11244	1	0	\N
172677	2132	147921923000	22472	11244	2	0	\N
172678	2133	94047530000	22472	11244	3	0	\N
172679	2133	94046528000	22472	11244	4	0	\N
172680	2134	86757561000	22472	11244	5	0	\N
172681	2134	86756558000	22472	11244	6	0	\N
172701	1397	1305476682000	22476	11246	0	0	\N
172702	1693	10210650245940	22476	11246	1	0	\N
172703	1693	10159553583248	22476	11246	2	0	\N
172704	1693	10112804767742	22476	11246	3	0	\N
172705	2134	86751543000	22476	11246	4	0	\N
172706	2133	94041518000	22476	11246	5	0	\N
172707	1397	1305466681000	22477	11247	0	0	\N
172708	1693	10066055243367	22477	11247	1	0	\N
172709	1693	10014958580675	22477	11247	2	0	\N
172710	1693	9968209771540	22477	11247	3	0	\N
172711	1693	9917113108848	22477	11247	4	0	\N
172712	1693	9870364356368	22477	11247	5	0	\N
172713	1693	9503498553907	22477	11247	6	0	\N
172714	2134	86750540000	22477	11247	7	0	\N
172715	1397	1305466681000	22478	11247	0	0	\N
172716	1693	10066055243367	22478	11247	1	0	\N
172717	1693	10014958580675	22478	11247	2	0	\N
172718	1693	9968209771540	22478	11247	3	0	\N
172719	1693	9917113108848	22478	11247	4	0	\N
172720	1693	9870364356368	22478	11247	5	0	\N
172667	2133	94048532000	22470	11243	2	0	3735
172668	1397	1305536688000	22471	11244	0	0	13329
172669	1397	1305526687000	22471	11244	1	0	13330
172670	2132	147921923000	22471	11244	2	0	1077
172671	2133	94047530000	22471	11244	3	0	3736
172673	2134	86757561000	22471	11244	5	0	3821
172674	2134	86756558000	22471	11244	6	0	3822
172682	1397	1305516686000	22474	11245	0	0	13331
172683	1397	1305506685000	22474	11245	1	0	13332
172684	1397	1305496684000	22474	11245	2	0	13333
172686	2134	86755555000	22474	11245	4	0	3823
172687	2132	147920922000	22474	11245	5	0	1078
172688	2133	94045526000	22474	11245	6	0	3738
172689	2134	86754552000	22474	11245	7	0	3824
172691	2134	86752546000	22474	11245	9	0	3826
172692	2133	94044524000	22474	11245	10	0	3739
172693	2133	94043522000	22474	11245	11	0	3740
172694	2133	94042520000	22474	11245	12	0	3741
172695	1397	1305476682000	22475	11246	0	0	13335
172697	1693	10159553583248	22475	11246	2	0	982
172698	1693	10112804767742	22475	11246	3	0	983
172699	2134	86751543000	22475	11246	4	0	3827
172700	2133	94041518000	22475	11246	5	0	3742
172721	1693	9503498553907	22478	11247	6	0	\N
172722	2133	94040516000	22478	11247	7	0	\N
172723	2134	86750540000	22478	11247	8	0	\N
172741	1397	1305456680000	22481	11248	0	0	\N
172742	1693	9452401891215	22481	11248	1	0	\N
172743	1693	9401305228523	22481	11248	2	0	\N
172744	1693	9350208565831	22481	11248	3	0	\N
172745	1693	9346328364119	22481	11248	4	0	\N
172746	1693	9295231701427	22481	11248	5	0	\N
172747	2133	94039514000	22481	11248	6	0	\N
172748	2132	147919921000	22481	11248	7	0	\N
172767	1397	1305426677000	22484	11250	0	0	\N
172768	1693	8253552492418	22484	11250	1	0	\N
172769	1693	8206803683283	22484	11250	2	0	\N
172770	1693	8155707020591	22484	11250	3	0	\N
172771	1693	8104610357899	22484	11250	4	0	\N
172772	1693	8102474176971	22484	11250	5	0	\N
172773	1693	8051377514279	22484	11250	6	0	\N
172774	2134	86747531000	22484	11250	7	0	\N
172775	2132	147918920000	22484	11250	8	0	\N
172804	1397	1305416676000	22487	11251	0	0	\N
172805	1693	8000280851587	22487	11251	1	0	\N
172806	1693	7949184188895	22487	11251	2	0	\N
172807	1693	7478484273724	22487	11251	3	0	\N
172808	1693	7427387611032	22487	11251	4	0	\N
172809	1397	1305406675000	22487	11251	5	0	\N
172810	1693	7376290948340	22487	11251	6	0	\N
172811	1693	7325194285648	22487	11251	7	0	\N
172812	1693	7274097622956	22487	11251	8	0	\N
172813	1693	7272539542275	22487	11251	9	0	\N
172814	1693	7221442879583	22487	11251	10	0	\N
172815	1693	7170453163642	22487	11251	11	0	\N
172816	1693	7119356500950	22487	11251	12	0	\N
172817	1693	7068259838258	22487	11251	13	0	\N
172818	2134	86746528000	22487	11251	14	0	\N
172819	2134	86745525000	22487	11251	15	0	\N
172820	2133	94035506000	22487	11251	16	0	\N
172821	2133	94034504000	22487	11251	17	0	\N
172831	1397	1305386673000	22489	11253	0	0	\N
172832	1397	1305376672000	22489	11253	1	0	\N
172833	1693	6800824502383	22489	11253	2	0	\N
172834	2133	94032500000	22489	11253	3	0	\N
172835	2132	147917919000	22489	11253	4	0	\N
172836	2133	94031498000	22489	11253	5	0	\N
172837	2134	86743519000	22489	11253	6	0	\N
172838	2134	86742516000	22489	11253	7	0	\N
172839	1397	1305386673000	22490	11253	0	0	\N
172840	1397	1305376672000	22490	11253	1	0	\N
172841	1693	6800824502383	22490	11253	2	0	\N
172842	2132	147917919000	22490	11253	3	0	\N
172843	2134	86743519000	22490	11253	4	0	\N
172844	2134	86742516000	22490	11253	5	0	\N
172845	1397	1305386673000	22491	11253	0	0	\N
172846	1397	1305376672000	22491	11253	1	0	\N
172847	1693	6800824502383	22491	11253	2	0	\N
172848	2133	94032500000	22491	11253	3	0	\N
172849	2132	147917919000	22491	11253	4	0	\N
172850	2133	94031498000	22491	11253	5	0	\N
172851	2134	86743519000	22491	11253	6	0	\N
172852	2134	86742516000	22491	11253	7	0	\N
172853	1397	1305386673000	22492	11253	0	0	\N
172854	1397	1305376672000	22492	11253	1	0	\N
172855	1693	6800824502383	22492	11253	2	0	\N
172856	2133	94032500000	22492	11253	3	0	\N
172726	1693	10014958580675	22479	11247	2	0	985
172727	1693	9968209771540	22479	11247	3	0	986
172728	1693	9917113108848	22479	11247	4	0	987
172729	1693	9870364356368	22479	11247	5	0	988
172730	1693	9503498553907	22479	11247	6	0	989
172732	2134	86750540000	22479	11247	8	0	3828
172733	1397	1305456680000	22480	11248	0	0	13337
172734	1693	9452401891215	22480	11248	1	0	990
172735	1693	9401305228523	22480	11248	2	0	991
172736	1693	9350208565831	22480	11248	3	0	992
172738	1693	9295231701427	22480	11248	5	0	994
172739	2133	94039514000	22480	11248	6	0	3744
172740	2132	147919921000	22480	11248	7	0	1079
172749	1693	9244135038735	22482	11249	0	0	995
172751	1693	9146291712639	22482	11249	2	0	997
172752	1397	1305446679000	22482	11249	3	0	13338
172753	1693	9140863430240	22482	11249	4	0	998
172754	1693	9089766767548	22482	11249	5	0	999
172755	1693	9038670104856	22482	11249	6	0	1000
172757	1693	8847241097656	22482	11249	8	0	1002
172758	1693	8796144434964	22482	11249	9	0	1003
172759	1693	8745047772272	22482	11249	10	0	1004
172760	1693	8355745817802	22482	11249	11	0	1005
172761	1693	8304649155110	22482	11249	13	0	1006
172763	2133	94038512000	22482	11249	15	0	3745
172764	2133	94037510000	22482	11249	16	0	3746
172765	2134	86749537000	22482	11249	17	0	3829
172766	2134	86748534000	22482	11249	18	0	3830
172777	1693	8253552492418	22485	11250	1	0	1007
172778	1693	8206803683283	22485	11250	2	0	1008
172779	1693	8155707020591	22485	11250	3	0	1009
172780	1693	8104610357899	22485	11250	4	0	1010
172781	1693	8102474176971	22485	11250	5	0	1011
172783	2134	86747531000	22485	11250	7	0	3831
172784	2133	94036508000	22485	11250	8	0	3747
172785	2132	147918920000	22485	11250	9	0	1080
172786	1397	1305416676000	22486	11251	0	0	13341
172787	1693	8000280851587	22486	11251	1	0	1013
172789	1693	7478484273724	22486	11251	3	0	1015
172790	1693	7427387611032	22486	11251	4	0	1016
172791	1397	1305406675000	22486	11251	5	0	13342
172792	1693	7376290948340	22486	11251	6	0	1017
172794	1693	7274097622956	22486	11251	8	0	1019
172795	1693	7272539542275	22486	11251	9	0	1020
172796	1693	7221442879583	22486	11251	10	0	1021
172797	1693	7170453163642	22486	11251	11	0	1022
172798	1693	7119356500950	22486	11251	12	0	1023
172800	2134	86746528000	22486	11251	14	0	3832
172801	2134	86745525000	22486	11251	15	0	3833
172802	2133	94035506000	22486	11251	16	0	3748
172803	2133	94034504000	22486	11251	17	0	3749
172822	1397	1305396674000	22488	11252	0	0	13343
172824	1693	6970414083172	22488	11252	2	0	1026
172825	1693	6919317420480	22488	11252	3	0	1027
172826	1693	6868220757788	22488	11252	4	0	1028
172827	1693	6866792739669	22488	11252	5	0	1029
172829	2134	86744522000	22488	11252	7	0	3834
172830	2133	94033502000	22488	11252	8	0	3750
172857	2132	147917919000	22492	11253	4	0	\N
172858	2133	94031498000	22492	11253	5	0	\N
172859	2134	86743519000	22492	11253	6	0	\N
172860	2134	86742516000	22492	11253	7	0	\N
172861	1397	1305386673000	22493	11253	0	0	\N
172862	1397	1305376672000	22493	11253	1	0	\N
172863	1693	6800824502383	22493	11253	2	0	\N
172864	2133	94032500000	22493	11253	3	0	\N
172865	2132	147917919000	22493	11253	4	0	\N
172866	2133	94031498000	22493	11253	5	0	\N
172867	2134	86743519000	22493	11253	6	0	\N
172868	2134	86742516000	22493	11253	7	0	\N
172877	1397	1305366671000	22495	11254	0	0	\N
172878	1693	6754075693248	22495	11254	1	0	\N
172879	2133	94030496000	22495	11254	2	0	\N
172880	2134	86741513000	22495	11254	3	0	\N
172884	1397	1305366671000	22497	11254	0	0	\N
172885	1693	6754075693248	22497	11254	1	0	\N
172886	2133	94030496000	22497	11254	2	0	\N
172887	2134	86741513000	22497	11254	3	0	\N
172888	2133	94032500000	22498	11254	0	0	\N
172889	2133	94031498000	22498	11254	1	0	\N
172890	2133	94030496000	22498	11254	2	0	\N
172928	1397	1305326667000	22502	11256	0	0	\N
172929	1693	5613713117013	22502	11256	1	0	\N
172930	1693	5562616454321	22502	11256	2	0	\N
172931	1693	5515867708926	22502	11256	3	0	\N
172932	1693	5514441307150	22502	11256	4	0	\N
172933	1693	5463344644458	22502	11256	5	0	\N
172934	1693	5416593958696	22502	11256	6	0	\N
172935	2133	94026488000	22502	11256	7	0	\N
172936	2134	86738504000	22502	11256	8	0	\N
172954	1397	1305316666000	22505	11257	0	0	\N
172955	1397	1305306665000	22505	11257	1	0	\N
172956	1693	5365497296004	22505	11257	2	0	\N
172957	1693	5318748437302	22505	11257	3	0	\N
172958	1693	5267651774610	22505	11257	4	0	\N
172959	1693	5220902965475	22505	11257	5	0	\N
172960	1693	5169806302783	22505	11257	6	0	\N
172961	1693	5118709640091	22505	11257	7	0	\N
172962	1693	5067612977399	22505	11257	8	0	\N
172963	1693	5016516314707	22505	11257	9	0	\N
172964	1693	5012358154437	22505	11257	10	0	\N
172965	1693	4965609062043	22505	11257	11	0	\N
172966	1693	4914512399351	22505	11257	12	0	\N
172967	1693	3602883099317	22505	11257	13	0	\N
172968	2132	147915917000	22505	11257	14	0	\N
172969	2133	94025486000	22505	11257	15	0	\N
172970	2134	86737501000	22505	11257	16	0	\N
172971	2133	94024484000	22505	11257	17	0	\N
172972	2134	86736498000	22505	11257	18	0	\N
172974	1693	3551786436625	22507	11258	0	0	\N
172975	1397	1305296664000	22507	11258	2	0	\N
172976	1693	3528719370809	22507	11258	3	0	\N
172977	1693	3477622708117	22507	11258	4	0	\N
172978	1693	3426526045425	22507	11258	5	0	\N
172979	1693	3375429382733	22507	11258	6	0	\N
172980	1693	3371271222463	22507	11258	7	0	\N
172981	2134	86735495000	22507	11258	8	0	\N
172982	2133	94025486000	22507	11258	9	0	\N
172983	2133	94024484000	22507	11258	10	0	\N
172984	2133	94023482000	22507	11258	11	0	\N
172871	1693	6800824502383	22494	11253	2	0	1031
172872	2133	94032500000	22494	11253	3	0	3751
172873	2132	147917919000	22494	11253	4	0	1081
172874	2133	94031498000	22494	11253	5	0	3752
172875	2134	86743519000	22494	11253	6	0	3835
172881	1397	1305366671000	22496	11254	0	0	13346
172882	1693	6754075693248	22496	11254	1	0	1032
172883	2134	86741513000	22496	11254	2	0	3837
172891	1693	6702979030556	22499	11255	0	0	1033
172892	1397	1305356670000	22499	11255	1	0	13347
172894	1397	1305336668000	22499	11255	3	0	13349
172895	1693	6651882367864	22499	11255	4	0	1034
172896	1693	6600785705172	22499	11255	5	0	1035
172897	1693	6549689042480	22499	11255	6	0	1036
172899	1693	6451843359622	22499	11255	8	0	1038
172900	1693	6400746696930	22499	11255	9	0	1039
172901	1693	6349650034238	22499	11255	10	0	1040
172902	1693	6298553371546	22499	11255	11	0	1041
172903	1693	6251804556040	22499	11255	12	0	1042
172905	1693	5963204577472	22499	11255	14	0	1044
172906	1693	5912107914780	22499	11255	15	0	1045
172907	1693	5864848576916	22499	11255	16	0	1046
172908	1693	5818099767781	22499	11255	17	0	1047
172909	1693	5767003105089	22499	11255	18	0	1048
172911	1693	5664809779705	22499	11255	20	0	1050
172912	2134	86740510000	22499	11255	21	0	3838
172913	2134	86739507000	22499	11255	22	0	3839
172914	2133	94030496000	22499	11255	23	0	3753
172916	2133	94028492000	22499	11255	25	0	3755
172917	2133	94027490000	22499	11255	26	0	3756
172918	2132	147916918000	22499	11255	27	0	1082
172919	1397	1305326667000	22501	11256	0	0	13350
172920	1693	5613713117013	22501	11256	1	0	1051
172922	1693	5515867708926	22501	11256	3	0	1053
172923	1693	5514441307150	22501	11256	4	0	1054
172924	1693	5463344644458	22501	11256	5	0	1055
172925	1693	5416593958696	22501	11256	6	0	1056
172926	2133	94026488000	22501	11256	7	0	3757
172937	1397	1305316666000	22504	11257	0	0	13351
172938	1397	1305306665000	22504	11257	1	0	13352
172939	1693	5365497296004	22504	11257	2	0	1057
172940	1693	5318748437302	22504	11257	3	0	1058
172942	1693	5220902965475	22504	11257	5	0	1060
172943	1693	5169806302783	22504	11257	6	0	1061
172944	1693	5118709640091	22504	11257	7	0	1062
172945	1693	5067612977399	22504	11257	8	0	1063
172946	1693	5016516314707	22504	11257	9	0	1064
172948	1693	4965609062043	22504	11257	11	0	1066
172949	1693	4914512399351	22504	11257	12	0	1067
172950	1693	3602883099317	22504	11257	13	0	1068
172951	2132	147915917000	22504	11257	14	0	1083
172952	2134	86737501000	22504	11257	15	0	3841
172973	1693	3551786436625	22506	11258	0	0	1069
172985	1397	1305296664000	22508	11259	0	0	13353
172986	1397	1305286663000	22508	11259	1	0	13354
172987	1693	3528719370809	22508	11259	2	0	1070
172989	1693	3426526045425	22508	11259	4	0	1072
172990	1693	3375429382733	22508	11259	5	0	1073
172991	1693	3371271222463	22508	11259	6	0	1074
172992	1693	3320174559771	22508	11259	7	0	1075
173005	1397	1305296664000	22509	11259	0	0	\N
173006	1397	1305286663000	22509	11259	1	0	\N
173007	1693	3528719370809	22509	11259	2	0	\N
173008	1693	3477622708117	22509	11259	3	0	\N
173009	1693	3426526045425	22509	11259	4	0	\N
173010	1693	3375429382733	22509	11259	5	0	\N
173011	1693	3371271222463	22509	11259	6	0	\N
173012	1693	3320174559771	22509	11259	7	0	\N
173013	1693	3269077897079	22509	11259	8	0	\N
173014	1693	3217981234387	22509	11259	9	0	\N
173015	1693	3166884571695	22509	11259	10	0	\N
173016	1693	3120134133789	22509	11259	11	0	\N
173017	1693	3069037471097	22509	11259	12	0	\N
173018	2134	86735495000	22509	11259	13	0	\N
173019	2133	94025486000	22509	11259	14	0	\N
173020	2134	86734492000	22509	11259	15	0	\N
173021	2132	147914916000	22509	11259	16	0	\N
173022	2133	94024484000	22509	11259	17	0	\N
173023	2133	94023482000	22509	11259	18	0	\N
173024	2133	94022480000	22509	11259	19	0	\N
173029	1397	1305276662000	22511	11260	0	0	\N
173030	1693	3017940808405	22511	11260	1	0	\N
173031	2134	86733489000	22511	11260	2	0	\N
173032	2133	94021478000	22511	11260	3	0	\N
173036	1397	1305256660000	22514	11262	0	0	\N
173037	2132	147913915000	22514	11262	1	0	\N
173038	2133	94019474000	22514	11262	2	0	\N
173039	2134	86731483000	22514	11262	3	0	\N
173044	1397	1305256660000	22516	11262	0	0	\N
173045	2132	147913915000	22516	11262	1	0	\N
173046	2133	94019474000	22516	11262	2	0	\N
173047	2134	86731483000	22516	11262	3	0	\N
173063	1397	1305226657000	22519	11265	0	0	\N
173064	1693	2468920427964	22519	11265	1	0	\N
173065	1693	2417823765272	22519	11265	2	0	\N
173066	1693	2366727102580	22519	11265	3	0	\N
173067	1693	2319976664674	22519	11265	4	0	\N
173068	1693	2273227919279	22519	11265	5	0	\N
173069	1693	2035724603403	22519	11265	6	0	\N
173070	2133	94016468000	22519	11265	7	0	\N
173071	2134	86729477000	22519	11265	8	0	\N
173094	1397	1305216656000	22522	11266	0	0	\N
173095	1599	22896943603909	22522	11266	1	0	\N
173096	1599	18159740119598	22522	11266	2	0	\N
173097	1599	14963451280472	22522	11266	3	0	\N
173098	1599	6056726097983	22522	11266	4	0	\N
173099	1693	1984627940711	22522	11266	5	0	\N
173100	1693	1933531278019	22522	11266	6	0	\N
173101	1693	1931973197338	22522	11266	7	0	\N
173102	1693	1880876534646	22522	11266	8	0	\N
173103	1693	1879318453965	22522	11266	9	0	\N
173104	2132	147912914000	22522	11266	10	0	\N
173105	2134	86728474000	22522	11266	11	0	\N
173106	2133	94015466000	22522	11266	12	0	\N
173123	1397	1305176652000	22527	11270	0	0	\N
173124	1397	1305166651000	22527	11270	1	0	\N
173125	2133	94011458000	22527	11270	2	0	\N
173126	2134	86724462000	22527	11270	3	0	\N
173127	2133	94010456000	22527	11270	4	0	\N
173128	2134	86723459000	22527	11270	5	0	\N
172995	1693	3166884571695	22508	11259	10	0	1078
172996	1693	3120134133789	22508	11259	11	0	1079
172997	1693	3069037471097	22508	11259	12	0	1080
172998	2134	86735495000	22508	11259	13	0	3843
172999	2133	94025486000	22508	11259	14	0	3758
173001	2132	147914916000	22508	11259	16	0	1084
173002	2133	94024484000	22508	11259	17	0	3759
173003	2133	94023482000	22508	11259	18	0	3760
173004	2133	94022480000	22508	11259	19	0	3761
173025	1397	1305276662000	22510	11260	0	0	13355
173027	2134	86733489000	22510	11260	2	0	3845
173028	2133	94021478000	22510	11260	3	0	3762
173033	1397	1305266661000	22512	11261	0	0	13356
173034	2134	86732486000	22512	11261	1	0	3846
173040	1397	1305256660000	22515	11262	0	0	13357
173041	2132	147913915000	22515	11262	1	0	1085
173042	2133	94019474000	22515	11262	2	0	3764
173043	2134	86731483000	22515	11262	3	0	3847
173048	1397	1305246659000	22517	11263	0	0	13358
173050	1693	2915747483021	22517	11263	2	0	1083
173051	1693	2864650820329	22517	11263	3	0	1084
173052	1693	2817902011194	22517	11263	4	0	1085
173053	2133	94018472000	22517	11263	5	0	3765
173054	1397	1305236658000	22518	11264	0	0	13359
173056	1693	2720056603107	22518	11264	2	0	1087
173057	1693	2668959940415	22518	11264	3	0	1088
173058	1693	2617863277723	22518	11264	4	0	1089
173059	1693	2571113753348	22518	11264	5	0	1090
173061	2134	86730480000	22518	11264	7	0	3848
173062	2133	94017470000	22518	11264	8	0	3766
173072	1397	1305226657000	22520	11265	0	0	13360
173073	1693	2468920427964	22520	11265	1	0	1092
173074	1693	2417823765272	22520	11265	2	0	1093
173076	1693	2319976664674	22520	11265	4	0	1095
173077	1693	2273227919279	22520	11265	5	0	1096
173078	1693	2035724603403	22520	11265	6	0	1097
173079	2133	94016468000	22520	11265	7	0	3767
173080	2134	86729477000	22520	11265	8	0	3849
173082	1599	22896943603909	22521	11266	1	0	5
173083	1599	18159740119598	22521	11266	2	0	6
173084	1599	14963451280472	22521	11266	3	0	7
173085	1599	6056726097983	22521	11266	4	0	8
173087	1693	1933531278019	22521	11266	6	0	1099
173088	1693	1931973197338	22521	11266	7	0	1100
173089	1693	1880876534646	22521	11266	8	0	1101
173090	1693	1879318453965	22521	11266	9	0	1102
173091	2132	147912914000	22521	11266	10	0	1086
173093	2133	94015466000	22521	11266	12	0	3768
173107	1397	1305206655000	22523	11267	0	0	13362
173108	1693	1828221791273	22523	11267	1	0	1103
173109	1693	1777125128581	22523	11267	2	0	1104
173110	1693	1726028465889	22523	11267	3	0	1105
173112	1693	977313956228	22523	11267	5	0	1107
173113	1693	926217293536	22523	11267	6	0	1108
173114	2134	86727471000	22523	11267	7	0	3851
173115	2133	94014464000	22523	11267	8	0	3769
173117	2134	86726468000	22524	11268	1	0	3852
173118	2133	94013462000	22524	11268	2	0	3770
173119	1397	1305186653000	22525	11269	0	0	13364
173120	2132	147911913000	22525	11269	1	0	1087
173121	2134	86725465000	22525	11269	2	0	3853
173142	1397	1305156650000	22530	11271	0	0	\N
173143	1397	1305146649000	22530	11271	1	0	\N
173144	2132	147910912000	22530	11271	2	0	\N
173145	2133	94011458000	22530	11271	3	0	\N
173146	2134	86722456000	22530	11271	4	0	\N
173147	2134	86721453000	22530	11271	5	0	\N
173148	2133	94010456000	22530	11271	6	0	\N
173149	1397	1305156650000	22531	11271	0	0	\N
173150	1397	1305146649000	22531	11271	1	0	\N
173151	2132	147910912000	22531	11271	2	0	\N
173152	2133	94011458000	22531	11271	3	0	\N
173153	2134	86722456000	22531	11271	4	0	\N
173154	2134	86721453000	22531	11271	5	0	\N
173155	2133	94010456000	22531	11271	6	0	\N
173156	2133	94009454000	22531	11271	7	0	\N
173157	2133	94008452000	22531	11271	8	0	\N
173185	1397	1305076642000	22535	11275	0	0	\N
173186	2133	94001438000	22535	11275	1	0	\N
173187	2134	86714432000	22535	11275	2	0	\N
173191	1693	1398937612395	22537	11276	0	0	\N
173192	1397	1305066641000	22537	11276	1	0	\N
173193	1397	1305056640000	22537	11276	2	0	\N
173194	1397	1305046639000	22537	11276	3	0	\N
173195	1693	1396072292484	22537	11276	4	0	\N
173196	2134	86713429000	22537	11276	5	0	\N
173197	2134	86712426000	22537	11276	6	0	\N
173198	2134	86711423000	22537	11276	7	0	\N
173199	2132	147907909000	22537	11276	8	0	\N
173200	2133	94000436000	22537	11276	9	0	\N
173201	2133	93999434000	22537	11276	10	0	\N
173202	2133	93998432000	22537	11276	11	0	\N
173215	1397	1305036638000	22539	11277	0	0	\N
173216	2134	86710420000	22539	11277	1	0	\N
173217	2133	93997430000	22539	11277	2	0	\N
173221	1397	1305026637000	22541	11278	0	0	\N
173222	1397	1305026637000	22542	11278	0	0	\N
173223	2134	86709417000	22542	11278	1	0	\N
173224	2133	93996428000	22542	11278	2	0	\N
173225	1397	1305026637000	22543	11278	0	0	\N
173226	2134	86709417000	22543	11278	1	0	\N
173227	2133	93996428000	22543	11278	2	0	\N
173248	1397	1305006635000	22548	11280	0	0	\N
173249	1397	1304996634000	22548	11280	1	0	\N
173250	1397	1304986633000	22548	11280	2	0	\N
173251	1397	1304976632000	22548	11280	3	0	\N
173252	2134	86707411000	22548	11280	4	0	\N
173253	2134	86706408000	22548	11280	5	0	\N
173254	2133	93994424000	22548	11280	6	0	\N
173255	2133	93993422000	22548	11280	7	0	\N
173256	2133	93992420000	22548	11280	8	0	\N
173257	2133	93991418000	22548	11280	9	0	\N
173258	2132	147905907000	22548	11280	10	0	\N
173259	2134	86705405000	22548	11280	11	0	\N
173260	2134	86704402000	22548	11280	12	0	\N
173131	2134	86724462000	22528	11270	2	0	3854
173132	2134	86723459000	22528	11270	3	0	3855
173133	1397	1305156650000	22529	11271	0	0	13367
173134	1397	1305146649000	22529	11271	1	0	13368
173135	2132	147910912000	22529	11271	2	0	1088
173137	2134	86722456000	22529	11271	4	0	3856
173138	2134	86721453000	22529	11271	5	0	3857
173139	2133	94010456000	22529	11271	6	0	3773
173140	2133	94009454000	22529	11271	7	0	3774
173141	2133	94008452000	22529	11271	8	0	3775
173159	1397	1305126647000	22532	11272	1	0	13370
173160	2133	94007450000	22532	11272	2	0	3776
173161	2133	94006448000	22532	11272	4	0	3777
173162	2134	86720450000	22532	11272	5	0	3858
173164	1693	1599490548141	22533	11273	0	0	1109
173165	1693	1596625228230	22533	11273	1	0	1110
173166	1693	1595527611252	22533	11273	2	0	1111
173167	1693	1548778802117	22533	11273	3	0	1112
173168	1397	1305116646000	22533	11273	4	0	13371
173170	1693	1497682139425	22533	11273	6	0	1113
173171	1693	1450932756681	22533	11273	7	0	1114
173172	2132	147909911000	22533	11273	8	0	1089
173173	2134	86718444000	22533	11273	9	0	3860
173174	2134	86717441000	22533	11273	10	0	3861
173176	2133	94004444000	22533	11273	12	0	3779
173177	1693	1400035229373	22534	11274	0	0	1115
173178	1397	1305096644000	22534	11274	1	0	13373
173179	1397	1305086643000	22534	11274	2	0	13374
173181	2132	147908910000	22534	11274	4	0	1090
173182	2133	94002440000	22534	11274	5	0	3781
173183	2134	86716438000	22534	11274	6	0	3862
173184	2134	86715435000	22534	11274	7	0	3863
173188	1397	1305076642000	22536	11275	0	0	13375
173190	2134	86714432000	22536	11275	2	0	3864
173203	1693	1398937612395	22538	11276	0	0	1116
173204	1397	1305066641000	22538	11276	1	0	13376
173205	1397	1305056640000	22538	11276	2	0	13377
173206	1397	1305046639000	22538	11276	3	0	13378
173208	2134	86713429000	22538	11276	5	0	3865
173209	2134	86712426000	22538	11276	6	0	3866
173210	2134	86711423000	22538	11276	7	0	3867
173211	2132	147907909000	22538	11276	8	0	1091
173213	2133	93999434000	22538	11276	10	0	3784
173214	2133	93998432000	22538	11276	11	0	3785
173218	1397	1305036638000	22540	11277	0	0	13379
173219	2134	86710420000	22540	11277	1	0	3868
173220	2133	93997430000	22540	11277	2	0	3786
173229	2134	86709417000	22544	11278	1	0	3869
173230	1397	1305016636000	22545	11279	0	0	13381
173231	2132	147906908000	22545	11279	1	0	1092
173232	2133	93996428000	22545	11279	2	0	3787
173233	2134	86708414000	22545	11279	3	0	3870
173235	1397	1305006635000	22547	11280	0	0	13382
173236	1397	1304996634000	22547	11280	1	0	13383
173237	1397	1304986633000	22547	11280	2	0	13384
173238	1397	1304976632000	22547	11280	3	0	13385
173240	2134	86706408000	22547	11280	5	0	3872
173241	2133	93994424000	22547	11280	6	0	3789
173242	2133	93993422000	22547	11280	7	0	3790
173243	2133	93992420000	22547	11280	8	0	3791
173244	2133	93991418000	22547	11280	9	0	3792
173246	2134	86705405000	22547	11280	11	0	3873
173247	2134	86704402000	22547	11280	12	0	3874
173261	1397	1304966631000	22549	11281	0	0	13386
173262	2134	86703399000	22549	11281	1	0	3875
173263	2133	93990416000	22549	11281	2	0	3793
173268	1397	1304946629000	22551	11283	0	0	\N
173269	1397	1304936628000	22551	11283	1	0	\N
173270	2134	86701393000	22551	11283	2	0	\N
173271	2134	86700390000	22551	11283	3	0	\N
173272	2133	93988412000	22551	11283	4	0	\N
173273	2133	93987410000	22551	11283	5	0	\N
173283	1397	1304916626000	22555	11285	0	0	\N
173284	2133	93985406000	22555	11285	1	0	\N
173285	2134	86698384000	22555	11285	2	0	\N
173286	2132	147903905000	22555	11285	3	0	\N
173291	1397	1304906625000	22557	11286	0	0	\N
173292	2133	93984404000	22557	11286	1	0	\N
173293	2134	86697381000	22557	11286	2	0	\N
173294	1397	1304906625000	22558	11286	0	0	\N
173295	2133	93984404000	22558	11286	1	0	\N
173296	2134	86697381000	22558	11286	2	0	\N
173300	1397	1304906625000	22560	11286	0	0	\N
173301	2133	93984404000	22560	11286	1	0	\N
173302	2134	86697381000	22560	11286	2	0	\N
173311	1397	1304876622000	22562	11288	0	0	\N
173312	2134	86694372000	22562	11288	1	0	\N
173313	2133	93981398000	22562	11288	3	0	\N
173320	1397	1304866621000	22565	11289	0	0	\N
173321	2134	86693369000	22565	11289	1	0	\N
173322	2133	93980396000	22565	11289	2	0	\N
173323	1397	1304866621000	22566	11289	0	0	\N
173324	2134	86693369000	22566	11289	1	0	\N
173325	2133	93980396000	22566	11289	2	0	\N
173326	1397	1304856620000	22567	11290	0	0	\N
173327	1397	1304846619000	22567	11290	1	0	\N
173328	1397	1304836618000	22567	11290	2	0	\N
173329	2134	86692366000	22567	11290	3	0	\N
173330	845	573333333200000	22567	11290	4	0	\N
173331	2132	147901903000	22567	11290	5	0	\N
173332	2133	93979394000	22567	11290	6	0	\N
173333	2086	333300069	22567	11290	7	0	\N
173334	2087	1155375147766	22567	11290	8	0	\N
173335	2133	93978392000	22567	11290	9	0	\N
173336	2134	86691363000	22567	11290	10	0	\N
173337	2134	86690360000	22567	11290	11	0	\N
173353	1397	1304816616000	22570	11292	0	0	\N
173354	2133	93976388000	22570	11292	1	0	\N
173355	2132	147900902000	22570	11292	2	0	\N
173359	1397	1304816616000	22572	11292	0	0	\N
173360	2133	93976388000	22572	11292	1	0	\N
173361	2132	147900902000	22572	11292	2	0	\N
173372	1773	4697069091402	22574	11293	0	0	\N
173373	1397	1304806615000	22574	11293	1	0	\N
173374	1773	4641863250848	22574	11293	2	0	\N
173375	1773	4011885219274	22574	11293	3	0	\N
173376	1773	2882977904260	22574	11293	4	0	\N
173377	1773	2122525554495	22574	11293	5	0	\N
173378	1773	0	22574	11293	6	0	\N
173379	2133	93975386000	22574	11293	7	0	\N
173380	2134	86688354000	22574	11293	8	0	\N
173381	846	573333333200000	22574	11293	9	0	\N
173385	1773	4697069091402	22576	11293	0	0	\N
173386	1397	1304806615000	22576	11293	1	0	\N
173387	1773	4641863250848	22576	11293	2	0	\N
173388	1773	4011885219274	22576	11293	3	0	\N
173389	1773	2882977904260	22576	11293	4	0	\N
173390	1397	1304796614000	22576	11293	5	0	\N
173391	1397	1304786613000	22576	11293	6	0	\N
173392	1397	1304776612000	22576	11293	7	0	\N
173393	1773	2122525554495	22576	11293	8	0	\N
173394	1773	0	22576	11293	9	0	\N
173395	2134	86688354000	22576	11293	10	0	\N
173396	2134	86687351000	22576	11293	11	0	\N
173397	2134	86686348000	22576	11293	12	0	\N
173398	2134	86685345000	22576	11293	13	0	\N
173399	846	573333333200000	22576	11293	14	0	\N
173400	2132	147899901000	22576	11293	15	0	\N
173267	2134	86702396000	22550	11282	3	0	3876
173274	1397	1304946629000	22552	11283	0	0	13388
173275	1397	1304936628000	22552	11283	1	0	13389
173276	2134	86701393000	22552	11283	2	0	3877
173277	2134	86700390000	22552	11283	3	0	3878
173279	2133	93987410000	22552	11283	5	0	3796
173280	1397	1304926627000	22554	11284	0	0	13390
173281	2134	86699387000	22554	11284	1	0	3879
173282	2133	93986408000	22554	11284	2	0	3797
173287	1397	1304916626000	22556	11285	0	0	13391
173289	2134	86698384000	22556	11285	2	0	3880
173290	2132	147903905000	22556	11285	3	0	1095
173297	1397	1304906625000	22559	11286	0	0	13392
173298	2133	93984404000	22559	11286	1	0	3799
173303	1397	1304896624000	22561	11287	0	0	13393
173304	1397	1304886623000	22561	11287	1	0	13394
173305	2134	86696378000	22561	11287	2	0	3882
173306	845	576805118311139	22561	11287	3	0	1
173307	2134	86695375000	22561	11287	4	0	3883
173309	2133	93983402000	22561	11287	6	0	3800
173310	2133	93982400000	22561	11287	7	0	3801
173314	1397	1304876622000	22563	11288	0	0	13395
173315	2134	86694372000	22563	11288	1	0	3884
173316	2133	93981398000	22563	11288	3	0	3802
173318	2134	86693369000	22564	11289	1	0	3885
173319	2133	93980396000	22564	11289	2	0	3803
173338	1397	1304856620000	22568	11290	0	0	13397
173339	1397	1304846619000	22568	11290	1	0	13398
173341	2134	86692366000	22568	11290	3	0	3886
173342	845	573333333200000	22568	11290	4	0	2
173343	2132	147901903000	22568	11290	5	0	1097
173344	2133	93979394000	22568	11290	6	0	3804
173345	2086	333300069	22568	11290	7	0	3
173347	2133	93978392000	22568	11290	9	0	3805
173348	2134	86691363000	22568	11290	10	0	3887
173349	2134	86690360000	22568	11290	11	0	3888
173350	1397	1304826617000	22569	11291	0	0	13400
173351	2134	86689357000	22569	11291	1	0	3889
173356	1397	1304816616000	22571	11292	0	0	13401
173357	2133	93976388000	22571	11292	1	0	3807
173358	2132	147900902000	22571	11292	2	0	1098
173362	1773	4697069091402	22573	11293	0	0	37
173364	1773	4641863250848	22573	11293	2	0	38
173365	1773	4011885219274	22573	11293	3	0	39
173366	1773	2882977904260	22573	11293	4	0	40
173367	1773	2122525554495	22573	11293	5	0	41
173368	1773	0	22573	11293	6	0	42
173370	2134	86688354000	22573	11293	8	0	3890
173371	846	573333333200000	22573	11293	9	0	1
173382	1397	1304796614000	22575	11294	0	0	13403
173383	2133	93974384000	22575	11294	1	0	3809
173384	2134	86687351000	22575	11294	2	0	3891
173401	2297	6946568222278	22576	11293	16	0	\N
173402	1397	1304786613000	22577	11295	0	0	\N
173403	1397	1304776612000	22577	11295	1	0	\N
173404	1397	1304766611000	22577	11295	2	0	\N
173405	2134	86686348000	22577	11295	3	0	\N
173406	2134	86685345000	22577	11295	4	0	\N
173407	2134	86684342000	22577	11295	5	0	\N
173408	2132	147899901000	22577	11295	6	0	\N
173409	2133	93973382000	22577	11295	7	0	\N
173410	2133	93972380000	22577	11295	8	0	\N
173411	2133	93971378000	22577	11295	9	0	\N
173412	2297	6946568222278	22577	11295	10	0	\N
173433	1687	124932103402	22581	11210	0	0	\N
173434	1397	1305676702000	22581	11210	1	0	\N
173435	1397	1305666701000	22581	11210	2	0	\N
173436	1397	1305656700000	22581	11210	3	0	\N
173437	1397	1305646699000	22581	11210	4	0	\N
173438	1397	1305636698000	22581	11210	5	0	\N
173439	1397	1305626697000	22581	11210	6	0	\N
173440	1397	1305616696000	22581	11210	7	0	\N
173441	1397	1305606695000	22581	11210	8	0	\N
173442	1397	1305596694000	22581	11210	9	0	\N
173443	1397	1305586693000	22581	11210	10	0	\N
173444	1397	1305576692000	22581	11210	11	0	\N
173445	1397	1305566691000	22581	11210	12	0	\N
173446	1397	1305556690000	22581	11210	13	0	\N
173447	1397	1305546689000	22581	11210	14	0	\N
173448	1599	22896943603909	22581	11210	15	0	\N
173449	1599	18159740119598	22581	11210	16	0	\N
173450	1599	14963451280472	22581	11210	17	0	\N
173451	1599	6056726097983	22581	11210	18	0	\N
173452	1397	1305536688000	22581	11210	19	0	\N
173453	1397	1305526687000	22581	11210	20	0	\N
173454	1693	10210650245940	22581	11210	21	0	\N
173455	1693	10159553583248	22581	11210	22	0	\N
173456	1693	10112804767742	22581	11210	23	0	\N
173457	1693	10066055243367	22581	11210	24	0	\N
173458	1693	10014958580675	22581	11210	25	0	\N
173459	1693	9968209771540	22581	11210	26	0	\N
173460	1693	9917113108848	22581	11210	27	0	\N
173461	1693	9870364356368	22581	11210	28	0	\N
173462	1693	9503498553907	22581	11210	29	0	\N
173463	1693	9452401891215	22581	11210	30	0	\N
173464	1693	9401305228523	22581	11210	31	0	\N
173465	1693	9350208565831	22581	11210	32	0	\N
173466	1693	9346328364119	22581	11210	33	0	\N
173467	1693	9295231701427	22581	11210	34	0	\N
173468	1693	9244135038735	22581	11210	35	0	\N
173469	1693	9193040521774	22581	11210	36	0	\N
173470	1693	9146291712639	22581	11210	37	0	\N
173471	1693	9140863430240	22581	11210	38	0	\N
173472	1693	9089766767548	22581	11210	39	0	\N
173473	1693	9038670104856	22581	11210	40	0	\N
173474	1693	8987573442164	22581	11210	41	0	\N
173475	1693	8847241097656	22581	11210	42	0	\N
173476	1693	8796144434964	22581	11210	43	0	\N
173477	1693	8745047772272	22581	11210	44	0	\N
173478	1693	8355745817802	22581	11210	45	0	\N
173479	1693	8304649155110	22581	11210	46	0	\N
173480	1693	8253552492418	22581	11210	47	0	\N
173481	1693	8206803683283	22581	11210	48	0	\N
173482	1693	8155707020591	22581	11210	50	0	\N
173483	1693	8104610357899	22581	11210	51	0	\N
173484	1693	8102474176971	22581	11210	52	0	\N
173485	1693	8051377514279	22581	11210	53	0	\N
173486	1693	8000280851587	22581	11210	54	0	\N
173487	1693	7949184188895	22581	11210	55	0	\N
173488	1693	7478484273724	22581	11210	56	0	\N
173489	1693	7427387611032	22581	11210	57	0	\N
173490	1693	7376290948340	22581	11210	58	0	\N
173491	1693	7325194285648	22581	11210	59	0	\N
173492	1693	7274097622956	22581	11210	60	0	\N
173493	1693	7272539542275	22581	11210	61	0	\N
173494	1693	7221442879583	22581	11210	62	0	\N
173495	1693	7170453163642	22581	11210	63	0	\N
173496	1693	7119356500950	22581	11210	64	0	\N
173497	1693	7068259838258	22581	11210	65	0	\N
173498	1693	7017163175566	22581	11210	66	0	\N
173499	1693	6970414083172	22581	11210	67	0	\N
173500	1693	6919317420480	22581	11210	68	0	\N
173501	1693	6868220757788	22581	11210	69	0	\N
173502	1693	6866792739669	22581	11210	70	0	\N
173503	1693	6851921165075	22581	11210	71	0	\N
173504	1693	6800824502383	22581	11210	72	0	\N
173505	1693	6754075693248	22581	11210	73	0	\N
173506	1693	6702979030556	22581	11210	74	0	\N
173507	1693	6651882367864	22581	11210	75	0	\N
173508	1693	6600785705172	22581	11210	76	0	\N
173509	1693	6549689042480	22581	11210	77	0	\N
173510	1693	6498592379788	22581	11210	78	0	\N
173511	1693	6451843359622	22581	11210	79	0	\N
173512	1693	6400746696930	22581	11210	80	0	\N
173513	1693	6349650034238	22581	11210	81	0	\N
173514	1693	6298553371546	22581	11210	82	0	\N
173515	1693	6251804556040	22581	11210	83	0	\N
173516	1693	6014301240164	22581	11210	84	0	\N
173517	1693	5963204577472	22581	11210	85	0	\N
173518	1693	5912107914780	22581	11210	86	0	\N
173519	1693	5864848576916	22581	11210	87	0	\N
173520	1693	5818099767781	22581	11210	88	0	\N
173521	1693	5767003105089	22581	11210	89	0	\N
173522	1693	5715906442397	22581	11210	90	0	\N
173523	1693	5664809779705	22581	11210	91	0	\N
173524	1693	5613713117013	22581	11210	92	0	\N
173525	1693	5562616454321	22581	11210	93	0	\N
173526	1693	5515867708926	22581	11210	94	0	\N
173527	1693	5514441307150	22581	11210	95	0	\N
173528	1693	5463344644458	22581	11210	96	0	\N
173529	1693	5416593958696	22581	11210	97	0	\N
173530	1693	5365497296004	22581	11210	98	0	\N
173531	1397	1305516686000	22581	11210	99	0	\N
173532	1397	1305506685000	22581	11210	100	0	\N
173533	1397	1305496684000	22581	11210	101	0	\N
173534	1397	1305486683000	22581	11210	102	0	\N
173535	1397	1305476682000	22581	11210	103	0	\N
173536	1397	1305466681000	22581	11210	104	0	\N
173415	1397	1304766611000	22578	11295	2	0	13406
173416	2134	86686348000	22578	11295	3	0	3892
173417	2134	86685345000	22578	11295	4	0	3893
173418	2134	86684342000	22578	11295	5	0	3894
173419	2132	147899901000	22578	11295	6	0	1099
173421	2133	93972380000	22578	11295	8	0	3811
173422	2133	93971378000	22578	11295	9	0	3812
173423	2297	6946568222278	22578	11295	10	0	1
173424	1397	1304756610000	22579	11296	0	0	13407
173425	2132	147898900000	22579	11296	1	0	1100
173427	2298	136988601386	22579	11296	3	0	1
173428	2134	86683339000	22579	11296	4	0	3895
173429	1687	844971103402	22580	11297	0	0	7
173430	1397	1304746609000	22580	11297	1	0	13408
173432	2133	93969374000	22580	11297	3	0	3814
173537	1397	1305456680000	22581	11210	105	0	\N
173538	1397	1305446679000	22581	11210	106	0	\N
173539	1397	1305436678000	22581	11210	107	0	\N
173540	1397	1305426677000	22581	11210	108	0	\N
173541	1397	1305416676000	22581	11210	109	0	\N
173542	1397	1305406675000	22581	11210	110	0	\N
173543	1397	1305396674000	22581	11210	111	0	\N
173544	1397	1305386673000	22581	11210	112	0	\N
173545	1397	1305376672000	22581	11210	113	0	\N
173546	1397	1305366671000	22581	11210	114	0	\N
173547	1397	1305356670000	22581	11210	115	0	\N
173548	1397	1305346669000	22581	11210	116	0	\N
173549	1397	1305336668000	22581	11210	117	0	\N
173550	1397	1305326667000	22581	11210	118	0	\N
173551	1397	1305316666000	22581	11210	119	0	\N
173552	1397	1305306665000	22581	11210	120	0	\N
173553	1397	1305296664000	22581	11210	121	0	\N
173554	1397	1305286663000	22581	11210	122	0	\N
173555	1397	1305276662000	22581	11210	123	0	\N
173556	1397	1305266661000	22581	11210	124	0	\N
173557	1397	1305256660000	22581	11210	125	0	\N
173564	1866	11616105302973	22583	11299	0	0	\N
173565	1866	10498102594221	22583	11299	1	0	\N
173566	1866	8494730518328	22583	11299	2	0	\N
173567	1866	7142982930705	22583	11299	3	0	\N
173568	1866	3376396745986	22583	11299	4	0	\N
173569	1866	3372461001076	22583	11299	5	0	\N
173570	1397	1304726607000	22583	11299	6	0	\N
173571	2134	86680330000	22583	11299	7	0	\N
173572	2133	93967370000	22583	11299	8	0	\N
173573	1866	11616105302973	22584	11299	0	0	\N
173574	1866	10498102594221	22584	11299	1	0	\N
173575	1866	8494730518328	22584	11299	2	0	\N
173576	1866	7142982930705	22584	11299	3	0	\N
173577	1866	3376396745986	22584	11299	4	0	\N
173578	1866	3372461001076	22584	11299	5	0	\N
173579	1397	1304726607000	22584	11299	6	0	\N
173580	2134	86680330000	22584	11299	7	0	\N
173581	2133	93967370000	22584	11299	8	0	\N
173595	1397	1304716606000	22587	11300	0	0	\N
173596	2134	86679327000	22587	11300	1	0	\N
173597	2132	147897899000	22587	11300	2	0	\N
173598	2133	93966368000	22587	11300	3	0	\N
173621	1687	124932103402	22592	11271	0	0	\N
173622	1693	1599490548141	22592	11271	1	0	\N
173623	2246	2686411101924	22592	11271	2	0	\N
173624	1693	1596625228230	22592	11271	3	0	\N
173625	1693	1595527611252	22592	11271	4	0	\N
173626	1693	1548778802117	22592	11271	5	0	\N
173627	1693	1497682139425	22592	11271	6	0	\N
173628	1693	1450932756681	22592	11271	7	0	\N
173629	1693	1400035229373	22592	11271	8	0	\N
173630	1693	1398937612395	22592	11271	9	0	\N
173631	1693	1396072292484	22592	11271	10	0	\N
173632	845	576805118311139	22592	11271	11	0	\N
173633	845	573333333200000	22592	11271	12	0	\N
173634	846	573333333200000	22592	11271	13	0	\N
173635	2086	333300069	22592	11271	15	0	\N
173636	2087	1155375147766	22592	11271	16	0	\N
173641	1397	1304646599000	22594	11304	0	0	\N
173642	2246	2686411101924	22594	11304	1	0	\N
173643	2134	86671303000	22594	11304	2	0	\N
173644	2133	93958352000	22594	11304	3	0	\N
173645	1397	1304646599000	22595	11304	0	0	\N
173646	2246	2686411101924	22595	11304	1	0	\N
173647	1397	1304636598000	22595	11304	2	0	\N
173648	2134	86671303000	22595	11304	3	0	\N
173649	2133	93958352000	22595	11304	4	0	\N
173653	1397	1304636598000	22597	11305	0	0	\N
173654	2134	86670300000	22597	11305	1	0	\N
173655	2133	93957350000	22597	11305	2	0	\N
173671	1397	1304626597000	22599	11306	0	0	\N
173672	1397	1304616596000	22599	11306	1	0	\N
173560	1866	12823976094654	22582	11298	2	0	27
173561	1397	1304736608000	22582	11298	3	0	13409
173562	2133	93968372000	22582	11298	4	0	3815
173563	2134	86681333000	22582	11298	5	0	3897
173582	1866	11616105302973	22585	11299	0	0	28
173584	1866	8494730518328	22585	11299	2	0	30
173585	1866	7142982930705	22585	11299	3	0	31
173586	1866	3376396745986	22585	11299	4	0	32
173587	1866	3372461001076	22585	11299	5	0	33
173588	1397	1304726607000	22585	11299	6	0	13410
173590	2133	93967370000	22585	11299	8	0	3816
173591	1397	1304716606000	22586	11300	0	0	13411
173592	2134	86679327000	22586	11300	1	0	3899
173593	2132	147897899000	22586	11300	2	0	1101
173599	1397	1304706605000	22588	11301	0	0	13412
173600	2134	86678324000	22588	11301	1	0	3900
173601	2133	93965366000	22588	11301	2	0	3818
173602	1397	1304696604000	22589	11302	0	0	13413
173603	1397	1304686603000	22589	11302	1	0	13414
173605	1397	1304676602000	22591	11303	0	0	13415
173606	1397	1304666601000	22591	11303	1	0	13416
173607	1397	1304656600000	22591	11303	2	0	13417
173608	2133	93964364000	22591	11303	3	0	3819
173609	2132	147895897000	22591	11303	4	0	1103
173611	2133	93962360000	22591	11303	6	0	3821
173612	2133	93961358000	22591	11303	7	0	3822
173613	2133	93960356000	22591	11303	8	0	3823
173614	2133	93959354000	22591	11303	9	0	3824
173616	2134	86676318000	22591	11303	11	0	3902
173617	2134	86675315000	22591	11303	12	0	3903
173618	2134	86674312000	22591	11303	13	0	3904
173619	2134	86673309000	22591	11303	14	0	3905
173620	2134	86672306000	22591	11303	15	0	3906
173638	2246	2686411101924	22593	11304	1	0	2
173639	2134	86671303000	22593	11304	2	0	3907
173640	2133	93958352000	22593	11304	3	0	3825
173650	1397	1304636598000	22596	11305	0	0	13419
173651	2134	86670300000	22596	11305	1	0	3908
173656	1397	1304626597000	22598	11306	0	0	13420
173657	1397	1304616596000	22598	11306	1	0	13421
173658	1397	1304606595000	22598	11306	2	0	13422
173659	1397	1304596594000	22598	11306	3	0	13423
173661	2132	147894896000	22598	11306	5	0	1104
173662	2132	147893895000	22598	11306	6	0	1105
173663	2133	93956348000	22598	11306	7	0	3827
173664	2134	86669297000	22598	11306	8	0	3909
173665	2134	86668294000	22598	11306	9	0	3910
173667	2134	86666288000	22598	11306	11	0	3912
173668	2133	93955346000	22598	11306	12	0	3828
173669	2133	93954344000	22598	11306	13	0	3829
173670	2133	93953342000	22598	11306	14	0	3830
173673	1397	1304606595000	22599	11306	2	0	\N
173674	1397	1304596594000	22599	11306	3	0	\N
173675	2246	0	22599	11306	4	0	\N
173676	2132	147894896000	22599	11306	5	0	\N
173677	2132	147893895000	22599	11306	6	0	\N
173678	2133	93956348000	22599	11306	7	0	\N
173679	2134	86669297000	22599	11306	8	0	\N
173680	2134	86668294000	22599	11306	9	0	\N
173681	2134	86667291000	22599	11306	10	0	\N
173682	2134	86666288000	22599	11306	11	0	\N
173683	2133	93955346000	22599	11306	12	0	\N
173684	2133	93954344000	22599	11306	13	0	\N
173685	2133	93953342000	22599	11306	14	0	\N
173686	1397	1304626597000	22600	11306	0	0	\N
173687	1397	1304616596000	22600	11306	1	0	\N
173688	1397	1304606595000	22600	11306	2	0	\N
173689	1397	1304596594000	22600	11306	3	0	\N
173690	2246	0	22600	11306	4	0	\N
173691	2132	147894896000	22600	11306	5	0	\N
173692	2132	147893895000	22600	11306	6	0	\N
173693	2134	86669297000	22600	11306	7	0	\N
173694	2134	86668294000	22600	11306	8	0	\N
173695	2134	86667291000	22600	11306	9	0	\N
173696	2134	86666288000	22600	11306	10	0	\N
173701	1397	1304566591000	22602	11308	0	0	\N
173702	2134	86663279000	22602	11308	1	0	\N
173703	2132	147892894000	22602	11308	2	0	\N
173704	2133	93952340000	22602	11308	3	0	\N
173705	2133	93951338000	22602	11308	4	0	\N
173706	2133	93950336000	22602	11308	5	0	\N
173713	1397	1304556590000	22604	11309	0	0	\N
173714	2133	93949334000	22604	11309	1	0	\N
173717	1397	1304556590000	22606	11309	0	0	\N
173718	2133	93949334000	22606	11309	1	0	\N
173726	1397	1304546589000	22608	11310	0	0	\N
173727	1397	1304536588000	22608	11310	1	0	\N
173728	1397	1304526587000	22608	11310	2	0	\N
173729	2132	147891893000	22608	11310	3	0	\N
173730	2134	86662276000	22608	11310	4	0	\N
173731	2134	86661273000	22608	11310	5	0	\N
173732	2134	86660270000	22608	11310	6	0	\N
173733	2133	93948332000	22608	11310	7	0	\N
173734	2133	93947330000	22608	11310	8	0	\N
173735	2133	93946328000	22608	11310	9	0	\N
173736	1397	1304516586000	22609	11311	0	0	\N
173737	2134	86659267000	22609	11311	1	0	\N
173738	2133	93948332000	22609	11311	2	0	\N
173739	2133	93947330000	22609	11311	3	0	\N
173740	2133	93946328000	22609	11311	4	0	\N
173741	2133	93945326000	22609	11311	5	0	\N
173744	1397	1304516586000	22611	11311	0	0	\N
173745	2134	86659267000	22611	11311	1	0	\N
173746	1397	1304516586000	22612	11311	0	0	\N
173747	2134	86659267000	22612	11311	1	0	\N
173748	2133	93948332000	22612	11311	2	0	\N
173749	2133	93947330000	22612	11311	3	0	\N
173750	2133	93946328000	22612	11311	4	0	\N
173751	2133	93945326000	22612	11311	5	0	\N
173759	1397	1304506585000	22614	11312	0	0	\N
173760	2134	86658264000	22614	11312	1	0	\N
173761	2133	93948332000	22614	11312	2	0	\N
173762	2133	93947330000	22614	11312	3	0	\N
173763	2133	93946328000	22614	11312	4	0	\N
173764	2133	93945326000	22614	11312	5	0	\N
173765	2133	93944324000	22614	11312	6	0	\N
173766	1397	1304496584000	22615	11313	0	0	\N
173767	2132	147890892000	22615	11313	1	0	\N
173768	2133	93943322000	22615	11313	2	0	\N
173769	2134	86657261000	22615	11313	3	0	\N
173772	1397	1304496584000	22617	11313	0	0	\N
173773	2132	147890892000	22617	11313	1	0	\N
173774	2133	93943322000	22617	11313	2	0	\N
173775	2134	86657261000	22617	11313	3	0	\N
173776	1397	1304496584000	22618	11313	0	0	\N
173777	2132	147890892000	22618	11313	1	0	\N
173778	2134	86657261000	22618	11313	2	0	\N
173779	1397	1304496584000	22619	11313	0	0	\N
173780	2132	147890892000	22619	11313	1	0	\N
173781	2133	93943322000	22619	11313	2	0	\N
173782	2134	86657261000	22619	11313	3	0	\N
173783	1397	1304486583000	22620	11314	0	0	\N
173784	2133	93942320000	22620	11314	1	0	\N
173785	2134	86656258000	22620	11314	2	0	\N
173795	1397	1304466581000	22623	11316	0	0	\N
173796	2132	147889891000	22623	11316	1	0	\N
173797	2133	93940316000	22623	11316	2	0	\N
173798	2134	86654252000	22623	11316	3	0	\N
173803	1397	1304466581000	22625	11316	0	0	\N
173804	2132	147889891000	22625	11316	1	0	\N
173805	2133	93940316000	22625	11316	2	0	\N
173806	2134	86654252000	22625	11316	3	0	\N
173807	1397	1304466581000	22626	11316	0	0	\N
173808	2133	93940316000	22626	11316	1	0	\N
173699	2134	86665285000	22601	11307	2	0	3913
173700	2134	86664282000	22601	11307	3	0	3914
173707	1397	1304566591000	22603	11308	0	0	13426
173708	2134	86663279000	22603	11308	1	0	3915
173709	2132	147892894000	22603	11308	2	0	1106
173711	2133	93951338000	22603	11308	4	0	3832
173712	2133	93950336000	22603	11308	5	0	3833
173715	1397	1304556590000	22605	11309	0	0	13427
173716	2133	93949334000	22605	11309	1	0	3834
173719	1397	1304546589000	22607	11310	0	0	13428
173721	1397	1304526587000	22607	11310	2	0	13430
173722	2132	147891893000	22607	11310	3	0	1107
173723	2134	86662276000	22607	11310	4	0	3916
173724	2134	86661273000	22607	11310	5	0	3917
173742	1397	1304516586000	22610	11311	0	0	13431
173743	2134	86659267000	22610	11311	1	0	3919
173752	1397	1304506585000	22613	11312	0	0	13432
173753	2134	86658264000	22613	11312	1	0	3920
173754	2133	93948332000	22613	11312	2	0	3835
173756	2133	93946328000	22613	11312	4	0	3837
173757	2133	93945326000	22613	11312	5	0	3838
173758	2133	93944324000	22613	11312	6	0	3839
173770	2132	147890892000	22616	11313	0	0	1108
173771	2134	86657261000	22616	11313	1	0	3921
173787	1397	1304486583000	22621	11314	1	0	13434
173788	2133	93943322000	22621	11314	2	0	3840
173789	2133	93942320000	22621	11314	3	0	3841
173790	2134	86656258000	22621	11314	4	0	3922
173792	2112	12766623101924	22622	11315	1	0	7
173793	2133	93941318000	22622	11315	2	0	3842
173794	2134	86655255000	22622	11315	3	0	3923
173799	1397	1304466581000	22624	11316	0	0	13436
173800	2132	147889891000	22624	11316	1	0	1109
173802	2134	86654252000	22624	11316	3	0	3924
173809	2134	86654252000	22626	11316	2	0	\N
173816	1397	1304456580000	22628	11317	0	0	\N
173817	1397	1304446579000	22628	11317	1	0	\N
173818	2133	93939314000	22628	11317	2	0	\N
173819	2134	86653249000	22628	11317	3	0	\N
173820	2133	93938312000	22628	11317	4	0	\N
173821	2134	86652246000	22628	11317	5	0	\N
173829	1397	1304426577000	22631	11319	0	0	\N
173830	2134	86650240000	22631	11319	1	0	\N
173831	2133	93936308000	22631	11319	2	0	\N
173832	2132	147888890000	22631	11319	3	0	\N
173833	1397	1304426577000	22632	11319	0	0	\N
173834	2134	86650240000	22632	11319	1	0	\N
173835	2133	93936308000	22632	11319	2	0	\N
173836	2132	147888890000	22632	11319	3	0	\N
173837	1397	1304426577000	22633	11319	0	0	\N
173838	2134	86650240000	22633	11319	1	0	\N
173839	2133	93936308000	22633	11319	2	0	\N
173840	2132	147888890000	22633	11319	3	0	\N
173841	1397	1304416576000	22634	11320	0	0	\N
173842	1397	1304406575000	22634	11320	1	0	\N
173843	2134	86649237000	22634	11320	2	0	\N
173844	2133	93935306000	22634	11320	3	0	\N
173845	2133	93934304000	22634	11320	4	0	\N
173846	2134	86648234000	22634	11320	5	0	\N
173847	1397	1304416576000	22635	11320	0	0	\N
173848	1397	1304406575000	22635	11320	1	0	\N
173849	2134	86649237000	22635	11320	2	0	\N
173850	2133	93935306000	22635	11320	3	0	\N
173851	2133	93934304000	22635	11320	4	0	\N
173852	2134	86648234000	22635	11320	5	0	\N
173859	1397	1304396574000	22637	11321	0	0	\N
173860	2133	93933302000	22637	11321	1	0	\N
173861	2134	86647231000	22637	11321	2	0	\N
173862	2132	147887889000	22637	11321	3	0	\N
173867	1397	1304396574000	22639	11321	0	0	\N
173868	2133	93933302000	22639	11321	1	0	\N
173869	2134	86647231000	22639	11321	2	0	\N
173870	2132	147887889000	22639	11321	3	0	\N
173874	1397	1304386573000	22641	11322	0	0	\N
173875	2134	86646228000	22641	11322	1	0	\N
173876	2133	93932300000	22641	11322	2	0	\N
173877	1397	1304376572000	22642	11323	0	0	\N
173878	2134	86645225000	22642	11323	1	0	\N
173879	2133	93931298000	22642	11323	2	0	\N
173883	1397	1304376572000	22644	11323	0	0	\N
173884	2134	86645225000	22644	11323	1	0	\N
173885	2133	93931298000	22644	11323	2	0	\N
173886	1397	1304376572000	22645	11323	0	0	\N
173887	2133	93931298000	22645	11323	1	0	\N
173888	1397	1304366571000	22646	11324	0	0	\N
173889	1397	1304356570000	22646	11324	1	0	\N
173890	2133	93930296000	22646	11324	2	0	\N
173891	2133	93929294000	22646	11324	3	0	\N
173892	2134	86644222000	22646	11324	4	0	\N
173893	2134	86643219000	22646	11324	5	0	\N
173894	2132	147886888000	22646	11324	6	0	\N
173902	1397	1304366571000	22648	11324	0	0	\N
173903	1397	1304356570000	22648	11324	1	0	\N
173904	2133	93930296000	22648	11324	2	0	\N
173905	2133	93929294000	22648	11324	3	0	\N
173906	2134	86644222000	22648	11324	4	0	\N
173907	2134	86643219000	22648	11324	5	0	\N
173908	2132	147886888000	22648	11324	6	0	\N
173915	1397	1304336568000	22651	11326	0	0	\N
173916	2134	86641213000	22651	11326	1	0	\N
173917	2133	93927290000	22651	11326	2	0	\N
173918	1397	1304336568000	22652	11326	0	0	\N
173919	2134	86641213000	22652	11326	1	0	\N
173920	2133	93927290000	22652	11326	2	0	\N
173921	1397	1304326567000	22653	11327	0	0	\N
173922	2133	93926288000	22653	11327	1	0	\N
173923	1885	8000000	22653	11327	2	0	\N
173924	2132	147885887000	22653	11327	3	0	\N
173925	1397	1304326567000	22654	11327	0	0	\N
173926	1885	8000000	22654	11327	1	0	\N
173927	2132	147885887000	22654	11327	2	0	\N
173935	1397	1304316566000	22657	11328	0	0	\N
173936	2134	86640210000	22657	11328	1	0	\N
173937	2133	93925286000	22657	11328	2	0	\N
173938	1397	1304316566000	22658	11328	0	0	\N
173939	2134	86640210000	22658	11328	1	0	\N
173940	2133	93925286000	22658	11328	2	0	\N
173941	1397	1304316566000	22659	11328	0	0	\N
173942	2134	86640210000	22659	11328	1	0	\N
173812	2133	93939314000	22627	11317	2	0	3844
173813	2134	86653249000	22627	11317	3	0	3925
173814	2133	93938312000	22627	11317	4	0	3845
173815	2134	86652246000	22627	11317	5	0	3926
173822	1397	1304436578000	22629	11318	0	0	13439
173824	2134	86651243000	22629	11318	2	0	3927
173825	1397	1304426577000	22630	11319	0	0	13440
173826	2134	86650240000	22630	11319	1	0	3928
173827	2133	93936308000	22630	11319	2	0	3847
173828	2132	147888890000	22630	11319	3	0	1110
173854	1397	1304406575000	22636	11320	1	0	13442
173855	2134	86649237000	22636	11320	2	0	3929
173856	2133	93935306000	22636	11320	3	0	3848
173857	2133	93934304000	22636	11320	4	0	3849
173863	1397	1304396574000	22638	11321	0	0	13443
173864	2133	93933302000	22638	11321	1	0	3850
173865	2134	86647231000	22638	11321	2	0	3931
173866	2132	147887889000	22638	11321	3	0	1111
173871	1397	1304386573000	22640	11322	0	0	13444
173873	2133	93932300000	22640	11322	2	0	3851
173880	1397	1304376572000	22643	11323	0	0	13445
173881	2134	86645225000	22643	11323	1	0	3933
173882	2133	93931298000	22643	11323	2	0	3852
173895	1397	1304366571000	22647	11324	0	0	13446
173897	2133	93930296000	22647	11324	2	0	3853
173898	2133	93929294000	22647	11324	3	0	3854
173899	2134	86644222000	22647	11324	4	0	3934
173900	2134	86643219000	22647	11324	5	0	3935
173909	1397	1304346569000	22649	11325	0	0	13448
173910	2133	93928292000	22649	11325	1	0	3855
173911	2134	86642216000	22649	11325	2	0	3936
173912	1397	1304336568000	22650	11326	0	0	13449
173913	2134	86641213000	22650	11326	1	0	3937
173928	1397	1304326567000	22655	11327	0	0	13450
173929	2133	93926288000	22655	11327	1	0	3857
173930	1885	8000000	22655	11327	2	0	4
173931	2132	147885887000	22655	11327	3	0	1113
173932	1397	1304316566000	22656	11328	0	0	13451
173934	2133	93925286000	22656	11328	2	0	3858
173943	1397	1304306565000	22660	11329	0	0	13452
173944	1397	1304296564000	22660	11329	1	0	13453
173950	1397	1304286563000	22661	11330	0	0	\N
173951	1397	1304276562000	22661	11330	1	0	\N
173952	1397	1304266561000	22661	11330	2	0	\N
173953	2134	86637201000	22661	11330	3	0	\N
173954	2134	86636198000	22661	11330	4	0	\N
173955	2133	93922280000	22661	11330	5	0	\N
173956	2134	86635195000	22661	11330	6	0	\N
173957	2132	147883885000	22661	11330	7	0	\N
173958	2133	93921278000	22661	11330	8	0	\N
173959	2133	93920276000	22661	11330	9	0	\N
173979	1397	1304226557000	22667	11332	0	0	\N
173980	2133	93916268000	22667	11332	1	0	\N
173981	2132	147882884000	22667	11332	2	0	\N
173982	2134	86631183000	22667	11332	3	0	\N
173990	1397	1304216556000	22670	11333	0	0	\N
173991	2134	86630180000	22670	11333	1	0	\N
173992	2133	93915266000	22670	11333	2	0	\N
174003	1397	1304186553000	22673	11335	0	0	\N
174004	2133	93912260000	22673	11335	1	0	\N
174005	2134	86627171000	22673	11335	2	0	\N
174013	1397	1304156550000	22676	11338	0	0	\N
174014	2134	86624162000	22676	11338	1	0	\N
174015	2133	93909254000	22676	11338	2	0	\N
174019	1397	1304146549000	22678	11339	0	0	\N
174020	2133	93908252000	22678	11339	1	0	\N
174021	2134	86623159000	22678	11339	2	0	\N
174035	1397	1304126547000	22682	11341	0	0	\N
174036	1397	1304116546000	22682	11341	1	0	\N
174037	2134	86621153000	22682	11341	2	0	\N
174038	2134	86620150000	22682	11341	3	0	\N
174039	2133	93906248000	22682	11341	4	0	\N
174040	2133	93905246000	22682	11341	5	0	\N
174041	2132	147879881000	22682	11341	6	0	\N
174045	1397	1304106545000	22685	11342	0	0	\N
174046	2133	93904244000	22685	11342	1	0	\N
174047	2134	86619147000	22685	11342	2	0	\N
174048	1633	15559964847463	22686	11343	0	0	\N
174049	1397	1304096544000	22686	11343	1	0	\N
174050	2132	147878880000	22686	11343	2	0	\N
174051	2133	93903242000	22686	11343	3	0	\N
174056	1633	15559964847463	22688	11343	0	0	\N
174057	1397	1304096544000	22688	11343	1	0	\N
174058	2132	147878880000	22688	11343	2	0	\N
174059	2133	93903242000	22688	11343	3	0	\N
174070	1633	13435820083107	22691	11345	0	0	\N
174071	1633	10287637513689	22691	11345	1	0	\N
174072	1397	1304076542000	22691	11345	2	0	\N
174073	1397	1304066541000	22691	11345	3	0	\N
174074	1633	4368537125277	22691	11345	4	0	\N
174075	2133	93901238000	22691	11345	5	0	\N
174076	2133	93900236000	22691	11345	6	0	\N
174077	43	69680031890000	22691	11345	7	0	\N
173947	2133	93923282000	22660	11329	4	0	3860
173948	2134	86638204000	22660	11329	5	0	3940
173949	2132	147884886000	22660	11329	6	0	1114
173960	1397	1304286563000	22662	11330	0	0	13454
173961	1397	1304276562000	22662	11330	1	0	13455
173963	2134	86637201000	22662	11330	3	0	3941
173964	2134	86636198000	22662	11330	4	0	3942
173965	2133	93922280000	22662	11330	5	0	3861
173966	2134	86635195000	22662	11330	6	0	3943
173967	2132	147883885000	22662	11330	7	0	1115
173969	2133	93920276000	22662	11330	9	0	3863
173970	1397	1304256560000	22663	11331	0	0	13457
173971	1397	1304246559000	22663	11331	1	0	13458
173972	1397	1304236558000	22663	11331	2	0	13459
173974	2134	86634192000	22663	11331	4	0	3944
173975	2134	86633189000	22663	11331	5	0	3945
173976	2134	86632186000	22663	11331	6	0	3946
173977	2133	93918272000	22663	11331	7	0	3865
173978	2133	93917270000	22663	11331	8	0	3866
173984	2133	93916268000	22668	11332	1	0	3867
173985	2132	147882884000	22668	11332	2	0	1116
173986	2134	86631183000	22668	11332	3	0	3947
173987	1397	1304216556000	22669	11333	0	0	13461
173988	2134	86630180000	22669	11333	1	0	3948
173993	1397	1304206555000	22671	11334	0	0	13462
173994	1397	1304196554000	22671	11334	1	0	13463
173995	2134	86629177000	22671	11334	2	0	3949
173996	2132	147881883000	22671	11334	3	0	1117
173998	2133	93914264000	22671	11334	5	0	3869
173999	2133	93913262000	22671	11334	6	0	3870
174000	1397	1304186553000	22672	11335	0	0	13464
174001	2133	93912260000	22672	11335	1	0	3871
174002	2134	86627171000	22672	11335	2	0	3951
174007	2134	86626168000	22674	11336	1	0	3952
174008	2133	93911258000	22674	11336	2	0	3872
174009	1397	1304166551000	22675	11337	0	0	13466
174010	2133	93910256000	22675	11337	1	0	3873
174011	2134	86625165000	22675	11337	2	0	3953
174016	1397	1304156550000	22677	11338	0	0	13467
174017	2134	86624162000	22677	11338	1	0	3954
174018	2133	93909254000	22677	11338	2	0	3874
174022	1397	1304146549000	22679	11339	0	0	13468
174024	2134	86623159000	22679	11339	2	0	3955
174025	1397	1304136548000	22680	11340	0	0	13469
174026	2134	86622156000	22680	11340	1	0	3956
174027	2133	93907250000	22680	11340	2	0	3876
174028	1397	1304126547000	22681	11341	0	0	13470
174030	2134	86621153000	22681	11341	2	0	3957
174031	2134	86620150000	22681	11341	3	0	3958
174032	2133	93906248000	22681	11341	4	0	3877
174033	2133	93905246000	22681	11341	5	0	3878
174034	2132	147879881000	22681	11341	6	0	1119
174043	2133	93904244000	22684	11342	1	0	3879
174044	2134	86619147000	22684	11342	2	0	3959
174052	1633	15559964847463	22687	11343	0	0	9
174053	1397	1304096544000	22687	11343	1	0	13473
174055	2133	93903242000	22687	11343	3	0	3880
174060	1397	1304086543000	22689	11344	0	0	13474
174061	2133	93902240000	22689	11344	1	0	3881
174062	1633	13435820083107	22690	11345	0	0	10
174063	1633	10287637513689	22690	11345	1	0	11
174065	1397	1304066541000	22690	11345	3	0	13476
174066	1633	4368537125277	22690	11345	4	0	12
174067	2133	93901238000	22690	11345	5	0	3882
174068	2133	93900236000	22690	11345	6	0	3883
174069	43	69680031890000	22690	11345	7	0	2
174079	2132	147877879000	22692	11346	1	0	1121
174080	2133	93899234000	22692	11346	2	0	3884
174081	1397	1304046539000	22693	11347	0	0	\N
174082	2133	93898232000	22693	11347	1	0	\N
174083	2028	11156372590000	22693	11347	2	0	\N
174084	2028	8522723500000	22693	11347	3	0	\N
174085	2028	4619402040000	22693	11347	4	0	\N
174086	2028	2441198400000	22693	11347	5	0	\N
174093	1397	1304046539000	22695	11347	0	0	\N
174094	2133	93898232000	22695	11347	1	0	\N
174095	2028	11156372590000	22695	11347	2	0	\N
174096	2028	8522723500000	22695	11347	3	0	\N
174097	2028	4619402040000	22695	11347	4	0	\N
174098	2028	2441198400000	22695	11347	5	0	\N
174112	1397	1303996534000	22698	11349	0	0	\N
174113	43	69600030890000	22698	11349	1	0	\N
174114	2133	93893222000	22698	11349	2	0	\N
174115	2132	147875877000	22698	11349	3	0	\N
174116	1397	1303996534000	22699	11349	0	0	\N
174117	43	69600030890000	22699	11349	1	0	\N
174118	2133	93893222000	22699	11349	2	0	\N
174119	2132	147875877000	22699	11349	3	0	\N
174120	1397	1303996534000	22700	11349	0	0	\N
174121	43	69600030890000	22700	11349	1	0	\N
174122	2133	93893222000	22700	11349	2	0	\N
174123	2132	147875877000	22700	11349	3	0	\N
174124	1397	1303996534000	22701	11349	0	0	\N
174125	43	69600030890000	22701	11349	1	0	\N
174126	2133	93893222000	22701	11349	2	0	\N
174127	2132	147875877000	22701	11349	3	0	\N
174128	1397	1303986533000	22702	11350	0	0	\N
174129	2133	93892220000	22702	11350	1	0	\N
174130	2028	2487063010000	22702	11350	2	0	\N
174131	2028	2474812480000	22702	11350	3	0	\N
174132	2028	2456656500000	22702	11350	4	0	\N
174133	2028	2446524320000	22702	11350	5	0	\N
174147	1397	1303976532000	22705	11351	0	0	\N
174148	1397	1303966531000	22705	11351	1	0	\N
174149	1397	1303956530000	22705	11351	2	0	\N
174150	2133	93891218000	22705	11351	3	0	\N
174151	2133	93890216000	22705	11351	4	0	\N
174152	2133	93889214000	22705	11351	5	0	\N
174153	2132	147874876000	22705	11351	6	0	\N
174154	1397	1303946529000	22706	11352	0	0	\N
174155	2133	93888212000	22706	11352	1	0	\N
174156	1397	1303946529000	22707	11352	0	0	\N
174157	2133	93888212000	22707	11352	1	0	\N
174160	1397	1303936528000	22709	11353	0	0	\N
174161	1397	1303926527000	22709	11353	1	0	\N
174162	2132	147873875000	22709	11353	2	0	\N
174163	2133	93887210000	22709	11353	3	0	\N
174164	2133	93886208000	22709	11353	4	0	\N
174170	1397	1303916526000	22711	11354	0	0	\N
174171	1397	1303906525000	22711	11354	1	0	\N
174172	2133	93885206000	22711	11354	2	0	\N
174173	2133	93884204000	22711	11354	3	0	\N
174174	2133	93883202000	22711	11354	4	0	\N
174175	2132	147872874000	22711	11354	5	0	\N
174176	1397	1303916526000	22712	11354	0	0	\N
174177	1397	1303906525000	22712	11354	1	0	\N
174178	2133	93885206000	22712	11354	2	0	\N
174179	2133	93884204000	22712	11354	3	0	\N
174180	2133	93883202000	22712	11354	4	0	\N
174181	2132	147872874000	22712	11354	5	0	\N
174197	1397	1303866521000	22717	11357	0	0	\N
174198	2133	93879194000	22717	11357	1	0	\N
174199	2132	147871873000	22717	11357	2	0	\N
174200	1397	1303856520000	22718	11358	0	0	\N
174201	2133	93878192000	22718	11358	1	0	\N
174204	1397	1303856520000	22720	11358	0	0	\N
174205	2133	93878192000	22720	11358	1	0	\N
174206	1397	1303846519000	22721	11359	0	0	\N
174207	2133	93877190000	22721	11359	1	0	\N
174089	2028	11156372590000	22694	11347	2	0	5
174090	2028	8522723500000	22694	11347	3	0	6
174091	2028	4619402040000	22694	11347	4	0	7
174092	2028	2441198400000	22694	11347	5	0	8
174099	1397	1304036538000	22696	11348	0	0	13479
174101	1397	1304016536000	22696	11348	2	0	13481
174102	1397	1304006535000	22696	11348	3	0	13482
174103	2132	147876878000	22696	11348	4	0	1122
174104	2133	93897230000	22696	11348	5	0	3886
174105	2133	93896228000	22696	11348	6	0	3887
174107	2133	93894224000	22696	11348	8	0	3889
174108	1397	1303996534000	22697	11349	0	0	13483
174109	43	69600030890000	22697	11349	1	0	3
174110	2133	93893222000	22697	11349	2	0	3890
174134	1397	1303986533000	22703	11350	0	0	13484
174135	2133	93892220000	22703	11350	1	0	3891
174136	2028	2487063010000	22703	11350	2	0	9
174137	2028	2474812480000	22703	11350	3	0	10
174138	2028	2456656500000	22703	11350	4	0	11
174140	1397	1303976532000	22704	11351	0	0	13485
174141	1397	1303966531000	22704	11351	1	0	13486
174142	1397	1303956530000	22704	11351	2	0	13487
174143	2133	93891218000	22704	11351	3	0	3892
174144	2133	93890216000	22704	11351	4	0	3893
174146	2132	147874876000	22704	11351	6	0	1124
174158	1397	1303946529000	22708	11352	0	0	13488
174159	2133	93888212000	22708	11352	1	0	3895
174165	1397	1303936528000	22710	11353	0	0	13489
174167	2132	147873875000	22710	11353	2	0	1125
174168	2133	93887210000	22710	11353	3	0	3896
174169	2133	93886208000	22710	11353	4	0	3897
174182	1397	1303916526000	22713	11354	0	0	13491
174183	1397	1303906525000	22713	11354	1	0	13492
174185	2133	93884204000	22713	11354	3	0	3899
174186	2133	93883202000	22713	11354	4	0	3900
174187	2132	147872874000	22713	11354	5	0	1126
174188	1397	1303896524000	22714	11355	0	0	13493
174189	1397	1303886523000	22714	11355	1	0	13494
174191	2133	93881198000	22714	11355	3	0	3902
174192	1397	1303876522000	22715	11356	0	0	13495
174193	2133	93880196000	22715	11356	1	0	3903
174194	1397	1303866521000	22716	11357	0	0	13496
174196	2132	147871873000	22716	11357	2	0	1127
174202	1397	1303856520000	22719	11358	0	0	13497
174203	2133	93878192000	22719	11358	1	0	3905
174208	1397	1303846519000	22722	11359	0	0	13498
174209	1397	1303836518000	22723	11360	0	0	13499
174211	2132	147870872000	22723	11360	2	0	1128
174212	2133	93876188000	22723	11360	3	0	3907
174213	1397	1303826517000	22724	11361	0	0	13500
174214	2133	93875186000	22724	11361	1	0	3908
174215	1397	1303816516000	22725	11362	0	0	13501
174219	1397	1303816516000	22726	11362	0	0	\N
174220	1397	1303806515000	22726	11362	1	0	\N
174221	2133	93874184000	22726	11362	2	0	\N
174222	2132	147869871000	22726	11362	3	0	\N
174223	1397	1303816516000	22727	11362	0	0	\N
174224	1397	1303806515000	22727	11362	1	0	\N
174225	2133	93874184000	22727	11362	2	0	\N
174226	2132	147869871000	22727	11362	3	0	\N
174227	1397	1303796514000	22728	11363	0	0	\N
174228	2133	93873182000	22728	11363	1	0	\N
174258	1397	1303736508000	22737	11368	0	0	\N
174259	1397	1303726507000	22737	11368	1	0	\N
174260	1397	1303716506000	22737	11368	2	0	\N
174261	1397	1303706505000	22737	11368	3	0	\N
174262	2133	93867170000	22737	11368	4	0	\N
174263	2133	93866168000	22737	11368	5	0	\N
174264	2133	93865166000	22737	11368	6	0	\N
174265	2133	93864164000	22737	11368	7	0	\N
174266	2132	147867869000	22737	11368	8	0	\N
174267	2132	147866868000	22737	11368	9	0	\N
174268	2134	86616138000	22737	11368	10	0	\N
174269	2134	86615135000	22737	11368	11	0	\N
174270	2134	86614132000	22737	11368	12	0	\N
174271	2134	86613129000	22737	11368	13	0	\N
174278	1397	1303676502000	22739	11370	0	0	\N
174279	2134	86610120000	22739	11370	1	0	\N
174280	2131	190997000	22739	11370	2	0	\N
174281	2133	93861158000	22739	11370	3	0	\N
174301	1397	1303636498000	22744	11373	0	0	\N
174302	1397	1303626497000	22744	11373	1	0	\N
174303	2133	93857150000	22744	11373	2	0	\N
174304	2133	93856148000	22744	11373	3	0	\N
174305	2132	147864866000	22744	11373	4	0	\N
174306	2134	86606108000	22744	11373	5	0	\N
174307	2134	86605105000	22744	11373	6	0	\N
174317	1397	1303596494000	22747	11376	0	0	\N
174318	2134	86602096000	22747	11376	1	0	\N
174319	2133	93853142000	22747	11376	2	0	\N
174323	1397	1303596494000	22749	11376	0	0	\N
174324	2134	86602096000	22749	11376	1	0	\N
174325	2133	93853142000	22749	11376	2	0	\N
174326	1397	1303596494000	22750	11376	0	0	\N
174327	2133	93853142000	22750	11376	1	0	\N
174328	1397	1303596494000	22751	11376	0	0	\N
174329	2133	93853142000	22751	11376	1	0	\N
174330	1397	1303596494000	22752	11376	0	0	\N
174331	2134	86602096000	22752	11376	1	0	\N
174332	2133	93853142000	22752	11376	2	0	\N
174333	1397	1303596494000	22753	11376	0	0	\N
174334	2133	93853142000	22753	11376	1	0	\N
174335	2246	2686411101924	22754	11165	0	0	\N
174336	1633	14119938847463	22754	11165	1	0	\N
174337	1633	11995794083107	22754	11165	2	0	\N
174338	1633	8847611513689	22754	11165	3	0	\N
174339	1599	22896943603909	22754	11165	4	0	\N
174340	1599	18159740119598	22754	11165	5	0	\N
174341	1599	14963451280472	22754	11165	6	0	\N
174342	1599	6056726097983	22754	11165	7	0	\N
174343	2112	7920186000000	22754	11165	8	0	\N
174344	1693	10210650245940	22754	11165	9	0	\N
174345	1693	10159553583248	22754	11165	10	0	\N
174346	1693	10112804767742	22754	11165	11	0	\N
174347	1693	10066055243367	22754	11165	12	0	\N
174348	1693	10014958580675	22754	11165	13	0	\N
174349	1693	9968209771540	22754	11165	14	0	\N
174350	1693	9917113108848	22754	11165	15	0	\N
174351	1693	9870364356368	22754	11165	16	0	\N
174352	1693	9503498553907	22754	11165	17	0	\N
174229	1397	1303796514000	22729	11363	0	0	13503
174230	2133	93873182000	22729	11363	1	0	3910
174231	1397	1303786513000	22730	11364	0	0	13504
174232	1397	1303776512000	22730	11364	1	0	13505
174233	2133	93872180000	22730	11364	2	0	3911
174235	1397	1303766511000	22731	11365	0	0	13506
174236	2133	93870176000	22731	11365	1	0	3913
174237	2132	147868870000	22731	11365	2	0	1130
174238	1397	1303756510000	22732	11366	0	0	13507
174239	2133	93869174000	22732	11366	1	0	3914
174241	1397	1303746509000	22733	11367	0	0	13508
174242	2134	86617141000	22733	11367	1	0	3961
174243	2133	93868172000	22733	11367	2	0	3915
174244	1397	1303736508000	22736	11368	0	0	13509
174246	1397	1303716506000	22736	11368	2	0	13511
174247	1397	1303706505000	22736	11368	3	0	13512
174248	2133	93867170000	22736	11368	4	0	3916
174249	2133	93866168000	22736	11368	5	0	3917
174250	2133	93865166000	22736	11368	6	0	3918
174252	2132	147867869000	22736	11368	8	0	1131
174253	2132	147866868000	22736	11368	9	0	1132
174254	2134	86616138000	22736	11368	10	0	3962
174255	2134	86615135000	22736	11368	11	0	3963
174256	2134	86614132000	22736	11368	12	0	3964
174272	1397	1303696504000	22738	11369	0	0	13513
174273	1397	1303686503000	22738	11369	1	0	13514
174274	2134	86612126000	22738	11369	2	0	3966
174275	2134	86611123000	22738	11369	3	0	3967
174277	2133	93862160000	22738	11369	5	0	3921
174282	1397	1303676502000	22740	11370	0	0	13515
174283	2134	86610120000	22740	11370	1	0	3968
174284	2131	190997000	22740	11370	2	0	8
174285	2133	93861158000	22740	11370	3	0	3922
174287	2134	86609117000	22741	11371	1	0	3969
174288	2133	93860156000	22741	11371	2	0	3923
174289	2132	147865867000	22741	11371	3	0	1133
174290	1397	1303656500000	22742	11372	0	0	13517
174291	1397	1303646499000	22742	11372	1	0	13518
174293	2133	93858152000	22742	11372	3	0	3925
174294	2134	86608114000	22742	11372	4	0	3970
174295	2134	86607111000	22742	11372	5	0	3971
174296	1397	1303636498000	22743	11373	0	0	13519
174298	2132	147864866000	22743	11373	2	0	1134
174299	2134	86606108000	22743	11373	3	0	3972
174300	2134	86605105000	22743	11373	4	0	3973
174308	1397	1303616496000	22745	11374	0	0	13521
174309	2134	86604102000	22745	11374	1	0	3974
174311	2133	93856148000	22745	11374	3	0	3927
174312	2133	93855146000	22745	11374	4	0	3928
174313	1397	1303606495000	22746	11375	0	0	13522
174314	2134	86603099000	22746	11375	1	0	3975
174315	2133	93854144000	22746	11375	2	0	3929
174320	1397	1303596494000	22748	11376	0	0	13523
174321	2134	86602096000	22748	11376	1	0	3976
174322	2133	93853142000	22748	11376	2	0	3930
174353	1693	9452401891215	22754	11165	18	0	\N
174354	1693	9401305228523	22754	11165	19	0	\N
174355	1693	9350208565831	22754	11165	20	0	\N
174356	1693	9346328364119	22754	11165	21	0	\N
174357	1693	9295231701427	22754	11165	22	0	\N
174358	1693	9244135038735	22754	11165	23	0	\N
174359	1693	9193040521774	22754	11165	24	0	\N
174360	1693	9146291712639	22754	11165	25	0	\N
174361	1693	9140863430240	22754	11165	26	0	\N
174362	1693	9089766767548	22754	11165	27	0	\N
174363	1693	9038670104856	22754	11165	28	0	\N
174364	1693	8987573442164	22754	11165	29	0	\N
174365	1693	8847241097656	22754	11165	30	0	\N
174366	1693	8796144434964	22754	11165	31	0	\N
174367	1693	8745047772272	22754	11165	32	0	\N
174368	1693	8355745817802	22754	11165	33	0	\N
174369	1693	8304649155110	22754	11165	34	0	\N
174370	1693	8253552492418	22754	11165	35	0	\N
174371	1693	8206803683283	22754	11165	36	0	\N
174372	1693	8155707020591	22754	11165	37	0	\N
174373	1693	8104610357899	22754	11165	38	0	\N
174374	1693	8102474176971	22754	11165	39	0	\N
174375	1693	8051377514279	22754	11165	40	0	\N
174376	1693	8000280851587	22754	11165	41	0	\N
174377	1693	7949184188895	22754	11165	42	0	\N
174378	1693	7478484273724	22754	11165	43	0	\N
174379	1693	7427387611032	22754	11165	44	0	\N
174380	1693	7376290948340	22754	11165	45	0	\N
174381	1693	7325194285648	22754	11165	46	0	\N
174382	1693	7274097622956	22754	11165	47	0	\N
174383	1693	7272539542275	22754	11165	48	0	\N
174384	1693	7221442879583	22754	11165	49	0	\N
174385	1693	7170453163642	22754	11165	50	0	\N
174386	1693	7119356500950	22754	11165	51	0	\N
174387	1693	7068259838258	22754	11165	52	0	\N
174388	1693	7017163175566	22754	11165	53	0	\N
174389	2246	0	22754	11165	54	0	\N
174390	1633	2928511125277	22754	11165	55	0	\N
174391	1693	6970414083172	22754	11165	56	0	\N
174392	1693	6919317420480	22754	11165	57	0	\N
174393	1693	6868220757788	22754	11165	58	0	\N
174394	1693	6866792739669	22754	11165	59	0	\N
174395	1693	6851921165075	22754	11165	60	0	\N
174396	1693	6800824502383	22754	11165	61	0	\N
174397	1693	6754075693248	22754	11165	62	0	\N
174398	1693	6702979030556	22754	11165	63	0	\N
174399	1693	6651882367864	22754	11165	64	0	\N
174400	1693	6600785705172	22754	11165	65	0	\N
174401	1693	6549689042480	22754	11165	66	0	\N
174402	1693	6498592379788	22754	11165	67	0	\N
174403	1693	6451843359622	22754	11165	68	0	\N
174404	1693	6400746696930	22754	11165	69	0	\N
174405	1693	6349650034238	22754	11165	70	0	\N
174406	1693	6298553371546	22754	11165	71	0	\N
174407	1693	6251804556040	22754	11165	72	0	\N
174408	1693	6014301240164	22754	11165	73	0	\N
174409	1693	5963204577472	22754	11165	74	0	\N
174410	1693	5912107914780	22754	11165	75	0	\N
174411	1693	5864848576916	22754	11165	76	0	\N
174412	1693	5818099767781	22754	11165	77	0	\N
174413	1693	5767003105089	22754	11165	78	0	\N
174414	1693	5715906442397	22754	11165	79	0	\N
174415	1693	5664809779705	22754	11165	80	0	\N
174416	1693	5613713117013	22754	11165	82	0	\N
174417	1693	5562616454321	22754	11165	83	0	\N
174418	1693	5515867708926	22754	11165	84	0	\N
174419	1693	5514441307150	22754	11165	85	0	\N
174420	1693	5463344644458	22754	11165	86	0	\N
174421	1693	5416593958696	22754	11165	87	0	\N
174422	1693	5365497296004	22754	11165	88	0	\N
174423	1693	5318748437302	22754	11165	89	0	\N
174424	1693	5267651774610	22754	11165	90	0	\N
174425	1693	5220902965475	22754	11165	91	0	\N
174426	1693	5169806302783	22754	11165	92	0	\N
174427	1693	5118709640091	22754	11165	93	0	\N
174428	1693	5067612977399	22754	11165	94	0	\N
174429	1693	5016516314707	22754	11165	95	0	\N
174430	1693	5012358154437	22754	11165	96	0	\N
174431	1693	4965609062043	22754	11165	97	0	\N
174432	1693	4914512399351	22754	11165	98	0	\N
174433	1693	3602883099317	22754	11165	99	0	\N
174434	1693	3551786436625	22754	11165	100	0	\N
174435	1693	3528719370809	22754	11165	101	0	\N
174436	1693	3477622708117	22754	11165	102	0	\N
174437	1693	3426526045425	22754	11165	103	0	\N
174438	1693	3375429382733	22754	11165	104	0	\N
174439	1693	3371271222463	22754	11165	105	0	\N
174440	1693	3320174559771	22754	11165	106	0	\N
174441	1693	3269077897079	22754	11165	107	0	\N
174442	1693	3217981234387	22754	11165	108	0	\N
174443	1693	3166884571695	22754	11165	109	0	\N
174444	1693	3120134133789	22754	11165	110	0	\N
174445	1693	3069037471097	22754	11165	111	0	\N
174446	1693	3017940808405	22754	11165	112	0	\N
174447	1693	2966844145713	22754	11165	113	0	\N
174448	1693	2915747483021	22754	11165	114	0	\N
174449	1693	2864650820329	22754	11165	115	0	\N
174450	1693	2817902011194	22754	11165	116	0	\N
174451	1693	2766805348502	22754	11165	117	0	\N
174452	1693	2720056603107	22754	11165	118	0	\N
174453	1693	2668959940415	22754	11165	119	0	\N
174454	1693	2617863277723	22754	11165	120	0	\N
174465	1397	1303586493000	22756	11377	0	0	\N
174466	1397	1303576492000	22756	11377	1	0	\N
174467	1397	1303566491000	22756	11377	2	0	\N
174468	2132	147862864000	22756	11377	3	0	\N
174469	2133	93852140000	22756	11377	4	0	\N
174470	2133	93851138000	22756	11377	5	0	\N
174471	2134	86601093000	22756	11377	6	0	\N
174472	2134	86600090000	22756	11377	7	0	\N
174473	2134	86599087000	22756	11377	8	0	\N
174474	2133	93850136000	22756	11377	9	0	\N
174485	1397	1303526487000	22760	11381	0	0	\N
174486	1397	1303516486000	22760	11381	1	0	\N
174487	2133	93846128000	22760	11381	2	0	\N
174488	2133	93845126000	22760	11381	3	0	\N
174457	1397	1303566491000	22755	11377	2	0	13526
174458	2132	147862864000	22755	11377	3	0	1136
174459	2133	93852140000	22755	11377	4	0	3931
174460	2133	93851138000	22755	11377	5	0	3932
174461	2134	86601093000	22755	11377	6	0	3977
174463	2134	86599087000	22755	11377	8	0	3979
174464	2133	93850136000	22755	11377	9	0	3933
174475	1397	1303556490000	22757	11378	0	0	13527
174476	2134	86598084000	22757	11378	1	0	3980
174477	2133	93849134000	22757	11378	2	0	3934
174479	2134	86597081000	22758	11379	1	0	3981
174480	2133	93848132000	22758	11379	2	0	3935
174481	1397	1303536488000	22759	11380	0	0	13529
174482	2133	93847130000	22759	11380	1	0	3936
174484	2134	86596078000	22759	11380	3	0	3982
174489	2134	86595075000	22760	11381	5	0	\N
174490	2134	86594072000	22760	11381	6	0	\N
174500	1397	1303506485000	22764	11382	0	0	\N
174501	2132	147860862000	22764	11382	1	0	\N
174502	2133	93846128000	22764	11382	2	0	\N
174503	2133	93845126000	22764	11382	3	0	\N
174504	2133	93844124000	22764	11382	4	0	\N
174505	1397	1303506485000	22765	11382	0	0	\N
174506	2132	147860862000	22765	11382	1	0	\N
174507	2133	93846128000	22765	11382	2	0	\N
174508	2133	93845126000	22765	11382	3	0	\N
174509	2133	93844124000	22765	11382	4	0	\N
174515	1397	1303476482000	22768	11385	0	0	\N
174516	2133	93842120000	22768	11385	1	0	\N
174517	2134	86591063000	22768	11385	2	0	\N
174518	2133	93841118000	22768	11385	3	0	\N
174533	1397	1303436478000	22772	11388	0	0	\N
174534	1397	1303426477000	22772	11388	1	0	\N
174535	1397	1303416476000	22772	11388	2	0	\N
174536	1397	1303406475000	22772	11388	3	0	\N
174537	1397	1303396474000	22772	11388	4	0	\N
174538	1397	1303386473000	22772	11388	5	0	\N
174539	2132	147858860000	22772	11388	6	0	\N
174540	2134	86587051000	22772	11388	7	0	\N
174541	2134	86586048000	22772	11388	8	0	\N
174542	2132	147857859000	22772	11388	9	0	\N
174543	1549	30576312000000	22772	11388	10	0	\N
174544	2134	86585045000	22772	11388	11	0	\N
174545	2133	93837110000	22772	11388	12	0	\N
174546	2133	93836108000	22772	11388	13	0	\N
174547	2133	93835106000	22772	11388	14	0	\N
174548	2133	93834104000	22772	11388	15	0	\N
174549	2133	93833102000	22772	11388	16	0	\N
174550	2133	93832100000	22772	11388	17	0	\N
174551	2134	86584042000	22772	11388	18	0	\N
174552	2134	86583039000	22772	11388	19	0	\N
174553	2134	86582036000	22772	11388	20	0	\N
174554	1397	1303436478000	22773	11388	0	0	\N
174555	1397	1303426477000	22773	11388	1	0	\N
174556	1397	1303416476000	22773	11388	2	0	\N
174557	1397	1303406475000	22773	11388	3	0	\N
174558	1397	1303396474000	22773	11388	4	0	\N
174559	1397	1303386473000	22773	11388	5	0	\N
174560	2132	147858860000	22773	11388	6	0	\N
174561	2134	86587051000	22773	11388	7	0	\N
174562	2134	86586048000	22773	11388	8	0	\N
174563	2132	147857859000	22773	11388	9	0	\N
174564	1549	30576312000000	22773	11388	10	0	\N
174565	2134	86585045000	22773	11388	11	0	\N
174566	2133	93837110000	22773	11388	12	0	\N
174567	2133	93836108000	22773	11388	13	0	\N
174568	2133	93835106000	22773	11388	14	0	\N
174569	2133	93834104000	22773	11388	15	0	\N
174570	2133	93833102000	22773	11388	16	0	\N
174571	2133	93832100000	22773	11388	17	0	\N
174572	2134	86584042000	22773	11388	18	0	\N
174573	2134	86583039000	22773	11388	19	0	\N
174574	2134	86582036000	22773	11388	20	0	\N
174599	1397	1303376472000	22776	11389	0	0	\N
174600	2133	93831098000	22776	11389	1	0	\N
174601	2134	86581033000	22776	11389	2	0	\N
174616	1397	1303336468000	22781	11393	0	0	\N
174617	2133	93827090000	22781	11393	1	0	\N
174618	2132	147855857000	22781	11393	2	0	\N
174619	2134	86577021000	22781	11393	3	0	\N
174620	2003	2075960654821	22782	11394	0	0	\N
174621	1397	1303326467000	22782	11394	1	0	\N
174622	1397	1303316466000	22782	11394	2	0	\N
174623	2134	86576018000	22782	11394	3	0	\N
174624	2134	86575015000	22782	11394	4	0	\N
174493	2134	86595075000	22761	11381	2	0	3983
174494	2134	86594072000	22761	11381	3	0	3984
174495	1397	1303506485000	22763	11382	0	0	13532
174496	2132	147860862000	22763	11382	1	0	1138
174497	2133	93846128000	22763	11382	2	0	3937
174499	2133	93844124000	22763	11382	4	0	3939
174510	1397	1303496484000	22766	11383	0	0	13533
174511	2133	93843122000	22766	11383	1	0	3940
174512	2134	86593069000	22766	11383	2	0	3985
174513	1397	1303486483000	22767	11384	0	0	13534
174519	1397	1303476482000	22769	11385	0	0	13535
174520	2133	93842120000	22769	11385	1	0	3941
174521	2134	86591063000	22769	11385	2	0	3987
174522	2133	93841118000	22769	11385	3	0	3942
174524	2132	147859861000	22770	11386	1	0	1139
174525	2134	86590060000	22770	11386	2	0	3988
174526	2133	93840116000	22770	11386	3	0	3943
174527	1397	1303456480000	22771	11387	0	0	13537
174528	1397	1303446479000	22771	11387	1	0	13538
174530	2134	86589057000	22771	11387	3	0	3989
174531	2134	86588054000	22771	11387	4	0	3990
174532	2133	93838112000	22771	11387	5	0	3945
174575	1397	1303436478000	22774	11388	0	0	13539
174576	1397	1303426477000	22774	11388	1	0	13540
174578	1397	1303406475000	22774	11388	3	0	13542
174579	1397	1303396474000	22774	11388	4	0	13543
174580	1397	1303386473000	22774	11388	5	0	13544
174581	2132	147858860000	22774	11388	6	0	1140
174583	2134	86586048000	22774	11388	8	0	3992
174584	2132	147857859000	22774	11388	9	0	1141
174585	1549	30576312000000	22774	11388	10	0	6
174586	2134	86585045000	22774	11388	11	0	3993
174587	2133	93837110000	22774	11388	12	0	3946
174589	2133	93835106000	22774	11388	14	0	3948
174590	2133	93834104000	22774	11388	15	0	3949
174591	2133	93833102000	22774	11388	16	0	3950
174592	2133	93832100000	22774	11388	17	0	3951
174593	2134	86584042000	22774	11388	18	0	3994
174595	2134	86582036000	22774	11388	20	0	3996
174596	1397	1303376472000	22775	11389	0	0	13545
174597	2133	93831098000	22775	11389	1	0	3952
174598	2134	86581033000	22775	11389	2	0	3997
174603	2134	86580030000	22777	11390	1	0	3998
174604	2133	93830096000	22777	11390	2	0	3953
174605	2132	147856858000	22777	11390	3	0	1142
174606	1397	1303356470000	22778	11391	0	0	13547
174607	2134	86579027000	22778	11391	1	0	3999
174609	1397	1303346469000	22779	11392	0	0	13548
174610	2134	86578024000	22779	11392	1	0	4000
174611	2133	93828092000	22779	11392	2	0	3955
174612	1397	1303336468000	22780	11393	0	0	13549
174613	2133	93827090000	22780	11393	1	0	3956
174615	2134	86577021000	22780	11393	3	0	4001
174625	2133	93826088000	22782	11394	5	0	\N
174626	2133	93825086000	22782	11394	6	0	\N
174627	2003	2075960654821	22783	11394	0	0	\N
174628	1397	1303326467000	22783	11394	1	0	\N
174629	1397	1303316466000	22783	11394	2	0	\N
174630	2134	86576018000	22783	11394	3	0	\N
174631	2134	86575015000	22783	11394	4	0	\N
174632	2133	93826088000	22783	11394	5	0	\N
174633	2133	93825086000	22783	11394	6	0	\N
174648	1397	1303296464000	22787	11396	0	0	\N
174649	2132	147854856000	22787	11396	1	0	\N
174650	2133	93823082000	22787	11396	2	0	\N
174651	2134	86573009000	22787	11396	3	0	\N
174652	2132	147854856000	22788	11396	0	0	\N
174653	2133	93823082000	22788	11396	1	0	\N
174654	2134	86573009000	22788	11396	2	0	\N
174684	1397	1303216456000	22793	11401	0	0	\N
174685	1397	1303206455000	22793	11401	1	0	\N
174686	2133	93815066000	22793	11401	2	0	\N
174687	2134	86564985000	22793	11401	3	0	\N
174688	2134	86563982000	22793	11401	4	0	\N
174689	2133	93814064000	22793	11401	5	0	\N
174696	1397	1303216456000	22795	11401	0	0	\N
174697	1397	1303206455000	22795	11401	1	0	\N
174698	2133	93815066000	22795	11401	2	0	\N
174699	2134	86564985000	22795	11401	3	0	\N
174700	2134	86563982000	22795	11401	4	0	\N
174701	2133	93814064000	22795	11401	5	0	\N
174702	1397	1303216456000	22796	11401	0	0	\N
174703	1397	1303206455000	22796	11401	1	0	\N
174704	1397	1303216456000	22797	11401	0	0	\N
174705	1397	1303206455000	22797	11401	1	0	\N
174706	2133	93815066000	22797	11401	2	0	\N
174707	2134	86564985000	22797	11401	3	0	\N
174708	2134	86563982000	22797	11401	4	0	\N
174709	2133	93814064000	22797	11401	5	0	\N
174710	1397	1303216456000	22798	11401	0	0	\N
174711	1397	1303206455000	22798	11401	1	0	\N
174712	2133	93815066000	22798	11401	2	0	\N
174713	2134	86564985000	22798	11401	3	0	\N
174714	2134	86563982000	22798	11401	4	0	\N
174715	2133	93814064000	22798	11401	5	0	\N
174720	1397	1303196454000	22800	11402	0	0	\N
174721	2134	86562979000	22800	11402	1	0	\N
174722	2132	147851853000	22800	11402	2	0	\N
174723	2133	93813062000	22800	11402	3	0	\N
174724	1397	1303196454000	22801	11402	0	0	\N
174725	2134	86562979000	22801	11402	1	0	\N
174726	2132	147851853000	22801	11402	2	0	\N
174727	2133	93813062000	22801	11402	3	0	\N
174731	1397	1303186453000	22803	11403	0	0	\N
174732	2134	86561976000	22803	11403	1	0	\N
174733	2133	93812060000	22803	11403	2	0	\N
174734	1397	1303186453000	22804	11403	0	0	\N
174735	2134	86561976000	22804	11403	1	0	\N
174736	2133	93812060000	22804	11403	2	0	\N
174737	1397	1303176452000	22805	11404	0	0	\N
174738	2133	93811058000	22805	11404	1	0	\N
174739	2134	86560973000	22805	11404	2	0	\N
174753	1397	1303136448000	22810	11408	0	0	\N
174754	2134	86556961000	22810	11408	1	0	\N
174755	2132	147849851000	22810	11408	2	0	\N
174759	1397	1303136448000	22812	11408	0	0	\N
174760	2134	86556961000	22812	11408	1	0	\N
174636	1397	1303316466000	22784	11394	2	0	13551
174637	2134	86576018000	22784	11394	3	0	4002
174638	2134	86575015000	22784	11394	4	0	4003
174639	2133	93826088000	22784	11394	5	0	3957
174640	2133	93825086000	22784	11394	6	0	3958
174642	2133	93824084000	22785	11395	1	0	3959
174643	2134	86574012000	22785	11395	2	0	4004
174644	1397	1303296464000	22786	11396	0	0	13553
174645	2132	147854856000	22786	11396	1	0	1144
174646	2133	93823082000	22786	11396	2	0	3960
174655	1397	1303286463000	22789	11397	0	0	13554
174656	1651	350418386014	22789	11397	1	0	13
174657	1651	2914145411	22789	11397	2	0	14
174658	1397	1303276462000	22789	11397	3	0	13555
174660	2134	86571003000	22789	11397	5	0	4007
174661	2133	93822080000	22789	11397	6	0	3961
174662	2133	93821078000	22789	11397	7	0	3962
174663	1397	1303266461000	22790	11398	0	0	13556
174664	1397	1303256460000	22790	11398	1	0	13557
174666	2132	147853855000	22790	11398	3	0	1145
174667	2133	93819074000	22790	11398	4	0	3964
174668	2134	86570000000	22790	11398	5	0	4008
174669	2134	86568997000	22790	11398	6	0	4009
174670	1397	1303246459000	22791	11399	0	0	13558
174672	2134	86567994000	22791	11399	3	0	4010
174673	2133	93818072000	22791	11399	4	0	3965
174674	2133	93817070000	22791	11399	5	0	3966
174675	1549	20745605000000	22791	11399	6	0	7
174677	2134	86566991000	22791	11399	8	0	4011
174678	1549	15516970000000	22791	11399	9	0	8
174679	1549	11989105000000	22791	11399	10	0	9
174680	1549	9071325000000	22791	11399	11	0	10
174681	1397	1303226457000	22792	11400	0	0	13560
174683	2133	93816068000	22792	11400	2	0	3967
174690	1397	1303216456000	22794	11401	0	0	13561
174691	1397	1303206455000	22794	11401	1	0	13562
174692	2133	93815066000	22794	11401	2	0	3968
174693	2134	86564985000	22794	11401	3	0	4013
174695	2133	93814064000	22794	11401	5	0	3969
174716	1397	1303196454000	22799	11402	0	0	13563
174717	2134	86562979000	22799	11402	1	0	4015
174718	2132	147851853000	22799	11402	2	0	1147
174728	1397	1303186453000	22802	11403	0	0	13564
174729	2134	86561976000	22802	11403	1	0	4016
174730	2133	93812060000	22802	11403	2	0	3971
174740	2134	86560973000	22806	11404	0	0	4017
174741	1397	1303176452000	22807	11405	0	0	13565
174743	2134	86559970000	22807	11405	2	0	4018
174744	2133	93811058000	22807	11405	3	0	3972
174745	2133	93810056000	22807	11405	4	0	3973
174746	2132	147850852000	22807	11405	5	0	1148
174747	1397	1303156450000	22808	11406	0	0	13567
174749	2133	93809054000	22808	11406	2	0	3974
174750	1397	1303146449000	22809	11407	0	0	13568
174751	2134	86557964000	22809	11407	1	0	4020
174752	2133	93808052000	22809	11407	2	0	3975
174757	2134	86556961000	22811	11408	1	0	4021
174758	2132	147849851000	22811	11408	2	0	1149
174761	2132	147849851000	22812	11408	2	0	\N
174765	1397	1303126447000	22814	11409	0	0	\N
174766	2134	86555958000	22814	11409	1	0	\N
174767	2133	93807050000	22814	11409	2	0	\N
174768	1397	1303126447000	22815	11409	0	0	\N
174769	2134	86555958000	22815	11409	1	0	\N
174770	2133	93807050000	22815	11409	2	0	\N
174771	2134	86555958000	22816	11409	0	0	\N
174772	2133	93807050000	22816	11409	1	0	\N
174773	1397	1303116446000	22817	11410	0	0	\N
174774	2134	86554955000	22817	11410	1	0	\N
174775	2134	86553952000	22817	11410	2	0	\N
174776	2133	93806048000	22817	11410	3	0	\N
174777	2133	93805046000	22817	11410	4	0	\N
174800	1397	1303226457000	22823	11400	0	0	\N
174811	1397	1303056440000	22826	11415	0	0	\N
174812	1397	1303046439000	22826	11415	1	0	\N
174813	1397	1303036438000	22826	11415	2	0	\N
174814	2133	93799034000	22826	11415	3	0	\N
174815	2133	93798032000	22826	11415	4	0	\N
174816	2133	93797030000	22826	11415	5	0	\N
174817	2132	147846848000	22826	11415	6	0	\N
174818	1397	1303026437000	22827	11416	0	0	\N
174819	2134	86544925000	22827	11416	1	0	\N
174820	2133	93796028000	22827	11416	2	0	\N
174824	1397	1303016436000	22829	11417	0	0	\N
174825	2119	194000000	22829	11417	1	0	\N
174826	2134	86543922000	22829	11417	2	0	\N
174827	2133	93795026000	22829	11417	3	0	\N
174836	1397	1303006435000	22832	11418	0	0	\N
174837	2133	93794024000	22832	11418	1	0	\N
174838	2132	147845847000	22832	11418	2	0	\N
174839	2134	86542919000	22832	11418	3	0	\N
174843	1397	1302996434000	22834	11419	0	0	\N
174844	2134	86541916000	22834	11419	1	0	\N
174845	2133	93793022000	22834	11419	2	0	\N
174846	1397	1302996434000	22835	11419	0	0	\N
174847	2134	86541916000	22835	11419	1	0	\N
174848	2133	93793022000	22835	11419	2	0	\N
174849	1397	1302986433000	22836	11420	0	0	\N
174850	2134	86540913000	22836	11420	1	0	\N
174864	1397	1302956430000	22840	11422	0	0	\N
174865	2133	93789014000	22840	11422	1	0	\N
174866	2134	86537904000	22840	11422	2	0	\N
174870	1580	2100034000000	22845	11424	0	0	\N
174871	1397	1302936428000	22845	11424	1	0	\N
174872	2132	147843845000	22845	11424	2	0	\N
174873	2134	86535898000	22845	11424	3	0	\N
174882	1397	1302916426000	22848	11426	0	0	\N
174883	2134	86533892000	22848	11426	1	0	\N
174884	2133	93785006000	22848	11426	2	0	\N
174885	1397	1302916426000	22849	11426	0	0	\N
174886	2134	86533892000	22849	11426	1	0	\N
174887	2133	93785006000	22849	11426	2	0	\N
174891	1397	1302916426000	22851	11426	0	0	\N
174892	2134	86533892000	22851	11426	1	0	\N
174893	2133	93785006000	22851	11426	2	0	\N
174894	2133	93792020000	22853	11422	0	0	\N
174895	1397	1302906425000	22854	11427	0	0	\N
174896	1580	24000000	22854	11427	1	0	\N
174764	2133	93807050000	22813	11409	2	0	3976
174778	1397	1303116446000	22818	11410	0	0	13571
174779	2134	86554955000	22818	11410	1	0	4023
174780	2134	86553952000	22818	11410	2	0	4024
174781	2133	93806048000	22818	11410	3	0	3977
174783	1397	1303106445000	22819	11411	0	0	13572
174784	1397	1303096444000	22819	11411	1	0	13573
174785	2134	86552949000	22819	11411	2	0	4025
174786	2134	86551946000	22819	11411	3	0	4026
174787	2133	93804044000	22819	11411	4	0	3979
174789	2132	147848850000	22819	11411	6	0	1150
174790	1397	1303086443000	22820	11412	0	0	13574
174791	2133	93802040000	22820	11412	1	0	3981
174792	2134	86550943000	22820	11412	2	0	4027
174794	2132	147847849000	22821	11413	1	0	1151
174795	2133	93801038000	22821	11413	2	0	3982
174796	2134	86549940000	22821	11413	3	0	4028
174797	1397	1303066441000	22822	11414	0	0	13576
174798	2133	93800036000	22822	11414	1	0	3983
174801	1397	1303056440000	22825	11415	0	0	13577
174802	1397	1303046439000	22825	11415	1	0	13578
174803	1397	1303036438000	22825	11415	2	0	13579
174804	2134	86547934000	22825	11415	3	0	4030
174805	2133	93799034000	22825	11415	4	0	3984
174807	2133	93797030000	22825	11415	6	0	3986
174808	2134	86546931000	22825	11415	7	0	4031
174809	2134	86545928000	22825	11415	8	0	4032
174810	2132	147846848000	22825	11415	9	0	1152
174822	2134	86544925000	22828	11416	1	0	4033
174823	2133	93796028000	22828	11416	2	0	3987
174828	1397	1303016436000	22830	11417	0	0	13581
174829	2119	194000000	22830	11417	1	0	6
174830	2134	86543922000	22830	11417	2	0	4034
174832	1397	1303006435000	22831	11418	0	0	13582
174833	2133	93794024000	22831	11418	1	0	3989
174834	2132	147845847000	22831	11418	2	0	1153
174835	2134	86542919000	22831	11418	3	0	4035
174840	1397	1302996434000	22833	11419	0	0	13583
174842	2133	93793022000	22833	11419	2	0	3990
174851	1397	1302986433000	22837	11420	0	0	13584
174852	2134	86540913000	22837	11420	1	0	4037
174853	2133	93792020000	22837	11420	2	0	3991
174855	1397	1302966431000	22838	11421	1	0	13586
174856	2133	93791018000	22838	11421	2	0	3992
174857	2133	93790016000	22838	11421	3	0	3993
174858	2134	86539910000	22838	11421	4	0	4038
174859	2134	86538907000	22838	11421	5	0	4039
174861	1397	1302956430000	22839	11422	0	0	13587
174862	2133	93789014000	22839	11422	1	0	3994
174863	2134	86537904000	22839	11422	2	0	4040
174867	1397	1302946429000	22844	11423	0	0	13588
174868	2133	93788012000	22844	11423	1	0	3995
174874	1580	2100034000000	22846	11424	0	0	1
174875	1397	1302936428000	22846	11424	1	0	13589
174876	2132	147843845000	22846	11424	2	0	1155
174877	2133	93787010000	22846	11424	3	0	3996
174879	1397	1302926427000	22847	11425	0	0	13590
174880	2134	86534895000	22847	11425	1	0	4043
174881	2133	93786008000	22847	11425	2	0	3997
174888	1397	1302916426000	22850	11426	0	0	13591
174889	2134	86533892000	22850	11426	1	0	4044
174897	2132	147842844000	22854	11427	2	0	\N
174898	2134	86532889000	22854	11427	3	0	\N
174899	2133	93784004000	22854	11427	4	0	\N
174900	1397	1302906425000	22855	11427	0	0	\N
174901	1580	24000000	22855	11427	1	0	\N
174902	2132	147842844000	22855	11427	2	0	\N
174903	2134	86532889000	22855	11427	3	0	\N
174904	2133	93784004000	22855	11427	4	0	\N
174914	1550	0	22858	11428	0	0	\N
174915	1397	1302896424000	22858	11428	1	0	\N
174916	2133	93783002000	22858	11428	2	0	\N
174917	2134	86532889000	22858	11428	3	0	\N
174918	2134	86531886000	22858	11428	4	0	\N
174919	1550	0	22859	11428	0	0	\N
174920	1397	1302896424000	22859	11428	1	0	\N
174921	2133	93783002000	22859	11428	2	0	\N
174922	2134	86532889000	22859	11428	3	0	\N
174923	2134	86531886000	22859	11428	4	0	\N
174924	1550	0	22860	11428	0	0	\N
174925	1397	1302896424000	22860	11428	1	0	\N
174926	2133	93783002000	22860	11428	2	0	\N
174927	2134	86532889000	22860	11428	3	0	\N
174932	1397	1302886423000	22862	11429	0	0	\N
174933	2133	93782000000	22862	11429	1	0	\N
174934	2119	193000000	22862	11429	2	0	\N
174935	2134	86530883000	22862	11429	3	0	\N
174936	1397	1302886423000	22863	11429	0	0	\N
174937	2133	93782000000	22863	11429	1	0	\N
174938	2119	193000000	22863	11429	2	0	\N
174939	2134	86530883000	22863	11429	3	0	\N
174940	1397	1302876422000	22864	11430	0	0	\N
174941	2132	147841843000	22864	11430	1	0	\N
174942	2134	86529880000	22864	11430	2	0	\N
174943	1603	61000000	22864	11430	3	0	\N
174944	2133	93780998000	22864	11430	4	0	\N
174950	1397	1302866421000	22866	11431	0	0	\N
174951	2134	86528877000	22866	11431	1	0	\N
174952	1531	89000000	22866	11431	2	0	\N
174953	2133	93779996000	22866	11431	3	0	\N
174954	1397	1302866421000	22867	11431	0	0	\N
174955	2134	86528877000	22867	11431	1	0	\N
174956	1531	89000000	22867	11431	2	0	\N
174957	2133	93779996000	22867	11431	3	0	\N
174962	1397	1302866421000	22869	11431	0	0	\N
174963	2134	86528877000	22869	11431	1	0	\N
174964	1531	89000000	22869	11431	2	0	\N
174965	2133	93779996000	22869	11431	3	0	\N
174966	1397	1302866421000	22870	11431	0	0	\N
174967	1397	1302856420000	22870	11431	1	0	\N
174968	2134	86528877000	22870	11431	2	0	\N
174969	1531	89000000	22870	11431	3	0	\N
174970	2133	93779996000	22870	11431	4	0	\N
174988	1397	1302826417000	22875	11435	0	0	\N
174989	1397	1302816416000	22875	11435	1	0	\N
174990	2134	86524865000	22875	11435	2	0	\N
174991	2133	93775988000	22875	11435	3	0	\N
174992	2134	86523862000	22875	11435	4	0	\N
174993	2133	93774986000	22875	11435	5	0	\N
174994	1397	1302806415000	22876	11436	0	0	\N
174995	2132	147839841000	22876	11436	1	0	\N
174996	2134	86522859000	22876	11436	2	0	\N
174997	2133	93773984000	22876	11436	3	0	\N
174998	1397	1302806415000	22877	11436	0	0	\N
174999	2132	147839841000	22877	11436	1	0	\N
175000	2134	86522859000	22877	11436	2	0	\N
175001	2133	93773984000	22877	11436	3	0	\N
175002	1397	1302806415000	22878	11436	0	0	\N
175003	2132	147839841000	22878	11436	1	0	\N
175004	2134	86522859000	22878	11436	2	0	\N
175005	2133	93773984000	22878	11436	3	0	\N
175010	1397	1302806415000	22880	11436	0	0	\N
175011	2132	147839841000	22880	11436	1	0	\N
175012	2134	86522859000	22880	11436	2	0	\N
175013	2133	93773984000	22880	11436	3	0	\N
175029	1397	1302766411000	22885	11440	0	0	\N
175030	1397	1302756410000	22885	11440	1	0	\N
175031	2133	93770978000	22885	11440	3	0	\N
175032	2133	93769976000	22885	11440	4	0	\N
174907	2132	147842844000	22856	11427	2	0	1156
174908	2133	93784004000	22856	11427	3	0	3999
174909	1550	0	22857	11428	0	0	1
174910	1397	1302896424000	22857	11428	1	0	13593
174911	2133	93783002000	22857	11428	2	0	4000
174913	2134	86531886000	22857	11428	4	0	4046
174928	1397	1302886423000	22861	11429	0	0	13594
174929	2133	93782000000	22861	11429	1	0	4001
174930	2119	193000000	22861	11429	2	0	7
174931	2134	86530883000	22861	11429	3	0	4047
174946	2132	147841843000	22865	11430	1	0	1157
174947	2134	86529880000	22865	11430	2	0	4048
174948	1603	61000000	22865	11430	3	0	1
174949	2133	93780998000	22865	11430	4	0	4002
174959	2134	86528877000	22868	11431	1	0	4049
174960	1531	89000000	22868	11431	2	0	1
174961	2133	93779996000	22868	11431	3	0	4003
174971	1397	1302856420000	22871	11432	0	0	13597
174972	2134	86527874000	22871	11432	1	0	4050
174974	1397	1302846419000	22872	11433	0	0	13598
174975	2133	93777992000	22872	11433	1	0	4005
174976	2134	86526871000	22872	11433	2	0	4051
174977	1397	1302836418000	22873	11434	0	0	13599
174978	1493	9000000	22873	11434	1	0	1
174980	2133	93776990000	22873	11434	3	0	4006
174981	2132	147840842000	22873	11434	4	0	1158
174982	1397	1302826417000	22874	11435	0	0	13600
174983	1397	1302816416000	22874	11435	1	0	13601
174985	2133	93775988000	22874	11435	3	0	4007
174986	2134	86523862000	22874	11435	4	0	4054
174987	2133	93774986000	22874	11435	5	0	4008
175006	1397	1302806415000	22879	11436	0	0	13602
175007	2132	147839841000	22879	11436	1	0	1159
175009	2133	93773984000	22879	11436	3	0	4009
175014	1397	1302796414000	22881	11437	0	0	13603
175015	2134	86521856000	22881	11437	1	0	4056
175016	1397	1302786413000	22882	11438	0	0	13604
175017	2134	86520853000	22882	11438	1	0	4057
175019	1397	1302776412000	22883	11439	0	0	13605
175020	2134	86519850000	22883	11439	1	0	4058
175021	2132	147838840000	22883	11439	2	0	1160
175022	2133	93771980000	22883	11439	3	0	4011
175024	1397	1302756410000	22884	11440	1	0	13607
175025	2133	93770978000	22884	11440	3	0	4012
175026	2133	93769976000	22884	11440	4	0	4013
175027	2134	86518847000	22884	11440	5	0	4059
175028	2134	86517844000	22884	11440	6	0	4060
175033	2134	86518847000	22885	11440	5	0	\N
175034	2134	86517844000	22885	11440	6	0	\N
175038	1397	1302736408000	22887	11442	0	0	\N
175039	2132	147837839000	22887	11442	1	0	\N
175040	2134	86515838000	22887	11442	2	0	\N
175041	2133	93767972000	22887	11442	3	0	\N
175042	1397	1302736408000	22888	11442	0	0	\N
175043	2132	147837839000	22888	11442	1	0	\N
175044	2134	86515838000	22888	11442	2	0	\N
175045	2133	93767972000	22888	11442	3	0	\N
175050	1397	1302866421000	22890	11431	0	0	\N
175051	1397	1302856420000	22890	11431	1	0	\N
175052	1397	1302846419000	22890	11431	2	0	\N
175053	1397	1302836418000	22890	11431	3	0	\N
175054	1397	1302826417000	22890	11431	4	0	\N
175055	1397	1302816416000	22890	11431	5	0	\N
175056	1397	1302806415000	22890	11431	6	0	\N
175057	1397	1302796414000	22890	11431	7	0	\N
175058	1397	1302786413000	22890	11431	8	0	\N
175059	1397	1302776412000	22890	11431	9	0	\N
175060	1397	1302766411000	22890	11431	10	0	\N
175061	1397	1302756410000	22890	11431	11	0	\N
175062	1397	1302746409000	22890	11431	12	0	\N
175063	1397	1302736408000	22890	11431	13	0	\N
175064	2134	86528877000	22890	11431	14	0	\N
175065	2134	86527874000	22890	11431	15	0	\N
175066	1531	89000000	22890	11431	16	0	\N
175067	1493	9000000	22890	11431	17	0	\N
175068	2133	93779996000	22890	11431	18	0	\N
175069	2134	86526871000	22890	11431	19	0	\N
175070	2134	86525868000	22890	11431	20	0	\N
175071	2134	86524865000	22890	11431	21	0	\N
175072	2134	86523862000	22890	11431	22	0	\N
175073	2134	86522859000	22890	11431	23	0	\N
175074	2134	86521856000	22890	11431	24	0	\N
175075	2134	86520853000	22890	11431	25	0	\N
175076	2134	86519850000	22890	11431	26	0	\N
175077	2134	86518847000	22890	11431	27	0	\N
175078	2132	147840842000	22890	11431	28	0	\N
175079	2132	147839841000	22890	11431	29	0	\N
175080	2132	147838840000	22890	11431	30	0	\N
175081	2132	147837839000	22890	11431	31	0	\N
175082	2133	93778994000	22890	11431	32	0	\N
175083	2133	93777992000	22890	11431	33	0	\N
175084	2133	93776990000	22890	11431	34	0	\N
175085	2133	93775988000	22890	11431	35	0	\N
175086	2134	86517844000	22890	11431	36	0	\N
175087	2134	86516841000	22890	11431	37	0	\N
175088	2134	86515838000	22890	11431	38	0	\N
175089	2133	93774986000	22890	11431	39	0	\N
175090	2133	93773984000	22890	11431	40	0	\N
175091	2133	93772982000	22890	11431	41	0	\N
175092	2133	93771980000	22890	11431	42	0	\N
175093	2133	93770978000	22890	11431	43	0	\N
175094	2133	93769976000	22890	11431	44	0	\N
175095	2133	93768974000	22890	11431	45	0	\N
175096	2133	93767972000	22890	11431	46	0	\N
175097	1397	1302726407000	22891	11443	0	0	\N
175098	2134	86514835000	22891	11443	1	0	\N
175099	2133	93766970000	22891	11443	2	0	\N
175103	1397	1302726407000	22893	11443	0	0	\N
175104	2133	93766970000	22893	11443	1	0	\N
175105	1397	1302716406000	22894	11444	0	0	\N
175106	2133	93765968000	22894	11444	1	0	\N
175107	2134	86513832000	22894	11444	2	0	\N
175111	1397	1302706405000	22896	11445	0	0	\N
175112	2134	86512829000	22896	11445	1	0	\N
175113	2133	93764966000	22896	11445	2	0	\N
175114	2132	147836838000	22896	11445	3	0	\N
175119	1397	1302696404000	22898	11446	0	0	\N
175120	2134	86511826000	22898	11446	1	0	\N
175121	2133	93763964000	22898	11446	2	0	\N
175125	1397	1302686403000	22900	11447	0	0	\N
175126	2134	86510823000	22900	11447	1	0	\N
175127	2133	93762962000	22900	11447	2	0	\N
175131	1397	1302686403000	22902	11447	0	0	\N
175132	2134	86510823000	22902	11447	1	0	\N
175133	2133	93762962000	22902	11447	2	0	\N
175134	2134	86514835000	22903	11432	0	0	\N
175135	2132	147836838000	22903	11432	1	0	\N
175136	2132	147835837000	22903	11432	2	0	\N
175137	2134	86513832000	22903	11432	3	0	\N
175138	2134	86512829000	22903	11432	4	0	\N
175139	2134	86511826000	22903	11432	6	0	\N
175140	2134	86510823000	22903	11432	7	0	\N
175141	2134	86509820000	22903	11432	8	0	\N
175146	1397	1302666401000	22905	11449	0	0	\N
175147	2133	93760958000	22905	11449	1	0	\N
175148	2134	86508817000	22905	11449	2	0	\N
175167	1397	1302656400000	22908	11450	0	0	\N
175168	1397	1302646399000	22908	11450	1	0	\N
175037	2133	93768974000	22886	11441	2	0	4014
175046	1397	1302736408000	22889	11442	0	0	13609
175047	2132	147837839000	22889	11442	1	0	1161
175048	2134	86515838000	22889	11442	2	0	4062
175049	2133	93767972000	22889	11442	3	0	4015
175101	2134	86514835000	22892	11443	1	0	4063
175102	2133	93766970000	22892	11443	2	0	4016
175108	1397	1302716406000	22895	11444	0	0	13611
175109	2133	93765968000	22895	11444	1	0	4017
175110	2134	86513832000	22895	11444	2	0	4064
175116	2134	86512829000	22897	11445	1	0	4065
175117	2133	93764966000	22897	11445	2	0	4018
175118	2132	147836838000	22897	11445	3	0	1162
175122	1397	1302696404000	22899	11446	0	0	13613
175124	2133	93763964000	22899	11446	2	0	4019
175128	1397	1302686403000	22901	11447	0	0	13614
175129	2134	86510823000	22901	11447	1	0	4067
175130	2133	93762962000	22901	11447	2	0	4020
175142	1397	1302676402000	22904	11448	0	0	13615
175144	2132	147835837000	22904	11448	2	0	1163
175145	2133	93761960000	22904	11448	3	0	4021
175149	1397	1302666401000	22906	11449	0	0	13616
175150	2133	93760958000	22906	11449	1	0	4022
175151	2134	86508817000	22906	11449	2	0	4069
175153	1397	1302646399000	22907	11450	1	0	13618
175154	1397	1302636398000	22907	11450	2	0	13619
175155	1422	21018034190073	22907	11450	3	0	8
175156	2133	93759956000	22907	11450	4	0	4023
175158	2133	93757952000	22907	11450	6	0	4025
175159	2132	147834836000	22907	11450	7	0	1164
175160	2134	86507814000	22907	11450	8	0	4070
175161	2134	86506811000	22907	11450	9	0	4071
175162	2134	86505808000	22907	11450	10	0	4072
175164	1447	14423624653000	22907	11450	12	0	8
175165	1447	12200418023000	22907	11450	13	0	9
175166	1447	10361677683000	22907	11450	14	0	10
175169	1397	1302636398000	22908	11450	2	0	\N
175170	1422	21018034190073	22908	11450	3	0	\N
175171	2132	147834836000	22908	11450	4	0	\N
175172	2134	86507814000	22908	11450	5	0	\N
175173	2134	86506811000	22908	11450	6	0	\N
175174	2134	86505808000	22908	11450	7	0	\N
175175	1447	17718630793000	22908	11450	8	0	\N
175176	1447	14423624653000	22908	11450	9	0	\N
175177	1447	12200418023000	22908	11450	10	0	\N
175178	1447	10361677683000	22908	11450	11	0	\N
175182	1397	1302626397000	22910	11451	0	0	\N
175183	2134	86504805000	22910	11451	1	0	\N
175184	2133	93756950000	22910	11451	2	0	\N
175188	1397	1302616396000	22912	11452	0	0	\N
175189	2134	86503802000	22912	11452	1	0	\N
175190	2133	93755948000	22912	11452	2	0	\N
175205	1397	1302566391000	22915	11455	0	0	\N
175206	2133	93750938000	22915	11455	1	0	\N
175207	845	573333333200000	22915	11455	2	0	\N
175208	2134	86498787000	22915	11455	3	0	\N
175209	845	573333333200000	22916	11455	0	0	\N
175210	2134	86498787000	22916	11455	1	0	\N
175219	1397	1302616396000	22919	11452	0	0	\N
175220	1397	1302606395000	22919	11452	1	0	\N
175221	1397	1302596394000	22919	11452	2	0	\N
175222	1397	1302586393000	22919	11452	3	0	\N
175223	1397	1302576392000	22919	11452	4	0	\N
175224	1397	1302566391000	22919	11452	5	0	\N
175225	1397	1302556390000	22919	11452	6	0	\N
175226	1397	1302546389000	22919	11452	7	0	\N
175227	846	573333333200000	22919	11452	8	0	\N
175228	2134	86503802000	22919	11452	9	0	\N
175229	2297	8154337013959	22919	11452	10	0	\N
175230	2132	147833835000	22919	11452	11	0	\N
175231	2132	147832834000	22919	11452	12	0	\N
175232	2134	86502799000	22919	11452	13	0	\N
175233	2133	93755948000	22919	11452	14	0	\N
175234	2133	93754946000	22919	11452	15	0	\N
175235	2133	93753944000	22919	11452	16	0	\N
175236	2133	93752942000	22919	11452	17	0	\N
175237	2133	93751940000	22919	11452	18	0	\N
175238	2133	93750938000	22919	11452	19	0	\N
175239	2133	93749936000	22919	11452	20	0	\N
175240	2133	93748934000	22919	11452	21	0	\N
175241	845	573333333200000	22919	11452	22	0	\N
175242	2134	86501796000	22919	11452	23	0	\N
175243	2134	86500793000	22919	11452	24	0	\N
175244	2134	86499790000	22919	11452	25	0	\N
175245	2134	86498787000	22919	11452	26	0	\N
175246	2134	86497784000	22919	11452	27	0	\N
175247	2134	86496781000	22919	11452	28	0	\N
175248	1397	1302546389000	22920	11457	0	0	\N
175249	2133	93748934000	22920	11457	1	0	\N
175250	2297	9362106805640	22920	11457	2	0	\N
175251	2134	86496781000	22920	11457	3	0	\N
175256	1397	1302536388000	22922	11453	0	0	\N
175257	2133	93747932000	22922	11453	1	0	\N
175258	2134	86495778000	22922	11453	2	0	\N
175259	2132	147831833000	22922	11453	3	0	\N
175260	1397	1302536388000	22923	11458	0	0	\N
175261	2134	86495778000	22923	11458	1	0	\N
175262	2132	147831833000	22923	11458	2	0	\N
175263	1397	1302536388000	22924	11458	0	0	\N
175264	2133	93747932000	22924	11458	1	0	\N
175265	2134	86495778000	22924	11458	2	0	\N
175266	2132	147831833000	22924	11458	3	0	\N
175267	1397	1302536388000	22925	11458	0	0	\N
175268	2133	93747932000	22925	11458	1	0	\N
175269	2134	86495778000	22925	11458	2	0	\N
175270	2132	147831833000	22925	11458	3	0	\N
175278	1550	0	22928	11402	0	0	\N
175279	1580	2100034000000	22928	11402	1	0	\N
175280	1580	24000000	22928	11402	2	0	\N
175281	846	573333333200000	22928	11402	3	0	\N
175282	1531	89000000	22928	11402	4	0	\N
175283	1422	21018030190073	22928	11402	5	0	\N
175284	1493	9000000	22928	11402	6	0	\N
175285	2297	8154337013959	22928	11402	7	0	\N
175286	2119	194000000	22928	11402	8	0	\N
175287	2133	93815066000	22928	11402	9	0	\N
175288	2134	86564985000	22928	11402	10	0	\N
175289	2119	193000000	22928	11402	11	0	\N
175290	2134	86563982000	22928	11402	12	0	\N
175291	2133	93814064000	22928	11402	13	0	\N
175292	845	573333333200000	22928	11402	14	0	\N
175293	1603	61000000	22928	11402	15	0	\N
175294	1447	16998606793000	22928	11402	16	0	\N
175295	1447	13703600653000	22928	11402	17	0	\N
175296	1447	11480394023000	22928	11402	18	0	\N
175297	1447	9641653683000	22928	11402	19	0	\N
175298	1397	1302686403000	22929	11447	0	0	\N
175299	1397	1302676402000	22929	11447	1	0	\N
175300	1397	1302666401000	22929	11447	2	0	\N
175301	1397	1302656400000	22929	11447	3	0	\N
175302	1397	1302646399000	22929	11447	4	0	\N
175303	1397	1302636398000	22929	11447	5	0	\N
175304	1397	1302626397000	22929	11447	6	0	\N
175181	2133	93756950000	22909	11451	2	0	4026
175185	1397	1302616396000	22911	11452	0	0	13621
175186	2134	86503802000	22911	11452	1	0	4074
175187	2133	93755948000	22911	11452	2	0	4027
175191	1397	1302606395000	22913	11453	0	0	13622
175193	1397	1302586393000	22913	11453	2	0	13624
175194	2132	147833835000	22913	11453	3	0	1165
175195	2134	86502799000	22913	11453	4	0	4075
175196	2133	93754946000	22913	11453	5	0	4028
175197	2133	93753944000	22913	11453	6	0	4029
175199	2134	86501796000	22913	11453	8	0	4076
175200	2134	86500793000	22913	11453	9	0	4077
175201	1397	1302576392000	22914	11454	0	0	13625
175202	2132	147832834000	22914	11454	1	0	1166
175204	2133	93751940000	22914	11454	3	0	4031
175211	1397	1302566391000	22917	11455	0	0	13626
175212	2133	93750938000	22917	11455	1	0	4032
175213	845	573333333200000	22917	11455	2	0	3
175214	2134	86498787000	22917	11455	3	0	4079
175216	846	573333333200000	22918	11456	1	0	2
175217	2133	93749936000	22918	11456	2	0	4033
175218	2134	86497784000	22918	11456	3	0	4080
175252	1397	1302546389000	22921	11457	0	0	13628
175253	2133	93748934000	22921	11457	1	0	4034
175255	2134	86496781000	22921	11457	3	0	4081
175271	1397	1302536388000	22926	11458	0	0	13629
175272	2133	93747932000	22926	11458	1	0	4035
175273	2134	86495778000	22926	11458	2	0	4082
175275	1397	1302526387000	22927	11459	0	0	13630
175276	2134	86494775000	22927	11459	1	0	4083
175277	2133	93746930000	22927	11459	2	0	4036
175305	1397	1302616396000	22929	11447	7	0	\N
175306	1397	1302606395000	22929	11447	8	0	\N
175307	1397	1302596394000	22929	11447	9	0	\N
175308	1397	1302586393000	22929	11447	10	0	\N
175309	1397	1302576392000	22929	11447	11	0	\N
175310	1397	1302566391000	22929	11447	12	0	\N
175311	1397	1302556390000	22929	11447	13	0	\N
175312	1397	1302546389000	22929	11447	14	0	\N
175313	1397	1302536388000	22929	11447	15	0	\N
175314	1397	1302526387000	22929	11447	16	0	\N
175315	846	573333333200000	22929	11447	17	0	\N
175316	1422	21018034190073	22929	11447	18	0	\N
175317	2134	86510823000	22929	11447	19	0	\N
175318	2134	86509820000	22929	11447	20	0	\N
175319	2297	8154337013959	22929	11447	21	0	\N
175320	2132	147835837000	22929	11447	22	0	\N
175321	2132	147834836000	22929	11447	23	0	\N
175322	2132	147833835000	22929	11447	24	0	\N
175323	2132	147832834000	22929	11447	25	0	\N
175324	2132	147831833000	22929	11447	26	0	\N
175325	2134	86508817000	22929	11447	27	0	\N
175326	2134	86507814000	22929	11447	28	0	\N
175327	2134	86506811000	22929	11447	29	0	\N
175328	2134	86505808000	22929	11447	30	0	\N
175329	2134	86504805000	22929	11447	31	0	\N
175330	2134	86503802000	22929	11447	32	0	\N
175331	2134	86502799000	22929	11447	33	0	\N
175332	2133	93762962000	22929	11447	34	0	\N
175333	845	573333333200000	22929	11447	35	0	\N
175334	1447	17718630793000	22929	11447	36	0	\N
175335	1447	14423624653000	22929	11447	37	0	\N
175336	1447	12200418023000	22929	11447	38	0	\N
175337	1447	10361677683000	22929	11447	39	0	\N
175338	2134	86501796000	22929	11447	40	0	\N
175339	2134	86500793000	22929	11447	41	0	\N
175340	2134	86499790000	22929	11447	42	0	\N
175341	2134	86498787000	22929	11447	43	0	\N
175342	2134	86497784000	22929	11447	44	0	\N
175343	2134	86496781000	22929	11447	45	0	\N
175344	2134	86495778000	22929	11447	46	0	\N
175345	2133	93761960000	22929	11447	47	0	\N
175346	2133	93760958000	22929	11447	48	0	\N
175347	2133	93759956000	22929	11447	49	0	\N
175348	2133	93758954000	22929	11447	50	0	\N
175349	2133	93757952000	22929	11447	51	0	\N
175350	2133	93756950000	22929	11447	52	0	\N
175351	2133	93755948000	22929	11447	53	0	\N
175352	2133	93754946000	22929	11447	54	0	\N
175353	2133	93753944000	22929	11447	55	0	\N
175354	2133	93752942000	22929	11447	56	0	\N
175355	2133	93751940000	22929	11447	57	0	\N
175356	2133	93750938000	22929	11447	58	0	\N
175357	2133	93749936000	22929	11447	59	0	\N
175358	2133	93748934000	22929	11447	60	0	\N
175359	2133	93747932000	22929	11447	61	0	\N
175360	2133	93746930000	22929	11447	62	0	\N
175364	1397	1302516386000	22931	11460	0	0	\N
175365	1397	1302516386000	22933	11460	0	0	\N
175366	2134	86493772000	22933	11460	1	0	\N
175367	2133	93745928000	22933	11460	2	0	\N
175372	1397	1302506385000	22935	11461	0	0	\N
175373	2134	86492769000	22935	11461	1	0	\N
175374	2132	147830832000	22935	11461	2	0	\N
175375	2133	93744926000	22935	11461	3	0	\N
175376	1397	1302506385000	22936	11461	0	0	\N
175377	2134	86492769000	22936	11461	1	0	\N
175378	2132	147830832000	22936	11461	2	0	\N
175379	2133	93744926000	22936	11461	3	0	\N
175380	1397	1302506385000	22937	11461	0	0	\N
175381	2134	86492769000	22937	11461	1	0	\N
175382	2132	147830832000	22937	11461	2	0	\N
175383	2133	93744926000	22937	11461	3	0	\N
175387	1397	1302496384000	22939	11462	0	0	\N
175388	2134	86491766000	22939	11462	1	0	\N
175389	2133	93743924000	22939	11462	2	0	\N
175393	1397	1302746409000	22941	11441	0	0	\N
175394	1397	1302736408000	22941	11441	1	0	\N
175395	1397	1302726407000	22941	11441	2	0	\N
175396	1397	1302716406000	22941	11441	3	0	\N
175397	1397	1302706405000	22941	11441	4	0	\N
175398	1397	1302696404000	22941	11441	5	0	\N
175399	1397	1302686403000	22941	11441	6	0	\N
175400	1397	1302676402000	22941	11441	7	0	\N
175401	1397	1302666401000	22941	11441	8	0	\N
175402	1397	1302656400000	22941	11441	9	0	\N
175403	1397	1302646399000	22941	11441	10	0	\N
175404	1397	1302636398000	22941	11441	11	0	\N
175405	1397	1302626397000	22941	11441	12	0	\N
175406	1397	1302616396000	22941	11441	13	0	\N
175407	1397	1302606395000	22941	11441	14	0	\N
175408	1397	1302596394000	22941	11441	15	0	\N
175409	1397	1302586393000	22941	11441	16	0	\N
175410	1397	1302576392000	22941	11441	17	0	\N
175411	1397	1302566391000	22941	11441	18	0	\N
175412	1397	1302556390000	22941	11441	19	0	\N
175413	1397	1302546389000	22941	11441	20	0	\N
175414	1397	1302536388000	22941	11441	21	0	\N
175415	1397	1302526387000	22941	11441	22	0	\N
175416	1397	1302516386000	22941	11441	23	0	\N
175417	1397	1302506385000	22941	11441	24	0	\N
175418	1397	1302496384000	22941	11441	25	0	\N
175419	1397	1302486383000	22941	11441	26	0	\N
175420	846	573333333200000	22941	11441	27	0	\N
175421	1422	21018034190073	22941	11441	28	0	\N
175422	2297	8154337013959	22941	11441	29	0	\N
175423	2132	147837839000	22941	11441	30	0	\N
175424	2132	147836838000	22941	11441	31	0	\N
175425	2132	147835837000	22941	11441	32	0	\N
175426	2132	147834836000	22941	11441	33	0	\N
175427	2132	147833835000	22941	11441	34	0	\N
175428	2132	147832834000	22941	11441	35	0	\N
175429	2132	147831833000	22941	11441	36	0	\N
175430	2132	147830832000	22941	11441	37	0	\N
175431	845	573333333200000	22941	11441	38	0	\N
175432	2134	86516841000	22941	11441	39	0	\N
175433	2134	86515838000	22941	11441	40	0	\N
175434	2134	86514835000	22941	11441	41	0	\N
175435	2134	86513832000	22941	11441	42	0	\N
175436	2134	86512829000	22941	11441	43	0	\N
175437	2134	86511826000	22941	11441	44	0	\N
175438	2134	86510823000	22941	11441	45	0	\N
175439	2134	86509820000	22941	11441	46	0	\N
175440	2134	86508817000	22941	11441	47	0	\N
175363	2133	93745928000	22930	11460	2	0	4037
175368	1397	1302506385000	22934	11461	0	0	13632
175369	2134	86492769000	22934	11461	1	0	4085
175370	2132	147830832000	22934	11461	2	0	1168
175371	2133	93744926000	22934	11461	3	0	4038
175385	2134	86491766000	22938	11462	1	0	4086
175386	2133	93743924000	22938	11462	2	0	4039
175390	1397	1302486383000	22940	11463	0	0	13634
175391	2134	86490763000	22940	11463	1	0	4087
175392	2133	93742922000	22940	11463	2	0	4040
175441	2134	86507814000	22941	11441	48	0	\N
175442	2134	86506811000	22941	11441	49	0	\N
175443	2134	86505808000	22941	11441	50	0	\N
175444	2134	86504805000	22941	11441	51	0	\N
175445	2134	86503802000	22941	11441	52	0	\N
175446	2134	86502799000	22941	11441	53	0	\N
175447	1447	17718630793000	22941	11441	54	0	\N
175448	1447	14423624653000	22941	11441	55	0	\N
175449	1447	12200418023000	22941	11441	56	0	\N
175450	1447	10361677683000	22941	11441	57	0	\N
175451	2134	86501796000	22941	11441	58	0	\N
175452	2134	86500793000	22941	11441	59	0	\N
175453	2134	86499790000	22941	11441	60	0	\N
175454	2134	86498787000	22941	11441	61	0	\N
175455	2134	86497784000	22941	11441	62	0	\N
175456	2134	86496781000	22941	11441	63	0	\N
175457	2134	86495778000	22941	11441	64	0	\N
175458	2134	86494775000	22941	11441	65	0	\N
175459	2134	86493772000	22941	11441	66	0	\N
175460	2134	86492769000	22941	11441	67	0	\N
175461	2134	86491766000	22941	11441	68	0	\N
175462	2134	86490763000	22941	11441	69	0	\N
175463	2133	93768974000	22941	11441	70	0	\N
175464	2133	93767972000	22941	11441	71	0	\N
175465	2133	93766970000	22941	11441	72	0	\N
175466	2133	93765968000	22941	11441	73	0	\N
175467	2133	93764966000	22941	11441	74	0	\N
175468	2133	93763964000	22941	11441	75	0	\N
175469	2133	93762962000	22941	11441	76	0	\N
175470	2133	93761960000	22941	11441	77	0	\N
175471	2133	93760958000	22941	11441	78	0	\N
175472	2133	93759956000	22941	11441	79	0	\N
175473	2133	93758954000	22941	11441	80	0	\N
175474	2133	93757952000	22941	11441	81	0	\N
175475	2133	93756950000	22941	11441	82	0	\N
175476	2133	93755948000	22941	11441	83	0	\N
175477	2133	93754946000	22941	11441	84	0	\N
175478	2133	93753944000	22941	11441	85	0	\N
175479	2133	93752942000	22941	11441	86	0	\N
175480	2133	93751940000	22941	11441	87	0	\N
175481	2133	93750938000	22941	11441	88	0	\N
175482	2133	93749936000	22941	11441	89	0	\N
175483	2133	93748934000	22941	11441	90	0	\N
175484	2133	93747932000	22941	11441	91	0	\N
175485	2133	93746930000	22941	11441	92	0	\N
175486	2133	93745928000	22941	11441	93	0	\N
175487	2133	93744926000	22941	11441	94	0	\N
175488	2133	93743924000	22941	11441	95	0	\N
175489	2133	93742922000	22941	11441	96	0	\N
175490	1397	1302476382000	22942	11464	0	0	\N
175491	1397	1302466381000	22942	11464	1	0	\N
175492	2134	86489760000	22942	11464	2	0	\N
175493	2133	93741920000	22942	11464	3	0	\N
175494	2133	93740918000	22942	11464	4	0	\N
175495	1422	19077349239740	22942	11464	5	0	\N
175496	2134	86488757000	22942	11464	6	0	\N
175497	2132	147829831000	22942	11464	7	0	\N
175504	1397	1302476382000	22944	11465	0	0	\N
175505	1397	1302466381000	22944	11465	1	0	\N
175506	1397	1302456380000	22944	11465	2	0	\N
175507	1397	1302446379000	22944	11465	3	0	\N
175508	1397	1302436378000	22944	11465	4	0	\N
175509	2132	147828830000	22944	11465	5	0	\N
175510	2133	93739916000	22944	11465	6	0	\N
175511	2133	93738914000	22944	11465	7	0	\N
175512	2133	93737912000	22944	11465	8	0	\N
175513	1457	21754165600000	22944	11465	9	0	\N
175514	1457	16525559160000	22944	11465	10	0	\N
175515	2134	86487754000	22944	11465	11	0	\N
175516	2134	86486751000	22944	11465	12	0	\N
175517	2134	86485748000	22944	11465	13	0	\N
175518	1457	12997869200000	22944	11465	14	0	\N
175519	1457	10080197800000	22944	11465	15	0	\N
175536	1397	1302426377000	22946	11466	0	0	\N
175537	2134	86484745000	22946	11466	1	0	\N
175538	2133	93736910000	22946	11466	2	0	\N
175539	1397	1302426377000	22947	11466	0	0	\N
175540	2134	86484745000	22947	11466	1	0	\N
175541	2133	93736910000	22947	11466	2	0	\N
175545	1397	1302426377000	22949	11466	0	0	\N
175546	2134	86484745000	22949	11466	1	0	\N
175547	2133	93736910000	22949	11466	2	0	\N
175548	2003	2075960654821	22950	11334	0	0	\N
175549	1550	0	22950	11334	1	0	\N
175550	1633	15559964847463	22950	11334	2	0	\N
175551	1633	13435820083107	22950	11334	3	0	\N
175552	1633	10287637513689	22950	11334	4	0	\N
175553	1580	2100034000000	22950	11334	5	0	\N
175554	1580	24000000	22950	11334	6	0	\N
175555	1397	1304206555000	22950	11334	7	0	\N
175556	1397	1304196554000	22950	11334	8	0	\N
175557	1397	1304186553000	22950	11334	9	0	\N
175558	1397	1304176552000	22950	11334	10	0	\N
175559	1397	1304166551000	22950	11334	11	0	\N
175560	1633	4368537125277	22950	11334	12	0	\N
175561	1397	1304156550000	22950	11334	13	0	\N
175562	1397	1304146549000	22950	11334	14	0	\N
175563	1397	1304136548000	22950	11334	15	0	\N
175564	1397	1304126547000	22950	11334	16	0	\N
175565	1397	1304116546000	22950	11334	17	0	\N
175566	1397	1304106545000	22950	11334	18	0	\N
175567	1397	1304096544000	22950	11334	19	0	\N
175568	1397	1304086543000	22950	11334	20	0	\N
175569	1397	1304076542000	22950	11334	21	0	\N
175570	1397	1304066541000	22950	11334	22	0	\N
175571	1397	1304056540000	22950	11334	23	0	\N
175572	1397	1304046539000	22950	11334	24	0	\N
175573	1397	1304036538000	22950	11334	25	0	\N
175574	1397	1304026537000	22950	11334	26	0	\N
175575	1397	1304016536000	22950	11334	27	0	\N
175576	1397	1304006535000	22950	11334	28	0	\N
175500	2133	93740918000	22943	11464	2	0	4042
175501	1422	19077349239740	22943	11464	3	0	9
175502	2134	86488757000	22943	11464	4	0	4089
175503	2132	147829831000	22943	11464	5	0	1169
175520	1397	1302476382000	22945	11465	0	0	13635
175522	1397	1302456380000	22945	11465	2	0	13637
175523	1397	1302446379000	22945	11465	3	0	13638
175524	1397	1302436378000	22945	11465	4	0	13639
175525	2132	147828830000	22945	11465	5	0	1170
175526	2133	93739916000	22945	11465	6	0	4043
175528	2133	93737912000	22945	11465	8	0	4045
175529	1457	21754165600000	22945	11465	9	0	5
175530	1457	16525559160000	22945	11465	10	0	6
175531	2134	86487754000	22945	11465	11	0	4090
175533	2134	86485748000	22945	11465	13	0	4092
175534	1457	12997869200000	22945	11465	14	0	7
175535	1457	10080197800000	22945	11465	15	0	8
175542	1397	1302426377000	22948	11466	0	0	13640
175543	2134	86484745000	22948	11466	1	0	4093
175577	1397	1303996534000	22950	11334	29	0	\N
175578	1397	1303986533000	22950	11334	30	0	\N
175579	1397	1303976532000	22950	11334	31	0	\N
175580	1397	1303966531000	22950	11334	32	0	\N
175581	1397	1303956530000	22950	11334	33	0	\N
175582	1397	1303946529000	22950	11334	34	0	\N
175583	1397	1303936528000	22950	11334	35	0	\N
175584	1397	1303926527000	22950	11334	36	0	\N
175585	1397	1303916526000	22950	11334	37	0	\N
175586	1397	1303906525000	22950	11334	38	0	\N
175587	1397	1303896524000	22950	11334	39	0	\N
175588	1397	1303886523000	22950	11334	40	0	\N
175589	1397	1303876522000	22950	11334	41	0	\N
175590	1397	1303866521000	22950	11334	42	0	\N
175591	1397	1303856520000	22950	11334	43	0	\N
175592	1397	1303846519000	22950	11334	44	0	\N
175593	1397	1303836518000	22950	11334	45	0	\N
175594	1397	1303826517000	22950	11334	46	0	\N
175595	1397	1303816516000	22950	11334	47	0	\N
175596	1397	1303806515000	22950	11334	49	0	\N
175597	1397	1303796514000	22950	11334	50	0	\N
175598	1397	1303786513000	22950	11334	51	0	\N
175599	1397	1303776512000	22950	11334	52	0	\N
175600	1397	1303766511000	22950	11334	53	0	\N
175601	1397	1303756510000	22950	11334	54	0	\N
175602	1397	1303746509000	22950	11334	55	0	\N
175603	1397	1303736508000	22950	11334	56	0	\N
175604	1397	1303726507000	22950	11334	57	0	\N
175605	1397	1303716506000	22950	11334	58	0	\N
175606	1397	1303706505000	22950	11334	59	0	\N
175607	1397	1303696504000	22950	11334	60	0	\N
175608	1397	1303686503000	22950	11334	61	0	\N
175609	1397	1303676502000	22950	11334	62	0	\N
175610	1397	1303666501000	22950	11334	63	0	\N
175611	1397	1303656500000	22950	11334	64	0	\N
175612	1397	1303646499000	22950	11334	65	0	\N
175613	1397	1303636498000	22950	11334	66	0	\N
175614	1397	1303626497000	22950	11334	67	0	\N
175615	1397	1303616496000	22950	11334	68	0	\N
175616	1397	1303606495000	22950	11334	69	0	\N
175617	1397	1303596494000	22950	11334	70	0	\N
175618	1397	1303586493000	22950	11334	71	0	\N
175619	1397	1303576492000	22950	11334	72	0	\N
175620	1397	1303566491000	22950	11334	73	0	\N
175621	1397	1303556490000	22950	11334	74	0	\N
175622	1397	1303546489000	22950	11334	75	0	\N
175623	1397	1303536488000	22950	11334	76	0	\N
175624	1397	1303526487000	22950	11334	77	0	\N
175625	1397	1303516486000	22950	11334	78	0	\N
175626	1397	1303506485000	22950	11334	79	0	\N
175627	1397	1303496484000	22950	11334	80	0	\N
175628	1397	1303486483000	22950	11334	81	0	\N
175629	1397	1303476482000	22950	11334	82	0	\N
175630	1397	1303466481000	22950	11334	83	0	\N
175631	1397	1303456480000	22950	11334	84	0	\N
175632	1397	1303446479000	22950	11334	85	0	\N
175633	1397	1303436478000	22950	11334	86	0	\N
175634	1397	1303426477000	22950	11334	87	0	\N
175635	1397	1303416476000	22950	11334	88	0	\N
175636	1397	1303406475000	22950	11334	89	0	\N
175637	1397	1303396474000	22950	11334	90	0	\N
175638	1397	1303386473000	22950	11334	91	0	\N
175639	1397	1303376472000	22950	11334	92	0	\N
175640	1397	1303366471000	22950	11334	93	0	\N
175641	1397	1303356470000	22950	11334	94	0	\N
175642	1397	1303346469000	22950	11334	95	0	\N
175643	1397	1303336468000	22950	11334	96	0	\N
175644	1397	1303326467000	22950	11334	97	0	\N
175645	1397	1303316466000	22950	11334	98	0	\N
175646	1397	1303306465000	22950	11334	99	0	\N
175647	1397	1303296464000	22950	11334	100	0	\N
175648	1397	1303286463000	22950	11334	101	0	\N
175649	1397	1303276462000	22950	11334	102	0	\N
175650	1397	1303266461000	22950	11334	103	0	\N
175651	1397	1303256460000	22950	11334	104	0	\N
175652	1397	1303246459000	22950	11334	105	0	\N
175653	1397	1303236458000	22950	11334	106	0	\N
175654	1397	1303226457000	22950	11334	107	0	\N
175655	1397	1303216456000	22950	11334	108	0	\N
175656	1397	1303206455000	22950	11334	109	0	\N
175657	1397	1303196454000	22950	11334	110	0	\N
175658	1397	1303186453000	22950	11334	111	0	\N
175659	1397	1303176452000	22950	11334	112	0	\N
175660	1397	1303166451000	22950	11334	113	0	\N
175661	1397	1303156450000	22950	11334	114	0	\N
175662	1397	1303146449000	22950	11334	115	0	\N
175663	1397	1303136448000	22950	11334	116	0	\N
175664	1397	1303126447000	22950	11334	117	0	\N
175665	1397	1303116446000	22950	11334	118	0	\N
175666	1397	1303106445000	22950	11334	119	0	\N
175667	1397	1303096444000	22950	11334	120	0	\N
175668	1397	1303086443000	22950	11334	121	0	\N
175669	1397	1303076442000	22950	11334	122	0	\N
175670	1397	1303066441000	22950	11334	123	0	\N
175671	1397	1303056440000	22950	11334	124	0	\N
175672	1397	1303046439000	22950	11334	125	0	\N
175681	1397	1302416376000	22952	11467	0	0	\N
175682	1397	1302406375000	22952	11467	1	0	\N
175683	2133	93735908000	22952	11467	2	0	\N
175684	2133	93734906000	22952	11467	3	0	\N
175685	2132	147827829000	22952	11467	4	0	\N
175686	2119	192000000	22952	11467	5	0	\N
175687	2134	86483742000	22952	11467	6	0	\N
175688	2134	86482739000	22952	11467	7	0	\N
175689	1397	1302526387000	22953	11454	0	0	\N
175690	1397	1302516386000	22953	11454	1	0	\N
175691	1397	1302506385000	22953	11454	2	0	\N
175692	1397	1302496384000	22953	11454	3	0	\N
175693	1397	1302486383000	22953	11454	4	0	\N
175694	1397	1302476382000	22953	11454	5	0	\N
175695	1397	1302466381000	22953	11454	6	0	\N
175696	1397	1302456380000	22953	11454	7	0	\N
175697	1397	1302446379000	22953	11454	8	0	\N
175698	1397	1302436378000	22953	11454	9	0	\N
175699	1397	1302426377000	22953	11454	10	0	\N
175700	1397	1302416376000	22953	11454	11	0	\N
175701	1397	1302406375000	22953	11454	12	0	\N
175702	1397	1302396374000	22953	11454	13	0	\N
175703	2134	86494775000	22953	11454	15	0	\N
175704	2134	86493772000	22953	11454	16	0	\N
175705	2134	86492769000	22953	11454	17	0	\N
175706	2132	147830832000	22953	11454	18	0	\N
175707	2119	192000000	22953	11454	19	0	\N
175708	2133	93746930000	22953	11454	20	0	\N
175709	2134	86491766000	22953	11454	21	0	\N
175710	2134	86490763000	22953	11454	22	0	\N
175711	2134	86489760000	22953	11454	23	0	\N
175712	1422	19077349239740	22953	11454	24	0	\N
175675	2133	93735908000	22951	11467	2	0	4047
175676	2133	93734906000	22951	11467	3	0	4048
175677	2132	147827829000	22951	11467	4	0	1171
175678	2119	192000000	22951	11467	5	0	8
175679	2134	86483742000	22951	11467	6	0	4094
175713	2134	86488757000	22953	11454	25	0	\N
175714	2132	147829831000	22953	11454	26	0	\N
175715	2132	147828830000	22953	11454	27	0	\N
175716	2132	147827829000	22953	11454	28	0	\N
175717	1457	21754165600000	22953	11454	29	0	\N
175718	1457	16525559160000	22953	11454	30	0	\N
175719	2134	86487754000	22953	11454	31	0	\N
175720	2134	86486751000	22953	11454	32	0	\N
175721	2134	86485748000	22953	11454	33	0	\N
175722	2134	86484745000	22953	11454	34	0	\N
175723	1457	12997869200000	22953	11454	35	0	\N
175724	1457	10080197800000	22953	11454	36	0	\N
175725	2133	93745928000	22953	11454	37	0	\N
175726	2133	93744926000	22953	11454	38	0	\N
175727	2133	93743924000	22953	11454	39	0	\N
175728	2133	93742922000	22953	11454	40	0	\N
175729	2133	93741920000	22953	11454	41	0	\N
175730	2133	93740918000	22953	11454	42	0	\N
175731	2133	93739916000	22953	11454	43	0	\N
175732	2133	93738914000	22953	11454	44	0	\N
175733	2133	93737912000	22953	11454	45	0	\N
175734	2133	93736910000	22953	11454	46	0	\N
175735	2133	93735908000	22953	11454	47	0	\N
175736	2133	93734906000	22953	11454	48	0	\N
175737	2133	93733904000	22953	11454	49	0	\N
175738	2134	86483742000	22953	11454	50	0	\N
175739	2134	86482739000	22953	11454	51	0	\N
175740	2134	86481736000	22953	11454	52	0	\N
175747	1397	1302476382000	22956	11442	0	0	\N
175748	1397	1302466381000	22956	11442	1	0	\N
175749	1397	1302456380000	22956	11442	2	0	\N
175750	1397	1302446379000	22956	11442	3	0	\N
175751	1397	1302436378000	22956	11442	4	0	\N
175752	1397	1302426377000	22956	11442	5	0	\N
175753	1397	1302416376000	22956	11442	6	0	\N
175754	1397	1302406375000	22956	11442	7	0	\N
175755	1397	1302396374000	22956	11442	8	0	\N
175756	1397	1302386373000	22956	11442	9	0	\N
175757	2119	192000000	22956	11442	10	0	\N
175758	2134	86489760000	22956	11442	11	0	\N
175759	2133	93741920000	22956	11442	12	0	\N
175760	2133	93740918000	22956	11442	13	0	\N
175761	1422	19077349239740	22956	11442	14	0	\N
175762	2134	86488757000	22956	11442	15	0	\N
175763	2132	147829831000	22956	11442	16	0	\N
175764	2132	147828830000	22956	11442	17	0	\N
175765	2132	147827829000	22956	11442	18	0	\N
175766	2133	93739916000	22956	11442	19	0	\N
175767	2133	93738914000	22956	11442	20	0	\N
175768	2133	93737912000	22956	11442	21	0	\N
175769	1457	21754165600000	22956	11442	23	0	\N
175770	1457	16525559160000	22956	11442	24	0	\N
175771	2134	86487754000	22956	11442	25	0	\N
175772	2134	86486751000	22956	11442	26	0	\N
175773	2134	86485748000	22956	11442	27	0	\N
175774	2134	86484745000	22956	11442	28	0	\N
175775	1457	12997869200000	22956	11442	29	0	\N
175776	1457	10080197800000	22956	11442	30	0	\N
175777	2133	93736910000	22956	11442	31	0	\N
175778	2133	93735908000	22956	11442	32	0	\N
175779	2133	93734906000	22956	11442	33	0	\N
175780	2133	93733904000	22956	11442	34	0	\N
175781	2133	93732902000	22956	11442	35	0	\N
175782	2134	86483742000	22956	11442	36	0	\N
175783	2134	86482739000	22956	11442	37	0	\N
175784	2134	86481736000	22956	11442	38	0	\N
175785	2134	86480733000	22956	11442	39	0	\N
175805	1397	1302326367000	22958	11471	0	0	\N
175806	2134	86474715000	22958	11471	1	0	\N
175807	1569	847999991	22958	11471	2	0	\N
175808	2133	93726890000	22958	11471	3	0	\N
175809	1397	1302326367000	22959	11471	0	0	\N
175810	2134	86474715000	22959	11471	1	0	\N
175811	1569	847999991	22959	11471	2	0	\N
175812	2133	93726890000	22959	11471	3	0	\N
175817	1397	1302316366000	22961	11472	0	0	\N
175818	2133	93725888000	22961	11472	1	0	\N
175819	2134	86473712000	22961	11472	2	0	\N
175820	1397	1302316366000	22962	11472	0	0	\N
175821	2133	93725888000	22962	11472	1	0	\N
175822	2134	86473712000	22962	11472	2	0	\N
175826	1397	1302316366000	22964	11472	0	0	\N
175827	2133	93725888000	22964	11472	1	0	\N
175828	2134	86473712000	22964	11472	2	0	\N
175829	2133	93725888000	22965	11472	0	0	\N
175830	2134	86473712000	22965	11472	1	0	\N
175835	1397	1302306365000	22967	11473	0	0	\N
175836	2133	93724886000	22967	11473	1	0	\N
175837	2132	147824826000	22967	11473	2	0	\N
175844	1397	1302276362000	22969	11475	0	0	\N
175845	2134	86469700000	22969	11475	1	0	\N
175846	1397	1302276362000	22970	11475	0	0	\N
175847	2134	86469700000	22970	11475	1	0	\N
175848	1397	1302276362000	22971	11475	0	0	\N
175743	2134	86481736000	22954	11468	2	0	4096
175744	1397	1302386373000	22955	11469	0	0	13644
175745	2133	93732902000	22955	11469	1	0	4050
175746	2134	86480733000	22955	11469	2	0	4097
175786	1397	1302376372000	22957	11470	0	0	13645
175788	1474	6665473000043	22957	11470	2	0	27
175789	1397	1302356370000	22957	11470	3	0	13647
175790	1397	1302346369000	22957	11470	4	0	13648
175791	1397	1302336368000	22957	11470	5	0	13649
175792	1422	16730882166024	22957	11470	6	0	10
175794	2132	147825827000	22957	11470	8	0	1173
175795	2133	93731900000	22957	11470	9	0	4051
175796	2133	93730898000	22957	11470	10	0	4052
175797	2133	93729896000	22957	11470	11	0	4053
175799	2133	93727892000	22957	11470	13	0	4055
175800	2134	86479730000	22957	11470	14	0	4098
175801	2134	86478727000	22957	11470	15	0	4099
175802	2134	86477724000	22957	11470	16	0	4100
175803	2134	86476721000	22957	11470	17	0	4101
175813	1397	1302326367000	22960	11471	0	0	13650
175814	2134	86474715000	22960	11471	1	0	4103
175815	1569	847999991	22960	11471	2	0	4
175816	2133	93726890000	22960	11471	3	0	4056
175823	1397	1302316366000	22963	11472	0	0	13651
175825	2134	86473712000	22963	11472	2	0	4104
175831	1397	1302306365000	22966	11473	0	0	13652
175832	2133	93724886000	22966	11473	1	0	4058
175833	2134	86472709000	22966	11473	2	0	4105
175838	1397	1302296364000	22968	11474	0	0	13653
175839	1397	1302286363000	22968	11474	1	0	13654
175840	2133	93723884000	22968	11474	2	0	4059
175841	2133	93722882000	22968	11474	3	0	4060
175842	2134	86471706000	22968	11474	4	0	4106
175849	2134	86469700000	22971	11475	1	0	\N
175856	1397	1302266361000	22974	11476	0	0	\N
175857	2133	93721880000	22974	11476	1	0	\N
175858	2132	147823825000	22974	11476	2	0	\N
175862	1397	1302256360000	22976	11477	0	0	\N
175863	2133	93720878000	22976	11477	1	0	\N
175864	1397	1302246359000	22977	11478	0	0	\N
175865	2133	93719876000	22977	11478	1	0	\N
175868	1397	1302246359000	22979	11478	0	0	\N
175869	2133	93719876000	22979	11478	1	0	\N
175870	1397	1303196454000	22980	11402	0	0	\N
175871	1550	0	22980	11402	1	0	\N
175872	1474	6665473000043	22980	11402	2	0	\N
175873	1397	1303186453000	22980	11402	3	0	\N
175874	1397	1303176452000	22980	11402	4	0	\N
175875	1397	1303166451000	22980	11402	5	0	\N
175876	1397	1303156450000	22980	11402	6	0	\N
175877	1580	2100034000000	22980	11402	7	0	\N
175878	1580	24000000	22980	11402	8	0	\N
175879	1397	1303146449000	22980	11402	9	0	\N
175880	1397	1303136448000	22980	11402	10	0	\N
175881	1397	1303126447000	22980	11402	11	0	\N
175882	1397	1303116446000	22980	11402	12	0	\N
175883	1397	1303106445000	22980	11402	13	0	\N
175884	1397	1303096444000	22980	11402	14	0	\N
175885	1397	1303086443000	22980	11402	15	0	\N
175886	1397	1303076442000	22980	11402	16	0	\N
175887	1397	1303066441000	22980	11402	17	0	\N
175888	1397	1303056440000	22980	11402	18	0	\N
175889	1397	1303046439000	22980	11402	19	0	\N
175890	1397	1303036438000	22980	11402	20	0	\N
175891	1397	1303026437000	22980	11402	21	0	\N
175892	1397	1303016436000	22980	11402	22	0	\N
175893	1397	1303006435000	22980	11402	23	0	\N
175894	1397	1302996434000	22980	11402	24	0	\N
175895	1397	1302986433000	22980	11402	25	0	\N
175896	1397	1302976432000	22980	11402	26	0	\N
175897	1397	1302966431000	22980	11402	27	0	\N
175898	1397	1302956430000	22980	11402	28	0	\N
175899	1397	1302946429000	22980	11402	29	0	\N
175900	1397	1302936428000	22980	11402	30	0	\N
175901	1397	1302926427000	22980	11402	31	0	\N
175902	1397	1302916426000	22980	11402	32	0	\N
175903	1397	1302906425000	22980	11402	33	0	\N
175904	1397	1302896424000	22980	11402	34	0	\N
175905	1397	1302886423000	22980	11402	35	0	\N
175906	1397	1302876422000	22980	11402	36	0	\N
175907	1397	1302866421000	22980	11402	37	0	\N
175908	1397	1302856420000	22980	11402	38	0	\N
175909	1397	1302846419000	22980	11402	39	0	\N
175910	1397	1302836418000	22980	11402	40	0	\N
175911	1397	1302826417000	22980	11402	41	0	\N
175912	1397	1302816416000	22980	11402	42	0	\N
175913	1397	1302806415000	22980	11402	43	0	\N
175914	1397	1302796414000	22980	11402	44	0	\N
175915	1397	1302786413000	22980	11402	45	0	\N
175916	1397	1302776412000	22980	11402	46	0	\N
175917	1397	1302766411000	22980	11402	47	0	\N
175918	1397	1302756410000	22980	11402	48	0	\N
175919	1397	1302746409000	22980	11402	49	0	\N
175920	1397	1302736408000	22980	11402	50	0	\N
175921	1397	1302726407000	22980	11402	51	0	\N
175922	1397	1302716406000	22980	11402	52	0	\N
175923	1397	1302706405000	22980	11402	53	0	\N
175924	1397	1302696404000	22980	11402	54	0	\N
175925	1397	1302686403000	22980	11402	55	0	\N
175926	1397	1302676402000	22980	11402	56	0	\N
175927	1397	1302666401000	22980	11402	57	0	\N
175928	1397	1302656400000	22980	11402	58	0	\N
175929	1397	1302646399000	22980	11402	59	0	\N
175930	1397	1302636398000	22980	11402	60	0	\N
175931	1397	1302626397000	22980	11402	61	0	\N
175932	1397	1302616396000	22980	11402	62	0	\N
175933	1397	1302606395000	22980	11402	63	0	\N
175934	1397	1302596394000	22980	11402	64	0	\N
175935	1397	1302586393000	22980	11402	65	0	\N
175936	1397	1302576392000	22980	11402	66	0	\N
175937	1397	1302566391000	22980	11402	67	0	\N
175938	1397	1302556390000	22980	11402	68	0	\N
175939	1397	1302546389000	22980	11402	69	0	\N
175940	1397	1302536388000	22980	11402	70	0	\N
175941	1397	1302526387000	22980	11402	71	0	\N
175942	1397	1302516386000	22980	11402	72	0	\N
175943	1397	1302506385000	22980	11402	73	0	\N
175944	1397	1302496384000	22980	11402	74	0	\N
175945	1397	1302486383000	22980	11402	75	0	\N
175946	1397	1302476382000	22980	11402	76	0	\N
175947	1397	1302466381000	22980	11402	77	0	\N
175948	1397	1302456380000	22980	11402	78	0	\N
175949	1397	1302446379000	22980	11402	79	0	\N
175950	1397	1302436378000	22980	11402	80	0	\N
175951	1397	1302426377000	22980	11402	81	0	\N
175952	1397	1302416376000	22980	11402	82	0	\N
175953	1397	1302406375000	22980	11402	83	0	\N
175954	1397	1302396374000	22980	11402	84	0	\N
175955	1397	1302386373000	22980	11402	85	0	\N
175956	1397	1302376372000	22980	11402	86	0	\N
175957	1397	1302366371000	22980	11402	87	0	\N
175958	1397	1302356370000	22980	11402	88	0	\N
175959	1397	1302346369000	22980	11402	89	0	\N
175960	1397	1302336368000	22980	11402	90	0	\N
175961	1397	1302326367000	22980	11402	91	0	\N
175962	1397	1302316366000	22980	11402	92	0	\N
175963	1397	1302306365000	22980	11402	93	0	\N
175964	1397	1302296364000	22980	11402	94	0	\N
175965	1397	1302286363000	22980	11402	95	0	\N
175966	1397	1302276362000	22980	11402	96	0	\N
175967	1397	1302266361000	22980	11402	97	0	\N
175968	1397	1302256360000	22980	11402	98	0	\N
175969	1397	1302246359000	22980	11402	99	0	\N
175970	846	573333333200000	22980	11402	100	0	\N
175971	1531	89000000	22980	11402	101	0	\N
175972	1422	21018034190073	22980	11402	103	0	\N
175973	1493	9000000	22980	11402	104	0	\N
175974	2297	8154337013959	22980	11402	105	0	\N
175975	2119	194000000	22980	11402	106	0	\N
175976	2119	193000000	22980	11402	107	0	\N
175977	2119	192000000	22980	11402	108	0	\N
175978	1422	19077349239740	22980	11402	109	0	\N
175979	1422	16730882166024	22980	11402	110	0	\N
175980	1457	21754165600000	22980	11402	111	0	\N
175981	1457	16525559160000	22980	11402	112	0	\N
175982	1457	12997869200000	22980	11402	113	0	\N
175983	1457	10080197800000	22980	11402	114	0	\N
175984	845	573333333200000	22980	11402	115	0	\N
175852	1397	1302266361000	22973	11476	0	0	13656
175853	2133	93721880000	22973	11476	1	0	4061
175854	2132	147823825000	22973	11476	2	0	1175
175855	2134	86468697000	22973	11476	3	0	4109
175859	1397	1302256360000	22975	11477	0	0	13657
175861	2133	93720878000	22975	11477	2	0	4062
175866	1397	1302246359000	22978	11478	0	0	13658
175867	2133	93719876000	22978	11478	1	0	4063
175985	1603	61000000	22980	11402	116	0	\N
175986	1447	16998606793000	22980	11402	117	0	\N
175987	1447	13703600653000	22980	11402	118	0	\N
175988	1447	11480394023000	22980	11402	119	0	\N
175989	1447	9641653683000	22980	11402	120	0	\N
175998	1397	1302236358000	22982	11479	0	0	\N
175999	1397	1302226357000	22982	11479	1	0	\N
176000	1397	1302216356000	22982	11479	2	0	\N
176001	2133	93718874000	22982	11479	3	0	\N
176002	2133	93717872000	22982	11479	4	0	\N
176003	2132	147822824000	22982	11479	5	0	\N
176004	2134	86466691000	22982	11479	6	0	\N
176005	2133	93716870000	22982	11479	7	0	\N
176013	1397	1302176352000	22984	11481	0	0	\N
176014	2132	147821823000	22984	11481	1	0	\N
176015	2133	93712862000	22984	11481	2	0	\N
176016	1397	1302206355000	22985	11480	0	0	\N
176017	1397	1302196354000	22985	11480	1	0	\N
176018	1397	1302186353000	22985	11480	2	0	\N
176019	1397	1302176352000	22985	11480	3	0	\N
176020	1422	13253192154809	22985	11480	4	0	\N
176021	2132	147821823000	22985	11480	5	0	\N
176022	2133	93715868000	22985	11480	6	0	\N
176023	2133	93714866000	22985	11480	7	0	\N
176024	2133	93713864000	22985	11480	8	0	\N
176025	2133	93712862000	22985	11480	9	0	\N
176028	1397	1302176352000	22987	11482	0	0	\N
176029	1397	1302166351000	22987	11482	1	0	\N
176030	1397	1302156350000	22987	11482	2	0	\N
176031	2133	93711860000	22987	11482	3	0	\N
176032	1422	6714554804270	22987	11482	4	0	\N
176033	2133	93710858000	22987	11482	5	0	\N
176038	1397	1302166351000	22989	11483	0	0	\N
176039	1397	1302156350000	22989	11483	1	0	\N
176040	1397	1302146349000	22989	11483	2	0	\N
176041	2132	147820822000	22989	11483	3	0	\N
176042	2133	93709856000	22989	11483	4	0	\N
176047	1397	1302136348000	22991	11484	0	0	\N
176048	1397	1302126347000	22991	11484	1	0	\N
176049	2132	147820822000	22991	11484	2	0	\N
176050	2133	93708854000	22991	11484	3	0	\N
176051	2133	93707852000	22991	11484	4	0	\N
176084	1397	1302036338000	22997	11489	0	0	\N
176085	2134	86457664000	22997	11489	1	0	\N
176086	2133	93698834000	22997	11489	2	0	\N
176093	1397	1302026337000	23000	11490	0	0	\N
176094	2134	86456661000	23000	11490	1	0	\N
176095	2133	93697832000	23000	11490	2	0	\N
176096	1397	1302026337000	23001	11490	0	0	\N
176097	2134	86456661000	23001	11490	1	0	\N
176098	2133	93697832000	23001	11490	2	0	\N
176099	1397	1302026337000	23002	11490	0	0	\N
176100	2134	86456661000	23002	11490	1	0	\N
176101	2133	93697832000	23002	11490	2	0	\N
176109	1397	1301996334000	23005	11493	0	0	\N
176110	2134	86453652000	23005	11493	1	0	\N
176111	2133	93694826000	23005	11493	2	0	\N
176112	1397	1301996334000	23006	11493	0	0	\N
176113	2134	86453652000	23006	11493	1	0	\N
176114	2133	93694826000	23006	11493	2	0	\N
176118	1397	1301996334000	23008	11493	0	0	\N
176119	2133	93694826000	23008	11493	1	0	\N
176120	1397	1301986333000	23009	11494	0	0	\N
175992	1397	1302216356000	22981	11479	2	0	13661
175993	2133	93718874000	22981	11479	3	0	4064
175994	2133	93717872000	22981	11479	4	0	4065
175995	2132	147822824000	22981	11479	5	0	1176
175996	2134	86466691000	22981	11479	6	0	4111
176006	1397	1302206355000	22983	11480	0	0	13662
176007	1397	1302196354000	22983	11480	1	0	13663
176008	1397	1302186353000	22983	11480	2	0	13664
176009	1422	13253192154809	22983	11480	3	0	11
176010	2133	93715868000	22983	11480	4	0	4067
176012	2133	93713864000	22983	11480	6	0	4069
176026	2132	147821823000	22986	11481	0	0	1177
176027	2133	93712862000	22986	11481	1	0	4070
176034	1397	1302176352000	22988	11482	0	0	13665
176036	1422	6714554804270	22988	11482	2	0	12
176037	2133	93710858000	22988	11482	3	0	4072
176043	1397	1302166351000	22990	11483	0	0	13666
176044	1397	1302156350000	22990	11483	1	0	13667
176045	1397	1302146349000	22990	11483	2	0	13668
176052	1397	1302136348000	22992	11484	0	0	13669
176053	1397	1302126347000	22992	11484	1	0	13670
176054	2132	147820822000	22992	11484	2	0	1178
176055	2133	93708854000	22992	11484	3	0	4074
176056	2133	93707852000	22992	11484	4	0	4075
176058	2133	93706850000	22993	11485	1	0	4076
176059	2134	86465688000	22993	11485	2	0	4112
176060	1397	1302106345000	22994	11486	0	0	13672
176061	2133	93705848000	22994	11486	1	0	4077
176063	2132	147819821000	22994	11486	3	0	1179
176064	1397	1302096344000	22995	11487	0	0	13673
176065	1397	1302086343000	22995	11487	1	0	13674
176066	2134	86463682000	22995	11487	2	0	4114
176067	2134	86462679000	22995	11487	3	0	4115
176069	2133	93703844000	22995	11487	5	0	4079
176070	1397	1302076342000	22996	11488	0	0	13675
176071	1397	1302066341000	22996	11488	1	0	13676
176072	1397	1302056340000	22996	11488	2	0	13677
176073	1397	1302046339000	22996	11488	3	0	13678
176075	2134	86460673000	22996	11488	5	0	4117
176076	2132	147818820000	22996	11488	6	0	1180
176077	2132	147817819000	22996	11488	7	0	1181
176078	2133	93702842000	22996	11488	8	0	4080
176080	2133	93700838000	22996	11488	10	0	4082
176081	2133	93699836000	22996	11488	11	0	4083
176082	2134	86459670000	22996	11488	12	0	4118
176083	2134	86458667000	22996	11488	13	0	4119
176087	1397	1302036338000	22998	11489	0	0	13679
176089	2133	93698834000	22998	11489	2	0	4084
176090	1397	1302026337000	22999	11490	0	0	13680
176091	2134	86456661000	22999	11490	1	0	4121
176092	2133	93697832000	22999	11490	2	0	4085
176102	1397	1302016336000	23003	11491	0	0	13681
176121	1397	1301976332000	23009	11494	1	0	\N
176122	2132	147815817000	23009	11494	2	0	\N
176123	2133	93693824000	23009	11494	3	0	\N
176124	2133	93692822000	23009	11494	4	0	\N
176125	2134	86453652000	23009	11494	5	0	\N
176126	2134	86452649000	23009	11494	6	0	\N
176127	2134	86451646000	23009	11494	7	0	\N
176128	1397	1301986333000	23010	11494	0	0	\N
176129	1397	1301976332000	23010	11494	1	0	\N
176130	2132	147815817000	23010	11494	2	0	\N
176131	2133	93693824000	23010	11494	3	0	\N
176132	2133	93692822000	23010	11494	4	0	\N
176133	2134	86453652000	23010	11494	5	0	\N
176134	2134	86452649000	23010	11494	6	0	\N
176135	2134	86451646000	23010	11494	7	0	\N
176136	1397	1301986333000	23011	11494	0	0	\N
176137	1397	1301976332000	23011	11494	1	0	\N
176138	2132	147815817000	23011	11494	2	0	\N
176139	2133	93693824000	23011	11494	3	0	\N
176140	2133	93692822000	23011	11494	4	0	\N
176141	2134	86453652000	23011	11494	5	0	\N
176142	2134	86452649000	23011	11494	6	0	\N
176143	2134	86451646000	23011	11494	7	0	\N
176154	1397	1301966331000	23014	11495	0	0	\N
176155	2133	93691820000	23014	11495	1	0	\N
176156	2134	86450643000	23014	11495	2	0	\N
176157	1397	1301966331000	23015	11495	0	0	\N
176158	1397	1301956330000	23017	11497	0	0	\N
176159	1397	1301946329000	23017	11497	1	0	\N
176160	1397	1301936328000	23017	11497	2	0	\N
176161	1397	1301926327000	23017	11497	3	0	\N
176162	2134	86449640000	23017	11497	4	0	\N
176163	2132	147814816000	23017	11497	5	0	\N
176164	2134	86448637000	23017	11497	6	0	\N
176165	2134	86447634000	23017	11497	7	0	\N
176166	2134	86446631000	23017	11497	8	0	\N
176167	2133	93690818000	23017	11497	9	0	\N
176168	2133	93689816000	23017	11497	10	0	\N
176169	2133	93688814000	23017	11497	11	0	\N
176170	2133	93687812000	23017	11497	12	0	\N
176171	1397	1301956330000	23018	11497	0	0	\N
176172	1397	1301946329000	23018	11497	1	0	\N
176173	1397	1301936328000	23018	11497	2	0	\N
176174	1397	1301926327000	23018	11497	3	0	\N
176175	2134	86449640000	23018	11497	4	0	\N
176176	2132	147814816000	23018	11497	5	0	\N
176177	2134	86448637000	23018	11497	6	0	\N
176178	2134	86447634000	23018	11497	7	0	\N
176179	2134	86446631000	23018	11497	8	0	\N
176180	2133	93690818000	23018	11497	9	0	\N
176181	2133	93689816000	23018	11497	10	0	\N
176182	2133	93688814000	23018	11497	11	0	\N
176183	2133	93687812000	23018	11497	12	0	\N
176197	1474	6665473000043	23020	11455	0	0	\N
176198	1397	1302386373000	23020	11455	1	0	\N
176199	1397	1302376372000	23020	11455	2	0	\N
176200	1397	1302366371000	23020	11455	3	0	\N
176201	1397	1302356370000	23020	11455	4	0	\N
176202	1397	1302346369000	23020	11455	5	0	\N
176203	1397	1302336368000	23020	11455	6	0	\N
176204	1397	1302326367000	23020	11455	7	0	\N
176205	1397	1302316366000	23020	11455	8	0	\N
176206	1397	1302306365000	23020	11455	9	0	\N
176207	1397	1302296364000	23020	11455	10	0	\N
176208	1397	1302286363000	23020	11455	11	0	\N
176209	1397	1302276362000	23020	11455	12	0	\N
176210	1397	1302266361000	23020	11455	13	0	\N
176211	1397	1302256360000	23020	11455	14	0	\N
176212	1397	1302246359000	23020	11455	15	0	\N
176213	1397	1302236358000	23020	11455	16	0	\N
176214	1397	1302226357000	23020	11455	17	0	\N
176215	1397	1302216356000	23020	11455	18	0	\N
176216	1397	1302206355000	23020	11455	19	0	\N
176217	1397	1302196354000	23020	11455	20	0	\N
176218	1397	1302186353000	23020	11455	21	0	\N
176219	1397	1302176352000	23020	11455	22	0	\N
176220	1397	1302166351000	23020	11455	23	0	\N
176221	1397	1302156350000	23020	11455	24	0	\N
176222	1397	1302146349000	23020	11455	25	0	\N
176223	1397	1302136348000	23020	11455	26	0	\N
176224	1397	1302126347000	23020	11455	27	0	\N
176225	1397	1302116346000	23020	11455	28	0	\N
176226	1397	1302106345000	23020	11455	29	0	\N
176227	1397	1302096344000	23020	11455	30	0	\N
176228	1397	1302086343000	23020	11455	31	0	\N
176229	1397	1302076342000	23020	11455	32	0	\N
176230	1397	1302066341000	23020	11455	33	0	\N
176231	1397	1302056340000	23020	11455	34	0	\N
176232	1397	1302046339000	23020	11455	35	0	\N
176233	1397	1302036338000	23020	11455	36	0	\N
176234	1397	1302026337000	23020	11455	37	0	\N
176235	1397	1302016336000	23020	11455	38	0	\N
176236	1397	1302006335000	23020	11455	39	0	\N
176237	1397	1301996334000	23020	11455	40	0	\N
176238	1397	1301986333000	23020	11455	41	0	\N
176239	1397	1301976332000	23020	11455	42	0	\N
176240	1397	1301966331000	23020	11455	43	0	\N
176241	1397	1301956330000	23020	11455	44	0	\N
176242	1397	1301946329000	23020	11455	45	0	\N
176243	1397	1301936328000	23020	11455	46	0	\N
176244	1397	1301926327000	23020	11455	47	0	\N
176245	1397	1301916326000	23020	11455	48	0	\N
176246	2133	93732902000	23020	11455	49	0	\N
176247	1422	16730882166024	23020	11455	50	0	\N
176248	1422	13253192154809	23020	11455	51	0	\N
176249	2132	147826828000	23020	11455	52	0	\N
176250	2132	147825827000	23020	11455	53	0	\N
176251	2132	147824826000	23020	11455	54	0	\N
176252	2132	147823825000	23020	11455	55	0	\N
176253	2132	147822824000	23020	11455	56	0	\N
176254	2132	147821823000	23020	11455	57	0	\N
176148	2133	93692822000	23012	11494	4	0	4090
176149	2134	86452649000	23012	11494	5	0	4125
176150	2134	86451646000	23012	11494	6	0	4126
176151	1397	1301966331000	23013	11495	0	0	13686
176152	2133	93691820000	23013	11495	1	0	4091
176153	2134	86450643000	23013	11495	2	0	4127
176184	1397	1301956330000	23019	11497	0	0	13687
176185	1397	1301946329000	23019	11497	1	0	13688
176186	1397	1301936328000	23019	11497	2	0	13689
176187	1397	1301926327000	23019	11497	3	0	13690
176188	2134	86449640000	23019	11497	4	0	4128
176189	2132	147814816000	23019	11497	5	0	1184
176190	2134	86448637000	23019	11497	6	0	4129
176191	2134	86447634000	23019	11497	7	0	4130
176193	2133	93690818000	23019	11497	9	0	4092
176194	2133	93689816000	23019	11497	10	0	4093
176195	2133	93688814000	23019	11497	11	0	4094
176196	2133	93687812000	23019	11497	12	0	4095
176255	1397	1301916326000	23022	11498	0	0	13691
176258	1397	1301916326000	23024	11498	0	0	\N
176259	2134	86445628000	23024	11498	1	0	\N
176260	2133	93686810000	23024	11498	2	0	\N
176261	1397	1301916326000	23025	11498	0	0	\N
176262	2134	86445628000	23025	11498	1	0	\N
176263	2133	93686810000	23025	11498	2	0	\N
176264	1397	1301916326000	23026	11498	0	0	\N
176265	2134	86445628000	23026	11498	1	0	\N
176266	2133	93686810000	23026	11498	2	0	\N
176267	1397	1301916326000	23027	11498	0	0	\N
176270	1397	1301906325000	23030	11499	0	0	\N
176271	2134	86444625000	23030	11499	1	0	\N
176272	2132	147813815000	23030	11499	2	0	\N
176273	1397	1301906325000	23031	11499	0	0	\N
176274	2134	86444625000	23031	11499	1	0	\N
176275	2132	147813815000	23031	11499	2	0	\N
176276	1397	1301906325000	23032	11499	0	0	\N
176277	2134	86444625000	23032	11499	1	0	\N
176278	2132	147813815000	23032	11499	2	0	\N
176296	1397	1301876322000	23035	11501	0	0	\N
176297	1397	1301866321000	23035	11501	1	0	\N
176298	1397	1301856320000	23035	11501	2	0	\N
176299	2133	93683804000	23035	11501	3	0	\N
176300	2133	93682802000	23035	11501	4	0	\N
176301	2132	147812814000	23035	11501	5	0	\N
176302	2133	93681800000	23035	11501	6	0	\N
176303	2134	86441616000	23035	11501	7	0	\N
176304	2134	86440613000	23035	11501	8	0	\N
176305	2134	86439610000	23035	11501	9	0	\N
176316	1397	1301846319000	23037	11502	0	0	\N
176317	1397	1301836318000	23037	11502	1	0	\N
176318	1397	1301826317000	23037	11502	2	0	\N
176319	2134	86438607000	23037	11502	3	0	\N
176320	2134	86437604000	23037	11502	4	0	\N
176321	2134	86436601000	23037	11502	5	0	\N
176322	2133	93680798000	23037	11502	6	0	\N
176323	2133	93679796000	23037	11502	7	0	\N
176324	2133	93678794000	23037	11502	8	0	\N
176325	2132	147811813000	23037	11502	9	0	\N
176333	1397	1301816316000	23039	11503	0	0	\N
176334	1397	1301806315000	23039	11503	1	0	\N
176335	2134	86435598000	23039	11503	2	0	\N
176336	2133	93677792000	23039	11503	3	0	\N
176337	2133	93676790000	23039	11503	4	0	\N
176338	2134	86434595000	23039	11503	5	0	\N
176339	2132	147810812000	23039	11503	6	0	\N
176343	1397	1301796314000	23041	11504	0	0	\N
176344	2133	93675788000	23041	11504	1	0	\N
176345	2134	86433592000	23041	11504	2	0	\N
176346	1397	1301786313000	23042	11505	0	0	\N
176347	2133	93674786000	23042	11505	1	0	\N
176348	2134	86432589000	23042	11505	2	0	\N
176352	1397	1301776312000	23044	11506	0	0	\N
176353	2133	93673784000	23044	11506	1	0	\N
176354	2132	147809811000	23044	11506	2	0	\N
176355	2134	86431586000	23044	11506	3	0	\N
176363	1550	0	23047	11424	0	0	\N
176364	1474	6665473000043	23047	11424	1	0	\N
176365	846	573333333200000	23047	11424	2	0	\N
176366	1531	89000000	23047	11424	3	0	\N
176367	1422	21018034190073	23047	11424	4	0	\N
176368	1493	9000000	23047	11424	5	0	\N
176369	2297	8154337013959	23047	11424	6	0	\N
176370	2119	193000000	23047	11424	7	0	\N
176371	2119	192000000	23047	11424	8	0	\N
176372	1422	19077349239740	23047	11424	9	0	\N
176373	1422	16730882166024	23047	11424	10	0	\N
176374	1422	13253192154809	23047	11424	11	0	\N
176375	1457	21754165600000	23047	11424	12	0	\N
176376	1457	16525559160000	23047	11424	13	0	\N
176377	1422	6714554804270	23047	11424	14	0	\N
176378	1457	12997869200000	23047	11424	15	0	\N
176379	1457	10080197800000	23047	11424	16	0	\N
176380	845	573333333200000	23047	11424	17	0	\N
176381	1603	61000000	23047	11424	18	0	\N
176382	1447	17718630793000	23047	11424	19	0	\N
176383	1447	14423624653000	23047	11424	20	0	\N
176384	1447	12200418023000	23047	11424	21	0	\N
176385	1447	10361677683000	23047	11424	22	0	\N
176386	1397	1301756310000	23048	11508	0	0	\N
176387	1397	1301746309000	23048	11508	1	0	\N
176388	2134	86429580000	23048	11508	2	0	\N
176389	2134	86428577000	23048	11508	3	0	\N
176390	2133	93671780000	23048	11508	4	0	\N
176391	2133	93670778000	23048	11508	5	0	\N
176392	2132	147808810000	23048	11508	6	0	\N
176269	2134	86444625000	23029	11499	1	0	4133
176279	1397	1301896324000	23033	11500	0	0	13693
176280	1397	1301886323000	23033	11500	1	0	13694
176281	2134	86443622000	23033	11500	2	0	4134
176282	2132	147813815000	23033	11500	3	0	1185
176284	2133	93685808000	23033	11500	5	0	4097
176285	2133	93684806000	23033	11500	6	0	4098
176286	1397	1301876322000	23034	11501	0	0	13695
176287	1397	1301866321000	23034	11501	1	0	13696
176288	1397	1301856320000	23034	11501	2	0	13697
176290	2133	93682802000	23034	11501	4	0	4100
176291	2132	147812814000	23034	11501	5	0	1186
176292	2133	93681800000	23034	11501	6	0	4101
176293	2134	86441616000	23034	11501	7	0	4136
176295	2134	86439610000	23034	11501	9	0	4138
176306	1397	1301846319000	23036	11502	0	0	13698
176307	1397	1301836318000	23036	11502	1	0	13699
176308	1397	1301826317000	23036	11502	2	0	13700
176309	2134	86438607000	23036	11502	3	0	4139
176311	2134	86436601000	23036	11502	5	0	4141
176312	2133	93680798000	23036	11502	6	0	4102
176313	2133	93679796000	23036	11502	7	0	4103
176314	2133	93678794000	23036	11502	8	0	4104
176315	2132	147811813000	23036	11502	9	0	1187
176327	1397	1301806315000	23038	11503	1	0	13702
176328	2134	86435598000	23038	11503	2	0	4142
176329	2133	93677792000	23038	11503	3	0	4105
176330	2133	93676790000	23038	11503	4	0	4106
176332	2132	147810812000	23038	11503	6	0	1188
176340	1397	1301796314000	23040	11504	0	0	13703
176341	2133	93675788000	23040	11504	1	0	4107
176342	2134	86433592000	23040	11504	2	0	4144
176349	1397	1301786313000	23043	11505	0	0	13704
176351	2134	86432589000	23043	11505	2	0	4145
176356	1397	1301776312000	23045	11506	0	0	13705
176357	2133	93673784000	23045	11506	1	0	4109
176358	2132	147809811000	23045	11506	2	0	1189
176359	2134	86431586000	23045	11506	3	0	4146
176361	2133	93672782000	23046	11507	1	0	4110
176362	2134	86430583000	23046	11507	2	0	4147
176400	1397	1301736308000	23050	11509	0	0	\N
176401	2133	93669776000	23050	11509	1	0	\N
176402	2134	86427574000	23050	11509	2	0	\N
176415	1397	1301726307000	23054	11511	0	0	\N
176416	1397	1301716306000	23054	11511	1	0	\N
176417	2133	93667772000	23054	11511	2	0	\N
176418	2134	86425568000	23054	11511	3	0	\N
176419	2132	147807809000	23054	11511	4	0	\N
176420	2134	86424565000	23054	11511	5	0	\N
176421	2133	93666770000	23054	11511	6	0	\N
176432	1397	1301686303000	23059	11514	0	0	\N
176433	2134	86421556000	23059	11514	1	0	\N
176434	2132	147806808000	23059	11514	2	0	\N
176435	2133	93663764000	23059	11514	4	0	\N
176436	1397	1301686303000	23060	11514	0	0	\N
176437	2134	86421556000	23060	11514	1	0	\N
176438	2132	147806808000	23060	11514	2	0	\N
176439	2133	93663764000	23060	11514	4	0	\N
176440	1397	1301676302000	23061	11515	0	0	\N
176441	1397	1301666301000	23061	11515	1	0	\N
176442	2134	86420553000	23061	11515	2	0	\N
176443	2134	86419550000	23061	11515	3	0	\N
176444	2133	93662762000	23061	11515	4	0	\N
176445	2133	93661760000	23061	11515	5	0	\N
176456	1397	1301656300000	23065	11516	0	0	\N
176457	2134	86418547000	23065	11516	1	0	\N
176458	2132	147805807000	23065	11516	2	0	\N
176459	2133	93660758000	23065	11516	3	0	\N
176460	1397	1301656300000	23066	11516	0	0	\N
176461	2134	86418547000	23066	11516	1	0	\N
176462	2132	147805807000	23066	11516	2	0	\N
176463	2133	93660758000	23066	11516	3	0	\N
176464	1397	1301646299000	23067	11517	0	0	\N
176465	1397	1301636298000	23067	11517	1	0	\N
176466	2133	93659756000	23067	11517	2	0	\N
176467	2133	93658754000	23067	11517	3	0	\N
176468	2134	86417544000	23067	11517	4	0	\N
176469	2134	86416541000	23067	11517	5	0	\N
176479	1397	1301626297000	23071	11518	0	0	\N
176480	2133	93657752000	23071	11518	1	0	\N
176481	2134	86415538000	23071	11518	2	0	\N
176486	1397	1301616296000	23073	11519	0	0	\N
176487	2134	86414535000	23073	11519	1	0	\N
176488	2132	147804806000	23073	11519	2	0	\N
176489	2133	93656750000	23073	11519	3	0	\N
176490	1397	1301606295000	23074	11520	0	0	\N
176491	2134	86413532000	23074	11520	1	0	\N
176492	2133	93655748000	23074	11520	2	0	\N
176503	1397	1301586293000	23078	11522	0	0	\N
176504	2132	147803805000	23078	11522	1	0	\N
176505	2134	86412529000	23078	11522	2	0	\N
176506	2134	86411526000	23078	11522	3	0	\N
176507	1397	1301586293000	23079	11522	0	0	\N
176508	2133	93653744000	23079	11522	1	0	\N
176509	2132	147803805000	23079	11522	2	0	\N
176510	2134	86412529000	23079	11522	3	0	\N
176395	2134	86429580000	23049	11508	2	0	4148
176396	2134	86428577000	23049	11508	3	0	4149
176397	2133	93671780000	23049	11508	4	0	4111
176398	2133	93670778000	23049	11508	5	0	4112
176399	2132	147808810000	23049	11508	6	0	1190
176404	2133	93669776000	23051	11509	1	0	4113
176405	2134	86427574000	23051	11509	2	0	4150
176406	2133	93668774000	23052	11510	0	0	4114
176407	2134	86426571000	23052	11510	1	0	4151
176408	1397	1301726307000	23053	11511	0	0	13710
176410	2133	93667772000	23053	11511	2	0	4115
176411	2134	86425568000	23053	11511	3	0	4152
176412	2132	147807809000	23053	11511	4	0	1191
176413	2134	86424565000	23053	11511	5	0	4153
176422	1397	1301706305000	23055	11512	0	0	13712
176423	2134	86423562000	23055	11512	1	0	4154
176424	2133	93665768000	23055	11512	2	0	4117
176425	1397	1301696304000	23056	11513	0	0	13713
176426	2133	93664766000	23056	11513	1	0	4118
176428	1397	1301686303000	23058	11514	0	0	13714
176429	2134	86421556000	23058	11514	1	0	4156
176430	2132	147806808000	23058	11514	2	0	1192
176431	2133	93663764000	23058	11514	4	0	4119
176446	1397	1301676302000	23062	11515	0	0	13715
176448	2134	86420553000	23062	11515	2	0	4157
176449	2134	86419550000	23062	11515	3	0	4158
176450	2133	93662762000	23062	11515	4	0	4120
176451	2133	93661760000	23062	11515	5	0	4121
176453	2134	86418547000	23064	11516	1	0	4159
176454	2132	147805807000	23064	11516	2	0	1193
176455	2133	93660758000	23064	11516	3	0	4122
176470	1397	1301646299000	23068	11517	0	0	13718
176471	1397	1301636298000	23068	11517	1	0	13719
176473	2133	93658754000	23068	11517	3	0	4124
176474	2134	86417544000	23068	11517	4	0	4160
176475	2134	86416541000	23068	11517	5	0	4161
176476	1397	1301626297000	23070	11518	0	0	13720
176477	2133	93657752000	23070	11518	1	0	4125
176482	1397	1301616296000	23072	11519	0	0	13721
176483	2134	86414535000	23072	11519	1	0	4163
176484	2132	147804806000	23072	11519	2	0	1194
176485	2133	93656750000	23072	11519	3	0	4126
176494	2134	86413532000	23075	11520	1	0	4164
176495	2133	93655748000	23075	11520	2	0	4127
176496	1397	1301596294000	23076	11521	0	0	13723
176497	2133	93654746000	23076	11521	1	0	4128
176498	1397	1301586293000	23077	11522	0	0	13724
176500	2132	147803805000	23077	11522	2	0	1195
176501	2134	86412529000	23077	11522	3	0	4165
176502	2134	86411526000	23077	11522	4	0	4166
176511	1397	1301576292000	23080	11523	0	0	13725
176512	2133	93652742000	23080	11523	1	0	4130
176514	1397	1301566291000	23081	11524	0	0	13726
176515	2134	86409520000	23081	11524	1	0	4168
176516	2133	93651740000	23081	11524	2	0	4131
176517	1397	1301556290000	23082	11525	0	0	13727
176519	2134	86408517000	23082	11525	2	0	4169
176520	2132	147802804000	23082	11525	3	0	1196
176521	1397	1301546289000	23083	11526	0	0	13728
176522	2134	86407514000	23083	11526	1	0	4170
176523	2133	93649736000	23083	11526	2	0	4133
176525	1397	1301526287000	23084	11527	1	0	13730
176526	1397	1301516286000	23084	11527	2	0	13731
176527	2134	86406511000	23084	11527	3	0	4171
176528	2132	147801803000	23084	11527	4	0	1197
176534	1397	1301506285000	23085	11528	0	0	\N
176535	2134	86403502000	23085	11528	1	0	\N
176536	1397	1301506285000	23086	11528	0	0	\N
176537	2134	86403502000	23086	11528	1	0	\N
176538	2133	93645728000	23086	11528	2	0	\N
176542	1397	1301506285000	23088	11528	0	0	\N
176543	2134	86403502000	23088	11528	1	0	\N
176544	2133	93645728000	23088	11528	2	0	\N
176545	1397	1301676302000	23089	11515	0	0	\N
176546	1397	1301666301000	23089	11515	1	0	\N
176547	1397	1301656300000	23089	11515	2	0	\N
176548	1397	1301646299000	23089	11515	3	0	\N
176549	1397	1301636298000	23089	11515	4	0	\N
176550	1397	1301626297000	23089	11515	5	0	\N
176551	1397	1301616296000	23089	11515	6	0	\N
176552	1397	1301606295000	23089	11515	7	0	\N
176553	1397	1301596294000	23089	11515	8	0	\N
176554	1397	1301586293000	23089	11515	9	0	\N
176555	1397	1301576292000	23089	11515	10	0	\N
176556	1397	1301566291000	23089	11515	11	0	\N
176557	1397	1301556290000	23089	11515	12	0	\N
176558	1397	1301546289000	23089	11515	13	0	\N
176559	1397	1301536288000	23089	11515	14	0	\N
176560	1397	1301526287000	23089	11515	15	0	\N
176561	1397	1301516286000	23089	11515	16	0	\N
176562	1397	1301506285000	23089	11515	17	0	\N
176563	1397	1301496284000	23089	11515	18	0	\N
176564	1397	1301486283000	23089	11515	19	0	\N
176565	1397	1301476282000	23089	11515	20	0	\N
176566	1397	1301466281000	23089	11515	21	0	\N
176567	2134	86420553000	23089	11515	22	0	\N
176568	2134	86419550000	23089	11515	23	0	\N
176569	2134	86418547000	23089	11515	24	0	\N
176570	2133	93662762000	23089	11515	25	0	\N
176571	2132	147805807000	23089	11515	26	0	\N
176572	2133	93661760000	23089	11515	27	0	\N
176573	2133	93660758000	23089	11515	28	0	\N
176574	2133	93659756000	23089	11515	29	0	\N
176575	2133	93658754000	23089	11515	30	0	\N
176576	2133	93657752000	23089	11515	31	0	\N
176577	2134	86417544000	23089	11515	32	0	\N
176578	2134	86416541000	23089	11515	33	0	\N
176579	2134	86415538000	23089	11515	34	0	\N
176580	2134	86414535000	23089	11515	35	0	\N
176581	2134	86413532000	23089	11515	36	0	\N
176582	2134	86412529000	23089	11515	37	0	\N
176583	2134	86411526000	23089	11515	38	0	\N
176584	2134	86410523000	23089	11515	39	0	\N
176585	2134	86409520000	23089	11515	40	0	\N
176586	2134	86408517000	23089	11515	41	0	\N
176587	2134	86407514000	23089	11515	42	0	\N
176588	2134	86406511000	23089	11515	43	0	\N
176589	2134	86405508000	23089	11515	44	0	\N
176590	2134	86404505000	23089	11515	45	0	\N
176591	2134	86403502000	23089	11515	46	0	\N
176592	2134	86402499000	23089	11515	47	0	\N
176593	2134	86401496000	23089	11515	48	0	\N
176594	2134	86400493000	23089	11515	49	0	\N
176595	2134	86399490000	23089	11515	50	0	\N
176596	2132	147804806000	23089	11515	51	0	\N
176597	2132	147803805000	23089	11515	52	0	\N
176598	2132	147802804000	23089	11515	53	0	\N
176599	2132	147801803000	23089	11515	54	0	\N
176600	2132	147800802000	23089	11515	55	0	\N
176601	2133	93656750000	23089	11515	56	0	\N
176602	2133	93655748000	23089	11515	57	0	\N
176603	2133	93654746000	23089	11515	58	0	\N
176604	2133	93653744000	23089	11515	59	0	\N
176605	2133	93652742000	23089	11515	60	0	\N
176606	2133	93651740000	23089	11515	61	0	\N
176607	2133	93650738000	23089	11515	62	0	\N
176608	2133	93649736000	23089	11515	63	0	\N
176609	2133	93648734000	23089	11515	64	0	\N
176610	2133	93647732000	23089	11515	65	0	\N
176611	2133	93646730000	23089	11515	66	0	\N
176612	2133	93645728000	23089	11515	67	0	\N
176613	2133	93644726000	23089	11515	68	0	\N
176614	2133	93643724000	23089	11515	69	0	\N
176615	2133	93642722000	23089	11515	70	0	\N
176616	2133	93641720000	23089	11515	71	0	\N
176640	1397	1301426277000	23093	11532	0	0	\N
176641	1397	1301416276000	23093	11532	1	0	\N
176642	2132	147798800000	23093	11532	2	0	\N
176643	2133	93637712000	23093	11532	3	0	\N
176644	2133	93636710000	23093	11532	4	0	\N
176645	2134	86395478000	23093	11532	5	0	\N
176646	2134	86394475000	23093	11532	6	0	\N
176647	1397	1301426277000	23094	11532	0	0	\N
176648	1397	1301416276000	23094	11532	1	0	\N
176649	2132	147798800000	23094	11532	2	0	\N
176650	2133	93637712000	23094	11532	3	0	\N
176651	2133	93636710000	23094	11532	4	0	\N
176652	2134	86395478000	23094	11532	5	0	\N
176653	2134	86394475000	23094	11532	6	0	\N
176664	1397	1301406275000	23097	11533	0	0	\N
176531	2133	93648734000	23084	11527	7	0	4134
176532	2133	93647732000	23084	11527	8	0	4135
176533	2133	93646730000	23084	11527	9	0	4136
176539	1397	1301506285000	23087	11528	0	0	13732
176540	2134	86403502000	23087	11528	1	0	4174
176617	1397	1301496284000	23090	11529	0	0	13733
176618	1397	1301486283000	23090	11529	1	0	13734
176619	1397	1301476282000	23090	11529	2	0	13735
176620	1397	1301466281000	23090	11529	3	0	13736
176621	1397	1301456280000	23090	11529	4	0	13737
176623	2132	147799801000	23090	11529	6	0	1199
176624	2133	93644726000	23090	11529	7	0	4138
176625	2133	93643724000	23090	11529	8	0	4139
176626	2133	93642722000	23090	11529	9	0	4140
176628	2134	86401496000	23090	11529	11	0	4176
176629	2134	86400493000	23090	11529	12	0	4177
176630	2134	86399490000	23090	11529	13	0	4178
176631	2134	86398487000	23090	11529	14	0	4179
176632	2133	93641720000	23090	11529	15	0	4141
176634	1397	1301446279000	23091	11530	0	0	13738
176635	2134	86397484000	23091	11530	1	0	4180
176636	2133	93639716000	23091	11530	2	0	4143
176637	1397	1301436278000	23092	11531	0	0	13739
176638	2134	86396481000	23092	11531	1	0	4181
176654	1397	1301426277000	23095	11532	0	0	13740
176655	1397	1301416276000	23095	11532	1	0	13741
176656	2132	147798800000	23095	11532	2	0	1200
176657	2133	93637712000	23095	11532	3	0	4145
176659	2134	86395478000	23095	11532	5	0	4182
176660	2134	86394475000	23095	11532	6	0	4183
176661	1397	1301406275000	23096	11533	0	0	13742
176662	2133	93635708000	23096	11533	1	0	4147
176663	2134	86393472000	23096	11533	2	0	4184
176665	2133	93635708000	23097	11533	1	0	\N
176666	2134	86393472000	23097	11533	2	0	\N
176676	2134	86390463000	23100	11536	0	0	\N
176690	1397	1301336268000	23105	11539	0	0	\N
176691	2133	93628694000	23105	11539	1	0	\N
176692	2134	86387454000	23105	11539	2	0	\N
176696	1397	1301316266000	23107	11541	0	0	\N
176697	2134	86385448000	23107	11541	1	0	\N
176698	2132	147795797000	23107	11541	2	0	\N
176699	2133	93626690000	23107	11541	3	0	\N
176704	1397	1301316266000	23109	11541	0	0	\N
176705	2134	86385448000	23109	11541	1	0	\N
176706	2132	147795797000	23109	11541	2	0	\N
176707	2133	93626690000	23109	11541	3	0	\N
176708	1397	1301306265000	23110	11542	0	0	\N
176709	2134	86384445000	23110	11542	1	0	\N
176710	2133	93625688000	23110	11542	2	0	\N
176735	647	66000099000000	23117	11525	0	0	\N
176736	1397	1301236258000	23119	11547	0	0	\N
176737	1397	1301226257000	23119	11547	1	0	\N
176738	2133	93618674000	23119	11547	2	0	\N
176739	2134	86377424000	23119	11547	3	0	\N
176740	2133	93617672000	23119	11547	4	0	\N
176741	2134	86376421000	23119	11547	5	0	\N
176754	1397	1301206255000	23123	11549	0	0	\N
176755	2133	93616670000	23123	11549	1	0	\N
176756	2134	86374415000	23123	11549	2	0	\N
176764	2133	93613664000	23125	11551	0	0	\N
176773	1397	1301166251000	23128	11552	0	0	\N
176774	2133	93612662000	23128	11552	1	0	\N
176775	2134	86370403000	23128	11552	2	0	\N
176776	1593	20972641000000	23128	11552	3	0	\N
176777	1593	15750640000000	23128	11552	4	0	\N
176778	1397	1301166251000	23129	11552	0	0	\N
176779	2133	93612662000	23129	11552	1	0	\N
176780	2134	86370403000	23129	11552	2	0	\N
176781	1593	20972641000000	23129	11552	3	0	\N
176782	1593	15750640000000	23129	11552	4	0	\N
176783	1474	6665473000043	23130	11433	0	0	\N
176784	846	573333333200000	23130	11433	1	0	\N
176785	1422	21018034190073	23130	11433	2	0	\N
176786	2119	192000000	23130	11433	3	0	\N
176787	2297	8154337013959	23130	11433	4	0	\N
176788	2132	147834836000	23130	11433	5	0	\N
176789	1593	19532616000000	23130	11433	6	0	\N
176790	647	66000099000000	23130	11433	7	0	\N
176791	2132	147833835000	23130	11433	8	0	\N
176792	2132	147832834000	23130	11433	9	0	\N
176793	1422	19077349239740	23130	11433	10	0	\N
176794	1422	16730882166024	23130	11433	11	0	\N
176795	1422	13253192154809	23130	11433	12	0	\N
176796	2132	147831833000	23130	11433	13	0	\N
176797	2132	147830832000	23130	11433	14	0	\N
176798	2132	147829831000	23130	11433	15	0	\N
176799	2132	147828830000	23130	11433	16	0	\N
176800	2132	147827829000	23130	11433	17	0	\N
176669	2132	147797799000	23098	11534	2	0	1201
176670	2133	93634706000	23098	11534	3	0	4148
176671	2133	93633704000	23098	11534	4	0	4149
176672	2134	86392469000	23098	11534	5	0	4185
176673	1397	1301376272000	23099	11535	0	0	13745
176675	2134	86391466000	23099	11535	2	0	4186
176677	1397	1301366271000	23101	11536	0	0	13746
176678	2133	93631700000	23101	11536	1	0	4151
176679	2134	86390463000	23101	11536	2	0	4187
176680	1397	1301356270000	23102	11537	0	0	13747
176682	2133	93630698000	23102	11537	2	0	4152
176683	2134	86389460000	23102	11537	3	0	4188
176684	1397	1301346269000	23103	11538	0	0	13748
176685	2134	86388457000	23103	11538	1	0	4189
176687	1397	1301336268000	23104	11539	0	0	13749
176688	2133	93628694000	23104	11539	1	0	4154
176689	2134	86387454000	23104	11539	2	0	4190
176693	1397	1301326267000	23106	11540	0	0	13750
176694	2134	86386451000	23106	11540	1	0	4191
176700	1397	1301316266000	23108	11541	0	0	13751
176701	2134	86385448000	23108	11541	1	0	4192
176702	2132	147795797000	23108	11541	2	0	1203
176703	2133	93626690000	23108	11541	3	0	4156
176711	1397	1301306265000	23111	11542	0	0	13752
176713	2133	93625688000	23111	11542	2	0	4157
176714	1397	1301296264000	23112	11543	0	0	13753
176715	2133	93624686000	23112	11543	1	0	4158
176716	2134	86383442000	23112	11543	2	0	4194
176718	2134	86382439000	23113	11544	1	0	4195
176719	2132	147794796000	23113	11544	2	0	1204
176720	2133	93623684000	23113	11544	3	0	4159
176721	1397	1301276262000	23115	11545	0	0	13755
176722	1397	1301266261000	23115	11545	1	0	13756
176724	2134	86381436000	23115	11545	3	0	4196
176725	2133	93622682000	23115	11545	4	0	4160
176726	2133	93621680000	23115	11545	5	0	4161
176727	2132	147793795000	23115	11545	6	0	1205
176728	2133	93620678000	23115	11545	7	0	4162
176730	2134	86379430000	23115	11545	9	0	4198
176731	1397	1301246259000	23116	11546	0	0	13758
176732	647	66000099000000	23116	11546	1	0	3
176733	2133	93619676000	23116	11546	2	0	4163
176742	1397	1301236258000	23120	11547	0	0	13759
176743	1397	1301226257000	23120	11547	1	0	13760
176744	2133	93618674000	23120	11547	2	0	4164
176745	2134	86377424000	23120	11547	3	0	4200
176746	2133	93617672000	23120	11547	4	0	4165
176748	1397	1301216256000	23121	11548	0	0	13761
176749	2134	86375418000	23121	11548	1	0	4202
176750	2132	147792794000	23121	11548	2	0	1206
176751	1397	1301206255000	23122	11549	0	0	13762
176752	2133	93616670000	23122	11549	1	0	4166
176757	1397	1301196254000	23124	11550	0	0	13763
176758	1397	1301186253000	23124	11550	1	0	13764
176759	2132	147791793000	23124	11550	2	0	1207
176760	2134	86373412000	23124	11550	3	0	4204
176762	2133	93614666000	23124	11550	5	0	4168
176763	2134	86372409000	23124	11550	6	0	4205
176765	1397	1301176252000	23126	11551	0	0	13765
176766	2133	93613664000	23126	11551	1	0	4169
176767	2134	86371406000	23126	11551	2	0	4206
176769	2133	93612662000	23127	11552	1	0	4170
176770	2134	86370403000	23127	11552	2	0	4207
176771	1593	20972641000000	23127	11552	3	0	5
176772	1593	15750640000000	23127	11552	4	0	6
176801	2132	147826828000	23130	11433	18	0	\N
176802	2132	147825827000	23130	11433	19	0	\N
176803	1593	14310615000000	23130	11433	20	0	\N
176804	2132	147824826000	23130	11433	21	0	\N
176805	2132	147823825000	23130	11433	22	0	\N
176806	2132	147822824000	23130	11433	23	0	\N
176807	2132	147821823000	23130	11433	24	0	\N
176808	2132	147820822000	23130	11433	25	0	\N
176809	2132	147819821000	23130	11433	26	0	\N
176810	2132	147818820000	23130	11433	27	0	\N
176811	2132	147817819000	23130	11433	28	0	\N
176812	2132	147816818000	23130	11433	29	0	\N
176813	2132	147815817000	23130	11433	30	0	\N
176814	2132	147814816000	23130	11433	31	0	\N
176815	2132	147813815000	23130	11433	32	0	\N
176816	2132	147812814000	23130	11433	33	0	\N
176817	2134	86508817000	23130	11433	34	0	\N
176818	2134	86507814000	23130	11433	35	0	\N
176819	2134	86506811000	23130	11433	36	0	\N
176820	2134	86505808000	23130	11433	37	0	\N
176821	2134	86504805000	23130	11433	38	0	\N
176822	2134	86503802000	23130	11433	39	0	\N
176823	2134	86502799000	23130	11433	40	0	\N
176824	1457	21754165600000	23130	11433	41	0	\N
176825	1457	16525559160000	23130	11433	42	0	\N
176826	1422	6714554804270	23130	11433	43	0	\N
176827	1457	12997869200000	23130	11433	44	0	\N
176828	1457	10080197800000	23130	11433	45	0	\N
176829	845	573333333200000	23130	11433	46	0	\N
176830	1447	17718630793000	23130	11433	47	0	\N
176831	1447	14423624653000	23130	11433	48	0	\N
176832	1447	12200418023000	23130	11433	49	0	\N
176833	1447	10361677683000	23130	11433	50	0	\N
176834	2134	86501796000	23130	11433	51	0	\N
176835	2134	86500793000	23130	11433	52	0	\N
176836	2134	86499790000	23130	11433	53	0	\N
176837	2134	86498787000	23130	11433	54	0	\N
176838	2134	86497784000	23130	11433	55	0	\N
176839	2134	86496781000	23130	11433	56	0	\N
176840	2134	86495778000	23130	11433	57	0	\N
176841	2134	86494775000	23130	11433	58	0	\N
176842	2134	86493772000	23130	11433	59	0	\N
176843	2134	86492769000	23130	11433	60	0	\N
176844	2134	86491766000	23130	11433	61	0	\N
176845	2134	86490763000	23130	11433	62	0	\N
176846	2134	86489760000	23130	11433	63	0	\N
176847	2134	86488757000	23130	11433	64	0	\N
176848	2134	86487754000	23130	11433	65	0	\N
176849	2134	86486751000	23130	11433	66	0	\N
176850	2134	86485748000	23130	11433	67	0	\N
176851	2134	86484745000	23130	11433	68	0	\N
176852	2134	86483742000	23130	11433	69	0	\N
176853	2134	86482739000	23130	11433	70	0	\N
176854	2134	86481736000	23130	11433	71	0	\N
176855	2134	86480733000	23130	11433	72	0	\N
176856	2132	147811813000	23130	11433	73	0	\N
176857	2132	147810812000	23130	11433	74	0	\N
176858	2132	147809811000	23130	11433	75	0	\N
176859	2132	147808810000	23130	11433	76	0	\N
176860	2132	147807809000	23130	11433	77	0	\N
176861	2132	147806808000	23130	11433	78	0	\N
176862	2132	147805807000	23130	11433	79	0	\N
176863	2132	147804806000	23130	11433	80	0	\N
176864	2132	147803805000	23130	11433	81	0	\N
176865	2132	147802804000	23130	11433	82	0	\N
176866	2132	147801803000	23130	11433	83	0	\N
176867	2132	147800802000	23130	11433	84	0	\N
176868	2132	147799801000	23130	11433	85	0	\N
176869	2132	147798800000	23130	11433	86	0	\N
176870	2132	147797799000	23130	11433	87	0	\N
176871	2132	147796798000	23130	11433	88	0	\N
176872	2132	147795797000	23130	11433	89	0	\N
176873	2132	147794796000	23130	11433	90	0	\N
176874	2132	147793795000	23130	11433	91	0	\N
176875	2132	147792794000	23130	11433	92	0	\N
176876	2132	147791793000	23130	11433	93	0	\N
176877	2134	86479730000	23130	11433	94	0	\N
176878	2134	86478727000	23130	11433	95	0	\N
176879	2134	86477724000	23130	11433	96	0	\N
176880	2134	86476721000	23130	11433	97	0	\N
176881	2134	86475718000	23130	11433	98	0	\N
176882	2134	86474715000	23130	11433	99	0	\N
176883	2134	86473712000	23130	11433	100	0	\N
176884	2134	86472709000	23130	11433	101	0	\N
176885	2134	86471706000	23130	11433	102	0	\N
176886	2134	86470703000	23130	11433	103	0	\N
176887	2134	86469700000	23130	11433	104	0	\N
176888	2134	86468697000	23130	11433	105	0	\N
176889	2134	86467694000	23130	11433	106	0	\N
176890	2134	86466691000	23130	11433	107	0	\N
176891	2134	86465688000	23130	11433	108	0	\N
176892	2134	86464685000	23130	11433	109	0	\N
176893	2134	86463682000	23130	11433	110	0	\N
176894	2134	86462679000	23130	11433	111	0	\N
176895	2134	86461676000	23130	11433	112	0	\N
176896	2134	86460673000	23130	11433	113	0	\N
176897	2134	86459670000	23130	11433	114	0	\N
176898	2134	86458667000	23130	11433	115	0	\N
176899	2134	86457664000	23130	11433	116	0	\N
176900	2134	86456661000	23130	11433	117	0	\N
176901	2134	86455658000	23130	11433	118	0	\N
176902	2134	86454655000	23130	11433	119	0	\N
176903	2134	86453652000	23130	11433	120	0	\N
176904	2134	86452649000	23130	11433	123	0	\N
176905	2134	86451646000	23130	11433	124	0	\N
176906	1397	1301166251000	23131	11552	0	0	\N
176907	2133	93612662000	23131	11552	1	0	\N
176908	2134	86370403000	23131	11552	2	0	\N
176909	1593	20972641000000	23131	11552	3	0	\N
176910	1593	15750640000000	23131	11552	4	0	\N
176917	1397	1301156250000	23133	11553	0	0	\N
176918	1397	1301146249000	23133	11553	1	0	\N
176919	2132	147790792000	23133	11553	2	0	\N
176920	1593	12226639000000	23133	11553	3	0	\N
176921	1593	9312638000000	23133	11553	5	0	\N
176922	2134	86369400000	23133	11553	6	0	\N
176923	2133	93611660000	23133	11553	7	0	\N
176924	2133	93610658000	23133	11553	8	0	\N
176925	2134	86368397000	23133	11553	9	0	\N
176926	1397	1301156250000	23134	11553	0	0	\N
176927	1397	1301146249000	23134	11553	1	0	\N
176928	2132	147790792000	23134	11553	2	0	\N
176929	1593	12226639000000	23134	11553	3	0	\N
176930	1593	9312638000000	23134	11553	5	0	\N
176931	2134	86369400000	23134	11553	6	0	\N
176932	2133	93611660000	23134	11553	7	0	\N
176933	2133	93610658000	23134	11553	8	0	\N
176934	2134	86368397000	23134	11553	9	0	\N
176935	1397	1301156250000	23135	11553	0	0	\N
176936	1397	1301146249000	23135	11553	1	0	\N
176913	2132	147790792000	23132	11553	2	0	1208
176914	1593	12226639000000	23132	11553	3	0	7
176915	1593	9312638000000	23132	11553	5	0	8
176916	2133	93611660000	23132	11553	6	0	4171
176937	2132	147790792000	23135	11553	2	0	\N
176938	1593	12226639000000	23135	11553	3	0	\N
176939	1593	9312638000000	23135	11553	5	0	\N
176940	2133	93611660000	23135	11553	6	0	\N
176941	2133	93610658000	23135	11553	7	0	\N
176942	1397	1301366271000	23136	11536	0	0	\N
176943	1397	1301356270000	23136	11536	1	0	\N
176944	1397	1301346269000	23136	11536	2	0	\N
176945	1397	1301336268000	23136	11536	3	0	\N
176946	1397	1301326267000	23136	11536	4	0	\N
176947	1397	1301316266000	23136	11536	5	0	\N
176948	1397	1301306265000	23136	11536	6	0	\N
176949	1397	1301296264000	23136	11536	7	0	\N
176950	1397	1301286263000	23136	11536	8	0	\N
176951	1397	1301276262000	23136	11536	9	0	\N
176952	1397	1301266261000	23136	11536	10	0	\N
176953	1397	1301256260000	23136	11536	11	0	\N
176954	1397	1301246259000	23136	11536	12	0	\N
176955	1397	1301236258000	23136	11536	13	0	\N
176956	1397	1301226257000	23136	11536	14	0	\N
176957	1397	1301216256000	23136	11536	15	0	\N
176958	1397	1301206255000	23136	11536	16	0	\N
176959	1397	1301196254000	23136	11536	17	0	\N
176960	1397	1301186253000	23136	11536	18	0	\N
176961	1397	1301176252000	23136	11536	19	0	\N
176962	1397	1301166251000	23136	11536	20	0	\N
176963	1397	1301156250000	23136	11536	21	0	\N
176964	2132	147796798000	23136	11536	22	0	\N
176965	2133	93631700000	23136	11536	23	0	\N
176966	2133	93630698000	23136	11536	24	0	\N
176967	2133	93629696000	23136	11536	25	0	\N
176968	2133	93628694000	23136	11536	26	0	\N
176969	1593	20972641000000	23136	11536	27	0	\N
176970	647	66000099000000	23136	11536	28	0	\N
176971	2132	147795797000	23136	11536	29	0	\N
176972	2132	147794796000	23136	11536	30	0	\N
176973	2134	86390463000	23136	11536	31	0	\N
176974	2134	86389460000	23136	11536	32	0	\N
176975	2134	86388457000	23136	11536	33	0	\N
176976	2134	86387454000	23136	11536	34	0	\N
176977	2134	86386451000	23136	11536	35	0	\N
176978	2134	86385448000	23136	11536	36	0	\N
176979	2134	86384445000	23136	11536	37	0	\N
176980	2134	86383442000	23136	11536	38	0	\N
176981	2134	86382439000	23136	11536	39	0	\N
176982	2134	86381436000	23136	11536	40	0	\N
176983	1593	15750640000000	23136	11536	41	0	\N
176984	1593	12226639000000	23136	11536	42	0	\N
176985	1593	9312638000000	23136	11536	43	0	\N
176986	2133	93627692000	23136	11536	44	0	\N
176987	2132	147793795000	23136	11536	45	0	\N
176988	2132	147792794000	23136	11536	46	0	\N
176989	2132	147791793000	23136	11536	47	0	\N
176990	2134	86380433000	23136	11536	48	0	\N
176991	2134	86379430000	23136	11536	49	0	\N
176992	2133	93626690000	23136	11536	50	0	\N
176993	2133	93625688000	23136	11536	51	0	\N
176994	2133	93624686000	23136	11536	52	0	\N
176995	2133	93623684000	23136	11536	53	0	\N
176996	2133	93622682000	23136	11536	54	0	\N
176997	2133	93621680000	23136	11536	55	0	\N
176998	2133	93620678000	23136	11536	56	0	\N
176999	2133	93619676000	23136	11536	57	0	\N
177000	2133	93618674000	23136	11536	58	0	\N
177001	2133	93617672000	23136	11536	59	0	\N
177002	2133	93616670000	23136	11536	60	0	\N
177003	2133	93615668000	23136	11536	61	0	\N
177004	2133	93614666000	23136	11536	62	0	\N
177005	2133	93613664000	23136	11536	63	0	\N
177006	2133	93612662000	23136	11536	64	0	\N
177007	2133	93611660000	23136	11536	65	0	\N
177008	2134	86378427000	23136	11536	66	0	\N
177009	2134	86377424000	23136	11536	67	0	\N
177010	2134	86376421000	23136	11536	68	0	\N
177011	2134	86375418000	23136	11536	69	0	\N
177012	2134	86374415000	23136	11536	70	0	\N
177013	2134	86373412000	23136	11536	71	0	\N
177014	2134	86372409000	23136	11536	72	0	\N
177015	2134	86371406000	23136	11536	73	0	\N
177016	2134	86370403000	23136	11536	74	0	\N
177017	2134	86369400000	23136	11536	75	0	\N
177018	1397	1301136248000	23137	11554	0	0	\N
177019	1397	1301126247000	23137	11554	1	0	\N
177020	2134	86369400000	23137	11554	2	0	\N
177021	2133	93610658000	23137	11554	3	0	\N
177022	2133	93609656000	23137	11554	4	0	\N
177023	2133	93608654000	23137	11554	5	0	\N
177024	2134	86368397000	23137	11554	6	0	\N
177025	2134	86367394000	23137	11554	7	0	\N
177026	2134	86366391000	23137	11554	8	0	\N
177043	1397	1301116246000	23140	11555	0	0	\N
177044	1397	1301106245000	23140	11555	1	0	\N
177045	2132	147789791000	23140	11555	2	0	\N
177046	2133	93607652000	23140	11555	3	0	\N
177047	2133	93606650000	23140	11555	4	0	\N
177048	2134	86365388000	23140	11555	5	0	\N
177049	2134	86364385000	23140	11555	6	0	\N
177050	1397	1301116246000	23141	11555	0	0	\N
177051	1397	1301106245000	23141	11555	1	0	\N
177052	2132	147789791000	23141	11555	2	0	\N
177053	2133	93607652000	23141	11555	3	0	\N
177054	2133	93606650000	23141	11555	4	0	\N
177055	2134	86365388000	23141	11555	5	0	\N
177056	2134	86364385000	23141	11555	6	0	\N
177057	1397	1301116246000	23142	11555	0	0	\N
177058	1397	1301106245000	23142	11555	1	0	\N
177059	2132	147789791000	23142	11555	2	0	\N
177060	2133	93607652000	23142	11555	3	0	\N
177061	2133	93606650000	23142	11555	4	0	\N
177062	2134	86365388000	23142	11555	5	0	\N
177063	2134	86364385000	23142	11555	6	0	\N
177029	2134	86369400000	23138	11554	2	0	4208
177030	2133	93610658000	23138	11554	3	0	4172
177031	2133	93609656000	23138	11554	4	0	4173
177032	2133	93608654000	23138	11554	5	0	4174
177033	2134	86368397000	23138	11554	6	0	4209
177035	2134	86366391000	23138	11554	8	0	4211
177036	1397	1301116246000	23139	11555	0	0	13771
177037	1397	1301106245000	23139	11555	1	0	13772
177038	2132	147789791000	23139	11555	2	0	1209
177039	2133	93607652000	23139	11555	3	0	4175
177041	2134	86365388000	23139	11555	5	0	4212
177042	2134	86364385000	23139	11555	6	0	4213
177064	1397	1301096244000	23143	11556	0	0	13773
177065	2134	86363382000	23143	11556	1	0	4214
177067	1397	1301086243000	23144	11557	0	0	13774
177068	2134	86362379000	23144	11557	1	0	4215
177069	2133	93604646000	23144	11557	2	0	4178
177070	2132	147788790000	23144	11557	3	0	1210
177071	1397	1301076242000	23145	11558	0	0	13775
177087	1397	1301026237000	23148	11561	0	0	\N
177088	2134	86356361000	23148	11561	1	0	\N
177089	2133	93598634000	23148	11561	2	0	\N
177093	1397	1301026237000	23150	11561	0	0	\N
177094	2134	86356361000	23150	11561	1	0	\N
177095	2133	93598634000	23150	11561	2	0	\N
177096	1397	1302136348000	23151	11484	0	0	\N
177097	1397	1302126347000	23151	11484	1	0	\N
177098	1397	1302116346000	23151	11484	2	0	\N
177099	1397	1302106345000	23151	11484	3	0	\N
177100	1397	1302096344000	23151	11484	4	0	\N
177101	1397	1302086343000	23151	11484	5	0	\N
177102	1397	1302076342000	23151	11484	6	0	\N
177103	1397	1302066341000	23151	11484	7	0	\N
177104	1397	1302056340000	23151	11484	8	0	\N
177105	1397	1302046339000	23151	11484	9	0	\N
177106	1397	1302036338000	23151	11484	10	0	\N
177107	1397	1302026337000	23151	11484	11	0	\N
177108	1397	1302016336000	23151	11484	12	0	\N
177109	1397	1302006335000	23151	11484	13	0	\N
177110	1397	1301996334000	23151	11484	14	0	\N
177111	1397	1301986333000	23151	11484	15	0	\N
177112	1397	1301976332000	23151	11484	16	0	\N
177113	1397	1301966331000	23151	11484	17	0	\N
177114	1397	1301956330000	23151	11484	18	0	\N
177115	1397	1301946329000	23151	11484	19	0	\N
177116	1397	1301936328000	23151	11484	20	0	\N
177117	1397	1301926327000	23151	11484	21	0	\N
177118	1397	1301916326000	23151	11484	22	0	\N
177119	1397	1301906325000	23151	11484	23	0	\N
177120	1397	1301896324000	23151	11484	24	0	\N
177121	1397	1301886323000	23151	11484	25	0	\N
177122	1397	1301876322000	23151	11484	26	0	\N
177123	1397	1301866321000	23151	11484	27	0	\N
177124	1397	1301856320000	23151	11484	28	0	\N
177125	1397	1301846319000	23151	11484	29	0	\N
177126	1397	1301836318000	23151	11484	30	0	\N
177127	1397	1301826317000	23151	11484	31	0	\N
177128	1397	1301816316000	23151	11484	32	0	\N
177129	1397	1301806315000	23151	11484	33	0	\N
177130	1397	1301796314000	23151	11484	34	0	\N
177131	1397	1301786313000	23151	11484	35	0	\N
177132	1397	1301776312000	23151	11484	36	0	\N
177133	1397	1301766311000	23151	11484	37	0	\N
177134	1397	1301756310000	23151	11484	38	0	\N
177135	1397	1301746309000	23151	11484	39	0	\N
177136	1397	1301736308000	23151	11484	40	0	\N
177137	1397	1301726307000	23151	11484	41	0	\N
177138	1397	1301716306000	23151	11484	42	0	\N
177139	1397	1301706305000	23151	11484	43	0	\N
177140	1397	1301696304000	23151	11484	44	0	\N
177141	1397	1301686303000	23151	11484	45	0	\N
177142	1397	1301676302000	23151	11484	46	0	\N
177143	1397	1301666301000	23151	11484	47	0	\N
177144	1397	1301656300000	23151	11484	48	0	\N
177145	1397	1301646299000	23151	11484	49	0	\N
177146	1397	1301636298000	23151	11484	50	0	\N
177147	1397	1301626297000	23151	11484	51	0	\N
177148	1397	1301616296000	23151	11484	52	0	\N
177149	1397	1301606295000	23151	11484	53	0	\N
177150	1397	1301596294000	23151	11484	54	0	\N
177151	1397	1301586293000	23151	11484	55	0	\N
177152	1397	1301576292000	23151	11484	56	0	\N
177153	1397	1301566291000	23151	11484	57	0	\N
177154	1397	1301556290000	23151	11484	58	0	\N
177155	1397	1301546289000	23151	11484	59	0	\N
177156	1397	1301536288000	23151	11484	60	0	\N
177157	1397	1301526287000	23151	11484	61	0	\N
177158	1397	1301516286000	23151	11484	62	0	\N
177159	1397	1301506285000	23151	11484	63	0	\N
177160	1397	1301496284000	23151	11484	64	0	\N
177161	1397	1301486283000	23151	11484	65	0	\N
177162	1397	1301476282000	23151	11484	66	0	\N
177163	1397	1301466281000	23151	11484	67	0	\N
177164	1397	1301456280000	23151	11484	68	0	\N
177165	1397	1301446279000	23151	11484	69	0	\N
177166	1397	1301436278000	23151	11484	70	0	\N
177167	1397	1301426277000	23151	11484	71	0	\N
177168	1397	1301416276000	23151	11484	72	0	\N
177169	1397	1301406275000	23151	11484	73	0	\N
177170	1397	1301396274000	23151	11484	74	0	\N
177171	1397	1301386273000	23151	11484	75	0	\N
177172	1397	1301376272000	23151	11484	76	0	\N
177173	1397	1301366271000	23151	11484	77	0	\N
177174	1397	1301356270000	23151	11484	78	0	\N
177175	1397	1301346269000	23151	11484	79	0	\N
177176	1397	1301336268000	23151	11484	80	0	\N
177177	1397	1301326267000	23151	11484	82	0	\N
177178	1397	1301316266000	23151	11484	83	0	\N
177179	1397	1301306265000	23151	11484	84	0	\N
177180	1397	1301296264000	23151	11484	85	0	\N
177181	1397	1301286263000	23151	11484	86	0	\N
177182	1397	1301276262000	23151	11484	87	0	\N
177183	1397	1301266261000	23151	11484	88	0	\N
177184	1397	1301256260000	23151	11484	89	0	\N
177185	1397	1301246259000	23151	11484	90	0	\N
177186	1397	1301236258000	23151	11484	91	0	\N
177187	1397	1301226257000	23151	11484	92	0	\N
177188	1397	1301216256000	23151	11484	93	0	\N
177189	1397	1301206255000	23151	11484	94	0	\N
177190	1397	1301196254000	23151	11484	95	0	\N
177191	1397	1301186253000	23151	11484	96	0	\N
177192	1397	1301176252000	23151	11484	97	0	\N
177193	1397	1301166251000	23151	11484	98	0	\N
177194	1397	1301156250000	23151	11484	99	0	\N
177195	1397	1301146249000	23151	11484	100	0	\N
177196	1397	1301136248000	23151	11484	101	0	\N
177197	1397	1301126247000	23151	11484	102	0	\N
177198	1397	1301116246000	23151	11484	103	0	\N
177199	1397	1301106245000	23151	11484	104	0	\N
177200	1397	1301096244000	23151	11484	105	0	\N
177201	1397	1301086243000	23151	11484	106	0	\N
177202	1397	1301076242000	23151	11484	107	0	\N
177203	1397	1301066241000	23151	11484	108	0	\N
177204	1397	1301056240000	23151	11484	109	0	\N
177205	1397	1301046239000	23151	11484	110	0	\N
177206	1397	1301036238000	23151	11484	111	0	\N
177207	1397	1301026237000	23151	11484	112	0	\N
177208	2132	147819821000	23151	11484	113	0	\N
177075	2134	86360373000	23146	11559	1	0	4217
177076	2133	93602642000	23146	11559	2	0	4180
177077	1397	1301056240000	23147	11560	0	0	13777
177078	1397	1301046239000	23147	11560	1	0	13778
177079	1397	1301036238000	23147	11560	2	0	13779
177081	2133	93601640000	23147	11560	4	0	4181
177082	2133	93600638000	23147	11560	5	0	4182
177083	2134	86359370000	23147	11560	6	0	4218
177084	2133	93599636000	23147	11560	7	0	4183
177085	2134	86358367000	23147	11560	8	0	4219
177090	1397	1301026237000	23149	11561	0	0	13780
177091	2134	86356361000	23149	11561	1	0	4221
177092	2133	93598634000	23149	11561	2	0	4184
177209	2132	147818820000	23151	11484	114	0	\N
177210	1593	20972641000000	23151	11484	115	0	\N
177211	647	66000099000000	23151	11484	116	0	\N
177212	2132	147817819000	23151	11484	117	0	\N
177213	2132	147816818000	23151	11484	118	0	\N
177214	2132	147815817000	23151	11484	119	0	\N
177215	2132	147814816000	23151	11484	120	0	\N
177216	2132	147813815000	23151	11484	121	0	\N
177217	2132	147812814000	23151	11484	122	0	\N
177218	1593	15750640000000	23151	11484	123	0	\N
177219	1593	12226639000000	23151	11484	124	0	\N
177220	1593	9312638000000	23151	11484	125	0	\N
177221	1397	1301016236000	23152	11562	0	0	\N
177222	2133	93597632000	23152	11562	1	0	\N
177223	2134	86355358000	23152	11562	2	0	\N
177224	2132	147786788000	23152	11562	3	0	\N
177229	1397	1301006235000	23155	11563	0	0	\N
177230	2134	86354355000	23155	11563	1	0	\N
177231	1397	1301146249000	23156	11537	0	0	\N
177232	1397	1301136248000	23156	11537	1	0	\N
177233	1397	1301126247000	23156	11537	2	0	\N
177234	1397	1301116246000	23156	11537	3	0	\N
177235	1397	1301106245000	23156	11537	4	0	\N
177236	1397	1301096244000	23156	11537	5	0	\N
177237	1397	1301086243000	23156	11537	6	0	\N
177238	1397	1301076242000	23156	11537	7	0	\N
177239	1397	1301066241000	23156	11537	8	0	\N
177240	1397	1301056240000	23156	11537	9	0	\N
177241	1397	1301046239000	23156	11537	10	0	\N
177242	1397	1301036238000	23156	11537	11	0	\N
177243	1397	1301026237000	23156	11537	12	0	\N
177244	1397	1301016236000	23156	11537	13	0	\N
177245	2132	147790792000	23156	11537	14	0	\N
177246	2132	147789791000	23156	11537	15	0	\N
177247	2133	93610658000	23156	11537	16	0	\N
177248	2133	93609656000	23156	11537	17	0	\N
177249	2133	93608654000	23156	11537	18	0	\N
177250	2133	93607652000	23156	11537	19	0	\N
177251	2133	93606650000	23156	11537	20	0	\N
177252	2133	93605648000	23156	11537	21	0	\N
177253	2133	93604646000	23156	11537	22	0	\N
177254	2133	93603644000	23156	11537	23	0	\N
177255	2133	93602642000	23156	11537	24	0	\N
177256	2133	93601640000	23156	11537	25	0	\N
177257	2133	93600638000	23156	11537	26	0	\N
177258	2133	93599636000	23156	11537	27	0	\N
177259	2134	86368397000	23156	11537	28	0	\N
177260	2134	86367394000	23156	11537	29	0	\N
177261	2134	86366391000	23156	11537	30	0	\N
177262	2134	86365388000	23156	11537	32	0	\N
177263	2134	86364385000	23156	11537	33	0	\N
177264	2134	86363382000	23156	11537	34	0	\N
177265	2134	86362379000	23156	11537	35	0	\N
177266	2134	86361376000	23156	11537	36	0	\N
177267	2134	86360373000	23156	11537	37	0	\N
177268	2134	86359370000	23156	11537	38	0	\N
177269	2134	86358367000	23156	11537	39	0	\N
177270	2134	86357364000	23156	11537	40	0	\N
177271	2134	86356361000	23156	11537	41	0	\N
177272	2134	86355358000	23156	11537	42	0	\N
177273	2132	147788790000	23156	11537	43	0	\N
177274	2132	147787789000	23156	11537	44	0	\N
177275	2132	147786788000	23156	11537	45	0	\N
177276	2133	93598634000	23156	11537	46	0	\N
177277	2133	93597632000	23156	11537	47	0	\N
177278	1397	1301006235000	23157	11563	0	0	\N
177279	1397	1301006235000	23158	11564	0	0	\N
177280	1397	1300996234000	23158	11564	1	0	\N
177281	1397	1300986233000	23158	11564	2	0	\N
177282	2134	86354355000	23158	11564	3	0	\N
177283	2132	147785787000	23158	11564	4	0	\N
177284	2134	86353352000	23158	11564	5	0	\N
177285	2134	86352349000	23158	11564	6	0	\N
177293	1397	1300976232000	23160	11565	0	0	\N
177294	2134	86351346000	23160	11565	1	0	\N
177302	1397	1300966231000	23163	11566	0	0	\N
177303	1397	1300956230000	23163	11566	1	0	\N
177304	2132	147784786000	23163	11566	2	0	\N
177305	2134	86350343000	23163	11566	3	0	\N
177306	2134	86349340000	23163	11566	4	0	\N
177307	1397	1300946229000	23164	11567	0	0	\N
177308	1397	1300936228000	23164	11567	1	0	\N
177309	2134	86348337000	23164	11567	2	0	\N
177310	2134	86347334000	23164	11567	3	0	\N
177317	1397	1300926227000	23167	11568	0	0	\N
177318	2134	86346331000	23167	11568	1	0	\N
177319	1397	1300926227000	23168	11568	0	0	\N
177320	2134	86346331000	23168	11568	1	0	\N
177321	1397	1300916226000	23169	11569	0	0	\N
177322	2134	86345328000	23169	11569	1	0	\N
177323	2132	147783785000	23169	11569	2	0	\N
177324	1397	1300916226000	23170	11569	0	0	\N
177325	2134	86345328000	23170	11569	1	0	\N
177326	2132	147783785000	23170	11569	2	0	\N
177330	1397	1300916226000	23172	11569	0	0	\N
177331	2134	86345328000	23172	11569	1	0	\N
177332	2132	147783785000	23172	11569	2	0	\N
177335	1397	1302886423000	23174	11429	0	0	\N
177336	1397	1302876422000	23174	11429	1	0	\N
177337	1397	1302866421000	23174	11429	2	0	\N
177338	1474	6665473000043	23174	11429	3	0	\N
177339	1397	1302856420000	23174	11429	4	0	\N
177340	1397	1302846419000	23174	11429	5	0	\N
177341	1397	1302836418000	23174	11429	6	0	\N
177342	1397	1302826417000	23174	11429	7	0	\N
177343	1397	1302816416000	23174	11429	8	0	\N
177344	1397	1302806415000	23174	11429	9	0	\N
177227	2134	86355358000	23153	11562	2	0	4222
177228	2132	147786788000	23153	11562	3	0	1212
177286	1397	1301006235000	23159	11564	0	0	13782
177287	1397	1300996234000	23159	11564	1	0	13783
177288	1397	1300986233000	23159	11564	2	0	13784
177290	2132	147785787000	23159	11564	4	0	1213
177291	2134	86353352000	23159	11564	5	0	4224
177292	2134	86352349000	23159	11564	6	0	4225
177295	1397	1300976232000	23161	11565	0	0	13785
177296	2134	86351346000	23161	11565	1	0	4226
177298	1397	1300956230000	23162	11566	1	0	13787
177299	2132	147784786000	23162	11566	2	0	1214
177300	2134	86350343000	23162	11566	3	0	4227
177301	2134	86349340000	23162	11566	4	0	4228
177312	1397	1300936228000	23165	11567	1	0	13789
177313	2134	86348337000	23165	11567	2	0	4229
177314	2134	86347334000	23165	11567	3	0	4230
177315	1397	1300926227000	23166	11568	0	0	13790
177316	2134	86346331000	23166	11568	1	0	4231
177328	2134	86345328000	23171	11569	1	0	4232
177329	2132	147783785000	23171	11569	2	0	1215
177333	1397	1300906225000	23173	11570	0	0	13792
177334	2134	86344325000	23173	11570	1	0	4233
177345	1397	1302796414000	23174	11429	10	0	\N
177346	1397	1302786413000	23174	11429	11	0	\N
177347	1397	1302776412000	23174	11429	12	0	\N
177348	1397	1302766411000	23174	11429	13	0	\N
177349	1397	1302756410000	23174	11429	14	0	\N
177350	1397	1302746409000	23174	11429	15	0	\N
177351	1397	1302736408000	23174	11429	16	0	\N
177352	1397	1302726407000	23174	11429	17	0	\N
177353	1397	1302716406000	23174	11429	18	0	\N
177354	1397	1302706405000	23174	11429	19	0	\N
177355	1397	1302696404000	23174	11429	20	0	\N
177356	1397	1302686403000	23174	11429	21	0	\N
177357	1397	1302676402000	23174	11429	22	0	\N
177358	1397	1302666401000	23174	11429	23	0	\N
177359	1397	1302656400000	23174	11429	24	0	\N
177360	1397	1302646399000	23174	11429	25	0	\N
177361	1397	1302636398000	23174	11429	26	0	\N
177362	1397	1302626397000	23174	11429	27	0	\N
177363	1397	1302616396000	23174	11429	28	0	\N
177364	1397	1302606395000	23174	11429	29	0	\N
177365	1397	1302596394000	23174	11429	30	0	\N
177366	1397	1302586393000	23174	11429	31	0	\N
177367	1397	1302576392000	23174	11429	32	0	\N
177368	1397	1302566391000	23174	11429	33	0	\N
177369	1397	1302556390000	23174	11429	34	0	\N
177370	1397	1302546389000	23174	11429	35	0	\N
177371	1397	1302536388000	23174	11429	36	0	\N
177372	1397	1302526387000	23174	11429	37	0	\N
177373	1397	1302516386000	23174	11429	38	0	\N
177374	1397	1302506385000	23174	11429	39	0	\N
177375	1397	1302496384000	23174	11429	40	0	\N
177376	1397	1302486383000	23174	11429	41	0	\N
177377	1397	1302476382000	23174	11429	42	0	\N
177378	1397	1302466381000	23174	11429	43	0	\N
177379	1397	1302456380000	23174	11429	44	0	\N
177380	1397	1302446379000	23174	11429	45	0	\N
177381	1397	1302436378000	23174	11429	46	0	\N
177382	1397	1302426377000	23174	11429	47	0	\N
177383	1397	1302416376000	23174	11429	48	0	\N
177384	1397	1302406375000	23174	11429	49	0	\N
177385	1397	1302396374000	23174	11429	50	0	\N
177386	1397	1302386373000	23174	11429	51	0	\N
177387	1397	1302376372000	23174	11429	52	0	\N
177388	1397	1302366371000	23174	11429	53	0	\N
177389	1397	1302356370000	23174	11429	54	0	\N
177390	1397	1302346369000	23174	11429	55	0	\N
177391	1397	1302336368000	23174	11429	56	0	\N
177392	1397	1302326367000	23174	11429	57	0	\N
177393	1397	1302316366000	23174	11429	58	0	\N
177394	1397	1302306365000	23174	11429	59	0	\N
177395	1397	1302296364000	23174	11429	60	0	\N
177396	1397	1302286363000	23174	11429	61	0	\N
177397	1397	1302276362000	23174	11429	62	0	\N
177398	1397	1302266361000	23174	11429	63	0	\N
177399	1397	1302256360000	23174	11429	64	0	\N
177400	1397	1302246359000	23174	11429	65	0	\N
177401	1397	1302236358000	23174	11429	66	0	\N
177402	1397	1302226357000	23174	11429	68	0	\N
177403	1397	1302216356000	23174	11429	69	0	\N
177404	1397	1302206355000	23174	11429	70	0	\N
177405	1397	1302196354000	23174	11429	71	0	\N
177406	1397	1302186353000	23174	11429	72	0	\N
177407	1397	1302176352000	23174	11429	73	0	\N
177408	1397	1302166351000	23174	11429	74	0	\N
177409	1397	1302156350000	23174	11429	75	0	\N
177410	1397	1302146349000	23174	11429	76	0	\N
177411	1397	1302136348000	23174	11429	77	0	\N
177412	1397	1302126347000	23174	11429	78	0	\N
177413	1397	1302116346000	23174	11429	79	0	\N
177414	1397	1302106345000	23174	11429	80	0	\N
177415	1397	1302096344000	23174	11429	81	0	\N
177416	1397	1302086343000	23174	11429	82	0	\N
177417	1397	1302076342000	23174	11429	83	0	\N
177418	1397	1302066341000	23174	11429	84	0	\N
177419	1397	1302056340000	23174	11429	85	0	\N
177420	1397	1302046339000	23174	11429	86	0	\N
177421	1397	1302036338000	23174	11429	87	0	\N
177422	1397	1302026337000	23174	11429	88	0	\N
177423	1397	1302016336000	23174	11429	89	0	\N
177424	1397	1302006335000	23174	11429	90	0	\N
177425	1397	1301996334000	23174	11429	91	0	\N
177426	1397	1301986333000	23174	11429	92	0	\N
177427	1397	1301976332000	23174	11429	93	0	\N
177428	1397	1301966331000	23174	11429	94	0	\N
177429	1397	1301956330000	23174	11429	95	0	\N
177430	1397	1301946329000	23174	11429	96	0	\N
177431	1397	1301936328000	23174	11429	97	0	\N
177432	1397	1301926327000	23174	11429	98	0	\N
177433	1397	1301916326000	23174	11429	99	0	\N
177434	1397	1301906325000	23174	11429	100	0	\N
177435	1397	1301896324000	23174	11429	101	0	\N
177436	1397	1301886323000	23174	11429	102	0	\N
177437	1397	1301876322000	23174	11429	103	0	\N
177438	1397	1301866321000	23174	11429	104	0	\N
177439	1397	1301856320000	23174	11429	105	0	\N
177440	1397	1301846319000	23174	11429	106	0	\N
177441	1397	1301836318000	23174	11429	107	0	\N
177442	1397	1301826317000	23174	11429	108	0	\N
177443	1397	1301816316000	23174	11429	109	0	\N
177444	1397	1301806315000	23174	11429	110	0	\N
177445	1397	1301796314000	23174	11429	111	0	\N
177446	1397	1301786313000	23174	11429	112	0	\N
177447	1397	1301776312000	23174	11429	113	0	\N
177448	1397	1301766311000	23174	11429	114	0	\N
177449	1397	1301756310000	23174	11429	115	0	\N
177450	1397	1301746309000	23174	11429	116	0	\N
177451	1397	1301736308000	23174	11429	117	0	\N
177452	1397	1301726307000	23174	11429	118	0	\N
177453	1397	1301716306000	23174	11429	119	0	\N
177454	1397	1301706305000	23174	11429	120	0	\N
177455	1397	1301696304000	23174	11429	121	0	\N
177456	1397	1301686303000	23174	11429	122	0	\N
177457	1397	1301676302000	23174	11429	123	0	\N
177458	1397	1301666301000	23174	11429	124	0	\N
177459	1397	1301656300000	23174	11429	125	0	\N
177463	1397	1300896224000	23176	11571	0	0	\N
177464	1397	1300886223000	23176	11571	1	0	\N
177465	2134	86343322000	23176	11571	2	0	\N
177466	2132	147782784000	23176	11571	3	0	\N
177467	2134	86342319000	23176	11571	4	0	\N
177474	1397	1301346269000	23179	11538	0	0	\N
177475	1397	1301336268000	23179	11538	1	0	\N
177476	1397	1301326267000	23179	11538	2	0	\N
177477	1397	1301316266000	23179	11538	3	0	\N
177478	1397	1301306265000	23179	11538	4	0	\N
177479	1397	1301296264000	23179	11538	5	0	\N
177480	1397	1301286263000	23179	11538	6	0	\N
177462	2132	147782784000	23175	11571	2	0	1216
177468	1397	1300876222000	23177	11572	0	0	13795
177469	2134	86343322000	23177	11572	1	0	4234
177470	2134	86342319000	23177	11572	2	0	4235
177471	2134	86341316000	23177	11572	3	0	4236
177473	2134	86340313000	23178	11573	1	0	4237
177481	1397	1301276262000	23179	11538	7	0	\N
177482	1397	1301266261000	23179	11538	8	0	\N
177483	1397	1301256260000	23179	11538	9	0	\N
177484	1397	1301246259000	23179	11538	10	0	\N
177485	1397	1301236258000	23179	11538	11	0	\N
177486	1397	1301226257000	23179	11538	12	0	\N
177487	1397	1301216256000	23179	11538	13	0	\N
177488	1397	1301206255000	23179	11538	14	0	\N
177489	1397	1301196254000	23179	11538	15	0	\N
177490	1397	1301186253000	23179	11538	16	0	\N
177491	1397	1301176252000	23179	11538	17	0	\N
177492	1397	1301166251000	23179	11538	18	0	\N
177493	1397	1301156250000	23179	11538	19	0	\N
177494	1397	1301146249000	23179	11538	20	0	\N
177495	1397	1301136248000	23179	11538	21	0	\N
177496	1397	1301126247000	23179	11538	22	0	\N
177497	1397	1301116246000	23179	11538	23	0	\N
177498	1397	1301106245000	23179	11538	24	0	\N
177499	1397	1301096244000	23179	11538	25	0	\N
177500	1397	1301086243000	23179	11538	26	0	\N
177501	1397	1301076242000	23179	11538	27	0	\N
177502	1397	1301066241000	23179	11538	28	0	\N
177503	1397	1301056240000	23179	11538	29	0	\N
177504	1397	1301046239000	23179	11538	30	0	\N
177505	1397	1301036238000	23179	11538	31	0	\N
177506	1397	1301026237000	23179	11538	32	0	\N
177507	1397	1301016236000	23179	11538	33	0	\N
177508	1397	1301006235000	23179	11538	34	0	\N
177509	1397	1300996234000	23179	11538	35	0	\N
177510	1397	1300986233000	23179	11538	36	0	\N
177511	1397	1300976232000	23179	11538	37	0	\N
177512	1397	1300966231000	23179	11538	38	0	\N
177513	1397	1300956230000	23179	11538	39	0	\N
177514	1397	1300946229000	23179	11538	40	0	\N
177515	1397	1300936228000	23179	11538	41	0	\N
177516	1397	1300926227000	23179	11538	42	0	\N
177517	1397	1300916226000	23179	11538	43	0	\N
177518	1397	1300906225000	23179	11538	44	0	\N
177519	1397	1300896224000	23179	11538	45	0	\N
177520	1397	1300886223000	23179	11538	46	0	\N
177521	1397	1300876222000	23179	11538	47	0	\N
177522	1397	1300866221000	23179	11538	48	0	\N
177523	1397	1300856220000	23179	11538	49	0	\N
177524	1397	1300846219000	23179	11538	50	0	\N
177525	2134	86388457000	23179	11538	51	0	\N
177526	2134	86387454000	23179	11538	52	0	\N
177527	2133	93629696000	23179	11538	53	0	\N
177528	2133	93628694000	23179	11538	54	0	\N
177529	1593	20972641000000	23179	11538	55	0	\N
177530	647	66000099000000	23179	11538	56	0	\N
177531	2134	86386451000	23179	11538	57	0	\N
177532	2134	86385448000	23179	11538	58	0	\N
177533	2134	86384445000	23179	11538	59	0	\N
177534	2132	147795797000	23179	11538	60	0	\N
177535	2132	147794796000	23179	11538	61	0	\N
177536	2134	86383442000	23179	11538	62	0	\N
177537	2134	86382439000	23179	11538	63	0	\N
177538	2134	86381436000	23179	11538	64	0	\N
177539	1593	15750640000000	23179	11538	65	0	\N
177540	1593	12226639000000	23179	11538	66	0	\N
177541	1593	9312638000000	23179	11538	67	0	\N
177542	2133	93627692000	23179	11538	68	0	\N
177543	2132	147793795000	23179	11538	69	0	\N
177544	2132	147792794000	23179	11538	70	0	\N
177545	2132	147791793000	23179	11538	71	0	\N
177546	2132	147790792000	23179	11538	72	0	\N
177547	2132	147789791000	23179	11538	73	0	\N
177548	2134	86380433000	23179	11538	74	0	\N
177549	2134	86379430000	23179	11538	75	0	\N
177550	2132	147788790000	23179	11538	76	0	\N
177551	2132	147787789000	23179	11538	77	0	\N
177552	2132	147786788000	23179	11538	78	0	\N
177553	2132	147785787000	23179	11538	79	0	\N
177554	2132	147784786000	23179	11538	80	0	\N
177555	2132	147783785000	23179	11538	81	0	\N
177556	2132	147782784000	23179	11538	82	0	\N
177557	2132	147781783000	23179	11538	83	0	\N
177558	2133	93626690000	23179	11538	84	0	\N
177559	2133	93625688000	23179	11538	85	0	\N
177560	2133	93624686000	23179	11538	86	0	\N
177561	2133	93623684000	23179	11538	87	0	\N
177562	2133	93622682000	23179	11538	88	0	\N
177563	2133	93621680000	23179	11538	89	0	\N
177564	2133	93620678000	23179	11538	90	0	\N
177565	2133	93619676000	23179	11538	91	0	\N
177566	2133	93618674000	23179	11538	92	0	\N
177567	2133	93617672000	23179	11538	93	0	\N
177568	2133	93616670000	23179	11538	94	0	\N
177569	2133	93615668000	23179	11538	95	0	\N
177570	2133	93614666000	23179	11538	96	0	\N
177571	2133	93613664000	23179	11538	97	0	\N
177572	2133	93612662000	23179	11538	99	0	\N
177573	2133	93611660000	23179	11538	100	0	\N
177574	2133	93610658000	23179	11538	101	0	\N
177575	2133	93609656000	23179	11538	102	0	\N
177576	2133	93608654000	23179	11538	103	0	\N
177577	2133	93607652000	23179	11538	104	0	\N
177578	2133	93606650000	23179	11538	105	0	\N
177579	2133	93605648000	23179	11538	106	0	\N
177580	2133	93604646000	23179	11538	107	0	\N
177581	2133	93603644000	23179	11538	108	0	\N
177582	2133	93602642000	23179	11538	109	0	\N
177583	2133	93601640000	23179	11538	110	0	\N
177584	2133	93600638000	23179	11538	111	0	\N
177585	2133	93599636000	23179	11538	112	0	\N
177586	2133	93598634000	23179	11538	113	0	\N
177587	2133	93597632000	23179	11538	114	0	\N
177588	2134	86378427000	23179	11538	115	0	\N
177589	2134	86377424000	23179	11538	116	0	\N
177590	2134	86376421000	23179	11538	117	0	\N
177591	2134	86375418000	23179	11538	118	0	\N
177592	2134	86374415000	23179	11538	119	0	\N
177593	2134	86373412000	23179	11538	120	0	\N
177594	2134	86372409000	23179	11538	121	0	\N
177595	2134	86371406000	23179	11538	122	0	\N
177596	2134	86370403000	23179	11538	123	0	\N
177597	2134	86369400000	23179	11538	124	0	\N
177598	2134	86368397000	23179	11538	125	0	\N
177606	1397	1300856220000	23181	11574	0	0	\N
177607	1397	1300846219000	23181	11574	1	0	\N
177608	1397	1300836218000	23181	11574	2	0	\N
177609	1397	1300826217000	23181	11574	3	0	\N
177610	1397	1300816216000	23181	11574	5	0	\N
177611	2134	86339310000	23181	11574	6	0	\N
177612	2134	86338307000	23181	11574	7	0	\N
177613	2134	86337304000	23181	11574	8	0	\N
177614	2134	86336301000	23181	11574	9	0	\N
177615	2134	86335298000	23181	11574	10	0	\N
177616	2132	147781783000	23181	11574	11	0	\N
177601	1397	1300836218000	23180	11574	2	0	13799
177602	1397	1300826217000	23180	11574	3	0	13800
177603	1397	1300816216000	23180	11574	5	0	13801
177604	2132	147781783000	23180	11574	6	0	1217
177605	2132	147780782000	23180	11574	7	0	1218
177617	2132	147780782000	23181	11574	12	0	\N
177618	1397	1300856220000	23182	11574	0	0	\N
177619	1397	1300846219000	23182	11574	1	0	\N
177620	1397	1300836218000	23182	11574	2	0	\N
177621	1397	1300826217000	23182	11574	3	0	\N
177622	1397	1300816216000	23182	11574	5	0	\N
177623	2134	86339310000	23182	11574	6	0	\N
177624	2134	86338307000	23182	11574	7	0	\N
177625	2134	86337304000	23182	11574	8	0	\N
177626	2134	86336301000	23182	11574	9	0	\N
177627	2134	86335298000	23182	11574	10	0	\N
177628	2132	147781783000	23182	11574	11	0	\N
177629	2132	147780782000	23182	11574	12	0	\N
177630	1397	1300856220000	23183	11574	0	0	\N
177631	1397	1300846219000	23183	11574	1	0	\N
177632	1397	1300836218000	23183	11574	2	0	\N
177633	1397	1300826217000	23183	11574	3	0	\N
177634	1397	1300816216000	23183	11574	5	0	\N
177635	2134	86339310000	23183	11574	6	0	\N
177636	2134	86338307000	23183	11574	7	0	\N
177637	2134	86337304000	23183	11574	8	0	\N
177638	2134	86336301000	23183	11574	9	0	\N
177639	2134	86335298000	23183	11574	10	0	\N
177640	2132	147781783000	23183	11574	11	0	\N
177641	2132	147780782000	23183	11574	12	0	\N
177642	1397	1303176452000	23184	11405	0	0	\N
177643	1550	0	23184	11405	1	0	\N
177644	1474	6665473000043	23184	11405	2	0	\N
177645	1397	1303166451000	23184	11405	3	0	\N
177646	1397	1303156450000	23184	11405	4	0	\N
177647	1580	2100034000000	23184	11405	5	0	\N
177648	1580	24000000	23184	11405	6	0	\N
177649	1397	1303146449000	23184	11405	7	0	\N
177650	1397	1303136448000	23184	11405	8	0	\N
177651	1397	1303126447000	23184	11405	9	0	\N
177652	1397	1303116446000	23184	11405	10	0	\N
177653	1397	1303106445000	23184	11405	11	0	\N
177654	1397	1303096444000	23184	11405	12	0	\N
177655	1397	1303086443000	23184	11405	13	0	\N
177656	1397	1303076442000	23184	11405	14	0	\N
177657	1397	1303066441000	23184	11405	15	0	\N
177658	1397	1303056440000	23184	11405	16	0	\N
177659	1397	1303046439000	23184	11405	17	0	\N
177660	1397	1303036438000	23184	11405	18	0	\N
177661	1397	1303026437000	23184	11405	19	0	\N
177662	1397	1303016436000	23184	11405	20	0	\N
177663	1397	1303006435000	23184	11405	21	0	\N
177664	1397	1302996434000	23184	11405	22	0	\N
177665	1397	1302986433000	23184	11405	23	0	\N
177666	1397	1302976432000	23184	11405	24	0	\N
177667	1397	1302966431000	23184	11405	25	0	\N
177668	1397	1302956430000	23184	11405	26	0	\N
177669	1397	1302946429000	23184	11405	27	0	\N
177670	1397	1302936428000	23184	11405	28	0	\N
177671	1397	1302926427000	23184	11405	29	0	\N
177672	1397	1302916426000	23184	11405	30	0	\N
177673	1397	1302906425000	23184	11405	31	0	\N
177674	1397	1302896424000	23184	11405	32	0	\N
177675	1397	1302886423000	23184	11405	33	0	\N
177676	1397	1302876422000	23184	11405	34	0	\N
177677	1397	1302866421000	23184	11405	35	0	\N
177678	1397	1302856420000	23184	11405	36	0	\N
177679	1397	1302846419000	23184	11405	37	0	\N
177680	1397	1302836418000	23184	11405	38	0	\N
177681	1397	1302826417000	23184	11405	39	0	\N
177682	1397	1302816416000	23184	11405	40	0	\N
177683	1397	1302806415000	23184	11405	41	0	\N
177684	1397	1302796414000	23184	11405	42	0	\N
177685	1397	1302786413000	23184	11405	43	0	\N
177686	1397	1302776412000	23184	11405	44	0	\N
177687	1397	1302766411000	23184	11405	45	0	\N
177688	1397	1302756410000	23184	11405	46	0	\N
177689	1397	1302746409000	23184	11405	47	0	\N
177690	1397	1302736408000	23184	11405	48	0	\N
177691	1397	1302726407000	23184	11405	49	0	\N
177692	1397	1302716406000	23184	11405	50	0	\N
177693	1397	1302706405000	23184	11405	51	0	\N
177694	1397	1302696404000	23184	11405	52	0	\N
177695	1397	1302686403000	23184	11405	53	0	\N
177696	1397	1302676402000	23184	11405	54	0	\N
177697	1397	1302666401000	23184	11405	55	0	\N
177698	1397	1302656400000	23184	11405	56	0	\N
177699	1397	1302646399000	23184	11405	57	0	\N
177700	1397	1302636398000	23184	11405	58	0	\N
177701	1397	1302626397000	23184	11405	59	0	\N
177702	1397	1302616396000	23184	11405	60	0	\N
177703	1397	1302606395000	23184	11405	61	0	\N
177704	1397	1302596394000	23184	11405	62	0	\N
177705	1397	1302586393000	23184	11405	63	0	\N
177706	1397	1302576392000	23184	11405	64	0	\N
177707	1397	1302566391000	23184	11405	65	0	\N
177708	1397	1302556390000	23184	11405	66	0	\N
177709	1397	1302546389000	23184	11405	67	0	\N
177710	1397	1302536388000	23184	11405	68	0	\N
177711	1397	1302526387000	23184	11405	69	0	\N
177712	1397	1302516386000	23184	11405	70	0	\N
177713	1397	1302506385000	23184	11405	71	0	\N
177714	1397	1302496384000	23184	11405	72	0	\N
177715	1397	1302486383000	23184	11405	73	0	\N
177716	1397	1302476382000	23184	11405	74	0	\N
177717	1397	1302466381000	23184	11405	75	0	\N
177718	1397	1302456380000	23184	11405	76	0	\N
177719	1397	1302446379000	23184	11405	77	0	\N
177720	1397	1302436378000	23184	11405	78	0	\N
177721	1397	1302426377000	23184	11405	79	0	\N
177722	1397	1302416376000	23184	11405	80	0	\N
177723	1397	1302406375000	23184	11405	81	0	\N
177724	1397	1302396374000	23184	11405	82	0	\N
177725	1397	1302386373000	23184	11405	83	0	\N
177726	1397	1302376372000	23184	11405	84	0	\N
177727	1397	1302366371000	23184	11405	85	0	\N
177728	1397	1302356370000	23184	11405	86	0	\N
177729	1397	1302346369000	23184	11405	87	0	\N
177730	1397	1302336368000	23184	11405	89	0	\N
177731	1397	1302326367000	23184	11405	90	0	\N
177732	1397	1302316366000	23184	11405	91	0	\N
177733	1397	1302306365000	23184	11405	92	0	\N
177734	1397	1302296364000	23184	11405	93	0	\N
177735	1397	1302286363000	23184	11405	94	0	\N
177736	1397	1302276362000	23184	11405	95	0	\N
177737	1397	1302266361000	23184	11405	96	0	\N
177738	1397	1302256360000	23184	11405	97	0	\N
177739	1397	1302246359000	23184	11405	98	0	\N
177740	1397	1302236358000	23184	11405	99	0	\N
177741	1397	1302226357000	23184	11405	100	0	\N
177742	1397	1302216356000	23184	11405	101	0	\N
177743	1397	1302206355000	23184	11405	102	0	\N
177744	1397	1302196354000	23184	11405	103	0	\N
177745	1397	1302186353000	23184	11405	104	0	\N
177746	1397	1302176352000	23184	11405	105	0	\N
177747	1397	1302166351000	23184	11405	106	0	\N
177748	1397	1302156350000	23184	11405	107	0	\N
177749	1397	1302146349000	23184	11405	108	0	\N
177750	1397	1302136348000	23184	11405	109	0	\N
177751	1397	1302126347000	23184	11405	110	0	\N
177752	1397	1302116346000	23184	11405	111	0	\N
177753	1397	1302106345000	23184	11405	112	0	\N
177754	1397	1302096344000	23184	11405	113	0	\N
177755	1397	1302086343000	23184	11405	114	0	\N
177756	1397	1302076342000	23184	11405	115	0	\N
177757	1397	1302066341000	23184	11405	116	0	\N
177758	1397	1302056340000	23184	11405	117	0	\N
177759	1397	1302046339000	23184	11405	118	0	\N
177760	1397	1302036338000	23184	11405	119	0	\N
177761	1397	1302026337000	23184	11405	120	0	\N
177762	1397	1302016336000	23184	11405	121	0	\N
177763	1397	1302006335000	23184	11405	122	0	\N
177764	1397	1301996334000	23184	11405	123	0	\N
177765	1397	1301986333000	23184	11405	124	0	\N
177766	1397	1301976332000	23184	11405	125	0	\N
177779	1397	1300776212000	23187	11577	0	0	\N
177780	2134	86331286000	23187	11577	1	0	\N
177783	1397	1300766211000	23189	11578	0	0	\N
177784	2134	86330283000	23189	11578	1	0	\N
177787	1397	1300766211000	23191	11578	0	0	\N
177788	2134	86330283000	23191	11578	1	0	\N
177789	1397	1300756210000	23192	11579	0	0	\N
177790	2132	147778780000	23192	11579	1	0	\N
177791	2134	86329280000	23192	11579	2	0	\N
177792	1397	1300756210000	23193	11579	0	0	\N
177793	2132	147778780000	23193	11579	1	0	\N
177794	2134	86329280000	23193	11579	2	0	\N
177795	1397	1300756210000	23194	11579	0	0	\N
177796	2132	147778780000	23194	11579	1	0	\N
177797	2134	86329280000	23194	11579	2	0	\N
177801	1397	1300756210000	23196	11579	0	0	\N
177802	2132	147778780000	23196	11579	1	0	\N
177803	2134	86329280000	23196	11579	2	0	\N
177804	2134	86329280000	23197	11579	0	0	\N
177814	1397	1300706205000	23202	11584	0	0	\N
177815	1397	1300696204000	23202	11584	1	0	\N
177816	2134	86324265000	23202	11584	2	0	\N
177817	2134	86323262000	23202	11584	3	0	\N
177822	1397	1300706205000	23204	11584	0	0	\N
177823	1397	1300696204000	23204	11584	1	0	\N
177824	2134	86324265000	23204	11584	2	0	\N
177825	2134	86323262000	23204	11584	3	0	\N
177826	1397	1300706205000	23205	11584	0	0	\N
177827	1397	1300696204000	23205	11584	1	0	\N
177828	2134	86324265000	23205	11584	2	0	\N
177829	2134	86323262000	23205	11584	3	0	\N
177830	1397	1300686203000	23206	11585	0	0	\N
177831	2134	86322259000	23206	11585	1	0	\N
177832	1397	1300686203000	23207	11585	0	0	\N
177833	2134	86322259000	23207	11585	1	0	\N
177836	1397	1300686203000	23209	11585	0	0	\N
177837	2134	86322259000	23209	11585	1	0	\N
177838	2134	86322259000	23210	11585	0	0	\N
177839	2134	86322259000	23211	11585	0	0	\N
177842	1397	1300676202000	23213	11586	0	0	\N
177843	2134	86321256000	23213	11586	1	0	\N
177844	1397	1301456280000	23214	11516	0	0	\N
177845	1397	1301446279000	23214	11516	1	0	\N
177846	1397	1301436278000	23214	11516	2	0	\N
177847	1397	1301426277000	23214	11516	3	0	\N
177848	1397	1301416276000	23214	11516	4	0	\N
177849	1397	1301406275000	23214	11516	5	0	\N
177850	1397	1301396274000	23214	11516	6	0	\N
177851	1397	1301386273000	23214	11516	7	0	\N
177852	1397	1301376272000	23214	11516	8	0	\N
177853	1397	1301366271000	23214	11516	9	0	\N
177854	1397	1301356270000	23214	11516	10	0	\N
177855	1397	1301346269000	23214	11516	11	0	\N
177856	1397	1301336268000	23214	11516	12	0	\N
177857	1397	1301326267000	23214	11516	13	0	\N
177858	1397	1301316266000	23214	11516	14	0	\N
177859	1397	1301306265000	23214	11516	15	0	\N
177860	1397	1301296264000	23214	11516	16	0	\N
177861	1397	1301286263000	23214	11516	17	0	\N
177862	1397	1301276262000	23214	11516	18	0	\N
177863	1397	1301266261000	23214	11516	19	0	\N
177864	1397	1301256260000	23214	11516	20	0	\N
177865	1397	1301246259000	23214	11516	21	0	\N
177866	1397	1301236258000	23214	11516	22	0	\N
177867	1397	1301226257000	23214	11516	23	0	\N
177868	1397	1301216256000	23214	11516	24	0	\N
177869	1397	1301206255000	23214	11516	25	0	\N
177870	1397	1301196254000	23214	11516	26	0	\N
177871	1397	1301186253000	23214	11516	27	0	\N
177872	1397	1301176252000	23214	11516	28	0	\N
177873	1397	1301166251000	23214	11516	29	0	\N
177874	1397	1301156250000	23214	11516	30	0	\N
177875	1397	1301146249000	23214	11516	31	0	\N
177876	1397	1301136248000	23214	11516	32	0	\N
177877	1397	1301126247000	23214	11516	33	0	\N
177878	1397	1301116246000	23214	11516	34	0	\N
177879	1397	1301106245000	23214	11516	35	0	\N
177880	1397	1301096244000	23214	11516	36	0	\N
177881	1397	1301086243000	23214	11516	37	0	\N
177882	1397	1301076242000	23214	11516	38	0	\N
177883	1397	1301066241000	23214	11516	39	0	\N
177884	1397	1301056240000	23214	11516	40	0	\N
177885	1397	1301046239000	23214	11516	41	0	\N
177886	1397	1301036238000	23214	11516	42	0	\N
177887	1397	1301026237000	23214	11516	43	0	\N
177888	1397	1301016236000	23214	11516	44	0	\N
177769	2134	86338307000	23185	11575	2	0	4239
177770	2134	86337304000	23185	11575	3	0	4240
177771	2134	86336301000	23185	11575	4	0	4241
177772	2134	86335298000	23185	11575	5	0	4242
177773	2134	86334295000	23185	11575	6	0	4243
177775	1397	1300786213000	23186	11576	1	0	13804
177776	2132	147779781000	23186	11576	2	0	1219
177777	2134	86333292000	23186	11576	3	0	4244
177778	2134	86332289000	23186	11576	4	0	4245
177781	1397	1300776212000	23188	11577	0	0	13805
177785	1397	1300766211000	23190	11578	0	0	13806
177786	2134	86330283000	23190	11578	1	0	4247
177798	1397	1300756210000	23195	11579	0	0	13807
177799	2132	147778780000	23195	11579	1	0	1220
177805	1397	1300746209000	23198	11580	0	0	13808
177806	2134	86328277000	23198	11580	1	0	4249
177807	1397	1300736208000	23199	11581	0	0	13809
177808	2134	86327274000	23199	11581	1	0	4250
177809	1397	1300726207000	23200	11582	0	0	13810
177811	1397	1300716206000	23201	11583	0	0	13811
177812	2132	147777779000	23201	11583	1	0	1221
177813	2134	86325268000	23201	11583	2	0	4252
177818	1397	1300706205000	23203	11584	0	0	13812
177819	1397	1300696204000	23203	11584	1	0	13813
177821	2134	86323262000	23203	11584	3	0	4254
177834	1397	1300686203000	23208	11585	0	0	13814
177835	2134	86322259000	23208	11585	1	0	4255
177840	1397	1300676202000	23212	11586	0	0	13815
177889	1397	1301006235000	23214	11516	45	0	\N
177890	1397	1300996234000	23214	11516	46	0	\N
177891	1397	1300986233000	23214	11516	47	0	\N
177892	1397	1300976232000	23214	11516	48	0	\N
177893	1397	1300966231000	23214	11516	49	0	\N
177894	1397	1300956230000	23214	11516	51	0	\N
177895	1397	1300946229000	23214	11516	52	0	\N
177896	1397	1300936228000	23214	11516	53	0	\N
177897	1397	1300926227000	23214	11516	54	0	\N
177898	1397	1300916226000	23214	11516	55	0	\N
177899	1397	1300906225000	23214	11516	56	0	\N
177900	1397	1300896224000	23214	11516	57	0	\N
177901	1397	1300886223000	23214	11516	58	0	\N
177902	1397	1300876222000	23214	11516	59	0	\N
177903	1397	1300866221000	23214	11516	60	0	\N
177904	1397	1300856220000	23214	11516	61	0	\N
177905	1397	1300846219000	23214	11516	62	0	\N
177906	1397	1300836218000	23214	11516	63	0	\N
177907	1397	1300826217000	23214	11516	64	0	\N
177908	1397	1300816216000	23214	11516	65	0	\N
177909	1397	1300806215000	23214	11516	66	0	\N
177910	1397	1300796214000	23214	11516	67	0	\N
177911	1397	1300786213000	23214	11516	68	0	\N
177912	1397	1300776212000	23214	11516	69	0	\N
177913	1397	1300766211000	23214	11516	70	0	\N
177914	1397	1300756210000	23214	11516	71	0	\N
177915	1397	1300746209000	23214	11516	72	0	\N
177916	1397	1300736208000	23214	11516	73	0	\N
177917	1397	1300726207000	23214	11516	74	0	\N
177918	1397	1300716206000	23214	11516	75	0	\N
177919	1397	1300706205000	23214	11516	76	0	\N
177920	1397	1300696204000	23214	11516	77	0	\N
177921	1397	1300686203000	23214	11516	78	0	\N
177922	2133	93640718000	23214	11516	79	0	\N
177923	2134	86398487000	23214	11516	80	0	\N
177924	2132	147799801000	23214	11516	81	0	\N
177925	2132	147798800000	23214	11516	82	0	\N
177926	2132	147797799000	23214	11516	83	0	\N
177927	2132	147796798000	23214	11516	84	0	\N
177928	1593	20972641000000	23214	11516	85	0	\N
177929	647	66000099000000	23214	11516	86	0	\N
177930	2134	86397484000	23214	11516	87	0	\N
177931	2134	86396481000	23214	11516	88	0	\N
177932	2134	86395478000	23214	11516	89	0	\N
177933	2134	86394475000	23214	11516	90	0	\N
177934	2132	147795797000	23214	11516	91	0	\N
177935	2132	147794796000	23214	11516	92	0	\N
177936	1593	15750640000000	23214	11516	93	0	\N
177937	1593	12226639000000	23214	11516	94	0	\N
177938	1593	9312638000000	23214	11516	95	0	\N
177939	2133	93639716000	23214	11516	96	0	\N
177940	2133	93638714000	23214	11516	97	0	\N
177941	2133	93637712000	23214	11516	98	0	\N
177942	2133	93636710000	23214	11516	99	0	\N
177943	2133	93635708000	23214	11516	100	0	\N
177944	2133	93634706000	23214	11516	101	0	\N
177945	2133	93633704000	23214	11516	102	0	\N
177946	2133	93632702000	23214	11516	103	0	\N
177947	2133	93631700000	23214	11516	104	0	\N
177948	2133	93630698000	23214	11516	105	0	\N
177949	2133	93629696000	23214	11516	106	0	\N
177950	2133	93628694000	23214	11516	107	0	\N
177951	2133	93627692000	23214	11516	108	0	\N
177952	2132	147793795000	23214	11516	109	0	\N
177953	2134	86393472000	23214	11516	110	0	\N
177954	2134	86392469000	23214	11516	111	0	\N
177955	2134	86391466000	23214	11516	112	0	\N
177956	2134	86390463000	23214	11516	113	0	\N
177957	2134	86389460000	23214	11516	114	0	\N
177958	2134	86388457000	23214	11516	115	0	\N
177959	2134	86387454000	23214	11516	116	0	\N
177960	2134	86386451000	23214	11516	117	0	\N
177961	2134	86385448000	23214	11516	118	0	\N
177962	2134	86384445000	23214	11516	119	0	\N
177963	2134	86383442000	23214	11516	120	0	\N
177964	2134	86382439000	23214	11516	121	0	\N
177965	2134	86381436000	23214	11516	122	0	\N
177966	2132	147792794000	23214	11516	123	0	\N
177967	2132	147791793000	23214	11516	124	0	\N
177968	2132	147790792000	23214	11516	125	0	\N
177969	1397	1300666201000	23215	11587	0	0	\N
177970	394	66001818809135	23215	11587	1	0	\N
177971	2134	86320253000	23215	11587	2	0	\N
177975	1397	1300656200000	23217	11588	0	0	\N
177976	2134	86319250000	23217	11588	1	0	\N
177979	394	66001818809135	23219	11526	0	0	\N
177980	1593	20972641000000	23219	11526	1	0	\N
177981	1593	15750640000000	23219	11526	2	0	\N
177982	1593	12226639000000	23219	11526	3	0	\N
177983	1593	9312638000000	23219	11526	4	0	\N
177989	1397	1300926227000	23222	11568	0	0	\N
177990	394	66001818809135	23222	11568	1	0	\N
177991	1397	1300916226000	23222	11568	2	0	\N
177992	1397	1300906225000	23222	11568	3	0	\N
177993	1397	1300896224000	23222	11568	4	0	\N
177994	1397	1300886223000	23222	11568	5	0	\N
177995	1397	1300876222000	23222	11568	6	0	\N
177996	1397	1300866221000	23222	11568	7	0	\N
177997	1397	1300856220000	23222	11568	8	0	\N
177998	1397	1300846219000	23222	11568	9	0	\N
177999	1397	1300836218000	23222	11568	10	0	\N
178000	1397	1300826217000	23222	11568	11	0	\N
178001	1397	1300816216000	23222	11568	12	0	\N
178002	1397	1300806215000	23222	11568	13	0	\N
178003	1397	1300796214000	23222	11568	14	0	\N
178004	1397	1300786213000	23222	11568	15	0	\N
178005	1397	1300776212000	23222	11568	16	0	\N
178006	1397	1300766211000	23222	11568	17	0	\N
178007	1397	1300756210000	23222	11568	18	0	\N
178008	1397	1300746209000	23222	11568	19	0	\N
178009	1397	1300736208000	23222	11568	20	0	\N
178010	1397	1300726207000	23222	11568	21	0	\N
178011	1397	1300716206000	23222	11568	22	0	\N
178012	1397	1300706205000	23222	11568	23	0	\N
178013	1397	1300696204000	23222	11568	24	0	\N
178014	1397	1300686203000	23222	11568	25	0	\N
178015	1397	1300676202000	23222	11568	26	0	\N
178016	1397	1300666201000	23222	11568	27	0	\N
178017	1397	1300656200000	23222	11568	28	0	\N
178018	1397	1300646199000	23222	11568	29	0	\N
178019	2132	147783785000	23222	11568	30	0	\N
178020	2132	147782784000	23222	11568	31	0	\N
178021	2134	86346331000	23222	11568	33	0	\N
178022	2134	86345328000	23222	11568	34	0	\N
178023	2134	86344325000	23222	11568	35	0	\N
178024	2134	86343322000	23222	11568	36	0	\N
177974	2134	86320253000	23216	11587	2	0	4257
177977	1397	1300656200000	23218	11588	0	0	13817
177978	2134	86319250000	23218	11588	1	0	4258
177984	1397	1300646199000	23220	11589	0	0	13818
177985	2134	86318247000	23220	11589	1	0	4259
177987	1397	1300636198000	23221	11590	1	0	13819
177988	2134	86317244000	23221	11590	2	0	4260
178025	2134	86342319000	23222	11568	37	0	\N
178026	2134	86341316000	23222	11568	38	0	\N
178027	2134	86340313000	23222	11568	39	0	\N
178028	2134	86339310000	23222	11568	40	0	\N
178029	2134	86338307000	23222	11568	41	0	\N
178030	2134	86337304000	23222	11568	42	0	\N
178031	2134	86336301000	23222	11568	43	0	\N
178032	2134	86335298000	23222	11568	44	0	\N
178033	2134	86334295000	23222	11568	45	0	\N
178034	2134	86333292000	23222	11568	46	0	\N
178035	2134	86332289000	23222	11568	47	0	\N
178036	2134	86331286000	23222	11568	48	0	\N
178037	2134	86330283000	23222	11568	49	0	\N
178038	2134	86329280000	23222	11568	50	0	\N
178039	2134	86328277000	23222	11568	51	0	\N
178040	2134	86327274000	23222	11568	52	0	\N
178041	2132	147781783000	23222	11568	53	0	\N
178042	2134	86326271000	23222	11568	54	0	\N
178043	2134	86325268000	23222	11568	55	0	\N
178044	2134	86324265000	23222	11568	56	0	\N
178045	2134	86323262000	23222	11568	57	0	\N
178046	2134	86322259000	23222	11568	58	0	\N
178047	2134	86321256000	23222	11568	59	0	\N
178048	2134	86320253000	23222	11568	60	0	\N
178049	2134	86319250000	23222	11568	61	0	\N
178050	2134	86318247000	23222	11568	62	0	\N
178051	2134	86317244000	23222	11568	63	0	\N
178052	2132	147780782000	23222	11568	64	0	\N
178053	2132	147779781000	23222	11568	65	0	\N
178054	2132	147778780000	23222	11568	66	0	\N
178055	2132	147777779000	23222	11568	67	0	\N
178061	394	66001718809135	23226	11591	0	0	\N
178062	1397	1300626197000	23226	11591	1	0	\N
178063	1397	1300616196000	23226	11591	2	0	\N
178064	2134	86316241000	23226	11591	3	0	\N
178065	2134	86315238000	23226	11591	4	0	\N
178066	394	66001718809135	23227	11591	0	0	\N
178067	1397	1300626197000	23227	11591	1	0	\N
178068	1397	1300616196000	23227	11591	2	0	\N
178069	2134	86316241000	23227	11591	3	0	\N
178070	2134	86315238000	23227	11591	4	0	\N
178071	1397	1301676302000	23228	11515	0	0	\N
178072	1397	1301666301000	23228	11515	1	0	\N
178073	394	66001818809135	23228	11515	2	0	\N
178074	394	66001718809135	23228	11515	3	0	\N
178075	1397	1301656300000	23228	11515	4	0	\N
178076	1397	1301646299000	23228	11515	5	0	\N
178077	1397	1301636298000	23228	11515	6	0	\N
178078	1397	1301626297000	23228	11515	7	0	\N
178079	1397	1301616296000	23228	11515	8	0	\N
178080	1397	1301606295000	23228	11515	9	0	\N
178081	1397	1301596294000	23228	11515	10	0	\N
178082	1397	1301586293000	23228	11515	11	0	\N
178083	1397	1301576292000	23228	11515	12	0	\N
178084	1397	1301566291000	23228	11515	13	0	\N
178085	1397	1301556290000	23228	11515	14	0	\N
178086	1397	1301546289000	23228	11515	15	0	\N
178087	1397	1301536288000	23228	11515	16	0	\N
178088	1397	1301526287000	23228	11515	17	0	\N
178089	1397	1301516286000	23228	11515	18	0	\N
178090	1397	1301506285000	23228	11515	19	0	\N
178091	1397	1301496284000	23228	11515	20	0	\N
178092	1397	1301486283000	23228	11515	21	0	\N
178093	1397	1301476282000	23228	11515	22	0	\N
178094	1397	1301466281000	23228	11515	23	0	\N
178095	1397	1301456280000	23228	11515	24	0	\N
178096	1397	1301446279000	23228	11515	25	0	\N
178097	1397	1301436278000	23228	11515	26	0	\N
178098	1397	1301426277000	23228	11515	27	0	\N
178099	1397	1301416276000	23228	11515	28	0	\N
178100	1397	1301406275000	23228	11515	29	0	\N
178101	1397	1301396274000	23228	11515	30	0	\N
178102	1397	1301386273000	23228	11515	31	0	\N
178103	1397	1301376272000	23228	11515	32	0	\N
178104	1397	1301366271000	23228	11515	33	0	\N
178105	1397	1301356270000	23228	11515	34	0	\N
178106	1397	1301346269000	23228	11515	35	0	\N
178107	1397	1301336268000	23228	11515	36	0	\N
178108	1397	1301326267000	23228	11515	37	0	\N
178109	1397	1301316266000	23228	11515	38	0	\N
178110	1397	1301306265000	23228	11515	39	0	\N
178111	1397	1301296264000	23228	11515	40	0	\N
178112	1397	1301286263000	23228	11515	41	0	\N
178113	1397	1301276262000	23228	11515	42	0	\N
178114	1397	1301266261000	23228	11515	43	0	\N
178115	1397	1301256260000	23228	11515	44	0	\N
178116	1397	1301246259000	23228	11515	45	0	\N
178117	1397	1301236258000	23228	11515	46	0	\N
178118	1397	1301226257000	23228	11515	47	0	\N
178119	1397	1301216256000	23228	11515	48	0	\N
178120	1397	1301206255000	23228	11515	49	0	\N
178121	1397	1301196254000	23228	11515	50	0	\N
178122	1397	1301186253000	23228	11515	51	0	\N
178123	1397	1301176252000	23228	11515	52	0	\N
178124	1397	1301166251000	23228	11515	53	0	\N
178125	1397	1301156250000	23228	11515	54	0	\N
178126	1397	1301146249000	23228	11515	55	0	\N
178127	1397	1301136248000	23228	11515	56	0	\N
178128	1397	1301126247000	23228	11515	57	0	\N
178129	1397	1301116246000	23228	11515	58	0	\N
178130	1397	1301106245000	23228	11515	59	0	\N
178131	1397	1301096244000	23228	11515	60	0	\N
178132	1397	1301086243000	23228	11515	61	0	\N
178133	1397	1301076242000	23228	11515	62	0	\N
178134	1397	1301066241000	23228	11515	63	0	\N
178135	1397	1301056240000	23228	11515	64	0	\N
178136	1397	1301046239000	23228	11515	65	0	\N
178137	1397	1301036238000	23228	11515	66	0	\N
178138	1397	1301026237000	23228	11515	67	0	\N
178139	1397	1301016236000	23228	11515	68	0	\N
178140	1397	1301006235000	23228	11515	69	0	\N
178141	1397	1300996234000	23228	11515	70	0	\N
178142	1397	1300986233000	23228	11515	71	0	\N
178143	1397	1300976232000	23228	11515	72	0	\N
178144	1397	1300966231000	23228	11515	73	0	\N
178145	1397	1300956230000	23228	11515	74	0	\N
178146	1397	1300946229000	23228	11515	75	0	\N
178147	1397	1300936228000	23228	11515	76	0	\N
178148	1397	1300926227000	23228	11515	77	0	\N
178149	1397	1300916226000	23228	11515	78	0	\N
178150	1397	1300906225000	23228	11515	79	0	\N
178151	1397	1300896224000	23228	11515	80	0	\N
178152	1397	1300886223000	23228	11515	81	0	\N
178153	1397	1300876222000	23228	11515	82	0	\N
178154	1397	1300866221000	23228	11515	83	0	\N
178155	1397	1300856220000	23228	11515	84	0	\N
178156	1397	1300846219000	23228	11515	85	0	\N
178157	1397	1300836218000	23228	11515	86	0	\N
178158	1397	1300826217000	23228	11515	87	0	\N
178159	1397	1300816216000	23228	11515	88	0	\N
178160	1397	1300806215000	23228	11515	89	0	\N
178058	1397	1300616196000	23225	11591	2	0	13821
178059	2134	86316241000	23225	11591	3	0	4261
178060	2134	86315238000	23225	11591	4	0	4262
178161	1397	1300796214000	23228	11515	90	0	\N
178162	1397	1300786213000	23228	11515	91	0	\N
178163	1397	1300776212000	23228	11515	92	0	\N
178164	1397	1300766211000	23228	11515	93	0	\N
178165	1397	1300756210000	23228	11515	94	0	\N
178166	1397	1300746209000	23228	11515	95	0	\N
178167	1397	1300736208000	23228	11515	96	0	\N
178168	1397	1300726207000	23228	11515	97	0	\N
178169	1397	1300716206000	23228	11515	98	0	\N
178170	1397	1300706205000	23228	11515	99	0	\N
178171	1397	1300696204000	23228	11515	100	0	\N
178172	1397	1300686203000	23228	11515	101	0	\N
178173	1397	1300676202000	23228	11515	102	0	\N
178174	1397	1300666201000	23228	11515	103	0	\N
178175	1397	1300656200000	23228	11515	104	0	\N
178176	1397	1300646199000	23228	11515	105	0	\N
178177	1397	1300636198000	23228	11515	106	0	\N
178178	1397	1300626197000	23228	11515	107	0	\N
178179	1397	1300616196000	23228	11515	108	0	\N
178180	2134	86420553000	23228	11515	109	0	\N
178181	2134	86419550000	23228	11515	110	0	\N
178182	2134	86418547000	23228	11515	111	0	\N
178183	2133	93662762000	23228	11515	112	0	\N
178184	1593	20972641000000	23228	11515	113	0	\N
178185	647	66000099000000	23228	11515	114	0	\N
178186	2132	147805807000	23228	11515	115	0	\N
178187	2133	93661760000	23228	11515	116	0	\N
178188	2133	93660758000	23228	11515	117	0	\N
178189	2133	93659756000	23228	11515	118	0	\N
178190	2133	93658754000	23228	11515	119	0	\N
178191	2133	93657752000	23228	11515	120	0	\N
178192	1593	15750640000000	23228	11515	121	0	\N
178193	1593	12226639000000	23228	11515	122	0	\N
178194	1593	9312638000000	23228	11515	123	0	\N
178195	2134	86417544000	23228	11515	125	0	\N
178196	1397	1300606195000	23230	11592	0	0	\N
178197	2134	86314235000	23230	11592	1	0	\N
178200	1397	1300596194000	23232	11593	0	0	\N
178201	2134	86313232000	23232	11593	1	0	\N
178205	1397	1300586193000	23235	11595	0	0	\N
178206	2134	86311226000	23235	11595	1	0	\N
178211	1397	1300576192000	23238	11596	0	0	\N
178212	2134	86310223000	23238	11596	1	0	\N
178215	1397	1300566191000	23240	11597	0	0	\N
178216	2134	86309220000	23240	11597	1	0	\N
178217	1397	1300556190000	23241	11598	0	0	\N
178218	2134	86308217000	23241	11598	1	0	\N
178223	394	66001818809135	23244	11547	0	0	\N
178224	394	66001718809135	23244	11547	1	0	\N
178225	1593	20972641000000	23244	11547	2	0	\N
178226	1593	15750640000000	23244	11547	3	0	\N
178227	1593	12226639000000	23244	11547	4	0	\N
178228	1593	9312638000000	23244	11547	5	0	\N
178229	1397	1300536188000	23245	11600	0	0	\N
178230	1397	1300526187000	23245	11600	1	0	\N
178231	2134	86306211000	23245	11600	2	0	\N
178232	2134	86305208000	23245	11600	3	0	\N
178237	1397	1300536188000	23247	11600	0	0	\N
178238	1397	1300526187000	23247	11600	1	0	\N
178239	2134	86306211000	23247	11600	2	0	\N
178240	2134	86305208000	23247	11600	3	0	\N
178241	1397	1300516186000	23248	11601	0	0	\N
178242	2134	86304205000	23248	11601	1	0	\N
178245	394	66001818809135	23250	11480	0	0	\N
178246	394	66001718809135	23250	11480	1	0	\N
178247	1593	20972641000000	23250	11480	2	0	\N
178248	647	66000099000000	23250	11480	3	0	\N
178249	1593	15750640000000	23250	11480	4	0	\N
178250	1593	12226639000000	23250	11480	5	0	\N
178251	1593	9312638000000	23250	11480	6	0	\N
178252	1397	1300516186000	23251	11601	0	0	\N
178253	2134	86304205000	23251	11601	1	0	\N
178254	1397	1300516186000	23252	11601	0	0	\N
178255	2134	86304205000	23252	11601	1	0	\N
178258	1397	1300506185000	23254	11602	0	0	\N
178259	2134	86303202000	23254	11602	1	0	\N
178260	1397	1300506185000	23255	11602	0	0	\N
178261	2134	86303202000	23255	11602	1	0	\N
178268	1397	1300476182000	23259	11605	0	0	\N
178269	2134	86300193000	23259	11605	1	0	\N
178270	1397	1300476182000	23260	11605	0	0	\N
178271	2134	86300193000	23260	11605	1	0	\N
178279	1397	1300446179000	23264	11608	0	0	\N
178280	112	66000012832720	23264	11608	1	0	\N
178281	2134	86297184000	23264	11608	2	0	\N
178284	1397	1300436178000	23266	11609	0	0	\N
178285	2134	86296181000	23266	11609	1	0	\N
178286	1397	1300436178000	23267	11609	0	0	\N
178287	2134	86296181000	23267	11609	1	0	\N
178288	1397	1300436178000	23268	11609	0	0	\N
178289	2134	86296181000	23268	11609	1	0	\N
178290	1397	1300426177000	23269	11610	0	0	\N
178291	2134	86295178000	23269	11610	1	0	\N
178294	112	66000012832720	23271	11581	0	0	\N
178295	1397	1300416176000	23272	11611	0	0	\N
178296	1397	1300406175000	23272	11611	1	0	\N
178202	1397	1300596194000	23233	11593	0	0	13823
178203	2134	86313232000	23233	11593	1	0	4264
178204	2134	86312229000	23234	11594	0	0	4265
178207	1397	1300586193000	23236	11595	0	0	13824
178208	2134	86311226000	23236	11595	1	0	4266
178210	2134	86310223000	23237	11596	1	0	4267
178213	1397	1300566191000	23239	11597	0	0	13826
178214	2134	86309220000	23239	11597	1	0	4268
178219	1397	1300556190000	23242	11598	0	0	13827
178220	2134	86308217000	23242	11598	1	0	4269
178222	2134	86307214000	23243	11599	1	0	4270
178233	1397	1300536188000	23246	11600	0	0	13829
178234	1397	1300526187000	23246	11600	1	0	13830
178235	2134	86306211000	23246	11600	2	0	4271
178243	1397	1300516186000	23249	11601	0	0	13831
178244	2134	86304205000	23249	11601	1	0	4273
178256	1397	1300506185000	23253	11602	0	0	13832
178257	2134	86303202000	23253	11602	1	0	4274
178262	1397	1300496184000	23256	11603	0	0	13833
178264	1397	1300486183000	23257	11604	0	0	13834
178265	2134	86301196000	23257	11604	1	0	4276
178266	1397	1300476182000	23258	11605	0	0	13835
178267	2134	86300193000	23258	11605	1	0	4277
178272	1397	1300466181000	23261	11606	0	0	13836
178274	1397	1300456180000	23262	11607	0	0	13837
178275	2134	86298187000	23262	11607	1	0	4279
178276	1397	1300446179000	23263	11608	0	0	13838
178277	112	66000012832720	23263	11608	1	0	8
178282	1397	1300436178000	23265	11609	0	0	13839
178283	2134	86296181000	23265	11609	1	0	4281
178292	1397	1300426177000	23270	11610	0	0	13840
178293	2134	86295178000	23270	11610	1	0	4282
178297	1397	1300396174000	23272	11611	2	0	\N
178298	2134	86294175000	23272	11611	3	0	\N
178299	2134	86293172000	23272	11611	4	0	\N
178300	2134	86292169000	23272	11611	5	0	\N
178307	1397	1300386173000	23274	11612	0	0	\N
178308	2134	86291166000	23274	11612	1	0	\N
178309	1397	1300386173000	23275	11612	0	0	\N
178310	2134	86291166000	23275	11612	1	0	\N
178318	1397	1300346169000	23279	11615	0	0	\N
178319	2134	86288157000	23279	11615	1	0	\N
178322	1397	1300336168000	23281	11616	0	0	\N
178323	2134	86287154000	23281	11616	1	0	\N
178328	1397	1300676202000	23284	11517	0	0	\N
178329	1397	1300666201000	23284	11517	1	0	\N
178330	1397	1300656200000	23284	11517	2	0	\N
178331	1397	1300646199000	23284	11517	3	0	\N
178332	394	66001818809135	23284	11517	4	0	\N
178333	394	66001718809135	23284	11517	5	0	\N
178334	1397	1300636198000	23284	11517	6	0	\N
178335	1397	1300626197000	23284	11517	7	0	\N
178336	1397	1300616196000	23284	11517	8	0	\N
178337	1397	1300606195000	23284	11517	9	0	\N
178338	1397	1300596194000	23284	11517	10	0	\N
178339	1397	1300586193000	23284	11517	11	0	\N
178340	1397	1300576192000	23284	11517	12	0	\N
178341	1397	1300566191000	23284	11517	13	0	\N
178342	1397	1300556190000	23284	11517	14	0	\N
178343	1397	1300546189000	23284	11517	15	0	\N
178344	1397	1300536188000	23284	11517	16	0	\N
178345	1397	1300526187000	23284	11517	17	0	\N
178346	1397	1300516186000	23284	11517	18	0	\N
178347	1397	1300506185000	23284	11517	19	0	\N
178348	1397	1300496184000	23284	11517	20	0	\N
178349	1397	1300486183000	23284	11517	21	0	\N
178350	1397	1300476182000	23284	11517	22	0	\N
178351	1397	1300466181000	23284	11517	23	0	\N
178352	1397	1300456180000	23284	11517	24	0	\N
178353	1397	1300446179000	23284	11517	25	0	\N
178354	1397	1300436178000	23284	11517	26	0	\N
178355	1397	1300426177000	23284	11517	27	0	\N
178356	1397	1300416176000	23284	11517	28	0	\N
178357	1397	1300406175000	23284	11517	29	0	\N
178358	1397	1300396174000	23284	11517	30	0	\N
178359	1397	1300386173000	23284	11517	31	0	\N
178360	1397	1300376172000	23284	11517	32	0	\N
178361	1397	1300366171000	23284	11517	33	0	\N
178362	1397	1300356170000	23284	11517	34	0	\N
178363	1397	1300346169000	23284	11517	35	0	\N
178364	1397	1300336168000	23284	11517	36	0	\N
178365	1397	1300326167000	23284	11517	37	0	\N
178366	112	66000012832720	23284	11517	38	0	\N
178367	2132	147789791000	23284	11517	39	0	\N
178368	2134	86380433000	23284	11517	40	0	\N
178369	2134	86379430000	23284	11517	41	0	\N
178370	2132	147788790000	23284	11517	42	0	\N
178371	2132	147787789000	23284	11517	43	0	\N
178372	2132	147786788000	23284	11517	44	0	\N
178373	2132	147785787000	23284	11517	45	0	\N
178374	2132	147784786000	23284	11517	46	0	\N
178375	2132	147783785000	23284	11517	47	0	\N
178376	2132	147782784000	23284	11517	48	0	\N
178377	2132	147781783000	23284	11517	49	0	\N
178378	2132	147780782000	23284	11517	51	0	\N
178379	2132	147779781000	23284	11517	52	0	\N
178380	2132	147778780000	23284	11517	53	0	\N
178381	2132	147777779000	23284	11517	54	0	\N
178382	2133	93626690000	23284	11517	55	0	\N
178383	2133	93625688000	23284	11517	56	0	\N
178384	2133	93624686000	23284	11517	57	0	\N
178385	2133	93623684000	23284	11517	58	0	\N
178386	2133	93622682000	23284	11517	59	0	\N
178387	2133	93621680000	23284	11517	60	0	\N
178388	2133	93620678000	23284	11517	61	0	\N
178389	2133	93619676000	23284	11517	62	0	\N
178390	2133	93618674000	23284	11517	63	0	\N
178391	2133	93617672000	23284	11517	64	0	\N
178392	2133	93616670000	23284	11517	65	0	\N
178393	2133	93615668000	23284	11517	66	0	\N
178394	2133	93614666000	23284	11517	67	0	\N
178395	2133	93613664000	23284	11517	68	0	\N
178396	2133	93612662000	23284	11517	69	0	\N
178397	2133	93611660000	23284	11517	70	0	\N
178398	2133	93610658000	23284	11517	71	0	\N
178399	2133	93609656000	23284	11517	72	0	\N
178400	2133	93608654000	23284	11517	73	0	\N
178401	2133	93607652000	23284	11517	74	0	\N
178402	2133	93606650000	23284	11517	75	0	\N
178403	2133	93605648000	23284	11517	76	0	\N
178404	2133	93604646000	23284	11517	77	0	\N
178405	2133	93603644000	23284	11517	78	0	\N
178406	2133	93602642000	23284	11517	79	0	\N
178407	2133	93601640000	23284	11517	80	0	\N
178408	2133	93600638000	23284	11517	81	0	\N
178409	2133	93599636000	23284	11517	82	0	\N
178410	2133	93598634000	23284	11517	83	0	\N
178411	2133	93597632000	23284	11517	84	0	\N
178412	2134	86378427000	23284	11517	85	0	\N
178413	2134	86377424000	23284	11517	86	0	\N
178414	2134	86376421000	23284	11517	87	0	\N
178415	2134	86375418000	23284	11517	88	0	\N
178416	2134	86374415000	23284	11517	89	0	\N
178417	2134	86373412000	23284	11517	90	0	\N
178418	2134	86372409000	23284	11517	91	0	\N
178419	2134	86371406000	23284	11517	92	0	\N
178420	2134	86370403000	23284	11517	93	0	\N
178421	2134	86369400000	23284	11517	94	0	\N
178422	2134	86368397000	23284	11517	95	0	\N
178423	2134	86367394000	23284	11517	96	0	\N
178424	2134	86366391000	23284	11517	97	0	\N
178425	2134	86365388000	23284	11517	98	0	\N
178426	2134	86364385000	23284	11517	99	0	\N
178427	2134	86363382000	23284	11517	100	0	\N
178428	2134	86362379000	23284	11517	101	0	\N
178429	2134	86361376000	23284	11517	102	0	\N
178430	2134	86360373000	23284	11517	103	0	\N
178431	2134	86359370000	23284	11517	104	0	\N
178432	2134	86358367000	23284	11517	105	0	\N
178303	1397	1300396174000	23273	11611	2	0	13843
178304	2134	86294175000	23273	11611	3	0	4283
178305	2134	86293172000	23273	11611	4	0	4284
178306	2134	86292169000	23273	11611	5	0	4285
178311	1397	1300386173000	23276	11612	0	0	13844
178313	1397	1300376172000	23277	11613	0	0	13845
178314	1397	1300366171000	23277	11613	1	0	13846
178315	2134	86290163000	23277	11613	2	0	4287
178316	2134	86289160000	23277	11613	3	0	4288
178317	1397	1300356170000	23278	11614	0	0	13847
178321	2134	86288157000	23280	11615	1	0	4289
178324	1397	1300336168000	23282	11616	0	0	13849
178325	2134	86287154000	23282	11616	1	0	4290
178326	1397	1300326167000	23283	11617	0	0	13850
178433	2134	86357364000	23284	11517	106	0	\N
178434	2134	86356361000	23284	11517	107	0	\N
178435	2134	86355358000	23284	11517	108	0	\N
178436	2134	86354355000	23284	11517	109	0	\N
178437	2134	86353352000	23284	11517	110	0	\N
178444	1397	1300316166000	23286	11618	0	0	\N
178445	1397	1300306165000	23286	11618	1	0	\N
178446	1397	1300296164000	23286	11618	2	0	\N
178447	2134	86285148000	23286	11618	3	0	\N
178448	2134	86284145000	23286	11618	4	0	\N
178449	2134	86283142000	23286	11618	5	0	\N
178452	1397	1300276162000	23288	11620	0	0	\N
178453	2134	86281136000	23288	11620	1	0	\N
178456	1397	1301016236000	23290	11485	0	0	\N
178457	394	66001818809135	23290	11485	1	0	\N
178458	394	66001718809135	23290	11485	2	0	\N
178459	1397	1301006235000	23290	11485	3	0	\N
178460	1397	1300996234000	23290	11485	4	0	\N
178461	1397	1300986233000	23290	11485	5	0	\N
178462	1397	1300976232000	23290	11485	6	0	\N
178463	1397	1300966231000	23290	11485	7	0	\N
178464	1397	1300956230000	23290	11485	8	0	\N
178465	1397	1300946229000	23290	11485	9	0	\N
178466	1397	1300936228000	23290	11485	10	0	\N
178467	1397	1300926227000	23290	11485	11	0	\N
178468	1397	1300916226000	23290	11485	12	0	\N
178469	1397	1300906225000	23290	11485	13	0	\N
178470	1397	1300896224000	23290	11485	14	0	\N
178471	1397	1300886223000	23290	11485	15	0	\N
178472	1397	1300876222000	23290	11485	16	0	\N
178473	1397	1300866221000	23290	11485	17	0	\N
178474	1397	1300856220000	23290	11485	18	0	\N
178475	1397	1300846219000	23290	11485	19	0	\N
178476	1397	1300836218000	23290	11485	20	0	\N
178477	1397	1300826217000	23290	11485	21	0	\N
178478	1397	1300816216000	23290	11485	22	0	\N
178479	1397	1300806215000	23290	11485	23	0	\N
178480	1397	1300796214000	23290	11485	24	0	\N
178481	1397	1300786213000	23290	11485	25	0	\N
178482	1397	1300776212000	23290	11485	26	0	\N
178483	1397	1300766211000	23290	11485	27	0	\N
178484	1397	1300756210000	23290	11485	28	0	\N
178485	1397	1300746209000	23290	11485	29	0	\N
178486	1397	1300736208000	23290	11485	30	0	\N
178487	1397	1300726207000	23290	11485	31	0	\N
178488	1397	1300716206000	23290	11485	32	0	\N
178489	1397	1300706205000	23290	11485	33	0	\N
178490	1397	1300696204000	23290	11485	34	0	\N
178491	1397	1300686203000	23290	11485	35	0	\N
178492	1397	1300676202000	23290	11485	36	0	\N
178493	1397	1300666201000	23290	11485	37	0	\N
178494	1397	1300656200000	23290	11485	38	0	\N
178495	1397	1300646199000	23290	11485	39	0	\N
178496	1397	1300636198000	23290	11485	40	0	\N
178497	1397	1300626197000	23290	11485	41	0	\N
178498	1397	1300616196000	23290	11485	42	0	\N
178499	1397	1300606195000	23290	11485	43	0	\N
178500	1397	1300596194000	23290	11485	44	0	\N
178501	1397	1300586193000	23290	11485	45	0	\N
178502	1397	1300576192000	23290	11485	46	0	\N
178503	1397	1300566191000	23290	11485	47	0	\N
178504	1397	1300556190000	23290	11485	48	0	\N
178505	1397	1300546189000	23290	11485	49	0	\N
178506	1397	1300536188000	23290	11485	50	0	\N
178507	1397	1300526187000	23290	11485	51	0	\N
178508	1397	1300516186000	23290	11485	52	0	\N
178509	1397	1300506185000	23290	11485	53	0	\N
178510	1397	1300496184000	23290	11485	54	0	\N
178511	1397	1300486183000	23290	11485	55	0	\N
178512	1397	1300476182000	23290	11485	56	0	\N
178513	1397	1300466181000	23290	11485	57	0	\N
178514	1397	1300456180000	23290	11485	58	0	\N
178515	1397	1300446179000	23290	11485	59	0	\N
178516	1397	1300436178000	23290	11485	60	0	\N
178517	1397	1300426177000	23290	11485	61	0	\N
178518	1397	1300416176000	23290	11485	62	0	\N
178519	1397	1300406175000	23290	11485	63	0	\N
178520	1397	1300396174000	23290	11485	64	0	\N
178521	1397	1300386173000	23290	11485	65	0	\N
178522	1397	1300376172000	23290	11485	66	0	\N
178523	1397	1300366171000	23290	11485	67	0	\N
178524	1397	1300356170000	23290	11485	68	0	\N
178525	1397	1300346169000	23290	11485	69	0	\N
178526	1397	1300336168000	23290	11485	70	0	\N
178527	1397	1300326167000	23290	11485	71	0	\N
178528	1397	1300316166000	23290	11485	72	0	\N
178529	1397	1300306165000	23290	11485	73	0	\N
178530	1397	1300296164000	23290	11485	74	0	\N
178531	1397	1300286163000	23290	11485	75	0	\N
178532	1397	1300276162000	23290	11485	76	0	\N
178533	112	66000012832720	23290	11485	77	0	\N
178534	2134	86465688000	23290	11485	78	0	\N
178535	2134	86464685000	23290	11485	79	0	\N
178536	2134	86463682000	23290	11485	80	0	\N
178537	2134	86462679000	23290	11485	82	0	\N
178538	2134	86461676000	23290	11485	83	0	\N
178539	2134	86460673000	23290	11485	84	0	\N
178540	2134	86459670000	23290	11485	85	0	\N
178541	2134	86458667000	23290	11485	86	0	\N
178542	2134	86457664000	23290	11485	87	0	\N
178543	2134	86456661000	23290	11485	88	0	\N
178544	2134	86455658000	23290	11485	89	0	\N
178545	2134	86454655000	23290	11485	90	0	\N
178546	2134	86453652000	23290	11485	91	0	\N
178547	2134	86452649000	23290	11485	92	0	\N
178548	2134	86451646000	23290	11485	93	0	\N
178549	2134	86450643000	23290	11485	94	0	\N
178550	2134	86449640000	23290	11485	95	0	\N
178551	2134	86448637000	23290	11485	96	0	\N
178552	2134	86447634000	23290	11485	97	0	\N
178553	2134	86446631000	23290	11485	98	0	\N
178554	2134	86445628000	23290	11485	99	0	\N
178555	2134	86444625000	23290	11485	100	0	\N
178556	2134	86443622000	23290	11485	101	0	\N
178557	2134	86442619000	23290	11485	102	0	\N
178558	2134	86441616000	23290	11485	103	0	\N
178559	2134	86440613000	23290	11485	104	0	\N
178560	2134	86439610000	23290	11485	105	0	\N
178561	2134	86438607000	23290	11485	106	0	\N
178562	2134	86437604000	23290	11485	107	0	\N
178563	2134	86436601000	23290	11485	108	0	\N
178564	2134	86435598000	23290	11485	109	0	\N
178565	2134	86434595000	23290	11485	110	0	\N
178566	2134	86433592000	23290	11485	111	0	\N
178567	2134	86432589000	23290	11485	112	0	\N
178568	2134	86431586000	23290	11485	113	0	\N
178440	1397	1300296164000	23285	11618	2	0	13853
178441	2134	86285148000	23285	11618	3	0	4292
178442	2134	86284145000	23285	11618	4	0	4293
178443	2134	86283142000	23285	11618	5	0	4294
178450	1397	1300286163000	23287	11619	0	0	13854
178454	1397	1300276162000	23289	11620	0	0	13855
178455	2134	86281136000	23289	11620	1	0	4296
178569	2134	86430583000	23290	11485	114	0	\N
178570	2134	86429580000	23290	11485	115	0	\N
178571	2134	86428577000	23290	11485	116	0	\N
178572	2134	86427574000	23290	11485	117	0	\N
178573	2134	86426571000	23290	11485	118	0	\N
178574	2134	86425568000	23290	11485	119	0	\N
178575	2134	86424565000	23290	11485	120	0	\N
178576	2134	86423562000	23290	11485	121	0	\N
178577	2134	86422559000	23290	11485	122	0	\N
178578	2134	86421556000	23290	11485	123	0	\N
178579	2134	86420553000	23290	11485	124	0	\N
178580	2134	86419550000	23290	11485	125	0	\N
178587	1397	1300236158000	23293	11623	0	0	\N
178588	1397	1300226157000	23293	11623	1	0	\N
178589	2134	86277124000	23293	11623	2	0	\N
178590	2134	86276121000	23293	11623	3	0	\N
178591	1397	1300236158000	23294	11623	0	0	\N
178592	1397	1300226157000	23294	11623	1	0	\N
178593	2134	86277124000	23294	11623	2	0	\N
178594	2134	86276121000	23294	11623	3	0	\N
178599	1397	1300216156000	23296	11624	0	0	\N
178600	2134	86275118000	23296	11624	1	0	\N
178613	1397	1301966331000	23302	11406	0	0	\N
178614	394	66001818809135	23302	11406	1	0	\N
178615	394	66001718809135	23302	11406	2	0	\N
178616	1397	1301956330000	23302	11406	3	0	\N
178617	1397	1301946329000	23302	11406	4	0	\N
178618	1397	1301936328000	23302	11406	5	0	\N
178619	1397	1301926327000	23302	11406	6	0	\N
178620	1397	1301916326000	23302	11406	7	0	\N
178621	1397	1301906325000	23302	11406	8	0	\N
178622	1397	1301896324000	23302	11406	9	0	\N
178623	1397	1301886323000	23302	11406	10	0	\N
178624	1397	1301876322000	23302	11406	11	0	\N
178625	1397	1301866321000	23302	11406	12	0	\N
178626	1397	1301856320000	23302	11406	13	0	\N
178627	1397	1301846319000	23302	11406	14	0	\N
178628	1397	1301836318000	23302	11406	15	0	\N
178629	1397	1301826317000	23302	11406	16	0	\N
178630	1397	1301816316000	23302	11406	17	0	\N
178631	1397	1301806315000	23302	11406	18	0	\N
178632	1397	1301796314000	23302	11406	19	0	\N
178633	1397	1301786313000	23302	11406	20	0	\N
178634	1397	1301776312000	23302	11406	21	0	\N
178635	1397	1301766311000	23302	11406	22	0	\N
178636	1397	1301756310000	23302	11406	23	0	\N
178637	1397	1301746309000	23302	11406	24	0	\N
178638	1397	1301736308000	23302	11406	25	0	\N
178639	1397	1301726307000	23302	11406	26	0	\N
178640	1397	1301716306000	23302	11406	27	0	\N
178641	1397	1301706305000	23302	11406	28	0	\N
178642	1397	1301696304000	23302	11406	29	0	\N
178643	1397	1301686303000	23302	11406	30	0	\N
178644	1397	1301676302000	23302	11406	31	0	\N
178645	1397	1301666301000	23302	11406	32	0	\N
178646	1397	1301656300000	23302	11406	33	0	\N
178647	1397	1301646299000	23302	11406	34	0	\N
178648	1397	1301636298000	23302	11406	35	0	\N
178649	1397	1301626297000	23302	11406	36	0	\N
178650	1397	1301616296000	23302	11406	37	0	\N
178651	1397	1301606295000	23302	11406	38	0	\N
178652	1397	1301596294000	23302	11406	39	0	\N
178653	1397	1301586293000	23302	11406	40	0	\N
178654	1397	1301576292000	23302	11406	41	0	\N
178655	1397	1301566291000	23302	11406	42	0	\N
178656	1397	1301556290000	23302	11406	43	0	\N
178657	1397	1301546289000	23302	11406	44	0	\N
178658	1397	1301536288000	23302	11406	45	0	\N
178659	1397	1301526287000	23302	11406	46	0	\N
178660	1397	1301516286000	23302	11406	47	0	\N
178661	1397	1301506285000	23302	11406	48	0	\N
178662	1397	1301496284000	23302	11406	49	0	\N
178663	1397	1301486283000	23302	11406	50	0	\N
178664	1397	1301476282000	23302	11406	51	0	\N
178665	1397	1301466281000	23302	11406	52	0	\N
178666	1397	1301456280000	23302	11406	53	0	\N
178667	1397	1301446279000	23302	11406	54	0	\N
178668	1397	1301436278000	23302	11406	55	0	\N
178669	1397	1301426277000	23302	11406	56	0	\N
178670	1397	1301416276000	23302	11406	57	0	\N
178671	1397	1301406275000	23302	11406	58	0	\N
178672	1397	1301396274000	23302	11406	59	0	\N
178673	1397	1301386273000	23302	11406	60	0	\N
178674	1397	1301376272000	23302	11406	61	0	\N
178675	1397	1301366271000	23302	11406	62	0	\N
178676	1397	1301356270000	23302	11406	63	0	\N
178677	1397	1301346269000	23302	11406	64	0	\N
178678	1397	1301336268000	23302	11406	65	0	\N
178679	1397	1301326267000	23302	11406	66	0	\N
178680	1397	1301316266000	23302	11406	67	0	\N
178681	1397	1301306265000	23302	11406	68	0	\N
178682	1397	1301296264000	23302	11406	69	0	\N
178683	1397	1301286263000	23302	11406	70	0	\N
178684	1397	1301276262000	23302	11406	71	0	\N
178685	1397	1301266261000	23302	11406	72	0	\N
178686	1397	1301256260000	23302	11406	73	0	\N
178687	1397	1301246259000	23302	11406	74	0	\N
178688	1397	1301236258000	23302	11406	75	0	\N
178689	1397	1301226257000	23302	11406	76	0	\N
178690	1397	1301216256000	23302	11406	77	0	\N
178691	1397	1301206255000	23302	11406	78	0	\N
178692	1397	1301196254000	23302	11406	79	0	\N
178693	1397	1301186253000	23302	11406	80	0	\N
178694	1397	1301176252000	23302	11406	81	0	\N
178695	1397	1301166251000	23302	11406	82	0	\N
178696	1397	1301156250000	23302	11406	83	0	\N
178697	1397	1301146249000	23302	11406	84	0	\N
178698	1397	1301136248000	23302	11406	85	0	\N
178699	1397	1301126247000	23302	11406	86	0	\N
178700	1397	1301116246000	23302	11406	87	0	\N
178701	1397	1301106245000	23302	11406	89	0	\N
178702	1397	1301096244000	23302	11406	90	0	\N
178703	1397	1301086243000	23302	11406	91	0	\N
178704	1397	1301076242000	23302	11406	92	0	\N
178583	2134	86280133000	23291	11621	2	0	4297
178584	2134	86279130000	23291	11621	3	0	4298
178585	1397	1300246159000	23292	11622	0	0	13858
178586	2134	86278127000	23292	11622	1	0	4299
178595	1397	1300236158000	23295	11623	0	0	13859
178597	2134	86277124000	23295	11623	2	0	4300
178598	2134	86276121000	23295	11623	3	0	4301
178601	1397	1300216156000	23297	11624	0	0	13861
178602	2134	86275118000	23297	11624	1	0	4302
178603	1397	1300206155000	23298	11625	0	0	13862
178605	2134	86274115000	23298	11625	2	0	4303
178606	2134	86273112000	23298	11625	3	0	4304
178607	1397	1300186153000	23299	11626	0	0	13864
178608	2134	86272109000	23299	11626	1	0	4305
178610	2134	86271106000	23300	11627	1	0	4306
178611	1397	1300166151000	23301	11628	0	0	13866
178612	2134	86270103000	23301	11628	1	0	4307
178705	1397	1301066241000	23302	11406	93	0	\N
178706	1397	1301056240000	23302	11406	94	0	\N
178707	1397	1301046239000	23302	11406	95	0	\N
178708	1397	1301036238000	23302	11406	96	0	\N
178709	1397	1301026237000	23302	11406	97	0	\N
178710	1397	1301016236000	23302	11406	98	0	\N
178711	1397	1301006235000	23302	11406	99	0	\N
178712	1397	1300996234000	23302	11406	100	0	\N
178713	1397	1300986233000	23302	11406	101	0	\N
178714	1397	1300976232000	23302	11406	102	0	\N
178715	1397	1300966231000	23302	11406	103	0	\N
178716	1397	1300956230000	23302	11406	104	0	\N
178717	1397	1300946229000	23302	11406	105	0	\N
178718	1397	1300936228000	23302	11406	106	0	\N
178719	1397	1300926227000	23302	11406	107	0	\N
178720	1397	1300916226000	23302	11406	108	0	\N
178721	1397	1300906225000	23302	11406	109	0	\N
178722	1397	1300896224000	23302	11406	110	0	\N
178723	1397	1300886223000	23302	11406	111	0	\N
178724	1397	1300876222000	23302	11406	112	0	\N
178725	1397	1300866221000	23302	11406	113	0	\N
178726	1397	1300856220000	23302	11406	114	0	\N
178727	1397	1300846219000	23302	11406	115	0	\N
178728	1397	1300836218000	23302	11406	116	0	\N
178729	1397	1300826217000	23302	11406	117	0	\N
178730	1397	1300816216000	23302	11406	118	0	\N
178731	1397	1300806215000	23302	11406	119	0	\N
178732	1397	1300796214000	23302	11406	120	0	\N
178733	1397	1300786213000	23302	11406	121	0	\N
178734	1397	1300776212000	23302	11406	122	0	\N
178735	1397	1300766211000	23302	11406	123	0	\N
178736	1397	1300756210000	23302	11406	124	0	\N
178737	1397	1300746209000	23302	11406	125	0	\N
178738	1397	1300156150000	23303	11629	0	0	\N
178739	2134	86269100000	23303	11629	1	0	\N
178742	1397	1300156150000	23305	11629	0	0	\N
178743	2134	86269100000	23305	11629	1	0	\N
178744	1397	1300156150000	23306	11629	0	0	\N
178745	2134	86269100000	23306	11629	1	0	\N
178752	1397	1300116146000	23309	11632	0	0	\N
178753	2134	86265088000	23309	11632	1	0	\N
178757	394	66001718809135	23312	11569	0	0	\N
178758	1397	1300636198000	23312	11569	1	0	\N
178759	1397	1300626197000	23312	11569	2	0	\N
178760	1397	1300616196000	23312	11569	3	0	\N
178761	1397	1300606195000	23312	11569	4	0	\N
178762	1397	1300596194000	23312	11569	5	0	\N
178763	1397	1300586193000	23312	11569	6	0	\N
178764	1397	1300576192000	23312	11569	7	0	\N
178765	1397	1300566191000	23312	11569	8	0	\N
178766	1397	1300556190000	23312	11569	9	0	\N
178767	1397	1300546189000	23312	11569	10	0	\N
178768	1397	1300536188000	23312	11569	11	0	\N
178769	1397	1300526187000	23312	11569	12	0	\N
178770	1397	1300516186000	23312	11569	13	0	\N
178771	1397	1300506185000	23312	11569	14	0	\N
178772	1397	1300496184000	23312	11569	15	0	\N
178773	1397	1300486183000	23312	11569	16	0	\N
178774	1397	1300476182000	23312	11569	17	0	\N
178775	1397	1300466181000	23312	11569	18	0	\N
178776	1397	1300456180000	23312	11569	19	0	\N
178777	1397	1300446179000	23312	11569	20	0	\N
178778	1397	1300436178000	23312	11569	21	0	\N
178779	1397	1300426177000	23312	11569	22	0	\N
178780	1397	1300416176000	23312	11569	23	0	\N
178781	1397	1300406175000	23312	11569	24	0	\N
178782	1397	1300396174000	23312	11569	25	0	\N
178783	1397	1300386173000	23312	11569	26	0	\N
178784	1397	1300376172000	23312	11569	27	0	\N
178785	1397	1300366171000	23312	11569	28	0	\N
178786	1397	1300356170000	23312	11569	29	0	\N
178787	1397	1300346169000	23312	11569	30	0	\N
178788	1397	1300336168000	23312	11569	31	0	\N
178789	1397	1300326167000	23312	11569	32	0	\N
178790	1397	1300316166000	23312	11569	33	0	\N
178791	1397	1300306165000	23312	11569	34	0	\N
178792	1397	1300296164000	23312	11569	35	0	\N
178793	1397	1300286163000	23312	11569	36	0	\N
178794	1397	1300276162000	23312	11569	37	0	\N
178795	1397	1300266161000	23312	11569	38	0	\N
178796	1397	1300256160000	23312	11569	39	0	\N
178797	1397	1300246159000	23312	11569	40	0	\N
178798	1397	1300236158000	23312	11569	41	0	\N
178799	1397	1300226157000	23312	11569	42	0	\N
178800	1397	1300216156000	23312	11569	43	0	\N
178801	1397	1300206155000	23312	11569	44	0	\N
178802	1397	1300196154000	23312	11569	45	0	\N
178803	1397	1300186153000	23312	11569	46	0	\N
178804	1397	1300176152000	23312	11569	47	0	\N
178805	1397	1300166151000	23312	11569	48	0	\N
178806	1397	1300156150000	23312	11569	49	0	\N
178807	1397	1300146149000	23312	11569	50	0	\N
178808	1397	1300136148000	23312	11569	51	0	\N
178809	1397	1300126147000	23312	11569	52	0	\N
178810	1397	1300116146000	23312	11569	53	0	\N
178811	1397	1300106145000	23312	11569	54	0	\N
178812	2134	86316241000	23312	11569	55	0	\N
178813	2134	86315238000	23312	11569	56	0	\N
178814	2134	86314235000	23312	11569	57	0	\N
178815	112	66000012832720	23312	11569	58	0	\N
178816	2134	86313232000	23312	11569	59	0	\N
178817	2134	86312229000	23312	11569	60	0	\N
178818	2134	86311226000	23312	11569	61	0	\N
178819	2134	86310223000	23312	11569	62	0	\N
178820	2134	86309220000	23312	11569	63	0	\N
178821	2134	86308217000	23312	11569	64	0	\N
178822	2134	86307214000	23312	11569	65	0	\N
178823	2134	86306211000	23312	11569	66	0	\N
178824	2134	86305208000	23312	11569	67	0	\N
178825	2134	86304205000	23312	11569	68	0	\N
178826	2134	86303202000	23312	11569	69	0	\N
178827	2134	86302199000	23312	11569	70	0	\N
178828	2134	86301196000	23312	11569	71	0	\N
178829	2134	86300193000	23312	11569	72	0	\N
178830	2134	86299190000	23312	11569	73	0	\N
178831	2134	86298187000	23312	11569	74	0	\N
178832	2134	86297184000	23312	11569	75	0	\N
178833	2134	86296181000	23312	11569	76	0	\N
178834	2134	86295178000	23312	11569	77	0	\N
178835	2134	86294175000	23312	11569	78	0	\N
178836	2134	86293172000	23312	11569	79	0	\N
178837	2134	86292169000	23312	11569	80	0	\N
178838	2134	86291166000	23312	11569	81	0	\N
178839	2134	86290163000	23312	11569	82	0	\N
178840	2134	86289160000	23312	11569	83	0	\N
178746	1397	1300146149000	23307	11630	0	0	13868
178747	2134	86268097000	23307	11630	1	0	4309
178748	1397	1300136148000	23308	11631	0	0	13869
178749	1397	1300126147000	23308	11631	1	0	13870
178750	2134	86267094000	23308	11631	2	0	4310
178754	1397	1300116146000	23310	11632	0	0	13871
178755	2134	86265088000	23310	11632	1	0	4312
178756	1397	1300106145000	23311	11633	0	0	13872
178841	2134	86288157000	23312	11569	84	0	\N
178842	2134	86287154000	23312	11569	85	0	\N
178843	2134	86286151000	23312	11569	86	0	\N
178844	2134	86285148000	23312	11569	87	0	\N
178845	2134	86284145000	23312	11569	88	0	\N
178846	2134	86283142000	23312	11569	89	0	\N
178847	2134	86282139000	23312	11569	91	0	\N
178848	2134	86281136000	23312	11569	92	0	\N
178849	2134	86280133000	23312	11569	93	0	\N
178850	2134	86279130000	23312	11569	94	0	\N
178851	2134	86278127000	23312	11569	95	0	\N
178852	2134	86277124000	23312	11569	96	0	\N
178853	2134	86276121000	23312	11569	97	0	\N
178854	2134	86275118000	23312	11569	98	0	\N
178855	2134	86274115000	23312	11569	99	0	\N
178856	2134	86273112000	23312	11569	100	0	\N
178857	2134	86272109000	23312	11569	101	0	\N
178858	2134	86271106000	23312	11569	102	0	\N
178859	2134	86270103000	23312	11569	103	0	\N
178860	2134	86269100000	23312	11569	104	0	\N
178861	2134	86268097000	23312	11569	105	0	\N
178862	2134	86267094000	23312	11569	106	0	\N
178863	2134	86266091000	23312	11569	107	0	\N
178864	2134	86265088000	23312	11569	108	0	\N
178865	2134	86264085000	23312	11569	109	0	\N
178871	1397	1300076142000	23315	11635	0	0	\N
178872	1397	1300066141000	23315	11635	1	0	\N
178873	2134	86261076000	23315	11635	2	0	\N
178874	2134	86260073000	23315	11635	3	0	\N
178879	1397	1300076142000	23317	11635	0	0	\N
178880	1397	1300066141000	23317	11635	1	0	\N
178881	2134	86261076000	23317	11635	2	0	\N
178882	2134	86260073000	23317	11635	3	0	\N
178891	1397	1300016136000	23321	11639	0	0	\N
178892	2134	86255058000	23321	11639	1	0	\N
178897	112	66000012832720	23324	11548	0	0	\N
178898	1397	1300006135000	23325	11640	0	0	\N
178899	2134	86254055000	23325	11640	1	0	\N
178900	1397	1299996134000	23326	11641	0	0	\N
178901	1397	1299986133000	23326	11641	1	0	\N
178902	2134	86253052000	23326	11641	2	0	\N
178903	2134	86252049000	23326	11641	3	0	\N
178908	1397	1299976132000	23330	11642	0	0	\N
178909	2134	86251046000	23330	11642	1	0	\N
178912	1397	1301596294000	23332	11521	0	0	\N
178913	1397	1301586293000	23332	11521	1	0	\N
178914	394	66001818809135	23332	11521	2	0	\N
178915	394	66001718809135	23332	11521	3	0	\N
178916	1397	1301576292000	23332	11521	4	0	\N
178917	1397	1301566291000	23332	11521	5	0	\N
178918	1397	1301556290000	23332	11521	6	0	\N
178919	1397	1301546289000	23332	11521	7	0	\N
178920	1397	1301536288000	23332	11521	8	0	\N
178921	1397	1301526287000	23332	11521	9	0	\N
178922	1397	1301516286000	23332	11521	10	0	\N
178923	1397	1301506285000	23332	11521	11	0	\N
178924	1397	1301496284000	23332	11521	12	0	\N
178925	1397	1301486283000	23332	11521	13	0	\N
178926	1397	1301476282000	23332	11521	14	0	\N
178927	1397	1301466281000	23332	11521	15	0	\N
178928	1397	1301456280000	23332	11521	16	0	\N
178929	1397	1301446279000	23332	11521	17	0	\N
178930	1397	1301436278000	23332	11521	18	0	\N
178931	1397	1301426277000	23332	11521	19	0	\N
178932	1397	1301416276000	23332	11521	20	0	\N
178933	1397	1301406275000	23332	11521	21	0	\N
178934	1397	1301396274000	23332	11521	22	0	\N
178935	1397	1301386273000	23332	11521	23	0	\N
178936	1397	1301376272000	23332	11521	24	0	\N
178937	1397	1301366271000	23332	11521	25	0	\N
178938	1397	1301356270000	23332	11521	26	0	\N
178939	1397	1301346269000	23332	11521	27	0	\N
178940	1397	1301336268000	23332	11521	28	0	\N
178941	1397	1301326267000	23332	11521	29	0	\N
178942	1397	1301316266000	23332	11521	30	0	\N
178943	1397	1301306265000	23332	11521	31	0	\N
178944	1397	1301296264000	23332	11521	32	0	\N
178945	1397	1301286263000	23332	11521	33	0	\N
178946	1397	1301276262000	23332	11521	34	0	\N
178947	1397	1301266261000	23332	11521	35	0	\N
178948	1397	1301256260000	23332	11521	36	0	\N
178949	1397	1301246259000	23332	11521	37	0	\N
178950	1397	1301236258000	23332	11521	38	0	\N
178951	1397	1301226257000	23332	11521	39	0	\N
178952	1397	1301216256000	23332	11521	40	0	\N
178953	1397	1301206255000	23332	11521	41	0	\N
178954	1397	1301196254000	23332	11521	42	0	\N
178955	1397	1301186253000	23332	11521	43	0	\N
178956	1397	1301176252000	23332	11521	44	0	\N
178957	1397	1301166251000	23332	11521	45	0	\N
178958	1397	1301156250000	23332	11521	46	0	\N
178959	1397	1301146249000	23332	11521	47	0	\N
178960	1397	1301136248000	23332	11521	48	0	\N
178961	1397	1301126247000	23332	11521	49	0	\N
178962	1397	1301116246000	23332	11521	50	0	\N
178963	1397	1301106245000	23332	11521	51	0	\N
178964	1397	1301096244000	23332	11521	52	0	\N
178965	1397	1301086243000	23332	11521	53	0	\N
178966	1397	1301076242000	23332	11521	54	0	\N
178967	1397	1301066241000	23332	11521	55	0	\N
178968	1397	1301056240000	23332	11521	56	0	\N
178969	1397	1301046239000	23332	11521	57	0	\N
178970	1397	1301036238000	23332	11521	58	0	\N
178971	1397	1301026237000	23332	11521	59	0	\N
178972	1397	1301016236000	23332	11521	60	0	\N
178973	1397	1301006235000	23332	11521	61	0	\N
178974	1397	1300996234000	23332	11521	62	0	\N
178975	1397	1300986233000	23332	11521	63	0	\N
178976	1397	1300976232000	23332	11521	64	0	\N
178868	2134	86264085000	23313	11634	2	0	4313
178869	2134	86263082000	23313	11634	3	0	4314
178870	2134	86262079000	23313	11634	4	0	4315
178875	1397	1300076142000	23316	11635	0	0	13875
178876	1397	1300066141000	23316	11635	1	0	13876
178878	2134	86260073000	23316	11635	3	0	4317
178883	1397	1300056140000	23318	11636	0	0	13877
178884	1397	1300046139000	23318	11636	1	0	13878
178885	2134	86259070000	23318	11636	2	0	4318
178886	2134	86258067000	23318	11636	3	0	4319
178888	2134	86257064000	23319	11637	1	0	4320
178889	1397	1300026137000	23320	11638	0	0	13880
178890	2134	86256061000	23320	11638	1	0	4321
178893	1397	1300016136000	23322	11639	0	0	13881
178895	1397	1300006135000	23323	11640	0	0	13882
178896	2134	86254055000	23323	11640	1	0	4323
178904	1397	1299996134000	23329	11641	0	0	13883
178905	1397	1299986133000	23329	11641	1	0	13884
178906	2134	86253052000	23329	11641	2	0	4324
178910	1397	1299976132000	23331	11642	0	0	13885
178911	2134	86251046000	23331	11642	1	0	4326
178977	1397	1300966231000	23332	11521	65	0	\N
178978	1397	1300956230000	23332	11521	66	0	\N
178979	1397	1300946229000	23332	11521	67	0	\N
178980	1397	1300936228000	23332	11521	68	0	\N
178981	1397	1300926227000	23332	11521	69	0	\N
178982	1397	1300916226000	23332	11521	70	0	\N
178983	1397	1300906225000	23332	11521	71	0	\N
178984	1397	1300896224000	23332	11521	72	0	\N
178985	1397	1300886223000	23332	11521	73	0	\N
178986	1397	1300876222000	23332	11521	74	0	\N
178987	1397	1300866221000	23332	11521	75	0	\N
178988	1397	1300856220000	23332	11521	76	0	\N
178989	1397	1300846219000	23332	11521	77	0	\N
178990	1397	1300836218000	23332	11521	78	0	\N
178991	1397	1300826217000	23332	11521	79	0	\N
178992	1397	1300816216000	23332	11521	80	0	\N
178993	1397	1300806215000	23332	11521	81	0	\N
178994	1397	1300796214000	23332	11521	82	0	\N
178995	1397	1300786213000	23332	11521	83	0	\N
178996	1397	1300776212000	23332	11521	84	0	\N
178997	1397	1300766211000	23332	11521	85	0	\N
178998	1397	1300756210000	23332	11521	87	0	\N
178999	1397	1300746209000	23332	11521	88	0	\N
179000	1397	1300736208000	23332	11521	89	0	\N
179001	1397	1300726207000	23332	11521	90	0	\N
179002	1397	1300716206000	23332	11521	91	0	\N
179003	1397	1300706205000	23332	11521	92	0	\N
179004	1397	1300696204000	23332	11521	93	0	\N
179005	1397	1300686203000	23332	11521	94	0	\N
179006	1397	1300676202000	23332	11521	95	0	\N
179007	1397	1300666201000	23332	11521	96	0	\N
179008	1397	1300656200000	23332	11521	97	0	\N
179009	1397	1300646199000	23332	11521	98	0	\N
179014	1397	1299956130000	23336	11644	0	0	\N
179015	2134	86249040000	23336	11644	1	0	\N
179020	1397	1299926127000	23340	11647	0	0	\N
179021	1397	1299916126000	23340	11647	1	0	\N
179022	2134	86246031000	23340	11647	2	0	\N
179023	2134	86245028000	23340	11647	3	0	\N
179028	1397	1299926127000	23342	11647	0	0	\N
179029	1397	1299916126000	23342	11647	1	0	\N
179030	2134	86246031000	23342	11647	2	0	\N
179031	2134	86245028000	23342	11647	3	0	\N
179037	1397	1299886123000	23344	11649	0	0	\N
179038	2134	86242019000	23344	11649	1	0	\N
179041	2134	86241016000	23346	11650	0	0	\N
179045	1397	1299866121000	23349	11652	0	0	\N
179046	1397	1299856120000	23349	11652	1	0	\N
179047	2134	86239010000	23349	11652	2	0	\N
179048	2134	86238007000	23349	11652	3	0	\N
179049	1397	1299866121000	23350	11652	0	0	\N
179050	1397	1299856120000	23350	11652	1	0	\N
179051	2134	86239010000	23350	11652	2	0	\N
179052	2134	86238007000	23350	11652	3	0	\N
179053	1397	1299866121000	23351	11652	0	0	\N
179054	1397	1299856120000	23351	11652	1	0	\N
179055	2134	86239010000	23351	11652	2	0	\N
179056	2134	86238007000	23351	11652	3	0	\N
179061	1397	1300736208000	23353	11407	0	0	\N
179062	1474	6470463000043	23353	11407	1	0	\N
179063	1397	1300726207000	23353	11407	2	0	\N
179064	1397	1300716206000	23353	11407	3	0	\N
179065	1397	1300706205000	23353	11407	4	0	\N
179066	1397	1300696204000	23353	11407	5	0	\N
179067	1397	1300686203000	23353	11407	6	0	\N
179068	1397	1300676202000	23353	11407	7	0	\N
179069	1397	1300666201000	23353	11407	8	0	\N
179070	1397	1300656200000	23353	11407	9	0	\N
179071	1397	1300646199000	23353	11407	10	0	\N
179072	1397	1300636198000	23353	11407	11	0	\N
179073	1397	1300626197000	23353	11407	12	0	\N
179074	1397	1300616196000	23353	11407	13	0	\N
179075	1397	1300606195000	23353	11407	14	0	\N
179076	1397	1300596194000	23353	11407	15	0	\N
179077	1397	1300586193000	23353	11407	16	0	\N
179078	1397	1300576192000	23353	11407	17	0	\N
179079	1397	1300566191000	23353	11407	18	0	\N
179080	1397	1300556190000	23353	11407	19	0	\N
179081	1397	1300546189000	23353	11407	20	0	\N
179082	1397	1300536188000	23353	11407	21	0	\N
179083	1397	1300526187000	23353	11407	22	0	\N
179084	1397	1300516186000	23353	11407	23	0	\N
179085	1397	1300506185000	23353	11407	24	0	\N
179086	1397	1300496184000	23353	11407	25	0	\N
179087	1397	1300486183000	23353	11407	26	0	\N
179088	1397	1300476182000	23353	11407	27	0	\N
179089	1397	1300466181000	23353	11407	28	0	\N
179090	1397	1300456180000	23353	11407	29	0	\N
179091	1397	1300446179000	23353	11407	30	0	\N
179092	1397	1300436178000	23353	11407	31	0	\N
179093	1397	1300426177000	23353	11407	32	0	\N
179094	1397	1300416176000	23353	11407	33	0	\N
179095	1397	1300406175000	23353	11407	34	0	\N
179096	1397	1300396174000	23353	11407	35	0	\N
179097	1397	1300386173000	23353	11407	36	0	\N
179098	1397	1300376172000	23353	11407	37	0	\N
179099	1397	1300366171000	23353	11407	38	0	\N
179100	1397	1300356170000	23353	11407	39	0	\N
179101	1397	1300346169000	23353	11407	40	0	\N
179102	1397	1300336168000	23353	11407	41	0	\N
179103	1397	1300326167000	23353	11407	42	0	\N
179104	1397	1300316166000	23353	11407	43	0	\N
179105	1397	1300306165000	23353	11407	44	0	\N
179106	1397	1300296164000	23353	11407	45	0	\N
179107	1397	1300286163000	23353	11407	46	0	\N
179108	1397	1300276162000	23353	11407	47	0	\N
179109	1397	1300266161000	23353	11407	48	0	\N
179110	1397	1300256160000	23353	11407	49	0	\N
179111	1397	1300246159000	23353	11407	50	0	\N
179112	1397	1300236158000	23353	11407	51	0	\N
179012	1397	1299956130000	23335	11644	0	0	13887
179013	2134	86249040000	23335	11644	1	0	4328
179016	1397	1299946129000	23337	11645	0	0	13888
179017	2134	86248037000	23337	11645	1	0	4329
179018	1397	1299936128000	23339	11646	0	0	13889
179024	1397	1299926127000	23341	11647	0	0	13890
179025	1397	1299916126000	23341	11647	1	0	13891
179026	2134	86246031000	23341	11647	2	0	4331
179027	2134	86245028000	23341	11647	3	0	4332
179032	1474	6470463000043	23343	11648	0	0	28
179034	1397	1299896124000	23343	11648	2	0	13893
179035	2134	86244025000	23343	11648	3	0	4333
179036	2134	86243022000	23343	11648	4	0	4334
179039	1397	1299886123000	23345	11649	0	0	13894
179042	2134	86241016000	23347	11650	0	0	4336
179043	1397	1299876122000	23348	11651	0	0	13895
179044	2134	86240013000	23348	11651	1	0	4337
179057	1397	1299866121000	23352	11652	0	0	13896
179058	1397	1299856120000	23352	11652	1	0	13897
179060	2134	86238007000	23352	11652	3	0	4339
179113	1397	1300226157000	23353	11407	52	0	\N
179114	1397	1300216156000	23353	11407	53	0	\N
179115	1397	1300206155000	23353	11407	54	0	\N
179116	1397	1300196154000	23353	11407	55	0	\N
179117	1397	1300186153000	23353	11407	56	0	\N
179118	1397	1300176152000	23353	11407	57	0	\N
179119	1397	1300166151000	23353	11407	58	0	\N
179120	1397	1300156150000	23353	11407	59	0	\N
179121	1397	1300146149000	23353	11407	60	0	\N
179122	1397	1300136148000	23353	11407	61	0	\N
179123	1397	1300126147000	23353	11407	62	0	\N
179124	1397	1300116146000	23353	11407	63	0	\N
179125	1397	1300106145000	23353	11407	64	0	\N
179126	1397	1300096144000	23353	11407	65	0	\N
179127	1397	1300086143000	23353	11407	66	0	\N
179128	1397	1300076142000	23353	11407	67	0	\N
179129	1397	1300066141000	23353	11407	68	0	\N
179130	1397	1300056140000	23353	11407	69	0	\N
179131	1397	1300046139000	23353	11407	70	0	\N
179132	1397	1300036138000	23353	11407	71	0	\N
179133	1397	1300026137000	23353	11407	72	0	\N
179134	1397	1300016136000	23353	11407	73	0	\N
179135	1397	1300006135000	23353	11407	74	0	\N
179136	1397	1299996134000	23353	11407	75	0	\N
179137	1397	1299986133000	23353	11407	76	0	\N
179138	1397	1299976132000	23353	11407	77	0	\N
179139	1397	1299966131000	23353	11407	78	0	\N
179140	1397	1299956130000	23353	11407	79	0	\N
179141	1397	1299946129000	23353	11407	80	0	\N
179142	1397	1299936128000	23353	11407	81	0	\N
179143	1397	1299926127000	23353	11407	82	0	\N
179144	1397	1299916126000	23353	11407	83	0	\N
179145	1397	1299906125000	23353	11407	84	0	\N
179146	1397	1299896124000	23353	11407	85	0	\N
179147	1397	1299886123000	23353	11407	86	0	\N
179148	1397	1299876122000	23353	11407	87	0	\N
179149	1397	1299866121000	23353	11407	89	0	\N
179150	1397	1299856120000	23353	11407	90	0	\N
179151	846	573333333200000	23353	11407	91	0	\N
179152	1531	89000000	23353	11407	92	0	\N
179153	2134	86559970000	23353	11407	93	0	\N
179154	2134	86558967000	23353	11407	94	0	\N
179155	1422	21018034190073	23353	11407	95	0	\N
179156	1493	9000000	23353	11407	96	0	\N
179157	2133	93811058000	23353	11407	97	0	\N
179158	2133	93810056000	23353	11407	98	0	\N
179159	2133	93809054000	23353	11407	99	0	\N
179160	2297	8154337013959	23353	11407	100	0	\N
179161	2119	194000000	23353	11407	101	0	\N
179162	2132	147850852000	23353	11407	102	0	\N
179163	1397	1299846119000	23354	11653	0	0	\N
179164	2134	86237004000	23354	11653	1	0	\N
179174	1397	1299806115000	23359	11656	0	0	\N
179175	2134	86232992000	23359	11656	2	0	\N
179176	1397	1299806115000	23360	11656	0	0	\N
179177	2134	86232992000	23360	11656	2	0	\N
179185	1397	1299776112000	23364	11659	0	0	\N
179186	2134	86229983000	23364	11659	1	0	\N
179191	1474	6470463000043	23366	11487	0	0	\N
179200	1397	1299726107000	23369	11662	0	0	\N
179201	1397	1299716106000	23369	11662	1	0	\N
179202	2134	86224968000	23369	11662	2	0	\N
179203	2134	86223965000	23369	11662	3	0	\N
179204	1397	1299706105000	23371	11663	0	0	\N
179205	2134	86222962000	23371	11663	1	0	\N
179208	1397	1299706105000	23373	11663	0	0	\N
179209	2134	86222962000	23373	11663	1	0	\N
179210	1397	1299696104000	23374	11664	0	0	\N
179211	2134	86221959000	23374	11664	1	0	\N
179212	1397	1299696104000	23375	11664	0	0	\N
179213	2134	86221959000	23375	11664	1	0	\N
179216	1397	1299686103000	23377	11665	0	0	\N
179217	1397	1299676102000	23377	11665	1	0	\N
179218	1397	1299666101000	23377	11665	2	0	\N
179219	2134	86220956000	23377	11665	3	0	\N
179220	2134	86219953000	23377	11665	4	0	\N
179225	1397	1299666101000	23379	11666	0	0	\N
179226	2134	86218950000	23379	11666	1	0	\N
179231	1397	1299656100000	23382	11667	0	0	\N
179232	2134	86217947000	23382	11667	1	0	\N
179233	1397	1299706105000	23383	11663	0	0	\N
179234	1397	1299696104000	23383	11663	1	0	\N
179235	1397	1299686103000	23383	11663	2	0	\N
179236	1397	1299676102000	23383	11663	3	0	\N
179237	1397	1299666101000	23383	11663	4	0	\N
179238	1397	1299656100000	23383	11663	5	0	\N
179239	2134	86222962000	23383	11663	6	0	\N
179240	2134	86221959000	23383	11663	7	0	\N
179241	2134	86220956000	23383	11663	8	0	\N
179242	2134	86219953000	23383	11663	9	0	\N
179243	2134	86218950000	23383	11663	10	0	\N
179244	2134	86217947000	23383	11663	11	0	\N
179167	1397	1299836118000	23356	11654	0	0	13899
179168	1397	1299826117000	23356	11654	1	0	13900
179169	2134	86236001000	23356	11654	2	0	4341
179170	2134	86234998000	23356	11654	3	0	4342
179171	1397	1299816116000	23357	11655	0	0	13901
179173	1397	1299806115000	23358	11656	0	0	13902
179178	1397	1299796114000	23361	11657	0	0	13903
179179	2134	86232992000	23361	11657	1	0	4344
179180	2134	86231989000	23361	11657	2	0	4345
179181	1397	1299786113000	23362	11658	0	0	13904
179183	1397	1299776112000	23363	11659	0	0	13905
179184	2134	86229983000	23363	11659	1	0	4347
179187	1397	1299766111000	23365	11660	0	0	13906
179188	1397	1299756110000	23365	11660	1	0	13907
179190	2134	86227977000	23365	11660	3	0	4349
179192	1397	1299746109000	23367	11661	0	0	13908
179193	1397	1299736108000	23367	11661	1	0	13909
179194	2134	86226974000	23367	11661	2	0	4350
179195	2134	86225971000	23367	11661	3	0	4351
179197	1397	1299716106000	23368	11662	1	0	13911
179198	2134	86224968000	23368	11662	2	0	4352
179199	2134	86223965000	23368	11662	3	0	4353
179206	1397	1299706105000	23372	11663	0	0	13912
179207	2134	86222962000	23372	11663	1	0	4354
179215	2134	86221959000	23376	11664	1	0	4355
179221	1397	1299686103000	23378	11665	0	0	13914
179222	1397	1299676102000	23378	11665	1	0	13915
179223	2134	86220956000	23378	11665	2	0	4356
179227	1397	1299666101000	23380	11666	0	0	13916
179228	2134	86218950000	23380	11666	1	0	4358
179229	1397	1299656100000	23381	11667	0	0	13917
179230	2134	86217947000	23381	11667	1	0	4359
179245	1397	1299646099000	23384	11668	0	0	13918
179247	2134	86216944000	23384	11668	2	0	4360
179248	2134	86215941000	23384	11668	3	0	4361
179251	1397	1299626097000	23386	11669	0	0	\N
179252	2134	86214938000	23386	11669	1	0	\N
179253	1474	6470463000043	23387	11570	0	0	\N
179254	394	66001818809135	23387	11570	1	0	\N
179255	394	66001718809135	23387	11570	2	0	\N
179256	112	66000012832720	23387	11570	3	0	\N
179257	1474	6470463000043	23388	11550	0	0	\N
179268	1397	1299616096000	23391	11670	0	0	\N
179269	1397	1299606095000	23391	11670	1	0	\N
179270	1397	1299596094000	23391	11670	2	0	\N
179271	1397	1299586093000	23391	11670	3	0	\N
179272	1397	1299576092000	23391	11670	4	0	\N
179273	2134	86213935000	23391	11670	5	0	\N
179274	2134	86212932000	23391	11670	6	0	\N
179275	2134	86211929000	23391	11670	7	0	\N
179276	2134	86210926000	23391	11670	8	0	\N
179277	2134	86209923000	23391	11670	9	0	\N
179282	1397	1299566091000	23393	11671	0	0	\N
179283	1397	1299556090000	23393	11671	1	0	\N
179284	2134	86208920000	23393	11671	2	0	\N
179285	2134	86207917000	23393	11671	3	0	\N
179286	1397	1299566091000	23394	11671	0	0	\N
179287	1397	1299556090000	23394	11671	1	0	\N
179288	2134	86208920000	23394	11671	2	0	\N
179289	2134	86207917000	23394	11671	3	0	\N
179290	2134	86208920000	23395	11671	0	0	\N
179291	2134	86207917000	23395	11671	1	0	\N
179292	1397	1299566091000	23396	11671	0	0	\N
179293	1397	1299556090000	23396	11671	1	0	\N
179294	2134	86208920000	23396	11671	2	0	\N
179295	2134	86207917000	23396	11671	3	0	\N
179296	1474	6470463000043	23397	11486	0	0	\N
179297	1397	1300266161000	23397	11486	1	0	\N
179298	1397	1300256160000	23397	11486	2	0	\N
179299	1397	1300246159000	23397	11486	3	0	\N
179300	1397	1300236158000	23397	11486	4	0	\N
179301	1397	1300226157000	23397	11486	5	0	\N
179302	1397	1300216156000	23397	11486	6	0	\N
179303	1397	1300206155000	23397	11486	7	0	\N
179304	1397	1300196154000	23397	11486	8	0	\N
179305	1397	1300186153000	23397	11486	9	0	\N
179306	1397	1300176152000	23397	11486	10	0	\N
179307	1397	1300166151000	23397	11486	11	0	\N
179308	1397	1300156150000	23397	11486	12	0	\N
179309	1397	1300146149000	23397	11486	13	0	\N
179310	1397	1300136148000	23397	11486	14	0	\N
179311	1397	1300126147000	23397	11486	15	0	\N
179312	1397	1300116146000	23397	11486	16	0	\N
179313	1397	1300106145000	23397	11486	17	0	\N
179314	1397	1300096144000	23397	11486	18	0	\N
179315	1397	1300086143000	23397	11486	19	0	\N
179316	1397	1300076142000	23397	11486	20	0	\N
179317	1397	1300066141000	23397	11486	21	0	\N
179318	1397	1300056140000	23397	11486	22	0	\N
179319	1397	1300046139000	23397	11486	23	0	\N
179320	1397	1300036138000	23397	11486	24	0	\N
179321	1397	1300026137000	23397	11486	25	0	\N
179322	1397	1300016136000	23397	11486	26	0	\N
179323	1397	1300006135000	23397	11486	27	0	\N
179324	1397	1299996134000	23397	11486	28	0	\N
179325	1397	1299986133000	23397	11486	29	0	\N
179326	1397	1299976132000	23397	11486	30	0	\N
179327	1397	1299966131000	23397	11486	31	0	\N
179328	1397	1299956130000	23397	11486	32	0	\N
179329	1397	1299946129000	23397	11486	33	0	\N
179330	1397	1299936128000	23397	11486	34	0	\N
179331	1397	1299926127000	23397	11486	35	0	\N
179332	1397	1299916126000	23397	11486	36	0	\N
179333	1397	1299906125000	23397	11486	37	0	\N
179334	1397	1299896124000	23397	11486	38	0	\N
179335	1397	1299886123000	23397	11486	39	0	\N
179336	1397	1299876122000	23397	11486	40	0	\N
179337	1397	1299866121000	23397	11486	41	0	\N
179338	1397	1299856120000	23397	11486	42	0	\N
179339	1397	1299846119000	23397	11486	43	0	\N
179340	1397	1299836118000	23397	11486	44	0	\N
179341	1397	1299826117000	23397	11486	45	0	\N
179342	1397	1299816116000	23397	11486	46	0	\N
179343	1397	1299806115000	23397	11486	47	0	\N
179344	1397	1299796114000	23397	11486	48	0	\N
179345	1397	1299786113000	23397	11486	49	0	\N
179346	1397	1299776112000	23397	11486	50	0	\N
179347	1397	1299766111000	23397	11486	51	0	\N
179348	1397	1299756110000	23397	11486	52	0	\N
179349	1397	1299746109000	23397	11486	53	0	\N
179350	1397	1299736108000	23397	11486	54	0	\N
179351	1397	1299726107000	23397	11486	55	0	\N
179352	1397	1299716106000	23397	11486	56	0	\N
179353	1397	1299706105000	23397	11486	57	0	\N
179354	1397	1299696104000	23397	11486	58	0	\N
179355	1397	1299686103000	23397	11486	59	0	\N
179356	1397	1299676102000	23397	11486	60	0	\N
179357	1397	1299666101000	23397	11486	61	0	\N
179358	1397	1299656100000	23397	11486	62	0	\N
179359	1397	1299646099000	23397	11486	63	0	\N
179360	1397	1299636098000	23397	11486	64	0	\N
179361	1397	1299626097000	23397	11486	65	0	\N
179362	1397	1299616096000	23397	11486	66	0	\N
179363	1397	1299606095000	23397	11486	67	0	\N
179364	1397	1299596094000	23397	11486	68	0	\N
179365	1397	1299586093000	23397	11486	69	0	\N
179366	1397	1299576092000	23397	11486	70	0	\N
179367	1397	1299566091000	23397	11486	71	0	\N
179368	1397	1299556090000	23397	11486	72	0	\N
179369	2134	86418547000	23397	11486	73	0	\N
179370	2134	86417544000	23397	11486	74	0	\N
179371	2134	86416541000	23397	11486	75	0	\N
179372	2134	86415538000	23397	11486	76	0	\N
179373	2134	86414535000	23397	11486	77	0	\N
179374	2134	86413532000	23397	11486	78	0	\N
179375	2134	86412529000	23397	11486	79	0	\N
179376	2134	86411526000	23397	11486	80	0	\N
179377	2134	86410523000	23397	11486	82	0	\N
179378	2134	86409520000	23397	11486	83	0	\N
179379	2134	86408517000	23397	11486	84	0	\N
179380	2134	86407514000	23397	11486	85	0	\N
179381	2134	86406511000	23397	11486	86	0	\N
179382	2134	86405508000	23397	11486	87	0	\N
179383	2134	86404505000	23397	11486	88	0	\N
179384	2134	86403502000	23397	11486	89	0	\N
179258	1397	1299616096000	23390	11670	0	0	13921
179259	1397	1299606095000	23390	11670	1	0	13922
179260	1397	1299596094000	23390	11670	2	0	13923
179261	1397	1299586093000	23390	11670	3	0	13924
179262	1397	1299576092000	23390	11670	4	0	13925
179264	2134	86212932000	23390	11670	6	0	4364
179265	2134	86211929000	23390	11670	7	0	4365
179266	2134	86210926000	23390	11670	8	0	4366
179267	2134	86209923000	23390	11670	9	0	4367
179278	1397	1299566091000	23392	11671	0	0	13926
179280	2134	86208920000	23392	11671	2	0	4368
179281	2134	86207917000	23392	11671	3	0	4369
179385	2134	86402499000	23397	11486	90	0	\N
179386	2134	86401496000	23397	11486	91	0	\N
179387	2134	86400493000	23397	11486	92	0	\N
179388	2134	86399490000	23397	11486	93	0	\N
179389	2134	86398487000	23397	11486	94	0	\N
179390	2134	86397484000	23397	11486	95	0	\N
179391	2134	86396481000	23397	11486	96	0	\N
179392	2134	86395478000	23397	11486	97	0	\N
179395	1397	1299546089000	23399	11672	0	0	\N
179396	2134	86206914000	23399	11672	1	0	\N
179413	1397	1299496084000	23405	11677	0	0	\N
179414	1397	1299486083000	23405	11677	1	0	\N
179415	1397	1299476082000	23405	11677	2	0	\N
179416	1397	1299466081000	23405	11677	3	0	\N
179417	2134	86201899000	23405	11677	4	0	\N
179418	2134	86200896000	23405	11677	5	0	\N
179419	2134	86199893000	23405	11677	6	0	\N
179420	2134	86198890000	23405	11677	7	0	\N
179421	1397	1299496084000	23406	11677	0	0	\N
179422	1397	1299486083000	23406	11677	1	0	\N
179423	1397	1299476082000	23406	11677	2	0	\N
179424	1397	1299466081000	23406	11677	3	0	\N
179425	2134	86201899000	23406	11677	4	0	\N
179426	2134	86200896000	23406	11677	5	0	\N
179427	2134	86199893000	23406	11677	6	0	\N
179428	2134	86198890000	23406	11677	7	0	\N
179433	1397	1299436078000	23408	11679	0	0	\N
179434	2134	86195881000	23408	11679	1	0	\N
179437	1474	6470463000043	23410	11538	0	0	\N
179438	394	66001818809135	23410	11538	1	0	\N
179439	394	66001718809135	23410	11538	2	0	\N
179440	1397	1301006235000	23410	11538	3	0	\N
179441	1397	1300996234000	23410	11538	4	0	\N
179442	1397	1300986233000	23410	11538	5	0	\N
179443	1397	1300976232000	23410	11538	6	0	\N
179444	1397	1300966231000	23410	11538	7	0	\N
179445	1397	1300956230000	23410	11538	8	0	\N
179446	1397	1300946229000	23410	11538	9	0	\N
179447	1397	1300936228000	23410	11538	10	0	\N
179448	1397	1300926227000	23410	11538	11	0	\N
179449	1397	1300916226000	23410	11538	12	0	\N
179450	1397	1300906225000	23410	11538	13	0	\N
179451	1397	1300896224000	23410	11538	14	0	\N
179452	1397	1300886223000	23410	11538	15	0	\N
179453	1397	1300876222000	23410	11538	16	0	\N
179454	1397	1300866221000	23410	11538	17	0	\N
179455	1397	1300856220000	23410	11538	18	0	\N
179456	1397	1300846219000	23410	11538	19	0	\N
179457	1397	1300836218000	23410	11538	20	0	\N
179458	1397	1300826217000	23410	11538	21	0	\N
179459	1397	1300816216000	23410	11538	22	0	\N
179460	1397	1300806215000	23410	11538	23	0	\N
179461	1397	1300796214000	23410	11538	24	0	\N
179462	1397	1300786213000	23410	11538	25	0	\N
179463	1397	1300776212000	23410	11538	26	0	\N
179464	1397	1300766211000	23410	11538	27	0	\N
179465	1397	1300756210000	23410	11538	28	0	\N
179466	1397	1300746209000	23410	11538	29	0	\N
179467	1397	1300736208000	23410	11538	30	0	\N
179468	1397	1300726207000	23410	11538	31	0	\N
179469	1397	1300716206000	23410	11538	32	0	\N
179470	1397	1300706205000	23410	11538	33	0	\N
179471	1397	1300696204000	23410	11538	34	0	\N
179472	1397	1300686203000	23410	11538	35	0	\N
179473	1397	1300676202000	23410	11538	36	0	\N
179474	1397	1300666201000	23410	11538	37	0	\N
179475	1397	1300656200000	23410	11538	38	0	\N
179476	1397	1300646199000	23410	11538	39	0	\N
179477	1397	1300636198000	23410	11538	40	0	\N
179478	1397	1300626197000	23410	11538	41	0	\N
179479	1397	1300616196000	23410	11538	42	0	\N
179480	1397	1300606195000	23410	11538	43	0	\N
179481	1397	1300596194000	23410	11538	44	0	\N
179482	1397	1300586193000	23410	11538	45	0	\N
179483	1397	1300576192000	23410	11538	46	0	\N
179484	1397	1300566191000	23410	11538	47	0	\N
179485	1397	1300556190000	23410	11538	48	0	\N
179486	1397	1300546189000	23410	11538	49	0	\N
179487	1397	1300536188000	23410	11538	50	0	\N
179488	1397	1300526187000	23410	11538	51	0	\N
179489	1397	1300516186000	23410	11538	52	0	\N
179490	1397	1300506185000	23410	11538	53	0	\N
179491	1397	1300496184000	23410	11538	54	0	\N
179492	1397	1300486183000	23410	11538	55	0	\N
179493	1397	1300476182000	23410	11538	56	0	\N
179494	1397	1300466181000	23410	11538	57	0	\N
179495	1397	1300456180000	23410	11538	58	0	\N
179496	1397	1300446179000	23410	11538	59	0	\N
179497	1397	1300436178000	23410	11538	60	0	\N
179498	1397	1300426177000	23410	11538	61	0	\N
179499	1397	1300416176000	23410	11538	62	0	\N
179500	1397	1300406175000	23410	11538	63	0	\N
179501	1397	1300396174000	23410	11538	64	0	\N
179502	1397	1300386173000	23410	11538	65	0	\N
179503	1397	1300376172000	23410	11538	66	0	\N
179504	1397	1300366171000	23410	11538	67	0	\N
179505	1397	1300356170000	23410	11538	68	0	\N
179506	1397	1300346169000	23410	11538	69	0	\N
179507	1397	1300336168000	23410	11538	70	0	\N
179508	1397	1300326167000	23410	11538	71	0	\N
179509	1397	1300316166000	23410	11538	72	0	\N
179510	1397	1300306165000	23410	11538	73	0	\N
179511	1397	1300296164000	23410	11538	74	0	\N
179512	1397	1300286163000	23410	11538	75	0	\N
179513	1397	1300276162000	23410	11538	76	0	\N
179514	1397	1300266161000	23410	11538	77	0	\N
179515	1397	1300256160000	23410	11538	78	0	\N
179516	1397	1300246159000	23410	11538	79	0	\N
179517	1397	1300236158000	23410	11538	80	0	\N
179518	1397	1300226157000	23410	11538	81	0	\N
179519	1397	1300216156000	23410	11538	82	0	\N
179520	1397	1300206155000	23410	11538	83	0	\N
179397	1397	1299536088000	23400	11673	0	0	13929
179398	2134	86205911000	23400	11673	1	0	4371
179399	1397	1299526087000	23401	11674	0	0	13930
179400	2134	86204908000	23401	11674	1	0	4372
179401	1397	1299516086000	23402	11675	0	0	13931
179403	1397	1299506085000	23403	11676	0	0	13932
179404	2134	86202902000	23403	11676	1	0	4374
179405	1397	1299496084000	23404	11677	0	0	13933
179406	1397	1299486083000	23404	11677	1	0	13934
179407	1397	1299476082000	23404	11677	2	0	13935
179409	2134	86201899000	23404	11677	4	0	4375
179410	2134	86200896000	23404	11677	5	0	4376
179411	2134	86199893000	23404	11677	6	0	4377
179412	2134	86198890000	23404	11677	7	0	4378
179430	1397	1299446079000	23407	11678	1	0	13938
179431	2134	86197887000	23407	11678	2	0	4379
179432	2134	86196884000	23407	11678	3	0	4380
179435	1397	1299436078000	23409	11679	0	0	13939
179436	2134	86195881000	23409	11679	1	0	4381
179521	1397	1300196154000	23410	11538	84	0	\N
179522	1397	1300186153000	23410	11538	85	0	\N
179523	1397	1300176152000	23410	11538	86	0	\N
179524	1397	1300166151000	23410	11538	87	0	\N
179525	1397	1300156150000	23410	11538	88	0	\N
179526	1397	1300146149000	23410	11538	89	0	\N
179527	1397	1300136148000	23410	11538	90	0	\N
179528	1397	1300126147000	23410	11538	91	0	\N
179529	1397	1300116146000	23410	11538	92	0	\N
179530	1397	1300106145000	23410	11538	93	0	\N
179531	1397	1300096144000	23410	11538	94	0	\N
179532	1397	1300086143000	23410	11538	95	0	\N
179533	1397	1300076142000	23410	11538	96	0	\N
179534	1397	1300066141000	23410	11538	97	0	\N
179535	1397	1300056140000	23410	11538	98	0	\N
179536	1397	1300046139000	23410	11538	99	0	\N
179537	1397	1300036138000	23410	11538	100	0	\N
179538	1397	1300026137000	23410	11538	101	0	\N
179539	1397	1300016136000	23410	11538	102	0	\N
179540	1397	1300006135000	23410	11538	103	0	\N
179541	1397	1299996134000	23410	11538	104	0	\N
179542	1397	1299986133000	23410	11538	105	0	\N
179543	1397	1299976132000	23410	11538	106	0	\N
179544	1397	1299966131000	23410	11538	107	0	\N
179545	1397	1299956130000	23410	11538	108	0	\N
179546	1397	1299946129000	23410	11538	110	0	\N
179547	1397	1299936128000	23410	11538	111	0	\N
179548	1397	1299926127000	23410	11538	112	0	\N
179549	1397	1299916126000	23410	11538	113	0	\N
179550	1397	1299906125000	23410	11538	114	0	\N
179551	1397	1299896124000	23410	11538	115	0	\N
179552	1397	1299886123000	23410	11538	116	0	\N
179553	1397	1299876122000	23410	11538	117	0	\N
179554	1397	1299866121000	23410	11538	118	0	\N
179555	1397	1299856120000	23410	11538	119	0	\N
179556	1397	1299846119000	23410	11538	120	0	\N
179557	1397	1299836118000	23410	11538	121	0	\N
179558	1397	1299826117000	23410	11538	122	0	\N
179559	1397	1299816116000	23410	11538	123	0	\N
179560	1397	1299806115000	23410	11538	124	0	\N
179561	1397	1299796114000	23410	11538	125	0	\N
179566	1397	1299406075000	23413	11682	0	0	\N
179567	1397	1299396074000	23413	11682	1	0	\N
179568	2134	86192872000	23413	11682	2	0	\N
179569	2134	86191869000	23413	11682	3	0	\N
179574	1397	1299406075000	23415	11682	0	0	\N
179575	1397	1299396074000	23415	11682	1	0	\N
179576	2134	86192872000	23415	11682	2	0	\N
179577	2134	86191869000	23415	11682	3	0	\N
179578	1397	1299546089000	23416	11672	0	0	\N
179579	1397	1299536088000	23416	11672	1	0	\N
179580	1397	1299526087000	23416	11672	2	0	\N
179581	1397	1299516086000	23416	11672	3	0	\N
179582	1397	1299506085000	23416	11672	4	0	\N
179583	1397	1299496084000	23416	11672	5	0	\N
179584	1397	1299486083000	23416	11672	6	0	\N
179585	1397	1299476082000	23416	11672	7	0	\N
179586	1397	1299466081000	23416	11672	8	0	\N
179587	1397	1299456080000	23416	11672	9	0	\N
179588	1397	1299446079000	23416	11672	10	0	\N
179589	1397	1299436078000	23416	11672	11	0	\N
179590	1397	1299426077000	23416	11672	12	0	\N
179591	1397	1299416076000	23416	11672	13	0	\N
179592	1397	1299406075000	23416	11672	14	0	\N
179593	1397	1299396074000	23416	11672	15	0	\N
179594	2134	86206914000	23416	11672	16	0	\N
179595	2134	86205911000	23416	11672	17	0	\N
179596	2134	86204908000	23416	11672	18	0	\N
179597	2134	86203905000	23416	11672	19	0	\N
179598	2134	86202902000	23416	11672	20	0	\N
179599	2134	86201899000	23416	11672	21	0	\N
179600	2134	86200896000	23416	11672	22	0	\N
179601	2134	86199893000	23416	11672	23	0	\N
179602	2134	86198890000	23416	11672	24	0	\N
179603	2134	86197887000	23416	11672	25	0	\N
179604	2134	86196884000	23416	11672	26	0	\N
179605	2134	86195881000	23416	11672	27	0	\N
179606	2134	86194878000	23416	11672	28	0	\N
179607	2134	86193875000	23416	11672	29	0	\N
179608	2134	86192872000	23416	11672	30	0	\N
179609	2134	86191869000	23416	11672	31	0	\N
179610	1397	1299386073000	23417	11683	0	0	\N
179611	2134	86190866000	23417	11683	1	0	\N
179619	112	66000001832720	23421	11673	0	0	\N
179620	1397	1299536088000	23421	11673	1	0	\N
179621	1397	1299526087000	23421	11673	2	0	\N
179622	1397	1299516086000	23421	11673	3	0	\N
179623	1397	1299506085000	23421	11673	4	0	\N
179624	1397	1299496084000	23421	11673	5	0	\N
179625	1397	1299486083000	23421	11673	6	0	\N
179626	1397	1299476082000	23421	11673	7	0	\N
179627	1397	1299466081000	23421	11673	8	0	\N
179628	1397	1299456080000	23421	11673	9	0	\N
179629	1397	1299446079000	23421	11673	10	0	\N
179630	1397	1299436078000	23421	11673	11	0	\N
179631	1397	1299426077000	23421	11673	12	0	\N
179632	1397	1299416076000	23421	11673	13	0	\N
179633	1397	1299406075000	23421	11673	14	0	\N
179634	1397	1299396074000	23421	11673	15	0	\N
179635	1397	1299386073000	23421	11673	16	0	\N
179636	1397	1299376072000	23421	11673	17	0	\N
179637	1397	1299366071000	23421	11673	18	0	\N
179638	2134	86205911000	23421	11673	19	0	\N
179639	2134	86204908000	23421	11673	20	0	\N
179640	2134	86203905000	23421	11673	21	0	\N
179641	2134	86202902000	23421	11673	22	0	\N
179642	2134	86201899000	23421	11673	23	0	\N
179643	2134	86200896000	23421	11673	24	0	\N
179644	2134	86199893000	23421	11673	25	0	\N
179645	2134	86198890000	23421	11673	26	0	\N
179646	2134	86197887000	23421	11673	27	0	\N
179647	2134	86196884000	23421	11673	28	0	\N
179648	2134	86195881000	23421	11673	29	0	\N
179649	2134	86194878000	23421	11673	30	0	\N
179650	2134	86193875000	23421	11673	31	0	\N
179651	2134	86192872000	23421	11673	32	0	\N
179652	2134	86191869000	23421	11673	33	0	\N
179653	2134	86190866000	23421	11673	34	0	\N
179654	2134	86189863000	23421	11673	35	0	\N
179655	2134	86188860000	23421	11673	36	0	\N
179564	1397	1299416076000	23412	11681	0	0	13941
179565	2134	86193875000	23412	11681	2	0	4383
179570	1397	1299406075000	23414	11682	0	0	13942
179571	1397	1299396074000	23414	11682	1	0	13943
179572	2134	86192872000	23414	11682	2	0	4384
179612	1397	1299386073000	23418	11683	0	0	13944
179613	2134	86190866000	23418	11683	1	0	4386
179614	112	66000001832720	23419	11684	0	0	9
179615	1397	1299376072000	23419	11684	1	0	13945
179616	2134	86189863000	23419	11684	2	0	4387
179618	2134	86188860000	23420	11685	1	0	4388
179656	1397	1299356070000	23422	11686	0	0	13947
179662	1397	1299326067000	23423	11687	0	0	\N
179663	1397	1299356070000	23424	11686	0	0	\N
179664	1397	1299346069000	23424	11686	1	0	\N
179665	1397	1299336068000	23424	11686	2	0	\N
179666	1397	1299326067000	23424	11686	3	0	\N
179667	2134	86187857000	23424	11686	4	0	\N
179668	2134	86186854000	23424	11686	5	0	\N
179669	2134	86185851000	23424	11686	6	0	\N
179670	2134	86184848000	23424	11686	7	0	\N
179671	1397	1299326067000	23425	11687	0	0	\N
179672	2134	86184848000	23425	11687	1	0	\N
179677	1397	1299306065000	23428	11689	0	0	\N
179678	2134	86182842000	23428	11689	1	0	\N
179681	1397	1299306065000	23430	11689	0	0	\N
179682	2134	86182842000	23430	11689	1	0	\N
179683	1397	1299306065000	23431	11689	0	0	\N
179684	2134	86182842000	23431	11689	1	0	\N
179685	1397	1299296064000	23432	11690	0	0	\N
179686	2134	86181839000	23432	11690	1	0	\N
179689	1397	1299296064000	23434	11690	0	0	\N
179690	2134	86181839000	23434	11690	1	0	\N
179691	1397	1299296064000	23435	11690	0	0	\N
179692	2134	86181839000	23435	11690	1	0	\N
179693	1397	1299296064000	23436	11690	0	0	\N
179694	2134	86181839000	23436	11690	1	0	\N
179695	1397	1299286063000	23437	11691	0	0	\N
179696	2134	86180836000	23437	11691	1	0	\N
179699	1397	1299286063000	23440	11691	0	0	\N
179700	2134	86180836000	23440	11691	1	0	\N
179701	1397	1299286063000	23441	11691	0	0	\N
179702	2134	86180836000	23441	11691	1	0	\N
179703	1397	1299286063000	23442	11691	0	0	\N
179704	2134	86180836000	23442	11691	1	0	\N
179705	1397	1299286063000	23444	11691	0	0	\N
179706	2134	86180836000	23444	11691	1	0	\N
179709	1397	1299276062000	23448	11692	0	0	\N
179710	2134	86179833000	23448	11692	1	0	\N
179713	1397	1299356070000	23450	11674	0	0	\N
179714	1397	1299346069000	23450	11674	1	0	\N
179715	1397	1299336068000	23450	11674	3	0	\N
179716	1397	1299326067000	23450	11674	4	0	\N
179717	1397	1299316066000	23450	11674	5	0	\N
179718	1397	1299306065000	23450	11674	6	0	\N
179719	1397	1299296064000	23450	11674	7	0	\N
179720	1397	1299286063000	23450	11674	8	0	\N
179721	1397	1299276062000	23450	11674	9	0	\N
179722	1397	1299266061000	23450	11674	10	0	\N
179725	1397	1299246059000	23452	11695	0	0	\N
179726	2134	86176824000	23452	11695	1	0	\N
179729	112	66000001832720	23454	11663	0	0	\N
179730	1397	1299706105000	23454	11663	1	0	\N
179731	1397	1299696104000	23454	11663	2	0	\N
179732	1397	1299686103000	23454	11663	3	0	\N
179733	1397	1299676102000	23454	11663	4	0	\N
179734	1397	1299666101000	23454	11663	5	0	\N
179735	1397	1299656100000	23454	11663	6	0	\N
179736	1397	1299646099000	23454	11663	7	0	\N
179737	1397	1299636098000	23454	11663	8	0	\N
179738	1397	1299626097000	23454	11663	9	0	\N
179739	1397	1299616096000	23454	11663	10	0	\N
179740	1397	1299606095000	23454	11663	11	0	\N
179741	1397	1299596094000	23454	11663	12	0	\N
179742	1397	1299586093000	23454	11663	13	0	\N
179743	1397	1299576092000	23454	11663	14	0	\N
179744	1397	1299566091000	23454	11663	15	0	\N
179745	1397	1299556090000	23454	11663	16	0	\N
179746	1397	1299546089000	23454	11663	17	0	\N
179747	1397	1299536088000	23454	11663	18	0	\N
179748	1397	1299526087000	23454	11663	19	0	\N
179749	1397	1299516086000	23454	11663	20	0	\N
179750	1397	1299506085000	23454	11663	21	0	\N
179751	1397	1299496084000	23454	11663	22	0	\N
179752	1397	1299486083000	23454	11663	23	0	\N
179753	1397	1299476082000	23454	11663	24	0	\N
179754	1397	1299466081000	23454	11663	25	0	\N
179755	1397	1299456080000	23454	11663	26	0	\N
179756	1397	1299446079000	23454	11663	27	0	\N
179757	1397	1299436078000	23454	11663	28	0	\N
179758	1397	1299426077000	23454	11663	29	0	\N
179759	1397	1299416076000	23454	11663	30	0	\N
179760	1397	1299406075000	23454	11663	31	0	\N
179761	1397	1299396074000	23454	11663	32	0	\N
179762	1397	1299386073000	23454	11663	33	0	\N
179763	1397	1299376072000	23454	11663	34	0	\N
179764	1397	1299366071000	23454	11663	35	0	\N
179765	1397	1299356070000	23454	11663	36	0	\N
179766	1397	1299346069000	23454	11663	37	0	\N
179767	1397	1299336068000	23454	11663	38	0	\N
179768	1397	1299326067000	23454	11663	39	0	\N
179769	1397	1299316066000	23454	11663	40	0	\N
179770	1397	1299306065000	23454	11663	41	0	\N
179771	1397	1299296064000	23454	11663	42	0	\N
179772	1397	1299286063000	23454	11663	43	0	\N
179773	1397	1299276062000	23454	11663	44	0	\N
179774	1397	1299266061000	23454	11663	45	0	\N
179775	1397	1299256060000	23454	11663	46	0	\N
179776	1397	1299246059000	23454	11663	47	0	\N
179777	2134	86222962000	23454	11663	48	0	\N
179778	2134	86221959000	23454	11663	49	0	\N
179779	2134	86220956000	23454	11663	50	0	\N
179780	2134	86219953000	23454	11663	51	0	\N
179781	2134	86218950000	23454	11663	52	0	\N
179782	2134	86217947000	23454	11663	53	0	\N
179783	2134	86216944000	23454	11663	54	0	\N
179784	2134	86215941000	23454	11663	55	0	\N
179785	2134	86214938000	23454	11663	56	0	\N
179786	2134	86213935000	23454	11663	57	0	\N
179787	2134	86212932000	23454	11663	58	0	\N
179788	2134	86211929000	23454	11663	59	0	\N
179789	2134	86210926000	23454	11663	60	0	\N
179790	2134	86209923000	23454	11663	61	0	\N
179791	2134	86208920000	23454	11663	62	0	\N
179792	2134	86207917000	23454	11663	63	0	\N
179659	2134	86187857000	23422	11686	3	0	4389
179660	2134	86186854000	23422	11686	4	0	4390
179661	2134	86185851000	23422	11686	5	0	4391
179673	1397	1299326067000	23426	11687	0	0	13950
179674	2134	86184848000	23426	11687	1	0	4392
179676	2134	86183845000	23427	11688	1	0	4393
179679	1397	1299306065000	23429	11689	0	0	13952
179680	2134	86182842000	23429	11689	1	0	4394
179687	1397	1299296064000	23433	11690	0	0	13953
179688	2134	86181839000	23433	11690	1	0	4395
179698	2134	86180836000	23439	11691	1	0	4396
179707	1397	1299276062000	23447	11692	0	0	13955
179708	2134	86179833000	23447	11692	1	0	4397
179711	1397	1299266061000	23449	11693	0	0	13956
179723	1397	1299256060000	23451	11694	0	0	13957
179724	2134	86177827000	23451	11694	1	0	4399
179727	1397	1299246059000	23453	11695	0	0	13958
179728	2134	86176824000	23453	11695	1	0	4400
179793	2134	86206914000	23454	11663	64	0	\N
179794	2134	86205911000	23454	11663	65	0	\N
179795	2134	86204908000	23454	11663	66	0	\N
179796	2134	86203905000	23454	11663	67	0	\N
179797	2134	86202902000	23454	11663	68	0	\N
179798	2134	86201899000	23454	11663	69	0	\N
179799	2134	86200896000	23454	11663	70	0	\N
179800	2134	86199893000	23454	11663	71	0	\N
179801	2134	86198890000	23454	11663	72	0	\N
179802	2134	86197887000	23454	11663	73	0	\N
179803	2134	86196884000	23454	11663	74	0	\N
179804	2134	86195881000	23454	11663	75	0	\N
179805	2134	86194878000	23454	11663	76	0	\N
179806	2134	86193875000	23454	11663	77	0	\N
179807	2134	86192872000	23454	11663	78	0	\N
179808	2134	86191869000	23454	11663	79	0	\N
179809	2134	86190866000	23454	11663	80	0	\N
179810	2134	86189863000	23454	11663	81	0	\N
179811	2134	86188860000	23454	11663	82	0	\N
179812	2134	86187857000	23454	11663	83	0	\N
179813	2134	86186854000	23454	11663	84	0	\N
179814	2134	86185851000	23454	11663	85	0	\N
179815	2134	86184848000	23454	11663	86	0	\N
179816	2134	86183845000	23454	11663	87	0	\N
179817	2134	86182842000	23454	11663	88	0	\N
179818	2134	86181839000	23454	11663	89	0	\N
179819	2134	86180836000	23454	11663	90	0	\N
179820	2134	86179833000	23454	11663	91	0	\N
179821	2134	86178830000	23454	11663	92	0	\N
179822	2134	86177827000	23454	11663	93	0	\N
179823	2134	86176824000	23454	11663	94	0	\N
179830	1397	1299226057000	23457	11697	0	0	\N
179831	2133	93595628000	23457	11697	1	0	\N
179832	2134	86174818000	23457	11697	2	0	\N
179833	1397	1299226057000	23458	11697	0	0	\N
179834	2133	93595628000	23458	11697	1	0	\N
179835	2134	86174818000	23458	11697	2	0	\N
179836	1397	1299226057000	23459	11697	0	0	\N
179837	2133	93595628000	23459	11697	1	0	\N
179838	2134	86174818000	23459	11697	2	0	\N
179839	1397	1299226057000	23461	11697	0	0	\N
179840	2133	93595628000	23461	11697	1	0	\N
179841	2134	86174818000	23461	11697	2	0	\N
179842	1397	1299786113000	23462	11539	0	0	\N
179843	1397	1299776112000	23462	11539	1	0	\N
179844	1397	1299766111000	23462	11539	2	0	\N
179845	1397	1299756110000	23462	11539	3	0	\N
179846	1397	1299746109000	23462	11539	4	0	\N
179847	1397	1299736108000	23462	11539	5	0	\N
179848	1397	1299726107000	23462	11539	6	0	\N
179849	1397	1299716106000	23462	11539	7	0	\N
179850	1397	1299706105000	23462	11539	8	0	\N
179851	1397	1299696104000	23462	11539	9	0	\N
179852	1397	1299686103000	23462	11539	10	0	\N
179853	1397	1299676102000	23462	11539	11	0	\N
179854	1397	1299666101000	23462	11539	12	0	\N
179855	1397	1299656100000	23462	11539	13	0	\N
179856	1397	1299646099000	23462	11539	14	0	\N
179857	1397	1299636098000	23462	11539	15	0	\N
179858	1397	1299626097000	23462	11539	16	0	\N
179859	1397	1299616096000	23462	11539	17	0	\N
179860	1397	1299606095000	23462	11539	18	0	\N
179861	1397	1299596094000	23462	11539	19	0	\N
179862	1397	1299586093000	23462	11539	20	0	\N
179863	1397	1299576092000	23462	11539	21	0	\N
179864	1397	1299566091000	23462	11539	22	0	\N
179865	1397	1299556090000	23462	11539	23	0	\N
179866	1397	1299546089000	23462	11539	24	0	\N
179867	1397	1299536088000	23462	11539	25	0	\N
179868	1397	1299526087000	23462	11539	26	0	\N
179869	1397	1299516086000	23462	11539	27	0	\N
179870	1397	1299506085000	23462	11539	28	0	\N
179871	1397	1299496084000	23462	11539	29	0	\N
179872	1397	1299486083000	23462	11539	30	0	\N
179873	1397	1299476082000	23462	11539	31	0	\N
179874	1397	1299466081000	23462	11539	32	0	\N
179875	1397	1299456080000	23462	11539	33	0	\N
179876	1397	1299446079000	23462	11539	34	0	\N
179877	1397	1299436078000	23462	11539	35	0	\N
179878	1397	1299426077000	23462	11539	36	0	\N
179879	1397	1299416076000	23462	11539	37	0	\N
179880	1397	1299406075000	23462	11539	38	0	\N
179881	1397	1299396074000	23462	11539	39	0	\N
179882	1397	1299386073000	23462	11539	40	0	\N
179883	1397	1299376072000	23462	11539	41	0	\N
179884	1397	1299366071000	23462	11539	42	0	\N
179885	1397	1299356070000	23462	11539	43	0	\N
179886	1397	1299346069000	23462	11539	44	0	\N
179887	1397	1299336068000	23462	11539	45	0	\N
179888	1397	1299326067000	23462	11539	46	0	\N
179889	1397	1299316066000	23462	11539	47	0	\N
179890	1397	1299306065000	23462	11539	48	0	\N
179891	1397	1299296064000	23462	11539	49	0	\N
179892	1397	1299286063000	23462	11539	50	0	\N
179893	1397	1299276062000	23462	11539	51	0	\N
179894	1397	1299266061000	23462	11539	52	0	\N
179895	1397	1299256060000	23462	11539	53	0	\N
179896	1397	1299246059000	23462	11539	54	0	\N
179897	1397	1299236058000	23462	11539	55	0	\N
179898	1397	1299226057000	23462	11539	56	0	\N
179899	2133	93596630000	23462	11539	57	0	\N
179900	2133	93595628000	23462	11539	58	0	\N
179901	2134	86354355000	23462	11539	59	0	\N
179902	2132	147785787000	23462	11539	60	0	\N
179903	2132	147784786000	23462	11539	61	0	\N
179904	2132	147783785000	23462	11539	62	0	\N
179905	2134	86353352000	23462	11539	63	0	\N
179906	2132	147782784000	23462	11539	64	0	\N
179907	112	66000012832720	23462	11539	65	0	\N
179908	112	66000001832720	23462	11539	66	0	\N
179909	2134	86352349000	23462	11539	67	0	\N
179910	2134	86351346000	23462	11539	68	0	\N
179911	2132	147781783000	23462	11539	69	0	\N
179912	2134	86350343000	23462	11539	70	0	\N
179913	2134	86349340000	23462	11539	71	0	\N
179914	2134	86348337000	23462	11539	72	0	\N
179915	2134	86347334000	23462	11539	73	0	\N
179916	2134	86346331000	23462	11539	74	0	\N
179917	2134	86345328000	23462	11539	75	0	\N
179918	2134	86344325000	23462	11539	76	0	\N
179919	2134	86343322000	23462	11539	77	0	\N
179920	2134	86342319000	23462	11539	78	0	\N
179921	2134	86341316000	23462	11539	79	0	\N
179922	2134	86340313000	23462	11539	80	0	\N
179923	2134	86339310000	23462	11539	81	0	\N
179924	2134	86338307000	23462	11539	82	0	\N
179925	2134	86337304000	23462	11539	83	0	\N
179926	2134	86336301000	23462	11539	84	0	\N
179927	2134	86335298000	23462	11539	85	0	\N
179928	2134	86334295000	23462	11539	86	0	\N
179826	2134	86175821000	23455	11696	2	0	4401
179827	1397	1299226057000	23456	11697	0	0	13960
179828	2133	93595628000	23456	11697	1	0	4187
179829	2134	86174818000	23456	11697	2	0	4402
179929	2134	86333292000	23462	11539	87	0	\N
179930	2134	86332289000	23462	11539	88	0	\N
179931	2134	86331286000	23462	11539	89	0	\N
179932	2134	86330283000	23462	11539	90	0	\N
179933	2134	86329280000	23462	11539	91	0	\N
179934	2134	86328277000	23462	11539	92	0	\N
179935	2134	86327274000	23462	11539	93	0	\N
179936	2134	86326271000	23462	11539	94	0	\N
179937	2134	86325268000	23462	11539	95	0	\N
179938	2134	86324265000	23462	11539	96	0	\N
179939	2134	86323262000	23462	11539	97	0	\N
179940	2134	86322259000	23462	11539	98	0	\N
179941	2134	86321256000	23462	11539	99	0	\N
179942	2134	86320253000	23462	11539	100	0	\N
179943	2134	86319250000	23462	11539	101	0	\N
179944	2134	86318247000	23462	11539	102	0	\N
179945	2134	86317244000	23462	11539	103	0	\N
179946	2134	86316241000	23462	11539	104	0	\N
179947	2134	86315238000	23462	11539	105	0	\N
179948	2134	86314235000	23462	11539	106	0	\N
179949	2134	86313232000	23462	11539	107	0	\N
179950	2134	86312229000	23462	11539	110	0	\N
179951	2134	86311226000	23462	11539	111	0	\N
179952	2134	86310223000	23462	11539	112	0	\N
179953	2134	86309220000	23462	11539	113	0	\N
179973	1397	1299166051000	23466	11700	0	0	\N
179974	2132	147776778000	23466	11700	1	0	\N
179975	2133	93589616000	23466	11700	2	0	\N
179976	2134	86168800000	23466	11700	3	0	\N
179977	1397	1299156050000	23467	11701	0	0	\N
179978	2133	93588614000	23467	11701	1	0	\N
179979	2134	86167797000	23467	11701	2	0	\N
179990	1397	1299136048000	23471	11703	0	0	\N
179991	2134	86165791000	23471	11703	1	0	\N
179992	2133	93586610000	23471	11703	2	0	\N
179993	2132	147775777000	23471	11703	3	0	\N
179994	1397	1299136048000	23472	11703	0	0	\N
179995	2134	86165791000	23472	11703	1	0	\N
179996	2133	93586610000	23472	11703	2	0	\N
179997	2132	147775777000	23472	11703	3	0	\N
180004	1397	1299116046000	23475	11705	0	0	\N
180005	2133	93584606000	23475	11705	1	0	\N
180006	2134	86163785000	23475	11705	2	0	\N
180007	1397	1299116046000	23476	11705	0	0	\N
180008	2133	93584606000	23476	11705	1	0	\N
180009	2134	86163785000	23476	11705	2	0	\N
180010	1397	1299116046000	23477	11705	0	0	\N
180011	2133	93584606000	23477	11705	1	0	\N
180012	2134	86163785000	23477	11705	2	0	\N
180013	112	66000001832720	23479	11552	0	0	\N
180027	1397	1299066041000	23482	11709	0	0	\N
180028	2132	147773775000	23482	11709	1	0	\N
180029	2133	93579596000	23482	11709	2	0	\N
180039	1397	1299056040000	23485	11710	0	0	\N
180040	1397	1299046039000	23485	11710	1	0	\N
180041	2133	93578594000	23485	11710	2	0	\N
180042	2133	93577592000	23485	11710	3	0	\N
180043	2134	86158770000	23485	11710	4	0	\N
180044	2134	86157767000	23485	11710	5	0	\N
180049	1397	1299026037000	23490	11712	0	0	\N
180050	2133	93575588000	23490	11712	1	0	\N
180051	2134	86155761000	23490	11712	2	0	\N
180052	1397	1299026037000	23491	11712	0	0	\N
180053	2133	93575588000	23491	11712	1	0	\N
180054	2134	86155761000	23491	11712	2	0	\N
180064	1397	1299016036000	23494	11713	0	0	\N
179956	1397	1299196054000	23463	11698	2	0	13963
179957	2134	86173815000	23463	11698	3	0	4403
179958	2134	86172812000	23463	11698	4	0	4404
179959	2133	93594626000	23463	11698	5	0	4188
179960	2133	93593624000	23463	11698	6	0	4189
179962	2133	93592622000	23463	11698	8	0	4190
179963	1397	1299186053000	23464	11699	0	0	13964
179964	1397	1299176052000	23464	11699	1	0	13965
179965	2134	86170806000	23464	11699	2	0	4406
179966	2134	86169803000	23464	11699	3	0	4407
179968	2133	93590618000	23464	11699	5	0	4192
179969	1397	1299166051000	23465	11700	0	0	13966
179970	2132	147776778000	23465	11700	1	0	1222
179971	2133	93589616000	23465	11700	2	0	4193
179980	1397	1299156050000	23468	11701	0	0	13967
179981	2133	93588614000	23468	11701	1	0	4194
179982	2134	86167797000	23468	11701	2	0	4409
179983	1397	1299146049000	23469	11702	0	0	13968
179984	2134	86166794000	23469	11702	1	0	4410
179986	1397	1299136048000	23470	11703	0	0	13969
179987	2134	86165791000	23470	11703	1	0	4411
179988	2133	93586610000	23470	11703	2	0	4196
179989	2132	147775777000	23470	11703	3	0	1223
179998	1397	1299126047000	23473	11704	0	0	13970
180000	2134	86164788000	23473	11704	2	0	4412
180001	1397	1299116046000	23474	11705	0	0	13971
180002	2133	93584606000	23474	11705	1	0	4198
180003	2134	86163785000	23474	11705	2	0	4413
180015	1397	1299096044000	23480	11707	1	0	13973
180016	1397	1299086043000	23480	11707	2	0	13974
180017	2134	86162782000	23480	11707	3	0	4414
180018	2134	86161779000	23480	11707	4	0	4415
180019	2132	147774776000	23480	11707	5	0	1224
180021	2133	93582602000	23480	11707	7	0	4200
180022	2134	86160776000	23480	11707	8	0	4416
180023	2133	93581600000	23480	11707	9	0	4201
180024	1397	1299076042000	23481	11708	0	0	13975
180025	2133	93580598000	23481	11708	1	0	4202
180030	1397	1299066041000	23483	11709	0	0	13976
180031	2132	147773775000	23483	11709	1	0	1225
180032	2133	93579596000	23483	11709	2	0	4203
180033	1397	1299056040000	23484	11710	0	0	13977
180035	2133	93578594000	23484	11710	2	0	4204
180036	2133	93577592000	23484	11710	3	0	4205
180037	2134	86158770000	23484	11710	4	0	4418
180038	2134	86157767000	23484	11710	5	0	4419
180045	1397	1299036038000	23487	11711	0	0	13979
180047	2134	86156764000	23487	11711	2	0	4420
180048	2132	147772774000	23487	11711	3	0	1226
180055	1397	1299026037000	23492	11712	0	0	13980
180056	2133	93575588000	23492	11712	1	0	4207
180057	2134	86155761000	23492	11712	2	0	4421
180059	1397	1299006035000	23493	11713	1	0	13982
180060	2133	93574586000	23493	11713	2	0	4208
180061	2134	86154758000	23493	11713	3	0	4422
180062	2134	86153755000	23493	11713	4	0	4423
180065	1397	1299006035000	23494	11713	1	0	\N
180066	2133	93574586000	23494	11713	2	0	\N
180067	2134	86154758000	23494	11713	3	0	\N
180068	2134	86153755000	23494	11713	4	0	\N
180069	2133	93573584000	23494	11713	5	0	\N
180070	1397	1298996034000	23495	11714	0	0	\N
180071	2133	93572582000	23495	11714	1	0	\N
180072	2134	86152752000	23495	11714	2	0	\N
180073	2132	147771773000	23495	11714	3	0	\N
180074	1397	1298996034000	23496	11714	0	0	\N
180075	2133	93572582000	23496	11714	1	0	\N
180076	2134	86152752000	23496	11714	2	0	\N
180077	2132	147771773000	23496	11714	3	0	\N
180078	1397	1298996034000	23497	11714	0	0	\N
180079	2133	93572582000	23497	11714	1	0	\N
180080	2134	86152752000	23497	11714	2	0	\N
180081	2132	147771773000	23497	11714	3	0	\N
180086	112	66000001832720	23499	11571	0	0	\N
180087	2133	93596630000	23499	11571	1	0	\N
180088	2133	93595628000	23499	11571	2	0	\N
180089	2133	93594626000	23499	11571	3	0	\N
180090	2133	93593624000	23499	11571	4	0	\N
180091	2133	93592622000	23499	11571	5	0	\N
180092	2133	93591620000	23499	11571	6	0	\N
180093	2133	93590618000	23499	11571	7	0	\N
180094	2133	93589616000	23499	11571	8	0	\N
180095	2133	93588614000	23499	11571	9	0	\N
180096	2133	93587612000	23499	11571	10	0	\N
180097	2133	93586610000	23499	11571	11	0	\N
180098	2133	93585608000	23499	11571	12	0	\N
180099	2133	93584606000	23499	11571	13	0	\N
180100	2133	93583604000	23499	11571	14	0	\N
180101	2133	93582602000	23499	11571	15	0	\N
180102	2133	93581600000	23499	11571	16	0	\N
180106	1397	1298976032000	23502	11716	0	0	\N
180107	1397	1298966031000	23502	11716	1	0	\N
180108	2132	147770772000	23502	11716	2	0	\N
180109	2134	86150746000	23502	11716	3	0	\N
180110	2133	93570578000	23502	11716	4	0	\N
180111	2133	93569576000	23502	11716	5	0	\N
180112	2134	86149743000	23502	11716	6	0	\N
180123	1397	1298956030000	23505	11717	0	0	\N
180124	2133	93568574000	23505	11717	1	0	\N
180125	2134	86148740000	23505	11717	2	0	\N
180126	1397	1298956030000	23506	11717	0	0	\N
180127	2133	93568574000	23506	11717	1	0	\N
180128	2134	86148740000	23506	11717	2	0	\N
180129	1397	1298956030000	23507	11717	0	0	\N
180130	2133	93568574000	23507	11717	1	0	\N
180131	2134	86148740000	23507	11717	2	0	\N
180135	1397	1298946029000	23509	11718	0	0	\N
180136	2133	93567572000	23509	11718	1	0	\N
180137	2134	86147737000	23509	11718	2	0	\N
180138	1397	1298936028000	23510	11719	0	0	\N
180139	2133	93566570000	23510	11719	1	0	\N
180140	2132	147769771000	23510	11719	2	0	\N
180141	2134	86146734000	23510	11719	3	0	\N
180146	1397	1298936028000	23512	11719	0	0	\N
180147	2133	93566570000	23512	11719	1	0	\N
180148	2132	147769771000	23512	11719	2	0	\N
180149	2134	86146734000	23512	11719	3	0	\N
180151	1397	1298926027000	23514	11721	0	0	\N
180152	2134	86144728000	23514	11721	1	0	\N
180153	2133	93565568000	23514	11721	2	0	\N
180154	2133	93564566000	23514	11721	3	0	\N
180155	1397	1298926027000	23515	11721	0	0	\N
180156	2134	86144728000	23515	11721	1	0	\N
180157	2133	93565568000	23515	11721	2	0	\N
180158	2133	93564566000	23515	11721	3	0	\N
180161	1397	1298916026000	23517	11722	0	0	\N
180162	2133	93564566000	23517	11722	1	0	\N
180163	2134	86144728000	23517	11722	2	0	\N
180164	2134	86143725000	23517	11722	3	0	\N
180165	2133	93563564000	23517	11722	4	0	\N
180167	1397	1298906025000	23519	11723	0	0	\N
180168	2133	93564566000	23519	11723	1	0	\N
180169	2134	86144728000	23519	11723	2	0	\N
180170	2134	86143725000	23519	11723	3	0	\N
180171	2132	147768770000	23519	11723	4	0	\N
180172	2133	93563564000	23519	11723	5	0	\N
180173	2133	93562562000	23519	11723	6	0	\N
180174	2134	86142722000	23519	11723	7	0	\N
180193	1397	1298896024000	23522	11724	0	0	\N
180194	1397	1298886023000	23522	11724	1	0	\N
180195	1397	1298876022000	23522	11724	2	0	\N
180196	2134	86141719000	23522	11724	3	0	\N
180197	2134	86140716000	23522	11724	4	0	\N
180198	2134	86139713000	23522	11724	5	0	\N
180199	2133	93561560000	23522	11724	6	0	\N
180200	2133	93560558000	23522	11724	7	0	\N
180084	2134	86152752000	23498	11714	2	0	4424
180085	2132	147771773000	23498	11714	3	0	1227
180103	1397	1298986033000	23501	11715	0	0	13984
180104	2133	93571580000	23501	11715	1	0	4211
180105	2134	86151749000	23501	11715	2	0	4425
180114	1397	1298966031000	23503	11716	1	0	13986
180115	2132	147770772000	23503	11716	2	0	1228
180116	2134	86150746000	23503	11716	3	0	4426
180117	2133	93570578000	23503	11716	4	0	4212
180118	2133	93569576000	23503	11716	5	0	4213
180120	1397	1298956030000	23504	11717	0	0	13987
180121	2133	93568574000	23504	11717	1	0	4214
180122	2134	86148740000	23504	11717	2	0	4428
180132	1397	1298946029000	23508	11718	0	0	13988
180134	2134	86147737000	23508	11718	2	0	4429
180142	1397	1298936028000	23511	11719	0	0	13989
180143	2133	93566570000	23511	11719	1	0	4216
180144	2132	147769771000	23511	11719	2	0	1229
180145	2134	86146734000	23511	11719	3	0	4430
180159	1397	1298926027000	23516	11721	0	0	13990
180160	2133	93565568000	23516	11721	1	0	4217
180166	1397	1298916026000	23518	11722	0	0	13991
180175	1397	1298906025000	23520	11723	0	0	13992
180176	2133	93564566000	23520	11723	1	0	4218
180178	2134	86143725000	23520	11723	3	0	4433
180179	2132	147768770000	23520	11723	4	0	1230
180180	2133	93563564000	23520	11723	5	0	4219
180181	2133	93562562000	23520	11723	6	0	4220
180183	1397	1298896024000	23521	11724	0	0	13993
180184	1397	1298886023000	23521	11724	1	0	13994
180185	1397	1298876022000	23521	11724	2	0	13995
180186	2134	86141719000	23521	11724	3	0	4435
180187	2134	86140716000	23521	11724	4	0	4436
180189	2133	93561560000	23521	11724	6	0	4221
180190	2133	93560558000	23521	11724	7	0	4222
180191	2133	93559556000	23521	11724	8	0	4223
180192	2132	147767769000	23521	11724	9	0	1231
180201	2133	93559556000	23522	11724	8	0	\N
180202	2132	147767769000	23522	11724	9	0	\N
180203	112	66000001832720	23523	11653	0	0	\N
180204	1397	1299846119000	23523	11653	1	0	\N
180205	1397	1299836118000	23523	11653	2	0	\N
180206	1397	1299826117000	23523	11653	3	0	\N
180207	1397	1299816116000	23523	11653	4	0	\N
180208	1397	1299806115000	23523	11653	5	0	\N
180209	1397	1299796114000	23523	11653	6	0	\N
180210	1397	1299786113000	23523	11653	7	0	\N
180211	1397	1299776112000	23523	11653	8	0	\N
180212	1397	1299766111000	23523	11653	9	0	\N
180213	1397	1299756110000	23523	11653	10	0	\N
180214	1397	1299746109000	23523	11653	11	0	\N
180215	1397	1299736108000	23523	11653	12	0	\N
180216	1397	1299726107000	23523	11653	13	0	\N
180217	1397	1299716106000	23523	11653	14	0	\N
180218	1397	1299706105000	23523	11653	16	0	\N
180219	1397	1299696104000	23523	11653	17	0	\N
180220	1397	1299686103000	23523	11653	18	0	\N
180221	1397	1299676102000	23523	11653	19	0	\N
180222	1397	1299666101000	23523	11653	20	0	\N
180223	1397	1299656100000	23523	11653	21	0	\N
180224	1397	1299646099000	23523	11653	22	0	\N
180225	1397	1299636098000	23523	11653	23	0	\N
180226	1397	1299626097000	23523	11653	24	0	\N
180227	1397	1299616096000	23523	11653	25	0	\N
180228	1397	1299606095000	23523	11653	26	0	\N
180229	1397	1299596094000	23523	11653	27	0	\N
180230	1397	1299586093000	23523	11653	28	0	\N
180231	1397	1299576092000	23523	11653	29	0	\N
180232	1397	1299566091000	23523	11653	30	0	\N
180233	1397	1299556090000	23523	11653	31	0	\N
180234	1397	1299546089000	23523	11653	32	0	\N
180235	1397	1299536088000	23523	11653	33	0	\N
180236	1397	1299526087000	23523	11653	34	0	\N
180237	1397	1299516086000	23523	11653	35	0	\N
180238	1397	1299506085000	23523	11653	36	0	\N
180239	1397	1299496084000	23523	11653	37	0	\N
180240	1397	1299486083000	23523	11653	38	0	\N
180241	1397	1299476082000	23523	11653	39	0	\N
180242	1397	1299466081000	23523	11653	40	0	\N
180243	1397	1299456080000	23523	11653	41	0	\N
180244	1397	1299446079000	23523	11653	42	0	\N
180245	1397	1299436078000	23523	11653	43	0	\N
180246	1397	1299426077000	23523	11653	44	0	\N
180247	1397	1299416076000	23523	11653	45	0	\N
180248	1397	1299406075000	23523	11653	46	0	\N
180249	1397	1299396074000	23523	11653	47	0	\N
180250	1397	1299386073000	23523	11653	48	0	\N
180251	1397	1299376072000	23523	11653	49	0	\N
180252	1397	1299366071000	23523	11653	50	0	\N
180253	1397	1299356070000	23523	11653	51	0	\N
180254	1397	1299346069000	23523	11653	52	0	\N
180255	1397	1299336068000	23523	11653	53	0	\N
180256	1397	1299326067000	23523	11653	54	0	\N
180257	1397	1299316066000	23523	11653	55	0	\N
180258	1397	1299306065000	23523	11653	56	0	\N
180259	1397	1299296064000	23523	11653	57	0	\N
180260	1397	1299286063000	23523	11653	58	0	\N
180261	1397	1299276062000	23523	11653	59	0	\N
180262	1397	1299266061000	23523	11653	60	0	\N
180263	1397	1299256060000	23523	11653	61	0	\N
180285	1397	1298846019000	23529	11728	0	0	\N
180286	1397	1298836018000	23529	11728	1	0	\N
180287	1397	1298826017000	23529	11728	2	0	\N
180288	1448	10667836000001	23529	11728	3	0	\N
180289	1448	7783826000001	23529	11728	4	0	\N
180290	1448	5837816000001	23529	11728	5	0	\N
180291	1448	416806000001	23529	11728	6	0	\N
180292	1448	204796000001	23529	11728	7	0	\N
180293	2134	86136704000	23529	11728	8	0	\N
180294	2133	93556550000	23529	11728	9	0	\N
180295	2133	93555548000	23529	11728	10	0	\N
180296	2133	93554546000	23529	11728	11	0	\N
180297	2134	86135701000	23529	11728	12	0	\N
180298	2134	86134698000	23529	11728	13	0	\N
180299	2132	147766768000	23529	11728	14	0	\N
180307	1397	1298806015000	23532	11730	0	0	\N
180308	2134	86132692000	23532	11730	1	0	\N
180309	2133	93552542000	23532	11730	2	0	\N
180310	2132	147765767000	23532	11730	3	0	\N
180314	1397	1298796014000	23534	11731	0	0	\N
180315	2133	93551540000	23534	11731	1	0	\N
180316	2134	86131689000	23534	11731	2	0	\N
180317	1448	10667836000001	23535	11553	0	0	\N
180318	1448	7783826000001	23535	11553	1	0	\N
180319	1448	5837816000001	23535	11553	2	0	\N
180320	1448	416806000001	23535	11553	3	0	\N
180321	1448	204796000001	23535	11553	4	0	\N
180322	1448	188786000001	23535	11553	5	0	\N
180323	1448	172776000001	23535	11553	6	0	\N
180333	1397	1298766011000	23537	11733	0	0	\N
180334	1397	1298756010000	23537	11733	1	0	\N
180335	1397	1298746009000	23537	11733	2	0	\N
180336	2132	147763765000	23537	11733	3	0	\N
180266	2134	86138710000	23524	11725	2	0	4438
180267	1397	1298856020000	23525	11726	0	0	13997
180268	2133	93557552000	23525	11726	1	0	4225
180269	2134	86137707000	23525	11726	2	0	4439
180270	1397	1298846019000	23528	11728	0	0	13998
180272	1397	1298826017000	23528	11728	2	0	14000
180273	1448	10667836000001	23528	11728	3	0	9
180274	1448	7783826000001	23528	11728	4	0	10
180275	1448	5837816000001	23528	11728	5	0	11
180276	1448	416806000001	23528	11728	6	0	12
180278	2134	86136704000	23528	11728	8	0	4440
180279	2133	93556550000	23528	11728	9	0	4226
180280	2133	93555548000	23528	11728	10	0	4227
180281	2133	93554546000	23528	11728	11	0	4228
180283	2134	86134698000	23528	11728	13	0	4442
180284	2132	147766768000	23528	11728	14	0	1232
180300	1397	1298816016000	23530	11729	0	0	14001
180301	2134	86133695000	23530	11729	1	0	4443
180302	2133	93553544000	23530	11729	2	0	4229
180304	2134	86132692000	23531	11730	1	0	4444
180305	2133	93552542000	23531	11730	2	0	4230
180306	2132	147765767000	23531	11730	3	0	1233
180311	1397	1298796014000	23533	11731	0	0	14003
180312	2133	93551540000	23533	11731	1	0	4231
180324	1397	1298786013000	23536	11732	0	0	14004
180325	1448	188786000001	23536	11732	1	0	14
180326	1448	172776000001	23536	11732	2	0	15
180327	1397	1298776012000	23536	11732	3	0	14005
180329	2133	93550538000	23536	11732	5	0	4232
180330	2133	93549536000	23536	11732	6	0	4233
180331	2134	86130686000	23536	11732	7	0	4446
180332	2134	86129683000	23536	11732	8	0	4447
180337	2133	93548534000	23537	11733	4	0	\N
180338	2133	93547532000	23537	11733	5	0	\N
180339	2133	93546530000	23537	11733	6	0	\N
180340	2134	86128680000	23537	11733	7	0	\N
180341	2134	86127677000	23537	11733	8	0	\N
180342	2134	86126674000	23537	11733	9	0	\N
180353	1397	1298736008000	23539	11734	0	0	\N
180354	2134	86125671000	23539	11734	1	0	\N
180355	2133	93545528000	23539	11734	2	0	\N
180356	1397	1298736008000	23540	11734	0	0	\N
180357	2134	86125671000	23540	11734	1	0	\N
180358	2133	93545528000	23540	11734	2	0	\N
180362	1397	1298736008000	23542	11734	0	0	\N
180363	2134	86125671000	23542	11734	1	0	\N
180374	1397	1298696004000	23546	11738	0	0	\N
180375	2133	93541520000	23546	11738	1	0	\N
180376	2134	86121659000	23546	11738	2	0	\N
180380	1397	1298696004000	23548	11738	0	0	\N
180381	2133	93541520000	23548	11738	1	0	\N
180382	2134	86121659000	23548	11738	2	0	\N
180383	1397	1298686003000	23549	11739	0	0	\N
180384	1397	1298676002000	23549	11739	1	0	\N
180385	2132	147761763000	23549	11739	2	0	\N
180386	2133	93540518000	23549	11739	3	0	\N
180387	2133	93539516000	23549	11739	4	0	\N
180388	2134	86120656000	23549	11739	5	0	\N
180389	2134	86119653000	23549	11739	6	0	\N
180390	1397	1298686003000	23551	11739	0	0	\N
180391	1397	1298676002000	23551	11739	1	0	\N
180392	2132	147761763000	23551	11739	2	0	\N
180393	2133	93540518000	23551	11739	3	0	\N
180394	2133	93539516000	23551	11739	4	0	\N
180395	2134	86120656000	23551	11739	5	0	\N
180396	2134	86119653000	23551	11739	6	0	\N
180404	1397	1298666001000	23553	11740	0	0	\N
180405	1397	1298656000000	23553	11740	1	0	\N
180406	2134	86118650000	23553	11740	2	0	\N
180407	2133	93538514000	23553	11740	3	0	\N
180408	2133	93537512000	23553	11740	4	0	\N
180409	2134	86117647000	23553	11740	5	0	\N
180416	1397	1298666001000	23555	11740	0	0	\N
180417	1397	1298656000000	23555	11740	1	0	\N
180418	2134	86118650000	23555	11740	2	0	\N
180419	2133	93538514000	23555	11740	3	0	\N
180420	2133	93537512000	23555	11740	4	0	\N
180421	2134	86117647000	23555	11740	5	0	\N
180422	1397	1298645999000	23556	11741	0	0	\N
180423	2134	86116644000	23556	11741	1	0	\N
180424	2132	147760762000	23556	11741	2	0	\N
180425	2134	86115641000	23556	11741	3	0	\N
180426	2133	93536510000	23556	11741	4	0	\N
180427	2133	93535508000	23556	11741	5	0	\N
180428	1397	1298645999000	23557	11741	0	0	\N
180429	2134	86116644000	23557	11741	1	0	\N
180430	2132	147760762000	23557	11741	2	0	\N
180431	2134	86115641000	23557	11741	3	0	\N
180432	2133	93536510000	23557	11741	4	0	\N
180433	2133	93535508000	23557	11741	5	0	\N
180440	1397	1298645999000	23559	11741	0	0	\N
180441	2134	86116644000	23559	11741	1	0	\N
180442	2132	147760762000	23559	11741	2	0	\N
180443	2134	86115641000	23559	11741	3	0	\N
180444	2133	93536510000	23559	11741	4	0	\N
180445	2133	93535508000	23559	11741	5	0	\N
180456	1397	1298615996000	23562	11743	0	0	\N
180457	2132	147759761000	23562	11743	1	0	\N
180458	2133	93532502000	23562	11743	2	0	\N
180459	2134	86112632000	23562	11743	3	0	\N
180460	2106	5759098000000	23563	11744	0	0	\N
180461	1397	1298605995000	23563	11744	1	0	\N
180462	2133	93531500000	23563	11744	2	0	\N
180463	2134	86111629000	23563	11744	3	0	\N
180464	2106	5759098000000	23564	11744	0	0	\N
180465	1397	1298605995000	23564	11744	1	0	\N
180466	2133	93531500000	23564	11744	2	0	\N
180467	2134	86111629000	23564	11744	3	0	\N
180472	1397	1298595994000	23567	11745	0	0	\N
180345	1397	1298746009000	23538	11733	2	0	14008
180346	2132	147763765000	23538	11733	3	0	1235
180347	2133	93548534000	23538	11733	4	0	4234
180348	2133	93547532000	23538	11733	5	0	4235
180349	2133	93546530000	23538	11733	6	0	4236
180351	2134	86127677000	23538	11733	8	0	4449
180352	2134	86126674000	23538	11733	9	0	4450
180359	1397	1298736008000	23541	11734	0	0	14009
180360	2134	86125671000	23541	11734	1	0	4451
180361	2133	93545528000	23541	11734	2	0	4237
180365	2134	86124668000	23543	11735	1	0	4452
180366	2133	93544526000	23543	11735	2	0	4238
180367	1397	1298716006000	23544	11736	0	0	14011
180368	2134	86123665000	23544	11736	1	0	4453
180370	1397	1298706005000	23545	11737	0	0	14012
180371	2133	93542522000	23545	11737	1	0	4240
180372	2134	86122662000	23545	11737	2	0	4454
180373	2132	147762764000	23545	11737	3	0	1236
180377	1397	1298696004000	23547	11738	0	0	14013
180379	2134	86121659000	23547	11738	2	0	4455
180397	1397	1298686003000	23552	11739	0	0	14014
180398	1397	1298676002000	23552	11739	1	0	14015
180399	2132	147761763000	23552	11739	2	0	1237
180400	2133	93540518000	23552	11739	3	0	4242
180402	2134	86120656000	23552	11739	5	0	4456
180403	2134	86119653000	23552	11739	6	0	4457
180410	1397	1298666001000	23554	11740	0	0	14016
180411	1397	1298656000000	23554	11740	1	0	14017
180413	2133	93538514000	23554	11740	3	0	4244
180414	2133	93537512000	23554	11740	4	0	4245
180415	2134	86117647000	23554	11740	5	0	4459
180434	1397	1298645999000	23558	11741	0	0	14018
180435	2134	86116644000	23558	11741	1	0	4460
180437	2134	86115641000	23558	11741	3	0	4461
180438	2133	93536510000	23558	11741	4	0	4246
180439	2133	93535508000	23558	11741	5	0	4247
180446	1397	1298635998000	23560	11742	0	0	14019
180447	1397	1298625997000	23560	11742	1	0	14020
180449	2133	93534506000	23560	11742	3	0	4248
180450	2133	93533504000	23560	11742	4	0	4249
180451	2134	86113635000	23560	11742	5	0	4463
180452	1397	1298615996000	23561	11743	0	0	14021
180454	2133	93532502000	23561	11743	2	0	4250
180455	2134	86112632000	23561	11743	3	0	4464
180468	2106	5759098000000	23565	11744	0	0	1
180469	1397	1298605995000	23565	11744	1	0	14022
180470	2133	93531500000	23565	11744	2	0	4251
180473	1397	1298585993000	23567	11745	1	0	\N
180474	2133	93530498000	23567	11745	2	0	\N
180475	2132	147758760000	23567	11745	3	0	\N
180476	2133	93529496000	23567	11745	4	0	\N
180477	2134	86110626000	23567	11745	5	0	\N
180488	1397	1298575992000	23570	11746	0	0	\N
180489	2106	88000000	23570	11746	1	0	\N
180490	2133	93528494000	23570	11746	2	0	\N
180491	2134	86109623000	23570	11746	3	0	\N
180495	1397	1298565991000	23572	11747	0	0	\N
180496	2133	93527492000	23572	11747	1	0	\N
180497	2134	86108620000	23572	11747	2	0	\N
180498	1397	1298565991000	23573	11747	0	0	\N
180499	2133	93527492000	23573	11747	1	0	\N
180500	2134	86108620000	23573	11747	2	0	\N
180501	1397	1298555990000	23574	11748	0	0	\N
180502	2134	86107617000	23574	11748	1	0	\N
180503	2132	147757759000	23574	11748	2	0	\N
180504	2133	93526490000	23574	11748	3	0	\N
180505	1397	1298555990000	23575	11748	0	0	\N
180506	2134	86107617000	23575	11748	1	0	\N
180507	2132	147757759000	23575	11748	2	0	\N
180508	2133	93526490000	23575	11748	3	0	\N
180513	1397	1298555990000	23577	11748	0	0	\N
180514	2132	147757759000	23577	11748	1	0	\N
180515	2133	93526490000	23577	11748	2	0	\N
180523	1448	5719776000001	23580	11750	0	0	\N
180524	1397	1298535988000	23580	11750	1	0	\N
180525	2133	93524486000	23580	11750	2	0	\N
180526	2134	86105611000	23580	11750	3	0	\N
180530	1397	1298515986000	23582	11752	0	0	\N
180531	2132	147756758000	23582	11752	1	0	\N
180532	2133	93522482000	23582	11752	2	0	\N
180533	2134	86103605000	23582	11752	3	0	\N
180538	1397	1298515986000	23584	11752	0	0	\N
180539	2132	147756758000	23584	11752	1	0	\N
180540	2133	93522482000	23584	11752	2	0	\N
180541	2134	86103605000	23584	11752	3	0	\N
180542	1397	1298515986000	23585	11752	0	0	\N
180543	2132	147756758000	23585	11752	1	0	\N
180544	2133	93522482000	23585	11752	2	0	\N
180545	2134	86103605000	23585	11752	3	0	\N
180549	1397	1298505985000	23587	11753	0	0	\N
180550	2133	93521480000	23587	11753	1	0	\N
180551	2134	86102602000	23587	11753	2	0	\N
180555	1397	1298485983000	23589	11755	0	0	\N
180556	2132	147755757000	23589	11755	1	0	\N
180557	2133	93519476000	23589	11755	2	0	\N
180558	2134	86100596000	23589	11755	3	0	\N
180563	1397	1298475982000	23591	11756	0	0	\N
180564	1397	1298465981000	23591	11756	1	0	\N
180565	2134	86099593000	23591	11756	2	0	\N
180566	2133	93518474000	23591	11756	3	0	\N
180567	2133	93517472000	23591	11756	4	0	\N
180568	2134	86098590000	23591	11756	5	0	\N
180575	1397	1298475982000	23593	11756	0	0	\N
180576	1397	1298465981000	23593	11756	1	0	\N
180577	2134	86099593000	23593	11756	2	0	\N
180578	2133	93518474000	23593	11756	3	0	\N
180579	2133	93517472000	23593	11756	4	0	\N
180580	2134	86098590000	23593	11756	5	0	\N
180581	1397	1298475982000	23594	11756	0	0	\N
180582	1397	1298465981000	23594	11756	1	0	\N
180583	2134	86099593000	23594	11756	2	0	\N
180584	2133	93518474000	23594	11756	3	0	\N
180585	2133	93517472000	23594	11756	4	0	\N
180586	2134	86098590000	23594	11756	5	0	\N
180587	1397	1298495984000	23595	11754	0	0	\N
180588	1397	1298485983000	23595	11754	1	0	\N
180589	1397	1298475982000	23595	11754	2	0	\N
180590	1397	1298465981000	23595	11754	3	0	\N
180591	2133	93520478000	23595	11754	4	0	\N
180592	2132	147755757000	23595	11754	5	0	\N
180593	2134	86101599000	23595	11754	6	0	\N
180594	2133	93519476000	23595	11754	7	0	\N
180595	2133	93518474000	23595	11754	8	0	\N
180596	2133	93517472000	23595	11754	9	0	\N
180597	2134	86100596000	23595	11754	10	0	\N
180598	2134	86099593000	23595	11754	11	0	\N
180599	2134	86098590000	23595	11754	12	0	\N
180607	1397	1298435978000	23597	11758	0	0	\N
180608	2134	86095581000	23597	11758	1	0	\N
180480	2133	93530498000	23568	11745	2	0	4252
180481	2132	147758760000	23568	11745	3	0	1240
180482	2133	93529496000	23568	11745	4	0	4253
180483	2134	86110626000	23568	11745	5	0	4466
180484	1397	1298575992000	23569	11746	0	0	14025
180486	2133	93528494000	23569	11746	2	0	4254
180487	2134	86109623000	23569	11746	3	0	4467
180492	1397	1298565991000	23571	11747	0	0	14026
180493	2133	93527492000	23571	11747	1	0	4255
180494	2134	86108620000	23571	11747	2	0	4468
180510	2134	86107617000	23576	11748	1	0	4469
180511	2132	147757759000	23576	11748	2	0	1241
180512	2133	93526490000	23576	11748	3	0	4256
180516	1397	1298545989000	23578	11749	0	0	14028
180518	2134	86106614000	23578	11749	2	0	4470
180519	1448	5719776000001	23579	11750	0	0	16
180520	1397	1298535988000	23579	11750	1	0	14029
180521	2133	93524486000	23579	11750	2	0	4258
180522	2134	86105611000	23579	11750	3	0	4471
180528	2133	93523484000	23581	11751	1	0	4259
180529	2134	86104608000	23581	11751	2	0	4472
180534	1397	1298515986000	23583	11752	0	0	14031
180535	2132	147756758000	23583	11752	1	0	1242
180536	2133	93522482000	23583	11752	2	0	4260
180546	1397	1298505985000	23586	11753	0	0	14032
180547	2133	93521480000	23586	11753	1	0	4261
180548	2134	86102602000	23586	11753	2	0	4474
180552	1397	1298495984000	23588	11754	0	0	14033
180554	2134	86101599000	23588	11754	2	0	4475
180559	1397	1298485983000	23590	11755	0	0	14034
180560	2132	147755757000	23590	11755	1	0	1243
180561	2133	93519476000	23590	11755	2	0	4263
180562	2134	86100596000	23590	11755	3	0	4476
180570	1397	1298465981000	23592	11756	1	0	14036
180571	2134	86099593000	23592	11756	2	0	4477
180572	2133	93518474000	23592	11756	3	0	4264
180573	2133	93517472000	23592	11756	4	0	4265
180574	2134	86098590000	23592	11756	5	0	4478
180601	1397	1298445979000	23596	11757	1	0	14038
180602	2132	147754756000	23596	11757	2	0	1244
180603	2134	86097587000	23596	11757	3	0	4479
180604	2134	86096584000	23596	11757	4	0	4480
180606	2133	93515468000	23596	11757	6	0	4267
180609	1397	1298525987000	23598	11751	0	0	\N
180610	1397	1298515986000	23598	11751	1	0	\N
180611	1397	1298505985000	23598	11751	2	0	\N
180612	1397	1298495984000	23598	11751	3	0	\N
180613	1397	1298485983000	23598	11751	4	0	\N
180614	1397	1298475982000	23598	11751	5	0	\N
180615	1397	1298465981000	23598	11751	6	0	\N
180616	1397	1298455980000	23598	11751	7	0	\N
180617	1397	1298445979000	23598	11751	8	0	\N
180618	1397	1298435978000	23598	11751	9	0	\N
180619	2133	93523484000	23598	11751	10	0	\N
180620	2132	147756758000	23598	11751	11	0	\N
180621	2134	86104608000	23598	11751	12	0	\N
180622	2133	93522482000	23598	11751	13	0	\N
180623	2133	93521480000	23598	11751	14	0	\N
180624	2133	93520478000	23598	11751	15	0	\N
180625	2132	147755757000	23598	11751	16	0	\N
180626	2132	147754756000	23598	11751	17	0	\N
180627	2134	86103605000	23598	11751	18	0	\N
180628	2134	86102602000	23598	11751	19	0	\N
180629	2134	86101599000	23598	11751	20	0	\N
180630	2133	93519476000	23598	11751	21	0	\N
180631	2133	93518474000	23598	11751	22	0	\N
180632	2133	93517472000	23598	11751	23	0	\N
180633	2133	93516470000	23598	11751	24	0	\N
180634	2133	93515468000	23598	11751	25	0	\N
180635	2134	86100596000	23598	11751	26	0	\N
180636	2134	86099593000	23598	11751	27	0	\N
180637	2134	86098590000	23598	11751	28	0	\N
180638	2134	86097587000	23598	11751	29	0	\N
180639	2134	86096584000	23598	11751	30	0	\N
180640	2134	86095581000	23598	11751	31	0	\N
180657	1571	8292062832307	23601	11759	0	0	\N
180658	1571	7837329766131	23601	11759	1	0	\N
180659	1571	7022459927607	23601	11759	2	0	\N
180660	1571	6472647757326	23601	11759	3	0	\N
180661	1571	4940565124154	23601	11759	4	0	\N
180662	1571	4940555124154	23601	11759	5	0	\N
180663	1397	1298425977000	23601	11759	6	0	\N
180664	1397	1298415976000	23601	11759	7	0	\N
180665	2133	93514466000	23601	11759	8	0	\N
180666	2134	86094578000	23601	11759	9	0	\N
180667	2132	147753755000	23601	11759	10	0	\N
180668	2133	93513464000	23601	11759	11	0	\N
180669	2133	93512462000	23601	11759	12	0	\N
180670	2134	86093575000	23601	11759	13	0	\N
180674	1397	1298405975000	23603	11760	0	0	\N
180675	2134	86092572000	23603	11760	1	0	\N
180676	2133	93511460000	23603	11760	2	0	\N
180677	1397	1298395974000	23604	11761	0	0	\N
180678	2133	93510458000	23604	11761	1	0	\N
180679	1397	1298395974000	23605	11761	0	0	\N
180680	2134	86091569000	23605	11761	1	0	\N
180681	2133	93510458000	23605	11761	2	0	\N
180685	2106	5039087000000	23607	11554	0	0	\N
180686	1571	7572049831979	23607	11554	1	0	\N
180687	1571	7117316765803	23607	11554	2	0	\N
180688	1571	6302446927279	23607	11554	3	0	\N
180689	1571	5752634756998	23607	11554	4	0	\N
180690	1571	4220552123826	23607	11554	5	0	\N
180691	1571	4220542123826	23607	11554	6	0	\N
180692	1397	1298395974000	23608	11761	0	0	\N
180693	2134	86091569000	23608	11761	1	0	\N
180694	2133	93510458000	23608	11761	2	0	\N
180695	1397	1298395974000	23609	11761	0	0	\N
180696	2134	86091569000	23609	11761	1	0	\N
180697	2133	93510458000	23609	11761	2	0	\N
180698	1397	1298395974000	23610	11761	0	0	\N
180699	2134	86091569000	23610	11761	1	0	\N
180700	2133	93510458000	23610	11761	2	0	\N
180714	1397	1298375972000	23613	11763	0	0	\N
180715	1397	1298365971000	23613	11763	1	0	\N
180716	1397	1298355970000	23613	11763	2	0	\N
180717	2133	93509456000	23613	11763	3	0	\N
180718	2133	93508454000	23613	11763	4	0	\N
180719	2133	93507452000	23613	11763	5	0	\N
180720	2134	86089563000	23613	11763	6	0	\N
180721	2134	86088560000	23613	11763	7	0	\N
180722	2132	147751753000	23613	11763	8	0	\N
180723	2134	86087557000	23613	11763	9	0	\N
180724	1397	1298345969000	23615	11765	0	0	\N
180725	1397	1298335968000	23615	11765	1	0	\N
180726	2134	86086554000	23615	11765	2	0	\N
180727	2133	93506450000	23615	11765	3	0	\N
180728	2133	93505448000	23615	11765	4	0	\N
180729	2134	86085551000	23615	11765	5	0	\N
180730	1397	1298345969000	23616	11765	0	0	\N
180731	1397	1298335968000	23616	11765	1	0	\N
180732	2134	86086554000	23616	11765	2	0	\N
180733	2133	93506450000	23616	11765	3	0	\N
180734	2133	93505448000	23616	11765	4	0	\N
180735	2134	86085551000	23616	11765	5	0	\N
180742	1397	1298325967000	23618	11766	0	0	\N
180743	2134	86084548000	23618	11766	1	0	\N
180744	2133	93504446000	23618	11766	2	0	\N
180643	1571	8292062832307	23600	11759	0	0	42
180644	1571	7837329766131	23600	11759	1	0	43
180645	1571	7022459927607	23600	11759	2	0	44
180646	1571	6472647757326	23600	11759	3	0	45
180647	1571	4940565124154	23600	11759	4	0	46
180649	1397	1298425977000	23600	11759	6	0	14040
180650	1397	1298415976000	23600	11759	7	0	14041
180651	2133	93514466000	23600	11759	8	0	4268
180652	2134	86094578000	23600	11759	9	0	4482
180653	2132	147753755000	23600	11759	10	0	1245
180655	2133	93512462000	23600	11759	12	0	4270
180656	2134	86093575000	23600	11759	13	0	4483
180671	1397	1298405975000	23602	11760	0	0	14042
180672	2134	86092572000	23602	11760	1	0	4484
180682	1397	1298395974000	23606	11761	0	0	14043
180683	2134	86091569000	23606	11761	1	0	4485
180684	2133	93510458000	23606	11761	2	0	4272
180701	1397	1298385973000	23611	11762	0	0	14044
180702	2134	86090566000	23611	11762	1	0	4486
180704	1397	1298375972000	23612	11763	0	0	14045
180705	1397	1298365971000	23612	11763	1	0	14046
180706	1397	1298355970000	23612	11763	2	0	14047
180707	2133	93509456000	23612	11763	3	0	4273
180708	2133	93508454000	23612	11763	4	0	4274
180710	2134	86089563000	23612	11763	6	0	4487
180711	2134	86088560000	23612	11763	7	0	4488
180712	2132	147751753000	23612	11763	8	0	1247
180713	2134	86087557000	23612	11763	9	0	4489
180737	1397	1298335968000	23617	11765	1	0	14049
180738	2134	86086554000	23617	11765	2	0	4490
180739	2133	93506450000	23617	11765	3	0	4276
180740	2133	93505448000	23617	11765	4	0	4277
180741	2134	86085551000	23617	11765	5	0	4491
180752	1397	1298315966000	23621	11767	0	0	\N
180753	2132	147750752000	23621	11767	1	0	\N
180754	2134	86083545000	23621	11767	2	0	\N
180755	2133	93503444000	23621	11767	3	0	\N
180764	1397	1298305965000	23623	11768	0	0	\N
180765	1397	1298295964000	23623	11768	1	0	\N
180766	1397	1298285963000	23623	11768	2	0	\N
180767	2058	546500000	23623	11768	3	0	\N
180768	2132	147749751000	23623	11768	4	0	\N
180769	2134	86082542000	23623	11768	5	0	\N
180770	2134	86081539000	23623	11768	6	0	\N
180771	2134	86080536000	23623	11768	7	0	\N
180772	2133	93502442000	23623	11768	8	0	\N
180773	2133	93501440000	23623	11768	9	0	\N
180774	2133	93500438000	23623	11768	10	0	\N
180775	1397	1298305965000	23624	11768	0	0	\N
180776	1397	1298295964000	23624	11768	1	0	\N
180777	1397	1298285963000	23624	11768	2	0	\N
180778	2058	546500000	23624	11768	3	0	\N
180779	2132	147749751000	23624	11768	4	0	\N
180780	2134	86082542000	23624	11768	5	0	\N
180781	2134	86081539000	23624	11768	6	0	\N
180782	2134	86080536000	23624	11768	7	0	\N
180783	2133	93502442000	23624	11768	8	0	\N
180784	2133	93501440000	23624	11768	9	0	\N
180785	2133	93500438000	23624	11768	10	0	\N
180795	2106	5039087000000	23626	11702	0	0	\N
180796	1571	8292062832307	23626	11702	1	0	\N
180797	1571	7837329766131	23626	11702	2	0	\N
180798	1571	7022459927607	23626	11702	3	0	\N
180799	1571	6472647757326	23626	11702	4	0	\N
180800	1571	4940565124154	23626	11702	5	0	\N
180801	1448	10667846000001	23626	11702	6	0	\N
180802	1448	7783836000001	23626	11702	7	0	\N
180803	1448	5837826000001	23626	11702	8	0	\N
180804	1571	4940555124154	23626	11702	9	0	\N
180805	1397	1299146049000	23626	11702	10	0	\N
180806	1397	1299136048000	23626	11702	11	0	\N
180807	1397	1299126047000	23626	11702	12	0	\N
180808	1397	1299116046000	23626	11702	13	0	\N
180809	1397	1299106045000	23626	11702	14	0	\N
180810	1397	1299096044000	23626	11702	15	0	\N
180811	1397	1299086043000	23626	11702	16	0	\N
180812	1397	1299076042000	23626	11702	17	0	\N
180813	1397	1299066041000	23626	11702	18	0	\N
180814	1397	1299056040000	23626	11702	19	0	\N
180815	1397	1299046039000	23626	11702	20	0	\N
180816	1397	1299036038000	23626	11702	22	0	\N
180817	1397	1299026037000	23626	11702	23	0	\N
180818	1397	1299016036000	23626	11702	24	0	\N
180819	1397	1299006035000	23626	11702	25	0	\N
180820	1397	1298996034000	23626	11702	26	0	\N
180821	1397	1298986033000	23626	11702	27	0	\N
180822	1397	1298976032000	23626	11702	28	0	\N
180823	1397	1298966031000	23626	11702	29	0	\N
180824	1397	1298956030000	23626	11702	30	0	\N
180825	1397	1298946029000	23626	11702	31	0	\N
180826	1397	1298936028000	23626	11702	32	0	\N
180827	1397	1298926027000	23626	11702	33	0	\N
180828	1397	1298916026000	23626	11702	34	0	\N
180829	1397	1298906025000	23626	11702	35	0	\N
180830	1397	1298896024000	23626	11702	36	0	\N
180831	1397	1298886023000	23626	11702	37	0	\N
180832	1397	1298876022000	23626	11702	38	0	\N
180833	1397	1298866021000	23626	11702	39	0	\N
180834	1397	1298856020000	23626	11702	40	0	\N
180835	1397	1298846019000	23626	11702	41	0	\N
180836	1397	1298836018000	23626	11702	42	0	\N
180837	1397	1298826017000	23626	11702	43	0	\N
180838	1397	1298816016000	23626	11702	44	0	\N
180839	1397	1298806015000	23626	11702	45	0	\N
180840	1397	1298796014000	23626	11702	46	0	\N
180841	1397	1298786013000	23626	11702	47	0	\N
180842	1397	1298776012000	23626	11702	48	0	\N
180843	1397	1298766011000	23626	11702	49	0	\N
180844	1397	1298756010000	23626	11702	50	0	\N
180845	1448	416816000001	23626	11702	51	0	\N
180846	1448	204806000001	23626	11702	52	0	\N
180847	1448	188796000001	23626	11702	53	0	\N
180848	1448	172786000001	23626	11702	54	0	\N
180849	1397	1298746009000	23626	11702	55	0	\N
180850	1397	1298736008000	23626	11702	56	0	\N
180851	1397	1298726007000	23626	11702	57	0	\N
180852	1397	1298716006000	23626	11702	58	0	\N
180853	1397	1298706005000	23626	11702	59	0	\N
180854	1397	1298696004000	23626	11702	60	0	\N
180855	1397	1298686003000	23626	11702	61	0	\N
180856	1397	1298676002000	23626	11702	62	0	\N
180857	1397	1298666001000	23626	11702	63	0	\N
180858	1397	1298656000000	23626	11702	64	0	\N
180859	1397	1298645999000	23626	11702	65	0	\N
180860	1397	1298635998000	23626	11702	66	0	\N
180861	1397	1298625997000	23626	11702	67	0	\N
180862	1397	1298615996000	23626	11702	68	0	\N
180863	1397	1298605995000	23626	11702	69	0	\N
180864	1397	1298595994000	23626	11702	70	0	\N
180865	1397	1298585993000	23626	11702	71	0	\N
180866	1397	1298575992000	23626	11702	72	0	\N
180867	1397	1298565991000	23626	11702	73	0	\N
180868	1397	1298555990000	23626	11702	74	0	\N
180869	1397	1298545989000	23626	11702	75	0	\N
180870	1397	1298535988000	23626	11702	76	0	\N
180871	1397	1298525987000	23626	11702	77	0	\N
180872	1397	1298515986000	23626	11702	78	0	\N
180873	1397	1298505985000	23626	11702	79	0	\N
180874	1397	1298495984000	23626	11702	80	0	\N
180875	1397	1298485983000	23626	11702	81	0	\N
180876	1397	1298475982000	23626	11702	82	0	\N
180877	1397	1298465981000	23626	11702	83	0	\N
180878	1397	1298455980000	23626	11702	84	0	\N
180879	1397	1298445979000	23626	11702	85	0	\N
180880	1397	1298435978000	23626	11702	86	0	\N
180747	2133	93504446000	23619	11766	2	0	4278
180748	1397	1298315966000	23620	11767	0	0	14051
180749	2132	147750752000	23620	11767	1	0	1248
180750	2134	86083545000	23620	11767	2	0	4493
180751	2133	93503444000	23620	11767	3	0	4279
180757	1397	1298295964000	23622	11768	1	0	14053
180758	1397	1298285963000	23622	11768	2	0	14054
180759	2058	546500000	23622	11768	3	0	8
180760	2132	147749751000	23622	11768	4	0	1249
180761	2133	93502442000	23622	11768	5	0	4280
180763	2133	93500438000	23622	11768	7	0	4282
180786	1397	1298275962000	23625	11769	0	0	14055
180787	1397	1298265961000	23625	11769	1	0	14056
180788	2134	86082542000	23625	11769	2	0	4494
180790	2134	86080536000	23625	11769	4	0	4496
180791	2134	86079533000	23625	11769	5	0	4497
180792	2134	86078530000	23625	11769	6	0	4498
180793	2133	93499436000	23625	11769	7	0	4283
180794	2133	93498434000	23625	11769	8	0	4284
180881	1397	1298425977000	23626	11702	87	0	\N
180882	1397	1298415976000	23626	11702	88	0	\N
180883	1397	1298405975000	23626	11702	89	0	\N
180884	1397	1298395974000	23626	11702	90	0	\N
180885	1397	1298385973000	23626	11702	91	0	\N
180886	1397	1298375972000	23626	11702	92	0	\N
180887	1397	1298365971000	23626	11702	93	0	\N
180888	1397	1298355970000	23626	11702	94	0	\N
180889	1397	1298345969000	23626	11702	95	0	\N
180890	1397	1298335968000	23626	11702	96	0	\N
180891	1397	1298325967000	23626	11702	97	0	\N
180892	1397	1298315966000	23626	11702	98	0	\N
180893	1397	1298305965000	23626	11702	99	0	\N
180894	1397	1298295964000	23626	11702	100	0	\N
180895	1397	1298285963000	23626	11702	101	0	\N
180896	1397	1298275962000	23626	11702	102	0	\N
180897	1397	1298265961000	23626	11702	103	0	\N
180898	2058	546500000	23626	11702	104	0	\N
180899	2134	86166794000	23626	11702	105	0	\N
180900	2134	86165791000	23626	11702	106	0	\N
180901	2133	93587612000	23626	11702	107	0	\N
180902	2133	93586610000	23626	11702	108	0	\N
180903	2133	93585608000	23626	11702	109	0	\N
180904	2134	86164788000	23626	11702	110	0	\N
180905	2133	93584606000	23626	11702	111	0	\N
180906	2133	93583604000	23626	11702	112	0	\N
180907	2133	93582602000	23626	11702	113	0	\N
180908	2132	147775777000	23626	11702	114	0	\N
180909	2132	147774776000	23626	11702	115	0	\N
180910	2132	147773775000	23626	11702	116	0	\N
180911	2132	147772774000	23626	11702	117	0	\N
180912	2134	86163785000	23626	11702	118	0	\N
180913	2134	86162782000	23626	11702	119	0	\N
180914	2134	86161779000	23626	11702	120	0	\N
180915	2134	86160776000	23626	11702	121	0	\N
180916	2133	93581600000	23626	11702	122	0	\N
180917	2133	93580598000	23626	11702	123	0	\N
180918	2133	93579596000	23626	11702	124	0	\N
180919	2133	93578594000	23626	11702	125	0	\N
180930	1397	1298235958000	23629	11771	0	0	\N
180931	2134	86075521000	23629	11771	1	0	\N
180932	2133	93495428000	23629	11771	2	0	\N
180940	1397	1298205955000	23631	11773	0	0	\N
180941	2133	93492422000	23631	11773	1	0	\N
180942	1397	1298205955000	23632	11773	0	0	\N
180943	2134	86072512000	23632	11773	1	0	\N
180944	2133	93492422000	23632	11773	2	0	\N
180951	1397	1298195954000	23635	11774	0	0	\N
180952	2133	93491420000	23635	11774	1	0	\N
180953	2134	86071509000	23635	11774	2	0	\N
180961	1397	1298185953000	23637	11775	0	0	\N
180962	1397	1298175952000	23637	11775	1	0	\N
180963	2132	147746748000	23637	11775	2	0	\N
180964	2134	86070506000	23637	11775	3	0	\N
180965	2133	93490418000	23637	11775	4	0	\N
180966	2134	86069503000	23637	11775	5	0	\N
180967	2133	93489416000	23637	11775	6	0	\N
180968	1397	1298165951000	23638	11776	0	0	\N
180969	1397	1298155950000	23638	11776	1	0	\N
180970	2134	86068500000	23638	11776	2	0	\N
180971	2134	86067497000	23638	11776	3	0	\N
180972	2133	93488414000	23638	11776	4	0	\N
180973	2133	93487412000	23638	11776	5	0	\N
180974	2133	93486410000	23638	11776	6	0	\N
180975	2134	86066494000	23638	11776	7	0	\N
180976	2132	147745747000	23638	11776	8	0	\N
180977	1397	1298165951000	23639	11776	0	0	\N
180978	1397	1298155950000	23639	11776	1	0	\N
180979	2134	86068500000	23639	11776	2	0	\N
180980	2134	86067497000	23639	11776	3	0	\N
180981	2133	93488414000	23639	11776	4	0	\N
180982	2133	93487412000	23639	11776	5	0	\N
180983	2133	93486410000	23639	11776	6	0	\N
180984	2134	86066494000	23639	11776	7	0	\N
180985	2132	147745747000	23639	11776	8	0	\N
180995	1397	1298145949000	23641	11777	0	0	\N
180996	2133	93485408000	23641	11777	1	0	\N
180997	2134	86065491000	23641	11777	2	0	\N
181008	1397	1298135948000	23644	11778	0	0	\N
181009	1397	1298125947000	23644	11778	1	0	\N
181010	2132	147744746000	23644	11778	2	0	\N
181011	2133	93484406000	23644	11778	3	0	\N
181012	2133	93483404000	23644	11778	4	0	\N
181013	2134	86064488000	23644	11778	5	0	\N
181014	2134	86063485000	23644	11778	6	0	\N
180922	2133	93497432000	23627	11770	2	0	4285
180923	2133	93496430000	23627	11770	3	0	4286
180924	2134	86077527000	23627	11770	4	0	4499
180925	2134	86076524000	23627	11770	5	0	4500
180926	2132	147748750000	23627	11770	6	0	1250
180928	2134	86075521000	23628	11771	1	0	4501
180929	2133	93495428000	23628	11771	2	0	4287
180933	1397	1298225957000	23630	11772	0	0	14060
180934	1397	1298215956000	23630	11772	1	0	14061
180935	2134	86074518000	23630	11772	2	0	4502
180937	2133	93493424000	23630	11772	4	0	4289
180938	2134	86073515000	23630	11772	5	0	4503
180939	2132	147747749000	23630	11772	6	0	1251
180945	1397	1298205955000	23633	11773	0	0	14062
180947	2133	93492422000	23633	11773	2	0	4290
180948	1397	1298195954000	23634	11774	0	0	14063
180949	2133	93491420000	23634	11774	1	0	4291
180950	2134	86071509000	23634	11774	2	0	4505
180954	1397	1298185953000	23636	11775	0	0	14064
180956	2132	147746748000	23636	11775	2	0	1252
180957	2134	86070506000	23636	11775	3	0	4506
180958	2133	93490418000	23636	11775	4	0	4292
180959	2134	86069503000	23636	11775	5	0	4507
180960	2133	93489416000	23636	11775	6	0	4293
180987	1397	1298155950000	23640	11776	1	0	14067
180988	2134	86068500000	23640	11776	2	0	4508
180989	2134	86067497000	23640	11776	3	0	4509
180990	2133	93488414000	23640	11776	4	0	4294
180992	2133	93486410000	23640	11776	6	0	4296
180993	2134	86066494000	23640	11776	7	0	4510
180994	2132	147745747000	23640	11776	8	0	1253
180998	1397	1298145949000	23642	11777	0	0	14068
180999	2133	93485408000	23642	11777	1	0	4297
181001	1397	1298135948000	23643	11778	0	0	14069
181002	1397	1298125947000	23643	11778	1	0	14070
181003	2132	147744746000	23643	11778	2	0	1254
181004	2133	93484406000	23643	11778	3	0	4298
181005	2133	93483404000	23643	11778	4	0	4299
181007	2134	86063485000	23643	11778	6	0	4513
181015	1397	1298115946000	23645	11779	0	0	14071
181016	2133	93482402000	23645	11779	1	0	4300
181018	1397	1298115946000	23646	11779	0	0	\N
181019	2133	93482402000	23646	11779	1	0	\N
181020	2134	86062482000	23646	11779	2	0	\N
181028	1397	1298095944000	23649	11781	0	0	\N
181029	2132	147743745000	23649	11781	1	0	\N
181030	2133	93480398000	23649	11781	2	0	\N
181031	2134	86060476000	23649	11781	3	0	\N
181039	42	74368733400000	23651	11782	0	0	\N
181040	42	72080927000000	23651	11782	1	0	\N
181041	42	70537175800000	23651	11782	2	0	\N
181042	42	69260595000000	23651	11782	3	0	\N
181043	1397	1298085943000	23651	11782	5	0	\N
181044	2134	86059473000	23651	11782	6	0	\N
181045	2133	93479396000	23651	11782	7	0	\N
181046	42	74368733400000	23652	11782	0	0	\N
181047	42	72080927000000	23652	11782	1	0	\N
181048	42	70537175800000	23652	11782	2	0	\N
181049	42	69260595000000	23652	11782	3	0	\N
181050	1397	1298085943000	23652	11782	5	0	\N
181051	2134	86059473000	23652	11782	6	0	\N
181055	1397	1298075942000	23654	11783	0	0	\N
181056	2133	93478394000	23654	11783	1	0	\N
181057	2134	86058470000	23654	11783	2	0	\N
181058	1397	1298075942000	23655	11783	0	0	\N
181059	2133	93478394000	23655	11783	1	0	\N
181060	2134	86058470000	23655	11783	2	0	\N
181061	1397	1298075942000	23656	11783	0	0	\N
181062	2133	93478394000	23656	11783	1	0	\N
181063	2134	86058470000	23656	11783	2	0	\N
181064	42	72928700400000	23657	11555	0	0	\N
181065	42	70640894000000	23657	11555	1	0	\N
181066	42	69097142800000	23657	11555	2	0	\N
181067	42	67820562000000	23657	11555	3	0	\N
181068	2058	546500000	23657	11555	4	0	\N
181079	1397	1298065941000	23659	11784	0	0	\N
181080	1397	1298055940000	23659	11784	1	0	\N
181081	1397	1298045939000	23659	11784	2	0	\N
181082	2132	147742744000	23659	11784	3	0	\N
181083	2134	86057467000	23659	11784	4	0	\N
181084	2134	86056464000	23659	11784	5	0	\N
181085	2133	93477392000	23659	11784	6	0	\N
181086	2133	93476390000	23659	11784	7	0	\N
181087	2134	86055461000	23659	11784	8	0	\N
181088	2133	93475388000	23659	11784	9	0	\N
181089	1397	1298035938000	23660	11785	0	0	\N
181090	2133	93474386000	23660	11785	1	0	\N
181091	2134	86054458000	23660	11785	2	0	\N
181095	1397	1298035938000	23662	11785	0	0	\N
181096	2133	93474386000	23662	11785	1	0	\N
181097	2134	86054458000	23662	11785	2	0	\N
181098	1397	1298035938000	23663	11785	0	0	\N
181099	2134	86054458000	23663	11785	1	0	\N
181100	1397	1298025937000	23664	11786	0	0	\N
181101	2132	147741743000	23664	11786	1	0	\N
181102	2133	93473384000	23664	11786	2	0	\N
181103	2134	86053455000	23664	11786	3	0	\N
181107	1397	1298025937000	23666	11786	0	0	\N
181108	2132	147741743000	23666	11786	1	0	\N
181109	2133	93473384000	23666	11786	2	0	\N
181110	2134	86053455000	23666	11786	3	0	\N
181113	1397	1298015936000	23668	11787	0	0	\N
181114	2133	93473384000	23668	11787	1	0	\N
181115	2133	93472382000	23668	11787	2	0	\N
181120	1397	1297995934000	23670	11789	0	0	\N
181121	1397	1297985933000	23670	11789	1	0	\N
181122	2134	86051449000	23670	11789	2	0	\N
181123	2134	86050446000	23670	11789	3	0	\N
181124	2132	147740742000	23670	11789	4	0	\N
181125	2133	93470378000	23670	11789	5	0	\N
181126	2133	93469376000	23670	11789	6	0	\N
181134	1397	1297995934000	23672	11789	0	0	\N
181135	1397	1297985933000	23672	11789	1	0	\N
181136	2134	86051449000	23672	11789	2	0	\N
181137	2134	86050446000	23672	11789	3	0	\N
181138	2132	147740742000	23672	11789	4	0	\N
181139	2133	93470378000	23672	11789	5	0	\N
181140	2133	93469376000	23672	11789	6	0	\N
181141	1397	1297995934000	23673	11789	0	0	\N
181142	1397	1297985933000	23673	11789	1	0	\N
181143	2134	86051449000	23673	11789	2	0	\N
181144	2134	86050446000	23673	11789	3	0	\N
181145	2132	147740742000	23673	11789	4	0	\N
181146	2133	93470378000	23673	11789	5	0	\N
181147	2133	93469376000	23673	11789	6	0	\N
181148	1397	1297995934000	23674	11789	0	0	\N
181149	1397	1297985933000	23674	11789	1	0	\N
181150	2134	86051449000	23674	11789	2	0	\N
181151	2134	86050446000	23674	11789	3	0	\N
181152	2132	147740742000	23674	11789	4	0	\N
181022	2133	93481400000	23647	11780	1	0	4301
181023	2134	86061479000	23647	11780	2	0	4515
181024	1397	1298095944000	23648	11781	0	0	14073
181025	2132	147743745000	23648	11781	1	0	1255
181026	2133	93480398000	23648	11781	2	0	4302
181032	42	74368733400000	23650	11782	0	0	9
181033	42	72080927000000	23650	11782	1	0	10
181034	42	70537175800000	23650	11782	2	0	11
181035	42	69260595000000	23650	11782	3	0	12
181036	1397	1298085943000	23650	11782	5	0	14074
181038	2133	93479396000	23650	11782	7	0	4303
181052	1397	1298075942000	23653	11783	0	0	14075
181053	2133	93478394000	23653	11783	1	0	4304
181054	2134	86058470000	23653	11783	2	0	4518
181070	1397	1298055940000	23658	11784	1	0	14077
181071	1397	1298045939000	23658	11784	2	0	14078
181072	2132	147742744000	23658	11784	3	0	1256
181073	2134	86057467000	23658	11784	4	0	4519
181074	2134	86056464000	23658	11784	5	0	4520
181076	2133	93476390000	23658	11784	7	0	4306
181077	2134	86055461000	23658	11784	8	0	4521
181078	2133	93475388000	23658	11784	9	0	4307
181092	1397	1298035938000	23661	11785	0	0	14079
181093	2133	93474386000	23661	11785	1	0	4308
181104	1397	1298025937000	23665	11786	0	0	14080
181105	2132	147741743000	23665	11786	1	0	1257
181106	2134	86053455000	23665	11786	2	0	4523
181111	1397	1298015936000	23667	11787	0	0	14081
181116	1397	1298005935000	23669	11788	0	0	14082
181117	2133	93472382000	23669	11788	1	0	4310
181118	2133	93471380000	23669	11788	2	0	4311
181119	2134	86052452000	23669	11788	3	0	4524
181127	1397	1297995934000	23671	11789	0	0	14083
181129	2134	86051449000	23671	11789	2	0	4525
181130	2134	86050446000	23671	11789	3	0	4526
181131	2132	147740742000	23671	11789	4	0	1258
181132	2133	93470378000	23671	11789	5	0	4312
181133	2133	93469376000	23671	11789	6	0	4313
181156	1397	1297975932000	23676	11790	0	0	\N
181157	2134	86049443000	23676	11790	1	0	\N
181158	1397	1297975932000	23677	11790	0	0	\N
181159	2134	86049443000	23677	11790	1	0	\N
181160	2133	93468374000	23677	11790	2	0	\N
181165	1397	1297955930000	23681	11792	0	0	\N
181166	1397	1297945929000	23681	11792	1	0	\N
181167	1747	65931000000	23681	11792	2	0	\N
181168	1746	11644491000000	23681	11792	3	0	\N
181169	2134	86047437000	23681	11792	4	0	\N
181170	2134	86046434000	23681	11792	5	0	\N
181171	2133	93466370000	23681	11792	6	0	\N
181172	2133	93465368000	23681	11792	7	0	\N
181216	1397	1297845919000	23692	11800	0	0	\N
181217	2133	93455348000	23692	11800	1	0	\N
181218	2134	86036404000	23692	11800	2	0	\N
181219	1397	1297835918000	23693	11801	0	0	\N
181220	1397	1297825917000	23693	11801	1	0	\N
181221	2132	147735737000	23693	11801	2	0	\N
181222	2133	93454346000	23693	11801	3	0	\N
181223	2133	93453344000	23693	11801	5	0	\N
181224	2134	86035401000	23693	11801	6	0	\N
181225	2134	86034398000	23693	11801	7	0	\N
181233	1397	1297835918000	23695	11801	0	0	\N
181234	1397	1297825917000	23695	11801	1	0	\N
181235	2132	147735737000	23695	11801	2	0	\N
181236	2133	93454346000	23695	11801	3	0	\N
181237	2133	93453344000	23695	11801	5	0	\N
181238	2134	86035401000	23695	11801	6	0	\N
181239	2134	86034398000	23695	11801	7	0	\N
181240	1397	1297835918000	23696	11801	0	0	\N
181241	1397	1297825917000	23696	11801	1	0	\N
181242	2132	147735737000	23696	11801	2	0	\N
181243	2133	93454346000	23696	11801	3	0	\N
181244	2133	93453344000	23696	11801	5	0	\N
181245	2134	86035401000	23696	11801	6	0	\N
181246	2134	86034398000	23696	11801	7	0	\N
181247	1397	1297835918000	23697	11801	0	0	\N
181248	1397	1297825917000	23697	11801	1	0	\N
181249	2132	147735737000	23697	11801	2	0	\N
181250	2133	93454346000	23697	11801	3	0	\N
181251	2133	93453344000	23697	11801	5	0	\N
181252	2134	86035401000	23697	11801	6	0	\N
181253	2134	86034398000	23697	11801	7	0	\N
181254	1397	1297815916000	23698	11802	0	0	\N
181255	1397	1297805915000	23698	11802	1	0	\N
181256	1397	1297795914000	23698	11802	2	0	\N
181257	2133	93452342000	23698	11802	3	0	\N
181258	2132	147734736000	23698	11802	4	0	\N
181259	2134	86033395000	23698	11802	5	0	\N
181260	2134	86032392000	23698	11802	6	0	\N
181261	2134	86031389000	23698	11802	7	0	\N
181262	2133	93451340000	23698	11802	8	0	\N
181263	2133	93450338000	23698	11802	9	0	\N
181264	1746	3990488000000	23698	11802	10	0	\N
181287	1397	1297755910000	23703	11805	0	0	\N
181288	2134	86027377000	23703	11805	1	0	\N
181155	2133	93468374000	23675	11790	2	0	4314
181161	1397	1297965931000	23678	11791	0	0	14086
181162	2134	86048440000	23678	11791	1	0	4528
181163	2132	147739741000	23678	11791	2	0	1259
181164	2133	93467372000	23678	11791	3	0	4315
181174	1397	1297945929000	23682	11792	1	0	14088
181175	1747	65931000000	23682	11792	2	0	6
181176	1746	11644491000000	23682	11792	3	0	3
181177	2134	86047437000	23682	11792	4	0	4529
181178	2134	86046434000	23682	11792	5	0	4530
181180	2133	93465368000	23682	11792	7	0	4317
181181	1397	1297935928000	23684	11793	0	0	14089
181182	1397	1297925927000	23684	11793	1	0	14090
181183	1746	7075490000000	23684	11793	2	0	4
181185	2133	93463364000	23684	11793	4	0	4319
181186	1746	3992489000000	23684	11793	5	0	5
181187	2134	86045431000	23684	11793	6	0	4531
181188	2134	86044428000	23684	11793	7	0	4532
181189	2132	147738740000	23684	11793	8	0	1260
181191	2133	93462362000	23685	11794	1	0	4320
181192	2134	86043425000	23685	11794	2	0	4533
181193	1397	1297905925000	23686	11795	0	0	14092
181194	2133	93461360000	23686	11795	1	0	4321
181195	2134	86042422000	23686	11795	2	0	4534
181197	1397	1297885923000	23687	11796	1	0	14094
181198	2134	86041419000	23687	11796	2	0	4535
181199	2134	86040416000	23687	11796	3	0	4536
181200	2133	93460358000	23687	11796	4	0	4322
181202	2132	147737739000	23687	11796	6	0	1261
181203	1397	1297875922000	23688	11797	0	0	14095
181204	2133	93458354000	23688	11797	1	0	4324
181205	2134	86039413000	23688	11797	2	0	4537
181206	1397	1297865921000	23689	11798	0	0	14096
181208	2132	147736738000	23689	11798	2	0	1262
181209	2133	93457352000	23689	11798	3	0	4325
181210	1397	1297855920000	23690	11799	0	0	14097
181211	2134	86037407000	23690	11799	1	0	4539
181212	2133	93456350000	23690	11799	2	0	4326
181214	2133	93455348000	23691	11800	1	0	4327
181215	2134	86036404000	23691	11800	2	0	4540
181226	1397	1297835918000	23694	11801	0	0	14099
181227	1397	1297825917000	23694	11801	1	0	14100
181229	2133	93454346000	23694	11801	3	0	4328
181230	2133	93453344000	23694	11801	5	0	4329
181231	2134	86035401000	23694	11801	6	0	4541
181232	2134	86034398000	23694	11801	7	0	4542
181265	1397	1297815916000	23699	11802	0	0	14101
181267	1397	1297795914000	23699	11802	2	0	14103
181268	2132	147734736000	23699	11802	3	0	1264
181269	2134	86033395000	23699	11802	4	0	4543
181270	2134	86032392000	23699	11802	5	0	4544
181271	2134	86031389000	23699	11802	6	0	4545
181273	1397	1297785913000	23701	11803	0	0	14104
181274	1397	1297775912000	23701	11803	1	0	14105
181275	2133	93452342000	23701	11803	2	0	4330
181276	2134	86030386000	23701	11803	3	0	4546
181278	2133	93451340000	23701	11803	5	0	4331
181279	2133	93450338000	23701	11803	6	0	4332
181280	2133	93449336000	23701	11803	7	0	4333
181281	2133	93448334000	23701	11803	8	0	4334
181282	1746	1248843000000	23701	11803	9	0	7
181284	2133	93447332000	23702	11804	1	0	4335
181285	2134	86028380000	23702	11804	2	0	4548
181286	2132	147733735000	23702	11804	3	0	1265
181289	1397	1297755910000	23704	11805	0	0	\N
181290	2134	86027377000	23704	11805	1	0	\N
181291	2133	93446330000	23704	11805	2	0	\N
181305	1397	1297725907000	23709	11808	0	0	\N
181306	2132	147732734000	23709	11808	1	0	\N
181307	2134	86024368000	23709	11808	2	0	\N
181308	2133	93443324000	23709	11808	3	0	\N
181309	1397	1297725907000	23710	11808	0	0	\N
181310	2132	147732734000	23710	11808	1	0	\N
181311	2134	86024368000	23710	11808	2	0	\N
181324	1397	1297685903000	23714	11811	0	0	\N
181325	2134	86020356000	23714	11811	1	0	\N
181326	1397	1297685903000	23715	11811	0	0	\N
181327	2134	86020356000	23715	11811	1	0	\N
181328	2133	93439316000	23715	11811	2	0	\N
181329	1397	1297685903000	23716	11811	0	0	\N
181330	2134	86020356000	23716	11811	1	0	\N
181331	2133	93439316000	23716	11811	2	0	\N
181332	1397	1297675902000	23717	11812	0	0	\N
181333	1397	1297665901000	23717	11812	1	0	\N
181334	2133	93439316000	23717	11812	2	0	\N
181335	2133	93438314000	23717	11812	3	0	\N
181336	2132	147730732000	23717	11812	4	0	\N
181337	2133	93437312000	23717	11812	5	0	\N
181338	2134	86019353000	23717	11812	6	0	\N
181339	2134	86018350000	23717	11812	7	0	\N
181351	1397	1297655900000	23720	11813	0	0	\N
181352	2133	93436310000	23720	11813	1	0	\N
181353	2134	86017347000	23720	11813	2	0	\N
181354	1397	1297645899000	23722	11814	0	0	\N
181355	1397	1297635898000	23722	11814	1	0	\N
181356	2133	93435308000	23722	11814	2	0	\N
181357	2133	93434306000	23722	11814	3	0	\N
181358	2134	86016344000	23722	11814	4	0	\N
181359	2134	86015341000	23722	11814	5	0	\N
181360	1397	1297645899000	23723	11814	0	0	\N
181361	1397	1297635898000	23723	11814	1	0	\N
181362	2133	93435308000	23723	11814	2	0	\N
181363	2133	93434306000	23723	11814	3	0	\N
181364	2134	86016344000	23723	11814	4	0	\N
181365	2134	86015341000	23723	11814	5	0	\N
181421	42	74368733400000	23733	11753	0	0	\N
181422	42	72080927000000	23733	11753	1	0	\N
181423	42	70537175800000	23733	11753	2	0	\N
181424	42	69260595000000	23733	11753	3	0	\N
181294	2133	93446330000	23705	11805	2	0	4336
181295	1397	1297745909000	23706	11806	0	0	14108
181296	2133	93445328000	23706	11806	1	0	4337
181297	2134	86026374000	23706	11806	2	0	4550
181298	1397	1297735908000	23707	11807	0	0	14109
181300	2134	86025371000	23707	11807	2	0	4551
181301	1397	1297725907000	23708	11808	0	0	14110
181302	2132	147732734000	23708	11808	1	0	1266
181303	2134	86024368000	23708	11808	2	0	4552
181304	2133	93443324000	23708	11808	3	0	4339
181313	1397	1297705905000	23711	11809	1	0	14112
181314	2134	86023365000	23711	11809	2	0	4553
181315	2133	93442322000	23711	11809	3	0	4340
181316	2133	93441320000	23711	11809	4	0	4341
181318	1397	1297695904000	23712	11810	0	0	14113
181319	2132	147731733000	23712	11810	1	0	1267
181320	2134	86021359000	23712	11810	2	0	4555
181321	2133	93440318000	23712	11810	3	0	4342
181322	1397	1297685903000	23713	11811	0	0	14114
181340	1397	1297675902000	23718	11812	0	0	14115
181341	1397	1297665901000	23718	11812	1	0	14116
181342	2133	93439316000	23718	11812	2	0	4343
181343	2133	93438314000	23718	11812	3	0	4344
181344	2132	147730732000	23718	11812	4	0	1268
181346	2134	86019353000	23718	11812	6	0	4557
181347	2134	86018350000	23718	11812	7	0	4558
181348	1397	1297655900000	23719	11813	0	0	14117
181349	2133	93436310000	23719	11813	1	0	4346
181366	1397	1297645899000	23724	11814	0	0	14118
181367	1397	1297635898000	23724	11814	1	0	14119
181368	2133	93435308000	23724	11814	2	0	4347
181369	2133	93434306000	23724	11814	3	0	4348
181370	2134	86016344000	23724	11814	4	0	4560
181372	1397	1297625897000	23725	11815	0	0	14120
181373	1397	1297615896000	23725	11815	1	0	14121
181374	2132	147729731000	23725	11815	2	0	1269
181375	2133	93433304000	23725	11815	3	0	4349
181376	2134	86014338000	23725	11815	4	0	4562
181378	2134	86013335000	23725	11815	6	0	4563
181379	2133	93432302000	23725	11815	7	0	4350
181380	1397	1297605895000	23726	11816	0	0	14122
181381	1397	1297595894000	23726	11816	1	0	14123
181383	2134	86011329000	23726	11816	3	0	4565
181384	2132	147728730000	23726	11816	4	0	1270
181385	2133	93431300000	23726	11816	5	0	4351
181386	2133	93430298000	23726	11816	6	0	4352
181387	1397	1297585893000	23727	11817	0	0	14124
181389	2133	93429296000	23727	11817	2	0	4353
181390	1397	1297575892000	23728	11818	0	0	14125
181391	1397	1297565891000	23728	11818	1	0	14126
181392	2134	86009323000	23728	11818	2	0	4567
181393	2133	93428294000	23728	11818	3	0	4354
181395	2132	147727729000	23728	11818	5	0	1271
181396	2134	86008320000	23728	11818	6	0	4568
181397	1397	1297555890000	23729	11819	0	0	14127
181398	2133	93426290000	23729	11819	1	0	4356
181400	1397	1297545889000	23730	11820	0	0	14128
181401	1397	1297535888000	23730	11820	1	0	14129
181402	1397	1297525887000	23730	11820	2	0	14130
181403	2133	93425288000	23730	11820	3	0	4357
181404	2134	86006314000	23730	11820	4	0	4570
181406	2134	86004308000	23730	11820	6	0	4572
181407	2132	147726728000	23730	11820	7	0	1272
181408	2133	93424286000	23730	11820	8	0	4358
181409	2133	93423284000	23730	11820	9	0	4359
181410	1397	1297515886000	23731	11821	0	0	14131
181412	2134	86003305000	23731	11821	2	0	4573
181413	2133	93422282000	23731	11821	3	0	4360
181414	2133	93421280000	23731	11821	4	0	4361
181415	2134	86002302000	23731	11821	5	0	4574
181417	1397	1297495884000	23732	11822	1	0	14133
181418	2132	147725727000	23732	11822	2	0	1273
181419	2133	93420278000	23732	11822	3	0	4362
181420	2134	86001299000	23732	11822	4	0	4575
181425	1571	8292062832307	23733	11753	4	0	\N
181426	1397	1298505985000	23733	11753	5	0	\N
181427	1571	7837329766131	23733	11753	6	0	\N
181428	1571	7022459927607	23733	11753	7	0	\N
181429	1571	6472647757326	23733	11753	8	0	\N
181430	1571	4940565124154	23733	11753	9	0	\N
181431	1571	4940555124154	23733	11753	10	0	\N
181432	1397	1298495984000	23733	11753	11	0	\N
181433	1397	1298485983000	23733	11753	12	0	\N
181434	1397	1298475982000	23733	11753	13	0	\N
181435	1397	1298465981000	23733	11753	14	0	\N
181436	1397	1298455980000	23733	11753	15	0	\N
181437	1397	1298445979000	23733	11753	16	0	\N
181438	1397	1298435978000	23733	11753	17	0	\N
181439	1397	1298425977000	23733	11753	18	0	\N
181440	1397	1298415976000	23733	11753	19	0	\N
181441	1397	1298405975000	23733	11753	20	0	\N
181442	1397	1298395974000	23733	11753	21	0	\N
181443	1397	1298385973000	23733	11753	22	0	\N
181444	1397	1298375972000	23733	11753	23	0	\N
181445	1397	1298365971000	23733	11753	24	0	\N
181446	1397	1298355970000	23733	11753	25	0	\N
181447	1397	1298345969000	23733	11753	26	0	\N
181448	1397	1298335968000	23733	11753	27	0	\N
181449	1397	1298325967000	23733	11753	28	0	\N
181450	1397	1298315966000	23733	11753	29	0	\N
181451	1397	1298305965000	23733	11753	30	0	\N
181452	1397	1298295964000	23733	11753	31	0	\N
181453	1397	1298285963000	23733	11753	32	0	\N
181454	1397	1298275962000	23733	11753	33	0	\N
181455	1397	1298265961000	23733	11753	34	0	\N
181456	1397	1298255960000	23733	11753	35	0	\N
181457	1397	1298245959000	23733	11753	36	0	\N
181458	1397	1298235958000	23733	11753	37	0	\N
181459	1397	1298225957000	23733	11753	38	0	\N
181460	1397	1298215956000	23733	11753	39	0	\N
181461	1397	1298205955000	23733	11753	40	0	\N
181462	1397	1298195954000	23733	11753	41	0	\N
181463	1397	1298185953000	23733	11753	42	0	\N
181464	1397	1298175952000	23733	11753	43	0	\N
181465	1397	1298165951000	23733	11753	44	0	\N
181466	1397	1298155950000	23733	11753	45	0	\N
181467	1397	1298145949000	23733	11753	46	0	\N
181468	1397	1298135948000	23733	11753	47	0	\N
181469	1397	1298125947000	23733	11753	48	0	\N
181470	1397	1298115946000	23733	11753	49	0	\N
181471	1397	1298105945000	23733	11753	50	0	\N
181472	1397	1298095944000	23733	11753	51	0	\N
181473	1397	1298085943000	23733	11753	52	0	\N
181474	1397	1298075942000	23733	11753	53	0	\N
181475	1397	1298065941000	23733	11753	54	0	\N
181476	1397	1298055940000	23733	11753	55	0	\N
181477	1397	1298045939000	23733	11753	56	0	\N
181478	1397	1298035938000	23733	11753	57	0	\N
181479	1397	1298025937000	23733	11753	58	0	\N
181480	1397	1298015936000	23733	11753	59	0	\N
181481	1397	1298005935000	23733	11753	60	0	\N
181482	1397	1297995934000	23733	11753	61	0	\N
181483	1397	1297985933000	23733	11753	62	0	\N
181484	1397	1297975932000	23733	11753	63	0	\N
181485	1397	1297965931000	23733	11753	64	0	\N
181486	1397	1297955930000	23733	11753	65	0	\N
181487	1397	1297945929000	23733	11753	66	0	\N
181488	1397	1297935928000	23733	11753	67	0	\N
181489	1397	1297925927000	23733	11753	68	0	\N
181490	1397	1297915926000	23733	11753	69	0	\N
181491	1397	1297905925000	23733	11753	70	0	\N
181492	1397	1297895924000	23733	11753	71	0	\N
181493	1397	1297885923000	23733	11753	72	0	\N
181494	1397	1297875922000	23733	11753	73	0	\N
181495	1397	1297865921000	23733	11753	74	0	\N
181496	1397	1297855920000	23733	11753	75	0	\N
181497	1397	1297845919000	23733	11753	76	0	\N
181498	1397	1297835918000	23733	11753	77	0	\N
181499	1397	1297825917000	23733	11753	78	0	\N
181500	1397	1297815916000	23733	11753	79	0	\N
181501	1397	1297805915000	23733	11753	81	0	\N
181502	1397	1297795914000	23733	11753	82	0	\N
181503	1397	1297785913000	23733	11753	83	0	\N
181504	1397	1297775912000	23733	11753	84	0	\N
181505	1397	1297765911000	23733	11753	85	0	\N
181506	1397	1297755910000	23733	11753	86	0	\N
181507	1397	1297745909000	23733	11753	87	0	\N
181508	1397	1297735908000	23733	11753	88	0	\N
181509	1397	1297725907000	23733	11753	89	0	\N
181510	1397	1297715906000	23733	11753	90	0	\N
181511	1397	1297705905000	23733	11753	91	0	\N
181512	1397	1297695904000	23733	11753	92	0	\N
181513	1397	1297685903000	23733	11753	93	0	\N
181514	1397	1297675902000	23733	11753	94	0	\N
181515	1397	1297665901000	23733	11753	95	0	\N
181516	1397	1297655900000	23733	11753	96	0	\N
181517	1397	1297645899000	23733	11753	97	0	\N
181518	1397	1297635898000	23733	11753	98	0	\N
181519	1397	1297625897000	23733	11753	99	0	\N
181520	1397	1297615896000	23733	11753	100	0	\N
181521	1397	1297605895000	23733	11753	101	0	\N
181522	1397	1297595894000	23733	11753	102	0	\N
181523	1397	1297585893000	23733	11753	103	0	\N
181524	1397	1297575892000	23733	11753	104	0	\N
181525	1397	1297565891000	23733	11753	105	0	\N
181526	1397	1297555890000	23733	11753	106	0	\N
181527	1397	1297545889000	23733	11753	107	0	\N
181528	1397	1297535888000	23733	11753	108	0	\N
181529	1397	1297525887000	23733	11753	109	0	\N
181530	1397	1297515886000	23733	11753	110	0	\N
181531	1397	1297505885000	23733	11753	111	0	\N
181532	1397	1297495884000	23733	11753	112	0	\N
181533	2058	546500000	23733	11753	113	0	\N
181534	2058	535500000	23733	11753	114	0	\N
181535	1747	65931000000	23733	11753	115	0	\N
181536	1746	11644491000000	23733	11753	116	0	\N
181537	1746	7075490000000	23733	11753	117	0	\N
181538	2133	93521480000	23733	11753	118	0	\N
181539	2134	86102602000	23733	11753	119	0	\N
181540	2133	93520478000	23733	11753	120	0	\N
181541	2132	147755757000	23733	11753	121	0	\N
181542	2132	147754756000	23733	11753	122	0	\N
181543	2132	147753755000	23733	11753	123	0	\N
181544	2132	147752754000	23733	11753	124	0	\N
181545	1746	3992489000000	23733	11753	125	0	\N
181546	1397	1297485883000	23734	11823	0	0	\N
181547	2133	93419276000	23734	11823	1	0	\N
181548	2134	86000296000	23734	11823	2	0	\N
181549	2134	85999293000	23734	11823	3	0	\N
181550	2133	93418274000	23734	11823	4	0	\N
181551	1397	1297485883000	23735	11823	0	0	\N
181552	2133	93419276000	23735	11823	1	0	\N
181553	2134	86000296000	23735	11823	2	0	\N
181554	2134	85999293000	23735	11823	3	0	\N
181555	2133	93418274000	23735	11823	4	0	\N
181558	2134	86000296000	23736	11823	2	0	4576
181559	1397	1297475882000	23737	11824	0	0	14135
181560	2134	85999293000	23737	11824	1	0	4577
181565	1397	1297475882000	23738	11824	0	0	\N
181566	2134	85999293000	23738	11824	1	0	\N
181567	2134	85998290000	23738	11824	2	0	\N
181568	2132	147724726000	23738	11824	3	0	\N
181569	2133	93418274000	23738	11824	4	0	\N
181570	2133	93417272000	23738	11824	5	0	\N
181571	1397	1297475882000	23739	11824	0	0	\N
181572	2134	85998290000	23739	11824	1	0	\N
181573	2133	93417272000	23739	11824	2	0	\N
181574	2132	147724726000	23739	11824	3	0	\N
181575	1397	1297475882000	23740	11824	0	0	\N
181576	2134	85998290000	23740	11824	1	0	\N
181577	2133	93417272000	23740	11824	2	0	\N
181578	2132	147724726000	23740	11824	3	0	\N
181579	1397	1297475882000	23741	11824	0	0	\N
181580	2134	85998290000	23741	11824	1	0	\N
181581	2133	93417272000	23741	11824	2	0	\N
181582	2132	147724726000	23741	11824	3	0	\N
181583	1397	1297475882000	23742	11824	0	0	\N
181584	2133	93417272000	23742	11824	1	0	\N
181620	2058	535500000	23748	11821	0	0	\N
181621	1397	1297515886000	23748	11821	1	0	\N
181622	1397	1297505885000	23748	11821	2	0	\N
181623	1397	1297495884000	23748	11821	3	0	\N
181624	1397	1297485883000	23748	11821	4	0	\N
181625	1397	1297475882000	23748	11821	5	0	\N
181626	1397	1297465881000	23748	11821	6	0	\N
181627	1397	1297455880000	23748	11821	7	0	\N
181628	1397	1297445879000	23748	11821	8	0	\N
181629	1397	1297435878000	23748	11821	9	0	\N
181630	1397	1297425877000	23748	11821	10	0	\N
181631	1397	1297415876000	23748	11821	11	0	\N
181632	1397	1297405875000	23748	11821	12	0	\N
181633	1397	1297395874000	23748	11821	13	0	\N
181634	1397	1297385873000	23748	11821	14	0	\N
181635	1397	1297375872000	23748	11821	15	0	\N
181636	1397	1297365871000	23748	11821	16	0	\N
181637	2132	147725727000	23748	11821	17	0	\N
181638	2134	86003305000	23748	11821	18	0	\N
181639	2133	93422282000	23748	11821	19	0	\N
181640	2133	93421280000	23748	11821	20	0	\N
181641	2133	93420278000	23748	11821	21	0	\N
181642	2133	93419276000	23748	11821	22	0	\N
181643	2134	86002302000	23748	11821	23	0	\N
181644	2132	147724726000	23748	11821	24	0	\N
181645	2132	147723725000	23748	11821	25	0	\N
181646	2132	147722724000	23748	11821	26	0	\N
181647	2132	147721723000	23748	11821	27	0	\N
181648	2133	93418274000	23748	11821	28	0	\N
181649	2133	93417272000	23748	11821	29	0	\N
181650	2133	93416270000	23748	11821	30	0	\N
181651	2134	86001299000	23748	11821	31	0	\N
181652	2134	86000296000	23748	11821	32	0	\N
181653	2134	85999293000	23748	11821	33	0	\N
181654	2134	85998290000	23748	11821	34	0	\N
181655	2134	85997287000	23748	11821	35	0	\N
181656	2134	85996284000	23748	11821	36	0	\N
181657	2134	85995281000	23748	11821	37	0	\N
181658	2134	85994278000	23748	11821	38	0	\N
181659	2134	85993275000	23748	11821	39	0	\N
181660	2134	85992272000	23748	11821	40	0	\N
181661	2134	85991269000	23748	11821	41	0	\N
181662	2134	85990266000	23748	11821	42	0	\N
181663	2134	85989263000	23748	11821	43	0	\N
181664	2133	93415268000	23748	11821	44	0	\N
181665	2133	93414266000	23748	11821	45	0	\N
181666	2133	93413264000	23748	11821	46	0	\N
181667	2133	93412262000	23748	11821	47	0	\N
181668	2133	93411260000	23748	11821	48	0	\N
181669	2133	93410258000	23748	11821	49	0	\N
181670	2133	93409256000	23748	11821	50	0	\N
181671	2133	93408254000	23748	11821	51	0	\N
181672	2133	93407252000	23748	11821	52	0	\N
181673	2133	93406250000	23748	11821	53	0	\N
181674	2134	85988260000	23748	11821	54	0	\N
181675	1397	1297355870000	23749	11829	0	0	\N
181676	2133	93405248000	23749	11829	1	0	\N
181677	2134	85987257000	23749	11829	2	0	\N
181678	2133	93405248000	23750	11829	0	0	\N
181682	1397	1297355870000	23752	11829	0	0	\N
181683	2133	93405248000	23752	11829	1	0	\N
181684	2134	85987257000	23752	11829	2	0	\N
181685	1397	1297355870000	23753	11822	0	0	\N
181686	2133	93405248000	23753	11822	1	0	\N
181687	2134	85987257000	23753	11822	2	0	\N
181688	1397	1297345869000	23754	11830	0	0	\N
181689	2134	85986254000	23754	11830	1	0	\N
181690	2133	93404246000	23754	11830	2	0	\N
181691	1397	1297345869000	23755	11830	0	0	\N
181692	2134	85986254000	23755	11830	1	0	\N
181693	2133	93404246000	23755	11830	2	0	\N
181563	2133	93418274000	23737	11824	4	0	4364
181564	2133	93417272000	23737	11824	5	0	4365
181585	1397	1297465881000	23743	11825	0	0	14136
181586	2133	93416270000	23743	11825	1	0	4366
181587	1397	1297455880000	23744	11826	0	0	14137
181589	2133	93415268000	23744	11826	2	0	4367
181590	1397	1297445879000	23746	11827	0	0	14138
181591	1397	1297435878000	23746	11827	1	0	14139
181592	1397	1297425877000	23746	11827	2	0	14140
181593	1397	1297415876000	23746	11827	3	0	14141
181595	1397	1297395874000	23746	11827	5	0	14143
181596	1397	1297385873000	23746	11827	6	0	14144
181597	2133	93414266000	23746	11827	7	0	4368
181598	2133	93413264000	23746	11827	8	0	4369
181600	2134	85996284000	23746	11827	10	0	4580
181601	2134	85995281000	23746	11827	11	0	4581
181602	2134	85994278000	23746	11827	12	0	4582
181603	2134	85993275000	23746	11827	13	0	4583
181604	2134	85992272000	23746	11827	14	0	4584
181606	2133	93412262000	23746	11827	16	0	4370
181607	2133	93411260000	23746	11827	17	0	4371
181608	2133	93410258000	23746	11827	18	0	4372
181609	2133	93409256000	23746	11827	19	0	4373
181610	2133	93408254000	23746	11827	20	0	4374
181612	2134	85990266000	23746	11827	22	0	4586
181613	1397	1297375872000	23747	11828	0	0	14145
181614	1397	1297365871000	23747	11828	1	0	14146
181615	2133	93407252000	23747	11828	2	0	4375
181617	2133	93406250000	23747	11828	4	0	4376
181618	2132	147721723000	23747	11828	5	0	1277
181619	2134	85988260000	23747	11828	6	0	4588
181679	1397	1297355870000	23751	11829	0	0	14147
181680	2133	93405248000	23751	11829	1	0	4377
181694	1397	1297345869000	23756	11830	0	0	14148
181695	2134	85986254000	23756	11830	1	0	4590
181696	2133	93404246000	23756	11830	2	0	4378
181697	42	74368733400000	23757	11774	0	0	\N
181698	42	72080927000000	23757	11774	1	0	\N
181699	42	70537175800000	23757	11774	2	0	\N
181700	42	69260595000000	23757	11774	3	0	\N
181701	2058	535500000	23757	11774	4	0	\N
181702	1397	1298195954000	23757	11774	5	0	\N
181703	1397	1298185953000	23757	11774	6	0	\N
181704	1397	1298175952000	23757	11774	7	0	\N
181705	1397	1298165951000	23757	11774	8	0	\N
181706	1397	1298155950000	23757	11774	9	0	\N
181707	1397	1298145949000	23757	11774	10	0	\N
181708	1397	1298135948000	23757	11774	11	0	\N
181709	1397	1298125947000	23757	11774	12	0	\N
181710	1397	1298115946000	23757	11774	13	0	\N
181711	1397	1298105945000	23757	11774	14	0	\N
181712	1397	1298095944000	23757	11774	15	0	\N
181713	1397	1298085943000	23757	11774	16	0	\N
181714	1397	1298075942000	23757	11774	17	0	\N
181715	1397	1298065941000	23757	11774	18	0	\N
181716	1397	1298055940000	23757	11774	19	0	\N
181717	1397	1298045939000	23757	11774	20	0	\N
181718	1397	1298035938000	23757	11774	21	0	\N
181719	1397	1298025937000	23757	11774	22	0	\N
181720	1397	1298015936000	23757	11774	23	0	\N
181721	1397	1298005935000	23757	11774	24	0	\N
181722	1397	1297995934000	23757	11774	25	0	\N
181723	1397	1297985933000	23757	11774	26	0	\N
181724	1397	1297975932000	23757	11774	27	0	\N
181725	1397	1297965931000	23757	11774	28	0	\N
181726	1397	1297955930000	23757	11774	29	0	\N
181727	1397	1297945929000	23757	11774	30	0	\N
181728	1397	1297935928000	23757	11774	31	0	\N
181729	1397	1297925927000	23757	11774	32	0	\N
181730	1397	1297915926000	23757	11774	33	0	\N
181731	1397	1297905925000	23757	11774	34	0	\N
181732	1397	1297895924000	23757	11774	35	0	\N
181733	1397	1297885923000	23757	11774	36	0	\N
181734	1397	1297875922000	23757	11774	37	0	\N
181735	1397	1297865921000	23757	11774	38	0	\N
181736	1397	1297855920000	23757	11774	39	0	\N
181737	1397	1297845919000	23757	11774	40	0	\N
181738	1397	1297835918000	23757	11774	41	0	\N
181739	1397	1297825917000	23757	11774	42	0	\N
181740	1397	1297815916000	23757	11774	43	0	\N
181741	1397	1297805915000	23757	11774	44	0	\N
181742	1397	1297795914000	23757	11774	45	0	\N
181743	1397	1297785913000	23757	11774	46	0	\N
181744	1397	1297775912000	23757	11774	47	0	\N
181745	1397	1297765911000	23757	11774	48	0	\N
181746	1397	1297755910000	23757	11774	49	0	\N
181747	1397	1297745909000	23757	11774	50	0	\N
181748	1397	1297735908000	23757	11774	51	0	\N
181749	1397	1297725907000	23757	11774	52	0	\N
181750	1397	1297715906000	23757	11774	53	0	\N
181751	1397	1297705905000	23757	11774	54	0	\N
181752	1397	1297695904000	23757	11774	55	0	\N
181753	1397	1297685903000	23757	11774	56	0	\N
181754	1397	1297675902000	23757	11774	57	0	\N
181755	1397	1297665901000	23757	11774	58	0	\N
181756	1397	1297655900000	23757	11774	59	0	\N
181757	1397	1297645899000	23757	11774	61	0	\N
181758	1397	1297635898000	23757	11774	62	0	\N
181759	1397	1297625897000	23757	11774	63	0	\N
181760	1397	1297615896000	23757	11774	64	0	\N
181761	1397	1297605895000	23757	11774	65	0	\N
181762	1397	1297595894000	23757	11774	66	0	\N
181763	1397	1297585893000	23757	11774	67	0	\N
181764	1397	1297575892000	23757	11774	68	0	\N
181765	1397	1297565891000	23757	11774	69	0	\N
181766	1397	1297555890000	23757	11774	70	0	\N
181767	1397	1297545889000	23757	11774	71	0	\N
181768	1397	1297535888000	23757	11774	72	0	\N
181769	1397	1297525887000	23757	11774	73	0	\N
181770	1397	1297515886000	23757	11774	74	0	\N
181771	1397	1297505885000	23757	11774	75	0	\N
181772	1397	1297495884000	23757	11774	76	0	\N
181773	1397	1297485883000	23757	11774	77	0	\N
181774	1397	1297475882000	23757	11774	78	0	\N
181775	1397	1297465881000	23757	11774	79	0	\N
181776	1397	1297455880000	23757	11774	80	0	\N
181777	1397	1297445879000	23757	11774	81	0	\N
181778	1397	1297435878000	23757	11774	82	0	\N
181779	1397	1297425877000	23757	11774	83	0	\N
181780	1397	1297415876000	23757	11774	84	0	\N
181781	1397	1297405875000	23757	11774	85	0	\N
181782	1397	1297395874000	23757	11774	86	0	\N
181783	1397	1297385873000	23757	11774	87	0	\N
181784	1397	1297375872000	23757	11774	88	0	\N
181785	1397	1297365871000	23757	11774	89	0	\N
181786	1397	1297355870000	23757	11774	90	0	\N
181787	1397	1297345869000	23757	11774	91	0	\N
181788	1747	65931000000	23757	11774	92	0	\N
181789	2132	147746748000	23757	11774	93	0	\N
181790	2134	86072512000	23757	11774	94	0	\N
181791	1746	11644491000000	23757	11774	95	0	\N
181792	1746	7075490000000	23757	11774	96	0	\N
181793	1746	3992489000000	23757	11774	97	0	\N
181794	2134	86071509000	23757	11774	98	0	\N
181795	2134	86070506000	23757	11774	99	0	\N
181796	1746	3990488000000	23757	11774	100	0	\N
181797	2134	86069503000	23757	11774	101	0	\N
181798	2134	86068500000	23757	11774	102	0	\N
181799	2134	86067497000	23757	11774	103	0	\N
181800	2134	86066494000	23757	11774	104	0	\N
181801	2134	86065491000	23757	11774	105	0	\N
181802	2134	86064488000	23757	11774	106	0	\N
181803	2134	86063485000	23757	11774	107	0	\N
181804	2134	86062482000	23757	11774	108	0	\N
181805	1746	1248843000000	23757	11774	109	0	\N
181806	2134	86061479000	23757	11774	110	0	\N
181807	2134	86060476000	23757	11774	111	0	\N
181808	2134	86059473000	23757	11774	112	0	\N
181809	2134	86058470000	23757	11774	113	0	\N
181810	2134	86057467000	23757	11774	114	0	\N
181811	2134	86056464000	23757	11774	115	0	\N
181812	2134	86055461000	23757	11774	116	0	\N
181813	2134	86054458000	23757	11774	117	0	\N
181814	2134	86053455000	23757	11774	118	0	\N
181815	2134	86052452000	23757	11774	119	0	\N
181816	2134	86051449000	23757	11774	120	0	\N
181817	2134	86050446000	23757	11774	121	0	\N
181818	2134	86049443000	23757	11774	122	0	\N
181819	2134	86048440000	23757	11774	123	0	\N
181820	2134	86047437000	23757	11774	124	0	\N
181825	1397	1297485883000	23759	11754	0	0	\N
181826	1397	1297475882000	23759	11754	1	0	\N
181827	1397	1297465881000	23759	11754	2	0	\N
181828	1397	1297455880000	23759	11754	3	0	\N
181829	1397	1297445879000	23759	11754	4	0	\N
181830	1397	1297435878000	23759	11754	5	0	\N
181831	1397	1297425877000	23759	11754	6	0	\N
181832	1397	1297415876000	23759	11754	7	0	\N
181823	2132	147720722000	23758	11831	2	0	1278
181824	2134	85985251000	23758	11831	3	0	4591
181833	1397	1297405875000	23759	11754	8	0	\N
181834	1397	1297395874000	23759	11754	9	0	\N
181835	1397	1297385873000	23759	11754	10	0	\N
181836	1397	1297375872000	23759	11754	11	0	\N
181837	1397	1297365871000	23759	11754	12	0	\N
181838	1397	1297355870000	23759	11754	13	0	\N
181839	1397	1297345869000	23759	11754	14	0	\N
181840	2134	86101599000	23759	11754	15	0	\N
181841	2132	147751753000	23759	11754	16	0	\N
181842	2132	147750752000	23759	11754	17	0	\N
181843	2132	147749751000	23759	11754	18	0	\N
181844	2133	93519476000	23759	11754	19	0	\N
181845	2133	93518474000	23759	11754	20	0	\N
181846	2133	93517472000	23759	11754	21	0	\N
181847	2133	93516470000	23759	11754	22	0	\N
181848	2133	93515468000	23759	11754	23	0	\N
181849	2133	93514466000	23759	11754	24	0	\N
181850	2133	93513464000	23759	11754	25	0	\N
181851	2133	93512462000	23759	11754	26	0	\N
181852	2133	93511460000	23759	11754	27	0	\N
181853	2133	93510458000	23759	11754	28	0	\N
181854	2133	93509456000	23759	11754	29	0	\N
181855	2133	93508454000	23759	11754	30	0	\N
181856	2133	93507452000	23759	11754	31	0	\N
181857	2133	93506450000	23759	11754	32	0	\N
181858	2133	93505448000	23759	11754	33	0	\N
181859	2133	93504446000	23759	11754	34	0	\N
181860	2133	93503444000	23759	11754	35	0	\N
181861	2133	93502442000	23759	11754	36	0	\N
181862	2133	93501440000	23759	11754	37	0	\N
181863	2133	93500438000	23759	11754	38	0	\N
181864	2133	93499436000	23759	11754	39	0	\N
181865	2133	93498434000	23759	11754	40	0	\N
181866	2133	93497432000	23759	11754	41	0	\N
181867	2133	93496430000	23759	11754	42	0	\N
181868	2133	93495428000	23759	11754	43	0	\N
181869	2133	93494426000	23759	11754	44	0	\N
181870	2133	93493424000	23759	11754	45	0	\N
181871	2133	93492422000	23759	11754	46	0	\N
181872	2133	93491420000	23759	11754	47	0	\N
181873	2133	93490418000	23759	11754	48	0	\N
181874	2133	93489416000	23759	11754	49	0	\N
181875	2133	93488414000	23759	11754	50	0	\N
181876	2133	93487412000	23759	11754	51	0	\N
181877	2133	93486410000	23759	11754	52	0	\N
181878	2133	93485408000	23759	11754	53	0	\N
181879	2133	93484406000	23759	11754	54	0	\N
181880	2133	93483404000	23759	11754	55	0	\N
181881	2133	93482402000	23759	11754	56	0	\N
181882	2133	93481400000	23759	11754	57	0	\N
181883	2133	93480398000	23759	11754	58	0	\N
181884	2132	147748750000	23759	11754	59	0	\N
181885	2132	147747749000	23759	11754	60	0	\N
181886	2132	147746748000	23759	11754	61	0	\N
181887	2134	86100596000	23759	11754	62	0	\N
181888	2134	86099593000	23759	11754	63	0	\N
181889	2134	86098590000	23759	11754	64	0	\N
181890	2134	86097587000	23759	11754	65	0	\N
181891	2134	86096584000	23759	11754	66	0	\N
181892	2134	86095581000	23759	11754	67	0	\N
181893	2134	86094578000	23759	11754	68	0	\N
181894	2134	86093575000	23759	11754	69	0	\N
181895	2134	86092572000	23759	11754	70	0	\N
181896	2134	86091569000	23759	11754	71	0	\N
181897	2134	86090566000	23759	11754	72	0	\N
181898	2134	86089563000	23759	11754	73	0	\N
181899	2134	86088560000	23759	11754	74	0	\N
181900	2134	86087557000	23759	11754	75	0	\N
181901	2134	86086554000	23759	11754	76	0	\N
181902	2134	86085551000	23759	11754	77	0	\N
181903	2134	86084548000	23759	11754	78	0	\N
181904	2134	86083545000	23759	11754	79	0	\N
181905	2134	86082542000	23759	11754	81	0	\N
181906	2134	86081539000	23759	11754	82	0	\N
181907	2134	86080536000	23759	11754	83	0	\N
181908	2134	86079533000	23759	11754	84	0	\N
181909	2134	86078530000	23759	11754	85	0	\N
181910	2134	86077527000	23759	11754	86	0	\N
181911	2134	86076524000	23759	11754	87	0	\N
181912	2134	86075521000	23759	11754	88	0	\N
181913	2134	86074518000	23759	11754	89	0	\N
181914	2134	86073515000	23759	11754	90	0	\N
181915	2134	86072512000	23759	11754	91	0	\N
181916	2134	86071509000	23759	11754	92	0	\N
181917	2134	86070506000	23759	11754	93	0	\N
181918	2134	86069503000	23759	11754	94	0	\N
181919	2134	86068500000	23759	11754	95	0	\N
181920	2134	86067497000	23759	11754	96	0	\N
181921	2134	86066494000	23759	11754	97	0	\N
181922	2134	86065491000	23759	11754	98	0	\N
181923	2134	86064488000	23759	11754	99	0	\N
181924	2134	86063485000	23759	11754	100	0	\N
181925	2134	86062482000	23759	11754	101	0	\N
181926	2134	86061479000	23759	11754	102	0	\N
181927	2134	86060476000	23759	11754	103	0	\N
181928	2134	86059473000	23759	11754	104	0	\N
181929	2134	86058470000	23759	11754	105	0	\N
181930	2134	86057467000	23759	11754	106	0	\N
181931	2134	86056464000	23759	11754	107	0	\N
181932	2134	86055461000	23759	11754	108	0	\N
181933	2134	86054458000	23759	11754	109	0	\N
181934	2134	86053455000	23759	11754	110	0	\N
181935	2134	86052452000	23759	11754	111	0	\N
181936	2134	86051449000	23759	11754	112	0	\N
181937	2134	86050446000	23759	11754	113	0	\N
181938	2134	86049443000	23759	11754	114	0	\N
181939	2134	86048440000	23759	11754	115	0	\N
181940	2134	86047437000	23759	11754	116	0	\N
181941	2134	86046434000	23759	11754	117	0	\N
181942	2134	86045431000	23759	11754	118	0	\N
181943	2134	86044428000	23759	11754	119	0	\N
181944	2134	86043425000	23759	11754	120	0	\N
181945	2134	86042422000	23759	11754	121	0	\N
181946	2134	86041419000	23759	11754	122	0	\N
181947	2134	86040416000	23759	11754	123	0	\N
181948	2132	147745747000	23759	11754	124	0	\N
181949	2132	147744746000	23759	11754	125	0	\N
181950	1397	1297325867000	23760	11832	0	0	\N
181951	1397	1297315866000	23760	11832	1	0	\N
181952	2134	85984248000	23760	11832	2	0	\N
181953	2134	85983245000	23760	11832	3	0	\N
181954	2133	93402242000	23760	11832	4	0	\N
181955	2133	93401240000	23760	11832	5	0	\N
181962	2058	535500000	23762	11785	0	0	\N
181963	1397	1298035938000	23762	11785	1	0	\N
181964	1397	1298025937000	23762	11785	2	0	\N
181965	1397	1298015936000	23762	11785	3	0	\N
181966	1397	1298005935000	23762	11785	4	0	\N
181967	1397	1297995934000	23762	11785	5	0	\N
181968	1397	1297985933000	23762	11785	6	0	\N
181958	2134	85984248000	23761	11832	2	0	4592
181959	2134	85983245000	23761	11832	3	0	4593
181960	2133	93402242000	23761	11832	4	0	4380
181961	2133	93401240000	23761	11832	5	0	4381
181969	1397	1297975932000	23762	11785	7	0	\N
181970	1397	1297965931000	23762	11785	8	0	\N
181971	1397	1297955930000	23762	11785	9	0	\N
181972	1397	1297945929000	23762	11785	10	0	\N
181973	1397	1297935928000	23762	11785	11	0	\N
181974	1397	1297925927000	23762	11785	12	0	\N
181975	1397	1297915926000	23762	11785	13	0	\N
181976	1397	1297905925000	23762	11785	14	0	\N
181977	1397	1297895924000	23762	11785	15	0	\N
181978	1397	1297885923000	23762	11785	16	0	\N
181979	1397	1297875922000	23762	11785	17	0	\N
181980	1397	1297865921000	23762	11785	18	0	\N
181981	1397	1297855920000	23762	11785	19	0	\N
181982	1397	1297845919000	23762	11785	20	0	\N
181983	1397	1297835918000	23762	11785	21	0	\N
181984	1397	1297825917000	23762	11785	22	0	\N
181985	1397	1297815916000	23762	11785	23	0	\N
181986	1397	1297805915000	23762	11785	24	0	\N
181987	1397	1297795914000	23762	11785	25	0	\N
181988	1397	1297785913000	23762	11785	26	0	\N
181989	1397	1297775912000	23762	11785	27	0	\N
181990	1397	1297765911000	23762	11785	28	0	\N
181991	1397	1297755910000	23762	11785	29	0	\N
181992	1397	1297745909000	23762	11785	30	0	\N
181993	1397	1297735908000	23762	11785	31	0	\N
181994	1397	1297725907000	23762	11785	32	0	\N
181995	1397	1297715906000	23762	11785	33	0	\N
181996	1397	1297705905000	23762	11785	34	0	\N
181997	1397	1297695904000	23762	11785	35	0	\N
181998	1397	1297685903000	23762	11785	36	0	\N
181999	1397	1297675902000	23762	11785	37	0	\N
182000	1397	1297665901000	23762	11785	38	0	\N
182001	1397	1297655900000	23762	11785	39	0	\N
182002	1397	1297645899000	23762	11785	40	0	\N
182003	1397	1297635898000	23762	11785	41	0	\N
182004	1397	1297625897000	23762	11785	42	0	\N
182005	1397	1297615896000	23762	11785	43	0	\N
182006	1397	1297605895000	23762	11785	44	0	\N
182007	1397	1297595894000	23762	11785	45	0	\N
182008	1397	1297585893000	23762	11785	46	0	\N
182009	1397	1297575892000	23762	11785	47	0	\N
182010	1397	1297565891000	23762	11785	48	0	\N
182011	1397	1297555890000	23762	11785	49	0	\N
182012	1397	1297545889000	23762	11785	50	0	\N
182013	1397	1297535888000	23762	11785	51	0	\N
182014	1397	1297525887000	23762	11785	52	0	\N
182015	1397	1297515886000	23762	11785	53	0	\N
182016	1397	1297505885000	23762	11785	54	0	\N
182017	1397	1297495884000	23762	11785	55	0	\N
182018	1397	1297485883000	23762	11785	56	0	\N
182019	1397	1297475882000	23762	11785	57	0	\N
182020	1397	1297465881000	23762	11785	58	0	\N
182021	1397	1297455880000	23762	11785	59	0	\N
182022	1397	1297445879000	23762	11785	60	0	\N
182023	1397	1297435878000	23762	11785	61	0	\N
182024	1397	1297425877000	23762	11785	62	0	\N
182025	1397	1297415876000	23762	11785	63	0	\N
182026	1397	1297405875000	23762	11785	64	0	\N
182027	1397	1297395874000	23762	11785	65	0	\N
182028	1397	1297385873000	23762	11785	66	0	\N
182029	1397	1297375872000	23762	11785	67	0	\N
182030	1397	1297365871000	23762	11785	68	0	\N
182031	1397	1297355870000	23762	11785	69	0	\N
182032	1397	1297345869000	23762	11785	70	0	\N
182033	1397	1297335868000	23762	11785	71	0	\N
182034	1397	1297325867000	23762	11785	72	0	\N
182035	1397	1297315866000	23762	11785	73	0	\N
182036	1747	65931000000	23762	11785	74	0	\N
182037	1746	11644491000000	23762	11785	75	0	\N
182038	1746	7075490000000	23762	11785	76	0	\N
182039	2132	147741743000	23762	11785	77	0	\N
182040	2132	147740742000	23762	11785	78	0	\N
182041	1746	3992489000000	23762	11785	79	0	\N
182042	2133	93474386000	23762	11785	80	0	\N
182043	2134	86054458000	23762	11785	81	0	\N
182044	2132	147739741000	23762	11785	82	0	\N
182045	1746	3990488000000	23762	11785	83	0	\N
182046	2133	93473384000	23762	11785	84	0	\N
182047	2133	93472382000	23762	11785	85	0	\N
182048	2133	93471380000	23762	11785	86	0	\N
182049	2133	93470378000	23762	11785	87	0	\N
182050	1746	1248843000000	23762	11785	88	0	\N
182051	2133	93469376000	23762	11785	89	0	\N
182052	2133	93468374000	23762	11785	90	0	\N
182053	2133	93467372000	23762	11785	91	0	\N
182054	2133	93466370000	23762	11785	92	0	\N
182055	2133	93465368000	23762	11785	93	0	\N
182056	2133	93464366000	23762	11785	94	0	\N
182057	2133	93463364000	23762	11785	95	0	\N
182058	2133	93462362000	23762	11785	96	0	\N
182059	2133	93461360000	23762	11785	97	0	\N
182060	2133	93460358000	23762	11785	98	0	\N
182061	2133	93459356000	23762	11785	99	0	\N
182062	2133	93458354000	23762	11785	100	0	\N
182063	2133	93457352000	23762	11785	101	0	\N
182064	2133	93456350000	23762	11785	102	0	\N
182065	2133	93455348000	23762	11785	103	0	\N
182066	2133	93454346000	23762	11785	104	0	\N
182067	2133	93453344000	23762	11785	106	0	\N
182068	2133	93452342000	23762	11785	107	0	\N
182069	2133	93451340000	23762	11785	108	0	\N
182070	2133	93450338000	23762	11785	109	0	\N
182071	2133	93449336000	23762	11785	110	0	\N
182072	2133	93448334000	23762	11785	111	0	\N
182073	2133	93447332000	23762	11785	112	0	\N
182074	2133	93446330000	23762	11785	113	0	\N
182075	2133	93445328000	23762	11785	114	0	\N
182076	2133	93444326000	23762	11785	115	0	\N
182077	2134	86053455000	23762	11785	116	0	\N
182078	2134	86052452000	23762	11785	117	0	\N
182079	2134	86051449000	23762	11785	118	0	\N
182080	2134	86050446000	23762	11785	119	0	\N
182081	2134	86049443000	23762	11785	120	0	\N
182082	2134	86048440000	23762	11785	121	0	\N
182083	2134	86047437000	23762	11785	122	0	\N
182084	2134	86046434000	23762	11785	123	0	\N
182085	2134	86045431000	23762	11785	124	0	\N
182086	2134	86044428000	23762	11785	125	0	\N
182087	1397	1297305865000	23763	11833	0	0	\N
182088	1397	1297295864000	23763	11833	1	0	\N
182089	2133	93400238000	23763	11833	2	0	\N
182090	2134	85982242000	23763	11833	3	0	\N
182091	2133	93399236000	23763	11833	4	0	\N
182092	2132	147719721000	23763	11833	5	0	\N
182093	2134	85981239000	23763	11833	6	0	\N
182099	1397	1297305865000	23765	11833	0	0	\N
182100	1397	1297295864000	23765	11833	1	0	\N
182101	2133	93400238000	23765	11833	2	0	\N
182102	2134	85982242000	23765	11833	3	0	\N
182103	2133	93399236000	23765	11833	4	0	\N
182104	2132	147719721000	23765	11833	5	0	\N
182096	2133	93399236000	23764	11833	2	0	4383
182097	2132	147719721000	23764	11833	3	0	1279
182098	2134	85981239000	23764	11833	4	0	4595
182105	2134	85981239000	23765	11833	6	0	\N
182115	1397	1297265861000	23769	11836	0	0	\N
182116	2133	93396230000	23769	11836	1	0	\N
182117	2134	85978230000	23769	11836	2	0	\N
182124	1397	1297265861000	23772	11837	0	0	\N
182125	1397	1297255860000	23772	11837	1	0	\N
182126	2134	85977227000	23772	11837	2	0	\N
182127	2133	93395228000	23772	11837	3	0	\N
182138	1397	1297225857000	23775	11839	0	0	\N
182139	2134	85974218000	23775	11839	1	0	\N
182140	2133	93392222000	23775	11839	2	0	\N
182141	1397	1297225857000	23776	11839	0	0	\N
182142	2134	85974218000	23776	11839	1	0	\N
182143	2133	93392222000	23776	11839	2	0	\N
182144	1397	1297215856000	23777	11840	0	0	\N
182145	2134	85973215000	23777	11840	1	0	\N
182146	2133	93391220000	23777	11840	2	0	\N
182154	2133	93389216000	23781	11842	0	0	\N
182155	2133	93388214000	23781	11842	1	0	\N
182156	1397	1297195854000	23782	11842	0	0	\N
182157	1397	1297185853000	23782	11842	1	0	\N
182158	2133	93389216000	23782	11842	2	0	\N
182159	2134	85971209000	23782	11842	3	0	\N
182160	2133	93388214000	23782	11842	4	0	\N
182161	2134	85970206000	23782	11842	5	0	\N
182170	1397	1297175852000	23785	11843	0	0	\N
182171	2132	147715717000	23785	11843	1	0	\N
182172	2133	93387212000	23785	11843	2	0	\N
182173	2134	85969203000	23785	11843	3	0	\N
182174	1397	1297175852000	23786	11843	0	0	\N
182175	2132	147715717000	23786	11843	1	0	\N
182176	2133	93387212000	23786	11843	2	0	\N
182177	2134	85969203000	23786	11843	3	0	\N
182178	1397	1297175852000	23787	11843	0	0	\N
182179	2132	147715717000	23787	11843	1	0	\N
182180	2133	93387212000	23787	11843	2	0	\N
182181	2134	85969203000	23787	11843	3	0	\N
182182	1397	1297175852000	23788	11843	0	0	\N
182183	2132	147715717000	23788	11843	1	0	\N
182184	2133	93387212000	23788	11843	2	0	\N
182185	2134	85969203000	23788	11843	3	0	\N
182191	1397	1297175852000	23790	11844	0	0	\N
182192	1397	1297165851000	23790	11844	1	0	\N
182193	2133	93386210000	23790	11844	2	0	\N
182194	2134	85969203000	23790	11844	3	0	\N
182195	2134	85968200000	23790	11844	4	0	\N
182196	1397	1297155850000	23791	11845	0	0	\N
182197	2134	85967197000	23791	11845	1	0	\N
182198	2133	93385208000	23791	11845	2	0	\N
182201	1397	1297155850000	23793	11845	0	0	\N
182202	2134	85967197000	23793	11845	1	0	\N
182203	2133	93385208000	23793	11845	2	0	\N
182204	1397	1297155850000	23794	11845	0	0	\N
182205	2134	85967197000	23794	11845	1	0	\N
182206	2133	93385208000	23794	11845	2	0	\N
182207	1397	1297155850000	23795	11845	0	0	\N
182208	2134	85967197000	23795	11845	1	0	\N
182209	2133	93385208000	23795	11845	2	0	\N
182210	1397	1297155850000	23796	11846	0	0	\N
182211	1397	1297145849000	23796	11846	1	0	\N
182212	2133	93384206000	23796	11846	2	0	\N
182213	2134	85966194000	23796	11846	3	0	\N
182214	1397	1297155850000	23797	11846	0	0	\N
182215	1397	1297145849000	23797	11846	1	0	\N
182216	2133	93384206000	23797	11846	2	0	\N
182217	2134	85966194000	23797	11846	3	0	\N
182218	1397	1297155850000	23798	11846	0	0	\N
182219	1397	1297145849000	23798	11846	1	0	\N
182220	2133	93384206000	23798	11846	2	0	\N
182221	2134	85966194000	23798	11846	3	0	\N
182222	1397	1297155850000	23799	11846	0	0	\N
182223	1397	1297145849000	23799	11846	1	0	\N
182224	2133	93384206000	23799	11846	2	0	\N
182225	2134	85966194000	23799	11846	3	0	\N
182237	1397	1297135848000	23802	11847	0	0	\N
182238	1397	1297125847000	23802	11847	1	0	\N
182239	2133	93383204000	23802	11847	2	0	\N
182240	2133	93382202000	23802	11847	3	0	\N
182108	1397	1297285863000	23766	11834	2	0	14154
182109	2133	93398234000	23766	11834	3	0	4384
182110	2134	85980236000	23766	11834	4	0	4596
182111	1397	1297275862000	23767	11835	0	0	14155
182112	2133	93397232000	23767	11835	2	0	4385
182114	2132	147718720000	23767	11835	4	0	1280
182118	2133	93396230000	23770	11836	0	0	4386
182119	2134	85978230000	23770	11836	1	0	4598
182120	1397	1297265861000	23771	11837	0	0	14156
182121	1397	1297255860000	23771	11837	1	0	14157
182123	2133	93395228000	23771	11837	3	0	4387
182128	1397	1297245859000	23773	11838	0	0	14158
182129	1397	1297235858000	23773	11838	1	0	14159
182130	2133	93394226000	23773	11838	2	0	4388
182132	2134	85976224000	23773	11838	4	0	4600
182133	2134	85975221000	23773	11838	5	0	4601
182134	2132	147717719000	23773	11838	6	0	1281
182135	1397	1297225857000	23774	11839	0	0	14160
182136	2134	85974218000	23774	11839	1	0	4602
182147	1397	1297215856000	23778	11840	0	0	14161
182148	2134	85973215000	23778	11840	1	0	4603
182149	2133	93391220000	23778	11840	2	0	4391
182150	1397	1297205855000	23780	11841	0	0	14162
182151	2132	147716718000	23780	11841	1	0	1282
182153	2134	85972212000	23780	11841	3	0	4604
182162	1397	1297195854000	23783	11842	0	0	14163
182163	1397	1297185853000	23783	11842	1	0	14164
182164	2133	93389216000	23783	11842	2	0	4393
182166	2133	93388214000	23783	11842	4	0	4394
182167	2134	85970206000	23783	11842	5	0	4606
182168	2132	147715717000	23784	11843	0	0	1283
182169	2133	93387212000	23784	11843	1	0	4395
182186	1397	1297175852000	23789	11844	0	0	14165
182188	2133	93386210000	23789	11844	2	0	4396
182189	2134	85969203000	23789	11844	3	0	4607
182190	2134	85968200000	23789	11844	4	0	4608
182199	2134	85967197000	23792	11845	0	0	4609
182200	2133	93385208000	23792	11845	1	0	4397
182227	1397	1297145849000	23800	11846	1	0	14168
182228	2133	93384206000	23800	11846	2	0	4398
182229	2134	85966194000	23800	11846	3	0	4610
182230	1397	1297135848000	23801	11847	0	0	14169
182232	2133	93383204000	23801	11847	2	0	4399
182233	2133	93382202000	23801	11847	3	0	4400
182234	2132	147714716000	23801	11847	4	0	1284
182235	2134	85965191000	23801	11847	5	0	4611
182236	2134	85964188000	23801	11847	6	0	4612
182241	2132	147714716000	23802	11847	4	0	\N
182242	2134	85965191000	23802	11847	5	0	\N
182243	2134	85964188000	23802	11847	6	0	\N
182247	1397	1297115846000	23804	11848	0	0	\N
182248	2134	85963185000	23804	11848	1	0	\N
182249	2133	93381200000	23804	11848	2	0	\N
182265	1419	17567031560130	23808	11851	0	0	\N
182266	1397	1297075842000	23808	11851	1	0	\N
182267	2134	85959173000	23808	11851	2	0	\N
182268	2133	93377192000	23808	11851	3	0	\N
182269	2132	147712714000	23808	11851	4	0	\N
182270	1397	1297065841000	23809	11852	0	0	\N
182271	2133	93376190000	23809	11852	1	0	\N
182272	2134	85958170000	23809	11852	2	0	\N
182273	1397	1297065841000	23810	11852	0	0	\N
182274	2133	93376190000	23810	11852	1	0	\N
182275	2134	85958170000	23810	11852	2	0	\N
182279	1397	1297055840000	23812	11853	0	0	\N
182280	2133	93375188000	23812	11853	1	0	\N
182281	2134	85957167000	23812	11853	2	0	\N
182285	1397	1297055840000	23814	11853	0	0	\N
182286	2133	93375188000	23814	11853	1	0	\N
182287	2134	85957167000	23814	11853	2	0	\N
182301	1397	1297025837000	23818	11856	0	0	\N
182302	1397	1297015836000	23818	11856	1	0	\N
182303	2133	93372182000	23818	11856	3	0	\N
182304	2133	93371180000	23818	11856	4	0	\N
182305	2134	85954158000	23818	11856	5	0	\N
182306	2134	85953155000	23818	11856	6	0	\N
182307	1397	1297005835000	23819	11857	0	0	\N
182308	1397	1296995834000	23819	11857	1	0	\N
182309	2132	147710712000	23819	11857	2	0	\N
182310	2133	93370178000	23819	11857	3	0	\N
182311	2133	93369176000	23819	11857	4	0	\N
182312	2134	85952152000	23819	11857	5	0	\N
182313	2134	85951149000	23819	11857	6	0	\N
182323	1397	1296985833000	23822	11858	0	0	\N
182324	2133	93368174000	23822	11858	1	0	\N
182325	2134	85950146000	23822	11858	2	0	\N
182326	1397	1296975832000	23823	11859	0	0	\N
182327	1397	1296965831000	23823	11859	1	0	\N
182328	2133	93367172000	23823	11859	2	0	\N
182329	2133	93366170000	23823	11859	3	0	\N
182330	2132	147709711000	23823	11859	4	0	\N
182339	1397	1296975832000	23825	11859	0	0	\N
182340	1397	1296965831000	23825	11859	1	0	\N
182341	2133	93367172000	23825	11859	2	0	\N
182342	2133	93366170000	23825	11859	3	0	\N
182343	2132	147709711000	23825	11859	4	0	\N
182344	2134	85950146000	23825	11859	5	0	\N
182345	2134	85949143000	23825	11859	6	0	\N
182346	2134	85948140000	23825	11859	7	0	\N
182353	1419	17567031560130	23828	11847	0	0	\N
182354	1397	1296935828000	23829	11862	0	0	\N
182355	1397	1296925827000	23829	11862	1	0	\N
182356	2133	93363164000	23829	11862	2	0	\N
182357	2133	93362162000	23829	11862	3	0	\N
182358	2132	147708710000	23829	11862	4	0	\N
182359	2134	85945131000	23829	11862	5	0	\N
182360	2134	85944128000	23829	11862	6	0	\N
182361	1397	1296935828000	23830	11862	0	0	\N
182362	1397	1296925827000	23830	11862	1	0	\N
182363	2133	93363164000	23830	11862	2	0	\N
182364	2133	93362162000	23830	11862	3	0	\N
182365	2132	147708710000	23830	11862	4	0	\N
182366	2134	85945131000	23830	11862	5	0	\N
182367	2134	85944128000	23830	11862	6	0	\N
182368	1397	1296935828000	23831	11862	0	0	\N
182369	1397	1296925827000	23831	11862	1	0	\N
182370	2133	93363164000	23831	11862	2	0	\N
182371	2133	93362162000	23831	11862	3	0	\N
182372	2132	147708710000	23831	11862	4	0	\N
182373	2134	85945131000	23831	11862	5	0	\N
182374	2134	85944128000	23831	11862	6	0	\N
182246	2133	93381200000	23803	11848	2	0	4401
182250	1397	1297105845000	23805	11849	0	0	14172
182251	2134	85962182000	23805	11849	1	0	4614
182252	2132	147713715000	23805	11849	2	0	1285
182253	2133	93380198000	23805	11849	3	0	4402
182255	1397	1297085843000	23806	11850	1	0	14174
182256	2134	85961179000	23806	11850	2	0	4615
182257	2134	85960176000	23806	11850	3	0	4616
182258	2133	93379196000	23806	11850	4	0	4403
182259	2133	93378194000	23806	11850	5	0	4404
182261	1397	1297075842000	23807	11851	1	0	14175
182262	2134	85959173000	23807	11851	2	0	4617
182263	2133	93377192000	23807	11851	3	0	4405
182264	2132	147712714000	23807	11851	4	0	1286
182277	2133	93376190000	23811	11852	1	0	4406
182278	2134	85958170000	23811	11852	2	0	4618
182282	1397	1297055840000	23813	11853	0	0	14177
182283	2133	93375188000	23813	11853	1	0	4407
182284	2134	85957167000	23813	11853	2	0	4619
182289	2133	93374186000	23815	11854	1	0	4408
182290	2134	85956164000	23815	11854	2	0	4620
182291	1397	1297035838000	23816	11855	0	0	14179
182292	2133	93373184000	23816	11855	1	0	4409
182293	2134	85955161000	23816	11855	2	0	4621
182295	1397	1297025837000	23817	11856	0	0	14180
182296	1397	1297015836000	23817	11856	1	0	14181
182297	2133	93372182000	23817	11856	3	0	4410
182298	2133	93371180000	23817	11856	4	0	4411
182300	2134	85953155000	23817	11856	6	0	4623
182314	1397	1297005835000	23820	11857	0	0	14182
182315	1397	1296995834000	23820	11857	1	0	14183
182316	2132	147710712000	23820	11857	2	0	1288
182317	2133	93370178000	23820	11857	3	0	4412
182319	2134	85952152000	23820	11857	5	0	4624
182320	2134	85951149000	23820	11857	6	0	4625
182321	1397	1296985833000	23821	11858	0	0	14184
182322	2133	93368174000	23821	11858	1	0	4414
182331	1397	1296975832000	23824	11859	0	0	14185
182333	2133	93367172000	23824	11859	2	0	4415
182334	2133	93366170000	23824	11859	3	0	4416
182335	2132	147709711000	23824	11859	4	0	1289
182336	2134	85950146000	23824	11859	5	0	4626
182338	2134	85948140000	23824	11859	7	0	4628
182347	1397	1296955830000	23826	11860	0	0	14187
182348	2134	85947137000	23826	11860	1	0	4629
182349	2133	93365168000	23826	11860	2	0	4417
182350	1397	1296945829000	23827	11861	0	0	14188
182352	2133	93364166000	23827	11861	2	0	4418
182375	1397	1296935828000	23832	11862	0	0	14189
182376	1397	1296925827000	23832	11862	1	0	14190
182382	1397	1296935828000	23833	11862	0	0	\N
182383	1397	1296925827000	23833	11862	1	0	\N
182384	2133	93363164000	23833	11862	2	0	\N
182385	2133	93362162000	23833	11862	3	0	\N
182386	2132	147708710000	23833	11862	4	0	\N
182387	2134	85945131000	23833	11862	5	0	\N
182388	2134	85944128000	23833	11862	6	0	\N
182389	1397	1296915826000	23834	11863	0	0	\N
182390	2133	93361160000	23834	11863	1	0	\N
182391	2133	93360158000	23834	11863	2	0	\N
182392	2132	147707709000	23834	11863	3	0	\N
182393	1397	1296915826000	23835	11863	0	0	\N
182394	2133	93361160000	23835	11863	1	0	\N
182395	2133	93360158000	23835	11863	2	0	\N
182396	2134	85943125000	23835	11863	3	0	\N
182397	2132	147707709000	23835	11863	4	0	\N
182398	2134	85942122000	23835	11863	5	0	\N
182405	2134	85943125000	23837	11863	0	0	\N
182406	2134	85942122000	23837	11863	1	0	\N
182410	1397	1296905825000	23839	11864	0	0	\N
182411	2134	85941119000	23839	11864	1	0	\N
182412	2133	93359156000	23839	11864	2	0	\N
182433	1397	1296835818000	23844	11869	0	0	\N
182434	2134	85934098000	23844	11869	1	0	\N
182435	2133	93352142000	23844	11869	2	0	\N
182436	1397	1296835818000	23845	11869	0	0	\N
182437	2134	85934098000	23845	11869	1	0	\N
182438	2133	93352142000	23845	11869	2	0	\N
182442	1419	16847019560130	23847	11673	0	0	\N
182443	42	74368733400000	23847	11673	1	0	\N
182444	42	72080927000000	23847	11673	2	0	\N
182445	42	70537175800000	23847	11673	3	0	\N
182446	42	69260595000000	23847	11673	4	0	\N
182447	112	66000001832720	23847	11673	5	0	\N
182448	2106	5039087000000	23847	11673	6	0	\N
182449	1397	1299386073000	23847	11673	7	0	\N
182450	1571	7572049832307	23847	11673	8	0	\N
182451	1571	7117316766131	23847	11673	9	0	\N
182452	1397	1299376072000	23847	11673	10	0	\N
182453	1397	1299366071000	23847	11673	12	0	\N
182454	1397	1299356070000	23847	11673	13	0	\N
182455	1397	1299346069000	23847	11673	14	0	\N
182456	1397	1299336068000	23847	11673	15	0	\N
182457	1397	1299326067000	23847	11673	16	0	\N
182458	1397	1299316066000	23847	11673	17	0	\N
182459	1397	1299306065000	23847	11673	18	0	\N
182460	1397	1299296064000	23847	11673	19	0	\N
182461	1397	1299286063000	23847	11673	20	0	\N
182462	1397	1299276062000	23847	11673	21	0	\N
182463	1397	1299266061000	23847	11673	22	0	\N
182464	1397	1299256060000	23847	11673	23	0	\N
182465	1397	1299246059000	23847	11673	24	0	\N
182466	1397	1299236058000	23847	11673	25	0	\N
182467	1397	1299226057000	23847	11673	26	0	\N
182468	1397	1299216056000	23847	11673	27	0	\N
182469	1397	1299206055000	23847	11673	28	0	\N
182470	1397	1299196054000	23847	11673	29	0	\N
182471	1397	1299186053000	23847	11673	30	0	\N
182472	1397	1299176052000	23847	11673	31	0	\N
182473	1397	1299166051000	23847	11673	32	0	\N
182474	1571	6302446927607	23847	11673	33	0	\N
182475	1571	5752634757326	23847	11673	34	0	\N
182476	1571	4220552124154	23847	11673	35	0	\N
182477	1448	10667846000001	23847	11673	36	0	\N
182478	1448	7783836000001	23847	11673	37	0	\N
182479	1448	5837826000001	23847	11673	38	0	\N
182480	1571	4220542124154	23847	11673	39	0	\N
182481	1397	1299156050000	23847	11673	40	0	\N
182482	1397	1299146049000	23847	11673	41	0	\N
182483	1397	1299136048000	23847	11673	42	0	\N
182484	1397	1299126047000	23847	11673	43	0	\N
182485	1397	1299116046000	23847	11673	44	0	\N
182486	1397	1299106045000	23847	11673	45	0	\N
182487	1397	1299096044000	23847	11673	46	0	\N
182488	1397	1299086043000	23847	11673	47	0	\N
182489	1397	1299076042000	23847	11673	48	0	\N
182490	1397	1299066041000	23847	11673	49	0	\N
182491	1397	1299056040000	23847	11673	50	0	\N
182492	1397	1299046039000	23847	11673	51	0	\N
182493	1397	1299036038000	23847	11673	52	0	\N
182494	1397	1299026037000	23847	11673	53	0	\N
182495	1397	1299016036000	23847	11673	54	0	\N
182496	1397	1299006035000	23847	11673	55	0	\N
182497	1397	1298996034000	23847	11673	56	0	\N
182498	1397	1298986033000	23847	11673	57	0	\N
182499	1397	1298976032000	23847	11673	58	0	\N
182500	1397	1298966031000	23847	11673	59	0	\N
182501	1397	1298956030000	23847	11673	60	0	\N
182502	1397	1298946029000	23847	11673	61	0	\N
182503	1397	1298936028000	23847	11673	62	0	\N
182504	1397	1298926027000	23847	11673	63	0	\N
182505	1397	1298916026000	23847	11673	64	0	\N
182506	1397	1298906025000	23847	11673	65	0	\N
182507	1397	1298896024000	23847	11673	66	0	\N
182508	1397	1298886023000	23847	11673	67	0	\N
182509	1397	1298876022000	23847	11673	68	0	\N
182510	1397	1298866021000	23847	11673	69	0	\N
182511	1397	1298856020000	23847	11673	70	0	\N
182512	1397	1298846019000	23847	11673	71	0	\N
182379	2132	147708710000	23832	11862	4	0	1290
182380	2134	85945131000	23832	11862	5	0	4631
182381	2134	85944128000	23832	11862	6	0	4632
182399	1397	1296915826000	23836	11863	0	0	14191
182400	2133	93361160000	23836	11863	1	0	4421
182402	2134	85943125000	23836	11863	3	0	4633
182403	2132	147707709000	23836	11863	4	0	1291
182404	2134	85942122000	23836	11863	5	0	4634
182407	1397	1296905825000	23838	11864	0	0	14192
182408	2134	85941119000	23838	11864	1	0	4635
182413	1397	1296895824000	23840	11865	0	0	14193
182414	2133	93358154000	23840	11865	1	0	4424
182415	2134	85940116000	23840	11865	2	0	4636
182416	1397	1296885823000	23841	11866	0	0	14194
182418	2134	85939113000	23841	11866	2	0	4637
182419	2133	93357152000	23841	11866	3	0	4425
182420	2133	93356150000	23841	11866	4	0	4426
182421	2132	147706708000	23841	11866	5	0	1292
182422	2134	85938110000	23841	11866	6	0	4638
182424	2133	93355148000	23842	11867	1	0	4427
182425	2134	85937107000	23842	11867	2	0	4639
182426	1397	1296855820000	23843	11868	0	0	14197
182427	1397	1296845819000	23843	11868	1	0	14198
182428	2134	85936104000	23843	11868	2	0	4640
182430	2133	93354146000	23843	11868	4	0	4428
182431	2133	93353144000	23843	11868	5	0	4429
182432	2132	147705707000	23843	11868	6	0	1293
182439	1397	1296835818000	23846	11869	0	0	14199
182441	2133	93352142000	23846	11869	2	0	4430
182513	1397	1298836018000	23847	11673	72	0	\N
182514	1397	1298826017000	23847	11673	73	0	\N
182515	1397	1298816016000	23847	11673	74	0	\N
182516	1397	1298806015000	23847	11673	75	0	\N
182517	1397	1298796014000	23847	11673	76	0	\N
182518	1397	1298786013000	23847	11673	77	0	\N
182519	1397	1298776012000	23847	11673	78	0	\N
182520	1397	1298766011000	23847	11673	79	0	\N
182521	1397	1298756010000	23847	11673	80	0	\N
182522	1448	416816000001	23847	11673	81	0	\N
182523	1448	204806000001	23847	11673	82	0	\N
182524	1448	188796000001	23847	11673	83	0	\N
182525	1448	172786000001	23847	11673	84	0	\N
182526	1397	1298746009000	23847	11673	85	0	\N
182527	1397	1298736008000	23847	11673	86	0	\N
182528	1397	1298726007000	23847	11673	87	0	\N
182529	1397	1298716006000	23847	11673	88	0	\N
182530	1397	1298706005000	23847	11673	89	0	\N
182531	1397	1298696004000	23847	11673	90	0	\N
182532	1397	1298686003000	23847	11673	91	0	\N
182533	1397	1298676002000	23847	11673	92	0	\N
182534	1397	1298666001000	23847	11673	93	0	\N
182535	1397	1298656000000	23847	11673	94	0	\N
182536	1397	1298645999000	23847	11673	95	0	\N
182537	1397	1298635998000	23847	11673	96	0	\N
182538	1397	1298625997000	23847	11673	97	0	\N
182539	1397	1298615996000	23847	11673	98	0	\N
182540	1397	1298605995000	23847	11673	99	0	\N
182541	1397	1298595994000	23847	11673	100	0	\N
182542	1397	1298585993000	23847	11673	101	0	\N
182543	1397	1298575992000	23847	11673	102	0	\N
182544	1397	1298565991000	23847	11673	103	0	\N
182545	1397	1298555990000	23847	11673	104	0	\N
182546	1397	1298545989000	23847	11673	105	0	\N
182547	1397	1298535988000	23847	11673	106	0	\N
182548	1397	1298525987000	23847	11673	107	0	\N
182549	1397	1298515986000	23847	11673	108	0	\N
182550	1397	1298505985000	23847	11673	109	0	\N
182551	1397	1298495984000	23847	11673	110	0	\N
182552	1397	1298485983000	23847	11673	111	0	\N
182553	1397	1298475982000	23847	11673	112	0	\N
182554	1397	1298465981000	23847	11673	113	0	\N
182555	1397	1298455980000	23847	11673	114	0	\N
182556	1397	1298445979000	23847	11673	115	0	\N
182557	1397	1298435978000	23847	11673	116	0	\N
182558	1397	1298425977000	23847	11673	117	0	\N
182559	1397	1298415976000	23847	11673	118	0	\N
182560	1397	1298405975000	23847	11673	119	0	\N
182561	1397	1298395974000	23847	11673	120	0	\N
182562	1397	1298385973000	23847	11673	121	0	\N
182563	1397	1298375972000	23847	11673	122	0	\N
182564	1397	1298365971000	23847	11673	123	0	\N
182565	1397	1298355970000	23847	11673	124	0	\N
182566	1397	1298345969000	23847	11673	125	0	\N
182587	1397	1296775812000	23852	11873	0	0	\N
182588	2133	93346130000	23852	11873	1	0	\N
182589	2134	85928080000	23852	11873	2	0	\N
182590	1419	16847019560130	23853	11634	0	0	\N
182591	42	73648711400000	23853	11634	1	0	\N
182592	42	71360905000000	23853	11634	2	0	\N
182593	42	69817153800000	23853	11634	3	0	\N
182594	42	68540573000000	23853	11634	4	0	\N
182595	112	66000001832720	23853	11634	5	0	\N
182596	2106	5039087000000	23853	11634	6	0	\N
182597	1397	1300096144000	23853	11634	7	0	\N
182598	1397	1300086143000	23853	11634	8	0	\N
182599	1571	7572049832307	23853	11634	9	0	\N
182600	1397	1300076142000	23853	11634	10	0	\N
182601	1474	6470463000043	23853	11634	11	0	\N
182602	1571	7117316766131	23853	11634	12	0	\N
182603	1571	6302446927607	23853	11634	13	0	\N
182604	1571	5752634757326	23853	11634	14	0	\N
182605	1571	4220552124154	23853	11634	15	0	\N
182606	1448	10667846000001	23853	11634	16	0	\N
182607	1448	7783836000001	23853	11634	17	0	\N
182608	1448	5837826000001	23853	11634	18	0	\N
182609	1571	4220542124154	23853	11634	19	0	\N
182610	1397	1300066141000	23853	11634	20	0	\N
182611	1397	1300056140000	23853	11634	21	0	\N
182612	1448	416816000001	23853	11634	22	0	\N
182613	1448	204806000001	23853	11634	23	0	\N
182614	1448	188796000001	23853	11634	24	0	\N
182615	1448	172786000001	23853	11634	25	0	\N
182616	1397	1300046139000	23853	11634	26	0	\N
182617	1397	1300036138000	23853	11634	27	0	\N
182618	1397	1300026137000	23853	11634	28	0	\N
182619	1397	1300016136000	23853	11634	29	0	\N
182620	1397	1300006135000	23853	11634	30	0	\N
182621	1397	1299996134000	23853	11634	31	0	\N
182622	1397	1299986133000	23853	11634	32	0	\N
182623	1397	1299976132000	23853	11634	33	0	\N
182624	1397	1299966131000	23853	11634	34	0	\N
182625	1397	1299956130000	23853	11634	35	0	\N
182626	1397	1299946129000	23853	11634	36	0	\N
182627	1397	1299936128000	23853	11634	37	0	\N
182628	1397	1299926127000	23853	11634	38	0	\N
182629	1397	1299916126000	23853	11634	39	0	\N
182630	1397	1299906125000	23853	11634	40	0	\N
182631	1397	1299896124000	23853	11634	41	0	\N
182632	1397	1299886123000	23853	11634	42	0	\N
182633	1397	1299876122000	23853	11634	43	0	\N
182634	1397	1299866121000	23853	11634	44	0	\N
182635	1397	1299856120000	23853	11634	45	0	\N
182636	1397	1299846119000	23853	11634	46	0	\N
182637	1397	1299836118000	23853	11634	47	0	\N
182638	1397	1299826117000	23853	11634	48	0	\N
182639	1397	1299816116000	23853	11634	49	0	\N
182640	1397	1299806115000	23853	11634	50	0	\N
182641	1397	1299796114000	23853	11634	51	0	\N
182642	1397	1299786113000	23853	11634	52	0	\N
182643	1397	1299776112000	23853	11634	53	0	\N
182644	1397	1299766111000	23853	11634	54	0	\N
182645	1397	1299756110000	23853	11634	55	0	\N
182646	1397	1299746109000	23853	11634	56	0	\N
182647	1397	1299736108000	23853	11634	57	0	\N
182648	1397	1299726107000	23853	11634	58	0	\N
182569	1397	1296805815000	23848	11870	2	0	14202
182570	2132	147704706000	23848	11870	3	0	1294
182571	2133	93351140000	23848	11870	4	0	4431
182572	2133	93350138000	23848	11870	5	0	4432
182573	2133	93349136000	23848	11870	6	0	4433
182575	2134	85932092000	23848	11870	8	0	4644
182576	2134	85931089000	23848	11870	9	0	4645
182577	1397	1296795814000	23849	11871	0	0	14203
182578	2134	85930086000	23849	11871	1	0	4646
182579	2133	93348134000	23849	11871	2	0	4434
182581	2134	85929083000	23850	11872	1	0	4647
182582	2133	93347132000	23850	11872	2	0	4435
182583	2132	147703705000	23850	11872	3	0	1295
182584	1397	1296775812000	23851	11873	0	0	14205
182586	2134	85928080000	23851	11873	2	0	4648
182649	1397	1299716106000	23853	11634	59	0	\N
182650	1397	1299706105000	23853	11634	60	0	\N
182651	1397	1299696104000	23853	11634	61	0	\N
182652	1397	1299686103000	23853	11634	62	0	\N
182653	1397	1299676102000	23853	11634	63	0	\N
182654	1397	1299666101000	23853	11634	64	0	\N
182655	1397	1299656100000	23853	11634	65	0	\N
182656	1397	1299646099000	23853	11634	66	0	\N
182657	1397	1299636098000	23853	11634	67	0	\N
182658	1397	1299626097000	23853	11634	68	0	\N
182659	1397	1299616096000	23853	11634	69	0	\N
182660	1397	1299606095000	23853	11634	70	0	\N
182661	1397	1299596094000	23853	11634	71	0	\N
182662	1397	1299586093000	23853	11634	72	0	\N
182663	1397	1299576092000	23853	11634	73	0	\N
182664	1397	1299566091000	23853	11634	74	0	\N
182665	1397	1299556090000	23853	11634	75	0	\N
182666	1397	1299546089000	23853	11634	76	0	\N
182667	1397	1299536088000	23853	11634	77	0	\N
182668	1397	1299526087000	23853	11634	78	0	\N
182669	1397	1299516086000	23853	11634	79	0	\N
182670	1397	1299506085000	23853	11634	80	0	\N
182671	1397	1299496084000	23853	11634	81	0	\N
182672	1397	1299486083000	23853	11634	82	0	\N
182673	1397	1299476082000	23853	11634	83	0	\N
182674	1397	1299466081000	23853	11634	84	0	\N
182675	1397	1299456080000	23853	11634	85	0	\N
182676	1397	1299446079000	23853	11634	86	0	\N
182677	1397	1299436078000	23853	11634	87	0	\N
182678	1397	1299426077000	23853	11634	88	0	\N
182679	1397	1299416076000	23853	11634	89	0	\N
182680	1397	1299406075000	23853	11634	90	0	\N
182681	1397	1299396074000	23853	11634	91	0	\N
182682	1397	1299386073000	23853	11634	92	0	\N
182683	1397	1299376072000	23853	11634	93	0	\N
182684	1397	1299366071000	23853	11634	94	0	\N
182685	1397	1299356070000	23853	11634	95	0	\N
182686	1397	1299346069000	23853	11634	96	0	\N
182687	1397	1299336068000	23853	11634	97	0	\N
182688	1397	1299326067000	23853	11634	98	0	\N
182689	1397	1299316066000	23853	11634	99	0	\N
182690	1397	1299306065000	23853	11634	100	0	\N
182691	1397	1299296064000	23853	11634	101	0	\N
182692	1397	1299286063000	23853	11634	102	0	\N
182693	1397	1299276062000	23853	11634	103	0	\N
182694	1397	1299266061000	23853	11634	104	0	\N
182695	1397	1299256060000	23853	11634	105	0	\N
182696	1397	1299246059000	23853	11634	107	0	\N
182697	1397	1299236058000	23853	11634	108	0	\N
182698	1397	1299226057000	23853	11634	109	0	\N
182699	1397	1299216056000	23853	11634	110	0	\N
182700	1397	1299206055000	23853	11634	111	0	\N
182701	1397	1299196054000	23853	11634	112	0	\N
182702	1397	1299186053000	23853	11634	113	0	\N
182703	1397	1299176052000	23853	11634	114	0	\N
182704	1397	1299166051000	23853	11634	115	0	\N
182705	1397	1299156050000	23853	11634	116	0	\N
182706	1397	1299146049000	23853	11634	117	0	\N
182707	1397	1299136048000	23853	11634	118	0	\N
182708	1397	1299126047000	23853	11634	119	0	\N
182709	1397	1299116046000	23853	11634	120	0	\N
182710	1397	1299106045000	23853	11634	121	0	\N
182711	1397	1299096044000	23853	11634	122	0	\N
182712	1397	1299086043000	23853	11634	123	0	\N
182713	1397	1299076042000	23853	11634	124	0	\N
182714	1397	1299066041000	23853	11634	125	0	\N
182718	1397	1296755810000	23859	11876	0	0	\N
182719	1397	1296745809000	23859	11876	1	0	\N
182720	2132	147702704000	23859	11876	2	0	\N
182721	2134	85926074000	23859	11876	3	0	\N
182722	2133	93344126000	23859	11876	4	0	\N
182723	2133	93343124000	23859	11876	5	0	\N
182724	2134	85925071000	23859	11876	6	0	\N
182725	1397	1296755810000	23860	11876	0	0	\N
182726	1397	1296745809000	23860	11876	1	0	\N
182727	2132	147702704000	23860	11876	2	0	\N
182728	2134	85926074000	23860	11876	3	0	\N
182729	2133	93344126000	23860	11876	4	0	\N
182730	2133	93343124000	23860	11876	5	0	\N
182731	2134	85925071000	23860	11876	6	0	\N
182732	1397	1296755810000	23861	11876	0	0	\N
182733	1397	1296745809000	23861	11876	1	0	\N
182734	2132	147702704000	23861	11876	2	0	\N
182735	2134	85926074000	23861	11876	3	0	\N
182736	2133	93344126000	23861	11876	4	0	\N
182737	2133	93343124000	23861	11876	5	0	\N
182738	2134	85925071000	23861	11876	6	0	\N
182749	1397	1296755810000	23863	11877	0	0	\N
182750	1397	1296745809000	23863	11877	1	0	\N
182751	1397	1296735808000	23863	11877	2	0	\N
182752	2132	147702704000	23863	11877	3	0	\N
182753	2134	85926074000	23863	11877	4	0	\N
182754	2133	93344126000	23863	11877	5	0	\N
182755	2133	93343124000	23863	11877	6	0	\N
182756	2133	93342122000	23863	11877	7	0	\N
182757	2134	85925071000	23863	11877	8	0	\N
182758	2134	85924068000	23863	11877	9	0	\N
182769	1397	1296705805000	23866	11879	0	0	\N
182770	2133	93339116000	23866	11879	1	0	\N
182771	2134	85921059000	23866	11879	2	0	\N
182772	1397	1296705805000	23867	11879	0	0	\N
182773	2133	93339116000	23867	11879	1	0	\N
182774	2134	85921059000	23867	11879	2	0	\N
182784	1397	1296675802000	23870	11881	0	0	\N
182717	2134	85927077000	23854	11874	2	0	4649
182739	1397	1296755810000	23862	11877	0	0	14207
182740	1397	1296745809000	23862	11877	1	0	14208
182741	1397	1296735808000	23862	11877	2	0	14209
182742	2132	147702704000	23862	11877	3	0	1296
182744	2133	93344126000	23862	11877	5	0	4438
182745	2133	93343124000	23862	11877	6	0	4439
182746	2133	93342122000	23862	11877	7	0	4440
182747	2134	85925071000	23862	11877	8	0	4651
182748	2134	85924068000	23862	11877	9	0	4652
182760	1397	1296715806000	23864	11878	1	0	14211
182761	2132	147701703000	23864	11878	2	0	1297
182762	2134	85923065000	23864	11878	3	0	4653
182763	2134	85922062000	23864	11878	4	0	4654
182765	2133	93340118000	23864	11878	6	0	4442
182766	1397	1296705805000	23865	11879	0	0	14212
182767	2133	93339116000	23865	11879	1	0	4443
182768	2134	85921059000	23865	11879	2	0	4655
182775	1397	1296695804000	23868	11880	0	0	14213
182777	2134	85920056000	23868	11880	2	0	4656
182778	2132	147700702000	23868	11880	3	0	1298
182779	2133	93338114000	23868	11880	4	0	4444
182780	2133	93337112000	23868	11880	5	0	4445
182781	1397	1296675802000	23869	11881	0	0	14215
182783	2134	85919053000	23869	11881	2	0	4657
182785	2133	93336110000	23870	11881	1	0	\N
182786	2134	85919053000	23870	11881	2	0	\N
182787	1397	1296675802000	23871	11881	0	0	\N
182788	2133	93336110000	23871	11881	1	0	\N
182789	2134	85919053000	23871	11881	2	0	\N
182796	1397	1296665801000	23873	11882	0	0	\N
182797	1397	1296655800000	23873	11882	1	0	\N
182798	2133	93335108000	23873	11882	2	0	\N
182799	2134	85918050000	23873	11882	3	0	\N
182800	2134	85917047000	23873	11882	4	0	\N
182801	2133	93334106000	23873	11882	5	0	\N
182812	1397	1296665801000	23876	11882	0	0	\N
182813	1397	1296655800000	23876	11882	1	0	\N
182814	1397	1296645799000	23876	11882	2	0	\N
182815	1397	1296635798000	23876	11882	3	0	\N
182816	1397	1296625797000	23876	11882	4	0	\N
182817	1397	1296615796000	23876	11882	5	0	\N
182818	2133	93335108000	23876	11882	6	0	\N
182819	2134	85918050000	23876	11882	7	0	\N
182820	2134	85917047000	23876	11882	8	0	\N
182821	2132	147699701000	23876	11882	9	0	\N
182822	2132	147698700000	23876	11882	10	0	\N
182823	2133	93334106000	23876	11882	11	0	\N
182824	2133	93333104000	23876	11882	12	0	\N
182825	2133	93332102000	23876	11882	13	0	\N
182826	2133	93331100000	23876	11882	14	0	\N
182827	2133	93330098000	23876	11882	15	0	\N
182828	2134	85916044000	23876	11882	16	0	\N
182829	2134	85915041000	23876	11882	17	0	\N
182830	2134	85914038000	23876	11882	18	0	\N
182831	2134	85913035000	23876	11882	19	0	\N
182832	1419	17567031560130	23877	11814	0	0	\N
182833	2058	535500000	23877	11814	1	0	\N
182834	1397	1297645899000	23877	11814	2	0	\N
182835	1397	1297635898000	23877	11814	3	0	\N
182836	1397	1297625897000	23877	11814	4	0	\N
182837	1397	1297615896000	23877	11814	5	0	\N
182838	1397	1297605895000	23877	11814	6	0	\N
182839	1397	1297595894000	23877	11814	7	0	\N
182840	1397	1297585893000	23877	11814	8	0	\N
182841	1397	1297575892000	23877	11814	9	0	\N
182842	1397	1297565891000	23877	11814	10	0	\N
182843	1397	1297555890000	23877	11814	11	0	\N
182844	1397	1297545889000	23877	11814	12	0	\N
182845	1397	1297535888000	23877	11814	13	0	\N
182846	1397	1297525887000	23877	11814	14	0	\N
182847	1397	1297515886000	23877	11814	15	0	\N
182848	1397	1297505885000	23877	11814	16	0	\N
182849	1397	1297495884000	23877	11814	17	0	\N
182850	1397	1297485883000	23877	11814	18	0	\N
182851	1397	1297475882000	23877	11814	19	0	\N
182852	1397	1297465881000	23877	11814	20	0	\N
182853	1397	1297455880000	23877	11814	21	0	\N
182854	1397	1297445879000	23877	11814	22	0	\N
182855	1397	1297435878000	23877	11814	23	0	\N
182856	1397	1297425877000	23877	11814	24	0	\N
182857	1397	1297415876000	23877	11814	25	0	\N
182858	1397	1297405875000	23877	11814	26	0	\N
182859	1397	1297395874000	23877	11814	27	0	\N
182860	1397	1297385873000	23877	11814	28	0	\N
182861	1397	1297375872000	23877	11814	29	0	\N
182862	1397	1297365871000	23877	11814	30	0	\N
182863	1397	1297355870000	23877	11814	31	0	\N
182864	1397	1297345869000	23877	11814	32	0	\N
182865	1397	1297335868000	23877	11814	33	0	\N
182866	1397	1297325867000	23877	11814	34	0	\N
182867	1397	1297315866000	23877	11814	35	0	\N
182868	1397	1297305865000	23877	11814	36	0	\N
182869	1397	1297295864000	23877	11814	37	0	\N
182870	1397	1297285863000	23877	11814	38	0	\N
182871	1397	1297275862000	23877	11814	39	0	\N
182872	1397	1297265861000	23877	11814	41	0	\N
182873	1397	1297255860000	23877	11814	42	0	\N
182874	1397	1297245859000	23877	11814	43	0	\N
182875	1397	1297235858000	23877	11814	44	0	\N
182876	1397	1297225857000	23877	11814	45	0	\N
182877	1397	1297215856000	23877	11814	46	0	\N
182878	1397	1297205855000	23877	11814	47	0	\N
182879	1397	1297195854000	23877	11814	48	0	\N
182880	1397	1297185853000	23877	11814	49	0	\N
182881	1397	1297175852000	23877	11814	50	0	\N
182882	1397	1297165851000	23877	11814	51	0	\N
182883	1397	1297155850000	23877	11814	52	0	\N
182884	1397	1297145849000	23877	11814	53	0	\N
182885	1397	1297135848000	23877	11814	54	0	\N
182886	1397	1297125847000	23877	11814	55	0	\N
182887	1397	1297115846000	23877	11814	56	0	\N
182888	1397	1297105845000	23877	11814	57	0	\N
182889	1397	1297095844000	23877	11814	58	0	\N
182890	1397	1297085843000	23877	11814	59	0	\N
182891	1397	1297075842000	23877	11814	60	0	\N
182892	1397	1297065841000	23877	11814	61	0	\N
182893	1397	1297055840000	23877	11814	62	0	\N
182894	1397	1297045839000	23877	11814	63	0	\N
182895	1397	1297035838000	23877	11814	64	0	\N
182896	1397	1297025837000	23877	11814	65	0	\N
182897	1397	1297015836000	23877	11814	66	0	\N
182898	1397	1297005835000	23877	11814	67	0	\N
182899	1397	1296995834000	23877	11814	68	0	\N
182900	1397	1296985833000	23877	11814	69	0	\N
182901	1397	1296975832000	23877	11814	70	0	\N
182902	1397	1296965831000	23877	11814	71	0	\N
182903	1397	1296955830000	23877	11814	72	0	\N
182904	1397	1296945829000	23877	11814	73	0	\N
182905	1397	1296935828000	23877	11814	74	0	\N
182906	1397	1296925827000	23877	11814	75	0	\N
182907	1397	1296915826000	23877	11814	76	0	\N
182908	1397	1296905825000	23877	11814	77	0	\N
182909	1397	1296895824000	23877	11814	78	0	\N
182910	1397	1296885823000	23877	11814	79	0	\N
182911	1397	1296875822000	23877	11814	80	0	\N
182912	1397	1296865821000	23877	11814	81	0	\N
182913	1397	1296855820000	23877	11814	82	0	\N
182914	1397	1296845819000	23877	11814	83	0	\N
182915	1397	1296835818000	23877	11814	84	0	\N
182916	1397	1296825817000	23877	11814	85	0	\N
182917	1397	1296815816000	23877	11814	86	0	\N
182918	1397	1296805815000	23877	11814	87	0	\N
182919	1397	1296795814000	23877	11814	88	0	\N
182920	1397	1296785813000	23877	11814	89	0	\N
182792	2133	93335108000	23872	11882	2	0	4447
182793	2134	85918050000	23872	11882	3	0	4658
182794	2134	85917047000	23872	11882	4	0	4659
182795	2133	93334106000	23872	11882	5	0	4448
182802	1397	1296645799000	23875	11883	0	0	14218
182804	1397	1296625797000	23875	11883	2	0	14220
182805	2133	93333104000	23875	11883	3	0	4449
182806	2133	93332102000	23875	11883	4	0	4450
182807	2133	93331100000	23875	11883	5	0	4451
182808	2132	147699701000	23875	11883	6	0	1299
182810	2134	85915041000	23875	11883	8	0	4661
182811	2134	85914038000	23875	11883	9	0	4662
182921	1397	1296775812000	23877	11814	90	0	\N
182922	1397	1296765811000	23877	11814	91	0	\N
182923	1397	1296755810000	23877	11814	92	0	\N
182924	1397	1296745809000	23877	11814	93	0	\N
182925	1397	1296735808000	23877	11814	94	0	\N
182926	1397	1296725807000	23877	11814	95	0	\N
182927	1397	1296715806000	23877	11814	96	0	\N
182928	1397	1296705805000	23877	11814	97	0	\N
182929	1397	1296695804000	23877	11814	98	0	\N
182930	1397	1296685803000	23877	11814	99	0	\N
182931	1397	1296675802000	23877	11814	100	0	\N
182932	1397	1296665801000	23877	11814	101	0	\N
182933	1397	1296655800000	23877	11814	102	0	\N
182934	1397	1296645799000	23877	11814	103	0	\N
182935	1397	1296635798000	23877	11814	104	0	\N
182936	1397	1296625797000	23877	11814	105	0	\N
182937	1397	1296615796000	23877	11814	106	0	\N
182938	2132	147729731000	23877	11814	107	0	\N
182939	2309	2742643000000	23877	11814	108	0	\N
182940	2133	93435308000	23877	11814	109	0	\N
182941	2132	147728730000	23877	11814	110	0	\N
182942	2132	147727729000	23877	11814	111	0	\N
182943	2132	147726728000	23877	11814	112	0	\N
182944	2132	147725727000	23877	11814	113	0	\N
182945	2132	147724726000	23877	11814	114	0	\N
182946	2132	147723725000	23877	11814	115	0	\N
182947	2132	147722724000	23877	11814	116	0	\N
182948	2132	147721723000	23877	11814	117	0	\N
182949	2132	147720722000	23877	11814	118	0	\N
182950	2132	147719721000	23877	11814	119	0	\N
182951	2132	147718720000	23877	11814	120	0	\N
182952	2132	147717719000	23877	11814	121	0	\N
182953	2132	147716718000	23877	11814	122	0	\N
182954	2132	147715717000	23877	11814	123	0	\N
182955	2132	147714716000	23877	11814	124	0	\N
182956	1397	1296615796000	23879	11884	0	0	\N
182957	1397	1296605795000	23879	11884	1	0	\N
182958	2132	147698700000	23879	11884	2	0	\N
182959	2133	93330098000	23879	11884	3	0	\N
182960	2133	93329096000	23879	11884	4	0	\N
182961	2134	85913035000	23879	11884	5	0	\N
182962	2134	85912032000	23879	11884	6	0	\N
182993	1397	1296525787000	23883	11888	0	0	\N
182994	2134	85904008000	23883	11888	1	0	\N
182995	2133	93321080000	23883	11888	2	0	\N
183017	1397	1296465781000	23888	11892	0	0	\N
183018	2134	85897990000	23888	11892	2	0	\N
183019	2133	92214068000	23888	11892	3	0	\N
183020	1397	1296465781000	23889	11892	0	0	\N
183021	2134	85897990000	23889	11892	2	0	\N
183022	2133	92214068000	23889	11892	3	0	\N
183026	1397	1296455780000	23891	11893	0	0	\N
183027	2133	92213066000	23891	11893	1	0	\N
183028	2134	85896987000	23891	11893	2	0	\N
183029	1397	1296455780000	23892	11893	0	0	\N
183030	2133	92213066000	23892	11893	1	0	\N
183031	2134	85896987000	23892	11893	2	0	\N
183035	2134	85896987000	23894	11893	0	0	\N
183036	1397	1296455780000	23895	11893	0	0	\N
183037	2133	92213066000	23895	11893	1	0	\N
183038	2134	85896987000	23895	11893	2	0	\N
183043	2132	147693695000	23897	11894	0	0	\N
183047	1397	1296425777000	23899	11896	0	0	\N
183048	2134	85893978000	23899	11896	1	0	\N
183049	2133	92210060000	23899	11896	2	0	\N
183050	1397	1296425777000	23900	11896	0	0	\N
183051	2134	85893978000	23900	11896	1	0	\N
183052	2133	92210060000	23900	11896	2	0	\N
183056	1397	1296425777000	23902	11896	0	0	\N
182965	1397	1296595794000	23880	11885	2	0	14223
182966	1397	1296585793000	23880	11885	3	0	14224
182967	2132	147698700000	23880	11885	4	0	1300
182968	2132	147697699000	23880	11885	5	0	1301
182969	2133	93330098000	23880	11885	6	0	4452
182971	2134	85913035000	23880	11885	8	0	4663
182972	2134	85912032000	23880	11885	9	0	4664
182973	2134	85911029000	23880	11885	10	0	4665
182974	2134	85910026000	23880	11885	11	0	4666
182975	2133	93328094000	23880	11885	12	0	4454
182977	1397	1296575792000	23881	11886	0	0	14225
182978	1397	1296565791000	23881	11886	1	0	14226
182979	1397	1296555790000	23881	11886	2	0	14227
182980	2133	93326090000	23881	11886	3	0	4456
182982	2134	85909023000	23881	11886	5	0	4667
182983	2134	85908020000	23881	11886	6	0	4668
182984	2134	85907017000	23881	11886	7	0	4669
182985	2133	93324086000	23881	11886	8	0	4458
182986	1397	1296545789000	23882	11887	0	0	14228
182988	2133	93323084000	23882	11887	2	0	4459
182989	2133	93322082000	23882	11887	3	0	4460
182990	2134	85906014000	23882	11887	4	0	4670
182991	2134	85905011000	23882	11887	5	0	4671
182992	2132	147696698000	23882	11887	6	0	1302
182997	2134	85904008000	23884	11888	1	0	4672
182998	2133	93321080000	23884	11888	2	0	4461
182999	1397	1296515786000	23885	11889	0	0	14231
183000	1397	1296505785000	23885	11889	1	0	14232
183002	2133	93319076000	23885	11889	3	0	4463
183003	2134	85903005000	23885	11889	4	0	4673
183004	2134	85902002000	23885	11889	5	0	4674
183005	2132	147695697000	23885	11889	6	0	1303
183006	1397	1296495784000	23886	11890	0	0	14233
183008	2134	85900999000	23886	11890	2	0	4675
183009	1397	1296485783000	23887	11891	0	0	14234
183010	1397	1296475782000	23887	11891	1	0	14235
183011	2132	147694696000	23887	11891	2	0	1304
183012	2133	92217074000	23887	11891	3	0	4465
183014	2134	85899996000	23887	11891	5	0	4676
183015	2134	85898993000	23887	11891	6	0	4677
183016	2133	92215070000	23887	11891	7	0	4467
183023	1397	1296465781000	23890	11892	0	0	14236
183025	2133	92214068000	23890	11892	3	0	4468
183032	1397	1296455780000	23893	11893	0	0	14237
183033	2133	92213066000	23893	11893	1	0	4469
183034	2134	85896987000	23893	11893	2	0	4679
183039	1397	1296445779000	23896	11894	0	0	14238
183041	2132	147693695000	23896	11894	2	0	1305
183042	2134	85895984000	23896	11894	3	0	4680
183044	1397	1296435778000	23898	11895	0	0	14239
183045	2134	85894981000	23898	11895	1	0	4681
183046	2133	92211062000	23898	11895	2	0	4471
183054	2134	85893978000	23901	11896	1	0	4682
183055	2133	92210060000	23901	11896	2	0	4472
183057	2134	85893978000	23902	11896	1	0	\N
183058	2133	92210060000	23902	11896	2	0	\N
183059	1397	1296425777000	23903	11896	0	0	\N
183060	2134	85893978000	23903	11896	1	0	\N
183061	2133	92210060000	23903	11896	2	0	\N
183062	1397	1296415776000	23904	11897	0	0	\N
183063	2133	92209058000	23904	11897	1	0	\N
183064	2134	85892975000	23904	11897	2	0	\N
183065	2132	147692694000	23904	11897	3	0	\N
183066	1397	1296415776000	23905	11897	0	0	\N
183067	2133	92209058000	23905	11897	1	0	\N
183068	2134	85892975000	23905	11897	2	0	\N
183069	2132	147692694000	23905	11897	3	0	\N
183070	2132	147692694000	23906	11897	0	0	\N
183076	1397	1296415776000	23909	11898	0	0	\N
183077	2133	92209058000	23909	11898	1	0	\N
183078	2134	85892975000	23909	11898	2	0	\N
183079	1397	1296415776000	23910	11898	0	0	\N
183080	2133	92209058000	23910	11898	1	0	\N
183081	2134	85892975000	23910	11898	2	0	\N
183082	1397	1296415776000	23911	11898	0	0	\N
183083	2133	92209058000	23911	11898	1	0	\N
183084	2133	92208056000	23911	11898	2	0	\N
183085	2134	85892975000	23911	11898	3	0	\N
183093	1397	1296405775000	23913	11899	0	0	\N
183094	1397	1296395774000	23913	11899	1	0	\N
183095	2133	92207054000	23913	11899	2	0	\N
183096	2133	92206052000	23913	11899	3	0	\N
183097	2132	147691693000	23913	11899	4	0	\N
183098	2134	85891972000	23913	11899	5	0	\N
183099	2134	85890969000	23913	11899	6	0	\N
183115	1419	16847019560130	23916	11755	0	0	\N
183116	1397	1297335868000	23916	11755	1	0	\N
183117	1397	1297325867000	23916	11755	2	0	\N
183118	1397	1297315866000	23916	11755	3	0	\N
183119	1397	1297305865000	23916	11755	4	0	\N
183120	1397	1297295864000	23916	11755	5	0	\N
183121	1397	1297285863000	23916	11755	6	0	\N
183122	1397	1297275862000	23916	11755	7	0	\N
183123	1397	1297265861000	23916	11755	8	0	\N
183124	1397	1297255860000	23916	11755	9	0	\N
183125	1397	1297245859000	23916	11755	10	0	\N
183126	1397	1297235858000	23916	11755	11	0	\N
183127	1397	1297225857000	23916	11755	12	0	\N
183128	1397	1297215856000	23916	11755	13	0	\N
183129	1397	1297205855000	23916	11755	14	0	\N
183130	1397	1297195854000	23916	11755	15	0	\N
183131	1397	1297185853000	23916	11755	16	0	\N
183132	1397	1297175852000	23916	11755	17	0	\N
183133	1397	1297165851000	23916	11755	18	0	\N
183134	1397	1297155850000	23916	11755	19	0	\N
183135	1397	1297145849000	23916	11755	20	0	\N
183136	1397	1297135848000	23916	11755	21	0	\N
183137	1397	1297125847000	23916	11755	22	0	\N
183138	1397	1297115846000	23916	11755	23	0	\N
183139	1397	1297105845000	23916	11755	24	0	\N
183140	1397	1297095844000	23916	11755	25	0	\N
183141	1397	1297085843000	23916	11755	26	0	\N
183142	1397	1297075842000	23916	11755	27	0	\N
183143	1397	1297065841000	23916	11755	28	0	\N
183144	1397	1297055840000	23916	11755	29	0	\N
183145	1397	1297045839000	23916	11755	30	0	\N
183146	1397	1297035838000	23916	11755	31	0	\N
183147	1397	1297025837000	23916	11755	32	0	\N
183148	1397	1297015836000	23916	11755	33	0	\N
183149	1397	1297005835000	23916	11755	34	0	\N
183150	1397	1296995834000	23916	11755	35	0	\N
183151	1397	1296985833000	23916	11755	36	0	\N
183152	1397	1296975832000	23916	11755	37	0	\N
183153	1397	1296965831000	23916	11755	38	0	\N
183154	1397	1296955830000	23916	11755	39	0	\N
183155	1397	1296945829000	23916	11755	40	0	\N
183156	1397	1296935828000	23916	11755	41	0	\N
183157	1397	1296925827000	23916	11755	42	0	\N
183158	1397	1296915826000	23916	11755	43	0	\N
183159	1397	1296905825000	23916	11755	44	0	\N
183160	1397	1296895824000	23916	11755	45	0	\N
183161	1397	1296885823000	23916	11755	46	0	\N
183162	1397	1296875822000	23916	11755	47	0	\N
183163	1397	1296865821000	23916	11755	48	0	\N
183164	1397	1296855820000	23916	11755	49	0	\N
183165	1397	1296845819000	23916	11755	50	0	\N
183166	1397	1296835818000	23916	11755	51	0	\N
183167	1397	1296825817000	23916	11755	52	0	\N
183168	1397	1296815816000	23916	11755	53	0	\N
183169	1397	1296805815000	23916	11755	54	0	\N
183170	1397	1296795814000	23916	11755	55	0	\N
183171	1397	1296785813000	23916	11755	56	0	\N
183172	1397	1296775812000	23916	11755	57	0	\N
183173	1397	1296765811000	23916	11755	58	0	\N
183174	1397	1296755810000	23916	11755	59	0	\N
183175	1397	1296745809000	23916	11755	60	0	\N
183176	1397	1296735808000	23916	11755	61	0	\N
183177	1397	1296725807000	23916	11755	62	0	\N
183178	1397	1296715806000	23916	11755	63	0	\N
183179	1397	1296705805000	23916	11755	64	0	\N
183180	1397	1296695804000	23916	11755	65	0	\N
183181	1397	1296685803000	23916	11755	66	0	\N
183182	1397	1296675802000	23916	11755	67	0	\N
183183	1397	1296665801000	23916	11755	68	0	\N
183184	1397	1296655800000	23916	11755	69	0	\N
183185	1397	1296645799000	23916	11755	70	0	\N
183186	1397	1296635798000	23916	11755	71	0	\N
183187	1397	1296625797000	23916	11755	72	0	\N
183188	1397	1296615796000	23916	11755	73	0	\N
183189	1397	1296605795000	23916	11755	74	0	\N
183190	1397	1296595794000	23916	11755	75	0	\N
183191	1397	1296585793000	23916	11755	76	0	\N
183192	1397	1296575792000	23916	11755	77	0	\N
183073	2133	92209058000	23908	11898	1	0	4473
183074	2133	92208056000	23908	11898	2	0	4474
183075	2134	85892975000	23908	11898	3	0	4683
183086	1397	1296405775000	23912	11899	0	0	14242
183087	1397	1296395774000	23912	11899	1	0	14243
183089	2133	92206052000	23912	11899	3	0	4476
183090	2132	147691693000	23912	11899	4	0	1307
183091	2134	85891972000	23912	11899	5	0	4684
183092	2134	85890969000	23912	11899	6	0	4685
183100	1397	1296385773000	23914	11900	0	0	14244
183102	2134	85889966000	23914	11900	2	0	4686
183103	1397	1296375772000	23915	11901	0	0	14245
183104	1397	1296365771000	23915	11901	1	0	14246
183105	1397	1296355770000	23915	11901	2	0	14247
183107	2134	85888963000	23915	11901	4	0	4687
183108	2132	147690692000	23915	11901	5	0	1308
183109	2134	85887960000	23915	11901	6	0	4688
183110	2134	85886957000	23915	11901	7	0	4689
183111	2134	85885954000	23915	11901	8	0	4690
183113	2133	92203046000	23915	11901	10	0	4479
183114	2133	92202044000	23915	11901	11	0	4480
183193	1397	1296565791000	23916	11755	78	0	\N
183194	1397	1296555790000	23916	11755	79	0	\N
183195	1397	1296545789000	23916	11755	81	0	\N
183196	1397	1296535788000	23916	11755	82	0	\N
183197	1397	1296525787000	23916	11755	83	0	\N
183198	1397	1296515786000	23916	11755	84	0	\N
183199	1397	1296505785000	23916	11755	85	0	\N
183200	1397	1296495784000	23916	11755	86	0	\N
183201	1397	1296485783000	23916	11755	87	0	\N
183202	1397	1296475782000	23916	11755	88	0	\N
183203	1397	1296465781000	23916	11755	89	0	\N
183204	1397	1296455780000	23916	11755	90	0	\N
183205	1397	1296445779000	23916	11755	91	0	\N
183206	1397	1296435778000	23916	11755	92	0	\N
183207	1397	1296425777000	23916	11755	93	0	\N
183208	1397	1296415776000	23916	11755	94	0	\N
183209	1397	1296405775000	23916	11755	95	0	\N
183210	1397	1296395774000	23916	11755	96	0	\N
183211	1397	1296385773000	23916	11755	97	0	\N
183212	1397	1296335768000	23917	11902	0	0	\N
183213	1397	1296325767000	23917	11902	1	0	\N
183214	1397	1296315766000	23917	11902	2	0	\N
183215	2133	92201042000	23917	11902	3	0	\N
183216	2134	85884951000	23917	11902	4	0	\N
183217	2133	92200040000	23917	11902	5	0	\N
183218	2133	92199038000	23917	11902	6	0	\N
183219	2134	85883948000	23917	11902	7	0	\N
183220	2134	85882945000	23917	11902	8	0	\N
183221	2119	191000000	23917	11902	9	0	\N
183222	2132	147689691000	23917	11902	10	0	\N
183241	1397	1296285763000	23921	11905	0	0	\N
183242	2133	92196032000	23921	11905	1	0	\N
183243	2134	85879936000	23921	11905	2	0	\N
183247	1397	1296285763000	23923	11905	0	0	\N
183248	2133	92196032000	23923	11905	1	0	\N
183249	2134	85879936000	23923	11905	2	0	\N
183250	1397	1296275762000	23924	11906	0	0	\N
183251	2134	85878933000	23924	11906	1	0	\N
183252	2133	92195030000	23924	11906	2	0	\N
183256	1397	1296265761000	23926	11907	0	0	\N
183257	2134	85877930000	23926	11907	1	0	\N
183258	2133	92194028000	23926	11907	2	0	\N
183266	1397	1296245759000	23929	11909	0	0	\N
183267	1397	1296235758000	23929	11909	1	0	\N
183268	1397	1296225757000	23929	11909	2	0	\N
183269	2132	147686688000	23929	11909	3	0	\N
183283	1397	1296215756000	23932	11910	0	0	\N
183284	2133	92189018000	23932	11910	1	0	\N
183285	2134	85872915000	23932	11910	2	0	\N
183289	1397	1296195754000	23934	11912	0	0	\N
183290	2133	92187014000	23934	11912	1	0	\N
183291	2132	147685687000	23934	11912	2	0	\N
183292	2134	85870909000	23934	11912	3	0	\N
183295	1397	1296195754000	23936	11912	0	0	\N
183296	2133	92187014000	23936	11912	1	0	\N
183297	2134	85870909000	23936	11912	2	0	\N
183298	1397	1296185753000	23937	11913	0	0	\N
183299	2133	92187014000	23937	11913	1	0	\N
183300	2133	92186012000	23937	11913	2	0	\N
183301	2134	85870909000	23937	11913	3	0	\N
183302	1397	1296185753000	23938	11913	0	0	\N
183303	2133	92187014000	23938	11913	1	0	\N
183304	2133	92186012000	23938	11913	2	0	\N
183305	2134	85870909000	23938	11913	3	0	\N
183306	2134	85869906000	23938	11913	4	0	\N
183307	1397	1296185753000	23939	11913	0	0	\N
183308	2133	92187014000	23939	11913	1	0	\N
183309	2133	92186012000	23939	11913	2	0	\N
183310	2134	85870909000	23939	11913	3	0	\N
183311	2134	85869906000	23939	11913	4	0	\N
183317	1397	1296175752000	23941	11914	0	0	\N
183318	1397	1296165751000	23941	11914	1	0	\N
183319	2134	85868903000	23941	11914	2	0	\N
183320	2133	92185010000	23941	11914	3	0	\N
183321	2134	85867900000	23941	11914	4	0	\N
183322	2133	92184008000	23941	11914	5	0	\N
183225	1397	1296315766000	23918	11902	2	0	14251
183226	2133	92201042000	23918	11902	3	0	4481
183227	2134	85884951000	23918	11902	4	0	4691
183228	2133	92200040000	23918	11902	5	0	4482
183229	2133	92199038000	23918	11902	6	0	4483
183231	2134	85882945000	23918	11902	8	0	4693
183232	2119	191000000	23918	11902	9	0	9
183233	2132	147689691000	23918	11902	10	0	1309
183234	1397	1296305765000	23919	11903	0	0	14252
183235	2133	92198036000	23919	11903	1	0	4484
183237	1397	1296295764000	23920	11904	0	0	14253
183238	2132	147688690000	23920	11904	1	0	1310
183239	2134	85880939000	23920	11904	2	0	4695
183240	2133	92197034000	23920	11904	3	0	4485
183245	2133	92196032000	23922	11905	1	0	4486
183246	2134	85879936000	23922	11905	2	0	4696
183253	1397	1296275762000	23925	11906	0	0	14255
183254	2134	85878933000	23925	11906	1	0	4697
183255	2133	92195030000	23925	11906	2	0	4487
183260	2134	85877930000	23927	11907	1	0	4698
183261	2133	92194028000	23927	11907	2	0	4488
183262	1397	1296255760000	23928	11908	0	0	14257
183263	2134	85876927000	23928	11908	1	0	4699
183264	2132	147687689000	23928	11908	2	0	1311
183270	1397	1296245759000	23930	11909	0	0	14258
183271	1397	1296235758000	23930	11909	1	0	14259
183272	1397	1296225757000	23930	11909	2	0	14260
183273	2133	92192024000	23930	11909	3	0	4490
183275	2133	92191022000	23930	11909	5	0	4491
183276	2133	92190020000	23930	11909	6	0	4492
183277	2134	85875924000	23930	11909	7	0	4700
183278	2134	85874921000	23930	11909	8	0	4701
183279	2134	85873918000	23930	11909	9	0	4702
183281	2133	92189018000	23931	11910	1	0	4493
183282	2134	85872915000	23931	11910	2	0	4703
183286	1397	1296205755000	23933	11911	0	0	14262
183287	2134	85871912000	23933	11911	1	0	4704
183288	2133	92188016000	23933	11911	2	0	4494
183294	2132	147685687000	23935	11912	1	0	1313
183312	1397	1296185753000	23940	11913	0	0	14264
183313	2133	92187014000	23940	11913	1	0	4495
183314	2133	92186012000	23940	11913	2	0	4496
183316	2134	85869906000	23940	11913	4	0	4706
183323	1397	1296175752000	23942	11914	0	0	14265
183324	1397	1296165751000	23942	11914	1	0	14266
183325	2134	85868903000	23942	11914	2	0	4707
183326	2133	92185010000	23942	11914	3	0	4497
183328	2133	92184008000	23942	11914	5	0	4498
183329	1397	1296155750000	23943	11915	0	0	\N
183330	2134	85866897000	23943	11915	1	0	\N
183331	2133	92183006000	23943	11915	2	0	\N
183332	1397	1296155750000	23944	11915	0	0	\N
183333	2134	85866897000	23944	11915	1	0	\N
183334	2133	92183006000	23944	11915	2	0	\N
183335	1397	1296155750000	23945	11915	0	0	\N
183336	2134	85866897000	23945	11915	1	0	\N
183337	2133	92183006000	23945	11915	2	0	\N
183341	1397	1296155750000	23947	11915	0	0	\N
183342	2134	85866897000	23947	11915	1	0	\N
183343	2133	92183006000	23947	11915	2	0	\N
183344	1397	1296145749000	23949	11916	0	0	\N
183345	1397	1296135748000	23949	11916	1	0	\N
183346	2134	85865894000	23949	11916	2	0	\N
183347	2134	85864891000	23949	11916	3	0	\N
183348	2133	92182004000	23949	11916	4	0	\N
183349	2133	92181002000	23949	11916	5	0	\N
183350	1397	1296145749000	23950	11916	0	0	\N
183351	1397	1296135748000	23950	11916	1	0	\N
183352	2134	85865894000	23950	11916	2	0	\N
183353	2134	85864891000	23950	11916	3	0	\N
183354	2133	92182004000	23950	11916	4	0	\N
183355	2133	92181002000	23950	11916	5	0	\N
183356	1397	1296145749000	23951	11917	0	0	\N
183357	1397	1296135748000	23951	11917	1	0	\N
183358	1397	1296125747000	23951	11917	2	0	\N
183359	2134	85865894000	23951	11917	3	0	\N
183360	2134	85864891000	23951	11917	4	0	\N
183361	2134	85863888000	23951	11917	5	0	\N
183362	2133	92182004000	23951	11917	6	0	\N
183363	2133	92181002000	23951	11917	7	0	\N
183364	2133	92180000000	23951	11917	8	0	\N
183371	1397	1296115746000	23953	11918	0	0	\N
183372	2134	85865894000	23953	11918	1	0	\N
183373	2134	85864891000	23953	11918	2	0	\N
183374	2133	92178998000	23953	11918	3	0	\N
183375	2134	85863888000	23953	11918	4	0	\N
183376	2134	85862885000	23953	11918	5	0	\N
183383	1397	1296105745000	23955	11919	0	0	\N
183384	2133	92177996000	23955	11919	1	0	\N
183385	2134	85861882000	23955	11919	2	0	\N
183389	1397	1296095744000	23957	11920	0	0	\N
183390	2134	85860879000	23957	11920	1	0	\N
183391	2133	92176994000	23957	11920	2	0	\N
183395	2134	85860879000	23959	11920	0	0	\N
183396	2133	92176994000	23959	11920	1	0	\N
183416	1419	16847019560130	23964	11786	0	0	\N
183417	1397	1297305865000	23964	11786	1	0	\N
183418	1397	1297295864000	23964	11786	2	0	\N
183419	1402	80210098344073	23964	11786	3	0	\N
183420	1397	1297285863000	23964	11786	4	0	\N
183421	1397	1297275862000	23964	11786	5	0	\N
183422	1397	1297265861000	23964	11786	6	0	\N
183423	1397	1297255860000	23964	11786	7	0	\N
183424	1397	1297245859000	23964	11786	8	0	\N
183425	1397	1297235858000	23964	11786	9	0	\N
183426	1397	1297225857000	23964	11786	10	0	\N
183427	1397	1297215856000	23964	11786	11	0	\N
183428	1397	1297205855000	23964	11786	12	0	\N
183429	1397	1297195854000	23964	11786	13	0	\N
183430	1397	1297185853000	23964	11786	14	0	\N
183431	1397	1297175852000	23964	11786	15	0	\N
183432	1397	1297165851000	23964	11786	16	0	\N
183433	1397	1297155850000	23964	11786	17	0	\N
183434	1397	1297145849000	23964	11786	18	0	\N
183435	1397	1297135848000	23964	11786	19	0	\N
183436	1397	1297125847000	23964	11786	20	0	\N
183437	1397	1297115846000	23964	11786	21	0	\N
183438	1397	1297105845000	23964	11786	22	0	\N
183439	1397	1297095844000	23964	11786	23	0	\N
183440	1397	1297085843000	23964	11786	24	0	\N
183441	1397	1297075842000	23964	11786	25	0	\N
183442	1397	1297065841000	23964	11786	26	0	\N
183443	1397	1297055840000	23964	11786	27	0	\N
183444	1397	1297045839000	23964	11786	28	0	\N
183445	1397	1297035838000	23964	11786	29	0	\N
183446	1397	1297025837000	23964	11786	30	0	\N
183447	1397	1297015836000	23964	11786	31	0	\N
183448	1397	1297005835000	23964	11786	32	0	\N
183449	1397	1296995834000	23964	11786	33	0	\N
183450	1397	1296985833000	23964	11786	34	0	\N
183451	1397	1296975832000	23964	11786	35	0	\N
183452	1397	1296965831000	23964	11786	36	0	\N
183453	1397	1296955830000	23964	11786	37	0	\N
183454	1397	1296945829000	23964	11786	38	0	\N
183455	1397	1296935828000	23964	11786	39	0	\N
183456	1397	1296925827000	23964	11786	40	0	\N
183457	1397	1296915826000	23964	11786	41	0	\N
183458	1397	1296905825000	23964	11786	42	0	\N
183459	1397	1296895824000	23964	11786	43	0	\N
183460	1397	1296885823000	23964	11786	44	0	\N
183461	1397	1296875822000	23964	11786	45	0	\N
183462	1397	1296865821000	23964	11786	46	0	\N
183463	1397	1296855820000	23964	11786	47	0	\N
183464	1397	1296845819000	23964	11786	48	0	\N
183340	2133	92183006000	23946	11915	2	0	4499
183365	1397	1296145749000	23952	11917	0	0	14268
183366	1397	1296135748000	23952	11917	1	0	14269
183367	1397	1296125747000	23952	11917	2	0	14270
183368	2133	92182004000	23952	11917	3	0	4500
183370	2133	92180000000	23952	11917	5	0	4502
183377	1397	1296115746000	23954	11918	0	0	14271
183378	2134	85865894000	23954	11918	1	0	4710
183379	2134	85864891000	23954	11918	2	0	4711
183380	2133	92178998000	23954	11918	3	0	4503
183382	2134	85862885000	23954	11918	5	0	4713
183386	1397	1296105745000	23956	11919	0	0	14272
183387	2133	92177996000	23956	11919	1	0	4504
183388	2134	85861882000	23956	11919	2	0	4714
183393	2134	85860879000	23958	11920	1	0	4715
183394	2133	92176994000	23958	11920	2	0	4505
183397	1397	1296085743000	23960	11921	0	0	14274
183398	2133	92175992000	23960	11921	1	0	4506
183399	2134	85859876000	23960	11921	2	0	4716
183401	1397	1296065741000	23961	11922	1	0	14276
183402	2134	85858873000	23961	11922	2	0	4717
183403	2134	85857870000	23961	11922	3	0	4718
183404	2133	92174990000	23961	11922	4	0	4507
183405	2133	92173988000	23961	11922	5	0	4508
183407	1397	1296045739000	23962	11923	1	0	14278
183408	1402	82370146344073	23962	11923	2	0	34
183409	2134	85856867000	23962	11923	3	0	4719
183410	2134	85855864000	23962	11923	4	0	4720
183412	2133	92171984000	23962	11923	6	0	4510
183413	1397	1296035738000	23963	11924	0	0	14279
183414	2133	92170982000	23963	11924	1	0	4511
183415	2134	85854861000	23963	11924	2	0	4721
183465	1397	1296835818000	23964	11786	49	0	\N
183466	1397	1296825817000	23964	11786	50	0	\N
183467	1397	1296815816000	23964	11786	51	0	\N
183468	1397	1296805815000	23964	11786	52	0	\N
183469	1397	1296795814000	23964	11786	53	0	\N
183470	1397	1296785813000	23964	11786	54	0	\N
183471	1397	1296775812000	23964	11786	55	0	\N
183472	1397	1296765811000	23964	11786	56	0	\N
183473	1397	1296755810000	23964	11786	57	0	\N
183474	1397	1296745809000	23964	11786	58	0	\N
183475	1397	1296735808000	23964	11786	59	0	\N
183476	1397	1296725807000	23964	11786	60	0	\N
183477	1397	1296715806000	23964	11786	61	0	\N
183478	1397	1296705805000	23964	11786	62	0	\N
183479	1397	1296695804000	23964	11786	63	0	\N
183480	1397	1296685803000	23964	11786	64	0	\N
183481	1397	1296675802000	23964	11786	65	0	\N
183482	1397	1296665801000	23964	11786	66	0	\N
183483	1397	1296655800000	23964	11786	67	0	\N
183484	1397	1296645799000	23964	11786	68	0	\N
183485	1397	1296635798000	23964	11786	69	0	\N
183486	1397	1296625797000	23964	11786	70	0	\N
183487	1397	1296615796000	23964	11786	71	0	\N
183488	1397	1296605795000	23964	11786	72	0	\N
183489	1397	1296595794000	23964	11786	73	0	\N
183490	1397	1296585793000	23964	11786	74	0	\N
183491	1397	1296575792000	23964	11786	75	0	\N
183492	1397	1296565791000	23964	11786	76	0	\N
183493	1397	1296555790000	23964	11786	77	0	\N
183494	1397	1296545789000	23964	11786	78	0	\N
183495	1397	1296535788000	23964	11786	79	0	\N
183496	1397	1296525787000	23964	11786	80	0	\N
183497	1397	1296515786000	23964	11786	81	0	\N
183498	1397	1296505785000	23964	11786	82	0	\N
183499	1397	1296495784000	23964	11786	83	0	\N
183500	1397	1296485783000	23964	11786	84	0	\N
183501	1397	1296475782000	23964	11786	85	0	\N
183502	1397	1296465781000	23964	11786	86	0	\N
183503	1397	1296455780000	23964	11786	87	0	\N
183504	1397	1296445779000	23964	11786	88	0	\N
183505	1397	1296435778000	23964	11786	89	0	\N
183506	1397	1296425777000	23964	11786	90	0	\N
183507	1397	1296415776000	23964	11786	91	0	\N
183508	1397	1296405775000	23964	11786	92	0	\N
183509	1397	1296395774000	23964	11786	93	0	\N
183510	1397	1296385773000	23964	11786	94	0	\N
183511	1397	1296375772000	23964	11786	95	0	\N
183512	1397	1296365771000	23964	11786	96	0	\N
183513	1397	1296355770000	23964	11786	97	0	\N
183514	1397	1296345769000	23964	11786	98	0	\N
183515	1397	1296335768000	23964	11786	99	0	\N
183516	1397	1296325767000	23964	11786	100	0	\N
183517	1397	1296315766000	23964	11786	101	0	\N
183518	1397	1296305765000	23964	11786	102	0	\N
183519	1397	1296295764000	23964	11786	103	0	\N
183520	1397	1296285763000	23964	11786	104	0	\N
183521	1397	1296275762000	23964	11786	106	0	\N
183522	1397	1296265761000	23964	11786	107	0	\N
183523	1397	1296255760000	23964	11786	108	0	\N
183524	1397	1296245759000	23964	11786	109	0	\N
183525	1397	1296235758000	23964	11786	110	0	\N
183526	1397	1296225757000	23964	11786	111	0	\N
183527	1397	1296215756000	23964	11786	112	0	\N
183528	1397	1296205755000	23964	11786	113	0	\N
183529	1397	1296195754000	23964	11786	114	0	\N
183530	1397	1296185753000	23964	11786	115	0	\N
183531	1397	1296175752000	23964	11786	116	0	\N
183532	1397	1296165751000	23964	11786	117	0	\N
183533	1397	1296155750000	23964	11786	118	0	\N
183534	1397	1296145749000	23964	11786	119	0	\N
183535	1397	1296135748000	23964	11786	120	0	\N
183536	1397	1296125747000	23964	11786	121	0	\N
183537	1397	1296115746000	23964	11786	122	0	\N
183538	1397	1296105745000	23964	11786	123	0	\N
183539	1397	1296095744000	23964	11786	124	0	\N
183540	1397	1296085743000	23964	11786	125	0	\N
183541	1397	1296025737000	23965	11925	0	0	\N
183542	1402	82133653373639	23965	11925	1	0	\N
183543	2133	92169980000	23965	11925	2	0	\N
183563	1402	79532332968864	23969	11927	0	0	\N
183564	1397	1296015736000	23969	11927	1	0	\N
183565	1402	79420304719737	23969	11927	2	0	\N
183566	1402	78188095054345	23969	11927	3	0	\N
183567	1402	77933870405665	23969	11927	4	0	\N
183568	1402	75137501710178	23969	11927	5	0	\N
183569	1402	74782969331459	23969	11927	6	0	\N
183570	1402	74122001778122	23969	11927	7	0	\N
183571	1402	69228384075906	23969	11927	8	0	\N
183572	1402	59748717473867	23969	11927	9	0	\N
183573	1402	58703422804871	23969	11927	10	0	\N
183574	1402	58150496390061	23969	11927	11	0	\N
183575	2134	85851852000	23969	11927	12	0	\N
183576	2133	92167976000	23969	11927	13	0	\N
183587	1402	56756315912048	23971	11928	0	0	\N
183588	1402	54830631501773	23971	11928	1	0	\N
183589	1402	53140095451847	23971	11928	2	0	\N
183590	1397	1296005735000	23971	11928	3	0	\N
183591	1402	42844400483440	23971	11928	4	0	\N
183592	1402	41743347053908	23971	11928	5	0	\N
183593	1402	31447652085501	23971	11928	6	0	\N
183594	2133	92166974000	23971	11928	7	0	\N
183595	2134	85851852000	23971	11928	8	0	\N
183596	2134	85850849000	23971	11928	9	0	\N
183597	1402	30545180810740	23972	11929	0	0	\N
183598	1402	29973188312672	23972	11929	1	0	\N
183599	1402	27494587487553	23972	11929	2	0	\N
183600	1402	27113255822176	23972	11929	3	0	\N
183546	2133	92169980000	23966	11925	2	0	4512
183547	2134	85853858000	23966	11925	3	0	4722
183548	2134	85852855000	23967	11926	0	0	4723
183549	2133	92168978000	23967	11926	1	0	4513
183550	1402	79532332968864	23968	11927	0	0	36
183552	1402	79420304719737	23968	11927	2	0	37
183553	1402	78188095054345	23968	11927	3	0	38
183554	1402	77933870405665	23968	11927	4	0	39
183555	1402	75137501710178	23968	11927	5	0	40
183556	1402	74782969331459	23968	11927	6	0	41
183558	1402	69228384075906	23968	11927	8	0	43
183559	1402	59748717473867	23968	11927	9	0	44
183560	1402	58703422804871	23968	11927	10	0	45
183561	1402	58150496390061	23968	11927	11	0	46
183577	1402	56756315912048	23970	11928	0	0	47
183578	1402	54830631501773	23970	11928	1	0	48
183579	1402	53140095451847	23970	11928	2	0	49
183580	1397	1296005735000	23970	11928	3	0	14282
183581	1402	42844400483440	23970	11928	4	0	50
183583	1402	31447652085501	23970	11928	6	0	52
183584	2133	92166974000	23970	11928	7	0	4515
183585	2134	85851852000	23970	11928	8	0	4724
183586	2134	85850849000	23970	11928	9	0	4725
183601	1402	25975156992857	23972	11929	4	0	\N
183602	1397	1295995734000	23972	11929	5	0	\N
183603	2134	85849846000	23972	11929	6	0	\N
183604	2133	92165972000	23972	11929	7	0	\N
183619	1397	1295975732000	23976	11931	0	0	\N
183620	2133	92163968000	23976	11931	1	0	\N
183621	2134	85847840000	23976	11931	2	0	\N
183631	1402	82370146344073	23980	11916	0	0	\N
183632	1402	82133653373639	23980	11916	1	0	\N
183633	1402	79532332968864	23980	11916	2	0	\N
183634	1402	79420304719737	23980	11916	3	0	\N
183635	1402	78188095054345	23980	11916	4	0	\N
183636	1402	77933870405665	23980	11916	5	0	\N
183637	1402	75137501710178	23980	11916	6	0	\N
183638	1402	74782969331459	23980	11916	7	0	\N
183639	1402	74122001778122	23980	11916	8	0	\N
183640	1402	69228384075906	23980	11916	9	0	\N
183641	1402	59748717473867	23980	11916	10	0	\N
183642	1402	58703422804871	23980	11916	11	0	\N
183643	1402	58150496390061	23980	11916	12	0	\N
183644	1402	56756315912048	23980	11916	13	0	\N
183645	1402	54830631501773	23980	11916	14	0	\N
183646	1402	53140095451847	23980	11916	15	0	\N
183647	1402	42844400483440	23980	11916	16	0	\N
183648	1402	41743347053908	23980	11916	17	0	\N
183649	1402	31447652085501	23980	11916	18	0	\N
183650	1402	30545180810740	23980	11916	19	0	\N
183651	1402	29973188312672	23980	11916	20	0	\N
183652	1402	27494587487553	23980	11916	21	0	\N
183653	1402	27113255822176	23980	11916	22	0	\N
183654	1402	25975156992857	23980	11916	23	0	\N
183655	1402	25019782421307	23980	11916	24	0	\N
183656	1402	22922503261602	23980	11916	25	0	\N
183657	1402	22645836766968	23980	11916	26	0	\N
183658	1402	22480912773160	23980	11916	27	0	\N
183659	1402	21985184608176	23980	11916	28	0	\N
183663	1397	1295935728000	23982	11935	0	0	\N
183664	1397	1295925727000	23983	11936	0	0	\N
183665	2133	92158958000	23983	11936	1	0	\N
183666	2134	85842825000	23983	11936	2	0	\N
183673	1397	1295915726000	23986	11937	0	0	\N
183674	2134	85841822000	23986	11937	1	0	\N
183675	2133	92157956000	23986	11937	2	0	\N
183678	1397	1295895724000	23988	11939	0	0	\N
183679	2134	85840819000	23988	11939	1	0	\N
183680	2133	92155952000	23988	11939	2	0	\N
183684	1397	1295885723000	23990	11940	0	0	\N
183685	2134	85839816000	23990	11940	1	0	\N
183686	2133	92154950000	23990	11940	2	0	\N
183690	1397	1295885723000	23992	11940	0	0	\N
183691	2134	85839816000	23992	11940	1	0	\N
183692	2133	92154950000	23992	11940	2	0	\N
183693	1402	82370146344073	23993	11894	0	0	\N
183694	1402	82133653373639	23993	11894	1	0	\N
183695	1402	79532332968864	23993	11894	2	0	\N
183696	1397	1296445779000	23993	11894	3	0	\N
183697	1397	1296435778000	23993	11894	4	0	\N
183698	1402	79420304719737	23993	11894	5	0	\N
183699	1402	78188095054345	23993	11894	6	0	\N
183700	1402	77933870405665	23993	11894	7	0	\N
183701	1397	1296425777000	23993	11894	8	0	\N
183702	1397	1296415776000	23993	11894	9	0	\N
183703	1397	1296405775000	23993	11894	10	0	\N
183704	1397	1296395774000	23993	11894	11	0	\N
183705	1397	1296385773000	23993	11894	12	0	\N
183706	1397	1296375772000	23993	11894	13	0	\N
183707	1397	1296365771000	23993	11894	14	0	\N
183708	1397	1296355770000	23993	11894	15	0	\N
183709	1397	1296345769000	23993	11894	16	0	\N
183710	1397	1296335768000	23993	11894	17	0	\N
183711	1397	1296325767000	23993	11894	18	0	\N
183712	1397	1296315766000	23993	11894	19	0	\N
183713	1397	1296305765000	23993	11894	20	0	\N
183714	1397	1296295764000	23993	11894	21	0	\N
183715	1397	1296285763000	23993	11894	22	0	\N
183716	1397	1296275762000	23993	11894	23	0	\N
183717	1397	1296265761000	23993	11894	24	0	\N
183718	1397	1296255760000	23993	11894	25	0	\N
183719	1397	1296245759000	23993	11894	26	0	\N
183720	1397	1296235758000	23993	11894	27	0	\N
183721	1397	1296225757000	23993	11894	28	0	\N
183722	1397	1296215756000	23993	11894	29	0	\N
183723	1397	1296205755000	23993	11894	30	0	\N
183724	1397	1296195754000	23993	11894	31	0	\N
183725	1397	1296185753000	23993	11894	32	0	\N
183726	1397	1296175752000	23993	11894	33	0	\N
183727	1397	1296165751000	23993	11894	34	0	\N
183728	1397	1296155750000	23993	11894	35	0	\N
183729	1397	1296145749000	23993	11894	36	0	\N
183730	1397	1296135748000	23993	11894	37	0	\N
183731	1397	1296125747000	23993	11894	38	0	\N
183732	1397	1296115746000	23993	11894	39	0	\N
183733	1397	1296105745000	23993	11894	40	0	\N
183734	1397	1296095744000	23993	11894	41	0	\N
183735	1397	1296085743000	23993	11894	42	0	\N
183736	1397	1296075742000	23993	11894	43	0	\N
183607	1402	27494587487553	23973	11929	2	0	55
183608	1402	27113255822176	23973	11929	3	0	56
183609	1402	25975156992857	23973	11929	4	0	57
183610	1397	1295995734000	23973	11929	5	0	14283
183611	2134	85849846000	23973	11929	6	0	4726
183613	1397	1295985733000	23974	11930	0	0	14284
183614	2133	92164970000	23974	11930	2	0	4517
183615	2134	85848843000	23974	11930	3	0	4727
183616	1397	1295975732000	23975	11931	0	0	14285
183617	2133	92163968000	23975	11931	1	0	4518
183622	1397	1295965731000	23977	11932	0	0	14286
183623	2133	92162966000	23977	11932	1	0	4519
183624	2134	85846837000	23977	11932	2	0	4729
183625	1397	1295955730000	23978	11933	0	0	14287
183627	2134	85845834000	23978	11933	2	0	4730
183628	1397	1295945729000	23979	11934	0	0	14288
183629	2134	85844831000	23979	11934	1	0	4731
183630	2133	92160962000	23979	11934	2	0	4521
183660	1397	1295935728000	23981	11935	0	0	14289
183662	2134	85843828000	23981	11935	2	0	4732
183667	1397	1295925727000	23984	11936	0	0	14290
183668	2133	92158958000	23984	11936	1	0	4523
183669	2134	85842825000	23984	11936	2	0	4733
183670	1397	1295915726000	23985	11937	0	0	14291
183672	2133	92157956000	23985	11937	2	0	4524
183676	1397	1295905725000	23987	11938	0	0	14292
183677	2133	92156954000	23987	11938	1	0	4525
183681	1397	1295895724000	23989	11939	0	0	14293
183683	2133	92155952000	23989	11939	2	0	4526
183687	1397	1295885723000	23991	11940	0	0	14294
183688	2134	85839816000	23991	11940	1	0	4736
183689	2133	92154950000	23991	11940	2	0	4527
183737	1397	1296065741000	23993	11894	44	0	\N
183738	1397	1296055740000	23993	11894	45	0	\N
183739	1397	1296045739000	23993	11894	46	0	\N
183740	1397	1296035738000	23993	11894	47	0	\N
183741	1397	1296025737000	23993	11894	48	0	\N
183742	1397	1296015736000	23993	11894	49	0	\N
183743	1397	1296005735000	23993	11894	50	0	\N
183744	1397	1295995734000	23993	11894	51	0	\N
183745	1397	1295985733000	23993	11894	52	0	\N
183746	1397	1295975732000	23993	11894	53	0	\N
183747	1397	1295965731000	23993	11894	54	0	\N
183748	1397	1295955730000	23993	11894	55	0	\N
183749	1397	1295945729000	23993	11894	56	0	\N
183750	1397	1295935728000	23993	11894	57	0	\N
183751	1397	1295925727000	23993	11894	58	0	\N
183752	1397	1295915726000	23993	11894	59	0	\N
183753	1397	1295905725000	23993	11894	60	0	\N
183754	1397	1295895724000	23993	11894	61	0	\N
183755	1397	1295885723000	23993	11894	62	0	\N
183756	1402	75137501710178	23993	11894	63	0	\N
183757	1402	74782969331459	23993	11894	64	0	\N
183758	1402	74122001778122	23993	11894	65	0	\N
183759	1402	69228384075906	23993	11894	66	0	\N
183760	1402	59748717473867	23993	11894	67	0	\N
183761	1402	58703422804871	23993	11894	68	0	\N
183762	1402	58150496390061	23993	11894	69	0	\N
183763	1402	56756315912048	23993	11894	70	0	\N
183764	1402	54830631501773	23993	11894	71	0	\N
183765	1402	53140095451847	23993	11894	72	0	\N
183766	1402	42844400483440	23993	11894	73	0	\N
183767	1402	41743347053908	23993	11894	74	0	\N
183768	1402	31447652085501	23993	11894	75	0	\N
183769	1402	30545180810740	23993	11894	76	0	\N
183770	1402	29973188312672	23993	11894	77	0	\N
183771	1402	27494587487553	23993	11894	78	0	\N
183772	1402	27113255822176	23993	11894	79	0	\N
183773	1402	25975156992857	23993	11894	80	0	\N
183774	1402	25019782421307	23993	11894	81	0	\N
183775	1402	22922503261602	23993	11894	82	0	\N
183776	1402	22645836766968	23993	11894	83	0	\N
183777	1402	22480912773160	23993	11894	84	0	\N
183778	1402	21985184608176	23993	11894	85	0	\N
183779	2133	92212064000	23993	11894	86	0	\N
183780	2132	147693695000	23993	11894	87	0	\N
183781	2132	147692694000	23993	11894	88	0	\N
183782	2132	147691693000	23993	11894	89	0	\N
183783	2132	147690692000	23993	11894	90	0	\N
183784	2119	191000000	23993	11894	91	0	\N
183785	2133	92211062000	23993	11894	92	0	\N
183786	2133	92210060000	23993	11894	93	0	\N
183787	2133	92209058000	23993	11894	94	0	\N
183788	2133	92208056000	23993	11894	95	0	\N
183789	2133	92207054000	23993	11894	96	0	\N
183790	2133	92206052000	23993	11894	97	0	\N
183791	2133	92205050000	23993	11894	98	0	\N
183792	2133	92204048000	23993	11894	99	0	\N
183793	2132	147689691000	23993	11894	100	0	\N
183794	2132	147688690000	23993	11894	101	0	\N
183795	2132	147687689000	23993	11894	102	0	\N
183796	2132	147686688000	23993	11894	103	0	\N
183797	2132	147685687000	23993	11894	104	0	\N
183798	2133	92203046000	23993	11894	105	0	\N
183799	2133	92202044000	23993	11894	106	0	\N
183800	2133	92201042000	23993	11894	107	0	\N
183801	2133	92200040000	23993	11894	108	0	\N
183802	2133	92199038000	23993	11894	109	0	\N
183803	2133	92198036000	23993	11894	110	0	\N
183804	2133	92197034000	23993	11894	111	0	\N
183805	2133	92196032000	23993	11894	112	0	\N
183806	2133	92195030000	23993	11894	113	0	\N
183807	2133	92194028000	23993	11894	114	0	\N
183808	2133	92193026000	23993	11894	115	0	\N
183809	2133	92192024000	23993	11894	116	0	\N
183810	2133	92191022000	23993	11894	117	0	\N
183811	2133	92190020000	23993	11894	119	0	\N
183812	2133	92189018000	23993	11894	120	0	\N
183813	2133	92188016000	23993	11894	121	0	\N
183814	2133	92187014000	23993	11894	122	0	\N
183815	2133	92186012000	23993	11894	123	0	\N
183816	2133	92185010000	23993	11894	124	0	\N
183817	2133	92184008000	23993	11894	125	0	\N
183821	1402	25019782421307	23995	11940	0	0	\N
183825	1397	1295865721000	23997	11942	0	0	\N
183826	2134	85837810000	23997	11942	1	0	\N
183827	2133	92152946000	23997	11942	2	0	\N
183828	1397	1295855720000	23998	11943	0	0	\N
183829	1397	1295845719000	23998	11943	1	0	\N
183830	1397	1295835718000	23998	11943	2	0	\N
183831	2134	85836807000	23998	11943	3	0	\N
183832	2134	85835804000	23998	11943	4	0	\N
183833	2134	85834801000	23998	11943	5	0	\N
183834	2133	92151944000	23998	11943	6	0	\N
183835	2133	92150942000	23998	11943	7	0	\N
183836	2133	92149940000	23998	11943	8	0	\N
183846	1397	1295825717000	24000	11944	0	0	\N
183847	2133	92148938000	24000	11944	1	0	\N
183848	2134	85833798000	24000	11944	2	0	\N
183849	2133	92148938000	24001	11944	0	0	\N
183853	1397	1295825717000	24003	11944	0	0	\N
183854	2133	92148938000	24003	11944	1	0	\N
183855	2134	85833798000	24003	11944	2	0	\N
183856	1397	1295815716000	24004	11945	0	0	\N
183857	2133	92147936000	24004	11945	1	0	\N
183858	2134	85832795000	24004	11945	2	0	\N
183859	367	66000011000000	24004	11945	3	0	\N
183860	446	66000998900001	24004	11945	4	0	\N
183869	1397	1295795714000	24007	11947	0	0	\N
183870	2134	85830789000	24007	11947	1	0	\N
183820	2133	92153948000	23994	11941	2	0	4528
183822	1397	1295865721000	23996	11942	0	0	14296
183823	2134	85837810000	23996	11942	1	0	4738
183824	2133	92152946000	23996	11942	2	0	4529
183837	1397	1295855720000	23999	11943	0	0	14297
183839	1397	1295835718000	23999	11943	2	0	14299
183840	2134	85836807000	23999	11943	3	0	4739
183841	2134	85835804000	23999	11943	4	0	4740
183842	2134	85834801000	23999	11943	5	0	4741
183843	2133	92151944000	23999	11943	6	0	4530
183845	2133	92149940000	23999	11943	8	0	4532
183850	1397	1295825717000	24002	11944	0	0	14300
183851	2133	92148938000	24002	11944	1	0	4533
183852	2134	85833798000	24002	11944	2	0	4742
183862	2133	92147936000	24005	11945	1	0	4534
183863	2134	85832795000	24005	11945	2	0	4743
183864	367	66000011000000	24005	11945	3	0	1
183865	446	66000998900001	24005	11945	4	0	1
183866	1397	1295805715000	24006	11946	0	0	14302
183868	2134	85831792000	24006	11946	2	0	4744
183871	1397	1295795714000	24008	11947	0	0	14303
183872	2134	85830789000	24008	11947	1	0	4745
183873	1397	1295795714000	24009	11947	0	0	\N
183874	2134	85830789000	24009	11947	1	0	\N
183881	1397	1295785713000	24011	11948	0	0	\N
183882	1397	1295775712000	24011	11948	1	0	\N
183883	2133	92145932000	24011	11948	2	0	\N
183884	2133	92144930000	24011	11948	3	0	\N
183885	1397	1295765711000	24012	11949	0	0	\N
183886	2134	85827780000	24012	11949	1	0	\N
183887	2133	92143928000	24012	11949	2	0	\N
183900	1402	25019782421307	24019	11953	0	0	\N
183901	1397	1295725707000	24019	11953	1	0	\N
183902	2133	92139920000	24019	11953	2	0	\N
183903	2134	85823768000	24019	11953	3	0	\N
183904	1402	25019782421307	24020	11953	0	0	\N
183905	1397	1295725707000	24020	11953	1	0	\N
183906	2133	92139920000	24020	11953	2	0	\N
183907	2134	85823768000	24020	11953	3	0	\N
183921	1397	1295705705000	24024	11955	0	0	\N
183922	1402	22922503261602	24024	11955	1	0	\N
183923	1402	22645836766968	24024	11955	2	0	\N
183924	1402	22480912773160	24024	11955	3	0	\N
183925	2133	92137916000	24024	11955	4	0	\N
183926	2134	85821762000	24024	11955	5	0	\N
183933	1402	21985184608176	24026	11956	0	0	\N
183934	1402	20202495822424	24026	11956	1	0	\N
183935	1402	19804066757638	24026	11956	2	0	\N
183936	1397	1295695704000	24026	11956	3	0	\N
183937	2134	85820759000	24026	11956	4	0	\N
183938	2133	92136914000	24026	11956	5	0	\N
183951	1397	1295665701000	24028	11958	0	0	\N
183952	2134	85817750000	24028	11958	1	0	\N
183953	2133	92133908000	24028	11958	2	0	\N
183957	1397	1295665701000	24030	11958	0	0	\N
183958	2134	85817750000	24030	11958	1	0	\N
183959	2133	92133908000	24030	11958	2	0	\N
183960	1397	1295655700000	24031	11959	0	0	\N
183961	2134	85816747000	24031	11959	1	0	\N
183962	2133	92132906000	24031	11959	2	0	\N
183963	1397	1295655700000	24032	11959	0	0	\N
183964	2134	85816747000	24032	11959	1	0	\N
183965	2133	92132906000	24032	11959	2	0	\N
183978	1397	1295625697000	24036	11961	0	0	\N
183979	2134	85813738000	24036	11961	1	0	\N
183980	2133	92129900000	24036	11961	2	0	\N
183981	1397	1295615696000	24037	11962	0	0	\N
183982	2133	92128898000	24037	11962	1	0	\N
183983	1397	1295615696000	24038	11962	0	0	\N
183984	2133	92128898000	24038	11962	1	0	\N
183989	1397	1295605695000	24042	11963	0	0	\N
183990	2134	85812735000	24042	11963	1	0	\N
183991	2133	92127896000	24042	11963	2	0	\N
183998	2134	85810729000	24045	11965	0	0	\N
183999	2133	92125892000	24045	11965	1	0	\N
183877	2134	85829786000	24010	11948	2	0	4746
183878	2134	85828783000	24010	11948	3	0	4747
183879	2133	92145932000	24010	11948	4	0	4536
183880	2133	92144930000	24010	11948	5	0	4537
183888	1397	1295765711000	24013	11949	0	0	14306
183890	2133	92143928000	24013	11949	2	0	4538
183891	1397	1295755710000	24014	11950	0	0	14307
183892	2134	85826777000	24014	11950	1	0	4749
183893	2133	92142926000	24014	11950	2	0	4539
183894	1397	1295745709000	24017	11951	0	0	14308
183896	2133	92141924000	24017	11951	2	0	4540
183897	1397	1295735708000	24018	11952	0	0	14309
183898	2133	92140922000	24018	11952	1	0	4541
183899	2134	85824771000	24018	11952	2	0	4751
183909	1397	1295725707000	24021	11953	1	0	14310
183910	2133	92139920000	24021	11953	2	0	4542
183911	2134	85823768000	24021	11953	3	0	4752
183912	1397	1295715706000	24022	11954	0	0	14311
183913	2133	92138918000	24022	11954	1	0	4543
183915	1397	1295705705000	24023	11955	0	0	14312
183916	1402	22922503261602	24023	11955	1	0	59
183917	1402	22645836766968	24023	11955	2	0	60
183918	1402	22480912773160	24023	11955	3	0	61
183919	2133	92137916000	24023	11955	4	0	4544
183927	1402	21985184608176	24025	11956	0	0	62
183928	1402	20202495822424	24025	11956	1	0	63
183929	1402	19804066757638	24025	11956	2	0	64
183930	1397	1295695704000	24025	11956	3	0	14313
183932	2133	92136914000	24025	11956	5	0	4545
183939	1402	19799800143739	24027	11957	0	0	65
183940	1402	18902767145435	24027	11957	1	0	66
183941	1397	1295685703000	24027	11957	2	0	14314
183942	1397	1295675702000	24027	11957	3	0	14315
183944	1613	13531827200000	24027	11957	5	0	8
183945	1613	10654529700000	24027	11957	6	0	9
183946	1613	7777232200000	24027	11957	7	0	10
183947	2133	92135912000	24027	11957	8	0	4546
183948	2133	92134910000	24027	11957	9	0	4547
183950	2134	85818753000	24027	11957	11	0	4757
183954	1397	1295665701000	24029	11958	0	0	14316
183955	2134	85817750000	24029	11958	1	0	4758
183956	2133	92133908000	24029	11958	2	0	4548
183967	2134	85816747000	24033	11959	1	0	4759
183968	2133	92132906000	24033	11959	2	0	4549
183969	1397	1295645699000	24034	11960	0	0	14318
183970	1397	1295635698000	24034	11960	1	0	14319
183971	2133	92131904000	24034	11960	2	0	4550
183973	2134	85815744000	24034	11960	4	0	4760
183974	2134	85814741000	24034	11960	5	0	4761
183975	1397	1295625697000	24035	11961	0	0	14320
183976	2134	85813738000	24035	11961	1	0	4762
183977	2133	92129900000	24035	11961	2	0	4552
183986	2133	92128898000	24039	11962	1	0	4553
183987	1397	1295605695000	24041	11963	0	0	14322
183988	2134	85812735000	24041	11963	1	0	4763
183992	1397	1295595694000	24043	11964	0	0	14323
183994	2133	92127896000	24043	11964	2	0	4554
183995	2133	92126894000	24043	11964	3	0	4555
183996	2134	85810729000	24044	11965	0	0	4765
183997	2133	92125892000	24044	11965	1	0	4556
184000	1397	1295585693000	24046	11966	0	0	14324
184002	2134	85809726000	24046	11966	2	0	4766
184003	1397	1295575692000	24047	11967	0	0	14325
184004	1397	1295565691000	24047	11967	1	0	14326
184005	2133	92123888000	24047	11967	2	0	4558
184006	2134	85808723000	24047	11967	3	0	4767
184008	2133	92122886000	24047	11967	5	0	4559
184009	1397	1295555690000	24048	11968	0	0	\N
184010	1397	1295545689000	24048	11968	1	0	\N
184011	2133	92121884000	24048	11968	2	0	\N
184012	2134	85806717000	24048	11968	3	0	\N
184013	2134	85805714000	24048	11968	4	0	\N
184019	1397	1295535688000	24050	11969	0	0	\N
184020	1397	1295525687000	24050	11969	1	0	\N
184021	2134	85804711000	24050	11969	2	0	\N
184022	2134	85803708000	24050	11969	3	0	\N
184023	1397	1295535688000	24051	11969	0	0	\N
184024	1397	1295525687000	24051	11969	1	0	\N
184025	2134	85804711000	24051	11969	2	0	\N
184026	2134	85803708000	24051	11969	3	0	\N
184029	1397	1295535688000	24053	11969	0	0	\N
184030	1397	1295525687000	24053	11969	1	0	\N
184031	2134	85804711000	24053	11969	2	0	\N
184032	2134	85803708000	24053	11969	3	0	\N
184033	1397	1295535688000	24054	11969	0	0	\N
184034	1397	1295525687000	24054	11969	1	0	\N
184035	2134	85804711000	24054	11969	2	0	\N
184036	2134	85803708000	24054	11969	3	0	\N
184045	1397	1295485683000	24058	11973	0	0	\N
184046	2134	85799696000	24058	11973	1	0	\N
184053	1397	1295465681000	24062	11975	0	0	\N
184054	2134	85797690000	24062	11975	1	0	\N
184055	1613	18250029400000	24063	11895	0	0	\N
184056	1402	20202495822424	24063	11895	1	0	\N
184057	1397	1295875722000	24063	11895	2	0	\N
184058	1397	1295865721000	24063	11895	3	0	\N
184059	1402	19804066757638	24063	11895	4	0	\N
184060	1402	19799800143739	24063	11895	5	0	\N
184061	1402	18902767145435	24063	11895	6	0	\N
184062	1613	13531827200000	24063	11895	7	0	\N
184063	1613	10654529700000	24063	11895	8	0	\N
184064	1613	7777232200000	24063	11895	9	0	\N
184065	1397	1295855720000	24063	11895	10	0	\N
184066	1397	1295845719000	24063	11895	11	0	\N
184067	1397	1295835718000	24063	11895	12	0	\N
184068	1397	1295825717000	24063	11895	13	0	\N
184069	1397	1295815716000	24063	11895	14	0	\N
184070	1397	1295805715000	24063	11895	15	0	\N
184071	1397	1295795714000	24063	11895	16	0	\N
184072	1397	1295785713000	24063	11895	17	0	\N
184073	1397	1295775712000	24063	11895	18	0	\N
184074	1397	1295765711000	24063	11895	19	0	\N
184075	1397	1295755710000	24063	11895	20	0	\N
184076	1397	1295745709000	24063	11895	21	0	\N
184077	1397	1295735708000	24063	11895	22	0	\N
184078	1397	1295725707000	24063	11895	23	0	\N
184079	1397	1295715706000	24063	11895	24	0	\N
184080	1397	1295705705000	24063	11895	25	0	\N
184081	1397	1295695704000	24063	11895	26	0	\N
184082	1397	1295685703000	24063	11895	27	0	\N
184083	1397	1295675702000	24063	11895	28	0	\N
184084	1397	1295665701000	24063	11895	29	0	\N
184085	1397	1295655700000	24063	11895	30	0	\N
184086	1397	1295645699000	24063	11895	31	0	\N
184087	1397	1295635698000	24063	11895	32	0	\N
184088	1397	1295625697000	24063	11895	33	0	\N
184089	1397	1295615696000	24063	11895	34	0	\N
184090	1397	1295605695000	24063	11895	35	0	\N
184091	1397	1295595694000	24063	11895	36	0	\N
184092	1397	1295585693000	24063	11895	37	0	\N
184093	1397	1295575692000	24063	11895	38	0	\N
184094	1397	1295565691000	24063	11895	39	0	\N
184095	1397	1295555690000	24063	11895	40	0	\N
184096	1397	1295545689000	24063	11895	41	0	\N
184097	1397	1295535688000	24063	11895	42	0	\N
184098	1397	1295525687000	24063	11895	43	0	\N
184099	1397	1295515686000	24063	11895	44	0	\N
184100	1397	1295505685000	24063	11895	45	0	\N
184101	1397	1295495684000	24063	11895	46	0	\N
184102	1397	1295485683000	24063	11895	47	0	\N
184103	1397	1295475682000	24063	11895	48	0	\N
184104	1397	1295465681000	24063	11895	49	0	\N
184105	367	66000011000000	24063	11895	50	0	\N
184106	446	66000998900001	24063	11895	51	0	\N
184107	2133	92183006000	24063	11895	52	0	\N
184108	2133	92182004000	24063	11895	53	0	\N
184109	2133	92181002000	24063	11895	54	0	\N
184110	2133	92180000000	24063	11895	55	0	\N
184111	2133	92178998000	24063	11895	56	0	\N
184112	2133	92177996000	24063	11895	57	0	\N
184113	2133	92176994000	24063	11895	58	0	\N
184114	2133	92175992000	24063	11895	59	0	\N
184115	2133	92174990000	24063	11895	60	0	\N
184116	2133	92173988000	24063	11895	61	0	\N
184117	2133	92172986000	24063	11895	62	0	\N
184118	2133	92171984000	24063	11895	63	0	\N
184119	2133	92170982000	24063	11895	64	0	\N
184120	2133	92169980000	24063	11895	65	0	\N
184121	2133	92168978000	24063	11895	66	0	\N
184122	2133	92167976000	24063	11895	67	0	\N
184123	2133	92166974000	24063	11895	68	0	\N
184124	2133	92165972000	24063	11895	69	0	\N
184125	2133	92164970000	24063	11895	70	0	\N
184126	2133	92163968000	24063	11895	71	0	\N
184127	2133	92162966000	24063	11895	72	0	\N
184128	2133	92161964000	24063	11895	73	0	\N
184129	2133	92160962000	24063	11895	74	0	\N
184130	2133	92159960000	24063	11895	75	0	\N
184131	2133	92158958000	24063	11895	76	0	\N
184132	2133	92157956000	24063	11895	77	0	\N
184133	2133	92156954000	24063	11895	78	0	\N
184134	2134	85895984000	24063	11895	79	0	\N
184135	2134	85894981000	24063	11895	80	0	\N
184136	2134	85893978000	24063	11895	81	0	\N
184137	2134	85892975000	24063	11895	82	0	\N
184138	2134	85891972000	24063	11895	83	0	\N
184139	2134	85890969000	24063	11895	84	0	\N
184140	2134	85889966000	24063	11895	85	0	\N
184141	2134	85888963000	24063	11895	86	0	\N
184142	2134	85887960000	24063	11895	87	0	\N
184143	2134	85886957000	24063	11895	88	0	\N
184144	2134	85885954000	24063	11895	89	0	\N
184016	2133	92121884000	24049	11968	2	0	4560
184017	2134	85806717000	24049	11968	3	0	4769
184018	2134	85805714000	24049	11968	4	0	4770
184027	1397	1295535688000	24052	11969	0	0	14329
184028	1397	1295525687000	24052	11969	1	0	14330
184038	2134	85804711000	24055	11970	1	0	4771
184039	2134	85803708000	24055	11970	2	0	4772
184040	2134	85802705000	24055	11970	3	0	4773
184041	1397	1295505685000	24056	11971	0	0	14332
184042	2134	85801702000	24056	11971	1	0	4774
184044	2134	85800699000	24057	11972	1	0	4775
184047	1397	1295485683000	24059	11973	0	0	14334
184048	2134	85799696000	24059	11973	1	0	4776
184049	1397	1295475682000	24060	11974	0	0	14335
184051	1397	1295465681000	24061	11975	0	0	14336
184052	2134	85797690000	24061	11975	1	0	4778
184145	2134	85884951000	24063	11895	90	0	\N
184146	2134	85883948000	24063	11895	91	0	\N
184147	2134	85882945000	24063	11895	92	0	\N
184148	2134	85881942000	24063	11895	93	0	\N
184149	2134	85880939000	24063	11895	94	0	\N
184150	2134	85879936000	24063	11895	95	0	\N
184151	2134	85878933000	24063	11895	96	0	\N
184152	2134	85877930000	24063	11895	97	0	\N
184153	2134	85876927000	24063	11895	98	0	\N
184154	2134	85875924000	24063	11895	99	0	\N
184155	2134	85874921000	24063	11895	100	0	\N
184156	2134	85873918000	24063	11895	101	0	\N
184157	2134	85872915000	24063	11895	102	0	\N
184158	2134	85871912000	24063	11895	103	0	\N
184159	2134	85870909000	24063	11895	104	0	\N
184160	2134	85869906000	24063	11895	105	0	\N
184161	2134	85868903000	24063	11895	106	0	\N
184162	2134	85867900000	24063	11895	107	0	\N
184163	2134	85866897000	24063	11895	108	0	\N
184164	2134	85865894000	24063	11895	109	0	\N
184165	2134	85864891000	24063	11895	110	0	\N
184166	2134	85863888000	24063	11895	111	0	\N
184167	2134	85862885000	24063	11895	112	0	\N
184168	2134	85861882000	24063	11895	113	0	\N
184169	2134	85860879000	24063	11895	114	0	\N
184170	2134	85859876000	24063	11895	115	0	\N
184171	2134	85858873000	24063	11895	116	0	\N
184172	2134	85857870000	24063	11895	117	0	\N
184173	2134	85856867000	24063	11895	119	0	\N
184174	2134	85855864000	24063	11895	120	0	\N
184175	2134	85854861000	24063	11895	121	0	\N
184176	2134	85853858000	24063	11895	122	0	\N
184177	2134	85852855000	24063	11895	123	0	\N
184178	2134	85851852000	24063	11895	124	0	\N
184179	2134	85850849000	24063	11895	125	0	\N
184180	1397	1295455680000	24066	11977	0	0	\N
184181	1397	1295445679000	24066	11977	1	0	\N
184182	1397	1295435678000	24066	11977	2	0	\N
184183	2134	85796687000	24066	11977	3	0	\N
184184	2134	85795684000	24066	11977	4	0	\N
184185	2134	85794681000	24066	11977	5	0	\N
184208	1397	1295345669000	24071	11981	0	0	\N
184209	2134	85785654000	24071	11981	1	0	\N
184214	1397	1295325667000	24074	11983	0	0	\N
184215	2134	85783648000	24074	11983	1	0	\N
184228	1397	1295295664000	24079	11986	0	0	\N
184229	1397	1295285663000	24079	11986	1	0	\N
184230	1397	1295275662000	24079	11986	2	0	\N
184231	2134	85780639000	24079	11986	3	0	\N
184232	2134	85779636000	24079	11986	4	0	\N
184233	2134	85778633000	24079	11986	5	0	\N
184236	1397	1295265661000	24081	11987	0	0	\N
184237	2134	85777630000	24081	11987	1	0	\N
184238	1397	1295265661000	24082	11987	0	0	\N
184239	2134	85777630000	24082	11987	1	0	\N
184245	1397	1295235658000	24085	11989	0	0	\N
184246	2134	85774621000	24085	11989	1	0	\N
184255	1397	1295235658000	24087	11990	0	0	\N
184256	1397	1295225657000	24087	11990	1	0	\N
184257	1397	1295215656000	24087	11990	2	0	\N
184258	1397	1295205655000	24087	11990	3	0	\N
184259	2134	85773618000	24087	11990	4	0	\N
184260	2134	85772615000	24087	11990	5	0	\N
184261	2134	85771612000	24087	11990	6	0	\N
184262	2134	85770609000	24087	11990	7	0	\N
184263	1397	1295235658000	24088	11990	0	0	\N
184264	1397	1295225657000	24088	11990	1	0	\N
184265	1397	1295215656000	24088	11990	2	0	\N
184266	1397	1295205655000	24088	11990	3	0	\N
184267	2134	85773618000	24088	11990	4	0	\N
184268	2134	85772615000	24088	11990	5	0	\N
184269	2134	85771612000	24088	11990	6	0	\N
184270	2134	85770609000	24088	11990	7	0	\N
184271	1397	1295235658000	24089	11990	0	0	\N
184272	1397	1295225657000	24089	11990	1	0	\N
184273	1397	1295215656000	24089	11990	2	0	\N
184274	1397	1295205655000	24089	11990	3	0	\N
184275	2134	85773618000	24089	11990	4	0	\N
184276	2134	85772615000	24089	11990	5	0	\N
184277	2134	85771612000	24089	11990	6	0	\N
184278	2134	85770609000	24089	11990	7	0	\N
184188	1397	1295435678000	24067	11977	2	0	14339
184189	2134	85796687000	24067	11977	3	0	4779
184190	2134	85795684000	24067	11977	4	0	4780
184191	2134	85794681000	24067	11977	5	0	4781
184192	1397	1295425677000	24068	11978	0	0	14340
184194	1397	1295405675000	24068	11978	2	0	14342
184195	1397	1295395674000	24068	11978	3	0	14343
184196	1397	1295385673000	24068	11978	4	0	14344
184197	2134	85793678000	24068	11978	5	0	4782
184198	2134	85792675000	24068	11978	6	0	4783
184200	2134	85790669000	24068	11978	8	0	4785
184201	2134	85789666000	24068	11978	9	0	4786
184202	1397	1295375672000	24069	11979	0	0	14345
184203	2134	85788663000	24069	11979	1	0	4787
184205	1397	1295355670000	24070	11980	1	0	14347
184206	2134	85787660000	24070	11980	2	0	4788
184207	2134	85786657000	24070	11980	3	0	4789
184210	1397	1295345669000	24072	11981	0	0	14348
184211	2134	85785654000	24072	11981	1	0	4790
184213	2134	85784651000	24073	11982	1	0	4791
184216	1397	1295325667000	24075	11983	0	0	14350
184217	2134	85783648000	24075	11983	1	0	4792
184218	1397	1295315666000	24076	11984	0	0	14351
184219	2134	85782645000	24076	11984	1	0	4793
184221	2134	85781642000	24077	11985	1	0	4794
184222	1397	1295295664000	24078	11986	0	0	14353
184223	1397	1295285663000	24078	11986	1	0	14354
184224	1397	1295275662000	24078	11986	2	0	14355
184226	2134	85779636000	24078	11986	4	0	4796
184227	2134	85778633000	24078	11986	5	0	4797
184234	1397	1295265661000	24080	11987	0	0	14356
184235	2134	85777630000	24080	11987	1	0	4798
184240	1397	1295255660000	24083	11988	0	0	14357
184242	2134	85776627000	24083	11988	2	0	4799
184243	2134	85775624000	24083	11988	3	0	4800
184244	2134	85774621000	24084	11989	0	0	4801
184247	1397	1295235658000	24086	11990	0	0	14359
184248	1397	1295225657000	24086	11990	1	0	14360
184250	1397	1295205655000	24086	11990	3	0	14362
184251	2134	85773618000	24086	11990	4	0	4802
184252	2134	85772615000	24086	11990	5	0	4803
184253	2134	85771612000	24086	11990	6	0	4804
184279	1397	1295195654000	24090	11991	0	0	14363
184280	2134	85769606000	24090	11991	1	0	4806
184291	1397	1295145649000	24095	11995	0	0	\N
184292	2134	85764591000	24095	11995	1	0	\N
184293	1397	1295145649000	24096	11995	0	0	\N
184294	2134	85764591000	24096	11995	1	0	\N
184295	1397	1295135648000	24097	11996	0	0	\N
184296	2134	85763588000	24097	11996	1	0	\N
184299	1397	1295135648000	24099	11996	0	0	\N
184300	2134	85763588000	24099	11996	1	0	\N
184302	1397	1295115646000	24101	11998	0	0	\N
184303	2134	85762585000	24101	11998	1	0	\N
184304	1397	1295115646000	24102	11998	0	0	\N
184305	2134	85762585000	24102	11998	1	0	\N
184310	1397	1295105645000	24105	11999	0	0	\N
184311	2134	85761582000	24105	11999	1	0	\N
184317	2134	85757570000	24112	12002	0	0	\N
184318	2134	85757570000	24113	12002	0	0	\N
184320	2134	85755564000	24115	12004	0	0	\N
184332	1397	1295085643000	24119	12005	0	0	\N
184333	1397	1295075642000	24119	12005	1	0	\N
184334	1397	1295065641000	24119	12005	2	0	\N
184335	1397	1295055640000	24119	12005	3	0	\N
184336	1489	24384531490000	24119	12005	4	0	\N
184337	2134	85754561000	24119	12005	5	0	\N
184338	2134	85753558000	24119	12005	6	0	\N
184339	1489	24383826550000	24119	12005	7	0	\N
184340	2134	85752555000	24119	12005	8	0	\N
184341	2134	85751552000	24119	12005	9	0	\N
184342	1397	1295045639000	24120	12006	0	0	\N
184343	2134	85750549000	24120	12006	1	0	\N
184346	1397	1295045639000	24122	12006	0	0	\N
184347	2134	85750549000	24122	12006	1	0	\N
184352	1397	1295035638000	24124	12007	0	0	\N
184353	1397	1295025637000	24124	12007	1	0	\N
184354	2134	85749546000	24124	12007	2	0	\N
184355	2134	85748543000	24124	12007	3	0	\N
184364	1397	1294985633000	24128	12010	0	0	\N
184365	2134	85744531000	24128	12010	1	0	\N
184368	1397	1294975632000	24130	12011	0	0	\N
184369	2134	85743528000	24130	12011	1	0	\N
184378	1397	1294965631000	24132	12012	0	0	\N
184379	1397	1294955630000	24132	12012	1	0	\N
184380	1397	1294945629000	24132	12012	2	0	\N
184381	2134	85742525000	24132	12012	3	0	\N
184382	2134	85741522000	24132	12012	4	0	\N
184383	1489	16703587030000	24132	12012	5	0	\N
184384	1489	13947442680000	24132	12012	6	0	\N
184385	2134	85740519000	24132	12012	7	0	\N
184394	1397	1294915626000	24135	12014	0	0	\N
184395	2134	85737510000	24135	12014	1	0	\N
184396	1397	1294915626000	24136	12014	0	0	\N
184397	2134	85737510000	24136	12014	1	0	\N
184398	2134	85736507000	24137	12015	0	0	\N
184399	2134	85735504000	24137	12015	1	0	\N
184412	2134	85730489000	24141	12018	0	0	\N
184413	2134	85729486000	24141	12018	1	0	\N
184283	1397	1295175652000	24092	11993	0	0	14365
184284	2134	85767600000	24092	11993	1	0	4808
184285	1397	1295165651000	24093	11994	0	0	14366
184286	1397	1295155650000	24093	11994	1	0	14367
184287	2134	85766597000	24093	11994	2	0	4809
184289	1397	1295145649000	24094	11995	0	0	14368
184290	2134	85764591000	24094	11995	1	0	4811
184297	1397	1295135648000	24098	11996	0	0	14369
184298	2134	85763588000	24098	11996	1	0	4812
184301	1397	1295125647000	24100	11997	0	0	14370
184307	2134	85762585000	24103	11998	1	0	4813
184308	1397	1295105645000	24104	11999	0	0	14372
184309	2134	85761582000	24104	11999	1	0	4814
184312	1397	1295095644000	24106	12000	0	0	14373
184314	2134	85759576000	24106	12000	2	0	4816
184315	2134	85758573000	24108	12001	0	0	4817
184316	2134	85757570000	24111	12002	0	0	4818
184319	2134	85756567000	24114	12003	0	0	4819
184321	2134	85755564000	24117	12004	0	0	4820
184323	1397	1295075642000	24118	12005	1	0	14375
184324	1397	1295065641000	24118	12005	2	0	14376
184325	1397	1295055640000	24118	12005	3	0	14377
184326	1489	24384531490000	24118	12005	4	0	5
184327	2134	85754561000	24118	12005	5	0	4821
184329	1489	24383826550000	24118	12005	7	0	6
184330	2134	85752555000	24118	12005	8	0	4823
184331	2134	85751552000	24118	12005	9	0	4824
184344	1397	1295045639000	24121	12006	0	0	14378
184348	1397	1295035638000	24123	12007	0	0	14379
184349	1397	1295025637000	24123	12007	1	0	14380
184350	2134	85749546000	24123	12007	2	0	4826
184351	2134	85748543000	24123	12007	3	0	4827
184356	1397	1295015636000	24125	12008	0	0	14381
184358	1397	1295005635000	24126	12009	0	0	14382
184359	1397	1294995634000	24126	12009	1	0	14383
184360	2134	85746537000	24126	12009	2	0	4829
184361	2134	85745534000	24126	12009	3	0	4830
184362	1397	1294985633000	24127	12010	0	0	14384
184366	1397	1294975632000	24129	12011	0	0	14385
184367	2134	85743528000	24129	12011	1	0	4832
184370	1397	1294965631000	24131	12012	0	0	14386
184371	1397	1294955630000	24131	12012	1	0	14387
184373	2134	85742525000	24131	12012	3	0	4833
184374	2134	85741522000	24131	12012	4	0	4834
184375	1489	16703587030000	24131	12012	5	0	7
184376	1489	13947442680000	24131	12012	6	0	8
184377	2134	85740519000	24131	12012	7	0	4835
184387	1397	1294925627000	24133	12013	1	0	14390
184388	1489	9862571430000	24133	12013	2	0	9
184389	1489	7583056040000	24133	12013	3	0	10
184390	2134	85739516000	24133	12013	4	0	4836
184391	2134	85738513000	24133	12013	5	0	4837
184393	2134	85737510000	24134	12014	1	0	4838
184400	1397	1294905625000	24138	12015	0	0	14392
184401	1397	1294895624000	24138	12015	1	0	14393
184402	2134	85736507000	24138	12015	2	0	4839
184404	1397	1294885623000	24139	12016	0	0	14394
184405	2134	85734501000	24139	12016	1	0	4841
184406	1397	1294875622000	24140	12017	0	0	14395
184407	1397	1294865621000	24140	12017	1	0	14396
184408	1397	1294855620000	24140	12017	2	0	14397
184410	2134	85732495000	24140	12017	4	0	4843
184411	2134	85731492000	24140	12017	5	0	4844
184414	1397	1294845619000	24142	12018	0	0	14398
184415	1397	1294835618000	24142	12018	1	0	14399
184416	2134	85730489000	24142	12018	2	0	4845
184418	1397	1294845619000	24143	12018	0	0	\N
184419	1397	1294835618000	24143	12018	1	0	\N
184420	2134	85730489000	24143	12018	2	0	\N
184421	2134	85729486000	24143	12018	3	0	\N
184422	1397	1296075742000	24144	11787	0	0	\N
184423	1397	1296065741000	24144	11787	1	0	\N
184424	1402	79973605373639	24144	11787	2	0	\N
184425	1402	77372284968864	24144	11787	3	0	\N
184426	1397	1296055740000	24144	11787	4	0	\N
184427	1397	1296045739000	24144	11787	5	0	\N
184428	1397	1296035738000	24144	11787	6	0	\N
184429	1397	1296025737000	24144	11787	7	0	\N
184430	1397	1296015736000	24144	11787	8	0	\N
184431	1397	1296005735000	24144	11787	9	0	\N
184432	1613	18250029400000	24144	11787	10	0	\N
184433	1397	1295995734000	24144	11787	11	0	\N
184434	1397	1295985733000	24144	11787	12	0	\N
184435	1397	1295975732000	24144	11787	13	0	\N
184436	1397	1295965731000	24144	11787	14	0	\N
184437	1613	13531827200000	24144	11787	15	0	\N
184438	1613	10654529700000	24144	11787	16	0	\N
184439	1613	7777232200000	24144	11787	17	0	\N
184440	1397	1295955730000	24144	11787	18	0	\N
184441	1397	1295945729000	24144	11787	19	0	\N
184442	1397	1295935728000	24144	11787	20	0	\N
184443	1397	1295925727000	24144	11787	21	0	\N
184444	1397	1295915726000	24144	11787	22	0	\N
184445	1397	1295905725000	24144	11787	23	0	\N
184446	1397	1295895724000	24144	11787	24	0	\N
184447	1397	1295885723000	24144	11787	25	0	\N
184448	1397	1295875722000	24144	11787	26	0	\N
184449	1397	1295865721000	24144	11787	27	0	\N
184450	1397	1295855720000	24144	11787	28	0	\N
184451	1397	1295845719000	24144	11787	29	0	\N
184452	1397	1295835718000	24144	11787	30	0	\N
184453	1397	1295825717000	24144	11787	31	0	\N
184454	1397	1295815716000	24144	11787	32	0	\N
184455	1397	1295805715000	24144	11787	33	0	\N
184456	1397	1295795714000	24144	11787	34	0	\N
184457	1402	77260256719737	24144	11787	35	0	\N
184458	1402	76028047054345	24144	11787	36	0	\N
184459	1402	75773822405665	24144	11787	37	0	\N
184460	1397	1295785713000	24144	11787	38	0	\N
184461	1397	1295775712000	24144	11787	39	0	\N
184462	1397	1295765711000	24144	11787	40	0	\N
184463	1397	1295755710000	24144	11787	41	0	\N
184464	1397	1295745709000	24144	11787	42	0	\N
184465	1397	1295735708000	24144	11787	43	0	\N
184466	1397	1295725707000	24144	11787	44	0	\N
184467	1397	1295715706000	24144	11787	45	0	\N
184468	1397	1295705705000	24144	11787	46	0	\N
184469	1397	1295695704000	24144	11787	47	0	\N
184470	1397	1295685703000	24144	11787	48	0	\N
184471	1397	1295675702000	24144	11787	49	0	\N
184472	1397	1295665701000	24144	11787	50	0	\N
184473	1402	72977453710178	24144	11787	51	0	\N
184474	1402	72622921331459	24144	11787	52	0	\N
184475	1402	71961953778122	24144	11787	53	0	\N
184476	1402	67068336075906	24144	11787	54	0	\N
184477	1402	57588669473867	24144	11787	55	0	\N
184478	1402	56543374804871	24144	11787	56	0	\N
184479	1402	55990448390061	24144	11787	57	0	\N
184480	1402	54596267912048	24144	11787	58	0	\N
184481	1402	52670583501773	24144	11787	59	0	\N
184482	1402	50980047451847	24144	11787	60	0	\N
184483	1402	40684352483440	24144	11787	61	0	\N
184484	1402	39583299053908	24144	11787	62	0	\N
184485	1402	29287604085501	24144	11787	63	0	\N
184486	1402	28385132810740	24144	11787	64	0	\N
184487	1402	27813140312672	24144	11787	65	0	\N
184488	1402	25334539487553	24144	11787	66	0	\N
184489	1402	24953207822176	24144	11787	67	0	\N
184490	1402	23815108992857	24144	11787	68	0	\N
184491	1402	22859734421307	24144	11787	69	0	\N
184492	1402	20762455261602	24144	11787	70	0	\N
184493	1402	20485788766968	24144	11787	71	0	\N
184494	1402	20320864773160	24144	11787	72	0	\N
184495	1402	19825136608176	24144	11787	73	0	\N
184496	1402	18042447822424	24144	11787	74	0	\N
184497	1402	17644018757638	24144	11787	75	0	\N
184498	1402	17639752143739	24144	11787	76	0	\N
184499	1402	16742719145435	24144	11787	77	0	\N
184500	1397	1295655700000	24144	11787	78	0	\N
184501	1397	1295645699000	24144	11787	79	0	\N
184502	1397	1295635698000	24144	11787	80	0	\N
184503	1397	1295625697000	24144	11787	81	0	\N
184504	1397	1295615696000	24144	11787	82	0	\N
184505	1397	1295605695000	24144	11787	83	0	\N
184506	1397	1295595694000	24144	11787	84	0	\N
184507	1397	1295585693000	24144	11787	85	0	\N
184508	1397	1295575692000	24144	11787	86	0	\N
184509	1397	1295565691000	24144	11787	87	0	\N
184510	1397	1295555690000	24144	11787	88	0	\N
184511	1397	1295545689000	24144	11787	89	0	\N
184512	1397	1295535688000	24144	11787	90	0	\N
184513	1397	1295525687000	24144	11787	91	0	\N
184514	1397	1295515686000	24144	11787	92	0	\N
184515	1397	1295505685000	24144	11787	93	0	\N
184516	1397	1295495684000	24144	11787	94	0	\N
184517	1397	1295485683000	24144	11787	95	0	\N
184518	1397	1295475682000	24144	11787	96	0	\N
184519	1397	1295465681000	24144	11787	97	0	\N
184520	1397	1295455680000	24144	11787	98	0	\N
184521	1397	1295445679000	24144	11787	99	0	\N
184522	1397	1295435678000	24144	11787	100	0	\N
184523	1397	1295425677000	24144	11787	101	0	\N
184524	1397	1295415676000	24144	11787	102	0	\N
184525	1397	1295405675000	24144	11787	103	0	\N
184526	1397	1295395674000	24144	11787	104	0	\N
184527	1397	1295385673000	24144	11787	106	0	\N
184528	1397	1295375672000	24144	11787	107	0	\N
184529	1397	1295365671000	24144	11787	108	0	\N
184530	1397	1294825617000	24145	12019	0	0	\N
184531	2134	85728483000	24145	12019	1	0	\N
184534	1397	1295455680000	24148	11896	0	0	\N
184535	1397	1295445679000	24148	11896	1	0	\N
184536	1397	1295435678000	24148	11896	2	0	\N
184537	1397	1295425677000	24148	11896	3	0	\N
184538	1397	1295415676000	24148	11896	4	0	\N
184539	1397	1295405675000	24148	11896	5	0	\N
184540	1397	1295395674000	24148	11896	6	0	\N
184541	1397	1295385673000	24148	11896	7	0	\N
184542	1397	1295375672000	24148	11896	8	0	\N
184543	1397	1295365671000	24148	11896	9	0	\N
184544	1397	1295355670000	24148	11896	10	0	\N
184545	1397	1295345669000	24148	11896	11	0	\N
184546	1397	1295335668000	24148	11896	12	0	\N
184547	1397	1295325667000	24148	11896	13	0	\N
184548	1397	1295315666000	24148	11896	14	0	\N
184549	1397	1295305665000	24148	11896	15	0	\N
184550	1397	1295295664000	24148	11896	16	0	\N
184551	1397	1295285663000	24148	11896	17	0	\N
184552	1397	1295275662000	24148	11896	18	0	\N
184533	2134	85728483000	24147	12019	1	0	4847
184553	1397	1295265661000	24148	11896	19	0	\N
184554	1397	1295255660000	24148	11896	20	0	\N
184555	1397	1295245659000	24148	11896	21	0	\N
184556	1397	1295235658000	24148	11896	22	0	\N
184557	1397	1295225657000	24148	11896	23	0	\N
184558	1397	1295215656000	24148	11896	24	0	\N
184559	1397	1295205655000	24148	11896	25	0	\N
184560	1397	1295195654000	24148	11896	26	0	\N
184561	1397	1295185653000	24148	11896	27	0	\N
184562	1397	1295175652000	24148	11896	28	0	\N
184563	1397	1295165651000	24148	11896	29	0	\N
184564	1397	1295155650000	24148	11896	30	0	\N
184565	1397	1295145649000	24148	11896	31	0	\N
184566	1397	1295135648000	24148	11896	32	0	\N
184567	1397	1295125647000	24148	11896	33	0	\N
184568	1397	1295115646000	24148	11896	34	0	\N
184569	1397	1295105645000	24148	11896	35	0	\N
184570	1397	1295095644000	24148	11896	36	0	\N
184571	1397	1295085643000	24148	11896	37	0	\N
184572	1397	1295075642000	24148	11896	38	0	\N
184573	1397	1295065641000	24148	11896	39	0	\N
184574	1397	1295055640000	24148	11896	40	0	\N
184575	1397	1295045639000	24148	11896	41	0	\N
184576	1397	1295035638000	24148	11896	42	0	\N
184577	1397	1295025637000	24148	11896	43	0	\N
184578	1397	1295015636000	24148	11896	44	0	\N
184579	1397	1295005635000	24148	11896	45	0	\N
184580	1397	1294995634000	24148	11896	46	0	\N
184581	1397	1294985633000	24148	11896	47	0	\N
184582	1397	1294975632000	24148	11896	48	0	\N
184583	1397	1294965631000	24148	11896	49	0	\N
184584	1397	1294955630000	24148	11896	50	0	\N
184585	1397	1294945629000	24148	11896	51	0	\N
184586	1397	1294815616000	24150	12020	0	0	\N
184593	1397	1294805615000	24153	12021	0	0	\N
184594	1397	1294795614000	24153	12021	1	0	\N
184595	2134	85727480000	24153	12021	2	0	\N
184596	2134	85726477000	24153	12021	3	0	\N
184597	2132	147684686000	24153	12021	4	0	\N
184608	1397	1294755610000	24157	12024	0	0	\N
184609	2132	147672685000	24157	12024	1	0	\N
184610	2134	85722465000	24157	12024	2	0	\N
184611	1397	1294755610000	24158	12024	0	0	\N
184612	2132	147672685000	24158	12024	1	0	\N
184613	2134	85722465000	24158	12024	2	0	\N
184614	1397	1294745609000	24159	12025	0	0	\N
184615	2134	85721462000	24159	12025	1	0	\N
184616	1397	1294745609000	24160	12025	0	0	\N
184617	2134	85721462000	24160	12025	1	0	\N
184620	1397	1294735608000	24163	12027	0	0	\N
184621	1397	1294725607000	24163	12027	1	0	\N
184622	1397	1294715606000	24163	12027	2	0	\N
184623	1708	4680419500051	24163	12027	3	0	\N
184624	2134	85720459000	24163	12027	4	0	\N
184625	2134	85719456000	24163	12027	5	0	\N
184626	2134	85718453000	24163	12027	6	0	\N
184627	2132	147671684000	24163	12027	7	0	\N
184638	1397	1294705605000	24166	12028	0	0	\N
184639	2134	85717450000	24166	12028	1	0	\N
184646	1397	1294695604000	24168	12029	0	0	\N
184647	1397	1294685603000	24168	12029	1	0	\N
184648	2134	85716447000	24168	12029	2	0	\N
184649	2132	147670683000	24168	12029	3	0	\N
184650	1925	1192000000	24168	12029	4	0	\N
184651	2134	85715444000	24168	12029	5	0	\N
184652	1397	1294675602000	24169	12030	0	0	\N
184653	2134	85714441000	24169	12030	1	0	\N
184656	1397	1294665601000	24171	12031	0	0	\N
184657	1397	1294655600000	24171	12031	1	0	\N
184658	2132	147669682000	24171	12031	2	0	\N
184659	2134	85713438000	24171	12031	3	0	\N
184660	2134	85712435000	24171	12031	4	0	\N
184674	1397	1294615596000	24174	12033	0	0	\N
184675	2134	85708423000	24174	12033	1	0	\N
184676	1397	1294615596000	24175	12033	0	0	\N
184677	2134	85708423000	24175	12033	1	0	\N
184589	1397	1294795614000	24152	12021	1	0	14403
184590	2134	85727480000	24152	12021	2	0	4848
184591	2134	85726477000	24152	12021	3	0	4849
184592	2132	147684686000	24152	12021	4	0	1314
184598	1397	1294785613000	24154	12022	0	0	14404
184600	2132	147673686000	24154	12022	2	0	1315
184601	1397	1294775612000	24155	12023	0	0	14405
184602	1397	1294765611000	24155	12023	1	0	14406
184603	2134	85724471000	24155	12023	2	0	4851
184604	2134	85723468000	24155	12023	3	0	4852
184606	2132	147672685000	24156	12024	1	0	1316
184607	2134	85722465000	24156	12024	2	0	4853
184618	1397	1294745609000	24161	12025	0	0	14408
184619	2134	85721462000	24161	12025	1	0	4854
184629	1397	1294725607000	24164	12027	1	0	14410
184630	1397	1294715606000	24164	12027	2	0	14411
184631	1708	4680419500051	24164	12027	3	0	8
184632	2134	85720459000	24164	12027	4	0	4855
184633	2134	85719456000	24164	12027	5	0	4856
184635	2132	147671684000	24164	12027	7	0	1317
184636	1397	1294705605000	24165	12028	0	0	14412
184637	2134	85717450000	24165	12028	1	0	4858
184640	1397	1294695604000	24167	12029	0	0	14413
184641	1397	1294685603000	24167	12029	1	0	14414
184643	2132	147670683000	24167	12029	3	0	1318
184644	1925	1192000000	24167	12029	4	0	8
184645	2134	85715444000	24167	12029	5	0	4860
184654	1397	1294675602000	24170	12030	0	0	14415
184661	1397	1294665601000	24172	12031	0	0	14416
184662	1397	1294655600000	24172	12031	1	0	14417
184663	2132	147669682000	24172	12031	2	0	1319
184664	2134	85713438000	24172	12031	3	0	4862
184665	2134	85712435000	24172	12031	4	0	4863
184667	1397	1294635598000	24173	12032	1	0	14419
184668	1397	1294625597000	24173	12032	2	0	14420
184669	1924	1193000000	24173	12032	3	0	7
184670	2134	85711432000	24173	12032	4	0	4864
184671	2134	85710429000	24173	12032	5	0	4865
184673	2132	147668681000	24173	12032	7	0	1320
184678	1397	1294615596000	24176	12033	0	0	14421
184679	2134	85708423000	24176	12033	1	0	4867
184680	1397	1294605595000	24177	12034	0	0	14422
184682	1397	1294595594000	24178	12035	0	0	14423
184683	1397	1294585593000	24178	12035	1	0	14424
184684	1397	1294575592000	24178	12035	2	0	14425
184685	2132	147667680000	24178	12035	3	0	1321
184686	2134	85706417000	24178	12035	4	0	4869
184688	2134	85704411000	24178	12035	6	0	4871
184689	1397	1294565591000	24179	12036	0	0	\N
184692	1397	1294565591000	24181	12036	0	0	\N
184693	2134	85703408000	24181	12036	1	0	\N
184694	1397	1294555590000	24182	12037	0	0	\N
184695	2134	85702405000	24182	12037	1	0	\N
184696	2132	147666679000	24182	12037	2	0	\N
184707	1402	25019782421307	24187	11936	0	0	\N
184708	1402	22922503261602	24187	11936	1	0	\N
184709	1613	18250029400000	24187	11936	2	0	\N
184710	1402	22645836766968	24187	11936	3	0	\N
184711	1402	22480912773160	24187	11936	4	0	\N
184712	1402	21985184608176	24187	11936	5	0	\N
184713	1402	20202495822424	24187	11936	6	0	\N
184714	1402	19804066757638	24187	11936	7	0	\N
184715	1402	19799800143739	24187	11936	8	0	\N
184716	1402	18902767145435	24187	11936	9	0	\N
184717	1613	13531827200000	24187	11936	10	0	\N
184718	1613	10654529700000	24187	11936	11	0	\N
184719	1613	7777232200000	24187	11936	12	0	\N
184720	1708	4680419500051	24187	11936	13	0	\N
184721	367	66000011000000	24187	11936	14	0	\N
184722	1924	1193000000	24187	11936	15	0	\N
184723	2132	147684686000	24187	11936	16	0	\N
184724	1489	23664530490000	24187	11936	17	0	\N
184725	2132	147673686000	24187	11936	18	0	\N
184726	446	66000998900001	24187	11936	19	0	\N
184727	2132	147672685000	24187	11936	20	0	\N
184728	1489	23663825550000	24187	11936	21	0	\N
184729	1489	15983586030000	24187	11936	22	0	\N
184730	1489	13227441680000	24187	11936	23	0	\N
184731	1489	9142570430000	24187	11936	24	0	\N
184732	1489	6863055040000	24187	11936	25	0	\N
184733	1925	1192000000	24187	11936	26	0	\N
184734	2132	147671684000	24187	11936	27	0	\N
184735	2132	147670683000	24187	11936	28	0	\N
184736	2132	147669682000	24187	11936	29	0	\N
184737	2132	147668681000	24187	11936	30	0	\N
184738	2132	147667680000	24187	11936	31	0	\N
184739	2132	147666679000	24187	11936	32	0	\N
184740	2132	147665678000	24187	11936	33	0	\N
184741	1397	1294515586000	24189	12041	0	0	\N
184742	2134	85698393000	24189	12041	1	0	\N
184745	1397	1294515586000	24191	12041	0	0	\N
184746	2134	85698393000	24191	12041	1	0	\N
184747	1397	1294515586000	24192	12041	0	0	\N
184748	2134	85698393000	24192	12041	1	0	\N
184749	1397	1294515586000	24193	12041	0	0	\N
184750	2134	85698393000	24193	12041	1	0	\N
184751	1397	1294505585000	24194	12042	0	0	\N
184752	2134	85697390000	24194	12042	1	0	\N
184753	2133	92120882000	24194	12042	2	0	\N
184770	1397	1294455580000	24199	12046	0	0	\N
184771	2132	147663676000	24199	12046	1	0	\N
184772	2133	92115872000	24199	12046	2	0	\N
184773	2134	85692375000	24199	12046	3	0	\N
184778	1613	18250029400000	24201	11917	0	0	\N
184779	1402	20202495822424	24201	11917	1	0	\N
184780	1402	19804066757638	24201	11917	2	0	\N
184781	1402	19799800143739	24201	11917	3	0	\N
184782	1402	18902767145435	24201	11917	4	0	\N
184783	1613	13531827200000	24201	11917	5	0	\N
184784	1613	10654529700000	24201	11917	6	0	\N
184785	1613	7777232200000	24201	11917	7	0	\N
184786	1708	4680419500051	24201	11917	8	0	\N
184787	367	66000011000000	24201	11917	9	0	\N
184788	1924	1193000000	24201	11917	10	0	\N
184789	2132	147684686000	24201	11917	11	0	\N
184790	1489	23664530490000	24201	11917	12	0	\N
184791	2132	147673686000	24201	11917	13	0	\N
184792	446	66000998900001	24201	11917	14	0	\N
184793	2132	147672685000	24201	11917	15	0	\N
184794	1489	23663825550000	24201	11917	16	0	\N
184795	1489	15983586030000	24201	11917	17	0	\N
184796	1489	13227441680000	24201	11917	18	0	\N
184797	1489	9142570430000	24201	11917	19	0	\N
184798	1489	6863055040000	24201	11917	20	0	\N
184799	1925	1192000000	24201	11917	21	0	\N
184800	2132	147671684000	24201	11917	22	0	\N
184801	2132	147670683000	24201	11917	23	0	\N
184802	2132	147669682000	24201	11917	24	0	\N
184803	2132	147668681000	24201	11917	25	0	\N
184804	2132	147667680000	24201	11917	26	0	\N
184805	2132	147666679000	24201	11917	27	0	\N
184806	2132	147665678000	24201	11917	28	0	\N
184807	2132	147664677000	24201	11917	29	0	\N
184808	2132	147663676000	24201	11917	30	0	\N
184809	1397	1294445579000	24202	12047	0	0	\N
184810	2134	85691372000	24202	12047	1	0	\N
184811	2133	92114870000	24202	12047	2	0	\N
184815	1397	1294435578000	24204	12048	0	0	\N
184816	1397	1294425577000	24204	12048	1	0	\N
184817	2132	147662675000	24204	12048	2	0	\N
184818	2133	92113868000	24204	12048	3	0	\N
184819	2133	92112866000	24204	12048	4	0	\N
184820	2134	85690369000	24204	12048	5	0	\N
184821	1397	1294435578000	24205	12048	0	0	\N
184822	1397	1294425577000	24205	12048	1	0	\N
184823	2132	147662675000	24205	12048	2	0	\N
184824	2133	92113868000	24205	12048	3	0	\N
184697	1397	1294555590000	24183	12037	0	0	14427
184698	2134	85702405000	24183	12037	1	0	4873
184699	2132	147666679000	24183	12037	2	0	1322
184700	1397	1294545589000	24184	12038	0	0	14428
184701	2134	85701402000	24184	12038	1	0	4874
184703	2134	85700399000	24185	12039	1	0	4875
184704	1397	1294525587000	24186	12040	0	0	14430
184705	2134	85699396000	24186	12040	1	0	4876
184706	2132	147665678000	24186	12040	2	0	1323
184743	1397	1294515586000	24190	12041	0	0	14431
184754	1397	1294505585000	24195	12042	0	0	14432
184755	2134	85697390000	24195	12042	1	0	4878
184756	2133	92120882000	24195	12042	2	0	4561
184757	1397	1294495584000	24196	12043	0	0	14433
184759	2134	85696387000	24196	12043	2	0	4879
184760	2132	147664677000	24196	12043	3	0	1324
184761	1397	1294485583000	24197	12044	0	0	14434
184762	1397	1294475582000	24197	12044	1	0	14435
184763	2133	92118878000	24197	12044	2	0	4563
184765	2134	85695384000	24197	12044	4	0	4880
184766	2134	85694381000	24197	12044	5	0	4881
184767	1397	1294465581000	24198	12045	0	0	14436
184768	2133	92116874000	24198	12045	1	0	4565
184769	2134	85693378000	24198	12045	2	0	4882
184775	2132	147663676000	24200	12046	1	0	1325
184776	2133	92115872000	24200	12046	2	0	4566
184777	2134	85692375000	24200	12046	3	0	4883
184812	1397	1294445579000	24203	12047	0	0	14438
184814	2133	92114870000	24203	12047	2	0	4567
184825	2133	92112866000	24205	12048	4	0	\N
184826	2134	85690369000	24205	12048	5	0	\N
184827	1397	1294435578000	24206	12048	0	0	\N
184828	1397	1294425577000	24206	12048	1	0	\N
184829	2132	147662675000	24206	12048	2	0	\N
184830	2133	92113868000	24206	12048	3	0	\N
184831	2133	92112866000	24206	12048	4	0	\N
184832	2134	85690369000	24206	12048	5	0	\N
184842	1397	1294405575000	24209	12050	0	0	\N
184843	1397	1294395574000	24209	12050	1	0	\N
184844	2133	92110862000	24209	12050	2	0	\N
184845	2132	147661674000	24209	12050	3	0	\N
184846	2133	92109860000	24209	12050	4	0	\N
184847	2134	85688363000	24209	12050	5	0	\N
184848	2134	85687360000	24209	12050	6	0	\N
184856	1397	1294405575000	24212	12050	0	0	\N
184857	1397	1294395574000	24212	12050	1	0	\N
184858	2133	92110862000	24212	12050	2	0	\N
184859	2132	147661674000	24212	12050	3	0	\N
184860	2133	92109860000	24212	12050	4	0	\N
184861	2134	85688363000	24212	12050	5	0	\N
184862	2134	85687360000	24212	12050	6	0	\N
184866	1397	1294385573000	24214	12051	0	0	\N
184867	2133	92108858000	24214	12051	1	0	\N
184868	2134	85686357000	24214	12051	2	0	\N
184872	1397	1294375572000	24216	12052	0	0	\N
184873	2133	92107856000	24216	12052	1	0	\N
184874	2134	85685354000	24216	12052	2	0	\N
184875	1397	1294365571000	24217	12053	0	0	\N
184876	2134	85684351000	24217	12053	1	0	\N
184877	2133	92106854000	24217	12053	2	0	\N
184881	1397	1294355570000	24219	12054	0	0	\N
184882	2132	147660673000	24219	12054	1	0	\N
184883	2134	85683348000	24219	12054	2	0	\N
184884	2133	92105852000	24219	12054	3	0	\N
184888	1397	1294355570000	24221	12054	0	0	\N
184889	2132	147660673000	24221	12054	1	0	\N
184890	2134	85683348000	24221	12054	2	0	\N
184895	1397	1294335568000	24223	12056	0	0	\N
184896	2134	85681342000	24223	12056	1	0	\N
184897	2133	92103848000	24223	12056	2	0	\N
184901	1397	1294325567000	24225	12057	0	0	\N
184902	2132	147659672000	24225	12057	1	0	\N
184903	2134	85680339000	24225	12057	2	0	\N
184904	2133	92102846000	24225	12057	3	0	\N
184905	1397	1294325567000	24226	12057	0	0	\N
184906	2132	147659672000	24226	12057	1	0	\N
184907	2134	85680339000	24226	12057	2	0	\N
184908	2133	92102846000	24226	12057	3	0	\N
184909	1397	1294325567000	24227	12057	0	0	\N
184910	2132	147659672000	24227	12057	1	0	\N
184911	2134	85680339000	24227	12057	2	0	\N
184912	2133	92102846000	24227	12057	3	0	\N
184917	1397	1294325567000	24229	12057	0	0	\N
184918	2132	147659672000	24229	12057	1	0	\N
184919	2134	85680339000	24229	12057	2	0	\N
184920	2133	92102846000	24229	12057	3	0	\N
184921	1397	1294325567000	24230	12057	0	0	\N
184922	2132	147659672000	24230	12057	1	0	\N
184923	2134	85680339000	24230	12057	2	0	\N
184924	2133	92102846000	24230	12057	3	0	\N
184925	1397	1294315566000	24231	12058	0	0	\N
184926	2134	85679336000	24231	12058	1	0	\N
184927	2133	92101844000	24231	12058	2	0	\N
184934	1397	1294305565000	24234	12059	0	0	\N
184935	2134	85678333000	24234	12059	1	0	\N
184936	2133	92100842000	24234	12059	2	0	\N
184937	1397	1294295564000	24235	12060	0	0	\N
184938	2133	92099840000	24235	12060	1	0	\N
184939	2132	147658671000	24235	12060	2	0	\N
184940	2134	85677330000	24235	12060	3	0	\N
184950	1708	4680419500051	24239	11999	0	0	\N
184951	1924	1193000000	24239	11999	1	0	\N
184952	2132	147684686000	24239	11999	2	0	\N
184953	1489	23664530490000	24239	11999	3	0	\N
184954	2132	147673686000	24239	11999	4	0	\N
184955	2132	147672685000	24239	11999	5	0	\N
184956	1489	23663825550000	24239	11999	6	0	\N
184957	1489	15983586030000	24239	11999	7	0	\N
184958	1489	13227441680000	24239	11999	8	0	\N
184959	1489	9142570430000	24239	11999	9	0	\N
184960	1489	6863055040000	24239	11999	10	0	\N
184835	2132	147662675000	24207	12048	2	0	1326
184836	2133	92113868000	24207	12048	3	0	4568
184837	2133	92112866000	24207	12048	4	0	4569
184838	2134	85690369000	24207	12048	5	0	4885
184839	1397	1294415576000	24208	12049	0	0	14441
184841	2134	85689366000	24208	12049	2	0	4886
184849	1397	1294405575000	24211	12050	0	0	14442
184850	1397	1294395574000	24211	12050	1	0	14443
184851	2133	92110862000	24211	12050	2	0	4571
184852	2132	147661674000	24211	12050	3	0	1327
184854	2134	85688363000	24211	12050	5	0	4887
184855	2134	85687360000	24211	12050	6	0	4888
184863	1397	1294385573000	24213	12051	0	0	14444
184864	2133	92108858000	24213	12051	1	0	4573
184869	1397	1294375572000	24215	12052	0	0	14445
184870	2133	92107856000	24215	12052	1	0	4574
184871	2134	85685354000	24215	12052	2	0	4890
184878	1397	1294365571000	24218	12053	0	0	14446
184879	2134	85684351000	24218	12053	1	0	4891
184885	1397	1294355570000	24220	12054	0	0	14447
184886	2132	147660673000	24220	12054	1	0	1328
184887	2134	85683348000	24220	12054	2	0	4892
184891	1397	1294345569000	24222	12055	0	0	14448
184892	2134	85682345000	24222	12055	1	0	4893
184894	2133	92104850000	24222	12055	3	0	4577
184898	1397	1294335568000	24224	12056	0	0	14449
184899	2134	85681342000	24224	12056	1	0	4894
184900	2133	92103848000	24224	12056	2	0	4578
184914	2132	147659672000	24228	12057	1	0	1329
184915	2134	85680339000	24228	12057	2	0	4895
184916	2133	92102846000	24228	12057	3	0	4579
184928	1397	1294315566000	24232	12058	0	0	14451
184929	2134	85679336000	24232	12058	1	0	4896
184931	1397	1294305565000	24233	12059	0	0	14452
184932	2134	85678333000	24233	12059	1	0	4897
184933	2133	92100842000	24233	12059	2	0	4581
184941	1397	1294295564000	24236	12060	0	0	14453
184942	2133	92099840000	24236	12060	1	0	4582
184944	2134	85677330000	24236	12060	3	0	4898
184945	1397	1294285563000	24237	12061	0	0	14454
184946	2133	92098838000	24237	12061	1	0	4583
184947	1397	1294275562000	24238	12062	0	0	14455
184949	2133	92097836000	24238	12062	2	0	4584
184961	1925	1192000000	24239	11999	11	0	\N
184962	2133	92120882000	24239	11999	12	0	\N
184963	1397	1294265561000	24240	12063	0	0	\N
184964	2134	85675324000	24240	12063	1	0	\N
184965	2133	92096834000	24240	12063	2	0	\N
184966	1397	1294265561000	24241	12063	0	0	\N
184967	2134	85675324000	24241	12063	1	0	\N
184968	2133	92096834000	24241	12063	2	0	\N
184972	1397	1294265561000	24243	12063	0	0	\N
184973	2134	85675324000	24243	12063	1	0	\N
184974	2133	92096834000	24243	12063	2	0	\N
184979	2132	147662675000	24245	11918	0	0	\N
184980	2132	147661674000	24245	11918	1	0	\N
184981	2132	147660673000	24245	11918	2	0	\N
184982	2132	147659672000	24245	11918	3	0	\N
184983	2132	147658671000	24245	11918	4	0	\N
184984	2132	147657670000	24245	11918	5	0	\N
184985	1397	1294245559000	24246	12065	0	0	\N
184986	2134	85673318000	24246	12065	1	0	\N
184987	2133	92094830000	24246	12065	2	0	\N
185004	1397	1294235558000	24249	12066	0	0	\N
185005	1397	1294225557000	24249	12066	1	0	\N
185006	1397	1294215556000	24249	12066	2	0	\N
185007	1397	1294205555000	24249	12066	3	0	\N
185008	2134	85672315000	24249	12066	4	0	\N
185009	2134	85671312000	24249	12066	5	0	\N
185010	2133	92093828000	24249	12066	6	0	\N
185011	2132	147656669000	24249	12066	7	0	\N
185012	2134	85670309000	24249	12066	8	0	\N
185013	2134	85669306000	24249	12066	9	0	\N
185014	2133	92092826000	24249	12066	10	0	\N
185015	2133	92091824000	24249	12066	11	0	\N
185016	2133	92090822000	24249	12066	12	0	\N
185024	1397	1294195554000	24251	12067	0	0	\N
185025	1397	1294185553000	24251	12067	1	0	\N
185026	2133	92089820000	24251	12067	2	0	\N
185027	2133	92088818000	24251	12067	3	0	\N
185028	2132	147655668000	24251	12067	4	0	\N
185029	2134	85668303000	24251	12067	5	0	\N
185030	2134	85667300000	24251	12067	6	0	\N
185039	1397	1294175552000	24253	12068	0	0	\N
185040	1622	25332983250418	24253	12068	1	0	\N
185041	1622	22232833685186	24253	12068	2	0	\N
185042	1622	16677400146274	24253	12068	3	0	\N
185043	1622	12929035184936	24253	12068	4	0	\N
185044	1622	2483900800048	24253	12068	5	0	\N
185045	2134	85666297000	24253	12068	6	0	\N
185046	2133	92087816000	24253	12068	7	0	\N
185060	1397	1294165551000	24258	12070	0	0	\N
185061	1397	1294155550000	24258	12070	1	0	\N
185062	1397	1294145549000	24258	12070	2	0	\N
185063	1397	1294135548000	24258	12070	3	0	\N
185064	2132	147654667000	24258	12070	4	0	\N
185065	2134	85665294000	24258	12070	5	0	\N
185066	2133	92086814000	24258	12070	6	0	\N
185067	2133	92085812000	24258	12070	7	0	\N
185068	2133	92084810000	24258	12070	8	0	\N
185069	2134	85664291000	24258	12070	9	0	\N
185070	2134	85663288000	24258	12070	10	0	\N
185071	2134	85662285000	24258	12070	11	0	\N
185072	2133	92083808000	24258	12070	12	0	\N
185077	1397	1294125547000	24260	12071	0	0	\N
185078	2133	92082806000	24260	12071	1	0	\N
185079	2134	85661282000	24260	12071	2	0	\N
185080	2132	147653666000	24260	12071	3	0	\N
185084	1397	1294115546000	24262	12072	0	0	\N
185085	2134	85660279000	24262	12072	1	0	\N
185086	2133	92081804000	24262	12072	2	0	\N
185087	1397	1294115546000	24263	12072	0	0	\N
185088	2134	85660279000	24263	12072	1	0	\N
185089	2133	92081804000	24263	12072	2	0	\N
185090	558	66242190726895	24264	12045	0	0	\N
185091	1622	25332983250418	24264	12045	1	0	\N
185092	1622	22232833685186	24264	12045	2	0	\N
185093	1622	16677400146274	24264	12045	3	0	\N
185094	1622	12929035184936	24264	12045	4	0	\N
185095	1622	2483900800048	24264	12045	5	0	\N
185096	1419	19006054560130	24264	12045	6	0	\N
184971	2133	92096834000	24242	12063	2	0	4585
184975	1397	1294255560000	24244	12064	0	0	14457
184976	2132	147657670000	24244	12064	1	0	1331
184977	2134	85674321000	24244	12064	2	0	4901
184978	2133	92095832000	24244	12064	3	0	4586
184989	2134	85673318000	24247	12065	1	0	4902
184990	2133	92094830000	24247	12065	2	0	4587
184991	1397	1294235558000	24248	12066	0	0	14459
184992	1397	1294225557000	24248	12066	1	0	14460
184993	1397	1294215556000	24248	12066	2	0	14461
184995	2134	85672315000	24248	12066	4	0	4903
184996	2134	85671312000	24248	12066	5	0	4904
184997	2133	92093828000	24248	12066	6	0	4588
184998	2132	147656669000	24248	12066	7	0	1332
185000	2134	85669306000	24248	12066	9	0	4906
185001	2133	92092826000	24248	12066	10	0	4589
185002	2133	92091824000	24248	12066	11	0	4590
185003	2133	92090822000	24248	12066	12	0	4591
185017	1397	1294195554000	24250	12067	0	0	14463
185019	2133	92089820000	24250	12067	2	0	4592
185020	2133	92088818000	24250	12067	3	0	4593
185021	2132	147655668000	24250	12067	4	0	1333
185022	2134	85668303000	24250	12067	5	0	4907
185023	2134	85667300000	24250	12067	6	0	4908
185032	1622	25332983250418	24252	12068	1	0	6
185033	1622	22232833685186	24252	12068	2	0	7
185034	1622	16677400146274	24252	12068	3	0	8
185035	1622	12929035184936	24252	12068	4	0	9
185037	2134	85666297000	24252	12068	6	0	4909
185038	2133	92087816000	24252	12068	7	0	4594
185047	1397	1294165551000	24257	12070	0	0	14466
185048	1397	1294155550000	24257	12070	1	0	14467
185049	1397	1294145549000	24257	12070	2	0	14468
185051	2132	147654667000	24257	12070	4	0	1334
185052	2134	85665294000	24257	12070	5	0	4910
185053	2133	92086814000	24257	12070	6	0	4595
185054	2133	92085812000	24257	12070	7	0	4596
185055	2133	92084810000	24257	12070	8	0	4597
185057	2134	85663288000	24257	12070	10	0	4912
185058	2134	85662285000	24257	12070	11	0	4913
185059	2133	92083808000	24257	12070	12	0	4598
185073	1397	1294125547000	24259	12071	0	0	14470
185075	2134	85661282000	24259	12071	2	0	4914
185076	2132	147653666000	24259	12071	3	0	1335
185081	1397	1294115546000	24261	12072	0	0	14471
185082	2134	85660279000	24261	12072	1	0	4915
185083	2133	92081804000	24261	12072	2	0	4600
185112	558	66242190726895	24266	12073	0	0	\N
185113	1397	1294105545000	24266	12073	1	0	\N
185114	1397	1294095544000	24266	12073	2	0	\N
185115	1397	1294085543000	24266	12073	3	0	\N
185116	1397	1294075542000	24266	12073	4	0	\N
185117	1419	19006054560130	24266	12073	5	0	\N
185118	2133	92080802000	24266	12073	6	0	\N
185119	2133	92079800000	24266	12073	7	0	\N
185120	2134	85659276000	24266	12073	8	0	\N
185121	2134	85658273000	24266	12073	9	0	\N
185122	2134	85657270000	24266	12073	10	0	\N
185123	2133	92078798000	24266	12073	11	0	\N
185124	2133	92077796000	24266	12073	12	0	\N
185125	2132	147652665000	24266	12073	13	0	\N
185126	2134	85656267000	24266	12073	14	0	\N
185130	1397	1294055540000	24269	12075	0	0	\N
185131	2133	92075792000	24269	12075	1	0	\N
185132	2132	147651664000	24269	12075	2	0	\N
185133	2134	85654261000	24269	12075	3	0	\N
185138	1397	1294055540000	24271	12075	0	0	\N
185139	2133	92075792000	24271	12075	1	0	\N
185140	2132	147651664000	24271	12075	2	0	\N
185141	2134	85654261000	24271	12075	3	0	\N
185146	1397	1294045539000	24273	12076	0	0	\N
185147	2310	990000000	24273	12076	1	0	\N
185148	2134	85653258000	24273	12076	2	0	\N
185149	2133	92074790000	24273	12076	3	0	\N
185150	558	66241140726895	24274	12077	0	0	\N
185151	1397	1294035538000	24274	12077	1	0	\N
185152	2133	92073788000	24274	12077	2	0	\N
185153	2134	85652255000	24274	12077	3	0	\N
185158	1397	1294025537000	24276	12078	0	0	\N
185159	2134	85651252000	24276	12078	1	0	\N
185160	2133	92072786000	24276	12078	2	0	\N
185161	2132	147650663000	24276	12078	3	0	\N
185162	1397	1294025537000	24277	12078	0	0	\N
185163	2134	85651252000	24277	12078	1	0	\N
185164	2133	92072786000	24277	12078	2	0	\N
185165	2132	147650663000	24277	12078	3	0	\N
185166	1397	1294025537000	24278	12078	0	0	\N
185167	2134	85651252000	24278	12078	1	0	\N
185168	2133	92072786000	24278	12078	2	0	\N
185169	2132	147650663000	24278	12078	3	0	\N
185170	1397	1294025537000	24279	12078	0	0	\N
185171	2132	147650663000	24279	12078	1	0	\N
185179	1397	1294015536000	24284	12079	0	0	\N
185180	2133	92071784000	24284	12079	1	0	\N
185181	2134	85650249000	24284	12079	2	0	\N
185182	1397	1294005535000	24287	12080	0	0	\N
185183	2134	85649246000	24287	12080	1	0	\N
185184	2133	92070782000	24287	12080	2	0	\N
185188	1397	1293995534000	24289	12081	0	0	\N
185189	2134	85648243000	24289	12081	1	0	\N
185190	2132	147649662000	24289	12081	2	0	\N
185191	2133	92069780000	24289	12081	3	0	\N
185192	1397	1293995534000	24290	12081	0	0	\N
185193	2134	85648243000	24290	12081	1	0	\N
185194	2132	147649662000	24290	12081	2	0	\N
185195	2133	92069780000	24290	12081	3	0	\N
185200	1397	1293985533000	24292	12082	0	0	\N
185201	2133	92068778000	24292	12082	1	0	\N
185202	2134	85647240000	24292	12082	2	0	\N
185216	2132	147648661000	24295	12083	0	0	\N
185217	1397	1293975532000	24296	12083	0	0	\N
185218	1397	1293965531000	24296	12083	1	0	\N
185219	1397	1293955530000	24296	12083	2	0	\N
185220	2132	147648661000	24296	12083	3	0	\N
185221	2134	85646237000	24296	12083	4	0	\N
185222	2134	85645234000	24296	12083	5	0	\N
185223	2133	92067776000	24296	12083	6	0	\N
185224	2133	92066774000	24296	12083	7	0	\N
185225	2133	92065772000	24296	12083	8	0	\N
185226	2134	85644231000	24296	12083	9	0	\N
185227	558	66242190726895	24297	12053	0	0	\N
185228	558	66241140726895	24297	12053	1	0	\N
185229	1622	25332983250418	24297	12053	2	0	\N
185230	1622	22232833685186	24297	12053	3	0	\N
185231	1622	16677400146274	24297	12053	4	0	\N
185232	1622	12929035184936	24297	12053	5	0	\N
185099	1397	1294095544000	24265	12073	2	0	14473
185100	1397	1294085543000	24265	12073	3	0	14474
185101	1397	1294075542000	24265	12073	4	0	14475
185102	1419	19006054560130	24265	12073	5	0	8
185103	2133	92080802000	24265	12073	6	0	4601
185105	2134	85659276000	24265	12073	8	0	4916
185106	2134	85658273000	24265	12073	9	0	4917
185107	2134	85657270000	24265	12073	10	0	4918
185108	2133	92078798000	24265	12073	11	0	4603
185109	2133	92077796000	24265	12073	12	0	4604
185111	2134	85656267000	24265	12073	14	0	4919
185127	1397	1294065541000	24267	12074	0	0	14476
185128	2133	92076794000	24267	12074	1	0	4605
185129	2134	85655264000	24267	12074	2	0	4920
185135	2133	92075792000	24270	12075	1	0	4606
185136	2132	147651664000	24270	12075	2	0	1337
185137	2134	85654261000	24270	12075	3	0	4921
185142	1397	1294045539000	24272	12076	0	0	14478
185143	2310	990000000	24272	12076	1	0	1
185145	2133	92074790000	24272	12076	3	0	4607
185154	558	66241140726895	24275	12077	0	0	5
185155	1397	1294035538000	24275	12077	1	0	14479
185156	2133	92073788000	24275	12077	2	0	4608
185157	2134	85652255000	24275	12077	3	0	4923
185173	2134	85651252000	24280	12078	1	0	4924
185174	2133	92072786000	24280	12078	2	0	4609
185175	2132	147650663000	24280	12078	3	0	1338
185176	1397	1294015536000	24282	12079	0	0	14481
185178	2134	85650249000	24282	12079	2	0	4925
185185	1397	1294005535000	24288	12080	0	0	14482
185186	2134	85649246000	24288	12080	1	0	4926
185187	2133	92070782000	24288	12080	2	0	4611
185196	1397	1293995534000	24291	12081	0	0	14483
185198	2132	147649662000	24291	12081	2	0	1339
185199	2133	92069780000	24291	12081	3	0	4612
185203	1397	1293985533000	24293	12082	0	0	14484
185204	2133	92068778000	24293	12082	1	0	4613
185205	2134	85647240000	24293	12082	2	0	4928
185207	1397	1293965531000	24294	12083	1	0	14486
185208	1397	1293955530000	24294	12083	2	0	14487
185209	2132	147648661000	24294	12083	3	0	1340
185210	2134	85646237000	24294	12083	4	0	4929
185212	2133	92067776000	24294	12083	6	0	4614
185213	2133	92066774000	24294	12083	7	0	4615
185214	2133	92065772000	24294	12083	8	0	4616
185215	2134	85644231000	24294	12083	9	0	4931
185233	1622	2483900800048	24297	12053	6	0	\N
185234	1419	19006054560130	24297	12053	7	0	\N
185235	1397	1293945529000	24298	12084	0	0	\N
185236	1397	1293935528000	24298	12084	1	0	\N
185237	2133	92064770000	24298	12084	2	0	\N
185238	2134	85643228000	24298	12084	3	0	\N
185239	2134	85642225000	24298	12084	4	0	\N
185240	2133	92063768000	24298	12084	5	0	\N
185254	1397	1293915526000	24302	12086	0	0	\N
185255	2133	92061764000	24302	12086	1	0	\N
185256	2134	85640219000	24302	12086	2	0	\N
185257	1397	1293915526000	24303	12086	0	0	\N
185258	2133	92061764000	24303	12086	1	0	\N
185259	2134	85640219000	24303	12086	2	0	\N
185260	1397	1293915526000	24304	12086	0	0	\N
185261	2133	92061764000	24304	12086	1	0	\N
185262	2134	85640219000	24304	12086	2	0	\N
185263	1397	1293905525000	24305	12087	0	0	\N
185264	1397	1293895524000	24305	12087	1	0	\N
185265	2134	85639216000	24305	12087	2	0	\N
185266	2134	85638213000	24305	12087	4	0	\N
185267	2133	92060762000	24305	12087	5	0	\N
185268	2132	147646659000	24305	12087	6	0	\N
185269	2133	92059760000	24305	12087	7	0	\N
185270	1397	1293905525000	24306	12087	0	0	\N
185271	1397	1293895524000	24306	12087	1	0	\N
185272	2134	85639216000	24306	12087	2	0	\N
185273	2134	85638213000	24306	12087	4	0	\N
185274	2133	92060762000	24306	12087	5	0	\N
185275	2132	147646659000	24306	12087	6	0	\N
185276	2133	92059760000	24306	12087	7	0	\N
185284	1397	1293905525000	24308	12087	0	0	\N
185285	1397	1293895524000	24308	12087	1	0	\N
185286	2134	85639216000	24308	12087	2	0	\N
185287	2134	85638213000	24308	12087	4	0	\N
185288	2133	92060762000	24308	12087	5	0	\N
185289	2132	147646659000	24308	12087	6	0	\N
185290	2133	92059760000	24308	12087	7	0	\N
185297	1397	1293875522000	24311	12089	0	0	\N
185298	2133	92057756000	24311	12089	1	0	\N
185299	2134	85636207000	24311	12089	2	0	\N
185300	1397	1293865521000	24312	12090	0	0	\N
185301	1397	1293855520000	24312	12090	1	0	\N
185302	1397	1293845519000	24312	12090	2	0	\N
185303	2134	85635204000	24312	12090	3	0	\N
185304	2134	85634201000	24312	12090	4	0	\N
185305	2133	92056754000	24312	12090	5	0	\N
185306	2133	92055752000	24312	12090	6	0	\N
185307	2132	147645658000	24312	12090	7	0	\N
185308	2133	92054750000	24312	12090	8	0	\N
185318	1397	1293835518000	24314	12091	0	0	\N
185319	1397	1293825517000	24314	12091	1	0	\N
185320	2132	147644657000	24314	12091	2	0	\N
185321	2134	85633198000	24314	12091	3	0	\N
185322	2134	85632195000	24314	12091	4	0	\N
185323	2133	92053748000	24314	12091	5	0	\N
185324	2133	92052746000	24314	12091	6	0	\N
185348	1397	1293765511000	24319	12095	0	0	\N
185349	1397	1293755510000	24319	12095	1	0	\N
185350	1397	1293745509000	24319	12095	2	0	\N
185351	1397	1293735508000	24319	12095	3	0	\N
185352	2134	85626177000	24319	12095	4	0	\N
185353	2134	85625174000	24319	12095	5	0	\N
185354	2133	92046734000	24319	12095	6	0	\N
185355	2134	85624171000	24319	12095	7	0	\N
185356	2134	85623168000	24319	12095	8	0	\N
185357	2132	147642655000	24319	12095	9	0	\N
185358	2133	92045732000	24319	12095	10	0	\N
185359	2133	92044730000	24319	12095	11	0	\N
185360	2133	92043728000	24319	12095	12	0	\N
185243	2133	92064770000	24299	12084	2	0	4617
185244	2134	85643228000	24299	12084	3	0	4932
185245	2134	85642225000	24299	12084	4	0	4933
185246	2133	92063768000	24299	12084	5	0	4618
185247	1397	1293925527000	24300	12085	0	0	14490
185249	2134	85641222000	24300	12085	2	0	4934
185250	2132	147647660000	24300	12085	3	0	1341
185251	1397	1293915526000	24301	12086	0	0	14491
185252	2133	92061764000	24301	12086	1	0	4620
185253	2134	85640219000	24301	12086	2	0	4935
185278	1397	1293895524000	24307	12087	1	0	14493
185279	2134	85639216000	24307	12087	2	0	4936
185280	2134	85638213000	24307	12087	4	0	4937
185281	2133	92060762000	24307	12087	5	0	4621
185283	2133	92059760000	24307	12087	7	0	4622
185291	1397	1293885523000	24309	12088	0	0	14494
185292	2134	85637210000	24309	12088	1	0	4938
185293	2133	92058758000	24309	12088	2	0	4623
185294	1397	1293875522000	24310	12089	0	0	14495
185296	2134	85636207000	24310	12089	2	0	4939
185309	1397	1293865521000	24313	12090	0	0	14496
185310	1397	1293855520000	24313	12090	1	0	14497
185311	1397	1293845519000	24313	12090	2	0	14498
185312	2134	85635204000	24313	12090	3	0	4940
185314	2133	92056754000	24313	12090	5	0	4625
185315	2133	92055752000	24313	12090	6	0	4626
185316	2132	147645658000	24313	12090	7	0	1343
185317	2133	92054750000	24313	12090	8	0	4627
185326	1397	1293825517000	24315	12091	1	0	14500
185327	2132	147644657000	24315	12091	2	0	1344
185328	2134	85633198000	24315	12091	3	0	4942
185329	2134	85632195000	24315	12091	4	0	4943
185330	2133	92053748000	24315	12091	5	0	4628
185332	1397	1293815516000	24316	12092	0	0	14501
185333	2134	85631192000	24316	12092	1	0	4944
185334	2133	92051744000	24316	12092	2	0	4630
185335	1397	1293805515000	24317	12093	0	0	14502
185336	1397	1293795514000	24317	12093	1	0	14503
185338	2134	85630189000	24317	12093	3	0	4945
185339	2134	85629186000	24317	12093	4	0	4946
185340	2133	92050742000	24317	12093	5	0	4631
185341	2133	92049740000	24317	12093	6	0	4632
185343	1397	1293775512000	24318	12094	1	0	14505
185344	2133	92048738000	24318	12094	2	0	4633
185345	2134	85628183000	24318	12094	3	0	4947
185346	2134	85627180000	24318	12094	4	0	4948
185347	2133	92047736000	24318	12094	5	0	4634
185362	1397	1293755510000	24320	12095	1	0	14507
185363	1397	1293745509000	24320	12095	2	0	14508
185364	1397	1293735508000	24320	12095	3	0	14509
185365	2134	85626177000	24320	12095	4	0	4949
185366	2134	85625174000	24320	12095	5	0	4950
185368	2134	85624171000	24320	12095	7	0	4951
185385	1397	1293715506000	24323	12097	0	0	\N
185386	1397	1293705505000	24323	12097	1	0	\N
185387	2058	533500000	24323	12097	2	0	\N
185388	2133	92041724000	24323	12097	3	0	\N
185389	2133	92040722000	24323	12097	4	0	\N
185390	2134	85621162000	24323	12097	5	0	\N
185391	2134	85620159000	24323	12097	6	0	\N
185392	1397	1293715506000	24324	12097	0	0	\N
185393	1397	1293705505000	24324	12097	1	0	\N
185394	2058	533500000	24324	12097	2	0	\N
185395	2133	92041724000	24324	12097	3	0	\N
185396	2133	92040722000	24324	12097	4	0	\N
185407	1397	1293695504000	24327	12099	0	0	\N
185408	2134	85616147000	24327	12099	1	0	\N
185409	2133	92036714000	24327	12099	2	0	\N
185410	1397	1293695504000	24328	12099	0	0	\N
185411	2134	85616147000	24328	12099	1	0	\N
185412	2133	92036714000	24328	12099	2	0	\N
185413	1397	1293695504000	24329	12099	0	0	\N
185414	2134	85616147000	24329	12099	1	0	\N
185415	2133	92036714000	24329	12099	2	0	\N
185420	1506	5040080967172	24331	12101	0	0	\N
185421	1397	1293675502000	24331	12101	1	0	\N
185422	1397	1293665501000	24331	12101	2	0	\N
185423	1397	1293655500000	24331	12101	3	0	\N
185424	2134	85614141000	24331	12101	4	0	\N
185425	2134	85613138000	24331	12101	5	0	\N
185426	2132	147638651000	24331	12101	6	0	\N
185427	2133	92034710000	24331	12101	7	0	\N
185428	2133	92033708000	24331	12101	8	0	\N
185429	2133	92032706000	24331	12101	9	0	\N
185430	2134	85612135000	24331	12101	10	0	\N
185431	1506	5040080967172	24332	12101	0	0	\N
185432	1397	1293675502000	24332	12101	1	0	\N
185433	1397	1293665501000	24332	12101	2	0	\N
185434	1397	1293655500000	24332	12101	3	0	\N
185435	2134	85614141000	24332	12101	4	0	\N
185436	2134	85613138000	24332	12101	5	0	\N
185437	2132	147638651000	24332	12101	6	0	\N
185438	2133	92034710000	24332	12101	7	0	\N
185439	2133	92033708000	24332	12101	8	0	\N
185440	2133	92032706000	24332	12101	9	0	\N
185441	2134	85612135000	24332	12101	10	0	\N
185442	1506	5040080967172	24333	12101	0	0	\N
185443	1397	1293675502000	24333	12101	1	0	\N
185444	1397	1293665501000	24333	12101	2	0	\N
185445	1397	1293655500000	24333	12101	3	0	\N
185446	2134	85614141000	24333	12101	4	0	\N
185447	2134	85613138000	24333	12101	5	0	\N
185448	2132	147638651000	24333	12101	6	0	\N
185449	2133	92034710000	24333	12101	7	0	\N
185450	2133	92033708000	24333	12101	8	0	\N
185451	2133	92032706000	24333	12101	9	0	\N
185452	2134	85612135000	24333	12101	10	0	\N
185453	1506	5040080967172	24334	12101	0	0	\N
185454	1397	1293675502000	24334	12101	1	0	\N
185455	1397	1293665501000	24334	12101	2	0	\N
185456	1397	1293655500000	24334	12101	3	0	\N
185457	2134	85614141000	24334	12101	4	0	\N
185458	2134	85613138000	24334	12101	5	0	\N
185459	2132	147638651000	24334	12101	6	0	\N
185460	2133	92034710000	24334	12101	7	0	\N
185461	2133	92033708000	24334	12101	8	0	\N
185462	2133	92032706000	24334	12101	9	0	\N
185463	2134	85612135000	24334	12101	10	0	\N
185475	1397	1293645499000	24336	12102	0	0	\N
185476	2133	92031704000	24336	12102	1	0	\N
185477	2134	85611132000	24336	12102	2	0	\N
185481	1397	1293635498000	24338	12103	0	0	\N
185482	2133	92030702000	24338	12103	2	0	\N
185483	2134	85610129000	24338	12103	3	0	\N
185489	1397	1293615496000	24341	12105	0	0	\N
185490	2132	147637650000	24341	12105	1	0	\N
185491	2133	92029700000	24341	12105	2	0	\N
185498	1397	1293595494000	24344	12107	0	0	\N
185499	2134	85607120000	24344	12107	1	0	\N
185500	2133	92027696000	24344	12107	2	0	\N
185371	2133	92045732000	24320	12095	10	0	4636
185372	2133	92044730000	24320	12095	11	0	4637
185373	2133	92043728000	24320	12095	12	0	4638
185374	1397	1293725507000	24321	12096	0	0	14510
185375	2132	147641654000	24321	12096	1	0	1347
185377	2134	85622165000	24321	12096	3	0	4953
185378	1397	1293715506000	24322	12097	0	0	14511
185379	1397	1293705505000	24322	12097	1	0	14512
185380	2058	533500000	24322	12097	2	0	10
185381	2133	92041724000	24322	12097	3	0	4640
185383	2134	85621162000	24322	12097	5	0	4954
185384	2134	85620159000	24322	12097	6	0	4955
185397	2134	85619156000	24325	12098	0	0	4956
185398	2134	85618153000	24325	12098	1	0	4957
185400	2132	147640653000	24325	12098	3	0	1348
185401	2133	92039720000	24325	12098	4	0	4642
185402	2133	92038718000	24325	12098	5	0	4643
185403	2133	92037716000	24325	12098	6	0	4644
185404	1397	1293695504000	24326	12099	0	0	14513
185406	2133	92036714000	24326	12099	2	0	4645
185416	1397	1293685503000	24330	12100	0	0	14514
185417	2134	85615144000	24330	12100	1	0	4960
185418	2132	147639652000	24330	12100	2	0	1349
185419	2133	92035712000	24330	12100	3	0	4646
185465	1397	1293675502000	24335	12101	1	0	14515
185466	1397	1293665501000	24335	12101	2	0	14516
185467	1397	1293655500000	24335	12101	3	0	14517
185468	2134	85614141000	24335	12101	4	0	4961
185470	2132	147638651000	24335	12101	6	0	1350
185471	2133	92034710000	24335	12101	7	0	4647
185472	2133	92033708000	24335	12101	8	0	4648
185473	2133	92032706000	24335	12101	9	0	4649
185474	2134	85612135000	24335	12101	10	0	4963
185479	2133	92031704000	24337	12102	1	0	4650
185480	2134	85611132000	24337	12102	2	0	4964
185484	1397	1293635498000	24339	12103	0	0	14519
185485	2133	92030702000	24339	12103	2	0	4651
185486	2134	85610129000	24339	12103	3	0	4965
185488	2134	85609126000	24340	12104	1	0	4966
185492	1397	1293615496000	24342	12105	0	0	14521
185493	2132	147637650000	24342	12105	1	0	1351
185494	2133	92029700000	24342	12105	2	0	4652
185496	2134	85608123000	24343	12106	1	0	4967
185497	2133	92028698000	24343	12106	2	0	4653
185501	1397	1293595494000	24345	12107	0	0	14523
185502	2134	85607120000	24345	12107	1	0	4968
185503	2133	92027696000	24345	12107	2	0	4654
185514	1397	1293565491000	24348	12109	0	0	\N
185515	2134	85604111000	24348	12109	1	0	\N
185516	2133	92024690000	24348	12109	2	0	\N
185517	1397	1293555490000	24349	12110	0	0	\N
185518	1397	1293545489000	24349	12110	1	0	\N
185519	2132	147635648000	24349	12110	2	0	\N
185520	2134	85603108000	24349	12110	3	0	\N
185521	2133	92023688000	24349	12110	4	0	\N
185522	2134	85602105000	24349	12110	5	0	\N
185529	1397	1293535488000	24351	12111	0	0	\N
185530	2134	85601102000	24351	12111	1	0	\N
185531	1397	1293535488000	24352	12111	0	0	\N
185532	2134	85601102000	24352	12111	1	0	\N
185535	1397	1293535488000	24354	12111	0	0	\N
185536	2134	85601102000	24354	12111	1	0	\N
185542	1397	1293515486000	24357	12113	0	0	\N
185543	2132	147634647000	24357	12113	1	0	\N
185544	2134	85599096000	24357	12113	2	0	\N
185545	1397	1293505485000	24358	12114	0	0	\N
185546	2134	85598093000	24358	12114	1	0	\N
185547	1397	1293505485000	24359	12114	0	0	\N
185548	2134	85598093000	24359	12114	1	0	\N
185551	1397	1293495484000	24361	12115	0	0	\N
185552	2134	85597090000	24361	12115	1	0	\N
185558	1397	1293485483000	24364	12116	0	0	\N
185559	2134	85596087000	24364	12116	1	0	\N
185560	2132	147633646000	24364	12116	2	0	\N
185572	1397	1293435478000	24367	12119	0	0	\N
185573	2134	85591072000	24367	12119	1	0	\N
185584	1451	4958837000000	24370	12120	0	0	\N
185585	1397	1293425477000	24370	12120	1	0	\N
185586	1397	1293415476000	24370	12120	2	0	\N
185587	1397	1293405475000	24370	12120	3	0	\N
185588	2134	85590069000	24370	12120	4	0	\N
185589	2134	85589066000	24370	12120	5	0	\N
185590	2134	85588063000	24370	12120	6	0	\N
185591	2132	147631644000	24370	12120	7	0	\N
185597	1451	2587737000000	24375	12123	0	0	\N
185598	1397	1293375472000	24375	12123	1	0	\N
185599	2134	85585054000	24375	12123	2	0	\N
185600	1451	2587737000000	24376	12123	0	0	\N
185601	1397	1293375472000	24376	12123	1	0	\N
185602	2134	85585054000	24376	12123	2	0	\N
185606	1451	12073037000000	24378	12116	0	0	\N
185607	1451	7824937000000	24378	12116	1	0	\N
185608	1451	4958837000000	24378	12116	2	0	\N
185609	1397	1293485483000	24378	12116	3	0	\N
185610	1397	1293475482000	24378	12116	4	0	\N
185611	1397	1293465481000	24378	12116	5	0	\N
185612	1397	1293455480000	24378	12116	6	0	\N
185613	1397	1293445479000	24378	12116	7	0	\N
185614	1397	1293435478000	24378	12116	8	0	\N
185615	1397	1293425477000	24378	12116	9	0	\N
185616	1397	1293415476000	24378	12116	10	0	\N
185617	1397	1293405475000	24378	12116	11	0	\N
185618	1397	1293395474000	24378	12116	12	0	\N
185619	1397	1293385473000	24378	12116	13	0	\N
185620	1397	1293375472000	24378	12116	14	0	\N
185621	2134	85596087000	24378	12116	15	0	\N
185622	2132	147633646000	24378	12116	16	0	\N
185623	2134	85595084000	24378	12116	17	0	\N
185624	2134	85594081000	24378	12116	18	0	\N
185625	2134	85593078000	24378	12116	19	0	\N
185626	2134	85592075000	24378	12116	20	0	\N
185627	2134	85591072000	24378	12116	21	0	\N
185628	2134	85590069000	24378	12116	22	0	\N
185629	2134	85589066000	24378	12116	23	0	\N
185630	2132	147632645000	24378	12116	24	0	\N
185631	2134	85588063000	24378	12116	25	0	\N
185632	2134	85587060000	24378	12116	26	0	\N
185633	2134	85586057000	24378	12116	27	0	\N
185634	2132	147631644000	24378	12116	28	0	\N
185635	2132	147630643000	24378	12116	29	0	\N
185637	1397	1293365471000	24380	12124	0	0	\N
185507	2133	92025692000	24346	12108	3	0	4656
185508	2134	85606117000	24346	12108	4	0	4969
185509	2132	147636649000	24346	12108	5	0	1352
185510	2134	85605114000	24346	12108	6	0	4970
185511	1397	1293565491000	24347	12109	0	0	14526
185513	2133	92024690000	24347	12109	2	0	4657
185523	1397	1293555490000	24350	12110	0	0	14527
185524	1397	1293545489000	24350	12110	1	0	14528
185525	2132	147635648000	24350	12110	2	0	1353
185526	2134	85603108000	24350	12110	3	0	4972
185528	2134	85602105000	24350	12110	5	0	4973
185533	1397	1293535488000	24353	12111	0	0	14529
185534	2134	85601102000	24353	12111	1	0	4974
185537	1397	1293525487000	24355	12112	0	0	14530
185539	1397	1293515486000	24356	12113	0	0	14531
185540	2132	147634647000	24356	12113	1	0	1354
185541	2134	85599096000	24356	12113	2	0	4976
185549	1397	1293505485000	24360	12114	0	0	14532
185550	2134	85598093000	24360	12114	1	0	4977
185554	2134	85597090000	24362	12115	1	0	4978
185555	1397	1293485483000	24363	12116	0	0	14534
185556	2134	85596087000	24363	12116	1	0	4979
185557	2132	147633646000	24363	12116	2	0	1355
185561	1451	12073037000000	24365	12117	0	0	10
185563	1397	1293465481000	24365	12117	2	0	14536
185564	2134	85595084000	24365	12117	3	0	4980
185565	2134	85594081000	24365	12117	4	0	4981
185566	1451	7824937000000	24366	12118	0	0	11
185568	1397	1293445479000	24366	12118	2	0	14538
185569	2134	85593078000	24366	12118	3	0	4982
185570	2134	85592075000	24366	12118	4	0	4983
185571	2132	147632645000	24366	12118	5	0	1356
185574	1397	1293435478000	24368	12119	0	0	14539
185576	1451	4958837000000	24369	12120	0	0	12
185577	1397	1293425477000	24369	12120	1	0	14540
185578	1397	1293415476000	24369	12120	2	0	14541
185579	1397	1293405475000	24369	12120	3	0	14542
185580	2134	85590069000	24369	12120	4	0	4985
185582	2134	85588063000	24369	12120	6	0	4987
185583	2132	147631644000	24369	12120	7	0	1357
185592	1397	1293395474000	24372	12121	0	0	14543
185593	2134	85587060000	24372	12121	1	0	4988
185595	2134	85586057000	24374	12122	1	0	4989
185596	2132	147630643000	24374	12122	2	0	1358
185603	1451	2587737000000	24377	12123	0	0	13
185604	1397	1293375472000	24377	12123	1	0	14545
185605	2134	85585054000	24377	12123	2	0	4990
185638	1397	1293355470000	24381	12125	0	0	14547
185639	2132	147629642000	24381	12125	1	0	1359
185640	2134	85584051000	24381	12125	2	0	4991
185652	1397	1293325467000	24385	12127	0	0	\N
185653	1397	1293315466000	24385	12127	1	0	\N
185654	1397	1293305465000	24385	12127	2	0	\N
185655	2132	147628641000	24385	12127	3	0	\N
185656	2134	85581042000	24385	12127	4	0	\N
185657	2134	85580039000	24385	12127	5	0	\N
185658	2134	85579036000	24385	12127	6	0	\N
185659	1397	1293325467000	24386	12127	0	0	\N
185660	1397	1293315466000	24386	12127	1	0	\N
185661	1397	1293305465000	24386	12127	2	0	\N
185662	2132	147628641000	24386	12127	3	0	\N
185663	2134	85581042000	24386	12127	4	0	\N
185664	2134	85580039000	24386	12127	5	0	\N
185665	2134	85579036000	24386	12127	6	0	\N
185666	1397	1293295464000	24387	12128	0	0	\N
185667	2134	85578033000	24387	12128	1	0	\N
185668	1397	1293295464000	24388	12128	0	0	\N
185669	2134	85578033000	24388	12128	1	0	\N
185672	1397	1293295464000	24390	12128	0	0	\N
185673	2134	85578033000	24390	12128	1	0	\N
185677	1397	1293295464000	24392	12128	0	0	\N
185678	1397	1293285463000	24392	12128	1	0	\N
185679	2132	147627640000	24392	12128	2	0	\N
185680	2134	85578033000	24392	12128	3	0	\N
185681	2134	85577030000	24392	12128	4	0	\N
185682	1397	1293285463000	24393	12129	0	0	\N
185683	2134	85577030000	24393	12129	1	0	\N
185684	2132	147627640000	24393	12129	2	0	\N
185685	1397	1293275462000	24394	12130	0	0	\N
185686	2134	85576027000	24394	12130	1	0	\N
185689	1451	12073037000000	24396	12113	0	0	\N
185690	1451	7824937000000	24396	12113	1	0	\N
185691	1451	4958837000000	24396	12113	2	0	\N
185692	1451	2587737000000	24396	12113	3	0	\N
185693	1397	1293515486000	24396	12113	4	0	\N
185694	1397	1293505485000	24396	12113	5	0	\N
185695	1397	1293495484000	24396	12113	6	0	\N
185696	1397	1293485483000	24396	12113	7	0	\N
185697	1397	1293475482000	24396	12113	8	0	\N
185698	1397	1293465481000	24396	12113	9	0	\N
185699	1397	1293455480000	24396	12113	10	0	\N
185700	1397	1293445479000	24396	12113	11	0	\N
185701	1397	1293435478000	24396	12113	12	0	\N
185702	1397	1293425477000	24396	12113	13	0	\N
185703	1397	1293415476000	24396	12113	14	0	\N
185704	1397	1293405475000	24396	12113	15	0	\N
185705	1397	1293395474000	24396	12113	16	0	\N
185706	1397	1293385473000	24396	12113	17	0	\N
185707	1397	1293375472000	24396	12113	18	0	\N
185708	1397	1293365471000	24396	12113	19	0	\N
185709	1397	1293355470000	24396	12113	20	0	\N
185710	1397	1293345469000	24396	12113	21	0	\N
185711	1397	1293335468000	24396	12113	22	0	\N
185712	1397	1293325467000	24396	12113	23	0	\N
185713	1397	1293315466000	24396	12113	24	0	\N
185714	1397	1293305465000	24396	12113	25	0	\N
185715	1397	1293295464000	24396	12113	26	0	\N
185716	1397	1293285463000	24396	12113	27	0	\N
185717	1397	1293275462000	24396	12113	28	0	\N
185718	2132	147634647000	24396	12113	29	0	\N
185719	2134	85599096000	24396	12113	30	0	\N
185720	2134	85598093000	24396	12113	31	0	\N
185721	2134	85597090000	24396	12113	32	0	\N
185722	2134	85596087000	24396	12113	33	0	\N
185723	2132	147633646000	24396	12113	34	0	\N
185724	2134	85595084000	24396	12113	35	0	\N
185725	2134	85594081000	24396	12113	36	0	\N
185726	2134	85593078000	24396	12113	37	0	\N
185727	2134	85592075000	24396	12113	38	0	\N
185728	2134	85591072000	24396	12113	39	0	\N
185729	2134	85590069000	24396	12113	40	0	\N
185730	2134	85589066000	24396	12113	41	0	\N
185731	2132	147632645000	24396	12113	42	0	\N
185732	2134	85588063000	24396	12113	43	0	\N
185733	2134	85587060000	24396	12113	44	0	\N
185734	2134	85586057000	24396	12113	45	0	\N
185735	2134	85585054000	24396	12113	46	0	\N
185736	2132	147631644000	24396	12113	47	0	\N
185737	2132	147630643000	24396	12113	48	0	\N
185738	2132	147629642000	24396	12113	49	0	\N
185739	2132	147628641000	24396	12113	50	0	\N
185740	2132	147627640000	24396	12113	51	0	\N
185741	2134	85584051000	24396	12113	52	0	\N
185742	2134	85583048000	24396	12113	53	0	\N
185743	2134	85582045000	24396	12113	54	0	\N
185744	2134	85581042000	24396	12113	55	0	\N
185745	2134	85580039000	24396	12113	56	0	\N
185746	2134	85579036000	24396	12113	57	0	\N
185747	2134	85578033000	24396	12113	58	0	\N
185748	2134	85577030000	24396	12113	59	0	\N
185749	2134	85576027000	24396	12113	60	0	\N
185750	1397	1293265461000	24397	12131	0	0	\N
185751	2134	85575024000	24397	12131	1	0	\N
185754	1397	1293255460000	24399	12132	0	0	\N
185755	2134	85574021000	24399	12132	1	0	\N
185756	2132	147626639000	24399	12132	2	0	\N
185768	1397	1293215456000	24404	12135	0	0	\N
185769	2134	85571012000	24404	12135	1	0	\N
185770	2132	147625638000	24404	12135	2	0	\N
185773	1397	1293205455000	24406	12136	0	0	\N
185774	2134	85570009000	24406	12136	1	0	\N
185643	2134	85583048000	24382	12126	2	0	4992
185644	2134	85582045000	24382	12126	3	0	4993
185645	1397	1293325467000	24384	12127	0	0	14550
185646	1397	1293315466000	24384	12127	1	0	14551
185647	1397	1293305465000	24384	12127	2	0	14552
185649	2134	85581042000	24384	12127	4	0	4994
185650	2134	85580039000	24384	12127	5	0	4995
185651	2134	85579036000	24384	12127	6	0	4996
185670	1397	1293295464000	24389	12128	0	0	14553
185671	2134	85578033000	24389	12128	1	0	4997
185675	2134	85577030000	24391	12129	1	0	4998
185676	2132	147627640000	24391	12129	2	0	1361
185687	1397	1293275462000	24395	12130	0	0	14555
185688	2134	85576027000	24395	12130	1	0	4999
185753	2134	85575024000	24398	12131	1	0	5000
185757	1397	1293255460000	24400	12132	0	0	14557
185758	2134	85574021000	24400	12132	1	0	5001
185759	2132	147626639000	24400	12132	2	0	1362
185760	1397	1293245459000	24401	12133	0	0	14558
185762	2134	85573018000	24401	12133	2	0	5002
185763	1397	1293225457000	24402	12134	0	0	14560
185764	2134	85572015000	24402	12134	1	0	5003
185765	1397	1293215456000	24403	12135	0	0	14561
185766	2134	85571012000	24403	12135	1	0	5004
185771	1397	1293205455000	24405	12136	0	0	14562
185772	2134	85570009000	24405	12136	1	0	5005
185775	1397	1293195454000	24407	12137	0	0	14563
185776	2134	85569006000	24407	12137	1	0	5006
185785	1397	1293175452000	24410	12139	0	0	\N
185786	2134	85567000000	24410	12139	1	0	\N
185797	1397	1293135448000	24415	12143	0	0	\N
185798	2134	85562988000	24415	12143	1	0	\N
185799	1397	1293135448000	24416	12143	0	0	\N
185800	2134	85562988000	24416	12143	1	0	\N
185810	1397	1293095444000	24419	12145	0	0	\N
185811	2134	85558976000	24419	12145	1	0	\N
185812	1397	1293265461000	24420	12114	0	0	\N
185813	1397	1293255460000	24420	12114	1	0	\N
185814	1397	1293245459000	24420	12114	2	0	\N
185815	1397	1293235458000	24420	12114	3	0	\N
185816	1397	1293225457000	24420	12114	4	0	\N
185817	1397	1293215456000	24420	12114	5	0	\N
185818	1397	1293205455000	24420	12114	6	0	\N
185819	1397	1293195454000	24420	12114	7	0	\N
185820	1397	1293185453000	24420	12114	8	0	\N
185821	1397	1293175452000	24420	12114	9	0	\N
185822	1397	1293165451000	24420	12114	10	0	\N
185823	1397	1293155450000	24420	12114	12	0	\N
185824	1397	1293145449000	24420	12114	13	0	\N
185825	1397	1293135448000	24420	12114	14	0	\N
185826	1397	1293125447000	24420	12114	15	0	\N
185827	1397	1293115446000	24420	12114	16	0	\N
185828	1397	1293105445000	24420	12114	17	0	\N
185829	1397	1293095444000	24420	12114	18	0	\N
185830	1397	1293085443000	24420	12114	19	0	\N
185831	1611	8663559824916	24420	12114	20	0	\N
185832	1611	7172315202966	24420	12114	21	0	\N
185833	1611	6166142403568	24420	12114	22	0	\N
185834	1611	3362354241757	24420	12114	23	0	\N
185835	2134	85575024000	24420	12114	24	0	\N
185836	2134	85574021000	24420	12114	25	0	\N
185837	2134	85573018000	24420	12114	26	0	\N
185838	2134	85572015000	24420	12114	27	0	\N
185839	2134	85571012000	24420	12114	28	0	\N
185840	2134	85570009000	24420	12114	29	0	\N
185841	2134	85569006000	24420	12114	30	0	\N
185842	2134	85568003000	24420	12114	31	0	\N
185843	2134	85567000000	24420	12114	32	0	\N
185844	2134	85565997000	24420	12114	33	0	\N
185845	2134	85564994000	24420	12114	34	0	\N
185846	2134	85563991000	24420	12114	35	0	\N
185847	2134	85562988000	24420	12114	36	0	\N
185848	2134	85561985000	24420	12114	37	0	\N
185849	2134	85560982000	24420	12114	38	0	\N
185850	2134	85559979000	24420	12114	39	0	\N
185851	2134	85558976000	24420	12114	40	0	\N
185852	2134	85557973000	24420	12114	41	0	\N
185853	2132	147626639000	24420	12114	42	0	\N
185854	2132	147625638000	24420	12114	43	0	\N
185855	2132	147624637000	24420	12114	44	0	\N
185856	2132	147623636000	24420	12114	45	0	\N
185857	2132	147622635000	24420	12114	46	0	\N
185858	2132	147621634000	24420	12114	47	0	\N
185859	1451	12073037000000	24421	12075	0	0	\N
185860	1451	7824937000000	24421	12075	1	0	\N
185861	1451	4958837000000	24421	12075	2	0	\N
185862	1451	2587737000000	24421	12075	3	0	\N
185863	558	66241140726895	24421	12075	4	0	\N
185864	1506	5040080967172	24421	12075	5	0	\N
185865	1397	1294055540000	24421	12075	6	0	\N
185866	1397	1294045539000	24421	12075	7	0	\N
185867	2310	990000000	24421	12075	8	0	\N
185868	1397	1294035538000	24421	12075	9	0	\N
185869	1397	1294025537000	24421	12075	10	0	\N
185870	1397	1294015536000	24421	12075	11	0	\N
185871	1397	1294005535000	24421	12075	12	0	\N
185872	1397	1293995534000	24421	12075	13	0	\N
185873	1397	1293985533000	24421	12075	14	0	\N
185874	1397	1293975532000	24421	12075	15	0	\N
185875	1397	1293965531000	24421	12075	16	0	\N
185876	1397	1293955530000	24421	12075	17	0	\N
185877	1397	1293945529000	24421	12075	18	0	\N
185878	1397	1293935528000	24421	12075	19	0	\N
185879	1397	1293925527000	24421	12075	20	0	\N
185880	1397	1293915526000	24421	12075	21	0	\N
185881	1397	1293905525000	24421	12075	22	0	\N
185882	1397	1293895524000	24421	12075	23	0	\N
185883	1397	1293885523000	24421	12075	24	0	\N
185884	1397	1293875522000	24421	12075	25	0	\N
185885	1397	1293865521000	24421	12075	26	0	\N
185886	1397	1293855520000	24421	12075	27	0	\N
185887	1397	1293845519000	24421	12075	28	0	\N
185888	1397	1293835518000	24421	12075	29	0	\N
185889	1397	1293825517000	24421	12075	30	0	\N
185890	1397	1293815516000	24421	12075	31	0	\N
185891	1397	1293805515000	24421	12075	32	0	\N
185892	1397	1293795514000	24421	12075	33	0	\N
185893	1397	1293785513000	24421	12075	34	0	\N
185894	1397	1293775512000	24421	12075	35	0	\N
185895	1397	1293765511000	24421	12075	36	0	\N
185896	1397	1293755510000	24421	12075	37	0	\N
185897	1397	1293745509000	24421	12075	38	0	\N
185898	1397	1293735508000	24421	12075	39	0	\N
185899	1397	1293725507000	24421	12075	40	0	\N
185900	1397	1293715506000	24421	12075	41	0	\N
185901	1397	1293705505000	24421	12075	42	0	\N
185902	1397	1293695504000	24421	12075	43	0	\N
185903	1397	1293685503000	24421	12075	44	0	\N
185904	1397	1293675502000	24421	12075	45	0	\N
185905	1397	1293665501000	24421	12075	46	0	\N
185906	1397	1293655500000	24421	12075	47	0	\N
185907	1397	1293645499000	24421	12075	48	0	\N
185908	1397	1293635498000	24421	12075	49	0	\N
185909	1397	1293625497000	24421	12075	50	0	\N
185910	1397	1293615496000	24421	12075	51	0	\N
185911	1397	1293605495000	24421	12075	52	0	\N
185912	1397	1293595494000	24421	12075	53	0	\N
185779	1611	6166142403568	24407	12137	4	0	12
185780	1611	3362354241757	24407	12137	5	0	13
185781	1397	1293185453000	24408	12138	0	0	14564
185782	2134	85568003000	24408	12138	1	0	5007
185783	2132	147624637000	24408	12138	2	0	1364
185787	1397	1293175452000	24411	12140	0	0	14565
185788	1397	1293165451000	24411	12140	1	0	14566
185789	2134	85565997000	24411	12140	2	0	5009
185790	1397	1293155450000	24412	12141	0	0	14567
185791	2132	147623636000	24412	12141	1	0	1365
185793	1397	1293145449000	24413	12142	0	0	14568
185794	2134	85563991000	24413	12142	1	0	5011
185795	1397	1293135448000	24414	12143	0	0	14569
185796	2134	85562988000	24414	12143	1	0	5012
185802	1397	1293115446000	24417	12144	1	0	14571
185803	1397	1293105445000	24417	12144	2	0	14572
185804	2132	147622635000	24417	12144	3	0	1366
185805	2134	85561985000	24417	12144	4	0	5013
185806	2134	85560982000	24417	12144	5	0	5014
185808	1397	1293095444000	24418	12145	0	0	14573
185809	2134	85558976000	24418	12145	1	0	5016
185913	1397	1293585493000	24421	12075	54	0	\N
185914	1397	1293575492000	24421	12075	55	0	\N
185915	1397	1293565491000	24421	12075	56	0	\N
185916	1397	1293555490000	24421	12075	57	0	\N
185917	1397	1293545489000	24421	12075	58	0	\N
185918	1397	1293535488000	24421	12075	59	0	\N
185919	1397	1293525487000	24421	12075	60	0	\N
185920	1397	1293515486000	24421	12075	61	0	\N
185921	1397	1293505485000	24421	12075	62	0	\N
185922	1397	1293495484000	24421	12075	63	0	\N
185923	1397	1293485483000	24421	12075	64	0	\N
185924	1397	1293475482000	24421	12075	65	0	\N
185925	1397	1293465481000	24421	12075	66	0	\N
185926	1397	1293455480000	24421	12075	67	0	\N
185927	1397	1293445479000	24421	12075	68	0	\N
185928	1397	1293435478000	24421	12075	69	0	\N
185929	1397	1293425477000	24421	12075	70	0	\N
185930	1397	1293415476000	24421	12075	71	0	\N
185931	1397	1293405475000	24421	12075	72	0	\N
185932	1397	1293395474000	24421	12075	73	0	\N
185933	1397	1293385473000	24421	12075	74	0	\N
185934	1397	1293375472000	24421	12075	75	0	\N
185935	1397	1293365471000	24421	12075	76	0	\N
185936	1397	1293355470000	24421	12075	77	0	\N
185937	1397	1293345469000	24421	12075	78	0	\N
185938	1397	1293335468000	24421	12075	80	0	\N
185939	1397	1293325467000	24421	12075	81	0	\N
185940	1397	1293315466000	24421	12075	82	0	\N
185941	1397	1293305465000	24421	12075	83	0	\N
185942	1397	1293295464000	24421	12075	84	0	\N
185943	1397	1293285463000	24421	12075	85	0	\N
185944	1397	1293275462000	24421	12075	86	0	\N
185945	1397	1293265461000	24421	12075	87	0	\N
185946	1397	1293255460000	24421	12075	88	0	\N
185947	1397	1293245459000	24421	12075	89	0	\N
185948	1397	1293235458000	24421	12075	90	0	\N
185949	1397	1293225457000	24421	12075	91	0	\N
185950	1397	1293215456000	24421	12075	92	0	\N
185951	1397	1293205455000	24421	12075	93	0	\N
185952	1397	1293195454000	24421	12075	94	0	\N
185953	1397	1293185453000	24421	12075	95	0	\N
185954	1397	1293175452000	24421	12075	96	0	\N
185955	1397	1293165451000	24421	12075	97	0	\N
185956	1397	1293155450000	24421	12075	98	0	\N
185957	1397	1293145449000	24421	12075	99	0	\N
185958	1397	1293135448000	24421	12075	100	0	\N
185959	1397	1293125447000	24421	12075	101	0	\N
185960	1397	1293115446000	24421	12075	102	0	\N
185961	1397	1293105445000	24421	12075	103	0	\N
185962	1397	1293095444000	24421	12075	104	0	\N
185963	1397	1293085443000	24421	12075	105	0	\N
185964	2058	533500000	24421	12075	106	0	\N
185965	1611	8663559824916	24421	12075	107	0	\N
185966	1611	7172315202966	24421	12075	108	0	\N
185967	1611	6166142403568	24421	12075	109	0	\N
185968	1611	3362354241757	24421	12075	110	0	\N
185969	2133	92075792000	24421	12075	111	0	\N
185970	2133	92074790000	24421	12075	112	0	\N
185971	2133	92073788000	24421	12075	113	0	\N
185972	2132	147651664000	24421	12075	114	0	\N
185973	2133	92072786000	24421	12075	115	0	\N
185974	2133	92071784000	24421	12075	116	0	\N
185975	2133	92070782000	24421	12075	117	0	\N
185976	2132	147650663000	24421	12075	118	0	\N
185977	2132	147649662000	24421	12075	119	0	\N
185978	2132	147648661000	24421	12075	120	0	\N
185979	2132	147647660000	24421	12075	121	0	\N
185980	2132	147646659000	24421	12075	122	0	\N
185981	2133	92069780000	24421	12075	123	0	\N
185982	2133	92068778000	24421	12075	124	0	\N
185983	2133	92067776000	24421	12075	125	0	\N
185984	1397	1293085443000	24422	12146	0	0	\N
185985	1397	1293075442000	24422	12146	1	0	\N
185986	1397	1293065441000	24422	12146	2	0	\N
185987	2132	147621634000	24422	12146	3	0	\N
185988	2134	85557973000	24422	12146	4	0	\N
185989	2134	85556970000	24422	12146	5	0	\N
185990	2134	85555967000	24422	12146	6	0	\N
186005	1397	1293025437000	24425	12148	0	0	\N
186006	2134	85551955000	24425	12148	1	0	\N
186009	1397	1293025437000	24427	12148	0	0	\N
186010	2134	85551955000	24427	12148	1	0	\N
186011	1397	1293015436000	24428	12149	0	0	\N
186012	2132	147619632000	24428	12149	1	0	\N
186013	2134	85550952000	24428	12149	2	0	\N
186017	1397	1293015436000	24430	12149	0	0	\N
186018	2132	147619632000	24430	12149	1	0	\N
186019	2134	85550952000	24430	12149	2	0	\N
186020	1397	1293015436000	24431	12149	0	0	\N
186021	2132	147619632000	24431	12149	1	0	\N
186022	2134	85550952000	24431	12149	2	0	\N
186023	1397	1293015436000	24432	12149	0	0	\N
186024	2132	147619632000	24432	12149	1	0	\N
186025	2134	85550952000	24432	12149	2	0	\N
186035	1397	1292995434000	24437	12152	0	0	\N
186036	1397	1292985433000	24437	12152	1	0	\N
186037	1397	1292975432000	24437	12152	2	0	\N
186038	2134	85548946000	24437	12152	3	0	\N
186039	2132	147618631000	24437	12152	4	0	\N
186040	2134	85547943000	24437	12152	5	0	\N
186041	2134	85546940000	24437	12152	6	0	\N
185993	1397	1293065441000	24423	12146	2	0	14576
185994	2132	147621634000	24423	12146	3	0	1367
185995	2134	85557973000	24423	12146	4	0	5017
185996	2134	85556970000	24423	12146	5	0	5018
185997	2134	85555967000	24423	12146	6	0	5019
185999	1397	1293045439000	24424	12147	1	0	14578
186000	1397	1293035438000	24424	12147	2	0	14579
186001	2132	147620633000	24424	12147	3	0	1368
186002	2134	85554964000	24424	12147	4	0	5020
186003	2134	85553961000	24424	12147	5	0	5021
186007	1397	1293025437000	24426	12148	0	0	14580
186008	2134	85551955000	24426	12148	1	0	5023
186014	1397	1293015436000	24429	12149	0	0	14581
186015	2132	147619632000	24429	12149	1	0	1369
186026	1397	1293005435000	24433	12150	0	0	14582
186027	2134	85549949000	24433	12150	1	0	5025
186028	1397	1292995434000	24436	12152	0	0	14583
186029	1397	1292985433000	24436	12152	1	0	14584
186030	1397	1292975432000	24436	12152	2	0	14585
186032	2132	147618631000	24436	12152	4	0	1370
186033	2134	85547943000	24436	12152	5	0	5027
186034	2134	85546940000	24436	12152	6	0	5028
186042	1397	1292965431000	24438	12153	0	0	14586
186043	2134	85545937000	24438	12153	1	0	5029
186045	1397	1292955430000	24439	12154	1	0	14587
186046	2134	85544934000	24439	12154	2	0	5030
186047	2132	147617630000	24439	12154	3	0	1371
186048	1397	1292945429000	24440	12155	0	0	14588
186052	114	66043463685762	24442	12154	0	0	\N
186053	1397	1292955430000	24442	12154	1	0	\N
186054	1397	1292945429000	24442	12154	2	0	\N
186055	1397	1292935428000	24442	12154	3	0	\N
186056	2134	85544934000	24442	12154	4	0	\N
186057	2134	85543931000	24442	12154	5	0	\N
186058	2132	147617630000	24442	12154	6	0	\N
186059	2134	85542928000	24442	12154	7	0	\N
186060	1397	1292945429000	24443	12155	0	0	\N
186061	1397	1292935428000	24443	12155	1	0	\N
186062	2134	85543931000	24443	12155	2	0	\N
186063	2134	85542928000	24443	12155	3	0	\N
186066	1397	1292925427000	24445	12157	0	0	\N
186067	2134	85541925000	24445	12157	1	0	\N
186068	1451	12073037000000	24446	12109	0	0	\N
186069	1451	7824937000000	24446	12109	1	0	\N
186070	1451	4958837000000	24446	12109	2	0	\N
186071	1451	2587737000000	24446	12109	3	0	\N
186072	114	66043463685762	24446	12109	4	0	\N
186073	1611	8663559824916	24446	12109	5	0	\N
186074	1611	7172315202966	24446	12109	6	0	\N
186075	1611	6166142403568	24446	12109	7	0	\N
186076	1611	3362354241757	24446	12109	8	0	\N
186084	1397	1292905425000	24449	12159	0	0	\N
186085	1397	1292895424000	24449	12159	1	0	\N
186086	2134	85539919000	24449	12159	2	0	\N
186087	2134	85538916000	24449	12159	3	0	\N
186088	1397	1292905425000	24450	12159	0	0	\N
186089	1397	1292895424000	24450	12159	1	0	\N
186090	2134	85539919000	24450	12159	2	0	\N
186091	2134	85538916000	24450	12159	3	0	\N
186092	1397	1292905425000	24451	12159	0	0	\N
186093	1397	1292895424000	24451	12159	1	0	\N
186094	2134	85539919000	24451	12159	2	0	\N
186095	2134	85538916000	24451	12159	3	0	\N
186096	1397	1292885423000	24452	12160	0	0	\N
186097	2134	85537913000	24452	12160	1	0	\N
186098	2132	147615628000	24452	12160	2	0	\N
186108	1397	1292855420000	24456	12162	0	0	\N
186109	2132	147614627000	24456	12162	1	0	\N
186110	2134	85535907000	24456	12162	2	0	\N
186115	1397	1292845419000	24458	12163	0	0	\N
186116	1397	1292835418000	24458	12163	1	0	\N
186117	2134	85534904000	24458	12163	2	0	\N
186118	2134	85533901000	24458	12163	3	0	\N
186119	1397	1292845419000	24459	12163	0	0	\N
186120	1397	1292835418000	24459	12163	1	0	\N
186121	2134	85534904000	24459	12163	2	0	\N
186122	2134	85533901000	24459	12163	3	0	\N
186125	1397	1292825417000	24461	12164	0	0	\N
186126	2134	85532898000	24461	12164	1	0	\N
186145	1397	1292755410000	24466	12168	0	0	\N
186146	2132	147611624000	24466	12168	1	0	\N
186147	2134	85525877000	24466	12168	2	0	\N
186151	1397	1292755410000	24468	12168	0	0	\N
186152	2132	147611624000	24468	12168	1	0	\N
186153	2134	85525877000	24468	12168	2	0	\N
186154	1397	1292755410000	24469	12168	0	0	\N
186155	2132	147611624000	24469	12168	1	0	\N
186156	1397	1292745409000	24470	12169	0	0	\N
186157	2134	85524874000	24470	12169	1	0	\N
186164	1397	1292735408000	24473	12170	0	0	\N
186165	1397	1292725407000	24473	12170	1	0	\N
186166	1397	1292735408000	24475	12170	0	0	\N
186167	1397	1292725407000	24475	12170	1	0	\N
186168	2134	85523871000	24475	12170	2	0	\N
186169	2134	85522868000	24475	12170	3	0	\N
186170	1397	1292735408000	24476	12170	0	0	\N
186171	1397	1292725407000	24476	12170	1	0	\N
186172	2134	85523871000	24476	12170	2	0	\N
186173	2134	85522868000	24476	12170	3	0	\N
186177	1397	1292705405000	24478	12172	0	0	\N
186178	2134	85520862000	24478	12172	1	0	\N
186051	2134	85542928000	24441	12156	1	0	5032
186064	1397	1292925427000	24444	12157	0	0	14590
186065	2134	85541925000	24444	12157	1	0	5033
186077	1397	1292915426000	24447	12158	0	0	14591
186078	2134	85540922000	24447	12158	1	0	5034
186080	1397	1292905425000	24448	12159	0	0	14592
186081	1397	1292895424000	24448	12159	1	0	14593
186082	2134	85539919000	24448	12159	2	0	5035
186083	2134	85538916000	24448	12159	3	0	5036
186099	1397	1292885423000	24453	12160	0	0	14594
186101	2132	147615628000	24453	12160	2	0	1373
186102	1397	1292875422000	24454	12161	0	0	14595
186103	1397	1292865421000	24454	12161	1	0	14596
186104	2134	85536910000	24454	12161	2	0	5038
186106	2132	147614627000	24455	12162	1	0	1374
186107	2134	85535907000	24455	12162	2	0	5039
186111	1397	1292845419000	24457	12163	0	0	14598
186112	1397	1292835418000	24457	12163	1	0	14599
186113	2134	85534904000	24457	12163	2	0	5040
186123	1397	1292825417000	24460	12164	0	0	14600
186124	2134	85532898000	24460	12164	1	0	5042
186127	1397	1292815416000	24463	12165	0	0	14601
186128	2132	147613626000	24463	12165	1	0	1375
186129	2134	85531895000	24463	12165	2	0	5043
186131	1397	1292795414000	24464	12166	1	0	14603
186132	1397	1292785413000	24464	12166	2	0	14604
186133	2134	85530892000	24464	12166	3	0	5044
186134	2134	85529889000	24464	12166	4	0	5045
186136	2132	147612625000	24464	12166	6	0	1376
186137	1601	8800843620000	24465	12167	0	0	18
186138	1601	6644833620000	24465	12167	1	0	19
186139	1601	5189823620000	24465	12167	2	0	20
186140	1601	3985813620000	24465	12167	3	0	21
186142	1397	1292765411000	24465	12167	5	0	14606
186143	2134	85527883000	24465	12167	6	0	5047
186144	2134	85526880000	24465	12167	7	0	5048
186148	1397	1292755410000	24467	12168	0	0	14607
186149	2132	147611624000	24467	12168	1	0	1377
186158	1397	1292745409000	24471	12169	0	0	14608
186159	2134	85524874000	24471	12169	1	0	5050
186160	1397	1292735408000	24472	12170	0	0	14609
186161	1397	1292725407000	24472	12170	1	0	14610
186163	2134	85522868000	24472	12170	3	0	5052
186174	1397	1292715406000	24477	12171	0	0	14611
186175	2134	85521865000	24477	12171	1	0	5053
186176	2132	147610623000	24477	12171	2	0	1378
186179	1397	1292705405000	24479	12172	0	0	14612
186181	1397	1292695404000	24481	12173	0	0	14613
186182	1397	1292685403000	24481	12173	1	0	14614
186183	2132	147609622000	24481	12173	2	0	1379
186184	2134	85519859000	24481	12173	3	0	5055
186206	1397	1292605395000	24490	12179	0	0	\N
186207	1397	1292595394000	24490	12179	1	0	\N
186208	2134	85510832000	24490	12179	2	0	\N
186209	2134	85509829000	24490	12179	3	0	\N
186212	1397	1292585393000	24492	12180	0	0	\N
186213	2132	147606619000	24492	12180	1	0	\N
186214	2134	85508826000	24492	12180	2	0	\N
186215	1397	1292575392000	24493	12181	0	0	\N
186216	2134	85508826000	24493	12181	1	0	\N
186217	2134	85507823000	24493	12181	2	0	\N
186222	1397	1292565391000	24496	12182	0	0	\N
186223	2134	85506820000	24496	12182	1	0	\N
186224	1397	1292555390000	24497	12183	0	0	\N
186225	1397	1292545389000	24497	12183	1	0	\N
186226	2134	85506820000	24497	12183	2	0	\N
186227	2134	85505817000	24497	12183	3	0	\N
186228	2134	85504814000	24497	12183	4	0	\N
186229	2132	147605618000	24497	12183	5	0	\N
186243	1451	12073037000000	24502	12028	0	0	\N
186244	1451	7824937000000	24502	12028	1	0	\N
186245	1451	4958837000000	24502	12028	2	0	\N
186246	1451	2587737000000	24502	12028	3	0	\N
186247	1601	8080831620000	24502	12028	4	0	\N
186248	114	66043463685762	24502	12028	5	0	\N
186249	558	66242190726895	24502	12028	6	0	\N
186250	558	66241140726895	24502	12028	7	0	\N
186251	1506	5040080967172	24502	12028	8	0	\N
186252	1601	5924821620000	24502	12028	9	0	\N
186253	1601	4469811620000	24502	12028	10	0	\N
186254	1601	3265801620000	24502	12028	11	0	\N
186255	1397	1294705605000	24502	12028	12	0	\N
186256	1397	1294695604000	24502	12028	13	0	\N
186257	1397	1294685603000	24502	12028	14	0	\N
186258	1397	1294675602000	24502	12028	15	0	\N
186259	1397	1294665601000	24502	12028	16	0	\N
186260	1397	1294655600000	24502	12028	17	0	\N
186261	1622	25332983250418	24502	12028	18	0	\N
186262	1622	22232833685186	24502	12028	19	0	\N
186263	1622	16677400146274	24502	12028	20	0	\N
186264	1622	12929035184936	24502	12028	21	0	\N
186265	1622	2483900800048	24502	12028	22	0	\N
186266	1397	1294645599000	24502	12028	23	0	\N
186267	1397	1294635598000	24502	12028	24	0	\N
186268	1397	1294625597000	24502	12028	25	0	\N
186269	1397	1294615596000	24502	12028	26	0	\N
186270	1397	1294605595000	24502	12028	27	0	\N
186271	1397	1294595594000	24502	12028	28	0	\N
186272	1397	1294585593000	24502	12028	29	0	\N
186273	1397	1294575592000	24502	12028	30	0	\N
186274	1397	1294565591000	24502	12028	31	0	\N
186275	1397	1294555590000	24502	12028	32	0	\N
186276	1397	1294545589000	24502	12028	33	0	\N
186277	1397	1294535588000	24502	12028	34	0	\N
186278	1397	1294525587000	24502	12028	35	0	\N
186279	1397	1294515586000	24502	12028	36	0	\N
186280	1397	1294505585000	24502	12028	37	0	\N
186281	1397	1294495584000	24502	12028	38	0	\N
186282	1397	1294485583000	24502	12028	39	0	\N
186283	1397	1294475582000	24502	12028	40	0	\N
186284	1397	1294465581000	24502	12028	41	0	\N
186285	1397	1294455580000	24502	12028	42	0	\N
186286	1397	1294445579000	24502	12028	43	0	\N
186287	1397	1294435578000	24502	12028	44	0	\N
186288	1397	1294425577000	24502	12028	45	0	\N
186289	1397	1294415576000	24502	12028	46	0	\N
186290	1397	1294405575000	24502	12028	47	0	\N
186291	1397	1294395574000	24502	12028	48	0	\N
186292	1397	1294385573000	24502	12028	49	0	\N
186293	1397	1294375572000	24502	12028	50	0	\N
186294	1397	1294365571000	24502	12028	51	0	\N
186295	1397	1294355570000	24502	12028	52	0	\N
186296	1397	1294345569000	24502	12028	53	0	\N
186297	1397	1294335568000	24502	12028	54	0	\N
186298	1397	1294325567000	24502	12028	55	0	\N
186299	1397	1294315566000	24502	12028	56	0	\N
186300	1397	1294305565000	24502	12028	57	0	\N
186301	1397	1294295564000	24502	12028	58	0	\N
186302	1397	1294285563000	24502	12028	59	0	\N
186303	1397	1294275562000	24502	12028	60	0	\N
186304	1397	1294265561000	24502	12028	61	0	\N
186305	1397	1294255560000	24502	12028	62	0	\N
186306	1397	1294245559000	24502	12028	63	0	\N
186307	1397	1294235558000	24502	12028	64	0	\N
186308	1397	1294225557000	24502	12028	65	0	\N
186309	1397	1294215556000	24502	12028	66	0	\N
186310	1397	1294205555000	24502	12028	67	0	\N
186311	1397	1294195554000	24502	12028	68	0	\N
186312	1397	1294185553000	24502	12028	69	0	\N
186313	1397	1294175552000	24502	12028	70	0	\N
186314	1397	1294165551000	24502	12028	71	0	\N
186315	1397	1294155550000	24502	12028	72	0	\N
186316	1397	1294145549000	24502	12028	73	0	\N
186317	1397	1294135548000	24502	12028	74	0	\N
186318	1397	1294125547000	24502	12028	75	0	\N
186319	1397	1294115546000	24502	12028	76	0	\N
186320	1397	1294105545000	24502	12028	77	0	\N
186187	2134	85517853000	24484	12174	1	0	5057
186188	1397	1292665401000	24485	12175	0	0	14616
186189	2134	85516850000	24485	12175	2	0	5058
186190	1397	1292655400000	24486	12176	0	0	14617
186191	1397	1292645399000	24486	12176	1	0	14618
186193	2134	85515847000	24486	12176	3	0	5059
186194	2134	85514844000	24486	12176	4	0	5060
186195	1397	1292635398000	24487	12177	0	0	14619
186196	1397	1292625397000	24487	12177	1	0	14620
186197	2134	85513841000	24487	12177	2	0	5061
186199	1397	1292615396000	24488	12178	0	0	14621
186200	2132	147607620000	24488	12178	1	0	1381
186201	2134	85511835000	24488	12178	2	0	5063
186202	1397	1292605395000	24489	12179	0	0	14622
186204	2134	85510832000	24489	12179	2	0	5064
186205	2134	85509829000	24489	12179	3	0	5065
186210	1397	1292585393000	24491	12180	0	0	14624
186211	2132	147606619000	24491	12180	1	0	1382
186218	1397	1292575392000	24494	12181	0	0	14625
186220	2134	85507823000	24494	12181	2	0	5067
186221	1397	1292565391000	24495	12182	0	0	14626
186230	1397	1292555390000	24498	12183	0	0	14627
186231	1397	1292545389000	24498	12183	1	0	14628
186232	2134	85506820000	24498	12183	2	0	5068
186234	2134	85504814000	24498	12183	4	0	5070
186235	2132	147605618000	24498	12183	5	0	1383
186236	1397	1292535388000	24499	12184	0	0	14629
186237	2134	85503811000	24499	12184	1	0	5071
186239	2134	85502808000	24500	12185	1	0	5072
186240	1397	1292515386000	24501	12186	0	0	14631
186241	2134	85501805000	24501	12186	1	0	5073
186242	2132	147604617000	24501	12186	2	0	1384
186321	1397	1294095544000	24502	12028	78	0	\N
186322	1397	1294085543000	24502	12028	79	0	\N
186323	1397	1294075542000	24502	12028	80	0	\N
186324	1397	1294065541000	24502	12028	81	0	\N
186325	1397	1294055540000	24502	12028	82	0	\N
186326	1397	1294045539000	24502	12028	83	0	\N
186327	1397	1294035538000	24502	12028	84	0	\N
186328	1397	1294025537000	24502	12028	85	0	\N
186329	1397	1294015536000	24502	12028	86	0	\N
186330	1397	1294005535000	24502	12028	87	0	\N
186331	1397	1293995534000	24502	12028	88	0	\N
186332	1397	1293985533000	24502	12028	89	0	\N
186333	1397	1293975532000	24502	12028	90	0	\N
186334	1397	1293965531000	24502	12028	91	0	\N
186335	1397	1293955530000	24502	12028	92	0	\N
186336	1397	1293945529000	24502	12028	93	0	\N
186337	1397	1293935528000	24502	12028	94	0	\N
186338	1397	1293925527000	24502	12028	95	0	\N
186339	1397	1293915526000	24502	12028	96	0	\N
186340	1397	1293905525000	24502	12028	97	0	\N
186341	1397	1293895524000	24502	12028	98	0	\N
186342	1397	1293885523000	24502	12028	99	0	\N
186343	1397	1293875522000	24502	12028	100	0	\N
186344	1397	1293865521000	24502	12028	101	0	\N
186345	1397	1293855520000	24502	12028	102	0	\N
186346	1397	1293845519000	24502	12028	103	0	\N
186347	1397	1293835518000	24502	12028	104	0	\N
186348	1397	1293825517000	24502	12028	105	0	\N
186349	1397	1293815516000	24502	12028	106	0	\N
186350	1397	1293805515000	24502	12028	107	0	\N
186351	1397	1293795514000	24502	12028	108	0	\N
186352	1397	1293785513000	24502	12028	109	0	\N
186353	1397	1293775512000	24502	12028	110	0	\N
186354	1397	1293765511000	24502	12028	111	0	\N
186355	1397	1293755510000	24502	12028	112	0	\N
186356	1397	1293745509000	24502	12028	113	0	\N
186357	1397	1293735508000	24502	12028	114	0	\N
186358	1397	1293725507000	24502	12028	115	0	\N
186359	1397	1293715506000	24502	12028	116	0	\N
186360	1397	1293705505000	24502	12028	118	0	\N
186361	1397	1293695504000	24502	12028	119	0	\N
186362	1397	1293685503000	24502	12028	120	0	\N
186363	1397	1293675502000	24502	12028	121	0	\N
186364	1397	1293665501000	24502	12028	122	0	\N
186365	1397	1293655500000	24502	12028	123	0	\N
186366	1397	1293645499000	24502	12028	124	0	\N
186367	1397	1293635498000	24502	12028	125	0	\N
186370	1397	1292495384000	24504	12188	0	0	\N
186371	2134	85499799000	24504	12188	1	0	\N
186379	1397	1292465381000	24508	12190	0	0	\N
186380	2134	85496790000	24508	12190	1	0	\N
186381	1397	1292465381000	24509	12190	0	0	\N
186382	2134	85496790000	24509	12190	1	0	\N
186383	1397	1292465381000	24510	12190	0	0	\N
186384	2134	85496790000	24510	12190	1	0	\N
186392	1397	1292455380000	24513	12191	0	0	\N
186393	1397	1292445379000	24513	12191	1	0	\N
186394	2132	147602615000	24513	12191	2	0	\N
186395	2134	85495787000	24513	12191	3	0	\N
186396	2134	85494784000	24513	12191	4	0	\N
186397	1451	12073037000000	24514	12096	0	0	\N
186398	1451	7824937000000	24514	12096	1	0	\N
186399	1451	4958837000000	24514	12096	2	0	\N
186400	1451	2587737000000	24514	12096	3	0	\N
186401	1601	8800843620000	24514	12096	4	0	\N
186402	114	66043463685762	24514	12096	5	0	\N
186403	1397	1293725507000	24514	12096	6	0	\N
186404	1506	5040080967172	24514	12096	7	0	\N
186405	1601	6644833620000	24514	12096	8	0	\N
186406	1601	5189823620000	24514	12096	9	0	\N
186407	1601	3985813620000	24514	12096	10	0	\N
186408	1397	1293715506000	24514	12096	11	0	\N
186409	1397	1293705505000	24514	12096	12	0	\N
186410	1397	1293695504000	24514	12096	13	0	\N
186411	1397	1293685503000	24514	12096	14	0	\N
186412	1397	1293675502000	24514	12096	15	0	\N
186413	1397	1293665501000	24514	12096	16	0	\N
186414	1397	1293655500000	24514	12096	17	0	\N
186415	1397	1293645499000	24514	12096	18	0	\N
186416	1397	1293635498000	24514	12096	19	0	\N
186417	1397	1293625497000	24514	12096	20	0	\N
186418	1397	1293615496000	24514	12096	21	0	\N
186419	1397	1293605495000	24514	12096	22	0	\N
186420	1397	1293595494000	24514	12096	23	0	\N
186421	1397	1293585493000	24514	12096	24	0	\N
186422	1397	1293575492000	24514	12096	25	0	\N
186423	1397	1293565491000	24514	12096	26	0	\N
186424	1397	1293555490000	24514	12096	27	0	\N
186425	1397	1293545489000	24514	12096	28	0	\N
186426	1397	1293535488000	24514	12096	29	0	\N
186427	1397	1293525487000	24514	12096	30	0	\N
186428	1397	1293515486000	24514	12096	31	0	\N
186429	1397	1293505485000	24514	12096	32	0	\N
186430	1397	1293495484000	24514	12096	33	0	\N
186431	1397	1293485483000	24514	12096	34	0	\N
186432	1397	1293475482000	24514	12096	35	0	\N
186433	1397	1293465481000	24514	12096	36	0	\N
186434	1397	1293455480000	24514	12096	37	0	\N
186435	1397	1293445479000	24514	12096	38	0	\N
186436	1397	1293435478000	24514	12096	39	0	\N
186437	1397	1293425477000	24514	12096	40	0	\N
186438	1397	1293415476000	24514	12096	41	0	\N
186439	1397	1293405475000	24514	12096	42	0	\N
186440	1397	1293395474000	24514	12096	43	0	\N
186441	1397	1293385473000	24514	12096	44	0	\N
186442	1397	1293375472000	24514	12096	45	0	\N
186443	1397	1293365471000	24514	12096	46	0	\N
186444	1397	1293355470000	24514	12096	47	0	\N
186445	1397	1293345469000	24514	12096	48	0	\N
186446	1397	1293335468000	24514	12096	49	0	\N
186447	1397	1293325467000	24514	12096	50	0	\N
186448	1397	1293315466000	24514	12096	51	0	\N
186449	1397	1293305465000	24514	12096	52	0	\N
186450	1397	1293295464000	24514	12096	53	0	\N
186451	1397	1293285463000	24514	12096	55	0	\N
186452	1397	1293275462000	24514	12096	56	0	\N
186453	1397	1293265461000	24514	12096	57	0	\N
186454	1397	1293255460000	24514	12096	58	0	\N
186455	1397	1293245459000	24514	12096	59	0	\N
186456	1397	1293235458000	24514	12096	60	0	\N
186372	1397	1292495384000	24506	12188	0	0	14633
186373	2134	85499799000	24506	12188	1	0	5075
186374	1397	1292485383000	24507	12189	0	0	14634
186375	1397	1292475382000	24507	12189	1	0	14635
186376	2134	85498796000	24507	12189	2	0	5076
186378	2134	85497793000	24507	12189	4	0	5077
186385	1397	1292465381000	24511	12190	0	0	14636
186386	2134	85496790000	24511	12190	1	0	5078
186387	1397	1292455380000	24512	12191	0	0	14637
186388	1397	1292445379000	24512	12191	1	0	14638
186390	2134	85495787000	24512	12191	3	0	5079
186391	2134	85494784000	24512	12191	4	0	5080
186457	1397	1293225457000	24514	12096	61	0	\N
186458	1397	1293215456000	24514	12096	62	0	\N
186459	1397	1293205455000	24514	12096	63	0	\N
186460	1397	1293195454000	24514	12096	64	0	\N
186461	1397	1293185453000	24514	12096	65	0	\N
186462	1397	1293175452000	24514	12096	66	0	\N
186463	1397	1293165451000	24514	12096	67	0	\N
186464	1397	1293155450000	24514	12096	68	0	\N
186465	1397	1293145449000	24514	12096	69	0	\N
186466	1397	1293135448000	24514	12096	70	0	\N
186467	1397	1293125447000	24514	12096	71	0	\N
186468	1397	1293115446000	24514	12096	72	0	\N
186469	1397	1293105445000	24514	12096	73	0	\N
186470	1397	1293095444000	24514	12096	74	0	\N
186471	1397	1293085443000	24514	12096	75	0	\N
186472	1397	1293075442000	24514	12096	76	0	\N
186473	1397	1293065441000	24514	12096	77	0	\N
186474	1397	1293055440000	24514	12096	78	0	\N
186475	1397	1293045439000	24514	12096	79	0	\N
186476	1397	1293035438000	24514	12096	80	0	\N
186477	1397	1293025437000	24514	12096	81	0	\N
186478	1397	1293015436000	24514	12096	82	0	\N
186479	1397	1293005435000	24514	12096	83	0	\N
186480	1397	1292995434000	24514	12096	84	0	\N
186481	1397	1292985433000	24514	12096	85	0	\N
186482	1397	1292975432000	24514	12096	86	0	\N
186483	1397	1292965431000	24514	12096	87	0	\N
186484	1397	1292955430000	24514	12096	88	0	\N
186485	1397	1292945429000	24514	12096	89	0	\N
186486	1397	1292935428000	24514	12096	90	0	\N
186487	1397	1292925427000	24514	12096	91	0	\N
186488	1397	1292915426000	24514	12096	92	0	\N
186489	1397	1292905425000	24514	12096	93	0	\N
186490	1397	1292895424000	24514	12096	94	0	\N
186491	1397	1292885423000	24514	12096	95	0	\N
186492	1397	1292875422000	24514	12096	96	0	\N
186493	1397	1292865421000	24514	12096	97	0	\N
186494	1397	1292855420000	24514	12096	98	0	\N
186495	1397	1292845419000	24514	12096	99	0	\N
186496	1397	1292835418000	24514	12096	100	0	\N
186497	1397	1292825417000	24514	12096	101	0	\N
186498	1397	1292815416000	24514	12096	102	0	\N
186499	1397	1292805415000	24514	12096	103	0	\N
186500	1397	1292795414000	24514	12096	104	0	\N
186501	1397	1292785413000	24514	12096	105	0	\N
186502	1397	1292775412000	24514	12096	106	0	\N
186503	1397	1292765411000	24514	12096	107	0	\N
186504	1397	1292755410000	24514	12096	108	0	\N
186505	1397	1292745409000	24514	12096	109	0	\N
186506	1397	1292735408000	24514	12096	110	0	\N
186507	1397	1292725407000	24514	12096	111	0	\N
186508	1397	1292715406000	24514	12096	112	0	\N
186509	1397	1292705405000	24514	12096	113	0	\N
186510	1397	1292695404000	24514	12096	114	0	\N
186511	1397	1292685403000	24514	12096	115	0	\N
186512	1397	1292675402000	24514	12096	116	0	\N
186513	1397	1292665401000	24514	12096	117	0	\N
186514	1397	1292655400000	24514	12096	118	0	\N
186515	1397	1292645399000	24514	12096	119	0	\N
186516	1397	1292635398000	24514	12096	120	0	\N
186517	1397	1292625397000	24514	12096	121	0	\N
186518	1397	1292615396000	24514	12096	122	0	\N
186519	1397	1292605395000	24514	12096	123	0	\N
186520	1397	1292595394000	24514	12096	124	0	\N
186521	1397	1292585393000	24514	12096	125	0	\N
186522	1397	1292435378000	24515	12192	0	0	\N
186523	1397	1292425377000	24515	12192	1	0	\N
186524	1397	1292415376000	24515	12192	2	0	\N
186525	2132	147601614000	24515	12192	3	0	\N
186526	2134	85493781000	24515	12192	4	0	\N
186527	2134	85492778000	24515	12192	5	0	\N
186528	2134	85491775000	24515	12192	6	0	\N
186536	1451	12073037000000	24517	11919	0	0	\N
186537	1451	7824937000000	24517	11919	1	0	\N
186538	1451	4958837000000	24517	11919	2	0	\N
186539	1451	2587737000000	24517	11919	3	0	\N
186540	1601	8080831620000	24517	11919	4	0	\N
186541	114	66043463685762	24517	11919	5	0	\N
186542	558	66242190726895	24517	11919	6	0	\N
186543	558	66241140726895	24517	11919	7	0	\N
186544	1506	5040080967172	24517	11919	8	0	\N
186545	1601	5924821620000	24517	11919	9	0	\N
186546	1601	4469811620000	24517	11919	10	0	\N
186547	1601	3265801620000	24517	11919	11	0	\N
186548	1622	24612971250418	24517	11919	12	0	\N
186549	1622	21512821685186	24517	11919	13	0	\N
186550	1622	15957388146274	24517	11919	14	0	\N
186551	1622	12209023184936	24517	11919	15	0	\N
186552	1622	1763888800048	24517	11919	16	0	\N
186553	2058	533500000	24517	11919	17	0	\N
186554	1419	17566030560130	24517	11919	18	0	\N
186555	1611	7223536824916	24517	11919	19	0	\N
186556	1611	5732292202966	24517	11919	20	0	\N
186557	1611	4726119403568	24517	11919	21	0	\N
186558	1611	1922331241757	24517	11919	22	0	\N
186559	2132	147656669000	24517	11919	23	0	\N
186560	2132	147655668000	24517	11919	24	0	\N
186561	2132	147654667000	24517	11919	25	0	\N
186562	2132	147653666000	24517	11919	26	0	\N
186563	2132	147652665000	24517	11919	27	0	\N
186564	2132	147651664000	24517	11919	28	0	\N
186565	2132	147650663000	24517	11919	29	0	\N
186566	1397	1292405375000	24518	12193	0	0	\N
186567	2134	85490772000	24518	12193	1	0	\N
186568	1397	1292405375000	24519	12193	0	0	\N
186569	2134	85490772000	24519	12193	1	0	\N
186570	1397	1292405375000	24520	12193	0	0	\N
186571	2134	85490772000	24520	12193	1	0	\N
186572	1397	1292405375000	24521	12193	0	0	\N
186573	2134	85490772000	24521	12193	1	0	\N
186574	1397	1292405375000	24522	12193	0	0	\N
186575	2134	85490772000	24522	12193	1	0	\N
186576	1397	1292405375000	24523	12193	0	0	\N
186577	2134	85490772000	24523	12193	1	0	\N
186580	1451	12073037000000	24525	12082	0	0	\N
186581	1451	7824937000000	24525	12082	1	0	\N
186582	1451	4958837000000	24525	12082	2	0	\N
186583	1451	2587737000000	24525	12082	3	0	\N
186584	1601	8800843620000	24525	12082	4	0	\N
186585	114	66043463685762	24525	12082	5	0	\N
186586	1506	5040080967172	24525	12082	6	0	\N
186587	1601	6644833620000	24525	12082	7	0	\N
186588	1601	5189823620000	24525	12082	8	0	\N
186589	1601	3985813620000	24525	12082	9	0	\N
186590	1397	1293985533000	24525	12082	10	0	\N
186591	1397	1293975532000	24525	12082	11	0	\N
186592	1397	1293965531000	24525	12082	12	0	\N
186531	1397	1292415376000	24516	12192	2	0	14641
186532	2132	147601614000	24516	12192	3	0	1387
186533	2134	85493781000	24516	12192	4	0	5081
186534	2134	85492778000	24516	12192	5	0	5082
186535	2134	85491775000	24516	12192	6	0	5083
186579	2134	85490772000	24524	12193	1	0	5084
186593	1397	1293955530000	24525	12082	13	0	\N
186594	1397	1293945529000	24525	12082	14	0	\N
186595	1397	1293935528000	24525	12082	15	0	\N
186596	1397	1293925527000	24525	12082	16	0	\N
186597	1397	1293915526000	24525	12082	17	0	\N
186598	1397	1293905525000	24525	12082	18	0	\N
186599	1397	1293895524000	24525	12082	19	0	\N
186600	1397	1293885523000	24525	12082	20	0	\N
186601	1397	1293875522000	24525	12082	21	0	\N
186602	1397	1293865521000	24525	12082	22	0	\N
186603	1397	1293855520000	24525	12082	23	0	\N
186604	1397	1293845519000	24525	12082	24	0	\N
186605	1397	1293835518000	24525	12082	25	0	\N
186606	1397	1293825517000	24525	12082	26	0	\N
186607	1397	1293815516000	24525	12082	27	0	\N
186608	1397	1293805515000	24525	12082	28	0	\N
186609	1397	1293795514000	24525	12082	29	0	\N
186610	1397	1293785513000	24525	12082	30	0	\N
186611	1397	1293775512000	24525	12082	31	0	\N
186612	1397	1293765511000	24525	12082	32	0	\N
186613	1397	1293755510000	24525	12082	33	0	\N
186614	1397	1293745509000	24525	12082	34	0	\N
186615	1397	1293735508000	24525	12082	35	0	\N
186616	1397	1293725507000	24525	12082	36	0	\N
186617	1397	1293715506000	24525	12082	37	0	\N
186618	1397	1293705505000	24525	12082	38	0	\N
186619	1397	1293695504000	24525	12082	40	0	\N
186620	1397	1293685503000	24525	12082	41	0	\N
186621	1397	1293675502000	24525	12082	42	0	\N
186622	1397	1293665501000	24525	12082	43	0	\N
186623	1397	1293655500000	24525	12082	44	0	\N
186624	1397	1293645499000	24525	12082	45	0	\N
186625	1397	1293635498000	24525	12082	46	0	\N
186626	1397	1293625497000	24525	12082	47	0	\N
186627	1397	1293615496000	24525	12082	48	0	\N
186628	1397	1293605495000	24525	12082	49	0	\N
186629	1397	1293595494000	24525	12082	50	0	\N
186630	1397	1293585493000	24525	12082	51	0	\N
186631	1397	1293575492000	24525	12082	52	0	\N
186632	1397	1293565491000	24525	12082	53	0	\N
186633	1397	1293555490000	24525	12082	54	0	\N
186634	1397	1293545489000	24525	12082	55	0	\N
186635	1397	1293535488000	24525	12082	56	0	\N
186636	1397	1293525487000	24525	12082	57	0	\N
186637	1397	1293515486000	24525	12082	58	0	\N
186638	1397	1293505485000	24525	12082	59	0	\N
186639	1397	1293495484000	24525	12082	60	0	\N
186640	1397	1293485483000	24525	12082	61	0	\N
186641	1397	1293475482000	24525	12082	62	0	\N
186642	1397	1293465481000	24525	12082	63	0	\N
186643	1397	1293455480000	24525	12082	64	0	\N
186644	1397	1293445479000	24525	12082	65	0	\N
186645	1397	1293435478000	24525	12082	66	0	\N
186646	1397	1293425477000	24525	12082	67	0	\N
186647	1397	1293415476000	24525	12082	68	0	\N
186648	1397	1293405475000	24525	12082	69	0	\N
186649	1397	1293395474000	24525	12082	70	0	\N
186650	1397	1293385473000	24525	12082	71	0	\N
186651	1397	1293375472000	24525	12082	72	0	\N
186652	1397	1293365471000	24525	12082	73	0	\N
186653	1397	1293355470000	24525	12082	74	0	\N
186654	1397	1293345469000	24525	12082	75	0	\N
186655	1397	1293335468000	24525	12082	76	0	\N
186656	1397	1293325467000	24525	12082	77	0	\N
186657	1397	1293315466000	24525	12082	78	0	\N
186658	1397	1293305465000	24525	12082	79	0	\N
186659	1397	1293295464000	24525	12082	80	0	\N
186660	1397	1293285463000	24525	12082	81	0	\N
186661	1397	1293275462000	24525	12082	82	0	\N
186662	1397	1293265461000	24525	12082	83	0	\N
186663	1397	1293255460000	24525	12082	84	0	\N
186664	1397	1293245459000	24525	12082	85	0	\N
186665	1397	1293235458000	24525	12082	86	0	\N
186666	1397	1293225457000	24525	12082	87	0	\N
186667	1397	1293215456000	24525	12082	88	0	\N
186668	1397	1293205455000	24525	12082	89	0	\N
186669	1397	1293195454000	24525	12082	90	0	\N
186670	1397	1293185453000	24525	12082	91	0	\N
186671	1397	1293175452000	24525	12082	92	0	\N
186672	1397	1293165451000	24525	12082	93	0	\N
186673	1397	1293155450000	24525	12082	94	0	\N
186674	1397	1293145449000	24525	12082	95	0	\N
186675	1397	1293135448000	24525	12082	96	0	\N
186676	1397	1293125447000	24525	12082	97	0	\N
186677	1397	1293115446000	24525	12082	98	0	\N
186678	1397	1293105445000	24525	12082	99	0	\N
186679	1397	1293095444000	24525	12082	100	0	\N
186680	1397	1293085443000	24525	12082	101	0	\N
186681	1397	1293075442000	24525	12082	102	0	\N
186682	1397	1293065441000	24525	12082	103	0	\N
186683	1397	1293055440000	24525	12082	104	0	\N
186684	1397	1293045439000	24525	12082	105	0	\N
186685	1397	1293035438000	24525	12082	106	0	\N
186686	1397	1293025437000	24525	12082	107	0	\N
186687	1397	1293015436000	24525	12082	108	0	\N
186688	1397	1293005435000	24525	12082	109	0	\N
186689	1397	1292995434000	24525	12082	110	0	\N
186690	1397	1292985433000	24525	12082	111	0	\N
186691	1397	1292975432000	24525	12082	112	0	\N
186692	1397	1292965431000	24525	12082	113	0	\N
186693	1397	1292955430000	24525	12082	114	0	\N
186694	1397	1292945429000	24525	12082	115	0	\N
186695	1397	1292935428000	24525	12082	116	0	\N
186696	1397	1292925427000	24525	12082	117	0	\N
186697	1397	1292915426000	24525	12082	118	0	\N
186698	1397	1292905425000	24525	12082	119	0	\N
186699	1397	1292895424000	24525	12082	120	0	\N
186700	1397	1292885423000	24525	12082	121	0	\N
186701	1397	1292875422000	24525	12082	122	0	\N
186702	1397	1292865421000	24525	12082	123	0	\N
186703	1397	1292855420000	24525	12082	124	0	\N
186704	1397	1292845419000	24525	12082	125	0	\N
186705	1397	1292405375000	24526	12193	0	0	\N
186706	2134	85490772000	24526	12193	1	0	\N
186707	1601	8800843620000	24527	12156	0	0	\N
186708	1601	6644833620000	24527	12156	1	0	\N
186709	1601	5189823620000	24527	12156	2	0	\N
186710	1601	3985813620000	24527	12156	3	0	\N
186711	1397	1292935428000	24527	12156	4	0	\N
186712	1397	1292925427000	24527	12156	5	0	\N
186713	1397	1292915426000	24527	12156	6	0	\N
186714	1397	1292905425000	24527	12156	7	0	\N
186715	1397	1292895424000	24527	12156	8	0	\N
186716	1397	1292885423000	24527	12156	9	0	\N
186717	2132	147616629000	24527	12156	10	0	\N
186718	2132	147615628000	24527	12156	11	0	\N
186719	2132	147614627000	24527	12156	12	0	\N
186720	2132	147613626000	24527	12156	13	0	\N
186721	2134	85542928000	24527	12156	14	0	\N
186722	2134	85541925000	24527	12156	15	0	\N
186723	2134	85540922000	24527	12156	16	0	\N
186724	2134	85539919000	24527	12156	17	0	\N
186725	2132	147612625000	24527	12156	18	0	\N
186726	2132	147611624000	24527	12156	19	0	\N
186727	2132	147610623000	24527	12156	20	0	\N
186728	2132	147609622000	24527	12156	21	0	\N
186729	2132	147608621000	24527	12156	22	0	\N
186730	2132	147607620000	24527	12156	23	0	\N
186731	2132	147606619000	24527	12156	24	0	\N
186732	2132	147605618000	24527	12156	25	0	\N
186733	2132	147604617000	24527	12156	26	0	\N
186734	2132	147603616000	24527	12156	27	0	\N
186735	2132	147602615000	24527	12156	28	0	\N
186736	2132	147601614000	24527	12156	29	0	\N
186737	2134	85538916000	24527	12156	30	0	\N
186738	2134	85537913000	24527	12156	31	0	\N
186739	2134	85536910000	24527	12156	32	0	\N
186740	2134	85535907000	24527	12156	33	0	\N
186741	2134	85534904000	24527	12156	34	0	\N
186742	2134	85533901000	24527	12156	35	0	\N
186743	2134	85532898000	24527	12156	36	0	\N
186744	2134	85531895000	24527	12156	37	0	\N
186745	2134	85530892000	24527	12156	38	0	\N
186746	2134	85529889000	24527	12156	39	0	\N
186747	2134	85528886000	24527	12156	40	0	\N
186748	2134	85527883000	24527	12156	41	0	\N
186749	2134	85526880000	24527	12156	42	0	\N
186750	2134	85525877000	24527	12156	43	0	\N
186751	2134	85524874000	24527	12156	44	0	\N
186752	2134	85523871000	24527	12156	45	0	\N
186753	2134	85522868000	24527	12156	46	0	\N
186754	2134	85521865000	24527	12156	47	0	\N
186755	2134	85520862000	24527	12156	48	0	\N
186756	2134	85519859000	24527	12156	49	0	\N
186757	2134	85518856000	24527	12156	50	0	\N
186758	2134	85517853000	24527	12156	51	0	\N
186759	2134	85516850000	24527	12156	52	0	\N
186760	2134	85515847000	24527	12156	53	0	\N
186761	2134	85514844000	24527	12156	54	0	\N
186762	2134	85513841000	24527	12156	55	0	\N
186763	2134	85512838000	24527	12156	56	0	\N
186764	2134	85511835000	24527	12156	57	0	\N
186765	2134	85510832000	24527	12156	58	0	\N
186766	2134	85509829000	24527	12156	59	0	\N
186767	2134	85508826000	24527	12156	60	0	\N
186768	2134	85507823000	24527	12156	61	0	\N
186769	2134	85506820000	24527	12156	62	0	\N
186770	2134	85505817000	24527	12156	63	0	\N
186771	2134	85504814000	24527	12156	64	0	\N
186772	2134	85503811000	24527	12156	65	0	\N
186773	2134	85502808000	24527	12156	66	0	\N
186774	2134	85501805000	24527	12156	67	0	\N
186775	2134	85500802000	24527	12156	68	0	\N
186776	2134	85499799000	24527	12156	69	0	\N
186777	2134	85498796000	24527	12156	70	0	\N
186778	2134	85497793000	24527	12156	71	0	\N
186779	2134	85496790000	24527	12156	72	0	\N
186780	2134	85495787000	24527	12156	73	0	\N
186781	2134	85494784000	24527	12156	74	0	\N
186782	2134	85493781000	24527	12156	75	0	\N
186783	2134	85492778000	24527	12156	76	0	\N
186784	2134	85491775000	24527	12156	77	0	\N
186785	2134	85490772000	24527	12156	78	0	\N
186786	1397	1292405375000	24528	12193	0	0	\N
186787	2134	85490772000	24528	12193	1	0	\N
186806	1397	1292405375000	24535	12193	0	0	\N
186807	1397	1292395374000	24535	12193	1	0	\N
186808	1397	1292385373000	24535	12193	2	0	\N
186809	1397	1292375372000	24535	12193	3	0	\N
186810	1397	1292365371000	24535	12193	4	0	\N
186811	1397	1292355370000	24535	12193	5	0	\N
186812	1397	1292345369000	24535	12193	6	0	\N
186813	1397	1292335368000	24535	12193	7	0	\N
186814	1397	1292325367000	24535	12193	8	0	\N
186815	2134	85490772000	24535	12193	9	0	\N
186816	2132	147600613000	24535	12193	10	0	\N
186817	2132	147599612000	24535	12193	11	0	\N
186818	2134	85489769000	24535	12193	12	0	\N
186819	2134	85488766000	24535	12193	13	0	\N
186820	2134	85487763000	24535	12193	14	0	\N
186821	2134	85486760000	24535	12193	15	0	\N
186822	2134	85485757000	24535	12193	16	0	\N
186823	2134	85484754000	24535	12193	17	0	\N
186824	2134	85483751000	24535	12193	18	0	\N
186825	2134	85482748000	24535	12193	19	0	\N
186826	1397	1292315366000	24538	12200	0	0	\N
186827	1397	1292305365000	24538	12200	1	0	\N
186828	1397	1292295364000	24538	12200	2	0	\N
186829	2132	147598611000	24538	12200	3	0	\N
186830	2134	85481745000	24538	12200	4	0	\N
186831	2134	85480742000	24538	12200	5	0	\N
186832	1397	1292315366000	24539	12200	0	0	\N
186833	1397	1292305365000	24539	12200	1	0	\N
186834	1397	1292295364000	24539	12200	2	0	\N
186835	2132	147598611000	24539	12200	3	0	\N
186836	2134	85481745000	24539	12200	4	0	\N
186837	2134	85480742000	24539	12200	5	0	\N
186851	1397	1292275362000	24542	12202	0	0	\N
186852	1397	1292265361000	24542	12202	1	0	\N
186853	2134	85478736000	24542	12202	2	0	\N
186854	2134	85477733000	24542	12202	3	0	\N
186862	1397	1292235358000	24549	12204	0	0	\N
186863	2134	85474724000	24549	12204	1	0	\N
186864	1397	1292235358000	24550	12204	0	0	\N
186790	2132	147600613000	24529	12194	2	0	1388
186791	2134	85489769000	24529	12194	3	0	5085
186792	2134	85488766000	24529	12194	4	0	5086
186793	1397	1292375372000	24531	12195	0	0	14645
186794	2134	85487763000	24531	12195	1	0	5087
186796	2134	85486760000	24532	12196	1	0	5088
186797	1397	1292355370000	24533	12197	0	0	14647
186798	1397	1292345369000	24533	12197	1	0	14648
186799	2134	85485757000	24533	12197	2	0	5089
186800	2132	147599612000	24533	12197	3	0	1389
186802	1397	1292335368000	24534	12198	0	0	14649
186803	1397	1292325367000	24534	12198	1	0	14650
186804	2134	85483751000	24534	12198	2	0	5091
186805	2134	85482748000	24534	12198	3	0	5092
186839	1397	1292305365000	24540	12201	1	0	14652
186840	1397	1292295364000	24540	12201	2	0	14653
186841	1397	1292285363000	24540	12201	3	0	14654
186842	2132	147598611000	24540	12201	4	0	1390
186843	2132	147597610000	24540	12201	5	0	1391
186845	2134	85480742000	24540	12201	7	0	5094
186846	2134	85479739000	24540	12201	8	0	5095
186847	1397	1292275362000	24541	12202	0	0	14655
186848	1397	1292265361000	24541	12202	1	0	14656
186849	2134	85478736000	24541	12202	2	0	5096
186855	1397	1292255360000	24547	12203	0	0	14657
186856	1397	1292245359000	24547	12203	1	0	14658
186857	2134	85476730000	24547	12203	2	0	5098
186858	2134	85475727000	24547	12203	3	0	5099
186860	1397	1292235358000	24548	12204	0	0	14659
186861	2134	85474724000	24548	12204	1	0	5100
186865	2134	85474724000	24550	12204	1	0	\N
186866	1397	1292235358000	24551	12204	0	0	\N
186867	2134	85474724000	24551	12204	1	0	\N
186870	1397	1292225357000	24554	12205	0	0	\N
186871	2134	85473721000	24554	12205	1	0	\N
186877	1397	1292215356000	24556	12206	0	0	\N
186878	1397	1292205355000	24556	12206	1	0	\N
186879	2134	85472718000	24556	12206	2	0	\N
186880	2132	147595608000	24556	12206	3	0	\N
186881	2134	85471715000	24556	12206	4	0	\N
186882	1397	1293625497000	24557	12029	0	0	\N
186883	1397	1293615496000	24557	12029	1	0	\N
186884	1397	1293605495000	24557	12029	2	0	\N
186885	1397	1293595494000	24557	12029	3	0	\N
186886	1397	1293585493000	24557	12029	4	0	\N
186887	1397	1293575492000	24557	12029	5	0	\N
186888	1397	1293565491000	24557	12029	6	0	\N
186889	1397	1293555490000	24557	12029	7	0	\N
186890	1397	1293545489000	24557	12029	8	0	\N
186891	1397	1293535488000	24557	12029	9	0	\N
186892	1397	1293525487000	24557	12029	10	0	\N
186893	1397	1293515486000	24557	12029	11	0	\N
186894	1397	1293505485000	24557	12029	12	0	\N
186895	1397	1293495484000	24557	12029	13	0	\N
186896	1397	1293485483000	24557	12029	14	0	\N
186897	1397	1293475482000	24557	12029	15	0	\N
186898	1397	1293465481000	24557	12029	16	0	\N
186899	1397	1293455480000	24557	12029	17	0	\N
186900	1397	1293445479000	24557	12029	18	0	\N
186901	1397	1293435478000	24557	12029	19	0	\N
186902	1397	1293425477000	24557	12029	20	0	\N
186903	1397	1293415476000	24557	12029	21	0	\N
186904	1397	1293405475000	24557	12029	22	0	\N
186905	1397	1293395474000	24557	12029	23	0	\N
186906	1397	1293385473000	24557	12029	24	0	\N
186907	1397	1293375472000	24557	12029	25	0	\N
186908	1397	1293365471000	24557	12029	26	0	\N
186909	1397	1293355470000	24557	12029	27	0	\N
186910	1397	1293345469000	24557	12029	28	0	\N
186911	1397	1293335468000	24557	12029	29	0	\N
186912	1397	1293325467000	24557	12029	30	0	\N
186913	1397	1293315466000	24557	12029	31	0	\N
186914	1397	1293305465000	24557	12029	32	0	\N
186915	1397	1293295464000	24557	12029	33	0	\N
186916	1397	1293285463000	24557	12029	34	0	\N
186917	1397	1293275462000	24557	12029	35	0	\N
186918	1397	1293265461000	24557	12029	36	0	\N
186919	1397	1293255460000	24557	12029	37	0	\N
186920	1397	1293245459000	24557	12029	38	0	\N
186921	1397	1293235458000	24557	12029	39	0	\N
186922	1397	1293225457000	24557	12029	40	0	\N
186923	1397	1293215456000	24557	12029	41	0	\N
186924	1397	1293205455000	24557	12029	42	0	\N
186925	1397	1293195454000	24557	12029	43	0	\N
186926	1397	1293185453000	24557	12029	44	0	\N
186927	1397	1293175452000	24557	12029	45	0	\N
186928	1397	1293165451000	24557	12029	46	0	\N
186929	1397	1293155450000	24557	12029	47	0	\N
186930	1397	1293145449000	24557	12029	48	0	\N
186931	1397	1293135448000	24557	12029	49	0	\N
186932	1397	1293125447000	24557	12029	50	0	\N
186933	1397	1293115446000	24557	12029	51	0	\N
186934	1397	1293105445000	24557	12029	52	0	\N
186935	1397	1293095444000	24557	12029	53	0	\N
186936	1397	1293085443000	24557	12029	54	0	\N
186937	1397	1293075442000	24557	12029	55	0	\N
186938	1397	1293065441000	24557	12029	56	0	\N
186939	1397	1293055440000	24557	12029	57	0	\N
186940	1397	1293045439000	24557	12029	58	0	\N
186941	1397	1293035438000	24557	12029	59	0	\N
186942	1397	1293025437000	24557	12029	60	0	\N
186943	1397	1293015436000	24557	12029	61	0	\N
186944	1397	1293005435000	24557	12029	62	0	\N
186945	1397	1292995434000	24557	12029	63	0	\N
186946	1397	1292985433000	24557	12029	64	0	\N
186947	1397	1292975432000	24557	12029	65	0	\N
186948	1397	1292965431000	24557	12029	66	0	\N
186949	1397	1292955430000	24557	12029	67	0	\N
186950	1397	1292945429000	24557	12029	68	0	\N
186951	1397	1292935428000	24557	12029	69	0	\N
186952	1397	1292925427000	24557	12029	70	0	\N
186953	1397	1292915426000	24557	12029	71	0	\N
186954	1397	1292905425000	24557	12029	72	0	\N
186955	1397	1292895424000	24557	12029	73	0	\N
186956	1397	1292885423000	24557	12029	74	0	\N
186957	1397	1292875422000	24557	12029	75	0	\N
186958	1397	1292865421000	24557	12029	76	0	\N
186959	1397	1292855420000	24557	12029	77	0	\N
186960	1397	1292845419000	24557	12029	78	0	\N
186961	1397	1292835418000	24557	12029	79	0	\N
186962	1397	1292825417000	24557	12029	80	0	\N
186963	1397	1292815416000	24557	12029	81	0	\N
186964	1397	1292805415000	24557	12029	82	0	\N
186965	1397	1292795414000	24557	12029	83	0	\N
186966	1397	1292785413000	24557	12029	84	0	\N
186967	1397	1292775412000	24557	12029	85	0	\N
186968	1397	1292765411000	24557	12029	86	0	\N
186969	1397	1292755410000	24557	12029	87	0	\N
186970	1397	1292745409000	24557	12029	88	0	\N
186971	1397	1292735408000	24557	12029	89	0	\N
186972	1397	1292725407000	24557	12029	90	0	\N
186973	1397	1292715406000	24557	12029	91	0	\N
186974	1397	1292705405000	24557	12029	92	0	\N
186975	1397	1292695404000	24557	12029	93	0	\N
186976	1397	1292685403000	24557	12029	94	0	\N
186977	1397	1292675402000	24557	12029	95	0	\N
186978	1397	1292665401000	24557	12029	96	0	\N
186979	1397	1292655400000	24557	12029	97	0	\N
186980	1397	1292645399000	24557	12029	98	0	\N
186981	1397	1292635398000	24557	12029	99	0	\N
186982	1397	1292625397000	24557	12029	100	0	\N
186983	1397	1292615396000	24557	12029	101	0	\N
186984	1397	1292605395000	24557	12029	102	0	\N
186985	1397	1292595394000	24557	12029	103	0	\N
186986	1397	1292585393000	24557	12029	104	0	\N
186987	1397	1292575392000	24557	12029	105	0	\N
186988	1397	1292565391000	24557	12029	106	0	\N
186989	1397	1292555390000	24557	12029	107	0	\N
186990	1397	1292545389000	24557	12029	108	0	\N
186991	1397	1292535388000	24557	12029	109	0	\N
186992	1397	1292525387000	24557	12029	110	0	\N
186993	1397	1292515386000	24557	12029	111	0	\N
186994	1397	1292505385000	24557	12029	112	0	\N
186995	1397	1292495384000	24557	12029	113	0	\N
186996	1397	1292485383000	24557	12029	114	0	\N
186997	1397	1292475382000	24557	12029	115	0	\N
186998	1397	1292465381000	24557	12029	116	0	\N
186999	1397	1292455380000	24557	12029	118	0	\N
187000	1397	1292445379000	24557	12029	119	0	\N
186872	1397	1292215356000	24555	12206	0	0	14661
186873	1397	1292205355000	24555	12206	1	0	14662
186874	2134	85472718000	24555	12206	2	0	5102
186875	2132	147595608000	24555	12206	3	0	1393
186876	2134	85471715000	24555	12206	4	0	5103
187001	1397	1292435378000	24557	12029	120	0	\N
187002	1397	1292425377000	24557	12029	121	0	\N
187003	1397	1292415376000	24557	12029	122	0	\N
187004	1397	1292405375000	24557	12029	123	0	\N
187005	1397	1292395374000	24557	12029	124	0	\N
187006	1397	1292385373000	24557	12029	125	0	\N
187012	1397	1292175352000	24560	12209	0	0	\N
187020	1397	1292145349000	24564	12212	0	0	\N
187021	2134	85465697000	24564	12212	1	0	\N
187024	1397	1292135348000	24566	12213	0	0	\N
187025	1397	1292125347000	24566	12213	1	0	\N
187026	2134	85464694000	24566	12213	2	0	\N
187027	2134	85463691000	24566	12213	3	0	\N
187032	1397	1292135348000	24568	12213	0	0	\N
187033	1397	1292125347000	24568	12213	1	0	\N
187034	2134	85464694000	24568	12213	2	0	\N
187035	2134	85463691000	24568	12213	3	0	\N
187036	1397	1292135348000	24569	12213	0	0	\N
187037	1397	1292125347000	24569	12213	1	0	\N
187038	2134	85464694000	24569	12213	2	0	\N
187039	2134	85463691000	24569	12213	3	0	\N
187040	1397	1292135348000	24570	12213	0	0	\N
187041	1397	1292125347000	24570	12213	1	0	\N
187042	2134	85464694000	24570	12213	2	0	\N
187043	2134	85463691000	24570	12213	3	0	\N
187047	1397	1292105345000	24572	12215	0	0	\N
187048	1397	1292095344000	24572	12215	1	0	\N
187049	1397	1292085343000	24572	12215	2	0	\N
187050	1397	1292075342000	24572	12215	3	0	\N
187051	2134	85461685000	24572	12215	4	0	\N
187052	2134	85460682000	24572	12215	5	0	\N
187053	2134	85459679000	24572	12215	6	0	\N
187054	2134	85458676000	24572	12215	7	0	\N
187055	2132	147591604000	24572	12215	8	0	\N
187065	1397	1292065341000	24574	12216	0	0	\N
187066	2134	85457673000	24574	12216	1	0	\N
187072	1397	1292055340000	24577	12217	0	0	\N
187073	2132	147590603000	24577	12217	1	0	\N
187074	2134	85456670000	24577	12217	2	0	\N
187099	1397	1291975332000	24583	12222	0	0	\N
187100	1397	1291965331000	24583	12222	1	0	\N
187101	1397	1291955330000	24583	12222	2	0	\N
187102	2134	85448646000	24583	12222	3	0	\N
187103	2132	147587600000	24583	12222	4	0	\N
187104	2134	85447643000	24583	12222	6	0	\N
187105	2134	85446640000	24583	12222	7	0	\N
187106	1397	1291975332000	24584	12222	0	0	\N
187107	1397	1291965331000	24584	12222	1	0	\N
187108	1397	1291955330000	24584	12222	2	0	\N
187109	2134	85448646000	24584	12222	3	0	\N
187110	2132	147587600000	24584	12222	4	0	\N
187111	2134	85447643000	24584	12222	6	0	\N
187112	2134	85446640000	24584	12222	7	0	\N
187113	1397	1291975332000	24585	12222	0	0	\N
187114	1397	1291965331000	24585	12222	1	0	\N
187115	1397	1291955330000	24585	12222	2	0	\N
187116	2134	85448646000	24585	12222	3	0	\N
187117	2132	147587600000	24585	12222	4	0	\N
187118	2134	85447643000	24585	12222	6	0	\N
187119	2134	85446640000	24585	12222	7	0	\N
187120	1397	1291975332000	24586	12222	0	0	\N
187121	1397	1291965331000	24586	12222	1	0	\N
187122	1397	1291955330000	24586	12222	2	0	\N
187123	2134	85448646000	24586	12222	3	0	\N
187124	2132	147587600000	24586	12222	4	0	\N
187125	2134	85447643000	24586	12222	6	0	\N
187126	2134	85446640000	24586	12222	7	0	\N
187127	1397	1291975332000	24587	12222	0	0	\N
187128	1397	1291965331000	24587	12222	1	0	\N
187129	1397	1291955330000	24587	12222	2	0	\N
187130	2134	85448646000	24587	12222	3	0	\N
187131	2132	147587600000	24587	12222	4	0	\N
187132	2134	85447643000	24587	12222	6	0	\N
187133	2134	85446640000	24587	12222	7	0	\N
187136	1397	1291945329000	24589	12223	0	0	\N
187009	1397	1292185353000	24559	12208	0	0	14664
187010	2132	147594607000	24559	12208	1	0	1394
187011	2134	85469709000	24559	12208	2	0	5105
187013	1397	1292175352000	24561	12209	0	0	14665
187014	2134	85468706000	24561	12209	1	0	5106
187016	2134	85467703000	24562	12210	1	0	5107
187017	1397	1292155350000	24563	12211	0	0	14667
187018	2132	147593606000	24563	12211	1	0	1395
187019	2134	85466700000	24563	12211	2	0	5108
187022	1397	1292145349000	24565	12212	0	0	14668
187028	1397	1292135348000	24567	12213	0	0	14669
187029	1397	1292125347000	24567	12213	1	0	14670
187030	2134	85464694000	24567	12213	2	0	5110
187031	2134	85463691000	24567	12213	3	0	5111
187045	2132	147592605000	24571	12214	1	0	1396
187046	2134	85462688000	24571	12214	2	0	5112
187056	1397	1292105345000	24573	12215	0	0	14672
187057	1397	1292095344000	24573	12215	1	0	14673
187058	1397	1292085343000	24573	12215	2	0	14674
187060	2134	85461685000	24573	12215	4	0	5113
187061	2134	85460682000	24573	12215	5	0	5114
187062	2134	85459679000	24573	12215	6	0	5115
187063	2134	85458676000	24573	12215	7	0	5116
187064	2132	147591604000	24573	12215	8	0	1397
187068	2134	85457673000	24575	12216	1	0	5117
187069	1397	1292055340000	24576	12217	0	0	14677
187070	2132	147590603000	24576	12217	1	0	1398
187071	2134	85456670000	24576	12217	2	0	5118
187076	2134	85455667000	24578	12218	1	0	5119
187077	1397	1292035338000	24579	12219	0	0	14679
187078	2134	85454664000	24579	12219	1	0	5120
187079	1715	20651063224631	24580	12220	0	0	10
187080	1397	1292025337000	24580	12220	1	0	14680
187082	1397	1292005335000	24580	12220	3	0	14682
187083	2132	147589602000	24580	12220	4	0	1399
187084	2134	85453661000	24580	12220	5	0	5121
187085	2134	85452658000	24580	12220	6	0	5122
187086	2134	85451655000	24580	12220	7	0	5123
187088	1397	1291985333000	24581	12221	1	0	14684
187089	2134	85450652000	24581	12221	2	0	5124
187090	2134	85449649000	24581	12221	3	0	5125
187091	2132	147588601000	24581	12221	4	0	1400
187093	1397	1291965331000	24582	12222	1	0	14686
187094	1397	1291955330000	24582	12222	2	0	14687
187095	2134	85448646000	24582	12222	3	0	5126
187096	2132	147587600000	24582	12222	4	0	1401
187097	2134	85447643000	24582	12222	6	0	5127
187134	1397	1291945329000	24588	12223	0	0	14688
187135	2134	85445637000	24588	12223	1	0	5129
187137	2134	85445637000	24589	12223	1	0	\N
187144	1397	1291905325000	24592	12225	0	0	\N
187145	1397	1291895324000	24592	12225	1	0	\N
187146	1397	1291885323000	24592	12225	2	0	\N
187147	2134	85442628000	24592	12225	3	0	\N
187148	2132	147585598000	24592	12225	4	0	\N
187149	2134	85441625000	24592	12225	5	0	\N
187150	2134	85440622000	24592	12225	6	0	\N
187151	1397	1291905325000	24593	12225	0	0	\N
187152	1397	1291895324000	24593	12225	1	0	\N
187153	1397	1291885323000	24593	12225	2	0	\N
187154	2134	85442628000	24593	12225	3	0	\N
187155	2132	147585598000	24593	12225	4	0	\N
187156	2134	85441625000	24593	12225	5	0	\N
187157	2134	85440622000	24593	12225	6	0	\N
187165	1397	1291875322000	24595	12226	0	0	\N
187166	2134	85439619000	24595	12226	1	0	\N
187169	1397	1291865321000	24597	12227	0	0	\N
187170	2134	85438616000	24597	12227	1	0	\N
187173	2134	85438616000	24599	12227	0	0	\N
187174	1397	1291855320000	24600	12228	0	0	\N
187175	2134	85437613000	24600	12228	1	0	\N
187176	2132	147584597000	24600	12228	2	0	\N
187183	1397	1291845319000	24603	12229	0	0	\N
187184	1588	31681760000000	24603	12229	1	0	\N
187185	2134	85436610000	24603	12229	2	0	\N
187186	1397	1291835318000	24604	12230	0	0	\N
187187	2134	85435607000	24604	12230	1	0	\N
187197	1397	1291805315000	24607	12232	0	0	\N
187198	2134	85432598000	24607	12232	1	0	\N
187199	2133	92020682000	24607	12232	2	0	\N
187203	1397	1291805315000	24609	12232	0	0	\N
187204	2134	85432598000	24609	12232	1	0	\N
187205	2133	92020682000	24609	12232	2	0	\N
187206	1397	1291805315000	24610	12232	0	0	\N
187207	2134	85432598000	24610	12232	1	0	\N
187208	2133	92020682000	24610	12232	2	0	\N
187209	1397	1291805315000	24611	12232	0	0	\N
187210	2134	85432598000	24611	12232	1	0	\N
187211	2133	92020682000	24611	12232	2	0	\N
187212	1397	1291805315000	24612	12232	0	0	\N
187213	2134	85432598000	24612	12232	1	0	\N
187214	2133	92020682000	24612	12232	2	0	\N
187215	1397	1291795314000	24613	12233	0	0	\N
187216	2133	92019680000	24613	12233	1	0	\N
187217	2134	85431595000	24613	12233	2	0	\N
187218	1397	1291795314000	24614	12233	0	0	\N
187219	2133	92019680000	24614	12233	1	0	\N
187220	2134	85431595000	24614	12233	2	0	\N
187224	2133	92019680000	24616	12233	0	0	\N
187225	2134	85431595000	24616	12233	1	0	\N
187243	1397	1291785313000	24618	12234	0	0	\N
187244	1397	1291775312000	24618	12234	1	0	\N
187245	1397	1291765311000	24618	12234	2	0	\N
187246	1397	1291755310000	24618	12234	3	0	\N
187247	1397	1291745309000	24618	12234	4	0	\N
187248	2134	85430592000	24618	12234	5	0	\N
187249	2132	147582595000	24618	12234	6	0	\N
187250	2132	147581594000	24618	12234	7	0	\N
187251	2134	85429589000	24618	12234	8	0	\N
187252	2134	85428586000	24618	12234	9	0	\N
187253	2134	85427583000	24618	12234	10	0	\N
187254	2134	85426580000	24618	12234	11	0	\N
187255	2133	92018678000	24618	12234	12	0	\N
187256	2133	92017676000	24618	12234	13	0	\N
187257	2133	92016674000	24618	12234	14	0	\N
187258	2133	92015672000	24618	12234	15	0	\N
187259	2133	92014670000	24618	12234	16	0	\N
187263	1397	1291735308000	24620	12235	0	0	\N
187264	2134	85425577000	24620	12235	1	0	\N
187265	2133	92013668000	24620	12235	2	0	\N
187266	1397	1291725307000	24621	12236	0	0	\N
187267	2133	92012666000	24621	12236	1	0	\N
187268	2134	85424574000	24621	12236	2	0	\N
187269	1715	19211041224631	24622	12110	0	0	\N
187270	1601	8800843620000	24622	12110	1	0	\N
187271	1601	6644833620000	24622	12110	2	0	\N
187272	1601	5189823620000	24622	12110	3	0	\N
187140	1397	1291915326000	24590	12224	2	0	14691
187141	2134	85444634000	24590	12224	3	0	5130
187142	2134	85443631000	24590	12224	4	0	5131
187143	2132	147586599000	24590	12224	5	0	1402
187158	1397	1291905325000	24594	12225	0	0	14692
187160	1397	1291885323000	24594	12225	2	0	14694
187161	2134	85442628000	24594	12225	3	0	5132
187162	2132	147585598000	24594	12225	4	0	1403
187163	2134	85441625000	24594	12225	5	0	5133
187164	2134	85440622000	24594	12225	6	0	5134
187168	2134	85439619000	24596	12226	1	0	5135
187171	1397	1291865321000	24598	12227	0	0	14696
187172	2134	85438616000	24598	12227	1	0	5136
187177	1397	1291855320000	24601	12228	0	0	14697
187179	2132	147584597000	24601	12228	2	0	1404
187180	1397	1291845319000	24602	12229	0	0	14698
187181	1588	31681760000000	24602	12229	1	0	7
187182	2134	85436610000	24602	12229	2	0	5138
187188	1397	1291835318000	24605	12230	0	0	14699
187190	1397	1291825317000	24606	12231	0	0	14700
187191	1397	1291815316000	24606	12231	1	0	14701
187192	2133	92022686000	24606	12231	2	0	4659
187193	2132	147583596000	24606	12231	3	0	1405
187194	2134	85434604000	24606	12231	4	0	5140
187196	2133	92021684000	24606	12231	6	0	4660
187200	1397	1291805315000	24608	12232	0	0	14702
187201	2134	85432598000	24608	12232	1	0	5142
187202	2133	92020682000	24608	12232	2	0	4661
187222	2133	92019680000	24615	12233	1	0	4662
187223	2134	85431595000	24615	12233	2	0	5143
187226	1397	1291785313000	24617	12234	0	0	14704
187227	1397	1291775312000	24617	12234	1	0	14705
187228	1397	1291765311000	24617	12234	2	0	14706
187230	1397	1291745309000	24617	12234	4	0	14708
187231	2134	85430592000	24617	12234	5	0	5144
187232	2132	147582595000	24617	12234	6	0	1406
187233	2132	147581594000	24617	12234	7	0	1407
187234	2134	85429589000	24617	12234	8	0	5145
187236	2134	85427583000	24617	12234	10	0	5147
187237	2134	85426580000	24617	12234	11	0	5148
187238	2133	92018678000	24617	12234	12	0	4663
187239	2133	92017676000	24617	12234	13	0	4664
187241	2133	92015672000	24617	12234	15	0	4666
187242	2133	92014670000	24617	12234	16	0	4667
187260	1397	1291735308000	24619	12235	0	0	14709
187261	2134	85425577000	24619	12235	1	0	5149
187262	2133	92013668000	24619	12235	2	0	4668
187273	1601	3985813620000	24622	12110	4	0	\N
187274	1588	30961698000000	24622	12110	5	0	\N
187275	1397	1291725307000	24623	12236	0	0	\N
187276	2133	92012666000	24623	12236	1	0	\N
187277	2134	85424574000	24623	12236	2	0	\N
187278	1397	1291725307000	24624	12236	0	0	\N
187279	2133	92012666000	24624	12236	1	0	\N
187280	1397	1291725307000	24625	12236	0	0	\N
187281	2133	92012666000	24625	12236	1	0	\N
187282	2134	85424574000	24625	12236	2	0	\N
187300	1397	1291685303000	24629	12239	0	0	\N
187301	2134	85419559000	24629	12239	1	0	\N
187302	2133	92007656000	24629	12239	2	0	\N
187303	1397	1291685303000	24630	12239	0	0	\N
187304	2134	85419559000	24630	12239	1	0	\N
187305	2133	92007656000	24630	12239	2	0	\N
187306	1397	1291685303000	24631	12239	0	0	\N
187307	2134	85419559000	24631	12239	1	0	\N
187308	2133	92007656000	24631	12239	2	0	\N
187322	1397	1291655300000	24635	12241	0	0	\N
187323	2133	92004650000	24635	12241	2	0	\N
187324	2132	147578591000	24635	12241	3	0	\N
187325	2134	85417553000	24635	12241	4	0	\N
187326	1397	1291655300000	24636	12241	0	0	\N
187327	2133	92004650000	24636	12241	2	0	\N
187328	2132	147578591000	24636	12241	3	0	\N
187329	2134	85417553000	24636	12241	4	0	\N
187330	1397	1291655300000	24637	12241	0	0	\N
187331	2133	92004650000	24637	12241	2	0	\N
187332	2132	147578591000	24637	12241	3	0	\N
187333	2134	85417553000	24637	12241	4	0	\N
187334	1397	1291655300000	24638	12241	0	0	\N
187335	2133	92004650000	24638	12241	2	0	\N
187336	2132	147578591000	24638	12241	3	0	\N
187337	2134	85417553000	24638	12241	4	0	\N
187338	1467	17088711371984	24639	12242	0	0	\N
187339	1467	12934295866644	24639	12242	1	0	\N
187340	1397	1291645299000	24639	12242	2	0	\N
187341	1467	10131225689819	24639	12242	3	0	\N
187342	1467	2320239272869	24639	12242	4	0	\N
187343	1467	2320229272869	24639	12242	5	0	\N
187344	2134	85416550000	24639	12242	6	0	\N
187345	2133	92003648000	24639	12242	7	0	\N
187354	1467	17088711371984	24641	12242	0	0	\N
187355	1467	12934295866644	24641	12242	1	0	\N
187356	1397	1291645299000	24641	12242	2	0	\N
187357	1467	10131225689819	24641	12242	3	0	\N
187358	1467	2320239272869	24641	12242	4	0	\N
187359	1467	2320229272869	24641	12242	5	0	\N
187360	2134	85416550000	24641	12242	6	0	\N
187361	2133	92003648000	24641	12242	7	0	\N
187362	1467	17088711371984	24642	12242	0	0	\N
187363	1467	12934295866644	24642	12242	1	0	\N
187364	1397	1291645299000	24642	12242	2	0	\N
187365	1467	10131225689819	24642	12242	3	0	\N
187366	1467	2320239272869	24642	12242	4	0	\N
187367	1467	2320229272869	24642	12242	5	0	\N
187368	2134	85416550000	24642	12242	6	0	\N
187369	2133	92003648000	24642	12242	7	0	\N
187370	1451	12073037000000	24643	12115	0	0	\N
187371	1715	19211041224631	24643	12115	1	0	\N
187372	1715	18955184013166	24643	12115	2	0	\N
187373	1715	18699326801701	24643	12115	3	0	\N
187374	1451	7824937000000	24643	12115	4	0	\N
187375	1451	4958837000000	24643	12115	5	0	\N
187376	1451	2587737000000	24643	12115	6	0	\N
187377	1601	8800843620000	24643	12115	7	0	\N
187378	1467	17088711371984	24643	12115	8	0	\N
187379	1467	12934295866644	24643	12115	9	0	\N
187380	114	66043463685762	24643	12115	10	0	\N
187381	1601	6644833620000	24643	12115	11	0	\N
187382	1601	5189823620000	24643	12115	12	0	\N
187383	1601	3985813620000	24643	12115	13	0	\N
187384	1588	30961698000000	24643	12115	14	0	\N
187385	1397	1293495484000	24643	12115	15	0	\N
187386	1467	10131225689819	24643	12115	16	0	\N
187387	1467	2320239272869	24643	12115	17	0	\N
187388	1397	1293485483000	24643	12115	18	0	\N
187389	1397	1293475482000	24643	12115	19	0	\N
187390	1397	1293465481000	24643	12115	20	0	\N
187391	1397	1293455480000	24643	12115	21	0	\N
187392	1397	1293445479000	24643	12115	22	0	\N
187393	1397	1293435478000	24643	12115	23	0	\N
187394	1397	1293425477000	24643	12115	24	0	\N
187395	1397	1293415476000	24643	12115	25	0	\N
187396	1397	1293405475000	24643	12115	26	0	\N
187397	1397	1293395474000	24643	12115	27	0	\N
187398	1397	1293385473000	24643	12115	28	0	\N
187399	1397	1293375472000	24643	12115	29	0	\N
187400	1397	1293365471000	24643	12115	30	0	\N
187401	1397	1293355470000	24643	12115	31	0	\N
187402	1397	1293345469000	24643	12115	32	0	\N
187403	1397	1293335468000	24643	12115	33	0	\N
187404	1397	1293325467000	24643	12115	34	0	\N
187405	1397	1293315466000	24643	12115	35	0	\N
187406	1397	1293305465000	24643	12115	36	0	\N
187407	1397	1293295464000	24643	12115	37	0	\N
187408	1397	1293285463000	24643	12115	38	0	\N
187285	2134	85424574000	24626	12236	2	0	5150
187286	1397	1291715306000	24627	12237	0	0	14711
187287	2133	92011664000	24627	12237	1	0	4670
187288	2134	85423571000	24627	12237	2	0	5151
187289	2132	147580593000	24627	12237	3	0	1408
187291	1397	1291705305000	24628	12238	1	0	14712
187292	1397	1291695304000	24628	12238	2	0	14713
187293	2134	85422568000	24628	12238	3	0	5152
187294	2133	92010662000	24628	12238	4	0	4671
187295	2133	92009660000	24628	12238	5	0	4672
187297	2132	147579592000	24628	12238	7	0	1409
187298	2134	85421565000	24628	12238	8	0	5153
187299	2134	85420562000	24628	12238	9	0	5154
187309	1397	1291685303000	24632	12239	0	0	14714
187311	2133	92007656000	24632	12239	2	0	4674
187312	1715	20139348801701	24633	12240	0	0	12
187313	1397	1291675302000	24633	12240	1	0	14715
187314	1397	1291665301000	24633	12240	2	0	14716
187315	2134	85418556000	24633	12240	3	0	5156
187317	2133	92005652000	24633	12240	5	0	4676
187318	1397	1291655300000	24634	12241	0	0	14717
187319	2133	92004650000	24634	12241	2	0	4677
187320	2132	147578591000	24634	12241	3	0	1410
187321	2134	85417553000	24634	12241	4	0	5157
187347	1467	12934295866644	24640	12242	1	0	6
187348	1397	1291645299000	24640	12242	2	0	14718
187349	1467	10131225689819	24640	12242	3	0	7
187350	1467	2320239272869	24640	12242	4	0	8
187352	2134	85416550000	24640	12242	6	0	5158
187353	2133	92003648000	24640	12242	7	0	4678
187409	1397	1293275462000	24643	12115	39	0	\N
187410	1397	1293265461000	24643	12115	40	0	\N
187411	1397	1293255460000	24643	12115	41	0	\N
187412	1397	1293245459000	24643	12115	42	0	\N
187413	1397	1293235458000	24643	12115	43	0	\N
187414	1397	1293225457000	24643	12115	44	0	\N
187415	1397	1293215456000	24643	12115	45	0	\N
187416	1397	1293205455000	24643	12115	46	0	\N
187417	1397	1293195454000	24643	12115	47	0	\N
187418	1397	1293185453000	24643	12115	48	0	\N
187419	1397	1293175452000	24643	12115	49	0	\N
187420	1397	1293165451000	24643	12115	50	0	\N
187421	1397	1293155450000	24643	12115	51	0	\N
187422	1397	1293145449000	24643	12115	52	0	\N
187423	1397	1293135448000	24643	12115	53	0	\N
187424	1397	1293125447000	24643	12115	54	0	\N
187425	1397	1293115446000	24643	12115	55	0	\N
187426	1397	1293105445000	24643	12115	56	0	\N
187427	1397	1293095444000	24643	12115	57	0	\N
187428	1397	1293085443000	24643	12115	58	0	\N
187429	1397	1293075442000	24643	12115	59	0	\N
187430	1397	1293065441000	24643	12115	60	0	\N
187431	1397	1293055440000	24643	12115	61	0	\N
187432	1397	1293045439000	24643	12115	62	0	\N
187433	1397	1293035438000	24643	12115	63	0	\N
187434	1397	1293025437000	24643	12115	64	0	\N
187435	1397	1293015436000	24643	12115	66	0	\N
187436	1397	1293005435000	24643	12115	67	0	\N
187437	1397	1292995434000	24643	12115	68	0	\N
187438	1397	1292985433000	24643	12115	69	0	\N
187439	1397	1292975432000	24643	12115	70	0	\N
187440	1397	1292965431000	24643	12115	71	0	\N
187441	1397	1292955430000	24643	12115	72	0	\N
187442	1397	1292945429000	24643	12115	73	0	\N
187443	1397	1292935428000	24643	12115	74	0	\N
187444	1397	1292925427000	24643	12115	75	0	\N
187445	1397	1292915426000	24643	12115	76	0	\N
187446	1397	1292905425000	24643	12115	77	0	\N
187447	1397	1292895424000	24643	12115	78	0	\N
187448	1397	1292885423000	24643	12115	79	0	\N
187449	1397	1292875422000	24643	12115	80	0	\N
187450	1397	1292865421000	24643	12115	81	0	\N
187451	1397	1292855420000	24643	12115	82	0	\N
187452	1397	1292845419000	24643	12115	83	0	\N
187453	1397	1292835418000	24643	12115	84	0	\N
187454	1397	1292825417000	24643	12115	85	0	\N
187455	1397	1292815416000	24643	12115	86	0	\N
187456	1397	1292805415000	24643	12115	87	0	\N
187457	1397	1292795414000	24643	12115	88	0	\N
187458	1397	1292785413000	24643	12115	89	0	\N
187459	1397	1292775412000	24643	12115	90	0	\N
187460	1397	1292765411000	24643	12115	91	0	\N
187461	1397	1292755410000	24643	12115	92	0	\N
187462	1397	1292745409000	24643	12115	93	0	\N
187463	1397	1292735408000	24643	12115	94	0	\N
187464	1397	1292725407000	24643	12115	95	0	\N
187465	1397	1292715406000	24643	12115	96	0	\N
187466	1397	1292705405000	24643	12115	97	0	\N
187467	1397	1292695404000	24643	12115	98	0	\N
187468	1397	1292685403000	24643	12115	99	0	\N
187469	1397	1292675402000	24643	12115	100	0	\N
187470	1397	1292665401000	24643	12115	101	0	\N
187471	1397	1292655400000	24643	12115	102	0	\N
187472	1397	1292645399000	24643	12115	103	0	\N
187473	1397	1292635398000	24643	12115	104	0	\N
187474	1397	1292625397000	24643	12115	105	0	\N
187475	1397	1292615396000	24643	12115	106	0	\N
187476	1397	1292605395000	24643	12115	107	0	\N
187477	1397	1292595394000	24643	12115	108	0	\N
187478	1397	1292585393000	24643	12115	109	0	\N
187479	1397	1292575392000	24643	12115	110	0	\N
187480	1397	1292565391000	24643	12115	111	0	\N
187481	1397	1292555390000	24643	12115	112	0	\N
187482	1397	1292545389000	24643	12115	113	0	\N
187483	1397	1292535388000	24643	12115	114	0	\N
187484	1397	1292525387000	24643	12115	115	0	\N
187485	1397	1292515386000	24643	12115	116	0	\N
187486	1397	1292505385000	24643	12115	117	0	\N
187487	1397	1292495384000	24643	12115	118	0	\N
187488	1397	1292485383000	24643	12115	119	0	\N
187489	1397	1292475382000	24643	12115	120	0	\N
187490	1397	1292465381000	24643	12115	121	0	\N
187491	1397	1292455380000	24643	12115	122	0	\N
187492	1397	1292445379000	24643	12115	123	0	\N
187493	1397	1292435378000	24643	12115	124	0	\N
187494	1397	1292425377000	24643	12115	125	0	\N
187495	1715	18289204689316	24644	12243	0	0	\N
187496	1397	1291635298000	24644	12243	1	0	\N
187497	2133	92002646000	24644	12243	2	0	\N
187498	2134	85415547000	24644	12243	3	0	\N
187503	1715	18289204689316	24646	12243	0	0	\N
187504	1397	1291635298000	24646	12243	1	0	\N
187505	2133	92002646000	24646	12243	2	0	\N
187506	2134	85415547000	24646	12243	3	0	\N
187507	1397	1291625297000	24647	12244	0	0	\N
187508	2134	85414544000	24647	12244	1	0	\N
187509	2132	147577590000	24647	12244	2	0	\N
187510	2133	92001644000	24647	12244	3	0	\N
187511	1397	1291625297000	24648	12244	0	0	\N
187512	2134	85414544000	24648	12244	1	0	\N
187513	2132	147577590000	24648	12244	2	0	\N
187514	2133	92001644000	24648	12244	3	0	\N
187515	1397	1291625297000	24649	12244	0	0	\N
187516	2134	85414544000	24649	12244	1	0	\N
187517	2132	147577590000	24649	12244	2	0	\N
187518	2133	92001644000	24649	12244	3	0	\N
187523	1715	14973841491090	24651	12245	0	0	\N
187524	1397	1291615296000	24651	12245	1	0	\N
187525	2133	92000642000	24651	12245	2	0	\N
187526	2134	85413541000	24651	12245	3	0	\N
187531	1715	14973841491090	24653	12245	0	0	\N
187532	1397	1291615296000	24653	12245	1	0	\N
187533	2133	92000642000	24653	12245	2	0	\N
187534	2134	85413541000	24653	12245	3	0	\N
187535	1715	14973841491090	24654	12245	0	0	\N
187536	1397	1291615296000	24654	12245	1	0	\N
187537	2133	92000642000	24654	12245	2	0	\N
187538	2134	85413541000	24654	12245	3	0	\N
187501	2133	92002646000	24645	12243	2	0	4679
187502	2134	85415547000	24645	12243	3	0	5159
187519	1397	1291625297000	24650	12244	0	0	14720
187520	2134	85414544000	24650	12244	1	0	5160
187521	2132	147577590000	24650	12244	2	0	1411
187527	1715	14973841491090	24652	12245	0	0	14
187528	1397	1291615296000	24652	12245	1	0	14721
187529	2133	92000642000	24652	12245	2	0	4681
187530	2134	85413541000	24652	12245	3	0	5161
187539	1715	12736867349966	24655	12246	0	0	15
187541	1397	1291605295000	24655	12246	2	0	14722
187542	1397	1291595294000	24655	12246	3	0	14723
187543	2133	91999640000	24655	12246	4	0	4682
187544	2133	91998638000	24655	12246	5	0	4683
187548	1397	1291585293000	24656	12247	0	0	\N
187549	2133	91997636000	24656	12247	1	0	\N
187550	2134	85410532000	24656	12247	2	0	\N
187557	1397	1291575292000	24659	12248	0	0	\N
187558	2134	85409529000	24659	12248	1	0	\N
187559	2133	91996634000	24659	12248	2	0	\N
187563	1397	1291555290000	24661	12250	0	0	\N
187564	2134	85407523000	24661	12250	1	0	\N
187565	2132	147575588000	24661	12250	2	0	\N
187566	2133	91994630000	24661	12250	3	0	\N
187567	1397	1291555290000	24662	12250	0	0	\N
187568	2134	85407523000	24662	12250	1	0	\N
187569	2132	147575588000	24662	12250	2	0	\N
187570	2133	91994630000	24662	12250	3	0	\N
187575	1397	1291555290000	24664	12250	0	0	\N
187576	2134	85407523000	24664	12250	1	0	\N
187577	2132	147575588000	24664	12250	2	0	\N
187578	2133	91994630000	24664	12250	3	0	\N
187579	2133	91993628000	24665	12251	0	0	\N
187582	1397	1291545289000	24667	12251	0	0	\N
187583	2133	91993628000	24667	12251	1	0	\N
187584	1397	1291535288000	24668	12252	0	0	\N
187585	2134	85406520000	24668	12252	1	0	\N
187586	2133	91992626000	24668	12252	2	0	\N
187594	1397	1291525287000	24671	12253	0	0	\N
187595	2132	147574587000	24671	12253	1	0	\N
187596	2134	85405517000	24671	12253	2	0	\N
187597	2133	91991624000	24671	12253	3	0	\N
187598	1397	1291525287000	24672	12253	0	0	\N
187599	2132	147574587000	24672	12253	1	0	\N
187600	2134	85405517000	24672	12253	2	0	\N
187601	2133	91991624000	24672	12253	3	0	\N
187617	1397	1291475282000	24676	12256	0	0	\N
187618	2134	85400502000	24676	12256	1	0	\N
187619	2133	91986614000	24676	12256	2	0	\N
187620	1673	12361978000000	24676	12256	3	0	\N
187647	1397	1291435278000	24682	12260	0	0	\N
187648	1397	1291425277000	24682	12260	1	0	\N
187649	1397	1291415276000	24682	12260	2	0	\N
187650	2132	147571584000	24682	12260	3	0	\N
187651	1673	8861976000000	24682	12260	4	0	\N
187652	2134	85396490000	24682	12260	6	0	\N
187653	2134	85395487000	24682	12260	7	0	\N
187654	2134	85394484000	24682	12260	8	0	\N
187655	2133	91982606000	24682	12260	9	0	\N
187656	2133	91981604000	24682	12260	10	0	\N
187657	2133	91980602000	24682	12260	11	0	\N
187661	1397	1291395274000	24684	12262	0	0	\N
187662	1397	1291385273000	24684	12262	1	0	\N
187663	1397	1291375272000	24684	12262	2	0	\N
187664	2132	147570583000	24684	12262	3	0	\N
187665	2133	91978598000	24684	12262	4	0	\N
187666	2133	91977596000	24684	12262	5	0	\N
187667	2133	91976594000	24684	12262	6	0	\N
187668	2134	85392478000	24684	12262	7	0	\N
187669	2134	85391475000	24684	12262	8	0	\N
187670	2134	85390472000	24684	12262	9	0	\N
187671	1397	1291395274000	24685	12262	0	0	\N
187672	1397	1291385273000	24685	12262	1	0	\N
187673	1397	1291375272000	24685	12262	2	0	\N
187674	2132	147570583000	24685	12262	3	0	\N
187675	2133	91978598000	24685	12262	4	0	\N
187676	2133	91977596000	24685	12262	5	0	\N
187677	2133	91976594000	24685	12262	6	0	\N
187678	2134	85392478000	24685	12262	7	0	\N
187679	2134	85391475000	24685	12262	8	0	\N
187680	2134	85390472000	24685	12262	9	0	\N
187547	2132	147576589000	24655	12246	8	0	1412
187551	1397	1291585293000	24657	12247	0	0	14724
187552	2133	91997636000	24657	12247	1	0	4684
187553	2134	85410532000	24657	12247	2	0	5164
187554	1397	1291575292000	24658	12248	0	0	14725
187556	2133	91996634000	24658	12248	2	0	4685
187560	1397	1291565291000	24660	12249	0	0	14726
187561	2133	91995632000	24660	12249	1	0	4686
187562	2134	85408526000	24660	12249	2	0	5166
187571	1397	1291555290000	24663	12250	0	0	14727
187573	2132	147575588000	24663	12250	2	0	1413
187574	2133	91994630000	24663	12250	3	0	4687
187580	1397	1291545289000	24666	12251	0	0	14728
187581	2133	91993628000	24666	12251	1	0	4688
187588	2134	85406520000	24669	12252	1	0	5168
187589	2133	91992626000	24669	12252	2	0	4689
187590	1397	1291525287000	24670	12253	0	0	14730
187591	2132	147574587000	24670	12253	1	0	1414
187592	2134	85405517000	24670	12253	2	0	5169
187602	1397	1291515286000	24673	12254	0	0	14731
187603	1397	1291505285000	24673	12254	1	0	14732
187604	1397	1291495284000	24673	12254	2	0	14733
187605	1673	22226300000000	24673	12254	3	0	13
187606	2132	147573586000	24673	12254	4	0	1415
187608	2134	85404514000	24673	12254	6	0	5170
187609	2134	85403511000	24673	12254	7	0	5171
187610	2134	85402508000	24673	12254	8	0	5172
187611	2133	91990622000	24673	12254	9	0	4691
187613	2133	91988618000	24673	12254	11	0	4693
187614	1397	1291485283000	24675	12255	0	0	14734
187615	2134	85401505000	24675	12255	1	0	5173
187616	2133	91987616000	24675	12255	2	0	4694
187621	1397	1291475282000	24677	12256	0	0	14735
187623	2133	91986614000	24677	12256	2	0	4695
187624	1673	12361978000000	24677	12256	3	0	15
187625	1397	1291465281000	24678	12257	0	0	14736
187626	2133	91985612000	24678	12257	1	0	4696
187627	2134	85399499000	24678	12257	2	0	5175
187629	2132	147572585000	24679	12258	1	0	1416
187630	1673	9075057000000	24679	12258	2	0	16
187631	2134	85398496000	24679	12258	3	0	5176
187632	2133	91984610000	24679	12258	4	0	4697
187634	2134	85397493000	24680	12259	1	0	5177
187635	2133	91983608000	24680	12259	2	0	4698
187636	1397	1291435278000	24681	12260	0	0	14739
187637	1397	1291425277000	24681	12260	1	0	14740
187638	1397	1291415276000	24681	12260	2	0	14741
187640	1673	8861976000000	24681	12260	4	0	17
187641	2134	85396490000	24681	12260	6	0	5178
187642	2134	85395487000	24681	12260	7	0	5179
187643	2134	85394484000	24681	12260	8	0	5180
187644	2133	91982606000	24681	12260	9	0	4699
187646	2133	91980602000	24681	12260	11	0	4701
187658	1397	1291405275000	24683	12261	0	0	14742
187659	2133	91979600000	24683	12261	1	0	4702
187660	2134	85393481000	24683	12261	2	0	5181
187691	1397	1291365271000	24687	12263	0	0	\N
187692	2134	85389469000	24687	12263	1	0	\N
187693	2133	91975592000	24687	12263	2	0	\N
187694	1673	8855435000000	24687	12263	3	0	\N
187695	1673	22226300000000	24688	12254	0	0	\N
187696	1673	16336169000000	24688	12254	1	0	\N
187697	1673	12361978000000	24688	12254	2	0	\N
187702	1397	1291365271000	24690	12263	0	0	\N
187703	2134	85389469000	24690	12263	1	0	\N
187704	2133	91975592000	24690	12263	2	0	\N
187705	1673	8855435000000	24690	12263	3	0	\N
187710	1397	1291345269000	24692	12265	0	0	\N
187711	1397	1291335268000	24692	12265	1	0	\N
187712	2133	91973588000	24692	12265	2	0	\N
187713	2133	91972586000	24692	12265	3	0	\N
187714	2134	85387463000	24692	12265	4	0	\N
187715	2134	85386460000	24692	12265	5	0	\N
187722	1693	15721176330507	24694	12266	0	0	\N
187723	1397	1291325267000	24694	12266	1	0	\N
187724	1693	15645343568530	24694	12266	2	0	\N
187725	2132	147568581000	24694	12266	3	0	\N
187726	2133	91971584000	24694	12266	4	0	\N
187727	1693	15721176330507	24695	12266	0	0	\N
187728	1397	1291325267000	24695	12266	1	0	\N
187729	1693	15645343568530	24695	12266	2	0	\N
187730	2132	147568581000	24695	12266	3	0	\N
187731	2133	91971584000	24695	12266	4	0	\N
187732	1693	15721176330507	24696	12266	0	0	\N
187733	1397	1291325267000	24696	12266	1	0	\N
187734	1693	15645343568530	24696	12266	2	0	\N
187735	2132	147568581000	24696	12266	3	0	\N
187736	2133	91971584000	24696	12266	4	0	\N
187742	1693	15721176330507	24698	12266	0	0	\N
187743	1397	1291325267000	24698	12266	1	0	\N
187744	1693	15645343568530	24698	12266	2	0	\N
187745	2132	147568581000	24698	12266	3	0	\N
187746	2133	91971584000	24698	12266	4	0	\N
187747	1693	15721176330507	24699	12266	0	0	\N
187748	1397	1291325267000	24699	12266	1	0	\N
187749	1693	15645343568530	24699	12266	2	0	\N
187750	2132	147568581000	24699	12266	3	0	\N
187751	2133	91971584000	24699	12266	4	0	\N
187767	1693	14754762543765	24702	12269	0	0	\N
187768	1397	1291295264000	24702	12269	1	0	\N
187769	1397	1291285263000	24702	12269	2	0	\N
187770	1397	1291275262000	24702	12269	3	0	\N
187771	1693	14678929781788	24702	12269	4	0	\N
187772	1693	14641674230206	24702	12269	5	0	\N
187773	1693	14565841468229	24702	12269	6	0	\N
187774	1693	14490331386537	24702	12269	7	0	\N
187775	1693	14414498624560	24702	12269	8	0	\N
187776	1693	14338665862583	24702	12269	9	0	\N
187777	1693	14262833100606	24702	12269	10	0	\N
187778	1693	14187000338629	24702	12269	11	0	\N
187779	1693	14111487122540	24702	12269	12	0	\N
187780	1693	14035976596999	24702	12269	13	0	\N
187781	1693	13960143835022	24702	12269	14	0	\N
187782	1693	13884311073045	24702	12269	15	0	\N
187783	1693	13808800888399	24702	12269	16	0	\N
187784	1693	13733290703753	24702	12269	17	0	\N
187785	1693	13657457941776	24702	12269	18	0	\N
187786	1693	11710661097788	24702	12269	19	0	\N
187787	2132	147567580000	24702	12269	20	0	\N
187788	2133	91968578000	24702	12269	21	0	\N
187789	2133	91967576000	24702	12269	22	0	\N
187790	2133	91966574000	24702	12269	23	0	\N
187791	2134	85383451000	24702	12269	24	0	\N
187792	2134	85382448000	24702	12269	25	0	\N
187793	2134	85381445000	24702	12269	26	0	\N
187683	1397	1291375272000	24686	12262	2	0	14745
187684	2132	147570583000	24686	12262	3	0	1418
187685	2133	91978598000	24686	12262	4	0	4703
187686	2133	91977596000	24686	12262	5	0	4704
187687	2133	91976594000	24686	12262	6	0	4705
187689	2134	85391475000	24686	12262	8	0	5183
187690	2134	85390472000	24686	12262	9	0	5184
187698	1397	1291365271000	24689	12263	0	0	14746
187699	2134	85389469000	24689	12263	1	0	5185
187700	2133	91975592000	24689	12263	2	0	4706
187706	1397	1291355270000	24691	12264	0	0	14747
187707	2133	91974590000	24691	12264	1	0	4707
187708	2132	147569582000	24691	12264	2	0	1419
187709	2134	85388466000	24691	12264	3	0	5186
187717	1397	1291335268000	24693	12265	1	0	14749
187718	2133	91973588000	24693	12265	2	0	4708
187719	2133	91972586000	24693	12265	3	0	4709
187720	2134	85387463000	24693	12265	4	0	5187
187721	2134	85386460000	24693	12265	5	0	5188
187738	1397	1291325267000	24697	12266	1	0	14750
187739	1693	15645343568530	24697	12266	2	0	1119
187740	2132	147568581000	24697	12266	3	0	1420
187741	2133	91971584000	24697	12266	4	0	4710
187752	1397	1291315266000	24700	12267	0	0	14751
187754	1693	15361485337310	24700	12267	2	0	1121
187755	1693	15285652575333	24700	12267	3	0	1122
187756	1693	15209819813356	24700	12267	4	0	1123
187757	1693	15133987051379	24700	12267	5	0	1124
187759	2134	85385457000	24700	12267	7	0	5189
187760	1397	1291305265000	24701	12268	0	0	14752
187761	1693	15058476409158	24701	12268	1	0	1125
187762	1693	14982643647181	24701	12268	2	0	1126
187763	1693	14906810885204	24701	12268	3	0	1127
187765	2134	85384454000	24701	12268	5	0	5190
187766	2133	91969580000	24701	12268	6	0	4712
187794	1693	14754762543765	24703	12269	0	0	1129
187795	1397	1291295264000	24703	12269	1	0	14753
187796	1397	1291285263000	24703	12269	2	0	14754
187798	1693	14678929781788	24703	12269	4	0	1130
187799	1693	14641674230206	24703	12269	5	0	1131
187800	1693	14565841468229	24703	12269	6	0	1132
187801	1693	14490331386537	24703	12269	7	0	1133
187803	1693	14338665862583	24703	12269	9	0	1135
187804	1693	14262833100606	24703	12269	10	0	1136
187805	1693	14187000338629	24703	12269	11	0	1137
187806	1693	14111487122540	24703	12269	12	0	1138
187807	1693	14035976596999	24703	12269	13	0	1139
187809	1693	13884311073045	24703	12269	15	0	1141
187810	1693	13808800888399	24703	12269	16	0	1142
187811	1693	13733290703753	24703	12269	17	0	1143
187812	1693	13657457941776	24703	12269	18	0	1144
187813	1693	11710661097788	24703	12269	19	0	1145
187815	2133	91968578000	24703	12269	21	0	4713
187816	2133	91967576000	24703	12269	22	0	4714
187821	1693	14754762543765	24704	12269	0	0	\N
187822	1397	1291295264000	24704	12269	1	0	\N
187823	1397	1291285263000	24704	12269	2	0	\N
187824	1397	1291275262000	24704	12269	3	0	\N
187825	1693	14678929781788	24704	12269	4	0	\N
187826	1693	14641674230206	24704	12269	5	0	\N
187827	1693	14565841468229	24704	12269	6	0	\N
187828	1693	14490331386537	24704	12269	7	0	\N
187829	1693	14414498624560	24704	12269	8	0	\N
187830	1693	14338665862583	24704	12269	9	0	\N
187831	1693	14262833100606	24704	12269	10	0	\N
187832	1693	14187000338629	24704	12269	11	0	\N
187833	1693	14111487122540	24704	12269	12	0	\N
187834	1693	14035976596999	24704	12269	13	0	\N
187835	1693	13960143835022	24704	12269	14	0	\N
187836	1693	13884311073045	24704	12269	15	0	\N
187837	1693	13808800888399	24704	12269	16	0	\N
187838	1693	13733290703753	24704	12269	17	0	\N
187839	1693	13657457941776	24704	12269	18	0	\N
187840	1693	11710661097788	24704	12269	19	0	\N
187841	2132	147567580000	24704	12269	20	0	\N
187842	2133	91968578000	24704	12269	21	0	\N
187843	2133	91967576000	24704	12269	22	0	\N
187844	2133	91966574000	24704	12269	23	0	\N
187845	2134	85383451000	24704	12269	24	0	\N
187846	2134	85382448000	24704	12269	25	0	\N
187847	2134	85381445000	24704	12269	26	0	\N
187848	1693	14754762543765	24705	12269	0	0	\N
187849	1397	1291295264000	24705	12269	1	0	\N
187850	1397	1291285263000	24705	12269	2	0	\N
187851	1397	1291275262000	24705	12269	3	0	\N
187852	1693	14678929781788	24705	12269	4	0	\N
187853	1693	14641674230206	24705	12269	5	0	\N
187854	1693	14565841468229	24705	12269	6	0	\N
187855	1693	14490331386537	24705	12269	7	0	\N
187856	1693	14414498624560	24705	12269	8	0	\N
187857	1693	14338665862583	24705	12269	9	0	\N
187858	1693	14262833100606	24705	12269	10	0	\N
187859	1693	14187000338629	24705	12269	11	0	\N
187860	1693	14111487122540	24705	12269	12	0	\N
187861	1693	14035976596999	24705	12269	13	0	\N
187862	1693	13960143835022	24705	12269	14	0	\N
187863	1693	13884311073045	24705	12269	15	0	\N
187864	1693	13808800888399	24705	12269	16	0	\N
187865	1693	13733290703753	24705	12269	17	0	\N
187866	1693	13657457941776	24705	12269	18	0	\N
187867	1693	11710661097788	24705	12269	19	0	\N
187868	2132	147567580000	24705	12269	20	0	\N
187869	2133	91968578000	24705	12269	21	0	\N
187870	2133	91967576000	24705	12269	22	0	\N
187871	2133	91966574000	24705	12269	23	0	\N
187872	2134	85383451000	24705	12269	24	0	\N
187873	2134	85382448000	24705	12269	25	0	\N
187874	2134	85381445000	24705	12269	26	0	\N
187900	1397	1291245259000	24709	12272	0	0	\N
187901	2134	85378436000	24709	12272	1	0	\N
187902	2133	91963568000	24709	12272	2	0	\N
187903	1693	10061461119735	24710	12272	0	0	\N
187904	1693	9985950033866	24710	12272	1	0	\N
187905	1693	9910117271889	24710	12272	2	0	\N
187906	1397	1291245259000	24710	12272	3	0	\N
187907	1693	9834607190197	24710	12272	4	0	\N
187908	1693	9758774428220	24710	12272	5	0	\N
187909	2134	85378436000	24710	12272	7	0	\N
187910	2133	91963568000	24710	12272	8	0	\N
187918	1693	9214090375323	24712	12273	0	0	\N
187919	1693	9138577559614	24712	12273	1	0	\N
187920	1397	1291235258000	24712	12273	2	0	\N
187921	1693	9062744797637	24712	12273	3	0	\N
187922	1693	8710247510118	24712	12273	4	0	\N
187923	2134	85377433000	24712	12273	5	0	\N
187924	2133	91962566000	24712	12273	6	0	\N
187925	1693	9214090375323	24713	12273	0	0	\N
187926	1693	9138577559614	24713	12273	1	0	\N
187927	1397	1291235258000	24713	12273	2	0	\N
187928	1693	9062744797637	24713	12273	3	0	\N
187929	1693	8710247510118	24713	12273	4	0	\N
187930	2134	85377433000	24713	12273	5	0	\N
187931	2133	91962566000	24713	12273	6	0	\N
187932	1693	8634414748141	24714	12274	0	0	\N
187933	1397	1291225257000	24714	12274	1	0	\N
187934	1693	8558581986164	24714	12274	2	0	\N
187935	1693	8483070646138	24714	12274	3	0	\N
187936	1693	8480762986694	24714	12274	4	0	\N
187937	2132	147565578000	24714	12274	5	0	\N
187938	2133	91961564000	24714	12274	6	0	\N
187942	1397	1291215256000	24716	12275	0	0	\N
187943	1693	8634414748141	24716	12275	1	0	\N
187944	1693	8558581986164	24716	12275	2	0	\N
187945	1693	8483070646138	24716	12275	3	0	\N
187946	1693	8480762986694	24716	12275	4	0	\N
187947	2134	85376430000	24716	12275	5	0	\N
187948	2133	91960562000	24716	12275	6	0	\N
187819	2134	85382448000	24703	12269	25	0	5192
187820	2134	85381445000	24703	12269	26	0	5193
187875	1693	11634828335811	24706	12270	0	0	1146
187876	1693	11558995573834	24706	12270	1	0	1147
187877	1397	1291265261000	24706	12270	2	0	14756
187879	1693	11481177832698	24706	12270	4	0	1149
187880	2133	91965572000	24706	12270	5	0	4716
187881	2134	85380442000	24706	12270	6	0	5194
187882	1397	1291255260000	24707	12271	0	0	14757
187883	1693	11405345070721	24707	12271	1	0	1150
187885	1693	11323758160116	24707	12271	3	0	1152
187886	1693	11247925398139	24707	12271	4	0	1153
187887	1693	10212482495691	24707	12271	5	0	1154
187888	1693	10136972230972	24707	12271	6	0	1155
187890	2134	85379439000	24707	12271	8	0	5195
187891	2132	147566579000	24707	12271	9	0	1422
187892	1693	10061461119735	24708	12272	0	0	1156
187893	1693	9985950033866	24708	12272	1	0	1157
187894	1693	9910117271889	24708	12272	2	0	1158
187896	1693	9834607190197	24708	12272	4	0	1159
187897	1693	9758774428220	24708	12272	5	0	1160
187898	2134	85378436000	24708	12272	7	0	5196
187899	2133	91963568000	24708	12272	8	0	4718
187911	1693	9214090375323	24711	12273	0	0	1161
187913	1397	1291235258000	24711	12273	2	0	14759
187914	1693	9062744797637	24711	12273	3	0	1163
187915	1693	8710247510118	24711	12273	4	0	1164
187916	2134	85377433000	24711	12273	5	0	5197
187939	1397	1291225257000	24715	12274	0	0	14760
187940	2132	147565578000	24715	12274	1	0	1423
187941	2133	91961564000	24715	12274	2	0	4720
187949	1397	1291215256000	24717	12275	0	0	14761
187950	1693	8634414748141	24717	12275	1	0	1165
187952	1693	8483070646138	24717	12275	3	0	1167
187963	1397	1291185253000	24719	12277	0	0	\N
187964	1693	8329097462740	24719	12277	1	0	\N
187965	1693	8253264700763	24719	12277	2	0	\N
187966	1693	8177431938786	24719	12277	3	0	\N
187967	1693	8101599176809	24719	12277	4	0	\N
187968	1693	8025766414832	24719	12277	5	0	\N
187969	2133	91958558000	24719	12277	6	0	\N
187970	2134	85373421000	24719	12277	7	0	\N
187971	1397	1291185253000	24720	12277	0	0	\N
187972	1693	8329097462740	24720	12277	1	0	\N
187973	1693	8253264700763	24720	12277	2	0	\N
187974	1693	8177431938786	24720	12277	3	0	\N
187975	1693	8101599176809	24720	12277	4	0	\N
187976	1693	8025766414832	24720	12277	5	0	\N
187977	2133	91958558000	24720	12277	6	0	\N
187978	2134	85373421000	24720	12277	7	0	\N
187979	1397	1291185253000	24721	12277	0	0	\N
187980	1693	8329097462740	24721	12277	1	0	\N
187981	1693	8253264700763	24721	12277	2	0	\N
187982	1693	8177431938786	24721	12277	3	0	\N
187983	1693	8101599176809	24721	12277	4	0	\N
187984	1693	8025766414832	24721	12277	5	0	\N
187985	2133	91958558000	24721	12277	6	0	\N
187986	2134	85373421000	24721	12277	7	0	\N
188031	1397	1291185253000	24724	12278	0	0	\N
188032	1397	1291175252000	24724	12278	1	0	\N
188033	1397	1291165251000	24724	12278	2	0	\N
188034	1397	1291155250000	24724	12278	3	0	\N
188035	1397	1291145249000	24724	12278	4	0	\N
188036	1693	8329097462740	24724	12278	5	0	\N
188037	1693	8253264700763	24724	12278	6	0	\N
188038	1693	8177431938786	24724	12278	7	0	\N
188039	1693	8101599176809	24724	12278	8	0	\N
188040	1693	8025766414832	24724	12278	9	0	\N
188041	1693	7950253599123	24724	12278	10	0	\N
188042	1693	7874420837146	24724	12278	11	0	\N
188043	1693	7798588075169	24724	12278	12	0	\N
188044	1693	7722755313192	24724	12278	13	0	\N
188045	1693	7646922551215	24724	12278	14	0	\N
188046	1693	7571412469523	24724	12278	15	0	\N
188047	1693	7495579707546	24724	12278	16	0	\N
188048	1693	7419746945569	24724	12278	17	0	\N
188049	1693	7343914183592	24724	12278	18	0	\N
188050	1693	7268081421615	24724	12278	19	0	\N
188051	1693	7192248659638	24724	12278	20	0	\N
188052	1693	7116415897661	24724	12278	21	0	\N
188053	1693	7040583135684	24724	12278	22	0	\N
188054	1693	6964750373707	24724	12278	23	0	\N
188055	1693	6266113161963	24724	12278	24	0	\N
188056	1693	6190280399986	24724	12278	25	0	\N
188057	1693	6114770215340	24724	12278	26	0	\N
188058	1693	6038937453363	24724	12278	27	0	\N
188059	1693	5963104691386	24724	12278	28	0	\N
188060	1693	5887271929409	24724	12278	29	0	\N
188061	1693	5811439167432	24724	12278	30	0	\N
188062	1693	5735606405455	24724	12278	31	0	\N
188063	1693	5733298746011	24724	12278	32	0	\N
188064	2133	91958558000	24724	12278	33	0	\N
188065	2134	85373421000	24724	12278	34	0	\N
188066	2132	147563576000	24724	12278	35	0	\N
188067	2133	91957556000	24724	12278	36	0	\N
188068	2133	91956554000	24724	12278	37	0	\N
188069	2134	85372418000	24724	12278	38	0	\N
188070	2133	91955552000	24724	12278	39	0	\N
188071	2133	91954550000	24724	12278	40	0	\N
188072	2134	85371415000	24724	12278	41	0	\N
188073	2134	85370412000	24724	12278	42	0	\N
188074	2134	85369409000	24724	12278	43	0	\N
188075	1397	1291185253000	24725	12278	0	0	\N
188076	1397	1291175252000	24725	12278	1	0	\N
188077	1397	1291165251000	24725	12278	2	0	\N
188078	1397	1291155250000	24725	12278	3	0	\N
188079	1397	1291145249000	24725	12278	4	0	\N
188080	1693	8329097462740	24725	12278	5	0	\N
188081	1693	8253264700763	24725	12278	6	0	\N
188082	1693	8177431938786	24725	12278	7	0	\N
188083	1693	8101599176809	24725	12278	8	0	\N
188084	1693	8025766414832	24725	12278	9	0	\N
188085	1693	7950253599123	24725	12278	10	0	\N
188086	1693	7874420837146	24725	12278	11	0	\N
188087	1693	7798588075169	24725	12278	12	0	\N
188088	1693	7722755313192	24725	12278	13	0	\N
187955	1397	1291205255000	24718	12276	0	0	14762
187956	1397	1291195254000	24718	12276	1	0	14763
187957	1693	8404930224717	24718	12276	2	0	1169
187958	2133	91960562000	24718	12276	3	0	4721
187959	2132	147564577000	24718	12276	4	0	1424
187961	2134	85375427000	24718	12276	6	0	5199
187962	2134	85374424000	24718	12276	7	0	5200
187987	1397	1291185253000	24723	12278	0	0	14764
187988	1397	1291175252000	24723	12278	1	0	14765
187989	1397	1291165251000	24723	12278	2	0	14766
187991	1397	1291145249000	24723	12278	4	0	14768
187992	1693	8329097462740	24723	12278	5	0	1170
187993	1693	8253264700763	24723	12278	6	0	1171
187994	1693	8177431938786	24723	12278	7	0	1172
187996	1693	8025766414832	24723	12278	9	0	1174
187997	1693	7950253599123	24723	12278	10	0	1175
187998	1693	7874420837146	24723	12278	11	0	1176
187999	1693	7798588075169	24723	12278	12	0	1177
188000	1693	7722755313192	24723	12278	13	0	1178
188002	1693	7571412469523	24723	12278	15	0	1180
188003	1693	7495579707546	24723	12278	16	0	1181
188004	1693	7419746945569	24723	12278	17	0	1182
188005	1693	7343914183592	24723	12278	18	0	1183
188006	1693	7268081421615	24723	12278	19	0	1184
188008	1693	7116415897661	24723	12278	21	0	1186
188009	1693	7040583135684	24723	12278	22	0	1187
188010	1693	6964750373707	24723	12278	23	0	1188
188011	1693	6266113161963	24723	12278	24	0	1189
188013	1693	6114770215340	24723	12278	26	0	1191
188014	1693	6038937453363	24723	12278	27	0	1192
188015	1693	5963104691386	24723	12278	28	0	1193
188016	1693	5887271929409	24723	12278	29	0	1194
188017	1693	5811439167432	24723	12278	30	0	1195
188019	1693	5733298746011	24723	12278	32	0	1197
188020	2133	91958558000	24723	12278	33	0	4723
188021	2134	85373421000	24723	12278	34	0	5201
188022	2132	147563576000	24723	12278	35	0	1425
188023	2133	91957556000	24723	12278	36	0	4724
188025	2134	85372418000	24723	12278	38	0	5202
188026	2133	91955552000	24723	12278	39	0	4726
188027	2133	91954550000	24723	12278	40	0	4727
188028	2134	85371415000	24723	12278	41	0	5203
188030	2134	85369409000	24723	12278	43	0	5205
188089	1693	7646922551215	24725	12278	14	0	\N
188090	1693	7571412469523	24725	12278	15	0	\N
188091	1693	7495579707546	24725	12278	16	0	\N
188092	1693	7419746945569	24725	12278	17	0	\N
188093	1693	7343914183592	24725	12278	18	0	\N
188094	1693	7268081421615	24725	12278	19	0	\N
188095	1693	7192248659638	24725	12278	20	0	\N
188096	1693	7116415897661	24725	12278	21	0	\N
188097	1693	7040583135684	24725	12278	22	0	\N
188098	1693	6964750373707	24725	12278	23	0	\N
188099	1693	6266113161963	24725	12278	24	0	\N
188100	1693	6190280399986	24725	12278	25	0	\N
188101	1693	6114770215340	24725	12278	26	0	\N
188102	1693	6038937453363	24725	12278	27	0	\N
188103	1693	5963104691386	24725	12278	28	0	\N
188104	1693	5887271929409	24725	12278	29	0	\N
188105	1693	5811439167432	24725	12278	30	0	\N
188106	1693	5735606405455	24725	12278	31	0	\N
188107	1693	5733298746011	24725	12278	32	0	\N
188108	2133	91958558000	24725	12278	33	0	\N
188109	2134	85373421000	24725	12278	34	0	\N
188110	2132	147563576000	24725	12278	35	0	\N
188111	2133	91957556000	24725	12278	36	0	\N
188112	2133	91956554000	24725	12278	37	0	\N
188113	2134	85372418000	24725	12278	38	0	\N
188114	2133	91955552000	24725	12278	39	0	\N
188115	2133	91954550000	24725	12278	40	0	\N
188116	2134	85371415000	24725	12278	41	0	\N
188117	2134	85370412000	24725	12278	42	0	\N
188118	2134	85369409000	24725	12278	43	0	\N
188142	1397	1291105245000	24728	12281	0	0	\N
188143	2134	85365397000	24728	12281	1	0	\N
188144	2133	91950542000	24728	12281	2	0	\N
188155	1693	4803956022186	24734	12283	0	0	\N
188156	1693	4728123260209	24734	12283	1	0	\N
188157	1397	1291085243000	24734	12283	2	0	\N
188158	1693	4652290498232	24734	12283	4	0	\N
188159	1693	4576780405100	24734	12283	5	0	\N
188160	1693	4500947643123	24734	12283	6	0	\N
188161	2133	91948538000	24734	12283	7	0	\N
188162	2134	85363391000	24734	12283	8	0	\N
188163	1693	4803956022186	24735	12283	0	0	\N
188164	1693	4728123260209	24735	12283	1	0	\N
188165	1693	4652290498232	24735	12283	2	0	\N
188166	1693	4576780405100	24735	12283	4	0	\N
188167	1693	4500947643123	24735	12283	5	0	\N
188168	2133	91948538000	24735	12283	6	0	\N
188169	2134	85363391000	24735	12283	7	0	\N
188177	1693	4425437458477	24737	12284	0	0	\N
188178	1397	1291085243000	24737	12284	1	0	\N
188179	1397	1291075242000	24737	12284	2	0	\N
188180	1693	4349604696500	24737	12284	3	0	\N
188181	1693	4273771934523	24737	12284	4	0	\N
188182	1693	4197939172546	24737	12284	5	0	\N
188183	2134	85362388000	24737	12284	6	0	\N
188184	2133	91947536000	24737	12284	7	0	\N
188200	1693	3595696523039	24740	12286	0	0	\N
188201	1693	3519863761062	24740	12286	1	0	\N
188202	1397	1291055240000	24740	12286	2	0	\N
188203	1397	1291045239000	24740	12286	3	0	\N
188204	1693	3517565746466	24740	12286	4	0	\N
188205	1693	3441732984489	24740	12286	5	0	\N
188206	1693	3365900222512	24740	12286	6	0	\N
188207	1693	3290067460535	24740	12286	7	0	\N
188208	1693	3214234698558	24740	12286	8	0	\N
188209	1693	3138401936581	24740	12286	9	0	\N
188210	1693	3062569174604	24740	12286	10	0	\N
188211	1693	2986736412627	24740	12286	11	0	\N
188212	1693	2910903650650	24740	12286	12	0	\N
188213	2134	85360382000	24740	12286	13	0	\N
188214	2133	91945532000	24740	12286	14	0	\N
188215	2133	91944530000	24740	12286	15	0	\N
188216	2132	147560573000	24740	12286	16	0	\N
188217	2134	85359379000	24740	12286	17	0	\N
188218	1693	3595696523039	24741	12286	0	0	\N
188219	1693	3519863761062	24741	12286	1	0	\N
188220	1397	1291055240000	24741	12286	2	0	\N
188221	1397	1291045239000	24741	12286	3	0	\N
188222	1693	3517565746466	24741	12286	4	0	\N
188223	1693	3441732984489	24741	12286	5	0	\N
188224	1693	3365900222512	24741	12286	6	0	\N
188121	1693	6226141460080	24726	12279	2	0	1200
188122	1693	6150308698103	24726	12279	3	0	1201
188123	1693	6074475936126	24726	12279	4	0	1202
188124	1693	5998965751480	24726	12279	5	0	1203
188125	1693	5421144449517	24726	12279	6	0	1204
188127	1693	5341870597783	24726	12279	8	0	1206
188128	1693	5266037835806	24726	12279	9	0	1207
188129	1397	1291135248000	24726	12279	10	0	14769
188130	1397	1291125247000	24726	12279	11	0	14770
188131	2132	147562575000	24726	12279	12	0	1426
188133	2133	91952546000	24726	12279	14	0	4729
188134	2134	85368406000	24726	12279	15	0	5206
188135	2134	85367403000	24726	12279	16	0	5207
188136	1397	1291115246000	24727	12280	0	0	14771
188138	1693	5182153265749	24727	12280	2	0	1209
188139	1693	5106643081103	24727	12280	3	0	1210
188140	2133	91951544000	24727	12280	4	0	4730
188141	2134	85366400000	24727	12280	5	0	5208
188145	1397	1291105245000	24729	12281	0	0	14772
188147	2133	91950542000	24729	12281	2	0	4731
188148	1693	5030810319126	24732	12282	0	0	1211
188149	1397	1291095244000	24732	12282	1	0	14773
188150	1693	4954977557149	24732	12282	2	0	1212
188151	1693	4879466217123	24732	12282	3	0	1213
188153	2134	85364394000	24732	12282	5	0	5210
188154	2132	147561574000	24732	12282	6	0	1427
188170	1693	4803956022186	24736	12283	0	0	1214
188171	1693	4728123260209	24736	12283	1	0	1215
188173	1693	4576780405100	24736	12283	4	0	1217
188174	1693	4500947643123	24736	12283	5	0	1218
188175	2133	91948538000	24736	12283	6	0	4733
188176	2134	85363391000	24736	12283	7	0	5211
188185	1693	4425437458477	24738	12284	0	0	1219
188187	1397	1291075242000	24738	12284	2	0	14775
188188	1693	4349604696500	24738	12284	3	0	1220
188189	1693	4273771934523	24738	12284	4	0	1221
188190	1693	4197939172546	24738	12284	5	0	1222
188191	2134	85362388000	24738	12284	6	0	5212
188193	1397	1291065241000	24739	12285	0	0	14776
188194	1693	3845441885027	24739	12285	1	0	1223
188195	1693	3769609123050	24739	12285	2	0	1224
188196	1693	3694098928113	24739	12285	3	0	1225
188198	2133	91946534000	24739	12285	5	0	4735
188199	2134	85361385000	24739	12285	6	0	5213
188225	1693	3290067460535	24741	12286	7	0	\N
188226	1693	3214234698558	24741	12286	8	0	\N
188227	1693	3138401936581	24741	12286	9	0	\N
188228	1693	3062569174604	24741	12286	10	0	\N
188229	1693	2986736412627	24741	12286	11	0	\N
188230	1693	2910903650650	24741	12286	12	0	\N
188231	2134	85360382000	24741	12286	13	0	\N
188232	2133	91945532000	24741	12286	14	0	\N
188233	2133	91944530000	24741	12286	15	0	\N
188234	2132	147560573000	24741	12286	16	0	\N
188235	2134	85359379000	24741	12286	17	0	\N
188254	1693	2835070888673	24743	12287	0	0	\N
188255	1693	2759238126696	24743	12287	1	0	\N
188256	1693	2756937511426	24743	12287	2	0	\N
188257	1693	2681104749449	24743	12287	3	0	\N
188258	1693	2605271987472	24743	12287	4	0	\N
188259	1397	1291035238000	24743	12287	5	0	\N
188260	2134	85358376000	24743	12287	6	0	\N
188261	2133	91943528000	24743	12287	7	0	\N
188270	1693	2835070888673	24745	12287	0	0	\N
188271	1693	2759238126696	24745	12287	1	0	\N
188272	1693	2756937511426	24745	12287	2	0	\N
188273	1693	2681104749449	24745	12287	3	0	\N
188274	1693	2605271987472	24745	12287	4	0	\N
188275	1397	1291035238000	24745	12287	5	0	\N
188276	2134	85358376000	24745	12287	6	0	\N
188277	2133	91943528000	24745	12287	7	0	\N
188286	1397	1291025237000	24747	12288	0	0	\N
188287	1693	2529761802826	24747	12288	1	0	\N
188288	1693	2453929040849	24747	12288	2	0	\N
188289	1693	2378418856203	24747	12288	3	0	\N
188290	1693	2302586094226	24747	12288	4	0	\N
188291	2134	85357373000	24747	12288	5	0	\N
188292	2132	147559572000	24747	12288	6	0	\N
188293	2133	91942526000	24747	12288	7	0	\N
188298	1397	1290995234000	24749	12290	0	0	\N
188299	1693	2226753332249	24749	12290	1	0	\N
188300	1693	2150920570272	24749	12290	2	0	\N
188301	2133	91941524000	24749	12290	3	0	\N
188302	2133	91940522000	24749	12290	4	0	\N
188303	2133	91939520000	24749	12290	5	0	\N
188304	2134	85354364000	24749	12290	6	0	\N
188305	2132	147558571000	24749	12290	7	0	\N
188326	1397	1290955230000	24753	12292	0	0	\N
188327	2133	91935512000	24753	12292	1	0	\N
188328	2132	147557570000	24753	12292	2	0	\N
188329	2134	85351355000	24753	12292	3	0	\N
188333	1397	1290945229000	24755	12293	0	0	\N
188334	2134	85350352000	24755	12293	1	0	\N
188335	2133	91934510000	24755	12293	2	0	\N
188336	1397	1290945229000	24756	12293	0	0	\N
188337	2134	85350352000	24756	12293	1	0	\N
188338	2133	91934510000	24756	12293	2	0	\N
188339	1397	1290945229000	24757	12293	0	0	\N
188340	2134	85350352000	24757	12293	1	0	\N
188341	1397	1290945229000	24758	12293	0	0	\N
188342	2134	85350352000	24758	12293	1	0	\N
188343	2133	91934510000	24758	12293	2	0	\N
188344	1397	1290935228000	24759	12294	0	0	\N
188345	1397	1290925227000	24759	12294	1	0	\N
188346	2132	147556569000	24759	12294	2	0	\N
188347	2133	91933508000	24759	12294	3	0	\N
188348	2133	91932506000	24759	12294	4	0	\N
188349	2134	85349349000	24759	12294	5	0	\N
188350	2134	85348346000	24759	12294	6	0	\N
188351	1397	1290935228000	24760	12294	0	0	\N
188352	1397	1290925227000	24760	12294	1	0	\N
188353	2132	147556569000	24760	12294	2	0	\N
188354	2134	85349349000	24760	12294	3	0	\N
188355	2134	85348346000	24760	12294	4	0	\N
188356	1397	1290935228000	24761	12294	0	0	\N
188357	1397	1290925227000	24761	12294	1	0	\N
188358	2132	147556569000	24761	12294	2	0	\N
188359	2133	91933508000	24761	12294	3	0	\N
188360	2133	91932506000	24761	12294	4	0	\N
188238	1397	1291055240000	24742	12286	2	0	14777
188239	1397	1291045239000	24742	12286	3	0	14778
188240	1693	3517565746466	24742	12286	4	0	1229
188241	1693	3441732984489	24742	12286	5	0	1230
188242	1693	3365900222512	24742	12286	6	0	1231
188244	1693	3214234698558	24742	12286	8	0	1233
188245	1693	3138401936581	24742	12286	9	0	1234
188246	1693	3062569174604	24742	12286	10	0	1235
188247	1693	2986736412627	24742	12286	11	0	1236
188248	1693	2910903650650	24742	12286	12	0	1237
188250	2133	91945532000	24742	12286	14	0	4736
188251	2133	91944530000	24742	12286	15	0	4737
188252	2132	147560573000	24742	12286	16	0	1428
188253	2134	85359379000	24742	12286	17	0	5215
188263	1693	2759238126696	24744	12287	1	0	1239
188264	1693	2756937511426	24744	12287	2	0	1240
188265	1693	2681104749449	24744	12287	3	0	1241
188266	1693	2605271987472	24744	12287	4	0	1242
188267	1397	1291035238000	24744	12287	5	0	14779
188269	2133	91943528000	24744	12287	7	0	4738
188278	1397	1291025237000	24746	12288	0	0	14780
188279	1693	2529761802826	24746	12288	1	0	1243
188280	1693	2453929040849	24746	12288	2	0	1244
188281	1693	2378418856203	24746	12288	3	0	1245
188283	2134	85357373000	24746	12288	5	0	5217
188284	2132	147559572000	24746	12288	6	0	1429
188285	2133	91942526000	24746	12288	7	0	4739
188294	1397	1291015236000	24748	12289	0	0	14781
188296	2134	85356370000	24748	12289	2	0	5218
188297	2134	85355367000	24748	12289	3	0	5219
188306	1397	1290995234000	24750	12290	0	0	14783
188307	1693	2226753332249	24750	12290	1	0	1247
188308	1693	2150920570272	24750	12290	2	0	1248
188310	2133	91940522000	24750	12290	4	0	4741
188311	2133	91939520000	24750	12290	5	0	4742
188312	2134	85354364000	24750	12290	6	0	5220
188313	2132	147558571000	24750	12290	7	0	1430
188314	1397	1290985233000	24751	12291	0	0	14784
188316	1397	1290965231000	24751	12291	2	0	14786
188317	2134	85353361000	24751	12291	3	0	5221
188318	2134	85352358000	24751	12291	4	0	5222
188319	2133	91938518000	24751	12291	5	0	4743
188321	2133	91936514000	24751	12291	7	0	4745
188322	1397	1290955230000	24752	12292	0	0	14787
188323	2133	91935512000	24752	12292	1	0	4746
188324	2132	147557570000	24752	12292	2	0	1431
188325	2134	85351355000	24752	12292	3	0	5223
188331	2134	85350352000	24754	12293	1	0	5224
188332	2133	91934510000	24754	12293	2	0	4747
188361	2134	85349349000	24761	12294	5	0	\N
188362	2134	85348346000	24761	12294	6	0	\N
188380	1588	12241763000000	24764	12296	0	0	\N
188381	1397	1290895224000	24764	12296	1	0	\N
188382	2133	91929500000	24764	12296	2	0	\N
188383	2133	91928498000	24764	12296	3	0	\N
188384	2132	147555568000	24764	12296	5	0	\N
188385	2134	85345337000	24764	12296	6	0	\N
188386	2134	85344334000	24764	12296	7	0	\N
188397	1397	1290885223000	24767	12297	0	0	\N
188398	2134	85343331000	24767	12297	1	0	\N
188399	2133	91927496000	24767	12297	2	0	\N
188400	1397	1290885223000	24768	12297	0	0	\N
188401	2134	85343331000	24768	12297	1	0	\N
188409	1397	1290865221000	24771	12299	0	0	\N
188410	2134	85341325000	24771	12299	1	0	\N
188411	2133	91925492000	24771	12299	2	0	\N
188412	2132	147554567000	24771	12299	3	0	\N
188413	1397	1290855220000	24772	12300	0	0	\N
188414	2134	85340322000	24772	12300	1	0	\N
188415	2133	91924490000	24772	12300	2	0	\N
188419	1397	1290845219000	24774	12301	0	0	\N
188420	2133	91923488000	24774	12301	1	0	\N
188423	1397	1290835218000	24776	12302	0	0	\N
188424	2134	85339319000	24776	12302	1	0	\N
188425	2132	147553566000	24776	12302	2	0	\N
188426	2133	91922486000	24776	12302	3	0	\N
188431	1397	1290825217000	24778	12303	0	0	\N
188432	1397	1290815216000	24778	12303	1	0	\N
188433	2134	85338316000	24778	12303	2	0	\N
188434	2134	85337313000	24778	12303	3	0	\N
188435	2133	91921484000	24778	12303	4	0	\N
188436	2133	91920482000	24778	12303	5	0	\N
188447	1715	19931052224631	24781	12157	0	0	\N
188448	1715	19675195013166	24781	12157	1	0	\N
188449	1715	19419337801701	24781	12157	2	0	\N
188450	1715	17569193689316	24781	12157	3	0	\N
188451	1715	14253830491090	24781	12157	4	0	\N
188452	1715	12016856349966	24781	12157	5	0	\N
188453	1715	5783507663945	24781	12157	6	0	\N
188454	1693	14281141330507	24781	12157	7	0	\N
188455	1467	17088711371984	24781	12157	8	0	\N
188456	1467	12934295866644	24781	12157	9	0	\N
188457	1588	30961698000000	24781	12157	10	0	\N
188458	1588	22203212000000	24781	12157	11	0	\N
188459	1467	10131225689819	24781	12157	12	0	\N
188460	1467	2320239272869	24781	12157	13	0	\N
188461	1467	2320229272869	24781	12157	14	0	\N
188462	1588	17544852000000	24781	12157	15	0	\N
188463	1588	14409206000000	24781	12157	16	0	\N
188464	1693	14205308568530	24781	12157	17	0	\N
188465	1693	13996960979531	24781	12157	18	0	\N
188466	1693	13921450337310	24781	12157	19	0	\N
188467	1693	13845617575333	24781	12157	20	0	\N
188468	1693	13769784813356	24781	12157	21	0	\N
188469	1693	13693952051379	24781	12157	22	0	\N
188470	1693	13618441409158	24781	12157	24	0	\N
188471	1693	13542608647181	24781	12157	25	0	\N
188472	1693	13466775885204	24781	12157	26	0	\N
188473	1693	13390560305742	24781	12157	27	0	\N
188474	1693	13314727543765	24781	12157	28	0	\N
188475	1693	13238894781788	24781	12157	29	0	\N
188476	1693	13201639230206	24781	12157	30	0	\N
188477	1693	13125806468229	24781	12157	31	0	\N
188478	1693	13050296386537	24781	12157	32	0	\N
188479	1693	12974463624560	24781	12157	33	0	\N
188480	1693	12898630862583	24781	12157	34	0	\N
188481	1693	12822798100606	24781	12157	35	0	\N
188482	1693	12746965338629	24781	12157	36	0	\N
188483	1693	12671452122540	24781	12157	37	0	\N
188484	1693	12595941596999	24781	12157	38	0	\N
188485	1693	12520108835022	24781	12157	39	0	\N
188486	1693	12444276073045	24781	12157	40	0	\N
188487	1693	12368765888399	24781	12157	41	0	\N
188488	1693	12293255703753	24781	12157	42	0	\N
188489	1693	12217422941776	24781	12157	43	0	\N
188490	1693	10270626097788	24781	12157	44	0	\N
188491	1693	10194793335811	24781	12157	45	0	\N
188492	1693	10118960573834	24781	12157	46	0	\N
188493	1693	10043450492142	24781	12157	47	0	\N
188494	1693	10041142832698	24781	12157	48	0	\N
188495	1693	9965310070721	24781	12157	49	0	\N
188496	1693	9889477308744	24781	12157	50	0	\N
188365	2132	147556569000	24762	12294	2	0	1432
188366	2133	91933508000	24762	12294	3	0	4748
188367	2133	91932506000	24762	12294	4	0	4749
188368	2134	85349349000	24762	12294	5	0	5225
188369	2134	85348346000	24762	12294	6	0	5226
188371	1397	1290915226000	24763	12295	1	0	14791
188372	1397	1290905225000	24763	12295	2	0	14792
188373	1588	18984967000000	24763	12295	3	0	9
188374	1588	15849321000000	24763	12295	4	0	10
188375	1588	13249773000000	24763	12295	5	0	11
188377	2134	85347343000	24763	12295	7	0	5227
188378	2134	85346340000	24763	12295	8	0	5228
188379	2133	91930502000	24763	12295	9	0	4751
188387	1588	12241763000000	24765	12296	0	0	12
188389	2133	91929500000	24765	12296	2	0	4752
188390	2133	91928498000	24765	12296	3	0	4753
188391	2132	147555568000	24765	12296	5	0	1433
188392	2134	85345337000	24765	12296	6	0	5229
188393	2134	85344334000	24765	12296	7	0	5230
188395	2134	85343331000	24766	12297	1	0	5231
188396	2133	91927496000	24766	12297	2	0	4754
188402	1397	1290875222000	24769	12298	0	0	14795
188403	2133	91926494000	24769	12298	1	0	4755
188404	2134	85342328000	24769	12298	2	0	5232
188406	2134	85341325000	24770	12299	1	0	5233
188407	2133	91925492000	24770	12299	2	0	4756
188408	2132	147554567000	24770	12299	3	0	1434
188416	1397	1290855220000	24773	12300	0	0	14797
188418	2133	91924490000	24773	12300	2	0	4757
188421	1397	1290845219000	24775	12301	0	0	14798
188422	2133	91923488000	24775	12301	1	0	4758
188427	1397	1290835218000	24777	12302	0	0	14799
188428	2134	85339319000	24777	12302	1	0	5235
188430	2133	91922486000	24777	12302	3	0	4759
188437	1397	1290825217000	24779	12303	0	0	14800
188438	1397	1290815216000	24779	12303	1	0	14801
188439	2134	85338316000	24779	12303	2	0	5236
188440	2134	85337313000	24779	12303	3	0	5237
188442	2133	91920482000	24779	12303	5	0	4761
188443	1397	1290805215000	24780	12304	0	0	14802
188444	2133	91919480000	24780	12304	1	0	4762
188445	2134	85336310000	24780	12304	2	0	5238
188497	1693	9883723160116	24781	12157	51	0	\N
188498	1693	9807890398139	24781	12157	52	0	\N
188499	1693	8772447495691	24781	12157	53	0	\N
188500	1693	8696937230972	24781	12157	54	0	\N
188501	1693	8621426119735	24781	12157	55	0	\N
188532	1397	1290705205000	24789	12309	0	0	\N
188533	2132	147549562000	24789	12309	1	0	\N
188534	2134	85326280000	24789	12309	2	0	\N
188535	2133	91909460000	24789	12309	3	0	\N
188540	1397	1290695204000	24792	12310	0	0	\N
188541	1397	1290685203000	24792	12310	1	0	\N
188542	1397	1290675202000	24792	12310	2	0	\N
188543	2134	85325277000	24792	12310	3	0	\N
188544	2133	91908458000	24792	12310	4	0	\N
188545	2133	91907456000	24792	12310	5	0	\N
188546	2133	91906454000	24792	12310	6	0	\N
188547	2134	85324274000	24792	12310	7	0	\N
188548	2134	85323271000	24792	12310	8	0	\N
188549	1926	1189000000	24792	12310	9	0	\N
188550	2133	91908458000	24793	12310	0	0	\N
188551	2133	91907456000	24793	12310	1	0	\N
188552	2133	91906454000	24793	12310	2	0	\N
188553	1926	1189000000	24793	12310	3	0	\N
188574	1397	1290635198000	24797	12313	0	0	\N
188575	2133	91902446000	24797	12313	1	0	\N
188576	2132	147547560000	24797	12313	2	0	\N
188577	2134	85319259000	24797	12313	3	0	\N
188603	1397	1290585193000	24804	12318	0	0	\N
188604	283	66001719734615	24804	12318	1	0	\N
188605	114	66000936901851	24804	12318	2	0	\N
188606	10	32558282617398	24804	12318	3	0	\N
188607	2134	85314244000	24804	12318	4	0	\N
188608	2133	91897436000	24804	12318	5	0	\N
188609	1397	1290575192000	24805	12319	0	0	\N
188610	301	66002710734615	24805	12319	1	0	\N
188611	2134	85313241000	24805	12319	2	0	\N
188612	2133	91896434000	24805	12319	3	0	\N
188617	1397	1290575192000	24807	12319	0	0	\N
188618	301	66002710734615	24807	12319	1	0	\N
188619	2134	85313241000	24807	12319	2	0	\N
188620	1397	1290565191000	24808	12320	0	0	\N
188621	2134	85312238000	24808	12320	1	0	\N
188622	2133	91895432000	24808	12320	2	0	\N
188623	2132	147545558000	24808	12320	3	0	\N
188626	1693	15721176330507	24810	12261	0	0	\N
188627	1588	22923274000000	24810	12261	1	0	\N
188628	114	66042453685762	24810	12261	2	0	\N
188629	114	66041443685762	24810	12261	3	0	\N
188630	1588	18264914000000	24810	12261	4	0	\N
188631	1588	15129268000000	24810	12261	5	0	\N
188632	1693	15645343568530	24810	12261	6	0	\N
188504	2133	91918478000	24782	12305	2	0	4763
188505	1397	1290785213000	24784	12306	0	0	14804
188506	1397	1290775212000	24784	12306	1	0	14805
188507	1397	1290765211000	24784	12306	2	0	14806
188508	1397	1290755210000	24784	12306	3	0	14807
188510	2133	91917476000	24784	12306	5	0	4764
188511	2133	91916474000	24784	12306	6	0	4765
188512	1926	1190000000	24784	12306	7	0	10
188513	2133	91915472000	24784	12306	8	0	4766
188514	2134	85334304000	24784	12306	9	0	5240
188516	2134	85332298000	24784	12306	11	0	5242
188517	2134	85331295000	24784	12306	12	0	5243
188518	2134	85330292000	24784	12306	13	0	5244
188519	2132	147551564000	24784	12306	14	0	1437
188521	2133	91913468000	24784	12306	16	0	4768
188522	1397	1290735208000	24785	12307	0	0	14809
188523	2133	91912466000	24785	12307	1	0	4769
188524	2132	147550563000	24785	12307	2	0	1438
188525	2134	85329289000	24785	12307	3	0	5245
188527	1397	1290715206000	24786	12308	1	0	14811
188528	2133	91911464000	24786	12308	2	0	4770
188529	2134	85328286000	24786	12308	3	0	5246
188530	2134	85327283000	24786	12308	4	0	5247
188531	2133	91910462000	24786	12308	5	0	4771
188537	2132	147549562000	24790	12309	1	0	1439
188538	2134	85326280000	24790	12309	2	0	5248
188539	2133	91909460000	24790	12309	3	0	4772
188554	1397	1290695204000	24794	12310	0	0	14813
188556	1397	1290675202000	24794	12310	2	0	14815
188557	2134	85325277000	24794	12310	3	0	5249
188558	2133	91908458000	24794	12310	4	0	4773
188559	2133	91907456000	24794	12310	5	0	4774
188560	2133	91906454000	24794	12310	6	0	4775
188562	2134	85323271000	24794	12310	8	0	5251
188563	1926	1189000000	24794	12310	9	0	11
188564	1397	1290665201000	24795	12311	0	0	14816
188565	1397	1290655200000	24795	12311	1	0	14817
188566	2132	147548561000	24795	12311	2	0	1440
188568	2134	85321265000	24795	12311	4	0	5253
188569	2133	91905452000	24795	12311	5	0	4776
188570	2133	91904450000	24795	12311	6	0	4777
188571	1397	1290645199000	24796	12312	0	0	14818
188573	2133	91903448000	24796	12312	2	0	4778
188578	1397	1290635198000	24798	12313	0	0	14819
188579	2133	91902446000	24798	12313	1	0	4779
188580	2132	147547560000	24798	12313	2	0	1441
188581	2134	85319259000	24798	12313	3	0	5255
188583	2133	91901444000	24799	12314	2	0	4780
188584	2134	85318256000	24799	12314	3	0	5256
188585	114	66117956901851	24800	12315	0	0	10
188586	1397	1290615196000	24800	12315	1	0	14821
188587	2133	91900442000	24800	12315	2	0	4781
188589	114	66116946901851	24801	12316	0	0	11
188590	1397	1290605195000	24801	12316	1	0	14822
188591	2134	85316250000	24801	12316	2	0	5258
188592	2132	147546559000	24801	12316	3	0	1442
188594	1397	1290595194000	24802	12317	0	0	14823
188595	2133	91898438000	24802	12317	1	0	4783
188596	2134	85315247000	24802	12317	2	0	5259
188597	1397	1290585193000	24803	12318	0	0	14824
188598	283	66001719734615	24803	12318	1	0	2
188600	10	32558282617398	24803	12318	3	0	2
188601	2134	85314244000	24803	12318	4	0	5260
188602	2133	91897436000	24803	12318	5	0	4784
188613	1397	1290575192000	24806	12319	0	0	14825
188614	301	66002710734615	24806	12319	1	0	3
188616	2133	91896434000	24806	12319	3	0	4785
188624	2133	91895432000	24809	12320	0	0	4786
188625	2132	147545558000	24809	12320	1	0	1443
188633	1693	15436995979531	24810	12261	7	0	\N
188634	1693	15361485337310	24810	12261	8	0	\N
188635	1693	15285652575333	24810	12261	9	0	\N
188636	1693	15209819813356	24810	12261	10	0	\N
188637	1693	15133987051379	24810	12261	11	0	\N
188638	1693	15058476409158	24810	12261	12	0	\N
188639	1693	14982643647181	24810	12261	13	0	\N
188640	1693	14906810885204	24810	12261	14	0	\N
188641	1693	14830595305742	24810	12261	15	0	\N
188642	1693	14754762543765	24810	12261	16	0	\N
188643	1693	14678929781788	24810	12261	17	0	\N
188644	1693	14641674230206	24810	12261	18	0	\N
188645	1693	14565841468229	24810	12261	19	0	\N
188646	1693	14490331386537	24810	12261	20	0	\N
188647	1693	14414498624560	24810	12261	21	0	\N
188648	1693	14338665862583	24810	12261	22	0	\N
188649	1693	14262833100606	24810	12261	23	0	\N
188650	1693	14187000338629	24810	12261	24	0	\N
188651	1693	14111487122540	24810	12261	25	0	\N
188652	1693	14035976596999	24810	12261	26	0	\N
188653	1693	13960143835022	24810	12261	27	0	\N
188654	1693	13884311073045	24810	12261	28	0	\N
188655	1693	13808800888399	24810	12261	29	0	\N
188656	1693	13733290703753	24810	12261	30	0	\N
188657	1693	13657457941776	24810	12261	31	0	\N
188658	1693	11710661097788	24810	12261	32	0	\N
188659	1693	11634828335811	24810	12261	33	0	\N
188660	1693	11558995573834	24810	12261	34	0	\N
188661	1693	11483485492142	24810	12261	35	0	\N
188662	1693	11481177832698	24810	12261	36	0	\N
188663	1693	11405345070721	24810	12261	37	0	\N
188664	1693	11329512308744	24810	12261	38	0	\N
188665	1693	11323758160116	24810	12261	39	0	\N
188666	1693	11247925398139	24810	12261	40	0	\N
188667	1693	10212482495691	24810	12261	41	0	\N
188668	1693	10136972230972	24810	12261	42	0	\N
188669	1693	10061461119735	24810	12261	43	0	\N
188670	1693	9985950033866	24810	12261	44	0	\N
188671	1693	9910117271889	24810	12261	45	0	\N
188672	1693	9834607190197	24810	12261	46	0	\N
188673	1693	9758774428220	24810	12261	47	0	\N
188674	1693	9214090375323	24810	12261	48	0	\N
188675	1693	9138577559614	24810	12261	49	0	\N
188676	1693	9062744797637	24810	12261	50	0	\N
188677	1693	8710247510118	24810	12261	51	0	\N
188678	1693	8634414748141	24810	12261	52	0	\N
188679	1693	8558581986164	24810	12261	53	0	\N
188680	1693	8483070646138	24810	12261	54	0	\N
188681	1693	8480762986694	24810	12261	55	0	\N
188682	1693	8404930224717	24810	12261	56	0	\N
188683	1693	8329097462740	24810	12261	57	0	\N
188684	1693	8253264700763	24810	12261	58	0	\N
188685	1693	8177431938786	24810	12261	59	0	\N
188686	1693	8101599176809	24810	12261	60	0	\N
188687	1693	8025766414832	24810	12261	61	0	\N
188688	1588	12529720000000	24810	12261	62	0	\N
188689	1588	11521710000000	24810	12261	63	0	\N
188690	1693	7950253599123	24810	12261	64	0	\N
188691	1693	7874420837146	24810	12261	65	0	\N
188692	1693	7798588075169	24810	12261	66	0	\N
188693	1693	7722755313192	24810	12261	67	0	\N
188694	1693	7646922551215	24810	12261	68	0	\N
188695	1693	7571412469523	24810	12261	69	0	\N
188696	1693	7495579707546	24810	12261	70	0	\N
188697	1693	7419746945569	24810	12261	71	0	\N
188698	1693	7343914183592	24810	12261	72	0	\N
188699	1693	7268081421615	24810	12261	73	0	\N
188700	1693	7192248659638	24810	12261	74	0	\N
188701	1693	7116415897661	24810	12261	75	0	\N
188702	1693	7040583135684	24810	12261	76	0	\N
188703	1693	6964750373707	24810	12261	77	0	\N
188704	1693	6266113161963	24810	12261	78	0	\N
188705	1693	6190280399986	24810	12261	79	0	\N
188706	1693	6114770215340	24810	12261	80	0	\N
188707	1693	6038937453363	24810	12261	81	0	\N
188708	1693	5963104691386	24810	12261	82	0	\N
188709	1693	5887271929409	24810	12261	83	0	\N
188710	1693	5811439167432	24810	12261	84	0	\N
188711	1693	5735606405455	24810	12261	85	0	\N
188712	1693	5733298746011	24810	12261	86	0	\N
188713	1693	5657465984034	24810	12261	87	0	\N
188714	1693	5581633222057	24810	12261	88	0	\N
188715	1693	5505800460080	24810	12261	89	0	\N
188716	1693	5429967698103	24810	12261	90	0	\N
188717	1693	5354134936126	24810	12261	91	0	\N
188718	1693	5278624751480	24810	12261	92	0	\N
188719	1693	4700803449517	24810	12261	93	0	\N
188720	1693	4697358893618	24810	12261	94	0	\N
188721	1693	4621529597783	24810	12261	95	0	\N
188722	1693	4545696835806	24810	12261	96	0	\N
188723	1693	4537645027726	24810	12261	97	0	\N
188724	1693	4461812265749	24810	12261	98	0	\N
188725	1693	4386302081103	24810	12261	99	0	\N
188726	1693	4310469319126	24810	12261	100	0	\N
188727	1693	4234636557149	24810	12261	101	0	\N
188728	1693	4159125217123	24810	12261	102	0	\N
188729	1693	4083615022186	24810	12261	103	0	\N
188730	1693	4007782260209	24810	12261	104	0	\N
188731	1693	3931949498232	24810	12261	105	0	\N
188732	1693	3856439405100	24810	12261	106	0	\N
188733	1693	3780606643123	24810	12261	107	0	\N
188734	1693	3705096458477	24810	12261	108	0	\N
188735	1693	3629263696500	24810	12261	109	0	\N
188736	1693	3553430934523	24810	12261	110	0	\N
188737	1693	3477598172546	24810	12261	111	0	\N
188738	1397	1290565191000	24811	12320	0	0	\N
188739	2134	85312238000	24811	12320	1	0	\N
188740	2133	91895432000	24811	12320	2	0	\N
188741	2132	147545558000	24811	12320	3	0	\N
188742	1397	1290565191000	24812	12321	0	0	\N
188743	1397	1290555190000	24812	12321	1	0	\N
188744	2134	85312238000	24812	12321	2	0	\N
188745	2134	85311235000	24812	12321	3	0	\N
188746	2133	91894430000	24812	12321	4	0	\N
188752	1397	1290565191000	24814	12321	0	0	\N
188753	1397	1290555190000	24814	12321	1	0	\N
188754	2134	85312238000	24814	12321	2	0	\N
188755	2134	85311235000	24814	12321	3	0	\N
188756	2133	91894430000	24814	12321	4	0	\N
188757	1588	22923274000000	24815	12287	0	0	\N
188758	114	66117956901851	24815	12287	1	0	\N
188759	114	66116946901851	24815	12287	2	0	\N
188760	283	66001719734615	24815	12287	3	0	\N
188761	114	66000936901851	24815	12287	4	0	\N
188762	301	66002710734615	24815	12287	5	0	\N
188763	10	32558282617398	24815	12287	6	0	\N
188764	1693	2835070888673	24815	12287	7	0	\N
188765	1693	2759238126696	24815	12287	8	0	\N
188766	1693	2756937511426	24815	12287	9	0	\N
188767	1693	2681104749449	24815	12287	10	0	\N
188768	1693	2605271987472	24815	12287	11	0	\N
188749	2134	85312238000	24813	12321	2	0	5262
188750	2134	85311235000	24813	12321	3	0	5263
188751	2133	91894430000	24813	12321	4	0	4787
188769	1693	2529761802826	24815	12287	12	0	\N
188770	1693	2453929040849	24815	12287	13	0	\N
188771	1693	2378418856203	24815	12287	14	0	\N
188772	1693	2302586094226	24815	12287	15	0	\N
188773	1693	2226753332249	24815	12287	16	0	\N
188774	1693	2150920570272	24815	12287	17	0	\N
188775	1397	1291035238000	24815	12287	18	0	\N
188776	1397	1291025237000	24815	12287	19	0	\N
188777	1397	1291015236000	24815	12287	20	0	\N
188778	1397	1291005235000	24815	12287	21	0	\N
188779	1397	1290995234000	24815	12287	22	0	\N
188780	1397	1290985233000	24815	12287	23	0	\N
188781	1397	1290975232000	24815	12287	24	0	\N
188782	1397	1290965231000	24815	12287	25	0	\N
188783	1397	1290955230000	24815	12287	26	0	\N
188784	1397	1290945229000	24815	12287	27	0	\N
188785	1397	1290935228000	24815	12287	28	0	\N
188786	1397	1290925227000	24815	12287	29	0	\N
188787	1397	1290915226000	24815	12287	30	0	\N
188788	1397	1290905225000	24815	12287	31	0	\N
188789	1397	1290895224000	24815	12287	32	0	\N
188790	1397	1290885223000	24815	12287	33	0	\N
188791	1588	18264914000000	24815	12287	34	0	\N
188792	1588	15129268000000	24815	12287	35	0	\N
188793	1588	12529720000000	24815	12287	36	0	\N
188794	1588	11521710000000	24815	12287	37	0	\N
188795	1397	1290875222000	24815	12287	38	0	\N
188796	1397	1290865221000	24815	12287	39	0	\N
188797	1397	1290855220000	24815	12287	40	0	\N
188798	1397	1290845219000	24815	12287	41	0	\N
188799	1397	1290835218000	24815	12287	42	0	\N
188800	1397	1290825217000	24815	12287	43	0	\N
188801	1397	1290815216000	24815	12287	44	0	\N
188802	1397	1290805215000	24815	12287	45	0	\N
188803	1397	1290795214000	24815	12287	46	0	\N
188804	1397	1290785213000	24815	12287	47	0	\N
188805	1397	1290775212000	24815	12287	48	0	\N
188806	1397	1290765211000	24815	12287	49	0	\N
188807	1397	1290755210000	24815	12287	50	0	\N
188808	1397	1290745209000	24815	12287	51	0	\N
188809	1397	1290735208000	24815	12287	52	0	\N
188810	1397	1290725207000	24815	12287	53	0	\N
188811	1397	1290715206000	24815	12287	54	0	\N
188812	1397	1290705205000	24815	12287	55	0	\N
188813	1397	1290695204000	24815	12287	56	0	\N
188814	1397	1290685203000	24815	12287	57	0	\N
188815	1397	1290675202000	24815	12287	58	0	\N
188816	1397	1290665201000	24815	12287	59	0	\N
188817	1397	1290655200000	24815	12287	60	0	\N
188818	1397	1290645199000	24815	12287	61	0	\N
188819	1397	1290635198000	24815	12287	62	0	\N
188820	1397	1290625197000	24815	12287	63	0	\N
188821	1397	1290615196000	24815	12287	64	0	\N
188822	1397	1290605195000	24815	12287	65	0	\N
188823	1397	1290595194000	24815	12287	66	0	\N
188824	1397	1290585193000	24815	12287	67	0	\N
188825	1397	1290575192000	24815	12287	68	0	\N
188826	1397	1290565191000	24815	12287	69	0	\N
188827	2134	85358376000	24815	12287	70	0	\N
188828	2134	85357373000	24815	12287	71	0	\N
188829	1926	1190000000	24815	12287	72	0	\N
188830	2132	147559572000	24815	12287	73	0	\N
188831	2134	85356370000	24815	12287	74	0	\N
188832	2134	85355367000	24815	12287	75	0	\N
188833	2134	85354364000	24815	12287	76	0	\N
188834	2134	85353361000	24815	12287	77	0	\N
188835	2134	85352358000	24815	12287	78	0	\N
188836	2132	147558571000	24815	12287	79	0	\N
188837	2132	147557570000	24815	12287	80	0	\N
188838	2132	147556569000	24815	12287	81	0	\N
188839	2132	147555568000	24815	12287	83	0	\N
188840	2132	147554567000	24815	12287	84	0	\N
188841	2132	147553566000	24815	12287	85	0	\N
188842	2132	147552565000	24815	12287	86	0	\N
188843	2132	147551564000	24815	12287	87	0	\N
188844	2132	147550563000	24815	12287	88	0	\N
188845	2132	147549562000	24815	12287	89	0	\N
188846	2132	147548561000	24815	12287	90	0	\N
188847	2132	147547560000	24815	12287	91	0	\N
188848	2132	147546559000	24815	12287	92	0	\N
188849	2133	91943528000	24815	12287	93	0	\N
188850	2133	91942526000	24815	12287	94	0	\N
188851	2133	91941524000	24815	12287	95	0	\N
188852	2133	91940522000	24815	12287	96	0	\N
188853	2133	91939520000	24815	12287	97	0	\N
188854	2133	91938518000	24815	12287	98	0	\N
188855	2133	91937516000	24815	12287	99	0	\N
188856	2133	91936514000	24815	12287	100	0	\N
188857	2133	91935512000	24815	12287	101	0	\N
188858	2133	91934510000	24815	12287	102	0	\N
188859	2133	91933508000	24815	12287	103	0	\N
188860	2133	91932506000	24815	12287	104	0	\N
188861	2133	91931504000	24815	12287	105	0	\N
188862	2133	91930502000	24815	12287	106	0	\N
188863	2133	91929500000	24815	12287	107	0	\N
188864	2133	91928498000	24815	12287	108	0	\N
188865	2133	91927496000	24815	12287	109	0	\N
188866	2133	91926494000	24815	12287	110	0	\N
188867	2133	91925492000	24815	12287	111	0	\N
188868	2133	91924490000	24815	12287	112	0	\N
188869	2133	91923488000	24815	12287	113	0	\N
188870	2133	91922486000	24815	12287	114	0	\N
188871	2134	85351355000	24815	12287	115	0	\N
188872	2134	85350352000	24815	12287	116	0	\N
188873	2134	85349349000	24815	12287	117	0	\N
188874	2134	85348346000	24815	12287	118	0	\N
188875	2134	85347343000	24815	12287	119	0	\N
188876	2134	85346340000	24815	12287	120	0	\N
188877	2134	85345337000	24815	12287	121	0	\N
188878	2134	85344334000	24815	12287	122	0	\N
188879	2134	85343331000	24815	12287	123	0	\N
188880	2134	85342328000	24815	12287	124	0	\N
188881	2134	85341325000	24815	12287	125	0	\N
188885	1692	1180542619999	24817	12323	0	0	\N
188886	1397	1290535188000	24817	12323	1	0	\N
188887	2132	147544557000	24817	12323	2	0	\N
188888	2134	85309229000	24817	12323	3	0	\N
188889	2133	91892426000	24817	12323	4	0	\N
188884	2133	91893428000	24816	12322	2	0	4788
188890	1692	1180542619999	24818	12323	0	0	6
188891	1397	1290535188000	24818	12323	1	0	14829
188892	2132	147544557000	24818	12323	2	0	1444
188893	2134	85309229000	24818	12323	3	0	5265
188895	1397	1290525187000	24819	12324	0	0	14830
188896	2133	91891424000	24819	12324	1	0	4790
188897	2134	85308226000	24819	12324	2	0	5266
188898	1397	1290515186000	24820	12325	0	0	14831
188899	1397	1290505185000	24820	12325	1	0	14832
188901	2058	531500000	24820	12325	3	0	11
188902	2314	427899000000	24820	12325	4	0	1
188903	2314	427389000000	24820	12325	5	0	2
188904	2134	85307223000	24820	12325	6	0	5267
188911	1397	1290515186000	24821	12325	0	0	\N
188912	1397	1290505185000	24821	12325	1	0	\N
188913	1397	1290495184000	24821	12325	2	0	\N
188914	2058	531500000	24821	12325	3	0	\N
188915	2314	427899000000	24821	12325	4	0	\N
188916	2314	427389000000	24821	12325	5	0	\N
188917	2134	85307223000	24821	12325	6	0	\N
188918	2133	91890422000	24821	12325	7	0	\N
188919	2133	91889420000	24821	12325	8	0	\N
188920	2133	91888418000	24821	12325	9	0	\N
188921	2134	85306220000	24821	12325	10	0	\N
188922	2132	147543556000	24821	12325	11	0	\N
188923	2134	85305217000	24821	12325	12	0	\N
188924	1397	1290485183000	24822	12326	0	0	\N
188925	2134	85304214000	24822	12326	1	0	\N
188926	2133	91887416000	24822	12326	2	0	\N
188930	1397	1290485183000	24824	12326	0	0	\N
188931	2134	85304214000	24824	12326	1	0	\N
188932	2133	91887416000	24824	12326	2	0	\N
188933	1397	1290475182000	24825	12327	0	0	\N
188934	1397	1290465181000	24825	12327	1	0	\N
188935	2314	879000000	24825	12327	2	0	\N
188936	2134	85303211000	24825	12327	3	0	\N
188937	2132	147542555000	24825	12327	4	0	\N
188938	2134	85302208000	24825	12327	5	0	\N
188939	2133	91886414000	24825	12327	6	0	\N
188940	2133	91885412000	24825	12327	7	0	\N
188941	1397	1290475182000	24826	12327	0	0	\N
188942	1397	1290465181000	24826	12327	1	0	\N
188943	2314	879000000	24826	12327	2	0	\N
188944	2134	85303211000	24826	12327	3	0	\N
188945	2132	147542555000	24826	12327	4	0	\N
188946	2134	85302208000	24826	12327	5	0	\N
188947	2133	91886414000	24826	12327	6	0	\N
188948	2133	91885412000	24826	12327	7	0	\N
188960	1397	1290455180000	24829	12328	0	0	\N
188961	2133	91884410000	24829	12328	1	0	\N
188962	2134	85301205000	24829	12328	2	0	\N
188963	1397	1290455180000	24830	12328	0	0	\N
188964	2133	91884410000	24830	12328	1	0	\N
188965	2134	85301205000	24830	12328	2	0	\N
188966	1397	1290455180000	24831	12328	0	0	\N
188967	2134	85301205000	24831	12328	1	0	\N
188971	1397	1290445179000	24833	12329	0	0	\N
188972	2134	85300202000	24833	12329	1	0	\N
188973	2133	91883408000	24833	12329	2	0	\N
188984	1397	1290405175000	24836	12332	0	0	\N
188985	1397	1290395174000	24836	12332	1	0	\N
188986	1397	1290385173000	24836	12332	2	0	\N
188987	2132	147540553000	24836	12332	3	0	\N
188988	2133	91879400000	24836	12332	4	0	\N
188989	2133	91878398000	24836	12332	5	0	\N
188990	2133	91877396000	24836	12332	6	0	\N
188991	2134	85296190000	24836	12332	7	0	\N
188992	2134	85295187000	24836	12332	8	0	\N
188993	2134	85294184000	24836	12332	10	0	\N
189004	1397	1290375172000	24838	12333	0	0	\N
189005	1397	1290365171000	24838	12333	1	0	\N
189006	2133	91876394000	24838	12333	2	0	\N
189007	2132	147539552000	24838	12333	3	0	\N
189008	2134	85293181000	24838	12333	4	0	\N
189009	2134	85292178000	24838	12333	5	0	\N
189010	2133	91875392000	24838	12333	6	0	\N
189018	1397	1290375172000	24840	12333	0	0	\N
189019	1397	1290365171000	24840	12333	1	0	\N
189020	2133	91876394000	24840	12333	2	0	\N
189021	2132	147539552000	24840	12333	3	0	\N
189022	2134	85293181000	24840	12333	4	0	\N
189023	2134	85292178000	24840	12333	5	0	\N
189024	2133	91875392000	24840	12333	6	0	\N
189025	1397	1290355170000	24841	12334	0	0	\N
189026	2133	91874390000	24841	12334	1	0	\N
189027	2134	85291175000	24841	12334	2	0	\N
189028	1397	1290355170000	24842	12334	0	0	\N
189029	2133	91874390000	24842	12334	1	0	\N
189030	2134	85291175000	24842	12334	2	0	\N
189037	1397	1290345169000	24846	12335	0	0	\N
189038	2134	85290172000	24846	12335	1	0	\N
188907	2133	91888418000	24820	12325	9	0	4793
188908	2134	85306220000	24820	12325	10	0	5268
188909	2132	147543556000	24820	12325	11	0	1445
188910	2134	85305217000	24820	12325	12	0	5269
188927	1397	1290485183000	24823	12326	0	0	14834
188929	2133	91887416000	24823	12326	2	0	4794
188949	1397	1290475182000	24827	12327	0	0	14835
188950	1397	1290465181000	24827	12327	1	0	14836
188951	2314	879000000	24827	12327	2	0	3
188952	2134	85303211000	24827	12327	3	0	5271
188954	2134	85302208000	24827	12327	5	0	5272
188955	2133	91886414000	24827	12327	6	0	4795
188956	2133	91885412000	24827	12327	7	0	4796
188957	1397	1290455180000	24828	12328	0	0	14837
188959	2134	85301205000	24828	12328	2	0	5273
188968	1397	1290445179000	24832	12329	0	0	14838
188969	2134	85300202000	24832	12329	1	0	5274
188970	2133	91883408000	24832	12329	2	0	4798
188974	1397	1290435178000	24834	12330	0	0	14839
188976	2134	85299199000	24834	12330	2	0	5275
188977	2134	85298196000	24834	12330	3	0	5276
188978	2132	147541554000	24834	12330	4	0	1447
188979	2133	91882406000	24834	12330	5	0	4799
188980	2133	91881404000	24834	12330	6	0	4800
188982	2133	91880402000	24835	12331	1	0	4801
188983	2134	85297193000	24835	12331	2	0	5277
188994	1397	1290405175000	24837	12332	0	0	14842
188995	1397	1290395174000	24837	12332	1	0	14843
188997	2132	147540553000	24837	12332	3	0	1448
188998	2133	91879400000	24837	12332	4	0	4802
188999	2133	91878398000	24837	12332	5	0	4803
189000	2133	91877396000	24837	12332	6	0	4804
189001	2134	85296190000	24837	12332	7	0	5278
189003	2134	85294184000	24837	12332	10	0	5280
189011	1397	1290375172000	24839	12333	0	0	14845
189012	1397	1290365171000	24839	12333	1	0	14846
189013	2133	91876394000	24839	12333	2	0	4805
189014	2132	147539552000	24839	12333	3	0	1449
189016	2134	85292178000	24839	12333	5	0	5282
189017	2133	91875392000	24839	12333	6	0	4806
189031	1397	1290355170000	24843	12334	0	0	14847
189032	2133	91874390000	24843	12334	1	0	4807
189034	1397	1290345169000	24845	12335	0	0	14848
189035	2133	91873388000	24845	12335	1	0	4808
189036	2134	85290172000	24845	12335	2	0	5284
189039	1397	1290335168000	24847	12336	0	0	14849
189040	2134	85289169000	24847	12336	1	0	5285
189043	1397	1290335168000	24848	12336	0	0	\N
189044	2134	85289169000	24848	12336	1	0	\N
189045	2132	147538551000	24848	12336	2	0	\N
189046	2133	91872386000	24848	12336	3	0	\N
189075	1397	1290245159000	24853	12341	0	0	\N
189076	2134	85280142000	24853	12341	1	0	\N
189077	2133	91863368000	24853	12341	2	0	\N
189088	1397	1290235158000	24856	12342	0	0	\N
189089	1397	1290225157000	24856	12342	1	0	\N
189090	2134	85279139000	24856	12342	2	0	\N
189091	2134	85278136000	24856	12342	3	0	\N
189092	2132	147535548000	24856	12342	4	0	\N
189093	2133	91862366000	24856	12342	5	0	\N
189094	2133	91861364000	24856	12342	6	0	\N
189095	1397	1290235158000	24857	12342	0	0	\N
189096	1397	1290225157000	24857	12342	1	0	\N
189097	2134	85279139000	24857	12342	2	0	\N
189098	2134	85278136000	24857	12342	3	0	\N
189099	2132	147535548000	24857	12342	4	0	\N
189100	2133	91862366000	24857	12342	5	0	\N
189101	2133	91861364000	24857	12342	6	0	\N
189105	1397	1290205155000	24859	12344	0	0	\N
189106	1397	1290195154000	24859	12344	1	0	\N
189107	2134	85276130000	24859	12344	2	0	\N
189108	2133	91859360000	24859	12344	3	0	\N
189109	2133	91858358000	24859	12344	4	0	\N
189110	2132	147534547000	24859	12344	5	0	\N
189111	1769	1578900000	24859	12344	6	0	\N
189112	2134	85275127000	24859	12344	7	0	\N
189113	1397	1290205155000	24860	12344	0	0	\N
189114	1397	1290195154000	24860	12344	1	0	\N
189115	2134	85276130000	24860	12344	2	0	\N
189116	2133	91859360000	24860	12344	3	0	\N
189117	2133	91858358000	24860	12344	4	0	\N
189118	2132	147534547000	24860	12344	5	0	\N
189119	1769	1578900000	24860	12344	6	0	\N
189120	2134	85275127000	24860	12344	7	0	\N
189141	1397	1290155150000	24864	12347	0	0	\N
189142	2134	85271115000	24864	12347	1	0	\N
189143	2133	91854350000	24864	12347	2	0	\N
189144	1397	1290155150000	24865	12347	0	0	\N
189145	2134	85271115000	24865	12347	1	0	\N
189146	2133	91854350000	24865	12347	2	0	\N
189147	1397	1290155150000	24866	12347	0	0	\N
189148	2133	91854350000	24866	12347	1	0	\N
189149	1397	1290155150000	24867	12347	0	0	\N
189150	2134	85271115000	24867	12347	1	0	\N
189151	2133	91854350000	24867	12347	2	0	\N
189153	1397	1290155150000	24869	12347	0	0	\N
189154	2134	85271115000	24869	12347	1	0	\N
189155	2133	91854350000	24869	12347	2	0	\N
189156	2134	85271115000	24870	12347	0	0	\N
189047	1397	1290325167000	24849	12337	0	0	14850
189048	1397	1290315166000	24849	12337	1	0	14851
189049	1397	1290305165000	24849	12337	2	0	14852
189050	1860	1968700000	24849	12337	3	0	5
189051	2133	91871384000	24849	12337	4	0	4810
189053	2133	91869380000	24849	12337	6	0	4812
189054	2134	85288166000	24849	12337	7	0	5286
189055	2134	85287163000	24849	12337	8	0	5287
189056	2134	85286160000	24849	12337	9	0	5288
189057	1397	1290295164000	24850	12338	0	0	14853
189059	2132	147537550000	24850	12338	2	0	1451
189060	2134	85285157000	24850	12338	3	0	5289
189061	2133	91868378000	24850	12338	4	0	4813
189062	2133	91867376000	24850	12338	5	0	4814
189064	1397	1290275162000	24851	12339	0	0	14855
189065	1397	1290265161000	24851	12339	1	0	14856
189066	2132	147536549000	24851	12339	2	0	1452
189067	2133	91866374000	24851	12339	3	0	4815
189068	2134	85283151000	24851	12339	4	0	5291
189070	2133	91865372000	24851	12339	6	0	4816
189071	441	66000148845612	24852	12340	0	0	2
189072	1397	1290255160000	24852	12340	1	0	14857
189073	2134	85281145000	24852	12340	2	0	5293
189074	2133	91864370000	24852	12340	3	0	4817
189079	2134	85280142000	24854	12341	1	0	5294
189080	2133	91863368000	24854	12341	2	0	4818
189081	1397	1290235158000	24855	12342	0	0	14859
189082	1397	1290225157000	24855	12342	1	0	14860
189084	2134	85278136000	24855	12342	3	0	5296
189085	2132	147535548000	24855	12342	4	0	1453
189086	2133	91862366000	24855	12342	5	0	4819
189087	2133	91861364000	24855	12342	6	0	4820
189102	1397	1290215156000	24858	12343	0	0	14861
189104	2134	85277133000	24858	12343	2	0	5297
189121	1397	1290205155000	24861	12344	0	0	14862
189122	1397	1290195154000	24861	12344	1	0	14863
189123	2134	85276130000	24861	12344	2	0	5298
189124	2133	91859360000	24861	12344	3	0	4822
189126	2132	147534547000	24861	12344	5	0	1454
189127	1769	1578900000	24861	12344	6	0	55
189128	2134	85275127000	24861	12344	7	0	5299
189129	1397	1290185153000	24862	12345	0	0	14864
189131	2133	91857356000	24862	12345	2	0	4824
189132	2133	91856354000	24862	12345	3	0	4825
189133	1769	1576700000	24862	12345	4	0	56
189134	2134	85274124000	24862	12345	5	0	5300
189135	2134	85273121000	24862	12345	6	0	5301
189137	2134	85272118000	24863	12346	1	0	5302
189138	1769	1575700000	24863	12346	2	0	57
189139	2132	147533546000	24863	12346	3	0	1455
189140	2133	91855352000	24863	12346	4	0	4826
189152	2134	85271115000	24868	12347	0	0	5303
189158	1397	1290145149000	24871	12348	1	0	14868
189159	238	66112415123421	24871	12348	2	0	5
189160	1397	1290135148000	24871	12348	3	0	14869
189161	1397	1290125147000	24871	12348	4	0	14870
189163	1769	1574700000	24871	12348	6	0	58
189164	2132	147532545000	24871	12348	7	0	1456
189165	2133	91854350000	24871	12348	8	0	4827
189166	2133	91853348000	24871	12348	9	0	4828
189167	2133	91852346000	24871	12348	10	0	4829
189169	2133	91850342000	24871	12348	12	0	4831
189170	2134	85269109000	24871	12348	13	0	5305
189171	2134	85268106000	24871	12348	14	0	5306
189172	2134	85267103000	24871	12348	16	0	5307
189173	1397	1290115146000	24872	12349	0	0	14871
189175	2133	91849340000	24872	12349	2	0	4832
189176	1397	1290105145000	24873	12350	0	0	14872
189180	1397	1290105145000	24874	12350	0	0	\N
189181	2134	85265097000	24874	12350	1	0	\N
189182	2133	91848338000	24874	12350	2	0	\N
189183	2132	147531544000	24874	12350	3	0	\N
189187	1397	1290095144000	24876	12351	0	0	\N
189188	2133	91847336000	24876	12351	1	0	\N
189189	2134	85264094000	24876	12351	2	0	\N
189190	1397	1290095144000	24877	12351	0	0	\N
189191	2133	91847336000	24877	12351	1	0	\N
189192	2134	85264094000	24877	12351	2	0	\N
189193	1397	1290095144000	24878	12351	0	0	\N
189194	2133	91847336000	24878	12351	1	0	\N
189195	2134	85264094000	24878	12351	2	0	\N
189203	238	66111405123421	24881	12353	0	0	\N
189204	1397	1290075142000	24881	12353	1	0	\N
189205	2132	147530543000	24881	12353	2	0	\N
189206	2133	91845332000	24881	12353	3	0	\N
189207	1397	1290065141000	24882	12354	0	0	\N
189208	2133	91844330000	24882	12354	1	0	\N
189209	2134	85262088000	24882	12354	2	0	\N
189213	1397	1290055140000	24884	12355	0	0	\N
189214	2133	91843328000	24884	12355	1	0	\N
189215	2134	85261085000	24884	12355	2	0	\N
189222	1397	1290035138000	24887	12357	0	0	\N
189223	2133	91842326000	24887	12357	1	0	\N
189224	2134	85259079000	24887	12357	2	0	\N
189225	1397	1290035138000	24888	12357	0	0	\N
189226	2133	91842326000	24888	12357	1	0	\N
189227	2134	85259079000	24888	12357	2	0	\N
189231	1397	1290025137000	24890	12358	0	0	\N
189232	2133	91841324000	24890	12358	1	0	\N
189233	2134	85258076000	24890	12358	2	0	\N
189245	1397	1290025137000	24893	12359	0	0	\N
189246	1397	1290015136000	24893	12359	1	0	\N
189247	1397	1290005135000	24893	12359	2	0	\N
189248	2133	91840322000	24893	12359	3	0	\N
189249	2132	147528541000	24893	12359	4	0	\N
189250	2133	91839320000	24893	12359	5	0	\N
189251	1769	1573700000	24893	12359	6	0	\N
189252	2134	85257073000	24893	12359	7	0	\N
189253	2134	85256070000	24893	12359	8	0	\N
189257	1397	1289995134000	24895	12360	0	0	\N
189258	2134	85255067000	24895	12360	1	0	\N
189259	2133	91838318000	24895	12360	2	0	\N
189273	1397	1289945129000	24899	12364	0	0	\N
189274	2134	85250052000	24899	12364	1	0	\N
189275	2132	147526539000	24899	12364	2	0	\N
189276	2133	91833308000	24899	12364	3	0	\N
189277	1397	1289945129000	24900	12364	0	0	\N
189278	2134	85250052000	24900	12364	1	0	\N
189279	2132	147526539000	24900	12364	2	0	\N
189280	2133	91833308000	24900	12364	3	0	\N
189291	1397	1289935128000	24903	12365	0	0	\N
189292	1397	1289925127000	24903	12365	1	0	\N
189293	2134	85249049000	24903	12365	2	0	\N
189294	2134	85248046000	24903	12365	3	0	\N
189295	2133	91832306000	24903	12365	4	0	\N
189296	2133	91831304000	24903	12365	5	0	\N
189297	1397	1289915126000	24904	12366	0	0	\N
189298	2133	91830302000	24904	12366	1	0	\N
189299	2134	85247043000	24904	12366	2	0	\N
189307	1397	1289905125000	24907	12367	0	0	\N
189308	2134	85246040000	24907	12367	1	0	\N
189309	2133	91829300000	24907	12367	2	0	\N
189310	2132	147525538000	24907	12367	3	0	\N
189311	1397	1289905125000	24908	12367	0	0	\N
189312	2134	85246040000	24908	12367	1	0	\N
189179	2132	147531544000	24873	12350	3	0	1457
189184	1397	1290095144000	24875	12351	0	0	14873
189185	2133	91847336000	24875	12351	1	0	4834
189186	2134	85264094000	24875	12351	2	0	5310
189196	1397	1290085143000	24879	12352	0	0	14874
189198	2134	85263091000	24879	12352	2	0	5311
189199	238	66111405123421	24880	12353	0	0	6
189200	1397	1290075142000	24880	12353	1	0	14875
189201	2132	147530543000	24880	12353	2	0	1458
189202	2133	91845332000	24880	12353	3	0	4836
189211	2133	91844330000	24883	12354	1	0	4837
189212	2134	85262088000	24883	12354	2	0	5312
189216	1397	1290055140000	24885	12355	0	0	14877
189217	2133	91843328000	24885	12355	1	0	4838
189219	1397	1290045139000	24886	12356	0	0	14878
189220	2132	147529542000	24886	12356	1	0	1459
189221	2134	85260082000	24886	12356	2	0	5314
189228	1397	1290035138000	24889	12357	0	0	14879
189229	2133	91842326000	24889	12357	1	0	4839
189234	2133	91841324000	24891	12358	0	0	4840
189235	2134	85258076000	24891	12358	1	0	5316
189236	1397	1290025137000	24892	12359	0	0	14880
189237	1397	1290015136000	24892	12359	1	0	14881
189238	1397	1290005135000	24892	12359	2	0	14882
189240	2132	147528541000	24892	12359	4	0	1460
189241	2133	91839320000	24892	12359	5	0	4842
189242	1769	1573700000	24892	12359	6	0	59
189243	2134	85257073000	24892	12359	7	0	5317
189254	1397	1289995134000	24894	12360	0	0	14883
189255	2134	85255067000	24894	12360	1	0	5319
189256	2133	91838318000	24894	12360	2	0	4843
189260	1397	1289985133000	24896	12361	0	0	14884
189261	2134	85254064000	24896	12361	1	0	5320
189263	1397	1289975132000	24897	12362	0	0	14885
189264	2134	85253061000	24897	12362	1	0	5321
189265	2133	91836314000	24897	12362	2	0	4845
189266	2132	147527540000	24897	12362	3	0	1461
189267	1397	1289965131000	24898	12363	0	0	14886
189269	2133	91835312000	24898	12363	2	0	4846
189270	2133	91834310000	24898	12363	3	0	4847
189271	2134	85252058000	24898	12363	4	0	5322
189272	2134	85251055000	24898	12363	5	0	5323
189282	2134	85250052000	24901	12364	1	0	5324
189283	2132	147526539000	24901	12364	2	0	1462
189284	2133	91833308000	24901	12364	3	0	4848
189285	1397	1289935128000	24902	12365	0	0	14889
189286	1397	1289925127000	24902	12365	1	0	14890
189288	2134	85248046000	24902	12365	3	0	5326
189289	2133	91832306000	24902	12365	4	0	4849
189290	2133	91831304000	24902	12365	5	0	4850
189300	1397	1289915126000	24905	12366	0	0	14891
189301	2133	91830302000	24905	12366	1	0	4851
189303	1397	1289905125000	24906	12367	0	0	14892
189304	2134	85246040000	24906	12367	1	0	5328
189305	2133	91829300000	24906	12367	2	0	4852
189306	2132	147525538000	24906	12367	3	0	1463
189313	2133	91829300000	24908	12367	2	0	\N
189314	2132	147525538000	24908	12367	3	0	\N
189315	1397	1289895124000	24909	12368	0	0	\N
189316	2133	91828298000	24909	12368	1	0	\N
189317	2134	85245037000	24909	12368	2	0	\N
189321	1397	1289895124000	24911	12368	0	0	\N
189322	2133	91828298000	24911	12368	1	0	\N
189323	2134	85245037000	24911	12368	2	0	\N
189324	1397	1289885123000	24912	12369	0	0	\N
189325	2134	85244034000	24912	12369	1	0	\N
189326	2133	91827296000	24912	12369	2	0	\N
189327	1397	1289885123000	24913	12369	0	0	\N
189328	2134	85244034000	24913	12369	1	0	\N
189329	2133	91827296000	24913	12369	2	0	\N
189333	1397	1289885123000	24915	12369	0	0	\N
189334	2134	85244034000	24915	12369	1	0	\N
189335	2133	91827296000	24915	12369	2	0	\N
189336	1397	1289885123000	24916	12369	0	0	\N
189337	2134	85244034000	24916	12369	1	0	\N
189338	2133	91827296000	24916	12369	2	0	\N
189339	1397	1289875122000	24917	12370	0	0	\N
189340	2133	91826294000	24917	12370	1	0	\N
189341	2132	147524537000	24917	12370	2	0	\N
189342	2134	85243031000	24917	12370	4	0	\N
189357	1397	1289835118000	24922	12374	0	0	\N
189358	2134	85239019000	24922	12374	1	0	\N
189359	2133	91822286000	24922	12374	2	0	\N
189360	1397	1289845119000	24923	12373	0	0	\N
189361	1397	1289835118000	24923	12373	1	0	\N
189362	2133	91823288000	24923	12373	2	0	\N
189363	2134	85240022000	24923	12373	3	0	\N
189364	2134	85239019000	24923	12373	4	0	\N
189365	2133	91822286000	24923	12373	5	0	\N
189366	2132	147523536000	24923	12373	6	0	\N
189376	1397	1289835118000	24926	12375	0	0	\N
189377	1397	1289825117000	24926	12375	1	0	\N
189378	1397	1289815116000	24926	12375	2	0	\N
189379	2134	85238016000	24926	12375	3	0	\N
189380	2134	85237013000	24926	12375	4	0	\N
189381	2133	91821284000	24926	12375	5	0	\N
189382	2133	91820282000	24926	12375	6	0	\N
189383	1397	1289835118000	24927	12375	0	0	\N
189384	1397	1289825117000	24927	12375	1	0	\N
189385	1397	1289815116000	24927	12375	2	0	\N
189386	2134	85238016000	24927	12375	3	0	\N
189387	2134	85237013000	24927	12375	4	0	\N
189388	2133	91821284000	24927	12375	5	0	\N
189389	2133	91820282000	24927	12375	6	0	\N
189390	1397	1289835118000	24928	12375	0	0	\N
189391	1397	1289825117000	24928	12375	1	0	\N
189392	1397	1289815116000	24928	12375	2	0	\N
189393	2134	85238016000	24928	12375	3	0	\N
189394	2134	85237013000	24928	12375	4	0	\N
189395	2133	91821284000	24928	12375	5	0	\N
189396	2133	91820282000	24928	12375	6	0	\N
189397	2134	85238016000	24929	12375	0	0	\N
189398	2134	85237013000	24929	12375	1	0	\N
189399	2133	91821284000	24929	12375	2	0	\N
189400	2133	91820282000	24929	12375	3	0	\N
189401	441	66000148845612	24930	12298	0	0	\N
189402	114	66117956901851	24930	12298	1	0	\N
189403	1692	460530619999	24930	12298	2	0	\N
189404	114	66116946901851	24930	12298	3	0	\N
189405	238	66112415123421	24930	12298	4	0	\N
189406	238	66111405123421	24930	12298	5	0	\N
189407	283	66001719734615	24930	12298	6	0	\N
189408	114	66000936901851	24930	12298	7	0	\N
189409	301	66002710734615	24930	12298	8	0	\N
189410	10	32558282617398	24930	12298	9	0	\N
189411	1397	1290875222000	24930	12298	10	0	\N
189412	1397	1290865221000	24930	12298	11	0	\N
189413	1397	1290855220000	24930	12298	12	0	\N
189414	1397	1290845219000	24930	12298	13	0	\N
189415	1397	1290835218000	24930	12298	14	0	\N
189416	1397	1290825217000	24930	12298	15	0	\N
189417	1397	1290815216000	24930	12298	16	0	\N
189418	1397	1290805215000	24930	12298	17	0	\N
189419	1397	1290795214000	24930	12298	18	0	\N
189420	1397	1290785213000	24930	12298	19	0	\N
189421	1397	1290775212000	24930	12298	20	0	\N
189422	1397	1290765211000	24930	12298	21	0	\N
189423	1397	1290755210000	24930	12298	22	0	\N
189424	1397	1290745209000	24930	12298	23	0	\N
189425	1397	1290735208000	24930	12298	24	0	\N
189426	1397	1290725207000	24930	12298	25	0	\N
189427	1397	1290715206000	24930	12298	26	0	\N
189428	1397	1290705205000	24930	12298	27	0	\N
189429	1397	1290695204000	24930	12298	28	0	\N
189430	1397	1290685203000	24930	12298	29	0	\N
189431	1397	1290675202000	24930	12298	30	0	\N
189432	1397	1290665201000	24930	12298	31	0	\N
189433	1397	1290655200000	24930	12298	32	0	\N
189434	1397	1290645199000	24930	12298	33	0	\N
189435	1397	1290635198000	24930	12298	34	0	\N
189436	1397	1290625197000	24930	12298	35	0	\N
189437	1397	1290615196000	24930	12298	36	0	\N
189438	1397	1290605195000	24930	12298	37	0	\N
189439	1397	1290595194000	24930	12298	38	0	\N
189440	1397	1290585193000	24930	12298	39	0	\N
189441	1397	1290575192000	24930	12298	40	0	\N
189442	1397	1290565191000	24930	12298	41	0	\N
189443	1397	1290555190000	24930	12298	42	0	\N
189444	1397	1290545189000	24930	12298	43	0	\N
189445	1397	1290535188000	24930	12298	44	0	\N
189446	1397	1290525187000	24930	12298	45	0	\N
189447	1397	1290515186000	24930	12298	46	0	\N
189448	1397	1290505185000	24930	12298	47	0	\N
189320	2134	85245037000	24910	12368	2	0	5329
189330	1397	1289885123000	24914	12369	0	0	14894
189331	2134	85244034000	24914	12369	1	0	5330
189332	2133	91827296000	24914	12369	2	0	4854
189343	1397	1289875122000	24918	12370	0	0	14895
189345	2132	147524537000	24918	12370	2	0	1464
189346	2134	85243031000	24918	12370	4	0	5331
189347	1397	1289865121000	24919	12371	0	0	14896
189348	2133	91825292000	24919	12371	1	0	4856
189349	2134	85242028000	24919	12371	2	0	5332
189351	2134	85241025000	24920	12372	1	0	5333
189352	2133	91824290000	24920	12372	2	0	4857
189353	1397	1289845119000	24921	12373	0	0	14898
189354	2133	91823288000	24921	12373	1	0	4858
189356	2132	147523536000	24921	12373	3	0	1465
189367	2134	85239019000	24924	12374	0	0	5335
189368	2133	91822286000	24924	12374	1	0	4859
189369	1397	1289835118000	24925	12375	0	0	14899
189370	1397	1289825117000	24925	12375	1	0	14900
189372	2134	85238016000	24925	12375	3	0	5336
189373	2134	85237013000	24925	12375	4	0	5337
189374	2133	91821284000	24925	12375	5	0	4860
189375	2133	91820282000	24925	12375	6	0	4861
189449	1397	1290495184000	24930	12298	48	0	\N
189450	1397	1290485183000	24930	12298	49	0	\N
189451	1397	1290475182000	24930	12298	50	0	\N
189452	1397	1290465181000	24930	12298	51	0	\N
189453	1397	1290455180000	24930	12298	52	0	\N
189454	1397	1290445179000	24930	12298	53	0	\N
189455	1397	1290435178000	24930	12298	54	0	\N
189456	1397	1290425177000	24930	12298	55	0	\N
189457	1397	1290415176000	24930	12298	56	0	\N
189458	1397	1290405175000	24930	12298	57	0	\N
189459	1397	1290395174000	24930	12298	58	0	\N
189460	1397	1290385173000	24930	12298	59	0	\N
189461	1397	1290375172000	24930	12298	60	0	\N
189462	1397	1290365171000	24930	12298	61	0	\N
189463	1397	1290355170000	24930	12298	62	0	\N
189464	1397	1290345169000	24930	12298	63	0	\N
189465	1397	1290335168000	24930	12298	64	0	\N
189466	1397	1290325167000	24930	12298	65	0	\N
189467	1397	1290315166000	24930	12298	66	0	\N
189468	1397	1290305165000	24930	12298	67	0	\N
189469	1397	1290295164000	24930	12298	68	0	\N
189470	1397	1290285163000	24930	12298	69	0	\N
189471	1397	1290275162000	24930	12298	70	0	\N
189472	1397	1290265161000	24930	12298	71	0	\N
189473	1397	1290255160000	24930	12298	72	0	\N
189474	1397	1290245159000	24930	12298	73	0	\N
189475	1397	1290235158000	24930	12298	74	0	\N
189476	1397	1290225157000	24930	12298	75	0	\N
189477	1397	1290215156000	24930	12298	76	0	\N
189478	1397	1290205155000	24930	12298	77	0	\N
189479	1397	1290195154000	24930	12298	78	0	\N
189480	1397	1290185153000	24930	12298	79	0	\N
189481	1397	1290175152000	24930	12298	80	0	\N
189482	1397	1290165151000	24930	12298	81	0	\N
189483	1397	1290155150000	24930	12298	82	0	\N
189484	1397	1290145149000	24930	12298	83	0	\N
189485	1397	1290135148000	24930	12298	84	0	\N
189486	1397	1290125147000	24930	12298	85	0	\N
189487	1397	1290115146000	24930	12298	86	0	\N
189488	1397	1290105145000	24930	12298	87	0	\N
189489	1397	1290095144000	24930	12298	88	0	\N
189490	1397	1290085143000	24930	12298	89	0	\N
189491	1397	1290075142000	24930	12298	90	0	\N
189492	1397	1290065141000	24930	12298	91	0	\N
189493	1397	1290055140000	24930	12298	92	0	\N
189494	1397	1290045139000	24930	12298	93	0	\N
189495	1397	1290035138000	24930	12298	94	0	\N
189496	1397	1290025137000	24930	12298	95	0	\N
189497	1397	1290015136000	24930	12298	96	0	\N
189498	1397	1290005135000	24930	12298	97	0	\N
189499	1397	1289995134000	24930	12298	98	0	\N
189500	1397	1289985133000	24930	12298	99	0	\N
189501	1397	1289975132000	24930	12298	100	0	\N
189502	1397	1289965131000	24930	12298	101	0	\N
189503	1397	1289955130000	24930	12298	102	0	\N
189504	1397	1289945129000	24930	12298	103	0	\N
189505	1397	1289935128000	24930	12298	104	0	\N
189506	1397	1289925127000	24930	12298	105	0	\N
189507	1397	1289915126000	24930	12298	106	0	\N
189508	1397	1289905125000	24930	12298	107	0	\N
189509	1397	1289895124000	24930	12298	108	0	\N
189510	1397	1289885123000	24930	12298	109	0	\N
189511	1397	1289875122000	24930	12298	110	0	\N
189512	1397	1289865121000	24930	12298	111	0	\N
189513	1397	1289855120000	24930	12298	112	0	\N
189514	1397	1289845119000	24930	12298	113	0	\N
189515	1397	1289835118000	24930	12298	114	0	\N
189516	1397	1289825117000	24930	12298	115	0	\N
189517	1397	1289815116000	24930	12298	116	0	\N
189518	2058	531500000	24930	12298	118	0	\N
189519	2133	91926494000	24930	12298	119	0	\N
189520	1926	1190000000	24930	12298	120	0	\N
189521	2134	85342328000	24930	12298	121	0	\N
189522	2134	85341325000	24930	12298	122	0	\N
189523	2134	85340322000	24930	12298	123	0	\N
189524	2134	85339319000	24930	12298	124	0	\N
189525	2134	85338316000	24930	12298	125	0	\N
189530	1397	1289795114000	24933	12377	0	0	\N
189531	2133	91818278000	24933	12377	1	0	\N
189532	2134	85235007000	24933	12377	2	0	\N
189533	1397	1289795114000	24934	12377	0	0	\N
189534	2133	91818278000	24934	12377	1	0	\N
189535	2134	85235007000	24934	12377	2	0	\N
189539	1397	1289885123000	24936	12369	0	0	\N
189540	1397	1289875122000	24936	12369	1	0	\N
189541	1397	1289865121000	24936	12369	2	0	\N
189542	1397	1289855120000	24936	12369	3	0	\N
189543	1397	1289845119000	24936	12369	4	0	\N
189544	1397	1289835118000	24936	12369	5	0	\N
189545	1397	1289825117000	24936	12369	6	0	\N
189546	1397	1289815116000	24936	12369	7	0	\N
189547	1397	1289805115000	24936	12369	9	0	\N
189548	2134	85244034000	24936	12369	10	0	\N
189549	2132	147524537000	24936	12369	11	0	\N
189550	2133	91827296000	24936	12369	12	0	\N
189551	2133	91826294000	24936	12369	13	0	\N
189552	2133	91825292000	24936	12369	14	0	\N
189553	2134	85243031000	24936	12369	15	0	\N
189554	2132	147523536000	24936	12369	16	0	\N
189555	2133	91824290000	24936	12369	17	0	\N
189556	2133	91823288000	24936	12369	18	0	\N
189557	2133	91822286000	24936	12369	19	0	\N
189558	2133	91821284000	24936	12369	20	0	\N
189559	2133	91820282000	24936	12369	21	0	\N
189560	2134	85242028000	24936	12369	22	0	\N
189561	2134	85241025000	24936	12369	23	0	\N
189562	2134	85240022000	24936	12369	24	0	\N
189563	2134	85239019000	24936	12369	25	0	\N
189564	2134	85238016000	24936	12369	26	0	\N
189565	2134	85237013000	24936	12369	27	0	\N
189566	2134	85236010000	24936	12369	28	0	\N
189567	2133	91819280000	24936	12369	29	0	\N
189568	2132	147522535000	24936	12369	30	0	\N
189582	1397	1289765111000	24941	12380	0	0	\N
189583	1397	1289755110000	24941	12380	1	0	\N
189584	2134	85231998000	24941	12380	2	0	\N
189528	2133	91819280000	24932	12376	2	0	4862
189529	2132	147522535000	24932	12376	3	0	1466
189536	1397	1289795114000	24935	12377	0	0	14903
189537	2133	91818278000	24935	12377	1	0	4863
189538	2134	85235007000	24935	12377	2	0	5339
189570	2134	85234004000	24937	12378	1	0	5340
189571	2133	91817276000	24937	12378	2	0	4864
189572	1397	1289775112000	24938	12379	0	0	14905
189573	2134	85233001000	24938	12379	1	0	5341
189574	2133	91816274000	24938	12379	2	0	4865
189576	1397	1289765111000	24940	12380	0	0	14906
189577	1397	1289755110000	24940	12380	1	0	14907
189578	2134	85231998000	24940	12380	2	0	5342
189579	2134	85230995000	24940	12380	3	0	5343
189581	2133	91814270000	24940	12380	5	0	4867
189585	2134	85230995000	24941	12380	3	0	\N
189586	2133	91815272000	24941	12380	4	0	\N
189587	2133	91814270000	24941	12380	5	0	\N
189595	2132	147520533000	24948	12382	0	0	\N
189596	2134	85228989000	24948	12382	1	0	\N
189597	2133	91812266000	24948	12382	2	0	\N
189601	1397	1289795114000	24953	12370	0	0	\N
189602	1397	1289785113000	24953	12370	1	0	\N
189603	1397	1289775112000	24953	12370	2	0	\N
189604	1397	1289765111000	24953	12370	3	0	\N
189605	1397	1289755110000	24953	12370	4	0	\N
189606	1397	1289745109000	24953	12370	5	0	\N
189607	1397	1289735108000	24953	12370	6	0	\N
189608	1397	1289725107000	24953	12370	7	0	\N
189609	2132	147521534000	24953	12370	8	0	\N
189610	2132	147520533000	24953	12370	9	0	\N
189611	2133	91818278000	24953	12370	10	0	\N
189612	2133	91817276000	24953	12370	11	0	\N
189613	2133	91816274000	24953	12370	12	0	\N
189614	2133	91815272000	24953	12370	13	0	\N
189615	2133	91814270000	24953	12370	14	0	\N
189616	2133	91813268000	24953	12370	15	0	\N
189617	2133	91812266000	24953	12370	16	0	\N
189618	2133	91811264000	24953	12370	17	0	\N
189619	2134	85235007000	24953	12370	18	0	\N
189620	2134	85234004000	24953	12370	19	0	\N
189621	2134	85233001000	24953	12370	20	0	\N
189622	2134	85231998000	24953	12370	21	0	\N
189623	2134	85230995000	24953	12370	22	0	\N
189624	2134	85229992000	24953	12370	23	0	\N
189625	2134	85228989000	24953	12370	24	0	\N
189626	2134	85227986000	24953	12370	25	0	\N
189627	1397	1289715106000	24954	12384	0	0	\N
189628	2133	91810262000	24954	12384	1	0	\N
189629	2134	85226983000	24954	12384	2	0	\N
189637	1397	1289705105000	24957	12385	0	0	\N
189638	2134	85225980000	24957	12385	1	0	\N
189639	2132	147519532000	24957	12385	2	0	\N
189640	2133	91809260000	24957	12385	3	0	\N
189641	1397	1289695104000	24958	12386	0	0	\N
189642	2133	91808258000	24958	12386	1	0	\N
189643	2134	85224977000	24958	12386	2	0	\N
189644	1397	1289695104000	24959	12386	0	0	\N
189645	2134	85224977000	24959	12386	1	0	\N
189646	1397	1289695104000	24960	12386	0	0	\N
189647	2133	91808258000	24960	12386	1	0	\N
189648	2134	85224977000	24960	12386	2	0	\N
189660	1397	1289685103000	24963	12387	0	0	\N
189661	1397	1289675102000	24963	12387	1	0	\N
189662	2314	869000000	24963	12387	2	0	\N
189663	2134	85223974000	24963	12387	3	0	\N
189664	2134	85222971000	24963	12387	4	0	\N
189665	2132	147518531000	24963	12387	5	0	\N
189666	2133	91807256000	24963	12387	6	0	\N
189667	2133	91806254000	24963	12387	7	0	\N
189687	1397	1289615096000	24968	12391	0	0	\N
189688	2133	91800242000	24968	12391	2	0	\N
189689	2134	85216953000	24968	12391	3	0	\N
189696	1397	1289595094000	24971	12393	0	0	\N
189697	2134	85214947000	24971	12393	1	0	\N
189698	2133	91798238000	24971	12393	2	0	\N
189699	1397	1289595094000	24972	12393	0	0	\N
189708	1397	1289585093000	24974	12394	0	0	\N
189709	1397	1289575092000	24974	12394	1	0	\N
189710	2134	85214947000	24974	12394	2	0	\N
189711	2134	85213944000	24974	12394	3	0	\N
189712	2134	85212941000	24974	12394	4	0	\N
189713	2133	91797236000	24974	12394	5	0	\N
189714	2133	91796234000	24974	12394	6	0	\N
189715	2132	147515528000	24974	12394	7	0	\N
189716	1397	1289585093000	24975	12394	0	0	\N
189717	1397	1289575092000	24975	12394	1	0	\N
189718	2134	85214947000	24975	12394	2	0	\N
189719	2134	85213944000	24975	12394	3	0	\N
189720	2134	85212941000	24975	12394	4	0	\N
189590	2134	85229992000	24945	12381	2	0	5344
189591	1397	1289735108000	24947	12382	0	0	14909
189592	2132	147520533000	24947	12382	1	0	1468
189593	2134	85228989000	24947	12382	2	0	5345
189594	2133	91812266000	24947	12382	3	0	4869
189599	2134	85227986000	24952	12383	1	0	5346
189600	2133	91811264000	24952	12383	2	0	4870
189630	1397	1289715106000	24955	12384	0	0	14911
189631	2133	91810262000	24955	12384	1	0	4871
189632	2134	85226983000	24955	12384	2	0	5347
189634	2134	85225980000	24956	12385	1	0	5348
189635	2132	147519532000	24956	12385	2	0	1469
189636	2133	91809260000	24956	12385	3	0	4872
189649	1397	1289695104000	24961	12386	0	0	14913
189651	2134	85224977000	24961	12386	2	0	5349
189652	1397	1289685103000	24962	12387	0	0	14914
189653	1397	1289675102000	24962	12387	1	0	14915
189654	2314	869000000	24962	12387	2	0	4
189655	2134	85223974000	24962	12387	3	0	5350
189657	2132	147518531000	24962	12387	5	0	1470
189658	2133	91807256000	24962	12387	6	0	4874
189659	2133	91806254000	24962	12387	7	0	4875
189668	1397	1289665101000	24964	12388	0	0	14916
189669	2133	91805252000	24964	12388	1	0	4876
189671	1397	1289655100000	24965	12389	0	0	14917
189672	2134	85220965000	24965	12389	1	0	5353
189673	2133	91804250000	24965	12389	2	0	4877
189674	1397	1289645099000	24966	12390	0	0	14918
189676	1397	1289625097000	24966	12390	2	0	14920
189677	2133	91803248000	24966	12390	3	0	4878
189678	2132	147517530000	24966	12390	4	0	1471
189679	2133	91802246000	24966	12390	5	0	4879
189680	2133	91801244000	24966	12390	6	0	4880
189682	2134	85218959000	24966	12390	8	0	5355
189683	2134	85217956000	24966	12390	9	0	5356
189684	1397	1289615096000	24967	12391	0	0	14921
189685	2133	91800242000	24967	12391	2	0	4881
189686	2134	85216953000	24967	12391	3	0	5357
189691	2133	91799240000	24969	12392	1	0	4882
189692	2132	147516529000	24969	12392	2	0	1472
189693	2134	85215950000	24969	12392	3	0	5358
189694	1397	1289595094000	24970	12393	0	0	14923
189700	1397	1289585093000	24973	12394	0	0	14924
189701	1397	1289575092000	24973	12394	1	0	14925
189702	2134	85214947000	24973	12394	2	0	5359
189703	2134	85213944000	24973	12394	3	0	5360
189704	2134	85212941000	24973	12394	4	0	5361
189706	2133	91796234000	24973	12394	6	0	4885
189707	2132	147515528000	24973	12394	7	0	1473
189721	2133	91797236000	24975	12394	5	0	\N
189722	2133	91796234000	24975	12394	6	0	\N
189723	2132	147515528000	24975	12394	7	0	\N
189727	1397	1289565091000	24977	12395	0	0	\N
189728	2134	85211938000	24977	12395	1	0	\N
189729	2133	91795232000	24977	12395	2	0	\N
189733	1397	1289545089000	24979	12397	0	0	\N
189734	2133	91793228000	24979	12397	1	0	\N
189735	2134	85209932000	24979	12397	2	0	\N
189736	1397	1289545089000	24980	12397	0	0	\N
189737	2133	91793228000	24980	12397	1	0	\N
189738	2134	85209932000	24980	12397	2	0	\N
189746	1397	1289535088000	24983	12398	0	0	\N
189747	2133	91792226000	24983	12398	1	0	\N
189748	2132	147514527000	24983	12398	2	0	\N
189749	2134	85209932000	24983	12398	3	0	\N
189750	2134	85208929000	24983	12398	4	0	\N
189751	1397	1289535088000	24984	12398	0	0	\N
189752	2133	91792226000	24984	12398	1	0	\N
189753	2132	147514527000	24984	12398	2	0	\N
189754	2134	85209932000	24984	12398	3	0	\N
189755	2134	85208929000	24984	12398	4	0	\N
189756	1397	1289535088000	24985	12398	0	0	\N
189757	2133	91792226000	24985	12398	1	0	\N
189758	2132	147514527000	24985	12398	2	0	\N
189770	1397	1289525087000	24987	12399	0	0	\N
189771	1397	1289515086000	24987	12399	1	0	\N
189772	1474	6390465000043	24987	12399	2	0	\N
189773	1397	1289505085000	24987	12399	3	0	\N
189774	2133	91791224000	24987	12399	4	0	\N
189775	2133	91790222000	24987	12399	5	0	\N
189776	2132	147513526000	24987	12399	6	0	\N
189777	2133	91789220000	24987	12399	7	0	\N
189778	2134	85207926000	24987	12399	8	0	\N
189779	2134	85206923000	24987	12399	9	0	\N
189780	2134	85205920000	24987	12399	10	0	\N
189781	1474	6390465000043	24988	12360	0	0	\N
189782	2314	869000000	24988	12360	1	0	\N
189783	1397	1289995134000	24988	12360	2	0	\N
189784	1397	1289985133000	24988	12360	3	0	\N
189785	1397	1289975132000	24988	12360	4	0	\N
189786	1397	1289965131000	24988	12360	5	0	\N
189787	1397	1289955130000	24988	12360	6	0	\N
189788	1397	1289945129000	24988	12360	7	0	\N
189789	1397	1289935128000	24988	12360	8	0	\N
189790	1397	1289925127000	24988	12360	9	0	\N
189791	1397	1289915126000	24988	12360	10	0	\N
189792	1397	1289905125000	24988	12360	11	0	\N
189793	1397	1289895124000	24988	12360	12	0	\N
189794	1397	1289885123000	24988	12360	13	0	\N
189795	1397	1289875122000	24988	12360	14	0	\N
189796	1397	1289865121000	24988	12360	15	0	\N
189797	1397	1289855120000	24988	12360	16	0	\N
189798	1397	1289845119000	24988	12360	17	0	\N
189799	1397	1289835118000	24988	12360	18	0	\N
189800	1397	1289825117000	24988	12360	19	0	\N
189801	1397	1289815116000	24988	12360	20	0	\N
189802	1397	1289805115000	24988	12360	21	0	\N
189803	1397	1289795114000	24988	12360	22	0	\N
189804	1397	1289785113000	24988	12360	23	0	\N
189805	1397	1289775112000	24988	12360	24	0	\N
189806	1397	1289765111000	24988	12360	25	0	\N
189807	1397	1289755110000	24988	12360	26	0	\N
189808	1397	1289745109000	24988	12360	27	0	\N
189809	1397	1289735108000	24988	12360	28	0	\N
189810	1397	1289725107000	24988	12360	29	0	\N
189811	1397	1289715106000	24988	12360	30	0	\N
189812	1397	1289705105000	24988	12360	31	0	\N
189813	1397	1289695104000	24988	12360	32	0	\N
189814	1397	1289685103000	24988	12360	33	0	\N
189815	1397	1289675102000	24988	12360	34	0	\N
189816	1397	1289665101000	24988	12360	35	0	\N
189817	1397	1289655100000	24988	12360	36	0	\N
189818	1397	1289645099000	24988	12360	37	0	\N
189819	1397	1289635098000	24988	12360	38	0	\N
189820	1397	1289625097000	24988	12360	39	0	\N
189821	1397	1289615096000	24988	12360	40	0	\N
189822	1397	1289605095000	24988	12360	41	0	\N
189823	1397	1289595094000	24988	12360	42	0	\N
189824	1397	1289585093000	24988	12360	43	0	\N
189825	1397	1289575092000	24988	12360	44	0	\N
189826	1397	1289565091000	24988	12360	45	0	\N
189827	1397	1289555090000	24988	12360	46	0	\N
189828	1397	1289545089000	24988	12360	47	0	\N
189829	1397	1289535088000	24988	12360	48	0	\N
189830	1397	1289525087000	24988	12360	49	0	\N
189831	1397	1289515086000	24988	12360	50	0	\N
189832	1397	1289505085000	24988	12360	51	0	\N
189833	2134	85255067000	24988	12360	52	0	\N
189834	2134	85254064000	24988	12360	53	0	\N
189835	2134	85253061000	24988	12360	54	0	\N
189836	2134	85252058000	24988	12360	55	0	\N
189837	2134	85251055000	24988	12360	56	0	\N
189838	2134	85250052000	24988	12360	57	0	\N
189839	2134	85249049000	24988	12360	58	0	\N
189840	2134	85248046000	24988	12360	59	0	\N
189841	2133	91838318000	24988	12360	60	0	\N
189842	2133	91837316000	24988	12360	61	0	\N
189843	2133	91836314000	24988	12360	63	0	\N
189844	2133	91835312000	24988	12360	64	0	\N
189845	2133	91834310000	24988	12360	65	0	\N
189846	2132	147527540000	24988	12360	66	0	\N
189847	2132	147526539000	24988	12360	67	0	\N
189848	2132	147525538000	24988	12360	68	0	\N
189849	2132	147524537000	24988	12360	69	0	\N
189850	2132	147523536000	24988	12360	70	0	\N
189851	2132	147522535000	24988	12360	71	0	\N
189852	2132	147521534000	24988	12360	72	0	\N
189853	2132	147520533000	24988	12360	73	0	\N
189854	2132	147519532000	24988	12360	74	0	\N
189855	2132	147518531000	24988	12360	75	0	\N
189856	2132	147517530000	24988	12360	76	0	\N
189726	2133	91795232000	24976	12395	2	0	4886
189730	1397	1289555090000	24978	12396	0	0	14927
189731	2134	85210935000	24978	12396	1	0	5363
189732	2133	91794230000	24978	12396	2	0	4887
189739	1397	1289545089000	24981	12397	0	0	14928
189741	1397	1289535088000	24982	12398	0	0	14929
189742	2133	91792226000	24982	12398	1	0	4889
189743	2132	147514527000	24982	12398	2	0	1474
189744	2134	85209932000	24982	12398	3	0	5364
189745	2134	85208929000	24982	12398	4	0	5365
189760	1397	1289515086000	24986	12399	1	0	14931
189761	1474	6390465000043	24986	12399	2	0	29
189762	1397	1289505085000	24986	12399	3	0	14932
189763	2133	91791224000	24986	12399	4	0	4890
189765	2132	147513526000	24986	12399	6	0	1475
189766	2133	91789220000	24986	12399	7	0	4892
189767	2134	85207926000	24986	12399	8	0	5366
189768	2134	85206923000	24986	12399	9	0	5367
189769	2134	85205920000	24986	12399	10	0	5368
189857	2132	147516529000	24988	12360	77	0	\N
189858	2132	147515528000	24988	12360	78	0	\N
189859	2132	147514527000	24988	12360	79	0	\N
189860	2132	147513526000	24988	12360	80	0	\N
189861	2133	91833308000	24988	12360	81	0	\N
189862	2133	91832306000	24988	12360	82	0	\N
189863	2133	91831304000	24988	12360	83	0	\N
189864	2133	91830302000	24988	12360	84	0	\N
189865	2133	91829300000	24988	12360	85	0	\N
189866	2133	91828298000	24988	12360	86	0	\N
189867	2133	91827296000	24988	12360	87	0	\N
189868	2133	91826294000	24988	12360	88	0	\N
189869	2133	91825292000	24988	12360	89	0	\N
189870	2133	91824290000	24988	12360	90	0	\N
189871	2133	91823288000	24988	12360	91	0	\N
189872	2133	91822286000	24988	12360	92	0	\N
189873	2133	91821284000	24988	12360	93	0	\N
189874	2133	91820282000	24988	12360	94	0	\N
189875	2133	91819280000	24988	12360	95	0	\N
189876	2133	91818278000	24988	12360	96	0	\N
189877	2133	91817276000	24988	12360	97	0	\N
189878	2133	91816274000	24988	12360	98	0	\N
189879	2133	91815272000	24988	12360	99	0	\N
189880	2133	91814270000	24988	12360	100	0	\N
189881	2133	91813268000	24988	12360	101	0	\N
189882	2133	91812266000	24988	12360	102	0	\N
189883	2133	91811264000	24988	12360	103	0	\N
189884	2133	91810262000	24988	12360	104	0	\N
189885	2133	91809260000	24988	12360	105	0	\N
189886	2133	91808258000	24988	12360	106	0	\N
189887	2133	91807256000	24988	12360	107	0	\N
189888	2133	91806254000	24988	12360	108	0	\N
189889	2133	91805252000	24988	12360	109	0	\N
189890	2133	91804250000	24988	12360	110	0	\N
189891	2133	91803248000	24988	12360	111	0	\N
189892	2133	91802246000	24988	12360	112	0	\N
189893	2133	91801244000	24988	12360	113	0	\N
189894	2133	91800242000	24988	12360	114	0	\N
189895	2133	91799240000	24988	12360	115	0	\N
189896	2133	91798238000	24988	12360	116	0	\N
189897	2133	91797236000	24988	12360	117	0	\N
189898	2133	91796234000	24988	12360	118	0	\N
189899	2133	91795232000	24988	12360	119	0	\N
189900	2133	91794230000	24988	12360	120	0	\N
189901	2133	91793228000	24988	12360	121	0	\N
189902	2133	91792226000	24988	12360	122	0	\N
189903	2133	91791224000	24988	12360	123	0	\N
189904	2133	91790222000	24988	12360	124	0	\N
189905	2133	91789220000	24988	12360	125	0	\N
189906	1397	1289495084000	24989	12400	0	0	\N
189907	1397	1289485083000	24989	12400	1	0	\N
189908	1397	1289475082000	24989	12400	2	0	\N
189909	2132	147512525000	24989	12400	3	0	\N
189910	2133	91788218000	24989	12400	4	0	\N
189911	2133	91787216000	24989	12400	5	0	\N
189912	2133	91786214000	24989	12400	6	0	\N
189913	2134	85204917000	24989	12400	7	0	\N
189914	2134	85203914000	24989	12400	8	0	\N
189915	2134	85202911000	24989	12400	9	0	\N
189926	1397	1289465081000	24991	12401	0	0	\N
189927	2133	91785212000	24991	12401	1	0	\N
189928	2134	85201908000	24991	12401	2	0	\N
189929	1397	1289465081000	24992	12401	0	0	\N
189930	2133	91785212000	24992	12401	1	0	\N
189934	441	66000148845612	24994	12262	0	0	\N
189935	1692	1180568619999	24994	12262	1	0	\N
189936	1397	1289525087000	24995	12399	0	0	\N
189937	1397	1289515086000	24995	12399	1	0	\N
189938	1474	6390465000043	24995	12399	2	0	\N
189939	1397	1289505085000	24995	12399	3	0	\N
189940	1397	1289495084000	24995	12399	4	0	\N
189941	1397	1289485083000	24995	12399	5	0	\N
189942	1397	1289475082000	24995	12399	6	0	\N
189943	1397	1289465081000	24995	12399	7	0	\N
189944	2133	91791224000	24995	12399	8	0	\N
189945	2133	91790222000	24995	12399	9	0	\N
189946	2132	147513526000	24995	12399	10	0	\N
189947	2132	147512525000	24995	12399	11	0	\N
189948	2133	91789220000	24995	12399	12	0	\N
189949	2134	85207926000	24995	12399	13	0	\N
189950	2134	85206923000	24995	12399	14	0	\N
189951	2134	85205920000	24995	12399	15	0	\N
189952	2133	91788218000	24995	12399	16	0	\N
189953	2133	91787216000	24995	12399	17	0	\N
189954	2133	91786214000	24995	12399	18	0	\N
189955	2133	91785212000	24995	12399	19	0	\N
189956	2134	85204917000	24995	12399	20	0	\N
189957	2134	85203914000	24995	12399	21	0	\N
189958	2134	85202911000	24995	12399	22	0	\N
189959	2134	85201908000	24995	12399	23	0	\N
189960	2134	85200905000	24995	12399	24	0	\N
189961	1397	1289455080000	24996	12402	0	0	\N
189962	1397	1289445079000	24996	12402	1	0	\N
189963	2058	529500000	24996	12402	2	0	\N
189964	2133	91784210000	24996	12402	3	0	\N
189965	2133	91783208000	24996	12402	4	0	\N
189973	1397	1289455080000	24998	12402	0	0	\N
189974	1397	1289445079000	24998	12402	1	0	\N
189975	2058	529500000	24998	12402	2	0	\N
189976	2133	91784210000	24998	12402	3	0	\N
189977	2133	91783208000	24998	12402	4	0	\N
189986	1397	1289435078000	25000	12403	0	0	\N
189987	1397	1289425077000	25000	12403	1	0	\N
189988	1397	1289415076000	25000	12403	2	0	\N
189989	2133	91782206000	25000	12403	3	0	\N
189990	2133	91781204000	25000	12403	4	0	\N
189991	2133	91780202000	25000	12403	5	0	\N
189992	2132	147511524000	25000	12403	6	0	\N
189918	1397	1289475082000	24990	12400	2	0	14935
189919	2132	147512525000	24990	12400	3	0	1476
189920	2133	91788218000	24990	12400	4	0	4893
189921	2133	91787216000	24990	12400	5	0	4894
189922	2133	91786214000	24990	12400	6	0	4895
189924	2134	85203914000	24990	12400	8	0	5370
189925	2134	85202911000	24990	12400	9	0	5371
189931	1397	1289465081000	24993	12401	0	0	14936
189932	2133	91785212000	24993	12401	1	0	4896
189933	2134	85201908000	24993	12401	2	0	5372
189967	1397	1289445079000	24997	12402	1	0	14938
189968	2058	529500000	24997	12402	2	0	12
189969	2134	85200905000	24997	12402	3	0	5373
189970	2134	85199902000	24997	12402	4	0	5374
189972	2133	91783208000	24997	12402	6	0	4898
189978	1397	1289435078000	24999	12403	0	0	14939
189979	1397	1289425077000	24999	12403	1	0	14940
189980	1397	1289415076000	24999	12403	2	0	14941
189981	2133	91782206000	24999	12403	3	0	4899
189983	2133	91780202000	24999	12403	5	0	4901
189984	2132	147511524000	24999	12403	6	0	1477
189985	2134	85198899000	24999	12403	7	0	5375
189993	1397	1289435078000	25001	12403	0	0	\N
189994	1397	1289425077000	25001	12403	1	0	\N
189995	1397	1289415076000	25001	12403	2	0	\N
189996	2133	91782206000	25001	12403	3	0	\N
189997	2133	91781204000	25001	12403	4	0	\N
189998	2133	91780202000	25001	12403	5	0	\N
189999	2132	147511524000	25001	12403	6	0	\N
190000	2134	85198899000	25001	12403	7	0	\N
190004	1397	1289405075000	25003	12404	0	0	\N
190005	2132	147510523000	25003	12404	1	0	\N
190006	2133	91779200000	25003	12404	2	0	\N
190007	1397	1289405075000	25004	12404	0	0	\N
190008	2132	147510523000	25004	12404	1	0	\N
190009	2133	91779200000	25004	12404	2	0	\N
190010	1397	1289395074000	25005	12405	0	0	\N
190011	1397	1289385073000	25005	12405	1	0	\N
190012	2058	527500000	25005	12405	2	0	\N
190013	2291	0	25005	12405	3	0	\N
190014	2133	91778198000	25005	12405	4	0	\N
190015	2152	106998999000000	25005	12405	5	0	\N
190016	2133	91777196000	25005	12405	6	0	\N
190024	1397	1289375072000	25007	12406	0	0	\N
190025	2132	147509522000	25007	12406	1	0	\N
190026	2133	91776194000	25007	12406	2	0	\N
190039	1397	1289325067000	25013	12411	0	0	\N
190040	2133	91771184000	25013	12411	1	0	\N
190043	1397	1289315066000	25015	12412	0	0	\N
190044	2133	91770182000	25015	12412	1	0	\N
190045	1397	1289315066000	25016	12412	0	0	\N
190046	2133	91770182000	25016	12412	1	0	\N
190056	1397	1289315066000	25020	12413	0	0	\N
190057	1397	1289305065000	25020	12413	1	0	\N
190058	1397	1289295064000	25020	12413	2	0	\N
190059	1397	1289285063000	25020	12413	3	0	\N
190060	2132	147507520000	25020	12413	4	0	\N
190061	2133	91770182000	25020	12413	5	0	\N
190062	2133	91769180000	25020	12413	6	0	\N
190063	2133	91768178000	25020	12413	7	0	\N
190064	2133	91767176000	25020	12413	8	0	\N
190065	1397	1289305065000	25021	12413	0	0	\N
190066	1397	1289295064000	25021	12413	1	0	\N
190067	1397	1289285063000	25021	12413	2	0	\N
190068	2132	147507520000	25021	12413	3	0	\N
190069	2133	91769180000	25021	12413	4	0	\N
190070	2133	91768178000	25021	12413	5	0	\N
190071	2133	91767176000	25021	12413	6	0	\N
190076	2317	254745211465	25023	12414	0	0	\N
190077	1397	1289275062000	25023	12414	1	0	\N
190078	2133	91766174000	25023	12414	2	0	\N
190079	2132	147506519000	25023	12414	3	0	\N
190080	1397	1289265061000	25024	12415	0	0	\N
190082	1397	1289255060000	25026	12416	0	0	\N
190083	2133	91765172000	25026	12416	1	0	\N
190093	1397	1289235058000	25030	12418	0	0	\N
190094	1397	1289225057000	25030	12418	1	0	\N
190095	2133	91763168000	25030	12418	2	0	\N
190096	2133	91762166000	25030	12418	3	0	\N
190097	2132	147505518000	25030	12418	4	0	\N
190100	1397	1289215056000	25032	12419	0	0	\N
190101	2133	91761164000	25032	12419	1	0	\N
190104	1397	1289205055000	25034	12421	0	0	\N
190105	1397	1289195054000	25034	12421	1	0	\N
190106	2133	91759160000	25034	12421	2	0	\N
190110	1397	1289185053000	25036	12422	0	0	\N
190111	2133	91758158000	25036	12422	1	0	\N
190114	1474	6390465000043	25038	12366	0	0	\N
190115	2314	869000000	25038	12366	1	0	\N
190116	2058	529500000	25038	12366	2	0	\N
190117	2058	527500000	25038	12366	3	0	\N
190118	2291	0	25038	12366	4	0	\N
190119	2152	106998999000000	25038	12366	5	0	\N
190120	2134	85247043000	25038	12366	6	0	\N
190121	2134	85246040000	25038	12366	7	0	\N
190122	2134	85245037000	25038	12366	8	0	\N
190123	2134	85244034000	25038	12366	9	0	\N
190124	2134	85243031000	25038	12366	10	0	\N
190125	2134	85242028000	25038	12366	11	0	\N
190126	2134	85241025000	25038	12366	12	0	\N
190127	2134	85240022000	25038	12366	13	0	\N
190128	2134	85239019000	25038	12366	14	0	\N
190003	2133	91779200000	25002	12404	2	0	4902
190017	1397	1289395074000	25006	12405	0	0	14943
190018	1397	1289385073000	25006	12405	1	0	14944
190019	2058	527500000	25006	12405	2	0	13
190020	2291	0	25006	12405	3	0	1
190022	2152	106998999000000	25006	12405	5	0	4
190023	2133	91777196000	25006	12405	6	0	4904
190027	1397	1289375072000	25008	12406	0	0	14945
190028	2132	147509522000	25008	12406	1	0	1479
190029	2133	91776194000	25008	12406	2	0	4905
190031	2133	91775192000	25009	12407	1	0	4906
190032	1397	1289355070000	25010	12408	0	0	14947
190033	2133	91774190000	25010	12408	1	0	4907
190034	1397	1289345069000	25011	12409	0	0	14948
190036	1397	1289335068000	25012	12410	0	0	14949
190037	2133	91772186000	25012	12410	2	0	4909
190038	2132	147508521000	25012	12410	3	0	1480
190041	1397	1289325067000	25014	12411	0	0	14950
190042	2133	91771184000	25014	12411	1	0	4910
190048	1397	1289305065000	25019	12413	1	0	14952
190049	1397	1289295064000	25019	12413	2	0	14953
190050	1397	1289285063000	25019	12413	3	0	14954
190051	2132	147507520000	25019	12413	4	0	1481
190052	2133	91770182000	25019	12413	5	0	4911
190054	2133	91768178000	25019	12413	7	0	4913
190055	2133	91767176000	25019	12413	8	0	4914
190072	2317	254745211465	25022	12414	0	0	1
190073	1397	1289275062000	25022	12414	1	0	14955
190075	2132	147506519000	25022	12414	3	0	1482
190081	1397	1289265061000	25025	12415	0	0	14956
190084	1397	1289255060000	25027	12416	0	0	14957
190085	2133	91765172000	25027	12416	1	0	4916
190086	1397	1289245059000	25028	12417	0	0	14958
190088	1397	1289235058000	25029	12418	0	0	14959
190089	1397	1289225057000	25029	12418	1	0	14960
190090	2133	91763168000	25029	12418	2	0	4918
190091	2133	91762166000	25029	12418	3	0	4919
190092	2132	147505518000	25029	12418	4	0	1483
190099	2133	91761164000	25031	12419	1	0	4920
190102	2132	147504517000	25033	12420	0	0	1484
190103	2133	91760162000	25033	12420	1	0	4921
190107	1397	1289205055000	25035	12421	0	0	14962
190109	2133	91759160000	25035	12421	2	0	4922
190112	1397	1289185053000	25037	12422	0	0	14964
190113	2133	91758158000	25037	12422	1	0	4923
190129	2134	85238016000	25038	12366	15	0	\N
190130	2134	85237013000	25038	12366	16	0	\N
190131	2134	85236010000	25038	12366	17	0	\N
190132	2134	85235007000	25038	12366	18	0	\N
190133	2134	85234004000	25038	12366	19	0	\N
190134	2134	85233001000	25038	12366	20	0	\N
190135	2134	85231998000	25038	12366	21	0	\N
190136	2134	85230995000	25038	12366	22	0	\N
190137	2134	85229992000	25038	12366	23	0	\N
190138	2134	85228989000	25038	12366	25	0	\N
190139	2134	85227986000	25038	12366	26	0	\N
190140	2134	85226983000	25038	12366	27	0	\N
190141	2134	85225980000	25038	12366	28	0	\N
190142	2134	85224977000	25038	12366	29	0	\N
190143	2134	85223974000	25038	12366	30	0	\N
190144	2134	85222971000	25038	12366	31	0	\N
190145	1397	1289185053000	25039	12422	0	0	\N
190146	2133	91758158000	25039	12422	1	0	\N
190147	1397	1289185053000	25040	12422	0	0	\N
190148	2133	91758158000	25040	12422	1	0	\N
190149	2133	91758158000	25041	12422	0	0	\N
190166	1397	1289115046000	25046	12427	0	0	\N
190173	1397	1289095044000	25050	12429	0	0	\N
190174	2133	91749140000	25050	12429	1	0	\N
190178	1397	1289075042000	25052	12431	0	0	\N
190179	2133	91747136000	25052	12431	1	0	\N
190180	1397	1289075042000	25053	12431	0	0	\N
190181	2133	91747136000	25053	12431	1	0	\N
190199	1397	1289015036000	25058	12435	0	0	\N
190200	2134	85195890000	25058	12435	1	0	\N
190201	2133	91740122000	25058	12435	2	0	\N
190202	2132	147498511000	25058	12435	3	0	\N
190210	1397	1289005035000	25061	12436	0	0	\N
190211	2133	91739120000	25061	12436	1	0	\N
190212	2134	85194887000	25061	12436	2	0	\N
190213	1397	1288995034000	25062	12437	0	0	\N
190214	2134	85193884000	25062	12437	1	0	\N
190215	2133	91738118000	25062	12437	2	0	\N
190242	1397	1288915026000	25070	12444	0	0	\N
190243	1397	1288905025000	25070	12444	1	0	\N
190244	2133	91730102000	25070	12444	2	0	\N
190245	2133	91729100000	25070	12444	3	0	\N
190246	2132	147495508000	25070	12444	4	0	\N
190247	2134	85185860000	25070	12444	5	0	\N
190248	2134	85184857000	25070	12444	6	0	\N
190252	1397	1288915026000	25072	12445	0	0	\N
190253	1397	1288905025000	25072	12445	1	0	\N
190254	1397	1288895024000	25072	12445	2	0	\N
190255	2133	91728098000	25072	12445	3	0	\N
190256	2134	85185860000	25072	12445	4	0	\N
190257	2134	85184857000	25072	12445	5	0	\N
190258	2134	85183854000	25072	12445	6	0	\N
190152	2133	91757156000	25042	12423	2	0	4924
190153	2132	147503516000	25042	12423	3	0	1485
190154	2133	91756154000	25042	12423	4	0	4925
190155	2152	106988998000000	25042	12423	5	0	5
190156	1397	1289155050000	25043	12424	0	0	14967
190158	2316	498999000000	25043	12424	2	0	1
190159	2133	91755152000	25043	12424	3	0	4926
190160	2133	91754150000	25043	12424	4	0	4927
190161	1397	1289135048000	25044	12425	0	0	14969
190162	2132	147502515000	25044	12425	1	0	1486
190164	1397	1289125047000	25045	12426	0	0	14970
190165	2133	91752146000	25045	12426	1	0	4929
190167	1397	1289115046000	25047	12427	0	0	14971
190168	2133	91751144000	25047	12427	1	0	4930
190170	2132	147501514000	25048	12428	1	0	1487
190171	2133	91750142000	25048	12428	2	0	4931
190172	1397	1289095044000	25049	12429	0	0	14973
190175	1397	1289085043000	25051	12430	0	0	14974
190176	2133	91749140000	25051	12430	1	0	4932
190182	1397	1289075042000	25054	12431	0	0	14975
190183	2133	91747136000	25054	12431	1	0	4934
190184	1397	1289065041000	25055	12432	0	0	14976
190185	2132	147500513000	25055	12432	1	0	1488
190186	2133	91746134000	25055	12432	2	0	4935
190188	1397	1289055040000	25056	12433	0	0	14977
190189	1397	1289045039000	25056	12433	1	0	14978
190190	1397	1289035038000	25056	12433	2	0	14979
190191	2132	147499512000	25056	12433	3	0	1489
190193	2133	91744130000	25056	12433	5	0	4937
190194	2133	91743128000	25056	12433	6	0	4938
190195	2133	91742126000	25056	12433	7	0	4939
190196	1397	1289025037000	25057	12434	0	0	14980
190197	2134	85196893000	25057	12434	1	0	5377
190203	1397	1289015036000	25059	12435	0	0	14981
190204	2134	85195890000	25059	12435	1	0	5378
190205	2133	91740122000	25059	12435	2	0	4941
190206	2132	147498511000	25059	12435	3	0	1490
190207	1397	1289005035000	25060	12436	0	0	14982
190209	2134	85194887000	25060	12436	2	0	5379
190216	1397	1288995034000	25063	12437	0	0	14983
190217	2134	85193884000	25063	12437	1	0	5380
190218	2133	91738118000	25063	12437	2	0	4943
190220	2134	85192881000	25064	12438	1	0	5381
190221	2133	91737116000	25064	12438	2	0	4944
190222	1397	1288975032000	25065	12439	0	0	14985
190223	2132	147497510000	25065	12439	1	0	1491
190224	2134	85191878000	25065	12439	2	0	5382
190226	1397	1288965031000	25066	12440	0	0	14986
190227	2134	85190875000	25066	12440	1	0	5383
190228	2133	91735112000	25066	12440	2	0	4946
190229	1397	1288955030000	25067	12441	0	0	14987
190230	2133	91734110000	25067	12441	1	0	4947
190232	1397	1288945029000	25068	12442	0	0	14988
190233	1397	1288935028000	25068	12442	1	0	14989
190234	2132	147496509000	25068	12442	2	0	1492
190235	2133	91733108000	25068	12442	3	0	4948
190237	2134	85188869000	25068	12442	5	0	5385
190238	2134	85187866000	25068	12442	6	0	5386
190239	1397	1288925027000	25069	12443	0	0	14990
190240	2133	91731104000	25069	12443	1	0	4950
190241	2134	85186863000	25069	12443	2	0	5387
190250	2133	91729100000	25071	12444	1	0	4952
190251	2132	147495508000	25071	12444	2	0	1493
190259	1397	1288915026000	25073	12445	0	0	14991
190260	1397	1288905025000	25073	12445	1	0	14992
190261	1397	1288895024000	25073	12445	2	0	14993
190263	2134	85185860000	25073	12445	4	0	5388
190264	2134	85184857000	25073	12445	5	0	5389
190266	1397	1288885023000	25074	12446	0	0	\N
190267	2134	85182851000	25074	12446	1	0	\N
190268	2133	91727096000	25074	12446	2	0	\N
190276	1397	1288875022000	25077	12447	0	0	\N
190277	2134	85181848000	25077	12447	1	0	\N
190278	2133	91726094000	25077	12447	2	0	\N
190279	2132	147494507000	25077	12447	3	0	\N
190282	1397	1288865021000	25079	12448	0	0	\N
190283	2133	91725092000	25079	12448	1	0	\N
190284	2134	85180845000	25079	12448	2	0	\N
190285	1397	1288855020000	25080	12449	0	0	\N
190286	1397	1288845019000	25080	12449	1	0	\N
190287	2133	91724090000	25080	12449	2	0	\N
190288	2133	91723088000	25080	12449	3	0	\N
190289	2132	147493506000	25080	12449	4	0	\N
190290	2134	85180845000	25080	12449	5	0	\N
190291	2134	85179842000	25080	12449	6	0	\N
190292	2134	85178839000	25080	12449	7	0	\N
190320	1397	1288815016000	25085	12452	0	0	\N
190321	1397	1288805015000	25085	12452	1	0	\N
190322	1397	1288795014000	25085	12452	2	0	\N
190323	1397	1288785013000	25085	12452	3	0	\N
190324	2134	85175830000	25085	12452	4	0	\N
190325	2134	85174827000	25085	12452	5	0	\N
190326	2134	85173824000	25085	12452	6	0	\N
190327	2134	85172821000	25085	12452	7	0	\N
190328	2132	147492505000	25085	12452	8	0	\N
190329	2133	91720082000	25085	12452	9	0	\N
190330	2133	91719080000	25085	12452	10	0	\N
190331	2133	91718078000	25085	12452	11	0	\N
190332	2133	91717076000	25085	12452	12	0	\N
190337	1397	1288765011000	25087	12454	0	0	\N
190338	1397	1288755010000	25087	12454	1	0	\N
190339	2133	91715072000	25087	12454	2	0	\N
190340	2134	85170815000	25087	12454	3	0	\N
190341	2134	85169812000	25087	12454	4	0	\N
190342	2133	91714070000	25087	12454	5	0	\N
190343	1397	1288765011000	25088	12454	0	0	\N
190344	1397	1288755010000	25088	12454	1	0	\N
190345	2133	91715072000	25088	12454	2	0	\N
190346	2134	85170815000	25088	12454	3	0	\N
190347	2134	85169812000	25088	12454	4	0	\N
190348	2133	91714070000	25088	12454	5	0	\N
190355	1397	1288745009000	25090	12455	0	0	\N
190356	2133	91713068000	25090	12455	1	0	\N
190357	2132	147490503000	25090	12455	2	0	\N
190362	1397	1288745009000	25092	12455	0	0	\N
190363	2134	85168809000	25092	12455	1	0	\N
190364	2133	91713068000	25092	12455	2	0	\N
190365	2132	147490503000	25092	12455	3	0	\N
190366	1397	1288745009000	25093	12455	0	0	\N
190367	2134	85168809000	25093	12455	1	0	\N
190368	2133	91713068000	25093	12455	2	0	\N
190369	2132	147490503000	25093	12455	3	0	\N
190370	1397	1288735008000	25094	12456	0	0	\N
190371	2133	91712066000	25094	12456	1	0	\N
190372	2134	85167806000	25094	12456	2	0	\N
190373	1397	1288735008000	25095	12456	0	0	\N
190374	2133	91712066000	25095	12456	1	0	\N
190375	2134	85167806000	25095	12456	2	0	\N
190376	1397	1288735008000	25096	12456	0	0	\N
190377	2133	91712066000	25096	12456	1	0	\N
190378	2134	85167806000	25096	12456	2	0	\N
190382	1397	1288725007000	25098	12457	0	0	\N
190383	2134	85166803000	25098	12457	1	0	\N
190384	2133	91711064000	25098	12457	2	0	\N
190385	1397	1288725007000	25099	12457	0	0	\N
190386	2134	85166803000	25099	12457	1	0	\N
190387	2133	91711064000	25099	12457	2	0	\N
190388	1397	1288725007000	25100	12457	0	0	\N
190389	2134	85166803000	25100	12457	1	0	\N
190390	2133	91711064000	25100	12457	2	0	\N
190394	2134	85166803000	25102	12457	0	0	\N
190395	2133	91711064000	25102	12457	1	0	\N
190396	1397	1288725007000	25103	12457	0	0	\N
190397	2134	85166803000	25103	12457	1	0	\N
190398	2133	91711064000	25103	12457	2	0	\N
190399	1397	1288865021000	25104	12448	0	0	\N
190400	1397	1288855020000	25104	12448	1	0	\N
190270	2134	85182851000	25075	12446	1	0	5391
190271	2133	91727096000	25075	12446	2	0	4954
190272	1397	1288875022000	25076	12447	0	0	14995
190273	2134	85181848000	25076	12447	1	0	5392
190274	2133	91726094000	25076	12447	2	0	4955
190280	1397	1288865021000	25078	12448	0	0	14996
190281	2133	91725092000	25078	12448	1	0	4956
190293	1397	1288855020000	25081	12449	0	0	14997
190294	1397	1288845019000	25081	12449	1	0	14998
190295	2133	91724090000	25081	12449	2	0	4957
190297	2132	147493506000	25081	12449	4	0	1495
190298	2134	85180845000	25081	12449	5	0	5393
190299	2134	85179842000	25081	12449	6	0	5394
190300	2134	85178839000	25081	12449	7	0	5395
190302	2133	91722086000	25082	12450	1	0	4959
190303	2134	85177836000	25082	12450	2	0	5396
190304	1397	1288825017000	25083	12451	0	0	15000
190305	2133	91721084000	25083	12451	1	0	4960
190306	2134	85176833000	25083	12451	2	0	5397
190308	1397	1288805015000	25084	12452	1	0	15002
190309	1397	1288795014000	25084	12452	2	0	15003
190310	1397	1288785013000	25084	12452	3	0	15004
190311	2134	85175830000	25084	12452	4	0	5398
190312	2134	85174827000	25084	12452	5	0	5399
190314	2134	85172821000	25084	12452	7	0	5401
190315	2132	147492505000	25084	12452	8	0	1496
190316	2133	91720082000	25084	12452	9	0	4961
190317	2133	91719080000	25084	12452	10	0	4962
190319	2133	91717076000	25084	12452	12	0	4964
190333	1397	1288775012000	25086	12453	0	0	15005
190334	2133	91716074000	25086	12453	1	0	4965
190335	2132	147491504000	25086	12453	2	0	1497
190336	2134	85171818000	25086	12453	3	0	5402
190350	1397	1288755010000	25089	12454	1	0	15007
190351	2133	91715072000	25089	12454	2	0	4966
190352	2134	85170815000	25089	12454	3	0	5403
190353	2134	85169812000	25089	12454	4	0	5404
190354	2133	91714070000	25089	12454	5	0	4967
190359	2134	85168809000	25091	12455	1	0	5405
190360	2133	91713068000	25091	12455	2	0	4968
190361	2132	147490503000	25091	12455	3	0	1498
190379	1397	1288735008000	25097	12456	0	0	15009
190381	2134	85167806000	25097	12456	2	0	5406
190391	1397	1288725007000	25101	12457	0	0	15010
190392	2134	85166803000	25101	12457	1	0	5407
190393	2133	91711064000	25101	12457	2	0	4970
190401	1397	1288845019000	25104	12448	2	0	\N
190402	1397	1288835018000	25104	12448	3	0	\N
190403	1397	1288825017000	25104	12448	4	0	\N
190404	1397	1288815016000	25104	12448	5	0	\N
190405	1397	1288805015000	25104	12448	6	0	\N
190406	1397	1288795014000	25104	12448	7	0	\N
190407	1397	1288785013000	25104	12448	8	0	\N
190408	1397	1288775012000	25104	12448	9	0	\N
190409	1397	1288765011000	25104	12448	10	0	\N
190410	1397	1288755010000	25104	12448	11	0	\N
190411	1397	1288745009000	25104	12448	12	0	\N
190412	1397	1288735008000	25104	12448	13	0	\N
190413	2133	91725092000	25104	12448	14	0	\N
190414	2133	91724090000	25104	12448	15	0	\N
190415	2133	91723088000	25104	12448	16	0	\N
190416	2133	91722086000	25104	12448	17	0	\N
190417	2133	91721084000	25104	12448	18	0	\N
190418	2132	147493506000	25104	12448	19	0	\N
190419	2132	147492505000	25104	12448	20	0	\N
190420	2132	147491504000	25104	12448	21	0	\N
190421	2132	147490503000	25104	12448	22	0	\N
190422	2134	85180845000	25104	12448	23	0	\N
190423	2134	85179842000	25104	12448	24	0	\N
190424	2134	85178839000	25104	12448	25	0	\N
190425	2134	85177836000	25104	12448	26	0	\N
190426	2134	85176833000	25104	12448	27	0	\N
190427	2134	85175830000	25104	12448	28	0	\N
190428	2134	85174827000	25104	12448	29	0	\N
190429	2134	85173824000	25104	12448	30	0	\N
190430	2134	85172821000	25104	12448	31	0	\N
190431	2134	85171818000	25104	12448	32	0	\N
190432	2134	85170815000	25104	12448	33	0	\N
190433	2134	85169812000	25104	12448	34	0	\N
190434	2134	85168809000	25104	12448	35	0	\N
190435	2134	85167806000	25104	12448	36	0	\N
190436	2133	91720082000	25104	12448	37	0	\N
190437	2133	91719080000	25104	12448	38	0	\N
190438	2133	91718078000	25104	12448	39	0	\N
190439	2133	91717076000	25104	12448	40	0	\N
190440	2133	91716074000	25104	12448	41	0	\N
190441	2133	91715072000	25104	12448	42	0	\N
190442	2133	91714070000	25104	12448	43	0	\N
190443	2133	91713068000	25104	12448	44	0	\N
190444	2133	91712066000	25104	12448	45	0	\N
190445	1397	1288725007000	25105	12457	0	0	\N
190446	2134	85166803000	25105	12457	1	0	\N
190447	2133	91711064000	25105	12457	2	0	\N
190448	1397	1288725007000	25106	12457	0	0	\N
190449	2134	85166803000	25106	12457	1	0	\N
190450	2133	91711064000	25106	12457	2	0	\N
190451	2133	91710062000	25106	12457	3	0	\N
190462	1397	1288715006000	25108	12458	0	0	\N
190463	1397	1288705005000	25108	12458	1	0	\N
190464	1397	1288695004000	25108	12458	2	0	\N
190465	2132	147489502000	25108	12458	3	0	\N
190466	2133	91709060000	25108	12458	4	0	\N
190467	2133	91708058000	25108	12458	5	0	\N
190468	1397	1288725007000	25109	12449	0	0	\N
190469	1397	1288715006000	25109	12449	1	0	\N
190470	1397	1288705005000	25109	12449	2	0	\N
190471	1397	1288695004000	25109	12449	4	0	\N
190472	2132	147489502000	25109	12449	5	0	\N
190473	2134	85166803000	25109	12449	6	0	\N
190474	2134	85165800000	25109	12449	7	0	\N
190475	2134	85164797000	25109	12449	8	0	\N
190476	2133	91711064000	25109	12449	9	0	\N
190477	2133	91710062000	25109	12449	10	0	\N
190478	2133	91709060000	25109	12449	11	0	\N
190479	2133	91708058000	25109	12449	12	0	\N
190480	2134	85163794000	25109	12449	13	0	\N
190491	1397	1288655000000	25113	12462	0	0	\N
190492	2134	85159782000	25113	12462	1	0	\N
190493	2133	91704050000	25113	12462	2	0	\N
190506	1397	1288644999000	25117	12464	0	0	\N
190507	1397	1288634998000	25117	12464	1	0	\N
190508	2133	91702046000	25117	12464	2	0	\N
190509	2134	85157776000	25117	12464	3	0	\N
190510	2134	85156773000	25117	12464	4	0	\N
190511	2133	91701044000	25117	12464	5	0	\N
190512	1397	1288644999000	25118	12464	0	0	\N
190513	1397	1288634998000	25118	12464	1	0	\N
190514	2133	91702046000	25118	12464	2	0	\N
190515	2134	85157776000	25118	12464	3	0	\N
190516	2134	85156773000	25118	12464	4	0	\N
190517	2133	91701044000	25118	12464	5	0	\N
190518	1397	1288644999000	25119	12464	0	0	\N
190519	1397	1288634998000	25119	12464	1	0	\N
190520	2133	91702046000	25119	12464	2	0	\N
190521	2134	85157776000	25119	12464	3	0	\N
190522	2134	85156773000	25119	12464	4	0	\N
190523	2133	91701044000	25119	12464	5	0	\N
190524	441	66000148845612	25120	12288	0	0	\N
190525	1692	460530619999	25120	12288	1	0	\N
190526	1397	1290555190000	25120	12288	2	0	\N
190527	1397	1290545189000	25120	12288	3	0	\N
190528	238	66112415123421	25120	12288	4	0	\N
190529	238	66111405123421	25120	12288	5	0	\N
190530	1474	6390465000043	25120	12288	6	0	\N
190531	1397	1290535188000	25120	12288	7	0	\N
190532	1397	1290525187000	25120	12288	8	0	\N
190533	1397	1290515186000	25120	12288	9	0	\N
190534	1397	1290505185000	25120	12288	10	0	\N
190535	1397	1290495184000	25120	12288	11	0	\N
190536	1397	1290485183000	25120	12288	12	0	\N
190454	1397	1288695004000	25107	12458	2	0	15013
190455	2132	147489502000	25107	12458	3	0	1499
190456	2134	85165800000	25107	12458	4	0	5408
190457	2134	85164797000	25107	12458	5	0	5409
190458	2133	91710062000	25107	12458	6	0	4971
190460	2133	91708058000	25107	12458	8	0	4973
190461	2134	85163794000	25107	12458	9	0	5410
190481	1397	1288685003000	25110	12459	0	0	15014
190482	2133	91707056000	25110	12459	1	0	4974
190483	2134	85162791000	25110	12459	2	0	5411
190485	2134	85161788000	25111	12460	1	0	5412
190486	2133	91706054000	25111	12460	2	0	4975
190487	2132	147488501000	25111	12460	3	0	1500
190488	1397	1288665001000	25112	12461	0	0	15016
190490	2134	85160785000	25112	12461	2	0	5413
190494	1397	1288655000000	25114	12462	0	0	15017
190495	2134	85159782000	25114	12462	1	0	5414
190496	2133	91704050000	25114	12462	2	0	4977
190497	2134	85158779000	25115	12463	0	0	5415
190499	2133	91703048000	25115	12463	2	0	4978
190500	1397	1288644999000	25116	12464	0	0	15018
190501	1397	1288634998000	25116	12464	1	0	15019
190502	2133	91702046000	25116	12464	2	0	4979
190503	2134	85157776000	25116	12464	3	0	5416
190505	2133	91701044000	25116	12464	5	0	4980
190537	1397	1290475182000	25120	12288	13	0	\N
190538	1397	1290465181000	25120	12288	14	0	\N
190539	1397	1290455180000	25120	12288	15	0	\N
190540	1397	1290445179000	25120	12288	16	0	\N
190541	1397	1290435178000	25120	12288	17	0	\N
190542	1397	1290425177000	25120	12288	18	0	\N
190543	1397	1290415176000	25120	12288	19	0	\N
190544	1397	1290405175000	25120	12288	20	0	\N
190545	1397	1290395174000	25120	12288	21	0	\N
190546	1397	1290385173000	25120	12288	22	0	\N
190547	1397	1290375172000	25120	12288	23	0	\N
190548	1397	1290365171000	25120	12288	24	0	\N
190549	1397	1290355170000	25120	12288	25	0	\N
190550	1397	1290345169000	25120	12288	26	0	\N
190551	1397	1290335168000	25120	12288	27	0	\N
190552	1397	1290325167000	25120	12288	28	0	\N
190553	1397	1290315166000	25120	12288	29	0	\N
190554	1397	1290305165000	25120	12288	30	0	\N
190555	1397	1290295164000	25120	12288	31	0	\N
190556	1397	1290285163000	25120	12288	32	0	\N
190557	1397	1290275162000	25120	12288	33	0	\N
190558	1397	1290265161000	25120	12288	34	0	\N
190559	1397	1290255160000	25120	12288	35	0	\N
190560	1397	1290245159000	25120	12288	36	0	\N
190561	1397	1290235158000	25120	12288	37	0	\N
190562	1397	1290225157000	25120	12288	38	0	\N
190563	1397	1290215156000	25120	12288	39	0	\N
190564	1397	1290205155000	25120	12288	40	0	\N
190565	1397	1290195154000	25120	12288	41	0	\N
190566	1397	1290185153000	25120	12288	42	0	\N
190567	1397	1290175152000	25120	12288	43	0	\N
190568	1397	1290165151000	25120	12288	44	0	\N
190569	1397	1290155150000	25120	12288	45	0	\N
190570	1397	1290145149000	25120	12288	46	0	\N
190571	1397	1290135148000	25120	12288	47	0	\N
190572	1397	1290125147000	25120	12288	48	0	\N
190573	1397	1290115146000	25120	12288	49	0	\N
190574	1397	1290105145000	25120	12288	50	0	\N
190575	1397	1290095144000	25120	12288	51	0	\N
190576	1397	1290085143000	25120	12288	52	0	\N
190577	1397	1290075142000	25120	12288	53	0	\N
190578	1397	1290065141000	25120	12288	54	0	\N
190579	1397	1290055140000	25120	12288	55	0	\N
190580	1397	1290045139000	25120	12288	56	0	\N
190581	1397	1290035138000	25120	12288	57	0	\N
190582	1397	1290025137000	25120	12288	58	0	\N
190583	1397	1290015136000	25120	12288	59	0	\N
190584	1397	1290005135000	25120	12288	60	0	\N
190585	1397	1289995134000	25120	12288	61	0	\N
190586	1397	1289985133000	25120	12288	62	0	\N
190587	1397	1289975132000	25120	12288	63	0	\N
190588	1397	1289965131000	25120	12288	64	0	\N
190589	1397	1289955130000	25120	12288	65	0	\N
190590	1397	1289945129000	25120	12288	66	0	\N
190591	1397	1289935128000	25120	12288	67	0	\N
190592	1397	1289925127000	25120	12288	68	0	\N
190593	1397	1289915126000	25120	12288	69	0	\N
190594	1397	1289905125000	25120	12288	70	0	\N
190595	1397	1289895124000	25120	12288	71	0	\N
190596	1397	1289885123000	25120	12288	72	0	\N
190597	1397	1289875122000	25120	12288	73	0	\N
190598	1397	1289865121000	25120	12288	74	0	\N
190599	1397	1289855120000	25120	12288	75	0	\N
190600	1397	1289845119000	25120	12288	76	0	\N
190601	1397	1289835118000	25120	12288	77	0	\N
190602	1397	1289825117000	25120	12288	78	0	\N
190603	1397	1289815116000	25120	12288	79	0	\N
190604	1397	1289805115000	25120	12288	80	0	\N
190605	1397	1289795114000	25120	12288	81	0	\N
190606	1397	1289785113000	25120	12288	83	0	\N
190607	1397	1289775112000	25120	12288	84	0	\N
190608	1397	1289765111000	25120	12288	85	0	\N
190609	1397	1289755110000	25120	12288	86	0	\N
190610	1397	1289745109000	25120	12288	87	0	\N
190611	1397	1289735108000	25120	12288	88	0	\N
190612	1397	1289725107000	25120	12288	89	0	\N
190613	1397	1289715106000	25120	12288	90	0	\N
190614	1397	1289705105000	25120	12288	91	0	\N
190615	1397	1289695104000	25120	12288	92	0	\N
190616	1397	1289685103000	25120	12288	93	0	\N
190617	1397	1289675102000	25120	12288	94	0	\N
190618	1397	1289665101000	25120	12288	95	0	\N
190619	1397	1289655100000	25120	12288	96	0	\N
190620	1397	1289645099000	25120	12288	97	0	\N
190621	1397	1289635098000	25120	12288	98	0	\N
190622	1397	1289625097000	25120	12288	99	0	\N
190623	1397	1289615096000	25120	12288	100	0	\N
190624	1397	1289605095000	25120	12288	101	0	\N
190625	1397	1289595094000	25120	12288	102	0	\N
190626	1397	1289585093000	25120	12288	103	0	\N
190627	1397	1289575092000	25120	12288	104	0	\N
190628	1397	1289565091000	25120	12288	105	0	\N
190629	1397	1289555090000	25120	12288	106	0	\N
190630	1397	1289545089000	25120	12288	107	0	\N
190631	1397	1289535088000	25120	12288	108	0	\N
190632	1397	1289525087000	25120	12288	109	0	\N
190633	1397	1289515086000	25120	12288	110	0	\N
190634	1397	1289505085000	25120	12288	111	0	\N
190635	1397	1289495084000	25120	12288	112	0	\N
190636	1397	1289485083000	25120	12288	113	0	\N
190637	1397	1289475082000	25120	12288	114	0	\N
190638	1397	1289465081000	25120	12288	115	0	\N
190639	1397	1289455080000	25120	12288	116	0	\N
190640	1397	1289445079000	25120	12288	117	0	\N
190641	1397	1289435078000	25120	12288	118	0	\N
190642	1397	1289425077000	25120	12288	119	0	\N
190643	1397	1289415076000	25120	12288	120	0	\N
190644	1397	1289405075000	25120	12288	121	0	\N
190645	1397	1289395074000	25120	12288	122	0	\N
190646	1397	1289385073000	25120	12288	123	0	\N
190647	1397	1289375072000	25120	12288	124	0	\N
190648	1397	1288624997000	25121	12465	0	0	\N
190649	2134	85155770000	25121	12465	1	0	\N
190650	2133	91700042000	25121	12465	2	0	\N
190651	1397	1288624997000	25122	12465	0	0	\N
190652	2134	85155770000	25122	12465	1	0	\N
190653	2133	91700042000	25122	12465	2	0	\N
190657	1397	1288614996000	25124	12466	0	0	\N
190658	2132	147486499000	25124	12466	1	0	\N
190659	2133	91699040000	25124	12466	2	0	\N
190660	2134	85154767000	25124	12466	3	0	\N
190656	2133	91700042000	25123	12465	2	0	4981
190661	1397	1288614996000	25125	12466	0	0	15021
190662	2132	147486499000	25125	12466	1	0	1502
190663	2133	91699040000	25125	12466	2	0	4982
190664	2134	85154767000	25125	12466	3	0	5419
190666	2133	91698038000	25126	12467	1	0	4983
190667	2134	85153764000	25126	12467	2	0	5420
190668	1397	1288594994000	25127	12468	0	0	15023
190669	2133	91697036000	25127	12468	1	0	4984
190670	2134	85152761000	25127	12468	2	0	5421
190672	2133	91696034000	25128	12469	1	0	4985
190678	1397	1288574992000	25130	12470	0	0	\N
190679	2134	85150755000	25130	12470	1	0	\N
190680	2133	91695032000	25130	12470	2	0	\N
190681	1397	1288564991000	25131	12471	0	0	\N
190682	1397	1288554990000	25131	12471	1	0	\N
190683	2134	85149752000	25131	12471	2	0	\N
190684	2132	147484497000	25131	12471	3	0	\N
190685	2134	85148749000	25131	12471	4	0	\N
190686	2133	91694030000	25131	12471	5	0	\N
190687	2133	91693028000	25131	12471	6	0	\N
190688	1397	1288564991000	25132	12471	0	0	\N
190689	1397	1288554990000	25132	12471	1	0	\N
190690	2134	85149752000	25132	12471	2	0	\N
190691	2132	147484497000	25132	12471	3	0	\N
190692	2134	85148749000	25132	12471	4	0	\N
190693	2133	91694030000	25132	12471	5	0	\N
190694	2133	91693028000	25132	12471	6	0	\N
190702	1397	1288564991000	25134	12471	0	0	\N
190703	1397	1288554990000	25134	12471	1	0	\N
190704	2134	85149752000	25134	12471	2	0	\N
190705	2132	147484497000	25134	12471	3	0	\N
190706	2134	85148749000	25134	12471	4	0	\N
190707	2133	91694030000	25134	12471	5	0	\N
190708	2133	91693028000	25134	12471	6	0	\N
190709	1397	1288564991000	25135	12471	0	0	\N
190710	1397	1288554990000	25135	12471	1	0	\N
190711	2134	85149752000	25135	12471	2	0	\N
190712	2132	147484497000	25135	12471	3	0	\N
190713	2134	85148749000	25135	12471	4	0	\N
190714	2133	91694030000	25135	12471	5	0	\N
190715	2133	91693028000	25135	12471	6	0	\N
190716	1397	1288544989000	25136	12472	0	0	\N
190717	2134	85147746000	25136	12472	1	0	\N
190718	2133	91692026000	25136	12472	2	0	\N
190722	1397	1288544989000	25138	12472	0	0	\N
190723	2134	85147746000	25138	12472	1	0	\N
190724	2133	91692026000	25138	12472	2	0	\N
190725	1397	1288534988000	25139	12473	0	0	\N
190726	2133	91691024000	25139	12473	1	0	\N
190727	2134	85146743000	25139	12473	2	0	\N
190728	1397	1288534988000	25140	12473	0	0	\N
190729	2133	91691024000	25140	12473	1	0	\N
190730	2134	85146743000	25140	12473	2	0	\N
190737	1397	1288524987000	25143	12474	0	0	\N
190738	2134	85145740000	25143	12474	1	0	\N
190739	2133	91690022000	25143	12474	2	0	\N
190748	1397	1288494984000	25146	12477	0	0	\N
190749	2133	91687016000	25146	12477	1	0	\N
190750	2134	85142731000	25146	12477	2	0	\N
190754	1397	1288494984000	25148	12477	0	0	\N
190755	2133	91687016000	25148	12477	1	0	\N
190756	2134	85142731000	25148	12477	2	0	\N
190762	1397	1288594994000	25150	12468	0	0	\N
190763	1397	1288584993000	25150	12468	1	0	\N
190764	1397	1288574992000	25150	12468	2	0	\N
190765	1397	1288564991000	25150	12468	3	0	\N
190766	1397	1288554990000	25150	12468	4	0	\N
190767	1397	1288544989000	25150	12468	5	0	\N
190768	1397	1288534988000	25150	12468	6	0	\N
190769	1397	1288524987000	25150	12468	7	0	\N
190770	1397	1288514986000	25150	12468	8	0	\N
190771	1397	1288504985000	25150	12468	9	0	\N
190772	1397	1288494984000	25150	12468	10	0	\N
190773	1397	1288484983000	25150	12468	11	0	\N
190774	2133	91697036000	25150	12468	12	0	\N
190775	2133	91696034000	25150	12468	13	0	\N
190776	2288	775756211465	25150	12468	14	0	\N
190777	2134	85152761000	25150	12468	15	0	\N
190778	2133	91695032000	25150	12468	16	0	\N
190779	2133	91694030000	25150	12468	17	0	\N
190780	2133	91693028000	25150	12468	18	0	\N
190781	2133	91692026000	25150	12468	19	0	\N
190782	2133	91691024000	25150	12468	20	0	\N
190783	2133	91690022000	25150	12468	21	0	\N
190784	2133	91689020000	25150	12468	22	0	\N
190785	2133	91688018000	25150	12468	23	0	\N
190786	2133	91687016000	25150	12468	24	0	\N
190787	2133	91686014000	25150	12468	25	0	\N
190788	2119	190000000	25150	12468	26	0	\N
190789	2134	85151758000	25150	12468	27	0	\N
190790	2134	85150755000	25150	12468	28	0	\N
190791	2134	85149752000	25150	12468	29	0	\N
190792	2134	85148749000	25150	12468	30	0	\N
190793	2134	85147746000	25150	12468	31	0	\N
190794	2134	85146743000	25150	12468	32	0	\N
190795	2134	85145740000	25150	12468	33	0	\N
190796	2134	85144737000	25150	12468	34	0	\N
190797	2134	85143734000	25150	12468	35	0	\N
190798	2134	85142731000	25150	12468	36	0	\N
190799	2132	147485498000	25150	12468	37	0	\N
190800	2132	147484497000	25150	12468	38	0	\N
190801	2132	147483496000	25150	12468	39	0	\N
190802	2132	147482495000	25150	12468	40	0	\N
190803	2134	85141728000	25150	12468	41	0	\N
190804	2288	774754211465	25151	12479	0	0	\N
190805	2134	85140725000	25151	12479	1	0	\N
190806	2133	91685012000	25151	12479	2	0	\N
190807	1397	1288474982000	25152	12479	0	0	\N
190808	2288	774754211465	25152	12479	1	0	\N
190675	1397	1288574992000	25129	12470	0	0	15025
190676	2134	85150755000	25129	12470	1	0	5423
190677	2133	91695032000	25129	12470	2	0	4986
190695	1397	1288564991000	25133	12471	0	0	15026
190696	1397	1288554990000	25133	12471	1	0	15027
190698	2132	147484497000	25133	12471	3	0	1504
190699	2134	85148749000	25133	12471	4	0	5425
190700	2133	91694030000	25133	12471	5	0	4987
190701	2133	91693028000	25133	12471	6	0	4988
190719	1397	1288544989000	25137	12472	0	0	15028
190721	2133	91692026000	25137	12472	2	0	4989
190731	1397	1288534988000	25141	12473	0	0	15029
190732	2133	91691024000	25141	12473	1	0	4990
190733	2134	85146743000	25141	12473	2	0	5427
190735	2134	85145740000	25142	12474	1	0	5428
190736	2133	91690022000	25142	12474	2	0	4991
190740	1397	1288514986000	25144	12475	0	0	15031
190741	2133	91689020000	25144	12475	1	0	4992
190742	2288	775756211465	25144	12475	2	0	1
190744	2134	85144737000	25144	12475	4	0	5429
190745	1397	1288504985000	25145	12476	0	0	15032
190746	2133	91688018000	25145	12476	2	0	4993
190747	2134	85143734000	25145	12476	3	0	5430
190751	1397	1288494984000	25147	12477	0	0	15033
190753	2134	85142731000	25147	12477	2	0	5431
190757	1397	1288484983000	25149	12478	0	0	15034
190758	2133	91686014000	25149	12478	1	0	4995
190759	2132	147482495000	25149	12478	2	0	1506
190761	2134	85141728000	25149	12478	4	0	5432
190809	2134	85140725000	25152	12479	2	0	\N
190810	2133	91685012000	25152	12479	3	0	\N
190825	2288	0	25156	12481	0	0	\N
190826	1397	1288454980000	25156	12481	1	0	\N
190827	2134	85138719000	25156	12481	2	0	\N
190828	2132	147481494000	25156	12481	3	0	\N
190829	2133	91683008000	25156	12481	4	0	\N
190830	2026	75199000000	25156	12481	5	0	\N
190831	2288	0	25157	12481	0	0	\N
190832	1397	1288454980000	25157	12481	1	0	\N
190833	2134	85138719000	25157	12481	2	0	\N
190834	2132	147481494000	25157	12481	3	0	\N
190835	2133	91683008000	25157	12481	4	0	\N
190836	2026	75199000000	25157	12481	5	0	\N
190837	2288	0	25158	12481	0	0	\N
190838	1397	1288454980000	25158	12481	1	0	\N
190839	2134	85138719000	25158	12481	2	0	\N
190840	2132	147481494000	25158	12481	3	0	\N
190841	2133	91683008000	25158	12481	4	0	\N
190842	2026	75199000000	25158	12481	5	0	\N
190846	1397	1288474982000	25160	12469	0	0	\N
190847	1397	1288464981000	25160	12469	1	0	\N
190848	1397	1288454980000	25160	12469	2	0	\N
190849	1397	1288444979000	25160	12469	3	0	\N
190850	2288	774754211465	25160	12469	5	0	\N
190851	2288	0	25160	12469	6	0	\N
190852	2132	147481494000	25160	12469	7	0	\N
190853	2134	85140725000	25160	12469	8	0	\N
190854	2133	91685012000	25160	12469	9	0	\N
190855	2026	75199000000	25160	12469	10	0	\N
190856	2133	91684010000	25160	12469	11	0	\N
190857	2133	91683008000	25160	12469	12	0	\N
190858	2134	85139722000	25160	12469	13	0	\N
190859	2134	85138719000	25160	12469	14	0	\N
190864	1397	1288434978000	25162	12483	0	0	\N
190865	2320	775741211465	25162	12483	1	0	\N
190866	2134	85136713000	25162	12483	2	0	\N
190867	2133	91681004000	25162	12483	3	0	\N
190871	1397	1288424977000	25164	12484	0	0	\N
190872	2133	91680002000	25164	12484	1	0	\N
190873	2134	85135710000	25164	12484	2	0	\N
190874	1397	1288424977000	25165	12484	0	0	\N
190875	2133	91680002000	25165	12484	1	0	\N
190876	2134	85135710000	25165	12484	2	0	\N
190877	1397	1288434978000	25166	12470	0	0	\N
190878	1397	1288424977000	25166	12470	1	0	\N
190879	2134	85137716000	25166	12470	2	0	\N
190880	2133	91682006000	25166	12470	3	0	\N
190881	2134	85136713000	25166	12470	4	0	\N
190882	2134	85135710000	25166	12470	5	0	\N
190883	2133	91681004000	25166	12470	6	0	\N
190884	2133	91680002000	25166	12470	7	0	\N
190889	1397	1288414976000	25168	12485	0	0	\N
190890	2134	85134707000	25168	12485	1	0	\N
190891	2132	147480493000	25168	12485	2	0	\N
190892	2133	91679000000	25168	12485	3	0	\N
190893	1397	1288404975000	25169	12486	0	0	\N
190894	2133	91677998000	25169	12486	1	0	\N
190895	2134	85133704000	25169	12486	2	0	\N
190896	1397	1288404975000	25170	12486	0	0	\N
190897	2133	91677998000	25170	12486	1	0	\N
190898	2134	85133704000	25170	12486	2	0	\N
190928	1397	1288374972000	25183	12489	0	0	\N
190929	1397	1288364971000	25183	12489	1	0	\N
190930	1397	1288354970000	25183	12489	2	0	\N
190931	1397	1288344969000	25183	12489	3	0	\N
190932	1397	1288334968000	25183	12489	4	0	\N
190933	1397	1288324967000	25183	12489	5	0	\N
190934	1397	1288314966000	25183	12489	6	0	\N
190935	1397	1288304965000	25183	12489	7	0	\N
190936	1397	1288294964000	25183	12489	8	0	\N
190937	2134	85130695000	25183	12489	9	0	\N
190938	2133	91674992000	25183	12489	10	0	\N
190939	2132	147478491000	25183	12489	11	0	\N
190940	1759	23508329289889	25183	12489	12	0	\N
190941	2134	85129692000	25183	12489	13	0	\N
190942	2134	85128689000	25183	12489	14	0	\N
190943	2134	85127686000	25183	12489	15	0	\N
190944	2134	85126683000	25183	12489	16	0	\N
190813	2134	85140725000	25153	12479	2	0	5433
190814	2133	91685012000	25153	12479	3	0	4996
190815	1397	1288464981000	25154	12480	0	0	15036
190816	2320	999000000	25154	12480	1	0	1
190817	2133	91684010000	25154	12480	2	0	4997
190819	2288	0	25155	12481	0	0	3
190820	1397	1288454980000	25155	12481	1	0	15037
190821	2134	85138719000	25155	12481	2	0	5435
190822	2132	147481494000	25155	12481	3	0	1507
190823	2133	91683008000	25155	12481	4	0	4998
190843	1397	1288444979000	25159	12482	0	0	15038
190844	2134	85137716000	25159	12482	1	0	5436
190845	2133	91682006000	25159	12482	2	0	4999
190860	1397	1288434978000	25161	12483	0	0	15039
190862	2134	85136713000	25161	12483	2	0	5437
190863	2133	91681004000	25161	12483	3	0	5000
190868	1397	1288424977000	25163	12484	0	0	15040
190869	2133	91680002000	25163	12484	1	0	5001
190870	2134	85135710000	25163	12484	2	0	5438
190886	2134	85134707000	25167	12485	1	0	5439
190887	2132	147480493000	25167	12485	2	0	1508
190888	2133	91679000000	25167	12485	3	0	5002
190899	2133	91677998000	25171	12486	0	0	5003
190900	2134	85133704000	25171	12486	1	0	5440
190902	1397	1288394974000	25172	12487	1	0	15043
190903	2134	85132701000	25172	12487	2	0	5441
190904	2133	91676996000	25172	12487	3	0	5004
190905	1397	1288384973000	25173	12488	0	0	15044
190907	2134	85131698000	25173	12488	2	0	5442
190908	2132	147479492000	25173	12488	3	0	1509
190909	1397	1288374972000	25174	12489	0	0	15045
190910	2134	85130695000	25174	12489	1	0	5443
190911	2133	91674992000	25174	12489	2	0	5006
190913	2134	85129692000	25175	12490	1	0	5444
190914	2133	91673990000	25175	12490	2	0	5007
190915	1397	1288354970000	25176	12491	0	0	15047
190916	2134	85128689000	25176	12491	1	0	5445
190917	2132	147478491000	25176	12491	2	0	1510
190919	1397	1288344969000	25177	12492	0	0	15048
190920	2133	91671986000	25177	12492	1	0	5009
190921	2134	85127686000	25177	12492	2	0	5446
190922	1397	1288334968000	25178	12493	0	0	15049
190924	2134	85126683000	25178	12493	2	0	5447
190925	1397	1288324967000	25179	12494	0	0	15050
190926	2134	85125680000	25179	12494	1	0	5448
190927	2133	91669982000	25179	12494	2	0	5011
190945	2134	85125680000	25183	12489	17	0	\N
190946	2134	85124677000	25183	12489	18	0	\N
190947	2134	85123674000	25183	12489	19	0	\N
190948	2134	85122671000	25183	12489	20	0	\N
190949	2132	147477490000	25183	12489	21	0	\N
190950	2133	91673990000	25183	12489	22	0	\N
190951	2133	91672988000	25183	12489	23	0	\N
190952	2133	91671986000	25183	12489	24	0	\N
190953	2133	91670984000	25183	12489	25	0	\N
190954	2133	91669982000	25183	12489	26	0	\N
190955	2133	91668980000	25183	12489	27	0	\N
190956	2133	91667978000	25183	12489	28	0	\N
190957	2133	91666976000	25183	12489	29	0	\N
190958	1397	1288314966000	25184	12495	0	0	\N
190959	1397	1288304965000	25184	12495	1	0	\N
190960	1397	1288294964000	25184	12495	2	0	\N
190961	2133	91668980000	25184	12495	3	0	\N
190962	2133	91667978000	25184	12495	4	0	\N
190963	2133	91666976000	25184	12495	5	0	\N
190964	1759	23508329289889	25184	12495	6	0	\N
190965	2134	85124677000	25184	12495	7	0	\N
190966	2134	85123674000	25184	12495	8	0	\N
190967	2134	85122671000	25184	12495	9	0	\N
190968	2132	147477490000	25184	12495	10	0	\N
190980	1397	1288314966000	25186	12495	0	0	\N
190981	1397	1288304965000	25186	12495	1	0	\N
190982	1397	1288294964000	25186	12495	2	0	\N
190983	2133	91668980000	25186	12495	3	0	\N
190984	2133	91667978000	25186	12495	4	0	\N
190985	2133	91666976000	25186	12495	5	0	\N
190986	1759	23508329289889	25186	12495	6	0	\N
190987	2134	85124677000	25186	12495	7	0	\N
190988	2134	85123674000	25186	12495	8	0	\N
190989	2134	85122671000	25186	12495	9	0	\N
190990	2132	147477490000	25186	12495	10	0	\N
190991	1397	1288314966000	25187	12495	0	0	\N
190992	1397	1288304965000	25187	12495	1	0	\N
190993	1397	1288294964000	25187	12495	2	0	\N
190994	2133	91668980000	25187	12495	3	0	\N
190995	2133	91667978000	25187	12495	4	0	\N
190996	2133	91666976000	25187	12495	5	0	\N
190997	1759	23508329289889	25187	12495	6	0	\N
190998	2134	85124677000	25187	12495	7	0	\N
190999	2134	85123674000	25187	12495	8	0	\N
191000	2134	85122671000	25187	12495	9	0	\N
191001	2132	147477490000	25187	12495	10	0	\N
191002	2133	91668980000	25188	12495	0	0	\N
191003	2133	91667978000	25188	12495	1	0	\N
191004	2133	91666976000	25188	12495	2	0	\N
191005	1759	23508329289889	25188	12495	3	0	\N
191006	2134	85124677000	25188	12495	4	0	\N
191007	2134	85123674000	25188	12495	5	0	\N
191008	2134	85122671000	25188	12495	6	0	\N
191009	2132	147477490000	25188	12495	7	0	\N
191010	1397	1288284963000	25189	12496	0	0	\N
191011	2133	91665974000	25189	12496	1	0	\N
191012	2132	147476489000	25189	12496	2	0	\N
191013	1759	20590886789889	25189	12496	3	0	\N
191014	1759	16266956139889	25189	12496	4	0	\N
191015	2134	85121668000	25189	12496	5	0	\N
191022	1397	1288274962000	25191	12497	0	0	\N
191023	1759	8137245139889	25191	12497	2	0	\N
191024	2134	85120665000	25191	12497	3	0	\N
191025	2133	91664972000	25191	12497	4	0	\N
191030	1397	1288274962000	25193	12497	0	0	\N
191031	1759	8137245139889	25193	12497	2	0	\N
191032	2134	85120665000	25193	12497	3	0	\N
191033	2133	91664972000	25193	12497	4	0	\N
191034	2186	7693786	25194	12498	0	0	\N
191035	1397	1288264961000	25194	12498	1	0	\N
191036	2134	85119662000	25194	12498	2	0	\N
191037	2133	91663970000	25194	12498	3	0	\N
191053	1397	1288234958000	25198	12500	0	0	\N
191054	2134	85116653000	25198	12500	1	0	\N
191055	2133	91660964000	25198	12500	2	0	\N
191056	1397	1288234958000	25199	12500	0	0	\N
191057	2134	85116653000	25199	12500	1	0	\N
191058	2133	91660964000	25199	12500	2	0	\N
191059	2186	7693786	25200	12455	0	0	\N
191060	1397	1288745009000	25200	12455	1	0	\N
191061	1397	1288735008000	25200	12455	2	0	\N
191062	1397	1288725007000	25200	12455	3	0	\N
191063	1397	1288715006000	25200	12455	4	0	\N
191064	1397	1288705005000	25200	12455	5	0	\N
191065	1397	1288695004000	25200	12455	6	0	\N
191066	1397	1288685003000	25200	12455	7	0	\N
191067	1397	1288675002000	25200	12455	8	0	\N
191068	1397	1288665001000	25200	12455	9	0	\N
191069	1397	1288655000000	25200	12455	10	0	\N
191070	1397	1288644999000	25200	12455	11	0	\N
191071	1397	1288634998000	25200	12455	12	0	\N
191072	1397	1288624997000	25200	12455	13	0	\N
191073	1397	1288614996000	25200	12455	14	0	\N
191074	1397	1288604995000	25200	12455	15	0	\N
191075	1397	1288594994000	25200	12455	16	0	\N
191076	1397	1288584993000	25200	12455	17	0	\N
191077	1397	1288574992000	25200	12455	18	0	\N
191078	1397	1288564991000	25200	12455	19	0	\N
191079	1397	1288554990000	25200	12455	20	0	\N
191080	1397	1288544989000	25200	12455	21	0	\N
190971	1397	1288294964000	25185	12495	2	0	15053
190972	2133	91668980000	25185	12495	3	0	5012
190973	2133	91667978000	25185	12495	4	0	5013
190974	2133	91666976000	25185	12495	5	0	5014
190975	1759	23508329289889	25185	12495	6	0	8
190977	2134	85123674000	25185	12495	8	0	5450
190978	2134	85122671000	25185	12495	9	0	5451
190979	2132	147477490000	25185	12495	10	0	1511
191016	1397	1288284963000	25190	12496	0	0	15054
191017	2133	91665974000	25190	12496	1	0	5015
191019	1759	20590886789889	25190	12496	3	0	9
191020	1759	16266956139889	25190	12496	4	0	10
191021	2134	85121668000	25190	12496	5	0	5452
191026	1397	1288274962000	25192	12497	0	0	15055
191028	2134	85120665000	25192	12497	3	0	5453
191029	2133	91664972000	25192	12497	4	0	5016
191038	2186	7693786	25195	12498	0	0	2
191039	1397	1288264961000	25195	12498	1	0	15056
191040	2134	85119662000	25195	12498	2	0	5454
191042	1397	1288254960000	25196	12499	0	0	15057
191043	1397	1288244959000	25196	12499	1	0	15058
191044	2133	91662968000	25196	12499	2	0	5018
191045	2134	85118659000	25196	12499	3	0	5455
191046	2134	85117656000	25196	12499	4	0	5456
191048	1764	24606459100000	25196	12499	6	0	9
191049	2132	147475488000	25196	12499	7	0	1513
191050	1397	1288234958000	25197	12500	0	0	15059
191051	2134	85116653000	25197	12500	1	0	5457
191081	1397	1288534988000	25200	12455	22	0	\N
191082	1397	1288524987000	25200	12455	23	0	\N
191083	1397	1288514986000	25200	12455	24	0	\N
191084	1397	1288504985000	25200	12455	25	0	\N
191085	1397	1288494984000	25200	12455	26	0	\N
191086	1397	1288484983000	25200	12455	27	0	\N
191087	1397	1288474982000	25200	12455	28	0	\N
191088	1397	1288464981000	25200	12455	29	0	\N
191089	1397	1288454980000	25200	12455	30	0	\N
191090	1397	1288444979000	25200	12455	31	0	\N
191091	1397	1288434978000	25200	12455	32	0	\N
191092	1397	1288424977000	25200	12455	33	0	\N
191093	1397	1288414976000	25200	12455	34	0	\N
191094	1397	1288404975000	25200	12455	35	0	\N
191095	1397	1288394974000	25200	12455	36	0	\N
191096	1397	1288384973000	25200	12455	37	0	\N
191097	1397	1288374972000	25200	12455	38	0	\N
191098	1397	1288364971000	25200	12455	39	0	\N
191099	1397	1288354970000	25200	12455	40	0	\N
191100	1397	1288344969000	25200	12455	41	0	\N
191101	1397	1288334968000	25200	12455	42	0	\N
191102	1397	1288324967000	25200	12455	43	0	\N
191103	1397	1288314966000	25200	12455	44	0	\N
191104	1397	1288304965000	25200	12455	45	0	\N
191105	1397	1288294964000	25200	12455	46	0	\N
191106	1397	1288284963000	25200	12455	47	0	\N
191107	1397	1288274962000	25200	12455	48	0	\N
191108	1397	1288264961000	25200	12455	49	0	\N
191109	1397	1288254960000	25200	12455	50	0	\N
191110	1397	1288244959000	25200	12455	51	0	\N
191111	1397	1288234958000	25200	12455	52	0	\N
191112	2134	85168809000	25200	12455	53	0	\N
191113	2133	91713068000	25200	12455	54	0	\N
191114	2133	91712066000	25200	12455	55	0	\N
191115	2288	775756211465	25200	12455	56	0	\N
191116	2288	774754211465	25200	12455	57	0	\N
191117	2288	0	25200	12455	58	0	\N
191118	2133	91711064000	25200	12455	59	0	\N
191119	2133	91710062000	25200	12455	60	0	\N
191120	2133	91709060000	25200	12455	61	0	\N
191121	2133	91708058000	25200	12455	62	0	\N
191122	2133	91707056000	25200	12455	63	0	\N
191123	2133	91706054000	25200	12455	64	0	\N
191124	2133	91705052000	25200	12455	65	0	\N
191125	2133	91704050000	25200	12455	66	0	\N
191126	2133	91703048000	25200	12455	67	0	\N
191127	2133	91702046000	25200	12455	68	0	\N
191128	2133	91701044000	25200	12455	69	0	\N
191129	1759	23508329289889	25200	12455	70	0	\N
191130	2134	85167806000	25200	12455	71	0	\N
191131	2134	85166803000	25200	12455	72	0	\N
191132	2134	85165800000	25200	12455	73	0	\N
191133	2134	85164797000	25200	12455	74	0	\N
191134	1759	20590886789889	25200	12455	75	0	\N
191135	1759	16266956139889	25200	12455	76	0	\N
191136	1759	8137245139889	25200	12455	77	0	\N
191137	2134	85163794000	25200	12455	78	0	\N
191138	2026	75199000000	25200	12455	79	0	\N
191139	1764	24606459100000	25200	12455	80	0	\N
191140	2132	147490503000	25200	12455	81	0	\N
191141	2132	147489502000	25200	12455	82	0	\N
191142	2132	147488501000	25200	12455	83	0	\N
191143	2132	147487500000	25200	12455	84	0	\N
191144	2132	147486499000	25200	12455	85	0	\N
191145	2119	190000000	25200	12455	86	0	\N
191146	2132	147485498000	25200	12455	87	0	\N
191147	2132	147484497000	25200	12455	88	0	\N
191148	2132	147483496000	25200	12455	89	0	\N
191149	2132	147482495000	25200	12455	90	0	\N
191150	2132	147481494000	25200	12455	91	0	\N
191151	2132	147480493000	25200	12455	92	0	\N
191152	2132	147479492000	25200	12455	93	0	\N
191153	2132	147478491000	25200	12455	94	0	\N
191154	2132	147477490000	25200	12455	95	0	\N
191155	2132	147476489000	25200	12455	96	0	\N
191156	2132	147475488000	25200	12455	97	0	\N
191157	2133	91700042000	25200	12455	98	0	\N
191158	2133	91699040000	25200	12455	99	0	\N
191159	2133	91698038000	25200	12455	100	0	\N
191160	2133	91697036000	25200	12455	101	0	\N
191161	2133	91696034000	25200	12455	102	0	\N
191162	2133	91695032000	25200	12455	103	0	\N
191163	2133	91694030000	25200	12455	104	0	\N
191164	2133	91693028000	25200	12455	105	0	\N
191165	2133	91692026000	25200	12455	106	0	\N
191166	2133	91691024000	25200	12455	107	0	\N
191167	2133	91690022000	25200	12455	108	0	\N
191168	2133	91689020000	25200	12455	109	0	\N
191169	2133	91688018000	25200	12455	110	0	\N
191170	2133	91687016000	25200	12455	111	0	\N
191171	2133	91686014000	25200	12455	112	0	\N
191172	2133	91685012000	25200	12455	113	0	\N
191173	2133	91684010000	25200	12455	114	0	\N
191174	2133	91683008000	25200	12455	115	0	\N
191175	2133	91682006000	25200	12455	116	0	\N
191176	2133	91681004000	25200	12455	117	0	\N
191177	2133	91680002000	25200	12455	118	0	\N
191178	2133	91679000000	25200	12455	119	0	\N
191179	2133	91677998000	25200	12455	120	0	\N
191180	2133	91676996000	25200	12455	121	0	\N
191181	2133	91675994000	25200	12455	122	0	\N
191182	2133	91674992000	25200	12455	123	0	\N
191183	2133	91673990000	25200	12455	124	0	\N
191184	2133	91672988000	25200	12455	125	0	\N
191185	1397	1288224957000	25201	12501	0	0	\N
191186	1397	1288214956000	25201	12501	1	0	\N
191187	2133	91659962000	25201	12501	2	0	\N
191188	2132	147474487000	25201	12501	3	0	\N
191189	2134	85115650000	25201	12501	4	0	\N
191190	2133	91658960000	25201	12501	5	0	\N
191191	2134	85114647000	25201	12501	6	0	\N
191192	1397	1288224957000	25202	12501	0	0	\N
191193	1397	1288214956000	25202	12501	1	0	\N
191194	2133	91659962000	25202	12501	2	0	\N
191195	2132	147474487000	25202	12501	3	0	\N
191196	2134	85115650000	25202	12501	4	0	\N
191197	2133	91658960000	25202	12501	5	0	\N
191198	2134	85114647000	25202	12501	6	0	\N
191201	2133	91659962000	25203	12501	2	0	5021
191202	2132	147474487000	25203	12501	3	0	1514
191203	2134	85115650000	25203	12501	4	0	5458
191204	2133	91658960000	25203	12501	5	0	5022
191205	2134	85114647000	25203	12501	6	0	5459
191207	2133	91657958000	25204	12502	1	0	5023
191208	2134	85113644000	25204	12502	2	0	5460
191209	1397	1288194954000	25206	12503	0	0	15063
191210	1397	1288184953000	25206	12503	1	0	15064
191211	2134	85112641000	25206	12503	2	0	5461
191213	2132	147473486000	25206	12503	4	0	1515
191214	2133	91656956000	25206	12503	5	0	5024
191215	2133	91655954000	25206	12503	6	0	5025
191216	1397	1288174952000	25207	12504	0	0	15065
191223	1397	1288154950000	25208	12505	0	0	\N
191224	2133	91652948000	25208	12505	1	0	\N
191225	2134	85108629000	25208	12505	2	0	\N
191226	1397	1288154950000	25209	12505	0	0	\N
191227	2133	91652948000	25209	12505	1	0	\N
191228	2134	85108629000	25209	12505	2	0	\N
191229	1397	1288154950000	25210	12505	0	0	\N
191230	2133	91652948000	25210	12505	1	0	\N
191231	2134	85108629000	25210	12505	2	0	\N
191235	1397	1288154950000	25212	12505	0	0	\N
191236	2133	91652948000	25212	12505	1	0	\N
191237	2134	85108629000	25212	12505	2	0	\N
191254	1397	1288104945000	25217	12510	0	0	\N
191255	2133	91647938000	25217	12510	1	0	\N
191256	2134	85103614000	25217	12510	2	0	\N
191257	1764	11602456100000	25217	12510	3	0	\N
191262	1397	1288094944000	25219	12511	0	0	\N
191263	2133	91646936000	25219	12511	1	0	\N
191264	2134	85102611000	25219	12511	2	0	\N
191268	1397	1288084943000	25221	12512	0	0	\N
191269	2132	147470483000	25221	12512	1	0	\N
191270	2133	91645934000	25221	12512	2	0	\N
191271	2134	85101608000	25221	12512	3	0	\N
191276	1397	1288074942000	25223	12513	0	0	\N
191277	2134	85100605000	25223	12513	1	0	\N
191278	2133	91644932000	25223	12513	2	0	\N
191279	1397	1288074942000	25224	12513	0	0	\N
191280	2134	85100605000	25224	12513	1	0	\N
191281	2133	91644932000	25224	12513	2	0	\N
191283	1397	1288064941000	25226	12514	0	0	\N
191284	2134	85100605000	25226	12514	1	0	\N
191285	2133	91644932000	25226	12514	2	0	\N
191286	2133	91643930000	25226	12514	3	0	\N
191287	2134	85099602000	25226	12514	4	0	\N
191288	1397	1288064941000	25227	12514	0	0	\N
191289	2134	85100605000	25227	12514	1	0	\N
191290	2133	91644932000	25227	12514	2	0	\N
191291	2133	91643930000	25227	12514	3	0	\N
191292	2134	85099602000	25227	12514	4	0	\N
191293	1397	1288064941000	25228	12514	0	0	\N
191294	2134	85100605000	25228	12514	1	0	\N
191295	2133	91644932000	25228	12514	2	0	\N
191296	2133	91643930000	25228	12514	3	0	\N
191297	2134	85099602000	25228	12514	4	0	\N
191303	1397	1288064941000	25230	12514	0	0	\N
191304	2134	85100605000	25230	12514	1	0	\N
191305	2133	91644932000	25230	12514	2	0	\N
191306	2134	85099602000	25230	12514	3	0	\N
191307	1397	1288064941000	25231	12514	0	0	\N
191308	2133	91643930000	25231	12514	1	0	\N
191309	2134	85099602000	25231	12514	2	0	\N
191320	1397	1288044939000	25234	12516	0	0	\N
191321	2133	91641926000	25234	12516	1	0	\N
191322	2132	147469482000	25234	12516	2	0	\N
191323	2134	85097596000	25234	12516	3	0	\N
191324	1749	12934586529980	25234	12516	4	0	\N
191325	1397	1288044939000	25235	12516	0	0	\N
191326	2133	91641926000	25235	12516	1	0	\N
191327	2132	147469482000	25235	12516	2	0	\N
191328	2134	85097596000	25235	12516	3	0	\N
191329	1749	12934586529980	25235	12516	4	0	\N
191330	1397	1288044939000	25236	12516	0	0	\N
191331	2133	91641926000	25236	12516	1	0	\N
191332	2132	147469482000	25236	12516	2	0	\N
191333	2134	85097596000	25236	12516	3	0	\N
191334	1749	12934586529980	25236	12516	4	0	\N
191335	1397	1288034938000	25239	12518	0	0	\N
191336	1397	1288024937000	25239	12518	1	0	\N
191337	2133	91640924000	25239	12518	2	0	\N
191338	2133	91639922000	25239	12518	3	0	\N
191339	2134	85096593000	25239	12518	4	0	\N
191340	2134	85095590000	25239	12518	5	0	\N
191341	1749	8444585529980	25239	12518	6	0	\N
191342	1749	2584529980	25239	12518	7	0	\N
191219	1769	1572700000	25207	12504	3	0	60
191220	2134	85110635000	25207	12504	4	0	5463
191221	2134	85109632000	25207	12504	5	0	5464
191222	2133	91653950000	25207	12504	6	0	5027
191232	1397	1288154950000	25211	12505	0	0	15067
191234	2134	85108629000	25211	12505	2	0	5465
191238	1397	1288144949000	25213	12506	0	0	15068
191239	2132	147472485000	25213	12506	1	0	1516
191240	2134	85107626000	25213	12506	2	0	5466
191241	2133	91651946000	25213	12506	3	0	5029
191243	2133	91650944000	25214	12507	1	0	5030
191244	2134	85106623000	25214	12507	2	0	5467
191245	1397	1288124947000	25215	12508	0	0	15070
191246	2134	85105620000	25215	12508	1	0	5468
191248	1397	1288114946000	25216	12509	0	0	15071
191249	2134	85104617000	25216	12509	1	0	5469
191250	2132	147471484000	25216	12509	2	0	1517
191251	2133	91648940000	25216	12509	3	0	5032
191252	1764	20948458100000	25216	12509	4	0	10
191258	1397	1288104945000	25218	12510	0	0	15072
191259	2133	91647938000	25218	12510	1	0	5033
191260	2134	85103614000	25218	12510	2	0	5470
191261	1764	11602456100000	25218	12510	3	0	12
191265	1397	1288094944000	25220	12511	0	0	15073
191267	2134	85102611000	25220	12511	2	0	5471
191272	1397	1288084943000	25222	12512	0	0	15074
191273	2132	147470483000	25222	12512	1	0	1518
191274	2133	91645934000	25222	12512	2	0	5035
191282	1397	1288074942000	25225	12513	0	0	15075
191298	1397	1288064941000	25229	12514	0	0	15076
191299	2134	85100605000	25229	12514	1	0	5473
191300	2133	91644932000	25229	12514	2	0	5036
191301	2133	91643930000	25229	12514	3	0	5037
191310	1397	1288054940000	25232	12515	0	0	15077
191311	1933	1819268000000	25232	12515	1	0	3
191312	2134	85098599000	25232	12515	2	0	5475
191313	2133	91642928000	25232	12515	3	0	5038
191314	1749	15963587529980	25232	12515	4	0	20
191316	2133	91641926000	25233	12516	1	0	5039
191317	2132	147469482000	25233	12516	2	0	1519
191318	2134	85097596000	25233	12516	3	0	5476
191319	1749	12934586529980	25233	12516	4	0	21
191344	1397	1288024937000	25240	12518	1	0	15080
191345	2133	91640924000	25240	12518	2	0	5040
191346	2133	91639922000	25240	12518	3	0	5041
191347	2134	85096593000	25240	12518	4	0	5477
191348	2134	85095590000	25240	12518	5	0	5478
191350	1749	2584529980	25240	12518	7	0	23
191351	1397	1288014936000	25241	12519	0	0	15081
191352	2134	85094587000	25241	12519	1	0	5479
191358	2186	7693786	25243	12471	0	0	\N
191359	1397	1288414976000	25243	12471	1	0	\N
191360	1397	1288404975000	25243	12471	2	0	\N
191361	1397	1288394974000	25243	12471	3	0	\N
191362	1397	1288384973000	25243	12471	4	0	\N
191363	1397	1288374972000	25243	12471	5	0	\N
191364	1397	1288364971000	25243	12471	6	0	\N
191365	1397	1288354970000	25243	12471	7	0	\N
191366	1397	1288344969000	25243	12471	8	0	\N
191367	1397	1288334968000	25243	12471	9	0	\N
191368	1397	1288324967000	25243	12471	10	0	\N
191369	1397	1288314966000	25243	12471	11	0	\N
191370	1397	1288304965000	25243	12471	12	0	\N
191371	1397	1288294964000	25243	12471	13	0	\N
191372	1397	1288284963000	25243	12471	14	0	\N
191373	1397	1288274962000	25243	12471	15	0	\N
191374	1397	1288264961000	25243	12471	16	0	\N
191375	1397	1288254960000	25243	12471	17	0	\N
191376	1397	1288244959000	25243	12471	18	0	\N
191377	1397	1288234958000	25243	12471	19	0	\N
191378	1397	1288224957000	25243	12471	20	0	\N
191379	1397	1288214956000	25243	12471	21	0	\N
191380	1397	1288204955000	25243	12471	22	0	\N
191381	1397	1288194954000	25243	12471	23	0	\N
191382	1397	1288184953000	25243	12471	24	0	\N
191383	1397	1288174952000	25243	12471	25	0	\N
191384	1397	1288164951000	25243	12471	26	0	\N
191385	1397	1288154950000	25243	12471	27	0	\N
191386	1397	1288144949000	25243	12471	28	0	\N
191387	1397	1288134948000	25243	12471	29	0	\N
191388	1397	1288124947000	25243	12471	30	0	\N
191389	1397	1288114946000	25243	12471	31	0	\N
191390	1397	1288104945000	25243	12471	32	0	\N
191391	1397	1288094944000	25243	12471	33	0	\N
191392	1397	1288084943000	25243	12471	34	0	\N
191393	1397	1288074942000	25243	12471	35	0	\N
191394	1397	1288064941000	25243	12471	36	0	\N
191395	1397	1288054940000	25243	12471	37	0	\N
191396	1397	1288044939000	25243	12471	38	0	\N
191397	1397	1288034938000	25243	12471	39	0	\N
191398	1397	1288024937000	25243	12471	40	0	\N
191399	1397	1288014936000	25243	12471	41	0	\N
191400	1397	1288004935000	25243	12471	42	0	\N
191401	1397	1287994934000	25243	12471	43	0	\N
191402	2134	85134707000	25243	12471	44	0	\N
191403	1933	1819268000000	25243	12471	45	0	\N
191404	1769	1572700000	25243	12471	46	0	\N
191405	2132	147480493000	25243	12471	47	0	\N
191406	2133	91679000000	25243	12471	48	0	\N
191407	2133	91677998000	25243	12471	49	0	\N
191408	2133	91676996000	25243	12471	50	0	\N
191409	2133	91675994000	25243	12471	51	0	\N
191410	2133	91674992000	25243	12471	52	0	\N
191411	2132	147479492000	25243	12471	53	0	\N
191412	2132	147478491000	25243	12471	54	0	\N
191413	1759	23508329289889	25243	12471	55	0	\N
191414	1759	20590886789889	25243	12471	56	0	\N
191415	1759	16266956139889	25243	12471	57	0	\N
191416	1759	8137245139889	25243	12471	58	0	\N
191417	1764	24606459100000	25243	12471	59	0	\N
191418	1764	20948458100000	25243	12471	60	0	\N
191419	1749	15963587529980	25243	12471	61	0	\N
191420	2132	147477490000	25243	12471	62	0	\N
191421	2132	147476489000	25243	12471	63	0	\N
191422	2133	91673990000	25243	12471	64	0	\N
191423	2133	91672988000	25243	12471	65	0	\N
191424	2133	91671986000	25243	12471	66	0	\N
191425	2133	91670984000	25243	12471	67	0	\N
191426	2133	91669982000	25243	12471	68	0	\N
191427	2133	91668980000	25243	12471	69	0	\N
191428	2133	91667978000	25243	12471	70	0	\N
191429	2133	91666976000	25243	12471	71	0	\N
191430	2133	91665974000	25243	12471	72	0	\N
191431	2133	91664972000	25243	12471	73	0	\N
191432	2132	147475488000	25243	12471	74	0	\N
191433	2132	147474487000	25243	12471	75	0	\N
191434	2132	147473486000	25243	12471	76	0	\N
191435	2132	147472485000	25243	12471	77	0	\N
191436	2132	147471484000	25243	12471	78	0	\N
191437	2132	147470483000	25243	12471	79	0	\N
191438	2132	147469482000	25243	12471	80	0	\N
191439	2132	147468481000	25243	12471	81	0	\N
191440	1764	14070457100000	25243	12471	82	0	\N
191441	1764	11602456100000	25243	12471	83	0	\N
191442	2134	85133704000	25243	12471	84	0	\N
191443	2134	85132701000	25243	12471	85	0	\N
191444	2134	85131698000	25243	12471	86	0	\N
191445	2134	85130695000	25243	12471	87	0	\N
191446	2134	85129692000	25243	12471	88	0	\N
191447	2134	85128689000	25243	12471	89	0	\N
191448	2134	85127686000	25243	12471	90	0	\N
191449	2134	85126683000	25243	12471	91	0	\N
191450	2134	85125680000	25243	12471	92	0	\N
191451	2134	85124677000	25243	12471	93	0	\N
191452	2134	85123674000	25243	12471	94	0	\N
191453	2134	85122671000	25243	12471	95	0	\N
191454	1749	12934586529980	25243	12471	96	0	\N
191455	1749	8444585529980	25243	12471	97	0	\N
191456	2134	85121668000	25243	12471	98	0	\N
191457	2134	85120665000	25243	12471	99	0	\N
191458	2134	85119662000	25243	12471	100	0	\N
191459	2134	85118659000	25243	12471	101	0	\N
191460	2134	85117656000	25243	12471	102	0	\N
191461	2134	85116653000	25243	12471	103	0	\N
191462	2134	85115650000	25243	12471	104	0	\N
191463	2134	85114647000	25243	12471	106	0	\N
191464	2134	85113644000	25243	12471	107	0	\N
191465	2134	85112641000	25243	12471	108	0	\N
191466	2134	85111638000	25243	12471	109	0	\N
191467	2134	85110635000	25243	12471	110	0	\N
191468	2134	85109632000	25243	12471	111	0	\N
191469	2134	85108629000	25243	12471	112	0	\N
191470	2134	85107626000	25243	12471	113	0	\N
191471	2134	85106623000	25243	12471	114	0	\N
191472	2134	85105620000	25243	12471	115	0	\N
191473	2134	85104617000	25243	12471	116	0	\N
191474	2134	85103614000	25243	12471	117	0	\N
191475	2134	85102611000	25243	12471	118	0	\N
191476	2134	85101608000	25243	12471	119	0	\N
191477	2134	85100605000	25243	12471	120	0	\N
191478	2134	85099602000	25243	12471	121	0	\N
191479	2134	85098599000	25243	12471	122	0	\N
191480	2134	85097596000	25243	12471	123	0	\N
191481	2134	85096593000	25243	12471	124	0	\N
191482	2134	85095590000	25243	12471	125	0	\N
191355	1397	1288004935000	25242	12520	0	0	15082
191356	2134	85093584000	25242	12520	1	0	5480
191357	2133	91637918000	25242	12520	2	0	5043
191483	1397	1287994934000	25244	12521	0	0	15083
191484	1397	1287984933000	25244	12521	1	0	15084
191486	2134	85092581000	25244	12521	3	0	5481
191487	2134	85091578000	25244	12521	4	0	5482
191488	2133	91636916000	25244	12521	5	0	5044
191490	1397	1287994934000	25245	12521	0	0	\N
191491	1397	1287984933000	25245	12521	1	0	\N
191492	2132	147467480000	25245	12521	2	0	\N
191493	2134	85092581000	25245	12521	3	0	\N
191494	2134	85091578000	25245	12521	4	0	\N
191495	2133	91636916000	25245	12521	5	0	\N
191496	2133	91635914000	25245	12521	6	0	\N
191497	1397	1287994934000	25246	12521	0	0	\N
191498	1397	1287984933000	25246	12521	1	0	\N
191499	2132	147467480000	25246	12521	2	0	\N
191500	2134	85092581000	25246	12521	3	0	\N
191501	2134	85091578000	25246	12521	4	0	\N
191502	2133	91636916000	25246	12521	5	0	\N
191503	2133	91635914000	25246	12521	6	0	\N
191504	1397	1287994934000	25247	12521	0	0	\N
191505	1397	1287984933000	25247	12521	1	0	\N
191506	2132	147467480000	25247	12521	2	0	\N
191507	2134	85092581000	25247	12521	3	0	\N
191508	2134	85091578000	25247	12521	4	0	\N
191509	2133	91636916000	25247	12521	5	0	\N
191510	2133	91635914000	25247	12521	6	0	\N
191530	1397	1287914926000	25252	12526	0	0	\N
191531	1397	1287904925000	25252	12526	1	0	\N
191532	1397	1287894924000	25252	12526	2	0	\N
191533	2132	147465478000	25252	12526	3	0	\N
191534	2134	85084557000	25252	12526	4	0	\N
191535	2134	85083554000	25252	12526	5	0	\N
191536	2134	85082551000	25252	12526	6	0	\N
191537	2133	91628900000	25252	12526	7	0	\N
191538	2133	91627898000	25252	12526	8	0	\N
191539	2133	91626896000	25252	12526	9	0	\N
191554	1397	1287884923000	25255	12527	0	0	\N
191555	2132	147464477000	25255	12527	1	0	\N
191556	2133	91625894000	25255	12527	2	0	\N
191557	2134	85081548000	25255	12527	3	0	\N
191567	1397	1287844919000	25259	12531	0	0	\N
191568	2133	91621886000	25259	12531	1	0	\N
191569	2134	85077536000	25259	12531	2	0	\N
191570	2132	147463476000	25259	12531	3	0	\N
191571	1397	1287844919000	25260	12531	0	0	\N
191572	2133	91621886000	25260	12531	1	0	\N
191573	2134	85077536000	25260	12531	2	0	\N
191574	2132	147463476000	25260	12531	3	0	\N
191575	1397	1287844919000	25261	12531	0	0	\N
191576	2133	91621886000	25261	12531	1	0	\N
191577	2134	85077536000	25261	12531	2	0	\N
191578	2132	147463476000	25261	12531	3	0	\N
191579	1397	1287844919000	25262	12531	0	0	\N
191580	2133	91621886000	25262	12531	1	0	\N
191581	2134	85077536000	25262	12531	2	0	\N
191582	2132	147463476000	25262	12531	3	0	\N
191589	1397	1287824917000	25265	12533	0	0	\N
191590	1397	1287814916000	25265	12533	1	0	\N
191591	1397	1287804915000	25265	12533	2	0	\N
191592	1397	1287794914000	25265	12533	3	0	\N
191593	1397	1287784913000	25265	12533	4	0	\N
191594	2132	147462475000	25265	12533	5	0	\N
191595	2133	91620884000	25265	12533	6	0	\N
191596	2132	147461474000	25265	12533	7	0	\N
191597	2133	91619882000	25265	12533	8	0	\N
191598	2133	91618880000	25265	12533	9	0	\N
191599	2133	91617878000	25265	12533	10	0	\N
191600	2134	85075530000	25265	12533	11	0	\N
191601	2134	85074527000	25265	12533	12	0	\N
191602	2134	85073524000	25265	12533	13	0	\N
191603	2134	85072521000	25265	12533	14	0	\N
191604	2134	85071518000	25265	12533	15	0	\N
191605	2133	91616876000	25265	12533	16	0	\N
191512	2133	91634912000	25248	12522	1	0	5046
191513	2134	85090575000	25248	12522	2	0	5483
191514	1397	1287964931000	25249	12523	0	0	15086
191515	1397	1287954930000	25249	12523	1	0	15087
191516	2134	85089572000	25249	12523	2	0	5484
191518	2133	91632908000	25249	12523	4	0	5048
191519	2134	85088569000	25249	12523	5	0	5485
191520	1397	1287944929000	25250	12524	0	0	15088
191521	1397	1287934928000	25250	12524	1	0	15089
191522	2134	85087566000	25250	12524	2	0	5486
191524	2132	147466479000	25250	12524	4	0	1522
191525	2133	91631906000	25250	12524	5	0	5049
191526	2133	91630904000	25250	12524	6	0	5050
191527	1397	1287924927000	25251	12525	0	0	15090
191529	2134	85085560000	25251	12525	2	0	5488
191540	1397	1287914926000	25253	12526	0	0	15091
191541	1397	1287904925000	25253	12526	1	0	15092
191542	1397	1287894924000	25253	12526	2	0	15093
191543	2132	147465478000	25253	12526	3	0	1523
191545	2134	85083554000	25253	12526	5	0	5490
191546	2134	85082551000	25253	12526	6	0	5491
191547	2133	91628900000	25253	12526	7	0	5052
191548	2133	91627898000	25253	12526	8	0	5053
191549	2133	91626896000	25253	12526	9	0	5054
191551	2132	147464477000	25254	12527	1	0	1524
191552	2133	91625894000	25254	12527	2	0	5055
191553	2134	85081548000	25254	12527	3	0	5492
191558	1397	1287874922000	25256	12528	0	0	15095
191560	2133	91624892000	25256	12528	2	0	5056
191561	1397	1287864921000	25257	12529	0	0	15096
191562	2133	91623890000	25257	12529	1	0	5057
191563	2134	85079542000	25257	12529	2	0	5494
191564	1397	1287854920000	25258	12530	0	0	15097
191566	2134	85078539000	25258	12530	2	0	5495
191583	1397	1287844919000	25263	12531	0	0	15098
191584	2133	91621886000	25263	12531	1	0	5059
191585	2134	85077536000	25263	12531	2	0	5496
191586	2132	147463476000	25263	12531	3	0	1525
191588	2134	85076533000	25264	12532	1	0	5497
191606	1397	1287824917000	25266	12533	0	0	15100
191607	1397	1287814916000	25266	12533	1	0	15101
191608	1397	1287804915000	25266	12533	2	0	15102
191610	1397	1287784913000	25266	12533	4	0	15104
191611	2132	147462475000	25266	12533	5	0	1526
191612	2133	91620884000	25266	12533	6	0	5060
191613	2132	147461474000	25266	12533	7	0	1527
191614	2133	91619882000	25266	12533	8	0	5061
191616	2133	91617878000	25266	12533	10	0	5063
191617	2134	85075530000	25266	12533	11	0	5498
191618	2134	85074527000	25266	12533	12	0	5499
191619	2134	85073524000	25266	12533	13	0	5500
191620	2134	85072521000	25266	12533	14	0	5501
191622	2133	91616876000	25266	12533	16	0	5064
191623	1397	1287774912000	25267	12534	0	0	15105
191624	1397	1287764911000	25267	12534	1	0	15106
191629	1397	1287754910000	25268	12535	0	0	\N
191630	1397	1287744909000	25268	12535	1	0	\N
191631	2132	147460473000	25268	12535	2	0	\N
191632	2134	85068509000	25268	12535	3	0	\N
191633	2133	91613870000	25268	12535	4	0	\N
191634	2134	85067506000	25268	12535	5	0	\N
191635	2133	91612868000	25268	12535	6	0	\N
191643	1397	1287754910000	25270	12535	0	0	\N
191644	1397	1287744909000	25270	12535	1	0	\N
191645	2132	147460473000	25270	12535	2	0	\N
191646	2134	85068509000	25270	12535	3	0	\N
191647	2133	91613870000	25270	12535	4	0	\N
191648	2134	85067506000	25270	12535	5	0	\N
191649	2133	91612868000	25270	12535	6	0	\N
191650	1397	1288054940000	25271	12515	0	0	\N
191651	1397	1288044939000	25271	12515	1	0	\N
191652	1397	1288034938000	25271	12515	2	0	\N
191653	1397	1288024937000	25271	12515	3	0	\N
191654	1397	1288014936000	25271	12515	4	0	\N
191655	1397	1288004935000	25271	12515	5	0	\N
191656	1397	1287994934000	25271	12515	6	0	\N
191657	1397	1287984933000	25271	12515	7	0	\N
191658	1397	1287974932000	25271	12515	8	0	\N
191659	1397	1287964931000	25271	12515	9	0	\N
191660	1397	1287954930000	25271	12515	10	0	\N
191661	1397	1287944929000	25271	12515	11	0	\N
191662	1397	1287934928000	25271	12515	12	0	\N
191663	1397	1287924927000	25271	12515	14	0	\N
191664	1397	1287914926000	25271	12515	15	0	\N
191665	1397	1287904925000	25271	12515	16	0	\N
191666	1397	1287894924000	25271	12515	17	0	\N
191667	1397	1287884923000	25271	12515	18	0	\N
191668	1397	1287874922000	25271	12515	19	0	\N
191669	1397	1287864921000	25271	12515	20	0	\N
191670	1397	1287854920000	25271	12515	21	0	\N
191671	1397	1287844919000	25271	12515	22	0	\N
191672	1397	1287834918000	25271	12515	23	0	\N
191673	1397	1287824917000	25271	12515	24	0	\N
191674	1397	1287814916000	25271	12515	25	0	\N
191675	1397	1287804915000	25271	12515	26	0	\N
191676	1397	1287794914000	25271	12515	27	0	\N
191677	1397	1287784913000	25271	12515	28	0	\N
191678	1397	1287774912000	25271	12515	29	0	\N
191679	1397	1287764911000	25271	12515	30	0	\N
191680	1397	1287754910000	25271	12515	31	0	\N
191681	1397	1287744909000	25271	12515	32	0	\N
191682	1933	1819268000000	25271	12515	33	0	\N
191683	2134	85098599000	25271	12515	34	0	\N
191684	2132	147469482000	25271	12515	35	0	\N
191685	2132	147468481000	25271	12515	36	0	\N
191686	2133	91642928000	25271	12515	37	0	\N
191687	2133	91641926000	25271	12515	38	0	\N
191688	2133	91640924000	25271	12515	39	0	\N
191689	2133	91639922000	25271	12515	40	0	\N
191690	2133	91638920000	25271	12515	41	0	\N
191691	2133	91637918000	25271	12515	42	0	\N
191692	2134	85097596000	25271	12515	43	0	\N
191693	2134	85096593000	25271	12515	44	0	\N
191694	2134	85095590000	25271	12515	45	0	\N
191695	2134	85094587000	25271	12515	46	0	\N
191696	2134	85093584000	25271	12515	47	0	\N
191697	2132	147467480000	25271	12515	48	0	\N
191698	2132	147466479000	25271	12515	49	0	\N
191699	2132	147465478000	25271	12515	50	0	\N
191700	2132	147464477000	25271	12515	51	0	\N
191701	2132	147463476000	25271	12515	52	0	\N
191702	2132	147462475000	25271	12515	53	0	\N
191703	2132	147461474000	25271	12515	54	0	\N
191704	2132	147460473000	25271	12515	55	0	\N
191705	2134	85092581000	25271	12515	56	0	\N
191706	2134	85091578000	25271	12515	57	0	\N
191707	2134	85090575000	25271	12515	58	0	\N
191708	2134	85089572000	25271	12515	59	0	\N
191709	2134	85088569000	25271	12515	60	0	\N
191710	2134	85087566000	25271	12515	61	0	\N
191711	2134	85086563000	25271	12515	62	0	\N
191712	1749	15963587529980	25271	12515	63	0	\N
191713	2134	85085560000	25271	12515	64	0	\N
191714	2134	85084557000	25271	12515	65	0	\N
191715	2134	85083554000	25271	12515	66	0	\N
191716	2134	85082551000	25271	12515	67	0	\N
191717	1749	12934586529980	25271	12515	68	0	\N
191718	1749	8444585529980	25271	12515	69	0	\N
191719	2134	85081548000	25271	12515	70	0	\N
191720	2134	85080545000	25271	12515	71	0	\N
191721	2134	85079542000	25271	12515	72	0	\N
191722	2134	85078539000	25271	12515	73	0	\N
191723	2134	85077536000	25271	12515	74	0	\N
191724	2134	85076533000	25271	12515	75	0	\N
191725	2134	85075530000	25271	12515	76	0	\N
191726	2134	85074527000	25271	12515	77	0	\N
191727	2134	85073524000	25271	12515	78	0	\N
191728	2134	85072521000	25271	12515	79	0	\N
191729	2134	85071518000	25271	12515	80	0	\N
191730	2134	85070515000	25271	12515	81	0	\N
191731	2134	85069512000	25271	12515	82	0	\N
191732	2134	85068509000	25271	12515	83	0	\N
191733	2134	85067506000	25271	12515	84	0	\N
191734	2133	91636916000	25271	12515	85	0	\N
191735	2133	91635914000	25271	12515	86	0	\N
191736	2133	91634912000	25271	12515	87	0	\N
191737	2133	91633910000	25271	12515	88	0	\N
191738	2133	91632908000	25271	12515	89	0	\N
191739	2133	91631906000	25271	12515	90	0	\N
191740	2133	91630904000	25271	12515	91	0	\N
191741	2133	91629902000	25271	12515	92	0	\N
191742	2133	91628900000	25271	12515	93	0	\N
191743	2133	91627898000	25271	12515	94	0	\N
191744	2133	91626896000	25271	12515	95	0	\N
191745	2133	91625894000	25271	12515	96	0	\N
191746	2133	91624892000	25271	12515	97	0	\N
191747	2133	91623890000	25271	12515	98	0	\N
191748	2133	91622888000	25271	12515	99	0	\N
191749	2133	91621886000	25271	12515	100	0	\N
191750	2133	91620884000	25271	12515	101	0	\N
191751	2133	91619882000	25271	12515	102	0	\N
191752	2133	91618880000	25271	12515	103	0	\N
191753	2133	91617878000	25271	12515	104	0	\N
191754	2133	91616876000	25271	12515	105	0	\N
191755	2133	91615874000	25271	12515	106	0	\N
191756	2133	91614872000	25271	12515	107	0	\N
191757	2133	91613870000	25271	12515	108	0	\N
191758	2133	91612868000	25271	12515	109	0	\N
191627	2134	85069512000	25267	12534	4	0	5504
191628	2133	91614872000	25267	12534	5	0	5066
191636	1397	1287754910000	25269	12535	0	0	15107
191637	1397	1287744909000	25269	12535	1	0	15108
191638	2132	147460473000	25269	12535	2	0	1528
191640	2133	91613870000	25269	12535	4	0	5067
191641	2134	85067506000	25269	12535	5	0	5506
191642	2133	91612868000	25269	12535	6	0	5068
191759	1397	1287734908000	25272	12536	0	0	15109
191760	2134	85066503000	25272	12536	1	0	5507
191769	1397	1287704905000	25275	12539	0	0	\N
191770	1397	1287694904000	25275	12539	1	0	\N
191771	2134	85063494000	25275	12539	2	0	\N
191772	2134	85062491000	25275	12539	3	0	\N
191773	1397	1287704905000	25276	12539	0	0	\N
191774	1397	1287694904000	25276	12539	1	0	\N
191775	2134	85063494000	25276	12539	2	0	\N
191776	2134	85062491000	25276	12539	3	0	\N
191777	2133	91608860000	25276	12539	4	0	\N
191778	2133	91607858000	25276	12539	5	0	\N
191779	1397	1287704905000	25277	12539	0	0	\N
191780	1397	1287694904000	25277	12539	1	0	\N
191781	2134	85063494000	25277	12539	2	0	\N
191782	2134	85062491000	25277	12539	3	0	\N
191783	2133	91608860000	25277	12539	4	0	\N
191784	2133	91607858000	25277	12539	5	0	\N
191791	1397	1287704905000	25279	12539	0	0	\N
191792	1397	1287694904000	25279	12539	1	0	\N
191793	2134	85063494000	25279	12539	2	0	\N
191794	2134	85062491000	25279	12539	3	0	\N
191795	2133	91608860000	25279	12539	4	0	\N
191796	2133	91607858000	25279	12539	5	0	\N
191801	1397	1287684903000	25281	12540	0	0	\N
191802	2133	91606856000	25281	12540	1	0	\N
191803	2134	85061488000	25281	12540	2	0	\N
191804	2132	147458471000	25281	12540	3	0	\N
191808	1397	1287664901000	25283	12542	0	0	\N
191809	1397	1287654900000	25283	12542	1	0	\N
191810	2134	85059482000	25283	12542	2	0	\N
191811	2133	91604852000	25283	12542	3	0	\N
191812	2133	91603850000	25283	12542	4	0	\N
191813	2134	85058479000	25283	12542	5	0	\N
191814	1397	1287664901000	25284	12542	0	0	\N
191815	1397	1287654900000	25284	12542	1	0	\N
191816	2134	85059482000	25284	12542	2	0	\N
191817	2133	91604852000	25284	12542	3	0	\N
191818	2133	91603850000	25284	12542	4	0	\N
191819	2134	85058479000	25284	12542	5	0	\N
191833	1397	1287634898000	25288	12544	0	0	\N
191834	2133	91601846000	25288	12544	1	0	\N
191835	2134	85056473000	25288	12544	2	0	\N
191838	2133	91600844000	25290	12545	0	0	\N
191839	2134	85055470000	25290	12545	1	0	\N
191840	1397	1287984933000	25291	12472	0	0	\N
191841	1397	1287974932000	25291	12472	1	0	\N
191842	1397	1287964931000	25291	12472	2	0	\N
191843	1397	1287954930000	25291	12472	3	0	\N
191844	1397	1287944929000	25291	12472	4	0	\N
191845	1397	1287934928000	25291	12472	5	0	\N
191846	1397	1287924927000	25291	12472	6	0	\N
191847	1397	1287914926000	25291	12472	7	0	\N
191848	1397	1287904925000	25291	12472	8	0	\N
191849	1397	1287894924000	25291	12472	9	0	\N
191850	1397	1287884923000	25291	12472	10	0	\N
191851	1397	1287874922000	25291	12472	11	0	\N
191852	1397	1287864921000	25291	12472	12	0	\N
191853	1397	1287854920000	25291	12472	13	0	\N
191854	1397	1287844919000	25291	12472	14	0	\N
191855	1397	1287834918000	25291	12472	15	0	\N
191856	1397	1287824917000	25291	12472	16	0	\N
191857	1397	1287814916000	25291	12472	17	0	\N
191858	1397	1287804915000	25291	12472	18	0	\N
191859	1397	1287794914000	25291	12472	19	0	\N
191860	1397	1287784913000	25291	12472	20	0	\N
191861	1397	1287774912000	25291	12472	21	0	\N
191862	1397	1287764911000	25291	12472	22	0	\N
191863	1397	1287754910000	25291	12472	23	0	\N
191864	1397	1287744909000	25291	12472	24	0	\N
191865	1397	1287734908000	25291	12472	25	0	\N
191866	1397	1287724907000	25291	12472	26	0	\N
191867	1397	1287714906000	25291	12472	27	0	\N
191868	1397	1287704905000	25291	12472	28	0	\N
191869	1397	1287694904000	25291	12472	29	0	\N
191870	1397	1287684903000	25291	12472	30	0	\N
191871	1397	1287674902000	25291	12472	31	0	\N
191872	1397	1287664901000	25291	12472	32	0	\N
191873	1397	1287654900000	25291	12472	33	0	\N
191874	1397	1287644899000	25291	12472	34	0	\N
191875	1397	1287634898000	25291	12472	35	0	\N
191876	2134	85094587000	25291	12472	36	0	\N
191877	2134	85093584000	25291	12472	37	0	\N
191878	2132	147467480000	25291	12472	38	0	\N
191879	2132	147466479000	25291	12472	39	0	\N
191880	2132	147465478000	25291	12472	40	0	\N
191881	2132	147464477000	25291	12472	41	0	\N
191882	2132	147463476000	25291	12472	42	0	\N
191883	2132	147462475000	25291	12472	43	0	\N
191884	2132	147461474000	25291	12472	44	0	\N
191885	2132	147460473000	25291	12472	45	0	\N
191886	2132	147459472000	25291	12472	46	0	\N
191887	2134	85092581000	25291	12472	47	0	\N
191888	2134	85091578000	25291	12472	48	0	\N
191889	2132	147458471000	25291	12472	49	0	\N
191890	2132	147457470000	25291	12472	50	0	\N
191891	2134	85090575000	25291	12472	51	0	\N
191892	2134	85089572000	25291	12472	52	0	\N
191893	2134	85088569000	25291	12472	53	0	\N
191894	2134	85087566000	25291	12472	54	0	\N
191895	2134	85086563000	25291	12472	55	0	\N
191896	2134	85085560000	25291	12472	56	0	\N
191763	2134	85065500000	25273	12537	1	0	5508
191764	2133	91610864000	25273	12537	2	0	5070
191765	1397	1287714906000	25274	12538	0	0	15111
191766	2133	91609862000	25274	12538	1	0	5071
191767	2134	85064497000	25274	12538	2	0	5509
191785	1397	1287704905000	25278	12539	0	0	15112
191786	1397	1287694904000	25278	12539	1	0	15113
191787	2134	85063494000	25278	12539	2	0	5510
191788	2134	85062491000	25278	12539	3	0	5511
191789	2133	91608860000	25278	12539	4	0	5072
191797	1397	1287684903000	25280	12540	0	0	15114
191798	2133	91606856000	25280	12540	1	0	5074
191799	2134	85061488000	25280	12540	2	0	5512
191800	2132	147458471000	25280	12540	3	0	1530
191806	2133	91605854000	25282	12541	1	0	5075
191807	2134	85060485000	25282	12541	2	0	5513
191820	1397	1287664901000	25285	12542	0	0	15116
191821	1397	1287654900000	25285	12542	1	0	15117
191822	2134	85059482000	25285	12542	2	0	5514
191824	2133	91603850000	25285	12542	4	0	5077
191825	2134	85058479000	25285	12542	5	0	5515
191826	1397	1287644899000	25286	12543	0	0	15118
191827	2132	147457470000	25286	12543	1	0	1531
191828	2133	91602848000	25286	12543	2	0	5078
191830	1397	1287634898000	25287	12544	0	0	15119
191831	2133	91601846000	25287	12544	1	0	5079
191832	2134	85056473000	25287	12544	2	0	5517
191836	2133	91600844000	25289	12545	0	0	5080
191897	2134	85084557000	25291	12472	57	0	\N
191898	2134	85083554000	25291	12472	58	0	\N
191899	2134	85082551000	25291	12472	59	0	\N
191900	2134	85081548000	25291	12472	60	0	\N
191901	2134	85080545000	25291	12472	61	0	\N
191902	2134	85079542000	25291	12472	62	0	\N
191903	2134	85078539000	25291	12472	63	0	\N
191904	2134	85077536000	25291	12472	64	0	\N
191905	2134	85076533000	25291	12472	65	0	\N
191906	2134	85075530000	25291	12472	66	0	\N
191907	2134	85074527000	25291	12472	67	0	\N
191908	2134	85073524000	25291	12472	68	0	\N
191909	2134	85072521000	25291	12472	69	0	\N
191910	2134	85071518000	25291	12472	70	0	\N
191911	2134	85070515000	25291	12472	71	0	\N
191912	2134	85069512000	25291	12472	72	0	\N
191913	2134	85068509000	25291	12472	73	0	\N
191914	2134	85067506000	25291	12472	74	0	\N
191915	2134	85066503000	25291	12472	75	0	\N
191916	2134	85065500000	25291	12472	76	0	\N
191917	2134	85064497000	25291	12472	77	0	\N
191918	2134	85063494000	25291	12472	78	0	\N
191919	2134	85062491000	25291	12472	79	0	\N
191920	2134	85061488000	25291	12472	80	0	\N
191921	2134	85060485000	25291	12472	81	0	\N
191922	2134	85059482000	25291	12472	82	0	\N
191923	2134	85058479000	25291	12472	83	0	\N
191924	2134	85057476000	25291	12472	84	0	\N
191925	2134	85056473000	25291	12472	85	0	\N
191926	2134	85055470000	25291	12472	86	0	\N
191927	2133	91663970000	25291	12472	87	0	\N
191928	2133	91662968000	25291	12472	88	0	\N
191929	2133	91661966000	25291	12472	89	0	\N
191930	2133	91660964000	25291	12472	90	0	\N
191931	2133	91659962000	25291	12472	91	0	\N
191932	2133	91658960000	25291	12472	92	0	\N
191933	2133	91657958000	25291	12472	93	0	\N
191934	2133	91656956000	25291	12472	94	0	\N
191935	2133	91655954000	25291	12472	95	0	\N
191936	2133	91654952000	25291	12472	96	0	\N
191937	2133	91653950000	25291	12472	97	0	\N
191938	2133	91652948000	25291	12472	98	0	\N
191939	2133	91651946000	25291	12472	99	0	\N
191940	2133	91650944000	25291	12472	100	0	\N
191941	2133	91649942000	25291	12472	101	0	\N
191942	2133	91648940000	25291	12472	102	0	\N
191943	2133	91647938000	25291	12472	103	0	\N
191944	2133	91646936000	25291	12472	104	0	\N
191945	2133	91645934000	25291	12472	106	0	\N
191946	2133	91644932000	25291	12472	107	0	\N
191947	2133	91643930000	25291	12472	108	0	\N
191948	2133	91642928000	25291	12472	109	0	\N
191949	2133	91641926000	25291	12472	110	0	\N
191950	2133	91640924000	25291	12472	111	0	\N
191951	2133	91639922000	25291	12472	112	0	\N
191952	2133	91638920000	25291	12472	113	0	\N
191953	2133	91637918000	25291	12472	114	0	\N
191954	2133	91636916000	25291	12472	115	0	\N
191955	2133	91635914000	25291	12472	116	0	\N
191956	2133	91634912000	25291	12472	117	0	\N
191957	2133	91633910000	25291	12472	118	0	\N
191958	2133	91632908000	25291	12472	119	0	\N
191959	2133	91631906000	25291	12472	120	0	\N
191960	2133	91630904000	25291	12472	121	0	\N
191961	2133	91629902000	25291	12472	122	0	\N
191962	2133	91628900000	25291	12472	123	0	\N
191963	2133	91627898000	25291	12472	124	0	\N
191964	2133	91626896000	25291	12472	125	0	\N
191979	2186	7693786	25296	12473	0	0	\N
191980	1933	1819268000000	25296	12473	1	0	\N
191981	2288	775756211465	25296	12473	2	0	\N
191982	2288	774754211465	25296	12473	3	0	\N
191983	2288	0	25296	12473	4	0	\N
191984	1769	1572700000	25296	12473	5	0	\N
191985	1759	23508329289889	25296	12473	6	0	\N
191986	1759	20590886789889	25296	12473	7	0	\N
191987	1759	16266956139889	25296	12473	8	0	\N
191988	1759	8137245139889	25296	12473	9	0	\N
191989	2026	75199000000	25296	12473	10	0	\N
191990	1764	24606459100000	25296	12473	11	0	\N
191991	1764	20948458100000	25296	12473	12	0	\N
191992	1749	15963587529980	25296	12473	13	0	\N
191993	1764	14070457100000	25296	12473	14	0	\N
191994	1764	11602456100000	25296	12473	15	0	\N
191995	2119	190000000	25296	12473	16	0	\N
191996	1749	12934586529980	25296	12473	17	0	\N
191997	1397	1287584893000	25297	12550	0	0	\N
191998	2134	85050455000	25297	12550	1	0	\N
192002	1397	1287584893000	25299	12550	0	0	\N
192003	2134	85050455000	25299	12550	1	0	\N
192004	2133	91595834000	25299	12550	2	0	\N
192008	1397	1287564891000	25301	12552	0	0	\N
192009	2134	85048449000	25301	12552	1	0	\N
192010	2133	91593830000	25301	12552	2	0	\N
192029	1397	1287524887000	25310	12557	0	0	\N
192030	1397	1287514886000	25310	12557	1	0	\N
192031	2134	85043434000	25310	12557	2	0	\N
192032	2133	91589822000	25310	12557	4	0	\N
191967	2134	85054467000	25292	12546	2	0	5519
191968	2132	147456469000	25292	12546	3	0	1532
191969	1397	1287614896000	25293	12547	0	0	15121
191970	2134	85053464000	25293	12547	1	0	5520
191971	2133	91598840000	25293	12547	2	0	5082
191973	2133	91597838000	25294	12548	1	0	5083
191974	2134	85052461000	25294	12548	2	0	5521
191975	1397	1287594894000	25295	12549	0	0	15123
191976	2133	91596836000	25295	12549	1	0	5084
191977	2132	147455468000	25295	12549	2	0	1533
191999	1397	1287584893000	25298	12550	0	0	15124
192000	2134	85050455000	25298	12550	1	0	5523
192001	2133	91595834000	25298	12550	2	0	5085
192005	1397	1287574892000	25300	12551	0	0	15125
192007	2133	91594832000	25300	12551	2	0	5086
192011	1397	1287564891000	25302	12552	0	0	15126
192012	2134	85048449000	25302	12552	1	0	5525
192013	2133	91593830000	25302	12552	2	0	5087
192014	1397	1287554890000	25303	12553	0	0	15127
192016	2132	147454467000	25303	12553	2	0	1534
192017	2134	85047446000	25303	12553	3	0	5526
192018	1397	1287544889000	25304	12554	0	0	15128
192019	2134	85046443000	25304	12554	1	0	5527
192020	2133	91591826000	25304	12554	2	0	5089
192022	2133	91590824000	25305	12555	1	0	5090
192023	2134	85045440000	25305	12555	2	0	5528
192024	2132	147453466000	25306	12556	0	0	1535
192025	2134	85044437000	25306	12556	1	0	5529
192027	1397	1287514886000	25308	12557	1	0	15131
192028	2134	85043434000	25308	12557	2	0	5530
192033	2133	91588820000	25310	12557	5	0	\N
192034	1397	1287504885000	25313	12558	0	0	\N
192035	2134	85042431000	25313	12558	1	0	\N
192036	2133	91589822000	25313	12558	2	0	\N
192037	2133	91588820000	25313	12558	3	0	\N
192038	2133	91587818000	25313	12558	4	0	\N
192039	1397	1287504885000	25314	12558	0	0	\N
192040	2134	85042431000	25314	12558	1	0	\N
192041	2133	91589822000	25314	12558	2	0	\N
192042	2133	91588820000	25314	12558	3	0	\N
192043	2133	91587818000	25314	12558	4	0	\N
192049	1397	1287504885000	25316	12558	0	0	\N
192050	2134	85042431000	25316	12558	1	0	\N
192051	2133	91589822000	25316	12558	2	0	\N
192052	2133	91588820000	25316	12558	3	0	\N
192053	2133	91587818000	25316	12558	4	0	\N
192054	1397	1287504885000	25317	12558	0	0	\N
192055	2134	85042431000	25317	12558	1	0	\N
192056	2133	91589822000	25317	12558	2	0	\N
192057	2133	91588820000	25317	12558	3	0	\N
192058	2133	91587818000	25317	12558	4	0	\N
192059	1397	1287504885000	25318	12558	0	0	\N
192060	2134	85042431000	25318	12558	1	0	\N
192061	2133	91589822000	25318	12558	2	0	\N
192062	2133	91588820000	25318	12558	3	0	\N
192063	2133	91587818000	25318	12558	4	0	\N
192068	1397	1287494884000	25320	12559	0	0	\N
192069	2134	85041428000	25320	12559	1	0	\N
192070	2133	91586816000	25320	12559	2	0	\N
192071	2132	147452465000	25320	12559	3	0	\N
192072	1397	1287494884000	25321	12559	0	0	\N
192073	2133	91586816000	25321	12559	1	0	\N
192074	1397	1287494884000	25322	12559	0	0	\N
192075	2133	91586816000	25322	12559	1	0	\N
192095	1397	1287454880000	25325	12561	0	0	\N
192096	1397	1287444879000	25325	12561	1	0	\N
192097	1397	1287434878000	25325	12561	2	0	\N
192098	2134	85037416000	25325	12561	3	0	\N
192099	2134	85036413000	25325	12561	4	0	\N
192100	2134	85035410000	25325	12561	5	0	\N
192101	2133	91582808000	25325	12561	6	0	\N
192102	2133	91581806000	25325	12561	7	0	\N
192103	2133	91580804000	25325	12561	8	0	\N
192104	2132	147451464000	25325	12561	9	0	\N
192108	222	66713079919853	25327	12563	0	0	\N
192109	1397	1287414876000	25327	12563	1	0	\N
192110	2134	85034407000	25327	12563	2	0	\N
192111	2133	91578800000	25327	12563	3	0	\N
192112	222	66713079919853	25328	12563	0	0	\N
192113	1397	1287414876000	25328	12563	1	0	\N
192114	2134	85034407000	25328	12563	2	0	\N
192115	2133	91578800000	25328	12563	3	0	\N
192120	1397	1287404875000	25330	12564	0	0	\N
192121	2134	85033404000	25330	12564	1	0	\N
192122	2133	91577798000	25330	12564	2	0	\N
192126	1397	1287404875000	25332	12564	0	0	\N
192127	2134	85033404000	25332	12564	1	0	\N
192128	2133	91577798000	25332	12564	2	0	\N
192129	222	66702479919853	25333	12565	0	0	\N
192130	2134	85032401000	25333	12565	1	0	\N
192131	2132	147449462000	25333	12565	2	0	\N
192132	2134	85031398000	25333	12565	3	0	\N
192133	222	66702479919853	25334	12565	0	0	\N
192134	1397	1287394874000	25334	12565	1	0	\N
192135	1397	1287384873000	25334	12565	2	0	\N
192136	2134	85032401000	25334	12565	3	0	\N
192137	2132	147449462000	25334	12565	4	0	\N
192138	2134	85031398000	25334	12565	5	0	\N
192139	222	66702479919853	25335	12565	0	0	\N
192140	1397	1287394874000	25335	12565	1	0	\N
192141	1397	1287384873000	25335	12565	2	0	\N
192142	2134	85032401000	25335	12565	3	0	\N
192143	2132	147449462000	25335	12565	4	0	\N
192144	2133	91576796000	25335	12565	5	0	\N
192145	2133	91575794000	25335	12565	6	0	\N
192146	2134	85031398000	25335	12565	7	0	\N
192155	1397	1287374872000	25337	12566	0	0	\N
192156	2134	85030395000	25337	12566	1	0	\N
192157	2133	91574792000	25337	12566	2	0	\N
192158	1397	1287374872000	25338	12566	0	0	\N
192159	2134	85030395000	25338	12566	1	0	\N
192160	2133	91574792000	25338	12566	2	0	\N
192164	1397	1287374872000	25340	12566	0	0	\N
192165	2134	85030395000	25340	12566	1	0	\N
192166	2133	91574792000	25340	12566	2	0	\N
192167	1397	1287374872000	25341	12566	0	0	\N
192168	2134	85030395000	25341	12566	1	0	\N
192046	2133	91589822000	25315	12558	2	0	5091
192047	2133	91588820000	25315	12558	3	0	5092
192048	2133	91587818000	25315	12558	4	0	5093
192064	1397	1287494884000	25319	12559	0	0	15133
192065	2134	85041428000	25319	12559	1	0	5532
192067	2132	147452465000	25319	12559	3	0	1536
192076	1397	1287484883000	25323	12560	0	0	15134
192077	1397	1287474882000	25323	12560	1	0	15135
192078	1397	1287464881000	25323	12560	2	0	15136
192079	2133	91585814000	25323	12560	3	0	5095
192081	2133	91583810000	25323	12560	5	0	5097
192082	2134	85040425000	25323	12560	6	0	5533
192083	2134	85039422000	25323	12560	7	0	5534
192084	2134	85038419000	25323	12560	8	0	5535
192086	1397	1287444879000	25324	12561	1	0	15138
192087	1397	1287434878000	25324	12561	2	0	15139
192088	2134	85037416000	25324	12561	3	0	5536
192089	2134	85036413000	25324	12561	4	0	5537
192090	2134	85035410000	25324	12561	5	0	5538
192092	2133	91581806000	25324	12561	7	0	5099
192093	2133	91580804000	25324	12561	8	0	5100
192094	2132	147451464000	25324	12561	9	0	1537
192105	1397	1287424877000	25326	12562	0	0	15140
192106	2133	91579802000	25326	12562	1	0	5101
192116	222	66713079919853	25329	12563	0	0	1
192117	1397	1287414876000	25329	12563	1	0	15141
192118	2134	85034407000	25329	12563	2	0	5539
192119	2133	91578800000	25329	12563	3	0	5102
192124	2134	85033404000	25331	12564	1	0	5540
192125	2133	91577798000	25331	12564	2	0	5103
192147	222	66702479919853	25336	12565	0	0	2
192148	1397	1287394874000	25336	12565	1	0	15143
192149	1397	1287384873000	25336	12565	2	0	15144
192151	2132	147449462000	25336	12565	4	0	1539
192152	2133	91576796000	25336	12565	5	0	5104
192153	2133	91575794000	25336	12565	6	0	5105
192154	2134	85031398000	25336	12565	7	0	5542
192161	1397	1287374872000	25339	12566	0	0	15145
192163	2133	91574792000	25339	12566	2	0	5106
192169	1397	1287374872000	25342	12566	0	0	\N
192170	2134	85030395000	25342	12566	1	0	\N
192171	2133	91574792000	25342	12566	2	0	\N
192172	1397	1287374872000	25343	12566	0	0	\N
192173	2134	85030395000	25343	12566	1	0	\N
192174	2133	91576796000	25343	12566	2	0	\N
192175	2133	91575794000	25343	12566	3	0	\N
192176	2133	91574792000	25343	12566	4	0	\N
192186	1397	1287344869000	25346	12568	0	0	\N
192187	2134	85027386000	25346	12568	1	0	\N
192188	2133	91571786000	25346	12568	2	0	\N
192189	222	66661279919853	25347	12569	0	0	\N
192190	1397	1287344869000	25347	12569	1	0	\N
192191	1397	1287334868000	25347	12569	2	0	\N
192192	2133	91571786000	25347	12569	3	0	\N
192193	2133	91570784000	25347	12569	4	0	\N
192194	2134	85026383000	25347	12569	5	0	\N
192201	1397	1287324867000	25349	12570	0	0	\N
192202	2133	91569782000	25349	12570	1	0	\N
192203	2132	147447460000	25349	12570	2	0	\N
192204	2134	85025380000	25349	12570	3	0	\N
192205	1397	1287324867000	25350	12570	0	0	\N
192206	2133	91569782000	25350	12570	1	0	\N
192207	2132	147447460000	25350	12570	2	0	\N
192208	2134	85025380000	25350	12570	3	0	\N
192209	222	66702479919853	25351	12565	0	0	\N
192211	1397	1287324867000	25353	12570	0	0	\N
192212	2133	91569782000	25353	12570	1	0	\N
192213	2132	147447460000	25353	12570	2	0	\N
192214	2134	85025380000	25353	12570	3	0	\N
192222	1397	1287304865000	25355	12572	0	0	\N
192223	2133	91567778000	25355	12572	1	0	\N
192224	2134	85023374000	25355	12572	2	0	\N
192225	1397	1287304865000	25356	12572	0	0	\N
192226	2134	85023374000	25356	12572	1	0	\N
192227	1397	1287304865000	25357	12572	0	0	\N
192228	2133	91567778000	25357	12572	1	0	\N
192229	2134	85023374000	25357	12572	2	0	\N
192247	1397	1287254860000	25361	12575	0	0	\N
192248	2132	147445458000	25361	12575	1	0	\N
192249	2134	85018359000	25361	12575	2	0	\N
192250	2133	91562768000	25361	12575	4	0	\N
192261	1397	1287244859000	25364	12576	0	0	\N
192262	1397	1287234858000	25364	12576	1	0	\N
192263	2133	91561766000	25364	12576	2	0	\N
192264	2133	91560764000	25364	12576	3	0	\N
192265	2134	85017356000	25364	12576	4	0	\N
192266	2134	85016353000	25364	12576	5	0	\N
192267	2132	147444457000	25365	12577	0	0	\N
192268	2134	85015350000	25365	12577	1	0	\N
192269	1397	1287224857000	25366	12577	0	0	\N
192270	2132	147444457000	25366	12577	1	0	\N
192271	2133	91559762000	25366	12577	2	0	\N
192272	2134	85015350000	25366	12577	3	0	\N
192273	1397	1287224857000	25367	12577	0	0	\N
192274	2132	147444457000	25367	12577	1	0	\N
192275	2133	91559762000	25367	12577	2	0	\N
192276	2134	85015350000	25367	12577	3	0	\N
192285	1397	1287204855000	25370	12579	0	0	\N
192286	2133	91557758000	25370	12579	1	0	\N
192287	2134	85013344000	25370	12579	2	0	\N
192294	1397	1287194854000	25373	12580	0	0	\N
192295	2133	91556756000	25373	12580	1	0	\N
192296	2134	85012341000	25373	12580	2	0	\N
192302	222	66713079919853	25375	12473	0	0	\N
192303	222	66702479919853	25375	12473	1	0	\N
192304	222	66681879919853	25375	12473	2	0	\N
192179	1397	1287354870000	25344	12567	2	0	15147
192180	2132	147448461000	25344	12567	3	0	1540
192181	2134	85029392000	25344	12567	4	0	5544
192182	2134	85028389000	25344	12567	5	0	5545
192183	2133	91573790000	25344	12567	6	0	5107
192185	2134	85027386000	25345	12568	0	0	5546
192195	222	66661279919853	25348	12569	0	0	4
192196	1397	1287344869000	25348	12569	1	0	15148
192197	1397	1287334868000	25348	12569	2	0	15149
192198	2133	91571786000	25348	12569	3	0	5109
192200	2134	85026383000	25348	12569	5	0	5547
192210	2132	147447460000	25352	12570	0	0	1541
192215	222	66540679919853	25354	12571	0	0	5
192216	1397	1287324867000	25354	12571	1	0	15150
192218	2133	91569782000	25354	12571	3	0	5111
192219	2133	91568780000	25354	12571	4	0	5112
192220	2134	85025380000	25354	12571	5	0	5548
192221	2134	85024377000	25354	12571	6	0	5549
192230	1397	1287304865000	25358	12572	0	0	15152
192232	2134	85023374000	25358	12572	2	0	5550
192233	222	66420079919853	25359	12573	0	0	6
192234	1397	1287294864000	25359	12573	1	0	15153
192235	2134	85022371000	25359	12573	2	0	5551
192236	2133	91566776000	25359	12573	3	0	5114
192238	1397	1287274862000	25360	12574	1	0	15155
192239	1397	1287264861000	25360	12574	2	0	15156
192240	2133	91565774000	25360	12574	3	0	5115
192241	2132	147446459000	25360	12574	4	0	1542
192243	2134	85020365000	25360	12574	6	0	5553
192244	2134	85019362000	25360	12574	7	0	5554
192245	2133	91564772000	25360	12574	8	0	5116
192246	2133	91563770000	25360	12574	9	0	5117
192251	1397	1287254860000	25362	12575	0	0	15157
192253	2134	85018359000	25362	12575	2	0	5555
192254	2133	91562768000	25362	12575	4	0	5118
192255	1397	1287244859000	25363	12576	0	0	15158
192256	1397	1287234858000	25363	12576	1	0	15159
192257	2133	91561766000	25363	12576	2	0	5119
192259	2134	85017356000	25363	12576	4	0	5556
192260	2134	85016353000	25363	12576	5	0	5557
192277	1397	1287224857000	25368	12577	0	0	15160
192278	2132	147444457000	25368	12577	1	0	1544
192280	2134	85015350000	25368	12577	3	0	5558
192281	222	66299479919853	25369	12578	0	0	7
192282	1397	1287214856000	25369	12578	1	0	15161
192283	2134	85014347000	25369	12578	2	0	5559
192284	2133	91558760000	25369	12578	3	0	5122
192289	2133	91557758000	25371	12579	1	0	5123
192290	2134	85013344000	25371	12579	2	0	5560
192291	1397	1287194854000	25372	12580	0	0	15163
192292	2133	91556756000	25372	12580	1	0	5124
192293	2134	85012341000	25372	12580	2	0	5561
192298	1397	1287184853000	25374	12581	1	0	15164
192299	2133	91555754000	25374	12581	2	0	5125
192300	2134	85011338000	25374	12581	3	0	5562
192301	2132	147443456000	25374	12581	4	0	1545
192305	222	66661279919853	25375	12473	3	0	\N
192306	222	66540679919853	25375	12473	4	0	\N
192307	222	66420079919853	25375	12473	5	0	\N
192308	222	66299479919853	25375	12473	6	0	\N
192309	222	66178879919853	25375	12473	7	0	\N
192310	1397	1287624897000	25375	12473	8	0	\N
192311	1397	1287614896000	25375	12473	9	0	\N
192312	1397	1287604895000	25375	12473	10	0	\N
192313	1397	1287594894000	25375	12473	11	0	\N
192314	1397	1287584893000	25375	12473	12	0	\N
192318	1397	1287174852000	25377	12582	0	0	\N
192319	2134	85010335000	25377	12582	1	0	\N
192320	1397	1287174852000	25378	12582	0	0	\N
192321	2133	91554752000	25378	12582	1	0	\N
192322	2134	85010335000	25378	12582	2	0	\N
192323	1397	1287174852000	25379	12582	0	0	\N
192324	2133	91554752000	25379	12582	1	0	\N
192325	2134	85010335000	25379	12582	2	0	\N
192326	1397	1287174852000	25380	12582	0	0	\N
192327	2133	91554752000	25380	12582	1	0	\N
192328	2134	85010335000	25380	12582	2	0	\N
192329	1397	1287164851000	25381	12583	0	0	\N
192330	2133	91553750000	25381	12583	1	0	\N
192331	2134	85009332000	25381	12583	2	0	\N
192335	1397	1287164851000	25383	12583	0	0	\N
192336	2133	91553750000	25383	12583	1	0	\N
192337	2134	85009332000	25383	12583	2	0	\N
192342	1397	1287144849000	25386	12585	0	0	\N
192343	2134	85007326000	25386	12585	1	0	\N
192344	2133	91551746000	25386	12585	2	0	\N
192345	1397	1287144849000	25387	12585	0	0	\N
192346	2134	85007326000	25387	12585	1	0	\N
192347	2133	91551746000	25387	12585	2	0	\N
192348	1397	1287144849000	25388	12585	0	0	\N
192349	2134	85007326000	25388	12585	1	0	\N
192350	2133	91551746000	25388	12585	2	0	\N
192351	1397	1287144849000	25389	12585	0	0	\N
192352	2134	85007326000	25389	12585	1	0	\N
192353	2133	91551746000	25389	12585	2	0	\N
192357	1397	1287144849000	25391	12585	0	0	\N
192358	2134	85007326000	25391	12585	1	0	\N
192359	2133	91551746000	25391	12585	2	0	\N
192360	1397	1287144849000	25392	12585	0	0	\N
192361	2134	85007326000	25392	12585	1	0	\N
192362	2133	91551746000	25392	12585	2	0	\N
192366	1397	1287134848000	25394	12586	0	0	\N
192367	1397	1287124847000	25394	12586	1	0	\N
192368	2132	147441454000	25394	12586	2	0	\N
192369	2133	91550744000	25394	12586	3	0	\N
192370	2133	91549742000	25394	12586	4	0	\N
192371	2134	85006323000	25394	12586	5	0	\N
192372	2134	85005320000	25394	12586	6	0	\N
192380	1397	1287134848000	25396	12587	0	0	\N
192381	1397	1287124847000	25396	12587	1	0	\N
192382	1397	1287114846000	25396	12587	2	0	\N
192383	2133	91550744000	25396	12587	3	0	\N
192384	2133	91549742000	25396	12587	4	0	\N
192385	2133	91548740000	25396	12587	5	0	\N
192386	2134	85004317000	25396	12587	6	0	\N
192387	1397	1287114846000	25398	12587	0	0	\N
192388	2133	91548740000	25398	12587	1	0	\N
192389	2134	85004317000	25398	12587	2	0	\N
192396	1397	1287104845000	25400	12588	0	0	\N
192397	1397	1287094844000	25400	12588	1	0	\N
192398	2133	91547738000	25400	12588	2	0	\N
192399	2134	85003314000	25400	12588	3	0	\N
192400	1791	1209000048	25400	12588	4	0	\N
192401	1791	208000048	25400	12588	5	0	\N
192402	2134	85002311000	25400	12588	6	0	\N
192403	2133	91546736000	25400	12588	7	0	\N
192404	1397	1287104845000	25401	12588	0	0	\N
192405	1397	1287094844000	25401	12588	1	0	\N
192406	2133	91547738000	25401	12588	2	0	\N
192407	2134	85003314000	25401	12588	3	0	\N
192408	1791	1209000048	25401	12588	4	0	\N
192409	1791	208000048	25401	12588	5	0	\N
192410	2134	85002311000	25401	12588	6	0	\N
192411	2133	91546736000	25401	12588	7	0	\N
192412	222	66058279919853	25402	12589	0	0	\N
192413	1397	1287084843000	25402	12589	1	0	\N
192414	2133	91547738000	25402	12589	2	0	\N
192415	2134	85001308000	25402	12589	3	0	\N
192416	2132	147440453000	25402	12589	4	0	\N
192417	2133	91546736000	25402	12589	5	0	\N
192418	2133	91545734000	25402	12589	6	0	\N
192426	222	66058279919853	25404	12589	0	0	\N
192427	1397	1287084843000	25404	12589	1	0	\N
192428	2133	91547738000	25404	12589	2	0	\N
192429	2134	85001308000	25404	12589	3	0	\N
192430	2132	147440453000	25404	12589	4	0	\N
192431	2133	91546736000	25404	12589	5	0	\N
192432	2133	91545734000	25404	12589	6	0	\N
192433	222	66713079919853	25405	12547	0	0	\N
192434	222	66702479919853	25405	12547	1	0	\N
192435	222	66681879919853	25405	12547	2	0	\N
192436	222	66661279919853	25405	12547	3	0	\N
192437	222	66540679919853	25405	12547	4	0	\N
192438	222	66420079919853	25405	12547	5	0	\N
192439	222	66299479919853	25405	12547	6	0	\N
192440	222	66178879919853	25405	12547	7	0	\N
192317	2134	85010335000	25376	12582	2	0	5563
192332	1397	1287164851000	25382	12583	0	0	15166
192333	2133	91553750000	25382	12583	1	0	5127
192334	2134	85009332000	25382	12583	2	0	5564
192338	1397	1287154850000	25384	12584	0	0	15167
192340	2133	91552748000	25384	12584	2	0	5128
192341	2134	85008329000	25384	12584	3	0	5565
192354	1397	1287144849000	25390	12585	0	0	15168
192355	2134	85007326000	25390	12585	1	0	5566
192356	2133	91551746000	25390	12585	2	0	5129
192364	2134	85006323000	25393	12586	1	0	5567
192365	2134	85005320000	25393	12586	2	0	5568
192373	1397	1287134848000	25395	12587	0	0	15169
192374	1397	1287124847000	25395	12587	1	0	15170
192376	2133	91550744000	25395	12587	3	0	5130
192377	2133	91549742000	25395	12587	4	0	5131
192378	2133	91548740000	25395	12587	5	0	5132
192379	2134	85004317000	25395	12587	6	0	5569
192390	1397	1287104845000	25399	12588	0	0	15172
192392	2134	85003314000	25399	12588	2	0	5570
192393	1791	1209000048	25399	12588	3	0	1
192394	1791	208000048	25399	12588	4	0	2
192395	2134	85002311000	25399	12588	5	0	5571
192419	222	66058279919853	25403	12589	0	0	9
192421	2133	91547738000	25403	12589	2	0	5133
192422	2134	85001308000	25403	12589	3	0	5572
192423	2132	147440453000	25403	12589	4	0	1548
192424	2133	91546736000	25403	12589	5	0	5134
192441	222	66058279919853	25405	12547	8	0	\N
192442	1791	1209000048	25405	12547	9	0	\N
192443	1791	208000048	25405	12547	10	0	\N
192465	1397	1287024837000	25410	12593	0	0	\N
192466	2133	91539722000	25410	12593	1	0	\N
192467	2134	84995290000	25410	12593	2	0	\N
192468	2132	147438451000	25410	12593	3	0	\N
192469	1397	1287024837000	25411	12593	0	0	\N
192470	2133	91539722000	25411	12593	1	0	\N
192471	2134	84995290000	25411	12593	2	0	\N
192472	2132	147438451000	25411	12593	3	0	\N
192473	1397	1287024837000	25412	12593	0	0	\N
192474	2133	91539722000	25412	12593	1	0	\N
192475	2134	84995290000	25412	12593	2	0	\N
192476	2132	147438451000	25412	12593	3	0	\N
192478	1397	1287014836000	25414	12594	0	0	\N
192479	2134	84994287000	25414	12594	1	0	\N
192480	2133	91538720000	25414	12594	2	0	\N
192481	2134	84994287000	25415	12594	0	0	\N
192485	1397	1287014836000	25417	12595	0	0	\N
192486	1397	1287004835000	25417	12595	1	0	\N
192487	2134	84993284000	25417	12595	2	0	\N
192488	2133	91538720000	25417	12595	4	0	\N
192489	2133	91537718000	25417	12595	5	0	\N
192490	1397	1286994834000	25418	12596	0	0	\N
192491	2134	84992281000	25418	12596	1	0	\N
192492	2133	91538720000	25418	12596	2	0	\N
192493	2133	91537718000	25418	12596	3	0	\N
192494	2133	91536716000	25418	12596	4	0	\N
192495	1397	1286994834000	25419	12596	0	0	\N
192496	2134	84992281000	25419	12596	1	0	\N
192497	2133	91538720000	25419	12596	2	0	\N
192498	2133	91537718000	25419	12596	3	0	\N
192499	2133	91536716000	25419	12596	4	0	\N
192505	1397	1286994834000	25421	12596	0	0	\N
192506	2134	84992281000	25421	12596	1	0	\N
192507	2133	91538720000	25421	12596	2	0	\N
192512	1397	1286974832000	25423	12598	0	0	\N
192513	2134	84990275000	25423	12598	1	0	\N
192520	1397	1286964831000	25426	12599	0	0	\N
192521	1397	1286954830000	25426	12599	1	0	\N
192522	1397	1286944829000	25426	12599	2	0	\N
192523	2133	91533710000	25426	12599	3	0	\N
192524	2134	84989272000	25426	12599	4	0	\N
192525	2133	91532708000	25426	12599	5	0	\N
192526	2133	91531706000	25426	12599	6	0	\N
192527	2134	84988269000	25426	12599	7	0	\N
192528	2134	84987266000	25426	12599	8	0	\N
192529	2132	147436449000	25426	12599	9	0	\N
192530	2132	147436449000	25427	12600	0	0	\N
192531	222	66058279919853	25428	12585	0	0	\N
192532	222	66002679919853	25428	12585	1	0	\N
192533	1791	1209000048	25428	12585	2	0	\N
192534	1791	208000048	25428	12585	3	0	\N
192542	1397	1286954830000	25430	12600	0	0	\N
192543	1397	1286944829000	25430	12600	1	0	\N
192544	2133	91532708000	25430	12600	2	0	\N
192545	2133	91531706000	25430	12600	3	0	\N
192546	2134	84988269000	25430	12600	4	0	\N
192547	2134	84987266000	25430	12600	5	0	\N
192548	2132	147436449000	25430	12600	6	0	\N
192549	1397	1286964831000	25431	12599	0	0	\N
192550	1397	1286954830000	25431	12599	1	0	\N
192551	1397	1286944829000	25431	12599	2	0	\N
192552	2134	84989272000	25431	12599	3	0	\N
192553	2134	84988269000	25431	12599	4	0	\N
192554	2134	84987266000	25431	12599	5	0	\N
192555	2132	147436449000	25431	12599	6	0	\N
192566	1397	1286914826000	25435	12603	0	0	\N
192567	2134	84984257000	25435	12603	1	0	\N
192568	2133	91528700000	25435	12603	2	0	\N
192569	1397	1286914826000	25436	12603	0	0	\N
192570	2134	84984257000	25436	12603	1	0	\N
192571	2133	91528700000	25436	12603	2	0	\N
192572	1397	1286904825000	25438	12604	0	0	\N
192573	2133	91527698000	25438	12604	1	0	\N
192574	2134	84983254000	25438	12604	2	0	\N
192575	1397	1286904825000	25439	12604	0	0	\N
192576	2133	91527698000	25439	12604	1	0	\N
192446	1397	1287064841000	25406	12590	2	0	15176
192447	1397	1287054840000	25406	12590	3	0	15177
192448	2134	85000305000	25406	12590	4	0	5573
192449	2132	147439452000	25406	12590	5	0	1549
192450	2133	91544732000	25406	12590	6	0	5136
192452	2133	91542728000	25406	12590	8	0	5138
192453	2134	84999302000	25406	12590	9	0	5574
192454	2134	84998299000	25406	12590	10	0	5575
192455	1397	1287044839000	25407	12591	0	0	15178
192456	2133	91541726000	25407	12591	1	0	5139
192458	1397	1287034838000	25408	12592	0	0	15179
192459	2134	84996293000	25408	12592	1	0	5577
192460	2133	91540724000	25408	12592	2	0	5140
192461	1397	1287024837000	25409	12593	0	0	15180
192463	2134	84995290000	25409	12593	2	0	5578
192464	2132	147438451000	25409	12593	3	0	1550
192477	2134	84994287000	25413	12594	0	0	5579
192482	1397	1287014836000	25416	12595	0	0	15181
192483	1397	1287004835000	25416	12595	1	0	15182
192500	1397	1286994834000	25420	12596	0	0	15183
192501	2134	84992281000	25420	12596	1	0	5581
192502	2133	91538720000	25420	12596	2	0	5142
192503	2133	91537718000	25420	12596	3	0	5143
192504	2133	91536716000	25420	12596	4	0	5144
192509	2134	84991278000	25422	12597	1	0	5582
192510	2133	91535714000	25422	12597	2	0	5145
192511	2132	147437450000	25422	12597	3	0	1551
192514	1397	1286974832000	25424	12598	0	0	15185
192516	2134	84990275000	25424	12598	2	0	5583
192517	1397	1286964831000	25425	12599	0	0	15186
192518	2133	91533710000	25425	12599	1	0	5147
192519	2134	84989272000	25425	12599	2	0	5584
192535	1397	1286954830000	25429	12600	0	0	15187
192537	2133	91532708000	25429	12600	2	0	5148
192538	2133	91531706000	25429	12600	3	0	5149
192539	2134	84988269000	25429	12600	4	0	5585
192540	2134	84987266000	25429	12600	5	0	5586
192541	2132	147436449000	25429	12600	6	0	1552
192557	2134	84986263000	25432	12601	1	0	5587
192558	2133	91530704000	25432	12601	2	0	5150
192559	1397	1286924827000	25433	12602	0	0	15190
192560	2133	91529702000	25433	12602	1	0	5151
192562	2132	147435448000	25433	12602	3	0	1553
192563	1397	1286914826000	25434	12603	0	0	15191
192564	2134	84984257000	25434	12603	1	0	5589
192565	2133	91528700000	25434	12603	2	0	5152
192577	2134	84983254000	25439	12604	2	0	\N
192578	1397	1286904825000	25440	12604	0	0	\N
192579	2133	91527698000	25440	12604	1	0	\N
192580	2134	84983254000	25440	12604	2	0	\N
192584	1397	1286904825000	25442	12604	0	0	\N
192585	2133	91527698000	25442	12604	1	0	\N
192586	2134	84983254000	25442	12604	2	0	\N
192587	1397	1286894824000	25443	12605	0	0	\N
192588	2134	84982251000	25443	12605	1	0	\N
192589	2133	91526696000	25443	12605	2	0	\N
192592	1397	1286894824000	25445	12605	0	0	\N
192593	2134	84982251000	25445	12605	1	0	\N
192594	2133	91526696000	25445	12605	2	0	\N
192595	1397	1286884823000	25446	12606	0	0	\N
192596	2132	147434447000	25446	12606	1	0	\N
192597	2134	84981248000	25446	12606	2	0	\N
192598	2133	91526696000	25446	12606	3	0	\N
192599	2133	91525694000	25446	12606	4	0	\N
192605	1397	1286884823000	25448	12606	0	0	\N
192606	2132	147434447000	25448	12606	1	0	\N
192607	2134	84981248000	25448	12606	2	0	\N
192608	2133	91526696000	25448	12606	3	0	\N
192609	2133	91525694000	25448	12606	4	0	\N
192617	1397	1286854820000	25450	12608	0	0	\N
192618	2132	147433446000	25450	12608	1	0	\N
192619	2134	84978239000	25450	12608	2	0	\N
192624	1397	1286844819000	25452	12609	0	0	\N
192625	2133	91521686000	25452	12609	1	0	\N
192626	2134	84977236000	25452	12609	2	0	\N
192627	1397	1286844819000	25453	12609	0	0	\N
192628	2133	91521686000	25453	12609	1	0	\N
192629	2134	84977236000	25453	12609	2	0	\N
192633	1397	1286844819000	25455	12609	0	0	\N
192634	2134	84977236000	25455	12609	1	0	\N
192635	1397	1286844819000	25456	12609	0	0	\N
192636	2133	91521686000	25456	12609	1	0	\N
192637	2134	84977236000	25456	12609	2	0	\N
192642	1791	1209000048	25458	12581	0	0	\N
192643	1791	208000048	25458	12581	1	0	\N
192644	2321	413499000000	25458	12581	2	0	\N
192645	2321	413399000000	25458	12581	3	0	\N
192650	1397	1286824817000	25462	12611	0	0	\N
192651	2132	147432445000	25462	12611	1	0	\N
192652	2134	84975230000	25462	12611	2	0	\N
192653	2133	91519682000	25462	12611	3	0	\N
192660	1397	1286794814000	25464	12613	0	0	\N
192661	2134	84972221000	25464	12613	1	0	\N
192662	2133	91516676000	25464	12613	2	0	\N
192670	1397	1286774812000	25467	12615	0	0	\N
192671	2134	84970215000	25467	12615	1	0	\N
192672	2133	91514672000	25467	12615	2	0	\N
192676	1397	1286774812000	25469	12615	0	0	\N
192677	2134	84970215000	25469	12615	1	0	\N
192678	2133	91514672000	25469	12615	2	0	\N
192679	1397	1286774812000	25470	12615	0	0	\N
192680	2134	84970215000	25470	12615	1	0	\N
192681	2133	91514672000	25470	12615	2	0	\N
192682	2134	84970215000	25471	12615	0	0	\N
192683	2133	91514672000	25471	12615	1	0	\N
192687	1397	1286754810000	25473	12617	0	0	\N
192688	2133	91512668000	25473	12617	2	0	\N
192689	2068	942999000000	25473	12617	3	0	\N
192690	2134	84968209000	25473	12617	4	0	\N
192691	1397	1286754810000	25474	12617	0	0	\N
192692	2133	91512668000	25474	12617	2	0	\N
192693	2068	942999000000	25474	12617	3	0	\N
192694	2134	84968209000	25474	12617	4	0	\N
192695	1397	1286754810000	25475	12617	0	0	\N
192696	2133	91512668000	25475	12617	2	0	\N
192697	2068	942999000000	25475	12617	3	0	\N
192698	2134	84968209000	25475	12617	4	0	\N
192703	1397	1286754810000	25477	12617	0	0	\N
192704	2133	91512668000	25477	12617	2	0	\N
192705	2068	942999000000	25477	12617	3	0	\N
192706	2134	84968209000	25477	12617	4	0	\N
192583	2134	84983254000	25441	12604	2	0	5590
192590	1397	1286894824000	25444	12605	0	0	15193
192591	2134	84982251000	25444	12605	1	0	5591
192600	1397	1286884823000	25447	12606	0	0	15194
192601	2132	147434447000	25447	12606	1	0	1554
192603	2133	91526696000	25447	12606	3	0	5154
192604	2133	91525694000	25447	12606	4	0	5155
192610	1397	1286874822000	25449	12607	0	0	15195
192611	1397	1286864821000	25449	12607	1	0	15196
192612	2133	91524692000	25449	12607	2	0	5156
192614	2321	709999000000	25449	12607	4	0	1
192615	2134	84979242000	25449	12607	5	0	5594
192616	2133	91523690000	25449	12607	6	0	5157
192620	1397	1286854820000	25451	12608	0	0	15197
192622	2133	91522688000	25451	12608	2	0	5158
192623	2134	84978239000	25451	12608	3	0	5595
192630	1397	1286844819000	25454	12609	0	0	15198
192631	2133	91521686000	25454	12609	1	0	5159
192632	2134	84977236000	25454	12609	2	0	5596
192639	1397	1286834818000	25457	12610	1	0	15199
192640	2133	91520684000	25457	12610	2	0	5160
192641	2134	84976233000	25457	12610	3	0	5597
192646	1397	1286824817000	25461	12611	0	0	15200
192647	2132	147432445000	25461	12611	1	0	1556
192649	2133	91519682000	25461	12611	3	0	5161
192654	1397	1286814816000	25463	12612	0	0	15201
192655	1397	1286804815000	25463	12612	1	0	15202
192656	2133	91518680000	25463	12612	2	0	5162
192658	2134	84974227000	25463	12612	4	0	5599
192659	2134	84973224000	25463	12612	5	0	5600
192663	1397	1286794814000	25465	12613	0	0	15203
192664	2134	84972221000	25465	12613	1	0	5601
192665	2133	91516676000	25465	12613	2	0	5164
192667	2133	91515674000	25466	12614	1	0	5165
192668	2134	84971218000	25466	12614	2	0	5602
192669	2132	147431444000	25466	12614	3	0	1557
192673	1397	1286774812000	25468	12615	0	0	15205
192674	2134	84970215000	25468	12615	1	0	5603
192684	1397	1286764811000	25472	12616	0	0	15206
192685	2134	84969212000	25472	12616	1	0	5604
192686	2133	91513670000	25472	12616	2	0	5167
192699	1397	1286754810000	25476	12617	0	0	15207
192701	2068	942999000000	25476	12617	3	0	1
192702	2134	84968209000	25476	12617	4	0	5605
192707	1397	1286744809000	25478	12618	0	0	15208
192708	2134	84967206000	25478	12618	1	0	5606
192709	2133	91511666000	25478	12618	2	0	5169
192711	2134	84966203000	25479	12619	1	0	5607
192712	2133	91510664000	25479	12619	2	0	5170
192713	1397	1286734808000	25480	12619	0	0	\N
192714	2134	84966203000	25480	12619	1	0	\N
192715	2133	91510664000	25480	12619	2	0	\N
192719	222	66058279919853	25482	12475	0	0	\N
192720	1397	1286724807000	25483	12620	0	0	\N
192721	2133	91509662000	25483	12620	1	0	\N
192722	2134	84965200000	25483	12620	2	0	\N
192726	1397	1286704805000	25485	12622	0	0	\N
192727	2134	84963194000	25485	12622	1	0	\N
192728	2133	91507658000	25485	12622	2	0	\N
192735	1397	1286694804000	25488	12623	0	0	\N
192736	2134	84962191000	25488	12623	1	0	\N
192737	2133	91506656000	25488	12623	2	0	\N
192738	2133	91506656000	25489	12623	0	0	\N
192742	1397	1286674802000	25492	12625	0	0	\N
192743	1397	1286664801000	25492	12625	1	0	\N
192744	2133	91504652000	25492	12625	2	0	\N
192745	2134	84960185000	25492	12625	3	0	\N
192746	2134	84959182000	25492	12625	4	0	\N
192747	2133	91503650000	25492	12625	5	0	\N
192754	1397	1286674802000	25494	12625	0	0	\N
192755	1397	1286664801000	25494	12625	1	0	\N
192756	2133	91504652000	25494	12625	2	0	\N
192757	2134	84960185000	25494	12625	3	0	\N
192758	2134	84959182000	25494	12625	4	0	\N
192759	2133	91503650000	25494	12625	5	0	\N
192760	1397	1286654800000	25495	12626	0	0	\N
192761	2134	84958179000	25495	12626	1	0	\N
192762	2133	91502648000	25495	12626	2	0	\N
192763	1397	1286654800000	25496	12626	0	0	\N
192764	2134	84958179000	25496	12626	1	0	\N
192765	2133	91502648000	25496	12626	2	0	\N
192766	1397	1286654800000	25497	12626	0	0	\N
192767	2134	84958179000	25497	12626	1	0	\N
192768	2133	91502648000	25497	12626	2	0	\N
192772	1397	1286654800000	25499	12626	0	0	\N
192773	2134	84958179000	25499	12626	1	0	\N
192774	2133	91502648000	25499	12626	2	0	\N
192787	1397	1286614796000	25504	12630	0	0	\N
192788	2133	91498640000	25504	12630	1	0	\N
192789	2134	84954167000	25504	12630	2	0	\N
192790	1397	1286604795000	25505	12631	0	0	\N
192791	2133	91497638000	25505	12631	1	0	\N
192792	2134	84953164000	25505	12631	2	0	\N
192793	1397	1286604795000	25506	12631	0	0	\N
192794	2133	91497638000	25506	12631	1	0	\N
192795	2134	84953164000	25506	12631	2	0	\N
192799	1397	1286594794000	25508	12632	0	0	\N
192800	2134	84952161000	25508	12632	1	0	\N
192801	2133	91496636000	25508	12632	2	0	\N
192805	1397	1286584793000	25510	12633	0	0	\N
192806	2133	91495634000	25510	12633	1	0	\N
192807	2134	84951158000	25510	12633	2	0	\N
192811	1397	1286584793000	25512	12633	0	0	\N
192812	2133	91495634000	25512	12633	1	0	\N
192813	2134	84951158000	25512	12633	2	0	\N
192814	1397	1286584793000	25513	12633	0	0	\N
192815	2133	91495634000	25513	12633	1	0	\N
192816	2134	84951158000	25513	12633	2	0	\N
192817	1397	1286584793000	25514	12633	0	0	\N
192818	2133	91495634000	25514	12633	1	0	\N
192819	2134	84951158000	25514	12633	2	0	\N
192820	1397	1286574792000	25515	12634	0	0	\N
192821	2134	84950155000	25515	12634	1	0	\N
192822	2133	91494632000	25515	12634	2	0	\N
192823	1397	1286574792000	25516	12634	0	0	\N
192824	2134	84950155000	25516	12634	1	0	\N
192825	2133	91494632000	25516	12634	2	0	\N
192826	1397	1286574792000	25517	12634	0	0	\N
192827	2134	84950155000	25517	12634	1	0	\N
192828	2133	91494632000	25517	12634	2	0	\N
192832	1397	1286564791000	25519	12635	0	0	\N
192833	2134	84949152000	25519	12635	1	0	\N
192834	2133	91493630000	25519	12635	2	0	\N
192835	1397	1286564791000	25520	12635	0	0	\N
192836	2134	84949152000	25520	12635	1	0	\N
192837	2133	91493630000	25520	12635	2	0	\N
192838	1397	1286564791000	25521	12635	0	0	\N
192839	2134	84949152000	25521	12635	1	0	\N
192840	2133	91493630000	25521	12635	2	0	\N
192718	2134	84965200000	25481	12620	2	0	5608
192723	1397	1286714806000	25484	12621	0	0	15211
192724	2134	84964197000	25484	12621	1	0	5609
192725	2133	91508660000	25484	12621	2	0	5172
192729	1397	1286704805000	25486	12622	0	0	15212
192731	2133	91507658000	25486	12622	2	0	5173
192732	1397	1286694804000	25487	12623	0	0	15213
192733	2134	84962191000	25487	12623	1	0	5611
192734	2133	91506656000	25487	12623	2	0	5174
192739	1397	1286684803000	25490	12624	0	0	15214
192741	2133	91505654000	25490	12624	2	0	5175
192748	1397	1286674802000	25493	12625	0	0	15215
192749	1397	1286664801000	25493	12625	1	0	15216
192750	2133	91504652000	25493	12625	2	0	5176
192752	2134	84959182000	25493	12625	4	0	5614
192753	2133	91503650000	25493	12625	5	0	5177
192769	1397	1286654800000	25498	12626	0	0	15217
192770	2134	84958179000	25498	12626	1	0	5615
192771	2133	91502648000	25498	12626	2	0	5178
192776	2134	84957176000	25500	12627	1	0	5616
192777	2133	91501646000	25500	12627	2	0	5179
192778	1397	1286634798000	25501	12628	0	0	15219
192779	2133	91500644000	25501	12628	1	0	5180
192780	2134	84956173000	25501	12628	2	0	5617
192782	2134	84955170000	25502	12629	1	0	5618
192783	2133	91499642000	25502	12629	2	0	5181
192784	1397	1286614796000	25503	12630	0	0	15221
192785	2133	91498640000	25503	12630	1	0	5182
192796	1397	1286604795000	25507	12631	0	0	15222
192797	2133	91497638000	25507	12631	1	0	5183
192798	2134	84953164000	25507	12631	2	0	5620
192802	1397	1286594794000	25509	12632	0	0	15223
192803	2134	84952161000	25509	12632	1	0	5621
192808	1397	1286584793000	25511	12633	0	0	15224
192809	2133	91495634000	25511	12633	1	0	5185
192810	2134	84951158000	25511	12633	2	0	5622
192829	1397	1286574792000	25518	12634	0	0	15225
192830	2134	84950155000	25518	12634	1	0	5623
192841	2133	91493630000	25522	12635	0	0	5187
192842	1397	1286564791000	25523	12636	0	0	15226
192843	1397	1286554790000	25523	12636	1	0	15227
192844	1397	1286544789000	25523	12636	2	0	15228
192846	2134	84949152000	25523	12636	4	0	5624
192847	2134	84948149000	25523	12636	5	0	5625
192848	2133	91491626000	25523	12636	6	0	5189
192849	1397	1286534788000	25524	12637	0	0	\N
192850	2134	84947146000	25524	12637	1	0	\N
192851	2133	91490624000	25524	12637	2	0	\N
192855	1397	1286534788000	25526	12637	0	0	\N
192856	2134	84947146000	25526	12637	1	0	\N
192857	2133	91490624000	25526	12637	2	0	\N
192858	1397	1286534788000	25527	12637	0	0	\N
192859	2134	84947146000	25527	12637	1	0	\N
192860	2133	91490624000	25527	12637	2	0	\N
192861	1397	1286524787000	25529	12638	0	0	\N
192862	1397	1286514786000	25529	12638	1	0	\N
192863	1397	1286504785000	25529	12638	2	0	\N
192864	2134	84946143000	25529	12638	3	0	\N
192865	2134	84945140000	25529	12638	4	0	\N
192866	2134	84944137000	25529	12638	5	0	\N
192867	2133	91489622000	25529	12638	6	0	\N
192868	2133	91488620000	25529	12638	7	0	\N
192869	2133	91487618000	25529	12638	8	0	\N
192885	1397	1286484783000	25533	12640	0	0	\N
192886	2133	91485614000	25533	12640	2	0	\N
192887	2134	84942131000	25533	12640	3	0	\N
192891	1397	1286464781000	25535	12642	0	0	\N
192892	2133	91483610000	25535	12642	1	0	\N
192893	2134	84940125000	25535	12642	2	0	\N
192903	1397	1286434778000	25538	12644	0	0	\N
192904	2134	84937116000	25538	12644	1	0	\N
192905	1397	1286434778000	25539	12644	0	0	\N
192906	2134	84937116000	25539	12644	1	0	\N
192914	2068	942999000000	25542	12582	0	0	\N
192915	2068	942999000000	25543	12608	0	0	\N
192940	1397	1286594794000	25551	12632	0	0	\N
192941	1397	1286584793000	25551	12632	1	0	\N
192942	1397	1286574792000	25551	12632	2	0	\N
192943	1397	1286564791000	25551	12632	3	0	\N
192944	1397	1286554790000	25551	12632	4	0	\N
192945	1397	1286544789000	25551	12632	5	0	\N
192946	1397	1286534788000	25551	12632	6	0	\N
192947	1397	1286524787000	25551	12632	7	0	\N
192948	1397	1286514786000	25551	12632	8	0	\N
192949	1397	1286504785000	25551	12632	9	0	\N
192950	1397	1286494784000	25551	12632	10	0	\N
192951	1397	1286484783000	25551	12632	11	0	\N
192952	1397	1286474782000	25551	12632	12	0	\N
192953	1397	1286464781000	25551	12632	13	0	\N
192954	1397	1286454780000	25551	12632	14	0	\N
192955	1397	1286444779000	25551	12632	15	0	\N
192956	1397	1286434778000	25551	12632	16	0	\N
192957	1397	1286424777000	25551	12632	17	0	\N
192958	1397	1286414776000	25551	12632	18	0	\N
192959	1397	1286404775000	25551	12632	19	0	\N
192960	1397	1286394774000	25551	12632	20	0	\N
192961	1397	1286384773000	25551	12632	21	0	\N
192962	1397	1286374772000	25551	12632	22	0	\N
192963	1397	1286364771000	25551	12632	23	0	\N
192964	1397	1286354770000	25551	12632	24	0	\N
192965	1397	1286344769000	25551	12632	25	0	\N
192966	2134	84952161000	25551	12632	26	0	\N
192967	2134	84951158000	25551	12632	27	0	\N
192968	2134	84950155000	25551	12632	28	0	\N
192969	2134	84949152000	25551	12632	29	0	\N
192970	2134	84948149000	25551	12632	30	0	\N
192971	2134	84947146000	25551	12632	31	0	\N
192972	2134	84946143000	25551	12632	32	0	\N
192973	2134	84945140000	25551	12632	33	0	\N
192974	2134	84944137000	25551	12632	34	0	\N
192975	2134	84943134000	25551	12632	35	0	\N
192976	2134	84942131000	25551	12632	36	0	\N
192977	2134	84941128000	25551	12632	37	0	\N
192978	2134	84940125000	25551	12632	38	0	\N
192979	2134	84939122000	25551	12632	39	0	\N
192980	2134	84938119000	25551	12632	40	0	\N
192981	2134	84937116000	25551	12632	41	0	\N
192982	2134	84936113000	25551	12632	42	0	\N
192983	2134	84935110000	25551	12632	43	0	\N
192984	2134	84934107000	25551	12632	44	0	\N
192854	2133	91490624000	25525	12637	2	0	5190
192870	1397	1286524787000	25530	12638	0	0	15230
192871	1397	1286514786000	25530	12638	1	0	15231
192872	1397	1286504785000	25530	12638	2	0	15232
192873	2134	84946143000	25530	12638	3	0	5627
192875	2134	84944137000	25530	12638	5	0	5629
192876	2133	91489622000	25530	12638	6	0	5191
192877	2133	91488620000	25530	12638	7	0	5192
192878	2133	91487618000	25530	12638	8	0	5193
192879	1397	1286494784000	25531	12639	0	0	15233
192881	2133	91486616000	25531	12639	2	0	5194
192882	1397	1286484783000	25532	12640	0	0	15234
192883	2133	91485614000	25532	12640	2	0	5195
192884	2134	84942131000	25532	12640	3	0	5631
192889	2134	84941128000	25534	12641	1	0	5632
192890	2133	91484612000	25534	12641	2	0	5196
192894	1397	1286464781000	25536	12642	0	0	15236
192895	2133	91483610000	25536	12642	1	0	5197
192896	2134	84940125000	25536	12642	2	0	5633
192898	1397	1286444779000	25537	12643	1	0	15238
192899	2133	91482608000	25537	12643	2	0	5198
192900	2134	84939122000	25537	12643	3	0	5634
192901	2134	84938119000	25537	12643	4	0	5635
192902	2133	91481606000	25537	12643	5	0	5199
192908	2134	84937116000	25540	12644	1	0	5636
192909	1397	1286424777000	25541	12645	0	0	15240
192910	2133	91480604000	25541	12645	1	0	5200
192911	2133	91479602000	25541	12645	2	0	5201
192913	2134	84935110000	25541	12645	4	0	5638
192916	1397	1286414776000	25544	12646	0	0	15241
192917	1397	1286404775000	25544	12646	1	0	15242
192918	2133	91478600000	25544	12646	2	0	5202
192919	2133	91477598000	25544	12646	3	0	5203
192921	2134	84933104000	25544	12646	5	0	5640
192922	1397	1286394774000	25545	12647	0	0	15243
192923	2134	84932101000	25545	12647	1	0	5641
192924	2133	91476596000	25545	12647	2	0	5204
192925	1397	1286384773000	25546	12648	0	0	15244
192927	2133	91475594000	25546	12648	2	0	5205
192928	1397	1286374772000	25548	12649	0	0	15245
192929	1397	1286364771000	25548	12649	1	0	15246
192930	1397	1286354770000	25548	12649	2	0	15247
192932	2134	84929092000	25548	12649	4	0	5644
192933	2133	91474592000	25548	12649	5	0	5206
192934	2133	91473590000	25548	12649	6	0	5207
192935	2133	91472588000	25548	12649	7	0	5208
192936	2134	84928089000	25549	12650	0	0	5645
192938	2133	91471586000	25550	12651	1	0	5209
192939	2134	84927086000	25550	12651	2	0	5646
192985	2133	91496636000	25551	12632	45	0	\N
192986	2133	91495634000	25551	12632	46	0	\N
192987	2133	91494632000	25551	12632	47	0	\N
192988	2133	91493630000	25551	12632	48	0	\N
192989	2133	91492628000	25551	12632	50	0	\N
192990	2134	84933104000	25551	12632	51	0	\N
192991	2134	84932101000	25551	12632	52	0	\N
192992	2134	84931098000	25551	12632	53	0	\N
192993	2134	84930095000	25551	12632	54	0	\N
192994	2134	84929092000	25551	12632	55	0	\N
192995	2134	84928089000	25551	12632	56	0	\N
192996	2134	84927086000	25551	12632	57	0	\N
192997	2133	91491626000	25551	12632	58	0	\N
192998	2133	91490624000	25551	12632	59	0	\N
192999	2133	91489622000	25551	12632	60	0	\N
193000	2133	91488620000	25551	12632	61	0	\N
193001	2133	91487618000	25551	12632	62	0	\N
193002	2133	91486616000	25551	12632	63	0	\N
193003	2133	91485614000	25551	12632	64	0	\N
193004	2133	91484612000	25551	12632	65	0	\N
193005	2133	91483610000	25551	12632	66	0	\N
193006	2133	91482608000	25551	12632	67	0	\N
193007	2133	91481606000	25551	12632	68	0	\N
193008	2133	91480604000	25551	12632	69	0	\N
193009	2133	91479602000	25551	12632	70	0	\N
193010	2133	91478600000	25551	12632	71	0	\N
193011	2133	91477598000	25551	12632	72	0	\N
193012	2133	91476596000	25551	12632	73	0	\N
193013	2133	91475594000	25551	12632	74	0	\N
193014	2133	91474592000	25551	12632	75	0	\N
193015	2133	91473590000	25551	12632	76	0	\N
193016	2133	91472588000	25551	12632	77	0	\N
193017	2133	91471586000	25551	12632	78	0	\N
193021	1397	1286324767000	25554	12653	0	0	\N
193022	1397	1286314766000	25554	12653	1	0	\N
193023	2133	91469582000	25554	12653	2	0	\N
193024	2134	84925080000	25554	12653	3	0	\N
193025	2134	84924077000	25554	12653	4	0	\N
193026	2133	91468580000	25554	12653	5	0	\N
193033	1397	1286934828000	25556	12601	0	0	\N
193034	1397	1286924827000	25556	12601	1	0	\N
193035	1397	1286914826000	25556	12601	2	0	\N
193036	1397	1286904825000	25556	12601	3	0	\N
193037	1397	1286894824000	25556	12601	4	0	\N
193038	1397	1286884823000	25556	12601	5	0	\N
193039	1397	1286874822000	25556	12601	6	0	\N
193040	1397	1286864821000	25556	12601	7	0	\N
193041	1397	1286854820000	25556	12601	8	0	\N
193042	1397	1286844819000	25556	12601	9	0	\N
193043	1397	1286834818000	25556	12601	10	0	\N
193044	1397	1286824817000	25556	12601	11	0	\N
193045	1397	1286814816000	25556	12601	12	0	\N
193046	1397	1286804815000	25556	12601	13	0	\N
193047	1397	1286794814000	25556	12601	14	0	\N
193048	1397	1286784813000	25556	12601	15	0	\N
193049	1397	1286774812000	25556	12601	16	0	\N
193050	1397	1286764811000	25556	12601	17	0	\N
193051	1397	1286754810000	25556	12601	18	0	\N
193052	1397	1286744809000	25556	12601	19	0	\N
193053	1397	1286734808000	25556	12601	20	0	\N
193054	1397	1286724807000	25556	12601	21	0	\N
193055	1397	1286714806000	25556	12601	22	0	\N
193056	1397	1286704805000	25556	12601	23	0	\N
193057	1397	1286694804000	25556	12601	24	0	\N
193058	1397	1286684803000	25556	12601	25	0	\N
193059	1397	1286674802000	25556	12601	26	0	\N
193060	1397	1286664801000	25556	12601	27	0	\N
193061	1397	1286654800000	25556	12601	28	0	\N
193062	1397	1286644799000	25556	12601	29	0	\N
193063	1397	1286634798000	25556	12601	30	0	\N
193064	1397	1286624797000	25556	12601	31	0	\N
193065	1397	1286614796000	25556	12601	32	0	\N
193066	1397	1286604795000	25556	12601	33	0	\N
193067	1397	1286594794000	25556	12601	34	0	\N
193068	1397	1286584793000	25556	12601	35	0	\N
193069	1397	1286574792000	25556	12601	36	0	\N
193070	1397	1286564791000	25556	12601	37	0	\N
193071	1397	1286554790000	25556	12601	38	0	\N
193072	1397	1286544789000	25556	12601	39	0	\N
193073	1397	1286534788000	25556	12601	40	0	\N
193074	1397	1286524787000	25556	12601	41	0	\N
193075	1397	1286514786000	25556	12601	42	0	\N
193076	1397	1286504785000	25556	12601	43	0	\N
193077	1397	1286494784000	25556	12601	44	0	\N
193078	1397	1286484783000	25556	12601	45	0	\N
193079	1397	1286474782000	25556	12601	46	0	\N
193080	1397	1286464781000	25556	12601	47	0	\N
193081	1397	1286454780000	25556	12601	48	0	\N
193082	1397	1286444779000	25556	12601	49	0	\N
193083	1397	1286434778000	25556	12601	50	0	\N
193084	1397	1286424777000	25556	12601	51	0	\N
193085	1397	1286414776000	25556	12601	52	0	\N
193086	1397	1286404775000	25556	12601	53	0	\N
193087	1397	1286394774000	25556	12601	54	0	\N
193088	1397	1286384773000	25556	12601	55	0	\N
193089	1397	1286374772000	25556	12601	56	0	\N
193090	1397	1286364771000	25556	12601	57	0	\N
193091	1397	1286354770000	25556	12601	58	0	\N
193092	1397	1286344769000	25556	12601	59	0	\N
193093	1397	1286334768000	25556	12601	60	0	\N
193094	1397	1286324767000	25556	12601	61	0	\N
193095	1397	1286314766000	25556	12601	62	0	\N
193096	2068	942999000000	25556	12601	63	0	\N
193097	2134	84986263000	25556	12601	64	0	\N
193098	2133	91530704000	25556	12601	65	0	\N
193099	2321	709999000000	25556	12601	66	0	\N
193100	2321	709899000000	25556	12601	67	0	\N
193101	2133	91529702000	25556	12601	68	0	\N
193102	2134	84985260000	25556	12601	69	0	\N
193103	2134	84984257000	25556	12601	70	0	\N
193104	2132	147435448000	25556	12601	71	0	\N
193105	2132	147434447000	25556	12601	72	0	\N
193106	2132	147433446000	25556	12601	73	0	\N
193107	2132	147432445000	25556	12601	74	0	\N
193108	2133	91528700000	25556	12601	75	0	\N
193109	2133	91527698000	25556	12601	76	0	\N
193110	2133	91526696000	25556	12601	77	0	\N
193111	2133	91525694000	25556	12601	78	0	\N
193112	2133	91524692000	25556	12601	79	0	\N
193113	2133	91523690000	25556	12601	80	0	\N
193114	2133	91522688000	25556	12601	81	0	\N
193115	2133	91521686000	25556	12601	82	0	\N
193116	2133	91520684000	25556	12601	83	0	\N
193117	2133	91519682000	25556	12601	84	0	\N
193118	2133	91518680000	25556	12601	85	0	\N
193119	2133	91517678000	25556	12601	86	0	\N
193120	2133	91516676000	25556	12601	87	0	\N
193020	2133	91470584000	25552	12652	2	0	5210
193027	1397	1286324767000	25555	12653	0	0	15250
193028	1397	1286314766000	25555	12653	1	0	15251
193029	2133	91469582000	25555	12653	2	0	5211
193030	2134	84925080000	25555	12653	3	0	5648
193032	2133	91468580000	25555	12653	5	0	5212
193121	2133	91515674000	25556	12601	88	0	\N
193122	2134	84983254000	25556	12601	89	0	\N
193123	2134	84982251000	25556	12601	90	0	\N
193124	2134	84981248000	25556	12601	91	0	\N
193125	2134	84980245000	25556	12601	92	0	\N
193126	2134	84979242000	25556	12601	93	0	\N
193127	2134	84978239000	25556	12601	95	0	\N
193128	2134	84977236000	25556	12601	96	0	\N
193129	2134	84976233000	25556	12601	97	0	\N
193130	2134	84975230000	25556	12601	98	0	\N
193131	2134	84974227000	25556	12601	99	0	\N
193132	2134	84973224000	25556	12601	100	0	\N
193133	2134	84972221000	25556	12601	101	0	\N
193134	2134	84971218000	25556	12601	102	0	\N
193135	2134	84970215000	25556	12601	103	0	\N
193136	2134	84969212000	25556	12601	104	0	\N
193137	2134	84968209000	25556	12601	105	0	\N
193138	2134	84967206000	25556	12601	106	0	\N
193139	2134	84966203000	25556	12601	107	0	\N
193140	2134	84965200000	25556	12601	108	0	\N
193141	2134	84964197000	25556	12601	109	0	\N
193142	2134	84963194000	25556	12601	110	0	\N
193143	2134	84962191000	25556	12601	111	0	\N
193144	2134	84961188000	25556	12601	112	0	\N
193145	2134	84960185000	25556	12601	113	0	\N
193146	2134	84959182000	25556	12601	114	0	\N
193147	2134	84958179000	25556	12601	115	0	\N
193148	2134	84957176000	25556	12601	116	0	\N
193149	2134	84956173000	25556	12601	117	0	\N
193150	2134	84955170000	25556	12601	118	0	\N
193151	2134	84954167000	25556	12601	119	0	\N
193152	2134	84953164000	25556	12601	120	0	\N
193153	2134	84952161000	25556	12601	121	0	\N
193154	2134	84951158000	25556	12601	122	0	\N
193155	2134	84950155000	25556	12601	123	0	\N
193156	2134	84949152000	25556	12601	124	0	\N
193157	2134	84948149000	25556	12601	125	0	\N
193167	1397	1286274762000	25560	12656	0	0	\N
193168	2133	91464572000	25560	12656	1	0	\N
193169	2134	84920065000	25560	12656	2	0	\N
193170	1397	1286274762000	25561	12656	0	0	\N
193171	2133	91464572000	25561	12656	1	0	\N
193172	2134	84920065000	25561	12656	2	0	\N
193176	1397	1286274762000	25563	12656	0	0	\N
193177	2133	91464572000	25563	12656	1	0	\N
193178	2134	84920065000	25563	12656	2	0	\N
193179	1397	1286274762000	25564	12656	0	0	\N
193180	2133	91464572000	25564	12656	1	0	\N
193181	2134	84920065000	25564	12656	2	0	\N
193191	1397	1286264761000	25566	12657	0	0	\N
193192	1397	1286254760000	25566	12657	1	0	\N
193193	1397	1286244759000	25566	12657	2	0	\N
193194	2133	91463570000	25566	12657	3	0	\N
193195	2133	91462568000	25566	12657	4	0	\N
193196	2133	91461566000	25566	12657	5	0	\N
193197	2134	84919062000	25566	12657	6	0	\N
193198	2134	84918059000	25566	12657	7	0	\N
193199	2134	84917056000	25566	12657	8	0	\N
193200	1397	1286264761000	25567	12657	0	0	\N
193201	1397	1286254760000	25567	12657	1	0	\N
193202	1397	1286244759000	25567	12657	2	0	\N
193203	2133	91463570000	25567	12657	3	0	\N
193204	2133	91462568000	25567	12657	4	0	\N
193205	2133	91461566000	25567	12657	5	0	\N
193206	2134	84919062000	25567	12657	6	0	\N
193207	2134	84918059000	25567	12657	7	0	\N
193208	2134	84917056000	25567	12657	8	0	\N
193221	1397	1286204755000	25571	12660	0	0	\N
193222	1397	1286194754000	25571	12660	1	0	\N
193223	1397	1286184753000	25571	12660	2	0	\N
193224	1397	1286204755000	25572	12660	0	0	\N
193225	1397	1286194754000	25572	12660	1	0	\N
193226	1397	1286184753000	25572	12660	2	0	\N
193227	2134	84913044000	25572	12660	4	0	\N
193228	2134	84912041000	25572	12660	5	0	\N
193229	2133	91457558000	25572	12660	6	0	\N
193230	2133	91456556000	25572	12660	7	0	\N
193231	2134	84911038000	25572	12660	8	0	\N
193232	2133	91455554000	25572	12660	9	0	\N
193233	1397	1286204755000	25573	12660	0	0	\N
193234	1397	1286194754000	25573	12660	1	0	\N
193235	1397	1286184753000	25573	12660	2	0	\N
193236	2134	84913044000	25573	12660	4	0	\N
193237	2134	84912041000	25573	12660	5	0	\N
193238	2133	91457558000	25573	12660	6	0	\N
193239	2133	91456556000	25573	12660	7	0	\N
193240	2134	84911038000	25573	12660	8	0	\N
193241	2133	91455554000	25573	12660	9	0	\N
193242	1397	1286204755000	25574	12660	0	0	\N
193243	1397	1286194754000	25574	12660	1	0	\N
193244	1397	1286184753000	25574	12660	2	0	\N
193245	2134	84913044000	25574	12660	4	0	\N
193246	2134	84912041000	25574	12660	5	0	\N
193247	2133	91457558000	25574	12660	6	0	\N
193248	2133	91456556000	25574	12660	7	0	\N
193249	2134	84911038000	25574	12660	8	0	\N
193250	2133	91455554000	25574	12660	9	0	\N
193251	1397	1286204755000	25575	12660	0	0	\N
193252	1397	1286194754000	25575	12660	1	0	\N
193253	1397	1286184753000	25575	12660	2	0	\N
193254	2134	84913044000	25575	12660	4	0	\N
193255	2134	84912041000	25575	12660	5	0	\N
193256	2133	91457558000	25575	12660	6	0	\N
193160	2133	91467578000	25557	12654	2	0	5213
193161	1397	1286294764000	25558	12655	0	0	15253
193162	1397	1286284763000	25558	12655	1	0	15254
193163	2134	84922071000	25558	12655	2	0	5651
193164	2134	84921068000	25558	12655	3	0	5652
193166	2133	91465574000	25558	12655	5	0	5215
193173	1397	1286274762000	25562	12656	0	0	15255
193174	2133	91464572000	25562	12656	1	0	5216
193175	2134	84920065000	25562	12656	2	0	5653
193182	1397	1286264761000	25565	12657	0	0	15256
193184	1397	1286244759000	25565	12657	2	0	15258
193185	2133	91463570000	25565	12657	3	0	5217
193186	2133	91462568000	25565	12657	4	0	5218
193187	2133	91461566000	25565	12657	5	0	5219
193189	2134	84918059000	25565	12657	7	0	5655
193190	2134	84917056000	25565	12657	8	0	5656
193209	1397	1286234758000	25568	12658	0	0	15259
193210	1397	1286224757000	25568	12658	1	0	15260
193211	2134	84916053000	25568	12658	2	0	5657
193213	2133	91460564000	25568	12658	4	0	5220
193214	2133	91459562000	25568	12658	5	0	5221
193215	1397	1286214756000	25569	12659	0	0	15261
193216	2134	84914047000	25569	12659	1	0	5659
193217	2133	91458560000	25569	12659	2	0	5222
193219	1397	1286194754000	25570	12660	1	0	15263
193220	1397	1286184753000	25570	12660	2	0	15264
193257	2133	91456556000	25575	12660	7	0	\N
193258	2134	84911038000	25575	12660	8	0	\N
193259	2133	91455554000	25575	12660	9	0	\N
193278	1397	1286144749000	25578	12662	0	0	\N
193279	2133	91451546000	25578	12662	1	0	\N
193280	2134	84907026000	25578	12662	2	0	\N
193281	1397	1286144749000	25579	12662	0	0	\N
193282	2133	91451546000	25579	12662	1	0	\N
193283	2134	84907026000	25579	12662	2	0	\N
193284	1397	1286134748000	25581	12663	0	0	\N
193285	2134	84906023000	25581	12663	1	0	\N
193286	2133	91450544000	25581	12663	2	0	\N
193290	2068	942999000000	25586	12591	0	0	\N
193291	2321	654499000000	25586	12591	1	0	\N
193292	2321	654399000000	25586	12591	2	0	\N
193293	1397	1286124747000	25587	12664	0	0	\N
193294	1397	1286114746000	25587	12664	1	0	\N
193295	1397	1286104745000	25587	12664	2	0	\N
193296	1397	1286094744000	25587	12664	3	0	\N
193297	2134	84905020000	25587	12664	4	0	\N
193298	2134	84904017000	25587	12664	5	0	\N
193299	2133	91449542000	25587	12664	6	0	\N
193300	2134	84903014000	25587	12664	7	0	\N
193301	2134	84902011000	25587	12664	8	0	\N
193302	2133	91448540000	25587	12664	9	0	\N
193303	2133	91447538000	25587	12664	10	0	\N
193304	2133	91446536000	25587	12664	11	0	\N
193317	1397	1286084743000	25589	12665	0	0	\N
193318	2133	91445534000	25589	12665	1	0	\N
193319	2134	84901008000	25589	12665	2	0	\N
193329	1397	1286054740000	25593	12668	0	0	\N
193330	2134	84897999000	25593	12668	1	0	\N
193334	1397	1286044739000	25596	12669	0	0	\N
193335	2134	84896996000	25596	12669	1	0	\N
193345	1397	1286034738000	25601	12670	0	0	\N
193346	1397	1286024737000	25601	12670	1	0	\N
193347	2134	84895993000	25601	12670	2	0	\N
193348	2133	91440524000	25601	12670	3	0	\N
193349	2133	91439522000	25601	12670	4	0	\N
193350	2134	84894990000	25601	12670	5	0	\N
193357	1397	1285994734000	25603	12672	0	0	\N
193358	1397	1285984733000	25603	12672	1	0	\N
193359	2134	84891981000	25603	12672	2	0	\N
193360	2134	84890978000	25603	12672	3	0	\N
193361	2133	91436516000	25603	12672	4	0	\N
193362	2133	91435514000	25603	12672	5	0	\N
193363	1397	1285994734000	25604	12672	0	0	\N
193364	1397	1285984733000	25604	12672	1	0	\N
193365	2134	84891981000	25604	12672	2	0	\N
193366	2134	84890978000	25604	12672	3	0	\N
193367	2133	91436516000	25604	12672	4	0	\N
193368	2133	91435514000	25604	12672	5	0	\N
193382	1397	1285964731000	25609	12674	0	0	\N
193383	1397	1285954730000	25609	12674	1	0	\N
193384	2134	84888972000	25609	12674	2	0	\N
193385	2134	84887969000	25609	12674	3	0	\N
193386	2133	91433510000	25609	12674	4	0	\N
193387	2133	91432508000	25609	12674	5	0	\N
193388	1397	1285944729000	25610	12675	0	0	\N
193389	2134	84886966000	25610	12675	1	0	\N
193390	2133	91433510000	25610	12675	2	0	\N
193391	2133	91432508000	25610	12675	3	0	\N
193392	2133	91431506000	25610	12675	4	0	\N
193262	1397	1286154750000	25576	12661	2	0	15267
193263	2134	84913044000	25576	12661	3	0	5660
193264	2134	84912041000	25576	12661	4	0	5661
193265	2133	91457558000	25576	12661	5	0	5223
193266	2133	91456556000	25576	12661	6	0	5224
193268	2133	91455554000	25576	12661	8	0	5225
193269	2133	91454552000	25576	12661	9	0	5226
193270	2133	91453550000	25576	12661	10	0	5227
193271	2133	91452548000	25576	12661	11	0	5228
193272	2134	84910035000	25576	12661	12	0	5663
193274	2134	84908029000	25576	12661	14	0	5665
193275	1397	1286144749000	25577	12662	0	0	15268
193276	2133	91451546000	25577	12662	1	0	5229
193277	2134	84907026000	25577	12662	2	0	5666
193288	2134	84906023000	25583	12663	1	0	5667
193289	2133	91450544000	25583	12663	2	0	5230
193305	1397	1286124747000	25588	12664	0	0	15270
193306	1397	1286114746000	25588	12664	1	0	15271
193307	1397	1286104745000	25588	12664	2	0	15272
193309	2134	84905020000	25588	12664	4	0	5668
193310	2134	84904017000	25588	12664	5	0	5669
193311	2133	91449542000	25588	12664	6	0	5231
193312	2134	84903014000	25588	12664	7	0	5670
193313	2134	84902011000	25588	12664	8	0	5671
193315	2133	91447538000	25588	12664	10	0	5233
193316	2133	91446536000	25588	12664	11	0	5234
193320	1397	1286084743000	25590	12665	0	0	15274
193321	2133	91445534000	25590	12665	1	0	5235
193323	1397	1286074742000	25591	12666	0	0	15275
193324	2134	84900005000	25591	12666	1	0	5673
193325	1397	1286064741000	25592	12667	0	0	15276
193326	2133	91444532000	25592	12667	1	0	5236
193327	2134	84899002000	25592	12667	2	0	5674
193331	1397	1286054740000	25594	12668	0	0	15277
193332	2133	91442528000	25594	12668	1	0	5238
193333	2134	84897999000	25594	12668	2	0	5675
193336	1397	1286044739000	25599	12669	0	0	15278
193337	2134	84896996000	25599	12669	1	0	5676
193339	1397	1286034738000	25600	12670	0	0	15279
193340	1397	1286024737000	25600	12670	1	0	15280
193341	2134	84895993000	25600	12670	2	0	5677
193342	2133	91440524000	25600	12670	3	0	5240
193344	2134	84894990000	25600	12670	5	0	5678
193351	1397	1286014736000	25602	12671	0	0	15281
193352	1397	1286004735000	25602	12671	1	0	15282
193353	2133	91438520000	25602	12671	2	0	5242
193354	2134	84893987000	25602	12671	3	0	5679
193356	2133	91437518000	25602	12671	5	0	5243
193369	1397	1285994734000	25605	12672	0	0	15283
193370	1397	1285984733000	25605	12672	1	0	15284
193371	2134	84891981000	25605	12672	2	0	5681
193372	2134	84890978000	25605	12672	3	0	5682
193374	2133	91435514000	25605	12672	5	0	5245
193375	1397	1285974732000	25606	12673	0	0	15285
193376	2134	84889975000	25606	12673	1	0	5683
193377	2133	91434512000	25606	12673	2	0	5246
193379	1397	1285954730000	25608	12674	1	0	15287
193380	2134	84888972000	25608	12674	2	0	5684
193381	2134	84887969000	25608	12674	3	0	5685
193398	1397	1285934728000	25612	12676	0	0	\N
193399	2133	91430504000	25612	12676	1	0	\N
193400	2134	84885963000	25612	12676	2	0	\N
193404	1397	1285934728000	25614	12676	0	0	\N
193405	2133	91430504000	25614	12676	1	0	\N
193406	2134	84885963000	25614	12676	2	0	\N
193410	1397	1285924727000	25616	12677	0	0	\N
193411	2134	84884960000	25616	12677	1	0	\N
193412	2133	91429502000	25616	12677	2	0	\N
193413	1397	1285924727000	25617	12677	0	0	\N
193414	2134	84884960000	25617	12677	1	0	\N
193415	2133	91429502000	25617	12677	2	0	\N
193416	1397	1285924727000	25618	12677	0	0	\N
193417	2134	84884960000	25618	12677	1	0	\N
193418	2133	91429502000	25618	12677	2	0	\N
193434	1397	1285874722000	25623	12680	0	0	\N
193435	1397	1285864721000	25623	12680	1	0	\N
193436	2134	84879945000	25623	12680	2	0	\N
193437	2133	91424492000	25623	12680	3	0	\N
193438	2133	91423490000	25623	12680	4	0	\N
193439	2134	84878942000	25623	12680	5	0	\N
193440	1397	1285874722000	25624	12681	0	0	\N
193441	1397	1285864721000	25624	12681	1	0	\N
193442	1397	1285854720000	25624	12681	2	0	\N
193443	1397	1285844719000	25624	12681	3	0	\N
193444	2134	84877939000	25624	12681	4	0	\N
193445	2134	84876936000	25624	12681	5	0	\N
193446	2133	91424492000	25624	12681	6	0	\N
193447	2133	91423490000	25624	12681	7	0	\N
193448	2133	91422488000	25624	12681	8	0	\N
193449	2133	91421486000	25624	12681	9	0	\N
193460	1397	1285874722000	25626	12681	0	0	\N
193461	1397	1285864721000	25626	12681	1	0	\N
193462	1397	1285854720000	25626	12681	2	0	\N
193463	1397	1285844719000	25626	12681	3	0	\N
193464	2134	84877939000	25626	12681	4	0	\N
193465	2134	84876936000	25626	12681	5	0	\N
193466	2133	91424492000	25626	12681	6	0	\N
193467	2133	91423490000	25626	12681	7	0	\N
193468	2133	91422488000	25626	12681	8	0	\N
193469	2133	91421486000	25626	12681	9	0	\N
193470	1397	1285874722000	25627	12681	0	0	\N
193471	1397	1285864721000	25627	12681	1	0	\N
193472	1397	1285854720000	25627	12681	2	0	\N
193473	1397	1285844719000	25627	12681	3	0	\N
193474	2134	84877939000	25627	12681	4	0	\N
193475	2134	84876936000	25627	12681	5	0	\N
193476	2133	91424492000	25627	12681	6	0	\N
193477	2133	91423490000	25627	12681	7	0	\N
193478	2133	91422488000	25627	12681	8	0	\N
193479	2133	91421486000	25627	12681	9	0	\N
193494	1397	1285784713000	25631	12685	0	0	\N
193495	1397	1285774712000	25631	12685	1	0	\N
193496	2134	84871921000	25631	12685	2	0	\N
193497	2133	91415474000	25631	12685	3	0	\N
193498	2133	91414472000	25631	12685	4	0	\N
193499	2134	84870918000	25631	12685	5	0	\N
193512	1397	1285744709000	25634	12687	0	0	\N
193513	1397	1285734708000	25634	12687	1	0	\N
193514	1397	1285724707000	25634	12687	2	0	\N
193515	1397	1285714706000	25634	12687	3	0	\N
193516	2133	91411466000	25634	12687	4	0	\N
193517	2134	84867909000	25634	12687	5	0	\N
193518	2133	91410464000	25634	12687	6	0	\N
193519	2134	84866906000	25634	12687	7	0	\N
193520	2134	84865903000	25634	12687	8	0	\N
193521	2133	91409462000	25634	12687	9	0	\N
193522	2133	91408460000	25634	12687	10	0	\N
193523	2134	84864900000	25634	12687	11	0	\N
193395	2133	91433510000	25611	12675	2	0	5247
193396	2133	91432508000	25611	12675	3	0	5248
193397	2133	91431506000	25611	12675	4	0	5249
193401	1397	1285934728000	25613	12676	0	0	15289
193402	2133	91430504000	25613	12676	1	0	5250
193407	1397	1285924727000	25615	12677	0	0	15290
193408	2134	84884960000	25615	12677	1	0	5688
193409	2133	91429502000	25615	12677	2	0	5251
193419	1397	1285914726000	25619	12678	0	0	15291
193420	1397	1285904725000	25619	12678	1	0	15292
193422	2134	84883957000	25619	12678	3	0	5689
193423	2134	84882954000	25619	12678	4	0	5690
193424	2133	91428500000	25619	12678	5	0	5252
193425	2133	91427498000	25619	12678	6	0	5253
193427	1397	1285884723000	25621	12679	1	0	15294
193428	2133	91426496000	25621	12679	2	0	5254
193429	2133	91425494000	25621	12679	3	0	5255
193430	2134	84881951000	25621	12679	4	0	5691
193431	2134	84880948000	25621	12679	5	0	5692
193433	2134	84878942000	25622	12680	1	0	5694
193450	1397	1285874722000	25625	12681	0	0	15295
193451	1397	1285864721000	25625	12681	1	0	15296
193452	1397	1285854720000	25625	12681	2	0	15297
193453	1397	1285844719000	25625	12681	3	0	15298
193455	2134	84876936000	25625	12681	5	0	5696
193456	2133	91424492000	25625	12681	6	0	5256
193457	2133	91423490000	25625	12681	7	0	5257
193458	2133	91422488000	25625	12681	8	0	5258
193480	1397	1285834718000	25628	12682	0	0	15299
193481	1397	1285824717000	25628	12682	1	0	15300
193482	2134	84875933000	25628	12682	2	0	5697
193483	2134	84874930000	25628	12682	3	0	5698
193484	2133	91420484000	25628	12682	4	0	5260
193486	1397	1285814716000	25629	12683	0	0	15301
193487	1397	1285804715000	25629	12683	1	0	15302
193488	2133	91418480000	25629	12683	2	0	5262
193489	2134	84873927000	25629	12683	3	0	5699
193490	2133	91417478000	25629	12683	4	0	5263
193492	2133	91416476000	25630	12684	1	0	5264
193493	2134	84872924000	25630	12684	2	0	5700
193500	1397	1285784713000	25632	12685	0	0	15304
193501	1397	1285774712000	25632	12685	1	0	15305
193503	2133	91415474000	25632	12685	3	0	5265
193504	2133	91414472000	25632	12685	4	0	5266
193505	2134	84870918000	25632	12685	5	0	5702
193506	1397	1285764711000	25633	12686	0	0	15306
193507	1397	1285754710000	25633	12686	1	0	15307
193509	2134	84868912000	25633	12686	3	0	5704
193510	2133	91413470000	25633	12686	4	0	5267
193511	2133	91412468000	25633	12686	5	0	5268
193524	1397	1285744709000	25635	12687	0	0	15308
193525	1397	1285734708000	25635	12687	1	0	15309
193527	1397	1285714706000	25635	12687	3	0	15311
193528	2133	91411466000	25635	12687	4	0	5269
193536	1397	1285704705000	25636	12688	0	0	\N
193537	2134	84863897000	25636	12688	1	0	\N
193538	2133	91407458000	25636	12688	2	0	\N
193539	1397	1285704705000	25637	12688	0	0	\N
193540	2134	84863897000	25637	12688	1	0	\N
193541	2133	91407458000	25637	12688	2	0	\N
193548	1397	1285684703000	25640	12690	0	0	\N
193549	2134	84861891000	25640	12690	1	0	\N
193550	2133	91405454000	25640	12690	2	0	\N
193554	1397	1285684703000	25642	12690	0	0	\N
193555	2134	84861891000	25642	12690	1	0	\N
193556	2133	91405454000	25642	12690	2	0	\N
193557	1397	1286334768000	25643	12633	0	0	\N
193558	1397	1286324767000	25643	12633	1	0	\N
193559	1397	1286314766000	25643	12633	2	0	\N
193560	1397	1286304765000	25643	12633	3	0	\N
193561	1397	1286294764000	25643	12633	4	0	\N
193562	1397	1286284763000	25643	12633	5	0	\N
193563	1397	1286274762000	25643	12633	6	0	\N
193564	1397	1286264761000	25643	12633	7	0	\N
193565	1397	1286254760000	25643	12633	8	0	\N
193566	1397	1286244759000	25643	12633	9	0	\N
193567	1397	1286234758000	25643	12633	10	0	\N
193568	1397	1286224757000	25643	12633	11	0	\N
193569	1397	1286214756000	25643	12633	12	0	\N
193570	1397	1286204755000	25643	12633	13	0	\N
193571	1397	1286194754000	25643	12633	14	0	\N
193572	1397	1286184753000	25643	12633	15	0	\N
193573	1397	1286174752000	25643	12633	16	0	\N
193574	1397	1286164751000	25643	12633	17	0	\N
193575	1397	1286154750000	25643	12633	18	0	\N
193576	1397	1286144749000	25643	12633	19	0	\N
193577	1397	1286134748000	25643	12633	20	0	\N
193578	1397	1286124747000	25643	12633	21	0	\N
193579	1397	1286114746000	25643	12633	22	0	\N
193580	1397	1286104745000	25643	12633	23	0	\N
193581	1397	1286094744000	25643	12633	24	0	\N
193582	1397	1286084743000	25643	12633	25	0	\N
193583	1397	1286074742000	25643	12633	26	0	\N
193584	1397	1286064741000	25643	12633	27	0	\N
193585	1397	1286054740000	25643	12633	28	0	\N
193586	1397	1286044739000	25643	12633	29	0	\N
193587	1397	1286034738000	25643	12633	30	0	\N
193588	1397	1286024737000	25643	12633	31	0	\N
193589	1397	1286014736000	25643	12633	32	0	\N
193590	1397	1286004735000	25643	12633	33	0	\N
193591	1397	1285994734000	25643	12633	34	0	\N
193592	1397	1285984733000	25643	12633	35	0	\N
193593	1397	1285974732000	25643	12633	36	0	\N
193594	1397	1285964731000	25643	12633	37	0	\N
193595	1397	1285954730000	25643	12633	38	0	\N
193596	1397	1285944729000	25643	12633	39	0	\N
193597	1397	1285934728000	25643	12633	40	0	\N
193598	1397	1285924727000	25643	12633	41	0	\N
193599	1397	1285914726000	25643	12633	42	0	\N
193600	1397	1285904725000	25643	12633	43	0	\N
193601	1397	1285894724000	25643	12633	44	0	\N
193602	1397	1285884723000	25643	12633	45	0	\N
193603	1397	1285874722000	25643	12633	46	0	\N
193604	1397	1285864721000	25643	12633	47	0	\N
193605	1397	1285854720000	25643	12633	48	0	\N
193606	1397	1285844719000	25643	12633	49	0	\N
193607	1397	1285834718000	25643	12633	50	0	\N
193608	1397	1285824717000	25643	12633	51	0	\N
193609	1397	1285814716000	25643	12633	52	0	\N
193610	1397	1285804715000	25643	12633	53	0	\N
193611	1397	1285794714000	25643	12633	54	0	\N
193612	1397	1285784713000	25643	12633	55	0	\N
193613	1397	1285774712000	25643	12633	56	0	\N
193614	1397	1285764711000	25643	12633	57	0	\N
193615	1397	1285754710000	25643	12633	58	0	\N
193616	1397	1285744709000	25643	12633	59	0	\N
193617	1397	1285734708000	25643	12633	60	0	\N
193618	1397	1285724707000	25643	12633	61	0	\N
193619	1397	1285714706000	25643	12633	62	0	\N
193620	1397	1285704705000	25643	12633	63	0	\N
193621	1397	1285694704000	25643	12633	64	0	\N
193622	1397	1285684703000	25643	12633	65	0	\N
193623	1159	615190749000000	25643	12633	66	0	\N
193624	2134	84926083000	25643	12633	67	0	\N
193625	2134	84925080000	25643	12633	68	0	\N
193626	2134	84924077000	25643	12633	69	0	\N
193627	2134	84923074000	25643	12633	70	0	\N
193628	2134	84922071000	25643	12633	71	0	\N
193629	2134	84921068000	25643	12633	72	0	\N
193630	2133	91470584000	25643	12633	73	0	\N
193631	2133	91469582000	25643	12633	74	0	\N
193632	2134	84920065000	25643	12633	75	0	\N
193633	2134	84919062000	25643	12633	76	0	\N
193634	2134	84918059000	25643	12633	77	0	\N
193635	2133	91468580000	25643	12633	78	0	\N
193636	2133	91467578000	25643	12633	79	0	\N
193637	2133	91466576000	25643	12633	80	0	\N
193638	2133	91465574000	25643	12633	81	0	\N
193639	2133	91464572000	25643	12633	82	0	\N
193640	2133	91463570000	25643	12633	83	0	\N
193641	2133	91462568000	25643	12633	84	0	\N
193642	2133	91461566000	25643	12633	85	0	\N
193643	2133	91460564000	25643	12633	86	0	\N
193644	2134	84917056000	25643	12633	87	0	\N
193645	2134	84916053000	25643	12633	88	0	\N
193646	2134	84915050000	25643	12633	89	0	\N
193647	2134	84914047000	25643	12633	90	0	\N
193648	2134	84913044000	25643	12633	91	0	\N
193649	2134	84912041000	25643	12633	92	0	\N
193650	2134	84911038000	25643	12633	93	0	\N
193651	2133	91459562000	25643	12633	94	0	\N
193652	2133	91458560000	25643	12633	95	0	\N
193653	2133	91457558000	25643	12633	97	0	\N
193654	2133	91456556000	25643	12633	98	0	\N
193655	2133	91455554000	25643	12633	99	0	\N
193656	2133	91454552000	25643	12633	100	0	\N
193657	2133	91453550000	25643	12633	101	0	\N
193658	2133	91452548000	25643	12633	102	0	\N
193659	2133	91451546000	25643	12633	103	0	\N
193660	2133	91450544000	25643	12633	104	0	\N
193661	2133	91449542000	25643	12633	105	0	\N
193662	2133	91448540000	25643	12633	106	0	\N
193663	2133	91447538000	25643	12633	107	0	\N
193664	2133	91446536000	25643	12633	108	0	\N
193531	2134	84866906000	25635	12687	7	0	5706
193532	2134	84865903000	25635	12687	8	0	5707
193533	2133	91409462000	25635	12687	9	0	5271
193534	2133	91408460000	25635	12687	10	0	5272
193535	2134	84864900000	25635	12687	11	0	5708
193543	2134	84863897000	25638	12688	1	0	5709
193544	2133	91407458000	25638	12688	2	0	5273
193545	1397	1285694704000	25639	12689	0	0	15313
193546	2134	84862894000	25639	12689	1	0	5710
193547	2133	91406456000	25639	12689	2	0	5274
193552	2134	84861891000	25641	12690	1	0	5711
193553	2133	91405454000	25641	12690	2	0	5275
193665	2133	91445534000	25643	12633	109	0	\N
193666	2133	91444532000	25643	12633	110	0	\N
193667	2133	91443530000	25643	12633	111	0	\N
193668	2133	91442528000	25643	12633	112	0	\N
193669	2133	91441526000	25643	12633	113	0	\N
193670	2133	91440524000	25643	12633	114	0	\N
193671	2133	91439522000	25643	12633	115	0	\N
193672	2133	91438520000	25643	12633	116	0	\N
193673	2133	91437518000	25643	12633	117	0	\N
193674	2133	91436516000	25643	12633	118	0	\N
193675	2133	91435514000	25643	12633	119	0	\N
193676	2133	91434512000	25643	12633	120	0	\N
193677	2133	91433510000	25643	12633	121	0	\N
193678	2133	91432508000	25643	12633	122	0	\N
193679	1397	1285674702000	25644	12691	0	0	\N
193680	1397	1285664701000	25644	12691	1	0	\N
193681	2133	91404452000	25644	12691	2	0	\N
193682	2134	84860888000	25644	12691	3	0	\N
193683	2134	84859885000	25644	12691	4	0	\N
193684	2133	91403450000	25644	12691	5	0	\N
193700	1397	1285634698000	25648	12693	0	0	\N
193701	2134	84856876000	25648	12693	1	0	\N
193702	2133	91400444000	25648	12693	2	0	\N
193703	1397	1285634698000	25649	12693	0	0	\N
193704	2134	84856876000	25649	12693	1	0	\N
193705	2133	91400444000	25649	12693	2	0	\N
193706	1397	1285624697000	25650	12694	0	0	\N
193707	2133	91399442000	25650	12694	1	0	\N
193708	2232	1199000000	25650	12694	2	0	\N
193709	2134	84855873000	25650	12694	3	0	\N
193710	1397	1285624697000	25651	12694	0	0	\N
193711	2232	1199000000	25651	12694	1	0	\N
193712	2134	84855873000	25651	12694	2	0	\N
193717	2134	84854870000	25653	12695	0	0	\N
193723	1397	1285604695000	25656	12697	0	0	\N
193724	1397	1285594694000	25656	12697	1	0	\N
193725	2134	84852864000	25656	12697	3	0	\N
193726	2133	91396436000	25656	12697	4	0	\N
193727	2133	91395434000	25656	12697	5	0	\N
193728	2134	84851861000	25656	12697	6	0	\N
193729	1397	1285604695000	25657	12697	0	0	\N
193730	1397	1285594694000	25657	12697	1	0	\N
193731	2134	84852864000	25657	12697	3	0	\N
193732	2133	91396436000	25657	12697	4	0	\N
193733	2133	91395434000	25657	12697	5	0	\N
193734	2134	84851861000	25657	12697	6	0	\N
193766	1397	1285504685000	25662	12701	0	0	\N
193767	2134	84842834000	25662	12701	1	0	\N
193768	2133	91386416000	25662	12701	2	0	\N
193769	1397	1285504685000	25663	12701	0	0	\N
193770	2134	84842834000	25663	12701	1	0	\N
193774	1397	1285494684000	25665	12702	0	0	\N
193775	2134	84841831000	25665	12702	1	0	\N
193779	1397	1285484683000	25667	12703	0	0	\N
193780	2134	84840828000	25667	12703	1	0	\N
193781	2133	91384412000	25667	12703	2	0	\N
193782	1397	1285484683000	25668	12703	0	0	\N
193783	2134	84840828000	25668	12703	1	0	\N
193784	2133	91384412000	25668	12703	2	0	\N
193791	1397	1285464681000	25671	12705	0	0	\N
193792	2134	84838822000	25671	12705	1	0	\N
193793	2133	91382408000	25671	12705	2	0	\N
193794	1397	1285464681000	25672	12705	0	0	\N
193795	2134	84838822000	25672	12705	1	0	\N
193799	1397	1285454680000	25674	12706	0	0	\N
193800	2134	84837819000	25674	12706	1	0	\N
193687	2133	91404452000	25645	12691	2	0	5276
193688	2134	84860888000	25645	12691	3	0	5712
193689	2134	84859885000	25645	12691	4	0	5713
193690	2133	91403450000	25645	12691	5	0	5277
193691	1397	1285654700000	25646	12692	0	0	15317
193693	2134	84858882000	25646	12692	2	0	5714
193694	2134	84857879000	25646	12692	3	0	5715
193695	2133	91402448000	25646	12692	4	0	5278
193696	2133	91401446000	25646	12692	5	0	5279
193697	1397	1285634698000	25647	12693	0	0	15319
193699	2133	91400444000	25647	12693	2	0	5280
193713	1397	1285624697000	25652	12694	0	0	15320
193714	2133	91399442000	25652	12694	1	0	5281
193715	2232	1199000000	25652	12694	2	0	1
193718	2134	84854870000	25654	12695	0	0	5718
193719	2133	91398440000	25654	12695	1	0	5282
193720	1397	1285614696000	25655	12696	0	0	15321
193721	2134	84853867000	25655	12696	1	0	5719
193722	2133	91397438000	25655	12696	2	0	5283
193736	1397	1285594694000	25658	12697	1	0	15323
193737	2134	84852864000	25658	12697	3	0	5720
193738	2133	91396436000	25658	12697	4	0	5284
193739	2133	91395434000	25658	12697	5	0	5285
193740	2134	84851861000	25658	12697	6	0	5721
193742	1397	1285574692000	25659	12698	1	0	15325
193743	2133	91394432000	25659	12698	2	0	5286
193744	2324	19000000	25659	12698	3	0	1
193745	2134	84850858000	25659	12698	4	0	5722
193747	2133	91393430000	25659	12698	6	0	5287
193748	1397	1285564691000	25660	12699	0	0	15326
193749	1397	1285554690000	25660	12699	1	0	15327
193750	1397	1285544689000	25660	12699	2	0	15328
193751	1397	1285534688000	25660	12699	3	0	15329
193753	2134	84847849000	25660	12699	5	0	5725
193754	2134	84846846000	25660	12699	6	0	5726
193755	2133	91392428000	25660	12699	7	0	5288
193756	2133	91391426000	25660	12699	8	0	5289
193757	2134	84845843000	25660	12699	9	0	5727
193759	2133	91389422000	25660	12699	11	0	5291
193760	1397	1285524687000	25661	12700	0	0	15330
193761	1397	1285514686000	25661	12700	1	0	15331
193762	2133	91388420000	25661	12700	2	0	5292
193764	2134	84843837000	25661	12700	4	0	5729
193765	2133	91387418000	25661	12700	5	0	5293
193771	1397	1285504685000	25664	12701	0	0	15332
193772	2134	84842834000	25664	12701	1	0	5730
193773	2133	91386416000	25664	12701	2	0	5294
193777	2133	91385414000	25666	12702	1	0	5295
193778	2134	84841831000	25666	12702	2	0	5731
193785	1397	1285484683000	25669	12703	0	0	15334
193786	2134	84840828000	25669	12703	1	0	5732
193787	2133	91384412000	25669	12703	2	0	5296
193789	2134	84839825000	25670	12704	1	0	5733
193790	2133	91383410000	25670	12704	2	0	5297
193796	1397	1285464681000	25673	12705	0	0	15336
193797	2134	84838822000	25673	12705	1	0	5734
193801	2133	91381406000	25674	12706	2	0	\N
193802	1397	1285454680000	25675	12706	0	0	\N
193803	2134	84837819000	25675	12706	1	0	\N
193804	2133	91381406000	25675	12706	2	0	\N
193807	1397	1285454680000	25677	12706	0	0	\N
193808	2134	84837819000	25677	12706	1	0	\N
193809	2133	91381406000	25677	12706	2	0	\N
193810	1397	1285454680000	25678	12706	0	0	\N
193811	2134	84837819000	25678	12706	1	0	\N
193812	2133	91382408000	25678	12706	2	0	\N
193813	2133	91381406000	25678	12706	3	0	\N
193814	1397	1285444679000	25679	12707	0	0	\N
193815	1397	1285434678000	25679	12707	1	0	\N
193816	1397	1285424677000	25679	12707	2	0	\N
193817	2134	84836816000	25679	12707	3	0	\N
193818	2134	84835813000	25679	12707	4	0	\N
193819	2134	84834810000	25679	12707	5	0	\N
193820	1397	1285444679000	25680	12707	0	0	\N
193821	1397	1285434678000	25680	12707	1	0	\N
193822	1397	1285424677000	25680	12707	2	0	\N
193823	2134	84836816000	25680	12707	3	0	\N
193824	2134	84835813000	25680	12707	4	0	\N
193825	2134	84834810000	25680	12707	5	0	\N
193826	1397	1285444679000	25681	12707	0	0	\N
193827	1397	1285434678000	25681	12707	1	0	\N
193828	1397	1285424677000	25681	12707	2	0	\N
193829	2133	91381406000	25681	12707	3	0	\N
193830	2133	91380404000	25681	12707	4	0	\N
193831	2133	91379402000	25681	12707	5	0	\N
193832	2133	91378400000	25681	12707	6	0	\N
193833	2134	84836816000	25681	12707	7	0	\N
193834	2134	84835813000	25681	12707	8	0	\N
193835	2134	84834810000	25681	12707	9	0	\N
193836	1397	1285444679000	25682	12707	0	0	\N
193837	1397	1285434678000	25682	12707	1	0	\N
193838	1397	1285424677000	25682	12707	2	0	\N
193839	2133	91381406000	25682	12707	3	0	\N
193840	2133	91380404000	25682	12707	4	0	\N
193841	2133	91379402000	25682	12707	5	0	\N
193842	2133	91378400000	25682	12707	6	0	\N
193843	2134	84836816000	25682	12707	7	0	\N
193844	2134	84835813000	25682	12707	8	0	\N
193845	2134	84834810000	25682	12707	9	0	\N
193859	1397	1285404675000	25685	12709	0	0	\N
193860	1397	1285394674000	25685	12709	1	0	\N
193861	2134	84832804000	25685	12709	2	0	\N
193862	2133	91376396000	25685	12709	3	0	\N
193863	2134	84831801000	25685	12709	4	0	\N
193864	2133	91375394000	25685	12709	5	0	\N
193871	1397	1285404675000	25687	12709	0	0	\N
193872	1397	1285394674000	25687	12709	1	0	\N
193873	2134	84832804000	25687	12709	2	0	\N
193874	2133	91376396000	25687	12709	3	0	\N
193875	2134	84831801000	25687	12709	4	0	\N
193876	2133	91375394000	25687	12709	5	0	\N
193882	1397	1285374672000	25690	12711	0	0	\N
193883	2134	84830798000	25690	12711	1	0	\N
193884	2133	91373390000	25690	12711	2	0	\N
193901	1397	1285314666000	25693	12714	0	0	\N
193902	2134	84824780000	25693	12714	1	0	\N
193903	2133	91367378000	25693	12714	2	0	\N
193904	1397	1285314666000	25694	12714	0	0	\N
193905	2134	84824780000	25694	12714	1	0	\N
193906	2133	91367378000	25694	12714	2	0	\N
193910	222	66058279919853	25696	12480	0	0	\N
193911	1397	1285304665000	25697	12715	0	0	\N
193912	2133	91366376000	25697	12715	2	0	\N
193913	2134	84823777000	25697	12715	3	0	\N
193917	1397	1285294664000	25699	12716	0	0	\N
193918	2133	91365374000	25699	12716	1	0	\N
193919	2134	84822774000	25699	12716	2	0	\N
193920	1397	1285294664000	25700	12716	0	0	\N
193921	2133	91365374000	25700	12716	1	0	\N
193922	2134	84822774000	25700	12716	2	0	\N
193925	1397	1285284663000	25702	12717	0	0	\N
193926	2133	91365374000	25702	12717	1	0	\N
193927	2133	91364372000	25702	12717	2	0	\N
193928	2134	84821771000	25702	12717	3	0	\N
193929	1159	615190749000000	25703	12668	0	0	\N
193930	1624	1001000000	25703	12668	1	0	\N
193935	1397	1285274662000	25705	12718	0	0	\N
193936	2134	84820768000	25705	12718	1	0	\N
193846	1397	1285444679000	25683	12707	0	0	15338
193847	1397	1285434678000	25683	12707	1	0	15339
193848	1397	1285424677000	25683	12707	2	0	15340
193849	2133	91381406000	25683	12707	3	0	5299
193850	2133	91380404000	25683	12707	4	0	5300
193852	2133	91378400000	25683	12707	6	0	5302
193853	2134	84836816000	25683	12707	7	0	5736
193854	2134	84835813000	25683	12707	8	0	5737
193855	2134	84834810000	25683	12707	9	0	5738
193856	1397	1285414676000	25684	12708	0	0	15341
193858	2134	84833807000	25684	12708	2	0	5739
193865	1397	1285404675000	25686	12709	0	0	15342
193866	1397	1285394674000	25686	12709	1	0	15343
193867	2134	84832804000	25686	12709	2	0	5740
193869	2134	84831801000	25686	12709	4	0	5741
193870	2133	91375394000	25686	12709	5	0	5305
193877	1397	1285384673000	25688	12710	0	0	15344
193878	2133	91374392000	25688	12710	1	0	5306
193879	1397	1285374672000	25689	12711	0	0	15345
193881	2133	91373390000	25689	12711	2	0	5307
193885	1397	1285364671000	25691	12712	0	0	15346
193886	1397	1285354670000	25691	12712	1	0	15347
193887	2134	84829795000	25691	12712	2	0	5743
193888	2133	91372388000	25691	12712	3	0	5308
193890	2134	84828792000	25691	12712	5	0	5744
193891	1397	1285344669000	25692	12713	0	0	15348
193892	1397	1285334668000	25692	12713	1	0	15349
193893	1397	1285324667000	25692	12713	2	0	15350
193895	2133	91370384000	25692	12713	4	0	5310
193896	2133	91369382000	25692	12713	5	0	5311
193897	2133	91368380000	25692	12713	6	0	5312
193898	1624	1001000000	25692	12713	7	0	2
193899	2134	84826786000	25692	12713	8	0	5746
193907	1397	1285314666000	25695	12714	0	0	15351
193908	2134	84824780000	25695	12714	1	0	5748
193909	2133	91367378000	25695	12714	2	0	5313
193914	1397	1285304665000	25698	12715	0	0	15352
193915	2133	91366376000	25698	12715	2	0	5314
193923	1397	1285294664000	25701	12716	0	0	15353
193924	2134	84822774000	25701	12716	1	0	5750
193931	1397	1285284663000	25704	12717	0	0	15354
193932	2133	91365374000	25704	12717	1	0	5315
193934	2134	84821771000	25704	12717	3	0	5751
193937	2133	91363370000	25705	12718	2	0	\N
193938	1397	1285274662000	25706	12718	0	0	\N
193939	2134	84820768000	25706	12718	1	0	\N
193940	2133	91363370000	25706	12718	2	0	\N
193944	1397	1285274662000	25708	12718	0	0	\N
193945	2134	84820768000	25708	12718	1	0	\N
193946	2133	91363370000	25708	12718	2	0	\N
193954	1397	1285264661000	25710	12719	0	0	\N
193955	1397	1285254660000	25710	12719	1	0	\N
193956	2134	84819765000	25710	12719	2	0	\N
193957	2133	91362368000	25710	12719	3	0	\N
193958	2133	91361366000	25710	12719	4	0	\N
193959	2134	84818762000	25710	12719	5	0	\N
193960	2134	84817759000	25710	12719	6	0	\N
193961	1397	1285264661000	25711	12719	0	0	\N
193962	1397	1285254660000	25711	12719	1	0	\N
193963	2134	84819765000	25711	12719	2	0	\N
193964	2133	91362368000	25711	12719	3	0	\N
193965	2133	91361366000	25711	12719	4	0	\N
193966	2134	84818762000	25711	12719	5	0	\N
193967	2134	84817759000	25711	12719	6	0	\N
193968	1397	1285244659000	25712	12720	0	0	\N
193969	1397	1285234658000	25712	12720	1	0	\N
193970	1397	1285224657000	25712	12720	2	0	\N
193971	2133	91360364000	25712	12720	3	0	\N
193972	2133	91359362000	25712	12720	4	0	\N
193973	2133	91358360000	25712	12720	5	0	\N
193974	1397	1285244659000	25713	12720	0	0	\N
193975	1397	1285234658000	25713	12720	1	0	\N
193976	1397	1285224657000	25713	12720	2	0	\N
193977	2133	91360364000	25713	12720	3	0	\N
193978	2134	84816756000	25713	12720	4	0	\N
193979	2134	84815753000	25713	12720	5	0	\N
193980	2134	84814750000	25713	12720	6	0	\N
193981	2133	91359362000	25713	12720	7	0	\N
193982	2133	91358360000	25713	12720	8	0	\N
193992	1397	1285244659000	25715	12720	0	0	\N
193993	1397	1285234658000	25715	12720	1	0	\N
193994	1397	1285224657000	25715	12720	2	0	\N
193995	2133	91360364000	25715	12720	3	0	\N
193996	2134	84816756000	25715	12720	4	0	\N
193997	2134	84815753000	25715	12720	5	0	\N
193998	2134	84814750000	25715	12720	6	0	\N
193999	2133	91359362000	25715	12720	7	0	\N
194000	2133	91358360000	25715	12720	8	0	\N
194004	1397	1285214656000	25717	12721	0	0	\N
194005	2134	84813747000	25717	12721	1	0	\N
194006	2133	91357358000	25717	12721	2	0	\N
194010	1397	1285204655000	25719	12722	0	0	\N
194011	2134	84812744000	25719	12722	1	0	\N
194012	2133	91356356000	25719	12722	2	0	\N
194019	1397	1285174652000	25722	12725	0	0	\N
194020	1397	1285164651000	25722	12725	1	0	\N
194021	2134	84809735000	25722	12725	2	0	\N
194022	2134	84808732000	25722	12725	3	0	\N
194023	2133	91353350000	25722	12725	4	0	\N
194024	2133	91352348000	25722	12725	5	0	\N
194043	1397	1285114646000	25727	12729	0	0	\N
194044	2133	91347338000	25727	12729	1	0	\N
194045	2134	84803717000	25727	12729	2	0	\N
194058	1397	1285074642000	25730	12731	0	0	\N
194059	2134	84799705000	25730	12731	1	0	\N
194060	2133	91343330000	25730	12731	2	0	\N
194061	1397	1285074642000	25731	12731	0	0	\N
194062	2134	84799705000	25731	12731	1	0	\N
194063	2133	91343330000	25731	12731	2	0	\N
193943	2133	91363370000	25707	12718	2	0	5317
193947	1397	1285264661000	25709	12719	0	0	15356
193948	1397	1285254660000	25709	12719	1	0	15357
193949	2134	84819765000	25709	12719	2	0	5753
193950	2133	91362368000	25709	12719	3	0	5318
193952	2134	84818762000	25709	12719	5	0	5754
193953	2134	84817759000	25709	12719	6	0	5755
193983	1397	1285244659000	25714	12720	0	0	15358
193984	1397	1285234658000	25714	12720	1	0	15359
193985	1397	1285224657000	25714	12720	2	0	15360
193987	2134	84816756000	25714	12720	4	0	5756
193988	2134	84815753000	25714	12720	5	0	5757
193989	2134	84814750000	25714	12720	6	0	5758
193990	2133	91359362000	25714	12720	7	0	5321
194001	1397	1285214656000	25716	12721	0	0	15361
194002	2134	84813747000	25716	12721	1	0	5759
194003	2133	91357358000	25716	12721	2	0	5323
194007	1397	1285204655000	25718	12722	0	0	15362
194008	2134	84812744000	25718	12722	1	0	5760
194013	1397	1285194654000	25720	12723	0	0	15363
194014	2133	91355354000	25720	12723	1	0	5325
194015	2134	84811741000	25720	12723	2	0	5761
194016	1397	1285184653000	25721	12724	0	0	15364
194017	2133	91354352000	25721	12724	1	0	5326
194025	1397	1285174652000	25723	12725	0	0	15365
194026	1397	1285164651000	25723	12725	1	0	15366
194027	2134	84809735000	25723	12725	2	0	5763
194028	2134	84808732000	25723	12725	3	0	5764
194030	2133	91352348000	25723	12725	5	0	5328
194031	1397	1285154650000	25724	12726	0	0	15367
194032	2133	91351346000	25724	12726	1	0	5329
194033	2134	84807729000	25724	12726	2	0	5765
194034	1397	1285144649000	25725	12727	0	0	15368
194036	2133	91350344000	25725	12727	2	0	5330
194037	1397	1285134648000	25726	12728	0	0	15369
194038	1397	1285124647000	25726	12728	1	0	15370
194039	2133	91349342000	25726	12728	2	0	5331
194040	2133	91348340000	25726	12728	3	0	5332
194042	2134	84804720000	25726	12728	5	0	5768
194046	1397	1285114646000	25728	12729	0	0	15371
194047	2133	91347338000	25728	12729	1	0	5333
194048	2134	84803717000	25728	12729	2	0	5769
194050	1397	1285094644000	25729	12730	1	0	15373
194051	1397	1285084643000	25729	12730	2	0	15374
194052	2133	91346336000	25729	12730	3	0	5334
194053	2133	91345334000	25729	12730	4	0	5335
194054	2134	84802714000	25729	12730	5	0	5770
194056	2134	84800708000	25729	12730	7	0	5772
194057	2133	91344332000	25729	12730	8	0	5336
194064	1397	1285074642000	25732	12731	0	0	15375
194065	2134	84799705000	25732	12731	1	0	5773
194066	2133	91343330000	25732	12731	2	0	5337
194068	2134	84798702000	25733	12732	1	0	5774
194069	2133	91342328000	25733	12732	2	0	5338
194070	1397	1285054640000	25734	12733	0	0	15377
194071	1397	1285044639000	25734	12733	1	0	15378
194076	1397	1285054640000	25735	12733	0	0	\N
194077	1397	1285044639000	25735	12733	1	0	\N
194078	2133	91341326000	25735	12733	2	0	\N
194079	2133	91340324000	25735	12733	3	0	\N
194080	2134	84797699000	25735	12733	4	0	\N
194081	2134	84796696000	25735	12733	5	0	\N
194082	1397	1285054640000	25736	12733	0	0	\N
194083	1397	1285044639000	25736	12733	1	0	\N
194084	2133	91341326000	25736	12733	2	0	\N
194085	2133	91340324000	25736	12733	3	0	\N
194086	2134	84797699000	25736	12733	4	0	\N
194087	2134	84796696000	25736	12733	5	0	\N
194088	1397	1285034638000	25737	12734	0	0	\N
194089	2134	84795693000	25737	12734	1	0	\N
194090	2133	91339322000	25737	12734	2	0	\N
194091	1769	1571700000	25737	12734	3	0	\N
194092	1769	1570700000	25737	12734	4	0	\N
194093	1397	1285034638000	25738	12734	0	0	\N
194094	2134	84795693000	25738	12734	1	0	\N
194095	2133	91339322000	25738	12734	2	0	\N
194096	1769	1571700000	25738	12734	3	0	\N
194097	1769	1570700000	25738	12734	4	0	\N
194098	2134	84795693000	25739	12734	0	0	\N
194099	1769	1571700000	25739	12734	1	0	\N
194100	1769	1570700000	25739	12734	2	0	\N
194106	1397	1285034638000	25741	12734	0	0	\N
194107	2134	84795693000	25741	12734	1	0	\N
194108	2133	91339322000	25741	12734	2	0	\N
194109	1769	1571700000	25741	12734	3	0	\N
194110	1769	1570700000	25741	12734	4	0	\N
194111	1159	615190749000000	25742	12584	0	0	\N
194112	1769	1571700000	25742	12584	1	0	\N
194113	1769	1570700000	25742	12584	2	0	\N
194114	1624	1001000000	25742	12584	3	0	\N
194116	1397	1285024637000	25744	12735	0	0	\N
194117	2133	91338320000	25744	12735	2	0	\N
194118	2134	84794690000	25744	12735	3	0	\N
194119	1397	1285024637000	25745	12735	0	0	\N
194120	2133	91338320000	25745	12735	2	0	\N
194121	2134	84794690000	25745	12735	3	0	\N
194122	1159	615190749000000	25746	12610	0	0	\N
194123	1769	1571700000	25746	12610	1	0	\N
194124	1769	1570700000	25746	12610	2	0	\N
194125	1624	1001000000	25746	12610	3	0	\N
194126	1397	1285024637000	25747	12736	0	0	\N
194127	1397	1285014636000	25747	12736	1	0	\N
194128	2133	91338320000	25747	12736	2	0	\N
194129	2133	91337318000	25747	12736	3	0	\N
194130	2134	84793687000	25747	12736	4	0	\N
194138	1397	1284994634000	25750	12738	0	0	\N
194139	2134	84792684000	25750	12738	1	0	\N
194140	1769	1569700000	25750	12738	2	0	\N
194141	2133	91335314000	25750	12738	3	0	\N
194149	1397	1284984633000	25753	12739	0	0	\N
194150	2133	91334312000	25753	12739	1	0	\N
194151	2134	84791681000	25753	12739	2	0	\N
194152	1397	1284984633000	25754	12739	0	0	\N
194153	2133	91334312000	25754	12739	1	0	\N
194154	2134	84791681000	25754	12739	2	0	\N
194158	1397	1284964631000	25756	12741	0	0	\N
194159	2133	91332308000	25756	12741	1	0	\N
194160	2134	84789675000	25756	12741	2	0	\N
194161	1397	1284974632000	25757	12740	0	0	\N
194162	1397	1284964631000	25757	12740	1	0	\N
194163	2134	84790678000	25757	12740	2	0	\N
194164	2134	84789675000	25757	12740	3	0	\N
194165	2133	91333310000	25757	12740	4	0	\N
194166	2133	91332308000	25757	12740	5	0	\N
194167	1397	1284964631000	25758	12741	0	0	\N
194168	2133	91332308000	25758	12741	1	0	\N
194169	2134	84789675000	25758	12741	2	0	\N
194173	1397	1284964631000	25760	12741	0	0	\N
194174	2133	91332308000	25760	12741	1	0	\N
194175	2134	84789675000	25760	12741	2	0	\N
194176	1397	1284954630000	25761	12742	0	0	\N
194177	2134	84788672000	25761	12742	1	0	\N
194178	2133	91331306000	25761	12742	2	0	\N
194182	1397	1284954630000	25763	12742	0	0	\N
194183	2134	84788672000	25763	12742	1	0	\N
194184	2133	91331306000	25763	12742	2	0	\N
194188	1769	1569700000	25765	12585	0	0	\N
194189	1397	1284934628000	25766	12744	0	0	\N
194190	2134	84786666000	25766	12744	1	0	\N
194191	2133	91329302000	25766	12744	2	0	\N
194192	1397	1284934628000	25767	12744	0	0	\N
194193	2134	84786666000	25767	12744	1	0	\N
194194	2133	91329302000	25767	12744	2	0	\N
194195	1769	1569700000	25768	12611	0	0	\N
194202	1397	1284944629000	25771	12743	0	0	\N
194203	1397	1284934628000	25771	12743	1	0	\N
194204	1397	1284924627000	25771	12743	2	0	\N
194205	2133	91330304000	25771	12743	3	0	\N
194206	2134	84787669000	25771	12743	4	0	\N
194207	2134	84786666000	25771	12743	5	0	\N
194208	2134	84785663000	25771	12743	6	0	\N
194075	2134	84796696000	25734	12733	5	0	5776
194101	1397	1285034638000	25740	12734	0	0	15379
194102	2134	84795693000	25740	12734	1	0	5777
194103	2133	91339322000	25740	12734	2	0	5341
194104	1769	1571700000	25740	12734	3	0	61
194115	2134	84794690000	25743	12735	0	0	5778
194131	1397	1285024637000	25748	12736	0	0	15380
194132	1397	1285014636000	25748	12736	1	0	15381
194133	2133	91338320000	25748	12736	2	0	5342
194134	2133	91337318000	25748	12736	3	0	5343
194136	1397	1285004635000	25749	12737	0	0	15382
194137	2133	91336316000	25749	12737	1	0	5344
194142	1397	1284994634000	25751	12738	0	0	15383
194143	2134	84792684000	25751	12738	1	0	5780
194145	2133	91335314000	25751	12738	3	0	5345
194146	1397	1284984633000	25752	12739	0	0	15384
194147	2133	91334312000	25752	12739	1	0	5346
194148	2134	84791681000	25752	12739	2	0	5781
194155	1397	1284974632000	25755	12740	0	0	15385
194157	2133	91333310000	25755	12740	2	0	5347
194170	1397	1284964631000	25759	12741	0	0	15386
194171	2134	84789675000	25759	12741	1	0	5783
194172	2133	91332308000	25759	12741	2	0	5348
194179	1397	1284954630000	25762	12742	0	0	15387
194181	2133	91331306000	25762	12742	2	0	5349
194185	1397	1284944629000	25764	12743	0	0	15388
194186	2133	91330304000	25764	12743	1	0	5350
194187	2134	84787669000	25764	12743	2	0	5785
194197	2134	84786666000	25769	12744	1	0	5786
194198	2133	91329302000	25769	12744	2	0	5351
194199	1397	1284924627000	25770	12745	0	0	15390
194200	2133	91328300000	25770	12745	1	0	5352
194201	2134	84785663000	25770	12745	2	0	5787
194209	2133	91329302000	25771	12743	7	0	\N
194210	2133	91328300000	25771	12743	8	0	\N
194211	1397	1284914626000	25772	12746	0	0	\N
194212	2133	91327298000	25772	12746	1	0	\N
194213	2134	84784660000	25772	12746	2	0	\N
194226	1397	1284894624000	25776	12748	0	0	\N
194227	1397	1284884623000	25776	12748	1	0	\N
194228	2134	84782654000	25776	12748	2	0	\N
194229	2134	84781651000	25776	12748	3	0	\N
194230	2133	91325294000	25776	12748	4	0	\N
194231	2133	91324292000	25776	12748	5	0	\N
194232	1159	615190749000000	25777	12625	0	0	\N
194233	1769	1571700000	25777	12625	1	0	\N
194234	1769	1570700000	25777	12625	2	0	\N
194235	1769	1569700000	25777	12625	3	0	\N
194236	1624	1001000000	25777	12625	4	0	\N
194240	1397	1284874622000	25779	12749	0	0	\N
194241	2134	84780648000	25779	12749	1	0	\N
194242	2133	91323290000	25779	12749	2	0	\N
194258	1397	1284834618000	25783	12752	0	0	\N
194259	1397	1284824617000	25783	12752	1	0	\N
194260	2134	84776636000	25783	12752	2	0	\N
194261	2134	84775633000	25783	12752	3	0	\N
194262	2133	91319282000	25783	12752	4	0	\N
194263	2133	91318280000	25783	12752	5	0	\N
194264	1397	1284834618000	25784	12752	0	0	\N
194265	1397	1284824617000	25784	12752	1	0	\N
194266	2134	84776636000	25784	12752	2	0	\N
194267	2134	84775633000	25784	12752	3	0	\N
194268	2133	91319282000	25784	12752	4	0	\N
194269	2133	91318280000	25784	12752	5	0	\N
194270	1397	1284834618000	25785	12752	0	0	\N
194271	1397	1284824617000	25785	12752	1	0	\N
194272	2134	84776636000	25785	12752	2	0	\N
194273	2134	84775633000	25785	12752	3	0	\N
194274	2133	91319282000	25785	12752	4	0	\N
194275	2133	91318280000	25785	12752	5	0	\N
194276	1397	1284814616000	25786	12753	0	0	\N
194277	2134	84774630000	25786	12753	1	0	\N
194278	2133	91317278000	25786	12753	2	0	\N
194285	1397	1284804615000	25789	12754	0	0	\N
194286	2134	84773627000	25789	12754	1	0	\N
194287	610	67438023000000	25789	12754	2	0	\N
194288	2133	91316276000	25789	12754	3	0	\N
194289	1397	1284804615000	25790	12754	0	0	\N
194290	2134	84773627000	25790	12754	1	0	\N
194291	610	67438023000000	25790	12754	2	0	\N
194292	2133	91316276000	25790	12754	3	0	\N
194293	2134	84773627000	25791	12754	0	0	\N
194294	610	67438023000000	25791	12754	1	0	\N
194295	1397	1284804615000	25792	12754	0	0	\N
194296	2134	84773627000	25792	12754	1	0	\N
194297	610	67438023000000	25792	12754	2	0	\N
194298	2133	91316276000	25792	12754	3	0	\N
194303	1397	1284784613000	25794	12756	0	0	\N
194304	1397	1284774612000	25794	12756	1	0	\N
194305	1397	1284764611000	25794	12756	2	0	\N
194306	1397	1284754610000	25794	12756	3	0	\N
194307	1397	1284744609000	25794	12756	4	0	\N
194308	2134	84771621000	25794	12756	5	0	\N
194309	610	66000022000000	25794	12756	6	0	\N
194310	2134	84770618000	25794	12756	7	0	\N
194311	2134	84769615000	25794	12756	8	0	\N
194312	2134	84768612000	25794	12756	9	0	\N
194313	2134	84767609000	25794	12756	10	0	\N
194314	2133	91314272000	25794	12756	11	0	\N
194315	2133	91313270000	25794	12756	12	0	\N
194316	2133	91312268000	25794	12756	13	0	\N
194317	610	66000021000000	25794	12756	15	0	\N
194318	2133	91311266000	25794	12756	16	0	\N
194319	2133	91310264000	25794	12756	17	0	\N
194337	1397	1284734608000	25796	12757	0	0	\N
194338	2133	91309262000	25796	12757	1	0	\N
194339	1397	1284734608000	25797	12757	0	0	\N
194340	2133	91309262000	25797	12757	1	0	\N
194341	1397	1284734608000	25798	12757	0	0	\N
194342	2133	91309262000	25798	12757	1	0	\N
194216	2134	84784660000	25773	12746	2	0	5788
194217	1397	1284904625000	25774	12747	0	0	15392
194218	2134	84783657000	25774	12747	1	0	5789
194219	2133	91326296000	25774	12747	2	0	5354
194220	1397	1284894624000	25775	12748	0	0	15393
194222	2134	84782654000	25775	12748	2	0	5790
194223	2134	84781651000	25775	12748	3	0	5791
194224	2133	91325294000	25775	12748	4	0	5355
194225	2133	91324292000	25775	12748	5	0	5356
194237	1397	1284874622000	25778	12749	0	0	15395
194239	2133	91323290000	25778	12749	2	0	5357
194243	1397	1284864621000	25780	12750	0	0	15396
194244	2134	84779645000	25780	12750	1	0	5793
194245	2133	91322288000	25780	12750	2	0	5358
194247	1397	1284844619000	25781	12751	1	0	15398
194248	2134	84778642000	25781	12751	2	0	5794
194249	2133	91321286000	25781	12751	3	0	5359
194250	2133	91320284000	25781	12751	4	0	5360
194251	2134	84777639000	25781	12751	5	0	5795
194253	1397	1284824617000	25782	12752	1	0	15400
194254	2134	84776636000	25782	12752	2	0	5796
194255	2134	84775633000	25782	12752	3	0	5797
194256	2133	91319282000	25782	12752	4	0	5361
194257	2133	91318280000	25782	12752	5	0	5362
194280	2134	84774630000	25787	12753	1	0	5798
194281	2133	91317278000	25787	12753	2	0	5363
194282	1397	1284804615000	25788	12754	0	0	15402
194283	2134	84773627000	25788	12754	1	0	5799
194299	1397	1284794614000	25793	12755	0	0	15403
194300	2134	84772624000	25793	12755	1	0	5800
194301	2133	91316276000	25793	12755	2	0	5364
194302	2133	91315274000	25793	12755	3	0	5365
194320	1397	1284784613000	25795	12756	0	0	15404
194322	1397	1284764611000	25795	12756	2	0	15406
194323	1397	1284754610000	25795	12756	3	0	15407
194324	1397	1284744609000	25795	12756	4	0	15408
194325	2134	84771621000	25795	12756	5	0	5801
194326	610	66000022000000	25795	12756	6	0	2
194328	2134	84769615000	25795	12756	8	0	5803
194329	2134	84768612000	25795	12756	9	0	5804
194330	2134	84767609000	25795	12756	10	0	5805
194331	2133	91314272000	25795	12756	11	0	5366
194333	2133	91312268000	25795	12756	13	0	5368
194334	610	66000021000000	25795	12756	15	0	3
194335	2133	91311266000	25795	12756	16	0	5369
194336	2133	91310264000	25795	12756	17	0	5370
194343	1397	1284734608000	25799	12757	0	0	15409
194345	1397	1284734608000	25800	12757	0	0	\N
194346	2133	91309262000	25800	12757	1	0	\N
194350	1397	1284714606000	25802	12759	0	0	\N
194351	2133	91307258000	25802	12759	1	0	\N
194352	2134	84765603000	25802	12759	2	0	\N
194353	1397	1284714606000	25803	12759	0	0	\N
194354	2133	91307258000	25803	12759	1	0	\N
194355	2134	84765603000	25803	12759	2	0	\N
194359	1397	1284714606000	25805	12759	0	0	\N
194360	2133	91307258000	25805	12759	1	0	\N
194361	2134	84765603000	25805	12759	2	0	\N
194368	1397	1284704605000	25807	12760	0	0	\N
194369	1397	1284694604000	25807	12760	1	0	\N
194370	2133	91306256000	25807	12760	2	0	\N
194371	2134	84764600000	25807	12760	3	0	\N
194372	2134	84763597000	25807	12760	4	0	\N
194373	2133	91305254000	25807	12760	5	0	\N
194378	1397	1284684603000	25809	12761	0	0	\N
194379	685	66000011000000	25809	12761	1	0	\N
194380	2134	84762594000	25809	12761	2	0	\N
194381	2133	91304252000	25809	12761	3	0	\N
194385	1397	1284674602000	25811	12762	0	0	\N
194386	2134	84761591000	25811	12762	1	0	\N
194387	2133	91303250000	25811	12762	2	0	\N
194388	1397	1284664601000	25812	12763	0	0	\N
194389	2134	84760588000	25812	12763	1	0	\N
194390	2133	91302248000	25812	12763	2	0	\N
194397	1397	1284644599000	25815	12765	0	0	\N
194398	1397	1284634598000	25815	12765	1	0	\N
194399	2134	84758582000	25815	12765	2	0	\N
194400	2134	84757579000	25815	12765	3	0	\N
194401	2133	91300244000	25815	12765	4	0	\N
194402	2133	91299242000	25815	12765	5	0	\N
194403	1397	1284644599000	25816	12765	0	0	\N
194404	1397	1284634598000	25816	12765	1	0	\N
194405	2134	84758582000	25816	12765	2	0	\N
194406	2134	84757579000	25816	12765	3	0	\N
194407	2133	91300244000	25816	12765	4	0	\N
194408	2133	91299242000	25816	12765	5	0	\N
194409	1397	1284644599000	25818	12766	0	0	\N
194410	1397	1284634598000	25818	12766	1	0	\N
194411	1397	1284624597000	25818	12766	2	0	\N
194412	1397	1284614596000	25818	12766	3	0	\N
194413	2134	84758582000	25818	12766	4	0	\N
194414	2134	84757579000	25818	12766	5	0	\N
194415	2134	84756576000	25818	12766	6	0	\N
194416	2134	84755573000	25818	12766	7	0	\N
194417	2133	91300244000	25818	12766	8	0	\N
194418	2133	91299242000	25818	12766	9	0	\N
194419	2133	91298240000	25818	12766	10	0	\N
194420	2133	91297238000	25818	12766	11	0	\N
194442	1397	1284594594000	25822	12768	0	0	\N
194443	1397	1284584593000	25822	12768	1	0	\N
194444	2133	91295234000	25822	12768	2	0	\N
194445	2133	91294232000	25822	12768	3	0	\N
194446	2134	84754570000	25822	12768	4	0	\N
194447	2134	84753567000	25822	12768	5	0	\N
194448	2134	84752564000	25822	12768	6	0	\N
194449	1397	1284574592000	25823	12769	0	0	\N
194450	1397	1284564591000	25823	12769	1	0	\N
194451	1397	1284554590000	25823	12769	2	0	\N
194452	2134	84751561000	25823	12769	3	0	\N
194453	2134	84750558000	25823	12769	4	0	\N
194454	2133	91293230000	25823	12769	5	0	\N
194455	2133	91292228000	25823	12769	6	0	\N
194456	2133	91291226000	25823	12769	7	0	\N
194457	2134	84749555000	25823	12769	8	0	\N
194467	1397	1284544589000	25825	12770	0	0	\N
194468	2133	91290224000	25825	12770	1	0	\N
194469	2134	84748552000	25825	12770	2	0	\N
194476	1397	1284524587000	25828	12772	0	0	\N
194477	1397	1284514586000	25828	12772	1	0	\N
194478	547	66719010000000	25828	12772	2	0	\N
194479	2133	91288220000	25828	12772	3	0	\N
194480	2133	91287218000	25828	12772	4	0	\N
194349	2133	91308260000	25801	12758	2	0	5372
194356	1397	1284714606000	25804	12759	0	0	15411
194357	2133	91307258000	25804	12759	1	0	5373
194358	2134	84765603000	25804	12759	2	0	5807
194362	1397	1284704605000	25806	12760	0	0	15412
194364	2133	91306256000	25806	12760	2	0	5374
194365	2134	84764600000	25806	12760	3	0	5808
194366	2134	84763597000	25806	12760	4	0	5809
194367	2133	91305254000	25806	12760	5	0	5375
194374	1397	1284684603000	25808	12761	0	0	15414
194376	2134	84762594000	25808	12761	2	0	5810
194377	2133	91304252000	25808	12761	3	0	5376
194382	1397	1284674602000	25810	12762	0	0	15415
194383	2134	84761591000	25810	12762	1	0	5811
194391	1397	1284664601000	25813	12763	0	0	15416
194392	2134	84760588000	25813	12763	1	0	5812
194393	2133	91302248000	25813	12763	2	0	5378
194394	1397	1284654600000	25814	12764	0	0	15417
194395	2133	91301246000	25814	12764	1	0	5379
194421	1397	1284644599000	25819	12766	0	0	15418
194422	1397	1284634598000	25819	12766	1	0	15419
194423	1397	1284624597000	25819	12766	2	0	15420
194424	1397	1284614596000	25819	12766	3	0	15421
194425	2134	84758582000	25819	12766	4	0	5814
194427	2134	84756576000	25819	12766	6	0	5816
194428	2134	84755573000	25819	12766	7	0	5817
194429	2133	91300244000	25819	12766	8	0	5380
194430	2133	91299242000	25819	12766	9	0	5381
194432	2133	91297238000	25819	12766	11	0	5383
194433	1397	1284604595000	25820	12767	0	0	15422
194434	2133	91296236000	25820	12767	1	0	5384
194435	1397	1284594594000	25821	12768	0	0	15423
194436	1397	1284584593000	25821	12768	1	0	15424
194438	2133	91294232000	25821	12768	3	0	5386
194439	2134	84754570000	25821	12768	4	0	5818
194440	2134	84753567000	25821	12768	5	0	5819
194441	2134	84752564000	25821	12768	6	0	5820
194458	1397	1284574592000	25824	12769	0	0	15425
194460	1397	1284554590000	25824	12769	2	0	15427
194461	2134	84751561000	25824	12769	3	0	5821
194462	2134	84750558000	25824	12769	4	0	5822
194463	2133	91293230000	25824	12769	5	0	5387
194465	2133	91291226000	25824	12769	7	0	5389
194466	2134	84749555000	25824	12769	8	0	5823
194470	1397	1284544589000	25826	12770	0	0	15428
194471	2133	91290224000	25826	12770	1	0	5390
194472	2134	84748552000	25826	12770	2	0	5824
194474	2134	84747549000	25827	12771	1	0	5825
194475	2133	91289222000	25827	12771	2	0	5391
194481	2134	84746546000	25828	12772	5	0	\N
194482	2134	84745543000	25828	12772	6	0	\N
194493	1397	1284504585000	25831	12773	0	0	\N
194494	2133	91286216000	25831	12773	1	0	\N
194495	2134	84744540000	25831	12773	2	0	\N
194500	1397	1284494584000	25833	12774	0	0	\N
194501	2134	84743537000	25833	12774	1	0	\N
194502	2133	91285214000	25833	12774	2	0	\N
194503	547	66000009000000	25833	12774	3	0	\N
194504	1397	1284494584000	25834	12774	0	0	\N
194505	2134	84743537000	25834	12774	1	0	\N
194506	2133	91285214000	25834	12774	2	0	\N
194507	547	66000009000000	25834	12774	3	0	\N
194508	547	66719010000000	25835	12669	0	0	\N
194509	610	67438023000000	25835	12669	1	0	\N
194510	547	66000009000000	25835	12669	2	0	\N
194511	610	66000022000000	25835	12669	3	0	\N
194512	1769	1571700000	25835	12669	4	0	\N
194513	1769	1570700000	25835	12669	5	0	\N
194514	1769	1569700000	25835	12669	6	0	\N
194515	610	66000021000000	25835	12669	7	0	\N
194519	1397	1284484583000	25837	12775	0	0	\N
194520	2133	91284212000	25837	12775	1	0	\N
194521	2134	84742534000	25837	12775	2	0	\N
194522	1397	1284484583000	25838	12775	0	0	\N
194523	2133	91284212000	25838	12775	1	0	\N
194524	2134	84742534000	25838	12775	2	0	\N
194525	1397	1284484583000	25839	12775	0	0	\N
194526	2133	91284212000	25839	12775	1	0	\N
194527	2134	84742534000	25839	12775	2	0	\N
194532	1397	1284474582000	25841	12776	0	0	\N
194533	547	66000004000000	25841	12776	1	0	\N
194534	2133	91283210000	25841	12776	2	0	\N
194535	2134	84741531000	25841	12776	3	0	\N
194536	1397	1284474582000	25842	12776	0	0	\N
194537	547	66000004000000	25842	12776	1	0	\N
194538	2133	91283210000	25842	12776	2	0	\N
194539	2134	84741531000	25842	12776	3	0	\N
194540	1397	1284464581000	25843	12777	0	0	\N
194541	2326	719003000000	25843	12777	1	0	\N
194542	2134	84740528000	25843	12777	2	0	\N
194543	2133	91282208000	25843	12777	3	0	\N
194550	1397	1284454580000	25846	12778	0	0	\N
194551	2133	91281206000	25846	12778	1	0	\N
194552	1397	1284454580000	25847	12778	0	0	\N
194553	2133	91281206000	25847	12778	1	0	\N
194554	1397	1284454580000	25848	12778	0	0	\N
194555	2133	91281206000	25848	12778	1	0	\N
194581	1397	1284374572000	25853	12782	0	0	\N
194582	2133	91273190000	25853	12782	1	0	\N
194583	2134	84732504000	25853	12782	2	0	\N
194584	1397	1284364571000	25854	12783	0	0	\N
194585	2133	91272188000	25854	12783	1	0	\N
194586	2134	84731501000	25854	12783	2	0	\N
194587	1397	1284364571000	25855	12783	0	0	\N
194588	2133	91272188000	25855	12783	1	0	\N
194589	2134	84731501000	25855	12783	2	0	\N
194593	1397	1284364571000	25857	12783	0	0	\N
194594	2133	91272188000	25857	12783	1	0	\N
194595	2134	84731501000	25857	12783	2	0	\N
194596	1397	1284354570000	25858	12784	0	0	\N
194597	2133	91271186000	25858	12784	1	0	\N
194598	2134	84730498000	25858	12784	2	0	\N
194600	1397	1284354570000	25860	12785	0	0	\N
194601	1397	1284344569000	25860	12785	1	0	\N
194602	1397	1284334568000	25860	12785	2	0	\N
194603	2133	91271186000	25860	12785	3	0	\N
194604	2133	91270184000	25860	12785	4	0	\N
194605	2133	91269182000	25860	12785	5	0	\N
194606	2134	84729495000	25860	12785	6	0	\N
194607	2134	84728492000	25860	12785	7	0	\N
194616	1397	1284354570000	25862	12785	0	0	\N
194485	547	66719010000000	25829	12772	2	0	1
194486	2133	91288220000	25829	12772	3	0	5392
194487	2133	91287218000	25829	12772	4	0	5393
194488	2134	84746546000	25829	12772	5	0	5826
194489	2134	84745543000	25829	12772	6	0	5827
194491	2133	91286216000	25830	12773	1	0	5394
194492	2134	84744540000	25830	12773	2	0	5828
194496	1397	1284494584000	25832	12774	0	0	15433
194497	2134	84743537000	25832	12774	1	0	5829
194498	2133	91285214000	25832	12774	2	0	5395
194516	1397	1284484583000	25836	12775	0	0	15434
194517	2133	91284212000	25836	12775	1	0	5396
194518	2134	84742534000	25836	12775	2	0	5830
194528	1397	1284474582000	25840	12776	0	0	15435
194530	2133	91283210000	25840	12776	2	0	5397
194531	2134	84741531000	25840	12776	3	0	5831
194544	1397	1284464581000	25844	12777	0	0	15436
194545	2326	719003000000	25844	12777	1	0	1
194546	2134	84740528000	25844	12777	2	0	5832
194548	1397	1284454580000	25845	12778	0	0	15437
194549	2133	91281206000	25845	12778	1	0	5399
194556	1397	1284444579000	25849	12779	0	0	15438
194557	1397	1284434578000	25849	12779	1	0	15439
194558	2134	84739525000	25849	12779	2	0	5833
194560	2133	91280204000	25849	12779	4	0	5400
194561	2133	91279202000	25849	12779	5	0	5401
194562	1397	1284424577000	25850	12780	0	0	15440
194563	1397	1284414576000	25850	12780	1	0	15441
194565	2134	84737519000	25850	12780	3	0	5835
194566	2134	84736516000	25850	12780	4	0	5836
194567	2030	199000000	25850	12780	5	0	1
194568	2133	91278200000	25850	12780	6	0	5402
194569	2133	91277198000	25850	12780	7	0	5403
194571	2134	84735513000	25850	12780	9	0	5837
194572	1397	1284394574000	25851	12781	0	0	15443
194573	1397	1284384573000	25851	12781	1	0	15444
194574	2133	91275194000	25851	12781	2	0	5405
194575	2133	91274192000	25851	12781	3	0	5406
194577	2134	84733507000	25851	12781	5	0	5839
194578	1397	1284374572000	25852	12782	0	0	15445
194579	2133	91273190000	25852	12782	1	0	5407
194580	2134	84732504000	25852	12782	2	0	5840
194591	2133	91272188000	25856	12783	1	0	5408
194592	2134	84731501000	25856	12783	2	0	5841
194599	2134	84730498000	25859	12784	0	0	5842
194608	1397	1284354570000	25861	12785	0	0	15447
194609	1397	1284344569000	25861	12785	1	0	15448
194611	2133	91271186000	25861	12785	3	0	5409
194612	2133	91270184000	25861	12785	4	0	5410
194613	2133	91269182000	25861	12785	5	0	5411
194614	2134	84729495000	25861	12785	6	0	5843
194615	2134	84728492000	25861	12785	7	0	5844
194617	1397	1284344569000	25862	12785	1	0	\N
194618	1397	1284334568000	25862	12785	2	0	\N
194619	2133	91271186000	25862	12785	3	0	\N
194620	2133	91270184000	25862	12785	4	0	\N
194621	2133	91269182000	25862	12785	5	0	\N
194622	2134	84729495000	25862	12785	6	0	\N
194623	2134	84728492000	25862	12785	7	0	\N
194624	1397	1284354570000	25863	12785	0	0	\N
194625	1397	1284344569000	25863	12785	1	0	\N
194626	1397	1284334568000	25863	12785	2	0	\N
194627	2133	91271186000	25863	12785	3	0	\N
194628	2133	91270184000	25863	12785	4	0	\N
194629	2133	91269182000	25863	12785	5	0	\N
194630	2134	84729495000	25863	12785	6	0	\N
194631	2134	84728492000	25863	12785	7	0	\N
194635	1397	1284924627000	25865	12745	0	0	\N
194636	1397	1284914626000	25865	12745	1	0	\N
194637	1397	1284904625000	25865	12745	2	0	\N
194638	1397	1284894624000	25865	12745	3	0	\N
194639	1397	1284884623000	25865	12745	4	0	\N
194640	1397	1284874622000	25865	12745	5	0	\N
194641	1397	1284864621000	25865	12745	6	0	\N
194642	1397	1284854620000	25865	12745	7	0	\N
194643	1397	1284844619000	25865	12745	8	0	\N
194644	1397	1284834618000	25865	12745	9	0	\N
194645	1397	1284824617000	25865	12745	10	0	\N
194646	1397	1284814616000	25865	12745	11	0	\N
194647	1397	1284804615000	25865	12745	12	0	\N
194648	1397	1284794614000	25865	12745	13	0	\N
194649	1397	1284784613000	25865	12745	14	0	\N
194650	1397	1284774612000	25865	12745	15	0	\N
194651	1397	1284764611000	25865	12745	16	0	\N
194652	1397	1284754610000	25865	12745	17	0	\N
194653	1397	1284744609000	25865	12745	18	0	\N
194654	1397	1284734608000	25865	12745	19	0	\N
194655	1397	1284724607000	25865	12745	20	0	\N
194656	1397	1284714606000	25865	12745	21	0	\N
194657	1397	1284704605000	25865	12745	22	0	\N
194658	1397	1284694604000	25865	12745	23	0	\N
194659	1397	1284684603000	25865	12745	24	0	\N
194660	1397	1284674602000	25865	12745	25	0	\N
194661	1397	1284664601000	25865	12745	26	0	\N
194662	1397	1284654600000	25865	12745	27	0	\N
194663	1397	1284644599000	25865	12745	28	0	\N
194664	1397	1284634598000	25865	12745	29	0	\N
194665	1397	1284624597000	25865	12745	30	0	\N
194666	1397	1284614596000	25865	12745	31	0	\N
194667	1397	1284604595000	25865	12745	32	0	\N
194668	1397	1284594594000	25865	12745	33	0	\N
194669	1397	1284584593000	25865	12745	34	0	\N
194670	1397	1284574592000	25865	12745	35	0	\N
194671	1397	1284564591000	25865	12745	36	0	\N
194672	1397	1284554590000	25865	12745	37	0	\N
194673	1397	1284544589000	25865	12745	38	0	\N
194674	1397	1284534588000	25865	12745	39	0	\N
194675	1397	1284524587000	25865	12745	40	0	\N
194676	1397	1284514586000	25865	12745	41	0	\N
194677	1397	1284504585000	25865	12745	42	0	\N
194678	1397	1284494584000	25865	12745	43	0	\N
194679	1397	1284484583000	25865	12745	44	0	\N
194680	1397	1284474582000	25865	12745	45	0	\N
194681	1397	1284464581000	25865	12745	46	0	\N
194682	1397	1284454580000	25865	12745	47	0	\N
194683	1397	1284444579000	25865	12745	48	0	\N
194684	1397	1284434578000	25865	12745	49	0	\N
194685	1397	1284424577000	25865	12745	50	0	\N
194686	1397	1284414576000	25865	12745	51	0	\N
194687	1397	1284404575000	25865	12745	52	0	\N
194688	1397	1284394574000	25865	12745	53	0	\N
194689	1397	1284384573000	25865	12745	54	0	\N
194690	1397	1284374572000	25865	12745	55	0	\N
194691	1397	1284364571000	25865	12745	56	0	\N
194692	1397	1284354570000	25865	12745	57	0	\N
194693	1397	1284344569000	25865	12745	58	0	\N
194694	1397	1284334568000	25865	12745	59	0	\N
194695	1397	1284324567000	25865	12745	60	0	\N
194696	1397	1284314566000	25865	12745	61	0	\N
194697	1397	1284304565000	25865	12745	62	0	\N
194698	2030	199000000	25865	12745	63	0	\N
194699	2133	91328300000	25865	12745	64	0	\N
194700	2133	91327298000	25865	12745	65	0	\N
194701	2133	91326296000	25865	12745	66	0	\N
194702	547	66719010000000	25865	12745	67	0	\N
194703	610	67438023000000	25865	12745	68	0	\N
194704	547	66000009000000	25865	12745	69	0	\N
194705	610	66000022000000	25865	12745	70	0	\N
194706	2134	84785663000	25865	12745	71	0	\N
194707	2134	84784660000	25865	12745	72	0	\N
194708	2134	84783657000	25865	12745	73	0	\N
194709	2134	84782654000	25865	12745	74	0	\N
194710	2134	84781651000	25865	12745	75	0	\N
194711	2134	84780648000	25865	12745	76	0	\N
194712	2134	84779645000	25865	12745	77	0	\N
194713	2134	84778642000	25865	12745	78	0	\N
194714	547	66000004000000	25865	12745	80	0	\N
194715	2133	91325294000	25865	12745	81	0	\N
194716	2133	91324292000	25865	12745	82	0	\N
194717	2133	91323290000	25865	12745	83	0	\N
194718	2133	91322288000	25865	12745	84	0	\N
194719	2133	91321286000	25865	12745	85	0	\N
194720	2133	91320284000	25865	12745	86	0	\N
194721	2133	91319282000	25865	12745	87	0	\N
194722	2133	91318280000	25865	12745	88	0	\N
194723	2133	91317278000	25865	12745	89	0	\N
194724	610	66000021000000	25865	12745	90	0	\N
194725	2133	91316276000	25865	12745	91	0	\N
194726	2133	91315274000	25865	12745	92	0	\N
194727	2133	91314272000	25865	12745	93	0	\N
194728	2133	91313270000	25865	12745	94	0	\N
194729	2133	91312268000	25865	12745	95	0	\N
194730	2133	91311266000	25865	12745	96	0	\N
194731	2133	91310264000	25865	12745	97	0	\N
194732	2133	91309262000	25865	12745	98	0	\N
194733	2133	91308260000	25865	12745	99	0	\N
194734	2133	91307258000	25865	12745	100	0	\N
194735	2133	91306256000	25865	12745	101	0	\N
194736	2133	91305254000	25865	12745	102	0	\N
194737	2133	91304252000	25865	12745	103	0	\N
194738	2133	91303250000	25865	12745	104	0	\N
194739	2133	91302248000	25865	12745	105	0	\N
194740	2133	91301246000	25865	12745	106	0	\N
194741	2133	91300244000	25865	12745	107	0	\N
194742	2133	91299242000	25865	12745	108	0	\N
194743	2133	91298240000	25865	12745	109	0	\N
194744	2133	91297238000	25865	12745	110	0	\N
194745	2133	91296236000	25865	12745	111	0	\N
194746	2133	91295234000	25865	12745	112	0	\N
194747	2133	91294232000	25865	12745	113	0	\N
194748	2133	91293230000	25865	12745	114	0	\N
194749	2133	91292228000	25865	12745	115	0	\N
194750	2133	91291226000	25865	12745	116	0	\N
194751	2133	91290224000	25865	12745	117	0	\N
194752	2133	91289222000	25865	12745	118	0	\N
194634	2133	91268180000	25864	12786	2	0	5412
194753	2133	91288220000	25865	12745	119	0	\N
194754	2133	91287218000	25865	12745	120	0	\N
194755	2133	91286216000	25865	12745	121	0	\N
194756	2133	91285214000	25865	12745	122	0	\N
194757	2133	91284212000	25865	12745	123	0	\N
194758	2133	91283210000	25865	12745	124	0	\N
194759	2133	91282208000	25865	12745	125	0	\N
194769	1397	1284294564000	25868	12788	0	0	\N
194770	2134	84724480000	25868	12788	1	0	\N
194771	2133	91265174000	25868	12788	2	0	\N
194772	1397	1284294564000	25869	12788	0	0	\N
194773	2134	84724480000	25869	12788	1	0	\N
194774	2133	91265174000	25869	12788	2	0	\N
194775	1397	1284294564000	25870	12788	0	0	\N
194776	2134	84724480000	25870	12788	1	0	\N
194777	2133	91265174000	25870	12788	2	0	\N
194778	1397	1284294564000	25871	12788	0	0	\N
194779	2134	84724480000	25871	12788	1	0	\N
194780	2133	91265174000	25871	12788	2	0	\N
194781	2134	84724480000	25872	12788	0	0	\N
194782	1397	1284284563000	25873	12789	0	0	\N
194783	1397	1284274562000	25873	12789	1	0	\N
194784	2134	84723477000	25873	12789	2	0	\N
194785	2134	84722474000	25873	12789	3	0	\N
194786	2133	91264172000	25873	12789	4	0	\N
194787	2133	91263170000	25873	12789	5	0	\N
194788	1397	1284284563000	25874	12789	0	0	\N
194789	1397	1284274562000	25874	12789	1	0	\N
194790	2134	84723477000	25874	12789	2	0	\N
194791	2134	84722474000	25874	12789	3	0	\N
194792	2133	91264172000	25874	12789	4	0	\N
194793	2133	91263170000	25874	12789	5	0	\N
194794	1397	1284284563000	25875	12789	0	0	\N
194795	1397	1284274562000	25875	12789	1	0	\N
194796	2134	84723477000	25875	12789	2	0	\N
194797	2134	84722474000	25875	12789	3	0	\N
194798	2133	91264172000	25875	12789	4	0	\N
194799	2133	91263170000	25875	12789	5	0	\N
194800	1397	1284284563000	25876	12789	0	0	\N
194801	1397	1284274562000	25876	12789	1	0	\N
194802	2134	84723477000	25876	12789	2	0	\N
194803	2134	84722474000	25876	12789	3	0	\N
194804	2133	91264172000	25876	12789	4	0	\N
194805	2133	91263170000	25876	12789	5	0	\N
194812	1397	1284264561000	25878	12790	0	0	\N
194813	1397	1284254560000	25878	12790	1	0	\N
194814	1397	1284244559000	25878	12790	2	0	\N
194815	2133	91262168000	25878	12790	3	0	\N
194816	2133	91261166000	25878	12790	4	0	\N
194817	2133	91260164000	25878	12790	5	0	\N
194826	1397	1284234558000	25881	12791	0	0	\N
194827	2133	91259162000	25881	12791	1	0	\N
194828	1397	1284224557000	25882	12792	0	0	\N
194829	2133	91258160000	25882	12792	1	0	\N
194834	1397	1284214556000	25885	12793	0	0	\N
194835	2133	91257158000	25885	12793	1	0	\N
194838	1397	1284194554000	25887	12795	0	0	\N
194839	1397	1284184553000	25887	12795	1	0	\N
194840	2133	91255154000	25887	12795	2	0	\N
194841	2133	91254152000	25887	12795	3	0	\N
194842	1397	1284194554000	25888	12795	0	0	\N
194843	1397	1284184553000	25888	12795	1	0	\N
194844	2133	91255154000	25888	12795	2	0	\N
194845	2133	91254152000	25888	12795	3	0	\N
194850	1397	1284174552000	25890	12796	0	0	\N
194851	2133	91253150000	25890	12796	1	0	\N
194856	1397	1284164551000	25893	12797	0	0	\N
194857	2133	91252148000	25893	12797	1	0	\N
194860	1397	1284144549000	25895	12799	0	0	\N
194861	1397	1284134548000	25895	12799	1	0	\N
194862	1397	1284124547000	25895	12799	2	0	\N
194863	1397	1284114546000	25895	12799	3	0	\N
194864	1397	1284104545000	25895	12799	4	0	\N
194865	2133	91250144000	25895	12799	5	0	\N
194866	2133	91249142000	25895	12799	6	0	\N
194867	2133	91248140000	25895	12799	7	0	\N
194868	2133	91247138000	25895	12799	8	0	\N
194869	2133	91246136000	25895	12799	9	0	\N
194870	2133	91245134000	25895	12799	10	0	\N
194887	470	77519349000000	25899	12801	0	0	\N
194888	1397	1284084543000	25899	12801	1	0	\N
194762	2134	84726486000	25866	12787	2	0	5846
194763	2134	84725483000	25866	12787	3	0	5847
194764	2133	91267178000	25866	12787	4	0	5413
194765	2133	91266176000	25866	12787	5	0	5414
194766	1397	1284294564000	25867	12788	0	0	15453
194768	2133	91265174000	25867	12788	2	0	5415
194806	1397	1284284563000	25877	12789	0	0	15454
194807	1397	1284274562000	25877	12789	1	0	15455
194808	2134	84723477000	25877	12789	2	0	5849
194809	2134	84722474000	25877	12789	3	0	5850
194811	2133	91263170000	25877	12789	5	0	5417
194818	1397	1284264561000	25879	12790	0	0	15456
194819	1397	1284254560000	25879	12790	1	0	15457
194820	1397	1284244559000	25879	12790	2	0	15458
194822	2133	91261166000	25879	12790	4	0	5419
194823	2133	91260164000	25879	12790	5	0	5420
194824	1397	1284234558000	25880	12791	0	0	15459
194825	2133	91259162000	25880	12791	1	0	5421
194830	1397	1284224557000	25883	12792	0	0	15460
194832	1397	1284214556000	25884	12793	0	0	15461
194833	2133	91257158000	25884	12793	1	0	5423
194836	1397	1284204555000	25886	12794	0	0	15462
194837	2133	91256156000	25886	12794	1	0	5424
194846	1397	1284194554000	25889	12795	0	0	15463
194848	2133	91255154000	25889	12795	2	0	5425
194849	2133	91254152000	25889	12795	3	0	5426
194852	1397	1284174552000	25891	12796	0	0	15465
194853	2133	91253150000	25891	12796	1	0	5427
194855	2133	91252148000	25892	12797	1	0	5428
194858	1397	1284154550000	25894	12798	0	0	15467
194859	2133	91251146000	25894	12798	1	0	5429
194871	1397	1284144549000	25896	12799	0	0	15468
194872	1397	1284134548000	25896	12799	1	0	15469
194874	1397	1284114546000	25896	12799	3	0	15471
194875	1397	1284104545000	25896	12799	4	0	15472
194876	2133	91250144000	25896	12799	5	0	5430
194877	2133	91249142000	25896	12799	6	0	5431
194878	2133	91248140000	25896	12799	7	0	5432
194880	2133	91246136000	25896	12799	9	0	5434
194881	2133	91245134000	25896	12799	10	0	5435
194882	1397	1284094544000	25897	12800	0	0	15473
194883	2133	91244132000	25897	12800	1	0	5436
194885	1397	1284084543000	25898	12801	1	0	15474
194886	2133	91243130000	25898	12801	2	0	5437
194889	2133	91243130000	25899	12801	2	0	\N
194890	470	77519349000000	25900	12801	0	0	\N
194891	1397	1284084543000	25900	12801	1	0	\N
194892	2133	91243130000	25900	12801	2	0	\N
194893	1397	1284074542000	25901	12802	0	0	\N
194894	2133	91242128000	25901	12802	1	0	\N
194899	1397	1284064541000	25905	12803	0	0	\N
194900	2133	91241126000	25905	12803	1	0	\N
194901	1397	1284054540000	25906	12804	0	0	\N
194902	1397	1284044539000	25906	12804	1	0	\N
194903	1397	1284034538000	25906	12804	2	0	\N
194904	2133	91240124000	25906	12804	3	0	\N
194905	2133	91239122000	25906	12804	4	0	\N
194906	2133	91238120000	25906	12804	5	0	\N
194907	2073	776166541448	25906	12804	6	0	\N
194915	1397	1284054540000	25908	12804	0	0	\N
194916	1397	1284044539000	25908	12804	1	0	\N
194917	1397	1284034538000	25908	12804	2	0	\N
194918	2133	91240124000	25908	12804	3	0	\N
194919	2133	91239122000	25908	12804	4	0	\N
194920	2133	91238120000	25908	12804	5	0	\N
194921	2073	776166541448	25908	12804	6	0	\N
194922	1397	1284024537000	25909	12805	0	0	\N
194923	2133	91237118000	25909	12805	1	0	\N
194924	1397	1284024537000	25910	12805	0	0	\N
194925	2133	91237118000	25910	12805	1	0	\N
194928	1397	1284014536000	25912	12806	0	0	\N
194929	2133	91236116000	25912	12806	1	0	\N
194932	1397	1284014536000	25914	12806	0	0	\N
194933	1397	1284004535000	25915	12807	0	0	\N
194934	1397	1283994534000	25915	12807	1	0	\N
194935	2133	91235114000	25915	12807	2	0	\N
194936	2133	91234112000	25915	12807	3	0	\N
194941	1397	1283984533000	25917	12808	0	0	\N
194942	2133	91233110000	25917	12808	1	0	\N
194945	1397	1283984533000	25919	12808	0	0	\N
194946	2133	91233110000	25919	12808	1	0	\N
194947	1397	1283974532000	25920	12809	0	0	\N
194948	2133	91232108000	25920	12809	1	0	\N
194949	1397	1283974532000	25921	12809	0	0	\N
194950	2133	91232108000	25921	12809	1	0	\N
194951	1397	1283974532000	25922	12809	0	0	\N
194952	2133	91232108000	25922	12809	1	0	\N
194963	1397	1283924527000	25926	12812	0	0	\N
194964	2133	91227098000	25926	12812	1	0	\N
194971	1397	1283894524000	25929	12814	0	0	\N
194972	2133	91224092000	25929	12814	1	0	\N
194984	1397	1283864521000	25933	12816	0	0	\N
194985	1397	1283854520000	25933	12816	1	0	\N
194986	2133	91221086000	25933	12816	2	0	\N
194987	2133	91220084000	25933	12816	3	0	\N
194999	1397	1283784513000	25938	12821	0	0	\N
195000	1397	1283774512000	25938	12821	1	0	\N
195001	1397	1283764511000	25938	12821	2	0	\N
195002	1397	1283754510000	25938	12821	3	0	\N
195003	2133	91214072000	25938	12821	4	0	\N
195004	2133	91213070000	25938	12821	5	0	\N
195005	2133	91212068000	25938	12821	6	0	\N
195006	1397	1283784513000	25939	12821	0	0	\N
195007	1397	1283774512000	25939	12821	1	0	\N
195008	1397	1283764511000	25939	12821	2	0	\N
195009	1397	1283754510000	25939	12821	3	0	\N
195010	2133	91214072000	25939	12821	4	0	\N
195011	2133	91213070000	25939	12821	5	0	\N
195012	2133	91212068000	25939	12821	6	0	\N
195013	2133	91211066000	25939	12821	8	0	\N
195014	2133	91210064000	25939	12821	9	0	\N
195024	1397	1283784513000	25941	12821	0	0	\N
194897	1397	1284064541000	25904	12803	0	0	15476
194898	2133	91241126000	25904	12803	1	0	5439
194908	1397	1284054540000	25907	12804	0	0	15477
194909	1397	1284044539000	25907	12804	1	0	15478
194910	1397	1284034538000	25907	12804	2	0	15479
194912	2133	91239122000	25907	12804	4	0	5441
194913	2133	91238120000	25907	12804	5	0	5442
194914	2073	776166541448	25907	12804	6	0	2
194926	1397	1284024537000	25911	12805	0	0	15480
194927	2133	91237118000	25911	12805	1	0	5443
194931	2133	91236116000	25913	12806	1	0	5444
194937	1397	1284004535000	25916	12807	0	0	15482
194938	1397	1283994534000	25916	12807	1	0	15483
194939	2133	91235114000	25916	12807	2	0	5445
194943	1397	1283984533000	25918	12808	0	0	15484
194944	2133	91233110000	25918	12808	1	0	5447
194953	1397	1283974532000	25923	12809	0	0	15485
194954	2133	91232108000	25923	12809	1	0	5448
194955	1397	1283964531000	25924	12810	0	0	15486
194957	1397	1283954530000	25925	12811	0	0	15487
194958	1397	1283944529000	25925	12811	1	0	15488
194959	1397	1283934528000	25925	12811	2	0	15489
194960	2133	91230104000	25925	12811	3	0	5450
194961	2133	91229102000	25925	12811	4	0	5451
194965	1397	1283924527000	25927	12812	0	0	15490
194966	2133	91227098000	25927	12812	1	0	5453
194967	1397	1283914526000	25928	12813	0	0	15491
194968	1397	1283904525000	25928	12813	1	0	15492
194970	2133	91225094000	25928	12813	3	0	5455
194973	1397	1283894524000	25930	12814	0	0	15493
194974	2133	91224092000	25930	12814	1	0	5456
194975	1397	1283884523000	25931	12815	0	0	15494
194976	1397	1283874522000	25931	12815	1	0	15495
194978	2133	91223090000	25931	12815	3	0	5457
194979	2133	91222088000	25931	12815	4	0	5458
194980	1397	1283864521000	25932	12816	0	0	15496
194981	1397	1283854520000	25932	12816	1	0	15497
194982	2133	91221086000	25932	12816	2	0	5459
194988	1397	1283844519000	25934	12817	0	0	15498
194989	2133	91219082000	25934	12817	1	0	5461
194990	1397	1283834518000	25935	12818	0	0	15499
194991	2133	91218080000	25935	12818	1	0	5462
194993	1397	1283814516000	25936	12819	1	0	15501
194994	1397	1283804515000	25936	12819	2	0	15502
194995	2133	91217078000	25936	12819	3	0	5463
194996	2133	91216076000	25936	12819	4	0	5464
194997	2133	91215074000	25936	12819	5	0	5465
195015	1397	1283784513000	25940	12821	0	0	15504
195016	1397	1283774512000	25940	12821	1	0	15505
195017	1397	1283764511000	25940	12821	2	0	15506
195018	1397	1283754510000	25940	12821	3	0	15507
195019	2133	91214072000	25940	12821	4	0	5466
195021	2133	91212068000	25940	12821	6	0	5468
195022	2133	91211066000	25940	12821	8	0	5469
195023	2133	91210064000	25940	12821	9	0	5470
195025	1397	1283774512000	25941	12821	1	0	\N
195026	1397	1283764511000	25941	12821	2	0	\N
195027	1397	1283754510000	25941	12821	3	0	\N
195028	2133	91214072000	25941	12821	4	0	\N
195029	2133	91213070000	25941	12821	5	0	\N
195030	2133	91212068000	25941	12821	6	0	\N
195031	2133	91211066000	25941	12821	8	0	\N
195032	2133	91210064000	25941	12821	9	0	\N
195033	1397	1283784513000	25942	12821	0	0	\N
195034	1397	1283774512000	25942	12821	1	0	\N
195035	1397	1283764511000	25942	12821	2	0	\N
195036	1397	1283754510000	25942	12821	3	0	\N
195037	2133	91214072000	25942	12821	4	0	\N
195038	2133	91213070000	25942	12821	5	0	\N
195039	2133	91212068000	25942	12821	6	0	\N
195040	2133	91211066000	25942	12821	8	0	\N
195041	2133	91210064000	25942	12821	9	0	\N
195043	1397	1283744509000	25945	12822	0	0	\N
195044	1397	1283734508000	25945	12822	1	0	\N
195045	1397	1283724507000	25945	12822	2	0	\N
195046	2133	91209062000	25945	12822	3	0	\N
195047	2133	91208060000	25945	12822	4	0	\N
195048	1397	1283744509000	25946	12822	0	0	\N
195049	1397	1283734508000	25946	12822	1	0	\N
195050	1397	1283724507000	25946	12822	2	0	\N
195051	2133	91209062000	25946	12822	3	0	\N
195052	2133	91208060000	25946	12822	4	0	\N
195057	1397	1283714506000	25951	12824	0	0	\N
195058	1397	1283704505000	25951	12824	1	0	\N
195059	2133	91207058000	25951	12824	2	0	\N
195060	2133	91206056000	25951	12824	3	0	\N
195067	1678	26640830559000	25954	12804	0	0	\N
195068	470	77395339000000	25954	12804	1	0	\N
195069	2073	776166541448	25954	12804	2	0	\N
195070	470	77395339000000	25955	12826	0	0	\N
195071	1397	1283684503000	25955	12826	1	0	\N
195072	2133	91204052000	25955	12826	2	0	\N
195076	1397	1283674502000	25957	12827	0	0	\N
195077	1397	1283664501000	25957	12827	1	0	\N
195078	2133	91203050000	25957	12827	2	0	\N
195079	2133	91202048000	25957	12827	3	0	\N
195084	1397	1283674502000	25959	12827	0	0	\N
195085	1397	1283664501000	25959	12827	1	0	\N
195086	2133	91203050000	25959	12827	2	0	\N
195087	2133	91202048000	25959	12827	3	0	\N
195090	1397	1283654500000	25961	12828	0	0	\N
195091	2133	91201046000	25961	12828	1	0	\N
195092	1397	1283644499000	25962	12829	0	0	\N
195093	1397	1283634498000	25962	12829	1	0	\N
195094	2133	91200044000	25962	12829	2	0	\N
195095	568	66000007000000	25962	12829	3	0	\N
195096	2133	91199042000	25962	12829	4	0	\N
195097	1397	1283644499000	25963	12829	0	0	\N
195098	1397	1283634498000	25963	12829	1	0	\N
195099	2133	91200044000	25963	12829	2	0	\N
195100	568	66000007000000	25963	12829	3	0	\N
195101	2133	91199042000	25963	12829	4	0	\N
195102	1397	1283644499000	25964	12829	0	0	\N
195103	1397	1283634498000	25964	12829	1	0	\N
195104	2133	91200044000	25964	12829	2	0	\N
195105	568	66000007000000	25964	12829	3	0	\N
195106	2133	91199042000	25964	12829	4	0	\N
195107	1397	1283644499000	25965	12829	0	0	\N
195108	1397	1283634498000	25965	12829	1	0	\N
195109	2133	91200044000	25965	12829	2	0	\N
195110	568	66000007000000	25965	12829	3	0	\N
195111	2133	91199042000	25965	12829	4	0	\N
195121	1397	1283624497000	25968	12830	0	0	\N
195122	2133	91198040000	25968	12830	1	0	\N
195123	2133	91197038000	25968	12830	2	0	\N
195124	2328	719003000000	25968	12830	3	0	\N
195125	1397	1283624497000	25969	12830	0	0	\N
195126	2133	91198040000	25969	12830	1	0	\N
195127	2133	91197038000	25969	12830	2	0	\N
195128	2328	719003000000	25969	12830	3	0	\N
195129	1397	1283614496000	25970	12831	0	0	\N
195130	2133	91196036000	25970	12831	1	0	\N
195139	568	66000007000000	25975	12805	0	0	\N
195142	1397	1283574492000	25977	12835	0	0	\N
195143	2133	91192028000	25977	12835	1	0	\N
195156	1397	1283514486000	25983	12840	0	0	\N
195157	2133	91186016000	25983	12840	1	0	\N
195158	1397	1283514486000	25984	12840	0	0	\N
195159	2133	91186016000	25984	12840	1	0	\N
195054	1397	1283724507000	25948	12823	1	0	15510
195055	2133	91209062000	25948	12823	2	0	5471
195056	2133	91208060000	25948	12823	3	0	5472
195061	1397	1283714506000	25952	12824	0	0	15511
195062	1397	1283704505000	25952	12824	1	0	15512
195064	2133	91206056000	25952	12824	3	0	5474
195065	1397	1283694504000	25953	12825	0	0	15513
195066	2133	91205054000	25953	12825	1	0	5475
195073	470	77395339000000	25956	12826	0	0	13
195074	1397	1283684503000	25956	12826	1	0	15514
195080	1397	1283674502000	25958	12827	0	0	15515
195081	1397	1283664501000	25958	12827	1	0	15516
195082	2133	91203050000	25958	12827	2	0	5477
195083	2133	91202048000	25958	12827	3	0	5478
195089	2133	91201046000	25960	12828	1	0	5479
195112	1397	1283644499000	25966	12829	0	0	15518
195113	1397	1283634498000	25966	12829	1	0	15519
195114	2133	91200044000	25966	12829	2	0	5480
195115	568	66000007000000	25966	12829	3	0	1
195117	1397	1283624497000	25967	12830	0	0	15520
195118	2133	91198040000	25967	12830	1	0	5482
195119	2133	91197038000	25967	12830	2	0	5483
195120	2328	719003000000	25967	12830	3	0	1
195131	1397	1283614496000	25971	12831	0	0	15521
195133	1397	1283604495000	25972	12832	0	0	15522
195134	2133	91195034000	25972	12832	1	0	5485
195135	1397	1283594494000	25973	12833	0	0	15523
195136	2133	91194032000	25973	12833	1	0	5486
195138	2133	91193030000	25974	12834	1	0	5487
195140	1397	1283574492000	25976	12835	0	0	15525
195141	2133	91192028000	25976	12835	1	0	5488
195144	1397	1283564491000	25978	12836	0	0	15526
195145	1397	1283554490000	25978	12836	1	0	15527
195147	2133	91190024000	25978	12836	3	0	5490
195148	1397	1283544489000	25979	12837	0	0	15528
195149	2133	91189022000	25979	12837	1	0	5491
195150	1397	1283534488000	25980	12838	0	0	15529
195151	2133	91188020000	25980	12838	1	0	5492
195153	2133	91187018000	25981	12839	1	0	5493
195154	1397	1283514486000	25982	12840	0	0	15531
195155	2133	91186016000	25982	12840	1	0	5494
195160	1397	1283504485000	25985	12841	0	0	15532
195170	1397	1283464481000	25988	12843	0	0	\N
195171	2133	91181006000	25988	12843	1	0	\N
195174	1397	1283454480000	25990	12844	0	0	\N
195175	2133	91180004000	25990	12844	1	0	\N
195178	1397	1283434478000	25992	12846	0	0	\N
195179	2133	91178000000	25992	12846	1	0	\N
195186	1397	1283424477000	25995	12847	0	0	\N
195187	1397	1283414476000	25995	12847	1	0	\N
195188	2133	91176998000	25995	12847	2	0	\N
195189	2133	91175996000	25995	12847	3	0	\N
195190	1397	1283404475000	25999	12849	0	0	\N
195191	1397	1283394474000	25999	12849	1	0	\N
195192	2133	91174994000	25999	12849	2	0	\N
195193	2133	91173992000	25999	12849	3	0	\N
195194	2327	124009000000	25999	12849	4	0	\N
195195	1397	1283404475000	26000	12850	0	0	\N
195196	1397	1283394474000	26000	12850	1	0	\N
195197	1397	1283384473000	26000	12850	2	0	\N
195198	2133	91174994000	26000	12850	3	0	\N
195199	2133	91173992000	26000	12850	4	0	\N
195200	2133	91172990000	26000	12850	5	0	\N
195201	2327	124009000000	26000	12850	6	0	\N
195209	470	77519349000000	26002	12731	0	0	\N
195210	2030	199000000	26002	12731	1	0	\N
195211	547	66719010000000	26002	12731	2	0	\N
195212	610	67438023000000	26002	12731	3	0	\N
195213	547	66000009000000	26002	12731	4	0	\N
195214	610	66000022000000	26002	12731	5	0	\N
195215	2073	776166541448	26002	12731	6	0	\N
195216	547	66000004000000	26002	12731	7	0	\N
195217	610	66000021000000	26002	12731	8	0	\N
195218	1678	26640830457000	26003	12732	0	0	\N
195219	470	77395339000000	26003	12732	1	0	\N
195220	568	66000007000000	26003	12732	2	0	\N
195221	2327	124009000000	26003	12732	3	0	\N
195223	1397	1283374472000	26005	12851	0	0	\N
195224	2133	91171988000	26005	12851	1	0	\N
195247	1397	1283304465000	26011	12856	0	0	\N
195248	2133	91164974000	26011	12856	1	0	\N
195249	2134	84715453000	26011	12856	2	0	\N
195250	1397	1283294464000	26012	12857	0	0	\N
195251	1159	614190748000000	26012	12857	1	0	\N
195252	2134	84714450000	26012	12857	2	0	\N
195253	2133	91163972000	26012	12857	3	0	\N
195258	1397	1286084743000	26014	12665	0	0	\N
195259	1397	1286074742000	26014	12665	1	0	\N
195260	1397	1286064741000	26014	12665	2	0	\N
195261	470	77519349000000	26014	12665	3	0	\N
195262	1397	1286054740000	26014	12665	4	0	\N
195263	1678	26640830360000	26014	12665	5	0	\N
195264	470	77395339000000	26014	12665	6	0	\N
195265	1397	1286044739000	26014	12665	7	0	\N
195266	1397	1286034738000	26014	12665	8	0	\N
195267	1397	1286024737000	26014	12665	9	0	\N
195268	1397	1286014736000	26014	12665	10	0	\N
195269	1397	1286004735000	26014	12665	11	0	\N
195270	1397	1285994734000	26014	12665	12	0	\N
195271	1397	1285984733000	26014	12665	13	0	\N
195272	1397	1285974732000	26014	12665	14	0	\N
195273	1397	1285964731000	26014	12665	15	0	\N
195274	1397	1285954730000	26014	12665	16	0	\N
195275	1397	1285944729000	26014	12665	17	0	\N
195276	1397	1285934728000	26014	12665	18	0	\N
195277	1397	1285924727000	26014	12665	19	0	\N
195278	1397	1285914726000	26014	12665	20	0	\N
195279	1397	1285904725000	26014	12665	21	0	\N
195280	1397	1285894724000	26014	12665	22	0	\N
195281	1397	1285884723000	26014	12665	23	0	\N
195282	1397	1285874722000	26014	12665	24	0	\N
195283	1397	1285864721000	26014	12665	25	0	\N
195284	1397	1285854720000	26014	12665	26	0	\N
195285	1397	1285844719000	26014	12665	27	0	\N
195286	1397	1285834718000	26014	12665	28	0	\N
195287	1397	1285824717000	26014	12665	29	0	\N
195288	1397	1285814716000	26014	12665	30	0	\N
195289	1397	1285804715000	26014	12665	31	0	\N
195290	1397	1285794714000	26014	12665	32	0	\N
195291	1397	1285784713000	26014	12665	33	0	\N
195292	1397	1285774712000	26014	12665	34	0	\N
195293	1397	1285764711000	26014	12665	35	0	\N
195294	1397	1285754710000	26014	12665	36	0	\N
195295	1397	1285744709000	26014	12665	37	0	\N
195296	1397	1285734708000	26014	12665	38	0	\N
195163	2133	91185014000	25985	12841	3	0	5495
195164	2133	91184012000	25985	12841	4	0	5496
195165	2133	91183010000	25985	12841	5	0	5497
195166	1397	1283474482000	25986	12842	0	0	15535
195167	2133	91182008000	25986	12842	1	0	5498
195169	2133	91181006000	25987	12843	1	0	5499
195172	1397	1283454480000	25989	12844	0	0	15537
195173	2133	91180004000	25989	12844	1	0	5500
195176	1397	1283444479000	25991	12845	0	0	15538
195177	2133	91179002000	25991	12845	1	0	5501
195181	2133	91178000000	25993	12846	1	0	5502
195182	1397	1283424477000	25994	12847	0	0	15540
195183	1397	1283414476000	25994	12847	1	0	15541
195184	2133	91176998000	25994	12847	2	0	5503
195202	1397	1283404475000	26001	12850	0	0	15542
195203	1397	1283394474000	26001	12850	1	0	15543
195204	1397	1283384473000	26001	12850	2	0	15544
195205	2133	91174994000	26001	12850	3	0	5505
195206	2133	91173992000	26001	12850	4	0	5506
195208	2327	124009000000	26001	12850	6	0	1
195222	1397	1283374472000	26004	12851	0	0	15545
195225	1397	1283364471000	26006	12852	0	0	15546
195226	1397	1283354470000	26006	12852	1	0	15547
195227	2134	84721471000	26006	12852	2	0	5851
195229	2133	91171988000	26006	12852	4	0	5508
195230	2133	91170986000	26006	12852	5	0	5509
195231	2133	91169984000	26006	12852	6	0	5510
195232	1397	1283344469000	26007	12853	0	0	15548
195234	2134	84719465000	26007	12853	2	0	5853
195235	1397	1283334468000	26008	12854	0	0	15549
195236	1397	1283324467000	26008	12854	1	0	15550
195237	2134	84718462000	26008	12854	2	0	5854
195238	2133	91167980000	26008	12854	3	0	5512
195240	2134	84717459000	26008	12854	5	0	5855
195241	1397	1283314466000	26009	12855	0	0	15551
195242	2133	91165976000	26009	12855	1	0	5514
195243	2134	84716456000	26009	12855	2	0	5856
195244	1397	1283304465000	26010	12856	0	0	15552
195246	2134	84715453000	26010	12856	2	0	5857
195254	1397	1283294464000	26013	12857	0	0	15553
195255	1159	614190748000000	26013	12857	1	0	2
195256	2134	84714450000	26013	12857	2	0	5858
195297	1397	1285724707000	26014	12665	39	0	\N
195298	1397	1285714706000	26014	12665	40	0	\N
195299	1397	1285704705000	26014	12665	41	0	\N
195300	1397	1285694704000	26014	12665	42	0	\N
195301	1397	1285684703000	26014	12665	43	0	\N
195302	1397	1285674702000	26014	12665	44	0	\N
195303	1397	1285664701000	26014	12665	45	0	\N
195304	1397	1285654700000	26014	12665	46	0	\N
195305	1397	1285644699000	26014	12665	47	0	\N
195306	1397	1285634698000	26014	12665	48	0	\N
195307	1397	1285624697000	26014	12665	49	0	\N
195308	1397	1285614696000	26014	12665	50	0	\N
195309	1397	1285604695000	26014	12665	51	0	\N
195310	1397	1285594694000	26014	12665	52	0	\N
195311	1397	1285584693000	26014	12665	53	0	\N
195312	1397	1285574692000	26014	12665	54	0	\N
195313	1397	1285564691000	26014	12665	55	0	\N
195314	1397	1285554690000	26014	12665	56	0	\N
195315	1397	1285544689000	26014	12665	57	0	\N
195316	1397	1285534688000	26014	12665	58	0	\N
195317	1397	1285524687000	26014	12665	59	0	\N
195318	1397	1285514686000	26014	12665	60	0	\N
195319	1397	1285504685000	26014	12665	61	0	\N
195320	1397	1285494684000	26014	12665	62	0	\N
195321	1397	1285484683000	26014	12665	63	0	\N
195322	1397	1285474682000	26014	12665	64	0	\N
195323	1397	1285464681000	26014	12665	65	0	\N
195324	1397	1285454680000	26014	12665	66	0	\N
195325	1397	1285444679000	26014	12665	67	0	\N
195326	1397	1285434678000	26014	12665	68	0	\N
195327	1397	1285424677000	26014	12665	69	0	\N
195328	1397	1285414676000	26014	12665	70	0	\N
195329	1397	1285404675000	26014	12665	71	0	\N
195330	1397	1285394674000	26014	12665	72	0	\N
195331	1397	1285384673000	26014	12665	73	0	\N
195332	1397	1285374672000	26014	12665	74	0	\N
195333	1397	1285364671000	26014	12665	75	0	\N
195334	1397	1285354670000	26014	12665	76	0	\N
195335	1397	1285344669000	26014	12665	77	0	\N
195336	1397	1285334668000	26014	12665	78	0	\N
195337	1397	1285324667000	26014	12665	79	0	\N
195338	1397	1285314666000	26014	12665	80	0	\N
195339	1397	1285304665000	26014	12665	81	0	\N
195340	1397	1285294664000	26014	12665	82	0	\N
195341	1397	1285284663000	26014	12665	83	0	\N
195342	1397	1285274662000	26014	12665	84	0	\N
195343	1397	1285264661000	26014	12665	86	0	\N
195344	1397	1285254660000	26014	12665	87	0	\N
195345	1397	1285244659000	26014	12665	88	0	\N
195346	1397	1285234658000	26014	12665	89	0	\N
195347	1397	1285224657000	26014	12665	90	0	\N
195348	1397	1285214656000	26014	12665	91	0	\N
195349	1397	1285204655000	26014	12665	92	0	\N
195350	1397	1285194654000	26014	12665	93	0	\N
195351	1397	1285184653000	26014	12665	94	0	\N
195352	1397	1285174652000	26014	12665	95	0	\N
195353	1397	1285164651000	26014	12665	96	0	\N
195354	1397	1285154650000	26014	12665	97	0	\N
195355	1397	1285144649000	26014	12665	98	0	\N
195356	1397	1285134648000	26014	12665	99	0	\N
195357	1397	1285124647000	26014	12665	100	0	\N
195358	1397	1285114646000	26014	12665	101	0	\N
195359	1397	1285104645000	26014	12665	102	0	\N
195360	1397	1285094644000	26014	12665	103	0	\N
195361	1397	1285084643000	26014	12665	104	0	\N
195362	1397	1285074642000	26014	12665	105	0	\N
195363	1397	1285064641000	26014	12665	106	0	\N
195364	1397	1285054640000	26014	12665	107	0	\N
195365	1397	1285044639000	26014	12665	108	0	\N
195366	1397	1285034638000	26014	12665	109	0	\N
195367	1397	1285024637000	26014	12665	110	0	\N
195368	1397	1285014636000	26014	12665	111	0	\N
195369	1397	1285004635000	26014	12665	112	0	\N
195370	1397	1284994634000	26014	12665	113	0	\N
195371	1397	1284984633000	26014	12665	114	0	\N
195372	1397	1284974632000	26014	12665	115	0	\N
195373	1397	1284964631000	26014	12665	116	0	\N
195374	1397	1284954630000	26014	12665	117	0	\N
195375	1397	1284944629000	26014	12665	118	0	\N
195376	1397	1284934628000	26014	12665	119	0	\N
195377	1397	1284924627000	26014	12665	120	0	\N
195378	1397	1284914626000	26014	12665	121	0	\N
195379	1397	1284904625000	26014	12665	122	0	\N
195380	1397	1284894624000	26014	12665	123	0	\N
195381	1397	1284884623000	26014	12665	124	0	\N
195382	1397	1284874622000	26014	12665	125	0	\N
195386	1397	1283284463000	26016	12858	0	0	\N
195387	2133	91162970000	26016	12858	1	0	\N
195388	2134	84713447000	26016	12858	2	0	\N
195389	1397	1283274462000	26018	12859	0	0	\N
195390	2134	84712444000	26018	12859	1	0	\N
195391	2133	91161968000	26018	12859	2	0	\N
195392	2133	91161968000	26019	12859	0	0	\N
195398	1397	1283254460000	26022	12861	0	0	\N
195399	2134	84710438000	26022	12861	1	0	\N
195404	1397	1283244459000	26025	12862	0	0	\N
195405	2134	84709435000	26025	12862	1	0	\N
195408	1397	1283224457000	26028	12864	0	0	\N
195409	2134	84707429000	26028	12864	1	0	\N
195410	1397	1283224457000	26029	12864	0	0	\N
195411	2134	84707429000	26029	12864	1	0	\N
195414	1397	1283224457000	26031	12864	0	0	\N
195415	2134	84707429000	26031	12864	1	0	\N
195416	470	77519349000000	26033	12748	0	0	\N
195417	1397	1284894624000	26033	12748	1	0	\N
195418	1678	26640830476000	26033	12748	2	0	\N
195419	470	77395339000000	26033	12748	3	0	\N
195420	1397	1284884623000	26033	12748	4	0	\N
195421	1397	1284874622000	26033	12748	5	0	\N
195422	1397	1284864621000	26033	12748	6	0	\N
195423	1397	1284854620000	26033	12748	7	0	\N
195424	1397	1284844619000	26033	12748	8	0	\N
195425	1397	1284834618000	26033	12748	9	0	\N
195426	1397	1284824617000	26033	12748	10	0	\N
195427	1397	1284814616000	26033	12748	11	0	\N
195428	1397	1284804615000	26033	12748	12	0	\N
195429	1397	1284794614000	26033	12748	13	0	\N
195430	1397	1284784613000	26033	12748	14	0	\N
195431	1397	1284774612000	26033	12748	15	0	\N
195432	1397	1284764611000	26033	12748	16	0	\N
195385	2134	84713447000	26015	12858	2	0	5859
195393	1397	1283274462000	26020	12859	0	0	15555
195394	2134	84712444000	26020	12859	1	0	5860
195395	2133	91161968000	26020	12859	2	0	5518
195396	1397	1283264461000	26021	12860	0	0	15556
195400	1397	1283254460000	26023	12861	0	0	15557
195401	2134	84710438000	26023	12861	1	0	5862
195402	1397	1283244459000	26024	12862	0	0	15558
195403	2134	84709435000	26024	12862	1	0	5863
195406	1397	1283234458000	26026	12863	0	0	15559
195412	1397	1283224457000	26030	12864	0	0	15560
195413	2134	84707429000	26030	12864	1	0	5865
195433	1397	1284754610000	26033	12748	17	0	\N
195434	1397	1284744609000	26033	12748	18	0	\N
195435	1397	1284734608000	26033	12748	19	0	\N
195436	1397	1284724607000	26033	12748	20	0	\N
195437	1397	1284714606000	26033	12748	21	0	\N
195438	1397	1284704605000	26033	12748	22	0	\N
195439	1397	1284694604000	26033	12748	23	0	\N
195440	1397	1284684603000	26033	12748	24	0	\N
195441	1397	1284674602000	26033	12748	25	0	\N
195442	1397	1284664601000	26033	12748	26	0	\N
195443	1397	1284654600000	26033	12748	27	0	\N
195444	1397	1284644599000	26033	12748	28	0	\N
195445	1397	1284634598000	26033	12748	29	0	\N
195446	1397	1284624597000	26033	12748	30	0	\N
195447	1397	1284614596000	26033	12748	31	0	\N
195448	1397	1284604595000	26033	12748	32	0	\N
195449	1397	1284594594000	26033	12748	33	0	\N
195450	1397	1284584593000	26033	12748	34	0	\N
195451	1397	1284574592000	26033	12748	35	0	\N
195452	1397	1284564591000	26033	12748	36	0	\N
195453	1397	1284554590000	26033	12748	37	0	\N
195454	1397	1284544589000	26033	12748	38	0	\N
195455	1397	1284534588000	26033	12748	39	0	\N
195456	1397	1284524587000	26033	12748	40	0	\N
195457	1397	1284514586000	26033	12748	41	0	\N
195458	1397	1284504585000	26033	12748	42	0	\N
195459	1397	1284494584000	26033	12748	43	0	\N
195460	1397	1284484583000	26033	12748	44	0	\N
195461	1397	1284474582000	26033	12748	45	0	\N
195462	1397	1284464581000	26033	12748	46	0	\N
195463	1397	1284454580000	26033	12748	47	0	\N
195464	1397	1284444579000	26033	12748	48	0	\N
195465	1397	1284434578000	26033	12748	49	0	\N
195466	1397	1284424577000	26033	12748	50	0	\N
195467	1397	1284414576000	26033	12748	51	0	\N
195468	1397	1284404575000	26033	12748	52	0	\N
195469	1397	1284394574000	26033	12748	53	0	\N
195470	1397	1284384573000	26033	12748	54	0	\N
195471	1397	1284374572000	26033	12748	55	0	\N
195472	1397	1284364571000	26033	12748	56	0	\N
195473	1397	1284354570000	26033	12748	57	0	\N
195474	1397	1284344569000	26033	12748	58	0	\N
195475	1397	1284334568000	26033	12748	59	0	\N
195476	1397	1284324567000	26033	12748	60	0	\N
195477	1397	1284314566000	26033	12748	61	0	\N
195478	1397	1284304565000	26033	12748	62	0	\N
195479	1397	1284294564000	26033	12748	63	0	\N
195480	1397	1284284563000	26033	12748	65	0	\N
195481	1397	1284274562000	26033	12748	66	0	\N
195482	1397	1284264561000	26033	12748	67	0	\N
195483	1397	1284254560000	26033	12748	68	0	\N
195484	1397	1284244559000	26033	12748	69	0	\N
195485	1397	1284234558000	26033	12748	70	0	\N
195486	1397	1284224557000	26033	12748	71	0	\N
195487	1397	1284214556000	26033	12748	72	0	\N
195488	1397	1284204555000	26033	12748	73	0	\N
195489	1397	1284194554000	26033	12748	74	0	\N
195490	1397	1284184553000	26033	12748	75	0	\N
195491	1397	1284174552000	26033	12748	76	0	\N
195492	1397	1284164551000	26033	12748	77	0	\N
195493	1397	1284154550000	26033	12748	78	0	\N
195494	1397	1284144549000	26033	12748	79	0	\N
195495	1397	1284134548000	26033	12748	80	0	\N
195496	1397	1284124547000	26033	12748	81	0	\N
195497	1397	1284114546000	26033	12748	82	0	\N
195498	1397	1284104545000	26033	12748	83	0	\N
195499	1397	1284094544000	26033	12748	84	0	\N
195500	1397	1284084543000	26033	12748	85	0	\N
195501	1397	1284074542000	26033	12748	86	0	\N
195502	1397	1284064541000	26033	12748	87	0	\N
195503	1397	1284054540000	26033	12748	88	0	\N
195504	1397	1284044539000	26033	12748	89	0	\N
195505	1397	1284034538000	26033	12748	90	0	\N
195506	1397	1284024537000	26033	12748	91	0	\N
195507	1397	1284014536000	26033	12748	92	0	\N
195508	1397	1284004535000	26033	12748	93	0	\N
195509	1397	1283994534000	26033	12748	94	0	\N
195510	1397	1283984533000	26033	12748	95	0	\N
195511	1397	1283974532000	26033	12748	96	0	\N
195512	1397	1283964531000	26033	12748	97	0	\N
195513	1397	1283954530000	26033	12748	98	0	\N
195514	1397	1283944529000	26033	12748	99	0	\N
195515	1397	1283934528000	26033	12748	100	0	\N
195516	1397	1283924527000	26033	12748	101	0	\N
195517	1397	1283914526000	26033	12748	102	0	\N
195518	1397	1283904525000	26033	12748	103	0	\N
195519	1397	1283894524000	26033	12748	104	0	\N
195520	1397	1283884523000	26033	12748	105	0	\N
195521	1397	1283874522000	26033	12748	106	0	\N
195522	1397	1283864521000	26033	12748	107	0	\N
195523	1397	1283854520000	26033	12748	108	0	\N
195524	1397	1283844519000	26033	12748	109	0	\N
195525	1397	1283834518000	26033	12748	110	0	\N
195526	1397	1283824517000	26033	12748	111	0	\N
195527	1397	1283814516000	26033	12748	112	0	\N
195528	1397	1283804515000	26033	12748	113	0	\N
195529	1397	1283794514000	26033	12748	114	0	\N
195530	1397	1283784513000	26033	12748	115	0	\N
195531	1397	1283774512000	26033	12748	116	0	\N
195532	1397	1283764511000	26033	12748	117	0	\N
195533	1397	1283754510000	26033	12748	118	0	\N
195534	1397	1283744509000	26033	12748	119	0	\N
195535	1397	1283734508000	26033	12748	120	0	\N
195536	1397	1283724507000	26033	12748	121	0	\N
195537	1397	1283714506000	26033	12748	122	0	\N
195538	1397	1283704505000	26033	12748	123	0	\N
195539	1397	1283694504000	26033	12748	124	0	\N
195540	1397	1283684503000	26033	12748	125	0	\N
195547	1397	1283204455000	26038	12866	0	0	\N
195548	1397	1283194454000	26038	12866	1	0	\N
195549	2134	84705423000	26038	12866	2	0	\N
195550	2134	84704420000	26038	12866	3	0	\N
195551	1397	1283204455000	26039	12866	0	0	\N
195552	1397	1283194454000	26039	12866	1	0	\N
195553	2134	84705423000	26039	12866	2	0	\N
195554	2134	84704420000	26039	12866	3	0	\N
195557	1397	1283174452000	26041	12868	0	0	\N
195558	2134	84702414000	26041	12868	1	0	\N
195559	1397	1283174452000	26042	12868	0	0	\N
195560	2134	84702414000	26042	12868	1	0	\N
195561	1397	1283174452000	26043	12868	0	0	\N
195562	2134	84702414000	26043	12868	1	0	\N
195543	1397	1283204455000	26037	12866	0	0	15562
195544	1397	1283194454000	26037	12866	1	0	15563
195545	2134	84705423000	26037	12866	2	0	5867
195546	2134	84704420000	26037	12866	3	0	5868
195555	1397	1283184453000	26040	12867	0	0	15564
195563	1397	1283174452000	26044	12868	0	0	15565
195564	2134	84702414000	26044	12868	1	0	5870
195565	1397	1283164451000	26045	12869	0	0	15566
195566	2134	84701411000	26045	12869	1	0	5871
195567	1397	1283154450000	26046	12870	0	0	15567
195571	1397	1283134448000	26047	12871	0	0	\N
195572	1397	1283124447000	26047	12871	1	0	\N
195596	1688	58655279750020	26051	12874	0	0	\N
195597	1688	58363792090020	26051	12874	1	0	\N
195598	1688	58158710265020	26051	12874	2	0	\N
195599	1688	55902912159020	26051	12874	3	0	\N
195600	1688	52612213832020	26051	12874	4	0	\N
195601	1688	16414663820020	26051	12874	5	0	\N
195602	1688	16414653694020	26051	12874	6	0	\N
195603	1688	10150586113020	26051	12874	7	0	\N
195604	1397	1283084443000	26051	12874	8	0	\N
195605	2134	84692384000	26051	12874	9	0	\N
195618	1688	58655279750020	26054	12875	0	0	\N
195619	1688	58363792090020	26054	12875	1	0	\N
195620	1688	58158710265020	26054	12875	2	0	\N
195621	1688	55902912159020	26054	12875	3	0	\N
195622	1688	52612213832020	26054	12875	4	0	\N
195623	1688	16414663820020	26054	12875	5	0	\N
195624	1688	16414653694020	26054	12875	6	0	\N
195625	1688	10150586113020	26054	12875	7	0	\N
195626	1397	1283074442000	26054	12875	8	0	\N
195627	2134	84691381000	26054	12875	9	0	\N
195630	1397	1283064441000	26057	12876	0	0	\N
195631	2134	84690378000	26057	12876	1	0	\N
195640	1688	69483948668020	26060	12862	0	0	\N
195641	1688	69343484612020	26060	12862	1	0	\N
195642	1688	69217570151020	26060	12862	2	0	\N
195643	1688	69164569222020	26060	12862	3	0	\N
195644	1688	68581659509020	26060	12862	4	0	\N
195645	1688	63918546115020	26060	12862	5	0	\N
195646	1688	63494617255020	26060	12862	6	0	\N
195647	1688	58831503861020	26060	12862	7	0	\N
195648	1688	58725512003020	26060	12862	8	0	\N
195649	1688	57559702576020	26060	12862	9	0	\N
195650	1688	57533199485020	26060	12862	10	0	\N
195651	1688	57241765742020	26060	12862	11	0	\N
195652	1688	57215257750020	26060	12862	12	0	\N
195653	1688	56923770090020	26060	12862	13	0	\N
195654	1688	56718688265020	26060	12862	14	0	\N
195655	1688	54462890159020	26060	12862	15	0	\N
195656	1688	51172191832020	26060	12862	16	0	\N
195657	1688	14974641820020	26060	12862	17	0	\N
195658	1688	14974631694020	26060	12862	18	0	\N
195659	1688	8710564113020	26060	12862	19	0	\N
195660	1397	1283244459000	26060	12862	20	0	\N
195661	1397	1283234458000	26060	12862	21	0	\N
195662	1397	1283224457000	26060	12862	22	0	\N
195663	1397	1283214456000	26060	12862	23	0	\N
195664	1397	1283204455000	26060	12862	24	0	\N
195665	1397	1283194454000	26060	12862	25	0	\N
195666	1397	1283184453000	26060	12862	26	0	\N
195667	1397	1283174452000	26060	12862	27	0	\N
195668	1397	1283164451000	26060	12862	28	0	\N
195669	1397	1283154450000	26060	12862	29	0	\N
195670	1397	1283144449000	26060	12862	30	0	\N
195671	1397	1283134448000	26060	12862	31	0	\N
195672	1397	1283124447000	26060	12862	32	0	\N
195673	1397	1283114446000	26060	12862	33	0	\N
195674	1397	1283104445000	26060	12862	34	0	\N
195675	1397	1283094444000	26060	12862	35	0	\N
195676	1397	1283084443000	26060	12862	36	0	\N
195677	1397	1283074442000	26060	12862	37	0	\N
195678	1397	1283064441000	26060	12862	38	0	\N
195679	1397	1283054440000	26060	12862	39	0	\N
195680	1397	1283044439000	26060	12862	40	0	\N
195681	2134	84709435000	26060	12862	41	0	\N
195682	2134	84708432000	26060	12862	42	0	\N
195683	2134	84707429000	26060	12862	43	0	\N
195684	2134	84706426000	26060	12862	44	0	\N
195685	2134	84705423000	26060	12862	45	0	\N
195686	2134	84704420000	26060	12862	46	0	\N
195687	2134	84703417000	26060	12862	47	0	\N
195688	2134	84702414000	26060	12862	48	0	\N
195689	2134	84701411000	26060	12862	49	0	\N
195690	2134	84700408000	26060	12862	50	0	\N
195691	2134	84699405000	26060	12862	51	0	\N
195692	2134	84698402000	26060	12862	52	0	\N
195693	2134	84697399000	26060	12862	53	0	\N
195694	2134	84696396000	26060	12862	54	0	\N
195695	2134	84695393000	26060	12862	55	0	\N
195696	2134	84694390000	26060	12862	56	0	\N
195697	2134	84693387000	26060	12862	57	0	\N
195698	2134	84692384000	26060	12862	59	0	\N
195699	2134	84691381000	26060	12862	60	0	\N
195700	2134	84690378000	26060	12862	61	0	\N
195701	2134	84689375000	26060	12862	62	0	\N
195702	2134	84688372000	26060	12862	63	0	\N
195573	1397	1283134448000	26048	12871	0	0	15569
195574	1397	1283124447000	26048	12871	1	0	15570
195575	1688	70923970668020	26049	12872	0	0	58
195576	1397	1283114446000	26049	12872	1	0	15571
195577	1397	1283104445000	26049	12872	2	0	15572
195579	1688	70657592151020	26049	12872	4	0	60
195580	1688	70604591222020	26049	12872	5	0	61
195581	2134	84698402000	26049	12872	6	0	5874
195582	2134	84697399000	26049	12872	7	0	5875
195583	2134	84696396000	26049	12872	8	0	5876
195585	2134	84694390000	26049	12872	10	0	5878
195586	1688	70021681509020	26050	12873	0	0	62
195587	1397	1283094444000	26050	12873	2	0	15573
195588	1688	65358568115020	26050	12873	3	0	63
195590	1688	60271525861020	26050	12873	5	0	65
195591	1688	60165534003020	26050	12873	6	0	66
195592	1688	58999724576020	26050	12873	7	0	67
195593	1688	58973221485020	26050	12873	8	0	68
195594	1688	58681787742020	26050	12873	9	0	69
195606	1397	1283084443000	26052	12874	0	0	15574
195607	2134	84692384000	26052	12874	1	0	5880
195608	1688	58655279750020	26053	12875	0	0	70
195609	1688	58363792090020	26053	12875	1	0	71
195610	1688	58158710265020	26053	12875	2	0	72
195612	1688	52612213832020	26053	12875	4	0	74
195613	1688	16414663820020	26053	12875	5	0	75
195614	1688	16414653694020	26053	12875	6	0	76
195615	1688	10150586113020	26053	12875	7	0	77
195617	2134	84691381000	26053	12875	9	0	5881
195628	1397	1283064441000	26056	12876	0	0	15576
195629	2134	84690378000	26056	12876	1	0	5882
195632	1397	1283054440000	26058	12877	0	0	15577
195633	2134	84689375000	26058	12877	1	0	5883
195635	1679	34247309235000	26059	12878	1	0	77
195636	1679	33895327813000	26059	12878	2	0	78
195637	1679	31289386384000	26059	12878	3	0	79
195638	1397	1283044439000	26059	12878	4	0	15578
195639	2134	84688372000	26059	12878	5	0	5884
195704	1397	1283034438000	26061	12879	1	0	15579
195718	1397	1283024437000	26063	12880	0	0	\N
195719	1397	1283014436000	26063	12880	1	0	\N
195720	2134	84686366000	26063	12880	2	0	\N
195721	2134	84685363000	26063	12880	3	0	\N
195746	1397	1282974432000	26066	12882	0	0	\N
195747	1397	1282964431000	26066	12882	1	0	\N
195748	1679	5222585143000	26066	12882	2	0	\N
195749	1397	1282954430000	26066	12882	3	0	\N
195750	1397	1282944429000	26066	12882	4	0	\N
195751	2134	84681351000	26066	12882	5	0	\N
195752	2134	84680348000	26066	12882	6	0	\N
195753	2134	84679345000	26066	12882	7	0	\N
195754	2134	84678342000	26066	12882	8	0	\N
195755	1397	1282934428000	26067	12883	0	0	\N
195756	1679	4917984489000	26067	12883	1	0	\N
195757	1397	1282924427000	26067	12883	2	0	\N
195758	1679	3598081657000	26067	12883	3	0	\N
195759	2134	84677339000	26067	12883	4	0	\N
195760	2134	84676336000	26067	12883	5	0	\N
195775	1397	1282914426000	26070	12884	0	0	\N
195776	1397	1282904425000	26070	12884	1	0	\N
195777	1397	1282894424000	26070	12884	2	0	\N
195778	2134	84675333000	26070	12884	3	0	\N
195779	2134	84674330000	26070	12884	4	0	\N
195780	2134	84673327000	26070	12884	5	0	\N
195785	1397	1282874422000	26072	12885	0	0	\N
195786	1397	1282864421000	26072	12885	1	0	\N
195787	2134	84671321000	26072	12885	2	0	\N
195788	2134	84670318000	26072	12885	3	0	\N
195791	1397	1282854420000	26074	12886	0	0	\N
195792	2134	84669315000	26074	12886	1	0	\N
195795	1397	1282844419000	26076	12887	0	0	\N
195796	2134	84668312000	26076	12887	1	0	\N
195797	1397	1282844419000	26077	12887	0	0	\N
195798	2134	84668312000	26077	12887	1	0	\N
195799	1397	1282834418000	26078	12888	0	0	\N
195800	2134	84667309000	26078	12888	1	0	\N
195803	1397	1282824417000	26080	12889	0	0	\N
195804	2134	84666306000	26080	12889	2	0	\N
195805	1397	1282824417000	26081	12889	0	0	\N
195806	2134	84666306000	26081	12889	2	0	\N
195809	1397	1282824417000	26083	12889	0	0	\N
195810	2134	84666306000	26083	12889	2	0	\N
195823	1397	1282764411000	26087	12892	0	0	\N
195824	2134	84660288000	26087	12892	1	0	\N
195827	1397	1282754410000	26089	12893	0	0	\N
195828	2134	84659285000	26089	12893	1	0	\N
195829	1397	1282744409000	26090	12894	0	0	\N
195830	2134	84658282000	26090	12894	1	0	\N
195831	1397	1282744409000	26091	12894	0	0	\N
195832	2134	84658282000	26091	12894	1	0	\N
195707	1679	24647773919000	26061	12879	4	0	83
195708	1679	23622308719000	26061	12879	5	0	84
195709	1679	22722064121000	26061	12879	6	0	85
195710	1679	17239422355000	26061	12879	7	0	86
195711	1679	16653087531000	26061	12879	8	0	87
195713	2134	84687369000	26061	12879	10	0	5885
195714	1397	1283024437000	26062	12880	0	0	15580
195715	1397	1283014436000	26062	12880	1	0	15581
195716	2134	84686366000	26062	12880	2	0	5886
195717	2134	84685363000	26062	12880	3	0	5887
195723	1679	10361313183000	26064	12881	1	0	90
195724	1679	9852554890000	26064	12881	2	0	91
195725	1679	8735712494000	26064	12881	3	0	92
195726	1679	8588378087000	26064	12881	4	0	93
195728	1679	8236559944000	26064	12881	6	0	95
195729	1679	7287242407000	26064	12881	7	0	96
195730	1679	5703171507000	26064	12881	8	0	97
195731	1397	1283004435000	26064	12881	9	0	15582
195732	1397	1282994434000	26064	12881	10	0	15583
195734	2134	84684360000	26064	12881	12	0	5888
195735	2134	84683357000	26064	12881	13	0	5889
195736	2134	84682354000	26064	12881	14	0	5890
195737	1397	1282974432000	26065	12882	0	0	15585
195738	1397	1282964431000	26065	12882	1	0	15586
195740	1397	1282954430000	26065	12882	3	0	15587
195741	1397	1282944429000	26065	12882	4	0	15588
195742	2134	84681351000	26065	12882	5	0	5891
195743	2134	84680348000	26065	12882	6	0	5892
195745	2134	84678342000	26065	12882	8	0	5894
195761	1397	1282934428000	26068	12883	0	0	15589
195762	1679	4917984489000	26068	12883	1	0	99
195763	1397	1282924427000	26068	12883	2	0	15590
195764	1679	3598081657000	26068	12883	3	0	100
195766	2134	84676336000	26068	12883	5	0	5896
195767	1397	1282914426000	26069	12884	0	0	15591
195768	1397	1282904425000	26069	12884	1	0	15592
195769	1397	1282894424000	26069	12884	2	0	15593
195770	1397	1282884423000	26069	12884	3	0	15594
195772	2134	84674330000	26069	12884	5	0	5898
195773	2134	84673327000	26069	12884	6	0	5899
195774	2134	84672324000	26069	12884	7	0	5900
195781	1397	1282874422000	26071	12885	0	0	15595
195783	2134	84671321000	26071	12885	2	0	5901
195784	2134	84670318000	26071	12885	3	0	5902
195789	1397	1282854420000	26073	12886	0	0	15597
195790	2134	84669315000	26073	12886	1	0	5903
195793	1397	1282844419000	26075	12887	0	0	15598
195801	1397	1282834418000	26079	12888	0	0	15599
195802	2134	84667309000	26079	12888	1	0	5905
195807	1397	1282824417000	26082	12889	0	0	15600
195808	2134	84666306000	26082	12889	2	0	5906
195811	1397	1282814416000	26084	12890	0	0	15601
195813	1397	1282794414000	26084	12890	2	0	15603
195814	1397	1282784413000	26084	12890	3	0	15604
195815	2134	84665303000	26084	12890	4	0	5907
195816	2134	84664300000	26084	12890	5	0	5908
195818	2134	84662294000	26084	12890	7	0	5910
195819	1397	1282774412000	26085	12891	0	0	15605
195820	2134	84661291000	26085	12891	1	0	5911
195821	1397	1282764411000	26086	12892	0	0	15606
195822	2134	84660288000	26086	12892	1	0	5912
195826	2134	84659285000	26088	12893	1	0	5913
195833	1397	1282744409000	26092	12894	0	0	15608
195834	2134	84658282000	26092	12894	1	0	5914
195835	1397	1282734408000	26093	12895	0	0	15609
195836	2134	84657279000	26093	12895	1	0	5915
195838	2134	84656276000	26094	12896	1	0	5916
195839	1397	1282714406000	26095	12897	0	0	15611
195840	2134	84655273000	26095	12897	1	0	5917
195841	1679	34436108583000	26096	12855	0	0	\N
195842	1688	69483948668020	26096	12855	1	0	\N
195843	1397	1283314466000	26096	12855	2	0	\N
195844	1397	1283304465000	26096	12855	3	0	\N
195845	1397	1283294464000	26096	12855	4	0	\N
195846	1688	69343484612020	26096	12855	5	0	\N
195847	1688	69217570151020	26096	12855	6	0	\N
195848	1688	69164569222020	26096	12855	7	0	\N
195849	1688	68581659509020	26096	12855	8	0	\N
195850	1688	63918546115020	26096	12855	9	0	\N
195851	1397	1283284463000	26096	12855	10	0	\N
195852	1397	1283274462000	26096	12855	11	0	\N
195853	1397	1283264461000	26096	12855	12	0	\N
195854	1397	1283254460000	26096	12855	13	0	\N
195855	1679	34247309235000	26096	12855	14	0	\N
195856	1679	33895327813000	26096	12855	15	0	\N
195857	1679	31289386384000	26096	12855	16	0	\N
195858	1679	26241293952000	26096	12855	17	0	\N
195859	1679	25684651640000	26096	12855	18	0	\N
195860	1679	25390204008000	26096	12855	19	0	\N
195861	1679	24647773919000	26096	12855	20	0	\N
195862	1679	23622308719000	26096	12855	21	0	\N
195863	1679	22722064121000	26096	12855	22	0	\N
195864	1679	17239422355000	26096	12855	23	0	\N
195865	1679	16653087531000	26096	12855	24	0	\N
195866	1679	11170445765000	26096	12855	25	0	\N
195867	1679	10689859401000	26096	12855	26	0	\N
195868	1679	10385258747000	26096	12855	27	0	\N
195869	1679	9065355915000	26096	12855	28	0	\N
195870	1679	7948513519000	26096	12855	29	0	\N
195871	1679	7801179112000	26096	12855	30	0	\N
195872	1679	7713349535000	26096	12855	31	0	\N
195873	1679	7449360969000	26096	12855	32	0	\N
195874	1679	6500043432000	26096	12855	33	0	\N
195875	1688	63494617255020	26096	12855	34	0	\N
195876	1688	58831503861020	26096	12855	35	0	\N
195877	1688	58725512003020	26096	12855	36	0	\N
195878	1688	57559702576020	26096	12855	37	0	\N
195879	1688	57533199485020	26096	12855	38	0	\N
195880	1688	57241765742020	26096	12855	39	0	\N
195881	1688	57215257750020	26096	12855	40	0	\N
195882	1688	56923770090020	26096	12855	41	0	\N
195883	1688	56718688265020	26096	12855	42	0	\N
195884	1688	54462890159020	26096	12855	43	0	\N
195885	1688	51172191832020	26096	12855	44	0	\N
195886	1688	14974641820020	26096	12855	45	0	\N
195887	1688	14974631694020	26096	12855	46	0	\N
195888	1688	8710564113020	26096	12855	47	0	\N
195889	1679	4915972532000	26096	12855	48	0	\N
195890	1679	4435386168000	26096	12855	49	0	\N
195891	1679	4130785514000	26096	12855	50	0	\N
195892	1679	2810882682000	26096	12855	51	0	\N
195893	1397	1283244459000	26096	12855	52	0	\N
195894	1397	1283234458000	26096	12855	53	0	\N
195895	1397	1283224457000	26096	12855	54	0	\N
195896	1397	1283214456000	26096	12855	55	0	\N
195897	1397	1283204455000	26096	12855	56	0	\N
195898	1397	1283194454000	26096	12855	57	0	\N
195899	1397	1283184453000	26096	12855	58	0	\N
195900	1397	1283174452000	26096	12855	59	0	\N
195901	1397	1283164451000	26096	12855	60	0	\N
195902	1397	1283154450000	26096	12855	61	0	\N
195903	1397	1283144449000	26096	12855	62	0	\N
195904	1397	1283134448000	26096	12855	63	0	\N
195905	1397	1283124447000	26096	12855	64	0	\N
195906	1397	1283114446000	26096	12855	65	0	\N
195907	1397	1283104445000	26096	12855	66	0	\N
195908	1397	1283094444000	26096	12855	67	0	\N
195909	1397	1283084443000	26096	12855	68	0	\N
195910	1397	1283074442000	26096	12855	69	0	\N
195911	1397	1283064441000	26096	12855	70	0	\N
195912	1397	1283054440000	26096	12855	71	0	\N
195913	1397	1283044439000	26096	12855	72	0	\N
195914	1397	1283034438000	26096	12855	73	0	\N
195915	1397	1283024437000	26096	12855	74	0	\N
195916	1397	1283014436000	26096	12855	75	0	\N
195917	1397	1283004435000	26096	12855	76	0	\N
195918	1397	1282994434000	26096	12855	77	0	\N
195919	1397	1282984433000	26096	12855	78	0	\N
195920	1397	1282974432000	26096	12855	79	0	\N
195921	1397	1282964431000	26096	12855	80	0	\N
195922	1397	1282954430000	26096	12855	81	0	\N
195923	1397	1282944429000	26096	12855	82	0	\N
195924	1397	1282934428000	26096	12855	83	0	\N
195925	1397	1282924427000	26096	12855	84	0	\N
195926	1397	1282914426000	26096	12855	85	0	\N
195927	1397	1282904425000	26096	12855	86	0	\N
195928	1397	1282894424000	26096	12855	87	0	\N
195929	1397	1282884423000	26096	12855	88	0	\N
195930	1397	1282874422000	26096	12855	89	0	\N
195931	1397	1282864421000	26096	12855	90	0	\N
195932	1397	1282854420000	26096	12855	91	0	\N
195933	1397	1282844419000	26096	12855	93	0	\N
195934	1397	1282834418000	26096	12855	94	0	\N
195935	1397	1282824417000	26096	12855	95	0	\N
195936	1397	1282814416000	26096	12855	96	0	\N
195937	1397	1282804415000	26096	12855	97	0	\N
195938	1397	1282794414000	26096	12855	98	0	\N
195939	1397	1282784413000	26096	12855	99	0	\N
195940	1397	1282774412000	26096	12855	100	0	\N
195941	1397	1282764411000	26096	12855	101	0	\N
195942	1397	1282754410000	26096	12855	102	0	\N
195943	1397	1282744409000	26096	12855	103	0	\N
195944	1397	1282734408000	26096	12855	104	0	\N
195945	1397	1282724407000	26096	12855	105	0	\N
195946	1397	1282714406000	26096	12855	106	0	\N
195947	1159	614190748000000	26096	12855	107	0	\N
195948	2133	91165976000	26096	12855	108	0	\N
195949	2134	84716456000	26096	12855	109	0	\N
195950	2133	91164974000	26096	12855	110	0	\N
195951	2133	91163972000	26096	12855	111	0	\N
195952	2133	91162970000	26096	12855	112	0	\N
195953	2133	91161968000	26096	12855	113	0	\N
195954	2134	84715453000	26096	12855	114	0	\N
195955	2134	84714450000	26096	12855	115	0	\N
195956	2134	84713447000	26096	12855	116	0	\N
195957	2134	84712444000	26096	12855	117	0	\N
195958	2134	84711441000	26096	12855	118	0	\N
195959	2134	84710438000	26096	12855	119	0	\N
195960	2134	84709435000	26096	12855	120	0	\N
195961	2134	84708432000	26096	12855	121	0	\N
195962	2134	84707429000	26096	12855	122	0	\N
195963	2134	84706426000	26096	12855	123	0	\N
195964	2134	84705423000	26096	12855	124	0	\N
195965	2134	84704420000	26096	12855	125	0	\N
195966	1397	1282704405000	26097	12898	0	0	\N
195967	2134	84654270000	26097	12898	1	0	\N
195975	1397	1282674402000	26101	12901	0	0	\N
195976	1397	1282664401000	26101	12901	1	0	\N
195970	1397	1282694404000	26099	12899	0	0	15613
195971	2320	775740211465	26099	12899	1	0	3
195972	2134	84653267000	26099	12899	2	0	5919
195973	1397	1282684403000	26100	12900	0	0	15614
195974	2134	84652264000	26100	12900	1	0	5920
195977	2134	84651261000	26101	12901	2	0	\N
195978	2134	84650258000	26101	12901	3	0	\N
195983	1397	1282674402000	26103	12901	0	0	\N
195984	1397	1282664401000	26103	12901	1	0	\N
195985	2134	84651261000	26103	12901	2	0	\N
195986	2134	84650258000	26103	12901	3	0	\N
195989	1397	1282654400000	26105	12902	0	0	\N
195990	2134	84649255000	26105	12902	1	0	\N
195995	470	76799314000000	26107	12626	0	0	\N
195996	1679	30836047583000	26107	12626	1	0	\N
195997	1688	63723836668020	26107	12626	2	0	\N
195998	1688	63583372612020	26107	12626	3	0	\N
195999	1688	63457458151020	26107	12626	4	0	\N
196000	1688	63404457222020	26107	12626	5	0	\N
196001	1688	62821547509020	26107	12626	6	0	\N
196002	1688	58158434115020	26107	12626	7	0	\N
196003	1679	30647248235000	26107	12626	8	0	\N
196004	1679	30295266813000	26107	12626	9	0	\N
196005	1679	27689325384000	26107	12626	10	0	\N
196006	1679	22641232952000	26107	12626	11	0	\N
196007	1679	22084590640000	26107	12626	12	0	\N
196008	1678	26640830297000	26107	12626	13	0	\N
196009	1679	21790143008000	26107	12626	14	0	\N
196010	1679	21047712919000	26107	12626	15	0	\N
196011	1679	20022247719000	26107	12626	16	0	\N
196012	1679	19122003121000	26107	12626	17	0	\N
196013	1679	13639361355000	26107	12626	18	0	\N
196014	1679	13053026531000	26107	12626	19	0	\N
196015	1679	7570384765000	26107	12626	20	0	\N
196016	1679	7089798401000	26107	12626	21	0	\N
196017	1679	6785197747000	26107	12626	22	0	\N
196018	1679	5465294915000	26107	12626	23	0	\N
196019	1679	4348452519000	26107	12626	24	0	\N
196020	1679	4201118112000	26107	12626	25	0	\N
196021	1679	4113288535000	26107	12626	26	0	\N
196022	1679	3849299969000	26107	12626	27	0	\N
196023	1679	2899982432000	26107	12626	28	0	\N
196024	470	76675304000000	26107	12626	29	0	\N
196025	1688	57734505255020	26107	12626	30	0	\N
196026	1688	53071391861020	26107	12626	31	0	\N
196027	1688	52965400003020	26107	12626	32	0	\N
196028	1688	51799590576020	26107	12626	33	0	\N
196029	1688	51773087485020	26107	12626	34	0	\N
196030	1688	51481653742020	26107	12626	35	0	\N
196031	1688	51455145750020	26107	12626	36	0	\N
196032	1688	51163658090020	26107	12626	37	0	\N
196033	1688	50958576265020	26107	12626	38	0	\N
196034	1688	48702778159020	26107	12626	39	0	\N
196035	1688	45412079832020	26107	12626	40	0	\N
196036	1688	9214529820020	26107	12626	41	0	\N
196037	1688	9214519694020	26107	12626	42	0	\N
196038	1688	2950452113020	26107	12626	43	0	\N
196039	1679	1315911532000	26107	12626	44	0	\N
196040	1679	835325168000	26107	12626	45	0	\N
196041	1679	530724514000	26107	12626	46	0	\N
196042	1159	614190748000000	26107	12626	47	0	\N
196043	2320	775740211465	26107	12626	48	0	\N
196044	2030	199000000	26107	12626	49	0	\N
196045	547	66719010000000	26107	12626	50	0	\N
196046	610	67438023000000	26107	12626	51	0	\N
196047	547	66000009000000	26107	12626	52	0	\N
196048	568	66000007000000	26107	12626	53	0	\N
196049	610	66000022000000	26107	12626	54	0	\N
196050	2073	776166541448	26107	12626	55	0	\N
196051	547	66000004000000	26107	12626	56	0	\N
196052	610	66000021000000	26107	12626	57	0	\N
196053	1397	1282624397000	26108	12904	0	0	\N
196054	2134	84646246000	26108	12904	1	0	\N
196055	1397	1282624397000	26109	12904	0	0	\N
196056	2134	84646246000	26109	12904	1	0	\N
196057	1397	1282624397000	26110	12904	0	0	\N
196058	2134	84646246000	26110	12904	1	0	\N
196061	1397	1282624397000	26112	12904	0	0	\N
196062	2134	84646246000	26112	12904	1	0	\N
196083	1397	1282514386000	26120	12912	0	0	\N
196084	2134	84635213000	26120	12912	1	0	\N
196093	1397	1282484383000	26124	12914	0	0	\N
196094	2134	84632204000	26124	12914	1	0	\N
196099	1397	1282454380000	26127	12917	0	0	\N
196100	2134	84629195000	26127	12917	1	0	\N
196101	1397	1282454380000	26128	12917	0	0	\N
196102	2134	84629195000	26128	12917	1	0	\N
196103	1397	1282454380000	26129	12917	0	0	\N
196104	2134	84629195000	26129	12917	1	0	\N
196107	1397	1282454380000	26131	12917	0	0	\N
196108	2134	84629195000	26131	12917	1	0	\N
196109	1397	1282444379000	26132	12918	0	0	\N
196110	2134	84628192000	26132	12918	1	0	\N
195981	2134	84651261000	26102	12901	2	0	5921
195982	2134	84650258000	26102	12901	3	0	5922
195987	1397	1282654400000	26104	12902	0	0	15617
195988	2134	84649255000	26104	12902	1	0	5923
195991	1397	1282644399000	26106	12903	0	0	15618
195993	2134	84648252000	26106	12903	2	0	5924
195994	2134	84647249000	26106	12903	3	0	5925
196059	1397	1282624397000	26111	12904	0	0	15620
196060	2134	84646246000	26111	12904	1	0	5926
196063	1397	1282614396000	26113	12905	0	0	15621
196065	1397	1282604395000	26114	12906	0	0	15622
196066	2134	84644240000	26114	12906	1	0	5928
196067	1397	1282594394000	26115	12907	0	0	15623
196068	2134	84643237000	26115	12907	1	0	5929
196070	2134	84642234000	26116	12908	1	0	5930
196071	1397	1282574392000	26117	12909	0	0	15625
196072	1397	1282564391000	26117	12909	1	0	15626
196073	2134	84641231000	26117	12909	2	0	5931
196074	2134	84640228000	26117	12909	3	0	5932
196076	1397	1282544389000	26118	12910	1	0	15628
196077	2134	84639225000	26118	12910	2	0	5933
196078	2134	84638222000	26118	12910	3	0	5934
196079	1397	1282534388000	26119	12911	0	0	15629
196080	1397	1282524387000	26119	12911	1	0	15630
196082	2134	84636216000	26119	12911	3	0	5936
196085	1397	1282514386000	26121	12912	0	0	15631
196086	2134	84635213000	26121	12912	1	0	5937
196087	1397	1282504385000	26122	12913	0	0	15632
196089	2134	84634210000	26122	12913	2	0	5938
196090	2134	84633207000	26122	12913	3	0	5939
196091	1397	1282484383000	26123	12914	0	0	15634
196092	2134	84632204000	26123	12914	1	0	5940
196095	1397	1282474382000	26125	12915	0	0	15635
196097	1397	1282464381000	26126	12916	0	0	15636
196098	2134	84630198000	26126	12916	2	0	5942
196105	1397	1282454380000	26130	12917	0	0	15637
196106	2134	84629195000	26130	12917	1	0	5943
196111	1397	1282444379000	26133	12918	0	0	15638
196113	1397	1282444379000	26134	12918	0	0	\N
196114	2134	84628192000	26134	12918	1	0	\N
196117	1397	1282434378000	26136	12919	0	0	\N
196118	2134	84627189000	26136	12919	1	0	\N
196123	1397	1282404375000	26138	12921	0	0	\N
196124	2134	84624180000	26138	12921	1	0	\N
196127	1397	1282404375000	26140	12921	0	0	\N
196128	2134	84624180000	26140	12921	1	0	\N
196133	1397	1282384373000	26143	12923	0	0	\N
196134	2134	84622174000	26143	12923	1	0	\N
196135	1397	1282384373000	26144	12923	0	0	\N
196136	2134	84622174000	26144	12923	1	0	\N
196151	1397	1282454380000	26149	12917	0	0	\N
196152	1397	1282444379000	26149	12917	1	0	\N
196153	1397	1282434378000	26149	12917	2	0	\N
196154	1397	1282424377000	26149	12917	3	0	\N
196155	1397	1282414376000	26149	12917	4	0	\N
196156	1397	1282404375000	26149	12917	5	0	\N
196157	1397	1282394374000	26149	12917	6	0	\N
196158	1397	1282384373000	26149	12917	7	0	\N
196159	1397	1282374372000	26149	12917	8	0	\N
196160	1397	1282364371000	26149	12917	9	0	\N
196161	1397	1282354370000	26149	12917	10	0	\N
196162	1397	1282344369000	26149	12917	11	0	\N
196163	1397	1282334368000	26149	12917	12	0	\N
196164	2133	91160966000	26149	12917	13	0	\N
196165	2133	91159964000	26149	12917	14	0	\N
196166	2134	84629195000	26149	12917	15	0	\N
196167	2134	84628192000	26149	12917	16	0	\N
196168	2133	91158962000	26149	12917	17	0	\N
196169	2133	91157960000	26149	12917	18	0	\N
196170	2134	84627189000	26149	12917	19	0	\N
196171	2134	84626186000	26149	12917	20	0	\N
196172	2134	84625183000	26149	12917	21	0	\N
196173	2134	84624180000	26149	12917	22	0	\N
196174	2134	84623177000	26149	12917	23	0	\N
196175	2134	84622174000	26149	12917	24	0	\N
196176	2134	84621171000	26149	12917	25	0	\N
196177	2134	84620168000	26149	12917	26	0	\N
196178	2134	84619165000	26149	12917	27	0	\N
196179	2134	84618162000	26149	12917	28	0	\N
196180	2134	84617159000	26149	12917	29	0	\N
196181	1397	1282324367000	26150	12928	0	0	\N
196182	1397	1282314366000	26150	12928	1	0	\N
196183	2134	84616156000	26150	12928	2	0	\N
196184	2134	84615153000	26150	12928	3	0	\N
196185	2133	91156958000	26150	12928	4	0	\N
196186	2133	91155956000	26150	12928	5	0	\N
196193	1397	1282324367000	26152	12928	0	0	\N
196194	1397	1282314366000	26152	12928	1	0	\N
196195	2134	84616156000	26152	12928	2	0	\N
196196	2134	84615153000	26152	12928	3	0	\N
196197	2133	91156958000	26152	12928	4	0	\N
196198	2133	91155956000	26152	12928	5	0	\N
196199	1397	1282324367000	26153	12928	0	0	\N
196200	1397	1282314366000	26153	12928	1	0	\N
196201	2134	84616156000	26153	12928	2	0	\N
196202	2134	84615153000	26153	12928	3	0	\N
196203	2133	91156958000	26153	12928	4	0	\N
196204	2133	91155956000	26153	12928	5	0	\N
196205	1397	1282324367000	26154	12928	0	0	\N
196206	1397	1282314366000	26154	12928	1	0	\N
196207	2134	84616156000	26154	12928	2	0	\N
196208	2134	84615153000	26154	12928	3	0	\N
196209	2133	91156958000	26154	12928	4	0	\N
196210	2133	91155956000	26154	12928	5	0	\N
196211	1397	1282304365000	26155	12929	0	0	\N
196212	2133	91154954000	26155	12929	1	0	\N
196213	1726	998997112000	26155	12929	2	0	\N
196214	2134	84614150000	26155	12929	3	0	\N
196215	1726	997896112000	26155	12929	4	0	\N
196221	1397	1282304365000	26157	12929	0	0	\N
196222	2133	91154954000	26157	12929	1	0	\N
196223	1726	998997112000	26157	12929	2	0	\N
196224	2134	84614150000	26157	12929	3	0	\N
196225	1726	997896112000	26157	12929	4	0	\N
196226	1397	1282304365000	26158	12929	0	0	\N
196227	2133	91154954000	26158	12929	1	0	\N
196228	1726	998997112000	26158	12929	2	0	\N
196229	2134	84614150000	26158	12929	3	0	\N
196230	1726	997896112000	26158	12929	4	0	\N
196231	1397	1282294364000	26159	12930	0	0	\N
196232	1397	1282284363000	26159	12930	1	0	\N
196233	2133	91153952000	26159	12930	2	0	\N
196234	2134	84613147000	26159	12930	3	0	\N
196235	1726	996795112000	26159	12930	4	0	\N
196236	1726	995694112000	26159	12930	5	0	\N
196237	2133	91152950000	26159	12930	6	0	\N
196238	2134	84612144000	26159	12930	7	0	\N
196119	1397	1282424377000	26137	12920	0	0	15640
196120	1397	1282414376000	26137	12920	1	0	15641
196121	2134	84626186000	26137	12920	2	0	5946
196122	2134	84625183000	26137	12920	3	0	5947
196125	1397	1282404375000	26139	12921	0	0	15642
196129	1397	1282394374000	26141	12922	0	0	15643
196130	2134	84623177000	26141	12922	1	0	5949
196131	1397	1282384373000	26142	12923	0	0	15644
196132	2134	84622174000	26142	12923	1	0	5950
196137	1397	1282374372000	26145	12924	0	0	15645
196139	1397	1282364371000	26146	12925	0	0	15646
196140	2133	91160966000	26146	12925	1	0	5519
196141	2134	84620168000	26146	12925	2	0	5952
196142	1397	1282354370000	26147	12926	0	0	15647
196144	2133	91159964000	26147	12926	2	0	5520
196145	2133	91158962000	26147	12926	3	0	5521
196146	2134	84619165000	26147	12926	4	0	5953
196147	2134	84618162000	26147	12926	5	0	5954
196148	1397	1282334368000	26148	12927	0	0	15649
196150	2134	84617159000	26148	12927	2	0	5955
196187	1397	1282324367000	26151	12928	0	0	15650
196188	1397	1282314366000	26151	12928	1	0	15651
196189	2134	84616156000	26151	12928	2	0	5956
196190	2134	84615153000	26151	12928	3	0	5957
196192	2133	91155956000	26151	12928	5	0	5524
196216	1397	1282304365000	26156	12929	0	0	15652
196217	2133	91154954000	26156	12929	1	0	5525
196218	1726	998997112000	26156	12929	2	0	8288
196220	1726	997896112000	26156	12929	4	0	8289
196239	1397	1282294364000	26160	12930	0	0	15653
196240	1397	1282284363000	26160	12930	1	0	15654
196241	2133	91153952000	26160	12930	2	0	5526
196242	2134	84613147000	26160	12930	3	0	5959
196244	1726	995694112000	26160	12930	5	0	8291
196245	2133	91152950000	26160	12930	6	0	5527
196246	2134	84612144000	26160	12930	7	0	5960
196247	1397	1282274362000	26161	12931	0	0	15655
196248	2133	91151948000	26161	12931	1	0	5528
196256	1397	1282264361000	26163	12932	0	0	\N
196257	2133	91150946000	26163	12932	1	0	\N
196258	2134	84610138000	26163	12932	2	0	\N
196268	1397	1282234358000	26166	12934	0	0	\N
196269	2134	84607129000	26166	12934	1	0	\N
196270	2133	91147940000	26166	12934	2	0	\N
196285	1397	1282194354000	26174	12940	0	0	\N
196286	1397	1282184353000	26174	12940	1	0	\N
196287	1397	1282174352000	26174	12940	2	0	\N
196288	1397	1282164351000	26174	12940	3	0	\N
196289	2134	84602114000	26174	12940	4	0	\N
196290	2133	91142930000	26174	12940	5	0	\N
196291	2132	147430443000	26174	12940	6	0	\N
196292	2132	147429442000	26174	12940	7	0	\N
196293	2133	91141928000	26174	12940	8	0	\N
196294	2133	91140926000	26174	12940	9	0	\N
196295	2133	91139924000	26174	12940	10	0	\N
196296	2134	84601111000	26174	12940	11	0	\N
196297	2134	84600108000	26174	12940	12	0	\N
196298	2134	84599105000	26174	12940	13	0	\N
196320	1397	1282154350000	26177	12941	0	0	\N
196321	1397	1282144349000	26177	12941	1	0	\N
196322	2132	147428441000	26177	12941	2	0	\N
196323	2133	91138922000	26177	12941	3	0	\N
196324	2134	84598102000	26177	12941	4	0	\N
196325	2134	84597099000	26177	12941	5	0	\N
196326	2133	91137920000	26177	12941	6	0	\N
196327	1397	1282154350000	26178	12941	0	0	\N
196328	1397	1282144349000	26178	12941	1	0	\N
196329	2132	147428441000	26178	12941	2	0	\N
196330	2133	91138922000	26178	12941	3	0	\N
196331	2134	84598102000	26178	12941	4	0	\N
196332	2134	84597099000	26178	12941	5	0	\N
196333	2133	91137920000	26178	12941	6	0	\N
196341	1397	1282114346000	26181	12944	0	0	\N
196342	2134	84594090000	26181	12944	1	0	\N
196343	2133	91134914000	26181	12944	2	0	\N
196344	1397	1282114346000	26182	12944	0	0	\N
196345	2134	84594090000	26182	12944	1	0	\N
196346	2133	91134914000	26182	12944	2	0	\N
196350	1397	1282114346000	26184	12944	0	0	\N
196351	2134	84594090000	26184	12944	1	0	\N
196352	2133	91134914000	26184	12944	2	0	\N
196353	1397	1282324367000	26185	12918	0	0	\N
196354	1397	1282314366000	26185	12918	1	0	\N
196355	1397	1282304365000	26185	12918	2	0	\N
196356	1397	1282294364000	26185	12918	3	0	\N
196357	1397	1282284363000	26185	12918	4	0	\N
196358	1397	1282274362000	26185	12918	5	0	\N
196359	1397	1282264361000	26185	12918	6	0	\N
196360	1397	1282254360000	26185	12918	7	0	\N
196361	1397	1282244359000	26185	12918	8	0	\N
196362	1397	1282234358000	26185	12918	9	0	\N
196363	1397	1282224357000	26185	12918	10	0	\N
196364	1397	1282214356000	26185	12918	11	0	\N
196365	1397	1282204355000	26185	12918	12	0	\N
196366	1397	1282194354000	26185	12918	13	0	\N
196367	1397	1282184353000	26185	12918	14	0	\N
196368	1397	1282174352000	26185	12918	15	0	\N
196369	1397	1282164351000	26185	12918	16	0	\N
196370	1397	1282154350000	26185	12918	17	0	\N
196371	1397	1282144349000	26185	12918	18	0	\N
196372	1397	1282134348000	26185	12918	19	0	\N
196373	1397	1282124347000	26185	12918	20	0	\N
196374	1397	1282114346000	26185	12918	21	0	\N
196375	1726	998997112000	26185	12918	22	0	\N
196376	2134	84616156000	26185	12918	23	0	\N
196377	2134	84615153000	26185	12918	24	0	\N
196378	2133	91156958000	26185	12918	25	0	\N
196379	2133	91155956000	26185	12918	26	0	\N
196380	2133	91154954000	26185	12918	27	0	\N
196381	2133	91153952000	26185	12918	28	0	\N
196382	2134	84614150000	26185	12918	29	0	\N
196383	2134	84613147000	26185	12918	30	0	\N
196384	2132	147430443000	26185	12918	31	0	\N
196251	1726	992391112000	26161	12931	4	0	8294
196252	2134	84611141000	26161	12931	5	0	5961
196253	1397	1282264361000	26162	12932	0	0	15656
196254	2133	91150946000	26162	12932	1	0	5529
196255	2134	84610138000	26162	12932	2	0	5962
196260	1397	1282244359000	26164	12933	1	0	15658
196261	2134	84609135000	26164	12933	2	0	5963
196262	2134	84608132000	26164	12933	3	0	5964
196263	2133	91149944000	26164	12933	4	0	5530
196264	2133	91148942000	26164	12933	5	0	5531
196266	2134	84607129000	26165	12934	1	0	5965
196267	2133	91147940000	26165	12934	2	0	5532
196271	1397	1282224357000	26167	12935	0	0	15660
196272	1397	1282214356000	26167	12935	1	0	15661
196274	2133	91145936000	26167	12935	3	0	5534
196275	2134	84606126000	26167	12935	4	0	5966
196276	2134	84605123000	26167	12935	5	0	5967
196277	1726	991290112000	26167	12935	6	0	8295
196278	1726	990189112000	26167	12935	7	0	8296
196280	2134	84604120000	26168	12936	1	0	5968
196281	2133	91144934000	26168	12936	2	0	5535
196282	1726	989088112000	26169	12937	0	0	8297
196283	2133	91143932000	26169	12937	1	0	5536
196284	2134	84603117000	26169	12937	2	0	5969
196300	1397	1282184353000	26175	12940	1	0	15664
196301	1397	1282174352000	26175	12940	2	0	15665
196302	1397	1282164351000	26175	12940	3	0	15666
196303	2134	84602114000	26175	12940	4	0	5970
196305	2132	147430443000	26175	12940	6	0	1558
196306	2132	147429442000	26175	12940	7	0	1559
196307	2133	91141928000	26175	12940	8	0	5538
196308	2133	91140926000	26175	12940	9	0	5539
196309	2133	91139924000	26175	12940	10	0	5540
196311	2134	84600108000	26175	12940	12	0	5972
196312	2134	84599105000	26175	12940	13	0	5973
196313	1397	1282154350000	26176	12941	0	0	15667
196314	1397	1282144349000	26176	12941	1	0	15668
196315	2132	147428441000	26176	12941	2	0	1560
196317	2134	84598102000	26176	12941	4	0	5974
196318	2134	84597099000	26176	12941	5	0	5975
196319	2133	91137920000	26176	12941	6	0	5542
196334	1397	1282134348000	26179	12942	0	0	15669
196336	1397	1282124347000	26180	12943	0	0	15670
196337	2133	91135916000	26180	12943	1	0	5544
196338	2134	84596096000	26180	12943	2	0	5976
196339	2134	84595093000	26180	12943	3	0	5977
196340	2132	147427440000	26180	12943	4	0	1561
196348	2134	84594090000	26183	12944	1	0	5978
196349	2133	91134914000	26183	12944	2	0	5545
196385	2132	147429442000	26185	12918	32	0	\N
196386	2132	147428441000	26185	12918	33	0	\N
196387	2133	91152950000	26185	12918	34	0	\N
196388	2133	91151948000	26185	12918	35	0	\N
196389	2133	91150946000	26185	12918	36	0	\N
196390	2132	147427440000	26185	12918	37	0	\N
196391	2133	91149944000	26185	12918	38	0	\N
196392	2133	91148942000	26185	12918	39	0	\N
196393	2133	91147940000	26185	12918	40	0	\N
196394	2133	91146938000	26185	12918	41	0	\N
196395	2133	91145936000	26185	12918	42	0	\N
196396	2133	91144934000	26185	12918	43	0	\N
196397	2133	91143932000	26185	12918	44	0	\N
196398	2133	91142930000	26185	12918	45	0	\N
196399	2134	84612144000	26185	12918	46	0	\N
196400	1726	997896112000	26185	12918	47	0	\N
196401	1726	996795112000	26185	12918	48	0	\N
196402	1726	995694112000	26185	12918	49	0	\N
196403	1726	994593112000	26185	12918	50	0	\N
196404	1726	993492112000	26185	12918	51	0	\N
196405	1726	992391112000	26185	12918	52	0	\N
196406	2133	91141928000	26185	12918	53	0	\N
196407	2133	91140926000	26185	12918	54	0	\N
196408	2133	91139924000	26185	12918	55	0	\N
196409	2133	91138922000	26185	12918	56	0	\N
196410	2133	91137920000	26185	12918	57	0	\N
196411	2133	91136918000	26185	12918	58	0	\N
196412	2133	91135916000	26185	12918	59	0	\N
196413	2133	91134914000	26185	12918	60	0	\N
196414	2134	84611141000	26185	12918	61	0	\N
196415	2134	84610138000	26185	12918	62	0	\N
196416	2134	84609135000	26185	12918	63	0	\N
196417	2134	84608132000	26185	12918	64	0	\N
196418	2134	84607129000	26185	12918	65	0	\N
196419	2134	84606126000	26185	12918	66	0	\N
196420	2134	84605123000	26185	12918	67	0	\N
196421	2134	84604120000	26185	12918	68	0	\N
196422	2134	84603117000	26185	12918	69	0	\N
196423	2134	84602114000	26185	12918	70	0	\N
196424	2134	84601111000	26185	12918	71	0	\N
196425	2134	84600108000	26185	12918	72	0	\N
196426	2134	84599105000	26185	12918	73	0	\N
196427	2134	84598102000	26185	12918	74	0	\N
196428	2134	84597099000	26185	12918	75	0	\N
196429	2134	84596096000	26185	12918	76	0	\N
196430	2134	84595093000	26185	12918	77	0	\N
196431	2134	84594090000	26185	12918	78	0	\N
196432	1726	991290112000	26185	12918	79	0	\N
196433	1726	990189112000	26185	12918	80	0	\N
196434	1726	989088112000	26185	12918	81	0	\N
196439	1397	1282104345000	26187	12945	0	0	\N
196440	2133	91133912000	26187	12945	1	0	\N
196441	2134	84593087000	26187	12945	2	0	\N
196442	1726	987987112000	26187	12945	3	0	\N
196447	1397	1282094344000	26189	12946	0	0	\N
196448	1637	301686278819988	26189	12946	1	0	\N
196449	2133	91132910000	26189	12946	2	0	\N
196450	2134	84592084000	26189	12946	3	0	\N
196451	1397	1283374472000	26190	12851	0	0	\N
196452	1679	34436108583000	26190	12851	1	0	\N
196453	1688	69483948668020	26190	12851	2	0	\N
196454	1688	69343484612020	26190	12851	3	0	\N
196455	1688	69217570151020	26190	12851	4	0	\N
196456	1688	69164569222020	26190	12851	5	0	\N
196457	1688	68581659509020	26190	12851	6	0	\N
196458	1688	63918546115020	26190	12851	7	0	\N
196459	1679	34247309235000	26190	12851	8	0	\N
196460	1679	33895327813000	26190	12851	9	0	\N
196461	1679	31289386384000	26190	12851	10	0	\N
196462	1679	26241293952000	26190	12851	11	0	\N
196463	1679	25684651640000	26190	12851	12	0	\N
196464	1679	25390204008000	26190	12851	13	0	\N
196465	1679	24647773919000	26190	12851	14	0	\N
196466	1679	23622308719000	26190	12851	15	0	\N
196467	1679	22722064121000	26190	12851	16	0	\N
196468	1679	17239422355000	26190	12851	17	0	\N
196469	1679	16653087531000	26190	12851	18	0	\N
196470	1679	11170445765000	26190	12851	19	0	\N
196471	1679	10689859401000	26190	12851	20	0	\N
196472	1679	10385258747000	26190	12851	21	0	\N
196473	1679	9065355915000	26190	12851	22	0	\N
196474	1679	7948513519000	26190	12851	23	0	\N
196475	1679	7801179112000	26190	12851	24	0	\N
196476	1679	7713349535000	26190	12851	25	0	\N
196477	1679	7449360969000	26190	12851	26	0	\N
196478	1679	6500043432000	26190	12851	27	0	\N
196479	1688	63494617255020	26190	12851	28	0	\N
196480	1688	58831503861020	26190	12851	29	0	\N
196481	1688	58725512003020	26190	12851	30	0	\N
196482	1688	57559702576020	26190	12851	31	0	\N
196483	1688	57533199485020	26190	12851	32	0	\N
196484	1688	57241765742020	26190	12851	33	0	\N
196485	1688	57215257750020	26190	12851	34	0	\N
196486	1688	56923770090020	26190	12851	35	0	\N
196487	1688	56718688265020	26190	12851	36	0	\N
196488	1688	54462890159020	26190	12851	37	0	\N
196489	1688	51172191832020	26190	12851	38	0	\N
196490	1688	14974641820020	26190	12851	39	0	\N
196491	1688	14974631694020	26190	12851	40	0	\N
196492	1688	8710564113020	26190	12851	41	0	\N
196493	1679	4915972532000	26190	12851	42	0	\N
196494	1679	4435386168000	26190	12851	43	0	\N
196495	1679	4130785514000	26190	12851	44	0	\N
196496	1679	2810882682000	26190	12851	45	0	\N
196497	1397	1283364471000	26190	12851	46	0	\N
196498	1397	1283354470000	26190	12851	47	0	\N
196499	1397	1283344469000	26190	12851	48	0	\N
196500	1397	1283334468000	26190	12851	49	0	\N
196501	1397	1283324467000	26190	12851	50	0	\N
196502	1397	1283314466000	26190	12851	51	0	\N
196503	1397	1283304465000	26190	12851	52	0	\N
196504	1397	1283294464000	26190	12851	53	0	\N
196505	1397	1283284463000	26190	12851	54	0	\N
196506	1397	1283274462000	26190	12851	55	0	\N
196507	1397	1283264461000	26190	12851	56	0	\N
196508	1397	1283254460000	26190	12851	57	0	\N
196509	1397	1283244459000	26190	12851	58	0	\N
196510	1397	1283234458000	26190	12851	59	0	\N
196511	1397	1283224457000	26190	12851	60	0	\N
196512	1397	1283214456000	26190	12851	61	0	\N
196513	1397	1283204455000	26190	12851	62	0	\N
196514	1397	1283194454000	26190	12851	63	0	\N
196515	1397	1283184453000	26190	12851	64	0	\N
196516	1397	1283174452000	26190	12851	65	0	\N
196517	1397	1283164451000	26190	12851	66	0	\N
196518	1397	1283154450000	26190	12851	67	0	\N
196519	1397	1283144449000	26190	12851	68	0	\N
196520	1397	1283134448000	26190	12851	69	0	\N
196437	2134	84593087000	26186	12945	2	0	5979
196438	1726	987987112000	26186	12945	3	0	8298
196443	1397	1282094344000	26188	12946	0	0	15673
196444	1637	301686278819988	26188	12946	1	0	1
196445	2133	91132910000	26188	12946	2	0	5547
196521	1397	1283124447000	26190	12851	70	0	\N
196522	1397	1283114446000	26190	12851	71	0	\N
196523	1397	1283104445000	26190	12851	72	0	\N
196524	1397	1283094444000	26190	12851	73	0	\N
196525	1397	1283084443000	26190	12851	74	0	\N
196526	1397	1283074442000	26190	12851	75	0	\N
196527	1397	1283064441000	26190	12851	76	0	\N
196528	1397	1283054440000	26190	12851	77	0	\N
196529	1397	1283044439000	26190	12851	78	0	\N
196530	1397	1283034438000	26190	12851	79	0	\N
196531	1397	1283024437000	26190	12851	80	0	\N
196532	1397	1283014436000	26190	12851	81	0	\N
196533	1397	1283004435000	26190	12851	82	0	\N
196534	1397	1282994434000	26190	12851	83	0	\N
196535	1397	1282984433000	26190	12851	84	0	\N
196536	1397	1282974432000	26190	12851	85	0	\N
196537	1397	1282964431000	26190	12851	86	0	\N
196538	1397	1282954430000	26190	12851	87	0	\N
196539	1397	1282944429000	26190	12851	88	0	\N
196540	1397	1282934428000	26190	12851	89	0	\N
196541	1397	1282924427000	26190	12851	90	0	\N
196542	1397	1282914426000	26190	12851	91	0	\N
196543	1397	1282904425000	26190	12851	92	0	\N
196544	1397	1282894424000	26190	12851	93	0	\N
196545	1397	1282884423000	26190	12851	94	0	\N
196546	1397	1282874422000	26190	12851	95	0	\N
196547	1397	1282864421000	26190	12851	96	0	\N
196548	1397	1282854420000	26190	12851	97	0	\N
196549	1397	1282844419000	26190	12851	98	0	\N
196550	1397	1282834418000	26190	12851	99	0	\N
196551	1397	1282824417000	26190	12851	100	0	\N
196552	1397	1282814416000	26190	12851	101	0	\N
196553	1397	1282804415000	26190	12851	102	0	\N
196554	1397	1282794414000	26190	12851	103	0	\N
196555	1397	1282784413000	26190	12851	104	0	\N
196556	1397	1282774412000	26190	12851	105	0	\N
196557	1397	1282764411000	26190	12851	106	0	\N
196558	1397	1282754410000	26190	12851	107	0	\N
196559	1397	1282744409000	26190	12851	108	0	\N
196560	1397	1282734408000	26190	12851	109	0	\N
196561	1397	1282724407000	26190	12851	110	0	\N
196562	1397	1282714406000	26190	12851	111	0	\N
196563	1397	1282704405000	26190	12851	112	0	\N
196564	1397	1282694404000	26190	12851	113	0	\N
196565	1397	1282684403000	26190	12851	114	0	\N
196566	1397	1282674402000	26190	12851	115	0	\N
196567	1397	1282664401000	26190	12851	116	0	\N
196568	1397	1282654400000	26190	12851	118	0	\N
196569	1397	1282644399000	26190	12851	119	0	\N
196570	1397	1282634398000	26190	12851	120	0	\N
196571	1397	1282624397000	26190	12851	121	0	\N
196572	1397	1282614396000	26190	12851	122	0	\N
196573	1397	1282604395000	26190	12851	123	0	\N
196574	1397	1282594394000	26190	12851	124	0	\N
196575	1397	1282584393000	26190	12851	125	0	\N
196592	1679	34436108583000	26193	12863	0	0	\N
196593	1397	1283034438000	26193	12863	1	0	\N
196594	1679	34247309235000	26193	12863	2	0	\N
196595	1679	33895327813000	26193	12863	3	0	\N
196596	1679	31289386384000	26193	12863	4	0	\N
196597	1679	26241293952000	26193	12863	5	0	\N
196598	1679	25684651640000	26193	12863	6	0	\N
196599	1397	1283024437000	26193	12863	7	0	\N
196600	1679	25390204008000	26193	12863	8	0	\N
196601	1679	24647773919000	26193	12863	9	0	\N
196602	1679	23622308719000	26193	12863	10	0	\N
196603	1679	22722064121000	26193	12863	11	0	\N
196604	1679	17239422355000	26193	12863	12	0	\N
196605	1679	16653087531000	26193	12863	13	0	\N
196606	1679	11170445765000	26193	12863	14	0	\N
196607	1679	10689859401000	26193	12863	15	0	\N
196608	1679	10385258747000	26193	12863	16	0	\N
196609	1679	9065355915000	26193	12863	17	0	\N
196610	1679	7948513519000	26193	12863	18	0	\N
196611	1679	7801179112000	26193	12863	19	0	\N
196612	1679	7713349535000	26193	12863	20	0	\N
196613	1679	7449360969000	26193	12863	21	0	\N
196614	1679	6500043432000	26193	12863	22	0	\N
196615	1679	4915972532000	26193	12863	23	0	\N
196616	1679	4435386168000	26193	12863	24	0	\N
196617	1679	4130785514000	26193	12863	25	0	\N
196618	1679	2810882682000	26193	12863	26	0	\N
196619	1397	1283014436000	26193	12863	27	0	\N
196620	1397	1283004435000	26193	12863	28	0	\N
196621	1397	1282994434000	26193	12863	29	0	\N
196622	1397	1282984433000	26193	12863	30	0	\N
196623	1397	1282974432000	26193	12863	31	0	\N
196624	1397	1282964431000	26193	12863	32	0	\N
196625	1397	1282954430000	26193	12863	33	0	\N
196626	1397	1282944429000	26193	12863	34	0	\N
196627	1397	1282934428000	26193	12863	35	0	\N
196628	1397	1282924427000	26193	12863	36	0	\N
196629	1397	1282914426000	26193	12863	37	0	\N
196630	1397	1282904425000	26193	12863	38	0	\N
196631	1397	1282894424000	26193	12863	39	0	\N
196632	1397	1282884423000	26193	12863	40	0	\N
196633	1397	1282874422000	26193	12863	41	0	\N
196634	1397	1282864421000	26193	12863	42	0	\N
196635	1397	1282854420000	26193	12863	43	0	\N
196636	1397	1282844419000	26193	12863	44	0	\N
196637	1397	1282834418000	26193	12863	45	0	\N
196638	1397	1282824417000	26193	12863	46	0	\N
196639	1397	1282814416000	26193	12863	47	0	\N
196640	1397	1282804415000	26193	12863	48	0	\N
196641	1397	1282794414000	26193	12863	49	0	\N
196642	1397	1282784413000	26193	12863	50	0	\N
196643	1397	1282774412000	26193	12863	51	0	\N
196644	1397	1282764411000	26193	12863	52	0	\N
196645	1397	1282754410000	26193	12863	53	0	\N
196646	1397	1282744409000	26193	12863	54	0	\N
196647	1397	1282734408000	26193	12863	55	0	\N
196648	1397	1282724407000	26193	12863	56	0	\N
196649	1397	1282714406000	26193	12863	57	0	\N
196650	1397	1282704405000	26193	12863	58	0	\N
196651	1397	1282694404000	26193	12863	59	0	\N
196652	1397	1282684403000	26193	12863	60	0	\N
196653	1397	1282674402000	26193	12863	61	0	\N
196654	1397	1282664401000	26193	12863	62	0	\N
196655	1397	1282654400000	26193	12863	63	0	\N
196656	1397	1282644399000	26193	12863	64	0	\N
196578	1397	1282064341000	26191	12947	2	0	15676
196579	2134	84591081000	26191	12947	3	0	5981
196580	2134	84590078000	26191	12947	4	0	5982
196581	2133	91131908000	26191	12947	5	0	5548
196582	2133	91130906000	26191	12947	6	0	5549
196584	2134	84589075000	26191	12947	8	0	5983
196585	1637	100000000	26191	12947	9	0	2
196586	2132	147426439000	26191	12947	10	0	1562
196587	1397	1282054340000	26192	12948	0	0	15677
196588	2132	147425438000	26192	12948	1	0	1563
196590	2133	91128902000	26192	12948	3	0	5551
196591	1726	986886112000	26192	12948	4	0	8299
196657	1397	1282634398000	26193	12863	65	0	\N
196658	1397	1282624397000	26193	12863	66	0	\N
196659	1397	1282614396000	26193	12863	67	0	\N
196660	1397	1282604395000	26193	12863	68	0	\N
196661	1397	1282594394000	26193	12863	69	0	\N
196662	1397	1282584393000	26193	12863	70	0	\N
196663	1397	1282574392000	26193	12863	71	0	\N
196664	1397	1282564391000	26193	12863	72	0	\N
196665	1397	1282554390000	26193	12863	73	0	\N
196666	1397	1282544389000	26193	12863	74	0	\N
196667	1397	1282534388000	26193	12863	75	0	\N
196668	1397	1282524387000	26193	12863	76	0	\N
196669	1397	1282514386000	26193	12863	77	0	\N
196670	1397	1282504385000	26193	12863	78	0	\N
196671	1397	1282494384000	26193	12863	79	0	\N
196672	1397	1282484383000	26193	12863	80	0	\N
196673	1397	1282474382000	26193	12863	81	0	\N
196674	1397	1282464381000	26193	12863	82	0	\N
196675	1397	1282454380000	26193	12863	83	0	\N
196676	1397	1282444379000	26193	12863	84	0	\N
196677	1397	1282434378000	26193	12863	85	0	\N
196678	1397	1282424377000	26193	12863	86	0	\N
196679	1397	1282414376000	26193	12863	87	0	\N
196680	1397	1282404375000	26193	12863	88	0	\N
196681	1397	1282394374000	26193	12863	89	0	\N
196682	1397	1282384373000	26193	12863	90	0	\N
196683	1397	1282374372000	26193	12863	91	0	\N
196684	1397	1282364371000	26193	12863	92	0	\N
196685	1397	1282354370000	26193	12863	93	0	\N
196686	1397	1282344369000	26193	12863	94	0	\N
196687	1397	1282334368000	26193	12863	95	0	\N
196688	1397	1282324367000	26193	12863	96	0	\N
196689	1397	1282314366000	26193	12863	97	0	\N
196690	1397	1282304365000	26193	12863	98	0	\N
196691	1397	1282294364000	26193	12863	99	0	\N
196692	1397	1282284363000	26193	12863	100	0	\N
196693	1397	1282274362000	26193	12863	101	0	\N
196694	1397	1282264361000	26193	12863	102	0	\N
196695	1397	1282254360000	26193	12863	103	0	\N
196696	1397	1282244359000	26193	12863	104	0	\N
196697	1397	1282234358000	26193	12863	105	0	\N
196698	1397	1282224357000	26193	12863	106	0	\N
196699	1397	1282214356000	26193	12863	107	0	\N
196700	1397	1282204355000	26193	12863	108	0	\N
196701	1397	1282194354000	26193	12863	109	0	\N
196702	1397	1282184353000	26193	12863	110	0	\N
196703	1397	1282174352000	26193	12863	111	0	\N
196704	1397	1282164351000	26193	12863	112	0	\N
196705	1397	1282154350000	26193	12863	113	0	\N
196706	1397	1282144349000	26193	12863	114	0	\N
196707	1397	1282134348000	26193	12863	115	0	\N
196708	1397	1282124347000	26193	12863	116	0	\N
196709	1397	1282114346000	26193	12863	117	0	\N
196710	1397	1282104345000	26193	12863	118	0	\N
196711	1397	1282094344000	26193	12863	119	0	\N
196712	1397	1282084343000	26193	12863	121	0	\N
196713	1397	1282074342000	26193	12863	122	0	\N
196714	1397	1282064341000	26193	12863	123	0	\N
196715	1397	1282054340000	26193	12863	124	0	\N
196716	2133	91160966000	26193	12863	125	0	\N
196717	1397	1282044339000	26194	12949	0	0	\N
196718	1397	1282034338000	26194	12949	1	0	\N
196719	2134	84587069000	26194	12949	2	0	\N
196720	2134	84586066000	26194	12949	3	0	\N
196721	2133	91127900000	26194	12949	4	0	\N
196722	2133	91126898000	26194	12949	5	0	\N
196729	1397	1282024337000	26196	12950	0	0	\N
196730	1726	985785112000	26196	12950	1	0	\N
196731	2132	147424437000	26196	12950	2	0	\N
196732	2134	84585063000	26196	12950	3	0	\N
196733	2133	91125896000	26196	12950	4	0	\N
196739	1397	1282024337000	26198	12950	0	0	\N
196740	1726	985785112000	26198	12950	1	0	\N
196741	2132	147424437000	26198	12950	2	0	\N
196742	2134	84585063000	26198	12950	3	0	\N
196743	2133	91125896000	26198	12950	4	0	\N
196752	2134	84582054000	26202	12953	0	0	\N
196753	2133	91122890000	26202	12953	1	0	\N
196758	1397	1281994334000	26204	12954	0	0	\N
196759	2134	84581051000	26204	12954	1	0	\N
196760	2132	147423436000	26204	12954	2	0	\N
196761	2133	91121888000	26204	12954	3	0	\N
196778	1397	1281934328000	26207	12957	0	0	\N
196779	2133	91115876000	26207	12957	1	0	\N
196780	2132	147421434000	26207	12957	2	0	\N
196781	2134	84575033000	26207	12957	3	0	\N
196782	1397	1281934328000	26208	12957	0	0	\N
196783	2133	91115876000	26208	12957	1	0	\N
196784	2132	147421434000	26208	12957	2	0	\N
196785	2134	84575033000	26208	12957	3	0	\N
196786	1397	1281934328000	26209	12957	0	0	\N
196787	2133	91115876000	26209	12957	1	0	\N
196788	2132	147421434000	26209	12957	2	0	\N
196789	2134	84575033000	26209	12957	3	0	\N
196725	2134	84587069000	26195	12949	2	0	5985
196726	2134	84586066000	26195	12949	3	0	5986
196727	2133	91127900000	26195	12949	4	0	5552
196728	2133	91126898000	26195	12949	5	0	5553
196734	1397	1282024337000	26197	12950	0	0	15680
196736	2132	147424437000	26197	12950	2	0	1564
196737	2134	84585063000	26197	12950	3	0	5987
196738	2133	91125896000	26197	12950	4	0	5554
196744	1397	1282014336000	26199	12951	0	0	15681
196745	2134	84584060000	26199	12951	1	0	5988
196747	1397	1282004335000	26200	12952	0	0	15682
196748	2134	84583057000	26200	12952	1	0	5989
196749	2133	91123892000	26200	12952	2	0	5556
196750	2134	84582054000	26201	12953	0	0	5990
196754	1397	1281994334000	26203	12954	0	0	15683
196755	2134	84581051000	26203	12954	1	0	5991
196756	2132	147423436000	26203	12954	2	0	1565
196757	2133	91121888000	26203	12954	3	0	5558
196762	1397	1281984333000	26205	12955	0	0	15684
196764	1397	1281964331000	26205	12955	2	0	15686
196765	1397	1281954330000	26205	12955	3	0	15687
196766	2133	91120886000	26205	12955	4	0	5559
196767	2134	84580048000	26205	12955	5	0	5992
196768	2134	84579045000	26205	12955	6	0	5993
196770	2134	84577039000	26205	12955	8	0	5995
196771	2132	147422435000	26205	12955	9	0	1566
196772	2133	91119884000	26205	12955	10	0	5560
196773	2133	91118882000	26205	12955	11	0	5561
196775	1397	1281944329000	26206	12956	0	0	15688
196776	2133	91116878000	26206	12956	1	0	5563
196777	2134	84576036000	26206	12956	2	0	5996
196790	1397	1281934328000	26210	12957	0	0	15689
196791	2133	91115876000	26210	12957	1	0	5564
196803	1397	1281894324000	26214	12961	0	0	\N
196804	2132	147420433000	26214	12961	1	0	\N
196805	2133	91111868000	26214	12961	2	0	\N
196806	2134	84571021000	26214	12961	3	0	\N
196811	1397	1281894324000	26216	12961	0	0	\N
196812	2132	147420433000	26216	12961	1	0	\N
196813	2133	91111868000	26216	12961	2	0	\N
196814	2134	84571021000	26216	12961	3	0	\N
196815	1397	1281894324000	26217	12961	0	0	\N
196816	2132	147420433000	26217	12961	1	0	\N
196817	2133	91111868000	26217	12961	2	0	\N
196818	2134	84571021000	26217	12961	3	0	\N
196829	1397	1281864321000	26220	12963	0	0	\N
196830	2133	91108862000	26220	12963	1	0	\N
196831	2134	84568012000	26220	12963	2	0	\N
196832	2132	147419432000	26220	12963	3	0	\N
196833	1397	1281854320000	26221	12964	0	0	\N
196834	2134	84567009000	26221	12964	1	0	\N
196835	2133	91107860000	26221	12964	2	0	\N
196839	1397	1281844319000	26223	12965	0	0	\N
196840	1397	1281834318000	26223	12965	1	0	\N
196841	2132	147418431000	26223	12965	2	0	\N
196842	2133	91106858000	26223	12965	3	0	\N
196843	2133	91105856000	26223	12965	4	0	\N
196844	2134	84566006000	26223	12965	5	0	\N
196845	2134	84565003000	26223	12965	6	0	\N
196853	1397	1282574392000	26225	12852	0	0	\N
196854	1397	1282564391000	26225	12852	1	0	\N
196855	1397	1282554390000	26225	12852	2	0	\N
196856	1397	1282544389000	26225	12852	3	0	\N
196857	1397	1282534388000	26225	12852	4	0	\N
196858	1397	1282524387000	26225	12852	5	0	\N
196859	1397	1282514386000	26225	12852	6	0	\N
196860	1397	1282504385000	26225	12852	7	0	\N
196861	1397	1282494384000	26225	12852	8	0	\N
196862	1397	1282484383000	26225	12852	9	0	\N
196863	1397	1282474382000	26225	12852	10	0	\N
196864	1397	1282464381000	26225	12852	11	0	\N
196865	1397	1282454380000	26225	12852	12	0	\N
196866	1397	1282444379000	26225	12852	13	0	\N
196867	1397	1282434378000	26225	12852	14	0	\N
196868	1397	1282424377000	26225	12852	15	0	\N
196869	1397	1282414376000	26225	12852	16	0	\N
196870	1397	1282404375000	26225	12852	17	0	\N
196871	1397	1282394374000	26225	12852	18	0	\N
196872	1397	1282384373000	26225	12852	19	0	\N
196873	1397	1282374372000	26225	12852	20	0	\N
196874	1397	1282364371000	26225	12852	21	0	\N
196875	1397	1282354370000	26225	12852	22	0	\N
196876	1397	1282344369000	26225	12852	23	0	\N
196877	1397	1282334368000	26225	12852	24	0	\N
196878	1397	1282324367000	26225	12852	25	0	\N
196879	1397	1282314366000	26225	12852	26	0	\N
196880	1397	1282304365000	26225	12852	27	0	\N
196881	1397	1282294364000	26225	12852	28	0	\N
196882	1397	1282284363000	26225	12852	29	0	\N
196883	1397	1282274362000	26225	12852	30	0	\N
196884	1397	1282264361000	26225	12852	31	0	\N
196885	1397	1282254360000	26225	12852	32	0	\N
196886	1397	1282244359000	26225	12852	33	0	\N
196887	1397	1282234358000	26225	12852	34	0	\N
196888	1397	1282224357000	26225	12852	35	0	\N
196889	1397	1282214356000	26225	12852	36	0	\N
196890	1397	1282204355000	26225	12852	37	0	\N
196891	1397	1282194354000	26225	12852	38	0	\N
196892	1397	1282184353000	26225	12852	39	0	\N
196893	1397	1282174352000	26225	12852	40	0	\N
196894	1397	1282164351000	26225	12852	41	0	\N
196895	1397	1282154350000	26225	12852	42	0	\N
196896	1397	1282144349000	26225	12852	43	0	\N
196897	1397	1282134348000	26225	12852	44	0	\N
196898	1397	1282124347000	26225	12852	45	0	\N
196899	1397	1282114346000	26225	12852	46	0	\N
196900	1397	1282104345000	26225	12852	47	0	\N
196901	1397	1282094344000	26225	12852	48	0	\N
196902	1397	1282084343000	26225	12852	49	0	\N
196903	1397	1282074342000	26225	12852	50	0	\N
196904	1397	1282064341000	26225	12852	51	0	\N
196905	1397	1282054340000	26225	12852	52	0	\N
196906	1397	1282044339000	26225	12852	53	0	\N
196907	1397	1282034338000	26225	12852	54	0	\N
196908	1397	1282024337000	26225	12852	55	0	\N
196909	1397	1282014336000	26225	12852	56	0	\N
196910	1397	1282004335000	26225	12852	57	0	\N
196911	1397	1281994334000	26225	12852	58	0	\N
196912	1397	1281984333000	26225	12852	59	0	\N
196913	1397	1281974332000	26225	12852	60	0	\N
196914	1397	1281964331000	26225	12852	61	0	\N
196915	1397	1281954330000	26225	12852	62	0	\N
196916	1397	1281944329000	26225	12852	63	0	\N
196917	1397	1281934328000	26225	12852	64	0	\N
196918	1397	1281924327000	26225	12852	65	0	\N
196919	1397	1281914326000	26225	12852	66	0	\N
196920	1397	1281904325000	26225	12852	67	0	\N
196921	1397	1281894324000	26225	12852	68	0	\N
196922	1397	1281884323000	26225	12852	69	0	\N
196923	1397	1281874322000	26225	12852	70	0	\N
196924	1397	1281864321000	26225	12852	71	0	\N
196925	1397	1281854320000	26225	12852	72	0	\N
196926	1397	1281844319000	26225	12852	73	0	\N
196927	1397	1281834318000	26225	12852	74	0	\N
196928	1397	1281824317000	26225	12852	75	0	\N
196795	2133	91114874000	26211	12958	1	0	5565
196796	2134	84574030000	26211	12958	2	0	5998
196797	1397	1281914326000	26212	12959	0	0	15691
196798	2133	91113872000	26212	12959	1	0	5566
196799	2134	84573027000	26212	12959	2	0	5999
196801	2133	91112870000	26213	12960	1	0	5567
196802	2134	84572024000	26213	12960	2	0	6000
196807	1397	1281894324000	26215	12961	0	0	15693
196808	2132	147420433000	26215	12961	1	0	1568
196809	2133	91111868000	26215	12961	2	0	5568
196819	1397	1281884323000	26218	12962	0	0	15694
196820	1397	1281874322000	26218	12962	1	0	15695
196821	2134	84570018000	26218	12962	2	0	6002
196822	2133	91110866000	26218	12962	3	0	5569
196824	2133	91109864000	26218	12962	5	0	5570
196825	1397	1281864321000	26219	12963	0	0	15696
196826	2133	91108862000	26219	12963	1	0	5571
196827	2134	84568012000	26219	12963	2	0	6004
196828	2132	147419432000	26219	12963	3	0	1569
196837	2134	84567009000	26222	12964	1	0	6005
196838	2133	91107860000	26222	12964	2	0	5572
196846	1397	1281844319000	26224	12965	0	0	15698
196847	1397	1281834318000	26224	12965	1	0	15699
196848	2132	147418431000	26224	12965	2	0	1570
196850	2133	91105856000	26224	12965	4	0	5574
196851	2134	84566006000	26224	12965	5	0	6006
196852	2134	84565003000	26224	12965	6	0	6007
196929	1397	1281814316000	26225	12852	76	0	\N
196930	1397	1281804315000	26225	12852	77	0	\N
196931	1159	614190748000000	26225	12852	78	0	\N
196932	1637	301686278819988	26225	12852	79	0	\N
196933	2134	84721471000	26225	12852	80	0	\N
196934	2320	775740211465	26225	12852	81	0	\N
196935	2134	84720468000	26225	12852	82	0	\N
196936	2133	91171988000	26225	12852	83	0	\N
196937	1637	100000000	26225	12852	84	0	\N
196938	2133	91170986000	26225	12852	85	0	\N
196939	2133	91169984000	26225	12852	86	0	\N
196940	2132	147430443000	26225	12852	87	0	\N
196941	2132	147429442000	26225	12852	88	0	\N
196942	2132	147428441000	26225	12852	89	0	\N
196943	2133	91168982000	26225	12852	90	0	\N
196944	2133	91167980000	26225	12852	91	0	\N
196945	2132	147427440000	26225	12852	92	0	\N
196946	2133	91166978000	26225	12852	93	0	\N
196947	2133	91165976000	26225	12852	94	0	\N
196948	2133	91164974000	26225	12852	95	0	\N
196949	2133	91163972000	26225	12852	96	0	\N
196950	2133	91162970000	26225	12852	97	0	\N
196951	2133	91161968000	26225	12852	98	0	\N
196952	2133	91160966000	26225	12852	99	0	\N
196953	2133	91159964000	26225	12852	100	0	\N
196954	2133	91158962000	26225	12852	101	0	\N
196955	2133	91157960000	26225	12852	102	0	\N
196956	2133	91156958000	26225	12852	103	0	\N
196957	2133	91155956000	26225	12852	104	0	\N
196958	2133	91154954000	26225	12852	105	0	\N
196959	2133	91153952000	26225	12852	106	0	\N
196960	2133	91152950000	26225	12852	107	0	\N
196961	2133	91151948000	26225	12852	108	0	\N
196962	2133	91150946000	26225	12852	109	0	\N
196963	2133	91149944000	26225	12852	110	0	\N
196964	2133	91148942000	26225	12852	111	0	\N
196965	2133	91147940000	26225	12852	112	0	\N
196966	2133	91146938000	26225	12852	113	0	\N
196967	2133	91145936000	26225	12852	114	0	\N
196968	2133	91144934000	26225	12852	115	0	\N
196969	2133	91143932000	26225	12852	116	0	\N
196970	2133	91142930000	26225	12852	118	0	\N
196971	2133	91141928000	26225	12852	119	0	\N
196972	2133	91140926000	26225	12852	120	0	\N
196973	2133	91139924000	26225	12852	121	0	\N
196974	2133	91138922000	26225	12852	122	0	\N
196975	2133	91137920000	26225	12852	123	0	\N
196976	2133	91136918000	26225	12852	124	0	\N
196977	2133	91135916000	26225	12852	125	0	\N
197002	1397	1281824317000	26227	12966	0	0	\N
197003	1397	1281814316000	26227	12966	1	0	\N
197004	1397	1281804315000	26227	12966	2	0	\N
197005	1397	1281794314000	26227	12966	3	0	\N
197006	1397	1281784313000	26227	12966	4	0	\N
197007	1397	1281774312000	26227	12966	5	0	\N
197008	1397	1281764311000	26227	12966	6	0	\N
197009	1726	984684112000	26227	12966	7	0	\N
197010	2134	84564000000	26227	12966	8	0	\N
197011	2133	91104854000	26227	12966	9	0	\N
197012	2133	91103852000	26227	12966	10	0	\N
197013	2133	91102850000	26227	12966	11	0	\N
197014	2133	91101848000	26227	12966	12	0	\N
197015	2133	91100846000	26227	12966	13	0	\N
197016	2133	91099844000	26227	12966	14	0	\N
197017	2133	91098842000	26227	12966	15	0	\N
197018	2132	147417430000	26227	12966	16	0	\N
197019	2132	147416429000	26227	12966	17	0	\N
197020	2134	84562997000	26227	12966	18	0	\N
197021	2134	84561994000	26227	12966	19	0	\N
197022	2134	84560991000	26227	12966	20	0	\N
197023	2134	84559988000	26227	12966	21	0	\N
197024	2134	84558985000	26227	12966	22	0	\N
197025	2134	84557982000	26227	12966	23	0	\N
197039	1397	1281734308000	26231	12969	0	0	\N
197040	1397	1281724307000	26231	12969	1	0	\N
197041	2134	84554973000	26231	12969	2	0	\N
197042	2133	91095836000	26231	12969	3	0	\N
197043	2133	91094834000	26231	12969	4	0	\N
197044	2134	84553970000	26231	12969	5	0	\N
197045	2132	147415428000	26231	12969	6	0	\N
197056	1397	1281704305000	26234	12971	0	0	\N
197057	1397	1281694304000	26234	12971	1	0	\N
197058	2133	91092830000	26234	12971	2	0	\N
197059	2133	91091828000	26234	12971	3	0	\N
197060	2134	84551964000	26234	12971	4	0	\N
197061	2134	84550961000	26234	12971	5	0	\N
197062	2132	147414427000	26234	12971	6	0	\N
196980	1397	1281804315000	26226	12966	2	0	15702
196981	1397	1281794314000	26226	12966	3	0	15703
196982	1397	1281784313000	26226	12966	4	0	15704
196983	1397	1281774312000	26226	12966	5	0	15705
196984	1397	1281764311000	26226	12966	6	0	15706
196986	2134	84564000000	26226	12966	8	0	6008
196987	2133	91104854000	26226	12966	9	0	5575
196988	2133	91103852000	26226	12966	10	0	5576
196989	2133	91102850000	26226	12966	11	0	5577
196990	2133	91101848000	26226	12966	12	0	5578
196992	2133	91099844000	26226	12966	14	0	5580
196993	2133	91098842000	26226	12966	15	0	5581
196994	2132	147417430000	26226	12966	16	0	1571
196995	2132	147416429000	26226	12966	17	0	1572
196997	2134	84561994000	26226	12966	19	0	6010
196998	2134	84560991000	26226	12966	20	0	6011
196999	2134	84559988000	26226	12966	21	0	6012
197000	2134	84558985000	26226	12966	22	0	6013
197001	2134	84557982000	26226	12966	23	0	6014
197027	2134	84556979000	26228	12967	1	0	6015
197028	2133	91097840000	26228	12967	2	0	5582
197029	1397	1281744309000	26229	12968	0	0	15708
197030	2134	84555976000	26229	12968	1	0	6016
197031	2133	91096838000	26229	12968	2	0	5583
197033	1397	1281724307000	26230	12969	1	0	15710
197034	2134	84554973000	26230	12969	2	0	6017
197035	2133	91095836000	26230	12969	3	0	5584
197036	2133	91094834000	26230	12969	4	0	5585
197038	2132	147415428000	26230	12969	6	0	1573
197046	1397	1281714306000	26232	12970	0	0	15711
197047	2133	91093832000	26232	12970	1	0	5586
197048	2134	84552967000	26232	12970	2	0	6019
197049	1397	1281704305000	26233	12971	0	0	15712
197051	2133	91092830000	26233	12971	2	0	5587
197052	2133	91091828000	26233	12971	3	0	5588
197053	2134	84551964000	26233	12971	4	0	6020
197054	2134	84550961000	26233	12971	5	0	6021
197055	2132	147414427000	26233	12971	6	0	1574
197064	2134	84549958000	26236	12972	1	0	6022
197066	1397	1281684303000	26237	12972	0	0	\N
197067	2134	84549958000	26237	12972	1	0	\N
197068	2133	91090826000	26237	12972	2	0	\N
197069	1397	1281684303000	26238	12972	0	0	\N
197070	2134	84549958000	26238	12972	1	0	\N
197071	2133	91090826000	26238	12972	2	0	\N
197095	1397	1281624297000	26245	12975	0	0	\N
197096	2134	84543940000	26245	12975	1	0	\N
197097	2133	91084814000	26245	12975	2	0	\N
197098	1397	1281624297000	26246	12975	0	0	\N
197099	2134	84543940000	26246	12975	1	0	\N
197100	2133	91084814000	26246	12975	2	0	\N
197101	1397	1281624297000	26247	12975	0	0	\N
197102	2134	84543940000	26247	12975	1	0	\N
197103	2133	91084814000	26247	12975	2	0	\N
197137	1397	1281514286000	26255	12983	0	0	\N
197138	2133	91073792000	26255	12983	1	0	\N
197139	2134	84532907000	26255	12983	2	0	\N
197143	1397	1281514286000	26257	12983	0	0	\N
197144	2133	91073792000	26257	12983	1	0	\N
197145	2134	84532907000	26257	12983	2	0	\N
197146	1397	1281514286000	26258	12983	0	0	\N
197147	2133	91073792000	26258	12983	1	0	\N
197148	2134	84532907000	26258	12983	2	0	\N
197149	1397	1281504285000	26259	12984	0	0	\N
197150	2134	84531904000	26259	12984	1	0	\N
197151	2133	91072790000	26259	12984	2	0	\N
197168	1397	1281484283000	26263	12986	0	0	\N
197169	1397	1281474282000	26263	12986	1	0	\N
197170	2133	91069784000	26263	12986	2	0	\N
197171	2133	91068782000	26263	12986	3	0	\N
197172	2132	147407420000	26263	12986	4	0	\N
197173	2134	84528895000	26263	12986	5	0	\N
197174	2134	84527892000	26263	12986	6	0	\N
197188	1397	1281424277000	26267	12990	0	0	\N
197189	2134	84522877000	26267	12990	1	0	\N
197190	2133	91063772000	26267	12990	2	0	\N
197197	1397	1281414276000	26270	12991	0	0	\N
197198	2134	84521874000	26270	12991	1	0	\N
197199	2133	91062770000	26270	12991	2	0	\N
197073	2134	84548955000	26242	12973	1	0	6023
197074	2133	91089824000	26242	12973	2	0	5590
197075	1397	1281664301000	26243	12974	0	0	15716
197076	1397	1281654300000	26243	12974	1	0	15717
197077	1397	1281644299000	26243	12974	2	0	15718
197079	2132	147413426000	26243	12974	5	0	1575
197080	1726	983583112000	26243	12974	6	0	8302
197081	2133	91088822000	26243	12974	7	0	5591
197082	2134	84547952000	26243	12974	8	0	6024
197083	2134	84546949000	26243	12974	9	0	6025
197085	2134	84544943000	26243	12974	11	0	6027
197086	1726	982482112000	26243	12974	12	0	8303
197087	2133	91087820000	26243	12974	13	0	5592
197088	1726	981381112000	26243	12974	14	0	8304
197090	2133	91086818000	26243	12974	16	0	5593
197091	2133	91085816000	26243	12974	17	0	5594
197092	1397	1281624297000	26244	12975	0	0	15720
197093	2134	84543940000	26244	12975	1	0	6028
197094	2133	91084814000	26244	12975	2	0	5595
197105	2134	84542937000	26248	12976	1	0	6029
197106	2133	91083812000	26248	12976	2	0	5596
197107	1397	1281604295000	26249	12977	0	0	15722
197108	2134	84541934000	26249	12977	1	0	6030
197109	2133	91082810000	26249	12977	2	0	5597
197111	2134	84540931000	26250	12978	1	0	6031
197112	2133	91081808000	26250	12978	2	0	5598
197113	2132	147411424000	26250	12978	3	0	1577
197114	1397	1281584293000	26251	12979	0	0	15724
197116	1397	1281564291000	26251	12979	2	0	15726
197117	1397	1281554290000	26251	12979	3	0	15727
197118	2133	91080806000	26251	12979	4	0	5599
197119	2133	91079804000	26251	12979	5	0	5600
197120	2132	147410423000	26251	12979	6	0	1578
197122	2134	84538925000	26251	12979	8	0	6033
197123	2134	84537922000	26251	12979	9	0	6034
197124	2134	84536919000	26251	12979	10	0	6035
197125	2133	91078802000	26251	12979	11	0	5601
197126	2133	91077800000	26251	12979	12	0	5602
197128	2134	84535916000	26252	12980	1	0	6036
197129	2133	91076798000	26252	12980	2	0	5603
197130	1397	1281534288000	26253	12981	0	0	15729
197131	2134	84534913000	26253	12981	1	0	6037
197133	2132	147409422000	26253	12981	3	0	1579
197134	1397	1281524287000	26254	12982	0	0	15730
197135	2134	84533910000	26254	12982	1	0	6038
197136	2133	91074794000	26254	12982	2	0	5605
197140	1397	1281514286000	26256	12983	0	0	15731
197142	2134	84532907000	26256	12983	2	0	6039
197152	1397	1281504285000	26260	12984	0	0	15732
197153	2134	84531904000	26260	12984	1	0	6040
197154	2133	91072790000	26260	12984	2	0	5607
197155	1397	1281494284000	26261	12985	0	0	15733
197157	2133	91070786000	26261	12985	2	0	5609
197158	2134	84530901000	26261	12985	3	0	6041
197159	2134	84529898000	26261	12985	4	0	6042
197160	2132	147408421000	26261	12985	5	0	1580
197162	1397	1281474282000	26262	12986	1	0	15735
197163	2133	91069784000	26262	12986	2	0	5610
197164	2133	91068782000	26262	12986	3	0	5611
197165	2132	147407420000	26262	12986	4	0	1581
197166	2134	84528895000	26262	12986	5	0	6043
197175	1397	1281464281000	26264	12987	0	0	15736
197176	2133	91067780000	26264	12987	1	0	5612
197177	2134	84526889000	26264	12987	2	0	6045
197178	1397	1281454280000	26265	12988	0	0	15737
197179	1397	1281444279000	26265	12988	1	0	15738
197181	2132	147406419000	26265	12988	3	0	1582
197182	2133	91066778000	26265	12988	4	0	5613
197183	2134	84524883000	26265	12988	5	0	6047
197184	2133	91065776000	26265	12988	6	0	5614
197186	2133	91064774000	26266	12989	1	0	5615
197187	2134	84523880000	26266	12989	2	0	6048
197191	1397	1281424277000	26268	12990	0	0	15740
197192	2134	84522877000	26268	12990	1	0	6049
197193	2133	91063772000	26268	12990	2	0	5616
197195	2134	84521874000	26269	12991	1	0	6050
197196	2133	91062770000	26269	12991	2	0	5617
197200	1397	1281404275000	26271	12992	0	0	15742
197213	1397	1281374272000	26275	12995	0	0	\N
197214	2132	147404417000	26275	12995	1	0	\N
197215	2133	91058762000	26275	12995	2	0	\N
197216	2134	84518865000	26275	12995	3	0	\N
197217	1397	1281374272000	26276	12995	0	0	\N
197218	2132	147404417000	26276	12995	1	0	\N
197219	2133	91058762000	26276	12995	2	0	\N
197220	2134	84518865000	26276	12995	3	0	\N
197234	1679	34436108583000	26280	12831	0	0	\N
197235	1688	68763937668020	26280	12831	1	0	\N
197236	1688	68623473612020	26280	12831	2	0	\N
197237	1688	68497559151020	26280	12831	3	0	\N
197238	1688	68444558222020	26280	12831	4	0	\N
197239	1688	67861648509020	26280	12831	5	0	\N
197240	1688	63198535115020	26280	12831	6	0	\N
197241	1679	34247309235000	26280	12831	7	0	\N
197242	1679	33895327813000	26280	12831	8	0	\N
197243	1679	31289386384000	26280	12831	9	0	\N
197244	1679	26241293952000	26280	12831	10	0	\N
197245	1679	25684651640000	26280	12831	11	0	\N
197246	1679	25390204008000	26280	12831	12	0	\N
197247	1679	24647773919000	26280	12831	13	0	\N
197248	1679	23622308719000	26280	12831	14	0	\N
197249	1679	22722064121000	26280	12831	15	0	\N
197250	1679	17239422355000	26280	12831	16	0	\N
197251	1679	16653087531000	26280	12831	17	0	\N
197252	1679	11170445765000	26280	12831	18	0	\N
197253	1679	10689859401000	26280	12831	19	0	\N
197254	1679	10385258747000	26280	12831	20	0	\N
197255	1679	9065355915000	26280	12831	21	0	\N
197256	1679	7948513519000	26280	12831	22	0	\N
197257	1679	7801179112000	26280	12831	23	0	\N
197258	1679	7713349535000	26280	12831	24	0	\N
197259	1679	7449360969000	26280	12831	25	0	\N
197260	1679	6500043432000	26280	12831	26	0	\N
197261	1688	62774606255020	26280	12831	27	0	\N
197262	1688	58111492861020	26280	12831	28	0	\N
197263	1688	58005501003020	26280	12831	29	0	\N
197264	1688	56839691576020	26280	12831	30	0	\N
197265	1688	56813188485020	26280	12831	31	0	\N
197266	1688	56521754742020	26280	12831	32	0	\N
197267	1688	56495246750020	26280	12831	33	0	\N
197268	1688	56203759090020	26280	12831	34	0	\N
197269	1688	55998677265020	26280	12831	35	0	\N
197270	1688	53742879159020	26280	12831	36	0	\N
197271	1688	50452180832020	26280	12831	37	0	\N
197272	1688	14254630820020	26280	12831	38	0	\N
197273	1688	14254620694020	26280	12831	39	0	\N
197274	1688	7990553113020	26280	12831	40	0	\N
197275	1679	4915972532000	26280	12831	41	0	\N
197276	1679	4435386168000	26280	12831	42	0	\N
197277	1679	4130785514000	26280	12831	43	0	\N
197278	1397	1283614496000	26280	12831	44	0	\N
197279	1397	1283604495000	26280	12831	45	0	\N
197280	1397	1283594494000	26280	12831	46	0	\N
197281	1397	1283584493000	26280	12831	47	0	\N
197282	1397	1283574492000	26280	12831	48	0	\N
197283	1397	1283564491000	26280	12831	49	0	\N
197284	1397	1283554490000	26280	12831	50	0	\N
197285	1397	1283544489000	26280	12831	51	0	\N
197286	1397	1283534488000	26280	12831	52	0	\N
197287	1679	2810882682000	26280	12831	53	0	\N
197288	1397	1283524487000	26280	12831	54	0	\N
197289	1397	1283514486000	26280	12831	55	0	\N
197290	1397	1283504485000	26280	12831	56	0	\N
197291	1397	1283494484000	26280	12831	57	0	\N
197292	1397	1283484483000	26280	12831	58	0	\N
197293	1397	1283474482000	26280	12831	59	0	\N
197294	1397	1283464481000	26280	12831	60	0	\N
197295	1397	1283454480000	26280	12831	61	0	\N
197296	1397	1283444479000	26280	12831	62	0	\N
197297	1397	1283434478000	26280	12831	63	0	\N
197298	1397	1283424477000	26280	12831	64	0	\N
197299	1397	1283414476000	26280	12831	65	0	\N
197300	1397	1283404475000	26280	12831	66	0	\N
197301	1397	1283394474000	26280	12831	67	0	\N
197302	1397	1283384473000	26280	12831	68	0	\N
197303	1397	1283374472000	26280	12831	69	0	\N
197304	1397	1283364471000	26280	12831	70	0	\N
197305	1397	1283354470000	26280	12831	71	0	\N
197306	1397	1283344469000	26280	12831	72	0	\N
197307	1397	1283334468000	26280	12831	73	0	\N
197308	1397	1283324467000	26280	12831	74	0	\N
197309	1397	1283314466000	26280	12831	75	0	\N
197310	1397	1283304465000	26280	12831	77	0	\N
197311	1397	1283294464000	26280	12831	78	0	\N
197312	1397	1283284463000	26280	12831	79	0	\N
197313	1397	1283274462000	26280	12831	80	0	\N
197314	1397	1283264461000	26280	12831	81	0	\N
197315	1397	1283254460000	26280	12831	82	0	\N
197316	1397	1283244459000	26280	12831	83	0	\N
197317	1397	1283234458000	26280	12831	84	0	\N
197318	1397	1283224457000	26280	12831	85	0	\N
197319	1397	1283214456000	26280	12831	86	0	\N
197320	1397	1283204455000	26280	12831	87	0	\N
197321	1397	1283194454000	26280	12831	88	0	\N
197322	1397	1283184453000	26280	12831	89	0	\N
197323	1397	1283174452000	26280	12831	90	0	\N
197324	1397	1283164451000	26280	12831	91	0	\N
197325	1397	1283154450000	26280	12831	92	0	\N
197326	1397	1283144449000	26280	12831	93	0	\N
197327	1397	1283134448000	26280	12831	94	0	\N
197328	1397	1283124447000	26280	12831	95	0	\N
197329	1397	1283114446000	26280	12831	96	0	\N
197330	1397	1283104445000	26280	12831	97	0	\N
197331	1397	1283094444000	26280	12831	98	0	\N
197332	1397	1283084443000	26280	12831	99	0	\N
197333	1397	1283074442000	26280	12831	100	0	\N
197334	1397	1283064441000	26280	12831	101	0	\N
197335	1397	1283054440000	26280	12831	102	0	\N
197336	1397	1283044439000	26280	12831	103	0	\N
197203	2133	91061768000	26271	12992	4	0	5618
197204	1397	1281394274000	26272	12993	0	0	15743
197205	2133	91060766000	26272	12993	1	0	5619
197206	1397	1281384273000	26273	12994	0	0	15744
197207	2133	91059764000	26273	12994	1	0	5620
197209	1397	1281374272000	26274	12995	0	0	15745
197210	2132	147404417000	26274	12995	1	0	1584
197211	2133	91058762000	26274	12995	2	0	5621
197212	2134	84518865000	26274	12995	3	0	6053
197221	1397	1281364271000	26277	12996	0	0	15746
197223	2134	84517862000	26277	12996	2	0	6054
197224	2134	84516859000	26277	12996	3	0	6055
197225	2133	91057760000	26277	12996	4	0	5622
197226	2133	91056758000	26277	12996	5	0	5623
197228	2133	91055756000	26278	12997	1	0	5624
197229	2134	84515856000	26278	12997	2	0	6056
197230	2132	147403416000	26278	12997	3	0	1585
197231	1397	1281334268000	26279	12998	0	0	15749
197232	2133	91054754000	26279	12998	1	0	5625
197337	1397	1283034438000	26280	12831	104	0	\N
197338	1397	1283024437000	26280	12831	105	0	\N
197339	1397	1283014436000	26280	12831	106	0	\N
197340	1397	1283004435000	26280	12831	107	0	\N
197341	1397	1282994434000	26280	12831	108	0	\N
197342	1397	1282984433000	26280	12831	109	0	\N
197343	1397	1282974432000	26280	12831	110	0	\N
197344	1397	1282964431000	26280	12831	111	0	\N
197345	1397	1282954430000	26280	12831	112	0	\N
197346	1397	1282944429000	26280	12831	113	0	\N
197347	1397	1282934428000	26280	12831	114	0	\N
197348	1397	1282924427000	26280	12831	115	0	\N
197349	1397	1282914426000	26280	12831	116	0	\N
197350	1397	1282904425000	26280	12831	117	0	\N
197351	1397	1282894424000	26280	12831	118	0	\N
197352	1397	1282884423000	26280	12831	119	0	\N
197353	1397	1282874422000	26280	12831	120	0	\N
197354	1397	1282864421000	26280	12831	121	0	\N
197355	1397	1282854420000	26280	12831	122	0	\N
197356	1397	1282844419000	26280	12831	123	0	\N
197357	1397	1282834418000	26280	12831	124	0	\N
197358	1397	1282824417000	26280	12831	125	0	\N
197359	1397	1281324267000	26281	12999	0	0	\N
197360	1397	1281314266000	26281	12999	1	0	\N
197361	1397	1281304265000	26281	12999	2	0	\N
197362	2134	84513850000	26281	12999	3	0	\N
197363	2134	84512847000	26281	12999	4	0	\N
197364	2134	84511844000	26281	12999	5	0	\N
197365	2132	147402415000	26281	12999	6	0	\N
197366	1397	1281324267000	26282	12999	0	0	\N
197367	1397	1281314266000	26282	12999	1	0	\N
197368	1397	1281304265000	26282	12999	2	0	\N
197369	2134	84513850000	26282	12999	3	0	\N
197370	2134	84512847000	26282	12999	4	0	\N
197371	2134	84511844000	26282	12999	5	0	\N
197372	2132	147402415000	26282	12999	6	0	\N
197380	1397	1281324267000	26284	12999	0	0	\N
197381	1397	1281314266000	26284	12999	1	0	\N
197382	1397	1281304265000	26284	12999	2	0	\N
197383	2134	84513850000	26284	12999	3	0	\N
197384	2134	84512847000	26284	12999	4	0	\N
197385	2134	84511844000	26284	12999	5	0	\N
197386	2132	147402415000	26284	12999	6	0	\N
197387	1397	1281294264000	26285	13000	0	0	\N
197388	2134	84510841000	26285	13000	1	0	\N
197405	1397	1281224257000	26291	13005	0	0	\N
197406	2134	84503820000	26291	13005	1	0	\N
197411	1397	1281204255000	26294	13007	0	0	\N
197412	1397	1281194254000	26294	13007	1	0	\N
197413	1397	1281184253000	26294	13007	2	0	\N
197414	1397	1281174252000	26294	13007	3	0	\N
197415	2132	147399412000	26294	13007	4	0	\N
197416	2132	147398411000	26294	13007	5	0	\N
197417	2134	84501814000	26294	13007	6	0	\N
197418	2134	84500811000	26294	13007	7	0	\N
197419	2134	84499808000	26294	13007	8	0	\N
197420	2134	84498805000	26294	13007	9	0	\N
197421	531	66000000000000	26294	13007	10	0	\N
197433	1397	1281204255000	26296	13007	0	0	\N
197434	1397	1281194254000	26296	13007	1	0	\N
197435	1397	1281184253000	26296	13007	2	0	\N
197436	1397	1281174252000	26296	13007	3	0	\N
197437	2132	147399412000	26296	13007	4	0	\N
197438	2132	147398411000	26296	13007	5	0	\N
197439	2134	84501814000	26296	13007	6	0	\N
197440	2134	84500811000	26296	13007	7	0	\N
197441	2134	84499808000	26296	13007	8	0	\N
197442	2134	84498805000	26296	13007	9	0	\N
197443	531	66000000000000	26296	13007	10	0	\N
197446	1397	1281164251000	26298	13008	0	0	\N
197447	2134	84497802000	26298	13008	1	0	\N
197448	1397	1281154250000	26299	13009	0	0	\N
197449	1397	1281144249000	26299	13009	1	0	\N
197450	2134	84496799000	26299	13009	2	0	\N
197451	2134	84495796000	26299	13009	3	0	\N
197452	2132	147397410000	26299	13009	4	0	\N
197458	1397	1281154250000	26301	13009	0	0	\N
197459	1397	1281144249000	26301	13009	1	0	\N
197460	2134	84496799000	26301	13009	2	0	\N
197461	2134	84495796000	26301	13009	3	0	\N
197462	2132	147397410000	26301	13009	4	0	\N
197375	1397	1281304265000	26283	12999	2	0	15752
197376	2134	84513850000	26283	12999	3	0	6058
197377	2134	84512847000	26283	12999	4	0	6059
197378	2134	84511844000	26283	12999	5	0	6060
197379	2132	147402415000	26283	12999	6	0	1586
197390	2134	84510841000	26286	13000	1	0	6061
197391	1397	1281284263000	26287	13001	0	0	15754
197392	2134	84509838000	26287	13001	1	0	6062
197393	1397	1281274262000	26288	13002	0	0	15755
197394	1397	1281264261000	26288	13002	1	0	15756
197396	2132	147401414000	26288	13002	3	0	1587
197397	2134	84508835000	26288	13002	4	0	6063
197398	2134	84507832000	26288	13002	5	0	6064
197399	2134	84506829000	26288	13002	6	0	6065
197401	2134	84505826000	26289	13003	1	0	6066
197402	2132	147400413000	26289	13003	2	0	1588
197403	1397	1281234258000	26290	13004	0	0	15759
197404	2134	84504823000	26290	13004	1	0	6067
197407	1397	1281224257000	26292	13005	0	0	15760
197409	1397	1281214256000	26293	13006	0	0	15761
197410	2134	84502817000	26293	13006	1	0	6069
197422	1397	1281204255000	26295	13007	0	0	15762
197423	1397	1281194254000	26295	13007	1	0	15763
197424	1397	1281184253000	26295	13007	2	0	15764
197426	2132	147399412000	26295	13007	4	0	1589
197427	2132	147398411000	26295	13007	5	0	1590
197428	2134	84501814000	26295	13007	6	0	6070
197429	2134	84500811000	26295	13007	7	0	6071
197431	2134	84498805000	26295	13007	9	0	6073
197432	531	66000000000000	26295	13007	10	0	1
197444	1397	1281164251000	26297	13008	0	0	15766
197445	2134	84497802000	26297	13008	1	0	6074
197453	1397	1281154250000	26300	13009	0	0	15767
197455	2134	84496799000	26300	13009	2	0	6075
197456	2134	84495796000	26300	13009	3	0	6076
197457	2132	147397410000	26300	13009	4	0	1591
197463	1397	1281134248000	26302	13010	0	0	15769
197464	1397	1281124247000	26302	13010	1	0	15770
197466	2134	84494793000	26302	13010	3	0	6077
197467	2134	84493790000	26302	13010	4	0	6078
197468	2134	84492787000	26302	13010	5	0	6079
197469	1397	1281104245000	26303	13011	0	0	15772
197471	2132	147396409000	26303	13011	2	0	1592
197472	2134	84491784000	26303	13011	3	0	6080
197476	1397	1281074242000	26305	13013	0	0	\N
197477	2132	147395408000	26305	13013	1	0	\N
197478	2134	84488775000	26305	13013	2	0	\N
197480	1637	301686278819988	26309	12929	0	0	\N
197481	1637	100000000	26309	12929	1	0	\N
197482	2132	147430443000	26309	12929	2	0	\N
197483	2132	147429442000	26309	12929	3	0	\N
197484	2132	147428441000	26309	12929	4	0	\N
197485	2132	147427440000	26309	12929	5	0	\N
197486	531	66000000000000	26309	12929	6	0	\N
197487	2132	147426439000	26309	12929	7	0	\N
197488	2132	147425438000	26309	12929	8	0	\N
197489	2132	147424437000	26309	12929	9	0	\N
197490	2132	147423436000	26309	12929	10	0	\N
197491	2132	147422435000	26309	12929	11	0	\N
197492	2132	147421434000	26309	12929	12	0	\N
197493	2132	147420433000	26309	12929	13	0	\N
197494	2132	147419432000	26309	12929	14	0	\N
197495	2132	147418431000	26309	12929	15	0	\N
197496	2132	147417430000	26309	12929	16	0	\N
197497	2132	147416429000	26309	12929	17	0	\N
197498	2132	147415428000	26309	12929	18	0	\N
197499	2132	147414427000	26309	12929	19	0	\N
197500	2132	147413426000	26309	12929	20	0	\N
197501	2132	147412425000	26309	12929	21	0	\N
197502	2132	147411424000	26309	12929	22	0	\N
197503	2132	147410423000	26309	12929	23	0	\N
197504	2132	147409422000	26309	12929	24	0	\N
197505	2132	147408421000	26309	12929	25	0	\N
197506	2132	147407420000	26309	12929	26	0	\N
197507	2132	147406419000	26309	12929	27	0	\N
197508	2132	147405418000	26309	12929	28	0	\N
197509	2132	147404417000	26309	12929	29	0	\N
197510	2132	147403416000	26309	12929	30	0	\N
197511	2132	147402415000	26309	12929	31	0	\N
197512	2132	147401414000	26309	12929	32	0	\N
197513	2132	147400413000	26309	12929	33	0	\N
197514	2132	147399412000	26309	12929	34	0	\N
197515	2132	147398411000	26309	12929	35	0	\N
197516	2132	147397410000	26309	12929	36	0	\N
197517	2132	147396409000	26309	12929	37	0	\N
197518	2132	147395408000	26309	12929	38	0	\N
197519	1397	1281074242000	26311	13015	0	0	\N
197520	1397	1281064241000	26311	13015	1	0	\N
197521	1397	1281054240000	26311	13015	2	0	\N
197522	2134	84488775000	26311	13015	3	0	\N
197523	2134	84487772000	26311	13015	4	0	\N
197524	2134	84486769000	26311	13015	5	0	\N
197525	1397	1281074242000	26312	13015	0	0	\N
197526	1397	1281064241000	26312	13015	1	0	\N
197527	1397	1281054240000	26312	13015	2	0	\N
197528	2134	84488775000	26312	13015	3	0	\N
197529	2134	84487772000	26312	13015	4	0	\N
197530	2134	84486769000	26312	13015	5	0	\N
197537	1397	1281044239000	26314	13016	0	0	\N
197538	2134	84485766000	26314	13016	1	0	\N
197539	2132	147394407000	26314	13016	2	0	\N
197540	1397	1281044239000	26315	13016	0	0	\N
197541	2134	84485766000	26315	13016	1	0	\N
197542	2132	147394407000	26315	13016	2	0	\N
197545	1397	1281034238000	26317	13017	0	0	\N
197546	1397	1281024237000	26317	13017	1	0	\N
197547	2134	84485766000	26317	13017	2	0	\N
197548	2134	84484763000	26317	13017	3	0	\N
197549	2134	84483760000	26317	13017	4	0	\N
197550	1397	1281034238000	26318	13017	0	0	\N
197551	1397	1281024237000	26318	13017	1	0	\N
197552	2134	84485766000	26318	13017	2	0	\N
197553	2134	84484763000	26318	13017	3	0	\N
197554	2134	84483760000	26318	13017	4	0	\N
197555	1397	1281034238000	26319	13017	0	0	\N
197556	1397	1281024237000	26319	13017	1	0	\N
197557	2134	84485766000	26319	13017	2	0	\N
197558	2134	84484763000	26319	13017	3	0	\N
197559	2134	84483760000	26319	13017	4	0	\N
197565	1397	1281034238000	26321	13017	0	0	\N
197566	1397	1281024237000	26321	13017	1	0	\N
197567	2134	84485766000	26321	13017	2	0	\N
197568	2134	84484763000	26321	13017	3	0	\N
197569	2134	84483760000	26321	13017	4	0	\N
197570	1397	1281014236000	26322	13018	0	0	\N
197571	1397	1281004235000	26322	13018	1	0	\N
197572	2134	84482757000	26322	13018	2	0	\N
197573	2134	84481754000	26322	13018	3	0	\N
197574	2132	147393406000	26322	13018	4	0	\N
197580	1397	1281014236000	26324	13018	0	0	\N
197581	1397	1281004235000	26324	13018	1	0	\N
197582	2134	84482757000	26324	13018	2	0	\N
197583	2134	84481754000	26324	13018	3	0	\N
197584	2132	147393406000	26324	13018	4	0	\N
197587	1397	1280984233000	26326	13020	0	0	\N
197588	2134	84479748000	26326	13020	1	0	\N
197589	1397	1280984233000	26327	13020	0	0	\N
197592	1397	1280974232000	26329	13021	0	0	\N
197593	1397	1280964231000	26329	13021	1	0	\N
197594	2132	147392405000	26329	13021	2	0	\N
197598	1397	1280974232000	26331	13021	0	0	\N
197599	1397	1280964231000	26331	13021	1	0	\N
197600	2132	147392405000	26331	13021	2	0	\N
197601	2134	84478745000	26331	13021	3	0	\N
197602	2134	84477742000	26331	13021	4	0	\N
197603	1397	1280974232000	26332	13021	0	0	\N
197604	1397	1280964231000	26332	13021	1	0	\N
197605	2132	147392405000	26332	13021	2	0	\N
197606	2134	84478745000	26332	13021	3	0	\N
197607	2134	84477742000	26332	13021	4	0	\N
197608	1397	1280974232000	26333	13021	0	0	\N
197475	2134	84489778000	26304	13012	1	0	6082
197479	2132	147395408000	26306	13013	0	0	1593
197531	1397	1281074242000	26313	13015	0	0	15775
197532	1397	1281064241000	26313	13015	1	0	15776
197533	1397	1281054240000	26313	13015	2	0	15777
197535	2134	84487772000	26313	13015	4	0	6084
197536	2134	84486769000	26313	13015	5	0	6085
197543	1397	1281044239000	26316	13016	0	0	15778
197544	2132	147394407000	26316	13016	1	0	1594
197560	1397	1281034238000	26320	13017	0	0	15779
197562	2134	84485766000	26320	13017	2	0	6086
197563	2134	84484763000	26320	13017	3	0	6087
197564	2134	84483760000	26320	13017	4	0	6088
197575	1397	1281014236000	26323	13018	0	0	15781
197577	2134	84482757000	26323	13018	2	0	6089
197578	2134	84481754000	26323	13018	3	0	6090
197579	2132	147393406000	26323	13018	4	0	1595
197585	1397	1280994234000	26325	13019	0	0	15783
197586	2134	84480751000	26325	13019	1	0	6091
197591	2134	84479748000	26328	13020	1	0	6092
197595	1397	1280974232000	26330	13021	0	0	15785
197596	1397	1280964231000	26330	13021	1	0	15786
197597	2132	147392405000	26330	13021	2	0	1596
197609	1397	1280964231000	26333	13021	1	0	\N
197610	2132	147392405000	26333	13021	2	0	\N
197611	2134	84478745000	26333	13021	3	0	\N
197612	2134	84477742000	26333	13021	4	0	\N
197626	1397	1280914226000	26338	13025	0	0	\N
197632	1397	1280904225000	26340	13026	0	0	\N
197633	1397	1280894224000	26340	13026	1	0	\N
197634	2134	84471724000	26340	13026	2	0	\N
197635	2132	147390403000	26340	13026	3	0	\N
197636	2134	84470721000	26340	13026	4	0	\N
197637	1397	1280904225000	26341	13026	0	0	\N
197638	1397	1280894224000	26341	13026	1	0	\N
197639	2134	84471724000	26341	13026	2	0	\N
197640	2132	147390403000	26341	13026	3	0	\N
197641	2134	84470721000	26341	13026	4	0	\N
197644	1397	1280884223000	26343	13027	0	0	\N
197645	2134	84469718000	26343	13027	1	0	\N
197646	1397	1280874222000	26344	13028	0	0	\N
197647	2132	147389402000	26344	13028	1	0	\N
197648	2134	84468715000	26344	13028	2	0	\N
197649	1397	1280874222000	26345	13028	0	0	\N
197650	2132	147389402000	26345	13028	1	0	\N
197651	2134	84468715000	26345	13028	2	0	\N
197655	2132	147389402000	26347	13028	0	0	\N
197656	2134	84468715000	26347	13028	1	0	\N
197657	1397	1280874222000	26348	13028	0	0	\N
197658	2132	147389402000	26348	13028	1	0	\N
197660	2134	84467712000	26350	13029	0	0	\N
197668	1397	1280864221000	26352	13030	0	0	\N
197669	1397	1280854220000	26352	13030	1	0	\N
197670	1397	1280844219000	26352	13030	2	0	\N
197671	2134	84466709000	26352	13030	3	0	\N
197672	2132	147388401000	26352	13030	4	0	\N
197673	2134	84465706000	26352	13030	5	0	\N
197674	2134	84464703000	26352	13030	6	0	\N
197677	1397	1280834218000	26354	13031	0	0	\N
197678	2134	84463700000	26354	13031	1	0	\N
197688	1397	1280814216000	26357	13033	0	0	\N
197689	1397	1280804215000	26357	13033	1	0	\N
197690	1397	1280794214000	26357	13033	2	0	\N
197691	2134	84461694000	26357	13033	3	0	\N
197692	2132	147387400000	26357	13033	4	0	\N
197693	2134	84460691000	26357	13033	5	0	\N
197694	2134	84459688000	26357	13033	6	0	\N
197695	1397	1282334368000	26358	12927	0	0	\N
197696	1397	1282324367000	26358	12927	1	0	\N
197697	1397	1282314366000	26358	12927	2	0	\N
197698	1397	1282304365000	26358	12927	3	0	\N
197699	1397	1282294364000	26358	12927	4	0	\N
197700	1397	1282284363000	26358	12927	5	0	\N
197701	1397	1282274362000	26358	12927	6	0	\N
197702	1397	1282264361000	26358	12927	7	0	\N
197703	1397	1282254360000	26358	12927	8	0	\N
197704	1397	1282244359000	26358	12927	9	0	\N
197705	1397	1282234358000	26358	12927	10	0	\N
197706	1397	1282224357000	26358	12927	11	0	\N
197707	1397	1282214356000	26358	12927	12	0	\N
197708	1397	1282204355000	26358	12927	13	0	\N
197709	1397	1282194354000	26358	12927	14	0	\N
197710	1397	1282184353000	26358	12927	15	0	\N
197711	1397	1282174352000	26358	12927	16	0	\N
197712	1397	1282164351000	26358	12927	17	0	\N
197713	1397	1282154350000	26358	12927	18	0	\N
197714	1397	1282144349000	26358	12927	19	0	\N
197715	1397	1282134348000	26358	12927	20	0	\N
197716	1397	1282124347000	26358	12927	21	0	\N
197717	1397	1282114346000	26358	12927	22	0	\N
197718	1397	1282104345000	26358	12927	23	0	\N
197719	1397	1282094344000	26358	12927	24	0	\N
197720	1397	1282084343000	26358	12927	25	0	\N
197721	1397	1282074342000	26358	12927	26	0	\N
197722	1397	1282064341000	26358	12927	27	0	\N
197723	1397	1282054340000	26358	12927	28	0	\N
197724	1397	1282044339000	26358	12927	29	0	\N
197725	1397	1282034338000	26358	12927	30	0	\N
197726	1397	1282024337000	26358	12927	31	0	\N
197727	1397	1282014336000	26358	12927	32	0	\N
197728	1397	1282004335000	26358	12927	33	0	\N
197729	1397	1281994334000	26358	12927	34	0	\N
197730	1397	1281984333000	26358	12927	35	0	\N
197731	1397	1281974332000	26358	12927	36	0	\N
197732	1397	1281964331000	26358	12927	37	0	\N
197733	1397	1281954330000	26358	12927	38	0	\N
197734	1397	1281944329000	26358	12927	39	0	\N
197735	1397	1281934328000	26358	12927	40	0	\N
197736	1397	1281924327000	26358	12927	41	0	\N
197737	1397	1281914326000	26358	12927	42	0	\N
197738	1397	1281904325000	26358	12927	43	0	\N
197739	1397	1281894324000	26358	12927	44	0	\N
197740	1397	1281884323000	26358	12927	45	0	\N
197741	1397	1281874322000	26358	12927	46	0	\N
197742	1397	1281864321000	26358	12927	47	0	\N
197743	1397	1281854320000	26358	12927	48	0	\N
197744	1397	1281844319000	26358	12927	49	0	\N
197615	2134	84477742000	26334	13022	2	0	6094
197616	2134	84476739000	26334	13022	3	0	6095
197617	1397	1280944229000	26335	13023	0	0	15788
197618	2134	84475736000	26335	13023	1	0	6096
197619	2132	147391404000	26335	13023	2	0	1597
197621	1397	1280924227000	26336	13024	1	0	15790
197622	2134	84474733000	26336	13024	2	0	6097
197623	2134	84473730000	26336	13024	3	0	6098
197624	1397	1280914226000	26337	13025	0	0	15791
197625	2134	84472727000	26337	13025	1	0	6099
197628	1397	1280894224000	26339	13026	1	0	15793
197629	2134	84471724000	26339	13026	2	0	6100
197630	2132	147390403000	26339	13026	3	0	1598
197631	2134	84470721000	26339	13026	4	0	6101
197643	2134	84469718000	26342	13027	1	0	6102
197652	1397	1280874222000	26346	13028	0	0	15795
197653	2132	147389402000	26346	13028	1	0	1599
197654	2134	84468715000	26346	13028	2	0	6103
197659	2134	84467712000	26349	13029	0	0	6104
197662	1397	1280854220000	26351	13030	1	0	15797
197663	1397	1280844219000	26351	13030	2	0	15798
197664	2134	84466709000	26351	13030	3	0	6105
197665	2132	147388401000	26351	13030	4	0	1600
197666	2134	84465706000	26351	13030	5	0	6106
197675	1397	1280834218000	26353	13031	0	0	15799
197676	2134	84463700000	26353	13031	1	0	6108
197679	1397	1280824217000	26355	13032	0	0	15800
197680	2134	84462697000	26355	13032	1	0	6109
197682	1397	1280804215000	26356	13033	1	0	15802
197683	1397	1280794214000	26356	13033	2	0	15803
197684	2134	84461694000	26356	13033	3	0	6110
197685	2132	147387400000	26356	13033	4	0	1601
197686	2134	84460691000	26356	13033	5	0	6111
197745	1397	1281834318000	26358	12927	50	0	\N
197746	1397	1281824317000	26358	12927	51	0	\N
197747	1397	1281814316000	26358	12927	52	0	\N
197748	1397	1281804315000	26358	12927	53	0	\N
197749	1397	1281794314000	26358	12927	54	0	\N
197750	1397	1281784313000	26358	12927	55	0	\N
197751	1397	1281774312000	26358	12927	56	0	\N
197752	1397	1281764311000	26358	12927	57	0	\N
197753	1397	1281754310000	26358	12927	58	0	\N
197754	1397	1281744309000	26358	12927	59	0	\N
197755	1397	1281734308000	26358	12927	60	0	\N
197756	1397	1281724307000	26358	12927	61	0	\N
197757	1397	1281714306000	26358	12927	62	0	\N
197758	1397	1281704305000	26358	12927	63	0	\N
197759	1397	1281694304000	26358	12927	64	0	\N
197760	1397	1281684303000	26358	12927	65	0	\N
197761	1397	1281674302000	26358	12927	66	0	\N
197762	1397	1281664301000	26358	12927	67	0	\N
197763	1397	1281654300000	26358	12927	68	0	\N
197764	1397	1281644299000	26358	12927	69	0	\N
197765	1397	1281634298000	26358	12927	70	0	\N
197766	1397	1281624297000	26358	12927	71	0	\N
197767	1397	1281614296000	26358	12927	72	0	\N
197768	1397	1281604295000	26358	12927	73	0	\N
197769	1397	1281594294000	26358	12927	74	0	\N
197770	1397	1281584293000	26358	12927	75	0	\N
197771	1397	1281574292000	26358	12927	76	0	\N
197772	1397	1281564291000	26358	12927	78	0	\N
197773	1397	1281554290000	26358	12927	79	0	\N
197774	1397	1281544289000	26358	12927	80	0	\N
197775	1397	1281534288000	26358	12927	81	0	\N
197776	1397	1281524287000	26358	12927	82	0	\N
197777	1397	1281514286000	26358	12927	83	0	\N
197778	1397	1281504285000	26358	12927	84	0	\N
197779	1397	1281494284000	26358	12927	85	0	\N
197780	1397	1281484283000	26358	12927	86	0	\N
197781	1397	1281474282000	26358	12927	87	0	\N
197782	1397	1281464281000	26358	12927	88	0	\N
197783	1397	1281454280000	26358	12927	89	0	\N
197784	1397	1281444279000	26358	12927	90	0	\N
197785	1397	1281434278000	26358	12927	91	0	\N
197786	1397	1281424277000	26358	12927	92	0	\N
197787	1397	1281414276000	26358	12927	93	0	\N
197788	1397	1281404275000	26358	12927	94	0	\N
197789	1397	1281394274000	26358	12927	95	0	\N
197790	1397	1281384273000	26358	12927	96	0	\N
197791	1397	1281374272000	26358	12927	97	0	\N
197792	1397	1281364271000	26358	12927	98	0	\N
197793	1397	1281354270000	26358	12927	99	0	\N
197794	1397	1281344269000	26358	12927	100	0	\N
197795	1397	1281334268000	26358	12927	101	0	\N
197796	1397	1281324267000	26358	12927	102	0	\N
197797	1397	1281314266000	26358	12927	103	0	\N
197798	1397	1281304265000	26358	12927	104	0	\N
197799	1397	1281294264000	26358	12927	105	0	\N
197800	1397	1281284263000	26358	12927	106	0	\N
197801	1397	1281274262000	26358	12927	107	0	\N
197802	1397	1281264261000	26358	12927	108	0	\N
197803	1397	1281254260000	26358	12927	109	0	\N
197804	1397	1281244259000	26358	12927	110	0	\N
197805	1397	1281234258000	26358	12927	111	0	\N
197806	1397	1281224257000	26358	12927	112	0	\N
197807	1397	1281214256000	26358	12927	113	0	\N
197808	1397	1281204255000	26358	12927	114	0	\N
197809	1397	1281194254000	26358	12927	115	0	\N
197810	1397	1281184253000	26358	12927	116	0	\N
197811	1397	1281174252000	26358	12927	117	0	\N
197812	1397	1281164251000	26358	12927	118	0	\N
197813	1397	1281154250000	26358	12927	119	0	\N
197814	1397	1281144249000	26358	12927	120	0	\N
197815	1397	1281134248000	26358	12927	121	0	\N
197816	1397	1281124247000	26358	12927	122	0	\N
197817	1397	1281114246000	26358	12927	123	0	\N
197818	1397	1281104245000	26358	12927	124	0	\N
197819	1397	1281094244000	26358	12927	125	0	\N
197827	1397	1280754210000	26362	13037	0	0	\N
197828	2132	147385398000	26362	13037	1	0	\N
197829	2134	84455676000	26362	13037	2	0	\N
197849	1397	1280684203000	26369	13042	0	0	\N
197850	1397	1280674202000	26369	13042	1	0	\N
197851	2132	147383396000	26369	13042	2	0	\N
197852	2134	84448655000	26369	13042	3	0	\N
197853	2134	84447652000	26369	13042	4	0	\N
197866	1397	1280654200000	26372	13044	0	0	\N
197867	2134	84445646000	26372	13044	1	0	\N
197868	1726	979179112000	26372	13044	2	0	\N
197869	2338	9000000	26372	13044	3	0	\N
197870	2132	147382395000	26372	13044	4	0	\N
197871	2133	91052750000	26372	13044	5	0	\N
197872	1397	1280654200000	26373	13044	0	0	\N
197873	2134	84445646000	26373	13044	1	0	\N
197874	1726	979179112000	26373	13044	2	0	\N
197875	2338	9000000	26373	13044	3	0	\N
197876	2132	147382395000	26373	13044	4	0	\N
197877	2133	91052750000	26373	13044	5	0	\N
197822	2132	147386399000	26359	13034	2	0	1602
197823	1397	1280774212000	26360	13035	0	0	15805
197824	2134	84457682000	26360	13035	1	0	6114
197825	1397	1280764211000	26361	13036	0	0	15806
197826	2134	84456679000	26361	13036	1	0	6115
197831	2132	147385398000	26363	13037	1	0	1603
197832	2134	84455676000	26363	13037	2	0	6116
197833	1397	1280744209000	26364	13038	0	0	15808
197834	2134	84454673000	26364	13038	1	0	6117
197835	1397	1280734208000	26366	13040	0	0	15809
197837	1397	1280714206000	26366	13040	2	0	15811
197838	2134	84453670000	26366	13040	3	0	6118
197839	2134	84452667000	26366	13040	4	0	6119
197840	2134	84451664000	26366	13040	5	0	6120
197842	1397	1280704205000	26367	13041	0	0	15812
197843	1397	1280694204000	26367	13041	1	0	15813
197844	2134	84450661000	26367	13041	2	0	6121
197845	2134	84449658000	26367	13041	3	0	6122
197846	1397	1280684203000	26368	13042	0	0	15814
197848	2132	147383396000	26368	13042	2	0	1605
197854	1397	1280664201000	26370	13043	0	0	15816
197855	2133	91053752000	26370	13043	1	0	5626
197856	2134	84448655000	26370	13043	2	0	6123
197857	2134	84447652000	26370	13043	3	0	6124
197859	1726	980280112000	26370	13043	5	0	8305
197860	1397	1280654200000	26371	13044	0	0	15817
197861	2134	84445646000	26371	13044	1	0	6126
197862	1726	979179112000	26371	13044	2	0	8306
197864	2132	147382395000	26371	13044	4	0	1606
197865	2133	91052750000	26371	13044	5	0	5627
197878	1397	1280644199000	26374	13045	0	0	15818
197879	1397	1280634198000	26374	13045	1	0	15819
197880	2134	84444643000	26374	13045	2	0	6127
197892	1397	1280624197000	26376	13046	0	0	\N
197893	1397	1280614196000	26376	13046	1	0	\N
197894	1726	978078112000	26376	13046	2	0	\N
197895	2132	147381394000	26376	13046	3	0	\N
197896	2134	84442637000	26376	13046	4	0	\N
197897	2133	91049744000	26376	13046	5	0	\N
197898	2133	91048742000	26376	13046	6	0	\N
197899	2134	84441634000	26376	13046	7	0	\N
197903	1397	1280604195000	26378	13047	0	0	\N
197904	2134	84440631000	26378	13047	1	0	\N
197905	2133	91047740000	26378	13047	2	0	\N
197909	1397	1280594194000	26380	13048	0	0	\N
197910	2133	91046738000	26380	13048	1	0	\N
197911	2134	84439628000	26380	13048	2	0	\N
197916	1397	1280584193000	26382	13049	0	0	\N
197917	2132	147380393000	26382	13049	1	0	\N
197918	2133	91045736000	26382	13049	2	0	\N
197919	2134	84438625000	26382	13049	3	0	\N
197920	1397	1280584193000	26383	13049	0	0	\N
197921	2132	147380393000	26383	13049	1	0	\N
197922	2133	91045736000	26383	13049	2	0	\N
197923	2134	84438625000	26383	13049	3	0	\N
197924	1397	1280584193000	26384	13049	0	0	\N
197925	2132	147380393000	26384	13049	1	0	\N
197926	2133	91045736000	26384	13049	2	0	\N
197927	2134	84438625000	26384	13049	3	0	\N
197928	1397	1280584193000	26385	13049	0	0	\N
197929	2132	147380393000	26385	13049	1	0	\N
197930	2133	91045736000	26385	13049	2	0	\N
197931	2134	84438625000	26385	13049	3	0	\N
197958	1397	1280514186000	26391	13054	0	0	\N
197959	1397	1280504185000	26391	13054	1	0	\N
197960	2133	91038722000	26391	13054	2	0	\N
197961	2133	91037720000	26391	13054	3	0	\N
197962	2132	147378391000	26391	13054	4	0	\N
197963	2134	84431604000	26391	13054	5	0	\N
197964	2134	84430601000	26391	13054	6	0	\N
197965	2133	91160966000	26392	12900	0	0	\N
197966	1637	301686278819988	26392	12900	1	0	\N
197967	2133	91159964000	26392	12900	2	0	\N
197968	1726	998997112000	26392	12900	3	0	\N
197969	1637	100000000	26392	12900	4	0	\N
197970	2132	147430443000	26392	12900	5	0	\N
197971	2132	147429442000	26392	12900	6	0	\N
197972	2132	147428441000	26392	12900	7	0	\N
197973	2132	147427440000	26392	12900	8	0	\N
197974	1726	997896112000	26392	12900	9	0	\N
197975	1726	996795112000	26392	12900	10	0	\N
197976	1726	995694112000	26392	12900	11	0	\N
197977	1726	994593112000	26392	12900	12	0	\N
197978	1726	993492112000	26392	12900	13	0	\N
197979	1726	992391112000	26392	12900	14	0	\N
197980	2133	91158962000	26392	12900	15	0	\N
197981	2133	91157960000	26392	12900	16	0	\N
197982	2133	91156958000	26392	12900	17	0	\N
197983	2133	91155956000	26392	12900	18	0	\N
197984	2133	91154954000	26392	12900	19	0	\N
197985	2133	91153952000	26392	12900	20	0	\N
197986	2133	91152950000	26392	12900	21	0	\N
197987	2133	91151948000	26392	12900	22	0	\N
197988	2133	91150946000	26392	12900	23	0	\N
197989	2133	91149944000	26392	12900	24	0	\N
197990	2133	91148942000	26392	12900	25	0	\N
197991	2133	91147940000	26392	12900	26	0	\N
197992	2133	91146938000	26392	12900	27	0	\N
197993	2133	91145936000	26392	12900	28	0	\N
197994	2133	91144934000	26392	12900	29	0	\N
197995	2133	91143932000	26392	12900	30	0	\N
197996	2133	91142930000	26392	12900	31	0	\N
197997	2133	91141928000	26392	12900	32	0	\N
197998	2133	91140926000	26392	12900	33	0	\N
197999	2133	91139924000	26392	12900	34	0	\N
198000	2133	91138922000	26392	12900	35	0	\N
198001	2133	91137920000	26392	12900	36	0	\N
198002	2133	91136918000	26392	12900	37	0	\N
198003	2133	91135916000	26392	12900	38	0	\N
198004	2133	91134914000	26392	12900	39	0	\N
198005	2133	91133912000	26392	12900	40	0	\N
198006	2133	91132910000	26392	12900	41	0	\N
198007	2133	91131908000	26392	12900	42	0	\N
198008	2133	91130906000	26392	12900	43	0	\N
198009	2133	91129904000	26392	12900	44	0	\N
198010	2133	91128902000	26392	12900	45	0	\N
198011	2133	91127900000	26392	12900	46	0	\N
198012	2133	91126898000	26392	12900	47	0	\N
198013	2133	91125896000	26392	12900	48	0	\N
198014	2133	91124894000	26392	12900	49	0	\N
198015	2133	91123892000	26392	12900	50	0	\N
198016	2133	91122890000	26392	12900	51	0	\N
197883	2133	91050746000	26374	13045	5	0	5629
197884	1397	1280624197000	26375	13046	0	0	15820
197885	1397	1280614196000	26375	13046	1	0	15821
197886	1726	978078112000	26375	13046	2	0	8307
197887	2132	147381394000	26375	13046	3	0	1607
197889	2133	91049744000	26375	13046	5	0	5630
197890	2133	91048742000	26375	13046	6	0	5631
197891	2134	84441634000	26375	13046	7	0	6130
197900	1397	1280604195000	26377	13047	0	0	15822
197901	2134	84440631000	26377	13047	1	0	6131
197906	1397	1280594194000	26379	13048	0	0	15823
197907	2133	91046738000	26379	13048	1	0	5633
197908	2134	84439628000	26379	13048	2	0	6132
197912	1397	1280584193000	26381	13049	0	0	15824
197914	2133	91045736000	26381	13049	2	0	5634
197915	2134	84438625000	26381	13049	3	0	6133
197932	1397	1280574192000	26386	13050	0	0	15825
197933	2134	84437622000	26386	13050	1	0	6134
197934	2133	91044734000	26386	13050	2	0	5635
197936	2133	91043732000	26387	13051	1	0	5636
197937	2134	84436619000	26387	13051	2	0	6135
197938	1397	1280554190000	26388	13052	0	0	15827
197939	1397	1280544189000	26388	13052	1	0	15828
197940	2133	91042730000	26388	13052	2	0	5637
197942	2132	147379392000	26388	13052	4	0	1609
197943	2134	84435616000	26388	13052	5	0	6136
197944	2134	84434613000	26388	13052	6	0	6137
197945	1397	1280534188000	26389	13053	0	0	15829
197947	2134	84433610000	26389	13053	2	0	6138
197948	2133	91040726000	26389	13053	3	0	5639
197949	2133	91039724000	26389	13053	4	0	5640
197950	2134	84432607000	26389	13053	5	0	6139
197951	1397	1280514186000	26390	13054	0	0	15831
197953	2133	91038722000	26390	13054	2	0	5641
197954	2133	91037720000	26390	13054	3	0	5642
197955	2132	147378391000	26390	13054	4	0	1610
197956	2134	84431604000	26390	13054	5	0	6140
197957	2134	84430601000	26390	13054	6	0	6141
198017	2133	91121888000	26392	12900	52	0	\N
198018	2133	91120886000	26392	12900	53	0	\N
198019	2133	91119884000	26392	12900	54	0	\N
198020	2133	91118882000	26392	12900	55	0	\N
198021	2133	91117880000	26392	12900	56	0	\N
198022	2133	91116878000	26392	12900	57	0	\N
198023	2133	91115876000	26392	12900	58	0	\N
198024	2133	91114874000	26392	12900	59	0	\N
198025	2133	91113872000	26392	12900	60	0	\N
198026	2133	91112870000	26392	12900	61	0	\N
198027	2133	91111868000	26392	12900	62	0	\N
198028	2133	91110866000	26392	12900	63	0	\N
198029	2133	91109864000	26392	12900	64	0	\N
198030	2133	91108862000	26392	12900	65	0	\N
198031	2133	91107860000	26392	12900	66	0	\N
198032	2133	91106858000	26392	12900	67	0	\N
198033	2133	91105856000	26392	12900	68	0	\N
198034	2133	91104854000	26392	12900	69	0	\N
198035	2133	91103852000	26392	12900	70	0	\N
198036	2133	91102850000	26392	12900	71	0	\N
198037	2133	91101848000	26392	12900	72	0	\N
198038	2133	91100846000	26392	12900	73	0	\N
198039	2133	91099844000	26392	12900	74	0	\N
198040	2133	91098842000	26392	12900	75	0	\N
198041	2133	91097840000	26392	12900	76	0	\N
198042	2133	91096838000	26392	12900	78	0	\N
198043	2133	91095836000	26392	12900	79	0	\N
198044	2133	91094834000	26392	12900	80	0	\N
198045	2133	91093832000	26392	12900	81	0	\N
198046	2133	91092830000	26392	12900	82	0	\N
198047	2133	91091828000	26392	12900	83	0	\N
198048	2133	91090826000	26392	12900	84	0	\N
198049	2133	91089824000	26392	12900	85	0	\N
198050	2133	91088822000	26392	12900	86	0	\N
198051	2133	91087820000	26392	12900	87	0	\N
198052	531	66000000000000	26392	12900	88	0	\N
198053	2132	147426439000	26392	12900	89	0	\N
198054	2132	147425438000	26392	12900	90	0	\N
198055	2132	147424437000	26392	12900	91	0	\N
198056	2132	147423436000	26392	12900	92	0	\N
198057	2132	147422435000	26392	12900	93	0	\N
198058	2132	147421434000	26392	12900	94	0	\N
198059	2132	147420433000	26392	12900	95	0	\N
198060	2132	147419432000	26392	12900	96	0	\N
198061	2132	147418431000	26392	12900	97	0	\N
198062	2132	147417430000	26392	12900	98	0	\N
198063	2132	147416429000	26392	12900	99	0	\N
198064	2132	147415428000	26392	12900	100	0	\N
198065	2132	147414427000	26392	12900	101	0	\N
198066	2132	147413426000	26392	12900	102	0	\N
198067	2132	147412425000	26392	12900	103	0	\N
198068	2132	147411424000	26392	12900	104	0	\N
198069	2132	147410423000	26392	12900	105	0	\N
198070	2132	147409422000	26392	12900	106	0	\N
198071	2132	147408421000	26392	12900	107	0	\N
198072	2132	147407420000	26392	12900	108	0	\N
198073	2132	147406419000	26392	12900	109	0	\N
198074	2132	147405418000	26392	12900	110	0	\N
198075	2132	147404417000	26392	12900	111	0	\N
198076	2132	147403416000	26392	12900	112	0	\N
198077	2132	147402415000	26392	12900	113	0	\N
198078	2132	147401414000	26392	12900	114	0	\N
198079	2132	147400413000	26392	12900	115	0	\N
198094	1397	1280454180000	26396	13058	0	0	\N
198095	1397	1280444179000	26396	13058	2	0	\N
198096	2133	91032710000	26396	13058	3	0	\N
198097	2133	91031708000	26396	13058	4	0	\N
198098	2134	84425586000	26396	13058	5	0	\N
198099	2134	84424583000	26396	13058	6	0	\N
198100	2132	147376389000	26396	13058	7	0	\N
198124	1397	1280394174000	26403	13063	0	0	\N
198125	2133	91026698000	26403	13063	1	0	\N
198126	2134	84419568000	26403	13063	2	0	\N
198131	1397	1280384173000	26405	13064	0	0	\N
198132	2134	84418565000	26405	13064	1	0	\N
198133	2132	147374387000	26405	13064	2	0	\N
198134	2133	91025696000	26405	13064	3	0	\N
198135	1397	1280434178000	26406	13059	0	0	\N
198136	1397	1280424177000	26406	13059	1	0	\N
198137	1397	1280414176000	26406	13059	2	0	\N
198138	1397	1280404175000	26406	13059	3	0	\N
198139	1397	1280394174000	26406	13059	4	0	\N
198140	1397	1280384173000	26406	13059	5	0	\N
198141	1397	1280374172000	26406	13059	6	0	\N
198142	2134	84423580000	26406	13059	7	0	\N
198143	2134	84422577000	26406	13059	8	0	\N
198144	2133	91030706000	26406	13059	9	0	\N
198145	2134	84421574000	26406	13059	10	0	\N
198146	2134	84420571000	26406	13059	11	0	\N
198147	2134	84419568000	26406	13059	12	0	\N
198148	2134	84418565000	26406	13059	13	0	\N
198149	2132	147375388000	26406	13059	14	0	\N
198150	2132	147374387000	26406	13059	15	0	\N
198151	2133	91029704000	26406	13059	16	0	\N
198152	2133	91028702000	26406	13059	17	0	\N
198082	2132	147377390000	26393	13055	2	0	1611
198083	2133	91036718000	26393	13055	3	0	5643
198084	2133	91035716000	26393	13055	4	0	5644
198085	2134	84429598000	26393	13055	5	0	6142
198086	2134	84428595000	26393	13055	6	0	6143
198088	2134	84427592000	26394	13056	1	0	6144
198089	2133	91034714000	26394	13056	2	0	5645
198090	1397	1280464181000	26395	13057	0	0	15836
198091	2134	84426589000	26395	13057	1	0	6145
198092	1741	1439021000000	26395	13057	2	0	1
198101	1397	1280454180000	26397	13058	0	0	15837
198102	1397	1280444179000	26397	13058	2	0	15838
198103	2133	91032710000	26397	13058	3	0	5647
198104	2133	91031708000	26397	13058	4	0	5648
198106	2134	84424583000	26397	13058	6	0	6147
198107	2132	147376389000	26397	13058	7	0	1612
198108	1397	1280434178000	26398	13059	0	0	15839
198109	2134	84423580000	26398	13059	1	0	6148
198110	1397	1280424177000	26399	13060	0	0	15840
198112	2133	91030706000	26399	13060	2	0	5649
198113	2133	91029704000	26399	13060	3	0	5650
198114	1397	1280414176000	26400	13061	0	0	15841
198115	2133	91028702000	26400	13061	1	0	5651
198116	2134	84421574000	26400	13061	2	0	6150
198118	1397	1280404175000	26401	13062	0	0	15842
198119	2134	84420571000	26401	13062	1	0	6151
198120	2133	91027700000	26401	13062	2	0	5652
198121	1397	1280394174000	26402	13063	0	0	15843
198123	2134	84419568000	26402	13063	2	0	6152
198127	1397	1280384173000	26404	13064	0	0	15844
198128	2134	84418565000	26404	13064	1	0	6153
198129	2132	147374387000	26404	13064	2	0	1614
198130	2133	91025696000	26404	13064	3	0	5654
198153	2133	91027700000	26406	13059	18	0	\N
198154	2133	91026698000	26406	13059	19	0	\N
198155	2133	91025696000	26406	13059	20	0	\N
198156	1397	1280374172000	26407	13065	0	0	\N
198157	1397	1280364171000	26407	13065	1	0	\N
198158	2134	84417562000	26407	13065	2	0	\N
198159	2134	84416559000	26407	13065	3	0	\N
198160	2133	91024694000	26407	13065	4	0	\N
198161	2133	91023692000	26407	13065	5	0	\N
198168	1397	1281794314000	26409	12853	0	0	\N
198169	1397	1281784313000	26409	12853	1	0	\N
198170	1397	1281774312000	26409	12853	2	0	\N
198171	1397	1281764311000	26409	12853	3	0	\N
198172	1397	1281754310000	26409	12853	4	0	\N
198173	1397	1281744309000	26409	12853	5	0	\N
198174	1397	1281734308000	26409	12853	6	0	\N
198175	1397	1281724307000	26409	12853	7	0	\N
198176	1397	1281714306000	26409	12853	8	0	\N
198177	1397	1281704305000	26409	12853	9	0	\N
198178	1397	1281694304000	26409	12853	10	0	\N
198179	1397	1281684303000	26409	12853	11	0	\N
198180	1397	1281674302000	26409	12853	12	0	\N
198181	1397	1281664301000	26409	12853	13	0	\N
198182	1397	1281654300000	26409	12853	14	0	\N
198183	1397	1281644299000	26409	12853	15	0	\N
198184	1397	1281634298000	26409	12853	16	0	\N
198185	1397	1281624297000	26409	12853	17	0	\N
198186	1397	1281614296000	26409	12853	18	0	\N
198187	1397	1281604295000	26409	12853	19	0	\N
198188	1397	1281594294000	26409	12853	20	0	\N
198189	1397	1281584293000	26409	12853	21	0	\N
198190	1397	1281574292000	26409	12853	22	0	\N
198191	1397	1281564291000	26409	12853	23	0	\N
198192	1397	1281554290000	26409	12853	24	0	\N
198193	1397	1281544289000	26409	12853	25	0	\N
198194	1397	1281534288000	26409	12853	26	0	\N
198195	1397	1281524287000	26409	12853	27	0	\N
198196	1397	1281514286000	26409	12853	28	0	\N
198197	1397	1281504285000	26409	12853	29	0	\N
198198	1397	1281494284000	26409	12853	30	0	\N
198199	1397	1281484283000	26409	12853	31	0	\N
198200	1397	1281474282000	26409	12853	32	0	\N
198201	1397	1281464281000	26409	12853	33	0	\N
198202	1397	1281454280000	26409	12853	34	0	\N
198203	1397	1281444279000	26409	12853	35	0	\N
198204	1397	1281434278000	26409	12853	36	0	\N
198205	1397	1281424277000	26409	12853	37	0	\N
198206	1397	1281414276000	26409	12853	38	0	\N
198207	1397	1281404275000	26409	12853	39	0	\N
198208	1397	1281394274000	26409	12853	40	0	\N
198209	1397	1281384273000	26409	12853	41	0	\N
198210	1397	1281374272000	26409	12853	42	0	\N
198211	1397	1281364271000	26409	12853	43	0	\N
198212	1397	1281354270000	26409	12853	44	0	\N
198213	1397	1281344269000	26409	12853	45	0	\N
198214	1397	1281334268000	26409	12853	46	0	\N
198215	1397	1281324267000	26409	12853	47	0	\N
198216	1397	1281314266000	26409	12853	48	0	\N
198217	1397	1281304265000	26409	12853	49	0	\N
198218	1397	1281294264000	26409	12853	50	0	\N
198219	1397	1281284263000	26409	12853	51	0	\N
198220	1397	1281274262000	26409	12853	52	0	\N
198221	1397	1281264261000	26409	12853	53	0	\N
198222	1397	1281254260000	26409	12853	54	0	\N
198223	1397	1281244259000	26409	12853	55	0	\N
198224	1397	1281234258000	26409	12853	56	0	\N
198225	1397	1281224257000	26409	12853	57	0	\N
198226	1397	1281214256000	26409	12853	58	0	\N
198227	1397	1281204255000	26409	12853	59	0	\N
198228	1397	1281194254000	26409	12853	60	0	\N
198229	1397	1281184253000	26409	12853	61	0	\N
198230	1397	1281174252000	26409	12853	62	0	\N
198231	1397	1281164251000	26409	12853	63	0	\N
198232	1397	1281154250000	26409	12853	64	0	\N
198233	1397	1281144249000	26409	12853	65	0	\N
198234	1397	1281134248000	26409	12853	66	0	\N
198235	1397	1281124247000	26409	12853	67	0	\N
198236	1397	1281114246000	26409	12853	68	0	\N
198237	1397	1281104245000	26409	12853	69	0	\N
198238	1397	1281094244000	26409	12853	70	0	\N
198239	1397	1281084243000	26409	12853	71	0	\N
198240	1397	1281074242000	26409	12853	72	0	\N
198241	1397	1281064241000	26409	12853	73	0	\N
198242	1397	1281054240000	26409	12853	74	0	\N
198243	1397	1281044239000	26409	12853	75	0	\N
198244	1397	1281034238000	26409	12853	76	0	\N
198245	1397	1281024237000	26409	12853	77	0	\N
198246	1397	1281014236000	26409	12853	78	0	\N
198247	1397	1281004235000	26409	12853	79	0	\N
198248	1397	1280994234000	26409	12853	80	0	\N
198249	1397	1280984233000	26409	12853	81	0	\N
198250	1397	1280974232000	26409	12853	82	0	\N
198251	1397	1280964231000	26409	12853	83	0	\N
198252	1397	1280954230000	26409	12853	84	0	\N
198253	1397	1280944229000	26409	12853	85	0	\N
198254	1397	1280934228000	26409	12853	86	0	\N
198255	1397	1280924227000	26409	12853	87	0	\N
198256	1397	1280914226000	26409	12853	88	0	\N
198257	1397	1280904225000	26409	12853	89	0	\N
198258	1397	1280894224000	26409	12853	90	0	\N
198259	1397	1280884223000	26409	12853	91	0	\N
198260	1397	1280874222000	26409	12853	92	0	\N
198261	1397	1280864221000	26409	12853	93	0	\N
198262	1397	1280854220000	26409	12853	94	0	\N
198263	1397	1280844219000	26409	12853	95	0	\N
198264	1397	1280834218000	26409	12853	96	0	\N
198265	1397	1280824217000	26409	12853	97	0	\N
198266	1397	1280814216000	26409	12853	98	0	\N
198267	1397	1280804215000	26409	12853	99	0	\N
198268	1397	1280794214000	26409	12853	100	0	\N
198269	1397	1280784213000	26409	12853	101	0	\N
198270	1397	1280774212000	26409	12853	102	0	\N
198271	1397	1280764211000	26409	12853	103	0	\N
198272	1397	1280754210000	26409	12853	104	0	\N
198273	1397	1280744209000	26409	12853	105	0	\N
198274	1397	1280734208000	26409	12853	106	0	\N
198275	1397	1280724207000	26409	12853	107	0	\N
198276	1397	1280714206000	26409	12853	108	0	\N
198277	1397	1280704205000	26409	12853	109	0	\N
198278	1397	1280694204000	26409	12853	110	0	\N
198279	1397	1280684203000	26409	12853	111	0	\N
198280	1397	1280674202000	26409	12853	112	0	\N
198281	1397	1280664201000	26409	12853	113	0	\N
198282	1397	1280654200000	26409	12853	114	0	\N
198283	1397	1280644199000	26409	12853	115	0	\N
198284	1397	1280634198000	26409	12853	116	0	\N
198285	1397	1280354170000	26410	13066	0	0	\N
198286	2132	147373386000	26410	13066	1	0	\N
198287	2133	91022690000	26410	13066	2	0	\N
198288	2134	84415556000	26410	13066	3	0	\N
198164	2134	84417562000	26408	13065	2	0	6154
198165	2134	84416559000	26408	13065	3	0	6155
198166	2133	91024694000	26408	13065	4	0	5655
198167	2133	91023692000	26408	13065	5	0	5656
198293	1397	1280344169000	26412	13067	0	0	\N
198294	2133	91021688000	26412	13067	1	0	\N
198295	2134	84414553000	26412	13067	2	0	\N
198317	1397	1280334168000	26415	13068	0	0	\N
198318	1397	1280324167000	26415	13068	1	0	\N
198319	1397	1280314166000	26415	13068	2	0	\N
198320	1397	1280304165000	26415	13068	3	0	\N
198321	1397	1280294164000	26415	13068	4	0	\N
198322	2132	147372385000	26415	13068	5	0	\N
198323	2134	84413550000	26415	13068	6	0	\N
198324	1726	976977112000	26415	13068	7	0	\N
198325	1726	975876112000	26415	13068	8	0	\N
198326	2134	84412547000	26415	13068	9	0	\N
198327	2134	84411544000	26415	13068	10	0	\N
198328	2134	84410541000	26415	13068	11	0	\N
198329	2134	84409538000	26415	13068	12	0	\N
198330	2133	91020686000	26415	13068	13	0	\N
198331	2133	91019684000	26415	13068	14	0	\N
198332	2133	91018682000	26415	13068	15	0	\N
198333	2133	91017680000	26415	13068	16	0	\N
198334	2133	91016678000	26415	13068	17	0	\N
198339	1397	1280284163000	26417	13069	0	0	\N
198340	2133	91015676000	26417	13069	1	0	\N
198341	2134	84408535000	26417	13069	2	0	\N
198342	2132	147371384000	26417	13069	3	0	\N
198356	1397	1280244159000	26421	13072	0	0	\N
198357	2133	91011668000	26421	13072	1	0	\N
198358	2134	84405526000	26421	13072	2	0	\N
198359	1397	1280244159000	26422	13072	0	0	\N
198360	2133	91011668000	26422	13072	1	0	\N
198361	2134	84405526000	26422	13072	2	0	\N
198362	1397	1280244159000	26423	13072	0	0	\N
198363	2133	91011668000	26423	13072	1	0	\N
198364	2134	84405526000	26423	13072	2	0	\N
198365	1397	1281084243000	26424	12928	0	0	\N
198366	1397	1281074242000	26424	12928	1	0	\N
198367	1397	1281064241000	26424	12928	2	0	\N
198368	1397	1281054240000	26424	12928	3	0	\N
198369	1397	1281044239000	26424	12928	4	0	\N
198370	1397	1281034238000	26424	12928	5	0	\N
198371	1397	1281024237000	26424	12928	6	0	\N
198372	1397	1281014236000	26424	12928	7	0	\N
198373	1397	1281004235000	26424	12928	8	0	\N
198374	1397	1280994234000	26424	12928	9	0	\N
198375	1397	1280984233000	26424	12928	10	0	\N
198376	1397	1280974232000	26424	12928	11	0	\N
198377	1397	1280964231000	26424	12928	12	0	\N
198378	1397	1280954230000	26424	12928	13	0	\N
198379	1397	1280944229000	26424	12928	14	0	\N
198380	1397	1280934228000	26424	12928	15	0	\N
198381	1397	1280924227000	26424	12928	16	0	\N
198382	1397	1280914226000	26424	12928	17	0	\N
198383	1397	1280904225000	26424	12928	18	0	\N
198384	1397	1280894224000	26424	12928	19	0	\N
198385	1397	1280884223000	26424	12928	20	0	\N
198386	1397	1280874222000	26424	12928	21	0	\N
198387	1397	1280864221000	26424	12928	22	0	\N
198388	1397	1280854220000	26424	12928	23	0	\N
198389	1397	1280844219000	26424	12928	24	0	\N
198390	1397	1280834218000	26424	12928	25	0	\N
198391	1397	1280824217000	26424	12928	26	0	\N
198392	1397	1280814216000	26424	12928	27	0	\N
198393	1397	1280804215000	26424	12928	28	0	\N
198394	1397	1280794214000	26424	12928	29	0	\N
198395	1397	1280784213000	26424	12928	30	0	\N
198396	1397	1280774212000	26424	12928	31	0	\N
198397	1397	1280764211000	26424	12928	32	0	\N
198398	1397	1280754210000	26424	12928	33	0	\N
198399	1397	1280744209000	26424	12928	34	0	\N
198400	1397	1280734208000	26424	12928	35	0	\N
198401	1397	1280724207000	26424	12928	36	0	\N
198402	1397	1280714206000	26424	12928	37	0	\N
198403	1397	1280704205000	26424	12928	38	0	\N
198404	1397	1280694204000	26424	12928	39	0	\N
198405	1397	1280684203000	26424	12928	40	0	\N
198406	1397	1280674202000	26424	12928	41	0	\N
198407	1397	1280664201000	26424	12928	42	0	\N
198408	1397	1280654200000	26424	12928	43	0	\N
198409	1397	1280644199000	26424	12928	44	0	\N
198410	1397	1280634198000	26424	12928	45	0	\N
198411	1397	1280624197000	26424	12928	46	0	\N
198412	1397	1280614196000	26424	12928	47	0	\N
198413	1397	1280604195000	26424	12928	48	0	\N
198414	1397	1280594194000	26424	12928	49	0	\N
198415	1397	1280584193000	26424	12928	50	0	\N
198416	1397	1280574192000	26424	12928	51	0	\N
198417	1397	1280564191000	26424	12928	52	0	\N
198418	1397	1280554190000	26424	12928	53	0	\N
198419	1397	1280544189000	26424	12928	54	0	\N
198420	1397	1280534188000	26424	12928	55	0	\N
198421	1397	1280524187000	26424	12928	56	0	\N
198422	1397	1280514186000	26424	12928	57	0	\N
198423	1397	1280504185000	26424	12928	58	0	\N
198424	1397	1280494184000	26424	12928	59	0	\N
198291	2133	91022690000	26411	13066	2	0	5657
198292	2134	84415556000	26411	13066	3	0	6156
198296	1397	1280344169000	26413	13067	0	0	15848
198297	2133	91021688000	26413	13067	1	0	5658
198298	2134	84414553000	26413	13067	2	0	6157
198300	1397	1280324167000	26414	13068	1	0	15850
198301	1397	1280314166000	26414	13068	2	0	15851
198302	1397	1280304165000	26414	13068	3	0	15852
198303	1397	1280294164000	26414	13068	4	0	15853
198304	2132	147372385000	26414	13068	5	0	1616
198306	1726	976977112000	26414	13068	7	0	8308
198307	1726	975876112000	26414	13068	8	0	8309
198308	2134	84412547000	26414	13068	9	0	6159
198309	2134	84411544000	26414	13068	10	0	6160
198311	2134	84409538000	26414	13068	12	0	6162
198312	2133	91020686000	26414	13068	13	0	5659
198313	2133	91019684000	26414	13068	14	0	5660
198314	2133	91018682000	26414	13068	15	0	5661
198315	2133	91017680000	26414	13068	16	0	5662
198335	1397	1280284163000	26416	13069	0	0	15854
198336	2133	91015676000	26416	13069	1	0	5664
198337	2134	84408535000	26416	13069	2	0	6163
198338	2132	147371384000	26416	13069	3	0	1617
198343	1397	1280274162000	26418	13070	0	0	15855
198345	2133	91014674000	26418	13070	2	0	5665
198346	1397	1280264161000	26419	13071	0	0	15856
198347	1397	1280254160000	26419	13071	1	0	15857
198348	2133	91013672000	26419	13071	2	0	5666
198350	2132	147370383000	26419	13071	4	0	1618
198351	2134	84407532000	26419	13071	5	0	6164
198352	2134	84406529000	26419	13071	6	0	6165
198353	1397	1280244159000	26420	13072	0	0	15858
198354	2133	91011668000	26420	13072	1	0	5668
198425	1397	1280484183000	26424	12928	60	0	\N
198426	1397	1280474182000	26424	12928	61	0	\N
198427	1397	1280464181000	26424	12928	62	0	\N
198428	1397	1280454180000	26424	12928	63	0	\N
198429	1397	1280444179000	26424	12928	64	0	\N
198430	1397	1280434178000	26424	12928	65	0	\N
198431	1397	1280424177000	26424	12928	66	0	\N
198432	1397	1280414176000	26424	12928	67	0	\N
198433	1397	1280404175000	26424	12928	68	0	\N
198434	1397	1280394174000	26424	12928	69	0	\N
198435	1397	1280384173000	26424	12928	70	0	\N
198436	1397	1280374172000	26424	12928	71	0	\N
198437	1397	1280364171000	26424	12928	72	0	\N
198438	1397	1280354170000	26424	12928	73	0	\N
198439	1397	1280344169000	26424	12928	74	0	\N
198440	1397	1280334168000	26424	12928	75	0	\N
198441	1397	1280324167000	26424	12928	76	0	\N
198442	1397	1280314166000	26424	12928	78	0	\N
198443	1397	1280304165000	26424	12928	79	0	\N
198444	1397	1280294164000	26424	12928	80	0	\N
198445	1397	1280284163000	26424	12928	81	0	\N
198446	1397	1280274162000	26424	12928	82	0	\N
198447	1397	1280264161000	26424	12928	83	0	\N
198448	1397	1280254160000	26424	12928	84	0	\N
198449	1397	1280244159000	26424	12928	85	0	\N
198450	1637	301686278819988	26424	12928	86	0	\N
198451	1726	998997112000	26424	12928	87	0	\N
198452	1741	1439021000000	26424	12928	88	0	\N
198459	1397	1280224157000	26427	13074	0	0	\N
198460	2133	91009664000	26427	13074	1	0	\N
198461	2134	84403520000	26427	13074	2	0	\N
198462	1397	1280224157000	26428	13074	0	0	\N
198463	2133	91009664000	26428	13074	1	0	\N
198464	2134	84403520000	26428	13074	2	0	\N
198465	1397	1280214156000	26429	13075	0	0	\N
198466	2133	91008662000	26429	13075	1	0	\N
198467	2132	147369382000	26429	13075	2	0	\N
198468	2134	84402517000	26429	13075	3	0	\N
198483	1397	1280194154000	26433	13077	0	0	\N
198484	1397	1280184153000	26433	13077	1	0	\N
198485	2134	84400511000	26433	13077	3	0	\N
198486	2134	84399508000	26433	13077	4	0	\N
198487	2133	91006658000	26433	13077	5	0	\N
198488	2132	147368381000	26433	13077	6	0	\N
198489	2133	91005656000	26433	13077	7	0	\N
198490	1397	1280194154000	26434	13077	0	0	\N
198491	1397	1280184153000	26434	13077	1	0	\N
198492	2134	84400511000	26434	13077	3	0	\N
198493	2134	84399508000	26434	13077	4	0	\N
198494	2133	91006658000	26434	13077	5	0	\N
198495	2132	147368381000	26434	13077	6	0	\N
198496	2133	91005656000	26434	13077	7	0	\N
198497	1397	1280194154000	26435	13077	0	0	\N
198498	1397	1280184153000	26435	13077	1	0	\N
198499	2134	84400511000	26435	13077	3	0	\N
198500	2134	84399508000	26435	13077	4	0	\N
198501	2133	91006658000	26435	13077	5	0	\N
198502	2132	147368381000	26435	13077	6	0	\N
198503	2133	91005656000	26435	13077	7	0	\N
198504	1397	1280174152000	26436	13078	0	0	\N
198505	1397	1280164151000	26436	13078	1	0	\N
198506	2133	91004654000	26436	13078	2	0	\N
198507	2133	91003652000	26436	13078	3	0	\N
198508	2134	84398505000	26436	13078	4	0	\N
198509	2134	84397502000	26436	13078	5	0	\N
198516	1397	1280154150000	26438	13079	0	0	\N
198517	2134	84396499000	26438	13079	1	0	\N
198518	2132	147367380000	26438	13079	2	0	\N
198519	2133	91002650000	26438	13079	3	0	\N
198524	1397	1280144149000	26440	13080	0	0	\N
198525	2133	91001648000	26440	13080	1	0	\N
198526	2134	84395496000	26440	13080	2	0	\N
198530	1397	1280134148000	26442	13081	0	0	\N
198531	1397	1280124147000	26442	13081	1	0	\N
198532	2133	91000646000	26442	13081	2	0	\N
198533	2133	90999644000	26442	13081	3	0	\N
198534	2134	84394493000	26442	13081	4	0	\N
198535	2134	84393490000	26442	13081	5	0	\N
198542	1397	1280134148000	26444	13081	0	0	\N
198543	1397	1280124147000	26444	13081	1	0	\N
198544	2133	91000646000	26444	13081	2	0	\N
198545	2133	90999644000	26444	13081	3	0	\N
198546	2134	84394493000	26444	13081	4	0	\N
198547	2134	84393490000	26444	13081	5	0	\N
198552	1397	1280114146000	26447	13082	0	0	\N
198553	2133	90998642000	26447	13082	1	0	\N
198554	2132	147366379000	26447	13082	2	0	\N
198555	2134	84392487000	26447	13082	3	0	\N
198556	1397	1280114146000	26448	13082	0	0	\N
198557	2133	90998642000	26448	13082	1	0	\N
198558	2132	147366379000	26448	13082	2	0	\N
198559	2134	84392487000	26448	13082	3	0	\N
198560	2132	147366379000	26449	13082	0	0	\N
198455	2133	91010666000	26425	13073	2	0	5669
198456	1397	1280224157000	26426	13074	0	0	15860
198457	2133	91009664000	26426	13074	1	0	5670
198458	2134	84403520000	26426	13074	2	0	6168
198469	1397	1280214156000	26430	13075	0	0	15861
198471	2132	147369382000	26430	13075	2	0	1619
198472	2134	84402517000	26430	13075	3	0	6169
198473	1397	1280204155000	26431	13076	0	0	15862
198474	2133	91007660000	26431	13076	1	0	5672
198475	2134	84401514000	26431	13076	2	0	6170
198477	1397	1280184153000	26432	13077	1	0	15864
198478	2134	84400511000	26432	13077	3	0	6171
198479	2134	84399508000	26432	13077	4	0	6172
198480	2133	91006658000	26432	13077	5	0	5673
198482	2133	91005656000	26432	13077	7	0	5674
198510	1397	1280174152000	26437	13078	0	0	15865
198511	1397	1280164151000	26437	13078	1	0	15866
198512	2133	91004654000	26437	13078	2	0	5675
198513	2133	91003652000	26437	13078	3	0	5676
198515	2134	84397502000	26437	13078	5	0	6174
198520	1397	1280154150000	26439	13079	0	0	15867
198521	2134	84396499000	26439	13079	1	0	6175
198522	2132	147367380000	26439	13079	2	0	1621
198523	2133	91002650000	26439	13079	3	0	5677
198528	2133	91001648000	26441	13080	1	0	5678
198529	2134	84395496000	26441	13080	2	0	6176
198536	1397	1280134148000	26443	13081	0	0	15869
198537	1397	1280124147000	26443	13081	1	0	15870
198539	2133	90999644000	26443	13081	3	0	5680
198540	2134	84394493000	26443	13081	4	0	6177
198541	2134	84393490000	26443	13081	5	0	6178
198548	1397	1280114146000	26446	13082	0	0	15871
198549	2133	90998642000	26446	13082	1	0	5681
198551	2134	84392487000	26446	13082	3	0	6179
198561	2134	84392487000	26449	13082	1	0	\N
198562	1397	1280104145000	26450	13083	0	0	\N
198563	2133	90997640000	26450	13083	1	0	\N
198564	2134	84391484000	26450	13083	2	0	\N
198568	1397	1280104145000	26452	13083	0	0	\N
198569	2133	90997640000	26452	13083	1	0	\N
198570	2134	84391484000	26452	13083	2	0	\N
198573	1397	1280084143000	26454	13085	0	0	\N
198574	2134	84389478000	26454	13085	1	0	\N
198575	2132	147365378000	26454	13085	2	0	\N
198576	2133	90996638000	26454	13085	3	0	\N
198577	1397	1280334168000	26455	13068	0	0	\N
198578	1397	1280324167000	26455	13068	1	0	\N
198579	1397	1280314166000	26455	13068	2	0	\N
198580	1397	1280304165000	26455	13068	3	0	\N
198581	1397	1280294164000	26455	13068	4	0	\N
198582	1397	1280284163000	26455	13068	5	0	\N
198583	1397	1280274162000	26455	13068	6	0	\N
198584	1397	1280264161000	26455	13068	7	0	\N
198585	1397	1280254160000	26455	13068	8	0	\N
198586	1397	1280244159000	26455	13068	9	0	\N
198587	1397	1280234158000	26455	13068	10	0	\N
198588	1397	1280224157000	26455	13068	11	0	\N
198589	1397	1280214156000	26455	13068	12	0	\N
198590	1397	1280204155000	26455	13068	13	0	\N
198591	1397	1280194154000	26455	13068	14	0	\N
198592	1397	1280184153000	26455	13068	15	0	\N
198593	1397	1280174152000	26455	13068	16	0	\N
198594	1397	1280164151000	26455	13068	17	0	\N
198595	1397	1280154150000	26455	13068	18	0	\N
198596	1397	1280144149000	26455	13068	19	0	\N
198597	1397	1280134148000	26455	13068	20	0	\N
198598	1397	1280124147000	26455	13068	21	0	\N
198599	1397	1280114146000	26455	13068	22	0	\N
198600	1397	1280104145000	26455	13068	23	0	\N
198601	1397	1280094144000	26455	13068	24	0	\N
198602	1397	1280084143000	26455	13068	25	0	\N
198603	2132	147372385000	26455	13068	26	0	\N
198604	2134	84413550000	26455	13068	27	0	\N
198605	1726	976977112000	26455	13068	28	0	\N
198606	1726	975876112000	26455	13068	29	0	\N
198607	1741	1439010000000	26455	13068	30	0	\N
198608	2132	147371384000	26455	13068	31	0	\N
198609	2132	147370383000	26455	13068	32	0	\N
198610	2132	147369382000	26455	13068	33	0	\N
198611	2132	147368381000	26455	13068	34	0	\N
198612	2132	147367380000	26455	13068	35	0	\N
198613	2132	147366379000	26455	13068	36	0	\N
198614	2132	147365378000	26455	13068	37	0	\N
198615	2134	84412547000	26455	13068	38	0	\N
198616	2134	84411544000	26455	13068	39	0	\N
198617	2134	84410541000	26455	13068	40	0	\N
198618	2134	84409538000	26455	13068	41	0	\N
198619	2134	84408535000	26455	13068	42	0	\N
198620	2134	84407532000	26455	13068	43	0	\N
198621	2134	84406529000	26455	13068	44	0	\N
198622	2134	84405526000	26455	13068	45	0	\N
198623	2134	84404523000	26455	13068	46	0	\N
198624	2134	84403520000	26455	13068	47	0	\N
198625	2134	84402517000	26455	13068	48	0	\N
198626	2134	84401514000	26455	13068	49	0	\N
198627	2134	84400511000	26455	13068	50	0	\N
198628	2134	84399508000	26455	13068	51	0	\N
198629	2134	84398505000	26455	13068	52	0	\N
198630	2134	84397502000	26455	13068	53	0	\N
198631	2134	84396499000	26455	13068	54	0	\N
198632	2134	84395496000	26455	13068	55	0	\N
198633	2134	84394493000	26455	13068	56	0	\N
198634	2134	84393490000	26455	13068	57	0	\N
198635	2134	84392487000	26455	13068	58	0	\N
198636	2134	84391484000	26455	13068	59	0	\N
198637	2134	84390481000	26455	13068	60	0	\N
198638	2134	84389478000	26455	13068	61	0	\N
198639	2133	91020686000	26455	13068	62	0	\N
198640	2133	91019684000	26455	13068	63	0	\N
198641	2133	91018682000	26455	13068	64	0	\N
198642	2133	91017680000	26455	13068	65	0	\N
198643	2133	91016678000	26455	13068	66	0	\N
198644	2133	91015676000	26455	13068	67	0	\N
198645	2133	91014674000	26455	13068	69	0	\N
198646	2133	91013672000	26455	13068	70	0	\N
198647	2133	91012670000	26455	13068	71	0	\N
198648	2133	91011668000	26455	13068	72	0	\N
198649	2133	91010666000	26455	13068	73	0	\N
198650	2133	91009664000	26455	13068	74	0	\N
198651	2133	91008662000	26455	13068	75	0	\N
198652	2133	91007660000	26455	13068	76	0	\N
198653	2133	91006658000	26455	13068	77	0	\N
198654	2133	91005656000	26455	13068	78	0	\N
198655	2133	91004654000	26455	13068	79	0	\N
198656	2133	91003652000	26455	13068	80	0	\N
198657	2133	91002650000	26455	13068	81	0	\N
198658	2133	91001648000	26455	13068	82	0	\N
198659	2133	91000646000	26455	13068	83	0	\N
198660	2133	90999644000	26455	13068	84	0	\N
198661	2133	90998642000	26455	13068	85	0	\N
198662	2133	90997640000	26455	13068	86	0	\N
198663	2133	90996638000	26455	13068	87	0	\N
198678	1397	1280424177000	26459	13060	0	0	\N
198679	1397	1280414176000	26459	13060	1	0	\N
198680	1397	1280404175000	26459	13060	2	0	\N
198681	1397	1280394174000	26459	13060	3	0	\N
198682	1397	1280384173000	26459	13060	4	0	\N
198683	1397	1280374172000	26459	13060	5	0	\N
198684	1397	1280364171000	26459	13060	6	0	\N
198685	1397	1280354170000	26459	13060	7	0	\N
198686	1397	1280344169000	26459	13060	8	0	\N
198687	1397	1280334168000	26459	13060	9	0	\N
198688	1397	1280324167000	26459	13060	10	0	\N
198689	1397	1280314166000	26459	13060	11	0	\N
198690	1397	1280304165000	26459	13060	12	0	\N
198691	1397	1280294164000	26459	13060	13	0	\N
198692	1397	1280284163000	26459	13060	14	0	\N
198693	1397	1280274162000	26459	13060	15	0	\N
198694	1397	1280264161000	26459	13060	16	0	\N
198695	1397	1280254160000	26459	13060	17	0	\N
198696	1397	1280244159000	26459	13060	18	0	\N
198567	2134	84391484000	26451	13083	2	0	6180
198571	1397	1280094144000	26453	13084	0	0	15873
198572	2134	84390481000	26453	13084	1	0	6181
198664	1397	1280084143000	26456	13085	0	0	15874
198665	2134	84389478000	26456	13085	1	0	6182
198667	2133	90996638000	26456	13085	3	0	5683
198668	1397	1280074142000	26457	13086	0	0	15875
198669	2133	90995636000	26457	13086	1	0	5684
198670	2134	84388475000	26457	13086	2	0	6183
198671	1397	1280064141000	26458	13087	0	0	15876
198673	2133	90994634000	26458	13087	2	0	5685
198674	2133	90993632000	26458	13087	3	0	5686
198675	2134	84387472000	26458	13087	4	0	6184
198676	2132	147364377000	26458	13087	5	0	1624
198697	1397	1280234158000	26459	13060	19	0	\N
198698	1397	1280224157000	26459	13060	20	0	\N
198699	1397	1280214156000	26459	13060	21	0	\N
198700	1397	1280204155000	26459	13060	22	0	\N
198701	1397	1280194154000	26459	13060	23	0	\N
198702	1397	1280184153000	26459	13060	24	0	\N
198703	1397	1280174152000	26459	13060	25	0	\N
198704	1397	1280164151000	26459	13060	26	0	\N
198705	1397	1280154150000	26459	13060	27	0	\N
198706	1397	1280144149000	26459	13060	28	0	\N
198707	1397	1280134148000	26459	13060	29	0	\N
198708	1397	1280124147000	26459	13060	30	0	\N
198709	1397	1280114146000	26459	13060	31	0	\N
198710	1397	1280104145000	26459	13060	32	0	\N
198711	1397	1280094144000	26459	13060	33	0	\N
198712	1397	1280084143000	26459	13060	34	0	\N
198713	1397	1280074142000	26459	13060	35	0	\N
198714	1397	1280064141000	26459	13060	36	0	\N
198715	1397	1280054140000	26459	13060	37	0	\N
198716	2134	84422577000	26459	13060	38	0	\N
198717	2133	91030706000	26459	13060	39	0	\N
198718	1726	976977112000	26459	13060	40	0	\N
198719	1726	975876112000	26459	13060	41	0	\N
198720	2134	84421574000	26459	13060	42	0	\N
198721	2134	84420571000	26459	13060	43	0	\N
198722	2134	84419568000	26459	13060	44	0	\N
198723	2134	84418565000	26459	13060	45	0	\N
198724	2134	84417562000	26459	13060	46	0	\N
198725	2134	84416559000	26459	13060	47	0	\N
198726	1741	1439010000000	26459	13060	48	0	\N
198727	2134	84415556000	26459	13060	49	0	\N
198728	2134	84414553000	26459	13060	50	0	\N
198729	2134	84413550000	26459	13060	51	0	\N
198730	2134	84412547000	26459	13060	52	0	\N
198731	2134	84411544000	26459	13060	53	0	\N
198732	2134	84410541000	26459	13060	54	0	\N
198733	2134	84409538000	26459	13060	55	0	\N
198734	2134	84408535000	26459	13060	56	0	\N
198735	2134	84407532000	26459	13060	57	0	\N
198736	2134	84406529000	26459	13060	58	0	\N
198737	2134	84405526000	26459	13060	59	0	\N
198738	2134	84404523000	26459	13060	60	0	\N
198739	2134	84403520000	26459	13060	61	0	\N
198740	2134	84402517000	26459	13060	62	0	\N
198741	2134	84401514000	26459	13060	63	0	\N
198742	2134	84400511000	26459	13060	64	0	\N
198743	2134	84399508000	26459	13060	65	0	\N
198744	2134	84398505000	26459	13060	66	0	\N
198745	2134	84397502000	26459	13060	67	0	\N
198746	2134	84396499000	26459	13060	68	0	\N
198747	2134	84395496000	26459	13060	69	0	\N
198748	2134	84394493000	26459	13060	70	0	\N
198749	2134	84393490000	26459	13060	71	0	\N
198750	2134	84392487000	26459	13060	72	0	\N
198751	2134	84391484000	26459	13060	73	0	\N
198752	2134	84390481000	26459	13060	74	0	\N
198753	2134	84389478000	26459	13060	75	0	\N
198754	2134	84388475000	26459	13060	76	0	\N
198755	2134	84387472000	26459	13060	77	0	\N
198756	2134	84386469000	26459	13060	78	0	\N
198757	2132	147375388000	26459	13060	79	0	\N
198758	2132	147374387000	26459	13060	80	0	\N
198759	2132	147373386000	26459	13060	81	0	\N
198760	2132	147372385000	26459	13060	82	0	\N
198761	2132	147371384000	26459	13060	83	0	\N
198762	2132	147370383000	26459	13060	84	0	\N
198763	2132	147369382000	26459	13060	85	0	\N
198764	2132	147368381000	26459	13060	86	0	\N
198765	2132	147367380000	26459	13060	87	0	\N
198766	2132	147366379000	26459	13060	88	0	\N
198767	2132	147365378000	26459	13060	89	0	\N
198768	2132	147364377000	26459	13060	90	0	\N
198769	2133	91029704000	26459	13060	91	0	\N
198770	2133	91028702000	26459	13060	92	0	\N
198771	2133	91027700000	26459	13060	93	0	\N
198772	2133	91026698000	26459	13060	94	0	\N
198773	2133	91025696000	26459	13060	95	0	\N
198774	2133	91024694000	26459	13060	96	0	\N
198775	2133	91023692000	26459	13060	97	0	\N
198776	2133	91022690000	26459	13060	98	0	\N
198777	2133	91021688000	26459	13060	99	0	\N
198778	2133	91020686000	26459	13060	100	0	\N
198779	2133	91019684000	26459	13060	101	0	\N
198780	2133	91018682000	26459	13060	102	0	\N
198781	2133	91017680000	26459	13060	103	0	\N
198782	2133	91016678000	26459	13060	104	0	\N
198783	2133	91015676000	26459	13060	105	0	\N
198784	2133	91014674000	26459	13060	106	0	\N
198785	2133	91013672000	26459	13060	107	0	\N
198786	2133	91012670000	26459	13060	108	0	\N
198787	2133	91011668000	26459	13060	109	0	\N
198788	2133	91010666000	26459	13060	110	0	\N
198789	2133	91009664000	26459	13060	111	0	\N
198790	2133	91008662000	26459	13060	112	0	\N
198791	2133	91007660000	26459	13060	113	0	\N
198792	2133	91006658000	26459	13060	114	0	\N
198793	2133	91005656000	26459	13060	116	0	\N
198794	2133	91004654000	26459	13060	117	0	\N
198804	1397	1280034138000	26463	13089	0	0	\N
198805	1397	1280024137000	26463	13089	1	0	\N
198806	2134	84384463000	26463	13089	2	0	\N
198807	2134	84383460000	26463	13089	3	0	\N
198808	2133	90991628000	26463	13089	4	0	\N
198809	2133	90990626000	26463	13089	5	0	\N
198816	1397	1280014136000	26466	13091	0	0	\N
198817	2134	84381454000	26466	13091	1	0	\N
198818	2133	90988622000	26466	13091	2	0	\N
198819	1397	1280354170000	26467	13066	0	0	\N
198820	1397	1280344169000	26467	13066	1	0	\N
198821	1397	1280334168000	26467	13066	2	0	\N
198822	1397	1280324167000	26467	13066	3	0	\N
198823	1397	1280314166000	26467	13066	4	0	\N
198824	1397	1280304165000	26467	13066	5	0	\N
198825	1397	1280294164000	26467	13066	6	0	\N
198826	1397	1280284163000	26467	13066	7	0	\N
198827	1397	1280274162000	26467	13066	8	0	\N
198828	1397	1280264161000	26467	13066	9	0	\N
198829	1397	1280254160000	26467	13066	10	0	\N
198830	1397	1280244159000	26467	13066	11	0	\N
198831	1397	1280234158000	26467	13066	12	0	\N
198832	1397	1280224157000	26467	13066	13	0	\N
198797	2134	84385466000	26460	13088	2	0	6186
198798	1397	1280034138000	26462	13089	0	0	15879
198799	1397	1280024137000	26462	13089	1	0	15880
198800	2134	84384463000	26462	13089	2	0	6187
198801	2134	84383460000	26462	13089	3	0	6188
198803	2133	90990626000	26462	13089	5	0	5689
198810	2134	84382457000	26464	13090	0	0	6189
198811	2132	147363376000	26464	13090	1	0	1625
198812	2133	90989624000	26464	13090	2	0	5690
198813	1397	1280014136000	26465	13091	0	0	15881
198815	2133	90988622000	26465	13091	2	0	5691
198833	1397	1280214156000	26467	13066	14	0	\N
198834	1397	1280204155000	26467	13066	15	0	\N
198835	1397	1280194154000	26467	13066	16	0	\N
198836	1397	1280184153000	26467	13066	17	0	\N
198837	1397	1280174152000	26467	13066	18	0	\N
198838	1397	1280164151000	26467	13066	19	0	\N
198839	1397	1280154150000	26467	13066	20	0	\N
198840	1397	1280144149000	26467	13066	21	0	\N
198841	1397	1280134148000	26467	13066	22	0	\N
198842	1397	1280124147000	26467	13066	23	0	\N
198843	1397	1280114146000	26467	13066	24	0	\N
198844	1397	1280104145000	26467	13066	25	0	\N
198845	1397	1280094144000	26467	13066	26	0	\N
198846	1397	1280084143000	26467	13066	27	0	\N
198847	1397	1280074142000	26467	13066	28	0	\N
198848	1397	1280064141000	26467	13066	29	0	\N
198849	1397	1280054140000	26467	13066	30	0	\N
198850	1397	1280044139000	26467	13066	31	0	\N
198851	1397	1280034138000	26467	13066	32	0	\N
198852	1397	1280024137000	26467	13066	33	0	\N
198853	1397	1280014136000	26467	13066	34	0	\N
198854	2132	147373386000	26467	13066	35	0	\N
198855	2132	147372385000	26467	13066	36	0	\N
198856	1726	976977112000	26467	13066	37	0	\N
198857	1726	975876112000	26467	13066	38	0	\N
198858	2133	91022690000	26467	13066	39	0	\N
198859	2133	91021688000	26467	13066	40	0	\N
198860	1741	1439010000000	26467	13066	41	0	\N
198861	2134	84415556000	26467	13066	42	0	\N
198862	2132	147371384000	26467	13066	43	0	\N
198863	2132	147370383000	26467	13066	44	0	\N
198864	2132	147369382000	26467	13066	45	0	\N
198865	2132	147368381000	26467	13066	46	0	\N
198866	2132	147367380000	26467	13066	47	0	\N
198867	2132	147366379000	26467	13066	48	0	\N
198868	2132	147365378000	26467	13066	49	0	\N
198869	2132	147364377000	26467	13066	50	0	\N
198870	2132	147363376000	26467	13066	51	0	\N
198871	2134	84414553000	26467	13066	52	0	\N
198872	2134	84413550000	26467	13066	53	0	\N
198873	2134	84412547000	26467	13066	54	0	\N
198874	2134	84411544000	26467	13066	55	0	\N
198875	2134	84410541000	26467	13066	56	0	\N
198876	2134	84409538000	26467	13066	57	0	\N
198877	2134	84408535000	26467	13066	58	0	\N
198878	2134	84407532000	26467	13066	59	0	\N
198879	2134	84406529000	26467	13066	60	0	\N
198880	2134	84405526000	26467	13066	61	0	\N
198881	2134	84404523000	26467	13066	62	0	\N
198882	2134	84403520000	26467	13066	63	0	\N
198883	2134	84402517000	26467	13066	64	0	\N
198884	2134	84401514000	26467	13066	65	0	\N
198885	2134	84400511000	26467	13066	66	0	\N
198886	2134	84399508000	26467	13066	67	0	\N
198887	2134	84398505000	26467	13066	68	0	\N
198888	2134	84397502000	26467	13066	69	0	\N
198889	2134	84396499000	26467	13066	70	0	\N
198890	2134	84395496000	26467	13066	71	0	\N
198891	2134	84394493000	26467	13066	72	0	\N
198892	2134	84393490000	26467	13066	73	0	\N
198893	2134	84392487000	26467	13066	74	0	\N
198894	2134	84391484000	26467	13066	75	0	\N
198895	2134	84390481000	26467	13066	76	0	\N
198896	2134	84389478000	26467	13066	77	0	\N
198897	2134	84388475000	26467	13066	78	0	\N
198898	2134	84387472000	26467	13066	80	0	\N
198899	2134	84386469000	26467	13066	81	0	\N
198900	2134	84385466000	26467	13066	82	0	\N
198901	2134	84384463000	26467	13066	83	0	\N
198902	2134	84383460000	26467	13066	84	0	\N
198903	2134	84382457000	26467	13066	85	0	\N
198904	2134	84381454000	26467	13066	86	0	\N
198905	2133	91020686000	26467	13066	87	0	\N
198906	2133	91019684000	26467	13066	88	0	\N
198907	2133	91018682000	26467	13066	89	0	\N
198908	2133	91017680000	26467	13066	90	0	\N
198909	2133	91016678000	26467	13066	91	0	\N
198910	2133	91015676000	26467	13066	92	0	\N
198911	2133	91014674000	26467	13066	93	0	\N
198912	2133	91013672000	26467	13066	94	0	\N
198913	2133	91012670000	26467	13066	95	0	\N
198914	2133	91011668000	26467	13066	96	0	\N
198915	2133	91010666000	26467	13066	97	0	\N
198916	2133	91009664000	26467	13066	98	0	\N
198917	2133	91008662000	26467	13066	99	0	\N
198918	2133	91007660000	26467	13066	100	0	\N
198919	2133	91006658000	26467	13066	101	0	\N
198920	2133	91005656000	26467	13066	102	0	\N
198921	2133	91004654000	26467	13066	103	0	\N
198922	2133	91003652000	26467	13066	104	0	\N
198923	2133	91002650000	26467	13066	105	0	\N
198924	2133	91001648000	26467	13066	106	0	\N
198925	2133	91000646000	26467	13066	107	0	\N
198926	2133	90999644000	26467	13066	108	0	\N
198927	2133	90998642000	26467	13066	109	0	\N
198928	2133	90997640000	26467	13066	110	0	\N
198929	2133	90996638000	26467	13066	111	0	\N
198930	2133	90995636000	26467	13066	112	0	\N
198931	2133	90994634000	26467	13066	113	0	\N
198932	2133	90993632000	26467	13066	114	0	\N
198933	2133	90992630000	26467	13066	115	0	\N
198934	2133	90991628000	26467	13066	116	0	\N
198935	2133	90990626000	26467	13066	117	0	\N
198936	2133	90989624000	26467	13066	118	0	\N
198937	2133	90988622000	26467	13066	119	0	\N
198938	1397	1280874222000	26468	13028	0	0	\N
198939	1397	1280864221000	26468	13028	1	0	\N
198940	1397	1280854220000	26468	13028	2	0	\N
198941	1397	1280844219000	26468	13028	3	0	\N
198942	1397	1280834218000	26468	13028	4	0	\N
198943	1397	1280824217000	26468	13028	5	0	\N
198944	1397	1280814216000	26468	13028	6	0	\N
198945	1397	1280804215000	26468	13028	7	0	\N
198946	1397	1280794214000	26468	13028	8	0	\N
198947	1397	1280784213000	26468	13028	9	0	\N
198948	1397	1280774212000	26468	13028	10	0	\N
198949	1397	1280764211000	26468	13028	11	0	\N
198950	1397	1280754210000	26468	13028	12	0	\N
198951	1397	1280744209000	26468	13028	13	0	\N
198952	1397	1280734208000	26468	13028	14	0	\N
198953	1397	1280724207000	26468	13028	15	0	\N
198954	1397	1280714206000	26468	13028	16	0	\N
198955	1397	1280704205000	26468	13028	17	0	\N
198956	1397	1280694204000	26468	13028	18	0	\N
198957	1397	1280684203000	26468	13028	19	0	\N
198958	1397	1280674202000	26468	13028	20	0	\N
198959	1397	1280664201000	26468	13028	21	0	\N
198960	1397	1280654200000	26468	13028	22	0	\N
198961	1397	1280644199000	26468	13028	23	0	\N
198962	1397	1280634198000	26468	13028	24	0	\N
198963	1397	1280624197000	26468	13028	25	0	\N
198964	1397	1280614196000	26468	13028	26	0	\N
198965	1397	1280604195000	26468	13028	27	0	\N
198966	1397	1280594194000	26468	13028	28	0	\N
198967	1397	1280584193000	26468	13028	29	0	\N
198968	1397	1280574192000	26468	13028	30	0	\N
198969	1397	1280564191000	26468	13028	31	0	\N
198970	1397	1280554190000	26468	13028	32	0	\N
198971	1397	1280544189000	26468	13028	33	0	\N
198972	1397	1280534188000	26468	13028	34	0	\N
198973	1397	1280524187000	26468	13028	35	0	\N
198974	1397	1280514186000	26468	13028	36	0	\N
198975	1397	1280504185000	26468	13028	37	0	\N
198976	1397	1280494184000	26468	13028	38	0	\N
198977	1397	1280484183000	26468	13028	39	0	\N
198978	1397	1280474182000	26468	13028	40	0	\N
198979	1397	1280464181000	26468	13028	41	0	\N
198980	1397	1280454180000	26468	13028	42	0	\N
198981	1397	1280444179000	26468	13028	43	0	\N
198982	1397	1280434178000	26468	13028	44	0	\N
198983	1397	1280424177000	26468	13028	45	0	\N
198984	1397	1280414176000	26468	13028	46	0	\N
198985	1397	1280404175000	26468	13028	47	0	\N
198986	1397	1280394174000	26468	13028	48	0	\N
198987	1397	1280384173000	26468	13028	49	0	\N
198988	1397	1280374172000	26468	13028	50	0	\N
198989	1397	1280364171000	26468	13028	51	0	\N
198990	1397	1280354170000	26468	13028	52	0	\N
198991	1397	1280344169000	26468	13028	53	0	\N
198992	1397	1280334168000	26468	13028	54	0	\N
198993	1397	1280324167000	26468	13028	55	0	\N
198994	1397	1280314166000	26468	13028	57	0	\N
198995	1397	1280304165000	26468	13028	58	0	\N
198996	1397	1280294164000	26468	13028	59	0	\N
198997	1397	1280284163000	26468	13028	60	0	\N
198998	1397	1280274162000	26468	13028	61	0	\N
198999	1397	1280264161000	26468	13028	62	0	\N
199000	1397	1280254160000	26468	13028	63	0	\N
199001	1397	1280244159000	26468	13028	64	0	\N
199002	1397	1280234158000	26468	13028	65	0	\N
199003	1397	1280224157000	26468	13028	66	0	\N
199004	1397	1280214156000	26468	13028	67	0	\N
199005	1397	1280204155000	26468	13028	68	0	\N
199006	1397	1280194154000	26468	13028	69	0	\N
199007	1397	1280184153000	26468	13028	70	0	\N
199008	1397	1280174152000	26468	13028	71	0	\N
199009	1397	1280164151000	26468	13028	72	0	\N
199010	1397	1280154150000	26468	13028	73	0	\N
199011	1397	1280144149000	26468	13028	74	0	\N
199012	1397	1280134148000	26468	13028	75	0	\N
199013	1397	1280124147000	26468	13028	76	0	\N
199014	1397	1280114146000	26468	13028	77	0	\N
199015	1397	1280104145000	26468	13028	78	0	\N
199016	1397	1280094144000	26468	13028	79	0	\N
199017	1397	1280084143000	26468	13028	80	0	\N
199018	1397	1280074142000	26468	13028	81	0	\N
199019	1397	1280064141000	26468	13028	82	0	\N
199020	1397	1280054140000	26468	13028	83	0	\N
199021	1397	1280044139000	26468	13028	84	0	\N
199022	1397	1280034138000	26468	13028	85	0	\N
199023	1397	1280024137000	26468	13028	86	0	\N
199024	1397	1280014136000	26468	13028	87	0	\N
199025	2133	91053752000	26468	13028	88	0	\N
199026	2132	147389402000	26468	13028	89	0	\N
199027	2132	147388401000	26468	13028	90	0	\N
199028	2134	84468715000	26468	13028	91	0	\N
199029	2134	84467712000	26468	13028	92	0	\N
199030	2134	84466709000	26468	13028	93	0	\N
199031	2134	84465706000	26468	13028	94	0	\N
199032	2134	84464703000	26468	13028	95	0	\N
199033	2134	84463700000	26468	13028	96	0	\N
199034	1741	1439021000000	26468	13028	97	0	\N
199035	2132	147387400000	26468	13028	98	0	\N
199036	2338	99000000	26468	13028	99	0	\N
199037	2134	84462697000	26468	13028	100	0	\N
199038	2134	84461694000	26468	13028	101	0	\N
199039	1741	1439010000000	26468	13028	102	0	\N
199040	2132	147386399000	26468	13028	103	0	\N
199041	2132	147385398000	26468	13028	104	0	\N
199042	2132	147384397000	26468	13028	105	0	\N
199043	2132	147383396000	26468	13028	106	0	\N
199044	2132	147382395000	26468	13028	107	0	\N
199045	2132	147381394000	26468	13028	108	0	\N
199046	2132	147380393000	26468	13028	109	0	\N
199047	1726	980280112000	26468	13028	110	0	\N
199048	1726	979179112000	26468	13028	111	0	\N
199049	1726	978078112000	26468	13028	112	0	\N
199050	1726	976977112000	26468	13028	113	0	\N
199051	1726	975876112000	26468	13028	114	0	\N
199052	2132	147379392000	26468	13028	115	0	\N
199053	2132	147378391000	26468	13028	116	0	\N
199054	2132	147377390000	26468	13028	117	0	\N
199055	2132	147376389000	26468	13028	118	0	\N
199056	2134	84460691000	26468	13028	119	0	\N
199057	2134	84459688000	26468	13028	120	0	\N
199058	2134	84458685000	26468	13028	121	0	\N
199059	2134	84457682000	26468	13028	122	0	\N
199060	2134	84456679000	26468	13028	123	0	\N
199061	2134	84455676000	26468	13028	124	0	\N
199062	2134	84454673000	26468	13028	125	0	\N
199071	1397	1280004135000	26470	13092	0	0	\N
199072	1397	1279994134000	26470	13092	1	0	\N
199073	2133	90987620000	26470	13092	2	0	\N
199074	418	66620012000000	26470	13092	3	0	\N
199075	2132	147362375000	26470	13092	4	0	\N
199076	2133	90986618000	26470	13092	5	0	\N
199077	2134	84380451000	26470	13092	6	0	\N
199078	2134	84379448000	26470	13092	7	0	\N
199082	1397	1279984133000	26472	13093	0	0	\N
199083	2134	84378445000	26472	13093	1	0	\N
199084	2133	90985616000	26472	13093	2	0	\N
199098	1397	1279954130000	26475	13095	0	0	\N
199099	1726	974775112000	26475	13095	1	0	\N
199100	418	66310011000000	26475	13095	2	0	\N
199101	2134	84375436000	26475	13095	3	0	\N
199102	1726	973674112000	26475	13095	4	0	\N
199103	2133	90982610000	26475	13095	5	0	\N
199104	1397	1279954130000	26476	13095	0	0	\N
199065	2133	90987620000	26469	13092	2	0	5692
199066	418	66620012000000	26469	13092	3	0	1
199067	2132	147362375000	26469	13092	4	0	1626
199068	2133	90986618000	26469	13092	5	0	5693
199069	2134	84380451000	26469	13092	6	0	6191
199079	1397	1279984133000	26471	13093	0	0	15884
199080	2134	84378445000	26471	13093	1	0	6193
199081	2133	90985616000	26471	13093	2	0	5694
199085	1397	1279974132000	26473	13094	0	0	15885
199086	1397	1279964131000	26473	13094	1	0	15886
199088	2134	84377442000	26473	13094	3	0	6194
199089	2133	90983612000	26473	13094	4	0	5696
199090	2134	84376439000	26473	13094	5	0	6195
199091	2132	147361374000	26473	13094	6	0	1627
199093	1726	974775112000	26474	13095	1	0	8310
199094	418	66310011000000	26474	13095	2	0	2
199095	2134	84375436000	26474	13095	3	0	6196
199096	1726	973674112000	26474	13095	4	0	8311
199097	2133	90982610000	26474	13095	5	0	5697
199105	1726	974775112000	26476	13095	1	0	\N
199106	418	66310011000000	26476	13095	2	0	\N
199107	2134	84375436000	26476	13095	3	0	\N
199108	1726	973674112000	26476	13095	4	0	\N
199109	2133	90982610000	26476	13095	5	0	\N
199118	1397	1279934128000	26479	13097	0	0	\N
199119	2134	84373430000	26479	13097	1	0	\N
199120	2352	99000000	26479	13097	2	0	\N
199121	2133	90980606000	26479	13097	3	0	\N
199127	1397	1279924127000	26481	13098	0	0	\N
199128	2132	147360373000	26481	13098	1	0	\N
199129	418	66000010000000	26481	13098	2	0	\N
199130	2134	84372427000	26481	13098	3	0	\N
199131	2133	90979604000	26481	13098	4	0	\N
199132	1397	1279914126000	26482	13099	0	0	\N
199133	2133	90978602000	26482	13099	1	0	\N
199134	2134	84371424000	26482	13099	2	0	\N
199135	1397	1279914126000	26483	13099	0	0	\N
199136	2133	90978602000	26483	13099	1	0	\N
199137	2134	84371424000	26483	13099	2	0	\N
199138	1397	1279914126000	26484	13099	0	0	\N
199139	2133	90978602000	26484	13099	1	0	\N
199140	2134	84371424000	26484	13099	2	0	\N
199154	1397	1279874122000	26489	13103	0	0	\N
199155	1397	1279864121000	26489	13103	1	0	\N
199156	2132	147358371000	26489	13103	2	0	\N
199157	2134	84367412000	26489	13103	3	0	\N
199158	2134	84366409000	26489	13103	4	0	\N
199159	2133	90974594000	26489	13103	5	0	\N
199160	2133	90973592000	26489	13103	6	0	\N
199174	1397	1279844119000	26493	13105	0	0	\N
199175	2134	84364403000	26493	13105	1	0	\N
199176	2133	90971588000	26493	13105	2	0	\N
199177	1397	1280364171000	26494	13060	0	0	\N
199178	1397	1280354170000	26494	13060	1	0	\N
199179	1397	1280344169000	26494	13060	2	0	\N
199180	1397	1280334168000	26494	13060	3	0	\N
199181	1397	1280324167000	26494	13060	4	0	\N
199182	1397	1280314166000	26494	13060	5	0	\N
199183	1397	1280304165000	26494	13060	6	0	\N
199184	1397	1280294164000	26494	13060	7	0	\N
199185	1397	1280284163000	26494	13060	8	0	\N
199186	1397	1280274162000	26494	13060	9	0	\N
199187	1397	1280264161000	26494	13060	10	0	\N
199188	1397	1280254160000	26494	13060	11	0	\N
199189	1397	1280244159000	26494	13060	12	0	\N
199190	1397	1280234158000	26494	13060	13	0	\N
199191	1397	1280224157000	26494	13060	14	0	\N
199192	1397	1280214156000	26494	13060	15	0	\N
199193	1397	1280204155000	26494	13060	16	0	\N
199194	1397	1280194154000	26494	13060	17	0	\N
199195	1397	1280184153000	26494	13060	18	0	\N
199196	1397	1280174152000	26494	13060	19	0	\N
199197	1397	1280164151000	26494	13060	20	0	\N
199198	1397	1280154150000	26494	13060	21	0	\N
199199	1397	1280144149000	26494	13060	22	0	\N
199200	1397	1280134148000	26494	13060	23	0	\N
199201	1397	1280124147000	26494	13060	24	0	\N
199202	1397	1280114146000	26494	13060	25	0	\N
199203	1397	1280104145000	26494	13060	26	0	\N
199204	1397	1280094144000	26494	13060	27	0	\N
199205	1397	1280084143000	26494	13060	28	0	\N
199206	1397	1280074142000	26494	13060	29	0	\N
199207	1397	1280064141000	26494	13060	30	0	\N
199208	1397	1280054140000	26494	13060	31	0	\N
199209	1397	1280044139000	26494	13060	32	0	\N
199210	1397	1280034138000	26494	13060	33	0	\N
199211	1397	1280024137000	26494	13060	34	0	\N
199212	1397	1280014136000	26494	13060	35	0	\N
199213	1397	1280004135000	26494	13060	36	0	\N
199214	1397	1279994134000	26494	13060	37	0	\N
199215	1397	1279984133000	26494	13060	38	0	\N
199216	1397	1279974132000	26494	13060	39	0	\N
199217	1397	1279964131000	26494	13060	40	0	\N
199218	1397	1279954130000	26494	13060	41	0	\N
199219	1397	1279944129000	26494	13060	42	0	\N
199220	1397	1279934128000	26494	13060	43	0	\N
199221	1397	1279924127000	26494	13060	44	0	\N
199222	1397	1279914126000	26494	13060	45	0	\N
199223	1397	1279904125000	26494	13060	46	0	\N
199224	1397	1279894124000	26494	13060	47	0	\N
199225	1397	1279884123000	26494	13060	48	0	\N
199226	1397	1279874122000	26494	13060	49	0	\N
199227	1397	1279864121000	26494	13060	50	0	\N
199228	1397	1279854120000	26494	13060	51	0	\N
199229	1397	1279844119000	26494	13060	52	0	\N
199230	1397	1279834118000	26494	13060	53	0	\N
199231	1397	1279824117000	26494	13060	54	0	\N
199232	2134	84417562000	26494	13060	55	0	\N
199233	2134	84416559000	26494	13060	56	0	\N
199234	2132	147373386000	26494	13060	57	0	\N
199235	2132	147372385000	26494	13060	58	0	\N
199236	1726	976977112000	26494	13060	59	0	\N
199237	1726	975876112000	26494	13060	60	0	\N
199238	1726	974775112000	26494	13060	61	0	\N
199239	1726	973674112000	26494	13060	62	0	\N
199240	1726	972573112000	26494	13060	63	0	\N
199112	1726	972573112000	26477	13096	2	0	8312
199113	2133	90981608000	26477	13096	4	0	5698
199114	1397	1279934128000	26478	13097	0	0	15889
199115	2134	84373430000	26478	13097	1	0	6198
199116	2352	99000000	26478	13097	2	0	1
199122	1397	1279924127000	26480	13098	0	0	15890
199123	2132	147360373000	26480	13098	1	0	1628
199124	418	66000010000000	26480	13098	2	0	3
199125	2134	84372427000	26480	13098	3	0	6199
199126	2133	90979604000	26480	13098	4	0	5700
199142	2133	90978602000	26485	13099	1	0	5701
199143	2134	84371424000	26485	13099	2	0	6200
199144	1397	1279904125000	26486	13100	0	0	15892
199145	2134	84370421000	26486	13100	1	0	6201
199147	1397	1279894124000	26487	13101	0	0	15893
199148	2133	90976598000	26487	13101	1	0	5703
199149	2132	147359372000	26487	13101	2	0	1629
199150	2134	84369418000	26487	13101	3	0	6202
199151	1397	1279884123000	26488	13102	0	0	15894
199153	2134	84368415000	26488	13102	2	0	6203
199161	1397	1279874122000	26490	13103	0	0	15895
199162	1397	1279864121000	26490	13103	1	0	15896
199163	2132	147358371000	26490	13103	2	0	1630
199164	2134	84367412000	26490	13103	3	0	6204
199166	2133	90974594000	26490	13103	5	0	5705
199167	2133	90973592000	26490	13103	6	0	5706
199168	1397	1279854120000	26491	13104	0	0	15897
199169	2133	90972590000	26491	13104	1	0	5707
199171	1397	1279844119000	26492	13105	0	0	15898
199172	2134	84364403000	26492	13105	1	0	6207
199173	2133	90971588000	26492	13105	2	0	5708
199241	2133	91024694000	26494	13060	64	0	\N
199242	2133	91023692000	26494	13060	65	0	\N
199243	2133	91022690000	26494	13060	66	0	\N
199244	2133	91021688000	26494	13060	67	0	\N
199245	1741	1439010000000	26494	13060	68	0	\N
199246	2134	84415556000	26494	13060	69	0	\N
199247	2132	147371384000	26494	13060	70	0	\N
199248	2132	147370383000	26494	13060	71	0	\N
199249	2132	147369382000	26494	13060	72	0	\N
199250	2132	147368381000	26494	13060	73	0	\N
199251	2132	147367380000	26494	13060	74	0	\N
199252	2132	147366379000	26494	13060	75	0	\N
199253	2132	147365378000	26494	13060	76	0	\N
199254	2132	147364377000	26494	13060	77	0	\N
199255	2132	147363376000	26494	13060	78	0	\N
199256	2132	147362375000	26494	13060	79	0	\N
199257	2132	147361374000	26494	13060	80	0	\N
199258	2132	147360373000	26494	13060	81	0	\N
199259	2132	147359372000	26494	13060	82	0	\N
199260	2132	147358371000	26494	13060	83	0	\N
199261	2132	147357370000	26494	13060	84	0	\N
199262	2134	84414553000	26494	13060	85	0	\N
199263	2134	84413550000	26494	13060	86	0	\N
199264	2134	84412547000	26494	13060	87	0	\N
199265	2134	84411544000	26494	13060	88	0	\N
199266	2134	84410541000	26494	13060	89	0	\N
199267	2134	84409538000	26494	13060	90	0	\N
199268	2134	84408535000	26494	13060	91	0	\N
199269	2134	84407532000	26494	13060	92	0	\N
199270	2134	84406529000	26494	13060	93	0	\N
199271	2134	84405526000	26494	13060	94	0	\N
199272	2134	84404523000	26494	13060	95	0	\N
199273	2134	84403520000	26494	13060	97	0	\N
199274	2134	84402517000	26494	13060	98	0	\N
199275	2134	84401514000	26494	13060	99	0	\N
199276	2134	84400511000	26494	13060	100	0	\N
199277	2134	84399508000	26494	13060	101	0	\N
199278	2134	84398505000	26494	13060	102	0	\N
199279	2134	84397502000	26494	13060	103	0	\N
199280	2134	84396499000	26494	13060	104	0	\N
199281	2134	84395496000	26494	13060	105	0	\N
199282	2134	84394493000	26494	13060	106	0	\N
199283	2134	84393490000	26494	13060	107	0	\N
199284	2134	84392487000	26494	13060	108	0	\N
199285	2134	84391484000	26494	13060	109	0	\N
199286	2134	84390481000	26494	13060	110	0	\N
199287	2134	84389478000	26494	13060	111	0	\N
199288	2134	84388475000	26494	13060	112	0	\N
199289	2134	84387472000	26494	13060	113	0	\N
199290	2134	84386469000	26494	13060	114	0	\N
199291	2134	84385466000	26494	13060	115	0	\N
199292	2134	84384463000	26494	13060	116	0	\N
199293	2134	84383460000	26494	13060	117	0	\N
199294	2134	84382457000	26494	13060	118	0	\N
199295	2134	84381454000	26494	13060	119	0	\N
199296	2134	84380451000	26494	13060	120	0	\N
199297	2134	84379448000	26494	13060	121	0	\N
199298	2134	84378445000	26494	13060	122	0	\N
199299	2134	84377442000	26494	13060	123	0	\N
199300	2134	84376439000	26494	13060	124	0	\N
199301	2134	84375436000	26494	13060	125	0	\N
199312	1397	1279804115000	26496	13107	0	0	\N
199313	2133	90967580000	26496	13107	1	0	\N
199314	2134	84360391000	26496	13107	2	0	\N
199318	2134	84360391000	26498	13107	0	0	\N
199336	1397	1279764111000	26502	13110	0	0	\N
199337	1397	1279754110000	26502	13110	1	0	\N
199338	2132	147355368000	26502	13110	2	0	\N
199339	2134	84356379000	26502	13110	3	0	\N
199340	2134	84355376000	26502	13110	4	0	\N
199341	2133	90963572000	26502	13110	5	0	\N
199342	2133	90962570000	26502	13110	6	0	\N
199346	1397	1279734108000	26504	13112	0	0	\N
199347	2133	90960566000	26504	13112	1	0	\N
199348	2134	84353370000	26504	13112	2	0	\N
199362	1397	1279814116000	26509	13061	0	0	\N
199363	1397	1279804115000	26509	13061	1	0	\N
199364	1397	1279794114000	26509	13061	2	0	\N
199365	1397	1279784113000	26509	13061	3	0	\N
199366	1397	1279774112000	26509	13061	4	0	\N
199367	1397	1279764111000	26509	13061	5	0	\N
199368	1397	1279754110000	26509	13061	6	0	\N
199369	1397	1279744109000	26509	13061	7	0	\N
199370	1397	1279734108000	26509	13061	8	0	\N
199371	1397	1279724107000	26509	13061	9	0	\N
199372	1397	1279714106000	26509	13061	10	0	\N
199373	1397	1279704105000	26509	13061	11	0	\N
199374	2134	84374433000	26509	13061	12	0	\N
199375	2134	84373430000	26509	13061	13	0	\N
199376	2134	84372427000	26509	13061	14	0	\N
199304	1397	1279814116000	26495	13106	2	0	15901
199305	2132	147357370000	26495	13106	3	0	1631
199306	2134	84363400000	26495	13106	4	0	6208
199307	2134	84362397000	26495	13106	5	0	6209
199308	2134	84361394000	26495	13106	6	0	6210
199310	2133	90969584000	26495	13106	8	0	5710
199311	2133	90968582000	26495	13106	9	0	5711
199315	1397	1279804115000	26497	13107	0	0	15902
199316	2133	90967580000	26497	13107	1	0	5712
199317	2134	84360391000	26497	13107	2	0	6211
199320	1397	1279784113000	26499	13108	1	0	15904
199321	2134	84359388000	26499	13108	2	0	6212
199322	2134	84358385000	26499	13108	3	0	6213
199323	2133	90966578000	26499	13108	4	0	5713
199325	2132	147356369000	26499	13108	6	0	1632
199326	1397	1279774112000	26500	13109	0	0	15905
199327	2134	84357382000	26500	13109	1	0	6214
199328	2133	90964574000	26500	13109	2	0	5715
199329	1397	1279764111000	26501	13110	0	0	15906
199331	2132	147355368000	26501	13110	2	0	1633
199332	2134	84356379000	26501	13110	3	0	6215
199333	2134	84355376000	26501	13110	4	0	6216
199334	2133	90963572000	26501	13110	5	0	5716
199335	2133	90962570000	26501	13110	6	0	5717
199344	2134	84354373000	26503	13111	1	0	6217
199345	2133	90961568000	26503	13111	2	0	5718
199349	1397	1279734108000	26505	13112	0	0	15909
199350	2133	90960566000	26505	13112	1	0	5719
199352	1397	1279724107000	26506	13113	0	0	15910
199353	2132	147354367000	26506	13113	1	0	1634
199354	2133	90959564000	26506	13113	2	0	5720
199355	2134	84352367000	26506	13113	3	0	6219
199356	1397	1279714106000	26507	13114	0	0	15911
199358	2134	84351364000	26507	13114	2	0	6220
199359	1397	1279704105000	26508	13115	0	0	15912
199360	2133	90957560000	26508	13115	1	0	5722
199361	2134	84350361000	26508	13115	2	0	6221
199377	2134	84371424000	26509	13061	15	0	\N
199378	2134	84370421000	26509	13061	16	0	\N
199379	2132	147356369000	26509	13061	17	0	\N
199380	2132	147355368000	26509	13061	18	0	\N
199381	2132	147354367000	26509	13061	19	0	\N
199382	2134	84369418000	26509	13061	20	0	\N
199383	2134	84368415000	26509	13061	21	0	\N
199384	2134	84367412000	26509	13061	22	0	\N
199385	2134	84366409000	26509	13061	23	0	\N
199386	2134	84365406000	26509	13061	24	0	\N
199387	2134	84364403000	26509	13061	25	0	\N
199388	2134	84363400000	26509	13061	26	0	\N
199389	2134	84362397000	26509	13061	27	0	\N
199390	2134	84361394000	26509	13061	28	0	\N
199391	2134	84360391000	26509	13061	29	0	\N
199392	2134	84359388000	26509	13061	30	0	\N
199393	2134	84358385000	26509	13061	31	0	\N
199394	2134	84357382000	26509	13061	32	0	\N
199395	2134	84356379000	26509	13061	33	0	\N
199396	2134	84355376000	26509	13061	34	0	\N
199397	2134	84354373000	26509	13061	35	0	\N
199398	2134	84353370000	26509	13061	36	0	\N
199399	2134	84352367000	26509	13061	37	0	\N
199400	2134	84351364000	26509	13061	38	0	\N
199401	2134	84350361000	26509	13061	39	0	\N
199402	2133	91020686000	26509	13061	40	0	\N
199403	2133	91019684000	26509	13061	41	0	\N
199404	2133	91018682000	26509	13061	42	0	\N
199405	2133	91017680000	26509	13061	43	0	\N
199406	2133	91016678000	26509	13061	44	0	\N
199407	2133	91015676000	26509	13061	45	0	\N
199408	2133	91014674000	26509	13061	46	0	\N
199409	2133	91013672000	26509	13061	47	0	\N
199410	2133	91012670000	26509	13061	48	0	\N
199411	2133	91011668000	26509	13061	49	0	\N
199412	2133	91010666000	26509	13061	50	0	\N
199413	2133	91009664000	26509	13061	51	0	\N
199414	2133	91008662000	26509	13061	52	0	\N
199415	2133	91007660000	26509	13061	53	0	\N
199416	2133	91006658000	26509	13061	54	0	\N
199417	2133	91005656000	26509	13061	55	0	\N
199418	2133	91004654000	26509	13061	56	0	\N
199419	2133	91003652000	26509	13061	57	0	\N
199420	2133	91002650000	26509	13061	58	0	\N
199421	2133	91001648000	26509	13061	59	0	\N
199422	2133	91000646000	26509	13061	60	0	\N
199423	2133	90999644000	26509	13061	61	0	\N
199424	2133	90998642000	26509	13061	62	0	\N
199425	2133	90997640000	26509	13061	63	0	\N
199426	2133	90996638000	26509	13061	64	0	\N
199427	2133	90995636000	26509	13061	65	0	\N
199428	2133	90994634000	26509	13061	66	0	\N
199429	2133	90993632000	26509	13061	67	0	\N
199430	2133	90992630000	26509	13061	68	0	\N
199431	2133	90991628000	26509	13061	69	0	\N
199432	2133	90990626000	26509	13061	70	0	\N
199433	2133	90989624000	26509	13061	71	0	\N
199434	2133	90988622000	26509	13061	72	0	\N
199435	2133	90987620000	26509	13061	73	0	\N
199436	2133	90986618000	26509	13061	74	0	\N
199437	2133	90985616000	26509	13061	75	0	\N
199438	2133	90984614000	26509	13061	76	0	\N
199439	2133	90983612000	26509	13061	77	0	\N
199440	2133	90982610000	26509	13061	78	0	\N
199441	2133	90981608000	26509	13061	79	0	\N
199442	2133	90980606000	26509	13061	80	0	\N
199443	2133	90979604000	26509	13061	81	0	\N
199444	2133	90978602000	26509	13061	82	0	\N
199445	2133	90977600000	26509	13061	83	0	\N
199446	2133	90976598000	26509	13061	84	0	\N
199447	2133	90975596000	26509	13061	85	0	\N
199448	2133	90974594000	26509	13061	86	0	\N
199449	2133	90973592000	26509	13061	87	0	\N
199450	2133	90972590000	26509	13061	88	0	\N
199451	2133	90971588000	26509	13061	89	0	\N
199452	2133	90970586000	26509	13061	90	0	\N
199453	2133	90969584000	26509	13061	91	0	\N
199454	2133	90968582000	26509	13061	92	0	\N
199455	2133	90967580000	26509	13061	93	0	\N
199456	2133	90966578000	26509	13061	94	0	\N
199457	2133	90965576000	26509	13061	95	0	\N
199458	2133	90964574000	26509	13061	97	0	\N
199459	2133	90963572000	26509	13061	98	0	\N
199460	2133	90962570000	26509	13061	99	0	\N
199461	2133	90961568000	26509	13061	100	0	\N
199462	2133	90960566000	26509	13061	101	0	\N
199463	2133	90959564000	26509	13061	102	0	\N
199464	2133	90958562000	26509	13061	103	0	\N
199465	2133	90957560000	26509	13061	104	0	\N
199466	1397	1279694104000	26510	13116	0	0	\N
199467	1397	1279684103000	26510	13116	1	0	\N
199468	1397	1279674102000	26510	13116	2	0	\N
199469	2134	84349358000	26510	13116	3	0	\N
199470	2133	90956558000	26510	13116	4	0	\N
199471	2133	90955556000	26510	13116	6	0	\N
199472	2132	147353366000	26510	13116	7	0	\N
199473	2134	84348355000	26510	13116	8	0	\N
199474	2134	84347352000	26510	13116	9	0	\N
199475	2133	90954554000	26510	13116	10	0	\N
199486	1397	1279664101000	26512	13117	0	0	\N
199487	2133	90953552000	26512	13117	1	0	\N
199488	2132	147352365000	26512	13117	2	0	\N
199489	2134	84346349000	26512	13117	3	0	\N
199500	1397	1279644099000	26515	13118	0	0	\N
199501	2134	84344343000	26515	13118	1	0	\N
199502	2133	90951548000	26515	13118	2	0	\N
199503	1397	1279634098000	26516	13119	0	0	\N
199504	2134	84343340000	26516	13119	1	0	\N
199505	2133	90950546000	26516	13119	2	0	\N
199506	1397	1279634098000	26517	13119	0	0	\N
199507	2134	84343340000	26517	13119	1	0	\N
199508	2133	90950546000	26517	13119	2	0	\N
199478	1397	1279674102000	26511	13116	2	0	15915
199479	2134	84349358000	26511	13116	3	0	6222
199480	2133	90956558000	26511	13116	4	0	5723
199481	2133	90955556000	26511	13116	6	0	5724
199482	2132	147353366000	26511	13116	7	0	1635
199484	2134	84347352000	26511	13116	9	0	6224
199485	2133	90954554000	26511	13116	10	0	5725
199490	1397	1279664101000	26513	13117	0	0	15916
199491	1397	1279654100000	26513	13117	1	0	15917
199492	2133	90953552000	26513	13117	2	0	5726
199494	2133	90952550000	26513	13117	4	0	5727
199495	2134	84346349000	26513	13117	5	0	6225
199496	2134	84345346000	26513	13117	6	0	6226
199497	1397	1279644099000	26514	13118	0	0	15918
199499	2133	90951548000	26514	13118	2	0	5728
199509	1397	1279634098000	26518	13119	0	0	15919
199510	2134	84343340000	26518	13119	1	0	6228
199511	2133	90950546000	26518	13119	2	0	5729
199512	1397	1279624097000	26519	13120	0	0	15920
199519	1397	1279614096000	26521	13121	0	0	\N
199520	2133	90948542000	26521	13121	1	0	\N
199521	1397	1279614096000	26522	13121	0	0	\N
199522	2134	84341334000	26522	13121	1	0	\N
199523	2133	90948542000	26522	13121	2	0	\N
199524	1397	1279614096000	26523	13121	0	0	\N
199525	2134	84341334000	26523	13121	1	0	\N
199526	2133	90948542000	26523	13121	2	0	\N
199527	1397	1279614096000	26524	13121	0	0	\N
199528	2134	84341334000	26524	13121	1	0	\N
199529	2133	90948542000	26524	13121	2	0	\N
199530	1397	1279614096000	26525	13121	0	0	\N
199531	2134	84341334000	26525	13121	1	0	\N
199532	2133	90948542000	26525	13121	2	0	\N
199543	1397	1279584093000	26529	13124	0	0	\N
199544	2134	84338325000	26529	13124	1	0	\N
199545	2133	90945536000	26529	13124	2	0	\N
199562	1397	1279554090000	26534	13127	0	0	\N
199563	1397	1279544089000	26534	13127	1	0	\N
199564	1397	1279534088000	26534	13127	2	0	\N
199565	2134	84335316000	26534	13127	3	0	\N
199566	2134	84334313000	26534	13127	4	0	\N
199567	2134	84333310000	26534	13127	5	0	\N
199568	2133	90942530000	26534	13127	6	0	\N
199569	2133	90941528000	26534	13127	7	0	\N
199570	2133	90940526000	26534	13127	8	0	\N
199571	1397	1279554090000	26535	13127	0	0	\N
199572	1397	1279544089000	26535	13127	1	0	\N
199573	1397	1279534088000	26535	13127	2	0	\N
199574	2134	84335316000	26535	13127	3	0	\N
199575	2134	84334313000	26535	13127	4	0	\N
199576	2134	84333310000	26535	13127	5	0	\N
199577	2133	90942530000	26535	13127	6	0	\N
199578	2133	90941528000	26535	13127	7	0	\N
199579	2133	90940526000	26535	13127	8	0	\N
199580	1397	1279554090000	26536	13127	0	0	\N
199581	1397	1279544089000	26536	13127	1	0	\N
199582	1397	1279534088000	26536	13127	2	0	\N
199583	2134	84335316000	26536	13127	3	0	\N
199584	2134	84334313000	26536	13127	4	0	\N
199585	2134	84333310000	26536	13127	5	0	\N
199586	2133	90942530000	26536	13127	6	0	\N
199587	2133	90941528000	26536	13127	7	0	\N
199588	2133	90940526000	26536	13127	8	0	\N
199589	1397	1279524087000	26537	13128	0	0	\N
199590	1397	1279514086000	26537	13128	1	0	\N
199591	2132	147348361000	26537	13128	2	0	\N
199592	2134	84332307000	26537	13128	3	0	\N
199593	2134	84331304000	26537	13128	4	0	\N
199614	1397	1279474082000	26541	13131	0	0	\N
199615	1397	1279464081000	26541	13131	1	0	\N
199616	2133	90934514000	26541	13131	2	0	\N
199617	2134	84327292000	26541	13131	3	0	\N
199618	2133	90933512000	26541	13131	4	0	\N
199619	2134	84326289000	26541	13131	5	0	\N
199620	2132	147346359000	26541	13131	6	0	\N
199628	2134	84325286000	26543	13132	0	0	\N
199629	2133	90932510000	26543	13132	1	0	\N
199632	2134	84325286000	26545	13132	0	0	\N
199633	2133	90932510000	26545	13132	1	0	\N
199647	1397	1279424077000	26548	13134	0	0	\N
199648	2134	84321274000	26548	13134	2	0	\N
199515	2134	84342337000	26519	13120	3	0	6229
199516	1397	1279614096000	26520	13121	0	0	15921
199517	2134	84341334000	26520	13121	1	0	6230
199518	2133	90948542000	26520	13121	2	0	5731
199533	1397	1279604095000	26526	13122	0	0	15922
199535	2133	90947540000	26526	13122	2	0	5732
199536	1397	1279594094000	26527	13123	0	0	15923
199537	2132	147350363000	26527	13123	1	0	1638
199538	2133	90946538000	26527	13123	2	0	5733
199539	2134	84339328000	26527	13123	3	0	6232
199541	2134	84338325000	26528	13124	1	0	6233
199542	2133	90945536000	26528	13124	2	0	5734
199546	1397	1279574092000	26530	13125	0	0	15925
199547	2133	90944534000	26530	13125	1	0	5735
199549	1397	1279564091000	26531	13126	0	0	15926
199550	2133	90943532000	26531	13126	1	0	5736
199551	2134	84336319000	26531	13126	2	0	6235
199552	2132	147349362000	26531	13126	3	0	1639
199553	1397	1279554090000	26533	13127	0	0	15927
199555	1397	1279534088000	26533	13127	2	0	15929
199556	2134	84335316000	26533	13127	3	0	6236
199557	2134	84334313000	26533	13127	4	0	6237
199558	2134	84333310000	26533	13127	5	0	6238
199559	2133	90942530000	26533	13127	6	0	5737
199561	2133	90940526000	26533	13127	8	0	5739
199594	1397	1279524087000	26538	13128	0	0	15930
199595	1397	1279514086000	26538	13128	1	0	15931
199596	2132	147348361000	26538	13128	2	0	1640
199598	2133	90938522000	26538	13128	4	0	5741
199599	2134	84332307000	26538	13128	5	0	6239
199600	2134	84331304000	26538	13128	6	0	6240
199601	1397	1279504085000	26539	13129	0	0	15932
199602	2133	90937520000	26539	13129	1	0	5742
199604	2351	99000000	26539	13129	3	0	1
199605	1397	1279494084000	26540	13130	0	0	15933
199606	1397	1279484083000	26540	13130	1	0	15934
199607	2134	84329298000	26540	13130	2	0	6242
199608	2134	84328295000	26540	13130	3	0	6243
199610	2133	90936518000	26540	13130	5	0	5743
199611	2133	90935516000	26540	13130	6	0	5744
199612	2351	97000000	26540	13130	7	0	3
199613	2132	147347360000	26540	13130	8	0	1641
199622	1397	1279464081000	26542	13131	1	0	15936
199623	2133	90934514000	26542	13131	2	0	5745
199624	2134	84327292000	26542	13131	3	0	6244
199625	2133	90933512000	26542	13131	4	0	5746
199626	2134	84326289000	26542	13131	5	0	6245
199630	2134	84325286000	26544	13132	0	0	6246
199631	2133	90932510000	26544	13132	1	0	5747
199634	1397	1279454080000	26546	13133	0	0	15937
199635	1397	1279444079000	26546	13133	1	0	15938
199636	1397	1279434078000	26546	13133	2	0	15939
199638	2132	147345358000	26546	13133	4	0	1643
199639	2134	84324283000	26546	13133	5	0	6247
199640	2134	84323280000	26546	13133	6	0	6248
199641	2134	84322277000	26546	13133	7	0	6249
199643	2133	90929504000	26546	13133	9	0	5750
199644	1397	1279424077000	26547	13134	0	0	15940
199645	2134	84321274000	26547	13134	2	0	6250
199646	2133	90928502000	26547	13134	3	0	5751
199649	2133	90928502000	26548	13134	3	0	\N
199656	1397	1279394074000	26551	13137	0	0	\N
199657	2134	84319268000	26551	13137	1	0	\N
199658	2133	90925496000	26551	13137	2	0	\N
199675	1397	1279344069000	26555	13140	0	0	\N
199676	2133	90920486000	26555	13140	1	0	\N
199677	2134	84314253000	26555	13140	2	0	\N
199681	1397	1279344069000	26557	13140	0	0	\N
199682	2133	90920486000	26557	13140	1	0	\N
199683	2134	84314253000	26557	13140	2	0	\N
199688	1397	1279334068000	26559	13141	0	0	\N
199689	2132	147342355000	26559	13141	1	0	\N
199690	2134	84313250000	26559	13141	2	0	\N
199691	2133	90919484000	26559	13141	3	0	\N
199692	1397	1279334068000	26560	13141	0	0	\N
199693	2132	147342355000	26560	13141	1	0	\N
199694	2134	84313250000	26560	13141	2	0	\N
199695	2133	90919484000	26560	13141	3	0	\N
199702	1397	1279314066000	26563	13143	0	0	\N
199703	2134	84311244000	26563	13143	1	0	\N
199704	2133	90917480000	26563	13143	2	0	\N
199705	1397	1280074142000	26564	13069	0	0	\N
199706	1397	1280064141000	26564	13069	1	0	\N
199707	1397	1280054140000	26564	13069	2	0	\N
199708	1397	1280044139000	26564	13069	3	0	\N
199709	1397	1280034138000	26564	13069	4	0	\N
199710	1397	1280024137000	26564	13069	5	0	\N
199711	1397	1280014136000	26564	13069	6	0	\N
199712	1397	1280004135000	26564	13069	7	0	\N
199713	1397	1279994134000	26564	13069	8	0	\N
199714	1397	1279984133000	26564	13069	9	0	\N
199715	1397	1279974132000	26564	13069	10	0	\N
199716	1397	1279964131000	26564	13069	11	0	\N
199717	1397	1279954130000	26564	13069	12	0	\N
199718	1397	1279944129000	26564	13069	13	0	\N
199719	1397	1279934128000	26564	13069	14	0	\N
199720	1397	1279924127000	26564	13069	15	0	\N
199721	1397	1279914126000	26564	13069	16	0	\N
199722	1397	1279904125000	26564	13069	17	0	\N
199723	1397	1279894124000	26564	13069	18	0	\N
199724	1397	1279884123000	26564	13069	19	0	\N
199725	1397	1279874122000	26564	13069	20	0	\N
199726	1397	1279864121000	26564	13069	21	0	\N
199727	1397	1279854120000	26564	13069	22	0	\N
199728	1397	1279844119000	26564	13069	23	0	\N
199729	1397	1279834118000	26564	13069	24	0	\N
199730	1397	1279824117000	26564	13069	25	0	\N
199731	1397	1279814116000	26564	13069	26	0	\N
199732	1397	1279804115000	26564	13069	27	0	\N
199733	1397	1279794114000	26564	13069	28	0	\N
199734	1397	1279784113000	26564	13069	29	0	\N
199735	1397	1279774112000	26564	13069	30	0	\N
199736	1397	1279764111000	26564	13069	31	0	\N
199737	1397	1279754110000	26564	13069	32	0	\N
199738	1397	1279744109000	26564	13069	33	0	\N
199739	1397	1279734108000	26564	13069	34	0	\N
199740	1397	1279724107000	26564	13069	35	0	\N
199741	1397	1279714106000	26564	13069	36	0	\N
199742	1397	1279704105000	26564	13069	37	0	\N
199743	1397	1279694104000	26564	13069	38	0	\N
199744	1397	1279684103000	26564	13069	39	0	\N
199745	1397	1279674102000	26564	13069	40	0	\N
199746	1397	1279664101000	26564	13069	41	0	\N
199747	1397	1279654100000	26564	13069	42	0	\N
199748	1397	1279644099000	26564	13069	43	0	\N
199749	1397	1279634098000	26564	13069	44	0	\N
199750	1397	1279624097000	26564	13069	45	0	\N
199751	1397	1279614096000	26564	13069	46	0	\N
199752	1397	1279604095000	26564	13069	47	0	\N
199753	1397	1279594094000	26564	13069	48	0	\N
199754	1397	1279584093000	26564	13069	49	0	\N
199755	1397	1279574092000	26564	13069	50	0	\N
199756	1397	1279564091000	26564	13069	51	0	\N
199757	1397	1279554090000	26564	13069	52	0	\N
199758	1397	1279544089000	26564	13069	53	0	\N
199759	1397	1279534088000	26564	13069	54	0	\N
199760	1397	1279524087000	26564	13069	55	0	\N
199761	1397	1279514086000	26564	13069	56	0	\N
199762	1397	1279504085000	26564	13069	57	0	\N
199763	1397	1279494084000	26564	13069	58	0	\N
199764	1397	1279484083000	26564	13069	59	0	\N
199765	1397	1279474082000	26564	13069	60	0	\N
199766	1397	1279464081000	26564	13069	61	0	\N
199767	1397	1279454080000	26564	13069	62	0	\N
199768	1397	1279444079000	26564	13069	63	0	\N
199769	1397	1279434078000	26564	13069	64	0	\N
199770	1397	1279424077000	26564	13069	65	0	\N
199771	1397	1279414076000	26564	13069	66	0	\N
199772	1397	1279404075000	26564	13069	67	0	\N
199773	1397	1279394074000	26564	13069	68	0	\N
199774	1397	1279384073000	26564	13069	69	0	\N
199775	1397	1279374072000	26564	13069	70	0	\N
199776	1397	1279364071000	26564	13069	71	0	\N
199777	1397	1279354070000	26564	13069	72	0	\N
199778	1397	1279344069000	26564	13069	73	0	\N
199779	1397	1279334068000	26564	13069	74	0	\N
199780	1397	1279324067000	26564	13069	75	0	\N
199781	1726	974775112000	26564	13069	76	0	\N
199782	1726	973674112000	26564	13069	77	0	\N
199783	1726	972573112000	26564	13069	78	0	\N
199784	2133	90995636000	26564	13069	79	0	\N
199652	1397	1279404075000	26550	13136	0	0	15942
199653	2132	147344357000	26550	13136	1	0	1644
199654	2134	84320271000	26550	13136	2	0	6251
199655	2133	90926498000	26550	13136	3	0	5753
199659	1397	1279394074000	26552	13137	0	0	15943
199661	2133	90925496000	26552	13137	2	0	5754
199662	1397	1279384073000	26553	13138	0	0	15944
199663	1397	1279374072000	26553	13138	1	0	15945
199664	2133	90924494000	26553	13138	2	0	5755
199665	2134	84318265000	26553	13138	3	0	6253
199667	2133	90923492000	26553	13138	5	0	5756
199668	2132	147343356000	26553	13138	6	0	1645
199669	1397	1279364071000	26554	13139	0	0	15946
199670	1397	1279354070000	26554	13139	1	0	15947
199672	2134	84315256000	26554	13139	3	0	6256
199673	2133	90922490000	26554	13139	4	0	5757
199674	2133	90921488000	26554	13139	5	0	5758
199678	1397	1279344069000	26556	13140	0	0	15948
199679	2133	90920486000	26556	13140	1	0	5759
199684	1397	1279334068000	26558	13141	0	0	15949
199685	2132	147342355000	26558	13141	1	0	1646
199686	2134	84313250000	26558	13141	2	0	6258
199687	2133	90919484000	26558	13141	3	0	5760
199696	1397	1279324067000	26561	13142	0	0	15950
199698	2133	90918482000	26561	13142	2	0	5761
199699	1397	1279314066000	26562	13143	0	0	15951
199700	2134	84311244000	26562	13143	1	0	6260
199701	2133	90917480000	26562	13143	2	0	5762
199785	2133	90994634000	26564	13069	80	0	\N
199786	2133	90993632000	26564	13069	81	0	\N
199787	2133	90992630000	26564	13069	82	0	\N
199788	2132	147364377000	26564	13069	83	0	\N
199789	2132	147363376000	26564	13069	84	0	\N
199790	2132	147362375000	26564	13069	85	0	\N
199791	2132	147361374000	26564	13069	86	0	\N
199792	2132	147360373000	26564	13069	87	0	\N
199793	2132	147359372000	26564	13069	88	0	\N
199794	2132	147358371000	26564	13069	89	0	\N
199795	2132	147357370000	26564	13069	90	0	\N
199796	2132	147356369000	26564	13069	91	0	\N
199797	2132	147355368000	26564	13069	92	0	\N
199798	2132	147354367000	26564	13069	93	0	\N
199799	2132	147353366000	26564	13069	94	0	\N
199800	2132	147352365000	26564	13069	95	0	\N
199801	2132	147351364000	26564	13069	96	0	\N
199802	2132	147350363000	26564	13069	97	0	\N
199803	2132	147349362000	26564	13069	98	0	\N
199804	2132	147348361000	26564	13069	99	0	\N
199805	2132	147347360000	26564	13069	100	0	\N
199806	2133	90991628000	26564	13069	101	0	\N
199807	2133	90990626000	26564	13069	102	0	\N
199808	2133	90989624000	26564	13069	103	0	\N
199809	2133	90988622000	26564	13069	104	0	\N
199810	2133	90987620000	26564	13069	105	0	\N
199811	2133	90986618000	26564	13069	107	0	\N
199812	2133	90985616000	26564	13069	108	0	\N
199813	2133	90984614000	26564	13069	109	0	\N
199814	2133	90983612000	26564	13069	110	0	\N
199815	2133	90982610000	26564	13069	111	0	\N
199816	2133	90981608000	26564	13069	112	0	\N
199817	2133	90980606000	26564	13069	113	0	\N
199818	2133	90979604000	26564	13069	114	0	\N
199819	2133	90978602000	26564	13069	115	0	\N
199820	2133	90977600000	26564	13069	116	0	\N
199821	2133	90976598000	26564	13069	117	0	\N
199822	2133	90975596000	26564	13069	118	0	\N
199823	2133	90974594000	26564	13069	119	0	\N
199824	2133	90973592000	26564	13069	120	0	\N
199825	2133	90972590000	26564	13069	121	0	\N
199826	2133	90971588000	26564	13069	122	0	\N
199827	2133	90970586000	26564	13069	123	0	\N
199828	2133	90969584000	26564	13069	124	0	\N
199829	2133	90968582000	26564	13069	125	0	\N
199840	1397	1279284063000	26568	13146	0	0	\N
199841	2134	84308235000	26568	13146	1	0	\N
199842	2133	90914474000	26568	13146	2	0	\N
199843	1397	1279284063000	26569	13146	0	0	\N
199844	2134	84308235000	26569	13146	1	0	\N
199845	2133	90914474000	26569	13146	2	0	\N
199846	1397	1279274062000	26570	13147	0	0	\N
199847	1397	1279264061000	26570	13147	1	0	\N
199848	2132	147340353000	26570	13147	2	0	\N
199849	2134	84307232000	26570	13147	3	0	\N
199850	2133	90913472000	26570	13147	4	0	\N
199851	2133	90912470000	26570	13147	5	0	\N
199852	2134	84306229000	26570	13147	6	0	\N
199860	1397	1279254060000	26572	13148	0	0	\N
199861	2338	8000000	26572	13148	1	0	\N
199862	2133	90911468000	26572	13148	2	0	\N
199863	2134	84305226000	26572	13148	3	0	\N
199883	1397	1279234058000	26577	13150	0	0	\N
199884	1397	1279224057000	26577	13150	1	0	\N
199885	1397	1279214056000	26577	13150	2	0	\N
199886	2335	0	26577	13150	3	0	\N
199887	2337	0	26577	13150	4	0	\N
199888	2134	84303220000	26577	13150	5	0	\N
199889	2134	84302217000	26577	13150	6	0	\N
199890	2134	84301214000	26577	13150	7	0	\N
199891	2132	147339352000	26577	13150	8	0	\N
199892	2133	90909464000	26577	13150	9	0	\N
199893	2133	90908462000	26577	13150	10	0	\N
199894	2133	90907460000	26577	13150	11	0	\N
199905	2338	8000000	26580	13078	0	0	\N
199906	1726	974775112000	26580	13078	1	0	\N
199907	2335	0	26580	13078	2	0	\N
199908	1726	973674112000	26580	13078	3	0	\N
199909	1726	972573112000	26580	13078	4	0	\N
199910	2337	0	26580	13078	5	0	\N
199911	1397	1279174052000	26581	13153	0	0	\N
199912	1397	1279164051000	26581	13153	1	0	\N
199913	2134	84297202000	26581	13153	2	0	\N
199914	2132	147337350000	26581	13153	3	0	\N
199915	2134	84296199000	26581	13153	4	0	\N
199916	2133	90903452000	26581	13153	5	0	\N
199917	2133	90902450000	26581	13153	7	0	\N
199918	1397	1279174052000	26582	13153	0	0	\N
199919	1397	1279164051000	26582	13153	1	0	\N
199920	2134	84297202000	26582	13153	2	0	\N
199832	2132	147341354000	26565	13144	2	0	1647
199833	1397	1279294064000	26566	13145	0	0	15953
199834	2134	84310241000	26566	13145	1	0	6261
199835	2133	90915476000	26566	13145	2	0	5764
199836	2134	84309238000	26566	13145	3	0	6262
199838	2134	84308235000	26567	13146	1	0	6263
199839	2133	90914474000	26567	13146	2	0	5765
199853	1397	1279274062000	26571	13147	0	0	15955
199854	1397	1279264061000	26571	13147	1	0	15956
199855	2132	147340353000	26571	13147	2	0	1648
199857	2133	90913472000	26571	13147	4	0	5766
199858	2133	90912470000	26571	13147	5	0	5767
199859	2134	84306229000	26571	13147	6	0	6265
199864	1397	1279254060000	26573	13148	0	0	15957
199866	2133	90911468000	26573	13148	2	0	5768
199867	2134	84305226000	26573	13148	3	0	6266
199868	1397	1279244059000	26575	13149	0	0	15958
199869	2134	84304223000	26575	13149	1	0	6267
199870	2133	90910466000	26575	13149	2	0	5769
199872	1397	1279224057000	26576	13150	1	0	15960
199873	1397	1279214056000	26576	13150	2	0	15961
199874	2335	0	26576	13150	3	0	1
199875	2337	0	26576	13150	4	0	1
199876	2134	84303220000	26576	13150	5	0	6268
199878	2134	84301214000	26576	13150	7	0	6270
199879	2132	147339352000	26576	13150	8	0	1649
199880	2133	90909464000	26576	13150	9	0	5770
199881	2133	90908462000	26576	13150	10	0	5771
199895	1397	1279204055000	26578	13151	0	0	15962
199896	2132	147338351000	26578	13151	1	0	1650
199897	2133	90906458000	26578	13151	2	0	5773
199898	2134	84300211000	26578	13151	3	0	6271
199899	1397	1279194054000	26579	13152	0	0	15963
199901	2134	84299208000	26579	13152	2	0	6272
199902	2134	84298205000	26579	13152	3	0	6273
199903	2133	90905456000	26579	13152	4	0	5774
199904	2133	90904454000	26579	13152	5	0	5775
199921	2132	147337350000	26582	13153	3	0	\N
199922	2134	84296199000	26582	13153	4	0	\N
199923	2133	90903452000	26582	13153	5	0	\N
199924	2133	90902450000	26582	13153	7	0	\N
199925	1397	1279174052000	26583	13153	0	0	\N
199926	1397	1279164051000	26583	13153	1	0	\N
199927	2134	84297202000	26583	13153	2	0	\N
199928	2132	147337350000	26583	13153	3	0	\N
199929	2134	84296199000	26583	13153	4	0	\N
199930	2133	90903452000	26583	13153	5	0	\N
199931	2133	90902450000	26583	13153	7	0	\N
199939	1397	1279174052000	26585	13153	0	0	\N
199940	1397	1279164051000	26585	13153	1	0	\N
199941	2134	84297202000	26585	13153	2	0	\N
199942	2132	147337350000	26585	13153	3	0	\N
199943	2134	84296199000	26585	13153	4	0	\N
199944	2133	90903452000	26585	13153	5	0	\N
199945	2133	90902450000	26585	13153	7	0	\N
199946	1397	1279174052000	26586	13153	0	0	\N
199947	1397	1279164051000	26586	13153	1	0	\N
199948	2134	84297202000	26586	13153	2	0	\N
199949	2132	147337350000	26586	13153	3	0	\N
199950	2134	84296199000	26586	13153	4	0	\N
199951	2133	90903452000	26586	13153	5	0	\N
199952	2133	90902450000	26586	13153	7	0	\N
199953	1397	1279154050000	26587	13154	0	0	\N
199954	1397	1279144049000	26587	13154	1	0	\N
199955	2133	90901448000	26587	13154	2	0	\N
199956	2133	90900446000	26587	13154	3	0	\N
199957	2134	84295196000	26587	13154	4	0	\N
199958	2134	84294193000	26587	13154	5	0	\N
199965	1397	1279154050000	26589	13154	0	0	\N
199966	1397	1279144049000	26589	13154	1	0	\N
199967	2133	90901448000	26589	13154	2	0	\N
199968	2133	90900446000	26589	13154	3	0	\N
199969	2134	84295196000	26589	13154	4	0	\N
199970	2134	84294193000	26589	13154	5	0	\N
199985	1397	1279094044000	26593	13158	0	0	\N
199986	1397	1279084043000	26593	13158	1	0	\N
199987	2134	84289178000	26593	13158	2	0	\N
199988	2134	84288175000	26593	13158	3	0	\N
199989	1397	1279094044000	26594	13158	0	0	\N
199990	1397	1279084043000	26594	13158	1	0	\N
199991	2133	90895436000	26594	13158	2	0	\N
199992	2134	84289178000	26594	13158	3	0	\N
199993	2134	84288175000	26594	13158	4	0	\N
199994	2133	90894434000	26594	13158	5	0	\N
200001	1397	1279094044000	26596	13158	0	0	\N
200002	1397	1279084043000	26596	13158	1	0	\N
200003	2133	90895436000	26596	13158	2	0	\N
200004	2134	84289178000	26596	13158	3	0	\N
200005	2134	84288175000	26596	13158	4	0	\N
200006	2133	90894434000	26596	13158	5	0	\N
200007	1397	1279094044000	26597	13158	0	0	\N
200008	1397	1279084043000	26597	13158	1	0	\N
200009	2133	90895436000	26597	13158	2	0	\N
200010	2134	84289178000	26597	13158	3	0	\N
200011	2134	84288175000	26597	13158	4	0	\N
200012	2133	90894434000	26597	13158	5	0	\N
200013	1397	1279094044000	26598	13158	0	0	\N
200014	1397	1279084043000	26598	13158	1	0	\N
200015	2133	90895436000	26598	13158	2	0	\N
200016	2134	84289178000	26598	13158	3	0	\N
200017	2134	84288175000	26598	13158	4	0	\N
200018	2133	90894434000	26598	13158	5	0	\N
200023	1397	1279074042000	26600	13159	0	0	\N
200024	2134	84287172000	26600	13159	1	0	\N
200025	2132	147334347000	26600	13159	2	0	\N
200026	2133	90893432000	26600	13159	3	0	\N
200032	1397	1279064041000	26602	13160	0	0	\N
200033	2133	90892430000	26602	13160	1	0	\N
200034	2133	90891428000	26602	13160	2	0	\N
200035	2134	84286169000	26602	13160	3	0	\N
200036	2134	84285166000	26602	13160	4	0	\N
200050	1397	1279014036000	26605	13163	0	0	\N
200051	2133	90886418000	26605	13163	1	0	\N
200052	2132	147332345000	26605	13163	2	0	\N
200053	2134	84280151000	26605	13163	3	0	\N
199934	2134	84297202000	26584	13153	2	0	6274
199935	2132	147337350000	26584	13153	3	0	1651
199936	2134	84296199000	26584	13153	4	0	6275
199937	2133	90903452000	26584	13153	5	0	5776
199938	2133	90902450000	26584	13153	7	0	5777
199960	1397	1279144049000	26588	13154	1	0	15968
199961	2133	90901448000	26588	13154	2	0	5778
199962	2133	90900446000	26588	13154	3	0	5779
199963	2134	84295196000	26588	13154	4	0	6276
199964	2134	84294193000	26588	13154	5	0	6277
199972	2133	90899444000	26590	13155	1	0	5780
199973	2132	147336349000	26590	13155	2	0	1652
199974	2134	84293190000	26590	13155	3	0	6278
199975	1397	1279124047000	26591	13156	0	0	15970
199977	2133	90898442000	26591	13156	2	0	5781
199978	2133	90897440000	26591	13156	3	0	5782
199979	2134	84292187000	26591	13156	4	0	6279
199980	2134	84291184000	26591	13156	5	0	6280
199981	1397	1279104045000	26592	13157	0	0	15972
199983	2132	147335348000	26592	13157	2	0	1653
199984	2133	90896438000	26592	13157	3	0	5783
199995	1397	1279094044000	26595	13158	0	0	15973
199996	1397	1279084043000	26595	13158	1	0	15974
199997	2133	90895436000	26595	13158	2	0	5784
199999	2134	84288175000	26595	13158	4	0	6283
200000	2133	90894434000	26595	13158	5	0	5785
200019	1397	1279074042000	26599	13159	0	0	15975
200020	2134	84287172000	26599	13159	1	0	6284
200022	2133	90893432000	26599	13159	3	0	5786
200027	1397	1279064041000	26601	13160	0	0	15976
200028	2133	90892430000	26601	13160	1	0	5787
200029	2133	90891428000	26601	13160	2	0	5788
200030	2134	84286169000	26601	13160	3	0	6285
200037	1397	1279054040000	26603	13161	0	0	15977
200038	2134	84284163000	26603	13161	1	0	6287
200039	2133	90890426000	26603	13161	2	0	5789
200040	1397	1279044039000	26604	13162	0	0	15978
200041	1397	1279034038000	26604	13162	1	0	15979
200043	2134	84283160000	26604	13162	3	0	6288
200044	2134	84282157000	26604	13162	4	0	6289
200045	2132	147333346000	26604	13162	5	0	1655
200046	2134	84281154000	26604	13162	6	0	6290
200048	2133	90888422000	26604	13162	8	0	5791
200049	2133	90887420000	26604	13162	9	0	5792
200054	1397	1279014036000	26606	13163	0	0	15981
200055	2132	147332345000	26606	13163	1	0	1656
200056	2134	84280151000	26606	13163	2	0	6291
200060	1397	1278994034000	26608	13165	0	0	\N
200061	2134	84279148000	26608	13165	1	0	\N
200062	2133	90884414000	26608	13165	2	0	\N
200063	1397	1278994034000	26609	13165	0	0	\N
200064	2134	84279148000	26609	13165	1	0	\N
200065	2133	90884414000	26609	13165	2	0	\N
200066	1397	1278994034000	26610	13165	0	0	\N
200067	2134	84279148000	26610	13165	1	0	\N
200068	2133	90884414000	26610	13165	2	0	\N
200080	1397	1278974032000	26614	13168	0	0	\N
200081	2132	147330343000	26614	13168	1	0	\N
200082	2133	90880406000	26614	13168	2	0	\N
200083	2133	90879404000	26614	13168	3	0	\N
200084	2133	90878402000	26614	13168	4	0	\N
200085	2134	84275136000	26614	13168	5	0	\N
200086	2134	84274133000	26614	13168	6	0	\N
200087	2134	84273130000	26614	13168	7	0	\N
200088	1397	1278974032000	26615	13168	0	0	\N
200089	2132	147330343000	26615	13168	1	0	\N
200090	2133	90880406000	26615	13168	2	0	\N
200091	2133	90879404000	26615	13168	3	0	\N
200092	2133	90878402000	26615	13168	4	0	\N
200093	2134	84275136000	26615	13168	5	0	\N
200094	2134	84274133000	26615	13168	6	0	\N
200095	2134	84273130000	26615	13168	7	0	\N
200096	1397	1278974032000	26616	13168	0	0	\N
200097	2132	147330343000	26616	13168	1	0	\N
200098	2133	90880406000	26616	13168	2	0	\N
200099	2133	90879404000	26616	13168	3	0	\N
200100	2133	90878402000	26616	13168	4	0	\N
200101	2134	84275136000	26616	13168	5	0	\N
200102	2134	84274133000	26616	13168	6	0	\N
200103	2134	84273130000	26616	13168	7	0	\N
200112	1397	1278974032000	26618	13168	0	0	\N
200113	2132	147330343000	26618	13168	1	0	\N
200114	2133	90880406000	26618	13168	2	0	\N
200115	2133	90879404000	26618	13168	3	0	\N
200116	2133	90878402000	26618	13168	4	0	\N
200117	2134	84275136000	26618	13168	5	0	\N
200118	2134	84274133000	26618	13168	6	0	\N
200119	2134	84273130000	26618	13168	7	0	\N
200120	1397	1278974032000	26619	13168	0	0	\N
200121	2132	147330343000	26619	13168	1	0	\N
200122	2133	90880406000	26619	13168	2	0	\N
200123	2133	90879404000	26619	13168	3	0	\N
200124	2133	90878402000	26619	13168	4	0	\N
200125	2134	84275136000	26619	13168	5	0	\N
200126	2134	84274133000	26619	13168	6	0	\N
200127	2134	84273130000	26619	13168	7	0	\N
200128	1397	1278964031000	26620	13169	0	0	\N
200129	1397	1278954030000	26620	13169	1	0	\N
200130	1397	1278944029000	26620	13169	2	0	\N
200131	1397	1278934028000	26620	13169	3	0	\N
200132	1397	1278924027000	26620	13169	4	0	\N
200133	2132	147329342000	26620	13169	5	0	\N
200134	1726	971472112000	26620	13169	6	0	\N
200135	2132	147328341000	26620	13169	7	0	\N
200136	2134	84272127000	26620	13169	8	0	\N
200137	2134	84271124000	26620	13169	9	0	\N
200138	2134	84270121000	26620	13169	10	0	\N
200139	2134	84269118000	26620	13169	11	0	\N
200140	1726	970371112000	26620	13169	12	0	\N
200141	1726	969270112000	26620	13169	13	0	\N
200142	1726	968169112000	26620	13169	14	0	\N
200143	1726	967068112000	26620	13169	15	0	\N
200144	2134	84268115000	26620	13169	16	0	\N
200145	2133	90877400000	26620	13169	17	0	\N
200146	2133	90876398000	26620	13169	18	0	\N
200147	2133	90875396000	26620	13169	19	0	\N
200148	2133	90874394000	26620	13169	20	0	\N
200149	2133	90873392000	26620	13169	22	0	\N
200150	1397	1278964031000	26621	13169	0	0	\N
200151	1397	1278954030000	26621	13169	1	0	\N
200152	1397	1278944029000	26621	13169	2	0	\N
200153	1397	1278934028000	26621	13169	3	0	\N
200154	1397	1278924027000	26621	13169	4	0	\N
200155	2132	147329342000	26621	13169	5	0	\N
200156	1726	971472112000	26621	13169	6	0	\N
200157	2132	147328341000	26621	13169	7	0	\N
200158	2134	84272127000	26621	13169	8	0	\N
200159	2134	84271124000	26621	13169	9	0	\N
200160	2134	84270121000	26621	13169	10	0	\N
200161	2134	84269118000	26621	13169	11	0	\N
200162	1726	970371112000	26621	13169	12	0	\N
200163	1726	969270112000	26621	13169	13	0	\N
200164	1726	968169112000	26621	13169	14	0	\N
200165	1726	967068112000	26621	13169	15	0	\N
200166	2134	84268115000	26621	13169	16	0	\N
200167	2133	90877400000	26621	13169	17	0	\N
200168	2133	90876398000	26621	13169	18	0	\N
200169	2133	90875396000	26621	13169	19	0	\N
200170	2133	90874394000	26621	13169	20	0	\N
200171	2133	90873392000	26621	13169	22	0	\N
200059	2133	90885416000	26607	13164	2	0	5794
200069	1397	1278994034000	26611	13165	0	0	15983
200070	2134	84279148000	26611	13165	1	0	6292
200071	2133	90884414000	26611	13165	2	0	5795
200072	1397	1278984033000	26612	13166	0	0	15984
200074	2134	84278145000	26612	13166	2	0	6293
200075	2134	84277142000	26612	13166	3	0	6294
200076	2133	90883412000	26612	13166	4	0	5796
200077	2133	90882410000	26612	13166	5	0	5797
200078	2133	90881408000	26613	13167	0	0	5798
200104	1397	1278974032000	26617	13168	0	0	15985
200105	2132	147330343000	26617	13168	1	0	1658
200106	2133	90880406000	26617	13168	2	0	5799
200107	2133	90879404000	26617	13168	3	0	5800
200109	2134	84275136000	26617	13168	5	0	6296
200110	2134	84274133000	26617	13168	6	0	6297
200111	2134	84273130000	26617	13168	7	0	6298
200172	1397	1278964031000	26622	13169	0	0	15986
200173	1397	1278954030000	26622	13169	1	0	15987
200175	1397	1278934028000	26622	13169	3	0	15989
200176	1397	1278924027000	26622	13169	4	0	15990
200177	2132	147329342000	26622	13169	5	0	1659
200178	1726	971472112000	26622	13169	6	0	8313
200179	2132	147328341000	26622	13169	7	0	1660
200181	2134	84271124000	26622	13169	9	0	6300
200182	2134	84270121000	26622	13169	10	0	6301
200183	2134	84269118000	26622	13169	11	0	6302
200184	1726	970371112000	26622	13169	12	0	8314
200186	1726	968169112000	26622	13169	14	0	8316
200187	1726	967068112000	26622	13169	15	0	8317
200188	2134	84268115000	26622	13169	16	0	6303
200189	2133	90877400000	26622	13169	17	0	5802
200190	2133	90876398000	26622	13169	18	0	5803
200192	2133	90874394000	26622	13169	20	0	5805
200194	1397	1278914026000	26623	13170	0	0	\N
200195	2133	90872390000	26623	13170	1	0	\N
200196	2134	84267112000	26623	13170	2	0	\N
200213	1397	1278884023000	26628	13173	0	0	\N
200214	1397	1278874022000	26628	13173	1	0	\N
200215	2134	84264103000	26628	13173	2	0	\N
200216	2134	84263100000	26628	13173	3	0	\N
200217	2133	90869384000	26628	13173	4	0	\N
200218	2133	90868382000	26628	13173	5	0	\N
200219	2132	147327340000	26628	13173	6	0	\N
200220	1397	1278884023000	26629	13173	0	0	\N
200221	1397	1278874022000	26629	13173	1	0	\N
200222	2134	84264103000	26629	13173	2	0	\N
200223	2134	84263100000	26629	13173	3	0	\N
200224	2133	90869384000	26629	13173	4	0	\N
200225	2133	90868382000	26629	13173	5	0	\N
200226	2132	147327340000	26629	13173	6	0	\N
200231	1397	1278854020000	26631	13175	0	0	\N
200232	2134	84261094000	26631	13175	1	0	\N
200233	2132	147326339000	26631	13175	2	0	\N
200234	2133	90866378000	26631	13175	3	0	\N
200244	1397	1278834018000	26635	13178	0	0	\N
200245	2134	84258085000	26635	13178	1	0	\N
200246	2133	90863372000	26635	13178	2	0	\N
200247	2132	147325338000	26635	13178	3	0	\N
200248	1397	1278834018000	26636	13178	0	0	\N
200249	2134	84258085000	26636	13178	1	0	\N
200250	2133	90863372000	26636	13178	2	0	\N
200251	2132	147325338000	26636	13178	3	0	\N
200256	1397	1278834018000	26638	13178	0	0	\N
200257	2134	84258085000	26638	13178	1	0	\N
200258	2133	90863372000	26638	13178	2	0	\N
200259	2132	147325338000	26638	13178	3	0	\N
200260	1397	1278824017000	26639	13179	0	0	\N
200261	1397	1278814016000	26639	13179	1	0	\N
200262	1397	1278804015000	26639	13179	2	0	\N
200263	2133	90862370000	26639	13179	3	0	\N
200264	2133	90861368000	26639	13179	4	0	\N
200265	2133	90860366000	26639	13179	5	0	\N
200266	2134	84257082000	26639	13179	6	0	\N
200267	2134	84256079000	26639	13179	7	0	\N
200268	2134	84255076000	26639	13179	8	0	\N
200278	1397	1278824017000	26641	13179	0	0	\N
200279	1397	1278814016000	26641	13179	1	0	\N
200280	1397	1278804015000	26641	13179	2	0	\N
200281	2133	90862370000	26641	13179	3	0	\N
200282	2133	90861368000	26641	13179	4	0	\N
200283	2133	90860366000	26641	13179	5	0	\N
200284	2134	84257082000	26641	13179	6	0	\N
200285	2134	84256079000	26641	13179	7	0	\N
200286	2134	84255076000	26641	13179	8	0	\N
200287	1397	1278824017000	26642	13179	0	0	\N
200288	1397	1278814016000	26642	13179	1	0	\N
200289	1397	1278804015000	26642	13179	2	0	\N
200290	2133	90862370000	26642	13179	3	0	\N
200291	2133	90861368000	26642	13179	4	0	\N
200292	2133	90860366000	26642	13179	5	0	\N
200293	2134	84257082000	26642	13179	6	0	\N
200294	2134	84256079000	26642	13179	7	0	\N
200295	2134	84255076000	26642	13179	8	0	\N
200306	1397	1278784013000	26645	13181	0	0	\N
200307	1397	1278774012000	26645	13181	1	0	\N
200308	2133	90858362000	26645	13181	2	0	\N
200309	2133	90857360000	26645	13181	3	0	\N
200310	2134	84254073000	26645	13181	4	0	\N
200311	2134	84253070000	26645	13181	5	0	\N
200312	2133	90858362000	26646	13181	0	0	\N
200313	2133	90857360000	26646	13181	1	0	\N
200314	2134	84254073000	26646	13181	2	0	\N
200315	2134	84253070000	26646	13181	3	0	\N
200316	1397	1278764011000	26647	13182	0	0	\N
200317	2132	147323336000	26647	13182	1	0	\N
200318	2134	84252067000	26647	13182	2	0	\N
200319	2133	90856358000	26647	13182	3	0	\N
200320	1397	1278764011000	26648	13182	0	0	\N
200321	2132	147323336000	26648	13182	1	0	\N
200322	2134	84252067000	26648	13182	2	0	\N
200323	2133	90856358000	26648	13182	3	0	\N
200198	2133	90872390000	26624	13170	1	0	5807
200199	2134	84267112000	26624	13170	2	0	6304
200200	1397	1278904025000	26625	13171	0	0	15992
200201	2134	84266109000	26625	13171	1	0	6305
200202	2133	90871388000	26625	13171	2	0	5808
200204	2134	84265106000	26626	13172	1	0	6306
200205	2133	90870386000	26626	13172	2	0	5809
200206	1397	1278884023000	26627	13173	0	0	15994
200207	1397	1278874022000	26627	13173	1	0	15995
200208	2134	84264103000	26627	13173	2	0	6307
200210	2133	90869384000	26627	13173	4	0	5810
200211	2133	90868382000	26627	13173	5	0	5811
200212	2132	147327340000	26627	13173	6	0	1661
200227	1397	1278864021000	26630	13174	0	0	15996
200229	2134	84262097000	26630	13174	2	0	6309
200230	2133	90867380000	26630	13174	3	0	5812
200235	1397	1278854020000	26632	13175	0	0	15997
200236	2134	84261094000	26632	13175	1	0	6310
200237	2132	147326339000	26632	13175	2	0	1662
200239	1397	1278844019000	26633	13176	0	0	15998
200240	2134	84260091000	26633	13176	1	0	6311
200241	2133	90865376000	26633	13176	2	0	5814
200242	2134	84259088000	26634	13177	0	0	6312
200243	2133	90864374000	26634	13177	1	0	5815
200253	2134	84258085000	26637	13178	1	0	6313
200254	2133	90863372000	26637	13178	2	0	5816
200255	2132	147325338000	26637	13178	3	0	1663
200269	1397	1278824017000	26640	13179	0	0	16000
200271	1397	1278804015000	26640	13179	2	0	16002
200272	2133	90862370000	26640	13179	3	0	5817
200273	2133	90861368000	26640	13179	4	0	5818
200274	2133	90860366000	26640	13179	5	0	5819
200275	2134	84257082000	26640	13179	6	0	6314
200277	2134	84255076000	26640	13179	8	0	6316
200296	1397	1278794014000	26643	13180	0	0	16003
200297	1724	12652760500000	26643	13180	1	0	15
200298	2132	147324337000	26643	13180	2	0	1664
200299	2133	90859364000	26643	13180	3	0	5820
200301	1397	1278774012000	26644	13181	1	0	16005
200302	2133	90858362000	26644	13181	2	0	5821
200303	2133	90857360000	26644	13181	3	0	5822
200304	2134	84254073000	26644	13181	4	0	6317
200324	1397	1278764011000	26649	13182	0	0	16006
200325	2132	147323336000	26649	13182	1	0	1665
200326	2134	84252067000	26649	13182	2	0	6319
200327	2133	90856358000	26649	13182	3	0	5823
200328	1397	1278754010000	26650	13183	0	0	16007
200331	1397	1279314066000	26651	13070	0	0	\N
200332	1397	1279304065000	26651	13070	1	0	\N
200333	1397	1279294064000	26651	13070	2	0	\N
200334	1397	1279284063000	26651	13070	3	0	\N
200335	1397	1279274062000	26651	13070	4	0	\N
200336	1397	1279264061000	26651	13070	5	0	\N
200337	1397	1279254060000	26651	13070	6	0	\N
200338	1397	1279244059000	26651	13070	7	0	\N
200339	1397	1279234058000	26651	13070	8	0	\N
200340	1397	1279224057000	26651	13070	9	0	\N
200341	1397	1279214056000	26651	13070	10	0	\N
200342	1397	1279204055000	26651	13070	11	0	\N
200343	1397	1279194054000	26651	13070	12	0	\N
200344	1397	1279184053000	26651	13070	13	0	\N
200345	1397	1279174052000	26651	13070	14	0	\N
200346	1397	1279164051000	26651	13070	15	0	\N
200347	1397	1279154050000	26651	13070	16	0	\N
200348	1397	1279144049000	26651	13070	17	0	\N
200349	1397	1279134048000	26651	13070	18	0	\N
200350	1397	1279124047000	26651	13070	19	0	\N
200351	1397	1279114046000	26651	13070	20	0	\N
200352	1397	1279104045000	26651	13070	21	0	\N
200353	1397	1279094044000	26651	13070	22	0	\N
200354	1397	1279084043000	26651	13070	23	0	\N
200355	1397	1279074042000	26651	13070	24	0	\N
200356	1397	1279064041000	26651	13070	25	0	\N
200357	1397	1279054040000	26651	13070	26	0	\N
200358	1397	1279044039000	26651	13070	27	0	\N
200359	1397	1279034038000	26651	13070	28	0	\N
200360	1397	1279024037000	26651	13070	29	0	\N
200361	1397	1279014036000	26651	13070	30	0	\N
200362	1397	1279004035000	26651	13070	31	0	\N
200363	1397	1278994034000	26651	13070	32	0	\N
200364	1397	1278984033000	26651	13070	33	0	\N
200365	1397	1278974032000	26651	13070	34	0	\N
200366	1397	1278964031000	26651	13070	35	0	\N
200367	1397	1278954030000	26651	13070	36	0	\N
200368	1397	1278944029000	26651	13070	37	0	\N
200369	1397	1278934028000	26651	13070	38	0	\N
200370	1397	1278924027000	26651	13070	39	0	\N
200371	1397	1278914026000	26651	13070	40	0	\N
200372	1397	1278904025000	26651	13070	41	0	\N
200373	1397	1278894024000	26651	13070	42	0	\N
200374	1397	1278884023000	26651	13070	43	0	\N
200375	1397	1278874022000	26651	13070	44	0	\N
200376	1397	1278864021000	26651	13070	45	0	\N
200377	1397	1278854020000	26651	13070	46	0	\N
200378	1397	1278844019000	26651	13070	47	0	\N
200379	1397	1278834018000	26651	13070	48	0	\N
200380	1397	1278824017000	26651	13070	49	0	\N
200381	1397	1278814016000	26651	13070	50	0	\N
200382	1397	1278804015000	26651	13070	51	0	\N
200383	1397	1278794014000	26651	13070	52	0	\N
200384	1397	1278784013000	26651	13070	53	0	\N
200385	1397	1278774012000	26651	13070	54	0	\N
200386	1397	1278764011000	26651	13070	55	0	\N
200387	1397	1278754010000	26651	13070	56	0	\N
200388	1724	12653766500000	26651	13070	57	0	\N
200389	1724	12652760500000	26651	13070	58	0	\N
200390	2338	8000000	26651	13070	59	0	\N
200391	2133	90967580000	26651	13070	60	0	\N
200392	1726	971472112000	26651	13070	61	0	\N
200393	2335	0	26651	13070	62	0	\N
200394	1726	970371112000	26651	13070	63	0	\N
200395	1726	969270112000	26651	13070	64	0	\N
200396	1726	968169112000	26651	13070	65	0	\N
200397	2337	0	26651	13070	66	0	\N
200398	1726	967068112000	26651	13070	67	0	\N
200399	2133	90966578000	26651	13070	68	0	\N
200400	2133	90965576000	26651	13070	69	0	\N
200401	2133	90964574000	26651	13070	70	0	\N
200402	2133	90963572000	26651	13070	71	0	\N
200403	2133	90962570000	26651	13070	72	0	\N
200404	2133	90961568000	26651	13070	73	0	\N
200405	2133	90960566000	26651	13070	74	0	\N
200406	2133	90959564000	26651	13070	75	0	\N
200407	2133	90958562000	26651	13070	76	0	\N
200408	2133	90957560000	26651	13070	77	0	\N
200409	2133	90956558000	26651	13070	78	0	\N
200410	2133	90955556000	26651	13070	79	0	\N
200411	2134	84388475000	26651	13070	80	0	\N
200412	2134	84387472000	26651	13070	81	0	\N
200413	2134	84386469000	26651	13070	82	0	\N
200414	2134	84385466000	26651	13070	83	0	\N
200415	2134	84384463000	26651	13070	84	0	\N
200416	2134	84383460000	26651	13070	85	0	\N
200417	2134	84382457000	26651	13070	86	0	\N
200418	2134	84381454000	26651	13070	87	0	\N
200419	2134	84380451000	26651	13070	88	0	\N
200420	2134	84379448000	26651	13070	89	0	\N
200421	2134	84378445000	26651	13070	90	0	\N
200422	2134	84377442000	26651	13070	91	0	\N
200423	2134	84376439000	26651	13070	92	0	\N
200424	2134	84375436000	26651	13070	93	0	\N
200425	2134	84374433000	26651	13070	94	0	\N
200426	2134	84373430000	26651	13070	95	0	\N
200427	2134	84372427000	26651	13070	96	0	\N
200428	2134	84371424000	26651	13070	97	0	\N
200429	2134	84370421000	26651	13070	98	0	\N
200430	2134	84369418000	26651	13070	99	0	\N
200431	2134	84368415000	26651	13070	100	0	\N
200432	2134	84367412000	26651	13070	101	0	\N
200433	2134	84366409000	26651	13070	102	0	\N
200434	2134	84365406000	26651	13070	103	0	\N
200435	2134	84364403000	26651	13070	104	0	\N
200436	2134	84363400000	26651	13070	105	0	\N
200437	2134	84362397000	26651	13070	107	0	\N
200438	2134	84361394000	26651	13070	108	0	\N
200439	2134	84360391000	26651	13070	109	0	\N
200440	2134	84359388000	26651	13070	110	0	\N
200441	2134	84358385000	26651	13070	111	0	\N
200442	2134	84357382000	26651	13070	112	0	\N
200443	2134	84356379000	26651	13070	113	0	\N
200444	2134	84355376000	26651	13070	114	0	\N
200445	2134	84354373000	26651	13070	115	0	\N
200446	2134	84353370000	26651	13070	116	0	\N
200447	2134	84352367000	26651	13070	117	0	\N
200448	2134	84351364000	26651	13070	118	0	\N
200449	2134	84350361000	26651	13070	119	0	\N
200450	2134	84349358000	26651	13070	120	0	\N
200451	2134	84348355000	26651	13070	121	0	\N
200452	2134	84347352000	26651	13070	122	0	\N
200453	2134	84346349000	26651	13070	123	0	\N
200454	2134	84345346000	26651	13070	124	0	\N
200455	2134	84344343000	26651	13070	125	0	\N
200456	1397	1278744009000	26652	13184	0	0	\N
200457	2134	84250061000	26652	13184	1	0	\N
200458	2133	90854354000	26652	13184	2	0	\N
200459	1397	1278744009000	26653	13184	0	0	\N
200460	2134	84250061000	26653	13184	1	0	\N
200461	2133	90854354000	26653	13184	2	0	\N
200462	1397	1278744009000	26654	13184	0	0	16008
200463	2134	84250061000	26654	13184	1	0	6321
200464	2133	90854354000	26654	13184	2	0	5825
200469	1397	1278734008000	26656	13185	0	0	\N
200470	2133	90853352000	26656	13185	1	0	\N
200471	2132	147322335000	26656	13185	2	0	\N
200472	2134	84249058000	26656	13185	3	0	\N
200476	1397	1278714006000	26658	13187	0	0	\N
200477	2134	84247052000	26658	13187	1	0	\N
200478	2133	90851348000	26658	13187	2	0	\N
200489	1397	1278704005000	26661	13188	0	0	\N
200490	1397	1278694004000	26661	13188	1	0	\N
200491	2134	84246049000	26661	13188	2	0	\N
200492	2133	90851348000	26661	13188	3	0	\N
200493	2134	84245046000	26661	13188	4	0	\N
200494	2133	90850346000	26661	13188	5	0	\N
200495	2133	90849344000	26661	13188	6	0	\N
200496	2132	147321334000	26661	13188	7	0	\N
200497	1397	1278704005000	26662	13188	0	0	\N
200498	1397	1278694004000	26662	13188	1	0	\N
200499	2134	84246049000	26662	13188	2	0	\N
200500	2133	90851348000	26662	13188	3	0	\N
200501	2134	84245046000	26662	13188	4	0	\N
200502	2133	90850346000	26662	13188	5	0	\N
200503	2133	90849344000	26662	13188	6	0	\N
200504	2132	147321334000	26662	13188	7	0	\N
200508	1397	1278684003000	26664	13189	0	0	\N
200509	2133	90848342000	26664	13189	1	0	\N
200510	2134	84244043000	26664	13189	2	0	\N
200511	1397	1278674002000	26665	13190	0	0	\N
200512	1397	1278664001000	26665	13190	1	0	\N
200513	2133	90847340000	26665	13190	3	0	\N
200514	2133	90846338000	26665	13190	4	0	\N
200515	2134	84243040000	26665	13190	5	0	\N
200516	2134	84242037000	26665	13190	6	0	\N
200517	2132	147320333000	26665	13190	7	0	\N
200518	1397	1278674002000	26666	13190	0	0	\N
200519	1397	1278664001000	26666	13190	1	0	\N
200520	2133	90847340000	26666	13190	3	0	\N
200521	2133	90846338000	26666	13190	4	0	\N
200522	2134	84243040000	26666	13190	5	0	\N
200523	2134	84242037000	26666	13190	6	0	\N
200524	2132	147320333000	26666	13190	7	0	\N
200525	1397	1278674002000	26667	13190	0	0	\N
200526	1397	1278664001000	26667	13190	1	0	\N
200527	2133	90847340000	26667	13190	3	0	\N
200528	2133	90846338000	26667	13190	4	0	\N
200529	2134	84243040000	26667	13190	5	0	\N
200530	2134	84242037000	26667	13190	6	0	\N
200531	2132	147320333000	26667	13190	7	0	\N
200532	1397	1278674002000	26668	13190	0	0	\N
200533	1397	1278664001000	26668	13190	1	0	\N
200534	2133	90847340000	26668	13190	3	0	\N
200535	2133	90846338000	26668	13190	4	0	\N
200536	2134	84243040000	26668	13190	5	0	\N
200537	2134	84242037000	26668	13190	6	0	\N
200538	2132	147320333000	26668	13190	7	0	\N
200546	1397	1278674002000	26670	13190	0	0	\N
200547	1397	1278664001000	26670	13190	1	0	\N
200548	2133	90847340000	26670	13190	3	0	\N
200549	2133	90846338000	26670	13190	4	0	\N
200550	2134	84243040000	26670	13190	5	0	\N
200551	2134	84242037000	26670	13190	6	0	\N
200552	2132	147320333000	26670	13190	7	0	\N
200563	1397	1278633998000	26674	13193	0	0	\N
200564	2134	84239028000	26674	13193	1	0	\N
200565	2132	147319332000	26674	13193	2	0	\N
200566	2133	90843332000	26674	13193	3	0	\N
200567	1397	1278633998000	26675	13193	0	0	\N
200568	2134	84239028000	26675	13193	1	0	\N
200569	2132	147319332000	26675	13193	2	0	\N
200570	2133	90843332000	26675	13193	3	0	\N
200580	1397	1278603995000	26679	13196	0	0	\N
200581	2134	84236019000	26679	13196	1	0	\N
200582	2133	90840326000	26679	13196	2	0	\N
200590	1397	1278744009000	26681	13071	0	0	\N
200591	1397	1278734008000	26681	13071	1	0	\N
200592	1397	1278724007000	26681	13071	2	0	\N
200593	1397	1278714006000	26681	13071	3	0	\N
200594	1397	1278704005000	26681	13071	4	0	\N
200595	1397	1278694004000	26681	13071	5	0	\N
200467	2132	147322335000	26655	13185	2	0	1666
200468	2134	84249058000	26655	13185	3	0	6322
200473	1397	1278724007000	26657	13186	0	0	16010
200474	2133	90852350000	26657	13186	1	0	5827
200475	2134	84248055000	26657	13186	2	0	6323
200480	2134	84247052000	26659	13187	1	0	6324
200481	1397	1278704005000	26660	13188	0	0	16012
200482	1397	1278694004000	26660	13188	1	0	16013
200483	2134	84246049000	26660	13188	2	0	6325
200484	2133	90851348000	26660	13188	3	0	5828
200486	2133	90850346000	26660	13188	5	0	5829
200487	2133	90849344000	26660	13188	6	0	5830
200488	2132	147321334000	26660	13188	7	0	1667
200505	1397	1278684003000	26663	13189	0	0	16014
200507	2134	84244043000	26663	13189	2	0	6327
200539	1397	1278674002000	26669	13190	0	0	16015
200540	1397	1278664001000	26669	13190	1	0	16016
200541	2133	90847340000	26669	13190	3	0	5832
200542	2133	90846338000	26669	13190	4	0	5833
200544	2134	84242037000	26669	13190	6	0	6329
200545	2132	147320333000	26669	13190	7	0	1668
200553	1397	1278654000000	26671	13191	0	0	16017
200554	2133	90845336000	26671	13191	1	0	5834
200555	2134	84241034000	26671	13191	2	0	6330
200557	2134	84240031000	26672	13192	1	0	6331
200558	2133	90844334000	26672	13192	2	0	5835
200559	1397	1278633998000	26673	13193	0	0	16019
200560	2134	84239028000	26673	13193	1	0	6332
200562	2133	90843332000	26673	13193	3	0	5836
200571	1397	1278623997000	26676	13194	0	0	16020
200572	2134	84238025000	26676	13194	1	0	6333
200573	2133	90842330000	26676	13194	2	0	5837
200574	1397	1278613996000	26677	13195	0	0	16021
200576	2133	90841328000	26677	13195	2	0	5838
200577	1397	1278603995000	26678	13196	0	0	16022
200578	2134	84236019000	26678	13196	1	0	6335
200579	2133	90840326000	26678	13196	2	0	5839
200583	1397	1278593994000	26680	13197	0	0	16023
200585	2132	147318331000	26680	13197	2	0	1670
200586	2134	84235016000	26680	13197	3	0	6336
200587	2133	90839324000	26680	13197	4	0	5840
200588	2134	84234013000	26680	13197	5	0	6337
200596	1397	1278573992000	26682	13198	0	0	16025
200597	1397	1278563991000	26682	13198	1	0	16026
200598	1397	1278553990000	26682	13198	2	0	16027
200599	2133	90837320000	26682	13198	3	0	5842
200600	2132	147317330000	26682	13198	4	0	1671
200605	1397	1278573992000	26683	13198	0	0	\N
200606	1397	1278563991000	26683	13198	1	0	\N
200607	1397	1278553990000	26683	13198	2	0	\N
200608	2133	90837320000	26683	13198	3	0	\N
200609	2132	147317330000	26683	13198	4	0	\N
200610	2133	90836318000	26683	13198	5	0	\N
200611	2134	84233010000	26683	13198	6	0	\N
200612	2134	84232007000	26683	13198	7	0	\N
200613	2134	84231004000	26683	13198	8	0	\N
200614	1397	1278543989000	26685	13199	0	0	\N
200615	1397	1278533988000	26685	13199	1	0	\N
200616	2133	90835316000	26685	13199	2	0	\N
200617	2133	90834314000	26685	13199	3	0	\N
200618	2132	147316329000	26685	13199	4	0	\N
200619	1726	965967112000	26685	13199	5	0	\N
200620	2134	84230001000	26685	13199	6	0	\N
200621	2134	84228998000	26685	13199	7	0	\N
200622	1397	1278543989000	26686	13199	0	0	\N
200623	1397	1278533988000	26686	13199	1	0	\N
200624	2133	90835316000	26686	13199	2	0	\N
200625	2133	90834314000	26686	13199	3	0	\N
200626	2132	147316329000	26686	13199	4	0	\N
200627	1726	965967112000	26686	13199	5	0	\N
200628	2134	84230001000	26686	13199	6	0	\N
200629	2134	84228998000	26686	13199	7	0	\N
200641	1397	1278513986000	26690	13201	0	0	\N
200642	1397	1278503985000	26690	13201	1	0	\N
200643	1397	1278493984000	26690	13201	2	0	\N
200644	2133	90832310000	26690	13201	3	0	\N
200645	2134	84226992000	26690	13201	4	0	\N
200646	2134	84225989000	26690	13201	5	0	\N
200647	2134	84224986000	26690	13201	6	0	\N
200648	2133	90831308000	26690	13201	7	0	\N
200649	2133	90830306000	26690	13201	8	0	\N
200650	2132	147315328000	26690	13201	9	0	\N
200651	1397	1278513986000	26691	13201	0	0	\N
200652	1397	1278503985000	26691	13201	1	0	\N
200653	1397	1278493984000	26691	13201	2	0	\N
200654	2133	90832310000	26691	13201	3	0	\N
200655	2134	84226992000	26691	13201	4	0	\N
200656	2134	84225989000	26691	13201	5	0	\N
200657	2134	84224986000	26691	13201	6	0	\N
200658	2133	90831308000	26691	13201	7	0	\N
200659	2133	90830306000	26691	13201	8	0	\N
200660	2132	147315328000	26691	13201	9	0	\N
200682	1397	1278463981000	26697	13204	0	0	\N
200683	2133	90827300000	26697	13204	1	0	\N
200684	2132	147314327000	26697	13204	2	0	\N
200685	2134	84221977000	26697	13204	3	0	\N
200689	1397	1278453980000	26699	13205	0	0	\N
200690	2134	84220974000	26699	13205	1	0	\N
200691	2133	90826298000	26699	13205	2	0	\N
200692	1397	1278443979000	26700	13206	0	0	\N
200693	2133	90825296000	26700	13206	1	0	\N
200694	2134	84219971000	26700	13206	2	0	\N
200698	1397	1278443979000	26702	13206	0	0	\N
200699	2133	90825296000	26702	13206	1	0	\N
200700	2134	84219971000	26702	13206	2	0	\N
200714	1397	1278393974000	26705	13209	0	0	\N
200715	1397	1278383973000	26705	13209	1	0	\N
200716	1397	1278373972000	26705	13209	2	0	\N
200717	2283	199000000	26705	13209	3	0	\N
200718	2133	90820286000	26705	13209	4	0	\N
200719	2133	90819284000	26705	13209	5	0	\N
200720	2134	84214956000	26705	13209	6	0	\N
200721	2134	84213953000	26705	13209	7	0	\N
200722	2134	84212950000	26705	13209	8	0	\N
200723	2133	90818282000	26705	13209	9	0	\N
200724	2132	147312325000	26705	13209	10	0	\N
200725	1397	1280534188000	26706	13053	0	0	\N
200726	1397	1280524187000	26706	13053	1	0	\N
200727	1397	1280514186000	26706	13053	2	0	\N
200728	1397	1280504185000	26706	13053	3	0	\N
200729	1397	1280494184000	26706	13053	4	0	\N
200730	1397	1280484183000	26706	13053	5	0	\N
200731	1397	1280474182000	26706	13053	6	0	\N
200732	1397	1280464181000	26706	13053	7	0	\N
200733	1397	1280454180000	26706	13053	8	0	\N
200734	1397	1280444179000	26706	13053	9	0	\N
200735	1397	1280434178000	26706	13053	10	0	\N
200736	1397	1280424177000	26706	13053	11	0	\N
200603	2134	84232007000	26682	13198	7	0	6339
200604	2134	84231004000	26682	13198	8	0	6340
200630	1397	1278543989000	26687	13199	0	0	16028
200631	1397	1278533988000	26687	13199	1	0	16029
200632	2133	90835316000	26687	13199	2	0	5844
200634	2132	147316329000	26687	13199	4	0	1672
200635	1726	965967112000	26687	13199	5	0	8318
200636	2134	84230001000	26687	13199	6	0	6341
200637	2134	84228998000	26687	13199	7	0	6342
200638	1397	1278523987000	26688	13200	0	0	16030
200640	2133	90833312000	26688	13200	2	0	5846
200661	1397	1278513986000	26692	13201	0	0	16031
200662	1397	1278503985000	26692	13201	1	0	16032
200663	1397	1278493984000	26692	13201	2	0	16033
200665	2134	84226992000	26692	13201	4	0	6344
200666	2134	84225989000	26692	13201	5	0	6345
200667	2134	84224986000	26692	13201	6	0	6346
200668	2133	90831308000	26692	13201	7	0	5848
200669	2133	90830306000	26692	13201	8	0	5849
200671	1397	1278483983000	26694	13202	0	0	16034
200672	2134	84223983000	26694	13202	1	0	6347
200673	2133	90829304000	26694	13202	2	0	5850
200674	1726	964866112000	26694	13202	3	0	8319
200675	1397	1278473982000	26695	13203	0	0	16035
200677	2133	90828302000	26695	13203	2	0	5851
200678	1397	1278463981000	26696	13204	0	0	16036
200679	2133	90827300000	26696	13204	1	0	5852
200680	2132	147314327000	26696	13204	2	0	1674
200686	1397	1278453980000	26698	13205	0	0	16037
200687	2134	84220974000	26698	13205	1	0	6350
200688	2133	90826298000	26698	13205	2	0	5853
200695	1397	1278443979000	26701	13206	0	0	16038
200696	2133	90825296000	26701	13206	1	0	5854
200701	1397	1278433978000	26703	13207	0	0	16039
200702	1397	1278423977000	26703	13207	1	0	16040
200703	2133	90824294000	26703	13207	2	0	5855
200704	2134	84218968000	26703	13207	3	0	6352
200705	2134	84217965000	26703	13207	4	0	6353
200707	2133	90823292000	26703	13207	6	0	5856
200708	1397	1278413976000	26704	13208	0	0	16041
200709	1397	1278403975000	26704	13208	1	0	16042
200710	2134	84216962000	26704	13208	2	0	6354
200712	2133	90822290000	26704	13208	4	0	5857
200713	2133	90821288000	26704	13208	5	0	5858
200737	1397	1280414176000	26706	13053	12	0	\N
200738	1397	1280404175000	26706	13053	13	0	\N
200739	1397	1280394174000	26706	13053	14	0	\N
200740	1397	1280384173000	26706	13053	15	0	\N
200741	1397	1280374172000	26706	13053	16	0	\N
200742	1397	1280364171000	26706	13053	17	0	\N
200743	1397	1280354170000	26706	13053	18	0	\N
200744	1397	1280344169000	26706	13053	19	0	\N
200745	1397	1280334168000	26706	13053	20	0	\N
200746	1397	1280324167000	26706	13053	21	0	\N
200747	1397	1280314166000	26706	13053	22	0	\N
200748	1397	1280304165000	26706	13053	23	0	\N
200749	1397	1280294164000	26706	13053	24	0	\N
200750	1397	1280284163000	26706	13053	25	0	\N
200751	1397	1280274162000	26706	13053	26	0	\N
200752	1397	1280264161000	26706	13053	27	0	\N
200753	1397	1280254160000	26706	13053	28	0	\N
200754	1397	1280244159000	26706	13053	29	0	\N
200755	1397	1280234158000	26706	13053	30	0	\N
200756	1397	1280224157000	26706	13053	31	0	\N
200757	1397	1280214156000	26706	13053	32	0	\N
200758	1397	1280204155000	26706	13053	33	0	\N
200759	1397	1280194154000	26706	13053	34	0	\N
200760	1397	1280184153000	26706	13053	35	0	\N
200761	1397	1280174152000	26706	13053	36	0	\N
200762	1397	1280164151000	26706	13053	37	0	\N
200763	1397	1280154150000	26706	13053	39	0	\N
200764	1397	1280144149000	26706	13053	40	0	\N
200765	1397	1280134148000	26706	13053	41	0	\N
200766	1397	1280124147000	26706	13053	42	0	\N
200767	1397	1280114146000	26706	13053	43	0	\N
200768	1397	1280104145000	26706	13053	44	0	\N
200769	1397	1280094144000	26706	13053	45	0	\N
200770	1397	1280084143000	26706	13053	46	0	\N
200771	1397	1280074142000	26706	13053	47	0	\N
200772	1397	1280064141000	26706	13053	48	0	\N
200773	1397	1280054140000	26706	13053	49	0	\N
200774	1397	1280044139000	26706	13053	50	0	\N
200775	1397	1280034138000	26706	13053	51	0	\N
200776	1397	1280024137000	26706	13053	52	0	\N
200777	1397	1280014136000	26706	13053	53	0	\N
200778	1397	1280004135000	26706	13053	54	0	\N
200779	1397	1279994134000	26706	13053	55	0	\N
200780	1397	1279984133000	26706	13053	56	0	\N
200781	1397	1279974132000	26706	13053	57	0	\N
200782	1397	1279964131000	26706	13053	58	0	\N
200783	1397	1279954130000	26706	13053	59	0	\N
200784	1397	1279944129000	26706	13053	60	0	\N
200785	1397	1279934128000	26706	13053	61	0	\N
200786	1397	1279924127000	26706	13053	62	0	\N
200787	1397	1279914126000	26706	13053	63	0	\N
200788	1397	1279904125000	26706	13053	64	0	\N
200789	1397	1279894124000	26706	13053	65	0	\N
200790	1397	1279884123000	26706	13053	66	0	\N
200791	1397	1279874122000	26706	13053	67	0	\N
200792	1397	1279864121000	26706	13053	68	0	\N
200793	1397	1279854120000	26706	13053	69	0	\N
200794	1397	1279844119000	26706	13053	70	0	\N
200795	1397	1279834118000	26706	13053	71	0	\N
200796	1397	1279824117000	26706	13053	72	0	\N
200797	1397	1279814116000	26706	13053	73	0	\N
200798	1397	1279804115000	26706	13053	74	0	\N
200799	1397	1279794114000	26706	13053	75	0	\N
200800	1397	1279784113000	26706	13053	76	0	\N
200801	1397	1279774112000	26706	13053	77	0	\N
200802	1397	1279764111000	26706	13053	78	0	\N
200803	1397	1279754110000	26706	13053	79	0	\N
200804	1397	1279744109000	26706	13053	80	0	\N
200805	1397	1279734108000	26706	13053	81	0	\N
200806	1397	1279724107000	26706	13053	82	0	\N
200807	1397	1279714106000	26706	13053	83	0	\N
200808	1397	1279704105000	26706	13053	84	0	\N
200809	1397	1279694104000	26706	13053	85	0	\N
200810	1397	1279684103000	26706	13053	86	0	\N
200811	1397	1279674102000	26706	13053	87	0	\N
200812	1397	1279664101000	26706	13053	88	0	\N
200813	1397	1279654100000	26706	13053	89	0	\N
200814	1397	1279644099000	26706	13053	90	0	\N
200815	1397	1279634098000	26706	13053	91	0	\N
200816	1397	1279624097000	26706	13053	92	0	\N
200817	1397	1279614096000	26706	13053	93	0	\N
200818	1397	1279604095000	26706	13053	94	0	\N
200819	1397	1279594094000	26706	13053	95	0	\N
200820	1397	1279584093000	26706	13053	96	0	\N
200821	1397	1279574092000	26706	13053	97	0	\N
200822	1397	1279564091000	26706	13053	98	0	\N
200823	1397	1279554090000	26706	13053	99	0	\N
200824	1397	1279544089000	26706	13053	100	0	\N
200825	1397	1279534088000	26706	13053	101	0	\N
200826	1397	1279524087000	26706	13053	102	0	\N
200827	1397	1279514086000	26706	13053	103	0	\N
200828	1397	1279504085000	26706	13053	104	0	\N
200829	1397	1279494084000	26706	13053	105	0	\N
200830	1397	1279484083000	26706	13053	106	0	\N
200831	1397	1279474082000	26706	13053	107	0	\N
200832	1397	1279464081000	26706	13053	108	0	\N
200833	1397	1279454080000	26706	13053	109	0	\N
200834	1397	1279444079000	26706	13053	110	0	\N
200835	1397	1279434078000	26706	13053	111	0	\N
200836	1397	1279424077000	26706	13053	112	0	\N
200837	1397	1279414076000	26706	13053	113	0	\N
200838	1397	1279404075000	26706	13053	114	0	\N
200839	1397	1279394074000	26706	13053	115	0	\N
200840	1397	1279384073000	26706	13053	116	0	\N
200841	1397	1279374072000	26706	13053	117	0	\N
200842	1397	1279364071000	26706	13053	118	0	\N
200843	1397	1279354070000	26706	13053	119	0	\N
200844	1397	1279344069000	26706	13053	120	0	\N
200845	1397	1279334068000	26706	13053	121	0	\N
200846	1397	1279324067000	26706	13053	122	0	\N
200847	1397	1279314066000	26706	13053	123	0	\N
200848	1397	1279304065000	26706	13053	124	0	\N
200849	1397	1279294064000	26706	13053	125	0	\N
200868	1397	1279014036000	26709	13163	0	0	\N
200869	1397	1279004035000	26709	13163	1	0	\N
200870	1397	1278994034000	26709	13163	2	0	\N
200871	1397	1278984033000	26709	13163	3	0	\N
200872	1397	1278974032000	26709	13163	4	0	\N
200852	1397	1278373972000	26707	13209	2	0	16045
200853	2283	199000000	26707	13209	3	0	1
200854	2133	90820286000	26707	13209	4	0	5859
200855	2133	90819284000	26707	13209	5	0	5860
200856	2134	84214956000	26707	13209	6	0	6356
200858	2134	84212950000	26707	13209	8	0	6358
200859	2133	90818282000	26707	13209	9	0	5861
200860	2132	147312325000	26707	13209	10	0	1676
200861	1397	1278363971000	26708	13210	0	0	16046
200862	1397	1278353970000	26708	13210	1	0	16047
200864	2132	147311324000	26708	13210	3	0	1677
200865	2134	84211947000	26708	13210	4	0	6359
200866	2134	84210944000	26708	13210	5	0	6360
200867	2133	90816278000	26708	13210	6	0	5863
200873	1397	1278964031000	26709	13163	5	0	\N
200874	1397	1278954030000	26709	13163	6	0	\N
200875	1397	1278944029000	26709	13163	7	0	\N
200876	1397	1278934028000	26709	13163	8	0	\N
200877	1397	1278924027000	26709	13163	9	0	\N
200878	1397	1278914026000	26709	13163	10	0	\N
200879	1397	1278904025000	26709	13163	11	0	\N
200880	1397	1278894024000	26709	13163	12	0	\N
200881	1397	1278884023000	26709	13163	13	0	\N
200882	1397	1278874022000	26709	13163	14	0	\N
200883	1397	1278864021000	26709	13163	15	0	\N
200884	1397	1278854020000	26709	13163	16	0	\N
200885	1397	1278844019000	26709	13163	17	0	\N
200886	1397	1278834018000	26709	13163	18	0	\N
200887	1397	1278824017000	26709	13163	19	0	\N
200888	1397	1278814016000	26709	13163	20	0	\N
200889	1397	1278804015000	26709	13163	21	0	\N
200890	1397	1278794014000	26709	13163	22	0	\N
200891	1397	1278784013000	26709	13163	23	0	\N
200892	1397	1278774012000	26709	13163	24	0	\N
200893	1397	1278764011000	26709	13163	25	0	\N
200894	1397	1278754010000	26709	13163	26	0	\N
200895	1397	1278744009000	26709	13163	27	0	\N
200896	1397	1278734008000	26709	13163	28	0	\N
200897	1397	1278724007000	26709	13163	29	0	\N
200898	1397	1278714006000	26709	13163	30	0	\N
200899	1397	1278704005000	26709	13163	31	0	\N
200900	1397	1278694004000	26709	13163	32	0	\N
200901	1397	1278684003000	26709	13163	33	0	\N
200902	1397	1278674002000	26709	13163	34	0	\N
200903	1397	1278664001000	26709	13163	35	0	\N
200904	1397	1278654000000	26709	13163	36	0	\N
200905	1397	1278643999000	26709	13163	37	0	\N
200906	1397	1278633998000	26709	13163	38	0	\N
200907	1397	1278623997000	26709	13163	39	0	\N
200908	1397	1278613996000	26709	13163	40	0	\N
200909	1397	1278603995000	26709	13163	41	0	\N
200910	1397	1278593994000	26709	13163	42	0	\N
200911	1397	1278583993000	26709	13163	43	0	\N
200912	1397	1278573992000	26709	13163	44	0	\N
200913	1397	1278563991000	26709	13163	45	0	\N
200914	1397	1278553990000	26709	13163	46	0	\N
200915	1397	1278543989000	26709	13163	47	0	\N
200916	1397	1278533988000	26709	13163	48	0	\N
200917	1397	1278523987000	26709	13163	49	0	\N
200918	1397	1278513986000	26709	13163	50	0	\N
200919	1397	1278503985000	26709	13163	51	0	\N
200920	1397	1278493984000	26709	13163	52	0	\N
200921	1397	1278483983000	26709	13163	53	0	\N
200922	1397	1278473982000	26709	13163	54	0	\N
200923	1397	1278463981000	26709	13163	55	0	\N
200924	1397	1278453980000	26709	13163	56	0	\N
200925	1397	1278443979000	26709	13163	57	0	\N
200926	1397	1278433978000	26709	13163	59	0	\N
200927	1397	1278423977000	26709	13163	60	0	\N
200928	1397	1278413976000	26709	13163	61	0	\N
200929	1397	1278403975000	26709	13163	62	0	\N
200930	1397	1278393974000	26709	13163	63	0	\N
200931	1397	1278383973000	26709	13163	64	0	\N
200932	1397	1278373972000	26709	13163	65	0	\N
200933	1397	1278363971000	26709	13163	66	0	\N
200934	1397	1278353970000	26709	13163	67	0	\N
200935	1724	12653766500000	26709	13163	68	0	\N
200936	1724	12652760500000	26709	13163	69	0	\N
200937	2133	90886418000	26709	13163	70	0	\N
200938	2283	199000000	26709	13163	71	0	\N
200939	1726	971472112000	26709	13163	72	0	\N
200940	2133	90885416000	26709	13163	73	0	\N
200941	1726	970371112000	26709	13163	74	0	\N
200942	1726	969270112000	26709	13163	75	0	\N
200943	1726	968169112000	26709	13163	76	0	\N
200944	2132	147332345000	26709	13163	77	0	\N
200945	2132	147331344000	26709	13163	78	0	\N
200946	2132	147330343000	26709	13163	79	0	\N
200947	2132	147329342000	26709	13163	80	0	\N
200948	2132	147328341000	26709	13163	81	0	\N
200949	1726	967068112000	26709	13163	82	0	\N
200950	1726	965967112000	26709	13163	83	0	\N
200951	2134	84280151000	26709	13163	84	0	\N
200952	2134	84279148000	26709	13163	85	0	\N
200953	2134	84278145000	26709	13163	86	0	\N
200954	2134	84277142000	26709	13163	87	0	\N
200955	2134	84276139000	26709	13163	88	0	\N
200956	2133	90884414000	26709	13163	89	0	\N
200957	2133	90883412000	26709	13163	90	0	\N
200958	2133	90882410000	26709	13163	91	0	\N
200959	2133	90881408000	26709	13163	92	0	\N
200960	2133	90880406000	26709	13163	93	0	\N
200961	2133	90879404000	26709	13163	94	0	\N
200962	2133	90878402000	26709	13163	95	0	\N
200963	1726	964866112000	26709	13163	96	0	\N
200964	2133	90877400000	26709	13163	97	0	\N
200965	2133	90876398000	26709	13163	98	0	\N
200966	2133	90875396000	26709	13163	99	0	\N
200967	2133	90874394000	26709	13163	100	0	\N
200968	2134	84275136000	26709	13163	101	0	\N
200969	2133	90873392000	26709	13163	102	0	\N
200970	2133	90872390000	26709	13163	103	0	\N
200971	2133	90871388000	26709	13163	104	0	\N
200972	2132	147327340000	26709	13163	105	0	\N
200973	2132	147326339000	26709	13163	106	0	\N
200974	2132	147325338000	26709	13163	107	0	\N
200975	2132	147324337000	26709	13163	108	0	\N
200976	2132	147323336000	26709	13163	109	0	\N
200977	2132	147322335000	26709	13163	110	0	\N
200978	2132	147321334000	26709	13163	111	0	\N
200979	2132	147320333000	26709	13163	112	0	\N
200980	2132	147319332000	26709	13163	113	0	\N
200981	2132	147318331000	26709	13163	114	0	\N
200982	2132	147317330000	26709	13163	115	0	\N
200983	2132	147316329000	26709	13163	116	0	\N
200984	2132	147315328000	26709	13163	117	0	\N
200985	2132	147314327000	26709	13163	118	0	\N
200986	2132	147313326000	26709	13163	119	0	\N
200987	2134	84274133000	26709	13163	120	0	\N
200988	2134	84273130000	26709	13163	121	0	\N
200989	2134	84272127000	26709	13163	122	0	\N
200990	2134	84271124000	26709	13163	123	0	\N
200991	2134	84270121000	26709	13163	124	0	\N
200992	2134	84269118000	26709	13163	125	0	\N
200993	1397	1278343969000	26710	13211	0	0	\N
200994	2134	84209941000	26710	13211	1	0	\N
200995	2133	90815276000	26710	13211	2	0	\N
201006	1397	1278313966000	26713	13213	0	0	\N
201007	1397	1278303965000	26713	13213	1	0	\N
201008	2134	84206932000	26713	13213	2	0	\N
200998	2133	90815276000	26711	13211	2	0	5864
200999	1397	1278333968000	26712	13212	0	0	16049
201000	1397	1278323967000	26712	13212	1	0	16050
201001	2134	84208938000	26712	13212	2	0	6362
201002	2134	84207935000	26712	13212	3	0	6363
201004	2133	90813272000	26712	13212	5	0	5866
201005	2132	147310323000	26712	13212	6	0	1678
201009	2133	90812270000	26713	13213	3	0	\N
201010	2134	84205929000	26713	13213	4	0	\N
201011	2133	90811268000	26713	13213	5	0	\N
201018	1397	1278293964000	26715	13214	0	0	\N
201019	2133	90810266000	26715	13214	1	0	\N
201020	2132	147309322000	26715	13214	2	0	\N
201021	2134	84204926000	26715	13214	3	0	\N
201026	1397	1278283963000	26717	13215	0	0	\N
201027	2133	90809264000	26717	13215	1	0	\N
201028	2134	84203923000	26717	13215	2	0	\N
201035	1397	1278273962000	26720	13216	0	0	\N
201036	2134	84202920000	26720	13216	1	0	\N
201037	2133	90808262000	26720	13216	2	0	\N
201038	1397	1278273962000	26721	13216	0	0	\N
201039	2134	84202920000	26721	13216	1	0	\N
201059	1397	1278203955000	26727	13221	0	0	\N
201060	1397	1278193954000	26727	13221	1	0	\N
201061	2134	84196902000	26727	13221	2	0	\N
201062	2132	147306319000	26727	13221	3	0	\N
201063	2133	90801248000	26727	13221	4	0	\N
201064	2133	90800246000	26727	13221	5	0	\N
201065	2134	84195899000	26727	13221	6	0	\N
201066	1397	1278203955000	26728	13221	0	0	\N
201067	1397	1278193954000	26728	13221	1	0	\N
201068	2134	84196902000	26728	13221	2	0	\N
201069	2132	147306319000	26728	13221	3	0	\N
201070	2133	90801248000	26728	13221	4	0	\N
201071	2133	90800246000	26728	13221	5	0	\N
201072	2134	84195899000	26728	13221	6	0	\N
201083	1397	1278183953000	26731	13222	0	0	\N
201084	2134	84194896000	26731	13222	1	0	\N
201085	2133	90799244000	26731	13222	2	0	\N
201086	1397	1278183953000	26732	13222	0	0	\N
201087	2134	84194896000	26732	13222	1	0	\N
201088	2133	90799244000	26732	13222	2	0	\N
201089	1397	1278173952000	26733	13223	0	0	\N
201090	1726	963765112000	26733	13223	1	0	\N
201091	2133	90798242000	26733	13223	2	0	\N
201092	1726	962664112000	26733	13223	3	0	\N
201093	2134	84193893000	26733	13223	4	0	\N
201112	1397	1278123947000	26739	13227	0	0	\N
201113	2133	90793232000	26739	13227	1	0	\N
201114	2134	84188878000	26739	13227	2	0	\N
201115	2132	147304317000	26739	13227	3	0	\N
201116	1397	1278123947000	26740	13227	0	0	\N
201117	2134	84188878000	26740	13227	1	0	\N
201118	2132	147304317000	26740	13227	2	0	\N
201119	1397	1278123947000	26741	13227	0	0	\N
201120	2133	90793232000	26741	13227	1	0	\N
201121	2134	84188878000	26741	13227	2	0	\N
201122	2132	147304317000	26741	13227	3	0	\N
201123	1397	1278123947000	26742	13227	0	0	\N
201124	2133	90793232000	26742	13227	1	0	\N
201125	2134	84188878000	26742	13227	2	0	\N
201126	2132	147304317000	26742	13227	3	0	\N
201127	1397	1278123947000	26743	13227	0	0	\N
201128	2133	90793232000	26743	13227	1	0	\N
201129	2134	84188878000	26743	13227	2	0	\N
201130	2132	147304317000	26743	13227	3	0	\N
201131	1397	1278123947000	26744	13228	0	0	\N
201132	1397	1278113946000	26744	13228	1	0	\N
201133	2133	90793232000	26744	13228	2	0	\N
201134	2134	84188878000	26744	13228	3	0	\N
201135	2134	84187875000	26744	13228	4	0	\N
201136	2133	90792230000	26744	13228	5	0	\N
201137	2132	147304317000	26744	13228	6	0	\N
201014	2134	84206932000	26714	13213	2	0	6364
201015	2133	90812270000	26714	13213	3	0	5867
201016	2134	84205929000	26714	13213	4	0	6365
201017	2133	90811268000	26714	13213	5	0	5868
201022	1397	1278293964000	26716	13214	0	0	16053
201024	2132	147309322000	26716	13214	2	0	1679
201025	2134	84204926000	26716	13214	3	0	6366
201029	1397	1278283963000	26718	13215	0	0	16054
201030	2133	90809264000	26718	13215	1	0	5870
201031	2134	84203923000	26718	13215	2	0	6367
201033	2134	84202920000	26719	13216	1	0	6368
201034	2133	90808262000	26719	13216	2	0	5871
201040	1397	1278263961000	26722	13217	0	0	16056
201041	2132	147308321000	26722	13217	1	0	1680
201043	2134	84201917000	26722	13217	3	0	6369
201044	1397	1278253960000	26724	13218	0	0	16057
201045	1397	1278243959000	26724	13218	1	0	16058
201046	1397	1278233958000	26724	13218	2	0	16059
201047	2133	90806258000	26724	13218	3	0	5873
201049	2133	90804254000	26724	13218	5	0	5875
201050	2134	84200914000	26724	13218	6	0	6370
201051	2134	84199911000	26724	13218	7	0	6371
201052	1397	1278223957000	26725	13219	0	0	16060
201053	2134	84198908000	26725	13219	1	0	6372
201055	2132	147307320000	26725	13219	3	0	1681
201056	1397	1278213956000	26726	13220	0	0	16061
201057	2134	84197905000	26726	13220	1	0	6373
201058	2133	90802250000	26726	13220	2	0	5877
201074	1397	1278193954000	26729	13221	1	0	16063
201075	2134	84196902000	26729	13221	2	0	6374
201076	2132	147306319000	26729	13221	3	0	1682
201077	2133	90801248000	26729	13221	4	0	5878
201078	2133	90800246000	26729	13221	5	0	5879
201080	1397	1278183953000	26730	13222	0	0	16064
201081	2134	84194896000	26730	13222	1	0	6376
201082	2133	90799244000	26730	13222	2	0	5880
201094	1397	1278173952000	26734	13223	0	0	16065
201095	1726	963765112000	26734	13223	1	0	8320
201097	1726	962664112000	26734	13223	3	0	8321
201098	2134	84193893000	26734	13223	4	0	6377
201099	1397	1278163951000	26735	13224	0	0	16066
201100	2133	90797240000	26735	13224	1	0	5882
201102	2134	84192890000	26735	13224	3	0	6378
201103	1397	1278153950000	26736	13225	0	0	16067
201104	1397	1278143949000	26736	13225	1	0	16068
201105	2134	84191887000	26736	13225	2	0	6379
201106	2133	90796238000	26736	13225	3	0	5883
201108	2134	84190884000	26736	13225	5	0	6380
201109	1397	1278133948000	26737	13226	0	0	16069
201110	2134	84189881000	26737	13226	1	0	6381
201111	2133	90794234000	26737	13226	2	0	5885
201138	1397	1278123947000	26745	13228	0	0	16070
201140	2133	90793232000	26745	13228	2	0	5886
201141	2134	84188878000	26745	13228	3	0	6382
201142	2134	84187875000	26745	13228	4	0	6383
201143	2133	90792230000	26745	13228	5	0	5887
201152	1724	12653766500000	26747	13125	0	0	\N
201153	1724	12652760500000	26747	13125	1	0	\N
201154	2338	8000000	26747	13125	2	0	\N
201155	2283	199000000	26747	13125	3	0	\N
201156	1726	971472112000	26747	13125	4	0	\N
201157	2335	0	26747	13125	5	0	\N
201158	1726	970371112000	26747	13125	6	0	\N
201159	1726	969270112000	26747	13125	7	0	\N
201160	1726	968169112000	26747	13125	8	0	\N
201161	2337	0	26747	13125	9	0	\N
201162	1726	967068112000	26747	13125	10	0	\N
201163	1726	965967112000	26747	13125	11	0	\N
201164	1726	964866112000	26747	13125	12	0	\N
201165	1726	963765112000	26747	13125	13	0	\N
201166	1726	962664112000	26747	13125	14	0	\N
201167	2351	99000000	26747	13125	15	0	\N
201168	2351	98000000	26747	13125	16	0	\N
201169	2351	97000000	26747	13125	17	0	\N
201170	1397	1278083943000	26748	13230	0	0	\N
201171	2133	90789224000	26748	13230	1	0	\N
201172	2134	84184866000	26748	13230	2	0	\N
201176	1397	1278073942000	26750	13231	0	0	\N
201177	2133	90788222000	26750	13231	1	0	\N
201178	2134	84183863000	26750	13231	2	0	\N
201182	2133	90788222000	26752	13231	0	0	\N
201183	2134	84183863000	26752	13231	1	0	\N
201184	1724	12653766500000	26753	13138	0	0	\N
201185	1724	12652760500000	26753	13138	1	0	\N
201186	2338	8000000	26753	13138	2	0	\N
201187	2283	199000000	26753	13138	3	0	\N
201188	1726	971472112000	26753	13138	4	0	\N
201189	2335	0	26753	13138	5	0	\N
201190	1726	970371112000	26753	13138	6	0	\N
201191	1726	969270112000	26753	13138	7	0	\N
201192	1726	968169112000	26753	13138	8	0	\N
201193	2337	0	26753	13138	9	0	\N
201194	1726	967068112000	26753	13138	10	0	\N
201195	1726	965967112000	26753	13138	11	0	\N
201196	1726	964866112000	26753	13138	12	0	\N
201197	1726	963765112000	26753	13138	13	0	\N
201198	1726	962664112000	26753	13138	14	0	\N
201199	1724	12653766500000	26754	13148	0	0	\N
201200	1724	12652760500000	26754	13148	1	0	\N
201201	2338	8000000	26754	13148	2	0	\N
201202	2283	199000000	26754	13148	3	0	\N
201203	1726	971472112000	26754	13148	4	0	\N
201204	2335	0	26754	13148	5	0	\N
201205	1726	970371112000	26754	13148	6	0	\N
201206	1726	969270112000	26754	13148	7	0	\N
201207	1726	968169112000	26754	13148	8	0	\N
201208	2337	0	26754	13148	9	0	\N
201209	1726	967068112000	26754	13148	10	0	\N
201210	1726	965967112000	26754	13148	11	0	\N
201211	1726	964866112000	26754	13148	12	0	\N
201212	1726	963765112000	26754	13148	13	0	\N
201213	1726	962664112000	26754	13148	14	0	\N
201218	1724	12653766500000	26756	13157	0	0	\N
201219	1724	12652760500000	26756	13157	1	0	\N
201220	2283	199000000	26756	13157	2	0	\N
201221	1726	971472112000	26756	13157	3	0	\N
201222	1726	970371112000	26756	13157	4	0	\N
201223	1726	969270112000	26756	13157	5	0	\N
201224	1726	968169112000	26756	13157	6	0	\N
201225	1726	967068112000	26756	13157	7	0	\N
201226	1726	965967112000	26756	13157	8	0	\N
201227	1726	964866112000	26756	13157	9	0	\N
201228	1726	963765112000	26756	13157	10	0	\N
201229	1726	962664112000	26756	13157	11	0	\N
201230	2283	199000000	26757	13185	0	0	\N
201231	1726	965967112000	26757	13185	1	0	\N
201232	1726	964866112000	26757	13185	2	0	\N
201233	1726	963765112000	26757	13185	3	0	\N
201234	1726	962664112000	26757	13185	4	0	\N
201235	1397	1278053940000	26758	13233	0	0	\N
201236	1397	1278043939000	26758	13233	1	0	\N
201237	2134	84181857000	26758	13233	2	0	\N
201238	2133	90786218000	26758	13233	3	0	\N
201239	2133	90785216000	26758	13233	4	0	\N
201240	2134	84180854000	26758	13233	5	0	\N
201254	1397	1278013936000	26764	13236	0	0	\N
201255	1397	1278003935000	26764	13236	1	0	\N
201256	1397	1277993934000	26764	13236	2	0	\N
201257	2134	84177845000	26764	13236	3	0	\N
201258	2133	90782210000	26764	13236	4	0	\N
201259	2133	90781208000	26764	13236	5	0	\N
201260	2133	90780206000	26764	13236	6	0	\N
201261	2134	84176842000	26764	13236	7	0	\N
201262	2134	84175839000	26764	13236	8	0	\N
201263	2132	147300313000	26764	13236	9	0	\N
201264	1397	1278013936000	26765	13236	0	0	\N
201265	1397	1278003935000	26765	13236	1	0	\N
201266	1397	1277993934000	26765	13236	2	0	\N
201267	2134	84177845000	26765	13236	3	0	\N
201268	2134	84176842000	26765	13236	4	0	\N
201269	2134	84175839000	26765	13236	5	0	\N
201270	2132	147300313000	26765	13236	6	0	\N
201147	2133	90791228000	26746	13229	2	0	5888
201148	2132	147303316000	26746	13229	3	0	1685
201149	2134	84186872000	26746	13229	4	0	6384
201150	2134	84185869000	26746	13229	5	0	6385
201151	2133	90790226000	26746	13229	6	0	5889
201174	2133	90789224000	26749	13230	1	0	5890
201175	2134	84184866000	26749	13230	2	0	6386
201179	1397	1278073942000	26751	13231	0	0	16075
201180	2133	90788222000	26751	13231	1	0	5891
201181	2134	84183863000	26751	13231	2	0	6387
201215	2132	147302315000	26755	13232	1	0	1686
201216	2133	90787220000	26755	13232	2	0	5892
201217	2134	84182860000	26755	13232	3	0	6388
201241	1397	1278053940000	26760	13233	0	0	16077
201243	2134	84181857000	26760	13233	2	0	6389
201244	2133	90786218000	26760	13233	3	0	5893
201245	2133	90785216000	26760	13233	4	0	5894
201246	2134	84180854000	26760	13233	5	0	6390
201247	1397	1278033938000	26762	13234	0	0	16079
201249	2133	90784214000	26762	13234	2	0	5895
201250	1397	1278023937000	26763	13235	0	0	16080
201251	2133	90783212000	26763	13235	1	0	5896
201252	2134	84178848000	26763	13235	2	0	6392
201253	2132	147301314000	26763	13235	3	0	1687
201272	1397	1278003935000	26766	13236	1	0	16082
201273	1397	1277993934000	26766	13236	2	0	16083
201274	2134	84177845000	26766	13236	3	0	6393
201275	2133	90782210000	26766	13236	4	0	5897
201277	2133	90780206000	26766	13236	6	0	5899
201278	2134	84176842000	26766	13236	7	0	6394
201279	2134	84175839000	26766	13236	8	0	6395
201280	2132	147300313000	26766	13236	9	0	1688
201281	1397	1278013936000	26767	13236	0	0	\N
201282	1397	1278003935000	26767	13236	1	0	\N
201283	1397	1277993934000	26767	13236	2	0	\N
201284	2134	84177845000	26767	13236	3	0	\N
201285	2133	90782210000	26767	13236	4	0	\N
201286	2133	90781208000	26767	13236	5	0	\N
201287	2133	90780206000	26767	13236	6	0	\N
201288	2134	84176842000	26767	13236	7	0	\N
201289	2134	84175839000	26767	13236	8	0	\N
201290	2132	147300313000	26767	13236	9	0	\N
201323	1397	1277943929000	26771	13239	0	0	\N
201324	1397	1277933928000	26771	13239	1	0	\N
201325	1397	1277923927000	26771	13239	2	0	\N
201326	1397	1277913926000	26771	13239	3	0	\N
201327	1397	1277903925000	26771	13239	4	0	\N
201328	1397	1277893924000	26771	13239	5	0	\N
201329	2133	90775196000	26771	13239	6	0	\N
201330	2132	147298311000	26771	13239	7	0	\N
201331	2132	147297310000	26771	13239	8	0	\N
201332	2133	90774194000	26771	13239	9	0	\N
201333	2133	90773192000	26771	13239	10	0	\N
201334	2133	90772190000	26771	13239	11	0	\N
201335	2133	90771188000	26771	13239	12	0	\N
201336	2133	90770186000	26771	13239	13	0	\N
201337	2134	84171827000	26771	13239	14	0	\N
201338	2134	84170824000	26771	13239	15	0	\N
201339	2134	84169821000	26771	13239	16	0	\N
201340	2134	84168818000	26771	13239	17	0	\N
201341	2134	84167815000	26771	13239	18	0	\N
201342	2134	84166812000	26771	13239	19	0	\N
201343	1397	1277883923000	26772	13240	0	0	\N
201344	1397	1277873922000	26772	13240	1	0	\N
201345	2133	90769184000	26772	13240	2	0	\N
201346	2133	90768182000	26772	13240	3	0	\N
201347	2134	84165809000	26772	13240	4	0	\N
201348	2134	84164806000	26772	13240	5	0	\N
201349	1397	1277883923000	26773	13240	0	0	\N
201350	1397	1277873922000	26773	13240	1	0	\N
201351	2133	90769184000	26773	13240	2	0	\N
201352	2133	90768182000	26773	13240	3	0	\N
201353	2134	84165809000	26773	13240	4	0	\N
201354	2134	84164806000	26773	13240	5	0	\N
201361	1397	1280004135000	26775	13067	0	0	\N
201362	1397	1279994134000	26775	13067	1	0	\N
201363	1397	1279984133000	26775	13067	2	0	\N
201364	1397	1279974132000	26775	13067	3	0	\N
201365	1397	1279964131000	26775	13067	4	0	\N
201366	1397	1279954130000	26775	13067	5	0	\N
201367	1397	1279944129000	26775	13067	6	0	\N
201368	1397	1279934128000	26775	13067	7	0	\N
201369	1397	1279924127000	26775	13067	8	0	\N
201370	1397	1279914126000	26775	13067	9	0	\N
201371	1397	1279904125000	26775	13067	10	0	\N
201372	1397	1279894124000	26775	13067	11	0	\N
201373	1397	1279884123000	26775	13067	12	0	\N
201374	1397	1279874122000	26775	13067	13	0	\N
201375	1397	1279864121000	26775	13067	14	0	\N
201376	1397	1279854120000	26775	13067	15	0	\N
201377	1397	1279844119000	26775	13067	16	0	\N
201378	1397	1279834118000	26775	13067	17	0	\N
201379	1397	1279824117000	26775	13067	18	0	\N
201380	1397	1279814116000	26775	13067	19	0	\N
201381	1397	1279804115000	26775	13067	20	0	\N
201382	1397	1279794114000	26775	13067	21	0	\N
201383	1397	1279784113000	26775	13067	22	0	\N
201384	1397	1279774112000	26775	13067	23	0	\N
201385	1397	1279764111000	26775	13067	24	0	\N
201386	1397	1279754110000	26775	13067	25	0	\N
201387	1397	1279744109000	26775	13067	26	0	\N
201388	1397	1279734108000	26775	13067	27	0	\N
201389	1397	1279724107000	26775	13067	28	0	\N
201390	1397	1279714106000	26775	13067	29	0	\N
201391	1397	1279704105000	26775	13067	30	0	\N
201392	1397	1279694104000	26775	13067	31	0	\N
201393	1397	1279684103000	26775	13067	32	0	\N
201394	1397	1279674102000	26775	13067	33	0	\N
201395	1397	1279664101000	26775	13067	34	0	\N
201396	1397	1279654100000	26775	13067	35	0	\N
201397	1397	1279644099000	26775	13067	36	0	\N
201398	1397	1279634098000	26775	13067	37	0	\N
201399	1397	1279624097000	26775	13067	38	0	\N
201400	1397	1279614096000	26775	13067	39	0	\N
201401	1397	1279604095000	26775	13067	40	0	\N
201402	1397	1279594094000	26775	13067	41	0	\N
201403	1397	1279584093000	26775	13067	42	0	\N
201404	1397	1279574092000	26775	13067	43	0	\N
201405	1397	1279564091000	26775	13067	44	0	\N
201406	1397	1279554090000	26775	13067	45	0	\N
201407	1397	1279544089000	26775	13067	46	0	\N
201408	1397	1279534088000	26775	13067	47	0	\N
201409	1397	1279524087000	26775	13067	48	0	\N
201410	1397	1279514086000	26775	13067	49	0	\N
201411	1397	1279504085000	26775	13067	50	0	\N
201412	1397	1279494084000	26775	13067	51	0	\N
201413	1397	1279484083000	26775	13067	52	0	\N
201414	1397	1279474082000	26775	13067	53	0	\N
201415	1397	1279464081000	26775	13067	54	0	\N
201416	1397	1279454080000	26775	13067	55	0	\N
201293	2134	84174836000	26768	13237	2	0	6396
201294	2133	90779204000	26768	13237	3	0	5900
201295	2133	90778202000	26768	13237	4	0	5901
201296	2134	84173833000	26768	13237	5	0	6397
201297	1397	1277963931000	26769	13238	0	0	16086
201299	2132	147299312000	26769	13238	2	0	1689
201300	2133	90777200000	26769	13238	3	0	5902
201301	2133	90776198000	26769	13238	4	0	5903
201302	2134	84172830000	26769	13238	5	0	6398
201303	1397	1277943929000	26770	13239	0	0	16088
201305	1397	1277923927000	26770	13239	2	0	16090
201306	1397	1277913926000	26770	13239	3	0	16091
201307	1397	1277903925000	26770	13239	4	0	16092
201308	1397	1277893924000	26770	13239	5	0	16093
201310	2132	147298311000	26770	13239	7	0	1690
201311	2132	147297310000	26770	13239	8	0	1691
201312	2133	90774194000	26770	13239	9	0	5905
201313	2133	90773192000	26770	13239	10	0	5906
201314	2133	90772190000	26770	13239	11	0	5907
201316	2133	90770186000	26770	13239	13	0	5909
201317	2134	84171827000	26770	13239	14	0	6399
201318	2134	84170824000	26770	13239	15	0	6400
201319	2134	84169821000	26770	13239	16	0	6401
201320	2134	84168818000	26770	13239	17	0	6402
201322	2134	84166812000	26770	13239	19	0	6404
201355	1397	1277883923000	26774	13240	0	0	16094
201356	1397	1277873922000	26774	13240	1	0	16095
201357	2133	90769184000	26774	13240	2	0	5910
201359	2134	84165809000	26774	13240	4	0	6405
201360	2134	84164806000	26774	13240	5	0	6406
201417	1397	1279444079000	26775	13067	56	0	\N
201418	1397	1279434078000	26775	13067	57	0	\N
201419	1397	1279424077000	26775	13067	58	0	\N
201420	1397	1279414076000	26775	13067	59	0	\N
201421	1397	1279404075000	26775	13067	60	0	\N
201422	1397	1279394074000	26775	13067	61	0	\N
201423	1397	1279384073000	26775	13067	62	0	\N
201424	1397	1279374072000	26775	13067	63	0	\N
201425	1397	1279364071000	26775	13067	64	0	\N
201426	1397	1279354070000	26775	13067	65	0	\N
201427	1397	1279344069000	26775	13067	66	0	\N
201428	1397	1279334068000	26775	13067	67	0	\N
201429	1397	1279324067000	26775	13067	68	0	\N
201430	1397	1279314066000	26775	13067	69	0	\N
201431	1397	1279304065000	26775	13067	70	0	\N
201432	1397	1279294064000	26775	13067	71	0	\N
201433	1397	1279284063000	26775	13067	72	0	\N
201434	1397	1279274062000	26775	13067	73	0	\N
201435	1397	1279264061000	26775	13067	74	0	\N
201436	1397	1279254060000	26775	13067	75	0	\N
201437	1397	1279244059000	26775	13067	76	0	\N
201438	1397	1279234058000	26775	13067	77	0	\N
201439	1397	1279224057000	26775	13067	78	0	\N
201440	1397	1279214056000	26775	13067	79	0	\N
201441	1397	1279204055000	26775	13067	80	0	\N
201442	1397	1279194054000	26775	13067	81	0	\N
201443	1397	1279184053000	26775	13067	82	0	\N
201444	1397	1279174052000	26775	13067	83	0	\N
201445	1397	1279164051000	26775	13067	84	0	\N
201446	1397	1279154050000	26775	13067	86	0	\N
201447	1397	1279144049000	26775	13067	87	0	\N
201448	1397	1279134048000	26775	13067	88	0	\N
201449	1397	1279124047000	26775	13067	89	0	\N
201450	1397	1279114046000	26775	13067	90	0	\N
201451	1397	1279104045000	26775	13067	91	0	\N
201452	1397	1279094044000	26775	13067	92	0	\N
201453	1397	1279084043000	26775	13067	93	0	\N
201454	1397	1279074042000	26775	13067	94	0	\N
201455	1397	1279064041000	26775	13067	95	0	\N
201456	1397	1279054040000	26775	13067	96	0	\N
201457	1397	1279044039000	26775	13067	97	0	\N
201458	1397	1279034038000	26775	13067	98	0	\N
201459	1397	1279024037000	26775	13067	99	0	\N
201460	1397	1279014036000	26775	13067	100	0	\N
201461	1397	1279004035000	26775	13067	101	0	\N
201462	1397	1278994034000	26775	13067	102	0	\N
201463	1397	1278984033000	26775	13067	103	0	\N
201464	1397	1278974032000	26775	13067	104	0	\N
201465	1397	1278964031000	26775	13067	105	0	\N
201466	1397	1278954030000	26775	13067	106	0	\N
201467	1397	1278944029000	26775	13067	107	0	\N
201468	1397	1278934028000	26775	13067	108	0	\N
201469	1397	1278924027000	26775	13067	109	0	\N
201470	1397	1278914026000	26775	13067	110	0	\N
201471	1397	1278904025000	26775	13067	111	0	\N
201472	1397	1278894024000	26775	13067	112	0	\N
201473	1397	1278884023000	26775	13067	113	0	\N
201474	1397	1278874022000	26775	13067	114	0	\N
201475	1397	1278864021000	26775	13067	115	0	\N
201476	1397	1278854020000	26775	13067	116	0	\N
201477	1397	1278844019000	26775	13067	117	0	\N
201478	1397	1278834018000	26775	13067	118	0	\N
201479	1397	1278824017000	26775	13067	119	0	\N
201480	1397	1278814016000	26775	13067	120	0	\N
201481	1397	1278804015000	26775	13067	121	0	\N
201482	1397	1278794014000	26775	13067	122	0	\N
201483	1397	1278784013000	26775	13067	123	0	\N
201484	1397	1278774012000	26775	13067	124	0	\N
201485	1397	1278764011000	26775	13067	125	0	\N
201486	1397	1280004135000	26776	13029	0	0	\N
201487	1397	1279994134000	26776	13029	1	0	\N
201488	1397	1279984133000	26776	13029	2	0	\N
201489	1397	1279974132000	26776	13029	3	0	\N
201490	1397	1279964131000	26776	13029	4	0	\N
201491	1397	1279954130000	26776	13029	5	0	\N
201492	1397	1279944129000	26776	13029	6	0	\N
201493	1397	1279934128000	26776	13029	7	0	\N
201494	1397	1279924127000	26776	13029	8	0	\N
201495	1397	1279914126000	26776	13029	9	0	\N
201496	1397	1279904125000	26776	13029	10	0	\N
201497	1397	1279894124000	26776	13029	11	0	\N
201498	1397	1279884123000	26776	13029	12	0	\N
201499	1397	1279874122000	26776	13029	13	0	\N
201500	1397	1279864121000	26776	13029	14	0	\N
201501	1397	1279854120000	26776	13029	15	0	\N
201502	1397	1279844119000	26776	13029	16	0	\N
201503	1397	1279834118000	26776	13029	17	0	\N
201504	1397	1279824117000	26776	13029	18	0	\N
201505	1397	1279814116000	26776	13029	19	0	\N
201506	1397	1279804115000	26776	13029	20	0	\N
201507	1397	1279794114000	26776	13029	21	0	\N
201508	1397	1279784113000	26776	13029	22	0	\N
201509	1397	1279774112000	26776	13029	23	0	\N
201510	1397	1279764111000	26776	13029	24	0	\N
201511	1397	1279754110000	26776	13029	25	0	\N
201512	1397	1279744109000	26776	13029	26	0	\N
201513	1397	1279734108000	26776	13029	27	0	\N
201514	1397	1279724107000	26776	13029	28	0	\N
201515	1397	1279714106000	26776	13029	29	0	\N
201516	1397	1279704105000	26776	13029	30	0	\N
201517	1397	1279694104000	26776	13029	31	0	\N
201518	1397	1279684103000	26776	13029	32	0	\N
201519	1397	1279674102000	26776	13029	33	0	\N
201520	1397	1279664101000	26776	13029	34	0	\N
201521	1397	1279654100000	26776	13029	35	0	\N
201522	1397	1279644099000	26776	13029	36	0	\N
201523	1397	1279634098000	26776	13029	37	0	\N
201524	1397	1279624097000	26776	13029	38	0	\N
201525	1397	1279614096000	26776	13029	39	0	\N
201526	1397	1279604095000	26776	13029	40	0	\N
201527	1397	1279594094000	26776	13029	41	0	\N
201528	1397	1279584093000	26776	13029	42	0	\N
201529	1397	1279574092000	26776	13029	43	0	\N
201530	1397	1279564091000	26776	13029	44	0	\N
201531	1397	1279554090000	26776	13029	45	0	\N
201532	1397	1279544089000	26776	13029	46	0	\N
201533	1397	1279534088000	26776	13029	47	0	\N
201534	1397	1279524087000	26776	13029	48	0	\N
201535	1397	1279514086000	26776	13029	49	0	\N
201536	1397	1279504085000	26776	13029	50	0	\N
201537	1397	1279494084000	26776	13029	51	0	\N
201538	1397	1279484083000	26776	13029	52	0	\N
201539	1397	1279474082000	26776	13029	53	0	\N
201540	1397	1279464081000	26776	13029	54	0	\N
201541	1397	1279454080000	26776	13029	55	0	\N
201542	1397	1279444079000	26776	13029	57	0	\N
201543	1397	1279434078000	26776	13029	58	0	\N
201544	1397	1279424077000	26776	13029	59	0	\N
201545	1397	1279414076000	26776	13029	60	0	\N
201546	1397	1279404075000	26776	13029	61	0	\N
201547	1397	1279394074000	26776	13029	62	0	\N
201548	1397	1279384073000	26776	13029	63	0	\N
201549	1397	1279374072000	26776	13029	64	0	\N
201550	1397	1279364071000	26776	13029	65	0	\N
201551	1397	1279354070000	26776	13029	66	0	\N
201552	1397	1279344069000	26776	13029	67	0	\N
201553	1397	1279334068000	26776	13029	68	0	\N
201554	1397	1279324067000	26776	13029	69	0	\N
201555	1397	1279314066000	26776	13029	70	0	\N
201556	1397	1279304065000	26776	13029	71	0	\N
201557	1397	1279294064000	26776	13029	72	0	\N
201558	1397	1279284063000	26776	13029	73	0	\N
201559	1397	1279274062000	26776	13029	74	0	\N
201560	1397	1279264061000	26776	13029	75	0	\N
201561	1397	1279254060000	26776	13029	76	0	\N
201562	1397	1279244059000	26776	13029	77	0	\N
201563	1397	1279234058000	26776	13029	78	0	\N
201564	1397	1279224057000	26776	13029	79	0	\N
201565	1397	1279214056000	26776	13029	80	0	\N
201566	1397	1279204055000	26776	13029	81	0	\N
201567	1397	1279194054000	26776	13029	82	0	\N
201568	1397	1279184053000	26776	13029	83	0	\N
201569	1397	1279174052000	26776	13029	84	0	\N
201570	1397	1279164051000	26776	13029	85	0	\N
201571	1397	1279154050000	26776	13029	86	0	\N
201572	1397	1279144049000	26776	13029	87	0	\N
201573	1397	1279134048000	26776	13029	88	0	\N
201574	1397	1279124047000	26776	13029	89	0	\N
201575	1397	1279114046000	26776	13029	90	0	\N
201576	1397	1279104045000	26776	13029	91	0	\N
201577	1397	1279094044000	26776	13029	92	0	\N
201578	1397	1279084043000	26776	13029	93	0	\N
201579	1397	1279074042000	26776	13029	94	0	\N
201580	1397	1279064041000	26776	13029	95	0	\N
201581	1397	1279054040000	26776	13029	96	0	\N
201582	1397	1279044039000	26776	13029	97	0	\N
201583	1397	1279034038000	26776	13029	98	0	\N
201584	1397	1279024037000	26776	13029	99	0	\N
201585	1397	1279014036000	26776	13029	100	0	\N
201586	1397	1279004035000	26776	13029	101	0	\N
201587	1397	1278994034000	26776	13029	102	0	\N
201588	1397	1278984033000	26776	13029	103	0	\N
201589	1397	1278974032000	26776	13029	104	0	\N
201590	1397	1278964031000	26776	13029	105	0	\N
201591	1397	1278954030000	26776	13029	106	0	\N
201592	1397	1278944029000	26776	13029	107	0	\N
201593	1397	1278934028000	26776	13029	108	0	\N
201594	1397	1278924027000	26776	13029	109	0	\N
201595	1397	1278914026000	26776	13029	110	0	\N
201596	1397	1278904025000	26776	13029	111	0	\N
201597	1397	1278894024000	26776	13029	112	0	\N
201598	1397	1278884023000	26776	13029	113	0	\N
201599	1397	1278874022000	26776	13029	114	0	\N
201600	1397	1278864021000	26776	13029	115	0	\N
201601	1397	1278854020000	26776	13029	116	0	\N
201602	1397	1278844019000	26776	13029	117	0	\N
201603	1397	1278834018000	26776	13029	118	0	\N
201604	1397	1278824017000	26776	13029	119	0	\N
201605	1397	1278814016000	26776	13029	120	0	\N
201606	1397	1278804015000	26776	13029	121	0	\N
201607	1397	1278794014000	26776	13029	122	0	\N
201608	1397	1278784013000	26776	13029	123	0	\N
201609	1397	1278774012000	26776	13029	124	0	\N
201610	1397	1278764011000	26776	13029	125	0	\N
201630	1726	961563112000	26780	13243	0	0	\N
201631	1726	960462112000	26780	13243	1	0	\N
201632	2132	147295308000	26780	13243	2	0	\N
201633	1397	1277813916000	26781	13244	0	0	\N
201634	2133	90762170000	26781	13244	1	0	\N
201635	2134	84158788000	26781	13244	2	0	\N
201639	1397	1277803915000	26783	13245	0	0	\N
201640	2133	90761168000	26783	13245	1	0	\N
201641	2134	84157785000	26783	13245	2	0	\N
201642	1724	12653766500000	26784	13094	0	0	\N
201643	1724	12652760500000	26784	13094	1	0	\N
201644	2283	199000000	26784	13094	2	0	\N
201645	2335	0	26784	13094	3	0	\N
201646	2337	0	26784	13094	4	0	\N
201647	2132	147361374000	26784	13094	5	0	\N
201648	2132	147360373000	26784	13094	6	0	\N
201649	2132	147359372000	26784	13094	7	0	\N
201650	2132	147358371000	26784	13094	8	0	\N
201651	2132	147357370000	26784	13094	9	0	\N
201652	2132	147356369000	26784	13094	10	0	\N
201653	2132	147355368000	26784	13094	11	0	\N
201654	2132	147354367000	26784	13094	12	0	\N
201655	2132	147353366000	26784	13094	13	0	\N
201656	2132	147352365000	26784	13094	14	0	\N
201657	2132	147351364000	26784	13094	15	0	\N
201658	2132	147350363000	26784	13094	16	0	\N
201659	2132	147349362000	26784	13094	17	0	\N
201660	2132	147348361000	26784	13094	18	0	\N
201664	1397	1277793914000	26786	13246	0	0	\N
201665	2133	90760166000	26786	13246	1	0	\N
201666	2132	147294307000	26786	13246	2	0	\N
201667	2134	84156782000	26786	13246	3	0	\N
201668	1397	1277793914000	26787	13246	0	0	\N
201669	2133	90760166000	26787	13246	1	0	\N
201670	2132	147294307000	26787	13246	2	0	\N
201671	2134	84156782000	26787	13246	3	0	\N
201676	1397	1277783913000	26789	13247	0	0	\N
201677	2133	90759164000	26789	13247	1	0	\N
201678	2134	84155779000	26789	13247	2	0	\N
201682	1397	1277783913000	26791	13247	0	0	\N
201683	2133	90759164000	26791	13247	1	0	\N
201684	2134	84155779000	26791	13247	2	0	\N
201613	2132	147296309000	26777	13241	2	0	1692
201614	2133	90767180000	26777	13241	3	0	5912
201615	1397	1277853920000	26778	13242	0	0	16097
201616	2134	84162800000	26778	13242	1	0	6408
201617	2133	90766178000	26778	13242	2	0	5913
201619	1397	1277833918000	26779	13243	1	0	16099
201620	1397	1277823917000	26779	13243	2	0	16100
201621	2133	90765176000	26779	13243	3	0	5914
201622	2134	84161797000	26779	13243	5	0	6409
201623	1726	961563112000	26779	13243	6	0	8322
201625	2133	90764174000	26779	13243	8	0	5915
201626	2133	90763172000	26779	13243	9	0	5916
201627	2134	84160794000	26779	13243	10	0	6410
201628	2134	84159791000	26779	13243	11	0	6411
201636	1397	1277813916000	26782	13244	0	0	16101
201637	2133	90762170000	26782	13244	1	0	5917
201638	2134	84158788000	26782	13244	2	0	6412
201661	1397	1277803915000	26785	13245	0	0	16102
201662	2133	90761168000	26785	13245	1	0	5918
201672	1397	1277793914000	26788	13246	0	0	16103
201673	2133	90760166000	26788	13246	1	0	5919
201674	2132	147294307000	26788	13246	2	0	1694
201675	2134	84156782000	26788	13246	3	0	6414
201679	1397	1277783913000	26790	13247	0	0	16104
201681	2134	84155779000	26790	13247	2	0	6415
201685	1397	1277773912000	26792	13248	0	0	16105
201686	1397	1277763911000	26792	13248	1	0	16106
201687	1397	1277753910000	26792	13248	2	0	16107
201695	1397	1277743909000	26793	13249	0	0	\N
201696	2134	84151767000	26793	13249	1	0	\N
201697	2133	90755156000	26793	13249	2	0	\N
201698	1397	1277743909000	26794	13249	0	0	\N
201699	2134	84151767000	26794	13249	1	0	\N
201700	2133	90755156000	26794	13249	2	0	\N
201701	1397	1277743909000	26795	13249	0	0	\N
201702	2134	84151767000	26795	13249	1	0	\N
201703	2133	90755156000	26795	13249	2	0	\N
201707	1397	1277733908000	26797	13250	0	0	\N
201708	2133	90754154000	26797	13250	1	0	\N
201715	1397	1277713906000	26800	13252	0	0	\N
201716	2133	90752150000	26800	13252	1	0	\N
201717	2134	84149761000	26800	13252	2	0	\N
201724	1397	1277703905000	26803	13253	0	0	\N
201725	2133	90751148000	26803	13253	1	0	\N
201726	2134	84148758000	26803	13253	2	0	\N
201748	1397	1277633898000	26808	13258	0	0	\N
201749	2133	90744134000	26808	13258	1	0	\N
201750	2134	84141737000	26808	13258	2	0	\N
201751	1397	1277633898000	26809	13258	0	0	\N
201752	2133	90744134000	26809	13258	1	0	\N
201753	2134	84141737000	26809	13258	2	0	\N
201754	1397	1277633898000	26810	13258	0	0	\N
201755	2133	90744134000	26810	13258	1	0	\N
201756	2134	84141737000	26810	13258	2	0	\N
201767	1397	1277623897000	26813	13259	0	0	\N
201768	1397	1277613896000	26813	13259	1	0	\N
201769	2132	147289302000	26813	13259	2	0	\N
201770	2133	90743132000	26813	13259	3	0	\N
201771	2133	90742130000	26813	13259	4	0	\N
201772	2134	84140734000	26813	13259	5	0	\N
201773	2134	84139731000	26813	13259	6	0	\N
201787	1397	1277563891000	26815	13261	0	0	\N
201788	2134	84134716000	26815	13261	2	0	\N
201789	2132	147287300000	26815	13261	3	0	\N
201790	2133	90737120000	26815	13261	4	0	\N
201798	134	66000090000000	26818	13262	0	0	\N
201799	1397	1277553890000	26818	13262	1	0	\N
201800	2134	84133713000	26818	13262	2	0	\N
201801	2133	90736118000	26818	13262	3	0	\N
201802	1397	1277553890000	26819	13263	0	0	\N
201803	1397	1277543889000	26819	13263	1	0	\N
201804	2134	84132710000	26819	13263	2	0	\N
201805	2133	90735116000	26819	13263	3	0	\N
201810	1397	1279304065000	26821	13144	0	0	\N
201811	1397	1279294064000	26821	13144	1	0	\N
201812	1397	1279284063000	26821	13144	2	0	\N
201813	1397	1279274062000	26821	13144	3	0	\N
201814	1397	1279264061000	26821	13144	4	0	\N
201815	1397	1279254060000	26821	13144	5	0	\N
201816	1397	1279244059000	26821	13144	6	0	\N
201817	1397	1279234058000	26821	13144	7	0	\N
201818	1397	1279224057000	26821	13144	8	0	\N
201819	1397	1279214056000	26821	13144	9	0	\N
201820	1397	1279204055000	26821	13144	10	0	\N
201821	1397	1279194054000	26821	13144	11	0	\N
201822	1397	1279184053000	26821	13144	12	0	\N
201823	1397	1279174052000	26821	13144	13	0	\N
201824	1397	1279164051000	26821	13144	14	0	\N
201691	2133	90756158000	26792	13248	6	0	5923
201692	2134	84154776000	26792	13248	7	0	6416
201693	2134	84153773000	26792	13248	8	0	6417
201694	2134	84152770000	26792	13248	9	0	6418
201704	1397	1277743909000	26796	13249	0	0	16108
201706	2133	90755156000	26796	13249	2	0	5924
201709	1397	1277733908000	26798	13250	0	0	16109
201710	2133	90754154000	26798	13250	1	0	5925
201711	1397	1277723907000	26799	13251	0	0	16110
201712	2132	147292305000	26799	13251	1	0	1696
201714	2133	90753152000	26799	13251	3	0	5926
201718	1397	1277713906000	26801	13252	0	0	16111
201719	2133	90752150000	26801	13252	1	0	5927
201720	2134	84149761000	26801	13252	2	0	6421
201722	2133	90751148000	26802	13253	1	0	5928
201723	2134	84148758000	26802	13253	2	0	6422
201727	1397	1277693904000	26804	13254	0	0	16113
201728	2134	84147755000	26804	13254	1	0	6423
201729	2133	90750146000	26804	13254	2	0	5929
201731	1693	9350954570272	26805	13255	0	0	1249
201732	1397	1277683903000	26805	13255	1	0	16114
201733	2133	90749144000	26805	13255	2	0	5930
201734	2134	84146752000	26805	13255	3	0	6424
201735	1397	1277673902000	26806	13256	0	0	16115
201737	1397	1277653900000	26806	13256	2	0	16117
201738	2132	147290303000	26806	13256	3	0	1698
201739	2133	90748142000	26806	13256	4	0	5931
201740	2133	90747140000	26806	13256	5	0	5932
201742	2134	84144746000	26806	13256	7	0	6426
201743	2134	84143743000	26806	13256	8	0	6427
201744	2133	90746138000	26806	13256	9	0	5933
201745	1397	1277643899000	26807	13257	0	0	16118
201746	2134	84142740000	26807	13257	1	0	6428
201757	1397	1277633898000	26811	13258	0	0	16119
201758	2133	90744134000	26811	13258	1	0	5935
201759	2134	84141737000	26811	13258	2	0	6429
201760	1397	1277623897000	26812	13259	0	0	16120
201761	1397	1277613896000	26812	13259	1	0	16121
201763	2133	90743132000	26812	13259	3	0	5936
201764	2133	90742130000	26812	13259	4	0	5937
201765	2134	84140734000	26812	13259	5	0	6430
201766	2134	84139731000	26812	13259	6	0	6431
201775	1397	1277593894000	26814	13260	1	0	16123
201776	1397	1277583893000	26814	13260	2	0	16124
201777	1397	1277573892000	26814	13260	3	0	16125
201778	2132	147288301000	26814	13260	4	0	1700
201779	2134	84138728000	26814	13260	5	0	6432
201781	2134	84136722000	26814	13260	7	0	6434
201782	2134	84135719000	26814	13260	8	0	6435
201783	2133	90741128000	26814	13260	9	0	5938
201784	2133	90740126000	26814	13260	10	0	5939
201785	2133	90739124000	26814	13260	11	0	5940
201791	1397	1277563891000	26816	13261	0	0	16126
201792	2134	84134716000	26816	13261	2	0	6436
201793	2132	147287300000	26816	13261	3	0	1701
201794	2133	90737120000	26816	13261	4	0	5942
201796	2134	84133713000	26817	13262	1	0	6437
201797	2133	90736118000	26817	13262	2	0	5943
201806	1397	1277553890000	26820	13263	0	0	16127
201807	1397	1277543889000	26820	13263	1	0	16128
201808	2134	84132710000	26820	13263	2	0	6438
201825	1397	1279154050000	26821	13144	15	0	\N
201826	1397	1279144049000	26821	13144	16	0	\N
201827	1397	1279134048000	26821	13144	17	0	\N
201828	1397	1279124047000	26821	13144	18	0	\N
201829	1397	1279114046000	26821	13144	19	0	\N
201830	1397	1279104045000	26821	13144	20	0	\N
201831	1397	1279094044000	26821	13144	21	0	\N
201832	1397	1279084043000	26821	13144	22	0	\N
201833	1397	1279074042000	26821	13144	23	0	\N
201834	1397	1279064041000	26821	13144	24	0	\N
201835	1397	1279054040000	26821	13144	25	0	\N
201836	1397	1279044039000	26821	13144	26	0	\N
201837	1397	1279034038000	26821	13144	27	0	\N
201838	1397	1279024037000	26821	13144	28	0	\N
201839	1397	1279014036000	26821	13144	29	0	\N
201840	1397	1279004035000	26821	13144	30	0	\N
201841	1397	1278994034000	26821	13144	31	0	\N
201842	1397	1278984033000	26821	13144	32	0	\N
201843	1397	1278974032000	26821	13144	33	0	\N
201844	1397	1278964031000	26821	13144	34	0	\N
201845	1397	1278954030000	26821	13144	35	0	\N
201846	1397	1278944029000	26821	13144	36	0	\N
201847	1397	1278934028000	26821	13144	37	0	\N
201848	1397	1278924027000	26821	13144	38	0	\N
201849	1397	1278914026000	26821	13144	39	0	\N
201850	1397	1278904025000	26821	13144	40	0	\N
201851	1397	1278894024000	26821	13144	41	0	\N
201852	1397	1278884023000	26821	13144	42	0	\N
201853	1397	1278874022000	26821	13144	43	0	\N
201854	1397	1278864021000	26821	13144	44	0	\N
201855	1397	1278854020000	26821	13144	45	0	\N
201856	1397	1278844019000	26821	13144	46	0	\N
201857	1397	1278834018000	26821	13144	47	0	\N
201858	1397	1278824017000	26821	13144	48	0	\N
201859	1397	1278814016000	26821	13144	49	0	\N
201860	1397	1278804015000	26821	13144	50	0	\N
201861	1397	1278794014000	26821	13144	51	0	\N
201862	1397	1278784013000	26821	13144	52	0	\N
201863	1397	1278774012000	26821	13144	53	0	\N
201864	1397	1278764011000	26821	13144	54	0	\N
201865	1397	1278754010000	26821	13144	55	0	\N
201866	1397	1278744009000	26821	13144	56	0	\N
201867	1397	1278734008000	26821	13144	57	0	\N
201868	1397	1278724007000	26821	13144	58	0	\N
201869	1397	1278714006000	26821	13144	59	0	\N
201870	1397	1278704005000	26821	13144	60	0	\N
201871	1397	1278694004000	26821	13144	61	0	\N
201872	1397	1278684003000	26821	13144	62	0	\N
201873	1397	1278674002000	26821	13144	63	0	\N
201874	1397	1278664001000	26821	13144	64	0	\N
201875	1397	1278654000000	26821	13144	65	0	\N
201876	1397	1278643999000	26821	13144	66	0	\N
201877	1397	1278633998000	26821	13144	67	0	\N
201878	1397	1278623997000	26821	13144	68	0	\N
201882	1693	7190916570272	26823	13126	0	0	\N
201883	1726	961563112000	26823	13126	1	0	\N
201884	1726	960462112000	26823	13126	2	0	\N
201885	1397	1277523887000	26824	13265	0	0	\N
201886	2132	147286299000	26824	13265	1	0	\N
201887	2134	84130704000	26824	13265	2	0	\N
201888	2133	90733112000	26824	13265	3	0	\N
201889	1397	1277523887000	26825	13265	0	0	\N
201890	2132	147286299000	26825	13265	1	0	\N
201891	2134	84130704000	26825	13265	2	0	\N
201892	2133	90733112000	26825	13265	3	0	\N
201893	1397	1277523887000	26826	13265	0	0	\N
201894	2132	147286299000	26826	13265	1	0	\N
201895	2134	84130704000	26826	13265	2	0	\N
201896	2133	90733112000	26826	13265	3	0	\N
201906	1397	1277493884000	26830	13268	0	0	\N
201907	2132	147285298000	26830	13268	1	0	\N
201908	2133	90730106000	26830	13268	2	0	\N
201909	2134	84128698000	26830	13268	3	0	\N
201914	1397	1277483883000	26832	13269	0	0	\N
201915	2134	84127695000	26832	13269	1	0	\N
201916	2133	90729104000	26832	13269	2	0	\N
201920	1397	1277483883000	26834	13269	0	0	\N
201921	2134	84127695000	26834	13269	1	0	\N
201935	1397	1277433878000	26837	13272	0	0	\N
201936	2133	90724094000	26837	13272	1	0	\N
201937	2134	84122680000	26837	13272	2	0	\N
201941	1397	1277423877000	26839	13273	0	0	\N
201942	2134	84121677000	26839	13273	1	0	\N
201943	2132	147283296000	26839	13273	2	0	\N
201944	2133	90723092000	26839	13273	3	0	\N
201952	1397	1277403875000	26842	13275	0	0	\N
201953	2134	84119671000	26842	13275	1	0	\N
201954	2133	90721088000	26842	13275	2	0	\N
201881	2134	84131707000	26822	13264	2	0	6439
201897	1397	1277523887000	26827	13265	0	0	16130
201898	2132	147286299000	26827	13265	1	0	1702
201899	2134	84130704000	26827	13265	2	0	6440
201900	2133	90733112000	26827	13265	3	0	5946
201902	2133	90732110000	26828	13266	1	0	5947
201903	1397	1277503885000	26829	13267	0	0	16132
201904	2133	90731108000	26829	13267	1	0	5948
201905	2134	84129701000	26829	13267	2	0	6441
201910	1397	1277493884000	26831	13268	0	0	16133
201912	2133	90730106000	26831	13268	2	0	5949
201913	2134	84128698000	26831	13268	3	0	6442
201917	1397	1277483883000	26833	13269	0	0	16134
201918	2134	84127695000	26833	13269	1	0	6443
201922	1397	1277473882000	26835	13270	0	0	16135
201923	1397	1277463881000	26835	13270	1	0	16136
201924	1397	1277453880000	26835	13270	2	0	16137
201925	2133	90728102000	26835	13270	3	0	5951
201926	2134	84126692000	26835	13270	4	0	6444
201928	2134	84124686000	26835	13270	6	0	6446
201929	2132	147284297000	26835	13270	7	0	1704
201930	2133	90727100000	26835	13270	8	0	5952
201931	2133	90726098000	26835	13270	9	0	5953
201932	1397	1277443879000	26836	13271	0	0	16138
201934	2134	84123683000	26836	13271	2	0	6447
201938	1397	1277433878000	26838	13272	0	0	16139
201939	2133	90724094000	26838	13272	1	0	5955
201940	2134	84122680000	26838	13272	2	0	6448
201946	2134	84121677000	26840	13273	1	0	6449
201947	2132	147283296000	26840	13273	2	0	1705
201948	2133	90723092000	26840	13273	3	0	5956
201949	1397	1277413876000	26841	13274	0	0	16141
201950	2133	90722090000	26841	13274	1	0	5957
201955	1397	1277403875000	26843	13275	0	0	16142
201956	2134	84119671000	26843	13275	1	0	6451
201957	2133	90721088000	26843	13275	2	0	5958
201958	1397	1277393874000	26844	13276	0	0	16143
201959	2133	90720086000	26844	13276	1	0	5959
201987	1397	1277313866000	26849	13280	0	0	\N
201988	2133	90712070000	26849	13280	1	0	\N
201989	2134	84111647000	26849	13280	2	0	\N
202000	1397	1277273862000	26852	13283	0	0	\N
202001	2134	84107635000	26852	13283	1	0	\N
202002	2133	90708062000	26852	13283	2	0	\N
202006	1397	1277273862000	26854	13283	0	0	\N
202007	2134	84107635000	26854	13283	1	0	\N
202008	2133	90708062000	26854	13283	2	0	\N
202009	1397	1277273862000	26855	13283	0	0	\N
202010	2134	84107635000	26855	13283	1	0	\N
202011	2133	90708062000	26855	13283	2	0	\N
202012	1693	9350954570272	26856	13245	0	0	\N
202013	1397	1277803915000	26856	13245	1	0	\N
202014	1397	1277793914000	26856	13245	2	0	\N
202015	1397	1277783913000	26856	13245	3	0	\N
202016	1397	1277773912000	26856	13245	4	0	\N
202017	1397	1277763911000	26856	13245	5	0	\N
202018	1397	1277753910000	26856	13245	6	0	\N
202019	1397	1277743909000	26856	13245	7	0	\N
202020	1397	1277733908000	26856	13245	8	0	\N
202021	1397	1277723907000	26856	13245	9	0	\N
202022	1397	1277713906000	26856	13245	10	0	\N
202023	1397	1277703905000	26856	13245	11	0	\N
202024	1397	1277693904000	26856	13245	12	0	\N
202025	1397	1277683903000	26856	13245	13	0	\N
202026	1397	1277673902000	26856	13245	14	0	\N
202027	1397	1277663901000	26856	13245	15	0	\N
202028	1397	1277653900000	26856	13245	16	0	\N
202029	1397	1277643899000	26856	13245	17	0	\N
202030	1397	1277633898000	26856	13245	18	0	\N
202031	1397	1277623897000	26856	13245	19	0	\N
202032	1397	1277613896000	26856	13245	20	0	\N
202033	1397	1277603895000	26856	13245	21	0	\N
202034	1397	1277593894000	26856	13245	22	0	\N
202035	1397	1277583893000	26856	13245	23	0	\N
202036	1397	1277573892000	26856	13245	24	0	\N
202037	1397	1277563891000	26856	13245	25	0	\N
202038	1397	1277553890000	26856	13245	26	0	\N
202039	1397	1277543889000	26856	13245	27	0	\N
202040	1397	1277533888000	26856	13245	28	0	\N
202041	1397	1277523887000	26856	13245	29	0	\N
202042	1397	1277513886000	26856	13245	30	0	\N
202043	1397	1277503885000	26856	13245	31	0	\N
202044	1397	1277493884000	26856	13245	32	0	\N
202045	1397	1277483883000	26856	13245	33	0	\N
202046	1397	1277473882000	26856	13245	34	0	\N
202047	1397	1277463881000	26856	13245	35	0	\N
202048	1397	1277453880000	26856	13245	36	0	\N
202049	1397	1277443879000	26856	13245	37	0	\N
202050	1397	1277433878000	26856	13245	38	0	\N
202051	1397	1277423877000	26856	13245	39	0	\N
202052	1397	1277413876000	26856	13245	40	0	\N
202053	1397	1277403875000	26856	13245	41	0	\N
202054	1397	1277393874000	26856	13245	42	0	\N
202055	1397	1277383873000	26856	13245	43	0	\N
202056	1397	1277373872000	26856	13245	44	0	\N
202057	1397	1277363871000	26856	13245	45	0	\N
202058	1397	1277353870000	26856	13245	46	0	\N
202059	1397	1277343869000	26856	13245	47	0	\N
202060	1397	1277333868000	26856	13245	48	0	\N
202061	1397	1277323867000	26856	13245	49	0	\N
202062	1397	1277313866000	26856	13245	50	0	\N
202063	1397	1277303865000	26856	13245	51	0	\N
202064	1397	1277293864000	26856	13245	52	0	\N
202065	1397	1277283863000	26856	13245	53	0	\N
202066	1397	1277273862000	26856	13245	54	0	\N
202067	2133	90761168000	26856	13245	55	0	\N
202068	2133	90760166000	26856	13245	56	0	\N
202069	2133	90759164000	26856	13245	57	0	\N
202070	2133	90758162000	26856	13245	58	0	\N
202071	2133	90757160000	26856	13245	59	0	\N
202072	2133	90756158000	26856	13245	60	0	\N
202073	2134	84157785000	26856	13245	61	0	\N
202074	2133	90755156000	26856	13245	62	0	\N
202075	2133	90754154000	26856	13245	63	0	\N
202076	2133	90753152000	26856	13245	64	0	\N
202077	2133	90752150000	26856	13245	65	0	\N
202078	2133	90751148000	26856	13245	66	0	\N
202079	2133	90750146000	26856	13245	67	0	\N
202080	2133	90749144000	26856	13245	68	0	\N
202081	2133	90748142000	26856	13245	69	0	\N
202082	2133	90747140000	26856	13245	70	0	\N
202083	2132	147294307000	26856	13245	71	0	\N
202084	2132	147293306000	26856	13245	72	0	\N
202085	2132	147292305000	26856	13245	73	0	\N
202086	2132	147291304000	26856	13245	74	0	\N
202087	2132	147290303000	26856	13245	75	0	\N
202088	2132	147289302000	26856	13245	76	0	\N
202089	2132	147288301000	26856	13245	77	0	\N
202090	2132	147287300000	26856	13245	78	0	\N
202091	2132	147286299000	26856	13245	79	0	\N
202092	2132	147285298000	26856	13245	80	0	\N
202093	2132	147284297000	26856	13245	81	0	\N
202094	2132	147283296000	26856	13245	82	0	\N
202095	2132	147282295000	26856	13245	83	0	\N
202096	2132	147281294000	26856	13245	84	0	\N
201963	1397	1277373872000	26845	13277	1	0	16145
201964	1397	1277363871000	26845	13277	2	0	16146
201965	1397	1277353870000	26845	13277	3	0	16147
201966	2133	90719084000	26845	13277	4	0	5960
201967	2134	84117665000	26845	13277	5	0	6453
201969	2133	90717080000	26845	13277	7	0	5962
201970	2133	90716078000	26845	13277	8	0	5963
201971	2132	147281294000	26845	13277	9	0	1707
201972	2134	84116662000	26845	13277	10	0	6454
201973	2134	84115659000	26845	13277	11	0	6455
201975	1397	1277343869000	26846	13278	0	0	16148
201976	2133	90715076000	26846	13278	1	0	5964
201977	1397	1277333868000	26847	13279	0	0	16149
201978	1397	1277323867000	26847	13279	1	0	16150
201980	2133	90714074000	26847	13279	3	0	5965
201981	2134	84112650000	26847	13279	4	0	6458
201982	2133	90713072000	26847	13279	5	0	5966
201983	2132	147280293000	26847	13279	6	0	1708
201984	1397	1277313866000	26848	13280	0	0	16151
201986	2134	84111647000	26848	13280	2	0	6459
201990	1397	1277303865000	26850	13281	0	0	16152
201991	2134	84110644000	26850	13281	1	0	6460
201992	2133	90711068000	26850	13281	2	0	5968
201993	1397	1277293864000	26851	13282	0	0	16153
201995	2133	90710066000	26851	13282	2	0	5969
201996	2134	84109641000	26851	13282	3	0	6461
201997	2133	90709064000	26851	13282	4	0	5970
201998	2132	147279292000	26851	13282	5	0	1709
202003	1397	1277273862000	26853	13283	0	0	16155
202004	2134	84107635000	26853	13283	1	0	6463
202005	2133	90708062000	26853	13283	2	0	5971
202097	2133	90746138000	26856	13245	85	0	\N
202098	2133	90745136000	26856	13245	86	0	\N
202099	2133	90744134000	26856	13245	87	0	\N
202100	2133	90743132000	26856	13245	88	0	\N
202101	2133	90742130000	26856	13245	89	0	\N
202102	2133	90741128000	26856	13245	90	0	\N
202103	2133	90740126000	26856	13245	91	0	\N
202104	2133	90739124000	26856	13245	92	0	\N
202105	2133	90738122000	26856	13245	93	0	\N
202106	2133	90737120000	26856	13245	94	0	\N
202107	2133	90736118000	26856	13245	95	0	\N
202108	2133	90735116000	26856	13245	96	0	\N
202109	2133	90734114000	26856	13245	97	0	\N
202110	2133	90733112000	26856	13245	98	0	\N
202111	2132	147280293000	26856	13245	99	0	\N
202112	2132	147279292000	26856	13245	100	0	\N
202113	2134	84156782000	26856	13245	101	0	\N
202114	2134	84155779000	26856	13245	102	0	\N
202115	2134	84154776000	26856	13245	103	0	\N
202116	2134	84153773000	26856	13245	104	0	\N
202117	2134	84152770000	26856	13245	105	0	\N
202118	2134	84151767000	26856	13245	106	0	\N
202119	2134	84150764000	26856	13245	107	0	\N
202120	2134	84149761000	26856	13245	108	0	\N
202121	2133	90732110000	26856	13245	109	0	\N
202122	2133	90731108000	26856	13245	110	0	\N
202123	2133	90730106000	26856	13245	111	0	\N
202124	2133	90729104000	26856	13245	113	0	\N
202125	2133	90728102000	26856	13245	114	0	\N
202126	2133	90727100000	26856	13245	115	0	\N
202127	2133	90726098000	26856	13245	116	0	\N
202128	2133	90725096000	26856	13245	117	0	\N
202129	2133	90724094000	26856	13245	118	0	\N
202130	2133	90723092000	26856	13245	119	0	\N
202131	2133	90722090000	26856	13245	120	0	\N
202132	2133	90721088000	26856	13245	121	0	\N
202133	2133	90720086000	26856	13245	122	0	\N
202134	2133	90719084000	26856	13245	123	0	\N
202135	2133	90718082000	26856	13245	124	0	\N
202136	2133	90717080000	26856	13245	125	0	\N
202147	1397	1277233858000	26858	13285	0	0	\N
202148	2133	90704054000	26858	13285	1	0	\N
202149	2134	84103623000	26858	13285	2	0	\N
202153	1397	1277233858000	26860	13285	0	0	\N
202154	2133	90704054000	26860	13285	1	0	\N
202155	2134	84103623000	26860	13285	2	0	\N
202156	1397	1277733908000	26861	13250	0	0	\N
202157	1693	9350954570272	26861	13250	1	0	\N
202158	1397	1277723907000	26861	13250	2	0	\N
202159	1397	1277713906000	26861	13250	3	0	\N
202160	1397	1277703905000	26861	13250	4	0	\N
202161	1397	1277693904000	26861	13250	5	0	\N
202162	1397	1277683903000	26861	13250	6	0	\N
202163	1397	1277673902000	26861	13250	7	0	\N
202164	1397	1277663901000	26861	13250	8	0	\N
202165	1397	1277653900000	26861	13250	9	0	\N
202166	1397	1277643899000	26861	13250	10	0	\N
202167	1397	1277633898000	26861	13250	11	0	\N
202168	1397	1277623897000	26861	13250	12	0	\N
202169	1397	1277613896000	26861	13250	13	0	\N
202170	1397	1277603895000	26861	13250	14	0	\N
202171	1397	1277593894000	26861	13250	15	0	\N
202172	1397	1277583893000	26861	13250	16	0	\N
202173	1397	1277573892000	26861	13250	17	0	\N
202174	1397	1277563891000	26861	13250	18	0	\N
202175	1397	1277553890000	26861	13250	19	0	\N
202176	1397	1277543889000	26861	13250	20	0	\N
202177	1397	1277533888000	26861	13250	21	0	\N
202178	1397	1277523887000	26861	13250	22	0	\N
202179	1397	1277513886000	26861	13250	23	0	\N
202180	1397	1277503885000	26861	13250	24	0	\N
202181	1397	1277493884000	26861	13250	25	0	\N
202182	1397	1277483883000	26861	13250	26	0	\N
202183	1397	1277473882000	26861	13250	27	0	\N
202184	1397	1277463881000	26861	13250	28	0	\N
202185	1397	1277453880000	26861	13250	29	0	\N
202186	1397	1277443879000	26861	13250	30	0	\N
202187	1397	1277433878000	26861	13250	31	0	\N
202188	1397	1277423877000	26861	13250	32	0	\N
202189	1397	1277413876000	26861	13250	33	0	\N
202190	1397	1277403875000	26861	13250	34	0	\N
202191	1397	1277393874000	26861	13250	35	0	\N
202192	1397	1277383873000	26861	13250	36	0	\N
202193	1397	1277373872000	26861	13250	37	0	\N
202194	1397	1277363871000	26861	13250	38	0	\N
202195	1397	1277353870000	26861	13250	39	0	\N
202196	1397	1277343869000	26861	13250	40	0	\N
202197	1397	1277333868000	26861	13250	41	0	\N
202198	1397	1277323867000	26861	13250	42	0	\N
202199	1397	1277313866000	26861	13250	43	0	\N
202200	1397	1277303865000	26861	13250	44	0	\N
202201	1397	1277293864000	26861	13250	45	0	\N
202202	1397	1277283863000	26861	13250	46	0	\N
202203	1397	1277273862000	26861	13250	47	0	\N
202204	1397	1277263861000	26861	13250	48	0	\N
202205	1397	1277253860000	26861	13250	49	0	\N
202206	1397	1277243859000	26861	13250	50	0	\N
202207	1397	1277233858000	26861	13250	51	0	\N
202208	2132	147292305000	26861	13250	52	0	\N
202209	2133	90754154000	26861	13250	53	0	\N
202210	2134	84150764000	26861	13250	54	0	\N
202211	2132	147291304000	26861	13250	55	0	\N
202212	2132	147290303000	26861	13250	56	0	\N
202213	2132	147289302000	26861	13250	57	0	\N
202214	2132	147288301000	26861	13250	58	0	\N
202215	2132	147287300000	26861	13250	59	0	\N
202216	2132	147286299000	26861	13250	60	0	\N
202217	2132	147285298000	26861	13250	61	0	\N
202218	2132	147284297000	26861	13250	62	0	\N
202219	2132	147283296000	26861	13250	63	0	\N
202220	2132	147282295000	26861	13250	64	0	\N
202221	2133	90753152000	26861	13250	65	0	\N
202222	2133	90752150000	26861	13250	66	0	\N
202223	2133	90751148000	26861	13250	67	0	\N
202224	2133	90750146000	26861	13250	68	0	\N
202225	2133	90749144000	26861	13250	69	0	\N
202226	2133	90748142000	26861	13250	70	0	\N
202227	2133	90747140000	26861	13250	71	0	\N
202228	2134	84149761000	26861	13250	72	0	\N
202229	2132	147281294000	26861	13250	73	0	\N
202230	2133	90746138000	26861	13250	74	0	\N
202231	2133	90745136000	26861	13250	75	0	\N
202232	2133	90744134000	26861	13250	76	0	\N
202139	1397	1277243859000	26857	13284	2	0	16158
202140	2132	147278291000	26857	13284	3	0	1710
202141	2134	84106632000	26857	13284	4	0	6464
202142	2134	84105629000	26857	13284	5	0	6465
202143	2134	84104626000	26857	13284	6	0	6466
202145	2133	90706058000	26857	13284	8	0	5973
202146	2133	90705056000	26857	13284	9	0	5974
202150	1397	1277233858000	26859	13285	0	0	16159
202151	2133	90704054000	26859	13285	1	0	5975
202152	2134	84103623000	26859	13285	2	0	6467
202233	2133	90743132000	26861	13250	77	0	\N
202234	2133	90742130000	26861	13250	78	0	\N
202235	2133	90741128000	26861	13250	80	0	\N
202236	2133	90740126000	26861	13250	81	0	\N
202237	2133	90739124000	26861	13250	82	0	\N
202238	2133	90738122000	26861	13250	83	0	\N
202239	2133	90737120000	26861	13250	84	0	\N
202240	2133	90736118000	26861	13250	85	0	\N
202241	2133	90735116000	26861	13250	86	0	\N
202242	2133	90734114000	26861	13250	87	0	\N
202243	2133	90733112000	26861	13250	88	0	\N
202244	2132	147280293000	26861	13250	89	0	\N
202245	2132	147279292000	26861	13250	90	0	\N
202246	2132	147278291000	26861	13250	91	0	\N
202247	2133	90732110000	26861	13250	92	0	\N
202248	2133	90731108000	26861	13250	93	0	\N
202249	2133	90730106000	26861	13250	94	0	\N
202250	2133	90729104000	26861	13250	95	0	\N
202251	2133	90728102000	26861	13250	96	0	\N
202252	2133	90727100000	26861	13250	97	0	\N
202253	2133	90726098000	26861	13250	98	0	\N
202254	2133	90725096000	26861	13250	99	0	\N
202255	2133	90724094000	26861	13250	100	0	\N
202256	2133	90723092000	26861	13250	101	0	\N
202257	2133	90722090000	26861	13250	102	0	\N
202258	2133	90721088000	26861	13250	103	0	\N
202259	2133	90720086000	26861	13250	104	0	\N
202260	2133	90719084000	26861	13250	105	0	\N
202261	2133	90718082000	26861	13250	106	0	\N
202262	2133	90717080000	26861	13250	107	0	\N
202263	2133	90716078000	26861	13250	108	0	\N
202264	2133	90715076000	26861	13250	109	0	\N
202265	2133	90714074000	26861	13250	110	0	\N
202266	2133	90713072000	26861	13250	111	0	\N
202267	2133	90712070000	26861	13250	112	0	\N
202268	2133	90711068000	26861	13250	113	0	\N
202269	2133	90710066000	26861	13250	114	0	\N
202270	2133	90709064000	26861	13250	115	0	\N
202271	2133	90708062000	26861	13250	116	0	\N
202272	2133	90707060000	26861	13250	117	0	\N
202273	2133	90706058000	26861	13250	118	0	\N
202274	2133	90705056000	26861	13250	119	0	\N
202275	2133	90704054000	26861	13250	120	0	\N
202276	2134	84148758000	26861	13250	121	0	\N
202277	2134	84147755000	26861	13250	122	0	\N
202278	2134	84146752000	26861	13250	123	0	\N
202279	2134	84145749000	26861	13250	124	0	\N
202280	2134	84144746000	26861	13250	125	0	\N
202281	1397	1277233858000	26862	13285	0	0	\N
202282	2133	90704054000	26862	13285	1	0	\N
202283	2134	84103623000	26862	13285	2	0	\N
202284	1397	1277223857000	26863	13286	0	0	\N
202285	1397	1277213856000	26863	13286	1	0	\N
202286	2134	84102620000	26863	13286	2	0	\N
202287	2133	90703052000	26863	13286	3	0	\N
202288	2133	90702050000	26863	13286	4	0	\N
202289	2134	84101617000	26863	13286	5	0	\N
202290	2132	147277290000	26863	13286	6	0	\N
202298	1397	1277223857000	26865	13286	0	0	\N
202299	1397	1277213856000	26865	13286	1	0	\N
202300	2134	84102620000	26865	13286	2	0	\N
202301	2133	90703052000	26865	13286	3	0	\N
202302	2133	90702050000	26865	13286	4	0	\N
202303	2134	84101617000	26865	13286	5	0	\N
202304	2132	147277290000	26865	13286	6	0	\N
202315	1397	1277183853000	26869	13289	0	0	\N
202316	2134	84098608000	26869	13289	1	0	\N
202317	2133	90699044000	26869	13289	2	0	\N
202318	1397	1277173852000	26870	13290	0	0	\N
202319	2133	90698042000	26870	13290	1	0	\N
202320	2134	84097605000	26870	13290	2	0	\N
202321	1397	1277173852000	26871	13290	0	0	\N
202322	2133	90698042000	26871	13290	1	0	\N
202323	2134	84097605000	26871	13290	2	0	\N
202324	1397	1277173852000	26872	13290	0	0	\N
202325	2133	90698042000	26872	13290	1	0	\N
202326	2134	84097605000	26872	13290	2	0	\N
202335	1397	1277153850000	26875	13292	0	0	\N
202336	2134	84095599000	26875	13292	1	0	\N
202337	2133	90696038000	26875	13292	2	0	\N
202341	1397	1277143849000	26877	13293	0	0	\N
202342	2134	84094596000	26877	13293	1	0	\N
202343	2133	90695036000	26877	13293	2	0	\N
202344	1397	1277143849000	26878	13293	0	0	\N
202345	2134	84094596000	26878	13293	1	0	\N
202346	2133	90695036000	26878	13293	2	0	\N
202350	1397	1277143849000	26880	13293	0	0	\N
202351	2134	84094596000	26880	13293	1	0	\N
202352	2133	90695036000	26880	13293	2	0	\N
202353	1397	1277143849000	26881	13293	0	0	\N
202354	2134	84094596000	26881	13293	1	0	\N
202355	2133	90695036000	26881	13293	2	0	\N
202356	1397	1277263861000	26882	13246	0	0	\N
202357	1397	1277253860000	26882	13246	1	0	\N
202358	1397	1277243859000	26882	13246	2	0	\N
202359	1397	1277233858000	26882	13246	3	0	\N
202360	1397	1277223857000	26882	13246	4	0	\N
202361	1397	1277213856000	26882	13246	5	0	\N
202362	1397	1277203855000	26882	13246	6	0	\N
202363	1397	1277193854000	26882	13246	7	0	\N
202364	1397	1277183853000	26882	13246	8	0	\N
202365	1397	1277173852000	26882	13246	9	0	\N
202366	1397	1277163851000	26882	13246	10	0	\N
202367	1397	1277153850000	26882	13246	11	0	\N
202368	1397	1277143849000	26882	13246	12	0	\N
202293	2134	84102620000	26864	13286	2	0	6468
202294	2133	90703052000	26864	13286	3	0	5976
202295	2133	90702050000	26864	13286	4	0	5977
202296	2134	84101617000	26864	13286	5	0	6469
202297	2132	147277290000	26864	13286	6	0	1711
202306	2134	84100614000	26866	13287	1	0	6470
202307	2133	90701048000	26866	13287	2	0	5978
202308	1397	1277193854000	26867	13288	0	0	16163
202309	2133	90700046000	26867	13288	1	0	5979
202310	2134	84099611000	26867	13288	2	0	6471
202312	1397	1277183853000	26868	13289	0	0	16164
202313	2134	84098608000	26868	13289	1	0	6472
202314	2133	90699044000	26868	13289	2	0	5980
202327	1397	1277173852000	26873	13290	0	0	16165
202329	2134	84097605000	26873	13290	2	0	6473
202330	1397	1277163851000	26874	13291	0	0	16166
202331	2133	90697040000	26874	13291	1	0	5982
202332	2134	84096602000	26874	13291	2	0	6474
202333	1639	0	26874	13291	3	0	4
202338	1397	1277153850000	26876	13292	0	0	16167
202339	2134	84095599000	26876	13292	1	0	6475
202340	2133	90696038000	26876	13292	2	0	5983
202347	1397	1277143849000	26879	13293	0	0	16168
202348	2134	84094596000	26879	13293	1	0	6476
202369	2132	147278291000	26882	13246	13	0	\N
202370	2133	90716078000	26882	13246	14	0	\N
202371	2133	90715076000	26882	13246	15	0	\N
202372	2133	90714074000	26882	13246	16	0	\N
202373	2133	90713072000	26882	13246	17	0	\N
202374	2133	90712070000	26882	13246	18	0	\N
202375	2133	90711068000	26882	13246	19	0	\N
202376	2133	90710066000	26882	13246	20	0	\N
202377	2133	90709064000	26882	13246	21	0	\N
202378	2133	90708062000	26882	13246	22	0	\N
202379	2133	90707060000	26882	13246	23	0	\N
202380	2133	90706058000	26882	13246	24	0	\N
202381	2133	90705056000	26882	13246	25	0	\N
202382	2133	90704054000	26882	13246	26	0	\N
202383	2133	90703052000	26882	13246	27	0	\N
202384	2133	90702050000	26882	13246	28	0	\N
202385	2133	90701048000	26882	13246	29	0	\N
202386	2133	90700046000	26882	13246	30	0	\N
202387	2133	90699044000	26882	13246	31	0	\N
202388	2133	90698042000	26882	13246	32	0	\N
202389	2133	90697040000	26882	13246	33	0	\N
202390	2133	90696038000	26882	13246	34	0	\N
202391	2133	90695036000	26882	13246	35	0	\N
202392	2132	147277290000	26882	13246	36	0	\N
202393	2132	147276289000	26882	13246	37	0	\N
202394	2132	147275288000	26882	13246	38	0	\N
202395	2134	84148758000	26882	13246	39	0	\N
202396	2134	84147755000	26882	13246	40	0	\N
202397	2134	84146752000	26882	13246	41	0	\N
202398	2134	84145749000	26882	13246	42	0	\N
202399	2134	84144746000	26882	13246	43	0	\N
202400	2134	84143743000	26882	13246	44	0	\N
202401	2134	84142740000	26882	13246	45	0	\N
202402	2134	84141737000	26882	13246	46	0	\N
202403	2134	84140734000	26882	13246	47	0	\N
202404	2134	84139731000	26882	13246	48	0	\N
202405	2134	84138728000	26882	13246	49	0	\N
202406	2134	84137725000	26882	13246	50	0	\N
202407	2134	84136722000	26882	13246	51	0	\N
202408	2134	84135719000	26882	13246	52	0	\N
202409	2134	84134716000	26882	13246	53	0	\N
202410	2134	84133713000	26882	13246	54	0	\N
202411	2134	84132710000	26882	13246	55	0	\N
202412	2134	84131707000	26882	13246	56	0	\N
202413	2134	84130704000	26882	13246	57	0	\N
202414	2134	84129701000	26882	13246	58	0	\N
202415	2134	84128698000	26882	13246	59	0	\N
202416	2134	84127695000	26882	13246	60	0	\N
202417	2134	84126692000	26882	13246	61	0	\N
202418	2134	84125689000	26882	13246	62	0	\N
202419	2134	84124686000	26882	13246	63	0	\N
202420	2134	84123683000	26882	13246	64	0	\N
202421	2134	84122680000	26882	13246	65	0	\N
202422	2134	84121677000	26882	13246	66	0	\N
202423	2134	84120674000	26882	13246	67	0	\N
202424	2134	84119671000	26882	13246	68	0	\N
202425	2134	84118668000	26882	13246	69	0	\N
202426	2134	84117665000	26882	13246	70	0	\N
202427	2134	84116662000	26882	13246	71	0	\N
202428	2134	84115659000	26882	13246	72	0	\N
202429	2134	84114656000	26882	13246	73	0	\N
202430	2134	84113653000	26882	13246	74	0	\N
202431	2134	84112650000	26882	13246	75	0	\N
202432	2134	84111647000	26882	13246	76	0	\N
202433	2134	84110644000	26882	13246	77	0	\N
202434	2134	84109641000	26882	13246	78	0	\N
202435	2134	84108638000	26882	13246	79	0	\N
202436	2134	84107635000	26882	13246	80	0	\N
202437	2134	84106632000	26882	13246	81	0	\N
202438	2134	84105629000	26882	13246	82	0	\N
202439	2134	84104626000	26882	13246	83	0	\N
202440	2134	84103623000	26882	13246	84	0	\N
202441	2134	84102620000	26882	13246	85	0	\N
202442	2134	84101617000	26882	13246	86	0	\N
202443	2134	84100614000	26882	13246	87	0	\N
202444	2134	84099611000	26882	13246	88	0	\N
202445	2134	84098608000	26882	13246	89	0	\N
202446	2134	84097605000	26882	13246	90	0	\N
202447	2134	84096602000	26882	13246	91	0	\N
202448	2134	84095599000	26882	13246	92	0	\N
202449	2134	84094596000	26882	13246	93	0	\N
202463	1397	1277103845000	26885	13295	0	0	\N
202464	2133	90691028000	26885	13295	1	0	\N
202465	2134	84090584000	26885	13295	2	0	\N
202466	1397	1277093844000	26886	13296	0	0	\N
202467	2133	90690026000	26886	13296	1	0	\N
202468	2132	147273286000	26886	13296	2	0	\N
202469	2134	84089581000	26886	13296	3	0	\N
202474	1397	1277093844000	26888	13296	0	0	\N
202475	2133	90690026000	26888	13296	1	0	\N
202476	2132	147273286000	26888	13296	2	0	\N
202477	2134	84089581000	26888	13296	3	0	\N
202481	1397	1277083843000	26890	13297	0	0	\N
202482	2134	84088578000	26890	13297	1	0	\N
202483	2133	90689024000	26890	13297	2	0	\N
202491	1397	1277063841000	26893	13299	0	0	\N
202492	2132	147272285000	26893	13299	1	0	\N
202493	2134	84086572000	26893	13299	2	0	\N
202494	2133	90687020000	26893	13299	3	0	\N
202495	1397	1277133848000	26894	13247	0	0	\N
202496	1397	1277123847000	26894	13247	1	0	\N
202497	1397	1277113846000	26894	13247	2	0	\N
202498	1397	1277103845000	26894	13247	3	0	\N
202499	1397	1277093844000	26894	13247	4	0	\N
202500	1397	1277083843000	26894	13247	5	0	\N
202501	1397	1277073842000	26894	13247	6	0	\N
202502	1397	1277063841000	26894	13247	7	0	\N
202503	1397	1277053840000	26894	13247	8	0	\N
202504	2133	90694034000	26894	13247	9	0	\N
202452	1397	1277113846000	26883	13294	2	0	16171
202453	2133	90694034000	26883	13294	3	0	5985
202454	2133	90693032000	26883	13294	4	0	5986
202455	2132	147274287000	26883	13294	5	0	1714
202456	2134	84093593000	26883	13294	6	0	6477
202458	2134	84091587000	26883	13294	8	0	6479
202459	2133	90692030000	26883	13294	9	0	5987
202460	1397	1277103845000	26884	13295	0	0	16172
202461	2133	90691028000	26884	13295	1	0	5988
202462	2134	84090584000	26884	13295	2	0	6480
202471	2133	90690026000	26887	13296	1	0	5989
202472	2132	147273286000	26887	13296	2	0	1715
202473	2134	84089581000	26887	13296	3	0	6481
202478	1397	1277083843000	26889	13297	0	0	16174
202480	2133	90689024000	26889	13297	2	0	5990
202484	1397	1277073842000	26891	13298	0	0	16175
202485	2134	84087575000	26891	13298	1	0	6483
202486	2133	90688022000	26891	13298	2	0	5991
202487	1397	1277063841000	26892	13299	0	0	16176
202489	2134	84086572000	26892	13299	2	0	6484
202490	2133	90687020000	26892	13299	3	0	5992
202505	2133	90693032000	26894	13247	10	0	\N
202506	2132	147274287000	26894	13247	11	0	\N
202507	2134	84093593000	26894	13247	12	0	\N
202508	2134	84092590000	26894	13247	13	0	\N
202509	2134	84091587000	26894	13247	14	0	\N
202510	2132	147273286000	26894	13247	15	0	\N
202511	2132	147272285000	26894	13247	17	0	\N
202512	2133	90692030000	26894	13247	18	0	\N
202513	2133	90691028000	26894	13247	19	0	\N
202514	2133	90690026000	26894	13247	20	0	\N
202515	2133	90689024000	26894	13247	21	0	\N
202516	2133	90688022000	26894	13247	22	0	\N
202517	2133	90687020000	26894	13247	23	0	\N
202518	2133	90686018000	26894	13247	24	0	\N
202519	2134	84090584000	26894	13247	25	0	\N
202520	2134	84089581000	26894	13247	26	0	\N
202521	2134	84088578000	26894	13247	27	0	\N
202522	2134	84087575000	26894	13247	28	0	\N
202523	2134	84086572000	26894	13247	29	0	\N
202524	2134	84085569000	26894	13247	30	0	\N
202534	1397	1277053840000	26896	13300	0	0	\N
202535	1397	1277043839000	26896	13300	1	0	\N
202536	1397	1277033838000	26896	13300	2	0	\N
202537	2134	84085569000	26896	13300	3	0	\N
202538	2134	84084566000	26896	13300	4	0	\N
202539	2134	84083563000	26896	13300	5	0	\N
202540	2133	90686018000	26896	13300	6	0	\N
202541	2133	90685016000	26896	13300	7	0	\N
202542	2133	90684014000	26896	13300	8	0	\N
202550	1397	1277003835000	26898	13302	0	0	\N
202551	1397	1276993834000	26898	13302	1	0	\N
202552	1397	1276983833000	26898	13302	2	0	\N
202553	1397	1276973832000	26898	13302	3	0	\N
202554	2134	84080554000	26898	13302	4	0	\N
202555	2133	90681008000	26898	13302	5	0	\N
202556	2133	90680006000	26898	13302	6	0	\N
202557	2134	84079551000	26898	13302	7	0	\N
202558	2133	90679004000	26898	13302	8	0	\N
202559	2134	84078548000	26898	13302	9	0	\N
202560	2134	84077545000	26898	13302	10	0	\N
202561	1397	1277003835000	26899	13302	0	0	\N
202562	1397	1276993834000	26899	13302	1	0	\N
202563	1397	1276983833000	26899	13302	2	0	\N
202564	1397	1276973832000	26899	13302	3	0	\N
202565	2134	84080554000	26899	13302	4	0	\N
202566	2133	90681008000	26899	13302	5	0	\N
202567	2133	90680006000	26899	13302	6	0	\N
202568	2134	84079551000	26899	13302	7	0	\N
202569	2133	90679004000	26899	13302	8	0	\N
202570	2134	84078548000	26899	13302	9	0	\N
202571	2134	84077545000	26899	13302	10	0	\N
202592	1397	1276943829000	26903	13304	0	0	\N
202593	2134	84074536000	26903	13304	1	0	\N
202594	2133	90675998000	26903	13304	2	0	\N
202607	1397	1276913826000	26907	13307	0	0	\N
202608	1397	1276903825000	26907	13307	1	0	\N
202609	2133	90672992000	26907	13307	2	0	\N
202610	2134	84071527000	26907	13307	3	0	\N
202611	2134	84070524000	26907	13307	4	0	\N
202612	2133	90671990000	26907	13307	5	0	\N
202613	1397	1276893824000	26908	13308	0	0	\N
202614	2133	90670988000	26908	13308	1	0	\N
202615	2134	84069521000	26908	13308	2	0	\N
202619	1397	1276893824000	26910	13308	0	0	\N
202620	2133	90670988000	26910	13308	1	0	\N
202621	2134	84069521000	26910	13308	2	0	\N
202622	1397	1276893824000	26911	13308	0	0	\N
202623	2133	90670988000	26911	13308	1	0	\N
202624	2134	84069521000	26911	13308	2	0	\N
202628	1397	1276873822000	26913	13310	0	0	\N
202629	2134	84067515000	26913	13310	1	0	\N
202630	2133	90668984000	26913	13310	2	0	\N
202636	1397	1276853820000	26916	13312	0	0	\N
202637	2133	90666980000	26916	13312	1	0	\N
202638	2134	84066512000	26916	13312	2	0	\N
202527	1397	1277033838000	26895	13300	2	0	16179
202528	2134	84085569000	26895	13300	3	0	6485
202529	2134	84084566000	26895	13300	4	0	6486
202530	2134	84083563000	26895	13300	5	0	6487
202531	2133	90686018000	26895	13300	6	0	5993
202533	2133	90684014000	26895	13300	8	0	5995
202543	1397	1277023837000	26897	13301	0	0	16180
202544	1397	1277013836000	26897	13301	1	0	16181
202545	2133	90683012000	26897	13301	2	0	5996
202546	2133	90682010000	26897	13301	3	0	5997
202548	2132	147271284000	26897	13301	5	0	1717
202549	2134	84081557000	26897	13301	6	0	6489
202572	1397	1277003835000	26900	13302	0	0	16182
202573	1397	1276993834000	26900	13302	1	0	16183
202575	1397	1276973832000	26900	13302	3	0	16185
202576	2134	84080554000	26900	13302	4	0	6490
202577	2133	90681008000	26900	13302	5	0	5998
202578	2133	90680006000	26900	13302	6	0	5999
202579	2134	84079551000	26900	13302	7	0	6491
202581	2134	84078548000	26900	13302	9	0	6492
202582	2134	84077545000	26900	13302	10	0	6493
202583	1397	1276963831000	26901	13303	0	0	16186
202584	1397	1276953830000	26901	13303	1	0	16187
202585	2133	90678002000	26901	13303	2	0	6001
202587	2134	84076542000	26901	13303	4	0	6494
202588	2134	84075539000	26901	13303	5	0	6495
202589	1397	1276943829000	26902	13304	0	0	16188
202590	2134	84074536000	26902	13304	1	0	6496
202595	1397	1276933828000	26904	13305	0	0	16189
202596	2133	90674996000	26904	13305	1	0	6004
202597	2134	84073533000	26904	13305	2	0	6497
202598	1397	1276923827000	26905	13306	0	0	16190
202599	2134	84072530000	26905	13306	1	0	6498
202601	1397	1276913826000	26906	13307	0	0	16191
202602	1397	1276903825000	26906	13307	1	0	16192
202603	2133	90672992000	26906	13307	2	0	6006
202604	2134	84071527000	26906	13307	3	0	6499
202605	2134	84070524000	26906	13307	4	0	6500
202616	1397	1276893824000	26909	13308	0	0	16193
202617	2133	90670988000	26909	13308	1	0	6008
202618	2134	84069521000	26909	13308	2	0	6501
202625	1397	1276883823000	26912	13309	0	0	16194
202627	2134	84068518000	26912	13309	2	0	6502
202631	1397	1276873822000	26914	13310	0	0	16195
202632	2134	84067515000	26914	13310	1	0	6503
202633	2133	90668984000	26914	13310	2	0	6010
202634	1397	1276863821000	26915	13311	0	0	16196
202639	1397	1276853820000	26917	13312	0	0	16197
202640	2133	90666980000	26917	13312	1	0	6012
202654	1397	1277043839000	26920	13248	0	0	\N
202655	1397	1277033838000	26920	13248	1	0	\N
202656	1397	1277023837000	26920	13248	2	0	\N
202657	1397	1277013836000	26920	13248	3	0	\N
202658	1397	1277003835000	26920	13248	4	0	\N
202659	1397	1276993834000	26920	13248	5	0	\N
202660	1397	1276983833000	26920	13248	6	0	\N
202661	1397	1276973832000	26920	13248	7	0	\N
202662	1397	1276963831000	26920	13248	8	0	\N
202663	1397	1276953830000	26920	13248	9	0	\N
202664	1397	1276943829000	26920	13248	10	0	\N
202665	1397	1276933828000	26920	13248	11	0	\N
202666	1397	1276923827000	26920	13248	12	0	\N
202667	1397	1276913826000	26920	13248	13	0	\N
202668	1397	1276903825000	26920	13248	14	0	\N
202669	1397	1276893824000	26920	13248	15	0	\N
202670	1397	1276883823000	26920	13248	16	0	\N
202671	1397	1276873822000	26920	13248	17	0	\N
202672	1397	1276863821000	26920	13248	18	0	\N
202673	1397	1276853820000	26920	13248	19	0	\N
202674	1397	1276843819000	26920	13248	20	0	\N
202675	1397	1276833818000	26920	13248	21	0	\N
202676	1397	1276823817000	26920	13248	22	0	\N
202677	1397	1276813816000	26920	13248	23	0	\N
202678	2133	90685016000	26920	13248	24	0	\N
202679	2133	90684014000	26920	13248	25	0	\N
202680	2133	90683012000	26920	13248	26	0	\N
202681	2133	90682010000	26920	13248	27	0	\N
202682	2134	84084566000	26920	13248	28	0	\N
202683	2134	84083563000	26920	13248	29	0	\N
202684	2134	84082560000	26920	13248	30	0	\N
202685	2132	147271284000	26920	13248	31	0	\N
202686	2133	90681008000	26920	13248	32	0	\N
202687	2133	90680006000	26920	13248	33	0	\N
202688	2134	84081557000	26920	13248	34	0	\N
202689	2134	84080554000	26920	13248	35	0	\N
202690	2134	84079551000	26920	13248	36	0	\N
202691	2133	90679004000	26920	13248	37	0	\N
202692	2133	90678002000	26920	13248	38	0	\N
202693	2133	90677000000	26920	13248	39	0	\N
202694	2133	90675998000	26920	13248	40	0	\N
202695	2133	90674996000	26920	13248	41	0	\N
202696	2133	90673994000	26920	13248	42	0	\N
202697	2133	90672992000	26920	13248	43	0	\N
202698	2134	84078548000	26920	13248	44	0	\N
202699	2134	84077545000	26920	13248	45	0	\N
202700	2134	84076542000	26920	13248	46	0	\N
202701	2134	84075539000	26920	13248	47	0	\N
202702	2134	84074536000	26920	13248	48	0	\N
202703	2134	84073533000	26920	13248	49	0	\N
202704	2134	84072530000	26920	13248	50	0	\N
202705	2134	84071527000	26920	13248	51	0	\N
202706	2134	84070524000	26920	13248	52	0	\N
202707	2134	84069521000	26920	13248	53	0	\N
202708	2134	84068518000	26920	13248	54	0	\N
202709	2134	84067515000	26920	13248	55	0	\N
202710	2134	84066512000	26920	13248	56	0	\N
202711	2134	84065509000	26920	13248	57	0	\N
202712	2134	84064506000	26920	13248	58	0	\N
202713	2134	84063503000	26920	13248	59	0	\N
202714	2134	84062500000	26920	13248	60	0	\N
202715	2133	90671990000	26920	13248	61	0	\N
202716	2133	90670988000	26920	13248	62	0	\N
202717	2133	90669986000	26920	13248	63	0	\N
202718	2133	90668984000	26920	13248	64	0	\N
202719	2133	90667982000	26920	13248	65	0	\N
202720	2133	90666980000	26920	13248	66	0	\N
202721	2133	90665978000	26920	13248	67	0	\N
202722	2133	90664976000	26920	13248	68	0	\N
202723	2133	90663974000	26920	13248	69	0	\N
202724	2133	90662972000	26920	13248	70	0	\N
202725	1397	1276803815000	26921	13315	0	0	\N
202726	2134	84061497000	26921	13315	1	0	\N
202727	2133	90661970000	26921	13315	2	0	\N
202737	1397	1276783813000	26925	13317	0	0	\N
202738	2134	84059491000	26925	13317	1	0	\N
202739	2133	90659966000	26925	13317	2	0	\N
202743	1397	1276773812000	26927	13318	0	0	\N
202744	2134	84058488000	26927	13318	1	0	\N
202745	2133	90658964000	26927	13318	2	0	\N
202749	1397	1276753810000	26929	13320	0	0	\N
202750	1397	1276743809000	26929	13320	1	0	\N
202751	1397	1276733808000	26929	13320	2	0	\N
202752	2133	90656960000	26929	13320	3	0	\N
202753	2133	90655958000	26929	13320	4	0	\N
202754	2133	90654956000	26929	13320	5	0	\N
202755	2134	84056482000	26929	13320	6	0	\N
202756	2134	84055479000	26929	13320	7	0	\N
202757	2134	84054476000	26929	13320	9	0	\N
202767	1397	1276723807000	26931	13321	0	0	\N
202768	1397	1276713806000	26931	13321	1	0	\N
202769	2133	90653954000	26931	13321	2	0	\N
202770	2134	84053473000	26931	13321	3	0	\N
202771	2133	90652952000	26931	13321	4	0	\N
202772	2134	84052470000	26931	13321	5	0	\N
202643	1397	1276833818000	26918	13313	1	0	16199
202644	2133	90665978000	26918	13313	2	0	6013
202645	2133	90664976000	26918	13313	3	0	6014
202646	2134	84065509000	26918	13313	4	0	6505
202647	2134	84064506000	26918	13313	5	0	6506
202649	1397	1276813816000	26919	13314	1	0	16201
202650	2133	90663974000	26919	13314	2	0	6015
202651	2134	84063503000	26919	13314	3	0	6507
202652	2134	84062500000	26919	13314	4	0	6508
202653	2133	90662972000	26919	13314	5	0	6016
202729	2134	84061497000	26922	13315	1	0	6509
202730	2133	90661970000	26922	13315	2	0	6017
202731	1397	1276793814000	26923	13316	0	0	16203
202732	2134	84060494000	26923	13316	1	0	6510
202734	1397	1276783813000	26924	13317	0	0	16204
202735	2134	84059491000	26924	13317	1	0	6511
202736	2133	90659966000	26924	13317	2	0	6019
202740	1397	1276773812000	26926	13318	0	0	16205
202741	2134	84058488000	26926	13318	1	0	6512
202746	1397	1276763811000	26928	13319	0	0	16206
202747	2134	84057485000	26928	13319	1	0	6513
202748	2133	90657962000	26928	13319	2	0	6021
202758	1397	1276753810000	26930	13320	0	0	16207
202759	1397	1276743809000	26930	13320	1	0	16208
202761	2133	90656960000	26930	13320	3	0	6022
202762	2133	90655958000	26930	13320	4	0	6023
202763	2133	90654956000	26930	13320	5	0	6024
202764	2134	84056482000	26930	13320	6	0	6514
202766	2134	84054476000	26930	13320	9	0	6516
202773	1397	1276723807000	26932	13321	0	0	16210
202774	1397	1276713806000	26932	13321	1	0	16211
202775	2133	90653954000	26932	13321	2	0	6025
202776	2134	84053473000	26932	13321	3	0	6517
202779	1397	1276723807000	26933	13321	0	0	\N
202780	1397	1276713806000	26933	13321	1	0	\N
202781	2133	90653954000	26933	13321	2	0	\N
202782	2134	84053473000	26933	13321	3	0	\N
202783	2133	90652952000	26933	13321	4	0	\N
202784	2134	84052470000	26933	13321	5	0	\N
202785	1397	1276723807000	26934	13321	0	0	\N
202786	1397	1276713806000	26934	13321	1	0	\N
202787	2133	90653954000	26934	13321	2	0	\N
202788	2134	84053473000	26934	13321	3	0	\N
202789	2133	90652952000	26934	13321	4	0	\N
202790	2134	84052470000	26934	13321	5	0	\N
202797	1397	1276683803000	26937	13324	0	0	\N
202798	2133	90649946000	26937	13324	1	0	\N
202799	2134	84049461000	26937	13324	2	0	\N
202806	1397	1276673802000	26940	13325	0	0	\N
202807	2133	90648944000	26940	13325	1	0	\N
202808	2134	84048458000	26940	13325	2	0	\N
202818	1397	1276663801000	26942	13326	0	0	\N
202819	1397	1276653800000	26942	13326	1	0	\N
202820	1397	1276643799000	26942	13326	2	0	\N
202821	2134	84047455000	26942	13326	3	0	\N
202822	2134	84046452000	26942	13326	4	0	\N
202823	2134	84045449000	26942	13326	5	0	\N
202824	2133	90647942000	26942	13326	6	0	\N
202825	2133	90646940000	26942	13326	7	0	\N
202826	2133	90645938000	26942	13326	8	0	\N
202840	1397	1276593794000	26944	13328	0	0	\N
202841	2133	90640928000	26944	13328	1	0	\N
202842	2134	84040434000	26944	13328	2	0	\N
202846	1397	1276593794000	26946	13328	0	0	\N
202847	2133	90640928000	26946	13328	1	0	\N
202848	2134	84040434000	26946	13328	2	0	\N
202855	1397	1276573792000	26949	13330	0	0	\N
202856	2134	84038428000	26949	13330	1	0	\N
202857	2133	90638924000	26949	13330	2	0	\N
202858	1397	1276563791000	26950	13331	0	0	\N
202859	2133	90637922000	26950	13331	1	0	\N
202860	2134	84037425000	26950	13331	2	0	\N
202864	1397	1276563791000	26952	13331	0	0	\N
202865	2133	90637922000	26952	13331	1	0	\N
202866	2134	84037425000	26952	13331	2	0	\N
202867	1397	1276553790000	26953	13332	0	0	\N
202868	1775	837210000	26953	13332	1	0	\N
202869	2134	84036422000	26953	13332	2	0	\N
202870	2133	90636920000	26953	13332	3	0	\N
202875	1397	1276553790000	26955	13332	0	0	\N
202876	1775	837210000	26955	13332	1	0	\N
202877	2134	84036422000	26955	13332	2	0	\N
202878	2133	90636920000	26955	13332	3	0	\N
202879	1397	1276553790000	26956	13332	0	0	\N
202880	1775	837210000	26956	13332	1	0	\N
202881	2134	84036422000	26956	13332	2	0	\N
202882	2133	90636920000	26956	13332	3	0	\N
202883	1775	837210000	26957	13332	0	0	\N
202884	2134	84036422000	26957	13332	1	0	\N
202885	2133	90636920000	26957	13332	2	0	\N
202889	1397	1276593794000	26959	13328	0	0	\N
202890	1397	1276583793000	26959	13328	1	0	\N
202891	1397	1276573792000	26959	13328	2	0	\N
202892	1397	1276563791000	26959	13328	3	0	\N
202893	1397	1276553790000	26959	13328	4	0	\N
202894	2133	90640928000	26959	13328	5	0	\N
202895	2133	90639926000	26959	13328	6	0	\N
202896	1775	837210000	26959	13328	7	0	\N
202897	2133	90638924000	26959	13328	8	0	\N
202898	2133	90637922000	26959	13328	9	0	\N
202899	2134	84040434000	26959	13328	10	0	\N
202900	2134	84039431000	26959	13328	11	0	\N
202901	2134	84038428000	26959	13328	12	0	\N
202902	2134	84037425000	26959	13328	13	0	\N
202903	2134	84036422000	26959	13328	14	0	\N
202904	2133	90636920000	26959	13328	15	0	\N
202912	1397	1276533788000	26961	13334	0	0	\N
202791	1397	1276703805000	26935	13322	0	0	16212
202792	2134	84051467000	26935	13322	1	0	6519
202793	2133	90651950000	26935	13322	2	0	6027
202794	1397	1276693804000	26936	13323	0	0	16213
202795	2133	90650948000	26936	13323	1	0	6028
202800	1397	1276683803000	26938	13324	0	0	16214
202801	2133	90649946000	26938	13324	1	0	6029
202802	2134	84049461000	26938	13324	2	0	6521
202803	1397	1276673802000	26939	13325	0	0	16215
202804	2133	90648944000	26939	13325	1	0	6030
202809	1397	1276663801000	26941	13326	0	0	16216
202810	1397	1276653800000	26941	13326	1	0	16217
202811	1397	1276643799000	26941	13326	2	0	16218
202812	2134	84047455000	26941	13326	3	0	6523
202814	2134	84045449000	26941	13326	5	0	6525
202815	2133	90647942000	26941	13326	6	0	6031
202816	2133	90646940000	26941	13326	7	0	6032
202817	2133	90645938000	26941	13326	8	0	6033
202827	1397	1276633798000	26943	13327	0	0	16219
202829	1397	1276613796000	26943	13327	2	0	16221
202830	1397	1276603795000	26943	13327	3	0	16222
202831	2047	40290000	26943	13327	4	0	1
202832	2134	84044446000	26943	13327	5	0	6526
202833	2133	90644936000	26943	13327	6	0	6034
202835	2133	90642932000	26943	13327	8	0	6036
202836	2133	90641930000	26943	13327	9	0	6037
202837	2134	84043443000	26943	13327	10	0	6527
202838	2134	84042440000	26943	13327	11	0	6528
202843	1397	1276593794000	26945	13328	0	0	16223
202844	2133	90640928000	26945	13328	1	0	6038
202845	2134	84040434000	26945	13328	2	0	6530
202849	1397	1276583793000	26947	13329	0	0	16224
202850	2133	90639926000	26947	13329	1	0	6039
202852	1397	1276573792000	26948	13330	0	0	16225
202853	2134	84038428000	26948	13330	1	0	6532
202854	2133	90638924000	26948	13330	2	0	6040
202861	1397	1276563791000	26951	13331	0	0	16226
202862	2133	90637922000	26951	13331	1	0	6041
202871	1397	1276553790000	26954	13332	0	0	16227
202872	1775	837210000	26954	13332	1	0	18
202873	2134	84036422000	26954	13332	2	0	6534
202874	2133	90636920000	26954	13332	3	0	6042
202887	2134	84035419000	26958	13333	1	0	6535
202888	2133	90635918000	26958	13333	2	0	6043
202905	1397	1276533788000	26960	13334	0	0	16229
202906	1397	1276523787000	26960	13334	1	0	16230
202907	2058	525500000	26960	13334	2	0	14
202909	2133	90634916000	26960	13334	4	0	6044
202910	2134	84033413000	26960	13334	5	0	6537
202911	2133	90633914000	26960	13334	6	0	6045
202913	1397	1276523787000	26961	13334	1	0	\N
202914	2058	525500000	26961	13334	2	0	\N
202915	2134	84034416000	26961	13334	3	0	\N
202916	2133	90634916000	26961	13334	4	0	\N
202917	2134	84033413000	26961	13334	5	0	\N
202918	2133	90633914000	26961	13334	6	0	\N
202919	1397	1276513786000	26962	13335	0	0	\N
202920	1397	1276503785000	26962	13335	1	0	\N
202921	2133	90632912000	26962	13335	2	0	\N
202922	2134	84032410000	26962	13335	3	0	\N
202923	2133	90631910000	26962	13335	4	0	\N
202938	1397	1276473782000	26967	13338	0	0	\N
202939	2134	84029401000	26967	13338	1	0	\N
202940	2133	90628904000	26967	13338	2	0	\N
202941	1397	1276473782000	26968	13338	0	0	\N
202942	2134	84029401000	26968	13338	1	0	\N
202943	2133	90628904000	26968	13338	2	0	\N
202944	1397	1276473782000	26969	13338	0	0	\N
202945	2134	84029401000	26969	13338	1	0	\N
202946	2133	90628904000	26969	13338	2	0	\N
202947	1693	9350954570272	26970	13247	0	0	\N
202948	2058	525500000	26970	13247	1	0	\N
202949	2132	147293306000	26970	13247	2	0	\N
202950	2047	40290000	26970	13247	3	0	\N
202951	2132	147292305000	26970	13247	4	0	\N
202952	1775	837210000	26970	13247	5	0	\N
202953	2133	90759164000	26970	13247	6	0	\N
202954	2133	90758162000	26970	13247	7	0	\N
202955	2133	90757160000	26970	13247	8	0	\N
202956	2133	90756158000	26970	13247	9	0	\N
202957	2132	147291304000	26970	13247	10	0	\N
202958	2132	147290303000	26970	13247	11	0	\N
202959	2132	147289302000	26970	13247	12	0	\N
202960	2132	147288301000	26970	13247	13	0	\N
202961	2132	147287300000	26970	13247	14	0	\N
202962	2132	147286299000	26970	13247	15	0	\N
202963	2132	147285298000	26970	13247	16	0	\N
202964	2132	147284297000	26970	13247	17	0	\N
202965	2132	147283296000	26970	13247	18	0	\N
202966	2132	147282295000	26970	13247	19	0	\N
202967	2133	90755156000	26970	13247	20	0	\N
202968	2133	90754154000	26970	13247	21	0	\N
202969	2133	90753152000	26970	13247	22	0	\N
202970	2133	90752150000	26970	13247	23	0	\N
202971	2133	90751148000	26970	13247	24	0	\N
202972	2133	90750146000	26970	13247	25	0	\N
202973	2133	90749144000	26970	13247	26	0	\N
202974	2134	84155779000	26970	13247	27	0	\N
202975	2134	84154776000	26970	13247	28	0	\N
202976	2134	84153773000	26970	13247	29	0	\N
202977	2134	84152770000	26970	13247	30	0	\N
202978	2134	84151767000	26970	13247	31	0	\N
202979	2134	84150764000	26970	13247	32	0	\N
202980	2133	90748142000	26970	13247	33	0	\N
202981	2133	90747140000	26970	13247	34	0	\N
202982	2134	84149761000	26970	13247	35	0	\N
202983	2132	147281294000	26970	13247	36	0	\N
202984	2133	90746138000	26970	13247	37	0	\N
202985	2133	90745136000	26970	13247	38	0	\N
202986	2133	90744134000	26970	13247	39	0	\N
202987	2133	90743132000	26970	13247	40	0	\N
202988	2133	90742130000	26970	13247	41	0	\N
202989	2133	90741128000	26970	13247	42	0	\N
202990	2133	90740126000	26970	13247	43	0	\N
202991	2133	90739124000	26970	13247	44	0	\N
202992	2133	90738122000	26970	13247	45	0	\N
202993	2133	90737120000	26970	13247	46	0	\N
202994	2133	90736118000	26970	13247	47	0	\N
202995	2133	90735116000	26970	13247	48	0	\N
202996	2133	90734114000	26970	13247	49	0	\N
202997	2133	90733112000	26970	13247	50	0	\N
202998	2132	147280293000	26970	13247	51	0	\N
202999	2132	147279292000	26970	13247	52	0	\N
203000	2132	147278291000	26970	13247	53	0	\N
203001	2132	147277290000	26970	13247	54	0	\N
203002	2132	147276289000	26970	13247	55	0	\N
203003	2132	147275288000	26970	13247	56	0	\N
203004	2132	147274287000	26970	13247	57	0	\N
203005	2132	147273286000	26970	13247	58	0	\N
203006	2132	147272285000	26970	13247	59	0	\N
203007	2132	147271284000	26970	13247	60	0	\N
203008	2133	90732110000	26970	13247	61	0	\N
203009	2133	90731108000	26970	13247	62	0	\N
203010	2133	90730106000	26970	13247	63	0	\N
203011	2133	90729104000	26970	13247	64	0	\N
203012	2133	90728102000	26970	13247	65	0	\N
203013	2133	90727100000	26970	13247	66	0	\N
203014	2133	90726098000	26970	13247	67	0	\N
203015	2133	90725096000	26970	13247	68	0	\N
203016	2133	90724094000	26970	13247	69	0	\N
203017	2133	90723092000	26970	13247	70	0	\N
203018	2133	90722090000	26970	13247	71	0	\N
203019	2133	90721088000	26970	13247	72	0	\N
203020	2133	90720086000	26970	13247	73	0	\N
203021	2133	90719084000	26970	13247	74	0	\N
203022	2133	90718082000	26970	13247	75	0	\N
203023	2133	90717080000	26970	13247	76	0	\N
203024	2133	90716078000	26970	13247	77	0	\N
203025	2133	90715076000	26970	13247	78	0	\N
203026	2133	90714074000	26970	13247	79	0	\N
203027	2133	90713072000	26970	13247	80	0	\N
203028	2133	90712070000	26970	13247	81	0	\N
203029	2133	90711068000	26970	13247	82	0	\N
203030	2133	90710066000	26970	13247	83	0	\N
203031	2133	90709064000	26970	13247	84	0	\N
203032	2133	90708062000	26970	13247	85	0	\N
203033	2133	90707060000	26970	13247	86	0	\N
203034	2133	90706058000	26970	13247	87	0	\N
203035	2133	90705056000	26970	13247	88	0	\N
203036	2133	90704054000	26970	13247	89	0	\N
203037	2133	90703052000	26970	13247	90	0	\N
203038	2133	90702050000	26970	13247	91	0	\N
203039	2133	90701048000	26970	13247	92	0	\N
203040	2133	90700046000	26970	13247	93	0	\N
203041	2133	90699044000	26970	13247	94	0	\N
203042	2133	90698042000	26970	13247	95	0	\N
203043	2133	90697040000	26970	13247	96	0	\N
203044	2133	90696038000	26970	13247	97	0	\N
203045	2133	90695036000	26970	13247	98	0	\N
203046	2133	90694034000	26970	13247	99	0	\N
203047	2133	90693032000	26970	13247	100	0	\N
203048	2133	90692030000	26970	13247	102	0	\N
202926	2133	90632912000	26963	13335	2	0	6046
202927	2134	84032410000	26963	13335	3	0	6538
202928	2133	90631910000	26963	13335	4	0	6047
202929	1397	1276493784000	26964	13336	0	0	16233
202930	2134	84031407000	26964	13336	1	0	6539
202932	1397	1276483783000	26965	13337	0	0	16234
202933	2134	84030404000	26965	13337	1	0	6540
202934	2133	90629906000	26965	13337	2	0	6049
202935	1397	1276473782000	26966	13338	0	0	16235
202936	2134	84029401000	26966	13338	1	0	6541
203049	2133	90691028000	26970	13247	103	0	\N
203050	2133	90690026000	26970	13247	104	0	\N
203051	2133	90689024000	26970	13247	105	0	\N
203052	2133	90688022000	26970	13247	106	0	\N
203053	2133	90687020000	26970	13247	107	0	\N
203054	2133	90686018000	26970	13247	108	0	\N
203055	2133	90685016000	26970	13247	109	0	\N
203056	2133	90684014000	26970	13247	110	0	\N
203057	2133	90683012000	26970	13247	111	0	\N
203058	2133	90682010000	26970	13247	112	0	\N
203059	2133	90681008000	26970	13247	113	0	\N
203060	2133	90680006000	26970	13247	114	0	\N
203061	2133	90679004000	26970	13247	115	0	\N
203062	2133	90678002000	26970	13247	116	0	\N
203063	2133	90677000000	26970	13247	117	0	\N
203064	2133	90675998000	26970	13247	118	0	\N
203065	2133	90674996000	26970	13247	119	0	\N
203066	2133	90673994000	26970	13247	120	0	\N
203067	2133	90672992000	26970	13247	121	0	\N
203068	2133	90671990000	26970	13247	122	0	\N
203069	2133	90670988000	26970	13247	123	0	\N
203070	2133	90669986000	26970	13247	124	0	\N
203071	2133	90668984000	26970	13247	125	0	\N
203075	1397	1276463781000	26972	13339	0	0	\N
203076	2133	90627902000	26972	13339	1	0	\N
203077	2134	84028398000	26972	13339	2	0	\N
203078	1397	1276463781000	26973	13339	0	0	\N
203079	2133	90627902000	26973	13339	1	0	\N
203080	2134	84028398000	26973	13339	2	0	\N
203081	1397	1276453780000	26974	13340	0	0	\N
203082	2133	90626900000	26974	13340	1	0	\N
203083	2134	84027395000	26974	13340	2	0	\N
203087	1397	1276453780000	26976	13340	0	0	\N
203088	2133	90626900000	26976	13340	1	0	\N
203089	2134	84027395000	26976	13340	2	0	\N
203090	1397	1276453780000	26977	13340	0	0	\N
203091	2133	90626900000	26977	13340	1	0	\N
203092	2134	84027395000	26977	13340	2	0	\N
203093	1397	1276453780000	26978	13340	0	0	\N
203094	2133	90626900000	26978	13340	1	0	\N
203095	2134	84027395000	26978	13340	2	0	\N
203096	1397	1276453780000	26979	13340	0	0	\N
203097	2133	90626900000	26979	13340	1	0	\N
203098	2134	84027395000	26979	13340	2	0	\N
203126	2134	84018368000	26985	13345	0	0	\N
203127	2133	90617882000	26985	13345	1	0	\N
203145	1397	1276313766000	26991	13350	0	0	\N
203146	2133	90611870000	26991	13350	1	0	\N
203147	2134	84012350000	26991	13350	2	0	\N
203148	1397	1276313766000	26992	13350	0	0	\N
203149	2133	90611870000	26992	13350	1	0	\N
203150	2134	84012350000	26992	13350	2	0	\N
203151	1397	1276303765000	26993	13351	0	0	\N
203152	2134	84011347000	26993	13351	1	0	\N
203153	2133	90610868000	26993	13351	2	0	\N
203168	1397	1276283763000	26997	13353	0	0	\N
203169	1397	1276273762000	26997	13353	1	0	\N
203170	1397	1276263761000	26997	13353	2	0	\N
203171	2134	84009341000	26997	13353	3	0	\N
203172	2134	84008338000	26997	13353	4	0	\N
203173	2133	90608864000	26997	13353	5	0	\N
203174	2133	90607862000	26997	13353	6	0	\N
203175	2133	90606860000	26997	13353	7	0	\N
203176	1397	1276253760000	26998	13354	0	0	\N
203177	2134	84007335000	26998	13354	1	0	\N
203178	2133	90605858000	26998	13354	2	0	\N
203184	1397	1276243759000	27001	13355	0	0	\N
203074	2134	84028398000	26971	13339	2	0	6542
203084	1397	1276453780000	26975	13340	0	0	16237
203085	2133	90626900000	26975	13340	1	0	6052
203086	2134	84027395000	26975	13340	2	0	6543
203099	2133	90625898000	26980	13341	0	0	6053
203101	1397	1276443779000	26981	13342	0	0	16238
203102	1397	1276433778000	26981	13342	1	0	16239
203103	1397	1276423777000	26981	13342	2	0	16240
203104	2134	84025389000	26981	13342	3	0	6545
203105	2134	84024386000	26981	13342	4	0	6546
203107	2133	90623894000	26981	13342	6	0	6055
203108	1397	1276413776000	26982	13343	0	0	16241
203109	1397	1276403775000	26982	13343	1	0	16242
203110	1397	1276393774000	26982	13343	2	0	16243
203112	2133	90621890000	26982	13343	4	0	6057
203113	2133	90620888000	26982	13343	5	0	6058
203114	2134	84023383000	26982	13343	6	0	6547
203115	2134	84022380000	26982	13343	7	0	6548
203116	2134	84021377000	26982	13343	8	0	6549
203118	1397	1276373772000	26983	13344	1	0	16245
203119	2133	90619886000	26983	13344	2	0	6059
203120	2133	90618884000	26983	13344	3	0	6060
203121	2134	84020374000	26983	13344	4	0	6550
203122	2134	84019371000	26983	13344	5	0	6551
203124	2134	84018368000	26984	13345	1	0	6552
203125	2133	90617882000	26984	13345	2	0	6061
203128	1397	1276353770000	26986	13346	0	0	16247
203129	2133	90616880000	26986	13346	1	0	6062
203131	2133	90615878000	26987	13347	0	0	6063
203132	2134	84016362000	26987	13347	1	0	6554
203133	1397	1276343769000	26988	13348	0	0	16248
203134	2133	90614876000	26988	13348	1	0	6064
203135	2134	84015359000	26988	13348	2	0	6555
203137	1397	1276323767000	26989	13349	1	0	16250
203138	2134	84014356000	26989	13349	2	0	6556
203139	2134	84013353000	26989	13349	3	0	6557
203140	2133	90613874000	26989	13349	4	0	6065
203141	2133	90612872000	26989	13349	5	0	6066
203143	2133	90611870000	26990	13350	1	0	6067
203144	2134	84012350000	26990	13350	2	0	6558
203154	1397	1276303765000	26994	13351	0	0	16252
203155	2134	84011347000	26994	13351	1	0	6559
203157	1397	1276293764000	26995	13352	0	0	16253
203158	2133	90609866000	26995	13352	1	0	6069
203159	2134	84010344000	26995	13352	2	0	6560
203160	1397	1276283763000	26996	13353	0	0	16254
203161	1397	1276273762000	26996	13353	1	0	16255
203163	2134	84009341000	26996	13353	3	0	6561
203164	2134	84008338000	26996	13353	4	0	6562
203165	2133	90608864000	26996	13353	5	0	6070
203166	2133	90607862000	26996	13353	6	0	6071
203167	2133	90606860000	26996	13353	7	0	6072
203180	2134	84007335000	26999	13354	1	0	6563
203181	2133	90605858000	26999	13354	2	0	6073
203182	1397	1276243759000	27000	13355	0	0	16258
203183	2134	84006332000	27000	13355	1	0	6564
203185	2134	84006332000	27001	13355	1	0	\N
203193	1397	1276223757000	27004	13357	0	0	\N
203194	2134	84004326000	27004	13357	1	0	\N
203195	2133	90602852000	27004	13357	2	0	\N
203196	1397	1276213756000	27005	13358	0	0	\N
203197	1397	1276203755000	27005	13358	1	0	\N
203198	2133	90601850000	27005	13358	2	0	\N
203199	2133	90600848000	27005	13358	3	0	\N
203200	2134	84003323000	27005	13358	4	0	\N
203201	2134	84002320000	27005	13358	5	0	\N
203202	1397	1276213756000	27006	13358	0	0	\N
203203	1397	1276203755000	27006	13358	1	0	\N
203204	2133	90601850000	27006	13358	2	0	\N
203205	2133	90600848000	27006	13358	3	0	\N
203206	2134	84003323000	27006	13358	4	0	\N
203207	2134	84002320000	27006	13358	5	0	\N
203214	1397	1276213756000	27008	13358	0	0	\N
203215	1397	1276203755000	27008	13358	1	0	\N
203216	2133	90601850000	27008	13358	2	0	\N
203217	2133	90600848000	27008	13358	3	0	\N
203218	2134	84003323000	27008	13358	4	0	\N
203219	2134	84002320000	27008	13358	5	0	\N
203223	2133	90599846000	27010	13359	0	0	\N
203224	1397	1276193754000	27011	13359	0	0	\N
203225	2134	84001317000	27011	13359	1	0	\N
203226	2133	90599846000	27011	13359	2	0	\N
203233	1397	1276163751000	27013	13361	0	0	\N
203234	2133	90596840000	27013	13361	2	0	\N
203235	2134	83998308000	27013	13361	3	0	\N
203236	1397	1276163751000	27014	13361	0	0	\N
203237	2133	90596840000	27014	13361	2	0	\N
203238	2134	83998308000	27014	13361	3	0	\N
203239	1397	1276163751000	27015	13361	0	0	\N
203240	2133	90596840000	27015	13361	2	0	\N
203241	2134	83998308000	27015	13361	3	0	\N
203247	1397	1276143749000	27018	13363	0	0	\N
203248	2133	90595838000	27018	13363	1	0	\N
203249	2134	83996302000	27018	13363	2	0	\N
203250	1397	1276143749000	27019	13363	0	0	\N
203251	2133	90595838000	27019	13363	1	0	\N
203255	1397	1276143749000	27021	13363	0	0	\N
203256	2133	90595838000	27021	13363	1	0	\N
203257	2134	83996302000	27021	13363	2	0	\N
203261	1397	1276123747000	27023	13365	0	0	\N
203262	2134	83994296000	27023	13365	1	0	\N
203263	2133	90593834000	27023	13365	2	0	\N
203267	1397	1276113746000	27025	13366	0	0	\N
203268	2134	83993293000	27025	13366	1	0	\N
203269	2133	90592832000	27025	13366	2	0	\N
203272	1397	1276863821000	27027	13311	0	0	\N
203273	1397	1276853820000	27027	13311	1	0	\N
203274	1397	1276843819000	27027	13311	2	0	\N
203275	1397	1276833818000	27027	13311	3	0	\N
203276	1397	1276823817000	27027	13311	4	0	\N
203277	1397	1276813816000	27027	13311	5	0	\N
203278	1397	1276803815000	27027	13311	6	0	\N
203279	1397	1276793814000	27027	13311	7	0	\N
203280	1397	1276783813000	27027	13311	8	0	\N
203281	1397	1276773812000	27027	13311	9	0	\N
203282	1397	1276763811000	27027	13311	10	0	\N
203283	1397	1276753810000	27027	13311	11	0	\N
203284	1397	1276743809000	27027	13311	12	0	\N
203285	1397	1276733808000	27027	13311	13	0	\N
203286	1397	1276723807000	27027	13311	14	0	\N
203287	1397	1276713806000	27027	13311	15	0	\N
203288	1397	1276703805000	27027	13311	16	0	\N
203289	1397	1276693804000	27027	13311	17	0	\N
203290	1397	1276683803000	27027	13311	18	0	\N
203291	1397	1276673802000	27027	13311	19	0	\N
203292	1397	1276663801000	27027	13311	20	0	\N
203293	1397	1276653800000	27027	13311	21	0	\N
203294	1397	1276643799000	27027	13311	22	0	\N
203295	1397	1276633798000	27027	13311	23	0	\N
203296	1397	1276623797000	27027	13311	24	0	\N
203297	1397	1276613796000	27027	13311	25	0	\N
203298	1397	1276603795000	27027	13311	26	0	\N
203299	1397	1276593794000	27027	13311	27	0	\N
203300	1397	1276583793000	27027	13311	28	0	\N
203301	1397	1276573792000	27027	13311	29	0	\N
203302	1397	1276563791000	27027	13311	30	0	\N
203303	1397	1276553790000	27027	13311	31	0	\N
203304	1397	1276543789000	27027	13311	32	0	\N
203305	1397	1276533788000	27027	13311	33	0	\N
203306	1397	1276523787000	27027	13311	34	0	\N
203307	1397	1276513786000	27027	13311	35	0	\N
203308	1397	1276503785000	27027	13311	36	0	\N
203309	1397	1276493784000	27027	13311	37	0	\N
203310	1397	1276483783000	27027	13311	38	0	\N
203311	1397	1276473782000	27027	13311	39	0	\N
203312	1397	1276463781000	27027	13311	40	0	\N
203313	1397	1276453780000	27027	13311	41	0	\N
203314	1397	1276443779000	27027	13311	42	0	\N
203315	1397	1276433778000	27027	13311	43	0	\N
203316	1397	1276423777000	27027	13311	44	0	\N
203317	1397	1276413776000	27027	13311	45	0	\N
203318	1397	1276403775000	27027	13311	46	0	\N
203319	1397	1276393774000	27027	13311	47	0	\N
203320	1397	1276383773000	27027	13311	48	0	\N
203188	2133	90603854000	27002	13356	2	0	6075
203189	2134	84005329000	27002	13356	3	0	6565
203190	1397	1276223757000	27003	13357	0	0	16260
203191	2134	84004326000	27003	13357	1	0	6566
203192	2133	90602852000	27003	13357	2	0	6076
203209	1397	1276203755000	27007	13358	1	0	16262
203210	2133	90601850000	27007	13358	2	0	6077
203211	2133	90600848000	27007	13358	3	0	6078
203212	2134	84003323000	27007	13358	4	0	6567
203213	2134	84002320000	27007	13358	5	0	6568
203221	2134	84001317000	27009	13359	1	0	6569
203222	2133	90599846000	27009	13359	2	0	6079
203227	1397	1276183753000	27012	13360	0	0	16264
203228	1397	1276173752000	27012	13360	1	0	16265
203230	2133	90597842000	27012	13360	3	0	6081
203231	2134	84000314000	27012	13360	4	0	6570
203232	2134	83999311000	27012	13360	5	0	6571
203242	1397	1276163751000	27016	13361	0	0	16266
203243	2133	90596840000	27016	13361	2	0	6082
203245	1397	1276153750000	27017	13362	0	0	16267
203246	2134	83997305000	27017	13362	1	0	6573
203252	1397	1276143749000	27020	13363	0	0	16268
203253	2133	90595838000	27020	13363	1	0	6083
203254	2134	83996302000	27020	13363	2	0	6574
203259	2134	83995299000	27022	13364	1	0	6575
203260	2133	90594836000	27022	13364	2	0	6084
203264	1397	1276123747000	27024	13365	0	0	16270
203265	2134	83994296000	27024	13365	1	0	6576
203270	2134	83993293000	27026	13366	0	0	6577
203271	2133	90592832000	27026	13366	1	0	6086
203321	1397	1276373772000	27027	13311	49	0	\N
203322	1397	1276363771000	27027	13311	50	0	\N
203323	1397	1276353770000	27027	13311	51	0	\N
203324	1397	1276343769000	27027	13311	52	0	\N
203325	1397	1276333768000	27027	13311	53	0	\N
203326	1397	1276323767000	27027	13311	54	0	\N
203327	1397	1276313766000	27027	13311	55	0	\N
203328	1397	1276303765000	27027	13311	56	0	\N
203329	1397	1276293764000	27027	13311	57	0	\N
203330	1397	1276283763000	27027	13311	59	0	\N
203331	1397	1276273762000	27027	13311	60	0	\N
203332	1397	1276263761000	27027	13311	61	0	\N
203333	1397	1276253760000	27027	13311	62	0	\N
203334	1397	1276243759000	27027	13311	63	0	\N
203335	1397	1276233758000	27027	13311	64	0	\N
203336	1397	1276223757000	27027	13311	65	0	\N
203337	1397	1276213756000	27027	13311	66	0	\N
203338	1397	1276203755000	27027	13311	67	0	\N
203339	1397	1276193754000	27027	13311	68	0	\N
203340	1397	1276183753000	27027	13311	69	0	\N
203341	1397	1276173752000	27027	13311	70	0	\N
203342	1397	1276163751000	27027	13311	71	0	\N
203343	1397	1276153750000	27027	13311	72	0	\N
203344	1397	1276143749000	27027	13311	73	0	\N
203345	1397	1276133748000	27027	13311	74	0	\N
203346	1397	1276123747000	27027	13311	75	0	\N
203347	1397	1276113746000	27027	13311	76	0	\N
203348	2058	525500000	27027	13311	77	0	\N
203349	2047	40290000	27027	13311	78	0	\N
203350	1775	837210000	27027	13311	79	0	\N
203351	2133	90667982000	27027	13311	80	0	\N
203352	2133	90666980000	27027	13311	81	0	\N
203353	2133	90665978000	27027	13311	82	0	\N
203354	2133	90664976000	27027	13311	83	0	\N
203355	2133	90663974000	27027	13311	84	0	\N
203356	2133	90662972000	27027	13311	85	0	\N
203357	2133	90661970000	27027	13311	86	0	\N
203358	2134	84066512000	27027	13311	87	0	\N
203359	2134	84065509000	27027	13311	88	0	\N
203360	2133	90660968000	27027	13311	89	0	\N
203361	2133	90659966000	27027	13311	90	0	\N
203362	2133	90658964000	27027	13311	91	0	\N
203363	2133	90657962000	27027	13311	92	0	\N
203364	2133	90656960000	27027	13311	93	0	\N
203365	2133	90655958000	27027	13311	94	0	\N
203366	2133	90654956000	27027	13311	95	0	\N
203367	2133	90653954000	27027	13311	96	0	\N
203368	2133	90652952000	27027	13311	97	0	\N
203369	2133	90651950000	27027	13311	98	0	\N
203370	2133	90650948000	27027	13311	99	0	\N
203371	2133	90649946000	27027	13311	100	0	\N
203372	2133	90648944000	27027	13311	101	0	\N
203373	2133	90647942000	27027	13311	102	0	\N
203374	2133	90646940000	27027	13311	103	0	\N
203375	2133	90645938000	27027	13311	104	0	\N
203376	2133	90644936000	27027	13311	105	0	\N
203377	2133	90643934000	27027	13311	106	0	\N
203378	2133	90642932000	27027	13311	107	0	\N
203379	2133	90641930000	27027	13311	108	0	\N
203380	2133	90640928000	27027	13311	109	0	\N
203381	2133	90639926000	27027	13311	110	0	\N
203382	2133	90638924000	27027	13311	111	0	\N
203383	2133	90637922000	27027	13311	112	0	\N
203384	2133	90636920000	27027	13311	113	0	\N
203385	2133	90635918000	27027	13311	114	0	\N
203386	2133	90634916000	27027	13311	115	0	\N
203387	2133	90633914000	27027	13311	116	0	\N
203388	2133	90632912000	27027	13311	117	0	\N
203389	2133	90631910000	27027	13311	118	0	\N
203390	2133	90630908000	27027	13311	119	0	\N
203391	2133	90629906000	27027	13311	120	0	\N
203392	2133	90628904000	27027	13311	121	0	\N
203393	2133	90627902000	27027	13311	122	0	\N
203394	2133	90626900000	27027	13311	123	0	\N
203395	2133	90625898000	27027	13311	124	0	\N
203396	2133	90624896000	27027	13311	125	0	\N
203397	1397	1276113746000	27028	13367	0	0	\N
203398	1397	1276103745000	27028	13367	1	0	\N
203399	2134	83992290000	27028	13367	2	0	\N
203400	2133	90591830000	27028	13367	3	0	\N
203405	1397	1276233758000	27030	13356	0	0	\N
203406	1397	1276223757000	27030	13356	1	0	\N
203407	1397	1276213756000	27030	13356	2	0	\N
203408	1397	1276203755000	27030	13356	3	0	\N
203409	1397	1276193754000	27030	13356	4	0	\N
203410	1397	1276183753000	27030	13356	5	0	\N
203411	1397	1276173752000	27030	13356	6	0	\N
203412	1397	1276163751000	27030	13356	7	0	\N
203413	1397	1276153750000	27030	13356	8	0	\N
203414	1397	1276143749000	27030	13356	9	0	\N
203415	1397	1276133748000	27030	13356	10	0	\N
203416	1397	1276123747000	27030	13356	11	0	\N
203417	1397	1276113746000	27030	13356	12	0	\N
203418	1397	1276103745000	27030	13356	13	0	\N
203419	1397	1276093744000	27030	13356	14	0	\N
203420	2133	90604856000	27030	13356	15	0	\N
203421	2133	90603854000	27030	13356	16	0	\N
203422	2133	90602852000	27030	13356	17	0	\N
203423	2133	90601850000	27030	13356	18	0	\N
203424	2134	84005329000	27030	13356	19	0	\N
203425	2134	84004326000	27030	13356	20	0	\N
203426	2133	90600848000	27030	13356	21	0	\N
203427	2133	90599846000	27030	13356	22	0	\N
203428	2133	90598844000	27030	13356	23	0	\N
203429	2133	90597842000	27030	13356	24	0	\N
203430	2133	90596840000	27030	13356	25	0	\N
203431	2133	90595838000	27030	13356	26	0	\N
203432	2133	90594836000	27030	13356	27	0	\N
203433	2133	90593834000	27030	13356	28	0	\N
203434	2133	90592832000	27030	13356	29	0	\N
203435	2133	90591830000	27030	13356	30	0	\N
203436	2133	90590828000	27030	13356	31	0	\N
203437	2134	84003323000	27030	13356	32	0	\N
203438	1397	1276093744000	27031	13368	0	0	\N
203439	2134	83991287000	27031	13368	1	0	\N
203440	2133	90590828000	27031	13368	2	0	\N
203444	1397	1276093744000	27033	13368	0	0	\N
203445	2134	83991287000	27033	13368	1	0	\N
203446	2133	90590828000	27033	13368	2	0	\N
203447	1397	1276093744000	27034	13368	0	0	\N
203448	2133	90590828000	27034	13368	1	0	\N
203453	1397	1276083743000	27036	13369	0	0	\N
203454	2134	83990284000	27036	13369	1	0	\N
203455	2133	90589826000	27036	13369	2	0	\N
203456	1726	959361112000	27036	13369	3	0	\N
203403	2134	83992290000	27029	13367	2	0	6578
203404	2133	90591830000	27029	13367	3	0	6087
203441	1397	1276093744000	27032	13368	0	0	16273
203442	2134	83991287000	27032	13368	1	0	6579
203443	2133	90590828000	27032	13368	2	0	6088
203450	2134	83990284000	27035	13369	1	0	6580
203451	2133	90589826000	27035	13369	2	0	6089
203452	1726	959361112000	27035	13369	3	0	8324
203457	1397	1276083743000	27037	13369	0	0	\N
203458	2133	90589826000	27037	13369	1	0	\N
203459	1726	959361112000	27037	13369	2	0	\N
203460	1397	1276073742000	27038	13370	0	0	\N
203461	2133	90588824000	27038	13370	1	0	\N
203462	1726	958260112000	27038	13370	2	0	\N
203463	1726	957159112000	27038	13370	3	0	\N
203464	1726	956058112000	27038	13370	4	0	\N
203465	1726	959361112000	27039	13360	0	0	\N
203466	1726	958260112000	27039	13360	1	0	\N
203467	1726	957159112000	27039	13360	2	0	\N
203468	1726	956058112000	27039	13360	3	0	\N
203469	1397	1276073742000	27040	13370	0	0	\N
203470	2133	90588824000	27040	13370	1	0	\N
203471	1726	958260112000	27040	13370	2	0	\N
203472	1726	957159112000	27040	13370	3	0	\N
203473	1726	956058112000	27040	13370	4	0	\N
203474	1397	1276803815000	27041	13249	0	0	\N
203475	1397	1276793814000	27041	13249	1	0	\N
203476	1397	1276783813000	27041	13249	2	0	\N
203477	1397	1276773812000	27041	13249	3	0	\N
203478	1397	1276763811000	27041	13249	4	0	\N
203479	1397	1276753810000	27041	13249	5	0	\N
203480	1397	1276743809000	27041	13249	6	0	\N
203481	1397	1276733808000	27041	13249	7	0	\N
203482	1397	1276723807000	27041	13249	8	0	\N
203483	1397	1276713806000	27041	13249	9	0	\N
203484	1397	1276703805000	27041	13249	10	0	\N
203485	1397	1276693804000	27041	13249	11	0	\N
203486	1397	1276683803000	27041	13249	12	0	\N
203487	1397	1276673802000	27041	13249	13	0	\N
203488	1397	1276663801000	27041	13249	14	0	\N
203489	1397	1276653800000	27041	13249	15	0	\N
203490	1397	1276643799000	27041	13249	16	0	\N
203491	1397	1276633798000	27041	13249	17	0	\N
203492	1397	1276623797000	27041	13249	18	0	\N
203493	1397	1276613796000	27041	13249	19	0	\N
203494	1397	1276603795000	27041	13249	20	0	\N
203495	1397	1276593794000	27041	13249	21	0	\N
203496	1397	1276583793000	27041	13249	22	0	\N
203497	1397	1276573792000	27041	13249	23	0	\N
203498	1397	1276563791000	27041	13249	24	0	\N
203499	1397	1276553790000	27041	13249	25	0	\N
203500	1397	1276543789000	27041	13249	26	0	\N
203501	1397	1276533788000	27041	13249	27	0	\N
203502	1397	1276523787000	27041	13249	28	0	\N
203503	1397	1276513786000	27041	13249	29	0	\N
203504	1397	1276503785000	27041	13249	30	0	\N
203505	1397	1276493784000	27041	13249	31	0	\N
203506	1397	1276483783000	27041	13249	32	0	\N
203507	1397	1276473782000	27041	13249	33	0	\N
203508	1397	1276463781000	27041	13249	34	0	\N
203509	1397	1276453780000	27041	13249	35	0	\N
203510	1397	1276443779000	27041	13249	36	0	\N
203511	1397	1276433778000	27041	13249	37	0	\N
203512	1397	1276423777000	27041	13249	39	0	\N
203513	1397	1276413776000	27041	13249	40	0	\N
203514	1397	1276073742000	27042	13370	0	0	\N
203515	2133	90588824000	27042	13370	1	0	\N
203516	1726	958260112000	27042	13370	2	0	\N
203517	1726	957159112000	27042	13370	3	0	\N
203518	1726	956058112000	27042	13370	4	0	\N
203524	1397	1278063941000	27044	13233	0	0	\N
203525	1693	9350954570272	27044	13233	1	0	\N
203526	2058	525500000	27044	13233	2	0	\N
203527	2132	147302315000	27044	13233	3	0	\N
203528	2133	90787220000	27044	13233	4	0	\N
203529	2047	40290000	27044	13233	5	0	\N
203530	1775	837210000	27044	13233	6	0	\N
203531	2134	84182860000	27044	13233	7	0	\N
203532	1726	961563112000	27044	13233	8	0	\N
203533	1726	960462112000	27044	13233	9	0	\N
203534	1726	959361112000	27044	13233	10	0	\N
203535	1726	958260112000	27044	13233	11	0	\N
203536	1726	957159112000	27044	13233	12	0	\N
203537	1726	956058112000	27044	13233	13	0	\N
203547	1397	1276053740000	27047	13372	0	0	\N
203548	1397	1276043739000	27047	13372	1	0	\N
203549	2133	90586820000	27047	13372	2	0	\N
203550	2134	83988278000	27047	13372	3	0	\N
203551	2134	83987275000	27047	13372	4	0	\N
203552	2133	90585818000	27047	13372	5	0	\N
203559	1397	1276033738000	27049	13373	0	0	\N
203560	1397	1276023737000	27049	13373	1	0	\N
203561	2134	83986272000	27049	13373	2	0	\N
203562	2134	83985269000	27049	13373	3	0	\N
203563	2133	90584816000	27049	13373	4	0	\N
203564	2133	90583814000	27049	13373	5	0	\N
203565	1397	1276013736000	27050	13374	0	0	\N
203566	2134	83984266000	27050	13374	1	0	\N
203567	2133	90582812000	27050	13374	2	0	\N
203568	1397	1276013736000	27051	13374	0	0	\N
203569	2134	83984266000	27051	13374	1	0	\N
203570	2133	90582812000	27051	13374	2	0	\N
203572	1397	1276773812000	27053	13318	0	0	\N
203573	1397	1276763811000	27053	13318	1	0	\N
203574	1397	1276753810000	27053	13318	2	0	\N
203575	1397	1276743809000	27053	13318	3	0	\N
203576	1397	1276733808000	27053	13318	4	0	\N
203577	1397	1276723807000	27053	13318	5	0	\N
203578	1397	1276713806000	27053	13318	6	0	\N
203579	1397	1276703805000	27053	13318	7	0	\N
203580	1397	1276693804000	27053	13318	8	0	\N
203581	1397	1276683803000	27053	13318	9	0	\N
203582	1397	1276673802000	27053	13318	10	0	\N
203583	1397	1276663801000	27053	13318	11	0	\N
203584	1397	1276653800000	27053	13318	12	0	\N
203585	1397	1276643799000	27053	13318	13	0	\N
203586	1397	1276633798000	27053	13318	14	0	\N
203587	1397	1276623797000	27053	13318	15	0	\N
203588	1397	1276613796000	27053	13318	16	0	\N
203521	1726	958260112000	27043	13370	2	0	8325
203522	1726	957159112000	27043	13370	3	0	8326
203523	1726	956058112000	27043	13370	4	0	8327
203538	1397	1276063741000	27045	13371	0	0	16276
203539	2133	90587822000	27045	13371	1	0	6091
203541	1397	1276053740000	27046	13372	0	0	16277
203542	1397	1276043739000	27046	13372	1	0	16278
203543	2133	90586820000	27046	13372	2	0	6092
203544	2134	83988278000	27046	13372	3	0	6582
203545	2134	83987275000	27046	13372	4	0	6583
203553	1397	1276033738000	27048	13373	0	0	16279
203554	1397	1276023737000	27048	13373	1	0	16280
203555	2134	83986272000	27048	13373	2	0	6584
203556	2134	83985269000	27048	13373	3	0	6585
203558	2133	90583814000	27048	13373	5	0	6095
203571	2134	83984266000	27052	13374	0	0	6586
203589	1397	1276013736000	27054	13375	0	0	16281
203590	1397	1276003735000	27054	13375	1	0	16282
203591	1397	1275993734000	27054	13375	2	0	16283
203597	1397	1276013736000	27055	13375	0	0	\N
203598	1397	1276003735000	27055	13375	1	0	\N
203599	1397	1275993734000	27055	13375	2	0	\N
203600	2134	83983263000	27055	13375	3	0	\N
203601	2134	83982260000	27055	13375	4	0	\N
203602	2133	90582812000	27055	13375	5	0	\N
203603	2133	90581810000	27055	13375	6	0	\N
203604	2133	90580808000	27055	13375	7	0	\N
203611	1397	1275983733000	27057	13376	0	0	\N
203612	1397	1275973732000	27057	13376	1	0	\N
203613	2133	90579806000	27057	13376	2	0	\N
203614	2134	83981257000	27057	13376	3	0	\N
203615	2133	90578804000	27057	13376	4	0	\N
203616	2134	83980254000	27057	13376	5	0	\N
203617	1397	1275963731000	27058	13377	0	0	\N
203618	2133	90577802000	27058	13377	1	0	\N
203619	2134	83979251000	27058	13377	2	0	\N
203643	1397	1275903725000	27065	13382	0	0	\N
203650	1397	1275903725000	27067	13382	0	0	\N
203651	1397	1275893724000	27067	13382	2	0	\N
203652	2133	90571790000	27067	13382	3	0	\N
203653	2133	90570788000	27067	13382	4	0	\N
203654	2134	83973233000	27067	13382	5	0	\N
203655	2134	83972230000	27067	13382	6	0	\N
203656	1397	1275903725000	27068	13382	0	0	\N
203657	1397	1275893724000	27068	13382	2	0	\N
203658	2133	90571790000	27068	13382	3	0	\N
203659	2133	90570788000	27068	13382	4	0	\N
203660	2134	83973233000	27068	13382	5	0	\N
203661	2134	83972230000	27068	13382	6	0	\N
203662	2133	90667982000	27069	13248	0	0	\N
203663	2133	90666980000	27069	13248	1	0	\N
203664	2133	90665978000	27069	13248	2	0	\N
203665	2133	90664976000	27069	13248	3	0	\N
203666	2133	90663974000	27069	13248	4	0	\N
203667	2133	90662972000	27069	13248	5	0	\N
203668	2133	90661970000	27069	13248	6	0	\N
203669	1611	5687627453965	27069	13248	7	0	\N
203670	1611	4693464035601	27069	13248	8	0	\N
203671	1611	4022681841845	27069	13248	9	0	\N
203672	1611	2153489402899	27069	13248	10	0	\N
203673	1611	2153488402899	27069	13248	11	0	\N
203674	2133	90660968000	27069	13248	12	0	\N
203675	2133	90659966000	27069	13248	13	0	\N
203676	2133	90658964000	27069	13248	14	0	\N
203677	2133	90657962000	27069	13248	15	0	\N
203678	2133	90656960000	27069	13248	16	0	\N
203679	2133	90655958000	27069	13248	17	0	\N
203680	2133	90654956000	27069	13248	18	0	\N
203681	2133	90653954000	27069	13248	19	0	\N
203682	2133	90652952000	27069	13248	20	0	\N
203683	2133	90651950000	27069	13248	21	0	\N
203684	2133	90650948000	27069	13248	22	0	\N
203685	2133	90649946000	27069	13248	23	0	\N
203686	2133	90648944000	27069	13248	24	0	\N
203687	2133	90647942000	27069	13248	25	0	\N
203688	2133	90646940000	27069	13248	26	0	\N
203689	2133	90645938000	27069	13248	27	0	\N
203690	2133	90644936000	27069	13248	28	0	\N
203691	2133	90643934000	27069	13248	29	0	\N
203692	2133	90642932000	27069	13248	30	0	\N
203693	2133	90641930000	27069	13248	31	0	\N
203694	2133	90640928000	27069	13248	32	0	\N
203695	2133	90639926000	27069	13248	33	0	\N
203696	2133	90638924000	27069	13248	34	0	\N
203697	2133	90637922000	27069	13248	35	0	\N
203698	1726	959361112000	27069	13248	36	0	\N
203699	1726	958260112000	27069	13248	37	0	\N
203700	1726	957159112000	27069	13248	38	0	\N
203701	1726	956058112000	27069	13248	39	0	\N
203702	2133	90636920000	27069	13248	40	0	\N
203703	2133	90635918000	27069	13248	41	0	\N
203704	2133	90634916000	27069	13248	42	0	\N
203705	2133	90633914000	27069	13248	43	0	\N
203706	2133	90632912000	27069	13248	44	0	\N
203707	2133	90631910000	27069	13248	45	0	\N
203708	2133	90630908000	27069	13248	46	0	\N
203709	2133	90629906000	27069	13248	47	0	\N
203710	2133	90628904000	27069	13248	48	0	\N
203711	2133	90627902000	27069	13248	49	0	\N
203712	2133	90626900000	27069	13248	50	0	\N
203713	2133	90625898000	27069	13248	51	0	\N
203714	2133	90624896000	27069	13248	52	0	\N
203715	2133	90623894000	27069	13248	53	0	\N
203716	2133	90622892000	27069	13248	54	0	\N
203717	2133	90621890000	27069	13248	55	0	\N
203718	2133	90620888000	27069	13248	56	0	\N
203719	2133	90619886000	27069	13248	57	0	\N
203720	2133	90618884000	27069	13248	58	0	\N
203721	2133	90617882000	27069	13248	59	0	\N
203722	2133	90616880000	27069	13248	60	0	\N
203723	2133	90615878000	27069	13248	61	0	\N
203724	2133	90614876000	27069	13248	62	0	\N
203725	2133	90613874000	27069	13248	63	0	\N
203726	2133	90612872000	27069	13248	64	0	\N
203727	2133	90611870000	27069	13248	65	0	\N
203728	2133	90610868000	27069	13248	66	0	\N
203595	2133	90581810000	27054	13375	6	0	6097
203596	2133	90580808000	27054	13375	7	0	6098
203605	1397	1275983733000	27056	13376	0	0	16284
203606	1397	1275973732000	27056	13376	1	0	16285
203607	2133	90579806000	27056	13376	2	0	6099
203609	2133	90578804000	27056	13376	4	0	6100
203610	2134	83980254000	27056	13376	5	0	6590
203620	1397	1275963731000	27059	13377	0	0	16286
203621	2133	90577802000	27059	13377	1	0	6101
203622	2134	83979251000	27059	13377	2	0	6591
203624	2134	83978248000	27060	13378	1	0	6592
203625	2133	90576800000	27060	13378	2	0	6102
203626	1397	1275943729000	27061	13379	0	0	16288
203627	1397	1275933728000	27061	13379	1	0	16289
203629	2133	90574796000	27061	13379	3	0	6104
203630	2134	83977245000	27061	13379	4	0	6593
203631	2134	83976242000	27061	13379	5	0	6594
203632	1397	1275923727000	27062	13380	0	0	16290
203633	2133	90573794000	27062	13380	1	0	6105
203635	1611	4693464035601	27062	13380	3	0	15
203636	1611	4022681841845	27062	13380	4	0	16
203637	1611	2153489402899	27062	13380	5	0	17
203638	1611	2153488402899	27062	13380	6	0	18
203639	2134	83975239000	27062	13380	7	0	6595
203641	2133	90572792000	27063	13381	1	0	6106
203642	2134	83974236000	27063	13381	2	0	6596
203644	1397	1275903725000	27066	13382	0	0	16292
203645	1397	1275893724000	27066	13382	2	0	16293
203647	2133	90570788000	27066	13382	4	0	6108
203648	2134	83973233000	27066	13382	5	0	6597
203649	2134	83972230000	27066	13382	6	0	6598
203729	2133	90609866000	27069	13248	67	0	\N
203730	2133	90608864000	27069	13248	68	0	\N
203731	2133	90607862000	27069	13248	69	0	\N
203732	2133	90606860000	27069	13248	70	0	\N
203733	2133	90605858000	27069	13248	71	0	\N
203734	2133	90604856000	27069	13248	72	0	\N
203735	2133	90603854000	27069	13248	73	0	\N
203736	2133	90602852000	27069	13248	74	0	\N
203737	2133	90601850000	27069	13248	75	0	\N
203738	2133	90600848000	27069	13248	76	0	\N
203739	2133	90599846000	27069	13248	77	0	\N
203740	2133	90598844000	27069	13248	78	0	\N
203741	2133	90597842000	27069	13248	79	0	\N
203742	2133	90596840000	27069	13248	80	0	\N
203743	2133	90595838000	27069	13248	81	0	\N
203744	2133	90594836000	27069	13248	82	0	\N
203745	2133	90593834000	27069	13248	83	0	\N
203746	2133	90592832000	27069	13248	84	0	\N
203747	2133	90591830000	27069	13248	85	0	\N
203748	2133	90590828000	27069	13248	86	0	\N
203749	2133	90589826000	27069	13248	87	0	\N
203750	2133	90588824000	27069	13248	88	0	\N
203751	2133	90587822000	27069	13248	89	0	\N
203752	2133	90586820000	27069	13248	90	0	\N
203753	2133	90585818000	27069	13248	91	0	\N
203754	2133	90584816000	27069	13248	92	0	\N
203755	2134	84148758000	27069	13248	93	0	\N
203756	2134	84147755000	27069	13248	94	0	\N
203757	2134	84146752000	27069	13248	95	0	\N
203758	2134	84145749000	27069	13248	96	0	\N
203759	2134	84144746000	27069	13248	97	0	\N
203760	2134	84143743000	27069	13248	98	0	\N
203761	2134	84142740000	27069	13248	99	0	\N
203762	2134	84141737000	27069	13248	100	0	\N
203763	2134	84140734000	27069	13248	102	0	\N
203764	2134	84139731000	27069	13248	103	0	\N
203765	2134	84138728000	27069	13248	104	0	\N
203766	2134	84137725000	27069	13248	105	0	\N
203767	2134	84136722000	27069	13248	106	0	\N
203768	2134	84135719000	27069	13248	107	0	\N
203769	2134	84134716000	27069	13248	108	0	\N
203770	2134	84133713000	27069	13248	109	0	\N
203771	2134	84132710000	27069	13248	110	0	\N
203772	2134	84131707000	27069	13248	111	0	\N
203773	2134	84130704000	27069	13248	112	0	\N
203774	2134	84129701000	27069	13248	113	0	\N
203775	2134	84128698000	27069	13248	114	0	\N
203776	2134	84127695000	27069	13248	115	0	\N
203777	2134	84126692000	27069	13248	116	0	\N
203778	2134	84125689000	27069	13248	117	0	\N
203779	2134	84124686000	27069	13248	118	0	\N
203780	2134	84123683000	27069	13248	119	0	\N
203781	2134	84122680000	27069	13248	120	0	\N
203782	2134	84121677000	27069	13248	121	0	\N
203783	2134	84120674000	27069	13248	122	0	\N
203784	2134	84119671000	27069	13248	123	0	\N
203785	2134	84118668000	27069	13248	124	0	\N
203786	2134	84117665000	27069	13248	125	0	\N
203793	1397	1275883723000	27071	13383	0	0	\N
203794	1397	1275873722000	27071	13383	1	0	\N
203795	2133	90569786000	27071	13383	2	0	\N
203796	2134	83971227000	27071	13383	3	0	\N
203797	2134	83970224000	27071	13383	4	0	\N
203798	2133	90568784000	27071	13383	5	0	\N
203799	1397	1275863721000	27072	13384	0	0	\N
203800	2134	83969221000	27072	13384	1	0	\N
203807	1397	1275853720000	27075	13385	0	0	\N
203808	2133	90566780000	27075	13385	1	0	\N
203809	2134	83968218000	27075	13385	2	0	\N
203815	1397	1275823717000	27077	13387	0	0	\N
203816	2133	90563774000	27077	13387	1	0	\N
203817	2134	83966212000	27077	13387	2	0	\N
203824	1397	1276463781000	27080	13339	0	0	\N
203825	1397	1276453780000	27080	13339	1	0	\N
203826	1397	1276443779000	27080	13339	2	0	\N
203827	1397	1276433778000	27080	13339	3	0	\N
203828	1397	1276423777000	27080	13339	4	0	\N
203829	1397	1276413776000	27080	13339	5	0	\N
203830	1397	1276403775000	27080	13339	6	0	\N
203831	1397	1276393774000	27080	13339	7	0	\N
203832	1397	1276383773000	27080	13339	9	0	\N
203833	1397	1276373772000	27080	13339	10	0	\N
203834	1397	1276363771000	27080	13339	11	0	\N
203835	1397	1276353770000	27080	13339	12	0	\N
203836	1397	1276343769000	27080	13339	13	0	\N
203837	1397	1276333768000	27080	13339	14	0	\N
203838	1397	1276323767000	27080	13339	15	0	\N
203839	1397	1276313766000	27080	13339	16	0	\N
203840	1397	1276303765000	27080	13339	17	0	\N
203841	1397	1276293764000	27080	13339	18	0	\N
203842	1397	1276283763000	27080	13339	19	0	\N
203843	1397	1276273762000	27080	13339	20	0	\N
203844	1397	1276263761000	27080	13339	21	0	\N
203845	1397	1276253760000	27080	13339	22	0	\N
203846	1397	1276243759000	27080	13339	23	0	\N
203847	1397	1276233758000	27080	13339	24	0	\N
203848	1397	1276223757000	27080	13339	25	0	\N
203849	1397	1276213756000	27080	13339	26	0	\N
203850	1397	1276203755000	27080	13339	27	0	\N
203851	1397	1276193754000	27080	13339	28	0	\N
203852	1397	1276183753000	27080	13339	29	0	\N
203853	1397	1276173752000	27080	13339	30	0	\N
203854	1397	1276163751000	27080	13339	31	0	\N
203855	1397	1276153750000	27080	13339	32	0	\N
203856	1397	1276143749000	27080	13339	33	0	\N
203857	1397	1276133748000	27080	13339	34	0	\N
203858	1397	1276123747000	27080	13339	35	0	\N
203859	1397	1276113746000	27080	13339	36	0	\N
203860	1397	1276103745000	27080	13339	37	0	\N
203861	1397	1276093744000	27080	13339	38	0	\N
203862	1397	1276083743000	27080	13339	39	0	\N
203863	1397	1276073742000	27080	13339	40	0	\N
203864	1397	1276063741000	27080	13339	41	0	\N
203789	2133	90569786000	27070	13383	2	0	6109
203790	2134	83971227000	27070	13383	3	0	6599
203791	2134	83970224000	27070	13383	4	0	6600
203792	2133	90568784000	27070	13383	5	0	6110
203801	1397	1275863721000	27073	13384	0	0	16296
203803	2133	90567782000	27073	13384	2	0	6111
203804	1397	1275853720000	27074	13385	0	0	16297
203805	2133	90566780000	27074	13385	1	0	6112
203806	2134	83968218000	27074	13385	2	0	6602
203810	1397	1275843719000	27076	13386	0	0	16298
203812	2134	83967215000	27076	13386	2	0	6603
203813	2133	90565778000	27076	13386	3	0	6113
203814	2133	90564776000	27076	13386	4	0	6114
203818	1397	1275823717000	27078	13387	0	0	16300
203820	2134	83966212000	27078	13387	2	0	6604
203821	1397	1275813716000	27079	13388	0	0	16301
203822	2134	83965209000	27079	13388	1	0	6605
203823	2133	90562772000	27079	13388	2	0	6116
203865	1397	1276053740000	27080	13339	42	0	\N
203866	1397	1276043739000	27080	13339	43	0	\N
203867	1397	1276033738000	27080	13339	44	0	\N
203890	1397	1275753710000	27085	13392	0	0	\N
203891	1397	1275743709000	27085	13392	1	0	\N
203892	2134	83959191000	27085	13392	2	0	\N
203893	2133	90556760000	27085	13392	3	0	\N
203894	2134	83958188000	27085	13392	4	0	\N
203895	2133	90555758000	27085	13392	5	0	\N
203896	1397	1275753710000	27086	13392	0	0	\N
203897	1397	1275743709000	27086	13392	1	0	\N
203898	2134	83959191000	27086	13392	2	0	\N
203899	2133	90556760000	27086	13392	3	0	\N
203900	2134	83958188000	27086	13392	4	0	\N
203901	2133	90555758000	27086	13392	5	0	\N
203902	1397	1275753710000	27087	13392	0	0	\N
203903	1397	1275743709000	27087	13392	1	0	\N
203904	2134	83959191000	27087	13392	2	0	\N
203905	2133	90556760000	27087	13392	3	0	\N
203906	2134	83958188000	27087	13392	4	0	\N
203907	2133	90555758000	27087	13392	5	0	\N
203908	1397	1275753710000	27088	13392	0	0	\N
203909	1397	1275743709000	27088	13392	1	0	\N
203910	2134	83959191000	27088	13392	2	0	\N
203911	2133	90556760000	27088	13392	3	0	\N
203912	2134	83958188000	27088	13392	4	0	\N
203913	2133	90555758000	27088	13392	5	0	\N
203917	1397	1275733708000	27090	13393	0	0	\N
203918	2134	83957185000	27090	13393	1	0	\N
203919	2133	90554756000	27090	13393	2	0	\N
203935	1397	1275683703000	27095	13397	0	0	\N
203936	2133	90549746000	27095	13397	1	0	\N
203937	2134	83952170000	27095	13397	2	0	\N
203938	1397	1275683703000	27096	13397	0	0	\N
203939	2133	90549746000	27096	13397	1	0	\N
203940	2134	83952170000	27096	13397	2	0	\N
203953	1397	1275653700000	27102	13399	0	0	\N
203954	1397	1275643699000	27102	13399	1	0	\N
203955	2134	83949161000	27102	13399	2	0	\N
203956	2133	90546740000	27102	13399	3	0	\N
203957	2134	83948158000	27102	13399	4	0	\N
203958	2133	90545738000	27102	13399	5	0	\N
203968	1397	1275613696000	27106	13401	0	0	\N
203969	2133	90542732000	27106	13401	1	0	\N
203970	2134	83945149000	27106	13401	2	0	\N
203971	1397	1275613696000	27107	13401	0	0	\N
203972	2133	90542732000	27107	13401	1	0	\N
203973	2134	83945149000	27107	13401	2	0	\N
203980	1397	1276103745000	27110	13312	0	0	\N
203981	1397	1276093744000	27110	13312	1	0	\N
203982	1397	1276083743000	27110	13312	2	0	\N
203983	1397	1276073742000	27110	13312	3	0	\N
203984	1397	1276063741000	27110	13312	4	0	\N
203985	1397	1276053740000	27110	13312	5	0	\N
203986	1397	1276043739000	27110	13312	6	0	\N
203987	1397	1276033738000	27110	13312	7	0	\N
203988	1397	1276023737000	27110	13312	8	0	\N
203989	1397	1276013736000	27110	13312	9	0	\N
203990	1397	1276003735000	27110	13312	10	0	\N
203991	1397	1275993734000	27110	13312	11	0	\N
203992	1397	1275983733000	27110	13312	12	0	\N
203993	1397	1275973732000	27110	13312	13	0	\N
203994	1397	1275963731000	27110	13312	14	0	\N
203995	1397	1275953730000	27110	13312	15	0	\N
203996	1397	1275943729000	27110	13312	16	0	\N
203997	1397	1275933728000	27110	13312	17	0	\N
203998	1397	1275923727000	27110	13312	18	0	\N
203999	1397	1275913726000	27110	13312	19	0	\N
204000	1397	1275903725000	27110	13312	20	0	\N
203870	2133	90561770000	27081	13389	2	0	6117
203871	1397	1275793714000	27082	13390	0	0	16303
203872	2134	83963203000	27082	13390	1	0	6607
203873	2133	90560768000	27082	13390	2	0	6118
203874	1397	1275783713000	27083	13391	0	0	16304
203876	1397	1275763711000	27083	13391	2	0	16306
203877	2134	83962200000	27083	13391	3	0	6608
203878	2134	83961197000	27083	13391	4	0	6609
203879	2134	83960194000	27083	13391	5	0	6610
203880	364	66000011000000	27083	13391	6	0	1
203882	2133	90558764000	27083	13391	8	0	6120
203883	2133	90557762000	27083	13391	9	0	6121
203884	1397	1275753710000	27084	13392	0	0	16307
203885	1397	1275743709000	27084	13392	1	0	16308
203887	2133	90556760000	27084	13392	3	0	6122
203888	2134	83958188000	27084	13392	4	0	6612
203889	2133	90555758000	27084	13392	5	0	6123
203914	1397	1275733708000	27089	13393	0	0	16309
203915	2134	83957185000	27089	13393	1	0	6613
203920	1397	1275723707000	27091	13394	0	0	16310
203921	2133	90553754000	27091	13394	1	0	6125
203922	2134	83956182000	27091	13394	2	0	6614
203923	1397	1275713706000	27092	13395	0	0	16311
203924	2133	90552752000	27092	13395	1	0	6126
203926	1397	1275703705000	27093	13396	0	0	16312
203927	1397	1275693704000	27093	13396	1	0	16313
203928	2134	83954176000	27093	13396	2	0	6616
203929	2133	90551750000	27093	13396	3	0	6127
203931	2134	83953173000	27093	13396	5	0	6617
203932	1397	1275683703000	27094	13397	0	0	16314
203933	2133	90549746000	27094	13397	1	0	6129
203934	2134	83952170000	27094	13397	2	0	6618
203941	1397	1275673702000	27100	13398	0	0	16315
203943	2134	83951167000	27100	13398	2	0	6619
203944	2134	83950164000	27100	13398	3	0	6620
203945	2133	90548744000	27100	13398	4	0	6130
203946	2133	90547742000	27100	13398	5	0	6131
203947	1397	1275653700000	27101	13399	0	0	16317
203949	2134	83949161000	27101	13399	2	0	6621
203950	2133	90546740000	27101	13399	3	0	6132
203951	2134	83948158000	27101	13399	4	0	6622
203952	2133	90545738000	27101	13399	5	0	6133
203960	1397	1275623697000	27103	13400	1	0	16320
203961	2133	90544736000	27103	13400	2	0	6134
203962	2134	83947155000	27103	13400	3	0	6623
203963	2133	90543734000	27103	13400	4	0	6135
203964	2134	83946152000	27103	13400	5	0	6624
203966	2133	90542732000	27104	13401	1	0	6136
203967	2134	83945149000	27104	13401	2	0	6625
203974	1397	1275603695000	27108	13402	0	0	16322
203975	2134	83944146000	27108	13402	1	0	6626
203976	2133	90541730000	27108	13402	2	0	6137
203978	2133	90540728000	27109	13403	1	0	6138
203979	2134	83943143000	27109	13403	2	0	6627
204001	1397	1275893724000	27110	13312	21	0	\N
204002	1397	1275883723000	27110	13312	22	0	\N
204003	1397	1275873722000	27110	13312	23	0	\N
204004	1397	1275863721000	27110	13312	24	0	\N
204005	1397	1275853720000	27110	13312	25	0	\N
204006	1397	1275843719000	27110	13312	26	0	\N
204007	1397	1275833718000	27110	13312	27	0	\N
204008	1397	1275823717000	27110	13312	28	0	\N
204009	1397	1275813716000	27110	13312	29	0	\N
204010	1397	1275803715000	27110	13312	30	0	\N
204011	1397	1275793714000	27110	13312	31	0	\N
204012	1397	1275783713000	27110	13312	32	0	\N
204013	1397	1275773712000	27110	13312	33	0	\N
204014	1397	1275763711000	27110	13312	34	0	\N
204015	1397	1275753710000	27110	13312	35	0	\N
204016	1397	1275743709000	27110	13312	36	0	\N
204017	1397	1275733708000	27110	13312	37	0	\N
204018	1397	1275723707000	27110	13312	38	0	\N
204019	1397	1275713706000	27110	13312	39	0	\N
204020	1397	1275703705000	27110	13312	40	0	\N
204021	1397	1275693704000	27110	13312	41	0	\N
204022	1397	1275683703000	27110	13312	42	0	\N
204023	1397	1275673702000	27110	13312	43	0	\N
204024	1397	1275663701000	27110	13312	44	0	\N
204025	1397	1275653700000	27110	13312	45	0	\N
204026	1397	1275643699000	27110	13312	46	0	\N
204027	1397	1275633698000	27110	13312	47	0	\N
204028	1397	1275623697000	27110	13312	48	0	\N
204029	1397	1275613696000	27110	13312	49	0	\N
204030	1397	1275603695000	27110	13312	50	0	\N
204031	2133	90623894000	27110	13312	51	0	\N
204032	2133	90622892000	27110	13312	52	0	\N
204033	364	66000011000000	27110	13312	53	0	\N
204034	2133	90621890000	27110	13312	54	0	\N
204035	2133	90620888000	27110	13312	55	0	\N
204036	2133	90619886000	27110	13312	56	0	\N
204037	2133	90618884000	27110	13312	57	0	\N
204038	2133	90617882000	27110	13312	59	0	\N
204039	2133	90616880000	27110	13312	60	0	\N
204040	2133	90615878000	27110	13312	61	0	\N
204041	2133	90614876000	27110	13312	62	0	\N
204042	2133	90613874000	27110	13312	63	0	\N
204043	2133	90612872000	27110	13312	64	0	\N
204044	2133	90611870000	27110	13312	65	0	\N
204045	2133	90610868000	27110	13312	66	0	\N
204046	2133	90609866000	27110	13312	67	0	\N
204047	2133	90608864000	27110	13312	68	0	\N
204048	1611	5687627453965	27110	13312	69	0	\N
204049	1611	4693464035601	27110	13312	70	0	\N
204050	1611	4022681841845	27110	13312	71	0	\N
204051	1611	2153489402899	27110	13312	72	0	\N
204052	1611	2153488402899	27110	13312	73	0	\N
204053	2133	90607862000	27110	13312	74	0	\N
204054	2133	90606860000	27110	13312	75	0	\N
204055	2133	90605858000	27110	13312	76	0	\N
204056	2133	90604856000	27110	13312	77	0	\N
204057	2133	90603854000	27110	13312	78	0	\N
204058	2133	90602852000	27110	13312	79	0	\N
204059	2133	90601850000	27110	13312	80	0	\N
204060	2133	90600848000	27110	13312	81	0	\N
204061	2133	90599846000	27110	13312	82	0	\N
204062	2133	90598844000	27110	13312	83	0	\N
204063	2133	90597842000	27110	13312	84	0	\N
204064	2133	90596840000	27110	13312	85	0	\N
204065	2133	90595838000	27110	13312	86	0	\N
204066	2133	90594836000	27110	13312	87	0	\N
204067	2133	90593834000	27110	13312	88	0	\N
204068	2133	90592832000	27110	13312	89	0	\N
204069	2133	90591830000	27110	13312	90	0	\N
204070	2133	90590828000	27110	13312	91	0	\N
204071	2133	90589826000	27110	13312	92	0	\N
204072	2133	90588824000	27110	13312	93	0	\N
204073	2133	90587822000	27110	13312	94	0	\N
204074	2133	90586820000	27110	13312	95	0	\N
204075	2133	90585818000	27110	13312	96	0	\N
204076	1726	959361112000	27110	13312	97	0	\N
204077	1726	958260112000	27110	13312	98	0	\N
204078	1726	957159112000	27110	13312	99	0	\N
204079	1726	956058112000	27110	13312	100	0	\N
204080	2133	90584816000	27110	13312	101	0	\N
204081	2134	84064506000	27110	13312	102	0	\N
204082	2134	84063503000	27110	13312	103	0	\N
204083	2134	84062500000	27110	13312	104	0	\N
204084	2134	84061497000	27110	13312	105	0	\N
204085	2134	84060494000	27110	13312	106	0	\N
204086	2134	84059491000	27110	13312	107	0	\N
204087	2134	84058488000	27110	13312	108	0	\N
204088	2134	84057485000	27110	13312	109	0	\N
204089	2134	84056482000	27110	13312	110	0	\N
204090	2134	84055479000	27110	13312	111	0	\N
204091	2134	84054476000	27110	13312	112	0	\N
204092	2134	84053473000	27110	13312	113	0	\N
204093	2134	84052470000	27110	13312	114	0	\N
204094	2134	84051467000	27110	13312	115	0	\N
204095	2134	84050464000	27110	13312	116	0	\N
204096	2134	84049461000	27110	13312	117	0	\N
204097	2134	84048458000	27110	13312	118	0	\N
204098	2134	84047455000	27110	13312	119	0	\N
204099	2134	84046452000	27110	13312	120	0	\N
204100	2134	84045449000	27110	13312	121	0	\N
204101	2134	84044446000	27110	13312	122	0	\N
204102	2134	84043443000	27110	13312	123	0	\N
204103	2134	84042440000	27110	13312	124	0	\N
204104	2134	84041437000	27110	13312	125	0	\N
204105	1397	1275583693000	27111	13404	0	0	\N
204106	2133	90539726000	27111	13404	1	0	\N
204109	1397	1275573692000	27113	13405	0	0	\N
204110	2134	83942140000	27113	13405	1	0	\N
204111	2133	90538724000	27113	13405	2	0	\N
204118	1397	1275573692000	27116	13406	0	0	\N
204119	2133	90537722000	27116	13406	1	0	\N
204120	2134	83941137000	27116	13406	2	0	\N
204130	1397	1275533688000	27120	13409	0	0	\N
204131	2134	83938128000	27120	13409	1	0	\N
204132	2133	90534716000	27120	13409	2	0	\N
204112	2134	83942140000	27114	13405	0	0	6628
204113	2133	90538724000	27114	13405	1	0	6140
204114	1397	1275573692000	27115	13406	0	0	16325
204115	1397	1275563691000	27115	13406	1	0	16326
204116	2133	90537722000	27115	13406	2	0	6141
204121	1397	1275553690000	27117	13407	0	0	16327
204122	2133	90536720000	27117	13407	1	0	6142
204123	2134	83940134000	27117	13407	2	0	6630
204124	1397	1275543689000	27118	13408	0	0	16328
204125	2134	83939131000	27118	13408	1	0	6631
204127	1397	1275533688000	27119	13409	0	0	16329
204128	2134	83938128000	27119	13409	1	0	6632
204129	2133	90534716000	27119	13409	2	0	6144
204133	1397	1275523687000	27121	13410	0	0	16330
204135	2133	90533714000	27121	13410	2	0	6145
204136	2134	83937125000	27121	13410	3	0	6633
204144	1397	1275503685000	27123	13411	0	0	\N
204145	2133	90531710000	27123	13411	1	0	\N
204146	2134	83935119000	27123	13411	2	0	\N
204147	2134	83934116000	27123	13411	3	0	\N
204148	2133	90530708000	27123	13411	4	0	\N
204161	1397	1275453680000	27128	13416	0	0	\N
204162	2134	83929101000	27128	13416	1	0	\N
204163	2133	90525698000	27128	13416	2	0	\N
204176	1397	1275443679000	27131	13417	0	0	\N
204177	1397	1275433678000	27131	13417	1	0	\N
204178	1397	1275423677000	27131	13417	2	0	\N
204179	2133	90524696000	27131	13417	3	0	\N
204180	2134	83928098000	27131	13417	4	0	\N
204181	2134	83927095000	27131	13417	5	0	\N
204182	2134	83926092000	27131	13417	6	0	\N
204183	2133	90523694000	27131	13417	7	0	\N
204184	2133	90522692000	27131	13417	8	0	\N
204188	1397	1275413676000	27133	13418	0	0	\N
204189	2133	90521690000	27133	13418	1	0	\N
204190	2134	83925089000	27133	13418	2	0	\N
204191	2133	90521690000	27134	13418	0	0	\N
204192	2134	83925089000	27134	13418	1	0	\N
204193	1397	1275413676000	27135	13418	0	0	\N
204194	2133	90521690000	27135	13418	1	0	\N
204195	2134	83925089000	27135	13418	2	0	\N
204199	1397	1275403675000	27137	13419	0	0	\N
204200	2134	83924086000	27137	13419	1	0	\N
204201	2133	90520688000	27137	13419	2	0	\N
204205	1397	1275393674000	27140	13420	0	0	\N
204206	2134	83923083000	27140	13420	1	0	\N
204207	2133	90519686000	27140	13420	2	0	\N
204208	1397	1275383673000	27141	13421	0	0	\N
204209	2133	90518684000	27141	13421	1	0	\N
204210	2134	83922080000	27141	13421	2	0	\N
204211	1397	1275383673000	27142	13421	0	0	\N
204212	2133	90518684000	27142	13421	1	0	\N
204213	2134	83922080000	27142	13421	2	0	\N
204225	1397	1275373672000	27145	13422	0	0	\N
204226	1397	1275363671000	27145	13422	1	0	\N
204227	1397	1275353670000	27145	13422	2	0	\N
204228	2133	90517682000	27145	13422	3	0	\N
204229	2133	90516680000	27145	13422	4	0	\N
204230	2134	83921077000	27145	13422	5	0	\N
204231	2134	83920074000	27145	13422	6	0	\N
204232	2133	90515678000	27145	13422	7	0	\N
204233	1397	1275343669000	27146	13423	0	0	\N
204234	2134	83919071000	27146	13423	1	0	\N
204235	2133	90514676000	27146	13423	2	0	\N
204236	1397	1275343669000	27147	13423	0	0	\N
204237	2134	83919071000	27147	13423	1	0	\N
204238	2133	90514676000	27147	13423	2	0	\N
204246	1397	1278794014000	27150	13180	0	0	\N
204247	1397	1278784013000	27150	13180	1	0	\N
204248	1397	1278774012000	27150	13180	2	0	\N
204249	1397	1278764011000	27150	13180	3	0	\N
204250	1693	9350954570272	27150	13180	4	0	\N
204251	1397	1278754010000	27150	13180	5	0	\N
204252	1397	1278744009000	27150	13180	6	0	\N
204253	1397	1278734008000	27150	13180	7	0	\N
204254	1397	1278724007000	27150	13180	8	0	\N
204255	1397	1278714006000	27150	13180	9	0	\N
204256	1397	1278704005000	27150	13180	10	0	\N
204257	1397	1278694004000	27150	13180	11	0	\N
204258	1397	1278684003000	27150	13180	12	0	\N
204259	1397	1278674002000	27150	13180	13	0	\N
204260	1397	1278664001000	27150	13180	14	0	\N
204261	1397	1278654000000	27150	13180	15	0	\N
204262	1397	1278643999000	27150	13180	16	0	\N
204263	1397	1278633998000	27150	13180	17	0	\N
204264	1397	1278623997000	27150	13180	18	0	\N
204265	1397	1278613996000	27150	13180	19	0	\N
204266	1397	1278603995000	27150	13180	20	0	\N
204267	1397	1278593994000	27150	13180	21	0	\N
204268	1397	1278583993000	27150	13180	22	0	\N
204269	1397	1278573992000	27150	13180	23	0	\N
204270	1397	1278563991000	27150	13180	24	0	\N
204271	1397	1278553990000	27150	13180	25	0	\N
204272	1397	1278543989000	27150	13180	26	0	\N
204139	1397	1275503685000	27122	13411	0	0	16332
204140	2133	90531710000	27122	13411	1	0	6147
204141	2134	83935119000	27122	13411	2	0	6635
204142	2134	83934116000	27122	13411	3	0	6636
204143	2133	90530708000	27122	13411	4	0	6148
204150	2133	90529706000	27124	13412	1	0	6149
204151	2134	83933113000	27124	13412	2	0	6637
204152	1397	1275483683000	27125	13413	0	0	16334
204153	2133	90528704000	27125	13413	1	0	6150
204154	2134	83932110000	27125	13413	2	0	6638
204156	2134	83931107000	27126	13414	1	0	6639
204157	2133	90527702000	27126	13414	2	0	6151
204158	1397	1275463681000	27127	13415	0	0	16336
204159	2134	83930104000	27127	13415	1	0	6640
204164	1397	1275453680000	27129	13416	0	0	16337
204165	2134	83929101000	27129	13416	1	0	6641
204166	2133	90525698000	27129	13416	2	0	6153
204167	1397	1275443679000	27130	13417	0	0	16338
204168	1397	1275433678000	27130	13417	1	0	16339
204170	2133	90524696000	27130	13417	3	0	6154
204171	2134	83928098000	27130	13417	4	0	6642
204172	2134	83927095000	27130	13417	5	0	6643
204173	2134	83926092000	27130	13417	6	0	6644
204174	2133	90523694000	27130	13417	7	0	6155
204185	1397	1275413676000	27132	13418	0	0	16341
204186	2133	90521690000	27132	13418	1	0	6157
204187	2134	83925089000	27132	13418	2	0	6645
204196	1397	1275403675000	27136	13419	0	0	16342
204198	2133	90520688000	27136	13419	2	0	6158
204202	1397	1275393674000	27139	13420	0	0	16343
204203	2134	83923083000	27139	13420	1	0	6647
204204	2133	90519686000	27139	13420	2	0	6159
204214	1397	1275383673000	27143	13421	0	0	16344
204216	2134	83922080000	27143	13421	2	0	6648
204217	1397	1275373672000	27144	13422	0	0	16345
204218	1397	1275363671000	27144	13422	1	0	16346
204219	1397	1275353670000	27144	13422	2	0	16347
204220	2133	90517682000	27144	13422	3	0	6161
204222	2134	83921077000	27144	13422	5	0	6649
204223	2134	83920074000	27144	13422	6	0	6650
204224	2133	90515678000	27144	13422	7	0	6163
204239	1397	1275343669000	27148	13423	0	0	16348
204241	2133	90514676000	27148	13423	2	0	6164
204242	2134	83918068000	27149	13424	0	0	6652
204243	2134	83917065000	27149	13424	2	0	6653
204244	2133	90513674000	27149	13424	3	0	6165
204245	2133	90512672000	27149	13424	4	0	6166
204273	1397	1278533988000	27150	13180	27	0	\N
204274	1397	1278523987000	27150	13180	28	0	\N
204275	1397	1278513986000	27150	13180	29	0	\N
204276	1397	1278503985000	27150	13180	30	0	\N
204277	1397	1278493984000	27150	13180	31	0	\N
204278	1397	1278483983000	27150	13180	32	0	\N
204279	1397	1278473982000	27150	13180	33	0	\N
204280	1397	1278463981000	27150	13180	34	0	\N
204281	1397	1278453980000	27150	13180	35	0	\N
204282	1397	1278443979000	27150	13180	36	0	\N
204283	1397	1278433978000	27150	13180	37	0	\N
204284	1397	1278423977000	27150	13180	38	0	\N
204285	1397	1278413976000	27150	13180	39	0	\N
204286	1397	1278403975000	27150	13180	40	0	\N
204287	1397	1278393974000	27150	13180	41	0	\N
204288	1397	1278383973000	27150	13180	42	0	\N
204289	1397	1278373972000	27150	13180	43	0	\N
204290	1397	1278363971000	27150	13180	44	0	\N
204291	1397	1278353970000	27150	13180	45	0	\N
204292	1397	1278343969000	27150	13180	46	0	\N
204293	1397	1278333968000	27150	13180	47	0	\N
204294	1397	1278323967000	27150	13180	48	0	\N
204295	1397	1278313966000	27150	13180	49	0	\N
204296	1397	1278303965000	27150	13180	50	0	\N
204297	1397	1278293964000	27150	13180	51	0	\N
204298	1397	1278283963000	27150	13180	52	0	\N
204299	1397	1278273962000	27150	13180	53	0	\N
204300	1397	1278263961000	27150	13180	54	0	\N
204301	1397	1278253960000	27150	13180	55	0	\N
204302	1397	1278243959000	27150	13180	56	0	\N
204303	1397	1278233958000	27150	13180	57	0	\N
204304	1397	1278223957000	27150	13180	58	0	\N
204305	1397	1278213956000	27150	13180	59	0	\N
204306	1397	1278203955000	27150	13180	60	0	\N
204307	1397	1278193954000	27150	13180	61	0	\N
204308	1397	1278183953000	27150	13180	63	0	\N
204309	1397	1278173952000	27150	13180	64	0	\N
204310	1397	1278163951000	27150	13180	65	0	\N
204311	1397	1278153950000	27150	13180	66	0	\N
204312	1397	1278143949000	27150	13180	67	0	\N
204313	1397	1278133948000	27150	13180	68	0	\N
204314	1397	1278123947000	27150	13180	69	0	\N
204315	1397	1278113946000	27150	13180	70	0	\N
204316	1397	1278103945000	27150	13180	71	0	\N
204317	1397	1278093944000	27150	13180	72	0	\N
204318	1397	1278083943000	27150	13180	73	0	\N
204319	1397	1278073942000	27150	13180	74	0	\N
204320	1397	1278063941000	27150	13180	75	0	\N
204321	1397	1278053940000	27150	13180	76	0	\N
204322	1397	1278043939000	27150	13180	77	0	\N
204323	1397	1278033938000	27150	13180	78	0	\N
204324	1397	1278023937000	27150	13180	79	0	\N
204325	1397	1278013936000	27150	13180	80	0	\N
204326	1397	1278003935000	27150	13180	81	0	\N
204327	1397	1277993934000	27150	13180	82	0	\N
204328	1397	1277983933000	27150	13180	83	0	\N
204329	1397	1277973932000	27150	13180	84	0	\N
204330	1397	1277963931000	27150	13180	85	0	\N
204331	1397	1277953930000	27150	13180	86	0	\N
204332	1397	1277943929000	27150	13180	87	0	\N
204333	1397	1277933928000	27150	13180	88	0	\N
204334	1397	1277923927000	27150	13180	89	0	\N
204335	1397	1277913926000	27150	13180	90	0	\N
204336	1397	1277903925000	27150	13180	91	0	\N
204337	1397	1277893924000	27150	13180	92	0	\N
204338	1397	1277883923000	27150	13180	93	0	\N
204339	1397	1277873922000	27150	13180	94	0	\N
204340	1397	1277863921000	27150	13180	95	0	\N
204341	1397	1277853920000	27150	13180	96	0	\N
204342	1397	1277843919000	27150	13180	97	0	\N
204343	1397	1277833918000	27150	13180	98	0	\N
204344	1397	1277823917000	27150	13180	99	0	\N
204345	1397	1277813916000	27150	13180	100	0	\N
204346	1397	1277803915000	27150	13180	101	0	\N
204347	1397	1277793914000	27150	13180	102	0	\N
204348	1397	1277783913000	27150	13180	103	0	\N
204349	1397	1277773912000	27150	13180	104	0	\N
204350	1397	1277763911000	27150	13180	105	0	\N
204351	1397	1277753910000	27150	13180	106	0	\N
204352	1397	1277743909000	27150	13180	107	0	\N
204353	1397	1277733908000	27150	13180	108	0	\N
204354	1397	1277723907000	27150	13180	109	0	\N
204355	1397	1277713906000	27150	13180	110	0	\N
204356	1397	1277703905000	27150	13180	111	0	\N
204357	1397	1277693904000	27150	13180	112	0	\N
204358	1397	1277683903000	27150	13180	113	0	\N
204359	1397	1277673902000	27150	13180	114	0	\N
204360	1397	1277663901000	27150	13180	115	0	\N
204361	1397	1277653900000	27150	13180	116	0	\N
204362	1397	1277643899000	27150	13180	117	0	\N
204363	1397	1277633898000	27150	13180	118	0	\N
204364	1397	1277623897000	27150	13180	119	0	\N
204365	1397	1277613896000	27150	13180	120	0	\N
204366	1397	1277603895000	27150	13180	121	0	\N
204367	1397	1277593894000	27150	13180	122	0	\N
204368	1397	1277583893000	27150	13180	123	0	\N
204369	1397	1277573892000	27150	13180	124	0	\N
204370	1397	1277563891000	27150	13180	125	0	\N
204373	1397	1275333668000	27152	13424	0	0	\N
204374	1397	1275323667000	27152	13424	2	0	\N
204375	1397	1275313666000	27152	13424	3	0	\N
204376	1397	1275303665000	27152	13424	4	0	\N
204377	2134	83918068000	27152	13424	5	0	\N
204378	2134	83917065000	27152	13424	6	0	\N
204379	2134	83916062000	27152	13424	7	0	\N
204380	2134	83915059000	27152	13424	8	0	\N
204381	2133	90513674000	27152	13424	9	0	\N
204382	2133	90512672000	27152	13424	10	0	\N
204383	2133	90511670000	27152	13424	11	0	\N
204384	2133	90510668000	27152	13424	12	0	\N
204385	1397	1275333668000	27153	13424	0	0	\N
204386	1397	1275323667000	27153	13424	2	0	\N
204387	1397	1275313666000	27153	13424	3	0	\N
204388	1397	1275303665000	27153	13424	4	0	\N
204389	2134	83918068000	27153	13424	5	0	\N
204390	2134	83917065000	27153	13424	6	0	\N
204391	2134	83916062000	27153	13424	7	0	\N
204392	2134	83915059000	27153	13424	8	0	\N
204393	2133	90513674000	27153	13424	9	0	\N
204394	2133	90512672000	27153	13424	10	0	\N
204395	2133	90511670000	27153	13424	11	0	\N
204396	2133	90510668000	27153	13424	12	0	\N
204397	1397	1275333668000	27154	13426	0	0	16349
204398	1397	1275323667000	27154	13426	1	0	16350
204399	1397	1275313666000	27154	13426	2	0	16351
204400	1397	1275303665000	27154	13426	3	0	16352
204401	2133	90510668000	27154	13426	4	0	6168
204403	1397	1275293664000	27155	13427	0	0	16353
204404	2134	83914056000	27155	13427	1	0	6656
204405	2133	90509666000	27155	13427	2	0	6169
204406	1397	1275283663000	27157	13428	0	0	16354
204407	1397	1275273662000	27157	13428	1	0	16355
204412	1397	1275283663000	27158	13428	0	0	\N
204413	1397	1275273662000	27158	13428	1	0	\N
204414	2133	90508664000	27158	13428	2	0	\N
204415	2133	90507662000	27158	13428	3	0	\N
204416	2134	83913053000	27158	13428	4	0	\N
204417	2134	83912050000	27158	13428	5	0	\N
204430	1397	1275223657000	27161	13431	0	0	\N
204431	2134	83907035000	27161	13431	1	0	\N
204432	2133	90502652000	27161	13431	2	0	\N
204439	364	66000011000000	27164	13234	0	0	\N
204440	1611	5687627453965	27164	13234	1	0	\N
204441	1611	4693464035601	27164	13234	2	0	\N
204442	1611	4022681841845	27164	13234	3	0	\N
204443	1611	2153489402899	27164	13234	4	0	\N
204444	1611	2153488402899	27164	13234	5	0	\N
204448	1397	1275193654000	27166	13434	0	0	\N
204449	2133	90499646000	27166	13434	1	0	\N
204450	2134	83904026000	27166	13434	2	0	\N
204451	1397	1275193654000	27167	13434	0	0	\N
204452	2133	90499646000	27167	13434	1	0	\N
204453	2134	83904026000	27167	13434	2	0	\N
204462	1397	1275183653000	27170	13435	0	0	\N
204463	1397	1275173652000	27170	13435	1	0	\N
204464	2134	83903023000	27170	13435	2	0	\N
204465	2133	90498644000	27170	13435	3	0	\N
204466	2133	90497642000	27170	13435	4	0	\N
204491	1397	1275083643000	27178	13443	0	0	\N
204492	1397	1275073642000	27178	13443	1	0	\N
204493	2134	83893996000	27178	13443	2	0	\N
204494	2133	90488624000	27178	13443	3	0	\N
204495	2133	90487622000	27178	13443	4	0	\N
204496	2134	83892993000	27178	13443	5	0	\N
204503	1397	1277553890000	27180	13181	0	0	\N
204504	1397	1277543889000	27180	13181	1	0	\N
204505	1397	1277533888000	27180	13181	2	0	\N
204506	1397	1277523887000	27180	13181	3	0	\N
204507	1397	1277513886000	27180	13181	4	0	\N
204508	1397	1277503885000	27180	13181	5	0	\N
204509	1397	1277493884000	27180	13181	6	0	\N
204510	1397	1277483883000	27180	13181	7	0	\N
204511	1397	1277473882000	27180	13181	8	0	\N
204512	1397	1277463881000	27180	13181	9	0	\N
204513	1397	1277453880000	27180	13181	10	0	\N
204514	1397	1277443879000	27180	13181	11	0	\N
204515	1397	1277433878000	27180	13181	12	0	\N
204516	1397	1277423877000	27180	13181	13	0	\N
204517	1397	1277413876000	27180	13181	14	0	\N
204518	1397	1277403875000	27180	13181	15	0	\N
204519	1397	1277393874000	27180	13181	16	0	\N
204520	1397	1277383873000	27180	13181	17	0	\N
204521	1397	1277373872000	27180	13181	18	0	\N
204522	1397	1277363871000	27180	13181	19	0	\N
204523	1397	1277353870000	27180	13181	20	0	\N
204524	1397	1277343869000	27180	13181	21	0	\N
204525	1397	1277333868000	27180	13181	22	0	\N
204526	1397	1277323867000	27180	13181	23	0	\N
204527	1397	1277313866000	27180	13181	24	0	\N
204528	1397	1277303865000	27180	13181	25	0	\N
204529	1397	1277293864000	27180	13181	26	0	\N
204530	1397	1277283863000	27180	13181	27	0	\N
204531	1397	1277273862000	27180	13181	28	0	\N
204532	1397	1277263861000	27180	13181	29	0	\N
204533	1397	1277253860000	27180	13181	30	0	\N
204534	1397	1277243859000	27180	13181	31	0	\N
204535	1397	1277233858000	27180	13181	32	0	\N
204536	1397	1277223857000	27180	13181	33	0	\N
204537	1397	1277213856000	27180	13181	34	0	\N
204538	1397	1277203855000	27180	13181	35	0	\N
204539	1397	1277193854000	27180	13181	36	0	\N
204540	1397	1277183853000	27180	13181	37	0	\N
204541	1397	1277173852000	27180	13181	38	0	\N
204542	1397	1277163851000	27180	13181	39	0	\N
204543	1397	1277153850000	27180	13181	40	0	\N
204544	1397	1277143849000	27180	13181	41	0	\N
204411	2134	83912050000	27157	13428	5	0	6658
204418	1397	1275263661000	27159	13429	0	0	16356
204419	2134	83911047000	27159	13429	1	0	6659
204420	2133	90506660000	27159	13429	2	0	6172
204421	1397	1275253660000	27160	13430	0	0	16357
204423	1397	1275233658000	27160	13430	2	0	16359
204424	2133	90505658000	27160	13430	3	0	6173
204425	2133	90504656000	27160	13430	4	0	6174
204426	2134	83910044000	27160	13430	5	0	6660
204427	2134	83909041000	27160	13430	6	0	6661
204429	2133	90503654000	27160	13430	8	0	6175
204433	1397	1275223657000	27162	13431	0	0	16360
204434	2134	83907035000	27162	13431	1	0	6663
204435	2133	90502652000	27162	13431	2	0	6176
204437	2133	90501650000	27163	13432	1	0	6177
204438	2134	83906032000	27163	13432	2	0	6664
204445	1397	1275203655000	27165	13433	0	0	16362
204446	2134	83905029000	27165	13433	1	0	6665
204447	2133	90500648000	27165	13433	2	0	6178
204455	2133	90499646000	27168	13434	1	0	6179
204456	2134	83904026000	27168	13434	2	0	6666
204457	1397	1275183653000	27169	13435	0	0	16364
204458	1397	1275173652000	27169	13435	1	0	16365
204459	2134	83903023000	27169	13435	2	0	6667
204461	2133	90497642000	27169	13435	4	0	6181
204467	1397	1275163651000	27171	13436	0	0	16366
204468	2134	83902020000	27171	13436	1	0	6668
204469	2133	90496640000	27171	13436	2	0	6182
204471	2134	83901017000	27172	13437	1	0	6669
204472	2133	90495638000	27172	13437	2	0	6183
204473	1397	1275143649000	27173	13438	0	0	16368
204474	2133	90494636000	27173	13438	1	0	6184
204475	2134	83900014000	27173	13438	2	0	6670
204477	2133	90493634000	27174	13439	1	0	6185
204478	2134	83899011000	27174	13439	2	0	6671
204479	1397	1275123647000	27175	13440	0	0	16370
204480	2134	83898008000	27175	13440	1	0	6672
204481	2133	90492632000	27175	13440	2	0	6186
204483	2133	90491630000	27176	13441	1	0	6187
204484	2134	83897005000	27176	13441	2	0	6673
204485	1397	1275103645000	27177	13442	0	0	16372
204486	1397	1275093644000	27177	13442	1	0	16373
204488	2134	83894999000	27177	13442	3	0	6675
204489	2133	90490628000	27177	13442	4	0	6188
204490	2133	90489626000	27177	13442	5	0	6189
204497	1397	1275083643000	27179	13443	0	0	16374
204498	1397	1275073642000	27179	13443	1	0	16375
204500	2133	90488624000	27179	13443	3	0	6190
204501	2133	90487622000	27179	13443	4	0	6191
204502	2134	83892993000	27179	13443	5	0	6677
204545	1397	1277133848000	27180	13181	42	0	\N
204546	1397	1277123847000	27180	13181	43	0	\N
204547	1397	1277113846000	27180	13181	44	0	\N
204548	1397	1277103845000	27180	13181	45	0	\N
204549	1397	1277093844000	27180	13181	46	0	\N
204550	1397	1277083843000	27180	13181	47	0	\N
204551	1397	1277073842000	27180	13181	48	0	\N
204552	1397	1277063841000	27180	13181	49	0	\N
204553	1397	1277053840000	27180	13181	50	0	\N
204554	1397	1277043839000	27180	13181	51	0	\N
204555	1397	1277033838000	27180	13181	52	0	\N
204556	1397	1277023837000	27180	13181	53	0	\N
204557	1397	1277013836000	27180	13181	54	0	\N
204558	1397	1277003835000	27180	13181	55	0	\N
204559	1397	1276993834000	27180	13181	56	0	\N
204560	1397	1276983833000	27180	13181	57	0	\N
204561	1397	1276973832000	27180	13181	58	0	\N
204562	1397	1276963831000	27180	13181	59	0	\N
204563	1397	1276953830000	27180	13181	60	0	\N
204564	1397	1276943829000	27180	13181	61	0	\N
204565	1397	1276933828000	27180	13181	63	0	\N
204566	1397	1276923827000	27180	13181	64	0	\N
204567	1397	1276913826000	27180	13181	65	0	\N
204568	1397	1276903825000	27180	13181	66	0	\N
204569	1397	1276893824000	27180	13181	67	0	\N
204570	1397	1276883823000	27180	13181	68	0	\N
204571	1397	1276873822000	27180	13181	69	0	\N
204572	1397	1276863821000	27180	13181	70	0	\N
204573	1397	1276853820000	27180	13181	71	0	\N
204574	1397	1276843819000	27180	13181	72	0	\N
204575	1397	1276833818000	27180	13181	73	0	\N
204576	1397	1276823817000	27180	13181	74	0	\N
204577	1397	1276813816000	27180	13181	75	0	\N
204578	1397	1276803815000	27180	13181	76	0	\N
204579	1397	1276793814000	27180	13181	77	0	\N
204580	1397	1276783813000	27180	13181	78	0	\N
204581	1397	1276773812000	27180	13181	79	0	\N
204582	1397	1276763811000	27180	13181	80	0	\N
204583	1397	1276753810000	27180	13181	81	0	\N
204584	1397	1276743809000	27180	13181	82	0	\N
204585	1397	1276733808000	27180	13181	83	0	\N
204586	1397	1276723807000	27180	13181	84	0	\N
204587	1397	1276713806000	27180	13181	85	0	\N
204588	1397	1276703805000	27180	13181	86	0	\N
204589	1397	1276693804000	27180	13181	87	0	\N
204590	1397	1276683803000	27180	13181	88	0	\N
204591	1397	1276673802000	27180	13181	89	0	\N
204592	1397	1276663801000	27180	13181	90	0	\N
204593	1397	1276653800000	27180	13181	91	0	\N
204594	1397	1276643799000	27180	13181	92	0	\N
204595	1397	1276633798000	27180	13181	93	0	\N
204596	1397	1276623797000	27180	13181	94	0	\N
204597	1397	1276613796000	27180	13181	95	0	\N
204598	1397	1276603795000	27180	13181	96	0	\N
204599	1397	1276593794000	27180	13181	97	0	\N
204600	1397	1276583793000	27180	13181	98	0	\N
204601	1397	1276573792000	27180	13181	99	0	\N
204602	1397	1276563791000	27180	13181	100	0	\N
204603	1397	1276553790000	27180	13181	101	0	\N
204604	1397	1276543789000	27180	13181	102	0	\N
204605	1397	1276533788000	27180	13181	103	0	\N
204606	1397	1276523787000	27180	13181	104	0	\N
204607	1397	1276513786000	27180	13181	105	0	\N
204608	1397	1276503785000	27180	13181	106	0	\N
204609	1397	1276493784000	27180	13181	107	0	\N
204610	1397	1276483783000	27180	13181	108	0	\N
204611	1397	1276473782000	27180	13181	109	0	\N
204612	1397	1276463781000	27180	13181	110	0	\N
204613	1397	1276453780000	27180	13181	111	0	\N
204614	1397	1276443779000	27180	13181	112	0	\N
204615	1397	1276433778000	27180	13181	113	0	\N
204616	1397	1276423777000	27180	13181	114	0	\N
204617	1397	1276413776000	27180	13181	115	0	\N
204618	1397	1276403775000	27180	13181	116	0	\N
204619	1397	1276393774000	27180	13181	117	0	\N
204620	1397	1276383773000	27180	13181	118	0	\N
204621	1397	1276373772000	27180	13181	119	0	\N
204622	1397	1276363771000	27180	13181	120	0	\N
204623	1397	1276353770000	27180	13181	121	0	\N
204624	1397	1276343769000	27180	13181	122	0	\N
204625	1397	1276333768000	27180	13181	123	0	\N
204626	1397	1276323767000	27180	13181	124	0	\N
204627	1397	1276313766000	27180	13181	125	0	\N
204631	1397	1275053640000	27182	13445	0	0	\N
204632	1397	1275043639000	27182	13445	2	0	\N
204633	2133	90485618000	27182	13445	3	0	\N
204634	2134	83890987000	27182	13445	4	0	\N
204635	2134	83889984000	27182	13445	5	0	\N
204636	2133	90484616000	27182	13445	6	0	\N
204637	1397	1275053640000	27183	13445	0	0	\N
204638	1397	1275043639000	27183	13445	2	0	\N
204639	2133	90485618000	27183	13445	3	0	\N
204640	2134	83890987000	27183	13445	4	0	\N
204641	2134	83889984000	27183	13445	5	0	\N
204642	2133	90484616000	27183	13445	6	0	\N
204652	1397	1275023637000	27186	13447	0	0	\N
204653	2133	90482612000	27186	13447	1	0	\N
204654	1397	1275023637000	27187	13447	0	0	\N
204655	2133	90482612000	27187	13447	1	0	\N
204656	2134	83887978000	27187	13447	2	0	\N
204660	2133	90482612000	27189	13447	0	0	\N
204661	2134	83887978000	27189	13447	1	0	\N
204662	1397	1275023637000	27190	13447	0	0	\N
204663	2133	90482612000	27190	13447	1	0	\N
204664	2134	83887978000	27190	13447	2	0	\N
204665	1397	1275013636000	27191	13448	0	0	\N
204666	2134	83886975000	27191	13448	1	0	\N
204667	2133	90481610000	27191	13448	2	0	\N
204679	1397	1275413676000	27195	13418	0	0	\N
204680	1397	1275403675000	27195	13418	1	0	\N
204630	2134	83891990000	27181	13444	2	0	6678
204643	1397	1275053640000	27184	13445	0	0	16377
204644	1397	1275043639000	27184	13445	2	0	16378
204645	2133	90485618000	27184	13445	3	0	6193
204646	2134	83890987000	27184	13445	4	0	6679
204648	2133	90484616000	27184	13445	6	0	6194
204649	1397	1275033638000	27185	13446	0	0	16379
204650	2134	83888981000	27185	13446	1	0	6681
204651	2133	90483614000	27185	13446	2	0	6195
204657	1397	1275023637000	27188	13447	0	0	16380
204659	2134	83887978000	27188	13447	2	0	6682
204668	1397	1275013636000	27192	13448	0	0	16381
204669	2134	83886975000	27192	13448	1	0	6683
204670	2133	90481610000	27192	13448	2	0	6197
204672	1397	1274993634000	27193	13449	1	0	16383
204673	2133	90480608000	27193	13449	2	0	6198
204674	2133	90479606000	27193	13449	3	0	6199
204675	2134	83885972000	27193	13449	4	0	6684
204676	2134	83884969000	27193	13449	5	0	6685
204678	2134	83883966000	27194	13450	1	0	6686
204681	1397	1275393674000	27195	13418	2	0	\N
204682	1397	1275383673000	27195	13418	3	0	\N
204683	1397	1275373672000	27195	13418	4	0	\N
204684	1397	1275363671000	27195	13418	5	0	\N
204685	1397	1275353670000	27195	13418	6	0	\N
204686	1397	1275343669000	27195	13418	7	0	\N
204687	1397	1275333668000	27195	13418	8	0	\N
204688	1397	1275323667000	27195	13418	9	0	\N
204689	1397	1275313666000	27195	13418	10	0	\N
204690	1397	1275303665000	27195	13418	11	0	\N
204691	1397	1275293664000	27195	13418	12	0	\N
204692	1397	1275283663000	27195	13418	13	0	\N
204693	1397	1275273662000	27195	13418	14	0	\N
204694	1397	1275263661000	27195	13418	15	0	\N
204695	1397	1275253660000	27195	13418	16	0	\N
204696	1397	1275243659000	27195	13418	17	0	\N
204697	1397	1275233658000	27195	13418	18	0	\N
204698	1397	1275223657000	27195	13418	19	0	\N
204699	1397	1275213656000	27195	13418	20	0	\N
204700	1397	1275203655000	27195	13418	21	0	\N
204701	1397	1275193654000	27195	13418	22	0	\N
204702	1397	1275183653000	27195	13418	23	0	\N
204703	1397	1275173652000	27195	13418	24	0	\N
204704	1397	1275163651000	27195	13418	25	0	\N
204705	1397	1275153650000	27195	13418	26	0	\N
204706	1397	1275143649000	27195	13418	27	0	\N
204707	1397	1275133648000	27195	13418	28	0	\N
204708	1397	1275123647000	27195	13418	29	0	\N
204709	1397	1275113646000	27195	13418	30	0	\N
204710	1397	1275103645000	27195	13418	31	0	\N
204711	1397	1275093644000	27195	13418	32	0	\N
204712	1397	1275083643000	27195	13418	33	0	\N
204713	1397	1275073642000	27195	13418	34	0	\N
204714	1397	1275063641000	27195	13418	35	0	\N
204715	1397	1275053640000	27195	13418	37	0	\N
204716	1397	1275043639000	27195	13418	38	0	\N
204717	1397	1275033638000	27195	13418	39	0	\N
204718	1397	1275023637000	27195	13418	40	0	\N
204719	1397	1275013636000	27195	13418	41	0	\N
204720	1397	1275003635000	27195	13418	42	0	\N
204721	1397	1274993634000	27195	13418	43	0	\N
204722	1397	1274983633000	27195	13418	44	0	\N
204723	1397	1274973632000	27195	13418	45	0	\N
204724	2133	90521690000	27195	13418	46	0	\N
204725	2133	90520688000	27195	13418	47	0	\N
204726	2133	90519686000	27195	13418	48	0	\N
204727	2133	90518684000	27195	13418	49	0	\N
204728	2133	90517682000	27195	13418	50	0	\N
204729	2133	90516680000	27195	13418	51	0	\N
204730	2133	90515678000	27195	13418	52	0	\N
204731	2133	90514676000	27195	13418	53	0	\N
204732	2134	83925089000	27195	13418	54	0	\N
204733	2134	83924086000	27195	13418	55	0	\N
204734	2134	83923083000	27195	13418	56	0	\N
204735	2134	83922080000	27195	13418	57	0	\N
204736	2134	83921077000	27195	13418	58	0	\N
204737	2134	83920074000	27195	13418	59	0	\N
204738	2134	83919071000	27195	13418	60	0	\N
204739	2134	83918068000	27195	13418	61	0	\N
204740	2134	83917065000	27195	13418	62	0	\N
204741	2134	83916062000	27195	13418	63	0	\N
204742	2134	83915059000	27195	13418	64	0	\N
204743	2134	83914056000	27195	13418	65	0	\N
204744	2134	83913053000	27195	13418	66	0	\N
204745	2134	83912050000	27195	13418	67	0	\N
204746	2134	83911047000	27195	13418	68	0	\N
204747	2134	83910044000	27195	13418	69	0	\N
204748	2134	83909041000	27195	13418	70	0	\N
204749	2134	83908038000	27195	13418	71	0	\N
204750	2134	83907035000	27195	13418	72	0	\N
204751	2134	83906032000	27195	13418	73	0	\N
204752	2134	83905029000	27195	13418	74	0	\N
204753	2134	83904026000	27195	13418	75	0	\N
204754	2134	83903023000	27195	13418	76	0	\N
204755	2134	83902020000	27195	13418	77	0	\N
204756	2134	83901017000	27195	13418	78	0	\N
204757	2134	83900014000	27195	13418	79	0	\N
204758	2134	83899011000	27195	13418	80	0	\N
204759	2134	83898008000	27195	13418	81	0	\N
204760	2134	83897005000	27195	13418	82	0	\N
204761	2134	83896002000	27195	13418	83	0	\N
204762	2134	83894999000	27195	13418	84	0	\N
204763	2134	83893996000	27195	13418	85	0	\N
204764	2134	83892993000	27195	13418	86	0	\N
204765	2134	83891990000	27195	13418	87	0	\N
204766	2134	83890987000	27195	13418	88	0	\N
204767	2134	83889984000	27195	13418	89	0	\N
204768	2134	83888981000	27195	13418	90	0	\N
204769	2134	83887978000	27195	13418	91	0	\N
204770	2134	83886975000	27195	13418	92	0	\N
204771	2134	83885972000	27195	13418	93	0	\N
204772	2134	83884969000	27195	13418	94	0	\N
204773	2134	83883966000	27195	13418	95	0	\N
204774	2134	83882963000	27195	13418	96	0	\N
204775	2133	90513674000	27195	13418	97	0	\N
204776	2133	90512672000	27195	13418	98	0	\N
204777	2133	90511670000	27195	13418	99	0	\N
204778	2133	90510668000	27195	13418	100	0	\N
204779	2133	90509666000	27195	13418	101	0	\N
204780	2133	90508664000	27195	13418	102	0	\N
204781	2133	90507662000	27195	13418	103	0	\N
204782	2133	90506660000	27195	13418	104	0	\N
204783	2133	90505658000	27195	13418	105	0	\N
204784	2133	90504656000	27195	13418	106	0	\N
204785	2133	90503654000	27195	13418	107	0	\N
204786	2133	90502652000	27195	13418	108	0	\N
204787	2133	90501650000	27195	13418	109	0	\N
204788	2133	90500648000	27195	13418	110	0	\N
204789	2133	90499646000	27195	13418	111	0	\N
204790	2133	90498644000	27195	13418	112	0	\N
204791	2133	90497642000	27195	13418	113	0	\N
204792	2133	90496640000	27195	13418	114	0	\N
204793	2133	90495638000	27195	13418	115	0	\N
204794	2133	90494636000	27195	13418	116	0	\N
204795	2133	90493634000	27195	13418	117	0	\N
204796	2133	90492632000	27195	13418	118	0	\N
204797	2133	90491630000	27195	13418	119	0	\N
204798	2133	90490628000	27195	13418	120	0	\N
204799	2133	90489626000	27195	13418	121	0	\N
204800	2133	90488624000	27195	13418	122	0	\N
204801	2133	90487622000	27195	13418	123	0	\N
204802	2133	90486620000	27195	13418	124	0	\N
204803	2133	90485618000	27195	13418	125	0	\N
204806	2134	83882963000	27196	13451	2	0	6687
204807	2133	90478604000	27196	13451	3	0	6200
204808	2133	90477602000	27196	13451	4	0	6201
204809	2134	83881960000	27196	13451	5	0	6688
204810	1397	1274953630000	27197	13452	0	0	16387
204812	2134	83880957000	27197	13452	2	0	6689
204813	1397	1274943629000	27198	13453	0	0	16388
204814	2134	83879954000	27198	13453	1	0	6690
204815	1726	954957112000	27198	13453	2	0	8328
204816	2133	90475598000	27198	13453	3	0	6203
204818	1397	1274943629000	27199	13453	0	0	\N
204819	2134	83879954000	27199	13453	1	0	\N
204820	1726	954957112000	27199	13453	2	0	\N
204821	2133	90475598000	27199	13453	3	0	\N
204822	1726	953856112000	27199	13453	4	0	\N
204823	1397	1274943629000	27200	13453	0	0	\N
204824	2134	83879954000	27200	13453	1	0	\N
204825	1726	954957112000	27200	13453	2	0	\N
204826	2133	90475598000	27200	13453	3	0	\N
204827	1726	953856112000	27200	13453	4	0	\N
204828	1726	954957112000	27201	13399	0	0	\N
204829	1726	953856112000	27201	13399	1	0	\N
204840	1397	1274923627000	27204	13455	0	0	\N
204841	1397	1274913626000	27204	13455	1	0	\N
204842	2134	83877948000	27204	13455	2	0	\N
204843	1726	952755112000	27204	13455	3	0	\N
204844	2133	90473594000	27204	13455	4	0	\N
204845	2133	90472592000	27204	13455	5	0	\N
204846	2134	83876945000	27204	13455	6	0	\N
204850	1397	1274903625000	27206	13456	0	0	\N
204851	2133	90471590000	27206	13456	1	0	\N
204852	2134	83875942000	27206	13456	2	0	\N
204858	1397	1274873622000	27209	13458	0	0	\N
204859	2133	90468584000	27209	13458	1	0	\N
204860	2134	83873936000	27209	13458	2	0	\N
204861	1397	1274873622000	27210	13458	0	0	\N
204862	2133	90468584000	27210	13458	1	0	\N
204863	2134	83873936000	27210	13458	2	0	\N
204870	1397	1275593694000	27213	13313	0	0	\N
204871	1397	1275583693000	27213	13313	1	0	\N
204872	1397	1275573692000	27213	13313	2	0	\N
204873	1397	1275563691000	27213	13313	3	0	\N
204874	1397	1275553690000	27213	13313	4	0	\N
204875	1397	1275543689000	27213	13313	5	0	\N
204876	1397	1275533688000	27213	13313	6	0	\N
204877	1397	1275523687000	27213	13313	7	0	\N
204878	1397	1275513686000	27213	13313	8	0	\N
204879	1397	1275503685000	27213	13313	9	0	\N
204880	1397	1275493684000	27213	13313	10	0	\N
204881	1397	1275483683000	27213	13313	11	0	\N
204882	1397	1275473682000	27213	13313	12	0	\N
204883	1397	1275463681000	27213	13313	13	0	\N
204884	1397	1275453680000	27213	13313	14	0	\N
204885	1397	1275443679000	27213	13313	15	0	\N
204886	1397	1275433678000	27213	13313	16	0	\N
204887	1397	1275423677000	27213	13313	17	0	\N
204888	1397	1275413676000	27213	13313	18	0	\N
204889	1397	1275403675000	27213	13313	19	0	\N
204890	1397	1275393674000	27213	13313	20	0	\N
204891	1397	1275383673000	27213	13313	21	0	\N
204892	1397	1275373672000	27213	13313	22	0	\N
204893	1397	1275363671000	27213	13313	23	0	\N
204894	1397	1275353670000	27213	13313	24	0	\N
204895	1397	1275343669000	27213	13313	25	0	\N
204896	1397	1275333668000	27213	13313	26	0	\N
204897	1397	1275323667000	27213	13313	27	0	\N
204898	1397	1275313666000	27213	13313	28	0	\N
204899	1397	1275303665000	27213	13313	29	0	\N
204900	1397	1275293664000	27213	13313	30	0	\N
204901	1397	1275283663000	27213	13313	31	0	\N
204902	1397	1275273662000	27213	13313	32	0	\N
204903	1397	1275263661000	27213	13313	33	0	\N
204904	1397	1275253660000	27213	13313	34	0	\N
204905	1397	1275243659000	27213	13313	35	0	\N
204906	1397	1275233658000	27213	13313	36	0	\N
204907	1397	1275223657000	27213	13313	37	0	\N
204908	1397	1275213656000	27213	13313	38	0	\N
204909	1397	1275203655000	27213	13313	39	0	\N
204910	1397	1275193654000	27213	13313	40	0	\N
204911	1397	1275183653000	27213	13313	41	0	\N
204912	1397	1275173652000	27213	13313	42	0	\N
204913	1397	1275163651000	27213	13313	43	0	\N
204914	1397	1275153650000	27213	13313	44	0	\N
204915	1397	1275143649000	27213	13313	45	0	\N
204916	1397	1275133648000	27213	13313	46	0	\N
204917	1397	1275123647000	27213	13313	47	0	\N
204918	1397	1275113646000	27213	13313	48	0	\N
204919	1397	1275103645000	27213	13313	49	0	\N
204920	1397	1275093644000	27213	13313	50	0	\N
204921	1397	1275083643000	27213	13313	51	0	\N
204922	1397	1275073642000	27213	13313	52	0	\N
204923	1397	1275063641000	27213	13313	53	0	\N
204924	1397	1275053640000	27213	13313	54	0	\N
204925	1397	1275043639000	27213	13313	55	0	\N
204926	1397	1275033638000	27213	13313	56	0	\N
204927	1397	1275023637000	27213	13313	57	0	\N
204928	1397	1275013636000	27213	13313	59	0	\N
204929	1397	1275003635000	27213	13313	60	0	\N
204930	1397	1274993634000	27213	13313	61	0	\N
204931	1397	1274983633000	27213	13313	62	0	\N
204932	1397	1274973632000	27213	13313	63	0	\N
204933	1397	1274963631000	27213	13313	64	0	\N
204934	1397	1274953630000	27213	13313	65	0	\N
204935	1397	1274943629000	27213	13313	66	0	\N
204936	1397	1274933628000	27213	13313	67	0	\N
204937	1397	1274923627000	27213	13313	68	0	\N
204938	1397	1274913626000	27213	13313	69	0	\N
204939	1397	1274903625000	27213	13313	70	0	\N
204940	1397	1274893624000	27213	13313	71	0	\N
204941	1397	1274883623000	27213	13313	72	0	\N
204942	1397	1274873622000	27213	13313	73	0	\N
204943	1397	1274863621000	27213	13313	74	0	\N
204944	1397	1274853620000	27213	13313	75	0	\N
204945	1397	1274843619000	27213	13313	76	0	\N
204946	1397	1274833618000	27213	13313	77	0	\N
204947	1397	1274823617000	27213	13313	78	0	\N
204948	1397	1274813616000	27213	13313	79	0	\N
204949	1726	954957112000	27213	13313	80	0	\N
204950	1726	953856112000	27213	13313	81	0	\N
204951	1726	952755112000	27213	13313	82	0	\N
204952	2134	84040434000	27213	13313	83	0	\N
204831	2133	90474596000	27202	13454	1	0	6204
204832	2134	83878951000	27202	13454	2	0	6691
204833	1397	1274923627000	27203	13455	0	0	16390
204834	1397	1274913626000	27203	13455	1	0	16391
204835	2134	83877948000	27203	13455	2	0	6692
204837	2133	90473594000	27203	13455	4	0	6205
204838	2133	90472592000	27203	13455	5	0	6206
204839	2134	83876945000	27203	13455	6	0	6693
204847	1397	1274903625000	27205	13456	0	0	16392
204848	2133	90471590000	27205	13456	1	0	6207
204853	1397	1274893624000	27207	13457	0	0	16393
204854	1397	1274883623000	27207	13457	1	0	16394
204855	2134	83874939000	27207	13457	2	0	6695
204856	2133	90470588000	27207	13457	3	0	6208
204864	1397	1274873622000	27211	13458	0	0	16395
204865	2133	90468584000	27211	13458	1	0	6210
204866	2134	83873936000	27211	13458	2	0	6696
204867	1397	1274863621000	27212	13459	0	0	16396
204868	2134	83872933000	27212	13459	1	0	6697
204953	2134	84039431000	27213	13313	84	0	\N
204954	2134	84038428000	27213	13313	85	0	\N
204955	2134	84037425000	27213	13313	86	0	\N
204956	2134	84036422000	27213	13313	87	0	\N
204957	2134	84035419000	27213	13313	88	0	\N
204958	2134	84034416000	27213	13313	89	0	\N
204959	1397	1274853620000	27214	13460	0	0	\N
204960	1397	1274843619000	27214	13460	1	0	\N
204961	1397	1274833618000	27214	13460	2	0	\N
204962	1397	1274823617000	27214	13460	3	0	\N
204963	1397	1274813616000	27214	13460	4	0	\N
204964	1397	1274803615000	27214	13460	5	0	\N
204965	1397	1274793614000	27214	13460	6	0	\N
204966	2133	90466580000	27214	13460	7	0	\N
204967	2134	83871930000	27214	13460	8	0	\N
204968	2134	83870927000	27214	13460	9	0	\N
204969	2134	83869924000	27214	13460	10	0	\N
204970	2134	83868921000	27214	13460	11	0	\N
204971	2134	83867918000	27214	13460	12	0	\N
204972	2134	83866915000	27214	13460	13	0	\N
204973	2134	83865912000	27214	13460	14	0	\N
204974	2133	90465578000	27214	13460	15	0	\N
204975	2133	90464576000	27214	13460	16	0	\N
204976	2133	90463574000	27214	13460	17	0	\N
204977	2133	90462572000	27214	13460	18	0	\N
204978	2133	90461570000	27214	13460	19	0	\N
204979	2133	90460568000	27214	13460	20	0	\N
205001	1397	1274963631000	27216	13419	0	0	\N
205002	1397	1274953630000	27216	13419	1	0	\N
205003	1397	1274943629000	27216	13419	2	0	\N
205004	1397	1274933628000	27216	13419	3	0	\N
205005	1397	1274923627000	27216	13419	4	0	\N
205006	1397	1274913626000	27216	13419	5	0	\N
205007	1397	1274903625000	27216	13419	6	0	\N
205008	1397	1274893624000	27216	13419	7	0	\N
205009	1397	1274883623000	27216	13419	8	0	\N
205010	1397	1274873622000	27216	13419	9	0	\N
205011	1397	1274863621000	27216	13419	10	0	\N
205012	1397	1274853620000	27216	13419	11	0	\N
205013	1397	1274843619000	27216	13419	12	0	\N
205014	1397	1274833618000	27216	13419	13	0	\N
205015	1397	1274823617000	27216	13419	14	0	\N
205016	1397	1274813616000	27216	13419	15	0	\N
205017	1397	1274803615000	27216	13419	16	0	\N
205018	1397	1274793614000	27216	13419	17	0	\N
205019	1397	1274783613000	27216	13419	18	0	\N
205020	1397	1274773612000	27216	13419	19	0	\N
205021	1726	954957112000	27216	13419	20	0	\N
205022	1726	953856112000	27216	13419	21	0	\N
205023	1726	952755112000	27216	13419	22	0	\N
205024	2134	83881960000	27216	13419	23	0	\N
205025	2134	83880957000	27216	13419	24	0	\N
205026	2134	83879954000	27216	13419	25	0	\N
205027	2134	83878951000	27216	13419	26	0	\N
205028	2134	83877948000	27216	13419	27	0	\N
205029	2134	83876945000	27216	13419	28	0	\N
205030	2134	83875942000	27216	13419	29	0	\N
205031	2134	83874939000	27216	13419	30	0	\N
205032	2133	90484616000	27216	13419	31	0	\N
205033	2133	90483614000	27216	13419	32	0	\N
205034	2133	90482612000	27216	13419	33	0	\N
205035	2133	90481610000	27216	13419	34	0	\N
205036	2133	90480608000	27216	13419	35	0	\N
205037	2133	90479606000	27216	13419	37	0	\N
205038	2133	90478604000	27216	13419	38	0	\N
205039	2133	90477602000	27216	13419	39	0	\N
205040	2133	90476600000	27216	13419	40	0	\N
205041	2133	90475598000	27216	13419	41	0	\N
205042	2133	90474596000	27216	13419	42	0	\N
205043	2133	90473594000	27216	13419	43	0	\N
205044	2133	90472592000	27216	13419	44	0	\N
205045	2133	90471590000	27216	13419	45	0	\N
205046	2133	90470588000	27216	13419	46	0	\N
205047	2133	90469586000	27216	13419	47	0	\N
205048	2133	90468584000	27216	13419	48	0	\N
205049	2133	90467582000	27216	13419	49	0	\N
205050	2133	90466580000	27216	13419	50	0	\N
205051	2134	83873936000	27216	13419	51	0	\N
205052	2134	83872933000	27216	13419	52	0	\N
205053	2134	83871930000	27216	13419	53	0	\N
205054	2134	83870927000	27216	13419	54	0	\N
205055	2134	83869924000	27216	13419	55	0	\N
205056	2134	83868921000	27216	13419	56	0	\N
205057	2134	83867918000	27216	13419	57	0	\N
205058	2134	83866915000	27216	13419	58	0	\N
205059	2134	83865912000	27216	13419	59	0	\N
205060	2134	83864909000	27216	13419	60	0	\N
205061	2134	83863906000	27216	13419	61	0	\N
205062	2133	90465578000	27216	13419	62	0	\N
205063	2133	90464576000	27216	13419	63	0	\N
205064	2133	90463574000	27216	13419	64	0	\N
205065	2133	90462572000	27216	13419	65	0	\N
205066	2133	90461570000	27216	13419	66	0	\N
205067	2133	90460568000	27216	13419	67	0	\N
205068	2133	90459566000	27216	13419	68	0	\N
205069	2133	90458564000	27216	13419	69	0	\N
205079	1397	1274783613000	27218	13461	0	0	\N
205080	1397	1274773612000	27218	13461	1	0	\N
205081	1397	1274763611000	27218	13461	2	0	\N
205082	2134	83864909000	27218	13461	3	0	\N
205083	2134	83863906000	27218	13461	4	0	\N
205084	2134	83862903000	27218	13461	5	0	\N
205085	2133	90459566000	27218	13461	6	0	\N
205086	2133	90458564000	27218	13461	7	0	\N
205087	2133	90457562000	27218	13461	8	0	\N
205088	1397	1274783613000	27219	13461	0	0	\N
204982	1397	1274833618000	27215	13460	2	0	16399
204983	1397	1274823617000	27215	13460	3	0	16400
204984	1397	1274813616000	27215	13460	4	0	16401
204985	1397	1274803615000	27215	13460	5	0	16402
204986	1397	1274793614000	27215	13460	6	0	16403
204988	2134	83871930000	27215	13460	8	0	6698
204989	2134	83870927000	27215	13460	9	0	6699
204990	2134	83869924000	27215	13460	10	0	6700
204991	2134	83868921000	27215	13460	11	0	6701
204992	2134	83867918000	27215	13460	12	0	6702
204994	2134	83865912000	27215	13460	14	0	6704
204995	2133	90465578000	27215	13460	15	0	6213
204996	2133	90464576000	27215	13460	16	0	6214
204997	2133	90463574000	27215	13460	17	0	6215
204999	2133	90461570000	27215	13460	19	0	6217
205000	2133	90460568000	27215	13460	20	0	6218
205070	1397	1274783613000	27217	13461	0	0	16404
205071	1397	1274773612000	27217	13461	1	0	16405
205072	1397	1274763611000	27217	13461	2	0	16406
205074	2134	83863906000	27217	13461	4	0	6706
205075	2134	83862903000	27217	13461	5	0	6707
205076	2133	90459566000	27217	13461	6	0	6219
205077	2133	90458564000	27217	13461	7	0	6220
205078	2133	90457562000	27217	13461	8	0	6221
205089	1397	1274773612000	27219	13461	1	0	\N
205090	1397	1274763611000	27219	13461	2	0	\N
205091	2134	83864909000	27219	13461	3	0	\N
205092	2134	83863906000	27219	13461	4	0	\N
205093	2134	83862903000	27219	13461	5	0	\N
205094	2133	90459566000	27219	13461	6	0	\N
205095	2133	90458564000	27219	13461	7	0	\N
205096	2133	90457562000	27219	13461	8	0	\N
205097	1397	1274753610000	27220	13462	0	0	\N
205098	2134	83861900000	27220	13462	1	0	\N
205099	2133	90456560000	27220	13462	2	0	\N
205100	1397	1274753610000	27221	13462	0	0	\N
205101	2134	83861900000	27221	13462	1	0	\N
205102	2133	90456560000	27221	13462	2	0	\N
205106	1397	1274743609000	27223	13463	0	0	\N
205107	2134	83860897000	27223	13463	1	0	\N
205108	2133	90455558000	27223	13463	2	0	\N
205109	1397	1274743609000	27224	13463	0	0	\N
205110	2134	83860897000	27224	13463	1	0	\N
205111	2133	90455558000	27224	13463	2	0	\N
205112	1397	1274743609000	27225	13463	0	0	\N
205113	2134	83860897000	27225	13463	1	0	\N
205114	2133	90455558000	27225	13463	2	0	\N
205115	1397	1274743609000	27226	13463	0	0	\N
205116	2134	83860897000	27226	13463	1	0	\N
205117	2133	90455558000	27226	13463	2	0	\N
205121	1397	1274733608000	27228	13464	0	0	\N
205122	1397	1274723607000	27228	13464	1	0	\N
205123	2133	90454556000	27228	13464	2	0	\N
205124	2133	90453554000	27228	13464	3	0	\N
205125	2134	83859894000	27228	13464	4	0	\N
205126	2134	83858891000	27228	13464	5	0	\N
205139	1397	1274703605000	27232	13466	0	0	\N
205140	2133	90451550000	27232	13466	1	0	\N
205141	2134	83856885000	27232	13466	2	0	\N
205142	1397	1274703605000	27233	13466	0	0	\N
205143	2133	90451550000	27233	13466	1	0	\N
205144	2134	83856885000	27233	13466	2	0	\N
205145	1397	1274703605000	27234	13466	0	0	\N
205146	2133	90451550000	27234	13466	1	0	\N
205147	2134	83856885000	27234	13466	2	0	\N
205148	1397	1274703605000	27235	13466	0	0	\N
205152	1397	1274693604000	27237	13467	0	0	\N
205153	2134	83855882000	27237	13467	1	0	\N
205167	1397	1274633598000	27242	13471	0	0	\N
205168	2133	90444536000	27242	13471	1	0	\N
205169	2134	83853876000	27242	13471	2	0	\N
205170	1726	949452112000	27242	13471	3	0	\N
205171	1397	1274633598000	27243	13471	0	0	\N
205172	2133	90444536000	27243	13471	1	0	\N
205173	2134	83853876000	27243	13471	2	0	\N
205174	1726	949452112000	27243	13471	3	0	\N
205182	1726	954957112000	27246	13382	0	0	\N
205183	1397	1274613596000	27247	13473	0	0	\N
205184	2134	83851870000	27247	13473	1	0	\N
205185	2133	90442532000	27247	13473	2	0	\N
205189	1397	1274613596000	27249	13473	0	0	\N
205190	2134	83851870000	27249	13473	1	0	\N
205191	2133	90442532000	27249	13473	2	0	\N
205192	1397	1274613596000	27250	13473	0	0	\N
205193	2134	83851870000	27250	13473	1	0	\N
205194	2133	90442532000	27250	13473	2	0	\N
205195	1397	1275503685000	27251	13411	0	0	\N
205196	1397	1275493684000	27251	13411	1	0	\N
205197	1397	1275483683000	27251	13411	2	0	\N
205198	1397	1275473682000	27251	13411	3	0	\N
205199	1397	1275463681000	27251	13411	4	0	\N
205200	1397	1275453680000	27251	13411	5	0	\N
205201	1397	1275443679000	27251	13411	6	0	\N
205202	1397	1275433678000	27251	13411	7	0	\N
205203	1397	1275423677000	27251	13411	8	0	\N
205204	1397	1275413676000	27251	13411	9	0	\N
205205	1397	1275403675000	27251	13411	10	0	\N
205206	1397	1275393674000	27251	13411	11	0	\N
205207	1397	1275383673000	27251	13411	12	0	\N
205208	1397	1275373672000	27251	13411	13	0	\N
205209	1397	1275363671000	27251	13411	14	0	\N
205210	1397	1275353670000	27251	13411	15	0	\N
205211	1397	1275343669000	27251	13411	16	0	\N
205212	1397	1275333668000	27251	13411	17	0	\N
205213	1397	1275323667000	27251	13411	18	0	\N
205214	1397	1275313666000	27251	13411	19	0	\N
205215	1397	1275303665000	27251	13411	20	0	\N
205216	1397	1275293664000	27251	13411	21	0	\N
205217	1397	1275283663000	27251	13411	22	0	\N
205218	1397	1275273662000	27251	13411	23	0	\N
205219	1397	1275263661000	27251	13411	24	0	\N
205220	1397	1275253660000	27251	13411	25	0	\N
205221	1397	1275243659000	27251	13411	26	0	\N
205222	1397	1275233658000	27251	13411	27	0	\N
205223	1397	1275223657000	27251	13411	28	0	\N
205224	1397	1275213656000	27251	13411	29	0	\N
205105	2133	90456560000	27222	13462	2	0	6222
205118	1397	1274743609000	27227	13463	0	0	16408
205119	2134	83860897000	27227	13463	1	0	6709
205120	2133	90455558000	27227	13463	2	0	6223
205127	1397	1274733608000	27229	13464	0	0	16409
205129	2133	90454556000	27229	13464	2	0	6224
205130	2133	90453554000	27229	13464	3	0	6225
205131	2134	83859894000	27229	13464	4	0	6710
205132	2134	83858891000	27229	13464	5	0	6711
205133	1397	1274713606000	27230	13465	0	0	16411
205135	2133	90452552000	27230	13465	2	0	6226
205136	1397	1274703605000	27231	13466	0	0	16412
205137	2133	90451550000	27231	13466	1	0	6227
205138	2134	83856885000	27231	13466	2	0	6713
205150	2133	90450548000	27236	13467	1	0	6228
205151	2134	83855882000	27236	13467	2	0	6714
205154	1397	1274683603000	27239	13468	0	0	16414
205155	1397	1274673602000	27239	13468	1	0	16415
205156	1397	1274663601000	27239	13468	2	0	16416
205158	1726	951654112000	27239	13468	4	0	8331
205159	1726	950553112000	27239	13468	5	0	8332
205160	2133	90449546000	27239	13468	6	0	6229
205161	2133	90448544000	27239	13468	7	0	6230
205162	2133	90447542000	27239	13468	8	0	6231
205164	2133	90446540000	27240	13469	1	0	6232
205165	1397	1274643599000	27241	13470	0	0	16418
205166	2133	90445538000	27241	13470	1	0	6233
205175	1397	1274633598000	27244	13471	0	0	16419
205177	2134	83853876000	27244	13471	2	0	6716
205178	1726	949452112000	27244	13471	3	0	8333
205179	1397	1274623597000	27245	13472	0	0	16420
205180	2134	83852873000	27245	13472	1	0	6717
205181	2133	90443534000	27245	13472	2	0	6235
205187	2134	83851870000	27248	13473	1	0	6718
205188	2133	90442532000	27248	13473	2	0	6236
205225	1397	1275203655000	27251	13411	30	0	\N
205226	1397	1275193654000	27251	13411	31	0	\N
205227	1397	1275183653000	27251	13411	32	0	\N
205228	1397	1275173652000	27251	13411	33	0	\N
205229	1397	1275163651000	27251	13411	34	0	\N
205230	1397	1275153650000	27251	13411	35	0	\N
205231	1397	1275143649000	27251	13411	36	0	\N
205232	1397	1275133648000	27251	13411	37	0	\N
205233	1397	1275123647000	27251	13411	38	0	\N
205234	1397	1275113646000	27251	13411	39	0	\N
205235	1397	1275103645000	27251	13411	40	0	\N
205236	1397	1275093644000	27251	13411	41	0	\N
205237	1397	1275083643000	27251	13411	42	0	\N
205238	1397	1275073642000	27251	13411	43	0	\N
205239	1397	1275063641000	27251	13411	44	0	\N
205240	1397	1275053640000	27251	13411	45	0	\N
205241	1397	1275043639000	27251	13411	46	0	\N
205242	1397	1275033638000	27251	13411	47	0	\N
205243	1397	1275023637000	27251	13411	48	0	\N
205244	1397	1275013636000	27251	13411	49	0	\N
205245	1397	1275003635000	27251	13411	50	0	\N
205246	1397	1274993634000	27251	13411	51	0	\N
205247	1397	1274983633000	27251	13411	52	0	\N
205248	1397	1274973632000	27251	13411	53	0	\N
205249	1397	1274963631000	27251	13411	54	0	\N
205250	1397	1274953630000	27251	13411	55	0	\N
205251	1397	1274943629000	27251	13411	56	0	\N
205252	1397	1274933628000	27251	13411	57	0	\N
205253	1397	1274923627000	27251	13411	58	0	\N
205254	1397	1274913626000	27251	13411	59	0	\N
205255	1397	1274903625000	27251	13411	60	0	\N
205256	1397	1274893624000	27251	13411	61	0	\N
205257	1397	1274883623000	27251	13411	62	0	\N
205258	1397	1274873622000	27251	13411	63	0	\N
205259	1397	1274863621000	27251	13411	64	0	\N
205260	1397	1274853620000	27251	13411	65	0	\N
205261	1397	1274843619000	27251	13411	66	0	\N
205262	1397	1274833618000	27251	13411	67	0	\N
205263	1397	1274823617000	27251	13411	68	0	\N
205264	1397	1274813616000	27251	13411	69	0	\N
205265	1397	1274803615000	27251	13411	70	0	\N
205266	1397	1274793614000	27251	13411	71	0	\N
205267	1397	1274783613000	27251	13411	72	0	\N
205268	1397	1274773612000	27251	13411	73	0	\N
205269	1397	1274763611000	27251	13411	74	0	\N
205270	1397	1274753610000	27251	13411	75	0	\N
205271	1397	1274743609000	27251	13411	76	0	\N
205272	1397	1274733608000	27251	13411	77	0	\N
205273	1397	1274723607000	27251	13411	78	0	\N
205274	1397	1274713606000	27251	13411	80	0	\N
205275	1397	1274703605000	27251	13411	81	0	\N
205276	1397	1274693604000	27251	13411	82	0	\N
205277	1397	1274683603000	27251	13411	83	0	\N
205278	1397	1274673602000	27251	13411	84	0	\N
205279	1397	1274663601000	27251	13411	85	0	\N
205280	1397	1274653600000	27251	13411	86	0	\N
205281	1397	1274643599000	27251	13411	87	0	\N
205282	1397	1274633598000	27251	13411	88	0	\N
205283	1397	1274623597000	27251	13411	89	0	\N
205284	1397	1274613596000	27251	13411	90	0	\N
205285	1726	954957112000	27251	13411	91	0	\N
205286	2133	90531710000	27251	13411	92	0	\N
205287	2134	83935119000	27251	13411	93	0	\N
205288	2134	83934116000	27251	13411	94	0	\N
205289	1726	953856112000	27251	13411	95	0	\N
205290	2134	83933113000	27251	13411	96	0	\N
205291	2134	83932110000	27251	13411	97	0	\N
205292	2134	83931107000	27251	13411	98	0	\N
205293	2134	83930104000	27251	13411	99	0	\N
205294	1726	952755112000	27251	13411	100	0	\N
205295	1726	951654112000	27251	13411	101	0	\N
205296	1726	950553112000	27251	13411	102	0	\N
205297	2134	83929101000	27251	13411	103	0	\N
205298	1726	949452112000	27251	13411	104	0	\N
205299	2134	83928098000	27251	13411	105	0	\N
205300	2134	83927095000	27251	13411	106	0	\N
205301	2134	83926092000	27251	13411	107	0	\N
205302	2133	90530708000	27251	13411	108	0	\N
205303	2133	90529706000	27251	13411	109	0	\N
205304	2133	90528704000	27251	13411	110	0	\N
205305	2133	90527702000	27251	13411	111	0	\N
205306	2133	90526700000	27251	13411	112	0	\N
205307	2133	90525698000	27251	13411	113	0	\N
205308	2133	90524696000	27251	13411	114	0	\N
205309	2133	90523694000	27251	13411	115	0	\N
205310	2133	90522692000	27251	13411	116	0	\N
205311	2133	90521690000	27251	13411	117	0	\N
205312	2133	90520688000	27251	13411	118	0	\N
205313	2133	90519686000	27251	13411	119	0	\N
205314	2133	90518684000	27251	13411	120	0	\N
205315	2133	90517682000	27251	13411	121	0	\N
205316	2133	90516680000	27251	13411	122	0	\N
205317	2133	90515678000	27251	13411	123	0	\N
205318	2133	90514676000	27251	13411	124	0	\N
205319	2134	83925089000	27251	13411	125	0	\N
205323	1397	1274603595000	27253	13474	0	0	\N
205324	2134	83850867000	27253	13474	1	0	\N
205325	2133	90441530000	27253	13474	2	0	\N
205329	1397	1274583593000	27255	13476	0	0	\N
205330	2133	90439526000	27255	13476	1	0	\N
205331	2134	83848861000	27255	13476	2	0	\N
205335	1397	1274573592000	27258	13477	0	0	\N
205336	2133	90438524000	27258	13477	1	0	\N
205337	2134	83847858000	27258	13477	2	0	\N
205341	1397	1274563591000	27263	13478	0	0	\N
205342	2134	83846855000	27263	13478	1	0	\N
205343	1397	1274563591000	27264	13478	0	0	\N
205344	2134	83846855000	27264	13478	1	0	\N
205345	2133	90437522000	27264	13478	2	0	\N
205346	1397	1274563591000	27265	13478	0	0	\N
205347	2134	83846855000	27265	13478	1	0	\N
205348	2133	90437522000	27265	13478	2	0	\N
205355	1397	1275253660000	27269	13431	0	0	\N
205356	1397	1275243659000	27269	13431	1	0	\N
205357	1397	1275233658000	27269	13431	2	0	\N
205358	2133	90505658000	27269	13431	3	0	\N
205359	2133	90504656000	27269	13431	4	0	\N
205360	2134	83910044000	27269	13431	5	0	\N
205322	2133	90441530000	27252	13474	2	0	6237
205326	1397	1274593594000	27254	13475	0	0	16423
205327	2134	83849864000	27254	13475	1	0	6720
205328	2133	90440528000	27254	13475	2	0	6238
205332	1397	1274583593000	27256	13476	0	0	16424
205334	2134	83848861000	27256	13476	2	0	6721
205338	1397	1274573592000	27259	13477	0	0	16425
205339	2133	90438524000	27259	13477	1	0	6240
205340	2134	83847858000	27259	13477	2	0	6722
205349	1397	1274563591000	27266	13478	0	0	16426
205351	2133	90437522000	27266	13478	2	0	6241
205352	1397	1274553590000	27268	13479	0	0	16427
205353	2133	90436520000	27268	13479	1	0	6242
205354	2134	83845852000	27268	13479	2	0	6724
205361	2134	83909041000	27269	13431	6	0	\N
205362	2134	83908038000	27269	13431	7	0	\N
205363	2134	83907035000	27269	13431	8	0	\N
205364	2134	83906032000	27269	13431	9	0	\N
205365	2134	83905029000	27269	13431	10	0	\N
205366	2134	83904026000	27269	13431	11	0	\N
205367	2134	83903023000	27269	13431	12	0	\N
205368	2134	83902020000	27269	13431	13	0	\N
205369	2134	83901017000	27269	13431	14	0	\N
205370	2134	83900014000	27269	13431	15	0	\N
205371	2134	83899011000	27269	13431	16	0	\N
205372	2134	83898008000	27269	13431	17	0	\N
205373	2134	83897005000	27269	13431	18	0	\N
205374	2134	83896002000	27269	13431	19	0	\N
205375	2134	83894999000	27269	13431	20	0	\N
205376	2134	83893996000	27269	13431	21	0	\N
205377	2134	83892993000	27269	13431	22	0	\N
205378	2134	83891990000	27269	13431	23	0	\N
205379	2134	83890987000	27269	13431	24	0	\N
205380	2134	83889984000	27269	13431	25	0	\N
205381	2134	83888981000	27269	13431	26	0	\N
205382	2134	83887978000	27269	13431	27	0	\N
205383	2134	83886975000	27269	13431	28	0	\N
205384	2134	83885972000	27269	13431	29	0	\N
205385	2134	83884969000	27269	13431	30	0	\N
205386	2134	83883966000	27269	13431	31	0	\N
205387	2134	83882963000	27269	13431	32	0	\N
205388	2134	83881960000	27269	13431	33	0	\N
205389	2134	83880957000	27269	13431	34	0	\N
205390	2133	90503654000	27269	13431	35	0	\N
205391	2133	90502652000	27269	13431	36	0	\N
205392	2133	90501650000	27269	13431	37	0	\N
205393	2133	90500648000	27269	13431	38	0	\N
205394	2133	90499646000	27269	13431	39	0	\N
205395	2133	90498644000	27269	13431	40	0	\N
205396	2133	90497642000	27269	13431	41	0	\N
205397	2133	90496640000	27269	13431	42	0	\N
205398	2133	90495638000	27269	13431	43	0	\N
205399	2133	90494636000	27269	13431	44	0	\N
205400	2133	90493634000	27269	13431	45	0	\N
205401	2133	90492632000	27269	13431	46	0	\N
205402	2133	90491630000	27269	13431	47	0	\N
205403	2133	90490628000	27269	13431	48	0	\N
205404	2133	90489626000	27269	13431	49	0	\N
205405	2133	90488624000	27269	13431	50	0	\N
205406	2133	90487622000	27269	13431	51	0	\N
205407	2133	90486620000	27269	13431	52	0	\N
205408	2133	90485618000	27269	13431	53	0	\N
205409	2133	90484616000	27269	13431	54	0	\N
205410	2133	90483614000	27269	13431	55	0	\N
205411	2133	90482612000	27269	13431	56	0	\N
205412	2133	90481610000	27269	13431	57	0	\N
205413	2133	90480608000	27269	13431	58	0	\N
205414	2133	90479606000	27269	13431	59	0	\N
205415	2133	90478604000	27269	13431	60	0	\N
205416	2133	90477602000	27269	13431	61	0	\N
205417	2133	90476600000	27269	13431	62	0	\N
205418	2133	90475598000	27270	13432	0	0	\N
205419	2133	90474596000	27270	13432	1	0	\N
205420	2133	90473594000	27270	13432	2	0	\N
205421	2133	90472592000	27270	13432	3	0	\N
205422	2133	90471590000	27270	13432	4	0	\N
205423	2133	90470588000	27270	13432	5	0	\N
205424	2133	90469586000	27270	13432	6	0	\N
205425	2133	90468584000	27270	13432	7	0	\N
205426	2133	90467582000	27270	13432	8	0	\N
205427	2133	90466580000	27270	13432	9	0	\N
205428	2133	90465578000	27270	13432	10	0	\N
205429	2133	90464576000	27270	13432	11	0	\N
205430	2133	90463574000	27270	13432	12	0	\N
205431	2133	90462572000	27270	13432	13	0	\N
205432	2133	90461570000	27270	13432	14	0	\N
205433	2133	90460568000	27270	13432	15	0	\N
205434	2133	90459566000	27270	13432	16	0	\N
205435	2133	90458564000	27270	13432	17	0	\N
205436	2133	90457562000	27270	13432	18	0	\N
205437	2133	90456560000	27270	13432	19	0	\N
205438	2133	90455558000	27270	13432	20	0	\N
205439	2133	90454556000	27270	13432	21	0	\N
205440	2133	90453554000	27270	13432	22	0	\N
205441	2133	90452552000	27270	13432	23	0	\N
205442	2133	90451550000	27270	13432	25	0	\N
205443	2133	90450548000	27270	13432	26	0	\N
205444	2133	90449546000	27270	13432	27	0	\N
205445	2133	90448544000	27270	13432	28	0	\N
205446	2133	90447542000	27270	13432	29	0	\N
205447	2133	90446540000	27270	13432	30	0	\N
205448	2133	90445538000	27270	13432	31	0	\N
205449	2133	90444536000	27270	13432	32	0	\N
205450	2133	90443534000	27270	13432	33	0	\N
205451	2133	90442532000	27270	13432	34	0	\N
205452	2133	90441530000	27270	13432	35	0	\N
205453	2133	90440528000	27270	13432	36	0	\N
205454	2133	90439526000	27270	13432	37	0	\N
205455	2133	90438524000	27270	13432	38	0	\N
205456	2133	90437522000	27270	13432	39	0	\N
205457	1397	1274553590000	27271	13479	0	0	\N
205458	2133	90436520000	27271	13479	1	0	\N
205459	2134	83845852000	27271	13479	2	0	\N
205466	1397	1274543589000	27274	13480	0	0	\N
205467	1397	1274533588000	27274	13480	1	0	\N
205468	2133	90435518000	27274	13480	2	0	\N
205469	2133	90434516000	27274	13480	3	0	\N
205470	2134	83844849000	27274	13480	4	0	\N
205471	2134	83843846000	27274	13480	5	0	\N
205475	1397	1274523587000	27276	13481	0	0	\N
205476	2133	90433514000	27276	13481	1	0	\N
205477	2134	83842843000	27276	13481	2	0	\N
205481	1397	1274513586000	27278	13482	0	0	\N
205482	2133	90432512000	27278	13482	1	0	\N
205483	2134	83841840000	27278	13482	2	0	\N
205462	2133	90435518000	27273	13480	2	0	6243
205463	2133	90434516000	27273	13480	3	0	6244
205464	2134	83844849000	27273	13480	4	0	6725
205465	2134	83843846000	27273	13480	5	0	6726
205472	1397	1274523587000	27275	13481	0	0	16430
205474	2134	83842843000	27275	13481	2	0	6727
205478	1397	1274513586000	27277	13482	0	0	16431
205479	2133	90432512000	27277	13482	1	0	6246
205480	2134	83841840000	27277	13482	2	0	6728
205484	1397	1274503585000	27279	13483	0	0	16432
205486	2133	90431510000	27279	13483	2	0	6247
205487	1397	1274493584000	27281	13484	0	0	16433
205488	1397	1274483583000	27281	13484	1	0	16434
205489	1397	1274473582000	27281	13484	2	0	16435
205491	2134	83838831000	27281	13484	4	0	6731
205492	2133	90430508000	27281	13484	5	0	6248
205493	2134	83837828000	27281	13484	6	0	6732
205494	2133	90429506000	27281	13484	7	0	6249
205495	2133	90428504000	27281	13484	8	0	6250
205498	2133	90436520000	27283	13433	0	0	\N
205499	2133	90435518000	27283	13433	1	0	\N
205500	2133	90434516000	27283	13433	2	0	\N
205501	2133	90433514000	27283	13433	3	0	\N
205502	2133	90432512000	27283	13433	4	0	\N
205503	2133	90431510000	27283	13433	5	0	\N
205504	2133	90430508000	27283	13433	6	0	\N
205505	2133	90429506000	27283	13433	7	0	\N
205506	2133	90428504000	27283	13433	8	0	\N
205507	2133	90427502000	27283	13433	9	0	\N
205508	1397	1275543689000	27284	13408	0	0	\N
205509	1397	1275533688000	27284	13408	1	0	\N
205510	1397	1275523687000	27284	13408	2	0	\N
205511	1397	1275513686000	27284	13408	3	0	\N
205512	1397	1275503685000	27284	13408	4	0	\N
205513	1397	1275493684000	27284	13408	5	0	\N
205514	1397	1275483683000	27284	13408	6	0	\N
205515	1397	1275473682000	27284	13408	7	0	\N
205516	1397	1275463681000	27284	13408	8	0	\N
205517	1397	1275453680000	27284	13408	9	0	\N
205518	1397	1275443679000	27284	13408	10	0	\N
205519	1397	1275433678000	27284	13408	11	0	\N
205520	1397	1275423677000	27284	13408	12	0	\N
205521	1397	1275413676000	27284	13408	13	0	\N
205522	1397	1275403675000	27284	13408	14	0	\N
205523	1397	1275393674000	27284	13408	15	0	\N
205524	1397	1275383673000	27284	13408	16	0	\N
205525	1397	1275373672000	27284	13408	17	0	\N
205526	1397	1275363671000	27284	13408	18	0	\N
205527	1397	1275353670000	27284	13408	19	0	\N
205528	1397	1275343669000	27284	13408	20	0	\N
205529	1397	1275333668000	27284	13408	21	0	\N
205530	1397	1275323667000	27284	13408	22	0	\N
205531	1397	1275313666000	27284	13408	23	0	\N
205532	1397	1275303665000	27284	13408	24	0	\N
205533	1397	1275293664000	27284	13408	25	0	\N
205534	1397	1275283663000	27284	13408	26	0	\N
205535	1397	1275273662000	27284	13408	27	0	\N
205536	1397	1275263661000	27284	13408	28	0	\N
205537	1397	1275253660000	27284	13408	29	0	\N
205538	1397	1275243659000	27284	13408	30	0	\N
205539	1397	1275233658000	27284	13408	31	0	\N
205540	1397	1275223657000	27284	13408	32	0	\N
205541	1397	1275213656000	27284	13408	33	0	\N
205542	1397	1275203655000	27284	13408	34	0	\N
205543	1397	1275193654000	27284	13408	35	0	\N
205544	1397	1275183653000	27284	13408	36	0	\N
205545	1397	1275173652000	27284	13408	37	0	\N
205546	1397	1275163651000	27284	13408	38	0	\N
205547	1397	1275153650000	27284	13408	39	0	\N
205548	1397	1275143649000	27284	13408	40	0	\N
205549	1397	1275133648000	27284	13408	41	0	\N
205550	1397	1275123647000	27284	13408	42	0	\N
205551	1397	1275113646000	27284	13408	43	0	\N
205552	1397	1275103645000	27284	13408	44	0	\N
205553	1397	1275093644000	27284	13408	45	0	\N
205554	1397	1275083643000	27284	13408	46	0	\N
205555	1397	1275073642000	27284	13408	47	0	\N
205556	1397	1275063641000	27284	13408	48	0	\N
205557	1397	1275053640000	27284	13408	49	0	\N
205558	1397	1275043639000	27284	13408	50	0	\N
205559	1397	1275033638000	27284	13408	51	0	\N
205560	1397	1275023637000	27284	13408	52	0	\N
205561	1397	1275013636000	27284	13408	53	0	\N
205562	1397	1275003635000	27284	13408	54	0	\N
205563	1397	1274993634000	27284	13408	55	0	\N
205564	1397	1274983633000	27284	13408	56	0	\N
205565	1397	1274973632000	27284	13408	57	0	\N
205566	1397	1274963631000	27284	13408	58	0	\N
205567	1397	1274953630000	27284	13408	59	0	\N
205568	1397	1274943629000	27284	13408	60	0	\N
205569	1397	1274933628000	27284	13408	61	0	\N
205570	1397	1274923627000	27284	13408	62	0	\N
205571	1397	1274913626000	27284	13408	63	0	\N
205572	1397	1274903625000	27284	13408	64	0	\N
205573	1397	1274893624000	27284	13408	65	0	\N
205574	1397	1274883623000	27284	13408	66	0	\N
205575	1397	1274873622000	27284	13408	67	0	\N
205576	1397	1274863621000	27284	13408	68	0	\N
205577	1397	1274853620000	27284	13408	69	0	\N
205578	1397	1274843619000	27284	13408	70	0	\N
205579	1397	1274833618000	27284	13408	71	0	\N
205580	1397	1274823617000	27284	13408	72	0	\N
205581	1397	1274813616000	27284	13408	73	0	\N
205582	1397	1274803615000	27284	13408	74	0	\N
205583	1397	1274793614000	27284	13408	75	0	\N
205584	1397	1274783613000	27284	13408	76	0	\N
205585	1397	1274773612000	27284	13408	77	0	\N
205586	1397	1274763611000	27284	13408	78	0	\N
205587	1397	1274753610000	27284	13408	79	0	\N
205588	1397	1274743609000	27284	13408	80	0	\N
205589	1397	1274733608000	27284	13408	81	0	\N
205590	1397	1274723607000	27284	13408	82	0	\N
205591	1397	1274713606000	27284	13408	83	0	\N
205592	1397	1274703605000	27284	13408	84	0	\N
205593	1397	1274693604000	27284	13408	85	0	\N
205594	1397	1274683603000	27284	13408	86	0	\N
205595	1397	1274673602000	27284	13408	87	0	\N
205596	1397	1274663601000	27284	13408	88	0	\N
205597	1397	1274653600000	27284	13408	89	0	\N
205598	1397	1274643599000	27284	13408	90	0	\N
205599	1397	1274633598000	27284	13408	91	0	\N
205600	1397	1274623597000	27284	13408	92	0	\N
205601	1397	1274613596000	27284	13408	93	0	\N
205602	1397	1274603595000	27284	13408	94	0	\N
205603	1397	1274593594000	27284	13408	95	0	\N
205604	1397	1274583593000	27284	13408	96	0	\N
205605	1397	1274573592000	27284	13408	98	0	\N
205606	1397	1274563591000	27284	13408	99	0	\N
205607	1397	1274553590000	27284	13408	100	0	\N
205608	1397	1274543589000	27284	13408	101	0	\N
205609	1397	1274533588000	27284	13408	102	0	\N
205610	1397	1274523587000	27284	13408	103	0	\N
205611	1397	1274513586000	27284	13408	104	0	\N
205612	1397	1274503585000	27284	13408	105	0	\N
205613	1397	1274493584000	27284	13408	106	0	\N
205614	1397	1274483583000	27284	13408	107	0	\N
205615	1397	1274473582000	27284	13408	108	0	\N
205616	1397	1274463581000	27284	13408	109	0	\N
205617	1726	954957112000	27284	13408	110	0	\N
205618	1726	953856112000	27284	13408	111	0	\N
205619	1726	952755112000	27284	13408	112	0	\N
205620	1726	951654112000	27284	13408	113	0	\N
205621	1726	950553112000	27284	13408	114	0	\N
205622	2134	83939131000	27284	13408	115	0	\N
205623	2134	83938128000	27284	13408	116	0	\N
205624	2134	83937125000	27284	13408	117	0	\N
205625	1726	949452112000	27284	13408	118	0	\N
205626	2134	83936122000	27284	13408	119	0	\N
205627	2134	83935119000	27284	13408	120	0	\N
205628	2134	83934116000	27284	13408	121	0	\N
205629	2134	83933113000	27284	13408	122	0	\N
205630	2134	83932110000	27284	13408	123	0	\N
205631	2134	83931107000	27284	13408	124	0	\N
205637	1397	1274443579000	27286	13487	0	0	\N
205638	2134	83833816000	27286	13487	1	0	\N
205641	1397	1274443579000	27288	13487	0	0	\N
205642	2134	83833816000	27288	13487	1	0	\N
205643	2133	90426500000	27289	13434	0	0	\N
205646	1397	1274433578000	27291	13488	0	0	\N
205647	2134	83832813000	27291	13488	1	0	\N
205650	1397	1274423577000	27293	13489	0	0	\N
205651	2134	83831810000	27293	13489	1	0	\N
205656	2133	90425498000	27295	13488	0	0	\N
205660	1397	1274383573000	27297	13492	0	0	\N
205661	1397	1274373572000	27297	13492	1	0	\N
205662	2133	90424496000	27297	13492	2	0	\N
205663	2134	83827798000	27297	13492	3	0	\N
205664	2133	90423494000	27297	13492	4	0	\N
205665	2134	83826795000	27297	13492	5	0	\N
205675	1397	1274353570000	27300	13494	0	0	\N
205676	2134	83824789000	27300	13494	1	0	\N
205677	2133	90421490000	27300	13494	2	0	\N
205690	1397	1274313566000	27304	13497	0	0	\N
205691	2134	83820777000	27304	13497	1	0	\N
205692	2133	90417482000	27304	13497	2	0	\N
205696	1397	1274303565000	27306	13498	0	0	\N
205697	2134	83819774000	27306	13498	1	0	\N
205698	2133	90416480000	27306	13498	2	0	\N
205699	1397	1274303565000	27307	13498	0	0	\N
205700	2134	83819774000	27307	13498	1	0	\N
205701	2133	90416480000	27307	13498	2	0	\N
205702	1397	1274303565000	27308	13498	0	0	\N
205703	2134	83819774000	27308	13498	1	0	\N
205704	2133	90416480000	27308	13498	2	0	\N
205729	1397	1274233558000	27317	13504	0	0	\N
205730	2134	83812753000	27317	13504	1	0	\N
205731	2133	90409466000	27317	13504	2	0	\N
205732	1397	1274223557000	27318	13505	0	0	\N
205733	1397	1274213556000	27318	13505	1	0	\N
205734	2133	90408464000	27318	13505	2	0	\N
205735	2133	90407462000	27318	13505	3	0	\N
205736	2134	83811750000	27318	13505	4	0	\N
205737	2134	83810747000	27318	13505	5	0	\N
205753	1397	1274193554000	27322	13507	0	0	\N
205754	1397	1274183553000	27322	13507	1	0	\N
205755	2133	90405458000	27322	13507	2	0	\N
205756	2133	90404456000	27322	13507	3	0	\N
205757	2134	83808741000	27322	13507	4	0	\N
205758	2134	83807738000	27322	13507	5	0	\N
205762	1397	1274173552000	27324	13508	0	0	\N
205763	2133	90403454000	27324	13508	1	0	\N
205764	2134	83806735000	27324	13508	2	0	\N
205765	1397	1274173552000	27325	13508	0	0	\N
205766	2133	90403454000	27325	13508	1	0	\N
205767	2134	83806735000	27325	13508	2	0	\N
205768	1397	1274173552000	27326	13508	0	0	\N
205635	2134	83834819000	27285	13486	3	0	6735
205636	2133	90426500000	27285	13486	4	0	6252
205639	1397	1274443579000	27287	13487	0	0	16438
205640	2134	83833816000	27287	13487	1	0	6736
205644	1397	1274433578000	27290	13488	0	0	16439
205648	1397	1274423577000	27292	13489	0	0	16440
205649	2134	83831810000	27292	13489	1	0	6738
205652	1397	1274413576000	27294	13490	0	0	16441
205653	1397	1274403575000	27294	13490	1	0	16442
205654	2134	83830807000	27294	13490	2	0	6739
205657	1397	1274393574000	27296	13491	0	0	16443
205658	2133	90425498000	27296	13491	1	0	6253
205659	2134	83828801000	27296	13491	2	0	6741
205666	1397	1274383573000	27298	13492	0	0	16444
205668	2133	90424496000	27298	13492	2	0	6254
205669	2134	83827798000	27298	13492	3	0	6742
205670	2133	90423494000	27298	13492	4	0	6255
205671	2134	83826795000	27298	13492	5	0	6743
205672	1397	1274363571000	27299	13493	0	0	16446
205674	2133	90422492000	27299	13493	2	0	6256
205678	1397	1274353570000	27301	13494	0	0	16447
205679	2134	83824789000	27301	13494	1	0	6745
205680	2133	90421490000	27301	13494	2	0	6257
205681	1397	1274343569000	27302	13495	0	0	16448
205683	2134	83823786000	27302	13495	2	0	6746
205684	2133	90420488000	27302	13495	3	0	6258
205685	2133	90419486000	27302	13495	4	0	6259
205686	2134	83822783000	27302	13495	5	0	6747
205688	2134	83821780000	27303	13496	1	0	6748
205689	2133	90418484000	27303	13496	2	0	6260
205693	1397	1274313566000	27305	13497	0	0	16451
205694	2134	83820777000	27305	13497	1	0	6749
205695	2133	90417482000	27305	13497	2	0	6261
205706	2134	83819774000	27309	13498	1	0	6750
205707	2133	90416480000	27309	13498	2	0	6262
205708	1397	1274293564000	27310	13499	0	0	16453
205709	2134	83818771000	27310	13499	1	0	6751
205710	2133	90415478000	27310	13499	2	0	6263
205712	2133	90414476000	27311	13500	1	0	6264
205713	2134	83817768000	27311	13500	2	0	6752
205714	1397	1274273562000	27312	13501	0	0	16455
205715	2134	83816765000	27312	13501	1	0	6753
205717	1397	1274263561000	27314	13502	0	0	16456
205718	1397	1274253560000	27314	13502	1	0	16457
205719	2134	83815762000	27314	13502	2	0	6754
205720	2134	83814759000	27314	13502	3	0	6755
205721	2133	90412472000	27314	13502	4	0	6266
205723	1397	1274243559000	27315	13503	0	0	16458
205724	2134	83813756000	27315	13503	1	0	6756
205725	2133	90410468000	27315	13503	2	0	6268
205726	1397	1274233558000	27316	13504	0	0	16459
205727	2134	83812753000	27316	13504	1	0	6757
205738	1397	1274223557000	27319	13505	0	0	16460
205739	1397	1274213556000	27319	13505	1	0	16461
205740	2133	90408464000	27319	13505	2	0	6270
205741	2133	90407462000	27319	13505	3	0	6271
205743	2134	83810747000	27319	13505	5	0	6759
205744	1397	1274203555000	27320	13506	0	0	16462
205745	2134	83809744000	27320	13506	1	0	6760
205746	2133	90406460000	27320	13506	2	0	6272
205747	1397	1274193554000	27321	13507	0	0	16463
205749	2133	90405458000	27321	13507	2	0	6273
205750	2133	90404456000	27321	13507	3	0	6274
205751	2134	83808741000	27321	13507	4	0	6761
205752	2134	83807738000	27321	13507	5	0	6762
205759	1397	1274173552000	27323	13508	0	0	16465
205761	2134	83806735000	27323	13508	2	0	6763
205769	2133	90403454000	27326	13508	1	0	\N
205770	2134	83806735000	27326	13508	2	0	\N
205771	1397	1274173552000	27327	13508	0	0	\N
205772	2133	90403454000	27327	13508	1	0	\N
205773	2134	83806735000	27327	13508	2	0	\N
205774	1397	1274173552000	27328	13508	0	0	\N
205775	2133	90403454000	27328	13508	1	0	\N
205776	2134	83806735000	27328	13508	2	0	\N
205777	1397	1274173552000	27329	13508	0	0	\N
205778	2133	90403454000	27329	13508	1	0	\N
205779	2134	83806735000	27329	13508	2	0	\N
205783	1397	1274163551000	27331	13509	0	0	\N
205784	2133	90402452000	27331	13509	1	0	\N
205785	2134	83805732000	27331	13509	2	0	\N
205793	1397	1274133548000	27334	13512	0	0	\N
205794	2134	83802723000	27334	13512	1	0	\N
205795	2133	90399446000	27334	13512	2	0	\N
205817	1397	1274073542000	27340	13516	0	0	\N
205818	2133	90393434000	27340	13516	1	0	\N
205819	2134	83796705000	27340	13516	2	0	\N
205820	1397	1274073542000	27341	13516	0	0	\N
205821	2133	90393434000	27341	13516	1	0	\N
205822	2134	83796705000	27341	13516	2	0	\N
205838	1397	1274013536000	27346	13521	0	0	\N
205839	2134	83790687000	27346	13521	1	0	\N
205840	2133	90387422000	27346	13521	2	0	\N
205841	1397	1274013536000	27347	13521	0	0	\N
205842	2134	83790687000	27347	13521	1	0	\N
205843	2133	90387422000	27347	13521	2	0	\N
205850	1397	1274003535000	27350	13522	0	0	\N
205851	2134	83789684000	27350	13522	1	0	\N
205852	2133	90386420000	27350	13522	2	0	\N
205868	1397	1273963531000	27354	13524	0	0	\N
205869	1397	1273953530000	27354	13524	1	0	\N
205870	2133	90382412000	27354	13524	2	0	\N
205871	2133	90381410000	27354	13524	3	0	\N
205872	2134	83785672000	27354	13524	4	0	\N
205873	2134	83784669000	27354	13524	5	0	\N
205883	1397	1273943529000	27356	13525	0	0	\N
205884	1397	1273933528000	27356	13525	1	0	\N
205885	1397	1273923527000	27356	13525	2	0	\N
205886	2134	83783666000	27356	13525	3	0	\N
205887	2134	83782663000	27356	13525	4	0	\N
205888	2134	83781660000	27356	13525	5	0	\N
205889	2133	90380408000	27356	13525	6	0	\N
205890	2133	90379406000	27356	13525	7	0	\N
205891	2133	90378404000	27356	13525	8	0	\N
205892	1397	1273943529000	27357	13525	0	0	\N
205893	1397	1273933528000	27357	13525	1	0	\N
205894	1397	1273923527000	27357	13525	2	0	\N
205895	2134	83783666000	27357	13525	3	0	\N
205896	2134	83782663000	27357	13525	4	0	\N
205897	2134	83781660000	27357	13525	5	0	\N
205898	2133	90380408000	27357	13525	6	0	\N
205899	2133	90379406000	27357	13525	7	0	\N
205900	2133	90378404000	27357	13525	8	0	\N
205901	1397	1273943529000	27358	13525	0	0	\N
205902	1397	1273933528000	27358	13525	1	0	\N
205903	1397	1273923527000	27358	13525	2	0	\N
205904	2134	83783666000	27358	13525	3	0	\N
205782	2134	83805732000	27330	13509	2	0	6764
205786	1397	1274153550000	27332	13510	0	0	16467
205787	2134	83804729000	27332	13510	1	0	6765
205788	2133	90401450000	27332	13510	2	0	6277
205789	1397	1274143549000	27333	13511	0	0	16468
205791	2133	90400448000	27333	13511	2	0	6278
205792	2134	83803726000	27333	13511	3	0	6766
205796	1397	1274133548000	27335	13512	0	0	16469
205797	2134	83802723000	27335	13512	1	0	6767
205798	2133	90399446000	27335	13512	2	0	6279
205800	1397	1274113546000	27336	13513	1	0	16471
205801	1397	1274103545000	27336	13513	2	0	16472
205802	2134	83801720000	27336	13513	3	0	6768
205803	2133	90398444000	27336	13513	4	0	6280
205805	2133	90396440000	27336	13513	6	0	6282
205806	2134	83800717000	27336	13513	7	0	6769
205807	2134	83799714000	27336	13513	8	0	6770
205808	1397	1274093544000	27337	13514	0	0	16473
205809	2134	83798711000	27337	13514	1	0	6771
205811	1397	1274083543000	27338	13515	0	0	16474
205812	2133	90394436000	27338	13515	1	0	6284
205813	2134	83797708000	27338	13515	2	0	6772
205814	1397	1274073542000	27339	13516	0	0	16475
205815	2133	90393434000	27339	13516	1	0	6285
205823	1397	1274063541000	27342	13517	0	0	16476
205824	1397	1274053540000	27342	13517	1	0	16477
205825	2133	90392432000	27342	13517	2	0	6286
205826	2134	83795702000	27342	13517	3	0	6774
205828	2133	90391430000	27342	13517	5	0	6287
205829	1397	1274043539000	27343	13518	0	0	16478
205830	2133	90390428000	27343	13518	1	0	6288
205831	2134	83793696000	27343	13518	2	0	6776
205832	1397	1274033538000	27344	13519	0	0	16479
205834	2133	90389426000	27344	13519	2	0	6289
205835	1397	1274023537000	27345	13520	0	0	16480
205836	2134	83791690000	27345	13520	1	0	6778
205837	2133	90388424000	27345	13520	2	0	6290
205844	1397	1274013536000	27348	13521	0	0	16481
205846	2133	90387422000	27348	13521	2	0	6291
205847	1397	1274003535000	27349	13522	0	0	16482
205848	2134	83789684000	27349	13522	1	0	6780
205849	2133	90386420000	27349	13522	2	0	6292
205854	1397	1273983533000	27352	13523	1	0	16484
205855	1397	1273973532000	27352	13523	2	0	16485
205856	2133	90385418000	27352	13523	3	0	6293
205857	2133	90384416000	27352	13523	4	0	6294
205858	2134	83788681000	27352	13523	5	0	6781
205860	2134	83786675000	27352	13523	7	0	6783
205861	2133	90383414000	27352	13523	8	0	6295
205862	1397	1273963531000	27353	13524	0	0	16486
205863	1397	1273953530000	27353	13524	1	0	16487
205864	2133	90382412000	27353	13524	2	0	6296
205866	2134	83785672000	27353	13524	4	0	6784
205867	2134	83784669000	27353	13524	5	0	6785
205874	1397	1273943529000	27355	13525	0	0	16488
205875	1397	1273933528000	27355	13525	1	0	16489
205877	2134	83783666000	27355	13525	3	0	6786
205878	2134	83782663000	27355	13525	4	0	6787
205879	2134	83781660000	27355	13525	5	0	6788
205880	2133	90380408000	27355	13525	6	0	6298
205881	2133	90379406000	27355	13525	7	0	6299
205905	2134	83782663000	27358	13525	4	0	\N
205906	2134	83781660000	27358	13525	5	0	\N
205907	2133	90380408000	27358	13525	6	0	\N
205908	2133	90379406000	27358	13525	7	0	\N
205909	2133	90378404000	27358	13525	8	0	\N
205922	1397	1273913526000	27360	13526	0	0	\N
205923	1397	1273903525000	27360	13526	1	0	\N
205924	1397	1273893524000	27360	13526	2	0	\N
205925	2133	90377402000	27360	13526	3	0	\N
205926	2133	90376400000	27360	13526	4	0	\N
205927	2133	90375398000	27360	13526	5	0	\N
205928	2134	83780657000	27360	13526	6	0	\N
205929	2134	83779654000	27360	13526	7	0	\N
205930	2134	83778651000	27360	13526	8	0	\N
205931	497	66719022000000	27360	13526	9	0	\N
205932	497	66718021000000	27360	13526	10	0	\N
205933	497	66717020000000	27360	13526	12	0	\N
205956	1397	1273823517000	27366	13531	0	0	\N
205957	2134	83771630000	27366	13531	1	0	\N
205958	2133	90368384000	27366	13531	2	0	\N
205959	1751	1439011000000	27367	13435	0	0	\N
205960	497	66719022000000	27367	13435	1	0	\N
205961	497	66718021000000	27367	13435	2	0	\N
205962	497	66717020000000	27367	13435	3	0	\N
205963	2133	90425498000	27367	13435	4	0	\N
205964	2133	90424496000	27367	13435	5	0	\N
205965	2133	90423494000	27367	13435	6	0	\N
205966	2133	90422492000	27367	13435	7	0	\N
205967	2133	90421490000	27367	13435	8	0	\N
205968	2133	90420488000	27367	13435	9	0	\N
205969	2133	90419486000	27367	13435	10	0	\N
205970	2133	90418484000	27367	13435	11	0	\N
205971	2133	90417482000	27367	13435	12	0	\N
205972	2133	90416480000	27367	13435	13	0	\N
205973	2133	90415478000	27367	13435	14	0	\N
205974	2133	90414476000	27367	13435	15	0	\N
205975	2133	90413474000	27367	13435	16	0	\N
205976	2133	90412472000	27367	13435	17	0	\N
205977	2133	90411470000	27367	13435	18	0	\N
205978	2133	90410468000	27367	13435	19	0	\N
205979	2133	90409466000	27367	13435	20	0	\N
205980	2133	90408464000	27367	13435	21	0	\N
205981	2133	90407462000	27367	13435	22	0	\N
205982	2133	90406460000	27367	13435	23	0	\N
205983	2133	90405458000	27367	13435	24	0	\N
205984	2133	90404456000	27367	13435	25	0	\N
205985	2133	90403454000	27367	13435	26	0	\N
205986	2133	90402452000	27367	13435	27	0	\N
205987	2133	90401450000	27367	13435	28	0	\N
205988	2133	90400448000	27367	13435	29	0	\N
205989	2133	90399446000	27367	13435	30	0	\N
205990	2133	90398444000	27367	13435	31	0	\N
205991	2133	90397442000	27367	13435	32	0	\N
205992	2133	90396440000	27367	13435	33	0	\N
205993	2133	90395438000	27367	13435	34	0	\N
205994	2133	90394436000	27367	13435	35	0	\N
205995	2133	90393434000	27367	13435	36	0	\N
205996	2133	90392432000	27367	13435	37	0	\N
205997	2133	90391430000	27367	13435	38	0	\N
205998	2133	90390428000	27367	13435	39	0	\N
205999	2133	90389426000	27367	13435	40	0	\N
206000	2133	90388424000	27367	13435	41	0	\N
206001	2133	90387422000	27367	13435	42	0	\N
206002	2133	90386420000	27367	13435	43	0	\N
206003	2133	90385418000	27367	13435	44	0	\N
206004	2133	90384416000	27367	13435	45	0	\N
206005	2133	90383414000	27367	13435	46	0	\N
206006	2133	90382412000	27367	13435	47	0	\N
206007	2133	90381410000	27367	13435	48	0	\N
206008	2133	90380408000	27367	13435	49	0	\N
206009	2133	90379406000	27367	13435	50	0	\N
206010	2133	90378404000	27367	13435	51	0	\N
206011	2133	90377402000	27367	13435	52	0	\N
206012	2133	90376400000	27367	13435	53	0	\N
206013	2133	90375398000	27367	13435	54	0	\N
206014	2133	90374396000	27367	13435	55	0	\N
206015	2133	90373394000	27367	13435	56	0	\N
206016	2133	90372392000	27367	13435	57	0	\N
206017	2133	90371390000	27367	13435	58	0	\N
206018	2133	90370388000	27367	13435	59	0	\N
206019	2133	90369386000	27367	13435	60	0	\N
206020	2133	90368384000	27367	13435	61	0	\N
206027	1397	1273803515000	27370	13533	0	0	\N
206028	2133	90366380000	27370	13533	1	0	\N
206029	2134	83769624000	27370	13533	2	0	\N
206033	1397	1273793514000	27372	13534	0	0	\N
206034	2134	83768621000	27372	13534	1	0	\N
206035	2133	90365378000	27372	13534	2	0	\N
205912	1397	1273893524000	27359	13526	2	0	16493
205913	2133	90377402000	27359	13526	3	0	6301
205914	2133	90376400000	27359	13526	4	0	6302
205915	2133	90375398000	27359	13526	5	0	6303
205916	2134	83780657000	27359	13526	6	0	6789
205918	2134	83778651000	27359	13526	8	0	6791
205919	497	66719022000000	27359	13526	9	0	3
205920	497	66718021000000	27359	13526	10	0	4
205921	497	66717020000000	27359	13526	12	0	5
205934	1397	1273883523000	27361	13527	0	0	16494
205936	1397	1273863521000	27361	13527	2	0	16496
205937	2133	90374396000	27361	13527	3	0	6304
205938	2133	90373394000	27361	13527	4	0	6305
205939	2133	90372392000	27361	13527	5	0	6306
205941	2134	83776645000	27361	13527	7	0	6793
205942	2134	83775642000	27361	13527	8	0	6794
205943	1397	1273853520000	27362	13528	0	0	16497
205944	2134	83774639000	27362	13528	1	0	6795
205945	2133	90371390000	27362	13528	2	0	6307
205947	2133	90370388000	27363	13529	1	0	6308
205948	2134	83773636000	27363	13529	2	0	6796
205949	1397	1273833518000	27364	13530	0	0	16499
205950	2134	83772633000	27364	13530	1	0	6797
205951	2133	90369386000	27364	13530	2	0	6309
205953	1397	1273823517000	27365	13531	0	0	16500
205954	2134	83771630000	27365	13531	1	0	6798
205955	2133	90368384000	27365	13531	2	0	6310
206021	1397	1273813516000	27368	13532	0	0	16501
206023	2133	90367382000	27368	13532	2	0	6311
206024	1397	1273803515000	27369	13533	0	0	16502
206025	2133	90366380000	27369	13533	1	0	6312
206026	2134	83769624000	27369	13533	2	0	6800
206030	1397	1273793514000	27371	13534	0	0	16503
206032	2133	90365378000	27371	13534	2	0	6313
206036	1397	1273783513000	27373	13535	0	0	16504
206037	2134	83767618000	27373	13535	1	0	6802
206038	2133	90364376000	27373	13535	2	0	6314
206039	1397	1273773512000	27374	13536	0	0	16505
206054	1397	1273773512000	27375	13536	0	0	\N
206055	1397	1273763511000	27375	13536	1	0	\N
206056	1397	1273753510000	27375	13536	2	0	\N
206057	1397	1273743509000	27375	13536	3	0	\N
206058	1397	1273733508000	27375	13536	4	0	\N
206059	2133	90363374000	27375	13536	5	0	\N
206060	2133	90362372000	27375	13536	6	0	\N
206061	2134	83766615000	27375	13536	7	0	\N
206062	2134	83765612000	27375	13536	8	0	\N
206063	2134	83764609000	27375	13536	9	0	\N
206064	2134	83763606000	27375	13536	10	0	\N
206065	2134	83762603000	27375	13536	11	0	\N
206066	2133	90361370000	27375	13536	12	0	\N
206067	2133	90360368000	27375	13536	13	0	\N
206068	2133	90359366000	27375	13536	14	0	\N
206075	1397	1273723507000	27377	13537	0	0	\N
206076	1397	1273713506000	27377	13537	1	0	\N
206077	2134	83761600000	27377	13537	2	0	\N
206078	2133	90358364000	27377	13537	3	0	\N
206079	2133	90357362000	27377	13537	4	0	\N
206080	2134	83760597000	27377	13537	5	0	\N
206084	1397	1273693504000	27379	13539	0	0	\N
206085	2133	90355358000	27379	13539	1	0	\N
206086	2134	83758591000	27379	13539	2	0	\N
206090	1397	1273683503000	27381	13540	0	0	\N
206091	1397	1273673502000	27381	13540	1	0	\N
206092	1397	1273663501000	27381	13540	2	0	\N
206093	2134	83757588000	27381	13540	3	0	\N
206094	2133	90354356000	27381	13540	4	0	\N
206095	2134	83756585000	27381	13540	5	0	\N
206096	2134	83755582000	27381	13540	6	0	\N
206097	2133	90353354000	27381	13540	7	0	\N
206098	2133	90352352000	27381	13540	8	0	\N
206108	1397	1273653500000	27383	13541	0	0	\N
206109	2133	90351350000	27383	13541	1	0	\N
206110	2134	83754579000	27383	13541	2	0	\N
206111	1397	1273653500000	27384	13541	0	0	\N
206112	2133	90351350000	27384	13541	1	0	\N
206113	2134	83754579000	27384	13541	2	0	\N
206114	1397	1273653500000	27385	13541	0	0	\N
206115	2133	90351350000	27385	13541	1	0	\N
206116	2134	83754579000	27385	13541	2	0	\N
206120	1397	1273643499000	27387	13542	0	0	\N
206121	1397	1273633498000	27387	13542	1	0	\N
206122	2133	90350348000	27387	13542	2	0	\N
206123	2133	90349346000	27387	13542	3	0	\N
206124	2134	83753576000	27387	13542	4	0	\N
206125	2134	83752573000	27387	13542	5	0	\N
206126	1397	1273643499000	27388	13542	0	0	\N
206127	1397	1273633498000	27388	13542	1	0	\N
206128	2133	90350348000	27388	13542	2	0	\N
206129	2133	90349346000	27388	13542	3	0	\N
206130	2134	83753576000	27388	13542	4	0	\N
206131	2134	83752573000	27388	13542	5	0	\N
206147	1397	1273603495000	27392	13544	0	0	\N
206148	2134	83749564000	27392	13544	1	0	\N
206149	2133	90346340000	27392	13544	2	0	\N
206171	1397	1273523487000	27397	13548	0	0	\N
206172	2134	83741540000	27397	13548	1	0	\N
206173	2133	90338324000	27397	13548	2	0	\N
206174	1397	1273523487000	27398	13548	0	0	\N
206175	2134	83741540000	27398	13548	1	0	\N
206176	2133	90338324000	27398	13548	2	0	\N
206043	1397	1273733508000	27374	13536	4	0	16509
206044	2133	90363374000	27374	13536	5	0	6315
206045	2133	90362372000	27374	13536	6	0	6316
206046	2134	83766615000	27374	13536	7	0	6803
206047	2134	83765612000	27374	13536	8	0	6804
206049	2134	83763606000	27374	13536	10	0	6806
206050	2134	83762603000	27374	13536	11	0	6807
206051	2133	90361370000	27374	13536	12	0	6317
206052	2133	90360368000	27374	13536	13	0	6318
206053	2133	90359366000	27374	13536	14	0	6319
206070	1397	1273713506000	27376	13537	1	0	16511
206071	2134	83761600000	27376	13537	2	0	6808
206072	2133	90358364000	27376	13537	3	0	6320
206073	2133	90357362000	27376	13537	4	0	6321
206081	1397	1273703505000	27378	13538	0	0	16512
206082	2134	83759594000	27378	13538	1	0	6810
206083	2133	90356360000	27378	13538	2	0	6322
206087	1397	1273693504000	27380	13539	0	0	16513
206088	2133	90355358000	27380	13539	1	0	6323
206099	1397	1273683503000	27382	13540	0	0	16514
206100	1397	1273673502000	27382	13540	1	0	16515
206101	1397	1273663501000	27382	13540	2	0	16516
206102	2134	83757588000	27382	13540	3	0	6812
206103	2133	90354356000	27382	13540	4	0	6324
206105	2134	83755582000	27382	13540	6	0	6814
206106	2133	90353354000	27382	13540	7	0	6325
206107	2133	90352352000	27382	13540	8	0	6326
206117	1397	1273653500000	27386	13541	0	0	16517
206119	2134	83754579000	27386	13541	2	0	6815
206132	1397	1273643499000	27389	13542	0	0	16518
206133	1397	1273633498000	27389	13542	1	0	16519
206134	2133	90350348000	27389	13542	2	0	6328
206135	2133	90349346000	27389	13542	3	0	6329
206137	2134	83752573000	27389	13542	5	0	6817
206138	1397	1273623497000	27390	13543	0	0	16520
206139	1397	1273613496000	27390	13543	1	0	16521
206140	2134	83751570000	27390	13543	2	0	6818
206141	2133	90348344000	27390	13543	3	0	6330
206143	2133	90347342000	27390	13543	5	0	6331
206144	1397	1273603495000	27391	13544	0	0	16522
206145	2134	83749564000	27391	13544	1	0	6820
206146	2133	90346340000	27391	13544	2	0	6332
206151	1397	1273583493000	27395	13546	1	0	16524
206152	1397	1273573492000	27395	13546	2	0	16525
206153	1397	1273563491000	27395	13546	3	0	16526
206154	1397	1273553490000	27395	13546	4	0	16527
206155	2134	83748561000	27395	13546	5	0	6821
206157	2134	83746555000	27395	13546	7	0	6823
206158	2134	83745552000	27395	13546	8	0	6824
206159	2134	83744549000	27395	13546	9	0	6825
206160	2133	90345338000	27395	13546	10	0	6333
206161	2133	90344336000	27395	13546	11	0	6334
206163	2133	90342332000	27395	13546	13	0	6336
206164	2133	90341330000	27395	13546	14	0	6337
206165	1397	1273543489000	27396	13547	0	0	16528
206166	1397	1273533488000	27396	13547	1	0	16529
206168	2133	90340328000	27396	13547	3	0	6338
206169	2134	83742543000	27396	13547	4	0	6827
206170	2133	90339326000	27396	13547	5	0	6339
206183	1397	1273503485000	27401	13550	0	0	\N
206184	2134	83739534000	27401	13550	1	0	\N
206185	2133	90336320000	27401	13550	2	0	\N
206189	1397	1273503485000	27403	13550	0	0	\N
206190	2134	83739534000	27403	13550	1	0	\N
206191	2133	90336320000	27403	13550	2	0	\N
206195	1397	1273493484000	27405	13551	0	0	\N
206196	2133	90335318000	27405	13551	1	0	\N
206197	2134	83738531000	27405	13551	2	0	\N
206204	1397	1273473482000	27408	13553	0	0	\N
206205	2134	83736525000	27408	13553	1	0	\N
206206	2133	90333314000	27408	13553	2	0	\N
206210	1397	1273463481000	27410	13554	0	0	\N
206211	2134	83735522000	27410	13554	1	0	\N
206212	2133	90332312000	27410	13554	2	0	\N
206213	1397	1273463481000	27411	13554	0	0	\N
206214	2134	83735522000	27411	13554	1	0	\N
206215	2133	90332312000	27411	13554	2	0	\N
206219	1397	1273453480000	27413	13555	0	0	\N
206220	2134	83734519000	27413	13555	1	0	\N
206221	2133	90331310000	27413	13555	2	0	\N
206222	1397	1273453480000	27414	13555	0	0	\N
206223	2134	83734519000	27414	13555	1	0	\N
206224	2133	90331310000	27414	13555	2	0	\N
206225	1397	1273443479000	27415	13556	0	0	\N
206226	2134	83733516000	27415	13556	1	0	\N
206227	2133	90330308000	27415	13556	2	0	\N
206228	1397	1273443479000	27416	13556	0	0	\N
206229	2134	83733516000	27416	13556	1	0	\N
206230	2133	90330308000	27416	13556	2	0	\N
206231	1397	1273443479000	27417	13556	0	0	\N
206232	2134	83733516000	27417	13556	1	0	\N
206233	2133	90330308000	27417	13556	2	0	\N
206237	1397	1273443479000	27419	13556	0	0	\N
206238	2134	83733516000	27419	13556	1	0	\N
206239	2133	90330308000	27419	13556	2	0	\N
206249	1397	1273433478000	27421	13557	0	0	\N
206250	1397	1273423477000	27421	13557	1	0	\N
206251	1397	1273413476000	27421	13557	2	0	\N
206252	2134	83732513000	27421	13557	3	0	\N
206253	2133	90329306000	27421	13557	4	0	\N
206254	2133	90328304000	27421	13557	5	0	\N
206255	2134	83731510000	27421	13557	6	0	\N
206256	2134	83730507000	27421	13557	7	0	\N
206257	2133	90327302000	27421	13557	8	0	\N
206258	1397	1273433478000	27422	13557	0	0	\N
206259	1397	1273423477000	27422	13557	1	0	\N
206260	1397	1273413476000	27422	13557	2	0	\N
206261	2134	83732513000	27422	13557	3	0	\N
206262	2133	90329306000	27422	13557	4	0	\N
206263	2133	90328304000	27422	13557	5	0	\N
206264	2134	83731510000	27422	13557	6	0	\N
206265	2134	83730507000	27422	13557	7	0	\N
206266	2133	90327302000	27422	13557	8	0	\N
206267	2133	90367382000	27423	13436	0	0	\N
206268	2133	90366380000	27423	13436	1	0	\N
206269	2133	90365378000	27423	13436	2	0	\N
206270	2133	90364376000	27423	13436	3	0	\N
206271	2133	90363374000	27423	13436	4	0	\N
206272	2133	90362372000	27423	13436	5	0	\N
206273	2133	90361370000	27423	13436	6	0	\N
206274	2133	90360368000	27423	13436	7	0	\N
206275	2133	90359366000	27423	13436	8	0	\N
206276	2133	90358364000	27423	13436	9	0	\N
206277	2133	90357362000	27423	13436	10	0	\N
206278	2133	90356360000	27423	13436	11	0	\N
206279	2133	90355358000	27423	13436	12	0	\N
206280	2133	90354356000	27423	13436	13	0	\N
206281	2133	90353354000	27423	13436	14	0	\N
206282	2133	90352352000	27423	13436	15	0	\N
206283	2133	90351350000	27423	13436	16	0	\N
206284	2133	90350348000	27423	13436	17	0	\N
206285	2133	90349346000	27423	13436	18	0	\N
206286	2133	90348344000	27423	13436	19	0	\N
206287	2133	90347342000	27423	13436	20	0	\N
206288	2133	90346340000	27423	13436	21	0	\N
206289	2133	90345338000	27423	13436	22	0	\N
206290	2133	90344336000	27423	13436	23	0	\N
206291	2133	90343334000	27423	13436	24	0	\N
206292	2133	90342332000	27423	13436	25	0	\N
206293	2133	90341330000	27423	13436	26	0	\N
206294	2133	90340328000	27423	13436	27	0	\N
206295	2133	90339326000	27423	13436	28	0	\N
206296	2133	90338324000	27423	13436	30	0	\N
206297	2133	90337322000	27423	13436	31	0	\N
206298	2133	90336320000	27423	13436	32	0	\N
206299	2133	90335318000	27423	13436	33	0	\N
206300	2133	90334316000	27423	13436	34	0	\N
206301	2133	90333314000	27423	13436	35	0	\N
206302	2133	90332312000	27423	13436	36	0	\N
206303	2133	90331310000	27423	13436	37	0	\N
206304	2133	90330308000	27423	13436	38	0	\N
206305	2133	90329306000	27423	13436	39	0	\N
206306	2133	90328304000	27423	13436	40	0	\N
206307	2133	90327302000	27423	13436	41	0	\N
206179	2133	90338324000	27399	13548	2	0	6340
206180	1397	1273513486000	27400	13549	0	0	16531
206181	2134	83740537000	27400	13549	1	0	6829
206182	2133	90337322000	27400	13549	2	0	6341
206186	1397	1273503485000	27402	13550	0	0	16532
206188	2133	90336320000	27402	13550	2	0	6342
206192	1397	1273493484000	27404	13551	0	0	16533
206193	2133	90335318000	27404	13551	1	0	6343
206194	2134	83738531000	27404	13551	2	0	6831
206198	1397	1273483483000	27406	13552	0	0	16534
206200	2133	90334316000	27406	13552	2	0	6344
206201	1397	1273473482000	27407	13553	0	0	16535
206202	2134	83736525000	27407	13553	1	0	6833
206203	2133	90333314000	27407	13553	2	0	6345
206208	2134	83735522000	27409	13554	1	0	6834
206209	2133	90332312000	27409	13554	2	0	6346
206216	1397	1273453480000	27412	13555	0	0	16537
206217	2134	83734519000	27412	13555	1	0	6835
206218	2133	90331310000	27412	13555	2	0	6347
206235	2134	83733516000	27418	13556	1	0	6836
206236	2133	90330308000	27418	13556	2	0	6348
206240	1397	1273433478000	27420	13557	0	0	16539
206241	1397	1273423477000	27420	13557	1	0	16540
206242	1397	1273413476000	27420	13557	2	0	16541
206244	2133	90329306000	27420	13557	4	0	6349
206245	2133	90328304000	27420	13557	5	0	6350
206246	2134	83731510000	27420	13557	6	0	6838
206247	2134	83730507000	27420	13557	7	0	6839
206308	1397	1273403475000	27424	13558	0	0	16542
206309	1397	1273393474000	27424	13558	1	0	16543
206310	1397	1273383473000	27424	13558	2	0	16544
206311	2133	90326300000	27424	13558	3	0	6352
206312	2133	90325298000	27424	13558	4	0	6353
206317	1397	1273403475000	27425	13558	0	0	\N
206318	1397	1273393474000	27425	13558	1	0	\N
206319	1397	1273383473000	27425	13558	2	0	\N
206320	2133	90326300000	27425	13558	3	0	\N
206321	2133	90325298000	27425	13558	4	0	\N
206322	2133	90324296000	27425	13558	5	0	\N
206323	2134	83729504000	27425	13558	6	0	\N
206324	2134	83728501000	27425	13558	7	0	\N
206325	2134	83727498000	27425	13558	8	0	\N
206329	1397	1273373472000	27427	13559	0	0	\N
206330	2133	90323294000	27427	13559	1	0	\N
206331	2134	83726495000	27427	13559	2	0	\N
206332	1397	1273363471000	27428	13560	0	0	\N
206333	2134	83725492000	27428	13560	1	0	\N
206334	2133	90322292000	27428	13560	2	0	\N
206335	1397	1273363471000	27429	13560	0	0	\N
206336	2134	83725492000	27429	13560	1	0	\N
206337	2133	90322292000	27429	13560	2	0	\N
206338	1397	1273363471000	27430	13560	0	0	\N
206339	2134	83725492000	27430	13560	1	0	\N
206340	2133	90322292000	27430	13560	2	0	\N
206350	1397	1273343469000	27434	13562	0	0	\N
206351	2134	83723486000	27434	13562	1	0	\N
206352	2133	90320288000	27434	13562	2	0	\N
206353	1397	1273343469000	27435	13562	0	0	\N
206354	2134	83723486000	27435	13562	1	0	\N
206355	2133	90320288000	27435	13562	2	0	\N
206356	1397	1273343469000	27436	13562	0	0	\N
206357	2134	83723486000	27436	13562	1	0	\N
206358	2133	90320288000	27436	13562	2	0	\N
206362	1515	1440048603400	27438	13406	0	0	\N
206363	1397	1273323467000	27439	13564	0	0	\N
206364	1397	1273313466000	27439	13564	1	0	\N
206365	2133	90318284000	27439	13564	2	0	\N
206366	2133	90317282000	27439	13564	3	0	\N
206367	2134	83721480000	27439	13564	4	0	\N
206368	2134	83720477000	27439	13564	5	0	\N
206369	1515	1440048603400	27439	13564	6	0	\N
206377	1515	1440048603400	27441	13421	0	0	\N
206378	1397	1273323467000	27442	13564	0	0	\N
206379	1397	1273313466000	27442	13564	1	0	\N
206380	2133	90318284000	27442	13564	2	0	\N
206381	2133	90317282000	27442	13564	3	0	\N
206382	2134	83721480000	27442	13564	4	0	\N
206383	2134	83720477000	27442	13564	5	0	\N
206384	1515	1440048603400	27442	13564	6	0	\N
206385	1515	1440048603400	27443	13435	0	0	\N
206386	1515	1440048603400	27444	13448	0	0	\N
206390	1397	1273293464000	27446	13566	0	0	\N
206391	1397	1273283463000	27446	13566	1	0	\N
206392	2134	83718471000	27446	13566	2	0	\N
206393	2133	90315278000	27446	13566	3	0	\N
206394	2134	83717468000	27446	13566	4	0	\N
206395	2133	90314276000	27446	13566	5	0	\N
206396	1397	1273293464000	27447	13566	0	0	\N
206397	1397	1273283463000	27447	13566	1	0	\N
206398	2134	83718471000	27447	13566	2	0	\N
206399	2133	90315278000	27447	13566	3	0	\N
206400	2134	83717468000	27447	13566	4	0	\N
206401	2133	90314276000	27447	13566	5	0	\N
206408	1397	1273293464000	27449	13566	0	0	\N
206409	1397	1273283463000	27449	13566	1	0	\N
206410	2134	83718471000	27449	13566	2	0	\N
206411	2133	90315278000	27449	13566	3	0	\N
206412	2134	83717468000	27449	13566	4	0	\N
206413	2133	90314276000	27449	13566	5	0	\N
206414	1397	1273293464000	27450	13566	0	0	\N
206415	1397	1273283463000	27450	13566	1	0	\N
206416	2134	83718471000	27450	13566	2	0	\N
206417	2133	90315278000	27450	13566	3	0	\N
206418	2134	83717468000	27450	13566	4	0	\N
206419	2133	90314276000	27450	13566	5	0	\N
206420	1397	1273273462000	27451	13567	0	0	\N
206421	2134	83716465000	27451	13567	1	0	\N
206422	2133	90313274000	27451	13567	2	0	\N
206432	1397	1273253460000	27455	13569	0	0	\N
206433	2133	90311270000	27455	13569	1	0	\N
206434	2134	83714459000	27455	13569	2	0	\N
206438	1397	1273243459000	27457	13570	0	0	\N
206439	2133	90310268000	27457	13570	1	0	\N
206440	2134	83713456000	27457	13570	2	0	\N
206315	2134	83728501000	27424	13558	7	0	6841
206316	2134	83727498000	27424	13558	8	0	6842
206326	1397	1273373472000	27426	13559	0	0	16545
206327	2133	90323294000	27426	13559	1	0	6355
206328	2134	83726495000	27426	13559	2	0	6843
206342	2134	83725492000	27431	13560	1	0	6844
206343	2133	90322292000	27431	13560	2	0	6356
206344	1397	1273353470000	27432	13561	0	0	16547
206345	2133	90321290000	27432	13561	1	0	6357
206346	2134	83724489000	27432	13561	2	0	6845
206348	2134	83723486000	27433	13562	1	0	6846
206349	2133	90320288000	27433	13562	2	0	6358
206359	1397	1273333468000	27437	13563	0	0	16549
206360	2134	83722483000	27437	13563	1	0	6847
206370	1397	1273323467000	27440	13564	0	0	16550
206371	1397	1273313466000	27440	13564	1	0	16551
206372	2133	90318284000	27440	13564	2	0	6360
206373	2133	90317282000	27440	13564	3	0	6361
206374	2134	83721480000	27440	13564	4	0	6848
206376	1515	1440048603400	27440	13564	6	0	2
206387	1397	1273303465000	27445	13565	0	0	16552
206388	2134	83719474000	27445	13565	2	0	6850
206389	2133	90316280000	27445	13565	3	0	6362
206402	1397	1273293464000	27448	13566	0	0	16553
206404	2134	83718471000	27448	13566	2	0	6851
206405	2133	90315278000	27448	13566	3	0	6363
206406	2134	83717468000	27448	13566	4	0	6852
206407	2133	90314276000	27448	13566	5	0	6364
206424	2134	83716465000	27452	13567	1	0	6853
206425	2133	90313274000	27452	13567	2	0	6365
206426	1397	1273263461000	27453	13568	0	0	16556
206427	2134	83715462000	27453	13568	1	0	6854
206428	2133	90312272000	27453	13568	2	0	6366
206430	2133	90311270000	27454	13569	1	0	6367
206431	2134	83714459000	27454	13569	2	0	6855
206435	1397	1273243459000	27456	13570	0	0	16558
206436	2133	90310268000	27456	13570	1	0	6368
206437	2134	83713456000	27456	13570	2	0	6856
206442	1397	1273223457000	27458	13571	1	0	16560
206443	1693	15042498716916	27458	13571	2	0	1250
206444	1693	14974189805187	27458	13571	3	0	1251
206445	1693	14905588951831	27458	13571	4	0	1252
206447	1693	14768387245119	27458	13571	6	0	1254
206448	1693	14699786391763	27458	13571	7	0	1255
206464	1397	1273203455000	27460	13573	0	0	\N
206465	2134	83709444000	27460	13573	1	0	\N
206466	2133	90306260000	27460	13573	2	0	\N
206467	1693	14148899781489	27460	13573	3	0	\N
206468	1693	14080298928133	27460	13573	4	0	\N
206469	1693	14011698074777	27460	13573	5	0	\N
206470	1693	13943097221421	27460	13573	6	0	\N
206471	1693	13874785836115	27460	13573	7	0	\N
206472	1693	13806184982759	27460	13573	8	0	\N
206482	1397	1273203455000	27462	13573	0	0	\N
206483	2134	83709444000	27462	13573	1	0	\N
206484	2133	90306260000	27462	13573	2	0	\N
206485	1693	14148899781489	27462	13573	3	0	\N
206486	1693	14080298928133	27462	13573	4	0	\N
206487	1693	14011698074777	27462	13573	5	0	\N
206488	1693	13943097221421	27462	13573	6	0	\N
206489	1693	13874785836115	27462	13573	7	0	\N
206490	1693	13806184982759	27462	13573	8	0	\N
206491	2134	83709444000	27463	13573	0	0	\N
206492	1693	14148899781489	27463	13573	1	0	\N
206493	1693	14080298928133	27463	13573	2	0	\N
206494	1693	14011698074777	27463	13573	3	0	\N
206495	1693	13943097221421	27463	13573	4	0	\N
206496	1693	13874785836115	27463	13573	5	0	\N
206497	2134	83709444000	27464	13573	0	0	\N
206498	1693	14148899781489	27464	13573	1	0	\N
206499	1693	14080298928133	27464	13573	2	0	\N
206500	1693	14011698074777	27464	13573	3	0	\N
206501	1693	13943097221421	27464	13573	4	0	\N
206510	1397	1273193454000	27466	13574	0	0	\N
206511	1693	13737584129403	27466	13574	1	0	\N
206512	1693	13244794922670	27466	13574	2	0	\N
206513	1693	13176194069314	27466	13574	3	0	\N
206514	1693	13107593215958	27466	13574	4	0	\N
206515	1693	13038992362602	27466	13574	5	0	\N
206516	2133	90305258000	27466	13574	6	0	\N
206517	2134	83708441000	27466	13574	7	0	\N
206542	1397	1273183453000	27468	13575	0	0	\N
206543	1397	1273173452000	27468	13575	1	0	\N
206544	1397	1273163451000	27468	13575	2	0	\N
206545	1693	12720082164317	27468	13575	3	0	\N
206546	1693	12651772114121	27468	13575	4	0	\N
206547	1693	12463279838829	27468	13575	5	0	\N
206548	1693	12394678985473	27468	13575	6	0	\N
206549	1693	12389481026893	27468	13575	7	0	\N
206550	1693	12321171183691	27468	13575	8	0	\N
206551	1693	12252570330335	27468	13575	9	0	\N
206552	1693	11315749085263	27468	13575	10	0	\N
206553	1693	11247440007938	27468	13575	11	0	\N
206554	2134	83707438000	27468	13575	12	0	\N
206555	2134	83706435000	27468	13575	13	0	\N
206556	2134	83705432000	27468	13575	14	0	\N
206557	1693	11179131096209	27468	13575	15	0	\N
206558	1693	11110530242853	27468	13575	16	0	\N
206559	1693	11042220422602	27468	13575	17	0	\N
206560	1693	10973909037296	27468	13575	18	0	\N
206561	1693	9212529464164	27468	13575	19	0	\N
206562	1693	9143928610808	27468	13575	20	0	\N
206563	2133	90304256000	27468	13575	21	0	\N
206564	2133	90303254000	27468	13575	22	0	\N
206565	2133	90302252000	27468	13575	23	0	\N
206574	2134	83702423000	27471	13577	0	0	\N
206575	1693	8938417992367	27471	13577	1	0	\N
206576	2133	90299246000	27471	13577	2	0	\N
206577	1693	8936338208941	27471	13577	3	0	\N
206578	1693	8867737355585	27471	13577	4	0	\N
206579	1693	8799136502229	27471	13577	5	0	\N
206580	1693	8730535648873	27471	13577	6	0	\N
206581	2134	83702423000	27472	13577	0	0	\N
206582	1693	8938417992367	27472	13577	1	0	\N
206583	2133	90299246000	27472	13577	2	0	\N
206584	1693	8936338208941	27472	13577	3	0	\N
206451	2133	90309266000	27458	13571	10	0	6369
206452	2133	90308264000	27458	13571	11	0	6370
206453	2134	83712453000	27458	13571	12	0	6857
206454	2134	83711450000	27458	13571	13	0	6858
206455	1397	1273213456000	27459	13572	0	0	16561
206457	1693	14425382978339	27459	13572	2	0	1259
206458	2134	83710447000	27459	13572	3	0	6859
206459	2133	90307262000	27459	13572	4	0	6371
206460	1693	14356782124983	27459	13572	5	0	1260
206461	1693	14288181271627	27459	13572	6	0	1261
206463	1693	14217500634845	27459	13572	8	0	1263
206473	1397	1273203455000	27461	13573	0	0	16562
206474	2134	83709444000	27461	13573	1	0	6860
206475	2133	90306260000	27461	13573	2	0	6372
206477	1693	14080298928133	27461	13573	4	0	1265
206478	1693	14011698074777	27461	13573	5	0	1266
206479	1693	13943097221421	27461	13573	6	0	1267
206480	1693	13874785836115	27461	13573	7	0	1268
206481	1693	13806184982759	27461	13573	8	0	1269
206503	1693	13737584129403	27465	13574	1	0	1270
206504	1693	13244794922670	27465	13574	2	0	1271
206505	1693	13176194069314	27465	13574	3	0	1272
206506	1693	13107593215958	27465	13574	4	0	1273
206507	1693	13038992362602	27465	13574	5	0	1274
206509	2134	83708441000	27465	13574	7	0	6861
206518	1397	1273183453000	27467	13575	0	0	16564
206519	1397	1273173452000	27467	13575	1	0	16565
206520	1397	1273163451000	27467	13575	2	0	16566
206522	1693	12651772114121	27467	13575	4	0	1276
206523	1693	12463279838829	27467	13575	5	0	1277
206524	1693	12394678985473	27467	13575	6	0	1278
206525	1693	12389481026893	27467	13575	7	0	1279
206526	1693	12321171183691	27467	13575	8	0	1280
206528	1693	11315749085263	27467	13575	10	0	1282
206529	1693	11247440007938	27467	13575	11	0	1283
206530	2134	83707438000	27467	13575	12	0	6862
206531	2134	83706435000	27467	13575	13	0	6863
206532	2134	83705432000	27467	13575	14	0	6864
206534	1693	11110530242853	27467	13575	16	0	1285
206535	1693	11042220422602	27467	13575	17	0	1286
206536	1693	10973909037296	27467	13575	18	0	1287
206537	1693	9212529464164	27467	13575	19	0	1288
206539	2133	90304256000	27467	13575	21	0	6374
206540	2133	90303254000	27467	13575	22	0	6375
206541	2133	90302252000	27467	13575	23	0	6376
206566	1397	1273153450000	27469	13576	0	0	16567
206567	1397	1273143449000	27469	13576	1	0	16568
206569	1693	9075327757452	27469	13576	3	0	1290
206570	1693	9007018845723	27469	13576	4	0	1291
206571	2134	83704429000	27469	13576	5	0	6865
206572	2134	83703426000	27469	13576	6	0	6866
206573	2133	90300248000	27469	13576	7	0	6378
206585	1693	8867737355585	27472	13577	4	0	\N
206586	1693	8799136502229	27472	13577	5	0	\N
206587	1693	8730535648873	27472	13577	6	0	\N
206621	1397	1273133448000	27478	13579	0	0	\N
206622	1397	1273123447000	27478	13579	1	0	\N
206623	1397	1273113446000	27478	13579	2	0	\N
206624	2133	90298244000	27478	13579	3	0	\N
206625	2133	90297242000	27478	13579	4	0	\N
206626	2133	90296240000	27478	13579	5	0	\N
206627	1693	8661934795517	27478	13579	6	0	\N
206628	2134	83701420000	27478	13579	7	0	\N
206629	1693	8593333942161	27478	13579	8	0	\N
206630	1693	8524733088805	27478	13579	9	0	\N
206631	1693	8456421341262	27478	13579	10	0	\N
206632	1693	8388112027959	27478	13579	11	0	\N
206633	1693	8319803023075	27478	13579	12	0	\N
206634	1693	8251494018191	27478	13579	13	0	\N
206635	1693	8182893164835	27478	13579	14	0	\N
206636	1693	8114292311479	27478	13579	15	0	\N
206637	1693	8045691458123	27478	13579	16	0	\N
206638	1693	7977382039261	27478	13579	17	0	\N
206639	1693	7908781185905	27478	13579	18	0	\N
206640	1693	7840180332549	27478	13579	19	0	\N
206641	1693	7771425317468	27478	13579	20	0	\N
206642	1693	7702824464112	27478	13579	21	0	\N
206643	1693	7669125939644	27478	13579	22	0	\N
206644	1693	7600525086288	27478	13579	23	0	\N
206645	2134	83700417000	27478	13579	24	0	\N
206646	2134	83699414000	27478	13579	25	0	\N
206655	1397	1273093444000	27480	13581	0	0	\N
206656	1397	1273083443000	27480	13581	1	0	\N
206657	1693	7120902488917	27480	13581	2	0	\N
206658	686	69550057000000	27480	13581	3	0	\N
206659	2134	83697408000	27480	13581	4	0	\N
206660	1693	7052593484033	27480	13581	5	0	\N
206661	1693	6984284479149	27480	13581	6	0	\N
206662	1693	6915683625793	27480	13581	7	0	\N
206663	2134	83696405000	27480	13581	8	0	\N
206664	2133	90295238000	27480	13581	9	0	\N
206665	2133	90294236000	27480	13581	10	0	\N
206666	1693	6847082772437	27480	13581	11	0	\N
206667	1693	6778481919081	27480	13581	12	0	\N
206668	1693	6709881065725	27480	13581	13	0	\N
206669	1693	6641280212369	27480	13581	14	0	\N
206670	1693	6572679359013	27480	13581	15	0	\N
206671	1693	6504078505657	27480	13581	16	0	\N
206672	1693	6435477652301	27480	13581	17	0	\N
206590	2133	90299246000	27473	13577	2	0	6379
206591	1693	8936338208941	27473	13577	3	0	1293
206592	1693	8867737355585	27473	13577	4	0	1294
206593	1693	8799136502229	27473	13577	5	0	1295
206594	1693	8730535648873	27473	13577	6	0	1296
206596	1397	1273123447000	27477	13579	1	0	16570
206597	1397	1273113446000	27477	13579	2	0	16571
206598	2133	90298244000	27477	13579	3	0	6380
206599	2133	90297242000	27477	13579	4	0	6381
206600	2133	90296240000	27477	13579	5	0	6382
206602	2134	83701420000	27477	13579	7	0	6868
206603	1693	8593333942161	27477	13579	8	0	1298
206604	1693	8524733088805	27477	13579	9	0	1299
206605	1693	8456421341262	27477	13579	10	0	1300
206607	1693	8319803023075	27477	13579	12	0	1302
206608	1693	8251494018191	27477	13579	13	0	1303
206609	1693	8182893164835	27477	13579	14	0	1304
206610	1693	8114292311479	27477	13579	15	0	1305
206611	1693	8045691458123	27477	13579	16	0	1306
206613	1693	7908781185905	27477	13579	18	0	1308
206614	1693	7840180332549	27477	13579	19	0	1309
206615	1693	7771425317468	27477	13579	20	0	1310
206616	1693	7702824464112	27477	13579	21	0	1311
206617	1693	7669125939644	27477	13579	22	0	1312
206619	2134	83700417000	27477	13579	24	0	6869
206620	2134	83699414000	27477	13579	25	0	6870
206647	1397	1273103445000	27479	13580	0	0	16572
206648	1693	7532216174559	27479	13580	1	0	1314
206650	1693	7395305902341	27479	13580	3	0	1316
206651	1693	7326705048985	27479	13580	4	0	1317
206652	1693	7258104195629	27479	13580	5	0	1318
206653	1693	7189503342273	27479	13580	6	0	1319
206654	2134	83698411000	27479	13580	7	0	6871
206674	1397	1273083443000	27481	13581	1	0	16574
206675	1693	7120902488917	27481	13581	2	0	1320
206676	686	69550057000000	27481	13581	3	0	1
206677	2134	83697408000	27481	13581	4	0	6872
206678	1693	7052593484033	27481	13581	5	0	1321
206680	1693	6915683625793	27481	13581	7	0	1323
206681	2134	83696405000	27481	13581	8	0	6873
206682	2133	90295238000	27481	13581	9	0	6383
206683	2133	90294236000	27481	13581	10	0	6384
206685	1693	6778481919081	27481	13581	12	0	1325
206686	1693	6709881065725	27481	13581	13	0	1326
206687	1693	6641280212369	27481	13581	14	0	1327
206688	1693	6572679359013	27481	13581	15	0	1328
206689	1693	6504078505657	27481	13581	16	0	1329
206691	1397	1273073442000	27482	13582	0	0	16575
206692	2134	83695402000	27482	13582	1	0	6874
206693	2133	90293234000	27482	13582	2	0	6385
206694	1693	6366876798945	27482	13582	3	0	1331
206695	1693	6364803388663	27482	13582	4	0	1332
206697	1693	6227601681951	27482	13582	6	0	1334
206698	1693	6225530606620	27482	13582	7	0	1335
206699	1693	6156929753264	27482	13582	8	0	1336
206700	1397	1273063441000	27483	13583	0	0	16576
206702	2133	90292232000	27483	13583	2	0	6386
206703	1693	6019728046552	27483	13583	3	0	1338
206704	1693	5951127193196	27483	13583	4	0	1339
206705	2134	83694399000	27483	13583	5	0	6875
206706	1397	1273053440000	27484	13584	0	0	16577
206708	1397	1273033438000	27484	13584	2	0	16579
206709	2134	83693396000	27484	13584	3	0	6876
206710	1693	5882526339840	27484	13584	4	0	1340
206711	1693	5563616141555	27484	13584	5	0	1341
206712	1693	5495015288199	27484	13584	6	0	1342
206714	2134	83691390000	27484	13584	8	0	6878
206715	2133	90291230000	27484	13584	9	0	6387
206716	2133	90290228000	27484	13584	10	0	6388
206717	2133	90289226000	27484	13584	11	0	6389
206719	1693	5426414434843	27484	13584	13	0	1343
206720	1693	5358105420648	27484	13584	14	0	1344
206765	1397	1273013436000	27487	13586	0	0	\N
206766	1397	1273003435000	27487	13586	1	0	\N
206767	1397	1272993434000	27487	13586	2	0	\N
206768	2133	90287222000	27487	13586	3	0	\N
206769	2133	90286220000	27487	13586	4	0	\N
206770	2133	90285218000	27487	13586	5	0	\N
206771	1693	3985593740346	27487	13586	6	0	\N
206772	1693	3916992886990	27487	13586	7	0	\N
206773	1693	3848392033634	27487	13586	8	0	\N
206774	1693	3780083028750	27487	13586	9	0	\N
206775	1693	3711482175394	27487	13586	10	0	\N
206776	1693	3642881322038	27487	13586	11	0	\N
206777	1693	3640801538612	27487	13586	12	0	\N
206778	2134	83689384000	27487	13586	13	0	\N
206779	2134	83688381000	27487	13586	15	0	\N
206780	2134	83687378000	27487	13586	16	0	\N
206781	1693	3572200685256	27487	13586	17	0	\N
206782	1693	3503599831900	27487	13586	18	0	\N
206783	1693	3434998978544	27487	13586	19	0	\N
206784	1693	3366398125188	27487	13586	20	0	\N
206785	1693	3297797271832	27487	13586	21	0	\N
206786	1693	3229196418476	27487	13586	22	0	\N
206787	1693	3160595565120	27487	13586	23	0	\N
206788	1693	3092286560236	27487	13586	24	0	\N
206789	1693	3089178181597	27487	13586	25	0	\N
206790	1693	3020577328241	27487	13586	26	0	\N
206791	1693	2952268323357	27487	13586	27	0	\N
206792	1397	1273013436000	27488	13586	0	0	\N
206793	1397	1273003435000	27488	13586	1	0	\N
206794	1397	1272993434000	27488	13586	2	0	\N
206795	2133	90287222000	27488	13586	3	0	\N
206796	2133	90286220000	27488	13586	4	0	\N
206797	2133	90285218000	27488	13586	5	0	\N
206798	1693	3985593740346	27488	13586	6	0	\N
206799	1693	3916992886990	27488	13586	7	0	\N
206800	1693	3848392033634	27488	13586	8	0	\N
206801	1693	3780083028750	27488	13586	9	0	\N
206802	1693	3711482175394	27488	13586	10	0	\N
206803	1693	3642881322038	27488	13586	11	0	\N
206804	1693	3640801538612	27488	13586	12	0	\N
206805	2134	83689384000	27488	13586	13	0	\N
206806	2134	83688381000	27488	13586	15	0	\N
206807	2134	83687378000	27488	13586	16	0	\N
206808	1693	3572200685256	27488	13586	17	0	\N
206809	1693	3503599831900	27488	13586	18	0	\N
206810	1693	3434998978544	27488	13586	19	0	\N
206811	1693	3366398125188	27488	13586	20	0	\N
206812	1693	3297797271832	27488	13586	21	0	\N
206813	1693	3229196418476	27488	13586	22	0	\N
206814	1693	3160595565120	27488	13586	23	0	\N
206815	1693	3092286560236	27488	13586	24	0	\N
206816	1693	3089178181597	27488	13586	25	0	\N
206817	1693	3020577328241	27488	13586	26	0	\N
206818	1693	2952268323357	27488	13586	27	0	\N
206819	1397	1273013436000	27489	13586	0	0	\N
206820	1397	1273003435000	27489	13586	1	0	\N
206821	1397	1272993434000	27489	13586	2	0	\N
206822	2133	90287222000	27489	13586	3	0	\N
206823	2133	90286220000	27489	13586	4	0	\N
206824	2133	90285218000	27489	13586	5	0	\N
206825	1693	3985593740346	27489	13586	6	0	\N
206826	1693	3916992886990	27489	13586	7	0	\N
206827	1693	3848392033634	27489	13586	8	0	\N
206828	1693	3780083028750	27489	13586	9	0	\N
206829	1693	3711482175394	27489	13586	10	0	\N
206830	1693	3642881322038	27489	13586	11	0	\N
206831	1693	3640801538612	27489	13586	12	0	\N
206832	2134	83689384000	27489	13586	13	0	\N
206833	2134	83688381000	27489	13586	15	0	\N
206834	2134	83687378000	27489	13586	16	0	\N
206835	1693	3572200685256	27489	13586	17	0	\N
206836	1693	3503599831900	27489	13586	18	0	\N
206837	1693	3434998978544	27489	13586	19	0	\N
206838	1693	3366398125188	27489	13586	20	0	\N
206839	1693	3297797271832	27489	13586	21	0	\N
206840	1693	3229196418476	27489	13586	22	0	\N
206841	1693	3160595565120	27489	13586	23	0	\N
206842	1693	3092286560236	27489	13586	24	0	\N
206843	1693	3089178181597	27489	13586	25	0	\N
206844	1693	3020577328241	27489	13586	26	0	\N
206845	1693	2952268323357	27489	13586	27	0	\N
206723	1693	5200492112057	27484	13584	17	0	1347
206724	1693	5131891258701	27484	13584	18	0	1348
206725	1693	5063581208505	27484	13584	19	0	1349
206726	1693	4995272194310	27484	13584	20	0	1350
206727	1693	4926963272227	27484	13584	21	0	1351
206729	1693	4789761565515	27484	13584	23	0	1353
206730	1397	1273023437000	27485	13585	0	0	16580
206731	1693	4721452560631	27485	13585	1	0	1354
206732	1693	4652851707275	27485	13585	2	0	1355
206733	1693	4130069053118	27485	13585	3	0	1356
206735	1693	4122792311107	27485	13585	5	0	1357
206736	1693	4054191457751	27485	13585	6	0	1358
206737	2134	83690387000	27485	13585	7	0	6879
206738	1397	1273013436000	27486	13586	0	0	16581
206740	1397	1272993434000	27486	13586	2	0	16583
206741	2133	90287222000	27486	13586	3	0	6391
206742	2133	90286220000	27486	13586	4	0	6392
206743	2133	90285218000	27486	13586	5	0	6393
206744	1693	3985593740346	27486	13586	6	0	1359
206746	1693	3848392033634	27486	13586	8	0	1361
206747	1693	3780083028750	27486	13586	9	0	1362
206748	1693	3711482175394	27486	13586	10	0	1363
206749	1693	3642881322038	27486	13586	11	0	1364
206750	1693	3640801538612	27486	13586	12	0	1365
206752	2134	83688381000	27486	13586	15	0	6881
206753	2134	83687378000	27486	13586	16	0	6882
206754	1693	3572200685256	27486	13586	17	0	1366
206755	1693	3503599831900	27486	13586	18	0	1367
206757	1693	3366398125188	27486	13586	20	0	1369
206758	1693	3297797271832	27486	13586	21	0	1370
206759	1693	3229196418476	27486	13586	22	0	1371
206760	1693	3160595565120	27486	13586	23	0	1372
206761	1693	3092286560236	27486	13586	24	0	1373
206763	1693	3020577328241	27486	13586	26	0	1375
206764	1693	2952268323357	27486	13586	27	0	1376
206846	1397	1272983433000	27490	13587	0	0	16584
206847	1397	1272973432000	27490	13587	1	0	16585
206848	2134	83686375000	27490	13587	2	0	6883
206850	1693	2251575183185	27490	13587	4	0	1378
206851	1693	2182974329829	27490	13587	5	0	1379
206852	2134	83685372000	27490	13587	6	0	6884
206853	1693	2114373476473	27490	13587	7	0	1380
206855	2133	90283214000	27490	13587	9	0	6395
206856	1397	1272963431000	27491	13588	0	0	16586
206863	1693	45773623117	27493	13589	0	0	\N
206864	1397	1272953430000	27493	13589	1	0	\N
206865	2134	83683366000	27493	13589	2	0	\N
206866	2133	90281210000	27493	13589	3	0	\N
206876	1397	1272913426000	27496	13592	0	0	\N
206877	2133	90277202000	27496	13592	1	0	\N
206878	2134	83679354000	27496	13592	2	0	\N
206882	1397	1272903425000	27498	13593	0	0	\N
206883	2338	7000000	27498	13593	1	0	\N
206884	2133	90276200000	27498	13593	2	0	\N
206885	2134	83678351000	27498	13593	3	0	\N
206893	1397	1272893424000	27501	13594	0	0	\N
206894	2133	90275198000	27501	13594	1	0	\N
206895	2134	83677348000	27501	13594	2	0	\N
206896	1397	1272893424000	27502	13594	0	0	\N
206897	2133	90275198000	27502	13594	1	0	\N
206898	2134	83677348000	27502	13594	2	0	\N
206932	1397	1272823417000	27508	13599	0	0	\N
206933	1397	1272813416000	27508	13599	1	0	\N
206934	1397	1272803415000	27508	13599	2	0	\N
206935	1397	1272793414000	27508	13599	3	0	\N
206936	1397	1272783413000	27508	13599	4	0	\N
206937	2134	83670327000	27508	13599	5	0	\N
206938	2133	90268184000	27508	13599	6	0	\N
206939	2133	90267182000	27508	13599	7	0	\N
206940	2134	83669324000	27508	13599	8	0	\N
206941	2134	83668321000	27508	13599	9	0	\N
206942	2134	83667318000	27508	13599	10	0	\N
206943	2134	83666315000	27508	13599	11	0	\N
206944	2133	90266180000	27508	13599	12	0	\N
206945	2133	90265178000	27508	13599	13	0	\N
206946	2133	90264176000	27508	13599	14	0	\N
206956	1397	1272743409000	27510	13601	0	0	\N
206957	2133	90260168000	27510	13601	1	0	\N
206958	2134	83662303000	27510	13601	2	0	\N
206962	1397	1272743409000	27512	13601	0	0	\N
206963	2134	83662303000	27512	13601	1	0	\N
206964	1397	1272733408000	27513	13602	0	0	\N
206965	2134	83661300000	27513	13602	2	0	\N
206966	1397	1272733408000	27514	13602	0	0	\N
206967	2134	83661300000	27514	13602	2	0	\N
206968	2133	90259166000	27514	13602	3	0	\N
206972	1397	1272733408000	27516	13602	0	0	\N
206973	2134	83661300000	27516	13602	2	0	\N
206974	2133	90259166000	27516	13602	3	0	\N
206975	1397	1272723407000	27517	13603	0	0	\N
206976	2133	90258164000	27517	13603	1	0	\N
206977	2134	83660297000	27517	13603	2	0	\N
206859	1693	45773623117	27492	13589	0	0	1381
206860	1397	1272953430000	27492	13589	1	0	16587
206861	2134	83683366000	27492	13589	2	0	6886
206862	2133	90281210000	27492	13589	3	0	6397
206867	1397	1272943429000	27494	13590	0	0	16588
206869	2133	90280208000	27494	13590	2	0	6398
206870	2133	90279206000	27494	13590	3	0	6399
206871	2134	83682363000	27494	13590	4	0	6887
206872	2134	83681360000	27494	13590	5	0	6888
206873	1397	1272923427000	27495	13591	0	0	16590
206875	2133	90278204000	27495	13591	2	0	6400
206879	1397	1272913426000	27497	13592	0	0	16591
206880	2133	90277202000	27497	13592	1	0	6401
206881	2134	83679354000	27497	13592	2	0	6890
206887	2338	7000000	27499	13593	1	0	3
206888	2133	90276200000	27499	13593	2	0	6402
206889	2134	83678351000	27499	13593	3	0	6891
206890	1397	1272893424000	27500	13594	0	0	16593
206891	2133	90275198000	27500	13594	1	0	6403
206899	1397	1272883423000	27503	13595	0	0	16594
206900	1397	1272873422000	27503	13595	1	0	16595
206901	2134	83676345000	27503	13595	2	0	6893
206902	2134	83675342000	27503	13595	3	0	6894
206903	2133	90274196000	27503	13595	4	0	6404
206905	1397	1272863421000	27504	13596	0	0	16596
206906	2134	83674339000	27504	13596	1	0	6895
206907	2133	90272192000	27504	13596	2	0	6406
206908	1397	1272853420000	27505	13597	0	0	16597
206910	2134	83673336000	27505	13597	2	0	6896
206911	2133	90271190000	27505	13597	3	0	6407
206912	2134	83672333000	27505	13597	4	0	6897
206913	2133	90270188000	27505	13597	5	0	6408
206914	1397	1272833418000	27506	13598	0	0	16599
206916	2134	83671330000	27506	13598	2	0	6898
206917	1397	1272823417000	27507	13599	0	0	16600
206918	1397	1272813416000	27507	13599	1	0	16601
206919	1397	1272803415000	27507	13599	2	0	16602
206920	1397	1272793414000	27507	13599	3	0	16603
206922	2134	83670327000	27507	13599	5	0	6899
206923	2133	90268184000	27507	13599	6	0	6410
206924	2133	90267182000	27507	13599	7	0	6411
206925	2134	83669324000	27507	13599	8	0	6900
206927	2134	83667318000	27507	13599	10	0	6902
206928	2134	83666315000	27507	13599	11	0	6903
206929	2133	90266180000	27507	13599	12	0	6412
206930	2133	90265178000	27507	13599	13	0	6413
206931	2133	90264176000	27507	13599	14	0	6414
206948	1397	1272763411000	27509	13600	1	0	16606
206949	1397	1272753410000	27509	13600	2	0	16607
206950	2134	83665312000	27509	13600	3	0	6904
206951	2134	83664309000	27509	13600	4	0	6905
206952	2134	83663306000	27509	13600	5	0	6906
206954	2133	90262172000	27509	13600	7	0	6416
206955	2133	90261170000	27509	13600	8	0	6417
206959	1397	1272743409000	27511	13601	0	0	16608
206960	2133	90260168000	27511	13601	1	0	6418
206969	1397	1272733408000	27515	13602	0	0	16609
206970	2134	83661300000	27515	13602	2	0	6908
206971	2133	90259166000	27515	13602	3	0	6419
206978	1397	1272723407000	27518	13603	0	0	16610
206979	2133	90258164000	27518	13603	1	0	6420
206981	1397	1272713406000	27519	13604	1	0	16611
206982	2132	147270283000	27519	13604	2	0	1718
206983	2133	90257162000	27519	13604	3	0	6421
206984	2134	83660297000	27519	13604	4	0	6909
206985	2134	83659294000	27519	13604	5	0	6910
206987	1397	1272693404000	27520	13605	1	0	16613
206988	1397	1272683403000	27520	13605	2	0	16614
206989	2132	147269282000	27520	13605	3	0	1719
206990	2134	83658291000	27520	13605	4	0	6911
206992	2133	90255158000	27520	13605	6	0	6423
207014	1397	1272633398000	27524	13609	0	0	\N
207015	2133	90249146000	27524	13609	1	0	\N
207016	2134	83651270000	27524	13609	2	0	\N
207020	1397	1272633398000	27526	13609	0	0	\N
207021	2133	90249146000	27526	13609	1	0	\N
207022	2134	83651270000	27526	13609	2	0	\N
207023	1397	1272633398000	27527	13609	0	0	\N
207024	2133	90249146000	27527	13609	1	0	\N
207025	1444	11767905329999	27528	13533	0	0	\N
207026	2132	147270283000	27528	13533	1	0	\N
207027	2132	147269282000	27528	13533	2	0	\N
207028	2338	7000000	27528	13533	3	0	\N
207029	1693	17042498716916	27528	13533	4	0	\N
207030	2132	147268281000	27528	13533	5	0	\N
207031	686	69550057000000	27528	13533	6	0	\N
207032	1693	16974189805187	27528	13533	7	0	\N
207033	1726	947250112000	27528	13533	8	0	\N
207034	1693	16905588951831	27528	13533	9	0	\N
207035	1726	946149112000	27528	13533	10	0	\N
207036	1726	945048112000	27528	13533	11	0	\N
207037	1726	943947112000	27528	13533	12	0	\N
207038	1693	16836988098475	27528	13533	13	0	\N
207039	1693	16768387245119	27528	13533	14	0	\N
207040	1693	16699786391763	27528	13533	15	0	\N
207041	1693	16631185538407	27528	13533	16	0	\N
207042	1693	16562584685051	27528	13533	17	0	\N
207043	1693	16493983831695	27528	13533	18	0	\N
207044	1693	16425382978339	27528	13533	19	0	\N
207045	1693	16356782124983	27528	13533	20	0	\N
207046	1693	16288181271627	27528	13533	21	0	\N
207047	1693	16219580418271	27528	13533	22	0	\N
207048	1693	16217500634845	27528	13533	23	0	\N
207049	1693	16148899781489	27528	13533	24	0	\N
207050	1693	16080298928133	27528	13533	25	0	\N
207051	1693	16011698074777	27528	13533	26	0	\N
207052	1693	15943097221421	27528	13533	27	0	\N
207053	1693	15874785836115	27528	13533	28	0	\N
207054	1693	15806184982759	27528	13533	29	0	\N
207055	1693	15737584129403	27528	13533	30	0	\N
207056	1693	15244794922670	27528	13533	31	0	\N
207057	1693	15176194069314	27528	13533	32	0	\N
207058	1693	15107593215958	27528	13533	33	0	\N
207059	1693	15038992362602	27528	13533	34	0	\N
207060	1693	14720082164317	27528	13533	35	0	\N
207061	1693	14651772114121	27528	13533	36	0	\N
207062	1693	14463279838829	27528	13533	37	0	\N
207063	1693	14394678985473	27528	13533	38	0	\N
207064	1693	14389481026893	27528	13533	39	0	\N
207065	1693	14321171183691	27528	13533	40	0	\N
207066	1693	14252570330335	27528	13533	41	0	\N
207067	1693	13315749085263	27528	13533	42	0	\N
207068	1693	13247440007938	27528	13533	43	0	\N
207069	1693	13179131096209	27528	13533	44	0	\N
207070	1693	13110530242853	27528	13533	45	0	\N
207071	1693	13042220422602	27528	13533	46	0	\N
207072	1693	12973909037296	27528	13533	47	0	\N
207073	1693	11212529464164	27528	13533	48	0	\N
207074	2132	147267280000	27528	13533	49	0	\N
207075	1693	11143928610808	27528	13533	50	0	\N
207076	1693	11075327757452	27528	13533	51	0	\N
207077	1693	11007018845723	27528	13533	52	0	\N
207078	1693	10938417992367	27528	13533	53	0	\N
207079	1693	10936338208941	27528	13533	54	0	\N
207080	1693	10867737355585	27528	13533	55	0	\N
207081	1693	10799136502229	27528	13533	56	0	\N
207082	1693	10730535648873	27528	13533	57	0	\N
207083	1693	10661934795517	27528	13533	58	0	\N
207084	1515	1440048603400	27528	13533	59	0	\N
207085	1693	10593333942161	27528	13533	60	0	\N
207086	1693	10524733088805	27528	13533	61	0	\N
207087	1693	10456421341262	27528	13533	62	0	\N
207088	1693	10388112027959	27528	13533	63	0	\N
207089	1693	10319803023075	27528	13533	64	0	\N
207090	1693	10251494018191	27528	13533	65	0	\N
207091	1693	10182893164835	27528	13533	66	0	\N
207092	1693	10114292311479	27528	13533	67	0	\N
207093	1693	10045691458123	27528	13533	68	0	\N
207094	1693	9977382039261	27528	13533	69	0	\N
207095	1693	9908781185905	27528	13533	70	0	\N
207096	1693	9840180332549	27528	13533	71	0	\N
207097	1693	9771425317468	27528	13533	72	0	\N
207098	1693	9702824464112	27528	13533	73	0	\N
207099	1693	9669125939644	27528	13533	74	0	\N
207100	1693	9600525086288	27528	13533	75	0	\N
207101	1693	9532216174559	27528	13533	76	0	\N
207102	1693	9463615321203	27528	13533	77	0	\N
207103	1693	9395305902341	27528	13533	78	0	\N
207104	1693	9326705048985	27528	13533	79	0	\N
207105	1693	9258104195629	27528	13533	80	0	\N
207106	1693	9189503342273	27528	13533	81	0	\N
207107	1693	9120902488917	27528	13533	82	0	\N
207108	1693	9052593484033	27528	13533	83	0	\N
207109	1693	8984284479149	27528	13533	84	0	\N
207110	1693	8915683625793	27528	13533	85	0	\N
207111	1693	8847082772437	27528	13533	86	0	\N
207112	1693	8778481919081	27528	13533	88	0	\N
207113	1397	1272623397000	27529	13610	0	0	\N
207114	1397	1272613396000	27529	13610	1	0	\N
207115	2134	83650267000	27529	13610	2	0	\N
207116	2133	90248144000	27529	13610	3	0	\N
207117	2133	90247142000	27529	13610	4	0	\N
207118	2134	83649264000	27529	13610	5	0	\N
206995	2133	90254156000	27520	13605	9	0	6424
206996	1726	946149112000	27520	13605	10	0	8336
206997	1726	945048112000	27520	13605	11	0	8337
206998	1726	943947112000	27520	13605	12	0	8338
206999	2134	83656285000	27520	13605	13	0	6913
207001	2132	147268281000	27521	13606	1	0	1720
207002	2134	83655282000	27521	13606	2	0	6914
207003	2133	90253154000	27521	13606	3	0	6425
207004	1397	1272663401000	27522	13607	0	0	16616
207005	2134	83654279000	27522	13607	1	0	6915
207007	1397	1272653400000	27523	13608	0	0	16617
207008	1397	1272643399000	27523	13608	1	0	16618
207009	2134	83653276000	27523	13608	2	0	6916
207010	2133	90251150000	27523	13608	3	0	6427
207012	2134	83652273000	27523	13608	5	0	6917
207013	2132	147267280000	27523	13608	6	0	1721
207017	1397	1272633398000	27525	13609	0	0	16619
207018	2133	90249146000	27525	13609	1	0	6429
207019	2134	83651270000	27525	13609	2	0	6918
207120	1397	1272613396000	27530	13610	1	0	16621
207121	2134	83650267000	27530	13610	2	0	6919
207122	2133	90248144000	27530	13610	3	0	6430
207123	2133	90247142000	27530	13610	4	0	6431
207124	2134	83649264000	27530	13610	5	0	6920
207126	2133	90246140000	27531	13611	1	0	6432
207127	1397	1272593394000	27532	13612	0	0	16623
207128	2133	90245138000	27532	13612	1	0	6433
207130	1397	1272593394000	27533	13612	0	0	\N
207131	2133	90245138000	27533	13612	1	0	\N
207132	2134	83648261000	27533	13612	2	0	\N
207133	1397	1274603595000	27534	13412	0	0	\N
207134	1397	1274593594000	27534	13412	1	0	\N
207135	1397	1274583593000	27534	13412	2	0	\N
207136	1397	1274573592000	27534	13412	3	0	\N
207137	1444	11767905329999	27534	13412	4	0	\N
207138	1397	1274563591000	27534	13412	5	0	\N
207139	1397	1274553590000	27534	13412	6	0	\N
207140	1397	1274543589000	27534	13412	7	0	\N
207141	1397	1274533588000	27534	13412	8	0	\N
207142	1397	1274523587000	27534	13412	9	0	\N
207143	1397	1274513586000	27534	13412	10	0	\N
207144	1397	1274503585000	27534	13412	11	0	\N
207145	1397	1274493584000	27534	13412	12	0	\N
207146	1397	1274483583000	27534	13412	13	0	\N
207147	1397	1274473582000	27534	13412	14	0	\N
207148	1397	1274463581000	27534	13412	15	0	\N
207149	1397	1274453580000	27534	13412	16	0	\N
207150	1397	1274443579000	27534	13412	17	0	\N
207151	1397	1274433578000	27534	13412	18	0	\N
207152	1397	1274423577000	27534	13412	19	0	\N
207153	1397	1274413576000	27534	13412	20	0	\N
207154	1397	1274403575000	27534	13412	21	0	\N
207155	1397	1274393574000	27534	13412	22	0	\N
207156	1397	1274383573000	27534	13412	23	0	\N
207157	1397	1274373572000	27534	13412	24	0	\N
207158	1397	1274363571000	27534	13412	25	0	\N
207159	1397	1274353570000	27534	13412	26	0	\N
207160	1397	1274343569000	27534	13412	27	0	\N
207161	1397	1274333568000	27534	13412	28	0	\N
207162	1397	1274323567000	27534	13412	29	0	\N
207163	1397	1274313566000	27534	13412	30	0	\N
207164	1397	1274303565000	27534	13412	31	0	\N
207165	1397	1274293564000	27534	13412	32	0	\N
207166	1397	1274283563000	27534	13412	33	0	\N
207167	1397	1274273562000	27534	13412	34	0	\N
207168	1397	1274263561000	27534	13412	35	0	\N
207169	1397	1274253560000	27534	13412	36	0	\N
207170	1397	1274243559000	27534	13412	37	0	\N
207171	1397	1274233558000	27534	13412	38	0	\N
207172	1397	1274223557000	27534	13412	39	0	\N
207173	1397	1274213556000	27534	13412	40	0	\N
207174	1397	1274203555000	27534	13412	41	0	\N
207175	1397	1274193554000	27534	13412	42	0	\N
207176	1397	1274183553000	27534	13412	43	0	\N
207177	1397	1274173552000	27534	13412	44	0	\N
207178	1397	1274163551000	27534	13412	45	0	\N
207179	1397	1274153550000	27534	13412	46	0	\N
207180	1397	1274143549000	27534	13412	47	0	\N
207181	1397	1274133548000	27534	13412	48	0	\N
207182	1397	1274123547000	27534	13412	49	0	\N
207183	1397	1274113546000	27534	13412	50	0	\N
207184	1397	1274103545000	27534	13412	51	0	\N
207185	1397	1274093544000	27534	13412	52	0	\N
207186	1397	1274083543000	27534	13412	53	0	\N
207187	1397	1274073542000	27534	13412	54	0	\N
207188	1397	1274063541000	27534	13412	55	0	\N
207189	1397	1274053540000	27534	13412	56	0	\N
207190	1397	1274043539000	27534	13412	57	0	\N
207191	1397	1274033538000	27534	13412	58	0	\N
207192	1397	1274023537000	27534	13412	59	0	\N
207193	1397	1274013536000	27534	13412	60	0	\N
207194	1397	1274003535000	27534	13412	61	0	\N
207195	1397	1273993534000	27534	13412	62	0	\N
207196	1397	1273983533000	27534	13412	63	0	\N
207197	1397	1273973532000	27534	13412	64	0	\N
207198	1397	1273963531000	27534	13412	65	0	\N
207199	1397	1273953530000	27534	13412	66	0	\N
207200	1397	1273943529000	27534	13412	67	0	\N
207201	1397	1273933528000	27534	13412	68	0	\N
207202	1397	1273923527000	27534	13412	69	0	\N
207203	1397	1273913526000	27534	13412	70	0	\N
207204	1397	1273903525000	27534	13412	71	0	\N
207205	1397	1273893524000	27534	13412	72	0	\N
207206	1397	1273883523000	27534	13412	73	0	\N
207207	1693	1945763623117	27535	13613	0	0	\N
207208	1397	1272583393000	27535	13613	1	0	\N
207209	1397	1272573392000	27535	13613	2	0	\N
207210	2134	83647258000	27535	13613	3	0	\N
207211	2133	90244136000	27535	13613	4	0	\N
207212	2133	90243134000	27535	13613	5	0	\N
207213	2134	83646255000	27535	13613	6	0	\N
207221	1693	1945763623117	27537	13613	0	0	\N
207222	1397	1272583393000	27537	13613	1	0	\N
207223	1397	1272573392000	27537	13613	2	0	\N
207224	2134	83647258000	27537	13613	3	0	\N
207225	2133	90244136000	27537	13613	4	0	\N
207226	2133	90243134000	27537	13613	5	0	\N
207227	2134	83646255000	27537	13613	6	0	\N
207228	1397	1272563391000	27538	13614	0	0	\N
207229	2133	90242132000	27538	13614	1	0	\N
207230	2134	83645252000	27538	13614	2	0	\N
207234	1397	1272563391000	27540	13614	0	0	\N
207235	2133	90242132000	27540	13614	1	0	\N
207236	2134	83645252000	27540	13614	2	0	\N
207237	1397	1272553390000	27541	13615	0	0	\N
207238	1693	45753623117	27541	13615	1	0	\N
207239	2134	83644249000	27541	13615	2	0	\N
207244	1397	1272553390000	27543	13615	0	0	\N
207245	1693	45753623117	27543	13615	1	0	\N
207246	2133	90241130000	27543	13615	2	0	\N
207247	2134	83644249000	27543	13615	3	0	\N
207248	1397	1272553390000	27544	13615	0	0	\N
207249	1693	45753623117	27544	13615	1	0	\N
207250	2133	90241130000	27544	13615	2	0	\N
207251	2134	83644249000	27544	13615	3	0	\N
207261	1397	1272543389000	27546	13616	0	0	\N
207262	1397	1272533388000	27546	13616	1	0	\N
207263	1397	1272523387000	27546	13616	2	0	\N
207264	2134	83643246000	27546	13616	3	0	\N
207215	1397	1272583393000	27536	13613	1	0	16624
207216	1397	1272573392000	27536	13613	2	0	16625
207217	2134	83647258000	27536	13613	3	0	6922
207218	2133	90244136000	27536	13613	4	0	6434
207219	2133	90243134000	27536	13613	5	0	6435
207231	1397	1272563391000	27539	13614	0	0	16626
207232	2133	90242132000	27539	13614	1	0	6436
207233	2134	83645252000	27539	13614	2	0	6924
207240	1397	1272553390000	27542	13615	0	0	16627
207241	1693	45753623117	27542	13615	1	0	1383
207243	2134	83644249000	27542	13615	3	0	6925
207252	1397	1272543389000	27545	13616	0	0	16628
207253	1397	1272533388000	27545	13616	1	0	16629
207254	1397	1272523387000	27545	13616	2	0	16630
207256	2133	90240128000	27545	13616	4	0	6438
207257	2133	90239126000	27545	13616	5	0	6439
207258	2133	90238124000	27545	13616	6	0	6440
207259	2134	83642243000	27545	13616	7	0	6927
207260	2134	83641240000	27545	13616	8	0	6928
207265	2133	90240128000	27546	13616	4	0	\N
207266	2133	90239126000	27546	13616	5	0	\N
207267	2133	90238124000	27546	13616	6	0	\N
207268	2134	83642243000	27546	13616	7	0	\N
207269	2134	83641240000	27546	13616	8	0	\N
207270	1397	1272543389000	27547	13616	0	0	\N
207271	1397	1272533388000	27547	13616	1	0	\N
207272	1397	1272523387000	27547	13616	2	0	\N
207273	2134	83643246000	27547	13616	3	0	\N
207274	2133	90240128000	27547	13616	4	0	\N
207275	2133	90239126000	27547	13616	5	0	\N
207276	2133	90238124000	27547	13616	6	0	\N
207277	2134	83642243000	27547	13616	7	0	\N
207278	2134	83641240000	27547	13616	8	0	\N
207285	1397	1272493384000	27549	13618	0	0	\N
207286	2133	90235118000	27549	13618	1	0	\N
207287	2134	83638231000	27549	13618	2	0	\N
207297	1397	1272473382000	27553	13620	0	0	\N
207298	2133	90234116000	27553	13620	1	0	\N
207299	2134	83636225000	27553	13620	2	0	\N
207300	2133	90233114000	27553	13620	3	0	\N
207301	1397	1272473382000	27554	13620	0	0	\N
207302	2133	90234116000	27554	13620	1	0	\N
207303	2134	83636225000	27554	13620	2	0	\N
207304	2133	90233114000	27554	13620	3	0	\N
207305	1397	1272473382000	27555	13620	0	0	\N
207306	2133	90234116000	27555	13620	1	0	\N
207307	2134	83636225000	27555	13620	2	0	\N
207308	2133	90233114000	27555	13620	3	0	\N
207312	2134	83634219000	27557	13622	0	0	\N
207313	2133	90231110000	27557	13622	1	0	\N
207320	1397	1272453380000	27560	13623	0	0	\N
207321	2134	83633216000	27560	13623	1	0	\N
207322	2382	99000000	27560	13623	2	0	\N
207323	2133	90230108000	27560	13623	3	0	\N
207324	1397	1272453380000	27561	13623	0	0	\N
207325	2134	83633216000	27561	13623	1	0	\N
207326	2382	99000000	27561	13623	2	0	\N
207327	2133	90230108000	27561	13623	3	0	\N
207328	1397	1272453380000	27562	13623	0	0	\N
207329	2134	83633216000	27562	13623	1	0	\N
207330	2382	99000000	27562	13623	2	0	\N
207331	2133	90230108000	27562	13623	3	0	\N
207332	1397	1272443379000	27563	13624	0	0	\N
207333	2133	90229106000	27563	13624	1	0	\N
207334	2134	83632213000	27563	13624	2	0	\N
207335	1397	1272443379000	27564	13624	0	0	\N
207336	2133	90229106000	27564	13624	1	0	\N
207337	2134	83632213000	27564	13624	2	0	\N
207344	1397	1272433378000	27567	13625	0	0	\N
207345	2134	83631210000	27567	13625	1	0	\N
207346	2133	90228104000	27567	13625	2	0	\N
207356	1397	1272403375000	27570	13627	0	0	\N
207357	2134	83628201000	27570	13627	1	0	\N
207358	2133	90225098000	27570	13627	2	0	\N
207359	1397	1272403375000	27571	13627	0	0	\N
207360	2134	83628201000	27571	13627	1	0	\N
207361	2133	90225098000	27571	13627	2	0	\N
207368	1397	1272373372000	27574	13629	0	0	\N
207369	2134	83625192000	27574	13629	1	0	\N
207370	2133	90222092000	27574	13629	2	0	\N
207374	1397	1272373372000	27576	13629	0	0	\N
207375	2134	83625192000	27576	13629	1	0	\N
207376	2133	90222092000	27576	13629	2	0	\N
207377	1444	11767905329999	27577	13437	0	0	\N
207378	2132	147270283000	27577	13437	1	0	\N
207379	2132	147269282000	27577	13437	2	0	\N
207380	2338	7000000	27577	13437	3	0	\N
207381	1693	13442390716916	27577	13437	4	0	\N
207382	2132	147268281000	27577	13437	5	0	\N
207383	686	69550057000000	27577	13437	6	0	\N
207384	2133	90326300000	27577	13437	7	0	\N
207385	2133	90325298000	27577	13437	8	0	\N
207386	2133	90324296000	27577	13437	9	0	\N
207387	1693	13374081805187	27577	13437	10	0	\N
207388	2133	90323294000	27577	13437	11	0	\N
207389	1693	13305480951831	27577	13437	12	0	\N
207390	2133	90322292000	27577	13437	13	0	\N
207391	2133	90321290000	27577	13437	14	0	\N
207392	2133	90320288000	27577	13437	15	0	\N
207393	1693	13236880098475	27577	13437	16	0	\N
207394	1693	13168279245119	27577	13437	17	0	\N
207395	1693	13099678391763	27577	13437	18	0	\N
207396	1693	13031077538407	27577	13437	19	0	\N
207397	1693	12962476685051	27577	13437	20	0	\N
207398	1693	12893875831695	27577	13437	21	0	\N
207399	1693	12825274978339	27577	13437	22	0	\N
207400	2382	99000000	27578	13620	0	0	\N
207281	2134	83640237000	27548	13617	2	0	6929
207282	2134	83639234000	27548	13617	3	0	6930
207283	2133	90237122000	27548	13617	4	0	6441
207284	2133	90236120000	27548	13617	5	0	6442
207288	1397	1272493384000	27550	13618	0	0	16633
207290	2134	83638231000	27550	13618	2	0	6931
207291	1397	1272483383000	27551	13619	0	0	16634
207292	2134	83637228000	27551	13619	1	0	6932
207293	1397	1272473382000	27552	13620	0	0	16635
207294	2133	90234116000	27552	13620	1	0	6444
207296	2133	90233114000	27552	13620	3	0	6445
207309	1397	1272463381000	27556	13621	0	0	16636
207310	2133	90232112000	27556	13621	1	0	6446
207311	2134	83635222000	27556	13621	2	0	6934
207315	2133	90231110000	27558	13622	1	0	6447
207316	1397	1272453380000	27559	13623	0	0	16637
207317	2134	83633216000	27559	13623	1	0	6936
207318	2382	99000000	27559	13623	2	0	1
207319	2133	90230108000	27559	13623	3	0	6448
207339	2133	90229106000	27565	13624	1	0	6449
207340	2134	83632213000	27565	13624	2	0	6937
207341	1397	1272433378000	27566	13625	0	0	16639
207342	2134	83631210000	27566	13625	1	0	6938
207343	2133	90228104000	27566	13625	2	0	6450
207348	1397	1272413376000	27568	13626	1	0	16641
207349	2133	90227102000	27568	13626	2	0	6451
207350	2133	90226100000	27568	13626	3	0	6452
207351	2134	83630207000	27568	13626	4	0	6939
207353	1397	1272403375000	27569	13627	0	0	16642
207354	2134	83628201000	27569	13627	1	0	6941
207355	2133	90225098000	27569	13627	2	0	6453
207362	1397	1272393374000	27572	13628	0	0	16643
207363	1397	1272383373000	27572	13628	1	0	16644
207365	2133	90224096000	27572	13628	3	0	6454
207366	2133	90223094000	27572	13628	4	0	6455
207367	2134	83626195000	27572	13628	5	0	6943
207371	1397	1272373372000	27575	13629	0	0	16645
207372	2134	83625192000	27575	13629	1	0	6944
207407	1397	1272363371000	27580	13630	0	0	\N
207408	1397	1272353370000	27580	13630	1	0	\N
207409	2134	83624189000	27580	13630	2	0	\N
207410	2133	90221090000	27580	13630	3	0	\N
207411	2133	90220088000	27580	13630	4	0	\N
207412	2134	83623186000	27580	13630	5	0	\N
207429	1588	16224799000000	27585	13633	0	0	\N
207430	1397	1272303365000	27585	13633	1	0	\N
207431	2133	90215078000	27585	13633	2	0	\N
207432	2134	83618171000	27585	13633	3	0	\N
207440	1397	1272283363000	27588	13635	0	0	\N
207441	1397	1272273362000	27588	13635	1	0	\N
207442	2133	90213074000	27588	13635	2	0	\N
207443	2133	90212072000	27588	13635	3	0	\N
207444	2134	83616165000	27588	13635	4	0	\N
207445	2134	83615162000	27588	13635	5	0	\N
207448	1397	1272263361000	27590	13636	0	0	\N
207449	2133	90213074000	27590	13636	1	0	\N
207450	2134	83614159000	27590	13636	2	0	\N
207451	2133	90212072000	27590	13636	3	0	\N
207452	2133	90211070000	27590	13636	4	0	\N
207453	1397	1272253360000	27591	13637	0	0	\N
207454	2133	90213074000	27591	13637	1	0	\N
207455	2134	83613156000	27591	13637	2	0	\N
207456	2133	90212072000	27591	13637	3	0	\N
207457	2133	90211070000	27591	13637	4	0	\N
207458	2133	90210068000	27591	13637	5	0	\N
207468	1397	1272243359000	27594	13638	0	0	\N
207469	2134	83612153000	27594	13638	1	0	\N
207470	2133	90209066000	27594	13638	2	0	\N
207471	1571	12765205894466	27595	13639	0	0	\N
207472	1571	12038110913010	27595	13639	1	0	\N
207473	1571	10735170855898	27595	13639	2	0	\N
207474	1571	9856047983650	27595	13639	3	0	\N
207475	1571	7406311798770	27595	13639	4	0	\N
207476	1571	7406301798770	27595	13639	5	0	\N
207477	1397	1272233358000	27595	13639	6	0	\N
207478	2133	90208064000	27595	13639	7	0	\N
207479	2134	83611150000	27595	13639	8	0	\N
207489	1397	1272223357000	27597	13640	0	0	\N
207490	1397	1272213356000	27597	13640	1	0	\N
207491	2068	89000000	27597	13640	2	0	\N
207492	2133	90207062000	27597	13640	3	0	\N
207493	2134	83610147000	27597	13640	4	0	\N
207494	2134	83609144000	27597	13640	5	0	\N
207495	2133	90206060000	27597	13640	6	0	\N
207509	1397	1272203355000	27600	13641	0	0	\N
207510	1397	1272193354000	27600	13641	1	0	\N
207511	2133	90205058000	27600	13641	2	0	\N
207512	2133	90204056000	27600	13641	3	0	\N
207513	2134	83608141000	27600	13641	4	0	\N
207514	2134	83607138000	27600	13641	5	0	\N
207515	1397	1272203355000	27602	13641	0	0	\N
207516	1397	1272193354000	27602	13641	1	0	\N
207517	2133	90205058000	27602	13641	2	0	\N
207518	2133	90204056000	27602	13641	3	0	\N
207519	2134	83608141000	27602	13641	4	0	\N
207520	2134	83607138000	27602	13641	5	0	\N
207533	1397	1272173352000	27606	13643	0	0	\N
207534	2134	83605132000	27606	13643	1	0	\N
207535	2133	90202052000	27606	13643	2	0	\N
207403	2134	83624189000	27579	13630	2	0	6945
207404	2133	90221090000	27579	13630	3	0	6457
207405	2133	90220088000	27579	13630	4	0	6458
207406	2134	83623186000	27579	13630	5	0	6946
207413	1397	1272343369000	27581	13631	0	0	16648
207415	2134	83622183000	27581	13631	2	0	6947
207416	2134	83621180000	27581	13631	3	0	6948
207417	2133	90219086000	27581	13631	4	0	6459
207418	2133	90218084000	27581	13631	5	0	6460
207419	1397	1272323367000	27583	13632	0	0	16650
207421	2133	90217082000	27583	13632	2	0	6461
207422	2134	83620177000	27583	13632	3	0	6949
207423	2133	90216080000	27583	13632	4	0	6462
207424	2134	83619174000	27583	13632	5	0	6950
207426	1397	1272303365000	27584	13633	1	0	16652
207427	2133	90215078000	27584	13633	2	0	6463
207428	2134	83618171000	27584	13633	3	0	6951
207433	1397	1272293364000	27586	13634	0	0	16653
207434	2133	90214076000	27586	13634	1	0	6464
207436	1397	1272283363000	27587	13635	0	0	16654
207437	1397	1272273362000	27587	13635	1	0	16655
207438	2134	83616165000	27587	13635	2	0	6953
207439	2134	83615162000	27587	13635	3	0	6954
207446	1397	1272263361000	27589	13636	0	0	16656
207459	1397	1272253360000	27592	13637	0	0	16657
207460	2133	90213074000	27592	13637	1	0	6465
207461	2134	83613156000	27592	13637	2	0	6956
207462	2133	90212072000	27592	13637	3	0	6466
207464	2133	90210068000	27592	13637	5	0	6468
207465	1397	1272243359000	27593	13638	0	0	16658
207466	2134	83612153000	27593	13638	1	0	6957
207467	2133	90209066000	27593	13638	2	0	6469
207480	1571	12765205894466	27596	13639	0	0	48
207482	1571	10735170855898	27596	13639	2	0	50
207483	1571	9856047983650	27596	13639	3	0	51
207484	1571	7406311798770	27596	13639	4	0	52
207485	1571	7406301798770	27596	13639	5	0	53
207486	1397	1272233358000	27596	13639	6	0	16659
207488	2134	83611150000	27596	13639	8	0	6958
207496	1397	1272223357000	27598	13640	0	0	16660
207497	1397	1272213356000	27598	13640	1	0	16661
207498	2068	89000000	27598	13640	2	0	2
207500	2134	83610147000	27598	13640	4	0	6959
207501	2134	83609144000	27598	13640	5	0	6960
207502	2133	90206060000	27598	13640	6	0	6472
207503	1397	1272203355000	27599	13641	0	0	16662
207504	1397	1272193354000	27599	13641	1	0	16663
207506	2133	90204056000	27599	13641	3	0	6474
207507	2134	83608141000	27599	13641	4	0	6961
207508	2134	83607138000	27599	13641	5	0	6962
207521	1397	1272183353000	27603	13642	0	0	16664
207522	1571	7370466673081	27603	13642	1	0	54
207524	1571	6609191033618	27603	13642	3	0	56
207525	1571	6279513706525	27603	13642	4	0	57
207526	1571	5360856387195	27603	13642	5	0	58
207527	1571	5360846387195	27603	13642	6	0	59
207529	2133	90203054000	27603	13642	8	0	6475
207530	1397	1272173352000	27605	13643	0	0	16665
207531	2134	83605132000	27605	13643	1	0	6964
207532	2133	90202052000	27605	13643	2	0	6476
207536	1397	1272163351000	27608	13645	0	0	16666
207551	1571	12045193894466	27610	13574	0	0	\N
207552	1571	11318098913010	27610	13574	1	0	\N
207553	1444	11767905329999	27610	13574	2	0	\N
207554	1588	16224799000000	27610	13574	3	0	\N
207555	1397	1273193454000	27610	13574	4	0	\N
207556	1397	1273183453000	27610	13574	5	0	\N
207557	1397	1273173452000	27610	13574	6	0	\N
207558	1397	1273163451000	27610	13574	7	0	\N
207559	1397	1273153450000	27610	13574	8	0	\N
207560	1397	1273143449000	27610	13574	9	0	\N
207561	1397	1273133448000	27610	13574	10	0	\N
207562	1397	1273123447000	27610	13574	11	0	\N
207563	1571	10015158855898	27610	13574	12	0	\N
207564	1571	9136035983650	27610	13574	13	0	\N
207565	1571	6686299798770	27610	13574	14	0	\N
207566	1571	6686289798770	27610	13574	15	0	\N
207567	1571	6650454673081	27610	13574	16	0	\N
207568	1571	6377787805035	27610	13574	17	0	\N
207569	1571	5889179033618	27610	13574	18	0	\N
207570	1571	5559501706525	27610	13574	19	0	\N
207571	1571	4640844387195	27610	13574	20	0	\N
207572	1571	4640834387195	27610	13574	21	0	\N
207573	1397	1273113446000	27610	13574	22	0	\N
207574	1397	1273103445000	27610	13574	23	0	\N
207575	1397	1273093444000	27610	13574	24	0	\N
207576	1397	1273083443000	27610	13574	25	0	\N
207577	1397	1273073442000	27610	13574	26	0	\N
207578	1397	1273063441000	27610	13574	27	0	\N
207579	1397	1273053440000	27610	13574	28	0	\N
207580	1397	1273043439000	27610	13574	29	0	\N
207581	1397	1273033438000	27610	13574	30	0	\N
207582	1397	1273023437000	27610	13574	31	0	\N
207583	1397	1273013436000	27610	13574	32	0	\N
207584	1397	1273003435000	27610	13574	33	0	\N
207585	1397	1272993434000	27610	13574	34	0	\N
207586	1397	1272983433000	27610	13574	35	0	\N
207587	1397	1272973432000	27610	13574	36	0	\N
207588	1397	1272963431000	27610	13574	37	0	\N
207589	1397	1272953430000	27610	13574	38	0	\N
207590	1397	1272943429000	27610	13574	39	0	\N
207591	1397	1272933428000	27610	13574	40	0	\N
207592	1397	1272923427000	27610	13574	41	0	\N
207593	1397	1272913426000	27610	13574	42	0	\N
207594	1397	1272903425000	27610	13574	43	0	\N
207595	1397	1272893424000	27610	13574	44	0	\N
207596	1397	1272883423000	27610	13574	45	0	\N
207597	1397	1272873422000	27610	13574	46	0	\N
207598	1397	1272863421000	27610	13574	47	0	\N
207599	1397	1272853420000	27610	13574	48	0	\N
207600	1397	1272843419000	27610	13574	49	0	\N
207601	1397	1272833418000	27610	13574	50	0	\N
207602	1397	1272823417000	27610	13574	51	0	\N
207603	1397	1272813416000	27610	13574	52	0	\N
207604	1397	1272803415000	27610	13574	53	0	\N
207605	1397	1272793414000	27610	13574	54	0	\N
207606	1397	1272783413000	27610	13574	56	0	\N
207607	1397	1272773412000	27610	13574	57	0	\N
207608	1397	1272763411000	27610	13574	58	0	\N
207609	1397	1272753410000	27610	13574	59	0	\N
207610	1397	1272743409000	27610	13574	60	0	\N
207611	1397	1272733408000	27610	13574	61	0	\N
207612	1397	1272723407000	27610	13574	62	0	\N
207613	1397	1272713406000	27610	13574	63	0	\N
207614	1397	1272703405000	27610	13574	64	0	\N
207615	1397	1272693404000	27610	13574	65	0	\N
207616	1397	1272683403000	27610	13574	66	0	\N
207617	1397	1272673402000	27610	13574	67	0	\N
207618	1397	1272663401000	27610	13574	68	0	\N
207619	1397	1272653400000	27610	13574	69	0	\N
207620	1397	1272643399000	27610	13574	70	0	\N
207621	1397	1272633398000	27610	13574	71	0	\N
207622	1397	1272623397000	27610	13574	72	0	\N
207623	1397	1272613396000	27610	13574	73	0	\N
207624	1397	1272603395000	27610	13574	74	0	\N
207625	1397	1272593394000	27610	13574	75	0	\N
207626	1397	1272583393000	27610	13574	76	0	\N
207627	1397	1272573392000	27610	13574	77	0	\N
207628	1397	1272563391000	27610	13574	78	0	\N
207629	1397	1272553390000	27610	13574	79	0	\N
207630	1397	1272543389000	27610	13574	80	0	\N
207631	1397	1272533388000	27610	13574	81	0	\N
207632	1397	1272523387000	27610	13574	82	0	\N
207633	1397	1272513386000	27610	13574	83	0	\N
207634	1397	1272503385000	27610	13574	84	0	\N
207635	1397	1272493384000	27610	13574	85	0	\N
207636	1397	1272483383000	27610	13574	86	0	\N
207637	1397	1272473382000	27610	13574	87	0	\N
207638	1397	1272463381000	27610	13574	88	0	\N
207639	1397	1272453380000	27610	13574	89	0	\N
207640	1397	1272443379000	27610	13574	90	0	\N
207641	1397	1272433378000	27610	13574	91	0	\N
207642	1397	1272423377000	27610	13574	92	0	\N
207643	1397	1272413376000	27610	13574	93	0	\N
207644	1397	1272403375000	27610	13574	94	0	\N
207645	1397	1272393374000	27610	13574	95	0	\N
207646	1397	1272383373000	27610	13574	96	0	\N
207647	1397	1272373372000	27610	13574	97	0	\N
207648	1397	1272363371000	27610	13574	98	0	\N
207649	1397	1272353370000	27610	13574	99	0	\N
207650	1397	1272343369000	27610	13574	100	0	\N
207651	1397	1272333368000	27610	13574	101	0	\N
207652	1397	1272323367000	27610	13574	102	0	\N
207653	1397	1272313366000	27610	13574	103	0	\N
207654	1397	1272303365000	27610	13574	104	0	\N
207655	1397	1272293364000	27610	13574	105	0	\N
207656	1397	1272283363000	27610	13574	106	0	\N
207657	1397	1272273362000	27610	13574	107	0	\N
207658	1397	1272263361000	27610	13574	108	0	\N
207659	1397	1272253360000	27610	13574	109	0	\N
207660	1397	1272243359000	27610	13574	110	0	\N
207661	1397	1272233358000	27610	13574	111	0	\N
207662	1397	1272223357000	27610	13574	112	0	\N
207663	1397	1272213356000	27610	13574	113	0	\N
207664	1397	1272203355000	27610	13574	114	0	\N
207665	1397	1272193354000	27610	13574	115	0	\N
207666	1397	1272183353000	27610	13574	116	0	\N
207667	1397	1272173352000	27610	13574	117	0	\N
207668	1397	1272163351000	27610	13574	118	0	\N
207669	1397	1272153350000	27610	13574	119	0	\N
207670	1397	1272143349000	27610	13574	120	0	\N
207671	1397	1272133348000	27610	13574	121	0	\N
207672	1397	1272123347000	27610	13574	122	0	\N
207539	1397	1272133348000	27608	13645	3	0	16669
207540	2133	90201050000	27608	13645	4	0	6477
207541	2133	90200048000	27608	13645	5	0	6478
207542	2134	83604129000	27608	13645	6	0	6965
207543	2134	83603126000	27608	13645	7	0	6966
207545	2133	90198044000	27608	13645	9	0	6480
207546	2134	83602123000	27608	13645	10	0	6967
207547	2134	83601120000	27608	13645	11	0	6968
207548	1397	1272123347000	27609	13646	0	0	16670
207549	2133	90197042000	27609	13646	1	0	6481
207673	1693	15737584129403	27610	13574	123	0	\N
207674	2132	147270283000	27610	13574	124	0	\N
207675	2132	147269282000	27610	13574	125	0	\N
207676	1571	12045193894466	27611	13576	0	0	\N
207677	1571	11318098913010	27611	13576	1	0	\N
207678	1444	11767905329999	27611	13576	2	0	\N
207679	1588	16224799000000	27611	13576	3	0	\N
207680	1397	1273153450000	27611	13576	4	0	\N
207681	1397	1273143449000	27611	13576	5	0	\N
207682	1397	1273133448000	27611	13576	6	0	\N
207683	1397	1273123447000	27611	13576	7	0	\N
207684	1571	10015158855898	27611	13576	8	0	\N
207685	1571	9136035983650	27611	13576	9	0	\N
207686	1571	6686299798770	27611	13576	10	0	\N
207687	1571	6686289798770	27611	13576	11	0	\N
207688	1571	6650454673081	27611	13576	12	0	\N
207689	1571	6377787805035	27611	13576	13	0	\N
207690	1571	5889179033618	27611	13576	14	0	\N
207691	1571	5559501706525	27611	13576	15	0	\N
207692	1571	4640844387195	27611	13576	16	0	\N
207693	1571	4640834387195	27611	13576	17	0	\N
207694	1397	1273113446000	27611	13576	18	0	\N
207695	1397	1273103445000	27611	13576	20	0	\N
207696	1397	1273093444000	27611	13576	21	0	\N
207697	1397	1273083443000	27611	13576	22	0	\N
207698	1397	1273073442000	27611	13576	23	0	\N
207699	1397	1273063441000	27611	13576	24	0	\N
207700	1397	1273053440000	27611	13576	25	0	\N
207701	1397	1273043439000	27611	13576	26	0	\N
207702	1397	1273033438000	27611	13576	27	0	\N
207703	1397	1273023437000	27611	13576	28	0	\N
207704	1397	1273013436000	27611	13576	29	0	\N
207705	1397	1273003435000	27611	13576	30	0	\N
207706	1397	1272993434000	27611	13576	31	0	\N
207707	1397	1272983433000	27611	13576	32	0	\N
207708	1397	1272973432000	27611	13576	33	0	\N
207709	1397	1272963431000	27611	13576	34	0	\N
207710	1397	1272953430000	27611	13576	35	0	\N
207711	1397	1272943429000	27611	13576	36	0	\N
207712	1397	1272933428000	27611	13576	37	0	\N
207713	1397	1272923427000	27611	13576	38	0	\N
207714	1397	1272913426000	27611	13576	39	0	\N
207715	1397	1272903425000	27611	13576	40	0	\N
207716	1397	1272893424000	27611	13576	41	0	\N
207717	1397	1272883423000	27611	13576	42	0	\N
207718	1397	1272873422000	27611	13576	43	0	\N
207719	1397	1272863421000	27611	13576	44	0	\N
207720	1397	1272853420000	27611	13576	45	0	\N
207721	1397	1272843419000	27611	13576	46	0	\N
207722	1397	1272833418000	27611	13576	47	0	\N
207723	1397	1272823417000	27611	13576	48	0	\N
207724	1397	1272813416000	27611	13576	49	0	\N
207725	1397	1272803415000	27611	13576	50	0	\N
207726	1397	1272793414000	27611	13576	51	0	\N
207727	1397	1272783413000	27611	13576	52	0	\N
207728	1397	1272773412000	27611	13576	53	0	\N
207729	1397	1272763411000	27611	13576	54	0	\N
207730	1397	1272753410000	27611	13576	55	0	\N
207731	1397	1272743409000	27611	13576	56	0	\N
207732	1397	1272733408000	27611	13576	57	0	\N
207733	1397	1272723407000	27611	13576	58	0	\N
207734	1397	1272713406000	27611	13576	59	0	\N
207735	1397	1272703405000	27611	13576	60	0	\N
207736	1397	1272693404000	27611	13576	61	0	\N
207737	1397	1272683403000	27611	13576	62	0	\N
207738	1397	1272673402000	27611	13576	63	0	\N
207739	1397	1272663401000	27611	13576	64	0	\N
207740	1397	1272653400000	27611	13576	65	0	\N
207741	1397	1272643399000	27611	13576	66	0	\N
207742	1397	1272633398000	27611	13576	67	0	\N
207743	1397	1272623397000	27611	13576	68	0	\N
207744	1397	1272613396000	27611	13576	69	0	\N
207745	1397	1272603395000	27611	13576	70	0	\N
207746	1397	1272593394000	27611	13576	71	0	\N
207747	1397	1272583393000	27611	13576	72	0	\N
207748	1397	1272573392000	27611	13576	73	0	\N
207749	1397	1272563391000	27611	13576	74	0	\N
207750	1397	1272553390000	27611	13576	75	0	\N
207751	1397	1272543389000	27611	13576	76	0	\N
207752	1397	1272533388000	27611	13576	77	0	\N
207753	1397	1272523387000	27611	13576	78	0	\N
207754	1397	1272513386000	27611	13576	79	0	\N
207755	1397	1272113346000	27612	13647	0	0	\N
207756	2133	90196040000	27612	13647	1	0	\N
207757	2134	83599114000	27612	13647	2	0	\N
207761	1397	1272113346000	27614	13647	0	0	\N
207762	2133	90196040000	27614	13647	1	0	\N
207763	2134	83599114000	27614	13647	2	0	\N
207768	1397	1272103345000	27616	13648	0	0	\N
207769	1397	1272093344000	27616	13648	1	0	\N
207770	1397	1272083343000	27616	13648	2	0	\N
207771	1397	1272073342000	27616	13648	3	0	\N
207772	2134	83598111000	27616	13648	4	0	\N
207773	2133	90195038000	27616	13648	5	0	\N
207774	2133	90194036000	27616	13648	6	0	\N
207775	2133	90193034000	27616	13648	7	0	\N
207776	2133	90192032000	27616	13648	8	0	\N
207777	2134	83597108000	27616	13648	9	0	\N
207778	2134	83596105000	27616	13648	10	0	\N
207779	2134	83595102000	27616	13648	11	0	\N
207800	1397	1272023337000	27619	13651	0	0	\N
207801	2134	83590087000	27619	13651	1	0	\N
207802	2133	90187022000	27619	13651	2	0	\N
207803	1397	1272023337000	27620	13651	0	0	\N
207804	2134	83590087000	27620	13651	1	0	\N
207805	2133	90187022000	27620	13651	2	0	\N
207806	1397	1272023337000	27621	13651	0	0	\N
207760	2134	83599114000	27613	13647	2	0	6970
207764	1397	1272103345000	27615	13648	0	0	16672
207765	1397	1272093344000	27615	13648	1	0	16673
207766	1397	1272083343000	27615	13648	2	0	16674
207767	1397	1272073342000	27615	13648	3	0	16675
207781	1397	1272053340000	27617	13649	1	0	16677
207782	1397	1272043339000	27617	13649	2	0	16678
207783	2134	83598111000	27617	13649	3	0	6971
207784	2133	90195038000	27617	13649	4	0	6483
207785	2133	90194036000	27617	13649	5	0	6484
207787	2133	90192032000	27617	13649	7	0	6486
207788	2133	90191030000	27617	13649	8	0	6487
207789	2134	83597108000	27617	13649	9	0	6972
207790	2134	83596105000	27617	13649	10	0	6973
207792	2133	90189026000	27617	13649	12	0	6489
207793	2134	83595102000	27617	13649	13	0	6974
207794	2134	83594099000	27617	13649	14	0	6975
207795	2134	83593096000	27617	13649	15	0	6976
207796	2134	83592093000	27617	13649	16	0	6977
207798	2134	83591090000	27618	13650	1	0	6978
207799	2133	90188024000	27618	13650	2	0	6490
207807	1397	1272023337000	27622	13651	0	0	16680
207808	2134	83590087000	27622	13651	1	0	6979
207813	1397	1272003335000	27624	13653	0	0	\N
207814	1397	1271993334000	27624	13653	1	0	\N
207815	2133	90185018000	27624	13653	2	0	\N
207816	2133	90184016000	27624	13653	3	0	\N
207817	2134	83588081000	27624	13653	4	0	\N
207818	2134	83587078000	27624	13653	5	0	\N
207825	1397	1272003335000	27626	13653	0	0	\N
207826	1397	1271993334000	27626	13653	1	0	\N
207827	2133	90185018000	27626	13653	2	0	\N
207828	2133	90184016000	27626	13653	3	0	\N
207829	2134	83588081000	27626	13653	4	0	\N
207830	2134	83587078000	27626	13653	5	0	\N
207835	1397	1271983333000	27628	13654	0	0	\N
207836	2134	83586075000	27628	13654	1	0	\N
207837	321	66009959000000	27628	13654	2	0	\N
207838	2133	90183014000	27628	13654	3	0	\N
207848	1397	1271943329000	27631	13657	0	0	\N
207849	2134	83582063000	27631	13657	1	0	\N
207850	2133	90179006000	27631	13657	2	0	\N
207854	1397	1271933328000	27633	13658	0	0	\N
207855	2134	83581060000	27633	13658	1	0	\N
207856	2133	90178004000	27633	13658	2	0	\N
207860	1397	1271933328000	27635	13658	0	0	\N
207861	2134	83581060000	27635	13658	1	0	\N
207862	2133	90178004000	27635	13658	2	0	\N
207863	1397	1271923327000	27640	13660	0	0	\N
207864	1397	1271913326000	27640	13660	1	0	\N
207865	1397	1271903325000	27640	13660	2	0	\N
207866	1397	1271893324000	27640	13660	3	0	\N
207867	2133	90177002000	27640	13660	4	0	\N
207868	2134	83580057000	27640	13660	5	0	\N
207869	2134	83579054000	27640	13660	6	0	\N
207870	2134	83578051000	27640	13660	7	0	\N
207871	2134	83577048000	27640	13660	8	0	\N
207872	2133	90176000000	27640	13660	9	0	\N
207873	2133	90174998000	27640	13660	10	0	\N
207874	2133	90173996000	27640	13660	11	0	\N
207887	1397	1271923327000	27642	13660	0	0	\N
207888	1397	1271913326000	27642	13660	1	0	\N
207889	1397	1271903325000	27642	13660	2	0	\N
207890	1397	1271893324000	27642	13660	3	0	\N
207891	2133	90177002000	27642	13660	4	0	\N
207892	2134	83580057000	27642	13660	5	0	\N
207893	2134	83579054000	27642	13660	6	0	\N
207894	2134	83578051000	27642	13660	7	0	\N
207895	2134	83577048000	27642	13660	8	0	\N
207896	2133	90176000000	27642	13660	9	0	\N
207897	2133	90174998000	27642	13660	10	0	\N
207898	2133	90173996000	27642	13660	11	0	\N
207899	1397	1271923327000	27643	13660	0	0	\N
207900	1397	1271913326000	27643	13660	1	0	\N
207901	1397	1271903325000	27643	13660	2	0	\N
207902	1397	1271893324000	27643	13660	3	0	\N
207903	2133	90177002000	27643	13660	4	0	\N
207904	2134	83580057000	27643	13660	5	0	\N
207905	2134	83579054000	27643	13660	6	0	\N
207906	2134	83578051000	27643	13660	7	0	\N
207907	2134	83577048000	27643	13660	8	0	\N
207908	2133	90176000000	27643	13660	9	0	\N
207909	2133	90174998000	27643	13660	10	0	\N
207910	2133	90173996000	27643	13660	11	0	\N
207911	1397	1271923327000	27644	13660	0	0	\N
207912	1397	1271913326000	27644	13660	1	0	\N
207913	1397	1271903325000	27644	13660	2	0	\N
207914	1397	1271893324000	27644	13660	3	0	\N
207915	2133	90177002000	27644	13660	4	0	\N
207916	2134	83580057000	27644	13660	5	0	\N
207917	2134	83579054000	27644	13660	6	0	\N
207918	2134	83578051000	27644	13660	7	0	\N
207919	2134	83577048000	27644	13660	8	0	\N
207920	2133	90176000000	27644	13660	9	0	\N
207921	2133	90174998000	27644	13660	10	0	\N
207922	2133	90173996000	27644	13660	11	0	\N
207927	1397	1271883323000	27646	13661	0	0	\N
207928	553	66000990000000	27646	13661	1	0	\N
207929	2134	83576045000	27646	13661	2	0	\N
207930	2133	90172994000	27646	13661	3	0	\N
207811	2133	90186020000	27623	13652	1	0	6492
207812	2134	83589084000	27623	13652	2	0	6980
207819	1397	1272003335000	27625	13653	0	0	16682
207820	1397	1271993334000	27625	13653	1	0	16683
207821	2133	90185018000	27625	13653	2	0	6493
207823	2134	83588081000	27625	13653	4	0	6981
207824	2134	83587078000	27625	13653	5	0	6982
207831	1397	1271983333000	27627	13654	0	0	16684
207832	2134	83586075000	27627	13654	1	0	6983
207833	321	66009959000000	27627	13654	2	0	2
207839	1397	1271973332000	27629	13655	0	0	16685
207840	1397	1271963331000	27629	13655	1	0	16686
207841	2134	83585072000	27629	13655	2	0	6984
207842	2134	83584069000	27629	13655	3	0	6985
207844	2133	90181010000	27629	13655	5	0	6497
207845	1397	1271953330000	27630	13656	0	0	16687
207846	2133	90180008000	27630	13656	1	0	6498
207847	2134	83583066000	27630	13656	2	0	6986
207851	1397	1271943329000	27632	13657	0	0	16688
207853	2133	90179006000	27632	13657	2	0	6499
207857	1397	1271933328000	27634	13658	0	0	16689
207858	2134	83581060000	27634	13658	1	0	6988
207859	2133	90178004000	27634	13658	2	0	6500
207875	1397	1271923327000	27641	13660	0	0	16690
207877	1397	1271903325000	27641	13660	2	0	16692
207878	1397	1271893324000	27641	13660	3	0	16693
207879	2133	90177002000	27641	13660	4	0	6501
207880	2134	83580057000	27641	13660	5	0	6989
207882	2134	83578051000	27641	13660	7	0	6991
207883	2134	83577048000	27641	13660	8	0	6992
207884	2133	90176000000	27641	13660	9	0	6502
207885	2133	90174998000	27641	13660	10	0	6503
207886	2133	90173996000	27641	13660	11	0	6504
207924	553	66000990000000	27645	13661	1	0	1
207925	2134	83576045000	27645	13661	2	0	6993
207926	2133	90172994000	27645	13661	3	0	6505
207931	1397	1271873322000	27647	13662	0	0	16695
207932	1397	1271863321000	27647	13662	1	0	16696
207934	2133	90170990000	27647	13662	3	0	6507
207935	2134	83575042000	27647	13662	4	0	6994
207936	2134	83574039000	27647	13662	5	0	6995
207937	1397	1271853320000	27648	13663	0	0	16697
207939	2133	90169988000	27648	13663	2	0	6508
207940	2133	90168986000	27648	13663	3	0	6509
207941	2134	83573036000	27648	13663	4	0	6996
207942	2134	83572033000	27648	13663	5	0	6997
207943	497	66717010000000	27650	13664	0	0	6
207953	497	66717010000000	27651	13633	0	0	\N
207954	657	66000990000000	27651	13633	1	0	\N
207955	1571	12765205894466	27651	13633	2	0	\N
207956	1571	12038110913010	27651	13633	3	0	\N
207957	1588	16224799000000	27651	13633	4	0	\N
207958	1397	1272303365000	27651	13633	5	0	\N
207959	1397	1272293364000	27651	13633	6	0	\N
207960	1397	1272283363000	27651	13633	7	0	\N
207961	1397	1272273362000	27651	13633	8	0	\N
207962	1397	1272263361000	27651	13633	9	0	\N
207963	1397	1272253360000	27651	13633	10	0	\N
207964	238	66000703200746	27651	13633	11	0	\N
207965	1397	1272243359000	27651	13633	12	0	\N
207966	1571	10735170855898	27651	13633	13	0	\N
207967	1571	9856047983650	27651	13633	14	0	\N
207968	1571	7406311798770	27651	13633	15	0	\N
207969	1571	7406301798770	27651	13633	16	0	\N
207970	1571	7370466673081	27651	13633	17	0	\N
207971	1571	7097799805035	27651	13633	18	0	\N
207972	1571	6609191033618	27651	13633	19	0	\N
207973	1571	6279513706525	27651	13633	20	0	\N
207974	1571	5360856387195	27651	13633	21	0	\N
207975	1571	5360846387195	27651	13633	22	0	\N
207976	1397	1272233358000	27651	13633	23	0	\N
207977	1397	1272223357000	27651	13633	24	0	\N
207978	1397	1272213356000	27651	13633	25	0	\N
207979	1397	1272203355000	27651	13633	26	0	\N
207980	1397	1272193354000	27651	13633	27	0	\N
207981	1397	1272183353000	27651	13633	28	0	\N
207982	1397	1272173352000	27651	13633	29	0	\N
207983	1397	1272163351000	27651	13633	30	0	\N
207984	1397	1272153350000	27651	13633	31	0	\N
207985	1397	1272143349000	27651	13633	32	0	\N
207986	1397	1272133348000	27651	13633	33	0	\N
207987	1397	1272123347000	27651	13633	34	0	\N
207988	1397	1272113346000	27651	13633	35	0	\N
207989	1397	1272103345000	27651	13633	36	0	\N
207990	1397	1272093344000	27651	13633	37	0	\N
207991	1397	1272083343000	27651	13633	38	0	\N
207992	1397	1272073342000	27651	13633	39	0	\N
207993	1397	1272063341000	27651	13633	40	0	\N
207994	1397	1272053340000	27651	13633	41	0	\N
207995	1397	1272043339000	27651	13633	42	0	\N
207996	1397	1272033338000	27651	13633	43	0	\N
207997	1397	1272023337000	27651	13633	44	0	\N
207998	1397	1272013336000	27651	13633	45	0	\N
207999	1397	1272003335000	27651	13633	46	0	\N
208000	1397	1271993334000	27651	13633	47	0	\N
208001	1397	1271983333000	27651	13633	48	0	\N
208002	1397	1271973332000	27651	13633	49	0	\N
208003	1397	1271963331000	27651	13633	50	0	\N
208004	1397	1271953330000	27651	13633	51	0	\N
208005	1397	1271943329000	27651	13633	53	0	\N
208006	1397	1271933328000	27651	13633	54	0	\N
208007	1397	1271923327000	27651	13633	55	0	\N
208008	590	66000990000000	27651	13633	56	0	\N
208009	1397	1271913326000	27651	13633	57	0	\N
208010	1397	1271903325000	27651	13633	58	0	\N
208011	1397	1271893324000	27651	13633	59	0	\N
208012	1397	1271883323000	27651	13633	60	0	\N
208013	1397	1271873322000	27651	13633	61	0	\N
208014	1397	1271863321000	27651	13633	62	0	\N
208015	1397	1271853320000	27651	13633	63	0	\N
208016	1397	1271843319000	27651	13633	64	0	\N
208017	1397	1271833318000	27651	13633	65	0	\N
208018	1397	1271823317000	27651	13633	66	0	\N
208019	553	66000990000000	27651	13633	67	0	\N
208020	321	66009959000000	27651	13633	68	0	\N
208021	2133	90215078000	27651	13633	69	0	\N
208022	2133	90214076000	27651	13633	70	0	\N
208023	2133	90213074000	27651	13633	71	0	\N
208024	2134	83618171000	27651	13633	72	0	\N
208025	2134	83617168000	27651	13633	73	0	\N
208026	2133	90212072000	27651	13633	74	0	\N
208027	2133	90211070000	27651	13633	75	0	\N
208028	2133	90210068000	27651	13633	76	0	\N
208029	2133	90209066000	27651	13633	77	0	\N
208030	2133	90208064000	27651	13633	78	0	\N
208031	2133	90207062000	27651	13633	79	0	\N
208032	2133	90206060000	27651	13633	80	0	\N
208033	2133	90205058000	27651	13633	81	0	\N
208034	2133	90204056000	27651	13633	82	0	\N
208035	2133	90203054000	27651	13633	83	0	\N
208036	2133	90202052000	27651	13633	84	0	\N
208037	2133	90201050000	27651	13633	85	0	\N
208038	2133	90200048000	27651	13633	86	0	\N
208039	2133	90199046000	27651	13633	87	0	\N
208040	2133	90198044000	27651	13633	88	0	\N
208041	2133	90197042000	27651	13633	89	0	\N
208042	2133	90196040000	27651	13633	90	0	\N
208043	2133	90195038000	27651	13633	91	0	\N
208044	2133	90194036000	27651	13633	92	0	\N
208045	2133	90193034000	27651	13633	93	0	\N
208046	2133	90192032000	27651	13633	94	0	\N
208047	2133	90191030000	27651	13633	95	0	\N
208048	2133	90190028000	27651	13633	96	0	\N
208049	2133	90189026000	27651	13633	97	0	\N
208050	2133	90188024000	27651	13633	98	0	\N
208051	2133	90187022000	27651	13633	99	0	\N
208052	2133	90186020000	27651	13633	100	0	\N
208053	2133	90185018000	27651	13633	101	0	\N
208054	2133	90184016000	27651	13633	102	0	\N
208055	2133	90183014000	27651	13633	103	0	\N
208056	2133	90182012000	27651	13633	104	0	\N
208057	2133	90181010000	27651	13633	105	0	\N
208058	2133	90180008000	27651	13633	106	0	\N
208059	2133	90179006000	27651	13633	107	0	\N
208060	2133	90178004000	27651	13633	108	0	\N
208061	2133	90177002000	27651	13633	109	0	\N
208062	2133	90176000000	27651	13633	110	0	\N
208063	2133	90174998000	27651	13633	111	0	\N
208064	2133	90173996000	27651	13633	112	0	\N
208065	2133	90172994000	27651	13633	113	0	\N
208066	2133	90171992000	27651	13633	114	0	\N
208067	2133	90170990000	27651	13633	115	0	\N
208068	2133	90169988000	27651	13633	116	0	\N
208069	2133	90168986000	27651	13633	117	0	\N
208070	2133	90167984000	27651	13633	118	0	\N
208071	2133	90166982000	27651	13633	119	0	\N
208072	2134	83616165000	27651	13633	120	0	\N
208073	2134	83615162000	27651	13633	121	0	\N
208074	2134	83614159000	27651	13633	122	0	\N
208075	2134	83613156000	27651	13633	123	0	\N
208076	2134	83612153000	27651	13633	124	0	\N
208077	2134	83611150000	27651	13633	125	0	\N
208078	497	66717010000000	27652	13664	0	0	\N
208079	657	66000990000000	27652	13664	1	0	\N
208080	1397	1271833318000	27652	13664	2	0	\N
207947	238	66000703200746	27650	13664	4	0	7
207948	590	66000990000000	27650	13664	5	0	1
207949	2133	90167984000	27650	13664	6	0	6510
207950	2133	90166982000	27650	13664	7	0	6511
207951	2134	83571030000	27650	13664	8	0	6998
208081	1397	1271823317000	27652	13664	3	0	\N
208082	238	66000703200746	27652	13664	4	0	\N
208083	590	66000990000000	27652	13664	5	0	\N
208084	2133	90167984000	27652	13664	6	0	\N
208085	2133	90166982000	27652	13664	7	0	\N
208086	2134	83571030000	27652	13664	8	0	\N
208087	2134	83570027000	27652	13664	9	0	\N
208091	1397	1271803315000	27654	13666	0	0	\N
208092	2133	90164978000	27654	13666	1	0	\N
208093	2134	83568021000	27654	13666	2	0	\N
208100	1397	1271793314000	27657	13667	0	0	\N
208101	2134	83567018000	27657	13667	1	0	\N
208102	2133	90163976000	27657	13667	2	0	\N
208106	1397	1271783313000	27659	13668	0	0	\N
208107	2133	90162974000	27659	13668	1	0	\N
208108	2134	83566015000	27659	13668	2	0	\N
208123	1397	1271753310000	27663	13671	0	0	\N
208124	1397	1271743309000	27663	13671	1	0	\N
208125	2305	198999000000	27663	13671	2	0	\N
208126	2133	90159968000	27663	13671	3	0	\N
208127	2133	90158966000	27663	13671	4	0	\N
208128	2131	189996000	27663	13671	5	0	\N
208129	2134	83563006000	27663	13671	6	0	\N
208130	2134	83562003000	27663	13671	7	0	\N
208137	1397	1271723307000	27666	13673	0	0	\N
208138	2134	83559997000	27666	13673	1	0	\N
208139	2133	90156962000	27666	13673	2	0	\N
208140	1397	1271723307000	27667	13673	0	0	\N
208141	2134	83559997000	27667	13673	1	0	\N
208142	2133	90156962000	27667	13673	2	0	\N
208146	1397	1271713306000	27669	13674	0	0	\N
208147	2134	83558994000	27669	13674	1	0	\N
208148	2133	90155960000	27669	13674	2	0	\N
208149	1397	1271713306000	27670	13674	0	0	\N
208150	2134	83558994000	27670	13674	1	0	\N
208151	2133	90155960000	27670	13674	2	0	\N
208152	1397	1271703305000	27671	13675	0	0	\N
208153	2134	83557991000	27671	13675	1	0	\N
208154	2133	90154958000	27671	13675	2	0	\N
208155	2134	83557991000	27672	13675	0	0	\N
208156	2133	90154958000	27672	13675	1	0	\N
208157	1397	1271703305000	27673	13675	0	0	\N
208158	2134	83557991000	27673	13675	1	0	\N
208159	2133	90154958000	27673	13675	2	0	\N
208160	1397	1271703305000	27674	13675	0	0	\N
208161	2134	83557991000	27674	13675	1	0	\N
208162	2133	90154958000	27674	13675	2	0	\N
208163	1397	1271703305000	27675	13675	0	0	\N
208164	2134	83557991000	27675	13675	1	0	\N
208165	2133	90154958000	27675	13675	2	0	\N
208166	1397	1271713306000	27676	13674	0	0	\N
208167	1397	1271703305000	27676	13674	1	0	\N
208168	2134	83558994000	27676	13674	2	0	\N
208169	2133	90155960000	27676	13674	3	0	\N
208176	1397	1271683303000	27679	13677	0	0	\N
208177	2133	90152954000	27679	13677	1	0	\N
208186	1397	1271813316000	27683	13634	0	0	\N
208187	1397	1271803315000	27683	13634	1	0	\N
208188	1397	1271793314000	27683	13634	2	0	\N
208189	1397	1271783313000	27683	13634	3	0	\N
208190	1397	1271773312000	27683	13634	4	0	\N
208191	1397	1271763311000	27683	13634	5	0	\N
208192	1397	1271753310000	27683	13634	6	0	\N
208193	1397	1271743309000	27683	13634	7	0	\N
208194	1397	1271733308000	27683	13634	8	0	\N
208195	1397	1271723307000	27683	13634	9	0	\N
208196	1397	1271713306000	27683	13634	10	0	\N
208197	1397	1271703305000	27683	13634	11	0	\N
208198	1397	1271693304000	27683	13634	12	0	\N
208199	1397	1271683303000	27683	13634	13	0	\N
208200	1397	1271673302000	27683	13634	14	0	\N
208201	1397	1271663301000	27683	13634	15	0	\N
208202	2133	90165980000	27683	13634	16	0	\N
208203	2133	90164978000	27683	13634	17	0	\N
208204	2305	198999000000	27683	13634	18	0	\N
208205	2131	189996000	27683	13634	19	0	\N
208206	2134	83610147000	27683	13634	20	0	\N
208207	2134	83609144000	27683	13634	21	0	\N
208208	2134	83608141000	27683	13634	22	0	\N
208209	2134	83607138000	27683	13634	23	0	\N
208210	2134	83606135000	27683	13634	24	0	\N
208211	2134	83605132000	27683	13634	25	0	\N
208212	2134	83604129000	27683	13634	26	0	\N
208213	2134	83603126000	27683	13634	27	0	\N
208214	2134	83602123000	27683	13634	28	0	\N
208215	2134	83601120000	27683	13634	29	0	\N
208216	2134	83600117000	27683	13634	30	0	\N
208090	2134	83569024000	27653	13665	2	0	7000
208094	1397	1271803315000	27655	13666	0	0	16702
208095	2133	90164978000	27655	13666	1	0	6513
208096	2134	83568021000	27655	13666	2	0	7001
208097	1397	1271793314000	27656	13667	0	0	16703
208099	2133	90163976000	27656	13667	2	0	6514
208103	1397	1271783313000	27658	13668	0	0	16704
208104	2133	90162974000	27658	13668	1	0	6515
208105	2134	83566015000	27658	13668	2	0	7003
208109	1397	1271773312000	27660	13669	0	0	16705
208111	2134	83565012000	27660	13669	2	0	7004
208112	1397	1271763311000	27661	13670	0	0	16706
208113	2133	90160970000	27661	13670	1	0	6517
208114	2134	83564009000	27661	13670	2	0	7005
208116	1397	1271743309000	27662	13671	1	0	16708
208117	2305	198999000000	27662	13671	2	0	1
208118	2133	90159968000	27662	13671	3	0	6518
208119	2133	90158966000	27662	13671	4	0	6519
208120	2131	189996000	27662	13671	5	0	9
208122	2134	83562003000	27662	13671	7	0	7007
208131	1397	1271733308000	27664	13672	0	0	16709
208132	2134	83561000000	27664	13672	1	0	7008
208133	2133	90157964000	27664	13672	2	0	6520
208134	1397	1271723307000	27665	13673	0	0	16710
208136	2133	90156962000	27665	13673	2	0	6521
208143	1397	1271713306000	27668	13674	0	0	16711
208144	2134	83558994000	27668	13674	1	0	7010
208145	2133	90155960000	27668	13674	2	0	6522
208171	2134	83557991000	27677	13675	1	0	7011
208172	2133	90154958000	27677	13675	2	0	6523
208173	1397	1271693304000	27678	13676	0	0	16713
208174	2133	90153956000	27678	13676	1	0	6524
208175	2134	83556988000	27678	13676	2	0	7012
208179	2133	90152954000	27680	13677	1	0	6525
208180	1397	1271673302000	27681	13678	0	0	16715
208181	2133	90151952000	27681	13678	1	0	6526
208182	2134	83555985000	27681	13678	2	0	7013
208183	1397	1271663301000	27682	13679	0	0	16716
208185	2134	83554982000	27682	13679	2	0	7014
208217	2134	83599114000	27683	13634	31	0	\N
208218	2134	83598111000	27683	13634	32	0	\N
208219	2134	83597108000	27683	13634	33	0	\N
208220	2134	83596105000	27683	13634	34	0	\N
208221	2133	90163976000	27683	13634	35	0	\N
208222	2133	90162974000	27683	13634	36	0	\N
208223	2133	90161972000	27683	13634	37	0	\N
208224	2133	90160970000	27683	13634	38	0	\N
208225	2133	90159968000	27683	13634	39	0	\N
208226	2133	90158966000	27683	13634	40	0	\N
208227	2133	90157964000	27683	13634	41	0	\N
208228	2133	90156962000	27683	13634	42	0	\N
208229	2134	83595102000	27683	13634	43	0	\N
208230	2134	83594099000	27683	13634	44	0	\N
208231	2134	83593096000	27683	13634	45	0	\N
208232	2134	83592093000	27683	13634	46	0	\N
208233	2134	83591090000	27683	13634	47	0	\N
208234	2134	83590087000	27683	13634	48	0	\N
208235	2134	83589084000	27683	13634	49	0	\N
208236	2134	83588081000	27683	13634	50	0	\N
208237	2134	83587078000	27683	13634	51	0	\N
208238	2134	83586075000	27683	13634	53	0	\N
208239	2134	83585072000	27683	13634	54	0	\N
208240	2134	83584069000	27683	13634	55	0	\N
208241	2134	83583066000	27683	13634	56	0	\N
208242	2134	83582063000	27683	13634	57	0	\N
208243	2134	83581060000	27683	13634	58	0	\N
208244	2134	83580057000	27683	13634	59	0	\N
208245	2134	83579054000	27683	13634	60	0	\N
208246	2134	83578051000	27683	13634	61	0	\N
208247	2134	83577048000	27683	13634	62	0	\N
208248	2134	83576045000	27683	13634	63	0	\N
208249	2134	83575042000	27683	13634	64	0	\N
208250	2134	83574039000	27683	13634	65	0	\N
208251	2134	83573036000	27683	13634	66	0	\N
208252	2134	83572033000	27683	13634	67	0	\N
208253	2134	83571030000	27683	13634	68	0	\N
208254	2134	83570027000	27683	13634	69	0	\N
208255	2134	83569024000	27683	13634	70	0	\N
208256	2134	83568021000	27683	13634	71	0	\N
208257	2134	83567018000	27683	13634	72	0	\N
208258	2134	83566015000	27683	13634	73	0	\N
208259	2134	83565012000	27683	13634	74	0	\N
208260	2134	83564009000	27683	13634	75	0	\N
208261	2134	83563006000	27683	13634	76	0	\N
208262	2134	83562003000	27683	13634	77	0	\N
208263	526	66000305000000	27685	13681	0	0	\N
208264	1397	1271653300000	27685	13681	1	0	\N
208265	1397	1271643299000	27685	13681	2	0	\N
208266	2133	90149948000	27685	13681	3	0	\N
208267	2133	90148946000	27685	13681	4	0	\N
208268	2134	83553979000	27685	13681	5	0	\N
208269	2134	83552976000	27685	13681	6	0	\N
208277	1397	1271633298000	27687	13682	0	0	\N
208278	1397	1271623297000	27687	13682	1	0	\N
208279	2134	83551973000	27687	13682	2	0	\N
208280	2133	90147944000	27687	13682	3	0	\N
208281	2133	90146942000	27687	13682	4	0	\N
208282	2134	83550970000	27687	13682	5	0	\N
208289	1397	1271613296000	27689	13683	0	0	\N
208290	2134	83549967000	27689	13683	1	0	\N
208291	2133	90145940000	27689	13683	2	0	\N
208292	1397	1271613296000	27690	13683	0	0	\N
208293	2134	83549967000	27690	13683	1	0	\N
208294	2133	90145940000	27690	13683	2	0	\N
208295	1397	1271613296000	27691	13683	0	0	\N
208296	2134	83549967000	27691	13683	1	0	\N
208297	2133	90145940000	27691	13683	2	0	\N
208304	1397	1271593294000	27694	13685	0	0	\N
208305	2133	90143936000	27694	13685	1	0	\N
208308	1397	1271583293000	27696	13686	0	0	\N
208309	2133	90142934000	27696	13686	1	0	\N
208312	526	66000305000000	27698	13513	0	0	\N
208313	1571	12045193894466	27698	13513	1	0	\N
208314	1571	11318098913010	27698	13513	2	0	\N
208315	1444	11767905329999	27698	13513	3	0	\N
208316	1588	16224799000000	27698	13513	4	0	\N
208317	1571	10015158855898	27698	13513	5	0	\N
208318	1571	9136035983650	27698	13513	6	0	\N
208319	1571	6686299798770	27698	13513	7	0	\N
208320	1571	6686289798770	27698	13513	8	0	\N
208321	1571	6650454673081	27698	13513	9	0	\N
208322	1571	6377787805035	27698	13513	10	0	\N
208323	1571	5889179033618	27698	13513	11	0	\N
208324	1571	5559501706525	27698	13513	12	0	\N
208325	1571	4640844387195	27698	13513	13	0	\N
208326	1571	4640834387195	27698	13513	14	0	\N
208327	2132	147270283000	27698	13513	15	0	\N
208328	2132	147269282000	27698	13513	16	0	\N
208329	2338	7000000	27698	13513	17	0	\N
208330	1693	15602438716916	27698	13513	18	0	\N
208331	2132	147268281000	27698	13513	19	0	\N
208332	686	69550057000000	27698	13513	20	0	\N
208333	2305	198999000000	27698	13513	21	0	\N
208334	1693	15534129805187	27698	13513	22	0	\N
208335	321	66009959000000	27698	13513	23	0	\N
208336	1693	15465528951831	27698	13513	24	0	\N
208337	1693	15396928098475	27698	13513	25	0	\N
208338	1693	15328327245119	27698	13513	26	0	\N
208339	1693	15259726391763	27698	13513	27	0	\N
208340	1693	15191125538407	27698	13513	28	0	\N
208341	1693	15122524685051	27698	13513	29	0	\N
208342	1693	15053923831695	27698	13513	30	0	\N
208343	1693	14985322978339	27698	13513	31	0	\N
208344	1693	14916722124983	27698	13513	32	0	\N
208345	1693	14848121271627	27698	13513	33	0	\N
208346	1693	14779520418271	27698	13513	34	0	\N
208347	1693	14777440634845	27698	13513	35	0	\N
208348	2131	189996000	27698	13513	36	0	\N
208349	1693	14708839781489	27698	13513	37	0	\N
208350	1693	14640238928133	27698	13513	38	0	\N
208351	1693	14571638074777	27698	13513	39	0	\N
208352	1693	14503037221421	27698	13513	40	0	\N
208272	1397	1271643299000	27686	13681	2	0	16718
208273	2133	90149948000	27686	13681	3	0	6528
208274	2133	90148946000	27686	13681	4	0	6529
208275	2134	83553979000	27686	13681	5	0	7015
208276	2134	83552976000	27686	13681	6	0	7016
208284	1397	1271623297000	27688	13682	1	0	16720
208285	2134	83551973000	27688	13682	2	0	7017
208286	2133	90147944000	27688	13682	3	0	6530
208287	2133	90146942000	27688	13682	4	0	6531
208288	2134	83550970000	27688	13682	5	0	7018
208299	2134	83549967000	27692	13683	1	0	7019
208300	2133	90145940000	27692	13683	2	0	6532
208301	1397	1271603295000	27693	13684	0	0	16722
208302	2133	90144938000	27693	13684	1	0	6533
208306	1397	1271593294000	27695	13685	0	0	16723
208307	2133	90143936000	27695	13685	1	0	6534
208310	1397	1271583293000	27697	13686	0	0	16724
208311	2133	90142934000	27697	13686	1	0	6535
208353	1693	14434725836115	27698	13513	41	0	\N
208354	1693	14366124982759	27698	13513	42	0	\N
208355	1693	14297524129403	27698	13513	43	0	\N
208356	1693	13804734922670	27698	13513	44	0	\N
208357	1693	13736134069314	27698	13513	45	0	\N
208358	1693	13667533215958	27698	13513	46	0	\N
208359	1693	13598932362602	27698	13513	47	0	\N
208360	1693	13280022164317	27698	13513	48	0	\N
208361	1693	13211712114121	27698	13513	49	0	\N
208362	1693	13023219838829	27698	13513	50	0	\N
208363	1693	12954618985473	27698	13513	51	0	\N
208364	1693	12949421026893	27698	13513	52	0	\N
208365	1693	12881111183691	27698	13513	53	0	\N
208366	1693	12812510330335	27698	13513	54	0	\N
208367	1693	11875689085263	27698	13513	55	0	\N
208368	1693	11807380007938	27698	13513	56	0	\N
208369	1693	11739071096209	27698	13513	57	0	\N
208370	1693	11670470242853	27698	13513	58	0	\N
208371	1693	11602160422602	27698	13513	59	0	\N
208372	1693	11533849037296	27698	13513	60	0	\N
208373	1693	9772469464164	27698	13513	61	0	\N
208374	2132	147267280000	27698	13513	62	0	\N
208375	1693	9703868610808	27698	13513	63	0	\N
208376	1693	9635267757452	27698	13513	64	0	\N
208377	1693	9566958845723	27698	13513	65	0	\N
208378	1693	9498357992367	27698	13513	66	0	\N
208379	1693	9496278208941	27698	13513	67	0	\N
208380	1693	9427677355585	27698	13513	68	0	\N
208381	1693	9359076502229	27698	13513	69	0	\N
208382	1693	9290475648873	27698	13513	70	0	\N
208383	1693	9221874795517	27698	13513	71	0	\N
208384	1515	1440048603400	27698	13513	72	0	\N
208385	1693	9153273942161	27698	13513	73	0	\N
208386	1693	9084673088805	27698	13513	74	0	\N
208387	1693	9016361341262	27698	13513	75	0	\N
208388	1693	8948052027959	27698	13513	76	0	\N
208389	1693	8879743023075	27698	13513	77	0	\N
208390	1693	8811434018191	27698	13513	78	0	\N
208391	1693	8742833164835	27698	13513	79	0	\N
208392	1693	8674232311479	27698	13513	80	0	\N
208393	1693	8605631458123	27698	13513	81	0	\N
208394	1693	8537322039261	27698	13513	82	0	\N
208395	1693	8468721185905	27698	13513	83	0	\N
208396	1693	8400120332549	27698	13513	84	0	\N
208397	1693	8331365317468	27698	13513	85	0	\N
208398	1693	8262764464112	27698	13513	86	0	\N
208399	1693	8229065939644	27698	13513	87	0	\N
208400	1693	8160465086288	27698	13513	88	0	\N
208401	1693	8092156174559	27698	13513	89	0	\N
208402	1693	8023555321203	27698	13513	90	0	\N
208403	1693	7955245902341	27698	13513	91	0	\N
208404	1693	7886645048985	27698	13513	92	0	\N
208405	1693	7818044195629	27698	13513	93	0	\N
208406	1693	7749443342273	27698	13513	94	0	\N
208407	1693	7680842488917	27698	13513	95	0	\N
208408	1693	7612533484033	27698	13513	96	0	\N
208409	1693	7544224479149	27698	13513	97	0	\N
208410	1693	7475623625793	27698	13513	98	0	\N
208411	1397	1271573292000	27699	13687	0	0	\N
208412	1397	1271563291000	27699	13687	1	0	\N
208413	1397	1271553290000	27699	13687	2	0	\N
208414	2133	90141932000	27699	13687	3	0	\N
208415	2133	90140930000	27699	13687	4	0	\N
208416	2133	90139928000	27699	13687	5	0	\N
208417	1397	1271573292000	27700	13687	0	0	\N
208418	1397	1271563291000	27700	13687	1	0	\N
208419	1397	1271553290000	27700	13687	2	0	\N
208420	2133	90141932000	27700	13687	3	0	\N
208421	2133	90140930000	27700	13687	4	0	\N
208422	2133	90139928000	27700	13687	5	0	\N
208429	1397	1271573292000	27702	13687	0	0	\N
208430	1397	1271563291000	27702	13687	1	0	\N
208431	1397	1271553290000	27702	13687	2	0	\N
208432	2133	90141932000	27702	13687	3	0	\N
208433	2133	90140930000	27702	13687	4	0	\N
208434	2133	90139928000	27702	13687	5	0	\N
208453	1397	1271503285000	27705	13689	0	0	\N
208454	1397	1271493284000	27705	13689	1	0	\N
208455	114	66001337649394	27705	13689	2	0	\N
208456	301	66002009153477	27705	13689	3	0	\N
208457	1397	1271483283000	27705	13689	4	0	\N
208458	283	66001018153477	27705	13689	5	0	\N
208459	10	32559970141866	27705	13689	6	0	\N
208460	2133	90134918000	27705	13689	7	0	\N
208461	2133	90133916000	27705	13689	8	0	\N
208462	2133	90132914000	27705	13689	9	0	\N
208463	1397	1271503285000	27706	13689	0	0	\N
208464	1397	1271493284000	27706	13689	1	0	\N
208465	114	66001337649394	27706	13689	2	0	\N
208466	301	66002009153477	27706	13689	3	0	\N
208467	1397	1271483283000	27706	13689	4	0	\N
208468	283	66001018153477	27706	13689	5	0	\N
208469	10	32559970141866	27706	13689	6	0	\N
208470	2133	90134918000	27706	13689	7	0	\N
208471	2133	90133916000	27706	13689	8	0	\N
208472	2133	90132914000	27706	13689	9	0	\N
208485	1397	1271423277000	27710	13692	0	0	\N
208486	2133	90126902000	27710	13692	1	0	\N
208487	1397	1271423277000	27711	13692	0	0	\N
208488	2133	90126902000	27711	13692	1	0	\N
208425	1397	1271553290000	27701	13687	2	0	16727
208426	2133	90141932000	27701	13687	3	0	6536
208427	2133	90140930000	27701	13687	4	0	6537
208428	2133	90139928000	27701	13687	5	0	6538
208435	1397	1271543289000	27703	13688	0	0	16728
208437	1397	1271523287000	27703	13688	2	0	16730
208438	1397	1271513286000	27703	13688	3	0	16731
208439	2133	90138926000	27703	13688	4	0	6539
208440	2133	90137924000	27703	13688	5	0	6540
208441	2133	90136922000	27703	13688	6	0	6541
208443	1397	1271503285000	27704	13689	0	0	16732
208444	1397	1271493284000	27704	13689	1	0	16733
208445	114	66001337649394	27704	13689	2	0	13
208446	301	66002009153477	27704	13689	3	0	4
208448	283	66001018153477	27704	13689	5	0	3
208449	10	32559970141866	27704	13689	6	0	3
208450	2133	90134918000	27704	13689	7	0	6543
208451	2133	90133916000	27704	13689	8	0	6544
208452	2133	90132914000	27704	13689	9	0	6545
208474	1397	1271463281000	27707	13690	1	0	16736
208475	2133	90131912000	27707	13690	2	0	6546
208476	2133	90130910000	27707	13690	3	0	6547
208477	1397	1271453280000	27708	13691	0	0	16737
208478	1397	1271443279000	27708	13691	1	0	16738
208480	2133	90129908000	27708	13691	3	0	6548
208481	2133	90128906000	27708	13691	4	0	6549
208482	2133	90127904000	27708	13691	5	0	6550
208483	1397	1271423277000	27709	13692	0	0	16740
208493	1397	1271413276000	27713	13693	0	0	\N
208494	1397	1271403275000	27713	13693	1	0	\N
208495	2133	90125900000	27713	13693	2	0	\N
208496	2133	90124898000	27713	13693	3	0	\N
208497	1397	1271393274000	27714	13694	0	0	\N
208498	2133	90123896000	27714	13694	1	0	\N
208501	1397	1271393274000	27716	13694	0	0	\N
208502	2133	90123896000	27716	13694	1	0	\N
208505	1397	1271383273000	27718	13695	0	0	\N
208506	2133	90122894000	27718	13695	1	0	\N
208507	1397	1271383273000	27719	13695	0	0	\N
208508	2133	90122894000	27719	13695	1	0	\N
208509	497	66717010000000	27720	13610	0	0	\N
208510	657	66000990000000	27720	13610	1	0	\N
208511	526	66000305000000	27720	13610	2	0	\N
208512	114	66001337649394	27720	13610	3	0	\N
208513	1571	12765205894466	27720	13610	4	0	\N
208514	1571	12038110913010	27720	13610	5	0	\N
208515	301	66002009153477	27720	13610	6	0	\N
208516	1588	16224799000000	27720	13610	7	0	\N
208517	1397	1272623397000	27720	13610	8	0	\N
208518	1397	1272613396000	27720	13610	9	0	\N
208519	283	66001018153477	27720	13610	10	0	\N
208520	238	66000703200746	27720	13610	11	0	\N
208521	1693	1945763623117	27720	13610	12	0	\N
208522	1693	45753623117	27720	13610	13	0	\N
208523	10	32559970141866	27720	13610	14	0	\N
208524	1571	10735170855898	27720	13610	15	0	\N
208525	1571	9856047983650	27720	13610	16	0	\N
208526	1571	7406311798770	27720	13610	17	0	\N
208527	1571	7406301798770	27720	13610	18	0	\N
208528	1571	7370466673081	27720	13610	19	0	\N
208529	1571	7097799805035	27720	13610	20	0	\N
208530	1571	6609191033618	27720	13610	21	0	\N
208531	1571	6279513706525	27720	13610	22	0	\N
208532	1571	5360856387195	27720	13610	23	0	\N
208533	1571	5360846387195	27720	13610	24	0	\N
208534	1397	1272603395000	27720	13610	25	0	\N
208535	1397	1272593394000	27720	13610	26	0	\N
208536	1397	1272583393000	27720	13610	27	0	\N
208537	1397	1272573392000	27720	13610	28	0	\N
208538	1397	1272563391000	27720	13610	29	0	\N
208539	1397	1272553390000	27720	13610	30	0	\N
208540	1397	1272543389000	27720	13610	31	0	\N
208541	1397	1272533388000	27720	13610	32	0	\N
208542	1397	1272523387000	27720	13610	33	0	\N
208543	1397	1272513386000	27720	13610	34	0	\N
208544	1397	1272503385000	27720	13610	35	0	\N
208545	1397	1272493384000	27720	13610	36	0	\N
208546	1397	1272483383000	27720	13610	37	0	\N
208547	1397	1272473382000	27720	13610	38	0	\N
208548	1397	1272463381000	27720	13610	39	0	\N
208549	1397	1272453380000	27720	13610	40	0	\N
208550	1397	1272443379000	27720	13610	41	0	\N
208551	1397	1272433378000	27720	13610	42	0	\N
208552	1397	1272423377000	27720	13610	43	0	\N
208553	1397	1272413376000	27720	13610	44	0	\N
208554	1397	1272403375000	27720	13610	45	0	\N
208555	1397	1272393374000	27720	13610	46	0	\N
208556	1397	1272383373000	27720	13610	47	0	\N
208557	1397	1272373372000	27720	13610	48	0	\N
208558	1397	1272363371000	27720	13610	49	0	\N
208559	1397	1272353370000	27720	13610	50	0	\N
208560	1397	1272343369000	27720	13610	51	0	\N
208561	1397	1272333368000	27720	13610	52	0	\N
208562	1397	1272323367000	27720	13610	53	0	\N
208563	1397	1272313366000	27720	13610	54	0	\N
208564	1397	1272303365000	27720	13610	55	0	\N
208565	1397	1272293364000	27720	13610	56	0	\N
208566	1397	1272283363000	27720	13610	57	0	\N
208567	1397	1272273362000	27720	13610	58	0	\N
208568	1397	1272263361000	27720	13610	59	0	\N
208569	1397	1272253360000	27720	13610	60	0	\N
208570	1397	1272243359000	27720	13610	61	0	\N
208571	1397	1272233358000	27720	13610	62	0	\N
208572	1397	1272223357000	27720	13610	63	0	\N
208573	1397	1272213356000	27720	13610	64	0	\N
208574	1397	1272203355000	27720	13610	65	0	\N
208575	1397	1272193354000	27720	13610	66	0	\N
208576	1397	1272183353000	27720	13610	67	0	\N
208577	1397	1272173352000	27720	13610	68	0	\N
208578	1397	1272163351000	27720	13610	69	0	\N
208579	1397	1272153350000	27720	13610	71	0	\N
208580	1397	1272143349000	27720	13610	72	0	\N
208581	1397	1272133348000	27720	13610	73	0	\N
208582	1397	1272123347000	27720	13610	74	0	\N
208583	1397	1272113346000	27720	13610	75	0	\N
208584	1397	1272103345000	27720	13610	76	0	\N
208585	1397	1272093344000	27720	13610	77	0	\N
208586	1397	1272083343000	27720	13610	78	0	\N
208587	1397	1272073342000	27720	13610	79	0	\N
208588	1397	1272063341000	27720	13610	80	0	\N
208589	1397	1272053340000	27720	13610	81	0	\N
208590	1397	1272043339000	27720	13610	82	0	\N
208591	1397	1272033338000	27720	13610	83	0	\N
208592	1397	1272023337000	27720	13610	84	0	\N
208593	1397	1272013336000	27720	13610	85	0	\N
208594	1397	1272003335000	27720	13610	86	0	\N
208595	1397	1271993334000	27720	13610	87	0	\N
208596	1397	1271983333000	27720	13610	88	0	\N
208597	1397	1271973332000	27720	13610	89	0	\N
208598	1397	1271963331000	27720	13610	90	0	\N
208599	1397	1271953330000	27720	13610	91	0	\N
208600	1397	1271943329000	27720	13610	92	0	\N
208601	1397	1271933328000	27720	13610	93	0	\N
208602	1397	1271923327000	27720	13610	94	0	\N
208603	590	66000990000000	27720	13610	95	0	\N
208604	1397	1271913326000	27720	13610	96	0	\N
208605	1397	1271903325000	27720	13610	97	0	\N
208606	1397	1271893324000	27720	13610	98	0	\N
208607	1397	1271883323000	27720	13610	99	0	\N
208608	1397	1271873322000	27720	13610	100	0	\N
208609	1397	1271863321000	27720	13610	101	0	\N
208610	1397	1271853320000	27720	13610	102	0	\N
208611	1397	1271843319000	27720	13610	103	0	\N
208612	1397	1271833318000	27720	13610	104	0	\N
208613	1397	1271823317000	27720	13610	105	0	\N
208614	1397	1271813316000	27720	13610	106	0	\N
208615	1397	1271803315000	27720	13610	107	0	\N
208616	1397	1271793314000	27720	13610	108	0	\N
208617	1397	1271783313000	27720	13610	109	0	\N
208618	1397	1271773312000	27720	13610	110	0	\N
208619	1397	1271763311000	27720	13610	111	0	\N
208620	1397	1271753310000	27720	13610	112	0	\N
208621	1397	1271743309000	27720	13610	113	0	\N
208622	1397	1271733308000	27720	13610	114	0	\N
208623	1397	1271723307000	27720	13610	115	0	\N
208624	1397	1271713306000	27720	13610	116	0	\N
208491	2133	90125900000	27712	13693	2	0	6552
208492	2133	90124898000	27712	13693	3	0	6553
208499	1397	1271393274000	27715	13694	0	0	16743
208500	2133	90123896000	27715	13694	1	0	6554
208503	1397	1271383273000	27717	13695	0	0	16744
208625	1397	1271703305000	27720	13610	117	0	\N
208626	1397	1271693304000	27720	13610	118	0	\N
208627	1397	1271683303000	27720	13610	119	0	\N
208628	1397	1271673302000	27720	13610	120	0	\N
208629	1397	1271663301000	27720	13610	121	0	\N
208630	1397	1271653300000	27720	13610	122	0	\N
208631	1397	1271643299000	27720	13610	123	0	\N
208632	1397	1271633298000	27720	13610	124	0	\N
208633	1397	1271623297000	27720	13610	125	0	\N
208636	1397	1271373272000	27722	13696	0	0	\N
208637	2133	90121892000	27722	13696	1	0	\N
208638	1397	1271373272000	27723	13696	0	0	\N
208639	2133	90121892000	27723	13696	1	0	\N
208643	1397	1271353270000	27725	13698	0	0	\N
208644	1397	1271343269000	27725	13698	1	0	\N
208645	2133	90119888000	27725	13698	2	0	\N
208646	2133	90118886000	27725	13698	3	0	\N
208647	1397	1271353270000	27727	13698	0	0	\N
208648	1397	1271343269000	27727	13698	1	0	\N
208649	2133	90119888000	27727	13698	2	0	\N
208650	2133	90118886000	27727	13698	3	0	\N
208655	1397	1271353270000	27729	13698	0	0	\N
208656	1397	1271343269000	27729	13698	1	0	\N
208657	2133	90119888000	27729	13698	2	0	\N
208658	2133	90118886000	27729	13698	3	0	\N
208661	1397	1271333268000	27731	13699	0	0	\N
208662	2133	90117884000	27731	13699	1	0	\N
208663	1397	1271323267000	27732	13700	0	0	\N
208664	2133	90116882000	27732	13700	1	0	\N
208675	1397	1271273262000	27736	13703	0	0	\N
208676	2133	90111872000	27736	13703	1	0	\N
208677	1397	1271273262000	27737	13703	0	0	\N
208678	2133	90111872000	27737	13703	1	0	\N
208683	1397	1271263261000	27740	13704	0	0	\N
208684	2133	90110870000	27740	13704	1	0	\N
208699	1397	1271183253000	27742	13706	0	0	\N
208700	2133	90102854000	27742	13706	1	0	\N
208701	1397	1271183253000	27743	13706	0	0	\N
208702	2133	90102854000	27743	13706	1	0	\N
208703	1397	1271183253000	27744	13706	0	0	\N
208704	2133	90102854000	27744	13706	1	0	\N
208707	1397	1271173252000	27746	13707	0	0	\N
208708	1397	1271163251000	27746	13707	1	0	\N
208709	2133	90101852000	27746	13707	2	0	\N
208710	2133	90100850000	27746	13707	3	0	\N
208717	1397	1271143249000	27749	13709	0	0	\N
208718	2133	90098846000	27749	13709	1	0	\N
208719	1397	1271143249000	27750	13709	0	0	\N
208720	2133	90098846000	27750	13709	1	0	\N
208721	1397	1271143249000	27751	13709	0	0	\N
208722	2133	90098846000	27751	13709	1	0	\N
208727	1397	1271133248000	27754	13710	0	0	\N
208728	2133	90097844000	27754	13710	1	0	\N
208729	2133	90097844000	27755	13710	0	0	\N
208734	1397	1271113246000	27758	13712	0	0	\N
208735	2133	90095840000	27758	13712	1	0	\N
208746	1397	1271103245000	27760	13713	0	0	\N
208747	1397	1271093244000	27760	13713	1	0	\N
208748	1397	1271083243000	27760	13713	2	0	\N
208749	1397	1271073242000	27760	13713	3	0	\N
208750	1397	1271063241000	27760	13713	4	0	\N
208751	2133	90094838000	27760	13713	5	0	\N
208752	2133	90093836000	27760	13713	6	0	\N
208753	2133	90092834000	27760	13713	7	0	\N
208754	2133	90091832000	27760	13713	8	0	\N
208755	2133	90090830000	27760	13713	9	0	\N
208760	1397	1271043239000	27763	13715	0	0	\N
208640	1397	1271363271000	27724	13697	0	0	16746
208641	2314	859000000	27724	13697	1	0	5
208642	2133	90120890000	27724	13697	2	0	6557
208651	1397	1271353270000	27728	13698	0	0	16747
208652	1397	1271343269000	27728	13698	1	0	16748
208654	2133	90118886000	27728	13698	3	0	6559
208659	1397	1271333268000	27730	13699	0	0	16749
208660	2133	90117884000	27730	13699	1	0	6560
208665	1397	1271323267000	27733	13700	0	0	16750
208666	2133	90116882000	27733	13700	1	0	6561
208668	1397	1271303265000	27734	13701	1	0	16752
208669	1397	1271293264000	27734	13701	2	0	16753
208670	2133	90115880000	27734	13701	3	0	6562
208671	2133	90114878000	27734	13701	4	0	6563
208673	1397	1271283263000	27735	13702	0	0	16754
208674	2133	90112874000	27735	13702	1	0	6565
208679	1397	1271273262000	27738	13703	0	0	16755
208680	2133	90111872000	27738	13703	1	0	6566
208681	1397	1271263261000	27739	13704	0	0	16756
208685	1397	1271253260000	27741	13705	0	0	16757
208686	1397	1271243259000	27741	13705	1	0	16758
208687	1397	1271233258000	27741	13705	2	0	16759
208688	1397	1271223257000	27741	13705	3	0	16760
208689	1397	1271213256000	27741	13705	4	0	16761
208691	1397	1271193254000	27741	13705	6	0	16763
208692	2133	90109868000	27741	13705	7	0	6568
208693	2133	90108866000	27741	13705	8	0	6569
208694	2133	90107864000	27741	13705	9	0	6570
208696	2133	90105860000	27741	13705	11	0	6572
208697	2133	90104858000	27741	13705	12	0	6573
208698	2133	90103856000	27741	13705	13	0	6574
208705	1397	1271183253000	27745	13706	0	0	16764
208706	2133	90102854000	27745	13706	1	0	6575
208712	1397	1271163251000	27747	13707	1	0	16766
208713	2133	90101852000	27747	13707	2	0	6576
208714	2133	90100850000	27747	13707	3	0	6577
208715	1397	1271153250000	27748	13708	0	0	16767
208716	2133	90099848000	27748	13708	1	0	6578
208724	2133	90098846000	27752	13709	1	0	6579
208725	1397	1271133248000	27753	13710	0	0	16769
208726	2133	90097844000	27753	13710	1	0	6580
208730	1397	1271123247000	27756	13711	0	0	16770
208732	1397	1271113246000	27757	13712	0	0	16771
208733	2133	90095840000	27757	13712	1	0	6582
208736	1397	1271103245000	27759	13713	0	0	16772
208737	1397	1271093244000	27759	13713	1	0	16773
208738	1397	1271083243000	27759	13713	2	0	16774
208740	1397	1271063241000	27759	13713	4	0	16776
208741	2133	90094838000	27759	13713	5	0	6583
208742	2133	90093836000	27759	13713	6	0	6584
208743	2133	90092834000	27759	13713	7	0	6585
208744	2133	90091832000	27759	13713	8	0	6586
208756	1397	1271053240000	27761	13714	0	0	16777
208757	2133	90089828000	27761	13714	1	0	6588
208758	1397	1271043239000	27762	13715	0	0	16778
208759	2133	90088826000	27762	13715	1	0	6589
208761	2133	90088826000	27763	13715	1	0	\N
208766	1397	1271013236000	27766	13718	0	0	\N
208767	2133	90085820000	27766	13718	1	0	\N
208768	1397	1271013236000	27767	13718	0	0	\N
208769	2133	90085820000	27767	13718	1	0	\N
208770	1397	1271013236000	27768	13718	0	0	\N
208771	2133	90085820000	27768	13718	1	0	\N
208787	1397	1270943229000	27774	13723	0	0	\N
208788	2133	90078806000	27774	13723	1	0	\N
208795	1397	1270913226000	27777	13725	0	0	\N
208796	2133	90075800000	27777	13725	1	0	\N
208797	1397	1270913226000	27778	13725	0	0	\N
208798	2133	90075800000	27778	13725	1	0	\N
208805	1397	1270903225000	27781	13726	0	0	\N
208806	1397	1270893224000	27781	13726	1	0	\N
208807	2133	90074798000	27781	13726	2	0	\N
208808	2133	90073796000	27781	13726	4	0	\N
208809	1397	1270903225000	27782	13726	0	0	\N
208810	1397	1270893224000	27782	13726	1	0	\N
208811	2133	90074798000	27782	13726	2	0	\N
208812	2133	90073796000	27782	13726	4	0	\N
208830	1397	1270803215000	27787	13731	0	0	\N
208831	1397	1270793214000	27787	13731	1	0	\N
208832	2133	90064778000	27787	13731	2	0	\N
208833	2133	90063776000	27787	13731	3	0	\N
208834	329	67442611000000	27787	13731	4	0	\N
208845	1397	1270773212000	27791	13733	0	0	\N
208846	2385	896000000	27791	13733	1	0	\N
208847	2133	90061772000	27791	13733	2	0	\N
208848	1397	1270773212000	27792	13733	0	0	\N
208849	2385	896000000	27792	13733	1	0	\N
208850	2133	90061772000	27792	13733	2	0	\N
208860	1397	1270733208000	27795	13736	0	0	\N
208861	2133	90057764000	27795	13736	1	0	\N
208862	2134	83544952000	27795	13736	2	0	\N
208866	1397	1270733208000	27797	13736	0	0	\N
208867	2133	90057764000	27797	13736	1	0	\N
208868	2134	83544952000	27797	13736	2	0	\N
208869	1397	1270723207000	27798	13737	0	0	\N
208870	121	66000099000000	27798	13737	1	0	\N
208871	2134	83543949000	27798	13737	2	0	\N
208872	2133	90056762000	27798	13737	3	0	\N
208873	1397	1270723207000	27799	13737	0	0	\N
208874	121	66000099000000	27799	13737	1	0	\N
208875	2134	83543949000	27799	13737	2	0	\N
208876	2133	90056762000	27799	13737	3	0	\N
208881	1397	1270723207000	27801	13737	0	0	\N
208882	121	66000099000000	27801	13737	1	0	\N
208883	2134	83543949000	27801	13737	2	0	\N
208884	2133	90056762000	27801	13737	3	0	\N
208885	1397	1270713206000	27802	13738	0	0	\N
208886	2133	90055760000	27802	13738	1	0	\N
208887	2134	83542946000	27802	13738	2	0	\N
208764	1397	1271023237000	27765	13717	0	0	16780
208765	2133	90086822000	27765	13717	1	0	6591
208772	1397	1271013236000	27769	13718	0	0	16781
208773	2133	90085820000	27769	13718	1	0	6592
208774	1397	1271003235000	27770	13719	0	0	16782
208776	1397	1270993234000	27772	13721	0	0	16783
208777	1397	1270983233000	27772	13721	1	0	16784
208778	2133	90083816000	27772	13721	2	0	6594
208779	2133	90082814000	27772	13721	3	0	6595
208780	1397	1270973232000	27773	13722	0	0	16785
208782	1397	1270953230000	27773	13722	2	0	16787
208783	2133	90081812000	27773	13722	3	0	6596
208784	2133	90080810000	27773	13722	4	0	6597
208785	2133	90079808000	27773	13722	5	0	6598
208789	1397	1270943229000	27775	13723	0	0	16788
208790	2133	90078806000	27775	13723	1	0	6599
208791	1397	1270933228000	27776	13724	0	0	16789
208792	1397	1270923227000	27776	13724	1	0	16790
208793	2133	90077804000	27776	13724	2	0	6600
208799	1397	1270913226000	27779	13725	0	0	16791
208800	2133	90075800000	27779	13725	1	0	6602
208801	1397	1270903225000	27780	13726	0	0	16792
208802	1397	1270893224000	27780	13726	1	0	16793
208803	2133	90074798000	27780	13726	2	0	6603
208813	2317	777585211465	27783	13727	0	0	2
208814	1397	1270883223000	27783	13727	1	0	16794
208815	1397	1270873222000	27783	13727	2	0	16795
208816	1397	1270863221000	27783	13727	3	0	16796
208818	2133	90071792000	27783	13727	5	0	6606
208819	2133	90070790000	27783	13727	6	0	6607
208820	1397	1270853220000	27784	13728	0	0	16797
208821	1397	1270843219000	27784	13728	1	0	16798
208822	2133	90069788000	27784	13728	2	0	6608
208824	1397	1270833218000	27785	13729	0	0	16799
208825	1397	1270823217000	27785	13729	1	0	16800
208826	2133	90067784000	27785	13729	2	0	6610
208827	2133	90066782000	27785	13729	3	0	6611
208828	1397	1270813216000	27786	13730	0	0	16801
208835	1397	1270803215000	27788	13731	0	0	16802
208836	1397	1270793214000	27788	13731	1	0	16803
208837	2133	90064778000	27788	13731	2	0	6613
208838	2133	90063776000	27788	13731	3	0	6614
208840	1397	1270783213000	27789	13732	0	0	16804
208841	2133	90062774000	27789	13732	1	0	6615
208842	1397	1270773212000	27790	13733	0	0	16805
208843	2385	896000000	27790	13733	1	0	1
208844	2133	90061772000	27790	13733	2	0	6616
208852	2134	83547961000	27793	13734	1	0	7021
208853	2133	90060770000	27793	13734	2	0	6617
208854	1397	1270753210000	27794	13735	0	0	16807
208855	1397	1270743209000	27794	13735	1	0	16808
208856	2134	83546958000	27794	13735	2	0	7022
208858	2133	90059768000	27794	13735	4	0	6618
208859	2133	90058766000	27794	13735	5	0	6619
208863	1397	1270733208000	27796	13736	0	0	16809
208864	2133	90057764000	27796	13736	1	0	6620
208877	1397	1270723207000	27800	13737	0	0	16810
208878	121	66000099000000	27800	13737	1	0	1
208879	2134	83543949000	27800	13737	2	0	7025
208880	2133	90056762000	27800	13737	3	0	6621
208888	1397	1270713206000	27803	13738	0	0	16811
208890	2134	83542946000	27803	13738	2	0	7026
208891	1397	1270703205000	27804	13739	0	0	16812
208892	1397	1270693204000	27804	13739	1	0	16813
208893	2133	90054758000	27804	13739	2	0	6623
208894	2134	83541943000	27804	13739	3	0	7027
208896	2133	90053756000	27804	13739	5	0	6624
208897	1397	1270703205000	27805	13739	0	0	\N
208898	1397	1270693204000	27805	13739	1	0	\N
208899	2133	90054758000	27805	13739	2	0	\N
208900	2134	83541943000	27805	13739	3	0	\N
208901	2134	83540940000	27805	13739	4	0	\N
208902	2133	90053756000	27805	13739	5	0	\N
208903	1397	1270683203000	27806	13740	0	0	\N
208904	1397	1270673202000	27806	13740	1	0	\N
208905	2133	90052754000	27806	13740	2	0	\N
208906	2134	83539937000	27806	13740	3	0	\N
208907	2134	83538934000	27806	13740	4	0	\N
208908	2133	90051752000	27806	13740	5	0	\N
208909	1397	1270683203000	27807	13740	0	0	\N
208910	1397	1270673202000	27807	13740	1	0	\N
208911	2133	90052754000	27807	13740	2	0	\N
208912	2134	83539937000	27807	13740	3	0	\N
208913	2134	83538934000	27807	13740	4	0	\N
208914	2133	90051752000	27807	13740	5	0	\N
208921	1397	1270683203000	27809	13740	0	0	\N
208922	1397	1270673202000	27809	13740	1	0	\N
208923	2133	90052754000	27809	13740	2	0	\N
208924	2134	83539937000	27809	13740	3	0	\N
208925	2134	83538934000	27809	13740	4	0	\N
208926	2133	90051752000	27809	13740	5	0	\N
208951	1397	1270603195000	27815	13745	0	0	\N
208952	1397	1270593194000	27815	13745	1	0	\N
208953	2133	90044738000	27815	13745	2	0	\N
208954	2134	83531913000	27815	13745	3	0	\N
208955	2134	83530910000	27815	13745	4	0	\N
208956	2133	90043736000	27815	13745	5	0	\N
208963	1397	1270563191000	27818	13748	0	0	\N
208964	2134	83527901000	27818	13748	1	0	\N
208965	2133	90040730000	27818	13748	2	0	\N
208972	1397	1270543189000	27821	13750	0	0	\N
208973	2133	90038726000	27821	13750	1	0	\N
208974	2134	83525895000	27821	13750	2	0	\N
208981	1397	1270533188000	27824	13751	0	0	\N
208982	2133	90037724000	27824	13751	1	0	\N
208983	2134	83524892000	27824	13751	2	0	\N
208984	1397	1270523187000	27825	13752	0	0	\N
208985	2134	83523889000	27825	13752	1	0	\N
208986	2133	90036722000	27825	13752	2	0	\N
209008	1397	1270493184000	27830	13755	0	0	\N
209009	1397	1270483183000	27830	13755	1	0	\N
209010	1397	1270473182000	27830	13755	2	0	\N
209011	1397	1270463181000	27830	13755	3	0	\N
209012	2134	83520880000	27830	13755	4	0	\N
209013	2133	90033716000	27830	13755	5	0	\N
209014	2133	90032714000	27830	13755	6	0	\N
209015	2133	90031712000	27830	13755	7	0	\N
209016	2133	90030710000	27830	13755	8	0	\N
209017	2134	83519877000	27830	13755	9	0	\N
209018	2134	83518874000	27830	13755	10	0	\N
209019	2134	83517871000	27830	13755	11	0	\N
209020	1397	1270493184000	27831	13755	0	0	\N
209021	1397	1270483183000	27831	13755	1	0	\N
209022	1397	1270473182000	27831	13755	2	0	\N
209023	1397	1270463181000	27831	13755	3	0	\N
209024	2134	83520880000	27831	13755	4	0	\N
209025	2133	90033716000	27831	13755	5	0	\N
209026	2133	90032714000	27831	13755	6	0	\N
209027	2133	90031712000	27831	13755	7	0	\N
209028	2133	90030710000	27831	13755	8	0	\N
209029	2134	83519877000	27831	13755	9	0	\N
209030	2134	83518874000	27831	13755	10	0	\N
209031	2134	83517871000	27831	13755	11	0	\N
208917	2133	90052754000	27808	13740	2	0	6625
208918	2134	83539937000	27808	13740	3	0	7029
208919	2134	83538934000	27808	13740	4	0	7030
208920	2133	90051752000	27808	13740	5	0	6626
208927	1397	1270663201000	27810	13741	0	0	16816
208929	2134	83537931000	27810	13741	2	0	7031
208930	2134	83536928000	27810	13741	3	0	7032
208931	2133	90050750000	27810	13741	4	0	6627
208932	2133	90049748000	27810	13741	5	0	6628
208933	1397	1270643199000	27811	13742	0	0	16818
208935	2133	90048746000	27811	13742	2	0	6629
208936	1397	1270633198000	27812	13743	0	0	16819
208937	1397	1270623197000	27812	13743	1	0	16820
208938	2134	83534922000	27812	13743	2	0	7034
208940	2133	90047744000	27812	13743	4	0	6630
208941	2133	90046742000	27812	13743	5	0	6631
208942	1397	1270613196000	27813	13744	0	0	16821
208943	2134	83532916000	27813	13744	1	0	7036
208944	2133	90045740000	27813	13744	2	0	6632
208946	1397	1270593194000	27814	13745	1	0	16823
208947	2133	90044738000	27814	13745	2	0	6633
208948	2134	83531913000	27814	13745	3	0	7037
208949	2134	83530910000	27814	13745	4	0	7038
208950	2133	90043736000	27814	13745	5	0	6634
208958	2133	90042734000	27816	13746	1	0	6635
208959	2134	83529907000	27816	13746	2	0	7039
208960	1397	1270573192000	27817	13747	0	0	16825
208961	2134	83528904000	27817	13747	1	0	7040
208966	1397	1270563191000	27819	13748	0	0	16826
208967	2134	83527901000	27819	13748	1	0	7041
208968	2133	90040730000	27819	13748	2	0	6637
208969	1397	1270553190000	27820	13749	0	0	16827
208970	2134	83526898000	27820	13749	1	0	7042
208975	1397	1270543189000	27822	13750	0	0	16828
208976	2133	90038726000	27822	13750	1	0	6639
208977	2134	83525895000	27822	13750	2	0	7043
208978	1397	1270533188000	27823	13751	0	0	16829
208979	2133	90037724000	27823	13751	1	0	6640
208987	1397	1270523187000	27826	13752	0	0	16830
208988	2134	83523889000	27826	13752	1	0	7045
208989	2133	90036722000	27826	13752	2	0	6641
208990	1397	1270513186000	27827	13753	0	0	16831
208992	2134	83522886000	27827	13753	2	0	7046
208993	1397	1270503185000	27828	13754	0	0	16832
208994	2134	83521883000	27828	13754	1	0	7047
208995	2133	90034718000	27828	13754	2	0	6643
208996	1397	1270493184000	27829	13755	0	0	16833
208998	1397	1270473182000	27829	13755	2	0	16835
208999	1397	1270463181000	27829	13755	3	0	16836
209000	2134	83520880000	27829	13755	4	0	7048
209001	2133	90033716000	27829	13755	5	0	6644
209002	2133	90032714000	27829	13755	6	0	6645
209004	2133	90030710000	27829	13755	8	0	6647
209005	2134	83519877000	27829	13755	9	0	7049
209006	2134	83518874000	27829	13755	10	0	7050
209007	2134	83517871000	27829	13755	11	0	7051
209035	1397	1270453180000	27833	13756	0	0	\N
209036	2134	83516868000	27833	13756	1	0	\N
209037	2133	90029708000	27833	13756	2	0	\N
209038	1397	1270453180000	27834	13756	0	0	\N
209039	2134	83516868000	27834	13756	1	0	\N
209040	2133	90029708000	27834	13756	2	0	\N
209059	1397	1270393174000	27840	13761	0	0	\N
209060	2134	83510850000	27840	13761	1	0	\N
209061	2133	90023696000	27840	13761	2	0	\N
209062	1397	1270393174000	27841	13761	0	0	\N
209063	2134	83510850000	27841	13761	1	0	\N
209064	2133	90023696000	27841	13761	2	0	\N
209065	1397	1270383173000	27842	13762	0	0	\N
209066	1397	1270373172000	27842	13762	1	0	\N
209067	1397	1270363171000	27842	13762	2	0	\N
209068	2133	90022694000	27842	13762	3	0	\N
209069	2134	83509847000	27842	13762	4	0	\N
209070	2134	83508844000	27842	13762	5	0	\N
209071	2134	83507841000	27842	13762	6	0	\N
209072	2133	90021692000	27842	13762	7	0	\N
209073	2133	90020690000	27842	13762	8	0	\N
209092	1397	1270323167000	27846	13765	0	0	\N
209093	2133	90016682000	27846	13765	1	0	\N
209094	2134	83503829000	27846	13765	2	0	\N
209098	1397	1270323167000	27848	13765	0	0	\N
209099	2133	90016682000	27848	13765	1	0	\N
209100	2134	83503829000	27848	13765	2	0	\N
209101	1397	1270313166000	27849	13766	0	0	\N
209102	2133	90015680000	27849	13766	1	0	\N
209103	2134	83502826000	27849	13766	2	0	\N
209104	1397	1270313166000	27850	13766	0	0	\N
209105	2133	90015680000	27850	13766	1	0	\N
209106	2134	83502826000	27850	13766	2	0	\N
209116	1397	1270293164000	27854	13768	0	0	\N
209117	2134	83500820000	27854	13768	2	0	\N
209118	2133	90013676000	27854	13768	3	0	\N
209119	1397	1270283163000	27855	13769	0	0	\N
209120	1397	1270273162000	27855	13769	1	0	\N
209121	2134	83499817000	27855	13769	2	0	\N
209122	2134	83498814000	27855	13769	3	0	\N
209123	2133	90012674000	27855	13769	4	0	\N
209124	2133	90011672000	27855	13769	5	0	\N
209131	1397	1270263161000	27857	13770	0	0	\N
209132	2133	90010670000	27857	13770	1	0	\N
209133	2134	83497811000	27857	13770	2	0	\N
209149	1397	1270223157000	27862	13773	0	0	\N
209150	2134	83493799000	27862	13773	1	0	\N
209151	2133	90006662000	27862	13773	2	0	\N
209041	1397	1270443179000	27835	13757	0	0	16838
209042	2133	90028706000	27835	13757	1	0	6649
209043	2134	83515865000	27835	13757	2	0	7053
209044	1397	1270433178000	27836	13758	0	0	16839
209045	2134	83514862000	27836	13758	1	0	7054
209047	1397	1270423177000	27837	13759	0	0	16840
209048	2134	83513859000	27837	13759	1	0	7055
209049	2133	90026702000	27837	13759	2	0	6651
209050	1397	1270413176000	27838	13760	0	0	16841
209051	1397	1270403175000	27838	13760	1	0	16842
209053	2133	90025700000	27838	13760	3	0	6652
209054	2133	90024698000	27838	13760	4	0	6653
209055	2134	83511853000	27838	13760	5	0	7057
209056	1397	1270393174000	27839	13761	0	0	16843
209058	2133	90023696000	27839	13761	2	0	6654
209074	1397	1270383173000	27843	13762	0	0	16844
209075	1397	1270373172000	27843	13762	1	0	16845
209076	1397	1270363171000	27843	13762	2	0	16846
209077	2133	90022694000	27843	13762	3	0	6655
209079	2134	83508844000	27843	13762	5	0	7060
209080	2134	83507841000	27843	13762	6	0	7061
209081	2133	90021692000	27843	13762	7	0	6656
209082	2133	90020690000	27843	13762	8	0	6657
209083	1397	1270353170000	27844	13763	0	0	16847
209085	2134	83506838000	27844	13763	2	0	7062
209086	2133	90019688000	27844	13763	3	0	6658
209087	2133	90018686000	27844	13763	4	0	6659
209088	2134	83505835000	27844	13763	5	0	7063
209090	2133	90017684000	27845	13764	1	0	6660
209091	2134	83504832000	27845	13764	2	0	7064
209095	1397	1270323167000	27847	13765	0	0	16850
209096	2133	90016682000	27847	13765	1	0	6661
209097	2134	83503829000	27847	13765	2	0	7065
209108	2133	90015680000	27851	13766	1	0	6662
209109	2134	83502826000	27851	13766	2	0	7066
209110	1397	1270303165000	27852	13767	0	0	16852
209111	2133	90014678000	27852	13767	1	0	6663
209112	2134	83501823000	27852	13767	2	0	7067
209114	2134	83500820000	27853	13768	2	0	7068
209115	2133	90013676000	27853	13768	3	0	6664
209125	1397	1270283163000	27856	13769	0	0	16854
209126	1397	1270273162000	27856	13769	1	0	16855
209128	2134	83498814000	27856	13769	3	0	7070
209129	2133	90012674000	27856	13769	4	0	6665
209130	2133	90011672000	27856	13769	5	0	6666
209134	1397	1270263161000	27858	13770	0	0	16856
209135	2133	90010670000	27858	13770	1	0	6667
209137	1397	1270253160000	27859	13771	0	0	16857
209138	1397	1270243159000	27859	13771	1	0	16858
209139	2134	83496808000	27859	13771	2	0	7072
209140	2133	90009668000	27859	13771	3	0	6668
209141	2133	90008666000	27859	13771	4	0	6669
209143	1397	1270233158000	27860	13772	0	0	16859
209144	2134	83494802000	27860	13772	1	0	7074
209145	2133	90007664000	27860	13772	2	0	6670
209146	1397	1270223157000	27861	13773	0	0	16860
209148	2133	90006662000	27861	13773	2	0	6671
209152	1397	1270213156000	27863	13774	0	0	16861
209153	2134	83492796000	27863	13774	1	0	7076
209154	2133	90005660000	27863	13774	2	0	6672
209155	1397	1270203155000	27864	13775	0	0	16862
209157	2133	90004658000	27864	13775	2	0	6673
209158	1397	1270193154000	27865	13776	0	0	16863
209159	2134	83490790000	27865	13776	1	0	7078
209160	1726	942846112000	27865	13776	2	0	8339
209161	2133	90003656000	27865	13776	3	0	6674
209163	1397	1270173152000	27866	13777	1	0	16865
209164	2351	96000000	27866	13777	2	0	4
209165	2133	90002654000	27866	13777	3	0	6675
209166	2133	90001652000	27866	13777	4	0	6676
209168	2134	83488784000	27866	13777	6	0	7080
209175	1397	1270153150000	27869	13779	0	0	\N
209176	2134	83486778000	27869	13779	1	0	\N
209177	2133	89999648000	27869	13779	2	0	\N
209178	1397	1270153150000	27870	13779	0	0	\N
209179	2134	83486778000	27870	13779	1	0	\N
209180	2133	89999648000	27870	13779	2	0	\N
209181	1397	1270683203000	27871	13740	0	0	\N
209182	1397	1270673202000	27871	13740	1	0	\N
209183	1397	1270663201000	27871	13740	2	0	\N
209184	1397	1270653200000	27871	13740	3	0	\N
209185	1397	1270643199000	27871	13740	4	0	\N
209186	1397	1270633198000	27871	13740	5	0	\N
209187	1397	1270623197000	27871	13740	6	0	\N
209188	1397	1270613196000	27871	13740	7	0	\N
209189	1397	1270603195000	27871	13740	8	0	\N
209190	1397	1270593194000	27871	13740	9	0	\N
209191	1397	1270583193000	27871	13740	10	0	\N
209192	1397	1270573192000	27871	13740	11	0	\N
209193	1397	1270563191000	27871	13740	12	0	\N
209194	1397	1270553190000	27871	13740	13	0	\N
209195	1397	1270543189000	27871	13740	14	0	\N
209196	1397	1270533188000	27871	13740	15	0	\N
209197	1397	1270523187000	27871	13740	16	0	\N
209198	1397	1270513186000	27871	13740	17	0	\N
209199	1397	1270503185000	27871	13740	18	0	\N
209200	1397	1270493184000	27871	13740	19	0	\N
209201	1397	1270483183000	27871	13740	20	0	\N
209202	1397	1270473182000	27871	13740	21	0	\N
209203	1397	1270463181000	27871	13740	22	0	\N
209204	1397	1270453180000	27871	13740	23	0	\N
209205	1397	1270443179000	27871	13740	24	0	\N
209206	1397	1270433178000	27871	13740	25	0	\N
209207	1397	1270423177000	27871	13740	26	0	\N
209208	1397	1270413176000	27871	13740	27	0	\N
209209	1397	1270403175000	27871	13740	28	0	\N
209210	1397	1270393174000	27871	13740	29	0	\N
209211	1397	1270383173000	27871	13740	30	0	\N
209212	1397	1270373172000	27871	13740	31	0	\N
209213	1397	1270363171000	27871	13740	32	0	\N
209214	1397	1270353170000	27871	13740	33	0	\N
209215	1397	1270343169000	27871	13740	34	0	\N
209216	1397	1270333168000	27871	13740	35	0	\N
209217	1397	1270323167000	27871	13740	36	0	\N
209218	1397	1270313166000	27871	13740	37	0	\N
209219	1397	1270303165000	27871	13740	38	0	\N
209220	1397	1270293164000	27871	13740	39	0	\N
209221	1397	1270283163000	27871	13740	40	0	\N
209222	1397	1270273162000	27871	13740	41	0	\N
209223	1397	1270263161000	27871	13740	42	0	\N
209224	1397	1270253160000	27871	13740	43	0	\N
209225	1397	1270243159000	27871	13740	44	0	\N
209226	1397	1270233158000	27871	13740	45	0	\N
209227	1397	1270223157000	27871	13740	47	0	\N
209228	1397	1270213156000	27871	13740	48	0	\N
209229	1397	1270203155000	27871	13740	49	0	\N
209230	1397	1270193154000	27871	13740	50	0	\N
209231	1397	1270183153000	27871	13740	51	0	\N
209232	1397	1270173152000	27871	13740	52	0	\N
209233	1397	1270163151000	27871	13740	53	0	\N
209234	1397	1270153150000	27871	13740	54	0	\N
209235	2351	96000000	27871	13740	55	0	\N
209236	2133	90052754000	27871	13740	56	0	\N
209237	1726	942846112000	27871	13740	57	0	\N
209238	2134	83539937000	27871	13740	58	0	\N
209239	2134	83538934000	27871	13740	59	0	\N
209240	2134	83537931000	27871	13740	60	0	\N
209241	2134	83536928000	27871	13740	61	0	\N
209242	2134	83535925000	27871	13740	62	0	\N
209243	2134	83534922000	27871	13740	63	0	\N
209244	2134	83533919000	27871	13740	64	0	\N
209245	2134	83532916000	27871	13740	65	0	\N
209246	2134	83531913000	27871	13740	66	0	\N
209247	2134	83530910000	27871	13740	67	0	\N
209248	2134	83529907000	27871	13740	68	0	\N
209249	2134	83528904000	27871	13740	69	0	\N
209250	2134	83527901000	27871	13740	70	0	\N
209251	2134	83526898000	27871	13740	71	0	\N
209252	2134	83525895000	27871	13740	72	0	\N
209253	2134	83524892000	27871	13740	73	0	\N
209254	2134	83523889000	27871	13740	74	0	\N
209255	2134	83522886000	27871	13740	75	0	\N
209256	2134	83521883000	27871	13740	76	0	\N
209257	2134	83520880000	27871	13740	77	0	\N
209258	2133	90051752000	27871	13740	78	0	\N
209259	2133	90050750000	27871	13740	79	0	\N
209260	2133	90049748000	27871	13740	80	0	\N
209261	2133	90048746000	27871	13740	81	0	\N
209262	2133	90047744000	27871	13740	82	0	\N
209263	2133	90046742000	27871	13740	83	0	\N
209264	2133	90045740000	27871	13740	84	0	\N
209265	2133	90044738000	27871	13740	85	0	\N
209266	2133	90043736000	27871	13740	86	0	\N
209267	2133	90042734000	27871	13740	87	0	\N
209268	2133	90041732000	27871	13740	88	0	\N
209269	2133	90040730000	27871	13740	89	0	\N
209270	2133	90039728000	27871	13740	90	0	\N
209271	2133	90038726000	27871	13740	91	0	\N
209272	2133	90037724000	27871	13740	92	0	\N
209273	2133	90036722000	27871	13740	93	0	\N
209274	2133	90035720000	27871	13740	94	0	\N
209275	2133	90034718000	27871	13740	95	0	\N
209276	2133	90033716000	27871	13740	96	0	\N
209277	2133	90032714000	27871	13740	97	0	\N
209278	2133	90031712000	27871	13740	98	0	\N
209279	2133	90030710000	27871	13740	99	0	\N
209280	2133	90029708000	27871	13740	100	0	\N
209281	2133	90028706000	27871	13740	101	0	\N
209282	2133	90027704000	27871	13740	102	0	\N
209283	2133	90026702000	27871	13740	103	0	\N
209284	2133	90025700000	27871	13740	104	0	\N
209285	2133	90024698000	27871	13740	105	0	\N
209286	2133	90023696000	27871	13740	106	0	\N
209287	2133	90022694000	27871	13740	107	0	\N
209288	2133	90021692000	27871	13740	108	0	\N
209289	2133	90020690000	27871	13740	109	0	\N
209290	2133	90019688000	27871	13740	110	0	\N
209291	2133	90018686000	27871	13740	111	0	\N
209292	2133	90017684000	27871	13740	112	0	\N
209293	2133	90016682000	27871	13740	113	0	\N
209294	2133	90015680000	27871	13740	114	0	\N
209295	2133	90014678000	27871	13740	115	0	\N
209296	2133	90013676000	27871	13740	116	0	\N
209297	2133	90012674000	27871	13740	117	0	\N
209298	2133	90011672000	27871	13740	118	0	\N
209299	2133	90010670000	27871	13740	119	0	\N
209300	2133	90009668000	27871	13740	120	0	\N
209301	2133	90008666000	27871	13740	121	0	\N
209302	2133	90007664000	27871	13740	122	0	\N
209303	2133	90006662000	27871	13740	123	0	\N
209304	2133	90005660000	27871	13740	124	0	\N
209171	2133	90000650000	27867	13778	2	0	6677
209172	1397	1270153150000	27868	13779	0	0	16867
209173	2134	83486778000	27868	13779	1	0	7082
209174	2133	89999648000	27868	13779	2	0	6678
209305	2133	90004658000	27871	13740	125	0	\N
209309	1397	1270143149000	27873	13780	0	0	\N
209310	2133	89998646000	27873	13780	1	0	\N
209311	2134	83485775000	27873	13780	2	0	\N
209312	1397	1270133148000	27874	13781	0	0	\N
209313	2133	89997644000	27874	13781	1	0	\N
209314	2134	83484772000	27874	13781	2	0	\N
209321	1397	1270113146000	27877	13783	0	0	\N
209322	2134	83482766000	27877	13783	1	0	\N
209323	2133	89995640000	27877	13783	2	0	\N
209327	1397	1270113146000	27879	13783	0	0	\N
209328	2134	83482766000	27879	13783	1	0	\N
209329	2133	89995640000	27879	13783	2	0	\N
209330	1397	1270103145000	27880	13784	0	0	\N
209331	1397	1270093144000	27880	13784	1	0	\N
209332	2133	89994638000	27880	13784	2	0	\N
209333	2134	83481763000	27880	13784	3	0	\N
209334	2134	83480760000	27880	13784	4	0	\N
209335	2134	83479757000	27880	13784	5	0	\N
209336	2133	89993636000	27880	13784	6	0	\N
209337	2133	89992634000	27880	13784	7	0	\N
209346	497	66717010000000	27882	13626	0	0	\N
209347	657	66000990000000	27882	13626	1	0	\N
209348	526	66000305000000	27882	13626	2	0	\N
209349	114	66001337649394	27882	13626	3	0	\N
209350	1571	12765205894466	27882	13626	4	0	\N
209351	2317	777585211465	27882	13626	5	0	\N
209352	1571	12038110913010	27882	13626	6	0	\N
209353	301	66002009153477	27882	13626	7	0	\N
209354	1588	16224799000000	27882	13626	8	0	\N
209355	283	66001018153477	27882	13626	9	0	\N
209356	238	66000703200746	27882	13626	10	0	\N
209357	10	32559970141866	27882	13626	11	0	\N
209358	1571	10735170855898	27882	13626	12	0	\N
209359	1571	9856047983650	27882	13626	13	0	\N
209360	1571	7406311798770	27882	13626	14	0	\N
209361	1571	7406301798770	27882	13626	15	0	\N
209362	1571	7370466673081	27882	13626	16	0	\N
209363	1571	7097799805035	27882	13626	17	0	\N
209364	1571	6609191033618	27882	13626	18	0	\N
209365	1571	6279513706525	27882	13626	19	0	\N
209366	1571	5360856387195	27882	13626	20	0	\N
209367	1571	5360846387195	27882	13626	21	0	\N
209368	590	66000990000000	27882	13626	22	0	\N
209369	553	66000990000000	27882	13626	23	0	\N
209370	2351	96000000	27882	13626	24	0	\N
209371	2305	198999000000	27882	13626	25	0	\N
209372	321	66009959000000	27882	13626	26	0	\N
209373	1726	942846112000	27882	13626	27	0	\N
209374	2318	9000000	27882	13626	28	0	\N
209375	329	67442611000000	27882	13626	29	0	\N
209376	2131	189996000	27882	13626	30	0	\N
209401	1397	1270003135000	27887	13789	0	0	\N
209402	2134	83470730000	27887	13789	1	0	\N
209403	2133	89983616000	27887	13789	2	0	\N
209404	1397	1270003135000	27888	13789	0	0	\N
209405	2134	83470730000	27888	13789	1	0	\N
209406	2133	89983616000	27888	13789	2	0	\N
209419	1397	1269973132000	27893	13792	0	0	\N
209420	2134	83467721000	27893	13792	1	0	\N
209421	2133	89980610000	27893	13792	2	0	\N
209422	1397	1269973132000	27894	13792	0	0	\N
209423	2134	83467721000	27894	13792	1	0	\N
209424	2133	89980610000	27894	13792	2	0	\N
209425	1397	1269963131000	27895	13793	0	0	\N
209426	1397	1269953130000	27895	13793	1	0	\N
209427	1521	67000000	27895	13793	2	0	\N
209428	2133	89979608000	27895	13793	3	0	\N
209429	2133	89978606000	27895	13793	4	0	\N
209430	2134	83466718000	27895	13793	5	0	\N
209431	2134	83465715000	27895	13793	6	0	\N
209439	1397	1269963131000	27897	13793	0	0	\N
209440	1397	1269953130000	27897	13793	1	0	\N
209308	2134	83485775000	27872	13780	2	0	7083
209315	1397	1270133148000	27875	13781	0	0	16869
209316	2133	89997644000	27875	13781	1	0	6680
209317	2134	83484772000	27875	13781	2	0	7084
209318	1397	1270123147000	27876	13782	0	0	16870
209320	2133	89996642000	27876	13782	2	0	6681
209324	1397	1270113146000	27878	13783	0	0	16871
209325	2134	83482766000	27878	13783	1	0	7086
209326	2133	89995640000	27878	13783	2	0	6682
209338	1397	1270103145000	27881	13784	0	0	16872
209340	2133	89994638000	27881	13784	2	0	6683
209341	2134	83481763000	27881	13784	3	0	7087
209342	2134	83480760000	27881	13784	4	0	7088
209343	2134	83479757000	27881	13784	5	0	7089
209345	2133	89992634000	27881	13784	7	0	6685
209377	1397	1270083143000	27883	13785	0	0	16874
209378	2134	83478754000	27883	13785	1	0	7090
209379	2133	89991632000	27883	13785	2	0	6686
209380	1397	1270073142000	27884	13786	0	0	16875
209382	1397	1270053140000	27884	13786	2	0	16877
209383	2134	83477751000	27884	13786	3	0	7091
209384	2133	89990630000	27884	13786	4	0	6687
209385	2133	89989628000	27884	13786	5	0	6688
209386	2133	89988626000	27884	13786	6	0	6689
209388	2134	83475745000	27884	13786	8	0	7093
209389	1397	1270043139000	27885	13787	0	0	16878
209390	2134	83474742000	27885	13787	1	0	7094
209391	2133	89987624000	27885	13787	2	0	6690
209393	1397	1270023137000	27886	13788	1	0	16880
209394	1397	1270013136000	27886	13788	2	0	16881
209395	2134	83473739000	27886	13788	3	0	7095
209396	2134	83472736000	27886	13788	4	0	7096
209397	2134	83471733000	27886	13788	5	0	7097
209399	2133	89985620000	27886	13788	8	0	6692
209400	2133	89984618000	27886	13788	9	0	6693
209407	1397	1270003135000	27889	13789	0	0	16882
209408	2134	83470730000	27889	13789	1	0	7098
209409	2133	89983616000	27889	13789	2	0	6694
209411	2133	89982614000	27890	13790	1	0	6695
209412	2134	83469727000	27890	13790	2	0	7099
209413	1397	1269983133000	27891	13791	0	0	16884
209414	2133	89981612000	27891	13791	1	0	6696
209416	1397	1269973132000	27892	13792	0	0	16885
209417	2134	83467721000	27892	13792	1	0	7101
209418	2133	89980610000	27892	13792	2	0	6697
209432	1397	1269963131000	27896	13793	0	0	16886
209433	1397	1269953130000	27896	13793	1	0	16887
209435	2133	89979608000	27896	13793	3	0	6698
209436	2133	89978606000	27896	13793	4	0	6699
209437	2134	83466718000	27896	13793	5	0	7102
209438	2134	83465715000	27896	13793	6	0	7103
209441	1521	67000000	27897	13793	2	0	\N
209442	2133	89979608000	27897	13793	3	0	\N
209443	2133	89978606000	27897	13793	4	0	\N
209444	2134	83466718000	27897	13793	5	0	\N
209445	2134	83465715000	27897	13793	6	0	\N
209446	1397	1269943129000	27898	13794	0	0	\N
209447	2133	89977604000	27898	13794	1	0	\N
209448	2134	83464712000	27898	13794	2	0	\N
209498	1397	1269793114000	27908	13803	0	0	\N
209499	2133	89962574000	27908	13803	1	0	\N
209500	2134	83449667000	27908	13803	2	0	\N
209501	1397	1269793114000	27909	13803	0	0	\N
209502	2133	89962574000	27909	13803	1	0	\N
209503	2134	83449667000	27909	13803	2	0	\N
209513	1397	1269783113000	27912	13804	0	0	\N
209514	1397	1269773112000	27912	13804	1	0	\N
209515	2133	89961572000	27912	13804	2	0	\N
209516	2133	89960570000	27912	13804	3	0	\N
209517	2134	83448664000	27912	13804	4	0	\N
209518	2134	83447661000	27912	13804	5	0	\N
209531	1397	1269723107000	27916	13808	0	0	\N
209532	2133	89955560000	27916	13808	1	0	\N
209533	2134	83443649000	27916	13808	2	0	\N
209537	1397	1269743109000	27918	13807	0	0	\N
209538	1397	1269733108000	27918	13807	1	0	\N
209539	1397	1269723107000	27918	13807	2	0	\N
209540	2134	83445655000	27918	13807	4	0	\N
209541	2134	83444652000	27918	13807	5	0	\N
209542	2133	89957564000	27918	13807	6	0	\N
209543	2134	83443649000	27918	13807	7	0	\N
209544	2133	89956562000	27918	13807	8	0	\N
209545	2133	89955560000	27918	13807	9	0	\N
209549	1397	1269713106000	27920	13809	0	0	\N
209550	2133	89954558000	27920	13809	1	0	\N
209551	2134	83442646000	27920	13809	2	0	\N
209558	1397	1269693104000	27923	13811	0	0	\N
209559	2134	83440640000	27923	13811	1	0	\N
209567	1397	1269673102000	27926	13813	0	0	\N
209568	2199	720328000000	27926	13813	1	0	\N
209569	2134	83438634000	27926	13813	2	0	\N
209570	2133	89950550000	27926	13813	3	0	\N
209574	1397	1269653100000	27928	13815	0	0	\N
209575	2134	83436628000	27928	13815	1	0	\N
209576	2133	89948546000	27928	13815	2	0	\N
209451	2134	83464712000	27899	13794	2	0	7104
209452	1397	1269933128000	27900	13795	0	0	16889
209453	2134	83463709000	27900	13795	1	0	7105
209454	2133	89976602000	27900	13795	2	0	6701
209455	1397	1269923127000	27901	13796	0	0	16890
209457	2134	83462706000	27901	13796	2	0	7106
209458	2134	83461703000	27901	13796	3	0	7107
209459	2133	89975600000	27901	13796	4	0	6702
209460	2133	89974598000	27901	13796	5	0	6703
209461	1397	1269903125000	27902	13797	0	0	16892
209463	2134	83460700000	27902	13797	2	0	7108
209464	1397	1269893124000	27903	13798	0	0	16893
209465	2133	89972594000	27903	13798	1	0	6705
209466	2134	83459697000	27903	13798	2	0	7109
209468	2134	83458694000	27904	13799	1	0	7110
209469	2133	89971592000	27904	13799	2	0	6706
209470	1397	1269873122000	27905	13800	0	0	16895
209471	1397	1269863121000	27905	13800	1	0	16896
209472	1397	1269853120000	27905	13800	2	0	16897
209474	1397	1269833118000	27905	13800	4	0	16899
209475	2133	89970590000	27905	13800	5	0	6707
209476	1726	941745112000	27905	13800	6	0	8340
209477	2133	89969588000	27905	13800	7	0	6708
209478	2133	89968586000	27905	13800	8	0	6709
209480	1726	939543112000	27905	13800	10	0	8342
209481	1726	938442112000	27905	13800	11	0	8343
209482	2134	83457691000	27905	13800	12	0	7111
209483	2134	83456688000	27905	13800	13	0	7112
209485	2134	83454682000	27905	13800	15	0	7114
209486	2134	83453679000	27905	13800	16	0	7115
209487	2133	89967584000	27905	13800	17	0	6710
209488	2133	89966582000	27905	13800	18	0	6711
209489	1397	1269823117000	27906	13801	0	0	16900
209491	2133	89965580000	27906	13801	2	0	6712
209492	1397	1269813116000	27907	13802	0	0	16901
209493	1397	1269803115000	27907	13802	1	0	16902
209494	2133	89964578000	27907	13802	2	0	6713
209495	2134	83451673000	27907	13802	3	0	7117
209497	2133	89963576000	27907	13802	5	0	6714
209504	1397	1269793114000	27910	13803	0	0	16903
209505	2133	89962574000	27910	13803	1	0	6715
209506	2134	83449667000	27910	13803	2	0	7119
209508	1397	1269773112000	27911	13804	1	0	16905
209509	2133	89961572000	27911	13804	2	0	6716
209510	2133	89960570000	27911	13804	3	0	6717
209511	2134	83448664000	27911	13804	4	0	7120
209512	2134	83447661000	27911	13804	5	0	7121
209520	2134	83446658000	27913	13805	1	0	7122
209521	2133	89959568000	27913	13805	2	0	6718
209522	1397	1269753110000	27914	13806	0	0	16907
209523	1474	24290633000043	27914	13806	1	0	30
209524	2133	89958566000	27914	13806	2	0	6719
209526	1397	1269733108000	27915	13807	1	0	16909
209527	2134	83445655000	27915	13807	2	0	7123
209528	2134	83444652000	27915	13807	4	0	7124
209529	2133	89957564000	27915	13807	5	0	6720
209534	1397	1269723107000	27917	13808	0	0	16910
209535	2133	89955560000	27917	13808	1	0	6722
209536	2134	83443649000	27917	13808	2	0	7125
209546	1397	1269713106000	27919	13809	0	0	16911
209547	2133	89954558000	27919	13809	1	0	6723
209552	1397	1269703105000	27921	13810	0	0	16912
209553	2134	83441643000	27921	13810	1	0	7127
209554	2133	89953556000	27921	13810	2	0	6724
209555	1397	1269693104000	27922	13811	0	0	16913
209556	2134	83440640000	27922	13811	1	0	7128
209560	1397	1269683103000	27924	13812	0	0	16914
209561	2134	83439637000	27924	13812	1	0	7129
209562	2133	89951552000	27924	13812	2	0	6726
209563	1397	1269673102000	27925	13813	0	0	16915
209565	2134	83438634000	27925	13813	2	0	7130
209566	2133	89950550000	27925	13813	3	0	6727
209571	1397	1269663101000	27927	13814	0	0	16916
209572	2133	89949548000	27927	13814	1	0	6728
209573	2134	83437631000	27927	13814	2	0	7131
209580	1397	1269653100000	27930	13815	0	0	\N
209581	2134	83436628000	27930	13815	1	0	\N
209582	2133	89948546000	27930	13815	2	0	\N
209592	1397	1269613096000	27932	13817	0	0	\N
209593	2133	89945540000	27932	13817	1	0	\N
209594	2134	83432616000	27932	13817	2	0	\N
209605	1397	1269603095000	27935	13818	0	0	\N
209606	1397	1269593094000	27935	13818	1	0	\N
209607	2133	89944538000	27935	13818	2	0	\N
209608	2133	89943536000	27935	13818	3	0	\N
209609	395	66044730646980	27935	13818	4	0	\N
209610	2134	83431613000	27935	13818	5	0	\N
209611	2134	83430610000	27935	13818	6	0	\N
209621	1397	1269563091000	27938	13820	0	0	\N
209622	2133	89940530000	27938	13820	1	0	\N
209623	2134	83427601000	27938	13820	2	0	\N
209624	1397	1269563091000	27939	13820	0	0	\N
209625	2133	89940530000	27939	13820	1	0	\N
209626	2134	83427601000	27939	13820	2	0	\N
209649	1397	1269483083000	27944	13825	0	0	\N
209650	2133	89932514000	27944	13825	1	0	\N
209651	2134	83419577000	27944	13825	2	0	\N
209655	1397	1269483083000	27946	13825	0	0	\N
209656	2133	89932514000	27946	13825	1	0	\N
209657	2134	83419577000	27946	13825	2	0	\N
209658	1397	1269473082000	27947	13826	0	0	\N
209659	1397	1269463081000	27947	13826	1	0	\N
209660	2134	83418574000	27947	13826	2	0	\N
209661	2134	83417571000	27947	13826	3	0	\N
209662	2133	89931512000	27947	13826	4	0	\N
209663	2133	89930510000	27947	13826	5	0	\N
209664	1397	1269473082000	27948	13826	0	0	\N
209665	1397	1269463081000	27948	13826	1	0	\N
209666	2134	83418574000	27948	13826	2	0	\N
209667	2134	83417571000	27948	13826	3	0	\N
209668	2133	89931512000	27948	13826	4	0	\N
209669	2133	89930510000	27948	13826	5	0	\N
209676	1397	1269453080000	27951	13828	0	0	\N
209677	1397	1269443079000	27951	13828	1	0	\N
209678	2133	89929508000	27951	13828	2	0	\N
209679	2133	89928506000	27951	13828	3	0	\N
209680	2134	83416568000	27951	13828	4	0	\N
209681	2134	83415565000	27951	13828	5	0	\N
209688	1397	1269433078000	27953	13829	0	0	\N
209689	1397	1269423077000	27953	13829	1	0	\N
209690	2134	83414562000	27953	13829	2	0	\N
209691	2133	89927504000	27953	13829	3	0	\N
209692	2134	83413559000	27953	13829	4	0	\N
209693	2133	89926502000	27953	13829	5	0	\N
209700	1397	1269413076000	27955	13830	0	0	\N
209701	1397	1269403075000	27955	13830	1	0	\N
209702	2134	83412556000	27955	13830	2	0	\N
209703	2134	83411553000	27955	13830	3	0	\N
209704	2133	89925500000	27955	13830	4	0	\N
209705	2133	89924498000	27955	13830	5	0	\N
209712	1397	1269393074000	27957	13831	0	0	\N
209579	2133	89948546000	27929	13815	2	0	6729
209583	1397	1269643099000	27931	13816	0	0	16918
209584	1397	1269633098000	27931	13816	1	0	16919
209585	1397	1269623097000	27931	13816	2	0	16920
209586	2192	994500000	27931	13816	3	0	1
209588	2133	89946542000	27931	13816	5	0	6731
209589	2134	83435625000	27931	13816	6	0	7133
209590	2134	83434622000	27931	13816	7	0	7134
209591	2134	83433619000	27931	13816	8	0	7135
209595	1397	1269613096000	27933	13817	0	0	16921
209597	2134	83432616000	27933	13817	2	0	7136
209598	1397	1269603095000	27934	13818	0	0	16922
209599	1397	1269593094000	27934	13818	1	0	16923
209600	2133	89944538000	27934	13818	2	0	6733
209602	395	66044730646980	27934	13818	4	0	3
209603	2134	83431613000	27934	13818	5	0	7137
209604	2134	83430610000	27934	13818	6	0	7138
209612	1397	1269583093000	27936	13819	0	0	16924
209613	1397	1269573092000	27936	13819	1	0	16925
209615	2133	89941532000	27936	13819	3	0	6736
209616	2134	83429607000	27936	13819	4	0	7139
209617	2134	83428604000	27936	13819	5	0	7140
209618	1397	1269563091000	27937	13820	0	0	16926
209619	2133	89940530000	27937	13820	1	0	6737
209627	1397	1269553090000	27940	13821	0	0	16927
209628	2134	83426598000	27940	13821	1	0	7142
209629	2133	89939528000	27940	13821	2	0	6738
209630	1397	1269543089000	27941	13822	0	0	16928
209632	2133	89938526000	27941	13822	2	0	6739
209633	1726	937341112000	27941	13822	3	0	8344
209634	1397	1269533088000	27942	13823	0	0	16929
209635	1397	1269523087000	27942	13823	1	0	16930
209636	2134	83424592000	27942	13823	2	0	7144
209638	2133	89936522000	27942	13823	4	0	6741
209639	2134	83423589000	27942	13823	5	0	7145
209640	1397	1269513086000	27943	13824	0	0	16931
209641	1397	1269503085000	27943	13824	1	0	16932
209642	1397	1269493084000	27943	13824	2	0	16933
209644	2133	89934518000	27943	13824	4	0	6743
209645	2133	89933516000	27943	13824	5	0	6744
209646	2134	83422586000	27943	13824	6	0	7146
209647	2134	83421583000	27943	13824	7	0	7147
209652	1397	1269483083000	27945	13825	0	0	16934
209653	2133	89932514000	27945	13825	1	0	6745
209654	2134	83419577000	27945	13825	2	0	7149
209670	1397	1269473082000	27949	13826	0	0	16935
209671	1397	1269463081000	27949	13826	1	0	16936
209673	2134	83417571000	27949	13826	3	0	7151
209674	2133	89931512000	27949	13826	4	0	6746
209675	2133	89930510000	27949	13826	5	0	6747
209682	1397	1269453080000	27952	13828	0	0	16937
209683	1397	1269443079000	27952	13828	1	0	16938
209685	2133	89928506000	27952	13828	3	0	6749
209686	2134	83416568000	27952	13828	4	0	7152
209687	2134	83415565000	27952	13828	5	0	7153
209694	1397	1269433078000	27954	13829	0	0	16939
209696	2134	83414562000	27954	13829	2	0	7154
209697	2133	89927504000	27954	13829	3	0	6750
209698	2134	83413559000	27954	13829	4	0	7155
209699	2133	89926502000	27954	13829	5	0	6751
209706	1397	1269413076000	27956	13830	0	0	16941
209708	2134	83412556000	27956	13830	2	0	7156
209709	2134	83411553000	27956	13830	3	0	7157
209710	2133	89925500000	27956	13830	4	0	6752
209711	2133	89924498000	27956	13830	5	0	6753
209713	2134	83410550000	27957	13831	1	0	\N
209714	2133	89923496000	27957	13831	2	0	\N
209722	1397	1269393074000	27960	13832	0	0	\N
209723	1397	1269383073000	27960	13832	1	0	\N
209724	1397	1269373072000	27960	13832	2	0	\N
209725	2134	83409547000	27960	13832	3	0	\N
209726	2134	83408544000	27960	13832	4	0	\N
209727	1397	1269393074000	27961	13832	0	0	\N
209728	1397	1269383073000	27961	13832	1	0	\N
209729	1397	1269373072000	27961	13832	2	0	\N
209730	2133	89922494000	27961	13832	3	0	\N
209731	2134	83409547000	27961	13832	4	0	\N
209732	2134	83408544000	27961	13832	5	0	\N
209733	2133	89921492000	27961	13832	6	0	\N
209734	1397	1269393074000	27962	13832	0	0	\N
209735	1397	1269383073000	27962	13832	1	0	\N
209736	1397	1269373072000	27962	13832	2	0	\N
209737	2133	89922494000	27962	13832	3	0	\N
209738	2134	83409547000	27962	13832	4	0	\N
209739	2134	83408544000	27962	13832	5	0	\N
209740	2133	89921492000	27962	13832	6	0	\N
209741	1397	1269393074000	27963	13832	0	0	\N
209742	1397	1269383073000	27963	13832	1	0	\N
209743	1397	1269373072000	27963	13832	2	0	\N
209744	2133	89922494000	27963	13832	3	0	\N
209745	2134	83409547000	27963	13832	4	0	\N
209746	2134	83408544000	27963	13832	5	0	\N
209747	2133	89921492000	27963	13832	6	0	\N
209763	1397	1269313066000	27967	13835	0	0	\N
209764	1397	1269303065000	27967	13835	1	0	\N
209765	1397	1269293064000	27967	13835	2	0	\N
209766	2134	83402526000	27967	13835	3	0	\N
209767	2133	89917484000	27967	13835	4	0	\N
209768	2133	89916482000	27967	13835	5	0	\N
209769	2134	83401523000	27967	13835	6	0	\N
209770	2134	83400520000	27967	13835	7	0	\N
209771	2133	89915480000	27967	13835	8	0	\N
209772	2133	89914478000	27967	13835	9	0	\N
209773	2133	89913476000	27967	13835	10	0	\N
209774	1397	1269313066000	27968	13835	0	0	\N
209775	1397	1269303065000	27968	13835	1	0	\N
209776	1397	1269293064000	27968	13835	2	0	\N
209777	2134	83402526000	27968	13835	3	0	\N
209778	2133	89917484000	27968	13835	4	0	\N
209779	2133	89916482000	27968	13835	5	0	\N
209780	2134	83401523000	27968	13835	6	0	\N
209781	2134	83400520000	27968	13835	7	0	\N
209782	2133	89915480000	27968	13835	8	0	\N
209783	2133	89914478000	27968	13835	9	0	\N
209784	2133	89913476000	27968	13835	10	0	\N
209785	1397	1269313066000	27969	13835	0	0	\N
209786	1397	1269303065000	27969	13835	1	0	\N
209787	1397	1269293064000	27969	13835	2	0	\N
209788	2134	83402526000	27969	13835	3	0	\N
209789	2133	89917484000	27969	13835	4	0	\N
209790	2133	89916482000	27969	13835	5	0	\N
209791	2134	83401523000	27969	13835	6	0	\N
209792	2134	83400520000	27969	13835	7	0	\N
209793	2133	89915480000	27969	13835	8	0	\N
209794	2133	89914478000	27969	13835	9	0	\N
209795	2133	89913476000	27969	13835	10	0	\N
209796	1397	1269313066000	27970	13835	0	0	\N
209797	1397	1269303065000	27970	13835	1	0	\N
209798	1397	1269293064000	27970	13835	2	0	\N
209799	2134	83402526000	27970	13835	3	0	\N
209800	2134	83401523000	27970	13835	4	0	\N
209801	2134	83400520000	27970	13835	5	0	\N
209813	1397	1269313066000	27972	13835	0	0	\N
209814	1397	1269303065000	27972	13835	1	0	\N
209815	1397	1269293064000	27972	13835	2	0	\N
209816	2134	83402526000	27972	13835	3	0	\N
209817	2133	89917484000	27972	13835	4	0	\N
209818	2133	89916482000	27972	13835	5	0	\N
209819	2134	83401523000	27972	13835	6	0	\N
209820	2134	83400520000	27972	13835	7	0	\N
209821	2133	89915480000	27972	13835	8	0	\N
209822	2133	89914478000	27972	13835	9	0	\N
209823	2133	89913476000	27972	13835	10	0	\N
209824	1397	1269313066000	27973	13835	0	0	\N
209825	1397	1269303065000	27973	13835	1	0	\N
209826	1397	1269293064000	27973	13835	2	0	\N
209827	2134	83402526000	27973	13835	3	0	\N
209828	2133	89917484000	27973	13835	4	0	\N
209829	2133	89916482000	27973	13835	5	0	\N
209830	2134	83401523000	27973	13835	6	0	\N
209831	2134	83400520000	27973	13835	7	0	\N
209832	2133	89915480000	27973	13835	8	0	\N
209833	2133	89914478000	27973	13835	9	0	\N
209834	2133	89913476000	27973	13835	10	0	\N
209838	1397	1269273062000	27975	13837	0	0	\N
209839	2133	89911472000	27975	13837	1	0	\N
209840	2134	83398514000	27975	13837	2	0	\N
209844	1397	1270143149000	27977	13741	0	0	\N
209845	1397	1270133148000	27977	13741	1	0	\N
209846	1397	1270123147000	27977	13741	2	0	\N
209847	1397	1270113146000	27977	13741	3	0	\N
209848	1474	24290633000043	27977	13741	4	0	\N
209717	1397	1269393074000	27959	13832	0	0	16943
209718	1397	1269383073000	27959	13832	1	0	16944
209719	1397	1269373072000	27959	13832	2	0	16945
209720	2134	83409547000	27959	13832	3	0	7159
209721	2134	83408544000	27959	13832	4	0	7160
209749	1397	1269353070000	27965	13833	1	0	16947
209750	1397	1269343069000	27965	13833	2	0	16948
209751	2134	83407541000	27965	13833	3	0	7161
209752	2133	89922494000	27965	13833	4	0	6755
209753	2133	89921492000	27965	13833	5	0	6756
209755	2133	89919488000	27965	13833	7	0	6758
209756	2133	89918486000	27965	13833	8	0	6759
209757	2134	83406538000	27965	13833	9	0	7162
209758	2134	83405535000	27965	13833	10	0	7163
209760	1397	1269323067000	27966	13834	1	0	16950
209761	2134	83404532000	27966	13834	2	0	7164
209762	2134	83403529000	27966	13834	3	0	7165
209802	1397	1269313066000	27971	13835	0	0	16951
209803	1397	1269303065000	27971	13835	1	0	16952
209805	2134	83402526000	27971	13835	3	0	7166
209806	2133	89917484000	27971	13835	4	0	6760
209807	2133	89916482000	27971	13835	5	0	6761
209808	2134	83401523000	27971	13835	6	0	7167
209809	2134	83400520000	27971	13835	7	0	7168
209811	2133	89914478000	27971	13835	9	0	6763
209812	2133	89913476000	27971	13835	10	0	6764
209835	1397	1269283063000	27974	13836	0	0	16954
209836	2133	89912474000	27974	13836	1	0	6765
209841	1397	1269273062000	27976	13837	0	0	16955
209842	2133	89911472000	27976	13837	1	0	6766
209843	2134	83398514000	27976	13837	2	0	7170
209849	2199	720328000000	27977	13741	5	0	\N
209850	1397	1270103145000	27977	13741	6	0	\N
209851	1397	1270093144000	27977	13741	7	0	\N
209852	1397	1270083143000	27977	13741	8	0	\N
209853	1397	1270073142000	27977	13741	9	0	\N
209854	1397	1270063141000	27977	13741	10	0	\N
209855	1397	1270053140000	27977	13741	11	0	\N
209856	1397	1270043139000	27977	13741	12	0	\N
209857	1397	1270033138000	27977	13741	13	0	\N
209858	1397	1270023137000	27977	13741	14	0	\N
209859	1397	1270013136000	27977	13741	15	0	\N
209860	1397	1270003135000	27977	13741	16	0	\N
209861	1397	1269993134000	27977	13741	17	0	\N
209862	1397	1269983133000	27977	13741	18	0	\N
209863	1397	1269973132000	27977	13741	19	0	\N
209864	1397	1269963131000	27977	13741	20	0	\N
209865	1397	1269953130000	27977	13741	21	0	\N
209866	1397	1269943129000	27977	13741	22	0	\N
209867	1397	1269933128000	27977	13741	23	0	\N
209868	1397	1269923127000	27977	13741	24	0	\N
209869	1397	1269913126000	27977	13741	25	0	\N
209870	1397	1269903125000	27977	13741	26	0	\N
209871	1397	1269893124000	27977	13741	27	0	\N
209872	1397	1269883123000	27977	13741	28	0	\N
209873	1397	1269873122000	27977	13741	29	0	\N
209874	1397	1269863121000	27977	13741	30	0	\N
209875	1397	1269853120000	27977	13741	31	0	\N
209876	1397	1269843119000	27977	13741	32	0	\N
209877	1397	1269833118000	27977	13741	33	0	\N
209878	1397	1269823117000	27977	13741	34	0	\N
209879	1397	1269813116000	27977	13741	35	0	\N
209880	1397	1269803115000	27977	13741	36	0	\N
209881	1397	1269793114000	27977	13741	37	0	\N
209882	1397	1269783113000	27977	13741	38	0	\N
209883	1397	1269773112000	27977	13741	39	0	\N
209884	1397	1269763111000	27977	13741	40	0	\N
209885	1397	1269753110000	27977	13741	41	0	\N
209886	1397	1269743109000	27977	13741	42	0	\N
209887	1397	1269733108000	27977	13741	43	0	\N
209888	1397	1269723107000	27977	13741	44	0	\N
209889	1397	1269713106000	27977	13741	45	0	\N
209890	1397	1269703105000	27977	13741	47	0	\N
209891	1397	1269693104000	27977	13741	48	0	\N
209892	1397	1269683103000	27977	13741	49	0	\N
209893	1397	1269673102000	27977	13741	50	0	\N
209894	1397	1269663101000	27977	13741	51	0	\N
209895	1397	1269653100000	27977	13741	52	0	\N
209896	1397	1269643099000	27977	13741	53	0	\N
209897	1397	1269633098000	27977	13741	54	0	\N
209898	1397	1269623097000	27977	13741	55	0	\N
209899	1397	1269613096000	27977	13741	56	0	\N
209900	1397	1269603095000	27977	13741	57	0	\N
209901	1397	1269593094000	27977	13741	58	0	\N
209902	1397	1269583093000	27977	13741	59	0	\N
209903	1397	1269573092000	27977	13741	60	0	\N
209904	1397	1269563091000	27977	13741	61	0	\N
209905	1397	1269553090000	27977	13741	62	0	\N
209906	1397	1269543089000	27977	13741	63	0	\N
209907	1397	1269533088000	27977	13741	64	0	\N
209908	1397	1269523087000	27977	13741	65	0	\N
209909	1397	1269513086000	27977	13741	66	0	\N
209910	1397	1269503085000	27977	13741	67	0	\N
209911	1397	1269493084000	27977	13741	68	0	\N
209912	1397	1269483083000	27977	13741	69	0	\N
209913	1397	1269473082000	27977	13741	70	0	\N
209914	1397	1269463081000	27977	13741	71	0	\N
209915	1397	1269453080000	27977	13741	72	0	\N
209916	1397	1269443079000	27977	13741	73	0	\N
209917	1397	1269433078000	27977	13741	74	0	\N
209918	1397	1269423077000	27977	13741	75	0	\N
209919	1397	1269413076000	27977	13741	76	0	\N
209920	1397	1269403075000	27977	13741	77	0	\N
209921	1397	1269393074000	27977	13741	78	0	\N
209922	1397	1269383073000	27977	13741	79	0	\N
209923	1397	1269373072000	27977	13741	80	0	\N
209924	1397	1269363071000	27977	13741	81	0	\N
209925	1397	1269353070000	27977	13741	82	0	\N
209926	1397	1269343069000	27977	13741	83	0	\N
209927	1397	1269333068000	27977	13741	84	0	\N
209928	1397	1269323067000	27977	13741	85	0	\N
209929	1397	1269313066000	27977	13741	86	0	\N
209930	1397	1269303065000	27977	13741	87	0	\N
209931	1397	1269293064000	27977	13741	88	0	\N
209932	1726	941745112000	27977	13741	89	0	\N
209933	1726	940644112000	27977	13741	90	0	\N
209934	395	66044730646980	27977	13741	91	0	\N
209935	1726	939543112000	27977	13741	92	0	\N
209936	1726	938442112000	27977	13741	93	0	\N
209937	2133	90003656000	27977	13741	94	0	\N
209938	2133	90002654000	27977	13741	95	0	\N
209939	2133	90001652000	27977	13741	96	0	\N
209940	1726	937341112000	27977	13741	97	0	\N
209941	2133	90000650000	27977	13741	98	0	\N
209942	2133	89999648000	27977	13741	99	0	\N
209943	2133	89998646000	27977	13741	100	0	\N
209944	2133	89997644000	27977	13741	101	0	\N
209945	2133	89996642000	27977	13741	102	0	\N
209946	2133	89995640000	27977	13741	103	0	\N
209947	2133	89994638000	27977	13741	104	0	\N
209948	2133	89993636000	27977	13741	105	0	\N
209949	2133	89992634000	27977	13741	106	0	\N
209950	2133	89991632000	27977	13741	107	0	\N
209951	2133	89990630000	27977	13741	108	0	\N
209952	2133	89989628000	27977	13741	109	0	\N
209953	2133	89988626000	27977	13741	110	0	\N
209954	2133	89987624000	27977	13741	111	0	\N
209955	2133	89986622000	27977	13741	112	0	\N
209956	2133	89985620000	27977	13741	113	0	\N
209957	2133	89984618000	27977	13741	114	0	\N
209958	2133	89983616000	27977	13741	115	0	\N
209959	2133	89982614000	27977	13741	116	0	\N
209960	2133	89981612000	27977	13741	117	0	\N
209961	2133	89980610000	27977	13741	118	0	\N
209962	2133	89979608000	27977	13741	119	0	\N
209963	2133	89978606000	27977	13741	120	0	\N
209964	2133	89977604000	27977	13741	121	0	\N
209965	2133	89976602000	27977	13741	122	0	\N
209966	2133	89975600000	27977	13741	123	0	\N
209967	2133	89974598000	27977	13741	124	0	\N
209968	2133	89973596000	27977	13741	125	0	\N
209980	1397	1269233058000	27980	13840	0	0	\N
209981	2133	89906462000	27980	13840	1	0	\N
209982	2134	83393499000	27980	13840	2	0	\N
209983	1397	1269233058000	27981	13840	0	0	\N
209984	2133	89906462000	27981	13840	1	0	\N
209971	2133	89910470000	27978	13838	2	0	6767
209972	2133	89909468000	27978	13838	3	0	6768
209973	2133	89908466000	27978	13838	4	0	6769
209974	2134	83397511000	27978	13838	5	0	7171
209975	2134	83396508000	27978	13838	6	0	7172
209977	1397	1269243059000	27979	13839	0	0	16958
209978	2133	89907464000	27979	13839	1	0	6770
209979	2134	83394502000	27979	13839	2	0	7174
209985	2134	83393499000	27981	13840	2	0	\N
209995	1397	1269223057000	27984	13841	0	0	\N
209996	1397	1269213056000	27984	13841	1	0	\N
209997	2133	89905460000	27984	13841	2	0	\N
209998	2133	89904458000	27984	13841	3	0	\N
209999	2134	83392496000	27984	13841	4	0	\N
210000	2134	83391493000	27984	13841	5	0	\N
210010	1397	1269173052000	27987	13844	0	0	\N
210011	1397	1269163051000	27987	13844	1	0	\N
210012	1397	1269153050000	27987	13844	2	0	\N
210013	2134	83387481000	27987	13844	3	0	\N
210014	2134	83386478000	27987	13844	4	0	\N
210015	2134	83385475000	27987	13844	5	0	\N
210016	2133	89900450000	27987	13844	6	0	\N
210017	2133	89899448000	27987	13844	7	0	\N
210018	2133	89898446000	27987	13844	8	0	\N
210019	1397	1269173052000	27988	13844	0	0	\N
210020	1397	1269163051000	27988	13844	1	0	\N
210021	1397	1269153050000	27988	13844	2	0	\N
210022	2134	83387481000	27988	13844	3	0	\N
210023	2134	83386478000	27988	13844	4	0	\N
210024	2134	83385475000	27988	13844	5	0	\N
210025	2133	89900450000	27988	13844	6	0	\N
210026	2133	89899448000	27988	13844	7	0	\N
210027	2133	89898446000	27988	13844	8	0	\N
210028	1397	1269173052000	27989	13844	0	0	\N
210029	1397	1269163051000	27989	13844	1	0	\N
210030	1397	1269153050000	27989	13844	2	0	\N
210031	2134	83387481000	27989	13844	3	0	\N
210032	2134	83386478000	27989	13844	4	0	\N
210033	2134	83385475000	27989	13844	5	0	\N
210034	2133	89900450000	27989	13844	6	0	\N
210035	2133	89899448000	27989	13844	7	0	\N
210036	2133	89898446000	27989	13844	8	0	\N
210046	1397	1269143049000	27991	13845	0	0	\N
210047	2134	83384472000	27991	13845	1	0	\N
210048	2133	89897444000	27991	13845	2	0	\N
210049	1397	1269143049000	27992	13845	0	0	\N
210050	2134	83384472000	27992	13845	1	0	\N
210051	2133	89897444000	27992	13845	2	0	\N
210055	1397	1269143049000	27994	13845	0	0	\N
210056	2134	83384472000	27994	13845	1	0	\N
210057	2133	89897444000	27994	13845	2	0	\N
210058	1397	1269133048000	27995	13846	0	0	\N
210059	2134	83383469000	27995	13846	1	0	\N
210060	2133	89896442000	27995	13846	2	0	\N
210061	1397	1269133048000	27996	13846	0	0	\N
210062	2134	83383469000	27996	13846	1	0	\N
210063	2133	89896442000	27996	13846	2	0	\N
210070	1397	1269123047000	28000	13847	0	0	\N
210071	2133	89895440000	28000	13847	1	0	\N
210072	2134	83382466000	28000	13847	2	0	\N
210082	1397	1269103045000	28005	13849	0	0	\N
210083	1397	1269093044000	28005	13849	1	0	\N
210084	2134	83380460000	28005	13849	2	0	\N
210085	2134	83379457000	28005	13849	3	0	\N
210086	2133	89893436000	28005	13849	4	0	\N
210087	2133	89892434000	28005	13849	5	0	\N
210088	1397	1269103045000	28006	13849	0	0	\N
210089	1397	1269093044000	28006	13849	1	0	\N
210090	2134	83380460000	28006	13849	2	0	\N
210091	2134	83379457000	28006	13849	3	0	\N
210092	2133	89893436000	28006	13849	4	0	\N
210093	2133	89892434000	28006	13849	5	0	\N
210094	1397	1269083043000	28007	13851	0	0	\N
210095	2134	83378454000	28007	13851	1	0	\N
210096	2133	89891432000	28007	13851	2	0	\N
210097	1397	1269083043000	28008	13851	0	0	\N
210098	2134	83378454000	28008	13851	1	0	\N
210099	2133	89891432000	28008	13851	2	0	\N
210100	1397	1269283063000	28009	13742	0	0	\N
210101	1397	1269273062000	28009	13742	1	0	\N
210102	1397	1269263061000	28009	13742	2	0	\N
210103	1397	1269253060000	28009	13742	3	0	\N
210104	1397	1269243059000	28009	13742	4	0	\N
210105	1397	1269233058000	28009	13742	5	0	\N
210106	1397	1269223057000	28009	13742	6	0	\N
210107	1397	1269213056000	28009	13742	7	0	\N
210108	1397	1269203055000	28009	13742	8	0	\N
210109	1397	1269193054000	28009	13742	9	0	\N
210110	1397	1269183053000	28009	13742	10	0	\N
210111	1397	1269173052000	28009	13742	11	0	\N
210112	1397	1269163051000	28009	13742	12	0	\N
210113	1397	1269153050000	28009	13742	13	0	\N
210114	1397	1269143049000	28009	13742	14	0	\N
210115	1397	1269133048000	28009	13742	15	0	\N
210116	1397	1269123047000	28009	13742	16	0	\N
210117	1397	1269113046000	28009	13742	17	0	\N
210118	1397	1269103045000	28009	13742	18	0	\N
210119	1397	1269093044000	28009	13742	19	0	\N
210120	1397	1269083043000	28009	13742	20	0	\N
209988	2134	83393499000	27982	13840	2	0	7175
209989	1397	1269223057000	27983	13841	0	0	16960
209990	1397	1269213056000	27983	13841	1	0	16961
209991	2133	89905460000	27983	13841	2	0	6772
209992	2133	89904458000	27983	13841	3	0	6773
209994	2134	83391493000	27983	13841	5	0	7177
210001	1397	1269203055000	27985	13842	0	0	16962
210002	2133	89903456000	27985	13842	1	0	6774
210003	2134	83390490000	27985	13842	2	0	7178
210004	1397	1269193054000	27986	13843	0	0	16963
210006	2134	83389487000	27986	13843	2	0	7179
210007	2133	89902454000	27986	13843	3	0	6775
210008	2133	89901452000	27986	13843	4	0	6776
210009	2134	83388484000	27986	13843	5	0	7180
210038	1397	1269163051000	27990	13844	1	0	16966
210039	1397	1269153050000	27990	13844	2	0	16967
210040	2134	83387481000	27990	13844	3	0	7181
210041	2134	83386478000	27990	13844	4	0	7182
210042	2134	83385475000	27990	13844	5	0	7183
210044	2133	89899448000	27990	13844	7	0	6778
210045	2133	89898446000	27990	13844	8	0	6779
210052	1397	1269143049000	27993	13845	0	0	16968
210053	2134	83384472000	27993	13845	1	0	7184
210054	2133	89897444000	27993	13845	2	0	6780
210065	2134	83383469000	27997	13846	1	0	7185
210066	2133	89896442000	27997	13846	2	0	6781
210067	1397	1269123047000	27998	13847	0	0	16970
210068	2133	89895440000	27998	13847	1	0	6782
210073	1397	1269113046000	28002	13848	0	0	16971
210074	2134	83381463000	28002	13848	1	0	7187
210075	2133	89894438000	28002	13848	2	0	6783
210076	1397	1269103045000	28003	13849	0	0	16972
210077	1397	1269093044000	28004	13850	0	0	16973
210079	2134	83379457000	28004	13850	2	0	7189
210080	2133	89893436000	28004	13850	3	0	6784
210081	2133	89892434000	28004	13850	4	0	6785
210121	2133	89972594000	28009	13742	21	0	\N
210122	2133	89971592000	28009	13742	22	0	\N
210123	2133	89970590000	28009	13742	23	0	\N
210124	2133	89969588000	28009	13742	24	0	\N
210125	2133	89968586000	28009	13742	25	0	\N
210126	2133	89967584000	28009	13742	26	0	\N
210127	2133	89966582000	28009	13742	27	0	\N
210128	2133	89965580000	28009	13742	28	0	\N
210129	2133	89964578000	28009	13742	29	0	\N
210130	2133	89963576000	28009	13742	30	0	\N
210131	2133	89962574000	28009	13742	31	0	\N
210132	2133	89961572000	28009	13742	32	0	\N
210133	2133	89960570000	28009	13742	33	0	\N
210134	2133	89959568000	28009	13742	34	0	\N
210135	2133	89958566000	28009	13742	35	0	\N
210136	2133	89957564000	28009	13742	36	0	\N
210137	2133	89956562000	28009	13742	37	0	\N
210138	2133	89955560000	28009	13742	38	0	\N
210139	2133	89954558000	28009	13742	39	0	\N
210140	2133	89953556000	28009	13742	40	0	\N
210141	2133	89952554000	28009	13742	41	0	\N
210142	2133	89951552000	28009	13742	42	0	\N
210143	2133	89950550000	28009	13742	43	0	\N
210144	2133	89949548000	28009	13742	44	0	\N
210145	2133	89948546000	28009	13742	45	0	\N
210146	2133	89947544000	28009	13742	47	0	\N
210147	2133	89946542000	28009	13742	48	0	\N
210148	2133	89945540000	28009	13742	49	0	\N
210149	2133	89944538000	28009	13742	50	0	\N
210150	2133	89943536000	28009	13742	51	0	\N
210151	2133	89942534000	28009	13742	52	0	\N
210152	2133	89941532000	28009	13742	53	0	\N
210153	2133	89940530000	28009	13742	54	0	\N
210154	2133	89939528000	28009	13742	55	0	\N
210155	2133	89938526000	28009	13742	56	0	\N
210156	2133	89937524000	28009	13742	57	0	\N
210157	2133	89936522000	28009	13742	58	0	\N
210158	2133	89935520000	28009	13742	59	0	\N
210159	2133	89934518000	28009	13742	60	0	\N
210160	2133	89933516000	28009	13742	61	0	\N
210161	2133	89932514000	28009	13742	62	0	\N
210162	2133	89931512000	28009	13742	63	0	\N
210163	2133	89930510000	28009	13742	64	0	\N
210164	2133	89929508000	28009	13742	65	0	\N
210165	2133	89928506000	28009	13742	66	0	\N
210166	2133	89927504000	28009	13742	67	0	\N
210167	2133	89926502000	28009	13742	68	0	\N
210168	2133	89925500000	28009	13742	69	0	\N
210169	2133	89924498000	28009	13742	70	0	\N
210170	2133	89923496000	28009	13742	71	0	\N
210171	2133	89922494000	28009	13742	72	0	\N
210172	2133	89921492000	28009	13742	73	0	\N
210173	2133	89920490000	28009	13742	74	0	\N
210174	2133	89919488000	28009	13742	75	0	\N
210175	2133	89918486000	28009	13742	76	0	\N
210176	2133	89917484000	28009	13742	77	0	\N
210177	2133	89916482000	28009	13742	78	0	\N
210178	2133	89915480000	28009	13742	79	0	\N
210179	2133	89914478000	28009	13742	80	0	\N
210180	2133	89913476000	28009	13742	81	0	\N
210181	2133	89912474000	28009	13742	82	0	\N
210182	2133	89911472000	28009	13742	83	0	\N
210183	2133	89910470000	28009	13742	84	0	\N
210198	1397	1269033038000	28014	13855	0	0	\N
210199	2134	83373439000	28014	13855	1	0	\N
210200	2133	89887424000	28014	13855	2	0	\N
210219	1397	1268973032000	28019	13859	0	0	\N
210220	1397	1268973032000	28020	13859	0	0	\N
210221	2133	89881412000	28020	13859	1	0	\N
210224	1397	1268963031000	28022	13860	0	0	\N
210225	2134	83367421000	28022	13860	1	0	\N
210226	2133	89880410000	28022	13860	2	0	\N
210230	1397	1268953030000	28024	13861	0	0	\N
210231	1397	1268943029000	28024	13861	1	0	\N
210232	2133	89879408000	28024	13861	2	0	\N
210233	2134	83366418000	28024	13861	3	0	\N
210234	2134	83365415000	28024	13861	4	0	\N
210235	2133	89878406000	28024	13861	5	0	\N
210242	1397	1268933028000	28027	13862	0	0	\N
210243	2133	89877404000	28027	13862	1	0	\N
210244	2134	83364412000	28027	13862	2	0	\N
210252	1397	1268913026000	28033	13864	0	0	\N
210253	1397	1268903025000	28033	13864	1	0	\N
210254	1397	1268893024000	28033	13864	2	0	\N
210255	1397	1268883023000	28033	13864	3	0	\N
210256	1397	1268873022000	28033	13864	4	0	\N
210186	2133	89891432000	28010	13851	2	0	6786
210187	1397	1269073042000	28011	13852	0	0	16975
210188	2134	83377451000	28011	13852	1	0	7191
210189	1397	1269063041000	28012	13853	0	0	16976
210190	2133	89890430000	28012	13853	1	0	6787
210192	1397	1269053040000	28013	13854	0	0	16977
210193	1397	1269043039000	28013	13854	1	0	16978
210194	2133	89889428000	28013	13854	2	0	6788
210195	2134	83375445000	28013	13854	3	0	7193
210196	2133	89888426000	28013	13854	4	0	6789
210201	1397	1269033038000	28015	13855	0	0	16979
210202	2134	83373439000	28015	13855	1	0	7195
210203	2133	89887424000	28015	13855	2	0	6790
210204	1397	1269023037000	28016	13856	0	0	16980
210206	2134	83372436000	28016	13856	2	0	7196
210207	1397	1269013036000	28017	13857	0	0	16981
210208	2134	83371433000	28017	13857	1	0	7197
210209	2133	89885420000	28017	13857	2	0	6792
210210	1397	1269003035000	28018	13858	0	0	16982
210212	1397	1268983033000	28018	13858	2	0	16984
210213	2133	89884418000	28018	13858	3	0	6793
210214	2133	89883416000	28018	13858	4	0	6794
210215	2133	89882414000	28018	13858	5	0	6795
210216	2134	83370430000	28018	13858	6	0	7198
210218	2134	83368424000	28018	13858	8	0	7200
210222	1397	1268973032000	28021	13859	0	0	16985
210223	2133	89881412000	28021	13859	1	0	6796
210227	1397	1268963031000	28023	13860	0	0	16986
210229	2133	89880410000	28023	13860	2	0	6797
210236	1397	1268953030000	28025	13861	0	0	16987
210237	1397	1268943029000	28025	13861	1	0	16988
210238	2133	89879408000	28025	13861	2	0	6798
210239	2134	83366418000	28025	13861	3	0	7202
210241	2133	89878406000	28025	13861	5	0	6799
210245	1397	1268933028000	28028	13862	0	0	16989
210246	2133	89877404000	28028	13862	1	0	6800
210247	2134	83364412000	28028	13862	2	0	7204
210248	1397	1268923027000	28032	13863	0	0	16990
210250	2134	83363409000	28032	13863	2	0	7205
210251	2388	99000000	28032	13863	3	0	1
210257	2134	83362406000	28033	13864	5	0	\N
210258	2134	83361403000	28033	13864	6	0	\N
210259	2134	83360400000	28033	13864	7	0	\N
210260	2134	83359397000	28033	13864	8	0	\N
210261	2133	89875400000	28033	13864	9	0	\N
210262	2133	89874398000	28033	13864	10	0	\N
210263	2133	89873396000	28033	13864	11	0	\N
210264	2133	89872394000	28033	13864	12	0	\N
210265	2133	89871392000	28033	13864	13	0	\N
210266	2134	83358394000	28033	13864	14	0	\N
210285	497	66717010000000	28036	13638	0	0	\N
210286	657	66000990000000	28036	13638	1	0	\N
210287	526	66000305000000	28036	13638	2	0	\N
210288	114	66001337649394	28036	13638	3	0	\N
210289	1571	12765205894466	28036	13638	4	0	\N
210290	1474	24290633000043	28036	13638	5	0	\N
210291	2317	777585211465	28036	13638	6	0	\N
210292	1571	12038110913010	28036	13638	7	0	\N
210293	301	66002009153477	28036	13638	8	0	\N
210294	2199	720328000000	28036	13638	9	0	\N
210295	283	66001018153477	28036	13638	10	0	\N
210296	238	66000703200746	28036	13638	11	0	\N
210297	10	32559970141866	28036	13638	12	0	\N
210298	1397	1272243359000	28036	13638	13	0	\N
210299	1571	10735170855898	28036	13638	14	0	\N
210300	1571	9856047983650	28036	13638	15	0	\N
210301	1571	7406311798770	28036	13638	16	0	\N
210302	1571	7406301798770	28036	13638	17	0	\N
210303	1571	7370466673081	28036	13638	18	0	\N
210304	1571	7097799805035	28036	13638	19	0	\N
210305	1571	6609191033618	28036	13638	20	0	\N
210306	1571	6279513706525	28036	13638	21	0	\N
210307	1571	5360856387195	28036	13638	22	0	\N
210308	1571	5360846387195	28036	13638	24	0	\N
210309	1397	1272233358000	28036	13638	25	0	\N
210310	1397	1272223357000	28036	13638	26	0	\N
210311	1397	1272213356000	28036	13638	27	0	\N
210312	1397	1272203355000	28036	13638	28	0	\N
210313	1397	1272193354000	28036	13638	29	0	\N
210314	1397	1272183353000	28036	13638	30	0	\N
210315	1397	1272173352000	28036	13638	31	0	\N
210316	1397	1272163351000	28036	13638	32	0	\N
210317	1397	1272153350000	28036	13638	33	0	\N
210318	1397	1272143349000	28036	13638	34	0	\N
210319	1397	1272133348000	28036	13638	35	0	\N
210320	1397	1272123347000	28036	13638	36	0	\N
210321	1397	1272113346000	28036	13638	37	0	\N
210322	1397	1272103345000	28036	13638	38	0	\N
210323	1397	1272093344000	28036	13638	39	0	\N
210324	1397	1272083343000	28036	13638	40	0	\N
210325	1397	1272073342000	28036	13638	41	0	\N
210326	1397	1272063341000	28036	13638	42	0	\N
210327	1397	1272053340000	28036	13638	43	0	\N
210328	1397	1272043339000	28036	13638	44	0	\N
210329	1397	1272033338000	28036	13638	45	0	\N
210330	1397	1272023337000	28036	13638	46	0	\N
210331	1397	1272013336000	28036	13638	47	0	\N
210332	1397	1272003335000	28036	13638	48	0	\N
210333	1397	1271993334000	28036	13638	49	0	\N
210334	1397	1271983333000	28036	13638	50	0	\N
210335	1397	1271973332000	28036	13638	51	0	\N
210336	1397	1271963331000	28036	13638	52	0	\N
210337	1397	1271953330000	28036	13638	53	0	\N
210338	1397	1271943329000	28036	13638	54	0	\N
210339	1397	1271933328000	28036	13638	55	0	\N
210340	1397	1271923327000	28036	13638	56	0	\N
210341	590	66000990000000	28036	13638	57	0	\N
210342	1397	1271913326000	28036	13638	58	0	\N
210343	1397	1271903325000	28036	13638	59	0	\N
210344	1397	1271893324000	28036	13638	60	0	\N
210345	1397	1271883323000	28036	13638	61	0	\N
210346	1397	1271873322000	28036	13638	62	0	\N
210347	1397	1271863321000	28036	13638	63	0	\N
210348	1397	1271853320000	28036	13638	64	0	\N
210349	1397	1271843319000	28036	13638	65	0	\N
210350	1397	1271833318000	28036	13638	66	0	\N
210351	1397	1271823317000	28036	13638	67	0	\N
210352	1397	1271813316000	28036	13638	68	0	\N
210353	1397	1271803315000	28036	13638	69	0	\N
210354	1397	1271793314000	28036	13638	70	0	\N
210355	1397	1271783313000	28036	13638	71	0	\N
210356	1397	1271773312000	28036	13638	72	0	\N
210357	1397	1271763311000	28036	13638	73	0	\N
210358	1397	1271753310000	28036	13638	74	0	\N
210359	1397	1271743309000	28036	13638	75	0	\N
210360	1397	1271733308000	28036	13638	76	0	\N
210361	1397	1271723307000	28036	13638	77	0	\N
210362	1397	1271713306000	28036	13638	78	0	\N
210363	1397	1271703305000	28036	13638	79	0	\N
210364	1397	1271693304000	28036	13638	80	0	\N
210365	1397	1271683303000	28036	13638	81	0	\N
210366	1397	1271673302000	28036	13638	82	0	\N
210367	1397	1271663301000	28036	13638	83	0	\N
210368	1397	1271653300000	28036	13638	84	0	\N
210369	1397	1271643299000	28036	13638	85	0	\N
210370	1397	1271633298000	28036	13638	86	0	\N
210371	1397	1271623297000	28036	13638	87	0	\N
210372	1397	1271613296000	28036	13638	88	0	\N
210373	1397	1271603295000	28036	13638	89	0	\N
210374	1397	1271593294000	28036	13638	90	0	\N
210375	1397	1271583293000	28036	13638	91	0	\N
210376	1397	1271573292000	28036	13638	92	0	\N
210377	1397	1271563291000	28036	13638	93	0	\N
210378	1397	1271553290000	28036	13638	94	0	\N
210379	1397	1271543289000	28036	13638	95	0	\N
210380	553	66000990000000	28036	13638	96	0	\N
210381	2068	89000000	28036	13638	97	0	\N
210382	1397	1271533288000	28036	13638	98	0	\N
210383	1397	1271523287000	28036	13638	99	0	\N
210384	1397	1271513286000	28036	13638	100	0	\N
210385	1397	1271503285000	28036	13638	101	0	\N
210386	1397	1271493284000	28036	13638	102	0	\N
210387	1397	1271483283000	28036	13638	103	0	\N
210388	1397	1271473282000	28036	13638	104	0	\N
210389	1397	1271463281000	28036	13638	105	0	\N
210390	1397	1271453280000	28036	13638	106	0	\N
210391	1397	1271443279000	28036	13638	107	0	\N
210392	1397	1271433278000	28036	13638	108	0	\N
210269	1397	1268893024000	28034	13864	2	0	16993
210270	1397	1268883023000	28034	13864	3	0	16994
210271	1397	1268873022000	28034	13864	4	0	16995
210272	2134	83362406000	28034	13864	5	0	7206
210273	2134	83361403000	28034	13864	6	0	7207
210275	2134	83359397000	28034	13864	8	0	7209
210276	2133	89875400000	28034	13864	9	0	6802
210277	2133	89874398000	28034	13864	10	0	6803
210278	2133	89873396000	28034	13864	11	0	6804
210279	2133	89872394000	28034	13864	12	0	6805
210281	2134	83358394000	28034	13864	14	0	7210
210282	1397	1268863021000	28035	13865	0	0	16996
210283	2133	89870390000	28035	13865	1	0	6807
210284	2134	83357391000	28035	13865	2	0	7211
210393	1397	1271423277000	28036	13638	109	0	\N
210394	1397	1271413276000	28036	13638	110	0	\N
210395	1397	1271403275000	28036	13638	111	0	\N
210396	1397	1271393274000	28036	13638	112	0	\N
210397	1397	1271383273000	28036	13638	113	0	\N
210398	1397	1271373272000	28036	13638	114	0	\N
210399	1397	1271363271000	28036	13638	115	0	\N
210400	1397	1271353270000	28036	13638	116	0	\N
210401	1397	1271343269000	28036	13638	117	0	\N
210402	1397	1271333268000	28036	13638	118	0	\N
210403	1397	1271323267000	28036	13638	119	0	\N
210404	1397	1271313266000	28036	13638	120	0	\N
210405	1397	1271303265000	28036	13638	121	0	\N
210406	1397	1271293264000	28036	13638	122	0	\N
210407	1397	1271283263000	28036	13638	123	0	\N
210408	1397	1271273262000	28036	13638	124	0	\N
210409	1397	1271263261000	28036	13638	125	0	\N
210410	1397	1268853020000	28037	13866	0	0	\N
210411	2133	89869388000	28037	13866	1	0	\N
210412	2134	83356388000	28037	13866	2	0	\N
210416	1397	1268843019000	28039	13867	0	0	\N
210417	2134	83355385000	28039	13867	1	0	\N
210424	2134	83354382000	28042	13868	0	0	\N
210425	2133	89867384000	28042	13868	1	0	\N
210434	1397	1268803015000	28047	13871	0	0	\N
210435	2134	83350370000	28047	13871	1	0	\N
210436	2133	89863376000	28047	13871	2	0	\N
210437	1397	1268803015000	28048	13871	0	0	\N
210438	2134	83350370000	28048	13871	1	0	\N
210439	2133	89863376000	28048	13871	2	0	\N
210443	1474	24290633000043	28050	13627	0	0	\N
210444	2199	720328000000	28050	13627	1	0	\N
210445	1726	941745112000	28050	13627	2	0	\N
210446	1726	940644112000	28050	13627	3	0	\N
210447	395	66044730646980	28050	13627	4	0	\N
210448	1726	939543112000	28050	13627	5	0	\N
210449	1726	938442112000	28050	13627	6	0	\N
210450	1726	937341112000	28050	13627	7	0	\N
210451	1397	1268793014000	28051	13872	0	0	\N
210455	1397	1268793014000	28053	13872	0	0	\N
210456	2134	83349367000	28053	13872	1	0	\N
210457	1397	1268793014000	28054	13872	0	0	\N
210458	2134	83349367000	28054	13872	1	0	\N
210459	2133	89862374000	28054	13872	2	0	\N
210460	1397	1268793014000	28055	13872	0	0	\N
210461	2134	83349367000	28055	13872	1	0	\N
210462	2133	89862374000	28055	13872	2	0	\N
210466	1397	1268773012000	28057	13874	0	0	\N
210467	2133	89860370000	28057	13874	1	0	\N
210468	2134	83347361000	28057	13874	2	0	\N
210469	1397	1268773012000	28058	13874	0	0	\N
210470	2133	89860370000	28058	13874	1	0	\N
210471	2134	83347361000	28058	13874	2	0	\N
210472	1397	1268773012000	28059	13874	0	0	\N
210473	2133	89860370000	28059	13874	1	0	\N
210474	2134	83347361000	28059	13874	2	0	\N
210484	1397	1268753010000	28063	13876	0	0	\N
210485	2133	89858366000	28063	13876	1	0	\N
210486	2134	83345355000	28063	13876	2	0	\N
210487	1397	1268753010000	28064	13876	0	0	\N
210488	2133	89858366000	28064	13876	1	0	\N
210489	2134	83345355000	28064	13876	2	0	\N
210499	1397	1268713006000	28066	13878	0	0	\N
210500	1397	1268703005000	28066	13878	1	0	\N
210501	2133	89854358000	28066	13878	2	0	\N
210502	2133	89853356000	28066	13878	3	0	\N
210503	2134	83341343000	28066	13878	4	0	\N
210504	2134	83340340000	28066	13878	5	0	\N
210511	1397	1268693004000	28068	13879	0	0	\N
210512	2133	89852354000	28068	13879	1	0	\N
210513	2134	83339337000	28068	13879	2	0	\N
210514	1726	936240112000	28068	13879	3	0	\N
210519	1397	1268683003000	28070	13880	0	0	\N
210520	1397	1268673002000	28070	13880	1	0	\N
210521	2133	89851352000	28070	13880	2	0	\N
210522	2133	89850350000	28070	13880	3	0	\N
210415	2134	83356388000	28038	13866	2	0	7212
210418	1397	1268843019000	28040	13867	0	0	16998
210419	2134	83355385000	28040	13867	1	0	7213
210420	2133	89868386000	28040	13867	2	0	6809
210421	1397	1268833018000	28041	13868	0	0	16999
210423	2133	89867384000	28041	13868	2	0	6810
210426	2133	89866382000	28043	13869	0	0	6811
210427	2134	83353379000	28043	13869	1	0	7215
210428	1397	1268823017000	28044	13870	0	0	17000
210429	1397	1268813016000	28044	13870	1	0	17001
210431	2134	83351373000	28044	13870	3	0	7217
210432	2133	89865380000	28044	13870	4	0	6812
210433	2133	89864378000	28044	13870	5	0	6813
210440	1397	1268803015000	28049	13871	0	0	17002
210442	2133	89863376000	28049	13871	2	0	6814
210452	1397	1268793014000	28052	13872	0	0	17003
210453	2134	83349367000	28052	13872	1	0	7219
210454	2133	89862374000	28052	13872	2	0	6815
210463	1397	1268783013000	28056	13873	0	0	17004
210465	2134	83348364000	28056	13873	2	0	7220
210475	1397	1268773012000	28060	13874	0	0	17005
210476	2133	89860370000	28060	13874	1	0	6817
210477	2134	83347361000	28060	13874	2	0	7221
210478	1397	1268763011000	28061	13875	0	0	17006
210480	2133	89859368000	28061	13875	2	0	6818
210481	1397	1268753010000	28062	13876	0	0	17007
210482	2133	89858366000	28062	13876	1	0	6819
210483	2134	83345355000	28062	13876	2	0	7223
210491	1397	1268733008000	28065	13877	1	0	17009
210492	1397	1268723007000	28065	13877	2	0	17010
210493	2133	89857364000	28065	13877	3	0	6820
210494	2133	89856362000	28065	13877	4	0	6821
210495	2133	89855360000	28065	13877	5	0	6822
210497	2134	83343349000	28065	13877	7	0	7225
210498	2134	83342346000	28065	13877	8	0	7226
210505	1397	1268713006000	28067	13878	0	0	17011
210506	1397	1268703005000	28067	13878	1	0	17012
210507	2133	89854358000	28067	13878	2	0	6823
210509	2134	83341343000	28067	13878	4	0	7227
210510	2134	83340340000	28067	13878	5	0	7228
210515	1397	1268693004000	28069	13879	0	0	17013
210516	2133	89852354000	28069	13879	1	0	6825
210518	1726	936240112000	28069	13879	3	0	8345
210523	1397	1268683003000	28071	13880	0	0	17014
210524	1397	1268673002000	28071	13880	1	0	17015
210525	2134	83338334000	28071	13880	2	0	7230
210526	2134	83337331000	28071	13880	3	0	7231
210528	2133	89850350000	28071	13880	5	0	6827
210529	1397	1268683003000	28072	13880	0	0	\N
210530	1397	1268673002000	28072	13880	1	0	\N
210531	2134	83338334000	28072	13880	2	0	\N
210532	2134	83337331000	28072	13880	3	0	\N
210533	2133	89851352000	28072	13880	4	0	\N
210534	2133	89850350000	28072	13880	5	0	\N
210535	1397	1271253260000	28073	13639	0	0	\N
210536	1397	1271243259000	28073	13639	1	0	\N
210537	1397	1271233258000	28073	13639	2	0	\N
210538	1397	1271223257000	28073	13639	3	0	\N
210539	1397	1271213256000	28073	13639	4	0	\N
210540	1397	1271203255000	28073	13639	5	0	\N
210541	1397	1271193254000	28073	13639	6	0	\N
210542	1397	1271183253000	28073	13639	7	0	\N
210543	1397	1271173252000	28073	13639	8	0	\N
210544	1397	1271163251000	28073	13639	9	0	\N
210545	1397	1271153250000	28073	13639	10	0	\N
210546	1397	1271143249000	28073	13639	11	0	\N
210547	1397	1271133248000	28073	13639	12	0	\N
210548	1397	1271123247000	28073	13639	13	0	\N
210549	1397	1271113246000	28073	13639	14	0	\N
210550	1397	1271103245000	28073	13639	15	0	\N
210551	1397	1271093244000	28073	13639	16	0	\N
210552	1397	1271083243000	28073	13639	17	0	\N
210553	1397	1271073242000	28073	13639	18	0	\N
210554	1397	1271063241000	28073	13639	19	0	\N
210555	1397	1271053240000	28073	13639	20	0	\N
210556	1397	1271043239000	28073	13639	21	0	\N
210557	1397	1271033238000	28073	13639	22	0	\N
210558	1397	1271023237000	28073	13639	24	0	\N
210559	1397	1271013236000	28073	13639	25	0	\N
210560	1397	1271003235000	28073	13639	26	0	\N
210561	1397	1270993234000	28073	13639	27	0	\N
210562	1397	1270983233000	28073	13639	28	0	\N
210563	1397	1270973232000	28073	13639	29	0	\N
210564	1397	1270963231000	28073	13639	30	0	\N
210565	1397	1270953230000	28073	13639	31	0	\N
210566	1397	1270943229000	28073	13639	32	0	\N
210567	1397	1270933228000	28073	13639	33	0	\N
210568	1397	1270923227000	28073	13639	34	0	\N
210569	1397	1270913226000	28073	13639	35	0	\N
210570	1397	1270903225000	28073	13639	36	0	\N
210571	1397	1270893224000	28073	13639	37	0	\N
210572	1397	1270883223000	28073	13639	38	0	\N
210573	1397	1270873222000	28073	13639	39	0	\N
210574	1397	1270863221000	28073	13639	40	0	\N
210575	1397	1270853220000	28073	13639	41	0	\N
210576	1397	1270843219000	28073	13639	42	0	\N
210577	1397	1270833218000	28073	13639	43	0	\N
210578	1397	1270823217000	28073	13639	44	0	\N
210579	1397	1270813216000	28073	13639	45	0	\N
210580	1397	1270803215000	28073	13639	46	0	\N
210581	1397	1270793214000	28073	13639	47	0	\N
210582	1397	1270783213000	28073	13639	48	0	\N
210583	1397	1270773212000	28073	13639	49	0	\N
210584	1397	1270763211000	28073	13639	50	0	\N
210585	1397	1270753210000	28073	13639	51	0	\N
210586	1397	1270743209000	28073	13639	52	0	\N
210587	1397	1270733208000	28073	13639	53	0	\N
210588	1397	1270723207000	28073	13639	54	0	\N
210589	1397	1270713206000	28073	13639	55	0	\N
210590	1397	1270703205000	28073	13639	56	0	\N
210591	1397	1270693204000	28073	13639	57	0	\N
210592	1397	1270683203000	28073	13639	58	0	\N
210593	1397	1270673202000	28073	13639	59	0	\N
210594	1397	1270663201000	28073	13639	60	0	\N
210595	1397	1270653200000	28073	13639	61	0	\N
210596	1397	1270643199000	28073	13639	62	0	\N
210597	1397	1270633198000	28073	13639	63	0	\N
210598	1397	1270623197000	28073	13639	64	0	\N
210599	1397	1270613196000	28073	13639	65	0	\N
210600	1397	1270603195000	28073	13639	66	0	\N
210601	1397	1270593194000	28073	13639	67	0	\N
210602	1397	1270583193000	28073	13639	68	0	\N
210603	1397	1270573192000	28073	13639	69	0	\N
210604	1397	1270563191000	28073	13639	70	0	\N
210605	1397	1270553190000	28073	13639	71	0	\N
210606	1397	1270543189000	28073	13639	72	0	\N
210607	1397	1270533188000	28073	13639	73	0	\N
210608	1397	1270523187000	28073	13639	74	0	\N
210609	1397	1270513186000	28073	13639	75	0	\N
210610	1397	1270503185000	28073	13639	76	0	\N
210611	1397	1270493184000	28073	13639	77	0	\N
210612	1397	1270483183000	28073	13639	78	0	\N
210613	1397	1270473182000	28073	13639	79	0	\N
210614	1397	1270463181000	28073	13639	80	0	\N
210615	1397	1270453180000	28073	13639	81	0	\N
210616	1397	1270443179000	28073	13639	82	0	\N
210617	1397	1270433178000	28073	13639	83	0	\N
210618	1397	1270423177000	28073	13639	84	0	\N
210619	1397	1270413176000	28073	13639	85	0	\N
210620	1397	1270403175000	28073	13639	86	0	\N
210621	1397	1270393174000	28073	13639	87	0	\N
210622	1397	1270383173000	28073	13639	88	0	\N
210623	1397	1270373172000	28073	13639	89	0	\N
210624	1397	1270363171000	28073	13639	90	0	\N
210625	1397	1270353170000	28073	13639	91	0	\N
210626	1397	1270343169000	28073	13639	92	0	\N
210627	1397	1270333168000	28073	13639	93	0	\N
210628	1397	1270323167000	28073	13639	94	0	\N
210629	1397	1270313166000	28073	13639	95	0	\N
210630	1397	1270303165000	28073	13639	96	0	\N
210631	1397	1270293164000	28073	13639	97	0	\N
210632	1397	1270283163000	28073	13639	98	0	\N
210633	1397	1270273162000	28073	13639	99	0	\N
210634	1397	1270263161000	28073	13639	100	0	\N
210635	1397	1270253160000	28073	13639	101	0	\N
210636	1397	1270243159000	28073	13639	102	0	\N
210637	1397	1270233158000	28073	13639	103	0	\N
210638	1397	1270223157000	28073	13639	104	0	\N
210639	1397	1270213156000	28073	13639	105	0	\N
210640	1397	1270203155000	28073	13639	106	0	\N
210641	1397	1270193154000	28073	13639	107	0	\N
210642	1397	1270183153000	28073	13639	108	0	\N
210643	1397	1270173152000	28073	13639	109	0	\N
210644	1397	1270163151000	28073	13639	110	0	\N
210645	1397	1270153150000	28073	13639	111	0	\N
210646	1397	1270143149000	28073	13639	112	0	\N
210647	1397	1270133148000	28073	13639	113	0	\N
210648	1397	1270123147000	28073	13639	114	0	\N
210649	1397	1270113146000	28073	13639	115	0	\N
210650	1397	1270103145000	28073	13639	116	0	\N
210651	1397	1270093144000	28073	13639	117	0	\N
210652	1397	1270083143000	28073	13639	118	0	\N
210653	1397	1270073142000	28073	13639	119	0	\N
210654	1397	1270063141000	28073	13639	120	0	\N
210655	1397	1270053140000	28073	13639	121	0	\N
210656	1397	1270043139000	28073	13639	122	0	\N
210657	1397	1270033138000	28073	13639	123	0	\N
210658	1397	1270023137000	28073	13639	124	0	\N
210659	1397	1270013136000	28073	13639	125	0	\N
210660	1397	1268663001000	28074	13881	0	0	\N
210661	1397	1268653000000	28074	13881	1	0	\N
210662	1397	1268642999000	28074	13881	2	0	\N
210663	1397	1268632998000	28074	13881	3	0	\N
210664	1397	1268622997000	28074	13881	4	0	\N
210665	2133	89849348000	28074	13881	5	0	\N
210666	2133	89848346000	28074	13881	6	0	\N
210667	2133	89847344000	28074	13881	7	0	\N
210668	2133	89846342000	28074	13881	8	0	\N
210669	2133	89845340000	28074	13881	9	0	\N
210670	2134	83336328000	28074	13881	10	0	\N
210671	2134	83335325000	28074	13881	11	0	\N
210672	2134	83334322000	28074	13881	12	0	\N
210673	2134	83333319000	28074	13881	13	0	\N
210674	2134	83332316000	28074	13881	14	0	\N
210675	1397	1268663001000	28075	13881	0	0	\N
210676	1397	1268653000000	28075	13881	1	0	\N
210677	1397	1268642999000	28075	13881	2	0	\N
210678	1397	1268632998000	28075	13881	3	0	\N
210679	1397	1268622997000	28075	13881	4	0	\N
210680	2133	89849348000	28075	13881	5	0	\N
210681	2133	89848346000	28075	13881	6	0	\N
210682	2133	89847344000	28075	13881	7	0	\N
210683	2133	89846342000	28075	13881	8	0	\N
210684	2133	89845340000	28075	13881	9	0	\N
210685	1397	1268663001000	28076	13881	0	0	\N
210686	1397	1268653000000	28076	13881	1	0	\N
210687	1397	1268642999000	28076	13881	2	0	\N
210688	1397	1268632998000	28076	13881	3	0	\N
210689	1397	1268622997000	28076	13881	4	0	\N
210690	2133	89849348000	28076	13881	5	0	\N
210691	2133	89848346000	28076	13881	6	0	\N
210692	2133	89847344000	28076	13881	7	0	\N
210693	2133	89846342000	28076	13881	8	0	\N
210694	2133	89845340000	28076	13881	9	0	\N
210695	2134	83336328000	28076	13881	10	0	\N
210696	2134	83335325000	28076	13881	11	0	\N
210697	2134	83334322000	28076	13881	12	0	\N
210698	2134	83333319000	28076	13881	13	0	\N
210699	2134	83332316000	28076	13881	14	0	\N
210705	1726	936240112000	28078	13872	0	0	\N
210706	1397	1268663001000	28079	13882	0	0	\N
210707	1397	1268653000000	28079	13882	1	0	\N
210708	1397	1268642999000	28079	13882	2	0	\N
210709	1397	1268632998000	28079	13882	3	0	\N
210710	1397	1268622997000	28079	13882	4	0	\N
210711	1397	1268612996000	28079	13882	5	0	\N
210712	1397	1268602995000	28079	13882	6	0	\N
210713	1397	1268592994000	28079	13882	7	0	\N
210714	2133	89844338000	28079	13882	8	0	\N
210715	2133	89843336000	28079	13882	9	0	\N
210716	2133	89842334000	28079	13882	10	0	\N
210717	2134	83336328000	28079	13882	11	0	\N
210718	2134	83335325000	28079	13882	12	0	\N
210719	2134	83334322000	28079	13882	13	0	\N
210720	2134	83333319000	28079	13882	14	0	\N
210721	2134	83332316000	28079	13882	15	0	\N
210722	2134	83331313000	28079	13882	16	0	\N
210723	2134	83330310000	28079	13882	17	0	\N
210724	2134	83329307000	28079	13882	18	0	\N
210725	1397	1268663001000	28080	13882	0	0	\N
210726	1397	1268653000000	28080	13882	1	0	\N
210727	1397	1268642999000	28080	13882	2	0	\N
210728	1397	1268632998000	28080	13882	3	0	\N
210729	1397	1268622997000	28080	13882	4	0	\N
210730	1397	1268612996000	28080	13882	5	0	\N
210731	1397	1268602995000	28080	13882	6	0	\N
210732	1397	1268592994000	28080	13882	7	0	\N
210733	2133	89844338000	28080	13882	8	0	\N
210734	2133	89843336000	28080	13882	9	0	\N
210735	2133	89842334000	28080	13882	10	0	\N
210736	2134	83336328000	28080	13882	11	0	\N
210737	2134	83335325000	28080	13882	12	0	\N
210738	2134	83334322000	28080	13882	13	0	\N
210739	2134	83333319000	28080	13882	14	0	\N
210740	2134	83332316000	28080	13882	15	0	\N
210741	2134	83331313000	28080	13882	16	0	\N
210742	2134	83330310000	28080	13882	17	0	\N
210743	2134	83329307000	28080	13882	18	0	\N
210776	1397	1268542989000	28084	13885	0	0	\N
210777	1397	1268532988000	28084	13885	1	0	\N
210778	2133	89837324000	28084	13885	2	0	\N
210779	2133	89836322000	28084	13885	3	0	\N
210780	2134	83324292000	28084	13885	4	0	\N
210781	2134	83323289000	28084	13885	5	0	\N
210782	1397	1268542989000	28085	13885	0	0	\N
210783	1397	1268532988000	28085	13885	1	0	\N
210784	2133	89837324000	28085	13885	2	0	\N
210785	2133	89836322000	28085	13885	3	0	\N
210786	2134	83324292000	28085	13885	4	0	\N
210787	2134	83323289000	28085	13885	5	0	\N
210788	1397	1268542989000	28086	13885	0	0	\N
210789	1397	1268532988000	28086	13885	1	0	\N
210790	2133	89837324000	28086	13885	2	0	\N
210791	2133	89836322000	28086	13885	3	0	\N
210792	2134	83324292000	28086	13885	4	0	\N
210793	2134	83323289000	28086	13885	5	0	\N
210702	2133	89847344000	28077	13881	2	0	6830
210703	2133	89846342000	28077	13881	3	0	6831
210704	2133	89845340000	28077	13881	4	0	6832
210744	1397	1268663001000	28081	13882	0	0	17016
210745	1397	1268653000000	28081	13882	1	0	17017
210747	1397	1268632998000	28081	13882	3	0	17019
210748	1397	1268622997000	28081	13882	4	0	17020
210749	1397	1268612996000	28081	13882	5	0	17021
210750	1397	1268602995000	28081	13882	6	0	17022
210751	1397	1268592994000	28081	13882	7	0	17023
210753	2133	89843336000	28081	13882	9	0	6834
210754	2133	89842334000	28081	13882	10	0	6835
210755	2134	83336328000	28081	13882	11	0	7232
210756	2134	83335325000	28081	13882	12	0	7233
210758	2134	83333319000	28081	13882	14	0	7235
210759	2134	83332316000	28081	13882	15	0	7236
210760	2134	83331313000	28081	13882	16	0	7237
210761	2134	83330310000	28081	13882	17	0	7238
210762	2134	83329307000	28081	13882	18	0	7239
210764	2134	83328304000	28082	13883	1	0	7240
210765	2133	89841332000	28082	13883	2	0	6836
210766	1397	1268572992000	28083	13884	0	0	17025
210767	1397	1268562991000	28083	13884	1	0	17026
210768	1397	1268552990000	28083	13884	2	0	17027
210770	2134	83327301000	28083	13884	5	0	7241
210771	2133	89839328000	28083	13884	6	0	6838
210772	2133	89838326000	28083	13884	7	0	6839
210773	2132	147266279000	28083	13884	8	0	1722
210775	2134	83325295000	28083	13884	10	0	7243
210794	1397	1268542989000	28087	13885	0	0	17028
210795	1397	1268532988000	28087	13885	1	0	17029
210796	2133	89837324000	28087	13885	2	0	6840
210797	2133	89836322000	28087	13885	3	0	6841
210799	2134	83323289000	28087	13885	5	0	7245
210800	1397	1268522987000	28088	13886	0	0	17030
210804	1397	1268522987000	28089	13886	0	0	\N
210805	2134	83322286000	28089	13886	1	0	\N
210806	2132	147265278000	28089	13886	2	0	\N
210807	2133	89835320000	28089	13886	3	0	\N
210808	1397	1268522987000	28090	13886	0	0	\N
210809	2134	83322286000	28090	13886	1	0	\N
210810	2132	147265278000	28090	13886	2	0	\N
210811	2133	89835320000	28090	13886	3	0	\N
210812	1397	1268512986000	28091	13887	0	0	\N
210813	2134	83321283000	28091	13887	1	0	\N
210814	2133	89834318000	28091	13887	2	0	\N
210818	1397	1268512986000	28093	13887	0	0	\N
210819	2134	83321283000	28093	13887	1	0	\N
210820	2133	89834318000	28093	13887	2	0	\N
210821	1397	1268512986000	28094	13887	0	0	\N
210822	2134	83321283000	28094	13887	1	0	\N
210823	2133	89834318000	28094	13887	2	0	\N
210831	1397	1268492984000	28097	13889	0	0	\N
210832	2134	83319277000	28097	13889	1	0	\N
210833	2132	147264277000	28097	13889	2	0	\N
210834	2133	89832314000	28097	13889	3	0	\N
210835	1397	1268482983000	28098	13890	0	0	\N
210836	1397	1268472982000	28098	13890	1	0	\N
210837	1397	1268462981000	28098	13890	2	0	\N
210838	2134	83318274000	28098	13890	3	0	\N
210839	2133	89831312000	28098	13890	4	0	\N
210840	2132	147263276000	28098	13890	5	0	\N
210841	2133	89830310000	28098	13890	6	0	\N
210842	2133	89829308000	28098	13890	7	0	\N
210843	2134	83317271000	28098	13890	8	0	\N
210844	2134	83316268000	28098	13890	9	0	\N
210855	1397	1268482983000	28100	13890	0	0	\N
210856	1397	1268472982000	28100	13890	1	0	\N
210857	1397	1268462981000	28100	13890	2	0	\N
210858	2134	83318274000	28100	13890	3	0	\N
210859	2133	89831312000	28100	13890	4	0	\N
210860	2132	147263276000	28100	13890	5	0	\N
210861	2133	89830310000	28100	13890	6	0	\N
210862	2133	89829308000	28100	13890	7	0	\N
210863	2134	83317271000	28100	13890	8	0	\N
210864	2134	83316268000	28100	13890	9	0	\N
210868	1397	1268452980000	28102	13891	0	0	\N
210869	2134	83315265000	28102	13891	1	0	\N
210870	2133	89828306000	28102	13891	2	0	\N
210874	1474	24290633000043	28104	13758	0	0	\N
210875	2199	720328000000	28104	13758	1	0	\N
210876	1397	1270433178000	28104	13758	2	0	\N
210877	1397	1270423177000	28104	13758	3	0	\N
210878	1397	1270413176000	28104	13758	4	0	\N
210879	1397	1270403175000	28104	13758	5	0	\N
210880	1397	1270393174000	28104	13758	6	0	\N
210881	1397	1270383173000	28104	13758	7	0	\N
210882	1397	1270373172000	28104	13758	8	0	\N
210883	1397	1270363171000	28104	13758	9	0	\N
210884	1397	1270353170000	28104	13758	10	0	\N
210885	1397	1270343169000	28104	13758	11	0	\N
210886	1397	1270333168000	28104	13758	12	0	\N
210887	1397	1270323167000	28104	13758	13	0	\N
210888	1397	1270313166000	28104	13758	14	0	\N
210889	1397	1270303165000	28104	13758	15	0	\N
210890	1397	1270293164000	28104	13758	16	0	\N
210891	1397	1270283163000	28104	13758	17	0	\N
210892	1397	1270273162000	28104	13758	18	0	\N
210893	1397	1270263161000	28104	13758	19	0	\N
210894	1397	1270253160000	28104	13758	20	0	\N
210895	1397	1270243159000	28104	13758	21	0	\N
210896	1397	1270233158000	28104	13758	22	0	\N
210897	1397	1270223157000	28104	13758	23	0	\N
210898	1397	1270213156000	28104	13758	24	0	\N
210899	1397	1270203155000	28104	13758	25	0	\N
210900	1397	1270193154000	28104	13758	26	0	\N
210901	1397	1270183153000	28104	13758	27	0	\N
210902	1397	1270173152000	28104	13758	28	0	\N
210903	1397	1270163151000	28104	13758	29	0	\N
210904	1397	1270153150000	28104	13758	30	0	\N
210905	1397	1270143149000	28104	13758	31	0	\N
210906	1397	1270133148000	28104	13758	32	0	\N
210907	1397	1270123147000	28104	13758	33	0	\N
210908	1397	1270113146000	28104	13758	34	0	\N
210909	1397	1270103145000	28104	13758	35	0	\N
210910	1397	1270093144000	28104	13758	36	0	\N
210911	1397	1270083143000	28104	13758	37	0	\N
210912	1397	1270073142000	28104	13758	38	0	\N
210913	1397	1270063141000	28104	13758	39	0	\N
210914	1397	1270053140000	28104	13758	40	0	\N
210915	1397	1270043139000	28104	13758	41	0	\N
210916	1397	1270033138000	28104	13758	42	0	\N
210917	1397	1270023137000	28104	13758	43	0	\N
210918	1397	1270013136000	28104	13758	44	0	\N
210919	1397	1270003135000	28104	13758	45	0	\N
210920	1397	1269993134000	28104	13758	46	0	\N
210921	1397	1269983133000	28104	13758	47	0	\N
210922	1397	1269973132000	28104	13758	48	0	\N
210923	1397	1269963131000	28104	13758	49	0	\N
210924	1397	1269953130000	28104	13758	50	0	\N
210925	1397	1269943129000	28104	13758	51	0	\N
210926	1397	1269933128000	28104	13758	52	0	\N
210927	1397	1269923127000	28104	13758	53	0	\N
210928	1397	1269913126000	28104	13758	54	0	\N
210929	1397	1269903125000	28104	13758	55	0	\N
210930	1397	1269893124000	28104	13758	56	0	\N
210931	1397	1269883123000	28104	13758	57	0	\N
210932	1397	1269873122000	28104	13758	58	0	\N
210933	1397	1269863121000	28104	13758	59	0	\N
210934	1397	1269853120000	28104	13758	60	0	\N
210935	1397	1269843119000	28104	13758	61	0	\N
210936	1397	1269833118000	28104	13758	62	0	\N
210803	2133	89835320000	28088	13886	3	0	6842
210815	1397	1268512986000	28092	13887	0	0	17031
210816	2134	83321283000	28092	13887	1	0	7247
210817	2133	89834318000	28092	13887	2	0	6843
210824	1397	1268502985000	28095	13888	0	0	17032
210826	2134	83320280000	28095	13888	2	0	7248
210827	1397	1268492984000	28096	13889	0	0	17033
210828	2134	83319277000	28096	13889	1	0	7249
210829	2132	147264277000	28096	13889	2	0	1724
210830	2133	89832314000	28096	13889	3	0	6845
210846	1397	1268472982000	28099	13890	1	0	17035
210847	1397	1268462981000	28099	13890	2	0	17036
210848	2134	83318274000	28099	13890	3	0	7250
210849	2133	89831312000	28099	13890	4	0	6846
210851	2133	89830310000	28099	13890	6	0	6847
210852	2133	89829308000	28099	13890	7	0	6848
210853	2134	83317271000	28099	13890	8	0	7251
210854	2134	83316268000	28099	13890	9	0	7252
210865	1397	1268452980000	28101	13891	0	0	17037
210867	2133	89828306000	28101	13891	2	0	6849
210871	1397	1268442979000	28103	13892	0	0	17038
210872	2134	83314262000	28103	13892	1	0	7254
210873	2133	89827304000	28103	13892	2	0	6850
210937	1397	1269823117000	28104	13758	64	0	\N
210938	1397	1269813116000	28104	13758	65	0	\N
210939	1397	1269803115000	28104	13758	66	0	\N
210940	1397	1269793114000	28104	13758	67	0	\N
210941	1397	1269783113000	28104	13758	68	0	\N
210942	1397	1269773112000	28104	13758	69	0	\N
210943	1397	1269763111000	28104	13758	70	0	\N
210944	1397	1269753110000	28104	13758	71	0	\N
210945	1397	1269743109000	28104	13758	72	0	\N
210946	1397	1269733108000	28104	13758	73	0	\N
210947	1397	1269723107000	28104	13758	74	0	\N
210948	1397	1269713106000	28104	13758	75	0	\N
210949	1397	1269703105000	28104	13758	76	0	\N
210950	1397	1269693104000	28104	13758	77	0	\N
210951	1397	1269683103000	28104	13758	78	0	\N
210952	1397	1269673102000	28104	13758	79	0	\N
210953	1397	1269663101000	28104	13758	80	0	\N
210954	1397	1269653100000	28104	13758	81	0	\N
210955	1397	1269643099000	28104	13758	82	0	\N
210956	1397	1269633098000	28104	13758	83	0	\N
210957	1397	1269623097000	28104	13758	84	0	\N
210958	1397	1269613096000	28104	13758	85	0	\N
210959	1397	1269603095000	28104	13758	86	0	\N
210960	1397	1269593094000	28104	13758	87	0	\N
210961	1397	1269583093000	28104	13758	88	0	\N
210962	1397	1269573092000	28104	13758	89	0	\N
210963	1397	1269563091000	28104	13758	90	0	\N
210964	1397	1269553090000	28104	13758	91	0	\N
210965	1397	1269543089000	28104	13758	92	0	\N
210966	1397	1269533088000	28104	13758	93	0	\N
210967	1397	1269523087000	28104	13758	94	0	\N
210968	1397	1269513086000	28104	13758	95	0	\N
210969	1397	1269503085000	28104	13758	96	0	\N
210970	1397	1269493084000	28104	13758	97	0	\N
210971	1397	1269483083000	28104	13758	98	0	\N
210972	1397	1269473082000	28104	13758	99	0	\N
210973	1397	1269463081000	28104	13758	100	0	\N
210974	1397	1269453080000	28104	13758	101	0	\N
210975	1397	1269443079000	28104	13758	102	0	\N
210976	1397	1269433078000	28104	13758	103	0	\N
210977	1397	1269423077000	28104	13758	104	0	\N
210978	1397	1269413076000	28104	13758	105	0	\N
210979	1397	1269403075000	28104	13758	106	0	\N
210980	1397	1269393074000	28104	13758	107	0	\N
210981	1397	1269383073000	28104	13758	108	0	\N
210982	1397	1269373072000	28104	13758	109	0	\N
210983	1397	1269363071000	28104	13758	110	0	\N
210984	1397	1269353070000	28104	13758	111	0	\N
210985	1397	1269343069000	28104	13758	112	0	\N
210986	1397	1269333068000	28104	13758	113	0	\N
210987	1397	1269323067000	28104	13758	114	0	\N
210988	1397	1269313066000	28104	13758	115	0	\N
210989	1397	1269303065000	28104	13758	116	0	\N
210990	1397	1269293064000	28104	13758	117	0	\N
210991	1397	1269283063000	28104	13758	118	0	\N
210992	1397	1269273062000	28104	13758	119	0	\N
210993	1397	1269263061000	28104	13758	120	0	\N
210994	1397	1269253060000	28104	13758	121	0	\N
210995	1397	1269243059000	28104	13758	122	0	\N
210996	1397	1269233058000	28104	13758	123	0	\N
210997	1397	1269223057000	28104	13758	124	0	\N
210998	1397	1269213056000	28104	13758	125	0	\N
210999	1397	1268432978000	28105	13893	0	0	\N
211000	1397	1268422977000	28105	13893	1	0	\N
211001	2134	83313259000	28105	13893	2	0	\N
211002	2132	147262275000	28105	13893	3	0	\N
211003	2133	89826302000	28105	13893	4	0	\N
211004	2133	89825300000	28105	13893	5	0	\N
211005	2134	83312256000	28105	13893	6	0	\N
211013	1397	1268412976000	28107	13894	0	0	\N
211014	2133	89824298000	28107	13894	1	0	\N
211015	2134	83311253000	28107	13894	2	0	\N
211016	1397	1268412976000	28108	13894	0	0	\N
211017	2133	89824298000	28108	13894	1	0	\N
211018	2134	83311253000	28108	13894	2	0	\N
211029	1397	1268402975000	28111	13895	0	0	\N
211030	1397	1268392974000	28111	13895	1	0	\N
211031	2134	83310250000	28111	13895	2	0	\N
211032	2134	83309247000	28111	13895	3	0	\N
211033	2133	89823296000	28111	13895	4	0	\N
211034	2132	147261274000	28111	13895	5	0	\N
211035	2133	89822294000	28111	13895	6	0	\N
211047	1397	1268372972000	28114	13897	0	0	\N
211048	1397	1268362971000	28114	13897	1	0	\N
211049	2133	89820290000	28114	13897	2	0	\N
211050	2132	147260273000	28114	13897	3	0	\N
211051	2133	89819288000	28114	13897	4	0	\N
211052	2134	83307241000	28114	13897	5	0	\N
211053	2134	83306238000	28114	13897	6	0	\N
211063	1397	1268332968000	28117	13899	0	0	\N
211064	2133	89816282000	28117	13899	1	0	\N
211065	2134	83303229000	28117	13899	2	0	\N
211008	2134	83313259000	28106	13893	2	0	7255
211009	2132	147262275000	28106	13893	3	0	1726
211010	2133	89826302000	28106	13893	4	0	6851
211011	2133	89825300000	28106	13893	5	0	6852
211012	2134	83312256000	28106	13893	6	0	7256
211020	2133	89824298000	28109	13894	1	0	6853
211021	2134	83311253000	28109	13894	2	0	7257
211022	1397	1268402975000	28110	13895	0	0	17042
211023	1397	1268392974000	28110	13895	1	0	17043
211024	2134	83310250000	28110	13895	2	0	7258
211026	2133	89823296000	28110	13895	4	0	6854
211027	2132	147261274000	28110	13895	5	0	1727
211028	2133	89822294000	28110	13895	6	0	6855
211036	1397	1268382973000	28112	13896	0	0	17044
211038	2133	89821292000	28112	13896	2	0	6856
211039	2134	83308244000	28112	13896	3	0	7260
211040	1397	1268372972000	28113	13897	0	0	17045
211041	1397	1268362971000	28113	13897	1	0	17046
211042	2133	89820290000	28113	13897	2	0	6857
211044	2133	89819288000	28113	13897	4	0	6858
211045	2134	83307241000	28113	13897	5	0	7261
211046	2134	83306238000	28113	13897	6	0	7262
211054	1397	1268352970000	28115	13898	0	0	17047
211055	1397	1268342969000	28115	13898	1	0	17048
211057	2134	83305235000	28115	13898	3	0	7263
211058	2134	83304232000	28115	13898	4	0	7264
211059	2133	89817284000	28115	13898	5	0	6860
211060	1397	1268332968000	28116	13899	0	0	17049
211062	2134	83303229000	28116	13899	2	0	7265
211066	1397	1268322967000	28118	13900	0	0	17050
211067	2134	83302226000	28118	13900	1	0	7266
211068	2132	147259272000	28118	13900	2	0	1729
211069	2133	89815280000	28118	13900	3	0	6862
211071	1464	14000000	28119	13901	1	0	2
211072	2134	83301223000	28119	13901	2	0	7267
211078	1397	1268282963000	28121	13903	0	0	\N
211079	2134	83298214000	28121	13903	1	0	\N
211080	1397	1268282963000	28122	13903	0	0	\N
211081	2134	83298214000	28122	13903	1	0	\N
211082	1397	1268282963000	28123	13903	0	0	\N
211083	2134	83298214000	28123	13903	1	0	\N
211084	1397	1268282963000	28124	13903	0	0	\N
211085	2134	83298214000	28124	13903	1	0	\N
211088	1397	1268282963000	28126	13903	0	0	\N
211089	2134	83298214000	28126	13903	1	0	\N
211090	1397	1268272962000	28127	13904	0	0	\N
211091	2134	83297211000	28127	13904	1	0	\N
211092	1397	1268272962000	28128	13904	0	0	\N
211094	1397	1268272962000	28130	13904	0	0	\N
211095	2134	83297211000	28131	13905	0	0	\N
211096	2132	147257270000	28131	13905	1	0	\N
211100	1397	1268252960000	28133	13906	0	0	\N
211101	96	66001212000000	28133	13906	1	0	\N
211102	2134	83296208000	28133	13906	2	0	\N
211103	1397	1268252960000	28134	13906	0	0	\N
211104	96	66001212000000	28134	13906	1	0	\N
211105	2134	83296208000	28134	13906	2	0	\N
211120	1397	1268202955000	28140	13911	0	0	\N
211121	2134	83291193000	28140	13911	1	0	\N
211124	1397	1268202955000	28142	13911	0	0	\N
211125	2134	83291193000	28142	13911	1	0	\N
211137	96	66001212000000	28146	13873	0	0	\N
211138	1464	2158024000000	28146	13873	1	0	\N
211139	1464	14000000	28146	13873	2	0	\N
211140	1726	935139112000	28146	13873	3	0	\N
211141	1726	934038112000	28146	13873	4	0	\N
211142	2132	147266279000	28146	13873	5	0	\N
211143	2132	147265278000	28146	13873	6	0	\N
211144	2132	147264277000	28146	13873	7	0	\N
211145	2132	147263276000	28146	13873	8	0	\N
211146	2132	147262275000	28146	13873	9	0	\N
211147	2132	147261274000	28146	13873	10	0	\N
211148	2132	147260273000	28146	13873	11	0	\N
211149	2132	147259272000	28146	13873	12	0	\N
211150	2132	147258271000	28146	13873	13	0	\N
211151	2132	147257270000	28146	13873	14	0	\N
211152	2132	147256269000	28146	13873	15	0	\N
211153	2132	147255268000	28146	13873	16	0	\N
211154	2132	147254267000	28146	13873	17	0	\N
211175	2132	147253266000	28154	13874	0	0	\N
211176	2132	147252265000	28154	13874	1	0	\N
211177	2132	147251264000	28154	13874	2	0	\N
211195	1397	1267992934000	28158	13925	0	0	\N
211196	1397	1267982933000	28158	13925	1	0	\N
211197	1397	1267972932000	28158	13925	2	0	\N
211198	2134	83270130000	28158	13925	3	0	\N
211199	2134	83269127000	28158	13925	4	0	\N
211200	2134	83268124000	28158	13925	5	0	\N
211201	2132	147249262000	28158	13925	6	0	\N
211202	1397	1267992934000	28159	13925	0	0	\N
211203	1397	1267982933000	28159	13925	1	0	\N
211204	1397	1267972932000	28159	13925	2	0	\N
211205	2134	83270130000	28159	13925	3	0	\N
211206	2134	83269127000	28159	13925	4	0	\N
211207	2134	83268124000	28159	13925	5	0	\N
211208	2132	147249262000	28159	13925	6	0	\N
211075	2132	147258271000	28120	13902	2	0	1730
211076	2134	83300220000	28120	13902	3	0	7268
211077	2134	83299217000	28120	13902	5	0	7269
211086	1397	1268282963000	28125	13903	0	0	17054
211087	2134	83298214000	28125	13903	1	0	7270
211097	1397	1268262961000	28132	13905	0	0	17056
211098	2134	83297211000	28132	13905	1	0	7271
211099	2132	147257270000	28132	13905	2	0	1731
211106	1397	1268252960000	28135	13906	0	0	17057
211107	96	66001212000000	28135	13906	1	0	1
211109	1397	1268242959000	28136	13907	0	0	17058
211110	2134	83295205000	28136	13907	1	0	7273
211111	1726	935139112000	28136	13907	2	0	8346
211112	1726	934038112000	28136	13907	3	0	8347
211114	2134	83294202000	28137	13908	1	0	7274
211115	1397	1268222957000	28138	13909	0	0	17060
211116	2134	83293199000	28138	13909	1	0	7275
211117	2132	147256269000	28138	13909	2	0	1732
211118	1397	1268212956000	28139	13910	0	0	17061
211122	1397	1268202955000	28141	13911	0	0	17062
211123	2134	83291193000	28141	13911	1	0	7277
211126	1397	1268192954000	28143	13912	0	0	17063
211127	1397	1268182953000	28143	13912	1	0	17064
211128	2394	1438994500000	28143	13912	2	0	1
211130	2134	83290190000	28143	13912	4	0	7278
211131	2134	83289187000	28143	13912	5	0	7279
211132	1397	1268172952000	28144	13913	0	0	17065
211133	2134	83288184000	28144	13913	1	0	7280
211135	2132	147254267000	28145	13914	1	0	1734
211136	2134	83287181000	28145	13914	2	0	7281
211155	1397	1268152950000	28147	13915	0	0	17067
211156	2134	83286178000	28147	13915	1	0	7282
211157	1397	1268142949000	28148	13916	0	0	17068
211159	1397	1268132948000	28149	13917	0	0	17069
211160	2134	83284172000	28149	13917	1	0	7284
211161	1397	1268122947000	28150	13918	0	0	17070
211162	1397	1268112946000	28150	13918	1	0	17071
211163	2132	147253266000	28150	13918	2	0	1735
211165	2134	83282166000	28150	13918	4	0	7286
211166	1397	1268102945000	28151	13919	0	0	17072
211167	2134	83281163000	28151	13919	1	0	7287
211168	1397	1268092944000	28152	13920	0	0	17073
211170	2134	83280160000	28152	13920	2	0	7288
211171	2132	147252265000	28152	13920	3	0	1736
211172	2134	83279157000	28152	13920	4	0	7289
211173	1397	1268072942000	28153	13921	0	0	17075
211174	2134	83278154000	28153	13921	1	0	7290
211179	2134	83277151000	28155	13922	1	0	7291
211180	2132	147251264000	28155	13922	2	0	1737
211181	1397	1268052940000	28156	13923	0	0	17077
211182	1397	1268042939000	28156	13923	1	0	17078
211183	1397	1268032938000	28156	13923	2	0	17079
211185	2132	147250263000	28156	13923	4	0	1738
211186	2134	83276148000	28156	13923	5	0	7292
211187	2134	83275145000	28156	13923	6	0	7293
211188	2358	50099000000	28156	13923	7	0	1
211190	2134	83273139000	28156	13923	9	0	7295
211191	1397	1268012936000	28157	13924	0	0	17081
211192	1397	1268002935000	28157	13924	1	0	17082
211193	2134	83272136000	28157	13924	2	0	7296
211194	2134	83271133000	28157	13924	3	0	7297
211209	1397	1267992934000	28160	13925	0	0	\N
211210	1397	1267982933000	28160	13925	1	0	\N
211211	1397	1267972932000	28160	13925	2	0	\N
211212	2134	83270130000	28160	13925	3	0	\N
211213	2134	83269127000	28160	13925	4	0	\N
211214	2134	83268124000	28160	13925	5	0	\N
211215	2132	147249262000	28160	13925	6	0	\N
211223	1397	1267992934000	28162	13925	0	0	\N
211224	1397	1267982933000	28162	13925	1	0	\N
211225	1397	1267972932000	28162	13925	2	0	\N
211226	2134	83270130000	28162	13925	3	0	\N
211227	2134	83269127000	28162	13925	4	0	\N
211228	2134	83268124000	28162	13925	5	0	\N
211229	2132	147249262000	28162	13925	6	0	\N
211230	1397	1267992934000	28163	13925	0	0	\N
211231	1397	1267982933000	28163	13925	1	0	\N
211232	1397	1267972932000	28163	13925	2	0	\N
211233	2134	83270130000	28163	13925	3	0	\N
211234	2134	83269127000	28163	13925	4	0	\N
211235	2134	83268124000	28163	13925	5	0	\N
211236	2132	147249262000	28163	13925	6	0	\N
211240	1397	1267952930000	28165	13927	0	0	\N
211241	2134	83266118000	28165	13927	1	0	\N
211242	1397	1267952930000	28166	13927	0	0	\N
211243	2134	83266118000	28166	13927	1	0	\N
211244	1397	1267952930000	28167	13927	0	0	\N
211245	2134	83266118000	28167	13927	1	0	\N
211246	96	66001212000000	28169	13846	0	0	\N
211247	1464	2158024000000	28169	13846	1	0	\N
211248	1464	14000000	28169	13846	2	0	\N
211249	1726	936240112000	28169	13846	3	0	\N
211250	1726	935139112000	28169	13846	4	0	\N
211251	1726	934038112000	28169	13846	5	0	\N
211252	2388	99000000	28169	13846	6	0	\N
211253	2358	50099000000	28169	13846	7	0	\N
211254	2132	147266279000	28169	13846	8	0	\N
211255	2132	147265278000	28169	13846	9	0	\N
211256	2132	147264277000	28169	13846	10	0	\N
211257	2132	147263276000	28169	13846	11	0	\N
211258	2132	147262275000	28169	13846	12	0	\N
211259	2132	147261274000	28169	13846	13	0	\N
211260	2132	147260273000	28169	13846	14	0	\N
211261	2132	147259272000	28169	13846	15	0	\N
211262	2132	147258271000	28169	13846	16	0	\N
211263	2132	147257270000	28169	13846	17	0	\N
211264	2132	147256269000	28169	13846	18	0	\N
211265	2132	147255268000	28169	13846	19	0	\N
211266	2132	147254267000	28169	13846	20	0	\N
211267	2132	147253266000	28169	13846	21	0	\N
211268	2132	147252265000	28169	13846	22	0	\N
211269	2132	147251264000	28169	13846	23	0	\N
211270	2132	147250263000	28169	13846	24	0	\N
211271	2132	147249262000	28169	13846	25	0	\N
211272	2132	147248261000	28169	13846	26	0	\N
211275	2132	147250263000	28171	13875	0	0	\N
211276	2132	147249262000	28171	13875	1	0	\N
211277	2358	50099000000	28171	13875	2	0	\N
211278	2132	147248261000	28171	13875	3	0	\N
211279	1397	1267942929000	28172	13928	0	0	\N
211280	1397	1267932928000	28172	13928	1	0	\N
211281	1397	1267922927000	28172	13928	2	0	\N
211282	2134	83265115000	28172	13928	3	0	\N
211283	2134	83264112000	28172	13928	4	0	\N
211284	2134	83263109000	28172	13928	5	0	\N
211285	2132	147247260000	28172	13928	6	0	\N
211295	1397	1267912926000	28175	13929	0	0	\N
211296	2134	83262106000	28175	13929	1	0	\N
211297	1397	1267912926000	28176	13929	0	0	\N
211298	2134	83262106000	28176	13929	1	0	\N
211299	1397	1267912926000	28177	13929	0	0	\N
211300	2134	83262106000	28177	13929	1	0	\N
211301	1397	1267912926000	28178	13929	0	0	\N
211302	2134	83262106000	28178	13929	1	0	\N
211303	1397	1267912926000	28179	13929	0	0	\N
211304	2134	83262106000	28179	13929	1	0	\N
211313	1397	1267872922000	28182	13932	0	0	\N
211314	2132	147245258000	28182	13932	1	0	\N
211315	2134	83257091000	28182	13932	2	0	\N
211316	1397	1267872922000	28183	13932	0	0	\N
211317	2132	147245258000	28183	13932	1	0	\N
211318	2134	83257091000	28183	13932	2	0	\N
211319	1397	1267872922000	28184	13932	0	0	\N
211320	2132	147245258000	28184	13932	1	0	\N
211321	2134	83257091000	28184	13932	2	0	\N
211325	1397	1267872922000	28186	13932	0	0	\N
211326	2132	147245258000	28186	13932	1	0	\N
211327	2134	83257091000	28186	13932	2	0	\N
211337	1397	1267842919000	28190	13935	0	0	\N
211338	1397	1267832918000	28190	13935	1	0	\N
211339	2134	83254082000	28190	13935	2	0	\N
211340	2134	83253079000	28190	13935	3	0	\N
211341	2132	147244257000	28190	13935	4	0	\N
211342	2132	147247260000	28191	13876	0	0	\N
211343	2132	147246259000	28191	13876	1	0	\N
211344	2132	147245258000	28191	13876	2	0	\N
211218	1397	1267972932000	28161	13925	2	0	17085
211219	2134	83270130000	28161	13925	3	0	7298
211220	2134	83269127000	28161	13925	4	0	7299
211221	2134	83268124000	28161	13925	5	0	7300
211222	2132	147249262000	28161	13925	6	0	1739
211238	2134	83267121000	28164	13926	2	0	7301
211239	2132	147248261000	28164	13926	3	0	1740
211273	1397	1267952930000	28170	13927	0	0	17087
211274	2134	83266118000	28170	13927	1	0	7302
211286	1397	1267942929000	28173	13928	0	0	17088
211288	1397	1267922927000	28173	13928	2	0	17090
211289	2134	83265115000	28173	13928	3	0	7303
211290	2134	83264112000	28173	13928	4	0	7304
211291	2134	83263109000	28173	13928	5	0	7305
211293	1397	1267912926000	28174	13929	0	0	17091
211294	2134	83262106000	28174	13929	1	0	7306
211305	1397	1267902925000	28180	13930	0	0	17092
211306	1397	1267892924000	28180	13930	1	0	17093
211307	2132	147246259000	28180	13930	2	0	1742
211309	2134	83260100000	28180	13930	4	0	7308
211310	2134	83259097000	28180	13930	5	0	7309
211311	1397	1267882923000	28181	13931	0	0	17094
211312	2134	83258094000	28181	13931	1	0	7310
211322	1397	1267872922000	28185	13932	0	0	17095
211324	2134	83257091000	28185	13932	2	0	7311
211328	1397	1267862921000	28187	13933	0	0	17096
211329	2134	83256088000	28187	13933	1	0	7312
211330	1397	1267852920000	28188	13934	0	0	17097
211332	1397	1267842919000	28189	13935	0	0	17098
211333	1397	1267832918000	28189	13935	1	0	17099
211334	2134	83254082000	28189	13935	2	0	7314
211335	2134	83253079000	28189	13935	3	0	7315
211336	2132	147244257000	28189	13935	4	0	1744
211345	2132	147244257000	28191	13876	3	0	\N
211363	1397	1267762911000	28200	13942	0	0	\N
211364	2134	83246058000	28200	13942	1	0	\N
211366	2134	83245055000	28202	13943	0	0	\N
211367	2134	83245055000	28203	13943	0	0	\N
211373	1397	1267722907000	28205	13945	0	0	\N
211374	2134	83242046000	28205	13945	1	0	\N
211375	1397	1267722907000	28206	13945	0	0	\N
211376	2134	83242046000	28206	13945	1	0	\N
211384	1397	1267702905000	28210	13947	0	0	\N
211385	2132	147240253000	28210	13947	1	0	\N
211386	2134	83240040000	28210	13947	2	0	\N
211391	1397	1267682903000	28213	13949	0	0	\N
211392	2134	83238034000	28213	13949	1	0	\N
211402	1397	1267652900000	28217	13952	0	0	\N
211403	2394	1438974500000	28217	13952	1	0	\N
211404	2134	83235025000	28217	13952	3	0	\N
211405	1397	1267652900000	28218	13952	0	0	\N
211406	2394	1438974500000	28218	13952	1	0	\N
211407	2134	83235025000	28218	13952	3	0	\N
211410	1397	1267642899000	28220	13953	0	0	\N
211411	2134	83234022000	28220	13953	1	0	\N
211412	1397	1267642899000	28221	13953	0	0	\N
211413	2134	83234022000	28221	13953	1	0	\N
211414	1397	1267642899000	28222	13953	0	0	\N
211415	2134	83234022000	28222	13953	1	0	\N
211419	2394	1438984500000	28225	13932	0	0	\N
211420	2394	1438974500000	28225	13932	1	0	\N
211423	1397	1267612896000	28227	13956	0	0	\N
211424	2134	83231013000	28227	13956	1	0	\N
211436	1397	1267592894000	28231	13958	0	0	\N
211437	1397	1267582893000	28231	13958	1	0	\N
211438	2134	83229007000	28231	13958	2	0	\N
211439	1769	1568700000	28231	13958	3	0	\N
211440	2134	83228004000	28231	13958	4	0	\N
211441	1769	1567700000	28231	13958	5	0	\N
211442	1397	1267592894000	28232	13958	0	0	\N
211443	1397	1267582893000	28232	13958	1	0	\N
211444	2134	83229007000	28232	13958	2	0	\N
211445	1769	1568700000	28232	13958	3	0	\N
211446	2134	83228004000	28232	13958	4	0	\N
211447	1769	1567700000	28232	13958	5	0	\N
211448	1397	1267592894000	28233	13958	0	0	\N
211449	1397	1267582893000	28233	13958	1	0	\N
211450	2134	83229007000	28233	13958	2	0	\N
211451	1769	1568700000	28233	13958	3	0	\N
211452	2134	83228004000	28233	13958	4	0	\N
211453	1769	1567700000	28233	13958	5	0	\N
211461	1397	1267552890000	28237	13961	0	0	\N
211462	2134	83224995000	28237	13961	1	0	\N
211463	2394	1438984500000	28238	13943	0	0	\N
211464	2394	1438974500000	28238	13943	1	0	\N
211465	1769	1568700000	28238	13943	2	0	\N
211466	1769	1567700000	28238	13943	3	0	\N
211467	1397	1267552890000	28239	13961	0	0	\N
211468	2134	83224995000	28239	13961	1	0	\N
211471	1397	1267542889000	28241	13962	0	0	\N
211472	2134	83223992000	28241	13962	1	0	\N
211476	1397	1267522887000	28243	13964	0	0	\N
211477	2134	83221986000	28243	13964	1	0	\N
211348	1397	1267812916000	28194	13937	0	0	17101
211349	2134	83251073000	28194	13937	1	0	7317
211350	1397	1267802915000	28195	13938	0	0	17102
211351	2132	147243256000	28195	13938	1	0	1745
211352	2134	83250070000	28195	13938	2	0	7318
211354	2134	83249067000	28196	13939	1	0	7319
211355	1397	1267782913000	28197	13940	0	0	17104
211356	2134	83248064000	28197	13940	1	0	7320
211357	1397	1267772912000	28198	13941	0	0	17105
211358	2132	147242255000	28198	13941	1	0	1746
211360	1397	1267762911000	28199	13942	0	0	17106
211361	1397	1267752910000	28199	13942	1	0	17107
211362	2134	83246058000	28199	13942	2	0	7322
211365	2134	83245055000	28201	13943	0	0	7323
211369	1397	1267732908000	28204	13944	1	0	17109
211370	2134	83244052000	28204	13944	2	0	7324
211371	2134	83243049000	28204	13944	3	0	7325
211372	2132	147241254000	28204	13944	4	0	1747
211377	1397	1267722907000	28207	13945	0	0	17110
211379	1397	1267712906000	28208	13946	0	0	17111
211380	2134	83241043000	28208	13946	1	0	7327
211381	1397	1267702905000	28209	13947	0	0	17112
211382	2132	147240253000	28209	13947	1	0	1748
211383	2134	83240040000	28209	13947	2	0	7328
211388	2134	83239037000	28211	13948	1	0	7329
211389	1397	1267682903000	28212	13949	0	0	17114
211390	2134	83238034000	28212	13949	1	0	7330
211393	1397	1267672902000	28214	13950	0	0	17115
211395	2134	83237031000	28214	13950	2	0	7331
211396	2394	1438984500000	28215	13951	0	0	2
211397	1397	1267662901000	28215	13951	1	0	17116
211398	2134	83236028000	28215	13951	2	0	7332
211399	1397	1267652900000	28216	13952	0	0	17117
211401	2134	83235025000	28216	13952	3	0	7333
211408	1397	1267642899000	28219	13953	0	0	17118
211409	2134	83234022000	28219	13953	1	0	7334
211416	1397	1267632898000	28224	13954	0	0	17119
211417	2134	83233019000	28224	13954	1	0	7335
211421	1397	1267622897000	28226	13955	0	0	17120
211422	2134	83232016000	28226	13955	1	0	7336
211425	1397	1267612896000	28228	13956	0	0	17121
211426	2134	83231013000	28228	13956	1	0	7337
211428	2134	83230010000	28229	13957	1	0	7338
211429	2132	147237250000	28229	13957	2	0	1751
211430	1397	1267592894000	28230	13958	0	0	17123
211431	1397	1267582893000	28230	13958	1	0	17124
211432	2134	83229007000	28230	13958	2	0	7339
211434	2134	83228004000	28230	13958	4	0	7340
211435	1769	1567700000	28230	13958	5	0	65
211454	1397	1267572892000	28234	13959	0	0	17125
211455	2132	147236249000	28234	13959	1	0	1752
211456	2134	83227001000	28234	13959	2	0	7341
211458	2134	83225998000	28235	13960	1	0	7342
211459	1397	1267552890000	28236	13961	0	0	17127
211460	2134	83224995000	28236	13961	1	0	7343
211469	1397	1267542889000	28240	13962	0	0	17128
211473	1397	1267532888000	28242	13963	0	0	17129
211474	2134	83222989000	28242	13963	1	0	7345
211475	2132	147235248000	28242	13963	2	0	1753
211478	1397	1267522887000	28244	13964	0	0	17130
211479	2134	83221986000	28244	13964	1	0	7346
211488	1397	1267492884000	28248	13967	0	0	\N
211489	2358	50098000000	28248	13967	1	0	\N
211490	2134	83218977000	28248	13967	2	0	\N
211491	1397	1267492884000	28249	13967	0	0	\N
211492	2358	50098000000	28249	13967	1	0	\N
211493	2134	83218977000	28249	13967	2	0	\N
211494	1474	24290633000043	28250	13730	0	0	\N
211495	2199	720328000000	28250	13730	1	0	\N
211496	96	66001212000000	28250	13730	2	0	\N
211497	1464	2158024000000	28250	13730	3	0	\N
211498	1464	14000000	28250	13730	4	0	\N
211499	2351	96000000	28250	13730	5	0	\N
211500	395	66044730646980	28250	13730	6	0	\N
211501	1769	1568700000	28250	13730	7	0	\N
211502	1726	942846112000	28250	13730	8	0	\N
211503	1726	941745112000	28250	13730	9	0	\N
211504	1726	940644112000	28250	13730	10	0	\N
211505	1726	939543112000	28250	13730	11	0	\N
211506	1726	938442112000	28250	13730	12	0	\N
211507	2358	50099000000	28250	13730	13	0	\N
211508	2358	50098000000	28250	13730	14	0	\N
211509	1726	937341112000	28250	13730	15	0	\N
211510	1726	936240112000	28250	13730	16	0	\N
211511	1726	935139112000	28250	13730	17	0	\N
211512	1726	934038112000	28250	13730	18	0	\N
211513	2132	147266279000	28250	13730	19	0	\N
211514	2132	147265278000	28250	13730	20	0	\N
211515	2132	147264277000	28250	13730	21	0	\N
211516	2132	147263276000	28250	13730	22	0	\N
211517	2132	147262275000	28250	13730	23	0	\N
211518	2132	147261274000	28250	13730	24	0	\N
211519	2132	147260273000	28250	13730	25	0	\N
211520	2132	147259272000	28250	13730	26	0	\N
211521	2132	147258271000	28250	13730	27	0	\N
211522	2132	147257270000	28250	13730	28	0	\N
211523	2132	147256269000	28250	13730	29	0	\N
211524	2132	147255268000	28250	13730	30	0	\N
211525	2132	147254267000	28250	13730	31	0	\N
211526	2132	147253266000	28250	13730	32	0	\N
211527	2132	147252265000	28250	13730	33	0	\N
211528	2132	147251264000	28250	13730	34	0	\N
211529	2132	147250263000	28250	13730	35	0	\N
211530	2132	147249262000	28250	13730	36	0	\N
211531	2132	147248261000	28250	13730	37	0	\N
211532	2132	147247260000	28250	13730	38	0	\N
211533	2132	147246259000	28250	13730	39	0	\N
211534	2132	147245258000	28250	13730	40	0	\N
211535	2132	147244257000	28250	13730	41	0	\N
211536	2132	147243256000	28250	13730	42	0	\N
211537	2132	147242255000	28250	13730	43	0	\N
211538	2132	147241254000	28250	13730	44	0	\N
211539	2132	147240253000	28250	13730	45	0	\N
211540	2132	147239252000	28250	13730	46	0	\N
211541	2132	147238251000	28250	13730	47	0	\N
211542	2132	147237250000	28250	13730	48	0	\N
211543	2132	147236249000	28250	13730	49	0	\N
211544	2132	147235248000	28250	13730	50	0	\N
211545	2132	147234247000	28250	13730	51	0	\N
211546	1769	1567700000	28250	13730	52	0	\N
211547	1397	1267482883000	28251	13968	0	0	\N
211548	1397	1267472882000	28251	13968	1	0	\N
211549	2134	83217974000	28251	13968	2	0	\N
211550	2134	83216971000	28251	13968	3	0	\N
211551	1253	607902749000000	28251	13968	4	0	\N
211552	2132	147233246000	28251	13968	5	0	\N
211563	1397	1267452880000	28255	13970	0	0	\N
211564	2134	83214965000	28255	13970	1	0	\N
211565	1397	1267442879000	28256	13971	0	0	\N
211566	2134	83213962000	28256	13971	1	0	\N
211569	1397	1267442879000	28258	13971	0	0	\N
211570	2134	83213962000	28258	13971	1	0	\N
211571	1397	1267442879000	28259	13971	0	0	\N
211572	2134	83213962000	28259	13971	1	0	\N
211573	1397	1267432878000	28260	13972	0	0	\N
211574	2134	83212959000	28260	13972	1	0	\N
211575	2132	147232245000	28260	13972	2	0	\N
211579	1397	1267432878000	28262	13972	0	0	\N
211580	2134	83212959000	28262	13972	1	0	\N
211581	2132	147232245000	28262	13972	2	0	\N
211586	1397	1267412876000	28265	13974	0	0	\N
211587	2134	83210953000	28265	13974	1	0	\N
211588	1397	1267412876000	28266	13974	0	0	\N
211589	2134	83210953000	28266	13974	1	0	\N
211593	2132	147243256000	28268	13878	0	0	\N
211594	2132	147242255000	28268	13878	1	0	\N
211595	1769	1568700000	28268	13878	2	0	\N
211596	2132	147241254000	28268	13878	3	0	\N
211597	2132	147240253000	28268	13878	4	0	\N
211598	2132	147239252000	28268	13878	5	0	\N
211599	2132	147238251000	28268	13878	6	0	\N
211600	2132	147237250000	28268	13878	7	0	\N
211601	2132	147236249000	28268	13878	8	0	\N
211602	2132	147235248000	28268	13878	9	0	\N
211603	2132	147234247000	28268	13878	10	0	\N
211604	2358	50098000000	28268	13878	11	0	\N
211605	1253	607902749000000	28268	13878	12	0	\N
211606	2132	147233246000	28268	13878	13	0	\N
211607	2132	147232245000	28268	13878	14	0	\N
211608	2132	147231244000	28268	13878	15	0	\N
211609	1769	1567700000	28268	13878	16	0	\N
211614	1397	1267382873000	28271	13977	0	0	\N
211615	2134	83207944000	28271	13977	1	0	\N
211483	2132	147234247000	28246	13966	1	0	1754
211484	2134	83219980000	28246	13966	2	0	7348
211485	1397	1267492884000	28247	13967	0	0	17133
211486	2358	50098000000	28247	13967	1	0	2
211487	2134	83218977000	28247	13967	2	0	7349
211554	1397	1267472882000	28252	13968	1	0	17135
211555	2134	83217974000	28252	13968	2	0	7350
211556	2134	83216971000	28252	13968	3	0	7351
211557	1253	607902749000000	28252	13968	4	0	1
211558	2132	147233246000	28252	13968	5	0	1755
211560	2134	83215968000	28253	13969	1	0	7352
211561	1397	1267452880000	28254	13970	0	0	17137
211562	2134	83214965000	28254	13970	1	0	7353
211567	1397	1267442879000	28257	13971	0	0	17138
211576	1397	1267432878000	28261	13972	0	0	17139
211577	2134	83212959000	28261	13972	1	0	7355
211578	2132	147232245000	28261	13972	2	0	1756
211582	1397	1267422877000	28263	13973	0	0	17140
211583	2134	83211956000	28263	13973	1	0	7356
211585	2134	83210953000	28264	13974	1	0	7357
211590	1397	1267402875000	28267	13975	0	0	17142
211591	2134	83209950000	28267	13975	1	0	7358
211592	2132	147231244000	28267	13975	2	0	1757
211610	1397	1267392874000	28269	13976	0	0	17143
211612	1397	1267382873000	28270	13977	0	0	17144
211613	2134	83207944000	28270	13977	1	0	7360
211616	1397	1267372872000	28272	13978	0	0	17145
211619	1397	1267362871000	28273	13979	0	0	\N
211620	2134	83205938000	28273	13979	1	0	\N
211623	1397	1267362871000	28275	13979	0	0	\N
211624	2134	83205938000	28275	13979	1	0	\N
211625	1397	1267362871000	28276	13979	0	0	\N
211626	2134	83205938000	28276	13979	1	0	\N
211627	1397	1267362871000	28277	13979	0	0	\N
211628	2134	83205938000	28277	13979	1	0	\N
211629	1397	1267352870000	28278	13980	0	0	\N
211630	2134	83204935000	28278	13980	1	0	\N
211633	1397	1267352870000	28280	13980	0	0	\N
211634	2134	83204935000	28280	13980	1	0	\N
211638	1397	1267332868000	28282	13982	0	0	\N
211639	2132	147229242000	28282	13982	1	0	\N
211640	2134	83202929000	28282	13982	2	0	\N
211646	1397	1267312866000	28285	13984	0	0	\N
211647	2134	83200923000	28285	13984	1	0	\N
211648	1397	1267312866000	28286	13984	0	0	\N
211649	2134	83200923000	28286	13984	1	0	\N
211650	1397	1267312866000	28287	13984	0	0	\N
211651	2134	83200923000	28287	13984	1	0	\N
211654	1397	1267312866000	28289	13984	0	0	\N
211655	2134	83200923000	28289	13984	1	0	\N
211656	1397	1267302865000	28290	13985	0	0	\N
211657	2132	147228241000	28290	13985	1	0	\N
211658	2134	83199920000	28290	13985	2	0	\N
211662	1397	1267292864000	28292	13986	0	0	\N
211663	2134	83198917000	28292	13986	1	0	\N
211664	1397	1267292864000	28294	13986	0	0	\N
211665	2134	83198917000	28294	13986	1	0	\N
211668	1397	1267282863000	28296	13987	0	0	\N
211669	1397	1267272862000	28296	13987	1	0	\N
211670	2134	83197914000	28296	13987	2	0	\N
211671	2132	147227240000	28296	13987	3	0	\N
211672	2134	83196911000	28296	13987	4	0	\N
211685	1397	1267242859000	28300	13989	0	0	\N
211686	2134	83193902000	28300	13989	1	0	\N
211687	1397	1267232858000	28301	13990	0	0	\N
211688	1397	1267222857000	28301	13990	1	0	\N
211689	2134	83192899000	28301	13990	2	0	\N
211690	2132	147226239000	28301	13990	3	0	\N
211691	2280	199000000	28301	13990	4	0	\N
211692	2134	83191896000	28301	13990	5	0	\N
211708	1397	1267192854000	28306	13993	0	0	\N
211709	1397	1267182853000	28306	13993	1	0	\N
211710	2134	83188887000	28306	13993	2	0	\N
211711	2134	83187884000	28306	13993	3	0	\N
211712	1397	1267172852000	28307	13994	0	0	\N
211713	2132	147224237000	28307	13994	1	0	\N
211714	2134	83186881000	28307	13994	2	0	\N
211733	1397	1267092844000	28311	13997	0	0	\N
211734	2134	83179860000	28311	13997	1	0	\N
211739	1397	1267302865000	28314	13985	0	0	\N
211740	1397	1267292864000	28314	13985	1	0	\N
211741	1397	1267282863000	28314	13985	2	0	\N
211742	1397	1267272862000	28314	13985	3	0	\N
211743	1397	1267262861000	28314	13985	4	0	\N
211744	1397	1267252860000	28314	13985	5	0	\N
211745	1397	1267242859000	28314	13985	6	0	\N
211746	1397	1267232858000	28314	13985	7	0	\N
211747	1397	1267222857000	28314	13985	8	0	\N
211748	1397	1267212856000	28314	13985	9	0	\N
211749	1397	1267202855000	28314	13985	10	0	\N
211750	1397	1267192854000	28314	13985	11	0	\N
211751	1397	1267182853000	28314	13985	12	0	\N
211752	1397	1267172852000	28314	13985	13	0	\N
211621	1397	1267362871000	28274	13979	0	0	17146
211622	2134	83205938000	28274	13979	1	0	7362
211631	1397	1267352870000	28279	13980	0	0	17147
211632	2134	83204935000	28279	13980	1	0	7363
211635	1397	1267342869000	28281	13981	0	0	17148
211637	2134	83203932000	28281	13981	2	0	7364
211641	1397	1267332868000	28283	13982	0	0	17149
211642	2132	147229242000	28283	13982	1	0	1759
211643	2134	83202929000	28283	13982	2	0	7365
211644	1397	1267322867000	28284	13983	0	0	17150
211652	1397	1267312866000	28288	13984	0	0	17151
211653	2134	83200923000	28288	13984	1	0	7367
211659	1397	1267302865000	28291	13985	0	0	17152
211660	2132	147228241000	28291	13985	1	0	1760
211666	1397	1267292864000	28295	13986	0	0	17153
211667	2134	83198917000	28295	13986	1	0	7369
211673	1397	1267282863000	28297	13987	0	0	17154
211674	1397	1267272862000	28297	13987	1	0	17155
211675	2134	83197914000	28297	13987	2	0	7370
211677	2134	83196911000	28297	13987	4	0	7371
211678	1397	1267262861000	28298	13988	0	0	17156
211679	1397	1267252860000	28298	13988	1	0	17157
211680	2358	50096000000	28298	13988	2	0	4
211681	2134	83195908000	28298	13988	3	0	7372
211683	1397	1267242859000	28299	13989	0	0	17158
211684	2134	83193902000	28299	13989	1	0	7374
211693	1397	1267232858000	28302	13990	0	0	17159
211694	1397	1267222857000	28302	13990	1	0	17160
211696	2132	147226239000	28302	13990	3	0	1762
211697	2280	199000000	28302	13990	4	0	1
211698	2134	83191896000	28302	13990	5	0	7376
211699	1397	1267212856000	28303	13991	0	0	17161
211700	2134	83190893000	28303	13991	1	0	7377
211702	2132	147225238000	28304	13992	1	0	1763
211703	2134	83189890000	28304	13992	2	0	7378
211704	1397	1267192854000	28305	13993	0	0	17163
211705	1397	1267182853000	28305	13993	1	0	17164
211706	2134	83188887000	28305	13993	2	0	7379
211715	1397	1267172852000	28308	13994	0	0	17165
211716	2132	147224237000	28308	13994	1	0	1764
211717	1397	1267162851000	28309	13995	0	0	17166
211718	1397	1267152850000	28309	13995	1	0	17167
211720	1397	1267132848000	28309	13995	3	0	17169
211721	1397	1267122847000	28309	13995	4	0	17170
211722	2134	83186881000	28309	13995	5	0	7381
211723	2132	147223236000	28309	13995	6	0	1765
211724	2134	83185878000	28309	13995	7	0	7382
211726	2134	83183872000	28309	13995	9	0	7384
211727	2134	83182869000	28309	13995	10	0	7385
211728	1397	1267112846000	28310	13996	0	0	17171
211729	1397	1267102845000	28310	13996	1	0	17172
211730	2132	147222235000	28310	13996	2	0	1766
211732	2134	83180863000	28310	13996	4	0	7387
211735	1397	1267092844000	28312	13997	0	0	17173
211736	2134	83179860000	28312	13997	1	0	7388
211737	1397	1267082843000	28313	13998	0	0	17174
211753	1397	1267162851000	28314	13985	14	0	\N
211754	1397	1267152850000	28314	13985	15	0	\N
211755	1397	1267142849000	28314	13985	16	0	\N
211756	1397	1267132848000	28314	13985	17	0	\N
211757	1397	1267122847000	28314	13985	18	0	\N
211758	1397	1267112846000	28314	13985	19	0	\N
211759	1397	1267102845000	28314	13985	20	0	\N
211760	1397	1267092844000	28314	13985	21	0	\N
211761	1397	1267082843000	28314	13985	22	0	\N
211762	2132	147228241000	28314	13985	23	0	\N
211763	2132	147227240000	28314	13985	24	0	\N
211764	2132	147226239000	28314	13985	25	0	\N
211765	2280	199000000	28314	13985	26	0	\N
211766	2358	50096000000	28314	13985	27	0	\N
211767	2134	83199920000	28314	13985	28	0	\N
211768	2134	83198917000	28314	13985	29	0	\N
211769	2134	83197914000	28314	13985	30	0	\N
211770	2134	83196911000	28314	13985	31	0	\N
211771	2132	147225238000	28314	13985	32	0	\N
211772	2132	147224237000	28314	13985	33	0	\N
211773	2132	147223236000	28314	13985	34	0	\N
211774	2132	147222235000	28314	13985	35	0	\N
211775	2134	83195908000	28314	13985	36	0	\N
211776	2134	83194905000	28314	13985	37	0	\N
211777	2134	83193902000	28314	13985	38	0	\N
211778	2134	83192899000	28314	13985	39	0	\N
211779	2134	83191896000	28314	13985	40	0	\N
211780	2134	83190893000	28314	13985	41	0	\N
211781	2134	83189890000	28314	13985	42	0	\N
211782	2134	83188887000	28314	13985	43	0	\N
211783	2134	83187884000	28314	13985	44	0	\N
211784	2134	83186881000	28314	13985	45	0	\N
211785	2134	83185878000	28314	13985	46	0	\N
211786	2134	83184875000	28314	13985	47	0	\N
211787	2134	83183872000	28314	13985	48	0	\N
211788	2134	83182869000	28314	13985	49	0	\N
211789	2134	83181866000	28314	13985	50	0	\N
211790	2134	83180863000	28314	13985	51	0	\N
211791	2134	83179860000	28314	13985	52	0	\N
211792	2134	83178857000	28314	13985	53	0	\N
211793	1397	1267082843000	28315	13998	0	0	\N
211794	2134	83178857000	28315	13998	1	0	\N
211800	1397	1267072842000	28317	13999	0	0	\N
211801	1397	1267062841000	28317	13999	1	0	\N
211802	2132	147221234000	28317	13999	2	0	\N
211803	2134	83177854000	28317	13999	3	0	\N
211804	2134	83176851000	28317	13999	4	0	\N
211809	2358	50097000000	28320	13976	0	0	\N
211810	2280	199000000	28320	13976	1	0	\N
211811	2358	50096000000	28320	13976	2	0	\N
211814	2358	50098000000	28322	13944	0	0	\N
211815	2358	50097000000	28322	13944	1	0	\N
211816	2280	199000000	28322	13944	2	0	\N
211817	2358	50096000000	28322	13944	3	0	\N
211818	1253	607902749000000	28322	13944	4	0	\N
211826	1397	1266992834000	28324	14004	0	0	\N
211827	2134	83169830000	28324	14004	1	0	\N
211828	1397	1266992834000	28325	14004	0	0	\N
211829	2134	83169830000	28325	14004	1	0	\N
211830	1397	1266992834000	28326	14004	0	0	\N
211831	2134	83169830000	28326	14004	1	0	\N
211836	1397	1266982833000	28329	14005	0	0	\N
211837	2134	83168827000	28329	14005	1	0	\N
211838	1397	1266972832000	28330	14006	0	0	\N
211839	1397	1266962831000	28330	14006	1	0	\N
211840	1397	1266952830000	28330	14006	2	0	\N
211841	2134	83167824000	28330	14006	3	0	\N
211842	2134	83166821000	28330	14006	4	0	\N
211843	2134	83165818000	28330	14006	5	0	\N
211844	1397	1266972832000	28331	14006	0	0	\N
211845	1397	1266962831000	28331	14006	1	0	\N
211846	1397	1266952830000	28331	14006	2	0	\N
211847	2134	83167824000	28331	14006	3	0	\N
211848	2134	83166821000	28331	14006	4	0	\N
211849	2134	83165818000	28331	14006	5	0	\N
211856	1397	1266942829000	28333	14007	0	0	\N
211857	2134	83164815000	28333	14007	1	0	\N
211858	1397	1266942829000	28334	14007	0	0	\N
211859	2134	83164815000	28334	14007	1	0	\N
211862	1397	1266932828000	28336	14008	0	0	\N
211863	1397	1266922827000	28336	14008	1	0	\N
211864	1397	1266912826000	28336	14008	2	0	\N
211865	1397	1266902825000	28336	14008	3	0	\N
211866	2134	83163812000	28336	14008	4	0	\N
211867	2134	83162809000	28336	14008	5	0	\N
211868	2134	83161806000	28336	14008	6	0	\N
211869	2134	83160803000	28336	14008	7	0	\N
211880	1397	1266892824000	28339	14009	0	0	\N
211881	2134	83159800000	28339	14009	1	0	\N
211884	1397	1266872822000	28341	14011	0	0	\N
211885	1397	1266862821000	28341	14011	1	0	\N
211886	1397	1266852820000	28341	14011	2	0	\N
211887	1397	1266842819000	28341	14011	3	0	\N
211888	2134	83157794000	28341	14011	4	0	\N
211797	2132	147221234000	28316	13999	2	0	1767
211798	2134	83177854000	28316	13999	3	0	7390
211799	2134	83176851000	28316	13999	4	0	7391
211805	1397	1267052840000	28318	14000	0	0	17177
211806	2134	83175848000	28318	14000	1	0	7392
211808	2134	83174845000	28319	14001	1	0	7393
211812	1397	1267032838000	28321	14002	0	0	17179
211813	2134	83173842000	28321	14002	1	0	7394
211819	1397	1267022837000	28323	14003	0	0	17180
211820	1397	1267012836000	28323	14003	1	0	17181
211822	2398	0	28323	14003	3	0	1
211823	2134	83172839000	28323	14003	5	0	7395
211824	2134	83171836000	28323	14003	6	0	7396
211825	2134	83170833000	28323	14003	7	0	7397
211833	2134	83169830000	28327	14004	1	0	7398
211834	1397	1266982833000	28328	14005	0	0	17184
211835	2134	83168827000	28328	14005	1	0	7399
211850	1397	1266972832000	28332	14006	0	0	17185
211851	1397	1266962831000	28332	14006	1	0	17186
211853	2134	83167824000	28332	14006	3	0	7400
211854	2134	83166821000	28332	14006	4	0	7401
211855	2134	83165818000	28332	14006	5	0	7402
211860	1397	1266942829000	28335	14007	0	0	17188
211861	2134	83164815000	28335	14007	1	0	7403
211871	1397	1266922827000	28337	14008	1	0	17190
211872	1397	1266912826000	28337	14008	2	0	17191
211873	1397	1266902825000	28337	14008	3	0	17192
211874	2134	83163812000	28337	14008	4	0	7404
211876	2134	83161806000	28337	14008	6	0	7406
211877	2134	83160803000	28337	14008	7	0	7407
211878	1397	1266892824000	28338	14009	0	0	17193
211879	2134	83159800000	28338	14009	1	0	7408
211882	1397	1266882823000	28340	14010	0	0	17194
211889	2134	83156791000	28341	14011	5	0	\N
211890	2134	83155788000	28341	14011	6	0	\N
211891	2134	83154785000	28341	14011	7	0	\N
211892	1397	1266872822000	28342	14011	0	0	\N
211893	1397	1266862821000	28342	14011	1	0	\N
211894	1397	1266852820000	28342	14011	2	0	\N
211895	1397	1266842819000	28342	14011	3	0	\N
211896	2134	83157794000	28342	14011	4	0	\N
211897	2134	83156791000	28342	14011	5	0	\N
211898	2134	83155788000	28342	14011	6	0	\N
211899	2134	83154785000	28342	14011	7	0	\N
211910	1397	1266832818000	28345	14012	0	0	\N
211911	2134	83153782000	28345	14012	1	0	\N
211920	1397	1266822817000	28347	14013	0	0	\N
211921	1397	1266812816000	28347	14013	1	0	\N
211922	329	67367601000000	28347	14013	2	0	\N
211923	1379	1693978636751650	28347	14013	3	0	\N
211924	2134	83152779000	28347	14013	4	0	\N
211925	2134	83151776000	28347	14013	5	0	\N
211926	2134	83150773000	28347	14013	6	0	\N
211927	1253	1000000000	28347	14013	7	0	\N
211928	329	67367601000000	28348	13879	0	0	\N
211929	2358	50097000000	28348	13879	1	0	\N
211930	2398	0	28348	13879	2	0	\N
211931	1379	1693978636751650	28348	13879	3	0	\N
211932	2280	199000000	28348	13879	4	0	\N
211933	2358	50096000000	28348	13879	5	0	\N
211934	2132	147230243000	28348	13879	6	0	\N
211935	2132	147229242000	28348	13879	7	0	\N
211936	2132	147228241000	28348	13879	8	0	\N
211937	2132	147227240000	28348	13879	9	0	\N
211938	2132	147226239000	28348	13879	10	0	\N
211939	2132	147225238000	28348	13879	11	0	\N
211940	2132	147224237000	28348	13879	12	0	\N
211941	2132	147223236000	28348	13879	13	0	\N
211942	2132	147222235000	28348	13879	14	0	\N
211943	2132	147221234000	28348	13879	15	0	\N
211948	1397	1266782813000	28350	14015	0	0	\N
211949	2134	83147764000	28350	14015	1	0	\N
211950	1397	1266782813000	28351	14015	0	0	\N
211951	2134	83147764000	28351	14015	1	0	\N
211963	1397	1266732808000	28357	14019	0	0	\N
211964	2134	83142749000	28357	14019	1	0	\N
211967	1397	1266732808000	28359	14019	0	0	\N
211968	2134	83142749000	28359	14019	1	0	\N
211971	1397	1266722807000	28361	14020	0	0	\N
211972	2134	83141746000	28361	14020	1	0	\N
211979	1397	1266712806000	28364	14021	0	0	\N
211980	1397	1266702805000	28364	14021	1	0	\N
211981	1397	1266692804000	28364	14021	2	0	\N
211982	2134	83140743000	28364	14021	3	0	\N
211983	2134	83139740000	28364	14021	4	0	\N
211984	2134	83138737000	28364	14021	5	0	\N
211989	1397	1266672802000	28367	14024	0	0	\N
211990	2134	83136731000	28367	14024	1	0	\N
211993	1397	1266662801000	28369	14025	0	0	\N
211994	2134	83135728000	28369	14025	1	0	\N
211995	1397	1266662801000	28370	14025	0	0	\N
211996	2134	83135728000	28370	14025	1	0	\N
211997	1397	1266662801000	28371	14025	0	0	\N
211998	2134	83135728000	28371	14025	1	0	\N
212001	1397	1266652800000	28373	14026	0	0	\N
212002	2134	83134725000	28373	14026	1	0	\N
212003	1397	1266642799000	28374	14027	0	0	\N
212004	2134	83133722000	28374	14027	2	0	\N
212007	1397	1266642799000	28376	14027	0	0	\N
212008	2134	83133722000	28376	14027	2	0	\N
212009	329	67367601000000	28377	13824	0	0	\N
212010	329	66000591000000	28377	13824	1	0	\N
212011	96	66001212000000	28377	13824	2	0	\N
212012	1464	2158024000000	28377	13824	3	0	\N
212013	1464	14000000	28377	13824	4	0	\N
212014	1726	936240112000	28377	13824	5	0	\N
212015	1769	1568700000	28377	13824	6	0	\N
212016	1379	1693978636751650	28377	13824	7	0	\N
212017	1726	935139112000	28377	13824	8	0	\N
212018	1726	934038112000	28377	13824	9	0	\N
212019	2388	99000000	28377	13824	10	0	\N
212020	2358	50099000000	28377	13824	11	0	\N
212021	2358	50098000000	28377	13824	12	0	\N
212022	2358	50097000000	28377	13824	13	0	\N
212023	2280	199000000	28377	13824	14	0	\N
212024	2358	50096000000	28377	13824	15	0	\N
211902	1397	1266852820000	28343	14011	2	0	17197
211903	1397	1266842819000	28343	14011	3	0	17198
211904	2134	83157794000	28343	14011	4	0	7410
211905	2134	83156791000	28343	14011	5	0	7411
211906	2134	83155788000	28343	14011	6	0	7412
211908	1397	1266832818000	28344	14012	0	0	17199
211909	2134	83153782000	28344	14012	1	0	7414
211912	1397	1266822817000	28346	14013	0	0	17200
211913	1397	1266812816000	28346	14013	1	0	17201
211914	329	67367601000000	28346	14013	2	0	7
211916	2134	83152779000	28346	14013	4	0	7415
211917	2134	83151776000	28346	14013	5	0	7416
211918	2134	83150773000	28346	14013	6	0	7417
211919	1253	1000000000	28346	14013	7	0	2
211945	1397	1266792814000	28349	14014	1	0	17203
211946	2134	83149770000	28349	14014	2	0	7418
211947	2134	83148767000	28349	14014	3	0	7419
211952	1397	1266782813000	28352	14015	0	0	17204
211953	2134	83147764000	28352	14015	1	0	7420
211955	2134	83146761000	28354	14016	1	0	7421
211956	329	66000591000000	28355	14017	0	0	8
211957	1397	1266762811000	28355	14017	1	0	17206
211958	1397	1266752810000	28355	14017	2	0	17207
211959	2134	83145758000	28355	14017	3	0	7422
211961	1397	1266742809000	28356	14018	0	0	17208
211962	2134	83143752000	28356	14018	1	0	7424
211965	1397	1266732808000	28358	14019	0	0	17209
211966	2134	83142749000	28358	14019	1	0	7425
211970	2134	83141746000	28360	14020	1	0	7426
211973	1397	1266712806000	28362	14021	0	0	17211
211974	2134	83140743000	28362	14021	1	0	7427
211975	1397	1266702805000	28363	14022	0	0	17212
211976	1397	1266692804000	28363	14022	1	0	17213
211978	2134	83138737000	28363	14022	3	0	7429
211985	1397	1266682803000	28365	14023	0	0	17214
211986	2134	83137734000	28365	14023	1	0	7430
211987	1397	1266672802000	28366	14024	0	0	17215
211988	2134	83136731000	28366	14024	1	0	7431
211992	2134	83135728000	28368	14025	1	0	7432
211999	1397	1266652800000	28372	14026	0	0	17217
212000	2134	83134725000	28372	14026	1	0	7433
212005	1397	1266642799000	28375	14027	0	0	17218
212025	1253	607902749000000	28377	13824	16	0	\N
212026	2132	147266279000	28377	13824	17	0	\N
212027	2132	147265278000	28377	13824	18	0	\N
212028	2132	147264277000	28377	13824	19	0	\N
212029	2132	147263276000	28377	13824	20	0	\N
212030	2132	147262275000	28377	13824	21	0	\N
212031	2132	147261274000	28377	13824	22	0	\N
212032	2132	147260273000	28377	13824	23	0	\N
212033	1397	1266632798000	28378	14028	0	0	\N
212034	2134	83132719000	28378	14028	1	0	\N
212037	1397	1266622797000	28380	14029	0	0	\N
212038	2134	83131716000	28380	14029	1	0	\N
212048	1397	1266592794000	28385	14032	0	0	\N
212049	2134	83128707000	28385	14032	1	0	\N
212050	1397	1266592794000	28386	14032	0	0	\N
212051	2134	83128707000	28386	14032	1	0	\N
212052	1397	1266592794000	28387	14032	0	0	\N
212053	2134	83128707000	28387	14032	1	0	\N
212057	1789	2980000000	28389	13989	0	0	\N
212058	1789	90000000	28389	13989	1	0	\N
212059	329	67367601000000	28389	13989	2	0	\N
212060	329	66000591000000	28389	13989	3	0	\N
212061	2398	0	28389	13989	4	0	\N
212062	1379	1693978636751650	28389	13989	5	0	\N
212063	2280	199000000	28389	13989	6	0	\N
212064	1789	90000000	28390	14033	0	0	\N
212065	1397	1266582793000	28390	14033	1	0	\N
212066	2134	83127704000	28390	14033	2	0	\N
212067	1789	90000000	28391	14033	0	0	\N
212068	1397	1266582793000	28391	14033	1	0	\N
212069	2134	83127704000	28391	14033	2	0	\N
212070	1789	90000000	28392	14033	0	0	\N
212071	1397	1266582793000	28392	14033	1	0	\N
212072	2134	83127704000	28392	14033	2	0	\N
212073	1789	90000000	28393	14033	0	0	\N
212074	1397	1266582793000	28393	14033	1	0	\N
212075	2134	83127704000	28393	14033	2	0	\N
212080	1397	1266562791000	28396	14035	0	0	\N
212081	2134	83125698000	28396	14035	1	0	\N
212082	2134	83125698000	28397	14035	0	0	\N
212085	1397	1266542789000	28399	14037	0	0	\N
212086	2400	0	28399	14037	1	0	\N
212087	2134	83123692000	28399	14037	2	0	\N
212091	1397	1266532788000	28401	14038	0	0	\N
212092	1397	1266522787000	28401	14038	1	0	\N
212093	2134	83122689000	28401	14038	2	0	\N
212094	2134	83121686000	28401	14038	3	0	\N
212101	1397	1266512786000	28404	14039	0	0	\N
212102	2134	83120683000	28404	14039	1	0	\N
212103	1397	1266512786000	28405	14039	0	0	\N
212104	2134	83120683000	28405	14039	1	0	\N
212105	1397	1266512786000	28406	14039	0	0	\N
212106	2134	83120683000	28406	14039	1	0	\N
212107	1397	1266512786000	28407	14039	0	0	\N
212108	2134	83120683000	28407	14039	1	0	\N
212112	1397	1266502785000	28409	14040	0	0	\N
212113	1507	49990000000	28409	14040	1	0	\N
212114	2134	83119680000	28409	14040	2	0	\N
212115	1397	1266502785000	28410	14040	0	0	\N
212116	1507	49990000000	28410	14040	1	0	\N
212117	2134	83119680000	28410	14040	2	0	\N
212118	1397	1266502785000	28411	14040	0	0	\N
212119	1507	49990000000	28411	14040	1	0	\N
212120	2134	83119680000	28411	14040	2	0	\N
212121	1397	1266492784000	28412	14041	0	0	\N
212122	2134	83118677000	28412	14041	1	0	\N
212124	1789	2980000000	28414	14022	0	0	\N
212125	1789	90000000	28414	14022	1	0	\N
212126	1507	49990000000	28414	14022	2	0	\N
212127	1397	1266682803000	28414	14022	3	0	\N
212128	1397	1266672802000	28414	14022	4	0	\N
212129	1397	1266662801000	28414	14022	5	0	\N
212130	1397	1266652800000	28414	14022	6	0	\N
212131	1397	1266642799000	28414	14022	7	0	\N
212132	1397	1266632798000	28414	14022	8	0	\N
212133	1397	1266622797000	28414	14022	9	0	\N
212134	1397	1266612796000	28414	14022	10	0	\N
212135	1397	1266602795000	28414	14022	11	0	\N
212136	1397	1266592794000	28414	14022	12	0	\N
212137	1397	1266582793000	28414	14022	13	0	\N
212138	1397	1266572792000	28414	14022	14	0	\N
212139	1397	1266562791000	28414	14022	15	0	\N
212140	1397	1266552790000	28414	14022	16	0	\N
212141	1397	1266542789000	28414	14022	17	0	\N
212142	1397	1266532788000	28414	14022	18	0	\N
212143	1397	1266522787000	28414	14022	20	0	\N
212144	1397	1266512786000	28414	14022	21	0	\N
212145	1397	1266502785000	28414	14022	22	0	\N
212146	2400	0	28414	14022	23	0	\N
212147	2134	83137734000	28414	14022	24	0	\N
212148	2134	83136731000	28414	14022	25	0	\N
212149	2134	83135728000	28414	14022	26	0	\N
212150	2134	83134725000	28414	14022	27	0	\N
212151	2134	83133722000	28414	14022	28	0	\N
212152	2134	83132719000	28414	14022	29	0	\N
212153	2134	83131716000	28414	14022	30	0	\N
212154	2134	83130713000	28414	14022	31	0	\N
212155	2134	83129710000	28414	14022	32	0	\N
212156	2134	83128707000	28414	14022	33	0	\N
212157	2134	83127704000	28414	14022	34	0	\N
212158	2134	83126701000	28414	14022	35	0	\N
212159	2134	83125698000	28414	14022	36	0	\N
212160	2134	83124695000	28414	14022	37	0	\N
212039	1397	1266622797000	28381	14029	0	0	17220
212040	2134	83131716000	28381	14029	1	0	7436
212041	1397	1266612796000	28382	14030	0	0	17221
212042	2134	83130713000	28382	14030	1	0	7437
212043	1789	2980000000	28383	14031	0	0	2
212045	2134	83129710000	28383	14031	2	0	7438
212046	1397	1266592794000	28384	14032	0	0	17223
212047	2134	83128707000	28384	14032	1	0	7439
212054	1789	90000000	28388	14033	0	0	3
212055	1397	1266582793000	28388	14033	1	0	17224
212076	1397	1266572792000	28394	14034	0	0	17225
212077	2134	83126701000	28394	14034	1	0	7441
212078	1397	1266562791000	28395	14035	0	0	17226
212079	2134	83125698000	28395	14035	1	0	7442
212084	2134	83124695000	28398	14036	1	0	7443
212088	1397	1266542789000	28400	14037	0	0	17228
212089	2400	0	28400	14037	1	0	1
212090	2134	83123692000	28400	14037	2	0	7444
212095	1397	1266532788000	28402	14038	0	0	17229
212097	2134	83122689000	28402	14038	2	0	7445
212098	2134	83121686000	28402	14038	3	0	7446
212099	1397	1266512786000	28403	14039	0	0	17231
212100	2134	83120683000	28403	14039	1	0	7447
212109	1397	1266502785000	28408	14040	0	0	17232
212111	2134	83119680000	28408	14040	2	0	7448
212123	2134	83118677000	28413	14041	0	0	7449
212161	2134	83123692000	28414	14022	38	0	\N
212162	2134	83122689000	28414	14022	39	0	\N
212163	2134	83121686000	28414	14022	40	0	\N
212164	2134	83120683000	28414	14022	41	0	\N
212183	1397	1266422777000	28420	14046	0	0	\N
212184	1397	1266412776000	28420	14046	1	0	\N
212185	2134	83111656000	28420	14046	2	0	\N
212186	2134	83110653000	28420	14046	3	0	\N
212187	1397	1266402775000	28421	14047	0	0	\N
212188	2134	83109650000	28421	14047	1	0	\N
212191	1789	2980000000	28423	13880	0	0	\N
212192	329	66000591000000	28423	13880	1	0	\N
212193	1789	90000000	28423	13880	2	0	\N
212194	1507	49990000000	28423	13880	3	0	\N
212195	2400	0	28423	13880	4	0	\N
212212	1397	1266322767000	28426	14049	0	0	\N
212213	2134	83101626000	28426	14049	1	0	\N
212214	1397	1266322767000	28427	14049	0	0	\N
212215	2134	83101626000	28427	14049	1	0	\N
212216	1397	1266492784000	28428	14041	0	0	\N
212217	1397	1266482783000	28428	14041	1	0	\N
212218	1397	1266472782000	28428	14041	2	0	\N
212219	1397	1266462781000	28428	14041	3	0	\N
212220	1397	1266452780000	28428	14041	4	0	\N
212221	1397	1266442779000	28428	14041	5	0	\N
212222	1397	1266432778000	28428	14041	6	0	\N
212223	1397	1266422777000	28428	14041	7	0	\N
212224	1397	1266412776000	28428	14041	8	0	\N
212225	1397	1266402775000	28428	14041	9	0	\N
212226	1397	1266392774000	28428	14041	10	0	\N
212227	1397	1266382773000	28428	14041	11	0	\N
212228	1397	1266372772000	28428	14041	12	0	\N
212229	1397	1266362771000	28428	14041	13	0	\N
212230	1397	1266352770000	28428	14041	14	0	\N
212231	1397	1266342769000	28428	14041	15	0	\N
212232	1397	1266332768000	28428	14041	16	0	\N
212233	1397	1266322767000	28428	14041	17	0	\N
212234	2402	48994500000	28428	14041	18	0	\N
212235	2134	83118677000	28428	14041	19	0	\N
212236	2134	83117674000	28428	14041	20	0	\N
212237	2134	83116671000	28428	14041	21	0	\N
212238	2134	83115668000	28428	14041	22	0	\N
212239	2134	83114665000	28428	14041	23	0	\N
212240	2134	83113662000	28428	14041	24	0	\N
212241	2134	83112659000	28428	14041	25	0	\N
212242	2134	83111656000	28428	14041	26	0	\N
212243	2134	83110653000	28428	14041	27	0	\N
212244	2134	83109650000	28428	14041	28	0	\N
212245	2134	83108647000	28428	14041	29	0	\N
212246	2134	83107644000	28428	14041	30	0	\N
212247	2134	83106641000	28428	14041	31	0	\N
212248	2134	83105638000	28428	14041	32	0	\N
212249	2134	83104635000	28428	14041	33	0	\N
212250	2134	83103632000	28428	14041	34	0	\N
212251	2134	83102629000	28428	14041	35	0	\N
212252	2134	83101626000	28428	14041	36	0	\N
212257	1397	1266292764000	28430	14051	0	0	\N
212258	2134	83098617000	28430	14051	1	0	\N
212263	1397	1266282763000	28433	14052	0	0	\N
212264	2134	83097614000	28433	14052	2	0	\N
212274	1789	2980000000	28436	13847	0	0	\N
212275	1789	90000000	28436	13847	1	0	\N
212276	329	67367601000000	28436	13847	2	0	\N
212277	329	66000591000000	28436	13847	3	0	\N
212278	1507	49990000000	28436	13847	4	0	\N
212279	338	67438024000000	28436	13847	5	0	\N
212280	1769	1568700000	28436	13847	6	0	\N
212281	1379	1693978636751650	28436	13847	7	0	\N
212282	2358	50098000000	28436	13847	8	0	\N
212283	2358	50097000000	28436	13847	9	0	\N
212284	2280	199000000	28436	13847	10	0	\N
212285	2132	147247260000	28436	13847	11	0	\N
212286	2132	147246259000	28436	13847	12	0	\N
212287	2358	50096000000	28436	13847	13	0	\N
212288	1253	607902749000000	28436	13847	14	0	\N
212289	2132	147245258000	28436	13847	15	0	\N
212290	2132	147244257000	28436	13847	16	0	\N
212291	2132	147243256000	28436	13847	17	0	\N
212292	2132	147242255000	28436	13847	18	0	\N
212293	2132	147241254000	28436	13847	19	0	\N
212294	2132	147240253000	28436	13847	20	0	\N
212295	2132	147239252000	28436	13847	21	0	\N
212296	2132	147238251000	28436	13847	22	0	\N
212167	1397	1266472782000	28415	14042	2	0	17235
212168	2134	83117674000	28415	14042	3	0	7450
212169	2134	83116671000	28415	14042	4	0	7451
212170	1397	1266462781000	28416	14043	0	0	17236
212171	2134	83115668000	28416	14043	1	0	7452
212173	2134	83114665000	28417	14044	1	0	7453
212174	1397	1266442779000	28418	14045	0	0	17238
212175	1397	1266432778000	28418	14045	1	0	17239
212176	2402	48994500000	28418	14045	2	0	1
212177	2134	83113662000	28418	14045	3	0	7454
212179	1397	1266422777000	28419	14046	0	0	17240
212180	1397	1266412776000	28419	14046	1	0	17241
212181	2134	83111656000	28419	14046	2	0	7456
212182	2134	83110653000	28419	14046	3	0	7457
212190	2134	83109650000	28422	14047	1	0	7458
212196	1397	1266392774000	28424	14048	0	0	17243
212197	1397	1266382773000	28424	14048	1	0	17244
212198	1397	1266372772000	28424	14048	2	0	17245
212199	1397	1266362771000	28424	14048	3	0	17246
212201	1397	1266342769000	28424	14048	5	0	17248
212202	1397	1266332768000	28424	14048	6	0	17249
212203	2134	83108647000	28424	14048	7	0	7459
212204	2134	83107644000	28424	14048	8	0	7460
212205	2134	83106641000	28424	14048	9	0	7461
212207	2134	83104635000	28424	14048	11	0	7463
212208	2134	83103632000	28424	14048	12	0	7464
212209	2134	83102629000	28424	14048	13	0	7465
212210	1397	1266322767000	28425	14049	0	0	17250
212253	1397	1266312766000	28429	14050	0	0	17251
212254	1397	1266302765000	28429	14050	1	0	17252
212255	2134	83100623000	28429	14050	2	0	7467
212256	2134	83099620000	28429	14050	3	0	7468
212259	1397	1266292764000	28431	14051	0	0	17253
212261	1397	1266282763000	28432	14052	0	0	17254
212262	2134	83097614000	28432	14052	2	0	7470
212265	1397	1266272762000	28434	14053	0	0	17255
212266	1397	1266262761000	28434	14053	1	0	17256
212267	1397	1266252760000	28434	14053	2	0	17257
212269	2134	83096611000	28434	14053	4	0	7471
212270	2134	83095608000	28434	14053	5	0	7472
212271	2134	83094605000	28434	14053	6	0	7473
212272	1397	1266242759000	28435	14054	0	0	17258
212297	2132	147237250000	28436	13847	23	0	\N
212298	2132	147236249000	28436	13847	24	0	\N
212299	2132	147235248000	28436	13847	25	0	\N
212300	2132	147234247000	28436	13847	26	0	\N
212301	2132	147233246000	28436	13847	27	0	\N
212302	2132	147232245000	28436	13847	28	0	\N
212303	2132	147231244000	28436	13847	29	0	\N
212304	2132	147230243000	28436	13847	30	0	\N
212305	2132	147229242000	28436	13847	31	0	\N
212306	2132	147228241000	28436	13847	32	0	\N
212307	2132	147227240000	28436	13847	33	0	\N
212308	2132	147226239000	28436	13847	34	0	\N
212309	1769	1567700000	28436	13847	35	0	\N
212310	2132	147225238000	28436	13847	36	0	\N
212311	2132	147224237000	28436	13847	37	0	\N
212312	2132	147223236000	28436	13847	38	0	\N
212313	2132	147222235000	28436	13847	39	0	\N
212314	2132	147221234000	28436	13847	40	0	\N
212315	1397	1266242759000	28437	14054	0	0	\N
212316	2134	83093602000	28437	14054	1	0	\N
212317	1397	1266242759000	28438	14054	0	0	\N
212318	2134	83093602000	28438	14054	1	0	\N
212319	1397	1266242759000	28439	14054	0	0	\N
212320	2134	83093602000	28439	14054	1	0	\N
212326	1397	1266212756000	28442	14057	0	0	\N
212327	2134	83090593000	28442	14057	1	0	\N
212335	1397	1266202755000	28445	14058	0	0	\N
212336	1397	1266192754000	28445	14058	1	0	\N
212337	2403	438994500000	28445	14058	2	0	\N
212338	2134	83089590000	28445	14058	3	0	\N
212339	2134	83088587000	28445	14058	4	0	\N
212340	1397	1266182753000	28446	14059	0	0	\N
212341	1397	1266172752000	28446	14059	1	0	\N
212342	2134	83087584000	28446	14059	2	0	\N
212343	2134	83086581000	28446	14059	3	0	\N
212344	1397	1266182753000	28447	14059	0	0	\N
212345	1397	1266172752000	28447	14059	1	0	\N
212346	2134	83087584000	28447	14059	2	0	\N
212347	2134	83086581000	28447	14059	3	0	\N
212348	1397	1266182753000	28448	14059	0	0	\N
212349	1397	1266172752000	28448	14059	1	0	\N
212350	2134	83087584000	28448	14059	2	0	\N
212351	2134	83086581000	28448	14059	3	0	\N
212356	1397	1266162751000	28450	14060	0	0	\N
212357	2134	83085578000	28450	14060	1	0	\N
212366	1397	1266122747000	28453	14062	0	0	\N
212367	2134	83081566000	28453	14062	1	0	\N
212370	1397	1266122747000	28455	14062	0	0	\N
212371	2134	83081566000	28455	14062	1	0	\N
212372	1397	1266122747000	28456	14062	0	0	\N
212373	2134	83081566000	28456	14062	1	0	\N
212374	1397	1266112746000	28457	14063	0	0	\N
212375	2134	83080563000	28457	14063	1	0	\N
212378	1397	1266102745000	28459	14064	0	0	\N
212379	2134	83079560000	28459	14064	1	0	\N
212380	1397	1266102745000	28460	14064	0	0	\N
212381	2134	83079560000	28460	14064	1	0	\N
212386	1397	1266092744000	28463	14065	0	0	\N
212387	2134	83078557000	28463	14065	1	0	\N
212388	1397	1266082743000	28464	14066	0	0	\N
212389	2134	83077554000	28464	14066	1	0	\N
212392	1397	1266082743000	28466	14066	0	0	\N
212393	2134	83077554000	28466	14066	1	0	\N
212396	338	67438024000000	28468	13881	0	0	\N
212397	338	67000023000000	28468	13881	1	0	\N
212398	1397	1266062741000	28469	14068	0	0	\N
212399	1397	1266052740000	28469	14068	1	0	\N
212400	2134	83075548000	28469	14068	2	0	\N
212401	2134	83074545000	28469	14068	3	0	\N
212419	1397	1265982733000	28476	14074	0	0	\N
212420	2134	83067524000	28476	14074	1	0	\N
212425	1397	1265972732000	28479	14075	0	0	\N
212426	2134	83066521000	28479	14075	1	0	\N
212427	1397	1265972732000	28480	14075	0	0	\N
212428	2134	83066521000	28480	14075	1	0	\N
212431	1397	1265962731000	28482	14076	0	0	\N
212432	2134	83065518000	28482	14076	1	0	\N
212323	1397	1266222757000	28441	14056	0	0	17260
212324	2134	83091596000	28441	14056	1	0	7476
212325	338	67000023000000	28441	14056	2	0	3
212328	1397	1266212756000	28443	14057	0	0	17261
212329	2134	83090593000	28443	14057	1	0	7477
212331	1397	1266192754000	28444	14058	1	0	17263
212332	2403	438994500000	28444	14058	2	0	1
212333	2134	83089590000	28444	14058	3	0	7478
212334	2134	83088587000	28444	14058	4	0	7479
212352	1397	1266182753000	28449	14059	0	0	17264
212354	2134	83087584000	28449	14059	2	0	7480
212355	2134	83086581000	28449	14059	3	0	7481
212358	1397	1266162751000	28451	14060	0	0	17266
212359	2134	83085578000	28451	14060	1	0	7482
212361	1397	1266142749000	28452	14061	1	0	17268
212362	1397	1266132748000	28452	14061	2	0	17269
212363	2134	83084575000	28452	14061	3	0	7483
212364	2134	83083572000	28452	14061	4	0	7484
212365	2134	83082569000	28452	14061	5	0	7485
212369	2134	83081566000	28454	14062	1	0	7486
212376	1397	1266112746000	28458	14063	0	0	17271
212377	2134	83080563000	28458	14063	1	0	7487
212382	1397	1266102745000	28461	14064	0	0	17272
212383	2134	83079560000	28461	14064	1	0	7488
212385	2134	83078557000	28462	14065	1	0	7489
212390	1397	1266082743000	28465	14066	0	0	17274
212391	2134	83077554000	28465	14066	1	0	7490
212394	1397	1266072742000	28467	14067	0	0	17275
212402	1397	1266062741000	28470	14068	0	0	17276
212403	1397	1266052740000	28470	14068	1	0	17277
212404	2134	83075548000	28470	14068	2	0	7492
212405	2134	83074545000	28470	14068	3	0	7493
212406	1397	1266042739000	28471	14069	0	0	17278
212408	2134	83073542000	28471	14069	2	0	7494
212409	2134	83072539000	28471	14069	3	0	7495
212410	1397	1266022737000	28472	14070	0	0	17280
212411	2134	83071536000	28472	14070	1	0	7496
212412	1397	1266012736000	28473	14071	0	0	17281
212414	2134	83070533000	28473	14071	2	0	7497
212415	1397	1266002735000	28474	14072	0	0	17282
212416	2134	83069530000	28474	14072	1	0	7498
212417	1397	1265992734000	28475	14073	0	0	17283
212421	1397	1265982733000	28477	14074	0	0	17284
212422	2134	83067524000	28477	14074	1	0	7500
212423	1397	1265972732000	28478	14075	0	0	17285
212424	2134	83066521000	28478	14075	1	0	7501
212429	1397	1265962731000	28481	14076	0	0	17286
212433	1397	1265962731000	28483	14076	0	0	\N
212434	2134	83065518000	28483	14076	1	0	\N
212435	1397	1265962731000	28484	14076	0	0	\N
212436	2134	83065518000	28484	14076	1	0	\N
212439	1397	1265952730000	28486	14077	0	0	\N
212440	2134	83064515000	28486	14077	1	0	\N
212441	1397	1265952730000	28487	14077	0	0	\N
212442	2134	83064515000	28487	14077	1	0	\N
212455	1397	1265922727000	28491	14080	0	0	\N
212456	1397	1265912726000	28491	14080	1	0	\N
212457	1397	1265902725000	28491	14080	2	0	\N
212458	2385	786833330	28491	14080	3	0	\N
212459	2134	83061506000	28491	14080	4	0	\N
212460	2134	83060503000	28491	14080	5	0	\N
212461	2134	83059500000	28491	14080	6	0	\N
212462	1397	1265922727000	28492	14080	0	0	\N
212463	1397	1265912726000	28492	14080	1	0	\N
212464	1397	1265902725000	28492	14080	2	0	\N
212465	2385	786833330	28492	14080	3	0	\N
212466	2134	83061506000	28492	14080	4	0	\N
212467	2134	83060503000	28492	14080	5	0	\N
212468	2134	83059500000	28492	14080	6	0	\N
212469	1397	1265892724000	28493	14081	0	0	\N
212470	2134	83058497000	28493	14081	1	0	\N
212473	1397	1265882723000	28495	14082	0	0	\N
212474	2134	83057494000	28495	14082	1	0	\N
212477	1397	1265882723000	28497	14082	0	0	\N
212478	2134	83057494000	28497	14082	1	0	\N
212488	1397	1265832718000	28500	14085	0	0	\N
212489	2134	83052479000	28500	14085	1	0	\N
212490	2133	89813276000	28500	14085	2	0	\N
212494	1397	1265832718000	28502	14085	0	0	\N
212495	2134	83052479000	28502	14085	1	0	\N
212496	2133	89813276000	28502	14085	2	0	\N
212500	1397	1265822717000	28504	14086	0	0	\N
212501	2134	83051476000	28504	14086	1	0	\N
212502	2133	89812274000	28504	14086	2	0	\N
212503	1397	1265822717000	28505	14086	0	0	\N
212504	2134	83051476000	28505	14086	1	0	\N
212505	2133	89812274000	28505	14086	2	0	\N
212506	1397	1265822717000	28506	14086	0	0	\N
212507	2134	83051476000	28506	14086	1	0	\N
212508	2133	89812274000	28506	14086	2	0	\N
212511	1789	2980000000	28508	13933	0	0	\N
212512	1789	90000000	28508	13933	1	0	\N
212513	329	67367601000000	28508	13933	2	0	\N
212514	329	66000591000000	28508	13933	3	0	\N
212515	1507	49990000000	28508	13933	4	0	\N
212516	2385	890500000	28508	13933	5	0	\N
212517	2385	786833330	28508	13933	6	0	\N
212518	338	67438024000000	28508	13933	7	0	\N
212519	1769	1568700000	28508	13933	8	0	\N
212520	1379	1693978636751650	28508	13933	9	0	\N
212521	2358	50098000000	28508	13933	10	0	\N
212522	2358	50097000000	28508	13933	11	0	\N
212523	2133	89814278000	28508	13933	12	0	\N
212524	2280	199000000	28508	13933	13	0	\N
212525	2358	50096000000	28508	13933	14	0	\N
212526	1253	607902749000000	28508	13933	15	0	\N
212527	338	67000023000000	28508	13933	16	0	\N
212528	1769	1567700000	28508	13933	17	0	\N
212529	2133	89813276000	28508	13933	18	0	\N
212530	2133	89812274000	28508	13933	19	0	\N
212531	2133	89811272000	28508	13933	20	0	\N
212532	1397	1265802715000	28509	14088	0	0	\N
212533	2133	89810270000	28509	14088	1	0	\N
212534	2134	83050473000	28509	14088	2	0	\N
212538	1397	1265802715000	28511	14088	0	0	\N
212539	2133	89810270000	28511	14088	1	0	\N
212540	2134	83050473000	28511	14088	2	0	\N
212546	1397	1265792714000	28513	14089	0	0	\N
212547	2134	83049470000	28513	14089	1	0	\N
212548	1726	932937112000	28513	14089	2	0	\N
212549	1726	931836112000	28513	14089	3	0	\N
212550	2133	89809268000	28513	14089	4	0	\N
212551	1397	1265792714000	28514	14089	0	0	\N
212552	2134	83049470000	28514	14089	1	0	\N
212553	1726	932937112000	28514	14089	2	0	\N
212554	1726	931836112000	28514	14089	3	0	\N
212555	2133	89809268000	28514	14089	4	0	\N
212556	1397	1265782713000	28515	14090	0	0	\N
212557	2134	83048467000	28515	14090	1	0	\N
212558	2132	147220233000	28515	14090	2	0	\N
212559	2133	89808266000	28515	14090	3	0	\N
212560	1397	1265782713000	28516	14090	0	0	\N
212561	2134	83048467000	28516	14090	1	0	\N
212562	2132	147220233000	28516	14090	2	0	\N
212563	2133	89808266000	28516	14090	3	0	\N
212564	1726	932937112000	28517	14047	0	0	\N
212565	1726	931836112000	28517	14047	1	0	\N
212443	1397	1265942729000	28488	14078	0	0	17288
212444	2385	890500000	28488	14078	1	0	2
212445	2134	83063512000	28488	14078	2	0	7504
212446	1397	1265932728000	28489	14079	0	0	17289
212447	2134	83062509000	28489	14079	1	0	7505
212449	1397	1265912726000	28490	14080	1	0	17291
212450	1397	1265902725000	28490	14080	2	0	17292
212451	2385	786833330	28490	14080	3	0	3
212452	2134	83061506000	28490	14080	4	0	7506
212453	2134	83060503000	28490	14080	5	0	7507
212471	1397	1265892724000	28494	14081	0	0	17293
212472	2134	83058497000	28494	14081	1	0	7509
212475	1397	1265882723000	28496	14082	0	0	17294
212476	2134	83057494000	28496	14082	1	0	7510
212480	1397	1265862721000	28498	14083	1	0	17296
212481	1397	1265852720000	28498	14083	2	0	17297
212482	2134	83056491000	28498	14083	3	0	7511
212483	2133	89814278000	28498	14083	4	0	6863
212484	2134	83055488000	28498	14083	5	0	7512
212486	1397	1265842719000	28499	14084	0	0	17298
212487	2134	83053482000	28499	14084	1	0	7514
212491	1397	1265832718000	28501	14085	0	0	17299
212492	2134	83052479000	28501	14085	1	0	7515
212493	2133	89813276000	28501	14085	2	0	6864
212498	2134	83051476000	28503	14086	1	0	7516
212499	2133	89812274000	28503	14086	2	0	6865
212509	1397	1265812716000	28507	14087	0	0	17301
212510	2133	89811272000	28507	14087	1	0	6866
212536	2133	89810270000	28510	14088	1	0	6867
212537	2134	83050473000	28510	14088	2	0	7517
212541	1397	1265792714000	28512	14089	0	0	17303
212542	2134	83049470000	28512	14089	1	0	7518
212543	1726	932937112000	28512	14089	2	0	8348
212545	2133	89809268000	28512	14089	4	0	6868
212566	1397	1265782713000	28518	14090	0	0	17304
212567	2134	83048467000	28518	14090	1	0	7519
212568	2132	147220233000	28518	14090	2	0	1768
212573	1397	1265762711000	28520	14092	0	0	\N
212574	2134	83046461000	28520	14092	1	0	\N
212575	2133	89806262000	28520	14092	2	0	\N
212576	1397	1265762711000	28521	14092	0	0	\N
212577	2134	83046461000	28521	14092	1	0	\N
212578	2133	89806262000	28521	14092	2	0	\N
212587	2133	9556262000	28524	14093	0	0	\N
212588	1397	1265752710000	28524	14093	1	0	\N
212589	2134	83045458000	28524	14093	2	0	\N
212590	1725	0	28524	14093	3	0	\N
212591	2133	9555260000	28524	14093	4	0	\N
212592	2133	9556262000	28525	14093	0	0	\N
212593	1397	1265752710000	28525	14093	1	0	\N
212594	2134	83045458000	28525	14093	2	0	\N
212595	1725	0	28525	14093	3	0	\N
212596	2133	9555260000	28525	14093	4	0	\N
212603	1397	1265732708000	28527	14095	0	0	\N
212604	2133	9553256000	28527	14095	1	0	\N
212605	2132	7218232000	28527	14095	2	0	\N
212606	2134	83043452000	28527	14095	3	0	\N
212611	1397	1265732708000	28529	14095	0	0	\N
212612	2133	9553256000	28529	14095	1	0	\N
212613	2132	7218232000	28529	14095	2	0	\N
212614	2134	83043452000	28529	14095	3	0	\N
212626	1397	1265692704000	28532	14098	0	0	\N
212627	2133	9549248000	28532	14098	1	0	\N
212630	1397	1265692704000	28534	14098	0	0	\N
212631	2133	9549248000	28534	14098	1	0	\N
212632	1397	1265692704000	28535	14098	0	0	\N
212633	2133	9549248000	28535	14098	1	0	\N
212638	1397	1265672702000	28537	14100	0	0	\N
212639	2133	9547244000	28537	14100	1	0	\N
212640	1397	1265672702000	28538	14100	0	0	\N
212641	2133	9547244000	28538	14100	1	0	\N
212644	1397	1265672702000	28540	14100	0	0	\N
212645	2133	9547244000	28540	14100	1	0	\N
212648	2401	2078874500000	28542	13848	0	0	\N
212649	2385	890500000	28542	13848	1	0	\N
212650	2403	994500000	28542	13848	2	0	\N
212651	2385	786833330	28542	13848	3	0	\N
212652	1874	6326000	28542	13848	4	0	\N
212653	2132	147220233000	28542	13848	5	0	\N
212654	1725	0	28542	13848	6	0	\N
212655	1726	932937112000	28542	13848	7	0	\N
212656	1726	931836112000	28542	13848	8	0	\N
212657	338	67000023000000	28542	13848	9	0	\N
212658	2132	147219232000	28542	13848	10	0	\N
212659	2132	7218232000	28542	13848	11	0	\N
212660	2132	7217231000	28542	13848	12	0	\N
212661	2132	7216230000	28542	13848	13	0	\N
212662	2132	7215229000	28542	13848	14	0	\N
212663	1726	131835112000	28542	13848	15	0	\N
212664	1726	130734112000	28542	13848	16	0	\N
212673	1397	1265642699000	28545	14103	0	0	\N
212674	2133	9543236000	28545	14103	1	0	\N
212675	2134	12788435000	28545	14103	2	0	\N
212676	1397	1265642699000	28546	14103	0	0	\N
212677	2134	12788435000	28546	14103	1	0	\N
212680	1397	1265632698000	28548	14104	0	0	\N
212681	2133	9542234000	28548	14104	1	0	\N
212682	1397	1265632698000	28549	14104	0	0	\N
212683	2133	9542234000	28549	14104	1	0	\N
212684	1397	1265632698000	28550	14104	0	0	\N
212685	2133	9542234000	28550	14104	1	0	\N
212686	1397	1265632698000	28551	14104	0	0	\N
212687	2133	9542234000	28551	14104	1	0	\N
212688	1397	1265632698000	28552	14104	0	0	\N
212689	2133	9542234000	28552	14104	1	0	\N
212694	1397	1265622697000	28554	14105	0	0	\N
212695	2132	7214228000	28554	14105	1	0	\N
212696	2133	9541232000	28554	14105	2	0	\N
212697	2134	12787431000	28554	14105	3	0	\N
212698	1397	1265622697000	28555	14105	0	0	\N
212699	2132	7214228000	28555	14105	1	0	\N
212700	2133	9541232000	28555	14105	2	0	\N
212701	2134	12787431000	28555	14105	3	0	\N
212571	2133	89807264000	28519	14091	1	0	6870
212572	2134	83047464000	28519	14091	2	0	7520
212579	1397	1265762711000	28522	14092	0	0	17306
212580	2134	83046461000	28522	14092	1	0	7521
212581	2133	89806262000	28522	14092	2	0	6871
212583	1397	1265752710000	28523	14093	1	0	17307
212584	2134	83045458000	28523	14093	2	0	7522
212585	1725	0	28523	14093	3	0	2
212586	2133	9555260000	28523	14093	4	0	6873
212597	1397	1265742709000	28526	14094	0	0	17308
212599	2133	9554258000	28526	14094	2	0	6874
212600	2134	83044455000	28526	14094	3	0	7523
212601	2132	147219232000	28526	14094	4	0	1769
212602	1726	131835112000	28526	14094	5	0	8350
212608	2133	9553256000	28528	14095	1	0	6875
212609	2132	7218232000	28528	14095	2	0	1770
212610	2134	83043452000	28528	14095	3	0	7524
212615	1397	1265722707000	28530	14096	0	0	17310
212616	2133	9552254000	28530	14096	1	0	6876
212618	1397	1265712706000	28531	14097	0	0	17311
212619	1397	1265702705000	28531	14097	1	0	17312
212620	2133	9551252000	28531	14097	2	0	6877
212621	2133	9550250000	28531	14097	3	0	6878
212622	2134	83041446000	28531	14097	4	0	7526
212624	2134	12790443000	28531	14097	6	0	7528
212625	2132	7217231000	28531	14097	7	0	1771
212628	1397	1265692704000	28533	14098	0	0	17313
212629	2133	9549248000	28533	14098	1	0	6879
212635	1726	130734112000	28536	14099	1	0	8351
212636	2132	7216230000	28536	14099	2	0	1772
212637	2133	9548246000	28536	14099	3	0	6880
212642	1397	1265672702000	28539	14100	0	0	17315
212643	2133	9547244000	28539	14100	1	0	6881
212647	2133	9546242000	28541	14101	2	0	6882
212665	1397	1265652700000	28543	14102	0	0	17317
212666	2133	9545240000	28543	14102	1	0	6883
212667	2134	12789439000	28543	14102	2	0	7529
212668	2133	9544238000	28543	14102	3	0	6884
212670	1397	1265642699000	28544	14103	0	0	17318
212671	2133	9543236000	28544	14103	1	0	6885
212672	2134	12788435000	28544	14103	2	0	7530
212678	1397	1265632698000	28547	14104	0	0	17319
212690	1397	1265622697000	28553	14105	0	0	17320
212691	2132	7214228000	28553	14105	1	0	1774
212692	2133	9541232000	28553	14105	2	0	6887
212693	2134	12787431000	28553	14105	3	0	7531
212702	1397	1265612696000	28557	14106	0	0	17321
212704	2133	9540230000	28557	14106	2	0	6888
212712	1397	1265612696000	28559	14106	0	0	\N
212713	1397	1265602695000	28559	14106	1	0	\N
212714	1397	1265592694000	28559	14106	2	0	\N
212715	1397	1265582693000	28559	14106	3	0	\N
212716	1726	129633112000	28559	14106	4	0	\N
212717	2132	7213227000	28559	14106	5	0	\N
212718	2134	12786427000	28559	14106	6	0	\N
212719	2134	12785423000	28559	14106	7	0	\N
212720	2134	12784419000	28559	14106	8	0	\N
212721	2133	9540230000	28559	14106	9	0	\N
212722	2133	9539228000	28559	14106	10	0	\N
212723	2133	9538226000	28559	14106	11	0	\N
212724	2133	9537224000	28559	14106	12	0	\N
212737	1397	1265572692000	28562	14109	0	0	\N
212738	1397	1265562691000	28562	14109	1	0	\N
212739	1397	1265552690000	28562	14109	2	0	\N
212740	2134	12783415000	28562	14109	3	0	\N
212741	2134	12782411000	28562	14109	4	0	\N
212742	2133	9536222000	28562	14109	5	0	\N
212743	2133	9535220000	28562	14109	6	0	\N
212744	2133	9534218000	28562	14109	7	0	\N
212745	2132	7212226000	28562	14109	8	0	\N
212749	1397	1265532688000	28564	14111	0	0	\N
212750	1397	1265522687000	28564	14111	1	0	\N
212751	2134	12780403000	28564	14111	2	0	\N
212752	2132	7211225000	28564	14111	3	0	\N
212753	2133	9532214000	28564	14111	4	0	\N
212754	2133	9531212000	28564	14111	5	0	\N
212755	2134	12779399000	28564	14111	6	0	\N
212763	1397	1265532688000	28566	14111	0	0	\N
212764	1397	1265522687000	28566	14111	1	0	\N
212765	2134	12780403000	28566	14111	2	0	\N
212766	2132	7211225000	28566	14111	3	0	\N
212767	2133	9532214000	28566	14111	4	0	\N
212768	2133	9531212000	28566	14111	5	0	\N
212769	2134	12779399000	28566	14111	6	0	\N
212770	1397	1265512686000	28567	14112	0	0	\N
212771	1397	1265502685000	28567	14112	1	0	\N
212772	1397	1265492684000	28567	14112	2	0	\N
212773	2134	12778395000	28567	14112	3	0	\N
212774	2134	12777391000	28567	14112	4	0	\N
212775	2132	7210224000	28567	14112	5	0	\N
212776	2133	9530210000	28567	14112	6	0	\N
212777	2133	9529208000	28567	14112	7	0	\N
212778	2133	9528206000	28567	14112	8	0	\N
212779	1397	1265512686000	28568	14112	0	0	\N
212780	1397	1265502685000	28568	14112	1	0	\N
212781	1397	1265492684000	28568	14112	2	0	\N
212782	2134	12778395000	28568	14112	3	0	\N
212783	2134	12777391000	28568	14112	4	0	\N
212784	2132	7210224000	28568	14112	5	0	\N
212785	2133	9530210000	28568	14112	6	0	\N
212786	2133	9529208000	28568	14112	7	0	\N
212787	2133	9528206000	28568	14112	8	0	\N
212788	2401	2078874500000	28569	13882	0	0	\N
212789	2385	890500000	28569	13882	1	0	\N
212790	2385	786833330	28569	13882	2	0	\N
212791	1874	6501000	28569	13882	3	0	\N
212792	2132	147220233000	28569	13882	4	0	\N
212793	1725	0	28569	13882	6	0	\N
212794	1726	932937112000	28569	13882	7	0	\N
212795	1726	931836112000	28569	13882	8	0	\N
212796	2132	147219232000	28569	13882	9	0	\N
212797	2132	7218232000	28569	13882	10	0	\N
212798	2132	7217231000	28569	13882	11	0	\N
212799	2132	7216230000	28569	13882	12	0	\N
212800	2132	7215229000	28569	13882	13	0	\N
212801	2132	7214228000	28569	13882	14	0	\N
212802	2132	7213227000	28569	13882	15	0	\N
212803	2132	7212226000	28569	13882	16	0	\N
212804	2132	7211225000	28569	13882	17	0	\N
212805	2132	7210224000	28569	13882	18	0	\N
212806	1726	131835112000	28569	13882	19	0	\N
212807	1726	130734112000	28569	13882	20	0	\N
212808	1726	129633112000	28569	13882	21	0	\N
212818	1397	1265482683000	28571	14113	0	0	\N
212819	1397	1265472682000	28571	14113	1	0	\N
212820	2134	12776387000	28571	14113	2	0	\N
212821	2386	1090227000000	28571	14113	3	0	\N
212822	2133	9527204000	28571	14113	4	0	\N
212823	2133	9526202000	28571	14113	5	0	\N
212830	2133	9556262000	28573	14093	0	0	\N
212831	1397	1265752710000	28573	14093	1	0	\N
212832	1397	1265742709000	28573	14093	2	0	\N
212833	1397	1265732708000	28573	14093	3	0	\N
212834	1397	1265722707000	28573	14093	4	0	\N
212835	1397	1265712706000	28573	14093	5	0	\N
212836	1397	1265702705000	28573	14093	6	0	\N
212837	1397	1265692704000	28573	14093	7	0	\N
212838	1397	1265682703000	28573	14093	8	0	\N
212839	1397	1265672702000	28573	14093	9	0	\N
212840	1397	1265662701000	28573	14093	10	0	\N
212707	1726	129633112000	28558	14107	2	0	8352
212708	2134	12785423000	28558	14107	3	0	7533
212709	2133	9539228000	28558	14107	4	0	6889
212710	2133	9538226000	28558	14107	5	0	6890
212711	2132	7213227000	28558	14107	6	0	1775
212726	2133	9537224000	28560	14108	1	0	6891
212727	2134	12784419000	28560	14108	2	0	7534
212728	1397	1265572692000	28561	14109	0	0	17325
212729	1397	1265562691000	28561	14109	1	0	17326
212730	1397	1265552690000	28561	14109	2	0	17327
212732	2134	12782411000	28561	14109	4	0	7536
212733	2133	9536222000	28561	14109	5	0	6892
212734	2133	9535220000	28561	14109	6	0	6893
212735	2133	9534218000	28561	14109	7	0	6894
212746	1397	1265542689000	28563	14110	0	0	17328
212747	2134	12781407000	28563	14110	1	0	7537
212748	2133	9533216000	28563	14110	2	0	6895
212756	1397	1265532688000	28565	14111	0	0	17329
212757	1397	1265522687000	28565	14111	1	0	17330
212759	2132	7211225000	28565	14111	3	0	1777
212760	2133	9532214000	28565	14111	4	0	6896
212761	2133	9531212000	28565	14111	5	0	6897
212762	2134	12779399000	28565	14111	6	0	7539
212809	1397	1265512686000	28570	14112	0	0	17331
212811	1397	1265492684000	28570	14112	2	0	17333
212812	2134	12778395000	28570	14112	3	0	7540
212813	2134	12777391000	28570	14112	4	0	7541
212814	2132	7210224000	28570	14112	5	0	1778
212816	2133	9529208000	28570	14112	7	0	6899
212817	2133	9528206000	28570	14112	8	0	6900
212824	1397	1265482683000	28572	14113	0	0	17334
212825	1397	1265472682000	28572	14113	1	0	17335
212826	2134	12776387000	28572	14113	2	0	7542
212828	2133	9527204000	28572	14113	4	0	6901
212829	2133	9526202000	28572	14113	5	0	6902
212841	1397	1265652700000	28573	14093	11	0	\N
212842	1397	1265642699000	28573	14093	12	0	\N
212843	1397	1265632698000	28573	14093	13	0	\N
212844	1397	1265622697000	28573	14093	14	0	\N
212845	1397	1265612696000	28573	14093	15	0	\N
212846	1397	1265602695000	28573	14093	16	0	\N
212847	1397	1265592694000	28573	14093	17	0	\N
212848	1397	1265582693000	28573	14093	18	0	\N
212849	1397	1265572692000	28573	14093	19	0	\N
212850	1397	1265562691000	28573	14093	20	0	\N
212851	1397	1265552690000	28573	14093	21	0	\N
212852	1397	1265542689000	28573	14093	22	0	\N
212853	1397	1265532688000	28573	14093	23	0	\N
212854	1397	1265522687000	28573	14093	24	0	\N
212855	1397	1265512686000	28573	14093	25	0	\N
212856	1397	1265502685000	28573	14093	26	0	\N
212857	1397	1265492684000	28573	14093	27	0	\N
212858	1397	1265482683000	28573	14093	28	0	\N
212859	1397	1265472682000	28573	14093	29	0	\N
212860	1874	7525000	28573	14093	30	0	\N
212861	2134	83045458000	28573	14093	31	0	\N
212862	2386	80129000000	28573	14093	32	0	\N
212863	1725	0	28573	14093	33	0	\N
212864	2134	83044455000	28573	14093	34	0	\N
212865	2134	83043452000	28573	14093	35	0	\N
212866	2132	147219232000	28573	14093	36	0	\N
212867	2132	7218232000	28573	14093	37	0	\N
212868	2132	7217231000	28573	14093	38	0	\N
212869	2132	7216230000	28573	14093	39	0	\N
212870	2132	7215229000	28573	14093	40	0	\N
212871	2132	7214228000	28573	14093	41	0	\N
212872	2132	7213227000	28573	14093	42	0	\N
212873	2132	7212226000	28573	14093	43	0	\N
212874	2132	7211225000	28573	14093	44	0	\N
212875	2132	7210224000	28573	14093	45	0	\N
212876	1726	131835112000	28573	14093	46	0	\N
212877	1726	130734112000	28573	14093	47	0	\N
212878	1726	129633112000	28573	14093	48	0	\N
212879	2133	9555260000	28573	14093	49	0	\N
212880	2133	9554258000	28573	14093	50	0	\N
212881	2133	9553256000	28573	14093	52	0	\N
212882	2133	9552254000	28573	14093	53	0	\N
212883	2133	9551252000	28573	14093	54	0	\N
212884	2133	9550250000	28573	14093	55	0	\N
212885	2133	9549248000	28573	14093	56	0	\N
212886	2133	9548246000	28573	14093	57	0	\N
212887	2133	9547244000	28573	14093	58	0	\N
212888	2133	9546242000	28573	14093	59	0	\N
212889	2133	9545240000	28573	14093	60	0	\N
212890	2133	9544238000	28573	14093	61	0	\N
212891	2133	9543236000	28573	14093	62	0	\N
212892	2133	9542234000	28573	14093	63	0	\N
212893	2133	9541232000	28573	14093	64	0	\N
212894	2133	9540230000	28573	14093	65	0	\N
212895	2133	9539228000	28573	14093	66	0	\N
212896	2133	9538226000	28573	14093	67	0	\N
212897	2133	9537224000	28573	14093	68	0	\N
212898	2133	9536222000	28573	14093	69	0	\N
212899	2133	9535220000	28573	14093	70	0	\N
212900	2133	9534218000	28573	14093	71	0	\N
212901	2133	9533216000	28573	14093	72	0	\N
212902	2133	9532214000	28573	14093	73	0	\N
212903	2133	9531212000	28573	14093	74	0	\N
212904	2133	9530210000	28573	14093	75	0	\N
212905	2133	9529208000	28573	14093	76	0	\N
212906	2133	9528206000	28573	14093	77	0	\N
212907	2133	9527204000	28573	14093	78	0	\N
212908	2133	9526202000	28573	14093	79	0	\N
212909	2134	83042449000	28573	14093	80	0	\N
212910	2134	83041446000	28573	14093	81	0	\N
212911	2134	12791446000	28573	14093	82	0	\N
212912	2134	12790443000	28573	14093	83	0	\N
212913	2134	12789440000	28573	14093	84	0	\N
212914	2134	12788436000	28573	14093	85	0	\N
212915	2134	12787432000	28573	14093	86	0	\N
212916	2134	12786428000	28573	14093	87	0	\N
212917	2134	12785424000	28573	14093	88	0	\N
212918	2134	12784420000	28573	14093	89	0	\N
212919	2134	12783416000	28573	14093	90	0	\N
212920	2134	12782412000	28573	14093	91	0	\N
212921	2134	12781408000	28573	14093	92	0	\N
212922	2134	12780404000	28573	14093	93	0	\N
212923	2134	12779400000	28573	14093	94	0	\N
212924	2134	12778396000	28573	14093	95	0	\N
212925	2134	12777392000	28573	14093	96	0	\N
212926	2134	12776388000	28573	14093	97	0	\N
212927	1397	1265482683000	28574	14113	0	0	\N
212928	1397	1265472682000	28574	14113	1	0	\N
212929	2134	12776387000	28574	14113	2	0	\N
212930	2386	1090227000000	28574	14113	3	0	\N
212931	2133	9527204000	28574	14113	4	0	\N
212932	2133	9526202000	28574	14113	5	0	\N
212933	1397	1265482683000	28575	14113	0	0	\N
212934	1397	1265472682000	28575	14113	1	0	\N
212935	2134	12776387000	28575	14113	2	0	\N
212936	2386	1090227000000	28575	14113	3	0	\N
212937	2133	9527204000	28575	14113	4	0	\N
212938	2133	9526202000	28575	14113	5	0	\N
212939	1397	1265462681000	28576	14114	0	0	\N
212940	1397	1265452680000	28576	14114	1	0	\N
212941	2133	9525200000	28576	14114	2	0	\N
212942	2133	9524198000	28576	14114	3	0	\N
212943	2134	12775383000	28576	14114	4	0	\N
212944	2132	7209223000	28576	14114	5	0	\N
212945	2134	12774379000	28576	14114	6	0	\N
212946	1397	1265462681000	28577	14114	0	0	\N
212947	1397	1265452680000	28577	14114	1	0	\N
212948	2133	9525200000	28577	14114	2	0	\N
212949	2133	9524198000	28577	14114	3	0	\N
212950	2134	12775383000	28577	14114	4	0	\N
212951	2132	7209223000	28577	14114	5	0	\N
212952	2134	12774379000	28577	14114	6	0	\N
212960	2386	940227000000	28579	13883	0	0	\N
212961	2132	7209223000	28579	13883	1	0	\N
212967	1397	1265442679000	28581	14115	0	0	\N
212968	1397	1265432678000	28581	14115	1	0	\N
212969	2134	12773375000	28581	14115	2	0	\N
212970	2133	9523196000	28581	14115	3	0	\N
212971	2133	9522194000	28581	14115	4	0	\N
212972	1397	1265442679000	28582	14115	0	0	\N
212973	1397	1265432678000	28582	14115	1	0	\N
212974	2134	12773375000	28582	14115	2	0	\N
212975	2133	9523196000	28582	14115	3	0	\N
212976	2133	9522194000	28582	14115	4	0	\N
212955	2133	9525200000	28578	14114	2	0	6903
212956	2133	9524198000	28578	14114	3	0	6904
212957	2134	12775383000	28578	14114	4	0	7543
212958	2132	7209223000	28578	14114	5	0	1779
212959	2134	12774379000	28578	14114	6	0	7544
212963	1397	1265432678000	28580	14115	1	0	17339
212964	2134	12773375000	28580	14115	2	0	7545
212965	2133	9523196000	28580	14115	3	0	6905
212966	2133	9522194000	28580	14115	4	0	6906
212981	1397	1265422677000	28584	14116	0	0	\N
212982	2133	9521192000	28584	14116	1	0	\N
212983	2132	7208222000	28584	14116	2	0	\N
212984	2134	12772371000	28584	14116	3	0	\N
212994	1397	1265382673000	28586	14118	0	0	\N
212995	2133	9517184000	28586	14118	1	0	\N
212996	2134	12769359000	28586	14118	2	0	\N
213000	1397	1265372672000	28589	14119	0	0	\N
213001	2133	9516182000	28589	14119	2	0	\N
213002	2134	12768355000	28589	14119	3	0	\N
213003	1397	1265372672000	28590	14119	0	0	\N
213004	2133	9516182000	28590	14119	2	0	\N
213005	2134	12768355000	28590	14119	3	0	\N
213022	1588	17352010000000	28594	14121	0	0	\N
213023	1397	1265352670000	28594	14121	1	0	\N
213024	1588	17185630000000	28594	14121	2	0	\N
213025	1588	17073633000000	28594	14121	3	0	\N
213026	1588	16980782000000	28594	14121	4	0	\N
213027	2134	12767351000	28594	14121	5	0	\N
213028	2134	12766347000	28594	14121	6	0	\N
213029	2133	9514178000	28594	14121	7	0	\N
213030	2133	9513176000	28594	14121	8	0	\N
213031	1588	17352010000000	28595	14121	0	0	\N
213032	1397	1265352670000	28595	14121	1	0	\N
213033	1588	17185630000000	28595	14121	2	0	\N
213034	1588	17073633000000	28595	14121	3	0	\N
213035	1588	16980782000000	28595	14121	4	0	\N
213036	2134	12767351000	28595	14121	5	0	\N
213037	2134	12766347000	28595	14121	6	0	\N
213038	2133	9514178000	28595	14121	7	0	\N
213039	2133	9513176000	28595	14121	8	0	\N
213040	1588	17352010000000	28596	14121	0	0	\N
213041	1397	1265352670000	28596	14121	1	0	\N
213042	1588	17185630000000	28596	14121	2	0	\N
213043	1588	17073633000000	28596	14121	3	0	\N
213044	1588	16980782000000	28596	14121	4	0	\N
213045	2134	12767351000	28596	14121	5	0	\N
213046	2134	12766347000	28596	14121	6	0	\N
213047	2133	9514178000	28596	14121	7	0	\N
213048	2133	9513176000	28596	14121	8	0	\N
213052	1397	1265342669000	28598	14122	0	0	\N
213053	2134	12765343000	28598	14122	1	0	\N
213054	2133	9512174000	28598	14122	2	0	\N
213058	1397	1265322667000	28600	14124	0	0	\N
213059	2133	9510170000	28600	14124	1	0	\N
213060	2134	12764339000	28600	14124	2	0	\N
213061	1397	1265322667000	28601	14124	0	0	\N
213062	2133	9510170000	28601	14124	1	0	\N
213063	2134	12764339000	28601	14124	2	0	\N
213070	1397	1265312666000	28604	14125	0	0	\N
213071	2134	12763335000	28604	14125	1	0	\N
213072	2133	9509168000	28604	14125	2	0	\N
213077	1397	1265302665000	28606	14126	0	0	\N
213078	2133	9508166000	28606	14126	1	0	\N
213079	2134	12762331000	28606	14126	2	0	\N
213080	2132	7204218000	28606	14126	3	0	\N
213081	1588	17352010000000	28607	14117	0	0	\N
213082	1588	17185630000000	28607	14117	1	0	\N
213083	1588	17073633000000	28607	14117	2	0	\N
213084	1588	16980782000000	28607	14117	3	0	\N
213085	1726	128532112000	28607	14117	4	0	\N
213086	1397	1265292664000	28608	14127	0	0	\N
213087	2133	9507164000	28608	14127	1	0	\N
213088	1397	1265292664000	28609	14127	0	0	\N
213089	2133	9507164000	28609	14127	1	0	\N
213090	1397	1265292664000	28610	14127	0	0	\N
213091	2133	9507164000	28610	14127	1	0	\N
213104	1397	1265252660000	28615	14130	0	0	\N
213105	2133	9503156000	28615	14130	1	0	\N
213111	1397	1265232658000	28618	14132	0	0	\N
213112	2132	7202216000	28618	14132	1	0	\N
212979	2132	7208222000	28583	14116	2	0	1780
212980	2134	12772371000	28583	14116	3	0	7546
212985	1397	1265412676000	28585	14117	0	0	17341
212986	1397	1265402675000	28585	14117	1	0	17342
212987	1397	1265392674000	28585	14117	2	0	17343
212989	2132	7207221000	28585	14117	4	0	1781
212990	2133	9519188000	28585	14117	5	0	6909
212991	2133	9518186000	28585	14117	6	0	6910
212992	2134	12771367000	28585	14117	7	0	7547
212993	2134	12770363000	28585	14117	8	0	7548
212998	2133	9517184000	28587	14118	1	0	6911
212999	2134	12769359000	28587	14118	2	0	7549
213006	1397	1265372672000	28591	14119	0	0	17345
213007	2133	9516182000	28591	14119	2	0	6912
213009	1397	1265362671000	28592	14120	0	0	17346
213010	2133	9515180000	28592	14120	1	0	6913
213011	1726	128532112000	28592	14120	2	0	8353
213012	2132	7206220000	28592	14120	3	0	1782
213013	1588	17352010000000	28593	14121	0	0	14
213015	1588	17185630000000	28593	14121	2	0	15
213016	1588	17073633000000	28593	14121	3	0	16
213017	1588	16980782000000	28593	14121	4	0	17
213018	2134	12767351000	28593	14121	5	0	7551
213019	2134	12766347000	28593	14121	6	0	7552
213021	2133	9513176000	28593	14121	8	0	6915
213049	1397	1265342669000	28597	14122	0	0	17348
213050	2134	12765343000	28597	14122	1	0	7553
213051	2133	9512174000	28597	14122	2	0	6916
213056	2133	9511172000	28599	14123	1	0	6917
213057	2132	7205219000	28599	14123	2	0	1783
213064	1397	1265322667000	28602	14124	0	0	17350
213065	2133	9510170000	28602	14124	1	0	6918
213066	2134	12764339000	28602	14124	2	0	7554
213068	2134	12763335000	28603	14125	1	0	7555
213069	2133	9509168000	28603	14125	2	0	6919
213073	1397	1265302665000	28605	14126	0	0	17352
213074	2133	9508166000	28605	14126	1	0	6920
213075	2134	12762331000	28605	14126	2	0	7556
213092	1397	1265292664000	28611	14127	0	0	17353
213093	2133	9507164000	28611	14127	1	0	6921
213094	1397	1265282663000	28613	14128	0	0	17354
213095	2133	9506162000	28613	14128	1	0	6922
213097	1397	1265272662000	28614	14129	0	0	17355
213098	1397	1265262661000	28614	14129	1	0	17356
213099	2134	12760323000	28614	14129	2	0	7558
213100	2134	12759319000	28614	14129	3	0	7559
213101	2133	9505160000	28614	14129	4	0	6923
213103	2132	7203217000	28614	14129	6	0	1785
213106	1397	1265252660000	28616	14130	0	0	17357
213107	2133	9503156000	28616	14130	1	0	6925
213108	1397	1265242659000	28617	14131	0	0	17358
213109	2133	9502154000	28617	14131	1	0	6926
213113	2133	9501152000	28618	14132	2	0	\N
213114	2134	12757311000	28618	14132	3	0	\N
213115	1397	1265232658000	28619	14132	0	0	\N
213116	2132	7202216000	28619	14132	1	0	\N
213117	2133	9501152000	28619	14132	2	0	\N
213118	2134	12757311000	28619	14132	3	0	\N
213119	1397	1265232658000	28620	14132	0	0	\N
213120	2132	7202216000	28620	14132	1	0	\N
213121	2133	9501152000	28620	14132	2	0	\N
213122	2134	12757311000	28620	14132	3	0	\N
213130	1588	17352010000000	28623	14089	0	0	\N
213131	1588	17185630000000	28623	14089	1	0	\N
213132	1588	17073633000000	28623	14089	2	0	\N
213133	1588	16980782000000	28623	14089	3	0	\N
213134	1874	7504000	28623	14089	4	0	\N
213135	2386	129000000	28623	14089	5	0	\N
213136	2132	147220233000	28623	14089	6	0	\N
213137	1725	0	28623	14089	7	0	\N
213138	2132	147219232000	28623	14089	8	0	\N
213139	2132	7218232000	28623	14089	9	0	\N
213140	2132	7217231000	28623	14089	10	0	\N
213141	2132	7216230000	28623	14089	11	0	\N
213142	2132	7215229000	28623	14089	12	0	\N
213143	2132	7214228000	28623	14089	13	0	\N
213144	2132	7213227000	28623	14089	14	0	\N
213145	2132	7212226000	28623	14089	15	0	\N
213146	2132	7211225000	28623	14089	16	0	\N
213147	2132	7210224000	28623	14089	17	0	\N
213148	2132	7209223000	28623	14089	18	0	\N
213149	2132	7208222000	28623	14089	19	0	\N
213150	2132	7207221000	28623	14089	20	0	\N
213151	2132	7206220000	28623	14089	21	0	\N
213152	2132	7205219000	28623	14089	22	0	\N
213153	2132	7204218000	28623	14089	23	0	\N
213154	2132	7203217000	28623	14089	24	0	\N
213155	2132	7202216000	28623	14089	25	0	\N
213157	1397	1265202655000	28625	14135	0	0	\N
213158	2133	9499148000	28625	14135	1	0	\N
213159	2134	12755303000	28625	14135	2	0	\N
213160	2132	7201215000	28625	14135	3	0	\N
213161	1588	16631998000000	28626	13884	0	0	\N
213162	1588	16465618000000	28626	13884	1	0	\N
213163	1588	16353621000000	28626	13884	2	0	\N
213164	1588	16260770000000	28626	13884	3	0	\N
213165	2132	7208222000	28626	13884	4	0	\N
213166	2132	7207221000	28626	13884	5	0	\N
213167	1726	128532112000	28626	13884	6	0	\N
213168	2132	7206220000	28626	13884	7	0	\N
213169	2132	7205219000	28626	13884	8	0	\N
213170	2132	7204218000	28626	13884	9	0	\N
213171	2132	7203217000	28626	13884	10	0	\N
213172	2132	7202216000	28626	13884	11	0	\N
213173	2132	7201215000	28626	13884	12	0	\N
213193	2132	7200214000	28630	13885	0	0	\N
213194	1397	1265142649000	28631	14138	0	0	\N
213195	2133	9493136000	28631	14138	1	0	\N
213196	1397	1265142649000	28632	14138	0	0	\N
213197	2133	9493136000	28632	14138	1	0	\N
213206	1397	1265132648000	28635	14139	0	0	\N
213207	1397	1265122647000	28635	14139	1	0	\N
213208	2132	7199213000	28635	14139	2	0	\N
213209	2133	9492134000	28635	14139	3	0	\N
213210	2134	12750283000	28635	14139	4	0	\N
213211	2134	12749279000	28635	14139	5	0	\N
213212	1397	1265112646000	28636	14140	0	0	\N
213213	2134	12748275000	28636	14140	1	0	\N
213216	1397	1265102645000	28638	14141	0	0	\N
213217	2132	7198212000	28638	14141	1	0	\N
213218	1588	17352010000000	28639	13934	0	0	\N
213219	1588	17185630000000	28639	13934	1	0	\N
213220	1588	17073633000000	28639	13934	2	0	\N
213221	1588	16980782000000	28639	13934	3	0	\N
213222	1874	6856000	28639	13934	4	0	\N
213223	2386	129000000	28639	13934	5	0	\N
213224	1725	0	28639	13934	6	0	\N
213225	1726	932937112000	28639	13934	7	0	\N
213226	1726	931836112000	28639	13934	8	0	\N
213227	2133	89810270000	28639	13934	9	0	\N
213228	2133	89809268000	28639	13934	10	0	\N
213229	2133	89808266000	28639	13934	11	0	\N
213230	2133	89807264000	28639	13934	12	0	\N
213231	1726	131835112000	28639	13934	13	0	\N
213232	1726	130734112000	28639	13934	14	0	\N
213233	1726	129633112000	28639	13934	15	0	\N
213234	1726	128532112000	28639	13934	16	0	\N
213235	2133	89806262000	28639	13934	17	0	\N
213236	2133	9556262000	28639	13934	18	0	\N
213237	2133	9555260000	28639	13934	19	0	\N
213238	2133	9554258000	28639	13934	20	0	\N
213239	2133	9553256000	28639	13934	21	0	\N
213240	2133	9552254000	28639	13934	22	0	\N
213241	2133	9551252000	28639	13934	23	0	\N
213242	2133	9550250000	28639	13934	24	0	\N
213243	2133	9549248000	28639	13934	25	0	\N
213244	2133	9548246000	28639	13934	26	0	\N
213245	2133	9547244000	28639	13934	27	0	\N
213246	2133	9546242000	28639	13934	28	0	\N
213247	2133	9545240000	28639	13934	29	0	\N
213248	2133	9544238000	28639	13934	30	0	\N
213125	2133	9501152000	28621	14132	2	0	6927
213126	2134	12757311000	28621	14132	3	0	7561
213127	1397	1265222657000	28622	14133	0	0	17360
213128	2133	9500150000	28622	14133	1	0	6928
213129	2134	12756307000	28622	14133	2	0	7562
213174	1397	1265202655000	28627	14135	0	0	17362
213175	2133	9499148000	28627	14135	1	0	6929
213176	2134	12755303000	28627	14135	2	0	7563
213177	2132	7201215000	28627	14135	3	0	1787
213178	1397	1265192654000	28628	14136	0	0	17363
213180	2133	9498146000	28628	14136	2	0	6930
213181	1397	1265182653000	28629	14137	0	0	17364
213182	1397	1265172652000	28629	14137	1	0	17365
213183	1397	1265162651000	28629	14137	2	0	17366
213185	2133	9497144000	28629	14137	4	0	6931
213186	2134	12753295000	28629	14137	5	0	7565
213187	2132	7200214000	28629	14137	6	0	1788
213188	2134	12752291000	28629	14137	7	0	7566
213189	2134	12751287000	28629	14137	8	0	7567
213191	2133	9495140000	28629	14137	10	0	6933
213192	2133	9494138000	28629	14137	11	0	6934
213198	1397	1265142649000	28633	14138	0	0	17368
213199	2133	9493136000	28633	14138	1	0	6935
213200	1397	1265132648000	28634	14139	0	0	17369
213202	2132	7199213000	28634	14139	2	0	1789
213203	2133	9492134000	28634	14139	3	0	6936
213204	2134	12750283000	28634	14139	4	0	7568
213205	2134	12749279000	28634	14139	5	0	7569
213215	2134	12748275000	28637	14140	1	0	7570
213249	2133	9543236000	28639	13934	31	0	\N
213250	2133	9542234000	28639	13934	32	0	\N
213251	2133	9541232000	28639	13934	33	0	\N
213252	2133	9540230000	28639	13934	34	0	\N
213253	2133	9539228000	28639	13934	35	0	\N
213254	2133	9538226000	28639	13934	36	0	\N
213255	2133	9537224000	28639	13934	37	0	\N
213256	2133	9536222000	28639	13934	38	0	\N
213257	2133	9535220000	28639	13934	39	0	\N
213258	2133	9534218000	28639	13934	40	0	\N
213259	2133	9533216000	28639	13934	41	0	\N
213260	2133	9532214000	28639	13934	42	0	\N
213261	2133	9531212000	28639	13934	43	0	\N
213262	2133	9530210000	28639	13934	44	0	\N
213263	2133	9529208000	28639	13934	45	0	\N
213264	2133	9528206000	28639	13934	46	0	\N
213265	2133	9527204000	28639	13934	47	0	\N
213266	2133	9526202000	28639	13934	48	0	\N
213267	2133	9525200000	28639	13934	49	0	\N
213268	2133	9524198000	28639	13934	50	0	\N
213269	2133	9523196000	28639	13934	51	0	\N
213270	2133	9522194000	28639	13934	52	0	\N
213271	2133	9521192000	28639	13934	53	0	\N
213272	2133	9520190000	28639	13934	54	0	\N
213273	2133	9519188000	28639	13934	55	0	\N
213274	2133	9518186000	28639	13934	56	0	\N
213275	2133	9517184000	28639	13934	57	0	\N
213276	2133	9516182000	28639	13934	58	0	\N
213277	2133	9515180000	28639	13934	59	0	\N
213278	2133	9514178000	28639	13934	60	0	\N
213279	2133	9513176000	28639	13934	61	0	\N
213280	2133	9512174000	28639	13934	62	0	\N
213281	2133	9511172000	28639	13934	63	0	\N
213282	2133	9510170000	28639	13934	64	0	\N
213283	2133	9509168000	28639	13934	65	0	\N
213284	2133	9508166000	28639	13934	66	0	\N
213285	2133	9507164000	28639	13934	68	0	\N
213286	2133	9506162000	28639	13934	69	0	\N
213287	2133	9505160000	28639	13934	70	0	\N
213288	2133	9504158000	28639	13934	71	0	\N
213289	2133	9503156000	28639	13934	72	0	\N
213290	2133	9502154000	28639	13934	73	0	\N
213291	2133	9501152000	28639	13934	74	0	\N
213292	2133	9500150000	28639	13934	75	0	\N
213293	2133	9499148000	28639	13934	76	0	\N
213294	2133	9498146000	28639	13934	77	0	\N
213295	2133	9497144000	28639	13934	78	0	\N
213296	2133	9496142000	28639	13934	79	0	\N
213297	2133	9495140000	28639	13934	80	0	\N
213298	2133	9494138000	28639	13934	81	0	\N
213299	2133	9493136000	28639	13934	82	0	\N
213300	2133	9492134000	28639	13934	83	0	\N
213301	1397	1265102645000	28640	14141	0	0	\N
213302	2132	7198212000	28640	14141	1	0	\N
213309	2132	7201215000	28643	14090	0	0	\N
213310	2132	7200214000	28643	14090	1	0	\N
213311	2132	7199213000	28643	14090	2	0	\N
213312	2132	7198212000	28643	14090	3	0	\N
213313	1397	1265092644000	28644	14142	0	0	\N
213314	1397	1265082643000	28644	14142	1	0	\N
213315	2134	12747271000	28644	14142	2	0	\N
213316	2134	12746267000	28644	14142	3	0	\N
213317	2134	12745263000	28645	14143	0	0	\N
213318	2132	7197211000	28645	14143	1	0	\N
213319	1397	1265072642000	28646	14143	0	0	\N
213320	2134	12745263000	28646	14143	1	0	\N
213321	2132	7197211000	28646	14143	2	0	\N
213325	1397	1265072642000	28648	14143	0	0	\N
213326	2134	12745263000	28648	14143	1	0	\N
213327	2132	7197211000	28648	14143	2	0	\N
213328	1397	1265062641000	28649	14144	0	0	\N
213346	1397	1264982633000	28654	14148	0	0	\N
213347	1397	1264972632000	28654	14148	1	0	\N
213348	1397	1264962631000	28654	14148	2	0	\N
213349	2134	12738235000	28654	14148	3	0	\N
213350	2134	12737231000	28654	14148	4	0	\N
213351	2132	7194208000	28654	14148	5	0	\N
213358	1397	1264982633000	28656	14148	0	0	\N
213359	1397	1264972632000	28656	14148	1	0	\N
213360	1397	1264962631000	28656	14148	2	0	\N
213361	2134	12738235000	28656	14148	3	0	\N
213362	2134	12737231000	28656	14148	4	0	\N
213363	2132	7194208000	28656	14148	5	0	\N
213364	1397	1264982633000	28657	14148	0	0	\N
213365	1397	1264972632000	28657	14148	1	0	\N
213366	1397	1264962631000	28657	14148	2	0	\N
213367	2134	12738235000	28657	14148	3	0	\N
213368	2134	12737231000	28657	14148	4	0	\N
213369	2132	7194208000	28657	14148	5	0	\N
213370	1754	4994000000	28658	14091	0	0	\N
213371	2132	7197211000	28658	14091	1	0	\N
213372	2132	7196210000	28658	14091	2	0	\N
213373	2132	7195209000	28658	14091	3	0	\N
213374	2132	7194208000	28658	14091	4	0	\N
213378	1397	1264942629000	28662	14150	0	0	\N
213384	1588	17352010000000	28665	13945	0	0	\N
213305	1397	1265092644000	28642	14142	0	0	17373
213306	1397	1265082643000	28642	14142	1	0	17374
213307	2134	12747271000	28642	14142	2	0	7571
213308	2134	12746267000	28642	14142	3	0	7572
213322	1397	1265072642000	28647	14143	0	0	17375
213324	2132	7197211000	28647	14143	2	0	1791
213329	1397	1265062641000	28650	14144	0	0	17376
213330	1397	1265052640000	28651	14145	0	0	17377
213331	1397	1265042639000	28651	14145	1	0	17378
213332	2134	12744259000	28651	14145	2	0	7574
213334	1397	1265032638000	28652	14146	0	0	17379
213335	1397	1265022637000	28652	14146	1	0	17380
213336	1754	4994000000	28652	14146	2	0	5
213337	2132	7196210000	28652	14146	3	0	1792
213339	1397	1265012636000	28653	14147	0	0	17381
213340	1397	1265002635000	28653	14147	1	0	17382
213341	1397	1264992634000	28653	14147	2	0	17383
213342	2132	7195209000	28653	14147	3	0	1793
213343	2134	12741247000	28653	14147	4	0	7577
213345	2134	12739239000	28653	14147	6	0	7579
213352	1397	1264982633000	28655	14148	0	0	17384
213353	1397	1264972632000	28655	14148	1	0	17385
213354	1397	1264962631000	28655	14148	2	0	17386
213355	2134	12738235000	28655	14148	3	0	7580
213357	2132	7194208000	28655	14148	5	0	1794
213375	1397	1264952630000	28659	14149	0	0	17387
213376	2134	12736227000	28659	14149	1	0	7582
213377	1397	1264942629000	28661	14150	0	0	17388
213380	2132	7193207000	28663	14151	1	0	1795
213381	2134	12735223000	28663	14151	2	0	7583
213382	1397	1264922627000	28664	14152	0	0	17390
213383	2134	12734219000	28664	14152	1	0	7584
213385	1789	2980000000	28665	13945	1	0	\N
213386	1789	90000000	28665	13945	2	0	\N
213387	329	67367601000000	28665	13945	3	0	\N
213388	329	66000591000000	28665	13945	4	0	\N
213389	1507	49990000000	28665	13945	5	0	\N
213390	1588	17185630000000	28665	13945	6	0	\N
213391	1588	17073633000000	28665	13945	7	0	\N
213392	1588	16980782000000	28665	13945	8	0	\N
213393	2385	890500000	28665	13945	9	0	\N
213394	2385	786833330	28665	13945	10	0	\N
213395	1754	4994000000	28665	13945	11	0	\N
213396	1874	6888000	28665	13945	12	0	\N
213397	2386	129000000	28665	13945	13	0	\N
213398	338	67438024000000	28665	13945	14	0	\N
213399	1725	0	28665	13945	15	0	\N
213400	1379	1693978636751650	28665	13945	16	0	\N
213401	1726	932937112000	28665	13945	17	0	\N
213402	1726	931836112000	28665	13945	18	0	\N
213403	2133	89814278000	28665	13945	19	0	\N
213404	338	67000023000000	28665	13945	20	0	\N
213405	1726	131835112000	28665	13945	21	0	\N
213406	1726	130734112000	28665	13945	22	0	\N
213407	1726	129633112000	28665	13945	23	0	\N
213408	1726	128532112000	28665	13945	24	0	\N
213409	2133	89813276000	28665	13945	25	0	\N
213410	2133	89812274000	28665	13945	26	0	\N
213411	2133	89811272000	28665	13945	27	0	\N
213412	2133	89810270000	28665	13945	28	0	\N
213413	2133	89809268000	28665	13945	29	0	\N
213414	2133	89808266000	28665	13945	31	0	\N
213415	2133	89807264000	28665	13945	32	0	\N
213416	2133	89806262000	28665	13945	33	0	\N
213417	2133	9556262000	28665	13945	34	0	\N
213418	2133	9555260000	28665	13945	35	0	\N
213419	2133	9554258000	28665	13945	36	0	\N
213420	2133	9553256000	28665	13945	37	0	\N
213421	2133	9552254000	28665	13945	38	0	\N
213422	2133	9551252000	28665	13945	39	0	\N
213423	2133	9550250000	28665	13945	40	0	\N
213424	2133	9549248000	28665	13945	41	0	\N
213425	2133	9548246000	28665	13945	42	0	\N
213426	2133	9547244000	28665	13945	43	0	\N
213427	2133	9546242000	28665	13945	44	0	\N
213428	2133	9545240000	28665	13945	45	0	\N
213429	2133	9544238000	28665	13945	46	0	\N
213430	2133	9543236000	28665	13945	47	0	\N
213431	2133	9542234000	28665	13945	48	0	\N
213432	2133	9541232000	28665	13945	49	0	\N
213433	2133	9540230000	28665	13945	50	0	\N
213434	2133	9539228000	28665	13945	51	0	\N
213435	2133	9538226000	28665	13945	52	0	\N
213436	2133	9537224000	28665	13945	53	0	\N
213437	2133	9536222000	28665	13945	54	0	\N
213438	2133	9535220000	28665	13945	55	0	\N
213439	2133	9534218000	28665	13945	56	0	\N
213440	2133	9533216000	28665	13945	57	0	\N
213441	2133	9532214000	28665	13945	58	0	\N
213442	2133	9531212000	28665	13945	59	0	\N
213443	2133	9530210000	28665	13945	60	0	\N
213444	2133	9529208000	28665	13945	61	0	\N
213445	2133	9528206000	28665	13945	62	0	\N
213446	2133	9527204000	28665	13945	63	0	\N
213447	2133	9526202000	28665	13945	64	0	\N
213448	2133	9525200000	28665	13945	65	0	\N
213449	2133	9524198000	28665	13945	66	0	\N
213450	2133	9523196000	28665	13945	67	0	\N
213451	1397	1264912626000	28666	14153	0	0	\N
213452	2134	12733215000	28666	14153	1	0	\N
213459	1397	1264882623000	28669	14155	0	0	\N
213460	1379	2000001650	28669	14155	1	0	\N
213461	2134	12731207000	28669	14155	2	0	\N
213462	1397	1264882623000	28670	14155	0	0	\N
213463	1379	2000001650	28670	14155	1	0	\N
213464	2134	12731207000	28670	14155	2	0	\N
213468	1588	17352010000000	28672	14094	0	0	\N
213469	1588	17185630000000	28672	14094	1	0	\N
213470	1588	17073633000000	28672	14094	2	0	\N
213471	1588	16980782000000	28672	14094	3	0	\N
213472	1397	1265462681000	28672	14094	4	0	\N
213473	1397	1265452680000	28672	14094	5	0	\N
213474	1397	1265442679000	28672	14094	6	0	\N
213475	1397	1265432678000	28672	14094	7	0	\N
213476	1397	1265422677000	28672	14094	8	0	\N
213477	1397	1265412676000	28672	14094	9	0	\N
213478	1397	1265402675000	28672	14094	10	0	\N
213479	1397	1265392674000	28672	14094	11	0	\N
213480	1397	1265382673000	28672	14094	12	0	\N
213481	1397	1265372672000	28672	14094	13	0	\N
213482	1397	1265362671000	28672	14094	14	0	\N
213483	1397	1265352670000	28672	14094	15	0	\N
213484	1397	1265342669000	28672	14094	16	0	\N
213485	1397	1265332668000	28672	14094	17	0	\N
213486	1397	1265322667000	28672	14094	18	0	\N
213487	1397	1265312666000	28672	14094	19	0	\N
213488	1397	1265302665000	28672	14094	20	0	\N
213489	1397	1265292664000	28672	14094	21	0	\N
213490	1397	1265282663000	28672	14094	22	0	\N
213491	1397	1265272662000	28672	14094	23	0	\N
213492	1397	1265262661000	28672	14094	24	0	\N
213493	1397	1265252660000	28672	14094	25	0	\N
213494	1397	1265242659000	28672	14094	26	0	\N
213495	1397	1265232658000	28672	14094	27	0	\N
213496	1397	1265222657000	28672	14094	28	0	\N
213497	1397	1265212656000	28672	14094	29	0	\N
213498	1397	1265202655000	28672	14094	30	0	\N
213499	1397	1265192654000	28672	14094	31	0	\N
213500	1397	1265182653000	28672	14094	32	0	\N
213501	1397	1265172652000	28672	14094	33	0	\N
213502	1397	1265162651000	28672	14094	34	0	\N
213503	1397	1265152650000	28672	14094	35	0	\N
213504	1397	1265142649000	28672	14094	36	0	\N
213505	1397	1265132648000	28672	14094	37	0	\N
213506	1397	1265122647000	28672	14094	38	0	\N
213507	1397	1265112646000	28672	14094	39	0	\N
213508	1397	1265102645000	28672	14094	40	0	\N
213509	1397	1265092644000	28672	14094	41	0	\N
213510	1397	1265082643000	28672	14094	42	0	\N
213511	1397	1265072642000	28672	14094	43	0	\N
213512	1397	1265062641000	28672	14094	44	0	\N
213513	1397	1265052640000	28672	14094	45	0	\N
213514	1397	1265042639000	28672	14094	46	0	\N
213515	1397	1265032638000	28672	14094	47	0	\N
213516	1397	1265022637000	28672	14094	48	0	\N
213517	1397	1265012636000	28672	14094	49	0	\N
213518	1397	1265002635000	28672	14094	50	0	\N
213519	1397	1264992634000	28672	14094	51	0	\N
213520	1397	1264982633000	28672	14094	52	0	\N
213455	1397	1264902625000	28668	14154	0	0	17392
213456	1397	1264892624000	28668	14154	1	0	17393
213457	2132	7192206000	28668	14154	2	0	1796
213458	2134	12732211000	28668	14154	3	0	7586
213465	1397	1264882623000	28671	14155	0	0	17394
213467	2134	12731207000	28671	14155	2	0	7587
213521	1397	1264972632000	28672	14094	53	0	\N
213522	1397	1264962631000	28672	14094	54	0	\N
213523	1397	1264952630000	28672	14094	55	0	\N
213524	1397	1264942629000	28672	14094	56	0	\N
213525	1397	1264932628000	28672	14094	57	0	\N
213526	1397	1264922627000	28672	14094	58	0	\N
213527	1397	1264912626000	28672	14094	59	0	\N
213528	1397	1264902625000	28672	14094	60	0	\N
213529	1397	1264892624000	28672	14094	61	0	\N
213530	1397	1264882623000	28672	14094	62	0	\N
213531	1754	4994000000	28672	14094	63	0	\N
213532	2133	9525200000	28672	14094	64	0	\N
213533	2133	9524198000	28672	14094	65	0	\N
213534	1726	128532112000	28672	14094	66	0	\N
213535	2133	9523196000	28672	14094	67	0	\N
213536	1379	2000001650	28672	14094	68	0	\N
213537	2132	7209223000	28672	14094	69	0	\N
213538	2132	7208222000	28672	14094	70	0	\N
213539	2132	7207221000	28672	14094	71	0	\N
213540	2132	7206220000	28672	14094	72	0	\N
213541	2132	7205219000	28672	14094	73	0	\N
213542	2132	7204218000	28672	14094	74	0	\N
213543	2133	9522194000	28672	14094	75	0	\N
213544	2133	9521192000	28672	14094	76	0	\N
213545	2133	9520190000	28672	14094	77	0	\N
213546	2133	9519188000	28672	14094	78	0	\N
213547	2133	9518186000	28672	14094	80	0	\N
213548	2133	9517184000	28672	14094	81	0	\N
213549	2133	9516182000	28672	14094	82	0	\N
213550	2133	9515180000	28672	14094	83	0	\N
213551	2132	7203217000	28672	14094	84	0	\N
213552	2132	7202216000	28672	14094	85	0	\N
213553	2132	7201215000	28672	14094	86	0	\N
213554	2132	7200214000	28672	14094	87	0	\N
213555	2132	7199213000	28672	14094	88	0	\N
213556	2132	7198212000	28672	14094	89	0	\N
213557	2132	7197211000	28672	14094	90	0	\N
213558	2132	7196210000	28672	14094	91	0	\N
213559	2132	7195209000	28672	14094	92	0	\N
213560	2132	7194208000	28672	14094	93	0	\N
213561	2132	7193207000	28672	14094	94	0	\N
213562	2132	7192206000	28672	14094	95	0	\N
213563	2133	9514178000	28672	14094	96	0	\N
213564	2133	9513176000	28672	14094	97	0	\N
213565	2133	9512174000	28672	14094	98	0	\N
213566	2133	9511172000	28672	14094	99	0	\N
213567	2133	9510170000	28672	14094	100	0	\N
213568	2133	9509168000	28672	14094	101	0	\N
213569	2133	9508166000	28672	14094	102	0	\N
213570	2133	9507164000	28672	14094	103	0	\N
213571	2133	9506162000	28672	14094	104	0	\N
213572	2133	9505160000	28672	14094	105	0	\N
213573	2133	9504158000	28672	14094	106	0	\N
213574	2133	9503156000	28672	14094	107	0	\N
213575	2133	9502154000	28672	14094	108	0	\N
213576	2133	9501152000	28672	14094	109	0	\N
213577	2133	9500150000	28672	14094	110	0	\N
213578	2133	9499148000	28672	14094	111	0	\N
213579	2133	9498146000	28672	14094	112	0	\N
213580	2133	9497144000	28672	14094	113	0	\N
213581	2133	9496142000	28672	14094	114	0	\N
213582	2133	9495140000	28672	14094	115	0	\N
213583	2133	9494138000	28672	14094	116	0	\N
213584	2133	9493136000	28672	14094	117	0	\N
213585	2133	9492134000	28672	14094	118	0	\N
213586	1397	1264872622000	28673	14156	0	0	\N
213587	1397	1264862621000	28673	14156	1	0	\N
213588	2132	7191205000	28673	14156	2	0	\N
213589	2134	12730203000	28673	14156	3	0	\N
213590	1397	1264872622000	28674	14156	0	0	\N
213591	1397	1264862621000	28674	14156	1	0	\N
213592	2132	7191205000	28674	14156	2	0	\N
213593	2134	12730203000	28674	14156	3	0	\N
213598	1397	1264872622000	28676	14156	0	0	\N
213599	1397	1264862621000	28676	14156	1	0	\N
213600	2132	7191205000	28676	14156	2	0	\N
213601	2134	12730203000	28676	14156	3	0	\N
213602	1754	4994000000	28677	13886	0	0	\N
213603	2132	7199213000	28677	13886	1	0	\N
213604	1379	2000001650	28677	13886	2	0	\N
213605	2132	7198212000	28677	13886	3	0	\N
213606	2132	7197211000	28677	13886	4	0	\N
213607	2132	7196210000	28677	13886	5	0	\N
213608	2132	7195209000	28677	13886	6	0	\N
213609	2132	7194208000	28677	13886	7	0	\N
213610	2132	7193207000	28677	13886	8	0	\N
213611	2132	7192206000	28677	13886	9	0	\N
213612	2132	7191205000	28677	13886	10	0	\N
213621	1397	1264832618000	28680	14158	0	0	\N
213622	2134	12727191000	28680	14158	1	0	\N
213623	2132	7190204000	28680	14158	2	0	\N
213624	2133	9491132000	28680	14158	3	0	\N
213627	2132	7190204000	28682	13887	0	0	\N
213635	1397	1264802615000	28686	14161	0	0	\N
213636	2133	9488126000	28686	14161	1	0	\N
213637	2132	7189203000	28686	14161	2	0	\N
213638	2134	12725183000	28686	14161	3	0	\N
213639	1397	1264802615000	28687	14161	0	0	\N
213640	2133	9488126000	28687	14161	1	0	\N
213641	2132	7189203000	28687	14161	2	0	\N
213642	2134	12725183000	28687	14161	3	0	\N
213655	1397	1264762611000	28692	14165	0	0	\N
213656	2134	12722171000	28692	14165	1	0	\N
213596	2132	7191205000	28675	14156	2	0	1797
213597	2134	12730203000	28675	14156	3	0	7588
213613	1397	1264852620000	28678	14157	0	0	17397
213614	1397	1264842619000	28678	14157	1	0	17398
213615	2134	12729199000	28678	14157	2	0	7589
213617	1397	1264832618000	28679	14158	0	0	17399
213618	2134	12727191000	28679	14158	1	0	7591
213619	2132	7190204000	28679	14158	2	0	1798
213620	2133	9491132000	28679	14158	3	0	6937
213625	1397	1264822617000	28681	14159	0	0	17400
213628	1397	1264812616000	28683	14160	0	0	17401
213629	2134	12726187000	28683	14160	1	0	7592
213630	2133	9489128000	28683	14160	2	0	6939
213631	1397	1264802615000	28685	14161	0	0	17402
213633	2132	7189203000	28685	14161	2	0	1799
213634	2134	12725183000	28685	14161	3	0	7593
213643	1397	1264792614000	28688	14162	0	0	17403
213644	2133	9487124000	28688	14162	1	0	6941
213645	2134	12724179000	28688	14162	2	0	7594
213647	2133	9486122000	28689	14163	1	0	6942
213648	1397	1264772612000	28690	14164	0	0	17405
213649	2133	9485120000	28690	14164	1	0	6943
213650	2132	7188202000	28690	14164	2	0	1800
213651	2134	12723175000	28690	14164	3	0	7595
213653	2134	12722171000	28691	14165	1	0	7596
213654	2133	9484118000	28691	14165	2	0	6944
213657	2133	9484118000	28692	14165	2	0	\N
213658	1397	1264762611000	28693	14165	0	0	\N
213659	2134	12722171000	28693	14165	1	0	\N
213660	2133	9484118000	28693	14165	2	0	\N
213663	1397	1264752610000	28695	14166	0	0	\N
213664	2133	9483116000	28695	14166	1	0	\N
213665	1397	1264742609000	28696	14167	0	0	\N
213666	2133	9482114000	28696	14167	1	0	\N
213667	2134	12721167000	28696	14167	2	0	\N
213668	1397	1264742609000	28697	14167	0	0	\N
213669	2133	9482114000	28697	14167	1	0	\N
213670	2134	12721167000	28697	14167	2	0	\N
213687	1397	1264692604000	28704	14172	0	0	\N
213688	2133	9477104000	28704	14172	1	0	\N
213689	2134	12717151000	28704	14172	2	0	\N
213693	2133	9477104000	28706	14172	0	0	\N
213694	2134	12717151000	28706	14172	1	0	\N
213695	2133	9476102000	28707	14173	0	0	\N
213696	2133	9476102000	28709	14173	0	0	\N
213697	2133	9476102000	28711	14173	0	0	\N
213698	2133	9476102000	28712	14173	0	0	\N
213699	2133	9476102000	28713	14173	0	0	\N
213700	2133	9476102000	28714	14173	0	0	\N
213705	1397	1264682603000	28720	14174	0	0	\N
213706	2134	12716147000	28720	14174	1	0	\N
213707	2132	7185199000	28720	14174	2	0	\N
213708	2133	9475100000	28720	14174	3	0	\N
213709	1397	1264682603000	28721	14174	0	0	\N
213710	2134	12716147000	28721	14174	1	0	\N
213711	2132	7185199000	28721	14174	2	0	\N
213712	2133	9475100000	28721	14174	3	0	\N
213713	1397	1264672602000	28722	14175	0	0	\N
213714	1397	1264662601000	28722	14175	1	0	\N
213715	2134	12715143000	28722	14175	2	0	\N
213716	2134	12714139000	28722	14175	3	0	\N
213717	2133	9475100000	28722	14175	4	0	\N
213718	2133	9474098000	28722	14175	5	0	\N
213719	2133	9473096000	28722	14175	6	0	\N
213720	1397	1264672602000	28723	14175	0	0	\N
213721	1397	1264662601000	28723	14175	1	0	\N
213722	2134	12715143000	28723	14175	2	0	\N
213723	2134	12714139000	28723	14175	3	0	\N
213724	2133	9475100000	28723	14175	4	0	\N
213725	2133	9474098000	28723	14175	5	0	\N
213726	2133	9473096000	28723	14175	6	0	\N
213736	1397	1264652600000	28726	14176	0	0	\N
213737	2133	9472094000	28726	14176	1	0	\N
213738	1397	1264642599000	28730	14177	0	0	\N
213739	2132	7184198000	28730	14177	1	0	\N
213740	2134	12713135000	28730	14177	2	0	\N
213741	2133	9471092000	28730	14177	3	0	\N
213749	1397	1264632598000	28733	14178	0	0	\N
213750	2133	9470090000	28733	14178	1	0	\N
213751	2134	12712131000	28733	14178	2	0	\N
213752	2393	2157990000000	28734	14177	0	0	\N
213753	1397	1264642599000	28734	14177	1	0	\N
213754	1397	1264632598000	28734	14177	2	0	\N
213755	1397	1264622597000	28734	14177	3	0	\N
213756	2132	7184198000	28734	14177	4	0	\N
213761	1397	1264612596000	28736	14180	0	0	\N
213762	2132	7183197000	28736	14180	1	0	\N
213765	1397	1264602595000	28738	14181	0	0	\N
213766	2134	12710123000	28738	14181	1	0	\N
213769	1397	1264602595000	28740	14181	0	0	\N
213770	2134	12710123000	28740	14181	1	0	\N
213771	2393	2157990000000	28741	14044	0	0	\N
213772	1588	17352010000000	28741	14044	1	0	\N
213773	1397	1266452780000	28741	14044	2	0	\N
213774	1397	1266442779000	28741	14044	3	0	\N
213775	1397	1266432778000	28741	14044	4	0	\N
213776	1397	1266422777000	28741	14044	5	0	\N
213777	1397	1266412776000	28741	14044	6	0	\N
213778	1397	1266402775000	28741	14044	7	0	\N
213779	1588	17185630000000	28741	14044	8	0	\N
213780	1588	17073633000000	28741	14044	9	0	\N
213781	1588	16980782000000	28741	14044	10	0	\N
213782	1397	1266392774000	28741	14044	11	0	\N
213783	1397	1266382773000	28741	14044	12	0	\N
213784	1397	1266372772000	28741	14044	13	0	\N
213785	1397	1266362771000	28741	14044	14	0	\N
213786	1397	1266352770000	28741	14044	15	0	\N
213787	1397	1266342769000	28741	14044	16	0	\N
213788	1397	1266332768000	28741	14044	17	0	\N
213789	1397	1266322767000	28741	14044	18	0	\N
213790	1397	1266312766000	28741	14044	19	0	\N
213791	1397	1266302765000	28741	14044	20	0	\N
213792	1397	1266292764000	28741	14044	21	0	\N
213671	1397	1264742609000	28698	14167	0	0	17408
213672	2133	9482114000	28698	14167	1	0	6946
213673	2134	12721167000	28698	14167	2	0	7597
213674	1397	1264732608000	28699	14168	0	0	17409
213675	2132	7187201000	28699	14168	1	0	1801
213677	2133	9481112000	28699	14168	3	0	6947
213678	1397	1264722607000	28700	14169	0	0	17410
213679	2133	9480110000	28700	14169	1	0	6948
213680	2134	12719159000	28700	14169	2	0	7599
213681	1397	1264712606000	28702	14170	0	0	17411
213683	1397	1264702605000	28703	14171	0	0	17412
213684	2134	12718155000	28703	14171	1	0	7600
213685	2133	9478106000	28703	14171	2	0	6950
213686	2132	7186200000	28703	14171	3	0	1802
213691	2133	9477104000	28705	14172	1	0	6951
213692	2134	12717151000	28705	14172	2	0	7601
213701	2133	9476102000	28716	14173	0	0	6952
213702	1397	1264682603000	28719	14174	0	0	17414
213703	2134	12716147000	28719	14174	1	0	7602
213727	1397	1264672602000	28724	14175	0	0	17415
213728	1397	1264662601000	28724	14175	1	0	17416
213729	2134	12715143000	28724	14175	2	0	7603
213730	2134	12714139000	28724	14175	3	0	7604
213731	2133	9475100000	28724	14175	4	0	6953
213733	2133	9473096000	28724	14175	6	0	6955
213734	1397	1264652600000	28725	14176	0	0	17417
213735	2133	9472094000	28725	14176	1	0	6956
213742	1397	1264642599000	28731	14177	0	0	17418
213744	2134	12713135000	28731	14177	2	0	7605
213745	2133	9471092000	28731	14177	3	0	6957
213746	1397	1264632598000	28732	14178	0	0	17419
213747	2133	9470090000	28732	14178	1	0	6958
213748	2134	12712131000	28732	14178	2	0	7606
213758	1397	1264622597000	28735	14179	1	0	17420
213759	2134	12711127000	28735	14179	2	0	7607
213760	2133	9469088000	28735	14179	3	0	6959
213763	1397	1264612596000	28737	14180	0	0	17421
213764	2132	7183197000	28737	14180	1	0	1805
213768	2134	12710123000	28739	14181	1	0	7608
213793	1397	1266282763000	28741	14044	22	0	\N
213794	1397	1266272762000	28741	14044	23	0	\N
213795	1397	1266262761000	28741	14044	24	0	\N
213796	1397	1266252760000	28741	14044	25	0	\N
213797	1397	1266242759000	28741	14044	26	0	\N
213798	1397	1266232758000	28741	14044	27	0	\N
213799	1397	1266222757000	28741	14044	28	0	\N
213800	1397	1266212756000	28741	14044	29	0	\N
213801	1397	1266202755000	28741	14044	30	0	\N
213802	1397	1266192754000	28741	14044	31	0	\N
213803	1397	1266182753000	28741	14044	32	0	\N
213804	1397	1266172752000	28741	14044	33	0	\N
213805	1397	1266162751000	28741	14044	34	0	\N
213806	1397	1266152750000	28741	14044	35	0	\N
213807	1397	1266142749000	28741	14044	36	0	\N
213808	1397	1266132748000	28741	14044	37	0	\N
213809	1397	1266122747000	28741	14044	38	0	\N
213810	1397	1266112746000	28741	14044	39	0	\N
213811	1397	1266102745000	28741	14044	40	0	\N
213812	1397	1266092744000	28741	14044	41	0	\N
213813	1397	1266082743000	28741	14044	42	0	\N
213814	1397	1266072742000	28741	14044	43	0	\N
213815	1397	1266062741000	28741	14044	44	0	\N
213816	1397	1266052740000	28741	14044	45	0	\N
213817	1397	1266042739000	28741	14044	46	0	\N
213818	1397	1266032738000	28741	14044	47	0	\N
213819	1397	1266022737000	28741	14044	48	0	\N
213820	1397	1266012736000	28741	14044	49	0	\N
213821	1397	1266002735000	28741	14044	50	0	\N
213822	1397	1265992734000	28741	14044	51	0	\N
213823	1397	1265982733000	28741	14044	53	0	\N
213824	1397	1265972732000	28741	14044	54	0	\N
213825	1397	1265962731000	28741	14044	55	0	\N
213826	1397	1265952730000	28741	14044	56	0	\N
213827	1397	1265942729000	28741	14044	57	0	\N
213828	1397	1265932728000	28741	14044	58	0	\N
213829	1397	1265922727000	28741	14044	59	0	\N
213830	1397	1265912726000	28741	14044	60	0	\N
213831	1397	1265902725000	28741	14044	61	0	\N
213832	1397	1265892724000	28741	14044	62	0	\N
213833	1397	1265882723000	28741	14044	63	0	\N
213834	1397	1265872722000	28741	14044	64	0	\N
213835	1397	1265862721000	28741	14044	65	0	\N
213836	1397	1265852720000	28741	14044	66	0	\N
213837	1397	1265842719000	28741	14044	67	0	\N
213838	1397	1265832718000	28741	14044	68	0	\N
213839	1397	1265822717000	28741	14044	69	0	\N
213840	1397	1265812716000	28741	14044	70	0	\N
213841	1397	1265802715000	28741	14044	71	0	\N
213842	1397	1265792714000	28741	14044	72	0	\N
213843	1397	1265782713000	28741	14044	73	0	\N
213844	1397	1265772712000	28741	14044	74	0	\N
213845	1397	1265762711000	28741	14044	75	0	\N
213846	1397	1265752710000	28741	14044	76	0	\N
213847	1397	1265742709000	28741	14044	77	0	\N
213848	1397	1265732708000	28741	14044	78	0	\N
213849	1397	1265722707000	28741	14044	79	0	\N
213850	1397	1265712706000	28741	14044	80	0	\N
213851	1397	1265702705000	28741	14044	81	0	\N
213852	1397	1265692704000	28741	14044	82	0	\N
213853	1397	1265682703000	28741	14044	83	0	\N
213854	1397	1265672702000	28741	14044	84	0	\N
213855	1397	1265662701000	28741	14044	85	0	\N
213856	1397	1265652700000	28741	14044	86	0	\N
213857	1397	1265642699000	28741	14044	87	0	\N
213858	1397	1265632698000	28741	14044	88	0	\N
213859	1397	1265622697000	28741	14044	89	0	\N
213860	1397	1265612696000	28741	14044	90	0	\N
213861	1397	1265602695000	28741	14044	91	0	\N
213862	1397	1265592694000	28741	14044	92	0	\N
213863	1397	1265582693000	28741	14044	93	0	\N
213864	1397	1265572692000	28741	14044	94	0	\N
213865	1397	1265562691000	28741	14044	95	0	\N
213866	1397	1265552690000	28741	14044	96	0	\N
213867	1397	1265542689000	28741	14044	97	0	\N
213868	1397	1265532688000	28741	14044	98	0	\N
213869	1397	1265522687000	28741	14044	99	0	\N
213870	1397	1265512686000	28741	14044	100	0	\N
213871	1397	1265502685000	28741	14044	101	0	\N
213872	1397	1265492684000	28741	14044	102	0	\N
213873	1397	1265482683000	28741	14044	103	0	\N
213874	1397	1265472682000	28741	14044	104	0	\N
213875	1397	1265462681000	28741	14044	105	0	\N
213876	1397	1265452680000	28741	14044	106	0	\N
213877	1397	1265442679000	28741	14044	107	0	\N
213878	1397	1265432678000	28741	14044	108	0	\N
213879	1397	1265422677000	28741	14044	109	0	\N
213880	1397	1265412676000	28741	14044	110	0	\N
213881	1397	1265402675000	28741	14044	111	0	\N
213882	1397	1265392674000	28741	14044	112	0	\N
213883	1397	1265382673000	28741	14044	113	0	\N
213884	1397	1265372672000	28741	14044	114	0	\N
213885	1397	1265362671000	28741	14044	115	0	\N
213886	1397	1265352670000	28741	14044	116	0	\N
213887	1397	1265342669000	28741	14044	117	0	\N
213888	1397	1265332668000	28741	14044	118	0	\N
213889	1397	1265322667000	28741	14044	119	0	\N
213890	1397	1265312666000	28741	14044	120	0	\N
213891	1397	1265302665000	28741	14044	121	0	\N
213892	1397	1265292664000	28741	14044	122	0	\N
213893	1397	1265282663000	28741	14044	123	0	\N
213894	1397	1265272662000	28741	14044	124	0	\N
213895	1397	1265262661000	28741	14044	125	0	\N
213896	1397	1264592594000	28742	14182	0	0	\N
213897	2134	12709119000	28742	14182	1	0	\N
213900	1397	1264592594000	28744	14182	0	0	\N
213901	2134	12709119000	28744	14182	1	0	\N
213902	1397	1264592594000	28745	14182	0	0	\N
213903	2134	12709119000	28745	14182	1	0	\N
213904	2393	2157990000000	28747	13906	0	0	\N
213908	1397	1264582593000	28749	14183	0	0	\N
213909	2132	7182196000	28749	14183	1	0	\N
213910	2134	12708115000	28749	14183	2	0	\N
213911	1397	1264582593000	28750	14183	0	0	\N
213912	2132	7182196000	28750	14183	1	0	\N
213913	2134	12708115000	28750	14183	2	0	\N
213916	2393	2157990000000	28752	13973	0	0	\N
213917	2393	2157990000000	28753	13979	0	0	\N
213918	2393	2157990000000	28754	13995	0	0	\N
213919	1397	1264562591000	28755	14185	0	0	\N
213920	2134	12706107000	28755	14185	1	0	\N
213923	1397	1264552590000	28757	14186	0	0	\N
213924	2133	9468086000	28757	14186	1	0	\N
213925	2132	7181195000	28757	14186	2	0	\N
213926	2134	12705103000	28757	14186	3	0	\N
213905	1397	1264582593000	28748	14183	0	0	17424
213906	2132	7182196000	28748	14183	1	0	1806
213907	2134	12708115000	28748	14183	2	0	7610
213914	1397	1264572592000	28751	14184	0	0	17425
213915	2134	12707111000	28751	14184	1	0	7611
213922	2134	12706107000	28756	14185	1	0	7612
213927	1397	1264552590000	28758	14186	0	0	17427
213928	2133	9468086000	28758	14186	1	0	6960
213933	1397	1264542589000	28760	14187	0	0	\N
213934	2133	9467084000	28760	14187	1	0	\N
213935	1397	1264542589000	28761	14187	0	0	\N
213936	2133	9467084000	28761	14187	1	0	\N
213941	1397	1264522587000	28763	14189	0	0	\N
213942	2132	7180194000	28763	14189	1	0	\N
213955	1397	1264512586000	28767	14190	0	0	\N
213956	1397	1264502585000	28767	14190	2	0	\N
213957	2133	9464078000	28767	14190	3	0	\N
213958	2133	9463076000	28767	14190	4	0	\N
213959	2133	9462074000	28767	14190	5	0	\N
213960	2132	7179193000	28767	14190	6	0	\N
213961	2134	12702091000	28767	14190	7	0	\N
213962	2134	12701087000	28767	14190	8	0	\N
213963	1397	1264512586000	28768	14190	0	0	\N
213964	1397	1264502585000	28768	14190	2	0	\N
213965	2133	9464078000	28768	14190	3	0	\N
213966	2133	9463076000	28768	14190	4	0	\N
213967	2133	9462074000	28768	14190	5	0	\N
213968	2132	7179193000	28768	14190	6	0	\N
213969	2134	12702091000	28768	14190	7	0	\N
213970	2134	12701087000	28768	14190	8	0	\N
213981	2408	1990000000	28771	14192	0	0	\N
213982	1397	1264472582000	28771	14192	1	0	\N
213983	2133	9459068000	28771	14192	2	0	\N
213988	2134	12697071000	28773	14194	0	0	\N
213989	1397	1264452580000	28774	14194	0	0	\N
213990	2134	12697071000	28774	14194	1	0	\N
213991	2133	9457064000	28774	14194	2	0	\N
213992	1397	1264452580000	28775	14194	0	0	\N
213993	2134	12697071000	28775	14194	1	0	\N
213994	2133	9457064000	28775	14194	2	0	\N
214004	1397	1264452580000	28778	14195	0	0	\N
214005	1397	1264442579000	28778	14195	1	0	\N
214006	1397	1264432578000	28778	14195	2	0	\N
214007	2133	9457064000	28778	14195	3	0	\N
214008	2133	9456062000	28778	14195	4	0	\N
214009	2132	7177191000	28778	14195	5	0	\N
214010	2133	9455060000	28778	14195	6	0	\N
214011	2134	12696067000	28778	14195	7	0	\N
214018	1397	1264422577000	28780	14196	0	0	\N
214019	1397	1264412576000	28780	14196	1	0	\N
214020	2133	9454058000	28780	14196	2	0	\N
214021	2134	12695063000	28780	14196	3	0	\N
214022	2134	12694059000	28780	14196	4	0	\N
214023	2133	9453056000	28780	14196	5	0	\N
214024	1397	1264422577000	28781	14196	0	0	\N
214025	1397	1264412576000	28781	14196	1	0	\N
214026	2133	9454058000	28781	14196	2	0	\N
214027	2134	12695063000	28781	14196	3	0	\N
214028	2134	12694059000	28781	14196	4	0	\N
214029	2133	9453056000	28781	14196	5	0	\N
214030	1397	1264422577000	28782	14196	0	0	\N
214031	1397	1264412576000	28782	14196	1	0	\N
214032	2133	9454058000	28782	14196	2	0	\N
214033	2134	12695063000	28782	14196	3	0	\N
214034	2134	12694059000	28782	14196	4	0	\N
214035	2133	9453056000	28782	14196	5	0	\N
214048	1397	1264372572000	28786	14199	0	0	\N
214049	2133	9449048000	28786	14199	1	0	\N
214050	2134	12691047000	28786	14199	2	0	\N
213931	1397	1264542589000	28759	14187	0	0	17428
213932	2133	9467084000	28759	14187	1	0	6961
213937	421	66843681394804	28762	14188	0	0	1
213938	1397	1264532588000	28762	14188	1	0	17429
213939	2134	12704099000	28762	14188	2	0	7614
213943	1397	1264522587000	28764	14189	0	0	17430
213944	2133	9465080000	28764	14189	1	0	6963
213945	2134	12703095000	28764	14189	2	0	7615
213946	2132	7180194000	28764	14189	3	0	1808
213947	1397	1264512586000	28766	14190	0	0	17431
213949	2133	9464078000	28766	14190	3	0	6964
213950	2133	9463076000	28766	14190	4	0	6965
213951	2133	9462074000	28766	14190	5	0	6966
213952	2132	7179193000	28766	14190	6	0	1809
213954	2134	12701087000	28766	14190	8	0	7617
213971	1397	1264492584000	28769	14191	0	0	17433
213972	1397	1264482583000	28769	14191	1	0	17434
213973	2134	12700083000	28769	14191	2	0	7618
213974	2134	12699079000	28769	14191	3	0	7619
213976	1726	127431112000	28769	14191	5	0	8354
213977	2133	9460070000	28769	14191	6	0	6968
213978	2408	1990000000	28770	14192	0	0	1
213979	1397	1264472582000	28770	14192	1	0	17435
213980	2133	9459068000	28770	14192	2	0	6969
213985	2132	7178192000	28772	14193	1	0	1810
213986	2134	12698075000	28772	14193	2	0	7620
213987	2133	9458066000	28772	14193	3	0	6970
213995	2134	12697071000	28776	14194	0	0	7621
213997	1397	1264442579000	28777	14195	1	0	17438
213998	1397	1264432578000	28777	14195	2	0	17439
213999	2133	9457064000	28777	14195	3	0	6971
214000	2133	9456062000	28777	14195	4	0	6972
214001	2132	7177191000	28777	14195	5	0	1811
214003	2134	12696067000	28777	14195	7	0	7622
214012	1397	1264422577000	28779	14196	0	0	17440
214013	1397	1264412576000	28779	14196	1	0	17441
214014	2133	9454058000	28779	14196	2	0	6974
214015	2134	12695063000	28779	14196	3	0	7623
214017	2133	9453056000	28779	14196	5	0	6975
214036	1397	1264402575000	28783	14197	0	0	17442
214037	2132	7176190000	28783	14197	1	0	1812
214038	2134	12693055000	28783	14197	2	0	7625
214040	1397	1264392574000	28784	14198	0	0	17443
214041	1397	1264382573000	28784	14198	1	0	17444
214042	2134	12692051000	28784	14198	2	0	7626
214043	2133	9451052000	28784	14198	3	0	6977
214044	2133	9450050000	28784	14198	4	0	6978
214046	2133	9449048000	28785	14199	1	0	6979
214047	2134	12691047000	28785	14199	2	0	7627
214051	1397	1264362571000	28787	14200	0	0	17446
214052	2132	7175189000	28787	14200	1	0	1813
214053	2133	9448046000	28787	14200	2	0	6980
214055	1397	1264352570000	28788	14201	0	0	17447
214056	2133	9447044000	28788	14201	1	0	6981
214057	1397	1264342569000	28789	14202	0	0	17448
214058	1397	1264332568000	28789	14202	1	0	17449
214060	2132	7174188000	28789	14202	3	0	1814
214061	2134	12689039000	28789	14202	4	0	7629
214062	2133	9446042000	28789	14202	5	0	6982
214063	2133	9445040000	28789	14202	6	0	6983
214064	2133	9444038000	28789	14202	7	0	6984
214073	1397	1264292564000	28792	14205	0	0	\N
214074	1397	1264282563000	28792	14205	1	0	\N
214075	2134	12685023000	28792	14205	2	0	\N
214076	2133	9441032000	28792	14205	3	0	\N
214077	2133	9440030000	28792	14205	4	0	\N
214078	1397	1264292564000	28793	14205	0	0	\N
214079	1397	1264282563000	28793	14205	1	0	\N
214080	2134	12685023000	28793	14205	2	0	\N
214081	2133	9441032000	28793	14205	3	0	\N
214082	2133	9440030000	28793	14205	4	0	\N
214088	1397	1264272562000	28795	14206	0	0	\N
214089	2133	9439028000	28795	14206	1	0	\N
214090	2134	12684019000	28795	14206	2	0	\N
214091	1397	1264272562000	28796	14206	0	0	\N
214092	2133	9439028000	28796	14206	1	0	\N
214093	2134	12684019000	28796	14206	2	0	\N
214097	2132	7172186000	28798	14207	0	0	\N
214098	2134	12683015000	28798	14207	1	0	\N
214099	2133	9438026000	28798	14207	2	0	\N
214106	1397	1264252560000	28805	14209	0	0	\N
214107	1397	1264242559000	28805	14209	1	0	\N
214108	2134	12681007000	28805	14209	2	0	\N
214109	2132	7171185000	28805	14209	3	0	\N
214110	2133	9436022000	28805	14209	4	0	\N
214111	2133	9435020000	28805	14209	6	0	\N
214118	1397	1264232558000	28807	14210	0	0	\N
214119	2134	12680003000	28807	14210	1	0	\N
214120	2133	9434018000	28807	14210	2	0	\N
214121	1397	1264232558000	28808	14210	0	0	\N
214122	2134	12680003000	28808	14210	1	0	\N
214123	2133	9434018000	28808	14210	2	0	\N
214127	1397	1264232558000	28810	14210	0	0	\N
214128	2134	12680003000	28810	14210	1	0	\N
214129	2133	9434018000	28810	14210	2	0	\N
214133	1397	1264222557000	28812	14211	0	0	\N
214134	2134	12678999000	28812	14211	1	0	\N
214135	1397	1264212556000	28813	14212	0	0	\N
214136	2132	7170184000	28813	14212	1	0	\N
214137	2133	9432014000	28813	14212	2	0	\N
214138	2132	7170184000	28814	14212	0	0	\N
214139	1397	1264212556000	28815	14212	0	0	\N
214140	2132	7170184000	28815	14212	1	0	\N
214141	2133	9432014000	28815	14212	2	0	\N
214148	1397	1264192554000	28818	14214	0	0	\N
214149	2134	12676991000	28818	14214	1	0	\N
214150	2133	9430010000	28818	14214	2	0	\N
214161	421	66843681394804	28823	14162	0	0	\N
214162	2393	2157990000000	28823	14162	1	0	\N
214163	1726	127431112000	28823	14162	2	0	\N
214164	2132	7188202000	28823	14162	3	0	\N
214165	2132	7187201000	28823	14162	4	0	\N
214166	2132	7186200000	28823	14162	5	0	\N
214167	2132	7185199000	28823	14162	6	0	\N
214168	2132	7184198000	28823	14162	7	0	\N
214169	2132	7183197000	28823	14162	8	0	\N
214170	2132	7182196000	28823	14162	9	0	\N
214171	2132	7181195000	28823	14162	10	0	\N
214172	2132	7180194000	28823	14162	11	0	\N
214173	2132	7179193000	28823	14162	12	0	\N
214174	2132	7178192000	28823	14162	13	0	\N
214175	1397	1264152550000	28824	14218	0	0	\N
214176	1397	1264142549000	28824	14218	1	0	\N
214177	2133	9428006000	28824	14218	2	0	\N
214178	2132	7168182000	28824	14218	3	0	\N
214179	2134	12673979000	28824	14218	4	0	\N
214180	2133	9427004000	28824	14218	5	0	\N
214181	2133	9426002000	28824	14218	6	0	\N
214182	2133	9425000000	28824	14218	7	0	\N
214183	1397	1264152550000	28825	14218	0	0	\N
214184	1397	1264142549000	28825	14218	1	0	\N
214185	2133	9428006000	28825	14218	2	0	\N
214186	2132	7168182000	28825	14218	3	0	\N
214187	2134	12673979000	28825	14218	4	0	\N
214188	2133	9427004000	28825	14218	5	0	\N
214189	2133	9426002000	28825	14218	6	0	\N
214190	2133	9425000000	28825	14218	7	0	\N
214067	1397	1264312566000	28790	14203	0	0	17451
214068	2133	9443036000	28790	14203	1	0	6985
214069	1397	1264302565000	28791	14204	0	0	17452
214070	2134	12686027000	28791	14204	1	0	7632
214071	2132	7173187000	28791	14204	2	0	1815
214083	1397	1264292564000	28794	14205	0	0	17453
214084	1397	1264282563000	28794	14205	1	0	17454
214085	2134	12685023000	28794	14205	2	0	7633
214086	2133	9441032000	28794	14205	3	0	6987
214087	2133	9440030000	28794	14205	4	0	6988
214095	2133	9439028000	28797	14206	1	0	6989
214096	2134	12684019000	28797	14206	2	0	7634
214100	2132	7172186000	28799	14207	0	0	1816
214101	2134	12683015000	28799	14207	1	0	7635
214103	2134	12682011000	28802	14208	1	0	7636
214104	2133	9438026000	28802	14208	2	0	6990
214105	2133	9437024000	28802	14208	3	0	6991
214112	1397	1264252560000	28806	14209	0	0	17457
214113	1397	1264242559000	28806	14209	1	0	17458
214115	2132	7171185000	28806	14209	3	0	1817
214116	2133	9436022000	28806	14209	4	0	6992
214117	2133	9435020000	28806	14209	6	0	6993
214124	1397	1264232558000	28809	14210	0	0	17459
214125	2134	12680003000	28809	14210	1	0	7638
214130	1397	1264222557000	28811	14211	0	0	17460
214131	2133	9433016000	28811	14211	1	0	6995
214132	2134	12678999000	28811	14211	2	0	7639
214142	1397	1264212556000	28816	14212	0	0	17461
214144	2133	9432014000	28816	14212	2	0	6996
214145	1397	1264202555000	28817	14213	0	0	17462
214146	2134	12677995000	28817	14213	1	0	7640
214147	2133	9431012000	28817	14213	2	0	6997
214151	1397	1264192554000	28819	14214	0	0	17463
214153	2133	9430010000	28819	14214	2	0	6998
214154	1397	1264182553000	28820	14215	0	0	17464
214155	2133	9429008000	28820	14215	1	0	6999
214156	1397	1264172552000	28821	14216	0	0	17465
214157	2134	12675987000	28821	14216	1	0	7642
214159	1397	1264162551000	28822	14217	0	0	17466
214160	2134	12674983000	28822	14217	1	0	7643
214191	1397	1264152550000	28826	14218	0	0	17467
214192	1397	1264142549000	28826	14218	1	0	17468
214194	2132	7168182000	28826	14218	3	0	1820
214195	2134	12673979000	28826	14218	4	0	7644
214196	2133	9427004000	28826	14218	5	0	7001
214197	2133	9426002000	28826	14218	6	0	7002
214198	2133	9425000000	28826	14218	7	0	7003
214200	2133	9423998000	28827	14219	1	0	7004
214202	1397	1264122547000	28828	14220	0	0	\N
214203	1397	1264112546000	28828	14220	1	0	\N
214204	2132	7167181000	28828	14220	2	0	\N
214205	2133	9422996000	28828	14220	3	0	\N
214206	2133	9421994000	28828	14220	4	0	\N
214207	2134	12671971000	28828	14220	5	0	\N
214208	2134	12670967000	28828	14220	6	0	\N
214209	1397	1264122547000	28829	14220	0	0	\N
214210	1397	1264112546000	28829	14220	1	0	\N
214211	2132	7167181000	28829	14220	2	0	\N
214212	2133	9422996000	28829	14220	3	0	\N
214213	2133	9421994000	28829	14220	4	0	\N
214214	2134	12671971000	28829	14220	5	0	\N
214215	2134	12670967000	28829	14220	6	0	\N
214216	1397	1264122547000	28830	14220	0	0	\N
214217	1397	1264112546000	28830	14220	1	0	\N
214218	2132	7167181000	28830	14220	2	0	\N
214219	2133	9422996000	28830	14220	3	0	\N
214220	2133	9421994000	28830	14220	4	0	\N
214221	2134	12671971000	28830	14220	5	0	\N
214222	2134	12670967000	28830	14220	6	0	\N
214230	1397	1264122547000	28832	14220	0	0	\N
214231	1397	1264112546000	28832	14220	1	0	\N
214232	2132	7167181000	28832	14220	2	0	\N
214233	2133	9422996000	28832	14220	3	0	\N
214234	2133	9421994000	28832	14220	4	0	\N
214235	2134	12671971000	28832	14220	5	0	\N
214236	2134	12670967000	28832	14220	6	0	\N
214250	1397	1264062541000	28836	14224	0	0	\N
214251	2134	12666951000	28836	14224	1	0	\N
214252	2133	9415982000	28836	14224	2	0	\N
214253	1397	1264062541000	28837	14224	0	0	\N
214254	2134	12666951000	28837	14224	1	0	\N
214255	2133	9415982000	28837	14224	2	0	\N
214259	1397	1264062541000	28839	14224	0	0	\N
214260	2134	12666951000	28839	14224	1	0	\N
214261	2133	9415982000	28839	14224	2	0	\N
214269	1397	1264052540000	28841	14225	0	0	\N
214270	1397	1264042539000	28841	14225	1	0	\N
214271	2132	7165179000	28841	14225	2	0	\N
214272	2133	9414980000	28841	14225	3	0	\N
214273	2134	12665947000	28841	14225	4	0	\N
214274	2133	9413978000	28841	14225	5	0	\N
214275	2134	12664943000	28841	14225	6	0	\N
214276	1397	1264052540000	28842	14225	0	0	\N
214277	1397	1264042539000	28842	14225	1	0	\N
214278	2132	7165179000	28842	14225	2	0	\N
214279	2133	9414980000	28842	14225	3	0	\N
214280	2134	12665947000	28842	14225	4	0	\N
214281	2133	9413978000	28842	14225	5	0	\N
214282	2134	12664943000	28842	14225	6	0	\N
214285	1397	1264022537000	28845	14227	0	0	\N
214286	2132	7164178000	28845	14227	1	0	\N
214287	2133	9411974000	28845	14227	2	0	\N
214288	2134	12663939000	28845	14227	3	0	\N
214293	1397	1264022537000	28847	14227	0	0	\N
214294	2132	7164178000	28847	14227	1	0	\N
214295	2133	9411974000	28847	14227	2	0	\N
214296	2134	12663939000	28847	14227	3	0	\N
214318	1397	1263962531000	28854	14231	0	0	\N
214319	1397	1263952530000	28854	14231	1	0	\N
214320	2132	7162176000	28854	14231	2	0	\N
214321	2133	9405962000	28854	14231	3	0	\N
214322	2133	9404960000	28854	14231	4	0	\N
214323	2134	12658919000	28854	14231	5	0	\N
214224	1397	1264112546000	28831	14220	1	0	17471
214225	2132	7167181000	28831	14220	2	0	1821
214226	2133	9422996000	28831	14220	3	0	7005
214227	2133	9421994000	28831	14220	4	0	7006
214228	2134	12671971000	28831	14220	5	0	7646
214237	2133	9420992000	28833	14221	0	0	7007
214238	1397	1264102545000	28834	14222	0	0	17472
214239	1397	1264092544000	28834	14222	1	0	17473
214240	2134	12669963000	28834	14222	2	0	7648
214241	2133	9419990000	28834	14222	3	0	7008
214243	2134	12668959000	28834	14222	5	0	7649
214244	1397	1264082543000	28835	14223	0	0	17474
214245	1397	1264072542000	28835	14223	1	0	17475
214246	2133	9417986000	28835	14223	2	0	7010
214248	2133	9416984000	28835	14223	4	0	7011
214249	2132	7166180000	28835	14223	5	0	1822
214256	1397	1264062541000	28838	14224	0	0	17476
214257	2134	12666951000	28838	14224	1	0	7651
214258	2133	9415982000	28838	14224	2	0	7012
214263	1397	1264042539000	28840	14225	1	0	17478
214264	2132	7165179000	28840	14225	2	0	1823
214265	2133	9414980000	28840	14225	3	0	7013
214266	2134	12665947000	28840	14225	4	0	7652
214267	2133	9413978000	28840	14225	5	0	7014
214283	1397	1264032538000	28843	14226	0	0	17479
214284	2133	9412976000	28843	14226	1	0	7015
214289	1397	1264022537000	28846	14227	0	0	17480
214290	2132	7164178000	28846	14227	1	0	1824
214292	2134	12663939000	28846	14227	3	0	7654
214297	1397	1264012536000	28850	14228	0	0	17481
214298	1397	1264002535000	28850	14228	1	0	17482
214299	2133	9410972000	28850	14228	2	0	7017
214300	2133	9409970000	28850	14228	3	0	7018
214302	2134	12661931000	28850	14228	5	0	7656
214303	1397	1263992534000	28851	14229	0	0	17483
214304	1397	1263982533000	28851	14229	1	0	17484
214305	2132	7163177000	28851	14229	2	0	1825
214306	2134	12660927000	28851	14229	3	0	7657
214308	2133	9407966000	28851	14229	5	0	7020
214309	1397	1263972532000	28852	14230	0	0	17485
214310	2134	12659923000	28852	14230	1	0	7658
214311	2133	9406964000	28852	14230	2	0	7021
214313	1397	1263952530000	28853	14231	1	0	17487
214314	2132	7162176000	28853	14231	2	0	1826
214315	2133	9405962000	28853	14231	3	0	7022
214316	2133	9404960000	28853	14231	4	0	7023
214317	2134	12658919000	28853	14231	5	0	7659
214325	1397	1263932528000	28855	14232	1	0	17489
214326	1397	1263922527000	28855	14232	2	0	17490
214327	2133	9403958000	28855	14232	3	0	7024
214328	2133	9402956000	28855	14232	4	0	7025
214329	2134	12657915000	28855	14232	5	0	7660
214331	2132	7161175000	28855	14232	7	0	1827
214332	2134	12656911000	28855	14232	8	0	7661
214333	1726	126330112000	28855	14232	9	0	8355
214334	1397	1263912526000	28856	14233	0	0	17491
214336	1397	1263892524000	28856	14233	2	0	17493
214351	1397	1263912526000	28857	14233	0	0	\N
214352	1397	1263902525000	28857	14233	1	0	\N
214353	1397	1263892524000	28857	14233	2	0	\N
214354	1397	1263882523000	28857	14233	3	0	\N
214355	1397	1263872522000	28857	14233	4	0	\N
214356	2405	96230770	28857	14233	5	0	\N
214357	2405	92461540	28857	14233	6	0	\N
214358	2133	9400952000	28857	14233	7	0	\N
214359	2133	9399950000	28857	14233	8	0	\N
214360	2133	9398948000	28857	14233	9	0	\N
214361	2133	9397946000	28857	14233	10	0	\N
214362	2133	9396944000	28857	14233	11	0	\N
214363	2134	12655907000	28857	14233	12	0	\N
214364	2134	12654903000	28857	14233	13	0	\N
214365	2134	12653899000	28857	14233	14	0	\N
214366	2134	12652895000	28857	14233	15	0	\N
214367	2132	7160174000	28857	14233	16	0	\N
214368	1397	1263912526000	28858	14233	0	0	\N
214369	1397	1263902525000	28858	14233	1	0	\N
214370	1397	1263892524000	28858	14233	2	0	\N
214371	1397	1263882523000	28858	14233	3	0	\N
214372	1397	1263872522000	28858	14233	4	0	\N
214373	2405	96230770	28858	14233	5	0	\N
214374	2405	92461540	28858	14233	6	0	\N
214375	2133	9400952000	28858	14233	7	0	\N
214376	2133	9399950000	28858	14233	8	0	\N
214377	2133	9398948000	28858	14233	9	0	\N
214378	2133	9397946000	28858	14233	10	0	\N
214379	2133	9396944000	28858	14233	11	0	\N
214380	2134	12655907000	28858	14233	12	0	\N
214381	2134	12654903000	28858	14233	13	0	\N
214382	2134	12653899000	28858	14233	14	0	\N
214383	2134	12652895000	28858	14233	15	0	\N
214384	2132	7160174000	28858	14233	16	0	\N
214385	1397	1263862521000	28859	14234	0	0	\N
214386	2133	9395942000	28859	14234	1	0	\N
214387	2134	12651891000	28859	14234	2	0	\N
214391	1397	1263862521000	28861	14234	0	0	\N
214392	2133	9395942000	28861	14234	1	0	\N
214393	2134	12651891000	28861	14234	2	0	\N
214394	1397	1263862521000	28862	14234	0	0	\N
214395	2133	9395942000	28862	14234	1	0	\N
214396	2134	12651891000	28862	14234	2	0	\N
214404	656	66544500726895	28865	14236	0	0	\N
214405	1397	1263842519000	28865	14236	1	0	\N
214406	2133	9393938000	28865	14236	2	0	\N
214420	1397	1263802515000	28870	14240	0	0	\N
214421	2133	9389930000	28870	14240	1	0	\N
214422	2134	12647875000	28870	14240	2	0	\N
214427	2411	10000000	28872	14242	0	0	\N
214428	1397	1263782513000	28872	14242	1	0	\N
214429	2134	12645867000	28872	14242	2	0	\N
214430	2133	9387926000	28872	14242	3	0	\N
214431	2132	7157171000	28872	14242	4	0	\N
214438	1397	1263772512000	28875	14244	0	0	\N
214439	2134	12644863000	28875	14244	1	0	\N
214440	2133	9385922000	28875	14244	2	0	\N
214441	1397	1263772512000	28876	14244	0	0	\N
214442	2134	12644863000	28876	14244	1	0	\N
214443	2133	9385922000	28876	14244	2	0	\N
214452	656	66000450726895	28879	14245	0	0	\N
214453	1397	1263762511000	28879	14245	1	0	\N
214454	2134	12643859000	28879	14245	2	0	\N
214455	2132	7156170000	28879	14245	3	0	\N
214456	2133	9384920000	28879	14245	4	0	\N
214460	1397	1263752510000	28881	14246	0	0	\N
214461	2134	12642855000	28881	14246	1	0	\N
214462	2133	9383918000	28881	14246	2	0	\N
214463	1397	1263752510000	28882	14246	0	0	\N
214464	2134	12642855000	28882	14246	1	0	\N
214465	2133	9383918000	28882	14246	2	0	\N
214339	2405	96230770	28856	14233	5	0	1
214340	2405	92461540	28856	14233	6	0	2
214341	2133	9400952000	28856	14233	7	0	7027
214342	2133	9399950000	28856	14233	8	0	7028
214343	2133	9398948000	28856	14233	9	0	7029
214345	2133	9396944000	28856	14233	11	0	7031
214346	2134	12655907000	28856	14233	12	0	7662
214347	2134	12654903000	28856	14233	13	0	7663
214348	2134	12653899000	28856	14233	14	0	7664
214349	2134	12652895000	28856	14233	15	0	7665
214388	1397	1263862521000	28860	14234	0	0	17496
214389	2133	9395942000	28860	14234	1	0	7032
214390	2134	12651891000	28860	14234	2	0	7666
214397	1397	1263852520000	28863	14235	0	0	17497
214399	2132	7159173000	28863	14235	2	0	1829
214400	2134	12650887000	28863	14235	3	0	7667
214401	656	66544500726895	28864	14236	0	0	1
214402	1397	1263842519000	28864	14236	1	0	17498
214403	2133	9393938000	28864	14236	2	0	7034
214408	2133	9392936000	28866	14237	1	0	7035
214409	2134	12649883000	28866	14237	2	0	7668
214410	1397	1263822517000	28867	14238	0	0	17500
214411	656	66543490726895	28867	14238	1	0	2
214412	2134	12648879000	28867	14238	2	0	7669
214414	2132	7158172000	28867	14238	4	0	1830
214415	1397	1263812516000	28868	14239	0	0	17501
214416	2133	9390932000	28868	14239	1	0	7037
214417	1397	1263802515000	28869	14240	0	0	17502
214419	2134	12647875000	28869	14240	2	0	7670
214423	1397	1263792514000	28871	14241	0	0	17503
214424	656	66543450726895	28871	14241	1	0	3
214425	2133	9388928000	28871	14241	2	0	7039
214426	2134	12646871000	28871	14241	3	0	7671
214433	1397	1263782513000	28873	14242	1	0	17504
214434	2134	12645867000	28873	14242	2	0	7672
214435	2133	9387926000	28873	14242	3	0	7040
214436	2132	7157171000	28873	14242	4	0	1831
214437	2133	9386924000	28874	14243	0	0	7041
214445	2134	12644863000	28877	14244	1	0	7673
214446	2133	9385922000	28877	14244	2	0	7042
214447	656	66000450726895	28878	14245	0	0	4
214448	1397	1263762511000	28878	14245	1	0	17506
214450	2132	7156170000	28878	14245	3	0	1832
214451	2133	9384920000	28878	14245	4	0	7043
214457	1397	1263752510000	28880	14246	0	0	17507
214458	2134	12642855000	28880	14246	1	0	7675
214459	2133	9383918000	28880	14246	2	0	7044
214467	1013	2000000000	28883	14247	1	0	1
214468	2133	9382916000	28883	14247	2	0	7045
214469	2411	543000000000	28884	14248	0	0	2
214470	1397	1263732508000	28884	14248	1	0	17509
214471	2133	9381914000	28884	14248	2	0	7046
214474	1397	1263722507000	28885	14249	0	0	\N
214475	1397	1263712506000	28885	14249	1	0	\N
214476	2133	9380912000	28885	14249	2	0	\N
214477	2134	12640847000	28885	14249	3	0	\N
214478	2134	12639843000	28885	14249	4	0	\N
214479	2133	9379910000	28885	14249	6	0	\N
214480	1133	1000000000	28885	14249	7	0	\N
214494	1397	1263682503000	28890	14252	0	0	\N
214495	1397	1263672502000	28890	14252	1	0	\N
214496	2134	12637835000	28890	14252	2	0	\N
214497	1726	125229112000	28890	14252	3	0	\N
214498	2133	9376904000	28890	14252	4	0	\N
214499	2133	9375902000	28890	14252	5	0	\N
214500	1397	1263682503000	28891	14252	0	0	\N
214501	1397	1263672502000	28891	14252	1	0	\N
214502	2134	12637835000	28891	14252	2	0	\N
214503	1726	125229112000	28891	14252	3	0	\N
214504	2133	9376904000	28891	14252	4	0	\N
214505	2133	9375902000	28891	14252	5	0	\N
214512	1397	1263662501000	28893	14253	0	0	\N
214513	2133	9374900000	28893	14253	1	0	\N
214514	2134	12636831000	28893	14253	2	0	\N
214515	2132	7153167000	28893	14253	3	0	\N
214516	1397	1263662501000	28894	14253	0	0	\N
214517	2133	9374900000	28894	14253	1	0	\N
214518	2134	12636831000	28894	14253	2	0	\N
214519	2132	7153167000	28894	14253	3	0	\N
214523	1397	1263662501000	28896	14253	0	0	\N
214524	2133	9374900000	28896	14253	1	0	\N
214525	2134	12636831000	28896	14253	2	0	\N
214526	2132	7153167000	28896	14253	3	0	\N
214531	1397	1263652500000	28898	14254	0	0	\N
214532	2133	9374900000	28898	14254	1	0	\N
214533	2134	12635827000	28898	14254	2	0	\N
214537	1397	1263642499000	28900	14255	0	0	\N
214538	2134	12634823000	28900	14255	1	0	\N
214539	2411	0	28901	14245	0	0	\N
214540	656	66000450726895	28901	14245	1	0	\N
214541	1397	1263762511000	28901	14245	2	0	\N
214542	1397	1263752510000	28901	14245	3	0	\N
214543	1397	1263742509000	28901	14245	4	0	\N
214544	1397	1263732508000	28901	14245	5	0	\N
214545	1397	1263722507000	28901	14245	6	0	\N
214546	1397	1263712506000	28901	14245	7	0	\N
214547	1397	1263702505000	28901	14245	8	0	\N
214548	1397	1263692504000	28901	14245	9	0	\N
214549	1397	1263682503000	28901	14245	10	0	\N
214550	1397	1263672502000	28901	14245	11	0	\N
214551	1397	1263662501000	28901	14245	12	0	\N
214552	1397	1263652500000	28901	14245	13	0	\N
214553	1397	1263642499000	28901	14245	14	0	\N
214554	1397	1263632498000	28901	14245	15	0	\N
214555	1397	1263622497000	28901	14245	16	0	\N
214556	1013	2000000000	28901	14245	17	0	\N
214557	2134	12643859000	28901	14245	18	0	\N
214558	2134	12642855000	28901	14245	19	0	\N
214559	2132	7156170000	28901	14245	20	0	\N
214560	2133	9384920000	28901	14245	21	0	\N
214561	1726	125229112000	28901	14245	22	0	\N
214562	2134	12641851000	28901	14245	23	0	\N
214563	2134	12640847000	28901	14245	24	0	\N
214564	2134	12639843000	28901	14245	25	0	\N
214565	2134	12638839000	28901	14245	26	0	\N
214566	2134	12637835000	28901	14245	27	0	\N
214567	2134	12636831000	28901	14245	28	0	\N
214568	2134	12635827000	28901	14245	30	0	\N
214569	2134	12634823000	28901	14245	31	0	\N
214570	2134	12633819000	28901	14245	32	0	\N
214571	2132	7155169000	28901	14245	33	0	\N
214572	2132	7154168000	28901	14245	34	0	\N
214573	2132	7153167000	28901	14245	35	0	\N
214574	2132	7152166000	28901	14245	36	0	\N
214575	2133	9383918000	28901	14245	37	0	\N
214576	1133	1000000000	28901	14245	38	0	\N
214577	2133	9382916000	28901	14245	39	0	\N
214578	2133	9381914000	28901	14245	40	0	\N
214579	2133	9380912000	28901	14245	41	0	\N
214580	2133	9379910000	28901	14245	42	0	\N
214581	2133	9378908000	28901	14245	43	0	\N
214582	2133	9377906000	28901	14245	44	0	\N
214583	2133	9376904000	28901	14245	45	0	\N
214584	2133	9375902000	28901	14245	46	0	\N
214585	2133	9374900000	28901	14245	47	0	\N
214586	2133	9373898000	28901	14245	48	0	\N
214587	2133	9372896000	28901	14245	49	0	\N
214588	2133	9371894000	28901	14245	50	0	\N
214589	2133	9370892000	28901	14245	51	0	\N
214590	1397	1263632498000	28902	14256	0	0	\N
214591	1397	1263622497000	28902	14256	1	0	\N
214592	1397	1263612496000	28902	14256	2	0	\N
214593	2134	12633819000	28902	14256	3	0	\N
214594	2134	12632815000	28902	14256	4	0	\N
214595	2132	7152166000	28902	14256	5	0	\N
214596	2133	9371894000	28902	14256	6	0	\N
214597	2133	9370892000	28902	14256	7	0	\N
214598	2133	9369890000	28902	14256	8	0	\N
214599	1397	1263632498000	28903	14256	0	0	\N
214600	1397	1263622497000	28903	14256	1	0	\N
214601	1397	1263612496000	28903	14256	2	0	\N
214602	2134	12633819000	28903	14256	3	0	\N
214603	2134	12632815000	28903	14256	4	0	\N
214604	2132	7152166000	28903	14256	5	0	\N
214605	2133	9371894000	28903	14256	6	0	\N
214606	2133	9370892000	28903	14256	7	0	\N
214607	2133	9369890000	28903	14256	8	0	\N
214482	1397	1263712506000	28886	14249	1	0	17511
214483	2133	9380912000	28886	14249	2	0	7047
214484	2134	12640847000	28886	14249	3	0	7677
214485	2134	12639843000	28886	14249	4	0	7678
214486	2133	9379910000	28886	14249	6	0	7048
214488	1397	1263702505000	28887	14250	0	0	17512
214489	2133	9378908000	28887	14250	1	0	7049
214490	1397	1263692504000	28888	14251	0	0	17513
214491	2132	7154168000	28888	14251	1	0	1834
214492	2133	9377906000	28888	14251	2	0	7050
214506	1397	1263682503000	28892	14252	0	0	17514
214507	1397	1263672502000	28892	14252	1	0	17515
214508	2134	12637835000	28892	14252	2	0	7680
214509	1726	125229112000	28892	14252	3	0	8356
214511	2133	9375902000	28892	14252	5	0	7052
214520	1397	1263662501000	28895	14253	0	0	17516
214521	2134	12636831000	28895	14253	1	0	7681
214522	2132	7153167000	28895	14253	2	0	1835
214527	1397	1263652500000	28897	14254	0	0	17517
214529	2133	9373898000	28897	14254	2	0	7054
214530	2134	12635827000	28897	14254	3	0	7682
214534	1397	1263642499000	28899	14255	0	0	17518
214535	2134	12634823000	28899	14255	1	0	7683
214536	2133	9372896000	28899	14255	2	0	7055
214614	2411	10000000	28905	14242	0	0	\N
214615	2411	0	28905	14242	1	0	\N
214616	656	66000450726895	28905	14242	2	0	\N
214617	1397	1263782513000	28905	14242	3	0	\N
214618	1397	1263772512000	28905	14242	4	0	\N
214619	1397	1263762511000	28905	14242	5	0	\N
214620	1397	1263752510000	28905	14242	6	0	\N
214621	1397	1263742509000	28905	14242	7	0	\N
214622	1397	1263732508000	28905	14242	8	0	\N
214623	1397	1263722507000	28905	14242	9	0	\N
214624	1397	1263712506000	28905	14242	10	0	\N
214625	1397	1263702505000	28905	14242	11	0	\N
214626	1397	1263692504000	28905	14242	12	0	\N
214627	1397	1263682503000	28905	14242	13	0	\N
214628	1397	1263672502000	28905	14242	14	0	\N
214629	1397	1263662501000	28905	14242	15	0	\N
214630	1397	1263652500000	28905	14242	16	0	\N
214631	1397	1263642499000	28905	14242	17	0	\N
214632	1397	1263632498000	28905	14242	18	0	\N
214633	1397	1263622497000	28905	14242	19	0	\N
214634	1397	1263612496000	28905	14242	20	0	\N
214635	2134	12645867000	28905	14242	21	0	\N
214636	1013	2000000000	28905	14242	22	0	\N
214637	2134	12644863000	28905	14242	23	0	\N
214638	2134	12643859000	28905	14242	24	0	\N
214639	2134	12642855000	28905	14242	25	0	\N
214640	1726	125229112000	28905	14242	26	0	\N
214641	2133	9387926000	28905	14242	27	0	\N
214642	2133	9386924000	28905	14242	28	0	\N
214643	2133	9385922000	28905	14242	29	0	\N
214644	2133	9384920000	28905	14242	30	0	\N
214645	2134	12641851000	28905	14242	31	0	\N
214646	2134	12640847000	28905	14242	32	0	\N
214647	2134	12639843000	28905	14242	33	0	\N
214648	2134	12638839000	28905	14242	34	0	\N
214649	2134	12637835000	28905	14242	35	0	\N
214650	2134	12636831000	28905	14242	36	0	\N
214651	2134	12635827000	28905	14242	37	0	\N
214652	2134	12634823000	28905	14242	38	0	\N
214653	2134	12633819000	28905	14242	39	0	\N
214654	2134	12632815000	28905	14242	40	0	\N
214655	2133	9383918000	28905	14242	41	0	\N
214656	2132	7157171000	28905	14242	42	0	\N
214657	2132	7156170000	28905	14242	43	0	\N
214658	2132	7155169000	28905	14242	45	0	\N
214659	2132	7154168000	28905	14242	46	0	\N
214660	2132	7153167000	28905	14242	47	0	\N
214661	2132	7152166000	28905	14242	48	0	\N
214662	1133	1000000000	28905	14242	49	0	\N
214663	2133	9382916000	28905	14242	50	0	\N
214664	2133	9381914000	28905	14242	51	0	\N
214665	2133	9380912000	28905	14242	52	0	\N
214666	2133	9379910000	28905	14242	53	0	\N
214667	2133	9378908000	28905	14242	54	0	\N
214668	2133	9377906000	28905	14242	55	0	\N
214669	2133	9376904000	28905	14242	56	0	\N
214670	2133	9375902000	28905	14242	57	0	\N
214671	2133	9374900000	28905	14242	58	0	\N
214672	2133	9373898000	28905	14242	59	0	\N
214673	2133	9372896000	28905	14242	60	0	\N
214674	2133	9371894000	28905	14242	61	0	\N
214675	2133	9370892000	28905	14242	62	0	\N
214676	2133	9369890000	28905	14242	63	0	\N
214686	1397	1263592494000	28908	14259	0	0	\N
214687	2133	9366884000	28908	14259	1	0	\N
214688	2134	12630807000	28908	14259	2	0	\N
214689	1397	1263592494000	28909	14259	0	0	\N
214690	2133	9366884000	28909	14259	1	0	\N
214691	2134	12630807000	28909	14259	2	0	\N
214701	2133	9362876000	28913	14262	0	0	\N
214702	2134	12627795000	28913	14262	1	0	\N
214703	2134	12627795000	28914	14262	0	0	\N
214704	2133	9362876000	28915	14262	0	0	\N
214705	2134	12627795000	28915	14262	1	0	\N
214708	2133	9362876000	28917	14262	0	0	\N
214709	2134	12627795000	28917	14262	1	0	\N
214710	2133	9362876000	28918	14262	0	0	\N
214711	2134	12627795000	28918	14262	1	0	\N
214720	1397	1263582493000	28922	14264	0	0	\N
214721	1397	1263572492000	28922	14264	1	0	\N
214722	2134	12625787000	28922	14264	2	0	\N
214723	2133	9360872000	28922	14264	3	0	\N
214724	2133	9359870000	28922	14264	4	0	\N
214725	1397	1263582493000	28923	14264	0	0	\N
214726	1397	1263572492000	28923	14264	1	0	\N
214727	2134	12625787000	28923	14264	2	0	\N
214728	2133	9360872000	28923	14264	3	0	\N
214729	2133	9359870000	28923	14264	4	0	\N
214730	1397	1263562491000	28924	14265	0	0	\N
214731	1397	1263552490000	28924	14265	1	0	\N
214732	2133	9358868000	28924	14265	2	0	\N
214733	2133	9357866000	28924	14265	3	0	\N
214734	2134	12624783000	28924	14265	4	0	\N
214735	2134	12623779000	28924	14265	5	0	\N
214736	2132	7148162000	28924	14265	6	0	\N
214744	1397	1263562491000	28926	14265	0	0	\N
214611	2134	12633819000	28904	14256	3	0	7684
214612	2134	12632815000	28904	14256	4	0	7685
214613	2132	7152166000	28904	14256	5	0	1836
214677	2134	12631811000	28906	14257	0	0	7686
214678	1726	124128112000	28906	14257	1	0	8357
214680	2133	9370892000	28906	14257	3	0	7057
214681	2133	9369890000	28906	14257	4	0	7058
214682	2133	9368888000	28906	14257	5	0	7059
214683	1397	1263602495000	28907	14258	0	0	17522
214684	2133	9367886000	28907	14258	1	0	7060
214692	1397	1263592494000	28910	14259	0	0	17523
214693	2133	9366884000	28910	14259	1	0	7061
214694	2134	12630807000	28910	14259	2	0	7687
214695	2133	9365882000	28911	14260	0	0	7062
214697	2132	7150164000	28911	14260	2	0	1838
214698	2134	12629803000	28911	14260	3	0	7688
214699	2134	12628799000	28911	14260	4	0	7689
214700	2133	9363878000	28912	14261	0	0	7064
214706	2133	9362876000	28916	14262	0	0	7065
214712	2133	9361874000	28920	14263	0	0	7066
214713	2132	7149163000	28920	14263	1	0	1839
214714	2134	12626791000	28920	14263	2	0	7691
214715	1397	1263582493000	28921	14264	0	0	17524
214716	1397	1263572492000	28921	14264	1	0	17525
214718	2133	9360872000	28921	14264	3	0	7067
214719	2133	9359870000	28921	14264	4	0	7068
214737	1397	1263562491000	28925	14265	0	0	17526
214738	1397	1263552490000	28925	14265	1	0	17527
214740	2133	9357866000	28925	14265	3	0	7070
214741	2134	12624783000	28925	14265	4	0	7693
214742	2134	12623779000	28925	14265	5	0	7694
214743	2132	7148162000	28925	14265	6	0	1840
214745	1397	1263552490000	28926	14265	1	0	\N
214746	2133	9358868000	28926	14265	2	0	\N
214747	2133	9357866000	28926	14265	3	0	\N
214748	2134	12624783000	28926	14265	4	0	\N
214749	2134	12623779000	28926	14265	5	0	\N
214750	2132	7148162000	28926	14265	6	0	\N
214751	1397	1263542489000	28927	14266	0	0	\N
214752	1726	123027112000	28927	14266	1	0	\N
214753	2133	9356864000	28927	14266	2	0	\N
214754	2134	12622775000	28927	14266	3	0	\N
214768	1397	1263522487000	28931	14268	0	0	\N
214769	1397	1263512486000	28931	14268	1	0	\N
214770	2132	7147161000	28931	14268	2	0	\N
214771	2134	12621771000	28931	14268	3	0	\N
214772	2134	12620767000	28931	14268	4	0	\N
214773	2133	9354860000	28931	14268	5	0	\N
214774	2133	9353858000	28931	14268	6	0	\N
214775	1397	1263502485000	28932	14269	0	0	\N
214776	2134	12619763000	28932	14269	1	0	\N
214777	2133	9352856000	28932	14269	2	0	\N
214778	1397	1263502485000	28933	14269	0	0	\N
214779	2134	12619763000	28933	14269	1	0	\N
214780	2133	9352856000	28933	14269	2	0	\N
214790	1397	1263472482000	28937	14272	0	0	\N
214791	2134	12617755000	28937	14272	1	0	\N
214792	2133	9349850000	28937	14272	2	0	\N
214796	1397	1263472482000	28939	14272	0	0	\N
214797	2134	12617755000	28939	14272	1	0	\N
214798	2133	9349850000	28939	14272	2	0	\N
214802	1397	1263462481000	28941	14273	0	0	\N
214803	2134	12616751000	28941	14273	1	0	\N
214804	1397	1263462481000	28942	14273	0	0	\N
214805	2134	12616751000	28942	14273	1	0	\N
214806	1397	1263462481000	28943	14273	0	0	\N
214807	2133	9348848000	28943	14273	1	0	\N
214808	2134	12616751000	28943	14273	2	0	\N
214812	1397	1263452480000	28945	14274	0	0	\N
214813	2133	9347846000	28945	14274	1	0	\N
214814	2132	7145159000	28945	14274	2	0	\N
214825	1397	1263442479000	28947	14275	0	0	\N
214826	1397	1263432478000	28947	14275	1	0	\N
214827	1397	1263422477000	28947	14275	2	0	\N
214828	2132	7144158000	28947	14275	3	0	\N
214829	2133	9346844000	28947	14275	4	0	\N
214830	2133	9345842000	28947	14275	5	0	\N
214831	2133	9344840000	28947	14275	6	0	\N
214832	2134	12615747000	28947	14275	7	0	\N
214833	2134	12614743000	28947	14275	8	0	\N
214834	2134	12613739000	28947	14275	9	0	\N
214835	1397	1263412476000	28949	14276	0	0	\N
214836	2133	9343838000	28949	14276	1	0	\N
214852	1397	1263362471000	28955	14281	0	0	\N
214853	2133	9338828000	28955	14281	1	0	\N
214854	2134	12609723000	28955	14281	2	0	\N
214865	1397	1263352470000	28958	14282	0	0	\N
214866	1397	1263342469000	28958	14282	1	0	\N
214867	2134	12608719000	28958	14282	2	0	\N
214868	2132	7142156000	28958	14282	3	0	\N
214869	2133	9337826000	28958	14282	4	0	\N
214870	2133	9336824000	28958	14282	5	0	\N
214871	1726	121926112000	28958	14282	6	0	\N
214872	1397	1263352470000	28959	14282	0	0	\N
214873	1397	1263342469000	28959	14282	1	0	\N
214874	2134	12608719000	28959	14282	2	0	\N
214875	2132	7142156000	28959	14282	3	0	\N
214876	2133	9337826000	28959	14282	4	0	\N
214877	2133	9336824000	28959	14282	5	0	\N
214878	1726	121926112000	28959	14282	6	0	\N
214757	2133	9356864000	28928	14266	2	0	7071
214758	2134	12622775000	28928	14266	3	0	7695
214759	1397	1263532488000	28929	14267	0	0	17529
214760	2133	9355862000	28929	14267	1	0	7072
214761	1397	1263522487000	28930	14268	0	0	17530
214763	2132	7147161000	28930	14268	2	0	1841
214764	2134	12621771000	28930	14268	3	0	7696
214765	2134	12620767000	28930	14268	4	0	7697
214766	2133	9354860000	28930	14268	5	0	7073
214767	2133	9353858000	28930	14268	6	0	7074
214782	2133	9352856000	28934	14269	1	0	7075
214783	1397	1263492484000	28935	14270	0	0	17533
214784	2134	12619763000	28935	14270	1	0	7698
214785	2133	9351854000	28935	14270	2	0	7076
214787	1397	1263482483000	28936	14271	0	0	17534
214788	2133	9350852000	28936	14271	1	0	7077
214789	2134	12618759000	28936	14271	2	0	7699
214793	1397	1263472482000	28938	14272	0	0	17535
214794	2134	12617755000	28938	14272	1	0	7700
214799	1397	1263462481000	28940	14273	0	0	17536
214800	2133	9348848000	28940	14273	1	0	7079
214801	2134	12616751000	28940	14273	2	0	7701
214809	1397	1263452480000	28944	14274	0	0	17537
214810	2133	9347846000	28944	14274	1	0	7080
214815	1397	1263442479000	28946	14275	0	0	17538
214816	1397	1263432478000	28946	14275	1	0	17539
214817	1397	1263422477000	28946	14275	2	0	17540
214818	2132	7144158000	28946	14275	3	0	1844
214820	2133	9345842000	28946	14275	5	0	7082
214821	2133	9344840000	28946	14275	6	0	7083
214822	2134	12615747000	28946	14275	7	0	7702
214823	2134	12614743000	28946	14275	8	0	7703
214824	2134	12613739000	28946	14275	9	0	7704
214838	1397	1263402475000	28951	14277	0	0	17542
214839	2416	95142860	28951	14277	1	0	1
214840	2134	12612735000	28951	14277	2	0	7705
214841	2133	9343838000	28951	14277	3	0	7084
214842	2133	9342836000	28951	14277	4	0	7085
214844	2134	12611731000	28952	14278	1	0	7706
214845	2133	9341834000	28952	14278	2	0	7086
214846	2132	7143157000	28952	14278	3	0	1845
214847	1397	1263382473000	28953	14279	0	0	17544
214849	1397	1263372472000	28954	14280	0	0	17545
214850	2133	9339830000	28954	14280	1	0	7088
214851	2134	12610727000	28954	14280	2	0	7707
214855	1397	1263362471000	28956	14281	0	0	17546
214856	2133	9338828000	28956	14281	1	0	7089
214858	1397	1263352470000	28957	14282	0	0	17547
214859	1397	1263342469000	28957	14282	1	0	17548
214860	2134	12608719000	28957	14282	2	0	7709
214861	2132	7142156000	28957	14282	3	0	1846
214862	2133	9337826000	28957	14282	4	0	7090
214864	1726	121926112000	28957	14282	6	0	8359
214879	1397	1263332468000	28960	14283	0	0	17549
214880	2134	12607715000	28960	14283	1	0	7710
214882	1397	1263332468000	28961	14283	0	0	\N
214883	2134	12607715000	28961	14283	1	0	\N
214884	2133	9335822000	28961	14283	2	0	\N
214885	1397	1263332468000	28962	14283	0	0	\N
214886	2134	12607715000	28962	14283	1	0	\N
214887	2133	9335822000	28962	14283	2	0	\N
214892	2134	12605707000	28964	14285	0	0	\N
214893	1397	1263312466000	28965	14285	0	0	\N
214894	1397	1263302465000	28965	14285	1	0	\N
214895	2133	9333818000	28965	14285	2	0	\N
214896	2134	12605707000	28965	14285	3	0	\N
214897	2133	9332816000	28965	14285	4	0	\N
214898	1397	1263312466000	28966	14285	0	0	\N
214899	1397	1263302465000	28966	14285	1	0	\N
214900	2133	9333818000	28966	14285	2	0	\N
214901	2134	12605707000	28966	14285	3	0	\N
214902	2133	9332816000	28966	14285	4	0	\N
214911	1397	1263292464000	28969	14286	0	0	\N
214912	2133	9331814000	28969	14286	1	0	\N
214913	2132	7140154000	28969	14286	2	0	\N
214914	2134	12604703000	28969	14286	3	0	\N
214915	1397	1263282463000	28970	14287	0	0	\N
214916	2133	9330812000	28970	14287	1	0	\N
214917	2134	12603699000	28970	14287	2	0	\N
214918	2132	7140154000	28970	14287	3	0	\N
214919	1397	1263282463000	28971	14287	0	0	\N
214920	2133	9330812000	28971	14287	1	0	\N
214921	2134	12603699000	28971	14287	2	0	\N
214926	1397	1263282463000	28973	14287	0	0	\N
214927	2133	9330812000	28973	14287	1	0	\N
214928	2134	12603699000	28973	14287	2	0	\N
214929	2132	7140154000	28973	14287	3	0	\N
214939	1397	1263262461000	28976	14289	0	0	\N
214940	1397	1263252460000	28976	14289	1	0	\N
214941	2133	9328808000	28976	14289	2	0	\N
214942	2133	9327806000	28976	14289	3	0	\N
214943	2132	7139153000	28976	14289	4	0	\N
214944	2134	12601691000	28976	14289	5	0	\N
214945	1397	1263242459000	28977	14290	0	0	\N
214946	2134	12600687000	28977	14290	1	0	\N
214947	2133	9326804000	28977	14290	2	0	\N
214948	1397	1263242459000	28978	14290	0	0	\N
214949	2134	12600687000	28978	14290	1	0	\N
214950	2133	9326804000	28978	14290	2	0	\N
214957	1397	1263232458000	28981	14291	0	0	\N
214958	2133	9325802000	28981	14291	1	0	\N
214959	2134	12599683000	28981	14291	2	0	\N
214968	2381	950000000	28983	14292	0	0	\N
214969	1397	1263222457000	28983	14292	1	0	\N
214970	1397	1263212456000	28983	14292	2	0	\N
214971	1963	731505120000	28983	14292	3	0	\N
214972	2132	7138152000	28983	14292	5	0	\N
214973	2133	9324800000	28983	14292	6	0	\N
214974	2133	9323798000	28983	14292	7	0	\N
214975	2134	12598679000	28983	14292	8	0	\N
214976	2381	950000000	28984	14243	0	0	\N
214977	1397	1263602495000	28984	14243	1	0	\N
214978	1397	1263592494000	28984	14243	2	0	\N
214979	1397	1263582493000	28984	14243	3	0	\N
214980	1397	1263572492000	28984	14243	4	0	\N
214981	1397	1263562491000	28984	14243	5	0	\N
214982	1397	1263552490000	28984	14243	6	0	\N
214983	1397	1263542489000	28984	14243	7	0	\N
214984	1397	1263532488000	28984	14243	8	0	\N
214985	1397	1263522487000	28984	14243	9	0	\N
214986	1397	1263512486000	28984	14243	10	0	\N
214987	1397	1263502485000	28984	14243	11	0	\N
214988	1397	1263492484000	28984	14243	12	0	\N
214989	1397	1263482483000	28984	14243	13	0	\N
214990	1397	1263472482000	28984	14243	14	0	\N
214991	1397	1263462481000	28984	14243	15	0	\N
214992	1397	1263452480000	28984	14243	16	0	\N
214993	1397	1263442479000	28984	14243	17	0	\N
214994	1397	1263432478000	28984	14243	18	0	\N
214995	1397	1263422477000	28984	14243	19	0	\N
214996	1397	1263412476000	28984	14243	20	0	\N
214997	1397	1263402475000	28984	14243	21	0	\N
214998	1397	1263392474000	28984	14243	22	0	\N
214999	1397	1263382473000	28984	14243	23	0	\N
215000	1397	1263372472000	28984	14243	24	0	\N
215001	1397	1263362471000	28984	14243	25	0	\N
215002	1397	1263352470000	28984	14243	26	0	\N
215003	1397	1263342469000	28984	14243	27	0	\N
215004	1397	1263332468000	28984	14243	28	0	\N
215005	1397	1263322467000	28984	14243	29	0	\N
215006	1397	1263312466000	28984	14243	30	0	\N
215007	1397	1263302465000	28984	14243	31	0	\N
215008	1397	1263292464000	28984	14243	32	0	\N
215009	1397	1263282463000	28984	14243	33	0	\N
215010	1397	1263272462000	28984	14243	34	0	\N
215011	1397	1263262461000	28984	14243	35	0	\N
215012	1397	1263252460000	28984	14243	36	0	\N
215013	1397	1263242459000	28984	14243	37	0	\N
215014	1397	1263232458000	28984	14243	38	0	\N
215015	1397	1263222457000	28984	14243	39	0	\N
215016	1397	1263212456000	28984	14243	40	0	\N
214889	2134	12606711000	28963	14284	1	0	7711
214890	2132	7141155000	28963	14284	2	0	1847
214891	2133	9334820000	28963	14284	3	0	7093
214903	1397	1263312466000	28967	14285	0	0	17551
214904	1397	1263302465000	28967	14285	1	0	17552
214906	2134	12605707000	28967	14285	3	0	7712
214907	2133	9332816000	28967	14285	4	0	7095
214908	1397	1263292464000	28968	14286	0	0	17553
214909	2133	9331814000	28968	14286	1	0	7096
214910	2134	12604703000	28968	14286	2	0	7713
214923	2133	9330812000	28972	14287	1	0	7097
214924	2134	12603699000	28972	14287	2	0	7714
214925	2132	7140154000	28972	14287	3	0	1848
214930	1397	1263272462000	28974	14288	0	0	17555
214932	2133	9329810000	28974	14288	2	0	7098
214933	1397	1263262461000	28975	14289	0	0	17556
214934	1397	1263252460000	28975	14289	1	0	17557
214935	2133	9328808000	28975	14289	2	0	7099
214936	2133	9327806000	28975	14289	3	0	7100
214938	2134	12601691000	28975	14289	5	0	7716
214951	1397	1263242459000	28979	14290	0	0	17558
214952	2134	12600687000	28979	14290	1	0	7717
214953	2133	9326804000	28979	14290	2	0	7101
214954	1397	1263232458000	28980	14291	0	0	17559
214956	2134	12599683000	28980	14291	2	0	7718
214960	2381	950000000	28982	14292	0	0	1
214961	1397	1263222457000	28982	14292	1	0	17560
214962	1397	1263212456000	28982	14292	2	0	17561
214964	2132	7138152000	28982	14292	5	0	1850
214965	2133	9324800000	28982	14292	6	0	7103
214966	2133	9323798000	28982	14292	7	0	7104
214967	2134	12598679000	28982	14292	8	0	7719
215017	1397	1263202455000	28984	14243	41	0	\N
215018	1963	731505120000	28984	14243	42	0	\N
215019	2133	9368888000	28984	14243	43	0	\N
215020	2133	9367886000	28984	14243	44	0	\N
215021	2133	9366884000	28984	14243	45	0	\N
215022	2133	9365882000	28984	14243	46	0	\N
215023	2133	9364880000	28984	14243	47	0	\N
215024	2132	7151165000	28984	14243	48	0	\N
215025	2132	7150164000	28984	14243	49	0	\N
215026	2132	7149163000	28984	14243	50	0	\N
215027	1726	124128112000	28984	14243	51	0	\N
215028	1726	123027112000	28984	14243	52	0	\N
215029	2133	9363878000	28984	14243	53	0	\N
215030	2133	9362876000	28984	14243	54	0	\N
215031	2133	9361874000	28984	14243	55	0	\N
215032	2133	9360872000	28984	14243	56	0	\N
215033	2133	9359870000	28984	14243	57	0	\N
215034	2133	9358868000	28984	14243	58	0	\N
215035	2133	9357866000	28984	14243	59	0	\N
215036	1397	1263202455000	28985	14293	0	0	\N
215037	2134	12597675000	28985	14293	1	0	\N
215038	2133	9322796000	28985	14293	2	0	\N
215042	1397	1263202455000	28987	14293	0	0	\N
215043	2134	12597675000	28987	14293	1	0	\N
215044	2133	9322796000	28987	14293	2	0	\N
215045	2381	950000000	28988	14265	0	0	\N
215046	1963	731505120000	28988	14265	1	0	\N
215047	2381	950000000	28989	14248	0	0	\N
215048	1963	731505120000	28989	14248	1	0	\N
215049	2381	950000000	28990	14282	0	0	\N
215050	1963	731505120000	28990	14282	1	0	\N
215051	1397	1263192454000	28991	14294	0	0	\N
215052	2133	9321794000	28991	14294	1	0	\N
215053	2132	7137151000	28991	14294	2	0	\N
215057	1397	1263192454000	28993	14294	0	0	\N
215058	2133	9321794000	28993	14294	1	0	\N
215059	2132	7137151000	28993	14294	2	0	\N
215063	1397	1263182453000	28995	14295	0	0	\N
215064	2133	9320792000	28995	14295	1	0	\N
215065	2134	12596671000	28995	14295	2	0	\N
215069	1397	1263172452000	28997	14296	0	0	\N
215070	2134	12595667000	28997	14296	1	0	\N
215071	2133	9319790000	28997	14296	2	0	\N
215078	1397	1263152450000	29000	14298	0	0	\N
215079	2132	7136150000	29000	14298	1	0	\N
215080	2133	9317786000	29000	14298	2	0	\N
215100	1397	1263102445000	29005	14302	0	0	\N
215101	1397	1263092444000	29005	14302	1	0	\N
215102	2133	9312776000	29005	14302	2	0	\N
215103	2134	12590647000	29005	14302	3	0	\N
215104	2133	9311774000	29005	14302	4	0	\N
215105	2134	12589643000	29005	14302	5	0	\N
215106	2132	7134148000	29005	14302	6	0	\N
215115	1397	1263072442000	29008	14304	0	0	\N
215116	1397	1263062441000	29008	14304	1	0	\N
215117	2134	12587635000	29008	14304	2	0	\N
215118	2133	9309770000	29008	14304	3	0	\N
215119	2133	9308768000	29008	14304	4	0	\N
215120	1397	1263052440000	29009	14305	0	0	\N
215121	2132	7133147000	29009	14305	1	0	\N
215122	2133	9307766000	29009	14305	2	0	\N
215123	2134	12586631000	29009	14305	3	0	\N
215128	1397	1263052440000	29011	14305	0	0	\N
215129	2132	7133147000	29011	14305	1	0	\N
215130	2133	9307766000	29011	14305	2	0	\N
215131	2134	12586631000	29011	14305	3	0	\N
215135	1397	1263042439000	29013	14306	0	0	\N
215136	2134	12585627000	29013	14306	1	0	\N
215137	2133	9306764000	29013	14306	2	0	\N
215138	1397	1263032438000	29014	14307	0	0	\N
215139	1397	1263022437000	29014	14307	1	0	\N
215140	2132	7132146000	29014	14307	2	0	\N
215141	2134	12584623000	29014	14307	3	0	\N
215142	2133	9305762000	29014	14307	4	0	\N
215143	2133	9304760000	29014	14307	5	0	\N
215041	2133	9322796000	28986	14293	2	0	7105
215054	1397	1263192454000	28992	14294	0	0	17563
215055	2133	9321794000	28992	14294	1	0	7106
215056	2132	7137151000	28992	14294	2	0	1851
215060	1397	1263182453000	28994	14295	0	0	17564
215062	2134	12596671000	28994	14295	2	0	7721
215066	1397	1263172452000	28996	14296	0	0	17565
215067	2134	12595667000	28996	14296	1	0	7722
215068	2133	9319790000	28996	14296	2	0	7108
215072	1397	1263162451000	28998	14297	0	0	17566
215074	2134	12594663000	28998	14297	2	0	7723
215075	1397	1263152450000	28999	14298	0	0	17567
215076	2132	7136150000	28999	14298	1	0	1852
215077	2133	9317786000	28999	14298	2	0	7110
215082	1397	1263132448000	29001	14299	1	0	17569
215083	2133	9316784000	29001	14299	2	0	7111
215084	2134	12593659000	29001	14299	3	0	7724
215085	2133	9315782000	29001	14299	4	0	7112
215086	2134	12592655000	29001	14299	5	0	7725
215088	2134	12591651000	29002	14300	1	0	7726
215089	2132	7135149000	29002	14300	2	0	1853
215090	2133	9314780000	29002	14300	3	0	7113
215091	1397	1263112446000	29003	14301	0	0	17571
215092	2133	9313778000	29003	14301	1	0	7114
215094	1397	1263092444000	29004	14302	1	0	17573
215095	2133	9312776000	29004	14302	2	0	7115
215096	2134	12590647000	29004	14302	3	0	7727
215097	2133	9311774000	29004	14302	4	0	7116
215099	2132	7134148000	29004	14302	6	0	1854
215107	1397	1263082443000	29006	14303	0	0	17574
215108	2133	9310772000	29006	14303	1	0	7117
215109	2134	12588639000	29006	14303	2	0	7729
215110	1397	1263072442000	29007	14304	0	0	17575
215112	2134	12587635000	29007	14304	2	0	7730
215113	2133	9309770000	29007	14304	3	0	7118
215114	2133	9308768000	29007	14304	4	0	7119
215124	1397	1263052440000	29010	14305	0	0	17577
215125	2132	7133147000	29010	14305	1	0	1855
215127	2134	12586631000	29010	14305	3	0	7731
215132	1397	1263042439000	29012	14306	0	0	17578
215133	2134	12585627000	29012	14306	1	0	7732
215134	2133	9306764000	29012	14306	2	0	7121
215145	1397	1263022437000	29015	14307	1	0	17580
215146	2132	7132146000	29015	14307	2	0	1856
215147	2134	12584623000	29015	14307	3	0	7733
215148	2133	9305762000	29015	14307	4	0	7122
215149	2133	9304760000	29015	14307	5	0	7123
215151	2134	12583619000	29016	14308	1	0	7734
215152	2133	9303758000	29016	14308	2	0	7124
215168	1397	1262962431000	29021	14312	0	0	\N
215169	2133	9298748000	29021	14312	1	0	\N
215170	1397	1262952430000	29022	14313	0	0	\N
215171	2133	9297746000	29022	14313	1	0	\N
215172	2134	12579603000	29022	14313	2	0	\N
215173	2132	7130144000	29022	14313	3	0	\N
215178	1397	1262942429000	29024	14314	0	0	\N
215179	1397	1262932428000	29024	14314	1	0	\N
215180	2133	9296744000	29024	14314	2	0	\N
215181	2134	12578599000	29024	14314	3	0	\N
215182	2133	9295742000	29024	14314	4	0	\N
215183	1397	1262942429000	29025	14314	0	0	\N
215184	1397	1262932428000	29025	14314	1	0	\N
215185	2133	9296744000	29025	14314	2	0	\N
215186	2134	12578599000	29025	14314	3	0	\N
215187	2133	9295742000	29025	14314	4	0	\N
215188	1397	1262942429000	29026	14314	0	0	\N
215189	1397	1262932428000	29026	14314	1	0	\N
215190	2133	9296744000	29026	14314	2	0	\N
215191	2134	12578599000	29026	14314	3	0	\N
215192	2133	9295742000	29026	14314	4	0	\N
215205	1397	1262902425000	29029	14316	0	0	\N
215206	1397	1262892424000	29029	14316	1	0	\N
215207	2133	9293738000	29029	14316	2	0	\N
215208	2134	12575587000	29029	14316	3	0	\N
215209	2132	7128142000	29029	14316	4	0	\N
215210	2133	9292736000	29029	14316	5	0	\N
215220	1397	1262882423000	29032	14317	0	0	\N
215221	2134	12574583000	29032	14317	1	0	\N
215222	2133	9291734000	29032	14317	2	0	\N
215223	1397	1262882423000	29033	14317	0	0	\N
215224	2134	12574583000	29033	14317	1	0	\N
215225	2133	9291734000	29033	14317	2	0	\N
215226	2414	90000000	29034	14318	0	0	\N
215227	1397	1262872422000	29034	14318	1	0	\N
215228	2133	9290732000	29034	14318	2	0	\N
215229	2134	12573579000	29034	14318	3	0	\N
215234	693	66000000000000	29036	14315	0	0	\N
215241	1397	1262852420000	29039	14320	0	0	\N
215242	2134	12572575000	29039	14320	1	0	\N
215243	2132	7127141000	29039	14320	2	0	\N
215244	2133	9288728000	29039	14320	3	0	\N
215251	1397	1262822417000	29042	14323	0	0	\N
215252	1397	1262812416000	29042	14323	1	0	\N
215253	2133	9285722000	29042	14323	2	0	\N
215254	2133	9284720000	29042	14323	3	0	\N
215255	2134	12569563000	29042	14323	4	0	\N
215256	2132	7126140000	29042	14323	5	0	\N
215266	1397	1262802415000	29045	14324	0	0	\N
215267	2133	9283718000	29045	14324	1	0	\N
215268	2134	12568559000	29045	14324	2	0	\N
215275	1397	1262792414000	29047	14325	0	0	\N
215276	1397	1262782413000	29047	14325	1	0	\N
215277	2134	12567555000	29047	14325	2	0	\N
215278	2132	7125139000	29047	14325	3	0	\N
215279	2133	9282716000	29047	14325	4	0	\N
215280	2133	9281714000	29047	14325	5	0	\N
215281	1397	1262792414000	29048	14325	0	0	\N
215282	1397	1262782413000	29048	14325	1	0	\N
215283	2134	12567555000	29048	14325	2	0	\N
215284	2132	7125139000	29048	14325	3	0	\N
215285	2133	9282716000	29048	14325	4	0	\N
215286	2133	9281714000	29048	14325	5	0	\N
215155	1397	1262992434000	29017	14309	2	0	17583
215156	2133	9302756000	29017	14309	3	0	7125
215157	2132	7131145000	29017	14309	4	0	1857
215158	2133	9301754000	29017	14309	5	0	7126
215159	2134	12582615000	29017	14309	6	0	7735
215161	2133	9300752000	29018	14310	1	0	7127
215162	2134	12581611000	29018	14310	2	0	7736
215163	1397	1262972432000	29019	14311	0	0	17585
215164	2133	9299750000	29019	14311	1	0	7128
215165	2134	12580607000	29019	14311	2	0	7737
215167	2133	9298748000	29020	14312	1	0	7129
215174	1397	1262952430000	29023	14313	0	0	17587
215175	2133	9297746000	29023	14313	1	0	7130
215176	2134	12579603000	29023	14313	2	0	7738
215193	1397	1262942429000	29027	14314	0	0	17588
215194	1397	1262932428000	29027	14314	1	0	17589
215195	2133	9296744000	29027	14314	2	0	7131
215196	2134	12578599000	29027	14314	3	0	7739
215197	2133	9295742000	29027	14314	4	0	7132
215199	1397	1262922427000	29028	14315	1	0	17590
215200	1397	1262912426000	29028	14315	2	0	17591
215201	2134	12577595000	29028	14315	3	0	7740
215202	2134	12576591000	29028	14315	4	0	7741
215203	2133	9294740000	29028	14315	5	0	7133
215211	1397	1262902425000	29030	14316	0	0	17592
215212	1397	1262892424000	29030	14316	1	0	17593
215213	2133	9293738000	29030	14316	2	0	7134
215214	2134	12575587000	29030	14316	3	0	7742
215216	2133	9292736000	29030	14316	5	0	7135
215217	1397	1262882423000	29031	14317	0	0	17594
215218	2134	12574583000	29031	14317	1	0	7743
215219	2133	9291734000	29031	14317	2	0	7136
215230	2414	90000000	29035	14318	0	0	1
215232	2133	9290732000	29035	14318	2	0	7137
215233	2134	12573579000	29035	14318	3	0	7744
215235	1397	1262862421000	29037	14319	0	0	17596
215236	2133	9289730000	29037	14319	1	0	7138
215237	1397	1262852420000	29038	14320	0	0	17597
215239	2132	7127141000	29038	14320	2	0	1861
215240	2133	9288728000	29038	14320	3	0	7139
215245	1397	1262842419000	29040	14321	0	0	17598
215246	2133	9287726000	29040	14321	1	0	7140
215248	1397	1262832418000	29041	14322	0	0	17599
215249	2134	12570567000	29041	14322	1	0	7747
215250	2133	9286724000	29041	14322	2	0	7141
215257	1397	1262822417000	29043	14323	0	0	17600
215258	1397	1262812416000	29043	14323	1	0	17601
215260	2133	9284720000	29043	14323	3	0	7143
215261	2134	12569563000	29043	14323	4	0	7748
215262	2132	7126140000	29043	14323	5	0	1862
215263	1397	1262802415000	29044	14324	0	0	17602
215264	2133	9283718000	29044	14324	1	0	7144
215269	1397	1262792414000	29046	14325	0	0	17603
215270	1397	1262782413000	29046	14325	1	0	17604
215271	2134	12567555000	29046	14325	2	0	7750
215272	2132	7125139000	29046	14325	3	0	1863
215274	2133	9281714000	29046	14325	5	0	7146
215287	1397	1262772412000	29049	14326	0	0	17605
215288	2133	9280712000	29049	14326	1	0	7147
215290	1397	1262772412000	29050	14326	0	0	\N
215291	2133	9280712000	29050	14326	1	0	\N
215292	2134	12566551000	29050	14326	2	0	\N
215293	1397	1262772412000	29051	14326	0	0	\N
215294	2133	9280712000	29051	14326	1	0	\N
215295	2134	12566551000	29051	14326	2	0	\N
215296	1397	1262772412000	29052	14326	0	0	\N
215297	2133	9280712000	29052	14326	1	0	\N
215298	2134	12566551000	29052	14326	2	0	\N
215299	1397	1262762411000	29053	14327	0	0	\N
215300	2133	9279710000	29053	14327	1	0	\N
215301	2134	12565547000	29053	14327	2	0	\N
215311	1397	1262752410000	29056	14328	0	0	\N
215312	1397	1262742409000	29056	14328	1	0	\N
215313	2133	9278708000	29056	14328	2	0	\N
215314	2133	9277706000	29056	14328	3	0	\N
215315	2134	12564543000	29056	14328	4	0	\N
215316	2132	7124138000	29056	14328	5	0	\N
215317	1397	1262732408000	29057	14329	0	0	\N
215318	2134	12563539000	29057	14329	1	0	\N
215319	2133	9276704000	29057	14329	2	0	\N
215323	1397	1262722407000	29059	14330	0	0	\N
215324	1397	1262712406000	29059	14330	1	0	\N
215325	1397	1262702405000	29059	14330	2	0	\N
215326	2132	7123137000	29059	14330	3	0	\N
215327	2134	12562535000	29059	14330	4	0	\N
215328	2133	9275702000	29059	14330	5	0	\N
215329	2133	9274700000	29059	14330	6	0	\N
215330	2133	9273698000	29059	14330	7	0	\N
215331	2134	12561531000	29059	14330	8	0	\N
215332	1397	1262722407000	29060	14330	0	0	\N
215333	1397	1262712406000	29060	14330	1	0	\N
215334	1397	1262702405000	29060	14330	2	0	\N
215335	2132	7123137000	29060	14330	3	0	\N
215336	2134	12562535000	29060	14330	4	0	\N
215337	2133	9275702000	29060	14330	5	0	\N
215338	2133	9274700000	29060	14330	6	0	\N
215339	2133	9273698000	29060	14330	7	0	\N
215340	2134	12561531000	29060	14330	8	0	\N
215341	1397	1262722407000	29061	14330	0	0	\N
215342	1397	1262712406000	29061	14330	1	0	\N
215343	1397	1262702405000	29061	14330	2	0	\N
215344	2132	7123137000	29061	14330	3	0	\N
215345	2134	12562535000	29061	14330	4	0	\N
215346	2133	9275702000	29061	14330	5	0	\N
215347	2133	9274700000	29061	14330	6	0	\N
215348	2133	9273698000	29061	14330	7	0	\N
215349	2134	12561531000	29061	14330	8	0	\N
215350	1397	1262722407000	29062	14330	0	0	\N
215351	1397	1262712406000	29062	14330	1	0	\N
215352	1397	1262702405000	29062	14330	2	0	\N
215353	2132	7123137000	29062	14330	3	0	\N
215354	2134	12562535000	29062	14330	4	0	\N
215355	2133	9275702000	29062	14330	5	0	\N
215356	2133	9274700000	29062	14330	6	0	\N
215357	2133	9273698000	29062	14330	7	0	\N
215358	2134	12561531000	29062	14330	8	0	\N
215359	1397	1262722407000	29063	14330	0	0	\N
215360	1397	1262712406000	29063	14330	1	0	\N
215361	1397	1262702405000	29063	14330	2	0	\N
215362	2132	7123137000	29063	14330	3	0	\N
215363	2134	12562535000	29063	14330	4	0	\N
215364	2133	9275702000	29063	14330	5	0	\N
215365	2133	9274700000	29063	14330	6	0	\N
215366	2133	9273698000	29063	14330	7	0	\N
215367	2134	12561531000	29063	14330	8	0	\N
215377	1397	1262692404000	29065	14331	0	0	\N
215378	2134	12560527000	29065	14331	1	0	\N
215379	2132	7122136000	29065	14331	2	0	\N
215380	2133	9272696000	29065	14331	3	0	\N
215385	1397	1262692404000	29067	14331	0	0	\N
215386	2134	12560527000	29067	14331	1	0	\N
215387	2132	7122136000	29067	14331	2	0	\N
215388	2133	9272696000	29067	14331	3	0	\N
215389	1397	1262692404000	29068	14331	0	0	\N
215390	2134	12560527000	29068	14331	1	0	\N
215391	2132	7122136000	29068	14331	2	0	\N
215392	2133	9272696000	29068	14331	3	0	\N
215398	1397	1262662401000	29071	14334	0	0	\N
215399	1397	1262662401000	29072	14334	0	0	\N
215400	2134	12558519000	29072	14334	1	0	\N
215401	2133	9269690000	29072	14334	3	0	\N
215405	1397	1262662401000	29074	14334	0	0	\N
215406	2134	12558519000	29074	14334	1	0	\N
215407	2133	9269690000	29074	14334	3	0	\N
215408	1397	1262662401000	29075	14334	0	0	\N
215409	2134	12558519000	29075	14334	1	0	\N
215410	2133	9269690000	29075	14334	3	0	\N
215415	1397	1262652400000	29077	14335	0	0	\N
215416	2132	7121135000	29077	14335	1	0	\N
215417	2133	9268688000	29077	14335	2	0	\N
215418	2134	12557515000	29077	14335	3	0	\N
215419	1397	1262652400000	29078	14335	0	0	\N
215420	2132	7121135000	29078	14335	1	0	\N
215421	2133	9268688000	29078	14335	2	0	\N
215422	2134	12557515000	29078	14335	3	0	\N
215423	1397	1262652400000	29079	14335	0	0	\N
215424	2132	7121135000	29079	14335	1	0	\N
215303	2133	9279710000	29054	14327	1	0	7148
215304	2134	12565547000	29054	14327	2	0	7752
215305	1397	1262752410000	29055	14328	0	0	17607
215306	1397	1262742409000	29055	14328	1	0	17608
215307	2133	9278708000	29055	14328	2	0	7149
215309	2134	12564543000	29055	14328	4	0	7753
215310	2132	7124138000	29055	14328	5	0	1864
215320	1397	1262732408000	29058	14329	0	0	17609
215321	2134	12563539000	29058	14329	1	0	7754
215322	2133	9276704000	29058	14329	2	0	7151
215369	1397	1262712406000	29064	14330	1	0	17611
215370	1397	1262702405000	29064	14330	2	0	17612
215371	2132	7123137000	29064	14330	3	0	1865
215372	2134	12562535000	29064	14330	4	0	7755
215374	2133	9274700000	29064	14330	6	0	7153
215375	2133	9273698000	29064	14330	7	0	7154
215376	2134	12561531000	29064	14330	8	0	7756
215381	1397	1262692404000	29066	14331	0	0	17613
215382	2134	12560527000	29066	14331	1	0	7757
215384	2133	9272696000	29066	14331	3	0	7155
215393	1397	1262682403000	29069	14332	0	0	17614
215394	2133	9271694000	29069	14332	1	0	7156
215395	1397	1262672402000	29070	14333	0	0	17615
215396	2134	12559523000	29070	14333	1	0	7758
215402	1397	1262662401000	29073	14334	0	0	17616
215403	2134	12558519000	29073	14334	1	0	7759
215404	2133	9269690000	29073	14334	3	0	7158
215411	1397	1262652400000	29076	14335	0	0	17617
215413	2133	9268688000	29076	14335	2	0	7159
215414	2134	12557515000	29076	14335	3	0	7760
215425	2133	9268688000	29079	14335	2	0	\N
215426	1397	1262652400000	29080	14335	0	0	\N
215427	2132	7121135000	29080	14335	1	0	\N
215428	2133	9268688000	29080	14335	2	0	\N
215434	1397	1262632398000	29083	14337	0	0	\N
215435	2133	9266684000	29083	14337	1	0	\N
215436	2134	12556511000	29083	14337	2	0	\N
215437	1397	1262632398000	29084	14337	0	0	\N
215438	2133	9266684000	29084	14337	1	0	\N
215439	2134	12556511000	29084	14337	2	0	\N
215440	1397	1262622397000	29085	14338	0	0	\N
215441	2132	7120134000	29085	14338	1	0	\N
215442	2133	9265682000	29085	14338	2	0	\N
215443	2134	12555507000	29085	14338	3	0	\N
215457	1397	1262582393000	29090	14342	0	0	\N
215458	835	3199985394837430	29090	14342	1	0	\N
215459	1397	1262572392000	29090	14342	2	0	\N
215460	2133	9261674000	29090	14342	3	0	\N
215461	2133	9260672000	29090	14342	4	0	\N
215462	2134	12552495000	29090	14342	5	0	\N
215472	1397	1262562391000	29093	14343	0	0	\N
215473	2134	12551491000	29093	14343	1	0	\N
215474	2133	9259670000	29093	14343	2	0	\N
215479	1397	1262552390000	29095	14344	0	0	\N
215480	2134	12550487000	29095	14344	1	0	\N
215481	2132	7118132000	29095	14344	2	0	\N
215482	2133	9258668000	29095	14344	3	0	\N
215483	1397	1262552390000	29096	14344	0	0	\N
215484	2134	12550487000	29096	14344	1	0	\N
215485	2132	7118132000	29096	14344	2	0	\N
215486	2133	9258668000	29096	14344	3	0	\N
215487	1397	1262552390000	29097	14344	0	0	\N
215488	2134	12550487000	29097	14344	1	0	\N
215489	2132	7118132000	29097	14344	2	0	\N
215490	2133	9258668000	29097	14344	3	0	\N
215491	2381	950000000	29098	14190	0	0	\N
215492	835	3199985394837430	29098	14190	2	0	\N
215493	656	66544500726895	29098	14190	3	0	\N
215494	693	66000000000000	29098	14190	4	0	\N
215495	656	66543490726895	29098	14190	5	0	\N
215496	656	66543450726895	29098	14190	6	0	\N
215497	656	66000440726895	29098	14190	7	0	\N
215498	1963	731505120000	29098	14190	8	0	\N
215499	2405	96230770	29098	14190	9	0	\N
215500	2405	92461540	29098	14190	10	0	\N
215501	1013	2000000000	29098	14190	11	0	\N
215502	1133	1000000000	29098	14190	12	0	\N
215505	1397	1262542389000	29100	14345	0	0	\N
215506	2133	9257666000	29100	14345	1	0	\N
215507	1397	1262532388000	29101	14346	0	0	\N
215508	1397	1262522387000	29101	14346	1	0	\N
215509	1397	1262512386000	29101	14346	2	0	\N
215510	2133	9256664000	29101	14346	3	0	\N
215511	2133	9255662000	29101	14346	4	0	\N
215512	2133	9254660000	29101	14346	5	0	\N
215513	2134	12549483000	29101	14346	6	0	\N
215514	2134	12548479000	29101	14346	7	0	\N
215515	2134	12547475000	29101	14346	8	0	\N
215516	2132	7117131000	29101	14346	9	0	\N
215527	1397	1262502385000	29103	14347	0	0	\N
215528	2133	9253658000	29103	14347	1	0	\N
215531	296	66001900000000	29105	14302	0	0	\N
215532	1397	1263102445000	29105	14302	1	0	\N
215533	1397	1263092444000	29105	14302	2	0	\N
215534	2414	90000000	29105	14302	3	0	\N
215535	835	3199985394837430	29105	14302	4	0	\N
215536	693	66000000000000	29105	14302	5	0	\N
215537	1397	1263082443000	29105	14302	6	0	\N
215538	1397	1263072442000	29105	14302	7	0	\N
215539	1397	1263062441000	29105	14302	8	0	\N
215540	1397	1263052440000	29105	14302	9	0	\N
215541	1397	1263042439000	29105	14302	10	0	\N
215542	1397	1263032438000	29105	14302	11	0	\N
215543	1397	1263022437000	29105	14302	12	0	\N
215544	1397	1263012436000	29105	14302	13	0	\N
215545	1397	1263002435000	29105	14302	14	0	\N
215546	1397	1262992434000	29105	14302	15	0	\N
215547	1397	1262982433000	29105	14302	16	0	\N
215548	1397	1262972432000	29105	14302	17	0	\N
215549	1397	1262962431000	29105	14302	18	0	\N
215550	1397	1262952430000	29105	14302	19	0	\N
215551	1397	1262942429000	29105	14302	20	0	\N
215552	1397	1262932428000	29105	14302	21	0	\N
215553	1397	1262922427000	29105	14302	22	0	\N
215554	1397	1262912426000	29105	14302	23	0	\N
215555	1397	1262902425000	29105	14302	24	0	\N
215556	1397	1262892424000	29105	14302	25	0	\N
215557	1397	1262882423000	29105	14302	26	0	\N
215558	1397	1262872422000	29105	14302	27	0	\N
215559	1397	1262862421000	29105	14302	28	0	\N
215560	1397	1262852420000	29105	14302	29	0	\N
215431	1397	1262632398000	29082	14337	0	0	17619
215432	2133	9266684000	29082	14337	1	0	7161
215433	2134	12556511000	29082	14337	2	0	7761
215444	1397	1262622397000	29086	14338	0	0	17620
215445	2132	7120134000	29086	14338	1	0	1868
215447	2134	12555507000	29086	14338	3	0	7762
215448	1397	1262612396000	29087	14339	0	0	17621
215449	2133	9264680000	29087	14339	1	0	7163
215450	1397	1262602395000	29088	14340	0	0	17622
215451	2133	9263678000	29088	14340	1	0	7164
215453	1397	1262592394000	29089	14341	0	0	17623
215454	2133	9262676000	29089	14341	1	0	7165
215455	2132	7119133000	29089	14341	2	0	1869
215456	2134	12553499000	29089	14341	3	0	7764
215464	835	3199985394837430	29091	14342	1	0	1
215465	1397	1262572392000	29091	14342	2	0	17625
215466	2133	9261674000	29091	14342	3	0	7166
215467	2133	9260672000	29091	14342	4	0	7167
215468	2134	12552495000	29091	14342	5	0	7765
215470	2134	12551491000	29092	14343	1	0	7766
215471	2133	9259670000	29092	14343	2	0	7168
215475	1397	1262552390000	29094	14344	0	0	17627
215476	2134	12550487000	29094	14344	1	0	7767
215477	2132	7118132000	29094	14344	2	0	1870
215503	1397	1262542389000	29099	14345	0	0	17628
215504	2133	9257666000	29099	14345	1	0	7170
215517	1397	1262532388000	29102	14346	0	0	17629
215518	1397	1262522387000	29102	14346	1	0	17630
215520	2133	9256664000	29102	14346	3	0	7171
215521	2133	9255662000	29102	14346	4	0	7172
215522	2133	9254660000	29102	14346	5	0	7173
215523	2134	12549483000	29102	14346	6	0	7768
215524	2134	12548479000	29102	14346	7	0	7769
215526	2132	7117131000	29102	14346	9	0	1871
215529	1397	1262502385000	29104	14347	0	0	17632
215530	2133	9253658000	29104	14347	1	0	7174
215561	1397	1262842419000	29105	14302	30	0	\N
215562	1397	1262832418000	29105	14302	31	0	\N
215563	1397	1262822417000	29105	14302	32	0	\N
215564	1397	1262812416000	29105	14302	33	0	\N
215565	1397	1262802415000	29105	14302	34	0	\N
215566	1397	1262792414000	29105	14302	35	0	\N
215567	1397	1262782413000	29105	14302	36	0	\N
215568	1397	1262772412000	29105	14302	37	0	\N
215569	1397	1262762411000	29105	14302	38	0	\N
215570	1397	1262752410000	29105	14302	39	0	\N
215571	1397	1262742409000	29105	14302	40	0	\N
215572	1397	1262732408000	29105	14302	41	0	\N
215573	1397	1262722407000	29105	14302	42	0	\N
215574	1397	1262712406000	29105	14302	43	0	\N
215575	1397	1262702405000	29105	14302	44	0	\N
215576	1397	1262692404000	29105	14302	45	0	\N
215577	1397	1262682403000	29105	14302	46	0	\N
215578	1397	1262672402000	29105	14302	47	0	\N
215579	1397	1262662401000	29105	14302	48	0	\N
215580	1397	1262652400000	29105	14302	49	0	\N
215581	1397	1262642399000	29105	14302	50	0	\N
215582	1397	1262632398000	29105	14302	51	0	\N
215583	1397	1262622397000	29105	14302	52	0	\N
215584	1397	1262612396000	29105	14302	53	0	\N
215585	1397	1262602395000	29105	14302	54	0	\N
215586	1397	1262592394000	29105	14302	55	0	\N
215587	1397	1262582393000	29105	14302	56	0	\N
215588	1397	1262572392000	29105	14302	57	0	\N
215589	1397	1262562391000	29105	14302	58	0	\N
215590	1397	1262552390000	29105	14302	59	0	\N
215591	1397	1262542389000	29105	14302	60	0	\N
215592	1397	1262532388000	29105	14302	61	0	\N
215593	1397	1262522387000	29105	14302	62	0	\N
215594	1397	1262512386000	29105	14302	63	0	\N
215595	1397	1262502385000	29105	14302	64	0	\N
215596	2133	9312776000	29105	14302	65	0	\N
215597	2134	12590647000	29105	14302	66	0	\N
215598	2133	9311774000	29105	14302	67	0	\N
215599	2133	9310772000	29105	14302	68	0	\N
215600	2133	9309770000	29105	14302	69	0	\N
215601	2133	9308768000	29105	14302	70	0	\N
215602	2133	9307766000	29105	14302	71	0	\N
215603	2134	12589643000	29105	14302	72	0	\N
215604	2134	12588639000	29105	14302	74	0	\N
215605	2134	12587635000	29105	14302	75	0	\N
215606	2134	12586631000	29105	14302	76	0	\N
215607	2134	12585627000	29105	14302	77	0	\N
215608	2134	12584623000	29105	14302	78	0	\N
215609	2134	12583619000	29105	14302	79	0	\N
215610	2134	12582615000	29105	14302	80	0	\N
215611	2134	12581611000	29105	14302	81	0	\N
215612	2134	12580607000	29105	14302	82	0	\N
215613	2134	12579603000	29105	14302	83	0	\N
215614	2134	12578599000	29105	14302	84	0	\N
215615	2134	12577595000	29105	14302	85	0	\N
215616	2134	12576591000	29105	14302	86	0	\N
215617	2134	12575587000	29105	14302	87	0	\N
215618	2134	12574583000	29105	14302	88	0	\N
215619	2132	7134148000	29105	14302	89	0	\N
215620	2132	7133147000	29105	14302	90	0	\N
215621	2132	7132146000	29105	14302	91	0	\N
215622	2132	7131145000	29105	14302	92	0	\N
215623	2132	7130144000	29105	14302	93	0	\N
215624	2132	7129143000	29105	14302	94	0	\N
215625	2132	7128142000	29105	14302	95	0	\N
215626	2132	7127141000	29105	14302	96	0	\N
215627	2132	7126140000	29105	14302	97	0	\N
215628	2132	7125139000	29105	14302	98	0	\N
215629	2132	7124138000	29105	14302	99	0	\N
215630	2132	7123137000	29105	14302	100	0	\N
215631	2132	7122136000	29105	14302	101	0	\N
215632	2132	7121135000	29105	14302	102	0	\N
215633	2132	7120134000	29105	14302	103	0	\N
215634	2132	7119133000	29105	14302	104	0	\N
215635	2132	7118132000	29105	14302	105	0	\N
215636	2132	7117131000	29105	14302	106	0	\N
215637	2134	12573579000	29105	14302	107	0	\N
215638	2134	12572575000	29105	14302	108	0	\N
215639	2134	12571571000	29105	14302	109	0	\N
215640	2134	12570567000	29105	14302	110	0	\N
215641	2134	12569563000	29105	14302	111	0	\N
215642	2134	12568559000	29105	14302	112	0	\N
215643	2134	12567555000	29105	14302	113	0	\N
215644	2134	12566551000	29105	14302	114	0	\N
215645	2134	12565547000	29105	14302	115	0	\N
215646	2134	12564543000	29105	14302	116	0	\N
215647	2134	12563539000	29105	14302	117	0	\N
215648	2134	12562535000	29105	14302	118	0	\N
215649	2134	12561531000	29105	14302	119	0	\N
215650	2134	12560527000	29105	14302	120	0	\N
215651	2134	12559523000	29105	14302	121	0	\N
215652	2134	12558519000	29105	14302	122	0	\N
215653	2134	12557515000	29105	14302	123	0	\N
215654	2134	12556511000	29105	14302	124	0	\N
215655	2134	12555507000	29105	14302	125	0	\N
215663	1397	1262482383000	29108	14349	0	0	\N
215664	2133	9251654000	29108	14349	1	0	\N
215665	2134	12545467000	29108	14349	2	0	\N
215675	1397	1262452380000	29111	14351	0	0	\N
215676	2134	12543459000	29111	14351	1	0	\N
215677	2133	9248648000	29111	14351	2	0	\N
215678	2132	7115129000	29111	14351	3	0	\N
215688	1397	1262412376000	29114	14354	0	0	\N
215689	1397	1262402375000	29114	14354	1	0	\N
215690	1397	1262392374000	29114	14354	2	0	\N
215691	2134	12540447000	29114	14354	3	0	\N
215692	2133	9244640000	29114	14354	4	0	\N
215693	2133	9243638000	29114	14354	5	0	\N
215694	2133	9242636000	29114	14354	6	0	\N
215695	2134	12539443000	29114	14354	7	0	\N
215658	2132	7116130000	29106	14348	2	0	1872
215659	2134	12546471000	29106	14348	3	0	7771
215660	1397	1262482383000	29107	14349	0	0	17634
215661	2133	9251654000	29107	14349	1	0	7176
215662	2134	12545467000	29107	14349	2	0	7772
215667	1397	1262462381000	29109	14350	1	0	17636
215668	2134	12544463000	29109	14350	2	0	7773
215669	2133	9250652000	29109	14350	3	0	7177
215670	2133	9249650000	29109	14350	4	0	7178
215671	1397	1262452380000	29110	14351	0	0	17637
215673	2133	9248648000	29110	14351	2	0	7179
215674	2132	7115129000	29110	14351	3	0	1873
215679	1397	1262442379000	29112	14352	0	0	17638
215680	2133	9247646000	29112	14352	1	0	7180
215682	1397	1262432378000	29113	14353	0	0	17639
215683	1397	1262422377000	29113	14353	1	0	17640
215684	2132	7114128000	29113	14353	2	0	1874
215685	2133	9246644000	29113	14353	3	0	7181
215686	2133	9245642000	29113	14353	4	0	7182
215696	1397	1262412376000	29115	14354	0	0	17641
215704	1397	1262412376000	29116	14354	0	0	\N
215705	1397	1262402375000	29116	14354	1	0	\N
215706	1397	1262392374000	29116	14354	2	0	\N
215707	2134	12540447000	29116	14354	3	0	\N
215708	2133	9244640000	29116	14354	4	0	\N
215709	2133	9243638000	29116	14354	5	0	\N
215710	2133	9242636000	29116	14354	6	0	\N
215711	2134	12539443000	29116	14354	7	0	\N
215712	1397	1262412376000	29117	14354	0	0	\N
215713	1397	1262402375000	29117	14354	1	0	\N
215714	1397	1262392374000	29117	14354	2	0	\N
215715	2134	12540447000	29117	14354	3	0	\N
215716	2133	9244640000	29117	14354	4	0	\N
215717	2133	9243638000	29117	14354	5	0	\N
215718	2133	9242636000	29117	14354	6	0	\N
215719	2134	12539443000	29117	14354	7	0	\N
215720	296	66001900000000	29118	14294	0	0	\N
215721	2414	90000000	29118	14294	1	0	\N
215722	835	3199985394837430	29118	14294	2	0	\N
215723	1397	1263192454000	29118	14294	3	0	\N
215724	1397	1263182453000	29118	14294	4	0	\N
215725	693	66000000000000	29118	14294	5	0	\N
215726	1397	1263172452000	29118	14294	6	0	\N
215727	1397	1263162451000	29118	14294	7	0	\N
215728	1397	1263152450000	29118	14294	8	0	\N
215729	1397	1263142449000	29118	14294	9	0	\N
215730	1397	1263132448000	29118	14294	10	0	\N
215731	1397	1263122447000	29118	14294	11	0	\N
215732	1397	1263112446000	29118	14294	12	0	\N
215733	1397	1263102445000	29118	14294	13	0	\N
215734	1397	1263092444000	29118	14294	14	0	\N
215735	1397	1263082443000	29118	14294	15	0	\N
215736	1397	1263072442000	29118	14294	16	0	\N
215737	1397	1263062441000	29118	14294	17	0	\N
215738	1397	1263052440000	29118	14294	18	0	\N
215739	1397	1263042439000	29118	14294	19	0	\N
215740	1397	1263032438000	29118	14294	20	0	\N
215741	1397	1263022437000	29118	14294	21	0	\N
215742	1397	1263012436000	29118	14294	22	0	\N
215743	1397	1263002435000	29118	14294	23	0	\N
215744	1397	1262992434000	29118	14294	24	0	\N
215745	1397	1262982433000	29118	14294	25	0	\N
215746	1397	1262972432000	29118	14294	26	0	\N
215747	1397	1262962431000	29118	14294	27	0	\N
215748	1397	1262952430000	29118	14294	28	0	\N
215749	1397	1262942429000	29118	14294	29	0	\N
215750	1397	1262932428000	29118	14294	30	0	\N
215751	1397	1262922427000	29118	14294	31	0	\N
215752	1397	1262912426000	29118	14294	32	0	\N
215753	1397	1262902425000	29118	14294	33	0	\N
215754	1397	1262892424000	29118	14294	34	0	\N
215755	1397	1262882423000	29118	14294	35	0	\N
215756	1397	1262872422000	29118	14294	36	0	\N
215757	1397	1262862421000	29118	14294	37	0	\N
215758	1397	1262852420000	29118	14294	38	0	\N
215759	1397	1262842419000	29118	14294	39	0	\N
215760	1397	1262832418000	29118	14294	40	0	\N
215761	1397	1262822417000	29118	14294	41	0	\N
215762	1397	1262812416000	29118	14294	42	0	\N
215763	1397	1262802415000	29118	14294	43	0	\N
215764	1397	1262792414000	29118	14294	44	0	\N
215765	1397	1262782413000	29118	14294	45	0	\N
215766	1397	1262772412000	29118	14294	46	0	\N
215767	1397	1262762411000	29118	14294	47	0	\N
215768	1397	1262752410000	29118	14294	48	0	\N
215769	1397	1262742409000	29118	14294	49	0	\N
215770	1397	1262732408000	29118	14294	50	0	\N
215771	1397	1262722407000	29118	14294	51	0	\N
215772	1397	1262712406000	29118	14294	52	0	\N
215773	1397	1262702405000	29118	14294	53	0	\N
215774	1397	1262692404000	29118	14294	54	0	\N
215775	1397	1262682403000	29118	14294	55	0	\N
215776	1397	1262672402000	29118	14294	56	0	\N
215777	1397	1262662401000	29118	14294	57	0	\N
215778	1397	1262652400000	29118	14294	58	0	\N
215779	1397	1262642399000	29118	14294	59	0	\N
215780	1397	1262632398000	29118	14294	60	0	\N
215781	1397	1262622397000	29118	14294	61	0	\N
215782	1397	1262612396000	29118	14294	62	0	\N
215783	1397	1262602395000	29118	14294	63	0	\N
215784	1397	1262592394000	29118	14294	64	0	\N
215785	1397	1262582393000	29118	14294	65	0	\N
215786	1397	1262572392000	29118	14294	66	0	\N
215787	1397	1262562391000	29118	14294	67	0	\N
215788	1397	1262552390000	29118	14294	68	0	\N
215789	1397	1262542389000	29118	14294	69	0	\N
215790	1397	1262532388000	29118	14294	70	0	\N
215791	1397	1262522387000	29118	14294	71	0	\N
215792	1397	1262512386000	29118	14294	72	0	\N
215793	1397	1262502385000	29118	14294	73	0	\N
215794	1397	1262492384000	29118	14294	74	0	\N
215795	1397	1262482383000	29118	14294	75	0	\N
215796	1397	1262472382000	29118	14294	76	0	\N
215797	1397	1262462381000	29118	14294	77	0	\N
215798	1397	1262452380000	29118	14294	78	0	\N
215799	1397	1262442379000	29118	14294	79	0	\N
215800	1397	1262432378000	29118	14294	80	0	\N
215801	1397	1262422377000	29118	14294	81	0	\N
215802	1397	1262412376000	29118	14294	82	0	\N
215803	1397	1262402375000	29118	14294	83	0	\N
215804	1397	1262392374000	29118	14294	84	0	\N
215805	2133	9321794000	29118	14294	85	0	\N
215806	2133	9320792000	29118	14294	86	0	\N
215807	2133	9319790000	29118	14294	87	0	\N
215808	2132	7137151000	29118	14294	88	0	\N
215809	2132	7136150000	29118	14294	89	0	\N
215810	2132	7135149000	29118	14294	90	0	\N
215811	2133	9318788000	29118	14294	91	0	\N
215812	2133	9317786000	29118	14294	92	0	\N
215813	2133	9316784000	29118	14294	93	0	\N
215814	2134	12596671000	29118	14294	94	0	\N
215815	2134	12595667000	29118	14294	95	0	\N
215816	2133	9315782000	29118	14294	96	0	\N
215817	2134	12594663000	29118	14294	97	0	\N
215818	2134	12593659000	29118	14294	98	0	\N
215819	2132	7134148000	29118	14294	99	0	\N
215820	2132	7133147000	29118	14294	100	0	\N
215821	2132	7132146000	29118	14294	101	0	\N
215822	2132	7131145000	29118	14294	102	0	\N
215823	2132	7130144000	29118	14294	103	0	\N
215824	2132	7129143000	29118	14294	104	0	\N
215825	2132	7128142000	29118	14294	105	0	\N
215826	2132	7127141000	29118	14294	106	0	\N
215827	2132	7126140000	29118	14294	107	0	\N
215828	2132	7125139000	29118	14294	108	0	\N
215829	2132	7124138000	29118	14294	109	0	\N
215830	2132	7123137000	29118	14294	110	0	\N
215831	2132	7122136000	29118	14294	111	0	\N
215832	2132	7121135000	29118	14294	112	0	\N
215699	2134	12540447000	29115	14354	3	0	7777
215700	2133	9244640000	29115	14354	4	0	7183
215701	2133	9243638000	29115	14354	5	0	7184
215702	2133	9242636000	29115	14354	6	0	7185
215703	2134	12539443000	29115	14354	7	0	7778
215833	2132	7120134000	29118	14294	113	0	\N
215834	2132	7119133000	29118	14294	114	0	\N
215835	2132	7118132000	29118	14294	115	0	\N
215836	2134	12592655000	29118	14294	117	0	\N
215837	2134	12591651000	29118	14294	118	0	\N
215838	2134	12590647000	29118	14294	119	0	\N
215839	2134	12589643000	29118	14294	120	0	\N
215840	2134	12588639000	29118	14294	121	0	\N
215841	2134	12587635000	29118	14294	122	0	\N
215842	2134	12586631000	29118	14294	123	0	\N
215843	2134	12585627000	29118	14294	124	0	\N
215844	2134	12584623000	29118	14294	125	0	\N
215854	1397	1262352370000	29121	14357	0	0	\N
215855	2132	7112126000	29121	14357	1	0	\N
215856	2134	12536431000	29121	14357	2	0	\N
215857	2133	9238628000	29121	14357	3	0	\N
215858	1397	1262352370000	29122	14357	0	0	\N
215859	2132	7112126000	29122	14357	1	0	\N
215860	2134	12536431000	29122	14357	2	0	\N
215861	2133	9238628000	29122	14357	3	0	\N
215875	2381	950000000	29126	14235	0	0	\N
215876	835	3199985394837430	29126	14235	1	0	\N
215877	656	66544500726895	29126	14235	2	0	\N
215878	693	66000000000000	29126	14235	3	0	\N
215879	656	66543490726895	29126	14235	4	0	\N
215880	656	66543450726895	29126	14235	5	0	\N
215881	656	66000440726895	29126	14235	6	0	\N
215882	1963	731505120000	29126	14235	7	0	\N
215883	1013	2000000000	29126	14235	8	0	\N
215884	2132	7159173000	29126	14235	9	0	\N
215885	1726	125229112000	29126	14235	10	0	\N
215886	1726	124128112000	29126	14235	11	0	\N
215887	1726	123027112000	29126	14235	12	0	\N
215888	2132	7158172000	29126	14235	13	0	\N
215889	2132	7157171000	29126	14235	14	0	\N
215890	2132	7156170000	29126	14235	15	0	\N
215891	2132	7155169000	29126	14235	16	0	\N
215892	2132	7154168000	29126	14235	17	0	\N
215893	2132	7153167000	29126	14235	18	0	\N
215894	2132	7152166000	29126	14235	19	0	\N
215895	2132	7151165000	29126	14235	20	0	\N
215896	2132	7150164000	29126	14235	21	0	\N
215897	2132	7149163000	29126	14235	22	0	\N
215898	2132	7148162000	29126	14235	23	0	\N
215899	2132	7147161000	29126	14235	24	0	\N
215900	1133	1000000000	29126	14235	25	0	\N
215901	1726	121926112000	29126	14235	26	0	\N
215902	2132	7146160000	29126	14235	27	0	\N
215903	2132	7145159000	29126	14235	28	0	\N
215904	2132	7144158000	29126	14235	29	0	\N
215905	2132	7143157000	29126	14235	30	0	\N
215906	2132	7142156000	29126	14235	31	0	\N
215907	2132	7141155000	29126	14235	32	0	\N
215908	2132	7140154000	29126	14235	33	0	\N
215909	2132	7139153000	29126	14235	34	0	\N
215910	2132	7138152000	29126	14235	35	0	\N
215911	2132	7137151000	29126	14235	36	0	\N
215912	2132	7136150000	29126	14235	37	0	\N
215913	2132	7135149000	29126	14235	38	0	\N
215914	2132	7134148000	29126	14235	39	0	\N
215915	2132	7133147000	29126	14235	40	0	\N
215916	2132	7132146000	29126	14235	41	0	\N
215917	2132	7131145000	29126	14235	42	0	\N
215918	2132	7130144000	29126	14235	43	0	\N
215919	2132	7129143000	29126	14235	44	0	\N
215920	2132	7128142000	29126	14235	45	0	\N
215921	2132	7127141000	29126	14235	46	0	\N
215922	2132	7126140000	29126	14235	47	0	\N
215923	2132	7125139000	29126	14235	48	0	\N
215924	2132	7124138000	29126	14235	49	0	\N
215925	2132	7123137000	29126	14235	50	0	\N
215926	2132	7122136000	29126	14235	51	0	\N
215927	2132	7121135000	29126	14235	52	0	\N
215928	2132	7120134000	29126	14235	53	0	\N
215929	2132	7119133000	29126	14235	54	0	\N
215930	2132	7118132000	29126	14235	55	0	\N
215931	2132	7117131000	29126	14235	56	0	\N
215932	2132	7116130000	29126	14235	57	0	\N
215933	2132	7115129000	29126	14235	58	0	\N
215934	2132	7114128000	29126	14235	59	0	\N
215935	2132	7113127000	29126	14235	60	0	\N
215936	2132	7112126000	29126	14235	61	0	\N
215937	2132	7111125000	29126	14235	62	0	\N
215950	2381	950000000	29128	14246	0	0	\N
215951	2414	90000000	29128	14246	1	0	\N
215952	835	3199985394837430	29128	14246	2	0	\N
215953	1397	1263612496000	29128	14246	3	0	\N
215954	1397	1263602495000	29128	14246	4	0	\N
215955	693	66000000000000	29128	14246	5	0	\N
215956	1397	1263592494000	29128	14246	6	0	\N
215957	1397	1263582493000	29128	14246	7	0	\N
215958	1397	1263572492000	29128	14246	8	0	\N
215959	1397	1263562491000	29128	14246	9	0	\N
215960	1397	1263552490000	29128	14246	10	0	\N
215961	1397	1263542489000	29128	14246	11	0	\N
215962	1397	1263532488000	29128	14246	12	0	\N
215963	1397	1263522487000	29128	14246	13	0	\N
215964	1397	1263512486000	29128	14246	14	0	\N
215965	1397	1263502485000	29128	14246	15	0	\N
215966	1397	1263492484000	29128	14246	16	0	\N
215967	1397	1263482483000	29128	14246	17	0	\N
215968	1397	1263472482000	29128	14246	18	0	\N
215847	2133	9241634000	29119	14355	3	0	7186
215848	2132	7113127000	29119	14355	4	0	1875
215849	1397	1262372372000	29120	14356	0	0	17645
215850	1397	1262362371000	29120	14356	1	0	17646
215851	2133	9240632000	29120	14356	2	0	7187
215853	2134	12537435000	29120	14356	4	0	7780
215862	1397	1262352370000	29123	14357	0	0	17647
215863	2132	7112126000	29123	14357	1	0	1876
215864	2134	12536431000	29123	14357	2	0	7781
215865	2133	9238628000	29123	14357	3	0	7189
215867	2133	9237626000	29124	14358	1	0	7190
215868	2134	12535427000	29124	14358	2	0	7782
215869	1397	1262332368000	29125	14359	0	0	17649
215870	1397	1262322367000	29125	14359	1	0	17650
215872	2132	7111125000	29125	14359	3	0	1877
215873	2133	9236624000	29125	14359	4	0	7191
215874	2133	9235622000	29125	14359	5	0	7192
215938	1397	1262312366000	29127	14360	0	0	17651
215939	1397	1262302365000	29127	14360	1	0	17652
215941	1397	1262282363000	29127	14360	3	0	17654
215942	2133	9234620000	29127	14360	4	0	7193
215943	2133	9233618000	29127	14360	5	0	7194
215944	2133	9232616000	29127	14360	6	0	7195
215945	2132	7110124000	29127	14360	7	0	1878
215947	2134	12533419000	29127	14360	9	0	7784
215948	2134	12532415000	29127	14360	10	0	7785
215949	2134	12531411000	29127	14360	11	0	7786
215969	1397	1263462481000	29128	14246	19	0	\N
215970	1397	1263452480000	29128	14246	20	0	\N
215971	1397	1263442479000	29128	14246	21	0	\N
215972	1397	1263432478000	29128	14246	22	0	\N
215973	1397	1263422477000	29128	14246	23	0	\N
215974	1397	1263412476000	29128	14246	24	0	\N
215975	1397	1263402475000	29128	14246	25	0	\N
215976	1397	1263392474000	29128	14246	26	0	\N
215977	1397	1263382473000	29128	14246	27	0	\N
215978	1397	1263372472000	29128	14246	28	0	\N
215979	1397	1263362471000	29128	14246	29	0	\N
215980	1397	1263352470000	29128	14246	30	0	\N
215981	1397	1263342469000	29128	14246	31	0	\N
215982	1397	1263332468000	29128	14246	32	0	\N
215983	1397	1263322467000	29128	14246	33	0	\N
215984	1397	1263312466000	29128	14246	34	0	\N
215985	1397	1263302465000	29128	14246	35	0	\N
215986	1397	1263292464000	29128	14246	36	0	\N
215987	1397	1263282463000	29128	14246	37	0	\N
215988	1397	1263272462000	29128	14246	38	0	\N
215989	1397	1263262461000	29128	14246	39	0	\N
215990	1397	1263252460000	29128	14246	40	0	\N
215991	1397	1263242459000	29128	14246	41	0	\N
215992	1397	1263232458000	29128	14246	42	0	\N
215993	1397	1263222457000	29128	14246	43	0	\N
215994	1397	1263212456000	29128	14246	44	0	\N
215995	1397	1263202455000	29128	14246	45	0	\N
215996	1397	1263192454000	29128	14246	46	0	\N
215997	1397	1263182453000	29128	14246	47	0	\N
215998	1397	1263172452000	29128	14246	48	0	\N
215999	1397	1263162451000	29128	14246	49	0	\N
216000	1397	1263152450000	29128	14246	50	0	\N
216001	1397	1263142449000	29128	14246	51	0	\N
216002	1397	1263132448000	29128	14246	52	0	\N
216003	1397	1263122447000	29128	14246	53	0	\N
216004	1397	1263112446000	29128	14246	54	0	\N
216005	1397	1263102445000	29128	14246	55	0	\N
216006	1397	1263092444000	29128	14246	56	0	\N
216007	1397	1263082443000	29128	14246	57	0	\N
216008	1397	1263072442000	29128	14246	58	0	\N
216009	1397	1263062441000	29128	14246	59	0	\N
216010	1397	1263052440000	29128	14246	60	0	\N
216011	1397	1263042439000	29128	14246	61	0	\N
216012	1397	1263032438000	29128	14246	62	0	\N
216013	1397	1263022437000	29128	14246	63	0	\N
216014	1397	1263012436000	29128	14246	64	0	\N
216015	1397	1263002435000	29128	14246	65	0	\N
216016	1397	1262992434000	29128	14246	66	0	\N
216017	1397	1262982433000	29128	14246	67	0	\N
216018	1397	1262972432000	29128	14246	68	0	\N
216019	1397	1262962431000	29128	14246	69	0	\N
216020	1397	1262952430000	29128	14246	70	0	\N
216021	1397	1262942429000	29128	14246	71	0	\N
216022	1397	1262932428000	29128	14246	72	0	\N
216023	1397	1262922427000	29128	14246	73	0	\N
216024	1397	1262912426000	29128	14246	74	0	\N
216025	1397	1262902425000	29128	14246	75	0	\N
216026	1397	1262892424000	29128	14246	76	0	\N
216027	1397	1262882423000	29128	14246	77	0	\N
216028	1397	1262872422000	29128	14246	78	0	\N
216029	1397	1262862421000	29128	14246	79	0	\N
216030	1397	1262852420000	29128	14246	80	0	\N
216031	1397	1262842419000	29128	14246	81	0	\N
216032	1397	1262832418000	29128	14246	82	0	\N
216033	1397	1262822417000	29128	14246	83	0	\N
216034	1397	1262812416000	29128	14246	84	0	\N
216035	1397	1262802415000	29128	14246	85	0	\N
216036	1397	1262792414000	29128	14246	86	0	\N
216037	1397	1262782413000	29128	14246	87	0	\N
216038	1397	1262772412000	29128	14246	88	0	\N
216039	1397	1262762411000	29128	14246	89	0	\N
216040	1397	1262752410000	29128	14246	90	0	\N
216041	1397	1262742409000	29128	14246	91	0	\N
216042	1397	1262732408000	29128	14246	92	0	\N
216043	1397	1262722407000	29128	14246	93	0	\N
216044	1397	1262712406000	29128	14246	94	0	\N
216045	1397	1262702405000	29128	14246	95	0	\N
216046	1397	1262692404000	29128	14246	96	0	\N
216047	1397	1262682403000	29128	14246	97	0	\N
216048	1397	1262672402000	29128	14246	98	0	\N
216049	1397	1262662401000	29128	14246	99	0	\N
216050	1397	1262652400000	29128	14246	100	0	\N
216051	1397	1262642399000	29128	14246	101	0	\N
216052	1397	1262632398000	29128	14246	102	0	\N
216053	1397	1262622397000	29128	14246	104	0	\N
216054	1397	1262612396000	29128	14246	105	0	\N
216055	1397	1262602395000	29128	14246	106	0	\N
216056	1397	1262592394000	29128	14246	107	0	\N
216057	1397	1262582393000	29128	14246	108	0	\N
216058	1397	1262572392000	29128	14246	109	0	\N
216059	1397	1262562391000	29128	14246	110	0	\N
216060	1397	1262552390000	29128	14246	111	0	\N
216061	1397	1262542389000	29128	14246	112	0	\N
216062	1397	1262532388000	29128	14246	113	0	\N
216063	1397	1262522387000	29128	14246	114	0	\N
216064	1397	1262512386000	29128	14246	115	0	\N
216065	1397	1262502385000	29128	14246	116	0	\N
216066	1397	1262492384000	29128	14246	117	0	\N
216067	1397	1262482383000	29128	14246	118	0	\N
216068	1397	1262472382000	29128	14246	119	0	\N
216069	1397	1262462381000	29128	14246	120	0	\N
216070	1397	1262452380000	29128	14246	121	0	\N
216071	1397	1262442379000	29128	14246	122	0	\N
216072	1397	1262432378000	29128	14246	123	0	\N
216073	1397	1262422377000	29128	14246	124	0	\N
216074	1397	1262412376000	29128	14246	125	0	\N
216087	1397	1262252360000	29131	14362	0	0	\N
216088	1397	1262242359000	29131	14362	1	0	\N
216089	2134	12530407000	29131	14362	2	0	\N
216090	2134	12529403000	29131	14362	3	0	\N
216091	2134	12528399000	29131	14362	4	0	\N
216092	2132	7109123000	29131	14362	5	0	\N
216093	2133	9228608000	29131	14362	6	0	\N
216094	2133	9227606000	29131	14362	7	0	\N
216077	2133	9230612000	29129	14361	2	0	7197
216078	2133	9229610000	29129	14361	3	0	7198
216079	1397	1262252360000	29130	14362	0	0	17657
216080	1397	1262242359000	29130	14362	1	0	17658
216081	2134	12530407000	29130	14362	2	0	7787
216083	2134	12528399000	29130	14362	4	0	7789
216084	2132	7109123000	29130	14362	5	0	1879
216085	2133	9228608000	29130	14362	6	0	7199
216086	2133	9227606000	29130	14362	7	0	7200
216095	1397	1262232358000	29132	14363	0	0	17659
216097	1397	1262212356000	29132	14363	2	0	17661
216098	2133	9226604000	29132	14363	3	0	7201
216099	2132	7108122000	29132	14363	4	0	1880
216100	2133	9225602000	29132	14363	5	0	7202
216102	2134	12527395000	29132	14363	7	0	7790
216103	2134	12526391000	29132	14363	8	0	7791
216104	2134	12525387000	29132	14363	9	0	7792
216105	1397	1262202355000	29133	14364	0	0	\N
216106	2133	9223598000	29133	14364	1	0	\N
216118	1397	1262162351000	29137	14367	0	0	\N
216119	1397	1262152350000	29137	14367	1	0	\N
216120	2133	9219590000	29137	14367	2	0	\N
216121	2132	7106120000	29137	14367	3	0	\N
216122	2134	12522375000	29137	14367	4	0	\N
216123	2134	12521371000	29137	14367	5	0	\N
216130	1397	1262142349000	29139	14368	0	0	\N
216131	2133	9218588000	29139	14368	1	0	\N
216132	2134	12520367000	29139	14368	2	0	\N
216136	1397	1262142349000	29141	14368	0	0	\N
216137	2133	9218588000	29141	14368	1	0	\N
216138	2134	12520367000	29141	14368	2	0	\N
216148	1397	1262132348000	29143	14369	0	0	\N
216149	1397	1262122347000	29143	14369	1	0	\N
216150	1397	1262112346000	29143	14369	2	0	\N
216151	2133	9217586000	29143	14369	3	0	\N
216152	2133	9216584000	29143	14369	4	0	\N
216153	2132	7105119000	29143	14369	5	0	\N
216154	2134	12519363000	29143	14369	6	0	\N
216155	2134	12518359000	29143	14369	7	0	\N
216156	2133	9215582000	29143	14369	8	0	\N
216162	1397	1262092344000	29146	14371	0	0	\N
216163	2133	9213578000	29146	14371	1	0	\N
216164	1397	1262082343000	29147	14372	0	0	\N
216165	2132	7104118000	29147	14372	1	0	\N
216166	2134	12516351000	29147	14372	2	0	\N
216167	2133	9212576000	29147	14372	3	0	\N
216186	1397	1262022337000	29152	14376	0	0	\N
216187	2134	12511331000	29152	14376	1	0	\N
216188	2133	9206564000	29152	14376	2	0	\N
216191	1397	1262022337000	29154	14376	0	0	\N
216192	2134	12511331000	29154	14376	1	0	\N
216193	2133	9206564000	29154	14376	2	0	\N
216203	1397	1262012336000	29156	14377	0	0	\N
216204	1397	1262002335000	29156	14377	1	0	\N
216205	1397	1261992334000	29156	14377	2	0	\N
216206	2134	12510327000	29156	14377	3	0	\N
216207	2133	9206564000	29156	14377	4	0	\N
216208	2133	9205562000	29156	14377	5	0	\N
216209	2134	12509323000	29156	14377	6	0	\N
216210	2133	9204560000	29156	14377	7	0	\N
216211	2133	9203558000	29156	14377	8	0	\N
216214	1397	1261982333000	29158	14378	0	0	\N
216215	2133	9202556000	29158	14378	1	0	\N
216216	2381	950000000	29159	14093	0	0	\N
216217	421	66843681394804	29159	14093	1	0	\N
216218	2393	2157990000000	29159	14093	2	0	\N
216219	835	3199985394837430	29159	14093	3	0	\N
216220	656	66544500726895	29159	14093	4	0	\N
216221	693	66000000000000	29159	14093	5	0	\N
216222	656	66543490726895	29159	14093	6	0	\N
216223	656	66543450726895	29159	14093	7	0	\N
216224	656	66000440726895	29159	14093	8	0	\N
216225	1963	731505120000	29159	14093	9	0	\N
216226	1013	2000000000	29159	14093	10	0	\N
216227	2132	7193207000	29159	14093	11	0	\N
216228	2132	7192206000	29159	14093	12	0	\N
216229	2132	7191205000	29159	14093	13	0	\N
216230	2132	7190204000	29159	14093	14	0	\N
216231	1379	2000001650	29159	14093	15	0	\N
216232	2132	7189203000	29159	14093	16	0	\N
216233	2132	7188202000	29159	14093	17	0	\N
216234	2132	7187201000	29159	14093	18	0	\N
216235	1133	1000000000	29159	14093	19	0	\N
216236	2132	7186200000	29159	14093	20	0	\N
216237	2132	7185199000	29159	14093	21	0	\N
216238	2132	7184198000	29159	14093	22	0	\N
216239	2132	7183197000	29159	14093	23	0	\N
216240	2132	7182196000	29159	14093	24	0	\N
216109	1397	1262192354000	29135	14365	0	0	17663
216110	1397	1262182353000	29135	14365	1	0	17664
216111	2132	7107121000	29135	14365	2	0	1881
216112	2133	9222596000	29135	14365	3	0	7205
216113	2133	9221594000	29135	14365	4	0	7206
216115	2134	12523379000	29135	14365	6	0	7794
216116	1397	1262172352000	29136	14366	0	0	17665
216117	2133	9220592000	29136	14366	1	0	7207
216124	1397	1262162351000	29138	14367	0	0	17666
216125	1397	1262152350000	29138	14367	1	0	17667
216127	2132	7106120000	29138	14367	3	0	1882
216128	2134	12522375000	29138	14367	4	0	7795
216129	2134	12521371000	29138	14367	5	0	7796
216133	1397	1262142349000	29140	14368	0	0	17668
216135	2134	12520367000	29140	14368	2	0	7797
216139	1397	1262132348000	29142	14369	0	0	17669
216140	1397	1262122347000	29142	14369	1	0	17670
216141	1397	1262112346000	29142	14369	2	0	17671
216142	2133	9217586000	29142	14369	3	0	7210
216144	2132	7105119000	29142	14369	5	0	1883
216145	2134	12519363000	29142	14369	6	0	7798
216146	2134	12518359000	29142	14369	7	0	7799
216147	2133	9215582000	29142	14369	8	0	7212
216157	1397	1262102345000	29144	14370	0	0	17672
216159	2134	12517355000	29144	14370	2	0	7800
216160	1397	1262092344000	29145	14371	0	0	17673
216161	2133	9213578000	29145	14371	1	0	7214
216168	1397	1262082343000	29148	14372	0	0	17674
216170	2134	12516351000	29148	14372	2	0	7801
216171	2133	9212576000	29148	14372	3	0	7215
216172	1397	1262072342000	29149	14373	0	0	17675
216173	1397	1262062341000	29149	14373	1	0	17676
216174	2134	12515347000	29149	14373	2	0	7802
216176	2133	9211574000	29149	14373	4	0	7216
216177	2133	9210572000	29149	14373	5	0	7217
216178	1397	1262052340000	29150	14374	0	0	17677
216179	1397	1262042339000	29150	14374	1	0	17678
216180	2133	9209570000	29150	14374	2	0	7218
216182	2134	12513339000	29150	14374	4	0	7804
216183	1397	1262032338000	29151	14375	0	0	17679
216184	2133	9207566000	29151	14375	1	0	7220
216185	2134	12512335000	29151	14375	2	0	7805
216190	2134	12511331000	29153	14376	1	0	7806
216194	1397	1262012336000	29155	14377	0	0	17681
216195	1397	1262002335000	29155	14377	1	0	17682
216196	1397	1261992334000	29155	14377	2	0	17683
216197	2134	12510327000	29155	14377	3	0	7807
216199	2133	9205562000	29155	14377	5	0	7222
216200	2134	12509323000	29155	14377	6	0	7808
216201	2133	9204560000	29155	14377	7	0	7223
216202	2133	9203558000	29155	14377	8	0	7224
216212	1397	1261982333000	29157	14378	0	0	17684
216241	2132	7181195000	29159	14093	25	0	\N
216242	2132	7180194000	29159	14093	26	0	\N
216243	2132	7179193000	29159	14093	27	0	\N
216244	2132	7178192000	29159	14093	28	0	\N
216245	2132	7177191000	29159	14093	29	0	\N
216246	2132	7176190000	29159	14093	30	0	\N
216247	2132	7175189000	29159	14093	31	0	\N
216248	2132	7174188000	29159	14093	33	0	\N
216249	2132	7173187000	29159	14093	34	0	\N
216250	2132	7172186000	29159	14093	35	0	\N
216251	2132	7171185000	29159	14093	36	0	\N
216252	2132	7170184000	29159	14093	37	0	\N
216253	2132	7169183000	29159	14093	38	0	\N
216254	2132	7168182000	29159	14093	39	0	\N
216255	2132	7167181000	29159	14093	40	0	\N
216256	2132	7166180000	29159	14093	41	0	\N
216257	2132	7165179000	29159	14093	42	0	\N
216258	2132	7164178000	29159	14093	43	0	\N
216259	2132	7163177000	29159	14093	44	0	\N
216260	2132	7162176000	29159	14093	45	0	\N
216261	1397	1261982333000	29160	14378	0	0	\N
216262	2133	9202556000	29160	14378	1	0	\N
216265	1397	1262402375000	29162	14247	0	0	\N
216266	1397	1262392374000	29162	14247	1	0	\N
216267	1397	1262382373000	29162	14247	2	0	\N
216268	1397	1262372372000	29162	14247	3	0	\N
216269	1397	1262362371000	29162	14247	4	0	\N
216270	1397	1262352370000	29162	14247	5	0	\N
216271	1397	1262342369000	29162	14247	6	0	\N
216272	1397	1262332368000	29162	14247	7	0	\N
216273	1397	1262322367000	29162	14247	8	0	\N
216274	1397	1262312366000	29162	14247	9	0	\N
216275	1397	1262302365000	29162	14247	10	0	\N
216276	1397	1262292364000	29162	14247	11	0	\N
216277	1397	1262282363000	29162	14247	12	0	\N
216278	1397	1262272362000	29162	14247	13	0	\N
216279	1397	1262262361000	29162	14247	14	0	\N
216280	1397	1262252360000	29162	14247	15	0	\N
216281	1397	1262242359000	29162	14247	16	0	\N
216282	1397	1262232358000	29162	14247	17	0	\N
216283	1397	1262222357000	29162	14247	18	0	\N
216284	1397	1262212356000	29162	14247	19	0	\N
216285	1397	1262202355000	29162	14247	20	0	\N
216286	1397	1262192354000	29162	14247	21	0	\N
216287	1397	1262182353000	29162	14247	22	0	\N
216288	1397	1262172352000	29162	14247	23	0	\N
216289	1397	1262162351000	29162	14247	24	0	\N
216290	1397	1262152350000	29162	14247	25	0	\N
216291	1397	1262142349000	29162	14247	26	0	\N
216292	1397	1262132348000	29162	14247	27	0	\N
216293	1397	1262122347000	29162	14247	28	0	\N
216294	1397	1262112346000	29162	14247	29	0	\N
216295	1397	1262102345000	29162	14247	30	0	\N
216296	1397	1262092344000	29162	14247	31	0	\N
216297	1397	1262082343000	29162	14247	32	0	\N
216298	1397	1262072342000	29162	14247	33	0	\N
216299	1397	1262062341000	29162	14247	34	0	\N
216300	1397	1262052340000	29162	14247	35	0	\N
216301	1397	1262042339000	29162	14247	36	0	\N
216302	1397	1262032338000	29162	14247	37	0	\N
216303	1397	1262022337000	29162	14247	38	0	\N
216304	1397	1262012336000	29162	14247	39	0	\N
216305	1397	1262002335000	29162	14247	40	0	\N
216306	1397	1261992334000	29162	14247	41	0	\N
216307	1397	1261982333000	29162	14247	42	0	\N
216308	1963	731505120000	29162	14247	43	0	\N
216309	2134	12632815000	29162	14247	44	0	\N
216310	2133	9369890000	29162	14247	45	0	\N
216311	2133	9368888000	29162	14247	46	0	\N
216312	2133	9367886000	29162	14247	47	0	\N
216313	2133	9366884000	29162	14247	48	0	\N
216314	2133	9365882000	29162	14247	49	0	\N
216315	2133	9364880000	29162	14247	50	0	\N
216316	2132	7151165000	29162	14247	51	0	\N
216317	2132	7150164000	29162	14247	52	0	\N
216318	2132	7149163000	29162	14247	53	0	\N
216319	2134	12631811000	29162	14247	54	0	\N
216320	1726	124128112000	29162	14247	55	0	\N
216321	1726	123027112000	29162	14247	56	0	\N
216322	2133	9363878000	29162	14247	57	0	\N
216323	2133	9362876000	29162	14247	58	0	\N
216324	2133	9361874000	29162	14247	59	0	\N
216325	2133	9360872000	29162	14247	60	0	\N
216326	2134	12630807000	29162	14247	61	0	\N
216327	2134	12629803000	29162	14247	62	0	\N
216328	2134	12628799000	29162	14247	63	0	\N
216329	2134	12627795000	29162	14247	64	0	\N
216330	2134	12626791000	29162	14247	65	0	\N
216331	2134	12625787000	29162	14247	66	0	\N
216332	2134	12624783000	29162	14247	67	0	\N
216333	2134	12623779000	29162	14247	68	0	\N
216334	2134	12622775000	29162	14247	69	0	\N
216335	2133	9359870000	29162	14247	70	0	\N
216336	2133	9358868000	29162	14247	71	0	\N
216337	2133	9357866000	29162	14247	72	0	\N
216338	2133	9356864000	29162	14247	73	0	\N
216339	2133	9355862000	29162	14247	74	0	\N
216340	2134	12621771000	29162	14247	75	0	\N
216341	2134	12620767000	29162	14247	76	0	\N
216342	2134	12619763000	29162	14247	77	0	\N
216343	2134	12618759000	29162	14247	78	0	\N
216344	2134	12617755000	29162	14247	79	0	\N
216345	2134	12616751000	29162	14247	80	0	\N
216346	2134	12615747000	29162	14247	81	0	\N
216347	2134	12614743000	29162	14247	82	0	\N
216348	2132	7148162000	29162	14247	83	0	\N
216349	2132	7147161000	29162	14247	84	0	\N
216350	1726	121926112000	29162	14247	85	0	\N
216351	2132	7146160000	29162	14247	86	0	\N
216352	2132	7145159000	29162	14247	87	0	\N
216353	2132	7144158000	29162	14247	88	0	\N
216354	2132	7143157000	29162	14247	89	0	\N
216355	2132	7142156000	29162	14247	90	0	\N
216356	2132	7141155000	29162	14247	91	0	\N
216357	2132	7140154000	29162	14247	92	0	\N
216358	2132	7139153000	29162	14247	93	0	\N
216359	2132	7138152000	29162	14247	94	0	\N
216360	2132	7137151000	29162	14247	95	0	\N
216361	2132	7136150000	29162	14247	96	0	\N
216362	2132	7135149000	29162	14247	97	0	\N
216363	2132	7134148000	29162	14247	98	0	\N
216364	2132	7133147000	29162	14247	99	0	\N
216365	2132	7132146000	29162	14247	100	0	\N
216366	2132	7131145000	29162	14247	101	0	\N
216367	2132	7130144000	29162	14247	102	0	\N
216368	2132	7129143000	29162	14247	104	0	\N
216369	2132	7128142000	29162	14247	105	0	\N
216370	2132	7127141000	29162	14247	106	0	\N
216371	2132	7126140000	29162	14247	107	0	\N
216372	2132	7125139000	29162	14247	108	0	\N
216373	2132	7124138000	29162	14247	109	0	\N
216374	2132	7123137000	29162	14247	110	0	\N
216375	2132	7122136000	29162	14247	111	0	\N
216376	2132	7121135000	29162	14247	112	0	\N
216377	2132	7120134000	29162	14247	113	0	\N
216378	2132	7119133000	29162	14247	114	0	\N
216379	2132	7118132000	29162	14247	115	0	\N
216380	2133	9354860000	29162	14247	116	0	\N
216381	2133	9353858000	29162	14247	117	0	\N
216382	2133	9352856000	29162	14247	118	0	\N
216383	2133	9351854000	29162	14247	119	0	\N
216384	2133	9350852000	29162	14247	120	0	\N
216385	2133	9349850000	29162	14247	121	0	\N
216386	2133	9348848000	29162	14247	122	0	\N
216387	2133	9347846000	29162	14247	123	0	\N
216388	2133	9346844000	29162	14247	124	0	\N
216389	2133	9345842000	29162	14247	125	0	\N
216390	2134	12507315000	29163	14380	0	0	\N
216391	2133	9200552000	29163	14380	1	0	\N
216394	2134	12507315000	29165	14380	0	0	\N
216395	2133	9200552000	29165	14380	1	0	\N
216396	2134	12507315000	29167	14380	0	0	\N
216397	2133	9200552000	29167	14380	1	0	\N
216398	1397	1261972332000	29168	14381	0	0	\N
216399	1397	1261962331000	29168	14381	1	0	\N
216400	1397	1261952330000	29168	14381	2	0	\N
216401	2134	12506311000	29168	14381	3	0	\N
216402	2134	12505307000	29168	14381	4	0	\N
216411	1397	1261972332000	29170	14381	0	0	\N
216412	1397	1261962331000	29170	14381	1	0	\N
216413	1397	1261952330000	29170	14381	2	0	\N
216414	2134	12506311000	29170	14381	3	0	\N
216415	2134	12505307000	29170	14381	4	0	\N
216416	1397	1261972332000	29171	14381	0	0	\N
216417	1397	1261962331000	29171	14381	1	0	\N
216418	1397	1261952330000	29171	14381	2	0	\N
216419	1397	1261972332000	29172	14381	0	0	\N
216420	1397	1261962331000	29172	14381	1	0	\N
216421	1397	1261952330000	29172	14381	2	0	\N
216422	2134	12506311000	29172	14381	3	0	\N
216423	2134	12505307000	29172	14381	4	0	\N
216424	2133	9199550000	29172	14381	5	0	\N
216425	2133	9198548000	29172	14381	6	0	\N
216426	2133	9197546000	29172	14381	7	0	\N
216430	1397	1261942329000	29174	14382	0	0	\N
216431	2133	9196544000	29174	14382	1	0	\N
216432	2134	12504303000	29174	14382	2	0	\N
216438	1397	1261912326000	29177	14385	0	0	\N
216439	2134	12502295000	29177	14385	1	0	\N
216440	2133	9193538000	29177	14385	2	0	\N
216444	1397	1261902325000	29179	14386	0	0	\N
216445	2133	9192536000	29179	14386	1	0	\N
216446	2134	12501291000	29179	14386	2	0	\N
216447	1397	1261902325000	29180	14386	0	0	\N
216448	2133	9192536000	29180	14386	1	0	\N
216449	2134	12501291000	29180	14386	2	0	\N
216453	2381	950000000	29182	14277	0	0	\N
216454	2414	90000000	29182	14277	1	0	\N
216455	835	3199985394837430	29182	14277	2	0	\N
216456	693	66000000000000	29182	14277	3	0	\N
216457	1963	731505120000	29182	14277	4	0	\N
216458	1726	121926112000	29182	14277	5	0	\N
216461	1397	1262072342000	29184	14373	0	0	\N
216462	1397	1262062341000	29184	14373	1	0	\N
216463	1397	1262052340000	29184	14373	2	0	\N
216464	1397	1262042339000	29184	14373	3	0	\N
216465	1397	1262032338000	29184	14373	4	0	\N
216466	1397	1262022337000	29184	14373	5	0	\N
216467	1397	1262012336000	29184	14373	6	0	\N
216468	1397	1262002335000	29184	14373	7	0	\N
216469	1397	1261992334000	29184	14373	8	0	\N
216470	1397	1261982333000	29184	14373	9	0	\N
216471	1397	1261972332000	29184	14373	10	0	\N
216472	1397	1261962331000	29184	14373	11	0	\N
216473	1397	1261952330000	29184	14373	12	0	\N
216474	1397	1261942329000	29184	14373	13	0	\N
216475	1397	1261932328000	29184	14373	14	0	\N
216476	1397	1261922327000	29184	14373	15	0	\N
216477	1397	1261912326000	29184	14373	16	0	\N
216478	1397	1261902325000	29184	14373	17	0	\N
216479	2134	12515347000	29184	14373	18	0	\N
216480	2134	12514343000	29184	14373	19	0	\N
216481	2133	9211574000	29184	14373	20	0	\N
216482	2134	12513339000	29184	14373	21	0	\N
216483	2134	12512335000	29184	14373	22	0	\N
216484	2134	12511331000	29184	14373	23	0	\N
216485	2134	12510327000	29184	14373	24	0	\N
216486	2134	12509323000	29184	14373	25	0	\N
216487	2134	12508319000	29184	14373	26	0	\N
216488	2134	12507315000	29184	14373	27	0	\N
216489	2134	12506311000	29184	14373	28	0	\N
216490	2134	12505307000	29184	14373	29	0	\N
216491	2133	9210572000	29184	14373	30	0	\N
216492	2133	9209570000	29184	14373	31	0	\N
216493	2133	9208568000	29184	14373	32	0	\N
216494	2133	9207566000	29184	14373	33	0	\N
216495	2133	9206564000	29184	14373	34	0	\N
216496	2133	9205562000	29184	14373	35	0	\N
216497	2133	9204560000	29184	14373	36	0	\N
216498	2133	9203558000	29184	14373	37	0	\N
216499	2134	12504303000	29184	14373	38	0	\N
216500	2133	9202556000	29184	14373	39	0	\N
216501	2133	9201554000	29184	14373	40	0	\N
216502	2133	9200552000	29184	14373	41	0	\N
216503	2133	9199550000	29184	14373	42	0	\N
216504	2133	9198548000	29184	14373	43	0	\N
216505	2133	9197546000	29184	14373	44	0	\N
216506	2133	9196544000	29184	14373	45	0	\N
216507	2134	12503299000	29184	14373	46	0	\N
216508	2134	12502295000	29184	14373	47	0	\N
216509	2134	12501291000	29184	14373	48	0	\N
216510	2133	9195542000	29184	14373	49	0	\N
216511	2133	9194540000	29184	14373	50	0	\N
216512	2133	9193538000	29184	14373	51	0	\N
216403	1397	1261972332000	29169	14381	0	0	17685
216404	1397	1261962331000	29169	14381	1	0	17686
216405	1397	1261952330000	29169	14381	2	0	17687
216406	2134	12506311000	29169	14381	3	0	7811
216407	2134	12505307000	29169	14381	4	0	7812
216409	2133	9198548000	29169	14381	6	0	7229
216410	2133	9197546000	29169	14381	7	0	7230
216427	1397	1261942329000	29173	14382	0	0	17688
216428	2133	9196544000	29173	14382	1	0	7231
216429	2134	12504303000	29173	14382	2	0	7813
216434	2134	12503299000	29175	14383	1	0	7814
216435	2133	9195542000	29175	14383	2	0	7232
216436	1397	1261922327000	29176	14384	0	0	17690
216437	2133	9194540000	29176	14384	1	0	7233
216442	2134	12502295000	29178	14385	1	0	7815
216443	2133	9193538000	29178	14385	2	0	7234
216450	1397	1261902325000	29181	14386	0	0	17692
216451	2133	9192536000	29181	14386	1	0	7235
216452	2134	12501291000	29181	14386	2	0	7816
216460	2133	9191534000	29183	14387	1	0	7236
216513	2133	9192536000	29184	14373	52	0	\N
216514	2133	9191534000	29184	14373	53	0	\N
216521	1397	1261882323000	29186	14388	0	0	\N
216522	1397	1261872322000	29186	14388	1	0	\N
216523	2134	12500287000	29186	14388	2	0	\N
216524	2134	12499283000	29186	14388	3	0	\N
216525	2133	9190532000	29186	14388	4	0	\N
216526	2133	9189530000	29186	14388	5	0	\N
216527	1397	1261882323000	29187	14388	0	0	\N
216528	1397	1261872322000	29187	14388	1	0	\N
216529	2134	12500287000	29187	14388	2	0	\N
216530	2134	12499283000	29187	14388	3	0	\N
216531	2133	9190532000	29187	14388	4	0	\N
216532	2133	9189530000	29187	14388	5	0	\N
216538	1397	1261842319000	29190	14391	0	0	\N
216539	2133	9186524000	29190	14391	1	0	\N
216540	2132	7103117000	29190	14391	2	0	\N
216541	2134	12497275000	29190	14391	3	0	\N
216542	1397	1261842319000	29191	14391	0	0	\N
216543	2133	9186524000	29191	14391	1	0	\N
216544	2132	7103117000	29191	14391	2	0	\N
216545	2134	12497275000	29191	14391	3	0	\N
216550	1397	1261832318000	29194	14392	0	0	\N
216551	1397	1261822317000	29194	14392	1	0	\N
216552	2133	9185522000	29194	14392	2	0	\N
216553	2133	9184520000	29194	14392	3	0	\N
216554	2134	12496271000	29194	14392	4	0	\N
216560	1397	1261832318000	29196	14392	0	0	\N
216561	1397	1261822317000	29196	14392	1	0	\N
216562	2134	12496271000	29196	14392	2	0	\N
216567	1397	1261802315000	29198	14394	0	0	\N
216568	1397	1261792314000	29198	14394	1	0	\N
216569	1397	1261782313000	29198	14394	2	0	\N
216570	2133	9182516000	29198	14394	3	0	\N
216571	2133	9181514000	29198	14394	4	0	\N
216572	2133	9180512000	29198	14394	5	0	\N
216573	2134	12494263000	29198	14394	7	0	\N
216574	2134	12493259000	29198	14394	8	0	\N
216575	1397	1261802315000	29199	14394	0	0	\N
216576	1397	1261792314000	29199	14394	1	0	\N
216577	1397	1261782313000	29199	14394	2	0	\N
216578	2133	9182516000	29199	14394	3	0	\N
216579	2133	9181514000	29199	14394	4	0	\N
216580	2133	9180512000	29199	14394	5	0	\N
216581	2134	12494263000	29199	14394	7	0	\N
216582	2134	12493259000	29199	14394	8	0	\N
216583	1397	1261802315000	29200	14394	0	0	\N
216584	1397	1261792314000	29200	14394	1	0	\N
216585	1397	1261782313000	29200	14394	2	0	\N
216586	2133	9182516000	29200	14394	3	0	\N
216587	2133	9181514000	29200	14394	4	0	\N
216588	2133	9180512000	29200	14394	5	0	\N
216589	2134	12494263000	29200	14394	7	0	\N
216590	2134	12493259000	29200	14394	8	0	\N
216591	1397	1261802315000	29201	14394	0	0	\N
216592	1397	1261792314000	29201	14394	1	0	\N
216593	1397	1261782313000	29201	14394	2	0	\N
216594	2133	9182516000	29201	14394	3	0	\N
216595	2133	9181514000	29201	14394	4	0	\N
216596	2133	9180512000	29201	14394	5	0	\N
216597	2134	12494263000	29201	14394	7	0	\N
216598	2134	12493259000	29201	14394	8	0	\N
216599	1397	1261802315000	29202	14394	0	0	\N
216600	1397	1261792314000	29202	14394	1	0	\N
216601	1397	1261782313000	29202	14394	2	0	\N
216602	2133	9182516000	29202	14394	3	0	\N
216603	2133	9181514000	29202	14394	4	0	\N
216604	2133	9180512000	29202	14394	5	0	\N
216605	2134	12494263000	29202	14394	7	0	\N
216606	2134	12493259000	29202	14394	8	0	\N
216613	1397	1261802315000	29204	14394	0	0	\N
216614	1397	1261792314000	29204	14394	1	0	\N
216615	1397	1261782313000	29204	14394	2	0	\N
216616	2133	9182516000	29204	14394	3	0	\N
216617	2133	9181514000	29204	14394	4	0	\N
216618	2133	9180512000	29204	14394	5	0	\N
216619	2134	12494263000	29204	14394	7	0	\N
216620	2134	12493259000	29204	14394	8	0	\N
216621	1397	1261772312000	29205	14395	0	0	\N
216622	2133	9179510000	29205	14395	1	0	\N
216623	2132	7101115000	29205	14395	2	0	\N
216624	2134	12494263000	29205	14395	3	0	\N
216625	2134	12493259000	29205	14395	4	0	\N
216626	2134	12492255000	29205	14395	5	0	\N
216633	1397	1261772312000	29207	14395	0	0	\N
216634	2133	9179510000	29207	14395	1	0	\N
216635	2132	7101115000	29207	14395	2	0	\N
216636	2134	12494263000	29207	14395	3	0	\N
216637	2134	12493259000	29207	14395	4	0	\N
216638	2134	12492255000	29207	14395	5	0	\N
216639	1397	1262272362000	29208	14361	0	0	\N
216640	1397	1262262361000	29208	14361	1	0	\N
216641	1397	1262252360000	29208	14361	2	0	\N
216642	1397	1262242359000	29208	14361	3	0	\N
216643	1397	1262232358000	29208	14361	4	0	\N
216644	1397	1262222357000	29208	14361	5	0	\N
216645	1397	1262212356000	29208	14361	6	0	\N
216646	1397	1262202355000	29208	14361	7	0	\N
216647	1397	1262192354000	29208	14361	8	0	\N
216648	1397	1262182353000	29208	14361	9	0	\N
216517	2134	12500287000	29185	14388	2	0	7817
216518	2134	12499283000	29185	14388	3	0	7818
216519	2133	9190532000	29185	14388	4	0	7237
216520	2133	9189530000	29185	14388	5	0	7238
216533	1397	1261862321000	29188	14389	0	0	17696
216535	2134	12498279000	29188	14389	2	0	7819
216536	1397	1261852320000	29189	14390	0	0	17697
216537	2133	9187526000	29189	14390	1	0	7240
216546	1397	1261842319000	29192	14391	0	0	17698
216547	2133	9186524000	29192	14391	1	0	7241
216549	2134	12497275000	29192	14391	3	0	7820
216555	1397	1261832318000	29195	14392	0	0	17699
216556	1397	1261822317000	29195	14392	1	0	17700
216557	2133	9185522000	29195	14392	2	0	7242
216559	2134	12496271000	29195	14392	4	0	7821
216563	1397	1261812316000	29197	14393	0	0	17701
216564	2133	9183518000	29197	14393	1	0	7244
216565	2132	7102116000	29197	14393	2	0	1886
216566	2134	12495267000	29197	14393	3	0	7822
216608	1397	1261792314000	29203	14394	1	0	17703
216609	1397	1261782313000	29203	14394	2	0	17704
216610	2133	9182516000	29203	14394	3	0	7245
216611	2133	9181514000	29203	14394	4	0	7246
216612	2133	9180512000	29203	14394	5	0	7247
216628	2133	9179510000	29206	14395	1	0	7248
216629	2132	7101115000	29206	14395	2	0	1887
216630	2134	12494263000	29206	14395	3	0	7823
216631	2134	12493259000	29206	14395	4	0	7824
216649	1397	1262172352000	29208	14361	10	0	\N
216650	1397	1262162351000	29208	14361	11	0	\N
216651	1397	1262152350000	29208	14361	12	0	\N
216652	1397	1262142349000	29208	14361	13	0	\N
216653	1397	1262132348000	29208	14361	14	0	\N
216654	1397	1262122347000	29208	14361	15	0	\N
216655	1397	1262112346000	29208	14361	16	0	\N
216656	1397	1262102345000	29208	14361	17	0	\N
216657	1397	1262092344000	29208	14361	18	0	\N
216658	1397	1262082343000	29208	14361	19	0	\N
216659	1397	1262072342000	29208	14361	20	0	\N
216660	1397	1262062341000	29208	14361	21	0	\N
216661	1397	1262052340000	29208	14361	22	0	\N
216662	1397	1262042339000	29208	14361	23	0	\N
216663	1397	1262032338000	29208	14361	24	0	\N
216664	1397	1262022337000	29208	14361	25	0	\N
216665	1397	1262012336000	29208	14361	26	0	\N
216666	1397	1262002335000	29208	14361	27	0	\N
216667	1397	1261992334000	29208	14361	28	0	\N
216668	1397	1261982333000	29208	14361	29	0	\N
216669	1397	1261972332000	29208	14361	30	0	\N
216670	1397	1261962331000	29208	14361	31	0	\N
216671	1397	1261952330000	29208	14361	32	0	\N
216672	1397	1261942329000	29208	14361	33	0	\N
216673	1397	1261932328000	29208	14361	34	0	\N
216674	1397	1261922327000	29208	14361	35	0	\N
216675	1397	1261912326000	29208	14361	36	0	\N
216676	1397	1261902325000	29208	14361	37	0	\N
216677	1397	1261892324000	29208	14361	38	0	\N
216678	1397	1261882323000	29208	14361	39	0	\N
216679	1397	1261872322000	29208	14361	40	0	\N
216680	1397	1261862321000	29208	14361	41	0	\N
216681	1397	1261852320000	29208	14361	42	0	\N
216682	1397	1261842319000	29208	14361	43	0	\N
216683	1397	1261832318000	29208	14361	44	0	\N
216684	1397	1261822317000	29208	14361	45	0	\N
216685	1397	1261812316000	29208	14361	46	0	\N
216686	1397	1261802315000	29208	14361	47	0	\N
216687	1397	1261792314000	29208	14361	48	0	\N
216688	1397	1261782313000	29208	14361	49	0	\N
216689	1397	1261772312000	29208	14361	50	0	\N
216690	2134	12530407000	29208	14361	51	0	\N
216691	2134	12529403000	29208	14361	52	0	\N
216692	2134	12528399000	29208	14361	53	0	\N
216693	2132	7109123000	29208	14361	54	0	\N
216694	2132	7108122000	29208	14361	55	0	\N
216695	2132	7107121000	29208	14361	56	0	\N
216696	2132	7106120000	29208	14361	57	0	\N
216697	2132	7105119000	29208	14361	58	0	\N
216698	2132	7104118000	29208	14361	59	0	\N
216699	2132	7103117000	29208	14361	60	0	\N
216700	2132	7102116000	29208	14361	61	0	\N
216701	2132	7101115000	29208	14361	62	0	\N
216702	2134	12527395000	29208	14361	63	0	\N
216703	2134	12526391000	29208	14361	64	0	\N
216704	2134	12525387000	29208	14361	65	0	\N
216705	2134	12524383000	29208	14361	66	0	\N
216706	2134	12523379000	29208	14361	67	0	\N
216707	2134	12522375000	29208	14361	68	0	\N
216708	2134	12521371000	29208	14361	69	0	\N
216709	2134	12520367000	29208	14361	70	0	\N
216710	2134	12519363000	29208	14361	71	0	\N
216711	2134	12518359000	29208	14361	72	0	\N
216712	2134	12517355000	29208	14361	73	0	\N
216713	2134	12516351000	29208	14361	74	0	\N
216714	2134	12515347000	29208	14361	75	0	\N
216715	2134	12514343000	29208	14361	76	0	\N
216716	2134	12513339000	29208	14361	77	0	\N
216717	2134	12512335000	29208	14361	78	0	\N
216718	2134	12511331000	29208	14361	79	0	\N
216719	2134	12510327000	29208	14361	80	0	\N
216720	2134	12509323000	29208	14361	81	0	\N
216721	2134	12508319000	29208	14361	82	0	\N
216722	2134	12507315000	29208	14361	84	0	\N
216723	2134	12506311000	29208	14361	85	0	\N
216724	2134	12505307000	29208	14361	86	0	\N
216725	2134	12504303000	29208	14361	87	0	\N
216726	2133	9230612000	29208	14361	88	0	\N
216727	2133	9229610000	29208	14361	89	0	\N
216728	2133	9228608000	29208	14361	90	0	\N
216729	2133	9227606000	29208	14361	91	0	\N
216730	2133	9226604000	29208	14361	92	0	\N
216731	2133	9225602000	29208	14361	93	0	\N
216732	2133	9224600000	29208	14361	94	0	\N
216733	2133	9223598000	29208	14361	95	0	\N
216734	2133	9222596000	29208	14361	96	0	\N
216735	2133	9221594000	29208	14361	97	0	\N
216736	2133	9220592000	29208	14361	98	0	\N
216737	2133	9219590000	29208	14361	99	0	\N
216738	2133	9218588000	29208	14361	100	0	\N
216739	2133	9217586000	29208	14361	101	0	\N
216740	2133	9216584000	29208	14361	102	0	\N
216741	2133	9215582000	29208	14361	103	0	\N
216742	2133	9214580000	29208	14361	104	0	\N
216743	2133	9213578000	29208	14361	105	0	\N
216744	2133	9212576000	29208	14361	106	0	\N
216745	2133	9211574000	29208	14361	107	0	\N
216746	2133	9210572000	29208	14361	108	0	\N
216747	2133	9209570000	29208	14361	109	0	\N
216748	2133	9208568000	29208	14361	110	0	\N
216749	2133	9207566000	29208	14361	111	0	\N
216750	2133	9206564000	29208	14361	112	0	\N
216751	2133	9205562000	29208	14361	113	0	\N
216752	2133	9204560000	29208	14361	114	0	\N
216753	2133	9203558000	29208	14361	115	0	\N
216754	2133	9202556000	29208	14361	116	0	\N
216755	2133	9201554000	29208	14361	117	0	\N
216756	2133	9200552000	29208	14361	118	0	\N
216757	2133	9199550000	29208	14361	119	0	\N
216758	2133	9198548000	29208	14361	120	0	\N
216759	2133	9197546000	29208	14361	121	0	\N
216760	2133	9196544000	29208	14361	122	0	\N
216761	2134	12503299000	29208	14361	123	0	\N
216762	2134	12502295000	29208	14361	124	0	\N
216763	2134	12501291000	29208	14361	125	0	\N
216767	1397	1261762311000	29210	14396	0	0	\N
216768	2134	12491251000	29210	14396	1	0	\N
216769	2133	9178508000	29210	14396	2	0	\N
216770	1397	1261762311000	29211	14396	0	0	\N
216771	2134	12491251000	29211	14396	1	0	\N
216772	2133	9178508000	29211	14396	2	0	\N
216773	1397	1261752310000	29212	14397	0	0	\N
216774	2134	12490247000	29212	14397	1	0	\N
216775	2133	9177506000	29212	14397	2	0	\N
216778	1397	1261742309000	29214	14398	0	0	\N
216779	2133	9176504000	29214	14398	1	0	\N
216780	2132	7100114000	29214	14398	2	0	\N
216781	2134	12490247000	29214	14398	3	0	\N
216766	2133	9178508000	29209	14396	2	0	7249
216776	1397	1261752310000	29213	14397	0	0	17707
216777	2133	9177506000	29213	14397	1	0	7250
216782	1397	1261742309000	29215	14398	0	0	17708
216783	2133	9176504000	29215	14398	1	0	7251
216789	1397	1261732308000	29217	14399	0	0	\N
216790	2134	12489243000	29217	14399	1	0	\N
216791	2133	9175502000	29217	14399	2	0	\N
216792	2134	12489243000	29218	14399	0	0	\N
216793	2133	9175502000	29218	14399	1	0	\N
216794	1397	1261722307000	29219	14400	0	0	\N
216795	2134	12488239000	29219	14400	1	0	\N
216799	1397	1261722307000	29221	14400	0	0	\N
216800	2133	9174500000	29221	14400	1	0	\N
216801	2134	12488239000	29221	14400	2	0	\N
216802	1397	1261712306000	29222	14401	0	0	\N
216803	2132	7099113000	29222	14401	1	0	\N
216807	1397	1261712306000	29224	14401	0	0	\N
216808	2132	7099113000	29224	14401	1	0	\N
216809	2133	9173498000	29224	14401	2	0	\N
216810	1397	1261702305000	29225	14402	0	0	\N
216811	2134	12487235000	29225	14402	1	0	\N
216812	2133	9172496000	29225	14402	2	0	\N
216813	1397	1261702305000	29226	14402	0	0	\N
216814	2134	12487235000	29226	14402	1	0	\N
216815	2133	9172496000	29226	14402	2	0	\N
216819	1397	1261692304000	29228	14403	0	0	\N
216820	1397	1261682303000	29228	14403	1	0	\N
216821	2134	12486231000	29228	14403	2	0	\N
216822	2133	9171494000	29228	14403	3	0	\N
216823	2133	9170492000	29228	14403	4	0	\N
216833	1397	1261672302000	29231	14404	0	0	\N
216834	2133	9169490000	29231	14404	1	0	\N
216835	2134	12485227000	29231	14404	2	0	\N
216836	2132	7098112000	29231	14404	3	0	\N
216853	1397	1261612296000	29235	14408	0	0	\N
216854	2132	7096110000	29235	14408	1	0	\N
216855	2133	9163478000	29235	14408	2	0	\N
216856	2134	12480207000	29235	14408	3	0	\N
216857	1397	1261612296000	29236	14408	0	0	\N
216858	2132	7096110000	29236	14408	1	0	\N
216859	2133	9163478000	29236	14408	2	0	\N
216860	2134	12480207000	29236	14408	3	0	\N
216861	1397	1261612296000	29237	14408	0	0	\N
216862	2132	7096110000	29237	14408	1	0	\N
216863	2133	9163478000	29237	14408	2	0	\N
216864	2134	12480207000	29237	14408	3	0	\N
216869	1397	1261612296000	29239	14408	0	0	\N
216870	2132	7096110000	29239	14408	1	0	\N
216871	2133	9163478000	29239	14408	2	0	\N
216872	2134	12480207000	29239	14408	3	0	\N
216878	1397	1261582293000	29242	14411	0	0	\N
216879	2133	9160472000	29242	14411	1	0	\N
216880	2134	12478199000	29242	14411	2	0	\N
216884	1397	1261582293000	29244	14411	0	0	\N
216885	2133	9160472000	29244	14411	1	0	\N
216886	2134	12478199000	29244	14411	2	0	\N
216900	1397	1261542289000	29248	14414	0	0	\N
216901	2133	9156464000	29248	14414	1	0	\N
216902	2132	7094108000	29248	14414	2	0	\N
216903	2134	12475187000	29248	14414	3	0	\N
216904	1397	1261542289000	29249	14414	0	0	\N
216905	2132	7094108000	29249	14414	1	0	\N
216906	2134	12475187000	29249	14414	2	0	\N
216907	1397	1261532288000	29250	14415	0	0	\N
216908	2133	9155462000	29250	14415	1	0	\N
216918	1397	1261502285000	29254	14418	0	0	\N
216919	2133	9152456000	29254	14418	1	0	\N
216920	2134	12472175000	29254	14418	2	0	\N
216787	2134	12489243000	29216	14399	1	0	7828
216788	2133	9175502000	29216	14399	2	0	7252
216796	1397	1261722307000	29220	14400	0	0	17710
216797	2133	9174500000	29220	14400	1	0	7253
216798	2134	12488239000	29220	14400	2	0	7829
216805	2132	7099113000	29223	14401	1	0	1889
216806	2133	9173498000	29223	14401	2	0	7254
216816	1397	1261702305000	29227	14402	0	0	17712
216817	2134	12487235000	29227	14402	1	0	7830
216818	2133	9172496000	29227	14402	2	0	7255
216825	1397	1261682303000	29229	14403	1	0	17714
216826	2134	12486231000	29229	14403	2	0	7831
216827	2133	9171494000	29229	14403	3	0	7256
216828	2133	9170492000	29229	14403	4	0	7257
216830	2133	9169490000	29230	14404	1	0	7258
216831	2134	12485227000	29230	14404	2	0	7832
216832	2132	7098112000	29230	14404	3	0	1890
216837	1397	1261662301000	29232	14405	0	0	17716
216838	2134	12484223000	29232	14405	1	0	7833
216840	1397	1261652300000	29233	14406	0	0	17717
216841	1397	1261642299000	29233	14406	1	0	17718
216842	2132	7097111000	29233	14406	2	0	1891
216843	2133	9167486000	29233	14406	3	0	7260
216844	2134	12483219000	29233	14406	4	0	7834
216846	1397	1261632298000	29234	14407	0	0	17719
216847	1397	1261622297000	29234	14407	1	0	17720
216848	338	66010022000000	29234	14407	2	0	4
216849	2133	9165482000	29234	14407	3	0	7262
216851	2134	12482215000	29234	14407	5	0	7835
216852	2134	12481211000	29234	14407	6	0	7836
216865	1397	1261612296000	29238	14408	0	0	17721
216866	2132	7096110000	29238	14408	1	0	1892
216867	2133	9163478000	29238	14408	2	0	7264
216873	1397	1261602295000	29240	14409	0	0	17722
216874	2133	9162476000	29240	14409	1	0	7265
216875	1397	1261592294000	29241	14410	0	0	17723
216876	2133	9161474000	29241	14410	1	0	7266
216877	2134	12479203000	29241	14410	2	0	7838
216882	2133	9160472000	29243	14411	1	0	7267
216883	2134	12478199000	29243	14411	2	0	7839
216887	1397	1261572292000	29245	14412	0	0	17725
216888	2133	9159470000	29245	14412	1	0	7268
216890	1397	1261562291000	29246	14413	0	0	17726
216891	1397	1261552290000	29246	14413	1	0	17727
216892	2134	12477195000	29246	14413	2	0	7840
216893	2134	12476191000	29246	14413	3	0	7841
216894	2133	9158468000	29246	14413	4	0	7269
216896	1397	1261542289000	29247	14414	0	0	17728
216897	2133	9156464000	29247	14414	1	0	7271
216898	2132	7094108000	29247	14414	2	0	1894
216899	2134	12475187000	29247	14414	3	0	7842
216909	1397	1261532288000	29251	14415	0	0	17729
216911	1397	1261522287000	29252	14416	0	0	17730
216912	2133	9154460000	29252	14416	1	0	7273
216913	2134	12474183000	29252	14416	2	0	7843
216914	1397	1261512286000	29253	14417	0	0	17731
216916	2133	9153458000	29253	14417	2	0	7274
216917	2132	7093107000	29253	14417	3	0	1895
216923	1397	1261492284000	29256	14419	0	0	\N
216924	2133	9152456000	29256	14419	1	0	\N
216925	2133	9151454000	29256	14419	2	0	\N
216932	1397	1261482283000	29259	14420	0	0	\N
216933	2133	9150452000	29259	14420	1	0	\N
216934	2134	12471171000	29259	14420	2	0	\N
216954	1397	1261452280000	29263	14423	0	0	\N
216955	1397	1261442279000	29263	14423	1	0	\N
216956	1397	1261432278000	29263	14423	2	0	\N
216957	1397	1261422277000	29263	14423	3	0	\N
216958	2134	12469163000	29263	14423	4	0	\N
216959	2134	12468159000	29263	14423	5	0	\N
216960	2134	12467155000	29263	14423	6	0	\N
216961	2133	9147446000	29263	14423	7	0	\N
216962	2133	9146444000	29263	14423	8	0	\N
216963	2133	9145442000	29263	14423	9	0	\N
216964	2133	9144440000	29263	14423	10	0	\N
216965	2132	7091105000	29263	14423	11	0	\N
216966	1397	1261452280000	29264	14423	0	0	\N
216967	1397	1261442279000	29264	14423	1	0	\N
216968	1397	1261432278000	29264	14423	2	0	\N
216969	1397	1261422277000	29264	14423	3	0	\N
216970	2134	12469163000	29264	14423	4	0	\N
216971	2134	12468159000	29264	14423	5	0	\N
216972	2134	12467155000	29264	14423	6	0	\N
216973	2133	9147446000	29264	14423	7	0	\N
216974	2133	9146444000	29264	14423	8	0	\N
216975	2133	9145442000	29264	14423	9	0	\N
216976	2133	9144440000	29264	14423	10	0	\N
216977	2132	7091105000	29264	14423	11	0	\N
216982	2414	90000000	29266	14309	0	0	\N
216983	835	3199985394837430	29266	14309	1	0	\N
216984	1992	1107990000	29266	14309	2	0	\N
216985	693	66000000000000	29266	14309	3	0	\N
216986	338	66010022000000	29266	14309	4	0	\N
216987	1397	1261402275000	29267	14425	0	0	\N
216988	1397	1261392274000	29267	14425	1	0	\N
216989	2134	12465147000	29267	14425	2	0	\N
216990	2134	12464143000	29267	14425	3	0	\N
216991	2133	9142436000	29267	14425	4	0	\N
216992	2133	9141434000	29267	14425	5	0	\N
216993	1397	1261402275000	29268	14425	0	0	\N
216994	1397	1261392274000	29268	14425	1	0	\N
216995	2134	12465147000	29268	14425	2	0	\N
216996	2134	12464143000	29268	14425	3	0	\N
217015	1992	1107990000	29271	14248	0	0	\N
217016	1397	1261972332000	29271	14248	1	0	\N
217017	1397	1261962331000	29271	14248	2	0	\N
217018	1397	1261952330000	29271	14248	3	0	\N
217019	1397	1261942329000	29271	14248	4	0	\N
217020	1397	1261932328000	29271	14248	5	0	\N
217021	1397	1261922327000	29271	14248	6	0	\N
217022	1397	1261912326000	29271	14248	7	0	\N
217023	1397	1261902325000	29271	14248	8	0	\N
217024	1397	1261892324000	29271	14248	9	0	\N
217025	1397	1261882323000	29271	14248	10	0	\N
217026	1397	1261872322000	29271	14248	11	0	\N
217027	1397	1261862321000	29271	14248	12	0	\N
217028	1397	1261852320000	29271	14248	13	0	\N
217029	1397	1261842319000	29271	14248	14	0	\N
217030	1397	1261832318000	29271	14248	15	0	\N
217031	1397	1261822317000	29271	14248	16	0	\N
217032	1397	1261812316000	29271	14248	17	0	\N
217033	1397	1261802315000	29271	14248	18	0	\N
217034	1397	1261792314000	29271	14248	19	0	\N
217035	1397	1261382273000	29272	14426	0	0	\N
217036	1397	1261372272000	29272	14426	1	0	\N
217037	1397	1261362271000	29272	14426	2	0	\N
217038	1397	1261352270000	29272	14426	3	0	\N
217039	2133	9140432000	29272	14426	4	0	\N
217040	2132	7089103000	29272	14426	5	0	\N
217041	2133	9139430000	29272	14426	6	0	\N
217042	2133	9138428000	29272	14426	7	0	\N
217043	2133	9137426000	29272	14426	8	0	\N
217044	2134	12463139000	29272	14426	9	0	\N
217045	2134	12462135000	29272	14426	10	0	\N
217046	2134	12461131000	29272	14426	11	0	\N
217053	296	66001900000000	29274	14303	0	0	\N
217054	2414	90000000	29274	14303	1	0	\N
217055	835	3199985394837430	29274	14303	2	0	\N
217056	1992	1107990000	29274	14303	3	0	\N
216926	1397	1261492284000	29257	14419	0	0	17733
216927	2133	9152456000	29257	14419	1	0	7275
216928	2133	9151454000	29257	14419	2	0	7276
216929	1397	1261482283000	29258	14420	0	0	17734
216930	2133	9150452000	29258	14420	1	0	7277
216935	2134	12470167000	29260	14421	0	0	7847
216936	2133	9149450000	29260	14421	1	0	7278
216937	2132	7092106000	29260	14421	2	0	1896
216938	1397	1261472282000	29261	14422	0	0	17735
216939	1992	1107990000	29261	14422	1	0	6
216941	2133	9148448000	29261	14422	3	0	7279
216942	1397	1261452280000	29262	14423	0	0	17737
216943	1397	1261442279000	29262	14423	1	0	17738
216944	1397	1261432278000	29262	14423	2	0	17739
216946	2134	12469163000	29262	14423	4	0	7848
216947	2134	12468159000	29262	14423	5	0	7849
216948	2134	12467155000	29262	14423	6	0	7850
216949	2133	9147446000	29262	14423	7	0	7280
216950	2133	9146444000	29262	14423	8	0	7281
216952	2133	9144440000	29262	14423	10	0	7283
216953	2132	7091105000	29262	14423	11	0	1897
216978	1397	1261412276000	29265	14424	0	0	17741
216979	2132	7090104000	29265	14424	1	0	1898
216980	2134	12466151000	29265	14424	2	0	7851
216997	1397	1261402275000	29269	14425	0	0	17742
216998	1397	1261392274000	29269	14425	1	0	17743
216999	2134	12465147000	29269	14425	2	0	7852
217000	2134	12464143000	29269	14425	3	0	7853
217002	2133	9141434000	29269	14425	5	0	7286
217003	1397	1261382273000	29270	14426	0	0	17744
217004	1397	1261372272000	29270	14426	1	0	17745
217005	1397	1261362271000	29270	14426	2	0	17746
217006	1397	1261352270000	29270	14426	3	0	17747
217008	2132	7089103000	29270	14426	5	0	1899
217009	2133	9139430000	29270	14426	6	0	7288
217010	2133	9138428000	29270	14426	7	0	7289
217011	2133	9137426000	29270	14426	8	0	7290
217012	2134	12463139000	29270	14426	9	0	7854
217014	2134	12461131000	29270	14426	11	0	7856
217047	1397	1261342269000	29273	14427	0	0	17748
217048	1397	1261332268000	29273	14427	1	0	17749
217049	2133	9136424000	29273	14427	2	0	7291
217051	2134	12460127000	29273	14427	4	0	7857
217052	2133	9135422000	29273	14427	5	0	7292
217057	693	66000000000000	29274	14303	4	0	\N
217058	1397	1263082443000	29274	14303	5	0	\N
217059	1397	1263072442000	29274	14303	6	0	\N
217060	1397	1263062441000	29274	14303	7	0	\N
217061	1397	1263052440000	29274	14303	8	0	\N
217062	1397	1263042439000	29274	14303	9	0	\N
217063	1397	1263032438000	29274	14303	10	0	\N
217064	1397	1263022437000	29274	14303	11	0	\N
217065	1397	1263012436000	29274	14303	12	0	\N
217066	1397	1263002435000	29274	14303	13	0	\N
217067	1397	1262992434000	29274	14303	14	0	\N
217068	1397	1262982433000	29274	14303	15	0	\N
217069	1397	1262972432000	29274	14303	16	0	\N
217070	1397	1262962431000	29274	14303	17	0	\N
217071	1397	1262952430000	29274	14303	18	0	\N
217072	1397	1262942429000	29274	14303	19	0	\N
217073	1397	1262932428000	29274	14303	20	0	\N
217074	1397	1262922427000	29274	14303	21	0	\N
217075	1397	1262912426000	29274	14303	22	0	\N
217076	1397	1262902425000	29274	14303	23	0	\N
217077	1397	1262892424000	29274	14303	24	0	\N
217078	1397	1262882423000	29274	14303	25	0	\N
217079	1397	1262872422000	29274	14303	26	0	\N
217080	1397	1262862421000	29274	14303	27	0	\N
217081	1397	1262852420000	29274	14303	28	0	\N
217082	1397	1262842419000	29274	14303	29	0	\N
217083	1397	1262832418000	29274	14303	30	0	\N
217084	1397	1262822417000	29274	14303	31	0	\N
217085	1397	1262812416000	29274	14303	32	0	\N
217086	1397	1262802415000	29274	14303	33	0	\N
217087	1397	1262792414000	29274	14303	34	0	\N
217088	1397	1262782413000	29274	14303	35	0	\N
217089	1397	1262772412000	29274	14303	36	0	\N
217090	1397	1262762411000	29274	14303	37	0	\N
217091	1397	1262752410000	29274	14303	38	0	\N
217092	1397	1262742409000	29274	14303	39	0	\N
217093	1397	1262732408000	29274	14303	40	0	\N
217094	1397	1262722407000	29274	14303	41	0	\N
217095	1397	1262712406000	29274	14303	42	0	\N
217096	1397	1262702405000	29274	14303	43	0	\N
217097	1397	1262692404000	29274	14303	44	0	\N
217098	1397	1262682403000	29274	14303	45	0	\N
217099	1397	1262672402000	29274	14303	46	0	\N
217100	1397	1262662401000	29274	14303	47	0	\N
217101	1397	1262652400000	29274	14303	48	0	\N
217102	1397	1262642399000	29274	14303	49	0	\N
217103	1397	1262632398000	29274	14303	50	0	\N
217104	1397	1262622397000	29274	14303	51	0	\N
217105	1397	1262612396000	29274	14303	52	0	\N
217106	1397	1262602395000	29274	14303	53	0	\N
217107	1397	1262592394000	29274	14303	54	0	\N
217108	1397	1262582393000	29274	14303	55	0	\N
217109	1397	1262572392000	29274	14303	56	0	\N
217110	1397	1262562391000	29274	14303	57	0	\N
217111	1397	1262552390000	29274	14303	58	0	\N
217112	1397	1262542389000	29274	14303	59	0	\N
217113	1397	1262532388000	29274	14303	60	0	\N
217114	1397	1262522387000	29274	14303	61	0	\N
217115	1397	1262512386000	29274	14303	62	0	\N
217116	1397	1262502385000	29274	14303	63	0	\N
217117	1397	1262492384000	29274	14303	65	0	\N
217118	1397	1262482383000	29274	14303	66	0	\N
217119	1397	1262472382000	29274	14303	67	0	\N
217120	1397	1262462381000	29274	14303	68	0	\N
217121	1397	1262452380000	29274	14303	69	0	\N
217122	1397	1262442379000	29274	14303	70	0	\N
217123	1397	1262432378000	29274	14303	71	0	\N
217124	1397	1262422377000	29274	14303	72	0	\N
217125	1397	1262412376000	29274	14303	73	0	\N
217126	1397	1262402375000	29274	14303	74	0	\N
217127	1397	1262392374000	29274	14303	75	0	\N
217128	1397	1262382373000	29274	14303	76	0	\N
217129	1397	1262372372000	29274	14303	77	0	\N
217130	1397	1262362371000	29274	14303	78	0	\N
217131	1397	1262352370000	29274	14303	79	0	\N
217132	1397	1262342369000	29274	14303	80	0	\N
217133	1397	1262332368000	29274	14303	81	0	\N
217134	1397	1262322367000	29274	14303	82	0	\N
217135	1397	1262312366000	29274	14303	83	0	\N
217136	1397	1262302365000	29274	14303	84	0	\N
217137	1397	1262292364000	29274	14303	85	0	\N
217138	1397	1262282363000	29274	14303	86	0	\N
217139	1397	1262272362000	29274	14303	87	0	\N
217140	1397	1262262361000	29274	14303	88	0	\N
217141	1397	1262252360000	29274	14303	89	0	\N
217142	1397	1262242359000	29274	14303	90	0	\N
217143	1397	1262232358000	29274	14303	91	0	\N
217144	1397	1262222357000	29274	14303	92	0	\N
217145	1397	1262212356000	29274	14303	93	0	\N
217146	1397	1262202355000	29274	14303	94	0	\N
217147	1397	1262192354000	29274	14303	95	0	\N
217148	1397	1262182353000	29274	14303	96	0	\N
217149	1397	1262172352000	29274	14303	97	0	\N
217150	1397	1262162351000	29274	14303	98	0	\N
217151	1397	1262152350000	29274	14303	99	0	\N
217152	1397	1262142349000	29274	14303	100	0	\N
217153	1397	1262132348000	29274	14303	101	0	\N
217154	1397	1262122347000	29274	14303	102	0	\N
217155	1397	1262112346000	29274	14303	103	0	\N
217156	1397	1262102345000	29274	14303	104	0	\N
217157	1397	1262092344000	29274	14303	105	0	\N
217158	1397	1262082343000	29274	14303	106	0	\N
217159	1397	1262072342000	29274	14303	107	0	\N
217160	1397	1262062341000	29274	14303	108	0	\N
217161	1397	1262052340000	29274	14303	109	0	\N
217162	1397	1262042339000	29274	14303	110	0	\N
217163	1397	1262032338000	29274	14303	111	0	\N
217164	1397	1262022337000	29274	14303	112	0	\N
217165	1397	1262012336000	29274	14303	113	0	\N
217166	1397	1262002335000	29274	14303	114	0	\N
217167	1397	1261992334000	29274	14303	115	0	\N
217168	1397	1261982333000	29274	14303	116	0	\N
217169	1397	1261972332000	29274	14303	117	0	\N
217170	1397	1261962331000	29274	14303	118	0	\N
217171	1397	1261952330000	29274	14303	119	0	\N
217172	1397	1261942329000	29274	14303	120	0	\N
217173	1397	1261932328000	29274	14303	121	0	\N
217174	1397	1261922327000	29274	14303	122	0	\N
217175	1397	1261912326000	29274	14303	123	0	\N
217176	1397	1261902325000	29274	14303	124	0	\N
217177	1397	1261892324000	29274	14303	125	0	\N
217178	1397	1261322267000	29275	14428	0	0	\N
217179	2134	12459123000	29275	14428	1	0	\N
217180	2133	9134420000	29275	14428	2	0	\N
217181	1397	1261322267000	29276	14428	0	0	\N
217182	2134	12459123000	29276	14428	1	0	\N
217183	2133	9134420000	29276	14428	2	0	\N
217187	1397	1261662301000	29278	14405	0	0	\N
217188	1992	1107990000	29278	14405	1	0	\N
217189	1397	1261652300000	29278	14405	2	0	\N
217190	1397	1261642299000	29278	14405	3	0	\N
217191	1397	1261632298000	29278	14405	4	0	\N
217192	1397	1261622297000	29278	14405	5	0	\N
217186	2133	9134420000	29277	14428	2	0	7293
217193	1397	1261612296000	29278	14405	6	0	\N
217194	1397	1261602295000	29278	14405	7	0	\N
217195	1397	1261592294000	29278	14405	8	0	\N
217196	1397	1261582293000	29278	14405	9	0	\N
217197	1397	1261572292000	29278	14405	10	0	\N
217198	1397	1261562291000	29278	14405	11	0	\N
217199	1397	1261552290000	29278	14405	12	0	\N
217200	1397	1261542289000	29278	14405	13	0	\N
217201	1397	1261532288000	29278	14405	14	0	\N
217202	1397	1261522287000	29278	14405	15	0	\N
217203	1397	1261512286000	29278	14405	16	0	\N
217204	1397	1261502285000	29278	14405	17	0	\N
217205	1397	1261492284000	29278	14405	18	0	\N
217206	1397	1261482283000	29278	14405	19	0	\N
217207	1397	1261472282000	29278	14405	20	0	\N
217208	1397	1261462281000	29278	14405	21	0	\N
217209	1397	1261452280000	29278	14405	22	0	\N
217210	1397	1261442279000	29278	14405	23	0	\N
217211	1397	1261432278000	29278	14405	24	0	\N
217212	1397	1261422277000	29278	14405	25	0	\N
217213	1397	1261412276000	29278	14405	26	0	\N
217214	1397	1261402275000	29278	14405	27	0	\N
217215	1397	1261392274000	29278	14405	28	0	\N
217216	1397	1261382273000	29278	14405	29	0	\N
217217	1397	1261372272000	29278	14405	30	0	\N
217218	1397	1261362271000	29278	14405	31	0	\N
217219	1397	1261352270000	29278	14405	32	0	\N
217220	1397	1261342269000	29278	14405	33	0	\N
217221	1397	1261332268000	29278	14405	34	0	\N
217222	1397	1261322267000	29278	14405	35	0	\N
217223	2134	12484223000	29278	14405	36	0	\N
217224	2132	7097111000	29278	14405	37	0	\N
217225	2132	7096110000	29278	14405	38	0	\N
217226	2133	9168488000	29278	14405	39	0	\N
217227	2133	9167486000	29278	14405	40	0	\N
217228	2134	12483219000	29278	14405	41	0	\N
217229	338	66010022000000	29278	14405	42	0	\N
217230	2133	9166484000	29278	14405	43	0	\N
217231	2133	9165482000	29278	14405	44	0	\N
217232	2133	9164480000	29278	14405	45	0	\N
217233	2133	9163478000	29278	14405	46	0	\N
217234	2133	9162476000	29278	14405	47	0	\N
217235	2133	9161474000	29278	14405	48	0	\N
217236	2133	9160472000	29278	14405	49	0	\N
217237	2133	9159470000	29278	14405	50	0	\N
217238	2134	12482215000	29278	14405	51	0	\N
217239	2134	12481211000	29278	14405	52	0	\N
217240	2134	12480207000	29278	14405	53	0	\N
217241	2134	12479203000	29278	14405	54	0	\N
217242	2134	12478199000	29278	14405	55	0	\N
217243	2134	12477195000	29278	14405	56	0	\N
217244	2134	12476191000	29278	14405	57	0	\N
217245	2134	12475187000	29278	14405	58	0	\N
217246	2133	9158468000	29278	14405	59	0	\N
217247	2133	9157466000	29278	14405	60	0	\N
217248	2133	9156464000	29278	14405	61	0	\N
217249	2133	9155462000	29278	14405	62	0	\N
217250	2133	9154460000	29278	14405	63	0	\N
217251	2133	9153458000	29278	14405	64	0	\N
217252	2133	9152456000	29278	14405	65	0	\N
217253	2133	9151454000	29278	14405	66	0	\N
217254	2133	9150452000	29278	14405	67	0	\N
217255	2133	9149450000	29278	14405	68	0	\N
217256	2133	9148448000	29278	14405	70	0	\N
217257	2133	9147446000	29278	14405	71	0	\N
217258	2133	9146444000	29278	14405	72	0	\N
217259	2133	9145442000	29278	14405	73	0	\N
217260	2133	9144440000	29278	14405	74	0	\N
217261	2132	7095109000	29278	14405	75	0	\N
217262	2132	7094108000	29278	14405	76	0	\N
217263	2132	7093107000	29278	14405	77	0	\N
217264	2132	7092106000	29278	14405	78	0	\N
217265	2132	7091105000	29278	14405	79	0	\N
217266	2132	7090104000	29278	14405	80	0	\N
217267	2132	7089103000	29278	14405	81	0	\N
217268	2132	7088102000	29278	14405	82	0	\N
217269	2134	12474183000	29278	14405	83	0	\N
217270	2134	12473179000	29278	14405	84	0	\N
217271	2134	12472175000	29278	14405	85	0	\N
217272	2134	12471171000	29278	14405	86	0	\N
217273	2134	12470167000	29278	14405	87	0	\N
217274	2134	12469163000	29278	14405	88	0	\N
217275	2134	12468159000	29278	14405	89	0	\N
217276	2134	12467155000	29278	14405	90	0	\N
217277	2134	12466151000	29278	14405	91	0	\N
217278	2134	12465147000	29278	14405	92	0	\N
217279	2134	12464143000	29278	14405	93	0	\N
217280	2134	12463139000	29278	14405	94	0	\N
217281	2134	12462135000	29278	14405	95	0	\N
217282	2134	12461131000	29278	14405	96	0	\N
217283	2134	12460127000	29278	14405	97	0	\N
217284	2134	12459123000	29278	14405	98	0	\N
217285	2133	9143438000	29278	14405	99	0	\N
217286	2133	9142436000	29278	14405	100	0	\N
217287	2133	9141434000	29278	14405	101	0	\N
217288	2133	9140432000	29278	14405	102	0	\N
217289	2133	9139430000	29278	14405	103	0	\N
217290	2133	9138428000	29278	14405	104	0	\N
217291	2133	9137426000	29278	14405	105	0	\N
217292	2133	9136424000	29278	14405	106	0	\N
217293	2133	9135422000	29278	14405	107	0	\N
217294	2133	9134420000	29278	14405	108	0	\N
217311	1397	1261272262000	29282	14431	0	0	\N
217312	2132	7086100000	29282	14431	1	0	\N
217313	2133	9129410000	29282	14431	2	0	\N
217314	1397	1261272262000	29283	14431	0	0	\N
217315	2132	7086100000	29283	14431	1	0	\N
217316	2133	9129410000	29283	14431	2	0	\N
217317	1397	1261272262000	29284	14431	0	0	\N
217318	2132	7086100000	29284	14431	1	0	\N
217319	2133	9129410000	29284	14431	2	0	\N
217320	1397	1261272262000	29285	14431	0	0	\N
217321	2132	7086100000	29285	14431	1	0	\N
217322	2133	9129410000	29285	14431	2	0	\N
217326	1397	1261262261000	29287	14432	0	0	\N
217327	2133	9128408000	29287	14432	1	0	\N
217328	2134	12455107000	29287	14432	2	0	\N
217297	2133	9133418000	29279	14429	2	0	7294
217298	2132	7087101000	29279	14429	3	0	1901
217299	2133	9132416000	29279	14429	4	0	7295
217300	2134	12458119000	29279	14429	5	0	7859
217301	1397	1261292264000	29280	14430	0	0	17753
217303	1726	120825112000	29280	14430	2	0	8360
217304	2133	9131414000	29280	14430	3	0	7296
217305	2134	12457115000	29280	14430	4	0	7860
217306	2134	12456111000	29280	14430	5	0	7861
217307	2133	9130412000	29280	14430	6	0	7297
217309	2132	7086100000	29281	14431	1	0	1902
217310	2133	9129410000	29281	14431	2	0	7298
217323	1397	1261262261000	29286	14432	0	0	17756
217324	2133	9128408000	29286	14432	1	0	7299
217329	1397	1261262261000	29288	14432	0	0	\N
217330	2133	9128408000	29288	14432	1	0	\N
217331	2134	12455107000	29288	14432	2	0	\N
217341	1397	1261232258000	29291	14434	0	0	\N
217342	2133	9125402000	29291	14434	1	0	\N
217343	1397	1261222257000	29292	14435	0	0	\N
217344	2133	9124400000	29292	14435	2	0	\N
217345	2134	12452095000	29292	14435	3	0	\N
217346	1397	1261222257000	29293	14435	0	0	\N
217347	2133	9124400000	29293	14435	2	0	\N
217348	2134	12452095000	29293	14435	3	0	\N
217352	1397	1261222257000	29295	14435	0	0	\N
217353	2133	9124400000	29295	14435	2	0	\N
217354	2134	12452095000	29295	14435	3	0	\N
217362	1397	1261192254000	29298	14438	0	0	\N
217363	1397	1261182253000	29298	14438	1	0	\N
217364	2133	9121394000	29298	14438	2	0	\N
217365	2134	12449083000	29298	14438	3	0	\N
217366	2133	9120392000	29298	14438	4	0	\N
217367	1397	1261192254000	29299	14438	0	0	\N
217368	1397	1261182253000	29299	14438	1	0	\N
217369	2133	9121394000	29299	14438	2	0	\N
217370	2134	12449083000	29299	14438	3	0	\N
217371	2133	9120392000	29299	14438	4	0	\N
217372	1397	1261192254000	29300	14438	0	0	\N
217373	1397	1261182253000	29300	14438	1	0	\N
217374	2133	9121394000	29300	14438	2	0	\N
217375	2134	12449083000	29300	14438	3	0	\N
217376	2133	9120392000	29300	14438	4	0	\N
217382	1397	1261192254000	29302	14438	0	0	\N
217383	1397	1261182253000	29302	14438	1	0	\N
217384	2133	9121394000	29302	14438	2	0	\N
217385	2134	12449083000	29302	14438	3	0	\N
217386	2133	9120392000	29302	14438	4	0	\N
217396	1397	1261142249000	29305	14441	0	0	\N
217397	2133	9116384000	29305	14441	1	0	\N
217398	2132	7082096000	29305	14441	2	0	\N
217399	2134	12446071000	29305	14441	3	0	\N
217404	1397	1261132248000	29307	14442	0	0	\N
217409	1397	1261122247000	29310	14443	0	0	\N
217410	2134	12445067000	29310	14443	1	0	\N
217411	2133	9115382000	29310	14443	2	0	\N
217421	1397	1261082243000	29315	14446	0	0	\N
217422	2134	12442055000	29315	14446	1	0	\N
217423	2133	9111374000	29315	14446	2	0	\N
217433	1397	1261062241000	29319	14448	0	0	\N
217434	2133	9109370000	29319	14448	1	0	\N
217435	2134	12440047000	29319	14448	2	0	\N
217436	1397	1261052240000	29320	14449	0	0	\N
217437	2134	12440047000	29320	14449	1	0	\N
217438	2133	9108368000	29320	14449	2	0	\N
217446	1397	1261032238000	29323	14451	0	0	\N
217447	2134	12438039000	29323	14451	1	0	\N
217448	2133	9106364000	29323	14451	2	0	\N
217452	1397	1261032238000	29325	14451	0	0	\N
217453	2134	12438039000	29325	14451	1	0	\N
217454	2133	9106364000	29325	14451	2	0	\N
217457	1397	1261022237000	29327	14452	0	0	\N
217458	2133	9105362000	29327	14452	1	0	\N
217459	1397	1261022237000	29328	14452	0	0	\N
217460	2133	9105362000	29328	14452	1	0	\N
217334	2132	7085099000	29289	14433	2	0	1903
217335	2134	12454103000	29289	14433	3	0	7863
217336	2134	12453099000	29289	14433	4	0	7864
217337	2133	9127406000	29289	14433	5	0	7300
217338	2133	9126404000	29289	14433	6	0	7301
217340	2133	9125402000	29290	14434	1	0	7302
217349	1397	1261222257000	29294	14435	0	0	17760
217350	2133	9124400000	29294	14435	2	0	7303
217351	2134	12452095000	29294	14435	3	0	7865
217355	1397	1261212256000	29296	14436	0	0	17761
217357	2133	9123398000	29296	14436	2	0	7304
217358	2134	12451091000	29296	14436	3	0	7866
217359	1397	1261202255000	29297	14437	0	0	17762
217360	2133	9122396000	29297	14437	1	0	7305
217377	1397	1261192254000	29301	14438	0	0	17763
217378	1397	1261182253000	29301	14438	1	0	17764
217379	2133	9121394000	29301	14438	2	0	7306
217380	2134	12449083000	29301	14438	3	0	7868
217381	2133	9120392000	29301	14438	4	0	7307
217388	2133	9119390000	29303	14439	1	0	7308
217389	2134	12448079000	29303	14439	2	0	7869
217390	2132	7083097000	29303	14439	3	0	1905
217391	1397	1261162251000	29304	14440	0	0	17766
217392	1397	1261152250000	29304	14440	1	0	17767
217394	2133	9117386000	29304	14440	3	0	7310
217395	2134	12447075000	29304	14440	4	0	7870
217400	1397	1261142249000	29306	14441	0	0	17768
217401	2133	9116384000	29306	14441	1	0	7311
217403	2134	12446071000	29306	14441	3	0	7871
217405	1397	1261132248000	29308	14442	0	0	17769
217406	1397	1261122247000	29309	14443	0	0	17770
217407	2134	12445067000	29309	14443	1	0	7872
217408	2133	9115382000	29309	14443	2	0	7312
217413	1397	1261102245000	29311	14444	1	0	17772
217414	2133	9114380000	29311	14444	2	0	7313
217415	2132	7081095000	29311	14444	3	0	1907
217416	2133	9113378000	29311	14444	4	0	7314
217417	2134	12444063000	29311	14444	5	0	7873
217419	1397	1261092244000	29312	14445	0	0	17773
217420	2133	9112376000	29312	14445	1	0	7315
217424	1397	1261082243000	29316	14446	0	0	17774
217425	2134	12442055000	29316	14446	1	0	7875
217427	1397	1261072242000	29317	14447	0	0	17775
217428	2134	12441051000	29317	14447	1	0	7876
217429	2133	9110372000	29317	14447	2	0	7317
217430	2132	7080094000	29317	14447	3	0	1908
217431	1397	1261062241000	29318	14448	0	0	17776
217439	1397	1261052240000	29321	14449	0	0	17777
217440	2134	12440047000	29321	14449	1	0	7877
217441	2133	9108368000	29321	14449	2	0	7319
217442	1397	1261042239000	29322	14450	0	0	17778
217443	2132	7079093000	29322	14450	1	0	1909
217445	2134	12439043000	29322	14450	3	0	7878
217449	1397	1261032238000	29324	14451	0	0	17779
217450	2134	12438039000	29324	14451	1	0	7879
217451	2133	9106364000	29324	14451	2	0	7321
217456	2133	9105362000	29326	14452	1	0	7322
217461	1397	1261012236000	29329	14453	0	0	17781
217462	1397	1261002235000	29329	14453	1	0	17782
217463	2134	12437035000	29329	14453	2	0	7880
217464	2133	9104360000	29329	14453	3	0	7323
217473	1397	1261882323000	29331	14304	0	0	\N
217474	1397	1261872322000	29331	14304	1	0	\N
217475	1397	1261862321000	29331	14304	2	0	\N
217476	1397	1261852320000	29331	14304	3	0	\N
217477	1397	1261842319000	29331	14304	4	0	\N
217478	1397	1261832318000	29331	14304	5	0	\N
217479	1397	1261822317000	29331	14304	6	0	\N
217480	1397	1261812316000	29331	14304	7	0	\N
217481	1397	1261802315000	29331	14304	8	0	\N
217482	1397	1261792314000	29331	14304	9	0	\N
217483	1397	1261782313000	29331	14304	10	0	\N
217484	1397	1261772312000	29331	14304	11	0	\N
217485	1397	1261762311000	29331	14304	12	0	\N
217486	1397	1261752310000	29331	14304	13	0	\N
217487	1397	1261742309000	29331	14304	14	0	\N
217488	1397	1261732308000	29331	14304	15	0	\N
217489	1397	1261722307000	29331	14304	16	0	\N
217490	1397	1261712306000	29331	14304	17	0	\N
217491	1397	1261702305000	29331	14304	18	0	\N
217492	1397	1261692304000	29331	14304	19	0	\N
217493	1397	1261682303000	29331	14304	20	0	\N
217494	1397	1261672302000	29331	14304	21	0	\N
217495	1397	1261662301000	29331	14304	22	0	\N
217496	1397	1261652300000	29331	14304	23	0	\N
217497	1397	1261642299000	29331	14304	24	0	\N
217498	1397	1261632298000	29331	14304	25	0	\N
217499	1397	1261622297000	29331	14304	26	0	\N
217500	1397	1261612296000	29331	14304	27	0	\N
217501	1397	1261602295000	29331	14304	28	0	\N
217502	1397	1261592294000	29331	14304	29	0	\N
217503	1397	1261582293000	29331	14304	30	0	\N
217504	1397	1261572292000	29331	14304	31	0	\N
217505	1397	1261562291000	29331	14304	32	0	\N
217506	1397	1261552290000	29331	14304	33	0	\N
217507	1397	1261542289000	29331	14304	34	0	\N
217508	1397	1261532288000	29331	14304	35	0	\N
217509	1397	1261522287000	29331	14304	36	0	\N
217510	1397	1261512286000	29331	14304	37	0	\N
217511	1397	1261502285000	29331	14304	38	0	\N
217512	1397	1261492284000	29331	14304	39	0	\N
217513	1397	1261482283000	29331	14304	40	0	\N
217514	1397	1261472282000	29331	14304	41	0	\N
217515	1397	1261462281000	29331	14304	42	0	\N
217516	1397	1261452280000	29331	14304	43	0	\N
217517	1397	1261442279000	29331	14304	44	0	\N
217518	1397	1261432278000	29331	14304	45	0	\N
217519	1397	1261422277000	29331	14304	46	0	\N
217520	1397	1261412276000	29331	14304	47	0	\N
217521	1397	1261402275000	29331	14304	48	0	\N
217522	1397	1261392274000	29331	14304	49	0	\N
217523	1397	1261382273000	29331	14304	50	0	\N
217524	1397	1261372272000	29331	14304	51	0	\N
217525	1397	1261362271000	29331	14304	52	0	\N
217526	1397	1261352270000	29331	14304	53	0	\N
217527	1397	1261342269000	29331	14304	54	0	\N
217528	1397	1261332268000	29331	14304	55	0	\N
217529	1397	1261322267000	29331	14304	56	0	\N
217530	1397	1261312266000	29331	14304	57	0	\N
217531	1397	1261302265000	29331	14304	58	0	\N
217532	1397	1261292264000	29331	14304	59	0	\N
217533	1397	1261282263000	29331	14304	60	0	\N
217534	1397	1261272262000	29331	14304	61	0	\N
217535	1397	1261262261000	29331	14304	62	0	\N
217536	1397	1261252260000	29331	14304	63	0	\N
217537	1397	1261242259000	29331	14304	65	0	\N
217538	1397	1261232258000	29331	14304	66	0	\N
217539	1397	1261222257000	29331	14304	67	0	\N
217540	1397	1261212256000	29331	14304	68	0	\N
217541	1397	1261202255000	29331	14304	69	0	\N
217542	1397	1261192254000	29331	14304	70	0	\N
217543	1397	1261182253000	29331	14304	71	0	\N
217544	1397	1261172252000	29331	14304	72	0	\N
217545	1397	1261162251000	29331	14304	73	0	\N
217546	1397	1261152250000	29331	14304	74	0	\N
217547	1397	1261142249000	29331	14304	75	0	\N
217548	1397	1261132248000	29331	14304	76	0	\N
217549	1397	1261122247000	29331	14304	77	0	\N
217550	1397	1261112246000	29331	14304	78	0	\N
217551	1397	1261102245000	29331	14304	79	0	\N
217552	1397	1261092244000	29331	14304	80	0	\N
217553	1397	1261082243000	29331	14304	81	0	\N
217554	1397	1261072242000	29331	14304	82	0	\N
217555	1397	1261062241000	29331	14304	83	0	\N
217556	1397	1261052240000	29331	14304	84	0	\N
217557	1397	1261042239000	29331	14304	85	0	\N
217558	1397	1261032238000	29331	14304	86	0	\N
217559	1397	1261022237000	29331	14304	87	0	\N
217560	1397	1261012236000	29331	14304	88	0	\N
217561	1397	1261002235000	29331	14304	89	0	\N
217562	1397	1260992234000	29331	14304	90	0	\N
217563	1726	120825112000	29331	14304	91	0	\N
217564	2133	9310772000	29331	14304	92	0	\N
217565	2133	9309770000	29331	14304	93	0	\N
217566	2133	9308768000	29331	14304	94	0	\N
217567	2132	7133147000	29331	14304	95	0	\N
217568	2132	7132146000	29331	14304	96	0	\N
217569	2133	9307766000	29331	14304	97	0	\N
217570	2132	7131145000	29331	14304	98	0	\N
217571	338	66010022000000	29331	14304	99	0	\N
217572	1419	29085321559748	29331	14304	100	0	\N
217573	1419	29084320559748	29331	14304	101	0	\N
217574	2132	7130144000	29331	14304	102	0	\N
217575	2134	12588639000	29331	14304	103	0	\N
217576	2134	12587635000	29331	14304	104	0	\N
217577	2134	12586631000	29331	14304	105	0	\N
217578	2134	12585627000	29331	14304	106	0	\N
217579	2134	12584623000	29331	14304	107	0	\N
217580	2134	12583619000	29331	14304	108	0	\N
217581	2134	12582615000	29331	14304	109	0	\N
217582	2134	12581611000	29331	14304	110	0	\N
217583	2134	12580607000	29331	14304	111	0	\N
217584	2134	12579603000	29331	14304	112	0	\N
217585	2134	12578599000	29331	14304	113	0	\N
217586	2134	12577595000	29331	14304	114	0	\N
217587	2134	12576591000	29331	14304	115	0	\N
217588	2134	12575587000	29331	14304	116	0	\N
217589	2134	12574583000	29331	14304	117	0	\N
217590	2132	7129143000	29331	14304	118	0	\N
217591	2132	7128142000	29331	14304	119	0	\N
217592	2132	7127141000	29331	14304	120	0	\N
217593	2132	7126140000	29331	14304	121	0	\N
217594	2132	7125139000	29331	14304	122	0	\N
217595	2132	7124138000	29331	14304	123	0	\N
217596	2132	7123137000	29331	14304	124	0	\N
217597	2132	7122136000	29331	14304	125	0	\N
217467	2132	7078092000	29329	14453	6	0	1910
217468	1397	1260992234000	29330	14454	0	0	17783
217469	2133	9102356000	29330	14454	1	0	7325
217470	1419	29805332559748	29330	14454	2	0	9
217471	1419	29804331559748	29330	14454	3	0	10
217598	1397	1260982233000	29332	14455	0	0	17784
217599	1576	10000000	29332	14455	1	0	1
217600	2133	9101354000	29332	14455	2	0	7326
217601	1397	1260982233000	29333	14455	0	0	\N
217602	1576	10000000	29333	14455	1	0	\N
217603	2133	9101354000	29333	14455	2	0	\N
217604	1397	1260982233000	29334	14455	0	0	\N
217605	1576	10000000	29334	14455	1	0	\N
217606	2133	9101354000	29334	14455	2	0	\N
217611	1397	1260972232000	29336	14456	0	0	\N
217612	2132	7077091000	29336	14456	1	0	\N
217613	2134	12434023000	29336	14456	2	0	\N
217614	2133	9100352000	29336	14456	3	0	\N
217625	1397	1260942229000	29339	14458	0	0	\N
217626	2133	9097346000	29339	14458	1	0	\N
217627	2134	12432015000	29339	14458	2	0	\N
217628	2132	7076090000	29339	14458	3	0	\N
217635	1397	1260912226000	29342	14461	0	0	\N
217636	1397	1260902225000	29342	14461	1	0	\N
217637	2134	12429003000	29342	14461	2	0	\N
217638	2133	9094340000	29342	14461	3	0	\N
217639	2133	9093338000	29342	14461	4	0	\N
217640	2132	7075089000	29342	14461	5	0	\N
217647	1397	1260912226000	29344	14461	0	0	\N
217648	1397	1260902225000	29344	14461	1	0	\N
217649	2134	12429003000	29344	14461	2	0	\N
217650	2133	9094340000	29344	14461	3	0	\N
217651	2133	9093338000	29344	14461	4	0	\N
217652	2132	7075089000	29344	14461	5	0	\N
217659	1397	1260882223000	29347	14463	0	0	\N
217660	2134	12426995000	29347	14463	1	0	\N
217661	2133	9091334000	29347	14463	2	0	\N
217671	1397	1260862221000	29350	14465	0	0	\N
217672	1397	1260852220000	29350	14465	1	0	\N
217673	2134	12425991000	29350	14465	2	0	\N
217674	2134	12424987000	29350	14465	3	0	\N
217675	2133	9089330000	29350	14465	4	0	\N
217676	2133	9088328000	29350	14465	5	0	\N
217677	1397	1260842219000	29351	14466	0	0	\N
217678	1397	1260832218000	29351	14466	1	0	\N
217679	2132	7073087000	29351	14466	2	0	\N
217680	2133	9087326000	29351	14466	3	0	\N
217681	2133	9086324000	29351	14466	4	0	\N
217682	2134	12423983000	29351	14466	5	0	\N
217692	1397	1260822217000	29354	14467	0	0	\N
217693	2133	9085322000	29354	14467	1	0	\N
217694	2134	12422979000	29354	14467	2	0	\N
217695	1397	1260812216000	29355	14468	0	0	\N
217696	2133	9084320000	29355	14468	1	0	\N
217697	2132	7072086000	29355	14468	2	0	\N
217698	2134	12421975000	29355	14468	3	0	\N
217703	1397	1260812216000	29357	14468	0	0	\N
217704	2133	9084320000	29357	14468	1	0	\N
217705	2132	7072086000	29357	14468	2	0	\N
217706	2134	12421975000	29357	14468	3	0	\N
217707	1397	1260802215000	29358	14469	0	0	\N
217708	2133	9083318000	29358	14469	1	0	\N
217711	1397	1260792214000	29361	14470	0	0	\N
217712	2133	9082316000	29361	14470	1	0	\N
217713	2134	12420971000	29361	14470	2	0	\N
217726	1397	1260762211000	29366	14473	0	0	\N
217727	2133	9079310000	29366	14473	1	0	\N
217728	2134	12418963000	29366	14473	2	0	\N
217732	1397	1260742209000	29368	14475	0	0	\N
217733	2132	7070084000	29368	14475	1	0	\N
217734	2133	9077306000	29368	14475	2	0	\N
217609	2134	12434023000	29335	14456	2	0	7883
217610	2133	9100352000	29335	14456	3	0	7327
217615	1397	1260962231000	29337	14457	0	0	17786
217616	1397	1260952230000	29337	14457	1	0	17787
217617	1659	94999990	29337	14457	2	0	2
217619	2133	9098348000	29337	14457	5	0	7329
217620	2134	12433019000	29337	14457	6	0	7884
217621	1397	1260942229000	29338	14458	0	0	17788
217622	2133	9097346000	29338	14458	1	0	7330
217623	2134	12432015000	29338	14458	2	0	7885
217629	1397	1260932228000	29340	14459	0	0	17789
217630	2133	9096344000	29340	14459	1	0	7331
217631	2134	12431011000	29340	14459	2	0	7886
217632	1397	1260922227000	29341	14460	0	0	17790
217634	2133	9095342000	29341	14460	2	0	7332
217641	1397	1260912226000	29343	14461	0	0	17791
217642	1397	1260902225000	29343	14461	1	0	17792
217643	2134	12429003000	29343	14461	2	0	7888
217644	2133	9094340000	29343	14461	3	0	7333
217646	2132	7075089000	29343	14461	5	0	1913
217653	1397	1260892224000	29345	14462	0	0	17793
217654	2133	9092336000	29345	14462	1	0	7335
217655	2134	12427999000	29345	14462	2	0	7889
217656	1397	1260882223000	29346	14463	0	0	17794
217658	2133	9091334000	29346	14463	2	0	7336
217662	1397	1260872222000	29348	14464	0	0	17795
217663	2133	9090332000	29348	14464	1	0	7337
217664	2132	7074088000	29348	14464	2	0	1914
217666	1397	1260852220000	29349	14465	1	0	17797
217667	2134	12425991000	29349	14465	2	0	7891
217668	2134	12424987000	29349	14465	3	0	7892
217669	2133	9089330000	29349	14465	4	0	7338
217670	2133	9088328000	29349	14465	5	0	7339
217684	1397	1260832218000	29352	14466	1	0	17799
217685	2132	7073087000	29352	14466	2	0	1915
217686	2133	9087326000	29352	14466	3	0	7340
217687	2133	9086324000	29352	14466	4	0	7341
217688	2134	12423983000	29352	14466	5	0	7893
217690	2133	9085322000	29353	14467	1	0	7342
217691	2134	12422979000	29353	14467	2	0	7894
217699	1397	1260812216000	29356	14468	0	0	17801
217700	2133	9084320000	29356	14468	1	0	7343
217702	2134	12421975000	29356	14468	3	0	7895
217709	1397	1260802215000	29359	14469	0	0	17802
217710	2133	9083318000	29359	14469	1	0	7344
217714	1397	1260792214000	29362	14470	0	0	17803
217715	2133	9082316000	29362	14470	1	0	7345
217717	1397	1260782213000	29363	14471	0	0	17804
217718	2134	12419967000	29363	14471	1	0	7897
217719	2133	9081314000	29363	14471	2	0	7346
217720	1397	1260772212000	29364	14472	0	0	17805
217721	2132	7071085000	29364	14472	1	0	1917
217723	1397	1260762211000	29365	14473	0	0	17806
217724	2133	9079310000	29365	14473	1	0	7348
217725	2134	12418963000	29365	14473	2	0	7898
217729	1397	1260752210000	29367	14474	0	0	17807
217731	2134	12417959000	29367	14474	2	0	7899
217735	1397	1260742209000	29369	14475	0	0	17808
217736	2132	7070084000	29369	14475	1	0	1918
217741	1397	1260732208000	29371	14476	0	0	\N
217742	2134	12416955000	29371	14476	1	0	\N
217743	2133	9076304000	29371	14476	2	0	\N
217755	1397	1260682203000	29376	14481	0	0	\N
217756	1397	1260672202000	29376	14481	1	0	\N
217757	1397	1260662201000	29376	14481	2	0	\N
217758	2133	9072296000	29376	14481	3	0	\N
217759	2133	9071294000	29376	14481	4	0	\N
217760	2132	7068082000	29376	14481	5	0	\N
217761	2133	9070292000	29376	14481	6	0	\N
217762	2134	12412939000	29376	14481	7	0	\N
217763	2134	12411935000	29376	14481	8	0	\N
217773	1397	1260682203000	29378	14481	0	0	\N
217774	1397	1260672202000	29378	14481	1	0	\N
217775	1397	1260662201000	29378	14481	2	0	\N
217776	2133	9072296000	29378	14481	3	0	\N
217777	2133	9071294000	29378	14481	4	0	\N
217778	2132	7068082000	29378	14481	5	0	\N
217779	2133	9070292000	29378	14481	6	0	\N
217780	2134	12412939000	29378	14481	7	0	\N
217781	2134	12411935000	29378	14481	8	0	\N
217794	1397	1260622197000	29383	14485	0	0	\N
217795	2133	9066284000	29383	14485	1	0	\N
217796	2134	12408923000	29383	14485	2	0	\N
217818	1397	1260582193000	29387	14488	0	0	\N
217819	1397	1260572192000	29387	14488	1	0	\N
217820	1397	1260562191000	29387	14488	2	0	\N
217821	2132	7065079000	29387	14488	3	0	\N
217822	2134	12405911000	29387	14488	4	0	\N
217823	1680	18732463499559	29387	14488	5	0	\N
217824	2133	9062276000	29387	14488	6	0	\N
217825	2133	9061274000	29387	14488	7	0	\N
217826	2133	9060272000	29387	14488	8	0	\N
217827	2133	9059270000	29387	14488	9	0	\N
217828	2134	12404907000	29387	14488	10	0	\N
217829	2134	12403903000	29387	14488	11	0	\N
217830	1397	1260582193000	29388	14488	0	0	\N
217831	1397	1260572192000	29388	14488	1	0	\N
217832	1397	1260562191000	29388	14488	2	0	\N
217833	2132	7065079000	29388	14488	3	0	\N
217834	2134	12405911000	29388	14488	4	0	\N
217835	1680	18732463499559	29388	14488	5	0	\N
217836	2134	12404907000	29388	14488	6	0	\N
217837	2134	12403903000	29388	14488	7	0	\N
217846	1397	1261312266000	29391	14406	0	0	\N
217847	1397	1261302265000	29391	14406	1	0	\N
217848	1397	1261292264000	29391	14406	2	0	\N
217849	1397	1261282263000	29391	14406	3	0	\N
217850	1397	1261272262000	29391	14406	4	0	\N
217851	1397	1261262261000	29391	14406	5	0	\N
217852	1397	1261252260000	29391	14406	6	0	\N
217853	1397	1261242259000	29391	14406	7	0	\N
217854	1397	1261232258000	29391	14406	8	0	\N
217855	1397	1261222257000	29391	14406	9	0	\N
217856	1397	1261212256000	29391	14406	10	0	\N
217857	1397	1261202255000	29391	14406	11	0	\N
217858	1397	1261192254000	29391	14406	12	0	\N
217859	1397	1261182253000	29391	14406	13	0	\N
217860	1397	1261172252000	29391	14406	14	0	\N
217861	1397	1261162251000	29391	14406	15	0	\N
217862	1397	1261152250000	29391	14406	16	0	\N
217863	1397	1261142249000	29391	14406	17	0	\N
217864	1397	1261132248000	29391	14406	18	0	\N
217865	1397	1261122247000	29391	14406	19	0	\N
217866	1397	1261112246000	29391	14406	20	0	\N
217867	1397	1261102245000	29391	14406	21	0	\N
217868	1397	1261092244000	29391	14406	22	0	\N
217869	1397	1261082243000	29391	14406	23	0	\N
217870	1397	1261072242000	29391	14406	24	0	\N
217871	1397	1261062241000	29391	14406	25	0	\N
217872	1397	1261052240000	29391	14406	26	0	\N
217739	2134	12416955000	29370	14476	1	0	7900
217740	2133	9076304000	29370	14476	2	0	7351
217744	1397	1260722207000	29372	14477	0	0	17810
217745	2134	12415951000	29372	14477	1	0	7901
217746	2133	9075302000	29372	14477	2	0	7352
217748	2134	12414947000	29373	14478	1	0	7902
217749	2132	7069083000	29373	14478	2	0	1919
217750	1397	1260702205000	29374	14479	0	0	17812
217751	1397	1260692204000	29374	14479	1	0	17813
217752	2133	9074300000	29374	14479	2	0	7353
217754	2133	9073298000	29374	14479	4	0	7354
217764	1397	1260682203000	29377	14481	0	0	17814
217765	1397	1260672202000	29377	14481	1	0	17815
217766	1397	1260662201000	29377	14481	2	0	17816
217768	2133	9071294000	29377	14481	4	0	7356
217769	2132	7068082000	29377	14481	5	0	1920
217770	2133	9070292000	29377	14481	6	0	7357
217771	2134	12412939000	29377	14481	7	0	7904
217772	2134	12411935000	29377	14481	8	0	7905
217783	2134	12410931000	29379	14482	1	0	7906
217784	2133	9069290000	29379	14482	2	0	7358
217785	1397	1260642199000	29380	14483	0	0	17818
217786	2133	9068288000	29380	14483	1	0	7359
217787	2134	12409927000	29380	14483	2	0	7907
217789	1397	1260632198000	29381	14484	0	0	17819
217790	2133	9067286000	29381	14484	1	0	7360
217791	1397	1260622197000	29382	14485	0	0	17820
217792	2133	9066284000	29382	14485	1	0	7361
217797	1397	1260612196000	29384	14486	0	0	17821
217798	1397	1260602195000	29384	14486	1	0	17822
217799	2132	7066080000	29384	14486	2	0	1922
217800	2133	9065282000	29384	14486	3	0	7362
217801	2133	9064280000	29384	14486	4	0	7363
217803	2134	12406915000	29384	14486	6	0	7910
217804	1397	1260592194000	29385	14487	0	0	17823
217805	2133	9063278000	29385	14487	1	0	7364
217806	1397	1260582193000	29386	14488	0	0	17824
217807	1397	1260572192000	29386	14488	1	0	17825
217809	2132	7065079000	29386	14488	3	0	1923
217810	2134	12405911000	29386	14488	4	0	7911
217811	1680	18732463499559	29386	14488	5	0	13
217812	2133	9062276000	29386	14488	6	0	7365
217814	2133	9060272000	29386	14488	8	0	7367
217815	2133	9059270000	29386	14488	9	0	7368
217816	2134	12404907000	29386	14488	10	0	7912
217817	2134	12403903000	29386	14488	11	0	7913
217838	1397	1260552190000	29389	14489	0	0	17827
217840	2133	9058268000	29389	14489	2	0	7369
217841	2134	12402899000	29389	14489	3	0	7914
217842	1397	1260542189000	29390	14490	0	0	17828
217843	80	66000499000000	29390	14490	1	0	1
217844	2134	12401895000	29390	14490	2	0	7915
217873	1397	1261042239000	29391	14406	27	0	\N
217874	1397	1261032238000	29391	14406	28	0	\N
217875	1397	1261022237000	29391	14406	29	0	\N
217876	1397	1261012236000	29391	14406	30	0	\N
217877	1397	1261002235000	29391	14406	31	0	\N
217878	1397	1260992234000	29391	14406	32	0	\N
217879	1397	1260982233000	29391	14406	33	0	\N
217880	1397	1260972232000	29391	14406	34	0	\N
217881	1397	1260962231000	29391	14406	35	0	\N
217882	1397	1260952230000	29391	14406	36	0	\N
217883	1397	1260942229000	29391	14406	37	0	\N
217884	1397	1260932228000	29391	14406	38	0	\N
217885	1397	1260922227000	29391	14406	39	0	\N
217886	1397	1260912226000	29391	14406	40	0	\N
217887	1397	1260902225000	29391	14406	41	0	\N
217888	1397	1260892224000	29391	14406	42	0	\N
217889	1397	1260882223000	29391	14406	43	0	\N
217890	1397	1260872222000	29391	14406	44	0	\N
217891	1397	1260862221000	29391	14406	45	0	\N
217892	1397	1260852220000	29391	14406	46	0	\N
217893	1397	1260842219000	29391	14406	47	0	\N
217894	1397	1260832218000	29391	14406	48	0	\N
217895	1397	1260822217000	29391	14406	49	0	\N
217896	1397	1260812216000	29391	14406	50	0	\N
217897	1397	1260802215000	29391	14406	51	0	\N
217898	1397	1260792214000	29391	14406	52	0	\N
217899	1397	1260782213000	29391	14406	53	0	\N
217900	1397	1260772212000	29391	14406	54	0	\N
217901	1397	1260762211000	29391	14406	55	0	\N
217902	1397	1260752210000	29391	14406	56	0	\N
217903	1397	1260742209000	29391	14406	57	0	\N
217904	1397	1260732208000	29391	14406	58	0	\N
217905	1397	1260722207000	29391	14406	59	0	\N
217906	1397	1260712206000	29391	14406	60	0	\N
217907	1397	1260702205000	29391	14406	61	0	\N
217908	1397	1260692204000	29391	14406	62	0	\N
217909	1397	1260682203000	29391	14406	63	0	\N
217910	1397	1260672202000	29391	14406	64	0	\N
217911	1397	1260662201000	29391	14406	65	0	\N
217912	1397	1260652200000	29391	14406	66	0	\N
217913	1397	1260642199000	29391	14406	67	0	\N
217914	1397	1260632198000	29391	14406	68	0	\N
217915	1397	1260622197000	29391	14406	69	0	\N
217916	1397	1260612196000	29391	14406	70	0	\N
217917	1397	1260602195000	29391	14406	71	0	\N
217918	1397	1260592194000	29391	14406	72	0	\N
217919	1397	1260582193000	29391	14406	73	0	\N
217920	1397	1260572192000	29391	14406	74	0	\N
217921	1397	1260562191000	29391	14406	75	0	\N
217922	1397	1260552190000	29391	14406	76	0	\N
217923	1397	1260542189000	29391	14406	77	0	\N
217924	1726	120825112000	29391	14406	78	0	\N
217925	1659	94999990	29391	14406	79	0	\N
217926	2133	9133418000	29391	14406	80	0	\N
217927	1576	10000000	29391	14406	81	0	\N
217928	2132	7087101000	29391	14406	82	0	\N
217929	2132	7086100000	29391	14406	83	0	\N
217930	1680	18012449499559	29391	14406	84	0	\N
217931	2133	9132416000	29391	14406	85	0	\N
217932	2133	9131414000	29391	14406	87	0	\N
217933	2132	7085099000	29391	14406	88	0	\N
217934	2132	7084098000	29391	14406	89	0	\N
217935	2132	7083097000	29391	14406	90	0	\N
217936	2132	7082096000	29391	14406	91	0	\N
217937	1419	29805332559748	29391	14406	92	0	\N
217938	1419	29804331559748	29391	14406	93	0	\N
217939	2132	7081095000	29391	14406	94	0	\N
217940	2134	12458119000	29391	14406	95	0	\N
217941	2134	12457115000	29391	14406	96	0	\N
217942	2134	12456111000	29391	14406	97	0	\N
217943	2132	7080094000	29391	14406	98	0	\N
217944	2132	7079093000	29391	14406	99	0	\N
217945	2132	7078092000	29391	14406	100	0	\N
217946	2132	7077091000	29391	14406	101	0	\N
217947	2132	7076090000	29391	14406	102	0	\N
217948	2132	7075089000	29391	14406	103	0	\N
217949	2132	7074088000	29391	14406	104	0	\N
217950	2132	7073087000	29391	14406	105	0	\N
217951	2132	7072086000	29391	14406	106	0	\N
217952	2132	7071085000	29391	14406	107	0	\N
217953	2132	7070084000	29391	14406	108	0	\N
217954	2132	7069083000	29391	14406	109	0	\N
217955	2132	7068082000	29391	14406	110	0	\N
217956	2132	7067081000	29391	14406	111	0	\N
217957	2132	7066080000	29391	14406	112	0	\N
217958	2132	7065079000	29391	14406	113	0	\N
217959	2132	7064078000	29391	14406	114	0	\N
217960	2134	12455107000	29391	14406	115	0	\N
217961	2134	12454103000	29391	14406	116	0	\N
217962	2134	12453099000	29391	14406	117	0	\N
217963	2134	12452095000	29391	14406	118	0	\N
217964	2134	12451091000	29391	14406	119	0	\N
217965	2134	12450087000	29391	14406	120	0	\N
217966	2134	12449083000	29391	14406	121	0	\N
217967	2134	12448079000	29391	14406	122	0	\N
217968	2134	12447075000	29391	14406	123	0	\N
217969	2134	12446071000	29391	14406	124	0	\N
217970	2134	12445067000	29391	14406	125	0	\N
217973	1397	1260532188000	29393	14491	0	0	\N
217974	2133	9056264000	29393	14491	1	0	\N
217975	1397	1260522187000	29394	14492	0	0	\N
217976	2132	7063077000	29394	14492	1	0	\N
217977	2133	9055262000	29394	14492	2	0	\N
217978	599	67439023000000	29394	14492	3	0	\N
217979	2134	12400891000	29394	14492	4	0	\N
217988	1397	1260502185000	29397	14494	0	0	\N
217989	2134	12398883000	29397	14494	1	0	\N
217990	2133	9053258000	29397	14494	2	0	\N
217991	1397	1260502185000	29398	14494	0	0	\N
217992	2134	12398883000	29398	14494	1	0	\N
217993	2133	9053258000	29398	14494	2	0	\N
218007	1397	1260462181000	29402	14497	0	0	\N
218008	2133	9049250000	29402	14497	1	0	\N
217980	1397	1260522187000	29395	14492	0	0	17830
217981	2132	7063077000	29395	14492	1	0	1925
217982	2133	9055262000	29395	14492	2	0	7372
217983	599	67439023000000	29395	14492	3	0	1
217984	2134	12400891000	29395	14492	4	0	7916
217986	2134	12399887000	29396	14493	1	0	7917
217987	2133	9054260000	29396	14493	2	0	7373
217994	1397	1260502185000	29399	14494	0	0	17832
217995	2134	12398883000	29399	14494	1	0	7918
217996	2133	9053258000	29399	14494	2	0	7374
217998	1397	1260482183000	29400	14495	1	0	17834
217999	2133	9052256000	29400	14495	2	0	7375
218000	2133	9051254000	29400	14495	3	0	7376
218001	2134	12397879000	29400	14495	4	0	7919
218003	1397	1260472182000	29401	14496	0	0	17835
218004	2134	12396875000	29401	14496	1	0	7920
218005	584	66209425788612	29401	14496	2	0	1
218006	2133	9050252000	29401	14496	3	0	7377
218010	1397	1260462181000	29404	14498	0	0	\N
218011	1397	1260452180000	29404	14498	1	0	\N
218012	2134	12395871000	29404	14498	2	0	\N
218013	2132	7061075000	29404	14498	3	0	\N
218014	2133	9048248000	29404	14498	4	0	\N
218015	1397	1260542189000	29405	14490	0	0	\N
218016	1397	1260532188000	29405	14490	1	0	\N
218017	1397	1260522187000	29405	14490	2	0	\N
218018	1397	1260512186000	29405	14490	3	0	\N
218019	1397	1260502185000	29405	14490	4	0	\N
218020	1397	1260492184000	29405	14490	5	0	\N
218021	1397	1260482183000	29405	14490	6	0	\N
218022	1397	1260472182000	29405	14490	7	0	\N
218023	1397	1260462181000	29405	14490	8	0	\N
218024	1397	1260452180000	29405	14490	9	0	\N
218025	2132	7063077000	29405	14490	10	0	\N
218026	599	67439023000000	29405	14490	11	0	\N
218027	584	66209425788612	29405	14490	12	0	\N
218028	2132	7062076000	29405	14490	13	0	\N
218029	2132	7061075000	29405	14490	14	0	\N
218030	80	66000499000000	29405	14490	15	0	\N
218031	2134	12401895000	29405	14490	16	0	\N
218032	2134	12400891000	29405	14490	17	0	\N
218033	2134	12399887000	29405	14490	18	0	\N
218034	2134	12398883000	29405	14490	19	0	\N
218035	2134	12397879000	29405	14490	20	0	\N
218036	2134	12396875000	29405	14490	21	0	\N
218037	2134	12395871000	29405	14490	22	0	\N
218038	2133	9057266000	29405	14490	23	0	\N
218039	2133	9056264000	29405	14490	24	0	\N
218040	2133	9055262000	29405	14490	25	0	\N
218041	2133	9054260000	29405	14490	26	0	\N
218042	2133	9053258000	29405	14490	27	0	\N
218043	2133	9052256000	29405	14490	28	0	\N
218044	2133	9051254000	29405	14490	29	0	\N
218045	2133	9050252000	29405	14490	30	0	\N
218046	2133	9049250000	29405	14490	31	0	\N
218047	2133	9048248000	29405	14490	32	0	\N
218056	1397	1260432178000	29408	14500	0	0	\N
218057	2133	9046244000	29408	14500	1	0	\N
218058	584	66000000000000	29408	14500	2	0	\N
218059	2134	12393863000	29408	14500	3	0	\N
218064	1397	1260422177000	29410	14501	0	0	\N
218065	1397	1260412176000	29410	14501	2	0	\N
218066	1397	1260402175000	29410	14501	3	0	\N
218067	2134	12392859000	29410	14501	4	0	\N
218068	2132	7060074000	29410	14501	5	0	\N
218069	2134	12391855000	29410	14501	6	0	\N
218070	2133	9045242000	29410	14501	7	0	\N
218071	2133	9044240000	29410	14501	8	0	\N
218072	2133	9043238000	29410	14501	9	0	\N
218082	511	66544310726895	29413	14310	0	0	\N
218083	1726	120825112000	29413	14310	1	0	\N
218084	1659	94999990	29413	14310	2	0	\N
218085	599	67439023000000	29413	14310	3	0	\N
218086	584	66209425788612	29413	14310	4	0	\N
218087	584	66000000000000	29413	14310	5	0	\N
218088	1680	17292437499559	29413	14310	6	0	\N
218089	1419	29085321559748	29413	14310	7	0	\N
218090	1419	29084320559748	29413	14310	8	0	\N
218091	511	66544310726895	29414	14502	0	0	\N
218092	1397	1260392174000	29414	14502	1	0	\N
218093	1397	1260382173000	29414	14502	2	0	\N
218094	1397	1260372172000	29414	14502	3	0	\N
218095	2132	7059073000	29414	14502	4	0	\N
218096	2134	12390851000	29414	14502	5	0	\N
218097	2134	12389847000	29414	14502	6	0	\N
218098	2133	9042236000	29414	14502	7	0	\N
218099	2005	0	29414	14502	8	0	\N
218100	2133	9041234000	29414	14502	9	0	\N
218101	2133	9040232000	29414	14502	10	0	\N
218113	1397	1260362171000	29416	14503	0	0	\N
218114	2134	12388843000	29416	14503	1	0	\N
218115	2133	9039230000	29416	14503	2	0	\N
218117	1397	1260352170000	29418	14504	0	0	\N
218118	2134	12388843000	29418	14504	1	0	\N
218119	2133	9039230000	29418	14504	2	0	\N
218120	2132	7058072000	29418	14504	3	0	\N
218125	1397	1260352170000	29420	14504	0	0	\N
218126	2134	12388843000	29420	14504	1	0	\N
218127	2133	9039230000	29420	14504	2	0	\N
218128	2132	7058072000	29420	14504	3	0	\N
218132	612	66543000726895	29422	14506	0	0	\N
218133	1397	1260332168000	29422	14506	1	0	\N
218134	2134	12386835000	29422	14506	2	0	\N
218135	2133	9037226000	29422	14506	3	0	\N
218136	612	66543000726895	29423	14506	0	0	\N
218137	1397	1260332168000	29423	14506	1	0	\N
218138	2134	12386835000	29423	14506	2	0	\N
218139	2133	9037226000	29423	14506	3	0	\N
218049	1397	1260452180000	29406	14498	1	0	17837
218050	2134	12395871000	29406	14498	2	0	7921
218051	2132	7061075000	29406	14498	3	0	1927
218052	2133	9048248000	29406	14498	4	0	7379
218053	1397	1260442179000	29407	14499	0	0	17838
218055	2133	9047246000	29407	14499	2	0	7380
218060	1397	1260432178000	29409	14500	0	0	17839
218061	2133	9046244000	29409	14500	1	0	7381
218062	584	66000000000000	29409	14500	2	0	2
218063	2134	12393863000	29409	14500	3	0	7923
218074	1397	1260412176000	29411	14501	2	0	17841
218075	1397	1260402175000	29411	14501	3	0	17842
218076	2134	12392859000	29411	14501	4	0	7924
218077	2132	7060074000	29411	14501	5	0	1928
218079	2133	9045242000	29411	14501	7	0	7382
218080	2133	9044240000	29411	14501	8	0	7383
218081	2133	9043238000	29411	14501	9	0	7384
218102	511	66544310726895	29415	14502	0	0	1
218103	1397	1260392174000	29415	14502	1	0	17843
218105	1397	1260372172000	29415	14502	3	0	17845
218106	2132	7059073000	29415	14502	4	0	1929
218107	2134	12390851000	29415	14502	5	0	7926
218108	2134	12389847000	29415	14502	6	0	7927
218109	2133	9042236000	29415	14502	7	0	7385
218111	2133	9041234000	29415	14502	9	0	7386
218112	2133	9040232000	29415	14502	10	0	7387
218116	1397	1260362171000	29417	14503	0	0	17846
218121	1397	1260352170000	29419	14504	0	0	17847
218123	2133	9039230000	29419	14504	2	0	7388
218124	2132	7058072000	29419	14504	3	0	1930
218129	1397	1260342169000	29421	14505	0	0	17848
218130	2134	12387839000	29421	14505	1	0	7929
218131	2133	9038228000	29421	14505	2	0	7389
218141	1397	1260332168000	29424	14506	1	0	17849
218142	2134	12386835000	29424	14506	2	0	7930
218143	2133	9037226000	29424	14506	3	0	7390
218144	612	66542980726895	29425	14507	0	0	2
218158	1397	1260302165000	29428	14509	0	0	\N
218159	1776	2132902366625	29428	14509	1	0	\N
218160	2133	9034220000	29428	14509	2	0	\N
218161	2134	12384827000	29428	14509	3	0	\N
218162	1397	1260292164000	29429	14510	0	0	\N
218163	2133	9033218000	29429	14510	1	0	\N
218164	2134	12383823000	29429	14510	2	0	\N
218165	1397	1260292164000	29430	14510	0	0	\N
218166	2133	9033218000	29430	14510	1	0	\N
218167	2134	12383823000	29430	14510	2	0	\N
218171	1397	1260292164000	29432	14510	0	0	\N
218172	2133	9033218000	29432	14510	1	0	\N
218173	2134	12383823000	29432	14510	2	0	\N
218174	1397	1260292164000	29433	14510	0	0	\N
218175	2133	9033218000	29433	14510	1	0	\N
218176	2134	12383823000	29433	14510	2	0	\N
218177	1397	1260292164000	29434	14510	0	0	\N
218178	2133	9033218000	29434	14510	1	0	\N
218179	2134	12383823000	29434	14510	2	0	\N
218197	1397	1260232158000	29440	14516	0	0	\N
218198	1397	1260222157000	29440	14516	1	0	\N
218199	1397	1260212156000	29440	14516	2	0	\N
218200	1397	1260202155000	29440	14516	3	0	\N
218201	2134	12379807000	29440	14516	4	0	\N
218202	2134	12378803000	29440	14516	5	0	\N
218203	2134	12377799000	29440	14516	6	0	\N
218204	1726	119724112000	29440	14516	7	0	\N
218205	1726	118623112000	29440	14516	8	0	\N
218206	2133	9027206000	29440	14516	9	0	\N
218207	2133	9026204000	29440	14516	10	0	\N
218208	2133	9025202000	29440	14516	11	0	\N
218209	2133	9024200000	29440	14516	12	0	\N
218210	2132	7054068000	29440	14516	13	0	\N
218225	1397	1260232158000	29442	14516	0	0	\N
218226	1397	1260222157000	29442	14516	1	0	\N
218227	1397	1260212156000	29442	14516	2	0	\N
218228	1397	1260202155000	29442	14516	3	0	\N
218229	2134	12379807000	29442	14516	4	0	\N
218230	2134	12378803000	29442	14516	5	0	\N
218231	2134	12377799000	29442	14516	6	0	\N
218232	1726	119724112000	29442	14516	7	0	\N
218233	1726	118623112000	29442	14516	8	0	\N
218234	2133	9027206000	29442	14516	9	0	\N
218235	2133	9026204000	29442	14516	10	0	\N
218236	2133	9025202000	29442	14516	11	0	\N
218237	2133	9024200000	29442	14516	12	0	\N
218238	2132	7054068000	29442	14516	13	0	\N
218239	1397	1260192154000	29443	14517	0	0	\N
218240	2133	9023198000	29443	14517	1	0	\N
218243	1397	1260192154000	29445	14517	0	0	\N
218244	2133	9023198000	29445	14517	1	0	\N
218265	1397	1260132148000	29450	14521	0	0	\N
218266	2134	12372779000	29450	14521	1	0	\N
218267	2133	9017186000	29450	14521	2	0	\N
218279	186	66845521394804	29453	14523	0	0	\N
218280	1397	1260102145000	29453	14523	1	0	\N
218147	2132	7057071000	29425	14507	3	0	1931
218148	2133	9036224000	29425	14507	4	0	7391
218149	612	66542450726895	29426	14508	0	0	4
218150	1397	1260312166000	29426	14508	1	0	17851
218151	1776	2133910116625	29426	14508	2	0	2
218153	2133	9035222000	29426	14508	4	0	7392
218154	1397	1260302165000	29427	14509	0	0	17852
218155	1776	2132902366625	29427	14509	1	0	3
218156	2133	9034220000	29427	14509	2	0	7393
218157	2134	12384827000	29427	14509	3	0	7932
218169	2133	9033218000	29431	14510	1	0	7394
218170	2134	12383823000	29431	14510	2	0	7933
218180	1397	1260282163000	29435	14511	0	0	17854
218181	2133	9032216000	29435	14511	1	0	7395
218183	1397	1260272162000	29436	14512	0	0	17855
218184	126	66000892250000	29436	14512	1	0	1
218185	2133	9031214000	29436	14512	2	0	7396
218186	2134	12382819000	29436	14512	3	0	7934
218187	1397	1260262161000	29437	14513	0	0	17856
218189	2134	12381815000	29437	14513	2	0	7935
218190	2133	9030212000	29437	14513	3	0	7397
218191	1397	1260252160000	29438	14514	0	0	17857
218192	2132	7055069000	29438	14514	1	0	1933
218193	2133	9029210000	29438	14514	2	0	7398
218195	2134	12380811000	29439	14515	1	0	7936
218196	2133	9028208000	29439	14515	2	0	7399
218211	1397	1260232158000	29441	14516	0	0	17859
218212	1397	1260222157000	29441	14516	1	0	17860
218214	1397	1260202155000	29441	14516	3	0	17862
218215	2134	12379807000	29441	14516	4	0	7937
218216	2134	12378803000	29441	14516	5	0	7938
218217	2134	12377799000	29441	14516	6	0	7939
218218	1726	119724112000	29441	14516	7	0	8361
218220	2133	9027206000	29441	14516	9	0	7400
218221	2133	9026204000	29441	14516	10	0	7401
218222	2133	9025202000	29441	14516	11	0	7402
218223	2133	9024200000	29441	14516	12	0	7403
218224	2132	7054068000	29441	14516	13	0	1934
218242	2133	9023198000	29444	14517	1	0	7404
218245	1539	719914000000	29446	14518	0	0	1
218246	363	67439950000000	29446	14518	1	0	1
218247	1397	1260182153000	29446	14518	2	0	17864
218249	2133	9022196000	29446	14518	4	0	7405
218250	2132	7053067000	29446	14518	5	0	1935
218251	1397	1260172152000	29447	14519	0	0	17865
218252	2134	12375791000	29447	14519	1	0	7941
218253	2133	9021194000	29447	14519	2	0	7406
218255	1397	1260152150000	29448	14520	1	0	17867
218256	1397	1260142149000	29448	14520	2	0	17868
218257	2134	12374787000	29448	14520	3	0	7942
218258	2132	7052066000	29448	14520	4	0	1936
218259	2133	9020192000	29448	14520	5	0	7407
218261	2133	9018188000	29448	14520	7	0	7409
218262	2134	12373783000	29448	14520	8	0	7943
218263	1397	1260132148000	29449	14521	0	0	17869
218264	2134	12372779000	29449	14521	1	0	7944
218269	1397	1260112146000	29451	14522	1	0	17871
218270	2132	7051065000	29451	14522	2	0	1937
218271	2134	12371775000	29451	14522	3	0	7945
218272	2133	9017186000	29451	14522	4	0	7410
218273	2133	9016184000	29451	14522	5	0	7411
218275	186	66845521394804	29452	14523	0	0	1
218276	1397	1260102145000	29452	14523	1	0	17872
218277	2134	12370771000	29452	14523	2	0	7946
218278	2133	9014180000	29452	14523	3	0	7413
218281	2134	12370771000	29453	14523	2	0	\N
218282	2133	9014180000	29453	14523	3	0	\N
218299	1397	1260062141000	29458	14527	0	0	\N
218300	1397	1260052140000	29458	14527	1	0	\N
218301	2402	47989000000	29458	14527	2	0	\N
218302	2134	12367759000	29458	14527	3	0	\N
218303	2132	7049063000	29458	14527	4	0	\N
218304	2133	9010172000	29458	14527	5	0	\N
218305	2133	9009170000	29458	14527	6	0	\N
218306	1397	1260062141000	29459	14527	0	0	\N
218307	1397	1260052140000	29459	14527	1	0	\N
218308	2402	47989000000	29459	14527	2	0	\N
218309	2134	12367759000	29459	14527	3	0	\N
218310	2132	7049063000	29459	14527	4	0	\N
218311	2133	9010172000	29459	14527	5	0	\N
218312	2133	9009170000	29459	14527	6	0	\N
218313	1397	1260062141000	29460	14527	0	0	\N
218314	1397	1260052140000	29460	14527	1	0	\N
218315	2402	47989000000	29460	14527	2	0	\N
218316	2134	12367759000	29460	14527	3	0	\N
218317	2132	7049063000	29460	14527	4	0	\N
218318	2133	9010172000	29460	14527	5	0	\N
218319	2133	9009170000	29460	14527	6	0	\N
218323	1397	1260042139000	29462	14528	0	0	\N
218324	2134	12366755000	29462	14528	1	0	\N
218325	2133	9008168000	29462	14528	2	0	\N
218329	1397	1260032138000	29464	14529	0	0	\N
218330	2133	9007166000	29464	14529	1	0	\N
218331	2134	12365751000	29464	14529	2	0	\N
218340	345	66000940000000	29466	14530	0	0	\N
218341	1397	1260022137000	29466	14530	1	0	\N
218342	2039	21498862000000	29466	14530	2	0	\N
218343	1397	1260012136000	29466	14530	3	0	\N
218344	2133	9006164000	29466	14530	4	0	\N
218345	2132	7048062000	29466	14530	5	0	\N
218346	2133	9005162000	29466	14530	6	0	\N
218347	2134	12364747000	29466	14530	7	0	\N
218360	2039	2345852000000	29469	14532	0	0	\N
218361	1397	1259992134000	29469	14532	1	0	\N
218362	1397	1259982133000	29469	14532	2	0	\N
218363	2402	47035000000	29469	14532	3	0	\N
218364	2134	12362739000	29469	14532	4	0	\N
218365	2132	7047061000	29469	14532	5	0	\N
218366	2133	9003158000	29469	14532	6	0	\N
218367	2133	9002156000	29469	14532	7	0	\N
218375	1397	1259962131000	29472	14534	0	0	\N
218376	2134	12360731000	29472	14534	1	0	\N
218377	2133	9000152000	29472	14534	2	0	\N
218389	1397	1259942129000	29475	14536	0	0	\N
218390	2426	990000000	29475	14536	1	0	\N
218391	1397	1259932128000	29475	14536	2	0	\N
218392	2133	8998148000	29475	14536	3	0	\N
218393	2134	12358723000	29475	14536	4	0	\N
218394	2133	8997146000	29475	14536	5	0	\N
218395	182	66000000000000	29475	14536	6	0	\N
218396	560	66846771394804	29476	14537	0	0	\N
218397	1397	1259922127000	29476	14537	1	0	\N
218398	1397	1259912126000	29476	14537	2	0	\N
218399	1397	1259902125000	29476	14537	3	0	\N
218400	2133	8996144000	29476	14537	4	0	\N
218401	2132	7045059000	29476	14537	5	0	\N
218402	2133	8995142000	29476	14537	6	0	\N
218403	2133	8994140000	29476	14537	7	0	\N
218404	2134	12357719000	29476	14537	8	0	\N
218405	702	44000000000515	29476	14537	9	0	\N
218406	2134	12356715000	29476	14537	10	0	\N
218285	1397	1260082143000	29455	14525	0	0	17874
218286	2133	9012176000	29455	14525	1	0	7415
218287	2132	7050064000	29455	14525	2	0	1938
218288	2134	12369767000	29455	14525	3	0	7947
218289	1397	1260072142000	29456	14526	0	0	17875
218291	2134	12368763000	29456	14526	2	0	7948
218292	1397	1260062141000	29457	14527	0	0	17876
218293	1397	1260052140000	29457	14527	1	0	17877
218294	2402	47989000000	29457	14527	2	0	2
218295	2134	12367759000	29457	14527	3	0	7949
218297	2133	9010172000	29457	14527	5	0	7417
218298	2133	9009170000	29457	14527	6	0	7418
218320	1397	1260042139000	29461	14528	0	0	17878
218321	2134	12366755000	29461	14528	1	0	7950
218326	1397	1260032138000	29463	14529	0	0	17879
218327	2133	9007166000	29463	14529	1	0	7420
218328	2134	12365751000	29463	14529	2	0	7951
218332	345	66000940000000	29465	14530	0	0	1
218333	1397	1260022137000	29465	14530	1	0	17880
218335	1397	1260012136000	29465	14530	3	0	17881
218336	2133	9006164000	29465	14530	4	0	7421
218337	2132	7048062000	29465	14530	5	0	1940
218338	2133	9005162000	29465	14530	6	0	7422
218339	2134	12364747000	29465	14530	7	0	7952
218349	532	66009037000000	29467	14531	1	0	2
218350	2133	9004160000	29467	14531	2	0	7423
218351	2134	12363743000	29467	14531	3	0	7953
218352	2039	2345852000000	29468	14532	0	0	8
218354	1397	1259982133000	29468	14532	2	0	17884
218355	2402	47035000000	29468	14532	3	0	3
218356	2134	12362739000	29468	14532	4	0	7954
218357	2132	7047061000	29468	14532	5	0	1941
218358	2133	9003158000	29468	14532	6	0	7424
218368	2402	46025000000	29470	14533	0	0	4
218369	1397	1259972132000	29470	14533	1	0	17885
218370	2133	9001154000	29470	14533	2	0	7426
218371	2134	12361735000	29470	14533	3	0	7955
218372	1397	1259962131000	29471	14534	0	0	17886
218374	2133	9000152000	29471	14534	2	0	7427
218378	1397	1259952130000	29473	14535	0	0	17887
218379	2133	8999150000	29473	14535	1	0	7428
218380	2134	12359727000	29473	14535	2	0	7957
218382	1397	1259942129000	29474	14536	0	0	17888
218383	2426	990000000	29474	14536	1	0	1
218384	1397	1259932128000	29474	14536	2	0	17889
218385	2133	8998148000	29474	14536	3	0	7429
218386	2134	12358723000	29474	14536	4	0	7958
218388	182	66000000000000	29474	14536	6	0	1
218407	560	66846771394804	29477	14537	0	0	1
218408	1397	1259922127000	29477	14537	1	0	17890
218409	1397	1259912126000	29477	14537	2	0	17891
218410	1397	1259902125000	29477	14537	3	0	17892
218412	2132	7045059000	29477	14537	5	0	1943
218413	2133	8995142000	29477	14537	6	0	7432
218414	2133	8994140000	29477	14537	7	0	7433
218415	2134	12357719000	29477	14537	8	0	7959
218418	560	66846771394804	29478	14537	0	0	\N
218419	1397	1259922127000	29478	14537	1	0	\N
218420	1397	1259912126000	29478	14537	2	0	\N
218421	1397	1259902125000	29478	14537	3	0	\N
218422	2133	8996144000	29478	14537	4	0	\N
218423	2132	7045059000	29478	14537	5	0	\N
218424	2133	8995142000	29478	14537	6	0	\N
218425	2133	8994140000	29478	14537	7	0	\N
218426	2134	12357719000	29478	14537	8	0	\N
218427	702	44000000000515	29478	14537	9	0	\N
218428	2134	12356715000	29478	14537	10	0	\N
218429	560	66846771394804	29479	14537	0	0	\N
218430	1397	1259922127000	29479	14537	1	0	\N
218431	1397	1259912126000	29479	14537	2	0	\N
218432	1397	1259902125000	29479	14537	3	0	\N
218433	2133	8996144000	29479	14537	4	0	\N
218434	2132	7045059000	29479	14537	5	0	\N
218435	2133	8995142000	29479	14537	6	0	\N
218436	2133	8994140000	29479	14537	7	0	\N
218437	2134	12357719000	29479	14537	8	0	\N
218438	702	44000000000515	29479	14537	9	0	\N
218439	2134	12356715000	29479	14537	10	0	\N
218440	560	66846771394804	29480	14537	0	0	\N
218441	1397	1259922127000	29480	14537	1	0	\N
218442	1397	1259912126000	29480	14537	2	0	\N
218443	1397	1259902125000	29480	14537	3	0	\N
218444	2133	8996144000	29480	14537	4	0	\N
218445	2132	7045059000	29480	14537	5	0	\N
218446	2133	8995142000	29480	14537	6	0	\N
218447	2133	8994140000	29480	14537	7	0	\N
218448	2134	12357719000	29480	14537	8	0	\N
218449	702	44000000000515	29480	14537	9	0	\N
218450	2134	12356715000	29480	14537	10	0	\N
218451	560	66846771394804	29481	14537	0	0	\N
218452	1397	1259922127000	29481	14537	1	0	\N
218453	1397	1259912126000	29481	14537	2	0	\N
218454	1397	1259902125000	29481	14537	3	0	\N
218455	2133	8996144000	29481	14537	4	0	\N
218456	2132	7045059000	29481	14537	5	0	\N
218457	2133	8995142000	29481	14537	6	0	\N
218458	2133	8994140000	29481	14537	7	0	\N
218459	2134	12357719000	29481	14537	8	0	\N
218460	702	44000000000515	29481	14537	9	0	\N
218461	2134	12356715000	29481	14537	10	0	\N
218462	560	66846771394804	29482	14537	0	0	\N
218463	1397	1259922127000	29482	14537	1	0	\N
218464	1397	1259912126000	29482	14537	2	0	\N
218465	1397	1259902125000	29482	14537	3	0	\N
218466	2133	8996144000	29482	14537	4	0	\N
218467	2132	7045059000	29482	14537	5	0	\N
218468	2133	8995142000	29482	14537	6	0	\N
218469	2133	8994140000	29482	14537	7	0	\N
218470	2134	12357719000	29482	14537	8	0	\N
218471	702	44000000000515	29482	14537	9	0	\N
218472	2134	12356715000	29482	14537	10	0	\N
218473	1397	1259892124000	29483	14538	0	0	\N
218474	2133	8993138000	29483	14538	1	0	\N
218475	2134	12355711000	29483	14538	2	0	\N
218476	1397	1259892124000	29484	14538	0	0	\N
218477	2133	8993138000	29484	14538	1	0	\N
218478	2134	12355711000	29484	14538	2	0	\N
218497	1397	1259832118000	29488	14541	0	0	\N
218498	1397	1259822117000	29488	14541	1	0	\N
218499	2132	7042056000	29488	14541	2	0	\N
218500	2134	12351695000	29488	14541	3	0	\N
218501	2133	8987126000	29488	14541	4	0	\N
218502	2134	12350691000	29488	14541	5	0	\N
218503	2133	8986124000	29488	14541	6	0	\N
218504	1397	1259832118000	29489	14541	0	0	\N
218505	1397	1259822117000	29489	14541	1	0	\N
218506	2132	7042056000	29489	14541	2	0	\N
218507	2134	12351695000	29489	14541	3	0	\N
218508	2133	8987126000	29489	14541	4	0	\N
218509	2134	12350691000	29489	14541	5	0	\N
218510	2133	8986124000	29489	14541	6	0	\N
218530	1397	1259772112000	29492	14543	0	0	\N
218531	2133	8981114000	29492	14543	1	0	\N
218534	1397	1259762111000	29494	14544	0	0	\N
218535	2133	8980112000	29494	14544	1	0	\N
218536	2134	12346675000	29494	14544	2	0	\N
218537	1397	1259762111000	29495	14544	0	0	\N
218538	2133	8980112000	29495	14544	1	0	\N
218539	2134	12346675000	29495	14544	2	0	\N
218543	1397	1259762111000	29497	14544	0	0	\N
218544	2133	8980112000	29497	14544	1	0	\N
218545	2134	12346675000	29497	14544	2	0	\N
218552	1397	1259732108000	29500	14547	0	0	\N
218480	2133	8993138000	29485	14538	1	0	7434
218481	2134	12355711000	29485	14538	2	0	7961
218482	1397	1259882123000	29486	14539	0	0	17894
218483	1397	1259872122000	29486	14539	1	0	17895
218484	1397	1259862121000	29486	14539	2	0	17896
218486	2134	12354707000	29486	14539	4	0	7962
218487	2134	12353703000	29486	14539	5	0	7963
218488	2133	8992136000	29486	14539	6	0	7435
218489	2133	8991134000	29486	14539	7	0	7436
218490	2133	8990132000	29486	14539	8	0	7437
218492	1397	1259842119000	29487	14540	1	0	17898
218493	2133	8989130000	29487	14540	2	0	7438
218494	2133	8988128000	29487	14540	3	0	7439
218495	2132	7043057000	29487	14540	4	0	1945
218511	1397	1259832118000	29490	14541	0	0	17899
218512	1397	1259822117000	29490	14541	1	0	17900
218513	2132	7042056000	29490	14541	2	0	1946
218514	2134	12351695000	29490	14541	3	0	7965
218515	2133	8987126000	29490	14541	4	0	7440
218517	2133	8986124000	29490	14541	6	0	7441
218518	1397	1259812116000	29491	14542	0	0	17901
218519	1397	1259802115000	29491	14542	1	0	17902
218520	1397	1259792114000	29491	14542	2	0	17903
218521	1397	1259782113000	29491	14542	3	0	17904
218523	2134	12349687000	29491	14542	5	0	7967
218524	2134	12348683000	29491	14542	6	0	7968
218525	2133	8985122000	29491	14542	7	0	7442
218526	2133	8984120000	29491	14542	8	0	7443
218528	2133	8982116000	29491	14542	10	0	7445
218529	2134	12347679000	29491	14542	11	0	7969
218532	1397	1259772112000	29493	14543	0	0	17905
218533	2133	8981114000	29493	14543	1	0	7446
218540	1397	1259762111000	29496	14544	0	0	17906
218542	2134	12346675000	29496	14544	2	0	7970
218546	1397	1259752110000	29498	14545	0	0	17907
218547	2132	7040054000	29498	14545	1	0	1948
218548	2134	12345671000	29498	14545	2	0	7971
218549	2133	8979110000	29498	14545	3	0	7448
218551	2133	8978108000	29499	14546	1	0	7449
218553	2134	12344667000	29500	14547	1	0	\N
218576	1397	1259672102000	29508	14553	0	0	\N
218577	2133	8972096000	29508	14553	1	0	\N
218578	1419	31243367559748	29508	14553	2	0	\N
218590	1397	1259652100000	29511	14555	0	0	\N
218591	1397	1259642099000	29511	14555	1	0	\N
218592	1769	1566700000	29511	14555	2	0	\N
218593	2132	7037051000	29511	14555	3	0	\N
218594	2134	12338643000	29511	14555	4	0	\N
218595	2133	8970092000	29511	14555	5	0	\N
218596	2133	8969090000	29511	14555	6	0	\N
218597	1397	1259652100000	29512	14555	0	0	\N
218598	1397	1259642099000	29512	14555	1	0	\N
218599	1769	1566700000	29512	14555	2	0	\N
218600	2132	7037051000	29512	14555	3	0	\N
218601	2134	12338643000	29512	14555	4	0	\N
218602	2133	8970092000	29512	14555	5	0	\N
218603	2133	8969090000	29512	14555	6	0	\N
218608	1397	1259632098000	29514	14556	0	0	\N
218609	2133	8968088000	29514	14556	1	0	\N
218610	2134	12337639000	29514	14556	2	0	\N
218611	1769	1565700000	29514	14556	3	0	\N
218619	1397	1259622097000	29516	14557	0	0	\N
218620	1397	1259612096000	29516	14557	1	0	\N
218621	2132	7036050000	29516	14557	2	0	\N
218622	2134	12336635000	29516	14557	4	0	\N
218623	2134	12335631000	29516	14557	5	0	\N
218624	2133	8967086000	29516	14557	6	0	\N
218625	2133	8966084000	29516	14557	7	0	\N
218626	1397	1259622097000	29517	14557	0	0	\N
218627	1397	1259612096000	29517	14557	1	0	\N
218628	2132	7036050000	29517	14557	2	0	\N
218629	2134	12336635000	29517	14557	4	0	\N
218630	2134	12335631000	29517	14557	5	0	\N
218631	2133	8967086000	29517	14557	6	0	\N
218632	2133	8966084000	29517	14557	7	0	\N
218646	2134	12332619000	29520	14559	0	0	\N
218647	2133	8962076000	29520	14559	1	0	\N
218648	2134	12332619000	29521	14559	0	0	\N
218649	2133	8962076000	29521	14559	1	0	\N
218650	2134	12332619000	29522	14559	0	0	\N
218651	2133	8962076000	29522	14559	1	0	\N
218652	2134	12332619000	29523	14559	0	0	\N
218653	2133	8962076000	29523	14559	1	0	\N
218654	1397	1259572092000	29524	14560	0	0	\N
218655	1397	1259562091000	29524	14560	1	0	\N
218656	2133	8961074000	29524	14560	2	0	\N
218657	2132	7034048000	29524	14560	3	0	\N
218658	2133	8960072000	29524	14560	4	0	\N
218659	2134	12331615000	29524	14560	5	0	\N
218666	1397	1259552090000	29526	14561	0	0	\N
218667	1726	118522112000	29526	14561	1	0	\N
218668	2133	8959070000	29526	14561	2	0	\N
218669	2134	12330611000	29526	14561	3	0	\N
218676	186	66845521394804	29529	14341	0	0	\N
218677	1539	719914000000	29529	14341	1	0	\N
218678	511	66544310726895	29529	14341	2	0	\N
218679	363	67439950000000	29529	14341	3	0	\N
218680	612	66543000726895	29529	14341	4	0	\N
218681	835	3199985394837430	29529	14341	5	0	\N
218682	612	66542980726895	29529	14341	6	0	\N
218683	1397	1262592394000	29529	14341	7	0	\N
218684	1397	1262582393000	29529	14341	8	0	\N
218685	1992	1107990000	29529	14341	9	0	\N
218686	1397	1262572392000	29529	14341	10	0	\N
218687	560	66846771394804	29529	14341	11	0	\N
218688	1397	1262562391000	29529	14341	12	0	\N
218556	1397	1259722107000	29502	14548	0	0	17910
218557	2132	7039053000	29502	14548	1	0	1949
218558	2133	8977106000	29502	14548	2	0	7450
218559	2134	12343663000	29502	14548	3	0	7973
218560	1397	1259712106000	29503	14549	0	0	17911
218562	1397	1259702105000	29504	14550	0	0	17912
218563	2134	12342659000	29504	14550	1	0	7974
218564	2133	8975102000	29504	14550	2	0	7452
218565	1397	1259692104000	29505	14551	0	0	17913
218566	2133	8974100000	29505	14551	1	0	7453
218568	613	66000090000000	29506	14552	0	0	1
218569	1397	1259682103000	29506	14552	1	0	17914
218570	2133	8973098000	29506	14552	2	0	7454
218571	2132	7038052000	29506	14552	3	0	1950
218573	1397	1259672102000	29507	14553	0	0	17915
218574	2133	8972096000	29507	14553	1	0	7455
218575	1419	31243367559748	29507	14553	2	0	11
218579	1397	1259662101000	29509	14554	0	0	17916
218580	1419	31243366559748	29509	14554	1	0	12
218582	2134	12339647000	29509	14554	3	0	7977
218583	1397	1259652100000	29510	14555	0	0	17917
218584	1397	1259642099000	29510	14555	1	0	17918
218585	1769	1566700000	29510	14555	2	0	66
218586	2132	7037051000	29510	14555	3	0	1951
218588	2133	8970092000	29510	14555	5	0	7457
218589	2133	8969090000	29510	14555	6	0	7458
218604	1397	1259632098000	29513	14556	0	0	17919
218605	2133	8968088000	29513	14556	1	0	7459
218607	1769	1565700000	29513	14556	3	0	67
218612	1397	1259622097000	29515	14557	0	0	17920
218613	1397	1259612096000	29515	14557	1	0	17921
218614	2132	7036050000	29515	14557	2	0	1952
218615	2134	12336635000	29515	14557	4	0	7980
218617	2133	8967086000	29515	14557	6	0	7460
218618	2133	8966084000	29515	14557	7	0	7461
218633	1397	1259602095000	29518	14558	0	0	17922
218634	1397	1259592094000	29518	14558	1	0	17923
218635	1397	1259582093000	29518	14558	2	0	17924
218637	2133	8965082000	29518	14558	4	0	7462
218638	2133	8964080000	29518	14558	5	0	7463
218639	2134	12334627000	29518	14558	6	0	7982
218640	2134	12333623000	29518	14558	7	0	7983
218642	613	66000087820000	29518	14558	9	0	3
218643	2133	8963078000	29518	14558	10	0	7464
218644	2134	12332619000	29519	14559	0	0	7984
218645	2133	8962076000	29519	14559	1	0	7465
218660	1397	1259572092000	29525	14560	0	0	17925
218662	2133	8961074000	29525	14560	2	0	7466
218663	2132	7034048000	29525	14560	3	0	1954
218664	2133	8960072000	29525	14560	4	0	7467
218665	2134	12331615000	29525	14560	5	0	7985
218670	1397	1259552090000	29527	14561	0	0	17927
218672	2133	8959070000	29527	14561	2	0	7468
218673	2134	12330611000	29527	14561	3	0	7986
218674	1397	1259542089000	29528	14562	0	0	17928
218675	2133	8958068000	29528	14562	1	0	7469
218689	2039	21498862000000	29529	14341	13	0	\N
218690	2039	2345852000000	29529	14341	14	0	\N
218691	1397	1262552390000	29529	14341	15	0	\N
218692	1397	1262542389000	29529	14341	16	0	\N
218693	1397	1262532388000	29529	14341	17	0	\N
218694	1397	1262522387000	29529	14341	18	0	\N
218695	612	66542960726895	29529	14341	19	0	\N
218696	612	66542450726895	29529	14341	20	0	\N
218697	1397	1262512386000	29529	14341	21	0	\N
218698	1397	1262502385000	29529	14341	22	0	\N
218699	1397	1262492384000	29529	14341	23	0	\N
218700	1397	1262482383000	29529	14341	24	0	\N
218701	1397	1262472382000	29529	14341	25	0	\N
218702	1397	1262462381000	29529	14341	26	0	\N
218703	1397	1262452380000	29529	14341	27	0	\N
218704	1397	1262442379000	29529	14341	28	0	\N
218705	1397	1262432378000	29529	14341	29	0	\N
218706	1397	1262422377000	29529	14341	30	0	\N
218707	1397	1262412376000	29529	14341	31	0	\N
218708	1397	1262402375000	29529	14341	32	0	\N
218709	1397	1262392374000	29529	14341	33	0	\N
218710	1397	1262382373000	29529	14341	34	0	\N
218711	1397	1262372372000	29529	14341	35	0	\N
218712	1397	1262362371000	29529	14341	36	0	\N
218713	1397	1262352370000	29529	14341	37	0	\N
218714	1397	1262342369000	29529	14341	38	0	\N
218715	1397	1262332368000	29529	14341	39	0	\N
218716	1397	1262322367000	29529	14341	40	0	\N
218717	1397	1262312366000	29529	14341	41	0	\N
218718	1397	1262302365000	29529	14341	42	0	\N
218719	1397	1262292364000	29529	14341	43	0	\N
218720	1397	1262282363000	29529	14341	44	0	\N
218721	1397	1262272362000	29529	14341	45	0	\N
218722	1397	1262262361000	29529	14341	46	0	\N
218723	1397	1262252360000	29529	14341	47	0	\N
218724	1397	1262242359000	29529	14341	48	0	\N
218725	1397	1262232358000	29529	14341	49	0	\N
218726	1397	1262222357000	29529	14341	50	0	\N
218727	1397	1262212356000	29529	14341	51	0	\N
218728	1397	1262202355000	29529	14341	52	0	\N
218729	1397	1262192354000	29529	14341	53	0	\N
218730	1397	1262182353000	29529	14341	54	0	\N
218731	1397	1262172352000	29529	14341	55	0	\N
218732	1397	1262162351000	29529	14341	56	0	\N
218733	1397	1262152350000	29529	14341	57	0	\N
218734	1397	1262142349000	29529	14341	58	0	\N
218735	1397	1262132348000	29529	14341	59	0	\N
218736	1397	1262122347000	29529	14341	60	0	\N
218737	1397	1262112346000	29529	14341	61	0	\N
218738	1397	1262102345000	29529	14341	62	0	\N
218739	1397	1262092344000	29529	14341	63	0	\N
218740	1397	1262082343000	29529	14341	64	0	\N
218741	1397	1262072342000	29529	14341	65	0	\N
218742	1397	1262062341000	29529	14341	66	0	\N
218743	1397	1262052340000	29529	14341	67	0	\N
218744	1397	1262042339000	29529	14341	68	0	\N
218745	1397	1262032338000	29529	14341	69	0	\N
218746	1397	1262022337000	29529	14341	70	0	\N
218747	1397	1262012336000	29529	14341	71	0	\N
218748	1397	1262002335000	29529	14341	72	0	\N
218749	1397	1261992334000	29529	14341	73	0	\N
218750	1397	1261982333000	29529	14341	74	0	\N
218751	1397	1261972332000	29529	14341	75	0	\N
218752	1397	1261962331000	29529	14341	76	0	\N
218753	1397	1261952330000	29529	14341	77	0	\N
218754	1397	1261942329000	29529	14341	78	0	\N
218755	1397	1261932328000	29529	14341	79	0	\N
218756	1397	1261922327000	29529	14341	80	0	\N
218757	1397	1261912326000	29529	14341	81	0	\N
218758	1397	1261902325000	29529	14341	82	0	\N
218759	1397	1261892324000	29529	14341	83	0	\N
218760	1397	1261882323000	29529	14341	84	0	\N
218761	1397	1261872322000	29529	14341	85	0	\N
218762	1397	1261862321000	29529	14341	86	0	\N
218763	1397	1261852320000	29529	14341	87	0	\N
218764	1397	1261842319000	29529	14341	88	0	\N
218765	1397	1261832318000	29529	14341	89	0	\N
218766	1397	1261822317000	29529	14341	90	0	\N
218767	1397	1261812316000	29529	14341	91	0	\N
218768	1397	1261802315000	29529	14341	92	0	\N
218769	1397	1261792314000	29529	14341	93	0	\N
218770	1397	1261782313000	29529	14341	95	0	\N
218771	1397	1261772312000	29529	14341	96	0	\N
218772	1397	1261762311000	29529	14341	97	0	\N
218773	1397	1259532088000	29530	14563	0	0	\N
218774	2133	8957066000	29530	14563	1	0	\N
218775	2132	7033047000	29530	14563	2	0	\N
218776	2134	12329607000	29530	14563	3	0	\N
218777	1397	1259532088000	29531	14563	0	0	\N
218778	2133	8957066000	29531	14563	1	0	\N
218779	2132	7033047000	29531	14563	2	0	\N
218780	2134	12329607000	29531	14563	3	0	\N
218781	1397	1259532088000	29532	14563	0	0	\N
218782	2133	8957066000	29532	14563	1	0	\N
218783	2132	7033047000	29532	14563	2	0	\N
218784	2134	12329607000	29532	14563	3	0	\N
218789	1397	1259532088000	29534	14563	0	0	\N
218790	2133	8957066000	29534	14563	1	0	\N
218791	2132	7033047000	29534	14563	2	0	\N
218792	2134	12329607000	29534	14563	3	0	\N
218793	1397	1259522087000	29536	14564	0	0	\N
218794	2133	8956064000	29536	14564	1	0	\N
218795	2134	12328603000	29536	14564	2	0	\N
218799	1397	1259522087000	29538	14564	0	0	\N
218800	2133	8956064000	29538	14564	1	0	\N
218801	2134	12328603000	29538	14564	2	0	\N
218809	1397	1259492084000	29542	14566	0	0	\N
218810	1397	1259482083000	29542	14566	1	0	\N
218811	2134	12326595000	29542	14566	2	0	\N
218812	2132	7032046000	29542	14566	3	0	\N
218813	2133	8953058000	29542	14566	4	0	\N
218814	2133	8952056000	29542	14566	5	0	\N
218821	1397	1259492084000	29544	14566	0	0	\N
218822	1397	1259482083000	29544	14566	1	0	\N
218823	2134	12326595000	29544	14566	2	0	\N
218824	2132	7032046000	29544	14566	3	0	\N
218787	2132	7033047000	29533	14563	2	0	1955
218788	2134	12329607000	29533	14563	3	0	7987
218796	1397	1259522087000	29537	14564	0	0	17930
218797	2133	8956064000	29537	14564	1	0	7471
218798	2134	12328603000	29537	14564	2	0	7988
218803	1397	1259502085000	29541	14565	1	0	17932
218804	2133	8955062000	29541	14565	2	0	7472
218805	2134	12327599000	29541	14565	3	0	7989
218806	693	66000099000000	29541	14565	4	0	2
218807	1504	156244000000	29541	14565	5	0	12
218815	1397	1259492084000	29543	14566	0	0	17933
218816	1397	1259482083000	29543	14566	1	0	17934
218817	2134	12326595000	29543	14566	2	0	7990
218818	2132	7032046000	29543	14566	3	0	1956
218820	2133	8952056000	29543	14566	5	0	7475
218825	2133	8953058000	29544	14566	4	0	\N
218826	2133	8952056000	29544	14566	5	0	\N
218830	1397	1259462081000	29546	14568	0	0	\N
218831	1397	1259452080000	29546	14568	1	0	\N
218832	2134	12324587000	29546	14568	2	0	\N
218833	2133	8950052000	29546	14568	3	0	\N
218834	2133	8949050000	29546	14568	4	0	\N
218835	2132	7031045000	29546	14568	5	0	\N
218836	2134	12323583000	29546	14568	6	0	\N
218844	1397	1259462081000	29548	14568	0	0	\N
218845	1397	1259452080000	29548	14568	1	0	\N
218846	2134	12324587000	29548	14568	2	0	\N
218847	2133	8950052000	29548	14568	3	0	\N
218848	2133	8949050000	29548	14568	4	0	\N
218849	2132	7031045000	29548	14568	5	0	\N
218850	2134	12323583000	29548	14568	6	0	\N
218851	1397	1259462081000	29549	14568	0	0	\N
218852	1397	1259452080000	29549	14568	1	0	\N
218853	2134	12324587000	29549	14568	2	0	\N
218854	2133	8950052000	29549	14568	3	0	\N
218855	2133	8949050000	29549	14568	4	0	\N
218856	2132	7031045000	29549	14568	5	0	\N
218857	2134	12323583000	29549	14568	6	0	\N
218868	1397	1259432078000	29552	14570	0	0	\N
218869	1397	1259422077000	29552	14570	1	0	\N
218870	2132	7030044000	29552	14570	2	0	\N
218871	2134	12322579000	29552	14570	3	0	\N
218872	113	66000000000000	29552	14570	4	0	\N
218873	2134	12321575000	29552	14570	5	0	\N
218874	1397	1259432078000	29553	14570	0	0	\N
218875	1397	1259422077000	29553	14570	1	0	\N
218876	2132	7030044000	29553	14570	2	0	\N
218877	2134	12322579000	29553	14570	3	0	\N
218878	2133	8947046000	29553	14570	4	0	\N
218879	113	66000000000000	29553	14570	5	0	\N
218880	2133	8946044000	29553	14570	6	0	\N
218881	2134	12321575000	29553	14570	7	0	\N
218882	1397	1259432078000	29554	14570	0	0	\N
218883	1397	1259422077000	29554	14570	1	0	\N
218884	2132	7030044000	29554	14570	2	0	\N
218885	2134	12322579000	29554	14570	3	0	\N
218886	2133	8947046000	29554	14570	4	0	\N
218887	113	66000000000000	29554	14570	5	0	\N
218888	2133	8946044000	29554	14570	6	0	\N
218889	2134	12321575000	29554	14570	7	0	\N
218890	186	66845521394804	29555	14362	0	0	\N
218891	1539	719914000000	29555	14362	1	0	\N
218892	511	66544310726895	29555	14362	2	0	\N
218893	363	67439950000000	29555	14362	3	0	\N
218894	612	66543000726895	29555	14362	4	0	\N
218895	612	66542980726895	29555	14362	5	0	\N
218896	1992	1107990000	29555	14362	6	0	\N
218897	1397	1261762311000	29555	14362	7	0	\N
218898	1397	1261752310000	29555	14362	8	0	\N
218899	560	66846771394804	29555	14362	9	0	\N
218900	2039	21498862000000	29555	14362	10	0	\N
218901	2039	2345852000000	29555	14362	11	0	\N
218902	1397	1261742309000	29555	14362	12	0	\N
218903	1397	1261732308000	29555	14362	13	0	\N
218904	1397	1261722307000	29555	14362	14	0	\N
218905	1397	1261712306000	29555	14362	15	0	\N
218906	1397	1261702305000	29555	14362	16	0	\N
218907	1397	1261692304000	29555	14362	17	0	\N
218908	1397	1261682303000	29555	14362	18	0	\N
218909	1397	1261672302000	29555	14362	19	0	\N
218910	1397	1261662301000	29555	14362	20	0	\N
218911	1397	1261652300000	29555	14362	21	0	\N
218912	1397	1261642299000	29555	14362	22	0	\N
218913	1397	1261632298000	29555	14362	23	0	\N
218914	612	66542960726895	29555	14362	24	0	\N
218915	612	66542450726895	29555	14362	25	0	\N
218916	1397	1261622297000	29555	14362	26	0	\N
218917	1397	1261612296000	29555	14362	27	0	\N
218918	1397	1261602295000	29555	14362	28	0	\N
218919	1397	1261592294000	29555	14362	29	0	\N
218920	1397	1261582293000	29555	14362	30	0	\N
218921	1397	1261572292000	29555	14362	31	0	\N
218922	1397	1261562291000	29555	14362	32	0	\N
218923	1397	1261552290000	29555	14362	33	0	\N
218924	1397	1261542289000	29555	14362	34	0	\N
218925	1397	1261532288000	29555	14362	35	0	\N
218926	1397	1261522287000	29555	14362	36	0	\N
218927	1397	1261512286000	29555	14362	37	0	\N
218928	1397	1261502285000	29555	14362	38	0	\N
218929	1397	1261492284000	29555	14362	39	0	\N
218930	1397	1261482283000	29555	14362	40	0	\N
218931	1397	1261472282000	29555	14362	41	0	\N
218932	1397	1261462281000	29555	14362	42	0	\N
218933	1397	1261452280000	29555	14362	43	0	\N
218934	1397	1261442279000	29555	14362	44	0	\N
218935	1397	1261432278000	29555	14362	45	0	\N
218936	1397	1261422277000	29555	14362	46	0	\N
218937	1397	1261412276000	29555	14362	47	0	\N
218938	1397	1261402275000	29555	14362	48	0	\N
218939	1397	1261392274000	29555	14362	49	0	\N
218940	1397	1261382273000	29555	14362	50	0	\N
218941	1397	1261372272000	29555	14362	51	0	\N
218942	1397	1261362271000	29555	14362	52	0	\N
218943	1397	1261352270000	29555	14362	53	0	\N
218944	1397	1261342269000	29555	14362	54	0	\N
218945	1397	1261332268000	29555	14362	55	0	\N
218946	1397	1261322267000	29555	14362	56	0	\N
218947	1397	1261312266000	29555	14362	57	0	\N
218948	1397	1261302265000	29555	14362	58	0	\N
218949	1397	1261292264000	29555	14362	59	0	\N
218950	1397	1261282263000	29555	14362	60	0	\N
218951	1397	1261272262000	29555	14362	61	0	\N
218952	1397	1261262261000	29555	14362	62	0	\N
218953	1397	1261252260000	29555	14362	63	0	\N
218954	1397	1261242259000	29555	14362	64	0	\N
218955	1397	1261232258000	29555	14362	65	0	\N
218956	1397	1261222257000	29555	14362	66	0	\N
218957	1397	1261212256000	29555	14362	67	0	\N
218958	1397	1261202255000	29555	14362	68	0	\N
218959	1397	1261192254000	29555	14362	69	0	\N
218960	1397	1261182253000	29555	14362	70	0	\N
218829	2134	12325591000	29545	14567	2	0	7991
218837	1397	1259462081000	29547	14568	0	0	17936
218838	1397	1259452080000	29547	14568	1	0	17937
218839	2134	12324587000	29547	14568	2	0	7992
218840	2133	8950052000	29547	14568	3	0	7477
218842	2132	7031045000	29547	14568	5	0	1957
218843	2134	12323583000	29547	14568	6	0	7993
218858	1397	1259442079000	29550	14569	0	0	17938
218859	2133	8948048000	29550	14569	1	0	7479
218860	1397	1259432078000	29551	14570	0	0	17939
218862	2132	7030044000	29551	14570	2	0	1958
218863	2134	12322579000	29551	14570	3	0	7994
218864	2133	8947046000	29551	14570	4	0	7480
218865	113	66000000000000	29551	14570	5	0	1
218867	2134	12321575000	29551	14570	7	0	7995
218961	1397	1261172252000	29555	14362	71	0	\N
218962	1397	1261162251000	29555	14362	72	0	\N
218963	1397	1261152250000	29555	14362	73	0	\N
218964	1397	1261142249000	29555	14362	74	0	\N
218965	1397	1261132248000	29555	14362	75	0	\N
218966	1397	1261122247000	29555	14362	76	0	\N
218967	1397	1261112246000	29555	14362	77	0	\N
218968	1397	1261102245000	29555	14362	78	0	\N
218969	1397	1261092244000	29555	14362	79	0	\N
218970	1397	1261082243000	29555	14362	80	0	\N
218971	1397	1261072242000	29555	14362	81	0	\N
218972	1397	1261062241000	29555	14362	82	0	\N
218973	1397	1261052240000	29555	14362	84	0	\N
218974	1397	1261042239000	29555	14362	85	0	\N
218975	1397	1261032238000	29555	14362	86	0	\N
218976	1397	1261022237000	29555	14362	87	0	\N
218977	1397	1261012236000	29555	14362	88	0	\N
218978	1397	1261002235000	29555	14362	89	0	\N
218979	1397	1260992234000	29555	14362	90	0	\N
218980	1397	1260982233000	29555	14362	91	0	\N
218981	1397	1260972232000	29555	14362	92	0	\N
218982	1397	1260962231000	29555	14362	93	0	\N
218983	1397	1260952230000	29555	14362	94	0	\N
218984	1397	1260942229000	29555	14362	95	0	\N
218985	1397	1260932228000	29555	14362	96	0	\N
218986	1397	1260922227000	29555	14362	97	0	\N
218987	1397	1260912226000	29555	14362	98	0	\N
218988	1397	1260902225000	29555	14362	99	0	\N
218989	1397	1260892224000	29555	14362	100	0	\N
218990	1397	1260882223000	29555	14362	101	0	\N
218991	1397	1260872222000	29555	14362	102	0	\N
218992	1397	1260862221000	29555	14362	103	0	\N
218993	1397	1260852220000	29555	14362	104	0	\N
218994	1397	1260842219000	29555	14362	105	0	\N
218995	1397	1260832218000	29555	14362	106	0	\N
218996	1397	1260822217000	29555	14362	107	0	\N
218997	1397	1260812216000	29555	14362	108	0	\N
218998	1397	1260802215000	29555	14362	109	0	\N
218999	1397	1260792214000	29555	14362	110	0	\N
219000	1397	1260782213000	29555	14362	111	0	\N
219001	1397	1260772212000	29555	14362	112	0	\N
219002	1397	1260762211000	29555	14362	113	0	\N
219003	1397	1260752210000	29555	14362	114	0	\N
219004	1397	1260742209000	29555	14362	115	0	\N
219005	1397	1260732208000	29555	14362	116	0	\N
219006	1397	1260722207000	29555	14362	117	0	\N
219007	1397	1260712206000	29555	14362	118	0	\N
219008	1397	1260702205000	29555	14362	119	0	\N
219009	1397	1260692204000	29555	14362	120	0	\N
219010	1397	1260682203000	29555	14362	121	0	\N
219011	1397	1260672202000	29555	14362	122	0	\N
219012	1397	1260662201000	29555	14362	123	0	\N
219013	1397	1260652200000	29555	14362	124	0	\N
219014	1397	1260642199000	29555	14362	125	0	\N
219018	1397	1259412076000	29557	14571	0	0	\N
219019	388	66772975736837	29557	14571	1	0	\N
219020	2133	8945042000	29557	14571	2	0	\N
219028	1397	1259702105000	29560	14550	0	0	\N
219029	1397	1259692104000	29560	14550	1	0	\N
219030	613	66000090000000	29560	14550	2	0	\N
219031	1397	1259682103000	29560	14550	3	0	\N
219032	1397	1259672102000	29560	14550	4	0	\N
219033	1397	1259662101000	29560	14550	5	0	\N
219034	1397	1259652100000	29560	14550	6	0	\N
219035	1397	1259642099000	29560	14550	7	0	\N
219036	1397	1259632098000	29560	14550	8	0	\N
219037	1397	1259622097000	29560	14550	9	0	\N
219038	1397	1259612096000	29560	14550	10	0	\N
219039	1397	1259602095000	29560	14550	11	0	\N
219040	1397	1259592094000	29560	14550	12	0	\N
219041	1397	1259582093000	29560	14550	13	0	\N
219042	1397	1259572092000	29560	14550	14	0	\N
219043	1397	1259562091000	29560	14550	15	0	\N
219044	1397	1259552090000	29560	14550	16	0	\N
219045	1397	1259542089000	29560	14550	17	0	\N
219046	1397	1259532088000	29560	14550	18	0	\N
219047	1397	1259522087000	29560	14550	19	0	\N
219048	1397	1259512086000	29560	14550	20	0	\N
219049	1397	1259502085000	29560	14550	21	0	\N
219050	1397	1259492084000	29560	14550	22	0	\N
219051	1397	1259482083000	29560	14550	23	0	\N
219052	1397	1259472082000	29560	14550	24	0	\N
219053	1397	1259462081000	29560	14550	25	0	\N
219054	1397	1259452080000	29560	14550	26	0	\N
219055	1397	1259442079000	29560	14550	27	0	\N
219056	1397	1259432078000	29560	14550	28	0	\N
219057	1397	1259422077000	29560	14550	29	0	\N
219058	1397	1259412076000	29560	14550	30	0	\N
219059	1397	1259402075000	29560	14550	31	0	\N
219060	1397	1259392074000	29560	14550	32	0	\N
219061	388	66772975736837	29560	14550	33	0	\N
219062	1769	1566700000	29560	14550	34	0	\N
219063	2134	12342659000	29560	14550	35	0	\N
219064	1419	31243367559748	29560	14550	36	0	\N
219065	1726	118522112000	29560	14550	37	0	\N
219066	2134	12341655000	29560	14550	38	0	\N
219067	613	66000088910000	29560	14550	39	0	\N
219068	613	66000087820000	29560	14550	40	0	\N
219069	1419	31243366559748	29560	14550	41	0	\N
219070	1769	1565700000	29560	14550	42	0	\N
219071	1504	156244000000	29560	14550	43	0	\N
219072	2133	8975102000	29560	14550	44	0	\N
219073	2133	8974100000	29560	14550	45	0	\N
219074	2133	8973098000	29560	14550	47	0	\N
219075	2133	8972096000	29560	14550	48	0	\N
219076	2133	8971094000	29560	14550	49	0	\N
219077	2132	7038052000	29560	14550	50	0	\N
219078	2132	7037051000	29560	14550	51	0	\N
219079	2132	7036050000	29560	14550	52	0	\N
219080	2132	7035049000	29560	14550	53	0	\N
219081	2132	7034048000	29560	14550	54	0	\N
219082	2132	7033047000	29560	14550	55	0	\N
219083	2132	7032046000	29560	14550	56	0	\N
219084	2132	7031045000	29560	14550	57	0	\N
219085	2132	7030044000	29560	14550	58	0	\N
219086	2132	7029043000	29560	14550	59	0	\N
219087	2133	8970092000	29560	14550	60	0	\N
219088	2133	8969090000	29560	14550	61	0	\N
219089	2133	8968088000	29560	14550	62	0	\N
219090	2133	8967086000	29560	14550	63	0	\N
219091	2133	8966084000	29560	14550	64	0	\N
219092	2133	8965082000	29560	14550	65	0	\N
219093	2133	8964080000	29560	14550	66	0	\N
219094	2133	8963078000	29560	14550	67	0	\N
219095	2133	8962076000	29560	14550	68	0	\N
219096	2133	8961074000	29560	14550	69	0	\N
219017	2133	8945042000	29556	14571	2	0	7482
219021	1397	1259402075000	29558	14572	0	0	17942
219022	2134	12320571000	29558	14572	1	0	7996
219023	2133	8944040000	29558	14572	2	0	7483
219024	1397	1259392074000	29559	14573	0	0	17943
219026	2134	12319567000	29559	14573	2	0	7997
219027	2132	7029043000	29559	14573	3	0	1959
219097	2133	8960072000	29560	14550	70	0	\N
219098	2133	8959070000	29560	14550	71	0	\N
219099	2133	8958068000	29560	14550	72	0	\N
219100	2133	8957066000	29560	14550	73	0	\N
219101	2133	8956064000	29560	14550	74	0	\N
219102	2133	8955062000	29560	14550	75	0	\N
219103	2133	8954060000	29560	14550	76	0	\N
219104	2133	8953058000	29560	14550	77	0	\N
219105	2133	8952056000	29560	14550	78	0	\N
219106	2133	8951054000	29560	14550	79	0	\N
219107	2133	8950052000	29560	14550	80	0	\N
219108	2133	8949050000	29560	14550	81	0	\N
219109	2133	8948048000	29560	14550	82	0	\N
219110	2133	8947046000	29560	14550	83	0	\N
219111	2133	8946044000	29560	14550	84	0	\N
219112	2133	8945042000	29560	14550	85	0	\N
219113	2133	8944040000	29560	14550	86	0	\N
219114	2133	8943038000	29560	14550	87	0	\N
219115	2134	12340651000	29560	14550	88	0	\N
219116	2134	12339647000	29560	14550	89	0	\N
219117	2134	12338643000	29560	14550	90	0	\N
219118	2134	12337639000	29560	14550	91	0	\N
219119	2134	12336635000	29560	14550	92	0	\N
219120	2134	12335631000	29560	14550	93	0	\N
219121	2134	12334627000	29560	14550	94	0	\N
219122	2134	12333623000	29560	14550	95	0	\N
219123	2134	12332619000	29560	14550	96	0	\N
219124	2134	12331615000	29560	14550	97	0	\N
219125	2134	12330611000	29560	14550	98	0	\N
219126	2134	12329607000	29560	14550	99	0	\N
219127	2134	12328603000	29560	14550	100	0	\N
219128	2134	12327599000	29560	14550	101	0	\N
219129	2134	12326595000	29560	14550	102	0	\N
219130	2134	12325591000	29560	14550	103	0	\N
219131	2134	12324587000	29560	14550	104	0	\N
219132	2134	12323583000	29560	14550	105	0	\N
219133	2134	12322579000	29560	14550	106	0	\N
219134	2134	12321575000	29560	14550	107	0	\N
219135	2134	12320571000	29560	14550	108	0	\N
219136	2134	12319567000	29560	14550	109	0	\N
219149	1397	1259342069000	29563	14576	0	0	\N
219150	2133	8938028000	29563	14576	1	0	\N
219157	1397	1259322067000	29566	14578	0	0	\N
219158	1397	1259312066000	29566	14578	1	0	\N
219159	2134	12314547000	29566	14578	2	0	\N
219160	2134	12313543000	29566	14578	3	0	\N
219161	2133	8936024000	29566	14578	4	0	\N
219162	2133	8935022000	29566	14578	5	0	\N
219163	1397	1259322067000	29567	14578	0	0	\N
219164	1397	1259312066000	29567	14578	1	0	\N
219165	2134	12314547000	29567	14578	2	0	\N
219166	2134	12313543000	29567	14578	3	0	\N
219167	2133	8936024000	29567	14578	4	0	\N
219168	2133	8935022000	29567	14578	5	0	\N
219175	1397	1259322067000	29569	14578	0	0	\N
219176	1397	1259312066000	29569	14578	1	0	\N
219177	2134	12314547000	29569	14578	2	0	\N
219178	2134	12313543000	29569	14578	3	0	\N
219179	2133	8936024000	29569	14578	4	0	\N
219180	2133	8935022000	29569	14578	5	0	\N
219187	1397	1259282063000	29571	14580	0	0	\N
219188	2133	8932016000	29571	14580	1	0	\N
219189	2134	12311535000	29571	14580	2	0	\N
219190	1397	1259282063000	29572	14580	0	0	\N
219191	2133	8932016000	29572	14580	1	0	\N
219192	2134	12311535000	29572	14580	2	0	\N
219207	1397	1259242059000	29577	14584	0	0	\N
219208	2133	8928008000	29577	14584	1	0	\N
219215	1397	1259222057000	29580	14586	0	0	\N
219216	2134	12307519000	29580	14586	1	0	\N
219217	2133	8926004000	29580	14586	2	0	\N
219139	1397	1259372072000	29562	14575	0	0	17945
219140	1397	1259362071000	29562	14575	1	0	17946
219141	1397	1259352070000	29562	14575	2	0	17947
219142	2133	8941034000	29562	14575	3	0	7486
219143	2134	12318563000	29562	14575	4	0	7998
219145	2134	12316555000	29562	14575	6	0	8000
219146	2132	7028042000	29562	14575	7	0	1960
219147	2133	8940032000	29562	14575	8	0	7487
219148	2133	8939030000	29562	14575	9	0	7488
219151	1397	1259342069000	29564	14576	0	0	17948
219153	1397	1259332068000	29565	14577	0	0	17949
219154	2132	7027041000	29565	14577	1	0	1961
219155	2133	8937026000	29565	14577	2	0	7490
219156	2134	12315551000	29565	14577	3	0	8001
219170	1397	1259312066000	29568	14578	1	0	17951
219171	2134	12314547000	29568	14578	2	0	8002
219172	2134	12313543000	29568	14578	3	0	8003
219173	2133	8936024000	29568	14578	4	0	7491
219174	2133	8935022000	29568	14578	5	0	7492
219182	1397	1259292064000	29570	14579	1	0	17953
219183	2133	8934020000	29570	14579	2	0	7493
219184	2132	7026040000	29570	14579	3	0	1962
219185	2133	8933018000	29570	14579	4	0	7494
219186	2134	12312539000	29570	14579	5	0	8004
219194	2134	12311535000	29573	14580	1	0	8005
219195	1397	1259272062000	29574	14581	0	0	17955
219196	2133	8932016000	29574	14581	1	0	7495
219197	2133	8931014000	29574	14581	2	0	7496
219199	2133	8930012000	29575	14582	1	0	7497
219200	2132	7025039000	29575	14582	2	0	1963
219201	2134	12310531000	29575	14582	3	0	8006
219202	1420	1854874980000	29576	14583	0	0	2
219203	1428	2159532000000	29576	14583	1	0	1
219205	2134	12309527000	29576	14583	3	0	8007
219206	2133	8929010000	29576	14583	4	0	7498
219209	1397	1259242059000	29578	14584	0	0	17958
219210	2133	8928008000	29578	14584	1	0	7499
219211	1397	1259232058000	29579	14585	0	0	17959
219213	2133	8927006000	29579	14585	2	0	7500
219214	2134	12308523000	29579	14585	3	0	8008
219218	1397	1259222057000	29581	14586	0	0	17960
219219	2134	12307519000	29581	14586	1	0	8009
219221	1428	2158922000000	29582	14587	0	0	2
219222	1428	2157812000000	29582	14587	1	0	3
219223	1397	1259212056000	29582	14587	2	0	17961
219224	1397	1259202055000	29582	14587	3	0	17962
219225	1397	1259192054000	29582	14587	4	0	17963
219227	2134	12305511000	29582	14587	6	0	8011
219228	2133	8925002000	29582	14587	7	0	7502
219229	2133	8924000000	29582	14587	8	0	7503
219230	2133	8922998000	29582	14587	9	0	7504
219231	2132	7023037000	29582	14587	10	0	1965
219235	1397	1259182053000	29584	14588	0	0	\N
219236	2134	12304507000	29584	14588	1	0	\N
219237	2133	8921996000	29584	14588	2	0	\N
219238	1397	1259182053000	29585	14588	0	0	\N
219239	2134	12304507000	29585	14588	1	0	\N
219240	2133	8921996000	29585	14588	2	0	\N
219241	1397	1259182053000	29586	14588	0	0	\N
219242	2134	12304507000	29586	14588	1	0	\N
219243	2133	8921996000	29586	14588	2	0	\N
219244	1397	1259172052000	29587	14589	0	0	\N
219245	1397	1259162051000	29587	14589	1	0	\N
219246	2134	12303503000	29587	14589	2	0	\N
219247	2132	7022036000	29587	14589	3	0	\N
219248	281	66000899000000	29587	14589	4	0	\N
219249	1726	117421112000	29587	14589	5	0	\N
219250	2133	8920994000	29587	14589	6	0	\N
219251	2133	8919992000	29587	14589	7	0	\N
219260	1420	1854874980000	29589	14363	0	0	\N
219261	1397	1260632198000	29589	14363	1	0	\N
219262	1428	2159532000000	29589	14363	2	0	\N
219263	1428	2158922000000	29589	14363	3	0	\N
219264	1428	2157812000000	29589	14363	4	0	\N
219265	1397	1260622197000	29589	14363	5	0	\N
219266	1397	1260612196000	29589	14363	6	0	\N
219267	1397	1260602195000	29589	14363	7	0	\N
219268	1397	1260592194000	29589	14363	8	0	\N
219269	1397	1260582193000	29589	14363	9	0	\N
219270	1397	1260572192000	29589	14363	10	0	\N
219271	1397	1260562191000	29589	14363	11	0	\N
219272	1397	1260552190000	29589	14363	12	0	\N
219273	1397	1260542189000	29589	14363	13	0	\N
219274	1397	1260532188000	29589	14363	14	0	\N
219275	1397	1260522187000	29589	14363	15	0	\N
219276	1397	1260512186000	29589	14363	16	0	\N
219277	1397	1260502185000	29589	14363	17	0	\N
219278	1397	1260492184000	29589	14363	18	0	\N
219279	1397	1260482183000	29589	14363	19	0	\N
219280	1397	1260472182000	29589	14363	20	0	\N
219281	1397	1260462181000	29589	14363	21	0	\N
219282	1397	1260452180000	29589	14363	22	0	\N
219283	1397	1260442179000	29589	14363	23	0	\N
219284	1397	1260432178000	29589	14363	24	0	\N
219285	1397	1260422177000	29589	14363	25	0	\N
219286	1397	1260412176000	29589	14363	26	0	\N
219287	1397	1260402175000	29589	14363	27	0	\N
219288	1397	1260392174000	29589	14363	28	0	\N
219289	1397	1260382173000	29589	14363	29	0	\N
219290	1397	1260372172000	29589	14363	30	0	\N
219291	1397	1260362171000	29589	14363	31	0	\N
219292	1397	1260352170000	29589	14363	32	0	\N
219293	1397	1260342169000	29589	14363	33	0	\N
219294	1397	1260332168000	29589	14363	34	0	\N
219295	1397	1260322167000	29589	14363	35	0	\N
219296	1397	1260312166000	29589	14363	36	0	\N
219297	1397	1260302165000	29589	14363	37	0	\N
219298	1397	1260292164000	29589	14363	38	0	\N
219299	1397	1260282163000	29589	14363	39	0	\N
219300	1397	1260272162000	29589	14363	40	0	\N
219301	1397	1260262161000	29589	14363	41	0	\N
219302	1397	1260252160000	29589	14363	42	0	\N
219303	1397	1260242159000	29589	14363	43	0	\N
219304	1397	1260232158000	29589	14363	44	0	\N
219305	1397	1260222157000	29589	14363	45	0	\N
219306	1397	1260212156000	29589	14363	46	0	\N
219307	1397	1260202155000	29589	14363	47	0	\N
219308	1397	1260192154000	29589	14363	48	0	\N
219309	1397	1260182153000	29589	14363	49	0	\N
219310	1397	1260172152000	29589	14363	50	0	\N
219311	1397	1260162151000	29589	14363	51	0	\N
219312	1397	1260152150000	29589	14363	52	0	\N
219313	1397	1260142149000	29589	14363	53	0	\N
219314	1397	1260132148000	29589	14363	54	0	\N
219315	1397	1260122147000	29589	14363	55	0	\N
219316	1397	1260112146000	29589	14363	56	0	\N
219317	1397	1260102145000	29589	14363	57	0	\N
219318	1397	1260092144000	29589	14363	58	0	\N
219319	1397	1260082143000	29589	14363	59	0	\N
219320	1397	1260072142000	29589	14363	60	0	\N
219321	1397	1260062141000	29589	14363	61	0	\N
219322	1397	1260052140000	29589	14363	62	0	\N
219323	1397	1260042139000	29589	14363	63	0	\N
219324	1397	1260032138000	29589	14363	64	0	\N
219325	1397	1260022137000	29589	14363	65	0	\N
219326	1397	1260012136000	29589	14363	66	0	\N
219327	1397	1260002135000	29589	14363	67	0	\N
219328	1397	1259992134000	29589	14363	68	0	\N
219329	1397	1259982133000	29589	14363	69	0	\N
219330	1397	1259972132000	29589	14363	70	0	\N
219331	1397	1259962131000	29589	14363	71	0	\N
219332	1397	1259952130000	29589	14363	72	0	\N
219333	1397	1259942129000	29589	14363	73	0	\N
219334	1397	1259932128000	29589	14363	74	0	\N
219335	1397	1259922127000	29589	14363	75	0	\N
219336	1397	1259912126000	29589	14363	76	0	\N
219337	1397	1259902125000	29589	14363	77	0	\N
219338	1397	1259892124000	29589	14363	78	0	\N
219339	1397	1259882123000	29589	14363	79	0	\N
219340	1397	1259872122000	29589	14363	80	0	\N
219341	1397	1259862121000	29589	14363	81	0	\N
219342	1397	1259852120000	29589	14363	82	0	\N
219343	1397	1259842119000	29589	14363	84	0	\N
219344	1397	1259832118000	29589	14363	85	0	\N
219345	1397	1259822117000	29589	14363	86	0	\N
219346	1397	1259812116000	29589	14363	87	0	\N
219347	1397	1259802115000	29589	14363	88	0	\N
219348	1397	1259792114000	29589	14363	89	0	\N
219349	1397	1259782113000	29589	14363	90	0	\N
219350	1397	1259772112000	29589	14363	91	0	\N
219351	1397	1259762111000	29589	14363	92	0	\N
219352	1397	1259752110000	29589	14363	93	0	\N
219353	1397	1259742109000	29589	14363	94	0	\N
219354	1397	1259732108000	29589	14363	95	0	\N
219355	1397	1259722107000	29589	14363	96	0	\N
219361	1397	1259152050000	29591	14590	0	0	\N
219362	1397	1259142049000	29591	14590	1	0	\N
219363	2134	12302499000	29591	14590	2	0	\N
219364	2133	8918990000	29591	14590	3	0	\N
219365	2134	12301495000	29591	14590	4	0	\N
219252	1397	1259172052000	29588	14589	0	0	17965
219253	1397	1259162051000	29588	14589	1	0	17966
219254	2134	12303503000	29588	14589	2	0	8013
219255	2132	7022036000	29588	14589	3	0	1966
219256	281	66000899000000	29588	14589	4	0	2
219258	2133	8920994000	29588	14589	6	0	7506
219259	2133	8919992000	29588	14589	7	0	7507
219356	1397	1259152050000	29590	14590	0	0	17967
219357	1397	1259142049000	29590	14590	1	0	17968
219358	2134	12302499000	29590	14590	2	0	8014
219360	2134	12301495000	29590	14590	4	0	8015
219366	1397	1259132048000	29592	14591	0	0	17969
219367	1397	1259122047000	29592	14591	1	0	17970
219368	2134	12300491000	29592	14591	2	0	8016
219372	1397	1259132048000	29593	14591	0	0	\N
219373	1397	1259122047000	29593	14591	1	0	\N
219374	2134	12300491000	29593	14591	2	0	\N
219375	2133	8917988000	29593	14591	3	0	\N
219376	2133	8916986000	29593	14591	4	0	\N
219377	2132	7021035000	29593	14591	5	0	\N
219381	1397	1259102045000	29595	14593	0	0	\N
219382	1397	1259092044000	29595	14593	1	0	\N
219383	1397	1259082043000	29595	14593	2	0	\N
219384	1397	1259072042000	29595	14593	3	0	\N
219385	2134	12298483000	29595	14593	4	0	\N
219386	2134	12297479000	29595	14593	5	0	\N
219387	2133	8914982000	29595	14593	6	0	\N
219388	2133	8913980000	29595	14593	7	0	\N
219389	2134	12296475000	29595	14593	8	0	\N
219390	2133	8912978000	29595	14593	9	0	\N
219391	2133	8911976000	29595	14593	10	0	\N
219392	2132	7020034000	29595	14593	11	0	\N
219413	1397	1259032038000	29599	14596	0	0	\N
219414	2132	7018032000	29599	14596	1	0	\N
219415	2134	12294467000	29599	14596	2	0	\N
219416	2133	8907968000	29599	14596	3	0	\N
219428	1420	1854874980000	29603	14551	0	0	\N
219429	1428	2159532000000	29603	14551	1	0	\N
219430	1428	2158922000000	29603	14551	2	0	\N
219431	1397	1259382073000	29603	14551	3	0	\N
219432	1397	1259372072000	29603	14551	4	0	\N
219433	1428	2157812000000	29603	14551	5	0	\N
219434	1397	1259362071000	29603	14551	6	0	\N
219435	1397	1259352070000	29603	14551	7	0	\N
219436	1397	1259342069000	29603	14551	8	0	\N
219437	1397	1259332068000	29603	14551	9	0	\N
219438	1397	1259322067000	29603	14551	10	0	\N
219439	1397	1259312066000	29603	14551	11	0	\N
219440	1397	1259302065000	29603	14551	12	0	\N
219441	1397	1259292064000	29603	14551	13	0	\N
219442	1397	1259282063000	29603	14551	14	0	\N
219443	1397	1259272062000	29603	14551	15	0	\N
219444	1397	1259262061000	29603	14551	16	0	\N
219445	1397	1259252060000	29603	14551	17	0	\N
219446	1397	1259242059000	29603	14551	18	0	\N
219447	1397	1259232058000	29603	14551	19	0	\N
219448	1397	1259222057000	29603	14551	20	0	\N
219449	1397	1259212056000	29603	14551	21	0	\N
219450	1397	1259202055000	29603	14551	22	0	\N
219451	1397	1259192054000	29603	14551	23	0	\N
219452	1397	1259182053000	29603	14551	24	0	\N
219453	1397	1259172052000	29603	14551	25	0	\N
219454	1397	1259162051000	29603	14551	26	0	\N
219455	1397	1259152050000	29603	14551	27	0	\N
219456	1397	1259142049000	29603	14551	28	0	\N
219457	1397	1259132048000	29603	14551	29	0	\N
219458	1397	1259122047000	29603	14551	30	0	\N
219459	1397	1259112046000	29603	14551	31	0	\N
219460	1397	1259102045000	29603	14551	32	0	\N
219461	1397	1259092044000	29603	14551	33	0	\N
219462	1397	1259082043000	29603	14551	34	0	\N
219463	1397	1259072042000	29603	14551	35	0	\N
219464	1397	1259062041000	29603	14551	36	0	\N
219465	1397	1259052040000	29603	14551	37	0	\N
219466	1397	1259042039000	29603	14551	38	0	\N
219467	1397	1259032038000	29603	14551	39	0	\N
219468	1397	1259022037000	29603	14551	40	0	\N
219469	1397	1259012036000	29603	14551	41	0	\N
219470	1397	1259002035000	29603	14551	42	0	\N
219471	281	66000899000000	29603	14551	43	0	\N
219472	1726	117421112000	29603	14551	44	0	\N
219473	1597	5811000000	29603	14551	45	0	\N
219474	2134	12318563000	29603	14551	46	0	\N
219475	2134	12317559000	29603	14551	47	0	\N
219476	2134	12316555000	29603	14551	48	0	\N
219477	2134	12315551000	29603	14551	49	0	\N
219478	2134	12314547000	29603	14551	50	0	\N
219479	2134	12313543000	29603	14551	51	0	\N
219480	2132	7028042000	29603	14551	52	0	\N
219481	2132	7027041000	29603	14551	53	0	\N
219482	2132	7026040000	29603	14551	54	0	\N
219483	2132	7025039000	29603	14551	55	0	\N
219484	2132	7024038000	29603	14551	56	0	\N
219485	2134	12312539000	29603	14551	57	0	\N
219486	2134	12311535000	29603	14551	58	0	\N
219487	2134	12310531000	29603	14551	59	0	\N
219488	2134	12309527000	29603	14551	60	0	\N
219489	2134	12308523000	29603	14551	61	0	\N
219490	2134	12307519000	29603	14551	63	0	\N
219491	2134	12306515000	29603	14551	64	0	\N
219492	2134	12305511000	29603	14551	65	0	\N
219493	2134	12304507000	29603	14551	66	0	\N
219494	2134	12303503000	29603	14551	67	0	\N
219495	2134	12302499000	29603	14551	68	0	\N
219496	2133	8942036000	29603	14551	69	0	\N
219497	2133	8941034000	29603	14551	70	0	\N
219498	2133	8940032000	29603	14551	71	0	\N
219499	2133	8939030000	29603	14551	72	0	\N
219500	2133	8938028000	29603	14551	73	0	\N
219501	2133	8937026000	29603	14551	74	0	\N
219502	2133	8936024000	29603	14551	75	0	\N
219503	2133	8935022000	29603	14551	76	0	\N
219504	2133	8934020000	29603	14551	77	0	\N
219371	2132	7021035000	29592	14591	5	0	1967
219378	1397	1259112046000	29594	14592	0	0	17971
219379	2134	12299487000	29594	14592	1	0	8017
219380	2133	8915984000	29594	14592	2	0	7511
219393	1397	1259102045000	29596	14593	0	0	17972
219395	1397	1259082043000	29596	14593	2	0	17974
219396	1397	1259072042000	29596	14593	3	0	17975
219397	2134	12298483000	29596	14593	4	0	8018
219398	2134	12297479000	29596	14593	5	0	8019
219399	2133	8914982000	29596	14593	6	0	7512
219401	2134	12296475000	29596	14593	8	0	8020
219402	2133	8912978000	29596	14593	9	0	7514
219403	2133	8911976000	29596	14593	10	0	7515
219404	2132	7020034000	29596	14593	11	0	1968
219406	1397	1259052040000	29597	14594	2	0	17977
219407	2133	8910974000	29597	14594	3	0	7516
219408	2132	7019033000	29597	14594	4	0	1969
219409	2133	8909972000	29597	14594	5	0	7517
219410	2134	12295471000	29597	14594	6	0	8021
219412	2133	8908970000	29598	14595	1	0	7518
219417	1397	1259032038000	29600	14596	0	0	17979
219418	2134	12294467000	29600	14596	1	0	8022
219419	2133	8907968000	29600	14596	2	0	7519
219420	1397	1259022037000	29601	14597	0	0	17980
219422	2132	7018032000	29601	14597	2	0	1970
219423	1597	5811000000	29601	14597	3	0	6
219424	2133	8906966000	29601	14597	4	0	7520
219425	1397	1259012036000	29602	14598	0	0	17981
219427	2134	12292459000	29602	14598	2	0	8024
219505	2133	8933018000	29603	14551	78	0	\N
219506	2133	8932016000	29603	14551	79	0	\N
219507	2133	8931014000	29603	14551	80	0	\N
219508	2133	8930012000	29603	14551	81	0	\N
219509	2133	8929010000	29603	14551	82	0	\N
219510	2133	8928008000	29603	14551	83	0	\N
219511	2133	8927006000	29603	14551	84	0	\N
219512	2133	8926004000	29603	14551	85	0	\N
219513	2133	8925002000	29603	14551	86	0	\N
219514	2133	8924000000	29603	14551	87	0	\N
219515	2133	8922998000	29603	14551	88	0	\N
219516	2133	8921996000	29603	14551	89	0	\N
219517	2133	8920994000	29603	14551	90	0	\N
219518	2133	8919992000	29603	14551	91	0	\N
219519	2133	8918990000	29603	14551	92	0	\N
219520	2133	8917988000	29603	14551	93	0	\N
219521	2133	8916986000	29603	14551	94	0	\N
219522	2133	8915984000	29603	14551	95	0	\N
219523	2133	8914982000	29603	14551	96	0	\N
219524	2133	8913980000	29603	14551	97	0	\N
219525	2133	8912978000	29603	14551	98	0	\N
219526	2133	8911976000	29603	14551	99	0	\N
219527	2133	8910974000	29603	14551	100	0	\N
219528	2133	8909972000	29603	14551	101	0	\N
219529	2133	8908970000	29603	14551	102	0	\N
219530	2133	8907968000	29603	14551	103	0	\N
219531	2133	8906966000	29603	14551	104	0	\N
219532	2133	8905964000	29603	14551	105	0	\N
219533	2133	8904962000	29603	14551	106	0	\N
219534	2132	7023037000	29603	14551	107	0	\N
219535	2132	7022036000	29603	14551	108	0	\N
219536	2132	7021035000	29603	14551	109	0	\N
219537	2132	7020034000	29603	14551	110	0	\N
219538	2132	7019033000	29603	14551	111	0	\N
219539	2132	7018032000	29603	14551	112	0	\N
219540	2134	12301495000	29603	14551	113	0	\N
219541	2134	12300491000	29603	14551	114	0	\N
219542	2134	12299487000	29603	14551	115	0	\N
219543	2134	12298483000	29603	14551	116	0	\N
219544	2134	12297479000	29603	14551	117	0	\N
219545	2134	12296475000	29603	14551	118	0	\N
219546	2134	12295471000	29603	14551	119	0	\N
219547	2134	12294467000	29603	14551	120	0	\N
219548	2134	12293463000	29603	14551	121	0	\N
219549	2134	12292459000	29603	14551	122	0	\N
219556	1397	1258982033000	29606	14601	0	0	\N
219557	2134	12290451000	29606	14601	1	0	\N
219558	2133	8902958000	29606	14601	2	0	\N
219559	1397	1258982033000	29607	14601	0	0	\N
219560	2134	12290451000	29607	14601	1	0	\N
219561	2133	8902958000	29607	14601	2	0	\N
219568	556	66720035511028	29610	14602	0	0	\N
219569	1397	1258972032000	29610	14602	1	0	\N
219570	2133	8901956000	29610	14602	2	0	\N
219591	1397	1258922027000	29613	14604	0	0	\N
219592	1397	1258912026000	29613	14604	1	0	\N
219593	2055	2159023000000	29613	14604	2	0	\N
219594	2133	8896946000	29613	14604	3	0	\N
219595	2133	8895944000	29613	14604	4	0	\N
219596	2134	12286435000	29613	14604	5	0	\N
219597	2134	12285431000	29613	14604	6	0	\N
219601	1397	1258892024000	29615	14606	0	0	\N
219602	2133	8893940000	29615	14606	1	0	\N
219603	2132	7014028000	29615	14606	2	0	\N
219605	1397	1258892024000	29617	14607	0	0	\N
219606	2425	90000000	29617	14607	1	0	\N
219607	1397	1258882023000	29617	14607	2	0	\N
219608	1397	1258872022000	29617	14607	3	0	\N
219609	2134	12283423000	29617	14607	4	0	\N
219610	2133	8893940000	29617	14607	5	0	\N
219611	2133	8892938000	29617	14607	6	0	\N
219612	2133	8891936000	29617	14607	7	0	\N
219613	2134	12282419000	29617	14607	8	0	\N
219623	1397	1258892024000	29619	14607	0	0	\N
219624	2425	90000000	29619	14607	1	0	\N
219625	1397	1258882023000	29619	14607	2	0	\N
219626	1397	1258872022000	29619	14607	3	0	\N
219627	2134	12283423000	29619	14607	4	0	\N
219628	2133	8893940000	29619	14607	5	0	\N
219629	2133	8892938000	29619	14607	6	0	\N
219630	2133	8891936000	29619	14607	7	0	\N
219631	2134	12282419000	29619	14607	8	0	\N
219638	1397	1258862021000	29621	14608	0	0	\N
219639	1397	1258852020000	29621	14608	1	0	\N
219640	2133	8890934000	29621	14608	2	0	\N
219552	1397	1258992034000	29605	14600	0	0	17983
219553	2134	12291455000	29605	14600	1	0	8025
219554	2132	7017031000	29605	14600	2	0	1971
219555	2133	8903960000	29605	14600	3	0	7523
219562	1397	1258982033000	29608	14601	0	0	17984
219564	2133	8902958000	29608	14601	2	0	7524
219565	556	66720035511028	29609	14602	0	0	1
219566	1397	1258972032000	29609	14602	1	0	17985
219567	2133	8901956000	29609	14602	2	0	7525
219571	1397	1258962031000	29611	14603	0	0	17986
219573	1397	1258942029000	29611	14603	2	0	17988
219574	1397	1258932028000	29611	14603	3	0	17989
219575	2134	12289447000	29611	14603	4	0	8027
219576	2134	12288443000	29611	14603	5	0	8028
219578	2134	12287439000	29611	14603	7	0	8029
219579	2133	8900954000	29611	14603	8	0	7526
219580	2133	8899952000	29611	14603	9	0	7527
219581	2133	8898950000	29611	14603	10	0	7528
219582	2133	8897948000	29611	14603	11	0	7529
219584	1397	1258922027000	29612	14604	0	0	17990
219585	1397	1258912026000	29612	14604	1	0	17991
219586	2055	2159023000000	29612	14604	2	0	1
219587	2133	8896946000	29612	14604	3	0	7530
219588	2133	8895944000	29612	14604	4	0	7531
219590	2134	12285431000	29612	14604	6	0	8031
219598	1397	1258902025000	29614	14605	0	0	17992
219599	2133	8894942000	29614	14605	1	0	7532
219600	2134	12284427000	29614	14605	2	0	8032
219614	1397	1258892024000	29618	14607	0	0	17993
219615	2425	90000000	29618	14607	1	0	1
219616	1397	1258882023000	29618	14607	2	0	17994
219617	1397	1258872022000	29618	14607	3	0	17995
219618	2134	12283423000	29618	14607	4	0	8033
219620	2133	8892938000	29618	14607	6	0	7534
219621	2133	8891936000	29618	14607	7	0	7535
219622	2134	12282419000	29618	14607	8	0	8034
219632	1397	1258862021000	29620	14608	0	0	17996
219633	1397	1258852020000	29620	14608	1	0	17997
219635	2133	8889932000	29620	14608	3	0	7537
219636	2132	7013027000	29620	14608	4	0	1975
219637	2134	12281415000	29620	14608	5	0	8035
219641	2133	8889932000	29621	14608	3	0	\N
219642	2132	7013027000	29621	14608	4	0	\N
219643	2134	12281415000	29621	14608	5	0	\N
219644	1397	1258862021000	29622	14608	0	0	\N
219645	1397	1258852020000	29622	14608	1	0	\N
219646	2133	8890934000	29622	14608	2	0	\N
219647	2133	8889932000	29622	14608	3	0	\N
219648	2132	7013027000	29622	14608	4	0	\N
219649	2134	12281415000	29622	14608	5	0	\N
219656	1397	1258842019000	29624	14609	0	0	\N
219657	1397	1258832018000	29624	14609	1	0	\N
219658	2427	96750000	29624	14609	2	0	\N
219659	2133	8888930000	29624	14609	3	0	\N
219660	2133	8887928000	29624	14609	4	0	\N
219661	2134	12280411000	29624	14609	5	0	\N
219662	1397	1258822017000	29625	14610	0	0	\N
219663	1397	1258812016000	29625	14610	1	0	\N
219664	1397	1258802015000	29625	14610	2	0	\N
219665	1397	1258792014000	29625	14610	3	0	\N
219666	2134	12279407000	29625	14610	4	0	\N
219667	2134	12278403000	29625	14610	5	0	\N
219668	2132	7012026000	29625	14610	6	0	\N
219669	2134	12277399000	29625	14610	7	0	\N
219670	2133	8886926000	29625	14610	8	0	\N
219671	2133	8885924000	29625	14610	9	0	\N
219672	2133	8884922000	29625	14610	10	0	\N
219673	2133	8883920000	29625	14610	11	0	\N
219674	2132	7011025000	29625	14610	12	0	\N
219688	1397	1258782013000	29627	14611	0	0	\N
219689	2134	12276395000	29627	14611	1	0	\N
219690	2133	8882918000	29627	14611	2	0	\N
219691	2134	12276395000	29628	14611	0	0	\N
219692	2133	8882918000	29628	14611	1	0	\N
219707	1397	1258772012000	29633	14613	0	0	\N
219708	1397	1258762011000	29633	14613	1	0	\N
219709	1397	1258752010000	29633	14613	2	0	\N
219710	2428	189000000	29633	14613	3	0	\N
219711	2132	7010024000	29633	14613	4	0	\N
219712	1726	116320112000	29633	14613	5	0	\N
219713	2134	12275391000	29633	14613	6	0	\N
219714	2134	12274387000	29633	14613	7	0	\N
219715	2133	8881916000	29633	14613	8	0	\N
219716	2133	8880914000	29633	14613	9	0	\N
219717	2133	8879912000	29633	14613	10	0	\N
219724	1397	1258732008000	29636	14615	0	0	\N
219725	309	66846780394804	29636	14615	1	0	\N
219726	2133	8877908000	29636	14615	2	0	\N
219727	1397	1258732008000	29637	14615	0	0	\N
219728	309	66846780394804	29637	14615	1	0	\N
219737	1397	1258712006000	29641	14617	0	0	\N
219738	2133	8875904000	29641	14617	1	0	\N
219739	2134	12271375000	29641	14617	2	0	\N
219742	1397	1258702005000	29643	14618	0	0	\N
219743	2134	12270371000	29643	14618	1	0	\N
219744	2133	8874902000	29643	14618	2	0	\N
219745	1397	1258702005000	29644	14618	0	0	\N
219746	2134	12270371000	29644	14618	1	0	\N
219747	2133	8874902000	29644	14618	2	0	\N
219757	1397	1258682003000	29647	14620	0	0	\N
219758	2134	12269367000	29647	14620	1	0	\N
219759	2132	7007021000	29647	14620	2	0	\N
219760	2134	12268363000	29647	14620	3	0	\N
219761	2133	8872898000	29647	14620	4	0	\N
219762	1397	1258672002000	29648	14621	0	0	\N
219763	2132	7006020000	29648	14621	1	0	\N
219764	2134	12267359000	29648	14621	2	0	\N
219765	2134	12266355000	29648	14621	3	0	\N
219766	2134	12265351000	29648	14621	4	0	\N
219767	2134	12264347000	29648	14621	5	0	\N
219652	2427	96750000	29623	14609	2	0	1
219653	2133	8888930000	29623	14609	3	0	7538
219654	2133	8887928000	29623	14609	4	0	7539
219655	2134	12280411000	29623	14609	5	0	8036
219675	1397	1258822017000	29626	14610	0	0	18000
219677	1397	1258802015000	29626	14610	2	0	18002
219678	1397	1258792014000	29626	14610	3	0	18003
219679	2134	12279407000	29626	14610	4	0	8037
219680	2134	12278403000	29626	14610	5	0	8038
219681	2132	7012026000	29626	14610	6	0	1976
219683	2133	8886926000	29626	14610	8	0	7540
219684	2133	8885924000	29626	14610	9	0	7541
219685	2133	8884922000	29626	14610	10	0	7542
219686	2133	8883920000	29626	14610	11	0	7543
219693	1397	1258782013000	29629	14611	0	0	18004
219694	2134	12276395000	29629	14611	1	0	8040
219695	2133	8882918000	29629	14611	2	0	7544
219696	1397	1258772012000	29632	14613	0	0	18005
219697	1397	1258762011000	29632	14613	1	0	18006
219699	2428	189000000	29632	14613	3	0	1
219700	2132	7010024000	29632	14613	4	0	1978
219701	1726	116320112000	29632	14613	5	0	8365
219702	2134	12275391000	29632	14613	6	0	8041
219703	2134	12274387000	29632	14613	7	0	8042
219705	2133	8880914000	29632	14613	9	0	7546
219706	2133	8879912000	29632	14613	10	0	7547
219718	1397	1258742009000	29634	14614	0	0	18008
219719	2134	12273383000	29634	14614	1	0	8043
219721	1397	1258732008000	29635	14615	0	0	18009
219722	309	66846780394804	29635	14615	1	0	1
219723	2133	8877908000	29635	14615	2	0	7549
219729	1397	1258722007000	29639	14616	0	0	18010
219730	2132	7009023000	29639	14616	1	0	1979
219732	2134	12272379000	29639	14616	3	0	8044
219733	718	2000001000000	29639	14616	4	0	1
219734	1397	1258712006000	29640	14617	0	0	18011
219735	2133	8875904000	29640	14617	1	0	7551
219736	2134	12271375000	29640	14617	2	0	8045
219741	2134	12270371000	29642	14618	1	0	8046
219748	1397	1258692004000	29645	14619	0	0	18013
219749	2132	7008022000	29645	14619	1	0	1980
219750	2133	8874902000	29645	14619	2	0	7552
219752	1397	1258682003000	29646	14620	0	0	18014
219753	2134	12269367000	29646	14620	1	0	8047
219754	2132	7007021000	29646	14620	2	0	1981
219755	2134	12268363000	29646	14620	3	0	8048
219756	2133	8872898000	29646	14620	4	0	7554
219769	2132	7006020000	29649	14621	1	0	1982
219770	2133	8871896000	29649	14621	2	0	7555
219771	2134	12267359000	29649	14621	3	0	8049
219772	2133	8870894000	29649	14621	4	0	7556
219773	2133	8869892000	29649	14621	5	0	7557
219775	2134	12265351000	29649	14621	7	0	8051
219776	2134	12264347000	29649	14621	8	0	8052
219803	1397	1258641999000	29652	14623	0	0	\N
219804	2134	12257319000	29652	14623	1	0	\N
219805	2133	8862878000	29652	14623	2	0	\N
219806	2132	7001015000	29652	14623	3	0	\N
219807	2134	12256315000	29652	14623	4	0	\N
219808	2134	12255311000	29652	14623	5	0	\N
219809	2133	8861876000	29652	14623	6	0	\N
219810	1397	1258641999000	29653	14623	0	0	\N
219811	2134	12257319000	29653	14623	1	0	\N
219812	2133	8862878000	29653	14623	2	0	\N
219813	2132	7001015000	29653	14623	3	0	\N
219814	2134	12256315000	29653	14623	4	0	\N
219815	2134	12255311000	29653	14623	5	0	\N
219816	2133	8861876000	29653	14623	6	0	\N
219876	1397	1258581993000	29657	14626	0	0	\N
219877	1397	1258571992000	29657	14626	1	0	\N
219878	2134	12235231000	29657	14626	2	0	\N
219879	2132	6993007000	29657	14626	3	0	\N
219880	2132	6992006000	29657	14626	4	0	\N
219881	2132	6991005000	29657	14626	5	0	\N
219882	2133	8845844000	29657	14626	6	0	\N
219883	2133	8844842000	29657	14626	7	0	\N
219884	2134	12234227000	29657	14626	8	0	\N
219885	2055	2159021000000	29657	14626	9	0	\N
219886	2134	12233223000	29657	14626	10	0	\N
219887	2134	12232219000	29657	14626	11	0	\N
219888	2134	12231215000	29657	14626	12	0	\N
219889	2134	12230211000	29657	14626	13	0	\N
219890	2134	12229207000	29657	14626	14	0	\N
219891	2134	12228203000	29657	14626	15	0	\N
219892	2134	12227199000	29657	14626	16	0	\N
219893	718	2000001000000	29657	14626	17	0	\N
219894	2133	8843840000	29657	14626	18	0	\N
219895	2133	8842838000	29657	14626	19	0	\N
219896	2133	8841836000	29657	14626	20	0	\N
219897	2133	8840834000	29657	14626	21	0	\N
219779	1397	1258652000000	29650	14622	2	0	18017
219780	2133	8868890000	29650	14622	3	0	7558
219781	2133	8867888000	29650	14622	4	0	7559
219782	2133	8866886000	29650	14622	5	0	7560
219783	2134	12263343000	29650	14622	6	0	8053
219785	2134	12261335000	29650	14622	8	0	8055
219786	2133	8865884000	29650	14622	9	0	7561
219787	2134	12260331000	29650	14622	10	0	8056
219788	2133	8864882000	29650	14622	11	0	7562
219789	2132	7005019000	29650	14622	12	0	1983
219791	2132	7003017000	29650	14622	14	0	1985
219792	2132	7002016000	29650	14622	15	0	1986
219793	2133	8863880000	29650	14622	16	0	7563
219794	2134	12259327000	29650	14622	17	0	8057
219796	1397	1258641999000	29651	14623	0	0	18018
219797	2134	12257319000	29651	14623	1	0	8059
219798	2133	8862878000	29651	14623	2	0	7564
219799	2132	7001015000	29651	14623	3	0	1987
219800	2134	12256315000	29651	14623	4	0	8060
219802	2133	8861876000	29651	14623	6	0	7565
219817	389	68159958000000	29654	14624	0	0	1
219818	744	2016912805578	29654	14624	1	0	1
219819	1397	1258631998000	29654	14624	2	0	18019
219820	1397	1258621997000	29654	14624	3	0	18020
219822	2133	8859872000	29654	14624	5	0	7567
219823	2133	8858870000	29654	14624	6	0	7568
219824	2133	8857868000	29654	14624	7	0	7569
219825	2133	8856866000	29654	14624	8	0	7570
219827	2134	12254307000	29654	14624	10	0	8062
219828	2134	12253303000	29654	14624	11	0	8063
219829	2134	12252299000	29654	14624	12	0	8064
219830	2134	12251295000	29654	14624	13	0	8065
219831	2134	12250291000	29654	14624	14	0	8066
219833	2134	12248283000	29654	14624	16	0	8068
219834	2132	7000014000	29654	14624	17	0	1988
219835	2132	6999013000	29654	14624	18	0	1989
219836	2132	6998012000	29654	14624	19	0	1990
219837	379	66190536998665	29655	14625	0	0	2
219839	1397	1258611996000	29655	14625	2	0	18021
219840	1397	1258601995000	29655	14625	3	0	18022
219841	1397	1258591994000	29655	14625	4	0	18023
219842	2134	12247279000	29655	14625	5	0	8069
219844	2132	6997011000	29655	14625	7	0	1991
219845	2133	8854862000	29655	14625	8	0	7572
219846	2133	8853860000	29655	14625	9	0	7573
219847	2133	8852858000	29655	14625	10	0	7574
219848	2132	6996010000	29655	14625	11	0	1992
219850	2133	8851856000	29655	14625	14	0	7575
219851	2133	8850854000	29655	14625	15	0	7576
219852	2133	8849852000	29655	14625	16	0	7577
219853	2133	8848850000	29655	14625	17	0	7578
219854	2133	8847848000	29655	14625	18	0	7579
219856	2132	6994008000	29655	14625	20	0	1994
219857	2134	12245271000	29655	14625	21	0	8071
219858	2134	12244267000	29655	14625	22	0	8072
219859	2134	12243263000	29655	14625	23	0	8073
219861	2134	12241255000	29655	14625	25	0	8075
219862	2134	12240251000	29655	14625	26	0	8076
219863	2134	12239247000	29655	14625	27	0	8077
219864	2134	12238243000	29655	14625	28	0	8078
219865	2134	12237239000	29655	14625	29	0	8079
219867	2134	12235231000	29656	14626	0	0	8081
219868	2132	6993007000	29656	14626	1	0	1995
219869	2132	6992006000	29656	14626	2	0	1996
219870	2133	8845844000	29656	14626	3	0	7581
219871	2133	8844842000	29656	14626	4	0	7582
219873	2134	12233223000	29656	14626	6	0	8083
219874	2134	12232219000	29656	14626	7	0	8084
219875	718	2000000000000	29656	14626	8	0	2
219898	1397	1258581993000	29658	14627	0	0	18024
219900	2132	6991005000	29658	14627	2	0	1997
219901	2132	6990004000	29658	14627	3	0	1998
219902	2134	12231215000	29658	14627	4	0	8085
219903	2134	12230211000	29658	14627	5	0	8086
219904	2134	12229207000	29658	14627	6	0	8087
219906	2134	12227199000	29658	14627	8	0	8089
219907	2055	2159021000000	29658	14627	9	0	2
219908	2133	8843840000	29658	14627	10	0	7583
219909	2133	8842838000	29658	14627	11	0	7584
219910	2133	8841836000	29658	14627	12	0	7585
219912	1397	1258561991000	29659	14628	0	0	18026
219935	1397	1258531988000	29661	14630	0	0	\N
219936	2134	12217159000	29661	14630	1	0	\N
219937	2134	12216155000	29661	14630	2	0	\N
219938	2134	12215151000	29661	14630	3	0	\N
219939	2132	6984999000	29661	14630	4	0	\N
219940	718	2000000000000	29661	14630	5	0	\N
219941	1397	1258531988000	29662	14630	0	0	\N
219942	2134	12217159000	29662	14630	1	0	\N
219943	2134	12216155000	29662	14630	2	0	\N
219944	2134	12215151000	29662	14630	3	0	\N
219945	2132	6984999000	29662	14630	4	0	\N
219946	718	2000000000000	29662	14630	5	0	\N
219947	2133	8832818000	29662	14630	6	0	\N
219948	2133	8831816000	29662	14630	7	0	\N
219949	2133	8830814000	29662	14630	8	0	\N
219995	1397	1258481983000	29666	14633	0	0	\N
219996	1397	1258471982000	29666	14633	1	0	\N
219997	2132	6977992000	29666	14633	3	0	\N
219998	2133	8818790000	29666	14633	4	0	\N
219999	2133	8817788000	29666	14633	5	0	\N
220000	2133	8816786000	29666	14633	6	0	\N
220001	2133	8815784000	29666	14633	7	0	\N
220002	2133	8814782000	29666	14633	8	0	\N
220003	2134	12201095000	29666	14633	9	0	\N
220004	2134	12200091000	29666	14633	10	0	\N
220005	2134	12199087000	29666	14633	11	0	\N
220006	2134	12198083000	29666	14633	12	0	\N
220007	2134	12197079000	29666	14633	13	0	\N
220008	2134	12196075000	29666	14633	14	0	\N
220009	2134	12195071000	29666	14633	15	0	\N
220010	2134	12194067000	29666	14633	16	0	\N
220011	2132	6976991000	29666	14633	17	0	\N
220012	2132	6975990000	29666	14633	18	0	\N
220031	1397	1258461981000	29668	14634	0	0	\N
220032	2133	8813780000	29668	14634	1	0	\N
220033	2132	6974989000	29668	14634	2	0	\N
220034	2132	6973988000	29668	14634	3	0	\N
220035	2133	8812778000	29668	14634	4	0	\N
220036	2133	8811776000	29668	14634	5	0	\N
220037	2134	12193063000	29668	14634	6	0	\N
220038	2134	12192059000	29668	14634	7	0	\N
220039	2134	12191055000	29668	14634	8	0	\N
220040	1397	1258461981000	29669	14634	0	0	\N
220041	2133	8813780000	29669	14634	1	0	\N
220042	2132	6974989000	29669	14634	2	0	\N
220043	2132	6973988000	29669	14634	3	0	\N
220044	2133	8812778000	29669	14634	4	0	\N
220045	2133	8811776000	29669	14634	5	0	\N
220046	2134	12193063000	29669	14634	6	0	\N
220047	2134	12192059000	29669	14634	7	0	\N
220048	2134	12191055000	29669	14634	8	0	\N
219915	2134	12226195000	29659	14628	3	0	8090
219916	2134	12225191000	29659	14628	4	0	8091
219917	2134	12224187000	29659	14628	5	0	8092
219918	2134	12223183000	29659	14628	6	0	8093
219919	2134	12222179000	29659	14628	7	0	8094
219921	2132	6988002000	29659	14628	9	0	2000
219922	2133	8839832000	29659	14628	10	0	7587
219923	2133	8838830000	29659	14628	11	0	7588
219924	2133	8837828000	29659	14628	12	0	7589
219925	2133	8836826000	29659	14628	13	0	7590
219927	1397	1258541989000	29660	14629	0	0	18028
219928	2132	6987001000	29660	14629	1	0	2001
219929	2132	6986000000	29660	14629	2	0	2002
219930	2134	12220171000	29660	14629	3	0	8096
219932	2134	12218163000	29660	14629	5	0	8098
219933	2133	8834822000	29660	14629	6	0	7592
219934	2133	8833820000	29660	14629	7	0	7593
219950	1397	1258531988000	29663	14630	0	0	18029
219951	2134	12217159000	29663	14630	1	0	8099
219953	2134	12215151000	29663	14630	3	0	8101
219954	2132	6984999000	29663	14630	4	0	2003
219955	718	2000000000000	29663	14630	5	0	3
219956	2133	8832818000	29663	14630	6	0	7594
219957	2133	8831816000	29663	14630	7	0	7595
219959	1397	1258521987000	29664	14631	0	0	18030
219960	2134	12214147000	29664	14631	1	0	8102
219961	2134	12213143000	29664	14631	2	0	8103
219962	2132	6983998000	29664	14631	3	0	2004
219964	2133	8829812000	29664	14631	5	0	7597
219965	2133	8828810000	29664	14631	6	0	7598
219966	2430	189426998000	29665	14632	0	0	1
219967	50	66008900000000	29665	14632	1	0	1
219968	1397	1258511986000	29665	14632	2	0	18031
219970	1397	1258491984000	29665	14632	4	0	18033
219971	2134	12212139000	29665	14632	5	0	8104
219972	2134	12211135000	29665	14632	6	0	8105
219973	2132	6981996000	29665	14632	7	0	2006
219974	2132	6980995000	29665	14632	8	0	2007
219976	2132	6978993000	29665	14632	10	0	2009
219977	2134	12210131000	29665	14632	11	0	8106
219978	2133	8827808000	29665	14632	12	0	7599
219979	2133	8826806000	29665	14632	13	0	7600
219981	2133	8824802000	29665	14632	15	0	7602
219982	2133	8823800000	29665	14632	16	0	7603
219983	2133	8822798000	29665	14632	17	0	7604
219984	2133	8821796000	29665	14632	18	0	7605
219985	2133	8820794000	29665	14632	19	0	7606
219987	2134	12209127000	29665	14632	21	0	8107
219988	2134	12208123000	29665	14632	22	0	8108
219989	2134	12207119000	29665	14632	23	0	8109
219990	2134	12206115000	29665	14632	24	0	8110
219991	2134	12205111000	29665	14632	25	0	8111
219993	2134	12203103000	29665	14632	27	0	8113
219994	2134	12202099000	29665	14632	28	0	8114
220013	1397	1258481983000	29667	14633	0	0	18034
220014	1397	1258471982000	29667	14633	1	0	18035
220016	2133	8818790000	29667	14633	4	0	7608
220017	2133	8817788000	29667	14633	5	0	7609
220018	2133	8816786000	29667	14633	6	0	7610
220019	2133	8815784000	29667	14633	7	0	7611
220020	2133	8814782000	29667	14633	8	0	7612
220022	2134	12200091000	29667	14633	10	0	8116
220023	2134	12199087000	29667	14633	11	0	8117
220024	2134	12198083000	29667	14633	12	0	8118
220025	2134	12197079000	29667	14633	13	0	8119
220026	2134	12196075000	29667	14633	14	0	8120
220028	2134	12194067000	29667	14633	16	0	8122
220029	2132	6976991000	29667	14633	17	0	2011
220030	2132	6975990000	29667	14633	18	0	2012
220058	2431	769614905251	29671	14635	0	0	\N
220059	1397	1258451980000	29671	14635	1	0	\N
220060	1397	1258441979000	29671	14635	2	0	\N
220061	2133	8810774000	29671	14635	3	0	\N
220062	453	66845780394804	29671	14635	4	0	\N
220063	2132	6972987000	29671	14635	5	0	\N
220064	2132	6971986000	29671	14635	6	0	\N
220065	2132	6970985000	29671	14635	7	0	\N
220066	2133	8809772000	29671	14635	8	0	\N
220067	2133	8808770000	29671	14635	9	0	\N
220068	2133	8807768000	29671	14635	10	0	\N
220069	2133	8806766000	29671	14635	11	0	\N
220070	2134	12190051000	29671	14635	12	0	\N
220071	2134	12189047000	29671	14635	13	0	\N
220072	2134	12188043000	29671	14635	14	0	\N
220073	2134	12187039000	29671	14635	15	0	\N
220074	2134	12186035000	29671	14635	16	0	\N
220075	2134	12185031000	29671	14635	17	0	\N
220094	2431	769614905251	29673	14635	0	0	\N
220095	1397	1258451980000	29673	14635	1	0	\N
220096	1397	1258441979000	29673	14635	2	0	\N
220097	2133	8810774000	29673	14635	3	0	\N
220098	453	66845780394804	29673	14635	4	0	\N
220099	2132	6972987000	29673	14635	5	0	\N
220100	2132	6971986000	29673	14635	6	0	\N
220101	2132	6970985000	29673	14635	7	0	\N
220102	2133	8809772000	29673	14635	8	0	\N
220103	2133	8808770000	29673	14635	9	0	\N
220104	2133	8807768000	29673	14635	10	0	\N
220105	2133	8806766000	29673	14635	11	0	\N
220106	2134	12190051000	29673	14635	12	0	\N
220107	2134	12189047000	29673	14635	13	0	\N
220108	2134	12188043000	29673	14635	14	0	\N
220109	2134	12187039000	29673	14635	15	0	\N
220110	2134	12186035000	29673	14635	16	0	\N
220111	2134	12185031000	29673	14635	17	0	\N
220154	651	66718925000000	29677	14639	0	0	\N
220155	1397	1258391974000	29677	14639	1	0	\N
220156	472	66000990000000	29677	14639	2	0	\N
220157	2133	8791736000	29677	14639	3	0	\N
220158	2134	12167963000	29677	14639	4	0	\N
220159	2134	12166959000	29677	14639	5	0	\N
220160	180	66846790394804	29677	14639	6	0	\N
220161	2134	12165955000	29677	14639	7	0	\N
220162	2132	6962977000	29677	14639	8	0	\N
220163	2132	6961976000	29677	14639	9	0	\N
220164	2133	8790734000	29677	14639	10	0	\N
220165	2133	8789732000	29677	14639	11	0	\N
220175	651	66718925000000	29679	14639	0	0	\N
220176	1397	1258391974000	29679	14639	1	0	\N
220177	472	66000990000000	29679	14639	2	0	\N
220178	2133	8791736000	29679	14639	3	0	\N
220179	2134	12167963000	29679	14639	4	0	\N
220180	2134	12166959000	29679	14639	5	0	\N
220181	180	66846790394804	29679	14639	6	0	\N
220182	2134	12165955000	29679	14639	7	0	\N
220183	2132	6962977000	29679	14639	8	0	\N
220184	2132	6961976000	29679	14639	9	0	\N
220051	2132	6974989000	29670	14634	2	0	2013
220052	2132	6973988000	29670	14634	3	0	2014
220053	2133	8812778000	29670	14634	4	0	7614
220054	2133	8811776000	29670	14634	5	0	7615
220055	2134	12193063000	29670	14634	6	0	8123
220057	2134	12191055000	29670	14634	8	0	8125
220076	2431	769614905251	29672	14635	0	0	1
220077	1397	1258451980000	29672	14635	1	0	18037
220078	1397	1258441979000	29672	14635	2	0	18038
220079	2133	8810774000	29672	14635	3	0	7616
220081	2132	6972987000	29672	14635	5	0	2015
220082	2132	6971986000	29672	14635	6	0	2016
220083	2132	6970985000	29672	14635	7	0	2017
220084	2133	8809772000	29672	14635	8	0	7617
220086	2133	8807768000	29672	14635	10	0	7619
220087	2133	8806766000	29672	14635	11	0	7620
220088	2134	12190051000	29672	14635	12	0	8126
220089	2134	12189047000	29672	14635	13	0	8127
220090	2134	12188043000	29672	14635	14	0	8128
220092	2134	12186035000	29672	14635	16	0	8130
220093	2134	12185031000	29672	14635	17	0	8131
220112	1397	1258431978000	29674	14636	0	0	18039
220113	1397	1258421977000	29674	14636	1	0	18040
220114	2134	12184027000	29674	14636	2	0	8132
220116	2132	6969984000	29674	14636	4	0	2018
220117	2132	6968983000	29674	14636	5	0	2019
220118	2132	6967982000	29674	14636	6	0	2020
220119	2134	12183023000	29674	14636	7	0	8133
220121	2133	8803760000	29674	14636	9	0	7623
220122	2133	8802758000	29674	14636	10	0	7624
220123	2133	8801756000	29674	14636	11	0	7625
220124	2134	12182019000	29674	14636	12	0	8134
220125	2134	12181015000	29674	14636	13	0	8135
220127	1397	1258411976000	29675	14637	0	0	18041
220128	146	66846779269804	29675	14637	1	0	1
220129	2133	8800754000	29675	14637	2	0	7626
220130	2132	6966981000	29675	14637	3	0	2021
220131	2133	8799752000	29675	14637	4	0	7627
220133	2133	8797748000	29675	14637	6	0	7629
220134	2134	12179007000	29675	14637	7	0	8137
220135	2132	6965980000	29675	14637	8	0	2022
220136	2132	6964979000	29675	14637	9	0	2023
220138	2134	12176999000	29675	14637	11	0	8139
220139	2133	8796746000	29675	14637	12	0	7630
220140	2134	12175995000	29675	14637	13	0	8140
220141	2134	12174991000	29675	14637	14	0	8141
220142	2134	12173987000	29675	14637	15	0	8142
220144	2133	8795744000	29675	14637	17	0	7631
220145	1397	1258401975000	29676	14638	0	0	18042
220146	2132	6963978000	29676	14638	1	0	2024
220147	2133	8794742000	29676	14638	2	0	7632
220148	2133	8793740000	29676	14638	3	0	7633
220150	2134	12171979000	29676	14638	5	0	8144
220151	2134	12170975000	29676	14638	6	0	8145
220152	2134	12169971000	29676	14638	7	0	8146
220153	2134	12168967000	29676	14638	8	0	8147
220167	1397	1258391974000	29678	14639	1	0	18043
220168	472	66000990000000	29678	14639	2	0	1
220169	2133	8791736000	29678	14639	3	0	7635
220170	180	66846790394804	29678	14639	4	0	1
220171	2132	6962977000	29678	14639	5	0	2025
220173	2133	8790734000	29678	14639	7	0	7636
220174	2133	8789732000	29678	14639	8	0	7637
220185	2133	8790734000	29679	14639	10	0	\N
220186	2133	8789732000	29679	14639	11	0	\N
220199	1397	1258371972000	29681	14641	0	0	\N
220200	1397	1258361971000	29681	14641	1	0	\N
220201	2132	6959974000	29681	14641	2	0	\N
220202	2132	6958973000	29681	14641	3	0	\N
220203	2132	6957972000	29681	14641	4	0	\N
220204	2133	8785724000	29681	14641	6	0	\N
220205	2134	12161939000	29681	14641	7	0	\N
220206	2134	12160935000	29681	14641	8	0	\N
220207	2134	12159931000	29681	14641	9	0	\N
220208	2133	8784722000	29681	14641	10	0	\N
220209	2133	8783720000	29681	14641	11	0	\N
220210	2133	8782718000	29681	14641	12	0	\N
220211	2133	8781716000	29681	14641	13	0	\N
220212	2134	12158927000	29681	14641	14	0	\N
220213	2134	12157923000	29681	14641	15	0	\N
220214	2134	12156919000	29681	14641	16	0	\N
220215	2134	12155915000	29681	14641	17	0	\N
220216	1397	1258371972000	29682	14641	0	0	\N
220217	1397	1258361971000	29682	14641	1	0	\N
220218	2132	6959974000	29682	14641	2	0	\N
220219	2132	6958973000	29682	14641	3	0	\N
220220	2132	6957972000	29682	14641	4	0	\N
220221	2133	8785724000	29682	14641	6	0	\N
220222	2134	12161939000	29682	14641	7	0	\N
220223	2134	12160935000	29682	14641	8	0	\N
220224	2134	12159931000	29682	14641	9	0	\N
220225	2133	8784722000	29682	14641	10	0	\N
220226	2133	8783720000	29682	14641	11	0	\N
220227	2133	8782718000	29682	14641	12	0	\N
220228	2133	8781716000	29682	14641	13	0	\N
220229	2134	12158927000	29682	14641	14	0	\N
220230	2134	12157923000	29682	14641	15	0	\N
220231	2134	12156919000	29682	14641	16	0	\N
220232	2134	12155915000	29682	14641	17	0	\N
220250	1397	1258371972000	29684	14641	0	0	\N
220251	1397	1258361971000	29684	14641	1	0	\N
220252	2132	6959974000	29684	14641	2	0	\N
220253	2132	6958973000	29684	14641	3	0	\N
220254	2132	6957972000	29684	14641	4	0	\N
220255	2133	8785724000	29684	14641	6	0	\N
220256	2134	12161939000	29684	14641	7	0	\N
220257	2134	12160935000	29684	14641	8	0	\N
220258	2134	12159931000	29684	14641	9	0	\N
220259	2133	8784722000	29684	14641	10	0	\N
220260	2133	8783720000	29684	14641	11	0	\N
220261	2133	8782718000	29684	14641	12	0	\N
220262	2133	8781716000	29684	14641	13	0	\N
220263	2134	12158927000	29684	14641	14	0	\N
220264	2134	12157923000	29684	14641	15	0	\N
220265	2134	12156919000	29684	14641	16	0	\N
220266	2134	12155915000	29684	14641	17	0	\N
220267	1397	1258351970000	29685	14642	0	0	\N
220268	2133	8780714000	29685	14642	1	0	\N
220269	2132	6956971000	29685	14642	2	0	\N
220270	2133	8779712000	29685	14642	3	0	\N
220271	2132	6955970000	29685	14642	4	0	\N
220272	2133	8778710000	29685	14642	5	0	\N
220273	2134	12154911000	29685	14642	6	0	\N
220274	2134	12153907000	29685	14642	7	0	\N
220275	2134	12152903000	29685	14642	8	0	\N
220276	2134	12151899000	29685	14642	9	0	\N
220287	1397	1258351970000	29687	14642	0	0	\N
220288	2133	8780714000	29687	14642	1	0	\N
220289	2132	6956971000	29687	14642	2	0	\N
220290	2133	8779712000	29687	14642	3	0	\N
220291	2132	6955970000	29687	14642	4	0	\N
220292	2133	8778710000	29687	14642	5	0	\N
220293	2134	12154911000	29687	14642	6	0	\N
220294	2134	12153907000	29687	14642	7	0	\N
220295	2134	12152903000	29687	14642	8	0	\N
220189	2133	8788730000	29680	14640	2	0	7638
220190	2134	12167963000	29680	14640	3	0	8148
220191	2134	12166959000	29680	14640	4	0	8149
220192	2134	12165955000	29680	14640	5	0	8150
220193	2134	12164951000	29680	14640	6	0	8151
220195	2134	12162943000	29680	14640	8	0	8153
220196	2132	6960975000	29680	14640	9	0	2027
220197	2133	8787728000	29680	14640	10	0	7639
220198	2133	8786726000	29680	14640	11	0	7640
220233	1397	1258371972000	29683	14641	0	0	18045
220235	2132	6959974000	29683	14641	2	0	2028
220236	2132	6958973000	29683	14641	3	0	2029
220237	2132	6957972000	29683	14641	4	0	2030
220238	2133	8785724000	29683	14641	6	0	7641
220240	2134	12160935000	29683	14641	8	0	8155
220241	2134	12159931000	29683	14641	9	0	8156
220242	2133	8784722000	29683	14641	10	0	7642
220243	2133	8783720000	29683	14641	11	0	7643
220244	2133	8782718000	29683	14641	12	0	7644
220246	2134	12158927000	29683	14641	14	0	8157
220247	2134	12157923000	29683	14641	15	0	8158
220248	2134	12156919000	29683	14641	16	0	8159
220249	2134	12155915000	29683	14641	17	0	8160
220277	1397	1258351970000	29686	14642	0	0	18047
220279	2132	6956971000	29686	14642	2	0	2031
220280	2133	8779712000	29686	14642	3	0	7647
220281	2132	6955970000	29686	14642	4	0	2032
220282	2133	8778710000	29686	14642	5	0	7648
220284	2134	12153907000	29686	14642	7	0	8162
220285	2134	12152903000	29686	14642	8	0	8163
220286	2134	12151899000	29686	14642	9	0	8164
220296	1397	1258341969000	29688	14643	0	0	18048
220297	2133	8777708000	29688	14643	1	0	7649
220299	2133	8775704000	29688	14643	3	0	7651
220300	2132	6954969000	29688	14643	4	0	2033
220301	2134	12150895000	29688	14643	5	0	8165
220302	1397	1258331968000	29689	14644	0	0	18049
220303	2134	12149891000	29689	14644	1	0	8166
220305	2132	6953968000	29689	14644	3	0	2034
220306	2132	6952967000	29689	14644	4	0	2035
220307	2134	12148887000	29689	14644	5	0	8167
220308	2133	8773700000	29689	14644	6	0	7653
220310	1397	1258321967000	29690	14645	0	0	18050
220311	2134	12147883000	29690	14645	1	0	8168
220312	2134	12146879000	29690	14645	2	0	8169
220313	2132	6951966000	29690	14645	3	0	2036
220314	2134	12145875000	29690	14645	4	0	8170
220316	2133	8770694000	29690	14645	6	0	7656
220317	1397	1258311966000	29691	14646	0	0	18051
220318	2134	12144871000	29691	14646	1	0	8171
220319	2134	12143867000	29691	14646	2	0	8172
220320	2134	12142863000	29691	14646	3	0	8173
220327	2132	6950965000	29692	14646	0	0	\N
220328	1726	115219112000	29692	14646	1	0	\N
220329	2132	6949964000	29692	14646	2	0	\N
220330	1397	1258301965000	29694	14647	0	0	\N
220331	2134	12141859000	29694	14647	1	0	\N
220332	2133	8766686000	29694	14647	2	0	\N
220333	2133	8765684000	29694	14647	3	0	\N
220334	2132	6948963000	29694	14647	4	0	\N
220335	2134	12140855000	29694	14647	5	0	\N
220336	1397	1258301965000	29696	14647	0	0	\N
220337	2134	12141859000	29696	14647	1	0	\N
220338	2133	8766686000	29696	14647	2	0	\N
220339	2133	8765684000	29696	14647	3	0	\N
220340	2132	6948963000	29696	14647	4	0	\N
220341	2134	12140855000	29696	14647	5	0	\N
220348	1397	1258301965000	29698	14647	0	0	\N
220349	2134	12141859000	29698	14647	1	0	\N
220350	2133	8766686000	29698	14647	2	0	\N
220351	2133	8765684000	29698	14647	3	0	\N
220352	2132	6948963000	29698	14647	4	0	\N
220353	2134	12140855000	29698	14647	5	0	\N
220354	1397	1258301965000	29699	14647	0	0	\N
220355	2134	12141859000	29699	14647	1	0	\N
220356	2133	8766686000	29699	14647	2	0	\N
220357	2133	8765684000	29699	14647	3	0	\N
220358	2132	6948963000	29699	14647	4	0	\N
220359	2134	12140855000	29699	14647	5	0	\N
220360	1397	1258291964000	29702	14648	0	0	\N
220361	2134	12139851000	29702	14648	1	0	\N
220362	2132	6947962000	29702	14648	2	0	\N
220363	2134	12138847000	29702	14648	3	0	\N
220364	2134	12137843000	29702	14648	4	0	\N
220365	2132	6946961000	29702	14648	5	0	\N
220366	2133	8764682000	29702	14648	6	0	\N
220367	2133	8763680000	29702	14648	7	0	\N
220368	2133	8762678000	29702	14648	8	0	\N
220378	1397	1258291964000	29704	14648	0	0	\N
220379	2134	12139851000	29704	14648	1	0	\N
220380	2132	6947962000	29704	14648	2	0	\N
220381	2134	12138847000	29704	14648	3	0	\N
220382	2133	8764682000	29704	14648	4	0	\N
220383	2133	8763680000	29704	14648	5	0	\N
220384	1397	1258291964000	29705	14648	0	0	\N
220385	2134	12139851000	29705	14648	1	0	\N
220386	2132	6947962000	29705	14648	2	0	\N
220387	2134	12138847000	29705	14648	3	0	\N
220388	2134	12137843000	29705	14648	4	0	\N
220389	2132	6946961000	29705	14648	5	0	\N
220390	2133	8764682000	29705	14648	6	0	\N
220391	2133	8763680000	29705	14648	7	0	\N
220392	2133	8762678000	29705	14648	8	0	\N
220400	1397	1258281963000	29707	14649	0	0	\N
220401	2134	12136839000	29707	14649	1	0	\N
220402	2133	8761676000	29707	14649	2	0	\N
220403	2133	8760674000	29707	14649	3	0	\N
220404	2133	8759672000	29707	14649	4	0	\N
220405	2134	12135835000	29707	14649	5	0	\N
220406	2132	6945960000	29707	14649	6	0	\N
220407	2134	12136839000	29708	14649	0	0	\N
220408	2133	8761676000	29708	14649	1	0	\N
220409	2133	8760674000	29708	14649	2	0	\N
220410	2133	8759672000	29708	14649	3	0	\N
220411	2134	12135835000	29708	14649	4	0	\N
220412	2132	6945960000	29708	14649	5	0	\N
220443	1397	1258271962000	29710	14650	0	0	\N
220444	1397	1258261961000	29710	14650	1	0	\N
220445	1397	1258251960000	29710	14650	2	0	\N
220446	2132	6944959000	29710	14650	3	0	\N
220447	686	69550056000000	29710	14650	4	0	\N
220448	2132	6943958000	29710	14650	5	0	\N
220449	2132	6942957000	29710	14650	6	0	\N
220450	2132	6941956000	29710	14650	7	0	\N
220451	2134	12134831000	29710	14650	8	0	\N
220452	2134	12133827000	29710	14650	9	0	\N
220453	2432	99000000	29710	14650	10	0	\N
220454	487	66563721585011	29710	14650	11	0	\N
220455	2134	12132823000	29710	14650	12	0	\N
220456	2134	12131819000	29710	14650	13	0	\N
220323	1726	115219112000	29691	14646	6	0	8366
220324	2132	6949964000	29691	14646	7	0	2038
220325	2133	8768690000	29691	14646	8	0	7658
220326	2133	8767688000	29691	14646	9	0	7659
220342	1397	1258301965000	29697	14647	0	0	18052
220344	2133	8766686000	29697	14647	2	0	7660
220345	2133	8765684000	29697	14647	3	0	7661
220346	2132	6948963000	29697	14647	4	0	2039
220347	2134	12140855000	29697	14647	5	0	8175
220369	1397	1258291964000	29703	14648	0	0	18053
220371	2132	6947962000	29703	14648	2	0	2040
220372	2134	12138847000	29703	14648	3	0	8177
220373	2134	12137843000	29703	14648	4	0	8178
220374	2132	6946961000	29703	14648	5	0	2041
220376	2133	8763680000	29703	14648	7	0	7663
220377	2133	8762678000	29703	14648	8	0	7664
220393	1397	1258281963000	29706	14649	0	0	18054
220394	2134	12136839000	29706	14649	1	0	8179
220395	2133	8761676000	29706	14649	2	0	7665
220397	2133	8759672000	29706	14649	4	0	7667
220398	2134	12135835000	29706	14649	5	0	8180
220399	2132	6945960000	29706	14649	6	0	2042
220413	1397	1258271962000	29709	14650	0	0	18055
220414	1397	1258261961000	29709	14650	1	0	18056
220416	2132	6944959000	29709	14650	3	0	2043
220417	686	69550056000000	29709	14650	4	0	2
220418	2132	6943958000	29709	14650	5	0	2044
220419	2132	6942957000	29709	14650	6	0	2045
220421	2134	12134831000	29709	14650	8	0	8181
220422	2134	12133827000	29709	14650	9	0	8182
220423	2133	8758670000	29709	14650	10	0	7668
220424	2133	8757668000	29709	14650	11	0	7669
220425	2133	8756666000	29709	14650	12	0	7670
220427	2133	8754662000	29709	14650	14	0	7672
220428	2133	8753660000	29709	14650	15	0	7673
220429	2133	8752658000	29709	14650	16	0	7674
220430	2133	8751656000	29709	14650	17	0	7675
220431	2432	99000000	29709	14650	18	0	1
220433	2134	12132823000	29709	14650	20	0	8183
220434	2134	12131819000	29709	14650	21	0	8184
220435	2134	12130815000	29709	14650	22	0	8185
220436	2134	12129811000	29709	14650	23	0	8186
220438	2134	12127803000	29709	14650	25	0	8188
220439	2134	12126799000	29709	14650	26	0	8189
220440	2134	12125795000	29709	14650	27	0	8190
220441	2134	12124791000	29709	14650	28	0	8191
220442	2134	12123787000	29709	14650	29	0	8192
220457	2134	12130815000	29710	14650	14	0	\N
220458	2134	12129811000	29710	14650	15	0	\N
220459	2134	12128807000	29710	14650	16	0	\N
220460	2134	12127803000	29710	14650	17	0	\N
220461	2134	12126799000	29710	14650	18	0	\N
220462	2134	12125795000	29710	14650	19	0	\N
220463	2134	12124791000	29710	14650	20	0	\N
220464	2134	12123787000	29710	14650	21	0	\N
220465	1397	1258271962000	29711	14650	0	0	\N
220466	1397	1258261961000	29711	14650	1	0	\N
220467	1397	1258251960000	29711	14650	2	0	\N
220468	2132	6944959000	29711	14650	3	0	\N
220469	686	69550056000000	29711	14650	4	0	\N
220470	2132	6943958000	29711	14650	5	0	\N
220471	2132	6942957000	29711	14650	6	0	\N
220472	2132	6941956000	29711	14650	7	0	\N
220473	2134	12134831000	29711	14650	8	0	\N
220474	2134	12133827000	29711	14650	9	0	\N
220475	2133	8758670000	29711	14650	10	0	\N
220476	2133	8757668000	29711	14650	11	0	\N
220477	2133	8756666000	29711	14650	12	0	\N
220478	2133	8755664000	29711	14650	13	0	\N
220479	2133	8754662000	29711	14650	14	0	\N
220480	2133	8753660000	29711	14650	15	0	\N
220481	2133	8752658000	29711	14650	16	0	\N
220482	2133	8751656000	29711	14650	17	0	\N
220483	2432	99000000	29711	14650	18	0	\N
220484	487	66563721585011	29711	14650	19	0	\N
220485	2134	12132823000	29711	14650	20	0	\N
220486	2134	12131819000	29711	14650	21	0	\N
220487	2134	12130815000	29711	14650	22	0	\N
220488	2134	12129811000	29711	14650	23	0	\N
220489	2134	12128807000	29711	14650	24	0	\N
220490	2134	12127803000	29711	14650	25	0	\N
220491	2134	12126799000	29711	14650	26	0	\N
220492	2134	12125795000	29711	14650	27	0	\N
220493	2134	12124791000	29711	14650	28	0	\N
220494	2134	12123787000	29711	14650	29	0	\N
220495	1397	1258271962000	29712	14650	0	0	\N
220496	1397	1258261961000	29712	14650	1	0	\N
220497	1397	1258251960000	29712	14650	2	0	\N
220498	2132	6944959000	29712	14650	3	0	\N
220499	686	69550056000000	29712	14650	4	0	\N
220500	2132	6943958000	29712	14650	5	0	\N
220501	2132	6942957000	29712	14650	6	0	\N
220502	2132	6941956000	29712	14650	7	0	\N
220503	2134	12134831000	29712	14650	8	0	\N
220504	2134	12133827000	29712	14650	9	0	\N
220505	2133	8758670000	29712	14650	10	0	\N
220506	2133	8757668000	29712	14650	11	0	\N
220507	2133	8756666000	29712	14650	12	0	\N
220508	2133	8755664000	29712	14650	13	0	\N
220509	2133	8754662000	29712	14650	14	0	\N
220510	2133	8753660000	29712	14650	15	0	\N
220511	2133	8752658000	29712	14650	16	0	\N
220512	2133	8751656000	29712	14650	17	0	\N
220513	2432	99000000	29712	14650	18	0	\N
220514	487	66563721585011	29712	14650	19	0	\N
220515	2134	12132823000	29712	14650	20	0	\N
220516	2134	12131819000	29712	14650	21	0	\N
220517	2134	12130815000	29712	14650	22	0	\N
220518	2134	12129811000	29712	14650	23	0	\N
220519	2134	12128807000	29712	14650	24	0	\N
220520	2134	12127803000	29712	14650	25	0	\N
220521	2134	12126799000	29712	14650	26	0	\N
220522	2134	12125795000	29712	14650	27	0	\N
220523	2134	12124791000	29712	14650	28	0	\N
220524	2134	12123787000	29712	14650	29	0	\N
220525	1397	1258271962000	29713	14650	0	0	\N
220526	1397	1258261961000	29713	14650	1	0	\N
220527	1397	1258251960000	29713	14650	2	0	\N
220528	2132	6944959000	29713	14650	3	0	\N
220529	686	69550056000000	29713	14650	4	0	\N
220530	2132	6943958000	29713	14650	5	0	\N
220531	2132	6942957000	29713	14650	6	0	\N
220532	2132	6941956000	29713	14650	7	0	\N
220533	2134	12134831000	29713	14650	8	0	\N
220534	2134	12133827000	29713	14650	9	0	\N
220535	2133	8758670000	29713	14650	10	0	\N
220536	2133	8757668000	29713	14650	11	0	\N
220537	2133	8756666000	29713	14650	12	0	\N
220538	2133	8755664000	29713	14650	13	0	\N
220539	2133	8754662000	29713	14650	14	0	\N
220540	2133	8753660000	29713	14650	15	0	\N
220541	2133	8752658000	29713	14650	16	0	\N
220542	2133	8751656000	29713	14650	17	0	\N
220543	2432	99000000	29713	14650	18	0	\N
220544	487	66563721585011	29713	14650	19	0	\N
220545	2134	12132823000	29713	14650	20	0	\N
220546	2134	12131819000	29713	14650	21	0	\N
220547	2134	12130815000	29713	14650	22	0	\N
220548	2134	12129811000	29713	14650	23	0	\N
220549	2134	12128807000	29713	14650	24	0	\N
220550	2134	12127803000	29713	14650	25	0	\N
220551	2134	12126799000	29713	14650	26	0	\N
220552	2134	12125795000	29713	14650	27	0	\N
220553	2134	12124791000	29713	14650	28	0	\N
220554	2134	12123787000	29713	14650	29	0	\N
220555	50	66008900000000	29714	14572	0	0	\N
220556	389	68159958000000	29714	14572	1	0	\N
220557	451	66564522585011	29714	14572	2	0	\N
220558	651	66718925000000	29714	14572	3	0	\N
220559	744	2016912805578	29714	14572	4	0	\N
220560	1420	1854874980000	29714	14572	5	0	\N
220561	379	66190536998665	29714	14572	6	0	\N
220562	556	66720035511028	29714	14572	7	0	\N
220563	1428	2159532000000	29714	14572	8	0	\N
220564	1428	2158922000000	29714	14572	9	0	\N
220565	1397	1259402075000	29714	14572	10	0	\N
220566	1397	1259392074000	29714	14572	11	0	\N
220567	1397	1259382073000	29714	14572	12	0	\N
220568	1397	1259372072000	29714	14572	13	0	\N
220569	379	66000000000665	29714	14572	14	0	\N
220570	2425	90000000	29714	14572	15	0	\N
220571	1428	2157812000000	29714	14572	16	0	\N
220572	1397	1259362071000	29714	14572	17	0	\N
220573	1397	1259352070000	29714	14572	18	0	\N
220574	1397	1259342069000	29714	14572	19	0	\N
220575	1397	1259332068000	29714	14572	20	0	\N
220576	1397	1259322067000	29714	14572	21	0	\N
220577	1397	1259312066000	29714	14572	22	0	\N
220578	1397	1259302065000	29714	14572	23	0	\N
220579	1397	1259292064000	29714	14572	24	0	\N
220580	1397	1259282063000	29714	14572	26	0	\N
220581	1397	1259272062000	29714	14572	27	0	\N
220582	1397	1259262061000	29714	14572	28	0	\N
220583	1397	1259252060000	29714	14572	29	0	\N
220584	1397	1259242059000	29714	14572	30	0	\N
220585	1397	1259232058000	29714	14572	31	0	\N
220586	1397	1259222057000	29714	14572	32	0	\N
220587	1397	1259212056000	29714	14572	33	0	\N
220588	1397	1259202055000	29714	14572	34	0	\N
220589	1397	1259192054000	29714	14572	35	0	\N
220590	1397	1259182053000	29714	14572	36	0	\N
220591	1397	1259172052000	29714	14572	37	0	\N
220592	1397	1259162051000	29714	14572	38	0	\N
220593	1397	1259152050000	29714	14572	39	0	\N
220594	1397	1259142049000	29714	14572	40	0	\N
220595	1397	1259132048000	29714	14572	41	0	\N
220596	1397	1259122047000	29714	14572	42	0	\N
220597	1397	1259112046000	29714	14572	43	0	\N
220598	1397	1259102045000	29714	14572	44	0	\N
220599	1397	1259092044000	29714	14572	45	0	\N
220600	1397	1259082043000	29714	14572	46	0	\N
220601	1397	1259072042000	29714	14572	47	0	\N
220602	1397	1259062041000	29714	14572	48	0	\N
220603	1397	1259052040000	29714	14572	49	0	\N
220604	1397	1259042039000	29714	14572	50	0	\N
220605	1397	1259032038000	29714	14572	51	0	\N
220606	1397	1259022037000	29714	14572	52	0	\N
220607	1397	1259012036000	29714	14572	53	0	\N
220608	1397	1259002035000	29714	14572	54	0	\N
220609	1397	1258992034000	29714	14572	55	0	\N
220610	1397	1258982033000	29714	14572	56	0	\N
220611	1397	1258972032000	29714	14572	57	0	\N
220612	1397	1258962031000	29714	14572	58	0	\N
220613	1397	1258952030000	29714	14572	59	0	\N
220614	1397	1258942029000	29714	14572	60	0	\N
220615	1397	1258932028000	29714	14572	61	0	\N
220616	1397	1258922027000	29714	14572	62	0	\N
220617	1397	1258912026000	29714	14572	63	0	\N
220618	1397	1258902025000	29714	14572	64	0	\N
220619	1397	1258892024000	29714	14572	65	0	\N
220620	1397	1258882023000	29714	14572	66	0	\N
220621	1397	1258872022000	29714	14572	67	0	\N
220622	1397	1258862021000	29714	14572	68	0	\N
220623	1397	1258852020000	29714	14572	69	0	\N
220624	1397	1258842019000	29714	14572	70	0	\N
220625	1397	1258832018000	29714	14572	71	0	\N
220626	1397	1258822017000	29714	14572	72	0	\N
220627	1397	1258812016000	29714	14572	73	0	\N
220628	1397	1258802015000	29714	14572	74	0	\N
220629	1397	1258792014000	29714	14572	75	0	\N
220630	1397	1258782013000	29714	14572	76	0	\N
220631	1397	1258772012000	29714	14572	77	0	\N
220632	1397	1258762011000	29714	14572	78	0	\N
220633	1397	1258752010000	29714	14572	79	0	\N
220634	1397	1258742009000	29714	14572	80	0	\N
220635	1397	1258732008000	29714	14572	81	0	\N
220636	1397	1258722007000	29714	14572	82	0	\N
220637	1397	1258712006000	29714	14572	83	0	\N
220638	1397	1258702005000	29714	14572	84	0	\N
220639	1397	1258692004000	29714	14572	85	0	\N
220640	1397	1258682003000	29714	14572	86	0	\N
220641	1397	1258672002000	29714	14572	87	0	\N
220642	1397	1258662001000	29714	14572	88	0	\N
220643	1397	1258652000000	29714	14572	89	0	\N
220644	1397	1258641999000	29714	14572	90	0	\N
220645	1397	1258631998000	29714	14572	91	0	\N
220646	1397	1258621997000	29714	14572	92	0	\N
220647	1397	1258611996000	29714	14572	93	0	\N
220648	1397	1258601995000	29714	14572	94	0	\N
220649	1397	1258591994000	29714	14572	95	0	\N
220650	1397	1258581993000	29714	14572	96	0	\N
220651	1397	1258571992000	29714	14572	97	0	\N
220652	1397	1258561991000	29714	14572	98	0	\N
220653	1397	1258551990000	29714	14572	99	0	\N
220654	1397	1258541989000	29714	14572	100	0	\N
220655	1397	1258531988000	29714	14572	101	0	\N
220656	1397	1258521987000	29714	14572	102	0	\N
220657	1397	1258511986000	29714	14572	103	0	\N
220658	1397	1258501985000	29714	14572	104	0	\N
220659	1397	1258491984000	29714	14572	105	0	\N
220660	1397	1258481983000	29714	14572	106	0	\N
220661	1397	1258471982000	29714	14572	107	0	\N
220662	1397	1258461981000	29714	14572	108	0	\N
220663	1397	1258451980000	29714	14572	109	0	\N
220664	1397	1258441979000	29714	14572	110	0	\N
220665	1397	1258431978000	29714	14572	111	0	\N
220666	1397	1258421977000	29714	14572	112	0	\N
220667	1397	1258411976000	29714	14572	113	0	\N
220668	1397	1258401975000	29714	14572	114	0	\N
220669	1397	1258391974000	29714	14572	115	0	\N
220670	1397	1258381973000	29714	14572	116	0	\N
220671	1397	1258371972000	29714	14572	117	0	\N
220672	1397	1258361971000	29714	14572	118	0	\N
220673	1397	1258351970000	29714	14572	119	0	\N
220674	1397	1258341969000	29714	14572	120	0	\N
220675	1397	1258331968000	29714	14572	121	0	\N
220676	1397	1258321967000	29714	14572	122	0	\N
220677	1397	1258311966000	29714	14572	123	0	\N
220678	1397	1258301965000	29714	14572	124	0	\N
220679	1397	1258291964000	29714	14572	125	0	\N
220700	1397	1258241959000	29716	14651	0	0	\N
220701	1268	1003913681688	29716	14651	1	0	\N
220702	1268	1003911681688	29716	14651	3	0	\N
220703	2134	12122783000	29716	14651	4	0	\N
220704	2134	12121779000	29716	14651	5	0	\N
220705	1268	1003909681688	29716	14651	6	0	\N
220706	1268	1003907681688	29716	14651	7	0	\N
220707	2133	8750654000	29716	14651	8	0	\N
220708	2133	8749652000	29716	14651	9	0	\N
220709	2133	8748650000	29716	14651	10	0	\N
220710	2134	12120775000	29716	14651	11	0	\N
220711	1268	1003905681688	29716	14651	12	0	\N
220712	1268	1003903681688	29716	14651	13	0	\N
220713	1268	1003901681688	29716	14651	14	0	\N
220714	1268	1003899681688	29716	14651	15	0	\N
220715	1268	1003897681688	29716	14651	16	0	\N
220716	1268	1003895681688	29716	14651	17	0	\N
220717	2132	6940955000	29716	14651	18	0	\N
220718	2132	6939954000	29716	14651	19	0	\N
220682	1268	1003911681688	29715	14651	3	0	5
220683	2134	12122783000	29715	14651	4	0	8193
220684	2134	12121779000	29715	14651	5	0	8194
220685	1268	1003909681688	29715	14651	6	0	6
220686	1268	1003907681688	29715	14651	7	0	7
220688	2133	8749652000	29715	14651	9	0	7677
220689	2133	8748650000	29715	14651	10	0	7678
220690	2134	12120775000	29715	14651	11	0	8195
220691	1268	1003905681688	29715	14651	12	0	8
220692	1268	1003903681688	29715	14651	13	0	9
220694	1268	1003899681688	29715	14651	15	0	11
220695	1268	1003897681688	29715	14651	16	0	12
220696	1268	1003895681688	29715	14651	17	0	13
220697	1268	1003893681688	29715	14651	18	0	14
220699	2132	6939954000	29715	14651	20	0	2048
220719	1397	1258231958000	29717	14652	0	0	18059
220720	1268	1003891681688	29717	14652	1	0	15
220721	2134	12119771000	29717	14652	2	0	8196
220722	2134	12118767000	29717	14652	3	0	8197
220724	2132	6938953000	29717	14652	5	0	2049
220725	1268	1003889681688	29717	14652	6	0	16
220726	1268	1003887681688	29717	14652	7	0	17
220727	2133	8747648000	29717	14652	8	0	7679
220728	2133	8746646000	29717	14652	9	0	7680
220734	1397	1258231958000	29718	14652	0	0	\N
220735	2134	12119771000	29718	14652	1	0	\N
220736	2134	12118767000	29718	14652	2	0	\N
220737	2134	12117763000	29718	14652	3	0	\N
220738	1268	1003893681688	29718	14652	4	0	\N
220739	1268	1003891681688	29718	14652	5	0	\N
220740	2132	6938953000	29718	14652	6	0	\N
220741	1268	1003889681688	29718	14652	7	0	\N
220742	1268	1003887681688	29718	14652	8	0	\N
220743	2133	8747648000	29718	14652	9	0	\N
220744	2133	8746646000	29718	14652	10	0	\N
220745	2133	8745644000	29718	14652	11	0	\N
220746	1268	1003885681688	29718	14652	12	0	\N
220747	1268	1003883681688	29718	14652	13	0	\N
220748	1268	1003881681688	29718	14652	14	0	\N
220749	1268	1003879681688	29718	14652	15	0	\N
220750	1268	1003877681688	29718	14652	16	0	\N
220751	1268	1003875681688	29718	14652	17	0	\N
220752	1268	1003873681688	29718	14652	18	0	\N
220753	1268	1003871681688	29718	14652	19	0	\N
220754	1268	1003869681688	29718	14652	20	0	\N
220755	1268	1003867681688	29718	14652	21	0	\N
220756	1268	1003865681688	29718	14652	22	0	\N
220757	1268	1003863681688	29718	14652	23	0	\N
220758	1268	1003861681688	29718	14652	24	0	\N
220759	1268	1003859681688	29718	14652	25	0	\N
220760	1268	1003857681688	29718	14652	26	0	\N
220782	186	66845521394804	29720	14446	0	0	\N
220783	50	66008900000000	29720	14446	1	0	\N
220784	389	68159958000000	29720	14446	2	0	\N
220785	1539	719914000000	29720	14446	3	0	\N
220786	451	66564522585011	29720	14446	4	0	\N
220787	511	66544310726895	29720	14446	5	0	\N
220788	651	66718925000000	29720	14446	6	0	\N
220789	744	2016912805578	29720	14446	7	0	\N
220790	1420	1854874980000	29720	14446	8	0	\N
220791	379	66190536998665	29720	14446	9	0	\N
220792	363	67439950000000	29720	14446	10	0	\N
220793	556	66720035511028	29720	14446	11	0	\N
220794	612	66543000726895	29720	14446	12	0	\N
220795	1397	1261082243000	29720	14446	13	0	\N
220796	1428	2159532000000	29720	14446	14	0	\N
220797	1428	2158922000000	29720	14446	15	0	\N
220798	612	66542980726895	29720	14446	16	0	\N
220799	379	66000000000665	29720	14446	17	0	\N
220800	1397	1261072242000	29720	14446	18	0	\N
220801	1397	1261062241000	29720	14446	19	0	\N
220802	1397	1261052240000	29720	14446	20	0	\N
220803	560	66846771394804	29720	14446	21	0	\N
220804	1428	2157812000000	29720	14446	22	0	\N
220805	2039	21498862000000	29720	14446	23	0	\N
220806	2039	2345852000000	29720	14446	24	0	\N
220807	612	66542960726895	29720	14446	25	0	\N
220808	612	66542450726895	29720	14446	26	0	\N
220809	1397	1261042239000	29720	14446	27	0	\N
220810	1397	1261032238000	29720	14446	28	0	\N
220811	1397	1261022237000	29720	14446	29	0	\N
220812	1397	1261012236000	29720	14446	30	0	\N
220813	1397	1261002235000	29720	14446	31	0	\N
220814	1397	1260992234000	29720	14446	32	0	\N
220815	1397	1260982233000	29720	14446	33	0	\N
220816	1397	1260972232000	29720	14446	34	0	\N
220817	1397	1260962231000	29720	14446	35	0	\N
220818	1397	1260952230000	29720	14446	36	0	\N
220819	1397	1260942229000	29720	14446	37	0	\N
220820	1397	1260932228000	29720	14446	38	0	\N
220821	1397	1260922227000	29720	14446	39	0	\N
220822	1397	1260912226000	29720	14446	40	0	\N
220823	1397	1260902225000	29720	14446	41	0	\N
220824	1397	1260892224000	29720	14446	42	0	\N
220825	1397	1260882223000	29720	14446	43	0	\N
220826	1397	1260872222000	29720	14446	44	0	\N
220827	1397	1260862221000	29720	14446	45	0	\N
220828	1397	1260852220000	29720	14446	46	0	\N
220829	1397	1260842219000	29720	14446	47	0	\N
220830	1397	1260832218000	29720	14446	48	0	\N
220831	1397	1260822217000	29720	14446	49	0	\N
220832	1397	1260812216000	29720	14446	50	0	\N
220833	1397	1260802215000	29720	14446	51	0	\N
220834	1397	1260792214000	29720	14446	52	0	\N
220835	1397	1260782213000	29720	14446	53	0	\N
220836	1397	1260772212000	29720	14446	54	0	\N
220837	1397	1260762211000	29720	14446	55	0	\N
220838	1397	1260752210000	29720	14446	56	0	\N
220839	1397	1260742209000	29720	14446	57	0	\N
220840	1397	1260732208000	29720	14446	58	0	\N
220841	1397	1260722207000	29720	14446	59	0	\N
220842	1397	1260712206000	29720	14446	60	0	\N
220843	1397	1260702205000	29720	14446	61	0	\N
220844	1397	1260692204000	29720	14446	62	0	\N
220845	1397	1260682203000	29720	14446	63	0	\N
220846	1397	1260672202000	29720	14446	64	0	\N
220847	1397	1260662201000	29720	14446	66	0	\N
220848	1397	1260652200000	29720	14446	67	0	\N
220849	1397	1260642199000	29720	14446	68	0	\N
220850	1397	1260632198000	29720	14446	69	0	\N
220851	1397	1260622197000	29720	14446	70	0	\N
220852	1397	1260612196000	29720	14446	71	0	\N
220853	1397	1260602195000	29720	14446	72	0	\N
220854	1397	1260592194000	29720	14446	73	0	\N
220855	1397	1260582193000	29720	14446	74	0	\N
220856	1397	1260572192000	29720	14446	75	0	\N
220857	1397	1260562191000	29720	14446	76	0	\N
220858	1397	1260552190000	29720	14446	77	0	\N
220859	1397	1260542189000	29720	14446	78	0	\N
220860	1397	1260532188000	29720	14446	79	0	\N
220861	1397	1260522187000	29720	14446	80	0	\N
220862	1397	1260512186000	29720	14446	81	0	\N
220863	1397	1260502185000	29720	14446	82	0	\N
220864	1397	1260492184000	29720	14446	83	0	\N
220731	1268	1003883681688	29717	14652	12	0	19
220732	1268	1003881681688	29717	14652	13	0	20
220733	1268	1003879681688	29717	14652	14	0	21
220761	472	66000080000000	29719	14653	0	0	2
220762	1397	1258221957000	29719	14653	1	0	18060
220764	2133	8744642000	29719	14653	3	0	7682
220765	2133	8743640000	29719	14653	4	0	7683
220766	1268	1003875681688	29719	14653	5	0	23
220767	2132	6937952000	29719	14653	6	0	2050
220768	2132	6936951000	29719	14653	7	0	2051
220770	2134	12115755000	29719	14653	9	0	8200
220771	2134	12114751000	29719	14653	10	0	8201
220772	2134	12113747000	29719	14653	11	0	8202
220773	1268	1003873681688	29719	14653	12	0	24
220775	1268	1003869681688	29719	14653	14	0	26
220776	1268	1003867681688	29719	14653	15	0	27
220777	1268	1003865681688	29719	14653	16	0	28
220778	1268	1003863681688	29719	14653	17	0	29
220779	1268	1003861681688	29719	14653	18	0	30
220781	1268	1003857681688	29719	14653	20	0	32
220865	1397	1260482183000	29720	14446	84	0	\N
220866	1397	1260472182000	29720	14446	85	0	\N
220867	1397	1260462181000	29720	14446	86	0	\N
220868	1397	1260452180000	29720	14446	87	0	\N
220869	1397	1260442179000	29720	14446	88	0	\N
220870	1397	1260432178000	29720	14446	89	0	\N
220871	1397	1260422177000	29720	14446	90	0	\N
220872	1397	1260412176000	29720	14446	91	0	\N
220873	1397	1260402175000	29720	14446	92	0	\N
220874	1397	1260392174000	29720	14446	93	0	\N
220875	1397	1260382173000	29720	14446	94	0	\N
220876	1397	1260372172000	29720	14446	95	0	\N
220877	1397	1260362171000	29720	14446	96	0	\N
220878	1397	1260352170000	29720	14446	97	0	\N
220879	1397	1260342169000	29720	14446	98	0	\N
220880	1397	1260332168000	29720	14446	99	0	\N
220881	1397	1260322167000	29720	14446	100	0	\N
220882	1397	1260312166000	29720	14446	101	0	\N
220883	1397	1260302165000	29720	14446	102	0	\N
220884	1397	1260292164000	29720	14446	103	0	\N
220885	1397	1260282163000	29720	14446	104	0	\N
220886	1397	1260272162000	29720	14446	105	0	\N
220887	1397	1260262161000	29720	14446	106	0	\N
220888	1397	1260252160000	29720	14446	107	0	\N
220889	1397	1260242159000	29720	14446	108	0	\N
220890	1397	1260232158000	29720	14446	109	0	\N
220891	1397	1260222157000	29720	14446	110	0	\N
220892	1397	1260212156000	29720	14446	111	0	\N
220893	1397	1260202155000	29720	14446	112	0	\N
220894	1397	1260192154000	29720	14446	113	0	\N
220895	1397	1260182153000	29720	14446	114	0	\N
220896	1397	1260172152000	29720	14446	115	0	\N
220897	1397	1260162151000	29720	14446	116	0	\N
220898	1397	1260152150000	29720	14446	117	0	\N
220899	1397	1260142149000	29720	14446	118	0	\N
220900	1397	1260132148000	29720	14446	119	0	\N
220901	1397	1260122147000	29720	14446	120	0	\N
220902	1397	1260112146000	29720	14446	121	0	\N
220903	1397	1260102145000	29720	14446	122	0	\N
220904	1397	1260092144000	29720	14446	123	0	\N
220905	1397	1260082143000	29720	14446	124	0	\N
220906	1397	1260072142000	29720	14446	125	0	\N
220907	498	67440214000000	29721	14654	0	0	\N
220908	1397	1258211956000	29721	14654	1	0	\N
220909	2134	12112743000	29721	14654	2	0	\N
220910	2134	12111739000	29721	14654	3	0	\N
220911	2134	12110735000	29721	14654	4	0	\N
220912	2133	8742638000	29721	14654	5	0	\N
220913	2132	6935950000	29721	14654	6	0	\N
220914	2133	8741636000	29721	14654	7	0	\N
220915	2133	8740634000	29721	14654	8	0	\N
220916	498	67440214000000	29722	14654	0	0	\N
220917	1397	1258211956000	29722	14654	1	0	\N
220918	2134	12112743000	29722	14654	2	0	\N
220919	2134	12111739000	29722	14654	3	0	\N
220920	2134	12110735000	29722	14654	4	0	\N
220921	2133	8742638000	29722	14654	5	0	\N
220922	2132	6935950000	29722	14654	6	0	\N
220923	2133	8741636000	29722	14654	7	0	\N
220924	2133	8740634000	29722	14654	8	0	\N
220934	498	67440214000000	29724	14654	0	0	\N
220935	1397	1258211956000	29724	14654	1	0	\N
220936	2133	8742638000	29724	14654	2	0	\N
220937	2132	6935950000	29724	14654	3	0	\N
220938	2133	8741636000	29724	14654	4	0	\N
220939	2133	8740634000	29724	14654	5	0	\N
220940	498	67440214000000	29725	14654	0	0	\N
220941	1397	1258211956000	29725	14654	1	0	\N
220942	2134	12112743000	29725	14654	2	0	\N
220943	2134	12111739000	29725	14654	3	0	\N
220944	2134	12110735000	29725	14654	4	0	\N
220945	2133	8742638000	29725	14654	5	0	\N
220946	2132	6935950000	29725	14654	6	0	\N
220947	2133	8741636000	29725	14654	7	0	\N
220948	2133	8740634000	29725	14654	8	0	\N
220966	1397	1258181953000	29727	14656	0	0	\N
220967	2133	8733620000	29727	14656	1	0	\N
220968	2132	6931946000	29727	14656	2	0	\N
220969	2134	12104711000	29727	14656	3	0	\N
220970	2134	12103707000	29727	14656	4	0	\N
220971	2134	12102703000	29727	14656	5	0	\N
220972	2133	8732618000	29727	14656	6	0	\N
220973	2132	6930945000	29727	14656	7	0	\N
220974	2133	8731616000	29727	14656	8	0	\N
220975	1397	1258181953000	29728	14656	0	0	\N
220976	2133	8733620000	29728	14656	1	0	\N
220977	2132	6931946000	29728	14656	2	0	\N
220978	2134	12104711000	29728	14656	3	0	\N
220979	2134	12103707000	29728	14656	4	0	\N
220980	2133	8732618000	29728	14656	5	0	\N
220990	1397	1258171952000	29730	14657	0	0	\N
220991	2133	8730614000	29730	14657	1	0	\N
220992	2133	8729612000	29730	14657	2	0	\N
220993	2132	6929944000	29730	14657	3	0	\N
220994	2134	12101699000	29730	14657	4	0	\N
220995	2134	12100695000	29730	14657	5	0	\N
220996	2134	12099691000	29730	14657	6	0	\N
220997	1397	1258171952000	29731	14657	0	0	\N
220998	2133	8730614000	29731	14657	1	0	\N
220999	2133	8729612000	29731	14657	2	0	\N
221000	2132	6929944000	29731	14657	3	0	\N
220927	2134	12112743000	29723	14654	2	0	8203
220928	2134	12111739000	29723	14654	3	0	8204
220929	2134	12110735000	29723	14654	4	0	8205
220930	2133	8742638000	29723	14654	5	0	7684
220931	2132	6935950000	29723	14654	6	0	2052
220933	2133	8740634000	29723	14654	8	0	7686
220949	724	20001130000000	29726	14655	0	0	6
220950	1397	1258201955000	29726	14655	1	0	18062
220951	1397	1258191954000	29726	14655	2	0	18063
220952	2134	12109731000	29726	14655	3	0	8206
220954	2133	8738630000	29726	14655	5	0	7688
220955	2134	12108727000	29726	14655	6	0	8207
220956	2134	12107723000	29726	14655	7	0	8208
220957	2132	6934949000	29726	14655	8	0	2053
220959	2132	6932947000	29726	14655	10	0	2055
220960	2133	8737628000	29726	14655	11	0	7689
220961	2133	8736626000	29726	14655	12	0	7690
220962	2133	8735624000	29726	14655	13	0	7691
220963	2133	8734622000	29726	14655	14	0	7692
220965	2134	12105715000	29726	14655	16	0	8210
220981	1397	1258181953000	29729	14656	0	0	18064
220982	2133	8733620000	29729	14656	1	0	7693
220983	2132	6931946000	29729	14656	2	0	2056
220984	2134	12104711000	29729	14656	3	0	8211
220986	2134	12102703000	29729	14656	5	0	8213
220987	2133	8732618000	29729	14656	6	0	7694
220988	2132	6930945000	29729	14656	7	0	2057
220989	2133	8731616000	29729	14656	8	0	7695
221001	2134	12101699000	29731	14657	4	0	\N
221002	2134	12100695000	29731	14657	5	0	\N
221003	2134	12099691000	29731	14657	6	0	\N
221011	1397	1258171952000	29733	14657	0	0	\N
221012	2133	8730614000	29733	14657	1	0	\N
221013	2133	8729612000	29733	14657	2	0	\N
221014	2132	6929944000	29733	14657	3	0	\N
221015	2134	12101699000	29733	14657	4	0	\N
221016	2134	12100695000	29733	14657	5	0	\N
221017	2134	12099691000	29733	14657	6	0	\N
221018	1397	1258171952000	29734	14657	0	0	\N
221019	2133	8730614000	29734	14657	1	0	\N
221020	2133	8729612000	29734	14657	2	0	\N
221021	2132	6929944000	29734	14657	3	0	\N
221022	2134	12101699000	29734	14657	4	0	\N
221023	2134	12100695000	29734	14657	5	0	\N
221024	2134	12099691000	29734	14657	6	0	\N
221025	1397	1258171952000	29735	14657	0	0	\N
221026	2134	12102703000	29735	14657	1	0	\N
221027	2132	6930945000	29735	14657	2	0	\N
221028	2132	6929944000	29735	14657	3	0	\N
221029	2133	8731616000	29735	14657	4	0	\N
221030	2133	8730614000	29735	14657	5	0	\N
221031	2133	8729612000	29735	14657	6	0	\N
221032	2134	12101699000	29735	14657	7	0	\N
221033	2134	12100695000	29735	14657	8	0	\N
221034	1397	1258171952000	29736	14657	0	0	\N
221035	2133	8730614000	29736	14657	1	0	\N
221036	2132	6929944000	29736	14657	2	0	\N
221037	2134	12101699000	29736	14657	3	0	\N
221038	2134	12100695000	29736	14657	4	0	\N
221039	1397	1258171952000	29737	14657	0	0	\N
221040	2133	8730614000	29737	14657	1	0	\N
221041	2133	8729612000	29737	14657	2	0	\N
221042	2132	6929944000	29737	14657	3	0	\N
221043	2134	12101699000	29737	14657	4	0	\N
221044	2134	12100695000	29737	14657	5	0	\N
221098	1397	1258121947000	29741	14660	0	0	\N
221099	2132	6922937000	29741	14660	1	0	\N
221100	2134	12086639000	29741	14660	2	0	\N
221101	2132	6921936000	29741	14660	3	0	\N
221102	2134	12085635000	29741	14660	4	0	\N
221103	2134	12084631000	29741	14660	5	0	\N
221104	2133	8717588000	29741	14660	6	0	\N
221105	2133	8716586000	29741	14660	7	0	\N
221106	2133	8715584000	29741	14660	8	0	\N
221123	1397	1258091944000	29743	14662	0	0	\N
221124	1397	1258081943000	29743	14662	1	0	\N
221125	2132	6917932000	29743	14662	2	0	\N
221126	2134	12077603000	29743	14662	3	0	\N
221127	2132	6916931000	29743	14662	4	0	\N
221128	2132	6915930000	29743	14662	5	0	\N
221129	2134	12076599000	29743	14662	6	0	\N
221130	2134	12075595000	29743	14662	7	0	\N
221131	2134	12074591000	29743	14662	8	0	\N
221132	2134	12073587000	29743	14662	9	0	\N
221133	2134	12072583000	29743	14662	10	0	\N
221134	2134	12071579000	29743	14662	11	0	\N
221135	1397	1258091944000	29744	14662	0	0	\N
221136	1397	1258081943000	29744	14662	1	0	\N
221006	2133	8729612000	29732	14657	2	0	7697
221007	2132	6929944000	29732	14657	3	0	2058
221008	2134	12101699000	29732	14657	4	0	8214
221009	2134	12100695000	29732	14657	5	0	8215
221010	2134	12099691000	29732	14657	6	0	8216
221046	2134	12098687000	29738	14658	1	0	8217
221047	2132	6928943000	29738	14658	2	0	2059
221048	2132	6927942000	29738	14658	3	0	2060
221049	2134	12097683000	29738	14658	4	0	8218
221050	2133	8728610000	29738	14658	5	0	7698
221052	1397	1258151950000	29739	14659	0	0	18067
221053	1397	1258141949000	29739	14659	1	0	18068
221054	1397	1258131948000	29739	14659	2	0	18069
221055	2133	8726606000	29739	14659	3	0	7700
221057	2133	8725604000	29739	14659	5	0	7701
221058	2133	8724602000	29739	14659	6	0	7702
221059	2133	8723600000	29739	14659	7	0	7703
221060	2132	6926941000	29739	14659	9	0	2061
221061	2132	6925940000	29739	14659	10	0	2062
221063	2132	6923938000	29739	14659	12	0	2064
221064	1268	1003855681688	29739	14659	13	0	33
221065	1268	1003853681688	29739	14659	14	0	34
221066	1268	1003851681688	29739	14659	15	0	35
221067	1268	1003849681688	29739	14659	16	0	36
221069	2133	8721596000	29739	14659	18	0	7705
221070	2133	8720594000	29739	14659	19	0	7706
221071	2134	12095675000	29739	14659	20	0	8220
221072	2134	12094671000	29739	14659	21	0	8221
221074	2134	12092663000	29739	14659	23	0	8223
221075	2134	12091659000	29739	14659	24	0	8224
221076	2134	12090655000	29739	14659	25	0	8225
221077	2134	12089651000	29739	14659	26	0	8226
221078	2134	12088647000	29739	14659	27	0	8227
221080	1268	1003847681688	29739	14659	29	0	37
221081	1268	1003845681688	29739	14659	30	0	38
221082	1268	1003843681688	29739	14659	31	0	39
221083	1268	1003841681688	29739	14659	32	0	40
221084	1268	1003839681688	29739	14659	33	0	41
221086	1268	1003835681688	29739	14659	35	0	43
221087	2133	8719592000	29739	14659	36	0	7707
221088	2133	8718590000	29739	14659	37	0	7708
221089	1397	1258121947000	29740	14660	0	0	18070
221091	2134	12086639000	29740	14660	2	0	8229
221092	2132	6921936000	29740	14660	3	0	2066
221093	2134	12085635000	29740	14660	4	0	8230
221094	2134	12084631000	29740	14660	5	0	8231
221095	2133	8717588000	29740	14660	6	0	7709
221097	2133	8715584000	29740	14660	8	0	7711
221107	1397	1258111946000	29742	14661	0	0	18071
221108	1397	1258101945000	29742	14661	1	0	18072
221109	2133	8714582000	29742	14661	2	0	7712
221110	2133	8713580000	29742	14661	3	0	7713
221112	2134	12082623000	29742	14661	5	0	8233
221113	2134	12081619000	29742	14661	6	0	8234
221114	2134	12080615000	29742	14661	7	0	8235
221115	2134	12079611000	29742	14661	8	0	8236
221117	2133	8712578000	29742	14661	10	0	7714
221118	2133	8711576000	29742	14661	11	0	7715
221119	2133	8710574000	29742	14661	12	0	7716
221120	2132	6920935000	29742	14661	13	0	2067
221121	2132	6919934000	29742	14661	14	0	2068
221137	2132	6917932000	29744	14662	2	0	\N
221138	2134	12077603000	29744	14662	3	0	\N
221139	2133	8709572000	29744	14662	4	0	\N
221140	2133	8708570000	29744	14662	5	0	\N
221141	2133	8707568000	29744	14662	6	0	\N
221142	2133	8706566000	29744	14662	7	0	\N
221143	2133	8705564000	29744	14662	8	0	\N
221144	2132	6916931000	29744	14662	9	0	\N
221145	2132	6915930000	29744	14662	10	0	\N
221146	2133	8704562000	29744	14662	11	0	\N
221147	2134	12076599000	29744	14662	12	0	\N
221148	2134	12075595000	29744	14662	13	0	\N
221149	2134	12074591000	29744	14662	14	0	\N
221150	2134	12073587000	29744	14662	15	0	\N
221151	2134	12072583000	29744	14662	16	0	\N
221152	2134	12071579000	29744	14662	17	0	\N
221171	1397	1258091944000	29746	14662	0	0	\N
221172	1397	1258081943000	29746	14662	1	0	\N
221173	2132	6917932000	29746	14662	2	0	\N
221174	2134	12077603000	29746	14662	3	0	\N
221175	2133	8709572000	29746	14662	4	0	\N
221176	2133	8708570000	29746	14662	5	0	\N
221177	2133	8707568000	29746	14662	6	0	\N
221178	2133	8706566000	29746	14662	7	0	\N
221179	2133	8705564000	29746	14662	8	0	\N
221180	2132	6916931000	29746	14662	9	0	\N
221181	2132	6915930000	29746	14662	10	0	\N
221182	2133	8704562000	29746	14662	11	0	\N
221183	2134	12076599000	29746	14662	12	0	\N
221184	2134	12075595000	29746	14662	13	0	\N
221185	2134	12074591000	29746	14662	14	0	\N
221186	2134	12073587000	29746	14662	15	0	\N
221187	2134	12072583000	29746	14662	16	0	\N
221188	2134	12071579000	29746	14662	17	0	\N
221189	1397	1258071942000	29747	14663	0	0	\N
221190	1397	1258061941000	29747	14663	1	0	\N
221191	1397	1258051940000	29747	14663	2	0	\N
221192	2132	6914929000	29747	14663	3	0	\N
221193	2132	6913928000	29747	14663	4	0	\N
221194	2132	6912927000	29747	14663	5	0	\N
221195	2132	6911926000	29747	14663	6	0	\N
221196	2134	12070575000	29747	14663	7	0	\N
221197	2134	12069571000	29747	14663	8	0	\N
221198	2134	12068567000	29747	14663	9	0	\N
221199	2134	12067563000	29747	14663	10	0	\N
221200	2134	12066559000	29747	14663	11	0	\N
221201	2134	12065555000	29747	14663	12	0	\N
221202	2134	12064551000	29747	14663	13	0	\N
221203	2134	12063547000	29747	14663	14	0	\N
221204	2134	12062543000	29747	14663	15	0	\N
221229	1397	1258071942000	29749	14663	0	0	\N
221230	1397	1258061941000	29749	14663	1	0	\N
221231	1397	1258051940000	29749	14663	2	0	\N
221232	2132	6914929000	29749	14663	3	0	\N
221233	2132	6913928000	29749	14663	4	0	\N
221234	2132	6912927000	29749	14663	5	0	\N
221235	2133	8703560000	29749	14663	6	0	\N
221236	2133	8702558000	29749	14663	7	0	\N
221237	2133	8701556000	29749	14663	8	0	\N
221238	2133	8700554000	29749	14663	9	0	\N
221239	2133	8699552000	29749	14663	10	0	\N
221240	2133	8698550000	29749	14663	11	0	\N
221241	2133	8697548000	29749	14663	12	0	\N
221242	2133	8696546000	29749	14663	13	0	\N
221243	2132	6911926000	29749	14663	14	0	\N
221244	2134	12070575000	29749	14663	15	0	\N
221245	2134	12069571000	29749	14663	16	0	\N
221246	2134	12068567000	29749	14663	17	0	\N
221247	2134	12067563000	29749	14663	18	0	\N
221248	2134	12066559000	29749	14663	19	0	\N
221249	2134	12065555000	29749	14663	20	0	\N
221250	2134	12064551000	29749	14663	21	0	\N
221251	2134	12063547000	29749	14663	22	0	\N
221252	2134	12062543000	29749	14663	23	0	\N
221253	1397	1258071942000	29750	14663	0	0	\N
221254	1397	1258061941000	29750	14663	1	0	\N
221255	1397	1258051940000	29750	14663	2	0	\N
221256	2132	6914929000	29750	14663	3	0	\N
221257	2132	6913928000	29750	14663	4	0	\N
221258	1397	1258041939000	29751	14664	0	0	\N
221259	2132	6910925000	29751	14664	1	0	\N
221268	1397	1258031938000	29753	14665	0	0	\N
221269	2132	6909924000	29753	14665	1	0	\N
221270	2132	6908923000	29753	14665	2	0	\N
221271	1397	1258031938000	29754	14665	0	0	\N
221272	2133	8692538000	29754	14665	1	0	\N
221155	2132	6917932000	29745	14662	2	0	2070
221156	2134	12077603000	29745	14662	3	0	8238
221157	2133	8709572000	29745	14662	4	0	7717
221158	2133	8708570000	29745	14662	5	0	7718
221159	2133	8707568000	29745	14662	6	0	7719
221161	2133	8705564000	29745	14662	8	0	7721
221162	2132	6916931000	29745	14662	9	0	2071
221163	2132	6915930000	29745	14662	10	0	2072
221164	2133	8704562000	29745	14662	11	0	7722
221165	2134	12076599000	29745	14662	12	0	8239
221167	2134	12074591000	29745	14662	14	0	8241
221168	2134	12073587000	29745	14662	15	0	8242
221169	2134	12072583000	29745	14662	16	0	8243
221170	2134	12071579000	29745	14662	17	0	8244
221206	1397	1258061941000	29748	14663	1	0	18076
221207	1397	1258051940000	29748	14663	2	0	18077
221208	2132	6914929000	29748	14663	3	0	2073
221209	2132	6913928000	29748	14663	4	0	2074
221210	2132	6912927000	29748	14663	5	0	2075
221212	2133	8702558000	29748	14663	7	0	7724
221213	2133	8701556000	29748	14663	8	0	7725
221214	2133	8700554000	29748	14663	9	0	7726
221215	2133	8699552000	29748	14663	10	0	7727
221216	2133	8698550000	29748	14663	11	0	7728
221218	2133	8696546000	29748	14663	13	0	7730
221219	2132	6911926000	29748	14663	14	0	2076
221220	2134	12070575000	29748	14663	15	0	8245
221221	2134	12069571000	29748	14663	16	0	8246
221223	2134	12067563000	29748	14663	18	0	8248
221224	2134	12066559000	29748	14663	19	0	8249
221225	2134	12065555000	29748	14663	20	0	8250
221226	2134	12064551000	29748	14663	21	0	8251
221227	2134	12063547000	29748	14663	22	0	8252
221260	1397	1258041939000	29752	14664	0	0	18078
221261	2133	8695544000	29752	14664	1	0	7731
221262	2133	8694542000	29752	14664	2	0	7732
221263	2132	6910925000	29752	14664	3	0	2077
221264	2134	12061539000	29752	14664	4	0	8254
221266	2134	12059531000	29752	14664	6	0	8256
221267	2133	8693540000	29752	14664	7	0	7733
221273	2133	8691536000	29754	14665	2	0	\N
221274	2133	8690534000	29754	14665	3	0	\N
221275	2132	6909924000	29754	14665	4	0	\N
221276	2132	6908923000	29754	14665	5	0	\N
221277	2134	12058527000	29754	14665	6	0	\N
221278	2134	12057523000	29754	14665	7	0	\N
221284	1397	1258021937000	29756	14666	0	0	\N
221285	1397	1258011936000	29756	14666	1	0	\N
221286	1693	17239788899116	29756	14666	2	0	\N
221287	2133	8692538000	29756	14666	3	0	\N
221288	1693	16836971063748	29756	14666	5	0	\N
221289	1693	16750321023883	29756	14666	6	0	\N
221290	1693	16663670984018	29756	14666	7	0	\N
221291	1693	16577020944153	29756	14666	8	0	\N
221292	1693	16490370904288	29756	14666	9	0	\N
221293	1693	16404089618295	29756	14666	10	0	\N
221294	1693	15781643702139	29756	14666	11	0	\N
221295	1693	14598290813627	29756	14666	12	0	\N
221296	1693	14512009318472	29756	14666	13	0	\N
221297	2132	6907922000	29756	14666	14	0	\N
221298	2132	6906921000	29756	14666	15	0	\N
221299	2132	6905920000	29756	14666	16	0	\N
221300	2133	8691536000	29756	14666	17	0	\N
221301	2133	8690534000	29756	14666	18	0	\N
221320	1397	1258021937000	29758	14666	0	0	\N
221321	1397	1258011936000	29758	14666	2	0	\N
221322	1693	17239788899116	29758	14666	3	0	\N
221323	2134	12056519000	29758	14666	4	0	\N
221324	2134	12055515000	29758	14666	5	0	\N
221325	2134	12054511000	29758	14666	6	0	\N
221326	2134	12053507000	29758	14666	7	0	\N
221327	1693	16836971063748	29758	14666	8	0	\N
221328	1693	16750321023883	29758	14666	9	0	\N
221329	1693	16663670984018	29758	14666	10	0	\N
221330	1693	16577020944153	29758	14666	11	0	\N
221331	1693	16490370904288	29758	14666	12	0	\N
221332	1693	16404089618295	29758	14666	13	0	\N
221333	1693	15781643702139	29758	14666	14	0	\N
221334	1693	14598290813627	29758	14666	15	0	\N
221335	1693	14512009318472	29758	14666	16	0	\N
221336	2132	6907922000	29758	14666	17	0	\N
221337	2132	6906921000	29758	14666	18	0	\N
221338	2132	6905920000	29758	14666	19	0	\N
221339	2133	8689532000	29758	14666	20	0	\N
221340	2133	8688530000	29758	14666	21	0	\N
221341	2133	8687528000	29758	14666	22	0	\N
221342	2133	8686526000	29758	14666	23	0	\N
221343	2133	8685524000	29758	14666	24	0	\N
221367	1397	1257991934000	29760	14668	0	0	\N
221368	2134	12049491000	29760	14668	1	0	\N
221369	2134	12048487000	29760	14668	2	0	\N
221370	2132	6903918000	29760	14668	3	0	\N
221371	2132	6902917000	29760	14668	4	0	\N
221372	2133	8681516000	29760	14668	5	0	\N
221373	2133	8680514000	29760	14668	6	0	\N
221374	2133	8679512000	29760	14668	7	0	\N
221375	1693	13835208700785	29760	14668	8	0	\N
221376	1693	13748558660920	29760	14668	9	0	\N
221377	1693	13661908621055	29760	14668	10	0	\N
221378	1693	13575258581190	29760	14668	11	0	\N
221379	1693	13488608541325	29760	14668	12	0	\N
221380	1693	13401958501460	29760	14668	13	0	\N
221381	2134	12049491000	29761	14668	0	0	\N
221382	2134	12048487000	29761	14668	1	0	\N
221383	2132	6903918000	29761	14668	2	0	\N
221384	2132	6902917000	29761	14668	3	0	\N
221385	2133	8681516000	29761	14668	4	0	\N
221386	2133	8680514000	29761	14668	5	0	\N
221387	2133	8679512000	29761	14668	6	0	\N
221388	1693	13835208700785	29761	14668	7	0	\N
221389	1693	13748558660920	29761	14668	8	0	\N
221390	1693	13661908621055	29761	14668	9	0	\N
221391	1693	13575258581190	29761	14668	10	0	\N
221392	1693	13488608541325	29761	14668	11	0	\N
221407	1397	1257991934000	29763	14668	0	0	\N
221408	2134	12049491000	29763	14668	1	0	\N
221281	2132	6908923000	29755	14665	2	0	2079
221282	2134	12058527000	29755	14665	3	0	8257
221283	2134	12057523000	29755	14665	4	0	8258
221302	1397	1258021937000	29757	14666	0	0	18080
221303	1397	1258011936000	29757	14666	1	0	18081
221305	2133	8692538000	29757	14666	3	0	7734
221306	1693	16836971063748	29757	14666	5	0	1385
221307	1693	16750321023883	29757	14666	6	0	1386
221308	1693	16663670984018	29757	14666	7	0	1387
221309	1693	16577020944153	29757	14666	8	0	1388
221311	1693	16404089618295	29757	14666	10	0	1390
221312	1693	15781643702139	29757	14666	11	0	1391
221313	1693	14598290813627	29757	14666	12	0	1392
221314	1693	14512009318472	29757	14666	13	0	1393
221316	2132	6906921000	29757	14666	15	0	2081
221317	2132	6905920000	29757	14666	16	0	2082
221318	2133	8691536000	29757	14666	17	0	7735
221319	2133	8690534000	29757	14666	18	0	7736
221344	1397	1258001935000	29759	14667	0	0	18082
221346	1693	14339444422371	29759	14667	2	0	1395
221347	1693	14253160011985	29759	14667	3	0	1396
221348	1693	14166509972120	29759	14667	4	0	1397
221349	1693	14159944650925	29759	14667	5	0	1398
221350	1693	14073294611060	29759	14667	6	0	1399
221352	2134	12055515000	29759	14667	8	0	8260
221353	2134	12054511000	29759	14667	9	0	8261
221354	2134	12053507000	29759	14667	10	0	8262
221355	2132	6904919000	29759	14667	11	0	2083
221357	2133	8689532000	29759	14667	13	0	7737
221358	2133	8688530000	29759	14667	14	0	7738
221359	2133	8687528000	29759	14667	15	0	7739
221360	2133	8686526000	29759	14667	16	0	7740
221361	2133	8685524000	29759	14667	17	0	7741
221363	2133	8683520000	29759	14667	19	0	7743
221364	2133	8682518000	29759	14667	20	0	7744
221365	2134	12051499000	29759	14667	21	0	8264
221366	2134	12050495000	29759	14667	22	0	8265
221393	1397	1257991934000	29762	14668	0	0	18083
221395	2134	12048487000	29762	14668	2	0	8267
221396	2132	6903918000	29762	14668	3	0	2084
221397	2132	6902917000	29762	14668	4	0	2085
221398	2133	8681516000	29762	14668	5	0	7745
221400	2133	8679512000	29762	14668	7	0	7747
221401	1693	13835208700785	29762	14668	8	0	1400
221402	1693	13748558660920	29762	14668	9	0	1401
221403	1693	13661908621055	29762	14668	10	0	1402
221404	1693	13575258581190	29762	14668	11	0	1403
221406	1693	13401958501460	29762	14668	13	0	1405
221409	2134	12048487000	29763	14668	2	0	\N
221410	2132	6903918000	29763	14668	3	0	\N
221411	2132	6902917000	29763	14668	4	0	\N
221412	1693	13835208700785	29763	14668	5	0	\N
221413	1693	13748558660920	29763	14668	6	0	\N
221414	1693	13661908621055	29763	14668	7	0	\N
221415	1693	13575258581190	29763	14668	8	0	\N
221416	1693	13488608541325	29763	14668	9	0	\N
221417	1693	13401958501460	29763	14668	10	0	\N
221454	1397	1257961931000	29767	14672	0	0	\N
221455	1397	1257951930000	29767	14672	1	0	\N
221456	2132	6897912000	29767	14672	2	0	\N
221457	2133	8671496000	29767	14672	3	0	\N
221458	1693	12014034272372	29767	14672	4	0	\N
221459	1693	11971469651633	29767	14672	5	0	\N
221460	2132	6896911000	29767	14672	6	0	\N
221461	2134	12040455000	29767	14672	7	0	\N
221462	2134	12039451000	29767	14672	8	0	\N
221463	2133	8670494000	29767	14672	9	0	\N
221464	2133	8669492000	29767	14672	10	0	\N
221465	2132	6895910000	29767	14672	11	0	\N
221466	2134	12038447000	29767	14672	12	0	\N
221467	2134	12037443000	29767	14672	13	0	\N
221468	2134	12036439000	29767	14672	14	0	\N
221469	2134	12035435000	29767	14672	15	0	\N
221470	2134	12034431000	29767	14672	16	0	\N
221471	2133	8668490000	29767	14672	17	0	\N
221472	2133	8667488000	29767	14672	18	0	\N
221473	1397	1257961931000	29768	14672	0	0	\N
221474	1397	1257951930000	29768	14672	1	0	\N
221475	2132	6897912000	29768	14672	2	0	\N
221476	2133	8671496000	29768	14672	3	0	\N
221477	1693	12014034272372	29768	14672	4	0	\N
221478	1693	11971469651633	29768	14672	5	0	\N
221479	2132	6896911000	29768	14672	6	0	\N
221480	2134	12040455000	29768	14672	7	0	\N
221481	2134	12039451000	29768	14672	8	0	\N
221482	2133	8670494000	29768	14672	9	0	\N
221483	2133	8669492000	29768	14672	10	0	\N
221484	2132	6895910000	29768	14672	11	0	\N
221485	2134	12038447000	29768	14672	12	0	\N
221486	2134	12037443000	29768	14672	13	0	\N
221487	2134	12036439000	29768	14672	14	0	\N
221488	2134	12035435000	29768	14672	15	0	\N
221489	2134	12034431000	29768	14672	16	0	\N
221490	2133	8668490000	29768	14672	17	0	\N
221491	2133	8667488000	29768	14672	18	0	\N
221536	1397	1257941929000	29771	14673	0	0	\N
221537	1397	1257931928000	29771	14673	1	0	\N
221538	1693	12014034272372	29771	14673	2	0	\N
221539	1693	11971469651633	29771	14673	3	0	\N
221540	2132	6894909000	29771	14673	4	0	\N
221541	1693	11884819611768	29771	14673	5	0	\N
221542	1693	11798169571903	29771	14673	7	0	\N
221543	1693	11711519532038	29771	14673	8	0	\N
221544	2132	6893908000	29771	14673	9	0	\N
221420	2134	12045475000	29764	14669	2	0	8270
221421	2133	8678510000	29764	14669	3	0	7748
221422	2132	6901916000	29764	14669	4	0	2086
221423	2133	8677508000	29764	14669	5	0	7749
221424	1693	13315308461595	29764	14669	6	0	1406
221426	1693	13142377135737	29764	14669	8	0	1408
221427	1693	13055727095872	29764	14669	9	0	1409
221428	1693	12969077056007	29764	14669	10	0	1410
221429	1397	1257981933000	29765	14670	0	0	18084
221430	2132	6900915000	29765	14670	1	0	2087
221432	1693	12795776976277	29765	14670	3	0	1412
221433	2132	6899914000	29765	14670	4	0	2088
221434	1693	12709126936412	29765	14670	5	0	1413
221435	1693	12622842526026	29765	14670	6	0	1414
221437	2134	12044471000	29765	14670	8	0	8271
221438	2134	12043467000	29765	14670	9	0	8272
221439	2133	8676506000	29765	14670	10	0	7750
221440	2133	8675504000	29765	14670	11	0	7751
221441	1397	1257971932000	29766	14671	0	0	18085
221443	2134	12042463000	29766	14671	2	0	8273
221444	2134	12041459000	29766	14671	3	0	8274
221445	2132	6898913000	29766	14671	4	0	2089
221446	2133	8674502000	29766	14671	5	0	7752
221447	2133	8673500000	29766	14671	6	0	7753
221449	1693	12362892406431	29766	14671	8	0	1417
221450	1693	12276242366566	29766	14671	9	0	1418
221451	1693	12189592326701	29766	14671	10	0	1419
221452	1693	12186965598230	29766	14671	11	0	1420
221492	1397	1257961931000	29769	14672	0	0	18086
221493	1397	1257951930000	29769	14672	1	0	18087
221494	2132	6897912000	29769	14672	2	0	2090
221495	2133	8671496000	29769	14672	3	0	7755
221496	2132	6896911000	29769	14672	4	0	2091
221498	2134	12039451000	29769	14672	6	0	8276
221499	2133	8670494000	29769	14672	7	0	7756
221500	2133	8669492000	29769	14672	8	0	7757
221501	2132	6895910000	29769	14672	9	0	2092
221502	2134	12038447000	29769	14672	10	0	8277
221504	2134	12036439000	29769	14672	12	0	8279
221505	2134	12035435000	29769	14672	13	0	8280
221506	2134	12034431000	29769	14672	14	0	8281
221507	2133	8668490000	29769	14672	15	0	7758
221509	1397	1257941929000	29770	14673	0	0	18088
221510	1397	1257931928000	29770	14673	1	0	18089
221511	2133	8666486000	29770	14673	2	0	7760
221512	2134	12033427000	29770	14673	3	0	8282
221513	2134	12032423000	29770	14673	4	0	8283
221515	2133	8665484000	29770	14673	7	0	7761
221516	2133	8664482000	29770	14673	8	0	7762
221517	1693	12014034272372	29770	14673	9	0	1422
221518	1693	11971469651633	29770	14673	10	0	1423
221519	2133	8663480000	29770	14673	11	0	7763
221521	2133	8661476000	29770	14673	13	0	7765
221522	2132	6894909000	29770	14673	14	0	2093
221523	2134	12030415000	29770	14673	15	0	8285
221524	2134	12029411000	29770	14673	16	0	8286
221526	1693	11884819611768	29770	14673	18	0	1424
221527	1693	11798169571903	29770	14673	19	0	1425
221528	1693	11711519532038	29770	14673	20	0	1426
221529	2132	6893908000	29770	14673	21	0	2094
221530	2132	6892907000	29770	14673	22	0	2095
221532	1693	11538392837247	29770	14673	24	0	1428
221533	1693	11451742797382	29770	14673	25	0	1429
221534	1693	11365092757517	29770	14673	26	0	1430
221535	1693	11278442717652	29770	14673	27	0	1431
221545	2132	6892907000	29771	14673	10	0	\N
221546	1693	11624674763803	29771	14673	11	0	\N
221547	1693	11538392837247	29771	14673	12	0	\N
221548	1693	11451742797382	29771	14673	13	0	\N
221549	1693	11365092757517	29771	14673	14	0	\N
221550	1693	11278442717652	29771	14673	15	0	\N
221582	1397	1257921927000	29773	14674	0	0	\N
221583	1397	1257911926000	29773	14674	1	0	\N
221584	2132	6891906000	29773	14674	2	0	\N
221585	2132	6890905000	29773	14674	3	0	\N
221586	2134	12027403000	29773	14674	4	0	\N
221587	2132	6889904000	29773	14674	5	0	\N
221588	2134	12026399000	29773	14674	6	0	\N
221589	2134	12025395000	29773	14674	7	0	\N
221590	2134	12024391000	29773	14674	8	0	\N
221591	2134	12023387000	29773	14674	9	0	\N
221592	2133	8660474000	29773	14674	10	0	\N
221593	2134	12022383000	29773	14674	11	0	\N
221594	2134	12021379000	29773	14674	12	0	\N
221595	2134	12020375000	29773	14674	13	0	\N
221596	1693	11192160791096	29773	14674	14	0	\N
221597	1693	11105510751231	29773	14674	15	0	\N
221598	1693	11018860711366	29773	14674	16	0	\N
221599	1693	10932210671501	29773	14674	17	0	\N
221600	1693	10845560631636	29773	14674	18	0	\N
221601	1693	10759279345643	29773	14674	19	0	\N
221602	1693	10756652617172	29773	14674	20	0	\N
221603	2133	8659472000	29773	14674	21	0	\N
221604	2133	8658470000	29773	14674	22	0	\N
221605	2133	8657468000	29773	14674	23	0	\N
221606	1693	10670002577307	29773	14674	24	0	\N
221607	1693	10583352537442	29773	14674	25	0	\N
221608	2133	8656466000	29773	14674	26	0	\N
221609	2133	8655464000	29773	14674	27	0	\N
221610	1693	8358452287170	29773	14674	28	0	\N
221611	1693	8271802247305	29773	14674	29	0	\N
221612	1693	8185152207440	29773	14674	30	0	\N
221613	1397	1257921927000	29774	14674	0	0	\N
221614	1397	1257911926000	29774	14674	1	0	\N
221615	2132	6891906000	29774	14674	2	0	\N
221616	2132	6890905000	29774	14674	3	0	\N
221617	2134	12027403000	29774	14674	4	0	\N
221618	2132	6889904000	29774	14674	5	0	\N
221619	2134	12026399000	29774	14674	6	0	\N
221620	2134	12025395000	29774	14674	7	0	\N
221621	2134	12024391000	29774	14674	8	0	\N
221622	2134	12023387000	29774	14674	9	0	\N
221623	2133	8660474000	29774	14674	10	0	\N
221624	2134	12022383000	29774	14674	11	0	\N
221625	2134	12021379000	29774	14674	12	0	\N
221626	2134	12020375000	29774	14674	13	0	\N
221627	1693	11192160791096	29774	14674	14	0	\N
221628	1693	11105510751231	29774	14674	15	0	\N
221629	1693	11018860711366	29774	14674	16	0	\N
221630	1693	10932210671501	29774	14674	17	0	\N
221631	1693	10845560631636	29774	14674	18	0	\N
221632	1693	10759279345643	29774	14674	19	0	\N
221633	1693	10756652617172	29774	14674	20	0	\N
221634	2133	8659472000	29774	14674	21	0	\N
221635	2133	8658470000	29774	14674	22	0	\N
221636	2133	8657468000	29774	14674	23	0	\N
221637	1693	10670002577307	29774	14674	24	0	\N
221638	1693	10583352537442	29774	14674	25	0	\N
221639	2133	8656466000	29774	14674	26	0	\N
221640	2133	8655464000	29774	14674	27	0	\N
221641	1693	8358452287170	29774	14674	28	0	\N
221642	1693	8271802247305	29774	14674	29	0	\N
221643	1693	8185152207440	29774	14674	30	0	\N
221672	1397	1257881923000	29776	14676	0	0	\N
221673	2133	8649452000	29776	14676	1	0	\N
221674	2133	8648450000	29776	14676	2	0	\N
221675	1693	7146822420059	29776	14676	3	0	\N
221676	2134	12012343000	29776	14676	4	0	\N
221677	2134	12011339000	29776	14676	5	0	\N
221678	2134	12010335000	29776	14676	6	0	\N
221679	2134	12009331000	29776	14676	7	0	\N
221680	1693	7060172380194	29776	14676	8	0	\N
221553	2132	6891906000	29772	14674	2	0	2096
221554	2132	6890905000	29772	14674	3	0	2097
221555	2134	12027403000	29772	14674	4	0	8288
221556	2132	6889904000	29772	14674	5	0	2098
221557	2134	12026399000	29772	14674	6	0	8289
221559	2134	12024391000	29772	14674	8	0	8291
221560	2134	12023387000	29772	14674	9	0	8292
221561	2133	8660474000	29772	14674	10	0	7766
221562	2134	12022383000	29772	14674	11	0	8293
221563	2134	12021379000	29772	14674	12	0	8294
221565	1693	11192160791096	29772	14674	14	0	1432
221566	1693	11105510751231	29772	14674	15	0	1433
221567	1693	11018860711366	29772	14674	16	0	1434
221568	1693	10932210671501	29772	14674	17	0	1435
221570	1693	10759279345643	29772	14674	19	0	1437
221571	1693	10756652617172	29772	14674	20	0	1438
221572	2133	8659472000	29772	14674	21	0	7767
221573	2133	8658470000	29772	14674	22	0	7768
221574	2133	8657468000	29772	14674	23	0	7769
221576	1693	10583352537442	29772	14674	25	0	1440
221577	2133	8656466000	29772	14674	26	0	7770
221578	2133	8655464000	29772	14674	27	0	7771
221579	1693	8358452287170	29772	14674	28	0	1441
221580	1693	8271802247305	29772	14674	29	0	1442
221644	1397	1257901925000	29775	14675	0	0	18092
221645	1397	1257891924000	29775	14675	1	0	18093
221646	2132	6888903000	29775	14675	2	0	2099
221647	2132	6887902000	29775	14675	3	0	2100
221649	2134	12019371000	29775	14675	5	0	8296
221650	2134	12018367000	29775	14675	6	0	8297
221651	2134	12017363000	29775	14675	7	0	8298
221652	2134	12016359000	29775	14675	8	0	8299
221653	2134	12015355000	29775	14675	9	0	8300
221655	2134	12013347000	29775	14675	11	0	8302
221656	1693	8098870803786	29775	14675	12	0	1444
221657	2133	8654462000	29775	14675	13	0	7772
221658	2133	8653460000	29775	14675	14	0	7773
221659	2133	8652458000	29775	14675	15	0	7774
221661	2133	8650454000	29775	14675	17	0	7776
221662	1693	8012589400132	29775	14675	18	0	1445
221663	1693	7926304532202	29775	14675	19	0	1446
221664	1693	7840022738979	29775	14675	20	0	1447
221666	1693	7666722659249	29775	14675	22	0	1449
221667	1693	7580072619384	29775	14675	23	0	1450
221668	1693	7493422579519	29775	14675	24	0	1451
221669	1693	7406772539654	29775	14675	25	0	1452
221670	1693	7320122499789	29775	14675	26	0	1453
221681	1693	6973522340329	29776	14676	9	0	\N
221682	1693	6970906574971	29776	14676	10	0	\N
221683	1693	6884256535106	29776	14676	11	0	\N
221684	1693	6859048541707	29776	14676	12	0	\N
221685	2132	6885900000	29776	14676	13	0	\N
221686	1397	1257881923000	29777	14676	0	0	\N
221687	2133	8649452000	29777	14676	1	0	\N
221688	2133	8648450000	29777	14676	2	0	\N
221689	1693	7146822420059	29777	14676	3	0	\N
221690	2134	12012343000	29777	14676	4	0	\N
221691	2134	12011339000	29777	14676	5	0	\N
221692	2134	12010335000	29777	14676	6	0	\N
221693	2134	12009331000	29777	14676	7	0	\N
221694	1693	7060172380194	29777	14676	8	0	\N
221695	1693	6973522340329	29777	14676	9	0	\N
221696	1693	6970906574971	29777	14676	10	0	\N
221697	1693	6884256535106	29777	14676	11	0	\N
221698	1693	6859048541707	29777	14676	12	0	\N
221699	2132	6885900000	29777	14676	13	0	\N
221700	2132	6884899000	29777	14676	14	0	\N
221701	1397	1257881923000	29778	14676	0	0	\N
221702	2133	8649452000	29778	14676	1	0	\N
221703	2133	8648450000	29778	14676	2	0	\N
221704	1693	7146822420059	29778	14676	3	0	\N
221705	2134	12012343000	29778	14676	4	0	\N
221706	2134	12011339000	29778	14676	5	0	\N
221707	2134	12010335000	29778	14676	6	0	\N
221708	2134	12009331000	29778	14676	7	0	\N
221709	1693	7060172380194	29778	14676	8	0	\N
221710	1693	6973522340329	29778	14676	9	0	\N
221711	1693	6970906574971	29778	14676	10	0	\N
221712	1693	6884256535106	29778	14676	11	0	\N
221713	1693	6859048541707	29778	14676	12	0	\N
221714	2132	6885900000	29778	14676	13	0	\N
221715	2132	6884899000	29778	14676	14	0	\N
221729	1397	1257881923000	29780	14676	0	0	\N
221730	2133	8649452000	29780	14676	1	0	\N
221731	2133	8648450000	29780	14676	2	0	\N
221732	1693	7146822420059	29780	14676	3	0	\N
221733	2134	12012343000	29780	14676	4	0	\N
221734	2134	12011339000	29780	14676	5	0	\N
221735	2134	12010335000	29780	14676	6	0	\N
221736	2134	12009331000	29780	14676	7	0	\N
221737	1693	7060172380194	29780	14676	8	0	\N
221738	1693	6973522340329	29780	14676	9	0	\N
221739	1693	6970906574971	29780	14676	10	0	\N
221740	1693	6884256535106	29780	14676	11	0	\N
221741	1693	6859048541707	29780	14676	12	0	\N
221742	2132	6885900000	29780	14676	13	0	\N
221743	2132	6884899000	29780	14676	14	0	\N
221776	1397	1258021937000	29783	14666	0	0	\N
221777	1397	1258011936000	29783	14666	2	0	\N
221778	1397	1258001935000	29783	14666	3	0	\N
221779	1397	1257991934000	29783	14666	4	0	\N
221780	1397	1257981933000	29783	14666	5	0	\N
221781	1397	1257971932000	29783	14666	6	0	\N
221782	1397	1257961931000	29783	14666	7	0	\N
221783	1397	1257951930000	29783	14666	8	0	\N
221784	1397	1257941929000	29783	14666	9	0	\N
221785	1397	1257931928000	29783	14666	10	0	\N
221786	1397	1257921927000	29783	14666	11	0	\N
221787	1397	1257911926000	29783	14666	12	0	\N
221788	1397	1257901925000	29783	14666	13	0	\N
221789	1397	1257891924000	29783	14666	14	0	\N
221790	1397	1257881923000	29783	14666	15	0	\N
221791	1397	1257871922000	29783	14666	16	0	\N
221792	1397	1257861921000	29783	14666	17	0	\N
221793	1397	1257851920000	29783	14666	18	0	\N
221794	1693	17239788899116	29783	14666	19	0	\N
221795	2134	12056519000	29783	14666	20	0	\N
221796	1693	16836971063748	29783	14666	21	0	\N
221797	1693	16750321023883	29783	14666	22	0	\N
221798	2132	6907922000	29783	14666	23	0	\N
221799	2133	8689532000	29783	14666	24	0	\N
221800	2133	8688530000	29783	14666	25	0	\N
221801	2133	8687528000	29783	14666	26	0	\N
221802	2133	8686526000	29783	14666	27	0	\N
221803	2133	8685524000	29783	14666	28	0	\N
221804	2133	8684522000	29783	14666	29	0	\N
221805	2133	8683520000	29783	14666	30	0	\N
221806	2133	8682518000	29783	14666	31	0	\N
221807	2133	8681516000	29783	14666	32	0	\N
221808	2133	8680514000	29783	14666	33	0	\N
221809	2133	8679512000	29783	14666	34	0	\N
221810	2133	8678510000	29783	14666	35	0	\N
221811	2133	8677508000	29783	14666	36	0	\N
221812	2133	8676506000	29783	14666	37	0	\N
221813	2133	8675504000	29783	14666	38	0	\N
221814	2133	8674502000	29783	14666	39	0	\N
221815	2133	8673500000	29783	14666	40	0	\N
221816	2133	8672498000	29783	14666	41	0	\N
221718	2133	8648450000	29779	14676	2	0	7778
221719	1693	7146822420059	29779	14676	3	0	1455
221720	2134	12012343000	29779	14676	4	0	8303
221721	2134	12011339000	29779	14676	5	0	8304
221722	2134	12010335000	29779	14676	6	0	8305
221724	1693	7060172380194	29779	14676	8	0	1456
221725	1693	6973522340329	29779	14676	9	0	1457
221726	1693	6970906574971	29779	14676	10	0	1458
221727	1693	6884256535106	29779	14676	11	0	1459
221728	2132	6885900000	29779	14676	12	0	2102
221745	1397	1257861921000	29781	14677	1	0	18096
221746	2133	8647448000	29781	14677	2	0	7779
221747	1693	6859048541707	29781	14677	3	0	1460
221748	1693	6772398501842	29781	14677	4	0	1461
221750	2132	6884899000	29781	14677	6	0	2103
221751	2132	6883898000	29781	14677	7	0	2104
221752	2132	6882897000	29781	14677	8	0	2105
221753	2132	6881896000	29781	14677	9	0	2106
221754	2134	12008327000	29781	14677	10	0	8307
221756	2134	12006319000	29781	14677	12	0	8309
221757	2134	12005315000	29781	14677	13	0	8310
221758	2133	8646446000	29781	14677	14	0	7780
221759	2133	8645444000	29781	14677	15	0	7781
221760	1693	6598524616145	29781	14677	16	0	1463
221762	2133	8643440000	29781	14677	18	0	7783
221763	2133	8642438000	29781	14677	19	0	7784
221764	1397	1257851920000	29782	14678	0	0	18097
221765	2132	6880895000	29782	14678	1	0	2107
221767	1693	6425593160866	29782	14678	4	0	1465
221768	1693	6338943121001	29782	14678	5	0	1466
221769	1693	5936125285633	29782	14678	6	0	1467
221770	1693	5849475245768	29782	14678	7	0	1468
221771	2133	8641436000	29782	14678	8	0	7785
221773	2134	12004311000	29782	14678	10	0	8311
221774	2134	12003307000	29782	14678	11	0	8312
221775	2134	12002303000	29782	14678	12	0	8313
221817	2133	8671496000	29783	14666	42	0	\N
221818	2133	8670494000	29783	14666	43	0	\N
221819	2133	8669492000	29783	14666	44	0	\N
221820	2133	8668490000	29783	14666	45	0	\N
221821	2133	8667488000	29783	14666	46	0	\N
221822	2133	8666486000	29783	14666	47	0	\N
221823	2133	8665484000	29783	14666	48	0	\N
221824	2133	8664482000	29783	14666	49	0	\N
221825	2133	8663480000	29783	14666	50	0	\N
221826	2133	8662478000	29783	14666	51	0	\N
221827	2133	8661476000	29783	14666	52	0	\N
221828	2133	8660474000	29783	14666	53	0	\N
221829	2133	8659472000	29783	14666	54	0	\N
221830	2133	8658470000	29783	14666	55	0	\N
221831	2133	8657468000	29783	14666	56	0	\N
221832	2133	8656466000	29783	14666	57	0	\N
221833	2133	8655464000	29783	14666	58	0	\N
221834	2133	8654462000	29783	14666	59	0	\N
221835	2133	8653460000	29783	14666	60	0	\N
221836	2133	8652458000	29783	14666	61	0	\N
221837	2133	8651456000	29783	14666	62	0	\N
221838	2133	8650454000	29783	14666	63	0	\N
221839	2133	8649452000	29783	14666	64	0	\N
221840	2133	8648450000	29783	14666	65	0	\N
221841	2133	8647448000	29783	14666	66	0	\N
221842	2133	8646446000	29783	14666	67	0	\N
221843	2133	8645444000	29783	14666	68	0	\N
221844	2133	8644442000	29783	14666	69	0	\N
221845	2133	8643440000	29783	14666	70	0	\N
221846	2133	8642438000	29783	14666	71	0	\N
221847	2133	8641436000	29783	14666	72	0	\N
221848	2133	8640434000	29783	14666	73	0	\N
221849	1397	1257851920000	29784	14678	0	0	\N
221850	2132	6880895000	29784	14678	1	0	\N
221851	1693	6512243200731	29784	14678	3	0	\N
221852	1693	6425593160866	29784	14678	4	0	\N
221853	1693	6338943121001	29784	14678	5	0	\N
221854	1693	5936125285633	29784	14678	6	0	\N
221855	1693	5849475245768	29784	14678	7	0	\N
221856	2133	8641436000	29784	14678	8	0	\N
221857	2133	8640434000	29784	14678	9	0	\N
221858	2134	12004311000	29784	14678	10	0	\N
221859	2134	12003307000	29784	14678	11	0	\N
221860	2134	12002303000	29784	14678	12	0	\N
221861	1397	1257841919000	29785	14679	0	0	\N
221862	1397	1257831918000	29785	14679	1	0	\N
221863	2133	8639432000	29785	14679	2	0	\N
221864	2133	8638430000	29785	14679	3	0	\N
221865	2132	6879894000	29785	14679	4	0	\N
221866	2133	8637428000	29785	14679	5	0	\N
221867	2133	8636426000	29785	14679	6	0	\N
221868	2133	8635424000	29785	14679	7	0	\N
221869	2133	8634422000	29785	14679	8	0	\N
221870	1693	5762825205903	29785	14679	9	0	\N
221871	1693	5676175166038	29785	14679	10	0	\N
221872	1693	5589525126173	29785	14679	11	0	\N
221873	1693	5502875086308	29785	14679	12	0	\N
221874	1693	5416593682654	29785	14679	13	0	\N
221875	1693	5329943642789	29785	14679	14	0	\N
221876	1693	5243662239135	29785	14679	15	0	\N
221877	1693	5157012199270	29785	14679	16	0	\N
221878	2132	6878893000	29785	14679	17	0	\N
221879	2132	6877892000	29785	14679	18	0	\N
221880	1693	5154393520771	29785	14679	19	0	\N
221881	1693	5067743480906	29785	14679	20	0	\N
221882	1693	4981093441041	29785	14679	21	0	\N
221883	1693	4894443401176	29785	14679	22	0	\N
221884	2134	12001299000	29785	14679	23	0	\N
221885	2134	12000295000	29785	14679	24	0	\N
221886	2134	11999291000	29785	14679	25	0	\N
221887	2134	11998287000	29785	14679	26	0	\N
221888	2134	11997283000	29785	14679	27	0	\N
221889	2134	11996279000	29785	14679	28	0	\N
221890	1397	1257841919000	29786	14679	0	0	\N
221891	1397	1257831918000	29786	14679	1	0	\N
221892	2133	8639432000	29786	14679	2	0	\N
221893	2133	8638430000	29786	14679	3	0	\N
221894	2132	6879894000	29786	14679	4	0	\N
221895	2133	8637428000	29786	14679	5	0	\N
221896	2133	8636426000	29786	14679	6	0	\N
221897	2133	8635424000	29786	14679	7	0	\N
221898	2133	8634422000	29786	14679	8	0	\N
221899	1693	5762825205903	29786	14679	9	0	\N
221900	1693	5676175166038	29786	14679	10	0	\N
221901	1693	5589525126173	29786	14679	11	0	\N
221902	1693	5502875086308	29786	14679	12	0	\N
221903	1693	5416593682654	29786	14679	13	0	\N
221904	1693	5329943642789	29786	14679	14	0	\N
221905	1693	5243662239135	29786	14679	15	0	\N
221906	1693	5157012199270	29786	14679	16	0	\N
221907	2132	6878893000	29786	14679	17	0	\N
221908	2132	6877892000	29786	14679	18	0	\N
221909	1693	5154393520771	29786	14679	19	0	\N
221910	1693	5067743480906	29786	14679	20	0	\N
221911	1693	4981093441041	29786	14679	21	0	\N
221912	1693	4894443401176	29786	14679	22	0	\N
221913	2134	12001299000	29786	14679	23	0	\N
221914	2134	12000295000	29786	14679	24	0	\N
221915	2134	11999291000	29786	14679	25	0	\N
221916	2134	11998287000	29786	14679	26	0	\N
221917	2134	11997283000	29786	14679	27	0	\N
221918	2134	11996279000	29786	14679	28	0	\N
221948	1397	1257841919000	29788	14667	0	0	\N
221949	1397	1257831918000	29788	14667	1	0	\N
221950	2133	8639432000	29788	14667	2	0	\N
221951	2133	8638430000	29788	14667	3	0	\N
221952	2133	8637428000	29788	14667	4	0	\N
221921	2133	8639432000	29787	14679	2	0	7787
221922	2133	8638430000	29787	14679	3	0	7788
221923	2132	6879894000	29787	14679	4	0	2108
221924	2133	8637428000	29787	14679	5	0	7789
221925	2133	8636426000	29787	14679	6	0	7790
221927	2133	8634422000	29787	14679	8	0	7792
221928	1693	5762825205903	29787	14679	9	0	1469
221929	1693	5676175166038	29787	14679	10	0	1470
221930	1693	5589525126173	29787	14679	11	0	1471
221931	1693	5502875086308	29787	14679	12	0	1472
221933	1693	5329943642789	29787	14679	14	0	1474
221934	1693	5243662239135	29787	14679	15	0	1475
221935	1693	5157012199270	29787	14679	16	0	1476
221936	2132	6878893000	29787	14679	17	0	2109
221938	1693	5154393520771	29787	14679	19	0	1477
221939	1693	5067743480906	29787	14679	20	0	1478
221940	1693	4981093441041	29787	14679	21	0	1479
221941	1693	4894443401176	29787	14679	22	0	1480
221942	2134	12001299000	29787	14679	23	0	8314
221944	2134	11999291000	29787	14679	25	0	8316
221945	2134	11998287000	29787	14679	26	0	8317
221946	2134	11997283000	29787	14679	27	0	8318
221947	2134	11996279000	29787	14679	28	0	8319
221953	2133	8636426000	29788	14667	5	0	\N
221954	2133	8635424000	29788	14667	6	0	\N
221955	2133	8634422000	29788	14667	7	0	\N
221956	1397	1257841919000	29789	14679	0	0	\N
221957	1397	1257831918000	29789	14679	1	0	\N
221958	2133	8639432000	29789	14679	2	0	\N
221959	2133	8638430000	29789	14679	3	0	\N
221960	2132	6879894000	29789	14679	4	0	\N
221961	2133	8637428000	29789	14679	5	0	\N
221962	2133	8636426000	29789	14679	6	0	\N
221963	2133	8635424000	29789	14679	7	0	\N
221964	2133	8634422000	29789	14679	8	0	\N
221965	1693	5762825205903	29789	14679	9	0	\N
221966	1693	5676175166038	29789	14679	10	0	\N
221967	1693	5589525126173	29789	14679	11	0	\N
221968	1693	5502875086308	29789	14679	12	0	\N
221969	1693	5416593682654	29789	14679	13	0	\N
221970	1693	5329943642789	29789	14679	14	0	\N
221971	1693	5243662239135	29789	14679	15	0	\N
221972	1693	5157012199270	29789	14679	16	0	\N
221973	2132	6878893000	29789	14679	17	0	\N
221974	2132	6877892000	29789	14679	18	0	\N
221975	1693	5154393520771	29789	14679	19	0	\N
221976	1693	5067743480906	29789	14679	20	0	\N
221977	1693	4981093441041	29789	14679	21	0	\N
221978	1693	4894443401176	29789	14679	22	0	\N
221979	2134	12001299000	29789	14679	23	0	\N
221980	2134	12000295000	29789	14679	24	0	\N
221981	2134	11999291000	29789	14679	25	0	\N
221982	2134	11998287000	29789	14679	26	0	\N
221983	2134	11997283000	29789	14679	27	0	\N
221984	2134	11996279000	29789	14679	28	0	\N
221985	1397	1257821917000	29791	14680	0	0	\N
221986	2133	8633420000	29791	14680	1	0	\N
221987	1693	4807793361311	29791	14680	2	0	\N
221988	2132	6876891000	29791	14680	3	0	\N
221989	1693	4721143321446	29791	14680	4	0	\N
221990	1693	4634493281581	29791	14680	5	0	\N
221991	1693	4548211877927	29791	14680	6	0	\N
221992	1693	4461561838062	29791	14680	7	0	\N
221993	2134	11995275000	29791	14680	8	0	\N
221994	2134	11994271000	29791	14680	9	0	\N
221995	2134	11993267000	29791	14680	10	0	\N
221996	2133	8632418000	29791	14680	11	0	\N
221997	2133	8631416000	29791	14680	12	0	\N
222011	1397	1257811916000	29793	14681	0	0	\N
222012	1693	4374911798197	29793	14681	1	0	\N
222013	2132	6875890000	29793	14681	2	0	\N
222014	2132	6874889000	29793	14681	3	0	\N
222015	2133	8630414000	29793	14681	4	0	\N
222016	2134	11992263000	29793	14681	5	0	\N
222017	2134	11991259000	29793	14681	6	0	\N
222018	1693	4288261758332	29793	14681	7	0	\N
222019	1693	4284335802777	29793	14681	8	0	\N
222020	1693	4197685762912	29793	14681	9	0	\N
222021	1693	4111035723047	29793	14681	10	0	\N
222022	1693	4108408994576	29793	14681	11	0	\N
222023	1397	1257811916000	29794	14681	0	0	\N
222024	1693	4374911798197	29794	14681	1	0	\N
222025	2132	6875890000	29794	14681	2	0	\N
222026	2132	6874889000	29794	14681	3	0	\N
222027	2133	8630414000	29794	14681	4	0	\N
222028	2134	11992263000	29794	14681	5	0	\N
222029	2134	11991259000	29794	14681	6	0	\N
222030	1693	4288261758332	29794	14681	7	0	\N
222031	1693	4284335802777	29794	14681	8	0	\N
222032	1693	4197685762912	29794	14681	9	0	\N
222033	1693	4111035723047	29794	14681	10	0	\N
222034	1693	4108408994576	29794	14681	11	0	\N
222047	1397	1257811916000	29796	14681	0	0	\N
222048	1693	4374911798197	29796	14681	1	0	\N
222049	2132	6875890000	29796	14681	2	0	\N
222050	2132	6874889000	29796	14681	3	0	\N
222051	2133	8630414000	29796	14681	4	0	\N
222052	1693	4288261758332	29796	14681	5	0	\N
222053	1693	4284335802777	29796	14681	6	0	\N
222054	1693	4197685762912	29796	14681	7	0	\N
222055	1693	4111035723047	29796	14681	8	0	\N
222000	1693	4807793361311	29792	14680	2	0	1481
222001	2132	6876891000	29792	14680	3	0	2111
222002	1693	4721143321446	29792	14680	4	0	1482
222003	1693	4634493281581	29792	14680	5	0	1483
222004	1693	4548211877927	29792	14680	6	0	1484
222006	2134	11995275000	29792	14680	8	0	8320
222007	2134	11994271000	29792	14680	9	0	8321
222008	2134	11993267000	29792	14680	10	0	8322
222009	2133	8632418000	29792	14680	11	0	7794
222010	2133	8631416000	29792	14680	12	0	7795
222036	1693	4374911798197	29795	14681	1	0	1486
222037	2132	6875890000	29795	14681	2	0	2112
222038	2132	6874889000	29795	14681	3	0	2113
222039	2133	8630414000	29795	14681	4	0	7796
222041	2134	11991259000	29795	14681	6	0	8324
222042	1693	4288261758332	29795	14681	7	0	1487
222043	1693	4284335802777	29795	14681	8	0	1488
222044	1693	4197685762912	29795	14681	9	0	1489
222045	1693	4111035723047	29795	14681	10	0	1490
222056	1643	3185279064700	29797	14682	0	0	26
222057	1397	1257801915000	29797	14682	1	0	18102
222058	1397	1257791914000	29797	14682	2	0	18103
222059	1397	1257781913000	29797	14682	3	0	18104
222060	1397	1257771912000	29797	14682	4	0	18105
222062	1693	3935108914846	29797	14682	6	0	1493
222063	1693	3848458874981	29797	14682	7	0	1494
222064	2132	6873888000	29797	14682	8	0	2114
222065	2134	11990255000	29797	14682	9	0	8325
222067	2134	11988247000	29797	14682	11	0	8327
222068	2134	11987243000	29797	14682	12	0	8328
222069	2132	6872887000	29797	14682	13	0	2115
222070	2132	6871886000	29797	14682	14	0	2116
222071	2132	6870885000	29797	14682	15	0	2117
222073	2132	6868883000	29797	14682	17	0	2119
222074	2134	11986239000	29797	14682	18	0	8329
222075	2134	11985235000	29797	14682	19	0	8330
222076	2134	11984231000	29797	14682	20	0	8331
222077	2134	11983227000	29797	14682	21	0	8332
222079	2134	11981219000	29797	14682	23	0	8334
222080	2134	11980215000	29797	14682	24	0	8335
222081	2134	11979211000	29797	14682	25	0	8336
222082	2134	11978207000	29797	14682	26	0	8337
222084	2134	11976199000	29797	14682	28	0	8339
222085	1693	3050026775845	29797	14682	29	0	1495
222086	1693	2963376735980	29797	14682	30	0	1496
222087	1693	2877095332326	29797	14682	31	0	1497
222088	1693	2790445292461	29797	14682	32	0	1498
222116	1397	1257761911000	29798	14683	0	0	\N
222117	2133	8618390000	29798	14683	1	0	\N
222118	2132	6867882000	29798	14683	2	0	\N
222119	2134	11975195000	29798	14683	3	0	\N
222120	2134	11974191000	29798	14683	4	0	\N
222121	2134	11973187000	29798	14683	5	0	\N
222122	2134	11972183000	29798	14683	6	0	\N
222123	2133	8617388000	29798	14683	7	0	\N
222124	2133	8616386000	29798	14683	8	0	\N
222133	1643	3185279064700	29800	14667	0	0	\N
222134	1397	1258001935000	29800	14667	1	0	\N
222135	1397	1257991934000	29800	14667	2	0	\N
222136	1397	1257981933000	29800	14667	3	0	\N
222137	1397	1257971932000	29800	14667	4	0	\N
222138	1397	1257961931000	29800	14667	5	0	\N
222139	1397	1257951930000	29800	14667	6	0	\N
222140	1397	1257941929000	29800	14667	7	0	\N
222141	1397	1257931928000	29800	14667	8	0	\N
222142	1397	1257921927000	29800	14667	9	0	\N
222143	1397	1257911926000	29800	14667	10	0	\N
222144	1397	1257901925000	29800	14667	11	0	\N
222145	1397	1257891924000	29800	14667	12	0	\N
222146	1397	1257881923000	29800	14667	13	0	\N
222147	1397	1257871922000	29800	14667	14	0	\N
222148	1397	1257861921000	29800	14667	15	0	\N
222149	1397	1257851920000	29800	14667	16	0	\N
222150	1397	1257841919000	29800	14667	17	0	\N
222151	1397	1257831918000	29800	14667	18	0	\N
222152	1397	1257821917000	29800	14667	19	0	\N
222153	1397	1257811916000	29800	14667	20	0	\N
222154	1397	1257801915000	29800	14667	21	0	\N
222155	1397	1257791914000	29800	14667	22	0	\N
222156	1397	1257781913000	29800	14667	23	0	\N
222157	1397	1257771912000	29800	14667	24	0	\N
222158	1397	1257761911000	29800	14667	25	0	\N
222159	1693	14425726855927	29800	14667	26	0	\N
222160	1693	14339444422371	29800	14667	27	0	\N
222161	1693	14253160011985	29800	14667	28	0	\N
222162	1693	14166509972120	29800	14667	29	0	\N
222163	1693	14159944650925	29800	14667	30	0	\N
222164	1693	14073294611060	29800	14667	31	0	\N
222165	2132	6904919000	29800	14667	32	0	\N
222166	2133	8689532000	29800	14667	33	0	\N
222167	2133	8688530000	29800	14667	34	0	\N
222168	2133	8687528000	29800	14667	35	0	\N
222169	2133	8686526000	29800	14667	36	0	\N
222170	2132	6903918000	29800	14667	37	0	\N
222171	2132	6902917000	29800	14667	38	0	\N
222172	2132	6901916000	29800	14667	39	0	\N
222173	2132	6900915000	29800	14667	40	0	\N
222174	2132	6899914000	29800	14667	41	0	\N
222175	2133	8685524000	29800	14667	42	0	\N
222176	2133	8684522000	29800	14667	43	0	\N
222177	2133	8683520000	29800	14667	44	0	\N
222178	2133	8682518000	29800	14667	45	0	\N
222179	2132	6898913000	29800	14667	46	0	\N
222180	2132	6897912000	29800	14667	47	0	\N
222181	2132	6896911000	29800	14667	48	0	\N
222182	2132	6895910000	29800	14667	49	0	\N
222183	2132	6894909000	29800	14667	50	0	\N
222184	2132	6893908000	29800	14667	51	0	\N
222185	2132	6892907000	29800	14667	52	0	\N
222186	2132	6891906000	29800	14667	53	0	\N
222187	2132	6890905000	29800	14667	54	0	\N
222188	2132	6889904000	29800	14667	55	0	\N
222189	2132	6888903000	29800	14667	56	0	\N
222190	2132	6887902000	29800	14667	57	0	\N
222191	2132	6886901000	29800	14667	58	0	\N
222192	2132	6885900000	29800	14667	59	0	\N
222193	2132	6884899000	29800	14667	60	0	\N
222194	2132	6883898000	29800	14667	61	0	\N
222195	2132	6882897000	29800	14667	62	0	\N
222196	2132	6881896000	29800	14667	63	0	\N
222197	2132	6880895000	29800	14667	64	0	\N
222198	2132	6879894000	29800	14667	65	0	\N
222199	2132	6878893000	29800	14667	66	0	\N
222200	2132	6877892000	29800	14667	67	0	\N
222201	2132	6876891000	29800	14667	68	0	\N
222202	2132	6875890000	29800	14667	69	0	\N
222203	2132	6874889000	29800	14667	70	0	\N
222204	2132	6873888000	29800	14667	71	0	\N
222205	2132	6872887000	29800	14667	72	0	\N
222206	2132	6871886000	29800	14667	73	0	\N
222207	2132	6870885000	29800	14667	74	0	\N
222208	2132	6869884000	29800	14667	75	0	\N
222209	2132	6868883000	29800	14667	76	0	\N
222210	2132	6867882000	29800	14667	77	0	\N
222211	2133	8681516000	29800	14667	78	0	\N
222212	2133	8680514000	29800	14667	79	0	\N
222213	2133	8679512000	29800	14667	80	0	\N
222214	1693	13835208700785	29800	14667	81	0	\N
222215	1693	13748558660920	29800	14667	82	0	\N
222216	1693	13661908621055	29800	14667	83	0	\N
222217	1693	13575258581190	29800	14667	84	0	\N
222218	1693	13488608541325	29800	14667	85	0	\N
222219	1693	13401958501460	29800	14667	86	0	\N
222220	1693	13315308461595	29800	14667	87	0	\N
222221	1693	13229027175602	29800	14667	88	0	\N
222222	1693	13142377135737	29800	14667	89	0	\N
222223	1693	13055727095872	29800	14667	90	0	\N
222224	1693	12969077056007	29800	14667	91	0	\N
222091	1693	2530863809077	29797	14682	35	0	1501
222092	1693	2444213769212	29797	14682	36	0	1502
222093	1693	2357932470143	29797	14682	37	0	1503
222094	1693	2271649746142	29797	14682	38	0	1504
222095	1693	2185368330728	29797	14682	39	0	1505
222097	1693	2012436887209	29797	14682	41	0	1507
222098	1693	1925786847344	29797	14682	42	0	1508
222099	1693	1839136807479	29797	14682	43	0	1509
222100	1693	1752486767614	29797	14682	44	0	1510
222101	1693	1665840688796	29797	14682	45	0	1511
222103	1693	1569999599262	29797	14682	47	0	1513
222104	1693	909642825590	29797	14682	48	0	1514
222105	2133	8629412000	29797	14682	49	0	7797
222106	2133	8628410000	29797	14682	51	0	7798
222108	2133	8626406000	29797	14682	53	0	7800
222109	2133	8625404000	29797	14682	54	0	7801
222110	2133	8624402000	29797	14682	55	0	7802
222111	2133	8623400000	29797	14682	56	0	7803
222112	2133	8622398000	29797	14682	57	0	7804
222114	2133	8620394000	29797	14682	59	0	7806
222115	2133	8619392000	29797	14682	60	0	7807
222125	1397	1257761911000	29799	14683	0	0	18106
222126	2133	8618390000	29799	14683	1	0	7808
222127	2132	6867882000	29799	14683	2	0	2120
222129	2134	11974191000	29799	14683	4	0	8341
222130	2134	11973187000	29799	14683	5	0	8342
222131	2134	11972183000	29799	14683	6	0	8343
222132	2133	8617388000	29799	14683	7	0	7809
222225	1693	12882427016142	29800	14667	92	0	\N
222226	1693	12795776976277	29800	14667	93	0	\N
222227	1693	12709126936412	29800	14667	94	0	\N
222228	1693	12622842526026	29800	14667	95	0	\N
222229	1693	12536192486161	29800	14667	96	0	\N
222230	1693	12449542446296	29800	14667	97	0	\N
222231	1693	12362892406431	29800	14667	98	0	\N
222232	1693	12276242366566	29800	14667	99	0	\N
222233	1693	12189592326701	29800	14667	100	0	\N
222234	1693	12186965598230	29800	14667	101	0	\N
222235	1397	1257751910000	29801	14684	0	0	\N
222236	2133	8616386000	29801	14684	1	0	\N
222237	2133	8615384000	29801	14684	2	0	\N
222238	2132	6866881000	29801	14684	3	0	\N
222239	2132	6865880000	29801	14684	4	0	\N
222240	2133	8614382000	29801	14684	5	0	\N
222241	2134	11971179000	29801	14684	6	0	\N
222242	2134	11970175000	29801	14684	7	0	\N
222243	2134	11969171000	29801	14684	8	0	\N
222244	2134	11968167000	29801	14684	9	0	\N
222245	2134	11967163000	29801	14684	10	0	\N
222276	1397	1257721907000	29804	14686	0	0	\N
222277	2134	11957123000	29804	14686	1	0	\N
222278	2134	11956119000	29804	14686	2	0	\N
222279	2132	6861876000	29804	14686	3	0	\N
222280	2134	11955115000	29804	14686	4	0	\N
222281	2134	11954111000	29804	14686	5	0	\N
222297	1397	1257711906000	29807	14687	0	0	\N
222303	1397	1257701905000	29809	14688	0	0	\N
222304	2133	8603360000	29809	14688	1	0	\N
222305	2133	8602358000	29809	14688	2	0	\N
222306	2132	6858873000	29809	14688	3	0	\N
222307	2133	8601356000	29809	14688	4	0	\N
222308	1397	1257701905000	29810	14688	0	0	\N
222309	2133	8603360000	29810	14688	1	0	\N
222310	2133	8602358000	29810	14688	2	0	\N
222311	2132	6858873000	29810	14688	3	0	\N
222312	2133	8601356000	29810	14688	4	0	\N
222313	1397	1257701905000	29811	14688	0	0	\N
222314	2133	8603360000	29811	14688	1	0	\N
222315	2133	8602358000	29811	14688	2	0	\N
222316	2132	6858873000	29811	14688	3	0	\N
222317	2133	8601356000	29811	14688	4	0	\N
222318	1643	3185279064700	29813	14666	0	0	\N
222319	1397	1258021937000	29813	14666	1	0	\N
222320	1397	1258011936000	29813	14666	2	0	\N
222321	1397	1258001935000	29813	14666	3	0	\N
222322	1397	1257991934000	29813	14666	5	0	\N
222323	1397	1257981933000	29813	14666	6	0	\N
222324	1397	1257971932000	29813	14666	7	0	\N
222325	1397	1257961931000	29813	14666	8	0	\N
222326	1397	1257951930000	29813	14666	9	0	\N
222327	1397	1257941929000	29813	14666	10	0	\N
222328	1397	1257931928000	29813	14666	11	0	\N
222329	1397	1257921927000	29813	14666	12	0	\N
222330	1397	1257911926000	29813	14666	13	0	\N
222331	1397	1257901925000	29813	14666	14	0	\N
222332	1397	1257891924000	29813	14666	15	0	\N
222333	1397	1257881923000	29813	14666	16	0	\N
222334	1397	1257871922000	29813	14666	17	0	\N
222335	1397	1257861921000	29813	14666	18	0	\N
222336	1397	1257851920000	29813	14666	19	0	\N
222337	1397	1257841919000	29813	14666	20	0	\N
222338	1397	1257831918000	29813	14666	21	0	\N
222339	1397	1257821917000	29813	14666	22	0	\N
222340	1397	1257811916000	29813	14666	23	0	\N
222341	1397	1257801915000	29813	14666	24	0	\N
222342	1397	1257791914000	29813	14666	25	0	\N
222343	1397	1257781913000	29813	14666	26	0	\N
222344	1397	1257771912000	29813	14666	27	0	\N
222345	1397	1257761911000	29813	14666	28	0	\N
222346	1397	1257751910000	29813	14666	29	0	\N
222347	1397	1257741909000	29813	14666	30	0	\N
222348	1397	1257731908000	29813	14666	31	0	\N
222349	1397	1257721907000	29813	14666	32	0	\N
222350	1397	1257711906000	29813	14666	33	0	\N
222351	1397	1257701905000	29813	14666	34	0	\N
222352	1693	17239788899116	29813	14666	35	0	\N
222353	2133	8692538000	29813	14666	36	0	\N
222354	2134	12056519000	29813	14666	37	0	\N
222355	2134	12055515000	29813	14666	38	0	\N
222356	2134	12054511000	29813	14666	39	0	\N
222357	2134	12053507000	29813	14666	40	0	\N
222358	1693	16836971063748	29813	14666	41	0	\N
222359	1693	16750321023883	29813	14666	42	0	\N
222360	1693	16663670984018	29813	14666	43	0	\N
222248	2133	8615384000	29802	14684	2	0	7811
222249	2132	6866881000	29802	14684	3	0	2121
222250	2132	6865880000	29802	14684	4	0	2122
222251	2133	8614382000	29802	14684	5	0	7812
222252	2134	11971179000	29802	14684	6	0	8344
222254	2134	11969171000	29802	14684	8	0	8346
222255	2134	11968167000	29802	14684	9	0	8347
222256	2134	11967163000	29802	14684	10	0	8348
222257	1397	1257741909000	29803	14685	0	0	18108
222258	1397	1257731908000	29803	14685	1	0	18109
222260	2134	11966159000	29803	14685	3	0	8349
222261	2134	11965155000	29803	14685	4	0	8350
222262	2132	6863878000	29803	14685	5	0	2124
222263	2132	6862877000	29803	14685	6	0	2125
222265	2134	11963147000	29803	14685	8	0	8352
222266	2134	11962143000	29803	14685	9	0	8353
222267	2133	8613380000	29803	14685	10	0	7813
222268	2133	8612378000	29803	14685	11	0	7814
222269	2133	8611376000	29803	14685	12	0	7815
222271	2133	8609372000	29803	14685	14	0	7817
222272	2134	11961139000	29803	14685	15	0	8354
222273	2134	11960135000	29803	14685	16	0	8355
222274	2134	11959131000	29803	14685	17	0	8356
222275	2134	11958127000	29803	14685	18	0	8357
222283	2134	11957123000	29805	14686	1	0	8358
222284	2134	11956119000	29805	14686	2	0	8359
222285	2132	6861876000	29805	14686	3	0	2126
222286	2134	11955115000	29805	14686	4	0	8360
222288	2133	8608370000	29805	14686	6	0	7818
222289	2133	8607368000	29805	14686	7	0	7819
222290	2133	8606366000	29805	14686	8	0	7820
222291	1397	1257711906000	29806	14687	0	0	18111
222292	2134	11953107000	29806	14687	1	0	8362
222294	2132	6860875000	29806	14687	3	0	2127
222295	2132	6859874000	29806	14687	4	0	2128
222296	2133	8604362000	29806	14687	5	0	7822
222298	1397	1257701905000	29808	14688	0	0	18112
222299	2133	8603360000	29808	14688	1	0	7823
222301	2132	6858873000	29808	14688	3	0	2129
222302	2133	8601356000	29808	14688	4	0	7825
222361	1693	16577020944153	29813	14666	44	0	\N
222362	1693	16490370904288	29813	14666	45	0	\N
222363	1693	16404089618295	29813	14666	46	0	\N
222364	1693	15781643702139	29813	14666	47	0	\N
222365	1693	14598290813627	29813	14666	48	0	\N
222366	1693	14512009318472	29813	14666	49	0	\N
222367	1693	14425726855927	29813	14666	50	0	\N
222368	1693	14339444422371	29813	14666	51	0	\N
222369	1693	14253160011985	29813	14666	52	0	\N
222370	1693	14166509972120	29813	14666	53	0	\N
222371	1693	14159944650925	29813	14666	54	0	\N
222372	1693	14073294611060	29813	14666	55	0	\N
222373	2134	12052503000	29813	14666	56	0	\N
222374	2132	6907922000	29813	14666	57	0	\N
222375	2132	6906921000	29813	14666	58	0	\N
222376	2132	6905920000	29813	14666	59	0	\N
222377	2132	6904919000	29813	14666	60	0	\N
222378	2133	8691536000	29813	14666	61	0	\N
222379	2133	8690534000	29813	14666	62	0	\N
222380	2133	8689532000	29813	14666	63	0	\N
222381	2133	8688530000	29813	14666	64	0	\N
222382	2133	8687528000	29813	14666	65	0	\N
222383	2133	8686526000	29813	14666	66	0	\N
222384	2132	6903918000	29813	14666	67	0	\N
222385	2132	6902917000	29813	14666	68	0	\N
222386	2132	6901916000	29813	14666	69	0	\N
222387	2132	6900915000	29813	14666	70	0	\N
222388	2132	6899914000	29813	14666	71	0	\N
222389	2133	8685524000	29813	14666	72	0	\N
222390	2133	8684522000	29813	14666	73	0	\N
222391	2133	8683520000	29813	14666	74	0	\N
222392	2133	8682518000	29813	14666	75	0	\N
222393	2132	6898913000	29813	14666	76	0	\N
222394	2132	6897912000	29813	14666	77	0	\N
222395	2132	6896911000	29813	14666	78	0	\N
222396	2134	12051499000	29813	14666	79	0	\N
222397	2134	12050495000	29813	14666	80	0	\N
222398	2134	12049491000	29813	14666	81	0	\N
222399	2134	12048487000	29813	14666	82	0	\N
222400	2134	12047483000	29813	14666	83	0	\N
222401	2134	12046479000	29813	14666	84	0	\N
222402	2134	12045475000	29813	14666	85	0	\N
222403	2132	6895910000	29813	14666	86	0	\N
222404	2132	6894909000	29813	14666	87	0	\N
222405	2132	6893908000	29813	14666	88	0	\N
222406	2132	6892907000	29813	14666	89	0	\N
222407	2132	6891906000	29813	14666	90	0	\N
222408	2132	6890905000	29813	14666	91	0	\N
222409	2132	6889904000	29813	14666	92	0	\N
222410	2132	6888903000	29813	14666	93	0	\N
222411	2132	6887902000	29813	14666	94	0	\N
222412	2132	6886901000	29813	14666	95	0	\N
222413	2132	6885900000	29813	14666	96	0	\N
222414	2132	6884899000	29813	14666	97	0	\N
222415	2132	6883898000	29813	14666	98	0	\N
222416	2132	6882897000	29813	14666	99	0	\N
222417	2132	6881896000	29813	14666	100	0	\N
222418	2132	6880895000	29813	14666	101	0	\N
222419	2132	6879894000	29813	14666	102	0	\N
222420	2132	6878893000	29813	14666	103	0	\N
222421	2132	6877892000	29813	14666	104	0	\N
222422	2132	6876891000	29813	14666	105	0	\N
222423	2132	6875890000	29813	14666	106	0	\N
222424	2132	6874889000	29813	14666	107	0	\N
222425	2132	6873888000	29813	14666	108	0	\N
222426	2132	6872887000	29813	14666	109	0	\N
222427	2132	6871886000	29813	14666	110	0	\N
222428	2132	6870885000	29813	14666	111	0	\N
222429	2132	6869884000	29813	14666	112	0	\N
222430	2132	6868883000	29813	14666	113	0	\N
222431	2132	6867882000	29813	14666	114	0	\N
222432	2132	6866881000	29813	14666	115	0	\N
222433	2132	6865880000	29813	14666	116	0	\N
222434	2132	6864879000	29813	14666	117	0	\N
222435	2132	6863878000	29813	14666	118	0	\N
222436	2132	6862877000	29813	14666	119	0	\N
222437	2132	6861876000	29813	14666	120	0	\N
222438	2132	6860875000	29813	14666	121	0	\N
222439	2132	6859874000	29813	14666	122	0	\N
222440	2132	6858873000	29813	14666	123	0	\N
222470	1397	1257691904000	29816	14689	0	0	\N
222471	1397	1257681903000	29816	14689	1	0	\N
222472	1397	1257671902000	29816	14689	2	0	\N
222473	2132	6857872000	29816	14689	3	0	\N
222474	2134	11952103000	29816	14689	4	0	\N
222475	2134	11951099000	29816	14689	5	0	\N
222476	2134	11950095000	29816	14689	6	0	\N
222477	2133	8600354000	29816	14689	7	0	\N
222478	2133	8599352000	29816	14689	8	0	\N
222479	2133	8598350000	29816	14689	9	0	\N
222480	2133	8597348000	29816	14689	10	0	\N
222481	2133	8596346000	29816	14689	11	0	\N
222482	2133	8595344000	29816	14689	12	0	\N
222483	2133	8594342000	29816	14689	13	0	\N
222484	2134	11949091000	29816	14689	14	0	\N
222485	2134	11948087000	29816	14689	15	0	\N
222486	2134	11947083000	29816	14689	16	0	\N
222487	2134	11946079000	29816	14689	17	0	\N
222488	2134	11945075000	29816	14689	18	0	\N
222489	2134	11944071000	29816	14689	19	0	\N
222490	2134	11943067000	29816	14689	20	0	\N
222491	2134	11942063000	29816	14689	21	0	\N
222492	2134	11941059000	29816	14689	22	0	\N
222493	2132	6856871000	29816	14689	23	0	\N
222494	2132	6855870000	29816	14689	24	0	\N
222495	2132	6854869000	29816	14689	25	0	\N
222496	2132	6853868000	29816	14689	26	0	\N
222443	2132	6857872000	29814	14689	2	0	2130
222444	2133	8600354000	29814	14689	3	0	7826
222445	2133	8599352000	29814	14689	4	0	7827
222446	2133	8598350000	29814	14689	5	0	7828
222447	2133	8597348000	29814	14689	6	0	7829
222449	2133	8595344000	29814	14689	8	0	7831
222450	2132	6856871000	29814	14689	9	0	2131
222451	2132	6855870000	29814	14689	10	0	2132
222452	1397	1257671902000	29815	14690	0	0	18115
222453	2134	11952103000	29815	14690	1	0	8363
222455	2132	6853868000	29815	14690	3	0	2134
222456	2134	11951099000	29815	14690	4	0	8364
222457	2134	11950095000	29815	14690	5	0	8365
222458	2133	8594342000	29815	14690	6	0	7832
222460	2134	11948087000	29815	14690	8	0	8367
222461	2134	11947083000	29815	14690	9	0	8368
222462	2134	11946079000	29815	14690	10	0	8369
222463	2134	11945075000	29815	14690	11	0	8370
222464	2134	11944071000	29815	14690	12	0	8371
222466	2134	11942063000	29815	14690	14	0	8373
222467	2134	11941059000	29815	14690	15	0	8374
222468	2133	8593340000	29815	14690	16	0	7833
222469	2133	8592338000	29815	14690	17	0	7834
222497	2133	8593340000	29816	14689	27	0	\N
222498	2133	8592338000	29816	14689	28	0	\N
222513	1397	1257641899000	29819	14693	0	0	\N
222514	2132	6850865000	29819	14693	1	0	\N
222515	2132	6849864000	29819	14693	2	0	\N
222516	2132	6848863000	29819	14693	3	0	\N
222517	2134	11935035000	29819	14693	4	0	\N
222518	2134	11934031000	29819	14693	5	0	\N
222519	2134	11933027000	29819	14693	6	0	\N
222520	2134	11932023000	29819	14693	7	0	\N
222521	2134	11931019000	29819	14693	8	0	\N
222522	2134	11930015000	29819	14693	9	0	\N
222523	2134	11929011000	29819	14693	10	0	\N
222524	2134	11928007000	29819	14693	11	0	\N
222525	2134	11927003000	29819	14693	12	0	\N
222526	2133	8586326000	29819	14693	13	0	\N
222527	2133	8585324000	29819	14693	14	0	\N
222528	2133	8584322000	29819	14693	15	0	\N
222529	2133	8583320000	29819	14693	16	0	\N
222530	2133	8582318000	29819	14693	17	0	\N
222531	2133	8581316000	29819	14693	18	0	\N
222561	1397	1257621897000	29822	14695	0	0	\N
222562	2133	8578310000	29822	14695	1	0	\N
222563	2133	8577308000	29822	14695	2	0	\N
222564	2133	8576306000	29822	14695	3	0	\N
222565	2132	6845860000	29822	14695	4	0	\N
222566	2134	11920979000	29822	14695	5	0	\N
222567	2134	11919975000	29822	14695	6	0	\N
222568	2134	11918971000	29822	14695	7	0	\N
222569	2134	11917967000	29822	14695	8	0	\N
222590	238	66000973695901	29825	14696	0	0	\N
222591	1397	1257611896000	29825	14696	1	0	\N
222592	2132	6844859000	29825	14696	2	0	\N
222593	2134	11916963000	29825	14696	3	0	\N
222594	2134	11915959000	29825	14696	4	0	\N
222595	2134	11914955000	29825	14696	5	0	\N
222596	2134	11913951000	29825	14696	6	0	\N
222597	2133	8575304000	29825	14696	7	0	\N
222598	2133	8574302000	29825	14696	8	0	\N
222599	2132	6843858000	29825	14696	9	0	\N
222600	2134	11912947000	29825	14696	10	0	\N
222601	238	66000973695901	29826	14696	0	0	\N
222602	1397	1257611896000	29826	14696	1	0	\N
222603	2132	6844859000	29826	14696	2	0	\N
222604	2133	8575304000	29826	14696	3	0	\N
222605	2133	8574302000	29826	14696	4	0	\N
222606	2132	6843858000	29826	14696	5	0	\N
222616	1397	1257601895000	29828	14697	0	0	\N
222617	2133	8573300000	29828	14697	1	0	\N
222618	2133	8572298000	29828	14697	2	0	\N
222619	2133	8571296000	29828	14697	3	0	\N
222620	2132	6842857000	29828	14697	4	0	\N
222621	2134	11911943000	29828	14697	5	0	\N
222622	2134	11910939000	29828	14697	6	0	\N
222623	2134	11909935000	29828	14697	7	0	\N
222624	2134	11908931000	29828	14697	8	0	\N
222625	1397	1257591894000	29829	14698	0	0	\N
222626	2132	6841856000	29829	14698	1	0	\N
222627	2132	6840855000	29829	14698	2	0	\N
222628	2133	8570294000	29829	14698	3	0	\N
222629	2134	11907927000	29829	14698	4	0	\N
222630	2133	8569292000	29829	14698	5	0	\N
222631	1397	1257591894000	29831	14698	0	0	\N
222632	2132	6841856000	29831	14698	1	0	\N
222501	2133	8591336000	29817	14691	2	0	7835
222502	2133	8590334000	29817	14691	3	0	7836
222503	1397	1257651900000	29818	14692	0	0	18117
222504	2133	8589332000	29818	14692	1	0	7837
222505	2132	6851866000	29818	14692	2	0	2136
222507	2133	8588330000	29818	14692	4	0	7838
222508	2133	8587328000	29818	14692	5	0	7839
222509	2134	11939051000	29818	14692	6	0	8376
222510	2134	11938047000	29818	14692	7	0	8377
222511	2134	11937043000	29818	14692	8	0	8378
222532	1397	1257641899000	29820	14693	0	0	18118
222533	2132	6850865000	29820	14693	1	0	2137
222534	2132	6849864000	29820	14693	2	0	2138
222535	2132	6848863000	29820	14693	3	0	2139
222537	2134	11934031000	29820	14693	5	0	8381
222538	2134	11933027000	29820	14693	6	0	8382
222539	2134	11932023000	29820	14693	7	0	8383
222540	2134	11931019000	29820	14693	8	0	8384
222541	2134	11930015000	29820	14693	9	0	8385
222543	2134	11928007000	29820	14693	11	0	8387
222544	2134	11927003000	29820	14693	12	0	8388
222545	2133	8586326000	29820	14693	13	0	7840
222546	2133	8585324000	29820	14693	14	0	7841
222547	2133	8584322000	29820	14693	15	0	7842
222549	2133	8582318000	29820	14693	17	0	7844
222550	2133	8581316000	29820	14693	18	0	7845
222551	1397	1257631898000	29821	14694	0	0	18119
222552	2134	11925999000	29821	14694	1	0	8389
222554	2134	11923991000	29821	14694	3	0	8391
222555	2133	8580314000	29821	14694	4	0	7846
222556	2134	11922987000	29821	14694	5	0	8392
222557	2134	11921983000	29821	14694	6	0	8393
222558	2132	6847862000	29821	14694	7	0	2140
222560	2133	8579312000	29821	14694	9	0	7847
222570	1397	1257621897000	29823	14695	0	0	18120
222571	2133	8578310000	29823	14695	1	0	7848
222572	2133	8577308000	29823	14695	2	0	7849
222573	2133	8576306000	29823	14695	3	0	7850
222575	2134	11920979000	29823	14695	5	0	8394
222576	2134	11919975000	29823	14695	6	0	8395
222577	2134	11918971000	29823	14695	7	0	8396
222578	2134	11917967000	29823	14695	8	0	8397
222580	1397	1257611896000	29824	14696	1	0	18121
222581	2132	6844859000	29824	14696	2	0	2143
222582	2134	11916963000	29824	14696	3	0	8398
222583	2134	11915959000	29824	14696	4	0	8399
222584	2134	11914955000	29824	14696	5	0	8400
222586	2133	8575304000	29824	14696	7	0	7851
222587	2133	8574302000	29824	14696	8	0	7852
222588	2132	6843858000	29824	14696	9	0	2144
222589	2134	11912947000	29824	14696	10	0	8402
222607	1397	1257601895000	29827	14697	0	0	18122
222609	2133	8572298000	29827	14697	2	0	7854
222610	2133	8571296000	29827	14697	3	0	7855
222611	2132	6842857000	29827	14697	4	0	2145
222612	2134	11911943000	29827	14697	5	0	8403
222614	2134	11909935000	29827	14697	7	0	8405
222615	2134	11908931000	29827	14697	8	0	8406
222633	2132	6840855000	29831	14698	2	0	\N
222634	2134	11907927000	29831	14698	3	0	\N
222658	1397	1257561891000	29834	14701	0	0	\N
222659	2133	8562278000	29834	14701	1	0	\N
222660	2132	6836851000	29834	14701	2	0	\N
222661	2133	8561276000	29834	14701	3	0	\N
222662	2133	8560274000	29834	14701	4	0	\N
222704	1397	1257531888000	29839	14704	0	0	\N
222705	1397	1257521887000	29839	14704	1	0	\N
222706	2132	6832847000	29839	14704	2	0	\N
222707	2132	6831846000	29839	14704	3	0	\N
222708	2132	6830845000	29839	14704	4	0	\N
222709	2134	11897887000	29839	14704	5	0	\N
222710	2134	11896883000	29839	14704	6	0	\N
222711	2134	11895879000	29839	14704	7	0	\N
222712	2134	11894875000	29839	14704	8	0	\N
222713	2133	8554262000	29839	14704	9	0	\N
222714	2133	8553260000	29839	14704	10	0	\N
222715	2133	8552258000	29839	14704	11	0	\N
222716	2134	11893871000	29839	14704	12	0	\N
222717	2134	11892867000	29839	14704	13	0	\N
222718	2134	11891863000	29839	14704	14	0	\N
222719	2134	11890859000	29839	14704	15	0	\N
222720	2133	8551256000	29839	14704	16	0	\N
222721	2133	8550254000	29839	14704	17	0	\N
222722	2133	8549252000	29839	14704	18	0	\N
222723	2134	11889855000	29839	14704	19	0	\N
222724	2134	11888851000	29839	14704	20	0	\N
222725	2134	11887847000	29839	14704	21	0	\N
222726	2134	11886843000	29839	14704	22	0	\N
222637	2132	6841856000	29832	14699	2	0	2146
222638	2132	6840855000	29832	14699	3	0	2147
222639	2133	8570294000	29832	14699	4	0	7856
222640	2132	6839854000	29832	14699	5	0	2148
222641	2134	11907927000	29832	14699	6	0	8407
222643	2134	11905919000	29832	14699	8	0	8409
222644	2134	11904915000	29832	14699	9	0	8410
222645	2134	11903911000	29832	14699	10	0	8411
222646	2134	11902907000	29832	14699	11	0	8412
222647	2134	11901903000	29832	14699	12	0	8413
222649	2133	8568290000	29832	14699	14	0	7858
222650	2133	8567288000	29832	14699	15	0	7859
222651	2133	8566286000	29832	14699	16	0	7860
222652	1397	1257571892000	29833	14700	0	0	18125
222654	2133	8565284000	29833	14700	2	0	7861
222655	2133	8564282000	29833	14700	3	0	7862
222656	2133	8563280000	29833	14700	4	0	7863
222657	2132	6837852000	29833	14700	5	0	2150
222663	1397	1257561891000	29835	14701	0	0	18126
222665	2132	6836851000	29835	14701	2	0	2151
222666	2133	8561276000	29835	14701	3	0	7865
222667	2133	8560274000	29835	14701	4	0	7866
222668	1397	1257551890000	29836	14702	0	0	18127
222669	2132	6835850000	29836	14702	1	0	2152
222671	2133	8559272000	29836	14702	3	0	7867
222672	2133	8558270000	29836	14702	4	0	7868
222673	1397	1257541889000	29837	14703	0	0	18128
222674	2133	8557268000	29837	14703	1	0	7869
222676	2132	6833848000	29837	14703	3	0	2154
222677	2134	11899895000	29837	14703	4	0	8415
222678	2133	8556266000	29837	14703	5	0	7870
222679	2133	8555264000	29837	14703	6	0	7871
222680	2134	11898891000	29837	14703	7	0	8416
222682	1397	1257521887000	29838	14704	1	0	18130
222683	2132	6832847000	29838	14704	2	0	2155
222684	2132	6831846000	29838	14704	3	0	2156
222685	2132	6830845000	29838	14704	4	0	2157
222686	2134	11897887000	29838	14704	5	0	8417
222688	2134	11895879000	29838	14704	7	0	8419
222689	2134	11894875000	29838	14704	8	0	8420
222690	2133	8554262000	29838	14704	9	0	7872
222691	2133	8553260000	29838	14704	10	0	7873
222693	2134	11893871000	29838	14704	12	0	8421
222694	2134	11892867000	29838	14704	13	0	8422
222695	2134	11891863000	29838	14704	14	0	8423
222696	2134	11890859000	29838	14704	15	0	8424
222697	2133	8551256000	29838	14704	16	0	7875
222699	2133	8549252000	29838	14704	18	0	7877
222700	2134	11889855000	29838	14704	19	0	8425
222701	2134	11888851000	29838	14704	20	0	8426
222702	2134	11887847000	29838	14704	21	0	8427
222703	2134	11886843000	29838	14704	22	0	8428
222728	2134	11885839000	29840	14705	1	0	8429
222729	2132	6829844000	29840	14705	2	0	2158
222730	2132	6828843000	29840	14705	3	0	2159
222731	2132	6827842000	29840	14705	4	0	2160
222733	2132	6825840000	29840	14705	6	0	2162
222734	2134	11884835000	29840	14705	7	0	8430
222735	2134	11883831000	29840	14705	8	0	8431
222736	2134	11882827000	29840	14705	9	0	8432
222737	2134	11881823000	29840	14705	10	0	8433
222739	2134	11879815000	29840	14705	12	0	8435
222740	2134	11878811000	29840	14705	13	0	8436
222741	2134	11877807000	29840	14705	14	0	8437
222742	2134	11876803000	29840	14705	15	0	8438
222743	2134	11875799000	29840	14705	16	0	8439
222745	2134	11873791000	29840	14705	18	0	8441
222746	2133	8548250000	29840	14705	19	0	7878
222747	2133	8547248000	29840	14705	20	0	7879
222748	2133	8546246000	29840	14705	21	0	7880
222750	2133	8544242000	29840	14705	23	0	7882
222751	2133	8543240000	29840	14705	24	0	7883
222752	2133	8542238000	29840	14705	25	0	7884
222753	2133	8541236000	29840	14705	26	0	7885
222754	2134	11872787000	29841	14706	0	0	8442
222756	2132	6824839000	29841	14706	2	0	2163
222757	2133	8540234000	29841	14706	3	0	7886
222758	2133	8539232000	29841	14706	4	0	7887
222759	2133	8538230000	29841	14706	5	0	7888
222760	2134	11870779000	29841	14706	6	0	8444
222762	2134	11868771000	29841	14706	8	0	8446
222763	2132	6823838000	29842	14707	0	0	2164
222764	2134	11867767000	29842	14707	1	0	8447
222765	2134	11866763000	29842	14707	2	0	8448
222767	2134	11864755000	29842	14707	4	0	8450
222768	2132	6822837000	29842	14707	5	0	2165
222795	1397	1257491884000	29845	14709	0	0	\N
222796	2133	8523200000	29845	14709	1	0	\N
222797	2132	6815830000	29845	14709	2	0	\N
222798	2133	8522198000	29845	14709	3	0	\N
222799	2133	8521196000	29845	14709	4	0	\N
222842	1397	1257481883000	29848	14710	0	0	\N
222843	1397	1257471882000	29848	14710	1	0	\N
222844	2132	6814829000	29848	14710	2	0	\N
222845	2132	6813828000	29848	14710	3	0	\N
222846	2132	6812827000	29848	14710	4	0	\N
222847	2134	11863751000	29848	14710	5	0	\N
222848	2134	11862747000	29848	14710	6	0	\N
222849	2134	11861743000	29848	14710	7	0	\N
222850	2134	11860739000	29848	14710	8	0	\N
222851	2134	11859735000	29848	14710	10	0	\N
222852	2134	11858731000	29848	14710	11	0	\N
222853	2134	11857727000	29848	14710	12	0	\N
222854	2134	11856723000	29848	14710	13	0	\N
222855	2134	11855719000	29848	14710	14	0	\N
222856	2134	11854715000	29848	14710	15	0	\N
222857	2134	11853711000	29848	14710	16	0	\N
222858	2134	11852707000	29848	14710	17	0	\N
222859	2134	11851703000	29848	14710	18	0	\N
222860	2134	11850699000	29848	14710	19	0	\N
222861	2134	11849695000	29848	14710	20	0	\N
222862	2134	11848691000	29848	14710	21	0	\N
222863	2134	11847687000	29848	14710	22	0	\N
222864	2134	11846683000	29848	14710	23	0	\N
222865	2134	11845679000	29848	14710	24	0	\N
222866	2134	11844675000	29848	14710	25	0	\N
222867	2134	11843671000	29848	14710	26	0	\N
222868	2134	11842667000	29848	14710	27	0	\N
222869	2134	11841663000	29848	14710	28	0	\N
222870	2134	11840659000	29848	14710	29	0	\N
222871	2134	11839655000	29848	14710	30	0	\N
222872	2134	11838651000	29848	14710	31	0	\N
222873	2134	11837647000	29848	14710	32	0	\N
222874	2134	11836643000	29848	14710	33	0	\N
222875	2134	11835639000	29848	14710	34	0	\N
222876	2134	11834635000	29848	14710	35	0	\N
222877	2134	11833631000	29848	14710	36	0	\N
222878	2134	11832627000	29848	14710	37	0	\N
222888	1397	1257461881000	29850	14711	0	0	\N
222889	2134	11831623000	29850	14711	1	0	\N
222890	2134	11830619000	29850	14711	2	0	\N
222891	2134	11829615000	29850	14711	3	0	\N
222892	2134	11828611000	29850	14711	4	0	\N
222893	2132	6811826000	29850	14711	5	0	\N
222894	2133	8515184000	29850	14711	6	0	\N
222895	2133	8514182000	29850	14711	7	0	\N
222896	2133	8513180000	29850	14711	8	0	\N
222771	2133	8535224000	29842	14707	8	0	7891
222772	2132	6821836000	29842	14707	9	0	2166
222773	2132	6820835000	29842	14707	10	0	2167
222774	2132	6819834000	29842	14707	11	0	2168
222775	2132	6818833000	29842	14707	12	0	2169
222777	2133	8533220000	29842	14707	14	0	7893
222778	2133	8532218000	29842	14707	15	0	7894
222779	2133	8531216000	29842	14707	16	0	7895
222780	2133	8530214000	29842	14707	17	0	7896
222781	2133	8529212000	29842	14707	18	0	7897
222783	2133	8527208000	29842	14707	20	0	7899
222784	1397	1257501885000	29843	14708	0	0	18132
222785	2133	8526206000	29843	14708	1	0	7900
222786	2132	6817832000	29843	14708	2	0	2170
222788	2133	8525204000	29843	14708	4	0	7901
222789	2133	8524202000	29843	14708	5	0	7902
222790	1397	1257491884000	29844	14709	0	0	18133
222791	2133	8523200000	29844	14709	1	0	7903
222792	2132	6815830000	29844	14709	2	0	2172
222794	2133	8521196000	29844	14709	4	0	7905
222800	1397	1257481883000	29847	14710	0	0	18134
222801	1397	1257471882000	29847	14710	1	0	18135
222802	2132	6814829000	29847	14710	2	0	2173
222803	2132	6813828000	29847	14710	3	0	2174
222805	2133	8520194000	29847	14710	5	0	7906
222806	2133	8519192000	29847	14710	6	0	7907
222807	2133	8518190000	29847	14710	7	0	7908
222808	2133	8517188000	29847	14710	8	0	7909
222810	2134	11862747000	29847	14710	11	0	8452
222811	2134	11861743000	29847	14710	12	0	8453
222812	2134	11860739000	29847	14710	13	0	8454
222813	2134	11859735000	29847	14710	14	0	8455
222814	2134	11858731000	29847	14710	15	0	8456
222816	2134	11856723000	29847	14710	17	0	8458
222817	2134	11855719000	29847	14710	18	0	8459
222818	2134	11854715000	29847	14710	19	0	8460
222819	2134	11853711000	29847	14710	20	0	8461
222820	2134	11852707000	29847	14710	21	0	8462
222822	2134	11850699000	29847	14710	23	0	8464
222823	2134	11849695000	29847	14710	24	0	8465
222824	2134	11848691000	29847	14710	25	0	8466
222825	2134	11847687000	29847	14710	26	0	8467
222827	2134	11845679000	29847	14710	28	0	8469
222828	2133	8516186000	29847	14710	29	0	7910
222829	2134	11844675000	29847	14710	30	0	8470
222830	2134	11843671000	29847	14710	31	0	8471
222831	2134	11842667000	29847	14710	32	0	8472
222833	2134	11840659000	29847	14710	34	0	8474
222834	2134	11839655000	29847	14710	35	0	8475
222835	2134	11838651000	29847	14710	36	0	8476
222836	2134	11837647000	29847	14710	37	0	8477
222837	2134	11836643000	29847	14710	38	0	8478
222839	2134	11834635000	29847	14710	40	0	8480
222840	2134	11833631000	29847	14710	41	0	8481
222841	2134	11832627000	29847	14710	42	0	8482
222879	1397	1257461881000	29849	14711	0	0	18136
222881	2134	11830619000	29849	14711	2	0	8484
222882	2134	11829615000	29849	14711	3	0	8485
222883	2134	11828611000	29849	14711	4	0	8486
222884	2132	6811826000	29849	14711	5	0	2176
222885	2133	8515184000	29849	14711	6	0	7911
222887	2133	8513180000	29849	14711	8	0	7913
222897	10	32559523762605	29851	14712	0	0	4
222898	301	66002280080033	29851	14712	1	0	5
222899	283	66001289080033	29851	14712	2	0	4
222900	1397	1257451880000	29851	14712	3	0	18137
222902	2134	11827607000	29851	14712	5	0	8487
222903	2134	11826603000	29851	14712	6	0	8488
222904	2133	8512178000	29851	14712	7	0	7914
222911	10	32559523762605	29852	14712	0	0	\N
222912	301	66002280080033	29852	14712	1	0	\N
222913	283	66001289080033	29852	14712	2	0	\N
222914	1397	1257451880000	29852	14712	3	0	\N
222915	114	66001611517324	29852	14712	4	0	\N
222916	2134	11827607000	29852	14712	5	0	\N
222917	2134	11826603000	29852	14712	6	0	\N
222918	2133	8512178000	29852	14712	7	0	\N
222919	2133	8511176000	29852	14712	8	0	\N
222920	2133	8510174000	29852	14712	9	0	\N
222921	2132	6810825000	29852	14712	10	0	\N
222922	2134	11825599000	29852	14712	11	0	\N
222923	2134	11824595000	29852	14712	12	0	\N
222924	2134	11823591000	29852	14712	13	0	\N
222925	2132	6809824000	29852	14712	14	0	\N
222954	1397	1257411876000	29855	14715	0	0	\N
222955	2133	8502158000	29855	14715	1	0	\N
222956	2133	8501156000	29855	14715	2	0	\N
222957	2133	8500154000	29855	14715	3	0	\N
222958	2132	6804819000	29855	14715	4	0	\N
222959	2132	6803818000	29855	14715	5	0	\N
222960	2134	11809535000	29855	14715	6	0	\N
222961	2134	11808531000	29855	14715	7	0	\N
222962	2134	11807527000	29855	14715	8	0	\N
222963	2134	11806523000	29855	14715	9	0	\N
222974	1397	1257411876000	29857	14715	0	0	\N
222975	2132	6804819000	29857	14715	1	0	\N
222976	2132	6803818000	29857	14715	2	0	\N
222977	2134	11809535000	29857	14715	3	0	\N
222978	2134	11808531000	29857	14715	4	0	\N
222979	2134	11807527000	29857	14715	5	0	\N
222980	2134	11806523000	29857	14715	6	0	\N
223010	1397	1257381873000	29861	14718	0	0	\N
223011	2133	8494142000	29861	14718	1	0	\N
223012	2133	8493140000	29861	14718	2	0	\N
223013	2133	8492138000	29861	14718	3	0	\N
223014	2134	11796483000	29861	14718	4	0	\N
223015	2134	11795479000	29861	14718	5	0	\N
223016	2134	11794475000	29861	14718	6	0	\N
223017	2134	11793471000	29861	14718	7	0	\N
223018	2132	6799814000	29861	14718	8	0	\N
223019	2134	11792467000	29861	14718	9	0	\N
222907	2132	6810825000	29851	14712	10	0	2177
222908	2134	11825599000	29851	14712	11	0	8489
222909	2134	11824595000	29851	14712	12	0	8490
222910	2132	6809824000	29851	14712	13	0	2178
222926	1397	1257441879000	29853	14713	0	0	18138
222928	2132	6808823000	29853	14713	2	0	2179
222929	2132	6807822000	29853	14713	3	0	2180
222930	2132	6806821000	29853	14713	4	0	2181
222931	2134	11823591000	29853	14713	5	0	8491
222932	2134	11822587000	29853	14713	6	0	8492
222934	2133	8509172000	29853	14713	8	0	7917
222935	2133	8508170000	29853	14713	9	0	7918
222936	2134	11820579000	29853	14713	10	0	8494
222937	2134	11819575000	29853	14713	11	0	8495
222939	2134	11817567000	29853	14713	13	0	8497
222940	2134	11816563000	29853	14713	14	0	8498
222941	2134	11815559000	29853	14713	15	0	8499
222942	2133	8507168000	29853	14713	16	0	7919
222943	2133	8506166000	29853	14713	17	0	7920
222945	1397	1257421877000	29854	14714	0	0	18140
222946	2134	11814555000	29854	14714	1	0	8500
222947	2134	11813551000	29854	14714	2	0	8501
222948	2134	11812547000	29854	14714	3	0	8502
222949	2134	11811543000	29854	14714	4	0	8503
222951	2133	8504162000	29854	14714	6	0	7922
222952	2133	8503160000	29854	14714	7	0	7923
222953	2132	6805820000	29854	14714	8	0	2182
222964	1397	1257411876000	29856	14715	0	0	18141
222966	2133	8501156000	29856	14715	2	0	7925
222967	2133	8500154000	29856	14715	3	0	7926
222968	2132	6804819000	29856	14715	4	0	2183
222969	2132	6803818000	29856	14715	5	0	2184
222970	2134	11809535000	29856	14715	6	0	8505
222972	2134	11807527000	29856	14715	8	0	8507
222973	2134	11806523000	29856	14715	9	0	8508
222981	1397	1257401875000	29858	14716	0	0	18142
222982	2133	8499152000	29858	14716	1	0	7927
222983	2134	11805519000	29858	14716	2	0	8509
222985	2132	6802817000	29858	14716	4	0	2185
222986	2134	11804515000	29858	14716	5	0	8510
222987	2134	11803511000	29858	14716	6	0	8511
222988	2134	11802507000	29858	14716	7	0	8512
222990	1397	1257391874000	29859	14717	0	0	18143
222991	2132	6801816000	29859	14717	1	0	2186
222992	2134	11800499000	29859	14717	2	0	8514
222993	2133	8497148000	29859	14717	3	0	7929
222994	2133	8496146000	29859	14717	4	0	7930
222996	2132	6800815000	29859	14717	7	0	2187
222997	2134	11799495000	29859	14717	8	0	8515
222998	2134	11798491000	29859	14717	9	0	8516
222999	2134	11797487000	29859	14717	10	0	8517
223000	1397	1257381873000	29860	14718	0	0	18144
223002	2133	8493140000	29860	14718	2	0	7933
223003	2133	8492138000	29860	14718	3	0	7934
223004	2134	11796483000	29860	14718	4	0	8518
223005	2134	11795479000	29860	14718	5	0	8519
223007	2134	11793471000	29860	14718	7	0	8521
223008	2132	6799814000	29860	14718	8	0	2188
223009	2134	11792467000	29860	14718	9	0	8522
223020	1397	1257371872000	29862	14719	0	0	18145
223021	1397	1257361871000	29862	14719	1	0	18146
223023	2134	11791463000	29862	14719	3	0	8523
223024	2134	11790459000	29862	14719	4	0	8524
223025	2132	6798813000	29862	14719	5	0	2189
223026	2132	6797812000	29862	14719	6	0	2190
223027	2132	6796811000	29862	14719	7	0	2191
223029	2134	11788451000	29862	14719	9	0	8526
223030	2134	11787447000	29862	14719	10	0	8527
223031	2134	11786443000	29862	14719	11	0	8528
223032	2134	11785439000	29862	14719	12	0	8529
223034	2134	11783431000	29862	14719	14	0	8531
223035	2133	8490134000	29862	14719	15	0	7936
223036	2133	8489132000	29862	14719	16	0	7937
223037	2133	8488130000	29862	14719	17	0	7938
223038	2133	8487128000	29862	14719	18	0	7939
223040	2134	11782427000	29863	14720	1	0	8532
223048	1397	1257351870000	29864	14720	0	0	\N
223049	2134	11782427000	29864	14720	1	0	\N
223050	2134	11781423000	29864	14720	2	0	\N
223051	2132	6795810000	29864	14720	3	0	\N
223052	2132	6794809000	29864	14720	4	0	\N
223053	2133	8486126000	29864	14720	5	0	\N
223054	2133	8485124000	29864	14720	6	0	\N
223055	2134	11780419000	29864	14720	7	0	\N
223056	2134	11779415000	29864	14720	8	0	\N
223057	1397	1257351870000	29865	14720	0	0	\N
223058	2134	11782427000	29865	14720	1	0	\N
223059	2134	11781423000	29865	14720	2	0	\N
223060	2132	6795810000	29865	14720	3	0	\N
223061	2132	6794809000	29865	14720	4	0	\N
223062	2133	8486126000	29865	14720	5	0	\N
223063	2133	8485124000	29865	14720	6	0	\N
223064	2134	11780419000	29865	14720	7	0	\N
223065	2134	11779415000	29865	14720	8	0	\N
223066	2314	849000000	29866	14721	0	0	\N
223067	1397	1257341869000	29866	14721	1	0	\N
223068	2133	8484122000	29866	14721	2	0	\N
223069	2133	8483120000	29866	14721	3	0	\N
223070	2132	6793808000	29866	14721	4	0	\N
223071	2134	11778411000	29866	14721	5	0	\N
223072	2134	11777407000	29866	14721	6	0	\N
223073	2134	11776403000	29866	14721	7	0	\N
223074	2134	11775399000	29866	14721	8	0	\N
223075	2134	11774395000	29866	14721	9	0	\N
223076	2314	849000000	29867	14721	0	0	\N
223077	1397	1257341869000	29867	14721	1	0	\N
223078	2133	8484122000	29867	14721	2	0	\N
223079	2133	8483120000	29867	14721	3	0	\N
223080	2132	6793808000	29867	14721	4	0	\N
223081	2134	11778411000	29867	14721	5	0	\N
223082	2134	11777407000	29867	14721	6	0	\N
223083	2134	11776403000	29867	14721	7	0	\N
223084	2134	11775399000	29867	14721	8	0	\N
223085	2134	11774395000	29867	14721	9	0	\N
223096	2314	849000000	29869	14721	0	0	\N
223097	1397	1257341869000	29869	14721	1	0	\N
223098	2133	8484122000	29869	14721	2	0	\N
223099	2133	8483120000	29869	14721	3	0	\N
223100	2132	6793808000	29869	14721	4	0	\N
223101	2134	11778411000	29869	14721	5	0	\N
223102	2134	11777407000	29869	14721	6	0	\N
223103	2134	11776403000	29869	14721	7	0	\N
223104	2134	11775399000	29869	14721	8	0	\N
223105	2134	11774395000	29869	14721	9	0	\N
223126	1397	1257331868000	29871	14722	0	0	\N
223127	1397	1257321867000	29871	14722	1	0	\N
223128	2132	6792807000	29871	14722	2	0	\N
223129	2133	8482118000	29871	14722	3	0	\N
223130	2132	6791806000	29871	14722	4	0	\N
223131	2132	6790805000	29871	14722	5	0	\N
223132	2134	11773391000	29871	14722	6	0	\N
223133	2134	11772387000	29871	14722	7	0	\N
223134	2133	8481116000	29871	14722	8	0	\N
223135	2134	11771383000	29871	14722	9	0	\N
223136	2134	11770379000	29871	14722	10	0	\N
223137	2134	11769375000	29871	14722	11	0	\N
223138	2134	11768371000	29871	14722	12	0	\N
223139	2133	8480114000	29871	14722	13	0	\N
223140	2133	8479112000	29871	14722	14	0	\N
223141	2133	8478110000	29871	14722	15	0	\N
223142	2133	8477108000	29871	14722	16	0	\N
223143	2134	11767367000	29871	14722	17	0	\N
223144	2134	11766363000	29871	14722	18	0	\N
223145	2134	11765359000	29871	14722	19	0	\N
223146	1397	1257331868000	29872	14722	0	0	\N
223147	1397	1257321867000	29872	14722	1	0	\N
223148	2132	6792807000	29872	14722	2	0	\N
223149	2132	6791806000	29872	14722	3	0	\N
223150	2132	6790805000	29872	14722	4	0	\N
223151	2134	11773391000	29872	14722	5	0	\N
223152	2134	11772387000	29872	14722	6	0	\N
223153	2134	11771383000	29872	14722	7	0	\N
223154	2134	11770379000	29872	14722	8	0	\N
223155	2134	11769375000	29872	14722	9	0	\N
223156	2134	11768371000	29872	14722	10	0	\N
223157	2134	11767367000	29872	14722	11	0	\N
223158	2134	11766363000	29872	14722	12	0	\N
223159	2134	11765359000	29872	14722	13	0	\N
223160	1397	1257311866000	29873	14723	0	0	\N
223161	2132	6789804000	29873	14723	1	0	\N
223162	2132	6788803000	29873	14723	2	0	\N
223163	2134	11764355000	29873	14723	3	0	\N
223164	2134	11763351000	29873	14723	4	0	\N
223165	2134	11762347000	29873	14723	5	0	\N
223166	2134	11761343000	29873	14723	6	0	\N
223043	2132	6794809000	29863	14720	4	0	2193
223044	2133	8486126000	29863	14720	5	0	7940
223045	2133	8485124000	29863	14720	6	0	7941
223046	2134	11780419000	29863	14720	7	0	8534
223047	2134	11779415000	29863	14720	8	0	8535
223087	1397	1257341869000	29868	14721	1	0	18148
223088	2133	8484122000	29868	14721	2	0	7942
223089	2133	8483120000	29868	14721	3	0	7943
223090	2132	6793808000	29868	14721	4	0	2194
223091	2134	11778411000	29868	14721	5	0	8536
223093	2134	11776403000	29868	14721	7	0	8538
223094	2134	11775399000	29868	14721	8	0	8539
223095	2134	11774395000	29868	14721	9	0	8540
223106	1397	1257331868000	29870	14722	0	0	18149
223108	2132	6792807000	29870	14722	2	0	2195
223109	2133	8482118000	29870	14722	3	0	7944
223110	2132	6791806000	29870	14722	4	0	2196
223111	2132	6790805000	29870	14722	5	0	2197
223112	2134	11773391000	29870	14722	6	0	8541
223114	2133	8481116000	29870	14722	8	0	7945
223115	2134	11771383000	29870	14722	9	0	8543
223116	2134	11770379000	29870	14722	10	0	8544
223117	2134	11769375000	29870	14722	11	0	8545
223118	2134	11768371000	29870	14722	12	0	8546
223120	2133	8479112000	29870	14722	14	0	7947
223121	2133	8478110000	29870	14722	15	0	7948
223122	2133	8477108000	29870	14722	16	0	7949
223123	2134	11767367000	29870	14722	17	0	8547
223125	2134	11765359000	29870	14722	19	0	8549
223167	1397	1257311866000	29874	14723	0	0	18151
223168	2133	8476106000	29874	14723	1	0	7950
223169	2133	8475104000	29874	14723	2	0	7951
223170	2132	6789804000	29874	14723	3	0	2198
223172	2134	11764355000	29874	14723	5	0	8550
223173	2134	11763351000	29874	14723	6	0	8551
223174	2134	11762347000	29874	14723	7	0	8552
223175	2134	11761343000	29874	14723	8	0	8553
223176	2133	8474102000	29874	14723	9	0	7952
223177	1397	1257311866000	29875	14723	0	0	\N
223178	2133	8476106000	29875	14723	1	0	\N
223179	2133	8475104000	29875	14723	2	0	\N
223180	2132	6789804000	29875	14723	3	0	\N
223181	2132	6788803000	29875	14723	4	0	\N
223182	2133	8474102000	29875	14723	5	0	\N
223183	10	32559523762605	29876	14690	0	0	\N
223184	238	66000973695901	29876	14690	1	0	\N
223185	301	66002280080033	29876	14690	2	0	\N
223186	1397	1257661901000	29876	14690	3	0	\N
223187	283	66001289080033	29876	14690	4	0	\N
223188	1397	1257651900000	29876	14690	5	0	\N
223189	1397	1257641899000	29876	14690	7	0	\N
223190	1397	1257631898000	29876	14690	8	0	\N
223191	1397	1257621897000	29876	14690	9	0	\N
223192	1397	1257611896000	29876	14690	10	0	\N
223193	1397	1257601895000	29876	14690	11	0	\N
223194	1397	1257591894000	29876	14690	12	0	\N
223195	1397	1257581893000	29876	14690	13	0	\N
223196	1397	1257571892000	29876	14690	14	0	\N
223197	1397	1257561891000	29876	14690	15	0	\N
223198	1397	1257551890000	29876	14690	16	0	\N
223199	1397	1257541889000	29876	14690	17	0	\N
223200	1397	1257531888000	29876	14690	18	0	\N
223201	114	66001611517324	29876	14690	19	0	\N
223202	1397	1257521887000	29876	14690	20	0	\N
223203	1397	1257511886000	29876	14690	21	0	\N
223204	1397	1257501885000	29876	14690	22	0	\N
223205	1397	1257491884000	29876	14690	23	0	\N
223206	1397	1257481883000	29876	14690	24	0	\N
223207	1397	1257471882000	29876	14690	25	0	\N
223208	1397	1257461881000	29876	14690	26	0	\N
223209	1397	1257451880000	29876	14690	27	0	\N
223210	1397	1257441879000	29876	14690	28	0	\N
223211	1397	1257431878000	29876	14690	29	0	\N
223212	1397	1257421877000	29876	14690	30	0	\N
223213	1397	1257411876000	29876	14690	31	0	\N
223214	1397	1257401875000	29876	14690	32	0	\N
223215	1397	1257391874000	29876	14690	33	0	\N
223216	1397	1257381873000	29876	14690	34	0	\N
223217	1397	1257371872000	29876	14690	35	0	\N
223218	1397	1257361871000	29876	14690	36	0	\N
223219	1397	1257351870000	29876	14690	37	0	\N
223220	1397	1257341869000	29876	14690	38	0	\N
223221	1397	1257331868000	29876	14690	39	0	\N
223222	1397	1257321867000	29876	14690	40	0	\N
223223	1397	1257311866000	29876	14690	41	0	\N
223224	2134	11940055000	29876	14690	42	0	\N
223225	2132	6852867000	29876	14690	43	0	\N
223226	2132	6851866000	29876	14690	44	0	\N
223227	2132	6850865000	29876	14690	45	0	\N
223228	2132	6849864000	29876	14690	46	0	\N
223229	2132	6848863000	29876	14690	47	0	\N
223230	2133	8591336000	29876	14690	48	0	\N
223231	2133	8590334000	29876	14690	49	0	\N
223232	2133	8589332000	29876	14690	50	0	\N
223233	2133	8588330000	29876	14690	51	0	\N
223234	2133	8587328000	29876	14690	52	0	\N
223235	2132	6847862000	29876	14690	53	0	\N
223236	2132	6846861000	29876	14690	54	0	\N
223237	2132	6845860000	29876	14690	55	0	\N
223238	2132	6844859000	29876	14690	56	0	\N
223239	2132	6843858000	29876	14690	57	0	\N
223240	2132	6842857000	29876	14690	58	0	\N
223241	2132	6841856000	29876	14690	59	0	\N
223242	2132	6840855000	29876	14690	60	0	\N
223243	2132	6839854000	29876	14690	61	0	\N
223244	2132	6838853000	29876	14690	62	0	\N
223245	2132	6837852000	29876	14690	63	0	\N
223246	2132	6836851000	29876	14690	64	0	\N
223247	2132	6835850000	29876	14690	65	0	\N
223248	2132	6834849000	29876	14690	66	0	\N
223249	2132	6833848000	29876	14690	67	0	\N
223250	2132	6832847000	29876	14690	68	0	\N
223251	2132	6831846000	29876	14690	69	0	\N
223252	2132	6830845000	29876	14690	70	0	\N
223253	2132	6829844000	29876	14690	71	0	\N
223254	2132	6828843000	29876	14690	72	0	\N
223255	2132	6827842000	29876	14690	73	0	\N
223256	2132	6826841000	29876	14690	74	0	\N
223257	2132	6825840000	29876	14690	75	0	\N
223258	2132	6824839000	29876	14690	76	0	\N
223259	2132	6823838000	29876	14690	77	0	\N
223260	2132	6822837000	29876	14690	78	0	\N
223261	2132	6821836000	29876	14690	79	0	\N
223262	2132	6820835000	29876	14690	80	0	\N
223263	2132	6819834000	29876	14690	81	0	\N
223264	2132	6818833000	29876	14690	82	0	\N
223265	2132	6817832000	29876	14690	83	0	\N
223266	2132	6816831000	29876	14690	84	0	\N
223267	2132	6815830000	29876	14690	85	0	\N
223268	2132	6814829000	29876	14690	86	0	\N
223269	2132	6813828000	29876	14690	87	0	\N
223270	2132	6812827000	29876	14690	88	0	\N
223271	2132	6811826000	29876	14690	89	0	\N
223272	2132	6810825000	29876	14690	90	0	\N
223273	2132	6809824000	29876	14690	91	0	\N
223274	2132	6808823000	29876	14690	92	0	\N
223275	2132	6807822000	29876	14690	93	0	\N
223276	2132	6806821000	29876	14690	94	0	\N
223277	2132	6805820000	29876	14690	95	0	\N
223278	2132	6804819000	29876	14690	96	0	\N
223279	2132	6803818000	29876	14690	97	0	\N
223280	2132	6802817000	29876	14690	98	0	\N
223281	2132	6801816000	29876	14690	99	0	\N
223282	2132	6800815000	29876	14690	100	0	\N
223283	2132	6799814000	29876	14690	101	0	\N
223284	2132	6798813000	29876	14690	102	0	\N
223285	2132	6797812000	29876	14690	103	0	\N
223286	2132	6796811000	29876	14690	104	0	\N
223287	2132	6795810000	29876	14690	105	0	\N
223288	2132	6794809000	29876	14690	106	0	\N
223289	2132	6793808000	29876	14690	107	0	\N
223290	2132	6792807000	29876	14690	108	0	\N
223291	2132	6791806000	29876	14690	109	0	\N
223292	2132	6790805000	29876	14690	110	0	\N
223293	2132	6789804000	29876	14690	111	0	\N
223294	2132	6788803000	29876	14690	112	0	\N
223295	2133	8586326000	29876	14690	113	0	\N
223296	2133	8585324000	29876	14690	114	0	\N
223297	2133	8584322000	29876	14690	115	0	\N
223298	2133	8583320000	29876	14690	116	0	\N
223299	2133	8582318000	29876	14690	117	0	\N
223300	2133	8581316000	29876	14690	118	0	\N
223301	2133	8580314000	29876	14690	119	0	\N
223302	2133	8579312000	29876	14690	120	0	\N
223305	1397	1257291864000	29877	14724	2	0	18153
223306	2132	6787802000	29877	14724	3	0	2200
223307	2134	11760339000	29877	14724	4	0	8554
223308	2134	11759335000	29877	14724	5	0	8555
223309	2134	11758331000	29877	14724	6	0	8556
223311	2132	6786801000	29877	14724	8	0	2201
223312	2134	11756323000	29877	14724	9	0	8558
223322	50	66008900000000	29878	14592	0	0	\N
223323	389	68159958000000	29878	14592	1	0	\N
223324	451	66564522585011	29878	14592	2	0	\N
223325	651	66718925000000	29878	14592	3	0	\N
223326	689	67438422000000	29878	14592	4	0	\N
223327	744	2016912805578	29878	14592	5	0	\N
223328	379	66190536998665	29878	14592	6	0	\N
223329	556	66720035511028	29878	14592	7	0	\N
223330	498	67440214000000	29878	14592	8	0	\N
223331	724	20001130000000	29878	14592	9	0	\N
223332	1643	3185279064700	29878	14592	10	0	\N
223333	735	3000990000000	29878	14592	11	0	\N
223334	379	66000000000665	29878	14592	12	0	\N
223335	2425	90000000	29878	14592	13	0	\N
223336	472	66000990000000	29878	14592	14	0	\N
223337	472	66000080000000	29878	14592	15	0	\N
223338	2427	96750000	29878	14592	16	0	\N
223339	146	66846779269804	29878	14592	17	0	\N
223340	1268	1003913681688	29878	14592	18	0	\N
223341	1268	1003911681688	29878	14592	19	0	\N
223342	1397	1257281863000	29879	14725	0	0	\N
223343	2133	8468090000	29879	14725	1	0	\N
223344	2132	6785800000	29879	14725	3	0	\N
223345	2132	6784799000	29879	14725	4	0	\N
223346	2134	11751303000	29879	14725	5	0	\N
223347	2134	11750299000	29879	14725	6	0	\N
223348	2134	11749295000	29879	14725	7	0	\N
223349	2134	11748291000	29879	14725	8	0	\N
223350	2133	8467088000	29879	14725	9	0	\N
223351	2133	8466086000	29879	14725	10	0	\N
223402	1397	1257251860000	29883	14727	0	0	\N
223403	1397	1257241859000	29883	14727	1	0	\N
223404	2133	8459072000	29883	14727	2	0	\N
223405	2133	8458070000	29883	14727	3	0	\N
223406	2133	8457068000	29883	14727	4	0	\N
223407	2133	8456066000	29883	14727	5	0	\N
223408	2132	6780795000	29883	14727	6	0	\N
223409	2132	6779794000	29883	14727	7	0	\N
223410	2132	6778793000	29883	14727	8	0	\N
223411	2133	8455064000	29883	14727	9	0	\N
223412	2133	8454062000	29883	14727	10	0	\N
223413	2134	11738251000	29883	14727	11	0	\N
223414	2134	11737247000	29883	14727	12	0	\N
223415	2134	11736243000	29883	14727	13	0	\N
223416	2134	11735239000	29883	14727	14	0	\N
223417	2134	11734235000	29883	14727	15	0	\N
223418	2134	11733231000	29883	14727	16	0	\N
223419	2134	11732227000	29883	14727	17	0	\N
223420	2134	11731223000	29883	14727	18	0	\N
223421	2134	11730219000	29883	14727	19	0	\N
223422	1397	1257251860000	29884	14727	0	0	\N
223423	1397	1257241859000	29884	14727	1	0	\N
223424	2133	8459072000	29884	14727	2	0	\N
223425	2133	8458070000	29884	14727	3	0	\N
223426	2133	8457068000	29884	14727	4	0	\N
223427	2133	8456066000	29884	14727	5	0	\N
223428	2132	6780795000	29884	14727	6	0	\N
223429	2132	6779794000	29884	14727	7	0	\N
223430	2132	6778793000	29884	14727	8	0	\N
223431	2133	8455064000	29884	14727	9	0	\N
223432	2133	8454062000	29884	14727	10	0	\N
223433	2134	11738251000	29884	14727	11	0	\N
223434	2134	11737247000	29884	14727	12	0	\N
223435	2134	11736243000	29884	14727	13	0	\N
223436	2134	11735239000	29884	14727	14	0	\N
223437	2134	11734235000	29884	14727	15	0	\N
223438	2134	11733231000	29884	14727	16	0	\N
223439	2134	11732227000	29884	14727	17	0	\N
223440	2134	11731223000	29884	14727	18	0	\N
223441	2134	11730219000	29884	14727	19	0	\N
223442	1397	1257231858000	29885	14728	0	0	\N
223443	2132	6777792000	29885	14728	1	0	\N
223444	2133	8453060000	29885	14728	2	0	\N
223445	2134	11729215000	29885	14728	3	0	\N
223446	2134	11728211000	29885	14728	4	0	\N
223447	2134	11727207000	29885	14728	5	0	\N
223448	2134	11726203000	29885	14728	6	0	\N
223315	2134	11753311000	29877	14724	12	0	8561
223316	2134	11752307000	29877	14724	13	0	8562
223317	2133	8473100000	29877	14724	14	0	7953
223318	2133	8472098000	29877	14724	15	0	7954
223319	2133	8471096000	29877	14724	16	0	7955
223321	2133	8469092000	29877	14724	18	0	7957
223352	1397	1257281863000	29880	14725	0	0	18154
223353	2133	8468090000	29880	14725	1	0	7958
223354	2132	6785800000	29880	14725	3	0	2202
223355	2132	6784799000	29880	14725	4	0	2203
223357	2134	11750299000	29880	14725	6	0	8564
223358	2134	11749295000	29880	14725	7	0	8565
223359	2134	11748291000	29880	14725	8	0	8566
223360	2133	8467088000	29880	14725	9	0	7959
223362	1397	1257271862000	29881	14726	0	0	18155
223363	1397	1257261861000	29881	14726	1	0	18156
223364	2134	11747287000	29881	14726	2	0	8567
223365	2134	11746283000	29881	14726	3	0	8568
223366	2132	6783798000	29881	14726	4	0	2204
223368	2134	11744275000	29881	14726	6	0	8570
223369	2134	11743271000	29881	14726	7	0	8571
223370	2133	8465084000	29881	14726	8	0	7961
223371	2133	8464082000	29881	14726	9	0	7962
223372	2133	8463080000	29881	14726	10	0	7963
223374	2133	8461076000	29881	14726	12	0	7965
223375	2133	8460074000	29881	14726	13	0	7966
223376	2132	6782797000	29881	14726	14	0	2205
223377	2132	6781796000	29881	14726	15	0	2206
223379	2134	11741263000	29881	14726	17	0	8573
223380	2134	11740259000	29881	14726	18	0	8574
223381	2134	11739255000	29881	14726	19	0	8575
223382	1397	1257251860000	29882	14727	0	0	18157
223383	1397	1257241859000	29882	14727	1	0	18158
223385	2133	8458070000	29882	14727	3	0	7968
223386	2133	8457068000	29882	14727	4	0	7969
223387	2133	8456066000	29882	14727	5	0	7970
223388	2132	6780795000	29882	14727	6	0	2207
223389	2132	6779794000	29882	14727	7	0	2208
223391	2133	8455064000	29882	14727	9	0	7971
223392	2133	8454062000	29882	14727	10	0	7972
223393	2134	11738251000	29882	14727	11	0	8576
223394	2134	11737247000	29882	14727	12	0	8577
223396	2134	11735239000	29882	14727	14	0	8579
223397	2134	11734235000	29882	14727	15	0	8580
223398	2134	11733231000	29882	14727	16	0	8581
223399	2134	11732227000	29882	14727	17	0	8582
223400	2134	11731223000	29882	14727	18	0	8583
223449	2134	11725199000	29885	14728	7	0	\N
223450	2133	8452058000	29885	14728	8	0	\N
223451	1397	1257231858000	29886	14728	0	0	\N
223452	2132	6777792000	29886	14728	1	0	\N
223453	2133	8453060000	29886	14728	2	0	\N
223454	2134	11729215000	29886	14728	3	0	\N
223455	2134	11728211000	29886	14728	4	0	\N
223456	2134	11727207000	29886	14728	5	0	\N
223457	2134	11726203000	29886	14728	6	0	\N
223458	2134	11725199000	29886	14728	7	0	\N
223459	2133	8452058000	29886	14728	8	0	\N
223469	1397	1257221857000	29888	14729	0	0	\N
223470	2133	8451056000	29888	14729	1	0	\N
223471	2134	11724195000	29888	14729	2	0	\N
223472	2132	6776791000	29888	14729	3	0	\N
223473	2134	11723191000	29888	14729	4	0	\N
223474	2134	11722187000	29888	14729	5	0	\N
223475	2132	6775790000	29888	14729	6	0	\N
223476	2133	8450054000	29888	14729	7	0	\N
223477	2133	8449052000	29888	14729	8	0	\N
223478	2134	11721183000	29888	14729	9	0	\N
223489	1397	1257221857000	29890	14729	0	0	\N
223490	2133	8451056000	29890	14729	1	0	\N
223491	2132	6776791000	29890	14729	2	0	\N
223492	2132	6775790000	29890	14729	3	0	\N
223493	2133	8450054000	29890	14729	4	0	\N
223494	2133	8449052000	29890	14729	5	0	\N
223504	1397	1257211856000	29892	14730	0	0	\N
223505	2133	8448050000	29892	14730	1	0	\N
223506	2133	8447048000	29892	14730	2	0	\N
223507	2134	11720179000	29892	14730	3	0	\N
223508	2134	11719175000	29892	14730	4	0	\N
223509	2134	11718171000	29892	14730	5	0	\N
223510	2134	11717167000	29892	14730	6	0	\N
223511	2132	6774789000	29892	14730	7	0	\N
223512	1397	1257201855000	29893	14731	0	0	\N
223513	2133	8445044000	29893	14731	1	0	\N
223514	2134	11716163000	29893	14731	2	0	\N
223515	2134	11715159000	29893	14731	3	0	\N
223516	2134	11714155000	29893	14731	4	0	\N
223517	2133	8444042000	29893	14731	5	0	\N
223518	2132	6773788000	29893	14731	6	0	\N
223519	2132	6772787000	29893	14731	7	0	\N
223520	2134	11713151000	29893	14731	8	0	\N
223521	2134	11712147000	29893	14731	9	0	\N
223522	1397	1257201855000	29894	14731	0	0	\N
223523	2133	8445044000	29894	14731	1	0	\N
223524	2134	11716163000	29894	14731	2	0	\N
223525	2134	11715159000	29894	14731	3	0	\N
223526	2134	11714155000	29894	14731	4	0	\N
223527	2133	8444042000	29894	14731	5	0	\N
223528	2132	6773788000	29894	14731	6	0	\N
223529	2132	6772787000	29894	14731	7	0	\N
223530	2134	11713151000	29894	14731	8	0	\N
223531	2134	11712147000	29894	14731	9	0	\N
223542	1397	1257201855000	29896	14731	0	0	\N
223543	2133	8445044000	29896	14731	1	0	\N
223544	2134	11716163000	29896	14731	2	0	\N
223545	2134	11715159000	29896	14731	3	0	\N
223546	2134	11714155000	29896	14731	4	0	\N
223547	2133	8444042000	29896	14731	5	0	\N
223548	2132	6773788000	29896	14731	6	0	\N
223549	2132	6772787000	29896	14731	7	0	\N
223550	2134	11713151000	29896	14731	8	0	\N
223551	2134	11712147000	29896	14731	9	0	\N
223552	1397	1257201855000	29897	14731	0	0	\N
223553	2133	8445044000	29897	14731	1	0	\N
223554	2134	11716163000	29897	14731	2	0	\N
223555	2134	11715159000	29897	14731	3	0	\N
223556	2134	11714155000	29897	14731	4	0	\N
223557	2133	8444042000	29897	14731	5	0	\N
223558	2132	6773788000	29897	14731	6	0	\N
223559	2132	6772787000	29897	14731	7	0	\N
223560	2134	11713151000	29897	14731	8	0	\N
223561	2134	11712147000	29897	14731	9	0	\N
223562	606	84046008286229	29898	14732	0	0	\N
223563	1397	1257191854000	29898	14732	1	0	\N
223564	2134	11711143000	29898	14732	2	0	\N
223565	2133	8443040000	29898	14732	3	0	\N
223566	2132	6771786000	29898	14732	4	0	\N
223567	2134	11710139000	29898	14732	5	0	\N
223568	2134	11709135000	29898	14732	6	0	\N
223569	2134	11708131000	29898	14732	7	0	\N
223570	2418	99000000	29898	14732	8	0	\N
223571	2133	8442038000	29898	14732	9	0	\N
223572	606	84046008286229	29899	14732	0	0	\N
223573	1397	1257191854000	29899	14732	1	0	\N
223574	2134	11711143000	29899	14732	2	0	\N
223575	2133	8443040000	29899	14732	3	0	\N
223576	2132	6771786000	29899	14732	4	0	\N
223577	2134	11710139000	29899	14732	5	0	\N
223578	2134	11709135000	29899	14732	6	0	\N
223579	2134	11708131000	29899	14732	7	0	\N
223580	2418	99000000	29899	14732	8	0	\N
223581	2133	8442038000	29899	14732	9	0	\N
223462	2133	8453060000	29887	14728	2	0	7973
223463	2134	11729215000	29887	14728	3	0	8585
223464	2134	11728211000	29887	14728	4	0	8586
223465	2134	11727207000	29887	14728	5	0	8587
223466	2134	11726203000	29887	14728	6	0	8588
223468	2133	8452058000	29887	14728	8	0	7974
223479	1397	1257221857000	29889	14729	0	0	18160
223480	2133	8451056000	29889	14729	1	0	7975
223481	2134	11724195000	29889	14729	2	0	8590
223482	2132	6776791000	29889	14729	3	0	2211
223484	2134	11722187000	29889	14729	5	0	8592
223485	2132	6775790000	29889	14729	6	0	2212
223486	2133	8450054000	29889	14729	7	0	7976
223487	2133	8449052000	29889	14729	8	0	7977
223495	1397	1257211856000	29891	14730	0	0	18161
223496	2133	8448050000	29891	14730	1	0	7978
223497	2133	8447048000	29891	14730	2	0	7979
223498	2134	11720179000	29891	14730	3	0	8594
223499	2134	11719175000	29891	14730	4	0	8595
223501	2134	11717167000	29891	14730	6	0	8597
223502	2132	6774789000	29891	14730	7	0	2213
223503	2133	8446046000	29891	14730	8	0	7980
223532	1397	1257201855000	29895	14731	0	0	18162
223533	2133	8445044000	29895	14731	1	0	7981
223535	2134	11715159000	29895	14731	3	0	8599
223536	2134	11714155000	29895	14731	4	0	8600
223537	2133	8444042000	29895	14731	5	0	7982
223538	2132	6773788000	29895	14731	6	0	2214
223540	2134	11713151000	29895	14731	8	0	8601
223541	2134	11712147000	29895	14731	9	0	8602
223582	606	84046008286229	29900	14732	0	0	19
223583	1397	1257191854000	29900	14732	1	0	18163
223584	2134	11711143000	29900	14732	2	0	8603
223592	606	84046008286229	29901	14732	0	0	\N
223593	1397	1257191854000	29901	14732	1	0	\N
223594	2134	11711143000	29901	14732	2	0	\N
223595	2133	8443040000	29901	14732	3	0	\N
223596	2132	6771786000	29901	14732	4	0	\N
223597	2134	11710139000	29901	14732	5	0	\N
223598	2134	11709135000	29901	14732	6	0	\N
223599	2134	11708131000	29901	14732	7	0	\N
223600	2418	99000000	29901	14732	8	0	\N
223601	2133	8442038000	29901	14732	9	0	\N
223602	606	84046008286229	29902	14732	0	0	\N
223603	1397	1257191854000	29902	14732	1	0	\N
223604	2134	11711143000	29902	14732	2	0	\N
223605	2132	6771786000	29902	14732	3	0	\N
223606	2134	11710139000	29902	14732	4	0	\N
223607	2134	11709135000	29902	14732	5	0	\N
223608	2134	11708131000	29902	14732	6	0	\N
223609	2418	99000000	29902	14732	7	0	\N
223630	1397	1257171852000	29905	14734	0	0	\N
223631	2134	11702107000	29905	14734	1	0	\N
223632	2133	8439032000	29905	14734	2	0	\N
223633	2134	11701103000	29905	14734	3	0	\N
223634	2134	11700099000	29905	14734	4	0	\N
223635	2134	11699095000	29905	14734	5	0	\N
223636	2132	6768783000	29905	14734	6	0	\N
223637	2133	8438030000	29905	14734	7	0	\N
223638	2133	8437028000	29905	14734	8	0	\N
223639	1397	1257161851000	29906	14735	0	0	\N
223640	2132	6767782000	29906	14735	1	0	\N
223641	2133	8436026000	29906	14735	2	0	\N
223642	2133	8435024000	29906	14735	3	0	\N
223643	2418	97000000	29906	14735	4	0	\N
223644	2132	6766781000	29906	14735	5	0	\N
223645	2134	11698091000	29906	14735	6	0	\N
223646	2134	11697087000	29906	14735	7	0	\N
223647	2134	11696083000	29906	14735	8	0	\N
223648	2134	11695079000	29906	14735	9	0	\N
223649	2134	11694075000	29906	14735	10	0	\N
223661	2132	6765780000	29908	14736	0	0	\N
223662	2133	8434022000	29909	14736	0	0	\N
223663	2132	6765780000	29909	14736	1	0	\N
223664	2133	8433020000	29909	14736	2	0	\N
223665	2133	8432018000	29909	14736	3	0	\N
223675	1397	1257141849000	29911	14737	0	0	\N
223676	2133	8431016000	29911	14737	1	0	\N
223677	2134	11689055000	29911	14737	2	0	\N
223678	2132	6764779000	29911	14737	3	0	\N
223679	2132	6763778000	29911	14737	4	0	\N
223680	2133	8430014000	29911	14737	5	0	\N
223681	2134	11688051000	29911	14737	6	0	\N
223682	2134	11687047000	29911	14737	7	0	\N
223683	2134	11686043000	29911	14737	8	0	\N
223684	2134	11685039000	29911	14737	9	0	\N
223693	1397	1257141849000	29913	14737	0	0	\N
223694	2133	8431016000	29913	14737	1	0	\N
223695	2134	11689055000	29913	14737	2	0	\N
223696	2132	6764779000	29913	14737	3	0	\N
223697	2132	6763778000	29913	14737	4	0	\N
223698	2133	8430014000	29913	14737	5	0	\N
223699	2134	11688051000	29913	14737	6	0	\N
223700	2134	11687047000	29913	14737	7	0	\N
223701	2134	11686043000	29913	14737	8	0	\N
223702	2134	11685039000	29913	14737	9	0	\N
223703	606	84046008286229	29914	14668	0	0	\N
223704	689	67438422000000	29914	14668	1	0	\N
223705	1397	1257821917000	29914	14668	2	0	\N
223706	2133	8633420000	29914	14668	3	0	\N
223707	2418	99000000	29914	14668	4	0	\N
223708	2418	98000000	29914	14668	5	0	\N
223709	2418	97000000	29914	14668	6	0	\N
223710	2133	8632418000	29914	14668	7	0	\N
223711	1397	1257131848000	29915	14738	0	0	\N
223712	2133	8429012000	29915	14738	1	0	\N
223713	2133	8428010000	29915	14738	2	0	\N
223714	2132	6762777000	29915	14738	3	0	\N
223715	2134	11684035000	29915	14738	4	0	\N
223716	2134	11683031000	29915	14738	5	0	\N
223717	2134	11682027000	29915	14738	6	0	\N
223587	2134	11710139000	29900	14732	5	0	8604
223588	2134	11709135000	29900	14732	6	0	8605
223589	2134	11708131000	29900	14732	7	0	8606
223590	2418	99000000	29900	14732	8	0	1
223591	2133	8442038000	29900	14732	9	0	7984
223611	2132	6770785000	29903	14733	1	0	2217
223612	2418	98000000	29903	14733	2	0	2
223613	2134	11707127000	29903	14733	3	0	8607
223614	2134	11706123000	29903	14733	4	0	8608
223615	2134	11705119000	29903	14733	5	0	8609
223617	2134	11703111000	29903	14733	7	0	8611
223618	2132	6769784000	29903	14733	8	0	2218
223619	2133	8441036000	29903	14733	9	0	7985
223620	2133	8440034000	29903	14733	10	0	7986
223622	2134	11702107000	29904	14734	1	0	8612
223623	2133	8439032000	29904	14734	2	0	7987
223624	2134	11701103000	29904	14734	3	0	8613
223625	2134	11700099000	29904	14734	4	0	8614
223626	2134	11699095000	29904	14734	5	0	8615
223628	2133	8438030000	29904	14734	7	0	7988
223629	2133	8437028000	29904	14734	8	0	7989
223650	1397	1257161851000	29907	14735	0	0	18166
223651	2132	6767782000	29907	14735	1	0	2220
223652	2133	8436026000	29907	14735	2	0	7990
223654	2418	97000000	29907	14735	4	0	3
223655	2132	6766781000	29907	14735	5	0	2221
223656	2134	11698091000	29907	14735	6	0	8616
223657	2134	11697087000	29907	14735	7	0	8617
223659	2134	11695079000	29907	14735	9	0	8619
223660	2134	11694075000	29907	14735	10	0	8620
223666	1397	1257151850000	29910	14736	0	0	18167
223667	2133	8434022000	29910	14736	1	0	7992
223668	2134	11693071000	29910	14736	2	0	8621
223670	2134	11691063000	29910	14736	4	0	8623
223671	2132	6765780000	29910	14736	5	0	2222
223672	2134	11690059000	29910	14736	6	0	8624
223673	2133	8433020000	29910	14736	7	0	7993
223674	2133	8432018000	29910	14736	8	0	7994
223686	2133	8431016000	29912	14737	1	0	7995
223687	2134	11689055000	29912	14737	2	0	8625
223688	2132	6764779000	29912	14737	3	0	2223
223689	2133	8430014000	29912	14737	4	0	7996
223691	2134	11687047000	29912	14737	6	0	8627
223692	2134	11686043000	29912	14737	7	0	8628
223718	1397	1257131848000	29916	14738	0	0	18169
223719	2132	6763778000	29916	14738	1	0	2224
223720	2133	8429012000	29916	14738	2	0	7997
223738	1397	1257111846000	29918	14740	0	0	\N
223739	2133	8424002000	29918	14740	1	0	\N
223740	2132	6759774000	29918	14740	2	0	\N
223741	2133	8423000000	29918	14740	3	0	\N
223742	1397	1257111846000	29919	14740	0	0	\N
223743	2133	8424002000	29919	14740	1	0	\N
223744	2132	6759774000	29919	14740	2	0	\N
223745	2134	11676003000	29919	14740	3	0	\N
223746	2134	11674999000	29919	14740	4	0	\N
223747	2133	8423000000	29919	14740	5	0	\N
223748	2134	11673995000	29919	14740	6	0	\N
223749	2134	11672991000	29919	14740	7	0	\N
223750	2134	11671987000	29919	14740	8	0	\N
223751	1397	1257181853000	29920	14733	0	0	\N
223752	1397	1257171852000	29920	14733	1	0	\N
223753	1397	1257161851000	29920	14733	2	0	\N
223754	1397	1257151850000	29920	14733	3	0	\N
223755	1397	1257141849000	29920	14733	4	0	\N
223756	1397	1257131848000	29920	14733	5	0	\N
223757	1397	1257121847000	29920	14733	6	0	\N
223758	1397	1257111846000	29920	14733	7	0	\N
223759	2132	6770785000	29920	14733	8	0	\N
223760	2418	98000000	29920	14733	9	0	\N
223761	2134	11707127000	29920	14733	10	0	\N
223762	2134	11706123000	29920	14733	12	0	\N
223763	2134	11705119000	29920	14733	13	0	\N
223764	2134	11704115000	29920	14733	14	0	\N
223765	2134	11703111000	29920	14733	15	0	\N
223766	2132	6769784000	29920	14733	16	0	\N
223767	2134	11702107000	29920	14733	17	0	\N
223768	2134	11701103000	29920	14733	18	0	\N
223769	2134	11700099000	29920	14733	19	0	\N
223770	2134	11699095000	29920	14733	20	0	\N
223771	2418	97000000	29920	14733	21	0	\N
223772	2132	6768783000	29920	14733	22	0	\N
223773	2132	6767782000	29920	14733	23	0	\N
223774	2132	6766781000	29920	14733	24	0	\N
223775	2132	6765780000	29920	14733	25	0	\N
223776	2132	6764779000	29920	14733	26	0	\N
223777	2132	6763778000	29920	14733	27	0	\N
223778	2132	6762777000	29920	14733	28	0	\N
223779	2132	6761776000	29920	14733	29	0	\N
223780	2132	6760775000	29920	14733	30	0	\N
223781	2132	6759774000	29920	14733	31	0	\N
223782	2133	8441036000	29920	14733	32	0	\N
223783	2133	8440034000	29920	14733	33	0	\N
223784	2133	8439032000	29920	14733	34	0	\N
223785	2134	11698091000	29920	14733	35	0	\N
223786	2134	11697087000	29920	14733	36	0	\N
223787	2134	11696083000	29920	14733	37	0	\N
223788	2134	11695079000	29920	14733	38	0	\N
223789	2134	11694075000	29920	14733	39	0	\N
223790	2134	11693071000	29920	14733	40	0	\N
223791	2134	11692067000	29920	14733	41	0	\N
223792	2134	11691063000	29920	14733	42	0	\N
223793	2134	11690059000	29920	14733	43	0	\N
223794	2134	11689055000	29920	14733	44	0	\N
223795	2134	11688051000	29920	14733	45	0	\N
223796	2134	11687047000	29920	14733	46	0	\N
223797	2134	11686043000	29920	14733	47	0	\N
223798	2134	11685039000	29920	14733	48	0	\N
223799	2134	11684035000	29920	14733	49	0	\N
223800	2134	11683031000	29920	14733	50	0	\N
223801	2134	11682027000	29920	14733	51	0	\N
223802	2134	11681023000	29920	14733	52	0	\N
223803	2134	11680019000	29920	14733	53	0	\N
223804	2134	11679015000	29920	14733	54	0	\N
223805	2133	8438030000	29920	14733	55	0	\N
223806	2133	8437028000	29920	14733	56	0	\N
223807	2133	8436026000	29920	14733	57	0	\N
223808	2133	8435024000	29920	14733	58	0	\N
223809	2133	8434022000	29920	14733	59	0	\N
223810	2133	8433020000	29920	14733	60	0	\N
223811	2133	8432018000	29920	14733	61	0	\N
223812	2133	8431016000	29920	14733	62	0	\N
223813	2133	8430014000	29920	14733	63	0	\N
223814	2133	8429012000	29920	14733	64	0	\N
223815	2133	8428010000	29920	14733	65	0	\N
223816	2133	8427008000	29920	14733	66	0	\N
223817	2133	8426006000	29920	14733	67	0	\N
223818	2133	8425004000	29920	14733	68	0	\N
223819	2133	8424002000	29920	14733	69	0	\N
223820	2133	8423000000	29920	14733	70	0	\N
223821	2134	11678011000	29920	14733	71	0	\N
223822	2134	11677007000	29920	14733	72	0	\N
223823	2134	11676003000	29920	14733	73	0	\N
223824	2134	11674999000	29920	14733	74	0	\N
223825	2134	11673995000	29920	14733	75	0	\N
223826	2134	11672991000	29920	14733	76	0	\N
223827	2134	11671987000	29920	14733	77	0	\N
223837	1397	1257101845000	29922	14741	0	0	\N
223838	2132	6758773000	29922	14741	1	0	\N
223839	2133	8421998000	29922	14741	2	0	\N
223840	2133	8420996000	29922	14741	3	0	\N
223841	2134	11670983000	29922	14741	4	0	\N
223842	2134	11669979000	29922	14741	5	0	\N
223843	2134	11668975000	29922	14741	6	0	\N
223844	2134	11667971000	29922	14741	7	0	\N
223845	1397	1257101845000	29923	14741	0	0	\N
223846	2132	6758773000	29923	14741	1	0	\N
223847	2133	8421998000	29923	14741	2	0	\N
223848	2133	8420996000	29923	14741	3	0	\N
223849	2134	11670983000	29923	14741	4	0	\N
223850	2134	11669979000	29923	14741	5	0	\N
223851	2134	11668975000	29923	14741	6	0	\N
223852	2134	11667971000	29923	14741	7	0	\N
223723	2134	11685039000	29916	14738	5	0	8629
223724	2134	11684035000	29916	14738	6	0	8630
223725	2134	11683031000	29916	14738	7	0	8631
223726	2134	11682027000	29916	14738	8	0	8632
223727	2134	11681023000	29916	14738	9	0	8633
223729	2134	11680019000	29917	14739	1	0	8634
223730	2134	11679015000	29917	14739	2	0	8635
223731	2132	6761776000	29917	14739	3	0	2226
223732	2132	6760775000	29917	14739	4	0	2227
223733	2133	8427008000	29917	14739	5	0	7999
223735	2133	8425004000	29917	14739	7	0	8001
223736	2134	11678011000	29917	14739	8	0	8636
223737	2134	11677007000	29917	14739	9	0	8637
223828	1397	1257111846000	29921	14740	0	0	18171
223830	2132	6759774000	29921	14740	2	0	2228
223831	2134	11676003000	29921	14740	3	0	8638
223832	2134	11674999000	29921	14740	4	0	8639
223833	2133	8423000000	29921	14740	5	0	8003
223834	2134	11673995000	29921	14740	6	0	8640
223836	2134	11671987000	29921	14740	8	0	8642
223853	1397	1257101845000	29924	14741	0	0	18172
223854	2132	6758773000	29924	14741	1	0	2229
223855	2133	8421998000	29924	14741	2	0	8004
223856	2133	8420996000	29924	14741	3	0	8005
223866	1397	1257091844000	29926	14742	0	0	\N
223867	1397	1257081843000	29926	14742	1	0	\N
223868	2134	11666967000	29926	14742	2	0	\N
223869	2133	8419994000	29926	14742	3	0	\N
223870	2133	8418992000	29926	14742	4	0	\N
223871	2133	8417990000	29926	14742	5	0	\N
223872	2132	6757772000	29926	14742	6	0	\N
223873	2132	6756771000	29926	14742	7	0	\N
223874	2132	6755770000	29926	14742	8	0	\N
223875	2133	8416988000	29926	14742	9	0	\N
223876	2133	8415986000	29926	14742	10	0	\N
223877	2134	11665963000	29926	14742	11	0	\N
223878	2134	11664959000	29926	14742	12	0	\N
223879	2134	11663955000	29926	14742	13	0	\N
223880	2134	11662951000	29926	14742	14	0	\N
223881	2134	11661947000	29926	14742	15	0	\N
223882	2134	11660943000	29926	14742	16	0	\N
223883	2134	11659939000	29926	14742	17	0	\N
223884	2134	11658935000	29926	14742	18	0	\N
223885	1397	1257091844000	29927	14742	0	0	\N
223886	1397	1257081843000	29927	14742	1	0	\N
223887	2134	11666967000	29927	14742	2	0	\N
223888	2133	8419994000	29927	14742	3	0	\N
223889	2133	8418992000	29927	14742	4	0	\N
223890	2133	8417990000	29927	14742	5	0	\N
223891	2132	6757772000	29927	14742	6	0	\N
223892	2132	6756771000	29927	14742	7	0	\N
223893	2132	6755770000	29927	14742	8	0	\N
223894	2133	8416988000	29927	14742	9	0	\N
223895	2133	8415986000	29927	14742	10	0	\N
223896	2134	11665963000	29927	14742	11	0	\N
223897	2134	11664959000	29927	14742	12	0	\N
223898	2134	11663955000	29927	14742	13	0	\N
223899	2134	11662951000	29927	14742	14	0	\N
223900	2134	11661947000	29927	14742	15	0	\N
223901	2134	11660943000	29927	14742	16	0	\N
223902	2134	11659939000	29927	14742	17	0	\N
223903	2134	11658935000	29927	14742	18	0	\N
223904	1397	1257091844000	29928	14742	0	0	\N
223905	1397	1257081843000	29928	14742	1	0	\N
223906	2134	11666967000	29928	14742	2	0	\N
223907	2133	8419994000	29928	14742	3	0	\N
223908	2133	8418992000	29928	14742	4	0	\N
223909	2133	8417990000	29928	14742	5	0	\N
223910	2132	6757772000	29928	14742	6	0	\N
223911	2132	6756771000	29928	14742	7	0	\N
223912	2132	6755770000	29928	14742	8	0	\N
223913	2133	8416988000	29928	14742	9	0	\N
223914	2133	8415986000	29928	14742	10	0	\N
223915	2134	11665963000	29928	14742	11	0	\N
223916	2134	11664959000	29928	14742	12	0	\N
223917	2134	11663955000	29928	14742	13	0	\N
223918	2134	11662951000	29928	14742	14	0	\N
223919	2134	11661947000	29928	14742	15	0	\N
223920	2134	11660943000	29928	14742	16	0	\N
223921	2134	11659939000	29928	14742	17	0	\N
223922	2134	11658935000	29928	14742	18	0	\N
223947	606	84046008286229	29930	14727	0	0	\N
223948	1397	1257251860000	29930	14727	1	0	\N
223949	1397	1257241859000	29930	14727	2	0	\N
223950	1397	1257231858000	29930	14727	3	0	\N
223951	1397	1257221857000	29930	14727	4	0	\N
223952	1397	1257211856000	29930	14727	5	0	\N
223953	1397	1257201855000	29930	14727	6	0	\N
223954	1397	1257191854000	29930	14727	7	0	\N
223955	1397	1257181853000	29930	14727	8	0	\N
223956	1397	1257171852000	29930	14727	9	0	\N
223957	1397	1257161851000	29930	14727	10	0	\N
223958	1397	1257151850000	29930	14727	11	0	\N
223959	1397	1257141849000	29930	14727	12	0	\N
223960	1397	1257131848000	29930	14727	13	0	\N
223961	1397	1257121847000	29930	14727	14	0	\N
223962	1397	1257111846000	29930	14727	15	0	\N
223963	1397	1257101845000	29930	14727	16	0	\N
223964	1397	1257091844000	29930	14727	17	0	\N
223965	1397	1257081843000	29930	14727	18	0	\N
223966	1397	1257071842000	29930	14727	19	0	\N
223967	2133	8459072000	29930	14727	20	0	\N
223968	2133	8458070000	29930	14727	21	0	\N
223969	2133	8457068000	29930	14727	22	0	\N
223970	2133	8456066000	29930	14727	23	0	\N
223971	2132	6780795000	29930	14727	24	0	\N
223972	2132	6779794000	29930	14727	25	0	\N
223973	2418	99000000	29930	14727	26	0	\N
223974	2418	98000000	29930	14727	27	0	\N
223975	2418	97000000	29930	14727	28	0	\N
223976	2132	6778793000	29930	14727	29	0	\N
223977	2132	6777792000	29930	14727	30	0	\N
223978	2132	6776791000	29930	14727	31	0	\N
223979	2132	6775790000	29930	14727	32	0	\N
223980	2133	8455064000	29930	14727	33	0	\N
223981	2133	8454062000	29930	14727	34	0	\N
223982	2133	8453060000	29930	14727	35	0	\N
223983	2132	6774789000	29930	14727	36	0	\N
223984	2132	6773788000	29930	14727	37	0	\N
223985	2132	6772787000	29930	14727	38	0	\N
223986	2132	6771786000	29930	14727	39	0	\N
223987	2132	6770785000	29930	14727	40	0	\N
223988	2132	6769784000	29930	14727	41	0	\N
223989	2132	6768783000	29930	14727	42	0	\N
223990	2132	6767782000	29930	14727	43	0	\N
223991	2132	6766781000	29930	14727	44	0	\N
223992	2132	6765780000	29930	14727	45	0	\N
223859	2134	11668975000	29924	14741	6	0	8645
223860	2134	11667971000	29924	14741	7	0	8646
223861	1397	1257091844000	29925	14742	0	0	18173
223862	1397	1257081843000	29925	14742	1	0	18174
223863	2132	6757772000	29925	14742	2	0	2230
223865	2132	6755770000	29925	14742	4	0	2232
223923	1397	1257071842000	29929	14743	0	0	18175
223924	2132	6754769000	29929	14743	1	0	2233
223925	2134	11666967000	29929	14743	2	0	8647
223926	2133	8419994000	29929	14743	3	0	8006
223928	2133	8417990000	29929	14743	5	0	8008
223929	2133	8416988000	29929	14743	6	0	8009
223930	2133	8415986000	29929	14743	7	0	8010
223931	2133	8414984000	29929	14743	8	0	8011
223933	2134	11665963000	29929	14743	10	0	8648
223934	2134	11664959000	29929	14743	11	0	8649
223935	2134	11663955000	29929	14743	12	0	8650
223936	2134	11662951000	29929	14743	13	0	8651
223937	2134	11661947000	29929	14743	14	0	8652
223939	2134	11659939000	29929	14743	16	0	8654
223940	2134	11658935000	29929	14743	17	0	8655
223941	2134	11657931000	29929	14743	18	0	8656
223942	2134	11656927000	29929	14743	19	0	8657
223943	2134	11655923000	29929	14743	20	0	8658
223945	2134	11653915000	29929	14743	22	0	8660
223946	2132	6753768000	29929	14743	23	0	2234
223993	2132	6764779000	29930	14727	46	0	\N
223994	2132	6763778000	29930	14727	47	0	\N
223995	2132	6762777000	29930	14727	48	0	\N
223996	2132	6761776000	29930	14727	49	0	\N
223997	2132	6760775000	29930	14727	50	0	\N
223998	2132	6759774000	29930	14727	51	0	\N
223999	2132	6758773000	29930	14727	52	0	\N
224000	2132	6757772000	29930	14727	53	0	\N
224001	2132	6756771000	29930	14727	54	0	\N
224002	2132	6755770000	29930	14727	55	0	\N
224003	2132	6754769000	29930	14727	56	0	\N
224004	2133	8452058000	29930	14727	57	0	\N
224005	2133	8451056000	29930	14727	58	0	\N
224006	2133	8450054000	29930	14727	59	0	\N
224007	2133	8449052000	29930	14727	60	0	\N
224008	2133	8448050000	29930	14727	61	0	\N
224009	2133	8447048000	29930	14727	62	0	\N
224010	2133	8446046000	29930	14727	63	0	\N
224011	2133	8445044000	29930	14727	64	0	\N
224012	2133	8444042000	29930	14727	65	0	\N
224013	2133	8443040000	29930	14727	66	0	\N
224014	2133	8442038000	29930	14727	67	0	\N
224015	2133	8441036000	29930	14727	68	0	\N
224016	2133	8440034000	29930	14727	69	0	\N
224017	2133	8439032000	29930	14727	70	0	\N
224018	2133	8438030000	29930	14727	71	0	\N
224019	2133	8437028000	29930	14727	72	0	\N
224020	2133	8436026000	29930	14727	73	0	\N
224021	2133	8435024000	29930	14727	74	0	\N
224022	2133	8434022000	29930	14727	75	0	\N
224023	2133	8433020000	29930	14727	76	0	\N
224024	2133	8432018000	29930	14727	77	0	\N
224025	2133	8431016000	29930	14727	78	0	\N
224026	2133	8430014000	29930	14727	79	0	\N
224027	2133	8429012000	29930	14727	80	0	\N
224028	2133	8428010000	29930	14727	81	0	\N
224029	2133	8427008000	29930	14727	82	0	\N
224030	2133	8426006000	29930	14727	83	0	\N
224031	2133	8425004000	29930	14727	84	0	\N
224032	2133	8424002000	29930	14727	85	0	\N
224033	2133	8423000000	29930	14727	86	0	\N
224034	2133	8421998000	29930	14727	87	0	\N
224035	2133	8420996000	29930	14727	88	0	\N
224036	2133	8419994000	29930	14727	89	0	\N
224037	2133	8418992000	29930	14727	90	0	\N
224038	2133	8417990000	29930	14727	92	0	\N
224039	2133	8416988000	29930	14727	93	0	\N
224040	2133	8415986000	29930	14727	94	0	\N
224041	2133	8414984000	29930	14727	95	0	\N
224057	1397	1257061841000	29933	14744	0	0	\N
224058	1397	1257051840000	29933	14744	1	0	\N
224059	2132	6752767000	29933	14744	2	0	\N
224060	2134	11652911000	29933	14744	3	0	\N
224061	2134	11651907000	29933	14744	4	0	\N
224062	2132	6751766000	29933	14744	5	0	\N
224063	2132	6750765000	29933	14744	6	0	\N
224064	1726	114118112000	29933	14744	7	0	\N
224065	1726	113017112000	29933	14744	8	0	\N
224066	2133	8412980000	29933	14744	9	0	\N
224067	2133	8411978000	29933	14744	10	0	\N
224068	2133	8410976000	29933	14744	11	0	\N
224069	2133	8409974000	29933	14744	12	0	\N
224070	2133	8408972000	29933	14744	13	0	\N
224071	2133	8407970000	29933	14744	14	0	\N
224072	1397	1257041839000	29934	14745	0	0	\N
224073	1397	1257031838000	29934	14745	1	0	\N
224074	2132	6749764000	29934	14745	2	0	\N
224075	2132	6748763000	29934	14745	3	0	\N
224076	2132	6747762000	29934	14745	4	0	\N
224077	2133	8406968000	29934	14745	5	0	\N
224078	2133	8405966000	29934	14745	6	0	\N
224079	2133	8404964000	29934	14745	7	0	\N
224080	2133	8403962000	29934	14745	8	0	\N
224081	2133	8402960000	29934	14745	9	0	\N
224092	1397	1257041839000	29936	14745	0	0	\N
224093	1397	1257031838000	29936	14745	1	0	\N
224094	2132	6749764000	29936	14745	2	0	\N
224095	2132	6748763000	29936	14745	3	0	\N
224096	2132	6747762000	29936	14745	4	0	\N
224097	2133	8406968000	29936	14745	5	0	\N
224098	2133	8405966000	29936	14745	6	0	\N
224099	2133	8404964000	29936	14745	7	0	\N
224100	2133	8403962000	29936	14745	8	0	\N
224101	2133	8402960000	29936	14745	9	0	\N
224102	1397	1257041839000	29937	14745	0	0	\N
224103	1397	1257031838000	29937	14745	1	0	\N
224104	2132	6749764000	29937	14745	2	0	\N
224105	2132	6748763000	29937	14745	3	0	\N
224106	2132	6747762000	29937	14745	4	0	\N
224107	2133	8406968000	29937	14745	5	0	\N
224108	2133	8405966000	29937	14745	6	0	\N
224109	2133	8404964000	29937	14745	7	0	\N
224110	2133	8403962000	29937	14745	8	0	\N
224111	2133	8402960000	29937	14745	9	0	\N
224112	1397	1257091844000	29938	14742	0	0	\N
224113	1397	1257081843000	29938	14742	1	0	\N
224114	1397	1257071842000	29938	14742	2	0	\N
224115	1397	1257061841000	29938	14742	3	0	\N
224116	1397	1257051840000	29938	14742	4	0	\N
224117	1397	1257041839000	29938	14742	5	0	\N
224118	1397	1257031838000	29938	14742	6	0	\N
224119	2134	11666967000	29938	14742	7	0	\N
224120	2133	8419994000	29938	14742	8	0	\N
224121	2133	8418992000	29938	14742	9	0	\N
224122	2133	8417990000	29938	14742	10	0	\N
224123	2132	6757772000	29938	14742	11	0	\N
224124	2132	6756771000	29938	14742	12	0	\N
224125	2132	6755770000	29938	14742	13	0	\N
224126	2132	6754769000	29938	14742	14	0	\N
224127	2133	8416988000	29938	14742	15	0	\N
224128	2133	8415986000	29938	14742	16	0	\N
224044	2132	6752767000	29932	14744	2	0	2235
224045	2134	11652911000	29932	14744	3	0	8661
224046	2134	11651907000	29932	14744	4	0	8662
224047	2132	6751766000	29932	14744	5	0	2236
224048	2132	6750765000	29932	14744	6	0	2237
224050	1726	113017112000	29932	14744	8	0	8368
224051	2133	8412980000	29932	14744	9	0	8013
224052	2133	8411978000	29932	14744	10	0	8014
224053	2133	8410976000	29932	14744	11	0	8015
224054	2133	8409974000	29932	14744	12	0	8016
224056	2133	8407970000	29932	14744	14	0	8018
224082	1397	1257041839000	29935	14745	0	0	18178
224083	1397	1257031838000	29935	14745	1	0	18179
224084	2132	6749764000	29935	14745	2	0	2238
224086	2132	6747762000	29935	14745	4	0	2240
224087	2133	8406968000	29935	14745	5	0	8019
224088	2133	8405966000	29935	14745	6	0	8020
224089	2133	8404964000	29935	14745	7	0	8021
224090	2133	8403962000	29935	14745	8	0	8022
224129	2133	8414984000	29938	14742	17	0	\N
224130	2133	8413982000	29938	14742	18	0	\N
224131	2134	11665963000	29938	14742	19	0	\N
224132	2134	11664959000	29938	14742	20	0	\N
224133	2134	11663955000	29938	14742	21	0	\N
224134	2134	11662951000	29938	14742	22	0	\N
224135	2134	11661947000	29938	14742	23	0	\N
224136	2134	11660943000	29938	14742	24	0	\N
224137	2134	11659939000	29938	14742	25	0	\N
224138	2134	11658935000	29938	14742	26	0	\N
224139	2134	11657931000	29938	14742	27	0	\N
224140	2134	11656927000	29938	14742	28	0	\N
224141	2134	11655923000	29938	14742	29	0	\N
224142	2134	11654919000	29938	14742	30	0	\N
224143	2134	11653915000	29938	14742	31	0	\N
224144	2134	11652911000	29938	14742	33	0	\N
224145	2134	11651907000	29938	14742	34	0	\N
224146	1726	114118112000	29938	14742	35	0	\N
224147	1726	113017112000	29938	14742	36	0	\N
224148	2132	6753768000	29938	14742	37	0	\N
224149	2132	6752767000	29938	14742	38	0	\N
224150	2132	6751766000	29938	14742	39	0	\N
224151	2132	6750765000	29938	14742	40	0	\N
224152	2132	6749764000	29938	14742	41	0	\N
224153	2132	6748763000	29938	14742	42	0	\N
224154	2132	6747762000	29938	14742	43	0	\N
224155	2133	8412980000	29938	14742	44	0	\N
224156	2133	8411978000	29938	14742	45	0	\N
224157	2133	8410976000	29938	14742	46	0	\N
224158	2133	8409974000	29938	14742	47	0	\N
224159	2133	8408972000	29938	14742	48	0	\N
224160	2133	8407970000	29938	14742	49	0	\N
224161	2133	8406968000	29938	14742	50	0	\N
224162	2133	8405966000	29938	14742	51	0	\N
224163	2133	8404964000	29938	14742	52	0	\N
224164	2133	8403962000	29938	14742	53	0	\N
224165	2133	8402960000	29938	14742	54	0	\N
224184	1397	1257001835000	29945	14748	0	0	\N
224185	2132	6743758000	29945	14748	1	0	\N
224186	2134	11650903000	29945	14748	2	0	\N
224187	2134	11649899000	29945	14748	3	0	\N
224188	2133	8395946000	29945	14748	4	0	\N
224189	2133	8394944000	29945	14748	5	0	\N
224190	2134	11648895000	29945	14748	6	0	\N
224191	2134	11647891000	29945	14748	7	0	\N
224192	1397	1257001835000	29946	14749	0	0	\N
224193	1397	1256991834000	29946	14749	1	0	\N
224194	2134	11646887000	29946	14749	2	0	\N
224195	2132	6742757000	29946	14749	3	0	\N
224196	2132	6741756000	29946	14749	4	0	\N
224197	2133	8393942000	29946	14749	5	0	\N
224198	2133	8392940000	29946	14749	6	0	\N
224199	2133	8391938000	29946	14749	7	0	\N
224200	2134	11645883000	29946	14749	8	0	\N
224201	2134	11644879000	29946	14749	9	0	\N
224202	2134	11643875000	29946	14749	10	0	\N
224203	1397	1257001835000	29947	14749	0	0	\N
224204	1397	1256991834000	29947	14749	1	0	\N
224205	2134	11646887000	29947	14749	2	0	\N
224206	2132	6742757000	29947	14749	3	0	\N
224207	2133	8393942000	29947	14749	4	0	\N
224208	2133	8392940000	29947	14749	5	0	\N
224209	2133	8391938000	29947	14749	6	0	\N
224210	2134	11645883000	29947	14749	7	0	\N
224211	2134	11644879000	29947	14749	8	0	\N
224212	2134	11643875000	29947	14749	9	0	\N
224168	2133	8400956000	29939	14746	2	0	8025
224169	2132	6746761000	29939	14746	3	0	2241
224170	2133	8399954000	29939	14746	4	0	8026
224171	1397	1257011836000	29940	14747	0	0	18181
224172	2133	8398952000	29940	14747	1	0	8027
224174	2133	8397950000	29940	14747	3	0	8028
224175	2132	6744759000	29940	14747	4	0	2243
224176	2133	8396948000	29940	14747	5	0	8029
224177	2132	6743758000	29944	14748	0	0	2244
224178	2134	11650903000	29944	14748	1	0	8663
224180	2133	8395946000	29944	14748	3	0	8030
224181	2133	8394944000	29944	14748	4	0	8031
224182	2134	11648895000	29944	14748	5	0	8665
224183	2134	11647891000	29944	14748	6	0	8666
224214	1397	1256991834000	29948	14749	1	0	18183
224215	2134	11646887000	29948	14749	2	0	8667
224216	2132	6742757000	29948	14749	3	0	2245
224217	2132	6741756000	29948	14749	4	0	2246
224218	2133	8393942000	29948	14749	5	0	8032
224220	2133	8391938000	29948	14749	7	0	8034
224221	2134	11645883000	29948	14749	8	0	8668
224222	2134	11644879000	29948	14749	9	0	8669
224223	2134	11643875000	29948	14749	10	0	8670
224224	1397	1256981833000	29949	14750	0	0	18184
224226	2133	8389934000	29949	14750	2	0	8036
224227	2132	6740755000	29949	14750	3	0	2247
224228	2134	11642871000	29949	14750	4	0	8671
224229	2134	11641867000	29949	14750	5	0	8672
224231	2134	11639859000	29949	14750	7	0	8674
224232	2134	11638855000	29949	14750	8	0	8675
224233	1397	1256971832000	29950	14751	0	0	18185
224234	1397	1256961831000	29950	14751	1	0	18186
224235	2133	8388932000	29950	14751	2	0	8037
224237	2132	6738753000	29950	14751	4	0	2249
224238	2132	6737752000	29950	14751	5	0	2250
224239	2134	11637851000	29950	14751	6	0	8676
224240	2133	8387930000	29950	14751	7	0	8038
224241	2134	11636847000	29950	14751	8	0	8677
224243	2133	8386928000	29950	14751	10	0	8039
224244	2133	8385926000	29950	14751	11	0	8040
224245	2133	8384924000	29950	14751	12	0	8041
224246	2134	11634839000	29950	14751	13	0	8679
224248	2134	11632831000	29950	14751	15	0	8681
224249	2134	11631827000	29950	14751	16	0	8682
224250	2134	11630823000	29950	14751	17	0	8683
224251	2134	11629819000	29950	14751	18	0	8684
224252	1397	1256951830000	29951	14752	0	0	18187
224254	2132	6736751000	29951	14752	2	0	2251
224255	2134	11627811000	29951	14752	3	0	8686
224256	2134	11626807000	29951	14752	4	0	8687
224257	2133	8383922000	29951	14752	5	0	8042
224258	2133	8382920000	29951	14752	6	0	8043
224260	2132	6735750000	29951	14752	8	0	2252
224261	1397	1256941829000	29954	14753	0	0	18188
224262	2133	8381918000	29954	14753	1	0	8044
224263	2134	11624799000	29954	14753	2	0	8689
224271	1397	1256941829000	29955	14753	0	0	\N
224272	2133	8381918000	29955	14753	1	0	\N
224273	2134	11624799000	29955	14753	2	0	\N
224274	2134	11623795000	29955	14753	3	0	\N
224275	2134	11622791000	29955	14753	4	0	\N
224276	2133	8380916000	29955	14753	5	0	\N
224277	2132	6734749000	29955	14753	6	0	\N
224278	2133	8379914000	29955	14753	7	0	\N
224279	2134	11621787000	29955	14753	8	0	\N
224280	2134	11620783000	29955	14753	9	0	\N
224291	1397	1256931828000	29957	14754	0	0	\N
224292	2133	8378912000	29957	14754	1	0	\N
224293	2132	6733748000	29957	14754	3	0	\N
224294	2134	11619779000	29957	14754	4	0	\N
224295	2132	6732747000	29957	14754	5	0	\N
224296	2133	8377910000	29957	14754	6	0	\N
224297	2133	8376908000	29957	14754	7	0	\N
224298	2134	11618775000	29957	14754	8	0	\N
224299	2134	11617771000	29957	14754	9	0	\N
224300	2134	11616767000	29957	14754	10	0	\N
224301	1397	1256921827000	29958	14755	0	0	\N
224302	2134	11615763000	29958	14755	1	0	\N
224303	2134	11614759000	29958	14755	2	0	\N
224304	2133	8375906000	29958	14755	3	0	\N
224305	2133	8374904000	29958	14755	4	0	\N
224306	2132	6731746000	29958	14755	5	0	\N
224318	1397	1256901825000	29961	14757	0	0	\N
224319	2132	6729744000	29961	14757	1	0	\N
224320	2132	6728743000	29961	14757	2	0	\N
224321	2133	8370896000	29961	14757	3	0	\N
224322	2133	8369894000	29961	14757	4	0	\N
224328	1397	1256901825000	29963	14757	0	0	\N
224329	2132	6729744000	29963	14757	1	0	\N
224330	2132	6728743000	29963	14757	2	0	\N
224331	2133	8370896000	29963	14757	3	0	\N
224332	2133	8369894000	29963	14757	4	0	\N
224333	1397	1256901825000	29964	14757	0	0	\N
224334	2132	6729744000	29964	14757	1	0	\N
224335	2132	6728743000	29964	14757	2	0	\N
224336	2133	8370896000	29964	14757	3	0	\N
224337	2133	8369894000	29964	14757	4	0	\N
224355	1397	1256891824000	29966	14758	0	0	\N
224356	2134	11613755000	29966	14758	1	0	\N
224357	2132	6727742000	29966	14758	2	0	\N
224358	2133	8368892000	29966	14758	3	0	\N
224359	2133	8367890000	29966	14758	4	0	\N
224360	2134	11612751000	29966	14758	5	0	\N
224361	2134	11611747000	29966	14758	6	0	\N
224362	2134	11610743000	29966	14758	7	0	\N
224363	2134	11609739000	29966	14758	8	0	\N
224364	2134	11608735000	29966	14758	9	0	\N
224365	2134	11607731000	29966	14758	10	0	\N
224366	2134	11606727000	29966	14758	11	0	\N
224367	2134	11605723000	29966	14758	12	0	\N
224368	2134	11604719000	29966	14758	13	0	\N
224369	2134	11603715000	29966	14758	14	0	\N
224370	2134	11602711000	29966	14758	15	0	\N
224371	2134	11601707000	29966	14758	16	0	\N
224372	2134	11600703000	29966	14758	17	0	\N
224373	2134	11599699000	29966	14758	18	0	\N
224387	1397	1256881823000	29968	14759	0	0	\N
224388	2134	11600703000	29968	14759	1	0	\N
224389	2134	11599699000	29968	14759	2	0	\N
224390	2134	11598695000	29968	14759	3	0	\N
224391	2133	8366888000	29968	14759	4	0	\N
224392	2132	6726741000	29968	14759	5	0	\N
224393	2133	8365886000	29968	14759	6	0	\N
224394	2133	8364884000	29968	14759	7	0	\N
224395	2132	6725740000	29968	14759	8	0	\N
224396	2134	11597691000	29968	14759	9	0	\N
224397	2134	11596687000	29968	14759	10	0	\N
224398	2134	11595683000	29968	14759	11	0	\N
224399	2134	11594679000	29968	14759	12	0	\N
224400	1397	1256871822000	29969	14760	0	0	\N
224267	2132	6734749000	29954	14753	6	0	2253
224268	2133	8379914000	29954	14753	7	0	8046
224269	2134	11621787000	29954	14753	8	0	8692
224270	2134	11620783000	29954	14753	9	0	8693
224281	1397	1256931828000	29956	14754	0	0	18189
224283	2132	6733748000	29956	14754	3	0	2254
224284	2134	11619779000	29956	14754	4	0	8694
224285	2132	6732747000	29956	14754	5	0	2255
224286	2133	8377910000	29956	14754	6	0	8048
224287	2133	8376908000	29956	14754	7	0	8049
224289	2134	11617771000	29956	14754	9	0	8696
224290	2134	11616767000	29956	14754	10	0	8697
224307	1397	1256921827000	29959	14755	0	0	18190
224308	2134	11615763000	29959	14755	1	0	8698
224310	2133	8375906000	29959	14755	3	0	8050
224311	2133	8374904000	29959	14755	4	0	8051
224312	2133	8373902000	29959	14755	5	0	8052
224313	2132	6731746000	29959	14755	6	0	2256
224314	1397	1256911826000	29960	14756	0	0	18191
224316	2133	8371898000	29960	14756	2	0	8054
224317	2132	6730745000	29960	14756	3	0	2257
224323	1397	1256901825000	29962	14757	0	0	18192
224324	2132	6729744000	29962	14757	1	0	2258
224325	2132	6728743000	29962	14757	2	0	2259
224327	2133	8369894000	29962	14757	4	0	8056
224338	1397	1256891824000	29965	14758	0	0	18193
224339	2134	11613755000	29965	14758	1	0	8700
224340	2132	6727742000	29965	14758	2	0	2260
224342	2133	8367890000	29965	14758	4	0	8058
224343	2134	11612751000	29965	14758	5	0	8701
224344	2134	11611747000	29965	14758	6	0	8702
224345	2134	11610743000	29965	14758	7	0	8703
224346	2134	11609739000	29965	14758	8	0	8704
224348	2134	11607731000	29965	14758	10	0	8706
224349	2134	11606727000	29965	14758	11	0	8707
224350	2134	11605723000	29965	14758	12	0	8708
224351	2134	11604719000	29965	14758	13	0	8709
224352	2134	11603715000	29965	14758	14	0	8710
224354	2134	11601707000	29965	14758	16	0	8712
224374	1397	1256881823000	29967	14759	0	0	18194
224375	2134	11600703000	29967	14759	1	0	8713
224376	2134	11599699000	29967	14759	2	0	8714
224378	2133	8366888000	29967	14759	4	0	8059
224379	2132	6726741000	29967	14759	5	0	2261
224380	2133	8365886000	29967	14759	6	0	8060
224381	2133	8364884000	29967	14759	7	0	8061
224382	2132	6725740000	29967	14759	8	0	2262
224384	2134	11596687000	29967	14759	10	0	8717
224385	2134	11595683000	29967	14759	11	0	8718
224386	2134	11594679000	29967	14759	12	0	8719
224401	2133	8363882000	29969	14760	1	0	\N
224402	2134	11593675000	29969	14760	2	0	\N
224403	2132	6724739000	29969	14760	3	0	\N
224404	2134	11592671000	29969	14760	4	0	\N
224405	2134	11591667000	29969	14760	5	0	\N
224406	2134	11590663000	29969	14760	6	0	\N
224407	2133	8362880000	29969	14760	7	0	\N
224408	2133	8361878000	29969	14760	8	0	\N
224409	1397	1256871822000	29970	14760	0	0	\N
224410	2133	8363882000	29970	14760	1	0	\N
224411	2134	11593675000	29970	14760	2	0	\N
224412	2132	6724739000	29970	14760	3	0	\N
224413	2134	11592671000	29970	14760	4	0	\N
224414	2134	11591667000	29970	14760	5	0	\N
224415	2134	11590663000	29970	14760	6	0	\N
224416	2133	8362880000	29970	14760	7	0	\N
224417	2133	8361878000	29970	14760	8	0	\N
224427	1397	1256871822000	29972	14760	0	0	\N
224428	2133	8363882000	29972	14760	1	0	\N
224429	2134	11593675000	29972	14760	2	0	\N
224430	2132	6724739000	29972	14760	3	0	\N
224431	2134	11592671000	29972	14760	4	0	\N
224432	2134	11591667000	29972	14760	5	0	\N
224433	2134	11590663000	29972	14760	6	0	\N
224434	2133	8362880000	29972	14760	7	0	\N
224435	2133	8361878000	29972	14760	8	0	\N
224436	1397	1256871822000	29973	14760	0	0	\N
224437	2133	8363882000	29973	14760	1	0	\N
224438	2132	6724739000	29973	14760	2	0	\N
224439	2133	8362880000	29973	14760	3	0	\N
224440	2133	8361878000	29973	14760	4	0	\N
224441	1397	1256861821000	29974	14761	0	0	\N
224442	1397	1256851820000	29974	14761	1	0	\N
224443	2133	8360876000	29974	14761	2	0	\N
224444	2133	8359874000	29974	14761	3	0	\N
224445	2133	8358872000	29974	14761	4	0	\N
224446	2134	11589659000	29974	14761	5	0	\N
224447	2134	11588655000	29974	14761	6	0	\N
224448	2134	11587651000	29974	14761	7	0	\N
224449	2134	11586647000	29974	14761	8	0	\N
224450	2132	6723738000	29974	14761	9	0	\N
224451	2132	6722737000	29974	14761	10	0	\N
224452	2132	6721736000	29974	14761	11	0	\N
224453	2134	11585643000	29974	14761	12	0	\N
224454	2134	11584639000	29974	14761	13	0	\N
224455	2134	11583635000	29974	14761	14	0	\N
224456	2134	11582631000	29974	14761	15	0	\N
224457	2134	11581627000	29974	14761	16	0	\N
224458	2133	8357870000	29974	14761	17	0	\N
224477	1397	1256861821000	29976	14761	0	0	\N
224478	1397	1256851820000	29976	14761	1	0	\N
224479	2133	8360876000	29976	14761	2	0	\N
224480	2133	8359874000	29976	14761	3	0	\N
224481	2133	8358872000	29976	14761	4	0	\N
224482	2132	6723738000	29976	14761	5	0	\N
224483	2132	6722737000	29976	14761	6	0	\N
224484	2132	6721736000	29976	14761	7	0	\N
224485	2133	8357870000	29976	14761	8	0	\N
224486	1397	1256841819000	29977	14762	0	0	\N
224487	1397	1256831818000	29977	14762	1	0	\N
224488	2134	11580623000	29977	14762	2	0	\N
224489	2133	8356868000	29977	14762	3	0	\N
224490	2133	8355866000	29977	14762	4	0	\N
224491	2132	6720735000	29977	14762	5	0	\N
224492	2133	8354864000	29977	14762	6	0	\N
224493	2133	8353862000	29977	14762	7	0	\N
224494	2133	8352860000	29977	14762	8	0	\N
224495	2133	8351858000	29977	14762	9	0	\N
224496	2132	6719734000	29977	14762	10	0	\N
224497	2132	6718733000	29977	14762	11	0	\N
224498	2134	11579619000	29977	14762	12	0	\N
224499	2134	11578615000	29977	14762	13	0	\N
224500	2134	11577611000	29977	14762	14	0	\N
224501	2134	11576607000	29977	14762	15	0	\N
224502	2134	11575603000	29977	14762	16	0	\N
224503	2134	11574599000	29977	14762	17	0	\N
224504	2134	11573595000	29977	14762	18	0	\N
224505	2134	11572591000	29977	14762	19	0	\N
224420	2134	11593675000	29971	14760	2	0	8720
224421	2132	6724739000	29971	14760	3	0	2263
224422	2134	11592671000	29971	14760	4	0	8721
224423	2134	11591667000	29971	14760	5	0	8722
224424	2134	11590663000	29971	14760	6	0	8723
224426	2133	8361878000	29971	14760	8	0	8064
224459	1397	1256861821000	29975	14761	0	0	18196
224460	1397	1256851820000	29975	14761	1	0	18197
224461	2133	8360876000	29975	14761	2	0	8065
224462	2133	8359874000	29975	14761	3	0	8066
224464	2134	11589659000	29975	14761	5	0	8724
224465	2134	11588655000	29975	14761	6	0	8725
224466	2134	11587651000	29975	14761	7	0	8726
224467	2134	11586647000	29975	14761	8	0	8727
224469	2132	6722737000	29975	14761	10	0	2265
224470	2132	6721736000	29975	14761	11	0	2266
224471	2134	11585643000	29975	14761	12	0	8728
224472	2134	11584639000	29975	14761	13	0	8729
224473	2134	11583635000	29975	14761	14	0	8730
224475	2134	11581627000	29975	14761	16	0	8732
224476	2133	8357870000	29975	14761	17	0	8068
224506	1397	1256841819000	29978	14762	0	0	18198
224507	1397	1256831818000	29978	14762	1	0	18199
224508	2134	11580623000	29978	14762	2	0	8733
224510	2133	8355866000	29978	14762	4	0	8070
224511	2132	6720735000	29978	14762	5	0	2267
224512	2133	8354864000	29978	14762	6	0	8071
224513	2133	8353862000	29978	14762	7	0	8072
224515	2133	8351858000	29978	14762	9	0	8074
224516	2132	6719734000	29978	14762	10	0	2268
224517	2132	6718733000	29978	14762	11	0	2269
224518	2134	11579619000	29978	14762	12	0	8734
224519	2134	11578615000	29978	14762	13	0	8735
224521	2134	11576607000	29978	14762	15	0	8737
224522	2134	11575603000	29978	14762	16	0	8738
224523	2134	11574599000	29978	14762	17	0	8739
224524	2134	11573595000	29978	14762	18	0	8740
224525	2134	11572591000	29978	14762	19	0	8741
224527	1397	1256811816000	29979	14763	1	0	18201
224528	2133	8350856000	29979	14763	2	0	8075
224529	2132	6717732000	29979	14763	4	0	2270
224530	2132	6716731000	29979	14763	5	0	2271
224532	2134	11571587000	29979	14763	7	0	8742
224533	2134	11570583000	29979	14763	8	0	8743
224534	2134	11569579000	29979	14763	9	0	8744
224535	2134	11568575000	29979	14763	10	0	8745
224536	2134	11567571000	29979	14763	11	0	8746
224545	1397	1256801815000	29980	14764	0	0	\N
224546	2134	11562551000	29980	14764	1	0	\N
224547	2133	8345846000	29980	14764	2	0	\N
224548	2133	8344844000	29980	14764	3	0	\N
224549	2133	8343842000	29980	14764	4	0	\N
224550	2132	6714729000	29980	14764	5	0	\N
224551	2134	11561547000	29980	14764	6	0	\N
224552	2134	11560543000	29980	14764	7	0	\N
224553	2134	11559539000	29980	14764	8	0	\N
224554	2132	6713728000	29980	14764	9	0	\N
224555	1397	1256801815000	29981	14764	0	0	\N
224556	2134	11562551000	29981	14764	1	0	\N
224557	2133	8345846000	29981	14764	2	0	\N
224558	2133	8344844000	29981	14764	3	0	\N
224559	2132	6714729000	29981	14764	4	0	\N
224560	2134	11561547000	29981	14764	5	0	\N
224561	2134	11560543000	29981	14764	6	0	\N
224562	2134	11559539000	29981	14764	7	0	\N
224563	2132	6713728000	29981	14764	8	0	\N
224574	1397	1256791814000	29983	14765	0	0	\N
224575	1397	1256781813000	29983	14765	1	0	\N
224576	2134	11558535000	29983	14765	2	0	\N
224577	2133	8342840000	29983	14765	3	0	\N
224578	2133	8341838000	29983	14765	4	0	\N
224579	2133	8340836000	29983	14765	5	0	\N
224580	2132	6712727000	29983	14765	6	0	\N
224581	2132	6711726000	29983	14765	7	0	\N
224582	2132	6710725000	29983	14765	8	0	\N
224583	2133	8339834000	29983	14765	9	0	\N
224584	2133	8338832000	29983	14765	10	0	\N
224585	2134	11557531000	29983	14765	11	0	\N
224586	2134	11556527000	29983	14765	12	0	\N
224587	2134	11555523000	29983	14765	13	0	\N
224588	2134	11554519000	29983	14765	14	0	\N
224589	2134	11553515000	29983	14765	15	0	\N
224590	2134	11552511000	29983	14765	16	0	\N
224591	2134	11551507000	29983	14765	17	0	\N
224592	2134	11550503000	29983	14765	18	0	\N
224612	1397	1256791814000	29985	14765	0	0	\N
224613	1397	1256781813000	29985	14765	1	0	\N
224614	2134	11558535000	29985	14765	2	0	\N
224615	2133	8342840000	29985	14765	3	0	\N
224616	2133	8341838000	29985	14765	4	0	\N
224617	2133	8340836000	29985	14765	5	0	\N
224618	2132	6712727000	29985	14765	6	0	\N
224619	2132	6711726000	29985	14765	7	0	\N
224620	2132	6710725000	29985	14765	8	0	\N
224621	2133	8339834000	29985	14765	9	0	\N
224622	2133	8338832000	29985	14765	10	0	\N
224623	2134	11557531000	29985	14765	11	0	\N
224624	2134	11556527000	29985	14765	12	0	\N
224625	2134	11555523000	29985	14765	13	0	\N
224626	2134	11554519000	29985	14765	14	0	\N
224627	2134	11553515000	29985	14765	15	0	\N
224628	2134	11552511000	29985	14765	16	0	\N
224629	2134	11551507000	29985	14765	17	0	\N
224630	2134	11550503000	29985	14765	18	0	\N
224631	1397	1256971832000	29986	14751	0	0	\N
224632	1397	1256961831000	29986	14751	1	0	\N
224633	1397	1256951830000	29986	14751	2	0	\N
224634	1397	1256941829000	29986	14751	3	0	\N
224635	1397	1256931828000	29986	14751	4	0	\N
224636	1397	1256921827000	29986	14751	5	0	\N
224637	1397	1256911826000	29986	14751	6	0	\N
224638	1397	1256901825000	29986	14751	7	0	\N
224639	1397	1256891824000	29986	14751	8	0	\N
224640	1397	1256881823000	29986	14751	9	0	\N
224641	1397	1256871822000	29986	14751	10	0	\N
224642	1397	1256861821000	29986	14751	11	0	\N
224643	1397	1256851820000	29986	14751	12	0	\N
224644	1397	1256841819000	29986	14751	13	0	\N
224645	1397	1256831818000	29986	14751	14	0	\N
224646	1397	1256821817000	29986	14751	15	0	\N
224647	1397	1256811816000	29986	14751	16	0	\N
224648	1397	1256801815000	29986	14751	17	0	\N
224649	1397	1256791814000	29986	14751	18	0	\N
224650	1397	1256781813000	29986	14751	19	0	\N
224651	2133	8388932000	29986	14751	20	0	\N
224652	2132	6739754000	29986	14751	21	0	\N
224653	2132	6738753000	29986	14751	22	0	\N
224654	2132	6737752000	29986	14751	23	0	\N
224655	2132	6736751000	29986	14751	24	0	\N
224656	2134	11637851000	29986	14751	25	0	\N
224657	2133	8387930000	29986	14751	26	0	\N
224658	2134	11636847000	29986	14751	27	0	\N
224659	2134	11635843000	29986	14751	28	0	\N
224660	2133	8386928000	29986	14751	29	0	\N
224661	2133	8385926000	29986	14751	30	0	\N
224662	2133	8384924000	29986	14751	31	0	\N
224663	2133	8383922000	29986	14751	32	0	\N
224664	2133	8382920000	29986	14751	33	0	\N
224665	2133	8381918000	29986	14751	34	0	\N
224666	2133	8380916000	29986	14751	35	0	\N
224667	2133	8379914000	29986	14751	36	0	\N
224668	2133	8378912000	29986	14751	37	0	\N
224669	2133	8377910000	29986	14751	38	0	\N
224670	2133	8376908000	29986	14751	39	0	\N
224671	2133	8375906000	29986	14751	40	0	\N
224672	2133	8374904000	29986	14751	41	0	\N
224539	2134	11564559000	29979	14763	14	0	8749
224540	2134	11563555000	29979	14763	15	0	8750
224541	2132	6715730000	29979	14763	16	0	2272
224542	2133	8348852000	29979	14763	17	0	8077
224543	2133	8347850000	29979	14763	18	0	8078
224564	1397	1256801815000	29982	14764	0	0	18202
224565	2134	11562551000	29982	14764	1	0	8751
224566	2133	8345846000	29982	14764	2	0	8080
224567	2133	8344844000	29982	14764	3	0	8081
224568	2133	8343842000	29982	14764	4	0	8082
224570	2134	11561547000	29982	14764	6	0	8752
224571	2134	11560543000	29982	14764	7	0	8753
224572	2134	11559539000	29982	14764	8	0	8754
224573	2132	6713728000	29982	14764	9	0	2274
224594	1397	1256781813000	29984	14765	1	0	18204
224595	2134	11558535000	29984	14765	2	0	8755
224596	2133	8342840000	29984	14765	3	0	8083
224597	2133	8341838000	29984	14765	4	0	8084
224598	2133	8340836000	29984	14765	5	0	8085
224600	2132	6711726000	29984	14765	7	0	2276
224601	2132	6710725000	29984	14765	8	0	2277
224602	2133	8339834000	29984	14765	9	0	8086
224603	2133	8338832000	29984	14765	10	0	8087
224604	2134	11557531000	29984	14765	11	0	8756
224606	2134	11555523000	29984	14765	13	0	8758
224607	2134	11554519000	29984	14765	14	0	8759
224608	2134	11553515000	29984	14765	15	0	8760
224609	2134	11552511000	29984	14765	16	0	8761
224611	2134	11550503000	29984	14765	18	0	8763
224673	2133	8373902000	29986	14751	42	0	\N
224674	2133	8372900000	29986	14751	43	0	\N
224675	2133	8371898000	29986	14751	44	0	\N
224676	2133	8370896000	29986	14751	45	0	\N
224677	2133	8369894000	29986	14751	47	0	\N
224678	2133	8368892000	29986	14751	48	0	\N
224679	2133	8367890000	29986	14751	49	0	\N
224680	2133	8366888000	29986	14751	50	0	\N
224681	2133	8365886000	29986	14751	51	0	\N
224682	2133	8364884000	29986	14751	52	0	\N
224683	2133	8363882000	29986	14751	53	0	\N
224684	2134	11634839000	29986	14751	54	0	\N
224685	2134	11633835000	29986	14751	55	0	\N
224686	2134	11632831000	29986	14751	56	0	\N
224687	2134	11631827000	29986	14751	57	0	\N
224688	2134	11630823000	29986	14751	58	0	\N
224689	2134	11629819000	29986	14751	59	0	\N
224690	2134	11628815000	29986	14751	60	0	\N
224691	2134	11627811000	29986	14751	61	0	\N
224692	2134	11626807000	29986	14751	62	0	\N
224693	2134	11625803000	29986	14751	63	0	\N
224694	2134	11624799000	29986	14751	64	0	\N
224695	2134	11623795000	29986	14751	65	0	\N
224696	2134	11622791000	29986	14751	66	0	\N
224697	2133	8362880000	29986	14751	67	0	\N
224698	2133	8361878000	29986	14751	68	0	\N
224699	2133	8360876000	29986	14751	69	0	\N
224700	2133	8359874000	29986	14751	70	0	\N
224701	2133	8358872000	29986	14751	71	0	\N
224702	2133	8357870000	29986	14751	72	0	\N
224703	2133	8356868000	29986	14751	73	0	\N
224704	2133	8355866000	29986	14751	74	0	\N
224705	2133	8354864000	29986	14751	75	0	\N
224706	2133	8353862000	29986	14751	76	0	\N
224707	2133	8352860000	29986	14751	77	0	\N
224708	2133	8351858000	29986	14751	78	0	\N
224709	2133	8350856000	29986	14751	79	0	\N
224710	2133	8349854000	29986	14751	80	0	\N
224711	2134	11621787000	29986	14751	81	0	\N
224712	2134	11620783000	29986	14751	82	0	\N
224713	2134	11619779000	29986	14751	83	0	\N
224714	2134	11618775000	29986	14751	84	0	\N
224715	2134	11617771000	29986	14751	85	0	\N
224716	2134	11616767000	29986	14751	86	0	\N
224717	2134	11615763000	29986	14751	87	0	\N
224718	2134	11614759000	29986	14751	88	0	\N
224719	2134	11613755000	29986	14751	89	0	\N
224720	2134	11612751000	29986	14751	90	0	\N
224721	2134	11611747000	29986	14751	91	0	\N
224722	2134	11610743000	29986	14751	92	0	\N
224723	2134	11609739000	29986	14751	93	0	\N
224724	2134	11608735000	29986	14751	94	0	\N
224725	2134	11607731000	29986	14751	95	0	\N
224726	2134	11606727000	29986	14751	96	0	\N
224727	2134	11605723000	29986	14751	97	0	\N
224728	2134	11604719000	29986	14751	98	0	\N
224729	2134	11603715000	29986	14751	99	0	\N
224730	2134	11602711000	29986	14751	100	0	\N
224731	2134	11601707000	29986	14751	101	0	\N
224732	2134	11600703000	29986	14751	102	0	\N
224733	2134	11599699000	29986	14751	103	0	\N
224734	2134	11598695000	29986	14751	104	0	\N
224735	2134	11597691000	29986	14751	105	0	\N
224736	2134	11596687000	29986	14751	106	0	\N
224737	2134	11595683000	29986	14751	107	0	\N
224738	2134	11594679000	29986	14751	108	0	\N
224739	2134	11593675000	29986	14751	109	0	\N
224740	2134	11592671000	29986	14751	110	0	\N
224741	2134	11591667000	29986	14751	111	0	\N
224742	2134	11590663000	29986	14751	112	0	\N
224743	2134	11589659000	29986	14751	113	0	\N
224744	2134	11588655000	29986	14751	114	0	\N
224745	2134	11587651000	29986	14751	115	0	\N
224746	2134	11586647000	29986	14751	116	0	\N
224747	2134	11585643000	29986	14751	117	0	\N
224748	2134	11584639000	29986	14751	118	0	\N
224749	2134	11583635000	29986	14751	119	0	\N
224750	2134	11582631000	29986	14751	120	0	\N
224751	2134	11581627000	29986	14751	121	0	\N
224752	1397	1256771812000	29987	14766	0	0	\N
224753	1397	1256761811000	29987	14766	1	0	\N
224754	2132	6709724000	29987	14766	2	0	\N
224755	2134	11549499000	29987	14766	3	0	\N
224756	2134	11548495000	29987	14766	4	0	\N
224757	2134	11547491000	29987	14766	5	0	\N
224758	2132	6708723000	29987	14766	6	0	\N
224759	2134	11546487000	29987	14766	7	0	\N
224760	2134	11545483000	29987	14766	8	0	\N
224761	2134	11544479000	29987	14766	9	0	\N
224762	2133	8337830000	29987	14766	10	0	\N
224763	2133	8336828000	29987	14766	11	0	\N
224764	2133	8335826000	29987	14766	12	0	\N
224765	2133	8334824000	29987	14766	13	0	\N
224766	2133	8333822000	29987	14766	14	0	\N
224767	2132	6707722000	29987	14766	15	0	\N
224768	2134	11543475000	29987	14766	16	0	\N
224769	2134	11542471000	29987	14766	17	0	\N
224770	2134	11541467000	29987	14766	18	0	\N
224785	1397	1256771812000	29989	14766	0	0	\N
224786	1397	1256761811000	29989	14766	1	0	\N
224787	2132	6709724000	29989	14766	2	0	\N
224788	2134	11549499000	29989	14766	3	0	\N
224789	2134	11548495000	29989	14766	4	0	\N
224790	2134	11547491000	29989	14766	5	0	\N
224791	2132	6708723000	29989	14766	6	0	\N
224792	2134	11546487000	29989	14766	7	0	\N
224793	2134	11545483000	29989	14766	8	0	\N
224794	2134	11544479000	29989	14766	9	0	\N
224795	2133	8337830000	29989	14766	10	0	\N
224796	2133	8336828000	29989	14766	11	0	\N
224797	2133	8335826000	29989	14766	12	0	\N
224798	2133	8334824000	29989	14766	13	0	\N
224799	2133	8333822000	29989	14766	14	0	\N
224800	2132	6707722000	29989	14766	15	0	\N
224801	2134	11543475000	29989	14766	16	0	\N
224802	2134	11542471000	29989	14766	17	0	\N
224803	2134	11541467000	29989	14766	18	0	\N
224773	2132	6709724000	29988	14766	2	0	2278
224774	2134	11549499000	29988	14766	3	0	8764
224775	2134	11548495000	29988	14766	4	0	8765
224776	2134	11547491000	29988	14766	5	0	8766
224777	2132	6708723000	29988	14766	6	0	2279
224779	2134	11545483000	29988	14766	8	0	8768
224780	2134	11544479000	29988	14766	9	0	8769
224781	2132	6707722000	29988	14766	10	0	2280
224782	2134	11543475000	29988	14766	11	0	8770
224783	2134	11542471000	29988	14766	12	0	8771
224804	1397	1256751810000	29990	14767	0	0	18207
224805	2132	6706721000	29990	14767	1	0	2281
224806	2134	11540463000	29990	14767	2	0	8773
224807	2134	11539459000	29990	14767	3	0	8774
224818	1397	1256751810000	29991	14767	0	0	\N
224819	2132	6706721000	29991	14767	1	0	\N
224820	2134	11540463000	29991	14767	2	0	\N
224821	2134	11539459000	29991	14767	3	0	\N
224822	2133	8337830000	29991	14767	4	0	\N
224823	2133	8336828000	29991	14767	5	0	\N
224824	2133	8335826000	29991	14767	6	0	\N
224825	2133	8334824000	29991	14767	7	0	\N
224826	2133	8333822000	29991	14767	8	0	\N
224827	2133	8332820000	29991	14767	9	0	\N
224828	2133	8331818000	29991	14767	10	0	\N
224829	2134	11538455000	29991	14767	11	0	\N
224830	2134	11537451000	29991	14767	12	0	\N
224831	2134	11536447000	29991	14767	13	0	\N
224842	1397	1256731808000	29993	14769	0	0	\N
224843	2134	11531427000	29993	14769	1	0	\N
224844	2132	6703718000	29993	14769	2	0	\N
224845	2134	11530423000	29993	14769	3	0	\N
224846	2134	11529419000	29993	14769	4	0	\N
224847	2134	11528415000	29993	14769	5	0	\N
224848	2134	11527411000	29993	14769	6	0	\N
224866	1397	1256721807000	29996	14770	0	0	\N
224867	2134	11526407000	29996	14770	1	0	\N
224868	2134	11525403000	29996	14770	2	0	\N
224869	2132	6702717000	29996	14770	3	0	\N
224870	2134	11524399000	29996	14770	4	0	\N
224871	2134	11523395000	29996	14770	5	0	\N
224872	1397	1256721807000	29997	14770	0	0	\N
224873	2134	11526407000	29997	14770	1	0	\N
224874	2134	11525403000	29997	14770	2	0	\N
224875	2133	8325806000	29997	14770	3	0	\N
224876	2133	8324804000	29997	14770	4	0	\N
224877	2132	6702717000	29997	14770	5	0	\N
224878	2134	11524399000	29997	14770	6	0	\N
224879	2134	11523395000	29997	14770	7	0	\N
224899	1397	1256711806000	29999	14771	0	0	\N
224900	1397	1256701805000	29999	14771	1	0	\N
224901	2134	11522391000	29999	14771	2	0	\N
224902	2134	11521387000	29999	14771	3	0	\N
224903	2134	11520383000	29999	14771	4	0	\N
224904	2132	6701716000	29999	14771	5	0	\N
224905	2132	6700715000	29999	14771	6	0	\N
224906	2134	11519379000	29999	14771	8	0	\N
224907	2134	11518375000	29999	14771	9	0	\N
224908	2133	8323802000	29999	14771	10	0	\N
224909	2134	11517371000	29999	14771	11	0	\N
224910	2134	11516367000	29999	14771	12	0	\N
224911	2134	11515363000	29999	14771	13	0	\N
224912	2132	6699714000	29999	14771	14	0	\N
224913	2133	8322800000	29999	14771	15	0	\N
224914	2133	8321798000	29999	14771	16	0	\N
224915	2133	8320796000	29999	14771	17	0	\N
224916	2133	8319794000	29999	14771	18	0	\N
224917	2134	11514359000	29999	14771	19	0	\N
224928	1397	1257101845000	30001	14734	0	0	\N
224929	1397	1257091844000	30001	14734	1	0	\N
224930	1397	1257081843000	30001	14734	2	0	\N
224931	1397	1257071842000	30001	14734	3	0	\N
224932	1397	1257061841000	30001	14734	4	0	\N
224933	1397	1257051840000	30001	14734	5	0	\N
224934	1397	1257041839000	30001	14734	6	0	\N
224935	1397	1257031838000	30001	14734	7	0	\N
224936	1397	1257021837000	30001	14734	8	0	\N
224937	1397	1257011836000	30001	14734	9	0	\N
224938	1397	1257001835000	30001	14734	10	0	\N
224939	1397	1256991834000	30001	14734	11	0	\N
224940	1397	1256981833000	30001	14734	12	0	\N
224941	1397	1256971832000	30001	14734	13	0	\N
224942	1397	1256961831000	30001	14734	14	0	\N
224943	1397	1256951830000	30001	14734	15	0	\N
224944	1397	1256941829000	30001	14734	16	0	\N
224811	2133	8334824000	29990	14767	7	0	8091
224812	2133	8333822000	29990	14767	8	0	8092
224813	2133	8332820000	29990	14767	9	0	8093
224814	2133	8331818000	29990	14767	10	0	8094
224815	2134	11538455000	29990	14767	11	0	8775
224817	2134	11536447000	29990	14767	13	0	8777
224832	1397	1256741809000	29992	14768	0	0	18208
224833	2134	11535443000	29992	14768	1	0	8778
224834	2134	11534439000	29992	14768	2	0	8779
224835	2134	11533435000	29992	14768	3	0	8780
224837	2133	8329814000	29992	14768	5	0	8096
224838	2133	8328812000	29992	14768	6	0	8097
224839	2132	6705720000	29992	14768	7	0	2282
224840	2134	11532431000	29992	14768	8	0	8781
224849	1397	1256731808000	29994	14769	0	0	18209
224850	2134	11531427000	29994	14769	1	0	8782
224851	2133	8327810000	29994	14769	2	0	8098
224852	2132	6703718000	29994	14769	3	0	2284
224853	2133	8326808000	29994	14769	4	0	8099
224855	2134	11529419000	29994	14769	6	0	8784
224856	2134	11528415000	29994	14769	7	0	8785
224857	2134	11527411000	29994	14769	8	0	8786
224858	1397	1256721807000	29995	14770	0	0	18210
224859	2134	11526407000	29995	14770	1	0	8787
224861	2133	8325806000	29995	14770	3	0	8100
224862	2133	8324804000	29995	14770	4	0	8101
224863	2132	6702717000	29995	14770	5	0	2285
224864	2134	11524399000	29995	14770	6	0	8789
224880	1397	1256711806000	29998	14771	0	0	18211
224881	1397	1256701805000	29998	14771	1	0	18212
224882	2134	11522391000	29998	14771	2	0	8791
224883	2134	11521387000	29998	14771	3	0	8792
224884	2134	11520383000	29998	14771	4	0	8793
224886	2132	6700715000	29998	14771	6	0	2287
224887	2134	11519379000	29998	14771	8	0	8794
224888	2134	11518375000	29998	14771	9	0	8795
224889	2133	8323802000	29998	14771	10	0	8102
224890	2134	11517371000	29998	14771	11	0	8796
224892	2134	11515363000	29998	14771	13	0	8798
224893	2132	6699714000	29998	14771	14	0	2288
224894	2133	8322800000	29998	14771	15	0	8103
224895	2133	8321798000	29998	14771	16	0	8104
224897	2133	8319794000	29998	14771	18	0	8106
224898	2134	11514359000	29998	14771	19	0	8799
224918	1397	1256691804000	30000	14772	0	0	18213
224919	2133	8318792000	30000	14772	1	0	8107
224920	2133	8317790000	30000	14772	2	0	8108
224922	2132	6698713000	30000	14772	4	0	2289
224923	2134	11512351000	30000	14772	5	0	8801
224924	2134	11511347000	30000	14772	6	0	8802
224925	2134	11510343000	30000	14772	7	0	8803
224926	2132	6697712000	30000	14772	8	0	2290
224945	1397	1256931828000	30001	14734	17	0	\N
224946	1397	1256921827000	30001	14734	18	0	\N
224947	1397	1256911826000	30001	14734	19	0	\N
224948	1397	1256901825000	30001	14734	20	0	\N
224949	1397	1256891824000	30001	14734	21	0	\N
224950	1397	1256881823000	30001	14734	22	0	\N
224951	1397	1256871822000	30001	14734	23	0	\N
224952	1397	1256861821000	30001	14734	24	0	\N
224953	1397	1256851820000	30001	14734	25	0	\N
224954	1397	1256841819000	30001	14734	26	0	\N
224955	1397	1256831818000	30001	14734	27	0	\N
224956	1397	1256821817000	30001	14734	28	0	\N
224957	1397	1256811816000	30001	14734	29	0	\N
224958	1397	1256801815000	30001	14734	30	0	\N
224959	1397	1256791814000	30001	14734	31	0	\N
224960	1397	1256781813000	30001	14734	32	0	\N
224961	1397	1256771812000	30001	14734	33	0	\N
224962	1397	1256761811000	30001	14734	34	0	\N
224963	1397	1256751810000	30001	14734	35	0	\N
224964	1397	1256741809000	30001	14734	36	0	\N
224965	1397	1256731808000	30001	14734	37	0	\N
224966	1397	1256721807000	30001	14734	38	0	\N
224967	1397	1256711806000	30001	14734	39	0	\N
224968	1397	1256701805000	30001	14734	40	0	\N
224969	1397	1256691804000	30001	14734	41	0	\N
224970	2132	6758773000	30001	14734	42	0	\N
224971	2133	8421998000	30001	14734	43	0	\N
224972	2133	8420996000	30001	14734	44	0	\N
224973	2133	8419994000	30001	14734	45	0	\N
224974	2133	8418992000	30001	14734	46	0	\N
224975	2133	8417990000	30001	14734	47	0	\N
224976	2134	11670983000	30001	14734	48	0	\N
224977	2132	6757772000	30001	14734	49	0	\N
224978	2132	6756771000	30001	14734	50	0	\N
224979	2132	6755770000	30001	14734	51	0	\N
224980	2132	6754769000	30001	14734	52	0	\N
224981	2133	8416988000	30001	14734	53	0	\N
224982	2133	8415986000	30001	14734	56	0	\N
224983	2133	8414984000	30001	14734	57	0	\N
224984	2133	8413982000	30001	14734	58	0	\N
224985	1726	114118112000	30001	14734	59	0	\N
224986	1726	113017112000	30001	14734	60	0	\N
224987	2132	6753768000	30001	14734	61	0	\N
224988	2132	6752767000	30001	14734	62	0	\N
224989	2132	6751766000	30001	14734	63	0	\N
224990	2132	6750765000	30001	14734	64	0	\N
224991	2132	6749764000	30001	14734	65	0	\N
224992	2132	6748763000	30001	14734	66	0	\N
224993	2132	6747762000	30001	14734	67	0	\N
224994	2132	6746761000	30001	14734	68	0	\N
224995	2132	6745760000	30001	14734	69	0	\N
224996	2132	6744759000	30001	14734	70	0	\N
224997	2132	6743758000	30001	14734	71	0	\N
224998	2132	6742757000	30001	14734	72	0	\N
224999	2132	6741756000	30001	14734	73	0	\N
225000	2132	6740755000	30001	14734	74	0	\N
225001	2132	6739754000	30001	14734	75	0	\N
225002	2132	6738753000	30001	14734	76	0	\N
225003	2132	6737752000	30001	14734	77	0	\N
225004	2132	6736751000	30001	14734	78	0	\N
225005	2134	11669979000	30001	14734	79	0	\N
225006	2134	11668975000	30001	14734	80	0	\N
225007	2134	11667971000	30001	14734	81	0	\N
225008	2134	11666967000	30001	14734	82	0	\N
225009	2134	11665963000	30001	14734	83	0	\N
225010	2134	11664959000	30001	14734	84	0	\N
225011	2134	11663955000	30001	14734	85	0	\N
225012	2134	11662951000	30001	14734	86	0	\N
225013	2134	11661947000	30001	14734	87	0	\N
225014	2134	11660943000	30001	14734	88	0	\N
225015	2134	11659939000	30001	14734	89	0	\N
225016	2134	11658935000	30001	14734	90	0	\N
225017	2134	11657931000	30001	14734	91	0	\N
225018	2134	11656927000	30001	14734	92	0	\N
225019	2134	11655923000	30001	14734	93	0	\N
225020	2134	11654919000	30001	14734	94	0	\N
225021	2134	11653915000	30001	14734	95	0	\N
225022	2134	11652911000	30001	14734	96	0	\N
225023	2134	11651907000	30001	14734	97	0	\N
225024	2134	11650903000	30001	14734	98	0	\N
225025	2134	11649899000	30001	14734	99	0	\N
225026	2134	11648895000	30001	14734	100	0	\N
225027	2134	11647891000	30001	14734	101	0	\N
225028	2134	11646887000	30001	14734	102	0	\N
225029	2134	11645883000	30001	14734	103	0	\N
225030	2134	11644879000	30001	14734	104	0	\N
225031	2134	11643875000	30001	14734	105	0	\N
225032	2134	11642871000	30001	14734	106	0	\N
225033	2134	11641867000	30001	14734	107	0	\N
225034	2134	11640863000	30001	14734	108	0	\N
225035	2134	11639859000	30001	14734	109	0	\N
225036	2134	11638855000	30001	14734	110	0	\N
225037	2134	11637851000	30001	14734	111	0	\N
225038	2134	11636847000	30001	14734	112	0	\N
225039	2134	11635843000	30001	14734	113	0	\N
225040	2134	11634839000	30001	14734	114	0	\N
225041	2134	11633835000	30001	14734	115	0	\N
225042	2134	11632831000	30001	14734	116	0	\N
225043	2134	11631827000	30001	14734	117	0	\N
225044	2134	11630823000	30001	14734	118	0	\N
225045	2134	11629819000	30001	14734	119	0	\N
225046	2134	11628815000	30001	14734	120	0	\N
225065	1397	1256671802000	30004	14774	0	0	\N
225066	2133	8313782000	30004	14774	1	0	\N
225067	2132	6695710000	30004	14774	2	0	\N
225068	2134	11504319000	30004	14774	3	0	\N
225069	2134	11503315000	30004	14774	4	0	\N
225070	2134	11502311000	30004	14774	5	0	\N
225071	2134	11501307000	30004	14774	6	0	\N
225072	2133	8312780000	30004	14774	7	0	\N
225049	2134	11508335000	30002	14773	2	0	8805
225050	2132	6696711000	30002	14773	3	0	2291
225051	2133	8315786000	30002	14773	4	0	8110
225052	2133	8314784000	30002	14773	5	0	8111
225053	2134	11507331000	30002	14773	6	0	8806
225055	2134	11505323000	30002	14773	8	0	8808
225056	1397	1256671802000	30003	14774	0	0	18215
225057	2133	8313782000	30003	14774	1	0	8112
225058	2132	6695710000	30003	14774	2	0	2292
225059	2132	6694709000	30003	14774	3	0	2293
225061	2134	11503315000	30003	14774	5	0	8810
225062	2134	11502311000	30003	14774	6	0	8811
225063	2134	11501307000	30003	14774	7	0	8812
225064	2133	8312780000	30003	14774	8	0	8113
225074	1397	1256651800000	30005	14775	1	0	18217
225075	2133	8311778000	30005	14775	2	0	8114
225076	2132	6693708000	30005	14775	3	0	2294
225077	2132	6692707000	30005	14775	4	0	2295
225078	2132	6691706000	30005	14775	5	0	2296
225080	2133	8309774000	30005	14775	7	0	8116
225093	1397	1256661801000	30006	14775	0	0	\N
225094	1397	1256651800000	30006	14775	1	0	\N
225095	2133	8311778000	30006	14775	2	0	\N
225096	2132	6693708000	30006	14775	3	0	\N
225097	2132	6692707000	30006	14775	4	0	\N
225098	2132	6691706000	30006	14775	5	0	\N
225099	2133	8310776000	30006	14775	6	0	\N
225100	2133	8309774000	30006	14775	7	0	\N
225101	2133	8308772000	30006	14775	8	0	\N
225102	2133	8307770000	30006	14775	9	0	\N
225103	2133	8306768000	30006	14775	10	0	\N
225104	2134	11500303000	30006	14775	11	0	\N
225105	2134	11499299000	30006	14775	12	0	\N
225106	2134	11498295000	30006	14775	13	0	\N
225107	2134	11497291000	30006	14775	14	0	\N
225108	2134	11496287000	30006	14775	15	0	\N
225109	2134	11495283000	30006	14775	16	0	\N
225110	2134	11494279000	30006	14775	17	0	\N
225111	2134	11493275000	30006	14775	18	0	\N
225112	2134	11492271000	30006	14775	19	0	\N
225132	1397	1256631798000	30009	14777	0	0	\N
225133	2132	6689704000	30009	14777	1	0	\N
225134	2132	6688703000	30009	14777	2	0	\N
225135	2133	8302760000	30009	14777	3	0	\N
225136	2134	11486247000	30009	14777	4	0	\N
225137	2134	11485243000	30009	14777	5	0	\N
225138	2134	11484239000	30009	14777	6	0	\N
225139	2134	11483235000	30009	14777	7	0	\N
225140	2133	8301758000	30009	14777	8	0	\N
225141	1397	1256631798000	30010	14777	0	0	\N
225142	2132	6689704000	30010	14777	1	0	\N
225143	2132	6688703000	30010	14777	2	0	\N
225144	2133	8302760000	30010	14777	3	0	\N
225145	2134	11486247000	30010	14777	4	0	\N
225146	2134	11485243000	30010	14777	5	0	\N
225147	2134	11484239000	30010	14777	6	0	\N
225148	2134	11483235000	30010	14777	7	0	\N
225149	2133	8301758000	30010	14777	8	0	\N
225206	1397	1256561791000	30016	14782	0	0	\N
225207	1397	1256551790000	30016	14782	1	0	\N
225208	1397	1256541789000	30016	14782	2	0	\N
225209	2132	6679694000	30016	14782	3	0	\N
225210	2133	8285726000	30016	14782	4	0	\N
225211	2132	6678693000	30016	14782	5	0	\N
225212	2132	6677692000	30016	14782	6	0	\N
225213	2132	6676691000	30016	14782	7	0	\N
225214	2132	6675690000	30016	14782	8	0	\N
225215	2133	8284724000	30016	14782	9	0	\N
225216	2133	8283722000	30016	14782	10	0	\N
225083	2133	8306768000	30005	14775	10	0	8119
225084	2134	11500303000	30005	14775	11	0	8813
225085	2134	11499299000	30005	14775	12	0	8814
225086	2134	11498295000	30005	14775	13	0	8815
225087	2134	11497291000	30005	14775	14	0	8816
225089	2134	11495283000	30005	14775	16	0	8818
225090	2134	11494279000	30005	14775	17	0	8819
225091	2134	11493275000	30005	14775	18	0	8820
225092	2134	11492271000	30005	14775	19	0	8821
225113	1397	1256641799000	30007	14776	0	0	18218
225115	2132	6690705000	30007	14776	2	0	2297
225116	2134	11491267000	30007	14776	3	0	8822
225117	2134	11490263000	30007	14776	4	0	8823
225118	2134	11489259000	30007	14776	5	0	8824
225120	2134	11487251000	30007	14776	7	0	8826
225121	2133	8304764000	30007	14776	8	0	8121
225122	2133	8303762000	30007	14776	9	0	8122
225123	1397	1256631798000	30008	14777	0	0	18219
225124	2132	6689704000	30008	14777	1	0	2298
225126	2133	8302760000	30008	14777	3	0	8123
225127	2134	11486247000	30008	14777	4	0	8827
225128	2134	11485243000	30008	14777	5	0	8828
225129	2134	11484239000	30008	14777	6	0	8829
225130	2134	11483235000	30008	14777	7	0	8830
225150	1397	1256621797000	30011	14778	0	0	18220
225151	1397	1256611796000	30011	14778	1	0	18221
225152	1397	1256601795000	30011	14778	2	0	18222
225153	2132	6687702000	30011	14778	3	0	2300
225155	2133	8300756000	30011	14778	5	0	8125
225156	2133	8299754000	30011	14778	6	0	8126
225157	2133	8298752000	30011	14778	7	0	8127
225158	2133	8297750000	30011	14778	8	0	8128
225159	2133	8296748000	30011	14778	9	0	8129
225161	2133	8294744000	30011	14778	11	0	8131
225162	2133	8293742000	30011	14778	12	0	8132
225163	2134	11481227000	30011	14778	13	0	8832
225164	2134	11480223000	30011	14778	14	0	8833
225165	2134	11479219000	30011	14778	15	0	8834
225167	2134	11477211000	30011	14778	17	0	8836
225168	2132	6686701000	30011	14778	18	0	2301
225169	2132	6685700000	30011	14778	19	0	2302
225170	2132	6684699000	30011	14778	20	0	2303
225172	2134	11475203000	30011	14778	22	0	8838
225173	2134	11474199000	30011	14778	23	0	8839
225174	2134	11473195000	30011	14778	24	0	8840
225175	2134	11472191000	30011	14778	25	0	8841
225176	2134	11471187000	30011	14778	26	0	8842
225178	2134	11469179000	30011	14778	28	0	8844
225179	1397	1256591794000	30012	14779	0	0	18223
225180	2133	8292740000	30012	14779	1	0	8133
225181	2133	8291738000	30012	14779	2	0	8134
225182	2132	6683698000	30012	14779	3	0	2304
225184	2134	11468175000	30012	14779	5	0	8845
225185	2134	11467171000	30012	14779	6	0	8846
225186	2134	11466167000	30012	14779	7	0	8847
225187	2134	11465163000	30012	14779	8	0	8848
225189	2133	8290736000	30013	14780	1	0	8135
225190	2133	8289734000	30013	14780	2	0	8136
225191	2133	8288732000	30013	14780	3	0	8137
225192	2132	6681696000	30013	14780	4	0	2306
225193	2134	11464159000	30013	14780	5	0	8849
225195	2134	11462151000	30013	14780	7	0	8851
225196	2134	11461147000	30013	14780	8	0	8852
225197	1397	1256571792000	30014	14781	0	0	18225
225198	2134	11460143000	30014	14781	1	0	8853
225199	2134	11459139000	30014	14781	2	0	8854
225201	2134	11458135000	30014	14781	4	0	8855
225202	2133	8287730000	30014	14781	5	0	8138
225203	2134	11457131000	30014	14781	6	0	8856
225204	2134	11456127000	30014	14781	7	0	8857
225217	2133	8282720000	30016	14782	11	0	\N
225218	2133	8281718000	30016	14782	12	0	\N
225219	2133	8280716000	30016	14782	13	0	\N
225220	2133	8279714000	30016	14782	14	0	\N
225221	2133	8278712000	30016	14782	15	0	\N
225222	2133	8277710000	30016	14782	16	0	\N
225223	2134	11455123000	30016	14782	17	0	\N
225224	2134	11454119000	30016	14782	18	0	\N
225225	2134	11453115000	30016	14782	19	0	\N
225226	2134	11452111000	30016	14782	20	0	\N
225227	2134	11451107000	30016	14782	21	0	\N
225228	2134	11450103000	30016	14782	22	0	\N
225229	2134	11449099000	30016	14782	23	0	\N
225230	2134	11448095000	30016	14782	24	0	\N
225231	2134	11447091000	30016	14782	25	0	\N
225232	2134	11446087000	30016	14782	26	0	\N
225233	2134	11445083000	30016	14782	27	0	\N
225234	2134	11444079000	30016	14782	28	0	\N
225235	2134	11443075000	30016	14782	29	0	\N
225236	1397	1256561791000	30017	14782	0	0	\N
225237	1397	1256551790000	30017	14782	1	0	\N
225238	1397	1256541789000	30017	14782	2	0	\N
225239	2132	6679694000	30017	14782	3	0	\N
225240	2133	8285726000	30017	14782	4	0	\N
225241	2132	6678693000	30017	14782	5	0	\N
225242	2132	6677692000	30017	14782	6	0	\N
225243	2132	6676691000	30017	14782	7	0	\N
225244	2132	6675690000	30017	14782	8	0	\N
225245	2133	8284724000	30017	14782	9	0	\N
225246	2133	8283722000	30017	14782	10	0	\N
225247	2133	8282720000	30017	14782	11	0	\N
225248	2133	8281718000	30017	14782	12	0	\N
225249	2133	8280716000	30017	14782	13	0	\N
225250	2133	8279714000	30017	14782	14	0	\N
225251	2133	8278712000	30017	14782	15	0	\N
225252	2133	8277710000	30017	14782	16	0	\N
225253	2134	11455123000	30017	14782	17	0	\N
225254	2134	11454119000	30017	14782	18	0	\N
225255	2134	11453115000	30017	14782	19	0	\N
225256	2134	11452111000	30017	14782	20	0	\N
225257	2134	11451107000	30017	14782	21	0	\N
225258	2134	11450103000	30017	14782	22	0	\N
225259	2134	11449099000	30017	14782	23	0	\N
225260	2134	11448095000	30017	14782	24	0	\N
225261	2134	11447091000	30017	14782	25	0	\N
225262	2134	11446087000	30017	14782	26	0	\N
225263	2134	11445083000	30017	14782	27	0	\N
225264	2134	11444079000	30017	14782	28	0	\N
225265	2134	11443075000	30017	14782	29	0	\N
225266	1397	1256561791000	30019	14782	0	0	\N
225267	1397	1256551790000	30019	14782	1	0	\N
225268	1397	1256541789000	30019	14782	2	0	\N
225269	2132	6679694000	30019	14782	3	0	\N
225270	2133	8285726000	30019	14782	4	0	\N
225271	2132	6678693000	30019	14782	5	0	\N
225272	2132	6677692000	30019	14782	6	0	\N
225273	2132	6676691000	30019	14782	7	0	\N
225274	2132	6675690000	30019	14782	8	0	\N
225275	2133	8284724000	30019	14782	9	0	\N
225276	2133	8283722000	30019	14782	10	0	\N
225277	2133	8282720000	30019	14782	11	0	\N
225278	2133	8281718000	30019	14782	12	0	\N
225279	2133	8280716000	30019	14782	13	0	\N
225280	2133	8279714000	30019	14782	14	0	\N
225281	2133	8278712000	30019	14782	15	0	\N
225282	2133	8277710000	30019	14782	16	0	\N
225283	2134	11455123000	30019	14782	17	0	\N
225284	2134	11454119000	30019	14782	18	0	\N
225285	2134	11453115000	30019	14782	19	0	\N
225286	2134	11452111000	30019	14782	20	0	\N
225287	2134	11451107000	30019	14782	21	0	\N
225288	2134	11450103000	30019	14782	22	0	\N
225289	2134	11449099000	30019	14782	23	0	\N
225290	2134	11448095000	30019	14782	24	0	\N
225291	2134	11447091000	30019	14782	25	0	\N
225292	2134	11446087000	30019	14782	26	0	\N
225293	2134	11445083000	30019	14782	27	0	\N
225294	2134	11444079000	30019	14782	28	0	\N
225295	2134	11443075000	30019	14782	29	0	\N
225326	1397	1256531788000	30024	14783	0	0	\N
225327	2134	11442071000	30024	14783	1	0	\N
225328	2133	8276708000	30024	14783	2	0	\N
225329	2134	11441067000	30024	14783	3	0	\N
225330	2134	11440063000	30024	14783	4	0	\N
225331	2134	11439059000	30024	14783	5	0	\N
225332	2133	8275706000	30024	14783	6	0	\N
225333	2132	6674689000	30024	14783	7	0	\N
225341	1397	1256531788000	30026	14783	0	0	\N
225342	2132	6674689000	30026	14783	1	0	\N
225343	1397	1256531788000	30027	14783	0	0	\N
225344	2133	8276708000	30027	14783	1	0	\N
225345	2133	8275706000	30027	14783	2	0	\N
225346	2132	6674689000	30027	14783	3	0	\N
225298	1397	1256541789000	30020	14782	2	0	18228
225299	2132	6679694000	30020	14782	3	0	2308
225300	2133	8285726000	30020	14782	4	0	8140
225301	2132	6678693000	30020	14782	5	0	2309
225302	2132	6677692000	30020	14782	6	0	2310
225304	2132	6675690000	30020	14782	8	0	2312
225305	2133	8284724000	30020	14782	9	0	8141
225306	2133	8283722000	30020	14782	10	0	8142
225307	2133	8282720000	30020	14782	11	0	8143
225308	2133	8281718000	30020	14782	12	0	8144
225310	2133	8279714000	30020	14782	14	0	8146
225311	2133	8278712000	30020	14782	15	0	8147
225312	2133	8277710000	30020	14782	16	0	8148
225313	2134	11455123000	30020	14782	17	0	8858
225315	2134	11453115000	30020	14782	19	0	8860
225316	2134	11452111000	30020	14782	20	0	8861
225317	2134	11451107000	30020	14782	21	0	8862
225318	2134	11450103000	30020	14782	22	0	8863
225319	2134	11449099000	30020	14782	23	0	8864
225321	2134	11447091000	30020	14782	25	0	8866
225322	2134	11446087000	30020	14782	26	0	8867
225323	2134	11445083000	30020	14782	27	0	8868
225324	2134	11444079000	30020	14782	28	0	8869
225325	2134	11443075000	30020	14782	29	0	8870
225335	2134	11442071000	30025	14783	1	0	8871
225336	2133	8276708000	30025	14783	2	0	8149
225337	2134	11441067000	30025	14783	3	0	8872
225338	2134	11440063000	30025	14783	4	0	8873
225340	2132	6674689000	30025	14783	6	0	2313
225347	1397	1256521787000	30028	14784	0	0	18230
225348	2133	8274704000	30028	14784	1	0	8151
225349	2134	11439059000	30028	14784	2	0	8874
225350	2132	6673688000	30028	14784	3	0	2314
225352	2133	8273702000	30028	14784	5	0	8152
225353	1397	1256521787000	30029	14784	0	0	\N
225354	2133	8274704000	30029	14784	1	0	\N
225355	2134	11439059000	30029	14784	2	0	\N
225356	2132	6673688000	30029	14784	3	0	\N
225357	2132	6672687000	30029	14784	4	0	\N
225390	1397	1256501785000	30032	14786	0	0	\N
225391	1397	1256491784000	30032	14786	1	0	\N
225392	2132	6670685000	30032	14786	2	0	\N
225393	2133	8270696000	30032	14786	3	0	\N
225394	2133	8269694000	30032	14786	4	0	\N
225395	2133	8268692000	30032	14786	5	0	\N
225396	2133	8267690000	30032	14786	6	0	\N
225397	2133	8266688000	30032	14786	7	0	\N
225398	2134	11429019000	30032	14786	8	0	\N
225399	2134	11428015000	30032	14786	9	0	\N
225400	2134	11427011000	30032	14786	10	0	\N
225401	2134	11426007000	30032	14786	11	0	\N
225402	2132	6669684000	30032	14786	12	0	\N
225403	2132	6668683000	30032	14786	13	0	\N
225404	2134	11425003000	30032	14786	14	0	\N
225405	2134	11423999000	30032	14786	15	0	\N
225406	2134	11422995000	30032	14786	16	0	\N
225407	2134	11421991000	30032	14786	17	0	\N
225408	2134	11420987000	30032	14786	18	0	\N
225438	1397	1256461781000	30035	14788	0	0	\N
225439	2134	11411951000	30035	14788	1	0	\N
225440	2133	8260676000	30035	14788	2	0	\N
225441	2133	8259674000	30035	14788	3	0	\N
225442	2133	8258672000	30035	14788	4	0	\N
225443	2134	11410947000	30035	14788	5	0	\N
225444	2134	11409943000	30035	14788	6	0	\N
225445	2132	6664679000	30035	14788	7	0	\N
225446	2134	11408939000	30035	14788	8	0	\N
225447	2134	11407935000	30035	14788	9	0	\N
225448	2132	6663678000	30035	14788	10	0	\N
225449	1726	114118112000	30036	14669	0	0	\N
225450	1726	113017112000	30036	14669	1	0	\N
225451	1397	1256451780000	30037	14789	0	0	\N
225452	2134	11406931000	30037	14789	1	0	\N
225453	2132	6662677000	30037	14789	2	0	\N
225454	1726	111916112000	30037	14789	3	0	\N
225455	1726	110815112000	30037	14789	4	0	\N
225456	2134	11405927000	30037	14789	5	0	\N
225457	2134	11404923000	30037	14789	6	0	\N
225458	2134	11403919000	30037	14789	7	0	\N
225459	2133	8257670000	30037	14789	8	0	\N
225460	2133	8256668000	30037	14789	9	0	\N
225471	1992	1236990000	30039	14790	0	0	\N
225472	1397	1256441779000	30039	14790	1	0	\N
225473	1397	1256431778000	30039	14790	2	0	\N
225474	2134	11402915000	30039	14790	3	0	\N
225475	2134	11401911000	30039	14790	4	0	\N
225476	2134	11400907000	30039	14790	5	0	\N
225477	2134	11399903000	30039	14790	6	0	\N
225478	2132	6661676000	30039	14790	7	0	\N
225479	2133	8255666000	30039	14790	8	0	\N
225480	2133	8254664000	30039	14790	9	0	\N
225481	2133	8253662000	30039	14790	10	0	\N
225482	2133	8252660000	30039	14790	11	0	\N
225483	1726	110714112000	30039	14790	12	0	\N
225484	2133	8251658000	30039	14790	13	0	\N
225485	2133	8250656000	30039	14790	14	0	\N
225486	2134	11398899000	30039	14790	15	0	\N
225487	2134	11397895000	30039	14790	16	0	\N
225488	2134	11396891000	30039	14790	17	0	\N
225360	2134	11437051000	30030	14785	2	0	8876
225361	2134	11436047000	30030	14785	3	0	8877
225362	2134	11435043000	30030	14785	4	0	8878
225363	2134	11434039000	30030	14785	5	0	8879
225364	2134	11433035000	30030	14785	6	0	8880
225366	2134	11431027000	30030	14785	8	0	8882
225367	2134	11430023000	30030	14785	9	0	8883
225368	2133	8272700000	30030	14785	10	0	8153
225369	2133	8271698000	30030	14785	11	0	8154
225370	2132	6671686000	30030	14785	12	0	2316
225372	1397	1256491784000	30031	14786	1	0	18233
225373	2132	6670685000	30031	14786	2	0	2317
225374	2133	8270696000	30031	14786	3	0	8155
225375	2133	8269694000	30031	14786	4	0	8156
225377	2133	8267690000	30031	14786	6	0	8158
225378	2133	8266688000	30031	14786	7	0	8159
225379	2134	11429019000	30031	14786	8	0	8884
225380	2134	11428015000	30031	14786	9	0	8885
225381	2134	11427011000	30031	14786	10	0	8886
225383	2132	6669684000	30031	14786	12	0	2318
225384	2132	6668683000	30031	14786	13	0	2319
225385	2134	11425003000	30031	14786	14	0	8888
225386	2134	11423999000	30031	14786	15	0	8889
225387	2134	11422995000	30031	14786	16	0	8890
225389	2134	11420987000	30031	14786	18	0	8892
225409	1397	1256481783000	30033	14787	0	0	18234
225410	1397	1256471782000	30033	14787	1	0	18235
225411	2133	8265686000	30033	14787	2	0	8160
225413	2133	8264684000	30033	14787	5	0	8161
225414	2134	11419983000	30033	14787	6	0	8893
225415	2134	11418979000	30033	14787	7	0	8894
225416	2132	6666681000	30033	14787	8	0	2321
225417	2132	6665680000	30033	14787	9	0	2322
225419	2133	8262680000	30033	14787	11	0	8163
225420	2133	8261678000	30033	14787	12	0	8164
225421	2134	11417975000	30033	14787	13	0	8895
225422	2134	11416971000	30033	14787	14	0	8896
225423	2134	11415967000	30033	14787	15	0	8897
225425	2134	11413959000	30033	14787	17	0	8899
225426	2134	11412955000	30033	14787	18	0	8900
225427	1397	1256461781000	30034	14788	0	0	18236
225428	2134	11411951000	30034	14788	1	0	8901
225430	2133	8259674000	30034	14788	3	0	8166
225431	2133	8258672000	30034	14788	4	0	8167
225432	2134	11410947000	30034	14788	5	0	8902
225433	2134	11409943000	30034	14788	6	0	8903
225434	2132	6664679000	30034	14788	7	0	2323
225436	2134	11407935000	30034	14788	9	0	8905
225437	2132	6663678000	30034	14788	10	0	2324
225461	1397	1256451780000	30038	14789	0	0	18237
225462	2134	11406931000	30038	14789	1	0	8906
225463	2132	6662677000	30038	14789	2	0	2325
225465	1726	110815112000	30038	14789	4	0	8370
225466	2134	11405927000	30038	14789	5	0	8907
225467	2134	11404923000	30038	14789	6	0	8908
225468	2134	11403919000	30038	14789	7	0	8909
225470	2133	8256668000	30038	14789	9	0	8169
225489	2134	11395887000	30039	14790	18	0	\N
225490	2134	11394883000	30039	14790	19	0	\N
225491	2132	6660675000	30039	14790	20	0	\N
225492	2132	6659674000	30039	14790	21	0	\N
225515	1992	1236990000	30041	14790	0	0	\N
225516	1397	1256441779000	30041	14790	1	0	\N
225517	1397	1256431778000	30041	14790	2	0	\N
225518	2134	11402915000	30041	14790	3	0	\N
225519	2134	11401911000	30041	14790	4	0	\N
225520	2134	11400907000	30041	14790	5	0	\N
225521	2134	11399903000	30041	14790	6	0	\N
225522	2132	6661676000	30041	14790	7	0	\N
225523	2133	8255666000	30041	14790	8	0	\N
225524	2133	8254664000	30041	14790	9	0	\N
225525	2133	8253662000	30041	14790	10	0	\N
225526	2133	8252660000	30041	14790	11	0	\N
225527	1726	110714112000	30041	14790	12	0	\N
225528	2133	8251658000	30041	14790	13	0	\N
225529	2133	8250656000	30041	14790	14	0	\N
225530	2134	11398899000	30041	14790	15	0	\N
225531	2134	11397895000	30041	14790	16	0	\N
225532	2134	11396891000	30041	14790	17	0	\N
225533	2134	11395887000	30041	14790	18	0	\N
225534	2134	11394883000	30041	14790	19	0	\N
225535	2132	6660675000	30041	14790	20	0	\N
225536	2132	6659674000	30041	14790	21	0	\N
225537	1397	1256421777000	30042	14791	0	0	\N
225538	1397	1256411776000	30042	14791	1	0	\N
225539	2133	8249654000	30042	14791	2	0	\N
225540	2132	6658673000	30042	14791	3	0	\N
225541	2134	11393879000	30042	14791	4	0	\N
225542	355	66000099000000	30042	14791	5	0	\N
225543	1726	109613112000	30042	14791	6	0	\N
225544	2134	11392875000	30042	14791	7	0	\N
225545	2134	11391871000	30042	14791	8	0	\N
225546	2134	11390867000	30042	14791	9	0	\N
225547	2134	11389863000	30042	14791	10	0	\N
225548	2134	11388859000	30042	14791	11	0	\N
225549	2134	11387855000	30042	14791	12	0	\N
225550	2134	11386851000	30042	14791	13	0	\N
225551	2134	11385847000	30042	14791	14	0	\N
225552	2133	8248652000	30042	14791	15	0	\N
225553	2133	8247650000	30042	14791	16	0	\N
225554	2133	8246648000	30042	14791	17	0	\N
225555	2133	8245646000	30042	14791	18	0	\N
225556	2132	6657672000	30042	14791	19	0	\N
225557	2132	6656671000	30042	14791	20	0	\N
225558	1397	1256421777000	30043	14791	0	0	\N
225559	1397	1256411776000	30043	14791	1	0	\N
225560	2133	8249654000	30043	14791	2	0	\N
225561	2132	6658673000	30043	14791	3	0	\N
225562	2134	11393879000	30043	14791	4	0	\N
225563	355	66000099000000	30043	14791	5	0	\N
225564	1726	109613112000	30043	14791	6	0	\N
225565	2134	11392875000	30043	14791	7	0	\N
225566	2134	11391871000	30043	14791	8	0	\N
225567	2134	11390867000	30043	14791	9	0	\N
225568	2134	11389863000	30043	14791	10	0	\N
225569	2134	11388859000	30043	14791	11	0	\N
225570	2134	11387855000	30043	14791	12	0	\N
225571	2134	11386851000	30043	14791	13	0	\N
225572	2134	11385847000	30043	14791	14	0	\N
225573	2133	8248652000	30043	14791	15	0	\N
225574	2133	8247650000	30043	14791	16	0	\N
225575	2133	8246648000	30043	14791	17	0	\N
225576	2133	8245646000	30043	14791	18	0	\N
225577	2132	6657672000	30043	14791	19	0	\N
225578	2132	6656671000	30043	14791	20	0	\N
225620	1397	1256401775000	30046	14792	0	0	\N
225621	1397	1256391774000	30046	14792	1	0	\N
225622	2041	2879000000000	30046	14792	2	0	\N
225623	2132	6655670000	30046	14792	3	0	\N
225624	2132	6654669000	30046	14792	4	0	\N
225495	1397	1256431778000	30040	14790	2	0	18239
225496	2134	11402915000	30040	14790	3	0	8910
225497	2134	11401911000	30040	14790	4	0	8911
225498	2134	11400907000	30040	14790	5	0	8912
225499	2134	11399903000	30040	14790	6	0	8913
225501	2133	8255666000	30040	14790	8	0	8170
225502	2133	8254664000	30040	14790	9	0	8171
225503	2133	8253662000	30040	14790	10	0	8172
225504	2133	8252660000	30040	14790	11	0	8173
225505	1726	110714112000	30040	14790	12	0	8371
225507	2133	8250656000	30040	14790	14	0	8175
225508	2134	11398899000	30040	14790	15	0	8914
225509	2134	11397895000	30040	14790	16	0	8915
225510	2134	11396891000	30040	14790	17	0	8916
225512	2134	11394883000	30040	14790	19	0	8918
225513	2132	6660675000	30040	14790	20	0	2327
225514	2132	6659674000	30040	14790	21	0	2328
225579	1397	1256421777000	30044	14791	0	0	18240
225580	1397	1256411776000	30044	14791	1	0	18241
225582	2132	6658673000	30044	14791	3	0	2329
225583	2134	11393879000	30044	14791	4	0	8919
225584	355	66000099000000	30044	14791	5	0	1
225585	1726	109613112000	30044	14791	6	0	8372
225586	2134	11392875000	30044	14791	7	0	8920
225588	2134	11390867000	30044	14791	9	0	8922
225589	2134	11389863000	30044	14791	10	0	8923
225590	2134	11388859000	30044	14791	11	0	8924
225591	2134	11387855000	30044	14791	12	0	8925
225593	2134	11385847000	30044	14791	14	0	8927
225594	2133	8248652000	30044	14791	15	0	8177
225595	2133	8247650000	30044	14791	16	0	8178
225596	2133	8246648000	30044	14791	17	0	8179
225597	2133	8245646000	30044	14791	18	0	8180
225599	2132	6656671000	30044	14791	20	0	2331
225600	1397	1256401775000	30045	14792	0	0	18242
225601	1397	1256391774000	30045	14792	1	0	18243
225602	2041	2879000000000	30045	14792	2	0	2
225603	2132	6655670000	30045	14792	3	0	2332
225605	2132	6653668000	30045	14792	5	0	2334
225606	2134	11384843000	30045	14792	6	0	8928
225607	2134	11383839000	30045	14792	7	0	8929
225608	2134	11382835000	30045	14792	8	0	8930
225610	2133	8244644000	30045	14792	10	0	8181
225611	2133	8243642000	30045	14792	11	0	8182
225612	2133	8242640000	30045	14792	12	0	8183
225613	2133	8241638000	30045	14792	13	0	8184
225614	2133	8240636000	30045	14792	14	0	8185
225616	2134	11379823000	30045	14792	16	0	8933
225617	2134	11378819000	30045	14792	17	0	8934
225618	2134	11377815000	30045	14792	18	0	8935
225619	2134	11376811000	30045	14792	19	0	8936
225625	2132	6653668000	30046	14792	5	0	\N
225626	2134	11384843000	30046	14792	6	0	\N
225627	2134	11383839000	30046	14792	7	0	\N
225628	2134	11382835000	30046	14792	8	0	\N
225629	2134	11381831000	30046	14792	9	0	\N
225630	2133	8244644000	30046	14792	10	0	\N
225631	2133	8243642000	30046	14792	11	0	\N
225632	2133	8242640000	30046	14792	12	0	\N
225633	2133	8241638000	30046	14792	13	0	\N
225634	2133	8240636000	30046	14792	14	0	\N
225635	2134	11380827000	30046	14792	15	0	\N
225636	2134	11379823000	30046	14792	16	0	\N
225637	2134	11378819000	30046	14792	17	0	\N
225638	2134	11377815000	30046	14792	18	0	\N
225639	2134	11376811000	30046	14792	19	0	\N
225640	1397	1256401775000	30047	14792	0	0	\N
225641	1397	1256391774000	30047	14792	1	0	\N
225642	2041	2879000000000	30047	14792	2	0	\N
225643	2132	6655670000	30047	14792	3	0	\N
225644	2132	6654669000	30047	14792	4	0	\N
225645	2132	6653668000	30047	14792	5	0	\N
225646	2134	11384843000	30047	14792	6	0	\N
225647	2134	11383839000	30047	14792	7	0	\N
225648	2134	11382835000	30047	14792	8	0	\N
225649	2134	11381831000	30047	14792	9	0	\N
225650	2133	8244644000	30047	14792	10	0	\N
225651	2133	8243642000	30047	14792	11	0	\N
225652	2133	8242640000	30047	14792	12	0	\N
225653	2133	8241638000	30047	14792	13	0	\N
225654	2133	8240636000	30047	14792	14	0	\N
225655	2134	11380827000	30047	14792	15	0	\N
225656	2134	11379823000	30047	14792	16	0	\N
225657	2134	11378819000	30047	14792	17	0	\N
225658	2134	11377815000	30047	14792	18	0	\N
225659	2134	11376811000	30047	14792	19	0	\N
225660	1397	1256381773000	30048	14793	0	0	\N
225661	2132	6652667000	30048	14793	1	0	\N
225662	2132	6651666000	30048	14793	2	0	\N
225663	2134	11375807000	30048	14793	3	0	\N
225664	2133	8239634000	30048	14793	4	0	\N
225665	2133	8238632000	30048	14793	5	0	\N
225666	2133	8237630000	30048	14793	6	0	\N
225667	2134	11374803000	30048	14793	7	0	\N
225668	2134	11373799000	30048	14793	8	0	\N
225669	2134	11372795000	30048	14793	9	0	\N
225680	1397	1256371772000	30051	14795	0	0	\N
225681	1397	1256361771000	30051	14795	1	0	\N
225682	2133	8236628000	30051	14795	2	0	\N
225683	2132	6650665000	30051	14795	3	0	\N
225684	2132	6649664000	30051	14795	4	0	\N
225685	2133	8235626000	30051	14795	5	0	\N
225686	2133	8234624000	30051	14795	6	0	\N
225687	2133	8233622000	30051	14795	7	0	\N
225688	2134	11371791000	30051	14795	8	0	\N
225689	2134	11370787000	30051	14795	9	0	\N
225690	2134	11369783000	30051	14795	10	0	\N
225691	2134	11368779000	30051	14795	11	0	\N
225692	2134	11367775000	30051	14795	12	0	\N
225693	2134	11366771000	30051	14795	13	0	\N
225694	2134	11365767000	30051	14795	14	0	\N
225695	2134	11364763000	30051	14795	15	0	\N
225696	2134	11363759000	30051	14795	16	0	\N
225724	1397	1256351770000	30054	14796	0	0	\N
225725	2134	11362755000	30054	14796	1	0	\N
225726	2133	8232620000	30054	14796	2	0	\N
225727	2133	8231618000	30054	14796	3	0	\N
225728	2132	6648663000	30054	14796	4	0	\N
225729	2132	6647662000	30054	14796	5	0	\N
225730	2134	11361751000	30054	14796	6	0	\N
225731	2134	11360747000	30054	14796	7	0	\N
225732	2134	11359743000	30054	14796	8	0	\N
225733	155	66000334000000	30054	14796	9	0	\N
225734	1397	1256341769000	30055	14797	0	0	\N
225735	1397	1256331768000	30055	14797	1	0	\N
225736	2134	11358739000	30055	14797	2	0	\N
225737	2132	6646661000	30055	14797	3	0	\N
225738	2133	8230616000	30055	14797	4	0	\N
225739	2133	8229614000	30055	14797	5	0	\N
225740	2133	8228612000	30055	14797	6	0	\N
225741	2133	8227610000	30055	14797	7	0	\N
225742	2133	8226608000	30055	14797	8	0	\N
225743	2133	8225606000	30055	14797	9	0	\N
225744	2134	11357735000	30055	14797	10	0	\N
225745	2132	6645660000	30055	14797	11	0	\N
225746	2134	11356731000	30055	14797	12	0	\N
225747	2134	11355727000	30055	14797	13	0	\N
225748	2134	11354723000	30055	14797	14	0	\N
225749	2134	11353719000	30055	14797	15	0	\N
225750	2134	11352715000	30055	14797	16	0	\N
225751	2132	6644659000	30055	14797	17	0	\N
225752	2134	11351711000	30055	14797	18	0	\N
225753	2134	11350707000	30055	14797	19	0	\N
225672	2132	6651666000	30049	14793	2	0	2336
225673	2134	11375807000	30049	14793	3	0	8937
225674	2133	8239634000	30049	14793	4	0	8186
225675	2133	8238632000	30049	14793	5	0	8187
225676	2133	8237630000	30049	14793	6	0	8188
225678	2134	11373799000	30049	14793	8	0	8939
225679	2134	11372795000	30049	14793	9	0	8940
225697	1397	1256371772000	30052	14795	0	0	18245
225698	1397	1256361771000	30052	14795	1	0	18246
225699	2133	8236628000	30052	14795	2	0	8189
225701	2132	6649664000	30052	14795	4	0	2338
225702	2133	8235626000	30052	14795	5	0	8190
225703	2133	8234624000	30052	14795	6	0	8191
225704	2133	8233622000	30052	14795	7	0	8192
225706	2134	11370787000	30052	14795	9	0	8942
225707	2134	11369783000	30052	14795	10	0	8943
225708	2134	11368779000	30052	14795	11	0	8944
225709	2134	11367775000	30052	14795	12	0	8945
225710	2134	11366771000	30052	14795	13	0	8946
225712	2134	11364763000	30052	14795	15	0	8948
225713	2134	11363759000	30052	14795	16	0	8949
225714	1397	1256351770000	30053	14796	0	0	18247
225715	2134	11362755000	30053	14796	1	0	8950
225716	2133	8232620000	30053	14796	2	0	8193
225718	2132	6648663000	30053	14796	4	0	2339
225719	2132	6647662000	30053	14796	5	0	2340
225720	2134	11361751000	30053	14796	6	0	8951
225721	2134	11360747000	30053	14796	7	0	8952
225723	155	66000334000000	30053	14796	9	0	1
225754	1397	1256341769000	30056	14797	0	0	18248
225755	1397	1256331768000	30056	14797	1	0	18249
225756	2134	11358739000	30056	14797	2	0	8954
225757	2132	6646661000	30056	14797	3	0	2341
225759	2133	8229614000	30056	14797	5	0	8196
225760	2133	8228612000	30056	14797	6	0	8197
225774	1397	1256341769000	30057	14797	0	0	\N
225775	1397	1256331768000	30057	14797	1	0	\N
225776	2134	11358739000	30057	14797	2	0	\N
225777	2132	6646661000	30057	14797	3	0	\N
225778	2133	8230616000	30057	14797	4	0	\N
225779	2133	8229614000	30057	14797	5	0	\N
225780	2133	8228612000	30057	14797	6	0	\N
225781	2133	8227610000	30057	14797	7	0	\N
225782	2133	8226608000	30057	14797	8	0	\N
225783	2133	8225606000	30057	14797	9	0	\N
225784	2134	11357735000	30057	14797	10	0	\N
225785	2132	6645660000	30057	14797	11	0	\N
225786	2134	11356731000	30057	14797	12	0	\N
225787	2134	11355727000	30057	14797	13	0	\N
225788	2134	11354723000	30057	14797	14	0	\N
225789	2134	11353719000	30057	14797	15	0	\N
225790	2134	11352715000	30057	14797	16	0	\N
225791	2132	6644659000	30057	14797	17	0	\N
225792	2134	11351711000	30057	14797	18	0	\N
225793	2134	11350707000	30057	14797	19	0	\N
225813	1397	1256321767000	30059	14798	0	0	\N
225814	1397	1256311766000	30059	14798	1	0	\N
225815	2134	11349703000	30059	14798	2	0	\N
225816	2133	8224604000	30059	14798	3	0	\N
225817	2133	8223602000	30059	14798	4	0	\N
225818	2133	8222600000	30059	14798	5	0	\N
225819	2134	11348699000	30059	14798	6	0	\N
225820	2134	11347695000	30059	14798	7	0	\N
225821	2134	11346691000	30059	14798	8	0	\N
225822	2134	11345687000	30059	14798	9	0	\N
225823	2134	11344683000	30059	14798	10	0	\N
225824	2134	11343679000	30059	14798	11	0	\N
225825	2134	11342675000	30059	14798	12	0	\N
225826	2134	11341671000	30059	14798	13	0	\N
225827	2132	6643658000	30059	14798	14	0	\N
225828	2132	6642657000	30059	14798	15	0	\N
225829	2132	6641656000	30059	14798	16	0	\N
225830	2133	8221598000	30059	14798	17	0	\N
225831	2133	8220596000	30059	14798	18	0	\N
225840	1397	1256291764000	30061	14800	0	0	\N
225841	1397	1256281763000	30061	14800	1	0	\N
225842	1397	1256271762000	30061	14800	2	0	\N
225843	1726	108512112000	30061	14800	3	0	\N
225844	2132	6639654000	30061	14800	4	0	\N
225845	2132	6638653000	30061	14800	5	0	\N
225846	2132	6637652000	30061	14800	6	0	\N
225847	2132	6636651000	30061	14800	7	0	\N
225848	2132	6635650000	30061	14800	8	0	\N
225889	1397	1256261761000	30064	14801	0	0	\N
225890	2133	8208572000	30064	14801	1	0	\N
225891	2132	6634649000	30064	14801	2	0	\N
225892	2133	8207570000	30064	14801	3	0	\N
225893	2134	11322595000	30064	14801	4	0	\N
225894	2134	11321591000	30064	14801	5	0	\N
225895	2134	11320587000	30064	14801	7	0	\N
225896	2134	11319583000	30064	14801	8	0	\N
225763	2133	8225606000	30056	14797	9	0	8200
225764	2134	11357735000	30056	14797	10	0	8955
225765	2132	6645660000	30056	14797	11	0	2342
225766	2134	11356731000	30056	14797	12	0	8956
225767	2134	11355727000	30056	14797	13	0	8957
225769	2134	11353719000	30056	14797	15	0	8959
225770	2134	11352715000	30056	14797	16	0	8960
225771	2132	6644659000	30056	14797	17	0	2343
225772	2134	11351711000	30056	14797	18	0	8961
225773	2134	11350707000	30056	14797	19	0	8962
225795	1397	1256311766000	30058	14798	1	0	18251
225796	2134	11349703000	30058	14798	2	0	8963
225797	2133	8224604000	30058	14798	3	0	8201
225798	2133	8223602000	30058	14798	4	0	8202
225800	2134	11348699000	30058	14798	6	0	8964
225801	2134	11347695000	30058	14798	7	0	8965
225802	2134	11346691000	30058	14798	8	0	8966
225803	2134	11345687000	30058	14798	9	0	8967
225804	2134	11344683000	30058	14798	10	0	8968
225806	2134	11342675000	30058	14798	12	0	8970
225807	2134	11341671000	30058	14798	13	0	8971
225808	2132	6643658000	30058	14798	14	0	2344
225809	2132	6642657000	30058	14798	15	0	2345
225810	2132	6641656000	30058	14798	16	0	2346
225812	2133	8220596000	30058	14798	18	0	8205
225832	1397	1256301765000	30060	14799	0	0	18252
225833	2133	8219594000	30060	14799	1	0	8206
225834	2132	6640655000	30060	14799	2	0	2347
225836	2134	11339663000	30060	14799	4	0	8973
225837	2134	11338659000	30060	14799	5	0	8974
225838	2134	11337655000	30060	14799	6	0	8975
225839	2133	8218592000	30060	14799	7	0	8207
225849	1397	1256291764000	30062	14800	0	0	18253
225851	1397	1256271762000	30062	14800	2	0	18255
225852	2133	8217590000	30062	14800	3	0	8208
225853	2133	8216588000	30062	14800	4	0	8209
225854	2134	11336651000	30062	14800	5	0	8976
225855	2134	11335647000	30062	14800	6	0	8977
225857	2133	8214584000	30062	14800	8	0	8211
225858	2133	8213582000	30062	14800	9	0	8212
225859	2133	8212580000	30062	14800	10	0	8213
225860	2133	8211578000	30062	14800	11	0	8214
225862	2133	8209574000	30062	14800	13	0	8216
225863	1726	108512112000	30062	14800	14	0	8373
225864	2132	6639654000	30062	14800	15	0	2348
225865	2132	6638653000	30062	14800	16	0	2349
225866	2132	6637652000	30062	14800	17	0	2350
225868	2132	6635650000	30062	14800	19	0	2352
225869	2134	11334643000	30062	14800	20	0	8978
225870	2134	11333639000	30062	14800	21	0	8979
225871	2134	11332635000	30062	14800	22	0	8980
225872	2134	11331631000	30062	14800	23	0	8981
225874	2134	11329623000	30062	14800	25	0	8983
225875	2134	11328619000	30062	14800	26	0	8984
225876	2134	11327615000	30062	14800	27	0	8985
225877	2134	11326611000	30062	14800	28	0	8986
225879	2134	11324603000	30062	14800	30	0	8988
225880	2134	11323599000	30062	14800	31	0	8989
225881	1397	1256261761000	30063	14801	0	0	18256
225882	2133	8208572000	30063	14801	1	0	8217
225883	2132	6634649000	30063	14801	2	0	2353
225885	2134	11322595000	30063	14801	4	0	8990
225886	2134	11321591000	30063	14801	5	0	8991
225887	2134	11320587000	30063	14801	7	0	8992
225888	2134	11319583000	30063	14801	8	0	8993
225925	1397	1256221757000	30068	14805	0	0	\N
225926	2133	8199554000	30068	14805	1	0	\N
225927	2132	6629644000	30068	14805	2	0	\N
225928	2132	6628643000	30068	14805	3	0	\N
225929	2133	8198552000	30068	14805	4	0	\N
225930	2133	8197550000	30068	14805	5	0	\N
225931	1397	1256221757000	30069	14805	0	0	\N
225932	2133	8199554000	30069	14805	1	0	\N
225933	2132	6629644000	30069	14805	2	0	\N
225934	2132	6628643000	30069	14805	3	0	\N
225935	2134	11305527000	30069	14805	4	0	\N
225936	2134	11304523000	30069	14805	5	0	\N
225937	2134	11303519000	30069	14805	6	0	\N
225938	2134	11302515000	30069	14805	7	0	\N
225939	2134	11301511000	30069	14805	8	0	\N
225940	2133	8198552000	30069	14805	9	0	\N
225941	2133	8197550000	30069	14805	10	0	\N
225953	1397	1256221757000	30071	14805	0	0	\N
225954	2133	8199554000	30071	14805	1	0	\N
225955	2132	6629644000	30071	14805	2	0	\N
225956	2132	6628643000	30071	14805	3	0	\N
225957	2134	11305527000	30071	14805	4	0	\N
225958	2134	11304523000	30071	14805	5	0	\N
225959	2134	11303519000	30071	14805	6	0	\N
225960	2134	11302515000	30071	14805	7	0	\N
225961	2134	11301511000	30071	14805	8	0	\N
225962	2133	8198552000	30071	14805	9	0	\N
225963	2133	8197550000	30071	14805	10	0	\N
225983	1397	1256191754000	30074	14808	0	0	\N
225984	1397	1256181753000	30074	14808	1	0	\N
225985	2133	8192540000	30074	14808	2	0	\N
225986	2133	8191538000	30074	14808	3	0	\N
225987	2133	8190536000	30074	14808	4	0	\N
225988	2133	8189534000	30074	14808	5	0	\N
225989	2133	8188532000	30074	14808	6	0	\N
225990	2134	11292475000	30074	14808	7	0	\N
225991	2134	11291471000	30074	14808	8	0	\N
225992	2134	11290467000	30074	14808	9	0	\N
225993	2134	11289463000	30074	14808	10	0	\N
225994	2134	11288459000	30074	14808	11	0	\N
225995	2134	11287455000	30074	14808	12	0	\N
225996	2134	11286451000	30074	14808	13	0	\N
225997	2134	11285447000	30074	14808	14	0	\N
225998	2134	11284443000	30074	14808	15	0	\N
225999	2132	6624639000	30074	14808	16	0	\N
226000	2132	6623638000	30074	14808	17	0	\N
226001	2132	6622637000	30074	14808	18	0	\N
226021	1397	1256191754000	30076	14808	0	0	\N
226022	1397	1256181753000	30076	14808	1	0	\N
226023	2132	6624639000	30076	14808	2	0	\N
226024	2132	6623638000	30076	14808	3	0	\N
226025	2132	6622637000	30076	14808	4	0	\N
225899	2133	8205566000	30065	14802	2	0	8220
225900	2133	8204564000	30065	14802	3	0	8221
225901	2134	11318579000	30065	14802	4	0	8994
225902	2134	11317575000	30065	14802	5	0	8995
225903	2134	11316571000	30065	14802	6	0	8996
225905	2132	6633648000	30065	14802	8	0	2354
225906	1397	1256241759000	30066	14803	0	0	18258
225907	2338	6000000	30066	14803	1	0	4
225908	2133	8203562000	30066	14803	2	0	8222
225909	2134	11314563000	30066	14803	3	0	8998
225911	2132	6632647000	30066	14803	5	0	2355
225912	2132	6631646000	30066	14803	6	0	2356
225913	2133	8202560000	30066	14803	7	0	8223
225914	2134	11312555000	30066	14803	8	0	9000
225916	2134	11310547000	30066	14803	10	0	9002
225917	1397	1256231758000	30067	14804	0	0	18259
225918	2132	6630645000	30067	14804	1	0	2357
225919	2133	8201558000	30067	14804	2	0	8224
225920	2134	11309543000	30067	14804	3	0	9003
225922	2133	8200556000	30067	14804	5	0	8225
225923	2134	11307535000	30067	14804	6	0	9005
225924	2134	11306531000	30067	14804	7	0	9006
225942	1397	1256221757000	30070	14805	0	0	18260
225943	2133	8199554000	30070	14805	1	0	8226
225945	2132	6628643000	30070	14805	3	0	2359
225946	2134	11305527000	30070	14805	4	0	9007
225947	2134	11304523000	30070	14805	5	0	9008
225948	2134	11303519000	30070	14805	6	0	9009
225950	2134	11301511000	30070	14805	8	0	9011
225951	2133	8198552000	30070	14805	9	0	8227
225952	2133	8197550000	30070	14805	10	0	8228
225964	1397	1256211756000	30072	14806	0	0	18261
225965	2133	8196548000	30072	14806	1	0	8229
225967	2134	11300507000	30072	14806	3	0	9012
225968	2134	11299503000	30072	14806	4	0	9013
225969	2134	11298499000	30072	14806	5	0	9014
225970	2134	11297495000	30072	14806	6	0	9015
225971	2132	6627642000	30072	14806	7	0	2360
225973	1533	715910000000	30073	14807	1	0	2
225974	1397	1256201755000	30073	14807	2	0	18262
225975	2133	8194544000	30073	14807	3	0	8231
225976	2133	8193542000	30073	14807	4	0	8232
225978	2134	11295487000	30073	14807	6	0	9017
225979	2134	11294483000	30073	14807	7	0	9018
225980	2134	11293479000	30073	14807	8	0	9019
225981	2132	6626641000	30073	14807	9	0	2361
225982	2132	6625640000	30073	14807	10	0	2362
226003	1397	1256181753000	30075	14808	1	0	18264
226004	2133	8192540000	30075	14808	2	0	8233
226005	2133	8191538000	30075	14808	3	0	8234
226006	2133	8190536000	30075	14808	4	0	8235
226007	2133	8189534000	30075	14808	5	0	8236
226009	2134	11292475000	30075	14808	7	0	9020
226010	2134	11291471000	30075	14808	8	0	9021
226011	2134	11290467000	30075	14808	9	0	9022
226012	2134	11289463000	30075	14808	10	0	9023
226014	2134	11287455000	30075	14808	12	0	9025
226015	2134	11286451000	30075	14808	13	0	9026
226016	2134	11285447000	30075	14808	14	0	9027
226017	2134	11284443000	30075	14808	15	0	9028
226018	2132	6624639000	30075	14808	16	0	2363
226020	2132	6622637000	30075	14808	18	0	2365
226026	1397	1256171752000	30077	14809	0	0	18265
226027	2134	11283439000	30077	14809	1	0	9029
226028	2133	8187530000	30077	14809	2	0	8238
226029	2133	8186528000	30077	14809	3	0	8239
226031	2134	11282435000	30077	14809	5	0	9030
226032	2133	8185526000	30077	14809	6	0	8240
226035	1397	1256161751000	30078	14810	0	0	\N
226036	2133	8184524000	30078	14810	1	0	\N
226037	2134	11279423000	30078	14810	2	0	\N
226038	2134	11278419000	30078	14810	3	0	\N
226039	2134	11277415000	30078	14810	4	0	\N
226040	2132	6620635000	30078	14810	5	0	\N
226041	2132	6619634000	30078	14810	6	0	\N
226042	2133	8183522000	30078	14810	7	0	\N
226043	2133	8182520000	30078	14810	8	0	\N
226044	2134	11276411000	30078	14810	9	0	\N
226065	1397	1256151750000	30081	14811	0	0	\N
226066	2134	11274403000	30081	14811	1	0	\N
226067	2133	8181518000	30081	14811	2	0	\N
226068	2134	11273399000	30081	14811	4	0	\N
226069	2134	11272395000	30081	14811	5	0	\N
226070	2134	11271391000	30081	14811	6	0	\N
226071	2133	8180516000	30081	14811	7	0	\N
226072	2133	8179514000	30081	14811	8	0	\N
226073	2132	6618633000	30081	14811	9	0	\N
226074	1397	1256151750000	30082	14811	0	0	\N
226075	2134	11274403000	30082	14811	1	0	\N
226076	2133	8181518000	30082	14811	2	0	\N
226077	2134	11273399000	30082	14811	4	0	\N
226078	2134	11272395000	30082	14811	5	0	\N
226079	2134	11271391000	30082	14811	6	0	\N
226080	2133	8180516000	30082	14811	7	0	\N
226081	2133	8179514000	30082	14811	8	0	\N
226082	2132	6618633000	30082	14811	9	0	\N
226083	1397	1256151750000	30083	14811	0	0	\N
226084	2134	11274403000	30083	14811	1	0	\N
226085	2133	8181518000	30083	14811	2	0	\N
226086	2134	11273399000	30083	14811	4	0	\N
226087	2134	11272395000	30083	14811	5	0	\N
226088	2134	11271391000	30083	14811	6	0	\N
226089	2133	8180516000	30083	14811	7	0	\N
226090	2133	8179514000	30083	14811	8	0	\N
226091	2132	6618633000	30083	14811	9	0	\N
226092	1397	1256151750000	30084	14811	0	0	\N
226093	2134	11274403000	30084	14811	1	0	\N
226094	2133	8181518000	30084	14811	2	0	\N
226095	2134	11273399000	30084	14811	4	0	\N
226096	2134	11272395000	30084	14811	5	0	\N
226097	2133	8180516000	30084	14811	6	0	\N
226098	2132	6618633000	30084	14811	7	0	\N
226136	1397	1256101745000	30087	14814	0	0	\N
226137	2133	8168492000	30087	14814	1	0	\N
226138	2132	6611626000	30087	14814	2	0	\N
226139	2133	8167490000	30087	14814	3	0	\N
226140	2132	6610625000	30087	14814	4	0	\N
226141	2134	11253319000	30087	14814	5	0	\N
226142	2134	11252315000	30087	14814	6	0	\N
226143	2134	11251311000	30087	14814	7	0	\N
226144	2134	11250307000	30087	14814	8	0	\N
226145	1397	1256101745000	30088	14814	0	0	\N
226146	2133	8168492000	30088	14814	1	0	\N
226147	2132	6611626000	30088	14814	2	0	\N
226148	2133	8167490000	30088	14814	3	0	\N
226149	2132	6610625000	30088	14814	4	0	\N
226150	2134	11253319000	30088	14814	5	0	\N
226151	2134	11252315000	30088	14814	6	0	\N
226152	2134	11251311000	30088	14814	7	0	\N
226153	2134	11250307000	30088	14814	8	0	\N
226154	1397	1256101745000	30089	14814	0	0	\N
226155	2133	8168492000	30089	14814	1	0	\N
226156	2132	6611626000	30089	14814	2	0	\N
226157	2133	8167490000	30089	14814	3	0	\N
226158	2132	6610625000	30089	14814	4	0	\N
226159	1397	1256101745000	30090	14814	0	0	\N
226160	2133	8168492000	30090	14814	1	0	\N
226161	2132	6611626000	30090	14814	2	0	\N
226162	2133	8167490000	30090	14814	3	0	\N
226163	2132	6610625000	30090	14814	4	0	\N
226164	2134	11253319000	30090	14814	5	0	\N
226165	2134	11252315000	30090	14814	6	0	\N
226166	2134	11251311000	30090	14814	7	0	\N
226167	2134	11250307000	30090	14814	8	0	\N
226045	1397	1256161751000	30079	14810	0	0	18266
226046	2133	8184524000	30079	14810	1	0	8241
226047	2134	11279423000	30079	14810	2	0	9033
226048	2134	11278419000	30079	14810	3	0	9034
226049	2134	11277415000	30079	14810	4	0	9035
226051	2132	6619634000	30079	14810	6	0	2368
226052	2133	8183522000	30079	14810	7	0	8242
226053	2133	8182520000	30079	14810	8	0	8243
226054	2134	11276411000	30079	14810	9	0	9036
226055	2134	11275407000	30079	14810	10	0	9037
226057	2134	11274403000	30080	14811	1	0	9038
226058	2133	8181518000	30080	14811	2	0	8244
226059	2134	11273399000	30080	14811	4	0	9039
226060	2134	11272395000	30080	14811	5	0	9040
226062	2133	8180516000	30080	14811	7	0	8245
226063	2133	8179514000	30080	14811	8	0	8246
226064	2132	6618633000	30080	14811	9	0	2369
226099	1397	1256141749000	30085	14812	0	0	18268
226100	2133	8178512000	30085	14812	1	0	8247
226102	2134	11269383000	30085	14812	3	0	9043
226103	2134	11268379000	30085	14812	4	0	9044
226104	2134	11267375000	30085	14812	5	0	9045
226105	2133	8177510000	30085	14812	6	0	8248
226106	2132	6617632000	30085	14812	7	0	2370
226108	1397	1256131748000	30086	14813	0	0	18269
226109	1397	1256121747000	30086	14813	1	0	18270
226110	1397	1256111746000	30086	14813	2	0	18271
226111	2133	8176508000	30086	14813	3	0	8249
226113	2134	11266371000	30086	14813	5	0	9046
226114	2134	11265367000	30086	14813	6	0	9047
226115	2134	11264363000	30086	14813	7	0	9048
226116	2134	11263359000	30086	14813	8	0	9049
226117	2132	6614629000	30086	14813	9	0	2373
226119	2132	6612627000	30086	14813	11	0	2375
226120	2134	11262355000	30086	14813	12	0	9050
226121	2133	8175506000	30086	14813	13	0	8250
226122	2133	8174504000	30086	14813	14	0	8251
226123	2133	8173502000	30086	14813	15	0	8252
226125	2133	8171498000	30086	14813	17	0	8254
226126	2133	8170496000	30086	14813	18	0	8255
226127	2133	8169494000	30086	14813	19	0	8256
226128	2134	11261351000	30086	14813	20	0	9051
226130	2134	11259343000	30086	14813	22	0	9053
226131	2134	11258339000	30086	14813	23	0	9054
226132	2134	11257335000	30086	14813	24	0	9055
226133	2134	11256331000	30086	14813	25	0	9056
226134	2134	11255327000	30086	14813	26	0	9057
226168	1397	1256101745000	30091	14814	0	0	18272
226177	1397	1256091744000	30092	14815	0	0	\N
226178	2133	8166488000	30092	14815	1	0	\N
226179	2132	6609624000	30092	14815	2	0	\N
226180	2134	11249303000	30092	14815	3	0	\N
226181	2134	11248299000	30092	14815	4	0	\N
226182	2133	8165486000	30092	14815	5	0	\N
226183	2134	11247295000	30092	14815	6	0	\N
226184	2134	11246291000	30092	14815	7	0	\N
226185	2134	11245287000	30092	14815	8	0	\N
226186	1397	1256091744000	30093	14815	0	0	\N
226187	2133	8166488000	30093	14815	1	0	\N
226188	2132	6609624000	30093	14815	2	0	\N
226189	2134	11249303000	30093	14815	3	0	\N
226190	2134	11248299000	30093	14815	4	0	\N
226191	2133	8165486000	30093	14815	5	0	\N
226192	2134	11247295000	30093	14815	6	0	\N
226193	2134	11246291000	30093	14815	7	0	\N
226203	1397	1256081743000	30095	14816	0	0	\N
226204	2132	6608623000	30095	14816	1	0	\N
226205	2134	11244283000	30095	14816	2	0	\N
226206	2134	11243279000	30095	14816	3	0	\N
226207	2134	11242275000	30095	14816	4	0	\N
226208	2134	11241271000	30095	14816	5	0	\N
226209	2133	8164484000	30095	14816	6	0	\N
226210	2133	8163482000	30095	14816	7	0	\N
226211	2132	6607622000	30095	14816	8	0	\N
226212	1397	1256081743000	30096	14816	0	0	\N
226213	2132	6608623000	30096	14816	1	0	\N
226214	2134	11244283000	30096	14816	2	0	\N
226215	2134	11243279000	30096	14816	3	0	\N
226216	2134	11242275000	30096	14816	4	0	\N
226217	2134	11241271000	30096	14816	5	0	\N
226218	2133	8164484000	30096	14816	6	0	\N
226219	2133	8163482000	30096	14816	7	0	\N
226220	2132	6607622000	30096	14816	8	0	\N
226249	1533	717960000000	30099	14773	0	0	\N
226250	1533	715910000000	30099	14773	1	0	\N
226251	1992	1236990000	30099	14773	2	0	\N
226252	1397	1256681803000	30099	14773	3	0	\N
226253	1397	1256671802000	30099	14773	4	0	\N
226254	1397	1256661801000	30099	14773	5	0	\N
226255	1397	1256651800000	30099	14773	6	0	\N
226256	1397	1256641799000	30099	14773	7	0	\N
226257	1397	1256631798000	30099	14773	8	0	\N
226258	1397	1256621797000	30099	14773	9	0	\N
226259	1397	1256611796000	30099	14773	10	0	\N
226260	1397	1256601795000	30099	14773	11	0	\N
226261	1397	1256591794000	30099	14773	12	0	\N
226262	1397	1256581793000	30099	14773	13	0	\N
226263	1397	1256571792000	30099	14773	14	0	\N
226264	1397	1256561791000	30099	14773	15	0	\N
226265	1397	1256551790000	30099	14773	16	0	\N
226266	1397	1256541789000	30099	14773	17	0	\N
226267	1397	1256531788000	30099	14773	18	0	\N
226268	1397	1256521787000	30099	14773	19	0	\N
226269	1397	1256511786000	30099	14773	20	0	\N
226270	1397	1256501785000	30099	14773	21	0	\N
226271	1397	1256491784000	30099	14773	22	0	\N
226272	1397	1256481783000	30099	14773	23	0	\N
226273	1397	1256471782000	30099	14773	24	0	\N
226274	1397	1256461781000	30099	14773	25	0	\N
226275	1397	1256451780000	30099	14773	26	0	\N
226276	1397	1256441779000	30099	14773	27	0	\N
226277	1397	1256431778000	30099	14773	28	0	\N
226278	1397	1256421777000	30099	14773	29	0	\N
226279	1397	1256411776000	30099	14773	30	0	\N
226280	1397	1256401775000	30099	14773	31	0	\N
226281	1397	1256391774000	30099	14773	32	0	\N
226282	1397	1256381773000	30099	14773	33	0	\N
226283	1397	1256371772000	30099	14773	34	0	\N
226284	1397	1256361771000	30099	14773	35	0	\N
226285	1397	1256351770000	30099	14773	36	0	\N
226286	1397	1256341769000	30099	14773	37	0	\N
226287	1397	1256331768000	30099	14773	38	0	\N
226288	1397	1256321767000	30099	14773	39	0	\N
226289	1397	1256311766000	30099	14773	40	0	\N
226290	1397	1256301765000	30099	14773	41	0	\N
226291	1397	1256291764000	30099	14773	42	0	\N
226292	1397	1256281763000	30099	14773	43	0	\N
226293	1397	1256271762000	30099	14773	44	0	\N
226294	1397	1256261761000	30099	14773	45	0	\N
226295	1397	1256251760000	30099	14773	46	0	\N
226296	1397	1256241759000	30099	14773	47	0	\N
226297	1397	1256231758000	30099	14773	48	0	\N
226298	1397	1256221757000	30099	14773	49	0	\N
226299	1397	1256211756000	30099	14773	50	0	\N
226300	1397	1256201755000	30099	14773	51	0	\N
226301	1397	1256191754000	30099	14773	52	0	\N
226302	1397	1256181753000	30099	14773	53	0	\N
226303	1397	1256171752000	30099	14773	54	0	\N
226304	1397	1256161751000	30099	14773	55	0	\N
226171	2133	8167490000	30091	14814	3	0	8258
226172	2132	6610625000	30091	14814	4	0	2377
226173	2134	11253319000	30091	14814	5	0	9059
226174	2134	11252315000	30091	14814	6	0	9060
226175	2134	11251311000	30091	14814	7	0	9061
226194	1397	1256091744000	30094	14815	0	0	18273
226195	2133	8166488000	30094	14815	1	0	8259
226196	2132	6609624000	30094	14815	2	0	2378
226197	2134	11249303000	30094	14815	3	0	9063
226198	2134	11248299000	30094	14815	4	0	9064
226200	2134	11247295000	30094	14815	6	0	9065
226201	2134	11246291000	30094	14815	7	0	9066
226202	2134	11245287000	30094	14815	8	0	9067
226221	1397	1256081743000	30097	14816	0	0	18274
226223	1397	1256071742000	30098	14817	0	0	18275
226224	1397	1256061741000	30098	14817	1	0	18276
226225	2134	11244283000	30098	14817	2	0	9068
226226	2134	11243279000	30098	14817	3	0	9069
226227	2134	11242275000	30098	14817	4	0	9070
226229	2134	11240267000	30098	14817	6	0	9072
226230	2134	11239263000	30098	14817	7	0	9073
226231	2134	11238259000	30098	14817	8	0	9074
226232	2133	8164484000	30098	14817	9	0	8261
226233	2134	11237255000	30098	14817	10	0	9075
226235	2134	11235247000	30098	14817	12	0	9077
226236	2134	11234243000	30098	14817	13	0	9078
226237	2134	11233239000	30098	14817	14	0	9079
226238	2134	11232235000	30098	14817	15	0	9080
226240	2132	6607622000	30098	14817	17	0	2380
226241	2132	6606621000	30098	14817	18	0	2381
226242	2132	6605620000	30098	14817	19	0	2382
226243	2132	6604619000	30098	14817	20	0	2383
226244	2133	8162480000	30098	14817	21	0	8263
226246	2133	8160476000	30098	14817	23	0	8265
226247	2133	8159474000	30098	14817	24	0	8266
226248	2133	8158472000	30098	14817	25	0	8267
226305	1397	1256151750000	30099	14773	56	0	\N
226306	1397	1256141749000	30099	14773	57	0	\N
226307	1397	1256131748000	30099	14773	58	0	\N
226308	1397	1256121747000	30099	14773	59	0	\N
226309	1397	1256111746000	30099	14773	60	0	\N
226310	1397	1256101745000	30099	14773	61	0	\N
226311	1397	1256091744000	30099	14773	62	0	\N
226312	1397	1256081743000	30099	14773	63	0	\N
226313	1397	1256071742000	30099	14773	64	0	\N
226314	2338	6000000	30099	14773	65	0	\N
226315	2041	2879000000000	30099	14773	66	0	\N
226316	1726	111916112000	30099	14773	67	0	\N
226317	1726	110815112000	30099	14773	68	0	\N
226318	2134	11509339000	30099	14773	69	0	\N
226319	2134	11508335000	30099	14773	70	0	\N
226320	2132	6696711000	30099	14773	71	0	\N
226321	2132	6695710000	30099	14773	72	0	\N
226322	2132	6694709000	30099	14773	73	0	\N
226323	2133	8315786000	30099	14773	74	0	\N
226324	2133	8314784000	30099	14773	75	0	\N
226325	2133	8313782000	30099	14773	76	0	\N
226326	2132	6693708000	30099	14773	77	0	\N
226327	2132	6692707000	30099	14773	78	0	\N
226328	1726	110714112000	30099	14773	79	0	\N
226329	1726	109613112000	30099	14773	80	0	\N
226330	1726	108512112000	30099	14773	81	0	\N
226331	2132	6691706000	30099	14773	82	0	\N
226332	2132	6690705000	30099	14773	83	0	\N
226333	2132	6689704000	30099	14773	84	0	\N
226334	2132	6688703000	30099	14773	85	0	\N
226335	2132	6687702000	30099	14773	86	0	\N
226336	2132	6686701000	30099	14773	87	0	\N
226337	2132	6685700000	30099	14773	88	0	\N
226338	2132	6684699000	30099	14773	89	0	\N
226339	2132	6683698000	30099	14773	90	0	\N
226340	2132	6682697000	30099	14773	91	0	\N
226341	2132	6681696000	30099	14773	92	0	\N
226342	2132	6680695000	30099	14773	93	0	\N
226343	2132	6679694000	30099	14773	94	0	\N
226344	2132	6678693000	30099	14773	95	0	\N
226345	2132	6677692000	30099	14773	97	0	\N
226346	2132	6676691000	30099	14773	98	0	\N
226347	2132	6675690000	30099	14773	99	0	\N
226348	2132	6674689000	30099	14773	100	0	\N
226349	2132	6673688000	30099	14773	101	0	\N
226350	2132	6672687000	30099	14773	102	0	\N
226351	2132	6671686000	30099	14773	103	0	\N
226352	2132	6670685000	30099	14773	104	0	\N
226353	2132	6669684000	30099	14773	105	0	\N
226354	2132	6668683000	30099	14773	106	0	\N
226355	2132	6667682000	30099	14773	107	0	\N
226356	2132	6666681000	30099	14773	108	0	\N
226357	2132	6665680000	30099	14773	109	0	\N
226358	2132	6664679000	30099	14773	110	0	\N
226359	2132	6663678000	30099	14773	111	0	\N
226360	2132	6662677000	30099	14773	112	0	\N
226361	2132	6661676000	30099	14773	113	0	\N
226362	2132	6660675000	30099	14773	114	0	\N
226363	2132	6659674000	30099	14773	115	0	\N
226364	2132	6658673000	30099	14773	116	0	\N
226365	2132	6657672000	30099	14773	117	0	\N
226366	2132	6656671000	30099	14773	118	0	\N
226367	2132	6655670000	30099	14773	119	0	\N
226368	2132	6654669000	30099	14773	120	0	\N
226369	2132	6653668000	30099	14773	121	0	\N
226370	2132	6652667000	30099	14773	122	0	\N
226371	1397	1256051740000	30100	14818	0	0	\N
226372	2133	8157470000	30100	14818	1	0	\N
226373	2132	6603618000	30100	14818	2	0	\N
226374	2134	11231231000	30100	14818	3	0	\N
226375	2133	8156468000	30100	14818	4	0	\N
226376	2133	8155466000	30100	14818	5	0	\N
226377	2134	11230227000	30100	14818	6	0	\N
226378	2134	11229223000	30100	14818	7	0	\N
226379	2134	11228219000	30100	14818	8	0	\N
226382	1397	1256051740000	30102	14818	0	0	\N
226383	2133	8157470000	30102	14818	1	0	\N
226384	2132	6603618000	30102	14818	2	0	\N
226385	2134	11231231000	30102	14818	3	0	\N
226386	2133	8156468000	30102	14818	4	0	\N
226387	2133	8155466000	30102	14818	5	0	\N
226388	2134	11230227000	30102	14818	6	0	\N
226389	2134	11229223000	30102	14818	7	0	\N
226390	2134	11228219000	30102	14818	8	0	\N
226391	1397	1256051740000	30103	14818	0	0	\N
226392	2133	8157470000	30103	14818	1	0	\N
226393	2132	6603618000	30103	14818	2	0	\N
226394	2134	11231231000	30103	14818	3	0	\N
226395	2133	8156468000	30103	14818	4	0	\N
226396	2134	11230227000	30103	14818	5	0	\N
226397	2134	11229223000	30103	14818	6	0	\N
226398	2134	11228219000	30103	14818	7	0	\N
226399	1397	1256051740000	30104	14818	0	0	\N
226400	2133	8157470000	30104	14818	1	0	\N
226401	2132	6603618000	30104	14818	2	0	\N
226402	2134	11231231000	30104	14818	3	0	\N
226403	2133	8156468000	30104	14818	4	0	\N
226404	2133	8155466000	30104	14818	5	0	\N
226405	2134	11230227000	30104	14818	6	0	\N
226406	2134	11229223000	30104	14818	7	0	\N
226407	2134	11228219000	30104	14818	8	0	\N
226408	1397	1256051740000	30105	14818	0	0	\N
226409	2133	8157470000	30105	14818	1	0	\N
226410	2132	6603618000	30105	14818	2	0	\N
226411	2133	8156468000	30105	14818	3	0	\N
226412	2133	8155466000	30105	14818	4	0	\N
226416	1397	1256041739000	30107	14819	0	0	\N
226417	1397	1256031738000	30107	14819	1	0	\N
226418	1397	1256021737000	30107	14819	2	0	\N
226419	2132	6602617000	30107	14819	3	0	\N
226420	2133	8157470000	30107	14819	4	0	\N
226421	2132	6601616000	30107	14819	5	0	\N
226422	2132	6600615000	30107	14819	6	0	\N
226423	2132	6599614000	30107	14819	7	0	\N
226424	2134	11231231000	30107	14819	8	0	\N
226425	2133	8156468000	30107	14819	9	0	\N
226426	2133	8155466000	30107	14819	10	0	\N
226427	2133	8154464000	30107	14819	11	0	\N
226428	2133	8153462000	30107	14819	12	0	\N
226429	2133	8152460000	30107	14819	13	0	\N
226430	2133	8151458000	30107	14819	14	0	\N
226431	2133	8150456000	30107	14819	15	0	\N
226432	2133	8149454000	30107	14819	17	0	\N
226433	2133	8148452000	30107	14819	18	0	\N
226434	2133	8147450000	30107	14819	19	0	\N
226435	2134	11230227000	30107	14819	20	0	\N
226436	2134	11229223000	30107	14819	21	0	\N
226437	2134	11228219000	30107	14819	22	0	\N
226438	1397	1256041739000	30108	14819	0	0	\N
226439	1397	1256031738000	30108	14819	1	0	\N
226440	1397	1256021737000	30108	14819	2	0	\N
226413	1397	1256041739000	30106	14819	0	0	18278
226414	1397	1256031738000	30106	14819	1	0	18279
226415	1397	1256021737000	30106	14819	2	0	18280
226441	2132	6602617000	30108	14819	3	0	\N
226442	2133	8157470000	30108	14819	4	0	\N
226443	2132	6601616000	30108	14819	5	0	\N
226444	2132	6600615000	30108	14819	6	0	\N
226445	2132	6599614000	30108	14819	7	0	\N
226446	2134	11231231000	30108	14819	8	0	\N
226447	2133	8156468000	30108	14819	9	0	\N
226448	2133	8155466000	30108	14819	10	0	\N
226449	2133	8154464000	30108	14819	11	0	\N
226450	2133	8153462000	30108	14819	12	0	\N
226451	2133	8152460000	30108	14819	13	0	\N
226452	2133	8151458000	30108	14819	14	0	\N
226453	2133	8150456000	30108	14819	15	0	\N
226454	2133	8149454000	30108	14819	17	0	\N
226455	2133	8148452000	30108	14819	18	0	\N
226456	2133	8147450000	30108	14819	19	0	\N
226457	2134	11230227000	30108	14819	20	0	\N
226458	2134	11229223000	30108	14819	21	0	\N
226459	2134	11228219000	30108	14819	22	0	\N
226460	2134	11227215000	30108	14819	23	0	\N
226461	2134	11226211000	30108	14819	24	0	\N
226462	2134	11225207000	30108	14819	25	0	\N
226463	2134	11224203000	30108	14819	26	0	\N
226464	2134	11223199000	30108	14819	27	0	\N
226465	2134	11222195000	30108	14819	28	0	\N
226466	2134	11221191000	30108	14819	29	0	\N
226467	2134	11220187000	30108	14819	30	0	\N
226468	2134	11219183000	30108	14819	31	0	\N
226469	2134	11218179000	30108	14819	32	0	\N
226470	2134	11217175000	30108	14819	33	0	\N
226471	2134	11216171000	30108	14819	34	0	\N
226472	2134	11215167000	30108	14819	35	0	\N
226473	234	66531385942306	30109	14820	0	0	\N
226474	1397	1256011736000	30109	14820	1	0	\N
226475	1397	1256001735000	30109	14820	2	0	\N
226476	2132	6602617000	30109	14820	3	0	\N
226477	2133	8157470000	30109	14820	4	0	\N
226478	2132	6601616000	30109	14820	5	0	\N
226479	2132	6600615000	30109	14820	6	0	\N
226480	2132	6599614000	30109	14820	7	0	\N
226481	2132	6598613000	30109	14820	8	0	\N
226482	2134	11231231000	30109	14820	9	0	\N
226483	2133	8156468000	30109	14820	10	0	\N
226484	2133	8155466000	30109	14820	12	0	\N
226485	2132	6597612000	30109	14820	13	0	\N
226486	2133	8154464000	30109	14820	14	0	\N
226487	2133	8153462000	30109	14820	15	0	\N
226488	2133	8152460000	30109	14820	16	0	\N
226489	2133	8151458000	30109	14820	17	0	\N
226490	2133	8150456000	30109	14820	18	0	\N
226491	2133	8149454000	30109	14820	19	0	\N
226492	2133	8148452000	30109	14820	20	0	\N
226493	2133	8147450000	30109	14820	21	0	\N
226494	2133	8146448000	30109	14820	22	0	\N
226495	2134	11230227000	30109	14820	23	0	\N
226496	2134	11229223000	30109	14820	24	0	\N
226497	2134	11228219000	30109	14820	25	0	\N
226498	2132	6596611000	30109	14820	26	0	\N
226499	2134	11227215000	30109	14820	27	0	\N
226500	2134	11226211000	30109	14820	28	0	\N
226501	2134	11225207000	30109	14820	29	0	\N
226502	2134	11224203000	30109	14820	30	0	\N
226503	2134	11223199000	30109	14820	31	0	\N
226504	2134	11222195000	30109	14820	32	0	\N
226505	2134	11221191000	30109	14820	33	0	\N
226506	2134	11220187000	30109	14820	34	0	\N
226507	2134	11219183000	30109	14820	35	0	\N
226508	2134	11218179000	30109	14820	36	0	\N
226509	2134	11217175000	30109	14820	37	0	\N
226510	2134	11216171000	30109	14820	38	0	\N
226511	2134	11215167000	30109	14820	39	0	\N
226512	2134	11214163000	30109	14820	40	0	\N
226513	2134	11213159000	30109	14820	41	0	\N
226514	2134	11212155000	30109	14820	42	0	\N
226515	2134	11211151000	30109	14820	43	0	\N
226516	2134	11210147000	30109	14820	44	0	\N
226517	2134	11209143000	30109	14820	45	0	\N
226518	2134	11208139000	30109	14820	46	0	\N
226519	2134	11207135000	30109	14820	47	0	\N
226520	2134	11206131000	30109	14820	48	0	\N
226521	2133	8145446000	30109	14820	49	0	\N
226522	2133	8144444000	30109	14820	50	0	\N
226523	2133	8143442000	30109	14820	51	0	\N
226524	2133	8142440000	30109	14820	52	0	\N
226525	234	66531385942306	30110	14820	0	0	\N
226526	1397	1256011736000	30110	14820	1	0	\N
226527	1397	1256001735000	30110	14820	2	0	\N
226528	2132	6602617000	30110	14820	3	0	\N
226529	2133	8157470000	30110	14820	4	0	\N
226530	2132	6601616000	30110	14820	5	0	\N
226531	2132	6600615000	30110	14820	6	0	\N
226532	2132	6599614000	30110	14820	7	0	\N
226533	2132	6598613000	30110	14820	8	0	\N
226534	2134	11231231000	30110	14820	9	0	\N
226535	2133	8156468000	30110	14820	10	0	\N
226536	2133	8155466000	30110	14820	12	0	\N
226537	2132	6597612000	30110	14820	13	0	\N
226538	2133	8154464000	30110	14820	14	0	\N
226539	2133	8153462000	30110	14820	15	0	\N
226540	2133	8152460000	30110	14820	16	0	\N
226541	2133	8151458000	30110	14820	17	0	\N
226542	2133	8150456000	30110	14820	18	0	\N
226543	2133	8149454000	30110	14820	19	0	\N
226544	2133	8148452000	30110	14820	20	0	\N
226545	2133	8147450000	30110	14820	21	0	\N
226546	2133	8146448000	30110	14820	22	0	\N
226547	2134	11230227000	30110	14820	23	0	\N
226548	2134	11229223000	30110	14820	24	0	\N
226549	2134	11228219000	30110	14820	25	0	\N
226550	2132	6596611000	30110	14820	26	0	\N
226551	2134	11227215000	30110	14820	27	0	\N
226552	2134	11226211000	30110	14820	28	0	\N
226553	2134	11225207000	30110	14820	29	0	\N
226554	2134	11224203000	30110	14820	30	0	\N
226555	2134	11223199000	30110	14820	31	0	\N
226556	2134	11222195000	30110	14820	32	0	\N
226557	2134	11221191000	30110	14820	33	0	\N
226558	2134	11220187000	30110	14820	34	0	\N
226559	2134	11219183000	30110	14820	35	0	\N
226560	2134	11218179000	30110	14820	36	0	\N
226561	2134	11217175000	30110	14820	37	0	\N
226562	2134	11216171000	30110	14820	38	0	\N
226563	2134	11215167000	30110	14820	39	0	\N
226564	2134	11214163000	30110	14820	40	0	\N
226565	2134	11213159000	30110	14820	41	0	\N
226566	2134	11212155000	30110	14820	42	0	\N
226567	2134	11211151000	30110	14820	43	0	\N
226568	2134	11210147000	30110	14820	44	0	\N
226569	2134	11209143000	30110	14820	45	0	\N
226570	2134	11208139000	30110	14820	46	0	\N
226571	2134	11207135000	30110	14820	47	0	\N
226572	2134	11206131000	30110	14820	48	0	\N
226573	2133	8145446000	30110	14820	49	0	\N
226574	2133	8144444000	30110	14820	50	0	\N
226575	2133	8143442000	30110	14820	51	0	\N
226576	2133	8142440000	30110	14820	52	0	\N
226629	234	66531385942306	30112	14820	0	0	\N
226630	1397	1256011736000	30112	14820	1	0	\N
226631	1397	1256001735000	30112	14820	2	0	\N
226632	2132	6602617000	30112	14820	3	0	\N
226633	2133	8157470000	30112	14820	4	0	\N
226634	2132	6601616000	30112	14820	5	0	\N
226635	2132	6600615000	30112	14820	6	0	\N
226636	2132	6599614000	30112	14820	7	0	\N
226637	2132	6598613000	30112	14820	8	0	\N
226638	2134	11231231000	30112	14820	9	0	\N
226639	2133	8156468000	30112	14820	10	0	\N
226640	2133	8155466000	30112	14820	12	0	\N
226641	2132	6597612000	30112	14820	13	0	\N
226642	2133	8154464000	30112	14820	14	0	\N
226643	2133	8153462000	30112	14820	15	0	\N
226644	2133	8152460000	30112	14820	16	0	\N
226645	2133	8151458000	30112	14820	17	0	\N
226646	2133	8150456000	30112	14820	18	0	\N
226647	2133	8149454000	30112	14820	19	0	\N
226648	2133	8148452000	30112	14820	20	0	\N
226649	2133	8147450000	30112	14820	21	0	\N
226650	2133	8146448000	30112	14820	22	0	\N
226651	2134	11230227000	30112	14820	23	0	\N
226652	2134	11229223000	30112	14820	24	0	\N
226653	2134	11228219000	30112	14820	25	0	\N
226654	2132	6596611000	30112	14820	26	0	\N
226655	2133	8145446000	30112	14820	27	0	\N
226656	2133	8144444000	30112	14820	28	0	\N
226657	2133	8143442000	30112	14820	29	0	\N
226658	2133	8142440000	30112	14820	30	0	\N
226659	234	66531385942306	30113	14820	0	0	\N
226660	1397	1256011736000	30113	14820	1	0	\N
226661	1397	1256001735000	30113	14820	2	0	\N
226662	2132	6602617000	30113	14820	3	0	\N
226663	2133	8157470000	30113	14820	4	0	\N
226664	2132	6601616000	30113	14820	5	0	\N
226665	2132	6600615000	30113	14820	6	0	\N
226666	2132	6599614000	30113	14820	7	0	\N
226667	2132	6598613000	30113	14820	8	0	\N
226668	2134	11231231000	30113	14820	9	0	\N
226669	2133	8156468000	30113	14820	10	0	\N
226670	2133	8155466000	30113	14820	12	0	\N
226671	2132	6597612000	30113	14820	13	0	\N
226672	2133	8154464000	30113	14820	14	0	\N
226673	2133	8153462000	30113	14820	15	0	\N
226674	2133	8152460000	30113	14820	16	0	\N
226675	2133	8151458000	30113	14820	17	0	\N
226676	2133	8150456000	30113	14820	18	0	\N
226677	2133	8149454000	30113	14820	19	0	\N
226678	2133	8148452000	30113	14820	20	0	\N
226679	2133	8147450000	30113	14820	21	0	\N
226680	2133	8146448000	30113	14820	22	0	\N
226681	2134	11230227000	30113	14820	23	0	\N
226682	2134	11229223000	30113	14820	24	0	\N
226683	2134	11228219000	30113	14820	25	0	\N
226684	2132	6596611000	30113	14820	26	0	\N
226685	2134	11227215000	30113	14820	27	0	\N
226686	2134	11226211000	30113	14820	28	0	\N
226687	2134	11225207000	30113	14820	29	0	\N
226688	2134	11224203000	30113	14820	30	0	\N
226689	2134	11223199000	30113	14820	31	0	\N
226690	2134	11222195000	30113	14820	32	0	\N
226691	2134	11221191000	30113	14820	33	0	\N
226692	2134	11220187000	30113	14820	34	0	\N
226693	2134	11219183000	30113	14820	35	0	\N
226694	2134	11218179000	30113	14820	36	0	\N
226695	2134	11217175000	30113	14820	37	0	\N
226696	2134	11216171000	30113	14820	38	0	\N
226697	2134	11215167000	30113	14820	39	0	\N
226698	2134	11214163000	30113	14820	40	0	\N
226699	2134	11213159000	30113	14820	41	0	\N
226700	2134	11212155000	30113	14820	42	0	\N
226701	2134	11211151000	30113	14820	43	0	\N
226702	2134	11210147000	30113	14820	44	0	\N
226703	2134	11209143000	30113	14820	45	0	\N
226704	2134	11208139000	30113	14820	46	0	\N
226705	2134	11207135000	30113	14820	47	0	\N
226706	2134	11206131000	30113	14820	48	0	\N
226707	2133	8145446000	30113	14820	49	0	\N
226708	2133	8144444000	30113	14820	50	0	\N
226709	2133	8143442000	30113	14820	51	0	\N
226710	2133	8142440000	30113	14820	52	0	\N
226711	234	66531385942306	30114	14820	0	0	\N
226712	1397	1256011736000	30114	14820	1	0	\N
226579	1397	1256001735000	30111	14820	2	0	18282
226580	2132	6602617000	30111	14820	3	0	2385
226581	2133	8157470000	30111	14820	4	0	8268
226582	2132	6601616000	30111	14820	5	0	2386
226583	2132	6600615000	30111	14820	6	0	2387
226585	2132	6598613000	30111	14820	8	0	2389
226586	2134	11231231000	30111	14820	9	0	9081
226587	2133	8156468000	30111	14820	10	0	8269
226588	2133	8155466000	30111	14820	12	0	8270
226589	2132	6597612000	30111	14820	13	0	2390
226591	2133	8153462000	30111	14820	15	0	8272
226592	2133	8152460000	30111	14820	16	0	8273
226593	2133	8151458000	30111	14820	17	0	8274
226594	2133	8150456000	30111	14820	18	0	8275
226596	2133	8148452000	30111	14820	20	0	8277
226597	2133	8147450000	30111	14820	21	0	8278
226598	2133	8146448000	30111	14820	22	0	8279
226599	2134	11230227000	30111	14820	23	0	9082
226600	2134	11229223000	30111	14820	24	0	9083
226602	2132	6596611000	30111	14820	26	0	2391
226603	2134	11227215000	30111	14820	27	0	9085
226604	2134	11226211000	30111	14820	28	0	9086
226605	2134	11225207000	30111	14820	29	0	9087
226606	2134	11224203000	30111	14820	30	0	9088
226608	2134	11222195000	30111	14820	32	0	9090
226609	2134	11221191000	30111	14820	33	0	9091
226610	2134	11220187000	30111	14820	34	0	9092
226611	2134	11219183000	30111	14820	35	0	9093
226613	2134	11217175000	30111	14820	37	0	9095
226614	2134	11216171000	30111	14820	38	0	9096
226615	2134	11215167000	30111	14820	39	0	9097
226616	2134	11214163000	30111	14820	40	0	9098
226617	2134	11213159000	30111	14820	41	0	9099
226619	2134	11211151000	30111	14820	43	0	9101
226620	2134	11210147000	30111	14820	44	0	9102
226621	2134	11209143000	30111	14820	45	0	9103
226622	2134	11208139000	30111	14820	46	0	9104
226623	2134	11207135000	30111	14820	47	0	9105
226625	2133	8145446000	30111	14820	49	0	8280
226626	2133	8144444000	30111	14820	50	0	8281
226627	2133	8143442000	30111	14820	51	0	8282
226628	2133	8142440000	30111	14820	52	0	8283
226713	1397	1256001735000	30114	14820	2	0	\N
226714	2132	6602617000	30114	14820	3	0	\N
226715	2133	8157470000	30114	14820	4	0	\N
226716	2132	6601616000	30114	14820	5	0	\N
226717	2132	6600615000	30114	14820	6	0	\N
226718	2132	6599614000	30114	14820	7	0	\N
226719	2132	6598613000	30114	14820	8	0	\N
226720	2133	8156468000	30114	14820	9	0	\N
226721	2133	8155466000	30114	14820	10	0	\N
226722	2132	6597612000	30114	14820	12	0	\N
226723	2133	8154464000	30114	14820	13	0	\N
226724	2133	8153462000	30114	14820	14	0	\N
226725	2133	8152460000	30114	14820	15	0	\N
226726	2133	8151458000	30114	14820	16	0	\N
226727	2133	8150456000	30114	14820	17	0	\N
226728	2133	8149454000	30114	14820	18	0	\N
226729	2133	8148452000	30114	14820	19	0	\N
226730	2133	8147450000	30114	14820	20	0	\N
226731	2133	8146448000	30114	14820	21	0	\N
226732	2132	6596611000	30114	14820	22	0	\N
226733	2133	8145446000	30114	14820	23	0	\N
226734	2133	8144444000	30114	14820	24	0	\N
226735	2133	8143442000	30114	14820	25	0	\N
226736	2133	8142440000	30114	14820	26	0	\N
226737	234	66531385942306	30115	14820	0	0	\N
226738	1397	1256011736000	30115	14820	1	0	\N
226739	1397	1256001735000	30115	14820	2	0	\N
226740	2132	6602617000	30115	14820	3	0	\N
226741	2133	8157470000	30115	14820	4	0	\N
226742	2132	6601616000	30115	14820	5	0	\N
226743	2132	6600615000	30115	14820	6	0	\N
226744	2132	6599614000	30115	14820	7	0	\N
226745	2132	6598613000	30115	14820	8	0	\N
226746	2134	11231231000	30115	14820	9	0	\N
226747	2133	8156468000	30115	14820	10	0	\N
226748	2133	8155466000	30115	14820	12	0	\N
226749	2132	6597612000	30115	14820	13	0	\N
226750	2133	8154464000	30115	14820	14	0	\N
226751	2133	8153462000	30115	14820	15	0	\N
226752	2133	8152460000	30115	14820	16	0	\N
226753	2133	8151458000	30115	14820	17	0	\N
226754	2133	8150456000	30115	14820	18	0	\N
226755	2133	8149454000	30115	14820	19	0	\N
226756	2133	8148452000	30115	14820	20	0	\N
226757	2133	8147450000	30115	14820	21	0	\N
226758	2133	8146448000	30115	14820	22	0	\N
226759	2134	11230227000	30115	14820	23	0	\N
226760	2134	11229223000	30115	14820	24	0	\N
226761	2134	11228219000	30115	14820	25	0	\N
226762	2132	6596611000	30115	14820	26	0	\N
226763	2134	11227215000	30115	14820	27	0	\N
226764	2134	11226211000	30115	14820	28	0	\N
226765	2134	11225207000	30115	14820	29	0	\N
226766	2134	11224203000	30115	14820	30	0	\N
226767	2134	11223199000	30115	14820	31	0	\N
226768	2134	11222195000	30115	14820	32	0	\N
226769	2134	11221191000	30115	14820	33	0	\N
226770	2134	11220187000	30115	14820	34	0	\N
226771	2134	11219183000	30115	14820	35	0	\N
226772	2134	11218179000	30115	14820	36	0	\N
226773	2134	11217175000	30115	14820	37	0	\N
226774	2134	11216171000	30115	14820	38	0	\N
226775	2134	11215167000	30115	14820	39	0	\N
226776	2134	11214163000	30115	14820	40	0	\N
226777	2134	11213159000	30115	14820	41	0	\N
226778	2134	11212155000	30115	14820	42	0	\N
226779	2134	11211151000	30115	14820	43	0	\N
226780	2134	11210147000	30115	14820	44	0	\N
226781	2134	11209143000	30115	14820	45	0	\N
226782	2134	11208139000	30115	14820	46	0	\N
226783	2134	11207135000	30115	14820	47	0	\N
226784	2134	11206131000	30115	14820	48	0	\N
226785	2133	8145446000	30115	14820	49	0	\N
226786	2133	8144444000	30115	14820	50	0	\N
226787	2133	8143442000	30115	14820	51	0	\N
226788	2133	8142440000	30115	14820	52	0	\N
226796	1397	1255991734000	30117	14821	0	0	\N
226797	2132	6595610000	30117	14821	1	0	\N
226798	2133	8141438000	30117	14821	2	0	\N
226799	2133	8140436000	30117	14821	3	0	\N
226800	2133	8139434000	30117	14821	4	0	\N
226801	664	66544509726895	30117	14821	5	0	\N
226802	2132	6594609000	30117	14821	6	0	\N
226803	2134	11205127000	30117	14821	7	0	\N
226804	2134	11204123000	30117	14821	8	0	\N
226805	2134	11203119000	30117	14821	9	0	\N
226806	2134	11202115000	30117	14821	10	0	\N
226807	2132	6595610000	30118	14821	0	0	\N
226808	2133	8141438000	30118	14821	1	0	\N
226809	2133	8140436000	30118	14821	2	0	\N
226810	2133	8139434000	30118	14821	3	0	\N
226811	664	66544509726895	30118	14821	4	0	\N
226812	2132	6594609000	30118	14821	5	0	\N
226813	2134	11205127000	30118	14821	6	0	\N
226814	2134	11204123000	30118	14821	7	0	\N
226815	2134	11203119000	30118	14821	8	0	\N
226816	2134	11202115000	30118	14821	9	0	\N
226817	1397	1255991734000	30119	14821	0	0	\N
226818	2132	6595610000	30119	14821	1	0	\N
226819	2133	8141438000	30119	14821	2	0	\N
226820	2133	8140436000	30119	14821	3	0	\N
226821	2133	8139434000	30119	14821	4	0	\N
226822	664	66544509726895	30119	14821	5	0	\N
226823	2132	6594609000	30119	14821	6	0	\N
226824	2134	11205127000	30119	14821	7	0	\N
226825	2134	11204123000	30119	14821	8	0	\N
226826	2134	11203119000	30119	14821	9	0	\N
226827	2134	11202115000	30119	14821	10	0	\N
226791	2133	8140436000	30116	14821	2	0	8285
226792	2134	11205127000	30116	14821	3	0	9107
226793	2134	11204123000	30116	14821	4	0	9108
226794	2134	11203119000	30116	14821	5	0	9109
226795	2134	11202115000	30116	14821	6	0	9110
226829	1397	1255981733000	30120	14822	1	0	18284
226830	1397	1255971732000	30120	14822	2	0	18285
226831	2163	1198995968420	30120	14822	3	0	2
226832	2134	11201111000	30120	14822	4	0	9111
226833	2133	8139434000	30120	14822	5	0	8286
226835	2134	11200107000	30120	14822	7	0	9112
226836	664	66544509726895	30120	14822	8	0	1
226837	2132	6594609000	30120	14822	9	0	2393
226838	2133	8137430000	30120	14822	10	0	8288
226840	2133	8135426000	30120	14822	12	0	8290
226841	2134	11199103000	30120	14822	13	0	9113
226842	2134	11198099000	30120	14822	14	0	9114
226843	2134	11197095000	30120	14822	15	0	9115
226844	2134	11196091000	30120	14822	16	0	9116
226846	2134	11194083000	30120	14822	18	0	9118
226847	2134	11193079000	30120	14822	19	0	9119
226848	2132	6593608000	30120	14822	20	0	2394
226851	1397	1255991734000	30121	14822	0	0	\N
226852	1397	1255981733000	30121	14822	1	0	\N
226853	1397	1255971732000	30121	14822	2	0	\N
226854	2163	1198995968420	30121	14822	3	0	\N
226855	2134	11201111000	30121	14822	4	0	\N
226856	2133	8139434000	30121	14822	5	0	\N
226857	2133	8138432000	30121	14822	6	0	\N
226858	2134	11200107000	30121	14822	7	0	\N
226859	664	66544509726895	30121	14822	8	0	\N
226860	2132	6594609000	30121	14822	9	0	\N
226861	2133	8137430000	30121	14822	10	0	\N
226862	2133	8136428000	30121	14822	11	0	\N
226863	2133	8135426000	30121	14822	12	0	\N
226864	2134	11199103000	30121	14822	13	0	\N
226865	2134	11198099000	30121	14822	14	0	\N
226866	2134	11197095000	30121	14822	15	0	\N
226867	2134	11196091000	30121	14822	16	0	\N
226868	2134	11195087000	30121	14822	17	0	\N
226869	2134	11194083000	30121	14822	18	0	\N
226870	2134	11193079000	30121	14822	19	0	\N
226871	2132	6593608000	30121	14822	20	0	\N
226872	2132	6592607000	30121	14822	21	0	\N
226873	2132	6591606000	30121	14822	22	0	\N
226874	1397	1255991734000	30122	14822	0	0	\N
226875	1397	1255981733000	30122	14822	1	0	\N
226876	1397	1255971732000	30122	14822	2	0	\N
226877	2163	1198995968420	30122	14822	3	0	\N
226878	2134	11201111000	30122	14822	4	0	\N
226879	2133	8139434000	30122	14822	5	0	\N
226880	2133	8138432000	30122	14822	6	0	\N
226881	2134	11200107000	30122	14822	7	0	\N
226882	664	66544509726895	30122	14822	8	0	\N
226883	2132	6594609000	30122	14822	9	0	\N
226884	2133	8137430000	30122	14822	10	0	\N
226885	2133	8136428000	30122	14822	11	0	\N
226886	2133	8135426000	30122	14822	12	0	\N
226887	2134	11199103000	30122	14822	13	0	\N
226888	2134	11198099000	30122	14822	14	0	\N
226889	2134	11197095000	30122	14822	15	0	\N
226890	2134	11196091000	30122	14822	16	0	\N
226891	2134	11195087000	30122	14822	17	0	\N
226892	2134	11194083000	30122	14822	18	0	\N
226893	2134	11193079000	30122	14822	19	0	\N
226894	2132	6593608000	30122	14822	20	0	\N
226895	2132	6592607000	30122	14822	21	0	\N
226896	2132	6591606000	30122	14822	22	0	\N
226964	1397	1255911726000	30126	14825	0	0	\N
226965	2132	6583598000	30126	14825	1	0	\N
226966	2133	8120396000	30126	14825	2	0	\N
226967	2133	8119394000	30126	14825	3	0	\N
226968	2134	11169987000	30126	14825	4	0	\N
226969	2134	11168983000	30126	14825	5	0	\N
226970	2134	11167979000	30126	14825	6	0	\N
226971	2132	6582597000	30126	14825	7	0	\N
226972	2132	6581596000	30126	14825	8	0	\N
226973	2133	8118392000	30126	14825	9	0	\N
226974	2133	8117390000	30126	14825	10	0	\N
226975	2133	8116388000	30126	14825	11	0	\N
226976	2133	8115386000	30126	14825	12	0	\N
226977	2134	11166975000	30126	14825	13	0	\N
226978	2134	11165971000	30126	14825	14	0	\N
226979	2134	11164967000	30126	14825	15	0	\N
226980	2134	11163963000	30126	14825	16	0	\N
226981	2134	11162959000	30126	14825	17	0	\N
226982	2134	11161955000	30126	14825	18	0	\N
226897	1397	1255961731000	30123	14823	0	0	18286
226898	1397	1255951730000	30123	14823	1	0	18287
226899	1397	1255941729000	30123	14823	2	0	18288
226900	2132	6590605000	30123	14823	3	0	2397
226901	2134	11192075000	30123	14823	4	0	9120
226903	2134	11190067000	30123	14823	6	0	9122
226904	2134	11189063000	30123	14823	7	0	9123
226905	2132	6589604000	30123	14823	8	0	2398
226906	2132	6588603000	30123	14823	9	0	2399
226907	2132	6587602000	30123	14823	10	0	2400
226909	2134	11187055000	30123	14823	12	0	9125
226910	2134	11186051000	30123	14823	13	0	9126
226911	2134	11185047000	30123	14823	14	0	9127
226912	2134	11184043000	30123	14823	15	0	9128
226914	2134	11182035000	30123	14823	17	0	9130
226915	2134	11181031000	30123	14823	18	0	9131
226916	2134	11180027000	30123	14823	19	0	9132
226917	2133	8134424000	30123	14823	20	0	8291
226918	2133	8133422000	30123	14823	21	0	8292
226920	2133	8131418000	30123	14823	23	0	8294
226921	2133	8130416000	30123	14823	24	0	8295
226922	2133	8129414000	30123	14823	25	0	8296
226923	2133	8128412000	30123	14823	26	0	8297
226924	2133	8127410000	30123	14823	27	0	8298
226926	1397	1255921727000	30124	14824	1	0	18290
226927	2132	6586601000	30124	14824	2	0	2401
226928	2133	8126408000	30124	14824	3	0	8299
226929	2133	8125406000	30124	14824	4	0	8300
226931	2134	11179023000	30124	14824	6	0	9133
226932	2134	11178019000	30124	14824	7	0	9134
226933	2134	11177015000	30124	14824	8	0	9135
226934	2134	11176011000	30124	14824	9	0	9136
226935	2134	11175007000	30124	14824	10	0	9137
226937	2133	8122400000	30124	14824	12	0	8303
226938	2133	8121398000	30124	14824	13	0	8304
226939	2132	6585600000	30124	14824	14	0	2402
226940	2132	6584599000	30124	14824	15	0	2403
226941	2134	11174003000	30124	14824	16	0	9138
226943	2134	11171995000	30124	14824	18	0	9140
226944	2134	11170991000	30124	14824	19	0	9141
226945	1397	1255911726000	30125	14825	0	0	18291
226946	2132	6583598000	30125	14825	1	0	2404
226948	2133	8119394000	30125	14825	3	0	8306
226949	2134	11169987000	30125	14825	4	0	9142
226950	2134	11168983000	30125	14825	5	0	9143
226951	2134	11167979000	30125	14825	6	0	9144
226952	2132	6582597000	30125	14825	7	0	2405
226954	2133	8118392000	30125	14825	9	0	8307
226955	2133	8117390000	30125	14825	10	0	8308
226956	2133	8116388000	30125	14825	11	0	8309
226957	2133	8115386000	30125	14825	12	0	8310
226958	2134	11166975000	30125	14825	13	0	9145
226960	2134	11164967000	30125	14825	15	0	9147
226961	2134	11163963000	30125	14825	16	0	9148
226962	2134	11162959000	30125	14825	17	0	9149
226963	2134	11161955000	30125	14825	18	0	9150
226984	2134	11160951000	30127	14826	1	0	9151
226991	1397	1255891724000	30128	14827	0	0	\N
226992	2133	8112380000	30128	14827	1	0	\N
226993	2133	8111378000	30128	14827	2	0	\N
226994	2133	8110376000	30128	14827	3	0	\N
226995	2132	6579594000	30128	14827	4	0	\N
226996	2132	6578593000	30128	14827	5	0	\N
226997	1397	1255891724000	30129	14827	0	0	\N
226998	2133	8112380000	30129	14827	1	0	\N
226999	2133	8111378000	30129	14827	2	0	\N
227000	2134	11156935000	30129	14827	3	0	\N
227001	2134	11155931000	30129	14827	4	0	\N
227002	2132	6579594000	30129	14827	5	0	\N
227003	2132	6578593000	30129	14827	6	0	\N
227004	2134	11154927000	30129	14827	7	0	\N
227005	2134	11153923000	30129	14827	8	0	\N
227006	1397	1255891724000	30130	14827	0	0	\N
227007	2133	8112380000	30130	14827	1	0	\N
227008	2133	8111378000	30130	14827	2	0	\N
227009	2133	8110376000	30130	14827	3	0	\N
227010	2134	11156935000	30130	14827	4	0	\N
227011	2134	11155931000	30130	14827	5	0	\N
227012	2132	6579594000	30130	14827	6	0	\N
227013	2132	6578593000	30130	14827	7	0	\N
227014	2134	11154927000	30130	14827	8	0	\N
227015	2134	11153923000	30130	14827	9	0	\N
227016	2134	11152919000	30130	14827	10	0	\N
227020	1397	1255891724000	30132	14827	0	0	\N
227021	2133	8112380000	30132	14827	1	0	\N
227022	2133	8111378000	30132	14827	2	0	\N
227023	2133	8110376000	30132	14827	3	0	\N
227024	2134	11156935000	30132	14827	4	0	\N
227025	2134	11155931000	30132	14827	5	0	\N
227026	2132	6579594000	30132	14827	6	0	\N
227027	2132	6578593000	30132	14827	7	0	\N
227028	2134	11154927000	30132	14827	8	0	\N
227029	2134	11153923000	30132	14827	9	0	\N
227030	2134	11152919000	30132	14827	10	0	\N
227031	1397	1255891724000	30133	14827	0	0	\N
227032	2133	8112380000	30133	14827	1	0	\N
227033	2133	8111378000	30133	14827	2	0	\N
227034	2132	6579594000	30133	14827	3	0	\N
227035	2132	6578593000	30133	14827	4	0	\N
227051	1397	1255871722000	30135	14829	0	0	\N
227052	2134	11148903000	30135	14829	1	0	\N
227053	2134	11147899000	30135	14829	2	0	\N
227054	2133	8107370000	30135	14829	3	0	\N
227055	2133	8106368000	30135	14829	4	0	\N
227056	2134	11146895000	30135	14829	5	0	\N
227057	2134	11145891000	30135	14829	6	0	\N
227058	2134	11144887000	30135	14829	7	0	\N
227059	2132	6576591000	30135	14829	8	0	\N
227060	2132	6575590000	30135	14829	9	0	\N
227080	1397	1255861721000	30138	14830	0	0	\N
227081	2133	8105366000	30138	14830	1	0	\N
227082	2134	11148903000	30138	14830	2	0	\N
227083	2134	11147899000	30138	14830	3	0	\N
227084	664	66543508726895	30138	14830	4	0	\N
227085	2133	8104364000	30138	14830	5	0	\N
227086	2132	6574589000	30138	14830	6	0	\N
227087	2134	11146895000	30138	14830	7	0	\N
227088	2134	11145891000	30138	14830	8	0	\N
227089	2134	11144887000	30138	14830	9	0	\N
227090	2134	11143883000	30138	14830	10	0	\N
227091	2134	11142879000	30138	14830	11	0	\N
227092	2134	11141875000	30138	14830	12	0	\N
227093	2134	11140871000	30138	14830	13	0	\N
227094	1397	1255861721000	30139	14830	0	0	\N
227095	2133	8105366000	30139	14830	1	0	\N
227096	2134	11148903000	30139	14830	2	0	\N
227097	2134	11147899000	30139	14830	3	0	\N
227098	664	66543508726895	30139	14830	4	0	\N
227099	2132	6574589000	30139	14830	5	0	\N
227100	2134	11146895000	30139	14830	6	0	\N
227101	2134	11145891000	30139	14830	7	0	\N
227102	2134	11144887000	30139	14830	8	0	\N
227103	2134	11143883000	30139	14830	9	0	\N
227104	2134	11142879000	30139	14830	10	0	\N
227105	2134	11141875000	30139	14830	11	0	\N
227106	1397	1255861721000	30140	14830	0	0	\N
227107	2133	8105366000	30140	14830	1	0	\N
227108	2134	11148903000	30140	14830	2	0	\N
227109	2134	11147899000	30140	14830	3	0	\N
227110	664	66543508726895	30140	14830	4	0	\N
227111	2134	11146895000	30140	14830	5	0	\N
227112	2134	11145891000	30140	14830	6	0	\N
227113	2134	11144887000	30140	14830	7	0	\N
227114	2134	11143883000	30140	14830	8	0	\N
227115	2134	11142879000	30140	14830	9	0	\N
227116	2134	11141875000	30140	14830	10	0	\N
227117	2134	11148903000	30141	14830	0	0	\N
227118	2134	11147899000	30141	14830	1	0	\N
227119	2132	6574589000	30141	14830	2	0	\N
227120	2134	11146895000	30141	14830	3	0	\N
226987	2134	11159947000	30127	14826	4	0	9152
226988	2132	6580595000	30127	14826	5	0	2407
226989	2134	11158943000	30127	14826	6	0	9153
226990	2134	11157939000	30127	14826	7	0	9154
227017	1397	1255891724000	30131	14827	0	0	18293
227019	2132	6578593000	30131	14827	2	0	2409
227036	1397	1255881723000	30134	14828	0	0	18294
227037	2133	8112380000	30134	14828	1	0	8313
227038	2133	8111378000	30134	14828	2	0	8314
227039	2132	6577592000	30134	14828	3	0	2410
227041	2134	11156935000	30134	14828	5	0	9155
227042	2134	11155931000	30134	14828	6	0	9156
227043	2134	11154927000	30134	14828	7	0	9157
227044	2134	11153923000	30134	14828	8	0	9158
227046	2134	11151915000	30134	14828	10	0	9160
227047	2134	11150911000	30134	14828	11	0	9161
227048	2134	11149907000	30134	14828	12	0	9162
227049	2133	8109374000	30134	14828	13	0	8316
227050	2133	8108372000	30134	14828	14	0	8317
227062	2133	8107370000	30136	14829	1	0	8318
227063	2133	8106368000	30136	14829	2	0	8319
227064	2132	6576591000	30136	14829	3	0	2411
227065	2132	6575590000	30136	14829	4	0	2412
227066	1397	1255861721000	30137	14830	0	0	18296
227068	2134	11148903000	30137	14830	2	0	9163
227069	2134	11147899000	30137	14830	3	0	9164
227070	664	66543508726895	30137	14830	4	0	2
227071	2133	8104364000	30137	14830	5	0	8321
227073	2134	11146895000	30137	14830	7	0	9165
227074	2134	11145891000	30137	14830	8	0	9166
227075	2134	11144887000	30137	14830	9	0	9167
227076	2134	11143883000	30137	14830	10	0	9168
227077	2134	11142879000	30137	14830	11	0	9169
227079	2134	11140871000	30137	14830	13	0	9171
227121	2134	11145891000	30141	14830	4	0	\N
227122	2134	11144887000	30141	14830	5	0	\N
227132	1397	1255851720000	30143	14831	0	0	\N
227133	2133	8103362000	30143	14831	1	0	\N
227134	2132	6573588000	30143	14831	2	0	\N
227135	2133	8102360000	30143	14831	3	0	\N
227136	1397	1255841719000	30144	14832	0	0	\N
227137	2133	8101358000	30144	14832	1	0	\N
227138	2134	11134847000	30144	14832	2	0	\N
227139	2133	8100356000	30144	14832	3	0	\N
227140	2133	8099354000	30144	14832	4	0	\N
227141	2132	6572587000	30144	14832	5	0	\N
227142	2132	6571586000	30144	14832	6	0	\N
227143	2134	11133843000	30144	14832	7	0	\N
227144	2134	11132839000	30144	14832	8	0	\N
227145	2134	11131835000	30144	14832	9	0	\N
227156	1397	1255831718000	30146	14833	0	0	\N
227157	2133	8098352000	30146	14833	1	0	\N
227158	2133	8097350000	30146	14833	2	0	\N
227159	2134	11130831000	30146	14833	3	0	\N
227160	2134	11129827000	30146	14833	4	0	\N
227161	2134	11128823000	30146	14833	5	0	\N
227162	2134	11127819000	30146	14833	6	0	\N
227163	2132	6570585000	30146	14833	7	0	\N
227164	1397	1255831718000	30147	14833	0	0	\N
227165	2133	8098352000	30147	14833	1	0	\N
227166	2133	8097350000	30147	14833	2	0	\N
227167	2134	11130831000	30147	14833	3	0	\N
227168	2134	11129827000	30147	14833	4	0	\N
227169	2134	11128823000	30147	14833	5	0	\N
227170	2134	11127819000	30147	14833	6	0	\N
227171	2132	6570585000	30147	14833	7	0	\N
227190	1397	1255821717000	30150	14834	0	0	\N
227191	2133	8096348000	30150	14834	1	0	\N
227192	2134	11126815000	30150	14834	2	0	\N
227193	2134	11125811000	30150	14834	3	0	\N
227194	2134	11124807000	30150	14834	4	0	\N
227195	2134	11123803000	30150	14834	5	0	\N
227196	2134	11122799000	30150	14834	6	0	\N
227197	2132	6569584000	30150	14834	7	0	\N
227198	2132	6568583000	30150	14834	8	0	\N
227199	2133	8095346000	30150	14834	9	0	\N
227200	1397	1255811716000	30153	14837	0	0	\N
227201	1397	1255801715000	30153	14837	1	0	\N
227202	1397	1255791714000	30153	14837	2	0	\N
227203	1397	1255781713000	30153	14837	3	0	\N
227204	1397	1255771712000	30153	14837	4	0	\N
227205	2133	8094344000	30153	14837	5	0	\N
227206	2134	11121795000	30153	14837	6	0	\N
227207	2134	11120791000	30153	14837	7	0	\N
227208	2133	8093342000	30153	14837	8	0	\N
227209	2134	11119787000	30153	14837	9	0	\N
227210	2134	11118783000	30153	14837	10	0	\N
227211	2134	11117779000	30153	14837	11	0	\N
227212	2134	11116775000	30153	14837	12	0	\N
227213	2134	11115771000	30153	14837	13	0	\N
227214	2134	11114767000	30153	14837	14	0	\N
227215	2134	11113763000	30153	14837	15	0	\N
227216	2134	11112759000	30153	14837	16	0	\N
227217	2134	11111755000	30153	14837	17	0	\N
227218	2134	11110751000	30153	14837	18	0	\N
227219	2133	8092340000	30153	14837	19	0	\N
227220	2133	8091338000	30153	14837	20	0	\N
227221	2133	8090336000	30153	14837	21	0	\N
227222	2133	8089334000	30153	14837	22	0	\N
227223	2133	8088332000	30153	14837	23	0	\N
227224	2133	8087330000	30153	14837	24	0	\N
227225	2133	8086328000	30153	14837	25	0	\N
227226	2133	8085326000	30153	14837	26	0	\N
227227	2132	6567582000	30153	14837	27	0	\N
227228	2132	6566581000	30153	14837	28	0	\N
227229	2132	6565580000	30153	14837	29	0	\N
227230	2133	8084324000	30153	14837	30	0	\N
227231	2133	8083322000	30153	14837	31	0	\N
227232	2133	8082320000	30153	14837	32	0	\N
227233	2133	8081318000	30153	14837	33	0	\N
227234	664	66542507726895	30153	14837	34	0	\N
227235	2134	11109747000	30153	14837	35	0	\N
227236	2134	11108743000	30153	14837	36	0	\N
227237	2134	11107739000	30153	14837	37	0	\N
227238	2134	11106735000	30153	14837	38	0	\N
227239	2134	11105731000	30153	14837	39	0	\N
227240	2134	11104727000	30153	14837	40	0	\N
227241	2134	11103723000	30153	14837	41	0	\N
227242	2134	11102719000	30153	14837	42	0	\N
227243	2134	11101715000	30153	14837	43	0	\N
227244	2134	11100711000	30153	14837	44	0	\N
227245	2132	6564579000	30153	14837	45	0	\N
227246	2132	6563578000	30153	14837	46	0	\N
227247	2132	6562577000	30153	14837	47	0	\N
227248	2132	6561576000	30153	14837	48	0	\N
227125	2132	6573588000	30142	14831	2	0	2414
227126	2134	11139867000	30142	14831	3	0	9172
227127	2134	11138863000	30142	14831	4	0	9173
227128	2133	8102360000	30142	14831	5	0	8323
227129	2134	11137859000	30142	14831	6	0	9174
227131	2134	11135851000	30142	14831	8	0	9176
227146	1397	1255841719000	30145	14832	0	0	18298
227147	2133	8101358000	30145	14832	1	0	8324
227148	2134	11134847000	30145	14832	2	0	9177
227149	2133	8100356000	30145	14832	3	0	8325
227151	2132	6572587000	30145	14832	5	0	2415
227152	2132	6571586000	30145	14832	6	0	2416
227153	2134	11133843000	30145	14832	7	0	9178
227154	2134	11132839000	30145	14832	8	0	9179
227172	1397	1255831718000	30148	14833	0	0	18299
227173	2133	8098352000	30148	14833	1	0	8327
227174	2133	8097350000	30148	14833	2	0	8328
227175	2134	11130831000	30148	14833	3	0	9181
227176	2134	11129827000	30148	14833	4	0	9182
227178	2134	11127819000	30148	14833	6	0	9184
227179	2132	6570585000	30148	14833	7	0	2417
227180	1397	1255821717000	30149	14834	0	0	18300
227181	2133	8096348000	30149	14834	1	0	8329
227182	2134	11126815000	30149	14834	2	0	9185
227184	2134	11124807000	30149	14834	4	0	9187
227185	2134	11123803000	30149	14834	5	0	9188
227186	2134	11122799000	30149	14834	6	0	9189
227187	2132	6569584000	30149	14834	7	0	2418
227189	2133	8095346000	30149	14834	9	0	8330
227249	1397	1255811716000	30154	14837	0	0	18301
227250	1397	1255801715000	30154	14837	1	0	18302
227251	1397	1255791714000	30154	14837	2	0	18303
227252	1397	1255781713000	30154	14837	3	0	18304
227254	2133	8094344000	30154	14837	5	0	8331
227255	2134	11121795000	30154	14837	6	0	9190
227256	2134	11120791000	30154	14837	7	0	9191
227308	664	66541497726895	30156	14838	0	0	\N
227309	1397	1255761711000	30156	14838	1	0	\N
227310	2132	6560575000	30156	14838	2	0	\N
227311	2134	11099707000	30156	14838	3	0	\N
227312	2132	6559574000	30156	14838	4	0	\N
227313	2133	8080316000	30156	14838	5	0	\N
227314	2133	8079314000	30156	14838	6	0	\N
227315	2134	11098703000	30156	14838	7	0	\N
227316	2134	11097699000	30156	14838	8	0	\N
227317	2134	11096695000	30156	14838	9	0	\N
227318	664	66541497726895	30157	14838	0	0	\N
227319	1397	1255761711000	30157	14838	1	0	\N
227320	2132	6560575000	30157	14838	2	0	\N
227321	2134	11099707000	30157	14838	3	0	\N
227322	2133	8080316000	30157	14838	4	0	\N
227323	2133	8079314000	30157	14838	5	0	\N
227324	2134	11098703000	30157	14838	6	0	\N
227325	2134	11097699000	30157	14838	7	0	\N
227334	1397	1255751710000	30159	14839	0	0	\N
227335	2132	6558573000	30159	14839	1	0	\N
227336	2134	11095691000	30159	14839	2	0	\N
227337	2134	11094687000	30159	14839	3	0	\N
227338	2134	11093683000	30159	14839	4	0	\N
227339	2134	11092679000	30159	14839	5	0	\N
227359	1397	1255721707000	30163	14842	0	0	\N
227360	1397	1255711706000	30163	14842	1	0	\N
227361	1397	1255701705000	30163	14842	2	0	\N
227362	1397	1255691704000	30163	14842	3	0	\N
227363	2133	8071298000	30163	14842	4	0	\N
227364	2134	11082639000	30163	14842	5	0	\N
227365	2132	6554569000	30163	14842	6	0	\N
227366	2132	6553568000	30163	14842	7	0	\N
227367	2132	6552567000	30163	14842	8	0	\N
227368	2132	6551566000	30163	14842	9	0	\N
227369	2132	6550565000	30163	14842	10	0	\N
227370	2133	8070296000	30163	14842	11	0	\N
227371	2133	8069294000	30163	14842	12	0	\N
227372	2133	8068292000	30163	14842	13	0	\N
227373	2133	8067290000	30163	14842	14	0	\N
227374	2133	8066288000	30163	14842	15	0	\N
227375	2133	8065286000	30163	14842	16	0	\N
227376	2133	8064284000	30163	14842	17	0	\N
227377	2133	8063282000	30163	14842	18	0	\N
227378	2133	8062280000	30163	14842	19	0	\N
227379	2133	8061278000	30163	14842	20	0	\N
227380	2133	8060276000	30163	14842	21	0	\N
227381	2134	11081635000	30163	14842	22	0	\N
227382	2134	11080631000	30163	14842	23	0	\N
227383	2134	11079627000	30163	14842	24	0	\N
227384	2134	11078623000	30163	14842	25	0	\N
227385	2134	11077619000	30163	14842	26	0	\N
227386	2134	11076615000	30163	14842	27	0	\N
227387	2134	11075611000	30163	14842	28	0	\N
227388	2134	11074607000	30163	14842	29	0	\N
227389	2134	11073603000	30163	14842	31	0	\N
227390	2134	11072599000	30163	14842	32	0	\N
227391	2134	11071595000	30163	14842	33	0	\N
227392	2134	11070591000	30163	14842	34	0	\N
227259	2134	11118783000	30154	14837	10	0	9193
227260	2134	11117779000	30154	14837	11	0	9194
227261	2134	11116775000	30154	14837	12	0	9195
227262	2134	11115771000	30154	14837	13	0	9196
227263	2134	11114767000	30154	14837	14	0	9197
227265	2134	11112759000	30154	14837	16	0	9199
227266	2134	11111755000	30154	14837	17	0	9200
227267	2134	11110751000	30154	14837	18	0	9201
227268	2133	8092340000	30154	14837	19	0	8333
227269	2133	8091338000	30154	14837	20	0	8334
227271	2133	8089334000	30154	14837	22	0	8336
227272	2133	8088332000	30154	14837	23	0	8337
227273	2133	8087330000	30154	14837	24	0	8338
227274	2133	8086328000	30154	14837	25	0	8339
227276	2132	6567582000	30154	14837	27	0	2420
227277	2132	6566581000	30154	14837	28	0	2421
227278	2132	6565580000	30154	14837	29	0	2422
227279	2133	8084324000	30154	14837	30	0	8341
227280	2133	8083322000	30154	14837	31	0	8342
227282	2133	8081318000	30154	14837	33	0	8344
227283	664	66542507726895	30154	14837	34	0	3
227284	2134	11109747000	30154	14837	35	0	9202
227285	2134	11108743000	30154	14837	36	0	9203
227286	2134	11107739000	30154	14837	37	0	9204
227288	2134	11105731000	30154	14837	39	0	9206
227289	2134	11104727000	30154	14837	40	0	9207
227290	2134	11103723000	30154	14837	41	0	9208
227291	2134	11102719000	30154	14837	42	0	9209
227293	2134	11100711000	30154	14837	44	0	9211
227294	2132	6564579000	30154	14837	45	0	2423
227295	2132	6563578000	30154	14837	46	0	2424
227296	2132	6562577000	30154	14837	47	0	2425
227297	2132	6561576000	30154	14837	48	0	2426
227299	1397	1255761711000	30155	14838	1	0	18306
227300	2132	6560575000	30155	14838	2	0	2427
227301	2134	11099707000	30155	14838	3	0	9212
227302	2132	6559574000	30155	14838	4	0	2428
227303	2133	8080316000	30155	14838	5	0	8345
227305	2134	11098703000	30155	14838	7	0	9213
227306	2134	11097699000	30155	14838	8	0	9214
227307	2134	11096695000	30155	14838	9	0	9215
227326	1397	1255751710000	30158	14839	0	0	18307
227328	2134	11095691000	30158	14839	2	0	9216
227329	2134	11094687000	30158	14839	3	0	9217
227330	2134	11093683000	30158	14839	4	0	9218
227331	2134	11092679000	30158	14839	5	0	9219
227332	2133	8078312000	30158	14839	6	0	8347
227340	1397	1255741709000	30161	14840	0	0	18308
227341	2134	11091675000	30161	14840	1	0	9220
227342	2134	11090671000	30161	14840	2	0	9221
227343	2132	6557572000	30161	14840	3	0	2430
227344	2134	11089667000	30161	14840	4	0	9222
227346	2133	8076308000	30161	14840	6	0	8349
227347	2133	8075306000	30161	14840	7	0	8350
227348	1397	1255731708000	30162	14841	0	0	18309
227349	2133	8074304000	30162	14841	1	0	8351
227351	2134	11086655000	30162	14841	3	0	9225
227352	2132	6556571000	30162	14841	4	0	2431
227353	2132	6555570000	30162	14841	5	0	2432
227354	2134	11085651000	30162	14841	6	0	9226
227355	2134	11084647000	30162	14841	7	0	9227
227357	2133	8073302000	30162	14841	9	0	8352
227358	2133	8072300000	30162	14841	10	0	8353
227393	2134	11069587000	30163	14842	35	0	\N
227394	2134	11068583000	30163	14842	36	0	\N
227395	2134	11067579000	30163	14842	37	0	\N
227396	2134	11066575000	30163	14842	38	0	\N
227397	2134	11065571000	30163	14842	39	0	\N
227398	1397	1255721707000	30164	14842	0	0	\N
227399	1397	1255711706000	30164	14842	1	0	\N
227400	1397	1255701705000	30164	14842	2	0	\N
227401	1397	1255691704000	30164	14842	3	0	\N
227402	2133	8071298000	30164	14842	4	0	\N
227403	2134	11082639000	30164	14842	5	0	\N
227404	2132	6554569000	30164	14842	6	0	\N
227405	2132	6553568000	30164	14842	7	0	\N
227406	2132	6552567000	30164	14842	8	0	\N
227407	2132	6551566000	30164	14842	9	0	\N
227408	2132	6550565000	30164	14842	10	0	\N
227409	2133	8070296000	30164	14842	11	0	\N
227410	2133	8069294000	30164	14842	12	0	\N
227411	2133	8068292000	30164	14842	13	0	\N
227412	2133	8067290000	30164	14842	14	0	\N
227413	2133	8066288000	30164	14842	15	0	\N
227414	2133	8065286000	30164	14842	16	0	\N
227415	2133	8064284000	30164	14842	17	0	\N
227416	2133	8063282000	30164	14842	18	0	\N
227417	2133	8062280000	30164	14842	19	0	\N
227418	2133	8061278000	30164	14842	20	0	\N
227419	2133	8060276000	30164	14842	21	0	\N
227420	2134	11081635000	30164	14842	22	0	\N
227421	2134	11080631000	30164	14842	23	0	\N
227422	2134	11079627000	30164	14842	24	0	\N
227423	2134	11078623000	30164	14842	25	0	\N
227424	2134	11077619000	30164	14842	26	0	\N
227425	2134	11076615000	30164	14842	27	0	\N
227426	2134	11075611000	30164	14842	28	0	\N
227427	2134	11074607000	30164	14842	29	0	\N
227428	2134	11073603000	30164	14842	31	0	\N
227429	2134	11072599000	30164	14842	32	0	\N
227430	2134	11071595000	30164	14842	33	0	\N
227431	2134	11070591000	30164	14842	34	0	\N
227432	2134	11069587000	30164	14842	35	0	\N
227433	2134	11068583000	30164	14842	36	0	\N
227434	2134	11067579000	30164	14842	37	0	\N
227435	2134	11066575000	30164	14842	38	0	\N
227436	2134	11065571000	30164	14842	39	0	\N
227476	1397	1255721707000	30166	14842	0	0	\N
227477	1397	1255711706000	30166	14842	1	0	\N
227478	1397	1255701705000	30166	14842	2	0	\N
227479	1397	1255691704000	30166	14842	3	0	\N
227480	2133	8071298000	30166	14842	4	0	\N
227481	2134	11082639000	30166	14842	5	0	\N
227482	2132	6554569000	30166	14842	6	0	\N
227483	2132	6553568000	30166	14842	7	0	\N
227484	2132	6552567000	30166	14842	8	0	\N
227485	2132	6551566000	30166	14842	9	0	\N
227486	2132	6550565000	30166	14842	10	0	\N
227487	2133	8070296000	30166	14842	11	0	\N
227488	2133	8069294000	30166	14842	12	0	\N
227489	2133	8068292000	30166	14842	13	0	\N
227490	2133	8067290000	30166	14842	14	0	\N
227491	2133	8066288000	30166	14842	15	0	\N
227492	2133	8065286000	30166	14842	16	0	\N
227493	2133	8064284000	30166	14842	17	0	\N
227494	2133	8063282000	30166	14842	18	0	\N
227495	2133	8062280000	30166	14842	19	0	\N
227496	2133	8061278000	30166	14842	20	0	\N
227497	2133	8060276000	30166	14842	21	0	\N
227498	2134	11081635000	30166	14842	22	0	\N
227499	2134	11080631000	30166	14842	23	0	\N
227500	2134	11079627000	30166	14842	24	0	\N
227501	2134	11078623000	30166	14842	25	0	\N
227502	2134	11077619000	30166	14842	26	0	\N
227503	2134	11076615000	30166	14842	27	0	\N
227504	2134	11075611000	30166	14842	28	0	\N
227505	2134	11074607000	30166	14842	29	0	\N
227506	2134	11073603000	30166	14842	31	0	\N
227507	2134	11072599000	30166	14842	32	0	\N
227508	2134	11071595000	30166	14842	33	0	\N
227509	2134	11070591000	30166	14842	34	0	\N
227510	2134	11069587000	30166	14842	35	0	\N
227511	2134	11068583000	30166	14842	36	0	\N
227512	2134	11067579000	30166	14842	37	0	\N
227513	2134	11066575000	30166	14842	38	0	\N
227514	2134	11065571000	30166	14842	39	0	\N
227515	1397	1255681703000	30167	14843	0	0	\N
227516	2133	8059274000	30167	14843	1	0	\N
227517	2132	6549564000	30167	14843	2	0	\N
227518	2133	8058272000	30167	14843	3	0	\N
227519	2134	11064567000	30167	14843	4	0	\N
227520	2134	11063563000	30167	14843	5	0	\N
227521	2134	11062559000	30167	14843	6	0	\N
227522	2134	11061555000	30167	14843	7	0	\N
227523	2132	6548563000	30167	14843	8	0	\N
227524	1397	1255681703000	30168	14843	0	0	\N
227525	2133	8059274000	30168	14843	1	0	\N
227526	2132	6549564000	30168	14843	2	0	\N
227527	2134	11064567000	30168	14843	3	0	\N
227528	2134	11063563000	30168	14843	4	0	\N
227439	1397	1255701705000	30165	14842	2	0	18312
227440	1397	1255691704000	30165	14842	3	0	18313
227441	2133	8071298000	30165	14842	4	0	8354
227442	2134	11082639000	30165	14842	5	0	9229
227443	2132	6554569000	30165	14842	6	0	2433
227445	2132	6552567000	30165	14842	8	0	2435
227446	2132	6551566000	30165	14842	9	0	2436
227447	2132	6550565000	30165	14842	10	0	2437
227448	2133	8070296000	30165	14842	11	0	8355
227449	2133	8069294000	30165	14842	12	0	8356
227451	2133	8067290000	30165	14842	14	0	8358
227452	2133	8066288000	30165	14842	15	0	8359
227453	2133	8065286000	30165	14842	16	0	8360
227454	2133	8064284000	30165	14842	17	0	8361
227456	2133	8062280000	30165	14842	19	0	8363
227457	2133	8061278000	30165	14842	20	0	8364
227458	2133	8060276000	30165	14842	21	0	8365
227459	2134	11081635000	30165	14842	22	0	9230
227460	2134	11080631000	30165	14842	23	0	9231
227462	2134	11078623000	30165	14842	25	0	9233
227463	2134	11077619000	30165	14842	26	0	9234
227464	2134	11076615000	30165	14842	27	0	9235
227465	2134	11075611000	30165	14842	28	0	9236
227466	2134	11074607000	30165	14842	29	0	9237
227468	2134	11072599000	30165	14842	32	0	9239
227469	2134	11071595000	30165	14842	33	0	9240
227470	2134	11070591000	30165	14842	34	0	9241
227471	2134	11069587000	30165	14842	35	0	9242
227473	2134	11067579000	30165	14842	37	0	9244
227474	2134	11066575000	30165	14842	38	0	9245
227475	2134	11065571000	30165	14842	39	0	9246
227529	2134	11062559000	30168	14843	5	0	\N
227530	2134	11061555000	30168	14843	6	0	\N
227531	2132	6548563000	30168	14843	7	0	\N
227541	1397	1255671702000	30170	14844	0	0	\N
227542	2133	8057270000	30170	14844	1	0	\N
227543	2134	11060551000	30170	14844	2	0	\N
227544	2133	8056268000	30170	14844	3	0	\N
227545	2132	6547562000	30170	14844	4	0	\N
227546	2134	11059547000	30170	14844	5	0	\N
227547	2134	11058543000	30170	14844	6	0	\N
227548	2134	11057539000	30170	14844	7	0	\N
227549	1397	1255671702000	30171	14844	0	0	\N
227550	2133	8057270000	30171	14844	1	0	\N
227551	2134	11060551000	30171	14844	2	0	\N
227552	2133	8056268000	30171	14844	3	0	\N
227553	2132	6547562000	30171	14844	4	0	\N
227554	2134	11059547000	30171	14844	5	0	\N
227555	2134	11058543000	30171	14844	6	0	\N
227556	2134	11057539000	30171	14844	7	0	\N
227565	1397	1255661701000	30173	14845	0	0	\N
227566	2134	11056535000	30173	14845	1	0	\N
227567	2133	8055266000	30173	14845	2	0	\N
227568	2133	8054264000	30173	14845	3	0	\N
227569	2134	11055531000	30173	14845	4	0	\N
227570	2134	11054527000	30173	14845	5	0	\N
227571	2134	11053523000	30173	14845	6	0	\N
227572	2132	6546561000	30173	14845	7	0	\N
227573	2132	6545560000	30173	14845	8	0	\N
227593	606	83325992286229	30176	14594	0	0	\N
227594	1533	717960000000	30176	14594	1	0	\N
227595	1533	715910000000	30176	14594	2	0	\N
227596	234	66531385942306	30176	14594	3	0	\N
227597	2163	1198995968420	30176	14594	4	0	\N
227598	2338	6000000	30176	14594	5	0	\N
227599	2055	2159023000000	30176	14594	6	0	\N
227600	2041	2879000000000	30176	14594	7	0	\N
227601	1693	17239788899116	30176	14594	8	0	\N
227602	1397	1255641699000	30177	14847	0	0	\N
227603	1397	1255631698000	30177	14847	1	0	\N
227604	2133	8051258000	30177	14847	2	0	\N
227605	2133	8050256000	30177	14847	3	0	\N
227606	2132	6543558000	30177	14847	4	0	\N
227607	2133	8049254000	30177	14847	5	0	\N
227608	2133	8048252000	30177	14847	6	0	\N
227609	2133	8047250000	30177	14847	7	0	\N
227610	2132	6542557000	30177	14847	8	0	\N
227611	2132	6541556000	30177	14847	9	0	\N
227612	2134	11047499000	30177	14847	10	0	\N
227613	2134	11046495000	30177	14847	11	0	\N
227614	2134	11045491000	30177	14847	12	0	\N
227615	2134	11044487000	30177	14847	13	0	\N
227616	2134	11043483000	30177	14847	14	0	\N
227617	2134	11042479000	30177	14847	15	0	\N
227618	2134	11041475000	30177	14847	16	0	\N
227619	2134	11040471000	30177	14847	17	0	\N
227620	2134	11039467000	30177	14847	18	0	\N
227621	1397	1255641699000	30178	14847	0	0	\N
227622	1397	1255631698000	30178	14847	1	0	\N
227623	2133	8051258000	30178	14847	2	0	\N
227624	2133	8050256000	30178	14847	3	0	\N
227625	2132	6543558000	30178	14847	4	0	\N
227626	2133	8049254000	30178	14847	5	0	\N
227627	2133	8048252000	30178	14847	6	0	\N
227628	2133	8047250000	30178	14847	7	0	\N
227629	2132	6542557000	30178	14847	8	0	\N
227630	2132	6541556000	30178	14847	9	0	\N
227650	1397	1255621697000	30180	14848	0	0	\N
227651	2133	8046248000	30180	14848	1	0	\N
227652	2133	8045246000	30180	14848	2	0	\N
227653	2132	6540555000	30180	14848	3	0	\N
227654	2134	11038463000	30180	14848	4	0	\N
227655	2134	11037459000	30180	14848	5	0	\N
227656	2134	11036455000	30180	14848	6	0	\N
227657	2134	11035451000	30180	14848	7	0	\N
227534	2132	6549564000	30169	14843	2	0	2438
227535	2133	8058272000	30169	14843	3	0	8367
227536	2134	11064567000	30169	14843	4	0	9247
227537	2134	11063563000	30169	14843	5	0	9248
227538	2134	11062559000	30169	14843	6	0	9249
227540	2132	6548563000	30169	14843	8	0	2439
227557	1397	1255671702000	30172	14844	0	0	18315
227558	2133	8057270000	30172	14844	1	0	8368
227559	2134	11060551000	30172	14844	2	0	9251
227560	2133	8056268000	30172	14844	3	0	8369
227562	2134	11059547000	30172	14844	5	0	9252
227563	2134	11058543000	30172	14844	6	0	9253
227564	2134	11057539000	30172	14844	7	0	9254
227574	1397	1255661701000	30174	14845	0	0	18316
227576	2133	8055266000	30174	14845	2	0	8370
227577	2133	8054264000	30174	14845	3	0	8371
227578	2134	11055531000	30174	14845	4	0	9256
227579	2134	11054527000	30174	14845	5	0	9257
227580	2134	11053523000	30174	14845	6	0	9258
227582	2132	6545560000	30174	14845	8	0	2442
227583	1397	1255651700000	30175	14846	0	0	18317
227584	2133	8053262000	30175	14846	1	0	8372
227585	2133	8052260000	30175	14846	2	0	8373
227586	2132	6544559000	30175	14846	3	0	2443
227588	2134	11052519000	30175	14846	5	0	9259
227589	2134	11051515000	30175	14846	6	0	9260
227590	2134	11050511000	30175	14846	7	0	9261
227591	2134	11049507000	30175	14846	8	0	9262
227631	1397	1255641699000	30179	14847	0	0	18318
227632	1397	1255631698000	30179	14847	1	0	18319
227633	2133	8051258000	30179	14847	2	0	8374
227634	2133	8050256000	30179	14847	3	0	8375
227635	2132	6543558000	30179	14847	4	0	2444
227637	2133	8048252000	30179	14847	6	0	8377
227638	2133	8047250000	30179	14847	7	0	8378
227639	2132	6542557000	30179	14847	8	0	2445
227640	2132	6541556000	30179	14847	9	0	2446
227641	2134	11047499000	30179	14847	10	0	9264
227643	2134	11045491000	30179	14847	12	0	9266
227644	2134	11044487000	30179	14847	13	0	9267
227645	2134	11043483000	30179	14847	14	0	9268
227646	2134	11042479000	30179	14847	15	0	9269
227648	2134	11040471000	30179	14847	17	0	9271
227649	2134	11039467000	30179	14847	18	0	9272
227658	1397	1255621697000	30181	14848	0	0	18320
227659	2133	8046248000	30181	14848	1	0	8379
227660	2133	8045246000	30181	14848	2	0	8380
227662	2134	11038463000	30181	14848	4	0	9273
227663	2134	11037459000	30181	14848	5	0	9274
227664	2134	11036455000	30181	14848	6	0	9275
227666	1397	1255621697000	30182	14848	0	0	\N
227667	2133	8046248000	30182	14848	1	0	\N
227668	2133	8045246000	30182	14848	2	0	\N
227669	2132	6540555000	30182	14848	3	0	\N
227679	1397	1255611696000	30184	14849	0	0	\N
227680	2132	6539554000	30184	14849	1	0	\N
227681	2133	8044244000	30184	14849	2	0	\N
227682	2132	6538553000	30184	14849	3	0	\N
227683	2134	11034447000	30184	14849	4	0	\N
227684	2134	11033443000	30184	14849	5	0	\N
227685	2134	11032439000	30184	14849	6	0	\N
227686	2134	11031435000	30184	14849	7	0	\N
227687	50	66008900000000	30185	14587	0	0	\N
227688	389	68159958000000	30185	14587	1	0	\N
227689	451	66564522585011	30185	14587	2	0	\N
227690	606	83325992286229	30185	14587	3	0	\N
227691	651	66718925000000	30185	14587	4	0	\N
227692	689	67438422000000	30185	14587	5	0	\N
227693	744	2016912805578	30185	14587	6	0	\N
227694	379	66190536998665	30185	14587	7	0	\N
227695	556	66720035511028	30185	14587	8	0	\N
227696	1533	717960000000	30185	14587	9	0	\N
227697	498	67440214000000	30185	14587	10	0	\N
227698	1533	715910000000	30185	14587	11	0	\N
227699	724	20001130000000	30185	14587	12	0	\N
227700	1643	3185279064700	30185	14587	13	0	\N
227701	234	66531385942306	30185	14587	14	0	\N
227702	379	66000000000665	30185	14587	15	0	\N
227703	2425	90000000	30185	14587	16	0	\N
227704	472	66000390000000	30185	14587	17	0	\N
227705	2163	1198995968420	30185	14587	18	0	\N
227706	146	66846779269804	30185	14587	19	0	\N
227707	2338	6000000	30185	14587	20	0	\N
227708	1268	1003913681688	30185	14587	21	0	\N
227709	1268	1003911681688	30185	14587	22	0	\N
227710	2055	2159023000000	30185	14587	23	0	\N
227711	2041	2879000000000	30185	14587	24	0	\N
227712	1693	17239788899116	30185	14587	25	0	\N
227713	686	69550056000000	30185	14587	26	0	\N
227714	281	66000899000000	30185	14587	27	0	\N
227715	309	66846780394804	30185	14587	28	0	\N
227716	1268	1003909681688	30185	14587	29	0	\N
227717	1268	1003907681688	30185	14587	30	0	\N
227718	1597	5811000000	30185	14587	31	0	\N
227719	180	66846790394804	30185	14587	32	0	\N
227720	180	66845789394804	30185	14587	33	0	\N
227721	453	66845780394804	30185	14587	34	0	\N
227722	1693	16836971063748	30185	14587	35	0	\N
227723	1693	16750321023883	30185	14587	36	0	\N
227724	1693	16663670984018	30185	14587	37	0	\N
227725	1693	16577020944153	30185	14587	38	0	\N
227726	1693	16490370904288	30185	14587	39	0	\N
227727	1693	16404089618295	30185	14587	40	0	\N
227728	1693	15781643702139	30185	14587	41	0	\N
227729	1693	14598290813627	30185	14587	42	0	\N
227730	1693	14512009318472	30185	14587	43	0	\N
227731	1693	14425726855927	30185	14587	44	0	\N
227732	1693	14339444422371	30185	14587	45	0	\N
227733	1693	14253160011985	30185	14587	46	0	\N
227734	1693	14166509972120	30185	14587	47	0	\N
227735	1693	14159944650925	30185	14587	48	0	\N
227736	1693	14073294611060	30185	14587	49	0	\N
227737	2418	99000000	30185	14587	50	0	\N
227738	2418	98000000	30185	14587	51	0	\N
227739	664	66544509726895	30185	14587	52	0	\N
227740	664	66543508726895	30185	14587	53	0	\N
227741	2418	97000000	30185	14587	54	0	\N
227742	2055	2159021000000	30185	14587	55	0	\N
227743	1268	1003905681688	30185	14587	56	0	\N
227744	1268	1003903681688	30185	14587	57	0	\N
227745	1268	1003901681688	30185	14587	58	0	\N
227746	1268	1003899681688	30185	14587	59	0	\N
227747	1268	1003897681688	30185	14587	60	0	\N
227748	1268	1003895681688	30185	14587	61	0	\N
227749	1268	1003893681688	30185	14587	62	0	\N
227750	1268	1003891681688	30185	14587	64	0	\N
227751	1268	1003889681688	30185	14587	65	0	\N
227752	1268	1003887681688	30185	14587	66	0	\N
227753	664	66542507726895	30185	14587	67	0	\N
227754	664	66541497726895	30185	14587	68	0	\N
227755	1268	1003885681688	30185	14587	69	0	\N
227756	1268	1003883681688	30185	14587	70	0	\N
227757	1693	13835208700785	30185	14587	71	0	\N
227758	1693	13748558660920	30185	14587	72	0	\N
227759	1693	13661908621055	30185	14587	73	0	\N
227760	1693	13575258581190	30185	14587	74	0	\N
227768	1397	1255591694000	30187	14851	0	0	\N
227769	1397	1255581693000	30187	14851	1	0	\N
227770	2133	8041238000	30187	14851	2	0	\N
227771	2133	8040236000	30187	14851	3	0	\N
227772	2133	8039234000	30187	14851	4	0	\N
227773	2133	8038232000	30187	14851	5	0	\N
227774	2133	8037230000	30187	14851	6	0	\N
227775	2133	8036228000	30187	14851	7	0	\N
227776	1397	1255591694000	30188	14851	0	0	\N
227777	1397	1255581693000	30188	14851	1	0	\N
227778	2132	6536551000	30188	14851	2	0	\N
227779	2133	8041238000	30188	14851	3	0	\N
227780	2134	11026415000	30188	14851	4	0	\N
227781	2134	11025411000	30188	14851	5	0	\N
227782	2133	8040236000	30188	14851	6	0	\N
227783	2133	8039234000	30188	14851	7	0	\N
227784	2133	8038232000	30188	14851	8	0	\N
227785	2133	8037230000	30188	14851	9	0	\N
227786	2133	8036228000	30188	14851	10	0	\N
227787	2132	6535550000	30188	14851	11	0	\N
227788	2132	6534549000	30188	14851	12	0	\N
227789	2134	11024407000	30188	14851	13	0	\N
227790	2134	11023403000	30188	14851	14	0	\N
227791	2134	11022399000	30188	14851	16	0	\N
227792	2134	11021395000	30188	14851	17	0	\N
227793	2134	11020391000	30188	14851	18	0	\N
227794	2134	11019387000	30188	14851	19	0	\N
227795	2134	11018383000	30188	14851	20	0	\N
227796	1397	1255591694000	30189	14851	0	0	\N
227797	1397	1255581693000	30189	14851	1	0	\N
227798	2132	6536551000	30189	14851	2	0	\N
227799	2133	8041238000	30189	14851	3	0	\N
227800	2133	8040236000	30189	14851	4	0	\N
227671	2132	6539554000	30183	14849	1	0	2448
227672	2133	8044244000	30183	14849	2	0	8381
227673	2133	8043242000	30183	14849	3	0	8382
227674	2132	6538553000	30183	14849	4	0	2449
227675	2134	11034447000	30183	14849	5	0	9277
227677	2134	11032439000	30183	14849	7	0	9279
227678	2134	11031435000	30183	14849	8	0	9280
227761	1397	1255601695000	30186	14850	0	0	18322
227762	2134	11030431000	30186	14850	1	0	9281
227763	2132	6537552000	30186	14850	2	0	2450
227765	2134	11029427000	30186	14850	4	0	9282
227766	2134	11028423000	30186	14850	5	0	9283
227767	2134	11027419000	30186	14850	6	0	9284
227801	2133	8039234000	30189	14851	5	0	\N
227802	2133	8038232000	30189	14851	6	0	\N
227803	2133	8037230000	30189	14851	7	0	\N
227804	2133	8036228000	30189	14851	8	0	\N
227805	2132	6535550000	30189	14851	9	0	\N
227806	2132	6534549000	30189	14851	10	0	\N
227827	234	66001375942306	30191	14852	0	0	\N
227828	1397	1255571692000	30191	14852	1	0	\N
227829	2133	8035226000	30191	14852	2	0	\N
227830	2133	8034224000	30191	14852	3	0	\N
227831	2134	11017379000	30191	14852	4	0	\N
227832	2132	6533548000	30191	14852	5	0	\N
227833	2132	6532547000	30191	14852	6	0	\N
227834	2134	11016375000	30191	14852	7	0	\N
227835	2134	11015371000	30191	14852	8	0	\N
227836	2134	11014367000	30191	14852	9	0	\N
227847	180	66930178434669	30193	14853	0	0	\N
227848	180	66925153434669	30193	14853	1	0	\N
227849	2439	628993000000	30193	14853	2	0	\N
227850	2132	6531546000	30193	14853	3	0	\N
227851	2133	8033222000	30193	14853	4	0	\N
227852	2132	6530545000	30193	14853	5	0	\N
227853	2132	6529544000	30193	14853	6	0	\N
227854	2133	8032220000	30193	14853	7	0	\N
227855	2133	8031218000	30193	14853	8	0	\N
227856	512	66544509726895	30193	14853	9	0	\N
227857	2134	11013363000	30193	14853	10	0	\N
227858	2134	11012359000	30193	14853	11	0	\N
227859	2133	8030216000	30193	14853	12	0	\N
227860	1611	6730272069739	30193	14853	13	0	\N
227861	2134	11011355000	30193	14853	14	0	\N
227862	2134	11010351000	30193	14853	15	0	\N
227863	2134	11009347000	30193	14853	16	0	\N
227864	2134	11008343000	30193	14853	17	0	\N
227865	2134	11007339000	30193	14853	18	0	\N
227866	2134	11006335000	30193	14853	19	0	\N
227867	1611	5901802387769	30193	14853	20	0	\N
227868	1611	5342817059639	30193	14853	21	0	\N
227869	1611	3785156527184	30193	14853	22	0	\N
227870	2134	11005331000	30193	14853	23	0	\N
227871	180	66930178434669	30194	14853	0	0	\N
227872	180	66925153434669	30194	14853	1	0	\N
227873	2439	628993000000	30194	14853	2	0	\N
227874	2133	8033222000	30194	14853	3	0	\N
227875	2133	8032220000	30194	14853	4	0	\N
227876	2133	8031218000	30194	14853	5	0	\N
227877	512	66544509726895	30194	14853	6	0	\N
227878	2133	8030216000	30194	14853	7	0	\N
227879	1611	6730272069739	30194	14853	8	0	\N
227880	1611	5901802387769	30194	14853	9	0	\N
227881	1611	5342817059639	30194	14853	10	0	\N
227882	1611	3785156527184	30194	14853	11	0	\N
227912	664	66540494726895	30197	14854	0	0	\N
227913	2132	6528543000	30197	14854	1	0	\N
227914	2134	11004327000	30197	14854	2	0	\N
227915	2134	11003323000	30197	14854	3	0	\N
227916	2134	11002319000	30197	14854	4	0	\N
227917	2134	11001315000	30197	14854	5	0	\N
227918	2133	8029214000	30197	14854	6	0	\N
227919	2133	8028212000	30197	14854	7	0	\N
227920	2133	8027210000	30197	14854	8	0	\N
227921	234	66001375942306	30198	14838	0	0	\N
227922	2439	628993000000	30198	14838	1	0	\N
227923	512	66544509726895	30198	14838	2	0	\N
227924	1611	6730272069739	30198	14838	3	0	\N
227925	1611	5901802387769	30198	14838	4	0	\N
227926	1611	5342817059639	30198	14838	5	0	\N
227927	1611	3785156527184	30198	14838	6	0	\N
227809	2132	6536551000	30190	14851	2	0	2451
227810	2133	8041238000	30190	14851	3	0	8384
227811	2134	11026415000	30190	14851	4	0	9285
227812	2134	11025411000	30190	14851	5	0	9286
227813	2133	8040236000	30190	14851	6	0	8385
227815	2133	8038232000	30190	14851	8	0	8387
227816	2133	8037230000	30190	14851	9	0	8388
227817	2133	8036228000	30190	14851	10	0	8389
227818	2132	6535550000	30190	14851	11	0	2452
227819	2132	6534549000	30190	14851	12	0	2453
227821	2134	11023403000	30190	14851	14	0	9288
227822	2134	11022399000	30190	14851	16	0	9289
227823	2134	11021395000	30190	14851	17	0	9290
227824	2134	11020391000	30190	14851	18	0	9291
227826	2134	11018383000	30190	14851	20	0	9293
227837	234	66001375942306	30192	14852	0	0	2
227838	1397	1255571692000	30192	14852	1	0	18325
227839	2133	8035226000	30192	14852	2	0	8390
227840	2133	8034224000	30192	14852	3	0	8391
227842	2132	6533548000	30192	14852	5	0	2454
227843	2132	6532547000	30192	14852	6	0	2455
227844	2134	11016375000	30192	14852	7	0	9295
227845	2134	11015371000	30192	14852	8	0	9296
227846	2134	11014367000	30192	14852	9	0	9297
227884	180	66925153434669	30195	14853	1	0	4
227885	2439	628993000000	30195	14853	2	0	1
227886	2132	6531546000	30195	14853	3	0	2456
227887	2133	8033222000	30195	14853	4	0	8392
227889	2132	6529544000	30195	14853	6	0	2458
227890	2133	8032220000	30195	14853	7	0	8393
227891	2133	8031218000	30195	14853	8	0	8394
227892	512	66544509726895	30195	14853	9	0	1
227893	2134	11013363000	30195	14853	10	0	9298
227895	2133	8030216000	30195	14853	12	0	8395
227896	1611	6730272069739	30195	14853	13	0	19
227897	2134	11011355000	30195	14853	14	0	9300
227898	2134	11010351000	30195	14853	15	0	9301
227899	2134	11009347000	30195	14853	16	0	9302
227901	2134	11007339000	30195	14853	18	0	9304
227902	2134	11006335000	30195	14853	19	0	9305
227903	1611	5901802387769	30195	14853	20	0	20
227904	1611	5342817059639	30195	14853	21	0	21
227906	2134	11005331000	30195	14853	23	0	9306
227907	664	66540494726895	30196	14854	0	0	5
227908	2132	6528543000	30196	14854	1	0	2459
227909	2133	8029214000	30196	14854	2	0	8396
227910	2133	8028212000	30196	14854	3	0	8397
227928	1397	1255561691000	30199	14855	0	0	18326
227929	2134	11004327000	30199	14855	1	0	9307
227930	2132	6527542000	30199	14855	2	0	2460
227931	2133	8026208000	30199	14855	3	0	8399
227932	2133	8025206000	30199	14855	4	0	8400
227934	2132	6526541000	30199	14855	6	0	2461
227935	2134	11003323000	30199	14855	7	0	9308
227936	2134	11002319000	30199	14855	8	0	9309
227948	1397	1255561691000	30200	14855	0	0	\N
227949	2134	11004327000	30200	14855	1	0	\N
227950	2132	6527542000	30200	14855	2	0	\N
227951	2133	8026208000	30200	14855	3	0	\N
227952	2133	8025206000	30200	14855	4	0	\N
227953	2133	8024204000	30200	14855	5	0	\N
227954	2132	6526541000	30200	14855	6	0	\N
227955	2134	11003323000	30200	14855	7	0	\N
227956	2134	11002319000	30200	14855	8	0	\N
227957	2134	11001315000	30200	14855	9	0	\N
227958	2134	11000311000	30200	14855	10	0	\N
227959	2134	10999307000	30200	14855	11	0	\N
227960	2134	10998303000	30200	14855	12	0	\N
227961	2134	10997299000	30200	14855	13	0	\N
227962	2134	10996295000	30200	14855	14	0	\N
227963	2134	10995291000	30200	14855	15	0	\N
227964	2132	6525540000	30200	14855	16	0	\N
227965	2134	10994287000	30200	14855	17	0	\N
227966	2134	10993283000	30200	14855	18	0	\N
227967	2133	8023202000	30200	14855	19	0	\N
227968	180	66920128434669	30202	14856	0	0	\N
227969	1397	1255551690000	30202	14856	1	0	\N
227970	1397	1255541689000	30202	14856	2	0	\N
227971	2133	8022200000	30202	14856	3	0	\N
227972	2132	6524539000	30202	14856	4	0	\N
227973	2134	10992279000	30202	14856	5	0	\N
227974	2132	6523538000	30202	14856	6	0	\N
227975	2132	6522537000	30202	14856	7	0	\N
227976	2134	10991275000	30202	14856	8	0	\N
227977	2134	10990271000	30202	14856	9	0	\N
227978	2133	8021198000	30202	14856	10	0	\N
227979	2134	10989267000	30202	14856	11	0	\N
227980	2134	10988263000	30202	14856	12	0	\N
227981	2134	10987259000	30202	14856	13	0	\N
227982	2134	10986255000	30202	14856	14	0	\N
227983	2134	10985251000	30202	14856	15	0	\N
227984	2134	10984247000	30202	14856	16	0	\N
227985	2133	8020196000	30202	14856	17	0	\N
227986	2133	8019194000	30202	14856	18	0	\N
227987	2133	8018192000	30202	14856	19	0	\N
227988	2133	8017190000	30202	14856	20	0	\N
228010	180	66000103434669	30204	14857	0	0	\N
228011	1397	1255531688000	30204	14857	1	0	\N
228012	2132	6521536000	30204	14857	2	0	\N
228013	2132	6520535000	30204	14857	3	0	\N
228014	2134	10983243000	30204	14857	4	0	\N
228015	2134	10982239000	30204	14857	5	0	\N
228016	512	66543508726895	30204	14857	6	0	\N
228017	2134	10981235000	30204	14857	7	0	\N
228018	2134	10980231000	30204	14857	8	0	\N
228019	2134	10979227000	30204	14857	9	0	\N
228020	2133	8016188000	30204	14857	10	0	\N
228021	2133	8015186000	30204	14857	11	0	\N
228022	180	66000103434669	30205	14857	0	0	\N
228023	1397	1255531688000	30205	14857	1	0	\N
228024	2132	6521536000	30205	14857	2	0	\N
228025	2132	6520535000	30205	14857	3	0	\N
228026	2134	10983243000	30205	14857	4	0	\N
228027	2134	10982239000	30205	14857	5	0	\N
228028	512	66543508726895	30205	14857	6	0	\N
228029	2134	10981235000	30205	14857	7	0	\N
228030	2134	10980231000	30205	14857	8	0	\N
228031	2134	10979227000	30205	14857	9	0	\N
228032	2133	8016188000	30205	14857	10	0	\N
228033	2133	8015186000	30205	14857	11	0	\N
228034	180	66000103434669	30206	14857	0	0	\N
228035	1397	1255531688000	30206	14857	1	0	\N
228036	2132	6521536000	30206	14857	2	0	\N
228037	2132	6520535000	30206	14857	3	0	\N
228038	2134	10983243000	30206	14857	4	0	\N
228039	2134	10982239000	30206	14857	5	0	\N
228040	512	66543508726895	30206	14857	6	0	\N
228041	2134	10981235000	30206	14857	7	0	\N
228042	2134	10980231000	30206	14857	8	0	\N
228043	2134	10979227000	30206	14857	9	0	\N
228044	2133	8016188000	30206	14857	10	0	\N
228045	2133	8015186000	30206	14857	11	0	\N
228046	234	66001375942306	30207	14832	0	0	\N
228047	1397	1255841719000	30207	14832	1	0	\N
228048	1397	1255831718000	30207	14832	2	0	\N
228049	1397	1255821717000	30207	14832	3	0	\N
228050	1397	1255811716000	30207	14832	4	0	\N
228051	1397	1255801715000	30207	14832	5	0	\N
228052	1397	1255791714000	30207	14832	6	0	\N
228053	1397	1255781713000	30207	14832	7	0	\N
228054	1397	1255771712000	30207	14832	8	0	\N
228055	1397	1255761711000	30207	14832	9	0	\N
228056	1397	1255751710000	30207	14832	10	0	\N
228057	1397	1255741709000	30207	14832	11	0	\N
228058	1397	1255731708000	30207	14832	12	0	\N
228059	1397	1255721707000	30207	14832	13	0	\N
228060	1397	1255711706000	30207	14832	14	0	\N
228061	1397	1255701705000	30207	14832	15	0	\N
228062	1397	1255691704000	30207	14832	16	0	\N
228063	1397	1255681703000	30207	14832	17	0	\N
228064	1397	1255671702000	30207	14832	18	0	\N
228065	1397	1255661701000	30207	14832	19	0	\N
228066	1397	1255651700000	30207	14832	20	0	\N
228067	1397	1255641699000	30207	14832	21	0	\N
228068	1397	1255631698000	30207	14832	22	0	\N
228069	1397	1255621697000	30207	14832	23	0	\N
228070	1397	1255611696000	30207	14832	24	0	\N
228071	1397	1255601695000	30207	14832	25	0	\N
228072	1397	1255591694000	30207	14832	26	0	\N
227939	2134	10999307000	30199	14855	11	0	9312
227940	2134	10998303000	30199	14855	12	0	9313
227941	2134	10997299000	30199	14855	13	0	9314
227942	2134	10996295000	30199	14855	14	0	9315
227943	2134	10995291000	30199	14855	15	0	9316
227945	2134	10994287000	30199	14855	17	0	9317
227946	2134	10993283000	30199	14855	18	0	9318
227947	2133	8023202000	30199	14855	19	0	8402
227989	180	66920128434669	30203	14856	0	0	5
227990	1397	1255551690000	30203	14856	1	0	18327
227992	2133	8022200000	30203	14856	3	0	8403
227993	2132	6524539000	30203	14856	4	0	2463
227994	2134	10992279000	30203	14856	5	0	9319
227995	2132	6523538000	30203	14856	6	0	2464
227997	2134	10991275000	30203	14856	8	0	9320
227998	2134	10990271000	30203	14856	9	0	9321
227999	2133	8021198000	30203	14856	10	0	8404
228000	2134	10989267000	30203	14856	11	0	9322
228001	2134	10988263000	30203	14856	12	0	9323
228003	2134	10986255000	30203	14856	14	0	9325
228004	2134	10985251000	30203	14856	15	0	9326
228005	2134	10984247000	30203	14856	16	0	9327
228006	2133	8020196000	30203	14856	17	0	8405
228007	2133	8019194000	30203	14856	18	0	8406
228009	2133	8017190000	30203	14856	20	0	8408
228073	1397	1255581693000	30207	14832	27	0	\N
228074	1397	1255571692000	30207	14832	28	0	\N
228075	1397	1255561691000	30207	14832	29	0	\N
228076	1397	1255551690000	30207	14832	30	0	\N
228077	1397	1255541689000	30207	14832	31	0	\N
228078	1397	1255531688000	30207	14832	32	0	\N
228079	2439	628993000000	30207	14832	33	0	\N
228080	2133	8101358000	30207	14832	34	0	\N
228081	2134	11134847000	30207	14832	36	0	\N
228082	180	66932438434669	30207	14832	37	0	\N
228083	180	66930178434669	30207	14832	38	0	\N
228084	180	66925153434669	30207	14832	39	0	\N
228085	180	66920128434669	30207	14832	40	0	\N
228086	180	66000103434669	30207	14832	41	0	\N
228087	512	66544509726895	30207	14832	42	0	\N
228088	512	66543508726895	30207	14832	43	0	\N
228089	2133	8100356000	30207	14832	44	0	\N
228090	2133	8099354000	30207	14832	45	0	\N
228091	2133	8098352000	30207	14832	46	0	\N
228092	2133	8097350000	30207	14832	47	0	\N
228093	2133	8096348000	30207	14832	48	0	\N
228094	1611	6730272069739	30207	14832	49	0	\N
228095	2132	6572587000	30207	14832	50	0	\N
228096	2132	6571586000	30207	14832	51	0	\N
228097	2134	11133843000	30207	14832	52	0	\N
228098	2134	11132839000	30207	14832	53	0	\N
228099	2134	11131835000	30207	14832	54	0	\N
228100	2134	11130831000	30207	14832	55	0	\N
228101	2134	11129827000	30207	14832	56	0	\N
228102	2134	11128823000	30207	14832	57	0	\N
228103	2134	11127819000	30207	14832	58	0	\N
228104	2134	11126815000	30207	14832	59	0	\N
228105	2134	11125811000	30207	14832	60	0	\N
228106	2134	11124807000	30207	14832	61	0	\N
228107	2134	11123803000	30207	14832	62	0	\N
228108	2134	11122799000	30207	14832	63	0	\N
228109	2134	11121795000	30207	14832	64	0	\N
228110	2134	11120791000	30207	14832	65	0	\N
228111	2134	11119787000	30207	14832	66	0	\N
228112	2134	11118783000	30207	14832	67	0	\N
228113	2134	11117779000	30207	14832	68	0	\N
228114	2134	11116775000	30207	14832	69	0	\N
228115	2134	11115771000	30207	14832	70	0	\N
228116	2134	11114767000	30207	14832	71	0	\N
228117	2134	11113763000	30207	14832	72	0	\N
228118	2134	11112759000	30207	14832	73	0	\N
228119	2134	11111755000	30207	14832	74	0	\N
228120	2134	11110751000	30207	14832	75	0	\N
228121	2133	8095346000	30207	14832	76	0	\N
228122	2133	8094344000	30207	14832	77	0	\N
228123	2133	8093342000	30207	14832	78	0	\N
228124	2133	8092340000	30207	14832	79	0	\N
228125	2133	8091338000	30207	14832	80	0	\N
228126	2133	8090336000	30207	14832	81	0	\N
228127	2133	8089334000	30207	14832	82	0	\N
228128	2133	8088332000	30207	14832	83	0	\N
228129	2133	8087330000	30207	14832	84	0	\N
228130	2133	8086328000	30207	14832	85	0	\N
228131	2133	8085326000	30207	14832	86	0	\N
228132	2132	6570585000	30207	14832	87	0	\N
228133	2132	6569584000	30207	14832	88	0	\N
228134	2132	6568583000	30207	14832	89	0	\N
228135	2132	6567582000	30207	14832	90	0	\N
228136	2132	6566581000	30207	14832	91	0	\N
228137	2132	6565580000	30207	14832	92	0	\N
228138	1611	5901802387769	30207	14832	93	0	\N
228139	1611	5342817059639	30207	14832	94	0	\N
228140	1611	3785156527184	30207	14832	95	0	\N
228141	2133	8084324000	30207	14832	96	0	\N
228142	2133	8083322000	30207	14832	97	0	\N
228143	2133	8082320000	30207	14832	98	0	\N
228144	2133	8081318000	30207	14832	99	0	\N
228145	2133	8080316000	30207	14832	100	0	\N
228146	2133	8079314000	30207	14832	101	0	\N
228147	664	66542507726895	30207	14832	102	0	\N
228148	664	66541497726895	30207	14832	103	0	\N
228149	664	66540494726895	30207	14832	104	0	\N
228150	2134	11109747000	30207	14832	105	0	\N
228151	2134	11108743000	30207	14832	106	0	\N
228152	2134	11107739000	30207	14832	107	0	\N
228153	2134	11106735000	30207	14832	108	0	\N
228154	2134	11105731000	30207	14832	109	0	\N
228155	2134	11104727000	30207	14832	110	0	\N
228156	2134	11103723000	30207	14832	111	0	\N
228157	2134	11102719000	30207	14832	112	0	\N
228158	2134	11101715000	30207	14832	113	0	\N
228159	2134	11100711000	30207	14832	114	0	\N
228160	2134	11099707000	30207	14832	115	0	\N
228161	2134	11098703000	30207	14832	116	0	\N
228162	2134	11097699000	30207	14832	117	0	\N
228163	2134	11096695000	30207	14832	118	0	\N
228164	2134	11095691000	30207	14832	119	0	\N
228165	2134	11094687000	30207	14832	120	0	\N
228168	1397	1255531688000	30210	14858	0	0	\N
228169	1397	1255521687000	30210	14858	1	0	\N
228170	1397	1255511686000	30210	14858	2	0	\N
228171	2132	6521536000	30210	14858	3	0	\N
228172	2132	6520535000	30210	14858	4	0	\N
228173	2134	10983243000	30210	14858	5	0	\N
228174	2134	10982239000	30210	14858	6	0	\N
228175	2132	6519534000	30210	14858	7	0	\N
228176	2134	10981235000	30210	14858	8	0	\N
228177	2134	10980231000	30210	14858	9	0	\N
228178	2134	10979227000	30210	14858	10	0	\N
228179	2134	10978223000	30210	14858	11	0	\N
228180	2133	8016188000	30210	14858	12	0	\N
228181	2133	8015186000	30210	14858	13	0	\N
228182	1726	112411112000	30210	14858	14	0	\N
228183	1726	111310112000	30210	14858	15	0	\N
228184	1726	110209112000	30210	14858	16	0	\N
228185	2134	10977219000	30210	14858	17	0	\N
228186	2134	10976215000	30210	14858	18	0	\N
228187	2132	6518533000	30210	14858	20	0	\N
228188	2132	6517532000	30210	14858	21	0	\N
228189	2134	10975211000	30210	14858	22	0	\N
228190	2133	8014184000	30210	14858	23	0	\N
228191	2133	8013182000	30210	14858	24	0	\N
228192	2133	8012180000	30210	14858	25	0	\N
228193	2133	8011178000	30210	14858	26	0	\N
228194	2133	8010176000	30210	14858	27	0	\N
228195	2133	8009174000	30210	14858	28	0	\N
228196	2134	10974207000	30210	14858	29	0	\N
228197	2134	10973203000	30210	14858	30	0	\N
228198	2134	10972199000	30210	14858	31	0	\N
228199	2134	10971195000	30210	14858	32	0	\N
228200	2134	10970191000	30210	14858	33	0	\N
228201	1397	1255531688000	30211	14858	0	0	\N
228202	1397	1255521687000	30211	14858	1	0	\N
228203	1397	1255511686000	30211	14858	2	0	\N
228204	2132	6521536000	30211	14858	3	0	\N
228205	2132	6520535000	30211	14858	4	0	\N
228206	2134	10983243000	30211	14858	5	0	\N
228207	2134	10982239000	30211	14858	6	0	\N
228208	2132	6519534000	30211	14858	7	0	\N
228209	2134	10981235000	30211	14858	8	0	\N
228210	2134	10980231000	30211	14858	9	0	\N
228211	2134	10979227000	30211	14858	10	0	\N
228212	2134	10978223000	30211	14858	11	0	\N
228213	2133	8016188000	30211	14858	12	0	\N
228214	2133	8015186000	30211	14858	13	0	\N
228215	1726	112411112000	30211	14858	14	0	\N
228216	1726	111310112000	30211	14858	15	0	\N
228217	1726	110209112000	30211	14858	16	0	\N
228218	2134	10977219000	30211	14858	17	0	\N
228219	2134	10976215000	30211	14858	18	0	\N
228220	2132	6518533000	30211	14858	20	0	\N
228221	2132	6517532000	30211	14858	21	0	\N
228222	2134	10975211000	30211	14858	22	0	\N
228223	2133	8014184000	30211	14858	23	0	\N
228224	2133	8013182000	30211	14858	24	0	\N
228225	2133	8012180000	30211	14858	25	0	\N
228226	2133	8011178000	30211	14858	26	0	\N
228227	2133	8010176000	30211	14858	27	0	\N
228228	2133	8009174000	30211	14858	28	0	\N
228229	2134	10974207000	30211	14858	29	0	\N
228230	2134	10973203000	30211	14858	30	0	\N
228231	2134	10972199000	30211	14858	31	0	\N
228232	2134	10971195000	30211	14858	32	0	\N
228233	1397	1255531688000	30213	14858	0	0	\N
228234	1397	1255521687000	30213	14858	1	0	\N
228235	1397	1255511686000	30213	14858	2	0	\N
228236	2132	6521536000	30213	14858	3	0	\N
228237	2132	6520535000	30213	14858	4	0	\N
228238	2134	10983243000	30213	14858	5	0	\N
228239	2134	10982239000	30213	14858	6	0	\N
228240	2132	6519534000	30213	14858	7	0	\N
228241	2134	10981235000	30213	14858	8	0	\N
228242	2134	10980231000	30213	14858	9	0	\N
228243	2134	10979227000	30213	14858	10	0	\N
228244	2134	10978223000	30213	14858	11	0	\N
228245	2133	8016188000	30213	14858	12	0	\N
228246	2133	8015186000	30213	14858	13	0	\N
228247	1726	112411112000	30213	14858	14	0	\N
228248	1726	111310112000	30213	14858	15	0	\N
228249	1726	110209112000	30213	14858	16	0	\N
228250	2134	10977219000	30213	14858	17	0	\N
228251	2134	10976215000	30213	14858	18	0	\N
228252	2132	6518533000	30213	14858	20	0	\N
228253	2132	6517532000	30213	14858	21	0	\N
228254	2134	10975211000	30213	14858	22	0	\N
228255	2133	8014184000	30213	14858	23	0	\N
228256	2133	8013182000	30213	14858	24	0	\N
228257	2133	8012180000	30213	14858	25	0	\N
228258	2133	8011178000	30213	14858	26	0	\N
228259	2133	8010176000	30213	14858	27	0	\N
228260	2133	8009174000	30213	14858	28	0	\N
228261	2134	10974207000	30213	14858	29	0	\N
228262	2134	10973203000	30213	14858	30	0	\N
228263	2134	10972199000	30213	14858	31	0	\N
228264	2134	10971195000	30213	14858	32	0	\N
228265	2134	10970191000	30213	14858	33	0	\N
228299	664	66010484726895	30215	14859	0	0	\N
228300	1397	1255501685000	30215	14859	1	0	\N
228301	2132	6516531000	30215	14859	2	0	\N
228302	2134	10969187000	30215	14859	3	0	\N
228303	2134	10968183000	30215	14859	4	0	\N
228304	2133	8008172000	30215	14859	5	0	\N
228305	2133	8007170000	30215	14859	6	0	\N
228306	2134	10967179000	30215	14859	7	0	\N
228307	2134	10966175000	30215	14859	8	0	\N
228308	512	66543506726895	30215	14859	9	0	\N
228309	664	66010484726895	30216	14859	0	0	\N
228310	1397	1255501685000	30216	14859	1	0	\N
228311	2132	6516531000	30216	14859	2	0	\N
228312	2134	10969187000	30216	14859	3	0	\N
228313	2134	10968183000	30216	14859	4	0	\N
228314	2133	8008172000	30216	14859	5	0	\N
228315	2133	8007170000	30216	14859	6	0	\N
228316	2134	10967179000	30216	14859	7	0	\N
228317	2134	10966175000	30216	14859	8	0	\N
228318	512	66543506726895	30216	14859	9	0	\N
228319	664	66010484726895	30217	14859	0	0	\N
228320	1397	1255501685000	30217	14859	1	0	\N
228321	2132	6516531000	30217	14859	2	0	\N
228322	2133	8008172000	30217	14859	3	0	\N
228323	2134	10970191000	30217	14859	4	0	\N
228324	2134	10969187000	30217	14859	5	0	\N
228325	2134	10968183000	30217	14859	6	0	\N
228326	2133	8007170000	30217	14859	7	0	\N
228327	2134	10967179000	30217	14859	8	0	\N
228328	512	66543506726895	30217	14859	9	0	\N
228329	664	66010484726895	30218	14859	0	0	\N
228330	1397	1255501685000	30218	14859	1	0	\N
228331	2132	6516531000	30218	14859	2	0	\N
228332	2133	8008172000	30218	14859	3	0	\N
228333	2134	10970191000	30218	14859	4	0	\N
228334	2134	10969187000	30218	14859	5	0	\N
228335	2134	10968183000	30218	14859	6	0	\N
228336	2133	8007170000	30218	14859	7	0	\N
228337	2134	10967179000	30218	14859	8	0	\N
228338	2134	10966175000	30218	14859	9	0	\N
228339	512	66543506726895	30218	14859	10	0	\N
228340	664	66010484726895	30219	14859	0	0	\N
228341	1397	1255501685000	30219	14859	1	0	\N
228342	2132	6516531000	30219	14859	2	0	\N
228343	2134	10969187000	30219	14859	3	0	\N
228344	2134	10968183000	30219	14859	4	0	\N
228268	1397	1255511686000	30214	14858	2	0	18331
228269	2132	6521536000	30214	14858	3	0	2466
228270	2132	6520535000	30214	14858	4	0	2467
228271	2134	10983243000	30214	14858	5	0	9328
228272	2134	10982239000	30214	14858	6	0	9329
228274	2134	10981235000	30214	14858	8	0	9330
228275	2134	10980231000	30214	14858	9	0	9331
228276	2134	10979227000	30214	14858	10	0	9332
228277	2134	10978223000	30214	14858	11	0	9333
228278	2133	8016188000	30214	14858	12	0	8409
228280	1726	112411112000	30214	14858	14	0	8374
228281	1726	111310112000	30214	14858	15	0	8375
228282	1726	110209112000	30214	14858	16	0	8376
228283	2134	10977219000	30214	14858	17	0	9334
228285	2132	6518533000	30214	14858	20	0	2469
228286	2132	6517532000	30214	14858	21	0	2470
228287	2134	10975211000	30214	14858	22	0	9336
228288	2133	8014184000	30214	14858	23	0	8411
228289	2133	8013182000	30214	14858	24	0	8412
228291	2133	8011178000	30214	14858	26	0	8414
228292	2133	8010176000	30214	14858	27	0	8415
228293	2133	8009174000	30214	14858	28	0	8416
228294	2134	10974207000	30214	14858	29	0	9337
228295	2134	10973203000	30214	14858	30	0	9338
228297	2134	10971195000	30214	14858	32	0	9340
228298	2134	10970191000	30214	14858	33	0	9341
228345	2133	8008172000	30219	14859	5	0	\N
228346	2133	8007170000	30219	14859	6	0	\N
228347	2134	10967179000	30219	14859	7	0	\N
228348	2134	10966175000	30219	14859	8	0	\N
228349	512	66543506726895	30219	14859	9	0	\N
228377	1533	717960000000	30223	14735	0	0	\N
228378	1533	715910000000	30223	14735	1	0	\N
228379	1397	1256681803000	30223	14735	2	0	\N
228380	234	66531385942306	30223	14735	3	0	\N
228381	234	66001375942306	30223	14735	4	0	\N
228382	1397	1256671802000	30223	14735	5	0	\N
228383	1397	1256661801000	30223	14735	6	0	\N
228384	1397	1256651800000	30223	14735	7	0	\N
228385	1397	1256641799000	30223	14735	8	0	\N
228386	1397	1256631798000	30223	14735	9	0	\N
228387	1397	1256621797000	30223	14735	10	0	\N
228388	1397	1256611796000	30223	14735	11	0	\N
228389	1397	1256601795000	30223	14735	12	0	\N
228390	1397	1256591794000	30223	14735	13	0	\N
228391	1397	1256581793000	30223	14735	14	0	\N
228392	1397	1256571792000	30223	14735	15	0	\N
228393	1397	1256561791000	30223	14735	16	0	\N
228394	1397	1256551790000	30223	14735	17	0	\N
228395	1397	1256541789000	30223	14735	18	0	\N
228396	1397	1256531788000	30223	14735	19	0	\N
228397	1397	1256521787000	30223	14735	20	0	\N
228398	1397	1256511786000	30223	14735	21	0	\N
228399	1397	1256501785000	30223	14735	22	0	\N
228400	1397	1256491784000	30223	14735	23	0	\N
228401	1397	1256481783000	30223	14735	24	0	\N
228402	1397	1256471782000	30223	14735	25	0	\N
228403	1397	1256461781000	30223	14735	26	0	\N
228404	1397	1256451780000	30223	14735	27	0	\N
228405	1397	1256441779000	30223	14735	28	0	\N
228406	1397	1256431778000	30223	14735	29	0	\N
228407	1397	1256421777000	30223	14735	30	0	\N
228408	1397	1256411776000	30223	14735	31	0	\N
228409	1397	1256401775000	30223	14735	32	0	\N
228410	1397	1256391774000	30223	14735	33	0	\N
228411	1397	1256381773000	30223	14735	34	0	\N
228412	1397	1256371772000	30223	14735	35	0	\N
228413	1397	1256361771000	30223	14735	36	0	\N
228414	1397	1256351770000	30223	14735	37	0	\N
228415	1397	1256341769000	30223	14735	38	0	\N
228416	1397	1256331768000	30223	14735	39	0	\N
228417	1397	1256321767000	30223	14735	40	0	\N
228418	1397	1256311766000	30223	14735	41	0	\N
228419	1397	1256301765000	30223	14735	42	0	\N
228420	1397	1256291764000	30223	14735	43	0	\N
228421	1397	1256281763000	30223	14735	44	0	\N
228422	1397	1256271762000	30223	14735	45	0	\N
228423	1397	1256261761000	30223	14735	46	0	\N
228424	1397	1256251760000	30223	14735	47	0	\N
228425	1397	1256241759000	30223	14735	48	0	\N
228426	1397	1256231758000	30223	14735	49	0	\N
228427	1397	1256221757000	30223	14735	56	0	\N
228428	1397	1256211756000	30223	14735	57	0	\N
228429	1397	1256201755000	30223	14735	58	0	\N
228430	1397	1256191754000	30223	14735	59	0	\N
228431	1397	1256181753000	30223	14735	60	0	\N
228432	1397	1256171752000	30223	14735	61	0	\N
228433	1397	1256161751000	30223	14735	62	0	\N
228434	1397	1256151750000	30223	14735	63	0	\N
228435	1397	1256141749000	30223	14735	64	0	\N
228436	1397	1256131748000	30223	14735	65	0	\N
228437	1397	1256121747000	30223	14735	66	0	\N
228438	1397	1256111746000	30223	14735	67	0	\N
228439	1397	1256101745000	30223	14735	68	0	\N
228440	1397	1256091744000	30223	14735	69	0	\N
228441	1397	1256081743000	30223	14735	70	0	\N
228442	1397	1256071742000	30223	14735	71	0	\N
228443	1397	1256061741000	30223	14735	72	0	\N
228444	1397	1256051740000	30223	14735	73	0	\N
228445	1397	1256041739000	30223	14735	74	0	\N
228446	1397	1256031738000	30223	14735	75	0	\N
228447	1397	1256021737000	30223	14735	76	0	\N
228448	1397	1256011736000	30223	14735	77	0	\N
228449	1397	1256001735000	30223	14735	78	0	\N
228450	1397	1255991734000	30223	14735	79	0	\N
228451	1397	1255981733000	30223	14735	80	0	\N
228452	1397	1255971732000	30223	14735	81	0	\N
228453	1397	1255961731000	30223	14735	82	0	\N
228454	1397	1255951730000	30223	14735	83	0	\N
228455	1397	1255941729000	30223	14735	84	0	\N
228456	1397	1255931728000	30223	14735	85	0	\N
228457	1397	1255921727000	30223	14735	86	0	\N
228458	1397	1255911726000	30223	14735	87	0	\N
228459	1397	1255901725000	30223	14735	88	0	\N
228460	1397	1255891724000	30223	14735	89	0	\N
228461	1397	1255881723000	30223	14735	90	0	\N
228462	1397	1255871722000	30223	14735	91	0	\N
228463	1397	1255861721000	30223	14735	92	0	\N
228464	1397	1255851720000	30223	14735	93	0	\N
228465	1397	1255841719000	30223	14735	94	0	\N
228466	1397	1255831718000	30223	14735	95	0	\N
228467	1397	1255821717000	30223	14735	96	0	\N
228477	1397	1255461681000	30225	14863	0	0	\N
228478	2441	927007000000	30225	14863	1	0	\N
228479	2133	8000156000	30225	14863	2	0	\N
228480	2132	6511526000	30225	14863	3	0	\N
228352	2132	6516531000	30220	14859	2	0	2471
228353	2134	10969187000	30220	14859	3	0	9342
228354	2134	10968183000	30220	14859	4	0	9343
228355	2133	8008172000	30220	14859	5	0	8417
228356	2133	8007170000	30220	14859	6	0	8418
228358	2134	10966175000	30220	14859	8	0	9345
228359	512	66543506726895	30220	14859	9	0	3
228360	1397	1255491684000	30221	14860	0	0	18333
228361	2133	8006168000	30221	14860	1	0	8419
228362	2132	6515530000	30221	14860	2	0	2472
228364	2133	8005166000	30221	14860	4	0	8420
228365	2134	10965171000	30221	14860	5	0	9346
228366	2134	10964167000	30221	14860	6	0	9347
228367	2134	10963163000	30221	14860	7	0	9348
228369	1397	1255481683000	30222	14861	0	0	18334
228370	2133	8004164000	30222	14861	1	0	8421
228371	2132	6513528000	30222	14861	2	0	2474
228372	2133	8003162000	30222	14861	3	0	8422
228373	2134	10961155000	30222	14861	4	0	9350
228375	2134	10959147000	30222	14861	6	0	9352
228376	2134	10958143000	30222	14861	7	0	9353
228468	1397	1255471682000	30224	14862	0	0	18335
228469	2440	532996750000	30224	14862	1	0	1
228470	2134	10957139000	30224	14862	2	0	9354
228472	2133	8001158000	30224	14862	4	0	8424
228473	2134	10956135000	30224	14862	5	0	9355
228474	2132	6512527000	30224	14862	6	0	2475
228475	2134	10955131000	30224	14862	7	0	9356
228481	2134	10953123000	30225	14863	4	0	\N
228482	2133	7999154000	30225	14863	5	0	\N
228483	2134	10952119000	30225	14863	6	0	\N
228484	2134	10951115000	30225	14863	7	0	\N
228485	2134	10950111000	30225	14863	8	0	\N
228486	2134	10949107000	30225	14863	9	0	\N
228487	2132	6510525000	30225	14863	10	0	\N
228488	1397	1255461681000	30226	14863	0	0	\N
228489	2441	927007000000	30226	14863	1	0	\N
228490	2133	8000156000	30226	14863	2	0	\N
228491	2132	6511526000	30226	14863	3	0	\N
228492	2134	10953123000	30226	14863	4	0	\N
228493	2133	7999154000	30226	14863	5	0	\N
228494	2134	10952119000	30226	14863	6	0	\N
228495	2134	10951115000	30226	14863	7	0	\N
228496	2134	10950111000	30226	14863	8	0	\N
228497	2134	10949107000	30226	14863	9	0	\N
228498	2132	6510525000	30226	14863	10	0	\N
228499	1397	1255481683000	30227	14861	0	0	\N
228500	2133	8004164000	30227	14861	1	0	\N
228501	2132	6513528000	30227	14861	2	0	\N
228502	2133	8003162000	30227	14861	3	0	\N
228503	2134	10961155000	30227	14861	4	0	\N
228504	2134	10960151000	30227	14861	5	0	\N
228505	2134	10959147000	30227	14861	6	0	\N
228506	2134	10958143000	30227	14861	7	0	\N
228507	2134	10957139000	30227	14861	8	0	\N
228519	1397	1255461681000	30229	14863	0	0	\N
228520	2441	927007000000	30229	14863	1	0	\N
228521	2133	8000156000	30229	14863	2	0	\N
228522	2132	6511526000	30229	14863	3	0	\N
228523	2134	10953123000	30229	14863	4	0	\N
228524	2133	7999154000	30229	14863	5	0	\N
228525	2134	10952119000	30229	14863	6	0	\N
228526	2134	10951115000	30229	14863	7	0	\N
228527	2134	10950111000	30229	14863	8	0	\N
228528	2134	10949107000	30229	14863	9	0	\N
228529	2132	6510525000	30229	14863	10	0	\N
228557	1397	1255421677000	30231	14865	0	0	\N
228558	2134	10935051000	30231	14865	1	0	\N
228559	2134	10934047000	30231	14865	2	0	\N
228560	2132	6505520000	30231	14865	3	0	\N
228561	2133	7991138000	30231	14865	4	0	\N
228562	2133	7990136000	30231	14865	5	0	\N
228563	2133	7989134000	30231	14865	6	0	\N
228564	2134	10933043000	30231	14865	7	0	\N
228565	2134	10932039000	30231	14865	8	0	\N
228566	2132	6504519000	30231	14865	9	0	\N
228567	1397	1255421677000	30232	14865	0	0	\N
228568	2134	10935051000	30232	14865	1	0	\N
228569	2134	10934047000	30232	14865	2	0	\N
228570	2132	6505520000	30232	14865	3	0	\N
228571	2133	7991138000	30232	14865	4	0	\N
228572	2133	7990136000	30232	14865	5	0	\N
228573	2133	7989134000	30232	14865	6	0	\N
228574	2134	10933043000	30232	14865	7	0	\N
228575	2134	10932039000	30232	14865	8	0	\N
228576	2132	6504519000	30232	14865	9	0	\N
228577	1397	1255421677000	30233	14865	0	0	\N
228578	2134	10935051000	30233	14865	1	0	\N
228579	2134	10934047000	30233	14865	2	0	\N
228580	2132	6505520000	30233	14865	3	0	\N
228581	2133	7991138000	30233	14865	4	0	\N
228582	2133	7990136000	30233	14865	5	0	\N
228583	2133	7989134000	30233	14865	6	0	\N
228584	2134	10933043000	30233	14865	7	0	\N
228585	2134	10932039000	30233	14865	8	0	\N
228586	2132	6504519000	30233	14865	9	0	\N
228587	1397	1255421677000	30234	14865	0	0	\N
228588	2134	10935051000	30234	14865	1	0	\N
228589	2134	10934047000	30234	14865	2	0	\N
228590	2132	6505520000	30234	14865	3	0	\N
228591	2133	7991138000	30234	14865	4	0	\N
228592	2133	7990136000	30234	14865	5	0	\N
228593	2133	7989134000	30234	14865	6	0	\N
228594	2134	10933043000	30234	14865	7	0	\N
228595	2134	10932039000	30234	14865	8	0	\N
228596	2132	6504519000	30234	14865	9	0	\N
228597	1397	1255421677000	30235	14865	0	0	\N
228598	2132	6505520000	30235	14865	1	0	\N
228599	2133	7991138000	30235	14865	2	0	\N
228600	2133	7990136000	30235	14865	3	0	\N
228601	2133	7989134000	30235	14865	4	0	\N
228602	2132	6504519000	30235	14865	5	0	\N
228603	1397	1255421677000	30236	14865	0	0	\N
228604	2134	10935051000	30236	14865	1	0	\N
228605	2134	10934047000	30236	14865	2	0	\N
228606	2132	6505520000	30236	14865	3	0	\N
228607	2133	7991138000	30236	14865	4	0	\N
228608	2133	7990136000	30236	14865	5	0	\N
228609	2133	7989134000	30236	14865	6	0	\N
228610	2134	10933043000	30236	14865	7	0	\N
228611	2134	10932039000	30236	14865	8	0	\N
228612	2132	6504519000	30236	14865	9	0	\N
228510	2133	8000156000	30228	14863	2	0	8425
228511	2132	6511526000	30228	14863	3	0	2476
228512	2134	10953123000	30228	14863	4	0	9358
228513	2133	7999154000	30228	14863	5	0	8426
228514	2134	10952119000	30228	14863	6	0	9359
228516	2134	10950111000	30228	14863	8	0	9361
228517	2134	10949107000	30228	14863	9	0	9362
228518	2132	6510525000	30228	14863	10	0	2477
228530	1397	1255451680000	30230	14864	0	0	18337
228531	1397	1255441679000	30230	14864	1	0	18338
228533	2134	10948103000	30230	14864	3	0	9363
228534	2132	6509524000	30230	14864	4	0	2478
228535	2132	6508523000	30230	14864	5	0	2479
228536	2132	6507522000	30230	14864	6	0	2480
228538	2134	10947099000	30230	14864	8	0	9364
228539	2134	10946095000	30230	14864	9	0	9365
228540	2134	10945091000	30230	14864	10	0	9366
228541	2134	10944087000	30230	14864	11	0	9367
228542	2134	10943083000	30230	14864	12	0	9368
228544	2133	7998152000	30230	14864	14	0	8427
228545	2133	7997150000	30230	14864	15	0	8428
228546	2133	7996148000	30230	14864	16	0	8429
228547	2134	10941075000	30230	14864	17	0	9370
228548	2134	10940071000	30230	14864	18	0	9371
228550	2134	10938063000	30230	14864	20	0	9373
228551	2134	10937059000	30230	14864	21	0	9374
228552	2134	10936055000	30230	14864	22	0	9375
228553	2133	7995146000	30230	14864	23	0	8430
228555	2133	7993142000	30230	14864	25	0	8432
228556	2133	7992140000	30230	14864	26	0	8433
228613	2132	6505520000	30237	14865	0	0	2482
228614	2133	7991138000	30237	14865	1	0	8434
228615	2133	7990136000	30237	14865	2	0	8435
228649	1397	1255391674000	30240	14867	0	0	\N
228650	2132	6500515000	30240	14867	1	0	\N
228651	2133	7984124000	30240	14867	2	0	\N
228652	2133	7983122000	30240	14867	3	0	\N
228653	1397	1255391674000	30241	14867	0	0	\N
228654	2132	6500515000	30241	14867	1	0	\N
228692	1397	1255341669000	30246	14872	0	0	\N
228693	1397	1255331668000	30246	14872	1	0	\N
228694	2133	7973102000	30246	14872	2	0	\N
228695	2132	6493508000	30246	14872	3	0	\N
228696	2133	7972100000	30246	14872	4	0	\N
228697	2133	7971098000	30246	14872	5	0	\N
228698	2133	7970096000	30246	14872	6	0	\N
228699	2133	7969094000	30246	14872	7	0	\N
228700	2132	6492507000	30246	14872	8	0	\N
228701	2132	6491506000	30246	14872	9	0	\N
228702	2134	10900915000	30246	14872	10	0	\N
228703	2134	10899911000	30246	14872	11	0	\N
228704	2134	10898907000	30246	14872	12	0	\N
228705	2134	10897903000	30246	14872	13	0	\N
228706	2134	10896899000	30246	14872	14	0	\N
228707	2134	10895895000	30246	14872	15	0	\N
228708	2134	10894891000	30246	14872	16	0	\N
228709	2134	10893887000	30246	14872	17	0	\N
228710	2134	10892883000	30246	14872	18	0	\N
228730	1397	1255321667000	30248	14873	0	0	\N
228731	2134	10891879000	30248	14873	1	0	\N
228732	2133	7968092000	30248	14873	2	0	\N
228733	2133	7967090000	30248	14873	3	0	\N
228734	2132	6490505000	30248	14873	4	0	\N
228735	1726	109108112000	30248	14873	5	0	\N
228736	1726	109007112000	30248	14873	6	0	\N
228737	2132	6489504000	30248	14873	7	0	\N
228738	2134	10890875000	30248	14873	8	0	\N
228739	2134	10889871000	30248	14873	9	0	\N
228740	2134	10888867000	30248	14873	10	0	\N
228741	1397	1255321667000	30249	14873	0	0	\N
228742	2134	10891879000	30249	14873	1	0	\N
228743	2133	7968092000	30249	14873	2	0	\N
228744	2133	7967090000	30249	14873	3	0	\N
228745	2132	6490505000	30249	14873	4	0	\N
228746	1726	109108112000	30249	14873	5	0	\N
228747	1726	109007112000	30249	14873	6	0	\N
228748	2132	6489504000	30249	14873	7	0	\N
228749	2134	10890875000	30249	14873	8	0	\N
228750	2134	10889871000	30249	14873	9	0	\N
228751	2134	10888867000	30249	14873	10	0	\N
228619	1397	1255411676000	30238	14866	1	0	18341
228620	1397	1255401675000	30238	14866	2	0	18342
228621	2132	6503518000	30238	14866	3	0	2484
228622	2134	10935051000	30238	14866	4	0	9376
228623	2134	10934047000	30238	14866	5	0	9377
228625	2134	10932039000	30238	14866	7	0	9379
228626	2134	10931035000	30238	14866	8	0	9380
228627	2134	10930031000	30238	14866	9	0	9381
228628	2134	10929027000	30238	14866	10	0	9382
228629	2133	7988132000	30238	14866	12	0	8437
228631	2133	7986128000	30238	14866	14	0	8439
228632	2133	7985126000	30238	14866	15	0	8440
228633	2132	6502517000	30238	14866	16	0	2485
228634	2132	6501516000	30238	14866	17	0	2486
228636	2134	10927019000	30238	14866	19	0	9384
228637	2134	10926015000	30238	14866	20	0	9385
228638	2134	10925011000	30238	14866	21	0	9386
228639	2134	10924007000	30238	14866	22	0	9387
228640	2134	10923003000	30238	14866	23	0	9388
228642	2134	10921999000	30239	14867	1	0	9389
228643	2134	10920995000	30239	14867	2	0	9390
228644	2134	10919991000	30239	14867	3	0	9391
228645	2134	10918987000	30239	14867	4	0	9392
228646	2132	6500515000	30239	14867	5	0	2487
228648	2133	7983122000	30239	14867	7	0	8442
228655	1397	1255381673000	30242	14868	0	0	18344
228656	2133	7982120000	30242	14868	1	0	8443
228657	2134	10917983000	30242	14868	2	0	9393
228659	2132	6498513000	30242	14868	4	0	2489
228660	2134	10916979000	30242	14868	5	0	9394
228661	2134	10915975000	30242	14868	6	0	9395
228662	2134	10914971000	30242	14868	7	0	9396
228663	2133	7981118000	30242	14868	8	0	8444
228665	1397	1255371672000	30243	14869	0	0	18345
228666	2134	10913967000	30243	14869	1	0	9397
228667	2134	10912963000	30243	14869	2	0	9398
228668	2134	10911959000	30243	14869	3	0	9399
228669	2134	10910955000	30243	14869	4	0	9400
228671	2133	7979114000	30243	14869	6	0	8446
228672	391	66932120434669	30244	14870	0	0	2
228673	1397	1255361671000	30245	14871	0	0	18346
228674	1397	1255351670000	30245	14871	1	0	18347
228676	2134	10908947000	30245	14871	3	0	9402
228677	2132	6496511000	30245	14871	4	0	2491
228678	2132	6495510000	30245	14871	5	0	2492
228679	2132	6494509000	30245	14871	6	0	2493
228680	2133	7978112000	30245	14871	7	0	8447
228682	2133	7976108000	30245	14871	9	0	8449
228683	2133	7975106000	30245	14871	10	0	8450
228684	2133	7974104000	30245	14871	11	0	8451
228685	2134	10907943000	30245	14871	12	0	9403
228686	2134	10906939000	30245	14871	13	0	9404
228688	2134	10904931000	30245	14871	15	0	9406
228689	2134	10903927000	30245	14871	16	0	9407
228690	2134	10902923000	30245	14871	17	0	9408
228691	2134	10901919000	30245	14871	18	0	9409
228712	1397	1255331668000	30247	14872	1	0	18349
228713	2133	7973102000	30247	14872	2	0	8452
228714	2132	6493508000	30247	14872	3	0	2494
228715	2133	7972100000	30247	14872	4	0	8453
228716	2133	7971098000	30247	14872	5	0	8454
228718	2133	7969094000	30247	14872	7	0	8456
228719	2132	6492507000	30247	14872	8	0	2495
228720	2132	6491506000	30247	14872	9	0	2496
228721	2134	10900915000	30247	14872	10	0	9410
228722	2134	10899911000	30247	14872	11	0	9411
228724	2134	10897903000	30247	14872	13	0	9413
228725	2134	10896899000	30247	14872	14	0	9414
228726	2134	10895895000	30247	14872	15	0	9415
228727	2134	10894891000	30247	14872	16	0	9416
228729	2134	10892883000	30247	14872	18	0	9418
228752	1397	1255321667000	30250	14873	0	0	18350
228761	1397	1255321667000	30251	14873	0	0	\N
228762	2134	10891879000	30251	14873	1	0	\N
228763	2133	7968092000	30251	14873	2	0	\N
228764	2133	7967090000	30251	14873	3	0	\N
228765	2132	6490505000	30251	14873	4	0	\N
228766	1726	109108112000	30251	14873	5	0	\N
228767	1726	109007112000	30251	14873	6	0	\N
228768	2132	6489504000	30251	14873	7	0	\N
228769	2134	10890875000	30251	14873	8	0	\N
228770	2134	10889871000	30251	14873	9	0	\N
228771	2134	10888867000	30251	14873	10	0	\N
228772	1397	1255311666000	30252	14874	0	0	\N
228773	2134	10888867000	30252	14874	1	0	\N
228774	2134	10887863000	30252	14874	2	0	\N
228775	2134	10886859000	30252	14874	3	0	\N
228776	2132	6489504000	30252	14874	4	0	\N
228777	2132	6488503000	30252	14874	5	0	\N
228778	2134	10885855000	30252	14874	6	0	\N
228779	2133	7966088000	30252	14874	7	0	\N
228780	2133	7965086000	30252	14874	8	0	\N
228800	1397	1255291664000	30255	14876	0	0	\N
228801	1397	1255281663000	30255	14876	1	0	\N
228802	2133	7961078000	30255	14876	2	0	\N
228803	2133	7960076000	30255	14876	3	0	\N
228804	2134	10879831000	30255	14876	4	0	\N
228805	2133	7959074000	30255	14876	5	0	\N
228806	2132	6486501000	30255	14876	6	0	\N
228807	2134	10878827000	30255	14876	7	0	\N
228808	2133	7958072000	30255	14876	8	0	\N
228809	2132	6485500000	30255	14876	9	0	\N
228810	2134	10877823000	30255	14876	10	0	\N
228811	2134	10876819000	30255	14876	11	0	\N
228812	2132	6484499000	30255	14876	12	0	\N
228813	2134	10875815000	30255	14876	13	0	\N
228814	2134	10874811000	30255	14876	14	0	\N
228815	2134	10873807000	30255	14876	15	0	\N
228816	2134	10872803000	30255	14876	16	0	\N
228817	2134	10871799000	30255	14876	17	0	\N
228818	1397	1255291664000	30256	14876	0	0	\N
228819	1397	1255281663000	30256	14876	1	0	\N
228820	2133	7961078000	30256	14876	2	0	\N
228821	2133	7960076000	30256	14876	3	0	\N
228822	2134	10879831000	30256	14876	4	0	\N
228823	2133	7959074000	30256	14876	5	0	\N
228824	2132	6486501000	30256	14876	6	0	\N
228825	2134	10878827000	30256	14876	7	0	\N
228826	2133	7958072000	30256	14876	8	0	\N
228827	2132	6485500000	30256	14876	9	0	\N
228828	2134	10877823000	30256	14876	10	0	\N
228829	2134	10876819000	30256	14876	11	0	\N
228830	2132	6484499000	30256	14876	12	0	\N
228831	2134	10875815000	30256	14876	13	0	\N
228832	2134	10874811000	30256	14876	14	0	\N
228833	2134	10873807000	30256	14876	15	0	\N
228834	2134	10872803000	30256	14876	16	0	\N
228835	2134	10871799000	30256	14876	17	0	\N
228854	333	66209360726895	30258	14877	0	0	\N
228855	1397	1255271662000	30258	14877	1	0	\N
228856	1397	1255261661000	30258	14877	2	0	\N
228857	1397	1255251660000	30258	14877	3	0	\N
228858	1397	1255241659000	30258	14877	4	0	\N
228859	2440	531992750000	30258	14877	5	0	\N
228860	2132	6483498000	30258	14877	6	0	\N
228861	2134	10870795000	30258	14877	7	0	\N
228862	2132	6482497000	30258	14877	8	0	\N
228863	2132	6481496000	30258	14877	9	0	\N
228864	2132	6480495000	30258	14877	10	0	\N
228865	2132	6479494000	30258	14877	11	0	\N
228866	2134	10869791000	30258	14877	12	0	\N
228867	2134	10868787000	30258	14877	13	0	\N
228868	2134	10867783000	30258	14877	14	0	\N
228869	2134	10866779000	30258	14877	15	0	\N
228870	2134	10865775000	30258	14877	16	0	\N
228871	2132	6478493000	30258	14877	17	0	\N
228872	2133	7957070000	30258	14877	18	0	\N
228873	2133	7956068000	30258	14877	19	0	\N
228874	2133	7955066000	30258	14877	20	0	\N
228875	2133	7954064000	30258	14877	21	0	\N
228876	2133	7953062000	30258	14877	22	0	\N
228877	2133	7952060000	30258	14877	23	0	\N
228878	2134	10864771000	30258	14877	24	0	\N
228879	2134	10863767000	30258	14877	25	0	\N
228880	2134	10862763000	30258	14877	26	0	\N
228881	2134	10861759000	30258	14877	27	0	\N
228882	2134	10860755000	30258	14877	28	0	\N
228883	2134	10859751000	30258	14877	29	0	\N
228884	2134	10858747000	30258	14877	30	0	\N
228885	2134	10857743000	30258	14877	31	0	\N
228886	2134	10856739000	30258	14877	32	0	\N
228887	2134	10855735000	30258	14877	33	0	\N
228888	2134	10854731000	30258	14877	34	0	\N
228755	2133	7967090000	30250	14873	3	0	8458
228756	2132	6490505000	30250	14873	4	0	2497
228757	1726	109108112000	30250	14873	5	0	8377
228758	1726	109007112000	30250	14873	6	0	8378
228759	2134	10890875000	30250	14873	7	0	9420
228781	1397	1255311666000	30253	14874	0	0	18351
228782	2134	10888867000	30253	14874	1	0	9422
228783	2134	10887863000	30253	14874	2	0	9423
228784	2134	10886859000	30253	14874	3	0	9424
228785	2132	6489504000	30253	14874	4	0	2498
228787	2134	10885855000	30253	14874	6	0	9425
228788	2134	10884851000	30253	14874	7	0	9426
228789	2133	7966088000	30253	14874	8	0	8459
228790	2133	7965086000	30253	14874	9	0	8460
228792	2133	7964084000	30254	14875	1	0	8461
228793	2133	7963082000	30254	14875	2	0	8462
228794	2134	10883847000	30254	14875	3	0	9427
228795	2132	6487502000	30254	14875	4	0	2500
228796	2133	7962080000	30254	14875	5	0	8463
228798	2134	10881839000	30254	14875	7	0	9429
228799	2134	10880835000	30254	14875	9	0	9430
228836	1397	1255291664000	30257	14876	0	0	18353
228837	1397	1255281663000	30257	14876	1	0	18354
228838	2133	7961078000	30257	14876	2	0	8464
228840	2134	10879831000	30257	14876	4	0	9431
228841	2133	7959074000	30257	14876	5	0	8466
228842	2132	6486501000	30257	14876	6	0	2501
228843	2134	10878827000	30257	14876	7	0	9432
228845	2132	6485500000	30257	14876	9	0	2502
228846	2134	10877823000	30257	14876	10	0	9433
228847	2134	10876819000	30257	14876	11	0	9434
228848	2132	6484499000	30257	14876	12	0	2503
228849	2134	10875815000	30257	14876	13	0	9435
228851	2134	10873807000	30257	14876	15	0	9437
228852	2134	10872803000	30257	14876	16	0	9438
228853	2134	10871799000	30257	14876	17	0	9439
228889	2134	10853727000	30258	14877	35	0	\N
228890	2133	7951058000	30258	14877	36	0	\N
228891	2133	7950056000	30258	14877	37	0	\N
228892	2133	7949054000	30258	14877	38	0	\N
228893	2133	7948052000	30258	14877	39	0	\N
228894	2133	7947050000	30258	14877	40	0	\N
228895	333	66209360726895	30259	14877	0	0	\N
228896	1397	1255271662000	30259	14877	1	0	\N
228897	1397	1255261661000	30259	14877	2	0	\N
228898	1397	1255251660000	30259	14877	3	0	\N
228899	1397	1255241659000	30259	14877	4	0	\N
228900	2440	531992750000	30259	14877	5	0	\N
228901	2132	6483498000	30259	14877	6	0	\N
228902	2134	10870795000	30259	14877	7	0	\N
228903	2132	6482497000	30259	14877	8	0	\N
228904	2132	6481496000	30259	14877	9	0	\N
228905	2132	6480495000	30259	14877	10	0	\N
228906	2132	6479494000	30259	14877	11	0	\N
228907	2134	10869791000	30259	14877	12	0	\N
228908	2134	10868787000	30259	14877	13	0	\N
228909	2134	10867783000	30259	14877	14	0	\N
228910	2134	10866779000	30259	14877	15	0	\N
228911	2134	10865775000	30259	14877	16	0	\N
228912	2132	6478493000	30259	14877	17	0	\N
228913	2133	7957070000	30259	14877	18	0	\N
228914	2133	7956068000	30259	14877	19	0	\N
228915	2133	7955066000	30259	14877	20	0	\N
228916	2133	7954064000	30259	14877	21	0	\N
228917	2133	7953062000	30259	14877	22	0	\N
228918	2133	7952060000	30259	14877	23	0	\N
228919	2134	10864771000	30259	14877	24	0	\N
228920	2134	10863767000	30259	14877	25	0	\N
228921	2134	10862763000	30259	14877	26	0	\N
228922	2134	10861759000	30259	14877	27	0	\N
228923	2134	10860755000	30259	14877	28	0	\N
228924	2134	10859751000	30259	14877	29	0	\N
228925	2134	10858747000	30259	14877	30	0	\N
228926	2134	10857743000	30259	14877	31	0	\N
228927	2134	10856739000	30259	14877	32	0	\N
228928	2134	10855735000	30259	14877	33	0	\N
228929	2134	10854731000	30259	14877	34	0	\N
228930	2134	10853727000	30259	14877	35	0	\N
228931	2133	7951058000	30259	14877	36	0	\N
228932	2133	7950056000	30259	14877	37	0	\N
228933	2133	7949054000	30259	14877	38	0	\N
228934	2133	7948052000	30259	14877	39	0	\N
228935	2133	7947050000	30259	14877	40	0	\N
229007	436	66717270000000	30263	14879	0	0	\N
229013	1397	1255201655000	30265	14880	0	0	\N
229014	2132	6472487000	30265	14880	1	0	\N
229015	2133	7939034000	30265	14880	2	0	\N
229016	2133	7938032000	30265	14880	3	0	\N
229017	2133	7937030000	30265	14880	4	0	\N
229018	2134	10838667000	30265	14880	5	0	\N
229019	2134	10837663000	30265	14880	6	0	\N
229020	2134	10836659000	30265	14880	7	0	\N
229021	2134	10835655000	30265	14880	8	0	\N
228938	1397	1255271662000	30261	14878	0	0	18355
228939	1397	1255261661000	30261	14878	1	0	18356
228940	1397	1255251660000	30261	14878	2	0	18357
228941	1397	1255241659000	30261	14878	3	0	18358
228942	1397	1255231658000	30261	14878	4	0	18359
228944	2134	10870795000	30261	14878	6	0	9440
228945	2132	6482497000	30261	14878	7	0	2505
228946	2132	6481496000	30261	14878	8	0	2506
228947	2132	6480495000	30261	14878	9	0	2507
228948	2132	6479494000	30261	14878	10	0	2508
228950	2134	10868787000	30261	14878	12	0	9442
228951	2134	10867783000	30261	14878	13	0	9443
228952	2134	10866779000	30261	14878	14	0	9444
228953	2134	10865775000	30261	14878	15	0	9445
228955	2132	6477492000	30261	14878	17	0	2510
228956	2133	7957070000	30261	14878	18	0	8468
228957	2133	7956068000	30261	14878	19	0	8469
228958	2133	7955066000	30261	14878	20	0	8470
228959	2133	7954064000	30261	14878	21	0	8471
228961	2133	7952060000	30261	14878	23	0	8473
228962	2134	10864771000	30261	14878	24	0	9446
228963	2134	10863767000	30261	14878	25	0	9447
228964	2134	10862763000	30261	14878	26	0	9448
228965	2134	10861759000	30261	14878	27	0	9449
228967	2134	10859751000	30261	14878	29	0	9451
228968	2134	10858747000	30261	14878	30	0	9452
228969	2134	10857743000	30261	14878	31	0	9453
228970	2134	10856739000	30261	14878	32	0	9454
228972	2134	10854731000	30261	14878	34	0	9456
228973	2134	10853727000	30261	14878	35	0	9457
228974	2134	10852723000	30261	14878	36	0	9458
228975	2134	10851719000	30261	14878	37	0	9459
228976	2134	10850715000	30261	14878	38	0	9460
228978	2134	10848707000	30261	14878	40	0	9462
228979	2133	7951058000	30261	14878	41	0	8474
228980	2133	7950056000	30261	14878	42	0	8475
228981	2133	7949054000	30261	14878	43	0	8476
228982	2132	6476491000	30261	14878	44	0	2511
228984	2133	7947050000	30261	14878	46	0	8478
228985	2133	7946048000	30261	14878	47	0	8479
228986	2133	7945046000	30261	14878	48	0	8480
228987	436	66717270000000	30262	14879	0	0	6
228989	1397	1255211656000	30262	14879	2	0	18361
228990	2133	7944044000	30262	14879	3	0	8481
228991	2132	6475490000	30262	14879	4	0	2512
228992	2132	6474489000	30262	14879	5	0	2513
228993	2132	6473488000	30262	14879	6	0	2514
228995	2133	7942040000	30262	14879	8	0	8483
228996	2133	7941038000	30262	14879	9	0	8484
228997	2133	7940036000	30262	14879	10	0	8485
228998	2134	10847703000	30262	14879	11	0	9463
228999	2134	10846699000	30262	14879	12	0	9464
229001	2134	10844691000	30262	14879	14	0	9466
229002	2134	10843687000	30262	14879	15	0	9467
229003	2134	10842683000	30262	14879	16	0	9468
229004	2134	10841679000	30262	14879	17	0	9469
229006	2134	10839671000	30262	14879	19	0	9471
229008	1397	1255201655000	30264	14880	0	0	18362
229009	2132	6472487000	30264	14880	1	0	2515
229010	2133	7939034000	30264	14880	2	0	8486
229011	2133	7938032000	30264	14880	3	0	8487
229022	1397	1255191654000	30266	14881	0	0	18363
229023	1397	1255181653000	30266	14881	1	0	18364
229024	1397	1255171652000	30266	14881	2	0	18365
229055	333	66209360726895	30267	14812	0	0	\N
229056	391	66932120434669	30267	14812	1	0	\N
229057	436	66717270000000	30267	14812	2	0	\N
229058	234	66531385942306	30267	14812	3	0	\N
229059	234	66001375942306	30267	14812	4	0	\N
229060	1397	1256141749000	30267	14812	5	0	\N
229061	1397	1256131748000	30267	14812	6	0	\N
229062	1397	1256121747000	30267	14812	7	0	\N
229063	1397	1256111746000	30267	14812	8	0	\N
229064	1397	1256101745000	30267	14812	9	0	\N
229065	1397	1256091744000	30267	14812	10	0	\N
229066	1397	1256081743000	30267	14812	11	0	\N
229067	1397	1256071742000	30267	14812	12	0	\N
229068	1397	1256061741000	30267	14812	13	0	\N
229069	1397	1256051740000	30267	14812	14	0	\N
229070	1397	1256041739000	30267	14812	15	0	\N
229071	1397	1256031738000	30267	14812	16	0	\N
229072	1397	1256021737000	30267	14812	17	0	\N
229073	1397	1256011736000	30267	14812	18	0	\N
229074	1397	1256001735000	30267	14812	19	0	\N
229075	1397	1255991734000	30267	14812	20	0	\N
229076	1397	1255981733000	30267	14812	21	0	\N
229077	1397	1255971732000	30267	14812	22	0	\N
229078	1397	1255961731000	30267	14812	23	0	\N
229079	1397	1255951730000	30267	14812	24	0	\N
229080	1397	1255941729000	30267	14812	25	0	\N
229081	1397	1255931728000	30267	14812	26	0	\N
229082	1397	1255921727000	30267	14812	27	0	\N
229083	1397	1255911726000	30267	14812	28	0	\N
229084	1397	1255901725000	30267	14812	29	0	\N
229085	1397	1255891724000	30267	14812	30	0	\N
229086	1397	1255881723000	30267	14812	31	0	\N
229087	1397	1255871722000	30267	14812	32	0	\N
229088	1397	1255861721000	30267	14812	33	0	\N
229089	1397	1255851720000	30267	14812	34	0	\N
229090	1397	1255841719000	30267	14812	35	0	\N
229091	1397	1255831718000	30267	14812	36	0	\N
229092	1397	1255821717000	30267	14812	37	0	\N
229093	1397	1255811716000	30267	14812	38	0	\N
229094	1397	1255801715000	30267	14812	39	0	\N
229095	1397	1255791714000	30267	14812	40	0	\N
229096	1397	1255781713000	30267	14812	41	0	\N
229097	1397	1255771712000	30267	14812	42	0	\N
229098	1397	1255761711000	30267	14812	43	0	\N
229099	1397	1255751710000	30267	14812	44	0	\N
229100	1397	1255741709000	30267	14812	45	0	\N
229101	1397	1255731708000	30267	14812	46	0	\N
229102	1397	1255721707000	30267	14812	47	0	\N
229103	1397	1255711706000	30267	14812	48	0	\N
229104	1397	1255701705000	30267	14812	49	0	\N
229105	1397	1255691704000	30267	14812	50	0	\N
229106	1397	1255681703000	30267	14812	51	0	\N
229107	1397	1255671702000	30267	14812	52	0	\N
229108	1397	1255661701000	30267	14812	53	0	\N
229109	1397	1255651700000	30267	14812	54	0	\N
229110	1397	1255641699000	30267	14812	55	0	\N
229111	1397	1255631698000	30267	14812	56	0	\N
229112	1397	1255621697000	30267	14812	57	0	\N
229113	1397	1255611696000	30267	14812	58	0	\N
229114	1397	1255601695000	30267	14812	59	0	\N
229115	1397	1255591694000	30267	14812	60	0	\N
229116	1397	1255581693000	30267	14812	61	0	\N
229117	1397	1255571692000	30267	14812	62	0	\N
229118	1397	1255561691000	30267	14812	63	0	\N
229119	1397	1255551690000	30267	14812	64	0	\N
229120	1397	1255541689000	30267	14812	65	0	\N
229121	1397	1255531688000	30267	14812	66	0	\N
229122	1397	1255521687000	30267	14812	67	0	\N
229123	1397	1255511686000	30267	14812	68	0	\N
229124	1397	1255501685000	30267	14812	69	0	\N
229125	1397	1255491684000	30267	14812	70	0	\N
229126	1397	1255481683000	30267	14812	71	0	\N
229127	1397	1255471682000	30267	14812	72	0	\N
229128	1397	1255461681000	30267	14812	73	0	\N
229129	1397	1255451680000	30267	14812	74	0	\N
229130	1397	1255441679000	30267	14812	75	0	\N
229131	1397	1255431678000	30267	14812	76	0	\N
229132	1397	1255421677000	30267	14812	77	0	\N
229133	1397	1255411676000	30267	14812	78	0	\N
229134	1397	1255401675000	30267	14812	79	0	\N
229135	1397	1255391674000	30267	14812	80	0	\N
229136	1397	1255381673000	30267	14812	81	0	\N
229137	1397	1255371672000	30267	14812	82	0	\N
229138	1397	1255361671000	30267	14812	83	0	\N
229139	1397	1255351670000	30267	14812	84	0	\N
229140	1397	1255341669000	30267	14812	85	0	\N
229141	1397	1255331668000	30267	14812	86	0	\N
229142	1397	1255321667000	30267	14812	87	0	\N
229143	1397	1255311666000	30267	14812	88	0	\N
229144	1397	1255301665000	30267	14812	89	0	\N
229145	1397	1255291664000	30267	14812	90	0	\N
229146	1397	1255281663000	30267	14812	91	0	\N
229147	1397	1255271662000	30267	14812	92	0	\N
229148	1397	1255261661000	30267	14812	93	0	\N
229149	1397	1255251660000	30267	14812	94	0	\N
229150	1397	1255241659000	30267	14812	95	0	\N
229151	1397	1255231658000	30267	14812	96	0	\N
229152	1397	1255221657000	30267	14812	97	0	\N
229153	1397	1255211656000	30267	14812	98	0	\N
229154	1397	1255201655000	30267	14812	99	0	\N
229155	1397	1255191654000	30267	14812	100	0	\N
229156	1397	1255181653000	30267	14812	101	0	\N
229157	1397	1255171652000	30267	14812	102	0	\N
229158	2163	1198995968420	30267	14812	103	0	\N
229159	180	66932438434669	30267	14812	104	0	\N
229160	180	66930178434669	30267	14812	105	0	\N
229027	2132	6470485000	30266	14881	5	0	2517
229028	2133	7935026000	30266	14881	6	0	8490
229029	2133	7934024000	30266	14881	7	0	8491
229030	2133	7933022000	30266	14881	8	0	8492
229031	2134	10838667000	30266	14881	9	0	9472
229033	2134	10836659000	30266	14881	11	0	9474
229034	2134	10835655000	30266	14881	12	0	9475
229035	2134	10834651000	30266	14881	13	0	9476
229036	2134	10833647000	30266	14881	15	0	9477
229037	2134	10832643000	30266	14881	16	0	9478
229039	2132	6468483000	30266	14881	18	0	2519
229040	2133	7932020000	30266	14881	19	0	8493
229041	2134	10831639000	30266	14881	20	0	9479
229042	2134	10830635000	30266	14881	21	0	9480
229044	2134	10828627000	30266	14881	23	0	9482
229045	2134	10827623000	30266	14881	24	0	9483
229046	2134	10826619000	30266	14881	25	0	9484
229047	2134	10825615000	30266	14881	26	0	9485
229048	2133	7931018000	30266	14881	27	0	8494
229050	2133	7929014000	30266	14881	29	0	8496
229051	2133	7928012000	30266	14881	30	0	8497
229052	2134	10824611000	30266	14881	31	0	9486
229053	2134	10823607000	30266	14881	32	0	9487
229054	2134	10822603000	30266	14881	33	0	9488
229161	180	66925153434669	30267	14812	106	0	\N
229162	180	66920128434669	30267	14812	107	0	\N
229163	180	66000103434669	30267	14812	108	0	\N
229164	2133	8178512000	30267	14812	109	0	\N
229165	512	66544509726895	30267	14812	110	0	\N
229166	512	66543508726895	30267	14812	111	0	\N
229167	1726	112411112000	30267	14812	112	0	\N
229168	1726	111310112000	30267	14812	113	0	\N
229169	1726	110209112000	30267	14812	114	0	\N
229170	2134	11270387000	30267	14812	116	0	\N
229171	2134	11269383000	30267	14812	117	0	\N
229172	2134	11268379000	30267	14812	118	0	\N
229173	2134	11267375000	30267	14812	119	0	\N
229174	1726	109108112000	30267	14812	120	0	\N
229175	1726	109007112000	30267	14812	121	0	\N
229176	664	66544509726895	30267	14812	122	0	\N
229177	664	66543508726895	30267	14812	123	0	\N
229178	1397	1255161651000	30268	14882	0	0	\N
229179	1397	1255151650000	30268	14882	1	0	\N
229180	163	66932426434669	30268	14882	2	0	\N
229181	2134	10821599000	30268	14882	3	0	\N
229182	2132	6467482000	30268	14882	4	0	\N
229183	2132	6466481000	30268	14882	5	0	\N
229184	2133	7927010000	30268	14882	6	0	\N
229185	2134	10820595000	30268	14882	7	0	\N
229186	2134	10819591000	30268	14882	8	0	\N
229187	2134	10818587000	30268	14882	9	0	\N
229188	2134	10817583000	30268	14882	10	0	\N
229189	2134	10816579000	30268	14882	11	0	\N
229190	2134	10815575000	30268	14882	12	0	\N
229191	2134	10814571000	30268	14882	13	0	\N
229192	2134	10813567000	30268	14882	14	0	\N
229193	2133	7926008000	30268	14882	15	0	\N
229194	2133	7925006000	30268	14882	16	0	\N
229195	2133	7924004000	30268	14882	17	0	\N
229196	2133	7923002000	30268	14882	18	0	\N
229197	2132	6465480000	30268	14882	19	0	\N
229239	1397	1255131648000	30272	14884	0	0	\N
229240	597	66543509084035	30272	14884	1	0	\N
229241	2132	6462477000	30272	14884	2	0	\N
229242	2134	10808547000	30272	14884	3	0	\N
229243	2134	10807543000	30272	14884	4	0	\N
229244	2133	7918994000	30272	14884	5	0	\N
229245	2134	10806539000	30272	14884	6	0	\N
229246	2134	10805535000	30272	14884	7	0	\N
229247	2134	10804531000	30272	14884	8	0	\N
229248	2133	7917992000	30272	14884	9	0	\N
229249	2133	7916990000	30272	14884	10	0	\N
229272	1397	1255121647000	30274	14885	0	0	\N
229273	1397	1255111646000	30274	14885	1	0	\N
229274	1397	1255101645000	30274	14885	2	0	\N
229275	1397	1255091644000	30274	14885	3	0	\N
229276	150	66932427747169	30274	14885	4	0	\N
229277	2133	7915988000	30274	14885	5	0	\N
229278	2133	7914986000	30274	14885	6	0	\N
229279	2134	10803527000	30274	14885	7	0	\N
229280	2134	10802523000	30274	14885	8	0	\N
229281	2132	6461476000	30274	14885	9	0	\N
229282	2134	10801519000	30274	14885	10	0	\N
229283	2134	10800515000	30274	14885	11	0	\N
229284	2132	6460475000	30274	14885	12	0	\N
229285	2132	6459474000	30274	14885	13	0	\N
229286	2132	6458473000	30274	14885	14	0	\N
229287	2132	6457472000	30274	14885	15	0	\N
229288	2132	6456471000	30274	14885	16	0	\N
229289	2134	10799511000	30274	14885	17	0	\N
229290	2134	10798507000	30274	14885	18	0	\N
229291	2134	10797503000	30274	14885	19	0	\N
229292	2134	10796499000	30274	14885	20	0	\N
229293	2134	10795495000	30274	14885	21	0	\N
229294	2134	10794491000	30274	14885	22	0	\N
229295	2134	10793487000	30274	14885	23	0	\N
229296	2134	10792483000	30274	14885	24	0	\N
229200	163	66932426434669	30269	14882	2	0	1
229201	2132	6467482000	30269	14882	3	0	2520
229202	2132	6466481000	30269	14882	4	0	2521
229203	2133	7927010000	30269	14882	5	0	8498
229204	2133	7926008000	30269	14882	6	0	8499
229206	2133	7924004000	30269	14882	8	0	8501
229207	2133	7923002000	30269	14882	9	0	8502
229208	2132	6465480000	30269	14882	10	0	2522
229209	1397	1255141649000	30270	14883	0	0	18368
229210	2134	10821599000	30270	14883	1	0	9489
229212	2132	6463478000	30270	14883	3	0	2524
229213	2134	10820595000	30270	14883	4	0	9490
229214	2134	10819591000	30270	14883	5	0	9491
229215	2134	10818587000	30270	14883	6	0	9492
229217	2133	7920998000	30270	14883	8	0	8504
229218	2133	7919996000	30270	14883	9	0	8505
229219	2134	10817583000	30270	14883	10	0	9493
229220	2134	10816579000	30270	14883	11	0	9494
229221	2134	10815575000	30270	14883	12	0	9495
229223	2134	10813567000	30270	14883	14	0	9497
229224	2134	10812563000	30270	14883	15	0	9498
229225	2134	10811559000	30270	14883	16	0	9499
229226	2134	10810555000	30270	14883	17	0	9500
229227	2134	10809551000	30270	14883	18	0	9501
229229	597	66543509084035	30271	14884	1	0	1
229230	2132	6462477000	30271	14884	2	0	2525
229231	2134	10808547000	30271	14884	3	0	9502
229232	2134	10807543000	30271	14884	4	0	9503
229234	2134	10806539000	30271	14884	6	0	9504
229235	2134	10805535000	30271	14884	7	0	9505
229236	2134	10804531000	30271	14884	8	0	9506
229237	2133	7917992000	30271	14884	9	0	8507
229238	2133	7916990000	30271	14884	10	0	8508
229251	1397	1255111646000	30273	14885	1	0	18371
229252	1397	1255101645000	30273	14885	2	0	18372
229253	1397	1255091644000	30273	14885	3	0	18373
229254	150	66932427747169	30273	14885	4	0	1
229255	2133	7915988000	30273	14885	5	0	8509
229257	2132	6461476000	30273	14885	7	0	2526
229258	2132	6460475000	30273	14885	8	0	2527
229259	2132	6459474000	30273	14885	9	0	2528
229260	2132	6458473000	30273	14885	10	0	2529
229262	2132	6456471000	30273	14885	12	0	2531
229263	2133	7913984000	30273	14885	13	0	8511
229264	2133	7912982000	30273	14885	14	0	8512
229265	2133	7911980000	30273	14885	15	0	8513
229266	2133	7910978000	30273	14885	16	0	8514
229268	2133	7908974000	30273	14885	18	0	8516
229269	2133	7907972000	30273	14885	19	0	8517
229270	2133	7906970000	30273	14885	20	0	8518
229271	2133	7905968000	30273	14885	21	0	8519
229297	2134	10791479000	30274	14885	25	0	\N
229298	2133	7913984000	30274	14885	26	0	\N
229299	2133	7912982000	30274	14885	27	0	\N
229300	2133	7911980000	30274	14885	28	0	\N
229301	2133	7910978000	30274	14885	29	0	\N
229302	2133	7909976000	30274	14885	30	0	\N
229303	2133	7908974000	30274	14885	31	0	\N
229304	2133	7907972000	30274	14885	32	0	\N
229305	2133	7906970000	30274	14885	33	0	\N
229306	2133	7905968000	30274	14885	34	0	\N
229307	2134	10790475000	30274	14885	35	0	\N
229308	2134	10789471000	30274	14885	36	0	\N
229309	2134	10788467000	30274	14885	37	0	\N
229310	2134	10787463000	30274	14885	38	0	\N
229366	1397	1255051640000	30279	14889	0	0	\N
229367	2134	10773407000	30279	14889	1	0	\N
229368	2134	10772403000	30279	14889	2	0	\N
229369	1726	107805112000	30279	14889	3	0	\N
229370	2132	6451466000	30279	14889	4	0	\N
229371	2132	6450465000	30279	14889	5	0	\N
229372	2134	10771399000	30279	14889	6	0	\N
229373	2134	10770395000	30279	14889	7	0	\N
229374	333	66209360726895	30280	14866	0	0	\N
229375	391	66932120434669	30280	14866	1	0	\N
229376	436	66717270000000	30280	14866	2	0	\N
229377	2440	531992750000	30280	14866	3	0	\N
229378	163	66932426434669	30280	14866	4	0	\N
229379	150	66932427747169	30280	14866	5	0	\N
229380	597	66543509084035	30280	14866	6	0	\N
229381	1726	109108112000	30280	14866	7	0	\N
229382	1726	109007112000	30280	14866	8	0	\N
229383	1726	108906112000	30280	14866	9	0	\N
229384	1726	107805112000	30280	14866	10	0	\N
229385	1397	1255051640000	30281	14889	0	0	\N
229386	2134	10773407000	30281	14889	1	0	\N
229387	2134	10772403000	30281	14889	2	0	\N
229388	1726	107805112000	30281	14889	3	0	\N
229389	2132	6451466000	30281	14889	4	0	\N
229390	2132	6450465000	30281	14889	5	0	\N
229391	2134	10771399000	30281	14889	6	0	\N
229392	2134	10770395000	30281	14889	7	0	\N
229393	1397	1255041639000	30282	14890	0	0	\N
229394	2132	6449464000	30282	14890	1	0	\N
229395	2134	10769391000	30282	14890	2	0	\N
229396	2134	10768387000	30282	14890	3	0	\N
229397	2134	10767383000	30282	14890	4	0	\N
229404	1397	1255031638000	30284	14891	0	0	\N
229405	2132	6448463000	30284	14891	1	0	\N
229406	1397	1255031638000	30285	14891	0	0	\N
229407	2134	10765375000	30285	14891	1	0	\N
229408	2134	10764371000	30285	14891	2	0	\N
229409	2132	6448463000	30285	14891	3	0	\N
229410	2134	10763367000	30285	14891	4	0	\N
229411	2134	10762363000	30285	14891	5	0	\N
229412	1397	1255031638000	30286	14891	0	0	\N
229413	2134	10765375000	30286	14891	1	0	\N
229414	2134	10764371000	30286	14891	2	0	\N
229415	2132	6448463000	30286	14891	3	0	\N
229416	2134	10763367000	30286	14891	4	0	\N
229417	2134	10762363000	30286	14891	5	0	\N
229424	1397	1255021637000	30288	14892	0	0	\N
229425	1397	1255011636000	30288	14892	1	0	\N
229426	2132	6447462000	30288	14892	2	0	\N
229427	2132	6446461000	30288	14892	3	0	\N
229428	2132	6445460000	30288	14892	4	0	\N
229429	1397	1255021637000	30289	14892	0	0	\N
229430	1397	1255011636000	30289	14892	1	0	\N
229431	2134	10761359000	30289	14892	2	0	\N
229432	2132	6447462000	30289	14892	3	0	\N
229313	2133	7903964000	30275	14886	2	0	8521
229314	2133	7902962000	30275	14886	3	0	8522
229315	1397	1255071642000	30276	14887	0	0	18375
229316	2132	6455470000	30276	14887	1	0	2532
229317	2132	6454469000	30276	14887	2	0	2533
229319	2134	10802523000	30276	14887	4	0	9508
229320	2134	10801519000	30276	14887	5	0	9509
229321	2133	7901960000	30276	14887	6	0	8523
229322	2133	7900958000	30276	14887	7	0	8524
229323	2133	7899956000	30276	14887	8	0	8525
229325	2134	10799511000	30276	14887	10	0	9511
229326	2134	10798507000	30276	14887	11	0	9512
229327	2134	10797503000	30276	14887	12	0	9513
229328	2134	10796499000	30276	14887	13	0	9514
229330	2134	10794491000	30276	14887	15	0	9516
229331	2134	10793487000	30276	14887	16	0	9517
229332	2134	10792483000	30276	14887	17	0	9518
229333	2134	10791479000	30276	14887	18	0	9519
229334	2134	10790475000	30276	14887	19	0	9520
229336	2134	10788467000	30276	14887	21	0	9522
229337	2134	10787463000	30276	14887	22	0	9523
229338	2134	10786459000	30276	14887	23	0	9524
229339	2134	10785455000	30276	14887	25	0	9525
229340	2134	10784451000	30276	14887	26	0	9526
229342	2134	10782443000	30276	14887	28	0	9528
229343	2134	10781439000	30276	14887	29	0	9529
229344	2134	10780435000	30276	14887	30	0	9530
229345	2134	10779431000	30276	14887	31	0	9531
229347	1397	1255061641000	30277	14888	0	0	18376
229348	2133	7898954000	30277	14888	1	0	8526
229349	2133	7897952000	30277	14888	2	0	8527
229350	2133	7896950000	30277	14888	3	0	8528
229351	2134	10778427000	30277	14888	4	0	9532
229353	2134	10776419000	30277	14888	6	0	9534
229354	2132	6452467000	30277	14888	7	0	2535
229355	1726	108906112000	30277	14888	8	0	8379
229356	2134	10775415000	30277	14888	9	0	9535
229357	2134	10774411000	30277	14888	10	0	9536
229359	2134	10773407000	30278	14889	1	0	9537
229360	2134	10772403000	30278	14889	2	0	9538
229361	1726	107805112000	30278	14889	3	0	8380
229362	2132	6451466000	30278	14889	4	0	2536
229364	2134	10771399000	30278	14889	6	0	9539
229365	2134	10770395000	30278	14889	7	0	9540
229398	1397	1255041639000	30283	14890	0	0	18378
229399	2132	6449464000	30283	14890	1	0	2538
229400	2134	10769391000	30283	14890	2	0	9541
229402	2134	10767383000	30283	14890	4	0	9543
229403	2134	10766379000	30283	14890	5	0	9544
229418	1397	1255031638000	30287	14891	0	0	18379
229419	2134	10765375000	30287	14891	1	0	9545
229420	2134	10764371000	30287	14891	2	0	9546
229422	2134	10763367000	30287	14891	4	0	9547
229423	2134	10762363000	30287	14891	5	0	9548
229433	2134	10760355000	30289	14892	4	0	\N
229434	2132	6446461000	30289	14892	5	0	\N
229435	2132	6445460000	30289	14892	6	0	\N
229436	2134	10759351000	30289	14892	7	0	\N
229437	2134	10758347000	30289	14892	8	0	\N
229438	2134	10757343000	30289	14892	9	0	\N
229439	2134	10756339000	30289	14892	10	0	\N
229440	2134	10755335000	30289	14892	11	0	\N
229441	2134	10754331000	30289	14892	12	0	\N
229442	1397	1255021637000	30290	14892	0	0	\N
229443	1397	1255011636000	30290	14892	1	0	\N
229444	2134	10761359000	30290	14892	2	0	\N
229445	2132	6447462000	30290	14892	3	0	\N
229446	2134	10760355000	30290	14892	4	0	\N
229447	2132	6446461000	30290	14892	5	0	\N
229448	2132	6445460000	30290	14892	6	0	\N
229449	2134	10759351000	30290	14892	7	0	\N
229450	2134	10758347000	30290	14892	8	0	\N
229451	2134	10757343000	30290	14892	9	0	\N
229452	2134	10756339000	30290	14892	10	0	\N
229453	2134	10755335000	30290	14892	11	0	\N
229454	2134	10754331000	30290	14892	12	0	\N
229455	1397	1255021637000	30291	14892	0	0	\N
229456	1397	1255011636000	30291	14892	1	0	\N
229457	2134	10761359000	30291	14892	2	0	\N
229458	2132	6447462000	30291	14892	3	0	\N
229459	2134	10760355000	30291	14892	4	0	\N
229460	2132	6446461000	30291	14892	5	0	\N
229461	2132	6445460000	30291	14892	6	0	\N
229462	2134	10759351000	30291	14892	7	0	\N
229463	2134	10758347000	30291	14892	8	0	\N
229464	2134	10757343000	30291	14892	9	0	\N
229465	2134	10756339000	30291	14892	10	0	\N
229466	2134	10755335000	30291	14892	11	0	\N
229467	2134	10754331000	30291	14892	12	0	\N
229468	1397	1255021637000	30292	14892	0	0	\N
229469	1397	1255011636000	30292	14892	1	0	\N
229470	2134	10761359000	30292	14892	2	0	\N
229471	2132	6447462000	30292	14892	3	0	\N
229472	2134	10760355000	30292	14892	4	0	\N
229473	2132	6446461000	30292	14892	5	0	\N
229474	2132	6445460000	30292	14892	6	0	\N
229475	2134	10759351000	30292	14892	7	0	\N
229476	2134	10758347000	30292	14892	8	0	\N
229477	2134	10757343000	30292	14892	9	0	\N
229478	2134	10756339000	30292	14892	10	0	\N
229479	2134	10755335000	30292	14892	11	0	\N
229480	2134	10754331000	30292	14892	12	0	\N
229494	1397	1255001635000	30294	14893	0	0	\N
229495	2132	6444459000	30294	14893	1	0	\N
229496	2132	6443458000	30294	14893	2	0	\N
229497	2134	10753327000	30294	14893	3	0	\N
229498	2134	10752323000	30294	14893	4	0	\N
229499	2134	10751319000	30294	14893	5	0	\N
229500	2134	10750315000	30294	14893	6	0	\N
229501	1397	1255001635000	30295	14893	0	0	\N
229502	2132	6444459000	30295	14893	1	0	\N
229503	2132	6443458000	30295	14893	2	0	\N
229504	2134	10753327000	30295	14893	3	0	\N
229505	2134	10752323000	30295	14893	4	0	\N
229506	2134	10751319000	30295	14893	5	0	\N
229507	2134	10750315000	30295	14893	6	0	\N
229508	1397	1255001635000	30296	14893	0	0	\N
229509	2132	6444459000	30296	14893	1	0	\N
229510	2132	6443458000	30296	14893	2	0	\N
229511	2134	10753327000	30296	14893	3	0	\N
229512	2134	10752323000	30296	14893	4	0	\N
229513	2134	10751319000	30296	14893	5	0	\N
229514	2134	10750315000	30296	14893	6	0	\N
229520	100	66769680000000	30298	14894	0	0	\N
229521	1397	1254991634000	30298	14894	1	0	\N
229522	2132	6444459000	30298	14894	2	0	\N
229523	2132	6443458000	30298	14894	3	0	\N
229524	2132	6442457000	30298	14894	4	0	\N
229525	100	66769680000000	30299	14894	0	0	\N
229526	100	66769670000000	30299	14894	1	0	\N
229527	100	66769660000000	30299	14894	2	0	\N
229528	1397	1254991634000	30299	14894	3	0	\N
229529	2132	6444459000	30299	14894	4	0	\N
229530	2132	6443458000	30299	14894	5	0	\N
229531	2132	6442457000	30299	14894	6	0	\N
229532	2134	10749311000	30299	14894	7	0	\N
229533	2134	10748307000	30299	14894	8	0	\N
229534	2134	10747303000	30299	14894	9	0	\N
229535	100	66769680000000	30300	14894	0	0	\N
229536	100	66769670000000	30300	14894	1	0	\N
229537	100	66769660000000	30300	14894	2	0	\N
229538	1397	1254991634000	30300	14894	3	0	\N
229539	2132	6444459000	30300	14894	4	0	\N
229540	2132	6443458000	30300	14894	5	0	\N
229541	2132	6442457000	30300	14894	6	0	\N
229542	2134	10749311000	30300	14894	7	0	\N
229543	2134	10748307000	30300	14894	8	0	\N
229544	2134	10747303000	30300	14894	9	0	\N
229562	1397	1254981633000	30303	14895	0	0	\N
229563	2132	6441456000	30303	14895	1	0	\N
229564	2132	6440455000	30303	14895	2	0	\N
229565	1397	1254971632000	30304	14896	0	0	\N
229566	1397	1254961631000	30304	14896	1	0	\N
229567	2133	7895948000	30304	14896	2	0	\N
229568	2133	7894946000	30304	14896	3	0	\N
229483	2134	10761359000	30293	14892	2	0	9549
229484	2132	6447462000	30293	14892	3	0	2540
229485	2134	10760355000	30293	14892	4	0	9550
229486	2132	6446461000	30293	14892	5	0	2541
229487	2132	6445460000	30293	14892	6	0	2542
229489	2134	10758347000	30293	14892	8	0	9552
229490	2134	10757343000	30293	14892	9	0	9553
229491	2134	10756339000	30293	14892	10	0	9554
229492	2134	10755335000	30293	14892	11	0	9555
229493	2134	10754331000	30293	14892	12	0	9556
229516	2134	10753327000	30297	14893	1	0	9557
229517	2134	10752323000	30297	14893	2	0	9558
229518	2134	10751319000	30297	14893	3	0	9559
229519	2134	10750315000	30297	14893	4	0	9560
229546	100	66769670000000	30301	14894	1	0	2
229547	100	66769660000000	30301	14894	2	0	3
229548	1397	1254991634000	30301	14894	3	0	18383
229549	2132	6444459000	30301	14894	4	0	2543
229550	2132	6443458000	30301	14894	5	0	2544
229552	2134	10749311000	30301	14894	7	0	9561
229553	2134	10748307000	30301	14894	8	0	9562
229554	2134	10747303000	30301	14894	9	0	9563
229555	1397	1254981633000	30302	14895	0	0	18384
229556	2132	6441456000	30302	14895	1	0	2546
229558	2132	6440455000	30302	14895	3	0	2547
229559	2134	10745295000	30302	14895	4	0	9565
229560	2134	10744291000	30302	14895	5	0	9566
229561	2134	10743287000	30302	14895	6	0	9567
229569	2134	10742283000	30304	14896	4	0	\N
229570	1541	2313000000	30304	14896	5	0	\N
229571	2134	10741279000	30304	14896	6	0	\N
229579	1397	1254981633000	30306	14895	0	0	\N
229580	1397	1254971632000	30306	14895	1	0	\N
229581	1397	1254961631000	30306	14895	2	0	\N
229582	2133	7895948000	30306	14895	3	0	\N
229583	2133	7894946000	30306	14895	4	0	\N
229584	2132	6441456000	30306	14895	5	0	\N
229585	1541	2313000000	30306	14895	6	0	\N
229586	2132	6440455000	30306	14895	7	0	\N
229587	1397	1254951630000	30307	14897	0	0	\N
229588	2134	10740275000	30307	14897	1	0	\N
229589	1397	1254951630000	30308	14897	0	0	\N
229590	2134	10740275000	30308	14897	1	0	\N
229591	1397	1254951630000	30309	14897	0	0	\N
229592	2134	10740275000	30309	14897	1	0	\N
229595	1397	1254951630000	30311	14897	0	0	\N
229596	1397	1254951630000	30312	14897	0	0	\N
229602	1397	1254941629000	30314	14898	0	0	\N
229603	2440	531988750000	30314	14898	1	0	\N
229604	2132	6439454000	30314	14898	2	0	\N
229605	2134	10739271000	30314	14898	3	0	\N
229606	2133	7893944000	30314	14898	4	0	\N
229607	1397	1254941629000	30315	14898	0	0	\N
229608	2440	531988750000	30315	14898	1	0	\N
229609	2132	6439454000	30315	14898	2	0	\N
229610	2134	10739271000	30315	14898	3	0	\N
229611	2133	7893944000	30315	14898	4	0	\N
229614	1397	1254921627000	30317	14900	0	0	\N
229615	2134	10737263000	30317	14900	1	0	\N
229616	2133	7892942000	30317	14900	3	0	\N
229617	1397	1254921627000	30318	14900	0	0	\N
229618	2134	10737263000	30318	14900	1	0	\N
229619	2133	7892942000	30318	14900	3	0	\N
229622	1678	1000	23	13	0	0	\N
229627	1678	4000	26	15	0	0	\N
229628	1678	5000	26	15	1	0	\N
229630	1678	7000	28	17	0	0	\N
229631	1678	8000	28	17	1	0	\N
229634	1678	9000	30	18	0	0	\N
229637	1678	11000	33	20	0	0	\N
229648	1678	20000	40	25	0	0	\N
229650	1678	21000	42	26	0	0	\N
229651	1678	21000	43	26	0	0	\N
229653	1678	22000	45	27	0	0	\N
229654	1678	22000	46	27	0	0	\N
229655	1678	22000	47	27	0	0	\N
229657	1678	23000	49	28	0	0	\N
229658	1678	23000	50	28	0	0	\N
229661	1678	25000	53	30	0	0	\N
229662	1678	26000	54	31	0	0	\N
229663	1678	27000	54	31	1	0	\N
229667	1678	29000	57	33	0	0	\N
229670	1678	31000	60	35	0	0	\N
229671	1678	31000	61	35	0	0	\N
229674	1678	32000	64	36	0	0	\N
229675	1678	32000	65	36	0	0	\N
229679	1678	34000	68	38	0	0	\N
229680	1678	35000	68	38	1	0	\N
229683	1678	38000	71	41	0	0	\N
229692	1678	44000	78	46	0	0	\N
229693	1678	45000	78	46	1	0	\N
229700	1678	52000	84	52	0	0	\N
229701	1678	53000	84	52	1	0	\N
229702	1678	54000	84	52	2	0	\N
229623	1678	2000	24	14	1	0	0
229624	1678	3000	24	14	2	0	0
229625	1678	4000	25	15	0	0	0
229626	1678	5000	25	15	1	0	0
229629	1678	6000	27	16	0	0	0
229633	1678	8000	29	17	1	0	0
229635	1678	9000	31	18	0	0	0
229636	1678	10000	32	19	0	0	0
229638	1678	11000	34	20	0	0	0
229639	1678	12000	35	21	0	0	0
229641	1678	14000	37	23	0	0	0
229642	1678	15000	37	23	1	0	0
229643	1678	16000	37	23	2	0	0
229644	1678	17000	38	24	0	0	0
229646	1678	19000	38	24	2	0	0
229647	1678	20000	39	25	0	0	0
229649	1678	21000	41	26	0	0	0
229652	1678	22000	44	27	0	0	0
229656	1678	23000	48	28	0	0	0
229660	1678	25000	52	30	0	0	0
229664	1678	26000	55	31	0	0	0
229665	1678	27000	55	31	1	0	0
229666	1678	28000	56	32	0	0	0
229668	1678	29000	58	33	0	0	0
229672	1678	31000	62	35	0	0	0
229673	1678	32000	63	36	0	0	0
229676	1678	33000	66	37	0	0	0
229677	1678	34000	67	38	0	0	0
229681	1678	36000	69	39	0	0	0
229682	1678	37000	70	40	0	0	0
229684	1678	38000	72	41	0	0	0
229685	1678	39000	73	42	0	0	0
229686	1678	40000	74	43	0	0	0
229688	1678	42000	76	45	0	0	0
229689	1678	43000	76	45	1	0	0
229690	1678	44000	77	46	0	0	0
229691	1678	45000	77	46	1	0	0
229694	1678	46000	79	47	0	0	0
229696	1678	48000	81	49	0	0	0
229697	1678	49000	81	49	1	0	0
229698	1678	50000	82	50	0	0	0
229699	1678	51000	83	51	0	0	0
229704	1678	53000	85	52	1	0	0
229572	1397	1254971632000	30305	14896	0	0	18385
229573	1397	1254961631000	30305	14896	1	0	18386
229574	2133	7895948000	30305	14896	2	0	8529
229575	2133	7894946000	30305	14896	3	0	8530
229577	1541	2313000000	30305	14896	5	0	5
229578	2134	10741279000	30305	14896	6	0	9569
229593	1397	1254951630000	30310	14897	0	0	18387
229594	2134	10740275000	30310	14897	1	0	9570
229597	1397	1254941629000	30313	14898	0	0	18388
229599	2132	6439454000	30313	14898	2	0	2548
229600	2134	10739271000	30313	14898	3	0	9571
229601	2133	7893944000	30313	14898	4	0	8531
229612	1397	1254931628000	30316	14899	0	0	18389
229714	1697	0	91	57	0	0	\N
229715	1678	61000	91	57	1	0	\N
229716	1697	0	92	57	0	0	\N
229717	1678	61000	92	57	1	0	\N
229722	1678	66000	95	60	0	0	\N
229724	1678	66000	97	60	0	0	\N
229725	1678	66000	98	60	0	0	\N
229730	1678	68000	101	62	0	0	\N
229731	1678	69000	101	62	1	0	\N
229732	1678	70000	101	62	2	0	\N
229733	1678	71000	102	63	0	0	\N
229734	1678	72000	102	63	1	0	\N
229735	1697	1000000000	102	63	2	0	\N
229736	1678	71000	103	63	0	0	\N
229737	1678	72000	103	63	1	0	\N
229738	1697	1000000000	103	63	2	0	\N
229745	1678	76000	107	66	0	0	\N
229746	1678	77000	107	66	1	0	\N
229747	1678	76000	108	66	0	0	\N
229748	1678	77000	108	66	1	0	\N
229751	1678	78000	110	67	0	0	\N
229754	1678	79000	113	68	0	0	\N
229755	1678	79000	114	68	0	0	\N
229756	1678	79000	115	68	0	0	\N
229762	1678	84000	118	70	0	0	\N
229764	1678	85000	120	71	0	0	\N
229765	1678	86000	121	72	0	0	\N
229767	1678	86000	123	72	0	0	\N
229768	1678	87000	124	73	0	0	\N
229769	1678	88000	124	73	1	0	\N
229770	1678	89000	124	73	2	0	\N
229771	1678	87000	125	73	0	0	\N
229772	1678	88000	125	73	1	0	\N
229773	1678	89000	125	73	2	0	\N
229783	1678	94000	130	76	0	0	\N
229784	1678	95000	130	76	1	0	\N
229789	1678	100000	134	80	0	0	\N
229790	1678	101000	134	80	1	0	\N
229794	1678	102000	137	81	0	0	\N
229795	1678	102000	138	81	0	0	\N
229796	1678	103000	139	82	0	0	\N
229797	1678	104000	139	82	1	0	\N
229801	1678	106000	142	84	0	0	\N
229805	1678	109000	146	87	0	0	\N
229808	1678	111000	149	89	0	0	\N
229809	1678	112000	149	89	1	0	\N
229812	1678	111000	151	89	0	0	\N
229813	1678	112000	151	89	1	0	\N
229816	1678	114000	154	91	0	0	\N
229820	1678	118000	157	94	0	0	\N
229821	1678	119000	157	94	1	0	\N
229822	1678	120000	157	94	2	0	\N
229823	1678	121000	157	94	3	0	\N
229831	1678	125000	160	96	0	0	\N
229832	1678	126000	160	96	1	0	\N
229835	1678	125000	162	96	0	0	\N
229836	1678	126000	162	96	1	0	\N
229707	1678	56000	86	53	1	0	0
229708	1678	57000	87	54	0	0	0
229709	1678	58000	88	55	0	0	0
229710	1678	59000	89	56	0	0	0
229711	1678	60000	89	56	1	0	0
229713	1678	61000	90	57	1	0	0
229718	1678	62000	93	58	0	0	0
229719	1678	63000	94	59	0	0	0
229720	1678	64000	94	59	1	0	0
229721	1678	65000	94	59	2	0	0
229726	1678	67000	99	61	0	0	0
229727	1678	68000	100	62	0	0	0
229728	1678	69000	100	62	1	0	0
229729	1678	70000	100	62	2	0	0
229740	1678	72000	104	63	1	0	0
229741	1697	1000000000	104	63	2	0	0
229742	1678	73000	105	64	0	0	0
229743	1678	74000	106	65	0	0	0
229744	1678	75000	106	65	1	0	0
229750	1678	77000	109	66	1	0	0
229752	1678	78000	111	67	0	0	0
229753	1678	79000	112	68	0	0	0
229757	1678	80000	116	69	0	0	0
229758	1678	81000	116	69	1	0	0
229760	1678	83000	116	69	3	0	0
229761	1678	84000	117	70	0	0	0
229763	1678	85000	119	71	0	0	0
229766	1678	86000	122	72	0	0	0
229775	1678	88000	126	73	1	0	0
229776	1678	89000	126	73	2	0	0
229777	1678	90000	127	74	0	0	0
229778	1678	91000	127	74	1	0	0
229779	1678	92000	127	74	2	0	0
229781	1678	94000	129	76	0	0	0
229782	1678	95000	129	76	1	0	0
229785	1678	96000	131	77	0	0	0
229786	1678	97000	131	77	1	0	0
229787	1678	98000	132	78	0	0	0
229791	1678	100000	135	80	0	0	0
229792	1678	101000	135	80	1	0	0
229793	1678	102000	136	81	0	0	0
229798	1678	103000	140	82	0	0	0
229800	1678	105000	141	83	0	0	0
229802	1678	106000	143	84	0	0	0
229803	1678	107000	144	85	0	0	0
229804	1678	108000	145	86	0	0	0
229806	1678	109000	147	87	0	0	0
229810	1678	111000	150	89	0	0	0
229811	1678	112000	150	89	1	0	0
229814	1678	113000	152	90	0	0	0
229815	1678	114000	153	91	0	0	0
229817	1678	115000	155	92	0	0	0
229819	1678	117000	156	93	1	0	0
229824	1678	118000	158	94	0	0	0
229825	1678	119000	158	94	1	0	0
229826	1678	120000	158	94	2	0	0
229828	1678	122000	159	95	0	0	0
229829	1678	123000	159	95	1	0	0
229830	1678	124000	159	95	2	0	0
229833	1678	125000	161	96	0	0	0
229834	1678	126000	161	96	1	0	0
229838	1678	128000	163	97	1	0	0
229839	1678	129000	164	98	0	0	0
229840	1678	130000	165	99	0	0	0
229848	1707	1000000000	168	101	0	0	\N
229849	1678	134000	168	101	1	0	\N
229850	1678	135000	168	101	2	0	\N
229851	1678	136000	168	101	3	0	\N
229852	1707	1000000000	169	101	0	0	\N
229853	1678	134000	169	101	1	0	\N
229854	1678	135000	169	101	2	0	\N
229855	1678	136000	169	101	3	0	\N
229857	1678	137000	171	102	0	0	\N
229860	1678	138000	173	103	0	0	\N
229861	1678	139000	173	103	1	0	\N
229862	1678	140000	174	104	0	0	\N
229863	1678	140000	175	104	0	0	\N
229865	1678	141000	177	105	0	0	\N
229869	1678	144000	181	108	0	0	\N
229874	1678	148000	185	111	0	0	\N
229875	1678	149000	185	111	2	0	\N
229876	1678	150000	185	111	3	0	\N
229880	1678	151000	187	112	0	0	\N
229881	1678	152000	187	112	1	0	\N
229884	1678	153000	189	113	0	0	\N
229886	1678	153000	191	113	0	0	\N
229888	1678	154000	194	115	0	0	\N
229889	1678	154000	195	115	0	0	\N
229892	1678	156000	198	117	0	0	\N
229893	1678	156000	199	117	0	0	\N
229894	1678	157000	200	118	0	0	\N
229898	1678	160000	203	120	0	0	\N
229901	1678	161000	206	121	0	0	\N
229902	1678	161000	207	121	0	0	\N
229904	1678	162000	209	122	0	0	\N
229907	1678	163000	211	123	0	0	\N
229908	1678	164000	211	123	1	0	\N
229909	1678	165000	212	124	0	0	\N
229918	1678	173000	219	130	0	0	\N
229921	1678	174000	222	131	0	0	\N
229923	1678	175000	224	132	0	0	\N
229925	1678	177000	226	134	0	0	\N
229927	1651	0	228	135	0	0	\N
229928	1678	178000	228	135	1	0	\N
229933	1678	180000	231	137	0	0	\N
229936	1678	181000	234	138	0	0	\N
229943	1678	186000	238	141	0	0	\N
229944	1678	187000	238	141	1	0	\N
229945	1678	186000	239	141	0	0	\N
229946	1678	187000	239	141	1	0	\N
229947	1678	188000	240	142	0	0	\N
229949	1678	189000	242	143	0	0	\N
229951	1678	190000	244	144	0	0	\N
229953	1678	191000	246	145	1	0	\N
229954	1678	192000	246	145	2	0	\N
229955	1678	193000	246	145	3	0	\N
229959	1678	194000	248	146	0	0	\N
229960	1678	195000	248	146	1	0	\N
229973	1678	205000	258	152	0	0	\N
229975	1678	205000	260	152	0	0	\N
229976	1678	205000	261	152	0	0	\N
229843	1678	133000	166	100	0	0	0
229844	1707	1000000000	167	101	0	0	0
229845	1678	134000	167	101	1	0	0
229846	1678	135000	167	101	2	0	0
229847	1678	136000	167	101	3	0	0
229858	1678	138000	172	103	0	0	0
229859	1678	139000	172	103	1	0	0
229864	1678	140000	176	104	0	0	0
229866	1678	141000	178	105	0	0	0
229867	1678	142000	179	106	0	0	0
229870	1678	144000	182	108	0	0	0
229871	1678	145000	183	109	0	0	0
229872	1678	146000	184	110	0	0	0
229873	1678	147000	184	110	1	0	0
229878	1678	149000	186	111	2	0	0
229879	1678	150000	186	111	3	0	0
229882	1678	151000	188	112	0	0	0
229883	1678	152000	188	112	1	0	0
229885	1678	153000	190	113	0	0	0
229890	1678	155000	196	116	0	0	0
229891	1678	156000	197	117	0	0	0
229895	1678	157000	201	118	0	0	0
229896	1678	158000	202	119	0	0	0
229897	1678	159000	202	119	1	0	0
229900	1678	161000	205	121	0	0	0
229903	1678	162000	208	122	0	0	0
229905	1678	163000	210	123	0	0	0
229906	1678	164000	210	123	1	0	0
229911	1678	166000	214	125	0	0	0
229912	1678	167000	215	126	0	0	0
229913	1678	168000	215	126	1	0	0
229914	1678	169000	216	127	1	0	0
229915	1678	170000	216	127	2	0	0
229917	1678	172000	218	129	0	0	0
229919	1678	173000	220	130	0	0	0
229920	1678	174000	221	131	0	0	0
229922	1678	175000	223	132	0	0	0
229924	1678	176000	225	133	0	0	0
229929	1651	0	229	135	0	0	0
229930	1678	178000	229	135	1	0	0
229931	1678	179000	230	136	0	0	0
229932	1712	7990000000	230	136	1	0	0
229935	1678	181000	233	138	0	0	0
229937	1678	182000	235	139	0	0	0
229938	1678	183000	235	139	1	0	0
229939	1678	184000	236	140	0	0	0
229940	1678	185000	236	140	1	0	0
229942	1678	187000	237	141	1	0	0
229948	1678	188000	241	142	0	0	0
229950	1678	189000	243	143	0	0	0
229952	1678	190000	245	144	0	0	0
229956	1678	191000	247	145	1	0	0
229958	1678	193000	247	145	3	0	0
229961	1678	194000	249	146	0	0	0
229962	1678	195000	249	146	1	0	0
229963	1678	196000	250	147	0	0	0
229965	1678	198000	250	147	2	0	0
229966	1617	0	255	149	0	0	0
229967	1678	199000	255	149	1	0	0
229968	1678	200000	255	149	2	0	0
229969	1678	201000	255	149	3	0	0
229971	1678	203000	256	150	0	0	0
229972	1678	204000	257	151	0	0	0
229974	1678	205000	259	152	0	0	0
229977	1678	206000	262	153	0	0	\N
229978	1678	206000	263	153	0	0	\N
229985	1678	209000	267	155	0	0	\N
229986	1678	210000	267	155	1	0	\N
229987	56	66000100000000	267	155	2	0	\N
229988	1678	211000	268	156	0	0	\N
229992	1678	213000	272	158	0	0	\N
229993	1678	214000	273	159	0	0	\N
229995	1678	214000	275	159	0	0	\N
229996	1678	215000	276	160	0	0	\N
229998	1678	216000	278	161	0	0	\N
230002	1678	218000	283	163	0	0	\N
230003	1678	219000	284	164	0	0	\N
230004	1678	219000	285	164	0	0	\N
230006	1678	219000	287	164	0	0	\N
230008	1678	220000	289	165	0	0	\N
230013	1678	224000	293	168	0	0	\N
230020	1678	228000	297	171	0	0	\N
230021	1678	229000	297	171	1	0	\N
230022	1678	230000	297	171	2	0	\N
230023	1678	228000	298	171	0	0	\N
230024	1678	229000	298	171	1	0	\N
230025	1678	230000	298	171	2	0	\N
230027	1678	232000	300	173	0	0	\N
230029	1678	232000	302	173	0	0	\N
230040	1678	239000	306	176	0	0	\N
230041	1697	202000000000	306	176	1	0	\N
230042	1678	239000	307	176	0	0	\N
230043	1697	202000000000	307	176	1	0	\N
230046	1678	242000	310	179	0	0	\N
230052	1678	244000	314	181	0	0	\N
230053	1678	245000	314	181	1	0	\N
230054	1678	244000	315	181	0	0	\N
230055	1678	245000	315	181	1	0	\N
230057	1678	247000	317	183	0	0	\N
230058	1697	302000000000	317	183	1	0	\N
230061	1678	247000	319	183	0	0	\N
230062	1697	302000000000	319	183	1	0	\N
230064	1678	248000	321	184	0	0	\N
230068	1678	252000	324	187	0	0	\N
230069	1678	253000	324	187	1	0	\N
230072	1678	252000	326	187	0	0	\N
230073	1678	253000	326	187	1	0	\N
230077	1678	256000	329	189	0	0	\N
230080	1678	258000	332	191	0	0	\N
230081	1678	258000	333	191	0	0	\N
230082	1678	259000	334	192	0	0	\N
230084	1678	260000	336	193	0	0	\N
230085	1678	261000	336	193	1	0	\N
230086	1678	260000	337	193	0	0	\N
230087	1678	261000	337	193	1	0	\N
230091	1678	262000	340	194	0	0	\N
230092	1678	263000	341	195	0	0	\N
230093	1678	264000	341	195	1	0	\N
230097	1678	266000	344	197	0	0	\N
230098	1678	267000	344	197	1	0	\N
230099	1697	402000000000	344	197	2	0	\N
230103	1678	266000	346	197	0	0	\N
230104	1678	267000	346	197	1	0	\N
230105	1697	402000000000	346	197	2	0	\N
230111	1678	271000	350	201	0	0	\N
229981	1678	208000	265	154	2	0	0
229982	1678	209000	266	155	0	0	0
229983	1678	210000	266	155	1	0	0
229984	56	66000100000000	266	155	2	0	0
229989	1678	211000	269	156	0	0	0
229991	1678	213000	271	158	0	0	0
229994	1678	214000	274	159	0	0	0
229997	1678	215000	277	160	0	0	0
229999	1678	216000	279	161	0	0	0
230000	1678	217000	281	162	0	0	0
230005	1678	219000	286	164	0	0	0
230007	1678	220000	288	165	0	0	0
230009	1678	221000	290	166	0	0	0
230010	1678	222000	290	166	1	0	0
230012	1678	224000	292	168	0	0	0
230014	1678	225000	294	169	0	0	0
230015	1678	226000	295	170	0	0	0
230016	1678	227000	295	170	1	0	0
230017	1678	228000	296	171	0	0	0
230019	1678	230000	296	171	2	0	0
230026	1678	231000	299	172	0	0	0
230028	1678	232000	301	173	0	0	0
230030	1697	2000000000	303	174	0	0	0
230031	1678	233000	303	174	1	0	0
230033	1678	235000	304	175	0	0	0
230034	1697	102000000000	304	175	1	0	0
230035	1678	236000	304	175	2	0	0
230036	1678	237000	304	175	3	0	0
230038	1678	239000	305	176	0	0	0
230039	1697	202000000000	305	176	1	0	0
230044	1678	240000	308	177	0	0	0
230045	1678	241000	309	178	0	0	0
230047	1678	242000	311	179	0	0	0
230049	1678	243000	312	180	1	0	0
230050	1678	244000	313	181	0	0	0
230051	1678	245000	313	181	1	0	0
230056	1678	246000	316	182	0	0	0
230059	1678	247000	318	183	0	0	0
230063	1678	248000	320	184	0	0	0
230065	1678	249000	322	185	0	0	0
230066	1678	250000	322	185	1	0	0
230067	1678	251000	323	186	0	0	0
230071	1678	253000	325	187	1	0	0
230074	1678	254000	327	188	0	0	0
230075	1678	255000	327	188	1	0	0
230076	1678	256000	328	189	0	0	0
230078	1678	257000	330	190	0	0	0
230083	1678	259000	335	192	0	0	0
230088	1678	260000	338	193	0	0	0
230089	1678	261000	338	193	1	0	0
230090	1678	262000	339	194	0	0	0
230094	1678	263000	342	195	0	0	0
230096	1678	265000	343	196	0	0	0
230100	1678	266000	345	197	0	0	0
230101	1678	267000	345	197	1	0	0
230102	1697	402000000000	345	197	2	0	0
230107	1678	269000	348	199	0	0	0
230108	1678	270000	349	200	0	0	0
230109	1720	0	349	200	1	0	0
230110	1721	0	349	200	2	0	0
230112	1678	271000	351	201	0	0	0
230113	1678	271000	353	201	0	0	\N
230114	1503	0	354	202	0	0	\N
230115	1678	272000	354	202	1	0	\N
230116	1678	273000	354	202	2	0	\N
230120	622	66002000000000	356	203	0	0	\N
230121	1678	274000	356	203	1	0	\N
230122	1678	275000	356	203	2	0	\N
230132	1678	279000	360	205	0	0	\N
230133	1678	280000	360	205	1	0	\N
230137	622	66002980000000	363	207	0	0	\N
230138	1678	283000	364	208	0	0	\N
230140	1678	284000	366	209	0	0	\N
230141	1678	285000	366	209	1	0	\N
230144	1678	284000	368	209	0	0	\N
230145	1678	285000	368	209	1	0	\N
230146	1678	286000	369	210	0	0	\N
230147	1678	287000	369	210	1	0	\N
230153	1678	290000	373	213	0	0	\N
230154	1678	290000	374	213	0	0	\N
230155	1678	290000	375	213	0	0	\N
230157	1678	290000	377	213	0	0	\N
230166	1678	296000	383	218	0	0	\N
230167	1678	296000	384	218	0	0	\N
230174	1678	300000	387	221	0	0	\N
230175	1652	490000000	387	221	1	0	\N
230178	1678	300000	389	221	0	0	\N
230179	1652	490000000	389	221	1	0	\N
230181	1678	302000	391	223	0	0	\N
230185	1678	304000	395	225	0	0	\N
230188	1678	305000	397	226	0	0	\N
230189	1678	306000	397	226	1	0	\N
230190	1678	305000	398	226	0	0	\N
230191	1678	306000	398	226	1	0	\N
230192	1678	307000	399	227	0	0	\N
230193	1678	308000	399	227	1	0	\N
230194	1678	309000	399	227	2	0	\N
230195	1678	307000	400	227	0	0	\N
230196	1678	308000	400	227	1	0	\N
230197	1678	309000	400	227	2	0	\N
230205	1678	314000	404	230	0	0	\N
230206	1652	490000000	404	230	1	0	\N
230207	1678	314000	405	230	0	0	\N
230208	1652	490000000	405	230	1	0	\N
230213	1678	317000	409	233	0	0	\N
230216	1678	318000	412	234	0	0	\N
230220	1678	322000	415	237	0	0	\N
230221	1678	323000	415	237	1	0	\N
230226	1725	100000000	418	239	0	0	\N
230227	1726	100000000	418	239	1	0	\N
230228	1678	326000	418	239	2	0	\N
230235	578	66000100000000	421	240	0	0	\N
230236	394	66000100000000	421	240	1	0	\N
230237	1678	327000	421	240	2	0	\N
230238	1678	328000	422	241	0	0	\N
230241	1678	329000	425	242	0	0	\N
230242	1678	329000	426	242	0	0	\N
230244	1678	331000	428	244	0	0	\N
230247	1678	332000	431	245	0	0	\N
230248	1678	332000	432	245	0	0	\N
230119	1678	273000	355	202	2	0	0
230123	622	66002000000000	357	203	0	0	0
230124	1678	274000	357	203	1	0	0
230125	1678	275000	357	203	2	0	0
230126	1503	0	358	204	0	0	0
230128	1678	277000	358	204	2	0	0
230129	1678	278000	358	204	3	0	0
230130	1678	279000	359	205	0	0	0
230131	1678	280000	359	205	1	0	0
230134	1678	281000	361	206	0	0	0
230136	1678	282000	362	207	1	0	0
230139	1678	283000	365	208	0	0	0
230142	1678	284000	367	209	0	0	0
230143	1678	285000	367	209	1	0	0
230149	1678	287000	370	210	1	0	0
230150	1507	0	371	211	0	0	0
230151	1678	288000	371	211	1	0	0
230152	1678	289000	372	212	0	0	0
230156	1678	290000	376	213	0	0	0
230159	1678	292000	379	215	0	0	0
230160	1678	293000	379	215	1	0	0
230161	1722	0	379	215	2	0	0
230162	443	66000500000000	379	215	3	0	0
230163	1678	294000	380	216	0	0	0
230165	1678	296000	382	218	0	0	0
230168	1678	297000	385	219	0	0	0
230169	1678	298000	385	219	2	0	0
230170	1722	718000000000	385	219	3	0	0
230172	1722	2154000000000	385	219	5	0	0
230173	1678	299000	386	220	0	0	0
230176	1678	300000	388	221	0	0	0
230177	1652	490000000	388	221	1	0	3
230180	1678	301000	390	222	0	0	0
230183	1678	303000	393	224	0	0	0
230184	1678	304000	394	225	0	0	0
230186	1678	305000	396	226	0	0	0
230187	1678	306000	396	226	1	0	0
230198	1678	307000	401	227	0	0	0
230200	1678	309000	401	227	2	0	0
230201	1678	310000	402	228	0	0	0
230202	1678	311000	402	228	1	0	0
230203	1678	312000	403	229	0	0	0
230209	1678	314000	406	230	0	0	0
230210	1652	490000000	406	230	1	0	3
230211	1678	315000	407	231	0	0	0
230212	1678	316000	408	232	0	0	0
230214	1678	317000	410	233	0	0	0
230217	1678	319000	413	235	0	0	0
230218	1678	320000	413	235	1	0	0
230219	1678	321000	414	236	0	0	0
230222	1678	322000	416	237	0	0	0
230223	1678	323000	416	237	1	0	0
230225	1678	325000	417	238	1	0	0
230229	1725	100000000	419	239	0	0	0
230230	1726	100000000	419	239	1	0	0
230231	1678	326000	419	239	2	0	0
230233	394	66000100000000	420	240	1	0	0
230234	1678	327000	420	240	2	0	0
230239	1678	328000	423	241	0	0	0
230240	1678	329000	424	242	0	0	0
230243	1678	330000	427	243	0	0	0
230246	1678	332000	430	245	0	0	0
230251	379	66000100000000	434	246	0	0	\N
230252	1678	333000	434	246	1	0	\N
230253	1678	334000	435	247	0	0	\N
230255	1678	335000	437	248	0	0	\N
230257	1678	335000	439	248	0	0	\N
230258	1678	336000	440	249	0	0	\N
230259	1678	337000	440	249	1	0	\N
230260	281	66000300000000	440	249	2	0	\N
230261	1678	336000	441	249	0	0	\N
230262	1678	337000	441	249	1	0	\N
230263	281	66000300000000	441	249	2	0	\N
230264	1678	336000	442	249	0	0	\N
230265	1678	337000	442	249	1	0	\N
230266	281	66000300000000	442	249	2	0	\N
230270	1678	336000	444	249	0	0	\N
230271	1678	337000	444	249	1	0	\N
230272	281	66000300000000	444	249	2	0	\N
230273	1678	336000	445	249	0	0	\N
230274	1678	337000	445	249	1	0	\N
230275	281	66000300000000	445	249	2	0	\N
230283	1678	344000	451	255	0	0	\N
230284	1678	344000	452	255	0	0	\N
230288	1678	345000	455	256	0	0	\N
230289	1678	346000	455	256	1	0	\N
230290	1678	347000	456	257	0	0	\N
230292	1678	347000	458	257	0	0	\N
230293	1678	347000	459	257	0	0	\N
230295	1678	348000	461	258	0	0	\N
230297	1678	350000	463	260	0	0	\N
230300	1678	352000	466	262	0	0	\N
230302	1678	352000	468	262	0	0	\N
230307	1678	353000	470	263	0	0	\N
230308	1678	354000	470	263	1	0	\N
230309	1678	355000	470	263	2	0	\N
230310	1678	356000	470	263	3	0	\N
230311	1678	357000	471	264	0	0	\N
230313	1678	358000	473	265	0	0	\N
230314	1678	359000	473	265	1	0	\N
230315	1678	360000	473	265	2	0	\N
230316	1678	358000	474	265	0	0	\N
230317	1678	359000	474	265	1	0	\N
230318	1678	360000	474	265	2	0	\N
230322	1678	358000	476	265	0	0	\N
230323	1678	359000	476	265	1	0	\N
230324	1678	360000	476	265	2	0	\N
230329	1728	0	479	267	0	0	\N
230330	1678	362000	479	267	1	0	\N
230334	1678	365000	483	270	0	0	\N
230335	1678	366000	484	271	0	0	\N
230336	1678	366000	485	271	0	0	\N
230337	1678	366000	486	271	0	0	\N
230338	1678	366000	487	271	0	0	\N
230340	1678	367000	489	272	0	0	\N
230341	1678	368000	489	272	1	0	\N
230342	1678	369000	489	272	2	0	\N
230347	1678	370000	492	273	0	0	\N
230349	1678	371000	494	274	0	0	\N
230359	1678	380000	500	280	0	0	\N
230367	1678	385000	505	284	0	0	\N
230368	1678	386000	505	284	1	0	\N
230369	1678	387000	505	284	2	0	\N
230370	1678	385000	506	284	0	0	\N
230371	1678	386000	506	284	1	0	\N
230372	1678	387000	506	284	2	0	\N
230376	1678	388000	508	285	0	0	\N
230378	1678	389000	510	286	0	0	\N
230379	1678	389000	511	286	0	0	\N
230254	1678	334000	436	247	0	0	0
230256	1678	335000	438	248	0	0	0
230267	1678	336000	443	249	0	0	0
230268	1678	337000	443	249	1	0	0
230269	281	66000300000000	443	249	2	0	0
230277	1483	0	446	250	1	0	0
230278	1678	339000	447	251	0	0	0
230279	1678	340000	448	252	0	0	0
230280	1678	341000	449	253	0	0	0
230281	1678	342000	450	254	0	0	0
230285	1678	344000	453	255	0	0	0
230286	1678	345000	454	256	0	0	0
230287	1678	346000	454	256	1	0	0
230291	1678	347000	457	257	0	0	0
230296	1678	349000	462	259	0	0	0
230298	1678	350000	464	260	0	0	0
230299	1678	351000	465	261	0	0	0
230301	1678	352000	467	262	0	0	0
230303	1678	353000	469	263	0	0	0
230305	1678	355000	469	263	2	0	0
230306	1678	356000	469	263	3	0	0
230312	1678	357000	472	264	0	0	0
230319	1678	358000	475	265	0	0	0
230320	1678	359000	475	265	1	0	0
230325	1678	361000	477	266	0	0	0
230326	1527	0	477	266	1	0	0
230327	1728	0	478	267	0	0	0
230328	1678	362000	478	267	1	0	0
230332	1678	364000	481	269	0	0	0
230333	1678	365000	482	270	0	0	0
230339	1678	366000	488	271	0	0	0
230343	1678	367000	490	272	0	0	0
230344	1678	368000	490	272	1	0	0
230346	1678	370000	491	273	0	0	0
230348	1678	371000	493	274	0	0	0
230350	1678	372000	495	275	0	0	0
230351	1678	373000	495	275	1	0	0
230352	1678	374000	495	275	2	0	0
230354	1678	376000	497	277	0	0	0
230355	1678	377000	497	277	1	0	0
230356	1678	378000	498	278	0	0	0
230357	1730	100000000	498	278	1	0	0
230360	1678	380000	501	280	0	0	0
230361	1678	381000	502	281	0	0	0
230362	1678	382000	502	281	1	0	0
230363	1678	383000	503	282	0	0	0
230364	1731	100000000	503	282	1	0	0
230366	1678	384000	504	283	0	0	0
230373	1678	385000	507	284	0	0	0
230374	1678	386000	507	284	1	0	0
230375	1678	387000	507	284	2	0	0
230377	1678	388000	509	285	0	0	0
230381	1678	390000	513	287	0	0	0
230382	1678	391000	513	287	1	0	0
230383	1678	392000	513	287	2	0	0
230384	1678	393000	513	287	3	0	0
230386	1678	394000	515	288	0	0	\N
230390	1678	398000	518	291	0	0	\N
230391	1678	399000	518	291	1	0	\N
230399	885	63455161096354	521	292	0	0	\N
230400	886	63455161096354	521	292	1	0	\N
230401	1678	400000	521	292	2	0	\N
230402	1678	401000	521	292	3	0	\N
230403	1678	402000	521	292	4	0	\N
230411	1678	410000	526	297	0	0	\N
230412	1734	100000000	526	297	1	0	\N
230421	1678	416000	534	303	0	0	\N
230422	1678	417000	535	304	0	0	\N
230426	1678	418000	538	305	0	0	\N
230427	1726	100000000	538	305	1	0	\N
230428	1678	418000	539	305	0	0	\N
230429	1726	100000000	539	305	1	0	\N
230432	1678	420000	542	307	0	0	\N
230433	1678	420000	543	307	0	0	\N
230434	1678	421000	544	308	0	0	\N
230436	1678	422000	546	309	0	0	\N
230437	1678	423000	546	309	1	0	\N
230438	1678	424000	546	309	2	0	\N
230443	1678	426000	549	311	0	0	\N
230447	1678	428000	553	313	0	0	\N
230448	1678	428000	554	313	0	0	\N
230449	1678	428000	555	313	0	0	\N
230451	1678	429000	557	314	0	0	\N
230456	1678	432000	561	317	0	0	\N
230457	1678	433000	561	317	1	0	\N
230458	1678	432000	562	317	0	0	\N
230459	1678	433000	562	317	1	0	\N
230461	1678	435000	564	319	0	0	\N
230464	1678	436000	567	320	0	0	\N
230465	1678	437000	568	321	0	0	\N
230469	1678	440000	572	324	0	0	\N
230471	1678	440000	574	324	0	0	\N
230472	1678	440000	575	324	0	0	\N
230473	1678	441000	576	325	0	0	\N
230474	1678	442000	576	325	1	0	\N
230475	1678	443000	576	325	2	0	\N
230482	1678	445000	580	327	1	0	\N
230483	1678	446000	580	327	2	0	\N
230487	1678	449000	584	330	0	0	\N
230488	1678	449000	585	330	0	0	\N
230489	1678	450000	586	331	0	0	\N
230498	1678	455000	593	336	0	0	\N
230499	1678	455000	594	336	0	0	\N
230504	1678	459000	598	339	0	0	\N
230506	1678	461000	600	341	0	0	\N
230508	1678	461000	602	341	0	0	\N
230510	1678	462000	604	342	0	0	\N
230511	1678	462000	605	342	0	0	\N
230512	1678	463000	606	343	0	0	\N
230514	1678	463000	608	343	0	0	\N
230515	1678	464000	609	344	0	0	\N
230517	1678	465000	611	345	0	0	\N
230518	1678	465000	612	345	0	0	\N
230520	1678	466000	614	346	0	0	\N
230388	1678	396000	517	290	1	0	0
230389	1678	397000	517	290	2	0	0
230392	1678	398000	519	291	0	0	0
230393	1678	399000	519	291	1	0	0
230394	885	63455161096354	520	292	0	0	0
230396	1678	400000	520	292	2	0	0
230397	1678	401000	520	292	3	0	0
230398	1678	402000	520	292	4	0	0
230404	1678	403000	522	293	0	0	0
230405	1678	404000	522	293	1	0	0
230407	1678	406000	523	294	1	0	0
230408	1678	407000	523	294	2	0	0
230409	1678	408000	524	295	0	0	0
230410	1678	409000	525	296	0	0	0
230414	1734	100000000	527	297	1	0	0
230415	1678	411000	528	298	0	0	0
230416	1678	412000	529	299	0	0	0
230417	1678	413000	530	300	0	0	0
230418	1678	414000	531	301	0	0	0
230420	1678	416000	533	303	0	0	0
230423	1678	417000	536	304	0	0	0
230424	1678	418000	537	305	0	0	0
230425	1726	100000000	537	305	1	0	0
230430	1678	419000	540	306	0	0	0
230435	1678	421000	545	308	0	0	0
230439	1678	422000	547	309	0	0	0
230440	1678	423000	547	309	1	0	0
230441	1678	424000	547	309	2	0	0
230444	1678	426000	550	311	0	0	0
230445	1678	427000	551	312	0	0	0
230446	1678	428000	552	313	0	0	0
230450	1678	429000	556	314	0	0	0
230452	1678	430000	558	315	0	0	0
230454	1678	432000	560	317	0	0	0
230455	1678	433000	560	317	1	0	0
230460	1678	434000	563	318	0	0	0
230462	1678	435000	565	319	0	0	0
230463	1678	436000	566	320	0	0	0
230467	1678	438000	570	322	0	0	0
230468	1678	439000	571	323	0	0	0
230470	1678	440000	573	324	0	0	0
230476	1678	441000	577	325	0	0	0
230478	1678	443000	577	325	2	0	0
230479	1678	444000	578	326	0	0	0
230480	1678	445000	579	327	1	0	0
230481	1678	446000	579	327	2	0	0
230484	1678	447000	581	328	0	0	0
230486	1678	449000	583	330	0	0	0
230490	1678	450000	587	331	0	0	0
230491	1678	451000	588	332	0	0	0
230492	1678	452000	589	333	0	0	0
230493	1678	453000	590	334	0	0	0
230495	1737	0	591	335	1	0	0
230496	1678	454000	591	335	2	0	0
230497	1678	455000	592	336	0	0	0
230500	1678	456000	595	337	0	0	0
230502	1678	458000	596	338	1	0	0
230503	1678	459000	597	339	0	0	0
230505	1678	460000	599	340	0	0	0
230507	1678	461000	601	341	0	0	0
230509	1678	462000	603	342	0	0	0
230516	1678	464000	610	344	0	0	0
230519	1678	465000	613	345	0	0	0
230522	1678	466000	616	346	0	0	\N
230523	1678	467000	617	347	0	0	\N
230531	1678	472000	625	351	0	0	\N
230532	1678	473000	625	351	1	0	\N
230533	1678	472000	626	351	0	0	\N
230534	1678	473000	626	351	1	0	\N
230537	1678	476000	628	353	0	0	\N
230538	1678	476000	629	353	0	0	\N
230541	1678	477000	632	354	0	0	\N
230544	1678	479000	635	356	0	0	\N
230545	1678	479000	636	356	0	0	\N
230548	1678	482000	639	359	0	0	\N
230550	1678	483000	641	360	0	0	\N
230551	1678	483000	642	360	0	0	\N
230554	1678	485000	645	362	0	0	\N
230555	1678	486000	645	362	1	0	\N
230560	1678	489000	648	364	0	0	\N
230562	1678	489000	650	364	0	0	\N
230563	1477	0	651	365	0	0	\N
230564	1678	490000	651	365	1	0	\N
230565	1678	491000	651	365	3	0	\N
230566	1678	492000	651	365	4	0	\N
230567	1477	0	652	365	0	0	\N
230568	1678	490000	652	365	1	0	\N
230569	1678	491000	652	365	3	0	\N
230570	1678	492000	652	365	4	0	\N
230571	1477	0	653	365	0	0	\N
230572	1678	490000	653	365	1	0	\N
230573	1678	491000	653	365	3	0	\N
230574	1678	492000	653	365	4	0	\N
230581	1678	493000	656	366	0	0	\N
230582	1678	494000	656	366	1	0	\N
230583	1678	493000	657	366	0	0	\N
230584	1678	494000	657	366	1	0	\N
230586	1678	495000	659	367	0	0	\N
230587	1678	496000	660	368	0	0	\N
230588	1678	497000	660	368	1	0	\N
230589	1678	498000	660	368	2	0	\N
230590	1678	499000	660	368	3	0	\N
230591	1678	496000	661	368	0	0	\N
230592	1678	497000	661	368	1	0	\N
230593	1678	498000	661	368	2	0	\N
230594	1678	499000	661	368	3	0	\N
230599	1678	500000	663	369	0	0	\N
230602	1678	501000	666	370	0	0	\N
230604	1678	502000	668	371	0	0	\N
230613	1678	511000	671	374	0	0	\N
230616	1678	513000	674	376	0	0	\N
230624	1678	519000	678	378	0	0	\N
230625	532	66000000000000	679	379	0	0	\N
230626	1678	520000	679	379	1	0	\N
230632	1678	523000	683	382	0	0	\N
230635	1678	524000	686	383	0	0	\N
230636	1678	720010525000	687	384	0	0	\N
230637	1678	720010526000	687	384	1	0	\N
230640	1678	720010527000	689	385	0	0	\N
230642	1678	720010527000	691	385	0	0	\N
230643	1678	720010527000	692	385	0	0	\N
230646	1678	720010529000	695	387	0	0	\N
230647	1678	720010529000	696	387	0	0	\N
230648	1678	720010530000	697	388	0	0	\N
230649	1678	720010531000	697	388	1	0	\N
230655	1678	720010534000	701	390	0	0	\N
230656	1678	720010535000	702	391	0	0	\N
230525	1678	468000	619	348	0	0	0
230526	1678	469000	622	349	0	0	0
230527	1678	470000	622	349	1	0	0
230528	1678	471000	623	350	0	0	0
230529	1678	472000	624	351	0	0	0
230535	1678	474000	627	352	0	0	0
230536	1678	475000	627	352	1	0	0
230539	1678	476000	630	353	0	0	0
230540	1678	477000	631	354	0	0	0
230542	1678	478000	633	355	0	0	0
230546	1678	480000	637	357	0	0	0
230547	1678	481000	638	358	0	0	0
230549	1678	482000	640	359	0	0	0
230552	1678	483000	643	360	0	0	0
230556	1678	485000	646	362	0	0	0
230557	1678	486000	646	362	1	0	0
230558	1678	487000	647	363	0	0	0
230559	1678	488000	647	363	1	0	0
230561	1678	489000	649	364	0	0	0
230576	1678	490000	654	365	1	0	0
230577	1678	491000	654	365	3	0	0
230578	1678	492000	654	365	4	0	0
230579	1678	493000	655	366	0	0	0
230580	1678	494000	655	366	1	0	0
230595	1678	496000	662	368	0	0	0
230596	1678	497000	662	368	1	0	0
230597	1678	498000	662	368	2	0	0
230598	1678	499000	662	368	3	0	0
230601	1678	501000	665	370	0	0	0
230603	1678	502000	667	371	0	0	0
230605	1678	503000	669	372	0	0	0
230606	1678	504000	669	372	1	0	0
230607	1678	505000	670	373	0	0	0
230609	1678	507000	670	373	2	0	0
230610	1678	508000	670	373	3	0	0
230611	1678	509000	670	373	4	0	0
230612	1678	510000	670	373	5	0	0
230614	1678	511000	672	374	0	0	0
230617	1678	513000	675	376	0	0	0
230618	1678	514000	676	377	0	0	0
230619	1678	515000	676	377	1	0	0
230620	1678	516000	676	377	2	0	0
230622	1678	518000	676	377	4	0	0
230623	1678	519000	677	378	0	0	0
230627	532	66000000000000	680	379	0	0	0
230628	1678	520000	680	379	1	0	0
230629	532	66000000000000	681	380	0	0	0
230631	1678	522000	682	381	0	0	0
230633	1678	523000	684	382	0	0	0
230634	1678	524000	685	383	0	0	0
230638	1678	720010525000	688	384	0	0	0
230639	1678	720010526000	688	384	1	0	0
230644	1678	720010528000	693	386	0	0	0
230645	1678	720010529000	694	387	0	0	0
230650	1678	720010530000	698	388	0	0	0
230651	1678	720010531000	698	388	1	0	0
230653	1678	720010533000	699	389	1	0	0
230654	1678	720010534000	700	390	0	0	0
230657	1678	720010536000	702	391	1	0	\N
230658	1678	720010537000	702	391	2	0	\N
230671	1678	720010546000	710	397	0	0	\N
230672	1678	720010547000	711	398	0	0	\N
230673	532	66000000000000	712	332	0	0	\N
230674	532	66000000000000	712	332	1	0	\N
230675	1590	0	712	332	2	0	\N
230676	1737	0	712	332	3	0	\N
230677	1477	0	712	332	4	0	\N
230678	532	66000000000000	713	334	0	0	\N
230679	532	66000000000000	713	334	1	0	\N
230680	1477	0	713	334	2	0	\N
230689	1678	720010554000	720	402	1	0	\N
230693	1678	720010556000	723	404	0	0	\N
230697	1678	720010557000	725	405	1	0	\N
230698	1678	720010558000	725	405	2	0	\N
230699	1678	720010559000	725	405	3	0	\N
230701	1678	720010560000	727	406	0	0	\N
230707	1678	720010565000	732	410	0	0	\N
230708	1678	720010566000	733	411	0	0	\N
230713	1678	720010570000	737	414	0	0	\N
230714	1678	720010570000	738	414	0	0	\N
230715	1678	720010570000	739	414	0	0	\N
230723	1678	720010576000	745	418	0	0	\N
230724	1678	720010576000	746	418	0	0	\N
230726	1678	720010577000	748	419	0	0	\N
230728	1678	720010578000	750	420	0	0	\N
230729	1678	720010578000	751	420	0	0	\N
230731	1678	720010579000	753	421	0	0	\N
230732	1678	720010580000	754	422	0	0	\N
230736	1678	720010581000	757	423	0	0	\N
230737	1678	720010582000	757	423	1	0	\N
230738	1678	720010583000	758	424	0	0	\N
230739	1678	720010583000	759	424	0	0	\N
230741	1678	720010583000	761	424	0	0	\N
230742	532	66000000000000	762	369	0	0	\N
230743	532	66000000000000	762	369	1	0	\N
230744	1483	0	762	369	5	0	\N
230745	1678	720010583000	763	424	0	0	\N
230747	14	4884200000000	765	426	0	0	\N
230748	1736	0	765	426	1	0	\N
230749	1678	720010585000	765	426	2	0	\N
230753	14	4884200000000	767	426	0	0	\N
230754	1736	0	767	426	1	0	\N
230755	1678	720010585000	767	426	2	0	\N
230756	1678	720010586000	768	427	0	0	\N
230762	30	6000200000000	771	428	0	0	\N
230763	1678	720010587000	771	428	1	0	\N
230764	1678	720010588000	771	428	2	0	\N
230765	1736	0	771	428	3	0	\N
230772	298	67439420000000	775	431	0	0	\N
230773	1678	720010592000	775	431	1	0	\N
230774	298	67439420000000	776	431	0	0	\N
230775	1678	720010592000	776	431	1	0	\N
230776	1678	720010593000	777	432	0	0	\N
230777	1678	720010593000	778	432	0	0	\N
230779	1678	720010594000	780	433	0	0	\N
230780	209	66001000000000	780	433	1	0	\N
230781	1678	720010595000	780	433	2	0	\N
230782	1678	720010594000	781	433	0	0	\N
230783	209	66001000000000	781	433	1	0	\N
230784	1678	720010595000	781	433	2	0	\N
230788	1678	720010596000	784	435	0	0	\N
230789	1678	720010597000	784	435	1	0	\N
230790	1678	720010598000	784	435	2	0	\N
230791	1678	720010596000	785	435	0	0	\N
230792	1678	720010597000	785	435	1	0	\N
230661	1678	720010537000	703	391	2	0	0
230662	1678	720010538000	704	392	0	0	0
230663	1678	720010539000	704	392	1	0	0
230664	1678	720010540000	705	393	0	0	0
230665	1678	720010541000	706	394	0	0	0
230667	1678	720010543000	707	395	1	0	0
230668	1678	720010544000	707	395	2	0	0
230669	1678	720010545000	708	396	0	0	0
230670	1678	720010546000	709	397	0	0	0
230681	1678	720010547000	714	398	0	0	0
230683	1678	720010549000	717	400	1	0	0
230684	1678	720010550000	717	400	2	0	0
230685	1678	720010551000	718	401	0	0	0
230686	1678	720010552000	718	401	1	0	0
230688	1678	720010554000	719	402	1	0	0
230690	1678	720010555000	721	403	1	0	0
230691	1483	0	721	403	2	0	0
230692	1678	720010556000	722	404	0	0	0
230694	1678	720010557000	724	405	1	0	0
230696	1678	720010559000	724	405	3	0	0
230700	1678	720010560000	726	406	0	0	0
230702	1678	720010561000	728	407	0	0	0
230703	1678	720010562000	728	407	1	0	0
230704	1678	720010563000	729	408	0	0	0
230706	1678	720010565000	731	410	0	0	0
230709	1678	720010566000	734	411	0	0	0
230710	1678	720010567000	735	412	0	0	0
230711	1678	720010568000	736	413	0	0	0
230716	1678	720010570000	740	414	0	0	0
230717	1678	720010571000	741	415	0	0	0
230718	1678	720010572000	741	415	1	0	0
230719	1678	720010573000	742	416	0	0	0
230720	1678	720010574000	743	417	0	0	0
230722	1678	720010576000	744	418	0	0	0
230725	1678	720010577000	747	419	0	0	0
230727	1678	720010578000	749	420	0	0	0
230730	1678	720010579000	752	421	0	0	0
230733	1678	720010580000	755	422	0	0	0
230735	1678	720010582000	756	423	1	0	0
230740	1678	720010583000	760	424	0	0	0
230746	1678	720010584000	764	425	0	0	0
230750	14	4884200000000	766	426	0	0	0
230752	1678	720010585000	766	426	2	0	0
230757	1678	720010586000	769	427	0	0	0
230758	30	6000200000000	770	428	0	0	0
230759	1678	720010587000	770	428	1	0	0
230760	1678	720010588000	770	428	2	0	0
230766	1736	0	772	429	0	0	0
230767	1678	720010589000	772	429	1	0	0
230768	1678	720010590000	772	429	2	0	0
230769	1678	720010591000	773	430	0	0	0
230770	298	67439420000000	774	431	0	0	2
230778	1678	720010593000	779	432	0	0	0
230785	1678	720010594000	782	433	0	0	0
230786	209	66001000000000	782	433	1	0	0
230787	1678	720010595000	782	433	2	0	0
230793	1678	720010598000	785	435	2	0	\N
230797	1678	720010596000	787	435	0	0	\N
230798	1678	720010597000	787	435	1	0	\N
230799	1678	720010598000	787	435	2	0	\N
230800	1678	720010599000	788	436	0	0	\N
230803	1678	720010601000	791	438	0	0	\N
230808	1678	720010605000	795	441	0	0	\N
230810	1678	720010606000	797	442	0	0	\N
230811	1678	720010606000	798	442	0	0	\N
230813	1678	720010607000	800	443	0	0	\N
230814	1678	720010607000	801	443	0	0	\N
230816	1678	720010608000	803	444	0	0	\N
230817	1678	720010609000	803	444	1	0	\N
230824	1678	720010611000	807	446	0	0	\N
230825	1678	720010612000	807	446	1	0	\N
230826	1678	720010613000	807	446	2	0	\N
230830	1678	720010615000	810	448	0	0	\N
230831	1678	720010616000	810	448	1	0	\N
230832	1678	720010617000	811	449	0	0	\N
230834	1678	720010618000	813	450	0	0	\N
230837	1678	720010619000	816	451	0	0	\N
230840	1678	720010621000	818	453	0	0	\N
230843	1678	720010622000	821	454	0	0	\N
230844	1678	720010622000	822	454	0	0	\N
230845	1678	720010623000	823	455	0	0	\N
230846	1678	720010624000	823	455	1	0	\N
230847	1678	720010623000	824	455	0	0	\N
230848	1678	720010624000	824	455	1	0	\N
230851	1678	720010623000	826	455	0	0	\N
230852	1678	720010624000	826	455	1	0	\N
230854	1678	720010625000	828	456	0	0	\N
230856	1678	720010627000	830	458	0	0	\N
230857	1678	720010627000	831	458	0	0	\N
230860	1678	720010628000	834	459	0	0	\N
230861	1678	720010629000	835	460	0	0	\N
230869	1678	720010634000	840	463	0	0	\N
230870	1678	720010635000	840	463	1	0	\N
230871	1678	720010636000	841	464	0	0	\N
230873	1678	720010637000	843	465	0	0	\N
230887	1678	720010646000	854	474	0	0	\N
230888	1678	720010647000	854	474	1	0	\N
230889	1678	720010648000	854	474	2	0	\N
230890	1678	720010649000	854	474	3	0	\N
230894	1678	720010650000	856	475	0	0	\N
230895	1678	720010651000	856	475	1	0	\N
230896	1678	720010652000	856	475	2	0	\N
230897	1678	720010653000	857	476	0	0	\N
230898	1678	720010653000	858	476	0	0	\N
230900	485	66719000000000	860	477	0	0	\N
230901	1678	720010654000	860	477	1	0	\N
230902	1678	720010655000	860	477	2	0	\N
230903	1678	720010656000	860	477	3	0	\N
230908	1678	720010657000	862	478	0	0	\N
230909	1678	720010657000	863	478	0	0	\N
230913	1737	1000000000	866	479	0	0	\N
230914	1678	720010658000	866	479	1	0	\N
230918	1678	720010661000	870	482	0	0	\N
230919	1678	720010662000	871	483	0	0	\N
230920	1678	720010662000	872	483	0	0	\N
230796	1678	720010598000	786	435	2	0	0
230801	1678	720010599000	789	436	0	0	0
230802	1678	720010600000	790	437	0	0	0
230804	1678	720010601000	792	438	0	0	0
230805	1678	720010602000	793	439	0	0	0
230807	1678	720010604000	794	440	1	0	0
230809	1678	720010605000	796	441	0	0	0
230812	1678	720010606000	799	442	0	0	0
230815	1678	720010607000	802	443	0	0	0
230818	1678	720010608000	804	444	0	0	0
230820	1678	720010610000	805	445	0	0	0
230821	1678	720010611000	806	446	0	0	0
230822	1678	720010612000	806	446	1	0	0
230823	1678	720010613000	806	446	2	0	0
230828	1678	720010615000	809	448	0	0	0
230829	1678	720010616000	809	448	1	0	0
230833	1678	720010617000	812	449	0	0	0
230835	1678	720010618000	814	450	0	0	0
230836	1678	720010619000	815	451	0	0	0
230839	1434	719100000000	817	452	1	0	1
230841	1678	720010621000	819	453	0	0	0
230842	1678	720010622000	820	454	0	0	0
230849	1678	720010623000	825	455	0	0	0
230850	1678	720010624000	825	455	1	0	0
230855	1678	720010626000	829	457	0	0	0
230858	1678	720010627000	832	458	0	0	0
230859	1678	720010628000	833	459	0	0	0
230862	1678	720010629000	836	460	0	0	0
230864	1678	720010631000	837	461	1	0	0
230865	1678	720010632000	838	462	0	0	0
230866	1678	720010633000	838	462	1	0	0
230867	1678	720010634000	839	463	0	0	0
230868	1678	720010635000	839	463	1	0	0
230874	1678	720010637000	844	465	0	0	0
230875	1678	720010638000	845	466	0	0	0
230876	1678	720010639000	846	467	0	0	0
230877	1678	720010640000	847	468	0	0	0
230878	1678	720010641000	847	468	1	0	0
230880	1678	720010643000	849	470	0	0	0
230881	1678	720010644000	850	471	0	0	0
230882	1678	720010645000	851	472	0	0	0
230883	1678	720010646000	853	474	0	0	0
230885	1678	720010648000	853	474	2	0	0
230886	1678	720010649000	853	474	3	0	0
230891	1678	720010650000	855	475	0	0	0
230892	1678	720010651000	855	475	1	0	0
230893	1678	720010652000	855	475	2	0	0
230904	485	66719000000000	861	477	0	0	0
230905	1678	720010654000	861	477	1	0	0
230906	1678	720010655000	861	477	2	0	0
230907	1678	720010656000	861	477	3	0	0
230910	1678	720010657000	864	478	0	0	0
230912	1678	720010658000	865	479	1	0	0
230915	1678	720010659000	867	480	0	0	0
230916	1678	720010660000	868	481	0	0	0
230917	1678	720010661000	869	482	0	0	0
230922	1678	720010663000	874	484	0	0	0
230923	1678	720010664000	874	484	1	0	0
230924	1678	720010665000	875	485	0	0	0
230925	1678	720010666000	875	485	1	0	0
230926	1678	720010667000	876	486	0	0	0
230928	1678	720010669000	877	487	0	0	0
230934	1678	720010673000	880	489	0	0	\N
230935	1678	720010674000	880	489	1	0	\N
230936	1678	720010675000	881	490	0	0	\N
230942	1483	0	886	493	0	0	\N
230943	1678	720010678000	886	493	1	0	\N
230944	1483	0	887	493	0	0	\N
230945	1678	720010678000	887	493	1	0	\N
230946	1483	0	888	493	0	0	\N
230947	1678	720010678000	888	493	1	0	\N
230949	1678	720010680000	890	495	0	0	\N
230950	1678	720010681000	890	495	1	0	\N
230951	1742	100000000	890	495	2	0	\N
230952	1678	720010680000	891	495	0	0	\N
230953	1678	720010681000	891	495	1	0	\N
230954	1742	100000000	891	495	2	0	\N
230959	1678	720010682000	894	496	0	0	\N
230967	1678	720010688000	899	500	0	0	\N
230969	1678	720010689000	901	501	0	0	\N
230973	1578	0	903	502	0	0	\N
230974	1678	720010690000	903	502	1	0	\N
230975	1678	720010691000	903	502	2	0	\N
230976	1578	0	904	502	0	0	\N
230977	1678	720010690000	904	502	1	0	\N
230978	1678	720010691000	904	502	2	0	\N
230979	1678	720010692000	905	503	0	0	\N
230980	1678	720010693000	905	503	1	0	\N
230985	1678	720010695000	909	505	0	0	\N
230988	1678	720010698000	911	507	0	0	\N
230989	1678	720010699000	911	507	1	0	\N
230992	1678	720010698000	913	507	0	0	\N
230993	1678	720010699000	913	507	1	0	\N
230997	1744	1000000000	916	509	0	0	\N
230998	1678	720010701000	916	509	1	0	\N
231003	1678	720010706000	918	511	0	0	\N
231004	1678	720010706000	919	511	0	0	\N
231011	1678	720010711000	926	516	0	0	\N
231012	1678	720010711000	927	516	0	0	\N
231014	1678	720010712000	929	517	0	0	\N
231017	1678	720010713000	931	518	0	0	\N
231018	1678	720010714000	931	518	1	0	\N
231019	1678	720010715000	932	519	0	0	\N
231020	1678	720010716000	932	519	1	0	\N
231023	1678	720010717000	934	520	0	0	\N
231024	1678	720010717000	935	520	0	0	\N
231029	1678	720010720000	940	523	0	0	\N
231030	1678	720010720000	941	523	0	0	\N
231034	1678	720010724000	943	525	0	0	\N
231040	1678	720010728000	948	528	0	0	\N
231042	1678	720010730000	950	530	0	0	\N
231043	1678	720010731000	950	530	1	0	\N
231049	1678	720010734000	954	532	0	0	\N
231050	1678	720010734000	955	532	0	0	\N
231055	1678	720010738000	958	534	0	0	\N
231062	1678	720010739000	960	535	0	0	\N
231063	1678	720010740000	960	535	1	0	\N
231064	1678	720010741000	960	535	2	0	\N
230931	1678	720010672000	878	488	0	0	0
230932	1678	720010673000	879	489	0	0	0
230933	1678	720010674000	879	489	1	0	0
230937	1678	720010675000	882	490	0	0	0
230938	1678	720010676000	883	491	0	0	0
230940	1483	0	885	493	0	0	0
230941	1678	720010678000	885	493	1	0	0
230948	1678	720010679000	889	494	0	0	0
230955	1678	720010680000	892	495	0	0	0
230956	1678	720010681000	892	495	1	0	0
230958	1678	720010682000	893	496	0	0	0
230960	1678	720010683000	895	497	0	0	0
230961	1678	720010684000	895	497	1	0	0
230962	1743	100000000	895	497	2	0	0
230964	1678	720010686000	896	498	1	0	0
230965	1678	720010687000	897	499	0	0	0
230966	1678	720010688000	898	500	0	0	0
230968	1678	720010689000	900	501	0	0	0
230970	1578	0	902	502	0	0	0
230972	1678	720010691000	902	502	2	0	0
230981	1678	720010692000	906	503	0	0	0
230982	1678	720010693000	906	503	1	0	0
230983	1678	720010694000	907	504	0	0	0
230984	1678	720010695000	908	505	0	0	0
230987	1678	720010697000	910	506	1	0	0
230990	1678	720010698000	912	507	0	0	0
230991	1678	720010699000	912	507	1	0	0
230994	1678	720010700000	914	508	0	0	0
230996	1678	720010701000	915	509	1	0	0
230999	1678	720010702000	917	510	0	0	0
231000	1678	720010703000	917	510	1	0	0
231001	1678	720010704000	917	510	2	0	0
231002	1678	720010705000	917	510	3	0	0
231006	1678	720010707000	921	512	0	0	0
231007	1678	720010708000	922	513	0	0	0
231008	1678	720010709000	923	514	0	0	0
231009	1678	720010710000	924	515	0	0	0
231010	1678	720010711000	925	516	0	0	0
231015	1678	720010713000	930	518	0	0	0
231016	1678	720010714000	930	518	1	0	0
231021	1678	720010715000	933	519	0	0	0
231022	1678	720010716000	933	519	1	0	0
231026	1678	720010718000	937	521	0	0	0
231027	1678	720010719000	938	522	0	0	0
231028	1678	720010720000	939	523	0	0	0
231031	1678	720010721000	942	524	0	0	0
231032	1678	720010722000	942	524	1	0	0
231035	1678	720010724000	944	525	0	0	0
231036	1678	720010725000	945	526	0	0	0
231037	1678	720010726000	946	527	0	0	0
231038	1678	720010727000	946	527	1	0	0
231039	1678	720010728000	947	528	0	0	0
231044	1678	720010730000	951	530	0	0	0
231045	1678	720010731000	951	530	1	0	0
231046	1678	720010732000	952	531	0	0	0
231047	1678	720010733000	952	531	1	0	0
231051	1678	720010735000	956	533	0	0	0
231052	1678	720010736000	956	533	1	0	0
231053	1678	720010737000	956	533	2	0	0
231054	1678	720010738000	957	534	0	0	0
231056	1678	720010739000	959	535	0	0	0
231058	1678	720010741000	959	535	2	0	0
231059	1678	720010742000	959	535	3	0	0
231060	1678	720010743000	959	535	4	0	0
231061	1678	720010744000	959	535	5	0	0
231065	1678	720010742000	960	535	3	0	\N
231066	1678	720010743000	960	535	4	0	\N
231067	1678	720010744000	960	535	5	0	\N
231070	1678	720010745000	962	536	0	0	\N
231071	1678	720010746000	962	536	1	0	\N
231072	1678	720010745000	963	536	0	0	\N
231073	1678	720010746000	963	536	1	0	\N
231077	1678	720010749000	966	538	0	0	\N
231079	1678	720010750000	968	539	0	0	\N
231080	1678	720010750000	969	539	0	0	\N
231082	1678	720010751000	971	540	0	0	\N
231083	1678	720010752000	972	541	0	0	\N
231085	1678	720010752000	974	541	0	0	\N
231086	1678	720010753000	975	542	0	0	\N
231088	1678	720010753000	977	542	0	0	\N
231091	1678	720010755000	980	544	0	0	\N
231092	1678	720010755000	981	544	0	0	\N
231093	1678	720010755000	982	544	0	0	\N
231095	1678	720010756000	984	545	0	0	\N
231097	1678	720010757000	986	546	0	0	\N
231098	1678	720010757000	987	546	0	0	\N
231099	1678	720010757000	988	546	0	0	\N
231100	1678	720010758000	989	547	0	0	\N
231101	1678	720010758000	990	547	0	0	\N
231102	1678	720010758000	991	547	0	0	\N
231104	1678	720010759000	993	548	0	0	\N
231107	1678	720010760000	996	549	0	0	\N
231111	1678	720010764000	1000	553	0	0	\N
231114	1678	720010766000	1003	555	0	0	\N
231116	1678	720010767000	1006	556	0	0	\N
231124	1678	1440030774000	1009	559	0	0	\N
231125	1678	1440030774000	1010	559	0	0	\N
231127	1678	1440030774000	1012	559	0	0	\N
231128	1678	1440030775000	1012	559	1	0	\N
231131	1678	1440030776000	1015	561	0	0	\N
231134	1678	1440030778000	1018	563	0	0	\N
231138	1678	1440030781000	1022	566	0	0	\N
231139	1678	1440030782000	1023	567	0	0	\N
231143	1678	1440030783000	1026	568	0	0	\N
231144	1678	1440030784000	1026	568	1	0	\N
231145	1678	1440030785000	1027	569	0	0	\N
231149	1678	1440030787000	1031	571	0	0	\N
231154	1678	1440030792000	1036	576	0	0	\N
231157	1678	1440030794000	1039	578	0	0	\N
231159	1678	1440030795000	1041	579	0	0	\N
231161	1678	1440030795000	1043	579	0	0	\N
231162	1678	1440030796000	1044	580	0	0	\N
231164	1678	1440030797000	1046	581	0	0	\N
231166	1678	1440030798000	1048	582	0	0	\N
231167	1678	1440030799000	1048	582	1	0	\N
231168	1678	1440030800000	1048	582	2	0	\N
231169	1678	1440030801000	1048	582	3	0	\N
231185	309	66037333809323	1052	584	0	0	\N
231186	551	66037333809323	1052	584	1	0	\N
231187	217	66037333809323	1052	584	2	0	\N
231188	1030	901483095166225	1052	584	3	0	\N
231189	205	66037333809323	1052	584	4	0	\N
231190	138	66037333809323	1052	584	5	0	\N
231191	275	66037333809323	1052	584	6	0	\N
231192	225	66037333809323	1052	584	7	0	\N
231193	1678	1440030803000	1052	584	8	0	\N
231074	1678	720010747000	964	537	0	0	0
231075	1678	720010748000	964	537	1	0	0
231076	1678	720010749000	965	538	0	0	0
231078	1678	720010750000	967	539	0	0	0
231081	1678	720010751000	970	540	0	0	0
231087	1678	720010753000	976	542	0	0	0
231089	1678	720010754000	978	543	0	0	0
231090	1678	720010755000	979	544	0	0	0
231094	1678	720010756000	983	545	0	0	0
231096	1678	720010757000	985	546	0	0	0
231105	1678	720010759000	994	548	0	0	0
231106	1678	720010760000	995	549	0	0	0
231108	1678	720010761000	997	550	0	0	0
231109	1678	720010762000	998	551	0	0	0
231112	1678	720010764000	1001	553	0	0	0
231113	1678	720010765000	1002	554	0	0	0
231115	1678	720010766000	1004	555	0	0	0
231117	1678	720010767000	1007	557	0	0	0
231118	1678	720010768000	1007	557	1	0	0
231120	1678	1440030770000	1008	558	1	0	0
231121	1678	1440030771000	1008	558	2	0	0
231122	1678	1440030772000	1008	558	3	0	0
231123	1678	1440030773000	1008	558	4	0	0
231126	1678	1440030774000	1011	559	0	0	0
231130	1678	1440030776000	1014	561	0	0	0
231132	1678	1440030777000	1016	562	0	0	0
231133	1678	1440030778000	1017	563	0	0	0
231135	1678	1440030779000	1019	564	0	0	0
231137	1678	1440030781000	1021	566	0	0	0
231140	1678	1440030782000	1024	567	0	0	0
231141	1678	1440030783000	1025	568	0	0	0
231142	1678	1440030784000	1025	568	1	0	0
231146	1678	1440030785000	1028	569	0	0	0
231148	1678	1440030787000	1030	571	0	0	0
231150	1678	1440030788000	1032	572	0	0	0
231151	1678	1440030789000	1033	573	0	0	0
231152	1678	1440030790000	1034	574	0	0	0
231153	1678	1440030791000	1035	575	0	0	0
231156	1678	1440030793000	1038	577	0	0	0
231158	1678	1440030794000	1040	578	0	0	0
231160	1678	1440030795000	1042	579	0	0	0
231163	1678	1440030796000	1045	580	0	0	0
231170	1678	1440030798000	1049	582	0	0	0
231171	1678	1440030799000	1049	582	1	0	0
231172	1678	1440030800000	1049	582	2	0	0
231173	1678	1440030801000	1049	582	3	0	0
231174	127	66037333809323	1050	583	0	0	0
231176	309	66037333809323	1051	584	0	0	0
231177	551	66037333809323	1051	584	1	0	0
231178	217	66037333809323	1051	584	2	0	0
231179	1030	901483095166225	1051	584	3	0	0
231180	205	66037333809323	1051	584	4	0	0
231182	275	66037333809323	1051	584	6	0	0
231183	225	66037333809323	1051	584	7	0	0
231184	1678	1440030803000	1051	584	8	0	0
231194	1542	0	1053	585	0	0	0
231196	373	66037333809323	1053	585	2	0	0
231197	402	66037333809323	1053	585	3	0	0
231198	690	66037333809323	1053	585	4	0	0
231199	731	2001131327550	1053	585	5	0	0
231200	877	203168026440745	1053	585	6	0	0
231230	1542	0	1054	585	0	0	\N
231231	304	66037333809323	1054	585	1	0	\N
231232	373	66037333809323	1054	585	2	0	\N
231233	402	66037333809323	1054	585	3	0	\N
231234	690	66037333809323	1054	585	4	0	\N
231235	731	2001131327550	1054	585	5	0	\N
231236	877	203168026440745	1054	585	6	0	\N
231237	191	66037333809323	1054	585	7	0	\N
231238	122	66037333809323	1054	585	8	0	\N
231239	5	6700788250312	1054	585	9	0	\N
231240	91	66037333809323	1054	585	10	0	\N
231241	99	66037333809323	1054	585	11	0	\N
231242	339	66037333809323	1054	585	12	0	\N
231243	420	66037333809323	1054	585	13	0	\N
231244	408	66037333809323	1054	585	14	0	\N
231245	206	66037333809323	1054	585	15	0	\N
231246	397	66037333809323	1054	585	16	0	\N
231247	534	66037333809323	1054	585	17	0	\N
231248	570	66037333809323	1054	585	18	0	\N
231249	894	306996475205388	1054	585	19	0	\N
231250	106	66037333809323	1054	585	20	0	\N
231251	146	66037333809323	1054	585	21	0	\N
231252	251	66037333809323	1054	585	22	0	\N
231253	89	66037333809323	1054	585	23	0	\N
231254	29	7003959646441	1054	585	24	0	\N
231255	84	66037333809323	1054	585	25	0	\N
231256	92	66037333809323	1054	585	26	0	\N
231257	395	66037333809323	1054	585	27	0	\N
231258	587	66037333809323	1054	585	28	0	\N
231259	611	66037333809323	1054	585	29	0	\N
231260	438	66037333809323	1054	585	30	0	\N
231261	710	5002828318886	1054	585	31	0	\N
231262	399	66037333809323	1054	585	32	0	\N
231263	322	66037333809323	1054	585	33	0	\N
231264	1678	1440030804000	1054	585	34	0	\N
231265	1678	1440030805000	1054	585	35	0	\N
231266	1542	0	1055	585	0	0	\N
231267	304	66037333809323	1055	585	1	0	\N
231268	373	66037333809323	1055	585	2	0	\N
231269	402	66037333809323	1055	585	3	0	\N
231270	690	66037333809323	1055	585	4	0	\N
231271	731	2001131327550	1055	585	5	0	\N
231272	877	203168026440745	1055	585	6	0	\N
231273	191	66037333809323	1055	585	7	0	\N
231274	122	66037333809323	1055	585	8	0	\N
231275	5	6700788250312	1055	585	9	0	\N
231276	91	66037333809323	1055	585	10	0	\N
231277	99	66037333809323	1055	585	11	0	\N
231278	339	66037333809323	1055	585	12	0	\N
231279	420	66037333809323	1055	585	13	0	\N
231280	408	66037333809323	1055	585	14	0	\N
231281	206	66037333809323	1055	585	15	0	\N
231282	397	66037333809323	1055	585	16	0	\N
231283	534	66037333809323	1055	585	17	0	\N
231284	570	66037333809323	1055	585	18	0	\N
231285	894	306996475205388	1055	585	19	0	\N
231286	106	66037333809323	1055	585	20	0	\N
231287	146	66037333809323	1055	585	21	0	\N
231288	251	66037333809323	1055	585	22	0	\N
231289	89	66037333809323	1055	585	23	0	\N
231290	29	7003959646441	1055	585	24	0	\N
231291	84	66037333809323	1055	585	25	0	\N
231292	92	66037333809323	1055	585	26	0	\N
231293	395	66037333809323	1055	585	27	0	\N
231294	587	66037333809323	1055	585	28	0	\N
231295	611	66037333809323	1055	585	29	0	\N
231296	438	66037333809323	1055	585	30	0	\N
231297	710	5002828318886	1055	585	31	0	\N
231298	399	66037333809323	1055	585	32	0	\N
231299	322	66037333809323	1055	585	33	0	\N
231300	1678	1440030804000	1055	585	34	0	\N
231301	1678	1440030805000	1055	585	35	0	\N
231302	910	503062168193579	1056	586	0	0	\N
231303	1678	1440030806000	1056	586	1	0	\N
231304	105	66037333809323	1056	586	2	0	\N
231305	500	66037333809323	1056	586	3	0	\N
231306	721	2001131327550	1056	586	4	0	\N
231307	560	66037333809323	1056	586	5	0	\N
231308	392	66037333809323	1056	586	6	0	\N
231309	194	66037333809323	1056	586	7	0	\N
231310	678	66037333809323	1056	586	8	0	\N
231311	320	66037333809323	1056	586	9	0	\N
231312	295	66037333809323	1056	586	10	0	\N
231313	78	66037333809323	1056	586	11	0	\N
231314	54	66037333809323	1056	586	12	0	\N
231315	594	66037333809323	1056	586	13	0	\N
231316	37	65364953683265	1056	586	14	0	\N
231317	1150	608248607628251	1056	586	15	0	\N
231318	163	66037333809323	1056	586	16	0	\N
231319	910	503062168193579	1057	586	0	0	\N
231320	1678	1440030806000	1057	586	1	0	\N
231321	105	66037333809323	1057	586	2	0	\N
231322	500	66037333809323	1057	586	3	0	\N
231323	721	2001131327550	1057	586	4	0	\N
231324	560	66037333809323	1057	586	5	0	\N
231325	392	66037333809323	1057	586	6	0	\N
231326	194	66037333809323	1057	586	7	0	\N
231327	678	66037333809323	1057	586	8	0	\N
231328	320	66037333809323	1057	586	9	0	\N
231329	295	66037333809323	1057	586	10	0	\N
231330	78	66037333809323	1057	586	11	0	\N
231331	54	66037333809323	1057	586	12	0	\N
231332	594	66037333809323	1057	586	13	0	\N
231333	37	65364953683265	1057	586	14	0	\N
231334	1150	608248607628251	1057	586	15	0	\N
231335	163	66037333809323	1057	586	16	0	\N
231203	5	6700788250312	1053	585	9	0	0
231204	91	66037333809323	1053	585	10	0	0
231205	99	66037333809323	1053	585	11	0	0
231206	339	66037333809323	1053	585	12	0	0
231207	420	66037333809323	1053	585	13	0	0
231209	206	66037333809323	1053	585	15	0	0
231210	397	66037333809323	1053	585	16	0	0
231211	534	66037333809323	1053	585	17	0	0
231212	570	66037333809323	1053	585	18	0	0
231213	894	306996475205388	1053	585	19	0	0
231215	146	66037333809323	1053	585	21	0	0
231216	251	66037333809323	1053	585	22	0	0
231217	89	66037333809323	1053	585	23	0	0
231218	29	7003959646441	1053	585	24	0	0
231220	92	66037333809323	1053	585	26	0	0
231221	395	66037333809323	1053	585	27	0	0
231222	587	66037333809323	1053	585	28	0	0
231223	611	66037333809323	1053	585	29	0	0
231224	438	66037333809323	1053	585	30	0	0
231226	399	66037333809323	1053	585	32	0	0
231227	322	66037333809323	1053	585	33	0	0
231228	1678	1440030804000	1053	585	34	0	0
231229	1678	1440030805000	1053	585	35	0	0
231336	910	503062168193579	1058	586	0	0	0
231353	1542	0	1059	572	0	0	\N
231354	127	66037333809323	1059	572	1	0	\N
231355	309	66037333809323	1059	572	2	0	\N
231356	551	66037333809323	1059	572	3	0	\N
231357	217	66037333809323	1059	572	4	0	\N
231358	1030	901483095166225	1059	572	5	0	\N
231359	205	66037333809323	1059	572	6	0	\N
231360	138	66037333809323	1059	572	7	0	\N
231361	275	66037333809323	1059	572	8	0	\N
231362	225	66037333809323	1059	572	9	0	\N
231363	304	66037333809323	1059	572	10	0	\N
231364	373	66037333809323	1059	572	11	0	\N
231365	402	66037333809323	1059	572	12	0	\N
231366	690	66037333809323	1059	572	13	0	\N
231367	731	2001131327550	1059	572	14	0	\N
231368	877	203168026440745	1059	572	15	0	\N
231369	191	66037333809323	1059	572	16	0	\N
231370	122	66037333809323	1059	572	17	0	\N
231371	5	6700788250312	1059	572	18	0	\N
231372	91	66037333809323	1059	572	19	0	\N
231373	99	66037333809323	1059	572	20	0	\N
231374	339	66037333809323	1059	572	21	0	\N
231375	420	66037333809323	1059	572	22	0	\N
231376	408	66037333809323	1059	572	23	0	\N
231377	206	66037333809323	1059	572	24	0	\N
231378	397	66037333809323	1059	572	25	0	\N
231379	534	66037333809323	1059	572	26	0	\N
231380	570	66037333809323	1059	572	27	0	\N
231381	894	306996475205388	1059	572	28	0	\N
231382	106	66037333809323	1059	572	29	0	\N
231383	146	66037333809323	1059	572	30	0	\N
231384	251	66037333809323	1059	572	31	0	\N
231385	89	66037333809323	1059	572	32	0	\N
231386	29	7003959646441	1059	572	33	0	\N
231387	84	66037333809323	1059	572	34	0	\N
231388	92	66037333809323	1059	572	35	0	\N
231389	395	66037333809323	1059	572	36	0	\N
231390	587	66037333809323	1059	572	37	0	\N
231391	611	66037333809323	1059	572	39	0	\N
231392	438	66037333809323	1059	572	40	0	\N
231393	710	5002828318886	1059	572	41	0	\N
231394	399	66037333809323	1059	572	42	0	\N
231414	1678	1440030808000	1062	588	0	0	\N
231415	353	66037333809323	1062	588	1	0	\N
231416	390	66037333809323	1062	588	2	0	\N
231417	1678	1440030808000	1063	588	0	0	\N
231418	353	66037333809323	1063	588	1	0	\N
231419	390	66037333809323	1063	588	2	0	\N
231423	1678	1440030812000	1066	591	0	0	\N
231427	1678	1440030814000	1070	593	0	0	\N
231428	1678	1440030814000	1071	593	0	0	\N
231429	1678	1440030814000	1072	593	0	0	\N
231432	1678	1440030815000	1074	594	0	0	\N
231433	1678	1440030816000	1074	594	1	0	\N
231437	1678	1440030820000	1078	598	0	0	\N
231438	1678	1440030821000	1078	598	1	0	\N
231439	1678	1440030822000	1078	598	2	0	\N
231445	1678	1440030825000	1082	601	0	0	\N
231446	1678	1440030825000	1083	601	0	0	\N
231448	1678	1440030825000	1085	601	0	0	\N
231449	1678	1440030826000	1086	602	0	0	\N
231467	1678	1440030829000	1090	604	0	0	\N
231468	201	66037333809323	1090	604	1	0	\N
231469	103	66037333809323	1090	604	2	0	\N
231470	261	66037333809323	1090	604	3	0	\N
231471	361	66037333809323	1090	604	4	0	\N
231472	680	66037333809323	1090	604	5	0	\N
231339	500	66037333809323	1058	586	3	0	0
231340	721	2001131327550	1058	586	4	0	0
231341	560	66037333809323	1058	586	5	0	0
231342	392	66037333809323	1058	586	6	0	0
231343	194	66037333809323	1058	586	7	0	0
231345	320	66037333809323	1058	586	9	0	0
231346	295	66037333809323	1058	586	10	0	0
231347	78	66037333809323	1058	586	11	0	0
231348	54	66037333809323	1058	586	12	0	0
231349	594	66037333809323	1058	586	13	0	0
231351	1150	608248607628251	1058	586	15	0	0
231352	163	66037333809323	1058	586	16	0	0
231395	1678	1440030807000	1060	587	0	0	0
231396	452	66037333809323	1060	587	1	0	0
231398	893	306996475205388	1060	587	3	0	0
231399	150	66037333809323	1060	587	4	0	0
231400	252	66037333809323	1060	587	5	0	0
231401	450	66037333809323	1060	587	6	0	0
231402	620	66037333809323	1060	587	7	0	0
231404	421	66037333809323	1060	587	9	0	0
231405	520	66037333809323	1060	587	10	0	0
231406	622	66040313809323	1060	587	11	0	1
231407	652	66037333809323	1060	587	12	0	0
231408	1276	1694938827606880	1060	587	13	0	0
231410	180	66037333809323	1060	587	15	0	0
231411	1678	1440030808000	1061	588	0	0	0
231412	353	66037333809323	1061	588	1	0	0
231413	390	66037333809323	1061	588	2	0	0
231421	1678	1440030810000	1064	589	1	0	0
231422	1678	1440030811000	1065	590	0	0	0
231424	1678	1440030812000	1067	591	0	0	0
231425	1678	1440030813000	1068	592	0	0	0
231426	1678	1440030814000	1069	593	0	0	0
231431	1678	1440030816000	1073	594	1	0	0
231434	1678	1440030817000	1075	595	0	0	0
231435	1678	1440030818000	1076	596	0	0	0
231436	1678	1440030819000	1077	597	0	0	0
231440	1678	1440030820000	1079	598	0	0	0
231442	1678	1440030822000	1079	598	2	0	0
231443	1678	1440030823000	1080	599	0	0	0
231444	1678	1440030824000	1081	600	0	0	0
231447	1678	1440030825000	1084	601	0	0	0
231451	569	66037333809323	1089	603	0	0	0
231452	745	2001131327550	1089	603	1	0	0
231453	41	66037333809323	1089	603	2	0	0
231454	308	66037333809323	1089	603	3	0	0
231455	878	203168026440745	1089	603	4	0	0
231457	1678	1440030827000	1089	603	6	0	0
231458	1678	1440030828000	1089	603	7	0	0
231459	49	66037333809323	1089	603	8	0	0
231460	112	66037333809323	1089	603	9	0	0
231461	383	66037333809323	1089	603	10	0	0
231463	499	66037333809323	1089	603	12	0	0
231464	35	19210860744526	1089	603	13	0	0
231465	453	66037333809323	1089	603	14	0	0
231466	82	66037333809323	1089	603	15	0	0
231473	63	66037333809323	1090	604	6	0	\N
231474	377	66037333809323	1090	604	7	0	\N
231475	266	66037333809323	1090	604	8	0	\N
231476	201	66037333809323	1091	604	0	0	\N
231477	103	66037333809323	1091	604	1	0	\N
231478	261	66037333809323	1091	604	2	0	\N
231479	361	66037333809323	1091	604	3	0	\N
231480	680	66037333809323	1091	604	4	0	\N
231481	63	66037333809323	1091	604	5	0	\N
231482	377	66037333809323	1091	604	6	0	\N
231483	266	66037333809323	1091	604	7	0	\N
231503	1678	1440030831000	1094	606	0	0	\N
231504	193	66037333809323	1094	606	1	0	\N
231505	593	66037333809323	1094	606	2	0	\N
231506	653	66037333809323	1094	606	3	0	\N
231511	1678	1440030831000	1096	606	0	0	\N
231512	193	66037333809323	1096	606	1	0	\N
231513	593	66037333809323	1096	606	2	0	\N
231514	653	66037333809323	1096	606	3	0	\N
231515	1678	1440030832000	1097	607	0	0	\N
231517	1678	1440030832000	1099	607	0	0	\N
231521	1678	1440030835000	1103	610	0	0	\N
231523	1678	1440030836000	1105	611	0	0	\N
231525	1678	1440030837000	1107	612	0	0	\N
231526	1678	1440030838000	1108	613	0	0	\N
231528	1678	1440030838000	1110	613	0	0	\N
231529	1678	1440030838000	1111	613	0	0	\N
231530	1678	1440030839000	1112	614	0	0	\N
231531	1678	1440030840000	1112	614	1	0	\N
231532	1678	1440030839000	1113	614	0	0	\N
231533	1678	1440030840000	1113	614	1	0	\N
231536	1678	1440030841000	1115	615	0	0	\N
231539	1678	1440030842000	1118	616	0	0	\N
231540	1678	1440030843000	1119	617	0	0	\N
231541	1678	1440030844000	1119	617	1	0	\N
231542	1678	1440030843000	1120	617	0	0	\N
231543	1678	1440030844000	1120	617	1	0	\N
231548	1678	1440030847000	1123	619	0	0	\N
231550	569	66037333809323	1125	591	0	0	\N
231551	1678	1440030812000	1125	591	1	0	\N
231552	1678	1440030813000	1125	591	2	0	\N
231553	1678	1440030814000	1125	591	3	0	\N
231554	1678	1440030815000	1125	591	4	0	\N
231555	1678	1440030816000	1125	591	5	0	\N
231556	1678	1440030817000	1125	591	6	0	\N
231557	1678	1440030818000	1125	591	7	0	\N
231558	1678	1440030819000	1125	591	8	0	\N
231559	1678	1440030820000	1125	591	9	0	\N
231560	1678	1440030821000	1125	591	10	0	\N
231561	1678	1440030822000	1125	591	11	0	\N
231562	1678	1440030823000	1125	591	12	0	\N
231563	745	2001131327550	1125	591	13	0	\N
231564	41	66037333809323	1125	591	14	0	\N
231565	308	66037333809323	1125	591	15	0	\N
231566	878	203168026440745	1125	591	16	0	\N
231567	186	66037333809323	1125	591	17	0	\N
231568	49	66037333809323	1125	591	18	0	\N
231569	112	66037333809323	1125	591	19	0	\N
231570	383	66037333809323	1125	591	20	0	\N
231571	663	66037333809323	1125	591	21	0	\N
231572	499	66037333809323	1125	591	22	0	\N
231573	35	19210860744526	1125	591	23	0	\N
231574	453	66037333809323	1125	591	24	0	\N
231575	82	66037333809323	1125	591	25	0	\N
231576	201	66037333809323	1125	591	26	0	\N
231577	103	66037333809323	1125	591	27	0	\N
231578	261	66037333809323	1125	591	29	0	\N
231579	361	66037333809323	1125	591	30	0	\N
231580	680	66037333809323	1125	591	31	0	\N
231581	63	66037333809323	1125	591	32	0	\N
231582	377	66037333809323	1125	591	33	0	\N
231583	266	66037333809323	1125	591	34	0	\N
231584	600	66037333809323	1125	591	35	0	\N
231585	691	66037333809323	1125	591	36	0	\N
231586	352	66037333809323	1125	591	37	0	\N
231587	601	66037333809323	1125	591	38	0	\N
231588	504	66037333809323	1125	591	39	0	\N
231589	658	66037333809323	1125	591	40	0	\N
231590	6	32576416881266	1125	591	41	0	\N
231591	391	66037333809323	1125	591	42	0	\N
231592	660	66037333809323	1125	591	43	0	\N
231593	193	66037333809323	1125	591	44	0	\N
231594	593	66037333809323	1125	591	45	0	\N
231595	653	66037333809323	1125	591	46	0	\N
231596	1678	1440030824000	1125	591	47	0	\N
231597	1678	1440030825000	1125	591	48	0	\N
231598	1678	1440030826000	1125	591	49	0	\N
231599	1678	1440030827000	1125	591	50	0	\N
231600	1678	1440030828000	1125	591	51	0	\N
231601	1678	1440030829000	1125	591	52	0	\N
231602	1678	1440030830000	1125	591	53	0	\N
231603	1678	1440030831000	1125	591	54	0	\N
231604	1678	1440030832000	1125	591	55	0	\N
231605	1678	1440030833000	1125	591	56	0	\N
231606	1678	1440030834000	1125	591	57	0	\N
231607	1678	1440030835000	1125	591	58	0	\N
231608	1678	1440030836000	1125	591	59	0	\N
231486	103	66037333809323	1092	604	2	0	0
231487	261	66037333809323	1092	604	3	0	0
231488	361	66037333809323	1092	604	4	0	0
231489	680	66037333809323	1092	604	5	0	0
231490	63	66037333809323	1092	604	6	0	0
231492	266	66037333809323	1092	604	8	0	0
231493	1678	1440030830000	1093	605	0	0	0
231494	600	66037333809323	1093	605	1	0	0
231495	691	66037333809323	1093	605	2	0	0
231496	352	66037333809323	1093	605	3	0	0
231498	504	66037333809323	1093	605	5	0	0
231499	658	66037333809323	1093	605	6	0	0
231500	6	32576416881266	1093	605	7	0	0
231501	391	66037333809323	1093	605	8	0	0
231507	1678	1440030831000	1095	606	0	0	0
231508	193	66037333809323	1095	606	1	0	0
231509	593	66037333809323	1095	606	2	0	0
231510	653	66037333809323	1095	606	3	0	0
231516	1678	1440030832000	1098	607	0	0	0
231519	1678	1440030834000	1101	609	0	0	0
231520	1678	1440030835000	1102	610	0	0	0
231522	1678	1440030836000	1104	611	0	0	0
231524	1678	1440030837000	1106	612	0	0	0
231527	1678	1440030838000	1109	613	0	0	0
231535	1678	1440030840000	1114	614	1	0	0
231537	1678	1440030841000	1116	615	0	0	0
231538	1678	1440030842000	1117	616	0	0	0
231544	1678	1440030843000	1121	617	0	0	0
231546	1678	1440030845000	1122	618	0	0	0
231547	1678	1440030846000	1122	618	1	0	0
231549	1678	1440030847000	1124	619	0	0	0
231609	1678	1440030837000	1125	591	60	0	\N
231610	1678	1440030838000	1125	591	61	0	\N
231611	1678	1440030839000	1125	591	62	0	\N
231612	1678	1440030840000	1125	591	63	0	\N
231613	1678	1440030841000	1125	591	64	0	\N
231614	1678	1440030842000	1125	591	65	0	\N
231615	1678	1440030843000	1125	591	66	0	\N
231616	1678	1440030844000	1125	591	67	0	\N
231617	1678	1440030845000	1125	591	68	0	\N
231618	1678	1440030846000	1125	591	69	0	\N
231619	1678	1440030847000	1125	591	70	0	\N
231623	1678	1440030850000	1128	622	0	0	\N
231630	1678	1440030856000	1134	627	0	0	\N
231631	1678	1440030857000	1134	627	1	0	\N
231635	1678	1440030858000	1137	628	0	0	\N
231636	1678	1440030859000	1138	629	0	0	\N
231637	1678	1440030859000	1139	629	0	0	\N
231639	1678	1440030860000	1141	630	0	0	\N
231642	1678	1440030861000	1144	631	0	0	\N
231643	1678	1440030861000	1145	631	0	0	\N
231644	1678	1440030862000	1146	632	0	0	\N
231646	1678	1440030862000	1148	632	0	0	\N
231647	1678	1440030862000	1149	632	0	0	\N
231651	1678	1440030866000	1152	635	0	0	\N
231652	1678	1440030867000	1152	635	1	0	\N
231653	1678	1440030868000	1152	635	2	0	\N
231654	1678	1440030866000	1153	635	0	0	\N
231655	1678	1440030867000	1153	635	1	0	\N
231656	1678	1440030868000	1153	635	2	0	\N
231660	1678	1440030869000	1155	636	0	0	\N
231665	1678	1440030872000	1160	639	0	0	\N
231668	1678	1440030873000	1162	640	0	0	\N
231669	1678	1440030874000	1162	640	1	0	\N
231670	1678	1440030875000	1163	641	0	0	\N
231672	1678	1440030876000	1165	642	0	0	\N
231673	1678	1440030877000	1165	642	1	0	\N
231676	1678	1440030878000	1167	643	0	0	\N
231677	1678	1440030878000	1168	643	0	0	\N
231679	1678	1440030878000	1170	643	0	0	\N
231683	1678	1440030882000	1174	647	0	0	\N
231684	1678	1440030883000	1174	647	1	0	\N
231689	1678	1440030886000	1178	650	0	0	\N
231690	1678	1440030887000	1178	650	1	0	\N
231695	1678	1440030890000	1182	653	0	0	\N
231702	1678	1440030893000	1186	655	0	0	\N
231703	1678	1440030894000	1186	655	1	0	\N
231704	1517	0	1186	655	2	0	\N
231709	1678	1440030899000	1191	658	0	0	\N
231710	1678	1440030900000	1191	658	1	0	\N
231711	1678	1440030899000	1192	658	0	0	\N
231712	1678	1440030900000	1192	658	1	0	\N
231715	1678	1440030899000	1194	658	0	0	\N
231716	1678	1440030900000	1194	658	1	0	\N
231718	1678	1440030901000	1196	659	0	0	\N
231720	1678	1440030902000	1198	660	0	0	\N
231721	1678	1440030903000	1199	661	0	0	\N
231725	1678	1440030906000	1203	664	0	0	\N
231727	1678	1440030906000	1205	664	0	0	\N
231728	1678	1440030906000	1206	664	0	0	\N
231731	1678	1440030909000	1208	666	0	0	\N
231732	1678	1440030909000	1209	666	0	0	\N
231735	1678	1440030910000	1212	667	0	0	\N
231736	1678	1440030910000	1213	667	0	0	\N
231741	1678	1440030915000	1216	670	0	0	\N
231743	1678	1440030915000	1218	670	0	0	\N
231622	1678	1440030849000	1127	621	0	0	0
231624	1678	1440030850000	1129	622	0	0	0
231625	1678	1440030851000	1130	623	0	0	0
231626	1678	1440030852000	1131	624	0	0	0
231627	1678	1440030853000	1132	625	0	0	0
231629	1678	1440030855000	1133	626	0	0	0
231632	1678	1440030856000	1135	627	0	0	0
231633	1678	1440030857000	1135	627	1	0	0
231634	1678	1440030858000	1136	628	0	0	0
231638	1678	1440030859000	1140	629	0	0	0
231641	1678	1440030861000	1143	631	0	0	0
231645	1678	1440030862000	1147	632	0	0	0
231648	1678	1440030863000	1150	633	0	0	0
231649	1678	1440030864000	1151	634	0	0	0
231657	1678	1440030866000	1154	635	0	0	0
231658	1678	1440030867000	1154	635	1	0	0
231659	1678	1440030868000	1154	635	2	0	0
231661	1678	1440030869000	1156	636	0	0	0
231662	1678	1440030870000	1157	637	0	0	0
231664	1678	1440030872000	1159	639	0	0	0
231666	1678	1440030873000	1161	640	0	0	0
231667	1678	1440030874000	1161	640	1	0	0
231671	1678	1440030875000	1164	641	0	0	0
231674	1678	1440030876000	1166	642	0	0	0
231678	1678	1440030878000	1169	643	0	0	0
231680	1678	1440030879000	1171	644	0	0	0
231681	1678	1440030880000	1172	645	0	0	0
231682	1678	1440030881000	1173	646	0	0	0
231686	1678	1440030883000	1175	647	1	0	0
231687	1678	1440030884000	1176	648	0	0	0
231688	1678	1440030885000	1177	649	0	0	0
231691	1678	1440030886000	1179	650	0	0	0
231692	1678	1440030887000	1179	650	1	0	0
231694	1678	1440030889000	1181	652	0	0	0
231696	1678	1440030890000	1183	653	0	0	0
231697	1678	1440030891000	1184	654	0	0	0
231698	1678	1440030892000	1184	654	1	0	0
231699	1678	1440030893000	1185	655	0	0	0
231701	1517	0	1185	655	2	0	0
231705	1678	1440030895000	1187	656	0	0	0
231706	1678	1440030896000	1187	656	1	0	0
231707	1678	1440030897000	1187	656	2	0	0
231713	1678	1440030899000	1193	658	0	0	0
231714	1678	1440030900000	1193	658	1	0	0
231717	1678	1440030901000	1195	659	0	0	0
231719	1678	1440030902000	1197	660	0	0	0
231722	1678	1440030903000	1200	661	0	0	0
231724	1678	1440030905000	1202	663	0	0	0
231726	1678	1440030906000	1204	664	0	0	0
231729	1678	1440030907000	1207	665	0	0	0
231730	1678	1440030908000	1207	665	1	0	0
231733	1678	1440030909000	1210	666	0	0	0
231737	1678	1440030911000	1214	668	0	0	0
231738	1678	1440030912000	1215	669	0	0	0
231739	1678	1440030913000	1215	669	1	0	0
231740	1678	1440030914000	1215	669	2	0	0
231744	1678	1440030916000	1219	671	0	0	0
231748	1678	1440030920000	1222	674	0	0	\N
231749	1678	1440030921000	1222	674	1	0	\N
231750	1678	1440030922000	1222	674	2	0	\N
231751	1678	1440030920000	1223	674	0	0	\N
231752	1678	1440030921000	1223	674	1	0	\N
231753	1678	1440030922000	1223	674	2	0	\N
231758	1678	1440030924000	1226	676	0	0	\N
231762	1678	1440030927000	1230	679	0	0	\N
231763	1678	1440030928000	1230	679	1	0	\N
231772	1678	1440030934000	1237	684	0	0	\N
231773	1678	1440030935000	1238	685	0	0	\N
231774	1678	1440030935000	1239	685	0	0	\N
231780	1678	1440030940000	1245	690	0	0	\N
231782	1678	1440030940000	1247	690	0	0	\N
231783	1678	1440030941000	1248	691	0	0	\N
231786	1678	1440030942000	1251	692	0	0	\N
231789	1678	1440030943000	1253	693	0	0	\N
231790	1678	1440030944000	1253	693	1	0	\N
231791	1678	1440030945000	1255	694	0	0	\N
231799	1678	1440030951000	1260	697	0	0	\N
231800	1678	1440030951000	1261	697	0	0	\N
231801	1678	1440030952000	1262	698	0	0	\N
231802	1678	1440030953000	1262	698	1	0	\N
231803	1678	1440030954000	1262	698	2	0	\N
231804	1678	1440030955000	1262	698	3	0	\N
231809	1678	1440030952000	1264	698	0	0	\N
231810	1678	1440030953000	1264	698	1	0	\N
231811	1678	1440030954000	1264	698	2	0	\N
231812	1678	1440030955000	1264	698	3	0	\N
231813	1678	1440030938000	1265	688	0	0	\N
231814	1678	1440030939000	1265	688	1	0	\N
231815	1678	1440030940000	1265	688	2	0	\N
231816	1678	1440030941000	1265	688	3	0	\N
231817	1678	1440030942000	1265	688	4	0	\N
231818	1678	1440030943000	1265	688	5	0	\N
231819	1678	1440030944000	1265	688	6	0	\N
231820	1678	1440030945000	1265	688	7	0	\N
231821	1678	1440030946000	1265	688	8	0	\N
231822	1678	1440030947000	1265	688	9	0	\N
231823	1678	1440030948000	1265	688	10	0	\N
231824	1678	1440030949000	1265	688	11	0	\N
231825	1678	1440030950000	1265	688	12	0	\N
231826	1678	1440030951000	1265	688	13	0	\N
231827	1678	1440030952000	1265	688	14	0	\N
231828	1678	1440030953000	1265	688	15	0	\N
231829	1678	1440030954000	1265	688	16	0	\N
231830	1678	1440030955000	1265	688	17	0	\N
231831	1678	1440030956000	1265	688	18	0	\N
231832	1678	1440030956000	1266	699	0	0	\N
231833	1678	1440030957000	1266	699	1	0	\N
231834	1678	1440030958000	1266	699	2	0	\N
231839	1678	1440030960000	1269	701	0	0	\N
231840	1678	1440030960000	1270	701	0	0	\N
231843	1678	1440030961000	1273	702	0	0	\N
231844	1678	1440030961000	1274	702	0	0	\N
231847	1678	1440030964000	1277	705	0	0	\N
231852	1678	1440030968000	1282	709	0	0	\N
231853	1678	1440030968000	1283	709	0	0	\N
231854	1678	1440030968000	1284	709	0	0	\N
231855	1678	1440030968000	1285	709	0	0	\N
231861	1678	1440030972000	1290	712	0	0	\N
231863	1678	1440030973000	1292	713	0	0	\N
231866	1678	1440030974000	1294	714	0	0	\N
231867	312	66000100000000	1294	714	1	0	\N
231869	1678	1440030976000	1296	716	0	0	\N
231870	1678	1440030977000	1296	716	1	0	\N
231871	1678	1440030978000	1296	716	2	0	\N
231872	1678	1440030979000	1296	716	3	0	\N
231873	1678	1440030976000	1297	716	0	0	\N
231874	1678	1440030977000	1297	716	1	0	\N
231875	1678	1440030978000	1297	716	2	0	\N
231876	1678	1440030979000	1297	716	3	0	\N
231877	1678	1440030976000	1298	716	0	0	\N
231878	1678	1440030977000	1298	716	1	0	\N
231879	1678	1440030978000	1298	716	2	0	\N
231880	1678	1440030979000	1298	716	3	0	\N
231747	1678	1440030919000	1221	673	1	0	0
231754	1678	1440030920000	1224	674	0	0	0
231755	1678	1440030921000	1224	674	1	0	0
231756	1678	1440030922000	1224	674	2	0	0
231757	1678	1440030923000	1225	675	0	0	0
231760	1678	1440030925000	1228	677	0	0	0
231761	1678	1440030926000	1229	678	0	0	0
231764	1678	1440030927000	1231	679	0	0	0
231765	1678	1440030928000	1231	679	1	0	0
231766	1678	1440030929000	1232	680	0	0	0
231768	1678	1440030931000	1234	682	0	0	0
231769	1678	1440030932000	1234	682	1	0	0
231770	1678	1440030933000	1235	683	0	0	0
231771	1678	1440030934000	1236	684	0	0	0
231776	1678	1440030936000	1241	686	0	0	0
231777	1678	1440030937000	1242	687	0	0	0
231778	1678	1440030938000	1243	688	0	0	0
231779	1678	1440030939000	1244	689	0	0	0
231781	1678	1440030940000	1246	690	0	0	0
231785	1678	1440030942000	1250	692	0	0	0
231787	1678	1440030943000	1252	693	0	0	0
231788	1678	1440030944000	1252	693	1	0	0
231792	1678	1440030945000	1256	694	0	0	0
231793	1678	1440030946000	1257	695	0	0	0
231795	1678	1440030948000	1258	696	1	0	0
231796	1678	1440030949000	1258	696	2	0	0
231797	1678	1440030950000	1258	696	3	0	0
231798	1678	1440030951000	1259	697	0	0	0
231806	1678	1440030953000	1263	698	1	0	0
231807	1678	1440030954000	1263	698	2	0	0
231808	1678	1440030955000	1263	698	3	0	0
231835	1678	1440030956000	1267	699	0	0	0
231836	1678	1440030957000	1267	699	1	0	0
231838	1678	1440030959000	1268	700	0	0	0
231841	1678	1440030960000	1271	701	0	0	0
231842	1678	1440030961000	1272	702	0	0	0
231845	1678	1440030962000	1275	703	0	0	0
231846	1678	1440030963000	1276	704	0	0	0
231849	1678	1440030965000	1279	706	0	0	0
231850	1678	1440030966000	1280	707	0	0	0
231851	1678	1440030967000	1281	708	0	0	0
231856	1678	1440030968000	1286	709	0	0	0
231858	1678	1440030970000	1288	711	0	0	0
231859	1678	1440030971000	1288	711	1	0	0
231860	1678	1440030972000	1289	712	0	0	0
231862	1678	1440030973000	1291	713	0	0	0
231864	1678	1440030974000	1293	714	0	0	0
231868	1678	1440030975000	1295	715	0	0	0
231885	1678	1440030976000	1300	716	0	0	\N
231886	1678	1440030977000	1300	716	1	0	\N
231887	1678	1440030978000	1300	716	2	0	\N
231888	1678	1440030979000	1300	716	3	0	\N
231890	1678	1440030980000	1302	717	0	0	\N
231899	1678	1440030987000	1310	722	0	0	\N
231903	1678	1440030989000	1314	724	0	0	\N
231904	1678	1440030989000	1315	724	0	0	\N
231905	1678	1440030990000	1316	725	0	0	\N
231907	1678	1440030991000	1318	726	0	0	\N
231914	1678	1440030992000	1321	727	0	0	\N
231915	1678	1440030993000	1321	727	1	0	\N
231916	1678	1440030994000	1321	727	2	0	\N
231917	1678	1440030995000	1321	727	3	0	\N
231918	1678	1440030996000	1321	727	4	0	\N
231922	1678	1440030997000	1325	728	0	0	\N
231923	1678	1440030998000	1325	728	1	0	\N
231924	1748	0	1325	728	2	0	\N
231929	1678	1440031003000	1328	731	0	0	\N
231932	1678	1440031004000	1331	732	0	0	\N
231934	1678	1440031005000	1333	733	0	0	\N
231935	1678	1440030957000	1334	689	0	0	\N
231936	1678	1440030958000	1334	689	1	0	\N
231937	1678	1440030959000	1334	689	2	0	\N
231938	1678	1440030960000	1334	689	3	0	\N
231939	1678	1440030961000	1334	689	4	0	\N
231940	1678	1440030962000	1334	689	5	0	\N
231941	1678	1440030963000	1334	689	6	0	\N
231942	1678	1440030964000	1334	689	7	0	\N
231943	1678	1440030965000	1334	689	8	0	\N
231944	1678	1440030966000	1334	689	9	0	\N
231945	1678	1440030967000	1334	689	10	0	\N
231946	1678	1440030968000	1334	689	11	0	\N
231947	1678	1440030969000	1334	689	12	0	\N
231948	312	66000100000000	1334	689	13	0	\N
231949	1678	1440030970000	1334	689	14	0	\N
231950	1678	1440030971000	1334	689	15	0	\N
231951	1678	1440030972000	1334	689	16	0	\N
231952	1678	1440030973000	1334	689	17	0	\N
231953	1678	1440030974000	1334	689	18	0	\N
231954	1678	1440030975000	1334	689	19	0	\N
231955	1678	1440030976000	1334	689	20	0	\N
231956	1678	1440030977000	1334	689	21	0	\N
231957	1678	1440030978000	1334	689	22	0	\N
231958	1678	1440030979000	1334	689	23	0	\N
231959	1678	1440030980000	1334	689	24	0	\N
231960	1678	1440030981000	1334	689	25	0	\N
231961	1678	1440030982000	1334	689	26	0	\N
231962	1678	1440030983000	1334	689	27	0	\N
231963	1678	1440030984000	1334	689	28	0	\N
231964	1678	1440030985000	1334	689	29	0	\N
231965	1678	1440030986000	1334	689	30	0	\N
231966	1678	1440030987000	1334	689	31	0	\N
231967	1678	1440030988000	1334	689	32	0	\N
231968	1678	1440030989000	1334	689	33	0	\N
231969	1678	1440030990000	1334	689	34	0	\N
231970	1678	1440030991000	1334	689	36	0	\N
231971	1678	1440030992000	1334	689	37	0	\N
231972	1678	1440030993000	1334	689	38	0	\N
231973	1678	1440030994000	1334	689	39	0	\N
231974	1678	1440030995000	1334	689	40	0	\N
231975	1678	1440030996000	1334	689	41	0	\N
231976	1678	1440030997000	1334	689	42	0	\N
231977	1678	1440030998000	1334	689	43	0	\N
231978	1678	1440030999000	1334	689	44	0	\N
231979	1678	1440031000000	1334	689	45	0	\N
231980	1678	1440031001000	1334	689	46	0	\N
231981	1678	1440031002000	1334	689	47	0	\N
231982	1678	1440031003000	1334	689	48	0	\N
231983	1678	1440031004000	1334	689	49	0	\N
231984	1678	1440031005000	1334	689	50	0	\N
231985	1678	1440031006000	1334	689	51	0	\N
231986	1740	2160540000000	1334	689	52	0	\N
231987	1748	0	1334	689	53	0	\N
231988	1740	4317539000000	1334	689	54	0	\N
231992	1678	1440031008000	1337	735	0	0	\N
231993	1678	1440031009000	1338	736	0	0	\N
231994	1678	1440031007000	1339	690	0	0	\N
231995	1678	1440031008000	1339	690	1	0	\N
231996	1678	1440031009000	1339	690	2	0	\N
232000	1678	1440031012000	1343	739	0	0	\N
232001	1678	1440031010000	1344	691	0	0	\N
232002	1678	1440031011000	1344	691	1	0	\N
232003	1678	1440031012000	1344	691	2	0	\N
232005	1678	1440031013000	1346	740	0	0	\N
232006	1678	1440031013000	1347	740	0	0	\N
232008	1678	1440031013000	1349	740	0	0	\N
232009	1678	1440031013000	1350	740	0	0	\N
232012	1678	1440031015000	1353	742	0	0	\N
232013	1678	1440031016000	1354	743	0	0	\N
232014	1678	1440031017000	1354	743	1	0	\N
231883	1678	1440030978000	1299	716	2	0	0
231884	1678	1440030979000	1299	716	3	0	0
231889	1678	1440030980000	1301	717	0	0	0
231891	1678	1440030981000	1303	718	0	0	0
231892	1678	1440030982000	1303	718	1	0	0
231894	1678	1440030983000	1304	719	0	0	0
231895	1678	1440030984000	1305	720	0	0	0
231896	1678	1440030985000	1306	721	0	0	0
231897	1678	1440030986000	1306	721	1	0	0
231898	1740	4318540000000	1306	721	2	0	0
231901	1678	1440030988000	1312	723	0	0	0
231902	1678	1440030989000	1313	724	0	0	0
231906	1678	1440030990000	1317	725	0	0	0
231908	1678	1440030991000	1319	726	0	0	0
231910	1678	1440030993000	1320	727	1	0	0
231911	1678	1440030994000	1320	727	2	0	0
231912	1678	1440030995000	1320	727	3	0	0
231913	1678	1440030996000	1320	727	4	0	0
231919	1678	1440030997000	1324	728	0	0	0
231921	1748	0	1324	728	2	0	0
231925	1678	1440030999000	1326	729	0	0	0
231926	1678	1440031000000	1326	729	1	0	0
231927	1678	1440031001000	1326	729	2	0	0
231928	1678	1440031002000	1327	730	0	0	0
231931	1678	1440031004000	1330	732	0	0	0
231933	1678	1440031005000	1332	733	0	0	0
231989	1678	1440031006000	1335	734	0	0	0
231990	1678	1440031007000	1335	734	1	0	0
231997	1678	1440031009000	1340	736	0	0	0
231998	1678	1440031010000	1341	737	0	0	0
231999	1678	1440031011000	1342	738	0	0	0
232004	1678	1440031012000	1345	739	0	0	0
232007	1678	1440031013000	1348	740	0	0	0
232011	1678	1440031015000	1352	742	0	0	0
232015	1678	1440031016000	1355	743	0	0	0
232016	1678	1440031017000	1355	743	1	0	0
232021	1678	1440031021000	1357	745	0	0	\N
232023	1678	1440031021000	1359	745	0	0	\N
232024	1678	1440031022000	1360	746	0	0	\N
232028	1678	1440031023000	1363	747	0	0	\N
232029	418	66000000000000	1363	747	1	0	\N
232030	1678	1440031023000	1364	747	0	0	\N
232031	418	66000000000000	1364	747	1	0	\N
232034	1678	1440031025000	1367	749	0	0	\N
232035	1678	1440031026000	1368	750	0	0	\N
232038	1678	1440031027000	1371	751	0	0	\N
232040	1678	1440031028000	1373	752	0	0	\N
232043	1678	1440031031000	1375	754	0	0	\N
232044	1678	1440031031000	1376	754	0	0	\N
232050	1477	0	1380	692	0	0	\N
232051	1678	1440031013000	1380	692	1	0	\N
232052	1678	1440031014000	1380	692	2	0	\N
232053	1678	1440031015000	1380	692	3	0	\N
232054	1678	1440031016000	1380	692	4	0	\N
232055	1678	1440031017000	1380	692	5	0	\N
232056	1678	1440031018000	1380	692	6	0	\N
232057	1678	1440031019000	1380	692	7	0	\N
232058	1678	1440031020000	1380	692	8	0	\N
232059	1678	1440031021000	1380	692	9	0	\N
232060	1678	1440031022000	1380	692	10	0	\N
232061	1678	1440031023000	1380	692	11	0	\N
232062	1678	1440031024000	1380	692	12	0	\N
232063	1678	1440031025000	1380	692	13	0	\N
232064	1678	1440031026000	1380	692	14	0	\N
232065	1678	1440031027000	1380	692	15	0	\N
232066	1678	1440031028000	1380	692	16	0	\N
232067	1678	1440031029000	1380	692	17	0	\N
232068	1678	1440031030000	1380	692	18	0	\N
232069	1678	1440031031000	1380	692	19	0	\N
232070	1678	1440031032000	1380	692	20	0	\N
232071	1678	1440031033000	1380	692	21	0	\N
232072	1678	1440031034000	1380	692	22	0	\N
232073	1678	1440031035000	1380	692	23	0	\N
232074	1678	1440031036000	1380	692	24	0	\N
232075	1748	1000000000	1380	692	25	0	\N
232076	1678	1440031035000	1381	757	0	0	\N
232077	1678	1440031036000	1381	757	1	0	\N
232088	1678	1440031045000	1386	761	0	0	\N
232089	1678	1440031046000	1386	761	1	0	\N
232090	1678	1440031047000	1386	761	2	0	\N
232091	1678	1440031048000	1386	761	3	0	\N
232092	448	66000000000000	1386	761	4	0	\N
232093	1678	1440031049000	1386	761	5	0	\N
232094	1678	1440031045000	1387	761	0	0	\N
232095	1678	1440031046000	1387	761	1	0	\N
232096	1678	1440031047000	1387	761	2	0	\N
232097	1678	1440031048000	1387	761	3	0	\N
232098	448	66000000000000	1387	761	4	0	\N
232099	1678	1440031049000	1387	761	5	0	\N
232106	1678	1440031050000	1389	762	0	0	\N
232108	1678	1440031050000	1391	762	0	0	\N
232109	1678	1440031050000	1392	762	0	0	\N
232110	1678	1440031050000	1393	762	0	0	\N
232112	1678	1440031051000	1395	763	0	0	\N
232113	1678	1440031051000	1396	763	0	0	\N
232116	1678	1440031052000	1398	764	0	0	\N
232117	1678	1440031053000	1398	764	1	0	\N
232125	1678	1440031060000	1402	767	0	0	\N
232126	1678	1440031060000	1403	767	0	0	\N
232127	1678	1440031060000	1404	767	0	0	\N
232130	1678	1440031061000	1406	768	0	0	\N
232131	1749	717000000000	1406	768	1	0	\N
232132	1678	1440031061000	1407	768	0	0	\N
232133	1749	717000000000	1407	768	1	0	\N
232134	1678	1440031061000	1408	768	0	0	\N
232135	1749	717000000000	1408	768	1	0	\N
232137	1678	1440031062000	1410	769	0	0	\N
232138	1678	1440031062000	1411	769	0	0	\N
232139	1678	1440031063000	1412	770	1	0	\N
232140	1678	1440031064000	1412	770	2	0	\N
232144	1678	1440031065000	1415	771	0	0	\N
232145	1678	1440031065000	1416	771	0	0	\N
232146	1678	1440031065000	1417	771	0	0	\N
232147	1678	1440031066000	1418	772	0	0	\N
232150	1678	1440031066000	1420	772	0	0	\N
232152	1678	1440031068000	1423	774	0	0	\N
232019	1678	1440031020000	1356	744	2	0	0
232020	1748	1000000000	1356	744	3	0	0
232022	1678	1440031021000	1358	745	0	0	0
232025	1678	1440031022000	1361	746	0	0	0
232026	1678	1440031023000	1362	747	0	0	0
232032	1678	1440031024000	1365	748	0	0	0
232033	1678	1440031025000	1366	749	0	0	0
232036	1678	1440031026000	1369	750	0	0	0
232037	1678	1440031027000	1370	751	0	0	0
232039	1678	1440031028000	1372	752	0	0	0
232042	1678	1440031030000	1374	753	1	0	0
232045	1678	1440031031000	1377	754	0	0	0
232046	1678	1440031032000	1378	755	0	0	0
232047	1477	0	1379	756	0	0	0
232049	1678	1440031034000	1379	756	2	0	0
232078	1678	1440031035000	1382	757	0	0	0
232079	1678	1440031036000	1382	757	1	0	0
232080	1678	1440031037000	1383	758	0	0	0
232081	1678	1440031038000	1383	758	1	0	0
232083	1678	1440031040000	1383	758	3	0	0
232084	1678	1440031041000	1383	758	4	0	0
232085	1678	1440031042000	1383	758	5	0	0
232086	1678	1440031043000	1384	759	0	0	0
232087	1678	1440031044000	1385	760	0	0	0
232101	1678	1440031046000	1388	761	1	0	0
232102	1678	1440031047000	1388	761	2	0	0
232103	1678	1440031048000	1388	761	3	0	0
232104	448	66000000000000	1388	761	4	0	0
232107	1678	1440031050000	1390	762	0	0	0
232111	1678	1440031051000	1394	763	0	0	0
232114	1678	1440031052000	1397	764	0	0	0
232115	1678	1440031053000	1397	764	1	0	0
232118	1678	1440031054000	1399	765	0	0	0
232120	1678	1440031056000	1399	765	2	0	0
232121	1678	1440031057000	1399	765	3	0	0
232122	1678	1440031058000	1399	765	4	0	0
232123	1678	1440031059000	1400	766	0	0	0
232124	1678	1440031060000	1401	767	0	0	0
232129	1749	717000000000	1405	768	1	0	0
232136	1678	1440031062000	1409	769	0	0	0
232141	1678	1440031063000	1413	770	1	0	0
232142	1678	1440031064000	1413	770	2	0	0
232148	1678	1440031066000	1419	772	0	0	0
232149	1745	2000000	1419	772	1	0	0
232151	1678	1440031067000	1421	773	0	0	0
232153	1678	1440031069000	1423	774	1	0	\N
232154	1678	1440031068000	1424	774	0	0	\N
232155	1678	1440031069000	1424	774	1	0	\N
232156	1678	1440031068000	1425	775	0	0	\N
232157	1678	1440031069000	1425	775	1	0	\N
232158	1678	1440031070000	1425	775	2	0	\N
232163	1678	1440031071000	1428	776	0	0	\N
232169	1678	2160041077000	1432	780	0	0	\N
232170	1678	2160041078000	1432	780	1	0	\N
232171	1678	2160041079000	1432	780	2	0	\N
232175	1678	2160041080000	1434	781	0	0	\N
232181	1678	2160041083000	1438	783	0	0	\N
232182	1678	2160041084000	1438	783	1	0	\N
232184	1678	2160041085000	1440	784	0	0	\N
232185	1678	2160041086000	1441	785	0	0	\N
232186	1678	2160041087000	1441	785	1	0	\N
232189	1678	2160041086000	1443	785	0	0	\N
232190	1678	2160041087000	1443	785	1	0	\N
232191	1749	717000000000	1444	693	0	0	\N
232192	1678	1440031037000	1444	693	2	0	\N
232193	1678	1440031038000	1444	693	3	0	\N
232194	1678	1440031039000	1444	693	4	0	\N
232195	1678	1440031040000	1444	693	5	0	\N
232196	1678	1440031041000	1444	693	6	0	\N
232197	1678	1440031042000	1444	693	7	0	\N
232198	1678	1440031043000	1444	693	8	0	\N
232199	1678	1440031044000	1444	693	9	0	\N
232200	1678	1440031045000	1444	693	10	0	\N
232201	1678	1440031046000	1444	693	11	0	\N
232202	1678	1440031047000	1444	693	12	0	\N
232203	1678	1440031048000	1444	693	13	0	\N
232204	448	66000000000000	1444	693	14	0	\N
232205	1678	1440031049000	1444	693	15	0	\N
232206	1678	1440031050000	1444	693	16	0	\N
232207	1678	1440031051000	1444	693	17	0	\N
232208	1678	1440031052000	1444	693	18	0	\N
232209	1678	1440031053000	1444	693	19	0	\N
232210	1678	1440031054000	1444	693	20	0	\N
232211	1678	1440031055000	1444	693	21	0	\N
232212	1678	1440031056000	1444	693	22	0	\N
232213	1678	1440031057000	1444	693	23	0	\N
232214	1678	1440031058000	1444	693	24	0	\N
232215	1678	1440031059000	1444	693	25	0	\N
232216	1678	1440031060000	1444	693	26	0	\N
232217	1678	1440031061000	1444	693	27	0	\N
232218	1678	1440031062000	1444	693	28	0	\N
232219	1678	1440031063000	1444	693	29	0	\N
232220	1678	1440031064000	1444	693	30	0	\N
232221	1678	1440031065000	1444	693	31	0	\N
232222	1678	1440031066000	1444	693	32	0	\N
232223	1678	1440031067000	1444	693	33	0	\N
232224	1678	1440031068000	1444	693	34	0	\N
232225	1678	1440031069000	1444	693	35	0	\N
232226	1678	1440031070000	1444	693	36	0	\N
232227	1678	1440031071000	1444	693	37	0	\N
232228	1678	1440031072000	1444	693	38	0	\N
232229	1678	1440031073000	1444	693	39	0	\N
232230	1678	1440031074000	1444	693	40	0	\N
232231	1678	1440031075000	1444	693	41	0	\N
232232	1678	1440031076000	1444	693	42	0	\N
232233	1678	1440031077000	1444	693	43	0	\N
232234	1678	1440031078000	1444	693	44	0	\N
232235	1678	1440031079000	1444	693	45	0	\N
232236	1678	1440031080000	1444	693	46	0	\N
232237	1678	1440031081000	1444	693	47	0	\N
232238	1678	1440031082000	1444	693	48	0	\N
232239	1678	1440031083000	1444	693	49	0	\N
232240	1678	1440031084000	1444	693	50	0	\N
232241	1678	1440031085000	1444	693	51	0	\N
232242	1678	1440031086000	1444	693	52	0	\N
232243	1678	1440031087000	1444	693	53	0	\N
232244	1745	2000000	1444	693	54	0	\N
232245	1678	2160041086000	1445	785	0	0	\N
232246	1678	2160041087000	1445	785	1	0	\N
232249	1678	2160041089000	1448	787	0	0	\N
232261	1678	2160041097000	1455	793	0	0	\N
232262	1750	7500000000	1455	793	1	0	\N
232263	1678	2160041097000	1456	793	0	0	\N
232264	1750	7500000000	1456	793	1	0	\N
232265	1678	2160041097000	1457	793	0	0	\N
232266	1750	7500000000	1457	793	1	0	\N
232268	1678	2160041099000	1459	795	0	0	\N
232269	1678	2160041100000	1459	795	1	0	\N
232270	1678	2160041101000	1459	795	2	0	\N
232271	1678	2160041102000	1459	795	3	0	\N
232277	1678	2160041103000	1462	796	0	0	\N
232284	563	66000528000000	1469	694	0	0	\N
232285	1678	1440031088000	1469	694	1	0	\N
232286	1678	1440031089000	1469	694	2	0	\N
232287	1678	1440031090000	1469	694	3	0	\N
232288	1678	1440031091000	1469	694	4	0	\N
232161	1678	1440031070000	1426	775	2	0	0
232162	1678	1440031071000	1427	776	0	0	0
232164	1678	1440031072000	1429	777	0	0	0
232165	1678	1440031073000	1430	778	0	0	0
232166	1678	1440031074000	1430	778	1	0	0
232168	1678	1440031076000	1431	779	0	0	0
232172	1678	2160041077000	1433	780	0	0	0
232173	1678	2160041078000	1433	780	1	0	0
232174	1678	2160041079000	1433	780	2	0	0
232176	1678	2160041080000	1435	781	0	0	0
232178	1678	2160041082000	1436	782	1	0	0
232179	1678	2160041083000	1437	783	0	0	0
232180	1678	2160041084000	1437	783	1	0	0
232183	1678	2160041085000	1439	784	0	0	0
232188	1678	2160041087000	1442	785	1	0	0
232247	1678	2160041088000	1446	786	0	0	0
232248	1678	2160041089000	1447	787	0	0	0
232250	1678	2160041090000	1449	788	0	0	0
232251	1678	2160041091000	1450	789	0	0	0
232253	1745	18007000000	1450	789	2	0	0
232254	1678	2160041093000	1451	790	0	0	0
232255	1678	2160041094000	1452	791	0	0	0
232256	563	66000528000000	1453	792	0	0	2
232257	1678	2160041095000	1453	792	1	0	0
232259	1678	2160041097000	1454	793	0	0	0
232260	1750	7500000000	1454	793	1	0	0
232267	1678	2160041098000	1458	794	0	0	0
232272	1678	2160041099000	1460	795	0	0	0
232274	1678	2160041101000	1460	795	2	0	0
232275	1678	2160041102000	1460	795	3	0	0
232276	1678	2160041103000	1461	796	0	0	0
232278	1678	2160041104000	1464	797	0	0	0
232279	1678	2160041105000	1465	798	0	0	0
232281	1678	2160041107000	1466	799	1	0	0
232282	1678	2160041108000	1467	800	0	0	0
232283	1678	2160041109000	1468	801	0	0	0
232289	1678	1440031092000	1469	694	5	0	\N
232290	1678	1440031093000	1469	694	6	0	\N
232291	1678	1440031094000	1469	694	7	0	\N
232292	1678	1440031095000	1469	694	8	0	\N
232293	1678	1440031096000	1469	694	9	0	\N
232294	1678	1440031097000	1469	694	10	0	\N
232295	1678	1440031098000	1469	694	12	0	\N
232296	1678	1440031099000	1469	694	13	0	\N
232297	1678	1440031100000	1469	694	14	0	\N
232298	1678	1440031101000	1469	694	15	0	\N
232299	1678	1440031102000	1469	694	16	0	\N
232300	1678	1440031103000	1469	694	17	0	\N
232301	1678	1440031104000	1469	694	18	0	\N
232302	1678	1440031105000	1469	694	19	0	\N
232303	1678	1440031106000	1469	694	20	0	\N
232304	1678	1440031107000	1469	694	21	0	\N
232305	1678	1440031108000	1469	694	22	0	\N
232306	1678	1440031109000	1469	694	23	0	\N
232307	1745	18007000000	1469	694	24	0	\N
232310	1678	2160041111000	1472	803	0	0	\N
232313	1678	2160041114000	1474	805	0	0	\N
232314	1678	2160041115000	1474	805	1	0	\N
232315	1678	2160041116000	1474	805	2	0	\N
232316	1678	2160041117000	1474	805	3	0	\N
232317	1678	2160041118000	1474	805	4	0	\N
232323	1678	2160041114000	1476	805	0	0	\N
232324	1678	2160041115000	1476	805	1	0	\N
232325	1678	2160041116000	1476	805	2	0	\N
232326	1678	2160041117000	1476	805	3	0	\N
232327	1678	2160041118000	1476	805	4	0	\N
232328	1678	2160041119000	1477	806	0	0	\N
232333	1678	2160041120000	1480	807	0	0	\N
232334	1678	2160041121000	1480	807	1	0	\N
232335	1752	100000000	1480	807	2	0	\N
232336	1678	2160041122000	1481	808	0	0	\N
232337	1678	2160041123000	1481	808	1	0	\N
232342	1678	2160041126000	1485	811	0	0	\N
232343	1735	1420000000000	1485	811	1	0	\N
232348	1678	2160041127000	1488	812	0	0	\N
232349	1678	2160041128000	1488	812	1	0	\N
232352	1678	2160041129000	1490	813	0	0	\N
232353	1745	8406000000	1490	813	1	0	\N
232358	1678	1440031110000	1495	695	0	0	\N
232359	1678	1440031111000	1495	695	1	0	\N
232360	1678	1440031112000	1495	695	2	0	\N
232361	1678	1440031113000	1495	695	3	0	\N
232362	1678	1440031114000	1495	695	4	0	\N
232363	1678	1440031115000	1495	695	5	0	\N
232364	1678	1440031116000	1495	695	6	0	\N
232365	1678	1440031117000	1495	695	7	0	\N
232366	1678	1440031118000	1495	695	8	0	\N
232367	1678	1440031119000	1495	695	9	0	\N
232368	1678	1440031120000	1495	695	10	0	\N
232369	1678	1440031121000	1495	695	11	0	\N
232370	1678	1440031122000	1495	695	12	0	\N
232371	1678	1440031123000	1495	695	13	0	\N
232372	1678	1440031124000	1495	695	14	0	\N
232373	1678	1440031125000	1495	695	15	0	\N
232374	1678	1440031126000	1495	695	16	0	\N
232375	1678	1440031127000	1495	695	17	0	\N
232376	1678	1440031128000	1495	695	18	0	\N
232377	1678	1440031129000	1495	695	19	0	\N
232378	1678	1440031130000	1495	695	20	0	\N
232379	1678	1440031131000	1495	695	21	0	\N
232380	1678	1440031132000	1495	695	22	0	\N
232381	1678	1440031133000	1495	695	23	0	\N
232382	1678	1440031134000	1495	695	24	0	\N
232383	1678	2160041134000	1496	818	0	0	\N
232384	1678	2160041135000	1496	818	1	0	\N
232385	1678	2160041136000	1496	818	2	0	\N
232386	1753	12000000000	1496	818	3	0	\N
232387	1678	2160041134000	1497	818	0	0	\N
232388	1678	2160041135000	1497	818	1	0	\N
232389	1678	2160041136000	1497	818	2	0	\N
232390	1753	12000000000	1497	818	3	0	\N
232404	1678	2160041144000	1507	826	0	0	\N
232405	1678	2160041144000	1508	826	0	0	\N
232406	1678	2160041144000	1509	826	0	0	\N
232407	1678	2160041145000	1510	827	0	0	\N
232408	1678	2160041146000	1510	827	1	0	\N
232409	1678	2160041145000	1511	827	0	0	\N
232410	1678	2160041146000	1511	827	1	0	\N
232413	1678	2160041147000	1513	828	0	0	\N
232414	1678	2160041148000	1513	828	1	0	\N
232424	1678	2160041154000	1518	831	0	0	\N
232311	1678	2160041112000	1473	804	0	0	0
232312	1678	2160041113000	1473	804	1	0	0
232318	1678	2160041114000	1475	805	0	0	0
232319	1678	2160041115000	1475	805	1	0	0
232320	1678	2160041116000	1475	805	2	0	0
232322	1678	2160041118000	1475	805	4	0	0
232329	1678	2160041119000	1478	806	0	0	0
232330	1678	2160041120000	1479	807	0	0	0
232331	1678	2160041121000	1479	807	1	0	0
232332	1752	100000000	1479	807	2	0	0
232339	1678	2160041123000	1482	808	1	0	0
232340	1678	2160041124000	1483	809	0	0	0
232341	1678	2160041125000	1484	810	0	0	0
232344	1678	2160041126000	1486	811	0	0	0
232346	1678	2160041127000	1487	812	0	0	0
232347	1678	2160041128000	1487	812	1	0	0
232350	1678	2160041129000	1489	813	0	0	0
232351	1745	8406000000	1489	813	1	0	2
232354	1678	2160041130000	1491	814	0	0	0
232356	1678	2160041132000	1493	816	0	0	0
232357	1678	2160041133000	1494	817	0	0	0
232391	1678	2160041134000	1498	818	0	0	0
232392	1678	2160041135000	1498	818	1	0	0
232393	1678	2160041136000	1498	818	2	0	0
232395	1678	2160041137000	1499	819	0	0	0
232396	1678	2160041138000	1500	820	0	0	0
232397	1753	1112000000000	1500	820	1	0	0
232398	1678	2160041139000	1501	821	0	0	0
232400	1678	2160041141000	1503	823	0	0	0
232401	1678	2160041142000	1504	824	0	0	0
232402	1678	2160041143000	1505	825	0	0	0
232403	1678	2160041144000	1506	826	0	0	0
232411	1678	2160041145000	1512	827	0	0	0
232415	1678	2160041147000	1514	828	0	0	0
232416	1678	2160041148000	1514	828	1	0	0
232417	1678	2160041149000	1515	829	0	0	0
232418	1678	2160041150000	1516	830	0	0	0
232419	1753	1435000000000	1516	830	1	0	0
232421	1678	2160041152000	1516	830	3	0	0
232422	1678	2160041153000	1516	830	4	0	0
232423	1678	2160041154000	1517	831	0	0	0
232425	1678	2160041155000	1519	832	0	0	\N
232426	1678	2160041156000	1519	832	1	0	\N
232429	1678	2160041157000	1521	833	0	0	\N
232430	1678	2160041158000	1521	833	1	0	\N
232433	1678	2160041157000	1523	833	0	0	\N
232434	1678	2160041158000	1523	833	1	0	\N
232440	1678	2160041160000	1526	835	0	0	\N
232441	1678	2160041161000	1526	835	1	0	\N
232442	1678	2160041162000	1526	835	2	0	\N
232443	1678	2160041163000	1526	835	3	0	\N
232446	1678	2160041165000	1529	837	0	0	\N
232447	1678	2160041165000	1530	837	0	0	\N
232449	1678	2160041167000	1532	839	0	0	\N
232450	1678	2160041167000	1533	839	0	0	\N
232452	1678	2160041168000	1535	840	0	0	\N
232453	1678	2160041168000	1536	840	0	0	\N
232456	1678	2160041170000	1539	842	0	0	\N
232457	1678	2160041169000	1541	841	0	0	\N
232459	1678	2160041171000	1545	843	0	0	\N
232461	1678	1440031135000	1547	696	0	0	\N
232462	1678	1440031136000	1547	696	1	0	\N
232463	1753	12000000000	1547	696	2	0	\N
232464	1678	1440031137000	1547	696	3	0	\N
232465	1678	1440031138000	1547	696	4	0	\N
232466	1678	1440031139000	1547	696	5	0	\N
232467	1678	1440031140000	1547	696	6	0	\N
232468	1678	1440031141000	1547	696	7	0	\N
232469	1753	1112000000000	1547	696	8	0	\N
232470	1753	1435000000000	1547	696	9	0	\N
232471	1678	1440031142000	1547	696	10	0	\N
232472	1678	1440031143000	1547	696	11	0	\N
232473	1678	1440031144000	1547	696	12	0	\N
232474	1678	1440031145000	1547	696	13	0	\N
232475	1678	1440031146000	1547	696	14	0	\N
232476	1678	1440031147000	1547	696	15	0	\N
232477	1678	1440031148000	1547	696	16	0	\N
232478	1678	1440031149000	1547	696	17	0	\N
232479	1678	1440031150000	1547	696	18	0	\N
232480	1678	1440031151000	1547	696	19	0	\N
232481	1678	1440031152000	1547	696	20	0	\N
232482	1678	1440031153000	1547	696	21	0	\N
232483	1678	1440031154000	1547	696	22	0	\N
232484	1678	1440031155000	1547	696	23	0	\N
232485	1678	1440031156000	1547	696	24	0	\N
232486	1678	1440031157000	1547	696	25	0	\N
232487	1678	1440031158000	1547	696	26	0	\N
232488	1678	1440031159000	1547	696	27	0	\N
232489	1678	1440031160000	1547	696	28	0	\N
232490	1678	1440031161000	1547	696	29	0	\N
232491	1678	1440031162000	1547	696	30	0	\N
232492	1678	1440031163000	1547	696	31	0	\N
232493	1678	1440031164000	1547	696	32	0	\N
232494	1678	1440031165000	1547	696	33	0	\N
232495	1678	1440031166000	1547	696	34	0	\N
232496	1678	1440031167000	1547	696	35	0	\N
232497	1678	1440031168000	1547	696	36	0	\N
232498	1678	1440031169000	1547	696	37	0	\N
232499	1678	1440031170000	1547	696	38	0	\N
232500	1678	1440031171000	1547	696	39	0	\N
232502	1678	2160041172000	1549	844	0	0	\N
232503	1678	2160041173000	1553	846	0	0	\N
232504	1678	2160041174000	1553	846	1	0	\N
232505	1678	2160041175000	1553	846	2	0	\N
232506	1678	2160041173000	1554	846	0	0	\N
232507	1678	2160041174000	1554	846	1	0	\N
232508	1678	2160041175000	1554	846	2	0	\N
232512	1678	2160041173000	1556	846	0	0	\N
232513	1678	2160041174000	1556	846	1	0	\N
232514	1678	2160041175000	1556	846	2	0	\N
232519	1678	2160041178000	1560	849	0	0	\N
232520	1678	2160041179000	1560	849	1	0	\N
232522	1678	2160041180000	1562	850	0	0	\N
232524	1678	2160041181000	1564	851	0	0	\N
232525	1678	2160041182000	1565	852	0	0	\N
232531	1678	2160041186000	1570	855	0	0	\N
232533	1678	2160041187000	1572	856	0	0	\N
232535	1678	2160041188000	1574	857	0	0	\N
232537	1678	2160041189000	1576	858	0	0	\N
232539	1678	2160041190000	1578	859	0	0	\N
232540	1678	2160041190000	1579	859	0	0	\N
232541	1678	2160041191000	1580	860	0	0	\N
232542	1678	2160041192000	1580	860	1	0	\N
232543	1678	2160041193000	1580	860	2	0	\N
232547	1678	2160041194000	1582	861	0	0	\N
232548	1678	2160041194000	1583	861	0	0	\N
232550	1678	2160041194000	1585	861	0	0	\N
232552	1678	2160041195000	1587	862	0	0	\N
232553	1678	2160041196000	1588	863	0	0	\N
232558	1678	2160041200000	1592	866	0	0	\N
232559	1678	2160041200000	1593	866	0	0	\N
232560	563	66000528000000	1594	785	0	0	\N
232431	1678	2160041157000	1522	833	0	0	0
232432	1678	2160041158000	1522	833	1	0	0
232435	1678	2160041159000	1524	834	0	0	0
232436	1678	2160041160000	1525	835	0	0	0
232437	1678	2160041161000	1525	835	1	0	0
232439	1678	2160041163000	1525	835	3	0	0
232444	1678	2160041164000	1527	836	0	0	0
232445	1678	2160041165000	1528	837	0	0	0
232448	1678	2160041166000	1531	838	0	0	0
232451	1678	2160041167000	1534	839	0	0	0
232455	1678	2160041169000	1538	841	0	0	0
232458	1678	2160041170000	1542	842	0	0	0
232460	1678	2160041171000	1546	843	0	0	0
232501	1678	2160041172000	1548	844	0	0	0
232510	1678	2160041174000	1555	846	1	0	0
232511	1678	2160041175000	1555	846	2	0	0
232515	1678	2160041176000	1557	847	0	0	0
232516	1678	2160041177000	1558	848	0	0	0
232517	1678	2160041178000	1559	849	0	0	0
232521	1678	2160041180000	1561	850	0	0	0
232523	1678	2160041181000	1563	851	0	0	0
232526	1678	2160041182000	1566	852	0	0	0
232527	1678	2160041183000	1567	853	0	0	0
232528	1678	2160041184000	1567	853	1	0	0
232530	1678	2160041186000	1569	855	0	0	0
232532	1678	2160041187000	1571	856	0	0	0
232534	1678	2160041188000	1573	857	0	0	0
232536	1678	2160041189000	1575	858	0	0	0
232544	1678	2160041191000	1581	860	0	0	0
232545	1678	2160041192000	1581	860	1	0	0
232546	1678	2160041193000	1581	860	2	0	0
232549	1678	2160041194000	1584	861	0	0	0
232551	1678	2160041195000	1586	862	0	0	0
232555	1678	2160041197000	1590	864	0	0	0
232556	1678	2160041198000	1591	865	0	0	0
232557	1678	2160041199000	1591	865	1	0	0
232561	1678	2160041086000	1594	785	1	0	\N
232562	1753	12000000000	1594	785	2	0	\N
232563	1753	1112000000000	1594	785	3	0	\N
232564	1753	1435000000000	1594	785	4	0	\N
232565	1678	2160041087000	1594	785	5	0	\N
232566	1678	2160041088000	1594	785	6	0	\N
232567	1678	2160041089000	1594	785	7	0	\N
232568	1678	2160041090000	1594	785	8	0	\N
232569	1678	2160041091000	1594	785	9	0	\N
232570	1678	2160041092000	1594	785	10	0	\N
232571	1678	2160041093000	1594	785	11	0	\N
232572	1678	2160041094000	1594	785	12	0	\N
232573	1678	2160041095000	1594	785	13	0	\N
232574	1678	2160041096000	1594	785	14	0	\N
232575	1678	2160041097000	1594	785	15	0	\N
232576	1678	2160041098000	1594	785	16	0	\N
232577	1678	2160041099000	1594	785	17	0	\N
232578	1678	2160041100000	1594	785	18	0	\N
232579	1678	2160041101000	1594	785	19	0	\N
232580	1678	2160041102000	1594	785	20	0	\N
232581	1678	2160041103000	1594	785	21	0	\N
232582	1678	2160041104000	1594	785	22	0	\N
232583	1678	2160041105000	1594	785	23	0	\N
232584	1678	2160041106000	1594	785	24	0	\N
232585	1678	2160041107000	1594	785	25	0	\N
232586	1678	2160041108000	1594	785	26	0	\N
232587	1678	2160041109000	1594	785	27	0	\N
232588	1678	2160041110000	1594	785	28	0	\N
232589	1678	2160041111000	1594	785	29	0	\N
232590	1678	2160041112000	1594	785	30	0	\N
232591	1678	2160041113000	1594	785	31	0	\N
232592	1678	2160041114000	1594	785	32	0	\N
232593	1678	2160041115000	1594	785	33	0	\N
232594	1678	2160041116000	1594	785	34	0	\N
232595	1678	2160041117000	1594	785	35	0	\N
232596	1678	2160041118000	1594	785	36	0	\N
232597	1678	2160041119000	1594	785	37	0	\N
232598	1678	2160041120000	1594	785	38	0	\N
232599	1678	2160041121000	1594	785	39	0	\N
232600	1678	2160041122000	1594	785	40	0	\N
232601	1678	2160041123000	1594	785	41	0	\N
232602	1678	2160041124000	1594	785	42	0	\N
232603	1678	2160041125000	1594	785	43	0	\N
232604	1678	2160041126000	1594	785	44	0	\N
232605	1678	2160041127000	1594	785	45	0	\N
232606	1678	2160041128000	1594	785	46	0	\N
232607	1678	2160041129000	1594	785	47	0	\N
232608	1678	2160041130000	1594	785	48	0	\N
232609	1678	2160041131000	1594	785	49	0	\N
232610	1678	2160041132000	1594	785	50	0	\N
232611	1678	2160041133000	1594	785	51	0	\N
232612	1678	2160041134000	1594	785	52	0	\N
232613	1678	2160041135000	1594	785	53	0	\N
232614	1678	2160041136000	1594	785	54	0	\N
232615	1678	2160041137000	1594	785	55	0	\N
232616	1678	2160041138000	1594	785	56	0	\N
232617	1678	2160041139000	1594	785	57	0	\N
232618	1678	2160041140000	1594	785	58	0	\N
232619	1678	2160041141000	1594	785	59	0	\N
232620	1678	2160041142000	1594	785	60	0	\N
232621	1678	2160041143000	1594	785	61	0	\N
232622	1678	2160041144000	1594	785	62	0	\N
232623	1678	2160041145000	1594	785	63	0	\N
232624	1678	2160041146000	1594	785	64	0	\N
232625	1678	2160041147000	1594	785	65	0	\N
232626	1678	2160041148000	1594	785	66	0	\N
232627	1678	2160041149000	1594	785	67	0	\N
232628	1678	2160041150000	1594	785	68	0	\N
232629	1678	2160041151000	1594	785	69	0	\N
232630	1678	2160041152000	1594	785	70	0	\N
232631	1678	2160041153000	1594	785	71	0	\N
232632	1678	2160041154000	1594	785	72	0	\N
232633	1678	2160041155000	1594	785	73	0	\N
232634	1678	2160041156000	1594	785	74	0	\N
232635	1678	2160041157000	1594	785	75	0	\N
232636	1678	2160041158000	1594	785	76	0	\N
232637	1678	2160041159000	1594	785	77	0	\N
232638	1678	2160041160000	1594	785	78	0	\N
232639	1678	2160041161000	1594	785	79	0	\N
232640	1678	2160041162000	1594	785	80	0	\N
232641	1678	2160041163000	1594	785	81	0	\N
232642	1678	2160041164000	1594	785	82	0	\N
232643	1678	2160041165000	1594	785	83	0	\N
232644	1678	2160041166000	1594	785	84	0	\N
232645	1678	2160041167000	1594	785	85	0	\N
232646	1678	2160041168000	1594	785	86	0	\N
232647	1678	2160041169000	1594	785	87	0	\N
232648	1678	2160041200000	1595	866	0	0	\N
232649	1678	2160041200000	1596	866	0	0	\N
232650	1678	2160041200000	1597	866	0	0	\N
232652	1678	2160041200000	1599	866	0	0	\N
232653	1678	2160041171000	1600	843	0	0	\N
232654	1678	2160041172000	1600	843	1	0	\N
232655	1678	2160041173000	1600	843	2	0	\N
232656	1678	2160041174000	1600	843	3	0	\N
232657	1678	2160041175000	1600	843	4	0	\N
232658	1678	2160041176000	1600	843	5	0	\N
232659	1678	2160041201000	1601	867	0	0	\N
232660	1678	2160041202000	1601	867	1	0	\N
232661	1678	2160041201000	1602	867	0	0	\N
232662	1678	2160041202000	1602	867	1	0	\N
232663	1678	2160041190000	1603	859	0	0	\N
232664	1678	2160041191000	1603	859	1	0	\N
232665	1678	2160041192000	1603	859	2	0	\N
232666	1678	2160041193000	1603	859	3	0	\N
232667	1678	2160041194000	1603	859	4	0	\N
232668	1678	2160041195000	1603	859	5	0	\N
232669	1678	2160041196000	1603	859	6	0	\N
232670	1678	2160041197000	1603	859	7	0	\N
232671	1678	2160041198000	1603	859	8	0	\N
232672	1678	2160041199000	1603	859	9	0	\N
232673	1678	2160041200000	1603	859	10	0	\N
232676	1678	2160041203000	1605	868	0	0	\N
232677	1678	2160041204000	1605	868	1	0	\N
232681	563	66000528000000	1608	783	0	0	\N
232682	1753	12000000000	1608	783	1	0	\N
232683	1753	1112000000000	1608	783	2	0	\N
232684	1753	1435000000000	1608	783	3	0	\N
232685	1678	2160041083000	1608	783	4	0	\N
232686	1678	2160041084000	1608	783	5	0	\N
232687	1678	2160041085000	1608	783	6	0	\N
232688	1678	2160041086000	1608	783	7	0	\N
232689	1678	2160041087000	1608	783	8	0	\N
232690	1678	2160041088000	1608	783	9	0	\N
232691	1678	2160041089000	1608	783	10	0	\N
232692	1678	2160041090000	1608	783	11	0	\N
232693	1678	2160041091000	1608	783	12	0	\N
232694	1678	2160041092000	1608	783	13	0	\N
232695	1678	2160041093000	1608	783	14	0	\N
232696	1678	2160041094000	1608	783	15	0	\N
232675	1678	2160041202000	1604	867	1	0	0
232678	1678	2160041203000	1606	868	0	0	0
232679	1678	2160041204000	1606	868	1	0	0
232680	1678	2160041205000	1607	869	0	0	0
232697	1678	2160041095000	1608	783	16	0	\N
232698	1678	2160041096000	1608	783	17	0	\N
232699	1678	2160041097000	1608	783	18	0	\N
232700	1678	2160041098000	1608	783	19	0	\N
232701	1678	2160041099000	1608	783	20	0	\N
232702	1678	2160041100000	1608	783	21	0	\N
232703	1678	2160041101000	1608	783	22	0	\N
232704	1678	2160041102000	1608	783	23	0	\N
232705	1678	2160041103000	1608	783	24	0	\N
232706	1678	2160041104000	1608	783	25	0	\N
232707	1678	2160041105000	1608	783	26	0	\N
232708	1678	2160041106000	1608	783	27	0	\N
232709	1678	2160041107000	1608	783	28	0	\N
232710	1678	2160041108000	1608	783	29	0	\N
232711	1678	2160041109000	1608	783	30	0	\N
232712	1678	2160041110000	1608	783	31	0	\N
232713	1678	2160041111000	1608	783	32	0	\N
232714	1678	2160041112000	1608	783	33	0	\N
232715	1678	2160041113000	1608	783	34	0	\N
232716	1678	2160041114000	1608	783	35	0	\N
232717	1678	2160041115000	1608	783	36	0	\N
232718	1678	2160041116000	1608	783	37	0	\N
232719	1678	2160041117000	1608	783	38	0	\N
232720	1678	2160041118000	1608	783	39	0	\N
232721	1678	2160041119000	1608	783	40	0	\N
232722	1678	2160041120000	1608	783	41	0	\N
232723	1678	2160041121000	1608	783	42	0	\N
232724	1678	2160041122000	1608	783	43	0	\N
232725	1678	2160041123000	1608	783	44	0	\N
232726	1678	2160041124000	1608	783	45	0	\N
232727	1678	2160041125000	1608	783	46	0	\N
232728	1678	2160041126000	1608	783	47	0	\N
232729	1678	2160041127000	1608	783	48	0	\N
232730	1678	2160041128000	1608	783	49	0	\N
232731	1678	2160041129000	1608	783	50	0	\N
232732	1678	2160041130000	1608	783	51	0	\N
232733	1678	2160041131000	1608	783	52	0	\N
232734	1678	2160041132000	1608	783	53	0	\N
232735	1678	2160041133000	1608	783	54	0	\N
232736	1678	2160041134000	1608	783	55	0	\N
232737	1678	2160041135000	1608	783	56	0	\N
232738	1678	2160041136000	1608	783	57	0	\N
232739	1678	2160041137000	1608	783	58	0	\N
232740	1678	2160041138000	1608	783	59	0	\N
232741	1678	2160041139000	1608	783	60	0	\N
232742	1678	2160041140000	1608	783	61	0	\N
232743	1678	2160041141000	1608	783	62	0	\N
232744	1678	2160041142000	1608	783	63	0	\N
232745	1678	2160041143000	1608	783	64	0	\N
232746	1678	2160041144000	1608	783	65	0	\N
232747	1678	2160041145000	1608	783	66	0	\N
232748	1678	2160041146000	1608	783	67	0	\N
232749	1678	2160041147000	1608	783	68	0	\N
232750	1678	2160041148000	1608	783	69	0	\N
232751	1678	2160041149000	1608	783	70	0	\N
232752	1678	2160041150000	1608	783	71	0	\N
232753	1678	2160041151000	1608	783	72	0	\N
232754	1678	2160041152000	1608	783	73	0	\N
232755	1678	2160041153000	1608	783	74	0	\N
232756	1678	2160041154000	1608	783	75	0	\N
232757	1678	2160041155000	1608	783	76	0	\N
232758	1678	2160041156000	1608	783	77	0	\N
232759	1678	2160041157000	1608	783	78	0	\N
232760	1678	2160041158000	1608	783	79	0	\N
232761	1678	2160041159000	1608	783	80	0	\N
232762	1678	2160041160000	1608	783	81	0	\N
232763	1678	2160041161000	1608	783	82	0	\N
232764	1678	2160041162000	1608	783	83	0	\N
232765	1678	2160041163000	1608	783	84	0	\N
232766	1678	2160041164000	1608	783	85	0	\N
232767	1678	2160041165000	1608	783	86	0	\N
232768	1678	2160041166000	1608	783	87	0	\N
232769	1678	2160041167000	1608	783	88	0	\N
232770	1678	2160041168000	1608	783	89	0	\N
232771	1678	2160041169000	1608	783	90	0	\N
232772	1678	2160041170000	1608	783	91	0	\N
232773	1678	2160041171000	1608	783	92	0	\N
232774	1678	2160041172000	1608	783	93	0	\N
232775	1678	2160041173000	1608	783	94	0	\N
232776	1678	2161006174000	1608	783	96	0	\N
232777	1678	2161006175000	1608	783	97	0	\N
232778	1678	2161006176000	1608	783	98	0	\N
232779	1678	2161006177000	1608	783	99	0	\N
232780	1678	2161006178000	1608	783	100	0	\N
232781	1678	2161006179000	1608	783	101	0	\N
232782	1678	2161006180000	1608	783	102	0	\N
232783	1678	2161006181000	1608	783	103	0	\N
232784	1678	2161006182000	1608	783	104	0	\N
232785	1678	2161006183000	1608	783	105	0	\N
232786	1678	2161006184000	1608	783	106	0	\N
232787	1678	2161006185000	1608	783	107	0	\N
232788	1678	2161006186000	1608	783	108	0	\N
232789	1678	2161006187000	1608	783	109	0	\N
232790	1678	2161006188000	1608	783	110	0	\N
232791	1678	2161006189000	1608	783	111	0	\N
232792	1678	2161006190000	1608	783	112	0	\N
232793	1678	2161006191000	1608	783	113	0	\N
232794	1678	2161006192000	1608	783	114	0	\N
232795	1678	2161006193000	1608	783	115	0	\N
232796	1678	2161006194000	1608	783	116	0	\N
232797	1678	2161006195000	1608	783	117	0	\N
232798	1678	2161006196000	1608	783	118	0	\N
232799	1678	2161006197000	1608	783	119	0	\N
232800	1678	2161006198000	1608	783	120	0	\N
232801	1678	2161006199000	1608	783	121	0	\N
232802	1678	2161006200000	1608	783	122	0	\N
232803	1678	2161006201000	1608	783	123	0	\N
232804	1678	2161006202000	1608	783	124	0	\N
232805	1678	2161006203000	1608	783	125	0	\N
232809	1678	2160041209000	1612	872	0	0	\N
232810	1678	2160041210000	1612	872	1	0	\N
232811	1678	2160041211000	1612	872	2	0	\N
232812	1678	2160041212000	1612	872	3	0	\N
232817	1678	2160041213000	1614	873	0	0	\N
232819	1678	2160041213000	1616	873	0	0	\N
232821	1678	2160041214000	1618	874	0	0	\N
232822	1678	2160041214000	1619	874	0	0	\N
232824	1678	2160041215000	1621	875	0	0	\N
232825	1678	2160041216000	1622	876	0	0	\N
232826	1678	2160041216000	1623	876	0	0	\N
232827	1678	1440031172000	1624	697	0	0	\N
232828	1678	1440031173000	1624	697	1	0	\N
232829	1678	1440031174000	1624	697	2	0	\N
232830	1678	1440031175000	1624	697	3	0	\N
232831	1678	1440031176000	1624	697	4	0	\N
232832	1678	1440031177000	1624	697	5	0	\N
232808	1678	2160041208000	1610	871	0	0	0
232813	1678	2160041209000	1613	872	0	0	0
232814	1678	2160041210000	1613	872	1	0	0
232815	1678	2160041211000	1613	872	2	0	0
232816	1678	2160041212000	1613	872	3	0	0
232820	1678	2160041214000	1617	874	0	0	0
232823	1678	2160041215000	1620	875	0	0	0
232833	1678	1440031178000	1624	697	6	0	\N
232834	1678	1440031179000	1624	697	7	0	\N
232835	1678	1440031180000	1624	697	8	0	\N
232836	1678	1440031181000	1624	697	9	0	\N
232837	1678	1440031182000	1624	697	10	0	\N
232838	1678	1440031183000	1624	697	11	0	\N
232839	1678	1440031184000	1624	697	12	0	\N
232840	1678	1440031185000	1624	697	13	0	\N
232841	1678	1440031186000	1624	697	14	0	\N
232842	1678	1440031187000	1624	697	15	0	\N
232843	1678	1440031188000	1624	697	16	0	\N
232844	1678	1440031189000	1624	697	17	0	\N
232845	1678	1440031190000	1624	697	18	0	\N
232846	1678	1440031191000	1624	697	19	0	\N
232847	1678	1440031192000	1624	697	20	0	\N
232848	1678	1440031193000	1624	697	21	0	\N
232849	1678	1440031194000	1624	697	22	0	\N
232850	1678	1440031195000	1624	697	23	0	\N
232851	1678	1440031196000	1624	697	24	0	\N
232852	1678	1440031197000	1624	697	25	0	\N
232853	1678	1440031198000	1624	697	26	0	\N
232854	1678	1440031199000	1624	697	27	0	\N
232855	1678	1440031200000	1624	697	28	0	\N
232856	1678	1440031201000	1624	697	29	0	\N
232857	1678	1440031202000	1624	697	30	0	\N
232858	1678	1440031203000	1624	697	31	0	\N
232859	1678	1440031204000	1624	697	32	0	\N
232860	1678	1440031205000	1624	697	33	0	\N
232861	1678	1440031206000	1624	697	34	0	\N
232862	1678	1440031207000	1624	697	35	0	\N
232863	1678	1440031208000	1624	697	36	0	\N
232864	1678	1440031209000	1624	697	37	0	\N
232865	1678	1440031210000	1624	697	38	0	\N
232866	1678	1440031211000	1624	697	39	0	\N
232867	1678	1440031212000	1624	697	40	0	\N
232868	1678	1440031213000	1624	697	41	0	\N
232869	1678	1440031214000	1624	697	42	0	\N
232870	1678	1440031215000	1624	697	44	0	\N
232871	1678	1440031216000	1624	697	45	0	\N
232875	1678	2160041218000	1628	878	0	0	\N
232876	1678	2160041219000	1629	879	0	0	\N
232877	1678	2160041219000	1630	879	0	0	\N
232878	1678	2160041219000	1631	879	0	0	\N
232880	1678	2160041220000	1633	880	0	0	\N
232881	1678	2160041221000	1633	880	1	0	\N
232887	1678	2160041224000	1637	882	0	0	\N
232890	1678	2160041227000	1640	885	0	0	\N
232891	1678	2160041227000	1641	885	0	0	\N
232892	1678	2160041227000	1642	885	0	0	\N
232895	1678	2160041228000	1645	886	0	0	\N
232896	1678	1440031217000	1647	698	0	0	\N
232897	1678	1440031218000	1647	698	1	0	\N
232898	1678	1440031219000	1647	698	2	0	\N
232899	1678	1440031220000	1647	698	3	0	\N
232900	1678	1440031221000	1647	698	4	0	\N
232901	1678	1440031222000	1647	698	5	0	\N
232902	1678	1440031223000	1647	698	6	0	\N
232903	1678	1440031224000	1647	698	7	0	\N
232904	1678	1440031225000	1647	698	8	0	\N
232905	1678	1440031226000	1647	698	9	0	\N
232906	1678	1440031227000	1647	698	10	0	\N
232907	1678	1440031228000	1647	698	11	0	\N
232910	1678	2160041230000	1650	888	0	0	\N
232912	1678	2160041232000	1652	890	0	0	\N
232914	1678	1440031229000	1654	699	0	0	\N
232915	1678	1440031230000	1654	699	1	0	\N
232916	1678	1440031231000	1654	699	2	0	\N
232917	1678	1440031232000	1654	699	3	0	\N
232918	1678	1440031233000	1654	699	4	0	\N
232922	1678	2160041236000	1657	893	0	0	\N
232923	1678	2160041236000	1658	893	0	0	\N
232929	1678	2160041237000	1661	894	0	0	\N
232930	1678	2160041238000	1661	894	1	0	\N
232931	1678	2160041239000	1661	894	2	0	\N
232932	1678	2160041240000	1661	894	3	0	\N
232933	1678	2160041237000	1662	894	0	0	\N
232934	1678	2160041238000	1662	894	1	0	\N
232935	1678	2160041239000	1662	894	2	0	\N
232936	1678	2160041240000	1662	894	3	0	\N
232939	1678	2160041230000	1664	888	0	0	\N
232940	1678	2160041231000	1664	888	1	0	\N
232941	1678	2160041232000	1664	888	2	0	\N
232942	1678	2160041233000	1664	888	3	0	\N
232943	1678	2160041234000	1664	888	4	0	\N
232944	1678	2160041235000	1664	888	5	0	\N
232945	1678	2160041236000	1664	888	6	0	\N
232946	1678	2160041237000	1664	888	7	0	\N
232947	1678	2160041238000	1664	888	8	0	\N
232948	1678	2160041239000	1664	888	9	0	\N
232949	1678	2160041240000	1664	888	10	0	\N
232950	1678	2160041241000	1664	888	11	0	\N
232951	1678	2160041242000	1664	888	12	0	\N
232952	1678	2160041241000	1665	895	0	0	\N
232953	1678	2160041242000	1665	895	1	0	\N
232954	1678	2160041241000	1666	895	0	0	\N
232955	1678	2160041242000	1666	895	1	0	\N
232956	1678	2160041241000	1667	895	0	0	\N
232957	1678	2160041242000	1667	895	1	0	\N
232958	1678	2160041243000	1668	896	0	0	\N
232959	1678	2160041244000	1668	896	1	0	\N
232965	1678	2160041247000	1672	898	0	0	\N
232874	1678	2160041218000	1627	878	0	0	0
232879	1678	2160041219000	1632	879	0	0	0
232882	1678	2160041220000	1634	880	0	0	0
232883	1678	2160041221000	1634	880	1	0	0
232884	1678	2160041222000	1635	881	0	0	0
232886	1678	2160041224000	1636	882	0	0	0
232888	1678	2160041225000	1638	883	0	0	0
232889	1678	2160041226000	1639	884	0	0	0
232893	1678	2160041227000	1643	885	0	0	0
232894	1678	2160041228000	1644	886	0	0	0
232909	1678	2160041230000	1649	888	0	0	0
232911	1678	2160041231000	1651	889	0	0	0
232913	1678	2160041232000	1653	890	0	0	0
232919	1678	2160041233000	1655	891	0	0	0
232921	1678	2160041235000	1656	892	1	0	0
232924	1678	2160041236000	1659	893	0	0	0
232925	1678	2160041237000	1660	894	0	0	0
232926	1678	2160041238000	1660	894	1	0	0
232927	1678	2160041239000	1660	894	2	0	0
232937	1678	2160041241000	1663	895	0	0	0
232938	1678	2160041242000	1663	895	1	0	0
232960	1678	2160041243000	1669	896	0	0	0
232961	1678	2160041244000	1669	896	1	0	0
232962	1678	2160041245000	1670	897	0	0	0
232964	1678	2160041247000	1671	898	0	0	0
232966	1678	2160041248000	1673	899	0	0	0
232967	1678	2160041249000	1673	899	1	0	0
232968	1678	2160041250000	1673	899	2	0	0
232970	1678	2160041248000	1674	899	0	0	\N
232971	1678	2160041249000	1674	899	1	0	\N
232972	1678	2160041250000	1674	899	2	0	\N
232973	1678	2160041251000	1674	899	3	0	\N
232974	1678	2160041248000	1675	899	0	0	\N
232975	1678	2160041249000	1675	899	1	0	\N
232976	1678	2160041250000	1675	899	2	0	\N
232977	1678	2160041251000	1675	899	3	0	\N
232979	1678	2160041252000	1677	900	0	0	\N
232980	1678	2160041253000	1678	901	0	0	\N
232983	1678	2160041255000	1682	903	0	0	\N
232987	1678	2160041258000	1686	906	0	0	\N
232993	1678	1440031234000	1691	700	0	0	\N
232994	1678	1440031235000	1691	700	1	0	\N
232995	1678	1440031236000	1691	700	2	0	\N
232996	1678	1440031237000	1691	700	3	0	\N
232997	1678	1440031238000	1691	700	4	0	\N
232998	1678	1440031239000	1691	700	5	0	\N
232999	1678	1440031240000	1691	700	6	0	\N
233000	1678	1440031241000	1691	700	7	0	\N
233001	1678	2160041263000	1692	910	0	0	\N
233002	1678	2160041264000	1692	910	1	0	\N
233013	1401	0	1701	889	0	0	\N
233014	1401	0	1701	889	1	0	\N
233015	1678	2160041243000	1701	889	2	0	\N
233016	1678	2160041244000	1701	889	3	0	\N
233017	1678	2160041245000	1701	889	4	0	\N
233018	1678	2160041246000	1701	889	5	0	\N
233019	1678	2160041247000	1701	889	6	0	\N
233020	1678	2160041248000	1701	889	7	0	\N
233021	1678	2160041249000	1701	889	8	0	\N
233022	1678	2160041250000	1701	889	9	0	\N
233023	1678	2160041251000	1701	889	10	0	\N
233024	1678	2160041252000	1701	889	11	0	\N
233025	1678	2160041253000	1701	889	12	0	\N
233026	1678	2160041254000	1701	889	13	0	\N
233027	1678	2160041255000	1701	889	14	0	\N
233028	1678	2160041256000	1701	889	15	0	\N
233029	1678	2160041257000	1701	889	16	0	\N
233030	1678	2160041258000	1701	889	17	0	\N
233031	1678	2160041259000	1701	889	18	0	\N
233032	1678	2160041260000	1701	889	19	0	\N
233033	1678	2160041261000	1701	889	20	0	\N
233034	1678	2160041262000	1701	889	21	0	\N
233035	1678	2160041263000	1701	889	22	0	\N
233036	1678	2160041264000	1701	889	23	0	\N
233037	1678	2160041265000	1701	889	24	0	\N
233038	1678	2160041266000	1701	889	25	0	\N
233039	1678	2160041267000	1701	889	26	0	\N
233040	1678	2160041268000	1701	889	27	0	\N
233041	1678	2160041269000	1701	889	28	0	\N
233042	1678	2160041270000	1701	889	29	0	\N
233043	1678	2160041271000	1701	889	30	0	\N
233044	1678	2160041271000	1702	916	0	0	\N
233045	1678	2160041271000	1703	916	0	0	\N
233046	1678	2160041271000	1704	916	0	0	\N
233049	1678	2160041271000	1707	917	0	0	\N
233050	1678	2160041272000	1707	917	1	0	\N
233051	1678	2881306204000	1708	784	0	0	\N
233052	1678	2881306205000	1708	784	1	0	\N
233053	1678	2881306206000	1708	784	2	0	\N
233054	1678	2881306207000	1708	784	3	0	\N
233055	1678	2881306208000	1708	784	4	0	\N
233056	1678	2881306209000	1708	784	5	0	\N
233057	1678	2881306210000	1708	784	6	0	\N
233058	1678	2881306211000	1708	784	7	0	\N
233059	1678	2881306212000	1708	784	8	0	\N
233060	1678	2881306213000	1708	784	9	0	\N
233061	1678	2881306214000	1708	784	10	0	\N
233062	1678	2881306215000	1708	784	11	0	\N
233063	1678	2881306216000	1708	784	12	0	\N
233064	1678	2881306217000	1708	784	13	0	\N
233065	1678	2881306218000	1708	784	14	0	\N
233066	1678	2881306219000	1708	784	15	0	\N
233067	1678	2881306220000	1708	784	16	0	\N
233068	1678	2881306221000	1708	784	17	0	\N
233069	1678	2881306222000	1708	784	18	0	\N
233070	1678	2881306223000	1708	784	19	0	\N
233071	1678	2881306224000	1708	784	20	0	\N
233072	1678	2881306225000	1708	784	21	0	\N
233073	1678	2881306226000	1708	784	22	0	\N
233074	1678	2881306227000	1708	784	23	0	\N
233075	1678	2881306228000	1708	784	24	0	\N
233076	1678	2881306229000	1708	784	25	0	\N
233077	1678	2881306230000	1708	784	26	0	\N
233078	1678	2881306231000	1708	784	27	0	\N
233079	1678	2881306232000	1708	784	28	0	\N
233080	1678	2881306233000	1708	784	29	0	\N
233081	1678	2881306234000	1708	784	30	0	\N
233082	1678	2881306235000	1708	784	31	0	\N
233083	1678	2881306236000	1708	784	32	0	\N
233084	1678	2881306237000	1708	784	33	0	\N
233085	1678	2881306238000	1708	784	34	0	\N
233086	1678	2881306239000	1708	784	35	0	\N
233087	1678	2881306240000	1708	784	36	0	\N
233088	1678	2881306241000	1708	784	37	0	\N
233089	1678	2881306242000	1708	784	38	0	\N
233090	1678	2881306243000	1708	784	39	0	\N
233091	1678	2881306244000	1708	784	40	0	\N
233092	1678	2881306245000	1708	784	41	0	\N
233093	1678	2881306246000	1708	784	42	0	\N
233094	1678	2881306247000	1708	784	43	0	\N
233095	1678	2881306248000	1708	784	44	0	\N
233096	1678	2881306249000	1708	784	45	0	\N
233097	1678	2881306250000	1708	784	46	0	\N
233098	1678	2881306251000	1708	784	47	0	\N
233099	1678	2881306252000	1708	784	48	0	\N
233100	1678	2881306253000	1708	784	49	0	\N
233101	1678	2881306254000	1708	784	50	0	\N
233102	1678	2881306255000	1708	784	51	0	\N
233103	1678	2881306256000	1708	784	52	0	\N
233104	1678	2881306257000	1708	784	53	0	\N
232981	1678	2160041253000	1679	901	0	0	0
232982	1678	2160041254000	1681	902	0	0	0
232984	1678	2160041255000	1683	903	0	0	0
232985	1678	2160041256000	1684	904	0	0	0
232986	1678	2160041257000	1685	905	0	0	0
232989	1678	2160041259000	1688	907	0	0	0
232990	1678	2160041260000	1689	908	0	0	0
232991	1678	2160041261000	1690	909	0	0	0
232992	1678	2160041262000	1690	909	1	0	0
233003	1678	2160041263000	1693	910	0	0	0
233005	1678	2160041265000	1694	911	0	0	0
233006	1678	2160041266000	1695	912	0	0	0
233007	1678	2160041267000	1696	913	0	0	0
233008	1401	0	1697	914	0	0	0
233010	1678	2160041268000	1697	914	2	0	0
233011	1678	2160041269000	1697	914	3	0	0
233012	1678	2160041270000	1698	915	0	0	0
233047	1678	2160041271000	1706	917	0	0	0
233048	1678	2160041272000	1706	917	1	0	0
233105	1678	2881306258000	1708	784	54	0	\N
233106	1678	2881306259000	1708	784	55	0	\N
233107	1678	2881306260000	1708	784	56	0	\N
233108	1678	2881306261000	1708	784	57	0	\N
233109	1678	2881306262000	1708	784	58	0	\N
233110	1678	2881306263000	1708	784	59	0	\N
233111	1678	2881306264000	1708	784	60	0	\N
233112	1678	2881306265000	1708	784	61	0	\N
233113	1678	2881306266000	1708	784	62	0	\N
233114	1678	2881306267000	1708	784	63	0	\N
233115	1678	2881306268000	1708	784	64	0	\N
233116	1678	2881306269000	1708	784	65	0	\N
233117	1678	2881306270000	1708	784	66	0	\N
233118	1678	2881306271000	1708	784	67	0	\N
233119	1678	2881306272000	1708	784	68	0	\N
233120	1678	2881306273000	1708	784	69	0	\N
233121	1745	18007000000	1708	784	70	0	\N
233122	1401	0	1708	784	71	0	\N
233123	1401	0	1708	784	72	0	\N
233128	1678	2160041276000	1710	919	0	0	\N
233129	1754	4000000000	1710	919	1	0	\N
233135	1678	2160041280000	1717	923	0	0	\N
233136	1401	0	1718	890	0	0	\N
233137	1678	2160041272000	1718	890	1	0	\N
233138	1678	2160041273000	1718	890	2	0	\N
233139	1678	2160041274000	1718	890	3	0	\N
233140	1754	4000000000	1718	890	4	0	\N
233141	1678	2160041275000	1718	890	5	0	\N
233142	1678	2160041276000	1718	890	6	0	\N
233143	1678	2160041277000	1718	890	7	0	\N
233144	1678	2160041278000	1718	890	8	0	\N
233145	1678	2160041279000	1718	890	9	0	\N
233146	1678	2160041280000	1718	890	10	0	\N
233147	1678	2160041280000	1719	923	0	0	\N
233153	1678	2160041281000	1722	924	0	0	\N
233154	1678	2160041282000	1722	924	1	0	\N
233155	1678	2160041283000	1722	924	2	0	\N
233156	1678	2160041284000	1722	924	3	0	\N
233159	1678	2160041285000	1724	925	0	0	\N
233160	1678	2160041286000	1724	925	1	0	\N
233164	1678	2160041281000	1728	891	0	0	\N
233165	1678	2160041282000	1728	891	1	0	\N
233166	1678	2160041283000	1728	891	2	0	\N
233167	1678	2160041284000	1728	891	3	0	\N
233168	1678	2160041285000	1728	891	4	0	\N
233169	1678	2160041286000	1728	891	5	0	\N
233170	1678	2160041287000	1728	891	6	0	\N
233171	1678	2160041288000	1728	891	7	0	\N
233172	1678	2160041289000	1728	891	8	0	\N
233174	1678	2160041291000	1730	930	0	0	\N
233175	1678	2160041292000	1730	930	1	0	\N
233178	1678	2160041293000	1732	931	0	0	\N
233179	1678	2160041293000	1733	931	0	0	\N
233180	1678	2160041293000	1734	931	0	0	\N
233182	1678	2160041294000	1736	932	0	0	\N
233184	1678	2160041295000	1739	933	0	0	\N
233187	1678	2160041295000	1741	934	0	0	\N
233188	1678	2160041296000	1741	934	1	0	\N
233189	1678	2160041297000	1742	935	0	0	\N
233192	1678	2160041298000	1745	936	0	0	\N
233195	1678	2160041299000	1747	937	0	0	\N
233196	1678	2160041300000	1747	937	1	0	\N
233197	1678	2160041299000	1748	937	0	0	\N
233198	1678	2160041300000	1748	937	1	0	\N
233199	1678	2160041299000	1749	937	0	0	\N
233200	1678	2160041300000	1749	937	1	0	\N
233201	1678	2160041301000	1750	938	0	0	\N
233202	1678	2160041301000	1751	938	0	0	\N
233205	1678	2160041302000	1754	939	0	0	\N
233207	1678	2160041303000	1756	940	0	0	\N
233210	1678	2160041304000	1758	941	0	0	\N
233211	1678	2160041305000	1758	941	1	0	\N
233213	1678	2160041306000	1760	942	0	0	\N
233214	1678	2160041306000	1761	942	0	0	\N
233230	1678	2160041322000	1773	952	0	0	\N
233231	1678	2160041322000	1774	952	0	0	\N
233232	1678	2160041322000	1775	952	0	0	\N
233235	1678	2160041323000	1778	953	0	0	\N
233236	1678	2160041323000	1779	953	0	0	\N
233237	1678	2160041323000	1780	953	0	0	\N
233240	1678	2160041324000	1782	954	0	0	\N
233126	1678	2160041274000	1709	918	2	0	0
233127	1678	2160041275000	1709	918	3	0	0
233130	1678	2160041276000	1711	919	0	0	0
233131	1754	4000000000	1711	919	1	0	0
233132	1678	2160041277000	1715	921	0	0	0
233134	1678	2160041279000	1716	922	0	0	0
233148	1678	2160041280000	1720	923	0	0	0
233149	1678	2160041281000	1721	924	0	0	0
233150	1678	2160041282000	1721	924	1	0	0
233151	1678	2160041283000	1721	924	2	0	0
233157	1678	2160041285000	1723	925	0	0	0
233158	1678	2160041286000	1723	925	1	0	0
233161	1678	2160041287000	1725	926	0	0	0
233162	1678	2160041288000	1726	927	0	0	0
233173	1678	2160041290000	1729	929	0	0	0
233176	1678	2160041291000	1731	930	0	0	0
233177	1678	2160041292000	1731	930	1	0	0
233181	1678	2160041293000	1735	931	0	0	0
233183	1678	2160041294000	1737	932	0	0	0
233186	1678	2160041296000	1740	934	1	0	0
233190	1678	2160041297000	1743	935	0	0	0
233191	1678	2160041298000	1744	936	0	0	0
233193	1678	2160041299000	1746	937	0	0	0
233194	1678	2160041300000	1746	937	1	0	0
233204	1678	2160041302000	1753	939	0	0	0
233206	1678	2160041303000	1755	940	0	0	0
233208	1678	2160041304000	1757	941	0	0	0
233209	1678	2160041305000	1757	941	1	0	0
233215	1678	2160041307000	1762	943	0	0	0
233216	1678	2160041308000	1762	943	1	0	0
233217	1678	2160041309000	1762	943	2	0	0
233218	1678	2160041310000	1763	944	0	0	0
233219	1678	2160041311000	1764	945	0	0	0
233221	1678	2160041313000	1767	947	0	0	0
233222	1678	2160041314000	1769	948	0	0	0
233223	1678	2160041315000	1770	949	0	0	0
233224	1678	2160041316000	1770	949	1	0	0
233225	1678	2160041317000	1770	949	2	0	0
233227	1678	2160041319000	1771	950	1	0	0
233228	1678	2160041320000	1772	951	0	0	0
233229	1678	2160041321000	1772	951	1	0	0
233233	1678	2160041322000	1776	952	0	0	0
233238	1678	2160041324000	1781	954	0	0	0
233239	1678	2160041325000	1781	954	1	0	0
233241	1678	2160041325000	1782	954	1	0	\N
233242	1678	2160041324000	1783	954	0	0	\N
233243	1678	2160041325000	1783	954	1	0	\N
233244	1678	2160041326000	1784	955	0	0	\N
233246	1678	2160041327000	1786	956	0	0	\N
233247	1678	2160041328000	1786	956	1	0	\N
233248	1678	2160041329000	1786	956	2	0	\N
233249	1678	2160041330000	1786	956	3	0	\N
233250	1678	2160041331000	1786	956	4	0	\N
233256	1678	2160041332000	1788	957	0	0	\N
233257	1678	2160041332000	1789	957	0	0	\N
233261	1678	2160041335000	1792	959	0	0	\N
233262	1678	2160041267000	1793	914	0	0	\N
233263	1754	4000000000	1793	914	1	0	\N
233264	1678	2160041268000	1793	914	2	0	\N
233265	1678	2160041269000	1793	914	3	0	\N
233266	1678	2160041270000	1793	914	4	0	\N
233267	1678	2160041271000	1793	914	5	0	\N
233268	1678	2160041272000	1793	914	6	0	\N
233269	1678	2160041273000	1793	914	7	0	\N
233270	1678	2160041274000	1793	914	8	0	\N
233271	1678	2160041275000	1793	914	9	0	\N
233272	1678	2160041276000	1793	914	10	0	\N
233273	1678	2160041277000	1793	914	11	0	\N
233274	1678	2160041278000	1793	914	12	0	\N
233275	1678	2160041279000	1793	914	13	0	\N
233276	1678	2160041280000	1793	914	14	0	\N
233277	1678	2160041281000	1793	914	15	0	\N
233278	1678	2160041282000	1793	914	16	0	\N
233279	1678	2160041283000	1793	914	17	0	\N
233280	1678	2160041284000	1793	914	18	0	\N
233281	1678	2160041285000	1793	914	19	0	\N
233282	1678	2160041286000	1793	914	20	0	\N
233283	1678	2160041287000	1793	914	21	0	\N
233284	1678	2160041288000	1793	914	22	0	\N
233285	1678	2160041289000	1793	914	23	0	\N
233286	1678	2160041290000	1793	914	24	0	\N
233287	1678	2160041291000	1793	914	25	0	\N
233288	1678	2160041335000	1795	959	0	0	\N
233296	1756	6479140000000	1799	962	0	0	\N
233297	1678	2160041339000	1799	962	1	0	\N
233298	1678	2160041340000	1799	962	2	0	\N
233300	1678	2160041342000	1801	964	0	0	\N
233302	1678	2160041342000	1803	964	0	0	\N
233303	1678	2160041343000	1804	965	0	0	\N
233304	1678	2160041344000	1804	965	1	0	\N
233305	1516	0	1804	965	2	0	\N
233310	1678	2160041346000	1807	967	0	0	\N
233312	1678	2160041347000	1809	968	0	0	\N
233313	1678	2160041347000	1810	968	0	0	\N
233317	1678	2160041350000	1813	970	0	0	\N
233319	1678	2160041351000	1815	971	0	0	\N
233320	1678	2160041352000	1815	971	1	0	\N
233329	1678	2160041358000	1821	975	0	0	\N
233330	1678	2160041358000	1824	975	0	0	\N
233331	1678	2160041358000	1825	975	0	0	\N
233334	1678	2160041361000	1828	978	0	0	\N
233336	1678	2160041361000	1830	978	0	0	\N
233337	1678	2160041362000	1831	979	0	0	\N
233338	1678	2160041362000	1832	979	0	0	\N
233339	1678	2160041362000	1833	979	0	0	\N
233343	1678	2160041364000	1837	981	0	0	\N
233345	1678	2160041366000	1839	983	0	0	\N
233348	1678	2160041367000	1842	984	0	0	\N
233349	1678	2160041368000	1843	985	0	0	\N
233351	1678	2160041367000	1845	984	0	0	\N
233352	1678	2160041368000	1845	984	1	0	\N
233353	1678	2160041369000	1846	986	0	0	\N
233354	1678	2160041369000	1847	986	0	0	\N
233356	1678	2160041369000	1849	986	0	0	\N
233357	1678	2160041370000	1850	987	0	0	\N
233359	1678	2160041370000	1852	987	0	0	\N
233360	1678	2160041371000	1853	988	0	0	\N
233362	1678	2160041372000	1855	989	0	0	\N
233367	1678	2160041374000	1859	991	0	0	\N
233368	1678	2160041375000	1859	991	1	0	\N
233369	1678	2160041374000	1860	991	0	0	\N
233370	1678	2160041375000	1860	991	1	0	\N
233371	1678	2160041376000	1861	992	0	0	\N
233373	1678	2160041377000	1863	993	0	0	\N
233376	1678	2160041378000	1866	994	0	0	\N
233252	1678	2160041328000	1787	956	1	0	0
233253	1678	2160041329000	1787	956	2	0	0
233254	1678	2160041330000	1787	956	3	0	0
233255	1678	2160041331000	1787	956	4	0	0
233258	1678	2160041332000	1790	957	0	0	0
233260	1678	2160041334000	1791	958	1	0	0
233289	1678	2160041335000	1796	960	0	0	0
233290	1678	2160041336000	1796	960	1	0	0
233291	1678	2160041337000	1796	960	2	0	0
233292	1678	2160041338000	1797	961	0	0	0
233294	1678	2160041339000	1798	962	1	0	0
233295	1678	2160041340000	1798	962	2	0	0
233299	1678	2160041341000	1800	963	0	0	0
233301	1678	2160041342000	1802	964	0	0	0
233307	1678	2160041344000	1805	965	1	0	0
233308	1516	0	1805	965	2	0	1
233309	1678	2160041345000	1806	966	0	0	0
233311	1678	2160041346000	1808	967	0	0	0
233314	1678	2160041347000	1811	968	0	0	0
233316	1678	2160041349000	1812	969	1	0	0
233318	1678	2160041350000	1814	970	0	0	0
233321	1678	2160041351000	1817	972	0	0	0
233322	1678	2160041352000	1817	972	1	0	0
233323	1678	2160041353000	1817	972	2	0	0
233325	1678	2160041355000	1818	973	0	0	0
233326	1678	2160041356000	1819	974	0	0	0
233327	1678	2160041357000	1819	974	1	0	0
233328	1678	2160041358000	1820	975	0	0	0
233333	1678	2160041360000	1827	977	0	0	0
233335	1678	2160041361000	1829	978	0	0	0
233340	1678	2160041362000	1835	980	0	0	0
233341	1678	2160041363000	1835	980	1	0	0
233342	1678	2160041364000	1836	981	0	0	0
233346	1678	2160041366000	1840	983	0	0	0
233347	1678	2160041367000	1841	984	0	0	0
233350	1678	2160041368000	1844	985	0	0	0
233355	1678	2160041369000	1848	986	0	0	0
233358	1678	2160041370000	1851	987	0	0	0
233363	1678	2160041372000	1856	989	0	0	0
233364	1678	2160041373000	1857	990	0	0	0
233365	1678	2160041374000	1858	991	0	0	0
233366	1678	2160041375000	1858	991	1	0	0
233374	1678	2160041377000	1864	993	0	0	0
233375	1678	2160041378000	1865	994	0	0	0
233378	1678	2160041297000	1868	935	0	0	\N
233379	1678	2160041298000	1868	935	1	0	\N
233380	1678	2160041299000	1868	935	2	0	\N
233381	1678	2160041300000	1868	935	3	0	\N
233382	1678	2160041301000	1868	935	4	0	\N
233383	1678	2160041302000	1868	935	5	0	\N
233384	1678	2160041303000	1868	935	6	0	\N
233385	1678	2160041304000	1868	935	7	0	\N
233386	1678	2160041305000	1868	935	8	0	\N
233387	1678	2160041306000	1868	935	9	0	\N
233388	1678	2160041307000	1868	935	10	0	\N
233389	1678	2160041308000	1868	935	11	0	\N
233390	1678	2160041309000	1868	935	12	0	\N
233391	1678	2160041310000	1868	935	13	0	\N
233392	1678	2160041311000	1868	935	14	0	\N
233393	1678	2160041312000	1868	935	15	0	\N
233394	1678	2160041313000	1868	935	16	0	\N
233395	1678	2160041314000	1868	935	17	0	\N
233396	1678	2160041315000	1868	935	18	0	\N
233397	1678	2160041316000	1868	935	19	0	\N
233398	1678	2160041317000	1868	935	20	0	\N
233399	1678	2160041318000	1868	935	21	0	\N
233400	1678	2160041319000	1868	935	22	0	\N
233401	1678	2160041320000	1868	935	23	0	\N
233402	1678	2160041321000	1868	935	24	0	\N
233403	1678	2160041322000	1868	935	25	0	\N
233404	1678	2160041323000	1868	935	26	0	\N
233405	1678	2160041324000	1868	935	27	0	\N
233406	1678	2160041325000	1868	935	28	0	\N
233407	1678	2160041326000	1868	935	29	0	\N
233408	1678	2160041327000	1868	935	30	0	\N
233409	1678	2160041328000	1868	935	31	0	\N
233410	1678	2160041329000	1868	935	32	0	\N
233411	1678	2160041330000	1868	935	33	0	\N
233412	1678	2160041331000	1868	935	34	0	\N
233413	1678	2160041332000	1868	935	35	0	\N
233414	1678	2160041333000	1868	935	36	0	\N
233415	1678	2160041334000	1868	935	37	0	\N
233416	1678	2160041335000	1868	935	38	0	\N
233417	1678	2160041336000	1868	935	39	0	\N
233418	1678	2160041337000	1868	935	40	0	\N
233419	1678	2160041338000	1868	935	41	0	\N
233420	1678	2160041339000	1868	935	42	0	\N
233421	1678	2160041340000	1868	935	43	0	\N
233422	1678	2160041341000	1868	935	44	0	\N
233423	1678	2160041342000	1868	935	45	0	\N
233424	1678	2160041343000	1868	935	46	0	\N
233425	1678	2160041344000	1868	935	47	0	\N
233426	1678	2160041345000	1868	935	48	0	\N
233427	1678	2160041346000	1868	935	49	0	\N
233428	1678	2160041347000	1868	935	50	0	\N
233429	1678	2160041348000	1868	935	51	0	\N
233430	1678	2160041349000	1868	935	52	0	\N
233431	1678	2160041350000	1868	935	53	0	\N
233432	1678	2160041351000	1868	935	54	0	\N
233433	1678	2160041352000	1868	935	55	0	\N
233434	1678	2160041353000	1868	935	56	0	\N
233435	1678	2160041354000	1868	935	57	0	\N
233436	1678	2160041355000	1868	935	58	0	\N
233437	1678	2160041356000	1868	935	59	0	\N
233438	1678	2160041357000	1868	935	60	0	\N
233439	1678	2160041358000	1868	935	61	0	\N
233440	1678	2160041359000	1868	935	62	0	\N
233441	1678	2160041360000	1868	935	63	0	\N
233442	1678	2160041361000	1868	935	64	0	\N
233443	1678	2160041362000	1868	935	65	0	\N
233444	1678	2160041363000	1868	935	66	0	\N
233445	1678	2160041364000	1868	935	67	0	\N
233446	1678	2160041365000	1868	935	68	0	\N
233447	1678	2160041366000	1868	935	69	0	\N
233448	1678	2160041367000	1868	935	70	0	\N
233449	1678	2160041368000	1868	935	71	0	\N
233450	1678	2160041369000	1868	935	72	0	\N
233451	1678	2160041370000	1868	935	73	0	\N
233452	1678	2160041371000	1868	935	74	0	\N
233453	1678	2160041372000	1868	935	75	0	\N
233454	1678	2160041373000	1868	935	76	0	\N
233455	1678	2160041374000	1868	935	77	0	\N
233456	1678	2160041375000	1868	935	78	0	\N
233457	1678	2160041376000	1868	935	79	0	\N
233458	1678	2160041380000	1869	996	0	0	\N
233459	1678	2160041380000	1870	996	0	0	\N
233461	1678	2160041381000	1872	997	0	0	\N
233462	1678	2160041382000	1872	997	2	0	\N
233465	1678	2160041381000	1874	997	0	0	\N
233466	1678	2160041382000	1874	997	2	0	\N
233468	1678	2160041383000	1876	998	0	0	\N
233469	1678	2160041383000	1877	998	0	0	\N
233470	1678	2160041383000	1878	998	0	0	\N
233474	1678	2160041386000	1881	1000	0	0	\N
233476	1678	2160041388000	1883	1002	0	0	\N
233477	1678	2160041388000	1884	1002	0	0	\N
233481	1678	2160041391000	1887	1004	0	0	\N
233483	1678	2160041392000	1889	1005	0	0	\N
233487	1678	2160041395000	1893	1008	0	0	\N
233493	1678	2160041400000	1897	1011	0	0	\N
233499	1678	2160041404000	1901	1013	0	0	\N
233500	1678	2160041404000	1902	1013	0	0	\N
233501	1678	2160041405000	1903	1014	0	0	\N
233504	1678	2160041406000	1906	1015	0	0	\N
233505	1678	2160041406000	1907	1015	0	0	\N
233506	1678	2160041407000	1908	1016	0	0	\N
233507	1678	2160041407000	1909	1016	0	0	\N
233463	1678	2160041381000	1873	997	0	0	0
233464	1678	2160041382000	1873	997	2	0	0
233467	1678	2160041383000	1875	998	0	0	0
233471	1678	2160041384000	1879	999	0	0	0
233472	1678	2160041385000	1879	999	1	0	0
233475	1678	2160041387000	1882	1001	0	0	0
233478	1678	2160041388000	1885	1002	0	0	0
233479	1678	2160041389000	1886	1003	0	0	0
233480	1678	2160041390000	1886	1003	1	0	0
233482	1678	2160041391000	1888	1004	0	0	0
233485	1678	2160041393000	1891	1006	0	0	0
233486	1678	2160041394000	1892	1007	0	0	0
233488	1678	2160041395000	1894	1008	0	0	0
233489	1678	2160041396000	1895	1009	0	0	0
233491	1678	2160041398000	1896	1010	1	0	0
233492	1678	2160041399000	1896	1010	2	0	0
233494	1678	2160041400000	1898	1011	0	0	0
233495	1678	2160041401000	1899	1012	0	0	0
233496	1678	2160041402000	1899	1012	1	0	0
233498	1678	2160041404000	1900	1013	0	0	0
233502	1678	2160041405000	1904	1014	0	0	0
233503	1678	2160041406000	1905	1015	0	0	0
233508	1678	2160041407000	1910	1016	0	0	0
233509	1678	2160041408000	1911	1017	0	0	0
233511	1678	2160041409000	1911	1017	2	0	0
233512	1678	2160041410000	1912	1018	0	0	0
233514	1678	2160041412000	1914	1020	0	0	\N
233515	1483	0	1914	1020	1	0	\N
233520	1678	2160041415000	1918	1023	0	0	\N
233521	1678	2160041415000	1919	1023	0	0	\N
233523	1678	2160041415000	1921	1023	0	0	\N
233524	1678	2160041416000	1922	1024	0	0	\N
233526	1678	2160041416000	1924	1024	0	0	\N
233527	1678	2160041416000	1925	1024	0	0	\N
233528	1678	2160041417000	1926	1025	0	0	\N
233529	1678	2160041418000	1926	1025	1	0	\N
233530	1678	2160041419000	1926	1025	2	0	\N
233534	1678	2160041417000	1928	1025	0	0	\N
233535	1678	2160041418000	1928	1025	1	0	\N
233536	1678	2160041419000	1928	1025	2	0	\N
233537	1678	2160041420000	1929	1026	0	0	\N
233541	1678	2160041423000	1932	1028	0	0	\N
233542	1678	2160041423000	1933	1028	0	0	\N
233544	1678	2160041421000	1935	1027	0	0	\N
233545	1678	2160041422000	1935	1027	1	0	\N
233546	1678	2160041423000	1935	1027	2	0	\N
233548	1678	2160041424000	1937	1029	0	0	\N
233549	1678	2160041424000	1938	1029	0	0	\N
233551	1678	2160041425000	1940	1030	0	0	\N
233552	1678	2160041425000	1941	1030	0	0	\N
233555	1678	2160041426000	1943	1031	0	0	\N
233556	1678	2160041427000	1943	1031	1	0	\N
233557	1678	2160041428000	1944	1032	0	0	\N
233558	1678	2160041428000	1945	1032	0	0	\N
233559	165	66000100000000	1946	998	0	0	\N
233560	1678	2160041383000	1946	998	1	0	\N
233561	1678	2160041384000	1946	998	2	0	\N
233562	1678	2160041385000	1946	998	3	0	\N
233563	1678	2160041386000	1946	998	4	0	\N
233564	1678	2160041387000	1946	998	5	0	\N
233565	1678	2160041388000	1946	998	6	0	\N
233566	1678	2160041389000	1946	998	7	0	\N
233567	1678	2160041390000	1946	998	8	0	\N
233568	1678	2160041391000	1946	998	9	0	\N
233569	1678	2160041392000	1946	998	10	0	\N
233570	1678	2160041393000	1946	998	11	0	\N
233571	1678	2160041394000	1946	998	12	0	\N
233572	1678	2160041395000	1946	998	13	0	\N
233573	1678	2160041396000	1946	998	14	0	\N
233574	1678	2160041397000	1946	998	15	0	\N
233575	1678	2160041398000	1946	998	16	0	\N
233576	1678	2160041399000	1946	998	17	0	\N
233577	1678	2160041400000	1946	998	18	0	\N
233578	1678	2160041401000	1946	998	19	0	\N
233579	1678	2160041402000	1946	998	20	0	\N
233580	1678	2160041403000	1946	998	21	0	\N
233581	1678	2160041404000	1946	998	22	0	\N
233582	1678	2160041405000	1946	998	23	0	\N
233583	1678	2160041406000	1946	998	24	0	\N
233584	1678	2160041407000	1946	998	25	0	\N
233585	1678	2160041408000	1946	998	26	0	\N
233586	1678	2160041409000	1946	998	27	0	\N
233587	1678	2160041410000	1946	998	28	0	\N
233588	1678	2160041411000	1946	998	29	0	\N
233589	1678	2160041412000	1946	998	30	0	\N
233590	1678	2160041413000	1946	998	31	0	\N
233591	1678	2160041414000	1946	998	32	0	\N
233592	1678	2160041415000	1946	998	33	0	\N
233593	1678	2160041416000	1946	998	34	0	\N
233594	1678	2160041417000	1946	998	35	0	\N
233595	1678	2160041418000	1946	998	36	0	\N
233596	1678	2160041419000	1946	998	37	0	\N
233597	1678	2160041420000	1946	998	38	0	\N
233598	1678	2160041421000	1946	998	39	0	\N
233599	1678	2160041422000	1946	998	40	0	\N
233600	1678	2160041423000	1946	998	41	0	\N
233601	1678	2160041424000	1946	998	42	0	\N
233602	1678	2160041425000	1946	998	43	0	\N
233603	1678	2160041426000	1946	998	44	0	\N
233604	1678	2160041427000	1946	998	45	0	\N
233605	1678	2160041428000	1946	998	46	0	\N
233610	1678	2160041431000	1950	1034	0	0	\N
233611	1678	2160041431000	1951	1034	0	0	\N
233612	1678	2160041431000	1952	1034	0	0	\N
233613	1678	2160041432000	1953	1035	0	0	\N
233615	1678	2160041433000	1955	1036	0	0	\N
233616	1678	2160041434000	1955	1036	1	0	\N
233620	1678	2160041435000	1958	1037	0	0	\N
233621	1678	2160041435000	1959	1037	0	0	\N
233622	1678	2160041436000	1960	1038	0	0	\N
233623	1678	2160041437000	1960	1038	1	0	\N
233626	1678	2160041438000	1962	1039	0	0	\N
233627	1678	2160041438000	1963	1039	0	0	\N
233629	1678	2160041438000	1965	1039	0	0	\N
233638	1678	2160041445000	1968	1041	0	0	\N
233639	1678	2160041446000	1968	1041	1	0	\N
233640	1678	2160041445000	1969	1041	0	0	\N
233641	1678	2160041446000	1969	1041	1	0	\N
233642	1678	2160041447000	1970	1042	0	0	\N
233645	1678	2160041448000	1973	1043	0	0	\N
233646	1678	2160041448000	1974	1043	0	0	\N
233647	165	66000100000000	1975	892	0	0	\N
233648	1678	2160041290000	1975	892	1	0	\N
233517	1483	0	1915	1020	1	0	0
233518	1678	2160041413000	1916	1021	0	0	0
233519	1678	2160041414000	1917	1022	0	0	0
233522	1678	2160041415000	1920	1023	0	0	0
233525	1678	2160041416000	1923	1024	0	0	0
233532	1678	2160041418000	1927	1025	1	0	0
233533	1678	2160041419000	1927	1025	2	0	0
233538	1678	2160041420000	1930	1026	0	0	0
233539	1678	2160041421000	1931	1027	0	0	0
233540	1678	2160041422000	1931	1027	1	0	0
233547	1678	2160041424000	1936	1029	0	0	0
233550	1678	2160041425000	1939	1030	0	0	0
233553	1678	2160041426000	1942	1031	0	0	0
233554	1678	2160041427000	1942	1031	1	0	0
233607	1678	2160041429000	1948	1033	0	0	0
233608	1678	2160041430000	1948	1033	1	0	0
233609	1678	2160041431000	1949	1034	0	0	0
233614	1678	2160041432000	1954	1035	0	0	0
233617	1678	2160041433000	1956	1036	0	0	0
233619	1678	2160041435000	1957	1037	0	0	0
233624	1678	2160041436000	1961	1038	0	0	0
233625	1678	2160041437000	1961	1038	1	0	0
233628	1678	2160041438000	1964	1039	0	0	0
233630	1678	2160041439000	1966	1040	0	0	0
233632	1678	2160041441000	1966	1040	2	0	0
233633	1678	2160041442000	1966	1040	3	0	0
233634	1678	2160041443000	1966	1040	4	0	0
233635	1678	2160041444000	1966	1040	5	0	0
233637	1678	2160041446000	1967	1041	1	0	0
233643	1678	2160041447000	1971	1042	0	0	0
233644	1678	2160041448000	1972	1043	0	0	0
233649	1678	2160041291000	1975	892	2	0	\N
233650	1678	2160041292000	1975	892	3	0	\N
233651	1678	2160041293000	1975	892	4	0	\N
233652	1678	2160041294000	1975	892	5	0	\N
233653	1678	2160041295000	1975	892	6	0	\N
233654	1678	2160041296000	1975	892	7	0	\N
233655	1678	2160041297000	1975	892	8	0	\N
233656	1678	2160041298000	1975	892	9	0	\N
233657	1678	2160041299000	1975	892	10	0	\N
233658	1678	2160041300000	1975	892	11	0	\N
233659	1678	2160041301000	1975	892	12	0	\N
233660	1678	2160041302000	1975	892	13	0	\N
233661	1678	2160041303000	1975	892	14	0	\N
233662	1678	2160041304000	1975	892	15	0	\N
233663	1678	2160041305000	1975	892	16	0	\N
233664	1678	2160041306000	1975	892	17	0	\N
233665	1678	2160041307000	1975	892	18	0	\N
233666	1678	2160041308000	1975	892	19	0	\N
233667	1678	2160041309000	1975	892	20	0	\N
233668	1678	2160041310000	1975	892	21	0	\N
233669	1678	2160041311000	1975	892	22	0	\N
233670	1678	2160041312000	1975	892	23	0	\N
233671	1678	2160041313000	1975	892	24	0	\N
233672	1678	2160041314000	1975	892	25	0	\N
233673	1678	2160041315000	1975	892	26	0	\N
233674	1678	2160041316000	1975	892	27	0	\N
233675	1678	2160041317000	1975	892	28	0	\N
233676	1678	2160041318000	1975	892	29	0	\N
233677	1678	2160041319000	1975	892	30	0	\N
233678	1678	2160041320000	1975	892	31	0	\N
233679	1678	2160041321000	1975	892	32	0	\N
233680	1678	2160041322000	1975	892	33	0	\N
233681	1678	2160041323000	1975	892	34	0	\N
233682	1678	2160041324000	1975	892	35	0	\N
233683	1678	2160041325000	1975	892	36	0	\N
233684	1678	2160041326000	1975	892	37	0	\N
233685	1678	2160041327000	1975	892	38	0	\N
233686	1678	2160041328000	1975	892	39	0	\N
233687	1678	2160041329000	1975	892	40	0	\N
233688	1678	2160041330000	1975	892	41	0	\N
233689	1678	2160041331000	1975	892	43	0	\N
233690	1678	2160041332000	1975	892	44	0	\N
233691	1678	2160041333000	1975	892	45	0	\N
233692	1678	2160041334000	1975	892	46	0	\N
233693	1678	2160041335000	1975	892	47	0	\N
233694	1678	2160041336000	1975	892	48	0	\N
233695	1678	2160041337000	1975	892	49	0	\N
233696	1678	2160041338000	1975	892	50	0	\N
233697	1678	2160041339000	1975	892	51	0	\N
233698	1678	2160041340000	1975	892	52	0	\N
233699	1678	2160041341000	1975	892	53	0	\N
233700	1678	2160041342000	1975	892	54	0	\N
233701	1678	2160041343000	1975	892	55	0	\N
233702	1678	2160041344000	1975	892	56	0	\N
233703	1678	2160041345000	1975	892	57	0	\N
233704	1678	2160041346000	1975	892	58	0	\N
233705	1678	2160041347000	1975	892	59	0	\N
233706	1678	2160041348000	1975	892	60	0	\N
233707	1678	2160041349000	1975	892	61	0	\N
233708	1678	2160041350000	1975	892	62	0	\N
233709	1678	2160041351000	1975	892	63	0	\N
233710	1678	2160041352000	1975	892	64	0	\N
233711	1678	2160041353000	1975	892	65	0	\N
233712	1678	2160041354000	1975	892	66	0	\N
233713	1678	2160041355000	1975	892	67	0	\N
233714	1678	2160041356000	1975	892	68	0	\N
233715	1678	2160041357000	1975	892	69	0	\N
233716	1678	2160041358000	1975	892	70	0	\N
233717	1678	2160041359000	1975	892	71	0	\N
233718	1678	2160041360000	1975	892	72	0	\N
233719	1678	2160041361000	1975	892	73	0	\N
233720	1678	2160041362000	1975	892	74	0	\N
233721	1678	2160041363000	1975	892	75	0	\N
233722	1678	2160041364000	1975	892	76	0	\N
233723	1678	2160041365000	1975	892	77	0	\N
233724	1678	2160041366000	1975	892	78	0	\N
233725	1678	2160041367000	1975	892	79	0	\N
233726	1678	2160041368000	1975	892	80	0	\N
233727	1678	2160041369000	1975	892	81	0	\N
233728	1678	2160041370000	1975	892	82	0	\N
233729	1678	2160041371000	1975	892	83	0	\N
233730	1678	2160041372000	1975	892	84	0	\N
233731	1678	2160041373000	1975	892	85	0	\N
233732	1678	2160041374000	1975	892	86	0	\N
233733	1678	2160041375000	1975	892	87	0	\N
233734	1678	2160041376000	1975	892	88	0	\N
233735	1678	2160041377000	1975	892	89	0	\N
233736	1678	2160041378000	1975	892	90	0	\N
233737	1678	2160041379000	1975	892	91	0	\N
233738	1678	2160041380000	1975	892	92	0	\N
233739	1678	2160041381000	1975	892	93	0	\N
233740	1678	2160041382000	1975	892	94	0	\N
233741	1678	2160041383000	1975	892	95	0	\N
233742	1678	2160041384000	1975	892	96	0	\N
233743	1678	2160041385000	1975	892	97	0	\N
233744	1678	2160041386000	1975	892	98	0	\N
233745	1678	2160041387000	1975	892	99	0	\N
233746	1678	2160041388000	1975	892	100	0	\N
233747	1678	2160041389000	1975	892	101	0	\N
233748	1678	2160041390000	1975	892	102	0	\N
233749	1678	2160041391000	1975	892	103	0	\N
233750	1678	2160041392000	1975	892	104	0	\N
233751	1678	2160041393000	1975	892	105	0	\N
233752	1678	2160041394000	1975	892	106	0	\N
233753	1678	2160041395000	1975	892	107	0	\N
233754	1678	2160041396000	1975	892	108	0	\N
233755	1678	2160041397000	1975	892	109	0	\N
233756	1678	2160041398000	1975	892	110	0	\N
233757	1678	2160041399000	1975	892	111	0	\N
233758	1678	2160041400000	1975	892	112	0	\N
233759	1678	2160041401000	1975	892	113	0	\N
233760	1678	2160041402000	1975	892	114	0	\N
233761	1678	2160041403000	1975	892	115	0	\N
233762	1678	2160041404000	1975	892	116	0	\N
233763	1678	2160041405000	1975	892	117	0	\N
233764	1678	2160041406000	1975	892	118	0	\N
233765	1678	2160041407000	1975	892	119	0	\N
233766	1678	2160041408000	1975	892	120	0	\N
233767	1678	2160041409000	1975	892	121	0	\N
233768	1678	2160041410000	1975	892	122	0	\N
233769	1678	2160041411000	1975	892	123	0	\N
233770	1678	2160041412000	1975	892	124	0	\N
233771	1678	2160041413000	1975	892	125	0	\N
233773	1678	2160041450000	1977	1045	0	0	\N
233778	1678	2160041454000	1980	1047	0	0	\N
233779	1678	2160041454000	1981	1047	0	0	\N
233782	1678	2160041456000	1984	1049	0	0	\N
233783	1678	2160041457000	1984	1049	1	0	\N
233775	1678	2160041451000	1979	1046	0	0	0
233776	1678	2160041452000	1979	1046	1	0	0
233777	1678	2160041453000	1979	1046	2	0	0
233780	1678	2160041454000	1982	1047	0	0	0
233781	1678	2160041455000	1983	1048	0	0	0
233787	1678	2160041459000	1987	1051	0	0	\N
233789	1678	2160041459000	1989	1051	0	0	\N
233790	1678	2160041460000	1990	1052	0	0	\N
233792	1678	2160041460000	1992	1052	0	0	\N
233794	1678	2160041462000	1994	1054	0	0	\N
233798	1678	2160041463000	1997	1055	0	0	\N
233799	1678	2160041464000	1997	1055	1	0	\N
233802	1678	2160041466000	2000	1057	0	0	\N
233803	1678	2160041466000	2001	1057	0	0	\N
233804	1678	2160041414000	2002	893	0	0	\N
233805	1678	2160041415000	2002	893	1	0	\N
233806	1678	2160041416000	2002	893	2	0	\N
233807	1678	2160041417000	2002	893	3	0	\N
233808	1678	2160041418000	2002	893	4	0	\N
233809	1678	2160041419000	2002	893	5	0	\N
233810	1678	2160041420000	2002	893	6	0	\N
233811	1678	2160041421000	2002	893	7	0	\N
233812	1678	2160041422000	2002	893	8	0	\N
233813	1678	2160041423000	2002	893	9	0	\N
233814	1678	2160041424000	2002	893	10	0	\N
233815	1678	2160041425000	2002	893	11	0	\N
233816	1678	2160041426000	2002	893	12	0	\N
233817	1678	2160041427000	2002	893	13	0	\N
233818	1678	2160041428000	2002	893	14	0	\N
233819	1678	2160041429000	2002	893	15	0	\N
233820	1678	2160041430000	2002	893	16	0	\N
233821	1678	2160041431000	2002	893	17	0	\N
233822	1678	2160041432000	2002	893	18	0	\N
233823	1678	2160041433000	2002	893	19	0	\N
233824	1678	2160041434000	2002	893	20	0	\N
233825	1678	2160041435000	2002	893	21	0	\N
233826	1678	2160041436000	2002	893	22	0	\N
233827	1678	2160041437000	2002	893	23	0	\N
233828	1678	2160041438000	2002	893	24	0	\N
233829	1678	2160041439000	2002	893	25	0	\N
233830	1678	2160041440000	2002	893	26	0	\N
233831	1678	2160041441000	2002	893	27	0	\N
233832	1678	2160041442000	2002	893	28	0	\N
233833	1678	2160041443000	2002	893	29	0	\N
233834	1678	2160041444000	2002	893	30	0	\N
233835	1678	2160041445000	2002	893	31	0	\N
233836	1678	2160041446000	2002	893	32	0	\N
233837	1678	2160041447000	2002	893	33	0	\N
233838	1678	2160041448000	2002	893	34	0	\N
233839	1678	2160041449000	2002	893	35	0	\N
233840	1678	2160041450000	2002	893	36	0	\N
233841	1678	2160041451000	2002	893	37	0	\N
233842	1678	2160041452000	2002	893	38	0	\N
233843	1678	2160041453000	2002	893	39	0	\N
233844	1678	2160041454000	2002	893	40	0	\N
233845	1678	2160041455000	2002	893	41	0	\N
233846	1678	2160041456000	2002	893	43	0	\N
233847	1678	2160041457000	2002	893	44	0	\N
233848	1678	2160041458000	2002	893	45	0	\N
233849	1678	2160041459000	2002	893	46	0	\N
233850	1678	2160041460000	2002	893	47	0	\N
233851	1678	2160041461000	2002	893	48	0	\N
233852	1678	2160041462000	2002	893	49	0	\N
233853	1678	2160041463000	2002	893	50	0	\N
233854	1678	2160041464000	2002	893	51	0	\N
233855	1678	2160041465000	2002	893	52	0	\N
233856	1678	2160041466000	2002	893	53	0	\N
233858	1678	2160041468000	2004	1059	0	0	\N
233859	1678	2160041469000	2004	1059	1	0	\N
233862	1678	2160041468000	2006	1059	0	0	\N
233863	1678	2160041469000	2006	1059	1	0	\N
233864	1678	2160041468000	2007	1059	0	0	\N
233865	1678	2160041469000	2007	1059	1	0	\N
233871	1678	2160041351000	2011	971	0	0	\N
233872	165	66000100000000	2011	971	1	0	\N
233873	1678	2160041352000	2011	971	2	0	\N
233874	1678	2160041353000	2011	971	3	0	\N
233875	1678	2160041354000	2011	971	4	0	\N
233876	1678	2160041355000	2011	971	5	0	\N
233877	1678	2160041356000	2011	971	6	0	\N
233878	1678	2160041357000	2011	971	7	0	\N
233879	1678	2160041358000	2011	971	8	0	\N
233880	1678	2160041359000	2011	971	9	0	\N
233881	1678	2160041360000	2011	971	10	0	\N
233882	1678	2160041361000	2011	971	11	0	\N
233883	1678	2160041362000	2011	971	12	0	\N
233884	1678	2160041363000	2011	971	13	0	\N
233885	1678	2160041364000	2011	971	14	0	\N
233886	1678	2160041365000	2011	971	15	0	\N
233887	1678	2160041366000	2011	971	16	0	\N
233888	1678	2160041367000	2011	971	17	0	\N
233889	1678	2160041368000	2011	971	18	0	\N
233890	1678	2160041369000	2011	971	19	0	\N
233891	1678	2160041370000	2011	971	20	0	\N
233892	1678	2160041371000	2011	971	21	0	\N
233893	1678	2160041372000	2011	971	22	0	\N
233894	1678	2160041373000	2011	971	23	0	\N
233895	1678	2160041374000	2011	971	24	0	\N
233896	1678	2160041375000	2011	971	25	0	\N
233897	1678	2160041376000	2011	971	26	0	\N
233898	1678	2160041377000	2011	971	27	0	\N
233899	1678	2160041378000	2011	971	28	0	\N
233900	1678	2160041379000	2011	971	29	0	\N
233901	1678	2160041380000	2011	971	30	0	\N
233902	1678	2160041381000	2011	971	31	0	\N
233903	1678	2160041382000	2011	971	32	0	\N
233904	1678	2160041383000	2011	971	33	0	\N
233905	1678	2160041384000	2011	971	34	0	\N
233906	1678	2160041385000	2011	971	35	0	\N
233907	1678	2160041386000	2011	971	36	0	\N
233908	1678	2160041387000	2011	971	37	0	\N
233909	1678	2160041388000	2011	971	38	0	\N
233910	1678	2160041389000	2011	971	39	0	\N
233911	1678	2160041390000	2011	971	40	0	\N
233912	1678	2160041391000	2011	971	41	0	\N
233913	1678	2160041392000	2011	971	42	0	\N
233914	1678	2160041393000	2011	971	43	0	\N
233915	1678	2160041394000	2011	971	44	0	\N
233916	1678	2160041395000	2011	971	45	0	\N
233917	1678	2160041396000	2011	971	46	0	\N
233918	1678	2160041397000	2011	971	47	0	\N
233919	1678	2160041398000	2011	971	48	0	\N
233920	1678	2160041399000	2011	971	49	0	\N
233788	1678	2160041459000	1988	1051	0	0	0
233791	1678	2160041460000	1991	1052	0	0	0
233793	1678	2160041461000	1993	1053	0	0	0
233795	1678	2160041462000	1995	1054	0	0	0
233796	1678	2160041463000	1996	1055	0	0	0
233800	1678	2160041465000	1998	1056	0	0	0
233801	1678	2160041466000	1999	1057	0	0	0
233857	1678	2160041467000	2003	1058	0	0	0
233860	1678	2160041468000	2005	1059	0	0	0
233861	1678	2160041469000	2005	1059	1	0	0
233867	1678	2160041471000	2008	1060	1	0	0
233868	1678	2160041472000	2008	1060	2	0	0
233869	1678	2160041473000	2009	1061	0	0	0
233870	1678	2160041474000	2010	1062	0	0	0
233921	1678	2160041400000	2011	971	50	0	\N
233922	1678	2160041401000	2011	971	51	0	\N
233923	1678	2160041402000	2011	971	52	0	\N
233924	1678	2160041403000	2011	971	53	0	\N
233925	1678	2160041404000	2011	971	54	0	\N
233926	1678	2160041405000	2011	971	55	0	\N
233927	1678	2160041406000	2011	971	56	0	\N
233928	1678	2160041407000	2011	971	57	0	\N
233929	1678	2160041408000	2011	971	58	0	\N
233930	1678	2160041409000	2011	971	59	0	\N
233931	1678	2160041410000	2011	971	60	0	\N
233932	1678	2160041411000	2011	971	61	0	\N
233933	1678	2160041412000	2011	971	62	0	\N
233934	1678	2160041413000	2011	971	63	0	\N
233935	1678	2160041414000	2011	971	64	0	\N
233936	1678	2160041415000	2011	971	65	0	\N
233937	1678	2160041416000	2011	971	66	0	\N
233938	1678	2160041417000	2011	971	67	0	\N
233939	1678	2160041418000	2011	971	68	0	\N
233940	1678	2160041419000	2011	971	69	0	\N
233941	1678	2160041420000	2011	971	70	0	\N
233942	1678	2160041421000	2011	971	71	0	\N
233943	1678	2160041422000	2011	971	72	0	\N
233944	1678	2160041423000	2011	971	73	0	\N
233945	1678	2160041424000	2011	971	74	0	\N
233946	1678	2160041425000	2011	971	75	0	\N
233947	1678	2160041426000	2011	971	76	0	\N
233948	1678	2160041427000	2011	971	77	0	\N
233949	1678	2160041428000	2011	971	78	0	\N
233950	1678	2160041429000	2011	971	79	0	\N
233951	1678	2160041430000	2011	971	80	0	\N
233952	1678	2160041474000	2012	1062	0	0	\N
233953	1678	2160041474000	2013	1062	0	0	\N
233954	1678	2160041474000	2014	1062	0	0	\N
233958	1678	2160041475000	2016	1063	0	0	\N
233959	1678	2160041476000	2016	1063	1	0	\N
233960	1678	2160041477000	2016	1063	2	0	\N
233962	1678	2160041479000	2018	1065	0	0	\N
233963	1678	2160041479000	2019	1065	0	0	\N
233965	1678	2160041480000	2021	1066	0	0	\N
233966	1678	2160041481000	2021	1066	1	0	\N
233967	1678	2160041480000	2022	1066	0	0	\N
233968	1678	2160041481000	2022	1066	1	0	\N
233975	1678	2160041484000	2026	1068	0	0	\N
233976	1678	2160041485000	2026	1068	1	0	\N
233979	1678	2160041488000	2029	1071	0	0	\N
233981	1678	2160041489000	2031	1072	0	0	\N
233982	1678	2160041489000	2032	1072	0	0	\N
233983	1678	2160041490000	2032	1072	1	0	\N
233984	1678	2160041489000	2033	1072	0	0	\N
233985	1678	2160041490000	2033	1072	1	0	\N
233989	1678	2160041492000	2036	1074	0	0	\N
233990	1678	2160041493000	2036	1074	1	0	\N
233998	1678	2160041497000	2041	1077	0	0	\N
233999	1678	2160041498000	2041	1077	1	0	\N
234002	1678	2160041500000	2044	1079	0	0	\N
234003	1678	2160041426000	2045	1031	0	0	\N
234004	1678	2160041427000	2045	1031	1	0	\N
234005	1678	2160041428000	2045	1031	2	0	\N
234006	1678	2160041429000	2045	1031	3	0	\N
234007	1678	2160041430000	2045	1031	4	0	\N
234008	1678	2160041431000	2045	1031	5	0	\N
234009	1678	2160041432000	2045	1031	6	0	\N
234010	1678	2160041433000	2045	1031	7	0	\N
234011	1678	2160041434000	2045	1031	8	0	\N
234012	1678	2160041435000	2045	1031	9	0	\N
234013	1678	2160041436000	2045	1031	10	0	\N
234014	1678	2160041437000	2045	1031	11	0	\N
234015	1678	2160041438000	2045	1031	12	0	\N
234016	1678	2160041439000	2045	1031	14	0	\N
234017	1678	2160041440000	2045	1031	15	0	\N
234018	1678	2160041441000	2045	1031	16	0	\N
234019	1678	2160041442000	2045	1031	17	0	\N
234020	1678	2160041443000	2045	1031	18	0	\N
234021	1678	2160041444000	2045	1031	19	0	\N
234022	1678	2160041445000	2045	1031	20	0	\N
234023	1678	2160041446000	2045	1031	21	0	\N
234024	1678	2160041447000	2045	1031	22	0	\N
234025	1678	2160041448000	2045	1031	23	0	\N
234026	1678	2160041449000	2045	1031	24	0	\N
234027	1678	2160041450000	2045	1031	25	0	\N
234028	1678	2160041451000	2045	1031	26	0	\N
234029	1678	2160041452000	2045	1031	27	0	\N
234030	1678	2160041453000	2045	1031	28	0	\N
234031	1678	2160041454000	2045	1031	29	0	\N
234032	1678	2160041455000	2045	1031	30	0	\N
234033	1678	2160041456000	2045	1031	31	0	\N
234034	1678	2160041457000	2045	1031	32	0	\N
234035	1678	2160041458000	2045	1031	33	0	\N
234036	1678	2160041459000	2045	1031	34	0	\N
234037	1678	2160041460000	2045	1031	35	0	\N
234038	1678	2160041461000	2045	1031	36	0	\N
234039	1678	2160041462000	2045	1031	37	0	\N
234040	1678	2160041463000	2045	1031	38	0	\N
234041	1678	2160041464000	2045	1031	39	0	\N
234042	1678	2160041465000	2045	1031	40	0	\N
234043	1678	2160041466000	2045	1031	41	0	\N
234044	1678	2160041467000	2045	1031	42	0	\N
234045	1678	2160041468000	2045	1031	43	0	\N
234046	1678	2160041469000	2045	1031	44	0	\N
234047	1678	2160041470000	2045	1031	45	0	\N
234048	1678	2160041471000	2045	1031	46	0	\N
234049	1678	2160041472000	2045	1031	47	0	\N
234050	1678	2160041473000	2045	1031	48	0	\N
233957	1678	2160041477000	2015	1063	2	0	0
233961	1678	2160041478000	2017	1064	0	0	0
233964	1678	2160041479000	2020	1065	0	0	0
233969	1678	2160041480000	2023	1066	0	0	0
233970	1678	2160041481000	2023	1066	1	0	0
233972	1678	2160041483000	2024	1067	1	0	0
233973	1678	2160041484000	2025	1068	0	0	0
233974	1678	2160041485000	2025	1068	1	0	0
233977	1678	2160041486000	2027	1069	0	0	0
233978	1678	2160041487000	2028	1070	0	0	0
233986	1678	2160041489000	2034	1072	0	0	0
233987	1678	2160041490000	2034	1072	1	0	0
233988	1678	2160041491000	2035	1073	0	0	0
233991	1678	2160041492000	2037	1074	0	0	0
233993	1678	2160041494000	2038	1075	0	0	0
233994	1678	2160041495000	2038	1075	1	0	0
233995	1678	2160041496000	2039	1076	0	0	0
233996	1678	2160041497000	2040	1077	0	0	0
233997	1678	2160041498000	2040	1077	1	0	0
234001	1678	2160041500000	2043	1079	0	0	0
234051	1678	2160041501000	2046	1080	0	0	0
234052	1678	2160041502000	2046	1080	1	0	0
234053	1678	2160041503000	2046	1080	2	0	0
234054	1678	2160041504000	2046	1080	3	0	0
234056	1678	2160041506000	2046	1080	5	0	0
234059	1678	2160041508000	2049	1082	0	0	\N
234063	1678	2160041510000	2052	1084	0	0	\N
234064	1678	2160041511000	2052	1084	1	0	\N
234066	1678	2160041512000	2054	1085	0	0	\N
234068	1678	2160041513000	2056	1086	0	0	\N
234069	1678	2160041514000	2057	1087	0	0	\N
234070	1678	2160041514000	2058	1087	0	0	\N
234074	1678	2160041517000	2062	1090	0	0	\N
234076	1678	2160041517000	2064	1090	0	0	\N
234078	1678	2160041519000	2066	1092	0	0	\N
234081	1678	2160041520000	2069	1093	0	0	\N
234082	1678	2160041520000	2070	1093	0	0	\N
234086	1678	2160041522000	2073	1095	0	0	\N
234087	1678	2160041523000	2073	1095	1	0	\N
234089	1678	2160041524000	2075	1096	0	0	\N
234090	1678	2160041524000	2076	1096	0	0	\N
234091	1678	2160041525000	2077	1097	0	0	\N
234093	1678	2160041526000	2079	1098	0	0	\N
234095	1678	2160041527000	2081	1099	0	0	\N
234096	1678	2160041527000	2082	1099	0	0	\N
234099	1678	2160041528000	2085	1100	0	0	\N
234108	1678	2160041537000	2091	1105	0	0	\N
234109	1678	2160041537000	2092	1105	0	0	\N
234111	1678	2160041537000	2094	1105	0	0	\N
234112	1678	2160041538000	2095	1106	0	0	\N
234113	1678	2160041539000	2095	1106	1	0	\N
234116	1678	2160041538000	2097	1106	0	0	\N
234117	1678	2160041539000	2097	1106	1	0	\N
234121	1678	2160041543000	2100	1109	0	0	\N
234123	1678	2160041543000	2102	1109	0	0	\N
234124	1678	2160041543000	2103	1109	0	0	\N
234125	1678	2160041544000	2104	1110	0	0	\N
234126	1678	2160041544000	2105	1110	0	0	\N
234128	1678	2160041392000	2107	1005	0	0	\N
234129	1678	2160041393000	2107	1005	1	0	\N
234130	1678	2160041394000	2107	1005	2	0	\N
234131	165	66000100000000	2107	1005	3	0	\N
234132	1678	2160041395000	2107	1005	4	0	\N
234133	1678	2160041396000	2107	1005	5	0	\N
234134	1678	2160041397000	2107	1005	6	0	\N
234135	1678	2160041398000	2107	1005	7	0	\N
234136	1678	2160041399000	2107	1005	8	0	\N
234137	1678	2160041400000	2107	1005	9	0	\N
234138	1678	2160041401000	2107	1005	10	0	\N
234139	1678	2160041402000	2107	1005	11	0	\N
234140	1678	2160041403000	2107	1005	12	0	\N
234141	1678	2160041404000	2107	1005	13	0	\N
234142	1678	2160041405000	2107	1005	14	0	\N
234143	1678	2160041406000	2107	1005	15	0	\N
234144	1678	2160041407000	2107	1005	16	0	\N
234145	1678	2160041408000	2107	1005	17	0	\N
234146	1678	2160041409000	2107	1005	18	0	\N
234147	1678	2160041410000	2107	1005	19	0	\N
234148	1678	2160041411000	2107	1005	20	0	\N
234149	1678	2160041412000	2107	1005	21	0	\N
234150	1678	2160041413000	2107	1005	22	0	\N
234151	1678	2160041414000	2107	1005	23	0	\N
234152	1678	2160041415000	2107	1005	24	0	\N
234153	1678	2160041416000	2107	1005	25	0	\N
234154	1678	2160041417000	2107	1005	26	0	\N
234155	1678	2160041418000	2107	1005	27	0	\N
234156	1678	2160041419000	2107	1005	28	0	\N
234157	1678	2160041420000	2107	1005	29	0	\N
234158	1678	2160041421000	2107	1005	30	0	\N
234159	1678	2160041422000	2107	1005	31	0	\N
234160	1678	2160041423000	2107	1005	32	0	\N
234161	1678	2160041424000	2107	1005	33	0	\N
234162	1678	2160041425000	2107	1005	34	0	\N
234163	1678	2160041426000	2107	1005	35	0	\N
234164	1678	2160041427000	2107	1005	36	0	\N
234165	1678	2160041428000	2107	1005	37	0	\N
234166	1678	2160041429000	2107	1005	38	0	\N
234167	1678	2160041430000	2107	1005	39	0	\N
234168	1678	2160041431000	2107	1005	40	0	\N
234169	1678	2160041432000	2107	1005	41	0	\N
234170	1678	2160041433000	2107	1005	42	0	\N
234171	1678	2160041434000	2107	1005	43	0	\N
234172	1678	2160041435000	2107	1005	44	0	\N
234173	1678	2160041436000	2107	1005	45	0	\N
234174	1678	2160041437000	2107	1005	46	0	\N
234175	1678	2160041438000	2107	1005	47	0	\N
234176	1678	2160041439000	2107	1005	48	0	\N
234177	1678	2160041440000	2107	1005	49	0	\N
234178	1678	2160041441000	2107	1005	50	0	\N
234179	1678	2160041442000	2107	1005	51	0	\N
234180	1678	2160041443000	2107	1005	52	0	\N
234181	1678	2160041444000	2107	1005	53	0	\N
234182	1678	2160041445000	2107	1005	54	0	\N
234183	1678	2160041446000	2107	1005	55	0	\N
234184	1678	2160041447000	2107	1005	56	0	\N
234185	1678	2160041448000	2107	1005	57	0	\N
234186	1678	2160041449000	2107	1005	58	0	\N
234187	1678	2160041450000	2107	1005	59	0	\N
234188	1678	2160041451000	2107	1005	60	0	\N
234189	1678	2160041452000	2107	1005	61	0	\N
234190	1678	2160041453000	2107	1005	62	0	\N
234191	1678	2160041454000	2107	1005	63	0	\N
234192	1678	2160041455000	2107	1005	64	0	\N
234060	1678	2160041509000	2050	1083	0	0	0
234061	1678	2160041510000	2051	1084	0	0	0
234062	1678	2160041511000	2051	1084	1	0	0
234065	1678	2160041512000	2053	1085	0	0	0
234067	1678	2160041513000	2055	1086	0	0	0
234072	1678	2160041515000	2060	1088	0	0	0
234073	1678	2160041516000	2061	1089	0	0	0
234075	1678	2160041517000	2063	1090	0	0	0
234077	1678	2160041518000	2065	1091	0	0	0
234079	1678	2160041519000	2067	1092	0	0	0
234083	1678	2160041521000	2071	1094	0	0	0
234084	1678	2160041522000	2072	1095	0	0	0
234085	1678	2160041523000	2072	1095	1	0	0
234088	1678	2160041524000	2074	1096	0	0	0
234094	1678	2160041526000	2080	1098	0	0	0
234097	1678	2160041527000	2083	1099	0	0	0
234098	1678	2160041528000	2084	1100	0	0	0
234100	1678	2160041529000	2086	1101	0	0	0
234101	1678	2160041530000	2087	1102	0	0	0
234103	1678	2160041532000	2087	1102	2	0	0
234104	1678	2160041533000	2089	1103	0	0	0
234105	1678	2160041534000	2089	1103	1	0	0
234106	1678	2160041535000	2089	1103	2	0	0
234107	1678	2160041536000	2090	1104	0	0	0
234114	1678	2160041538000	2096	1106	0	0	0
234115	1678	2160041539000	2096	1106	1	0	0
234118	1678	2160041540000	2098	1107	0	0	0
234119	1678	2160041541000	2098	1107	1	0	0
234122	1678	2160041543000	2101	1109	0	0	0
234127	1678	2160041544000	2106	1110	0	0	0
234193	1678	2160041456000	2107	1005	65	0	\N
234194	1678	2160041457000	2107	1005	66	0	\N
234195	1678	2160041458000	2107	1005	67	0	\N
234196	1678	2160041459000	2107	1005	68	0	\N
234197	1678	2160041460000	2107	1005	69	0	\N
234198	1678	2160041461000	2107	1005	70	0	\N
234199	1678	2160041462000	2107	1005	71	0	\N
234200	1678	2160041463000	2107	1005	72	0	\N
234201	1678	2160041464000	2107	1005	73	0	\N
234202	1678	2160041465000	2107	1005	74	0	\N
234203	1678	2160041466000	2107	1005	75	0	\N
234204	1678	2160041467000	2107	1005	76	0	\N
234205	1678	2160041468000	2107	1005	77	0	\N
234206	1678	2160041469000	2107	1005	78	0	\N
234207	1678	2160041470000	2107	1005	79	0	\N
234208	1678	2160041471000	2107	1005	80	0	\N
234209	1678	2160041472000	2107	1005	81	0	\N
234210	1678	2160041473000	2107	1005	82	0	\N
234211	1678	2160041474000	2107	1005	83	0	\N
234212	1678	2160041475000	2107	1005	84	0	\N
234213	1678	2160041476000	2107	1005	85	0	\N
234214	1678	2160041477000	2107	1005	86	0	\N
234215	1678	2160041478000	2107	1005	87	0	\N
234216	1678	2160041479000	2107	1005	88	0	\N
234217	1678	2160041480000	2107	1005	89	0	\N
234218	1678	2160041481000	2107	1005	90	0	\N
234219	1678	2160041482000	2107	1005	91	0	\N
234220	1678	2160041483000	2107	1005	92	0	\N
234221	1678	2160041484000	2107	1005	93	0	\N
234222	1678	2160041485000	2107	1005	94	0	\N
234223	1678	2160041486000	2107	1005	95	0	\N
234224	1678	2160041487000	2107	1005	96	0	\N
234225	1678	2160041488000	2107	1005	97	0	\N
234226	1678	2160041489000	2107	1005	98	0	\N
234227	1678	2160041490000	2107	1005	99	0	\N
234228	1678	2160041491000	2107	1005	100	0	\N
234229	1678	2160041492000	2107	1005	102	0	\N
234230	1678	2160041493000	2107	1005	103	0	\N
234231	1678	2160041494000	2107	1005	104	0	\N
234232	1678	2160041495000	2107	1005	105	0	\N
234233	1678	2160041496000	2107	1005	106	0	\N
234234	1678	2160041497000	2107	1005	107	0	\N
234235	1678	2160041498000	2107	1005	108	0	\N
234236	1678	2160041499000	2107	1005	109	0	\N
234237	1678	2160041500000	2107	1005	110	0	\N
234238	1678	2160041501000	2107	1005	111	0	\N
234239	1678	2160041502000	2107	1005	112	0	\N
234240	1678	2160041503000	2107	1005	113	0	\N
234241	1678	2160041504000	2107	1005	114	0	\N
234242	1678	2160041505000	2107	1005	115	0	\N
234243	1678	2160041506000	2107	1005	116	0	\N
234244	1678	2160041507000	2107	1005	117	0	\N
234245	1678	2160041508000	2107	1005	118	0	\N
234246	1678	2160041509000	2107	1005	119	0	\N
234247	1678	2160041510000	2107	1005	120	0	\N
234248	1678	2160041511000	2107	1005	121	0	\N
234249	1678	2160041512000	2107	1005	122	0	\N
234250	1678	2160041513000	2107	1005	123	0	\N
234251	1678	2160041514000	2107	1005	124	0	\N
234252	1678	2160041515000	2107	1005	125	0	\N
234253	1678	2160041545000	2108	1111	0	0	\N
234256	1678	2160041546000	2111	1112	0	0	\N
234258	1678	2160041547000	2113	1113	0	0	\N
234262	1678	2160041551000	2116	1116	0	0	\N
234263	1678	2160041552000	2116	1116	1	0	\N
234267	1678	2160041553000	2119	1117	0	0	\N
234269	1678	2160041554000	2121	1118	0	0	\N
234270	1678	2160041554000	2122	1118	0	0	\N
234272	1678	2160041556000	2124	1120	0	0	\N
234273	1678	2160041557000	2124	1120	1	0	\N
234281	1678	2160041563000	2131	1126	0	0	\N
234284	1678	2160041564000	2134	1127	0	0	\N
234285	1678	2160041564000	2135	1127	0	0	\N
234286	1678	2160041562000	2136	1125	0	0	\N
234287	1678	2160041563000	2136	1125	1	0	\N
234288	1678	2160041564000	2136	1125	2	0	\N
234289	1678	2160041564000	2137	1127	0	0	\N
234291	1678	2160041565000	2139	1128	0	0	\N
234292	1678	2160041565000	2140	1128	0	0	\N
234294	1678	2160041566000	2142	1129	0	0	\N
234304	1678	2160041576000	2150	1137	0	0	\N
234305	1678	2160041577000	2150	1137	1	0	\N
234311	1678	2160041581000	2156	1140	0	0	\N
234312	1678	2160041582000	2156	1140	1	0	\N
234315	1678	2160041581000	2158	1140	0	0	\N
234316	1678	2160041582000	2158	1140	1	0	\N
234317	1678	2160041581000	2159	1140	0	0	\N
234318	1678	2160041582000	2159	1140	1	0	\N
234320	1678	2160041583000	2161	1141	0	0	\N
234321	1678	2160041583000	2162	1141	0	0	\N
234323	1678	2160041585000	2164	1143	0	0	\N
234324	1678	2160041585000	2165	1143	0	0	\N
234326	120	66001000000000	2167	1144	0	0	\N
234327	1678	2160041586000	2167	1144	1	0	\N
234257	1678	2160041547000	2112	1113	0	0	0
234259	1678	2160041548000	2114	1114	0	0	0
234260	1678	2160041549000	2115	1115	0	0	0
234261	1678	2160041550000	2115	1115	1	0	0
234264	1678	2160041551000	2117	1116	0	0	0
234266	1678	2160041553000	2118	1117	0	0	0
234268	1678	2160041554000	2120	1118	0	0	0
234271	1678	2160041555000	2123	1119	0	0	0
234274	1678	2160041556000	2125	1120	0	0	0
234275	1678	2160041557000	2125	1120	1	0	0
234277	1678	2160041559000	2127	1122	0	0	0
234278	1678	2160041560000	2128	1123	0	0	0
234279	1678	2160041561000	2129	1124	0	0	0
234280	1678	2160041562000	2130	1125	0	0	0
234283	1678	2160041564000	2133	1127	0	0	0
234290	1678	2160041565000	2138	1128	0	0	0
234293	1678	2160041566000	2141	1129	0	0	0
234295	1678	2160041567000	2143	1130	0	0	0
234296	1678	2160041568000	2144	1131	0	0	0
234298	1678	2160041570000	2146	1133	0	0	0
234299	1678	2160041571000	2146	1133	1	0	0
234300	1678	2160041572000	2147	1134	0	0	0
234301	1678	2160041573000	2147	1134	1	0	0
234302	1678	2160041574000	2148	1135	0	0	0
234306	1678	2160041576000	2152	1137	0	0	0
234307	1678	2160041577000	2152	1137	1	0	0
234308	1678	2160041578000	2153	1138	0	0	0
234309	1678	2160041579000	2154	1139	0	0	0
234313	1678	2160041581000	2157	1140	0	0	0
234314	1678	2160041582000	2157	1140	1	0	0
234319	1678	2160041583000	2160	1141	0	0	0
234322	1678	2160041584000	2163	1142	0	0	0
234325	1678	2160041585000	2166	1143	0	0	0
234330	120	66001000000000	2169	1144	0	0	\N
234331	1678	2160041586000	2169	1144	1	0	\N
234332	1678	2160041587000	2170	1145	0	0	\N
234337	1678	2160041591000	2174	1147	0	0	\N
234339	1678	2160041591000	2176	1147	0	0	\N
234340	1678	2160041592000	2177	1148	0	0	\N
234345	1678	2160041596000	2180	1150	0	0	\N
234346	1678	2160041597000	2180	1150	1	0	\N
234350	1678	2160041598000	2183	1151	0	0	\N
234351	1678	2160041598000	2184	1151	0	0	\N
234352	1678	2160041599000	2185	1152	0	0	\N
234353	1678	2160041600000	2185	1152	1	0	\N
234354	120	66001000000000	2186	972	0	0	\N
234355	1678	2160041431000	2186	972	1	0	\N
234356	1678	2160041432000	2186	972	2	0	\N
234357	1678	2160041433000	2186	972	3	0	\N
234358	1678	2160041434000	2186	972	4	0	\N
234359	1678	2160041435000	2186	972	5	0	\N
234360	1678	2160041436000	2186	972	6	0	\N
234361	1678	2160041437000	2186	972	7	0	\N
234362	1678	2160041438000	2186	972	8	0	\N
234363	1678	2160041439000	2186	972	9	0	\N
234364	1678	2160041440000	2186	972	10	0	\N
234365	1678	2160041441000	2186	972	11	0	\N
234366	1678	2160041442000	2186	972	12	0	\N
234370	1678	2160041602000	2189	1154	0	0	\N
234372	1678	2160041603000	2191	1155	0	0	\N
234374	1678	2160041603000	2193	1155	0	0	\N
234375	1678	2160041604000	2193	1155	1	0	\N
234376	1678	2160041605000	2193	1155	2	0	\N
234377	1678	2160041606000	2193	1155	3	0	\N
234381	120	66001000000000	2195	1112	0	0	\N
234382	1678	2160041546000	2195	1112	1	0	\N
234383	1678	2160041547000	2195	1112	2	0	\N
234384	1678	2160041548000	2195	1112	3	0	\N
234385	1678	2160041549000	2195	1112	4	0	\N
234386	1678	2160041550000	2195	1112	5	0	\N
234387	1678	2160041551000	2195	1112	6	0	\N
234388	1678	2160041552000	2195	1112	7	0	\N
234389	1678	2160041553000	2195	1112	8	0	\N
234390	1678	2160041554000	2195	1112	9	0	\N
234391	1678	2160041555000	2195	1112	10	0	\N
234392	1678	2160041556000	2195	1112	11	0	\N
234393	1678	2160041557000	2195	1112	12	0	\N
234394	1678	2160041558000	2195	1112	13	0	\N
234395	1678	2160041559000	2195	1112	14	0	\N
234396	1678	2160041560000	2195	1112	15	0	\N
234397	1678	2160041561000	2195	1112	16	0	\N
234398	1678	2160041562000	2195	1112	17	0	\N
234399	1678	2160041563000	2195	1112	18	0	\N
234400	1678	2160041564000	2195	1112	19	0	\N
234401	1678	2160041565000	2195	1112	20	0	\N
234402	1678	2160041566000	2195	1112	21	0	\N
234403	1678	2160041567000	2195	1112	22	0	\N
234404	1678	2160041568000	2195	1112	23	0	\N
234405	1678	2160041569000	2195	1112	24	0	\N
234406	1678	2160041570000	2195	1112	25	0	\N
234407	1678	2160041571000	2195	1112	26	0	\N
234408	1678	2160041572000	2195	1112	27	0	\N
234409	1678	2160041573000	2195	1112	28	0	\N
234410	1678	2160041574000	2195	1112	29	0	\N
234411	1678	2160041575000	2195	1112	30	0	\N
234412	1678	2160041576000	2195	1112	31	0	\N
234413	1678	2160041577000	2195	1112	32	0	\N
234414	1678	2160041578000	2195	1112	33	0	\N
234415	1678	2160041579000	2195	1112	34	0	\N
234416	1678	2160041580000	2195	1112	35	0	\N
234417	1678	2160041581000	2195	1112	36	0	\N
234418	1678	2160041582000	2195	1112	37	0	\N
234419	1678	2160041583000	2195	1112	38	0	\N
234420	1678	2160041584000	2195	1112	39	0	\N
234421	1678	2160041585000	2195	1112	40	0	\N
234422	1678	2160041586000	2195	1112	41	0	\N
234423	1678	2160041587000	2195	1112	42	0	\N
234424	1678	2160041588000	2195	1112	43	0	\N
234425	1678	2160041589000	2195	1112	44	0	\N
234426	1678	2160041590000	2195	1112	45	0	\N
234427	1678	2160041591000	2195	1112	46	0	\N
234428	1678	2160041592000	2195	1112	47	0	\N
234429	1678	2160041593000	2195	1112	48	0	\N
234430	1678	2160041594000	2195	1112	49	0	\N
234431	1678	2160041595000	2195	1112	50	0	\N
234432	1678	2160041596000	2195	1112	51	0	\N
234433	1678	2160041597000	2195	1112	52	0	\N
234434	1678	2160041598000	2195	1112	53	0	\N
234435	1678	2160041599000	2195	1112	54	0	\N
234436	1678	2160041600000	2195	1112	55	0	\N
234437	1678	2160041601000	2195	1112	56	0	\N
234438	1678	2160041602000	2195	1112	57	0	\N
234439	1678	2160041603000	2195	1112	58	0	\N
234440	1678	2160041604000	2195	1112	59	0	\N
234441	1678	2160041605000	2195	1112	60	0	\N
234442	1678	2160041606000	2195	1112	61	0	\N
234443	1678	2160041607000	2196	1157	0	0	\N
234445	1678	2160041607000	2198	1157	0	0	\N
234449	1678	2160041611000	2200	1159	0	0	\N
234450	1678	2160041611000	2201	1159	0	0	\N
234452	1678	2160041611000	2203	1159	0	0	\N
234453	1678	2160041612000	2204	1160	0	0	\N
234454	1678	2160041613000	2204	1160	1	0	\N
234458	1678	2160041615000	2207	1162	0	0	\N
234459	1678	2160041616000	2207	1162	1	0	\N
234460	1678	2160041615000	2208	1162	0	0	\N
234461	1678	2160041616000	2208	1162	1	0	\N
234334	1678	2160041588000	2172	1146	0	0	0
234335	1678	2160041589000	2172	1146	1	0	0
234336	1678	2160041590000	2172	1146	2	0	0
234338	1678	2160041591000	2175	1147	0	0	0
234341	1678	2160041592000	2178	1148	0	0	0
234343	1678	2160041594000	2179	1149	1	0	0
234344	1678	2160041595000	2179	1149	2	0	0
234347	1678	2160041596000	2181	1150	0	0	0
234348	1678	2160041597000	2181	1150	1	0	0
234349	1678	2160041598000	2182	1151	0	0	0
234368	1678	2160041600000	2187	1152	1	0	0
234369	1678	2160041601000	2188	1153	0	0	0
234371	1678	2160041602000	2190	1154	0	0	0
234373	1678	2160041603000	2192	1155	0	0	0
234379	1678	2160041605000	2194	1156	1	0	0
234380	1678	2160041606000	2194	1156	2	0	0
234444	1678	2160041607000	2197	1157	0	0	0
234446	1678	2160041608000	2199	1158	0	0	0
234447	1678	2160041609000	2199	1158	1	0	0
234451	1678	2160041611000	2202	1159	0	0	0
234455	1678	2160041612000	2205	1160	0	0	0
234456	1678	2160041613000	2205	1160	1	0	0
234457	1678	2160041614000	2206	1161	0	0	0
234462	1678	2160041615000	2209	1162	0	0	0
234464	1678	2160041617000	2210	1163	0	0	0
234466	1678	2160041614000	2211	1161	0	0	\N
234470	1678	2160041621000	2215	1166	0	0	\N
234471	1678	2160041620000	2216	1165	0	0	\N
234472	1678	2160041621000	2216	1165	1	0	\N
234473	1678	2160041622000	2216	1165	2	0	\N
234474	1678	2160041622000	2217	1167	0	0	\N
234477	1678	2160041624000	2220	1169	0	0	\N
234479	1678	2160041624000	2222	1169	0	0	\N
234489	1678	2160041633000	2227	1174	0	0	\N
234492	1678	2160041634000	2230	1175	0	0	\N
234493	1678	2160041635000	2232	1177	0	0	\N
234494	1678	2160041636000	2232	1177	1	0	\N
234497	1758	2000000000	2234	1178	0	0	\N
234498	1678	2160041637000	2234	1178	1	0	\N
234501	1678	2160041638000	2236	1179	0	0	\N
234503	1678	2160041638000	2238	1179	0	0	\N
234508	1590	9900000000	2241	974	0	0	\N
234509	120	66001000000000	2241	974	1	0	\N
234510	165	66000100000000	2241	974	2	0	\N
234511	1713	500000000	2242	1182	0	0	\N
234512	1678	2160041643000	2242	1182	1	0	\N
234518	1678	2160041644000	2253	1184	0	0	\N
234519	1678	2160041645000	2253	1184	1	0	\N
234520	1678	2160041646000	2253	1184	2	0	\N
234521	1678	2160041644000	2254	1184	0	0	\N
234522	1678	2160041645000	2254	1184	1	0	\N
234523	1678	2160041646000	2254	1184	2	0	\N
234524	1678	2160041644000	2255	1184	0	0	\N
234525	1678	2160041645000	2255	1184	1	0	\N
234526	1678	2160041646000	2255	1184	2	0	\N
234527	1678	2160041644000	2256	1184	0	0	\N
234528	1678	2160041645000	2256	1184	1	0	\N
234529	1678	2160041646000	2256	1184	2	0	\N
234531	1678	2160041647000	2258	1185	0	0	\N
234538	1590	9900000000	2261	974	0	0	\N
234539	1760	2020000000	2261	974	1	0	\N
234544	1678	2160041652000	2263	1188	0	0	\N
234545	1761	10000000	2263	1188	1	0	\N
234546	1678	2160041653000	2263	1188	2	0	\N
234547	1678	2160041654000	2263	1188	3	0	\N
234548	1678	2160041655000	2264	1189	0	0	\N
234549	1678	2160041656000	2264	1189	1	0	\N
234550	1678	2160041655000	2265	1189	0	0	\N
234551	1678	2160041656000	2265	1189	1	0	\N
234554	1678	2160041657000	2267	1190	0	0	\N
234557	1678	2160041659000	2270	1192	0	0	\N
234558	1678	2160041659000	2272	1193	0	0	\N
234559	1678	2160041660000	2272	1193	1	0	\N
234560	1678	2160041659000	2273	1193	0	0	\N
234561	1678	2160041660000	2273	1193	1	0	\N
234564	1678	2160041659000	2275	1193	0	0	\N
234565	1678	2160041659000	2276	1193	0	0	\N
234567	1678	2160041661000	2278	1194	0	0	\N
234568	1678	2160041662000	2279	1195	0	0	\N
234570	1590	9900000000	2281	1016	0	0	\N
234571	120	66001000000000	2281	1016	1	0	\N
234572	165	66000100000000	2281	1016	2	0	\N
234573	1678	2160041407000	2281	1016	3	0	\N
234574	1678	2160041408000	2281	1016	4	0	\N
234575	1760	2020000000	2281	1016	5	0	\N
234576	1678	2160041409000	2281	1016	6	0	\N
234577	1678	2160041410000	2281	1016	7	0	\N
234578	1678	2160041411000	2281	1016	8	0	\N
234579	1678	2160041412000	2281	1016	9	0	\N
234582	1678	2160041665000	2283	1197	0	0	\N
234587	1678	2160041668000	2288	1200	0	0	\N
234589	1678	2160041670000	2292	1203	0	0	\N
234590	1678	2160041671000	2292	1203	1	0	\N
234591	1678	2160041672000	2292	1203	2	0	\N
234592	1678	2160041670000	2293	1203	0	0	\N
234593	1678	2160041671000	2293	1203	1	0	\N
234594	1678	2160041672000	2293	1203	2	0	\N
234598	1678	2160041673000	2295	1204	0	0	\N
234599	1678	2160041674000	2295	1204	1	0	\N
234468	1678	2160041620000	2213	1165	0	0	0
234469	1678	2160041621000	2214	1166	0	0	0
234475	1678	2160041622000	2218	1167	0	0	0
234476	1678	2160041623000	2219	1168	0	0	0
234478	1678	2160041624000	2221	1169	0	0	0
234481	1590	9900000000	2224	1171	0	0	0
234482	1678	2160041626000	2224	1171	1	0	0
234483	1678	2160041627000	2224	1171	2	0	0
234484	1678	2160041628000	2224	1171	3	0	0
234485	1678	2160041629000	2224	1171	4	0	0
234487	1678	2160041631000	2225	1172	1	0	0
234488	1678	2160041632000	2226	1173	0	0	0
234490	1678	2160041633000	2228	1174	0	0	0
234491	1678	2160041634000	2229	1175	0	0	0
234496	1678	2160041636000	2233	1177	1	0	0
234499	1758	2000000000	2235	1178	0	0	0
234500	1678	2160041637000	2235	1178	1	0	0
234502	1678	2160041638000	2237	1179	0	0	0
234504	1678	2160041639000	2239	1180	0	0	0
234506	1678	2160041641000	2240	1181	0	0	0
234507	1678	2160041642000	2240	1181	1	0	0
234513	1713	500000000	2243	1182	0	0	0
234514	1678	2160041643000	2243	1182	1	0	0
234515	1678	2160041644000	2251	1184	0	0	0
234517	1678	2160041646000	2251	1184	2	0	0
234530	1678	2160041647000	2257	1185	0	0	0
234532	1678	2160041648000	2259	1186	0	0	0
234533	1678	2160041649000	2259	1186	1	0	0
234535	1760	2020000000	2259	1186	3	0	0
234536	1678	2160041651000	2260	1187	0	0	0
234537	1761	10000000	2260	1187	1	0	0
234540	1678	2160041652000	2262	1188	0	0	0
234541	1761	10000000	2262	1188	1	0	0
234543	1678	2160041654000	2262	1188	3	0	0
234552	1678	2160041655000	2266	1189	0	0	0
234553	1678	2160041656000	2266	1189	1	0	0
234555	1678	2160041657000	2269	1191	0	0	0
234556	1678	2160041658000	2269	1191	1	0	0
234563	1678	2160041660000	2274	1193	1	0	0
234566	1678	2160041661000	2277	1194	0	0	0
234569	1678	2160041662000	2280	1195	0	0	0
234580	1678	2160041663000	2282	1196	0	0	0
234583	1678	2160041665000	2285	1198	0	0	0
234584	1678	2160041666000	2286	1199	0	0	0
234585	1678	2160041667000	2286	1199	1	0	0
234586	1678	2160041668000	2287	1200	0	0	0
234588	1678	2160041669000	2291	1202	0	0	0
234596	1678	2160041671000	2294	1203	1	0	0
234597	1678	2160041672000	2294	1203	2	0	0
234600	1678	2160041673000	2296	1204	0	0	0
234603	1678	2160041676000	2298	1206	0	0	\N
234604	1678	2160041676000	2299	1206	0	0	\N
234606	1590	9900000000	2301	1082	0	0	\N
234607	120	66001000000000	2301	1082	1	0	\N
234608	1678	2160041508000	2301	1082	2	0	\N
234609	1678	2160041509000	2301	1082	3	0	\N
234610	1678	2160041510000	2301	1082	4	0	\N
234611	1678	2160041511000	2301	1082	5	0	\N
234612	1678	2160041512000	2301	1082	6	0	\N
234613	1760	2020000000	2301	1082	7	0	\N
234614	1678	2160041513000	2301	1082	8	0	\N
234615	1678	2160041514000	2301	1082	9	0	\N
234616	1678	2160041515000	2301	1082	10	0	\N
234617	1678	2160041516000	2301	1082	11	0	\N
234618	1678	2160041517000	2301	1082	12	0	\N
234619	1678	2160041518000	2301	1082	13	0	\N
234620	1678	2160041519000	2301	1082	14	0	\N
234621	1678	2160041520000	2301	1082	15	0	\N
234622	1678	2160041521000	2301	1082	16	0	\N
234623	1678	2160041522000	2301	1082	17	0	\N
234624	1678	2160041523000	2301	1082	18	0	\N
234625	1678	2160041524000	2301	1082	19	0	\N
234626	1678	2160041525000	2301	1082	20	0	\N
234627	1678	2160041526000	2301	1082	21	0	\N
234628	1678	2160041527000	2301	1082	22	0	\N
234629	1678	2160041528000	2301	1082	23	0	\N
234630	1678	2160041529000	2301	1082	24	0	\N
234631	1678	2160041530000	2301	1082	25	0	\N
234632	1678	2160041531000	2301	1082	26	0	\N
234633	1678	2160041532000	2301	1082	27	0	\N
234634	1678	2160041533000	2301	1082	28	0	\N
234635	1678	2160041534000	2301	1082	29	0	\N
234636	1678	2160041535000	2301	1082	30	0	\N
234637	1678	2160041536000	2301	1082	31	0	\N
234638	1678	2160041537000	2301	1082	32	0	\N
234639	1678	2160041538000	2301	1082	33	0	\N
234640	1678	2160041539000	2301	1082	34	0	\N
234641	1678	2160041540000	2301	1082	35	0	\N
234642	1678	2160041541000	2301	1082	36	0	\N
234643	1678	2160041542000	2301	1082	37	0	\N
234644	1678	2160041543000	2301	1082	38	0	\N
234645	1678	2160041544000	2301	1082	39	0	\N
234646	1678	2160041545000	2301	1082	40	0	\N
234647	1678	2160041546000	2301	1082	41	0	\N
234648	1678	2160041547000	2301	1082	42	0	\N
234649	1678	2160041548000	2301	1082	43	0	\N
234650	1678	2160041549000	2301	1082	44	0	\N
234651	1678	2160041550000	2301	1082	45	0	\N
234652	1678	2160041551000	2301	1082	46	0	\N
234653	1678	2160041552000	2301	1082	47	0	\N
234654	1678	2160041553000	2301	1082	48	0	\N
234655	1678	2160041554000	2301	1082	49	0	\N
234656	1678	2160041555000	2301	1082	50	0	\N
234657	1678	2160041556000	2301	1082	51	0	\N
234658	1678	2160041557000	2301	1082	52	0	\N
234659	1678	2160041558000	2301	1082	53	0	\N
234660	1678	2160041559000	2301	1082	54	0	\N
234661	1678	2160041560000	2301	1082	55	0	\N
234662	1678	2160041561000	2301	1082	56	0	\N
234663	1678	2160041562000	2301	1082	57	0	\N
234664	1678	2160041563000	2301	1082	58	0	\N
234665	1678	2160041564000	2301	1082	59	0	\N
234666	1678	2160041565000	2301	1082	60	0	\N
234667	1678	2160041566000	2301	1082	61	0	\N
234668	1678	2160041567000	2301	1082	62	0	\N
234669	1678	2160041568000	2301	1082	63	0	\N
234670	1678	2160041569000	2301	1082	64	0	\N
234671	1678	2160041570000	2301	1082	65	0	\N
234672	1678	2160041571000	2301	1082	66	0	\N
234673	1678	2160041572000	2301	1082	67	0	\N
234674	1678	2160041573000	2301	1082	68	0	\N
234675	1678	2160041574000	2301	1082	69	0	\N
234676	1678	2160041575000	2301	1082	70	0	\N
234677	1678	2160041576000	2301	1082	71	0	\N
234678	1678	2160041577000	2301	1082	72	0	\N
234679	1678	2160041578000	2301	1082	73	0	\N
234680	1678	2160041579000	2301	1082	74	0	\N
234681	1678	2160041580000	2301	1082	75	0	\N
234682	1678	2160041581000	2301	1082	76	0	\N
234683	1678	2160041582000	2301	1082	77	0	\N
234684	1678	2160041583000	2301	1082	78	0	\N
234685	1678	2160041584000	2301	1082	79	0	\N
234686	1678	2160041585000	2301	1082	80	0	\N
234687	1678	2160041586000	2301	1082	81	0	\N
234688	1678	2160041587000	2301	1082	82	0	\N
234689	1678	2160041588000	2301	1082	83	0	\N
234690	1678	2160041589000	2301	1082	84	0	\N
234691	1678	2160041590000	2301	1082	86	0	\N
234692	1678	2160041591000	2301	1082	87	0	\N
234693	1678	2160041592000	2301	1082	88	0	\N
234694	1678	2160041593000	2301	1082	89	0	\N
234695	1678	2160041594000	2301	1082	90	0	\N
234696	1678	2160041595000	2301	1082	91	0	\N
234697	1678	2160041596000	2301	1082	92	0	\N
234698	1678	2160041597000	2301	1082	93	0	\N
234699	1678	2160041598000	2301	1082	94	0	\N
234700	1678	2160041599000	2301	1082	95	0	\N
234701	1678	2160041600000	2301	1082	96	0	\N
234702	1678	2160041601000	2301	1082	97	0	\N
234703	1678	2160041602000	2301	1082	98	0	\N
234704	1678	2160041603000	2301	1082	99	0	\N
234705	1678	2160041604000	2301	1082	100	0	\N
234706	1678	2160041605000	2301	1082	101	0	\N
234707	1678	2160041606000	2301	1082	102	0	\N
234708	1678	2160041607000	2301	1082	103	0	\N
234709	1678	2160041608000	2301	1082	104	0	\N
234710	1678	2160041609000	2301	1082	105	0	\N
234711	1678	2160041610000	2301	1082	106	0	\N
234712	1678	2160041611000	2301	1082	107	0	\N
234713	1678	2160041612000	2301	1082	108	0	\N
234714	1678	2160041613000	2301	1082	109	0	\N
234715	1678	2160041614000	2301	1082	110	0	\N
234716	1678	2160041615000	2301	1082	111	0	\N
234717	1678	2160041616000	2301	1082	112	0	\N
234718	1678	2160041617000	2301	1082	113	0	\N
234719	1678	2160041618000	2301	1082	114	0	\N
234720	1678	2160041619000	2301	1082	115	0	\N
234721	1678	2160041620000	2301	1082	116	0	\N
234722	1678	2160041621000	2301	1082	117	0	\N
234723	1678	2160041622000	2301	1082	118	0	\N
234724	1678	2160041623000	2301	1082	119	0	\N
234725	1678	2160041624000	2301	1082	120	0	\N
234726	1678	2160041625000	2301	1082	121	0	\N
234727	1678	2160041626000	2301	1082	122	0	\N
234728	1678	2160041627000	2301	1082	123	0	\N
234729	1678	2160041628000	2301	1082	124	0	\N
234730	1678	2160041629000	2301	1082	125	0	\N
234731	1678	2160041677000	2302	1207	0	0	\N
234735	1678	2160041679000	2308	1209	0	0	\N
234736	1678	2160041680000	2311	1210	0	0	\N
234605	1678	2160041676000	2300	1206	0	0	0
234732	1678	2160041677000	2303	1207	0	0	0
234733	1678	2160041678000	2304	1208	0	0	0
234734	1678	2160041679000	2306	1209	0	0	0
234737	1678	2160041681000	2311	1210	1	0	\N
234738	1678	2160041682000	2311	1210	2	0	\N
234742	1678	2160041670000	2313	1203	0	0	\N
234743	1678	2160041671000	2313	1203	1	0	\N
234744	1678	2160041672000	2313	1203	2	0	\N
234745	1678	2160041673000	2313	1203	3	0	\N
234746	1678	2160041674000	2313	1203	4	0	\N
234747	1678	2160041675000	2313	1203	5	0	\N
234748	1678	2160041676000	2313	1203	6	0	\N
234749	1678	2160041677000	2313	1203	7	0	\N
234750	1678	2160041678000	2313	1203	8	0	\N
234751	1678	2160041679000	2313	1203	9	0	\N
234752	1678	2160041680000	2313	1203	10	0	\N
234753	1678	2160041681000	2313	1203	11	0	\N
234754	1678	2160041682000	2313	1203	12	0	\N
234755	1678	2160041683000	2314	1211	0	0	\N
234761	1678	2160041688000	2319	1214	0	0	\N
234763	1678	2160041689000	2321	1215	0	0	\N
234770	1678	2160041693000	2327	1219	0	0	\N
234771	1678	2160041694000	2327	1219	1	0	\N
234772	1678	2160041693000	2328	1219	0	0	\N
234773	1678	2160041694000	2328	1219	1	0	\N
234774	1678	2160041693000	2329	1219	0	0	\N
234775	1678	2160041694000	2329	1219	1	0	\N
234776	1678	2160041695000	2331	1220	0	0	\N
234777	1678	2160041696000	2331	1220	1	0	\N
234778	1678	2160041697000	2331	1220	2	0	\N
234779	1678	2160041695000	2332	1220	0	0	\N
234780	1678	2160041696000	2332	1220	1	0	\N
234781	1678	2160041697000	2332	1220	2	0	\N
234782	1678	2160041695000	2333	1220	0	0	\N
234783	1678	2160041696000	2333	1220	1	0	\N
234784	1678	2160041697000	2333	1220	2	0	\N
234785	1678	2160041695000	2334	1220	0	0	\N
234786	1678	2160041696000	2334	1220	1	0	\N
234787	1678	2160041697000	2334	1220	2	0	\N
234788	1678	2160041695000	2335	1220	0	0	\N
234789	1678	2160041696000	2335	1220	1	0	\N
234790	1678	2160041697000	2335	1220	2	0	\N
234795	1678	2160041699000	2338	1222	0	0	\N
234796	1678	2160041699000	2339	1222	0	0	\N
234800	1678	2160041699000	2341	1223	0	0	\N
234801	1678	2160041700000	2341	1223	1	0	\N
234802	1678	2160041701000	2341	1223	2	0	\N
234805	1678	2160041702000	2343	1224	0	0	\N
234806	1678	2160041703000	2343	1224	1	0	\N
234811	1678	2160041707000	2346	1226	0	0	\N
234816	1678	2160041710000	2350	1229	0	0	\N
234817	1678	2160041711000	2350	1229	1	0	\N
234818	1678	2160041710000	2351	1229	0	0	\N
234819	1678	2160041711000	2351	1229	1	0	\N
234820	1678	2160041710000	2352	1229	0	0	\N
234821	1678	2160041711000	2352	1229	1	0	\N
234823	1678	2160041713000	2355	1231	0	0	\N
234824	1678	2160041714000	2355	1231	1	0	\N
234830	1678	2160041717000	2360	1234	0	0	\N
234831	1678	2160041717000	2361	1234	0	0	\N
234832	1590	9900000000	2362	1062	0	0	\N
234833	120	66001000000000	2362	1062	1	0	\N
234834	1678	2160041474000	2362	1062	2	0	\N
234835	1678	2160041475000	2362	1062	3	0	\N
234836	1678	2160041476000	2362	1062	4	0	\N
234837	1760	2020000000	2362	1062	5	0	\N
234838	1678	2160041477000	2362	1062	6	0	\N
234839	1678	2160041478000	2362	1062	7	0	\N
234840	1678	2160041479000	2362	1062	8	0	\N
234841	1678	2160041480000	2362	1062	9	0	\N
234842	1678	2160041481000	2362	1062	10	0	\N
234843	1678	2160041482000	2362	1062	11	0	\N
234844	1678	2160041483000	2362	1062	12	0	\N
234845	1678	2160041484000	2362	1062	13	0	\N
234846	1678	2160041485000	2362	1062	14	0	\N
234847	1678	2160041486000	2362	1062	15	0	\N
234848	1678	2160041487000	2362	1062	16	0	\N
234849	1678	2160041488000	2362	1062	17	0	\N
234850	1678	2160041489000	2362	1062	18	0	\N
234851	1678	2160041490000	2362	1062	19	0	\N
234852	1678	2160041491000	2362	1062	20	0	\N
234853	1678	2160041492000	2362	1062	21	0	\N
234854	1678	2160041493000	2362	1062	22	0	\N
234855	1678	2160041494000	2362	1062	23	0	\N
234856	1678	2160041495000	2362	1062	24	0	\N
234857	1678	2160041496000	2362	1062	25	0	\N
234858	1678	2160041497000	2362	1062	26	0	\N
234859	1678	2160041498000	2362	1062	27	0	\N
234860	1678	2160041499000	2362	1062	28	0	\N
234861	1678	2160041500000	2362	1062	29	0	\N
234862	1678	2160041501000	2362	1062	30	0	\N
234863	1678	2160041502000	2362	1062	32	0	\N
234864	1678	2160041503000	2362	1062	33	0	\N
234865	1678	2160041504000	2362	1062	34	0	\N
234866	1678	2160041505000	2362	1062	35	0	\N
234867	1678	2160041506000	2362	1062	36	0	\N
234868	1678	2160041507000	2362	1062	37	0	\N
234869	1678	2160041508000	2362	1062	38	0	\N
234870	1678	2160041509000	2362	1062	39	0	\N
234871	1678	2160041510000	2362	1062	40	0	\N
234872	1678	2160041511000	2362	1062	41	0	\N
234741	1678	2160041682000	2312	1210	2	0	0
234756	1678	2160041683000	2315	1211	0	0	0
234757	1678	2160041684000	2316	1212	0	0	0
234758	1678	2160041685000	2316	1212	1	0	0
234759	1678	2160041686000	2317	1213	0	0	0
234762	1678	2160041688000	2320	1214	0	0	0
234764	1678	2160041689000	2322	1215	0	0	0
234765	1678	2160041690000	2323	1216	0	0	0
234766	1678	2160041691000	2324	1217	0	0	0
234767	1678	2160041692000	2325	1218	0	0	0
234769	1678	2160041694000	2326	1219	1	0	0
234791	1678	2160041695000	2336	1221	0	0	0
234792	1678	2160041696000	2336	1221	1	0	0
234793	1678	2160041697000	2336	1221	2	0	0
234797	1678	2160041699000	2340	1223	0	0	0
234798	1678	2160041700000	2340	1223	1	0	0
234799	1678	2160041701000	2340	1223	2	0	0
234803	1678	2160041702000	2342	1224	0	0	0
234804	1678	2160041703000	2342	1224	1	0	0
234808	1678	2160041705000	2344	1225	1	0	0
234809	1678	2160041706000	2344	1225	2	0	0
234810	1678	2160041707000	2345	1226	0	0	0
234812	1678	2160041708000	2347	1227	0	0	0
234813	1678	2160041709000	2348	1228	0	0	0
234815	1678	2160041711000	2349	1229	1	0	0
234822	1678	2160041712000	2353	1230	0	0	0
234825	1678	2160041713000	2356	1231	0	0	0
234826	1678	2160041714000	2356	1231	1	0	0
234828	1678	2160041716000	2358	1233	0	0	0
234829	1678	2160041717000	2359	1234	0	0	0
234873	1678	2160041512000	2362	1062	42	0	\N
234874	1678	2160041513000	2362	1062	43	0	\N
234875	1678	2160041514000	2362	1062	44	0	\N
234876	1678	2160041515000	2362	1062	45	0	\N
234877	1678	2160041516000	2362	1062	46	0	\N
234878	1678	2160041517000	2362	1062	47	0	\N
234879	1678	2160041518000	2362	1062	48	0	\N
234880	1678	2160041519000	2362	1062	49	0	\N
234881	1678	2160041520000	2362	1062	50	0	\N
234882	1678	2160041521000	2362	1062	51	0	\N
234883	1678	2160041522000	2362	1062	52	0	\N
234884	1678	2160041523000	2362	1062	53	0	\N
234885	1678	2160041524000	2362	1062	54	0	\N
234886	1678	2160041525000	2362	1062	55	0	\N
234887	1678	2160041526000	2362	1062	56	0	\N
234888	1678	2160041527000	2362	1062	57	0	\N
234889	1678	2160041528000	2362	1062	58	0	\N
234890	1678	2160041529000	2362	1062	59	0	\N
234891	1678	2160041530000	2362	1062	60	0	\N
234892	1678	2160041531000	2362	1062	61	0	\N
234893	1678	2160041532000	2362	1062	62	0	\N
234894	1678	2160041533000	2362	1062	63	0	\N
234895	1678	2160041534000	2362	1062	64	0	\N
234896	1678	2160041535000	2362	1062	65	0	\N
234897	1678	2160041536000	2362	1062	66	0	\N
234898	1678	2160041537000	2362	1062	67	0	\N
234899	1678	2160041538000	2362	1062	68	0	\N
234900	1678	2160041539000	2362	1062	69	0	\N
234901	1678	2160041540000	2362	1062	70	0	\N
234902	1678	2160041541000	2362	1062	71	0	\N
234903	1678	2160041542000	2362	1062	72	0	\N
234904	1678	2160041543000	2362	1062	73	0	\N
234905	1678	2160041544000	2362	1062	74	0	\N
234906	1678	2160041545000	2362	1062	75	0	\N
234907	1678	2160041546000	2362	1062	76	0	\N
234908	1678	2160041547000	2362	1062	77	0	\N
234909	1678	2160041548000	2362	1062	78	0	\N
234910	1678	2160041549000	2362	1062	79	0	\N
234911	1678	2160041550000	2362	1062	80	0	\N
234912	1678	2160041551000	2362	1062	81	0	\N
234913	1678	2160041552000	2362	1062	82	0	\N
234914	1678	2160041553000	2362	1062	83	0	\N
234915	1678	2160041554000	2362	1062	84	0	\N
234916	1678	2160041555000	2362	1062	85	0	\N
234917	1678	2160041556000	2362	1062	86	0	\N
234918	1678	2160041557000	2362	1062	87	0	\N
234919	1678	2160041558000	2362	1062	88	0	\N
234920	1678	2160041559000	2362	1062	89	0	\N
234921	1678	2160041560000	2362	1062	90	0	\N
234922	1678	2160041561000	2362	1062	91	0	\N
234923	1678	2160041562000	2362	1062	92	0	\N
234924	1678	2160041563000	2362	1062	93	0	\N
234925	1678	2160041564000	2362	1062	94	0	\N
234926	1678	2160041565000	2362	1062	95	0	\N
234927	1678	2160041566000	2362	1062	96	0	\N
234928	1678	2160041567000	2362	1062	97	0	\N
234929	1678	2160041568000	2362	1062	98	0	\N
234930	1678	2160041569000	2362	1062	99	0	\N
234931	1678	2160041570000	2362	1062	100	0	\N
234932	1678	2160041571000	2362	1062	101	0	\N
234933	1678	2160041572000	2362	1062	102	0	\N
234934	1678	2160041573000	2362	1062	103	0	\N
234935	1678	2160041574000	2362	1062	104	0	\N
234936	1678	2160041575000	2362	1062	105	0	\N
234937	1678	2160041576000	2362	1062	106	0	\N
234938	1678	2160041577000	2362	1062	107	0	\N
234939	1678	2160041578000	2362	1062	108	0	\N
234940	1678	2160041579000	2362	1062	109	0	\N
234941	1678	2160041580000	2362	1062	110	0	\N
234942	1678	2160041581000	2362	1062	111	0	\N
234943	1678	2160041582000	2362	1062	112	0	\N
234944	1678	2160041583000	2362	1062	113	0	\N
234945	1678	2160041584000	2362	1062	114	0	\N
234946	1678	2160041585000	2362	1062	115	0	\N
234947	1678	2160041586000	2362	1062	116	0	\N
234948	1678	2160041587000	2362	1062	117	0	\N
234949	1678	2160041588000	2362	1062	118	0	\N
234950	1678	2160041589000	2362	1062	119	0	\N
234951	1678	2160041590000	2362	1062	120	0	\N
234952	1678	2160041591000	2362	1062	121	0	\N
234953	1678	2160041592000	2362	1062	122	0	\N
234954	1678	2160041593000	2362	1062	123	0	\N
234955	1678	2160041594000	2362	1062	124	0	\N
234956	1678	2160041595000	2362	1062	125	0	\N
234960	1678	2160041718000	2364	1235	0	0	\N
234961	1678	2160041719000	2364	1235	1	0	\N
234962	510	66720000000000	2364	1235	2	0	\N
234963	1678	2160041720000	2365	1236	0	0	\N
234965	1678	2160041721000	2367	1237	0	0	\N
234967	1678	2160041721000	2369	1237	0	0	\N
234968	1678	2160041722000	2370	1238	0	0	\N
234969	1678	2160041723000	2370	1238	1	0	\N
234975	1678	2160041727000	2375	1242	0	0	\N
234981	1678	2160041731000	2381	1246	0	0	\N
234982	1678	2160041731000	2382	1246	0	0	\N
234983	1678	2160041731000	2383	1246	0	0	\N
234984	1678	2160041731000	2384	1246	0	0	\N
234985	1678	2160041732000	2385	1247	0	0	\N
234986	1678	2160041732000	2386	1247	0	0	\N
234987	1678	2160041732000	2387	1247	0	0	\N
234992	1678	2160041735000	2392	1250	0	0	\N
234993	1678	2160041735000	2393	1250	0	0	\N
235004	1678	2160041744000	2399	1255	0	0	\N
235005	1678	2160041744000	2400	1255	0	0	\N
235006	1678	2160041745000	2401	1256	0	0	\N
235007	1678	2160041745000	2402	1256	0	0	\N
234959	510	66720000000000	2363	1235	2	0	0
234964	1678	2160041720000	2366	1236	0	0	0
234966	1678	2160041721000	2368	1237	0	0	0
234970	1678	2160041722000	2371	1238	0	0	0
234971	1678	2160041723000	2371	1238	1	0	0
234973	1678	2160041725000	2373	1240	0	0	0
234974	1678	2160041726000	2374	1241	0	0	0
234976	1678	2160041727000	2376	1242	0	0	0
234977	1678	2160041728000	2377	1243	0	0	0
234978	1678	2160041729000	2378	1244	0	0	0
234980	1678	2160041731000	2380	1246	0	0	0
234988	1678	2160041732000	2388	1247	0	0	0
234989	1678	2160041733000	2389	1248	0	0	0
234990	1483	0	2390	1249	0	0	0
234994	1678	2160041735000	2394	1251	0	0	0
234995	1678	2160041736000	2394	1251	1	0	0
234996	1678	2160041737000	2395	1252	0	0	0
234997	1678	2160041738000	2395	1252	1	0	0
234998	1678	2160041739000	2395	1252	2	0	0
235000	1678	2160041741000	2396	1253	0	0	0
235001	1678	2160041742000	2397	1254	0	0	0
235002	1678	2160041743000	2397	1254	1	0	0
235003	1678	2160041744000	2398	1255	0	0	0
235008	1678	2160041745000	2403	1256	0	0	0
235011	1678	2160041747000	2406	1258	0	0	\N
235015	1678	2160041750000	2409	1260	0	0	\N
235016	1678	2160041751000	2410	1261	0	0	\N
235020	1678	2160041754000	2413	1263	0	0	\N
235025	1678	2160041756000	2417	1265	0	0	\N
235026	1678	2160041757000	2417	1265	1	0	\N
235027	1678	2160041756000	2418	1265	0	0	\N
235028	1678	2160041757000	2418	1265	1	0	\N
235032	1647	0	2420	1266	0	0	\N
235033	1678	2160041758000	2420	1266	1	0	\N
235034	1678	2160041759000	2420	1266	2	0	\N
235035	1678	2160041760000	2421	1267	0	0	\N
235040	1678	2160041764000	2425	1270	0	0	\N
235043	1678	2160041765000	2428	1271	0	0	\N
235045	1678	2160041766000	2430	1272	0	0	\N
235046	1678	2160041767000	2431	1273	0	0	\N
235048	1678	2160041767000	2433	1273	0	0	\N
235049	1678	2160041768000	2434	1274	0	0	\N
235050	1678	2160041769000	2434	1274	1	0	\N
235053	1678	2160041770000	2436	1275	0	0	\N
235054	1678	2160041771000	2436	1275	1	0	\N
235055	1678	2160041772000	2436	1275	2	0	\N
235056	1678	2160041770000	2437	1275	0	0	\N
235057	1678	2160041771000	2437	1275	1	0	\N
235058	1678	2160041772000	2437	1275	2	0	\N
235062	1678	2160041773000	2439	1276	0	0	\N
235064	1678	2160041774000	2441	1277	0	0	\N
235065	1678	2160041774000	2442	1277	0	0	\N
235069	1678	2160041776000	2446	1279	0	0	\N
235071	1678	2160041778000	2448	1281	0	0	\N
235074	1678	2160041779000	2451	1282	0	0	\N
235077	1678	2160041782000	2453	1284	0	0	\N
235078	1678	2160041782000	2454	1284	0	0	\N
235086	1678	2160041788000	2459	1287	0	0	\N
235087	1678	2160041789000	2460	1288	0	0	\N
235091	1678	2160041790000	2463	1289	0	0	\N
235092	1678	2160041791000	2463	1289	1	0	\N
235094	1678	2160041792000	2465	1290	0	0	\N
235100	1678	2160041797000	2470	1294	0	0	\N
235101	1678	2160041797000	2471	1294	0	0	\N
235102	1678	2160041798000	2472	1295	0	0	\N
235103	1678	2160041798000	2473	1295	0	0	\N
235111	1678	2160041805000	2477	1298	0	0	\N
235112	1678	2160041805000	2478	1298	0	0	\N
235116	1678	2160041808000	2482	1301	0	0	\N
235117	1678	2160041809000	2482	1301	1	0	\N
235118	1678	2160041808000	2483	1301	0	0	\N
235119	1678	2160041809000	2483	1301	1	0	\N
235120	1483	0	2485	1230	0	0	\N
235121	1647	0	2485	1230	1	0	\N
235122	1678	2160041712000	2485	1230	2	0	\N
235123	1678	2160041713000	2485	1230	3	0	\N
235124	1678	2160041714000	2485	1230	4	0	\N
235125	510	66720000000000	2485	1230	5	0	\N
235126	1678	2160041715000	2485	1230	6	0	\N
235127	1678	2160041716000	2485	1230	7	0	\N
235128	1678	2160041717000	2485	1230	8	0	\N
235129	1678	2160041718000	2485	1230	9	0	\N
235130	1678	2160041719000	2485	1230	10	0	\N
235131	1678	2160041720000	2485	1230	11	0	\N
235132	1678	2160041721000	2485	1230	12	0	\N
235133	1678	2160041722000	2485	1230	13	0	\N
235134	1678	2160041723000	2485	1230	14	0	\N
235135	1678	2160041724000	2485	1230	15	0	\N
235136	1678	2160041725000	2485	1230	16	0	\N
235137	1678	2160041726000	2485	1230	17	0	\N
235138	1678	2160041727000	2485	1230	18	0	\N
235139	1678	2160041728000	2485	1230	19	0	\N
235140	1678	2160041729000	2485	1230	20	0	\N
235141	1678	2160041730000	2485	1230	21	0	\N
235142	1678	2160041731000	2485	1230	22	0	\N
235143	1678	2160041732000	2485	1230	23	0	\N
235144	1678	2160041733000	2485	1230	24	0	\N
235012	1678	2160041748000	2407	1259	0	0	0
235013	1678	2160041749000	2407	1259	1	0	0
235014	1678	2160041750000	2408	1260	0	0	0
235017	1678	2160041751000	2411	1261	0	0	0
235018	1678	2160041752000	2412	1262	0	0	0
235021	1678	2160041754000	2414	1263	0	0	0
235022	1678	2160041755000	2415	1264	0	0	0
235023	1678	2160041756000	2416	1265	0	0	0
235024	1678	2160041757000	2416	1265	1	0	0
235029	1647	0	2419	1266	0	0	0
235031	1678	2160041759000	2419	1266	2	0	0
235036	1678	2160041760000	2422	1267	0	0	0
235037	1678	2160041761000	2423	1268	0	0	0
235038	1678	2160041762000	2423	1268	1	0	0
235041	1678	2160041764000	2426	1270	0	0	0
235042	1678	2160041765000	2427	1271	0	0	0
235044	1678	2160041766000	2429	1272	0	0	0
235047	1678	2160041767000	2432	1273	0	0	0
235051	1678	2160041768000	2435	1274	0	0	0
235059	1678	2160041770000	2438	1275	0	0	0
235060	1678	2160041771000	2438	1275	1	0	0
235061	1678	2160041772000	2438	1275	2	0	0
235063	1678	2160041773000	2440	1276	0	0	0
235066	1678	2160041774000	2443	1277	0	0	0
235068	1678	2160041776000	2445	1279	0	0	0
235070	1678	2160041777000	2447	1280	0	0	0
235072	1678	2160041778000	2449	1281	0	0	0
235073	1678	2160041779000	2450	1282	0	0	0
235076	1678	2160041781000	2452	1283	1	0	0
235079	1678	2160041782000	2455	1284	0	0	0
235080	1678	2160041783000	2456	1285	0	0	0
235081	1678	2160041784000	2456	1285	1	0	0
235082	1678	2160041785000	2456	1285	2	0	0
235084	1678	2160041787000	2457	1286	0	0	0
235085	1678	2160041788000	2458	1287	0	0	0
235088	1678	2160041789000	2461	1288	0	0	0
235089	1678	2160041790000	2462	1289	0	0	0
235090	1678	2160041791000	2462	1289	1	0	0
235095	1678	2160041793000	2466	1291	0	0	0
235096	1678	2160041794000	2467	1292	0	0	0
235097	1678	2160041795000	2467	1292	1	0	0
235098	1678	2160041796000	2468	1293	0	0	0
235104	1678	2160041798000	2474	1295	0	0	0
235105	1678	2160041799000	2475	1296	0	0	0
235106	1678	2160041800000	2475	1296	1	0	0
235107	1678	2160041801000	2475	1296	2	0	0
235108	1678	2160041802000	2475	1296	3	0	0
235110	1678	2160041804000	2476	1297	0	0	0
235113	1678	2160041805000	2479	1298	0	0	0
235114	1678	2160041806000	2480	1299	0	0	0
235115	1678	2160041807000	2480	1299	1	0	0
235145	1678	2160041734000	2485	1230	25	0	\N
235146	1678	2160041735000	2485	1230	26	0	\N
235147	1678	2160041736000	2485	1230	27	0	\N
235148	1678	2160041737000	2485	1230	28	0	\N
235149	1678	2160041738000	2485	1230	29	0	\N
235150	1678	2160041739000	2485	1230	30	0	\N
235151	1678	2160041740000	2485	1230	31	0	\N
235152	1678	2160041741000	2485	1230	32	0	\N
235153	1678	2160041742000	2485	1230	33	0	\N
235154	1678	2160041743000	2485	1230	34	0	\N
235155	1678	2160041744000	2485	1230	35	0	\N
235156	1678	2160041745000	2485	1230	36	0	\N
235157	1678	2160041746000	2485	1230	37	0	\N
235158	1678	2160041747000	2485	1230	38	0	\N
235159	1678	2160041748000	2485	1230	39	0	\N
235160	1678	2160041749000	2485	1230	40	0	\N
235161	1678	2160041750000	2485	1230	41	0	\N
235162	1678	2160041751000	2485	1230	42	0	\N
235163	1678	2160041752000	2485	1230	43	0	\N
235164	1678	2160041753000	2485	1230	44	0	\N
235165	1678	2160041754000	2485	1230	45	0	\N
235166	1678	2160041755000	2485	1230	46	0	\N
235167	1678	2160041756000	2485	1230	47	0	\N
235168	1678	2160041757000	2485	1230	48	0	\N
235169	1678	2160041758000	2485	1230	49	0	\N
235170	1678	2160041759000	2485	1230	50	0	\N
235171	1678	2160041760000	2485	1230	51	0	\N
235172	1678	2160041761000	2485	1230	52	0	\N
235173	1678	2160041762000	2485	1230	53	0	\N
235174	1678	2160041763000	2485	1230	54	0	\N
235175	1678	2160041764000	2485	1230	55	0	\N
235176	1678	2160041765000	2485	1230	56	0	\N
235177	1678	2160041766000	2485	1230	57	0	\N
235178	1678	2160041767000	2485	1230	58	0	\N
235179	1678	2160041768000	2485	1230	59	0	\N
235180	1678	2160041769000	2485	1230	60	0	\N
235181	1678	2160041770000	2485	1230	61	0	\N
235182	1678	2160041771000	2485	1230	62	0	\N
235183	1678	2160041772000	2485	1230	63	0	\N
235184	1678	2160041773000	2485	1230	64	0	\N
235185	1678	2160041774000	2485	1230	65	0	\N
235186	1678	2160041775000	2485	1230	66	0	\N
235187	1678	2160041776000	2485	1230	67	0	\N
235188	1678	2160041777000	2485	1230	68	0	\N
235189	1678	2160041778000	2485	1230	69	0	\N
235190	1678	2160041779000	2485	1230	70	0	\N
235191	1678	2160041780000	2485	1230	71	0	\N
235192	1678	2160041781000	2485	1230	72	0	\N
235193	1678	2160041782000	2485	1230	73	0	\N
235194	1678	2160041783000	2485	1230	74	0	\N
235195	1678	2160041784000	2485	1230	75	0	\N
235196	1678	2160041785000	2485	1230	76	0	\N
235197	1678	2160041786000	2485	1230	77	0	\N
235198	1678	2160041787000	2485	1230	78	0	\N
235199	1678	2160041788000	2485	1230	79	0	\N
235200	1678	2160041789000	2485	1230	80	0	\N
235201	1678	2160041790000	2485	1230	81	0	\N
235202	1678	2160041791000	2485	1230	82	0	\N
235203	1678	2160041792000	2485	1230	83	0	\N
235204	1678	2160041793000	2485	1230	84	0	\N
235205	1678	2160041794000	2485	1230	85	0	\N
235206	1678	2160041795000	2485	1230	86	0	\N
235207	1678	2160041796000	2485	1230	87	0	\N
235208	1678	2160041797000	2485	1230	88	0	\N
235209	1678	2160041798000	2485	1230	89	0	\N
235210	1678	2160041799000	2485	1230	90	0	\N
235211	1678	2160041800000	2485	1230	91	0	\N
235212	1678	2160041801000	2485	1230	92	0	\N
235213	1678	2160041802000	2485	1230	93	0	\N
235214	1678	2160041803000	2485	1230	94	0	\N
235215	1678	2160041804000	2485	1230	95	0	\N
235216	1678	2160041805000	2485	1230	96	0	\N
235217	1678	2160041806000	2485	1230	97	0	\N
235218	1678	2160041807000	2485	1230	99	0	\N
235219	1678	2160041808000	2485	1230	100	0	\N
235220	1678	2160041809000	2485	1230	101	0	\N
235221	1678	2160041810000	2485	1230	102	0	\N
235226	1678	2160041811000	2488	1303	0	0	\N
235227	1678	2160041812000	2489	1304	0	0	\N
235229	1678	2160041813000	2491	1305	0	0	\N
235231	1678	2160041813000	2493	1305	0	0	\N
235234	1678	2160041814000	2495	1306	0	0	\N
235235	1763	0	2495	1306	1	0	\N
235240	1678	2160041819000	2497	1308	0	0	\N
235247	1647	0	2501	1266	0	0	\N
235248	1763	0	2501	1266	1	0	\N
235249	1678	2160041758000	2501	1266	2	0	\N
235250	1678	2160041759000	2501	1266	3	0	\N
235251	1678	2160041760000	2501	1266	4	0	\N
235252	1678	2160041761000	2501	1266	5	0	\N
235253	1678	2160041762000	2501	1266	6	0	\N
235254	1678	2160041763000	2501	1266	7	0	\N
235255	1678	2160041764000	2501	1266	8	0	\N
235256	1678	2160041765000	2501	1266	9	0	\N
235257	1678	2160041766000	2501	1266	10	0	\N
235258	1678	2160041767000	2501	1266	11	0	\N
235259	1678	2160041768000	2501	1266	12	0	\N
235260	1678	2160041769000	2501	1266	13	0	\N
235261	1678	2160041770000	2501	1266	14	0	\N
235262	1678	2160041771000	2501	1266	15	0	\N
235263	1678	2160041772000	2501	1266	16	0	\N
235264	1678	2160041773000	2501	1266	17	0	\N
235265	1678	2160041774000	2501	1266	18	0	\N
235266	1678	2160041775000	2501	1266	19	0	\N
235267	1678	2160041776000	2501	1266	20	0	\N
235268	1678	2160041777000	2501	1266	21	0	\N
235269	1678	2160041778000	2501	1266	22	0	\N
235270	1678	2160041779000	2501	1266	23	0	\N
235271	1678	2160041780000	2501	1266	24	0	\N
235272	1678	2160041781000	2501	1266	25	0	\N
235273	1678	2160041782000	2501	1266	26	0	\N
235274	1678	2160041783000	2501	1266	27	0	\N
235275	1678	2160041784000	2501	1266	28	0	\N
235276	1678	2160041785000	2501	1266	29	0	\N
235277	1678	2160041786000	2501	1266	30	0	\N
235278	1678	2160041787000	2501	1266	31	0	\N
235279	1678	2160041788000	2501	1266	32	0	\N
235280	1678	2160041789000	2501	1266	33	0	\N
235224	1678	2160041810000	2486	1302	2	0	0
235225	1678	2160041811000	2487	1303	0	0	0
235228	1678	2160041812000	2490	1304	0	0	0
235230	1678	2160041813000	2492	1305	0	0	0
235232	1678	2160041814000	2494	1306	0	0	0
235236	1678	2160041815000	2496	1307	0	0	0
235237	1678	2160041816000	2496	1307	1	0	0
235238	1678	2160041817000	2496	1307	2	0	0
235239	1678	2160041818000	2496	1307	3	0	0
235241	1678	2160041819000	2498	1308	0	0	0
235243	1678	2160041821000	2500	1310	0	0	0
235244	1678	2160041822000	2500	1310	1	0	0
235245	1678	2160041823000	2500	1310	2	0	0
235246	1678	2160041824000	2500	1310	3	0	0
235281	1678	2160041790000	2501	1266	34	0	\N
235282	1678	2160041791000	2501	1266	35	0	\N
235283	1678	2160041792000	2501	1266	36	0	\N
235284	1678	2160041793000	2501	1266	37	0	\N
235285	1678	2160041794000	2501	1266	38	0	\N
235286	1678	2160041795000	2501	1266	39	0	\N
235287	1678	2160041796000	2501	1266	40	0	\N
235288	1678	2160041797000	2501	1266	41	0	\N
235289	1678	2160041798000	2501	1266	42	0	\N
235290	1678	2160041799000	2501	1266	43	0	\N
235291	1678	2160041800000	2501	1266	44	0	\N
235292	1678	2160041801000	2501	1266	45	0	\N
235293	1678	2160041802000	2501	1266	46	0	\N
235294	1678	2160041803000	2501	1266	47	0	\N
235295	1678	2160041804000	2501	1266	48	0	\N
235296	1678	2160041805000	2501	1266	49	0	\N
235297	1678	2160041806000	2501	1266	50	0	\N
235298	1678	2160041807000	2501	1266	51	0	\N
235299	1678	2160041808000	2501	1266	52	0	\N
235300	1678	2160041809000	2501	1266	53	0	\N
235301	1678	2160041810000	2501	1266	54	0	\N
235302	1678	2160041811000	2501	1266	55	0	\N
235303	1678	2160041812000	2501	1266	56	0	\N
235304	1678	2160041813000	2501	1266	57	0	\N
235305	1678	2160041814000	2501	1266	58	0	\N
235306	1678	2160041815000	2501	1266	59	0	\N
235307	1678	2160041816000	2501	1266	60	0	\N
235308	1678	2160041817000	2501	1266	61	0	\N
235309	1678	2160041818000	2501	1266	62	0	\N
235310	1678	2160041819000	2501	1266	63	0	\N
235311	1678	2160041820000	2501	1266	64	0	\N
235312	1678	2160041821000	2501	1266	65	0	\N
235313	1678	2160041822000	2501	1266	66	0	\N
235314	1678	2160041823000	2501	1266	67	0	\N
235315	1678	2160041824000	2501	1266	68	0	\N
235320	1756	7919139000000	2503	1311	0	0	\N
235321	1678	2160041825000	2503	1311	1	0	\N
235322	1678	2160041826000	2503	1311	2	0	\N
235323	1678	2160041827000	2503	1311	3	0	\N
235329	1678	2160041833000	2508	1316	0	0	\N
235330	1678	2160041834000	2508	1316	1	0	\N
235331	1678	2160041835000	2508	1316	2	0	\N
235336	1678	2160041837000	2511	1318	0	0	\N
235337	1678	2160041838000	2511	1318	1	0	\N
235343	1678	2160041841000	2516	1321	0	0	\N
235347	1678	2160041842000	2518	1322	0	0	\N
235348	1678	2160041843000	2518	1322	1	0	\N
235349	1678	2160041844000	2518	1322	2	0	\N
235350	1678	2160041842000	2519	1322	0	0	\N
235351	1678	2160041843000	2519	1322	1	0	\N
235352	1678	2160041844000	2519	1322	2	0	\N
235357	1678	2160041845000	2521	1323	0	0	\N
235358	1678	2160041846000	2521	1323	1	0	\N
235359	1678	2160041847000	2521	1323	2	0	\N
235360	1765	100000000	2521	1323	3	0	\N
235368	1678	2160041855000	2526	1328	0	0	\N
235370	1678	2160041855000	2528	1328	0	0	\N
235374	1756	7919139000000	2532	1304	0	0	\N
235375	1763	0	2532	1304	1	0	\N
235376	1765	100000000	2532	1304	2	0	\N
235377	1678	2160041812000	2532	1304	3	0	\N
235378	1678	2160041813000	2532	1304	4	0	\N
235379	1678	2160041814000	2532	1304	5	0	\N
235380	1678	2160041815000	2532	1304	6	0	\N
235381	1678	2160041816000	2532	1304	7	0	\N
235382	1678	2160041817000	2532	1304	8	0	\N
235383	1678	2160041818000	2532	1304	9	0	\N
235384	1678	2160041819000	2532	1304	10	0	\N
235385	1678	2160041820000	2532	1304	11	0	\N
235386	1678	2160041821000	2532	1304	12	0	\N
235387	1678	2160041822000	2532	1304	13	0	\N
235388	1678	2160041823000	2532	1304	14	0	\N
235389	1678	2160041824000	2532	1304	15	0	\N
235390	1678	2160041825000	2532	1304	16	0	\N
235391	1678	2160041826000	2532	1304	17	0	\N
235392	1678	2160041827000	2532	1304	18	0	\N
235393	1678	2160041828000	2532	1304	19	0	\N
235394	1678	2160041829000	2532	1304	20	0	\N
235395	1678	2160041830000	2532	1304	21	0	\N
235396	1678	2160041831000	2532	1304	22	0	\N
235397	1678	2160041832000	2532	1304	23	0	\N
235398	1678	2160041833000	2532	1304	24	0	\N
235399	1678	2160041834000	2532	1304	25	0	\N
235400	1678	2160041835000	2532	1304	26	0	\N
235401	1678	2160041836000	2532	1304	27	0	\N
235402	1678	2160041837000	2532	1304	28	0	\N
235403	1678	2160041838000	2532	1304	29	0	\N
235404	1678	2160041839000	2532	1304	30	0	\N
235405	1678	2160041840000	2532	1304	31	0	\N
235406	1678	2160041841000	2532	1304	32	0	\N
235407	1678	2160041842000	2532	1304	33	0	\N
235408	1678	2160041843000	2532	1304	34	0	\N
235409	1678	2160041844000	2532	1304	35	0	\N
235410	1678	2160041845000	2532	1304	36	0	\N
235411	1678	2160041846000	2532	1304	37	0	\N
235412	1678	2160041847000	2532	1304	38	0	\N
235413	1678	2160041848000	2532	1304	39	0	\N
235414	1678	2160041849000	2532	1304	40	0	\N
235415	1678	2160041850000	2532	1304	41	0	\N
235416	1678	2160041851000	2532	1304	42	0	\N
235318	1678	2160041826000	2502	1311	2	0	0
235319	1678	2160041827000	2502	1311	3	0	0
235324	1678	2160041828000	2504	1312	0	0	0
235325	1678	2160041829000	2505	1313	0	0	0
235326	1678	2160041830000	2506	1314	0	0	0
235328	1678	2160041832000	2507	1315	1	0	0
235332	1678	2160041833000	2509	1316	0	0	0
235333	1678	2160041834000	2509	1316	1	0	0
235334	1678	2160041835000	2509	1316	2	0	0
235335	1678	2160041836000	2510	1317	0	0	0
235339	1678	2160041838000	2512	1318	1	0	0
235340	1678	2160041839000	2513	1319	0	0	0
235341	1678	2160041840000	2514	1320	0	0	0
235342	1678	2160041841000	2515	1321	0	0	0
235345	1678	2160041843000	2517	1322	1	0	0
235346	1678	2160041844000	2517	1322	2	0	0
235353	1678	2160041845000	2520	1323	0	0	0
235354	1678	2160041846000	2520	1323	1	0	0
235355	1678	2160041847000	2520	1323	2	0	0
235361	1678	2160041848000	2522	1324	0	0	0
235362	1678	2160041849000	2523	1325	0	0	0
235363	1678	2160041850000	2524	1326	0	0	0
235364	1678	2160041851000	2524	1326	1	0	0
235365	1678	2160041852000	2524	1326	2	0	0
235367	1678	2160041854000	2525	1327	1	0	0
235369	1678	2160041855000	2527	1328	0	0	0
235371	1678	2160041856000	2529	1329	0	0	0
235372	1678	2160041857000	2530	1330	0	0	0
235417	1678	2160041852000	2532	1304	43	0	\N
235418	1678	2160041853000	2532	1304	44	0	\N
235419	1678	2160041854000	2532	1304	45	0	\N
235420	1678	2160041855000	2532	1304	46	0	\N
235421	1678	2160041856000	2532	1304	47	0	\N
235422	1678	2160041857000	2532	1304	48	0	\N
235423	1678	2160041858000	2532	1304	49	0	\N
235424	1678	2160041859000	2532	1304	50	0	\N
235427	1678	2160041859000	2535	1333	0	0	\N
235428	1678	2160041860000	2535	1333	1	0	\N
235430	1646	0	2537	1335	0	0	\N
235431	1678	2160041862000	2537	1335	1	0	\N
235434	1678	2160041863000	2539	1336	0	0	\N
235436	1678	2160041863000	2541	1336	0	0	\N
235441	1678	2160041867000	2546	1340	0	0	\N
235442	1678	2160041868000	2548	1341	0	0	\N
235443	1678	2160041869000	2548	1341	1	0	\N
235444	1678	2160041870000	2548	1341	2	0	\N
235445	1678	2160041871000	2548	1341	3	0	\N
235454	1646	0	2553	1277	0	0	\N
235455	1756	7919139000000	2553	1277	1	0	\N
235456	1763	0	2553	1277	2	0	\N
235457	1678	2160041774000	2553	1277	3	0	\N
235458	1678	2160041775000	2553	1277	4	0	\N
235459	1678	2160041776000	2553	1277	5	0	\N
235460	1678	2160041777000	2553	1277	6	0	\N
235461	1678	2160041778000	2553	1277	7	0	\N
235462	1678	2160041779000	2553	1277	8	0	\N
235463	1678	2160041780000	2553	1277	9	0	\N
235464	1678	2160041781000	2553	1277	10	0	\N
235465	1765	100000000	2553	1277	11	0	\N
235466	1678	2160041782000	2553	1277	12	0	\N
235467	1678	2160041783000	2553	1277	13	0	\N
235468	1678	2160041784000	2553	1277	14	0	\N
235469	1678	2160041785000	2553	1277	15	0	\N
235470	1678	2160041786000	2553	1277	16	0	\N
235471	1678	2160041787000	2553	1277	17	0	\N
235472	1678	2160041788000	2553	1277	18	0	\N
235473	1678	2160041789000	2553	1277	19	0	\N
235474	1678	2160041790000	2553	1277	20	0	\N
235475	1678	2160041791000	2553	1277	21	0	\N
235476	1678	2160041792000	2553	1277	22	0	\N
235477	1678	2160041793000	2553	1277	23	0	\N
235478	1678	2160041794000	2553	1277	24	0	\N
235479	1678	2160041795000	2553	1277	25	0	\N
235480	1678	2160041796000	2553	1277	26	0	\N
235481	1678	2160041797000	2553	1277	27	0	\N
235482	1678	2160041798000	2553	1277	28	0	\N
235483	1678	2160041799000	2553	1277	29	0	\N
235484	1678	2160041800000	2553	1277	30	0	\N
235485	1678	2160041801000	2553	1277	31	0	\N
235486	1678	2160041802000	2553	1277	32	0	\N
235487	1678	2160041803000	2553	1277	33	0	\N
235488	1678	2160041804000	2553	1277	34	0	\N
235489	1678	2160041805000	2553	1277	35	0	\N
235490	1678	2160041806000	2553	1277	36	0	\N
235491	1678	2160041807000	2553	1277	37	0	\N
235492	1678	2160041808000	2553	1277	38	0	\N
235493	1678	2160041809000	2553	1277	39	0	\N
235494	1678	2160041810000	2553	1277	40	0	\N
235495	1678	2160041811000	2553	1277	41	0	\N
235496	1678	2160041812000	2553	1277	42	0	\N
235497	1678	2160041813000	2553	1277	43	0	\N
235498	1678	2160041814000	2553	1277	44	0	\N
235499	1678	2160041815000	2553	1277	45	0	\N
235500	1678	2160041816000	2553	1277	46	0	\N
235501	1678	2160041817000	2553	1277	47	0	\N
235502	1678	2160041818000	2553	1277	48	0	\N
235503	1678	2160041819000	2553	1277	49	0	\N
235504	1678	2160041820000	2553	1277	50	0	\N
235505	1678	2160041821000	2553	1277	51	0	\N
235506	1678	2160041822000	2553	1277	52	0	\N
235507	1678	2160041823000	2553	1277	53	0	\N
235508	1678	2160041824000	2553	1277	54	0	\N
235509	1678	2160041825000	2553	1277	55	0	\N
235510	1678	2160041826000	2553	1277	56	0	\N
235511	1678	2160041827000	2553	1277	57	0	\N
235512	1678	2160041828000	2553	1277	58	0	\N
235513	1678	2160041829000	2553	1277	59	0	\N
235514	1678	2160041830000	2553	1277	60	0	\N
235515	1678	2160041831000	2553	1277	61	0	\N
235516	1678	2160041832000	2553	1277	62	0	\N
235517	1678	2160041833000	2553	1277	63	0	\N
235518	1678	2160041834000	2553	1277	64	0	\N
235519	1678	2160041835000	2553	1277	65	0	\N
235520	1678	2160041836000	2553	1277	66	0	\N
235521	1678	2160041837000	2553	1277	67	0	\N
235522	1678	2160041838000	2553	1277	69	0	\N
235523	1678	2160041839000	2553	1277	70	0	\N
235524	1678	2160041840000	2553	1277	71	0	\N
235525	1678	2160041841000	2553	1277	72	0	\N
235526	1678	2160041842000	2553	1277	73	0	\N
235527	1678	2160041843000	2553	1277	74	0	\N
235528	1678	2160041844000	2553	1277	75	0	\N
235529	1678	2160041845000	2553	1277	76	0	\N
235530	1678	2160041846000	2553	1277	77	0	\N
235531	1678	2160041847000	2553	1277	78	0	\N
235532	1678	2160041848000	2553	1277	79	0	\N
235533	1678	2160041849000	2553	1277	80	0	\N
235536	1678	2160041876000	2555	1345	0	0	\N
235537	1678	2160041877000	2555	1345	1	0	\N
235543	1678	2160041883000	2560	1350	0	0	\N
235544	1678	2160041884000	2560	1350	1	0	\N
235545	1646	0	2561	1321	0	0	\N
235546	1678	2160041841000	2561	1321	1	0	\N
235547	1765	100000000	2561	1321	2	0	\N
235548	1678	2160041842000	2561	1321	3	0	\N
235549	1678	2160041843000	2561	1321	4	0	\N
235550	1678	2160041844000	2561	1321	5	0	\N
235551	1678	2160041845000	2561	1321	6	0	\N
235552	1678	2160041846000	2561	1321	7	0	\N
235429	1678	2160041861000	2536	1334	0	0	0
235432	1646	0	2538	1335	0	0	0
235433	1678	2160041862000	2538	1335	1	0	0
235435	1678	2160041863000	2540	1336	0	0	0
235437	1678	2160041864000	2542	1337	0	0	0
235439	1678	2160041866000	2544	1339	0	0	0
235440	1678	2160041867000	2545	1340	0	0	0
235446	1678	2160041868000	2549	1341	0	0	0
235447	1678	2160041869000	2549	1341	1	0	0
235448	1678	2160041870000	2549	1341	2	0	0
235450	1678	2160041872000	2550	1342	0	0	0
235451	1678	2160041873000	2551	1343	0	0	0
235452	1678	2160041874000	2551	1343	1	0	0
235453	1678	2160041875000	2552	1344	0	0	0
235535	1678	2160041877000	2554	1345	1	0	0
235538	1678	2160041878000	2556	1346	0	0	0
235539	1678	2160041879000	2557	1347	0	0	0
235540	1678	2160041880000	2557	1347	1	0	0
235541	1678	2160041881000	2558	1348	0	0	0
235553	1678	2160041847000	2561	1321	8	0	\N
235554	1678	2160041848000	2561	1321	9	0	\N
235555	1678	2160041849000	2561	1321	10	0	\N
235556	1678	2160041850000	2561	1321	11	0	\N
235557	1678	2160041851000	2561	1321	12	0	\N
235558	1678	2160041852000	2561	1321	13	0	\N
235559	1678	2160041853000	2561	1321	14	0	\N
235560	1678	2160041854000	2561	1321	15	0	\N
235561	1678	2160041855000	2561	1321	16	0	\N
235562	1678	2160041856000	2561	1321	17	0	\N
235563	1678	2160041857000	2561	1321	18	0	\N
235564	1678	2160041858000	2561	1321	19	0	\N
235565	1678	2160041859000	2561	1321	20	0	\N
235566	1678	2160041860000	2561	1321	21	0	\N
235567	1678	2160041861000	2561	1321	22	0	\N
235568	1678	2160041862000	2561	1321	23	0	\N
235569	1678	2160041863000	2561	1321	24	0	\N
235570	1678	2160041864000	2561	1321	25	0	\N
235571	1678	2160041865000	2561	1321	26	0	\N
235572	1678	2160041866000	2561	1321	27	0	\N
235573	1678	2160041867000	2561	1321	28	0	\N
235574	1678	2160041868000	2561	1321	29	0	\N
235575	1678	2160041869000	2561	1321	30	0	\N
235576	1678	2160041870000	2561	1321	31	0	\N
235577	1678	2160041871000	2561	1321	32	0	\N
235578	1678	2160041872000	2561	1321	33	0	\N
235579	1678	2160041873000	2561	1321	34	0	\N
235580	1678	2160041874000	2561	1321	35	0	\N
235581	1678	2160041875000	2561	1321	36	0	\N
235582	1678	2160041876000	2561	1321	37	0	\N
235583	1678	2160041877000	2561	1321	38	0	\N
235584	1678	2160041878000	2561	1321	39	0	\N
235585	1678	2160041879000	2561	1321	40	0	\N
235586	1678	2160041880000	2561	1321	42	0	\N
235587	1678	2160041881000	2561	1321	43	0	\N
235588	1678	2160041882000	2561	1321	44	0	\N
235589	1678	2160041883000	2561	1321	45	0	\N
235590	1678	2160041884000	2561	1321	46	0	\N
235591	1678	2160041883000	2562	1350	0	0	\N
235592	1678	2160041884000	2562	1350	1	0	\N
235595	1678	2160041883000	2564	1350	0	0	\N
235596	1678	2160041884000	2564	1350	1	0	\N
235600	1678	2160041887000	2568	1353	0	0	\N
235601	1590	9900000000	2569	1144	0	0	\N
235602	1646	0	2569	1144	1	0	\N
235603	120	66001000000000	2569	1144	2	0	\N
235604	1647	0	2569	1144	3	0	\N
235605	1678	2160041586000	2569	1144	4	0	\N
235606	1763	0	2569	1144	5	0	\N
235607	1678	2160041587000	2569	1144	6	0	\N
235608	1678	2160041588000	2569	1144	7	0	\N
235609	1678	2160041589000	2569	1144	8	0	\N
235610	1678	2160041590000	2569	1144	9	0	\N
235611	1678	2160041591000	2569	1144	10	0	\N
235612	1678	2160041592000	2569	1144	12	0	\N
235613	1678	2160041887000	2570	1353	0	0	\N
235624	1678	2160041897000	2577	1359	0	0	\N
235625	1678	2160041898000	2579	1360	0	0	\N
235626	1678	2160041899000	2579	1360	1	0	\N
235627	1678	2160041900000	2579	1360	2	0	\N
235631	1678	2160041901000	2581	1361	0	0	\N
235633	1678	2160041902000	2583	1362	0	0	\N
235634	1678	2160041902000	2584	1362	0	0	\N
235637	1678	2160041903000	2588	1363	0	0	\N
235640	1678	2160041904000	2590	1364	0	0	\N
235641	1678	2160041905000	2590	1364	1	0	\N
235643	1678	2160041907000	2592	1366	0	0	\N
235645	1678	2160041907000	2594	1366	0	0	\N
235648	1678	2160041908000	2596	1367	0	0	\N
235649	1678	2160041909000	2596	1367	1	0	\N
235650	1678	2160041908000	2597	1367	0	0	\N
235651	1678	2160041909000	2597	1367	1	0	\N
235653	1678	2160041911000	2603	1370	0	0	\N
235654	1678	2160041912000	2603	1370	1	0	\N
235659	1678	2160041913000	2606	1371	0	0	\N
235660	1678	2160041914000	2606	1371	1	0	\N
235661	1678	2160041915000	2607	1372	0	0	\N
235663	1678	2160041885000	2609	1322	0	0	\N
235664	1678	2160041886000	2609	1322	1	0	\N
235665	1678	2160041887000	2609	1322	2	0	\N
235666	1678	2160041888000	2609	1322	3	0	\N
235667	1678	2160041889000	2609	1322	4	0	\N
235668	1678	2160041890000	2609	1322	5	0	\N
235669	1678	2160041891000	2609	1322	6	0	\N
235670	1678	2160041892000	2609	1322	7	0	\N
235671	1678	2160041893000	2609	1322	8	0	\N
235672	1678	2160041894000	2609	1322	9	0	\N
235673	1678	2160041895000	2609	1322	10	0	\N
235674	1678	2160041896000	2609	1322	11	0	\N
235675	1678	2160041897000	2609	1322	12	0	\N
235676	1678	2160041898000	2609	1322	13	0	\N
235677	1678	2160041899000	2609	1322	14	0	\N
235678	1678	2160041900000	2609	1322	15	0	\N
235679	1678	2160041901000	2609	1322	16	0	\N
235680	1678	2160041902000	2609	1322	17	0	\N
235681	1678	2160041903000	2609	1322	18	0	\N
235682	1678	2160041904000	2609	1322	19	0	\N
235683	1678	2160041905000	2609	1322	20	0	\N
235684	1678	2160041906000	2609	1322	21	0	\N
235685	1678	2160041907000	2609	1322	22	0	\N
235686	1678	2160041908000	2609	1322	23	0	\N
235687	1678	2160041909000	2609	1322	24	0	\N
235688	1678	2160041910000	2609	1322	25	0	\N
235597	1678	2160041885000	2565	1351	0	0	0
235598	1678	2160041886000	2566	1352	0	0	0
235599	1678	2160041887000	2567	1353	0	0	0
235614	1678	2160041888000	2571	1354	0	0	0
235615	1678	2160041889000	2571	1354	1	0	0
235617	1678	2160041891000	2572	1355	1	0	0
235618	1678	2160041892000	2573	1356	0	0	0
235619	1678	2160041893000	2573	1356	1	0	0
235620	1678	2160041894000	2574	1357	0	0	0
235621	1678	2160041895000	2574	1357	1	0	0
235623	1678	2160041897000	2576	1359	0	0	0
235628	1678	2160041898000	2580	1360	0	0	0
235629	1678	2160041899000	2580	1360	1	0	0
235630	1678	2160041900000	2580	1360	2	0	0
235635	1678	2160041902000	2585	1362	0	0	0
235636	1678	2160041903000	2587	1363	0	0	0
235638	1678	2160041904000	2589	1364	0	0	0
235639	1678	2160041905000	2589	1364	1	0	0
235642	1678	2160041906000	2591	1365	0	0	0
235646	1678	2160041908000	2595	1367	0	0	0
235647	1678	2160041909000	2595	1367	1	0	0
235652	1678	2160041910000	2598	1368	0	0	0
235655	1678	2160041911000	2604	1370	0	0	0
235656	1678	2160041912000	2604	1370	1	0	0
235658	1678	2160041914000	2605	1371	1	0	0
235662	1678	2160041915000	2608	1372	0	0	0
235689	1678	2160041911000	2609	1322	26	0	\N
235690	1678	2160041912000	2609	1322	27	0	\N
235691	1678	2160041913000	2609	1322	28	0	\N
235692	1678	2160041914000	2609	1322	29	0	\N
235693	1678	2160041915000	2609	1322	30	0	\N
235696	1678	2160041916000	2611	1373	0	0	\N
235697	1678	2160041917000	2611	1373	1	0	\N
235704	1678	2160041919000	2614	1375	0	0	\N
235705	1678	2160041920000	2614	1375	1	0	\N
235706	1678	2160041921000	2614	1375	2	0	\N
235707	1678	2160041922000	2614	1375	3	0	\N
235708	1678	2160041923000	2614	1375	4	0	\N
235711	1678	2160041926000	2618	1378	0	0	\N
235712	1678	2160041926000	2619	1378	0	0	\N
235714	1678	2160041926000	2622	1378	0	0	\N
235720	1678	2160041931000	2626	1381	0	0	\N
235721	1678	2160041931000	2627	1381	0	0	\N
235726	1678	2160041934000	2631	1384	0	0	\N
235727	1678	2160041935000	2631	1384	1	0	\N
235729	1678	2160041936000	2633	1385	0	0	\N
235731	1678	2160041937000	2635	1386	0	0	\N
235733	1678	2160041938000	2637	1387	0	0	\N
235734	1678	2160041939000	2638	1388	0	0	\N
235735	1678	2160041939000	2639	1388	0	0	\N
235737	1678	2160041939000	2641	1388	0	0	\N
235742	1678	2160041944000	2645	1392	0	0	\N
235745	1678	2160041945000	2648	1393	0	0	\N
235747	1678	2160041946000	2650	1394	0	0	\N
235750	1678	2160041947000	2652	1395	0	0	\N
235751	1678	2160041948000	2652	1395	1	0	\N
235752	1678	2160041947000	2653	1395	0	0	\N
235753	1678	2160041948000	2653	1395	1	0	\N
235759	1646	0	2655	1267	0	0	\N
235760	1756	7919139000000	2655	1267	1	0	\N
235761	1765	100000000	2655	1267	2	0	\N
235762	1678	2160041825000	2655	1267	3	0	\N
235763	1678	2160041826000	2655	1267	4	0	\N
235764	1678	2160041827000	2655	1267	5	0	\N
235765	1678	2160041828000	2655	1267	6	0	\N
235766	1678	2160041829000	2655	1267	7	0	\N
235767	1678	2160041830000	2655	1267	8	0	\N
235768	1678	2160041831000	2655	1267	9	0	\N
235769	1678	2160041832000	2655	1267	10	0	\N
235770	1678	2160041833000	2655	1267	11	0	\N
235771	1678	2160041834000	2655	1267	12	0	\N
235772	1678	2160041835000	2655	1267	13	0	\N
235773	1678	2160041836000	2655	1267	14	0	\N
235774	1678	2160041837000	2655	1267	15	0	\N
235775	1678	2160041838000	2655	1267	16	0	\N
235776	1678	2160041839000	2655	1267	17	0	\N
235777	1678	2160041840000	2655	1267	18	0	\N
235778	1678	2160041841000	2655	1267	19	0	\N
235779	1678	2160041842000	2655	1267	20	0	\N
235780	1678	2160041843000	2655	1267	21	0	\N
235781	1678	2160041844000	2655	1267	22	0	\N
235782	1678	2160041845000	2655	1267	23	0	\N
235783	1678	2160041846000	2655	1267	24	0	\N
235784	1678	2160041847000	2655	1267	25	0	\N
235785	1678	2160041848000	2655	1267	26	0	\N
235786	1678	2160041849000	2655	1267	27	0	\N
235787	1678	2160041850000	2655	1267	28	0	\N
235788	1678	2160041851000	2655	1267	29	0	\N
235789	1678	2160041852000	2655	1267	30	0	\N
235790	1678	2160041853000	2655	1267	31	0	\N
235791	1678	2160041854000	2655	1267	32	0	\N
235792	1678	2160041855000	2655	1267	33	0	\N
235793	1678	2160041856000	2655	1267	34	0	\N
235794	1678	2160041857000	2655	1267	35	0	\N
235795	1678	2160041858000	2655	1267	37	0	\N
235796	1678	2160041859000	2655	1267	38	0	\N
235797	1678	2160041860000	2655	1267	39	0	\N
235798	1678	2160041861000	2655	1267	40	0	\N
235799	1678	2160041862000	2655	1267	41	0	\N
235800	1678	2160041863000	2655	1267	42	0	\N
235801	1678	2160041864000	2655	1267	43	0	\N
235802	1678	2160041865000	2655	1267	44	0	\N
235803	1678	2160041866000	2655	1267	45	0	\N
235804	1678	2160041867000	2655	1267	46	0	\N
235805	1678	2160041868000	2655	1267	47	0	\N
235806	1678	2160041869000	2655	1267	48	0	\N
235807	1678	2160041870000	2655	1267	49	0	\N
235808	1678	2160041871000	2655	1267	50	0	\N
235809	1678	2160041872000	2655	1267	51	0	\N
235810	1678	2160041873000	2655	1267	52	0	\N
235811	1678	2160041874000	2655	1267	53	0	\N
235812	1678	2160041875000	2655	1267	54	0	\N
235813	1678	2160041876000	2655	1267	55	0	\N
235814	1678	2160041877000	2655	1267	56	0	\N
235815	1678	2160041878000	2655	1267	57	0	\N
235816	1678	2160041879000	2655	1267	58	0	\N
235817	1678	2160041880000	2655	1267	59	0	\N
235818	1678	2160041881000	2655	1267	60	0	\N
235819	1678	2160041882000	2655	1267	61	0	\N
235820	1678	2160041883000	2655	1267	62	0	\N
235821	1678	2160041884000	2655	1267	63	0	\N
235822	1678	2160041885000	2655	1267	64	0	\N
235823	1678	2160041886000	2655	1267	65	0	\N
235824	1678	2160041887000	2655	1267	66	0	\N
235698	1678	2160041918000	2612	1374	0	0	0
235699	1678	2160041919000	2613	1375	0	0	0
235700	1678	2160041920000	2613	1375	1	0	0
235701	1678	2160041921000	2613	1375	2	0	0
235702	1678	2160041922000	2613	1375	3	0	0
235709	1678	2160041924000	2615	1376	0	0	0
235710	1678	2160041925000	2616	1377	0	0	0
235713	1678	2160041926000	2621	1378	0	0	0
235715	1678	2160041927000	2623	1379	0	0	0
235716	1678	2160041928000	2623	1379	1	0	0
235718	1678	2160041930000	2624	1380	1	0	0
235719	1678	2160041931000	2625	1381	0	0	0
235722	1678	2160041932000	2628	1382	0	0	0
235723	1678	2160041933000	2629	1383	0	0	0
235725	1678	2160041935000	2630	1384	1	0	0
235728	1678	2160041936000	2632	1385	0	0	0
235730	1678	2160041937000	2634	1386	0	0	0
235732	1678	2160041938000	2636	1387	0	0	0
235736	1678	2160041939000	2640	1388	0	0	0
235739	1678	2160041941000	2643	1390	0	0	0
235740	1678	2160041942000	2643	1390	1	0	0
235741	1678	2160041943000	2644	1391	0	0	0
235743	1678	2160041944000	2646	1392	0	0	0
235744	1678	2160041945000	2647	1393	0	0	0
235748	1678	2160041947000	2651	1395	0	0	0
235749	1678	2160041948000	2651	1395	1	0	0
235754	1678	2160041949000	2654	1396	0	0	0
235755	1678	2160041950000	2654	1396	1	0	0
235757	1678	2160041952000	2654	1396	3	0	0
235758	1678	2160041953000	2654	1396	4	0	0
235825	1678	2160041888000	2655	1267	67	0	\N
235826	1678	2160041889000	2655	1267	68	0	\N
235827	1678	2160041890000	2655	1267	69	0	\N
235828	1678	2160041891000	2655	1267	70	0	\N
235829	1678	2160041892000	2655	1267	71	0	\N
235830	1678	2160041893000	2655	1267	72	0	\N
235831	1678	2160041894000	2655	1267	73	0	\N
235832	1678	2160041895000	2655	1267	74	0	\N
235833	1678	2160041896000	2655	1267	75	0	\N
235834	1678	2160041897000	2655	1267	76	0	\N
235835	1678	2160041898000	2655	1267	77	0	\N
235836	1678	2160041899000	2655	1267	78	0	\N
235837	1678	2160041900000	2655	1267	79	0	\N
235838	1678	2160041901000	2655	1267	80	0	\N
235839	1678	2160041902000	2655	1267	81	0	\N
235840	1678	2160041903000	2655	1267	82	0	\N
235841	1678	2160041904000	2655	1267	83	0	\N
235842	1678	2160041905000	2655	1267	84	0	\N
235843	1678	2160041906000	2655	1267	85	0	\N
235844	1678	2160041907000	2655	1267	86	0	\N
235845	1678	2160041954000	2656	1397	0	0	\N
235846	1678	2160041954000	2657	1397	0	0	\N
235849	1678	2160041955000	2660	1398	0	0	\N
235850	1678	2160041955000	2661	1398	0	0	\N
235853	1678	2160041956000	2663	1399	0	0	\N
235854	1678	2160041957000	2663	1399	1	0	\N
235855	1678	2160041958000	2664	1400	0	0	\N
235856	1678	2160041958000	2665	1400	0	0	\N
235861	1678	2160041960000	2669	1402	0	0	\N
235862	1678	2160041961000	2669	1402	1	0	\N
235863	1678	2160041960000	2670	1402	0	0	\N
235864	1678	2160041961000	2670	1402	1	0	\N
235866	1678	2160041963000	2672	1404	0	0	\N
235869	1678	2160041965000	2675	1406	0	0	\N
235870	1678	2160041966000	2675	1406	1	0	\N
235871	1678	2160041967000	2675	1406	2	0	\N
235872	1678	2160041968000	2675	1406	3	0	\N
235873	1678	2160041965000	2676	1406	0	0	\N
235874	1678	2160041966000	2676	1406	1	0	\N
235875	1678	2160041967000	2676	1406	2	0	\N
235876	1678	2160041968000	2676	1406	3	0	\N
235885	1678	2160041972000	2681	1409	0	0	\N
235886	1646	0	2682	1269	0	0	\N
235887	1756	7919139000000	2682	1269	1	0	\N
235888	1678	2160041763000	2682	1269	2	0	\N
235889	1763	0	2682	1269	3	0	\N
235890	1678	2160041764000	2682	1269	4	0	\N
235891	1765	100000000	2682	1269	5	0	\N
235892	1678	2160041765000	2682	1269	6	0	\N
235893	1678	2160041766000	2682	1269	7	0	\N
235894	1678	2160041767000	2682	1269	8	0	\N
235895	1678	2160041768000	2682	1269	9	0	\N
235896	1678	2160041769000	2682	1269	10	0	\N
235897	1678	2160041770000	2682	1269	11	0	\N
235898	1678	2160041771000	2682	1269	12	0	\N
235899	1678	2160041772000	2682	1269	13	0	\N
235900	1678	2160041773000	2682	1269	14	0	\N
235901	1678	2160041774000	2682	1269	15	0	\N
235902	1678	2160041775000	2682	1269	16	0	\N
235903	1678	2160041776000	2682	1269	17	0	\N
235904	1678	2160041777000	2682	1269	18	0	\N
235905	1678	2160041778000	2682	1269	19	0	\N
235906	1678	2160041779000	2682	1269	20	0	\N
235907	1678	2160041780000	2682	1269	21	0	\N
235908	1678	2160041781000	2682	1269	22	0	\N
235909	1678	2160041782000	2682	1269	23	0	\N
235910	1678	2160041783000	2682	1269	24	0	\N
235911	1678	2160041784000	2682	1269	25	0	\N
235912	1678	2160041785000	2682	1269	26	0	\N
235913	1678	2160041786000	2682	1269	27	0	\N
235914	1678	2160041787000	2682	1269	28	0	\N
235915	1678	2160041788000	2682	1269	29	0	\N
235916	1678	2160041789000	2682	1269	30	0	\N
235917	1678	2160041790000	2682	1269	31	0	\N
235918	1678	2160041791000	2682	1269	32	0	\N
235919	1678	2160041792000	2682	1269	33	0	\N
235920	1678	2160041793000	2682	1269	34	0	\N
235921	1678	2160041794000	2682	1269	35	0	\N
235922	1678	2160041795000	2682	1269	36	0	\N
235923	1678	2160041796000	2682	1269	37	0	\N
235924	1678	2160041797000	2682	1269	38	0	\N
235925	1678	2160041798000	2682	1269	39	0	\N
235926	1678	2160041799000	2682	1269	40	0	\N
235927	1678	2160041800000	2682	1269	41	0	\N
235928	1678	2160041801000	2682	1269	42	0	\N
235929	1678	2160041802000	2682	1269	43	0	\N
235930	1678	2160041803000	2682	1269	44	0	\N
235931	1678	2160041804000	2682	1269	45	0	\N
235932	1678	2160041805000	2682	1269	46	0	\N
235933	1678	2160041806000	2682	1269	47	0	\N
235934	1678	2160041807000	2682	1269	48	0	\N
235935	1678	2160041808000	2682	1269	49	0	\N
235936	1678	2160041809000	2682	1269	50	0	\N
235937	1678	2160041810000	2682	1269	51	0	\N
235938	1678	2160041811000	2682	1269	52	0	\N
235939	1678	2160041812000	2682	1269	53	0	\N
235940	1678	2160041813000	2682	1269	54	0	\N
235941	1678	2160041814000	2682	1269	55	0	\N
235942	1678	2160041815000	2682	1269	56	0	\N
235943	1678	2160041816000	2682	1269	57	0	\N
235944	1678	2160041817000	2682	1269	58	0	\N
235945	1678	2160041818000	2682	1269	59	0	\N
235946	1678	2160041819000	2682	1269	60	0	\N
235947	1678	2160041820000	2682	1269	61	0	\N
235948	1678	2160041821000	2682	1269	62	0	\N
235949	1678	2160041822000	2682	1269	63	0	\N
235950	1678	2160041823000	2682	1269	64	0	\N
235951	1678	2160041824000	2682	1269	65	0	\N
235952	1678	2160041825000	2682	1269	66	0	\N
235953	1678	2160041826000	2682	1269	67	0	\N
235954	1678	2160041827000	2682	1269	68	0	\N
235955	1678	2160041828000	2682	1269	69	0	\N
235956	1678	2160041829000	2682	1269	70	0	\N
235957	1678	2160041830000	2682	1269	71	0	\N
235958	1678	2160041831000	2682	1269	72	0	\N
235959	1678	2160041832000	2682	1269	73	0	\N
235960	1678	2160041833000	2682	1269	74	0	\N
235851	1678	2160041956000	2662	1399	0	0	0
235852	1678	2160041957000	2662	1399	1	0	0
235857	1678	2160041958000	2666	1400	0	0	0
235858	1678	2160041959000	2667	1401	0	0	0
235859	1678	2160041960000	2668	1402	0	0	0
235865	1678	2160041962000	2671	1403	0	0	0
235867	1678	2160041963000	2673	1404	0	0	0
235868	1678	2160041964000	2674	1405	0	0	0
235877	1678	2160041965000	2677	1406	0	0	0
235878	1678	2160041966000	2677	1406	1	0	0
235880	1678	2160041968000	2677	1406	3	0	0
235881	1678	2160041969000	2678	1407	0	0	0
235882	1678	2160041970000	2678	1407	1	0	0
235883	1678	2160041971000	2679	1408	0	0	0
235961	1678	2160041834000	2682	1269	75	0	\N
235962	1678	2160041835000	2682	1269	76	0	\N
235963	1678	2160041836000	2682	1269	77	0	\N
235964	1678	2160041837000	2682	1269	78	0	\N
235965	1678	2160041838000	2682	1269	79	0	\N
235966	1678	2160041839000	2682	1269	80	0	\N
235967	1678	2160041840000	2682	1269	81	0	\N
235968	1678	2160041841000	2682	1269	82	0	\N
235969	1678	2160041842000	2682	1269	83	0	\N
235970	1678	2160041843000	2682	1269	84	0	\N
235971	1678	2160041844000	2682	1269	85	0	\N
235972	1678	2160041845000	2682	1269	86	0	\N
235973	1678	2160041846000	2682	1269	87	0	\N
235974	1678	2160041847000	2682	1269	88	0	\N
235975	1678	2160041848000	2682	1269	89	0	\N
235976	1678	2160041849000	2682	1269	90	0	\N
235977	1678	2160041850000	2682	1269	91	0	\N
235978	1678	2160041851000	2682	1269	92	0	\N
235979	1678	2160041852000	2682	1269	93	0	\N
235980	1678	2160041973000	2683	1410	0	0	\N
235983	1678	2160041974000	2686	1411	0	0	\N
235984	1678	2160041975000	2687	1412	0	0	\N
235986	1678	2160041975000	2689	1412	0	0	\N
235987	1678	2160041975000	2690	1412	0	0	\N
235989	1678	2160041977000	2692	1414	0	0	\N
235990	1678	2160041978000	2692	1414	1	0	\N
235998	1678	2160041983000	2698	1418	0	0	\N
235999	1678	2160041983000	2699	1418	0	0	\N
236001	1678	2160041984000	2701	1419	0	0	\N
236002	1678	2160041984000	2702	1419	0	0	\N
236003	1646	0	2703	1289	0	0	\N
236004	1756	7919139000000	2703	1289	1	0	\N
236005	1763	0	2703	1289	2	0	\N
236006	1765	100000000	2703	1289	3	0	\N
236007	1678	2160041790000	2703	1289	4	0	\N
236008	1678	2160041791000	2703	1289	5	0	\N
236009	1678	2160041792000	2703	1289	6	0	\N
236010	1678	2160041793000	2703	1289	7	0	\N
236011	1678	2160041794000	2703	1289	8	0	\N
236012	1678	2160041795000	2703	1289	9	0	\N
236013	1678	2160041796000	2703	1289	10	0	\N
236014	1678	2160041797000	2703	1289	11	0	\N
236015	1678	2160041798000	2703	1289	12	0	\N
236016	1678	2160041799000	2703	1289	13	0	\N
236017	1678	2160041800000	2703	1289	14	0	\N
236018	1678	2160041801000	2703	1289	15	0	\N
236019	1678	2160041802000	2703	1289	16	0	\N
236020	1678	2160041803000	2703	1289	17	0	\N
236021	1678	2160041804000	2703	1289	18	0	\N
236022	1678	2160041805000	2703	1289	19	0	\N
236023	1678	2160041806000	2703	1289	20	0	\N
236024	1678	2160041807000	2703	1289	21	0	\N
236025	1678	2160041808000	2703	1289	22	0	\N
236026	1678	2160041809000	2703	1289	23	0	\N
236027	1678	2160041810000	2703	1289	24	0	\N
236028	1678	2160041811000	2703	1289	25	0	\N
236029	1678	2160041812000	2703	1289	26	0	\N
236030	1678	2160041813000	2703	1289	27	0	\N
236031	1678	2160041814000	2703	1289	29	0	\N
236032	1678	2160041815000	2703	1289	30	0	\N
236033	1678	2160041816000	2703	1289	31	0	\N
236034	1678	2160041817000	2703	1289	32	0	\N
236035	1678	2160041818000	2703	1289	33	0	\N
236036	1678	2160041819000	2703	1289	34	0	\N
236037	1678	2160041820000	2703	1289	35	0	\N
236038	1678	2160041821000	2703	1289	36	0	\N
236039	1678	2160041822000	2703	1289	37	0	\N
236040	1678	2160041823000	2703	1289	38	0	\N
236041	1678	2160041824000	2703	1289	39	0	\N
236042	1678	2160041825000	2703	1289	40	0	\N
236043	1678	2160041826000	2703	1289	41	0	\N
236044	1678	2160041827000	2703	1289	42	0	\N
236045	1678	2160041828000	2703	1289	43	0	\N
236046	1678	2160041829000	2703	1289	44	0	\N
236047	1678	2160041830000	2703	1289	45	0	\N
236048	1678	2160041831000	2703	1289	46	0	\N
236049	1678	2160041832000	2703	1289	47	0	\N
236050	1678	2160041833000	2703	1289	48	0	\N
236051	1678	2160041834000	2703	1289	49	0	\N
236052	1678	2160041835000	2703	1289	50	0	\N
236053	1678	2160041836000	2703	1289	51	0	\N
236054	1678	2160041837000	2703	1289	52	0	\N
236055	1678	2160041838000	2703	1289	53	0	\N
236056	1678	2160041839000	2703	1289	54	0	\N
236057	1678	2160041840000	2703	1289	55	0	\N
236058	1678	2160041841000	2703	1289	56	0	\N
236059	1678	2160041842000	2703	1289	57	0	\N
236060	1678	2160041843000	2703	1289	58	0	\N
236061	1678	2160041844000	2703	1289	59	0	\N
236062	1678	2160041845000	2703	1289	60	0	\N
236063	1678	2160041846000	2703	1289	61	0	\N
236064	1678	2160041847000	2703	1289	62	0	\N
236065	1678	2160041848000	2703	1289	63	0	\N
236066	1678	2160041849000	2703	1289	64	0	\N
236067	1678	2160041850000	2703	1289	65	0	\N
236068	1678	2160041851000	2703	1289	66	0	\N
236069	1678	2160041852000	2703	1289	67	0	\N
236070	1678	2160041853000	2703	1289	68	0	\N
236071	1678	2160041854000	2703	1289	69	0	\N
236072	1678	2160041855000	2703	1289	70	0	\N
236073	1678	2160041856000	2703	1289	71	0	\N
236074	1678	2160041857000	2703	1289	72	0	\N
236075	1678	2160041858000	2703	1289	73	0	\N
236076	1678	2160041859000	2703	1289	74	0	\N
236077	1678	2160041860000	2703	1289	75	0	\N
236078	1678	2160041861000	2703	1289	76	0	\N
236079	1678	2160041862000	2703	1289	77	0	\N
236080	1678	2160041863000	2703	1289	78	0	\N
236081	1678	2160041864000	2703	1289	79	0	\N
236082	1678	2160041865000	2703	1289	80	0	\N
236083	1678	2160041866000	2703	1289	81	0	\N
236084	1678	2160041867000	2703	1289	82	0	\N
236085	1678	2160041868000	2703	1289	83	0	\N
236086	1678	2160041869000	2703	1289	84	0	\N
236087	1678	2160041870000	2703	1289	85	0	\N
236088	1678	2160041871000	2703	1289	86	0	\N
236089	1678	2160041872000	2703	1289	87	0	\N
236090	1678	2160041873000	2703	1289	88	0	\N
236091	1678	2160041874000	2703	1289	89	0	\N
236092	1678	2160041875000	2703	1289	90	0	\N
236093	1678	2160041876000	2703	1289	91	0	\N
236094	1678	2160041877000	2703	1289	92	0	\N
236095	1678	2160041878000	2703	1289	93	0	\N
236096	1678	2160041879000	2703	1289	94	0	\N
235985	1678	2160041975000	2688	1412	0	0	0
235988	1678	2160041976000	2691	1413	0	0	0
235991	1678	2160041977000	2693	1414	0	0	0
235992	1678	2160041978000	2693	1414	1	0	0
235993	1678	2160041979000	2694	1415	0	0	0
235995	1678	2160041981000	2695	1416	1	0	0
235996	1678	2160041982000	2696	1417	0	0	0
235997	1678	2160041983000	2697	1418	0	0	0
236000	1678	2160041984000	2700	1419	0	0	0
236097	1678	2160041880000	2703	1289	95	0	\N
236098	1678	2160041881000	2703	1289	96	0	\N
236099	1678	2160041882000	2703	1289	97	0	\N
236100	1678	2160041883000	2703	1289	98	0	\N
236101	1678	2160041884000	2703	1289	99	0	\N
236102	1678	2160041885000	2703	1289	100	0	\N
236103	1678	2160041886000	2703	1289	101	0	\N
236104	1678	2160041887000	2703	1289	102	0	\N
236105	1678	2160041888000	2703	1289	103	0	\N
236106	1678	2160041889000	2703	1289	104	0	\N
236107	1678	2160041890000	2703	1289	105	0	\N
236108	1678	2160041891000	2703	1289	106	0	\N
236109	1678	2160041892000	2703	1289	107	0	\N
236110	1678	2160041893000	2703	1289	108	0	\N
236111	1678	2160041894000	2703	1289	109	0	\N
236112	1678	2160041895000	2703	1289	110	0	\N
236113	1678	2160041896000	2703	1289	111	0	\N
236114	1678	2160041897000	2703	1289	112	0	\N
236115	1678	2160041898000	2703	1289	113	0	\N
236116	1678	2160041899000	2703	1289	114	0	\N
236117	1678	2160041900000	2703	1289	115	0	\N
236118	1678	2160041901000	2703	1289	116	0	\N
236119	1678	2160041902000	2703	1289	117	0	\N
236120	1678	2160041903000	2703	1289	118	0	\N
236121	1678	2160041904000	2703	1289	119	0	\N
236122	1678	2160041905000	2703	1289	120	0	\N
236123	1678	2160041906000	2703	1289	121	0	\N
236124	1678	2160041907000	2703	1289	122	0	\N
236125	1678	2160041908000	2703	1289	123	0	\N
236126	1678	2160041909000	2703	1289	124	0	\N
236127	1678	2160041910000	2703	1289	125	0	\N
236131	1678	2160041988000	2706	1422	0	0	\N
236132	1678	2160041988000	2707	1422	0	0	\N
236135	1678	2160041990000	2710	1424	0	0	\N
236137	1678	2160041990000	2712	1424	0	0	\N
236144	1678	2160041996000	2718	1428	0	0	\N
236145	1678	2160041997000	2719	1429	0	0	\N
236146	1678	2160041998000	2719	1429	1	0	\N
236150	1678	2160041997000	2721	1429	0	0	\N
236151	1678	2160041998000	2721	1429	1	0	\N
236153	1678	2160042001000	2723	1431	0	0	\N
236154	1678	2160042002000	2723	1431	1	0	\N
236155	1678	2160042001000	2724	1431	0	0	\N
236156	1678	2160042002000	2724	1431	1	0	\N
236157	1678	2160042001000	2725	1431	0	0	\N
236158	1678	2160042002000	2725	1431	1	0	\N
236159	1678	2160042001000	2726	1431	0	0	\N
236160	1678	2160042002000	2726	1431	1	0	\N
236163	1678	2160041911000	2728	1290	0	0	\N
236164	1678	2160041912000	2728	1290	1	0	\N
236165	1678	2160041913000	2728	1290	2	0	\N
236166	1678	2160041914000	2728	1290	3	0	\N
236167	1678	2160041915000	2728	1290	4	0	\N
236168	1678	2160041916000	2728	1290	5	0	\N
236169	1678	2160041917000	2728	1290	6	0	\N
236170	1678	2160041918000	2728	1290	7	0	\N
236171	1678	2160041919000	2728	1290	8	0	\N
236172	1678	2160041920000	2728	1290	9	0	\N
236173	1678	2160041921000	2728	1290	10	0	\N
236174	1678	2160041922000	2728	1290	11	0	\N
236175	1678	2160041923000	2728	1290	12	0	\N
236176	1678	2160041924000	2728	1290	13	0	\N
236177	1678	2160041925000	2728	1290	14	0	\N
236178	1678	2160041926000	2728	1290	15	0	\N
236179	1678	2160041927000	2728	1290	16	0	\N
236180	1678	2160041928000	2728	1290	17	0	\N
236181	1678	2160041929000	2728	1290	18	0	\N
236182	1678	2160041930000	2728	1290	19	0	\N
236183	1678	2160041931000	2728	1290	20	0	\N
236184	1678	2160041932000	2728	1290	21	0	\N
236185	1678	2160041933000	2728	1290	22	0	\N
236186	1678	2160041934000	2728	1290	23	0	\N
236187	1678	2160041935000	2728	1290	24	0	\N
236188	1678	2160041936000	2728	1290	25	0	\N
236189	1678	2160041937000	2728	1290	26	0	\N
236190	1678	2160041938000	2728	1290	27	0	\N
236191	1678	2160041939000	2728	1290	29	0	\N
236192	1678	2160041940000	2728	1290	30	0	\N
236193	1678	2160041941000	2728	1290	31	0	\N
236194	1678	2160041942000	2728	1290	32	0	\N
236195	1678	2160041943000	2728	1290	33	0	\N
236196	1678	2160041944000	2728	1290	34	0	\N
236197	1678	2160041945000	2728	1290	35	0	\N
236198	1678	2160041946000	2728	1290	36	0	\N
236199	1678	2160041947000	2728	1290	37	0	\N
236200	1678	2160041948000	2728	1290	38	0	\N
236201	1678	2160041949000	2728	1290	39	0	\N
236202	1678	2160041950000	2728	1290	40	0	\N
236203	1678	2160041951000	2728	1290	41	0	\N
236204	1678	2160041952000	2728	1290	42	0	\N
236205	1678	2160041953000	2728	1290	43	0	\N
236206	1678	2160041954000	2728	1290	44	0	\N
236207	1678	2160041955000	2728	1290	45	0	\N
236208	1678	2160041956000	2728	1290	46	0	\N
236209	1678	2160041957000	2728	1290	47	0	\N
236210	1678	2160041958000	2728	1290	48	0	\N
236211	1678	2160041959000	2728	1290	49	0	\N
236212	1678	2160041960000	2728	1290	50	0	\N
236213	1678	2160041961000	2728	1290	51	0	\N
236214	1678	2160041962000	2728	1290	52	0	\N
236215	1678	2160041963000	2728	1290	53	0	\N
236216	1678	2160041964000	2728	1290	54	0	\N
236217	1678	2160041965000	2728	1290	55	0	\N
236218	1678	2160041966000	2728	1290	56	0	\N
236219	1678	2160041967000	2728	1290	57	0	\N
236220	1678	2160041968000	2728	1290	58	0	\N
236221	1678	2160041969000	2728	1290	59	0	\N
236222	1678	2160041970000	2728	1290	60	0	\N
236223	1678	2160041971000	2728	1290	61	0	\N
236224	1678	2160041972000	2728	1290	62	0	\N
236225	1678	2160041973000	2728	1290	63	0	\N
236226	1678	2160041974000	2728	1290	64	0	\N
236227	1678	2160041975000	2728	1290	65	0	\N
236228	1678	2160041976000	2728	1290	66	0	\N
236229	1678	2160041977000	2728	1290	67	0	\N
236230	1678	2160041978000	2728	1290	68	0	\N
236231	1678	2160041979000	2728	1290	69	0	\N
236232	1678	2160041980000	2728	1290	70	0	\N
236130	1678	2160041987000	2705	1421	0	0	0
236133	1678	2160041988000	2708	1422	0	0	0
236134	1678	2160041989000	2709	1423	0	0	0
236136	1678	2160041990000	2711	1424	0	0	0
236138	1678	2160041991000	2714	1425	0	0	0
236140	1678	2160041993000	2715	1426	1	0	0
236141	1678	2160041994000	2715	1426	2	0	0
236142	1678	2160041995000	2716	1427	0	0	0
236143	1678	2160041996000	2717	1428	0	0	0
236147	1678	2160041997000	2720	1429	0	0	0
236149	1678	2160041999000	2720	1429	2	0	0
236152	1678	2160042000000	2722	1430	0	0	0
236161	1678	2160042001000	2727	1431	0	0	0
236162	1678	2160042002000	2727	1431	1	0	0
236233	1678	2160041981000	2728	1290	71	0	\N
236234	1678	2160041982000	2728	1290	72	0	\N
236235	1678	2160041983000	2728	1290	73	0	\N
236236	1678	2160041984000	2728	1290	74	0	\N
236237	1678	2160041985000	2728	1290	75	0	\N
236238	1678	2160041986000	2728	1290	76	0	\N
236239	1678	2160041987000	2728	1290	77	0	\N
236240	1678	2160041988000	2728	1290	78	0	\N
236241	1678	2160041989000	2728	1290	79	0	\N
236242	1678	2160041990000	2728	1290	80	0	\N
236243	1678	2160041991000	2728	1290	81	0	\N
236244	1678	2160041992000	2728	1290	82	0	\N
236245	1678	2160041993000	2728	1290	83	0	\N
236246	1678	2160041994000	2728	1290	84	0	\N
236247	1678	2160041995000	2728	1290	85	0	\N
236248	1678	2160041996000	2728	1290	86	0	\N
236249	1678	2160041997000	2728	1290	87	0	\N
236250	1678	2160041998000	2728	1290	88	0	\N
236251	1678	2160041999000	2728	1290	89	0	\N
236252	1678	2160042000000	2728	1290	90	0	\N
236253	1678	2160042001000	2728	1290	91	0	\N
236254	1678	2160042002000	2728	1290	92	0	\N
236259	1678	2160042005000	2732	1434	0	0	\N
236260	1678	2160042006000	2732	1434	1	0	\N
236262	1678	2160042008000	2734	1436	0	0	\N
236263	1678	2160042009000	2734	1436	1	0	\N
236267	1678	2160042010000	2737	1437	0	0	\N
236268	1678	2160042010000	2738	1437	0	0	\N
236269	1678	2160042011000	2739	1438	0	0	\N
236271	1678	2160042012000	2741	1439	0	0	\N
236272	1678	2160042013000	2741	1439	1	0	\N
236275	1678	2160041944000	2743	1392	0	0	\N
236276	1678	2160041945000	2743	1392	1	0	\N
236277	1678	2160041946000	2743	1392	2	0	\N
236278	1678	2160041947000	2743	1392	3	0	\N
236279	1678	2160041948000	2743	1392	4	0	\N
236280	1678	2160041949000	2743	1392	5	0	\N
236281	1678	2160041950000	2743	1392	6	0	\N
236282	1678	2160041951000	2743	1392	7	0	\N
236283	1678	2160041952000	2743	1392	8	0	\N
236284	1678	2160041953000	2743	1392	9	0	\N
236285	1678	2160041954000	2743	1392	10	0	\N
236286	1678	2160041955000	2743	1392	11	0	\N
236287	1678	2160041956000	2743	1392	12	0	\N
236288	1678	2160041957000	2743	1392	13	0	\N
236289	1678	2160041958000	2743	1392	14	0	\N
236290	1678	2160041959000	2743	1392	15	0	\N
236291	1678	2160041960000	2743	1392	16	0	\N
236292	1678	2160041961000	2743	1392	17	0	\N
236293	1678	2160041962000	2743	1392	18	0	\N
236294	1678	2160041963000	2743	1392	19	0	\N
236295	1678	2160041964000	2743	1392	20	0	\N
236296	1678	2160041965000	2743	1392	21	0	\N
236297	1678	2160041966000	2743	1392	22	0	\N
236298	1678	2160041967000	2743	1392	23	0	\N
236299	1678	2160041968000	2743	1392	24	0	\N
236300	1678	2160041969000	2743	1392	25	0	\N
236301	1678	2160041970000	2743	1392	26	0	\N
236302	1678	2160041971000	2743	1392	27	0	\N
236303	1678	2160041972000	2743	1392	28	0	\N
236304	1678	2160041973000	2743	1392	29	0	\N
236305	1678	2160041974000	2743	1392	30	0	\N
236306	1678	2160041975000	2743	1392	31	0	\N
236307	1678	2160041976000	2743	1392	32	0	\N
236308	1678	2160041977000	2743	1392	33	0	\N
236309	1678	2160041978000	2743	1392	34	0	\N
236310	1678	2160041979000	2743	1392	35	0	\N
236311	1678	2160041980000	2743	1392	36	0	\N
236312	1678	2160041981000	2743	1392	37	0	\N
236313	1678	2160041982000	2743	1392	38	0	\N
236314	1678	2160041983000	2743	1392	39	0	\N
236315	1678	2160041984000	2743	1392	40	0	\N
236316	1678	2160041985000	2743	1392	41	0	\N
236317	1678	2160041986000	2743	1392	42	0	\N
236318	1678	2160041987000	2743	1392	43	0	\N
236319	1678	2160041988000	2743	1392	44	0	\N
236320	1678	2160041989000	2743	1392	45	0	\N
236321	1678	2160041990000	2743	1392	46	0	\N
236322	1678	2160041991000	2743	1392	47	0	\N
236323	1678	2160041992000	2743	1392	49	0	\N
236324	1678	2160041993000	2743	1392	50	0	\N
236325	1678	2160041994000	2743	1392	51	0	\N
236326	1678	2160041995000	2743	1392	52	0	\N
236327	1678	2160041996000	2743	1392	53	0	\N
236328	1678	2160041997000	2743	1392	54	0	\N
236329	1678	2160041998000	2743	1392	55	0	\N
236330	1678	2160041999000	2743	1392	56	0	\N
236331	1678	2160042000000	2743	1392	57	0	\N
236332	1678	2160042001000	2743	1392	58	0	\N
236333	1678	2160042002000	2743	1392	59	0	\N
236334	1678	2160042003000	2743	1392	60	0	\N
236335	1678	2160042004000	2743	1392	61	0	\N
236336	1678	2160042005000	2743	1392	62	0	\N
236337	1678	2160042006000	2743	1392	63	0	\N
236338	1678	2160042007000	2743	1392	64	0	\N
236339	1678	2160042008000	2743	1392	65	0	\N
236340	1678	2160042009000	2743	1392	66	0	\N
236341	1678	2160042010000	2743	1392	67	0	\N
236342	1678	2160042011000	2743	1392	68	0	\N
236343	1678	2160042012000	2743	1392	69	0	\N
236344	1678	2160042013000	2743	1392	70	0	\N
236345	1678	2160042014000	2744	1440	0	0	\N
236346	1678	2160042014000	2745	1440	0	0	\N
236347	1678	2160042014000	2746	1440	0	0	\N
236349	1678	2160042015000	2749	1441	0	0	\N
236350	1678	2160042015000	2750	1441	0	0	\N
236351	1678	2160042015000	2753	1441	0	0	\N
236352	1678	2160042015000	2755	1442	0	0	\N
236353	1678	2160042016000	2755	1442	1	0	\N
236354	1678	2160042015000	2756	1442	0	0	\N
236355	1678	2160042015000	2757	1442	0	0	\N
236356	1678	2160042016000	2757	1442	1	0	\N
236359	1678	2160042015000	2759	1442	0	0	\N
236360	1678	2160042016000	2759	1442	1	0	\N
236361	1646	0	2760	1231	0	0	\N
236362	1756	7919139000000	2760	1231	1	0	\N
236363	1763	0	2760	1231	2	0	\N
236364	1765	100000000	2760	1231	3	0	\N
236365	1678	2160041811000	2760	1231	4	0	\N
236366	1678	2160041812000	2760	1231	5	0	\N
236367	1678	2160041813000	2760	1231	6	0	\N
236368	1678	2160041814000	2760	1231	7	0	\N
236257	1678	2160042005000	2731	1434	0	0	0
236258	1678	2160042006000	2731	1434	1	0	0
236261	1678	2160042007000	2733	1435	0	0	0
236264	1678	2160042008000	2735	1436	0	0	0
236265	1678	2160042009000	2735	1436	1	0	0
236270	1678	2160042011000	2740	1438	0	0	0
236273	1678	2160042012000	2742	1439	0	0	0
236274	1678	2160042013000	2742	1439	1	0	0
236348	1678	2160042014000	2747	1440	0	0	0
236357	1678	2160042015000	2758	1442	0	0	0
236369	1678	2160041815000	2760	1231	8	0	\N
236370	1678	2160041816000	2760	1231	9	0	\N
236371	1678	2160041817000	2760	1231	10	0	\N
236372	1678	2160041818000	2760	1231	11	0	\N
236373	1678	2160041819000	2760	1231	12	0	\N
236374	1678	2160041820000	2760	1231	13	0	\N
236375	1678	2160041821000	2760	1231	14	0	\N
236376	1678	2160041822000	2760	1231	15	0	\N
236377	1678	2160041823000	2760	1231	16	0	\N
236378	1678	2160041824000	2760	1231	17	0	\N
236379	1678	2160041825000	2760	1231	18	0	\N
236380	1678	2160041826000	2760	1231	19	0	\N
236381	1678	2160041827000	2760	1231	20	0	\N
236382	1678	2160041828000	2760	1231	21	0	\N
236383	1678	2160041829000	2760	1231	22	0	\N
236384	1678	2160041830000	2760	1231	23	0	\N
236385	1678	2160041831000	2760	1231	24	0	\N
236386	1678	2160041832000	2760	1231	25	0	\N
236387	1678	2160041833000	2760	1231	26	0	\N
236388	1678	2160041834000	2760	1231	27	0	\N
236389	1678	2160041835000	2760	1231	28	0	\N
236390	1678	2160041836000	2760	1231	29	0	\N
236391	1678	2160041837000	2760	1231	30	0	\N
236392	1678	2160041838000	2760	1231	31	0	\N
236393	1678	2160041839000	2760	1231	32	0	\N
236394	1678	2160041840000	2760	1231	33	0	\N
236395	1678	2160041841000	2760	1231	34	0	\N
236396	1678	2160041842000	2760	1231	35	0	\N
236397	1678	2160041843000	2760	1231	36	0	\N
236398	1678	2160041844000	2760	1231	37	0	\N
236399	1678	2160041845000	2760	1231	38	0	\N
236400	1678	2160041846000	2760	1231	39	0	\N
236401	1678	2160041847000	2760	1231	40	0	\N
236402	1678	2160041848000	2760	1231	41	0	\N
236403	1678	2160041849000	2760	1231	42	0	\N
236404	1678	2160041850000	2760	1231	43	0	\N
236405	1678	2160041851000	2760	1231	44	0	\N
236406	1678	2160041852000	2760	1231	45	0	\N
236407	1678	2160041853000	2760	1231	46	0	\N
236408	1678	2160041854000	2760	1231	47	0	\N
236409	1678	2160041855000	2760	1231	48	0	\N
236410	1678	2160041856000	2760	1231	49	0	\N
236411	1678	2160041857000	2760	1231	50	0	\N
236412	1678	2160041858000	2760	1231	51	0	\N
236413	1678	2160041859000	2760	1231	52	0	\N
236414	1678	2160041860000	2760	1231	53	0	\N
236415	1678	2160041861000	2760	1231	54	0	\N
236416	1678	2160041862000	2760	1231	55	0	\N
236417	1678	2160041863000	2760	1231	56	0	\N
236418	1678	2160041864000	2760	1231	57	0	\N
236419	1678	2160041865000	2760	1231	58	0	\N
236420	1678	2160041866000	2760	1231	59	0	\N
236421	1678	2160041867000	2760	1231	60	0	\N
236422	1678	2160041868000	2760	1231	61	0	\N
236423	1678	2160041869000	2760	1231	62	0	\N
236424	1678	2160041870000	2760	1231	63	0	\N
236425	1678	2160041871000	2760	1231	64	0	\N
236426	1678	2160041872000	2760	1231	65	0	\N
236427	1678	2160041873000	2760	1231	66	0	\N
236428	1678	2160041874000	2760	1231	67	0	\N
236429	1678	2160041875000	2760	1231	68	0	\N
236430	1678	2160041876000	2760	1231	69	0	\N
236431	1678	2160041877000	2760	1231	70	0	\N
236432	1678	2160041878000	2760	1231	71	0	\N
236433	1678	2160041879000	2760	1231	72	0	\N
236434	1678	2160041880000	2760	1231	73	0	\N
236435	1678	2160041881000	2760	1231	74	0	\N
236436	1678	2160041882000	2760	1231	75	0	\N
236437	1678	2160041883000	2760	1231	76	0	\N
236438	1678	2160041884000	2760	1231	77	0	\N
236439	1678	2160041885000	2760	1231	78	0	\N
236440	1678	2160041886000	2760	1231	79	0	\N
236441	1678	2160041887000	2760	1231	80	0	\N
236442	1678	2160041888000	2760	1231	81	0	\N
236443	1678	2160041889000	2760	1231	82	0	\N
236444	1678	2160041890000	2760	1231	83	0	\N
236445	1678	2160041891000	2760	1231	84	0	\N
236446	1678	2160041892000	2760	1231	85	0	\N
236447	1678	2160041893000	2760	1231	86	0	\N
236448	1678	2160041894000	2760	1231	87	0	\N
236449	1678	2160041895000	2760	1231	88	0	\N
236450	1678	2160041896000	2760	1231	89	0	\N
236451	1678	2160041897000	2760	1231	90	0	\N
236452	1678	2160041898000	2760	1231	91	0	\N
236453	1678	2160041899000	2760	1231	92	0	\N
236454	1678	2160041900000	2760	1231	93	0	\N
236455	1678	2160041901000	2760	1231	94	0	\N
236456	1678	2160041902000	2760	1231	95	0	\N
236457	1678	2160041903000	2760	1231	96	0	\N
236458	1678	2160041904000	2760	1231	97	0	\N
236459	1678	2160041905000	2760	1231	98	0	\N
236460	1678	2160041906000	2760	1231	99	0	\N
236461	1678	2160041907000	2760	1231	100	0	\N
236462	1678	2160041908000	2760	1231	101	0	\N
236463	1678	2160041909000	2760	1231	102	0	\N
236464	1678	2160041910000	2760	1231	103	0	\N
236465	1678	2160041911000	2760	1231	104	0	\N
236466	1678	2160041912000	2760	1231	105	0	\N
236467	1678	2160041913000	2760	1231	106	0	\N
236468	1678	2160041914000	2760	1231	107	0	\N
236469	1678	2160041915000	2760	1231	108	0	\N
236470	1678	2160041916000	2760	1231	109	0	\N
236471	1678	2160041917000	2760	1231	110	0	\N
236472	1678	2160041918000	2760	1231	111	0	\N
236473	1678	2160041919000	2760	1231	112	0	\N
236474	1678	2160041920000	2760	1231	113	0	\N
236475	1678	2160041921000	2760	1231	114	0	\N
236476	1678	2160041922000	2760	1231	115	0	\N
236477	1678	2160041923000	2760	1231	116	0	\N
236478	1678	2160041924000	2760	1231	122	0	\N
236479	1678	2160041925000	2760	1231	123	0	\N
236480	1678	2160041926000	2760	1231	124	0	\N
236481	1678	2160041927000	2760	1231	125	0	\N
236487	1678	2160042021000	2763	1444	0	0	\N
236488	1678	2160042022000	2764	1445	0	0	\N
236500	1678	2160042033000	2775	1453	0	0	\N
236501	1678	2160042034000	2775	1453	1	0	\N
236504	1678	2160042033000	2777	1453	0	0	\N
236484	1678	2160042019000	2761	1443	3	0	0
236485	1678	2160042020000	2761	1443	4	0	0
236486	1678	2160042021000	2762	1444	0	0	0
236489	1678	2160042022000	2765	1445	0	0	0
236490	1678	2160042023000	2767	1446	0	0	0
236492	1678	2160042025000	2767	1446	2	0	0
236493	1678	2160042026000	2767	1446	3	0	0
236494	1678	2160042027000	2769	1447	0	0	0
236495	1678	2160042028000	2770	1448	0	0	0
236496	1678	2160042029000	2771	1449	0	0	0
236498	1678	2160042031000	2773	1451	0	0	0
236499	1678	2160042032000	2774	1452	0	0	0
236502	1678	2160042033000	2776	1453	0	0	0
236503	1678	2160042034000	2776	1453	1	0	0
236505	1678	2160042034000	2777	1453	1	0	\N
236506	1678	2160042033000	2778	1453	0	0	\N
236507	1678	2160042034000	2778	1453	1	0	\N
236510	1678	2160042035000	2780	1454	0	0	\N
236511	1678	2160042036000	2780	1454	1	0	\N
236516	1678	2160042040000	2786	1458	0	0	\N
236519	1646	0	2788	1333	0	0	\N
236520	1678	2160041859000	2788	1333	1	0	\N
236521	1678	2160041860000	2788	1333	2	0	\N
236522	528	66002000000000	2788	1333	3	0	\N
236523	1678	2160041861000	2788	1333	4	0	\N
236524	1678	2160041862000	2788	1333	5	0	\N
236525	1678	2160041863000	2788	1333	6	0	\N
236526	1678	2160041864000	2788	1333	7	0	\N
236527	1678	2160041865000	2788	1333	8	0	\N
236528	1678	2160041866000	2788	1333	9	0	\N
236529	1678	2160041867000	2788	1333	10	0	\N
236530	1678	2160041868000	2788	1333	11	0	\N
236531	1678	2160041869000	2788	1333	12	0	\N
236532	1678	2160041870000	2788	1333	13	0	\N
236533	1678	2160041871000	2788	1333	14	0	\N
236534	1678	2160041872000	2788	1333	15	0	\N
236535	1678	2160041873000	2788	1333	16	0	\N
236536	1678	2160041874000	2788	1333	17	0	\N
236537	1678	2160041875000	2788	1333	18	0	\N
236538	1678	2160041876000	2788	1333	19	0	\N
236539	1678	2160041877000	2788	1333	20	0	\N
236540	1678	2160041878000	2788	1333	21	0	\N
236541	1678	2160041879000	2788	1333	22	0	\N
236542	1678	2160041880000	2788	1333	23	0	\N
236543	1678	2160041881000	2788	1333	24	0	\N
236544	1678	2160041882000	2788	1333	25	0	\N
236545	1678	2160041883000	2788	1333	26	0	\N
236546	1678	2160041884000	2788	1333	27	0	\N
236547	1678	2160041885000	2788	1333	28	0	\N
236548	1678	2160041886000	2788	1333	29	0	\N
236549	1678	2160041887000	2788	1333	30	0	\N
236550	1678	2160041888000	2788	1333	31	0	\N
236551	1678	2160041889000	2788	1333	32	0	\N
236552	1678	2160041890000	2788	1333	33	0	\N
236553	1678	2160041891000	2788	1333	34	0	\N
236554	1678	2160041892000	2788	1333	35	0	\N
236555	1678	2160041893000	2788	1333	36	0	\N
236556	1678	2160041894000	2788	1333	37	0	\N
236557	1678	2160041895000	2788	1333	38	0	\N
236558	1678	2160041896000	2788	1333	39	0	\N
236559	1678	2160041897000	2788	1333	40	0	\N
236560	1678	2160041898000	2788	1333	41	0	\N
236561	1678	2160041899000	2788	1333	42	0	\N
236562	1678	2160041900000	2788	1333	43	0	\N
236563	1678	2160041901000	2788	1333	44	0	\N
236564	1678	2160041902000	2788	1333	45	0	\N
236565	1678	2160041903000	2788	1333	46	0	\N
236566	1678	2160041904000	2788	1333	47	0	\N
236567	1678	2160041905000	2788	1333	48	0	\N
236568	1678	2160041906000	2788	1333	49	0	\N
236569	1678	2160041907000	2788	1333	50	0	\N
236570	1678	2160041908000	2788	1333	51	0	\N
236571	1678	2160041909000	2788	1333	52	0	\N
236572	1678	2160041910000	2788	1333	53	0	\N
236573	1678	2160041911000	2788	1333	54	0	\N
236574	1678	2160041912000	2788	1333	55	0	\N
236575	1678	2160041913000	2788	1333	56	0	\N
236576	1678	2160041914000	2788	1333	57	0	\N
236577	1678	2160041915000	2788	1333	58	0	\N
236578	1678	2160041916000	2788	1333	59	0	\N
236579	1678	2160041917000	2788	1333	60	0	\N
236580	1678	2160041918000	2788	1333	61	0	\N
236581	1678	2160041919000	2788	1333	62	0	\N
236582	1678	2160041920000	2788	1333	63	0	\N
236583	1678	2160041921000	2788	1333	64	0	\N
236584	1678	2160041922000	2788	1333	65	0	\N
236585	1678	2160041923000	2788	1333	66	0	\N
236586	1678	2160041924000	2788	1333	67	0	\N
236587	1678	2160041925000	2788	1333	68	0	\N
236588	1678	2160041926000	2788	1333	69	0	\N
236589	1678	2160041927000	2788	1333	70	0	\N
236590	1678	2160041928000	2788	1333	71	0	\N
236591	1678	2160041929000	2788	1333	72	0	\N
236592	1678	2160041930000	2788	1333	73	0	\N
236593	1678	2160041931000	2788	1333	74	0	\N
236594	1678	2160041932000	2788	1333	75	0	\N
236595	1678	2160041933000	2788	1333	76	0	\N
236596	1678	2160041934000	2788	1333	77	0	\N
236597	1678	2160041935000	2788	1333	78	0	\N
236598	1678	2160041936000	2788	1333	79	0	\N
236599	1678	2160041937000	2788	1333	80	0	\N
236600	1678	2160041938000	2788	1333	81	0	\N
236601	1678	2160041939000	2788	1333	82	0	\N
236602	1678	2160041940000	2788	1333	83	0	\N
236603	1678	2160041941000	2788	1333	84	0	\N
236604	1678	2160041942000	2788	1333	85	0	\N
236605	1678	2160041943000	2788	1333	86	0	\N
236606	1678	2160041944000	2788	1333	87	0	\N
236607	1678	2160041945000	2788	1333	88	0	\N
236608	1678	2160041946000	2788	1333	89	0	\N
236609	1678	2160041947000	2788	1333	90	0	\N
236610	1678	2160041948000	2788	1333	91	0	\N
236611	1678	2160041949000	2788	1333	92	0	\N
236612	1678	2160041950000	2788	1333	93	0	\N
236613	1678	2160041951000	2788	1333	94	0	\N
236614	1678	2160041952000	2788	1333	95	0	\N
236615	1678	2160041953000	2788	1333	96	0	\N
236616	1678	2160041954000	2788	1333	97	0	\N
236617	1678	2160041955000	2788	1333	98	0	\N
236618	1678	2160041956000	2788	1333	99	0	\N
236619	1678	2160041957000	2788	1333	100	0	\N
236620	1678	2160041958000	2788	1333	101	0	\N
236621	1678	2160041959000	2788	1333	102	0	\N
236622	1678	2160041960000	2788	1333	103	0	\N
236623	1678	2160041961000	2788	1333	104	0	\N
236624	1678	2160041962000	2788	1333	105	0	\N
236625	1678	2160041963000	2788	1333	106	0	\N
236626	1678	2160041964000	2788	1333	107	0	\N
236627	1678	2160041965000	2788	1333	108	0	\N
236628	1678	2160041966000	2788	1333	109	0	\N
236629	1678	2160041967000	2788	1333	110	0	\N
236630	1678	2160041968000	2788	1333	111	0	\N
236631	1678	2160041969000	2788	1333	112	0	\N
236632	1678	2160041970000	2788	1333	113	0	\N
236633	1678	2160041971000	2788	1333	114	0	\N
236634	1678	2160041972000	2788	1333	115	0	\N
236635	1678	2160041973000	2788	1333	116	0	\N
236636	1678	2160041974000	2788	1333	117	0	\N
236637	1678	2160041975000	2788	1333	118	0	\N
236638	1678	2160041976000	2788	1333	119	0	\N
236639	1678	2160041977000	2788	1333	120	0	\N
236640	1678	2160041978000	2788	1333	121	0	\N
236512	1678	2160042037000	2781	1455	0	0	0
236513	1678	2160042038000	2783	1456	0	0	0
236514	1678	2160042039000	2784	1457	0	0	0
236515	1678	2160042040000	2785	1458	0	0	0
236517	1678	2160042041000	2787	1459	0	0	0
236641	1678	2160041979000	2788	1333	122	0	\N
236642	1678	2160041980000	2788	1333	123	0	\N
236643	1678	2160041981000	2788	1333	124	0	\N
236644	1678	2160041982000	2788	1333	125	0	\N
236646	1678	2160042042000	2790	1460	0	0	\N
236648	1678	2160042044000	2792	1462	0	0	\N
236650	1678	2160042044000	2794	1462	0	0	\N
236651	1678	2160042045000	2795	1463	0	0	\N
236652	1678	2160042045000	2796	1463	0	0	\N
236654	1678	2160042046000	2798	1464	0	0	\N
236655	1678	2160042047000	2798	1464	1	0	\N
236656	1678	2160042048000	2798	1464	2	0	\N
236657	1678	2160042049000	2798	1464	3	0	\N
236662	1678	2160042046000	2800	1464	0	0	\N
236663	1678	2160042047000	2800	1464	1	0	\N
236664	1678	2160042048000	2800	1464	2	0	\N
236665	1678	2160042049000	2800	1464	3	0	\N
236666	1678	2160042050000	2801	1465	0	0	\N
236667	1678	2160042051000	2801	1465	1	0	\N
236668	1678	2160042052000	2801	1465	2	0	\N
236672	1678	2160042050000	2803	1465	0	0	\N
236673	1678	2160042051000	2803	1465	1	0	\N
236674	1678	2160042052000	2803	1465	2	0	\N
236675	1646	0	2804	1334	0	0	\N
236676	528	66002000000000	2804	1334	1	0	\N
236677	1678	2160041861000	2804	1334	2	0	\N
236678	1678	2160041862000	2804	1334	3	0	\N
236679	1678	2160041863000	2804	1334	4	0	\N
236680	1678	2160041864000	2804	1334	5	0	\N
236681	1678	2160041865000	2804	1334	6	0	\N
236682	1678	2160041866000	2804	1334	7	0	\N
236683	1678	2160041867000	2804	1334	8	0	\N
236684	1678	2160041868000	2804	1334	9	0	\N
236685	1678	2160041869000	2804	1334	10	0	\N
236686	1678	2160041870000	2804	1334	11	0	\N
236687	1678	2160041871000	2804	1334	12	0	\N
236688	1678	2160041872000	2804	1334	13	0	\N
236689	1678	2160041873000	2804	1334	14	0	\N
236690	1678	2160041874000	2804	1334	15	0	\N
236691	1678	2160041875000	2804	1334	16	0	\N
236692	1678	2160041876000	2804	1334	17	0	\N
236693	1678	2160041877000	2804	1334	18	0	\N
236694	1678	2160041878000	2804	1334	19	0	\N
236695	1678	2160041879000	2804	1334	20	0	\N
236696	1678	2160041880000	2804	1334	21	0	\N
236697	1678	2160041881000	2804	1334	22	0	\N
236698	1678	2160041882000	2804	1334	23	0	\N
236699	1678	2160041883000	2804	1334	24	0	\N
236700	1678	2160041884000	2804	1334	25	0	\N
236701	1678	2160041885000	2804	1334	26	0	\N
236702	1678	2160041886000	2804	1334	27	0	\N
236703	1678	2160041887000	2804	1334	28	0	\N
236704	1678	2160041888000	2804	1334	29	0	\N
236705	1678	2160041889000	2804	1334	30	0	\N
236706	1678	2160041890000	2804	1334	31	0	\N
236707	1678	2160041891000	2804	1334	32	0	\N
236708	1678	2160041892000	2804	1334	33	0	\N
236709	1678	2160041893000	2804	1334	34	0	\N
236710	1678	2160041894000	2804	1334	35	0	\N
236711	1678	2160041895000	2804	1334	36	0	\N
236712	1678	2160041896000	2804	1334	37	0	\N
236713	1678	2160041897000	2804	1334	38	0	\N
236714	1678	2160041898000	2804	1334	39	0	\N
236715	1678	2160041899000	2804	1334	40	0	\N
236716	1678	2160041900000	2804	1334	41	0	\N
236717	1678	2160041901000	2804	1334	42	0	\N
236718	1678	2160041902000	2804	1334	43	0	\N
236719	1678	2160041903000	2804	1334	44	0	\N
236720	1678	2160041904000	2804	1334	45	0	\N
236721	1678	2160041905000	2804	1334	46	0	\N
236722	1678	2160041906000	2804	1334	47	0	\N
236723	1678	2160041907000	2804	1334	48	0	\N
236724	1678	2160041908000	2804	1334	49	0	\N
236725	1678	2160041909000	2804	1334	50	0	\N
236726	1678	2160041910000	2804	1334	51	0	\N
236727	1678	2160041911000	2804	1334	52	0	\N
236728	1678	2160041912000	2804	1334	53	0	\N
236729	1678	2160041913000	2804	1334	54	0	\N
236730	1678	2160041914000	2804	1334	55	0	\N
236731	1678	2160041915000	2804	1334	56	0	\N
236732	1678	2160041916000	2804	1334	57	0	\N
236733	1678	2160041917000	2804	1334	58	0	\N
236734	1678	2160041918000	2804	1334	59	0	\N
236735	1678	2160041919000	2804	1334	60	0	\N
236736	1678	2160041920000	2804	1334	61	0	\N
236737	1678	2160041921000	2804	1334	62	0	\N
236738	1678	2160041922000	2804	1334	63	0	\N
236739	1678	2160041923000	2804	1334	64	0	\N
236740	1678	2160041924000	2804	1334	65	0	\N
236741	1678	2160041925000	2804	1334	66	0	\N
236742	1678	2160041926000	2804	1334	67	0	\N
236743	1678	2160041927000	2804	1334	68	0	\N
236744	1678	2160041928000	2804	1334	69	0	\N
236745	1678	2160041929000	2804	1334	70	0	\N
236746	1678	2160041930000	2804	1334	71	0	\N
236747	1678	2160041931000	2804	1334	72	0	\N
236748	1678	2160041932000	2804	1334	73	0	\N
236749	1678	2160041933000	2804	1334	74	0	\N
236750	1678	2160041934000	2804	1334	75	0	\N
236751	1678	2160041935000	2804	1334	76	0	\N
236752	1678	2160041936000	2804	1334	77	0	\N
236753	1678	2160041937000	2804	1334	78	0	\N
236754	1678	2160041938000	2804	1334	79	0	\N
236755	1678	2160041939000	2804	1334	80	0	\N
236756	1678	2160041940000	2804	1334	81	0	\N
236757	1678	2160041941000	2804	1334	82	0	\N
236758	1678	2160041942000	2804	1334	83	0	\N
236759	1678	2160041943000	2804	1334	84	0	\N
236760	1678	2160041944000	2804	1334	85	0	\N
236761	1678	2160041945000	2804	1334	86	0	\N
236762	1678	2160041946000	2804	1334	87	0	\N
236763	1678	2160041947000	2804	1334	88	0	\N
236764	1678	2160041948000	2804	1334	89	0	\N
236765	1678	2160041949000	2804	1334	90	0	\N
236766	1678	2160041950000	2804	1334	91	0	\N
236767	1678	2160041951000	2804	1334	92	0	\N
236768	1678	2160041952000	2804	1334	93	0	\N
236769	1678	2160041953000	2804	1334	94	0	\N
236770	1678	2160041954000	2804	1334	95	0	\N
236771	1678	2160041955000	2804	1334	96	0	\N
236772	1678	2160041956000	2804	1334	97	0	\N
236773	1678	2160041957000	2804	1334	98	0	\N
236774	1678	2160041958000	2804	1334	99	0	\N
236775	1678	2160041959000	2804	1334	100	0	\N
236776	1678	2160041960000	2804	1334	101	0	\N
236649	1678	2160042044000	2793	1462	0	0	0
236653	1678	2160042045000	2797	1463	0	0	0
236658	1678	2160042046000	2799	1464	0	0	0
236659	1678	2160042047000	2799	1464	1	0	0
236660	1678	2160042048000	2799	1464	2	0	0
236669	1678	2160042050000	2802	1465	0	0	0
236670	1678	2160042051000	2802	1465	1	0	0
236671	1678	2160042052000	2802	1465	2	0	0
236777	1678	2160041961000	2804	1334	102	0	\N
236778	1678	2160041962000	2804	1334	103	0	\N
236779	1678	2160041963000	2804	1334	104	0	\N
236780	1678	2160041964000	2804	1334	105	0	\N
236781	1678	2160041965000	2804	1334	106	0	\N
236782	1678	2160041966000	2804	1334	107	0	\N
236783	1678	2160041967000	2804	1334	108	0	\N
236784	1678	2160041968000	2804	1334	109	0	\N
236785	1678	2160041969000	2804	1334	110	0	\N
236786	1678	2160041970000	2804	1334	111	0	\N
236787	1678	2160041971000	2804	1334	112	0	\N
236788	1678	2160041972000	2804	1334	113	0	\N
236789	1678	2160041973000	2804	1334	114	0	\N
236790	1678	2160041974000	2804	1334	115	0	\N
236791	1678	2160041975000	2804	1334	116	0	\N
236792	1678	2160041976000	2804	1334	117	0	\N
236793	1678	2160041977000	2804	1334	118	0	\N
236794	1678	2160041978000	2804	1334	119	0	\N
236795	1678	2160041979000	2804	1334	120	0	\N
236796	1678	2160041980000	2804	1334	122	0	\N
236797	1678	2160041981000	2804	1334	123	0	\N
236798	1678	2160041982000	2804	1334	124	0	\N
236799	1678	2160041983000	2804	1334	125	0	\N
236800	1678	2160042050000	2805	1465	0	0	\N
236801	1678	2160042051000	2805	1465	1	0	\N
236802	1678	2160042052000	2805	1465	2	0	\N
236804	1678	2160042054000	2807	1467	0	0	\N
236805	1678	2160042055000	2807	1467	1	0	\N
236812	1678	2160042059000	2813	1471	0	0	\N
236820	1678	2160042064000	2828	1478	0	0	\N
236821	1678	2160042065000	2828	1478	1	0	\N
236822	1678	2160042066000	2828	1478	2	0	\N
236823	1678	2160042067000	2828	1478	3	0	\N
236824	1678	2160042068000	2828	1478	4	0	\N
236825	1678	2160042069000	2828	1478	5	0	\N
236826	1678	2160042070000	2828	1478	6	0	\N
236827	1678	2160042071000	2828	1478	7	0	\N
236838	1678	2160042072000	2833	1480	0	0	\N
236839	1678	2160042073000	2833	1480	1	0	\N
236840	1678	2160042074000	2833	1480	2	0	\N
236856	1678	2160042088000	2845	1490	0	0	\N
236862	1678	2160042092000	2852	1493	0	0	\N
236865	1678	2160042093000	2855	1495	0	0	\N
236866	1678	2160042094000	2855	1495	1	0	\N
236870	1678	2160042095000	2857	1496	0	0	\N
236871	1678	2160042096000	2857	1496	1	0	\N
236872	1474	6474062000000	2857	1496	2	0	\N
236873	1678	2160042095000	2858	1496	0	0	\N
236874	1678	2160042096000	2858	1496	1	0	\N
236875	1474	6474062000000	2858	1496	2	0	\N
236876	1474	6474062000000	2859	1496	0	0	\N
236877	1678	2160042095000	2860	1496	0	0	\N
236878	1678	2160042096000	2860	1496	1	0	\N
236879	1474	6474062000000	2860	1496	2	0	\N
236881	1678	2160041964000	2862	1405	0	0	\N
236884	1678	2160042100000	2864	1499	0	0	\N
236889	1678	2160042101000	2867	1500	0	0	\N
236890	1678	2160042102000	2867	1500	1	0	\N
236891	1678	2160042103000	2867	1500	2	0	\N
236892	1678	2160042104000	2869	1501	0	0	\N
236895	1678	2160042104000	2872	1502	0	0	\N
236896	1678	2160042105000	2872	1502	1	0	\N
236898	1678	2160042107000	2875	1504	0	0	\N
236900	1678	2160042108000	2877	1505	0	0	\N
236901	1678	2160042108000	2878	1505	0	0	\N
236902	1678	2160042108000	2879	1505	0	0	\N
236905	1678	2160042108000	2882	1506	0	0	\N
236906	1678	2160042109000	2882	1506	1	0	\N
236907	1678	2160042108000	2883	1506	0	0	\N
236908	1678	2160042109000	2883	1506	1	0	\N
236909	1678	2160042110000	2884	1507	0	0	\N
236911	1678	2160042110000	2886	1507	0	0	\N
236807	1678	2160042055000	2808	1467	1	0	0
236808	1678	2160042056000	2809	1468	0	0	0
236809	1678	2160042057000	2810	1469	0	0	0
236810	1678	2160042058000	2811	1470	0	0	0
236811	1678	2160042059000	2812	1471	0	0	0
236814	1678	2160042061000	2817	1473	0	0	0
236815	1678	2160042062000	2817	1473	1	0	0
236816	1769	1000000000	2822	1474	0	0	0
236817	1678	2160042063000	2822	1474	1	0	0
236818	1769	3000000000	2825	1475	0	0	0
236828	1678	2160042064000	2829	1478	0	0	0
236829	1678	2160042065000	2829	1478	1	0	0
236830	1678	2160042066000	2829	1478	2	0	0
236831	1678	2160042067000	2829	1478	3	0	0
236833	1678	2160042069000	2829	1478	5	0	0
236834	1678	2160042070000	2829	1478	6	0	0
236835	1678	2160042071000	2829	1478	7	0	0
236836	1678	2160042072000	2832	1480	0	0	0
236837	1678	2160042073000	2832	1480	1	0	0
236842	1678	2160042075000	2836	1482	0	0	0
236843	1678	2160042076000	2836	1482	1	0	0
236844	1678	2160042077000	2836	1482	2	0	0
236845	44	70320160000000	2836	1482	3	0	0
236846	1678	2160042078000	2838	1484	0	0	0
236848	1678	2160042080000	2838	1484	2	0	0
236849	1678	2160042081000	2840	1485	0	0	0
236850	1678	2160042082000	2841	1486	0	0	0
236851	1678	2160042083000	2841	1486	1	0	0
236853	1678	2160042085000	2842	1487	1	0	0
236854	1678	2160042086000	2843	1488	0	0	0
236855	1678	2160042087000	2844	1489	0	0	0
236857	1678	2160042088000	2846	1490	0	0	0
236858	1678	2160042089000	2847	1491	0	0	0
236860	1678	2160042091000	2849	1492	0	0	0
236861	1678	2160042092000	2850	1493	0	0	0
236863	1678	2160042093000	2854	1495	0	0	0
236864	1678	2160042094000	2854	1495	1	0	0
236867	1678	2160042095000	2856	1496	0	0	0
236869	1474	6474062000000	2856	1496	2	0	3
236880	1678	2160042097000	2861	1497	0	0	0
236882	1678	2160042098000	2863	1498	0	0	0
236883	1678	2160042099000	2863	1498	1	0	0
236886	1678	2160042101000	2866	1500	0	0	0
236887	1678	2160042102000	2866	1500	1	0	0
236888	1678	2160042103000	2866	1500	2	0	0
236893	1678	2160042104000	2871	1502	0	0	0
236894	1678	2160042105000	2871	1502	1	0	0
236899	1678	2160042107000	2876	1504	0	0	0
236903	1678	2160042108000	2881	1506	0	0	0
236904	1678	2160042109000	2881	1506	1	0	0
236910	1678	2160042110000	2885	1507	0	0	0
236912	1678	2160042111000	2887	1508	0	0	0
236914	1678	2160042112000	2889	1509	0	0	\N
236916	1678	2160042113000	2891	1510	0	0	\N
236917	1678	2160042113000	2892	1510	0	0	\N
236918	1678	2160042113000	2893	1510	0	0	\N
236919	1678	2160042113000	2894	1510	0	0	\N
236925	1678	2160042119000	2897	1513	0	0	\N
236928	1678	2160042120000	2900	1514	0	0	\N
236929	1678	2160042121000	2902	1515	0	0	\N
236932	1678	2160042123000	2905	1517	0	0	\N
236933	1678	2160042124000	2905	1517	1	0	\N
236934	1678	2160042125000	2905	1517	2	0	\N
236935	1678	2160042126000	2905	1517	3	0	\N
236940	1678	2160042123000	2908	1517	0	0	\N
236941	1678	2160042124000	2908	1517	1	0	\N
236942	1678	2160042125000	2908	1517	2	0	\N
236943	1678	2160042126000	2908	1517	3	0	\N
236944	1678	2160042123000	2909	1517	0	0	\N
236945	1678	2160042124000	2909	1517	1	0	\N
236946	1678	2160042125000	2909	1517	2	0	\N
236947	1678	2160042126000	2909	1517	3	0	\N
236948	1678	2160042127000	2911	1518	0	0	\N
236949	1678	2160042128000	2911	1518	1	0	\N
236950	1678	2160042129000	2911	1518	2	0	\N
236951	1678	2160042130000	2911	1518	3	0	\N
236952	1678	2160042131000	2911	1518	4	0	\N
236953	1769	1000000000	2912	1465	0	0	\N
236954	1678	2160042050000	2912	1465	1	0	\N
236955	1678	2160042051000	2912	1465	2	0	\N
236956	1678	2160042052000	2912	1465	3	0	\N
236957	1678	2160042053000	2912	1465	4	0	\N
236958	1678	2160042054000	2912	1465	5	0	\N
236959	1678	2160042055000	2912	1465	6	0	\N
236960	1678	2160042056000	2912	1465	7	0	\N
236961	1769	3000000000	2912	1465	8	0	\N
236962	1678	2160042057000	2912	1465	9	0	\N
236963	1678	2160042058000	2912	1465	10	0	\N
236964	1678	2160042059000	2912	1465	11	0	\N
236965	1678	2160042060000	2912	1465	12	0	\N
236966	1678	2160042061000	2912	1465	13	0	\N
236967	1678	2160042062000	2912	1465	14	0	\N
236968	1678	2160042063000	2912	1465	15	0	\N
236969	1678	2160042064000	2912	1465	16	0	\N
236970	1678	2160042065000	2912	1465	17	0	\N
236971	1678	2160042066000	2912	1465	18	0	\N
236972	1678	2160042067000	2912	1465	19	0	\N
236973	1678	2160042068000	2912	1465	20	0	\N
236974	1678	2160042069000	2912	1465	21	0	\N
236975	1678	2160042070000	2912	1465	22	0	\N
236976	1678	2160042071000	2912	1465	23	0	\N
236977	1678	2160042072000	2912	1465	24	0	\N
236978	1678	2160042073000	2912	1465	25	0	\N
236979	1678	2160042074000	2912	1465	26	0	\N
236980	1678	2160042075000	2912	1465	27	0	\N
236981	1678	2160042076000	2912	1465	28	0	\N
236982	1678	2160042077000	2912	1465	29	0	\N
236983	1678	2160042078000	2912	1465	30	0	\N
236984	1678	2160042079000	2912	1465	31	0	\N
236985	1678	2160042080000	2912	1465	32	0	\N
236986	1678	2160042081000	2912	1465	33	0	\N
236987	1678	2160042082000	2912	1465	34	0	\N
236988	1678	2160042083000	2912	1465	35	0	\N
236989	1678	2160042084000	2912	1465	36	0	\N
236990	1678	2160042085000	2912	1465	37	0	\N
236991	1678	2160042086000	2912	1465	38	0	\N
236992	1678	2160042087000	2912	1465	39	0	\N
236993	1678	2160042088000	2912	1465	40	0	\N
236994	1678	2160042089000	2912	1465	41	0	\N
236995	1678	2160042090000	2912	1465	42	0	\N
236996	1678	2160042091000	2912	1465	43	0	\N
236997	1678	2160042092000	2912	1465	44	0	\N
236998	1678	2160042093000	2912	1465	45	0	\N
236999	1678	2160042094000	2912	1465	46	0	\N
237000	1678	2160042095000	2912	1465	47	0	\N
237001	1678	2160042096000	2912	1465	48	0	\N
237002	1678	2160042097000	2912	1465	49	0	\N
237003	1678	2160042098000	2912	1465	50	0	\N
237009	1678	2160042127000	2914	1518	0	0	\N
237010	1678	2160042128000	2914	1518	1	0	\N
237011	1678	2160042129000	2914	1518	2	0	\N
237012	1678	2160042130000	2914	1518	3	0	\N
237013	1678	2160042131000	2914	1518	4	0	\N
237014	1678	2160042132000	2915	1519	0	0	\N
237020	1678	2160042003000	2921	1432	0	0	\N
237021	1678	2160042004000	2921	1432	1	0	\N
237022	1678	2160042005000	2921	1432	2	0	\N
237023	528	66002000000000	2921	1432	3	0	\N
237024	1769	1000000000	2921	1432	4	0	\N
237025	1769	3000000000	2921	1432	5	0	\N
237026	1678	2160042006000	2921	1432	6	0	\N
237027	1678	2160042007000	2921	1432	7	0	\N
237028	1678	2160042008000	2921	1432	8	0	\N
237029	1678	2160042009000	2921	1432	9	0	\N
237030	1678	2160042010000	2921	1432	10	0	\N
237031	1678	2160042011000	2921	1432	11	0	\N
237032	1678	2160042012000	2921	1432	12	0	\N
237033	1678	2160042013000	2921	1432	13	0	\N
237034	1678	2160042014000	2921	1432	14	0	\N
237035	1678	2160042015000	2921	1432	15	0	\N
237036	1678	2160042016000	2921	1432	16	0	\N
237037	1678	2160042017000	2921	1432	17	0	\N
237038	1678	2160042018000	2921	1432	18	0	\N
237039	1678	2160042019000	2921	1432	19	0	\N
237040	1678	2160042020000	2921	1432	20	0	\N
237041	1678	2160042021000	2921	1432	21	0	\N
237042	1678	2160042022000	2921	1432	22	0	\N
237043	1678	2160042023000	2921	1432	23	0	\N
237044	1678	2160042024000	2921	1432	24	0	\N
237045	1678	2160042025000	2921	1432	25	0	\N
237046	1678	2160042026000	2921	1432	26	0	\N
237047	1678	2160042027000	2921	1432	27	0	\N
237048	1678	2160042028000	2921	1432	28	0	\N
236920	1678	2160042114000	2895	1511	0	0	0
236921	1678	2160042115000	2895	1511	1	0	0
236922	1678	2160042116000	2895	1511	2	0	0
236923	1678	2160042117000	2896	1512	0	0	0
236924	1678	2160042118000	2896	1512	1	0	0
236927	1678	2160042120000	2899	1514	0	0	0
236930	1678	2160042121000	2903	1515	0	0	0
236931	1678	2160042122000	2904	1516	0	0	0
236936	1678	2160042123000	2906	1517	0	0	0
236937	1678	2160042124000	2906	1517	1	0	0
236939	1678	2160042126000	2906	1517	3	0	0
237004	1678	2160042127000	2913	1518	0	0	0
237005	1678	2160042128000	2913	1518	1	0	0
237006	1678	2160042129000	2913	1518	2	0	0
237008	1678	2160042131000	2913	1518	4	0	0
237015	1678	2160042132000	2916	1519	0	0	0
237016	1678	2160042133000	2918	1520	0	0	0
237017	1678	2160042134000	2918	1520	1	0	0
237018	1678	2160042135000	2918	1520	2	0	0
237049	1678	2160042029000	2921	1432	29	0	\N
237050	1678	2160042030000	2921	1432	30	0	\N
237051	1678	2160042031000	2921	1432	31	0	\N
237052	1678	2160042032000	2921	1432	32	0	\N
237053	1678	2160042033000	2921	1432	33	0	\N
237054	1678	2160042034000	2921	1432	34	0	\N
237055	1678	2160042035000	2921	1432	35	0	\N
237056	1678	2160042036000	2921	1432	36	0	\N
237057	1678	2160042037000	2921	1432	38	0	\N
237058	1678	2160042038000	2921	1432	39	0	\N
237059	1678	2160042039000	2921	1432	40	0	\N
237060	1678	2160042040000	2921	1432	41	0	\N
237061	1678	2160042041000	2921	1432	42	0	\N
237062	1678	2160042042000	2921	1432	43	0	\N
237063	1678	2160042043000	2921	1432	44	0	\N
237064	1678	2160042044000	2921	1432	45	0	\N
237065	1678	2160042045000	2921	1432	46	0	\N
237066	1678	2160042046000	2921	1432	47	0	\N
237067	1678	2160042047000	2921	1432	48	0	\N
237068	1678	2160042048000	2921	1432	49	0	\N
237069	1678	2160042049000	2921	1432	50	0	\N
237070	1678	2160042050000	2921	1432	51	0	\N
237071	1678	2160042051000	2921	1432	52	0	\N
237072	1678	2160042052000	2921	1432	53	0	\N
237073	1678	2160042053000	2921	1432	54	0	\N
237074	1678	2160042054000	2921	1432	55	0	\N
237075	1678	2160042055000	2921	1432	56	0	\N
237076	1678	2160042056000	2921	1432	57	0	\N
237077	1678	2160042057000	2921	1432	58	0	\N
237078	1678	2160042058000	2921	1432	59	0	\N
237079	1678	2160042059000	2921	1432	60	0	\N
237080	1678	2160042060000	2921	1432	61	0	\N
237081	1678	2160042061000	2921	1432	62	0	\N
237082	1678	2160042062000	2921	1432	63	0	\N
237083	1678	2160042063000	2921	1432	64	0	\N
237084	1678	2160042064000	2921	1432	65	0	\N
237085	1678	2160042065000	2921	1432	66	0	\N
237086	1678	2160042066000	2921	1432	67	0	\N
237087	1678	2160042067000	2921	1432	68	0	\N
237088	1678	2160042068000	2921	1432	69	0	\N
237089	1678	2160042069000	2921	1432	70	0	\N
237090	1678	2160042070000	2921	1432	71	0	\N
237091	1678	2160042071000	2921	1432	72	0	\N
237092	1678	2160042072000	2921	1432	73	0	\N
237093	1678	2160042073000	2921	1432	74	0	\N
237094	1678	2160042074000	2921	1432	75	0	\N
237095	1678	2160042075000	2921	1432	76	0	\N
237096	1678	2160042076000	2921	1432	77	0	\N
237097	1678	2160042077000	2921	1432	78	0	\N
237098	1678	2160042078000	2921	1432	79	0	\N
237099	1678	2160042079000	2921	1432	80	0	\N
237100	1678	2160042080000	2921	1432	81	0	\N
237101	1678	2160042081000	2921	1432	82	0	\N
237102	1678	2160042082000	2921	1432	83	0	\N
237103	1678	2160042083000	2921	1432	84	0	\N
237104	1678	2160042084000	2921	1432	85	0	\N
237105	1678	2160042085000	2921	1432	86	0	\N
237106	1678	2160042086000	2921	1432	87	0	\N
237107	1678	2160042087000	2921	1432	88	0	\N
237108	1678	2160042088000	2921	1432	89	0	\N
237109	1678	2160042089000	2921	1432	90	0	\N
237110	1678	2160042090000	2921	1432	91	0	\N
237111	1678	2160042091000	2921	1432	92	0	\N
237112	1678	2160042092000	2921	1432	93	0	\N
237113	1678	2160042093000	2921	1432	94	0	\N
237114	1678	2160042094000	2921	1432	95	0	\N
237115	1678	2160042095000	2921	1432	96	0	\N
237116	1678	2160042096000	2921	1432	97	0	\N
237117	1678	2160042097000	2921	1432	98	0	\N
237118	1678	2160042098000	2921	1432	99	0	\N
237119	1678	2160042099000	2921	1432	100	0	\N
237120	1678	2160042100000	2921	1432	101	0	\N
237121	1678	2160042101000	2921	1432	102	0	\N
237122	1678	2160042102000	2921	1432	103	0	\N
237123	1678	2160042103000	2921	1432	104	0	\N
237124	1678	2160042104000	2921	1432	105	0	\N
237125	1678	2160042105000	2921	1432	106	0	\N
237126	1678	2160042106000	2921	1432	107	0	\N
237127	1678	2160042107000	2921	1432	108	0	\N
237128	1678	2160042108000	2921	1432	109	0	\N
237129	1678	2160042109000	2921	1432	110	0	\N
237130	1678	2160042110000	2921	1432	111	0	\N
237131	1678	2160042111000	2921	1432	112	0	\N
237132	1678	2160042112000	2921	1432	113	0	\N
237133	1678	2160042113000	2921	1432	114	0	\N
237134	1678	2160042114000	2921	1432	115	0	\N
237135	1678	2160042115000	2921	1432	116	0	\N
237136	1678	2160042116000	2921	1432	117	0	\N
237137	1678	2160042117000	2921	1432	118	0	\N
237138	1678	2160042118000	2921	1432	119	0	\N
237139	1678	2160042119000	2921	1432	120	0	\N
237140	1678	2160042120000	2921	1432	121	0	\N
237141	1678	2160042121000	2921	1432	122	0	\N
237142	1678	2160042122000	2921	1432	123	0	\N
237143	1678	2160042123000	2921	1432	124	0	\N
237144	1678	2160042124000	2921	1432	125	0	\N
237145	1678	2160042137000	2922	1522	0	0	\N
237146	1678	2160042138000	2922	1522	1	0	\N
237149	1678	2160042137000	2924	1522	0	0	\N
237150	1678	2160042138000	2924	1522	1	0	\N
237151	1678	2160042137000	2925	1522	0	0	\N
237152	1678	2160042138000	2925	1522	1	0	\N
237153	1678	2160042139000	2927	1523	0	0	\N
237154	1678	2160042139000	2928	1523	0	0	\N
237155	1678	2160042139000	2929	1524	0	0	\N
237156	1678	2160042140000	2929	1524	1	0	\N
237159	1678	2160042139000	2931	1524	0	0	\N
237160	1678	2160042140000	2931	1524	1	0	\N
237163	1678	2160042143000	2934	1526	0	0	\N
237168	1678	2160042146000	2942	1529	0	0	\N
237170	1678	2160042148000	2945	1531	0	0	\N
237173	1678	2160042150000	2948	1533	0	0	\N
237184	1678	2160042160000	2954	1537	0	0	\N
237157	1678	2160042139000	2930	1524	0	0	0
237158	1678	2160042140000	2930	1524	1	0	0
237161	1678	2160042141000	2932	1525	0	0	0
237162	1678	2160042142000	2932	1525	1	0	0
237164	1678	2160042143000	2935	1527	0	0	0
237166	1678	2160042145000	2936	1528	0	0	0
237167	1678	2160042146000	2941	1529	0	0	0
237169	1678	2160042147000	2943	1530	0	0	0
237171	1678	2160042148000	2946	1531	0	0	0
237172	1678	2160042149000	2947	1532	0	0	0
237175	1678	2160042151000	2950	1534	0	0	0
237176	1678	2160042152000	2950	1534	1	0	0
237177	1678	2160042153000	2950	1534	2	0	0
237178	1678	2160042154000	2950	1534	3	0	0
237180	1678	2160042156000	2952	1535	1	0	0
237181	1678	2160042157000	2952	1535	2	0	0
237182	1678	2160042158000	2952	1535	3	0	0
237183	1678	2160042159000	2953	1536	0	0	0
237185	1678	2160042160000	2955	1537	0	0	\N
237188	1678	2160042161000	2959	1538	0	0	\N
237189	1678	2160042161000	2960	1538	0	0	\N
237190	1678	2160042161000	2961	1538	0	0	\N
237192	1678	2160042162000	2963	1539	0	0	\N
237193	1678	2160042163000	2964	1540	0	0	\N
237195	1678	2160042163000	2966	1540	0	0	\N
237205	1678	2160042170000	2972	1545	0	0	\N
237206	1678	2160042171000	2972	1545	1	0	\N
237207	1678	2160042172000	2972	1545	2	0	\N
237209	1678	2160042173000	2974	1546	0	0	\N
237213	1678	2160042177000	2978	1549	0	0	\N
237214	1678	2160042177000	2979	1549	0	0	\N
237218	1678	2160042180000	2983	1552	0	0	\N
237220	1678	2160042180000	2985	1552	0	0	\N
237221	1678	2160042180000	2986	1552	0	0	\N
237223	1678	2160042181000	2988	1553	0	0	\N
237227	1678	2160042182000	2991	1554	0	0	\N
237228	1678	2160042183000	2991	1554	2	0	\N
237229	1678	2160042184000	2991	1554	3	0	\N
237231	1678	2160042185000	2993	1555	0	0	\N
237235	1678	2160042187000	2996	1557	0	0	\N
237236	1678	2160042188000	2996	1557	1	0	\N
237237	1737	1100001100	2997	1558	0	0	\N
237238	1737	1100001100	2998	1558	0	0	\N
237240	1737	1100000200	3004	1359	0	0	\N
237241	1678	2160041897000	3004	1359	1	0	\N
237242	1678	2160041898000	3004	1359	2	0	\N
237243	1678	2160041899000	3004	1359	3	0	\N
237244	1678	2160041900000	3004	1359	4	0	\N
237245	1678	2160041901000	3004	1359	5	0	\N
237246	1678	2160041902000	3004	1359	6	0	\N
237247	1678	2160041903000	3004	1359	7	0	\N
237248	528	66002000000000	3004	1359	8	0	\N
237249	1769	1000000000	3004	1359	9	0	\N
237250	1769	3000000000	3004	1359	10	0	\N
237251	1678	2160041904000	3004	1359	11	0	\N
237252	1678	2160041905000	3004	1359	12	0	\N
237253	1678	2160041906000	3004	1359	13	0	\N
237254	1678	2160041907000	3004	1359	14	0	\N
237255	1678	2160041908000	3004	1359	15	0	\N
237256	1678	2160041909000	3004	1359	16	0	\N
237257	1678	2160041910000	3004	1359	17	0	\N
237258	1678	2160041911000	3004	1359	18	0	\N
237259	1678	2160041912000	3004	1359	19	0	\N
237260	1678	2160041913000	3004	1359	20	0	\N
237261	1678	2160041914000	3004	1359	21	0	\N
237262	1678	2160041915000	3004	1359	22	0	\N
237263	1678	2160041916000	3004	1359	23	0	\N
237264	1678	2160041917000	3004	1359	24	0	\N
237265	1678	2160041918000	3004	1359	25	0	\N
237266	1678	2160041919000	3004	1359	26	0	\N
237267	1678	2160041920000	3004	1359	27	0	\N
237268	1678	2160041921000	3004	1359	28	0	\N
237269	1678	2160041922000	3004	1359	29	0	\N
237270	1678	2160041923000	3004	1359	30	0	\N
237271	1678	2160041924000	3004	1359	31	0	\N
237272	1678	2160041925000	3004	1359	32	0	\N
237273	1678	2160041926000	3004	1359	33	0	\N
237274	1678	2160041927000	3004	1359	35	0	\N
237275	1678	2160041928000	3004	1359	36	0	\N
237276	1678	2160041929000	3004	1359	37	0	\N
237277	1678	2160041930000	3004	1359	38	0	\N
237278	1678	2160041931000	3004	1359	39	0	\N
237279	1678	2160041932000	3004	1359	40	0	\N
237280	1678	2160041933000	3004	1359	41	0	\N
237281	1678	2160041934000	3004	1359	42	0	\N
237282	1678	2160041935000	3004	1359	43	0	\N
237283	1678	2160041936000	3004	1359	44	0	\N
237284	1678	2160041937000	3004	1359	45	0	\N
237285	1678	2160041938000	3004	1359	46	0	\N
237286	1678	2160041939000	3004	1359	47	0	\N
237287	1678	2160041940000	3004	1359	48	0	\N
237288	1678	2160041941000	3004	1359	49	0	\N
237289	1678	2160041942000	3004	1359	50	0	\N
237290	1678	2160041943000	3004	1359	51	0	\N
237291	1678	2160041944000	3004	1359	52	0	\N
237292	1678	2160041945000	3004	1359	53	0	\N
237293	1678	2160041946000	3004	1359	54	0	\N
237294	1678	2160041947000	3004	1359	55	0	\N
237295	1678	2160041948000	3004	1359	56	0	\N
237296	1678	2160041949000	3004	1359	57	0	\N
237297	1678	2160041950000	3004	1359	58	0	\N
237298	1678	2160041951000	3004	1359	59	0	\N
237299	1678	2160041952000	3004	1359	60	0	\N
237300	1678	2160041953000	3004	1359	61	0	\N
237301	1678	2160041954000	3004	1359	62	0	\N
237302	1678	2160041955000	3004	1359	63	0	\N
237303	1678	2160041956000	3004	1359	64	0	\N
237304	1678	2160041957000	3004	1359	65	0	\N
237305	1678	2160041958000	3004	1359	66	0	\N
237306	1678	2160041959000	3004	1359	67	0	\N
237307	1678	2160041960000	3004	1359	68	0	\N
237310	1678	2160042191000	3011	1564	0	0	\N
237312	1678	2160042192000	3013	1565	0	0	\N
237313	1678	2160042192000	3014	1565	0	0	\N
237316	1678	2160042193000	3017	1566	0	0	\N
237318	1678	2160042194000	3019	1567	0	0	\N
237319	1678	2160042195000	3020	1568	0	0	\N
237191	1678	2160042162000	2962	1539	0	0	0
237194	1678	2160042163000	2965	1540	0	0	0
237196	1678	2160042164000	2967	1541	0	0	0
237197	1678	2160042165000	2968	1542	0	0	0
237198	1678	2160042166000	2969	1543	0	0	0
237200	1678	2160042168000	2969	1543	2	0	0
237201	1678	2160042169000	2970	1544	0	0	0
237202	1678	2160042170000	2971	1545	0	0	0
237203	1678	2160042171000	2971	1545	1	0	0
237204	1678	2160042172000	2971	1545	2	0	0
237210	1678	2160042174000	2975	1547	0	0	0
237211	1678	2160042175000	2975	1547	1	0	0
237212	1678	2160042176000	2976	1548	0	0	0
237215	1678	2160042177000	2980	1549	0	0	0
237217	1678	2160042179000	2982	1551	0	0	0
237219	1678	2160042180000	2984	1552	0	0	0
237222	1678	2160042181000	2987	1553	0	0	0
237224	1678	2160042182000	2990	1554	0	0	0
237225	1678	2160042183000	2990	1554	2	0	0
237230	1678	2160042185000	2992	1555	0	0	0
237232	1678	2160042186000	2994	1556	0	0	0
237233	1678	2160042187000	2995	1557	0	0	0
237234	1678	2160042188000	2995	1557	1	0	0
237239	1737	1100001100	2999	1558	0	0	0
237309	1678	2160042190000	3010	1563	1	0	0
237311	1678	2160042191000	3012	1564	0	0	0
237314	1678	2160042192000	3015	1565	0	0	0
237315	1678	2160042193000	3016	1566	0	0	0
237320	1678	2160042195000	3021	1568	0	0	0
237324	1678	2160042199000	3025	1572	0	0	\N
237325	1678	2160042199000	3026	1572	0	0	\N
237326	1678	2160042199000	3027	1572	0	0	\N
237330	1678	2160042202000	3031	1575	0	0	\N
237332	1678	2160042202000	3033	1575	0	0	\N
237333	1678	2160042203000	3034	1576	0	0	\N
237337	1678	2160042206000	3037	1578	0	0	\N
237339	1678	2160042207000	3039	1579	0	0	\N
237343	1678	2160042210000	3043	1581	0	0	\N
237344	1678	2160042211000	3043	1581	1	0	\N
237348	1737	1100001100	3046	1552	0	0	\N
237349	1678	2160042180000	3046	1552	1	0	\N
237350	1678	2160042181000	3046	1552	2	0	\N
237351	1678	2160042182000	3046	1552	3	0	\N
237352	1678	2160042183000	3046	1552	4	0	\N
237353	1678	2160042184000	3046	1552	5	0	\N
237354	1678	2160042185000	3046	1552	6	0	\N
237355	1678	2160042186000	3046	1552	8	0	\N
237356	1678	2160042187000	3046	1552	9	0	\N
237357	1678	2160042188000	3046	1552	10	0	\N
237358	1678	2160042189000	3046	1552	11	0	\N
237359	1678	2160042190000	3046	1552	12	0	\N
237360	1678	2160042191000	3046	1552	13	0	\N
237361	1678	2160042192000	3046	1552	14	0	\N
237362	1678	2160042193000	3046	1552	15	0	\N
237363	1678	2160042194000	3046	1552	16	0	\N
237364	1678	2160042195000	3046	1552	17	0	\N
237365	1678	2160042196000	3046	1552	18	0	\N
237366	1678	2160042197000	3046	1552	19	0	\N
237367	1678	2160042198000	3046	1552	20	0	\N
237368	1678	2160042199000	3046	1552	21	0	\N
237369	1678	2160042200000	3046	1552	22	0	\N
237370	1678	2160042201000	3046	1552	23	0	\N
237371	1678	2160042202000	3046	1552	24	0	\N
237372	1678	2160042203000	3046	1552	25	0	\N
237373	1678	2160042204000	3046	1552	26	0	\N
237374	1678	2160042205000	3046	1552	27	0	\N
237375	1678	2160042206000	3046	1552	28	0	\N
237376	1678	2160042207000	3046	1552	29	0	\N
237377	1678	2160042208000	3046	1552	30	0	\N
237378	1678	2160042209000	3046	1552	31	0	\N
237379	1678	2160042210000	3046	1552	32	0	\N
237380	1678	2160042211000	3046	1552	33	0	\N
237381	1678	2160042212000	3046	1552	34	0	\N
237384	1678	2160042213000	3048	1583	0	0	\N
237385	1678	2160042214000	3048	1583	1	0	\N
237393	1678	2160042222000	3053	1588	0	0	\N
237395	1678	2160042222000	3055	1588	0	0	\N
237399	1770	4105104499987	3062	1566	0	0	\N
237409	1678	2160042234000	3072	1598	0	0	\N
237411	1678	2160042234000	3074	1598	0	0	\N
237412	1678	2160042234000	3075	1598	0	0	\N
237413	1737	1100001100	3076	1473	0	0	\N
237414	1770	4105104499987	3076	1473	1	0	\N
237415	1769	1000000000	3076	1473	2	0	\N
237416	1678	2160042061000	3076	1473	3	0	\N
237417	1678	2160042062000	3076	1473	4	0	\N
237418	1678	2160042063000	3076	1473	5	0	\N
237419	1678	2160042064000	3076	1473	6	0	\N
237420	1678	2160042065000	3076	1473	7	0	\N
237421	1678	2160042066000	3076	1473	8	0	\N
237422	1769	3000000000	3076	1473	9	0	\N
237423	1678	2160042067000	3076	1473	10	0	\N
237424	1678	2160042068000	3076	1473	11	0	\N
237425	1678	2160042069000	3076	1473	12	0	\N
237426	1678	2160042070000	3076	1473	13	0	\N
237427	1678	2160042071000	3076	1473	14	0	\N
237428	1678	2160042072000	3076	1473	15	0	\N
237429	1678	2160042073000	3076	1473	16	0	\N
237430	1678	2160042074000	3076	1473	17	0	\N
237431	1678	2160042075000	3076	1473	18	0	\N
237432	1678	2160042076000	3076	1473	19	0	\N
237433	1678	2160042077000	3076	1473	20	0	\N
237434	1678	2160042078000	3076	1473	21	0	\N
237435	1678	2160042079000	3076	1473	22	0	\N
237436	1678	2160042080000	3076	1473	23	0	\N
237437	1678	2160042081000	3076	1473	25	0	\N
237438	1678	2160042082000	3076	1473	26	0	\N
237439	1678	2160042083000	3076	1473	27	0	\N
237440	1678	2160042084000	3076	1473	28	0	\N
237441	1678	2160042085000	3076	1473	29	0	\N
237442	1678	2160042086000	3076	1473	30	0	\N
237443	1678	2160042087000	3076	1473	31	0	\N
237444	1678	2160042088000	3076	1473	32	0	\N
237445	1678	2160042089000	3076	1473	33	0	\N
237446	1678	2160042090000	3076	1473	34	0	\N
237447	1678	2160042091000	3076	1473	35	0	\N
237448	1678	2160042092000	3076	1473	36	0	\N
237449	1678	2160042093000	3076	1473	37	0	\N
237450	1678	2160042094000	3076	1473	38	0	\N
237451	1678	2160042095000	3076	1473	39	0	\N
237452	1678	2160042096000	3076	1473	40	0	\N
237453	1678	2160042097000	3076	1473	41	0	\N
237454	1678	2160042098000	3076	1473	42	0	\N
237455	1678	2160042099000	3076	1473	43	0	\N
237456	1678	2160042100000	3076	1473	44	0	\N
237323	1678	2160042198000	3024	1571	0	0	0
237327	1678	2160042199000	3028	1572	0	0	0
237328	1678	2160042200000	3029	1573	0	0	0
237329	1678	2160042201000	3030	1574	0	0	0
237331	1678	2160042202000	3032	1575	0	0	0
237335	1678	2160042204000	3036	1577	0	0	0
237336	1678	2160042205000	3036	1577	1	0	0
237338	1678	2160042206000	3038	1578	0	0	0
237340	1678	2160042207000	3040	1579	0	0	0
237341	1678	2160042208000	3042	1580	0	0	0
237345	1678	2160042210000	3044	1581	0	0	0
237346	1678	2160042211000	3044	1581	1	0	0
237347	1678	2160042212000	3045	1582	0	0	0
237382	1678	2160042213000	3047	1583	0	0	0
237386	1678	2160042215000	3049	1584	0	0	0
237387	1678	2160042216000	3050	1585	0	0	0
237388	1678	2160042217000	3050	1585	1	0	0
237389	1678	2160042218000	3050	1585	2	0	0
237390	1678	2160042219000	3051	1586	0	0	0
237392	1678	2160042221000	3052	1587	1	0	0
237394	1678	2160042222000	3054	1588	0	0	0
237396	1770	4105104499987	3058	1589	0	0	0
237397	1678	2160042223000	3058	1589	1	0	0
237398	1678	2160042224000	3058	1589	2	0	0
237401	1678	2160042226000	3064	1591	0	0	0
237402	1678	2160042227000	3065	1592	0	0	0
237403	1678	2160042228000	3067	1593	0	0	0
237404	1678	2160042229000	3068	1594	0	0	0
237406	1678	2160042231000	3070	1596	0	0	0
237407	1678	2160042232000	3070	1596	1	0	0
237408	1678	2160042233000	3071	1597	0	0	0
237410	1678	2160042234000	3073	1598	0	0	0
237457	1678	2160042101000	3076	1473	45	0	\N
237458	1678	2160042102000	3076	1473	46	0	\N
237459	1678	2160042103000	3076	1473	47	0	\N
237460	1678	2160042104000	3076	1473	48	0	\N
237461	1678	2160042105000	3076	1473	49	0	\N
237462	1678	2160042106000	3076	1473	50	0	\N
237463	1678	2160042107000	3076	1473	51	0	\N
237464	1678	2160042108000	3076	1473	52	0	\N
237465	1678	2160042109000	3076	1473	53	0	\N
237466	1678	2160042110000	3076	1473	54	0	\N
237467	1678	2160042111000	3076	1473	55	0	\N
237468	1678	2160042112000	3076	1473	56	0	\N
237469	1678	2160042113000	3076	1473	57	0	\N
237470	1678	2160042114000	3076	1473	58	0	\N
237471	1678	2160042115000	3076	1473	59	0	\N
237472	1678	2160042116000	3076	1473	60	0	\N
237473	1678	2160042117000	3076	1473	61	0	\N
237474	1678	2160042118000	3076	1473	62	0	\N
237475	1678	2160042119000	3076	1473	63	0	\N
237476	1678	2160042120000	3076	1473	64	0	\N
237477	1678	2160042121000	3076	1473	65	0	\N
237478	1678	2160042122000	3076	1473	66	0	\N
237479	1678	2160042123000	3076	1473	67	0	\N
237480	1678	2160042124000	3076	1473	68	0	\N
237481	1678	2160042125000	3076	1473	69	0	\N
237482	1678	2160042126000	3076	1473	70	0	\N
237483	1678	2160042127000	3076	1473	71	0	\N
237484	1678	2160042128000	3076	1473	72	0	\N
237485	1678	2160042129000	3076	1473	73	0	\N
237486	1678	2160042130000	3076	1473	74	0	\N
237487	1678	2160042131000	3076	1473	75	0	\N
237488	1678	2160042132000	3076	1473	76	0	\N
237489	1678	2160042133000	3076	1473	77	0	\N
237490	1678	2160042134000	3076	1473	78	0	\N
237491	1678	2160042135000	3076	1473	79	0	\N
237492	1678	2160042136000	3076	1473	80	0	\N
237493	1678	2160042137000	3076	1473	81	0	\N
237494	1678	2160042138000	3076	1473	82	0	\N
237495	1678	2160042139000	3076	1473	83	0	\N
237496	1678	2160042140000	3076	1473	84	0	\N
237497	1678	2160042141000	3076	1473	85	0	\N
237498	1678	2160042142000	3076	1473	86	0	\N
237499	1678	2160042143000	3076	1473	87	0	\N
237500	1678	2160042144000	3076	1473	88	0	\N
237501	1678	2160042145000	3076	1473	89	0	\N
237502	1678	2160042146000	3076	1473	90	0	\N
237503	1678	2160042147000	3076	1473	91	0	\N
237504	1678	2160042148000	3076	1473	92	0	\N
237505	1678	2160042149000	3076	1473	93	0	\N
237506	1678	2160042150000	3076	1473	94	0	\N
237507	1678	2160042151000	3076	1473	95	0	\N
237508	1678	2160042152000	3076	1473	96	0	\N
237509	1678	2160042153000	3076	1473	97	0	\N
237510	1678	2160042154000	3076	1473	98	0	\N
237511	1678	2160042155000	3076	1473	99	0	\N
237512	1678	2160042156000	3076	1473	100	0	\N
237513	1678	2160042157000	3076	1473	101	0	\N
237514	1678	2160042158000	3076	1473	102	0	\N
237515	1678	2160042159000	3076	1473	103	0	\N
237516	1678	2160042160000	3076	1473	104	0	\N
237517	1678	2160042161000	3076	1473	105	0	\N
237518	1678	2160042162000	3076	1473	106	0	\N
237519	1678	2160042163000	3076	1473	107	0	\N
237520	1678	2160042164000	3076	1473	108	0	\N
237521	1678	2160042165000	3076	1473	109	0	\N
237522	1678	2160042166000	3076	1473	110	0	\N
237523	1678	2160042167000	3076	1473	111	0	\N
237524	1678	2160042168000	3076	1473	112	0	\N
237525	1678	2160042169000	3076	1473	113	0	\N
237526	1678	2160042170000	3076	1473	114	0	\N
237527	1678	2160042171000	3076	1473	115	0	\N
237528	1678	2160042172000	3076	1473	116	0	\N
237529	1678	2160042173000	3076	1473	117	0	\N
237530	1678	2160042174000	3076	1473	118	0	\N
237531	1678	2160042175000	3076	1473	119	0	\N
237532	1678	2160042176000	3076	1473	120	0	\N
237533	1678	2160042177000	3076	1473	121	0	\N
237534	1678	2160042178000	3076	1473	122	0	\N
237535	1678	2160042179000	3076	1473	123	0	\N
237536	1678	2160042180000	3076	1473	124	0	\N
237537	1678	2160042181000	3076	1473	125	0	\N
237539	1678	2160042236000	3078	1600	0	0	\N
237541	1678	2160042236000	3080	1600	0	0	\N
237542	1678	2160042236000	3081	1600	0	0	\N
237543	1678	2160042236000	3082	1600	0	0	\N
237544	1678	2160042236000	3083	1600	0	0	\N
237545	1770	4105104499987	3084	1553	0	0	\N
237546	1678	2160042213000	3084	1553	1	0	\N
237547	1678	2160042214000	3084	1553	2	0	\N
237548	1678	2160042215000	3084	1553	3	0	\N
237549	1678	2160042216000	3084	1553	4	0	\N
237550	1678	2160042217000	3084	1553	5	0	\N
237551	1678	2160042218000	3084	1553	6	0	\N
237552	1678	2160042219000	3084	1553	7	0	\N
237553	1678	2160042220000	3084	1553	8	0	\N
237554	1678	2160042221000	3084	1553	9	0	\N
237555	1678	2160042222000	3084	1553	10	0	\N
237556	1678	2160042223000	3084	1553	11	0	\N
237557	1678	2160042224000	3084	1553	12	0	\N
237558	1678	2160042225000	3084	1553	13	0	\N
237559	1678	2160042226000	3084	1553	14	0	\N
237560	1678	2160042227000	3084	1553	15	0	\N
237561	1678	2160042228000	3084	1553	16	0	\N
237562	1678	2160042229000	3084	1553	17	0	\N
237563	1678	2160042230000	3084	1553	18	0	\N
237564	1678	2160042231000	3084	1553	19	0	\N
237565	1678	2160042232000	3084	1553	20	0	\N
237566	1678	2160042233000	3084	1553	21	0	\N
237567	1678	2160042234000	3084	1553	22	0	\N
237568	1678	2160042235000	3084	1553	23	0	\N
237569	1678	2160042236000	3085	1600	0	0	\N
237573	1678	2160042238000	3088	1602	0	0	\N
237574	1678	2160042239000	3088	1602	1	0	\N
237578	1737	1100000000	3092	1334	0	0	\N
237579	1770	4105104499987	3092	1334	1	0	\N
237580	1769	1000000000	3092	1334	2	0	\N
237581	1678	2160041983000	3092	1334	3	0	\N
237582	1678	2160041984000	3092	1334	4	0	\N
237583	1678	2160041985000	3092	1334	5	0	\N
237584	1678	2160041986000	3092	1334	6	0	\N
237585	1678	2160041987000	3092	1334	7	0	\N
237586	1678	2160041988000	3092	1334	8	0	\N
237587	1678	2160041989000	3092	1334	9	0	\N
237588	1678	2160041990000	3092	1334	10	0	\N
237589	1678	2160041991000	3092	1334	11	0	\N
237590	1678	2160041992000	3092	1334	12	0	\N
237591	1678	2160041993000	3092	1334	13	0	\N
237592	1678	2160041994000	3092	1334	14	0	\N
237570	1678	2160042237000	3086	1601	0	0	0
237571	1678	2160042238000	3087	1602	0	0	0
237572	1678	2160042239000	3087	1602	1	0	0
237575	1678	2160042240000	3089	1603	0	0	0
237576	1678	2160042241000	3090	1604	0	0	0
237593	1769	3000000000	3092	1334	15	0	\N
237594	1678	2160041995000	3092	1334	16	0	\N
237595	1678	2160041996000	3092	1334	17	0	\N
237596	1678	2160041997000	3092	1334	18	0	\N
237597	1678	2160041998000	3092	1334	19	0	\N
237598	1678	2160041999000	3092	1334	20	0	\N
237599	1678	2160042000000	3092	1334	21	0	\N
237600	1678	2160042001000	3092	1334	22	0	\N
237601	1678	2160042002000	3092	1334	23	0	\N
237602	1678	2160042003000	3092	1334	24	0	\N
237603	1678	2160042004000	3092	1334	25	0	\N
237604	1678	2160042005000	3092	1334	26	0	\N
237605	1678	2160042006000	3092	1334	27	0	\N
237606	1678	2160042007000	3092	1334	28	0	\N
237607	1678	2160042008000	3092	1334	29	0	\N
237608	1678	2160042009000	3092	1334	30	0	\N
237609	1678	2160042010000	3092	1334	31	0	\N
237610	1678	2160042011000	3092	1334	32	0	\N
237611	1678	2160042012000	3092	1334	33	0	\N
237612	1678	2160042013000	3092	1334	34	0	\N
237613	1678	2160042014000	3092	1334	35	0	\N
237614	1678	2160042015000	3092	1334	36	0	\N
237615	1678	2160042016000	3092	1334	37	0	\N
237616	1678	2160042017000	3092	1334	38	0	\N
237617	1678	2160042018000	3092	1334	39	0	\N
237618	1678	2160042019000	3092	1334	40	0	\N
237619	1678	2160042020000	3092	1334	41	0	\N
237620	1678	2160042021000	3092	1334	42	0	\N
237621	1678	2160042022000	3092	1334	43	0	\N
237622	1678	2160042023000	3092	1334	44	0	\N
237623	1678	2160042024000	3092	1334	45	0	\N
237624	1678	2160042025000	3092	1334	46	0	\N
237625	1678	2160042026000	3092	1334	47	0	\N
237626	1678	2160042027000	3092	1334	48	0	\N
237627	1678	2160042028000	3092	1334	49	0	\N
237628	1678	2160042029000	3092	1334	50	0	\N
237629	1678	2160042030000	3092	1334	51	0	\N
237630	1678	2160042031000	3092	1334	52	0	\N
237631	1678	2160042032000	3092	1334	53	0	\N
237632	1678	2160042033000	3092	1334	54	0	\N
237633	1678	2160042034000	3092	1334	55	0	\N
237634	1678	2160042035000	3092	1334	56	0	\N
237635	1678	2160042036000	3092	1334	57	0	\N
237636	1678	2160042037000	3092	1334	58	0	\N
237637	1678	2160042038000	3092	1334	59	0	\N
237638	1678	2160042039000	3092	1334	60	0	\N
237639	1678	2160042040000	3092	1334	61	0	\N
237640	1678	2160042041000	3092	1334	62	0	\N
237641	1678	2160042042000	3092	1334	63	0	\N
237642	1678	2160042043000	3092	1334	64	0	\N
237643	1678	2160042044000	3092	1334	65	0	\N
237644	1678	2160042045000	3092	1334	66	0	\N
237645	1678	2160042046000	3092	1334	67	0	\N
237646	1678	2160042047000	3092	1334	68	0	\N
237647	1678	2160042048000	3092	1334	69	0	\N
237648	1678	2160042049000	3092	1334	70	0	\N
237649	1678	2160042050000	3092	1334	71	0	\N
237650	1678	2160042051000	3092	1334	72	0	\N
237651	1678	2160042052000	3092	1334	73	0	\N
237652	1678	2160042053000	3092	1334	74	0	\N
237653	1678	2160042054000	3092	1334	75	0	\N
237654	1678	2160042055000	3092	1334	76	0	\N
237655	1678	2160042056000	3092	1334	77	0	\N
237656	1678	2160042057000	3092	1334	78	0	\N
237657	1678	2160042058000	3092	1334	79	0	\N
237658	1678	2160042059000	3092	1334	80	0	\N
237659	1678	2160042060000	3092	1334	81	0	\N
237660	1678	2160042061000	3092	1334	82	0	\N
237661	1678	2160042062000	3092	1334	83	0	\N
237662	1678	2160042063000	3092	1334	84	0	\N
237663	1678	2160042064000	3092	1334	85	0	\N
237664	1678	2160042065000	3092	1334	86	0	\N
237665	1678	2160042066000	3092	1334	87	0	\N
237666	1678	2160042067000	3092	1334	88	0	\N
237667	1678	2160042068000	3092	1334	89	0	\N
237668	1678	2160042069000	3092	1334	90	0	\N
237669	1678	2160042070000	3092	1334	91	0	\N
237670	1678	2160042071000	3092	1334	92	0	\N
237671	1678	2160042072000	3092	1334	93	0	\N
237672	1678	2160042073000	3092	1334	94	0	\N
237673	1678	2160042074000	3092	1334	95	0	\N
237674	1678	2160042075000	3092	1334	96	0	\N
237675	1678	2160042076000	3092	1334	97	0	\N
237676	1678	2160042077000	3092	1334	98	0	\N
237677	1678	2160042078000	3092	1334	99	0	\N
237678	1678	2160042079000	3092	1334	100	0	\N
237679	1678	2160042080000	3092	1334	101	0	\N
237680	1678	2160042081000	3092	1334	102	0	\N
237681	1678	2160042082000	3092	1334	103	0	\N
237682	1678	2160042083000	3092	1334	104	0	\N
237683	1678	2160042084000	3092	1334	105	0	\N
237684	1678	2160042085000	3092	1334	106	0	\N
237685	1678	2160042086000	3092	1334	107	0	\N
237686	1678	2160042087000	3092	1334	108	0	\N
237687	1678	2160042088000	3092	1334	109	0	\N
237688	1678	2160042089000	3092	1334	110	0	\N
237689	1678	2160042090000	3092	1334	111	0	\N
237690	1678	2160042091000	3092	1334	112	0	\N
237691	1678	2160042092000	3092	1334	113	0	\N
237692	1678	2160042093000	3092	1334	114	0	\N
237693	1678	2160042094000	3092	1334	115	0	\N
237694	1678	2160042095000	3092	1334	116	0	\N
237695	1678	2160042096000	3092	1334	117	0	\N
237696	1678	2160042097000	3092	1334	118	0	\N
237697	1678	2160042098000	3092	1334	119	0	\N
237698	1678	2160042099000	3092	1334	120	0	\N
237699	1678	2160042100000	3092	1334	121	0	\N
237700	1678	2160042101000	3092	1334	122	0	\N
237701	1678	2160042102000	3092	1334	123	0	\N
237702	1678	2160042103000	3092	1334	124	0	\N
237703	1678	2160042104000	3092	1334	125	0	\N
237704	1678	2160042243000	3093	1606	0	0	\N
237705	1678	2160042244000	3093	1606	1	0	\N
237706	1678	2160042245000	3093	1606	2	0	\N
237707	1678	2160042246000	3093	1606	3	0	\N
237708	1678	2160042247000	3093	1606	4	0	\N
237709	1678	2160042248000	3093	1606	5	0	\N
237710	1678	2160042249000	3093	1606	6	0	\N
237711	1771	69383739594	3093	1606	7	0	\N
237720	1678	2160042243000	3095	1606	0	0	\N
237721	1678	2160042244000	3095	1606	1	0	\N
237722	1678	2160042245000	3095	1606	2	0	\N
237723	1678	2160042246000	3095	1606	3	0	\N
237724	1678	2160042247000	3095	1606	4	0	\N
237725	1678	2160042248000	3095	1606	5	0	\N
237726	1678	2160042249000	3095	1606	6	0	\N
237727	1771	69383739594	3095	1606	7	0	\N
237714	1678	2160042245000	3094	1606	2	0	0
237715	1678	2160042246000	3094	1606	3	0	0
237716	1678	2160042247000	3094	1606	4	0	0
237717	1678	2160042248000	3094	1606	5	0	0
237718	1678	2160042249000	3094	1606	6	0	0
237728	1678	2160042250000	3096	1607	0	0	0
237731	1678	2160042250000	3097	1607	0	0	\N
237732	1678	2160042251000	3097	1607	1	0	\N
237733	1771	69384135534	3097	1607	2	0	\N
237734	1678	2160042252000	3098	1608	0	0	\N
237737	1678	2160042253000	3101	1609	0	0	\N
237741	1678	2160042257000	3104	1612	0	0	\N
237747	1678	2160042259000	3109	1614	0	0	\N
237748	1678	2160042260000	3109	1614	1	0	\N
237749	1678	2160042261000	3109	1614	2	0	\N
237752	1678	2160042262000	3111	1615	0	0	\N
237753	1678	2160042263000	3111	1615	1	0	\N
237754	1678	2160042262000	3112	1615	0	0	\N
237755	1678	2160042263000	3112	1615	1	0	\N
237758	1678	2160042266000	3115	1618	0	0	\N
237759	1678	2160042267000	3115	1618	1	0	\N
237760	1678	2160042268000	3115	1618	2	0	\N
237768	1771	69384136474	3120	1622	0	0	\N
237769	1771	69384137414	3120	1622	1	0	\N
237770	1678	2160042273000	3120	1622	2	0	\N
237771	1678	2160042274000	3120	1622	3	0	\N
237772	1771	69384138354	3120	1622	4	0	\N
237773	1771	69384139294	3120	1622	5	0	\N
237774	195	66069405749490	3120	1622	6	0	\N
237775	291	66069405749490	3120	1622	7	0	\N
237776	1023	503306233132568	3120	1622	8	0	\N
237777	1143	901920457445734	3120	1622	9	0	\N
237778	1263	608543704673294	3120	1622	10	0	\N
237779	1389	1695761141761468	3120	1622	11	0	\N
237792	1678	2160042275000	3122	1623	0	0	\N
237793	1678	2160042276000	3122	1623	1	0	\N
237794	1678	2160042277000	3122	1623	2	0	\N
237810	1678	2160042288000	3130	1628	0	0	\N
237811	1771	69383739594	3131	1567	0	0	\N
237812	1771	69384135534	3131	1567	1	0	\N
237813	1771	69384136474	3131	1567	2	0	\N
237814	1771	69384137414	3131	1567	3	0	\N
237815	1771	69384138354	3131	1567	4	0	\N
237816	1771	69384139294	3131	1567	5	0	\N
237817	195	66069405749490	3131	1567	6	0	\N
237818	291	66069405749490	3131	1567	7	0	\N
237819	1023	503306233132568	3131	1567	8	0	\N
237820	1143	901920457445734	3131	1567	9	0	\N
237821	1263	608543704673294	3131	1567	10	0	\N
237822	1389	1695761141761468	3131	1567	11	0	\N
237823	1771	70253739593	3131	1567	12	0	\N
237825	1678	2160042289000	3133	1629	0	0	\N
237828	1678	2160042291000	3136	1631	0	0	\N
237829	1678	2160042291000	3137	1631	0	0	\N
237830	1678	2160042292000	3138	1632	0	0	\N
237831	1678	2160042293000	3138	1632	1	0	\N
237832	1678	2160042294000	3138	1632	2	0	\N
237833	1678	2160042295000	3138	1632	3	0	\N
237845	1678	2160042303000	3142	1635	0	0	\N
237846	1678	2160042303000	3143	1635	0	0	\N
237847	1678	2160042303000	3144	1635	0	0	\N
237849	1678	2160042304000	3146	1636	0	0	\N
237851	1678	2160042305000	3148	1637	0	0	\N
237852	1678	2160042306000	3148	1637	1	0	\N
237856	1678	2160042305000	3151	1637	0	0	\N
237857	1678	2160042306000	3151	1637	1	0	\N
237858	1678	2160042307000	3151	1637	2	0	\N
237859	1678	2160042307000	3152	1638	0	0	\N
237862	1678	2160042310000	3155	1641	0	0	\N
237864	1678	2160042310000	3157	1641	0	0	\N
237735	1678	2160042252000	3099	1608	0	0	0
237736	1678	2160042253000	3100	1609	0	0	0
237738	1678	2160042254000	3102	1610	0	0	0
237739	1678	2160042255000	3103	1611	0	0	0
237740	1678	2160042256000	3103	1611	1	0	0
237743	1678	2160042258000	3107	1613	0	0	0
237744	1678	2160042259000	3108	1614	0	0	0
237745	1678	2160042260000	3108	1614	1	0	0
237746	1678	2160042261000	3108	1614	2	0	0
237750	1678	2160042262000	3110	1615	0	0	0
237756	1678	2160042264000	3113	1616	0	0	0
237757	1678	2160042265000	3114	1617	0	0	0
237761	1678	2160042266000	3116	1618	0	0	0
237762	1678	2160042267000	3116	1618	1	0	0
237764	1678	2160042269000	3117	1619	0	0	0
237765	1678	2160042270000	3117	1619	1	0	0
237766	1678	2160042271000	3118	1620	0	0	0
237767	1678	2160042272000	3119	1621	0	0	0
237780	1771	69384136474	3121	1622	0	0	0
237782	1678	2160042273000	3121	1622	2	0	0
237783	1678	2160042274000	3121	1622	3	0	0
237784	1771	69384138354	3121	1622	4	0	0
237785	1771	69384139294	3121	1622	5	0	0
237786	195	66069405749490	3121	1622	6	0	0
237788	1023	503306233132568	3121	1622	8	0	0
237789	1143	901920457445734	3121	1622	9	0	0
237790	1263	608543704673294	3121	1622	10	0	0
237791	1389	1695761141761468	3121	1622	11	0	0
237796	1678	2160042276000	3123	1623	1	0	0
237797	1678	2160042277000	3123	1623	2	0	0
237798	1678	2160042278000	3124	1624	0	0	0
237799	1678	2160042279000	3124	1624	1	0	0
237800	1678	2160042280000	3124	1624	2	0	0
237802	1678	2160042281000	3125	1625	0	0	0
237803	1678	2160042282000	3125	1625	1	0	0
237804	1678	2160042283000	3125	1625	2	0	0
237805	1678	2160042284000	3128	1627	0	0	0
237806	1678	2160042285000	3128	1627	1	0	0
237808	1678	2160042287000	3128	1627	3	0	0
237809	1678	2160042288000	3129	1628	0	0	0
237824	1678	2160042289000	3132	1629	0	0	0
237826	1678	2160042290000	3134	1630	0	0	0
237834	1678	2160042292000	3139	1632	0	0	0
237835	1678	2160042293000	3139	1632	1	0	0
237836	1678	2160042294000	3139	1632	2	0	0
237837	1678	2160042295000	3139	1632	3	0	0
237838	1678	2160042296000	3140	1633	0	0	0
237840	1678	2160042298000	3141	1634	0	0	0
237841	1678	2160042299000	3141	1634	1	0	0
237842	1678	2160042300000	3141	1634	2	0	0
237843	1678	2160042301000	3141	1634	3	0	0
237844	1678	2160042302000	3141	1634	4	0	0
237850	1678	2160042304000	3147	1636	0	0	0
237853	1678	2160042305000	3149	1637	0	0	0
237854	1678	2160042306000	3149	1637	1	0	0
237855	1678	2160042307000	3150	1638	0	0	0
237861	1678	2160042309000	3154	1640	0	0	0
237863	1678	2160042310000	3156	1641	0	0	0
237865	1678	2160042310000	3158	1641	0	0	\N
237866	1678	2160042311000	3159	1642	0	0	\N
237868	1678	2160042311000	3161	1642	0	0	\N
237869	1678	2160042311000	3162	1642	0	0	\N
237878	1678	2160042319000	3167	1646	0	0	\N
237880	1678	2160042320000	3169	1647	0	0	\N
237882	1678	2160042321000	3171	1648	0	0	\N
237883	1678	2160042321000	3172	1648	0	0	\N
237884	1678	2160042321000	3173	1648	0	0	\N
237885	1678	2160042322000	3174	1649	0	0	\N
237887	1737	1100001100	3176	1531	0	0	\N
237888	1770	4105104499987	3176	1531	1	0	\N
237889	1678	2160042323000	3177	1650	0	0	\N
237890	1678	2160042324000	3177	1650	1	0	\N
237893	1678	2160042325000	3179	1651	0	0	\N
237894	1678	2160042326000	3179	1651	1	0	\N
237897	1678	2160042327000	3181	1652	0	0	\N
237899	1678	2160042327000	3183	1652	0	0	\N
237901	1678	2160042328000	3185	1653	0	0	\N
237903	1678	2160042330000	3187	1655	0	0	\N
237904	1678	2160042330000	3188	1655	0	0	\N
237911	1678	2160042335000	3192	1657	0	0	\N
237913	1678	2160042336000	3194	1658	0	0	\N
237914	1678	2160042336000	3195	1658	0	0	\N
237916	1678	2160042338000	3197	1660	0	0	\N
237917	1678	2160042339000	3197	1660	1	0	\N
237920	1678	2160042340000	3199	1661	0	0	\N
237922	1678	2160042341000	3202	1663	0	0	\N
237923	1678	2160042342000	3202	1663	1	0	\N
237924	1678	2160042343000	3202	1663	2	0	\N
237925	1678	2160042344000	3202	1663	3	0	\N
237926	1678	2160042345000	3202	1663	4	0	\N
237927	1678	2160042346000	3202	1663	5	0	\N
237928	1678	2160042347000	3202	1663	6	0	\N
237938	1678	2160042350000	3206	1666	0	0	\N
237939	1678	2160042350000	3207	1666	0	0	\N
237941	1678	2160042236000	3209	1554	0	0	\N
237942	1678	2160042237000	3209	1554	1	0	\N
237943	1678	2160042238000	3209	1554	2	0	\N
237944	1678	2160042239000	3209	1554	3	0	\N
237945	1678	2160042240000	3209	1554	4	0	\N
237946	1678	2160042241000	3209	1554	5	0	\N
237947	1678	2160042242000	3209	1554	6	0	\N
237948	1678	2160042243000	3209	1554	7	0	\N
237949	1678	2160042244000	3209	1554	8	0	\N
237950	1678	2160042245000	3209	1554	9	0	\N
237951	1678	2160042246000	3209	1554	10	0	\N
237952	1678	2160042247000	3209	1554	11	0	\N
237953	1678	2160042248000	3209	1554	12	0	\N
237954	1678	2160042249000	3209	1554	13	0	\N
237955	1678	2160042250000	3209	1554	14	0	\N
237956	1678	2160042251000	3209	1554	15	0	\N
237957	1678	2160042252000	3209	1554	16	0	\N
237958	1771	69383739594	3209	1554	17	0	\N
237959	1678	2160042253000	3209	1554	18	0	\N
237960	1678	2160042254000	3209	1554	19	0	\N
237961	1678	2160042255000	3209	1554	20	0	\N
237962	1771	69384135534	3209	1554	21	0	\N
237963	1771	69384136474	3209	1554	22	0	\N
237964	1771	69384137414	3209	1554	23	0	\N
237965	1771	69384138354	3209	1554	24	0	\N
237966	1771	69384139294	3209	1554	25	0	\N
237967	195	66069405749490	3209	1554	26	0	\N
237968	291	66069405749490	3209	1554	27	0	\N
237969	1023	503306233132568	3209	1554	28	0	\N
237970	1143	901920457445734	3209	1554	29	0	\N
237971	1263	608543704673294	3209	1554	30	0	\N
237972	1389	1695761141761468	3209	1554	31	0	\N
237973	1771	70253739593	3209	1554	32	0	\N
237974	1678	2160042256000	3209	1554	33	0	\N
237975	1678	2160042257000	3209	1554	34	0	\N
237976	1678	2160042258000	3209	1554	35	0	\N
237977	1678	2160042259000	3209	1554	36	0	\N
237978	1678	2160042260000	3209	1554	37	0	\N
237979	1678	2160042261000	3209	1554	38	0	\N
237980	1678	2160042262000	3209	1554	39	0	\N
237981	1678	2160042263000	3209	1554	40	0	\N
237982	1678	2160042264000	3209	1554	41	0	\N
237983	1678	2160042265000	3209	1554	42	0	\N
237984	1678	2160042266000	3209	1554	43	0	\N
237985	1678	2160042267000	3209	1554	44	0	\N
237986	1678	2160042268000	3209	1554	45	0	\N
237987	1678	2160042269000	3209	1554	46	0	\N
237988	1678	2160042270000	3209	1554	47	0	\N
237989	1678	2160042271000	3209	1554	48	0	\N
237990	1678	2160042272000	3209	1554	49	0	\N
237991	1678	2160042273000	3209	1554	50	0	\N
237992	1678	2160042274000	3209	1554	51	0	\N
237993	1678	2160042275000	3209	1554	52	0	\N
237994	1678	2160042276000	3209	1554	53	0	\N
237995	1678	2160042277000	3209	1554	54	0	\N
237996	1678	2160042278000	3209	1554	55	0	\N
237997	1678	2160042279000	3209	1554	56	0	\N
237998	1678	2160042280000	3209	1554	57	0	\N
237999	1678	2160042281000	3209	1554	58	0	\N
238000	1678	2160042282000	3209	1554	59	0	\N
237871	1678	2160042313000	3164	1644	0	0	0
237872	1678	2160042314000	3165	1645	0	0	0
237873	1678	2160042315000	3165	1645	1	0	0
237874	1678	2160042316000	3165	1645	2	0	0
237875	1678	2160042317000	3165	1645	3	0	0
237877	1678	2160042319000	3166	1646	0	0	0
237879	1678	2160042320000	3168	1647	0	0	0
237881	1678	2160042321000	3170	1648	0	0	0
237886	1678	2160042322000	3175	1649	0	0	0
237891	1678	2160042323000	3178	1650	0	0	0
237895	1678	2160042325000	3180	1651	0	0	0
237896	1678	2160042326000	3180	1651	1	0	0
237898	1678	2160042327000	3182	1652	0	0	0
237900	1678	2160042328000	3184	1653	0	0	0
237905	1678	2160042330000	3189	1655	0	0	0
237906	1678	2160042331000	3190	1656	0	0	0
237907	1678	2160042332000	3190	1656	1	0	0
237908	1678	2160042333000	3190	1656	2	0	0
237909	1678	2160042334000	3190	1656	3	0	0
237912	1678	2160042336000	3193	1658	0	0	0
237915	1678	2160042337000	3196	1659	0	0	0
237918	1678	2160042338000	3198	1660	0	0	0
237919	1678	2160042339000	3198	1660	1	0	0
237921	1678	2160042340000	3200	1661	0	0	0
237930	1678	2160042342000	3203	1663	1	0	0
237931	1678	2160042343000	3203	1663	2	0	0
237932	1678	2160042344000	3203	1663	3	0	0
237933	1678	2160042345000	3203	1663	4	0	0
237935	1678	2160042347000	3203	1663	6	0	0
237936	1678	2160042348000	3204	1664	0	0	0
237937	1678	2160042349000	3205	1665	0	0	0
237940	1678	2160042350000	3208	1666	0	0	0
238001	1678	2160042283000	3209	1554	60	0	\N
238002	1678	2160042284000	3209	1554	61	0	\N
238003	1678	2160042285000	3209	1554	62	0	\N
238004	1678	2160042286000	3209	1554	63	0	\N
238005	1678	2160042287000	3209	1554	64	0	\N
238006	1678	2160042288000	3209	1554	65	0	\N
238007	1678	2160042289000	3209	1554	66	0	\N
238008	1678	2160042290000	3209	1554	67	0	\N
238009	1678	2160042291000	3209	1554	68	0	\N
238010	1678	2160042292000	3209	1554	69	0	\N
238011	1678	2160042293000	3209	1554	70	0	\N
238012	1678	2160042294000	3209	1554	71	0	\N
238013	1678	2160042295000	3209	1554	73	0	\N
238014	1678	2160042296000	3209	1554	74	0	\N
238015	1678	2160042297000	3209	1554	75	0	\N
238016	1678	2160042298000	3209	1554	76	0	\N
238017	1678	2160042299000	3209	1554	77	0	\N
238018	1678	2160042300000	3209	1554	78	0	\N
238019	1678	2160042301000	3209	1554	79	0	\N
238020	1678	2160042302000	3209	1554	80	0	\N
238021	1678	2160042303000	3209	1554	81	0	\N
238022	1678	2160042304000	3209	1554	82	0	\N
238023	1678	2160042305000	3209	1554	83	0	\N
238024	1678	2160042306000	3209	1554	84	0	\N
238025	1678	2160042307000	3209	1554	85	0	\N
238026	1678	2160042308000	3209	1554	86	0	\N
238027	1678	2160042309000	3209	1554	87	0	\N
238028	1678	2160042310000	3209	1554	88	0	\N
238029	1678	2160042311000	3209	1554	89	0	\N
238030	1678	2160042312000	3209	1554	90	0	\N
238031	1678	2160042313000	3209	1554	91	0	\N
238032	1678	2160042314000	3209	1554	92	0	\N
238033	1678	2160042315000	3209	1554	93	0	\N
238034	1678	2160042316000	3209	1554	94	0	\N
238035	1678	2160042317000	3209	1554	95	0	\N
238036	1678	2160042318000	3209	1554	96	0	\N
238037	1678	2160042319000	3209	1554	97	0	\N
238038	1678	2160042320000	3209	1554	98	0	\N
238039	1678	2160042321000	3209	1554	99	0	\N
238040	1678	2160042322000	3209	1554	100	0	\N
238041	1678	2160042323000	3209	1554	101	0	\N
238042	1678	2160042324000	3209	1554	102	0	\N
238043	1678	2160042325000	3209	1554	103	0	\N
238044	1678	2160042326000	3209	1554	104	0	\N
238045	1678	2160042327000	3209	1554	105	0	\N
238046	1678	2160042328000	3209	1554	106	0	\N
238047	1678	2160042329000	3209	1554	107	0	\N
238048	1678	2160042330000	3209	1554	108	0	\N
238049	1678	2160042331000	3209	1554	109	0	\N
238050	1678	2160042332000	3209	1554	110	0	\N
238051	1678	2160042333000	3209	1554	111	0	\N
238052	1678	2160042334000	3209	1554	112	0	\N
238053	1678	2160042335000	3209	1554	113	0	\N
238054	1678	2160042336000	3209	1554	114	0	\N
238055	1678	2160042337000	3209	1554	115	0	\N
238056	1678	2160042338000	3209	1554	116	0	\N
238057	1678	2160042339000	3209	1554	117	0	\N
238058	1678	2160042340000	3209	1554	118	0	\N
238059	1678	2160042341000	3209	1554	119	0	\N
238060	1678	2160042342000	3209	1554	120	0	\N
238061	1678	2160042343000	3209	1554	121	0	\N
238062	1678	2160042344000	3209	1554	122	0	\N
238063	1678	2160042345000	3209	1554	123	0	\N
238064	1678	2160042346000	3209	1554	124	0	\N
238065	1678	2160042347000	3209	1554	125	0	\N
238073	1678	2160042357000	3215	1671	0	0	\N
238076	1678	2160042358000	3217	1672	0	0	\N
238077	1678	2160042359000	3217	1672	1	0	\N
238079	1678	2160042360000	3219	1673	0	0	\N
238080	1678	2160042361000	3220	1674	0	0	\N
238082	1678	2160042361000	3222	1674	0	0	\N
238083	1678	2160042361000	3223	1674	0	0	\N
238084	1678	2160042361000	3224	1674	0	0	\N
238085	1678	2160042361000	3225	1674	0	0	\N
238099	1737	1200001100	3227	1675	0	0	\N
238100	1678	2160042362000	3227	1675	1	0	\N
238101	1678	2160042363000	3227	1675	2	0	\N
238102	41	66087112047044	3227	1675	3	0	\N
238103	225	66087112047044	3227	1675	4	0	\N
238104	304	66087112047044	3227	1675	5	0	\N
238105	308	66087112047044	3227	1675	6	0	\N
238106	373	66087112047044	3227	1675	7	0	\N
238107	191	66087112047044	3227	1675	8	0	\N
238108	877	203321172331632	3227	1675	9	0	\N
238109	309	66087112047044	3227	1675	10	0	\N
238110	731	2002639758987	3227	1675	11	0	\N
238111	217	66087112047044	3227	1675	12	0	\N
238112	1737	1200001100	3228	1675	0	0	\N
238113	1678	2160042362000	3228	1675	1	0	\N
238114	1678	2160042363000	3228	1675	2	0	\N
238115	41	66087112047044	3228	1675	3	0	\N
238116	225	66087112047044	3228	1675	4	0	\N
238117	304	66087112047044	3228	1675	5	0	\N
238118	308	66087112047044	3228	1675	6	0	\N
238119	373	66087112047044	3228	1675	7	0	\N
238120	191	66087112047044	3228	1675	8	0	\N
238121	877	203321172331632	3228	1675	9	0	\N
238122	309	66087112047044	3228	1675	10	0	\N
238123	731	2002639758987	3228	1675	11	0	\N
238124	217	66087112047044	3228	1675	12	0	\N
238125	1737	1200001100	3229	1675	0	0	\N
238126	1678	2160042362000	3229	1675	1	0	\N
238127	1678	2160042363000	3229	1675	2	0	\N
238128	41	66087112047044	3229	1675	3	0	\N
238068	1678	2160042353000	3211	1668	0	0	0
238069	1678	2160042354000	3212	1669	0	0	0
238070	1678	2160042355000	3213	1670	0	0	0
238071	1678	2160042356000	3213	1670	1	0	0
238072	1678	2160042357000	3214	1671	0	0	0
238075	1678	2160042359000	3216	1672	1	0	0
238078	1678	2160042360000	3218	1673	0	0	0
238081	1678	2160042361000	3221	1674	0	0	0
238086	1737	1200001100	3226	1675	0	0	0
238087	1678	2160042362000	3226	1675	1	0	0
238089	41	66087112047044	3226	1675	3	0	0
238090	225	66087112047044	3226	1675	4	0	0
238091	304	66087112047044	3226	1675	5	0	0
238092	308	66087112047044	3226	1675	6	0	0
238094	191	66087112047044	3226	1675	8	0	0
238095	877	203321172331632	3226	1675	9	0	0
238096	309	66087112047044	3226	1675	10	0	0
238097	731	2002639758987	3226	1675	11	0	0
238098	217	66087112047044	3226	1675	12	0	0
238130	402	66087112047044	3230	1676	1	0	0
238131	1030	902162602054525	3230	1676	2	0	0
238132	205	66087112047044	3230	1676	3	0	0
238133	138	66087112047044	3230	1676	4	0	0
238134	275	66087112047044	3230	1676	5	0	0
238136	690	66087112047044	3231	1677	1	0	0
238145	1737	1100001100	3233	1551	0	0	\N
238146	1737	1200001100	3233	1551	1	0	\N
238147	1770	4105104499987	3233	1551	2	0	\N
238148	1678	2160042179000	3233	1551	3	0	\N
238149	1678	2160042180000	3233	1551	4	0	\N
238150	1678	2160042181000	3233	1551	5	0	\N
238151	1678	2160042182000	3233	1551	6	0	\N
238152	1678	2160042183000	3233	1551	7	0	\N
238153	1678	2160042184000	3233	1551	8	0	\N
238154	1678	2160042185000	3233	1551	9	0	\N
238167	1678	2160042372000	3236	1681	0	0	\N
238168	1678	2160042372000	3237	1681	0	0	\N
238188	570	66087112047044	3240	1682	0	0	\N
238189	910	503441359118351	3240	1682	1	0	\N
238190	322	66087112047044	3240	1682	2	0	\N
238191	500	66087112047044	3240	1682	3	0	\N
238192	105	66087112047044	3240	1682	4	0	\N
238193	89	66087112047044	3240	1682	5	0	\N
238194	146	66087112047044	3240	1682	6	0	\N
238195	92	66087112047044	3240	1682	7	0	\N
238196	29	7009239156499	3240	1682	8	0	\N
238197	251	66087112047044	3240	1682	9	0	\N
238198	84	66087112047044	3240	1682	10	0	\N
238199	395	66084082047044	3240	1682	11	0	\N
238200	587	66087112047044	3240	1682	12	0	\N
238201	1678	2160042373000	3240	1682	13	0	\N
238202	1678	2160042374000	3240	1682	14	0	\N
238203	1678	2160042375000	3240	1682	15	0	\N
238204	611	66087112047044	3240	1682	16	0	\N
238205	678	66087112047044	3240	1682	17	0	\N
238209	1678	2160042376000	3242	1683	0	0	\N
238210	320	66087112047044	3242	1683	1	0	\N
238211	710	5006599397497	3242	1683	2	0	\N
238213	1678	2160042377000	3244	1684	0	0	\N
238214	1678	2160042378000	3245	1685	0	0	\N
238215	1678	2160042379000	3245	1685	1	0	\N
238218	1737	1200001100	3247	1675	0	0	\N
238219	1678	2160042362000	3247	1675	1	0	\N
238220	1678	2160042363000	3247	1675	2	0	\N
238221	1678	2160042364000	3247	1675	3	0	\N
238222	1678	2160042365000	3247	1675	4	0	\N
238223	1678	2160042366000	3247	1675	5	0	\N
238224	1678	2160042367000	3247	1675	6	0	\N
238225	1678	2160042368000	3247	1675	7	0	\N
238226	1678	2160042369000	3247	1675	8	0	\N
238227	1678	2160042370000	3247	1675	9	0	\N
238228	1678	2160042371000	3247	1675	10	0	\N
238229	1678	2160042372000	3247	1675	11	0	\N
238230	1678	2160042373000	3247	1675	12	0	\N
238231	1678	2160042374000	3247	1675	13	0	\N
238232	1678	2160042375000	3247	1675	14	0	\N
238233	1678	2160042376000	3247	1675	15	0	\N
238234	1678	2160042377000	3247	1675	16	0	\N
238235	1678	2160042378000	3247	1675	17	0	\N
238236	1678	2160042379000	3247	1675	18	0	\N
238237	41	66087112047044	3247	1675	19	0	\N
238238	225	66087112047044	3247	1675	20	0	\N
238239	304	66087112047044	3247	1675	21	0	\N
238240	308	66087112047044	3247	1675	22	0	\N
238241	373	66087112047044	3247	1675	23	0	\N
238242	191	66087112047044	3247	1675	24	0	\N
238243	877	203321172331632	3247	1675	25	0	\N
238244	309	66087112047044	3247	1675	26	0	\N
238245	731	2002639758987	3247	1675	27	0	\N
238246	217	66087112047044	3247	1675	28	0	\N
238247	402	66087112047044	3247	1675	29	0	\N
238248	1030	902162602054525	3247	1675	30	0	\N
238249	205	66087112047044	3247	1675	31	0	\N
238250	138	66087112047044	3247	1675	32	0	\N
238251	275	66087112047044	3247	1675	33	0	\N
238252	397	66087112047044	3247	1675	34	0	\N
238253	690	66087112047044	3247	1675	35	0	\N
238254	106	66087112047044	3247	1675	36	0	\N
238255	894	307227885873282	3247	1675	37	0	\N
238256	5	6705839233000	3247	1675	38	0	\N
238257	122	66087112047044	3247	1675	39	0	\N
238258	91	66087112047044	3247	1675	40	0	\N
238259	99	66087112047044	3247	1675	41	0	\N
238260	339	66087112047044	3247	1675	42	0	\N
238261	420	66087112047044	3247	1675	43	0	\N
238262	206	66087112047044	3247	1675	44	0	\N
238263	408	66087112047044	3247	1675	45	0	\N
238264	438	66087112047044	3247	1675	46	0	\N
238265	534	66087112047044	3247	1675	47	0	\N
238266	399	66087112047044	3247	1675	48	0	\N
238267	570	66087112047044	3247	1675	49	0	\N
238268	910	503441359118351	3247	1675	50	0	\N
238269	322	66087112047044	3247	1675	51	0	\N
238270	500	66087112047044	3247	1675	52	0	\N
238271	105	66087112047044	3247	1675	53	0	\N
238272	89	66087112047044	3247	1675	54	0	\N
238139	1678	2160042367000	3232	1678	0	0	0
238140	1678	2160042368000	3232	1678	1	0	0
238141	106	66087112047044	3232	1678	2	0	0
238142	894	307227885873282	3232	1678	3	0	0
238143	5	6705839233000	3232	1678	4	0	0
238155	91	66087112047044	3234	1679	0	0	0
238156	99	66087112047044	3234	1679	1	0	0
238157	339	66087112047044	3234	1679	2	0	0
238158	1678	2160042369000	3234	1679	3	0	0
238159	1678	2160042370000	3234	1679	4	0	0
238161	206	66087112047044	3234	1679	6	0	0
238162	408	66087112047044	3234	1679	7	0	0
238163	1678	2160042371000	3235	1680	0	0	0
238164	438	66087112047044	3235	1680	1	0	0
238166	399	66087112047044	3235	1680	3	0	0
238169	1678	2160042372000	3238	1681	0	0	0
238170	570	66087112047044	3239	1682	0	0	0
238171	910	503441359118351	3239	1682	1	0	0
238172	322	66087112047044	3239	1682	2	0	0
238174	105	66087112047044	3239	1682	4	0	0
238175	89	66087112047044	3239	1682	5	0	0
238176	146	66087112047044	3239	1682	6	0	0
238177	92	66087112047044	3239	1682	7	0	0
238178	29	7009239156499	3239	1682	8	0	0
238180	84	66087112047044	3239	1682	10	0	0
238181	395	66084082047044	3239	1682	11	0	1
238182	587	66087112047044	3239	1682	12	0	0
238183	1678	2160042373000	3239	1682	13	0	0
238185	1678	2160042375000	3239	1682	15	0	0
238186	611	66087112047044	3239	1682	16	0	0
238187	678	66087112047044	3239	1682	17	0	0
238206	1678	2160042376000	3241	1683	0	0	0
238207	320	66087112047044	3241	1683	1	0	0
238212	1678	2160042377000	3243	1684	0	0	0
238216	1678	2160042378000	3246	1685	0	0	0
238217	1678	2160042379000	3246	1685	1	0	0
238273	146	66087112047044	3247	1675	55	0	\N
238274	92	66087112047044	3247	1675	56	0	\N
238275	29	7009239156499	3247	1675	57	0	\N
238276	251	66087112047044	3247	1675	58	0	\N
238277	84	66087112047044	3247	1675	59	0	\N
238278	395	66084082047044	3247	1675	60	0	\N
238279	587	66087112047044	3247	1675	61	0	\N
238280	611	66087112047044	3247	1675	62	0	\N
238281	678	66087112047044	3247	1675	63	0	\N
238282	320	66087112047044	3247	1675	64	0	\N
238283	710	5006599397497	3247	1675	65	0	\N
238285	1678	2160042381000	3249	1687	0	0	\N
238292	1678	2160042387000	3254	1691	0	0	\N
238293	1678	2160042388000	3254	1691	1	0	\N
238294	1678	2160042387000	3255	1691	0	0	\N
238295	1678	2160042388000	3255	1691	1	0	\N
238299	1678	2160042389000	3258	1692	0	0	\N
238301	1678	2160042391000	3260	1694	0	0	\N
238308	1678	2160042395000	3263	1696	0	0	\N
238309	1678	2160042395000	3264	1696	0	0	\N
238312	1678	2160042397000	3267	1698	0	0	\N
238313	1678	2160042397000	3268	1698	0	0	\N
238315	1737	1200001100	3270	1568	0	0	\N
238316	41	66087112047044	3270	1568	1	0	\N
238317	225	66087112047044	3270	1568	2	0	\N
238318	304	66087112047044	3270	1568	3	0	\N
238319	308	66087112047044	3270	1568	4	0	\N
238320	373	66087112047044	3270	1568	5	0	\N
238321	191	66087112047044	3270	1568	6	0	\N
238322	877	203321172331632	3270	1568	7	0	\N
238323	309	66087112047044	3270	1568	8	0	\N
238324	731	2002639758987	3270	1568	9	0	\N
238325	217	66087112047044	3270	1568	10	0	\N
238326	402	66087112047044	3270	1568	11	0	\N
238327	1030	902162602054525	3270	1568	12	0	\N
238328	205	66087112047044	3270	1568	13	0	\N
238329	138	66087112047044	3270	1568	14	0	\N
238330	275	66087112047044	3270	1568	15	0	\N
238331	397	66087112047044	3270	1568	16	0	\N
238332	690	66087112047044	3270	1568	17	0	\N
238333	106	66087112047044	3270	1568	18	0	\N
238334	894	307227885873282	3270	1568	19	0	\N
238335	5	6705839233000	3270	1568	20	0	\N
238336	122	66087112047044	3270	1568	21	0	\N
238337	91	66087112047044	3270	1568	22	0	\N
238338	99	66087112047044	3270	1568	23	0	\N
238339	339	66087112047044	3270	1568	24	0	\N
238340	420	66087112047044	3270	1568	25	0	\N
238341	206	66087112047044	3270	1568	26	0	\N
238342	408	66087112047044	3270	1568	27	0	\N
238343	438	66087112047044	3270	1568	28	0	\N
238344	534	66087112047044	3270	1568	29	0	\N
238345	399	66087112047044	3270	1568	30	0	\N
238346	570	66087112047044	3270	1568	31	0	\N
238347	910	503441359118351	3270	1568	32	0	\N
238348	322	66087112047044	3270	1568	33	0	\N
238349	500	66087112047044	3270	1568	34	0	\N
238350	105	66087112047044	3270	1568	35	0	\N
238351	89	66087112047044	3270	1568	36	0	\N
238352	146	66087112047044	3270	1568	37	0	\N
238353	92	66087112047044	3270	1568	38	0	\N
238354	29	7009239156499	3270	1568	39	0	\N
238355	251	66087112047044	3270	1568	40	0	\N
238356	84	66087112047044	3270	1568	41	0	\N
238357	395	66084082047044	3270	1568	42	0	\N
238358	587	66087112047044	3270	1568	43	0	\N
238359	611	66087112047044	3270	1568	44	0	\N
238360	678	66087112047044	3270	1568	45	0	\N
238361	320	66087112047044	3270	1568	46	0	\N
238362	710	5006599397497	3270	1568	47	0	\N
238363	721	2002639758987	3270	1568	48	0	\N
238364	295	66087112047044	3270	1568	49	0	\N
238365	1678	2160042398000	3271	1699	0	0	\N
238366	1678	2160042399000	3271	1699	1	0	\N
238371	1678	2160042400000	3274	1700	0	0	\N
238372	1678	2160042401000	3274	1700	1	0	\N
238378	560	66087112047044	3277	1702	0	0	\N
238379	1678	2160042403000	3277	1702	1	0	\N
238380	392	66087112047044	3277	1702	2	0	\N
238381	194	66087112047044	3277	1702	3	0	\N
238382	560	66087112047044	3278	1702	0	0	\N
238383	1678	2160042403000	3278	1702	1	0	\N
238384	392	66087112047044	3278	1702	2	0	\N
238385	194	66087112047044	3278	1702	3	0	\N
238395	1678	2160042410000	3283	1706	0	0	\N
238396	1678	2160042411000	3283	1706	1	0	\N
238397	1678	2160042412000	3283	1706	2	0	\N
238400	1678	2160042413000	3285	1707	0	0	\N
238401	252	66087112047044	3285	1707	1	0	\N
238402	1772	259000000000	3286	1708	0	0	\N
238403	150	66087112047044	3286	1708	1	0	\N
238404	450	66087112047044	3286	1708	2	0	\N
238405	620	66087112047044	3286	1708	3	0	\N
238406	421	66087112047044	3286	1708	4	0	\N
238407	245	66087112047044	3286	1708	5	0	\N
238408	54	66087112047044	3286	1708	6	0	\N
238287	1678	2160042382000	3251	1688	0	0	0
238288	1678	2160042383000	3251	1688	1	0	0
238289	1678	2160042384000	3252	1689	0	0	0
238290	1678	2160042385000	3252	1689	1	0	0
238291	1678	2160042386000	3253	1690	0	0	0
238297	1678	2160042388000	3256	1691	1	0	0
238298	1678	2160042389000	3257	1692	0	0	0
238300	1678	2160042390000	3259	1693	0	0	0
238302	1678	2160042391000	3261	1694	0	0	0
238303	721	2002639758987	3262	1695	0	0	0
238305	1678	2160042392000	3262	1695	2	0	0
238306	1678	2160042393000	3262	1695	3	0	0
238307	1678	2160042394000	3262	1695	4	0	0
238310	1678	2160042395000	3265	1696	0	0	0
238314	1678	2160042397000	3269	1698	0	0	0
238367	1678	2160042398000	3272	1699	0	0	0
238368	1678	2160042399000	3272	1699	1	0	0
238369	1678	2160042400000	3273	1700	0	0	0
238370	1678	2160042401000	3273	1700	1	0	0
238374	560	66087112047044	3276	1702	0	0	0
238375	1678	2160042403000	3276	1702	1	0	0
238376	392	66087112047044	3276	1702	2	0	0
238377	194	66087112047044	3276	1702	3	0	0
238386	1678	2160042404000	3279	1703	0	0	0
238388	1678	2160042406000	3280	1704	0	0	0
238389	1678	2160042407000	3280	1704	1	0	0
238390	1678	2160042408000	3281	1705	0	0	0
238391	1678	2160042409000	3281	1705	1	0	0
238393	1678	2160042411000	3282	1706	1	0	0
238394	1678	2160042412000	3282	1706	2	0	0
238398	1678	2160042413000	3284	1707	0	0	0
238399	252	66087112047044	3284	1707	1	0	0
238409	1678	2160042414000	3286	1708	7	0	\N
238418	1772	259000000000	3288	1708	0	0	\N
238419	150	66087112047044	3288	1708	1	0	\N
238420	450	66087112047044	3288	1708	2	0	\N
238421	620	66087112047044	3288	1708	3	0	\N
238422	421	66087112047044	3288	1708	4	0	\N
238423	245	66087112047044	3288	1708	5	0	\N
238424	54	66087112047044	3288	1708	6	0	\N
238425	1678	2160042414000	3288	1708	7	0	\N
238426	1772	259000000000	3291	1708	0	0	\N
238427	150	66087112047044	3291	1708	1	0	\N
238428	450	66087112047044	3291	1708	2	0	\N
238429	620	66087112047044	3291	1708	3	0	\N
238430	421	66087112047044	3291	1708	4	0	\N
238431	245	66087112047044	3291	1708	5	0	\N
238432	54	66087112047044	3291	1708	6	0	\N
238433	78	66087112047044	3291	1708	7	0	\N
238434	37	65414225088019	3291	1708	8	0	\N
238435	520	66087112047044	3291	1708	9	0	\N
238436	163	66087112047044	3291	1708	10	0	\N
238437	1678	2160042414000	3291	1708	11	0	\N
238438	1678	2160042415000	3291	1708	12	0	\N
238445	1678	2160042416000	3297	1709	0	0	\N
238446	1678	2160042417000	3297	1709	1	0	\N
238449	1678	2160042419000	3299	1712	0	0	\N
238450	1678	2160042420000	3299	1712	1	0	\N
238457	1150	608707084465919	3302	1713	0	0	\N
238458	452	66087112047044	3302	1713	1	0	\N
238459	594	66087112047044	3302	1713	2	0	\N
238460	1678	2160042421000	3302	1713	3	0	\N
238469	1678	2880082425000	3307	1717	0	0	\N
238470	1678	2880082425000	3308	1717	0	0	\N
238471	1678	2880082425000	3309	1717	0	0	\N
238473	1678	2880082426000	3311	1718	0	0	\N
238476	436	66719700000000	3313	1719	0	0	\N
238477	1678	2880082427000	3313	1719	1	0	\N
238478	436	66719700000000	3314	1719	0	0	\N
238479	1678	2880082427000	3314	1719	1	0	\N
238480	1678	2880082428000	3315	1720	0	0	\N
238481	1678	2880082429000	3315	1720	1	0	\N
238482	1678	2880082428000	3316	1720	0	0	\N
238483	1678	2880082429000	3316	1720	1	0	\N
238486	1678	2880082428000	3318	1720	0	0	\N
238487	1678	2880082429000	3318	1720	1	0	\N
238490	1678	2880082430000	3320	1721	0	0	\N
238491	391	66087112047044	3320	1721	1	0	\N
238501	1678	2880082432000	3322	1723	0	0	\N
238502	1678	2880082433000	3322	1723	1	0	\N
238503	660	66087112047044	3322	1723	2	0	\N
238504	1276	1696216414080520	3322	1723	3	0	\N
238505	180	66087112047044	3322	1723	4	0	\N
238506	353	66087112047044	3322	1723	5	0	\N
238507	108	66087112047044	3322	1723	6	0	\N
238508	390	66087112047044	3322	1723	7	0	\N
238509	601	66087112047044	3322	1723	8	0	\N
238510	266	66087112047044	3322	1723	9	0	\N
238511	600	66087112047044	3322	1723	10	0	\N
238512	691	66087112047044	3322	1723	11	0	\N
238513	352	66087112047044	3322	1723	12	0	\N
238514	63	66087112047044	3322	1723	13	0	\N
238515	739	10013198794995	3322	1723	14	0	\N
238516	893	307227885873282	3322	1723	15	0	\N
238517	377	66087112047044	3322	1723	16	0	\N
238518	103	66087112047044	3322	1723	17	0	\N
238519	361	66087112047044	3322	1723	18	0	\N
238539	1678	2880082434000	3324	1724	0	0	\N
238540	10	32558500000000	3324	1724	1	0	\N
238541	10	32559000000000	3324	1724	2	0	\N
238542	283	66000500000000	3324	1724	3	0	\N
238543	238	66000200000000	3324	1724	4	0	\N
238412	450	66087112047044	3287	1708	2	0	0
238413	620	66087112047044	3287	1708	3	0	0
238414	421	66087112047044	3287	1708	4	0	0
238415	245	66087112047044	3287	1708	5	0	0
238416	54	66087112047044	3287	1708	6	0	0
238439	78	66087112047044	3293	1709	0	0	0
238440	37	65414225088019	3293	1709	1	0	0
238441	520	66087112047044	3293	1709	2	0	0
238442	163	66087112047044	3293	1709	3	0	0
238443	1678	2160042415000	3293	1709	4	0	0
238447	1678	2160042417000	3298	1711	0	0	0
238448	1678	2160042418000	3298	1711	1	0	0
238451	1678	2160042419000	3300	1712	0	0	0
238452	1678	2160042420000	3300	1712	1	0	0
238454	452	66087112047044	3301	1713	1	0	0
238455	594	66087112047044	3301	1713	2	0	0
238456	1678	2160042421000	3301	1713	3	0	0
238461	1678	2880082422000	3303	1714	0	0	0
238462	114	66005000000000	3303	1714	1	0	0
238464	436	66003000000000	3305	1716	1	0	0
238465	1773	8892278499961	3305	1716	2	0	0
238466	1678	2880082423000	3305	1716	3	0	0
238467	1678	2880082424000	3305	1716	4	0	0
238468	1678	2880082425000	3306	1717	0	0	0
238474	436	66719700000000	3312	1719	0	0	0
238475	1678	2880082427000	3312	1719	1	0	0
238484	1678	2880082428000	3317	1720	0	0	0
238485	1678	2880082429000	3317	1720	1	0	0
238489	391	66087112047044	3319	1721	1	0	0
238492	1678	2880082431000	3321	1722	0	0	0
238493	622	66090092047044	3321	1722	1	0	1
238494	653	66087112047044	3321	1722	2	0	0
238495	193	66087112047044	3321	1722	3	0	0
238497	593	66087112047044	3321	1722	5	0	0
238498	658	66087112047044	3321	1722	6	0	0
238499	6	32600972636768	3321	1722	7	0	0
238500	652	66087112047044	3321	1722	8	0	0
238520	1678	2880082432000	3323	1723	0	0	0
238522	660	66087112047044	3323	1723	2	0	0
238523	1276	1696216414080520	3323	1723	3	0	0
238524	180	66087112047044	3323	1723	4	0	0
238525	353	66087112047044	3323	1723	5	0	0
238527	390	66087112047044	3323	1723	7	0	0
238528	601	66087112047044	3323	1723	8	0	0
238529	266	66087112047044	3323	1723	9	0	0
238530	600	66087112047044	3323	1723	10	0	0
238531	691	66087112047044	3323	1723	11	0	0
238533	63	66087112047044	3323	1723	13	0	0
238534	739	10013198794995	3323	1723	14	0	0
238535	893	307227885873282	3323	1723	15	0	0
238536	377	66087112047044	3323	1723	16	0	0
238537	103	66087112047044	3323	1723	17	0	0
238544	1678	2880082434000	3325	1724	0	0	0
238559	1678	2880082434000	3329	1724	0	0	\N
238560	1678	2880082435000	3329	1724	1	0	\N
238561	10	32558500000000	3329	1724	2	0	\N
238562	10	32559000000000	3329	1724	3	0	\N
238563	1678	2880082436000	3329	1724	4	0	\N
238564	1678	2880082437000	3329	1724	5	0	\N
238565	1678	2880082438000	3329	1724	6	0	\N
238566	182	66153938198848	3329	1724	7	0	\N
238567	702	44102625465903	3329	1724	8	0	\N
238568	283	66000500000000	3329	1724	9	0	\N
238569	238	66000200000000	3329	1724	10	0	\N
238570	301	66000500000000	3329	1724	11	0	\N
238573	436	66001500000000	3331	1709	0	0	\N
238574	436	66003000000000	3331	1709	1	0	\N
238575	436	66719700000000	3331	1709	2	0	\N
238576	1773	8892278499961	3331	1709	3	0	\N
238577	114	66005000000000	3331	1709	4	0	\N
238582	1678	2880082440000	3333	1729	0	0	\N
238583	1483	0	3333	1729	1	0	\N
238584	1678	2880082441000	3333	1729	2	0	\N
238585	1483	0	3333	1729	3	0	\N
238590	1483	0	3336	1732	0	0	\N
238591	1678	2880082445000	3336	1732	1	0	\N
238592	1678	2880082446000	3336	1732	2	0	\N
238601	1678	2880082451000	3340	1735	0	0	\N
238603	1678	2880082452000	3342	1736	0	0	\N
238604	1678	2880082453000	3342	1736	1	0	\N
238605	1745	8406000000	3342	1736	2	0	\N
238610	1678	2880082455000	3345	1738	0	0	\N
238611	453	66087112047044	3345	1738	1	0	\N
238612	82	66087112047044	3345	1738	2	0	\N
238613	261	66087112047044	3345	1738	3	0	\N
238614	201	66087112047044	3345	1738	5	0	\N
238615	383	66087112047044	3345	1738	6	0	\N
238632	878	203321172331632	3348	1740	0	0	\N
238633	569	66087112047044	3348	1740	1	0	\N
238634	745	2002639758987	3348	1740	2	0	\N
238635	1678	2880082457000	3348	1740	3	0	\N
238636	1774	100000000	3348	1740	4	0	\N
238642	436	66001500000000	3350	1532	0	0	\N
238643	436	66003000000000	3350	1532	1	0	\N
238644	436	66719700000000	3350	1532	2	0	\N
238645	1737	1200001100	3350	1532	3	0	\N
238646	1773	8892278499961	3350	1532	4	0	\N
238647	114	66005000000000	3350	1532	5	0	\N
238648	41	66087112047044	3350	1532	6	0	\N
238649	225	66087112047044	3350	1532	7	0	\N
238650	304	66087112047044	3350	1532	8	0	\N
238651	308	66087112047044	3350	1532	9	0	\N
238652	373	66087112047044	3350	1532	10	0	\N
238653	191	66087112047044	3350	1532	11	0	\N
238654	877	203321172331632	3350	1532	12	0	\N
238655	309	66087112047044	3350	1532	13	0	\N
238656	731	2002639758987	3350	1532	14	0	\N
238657	217	66087112047044	3350	1532	15	0	\N
238658	402	66087112047044	3350	1532	16	0	\N
238659	1030	902162602054525	3350	1532	17	0	\N
238660	205	66087112047044	3350	1532	18	0	\N
238661	138	66087112047044	3350	1532	19	0	\N
238662	275	66087112047044	3350	1532	20	0	\N
238663	397	66087112047044	3350	1532	21	0	\N
238664	690	66087112047044	3350	1532	22	0	\N
238665	106	66087112047044	3350	1532	23	0	\N
238666	894	307227885873282	3350	1532	24	0	\N
238667	5	6705839233000	3350	1532	25	0	\N
238668	122	66087112047044	3350	1532	26	0	\N
238669	91	66087112047044	3350	1532	27	0	\N
238670	99	66087112047044	3350	1532	28	0	\N
238671	339	66087112047044	3350	1532	29	0	\N
238672	420	66087112047044	3350	1532	30	0	\N
238673	206	66087112047044	3350	1532	31	0	\N
238674	408	66087112047044	3350	1532	32	0	\N
238675	438	66087112047044	3350	1532	33	0	\N
238676	534	66087112047044	3350	1532	34	0	\N
238677	399	66087112047044	3350	1532	35	0	\N
238678	570	66087112047044	3350	1532	36	0	\N
238679	910	503441359118351	3350	1532	37	0	\N
238680	322	66087112047044	3350	1532	38	0	\N
238547	283	66000500000000	3325	1724	3	0	0
238548	238	66000200000000	3325	1724	4	0	0
238549	1678	2880082435000	3326	1725	0	0	0
238550	301	66000500000000	3327	1726	0	0	0
238551	1678	2880082436000	3327	1726	1	0	0
238553	182	66153938198848	3328	1727	1	0	0
238554	702	44102625465903	3328	1727	2	0	0
238555	927	503949453650623	3328	1727	3	0	0
238556	1047	903073103102978	3328	1727	4	0	0
238557	1167	609321417666323	3328	1727	5	0	0
238571	1678	2880082438000	3330	1728	0	0	0
238572	1678	2880082439000	3330	1728	1	0	0
238578	1678	2880082440000	3332	1729	0	0	0
238579	1483	0	3332	1729	1	0	0
238581	1483	0	3332	1729	3	0	0
238586	1483	0	3334	1730	0	0	0
238587	1678	2880082442000	3334	1730	1	0	0
238588	1678	2880082443000	3334	1730	2	0	0
238589	1678	2880082444000	3335	1731	0	0	0
238594	1678	2880082445000	3337	1732	1	0	0
238595	1678	2880082446000	3337	1732	2	0	0
238596	1678	2880082447000	3338	1733	0	0	0
238597	1745	8406000000	3338	1733	1	0	2
238598	1678	2880082448000	3339	1734	0	0	0
238600	1678	2880082450000	3339	1734	2	0	0
238602	1678	2880082451000	3341	1735	0	0	0
238606	1678	2880082452000	3343	1736	0	0	0
238607	1678	2880082453000	3343	1736	1	0	0
238609	1678	2880082454000	3344	1737	0	0	0
238616	1678	2880082455000	3346	1738	0	0	0
238617	453	66087112047044	3346	1738	1	0	0
238618	82	66087112047044	3346	1738	2	0	0
238619	261	66087112047044	3346	1738	3	0	0
238621	383	66087112047044	3346	1738	6	0	0
238622	1678	2880082456000	3347	1739	0	0	0
238623	499	66087112047044	3347	1739	1	0	0
238624	35	19225341686403	3347	1739	2	0	0
238625	49	66087112047044	3347	1739	3	0	0
238627	127	66087112047044	3347	1739	5	0	0
238628	186	66087112047044	3347	1739	6	0	0
238629	551	66087112047044	3347	1739	7	0	0
238630	663	66087112047044	3347	1739	8	0	0
238637	878	203321172331632	3349	1740	0	0	0
238638	569	66087112047044	3349	1740	1	0	0
238639	745	2002639758987	3349	1740	2	0	0
238640	1678	2880082457000	3349	1740	3	0	0
238641	1774	100000000	3349	1740	4	0	0
238681	500	66087112047044	3350	1532	39	0	\N
238682	105	66087112047044	3350	1532	40	0	\N
238683	89	66087112047044	3350	1532	41	0	\N
238684	146	66087112047044	3350	1532	42	0	\N
238685	92	66087112047044	3350	1532	43	0	\N
238686	29	7009239156499	3350	1532	44	0	\N
238687	251	66087112047044	3350	1532	45	0	\N
238688	84	66087112047044	3350	1532	46	0	\N
238689	395	66084082047044	3350	1532	47	0	\N
238690	587	66087112047044	3350	1532	48	0	\N
238691	611	66087112047044	3350	1532	49	0	\N
238692	678	66087112047044	3350	1532	50	0	\N
238693	320	66087112047044	3350	1532	51	0	\N
238694	710	5006599397497	3350	1532	52	0	\N
238695	721	2002639758987	3350	1532	53	0	\N
238696	295	66087112047044	3350	1532	54	0	\N
238697	560	66087112047044	3350	1532	55	0	\N
238698	392	66087112047044	3350	1532	56	0	\N
238699	194	66087112047044	3350	1532	57	0	\N
238700	252	66087112047044	3350	1532	58	0	\N
238701	150	66087112047044	3350	1532	59	0	\N
238702	450	66087112047044	3350	1532	60	0	\N
238703	620	66087112047044	3350	1532	61	0	\N
238704	421	66087112047044	3350	1532	62	0	\N
238705	245	66087112047044	3350	1532	63	0	\N
238706	54	66087112047044	3350	1532	64	0	\N
238707	78	66087112047044	3350	1532	65	0	\N
238708	37	65414225088019	3350	1532	66	0	\N
238709	520	66087112047044	3350	1532	67	0	\N
238710	163	66087112047044	3350	1532	68	0	\N
238711	1150	608707084465919	3350	1532	69	0	\N
238712	452	66087112047044	3350	1532	70	0	\N
238713	594	66087112047044	3350	1532	71	0	\N
238714	391	66087112047044	3350	1532	72	0	\N
238715	622	66090092047044	3350	1532	73	0	\N
238716	653	66087112047044	3350	1532	74	0	\N
238717	193	66087112047044	3350	1532	75	0	\N
238718	504	66087112047044	3350	1532	76	0	\N
238719	593	66087112047044	3350	1532	77	0	\N
238720	658	66087112047044	3350	1532	78	0	\N
238721	1678	2880082458000	3351	1741	0	0	\N
238730	1678	2880082462000	3355	1743	0	0	\N
238731	1678	2880082463000	3355	1743	1	0	\N
238732	436	66001500000000	3356	1648	0	0	\N
238733	436	66003000000000	3356	1648	1	0	\N
238734	436	66719700000000	3356	1648	2	0	\N
238735	1737	1200001100	3356	1648	3	0	\N
238736	1773	8892278499961	3356	1648	4	0	\N
238737	114	66005000000000	3356	1648	5	0	\N
238738	41	66087112047044	3356	1648	6	0	\N
238739	225	66087112047044	3356	1648	7	0	\N
238740	304	66087112047044	3356	1648	8	0	\N
238741	308	66087112047044	3356	1648	9	0	\N
238742	373	66087112047044	3356	1648	10	0	\N
238743	191	66087112047044	3356	1648	11	0	\N
238744	877	203321172331632	3356	1648	12	0	\N
238745	309	66087112047044	3356	1648	13	0	\N
238746	731	2002639758987	3356	1648	14	0	\N
238747	217	66087112047044	3356	1648	15	0	\N
238748	402	66087112047044	3356	1648	16	0	\N
238749	1030	902162602054525	3356	1648	17	0	\N
238750	205	66087112047044	3356	1648	18	0	\N
238751	138	66087112047044	3356	1648	19	0	\N
238752	275	66087112047044	3356	1648	20	0	\N
238753	397	66087112047044	3356	1648	21	0	\N
238754	690	66087112047044	3356	1648	22	0	\N
238755	106	66087112047044	3356	1648	23	0	\N
238756	894	307227885873282	3356	1648	24	0	\N
238757	5	6705839233000	3356	1648	25	0	\N
238758	122	66087112047044	3356	1648	26	0	\N
238759	91	66087112047044	3356	1648	27	0	\N
238760	99	66087112047044	3356	1648	28	0	\N
238761	339	66087112047044	3356	1648	29	0	\N
238762	420	66087112047044	3356	1648	30	0	\N
238763	206	66087112047044	3356	1648	31	0	\N
238764	408	66087112047044	3356	1648	32	0	\N
238765	438	66087112047044	3356	1648	33	0	\N
238766	534	66087112047044	3356	1648	34	0	\N
238767	399	66087112047044	3356	1648	35	0	\N
238768	570	66087112047044	3356	1648	36	0	\N
238769	910	503441359118351	3356	1648	37	0	\N
238770	322	66087112047044	3356	1648	38	0	\N
238771	500	66087112047044	3356	1648	39	0	\N
238772	105	66087112047044	3356	1648	40	0	\N
238773	89	66087112047044	3356	1648	41	0	\N
238774	146	66087112047044	3356	1648	42	0	\N
238775	92	66087112047044	3356	1648	43	0	\N
238776	29	7009239156499	3356	1648	44	0	\N
238777	251	66087112047044	3356	1648	45	0	\N
238778	84	66087112047044	3356	1648	46	0	\N
238779	395	66084082047044	3356	1648	47	0	\N
238781	1678	2880082464000	3358	1744	0	0	\N
238789	1678	2880082471000	3364	1749	0	0	\N
238794	1678	2880082476000	3368	1753	0	0	\N
238795	1678	2880082477000	3368	1753	1	0	\N
238796	436	66001500000000	3369	1703	0	0	\N
238797	436	66003000000000	3369	1703	1	0	\N
238798	436	66719700000000	3369	1703	2	0	\N
238799	1773	8892278499961	3369	1703	3	0	\N
238800	1772	259000000000	3369	1703	4	0	\N
238801	252	66087112047044	3369	1703	5	0	\N
238802	114	66005000000000	3369	1703	6	0	\N
238803	150	66087112047044	3369	1703	7	0	\N
238804	450	66087112047044	3369	1703	8	0	\N
238805	620	66087112047044	3369	1703	9	0	\N
238806	421	66087112047044	3369	1703	10	0	\N
238807	245	66087112047044	3369	1703	11	0	\N
238808	54	66087112047044	3369	1703	12	0	\N
238809	78	66087112047044	3369	1703	13	0	\N
238810	37	65414225088019	3369	1703	14	0	\N
238811	520	66087112047044	3369	1703	15	0	\N
238812	163	66087112047044	3369	1703	16	0	\N
238813	1150	608707084465919	3369	1703	17	0	\N
238814	452	66087112047044	3369	1703	18	0	\N
238815	594	66087112047044	3369	1703	19	0	\N
238816	1678	2160042404000	3369	1703	20	0	\N
238724	1678	2880082459000	3352	1741	2	0	0
238725	1483	0	3353	1742	0	0	0
238726	1678	2880082460000	3353	1742	1	0	0
238727	1678	2880082461000	3353	1742	2	0	0
238728	1678	2880082462000	3354	1743	0	0	0
238780	1678	2880082464000	3357	1744	0	0	0
238782	1678	2880082465000	3359	1745	0	0	0
238783	1678	2880082466000	3360	1746	0	0	0
238784	1678	2880082467000	3360	1746	1	0	0
238785	1678	2880082468000	3361	1747	0	0	0
238787	1678	2880082470000	3362	1748	0	0	0
238788	1678	2880082471000	3363	1749	0	0	0
238790	1678	2880082472000	3365	1750	0	0	0
238791	1678	2880082473000	3365	1750	1	0	0
238793	1678	2880082475000	3367	1752	0	0	0
238817	1678	2160042405000	3369	1703	21	0	\N
238818	1678	2160042406000	3369	1703	22	0	\N
238819	1678	2160042407000	3369	1703	23	0	\N
238820	1678	2160042408000	3369	1703	24	0	\N
238821	1678	2160042409000	3369	1703	25	0	\N
238822	1678	2160042410000	3369	1703	26	0	\N
238823	1678	2160042411000	3369	1703	27	0	\N
238824	1678	2160042412000	3369	1703	28	0	\N
238825	1678	2160042413000	3369	1703	29	0	\N
238826	1678	2160042414000	3369	1703	30	0	\N
238827	1678	2160042415000	3369	1703	31	0	\N
238828	1678	2160042416000	3369	1703	32	0	\N
238829	1678	2160042417000	3369	1703	33	0	\N
238830	1678	2160042418000	3369	1703	34	0	\N
238831	1678	2160042419000	3369	1703	35	0	\N
238832	1678	2160042420000	3369	1703	36	0	\N
238833	1678	2160042421000	3369	1703	37	0	\N
238834	1678	2160042422000	3369	1703	38	0	\N
238835	1678	2160042423000	3369	1703	39	0	\N
238836	1678	2160042424000	3369	1703	40	0	\N
238837	1678	2160042425000	3369	1703	41	0	\N
238838	1678	2160042426000	3369	1703	42	0	\N
238839	1678	2160042427000	3369	1703	43	0	\N
238840	1678	2160042428000	3369	1703	44	0	\N
238841	1678	2160042429000	3369	1703	45	0	\N
238842	1678	2160042430000	3369	1703	46	0	\N
238843	1678	2160042431000	3369	1703	47	0	\N
238844	1678	2160042432000	3369	1703	48	0	\N
238845	1678	2160042433000	3369	1703	49	0	\N
238846	1678	2160042434000	3369	1703	50	0	\N
238847	1678	2160042435000	3369	1703	51	0	\N
238848	1678	2160042436000	3369	1703	52	0	\N
238849	1678	2160042437000	3369	1703	53	0	\N
238850	1678	2160042438000	3369	1703	54	0	\N
238851	1678	2160042439000	3369	1703	55	0	\N
238852	1678	2160042440000	3369	1703	56	0	\N
238853	1678	2160042441000	3369	1703	57	0	\N
238854	1678	2160042442000	3369	1703	58	0	\N
238855	1678	2160042443000	3369	1703	60	0	\N
238858	1678	2880082478000	3371	1754	0	0	\N
238867	1678	2880082483000	3375	1756	0	0	\N
238868	1678	2880082484000	3375	1756	1	0	\N
238869	436	66001500000000	3376	1611	0	0	\N
238870	436	66003000000000	3376	1611	1	0	\N
238871	436	66719700000000	3376	1611	2	0	\N
238872	1737	1200001100	3376	1611	3	0	\N
238873	1773	8892278499961	3376	1611	4	0	\N
238874	1678	2160042255000	3376	1611	5	0	\N
238875	1771	69384136474	3376	1611	6	0	\N
238876	1771	69384137414	3376	1611	7	0	\N
238877	114	66005000000000	3376	1611	8	0	\N
238878	1771	69384138354	3376	1611	9	0	\N
238879	1771	69384139294	3376	1611	10	0	\N
238880	195	66069405749490	3376	1611	11	0	\N
238881	291	66069405749490	3376	1611	12	0	\N
238882	1023	503306233132568	3376	1611	13	0	\N
238883	1143	901920457445734	3376	1611	14	0	\N
238884	1263	608543704673294	3376	1611	15	0	\N
238885	1389	1695761141761468	3376	1611	16	0	\N
238886	1771	70253739593	3376	1611	17	0	\N
238887	1678	2160042256000	3376	1611	18	0	\N
238888	1678	2160042257000	3376	1611	19	0	\N
238889	1678	2160042258000	3376	1611	20	0	\N
238890	1678	2160042259000	3376	1611	21	0	\N
238891	1678	2160042260000	3376	1611	22	0	\N
238892	1678	2160042261000	3376	1611	23	0	\N
238893	1678	2160042262000	3376	1611	24	0	\N
238894	1678	2160042263000	3376	1611	25	0	\N
238895	1678	2160042264000	3376	1611	26	0	\N
238896	1678	2160042265000	3376	1611	27	0	\N
238897	1678	2160042266000	3376	1611	28	0	\N
238898	1678	2160042267000	3376	1611	29	0	\N
238899	1678	2160042268000	3376	1611	30	0	\N
238900	1678	2160042269000	3376	1611	31	0	\N
238901	1678	2160042270000	3376	1611	32	0	\N
238902	1678	2160042271000	3376	1611	33	0	\N
238903	1678	2160042272000	3376	1611	34	0	\N
238904	1678	2160042273000	3376	1611	35	0	\N
238905	1678	2160042274000	3376	1611	36	0	\N
238906	1678	2160042275000	3376	1611	37	0	\N
238907	1678	2160042276000	3376	1611	38	0	\N
238908	1678	2160042277000	3376	1611	39	0	\N
238909	1678	2160042278000	3376	1611	40	0	\N
238910	1678	2160042279000	3376	1611	41	0	\N
238911	1678	2160042280000	3376	1611	42	0	\N
238912	1678	2160042281000	3376	1611	43	0	\N
238913	1678	2160042282000	3376	1611	44	0	\N
238914	1678	2160042283000	3376	1611	45	0	\N
238915	1678	2160042284000	3376	1611	46	0	\N
238916	1678	2160042285000	3376	1611	47	0	\N
238917	1678	2160042286000	3376	1611	48	0	\N
238918	41	66087112047044	3376	1611	49	0	\N
238919	225	66087112047044	3376	1611	50	0	\N
238920	304	66087112047044	3376	1611	51	0	\N
238921	308	66087112047044	3376	1611	52	0	\N
238922	373	66087112047044	3376	1611	53	0	\N
238923	191	66087112047044	3376	1611	54	0	\N
238924	877	203321172331632	3376	1611	55	0	\N
238925	309	66087112047044	3376	1611	56	0	\N
238926	731	2002639758987	3376	1611	57	0	\N
238927	217	66087112047044	3376	1611	58	0	\N
238928	402	66087112047044	3376	1611	59	0	\N
238929	1030	902162602054525	3376	1611	60	0	\N
238930	205	66087112047044	3376	1611	61	0	\N
238931	138	66087112047044	3376	1611	62	0	\N
238932	275	66087112047044	3376	1611	63	0	\N
238933	397	66087112047044	3376	1611	64	0	\N
238934	690	66087112047044	3376	1611	65	0	\N
238935	106	66087112047044	3376	1611	66	0	\N
238936	894	307227885873282	3376	1611	67	0	\N
238937	5	6705839233000	3376	1611	68	0	\N
238938	122	66087112047044	3376	1611	69	0	\N
238939	91	66087112047044	3376	1611	71	0	\N
238940	99	66087112047044	3376	1611	72	0	\N
238941	339	66087112047044	3376	1611	73	0	\N
238942	420	66087112047044	3376	1611	74	0	\N
238943	206	66087112047044	3376	1611	75	0	\N
238944	408	66087112047044	3376	1611	76	0	\N
238945	438	66087112047044	3376	1611	77	0	\N
238946	534	66087112047044	3376	1611	78	0	\N
238947	399	66087112047044	3376	1611	79	0	\N
238948	570	66087112047044	3376	1611	80	0	\N
238949	910	503441359118351	3376	1611	81	0	\N
238950	322	66087112047044	3376	1611	82	0	\N
238951	500	66087112047044	3376	1611	83	0	\N
238952	105	66087112047044	3376	1611	84	0	\N
238859	1678	2880082478000	3372	1754	0	0	0
238860	1678	2880082479000	3373	1755	0	0	0
238861	1678	2880082480000	3373	1755	1	0	0
238862	1678	2880082481000	3373	1755	2	0	0
238863	1678	2880082482000	3373	1755	3	0	0
238865	1678	2880082483000	3374	1756	0	0	0
238866	1678	2880082484000	3374	1756	1	0	0
238953	89	66087112047044	3376	1611	85	0	\N
238954	146	66087112047044	3376	1611	86	0	\N
238955	92	66087112047044	3376	1611	87	0	\N
238956	29	7009239156499	3376	1611	88	0	\N
238957	251	66087112047044	3376	1611	89	0	\N
238958	84	66087112047044	3376	1611	90	0	\N
238959	395	66084082047044	3376	1611	91	0	\N
238960	587	66087112047044	3376	1611	92	0	\N
238961	611	66087112047044	3376	1611	93	0	\N
238962	678	66087112047044	3376	1611	94	0	\N
238963	320	66087112047044	3376	1611	95	0	\N
238964	710	5006599397497	3376	1611	96	0	\N
238965	721	2002639758987	3376	1611	97	0	\N
238966	295	66087112047044	3376	1611	98	0	\N
238967	560	66087112047044	3376	1611	99	0	\N
238968	392	66087112047044	3376	1611	100	0	\N
238969	194	66087112047044	3376	1611	101	0	\N
238970	252	66087112047044	3376	1611	102	0	\N
238971	150	66087112047044	3376	1611	103	0	\N
238972	450	66087112047044	3376	1611	104	0	\N
238973	620	66087112047044	3376	1611	105	0	\N
238974	421	66087112047044	3376	1611	106	0	\N
238975	245	66087112047044	3376	1611	107	0	\N
238976	54	66087112047044	3376	1611	108	0	\N
238977	78	66087112047044	3376	1611	109	0	\N
238978	37	65414225088019	3376	1611	110	0	\N
238979	520	66087112047044	3376	1611	111	0	\N
238980	163	66087112047044	3376	1611	112	0	\N
238981	1150	608707084465919	3376	1611	113	0	\N
238982	452	66087112047044	3376	1611	114	0	\N
238983	594	66087112047044	3376	1611	115	0	\N
238984	391	66087112047044	3376	1611	116	0	\N
238985	622	66090092047044	3376	1611	117	0	\N
238986	653	66087112047044	3376	1611	118	0	\N
238987	193	66087112047044	3376	1611	119	0	\N
238988	504	66087112047044	3376	1611	120	0	\N
238989	593	66087112047044	3376	1611	121	0	\N
238990	658	66087112047044	3376	1611	122	0	\N
238991	6	32600972636768	3376	1611	123	0	\N
238992	652	66087112047044	3376	1611	124	0	\N
238993	660	66087112047044	3376	1611	125	0	\N
238994	1678	2880082485000	3377	1757	0	0	\N
238998	1678	2880082487000	3381	1759	0	0	\N
238999	1678	2880082488000	3382	1760	0	0	\N
239000	1678	2880082488000	3383	1760	0	0	\N
239005	1678	2880082464000	3389	1744	0	0	\N
239006	1678	2880082465000	3389	1744	1	0	\N
239007	1678	2880082466000	3389	1744	2	0	\N
239008	1678	2880082467000	3389	1744	3	0	\N
239009	1678	2880082468000	3389	1744	4	0	\N
239010	1678	2880082469000	3389	1744	5	0	\N
239011	1678	2880082470000	3389	1744	6	0	\N
239012	1678	2880082471000	3389	1744	7	0	\N
239013	1678	2880082472000	3389	1744	8	0	\N
239014	1678	2880082473000	3389	1744	9	0	\N
239015	1678	2880082474000	3389	1744	10	0	\N
239016	1678	2880082475000	3389	1744	11	0	\N
239017	1678	2880082476000	3389	1744	12	0	\N
239018	1678	2880082477000	3389	1744	13	0	\N
239019	1678	2880082478000	3389	1744	14	0	\N
239020	1678	2880082479000	3389	1744	15	0	\N
239021	1678	2880082480000	3389	1744	16	0	\N
239022	1678	2880082481000	3389	1744	17	0	\N
239023	1678	2880082482000	3389	1744	18	0	\N
239024	1678	2880082483000	3389	1744	19	0	\N
239025	1678	2880082484000	3389	1744	20	0	\N
239026	1678	2880082485000	3389	1744	21	0	\N
239027	1678	2880082486000	3389	1744	22	0	\N
239028	1678	2880082487000	3389	1744	23	0	\N
239029	1678	2880082488000	3389	1744	24	0	\N
239030	1678	2880082489000	3389	1744	25	0	\N
239031	1678	2880082490000	3389	1744	26	0	\N
239032	1678	2880082491000	3389	1744	27	0	\N
239033	1678	2880082492000	3389	1744	28	0	\N
239034	1396	20000000	3389	1744	29	0	\N
239036	1678	2880082492000	3391	1764	0	0	\N
239038	1678	2880082494000	3393	1766	0	0	\N
239040	1678	2160042287000	3395	1612	0	0	\N
239041	1678	2160042288000	3395	1612	1	0	\N
239042	1678	2160042289000	3395	1612	2	0	\N
239043	1678	2160042290000	3395	1612	3	0	\N
239044	1678	2160042291000	3395	1612	4	0	\N
239045	1678	2160042292000	3395	1612	5	0	\N
239046	1678	2160042293000	3395	1612	6	0	\N
239047	1678	2160042294000	3395	1612	7	0	\N
239048	1678	2160042295000	3395	1612	8	0	\N
239049	1678	2160042296000	3395	1612	9	0	\N
239050	1678	2160042297000	3395	1612	10	0	\N
239051	1678	2160042298000	3395	1612	11	0	\N
239052	1678	2160042299000	3395	1612	12	0	\N
239053	1678	2160042300000	3395	1612	13	0	\N
239054	1678	2160042301000	3395	1612	14	0	\N
239055	1678	2160042302000	3395	1612	15	0	\N
239056	1678	2160042303000	3395	1612	16	0	\N
239057	1678	2160042304000	3395	1612	17	0	\N
239058	1678	2160042305000	3395	1612	18	0	\N
239059	1678	2160042306000	3395	1612	19	0	\N
239060	1678	2160042307000	3395	1612	20	0	\N
239061	1678	2160042308000	3395	1612	21	0	\N
239062	1678	2160042309000	3395	1612	22	0	\N
239063	1678	2160042310000	3395	1612	23	0	\N
239064	1678	2160042311000	3395	1612	24	0	\N
239065	1678	2160042312000	3395	1612	25	0	\N
239066	1678	2160042313000	3395	1612	26	0	\N
239067	1678	2160042314000	3395	1612	27	0	\N
239068	1678	2160042315000	3395	1612	28	0	\N
239069	1678	2160042316000	3395	1612	29	0	\N
239070	1678	2160042317000	3395	1612	30	0	\N
239071	1678	2160042318000	3395	1612	31	0	\N
239072	1678	2160042319000	3395	1612	32	0	\N
239073	1678	2160042320000	3395	1612	33	0	\N
239074	1678	2160042321000	3395	1612	34	0	\N
239075	1678	2160042322000	3395	1612	35	0	\N
239076	1678	2160042323000	3395	1612	36	0	\N
239077	1678	2160042324000	3395	1612	37	0	\N
239078	1678	2160042325000	3395	1612	38	0	\N
239079	1678	2160042326000	3395	1612	39	0	\N
239080	1678	2160042327000	3395	1612	40	0	\N
239081	1678	2160042328000	3395	1612	41	0	\N
239082	1678	2160042329000	3395	1612	42	0	\N
239083	1678	2160042330000	3395	1612	43	0	\N
239084	1678	2160042331000	3395	1612	44	0	\N
239085	1678	2160042332000	3395	1612	45	0	\N
239086	1678	2160042333000	3395	1612	46	0	\N
239087	1678	2160042334000	3395	1612	47	0	\N
239088	1678	2160042335000	3395	1612	48	0	\N
238997	1678	2880082487000	3380	1759	0	0	0
239001	1678	2880082488000	3384	1760	0	0	0
239002	1678	2880082489000	3386	1761	0	0	0
239003	1678	2880082490000	3387	1762	0	0	0
239004	1678	2880082491000	3388	1763	0	0	0
239037	1678	2880082493000	3392	1765	0	0	0
239039	1678	2880082494000	3394	1766	0	0	0
239089	1678	2160042336000	3395	1612	49	0	\N
239090	1678	2160042337000	3395	1612	50	0	\N
239091	1678	2160042338000	3395	1612	51	0	\N
239092	1678	2160042339000	3395	1612	52	0	\N
239093	1678	2160042340000	3395	1612	53	0	\N
239094	1678	2160042341000	3395	1612	54	0	\N
239095	1678	2160042342000	3395	1612	55	0	\N
239096	1678	2160042343000	3395	1612	56	0	\N
239097	1678	2160042344000	3395	1612	57	0	\N
239098	1678	2160042345000	3395	1612	58	0	\N
239099	1678	2160042346000	3395	1612	59	0	\N
239100	1678	2160042347000	3395	1612	60	0	\N
239101	1678	2160042348000	3395	1612	61	0	\N
239102	1678	2160042349000	3395	1612	62	0	\N
239103	1678	2160042350000	3395	1612	63	0	\N
239104	1678	2160042351000	3395	1612	64	0	\N
239105	1678	2160042352000	3395	1612	65	0	\N
239106	1678	2160042353000	3395	1612	66	0	\N
239107	1678	2160042354000	3395	1612	67	0	\N
239108	1678	2160042355000	3395	1612	68	0	\N
239109	1678	2160042356000	3395	1612	69	0	\N
239110	1678	2160042357000	3395	1612	71	0	\N
239111	1678	2160042358000	3395	1612	72	0	\N
239112	1678	2160042359000	3395	1612	73	0	\N
239113	1678	2160042360000	3395	1612	74	0	\N
239114	1678	2160042361000	3395	1612	75	0	\N
239115	1678	2160042362000	3395	1612	76	0	\N
239116	1678	2160042363000	3395	1612	77	0	\N
239117	1678	2160042364000	3395	1612	78	0	\N
239118	1678	2160042365000	3395	1612	79	0	\N
239119	1678	2160042366000	3395	1612	80	0	\N
239120	1678	2160042367000	3395	1612	81	0	\N
239121	1678	2160042368000	3395	1612	82	0	\N
239122	1678	2160042369000	3395	1612	83	0	\N
239123	1678	2160042370000	3395	1612	84	0	\N
239124	1678	2160042371000	3395	1612	85	0	\N
239125	1678	2160042372000	3395	1612	86	0	\N
239126	1678	2160042373000	3395	1612	87	0	\N
239127	1678	2160042374000	3395	1612	88	0	\N
239128	1678	2160042375000	3395	1612	89	0	\N
239129	1678	2160042376000	3395	1612	90	0	\N
239130	1678	2160042377000	3395	1612	91	0	\N
239131	1678	2160042378000	3395	1612	92	0	\N
239132	1678	2160042379000	3395	1612	93	0	\N
239133	1678	2160042380000	3395	1612	94	0	\N
239134	1678	2160042381000	3395	1612	95	0	\N
239135	1678	2160042382000	3395	1612	96	0	\N
239136	1678	2160042383000	3395	1612	97	0	\N
239137	1678	2160042384000	3395	1612	98	0	\N
239138	1678	2160042385000	3395	1612	99	0	\N
239139	1678	2160042386000	3395	1612	100	0	\N
239140	1678	2160042387000	3395	1612	101	0	\N
239141	1678	2160042388000	3395	1612	102	0	\N
239142	1678	2160042389000	3395	1612	103	0	\N
239143	1678	2160042390000	3395	1612	104	0	\N
239144	1678	2160042391000	3395	1612	105	0	\N
239145	1678	2160042392000	3395	1612	106	0	\N
239146	1678	2160042393000	3395	1612	107	0	\N
239147	1678	2160042394000	3395	1612	108	0	\N
239148	1678	2160042395000	3395	1612	109	0	\N
239149	1678	2160042396000	3395	1612	110	0	\N
239150	1678	2160042397000	3395	1612	111	0	\N
239151	1678	2160042398000	3395	1612	112	0	\N
239152	1678	2160042399000	3395	1612	113	0	\N
239153	1678	2160042400000	3395	1612	114	0	\N
239154	1678	2160042401000	3395	1612	115	0	\N
239155	1678	2160042402000	3395	1612	116	0	\N
239156	1678	2160042403000	3395	1612	117	0	\N
239157	1678	2160042404000	3395	1612	118	0	\N
239158	1678	2160042405000	3395	1612	119	0	\N
239159	1678	2160042406000	3395	1612	120	0	\N
239160	1678	2160042407000	3395	1612	121	0	\N
239161	1678	2160042408000	3395	1612	122	0	\N
239162	1678	2160042409000	3395	1612	123	0	\N
239163	1678	2160042410000	3395	1612	124	0	\N
239164	1678	2160042411000	3395	1612	125	0	\N
239166	1678	2880082495000	3397	1767	0	0	\N
239167	1678	2880082492000	3398	1764	0	0	\N
239168	1678	2880082493000	3398	1764	1	0	\N
239169	1678	2880082494000	3398	1764	2	0	\N
239170	1678	2880082495000	3398	1764	3	0	\N
239172	1678	2880082496000	3400	1768	0	0	\N
239173	1678	2880082496000	3401	1768	0	0	\N
239174	1483	0	3402	1741	0	0	\N
239175	1772	517750000000	3402	1741	1	0	\N
239176	1678	2880082458000	3402	1741	2	0	\N
239177	1678	2880082459000	3402	1741	3	0	\N
239178	1678	2880082460000	3402	1741	4	0	\N
239179	1678	2880082461000	3402	1741	5	0	\N
239180	1678	2880082462000	3402	1741	6	0	\N
239181	1678	2880082463000	3402	1741	7	0	\N
239182	1678	2880082464000	3402	1741	8	0	\N
239183	1678	2880082465000	3402	1741	9	0	\N
239184	1678	2880082466000	3402	1741	10	0	\N
239185	1678	2880082467000	3402	1741	11	0	\N
239186	1678	2880082468000	3402	1741	12	0	\N
239187	1678	2880082469000	3402	1741	13	0	\N
239188	1678	2880082470000	3402	1741	14	0	\N
239189	1678	2880082471000	3402	1741	15	0	\N
239190	1678	2880082472000	3402	1741	16	0	\N
239191	1678	2880082473000	3402	1741	17	0	\N
239192	1678	2880082474000	3402	1741	18	0	\N
239193	1678	2880082475000	3402	1741	19	0	\N
239194	1678	2880082476000	3402	1741	20	0	\N
239195	1678	2880082477000	3402	1741	21	0	\N
239196	1678	2880082478000	3402	1741	22	0	\N
239197	1678	2880082479000	3402	1741	23	0	\N
239198	1678	2880082480000	3402	1741	24	0	\N
239199	1678	2880082481000	3402	1741	25	0	\N
239200	1678	2880082482000	3402	1741	26	0	\N
239201	1678	2880082483000	3402	1741	27	0	\N
239202	1678	2880082484000	3402	1741	28	0	\N
239203	1678	2880082485000	3402	1741	29	0	\N
239204	1678	2880082486000	3402	1741	30	0	\N
239205	1678	2880082487000	3402	1741	31	0	\N
239206	1678	2880082488000	3402	1741	32	0	\N
239207	1678	2880082489000	3402	1741	33	0	\N
239208	1678	2880082490000	3402	1741	34	0	\N
239209	1678	2880082491000	3402	1741	35	0	\N
239210	1678	2880082492000	3402	1741	36	0	\N
239211	1678	2880082493000	3402	1741	37	0	\N
239212	1678	2880082494000	3402	1741	38	0	\N
239213	1678	2880082495000	3402	1741	39	0	\N
239214	1396	20000000	3402	1741	40	0	\N
239217	1678	2880082493000	3408	1745	0	0	\N
239218	1678	2880082494000	3408	1745	1	0	\N
239219	1678	2880082495000	3408	1745	2	0	\N
239220	1678	2880082496000	3408	1745	3	0	\N
239221	1678	2880082497000	3408	1745	4	0	\N
239222	1678	2880082498000	3408	1745	5	0	\N
239223	1678	2880082499000	3408	1745	6	0	\N
239224	1678	2880082500000	3408	1745	7	0	\N
239215	1678	2880082497000	3403	1769	0	0	0
239216	1678	2880082498000	3404	1770	0	0	0
239225	1678	2880082499000	3409	1773	0	0	\N
239226	1678	2880082500000	3409	1773	1	0	\N
239227	1678	2880082499000	3410	1773	0	0	\N
239228	1678	2880082500000	3410	1773	1	0	\N
239229	1678	2880082499000	3411	1773	0	0	\N
239230	1678	2880082500000	3411	1773	1	0	\N
239236	1678	2880082503000	3416	1776	0	0	\N
239237	1678	2880082504000	3417	1777	0	0	\N
239238	1678	2880082504000	3418	1777	0	0	\N
239240	1678	2880082505000	3420	1778	0	0	\N
239241	1678	2880082506000	3420	1778	1	0	\N
239244	1678	2880082507000	3422	1779	0	0	\N
239245	1678	2880082507000	3424	1779	0	0	\N
239246	1678	2880082507000	3425	1780	0	0	\N
239247	1678	2880082508000	3425	1780	1	0	\N
239248	1678	2880082509000	3425	1780	2	0	\N
239249	1678	2880082507000	3426	1780	0	0	\N
239250	1678	2880082508000	3426	1780	1	0	\N
239251	1678	2880082509000	3426	1780	2	0	\N
239255	1678	2880082507000	3428	1780	0	0	\N
239256	1678	2880082508000	3428	1780	1	0	\N
239257	1678	2880082509000	3428	1780	2	0	\N
239258	1678	2880082510000	3429	1781	0	0	\N
239263	1749	4315990000000	3445	1789	0	0	\N
239265	1749	4315990000000	3447	1789	0	0	\N
239266	1749	4315990000000	3448	1789	0	0	\N
239267	436	66001500000000	3456	1676	0	0	\N
239268	436	66003000000000	3456	1676	1	0	\N
239269	436	66719700000000	3456	1676	2	0	\N
239270	1773	8892278499961	3456	1676	3	0	\N
239271	1772	259000000000	3456	1676	4	0	\N
239272	114	66005000000000	3456	1676	5	0	\N
239273	721	2002639758987	3456	1676	6	0	\N
239274	1759	6480000000000	3456	1676	7	0	\N
239275	1678	2160042380000	3456	1676	8	0	\N
239276	1678	2160042381000	3456	1676	9	0	\N
239277	1678	2160042382000	3456	1676	10	0	\N
239278	1764	5039010000000	3456	1676	11	0	\N
239279	1749	4315990000000	3456	1676	12	0	\N
239280	1678	2160042383000	3456	1676	13	0	\N
239281	1678	2160042384000	3456	1676	15	0	\N
239282	1678	2160042385000	3456	1676	16	0	\N
239283	1678	2160042386000	3456	1676	17	0	\N
239284	1678	2160042387000	3456	1676	18	0	\N
239285	1678	2160042388000	3456	1676	19	0	\N
239286	1678	2160042389000	3456	1676	20	0	\N
239287	1678	2160042390000	3456	1676	21	0	\N
239288	1678	2160042391000	3456	1676	22	0	\N
239289	295	66087112047044	3456	1676	23	0	\N
239290	560	66087112047044	3456	1676	24	0	\N
239291	392	66087112047044	3456	1676	25	0	\N
239292	194	66087112047044	3456	1676	26	0	\N
239293	252	66087112047044	3456	1676	27	0	\N
239294	150	66087112047044	3456	1676	28	0	\N
239295	450	66087112047044	3456	1676	29	0	\N
239296	620	66087112047044	3456	1676	30	0	\N
239297	421	66087112047044	3456	1676	31	0	\N
239298	245	66087112047044	3456	1676	32	0	\N
239299	54	66087112047044	3456	1676	33	0	\N
239300	78	66087112047044	3456	1676	34	0	\N
239301	37	65414225088019	3456	1676	35	0	\N
239302	520	66087112047044	3456	1676	36	0	\N
239303	163	66087112047044	3456	1676	37	0	\N
239304	1150	608707084465919	3456	1676	38	0	\N
239305	452	66087112047044	3456	1676	39	0	\N
239306	594	66087112047044	3456	1676	40	0	\N
239307	1678	2160042392000	3456	1676	41	0	\N
239308	1678	2160042393000	3456	1676	42	0	\N
239309	1678	2160042394000	3456	1676	43	0	\N
239310	1678	2160042395000	3456	1676	44	0	\N
239311	1678	2160042396000	3456	1676	45	0	\N
239312	1678	2160042397000	3456	1676	46	0	\N
239313	1678	2160042398000	3456	1676	47	0	\N
239314	1678	2160042399000	3456	1676	48	0	\N
239315	1678	2160042400000	3456	1676	49	0	\N
239316	1678	2160042401000	3456	1676	50	0	\N
239317	1678	2160042402000	3456	1676	51	0	\N
239318	1678	2160042403000	3456	1676	52	0	\N
239319	1678	2160042404000	3456	1676	53	0	\N
239320	1678	2160042405000	3456	1676	54	0	\N
239321	1678	2160042406000	3456	1676	55	0	\N
239322	1678	2160042407000	3456	1676	56	0	\N
239323	1678	2160042408000	3456	1676	57	0	\N
239324	1678	2160042409000	3456	1676	58	0	\N
239325	1678	2160042410000	3456	1676	59	0	\N
239326	1678	2160042411000	3456	1676	60	0	\N
239327	1678	2160042412000	3456	1676	61	0	\N
239328	1678	2160042413000	3456	1676	62	0	\N
239329	1678	2160042414000	3456	1676	63	0	\N
239330	1678	2160042415000	3456	1676	64	0	\N
239331	1678	2160042416000	3456	1676	65	0	\N
239332	1678	2160042417000	3456	1676	66	0	\N
239333	1678	2160042418000	3456	1676	67	0	\N
239334	1678	2160042419000	3456	1676	68	0	\N
239335	1678	2160042420000	3456	1676	69	0	\N
239336	1678	2160042421000	3456	1676	70	0	\N
239337	1678	2160042422000	3456	1676	71	0	\N
239338	1678	2160042423000	3456	1676	72	0	\N
239339	1678	2160042424000	3456	1676	73	0	\N
239340	1678	2160042425000	3456	1676	74	0	\N
239341	1678	2160042426000	3456	1676	75	0	\N
239342	1678	2160042427000	3456	1676	76	0	\N
239343	1678	2160042428000	3456	1676	77	0	\N
239344	1678	2160042429000	3456	1676	78	0	\N
239345	1678	2160042430000	3456	1676	79	0	\N
239346	1678	2160042431000	3456	1676	80	0	\N
239347	1678	2160042432000	3456	1676	81	0	\N
239348	1678	2160042433000	3456	1676	82	0	\N
239349	1678	2160042434000	3456	1676	83	0	\N
239350	1678	2160042435000	3456	1676	84	0	\N
239351	1678	2160042436000	3456	1676	85	0	\N
239352	1678	2160042437000	3456	1676	86	0	\N
239353	1678	2160042438000	3456	1676	87	0	\N
239354	1678	2160042439000	3456	1676	88	0	\N
239355	1678	2160042440000	3456	1676	89	0	\N
239356	1678	2160042441000	3456	1676	90	0	\N
239357	1678	2160042442000	3456	1676	91	0	\N
239358	1678	2160042443000	3456	1676	92	0	\N
239359	1678	2160042444000	3456	1676	93	0	\N
239360	1678	2160042445000	3456	1676	94	0	\N
239233	1678	2880082501000	3413	1774	2	0	0
239234	1678	2880082502000	3414	1775	0	0	0
239235	1678	2880082503000	3415	1776	0	0	0
239239	1678	2880082504000	3419	1777	0	0	0
239242	1678	2880082505000	3421	1778	0	0	0
239252	1678	2880082507000	3427	1780	0	0	0
239253	1678	2880082508000	3427	1780	1	0	0
239254	1678	2880082509000	3427	1780	2	0	0
239259	1678	2880082510000	3430	1781	0	0	0
239260	1678	2880082511000	3431	1782	0	0	0
239262	1764	5039010000000	3444	1788	1	0	0
239264	1749	4315990000000	3446	1789	0	0	1
239361	1678	2160042446000	3456	1676	95	0	\N
239362	1678	2160042447000	3456	1676	96	0	\N
239363	1678	2160042448000	3456	1676	97	0	\N
239364	1678	2160042449000	3456	1676	98	0	\N
239365	1678	2160042450000	3456	1676	99	0	\N
239366	1678	2160042451000	3456	1676	100	0	\N
239367	1678	2160042452000	3456	1676	101	0	\N
239368	1678	2160042453000	3456	1676	102	0	\N
239369	1678	2160042454000	3456	1676	103	0	\N
239370	1678	2160042455000	3456	1676	104	0	\N
239371	1678	2160042456000	3456	1676	105	0	\N
239372	391	66087112047044	3456	1676	106	0	\N
239373	622	66090092047044	3456	1676	107	0	\N
239374	653	66087112047044	3456	1676	108	0	\N
239375	193	66087112047044	3456	1676	109	0	\N
239376	504	66087112047044	3456	1676	110	0	\N
239377	593	66087112047044	3456	1676	111	0	\N
239378	658	66087112047044	3456	1676	112	0	\N
239379	6	32600972636768	3456	1676	113	0	\N
239380	652	66087112047044	3456	1676	114	0	\N
239381	660	66087112047044	3456	1676	115	0	\N
239382	1276	1696216414080520	3456	1676	116	0	\N
239383	180	66087112047044	3456	1676	117	0	\N
239384	353	66087112047044	3456	1676	118	0	\N
239385	108	66087112047044	3456	1676	119	0	\N
239386	390	66087112047044	3456	1676	120	0	\N
239387	601	66087112047044	3456	1676	121	0	\N
239388	266	66087112047044	3456	1676	122	0	\N
239389	600	66087112047044	3456	1676	123	0	\N
239390	691	66087112047044	3456	1676	124	0	\N
239391	352	66087112047044	3456	1676	125	0	\N
239393	436	66001500000000	3489	1701	0	0	\N
239394	436	66003000000000	3489	1701	1	0	\N
239395	436	66719700000000	3489	1701	2	0	\N
239396	1773	8892278499961	3489	1701	3	0	\N
239397	1772	259000000000	3489	1701	4	0	\N
239398	560	66087112047044	3489	1701	5	0	\N
239399	1678	2160042402000	3489	1701	6	0	\N
239400	114	66005000000000	3489	1701	7	0	\N
239401	1759	6480000000000	3489	1701	8	0	\N
239402	1678	2160042403000	3489	1701	9	0	\N
239403	1764	5039010000000	3489	1701	10	0	\N
239404	1749	4315990000000	3489	1701	11	0	\N
239405	1678	2160042404000	3489	1701	12	0	\N
239406	1678	2160042405000	3489	1701	13	0	\N
239407	1678	2160042406000	3489	1701	14	0	\N
239408	1678	2160042407000	3489	1701	15	0	\N
239409	392	66087112047044	3489	1701	16	0	\N
239410	194	66087112047044	3489	1701	17	0	\N
239411	252	66087112047044	3489	1701	18	0	\N
239412	150	66087112047044	3489	1701	19	0	\N
239413	450	66087112047044	3489	1701	20	0	\N
239414	620	66087112047044	3489	1701	21	0	\N
239415	421	66087112047044	3489	1701	22	0	\N
239416	245	66087112047044	3489	1701	23	0	\N
239417	54	66087112047044	3489	1701	24	0	\N
239418	78	66087112047044	3489	1701	25	0	\N
239419	37	65414225088019	3489	1701	26	0	\N
239420	520	66087112047044	3489	1701	27	0	\N
239421	163	66087112047044	3489	1701	28	0	\N
239422	1150	608707084465919	3489	1701	29	0	\N
239423	452	66087112047044	3489	1701	30	0	\N
239424	594	66087112047044	3489	1701	31	0	\N
239425	1678	2160042408000	3489	1701	32	0	\N
239426	1678	2160042409000	3489	1701	33	0	\N
239427	1678	2160042410000	3489	1701	34	0	\N
239428	1678	2160042411000	3489	1701	35	0	\N
239429	1678	2160042412000	3489	1701	36	0	\N
239430	1678	2160042413000	3489	1701	37	0	\N
239431	1678	2160042414000	3489	1701	38	0	\N
239432	1678	2160042415000	3489	1701	39	0	\N
239433	1678	2160042416000	3489	1701	40	0	\N
239434	1678	2160042417000	3489	1701	41	0	\N
239435	1678	2160042418000	3489	1701	42	0	\N
239436	1678	2160042419000	3489	1701	43	0	\N
239437	1678	2160042420000	3489	1701	44	0	\N
239438	1678	2160042421000	3489	1701	45	0	\N
239439	1678	2160042422000	3489	1701	46	0	\N
239440	1678	2160042423000	3489	1701	47	0	\N
239441	1678	2160042424000	3489	1701	48	0	\N
239442	1678	2160042425000	3489	1701	49	0	\N
239443	1678	2160042426000	3489	1701	50	0	\N
239444	1678	2160042427000	3489	1701	51	0	\N
239445	1678	2160042428000	3489	1701	52	0	\N
239446	1678	2160042429000	3489	1701	53	0	\N
239447	1678	2160042430000	3489	1701	54	0	\N
239448	1678	2160042431000	3489	1701	55	0	\N
239449	1678	2160042432000	3489	1701	56	0	\N
239450	1678	2160042433000	3489	1701	57	0	\N
239451	1678	2160042434000	3489	1701	58	0	\N
239452	1678	2160042435000	3489	1701	59	0	\N
239453	1678	2160042436000	3489	1701	60	0	\N
239454	1678	2160042437000	3489	1701	61	0	\N
239455	1678	2160042438000	3489	1701	62	0	\N
239456	1678	2160042439000	3489	1701	63	0	\N
239457	1678	2160042440000	3489	1701	64	0	\N
239458	1678	2160042441000	3489	1701	65	0	\N
239459	1678	2160042442000	3489	1701	66	0	\N
239460	1678	2160042443000	3489	1701	67	0	\N
239461	1678	2160042444000	3489	1701	69	0	\N
239462	1678	2160042445000	3489	1701	70	0	\N
239463	1678	2160042446000	3489	1701	71	0	\N
239464	1678	2160042447000	3489	1701	72	0	\N
239465	1678	2160042448000	3489	1701	73	0	\N
239466	1678	2160042449000	3489	1701	74	0	\N
239467	1678	2160042450000	3489	1701	75	0	\N
239468	1678	2160042451000	3489	1701	76	0	\N
239469	1678	2160042452000	3489	1701	77	0	\N
239470	1678	2160042453000	3489	1701	78	0	\N
239471	1678	2160042454000	3489	1701	79	0	\N
239472	1678	2160042455000	3489	1701	80	0	\N
239473	1678	2160042456000	3489	1701	81	0	\N
239474	391	66087112047044	3489	1701	82	0	\N
239475	622	66090092047044	3489	1701	83	0	\N
239476	653	66087112047044	3489	1701	84	0	\N
239477	1759	6480000000000	3493	1613	0	0	\N
239478	1764	5039010000000	3493	1613	1	0	\N
239479	1678	2160042412000	3493	1613	2	0	\N
239480	1678	2160042413000	3493	1613	3	0	\N
239481	1678	2160042414000	3493	1613	4	0	\N
239482	1678	2160042415000	3493	1613	5	0	\N
239483	1678	2160042416000	3493	1613	6	0	\N
239484	1678	2160042417000	3493	1613	7	0	\N
239485	1678	2160042418000	3493	1613	8	0	\N
239486	1678	2160042419000	3493	1613	9	0	\N
239487	1678	2160042420000	3493	1613	10	0	\N
239488	1678	2160042421000	3493	1613	11	0	\N
239489	1678	2160042422000	3493	1613	12	0	\N
239490	1678	2160042423000	3493	1613	13	0	\N
239491	1678	2160042424000	3493	1613	14	0	\N
239492	1678	2160042425000	3493	1613	15	0	\N
239493	1678	2160042426000	3493	1613	16	0	\N
239494	1678	2160042427000	3493	1613	17	0	\N
239495	1678	2160042428000	3493	1613	18	0	\N
239496	1678	2160042429000	3493	1613	19	0	\N
239497	1678	2160042430000	3493	1613	20	0	\N
239498	1678	2160042431000	3493	1613	21	0	\N
239499	1678	2160042432000	3493	1613	22	0	\N
239500	1678	2160042433000	3493	1613	23	0	\N
239501	1678	2160042434000	3493	1613	24	0	\N
239502	1678	2160042435000	3493	1613	25	0	\N
239503	1678	2160042436000	3493	1613	26	0	\N
239504	1678	2160042437000	3493	1613	27	0	\N
239505	1678	2160042438000	3493	1613	28	0	\N
239506	1678	2160042439000	3493	1613	29	0	\N
239507	1678	2160042440000	3493	1613	30	0	\N
239508	1678	2160042441000	3493	1613	31	0	\N
239509	1678	2160042442000	3493	1613	32	0	\N
239510	1678	2160042443000	3493	1613	33	0	\N
239511	1678	2160042444000	3493	1613	34	0	\N
239512	1678	2160042445000	3493	1613	35	0	\N
239513	1678	2160042446000	3493	1613	36	0	\N
239514	1678	2160042447000	3493	1613	37	0	\N
239515	1678	2160042448000	3493	1613	38	0	\N
239516	1678	2160042449000	3493	1613	39	0	\N
239517	1678	2160042450000	3493	1613	40	0	\N
239518	1678	2160042451000	3493	1613	41	0	\N
239519	1678	2160042452000	3493	1613	42	0	\N
239520	1678	2160042453000	3493	1613	43	0	\N
239521	1678	2160042454000	3493	1613	44	0	\N
239522	1678	2160042455000	3493	1613	45	0	\N
239523	1678	2160042456000	3493	1613	46	0	\N
239524	1678	2160042457000	3493	1613	47	0	\N
239525	1678	2160042458000	3493	1613	48	0	\N
239526	1678	2160042459000	3493	1613	49	0	\N
239527	1678	2160042460000	3493	1613	50	0	\N
239528	1678	2160042461000	3493	1613	51	0	\N
239529	1678	2160042462000	3493	1613	52	0	\N
239530	1678	2160042463000	3493	1613	53	0	\N
239531	1678	2160042464000	3493	1613	54	0	\N
239532	1678	2160042465000	3493	1613	55	0	\N
239533	1678	2160042466000	3493	1613	56	0	\N
239534	1678	2160042467000	3493	1613	57	0	\N
239535	1678	2160042468000	3493	1613	58	0	\N
239536	1678	2160042469000	3493	1613	59	0	\N
239537	1678	2160042470000	3493	1613	60	0	\N
239538	1678	2160042471000	3493	1613	61	0	\N
239539	1678	2160042472000	3493	1613	62	0	\N
239540	1678	2160042473000	3493	1613	63	0	\N
239541	1678	2160042474000	3493	1613	64	0	\N
239542	1678	2160042475000	3493	1613	65	0	\N
239543	1678	2160042476000	3493	1613	66	0	\N
239544	1678	2160042477000	3493	1613	67	0	\N
239545	1678	2160042478000	3493	1613	68	0	\N
239546	1678	2160042479000	3493	1613	69	0	\N
239547	1678	2160042480000	3493	1613	71	0	\N
239548	1678	2160042481000	3493	1613	72	0	\N
239549	1678	2160042482000	3493	1613	73	0	\N
239550	1678	2160042483000	3493	1613	74	0	\N
239551	1678	2160042484000	3493	1613	75	0	\N
239552	1678	2160042485000	3493	1613	76	0	\N
239553	1678	2160042486000	3493	1613	77	0	\N
239554	1678	2160042487000	3493	1613	78	0	\N
239555	1678	2160042488000	3493	1613	79	0	\N
239556	1678	2160042489000	3493	1613	80	0	\N
239557	1678	2160042490000	3493	1613	81	0	\N
239558	1678	2160042491000	3493	1613	82	0	\N
239559	1678	2160042492000	3493	1613	83	0	\N
239560	1678	2160042493000	3493	1613	84	0	\N
239561	1678	2160042494000	3493	1613	85	0	\N
239562	1678	2160042495000	3493	1613	86	0	\N
239563	1678	2160042496000	3493	1613	87	0	\N
239564	1678	2160042497000	3493	1613	88	0	\N
239565	1678	2160042498000	3493	1613	89	0	\N
239566	1678	2160042499000	3493	1613	90	0	\N
239567	1678	2160042500000	3493	1613	91	0	\N
239568	1678	2160042501000	3493	1613	92	0	\N
239569	1678	2160042502000	3493	1613	93	0	\N
239570	1678	2160042503000	3493	1613	94	0	\N
239571	1678	2160042504000	3493	1613	95	0	\N
239573	1764	8651010000000	3496	1814	0	0	\N
239575	1678	2160042457000	3499	1677	0	0	\N
239576	1678	2160042458000	3499	1677	1	0	\N
239577	1678	2160042459000	3499	1677	2	0	\N
239578	1678	2160042460000	3499	1677	3	0	\N
239579	1678	2160042461000	3499	1677	4	0	\N
239580	1678	2160042462000	3499	1677	5	0	\N
239581	1678	2160042463000	3499	1677	6	0	\N
239582	1678	2160042464000	3499	1677	7	0	\N
239583	1678	2160042465000	3499	1677	8	0	\N
239584	1678	2160042466000	3499	1677	9	0	\N
239585	1678	2160042467000	3499	1677	10	0	\N
239586	1678	2160042468000	3499	1677	11	0	\N
239587	1678	2160042469000	3499	1677	12	0	\N
239588	1678	2160042470000	3499	1677	13	0	\N
239589	1678	2160042471000	3499	1677	15	0	\N
239590	1678	2160042472000	3499	1677	16	0	\N
239591	1678	2160042473000	3499	1677	17	0	\N
239592	1678	2160042474000	3499	1677	18	0	\N
239593	1678	2160042475000	3499	1677	19	0	\N
239594	1678	2160042476000	3499	1677	20	0	\N
239595	1678	2160042477000	3499	1677	21	0	\N
239596	1678	2160042478000	3499	1677	22	0	\N
239597	1678	2160042479000	3499	1677	23	0	\N
239598	1678	2160042480000	3499	1677	24	0	\N
239599	1678	2160042481000	3499	1677	25	0	\N
239600	1678	2160042482000	3499	1677	26	0	\N
239601	1678	2160042483000	3499	1677	27	0	\N
239602	1678	2160042484000	3499	1677	28	0	\N
239603	1678	2160042485000	3499	1677	29	0	\N
239604	1678	2160042486000	3499	1677	30	0	\N
239605	1678	2160042487000	3499	1677	31	0	\N
239606	1678	2160042488000	3499	1677	32	0	\N
239607	1678	2160042489000	3499	1677	33	0	\N
239608	1678	2160042490000	3499	1677	34	0	\N
239609	1678	2160042491000	3499	1677	35	0	\N
239610	1678	2160042492000	3499	1677	36	0	\N
239611	1678	2160042493000	3499	1677	37	0	\N
239612	1678	2160042494000	3499	1677	38	0	\N
239613	1678	2160042495000	3499	1677	39	0	\N
239614	1678	2160042496000	3499	1677	40	0	\N
239615	1678	2160042497000	3499	1677	41	0	\N
239616	1678	2160042498000	3499	1677	42	0	\N
239617	1678	2160042499000	3499	1677	43	0	\N
239618	1678	2160042500000	3499	1677	44	0	\N
239619	1678	2160042501000	3499	1677	45	0	\N
239620	1678	2160042502000	3499	1677	46	0	\N
239621	1678	2160042503000	3499	1677	47	0	\N
239622	1678	2160042504000	3499	1677	48	0	\N
239623	1678	2160042505000	3499	1677	49	0	\N
239624	1678	2160042506000	3499	1677	50	0	\N
239625	1678	2160042507000	3499	1677	51	0	\N
239626	1678	2160042508000	3499	1677	52	0	\N
239627	1678	2160042509000	3499	1677	53	0	\N
239628	1678	2160042510000	3499	1677	54	0	\N
239629	1678	2160042511000	3499	1677	55	0	\N
239630	1764	8651010000000	3499	1677	56	0	\N
239631	1745	8406000000	3499	1677	57	0	\N
239632	1745	8406000000	3499	1677	58	0	\N
239633	1774	100000000	3499	1677	59	0	\N
239634	1749	4314989000000	3499	1677	60	0	\N
239635	1775	2000000000	3499	1677	61	0	\N
239636	1521	1437059000000	3503	1819	0	0	\N
239638	1521	1437059000000	3505	1819	0	0	\N
239639	1500	0	3508	1821	0	0	\N
239641	1500	0	3510	1821	0	0	\N
239644	1500	0	3526	1793	0	0	\N
239645	1764	8651010000000	3526	1793	2	0	\N
239646	1749	704089000000	3526	1793	3	0	\N
239647	1749	4315089000000	3526	1793	4	0	\N
239648	1775	2000000000	3526	1793	5	0	\N
239649	1605	20000000	3528	1832	0	0	\N
239651	1605	20000000	3530	1832	0	0	\N
239652	1605	20000000	3531	1832	0	0	\N
239655	11	4652000000000	3533	1833	0	0	\N
239656	1521	1437079000000	3533	1833	1	0	\N
239657	11	4652000000000	3543	1710	0	0	\N
239658	1759	6480000000000	3543	1710	1	0	\N
239659	1500	0	3543	1710	2	0	\N
239660	1764	5039010000000	3543	1710	3	0	\N
239661	1749	4315990000000	3543	1710	4	0	\N
239662	1745	8406000000	3543	1710	6	0	\N
239663	1749	4316090000000	3543	1710	7	0	\N
239664	1775	2000000000	3543	1710	8	0	\N
239665	11	4652000000000	3628	1794	0	0	\N
239672	1776	0	3636	1885	0	0	\N
239673	1483	0	3636	1885	1	0	\N
239674	1483	0	3636	1885	2	0	\N
239675	1776	0	3637	1885	0	0	\N
239676	1483	0	3637	1885	1	0	\N
239677	1483	0	3637	1885	2	0	\N
239678	1776	0	3640	1712	0	0	\N
239679	348	66001000000000	3640	1712	1	0	\N
239680	1777	1000000000	3640	1712	2	0	\N
239681	530	66000100000000	3640	1712	3	0	\N
239682	1483	0	3640	1712	4	0	\N
239685	1778	100000000	3665	1903	0	0	\N
239692	1678	2880082515000	3673	1907	0	0	\N
239693	1678	2880082516000	3674	1908	0	0	\N
239694	1678	2880082516000	3675	1908	0	0	\N
239696	1678	2880082516000	3677	1908	0	0	\N
239699	1678	2880082519000	3680	1911	0	0	\N
239703	1483	0	3684	1914	0	0	\N
239704	1678	2880082522000	3684	1914	1	0	\N
239705	1678	2880082523000	3684	1914	2	0	\N
239709	1678	2880082524000	3686	1915	0	0	\N
239710	1678	2880082525000	3686	1915	1	0	\N
239713	1678	2880082524000	3688	1915	0	0	\N
239714	1678	2880082525000	3688	1915	1	0	\N
239716	1678	2880082526000	3690	1916	0	0	\N
239717	1678	2880082526000	3691	1916	0	0	\N
239718	1678	2880082526000	3692	1916	0	0	\N
239721	1678	2880082529000	3695	1919	0	0	\N
239722	1678	2880082530000	3695	1919	1	0	\N
239723	1779	2200000000	3695	1919	2	0	\N
239728	1678	2880082531000	3698	1920	0	0	\N
239729	1678	2880082532000	3699	1921	0	0	\N
239731	562	66000100000000	3701	1922	0	0	\N
239732	1678	2880082533000	3701	1922	1	0	\N
239733	1779	2323456789	3701	1922	2	0	\N
239734	562	66000100000000	3702	1922	0	0	\N
239735	1678	2880082533000	3702	1922	1	0	\N
239736	1779	2323456789	3702	1922	2	0	\N
239740	1678	2880082534000	3704	1923	0	0	\N
239742	1678	2880082534000	3706	1923	0	0	\N
239749	1678	2880082541000	3710	1927	0	0	\N
239750	1678	2880082542000	3710	1927	1	0	\N
239753	1678	2880082541000	3712	1927	0	0	\N
239754	1678	2880082542000	3712	1927	1	0	\N
239756	1678	2880082543000	3714	1928	0	0	\N
239759	1678	2880082545000	3717	1930	0	0	\N
239760	1678	2880082545000	3718	1930	0	0	\N
239761	1678	2880082545000	3719	1930	0	0	\N
239762	562	66000100000000	3720	1922	0	0	\N
239763	1678	2880082533000	3720	1922	1	0	\N
239764	1678	2880082534000	3720	1922	2	0	\N
239765	1678	2880082535000	3720	1922	4	0	\N
239766	1678	2880082536000	3720	1922	5	0	\N
239767	1678	2880082537000	3720	1922	6	0	\N
239768	1678	2880082538000	3720	1922	7	0	\N
239642	1605	10000000	3519	1827	0	0	0
239643	1749	4315089000000	3521	1829	0	0	2
239650	1605	20000000	3529	1832	0	0	0
239653	11	4652000000000	3532	1833	0	0	0
239654	1521	1437079000000	3532	1833	1	0	1
239667	1777	1000000000	3632	1882	1	0	0
239668	530	66000100000000	3633	1883	0	0	0
239669	1776	0	3635	1885	0	0	0
239670	1483	0	3635	1885	1	0	0
239671	1483	0	3635	1885	2	0	0
239684	1500	0	3653	1896	0	0	0
239686	1778	100000000	3666	1903	0	0	0
239687	1678	2880082512000	3669	1905	0	0	0
239688	1678	2880082513000	3669	1905	1	0	0
239690	1678	2880082514000	3670	1906	0	0	0
239691	1678	2880082515000	3671	1907	0	0	0
239695	1678	2880082516000	3676	1908	0	0	0
239697	1678	2880082517000	3678	1909	0	0	0
239698	1678	2880082518000	3679	1910	0	0	0
239701	1678	2880082520000	3682	1912	0	0	0
239702	1678	2880082521000	3683	1913	0	0	0
239706	1483	0	3685	1914	0	0	0
239707	1678	2880082522000	3685	1914	1	0	0
239708	1678	2880082523000	3685	1914	2	0	0
239712	1678	2880082525000	3687	1915	1	0	0
239715	1678	2880082526000	3689	1916	0	0	0
239719	1678	2880082527000	3693	1917	0	0	0
239720	1678	2880082528000	3694	1918	0	0	0
239725	1678	2880082530000	3696	1919	1	0	0
239726	1779	2200000000	3696	1919	2	0	0
239727	1678	2880082531000	3697	1920	0	0	0
239730	1678	2880082532000	3700	1921	0	0	0
239737	562	66000100000000	3703	1922	0	0	0
239739	1779	2323456789	3703	1922	2	0	0
239741	1678	2880082534000	3705	1923	0	0	0
239743	1678	2880082535000	3707	1924	0	0	0
239744	1678	2880082536000	3708	1925	0	0	0
239745	1678	2880082537000	3709	1926	0	0	0
239747	1678	2880082539000	3709	1926	2	0	0
239748	1678	2880082540000	3709	1926	3	0	0
239751	1678	2880082541000	3711	1927	0	0	0
239752	1678	2880082542000	3711	1927	1	0	0
239757	1678	2880082544000	3715	1929	0	0	0
239758	1678	2880082545000	3716	1930	0	0	0
239769	1678	2880082539000	3720	1922	8	0	\N
239770	1678	2880082540000	3720	1922	9	0	\N
239771	1678	2880082541000	3720	1922	10	0	\N
239772	1678	2880082542000	3720	1922	11	0	\N
239773	1678	2880082546000	3721	1931	0	0	\N
239777	1678	2880082548000	3725	1933	0	0	\N
239778	1678	2880082548000	3726	1933	0	0	\N
239779	1678	2880082548000	3727	1933	0	0	\N
239782	1678	2880082551000	3730	1936	0	0	\N
239783	1678	2880082551000	3731	1936	0	0	\N
239785	1678	2880082551000	3733	1936	0	0	\N
239787	1678	2880082553000	3735	1938	0	0	\N
239788	1678	2880082554000	3735	1938	1	0	\N
239791	1678	2880082555000	3737	1939	0	0	\N
239792	1678	2880082555000	3738	1939	0	0	\N
239794	1678	2880082556000	3740	1940	0	0	\N
239796	1678	2880082556000	3742	1940	0	0	\N
239797	1678	2880082557000	3743	1941	0	0	\N
239798	1754	5673543211	3743	1941	1	0	\N
239801	1678	2880082557000	3745	1941	0	0	\N
239802	1754	5673543211	3745	1941	1	0	\N
239803	1678	2880082558000	3746	1942	0	0	\N
239804	1678	2880082559000	3746	1942	1	0	\N
239810	1678	2880082561000	3750	1944	0	0	\N
239811	1678	2880082562000	3750	1944	1	0	\N
239813	1754	5999000000	3752	1919	0	0	\N
239815	1678	2880082564000	3754	1946	0	0	\N
239821	1678	2880082568000	3758	1949	0	0	\N
239822	1678	2880082569000	3758	1949	1	0	\N
239823	1776	1000000000	3759	1713	0	0	\N
239824	1754	9000000000	3759	1713	1	0	\N
239828	1678	2880082572000	3763	1952	0	0	\N
239831	1678	2880082575000	3765	1954	0	0	\N
239832	1678	2880082576000	3765	1954	1	0	\N
239833	1678	2880082575000	3766	1954	0	0	\N
239834	1678	2880082576000	3766	1954	1	0	\N
239835	1678	2880082575000	3767	1954	0	0	\N
239836	1678	2880082576000	3767	1954	1	0	\N
239842	1678	2880082579000	3771	1956	0	0	\N
239843	1678	2880082580000	3772	1957	0	0	\N
239846	1678	2880082582000	3779	1959	0	0	\N
239848	1678	2880082582000	3781	1959	0	0	\N
239849	1678	2880082583000	3782	1960	0	0	\N
239850	1678	2880082584000	3782	1960	1	0	\N
239851	1678	2880082583000	3783	1960	0	0	\N
239852	1678	2880082584000	3783	1960	1	0	\N
239855	1678	2880082583000	3785	1960	0	0	\N
239856	1678	2880082584000	3785	1960	1	0	\N
239857	1678	2880082583000	3786	1960	0	0	\N
239858	1678	2880082584000	3786	1960	1	0	\N
239866	1678	2880082588000	3790	1963	0	0	\N
239867	1678	2880082589000	3790	1963	1	0	\N
239868	1678	2880082590000	3790	1963	2	0	\N
239869	1678	2880082591000	3790	1963	3	0	\N
239871	1678	2880082592000	3793	1964	0	0	\N
239875	1678	2880082596000	3797	1968	0	0	\N
239878	1678	2880082598000	3800	1970	0	0	\N
239879	1678	2880082599000	3800	1970	1	0	\N
239882	1678	2880082598000	3802	1970	0	0	\N
239883	1678	2880082599000	3802	1970	1	0	\N
239885	1678	2880082601000	3804	1972	0	0	\N
239886	1678	2880082602000	3804	1972	1	0	\N
239887	1678	2880082603000	3804	1972	2	0	\N
239888	1678	2880082601000	3805	1972	0	0	\N
239889	1678	2880082602000	3805	1972	1	0	\N
239890	1678	2880082603000	3805	1972	2	0	\N
239897	1678	2880082607000	3810	1976	0	0	\N
239899	1678	2880082608000	3812	1977	0	0	\N
239900	1678	2880082609000	3812	1977	1	0	\N
239901	1678	2880082608000	3813	1977	0	0	\N
239902	1678	2880082609000	3813	1977	1	0	\N
239776	1678	2880082548000	3724	1933	0	0	0
239780	1678	2880082549000	3728	1934	0	0	0
239781	1678	2880082550000	3729	1935	0	0	0
239784	1678	2880082551000	3732	1936	0	0	0
239786	1678	2880082552000	3734	1937	0	0	0
239790	1678	2880082554000	3736	1938	1	0	0
239793	1678	2880082555000	3739	1939	0	0	0
239795	1678	2880082556000	3741	1940	0	0	0
239799	1678	2880082557000	3744	1941	0	0	0
239800	1754	5673543211	3744	1941	1	0	3
239806	1678	2880082559000	3747	1942	1	0	0
239807	1678	2880082560000	3748	1943	0	0	0
239808	1678	2880082561000	3749	1944	0	0	0
239809	1678	2880082562000	3749	1944	1	0	0
239814	1678	2880082564000	3753	1946	0	0	0
239816	1678	2880082565000	3755	1947	0	0	0
239817	1678	2880082566000	3756	1948	0	0	0
239818	1678	2880082567000	3756	1948	1	0	0
239819	1678	2880082568000	3757	1949	0	0	0
239825	1678	2880082570000	3760	1950	0	0	0
239826	1678	2880082571000	3761	1951	0	0	0
239827	1678	2880082572000	3762	1952	0	0	0
239829	1678	2880082573000	3764	1953	0	0	0
239830	1678	2880082574000	3764	1953	1	0	0
239838	1678	2880082576000	3768	1954	1	0	0
239839	1678	2880082577000	3769	1955	0	0	0
239840	1678	2880082578000	3769	1955	1	0	0
239841	1678	2880082579000	3770	1956	0	0	0
239845	1678	2880082581000	3778	1958	0	0	0
239847	1678	2880082582000	3780	1959	0	0	0
239853	1678	2880082583000	3784	1960	0	0	0
239854	1678	2880082584000	3784	1960	1	0	0
239859	1678	2880082585000	3787	1961	0	0	0
239861	1678	2880082587000	3788	1962	1	0	0
239862	1678	2880082588000	3789	1963	0	0	0
239863	1678	2880082589000	3789	1963	1	0	0
239864	1678	2880082590000	3789	1963	2	0	0
239865	1678	2880082591000	3789	1963	3	0	0
239872	1678	2880082593000	3794	1965	0	0	0
239873	1678	2880082594000	3795	1966	0	0	0
239874	1678	2880082595000	3796	1967	0	0	0
239876	1678	2880082596000	3798	1968	0	0	0
239880	1678	2880082598000	3801	1970	0	0	0
239881	1678	2880082599000	3801	1970	1	0	0
239884	1678	2880082600000	3803	1971	0	0	0
239891	1678	2880082601000	3806	1972	0	0	0
239892	1678	2880082602000	3806	1972	1	0	0
239894	1678	2880082604000	3807	1973	0	0	0
239895	1678	2880082605000	3808	1974	0	0	0
239896	1678	2880082606000	3809	1975	0	0	0
239898	1678	2880082607000	3811	1976	0	0	0
239903	1678	2880082608000	3814	1977	0	0	0
239905	1678	2880082608000	3815	1977	0	0	\N
239906	1678	2880082609000	3815	1977	1	0	\N
239907	1678	2880082610000	3816	1978	0	0	\N
239909	1678	2880082610000	3818	1978	0	0	\N
239911	1678	2880082611000	3820	1979	0	0	\N
239920	11	4652000000000	3826	1793	0	0	\N
239921	1678	2880082512000	3826	1793	1	0	\N
239922	1678	2880082513000	3826	1793	2	0	\N
239923	1500	0	3826	1793	3	0	\N
239924	1778	100000000	3826	1793	4	0	\N
239925	562	66000100000000	3826	1793	5	0	\N
239926	1678	2880082514000	3826	1793	6	0	\N
239927	1678	2880082515000	3826	1793	7	0	\N
239928	1678	2880082516000	3826	1793	8	0	\N
239929	1678	2880082517000	3826	1793	9	0	\N
239930	1678	2880082518000	3826	1793	10	0	\N
239931	1776	0	3826	1793	12	0	\N
239932	1776	1000000000	3826	1793	13	0	\N
239933	1678	2880082519000	3826	1793	14	0	\N
239934	1678	2880082520000	3826	1793	15	0	\N
239935	1678	2880082521000	3826	1793	16	0	\N
239936	1678	2880082522000	3826	1793	17	0	\N
239937	1678	2880082523000	3826	1793	18	0	\N
239938	1678	2880082524000	3826	1793	19	0	\N
239939	1678	2880082525000	3826	1793	20	0	\N
239940	1678	2880082526000	3826	1793	21	0	\N
239941	1678	2880082527000	3826	1793	22	0	\N
239942	1678	2880082528000	3826	1793	23	0	\N
239943	1678	2880082529000	3826	1793	24	0	\N
239944	1678	2880082530000	3826	1793	25	0	\N
239945	1678	2880082531000	3826	1793	26	0	\N
239946	1678	2880082532000	3826	1793	27	0	\N
239947	1678	2880082533000	3826	1793	28	0	\N
239948	1678	2880082534000	3826	1793	29	0	\N
239949	1678	2880082535000	3826	1793	30	0	\N
239950	1678	2880082536000	3826	1793	31	0	\N
239951	1678	2880082537000	3826	1793	32	0	\N
239952	1678	2880082538000	3826	1793	33	0	\N
239953	1678	2880082539000	3826	1793	34	0	\N
239954	1678	2880082540000	3826	1793	35	0	\N
239955	1678	2880082541000	3826	1793	36	0	\N
239956	1678	2880082542000	3826	1793	37	0	\N
239957	1678	2880082543000	3826	1793	38	0	\N
239958	1678	2880082544000	3826	1793	39	0	\N
239959	1678	2880082545000	3826	1793	40	0	\N
239960	1678	2880082546000	3826	1793	41	0	\N
239961	1678	2880082547000	3826	1793	42	0	\N
239962	1678	2880082548000	3826	1793	43	0	\N
239963	1678	2880082549000	3826	1793	44	0	\N
239964	1678	2880082550000	3826	1793	45	0	\N
239965	1678	2880082551000	3826	1793	46	0	\N
239966	1678	2880082552000	3826	1793	47	0	\N
239967	1678	2880082553000	3826	1793	48	0	\N
239968	1678	2880082554000	3826	1793	49	0	\N
239969	1678	2880082555000	3826	1793	50	0	\N
239970	1678	2880082556000	3826	1793	51	0	\N
239971	1678	2880082557000	3826	1793	52	0	\N
239972	1678	2880082558000	3826	1793	53	0	\N
239973	1678	2880082559000	3826	1793	54	0	\N
239974	1678	2880082560000	3826	1793	55	0	\N
239975	1678	2880082561000	3826	1793	56	0	\N
239976	1678	2880082562000	3826	1793	57	0	\N
239977	1678	2880082563000	3826	1793	58	0	\N
239978	1678	2880082564000	3826	1793	59	0	\N
239979	1678	2880082565000	3826	1793	60	0	\N
239980	1678	2880082566000	3826	1793	61	0	\N
239981	1678	2880082567000	3826	1793	62	0	\N
239982	1678	2880082568000	3826	1793	63	0	\N
239983	1678	2880082569000	3826	1793	64	0	\N
239984	1678	2880082570000	3826	1793	65	0	\N
239985	1678	2880082571000	3826	1793	66	0	\N
239986	1678	2880082572000	3826	1793	67	0	\N
239987	1678	2880082573000	3826	1793	68	0	\N
239988	1678	2880082574000	3826	1793	69	0	\N
239989	1678	2880082575000	3826	1793	70	0	\N
239990	1678	2880082576000	3826	1793	71	0	\N
239991	1678	2880082577000	3826	1793	72	0	\N
239992	1678	2880082578000	3826	1793	73	0	\N
239993	1678	2880082579000	3826	1793	74	0	\N
239994	1678	2880082580000	3826	1793	75	0	\N
239995	1678	2880082581000	3826	1793	76	0	\N
239996	1678	2880082582000	3826	1793	77	0	\N
239997	1678	2880082583000	3826	1793	78	0	\N
239998	1678	2880082584000	3826	1793	79	0	\N
239999	1678	2880082585000	3826	1793	80	0	\N
240000	1678	2880082586000	3826	1793	82	0	\N
240001	1678	2880082587000	3826	1793	83	0	\N
240002	1678	2880082588000	3826	1793	84	0	\N
240003	1678	2880082589000	3826	1793	85	0	\N
240004	1678	2880082590000	3826	1793	86	0	\N
240005	1678	2880082591000	3826	1793	87	0	\N
240006	1678	2880082592000	3826	1793	88	0	\N
240007	1678	2880082593000	3826	1793	89	0	\N
240008	1678	2880082594000	3826	1793	90	0	\N
240009	1678	2880082595000	3826	1793	91	0	\N
240010	1678	2880082596000	3826	1793	92	0	\N
240011	1678	2880082597000	3826	1793	93	0	\N
240012	1678	2880082598000	3826	1793	94	0	\N
240013	1678	2880082599000	3826	1793	95	0	\N
240014	1678	2880082600000	3826	1793	96	0	\N
240015	1678	2880082601000	3826	1793	97	0	\N
240016	1678	2880082602000	3826	1793	98	0	\N
240017	1678	2880082603000	3826	1793	99	0	\N
240018	1678	2880082604000	3826	1793	100	0	\N
240019	1678	2880082605000	3826	1793	101	0	\N
240020	1678	2880082606000	3826	1793	102	0	\N
240021	1678	2880082607000	3826	1793	103	0	\N
240022	1678	2880082608000	3826	1793	104	0	\N
240023	1678	2880082609000	3826	1793	105	0	\N
240024	1678	2880082610000	3826	1793	106	0	\N
240025	1678	2880082611000	3826	1793	107	0	\N
240026	1678	2880082612000	3826	1793	108	0	\N
240027	1678	2880082613000	3826	1793	109	0	\N
240028	1678	2880082614000	3826	1793	110	0	\N
240029	1678	2880082615000	3826	1793	111	0	\N
240034	1781	0	3830	1988	0	0	\N
240035	1678	2880082621000	3830	1988	1	0	\N
239912	1678	2880082612000	3821	1980	0	0	0
239913	1678	2880082613000	3822	1981	0	0	0
239914	1678	2880082614000	3823	1982	0	0	0
239915	1678	2880082615000	3823	1982	1	0	0
239916	1483	0	3824	1983	0	0	0
239918	255	66000000000000	3825	1984	0	0	0
239919	1678	2880082617000	3825	1984	1	0	0
240030	871	109739603307813	3827	1985	0	0	0
240031	1678	2880082618000	3827	1985	1	0	0
240032	1678	2880082619000	3828	1986	0	0	0
240036	1781	0	3831	1988	0	0	0
240037	1678	2880082621000	3831	1988	1	0	0
240038	1765	70000000	3832	1989	0	0	1
240039	1678	2880082622000	3832	1989	1	0	0
240051	1678	2880082633000	3839	1995	0	0	\N
240052	1781	0	3840	1891	0	0	\N
240053	871	109739603307813	3840	1891	1	0	\N
240054	1776	1000000000	3840	1891	2	0	\N
240055	1678	2880082512000	3840	1891	3	0	\N
240056	1678	2880082513000	3840	1891	4	0	\N
240057	1778	100000000	3840	1891	5	0	\N
240058	562	66000100000000	3840	1891	6	0	\N
240059	1678	2880082514000	3840	1891	7	0	\N
240060	1678	2880082515000	3840	1891	8	0	\N
240061	1678	2880082516000	3840	1891	9	0	\N
240062	1678	2880082517000	3840	1891	10	0	\N
240063	1678	2880082518000	3840	1891	11	0	\N
240064	1678	2880082519000	3840	1891	12	0	\N
240065	1678	2880082520000	3840	1891	13	0	\N
240066	1678	2880082521000	3840	1891	14	0	\N
240067	1678	2880082522000	3840	1891	15	0	\N
240068	1678	2880082523000	3840	1891	16	0	\N
240069	1678	2880082524000	3840	1891	17	0	\N
240070	1678	2880082525000	3840	1891	18	0	\N
240071	1678	2880082526000	3840	1891	19	0	\N
240072	1678	2880082527000	3840	1891	20	0	\N
240073	1678	2880082528000	3840	1891	21	0	\N
240074	1678	2880082529000	3840	1891	22	0	\N
240075	1678	2880082530000	3840	1891	23	0	\N
240076	1678	2880082531000	3840	1891	24	0	\N
240077	1678	2880082532000	3840	1891	25	0	\N
240078	1678	2880082533000	3840	1891	26	0	\N
240079	1678	2880082534000	3840	1891	27	0	\N
240080	1678	2880082535000	3840	1891	28	0	\N
240081	1678	2880082536000	3840	1891	29	0	\N
240082	1678	2880082537000	3840	1891	30	0	\N
240083	1678	2880082538000	3840	1891	31	0	\N
240084	1678	2880082539000	3840	1891	32	0	\N
240085	1678	2880082540000	3840	1891	33	0	\N
240086	1678	2880082541000	3840	1891	34	0	\N
240087	1678	2880082542000	3840	1891	35	0	\N
240088	1678	2880082543000	3840	1891	36	0	\N
240089	1678	2880082544000	3840	1891	37	0	\N
240090	1678	2880082545000	3840	1891	38	0	\N
240091	1678	2880082546000	3840	1891	39	0	\N
240092	1678	2880082547000	3840	1891	40	0	\N
240093	1678	2880082548000	3840	1891	41	0	\N
240094	1678	2880082549000	3840	1891	42	0	\N
240095	1678	2880082550000	3840	1891	43	0	\N
240096	1678	2880082551000	3840	1891	44	0	\N
240097	1678	2880082552000	3840	1891	45	0	\N
240098	1678	2880082553000	3840	1891	46	0	\N
240099	1678	2880082554000	3840	1891	47	0	\N
240100	1678	2880082555000	3840	1891	48	0	\N
240101	1678	2880082556000	3840	1891	49	0	\N
240102	1678	2880082557000	3840	1891	50	0	\N
240103	1678	2880082558000	3840	1891	51	0	\N
240104	1678	2880082559000	3840	1891	52	0	\N
240105	1678	2880082560000	3840	1891	53	0	\N
240106	1678	2880082561000	3840	1891	54	0	\N
240107	1678	2880082562000	3840	1891	55	0	\N
240108	1678	2880082563000	3840	1891	56	0	\N
240109	1678	2880082564000	3840	1891	57	0	\N
240110	1678	2880082565000	3840	1891	58	0	\N
240111	1678	2880082566000	3840	1891	59	0	\N
240112	1678	2880082567000	3840	1891	60	0	\N
240113	1678	2880082568000	3840	1891	61	0	\N
240114	1678	2880082569000	3840	1891	62	0	\N
240115	1678	2880082570000	3840	1891	63	0	\N
240116	1678	2880082571000	3840	1891	64	0	\N
240117	1678	2880082572000	3840	1891	65	0	\N
240118	1678	2880082573000	3840	1891	66	0	\N
240119	1678	2880082574000	3840	1891	67	0	\N
240120	1678	2880082575000	3840	1891	68	0	\N
240121	1678	2880082576000	3840	1891	69	0	\N
240122	1678	2880082577000	3840	1891	70	0	\N
240123	1678	2880082578000	3840	1891	71	0	\N
240124	1678	2880082579000	3840	1891	72	0	\N
240125	1678	2880082580000	3840	1891	73	0	\N
240126	1678	2880082581000	3840	1891	74	0	\N
240127	1678	2880082582000	3840	1891	75	0	\N
240128	1678	2880082583000	3840	1891	76	0	\N
240129	1678	2880082584000	3840	1891	77	0	\N
240130	1678	2880082585000	3840	1891	78	0	\N
240131	1678	2880082586000	3840	1891	79	0	\N
240132	1678	2880082587000	3840	1891	80	0	\N
240133	1678	2880082588000	3840	1891	82	0	\N
240134	1678	2880082589000	3840	1891	83	0	\N
240135	1678	2880082590000	3840	1891	84	0	\N
240136	1678	2880082591000	3840	1891	85	0	\N
240137	1678	2880082592000	3840	1891	86	0	\N
240138	1678	2880082593000	3840	1891	87	0	\N
240139	1678	2880082594000	3840	1891	88	0	\N
240140	1678	2880082595000	3840	1891	89	0	\N
240141	1678	2880082596000	3840	1891	90	0	\N
240142	1678	2880082597000	3840	1891	91	0	\N
240143	1678	2880082598000	3840	1891	92	0	\N
240144	1678	2880082599000	3840	1891	93	0	\N
240145	1678	2880082600000	3840	1891	94	0	\N
240146	1678	2880082601000	3840	1891	95	0	\N
240147	1678	2880082602000	3840	1891	96	0	\N
240148	1678	2880082603000	3840	1891	97	0	\N
240149	1678	2880082604000	3840	1891	98	0	\N
240150	1678	2880082605000	3840	1891	99	0	\N
240151	1678	2880082606000	3840	1891	100	0	\N
240152	1678	2880082607000	3840	1891	101	0	\N
240153	1678	2880082608000	3840	1891	102	0	\N
240154	1678	2880082609000	3840	1891	103	0	\N
240155	1678	2880082610000	3840	1891	104	0	\N
240156	1678	2880082611000	3840	1891	105	0	\N
240157	1678	2880082612000	3840	1891	106	0	\N
240158	1678	2880082613000	3840	1891	107	0	\N
240159	1678	2880082614000	3840	1891	108	0	\N
240160	1678	2880082615000	3840	1891	109	0	\N
240161	1678	2880082616000	3840	1891	110	0	\N
240162	1678	2880082617000	3840	1891	111	0	\N
240163	1678	2880082618000	3840	1891	112	0	\N
240164	1678	2880082619000	3840	1891	113	0	\N
240165	1678	2880082620000	3840	1891	114	0	\N
240166	1678	2880082621000	3840	1891	115	0	\N
240167	1678	2880082622000	3840	1891	116	0	\N
240168	1678	2880082623000	3840	1891	117	0	\N
240169	1678	2880082624000	3840	1891	118	0	\N
240170	1678	2880082625000	3840	1891	119	0	\N
240171	1678	2880082626000	3840	1891	120	0	\N
240172	1678	2880082627000	3840	1891	121	0	\N
240173	1678	2880082628000	3840	1891	122	0	\N
240174	1678	2880082629000	3840	1891	123	0	\N
240175	1678	2880082630000	3840	1891	124	0	\N
240176	1678	2880082631000	3840	1891	125	0	\N
240043	1678	2880082626000	3833	1990	1	0	0
240044	1678	2880082627000	3834	1991	0	0	0
240045	1678	2880082628000	3834	1991	1	0	0
240046	1678	2880082629000	3835	1992	0	0	0
240047	1678	2880082630000	3836	1993	0	0	0
240049	1678	2880082632000	3837	1994	0	0	0
240050	1678	2880082633000	3838	1995	0	0	0
240178	1678	2880082635000	3842	1997	0	0	\N
240179	1678	2880082636000	3842	1997	1	0	\N
240180	1678	2880082635000	3843	1997	0	0	\N
240181	1678	2880082636000	3843	1997	1	0	\N
240182	1678	2880082635000	3844	1997	0	0	\N
240183	1678	2880082636000	3844	1997	1	0	\N
240184	1678	2880082635000	3845	1997	0	0	\N
240185	1678	2880082636000	3845	1997	1	0	\N
240189	1678	2880082637000	3848	1998	0	0	\N
240190	1678	2880082638000	3849	1999	0	0	\N
240191	1678	2880082639000	3849	1999	1	0	\N
240194	1678	2880082638000	3851	1999	0	0	\N
240195	1678	2880082639000	3851	1999	1	0	\N
240196	1678	2880082640000	3852	2000	0	0	\N
240199	1678	2880082642000	3855	2002	0	0	\N
240200	1678	2880082643000	3855	2002	1	0	\N
240201	1678	2880082644000	3855	2002	2	0	\N
240202	1678	2880082645000	3855	2002	3	0	\N
240208	1678	2880082646000	3858	2003	0	0	\N
240209	1678	2880082646000	3859	2003	0	0	\N
240211	1678	2880082648000	3861	2005	0	0	\N
240216	1678	2880082649000	3864	2006	0	0	\N
240217	1678	2880082650000	3864	2006	1	0	\N
240218	1678	2880082651000	3864	2006	2	0	\N
240219	1678	2880082649000	3865	2006	0	0	\N
240220	1678	2880082650000	3865	2006	1	0	\N
240221	1678	2880082651000	3865	2006	2	0	\N
240225	1678	2880082653000	3868	2008	0	0	\N
240226	1678	2880082654000	3868	2008	1	0	\N
240229	1678	2880082656000	3871	2010	0	0	\N
240230	1678	2880082656000	3872	2010	0	0	\N
240234	1678	2880082659000	3876	2013	0	0	\N
240236	1678	2880082660000	3878	2014	0	0	\N
240237	1678	2880082660000	3879	2014	0	0	\N
240243	1678	2880082664000	3884	2018	0	0	\N
240244	1678	2880082665000	3884	2018	1	0	\N
240245	1678	2880082666000	3885	2019	0	0	\N
240247	1678	2880082667000	3887	2020	0	0	\N
240248	1678	2880082668000	3887	2020	1	0	\N
240252	1678	2880082670000	3894	2022	0	0	\N
240253	1678	2880082671000	3894	2022	1	0	\N
240257	1678	2880082672000	3897	2023	0	0	\N
240259	1678	2880082673000	3899	2024	0	0	\N
240261	1678	2880082675000	3901	2026	0	0	\N
240263	1678	2880082676000	3903	2027	0	0	\N
240264	1678	2880082677000	3903	2027	1	0	\N
240270	1678	2880082679000	3907	2029	0	0	\N
240271	1678	2880082680000	3907	2029	1	0	\N
240272	1678	2880082679000	3908	2029	0	0	\N
240273	1678	2880082680000	3908	2029	1	0	\N
240275	1678	2880082682000	3911	2031	0	0	\N
240276	1678	2880082683000	3911	2031	1	0	\N
240280	1678	2880082685000	3918	2033	0	0	\N
240283	1678	2880082686000	3921	2034	0	0	\N
240285	1678	2880082688000	3923	2036	0	0	\N
240286	1678	2880082689000	3923	2036	1	0	\N
240287	1678	2880082688000	3924	2036	0	0	\N
240288	1678	2880082689000	3924	2036	1	0	\N
240291	1678	2880082688000	3926	2036	0	0	\N
240292	1678	2880082689000	3926	2036	1	0	\N
240293	1678	2880082632000	3927	1892	0	0	\N
240294	1678	2880082633000	3927	1892	1	0	\N
240295	1678	2880082634000	3927	1892	2	0	\N
240296	1678	2880082635000	3927	1892	3	0	\N
240297	1678	2880082636000	3927	1892	4	0	\N
240298	1678	2880082637000	3927	1892	5	0	\N
240299	1678	2880082638000	3927	1892	6	0	\N
240300	1678	2880082639000	3927	1892	7	0	\N
240301	1678	2880082640000	3927	1892	8	0	\N
240302	1678	2880082641000	3927	1892	9	0	\N
240303	1678	2880082642000	3927	1892	10	0	\N
240304	1678	2880082643000	3927	1892	11	0	\N
240305	1678	2880082644000	3927	1892	12	0	\N
240306	1678	2880082645000	3927	1892	13	0	\N
240307	1678	2880082646000	3927	1892	14	0	\N
240308	1678	2880082647000	3927	1892	15	0	\N
240309	1678	2880082648000	3927	1892	16	0	\N
240310	1678	2880082649000	3927	1892	17	0	\N
240311	1678	2880082650000	3927	1892	18	0	\N
240312	1678	2880082651000	3927	1892	19	0	\N
240187	1678	2880082636000	3846	1997	1	0	0
240188	1678	2880082637000	3847	1998	0	0	0
240192	1678	2880082638000	3850	1999	0	0	0
240193	1678	2880082639000	3850	1999	1	0	0
240197	1678	2880082640000	3853	2000	0	0	0
240203	1678	2880082642000	3856	2002	0	0	0
240204	1678	2880082643000	3856	2002	1	0	0
240205	1678	2880082644000	3856	2002	2	0	0
240206	1678	2880082645000	3856	2002	3	0	0
240207	1678	2880082646000	3857	2003	0	0	0
240212	1678	2880082648000	3862	2005	0	0	0
240213	1678	2880082649000	3863	2006	0	0	0
240214	1678	2880082650000	3863	2006	1	0	0
240215	1678	2880082651000	3863	2006	2	0	0
240223	1678	2880082653000	3867	2008	0	0	0
240224	1678	2880082654000	3867	2008	1	0	0
240227	1678	2880082655000	3869	2009	0	0	0
240228	1678	2880082656000	3870	2010	0	0	0
240231	1678	2880082657000	3873	2011	0	0	0
240233	1678	2880082659000	3875	2013	0	0	0
240235	1678	2880082660000	3877	2014	0	0	0
240238	1678	2880082661000	3880	2015	0	0	0
240239	1678	2880082662000	3881	2016	0	0	0
240240	1678	2880082663000	3882	2017	0	0	0
240242	1678	2880082665000	3883	2018	1	0	0
240246	1678	2880082666000	3886	2019	0	0	0
240249	1678	2880082667000	3889	2020	0	0	0
240250	1678	2880082668000	3889	2020	1	0	0
240254	1678	2880082670000	3895	2022	0	0	0
240255	1678	2880082671000	3895	2022	1	0	0
240256	1678	2880082672000	3896	2023	0	0	0
240258	1678	2880082673000	3898	2024	0	0	0
240260	1678	2880082674000	3900	2025	0	0	0
240265	1678	2880082676000	3904	2027	0	0	0
240266	1678	2880082677000	3904	2027	1	0	0
240267	1678	2880082678000	3905	2028	0	0	0
240268	1678	2880082679000	3906	2029	0	0	0
240269	1678	2880082680000	3906	2029	1	0	0
240277	1678	2880082682000	3912	2031	0	0	0
240278	1678	2880082683000	3912	2031	1	0	0
240279	1678	2880082684000	3917	2032	0	0	0
240281	1678	2880082685000	3919	2033	0	0	0
240284	1678	2880082687000	3922	2035	0	0	0
240289	1678	2880082688000	3925	2036	0	0	0
240290	1678	2880082689000	3925	2036	1	0	0
240313	1678	2880082652000	3927	1892	20	0	\N
240314	1678	2880082653000	3927	1892	21	0	\N
240315	1678	2880082654000	3927	1892	22	0	\N
240316	1678	2880082655000	3927	1892	23	0	\N
240317	1678	2880082656000	3927	1892	24	0	\N
240318	1678	2880082657000	3927	1892	25	0	\N
240319	1678	2880082658000	3927	1892	26	0	\N
240320	1678	2880082659000	3927	1892	27	0	\N
240321	1678	2880082660000	3927	1892	28	0	\N
240322	1678	2880082661000	3927	1892	29	0	\N
240323	1678	2880082662000	3927	1892	30	0	\N
240324	1678	2880082663000	3927	1892	31	0	\N
240325	1678	2880082664000	3927	1892	32	0	\N
240326	1678	2880082665000	3927	1892	33	0	\N
240327	1678	2880082666000	3927	1892	34	0	\N
240328	1678	2880082667000	3927	1892	35	0	\N
240329	1678	2880082668000	3927	1892	36	0	\N
240330	1678	2880082669000	3927	1892	37	0	\N
240331	1678	2880082670000	3927	1892	38	0	\N
240332	1678	2880082671000	3927	1892	39	0	\N
240333	1678	2880082672000	3927	1892	40	0	\N
240334	1678	2880082673000	3927	1892	41	0	\N
240335	1678	2880082674000	3927	1892	42	0	\N
240336	1678	2880082675000	3927	1892	43	0	\N
240337	1678	2880082676000	3927	1892	44	0	\N
240338	1678	2880082677000	3927	1892	45	0	\N
240339	1678	2880082678000	3927	1892	46	0	\N
240340	1678	2880082679000	3927	1892	47	0	\N
240341	1678	2880082680000	3927	1892	48	0	\N
240342	1678	2880082681000	3927	1892	49	0	\N
240343	1678	2880082682000	3927	1892	50	0	\N
240344	1678	2880082683000	3927	1892	51	0	\N
240345	1678	2880082684000	3927	1892	52	0	\N
240346	1678	2880082685000	3927	1892	53	0	\N
240347	1678	2880082686000	3927	1892	54	0	\N
240348	1678	2880082687000	3927	1892	55	0	\N
240349	1678	2880082688000	3927	1892	56	0	\N
240350	1678	2880082689000	3927	1892	57	0	\N
240351	1754	9000000000	3927	1892	58	0	\N
240352	1779	2000000000	3927	1892	59	0	\N
240353	1779	2200000000	3927	1892	60	0	\N
240354	1779	2323456789	3927	1892	61	0	\N
240358	1678	2880082693000	3930	2039	0	0	\N
240359	1678	2880082694000	3930	2039	1	0	\N
240360	1678	2880082693000	3931	2039	0	0	\N
240361	1678	2880082694000	3931	2039	1	0	\N
240366	1678	2880082696000	3935	2041	0	0	\N
240373	1678	2880082703000	3941	2046	0	0	\N
240377	1678	2880082704000	3944	2047	0	0	\N
240378	1678	2880082705000	3944	2047	1	0	\N
240393	1678	2880082715000	3951	2054	0	0	\N
240396	1678	2880082717000	3954	2056	0	0	\N
240397	1678	2880082717000	3955	2056	0	0	\N
240402	1678	2880082720000	3960	2059	0	0	\N
240403	1678	2880082720000	3961	2059	0	0	\N
240404	1678	2880082721000	3962	2060	0	0	\N
240406	1678	2880082721000	3964	2060	0	0	\N
240407	1678	2880082721000	3965	2060	0	0	\N
240408	1781	0	3966	1988	0	0	\N
240409	1749	5755089000000	3966	1988	1	0	\N
240410	1652	490000000	3966	1988	2	0	\N
240411	1652	490000000	3966	1988	3	0	\N
240412	1652	490000000	3966	1988	4	0	\N
240413	1652	490000000	3966	1988	5	0	\N
240416	1678	2880082724000	3968	2062	0	0	\N
240418	1678	2880082725000	3970	2063	0	0	\N
240420	1678	2880082726000	3972	2064	0	0	\N
240421	1678	2880082726000	3973	2064	0	0	\N
240422	1678	2880082726000	3974	2064	0	0	\N
240424	1678	2880082727000	3976	2065	0	0	\N
240429	1678	2880082730000	3980	2067	0	0	\N
240430	1678	2880082731000	3981	2068	0	0	\N
240431	1678	2880082731000	3982	2068	0	0	\N
240435	1678	2880082732000	3985	2069	0	0	\N
240436	1678	2880082733000	3985	2069	1	0	\N
240438	1678	2880082735000	3987	2071	0	0	\N
240441	1678	2880082736000	3990	2072	0	0	\N
240442	1678	2880082736000	3991	2072	0	0	\N
240443	1678	2880082736000	3992	2072	0	0	\N
240444	1678	2880082736000	3993	2072	0	0	\N
240446	1678	2880082738000	3995	2074	0	0	\N
240447	1678	2880082738000	3996	2074	0	0	\N
240357	1678	2880082692000	3929	2038	1	0	0
240362	1678	2880082693000	3932	2039	0	0	0
240363	1678	2880082694000	3932	2039	1	0	0
240364	1678	2880082695000	3933	2040	0	0	0
240365	1678	2880082696000	3934	2041	0	0	0
240368	1678	2880082698000	3937	2043	0	0	0
240369	1678	2880082699000	3938	2044	0	0	0
240370	1678	2880082700000	3938	2044	1	0	0
240371	1678	2880082701000	3939	2045	0	0	0
240372	1678	2880082702000	3939	2045	1	0	0
240375	1678	2880082704000	3943	2047	0	0	0
240376	1678	2880082705000	3943	2047	1	0	0
240379	1678	2880082706000	3945	2048	0	0	0
240380	1678	2880082707000	3945	2048	1	0	0
240382	1678	2880082708000	3946	2049	0	0	0
240383	1652	490000000	3946	2049	1	0	3
240384	1652	490000000	3946	2049	2	0	3
240385	1652	490000000	3946	2049	3	0	3
240386	1652	490000000	3946	2049	4	0	3
240388	1678	2880082710000	3948	2051	0	0	0
240389	1678	2880082711000	3949	2052	0	0	0
240390	1678	2880082712000	3949	2052	1	0	0
240391	1678	2880082713000	3949	2052	2	0	0
240392	1678	2880082714000	3950	2053	0	0	0
240395	1678	2880082716000	3953	2055	0	0	0
240398	1678	2880082717000	3956	2056	0	0	0
240399	1678	2880082718000	3957	2057	0	0	0
240400	1678	2880082719000	3958	2058	0	0	0
240405	1678	2880082721000	3963	2060	0	0	0
240414	1678	2880082722000	3967	2061	0	0	0
240415	1678	2880082723000	3967	2061	1	0	0
240417	1678	2880082724000	3969	2062	0	0	0
240419	1678	2880082725000	3971	2063	0	0	0
240425	1678	2880082727000	3977	2065	0	0	0
240426	1678	2880082728000	3978	2066	0	0	0
240427	1678	2880082729000	3978	2066	1	0	0
240428	1678	2880082730000	3979	2067	0	0	0
240432	1678	2880082731000	3983	2068	0	0	0
240434	1678	2880082733000	3984	2069	1	0	0
240437	1678	2880082734000	3986	2070	0	0	0
240439	1678	2880082735000	3988	2071	0	0	0
240440	1678	2880082736000	3989	2072	0	0	0
240448	1678	2880082738000	3997	2074	0	0	0
240451	1678	2880082741000	3999	2076	0	0	\N
240452	1678	2880082741000	4000	2076	0	0	\N
240454	1678	2880082742000	4002	2077	0	0	\N
240456	1678	2880082743000	4004	2078	0	0	\N
240461	1678	2880082747000	4008	2081	0	0	\N
240463	1678	2880082748000	4011	2082	0	0	\N
240464	1678	2880082749000	4011	2082	1	0	\N
240465	1678	2880082748000	4012	2082	0	0	\N
240466	1678	2880082749000	4012	2082	1	0	\N
240469	1678	2880082748000	4014	2082	0	0	\N
240470	1678	2880082749000	4014	2082	1	0	\N
240472	1678	2880082750000	4016	2083	0	0	\N
240473	1678	2880082750000	4017	2083	0	0	\N
240475	1678	2880082751000	4019	2084	0	0	\N
240486	1678	2880082760000	4027	2091	0	0	\N
240487	1678	2880082760000	4028	2091	0	0	\N
240489	1678	2880082762000	4030	2093	0	0	\N
240491	1678	2880082762000	4032	2093	0	0	\N
240493	1678	2880082764000	4034	2095	0	0	\N
240494	1678	2880082764000	4035	2095	0	0	\N
240501	1678	2880082767000	4041	2098	0	0	\N
240502	1678	2880082768000	4041	2098	1	0	\N
240503	1678	2880082769000	4041	2098	2	0	\N
240507	1678	2880082772000	4044	2100	0	0	\N
240508	1678	2880082773000	4045	2101	0	0	\N
240514	1678	2880082777000	4049	2103	0	0	\N
240515	1678	2880082777000	4050	2103	0	0	\N
240519	1678	2880082781000	4053	2106	0	0	\N
240520	1678	2880082782000	4053	2106	1	0	\N
240521	1678	2880082781000	4054	2106	0	0	\N
240522	1678	2880082782000	4054	2106	1	0	\N
240529	1678	2880082785000	4058	2108	0	0	\N
240530	1678	2880082786000	4059	2109	0	0	\N
240533	1678	2880082788000	4062	2111	0	0	\N
240534	1678	2880082789000	4062	2111	1	0	\N
240535	1678	2880082790000	4062	2111	2	0	\N
240540	1678	2880082791000	4065	2112	0	0	\N
240543	1678	2880082793000	4068	2114	0	0	\N
240546	1678	2880082796000	4070	2116	0	0	\N
240548	1678	2880082797000	4072	2117	0	0	\N
240549	1678	2880082797000	4073	2117	0	0	\N
240551	1678	2880082798000	4075	2118	0	0	\N
240554	1678	2880082800000	4078	2120	0	0	\N
240555	1678	2880082801000	4078	2120	1	0	\N
240556	1678	2880082800000	4079	2120	0	0	\N
240557	1678	2880082801000	4079	2120	1	0	\N
240558	1678	2880082800000	4080	2120	0	0	\N
240559	1678	2880082801000	4080	2120	1	0	\N
240563	1678	2880082802000	4083	2121	0	0	\N
240565	1678	2880082804000	4085	2123	0	0	\N
240567	1678	2880082805000	4087	2124	0	0	\N
240569	1758	1600400000	4089	2125	0	0	\N
240570	1678	2880082806000	4089	2125	1	0	\N
240578	1782	200000000	4092	2126	0	0	\N
240579	1678	2880082807000	4092	2126	1	0	\N
240580	1678	2880082808000	4092	2126	2	0	\N
240581	1678	2880082809000	4092	2126	3	0	\N
240582	1678	2880082810000	4092	2126	4	0	\N
240453	1678	2880082741000	4001	2076	0	0	0
240455	1678	2880082742000	4003	2077	0	0	0
240457	1678	2880082743000	4005	2078	0	0	0
240458	1678	2880082744000	4006	2079	0	0	0
240459	1678	2880082745000	4006	2079	1	0	0
240462	1678	2880082747000	4009	2081	0	0	0
240467	1678	2880082748000	4013	2082	0	0	0
240468	1678	2880082749000	4013	2082	1	0	0
240471	1678	2880082750000	4015	2083	0	0	0
240474	1678	2880082751000	4018	2084	0	0	0
240477	1678	2880082753000	4020	2085	1	0	0
240478	1678	2880082754000	4021	2086	0	0	0
240479	1678	2880082755000	4021	2086	1	0	0
240480	175	66000000000000	4022	2087	0	0	0
240482	1678	2880082757000	4023	2088	0	0	0
240483	1678	2880082758000	4024	2089	0	0	0
240484	1678	2880082759000	4025	2090	0	0	0
240485	1678	2880082760000	4026	2091	0	0	0
240488	1678	2880082761000	4029	2092	0	0	0
240492	1678	2880082763000	4033	2094	0	0	0
240495	1678	2880082764000	4036	2095	0	0	0
240496	1678	2880082765000	4038	2096	0	0	0
240497	1678	2880082766000	4039	2097	0	0	0
240498	1678	2880082767000	4040	2098	0	0	0
240500	1678	2880082769000	4040	2098	2	0	0
240504	1678	2880082770000	4042	2099	0	0	0
240505	1678	2880082771000	4042	2099	1	0	0
240506	1678	2880082772000	4043	2100	0	0	0
240510	1678	2880082774000	4047	2102	0	0	0
240511	1678	2880082775000	4047	2102	1	0	0
240512	1678	2880082776000	4047	2102	2	0	0
240513	1678	2880082777000	4048	2103	0	0	0
240516	1678	2880082778000	4051	2104	0	0	0
240518	1678	2880082780000	4052	2105	1	0	0
240523	1678	2880082781000	4055	2106	0	0	0
240524	1678	2880082782000	4055	2106	1	0	0
240525	1678	2880082783000	4056	2107	0	0	0
240526	1678	2880082784000	4056	2107	1	0	0
240528	1678	2880082785000	4057	2108	0	0	0
240531	1678	2880082786000	4060	2109	0	0	0
240532	1678	2880082787000	4061	2110	0	0	0
240536	1678	2880082788000	4063	2111	0	0	0
240538	1678	2880082790000	4063	2111	2	0	0
240539	1678	2880082791000	4064	2112	0	0	0
240541	1678	2880082792000	4066	2113	0	0	0
240542	1678	2880082793000	4067	2114	0	0	0
240544	1678	2880082794000	4069	2115	0	0	0
240547	1678	2880082796000	4071	2116	0	0	0
240550	1678	2880082797000	4074	2117	0	0	0
240552	1678	2880082798000	4076	2118	0	0	0
240553	1678	2880082799000	4077	2119	0	0	0
240560	1678	2880082800000	4081	2120	0	0	0
240562	1678	2880082802000	4082	2121	0	0	0
240564	1678	2880082803000	4084	2122	0	0	0
240566	1678	2880082804000	4086	2123	0	0	0
240568	1678	2880082805000	4088	2124	0	0	0
240572	1678	2880082806000	4090	2125	1	0	0
240573	1782	200000000	4091	2126	0	0	0
240574	1678	2880082807000	4091	2126	1	0	0
240575	1678	2880082808000	4091	2126	2	0	0
240576	1678	2880082809000	4091	2126	3	0	0
240583	1678	2880082811000	4093	2127	0	0	0
240584	1678	2880082812000	4094	2128	0	0	0
240585	1678	2880082813000	4095	2129	0	0	\N
240591	1678	2880082816000	4099	2131	0	0	\N
240592	1678	2880082817000	4099	2131	1	0	\N
240594	1678	2880082818000	4101	2132	0	0	\N
240595	329	66718800000000	4102	2133	0	0	\N
240596	1678	2880082819000	4102	2133	1	0	\N
240599	329	66718800000000	4104	2133	0	0	\N
240600	1678	2880082819000	4104	2133	1	0	\N
240601	329	66718800000000	4105	2057	0	0	\N
240602	175	66000000000000	4105	2057	1	0	\N
240603	1726	1000100000000	4105	2057	2	0	\N
240604	329	66718800000000	4106	2133	0	0	\N
240605	1678	2880082819000	4106	2133	1	0	\N
240612	1678	2880082823000	4111	2137	0	0	\N
240613	1678	2880082823000	4112	2137	0	0	\N
240614	1678	2880082824000	4113	2138	0	0	\N
240615	1678	2880082824000	4114	2138	0	0	\N
240619	1777	1000000000	4117	2039	0	0	\N
240620	329	66718800000000	4117	2039	1	0	\N
240621	175	66000000000000	4117	2039	2	0	\N
240622	1483	0	4117	2039	3	0	\N
240623	1678	2880082693000	4117	2039	4	0	\N
240624	1678	2880082694000	4117	2039	5	0	\N
240625	1678	2880082695000	4117	2039	6	0	\N
240626	1678	2880082696000	4117	2039	7	0	\N
240627	1678	2880082697000	4117	2039	8	0	\N
240628	1678	2880082698000	4117	2039	9	0	\N
240629	1678	2880082699000	4117	2039	10	0	\N
240630	1678	2880082700000	4117	2039	11	0	\N
240631	1678	2880082701000	4117	2039	12	0	\N
240632	1678	2880082702000	4117	2039	13	0	\N
240633	1678	2880082703000	4117	2039	14	0	\N
240634	1678	2880082704000	4117	2039	15	0	\N
240635	1678	2880082705000	4117	2039	16	0	\N
240636	1678	2880082706000	4117	2039	17	0	\N
240637	1678	2880082707000	4117	2039	18	0	\N
240638	1678	2880082708000	4117	2039	19	0	\N
240639	1678	2880082709000	4117	2039	20	0	\N
240640	1678	2880082710000	4117	2039	21	0	\N
240641	1678	2880082711000	4117	2039	22	0	\N
240642	1678	2880082712000	4117	2039	23	0	\N
240643	1678	2880082713000	4117	2039	24	0	\N
240644	1678	2880082714000	4117	2039	25	0	\N
240645	1678	2880082715000	4117	2039	26	0	\N
240646	1678	2880082716000	4117	2039	27	0	\N
240647	1678	2880082717000	4117	2039	28	0	\N
240648	1678	2880082718000	4117	2039	29	0	\N
240649	1678	2880082719000	4117	2039	30	0	\N
240650	1678	2880082720000	4117	2039	31	0	\N
240651	1678	2880082721000	4117	2039	32	0	\N
240652	1678	2880082722000	4117	2039	33	0	\N
240653	1678	2880082723000	4117	2039	34	0	\N
240654	1678	2880082724000	4117	2039	35	0	\N
240655	1678	2880082725000	4117	2039	36	0	\N
240656	1678	2880082726000	4117	2039	37	0	\N
240657	1678	2880082727000	4117	2039	38	0	\N
240658	1678	2880082728000	4117	2039	39	0	\N
240659	1678	2880082729000	4117	2039	40	0	\N
240660	1678	2880082730000	4117	2039	41	0	\N
240661	1678	2880082731000	4117	2039	42	0	\N
240662	1678	2880082732000	4117	2039	43	0	\N
240663	1678	2880082733000	4117	2039	44	0	\N
240664	1678	2880082734000	4117	2039	45	0	\N
240665	1678	2880082735000	4117	2039	46	0	\N
240666	1678	2880082736000	4117	2039	47	0	\N
240667	1678	2880082737000	4117	2039	48	0	\N
240668	1678	2880082738000	4117	2039	49	0	\N
240669	1678	2880082739000	4117	2039	50	0	\N
240670	1678	2880082740000	4117	2039	51	0	\N
240671	1678	2880082741000	4117	2039	52	0	\N
240672	1678	2880082742000	4117	2039	53	0	\N
240673	1678	2880082743000	4117	2039	54	0	\N
240674	1678	2880082744000	4117	2039	55	0	\N
240675	1678	2880082745000	4117	2039	56	0	\N
240676	1678	2880082746000	4117	2039	57	0	\N
240677	1678	2880082747000	4117	2039	58	0	\N
240678	1678	2880082748000	4117	2039	59	0	\N
240679	1678	2880082749000	4117	2039	60	0	\N
240680	1678	2880082750000	4117	2039	61	0	\N
240681	1678	2880082751000	4117	2039	62	0	\N
240682	1678	2880082752000	4117	2039	63	0	\N
240683	1678	2880082753000	4117	2039	64	0	\N
240684	1678	2880082754000	4117	2039	65	0	\N
240685	1678	2880082755000	4117	2039	66	0	\N
240686	1678	2880082756000	4117	2039	67	0	\N
240687	1678	2880082757000	4117	2039	68	0	\N
240688	1678	2880082758000	4117	2039	69	0	\N
240689	1678	2880082759000	4117	2039	70	0	\N
240690	1678	2880082760000	4117	2039	71	0	\N
240691	1678	2880082761000	4117	2039	72	0	\N
240692	1678	2880082762000	4117	2039	73	0	\N
240693	1678	2880082763000	4117	2039	74	0	\N
240694	1678	2880082764000	4117	2039	75	0	\N
240695	1678	2880082765000	4117	2039	76	0	\N
240696	1678	2880082766000	4117	2039	77	0	\N
240697	1678	2880082767000	4117	2039	78	0	\N
240698	1678	2880082768000	4117	2039	79	0	\N
240699	1678	2880082769000	4117	2039	80	0	\N
240700	1678	2880082770000	4117	2039	81	0	\N
240701	1678	2880082771000	4117	2039	82	0	\N
240702	1678	2880082772000	4117	2039	83	0	\N
240703	1678	2880082773000	4117	2039	84	0	\N
240704	1678	2880082774000	4117	2039	85	0	\N
240705	1678	2880082775000	4117	2039	86	0	\N
240706	1678	2880082776000	4117	2039	87	0	\N
240707	1678	2880082777000	4117	2039	88	0	\N
240708	1678	2880082778000	4117	2039	89	0	\N
240709	1678	2880082779000	4117	2039	90	0	\N
240710	1678	2880082780000	4117	2039	91	0	\N
240711	1678	2880082781000	4117	2039	92	0	\N
240712	1678	2880082782000	4117	2039	93	0	\N
240713	1678	2880082783000	4117	2039	94	0	\N
240714	1678	2880082784000	4117	2039	95	0	\N
240715	1678	2880082785000	4117	2039	96	0	\N
240716	1678	2880082786000	4117	2039	97	0	\N
240717	1678	2880082787000	4117	2039	98	0	\N
240718	1678	2880082788000	4117	2039	99	0	\N
240719	1678	2880082789000	4117	2039	100	0	\N
240720	1678	2880082790000	4117	2039	101	0	\N
240588	1678	2880082815000	4097	2130	1	0	0
240589	1678	2880082816000	4098	2131	0	0	0
240590	1678	2880082817000	4098	2131	1	0	0
240593	1678	2880082818000	4100	2132	0	0	0
240597	329	66718800000000	4103	2133	0	0	1
240606	1777	1000000000	4107	2134	0	0	0
240607	1678	2880082820000	4107	2134	1	0	0
240608	1678	2880082821000	4108	2135	0	0	0
240609	1678	2880082822000	4109	2136	0	0	0
240610	1783	100000000	4109	2136	1	0	0
240616	1678	2880082824000	4115	2138	0	0	0
240617	1483	0	4116	2139	0	0	0
240618	1678	2880082825000	4116	2139	1	0	0
240721	1678	2880082791000	4117	2039	102	0	\N
240722	1678	2880082792000	4117	2039	103	0	\N
240723	1678	2880082793000	4117	2039	104	0	\N
240724	1678	2880082794000	4117	2039	105	0	\N
240725	1678	2880082795000	4117	2039	106	0	\N
240726	1678	2880082796000	4117	2039	107	0	\N
240727	1678	2880082797000	4117	2039	108	0	\N
240728	1678	2880082798000	4117	2039	109	0	\N
240729	1678	2880082799000	4117	2039	110	0	\N
240730	1678	2880082800000	4117	2039	111	0	\N
240731	1678	2880082801000	4117	2039	112	0	\N
240732	1678	2880082802000	4117	2039	114	0	\N
240733	1678	2880082803000	4117	2039	115	0	\N
240734	1678	2880082804000	4117	2039	116	0	\N
240735	1678	2880082805000	4117	2039	117	0	\N
240736	1678	2880082806000	4117	2039	118	0	\N
240737	1678	2880082807000	4117	2039	119	0	\N
240738	1678	2880082808000	4117	2039	120	0	\N
240739	1678	2880082809000	4117	2039	121	0	\N
240740	1678	2880082810000	4117	2039	122	0	\N
240741	1678	2880082811000	4117	2039	123	0	\N
240742	1678	2880082812000	4117	2039	124	0	\N
240743	1678	2880082813000	4117	2039	125	0	\N
240746	1678	2880082828000	4119	2141	0	0	\N
240747	1678	2880082829000	4119	2141	1	0	\N
240754	1678	2880082833000	4124	2144	0	0	\N
240755	1678	2880082833000	4125	2144	0	0	\N
240757	1678	2880082835000	4128	2147	0	0	\N
240758	1678	2880082836000	4128	2147	1	0	\N
240765	1678	2880082840000	4133	2150	0	0	\N
240767	1678	2880082841000	4135	2151	0	0	\N
240768	1678	2880082841000	4136	2151	0	0	\N
240770	1784	200000000	4138	2153	0	0	\N
240771	1785	200000000	4138	2153	1	0	\N
240772	1786	200000000	4138	2153	2	0	\N
240773	1787	200000000	4138	2153	3	0	\N
240774	1788	200000000	4138	2153	4	0	\N
240775	1789	0	4138	2153	5	0	\N
240776	1678	2880082843000	4138	2153	6	0	\N
240777	1678	2880082844000	4138	2153	7	0	\N
240778	1678	2880082845000	4138	2153	8	0	\N
240788	1678	2880082846000	4140	2154	0	0	\N
240789	1678	2880082847000	4140	2154	1	0	\N
240793	1678	2880082848000	4143	2155	0	0	\N
240794	1678	2880082848000	4144	2155	0	0	\N
240801	1678	2880082855000	4149	2160	0	0	\N
240802	1678	2880082855000	4150	2160	0	0	\N
240804	1678	2880082855000	4152	2160	0	0	\N
240805	1678	2880082855000	4153	2160	0	0	\N
240806	1678	2880082855000	4154	2160	0	0	\N
240810	1790	200000000	4157	2162	0	0	\N
240811	1678	2880082857000	4157	2162	1	0	\N
240813	1678	2880082858000	4159	2163	0	0	\N
240814	1678	2880082858000	4160	2163	0	0	\N
240816	1678	2880082860000	4162	2165	0	0	\N
240818	1789	3000000000	4164	2166	0	0	\N
240819	1678	2880082861000	4164	2166	1	0	\N
240822	1789	3000000000	4166	2166	0	0	\N
240823	1678	2880082861000	4166	2166	1	0	\N
240831	1678	2880082868000	4171	2171	0	0	\N
240834	1678	2880082869000	4174	2172	0	0	\N
240839	1678	2880082871000	4177	2174	0	0	\N
240840	1678	2880082872000	4177	2174	1	0	\N
240841	1678	2880082873000	4177	2174	2	0	\N
240846	1789	0	4180	2040	0	0	\N
240847	1789	3000000000	4180	2040	1	0	\N
240848	1789	713000000000	4180	2040	2	0	\N
240849	1678	2880082814000	4180	2040	3	0	\N
240850	1678	2880082815000	4180	2040	4	0	\N
240851	1678	2880082816000	4180	2040	5	0	\N
240852	1678	2880082817000	4180	2040	6	0	\N
240853	1678	2880082818000	4180	2040	7	0	\N
240854	1678	2880082819000	4180	2040	8	0	\N
240855	1678	2880082820000	4180	2040	9	0	\N
240856	1678	2880082821000	4180	2040	10	0	\N
240748	1678	2880082828000	4120	2141	0	0	0
240749	1678	2880082829000	4120	2141	1	0	0
240750	1678	2880082830000	4121	2142	0	0	0
240751	1678	2880082831000	4122	2143	0	0	0
240752	1678	2880082832000	4122	2143	1	0	0
240756	1678	2880082834000	4126	2145	0	0	0
240759	1678	2880082835000	4129	2147	0	0	0
240760	1678	2880082836000	4129	2147	1	0	0
240761	1678	2880082837000	4130	2148	0	0	0
240762	1678	2880082838000	4130	2148	1	0	0
240764	1678	2880082840000	4132	2150	0	0	0
240766	1678	2880082841000	4134	2151	0	0	0
240769	1678	2880082842000	4137	2152	0	0	0
240779	1784	200000000	4139	2153	0	0	0
240781	1786	200000000	4139	2153	2	0	0
240782	1787	200000000	4139	2153	3	0	0
240783	1788	200000000	4139	2153	4	0	0
240784	1789	0	4139	2153	5	0	0
240785	1678	2880082843000	4139	2153	6	0	0
240787	1678	2880082845000	4139	2153	8	0	0
240790	1678	2880082846000	4141	2154	0	0	0
240791	1678	2880082847000	4141	2154	1	0	0
240792	1678	2880082848000	4142	2155	0	0	0
240795	1678	2880082849000	4145	2156	0	0	0
240797	1678	2880082851000	4146	2157	0	0	0
240798	1678	2880082852000	4147	2158	0	0	0
240799	1678	2880082853000	4147	2158	1	0	0
240800	1678	2880082854000	4148	2159	0	0	0
240807	1678	2880082856000	4155	2161	0	0	0
240808	1790	200000000	4156	2162	0	0	0
240809	1678	2880082857000	4156	2162	1	0	0
240812	1678	2880082858000	4158	2163	0	0	0
240815	1678	2880082859000	4161	2164	0	0	0
240820	1789	3000000000	4165	2166	0	0	0
240821	1678	2880082861000	4165	2166	1	0	0
240824	1678	2880082862000	4167	2167	0	0	0
240825	1678	2880082863000	4168	2168	0	0	0
240826	1678	2880082864000	4168	2168	1	0	0
240828	1521	1437080000000	4168	2168	3	0	1
240829	1678	2880082866000	4169	2169	0	0	0
240830	1678	2880082867000	4170	2170	0	0	0
240832	1678	2880082868000	4172	2171	0	0	0
240835	1678	2880082870000	4175	2173	0	0	0
240836	1678	2880082871000	4176	2174	0	0	0
240837	1678	2880082872000	4176	2174	1	0	0
240838	1678	2880082873000	4176	2174	2	0	0
240842	1789	713000000000	4178	2175	0	0	0
240844	1678	2880082875000	4179	2176	0	0	0
240845	1483	0	4179	2176	1	0	0
240857	1678	2880082822000	4180	2040	11	0	\N
240858	1678	2880082823000	4180	2040	12	0	\N
240859	1678	2880082824000	4180	2040	13	0	\N
240860	1678	2880082825000	4180	2040	14	0	\N
240861	1678	2880082826000	4180	2040	15	0	\N
240862	1678	2880082827000	4180	2040	16	0	\N
240863	1678	2880082828000	4180	2040	17	0	\N
240864	1678	2880082829000	4180	2040	18	0	\N
240865	1678	2880082830000	4180	2040	19	0	\N
240866	1678	2880082831000	4180	2040	20	0	\N
240867	1678	2880082832000	4180	2040	21	0	\N
240868	1678	2880082833000	4180	2040	22	0	\N
240869	1678	2880082834000	4180	2040	23	0	\N
240870	1678	2880082835000	4180	2040	24	0	\N
240871	1678	2880082836000	4180	2040	25	0	\N
240872	1678	2880082837000	4180	2040	26	0	\N
240873	1678	2880082838000	4180	2040	27	0	\N
240874	1678	2880082839000	4180	2040	28	0	\N
240875	1678	2880082840000	4180	2040	29	0	\N
240876	1678	2880082841000	4180	2040	30	0	\N
240877	1678	2880082842000	4180	2040	31	0	\N
240878	1678	2880082843000	4180	2040	32	0	\N
240879	1678	2880082844000	4180	2040	33	0	\N
240880	1678	2880082845000	4180	2040	34	0	\N
240881	1678	2880082846000	4180	2040	35	0	\N
240882	1678	2880082847000	4180	2040	36	0	\N
240883	1678	2880082848000	4180	2040	37	0	\N
240884	1678	2880082849000	4180	2040	38	0	\N
240885	1678	2880082850000	4180	2040	39	0	\N
240886	1678	2880082851000	4180	2040	40	0	\N
240887	1678	2880082852000	4180	2040	41	0	\N
240888	1678	2880082853000	4180	2040	42	0	\N
240889	1678	2880082854000	4180	2040	43	0	\N
240890	1678	2880082855000	4180	2040	44	0	\N
240891	1678	2880082856000	4180	2040	45	0	\N
240892	1678	2880082857000	4180	2040	46	0	\N
240893	1678	2880082858000	4180	2040	47	0	\N
240894	1678	2880082859000	4180	2040	48	0	\N
240895	1678	2880082860000	4180	2040	49	0	\N
240896	1678	2880082861000	4180	2040	50	0	\N
240897	1678	2880082862000	4180	2040	51	0	\N
240898	1678	2880082863000	4180	2040	52	0	\N
240899	1678	2880082864000	4180	2040	53	0	\N
240900	1678	2880082865000	4180	2040	54	0	\N
240901	1678	2880082866000	4180	2040	55	0	\N
240902	1678	2880082867000	4180	2040	56	0	\N
240903	1678	2880082868000	4180	2040	57	0	\N
240904	1678	2880082869000	4180	2040	58	0	\N
240905	1678	2880082870000	4180	2040	59	0	\N
240906	1678	2880082871000	4180	2040	60	0	\N
240907	1678	2880082872000	4180	2040	61	0	\N
240908	1678	2880082873000	4180	2040	62	0	\N
240909	1678	2880082874000	4180	2040	63	0	\N
240910	1678	2880082875000	4180	2040	64	0	\N
240911	1749	5755089000000	4180	2040	65	0	\N
240912	1726	1000100000000	4180	2040	66	0	\N
240913	1652	490000000	4180	2040	67	0	\N
240914	1483	0	4180	2040	68	0	\N
240915	1652	490000000	4180	2040	69	0	\N
240916	1783	100000000	4180	2040	70	0	\N
240917	1652	490000000	4180	2040	71	0	\N
240918	1521	1437080000000	4180	2040	72	0	\N
240919	1652	490000000	4180	2040	73	0	\N
240922	1777	1000000000	4184	2058	0	0	\N
240923	1483	0	4184	2058	1	0	\N
240924	1789	0	4184	2058	2	0	\N
240925	1789	3000000000	4184	2058	3	0	\N
240926	1789	713000000000	4184	2058	4	0	\N
240927	1483	0	4184	2058	5	0	\N
240928	1783	100000000	4184	2058	6	0	\N
240929	44	71040180000000	4184	2058	7	0	\N
240930	1474	7914113000000	4184	2058	8	0	\N
240931	1521	1437080000000	4184	2058	9	0	\N
240935	1678	2880082877000	4186	2179	0	0	\N
240936	1678	2880082878000	4186	2179	1	0	\N
240937	1474	7914113000000	4186	2179	2	0	\N
240938	1791	200000000	4187	2180	0	0	\N
240939	1792	200000000	4187	2180	1	0	\N
240940	1678	2880082879000	4187	2180	2	0	\N
240941	1678	2880082880000	4187	2180	3	0	\N
240946	1678	2880082881000	4189	2181	0	0	\N
240947	1754	7996000000	4189	2181	1	0	\N
240950	1678	2880082882000	4191	2182	0	0	\N
240951	1678	2880082883000	4191	2182	1	0	\N
240960	1793	200000000	4194	2183	0	0	\N
240961	1406	0	4194	2183	1	0	\N
240962	1678	2880082884000	4194	2183	2	0	\N
240963	1678	2880082885000	4194	2183	3	0	\N
240964	1678	2880082886000	4194	2183	4	0	\N
240965	1406	0	4194	2183	5	0	\N
240967	1678	2880082888000	4196	2185	0	0	\N
240968	1678	2880082889000	4196	2185	1	0	\N
240971	1794	200000000	4198	2186	0	0	\N
240972	1678	2880082890000	4198	2186	1	0	\N
240973	1678	2880082891000	4198	2186	2	0	\N
240974	1678	2880082892000	4198	2186	3	0	\N
240979	1678	2880082893000	4200	2187	0	0	\N
240980	1678	2880082893000	4201	2187	0	0	\N
240981	1678	2880082893000	4202	2187	0	0	\N
240988	1795	200000000	4205	2188	0	0	\N
240989	1678	2880082894000	4205	2188	1	0	\N
240990	1678	2880082895000	4205	2188	2	0	\N
240991	1678	2880082896000	4205	2188	3	0	\N
240992	1678	2880082897000	4205	2188	4	0	\N
240932	1678	2880082877000	4185	2179	0	0	0
240933	1678	2880082878000	4185	2179	1	0	0
240934	1474	7914113000000	4185	2179	2	0	3
240942	1791	200000000	4188	2180	0	0	0
240943	1792	200000000	4188	2180	1	0	0
240945	1678	2880082880000	4188	2180	3	0	0
240948	1678	2880082881000	4190	2181	0	0	0
240949	1754	7996000000	4190	2181	1	0	3
240952	1678	2880082882000	4192	2182	0	0	0
240953	1678	2880082883000	4192	2182	1	0	0
240955	1406	0	4193	2183	1	0	0
240956	1678	2880082884000	4193	2183	2	0	0
240957	1678	2880082885000	4193	2183	3	0	0
240958	1678	2880082886000	4193	2183	4	0	0
240966	1678	2880082887000	4195	2184	0	0	0
240969	1678	2880082888000	4197	2185	0	0	0
240970	1678	2880082889000	4197	2185	1	0	0
240975	1794	200000000	4199	2186	0	0	0
240976	1678	2880082890000	4199	2186	1	0	0
240978	1678	2880082892000	4199	2186	3	0	0
240982	1678	2880082893000	4203	2187	0	0	0
240983	1795	200000000	4204	2188	0	0	0
240984	1678	2880082894000	4204	2188	1	0	0
240985	1678	2880082895000	4204	2188	2	0	0
240987	1678	2880082897000	4204	2188	4	0	0
240993	1678	2880082894000	4206	2188	0	0	\N
240994	1678	2880082895000	4206	2188	1	0	\N
240996	1678	2880082899000	4208	2190	0	0	\N
240998	1678	2880082900000	4210	2191	0	0	\N
240999	1678	2880082900000	4211	2191	0	0	\N
241001	1678	2880082901000	4213	2192	0	0	\N
241003	1678	2880082901000	4215	2192	0	0	\N
241004	1678	2880082901000	4216	2192	0	0	\N
241005	1678	2880082901000	4217	2192	0	0	\N
241006	1678	2880082901000	4218	2192	0	0	\N
241007	1678	2880082902000	4219	2193	0	0	\N
241008	1678	2880082902000	4220	2193	0	0	\N
241011	1678	2880082904000	4223	2195	0	0	\N
241012	1678	2880082905000	4223	2195	1	0	\N
241013	1678	2880082904000	4224	2195	0	0	\N
241014	1678	2880082905000	4224	2195	1	0	\N
241017	1406	0	4226	2059	0	0	\N
241018	1406	0	4226	2059	1	0	\N
241019	1754	7996000000	4226	2059	2	0	\N
241029	1678	2880082911000	4228	2197	0	0	\N
241031	1678	2880082911000	4230	2197	0	0	\N
241040	1796	200000000	4233	2199	0	0	\N
241041	1678	2880082915000	4233	2199	1	0	\N
241042	1678	2880082916000	4233	2199	2	0	\N
241043	1678	2880082917000	4233	2199	3	0	\N
241044	1678	2880082918000	4233	2199	4	0	\N
241045	1678	2880082919000	4234	2200	0	0	\N
241046	1678	2880082919000	4235	2200	0	0	\N
241049	1299	1696794610488650	4238	2060	0	0	\N
241050	1053	902470023242000	4238	2060	1	0	\N
241051	1173	608914357370000	4238	2060	2	0	\N
241052	933	503613163537300	4238	2060	3	0	\N
241053	1678	2880082920000	4239	2201	0	0	\N
241054	1678	2880082920000	4240	2201	0	0	\N
241055	1678	2880082920000	4241	2201	0	0	\N
241057	1678	2880082922000	4243	2203	0	0	\N
241059	1789	3000000000	4245	2163	0	0	\N
241060	1299	1696794610488650	4245	2163	1	0	\N
241061	1053	902470023242000	4245	2163	2	0	\N
241062	1173	608914357370000	4245	2163	3	0	\N
241063	933	503613163537300	4245	2163	4	0	\N
241064	1789	713000000000	4245	2163	5	0	\N
241065	1678	2880082858000	4245	2163	6	0	\N
241066	1678	2880082859000	4245	2163	7	0	\N
241067	1678	2880082860000	4245	2163	8	0	\N
241068	1678	2880082861000	4245	2163	10	0	\N
241069	1678	2880082862000	4245	2163	11	0	\N
241070	1678	2880082863000	4245	2163	12	0	\N
241071	1678	2880082864000	4245	2163	13	0	\N
241072	1678	2880082865000	4245	2163	14	0	\N
241073	1678	2880082866000	4245	2163	15	0	\N
241074	1678	2880082867000	4245	2163	16	0	\N
241075	1678	2880082868000	4245	2163	17	0	\N
241076	1678	2880082869000	4245	2163	18	0	\N
241077	1678	2880082870000	4245	2163	19	0	\N
241078	1678	2880082871000	4245	2163	20	0	\N
241079	1678	2880082872000	4245	2163	21	0	\N
241080	1678	2880082873000	4245	2163	22	0	\N
241081	1678	2880082874000	4245	2163	23	0	\N
241082	1678	2880082875000	4245	2163	24	0	\N
241083	1678	2880082876000	4245	2163	25	0	\N
241084	1678	2880082877000	4245	2163	26	0	\N
241085	1678	2880082878000	4245	2163	27	0	\N
241086	1678	2880082879000	4245	2163	28	0	\N
241087	1678	2880082880000	4245	2163	29	0	\N
241088	1678	2880082881000	4245	2163	30	0	\N
241089	1678	2880082882000	4245	2163	31	0	\N
241090	1678	2880082883000	4245	2163	32	0	\N
241091	1678	2880082884000	4245	2163	33	0	\N
241092	1678	2880082885000	4245	2163	34	0	\N
241093	1678	2880082886000	4245	2163	35	0	\N
241094	1678	2880082887000	4245	2163	36	0	\N
241095	1678	2880082888000	4245	2163	37	0	\N
241096	1678	2880082889000	4245	2163	38	0	\N
241097	1678	2880082890000	4245	2163	39	0	\N
241098	1678	2880082891000	4245	2163	40	0	\N
241099	1678	2880082892000	4245	2163	41	0	\N
241100	1678	2880082893000	4245	2163	42	0	\N
241101	1678	2880082894000	4245	2163	43	0	\N
241102	1678	2880082895000	4245	2163	44	0	\N
241103	1678	2880082896000	4245	2163	45	0	\N
241104	1678	2880082897000	4245	2163	46	0	\N
241105	1678	2880082898000	4245	2163	47	0	\N
241106	1678	2880082899000	4245	2163	48	0	\N
241107	1678	2880082900000	4245	2163	49	0	\N
241108	1678	2880082901000	4245	2163	50	0	\N
241109	1678	2880082902000	4245	2163	51	0	\N
241110	1678	2880082903000	4245	2163	52	0	\N
241111	1678	2880082904000	4245	2163	53	0	\N
241112	1678	2880082905000	4245	2163	54	0	\N
241113	1678	2880082906000	4245	2163	55	0	\N
241114	1678	2880082907000	4245	2163	56	0	\N
241115	1678	2880082908000	4245	2163	57	0	\N
241116	1678	2880082909000	4245	2163	58	0	\N
241117	1678	2880082910000	4245	2163	59	0	\N
241118	1678	2880082911000	4245	2163	60	0	\N
241119	1678	2880082912000	4245	2163	61	0	\N
241120	1678	2880082913000	4245	2163	62	0	\N
241121	1678	2880082914000	4245	2163	63	0	\N
241122	1678	2880082915000	4245	2163	64	0	\N
241123	1678	2880082916000	4245	2163	66	0	\N
241124	1678	2880082917000	4245	2163	67	0	\N
241125	1678	2880082918000	4245	2163	68	0	\N
241126	1678	2880082919000	4245	2163	69	0	\N
241127	1678	2880082920000	4245	2163	70	0	\N
241128	1678	2880082921000	4245	2163	71	0	\N
241000	1678	2880082900000	4212	2191	0	0	0
241002	1678	2880082901000	4214	2192	0	0	0
241009	1678	2880082902000	4221	2193	0	0	0
241010	1678	2880082903000	4222	2194	0	0	0
241015	1678	2880082904000	4225	2195	0	0	0
241020	1299	1696794610488650	4227	2196	0	0	0
241021	1053	902470023242000	4227	2196	1	0	0
241022	1173	608914357370000	4227	2196	2	0	0
241023	933	503613163537300	4227	2196	3	0	0
241024	1678	2880082906000	4227	2196	4	0	0
241026	1678	2880082908000	4227	2196	6	0	0
241027	1678	2880082909000	4227	2196	7	0	0
241028	1678	2880082910000	4227	2196	8	0	0
241030	1678	2880082911000	4229	2197	0	0	0
241033	1678	2880082913000	4231	2198	1	0	0
241034	1678	2880082914000	4231	2198	2	0	0
241035	1796	200000000	4232	2199	0	0	0
241036	1678	2880082915000	4232	2199	1	0	0
241037	1678	2880082916000	4232	2199	2	0	0
241039	1678	2880082918000	4232	2199	4	0	0
241047	1678	2880082919000	4236	2200	0	0	0
241048	1678	2880082920000	4237	2201	0	0	0
241056	1678	2880082921000	4242	2202	0	0	0
241058	1678	2880082922000	4244	2203	0	0	0
241129	1678	2880082922000	4245	2163	72	0	\N
241130	1678	2880082923000	4245	2163	73	0	\N
241131	1483	0	4245	2163	74	0	\N
241132	44	71040180000000	4245	2163	75	0	\N
241133	1474	7914113000000	4245	2163	76	0	\N
241134	1406	0	4245	2163	77	0	\N
241135	1406	0	4245	2163	78	0	\N
241136	1754	7996000000	4245	2163	79	0	\N
241137	1521	1437080000000	4245	2163	80	0	\N
241142	1737	1300001100	4247	2204	0	0	\N
241143	1678	2880082923000	4247	2204	1	0	\N
241144	1678	2880082924000	4247	2204	2	0	\N
241145	1678	2880082925000	4247	2204	3	0	\N
241146	1737	1300001100	4248	2204	0	0	\N
241147	1678	2880082923000	4248	2204	1	0	\N
241148	1678	2880082924000	4248	2204	2	0	\N
241149	1678	2880082925000	4248	2204	3	0	\N
241150	1737	1300001100	4249	2204	0	0	\N
241151	1678	2880082923000	4249	2204	1	0	\N
241152	1678	2880082924000	4249	2204	2	0	\N
241153	1678	2880082925000	4249	2204	3	0	\N
241157	1678	2880082929000	4252	2207	0	0	\N
241158	1678	2880082930000	4252	2207	1	0	\N
241159	1678	2880082929000	4253	2207	0	0	\N
241160	1678	2880082930000	4253	2207	1	0	\N
241166	1678	2880082934000	4256	2209	0	0	\N
241167	1678	2880082934000	4257	2209	0	0	\N
241169	1678	2880082934000	4259	2209	0	0	\N
241172	1678	2880082935000	4262	2210	0	0	\N
241173	1678	2880082936000	4262	2210	2	0	\N
241174	1678	2880082935000	4263	2210	0	0	\N
241175	1678	2880082936000	4263	2210	2	0	\N
241176	1678	2880082936000	4264	2211	0	0	\N
241177	1678	2880082937000	4264	2211	1	0	\N
241178	1678	2880082937000	4265	2211	0	0	\N
241180	1678	2880082937000	4267	2212	0	0	\N
241182	1678	2880082938000	4269	2213	0	0	\N
241187	1797	200000000	4273	2217	0	0	\N
241188	1678	2880082943000	4273	2217	1	0	\N
241191	1797	200000000	4275	2217	0	0	\N
241192	1678	2880082943000	4275	2217	1	0	\N
241193	1737	1300001100	4276	2041	0	0	\N
241194	1299	1696794610488650	4276	2041	1	0	\N
241195	1053	902470023242000	4276	2041	2	0	\N
241196	1173	608914357370000	4276	2041	3	0	\N
241197	933	503613163537300	4276	2041	4	0	\N
241198	1678	2880082876000	4276	2041	6	0	\N
241199	1678	2880082877000	4276	2041	7	0	\N
241200	1678	2880082878000	4276	2041	8	0	\N
241201	1678	2880082879000	4276	2041	9	0	\N
241202	1678	2880082880000	4276	2041	10	0	\N
241203	1678	2880082881000	4276	2041	11	0	\N
241204	1678	2880082882000	4276	2041	12	0	\N
241205	1678	2880082883000	4276	2041	13	0	\N
241206	1678	2880082884000	4276	2041	14	0	\N
241207	1678	2880082885000	4276	2041	15	0	\N
241208	1678	2880082886000	4276	2041	16	0	\N
241209	1678	2880082887000	4276	2041	17	0	\N
241210	1678	2880082888000	4276	2041	18	0	\N
241211	1678	2880082889000	4276	2041	19	0	\N
241212	1678	2880082890000	4276	2041	20	0	\N
241213	1678	2880082891000	4276	2041	21	0	\N
241214	1678	2880082892000	4276	2041	22	0	\N
241215	1678	2880082893000	4276	2041	23	0	\N
241216	1678	2880082894000	4276	2041	24	0	\N
241217	1678	2880082895000	4276	2041	25	0	\N
241218	1678	2880082896000	4276	2041	26	0	\N
241219	1678	2880082897000	4276	2041	27	0	\N
241220	1678	2880082898000	4276	2041	28	0	\N
241221	1678	2880082899000	4276	2041	29	0	\N
241222	1678	2880082900000	4276	2041	30	0	\N
241223	1678	2880082901000	4276	2041	31	0	\N
241224	1678	2880082902000	4276	2041	32	0	\N
241225	1678	2880082903000	4276	2041	33	0	\N
241226	1678	2880082904000	4276	2041	34	0	\N
241227	1678	2880082905000	4276	2041	35	0	\N
241228	1678	2880082906000	4276	2041	36	0	\N
241229	1678	2880082907000	4276	2041	38	0	\N
241230	1678	2880082908000	4276	2041	39	0	\N
241231	1678	2880082909000	4276	2041	40	0	\N
241232	1678	2880082910000	4276	2041	41	0	\N
241233	1678	2880082911000	4276	2041	42	0	\N
241234	1678	2880082912000	4276	2041	43	0	\N
241235	1678	2880082913000	4276	2041	44	0	\N
241236	1678	2880082914000	4276	2041	45	0	\N
241237	1678	2880082915000	4276	2041	46	0	\N
241238	1678	2880082916000	4276	2041	47	0	\N
241239	1678	2880082917000	4276	2041	48	0	\N
241240	1678	2880082918000	4276	2041	49	0	\N
241241	1678	2880082919000	4276	2041	50	0	\N
241242	1678	2880082920000	4276	2041	51	0	\N
241243	1678	2880082921000	4276	2041	52	0	\N
241244	1678	2880082922000	4276	2041	53	0	\N
241245	1678	2880082923000	4276	2041	54	0	\N
241246	1678	2880082924000	4276	2041	55	0	\N
241247	1678	2880082925000	4276	2041	56	0	\N
241248	1678	2880082926000	4276	2041	57	0	\N
241249	1678	2880082927000	4276	2041	58	0	\N
241250	1678	2880082928000	4276	2041	59	0	\N
241251	1678	2880082929000	4276	2041	60	0	\N
241252	1678	2880082930000	4276	2041	61	0	\N
241253	1678	2880082931000	4276	2041	62	0	\N
241254	1678	2880082932000	4276	2041	63	0	\N
241255	1678	2880082933000	4276	2041	64	0	\N
241256	1678	2880082934000	4276	2041	65	0	\N
241257	1678	2880082935000	4276	2041	66	0	\N
241258	1678	2880082936000	4276	2041	67	0	\N
241259	1678	2880082937000	4276	2041	68	0	\N
241260	1678	2880082938000	4276	2041	69	0	\N
241261	1678	2880082939000	4276	2041	70	0	\N
241262	1678	2880082940000	4276	2041	71	0	\N
241263	1678	2880082941000	4276	2041	72	0	\N
241264	1678	2880082942000	4276	2041	73	0	\N
241140	1678	2880082924000	4246	2204	2	0	0
241141	1678	2880082925000	4246	2204	3	0	0
241154	1678	2880082926000	4250	2205	0	0	0
241155	1678	2880082927000	4250	2205	1	0	0
241156	1678	2880082928000	4251	2206	0	0	0
241162	1678	2880082930000	4254	2207	1	0	0
241163	1678	2880082931000	4255	2208	0	0	0
241164	1678	2880082932000	4255	2208	1	0	0
241165	1678	2880082933000	4255	2208	2	0	0
241168	1678	2880082934000	4258	2209	0	0	0
241171	1678	2880082936000	4261	2211	0	0	0
241179	1678	2880082937000	4266	2212	0	0	0
241181	1678	2880082938000	4268	2213	0	0	0
241183	1678	2880082939000	4270	2214	0	0	0
241185	1678	2880082941000	4271	2215	0	0	0
241186	1678	2880082942000	4272	2216	0	0	0
241189	1797	200000000	4274	2217	0	0	0
241190	1678	2880082943000	4274	2217	1	0	0
241265	1678	2880082943000	4276	2041	74	0	\N
241266	44	71040180000000	4276	2041	75	0	\N
241267	1474	7914113000000	4276	2041	76	0	\N
241268	1406	0	4276	2041	77	0	\N
241269	1406	0	4276	2041	78	0	\N
241270	1754	7996000000	4276	2041	79	0	\N
241271	1797	200000000	4277	2217	0	0	\N
241272	1678	2880082943000	4277	2217	1	0	\N
241273	1678	2880082944000	4277	2217	2	0	\N
241276	1678	2880082944000	4279	2218	0	0	\N
241277	1678	2880082945000	4279	2218	1	0	\N
241280	1678	2880082948000	4282	2221	0	0	\N
241285	1678	2880082949000	4285	2222	0	0	\N
241286	1678	2880082950000	4285	2222	1	0	\N
241287	1678	2880082951000	4285	2222	2	0	\N
241288	1678	2880082949000	4286	2222	0	0	\N
241289	1678	2880082950000	4286	2222	1	0	\N
241290	1678	2880082951000	4286	2222	2	0	\N
241291	1678	2880082949000	4287	2222	0	0	\N
241292	1678	2880082950000	4287	2222	1	0	\N
241293	1678	2880082951000	4287	2222	2	0	\N
241294	1678	2880082949000	4288	2222	0	0	\N
241295	1678	2880082950000	4288	2222	1	0	\N
241296	1678	2880082951000	4288	2222	2	0	\N
241304	1678	2880082957000	4295	2228	0	0	\N
241305	1678	2880082958000	4296	2229	0	0	\N
241309	1678	2880082960000	4303	2231	0	0	\N
241313	1777	1000000000	4306	1996	0	0	\N
241314	1737	1300001100	4306	1996	1	0	\N
241315	1299	1696794610488650	4306	1996	3	0	\N
241316	1053	902470023242000	4306	1996	4	0	\N
241317	329	66718800000000	4306	1996	5	0	\N
241318	175	66000000000000	4306	1996	6	0	\N
241319	1173	608914357370000	4306	1996	7	0	\N
241320	933	503613163537300	4306	1996	8	0	\N
241321	1483	0	4306	1996	9	0	\N
241322	1789	0	4306	1996	10	0	\N
241323	1789	3000000000	4306	1996	11	0	\N
241324	1789	713000000000	4306	1996	12	0	\N
241325	1678	2880082634000	4306	1996	13	0	\N
241326	1678	2880082635000	4306	1996	15	0	\N
241327	1678	2880082636000	4306	1996	16	0	\N
241328	1678	2880082637000	4306	1996	17	0	\N
241329	1678	2880082638000	4306	1996	18	0	\N
241330	1678	2880082639000	4306	1996	19	0	\N
241331	1678	2880082640000	4306	1996	20	0	\N
241332	1678	2880082641000	4306	1996	21	0	\N
241333	1678	2880082642000	4306	1996	22	0	\N
241334	1678	2880082643000	4306	1996	23	0	\N
241335	1678	2880082644000	4306	1996	24	0	\N
241336	1678	2880082645000	4306	1996	25	0	\N
241337	1678	2880082646000	4306	1996	26	0	\N
241338	1678	2880082647000	4306	1996	27	0	\N
241339	1678	2880082648000	4306	1996	28	0	\N
241340	1678	2880082649000	4306	1996	29	0	\N
241341	1678	2880082650000	4306	1996	30	0	\N
241342	1678	2880082651000	4306	1996	31	0	\N
241343	1678	2880082652000	4306	1996	32	0	\N
241344	1678	2880082653000	4306	1996	33	0	\N
241345	1678	2880082654000	4306	1996	34	0	\N
241346	1678	2880082655000	4306	1996	35	0	\N
241347	1678	2880082656000	4306	1996	36	0	\N
241348	1678	2880082657000	4306	1996	37	0	\N
241349	1678	2880082658000	4306	1996	38	0	\N
241350	1678	2880082659000	4306	1996	39	0	\N
241351	1678	2880082660000	4306	1996	40	0	\N
241352	1678	2880082661000	4306	1996	41	0	\N
241353	1678	2880082662000	4306	1996	42	0	\N
241354	1678	2880082663000	4306	1996	43	0	\N
241355	1678	2880082664000	4306	1996	44	0	\N
241356	1678	2880082665000	4306	1996	45	0	\N
241357	1678	2880082666000	4306	1996	46	0	\N
241358	1678	2880082667000	4306	1996	47	0	\N
241359	1678	2880082668000	4306	1996	48	0	\N
241360	1678	2880082669000	4306	1996	49	0	\N
241361	1678	2880082670000	4306	1996	50	0	\N
241362	1678	2880082671000	4306	1996	51	0	\N
241363	1678	2880082672000	4306	1996	52	0	\N
241364	1678	2880082673000	4306	1996	53	0	\N
241365	1678	2880082674000	4306	1996	54	0	\N
241366	1678	2880082675000	4306	1996	55	0	\N
241367	1678	2880082676000	4306	1996	56	0	\N
241368	1678	2880082677000	4306	1996	57	0	\N
241369	1678	2880082678000	4306	1996	58	0	\N
241370	1678	2880082679000	4306	1996	59	0	\N
241371	1678	2880082680000	4306	1996	60	0	\N
241372	1678	2880082681000	4306	1996	61	0	\N
241373	1678	2880082682000	4306	1996	62	0	\N
241374	1678	2880082683000	4306	1996	63	0	\N
241375	1678	2880082684000	4306	1996	64	0	\N
241376	1678	2880082685000	4306	1996	65	0	\N
241377	1678	2880082686000	4306	1996	66	0	\N
241378	1678	2880082687000	4306	1996	67	0	\N
241379	1678	2880082688000	4306	1996	68	0	\N
241380	1678	2880082689000	4306	1996	69	0	\N
241381	1678	2880082690000	4306	1996	70	0	\N
241382	1678	2880082691000	4306	1996	71	0	\N
241383	1678	2880082692000	4306	1996	72	0	\N
241384	1678	2880082693000	4306	1996	73	0	\N
241385	1678	2880082694000	4306	1996	74	0	\N
241386	1678	2880082695000	4306	1996	75	0	\N
241387	1678	2880082696000	4306	1996	76	0	\N
241388	1678	2880082697000	4306	1996	77	0	\N
241389	1678	2880082698000	4306	1996	78	0	\N
241390	1678	2880082699000	4306	1996	79	0	\N
241391	1678	2880082700000	4306	1996	80	0	\N
241392	1678	2880082701000	4306	1996	81	0	\N
241393	1678	2880082702000	4306	1996	82	0	\N
241394	1678	2880082703000	4306	1996	83	0	\N
241395	1678	2880082704000	4306	1996	84	0	\N
241396	1678	2880082705000	4306	1996	85	0	\N
241397	1678	2880082706000	4306	1996	86	0	\N
241398	1678	2880082707000	4306	1996	87	0	\N
241399	1678	2880082708000	4306	1996	88	0	\N
241400	1678	2880082709000	4306	1996	89	0	\N
241278	1678	2880082946000	4280	2219	0	0	0
241279	1678	2880082947000	4281	2220	0	0	0
241281	1678	2880082948000	4283	2221	0	0	0
241282	1678	2880082949000	4284	2222	0	0	0
241283	1678	2880082950000	4284	2222	1	0	0
241297	1678	2880082952000	4289	2223	0	0	0
241298	1678	2880082953000	4290	2224	0	0	0
241299	1678	2880082954000	4291	2225	0	0	0
241300	1678	2880082955000	4292	2226	0	0	0
241301	1798	200000000	4293	2227	0	0	0
241303	1678	2880082957000	4294	2228	0	0	0
241306	1678	2880082958000	4297	2229	0	0	0
241307	1799	200000000	4299	2230	0	0	0
241308	1678	2880082959000	4299	2230	1	0	0
241311	1800	200000000	4305	2232	0	0	0
241312	1678	2880082961000	4305	2232	1	0	0
241401	1678	2880082710000	4306	1996	90	0	\N
241402	1678	2880082711000	4306	1996	91	0	\N
241403	1678	2880082712000	4306	1996	92	0	\N
241404	1678	2880082713000	4306	1996	93	0	\N
241405	1678	2880082714000	4306	1996	94	0	\N
241406	1678	2880082715000	4306	1996	95	0	\N
241407	1678	2880082716000	4306	1996	96	0	\N
241408	1678	2880082717000	4306	1996	97	0	\N
241409	1678	2880082718000	4306	1996	98	0	\N
241410	1678	2880082719000	4306	1996	99	0	\N
241411	1678	2880082720000	4306	1996	100	0	\N
241412	1678	2880082721000	4306	1996	101	0	\N
241413	1678	2880082722000	4306	1996	102	0	\N
241414	1678	2880082723000	4306	1996	103	0	\N
241415	1678	2880082724000	4306	1996	104	0	\N
241416	1678	2880082725000	4306	1996	105	0	\N
241417	1678	2880082726000	4306	1996	106	0	\N
241418	1678	2880082727000	4306	1996	107	0	\N
241419	1678	2880082728000	4306	1996	108	0	\N
241420	1678	2880082729000	4306	1996	109	0	\N
241421	1678	2880082730000	4306	1996	110	0	\N
241422	1678	2880082731000	4306	1996	111	0	\N
241423	1678	2880082732000	4306	1996	112	0	\N
241424	1678	2880082733000	4306	1996	113	0	\N
241425	1678	2880082734000	4306	1996	114	0	\N
241426	1678	2880082735000	4306	1996	115	0	\N
241427	1678	2880082736000	4306	1996	116	0	\N
241428	1678	2880082737000	4306	1996	117	0	\N
241429	1678	2880082738000	4306	1996	118	0	\N
241430	1678	2880082739000	4306	1996	119	0	\N
241431	1678	2880082740000	4306	1996	120	0	\N
241432	1678	2880082741000	4306	1996	121	0	\N
241433	1678	2880082742000	4306	1996	122	0	\N
241434	1678	2880082743000	4306	1996	123	0	\N
241435	1678	2880082744000	4306	1996	124	0	\N
241436	1678	2880082745000	4306	1996	125	0	\N
241440	1678	2880082964000	4309	2235	0	0	\N
241444	1678	2880082965000	4313	2236	0	0	\N
241445	1678	2880082966000	4313	2236	1	0	\N
241446	1678	2880082965000	4314	2236	0	0	\N
241447	1678	2880082966000	4314	2236	1	0	\N
241451	1678	2880082970000	4316	2238	0	0	\N
241452	1678	2880082970000	4317	2238	0	0	\N
241454	1678	2880082971000	4319	2239	0	0	\N
241455	1678	2880082971000	4320	2239	0	0	\N
241459	1737	1300001100	4324	2061	0	0	\N
241460	636	66000100000000	4324	2061	1	0	\N
241463	1678	2880082976000	4326	2242	0	0	\N
241466	1678	2880082977000	4329	2243	0	0	\N
241467	1678	2880082977000	4330	2243	0	0	\N
241468	1678	2880082978000	4331	2244	0	0	\N
241474	1678	2880082983000	4338	2249	0	0	\N
241475	1678	2880082984000	4338	2249	1	0	\N
241476	1678	2880082985000	4338	2249	2	0	\N
241480	1678	2880082986000	4340	2250	0	0	\N
241482	1678	2880082986000	4342	2250	0	0	\N
241483	1678	2880082987000	4343	2251	0	0	\N
241484	1678	2880082987000	4344	2251	0	0	\N
241485	1758	1600400000	4345	2113	0	0	\N
241486	1777	1000000000	4345	2113	1	0	\N
241487	1737	1300001100	4345	2113	2	0	\N
241488	1299	1696794610488650	4345	2113	3	0	\N
241489	1053	902470023242000	4345	2113	4	0	\N
241490	329	66718800000000	4345	2113	5	0	\N
241491	1173	608914357370000	4345	2113	6	0	\N
241492	933	503613163537300	4345	2113	7	0	\N
241493	1782	200000000	4345	2113	8	0	\N
241494	1784	200000000	4345	2113	9	0	\N
241495	1785	200000000	4345	2113	10	0	\N
241496	1786	200000000	4345	2113	11	0	\N
241497	1787	200000000	4345	2113	12	0	\N
241498	1788	200000000	4345	2113	13	0	\N
241499	1790	200000000	4345	2113	14	0	\N
241500	1791	200000000	4345	2113	15	0	\N
241501	1792	200000000	4345	2113	16	0	\N
241502	1483	0	4345	2113	17	0	\N
241503	1789	0	4345	2113	18	0	\N
241504	1789	3000000000	4345	2113	19	0	\N
241505	1793	200000000	4345	2113	20	0	\N
241506	1794	200000000	4345	2113	21	0	\N
241507	1795	200000000	4345	2113	22	0	\N
241508	1796	200000000	4345	2113	23	0	\N
241509	1797	200000000	4345	2113	24	0	\N
241510	1798	200000000	4345	2113	25	0	\N
241511	1799	200000000	4345	2113	26	0	\N
241512	1800	200000000	4345	2113	27	0	\N
241513	1789	713000000000	4345	2113	28	0	\N
241514	636	66000100000000	4345	2113	30	0	\N
241515	1483	0	4345	2113	31	0	\N
241516	1783	100000000	4345	2113	32	0	\N
241517	44	71040180000000	4345	2113	33	0	\N
241518	1474	7914113000000	4345	2113	34	0	\N
241519	1406	0	4345	2113	35	0	\N
241520	1406	0	4345	2113	36	0	\N
241521	1754	7996000000	4345	2113	37	0	\N
241522	1521	1437080000000	4345	2113	38	0	\N
241524	1678	2880082746000	4347	1997	0	0	\N
241525	1678	2880082747000	4347	1997	1	0	\N
241526	1678	2880082748000	4347	1997	3	0	\N
241527	1678	2880082749000	4347	1997	4	0	\N
241528	1678	2880082750000	4347	1997	5	0	\N
241529	1678	2880082751000	4347	1997	6	0	\N
241530	1678	2880082752000	4347	1997	7	0	\N
241531	1678	2880082753000	4347	1997	8	0	\N
241532	1678	2880082754000	4347	1997	9	0	\N
241533	1678	2880082755000	4347	1997	10	0	\N
241534	1678	2880082756000	4347	1997	11	0	\N
241535	1678	2880082757000	4347	1997	12	0	\N
241536	636	66000100000000	4347	1997	13	0	\N
241439	636	66000100000000	4308	2234	1	0	0
241441	1678	2880082964000	4310	2235	0	0	0
241442	1678	2880082965000	4312	2236	0	0	0
241443	1678	2880082966000	4312	2236	1	0	0
241448	1678	2880082967000	4315	2237	0	0	0
241450	1678	2880082969000	4315	2237	2	0	0
241453	1678	2880082970000	4318	2238	0	0	0
241456	1678	2880082971000	4322	2239	0	0	0
241457	1678	2880082972000	4323	2240	0	0	0
241458	1678	2880082973000	4323	2240	1	0	0
241462	1678	2880082975000	4325	2241	1	0	0
241464	1678	2880082976000	4327	2242	0	0	0
241465	1678	2880082977000	4328	2243	0	0	0
241469	1678	2880082978000	4332	2244	0	0	0
241471	1678	2880082980000	4334	2246	0	0	0
241472	1678	2880082981000	4334	2246	1	0	0
241473	1678	2880082982000	4335	2247	0	0	0
241477	1678	2880082983000	4339	2249	0	0	0
241478	1678	2880082984000	4339	2249	1	0	0
241481	1678	2880082986000	4341	2250	0	0	0
241523	1678	2880082987000	4346	2251	0	0	0
241537	1678	2880082758000	4347	1997	14	0	\N
241538	1678	2880082759000	4347	1997	15	0	\N
241539	1678	2880082760000	4347	1997	16	0	\N
241540	1678	2880082761000	4347	1997	17	0	\N
241541	1678	2880082762000	4347	1997	18	0	\N
241542	1678	2880082763000	4347	1997	19	0	\N
241543	1678	2880082764000	4347	1997	20	0	\N
241544	1678	2880082765000	4347	1997	21	0	\N
241545	1678	2880082766000	4347	1997	22	0	\N
241546	1678	2880082767000	4347	1997	23	0	\N
241547	1678	2880082768000	4347	1997	24	0	\N
241548	1678	2880082769000	4347	1997	25	0	\N
241549	1678	2880082770000	4347	1997	26	0	\N
241550	1678	2880082771000	4347	1997	27	0	\N
241551	1678	2880082772000	4347	1997	28	0	\N
241552	1678	2880082773000	4347	1997	29	0	\N
241553	1678	2880082774000	4347	1997	30	0	\N
241554	1678	2880082775000	4347	1997	31	0	\N
241555	1678	2880082776000	4347	1997	32	0	\N
241556	1678	2880082777000	4347	1997	33	0	\N
241557	1678	2880082778000	4347	1997	34	0	\N
241558	1678	2880082779000	4347	1997	35	0	\N
241559	1678	2880082780000	4347	1997	36	0	\N
241560	1678	2880082781000	4347	1997	37	0	\N
241561	1678	2880082782000	4347	1997	38	0	\N
241562	1678	2880082783000	4347	1997	39	0	\N
241563	1678	2880082784000	4347	1997	40	0	\N
241564	1678	2880082785000	4347	1997	41	0	\N
241565	1678	2880082786000	4347	1997	42	0	\N
241566	1678	2880082787000	4347	1997	43	0	\N
241567	1678	2880082788000	4347	1997	44	0	\N
241568	1678	2880082789000	4347	1997	45	0	\N
241569	1678	2880082790000	4347	1997	46	0	\N
241570	1678	2880082791000	4347	1997	47	0	\N
241571	1678	2880082792000	4347	1997	48	0	\N
241572	1678	2880082793000	4347	1997	49	0	\N
241573	1678	2880082794000	4347	1997	50	0	\N
241574	1678	2880082795000	4347	1997	51	0	\N
241575	1678	2880082796000	4347	1997	52	0	\N
241576	1678	2880082797000	4347	1997	53	0	\N
241577	1678	2880082798000	4347	1997	54	0	\N
241578	1678	2880082799000	4347	1997	55	0	\N
241579	1678	2880082800000	4347	1997	56	0	\N
241580	1678	2880082801000	4347	1997	57	0	\N
241581	1678	2880082802000	4347	1997	58	0	\N
241582	1678	2880082803000	4347	1997	59	0	\N
241583	1678	2880082804000	4347	1997	60	0	\N
241584	1678	2880082805000	4347	1997	61	0	\N
241585	1678	2880082806000	4347	1997	62	0	\N
241586	1678	2880082807000	4347	1997	63	0	\N
241587	1678	2880082808000	4347	1997	64	0	\N
241588	1678	2880082809000	4347	1997	65	0	\N
241589	1678	2880082810000	4347	1997	66	0	\N
241590	1678	2880082811000	4347	1997	67	0	\N
241591	1678	2880082812000	4347	1997	68	0	\N
241592	1678	2880082813000	4347	1997	69	0	\N
241593	1678	2880082814000	4347	1997	70	0	\N
241594	1678	2880082815000	4347	1997	71	0	\N
241595	1678	2880082816000	4347	1997	72	0	\N
241596	1678	2880082817000	4347	1997	73	0	\N
241597	1678	2880082818000	4347	1997	74	0	\N
241598	1678	2880082819000	4347	1997	75	0	\N
241599	1678	2880082820000	4347	1997	76	0	\N
241600	1678	2880082821000	4347	1997	77	0	\N
241601	1678	2880082822000	4347	1997	78	0	\N
241602	1678	2880082823000	4347	1997	79	0	\N
241603	1678	2880082824000	4347	1997	80	0	\N
241604	1678	2880082825000	4347	1997	81	0	\N
241605	1678	2880082826000	4347	1997	82	0	\N
241606	1678	2880082827000	4347	1997	83	0	\N
241607	1678	2880082828000	4347	1997	84	0	\N
241608	1678	2880082829000	4347	1997	85	0	\N
241609	1678	2880082830000	4347	1997	86	0	\N
241610	1678	2880082831000	4347	1997	87	0	\N
241611	1678	2880082832000	4347	1997	88	0	\N
241612	1678	2880082833000	4347	1997	89	0	\N
241613	1678	2880082834000	4347	1997	90	0	\N
241614	1678	2880082835000	4347	1997	91	0	\N
241615	1678	2880082836000	4347	1997	92	0	\N
241616	1678	2880082837000	4347	1997	93	0	\N
241617	1678	2880082838000	4347	1997	94	0	\N
241618	1678	2880082839000	4347	1997	95	0	\N
241619	1678	2880082840000	4347	1997	96	0	\N
241620	1678	2880082841000	4347	1997	97	0	\N
241621	1678	2880082842000	4347	1997	98	0	\N
241622	1678	2880082843000	4347	1997	99	0	\N
241623	1678	2880082844000	4347	1997	100	0	\N
241624	1678	2880082845000	4347	1997	101	0	\N
241625	1678	2880082846000	4347	1997	102	0	\N
241626	1678	2880082847000	4347	1997	103	0	\N
241627	1678	2880082848000	4347	1997	104	0	\N
241628	1678	2880082849000	4347	1997	105	0	\N
241629	1678	2880082850000	4347	1997	106	0	\N
241630	1678	2880082851000	4347	1997	107	0	\N
241631	1678	2880082852000	4347	1997	108	0	\N
241632	1678	2880082853000	4347	1997	109	0	\N
241633	1678	2880082854000	4347	1997	110	0	\N
241634	1678	2880082855000	4347	1997	111	0	\N
241635	1678	2880082856000	4347	1997	112	0	\N
241636	1678	2880082857000	4347	1997	113	0	\N
241637	1678	2880082858000	4347	1997	114	0	\N
241638	1678	2880082859000	4347	1997	115	0	\N
241639	1678	2880082860000	4347	1997	116	0	\N
241640	1678	2880082861000	4347	1997	117	0	\N
241641	1678	2880082862000	4347	1997	118	0	\N
241642	1678	2880082863000	4347	1997	119	0	\N
241643	1678	2880082864000	4347	1997	120	0	\N
241644	1678	2880082865000	4347	1997	121	0	\N
241645	1678	2880082866000	4347	1997	122	0	\N
241646	1678	2880082867000	4347	1997	123	0	\N
241647	1678	2880082868000	4347	1997	124	0	\N
241648	1678	2880082869000	4347	1997	125	0	\N
241658	1678	2880082996000	4353	2255	0	0	\N
241663	1678	2880082999000	4357	2258	0	0	\N
241665	1678	2880083000000	4359	2259	0	0	\N
241670	1678	2880083004000	4363	2263	0	0	\N
241671	1678	2880083005000	4363	2263	1	0	\N
241651	1678	2880082990000	4348	2252	2	0	0
241652	1678	2880082991000	4349	2253	0	0	0
241653	1678	2880082992000	4351	2254	0	0	0
241654	1678	2880082993000	4351	2254	1	0	0
241655	1678	2880082994000	4351	2254	2	0	0
241657	1678	2880082996000	4352	2255	0	0	0
241659	1802	200000000	4354	2256	0	0	0
241660	1678	2880082997000	4354	2256	1	0	0
241661	1678	2880082998000	4355	2257	0	0	0
241662	1678	2880082999000	4356	2258	0	0	0
241666	1803	200000000	4360	2260	0	0	0
241667	1678	2880083001000	4360	2260	1	0	0
241668	1678	2880083002000	4361	2261	0	0	0
241669	1678	2880083003000	4362	2262	0	0	0
241674	1678	2880083006000	4365	2264	0	0	\N
241676	1678	2880083006000	4367	2264	0	0	\N
241684	1678	2880083111000	4371	2267	0	0	\N
241686	1678	2880083112000	4374	2268	0	0	\N
241687	1678	2880083113000	4375	2269	0	0	\N
241688	1678	2880083113000	4376	2269	0	0	\N
241693	1678	2880083117000	4381	2273	0	0	\N
241694	1678	2880083117000	4382	2273	0	0	\N
241695	1678	2880083117000	4383	2273	0	0	\N
241697	1678	2880083118000	4385	2274	0	0	\N
241700	1798	200000000	4388	2223	0	0	\N
241701	1799	200000000	4388	2223	1	0	\N
241702	1800	200000000	4388	2223	2	0	\N
241703	1802	200000000	4388	2223	3	0	\N
241704	1803	200000000	4388	2223	4	0	\N
241705	1678	2880082952000	4388	2223	5	0	\N
241706	1678	2880083052000	4388	2223	6	0	\N
241707	1678	2880083053000	4388	2223	7	0	\N
241708	1678	2880083054000	4388	2223	8	0	\N
241709	1678	2880083055000	4388	2223	9	0	\N
241710	1678	2880083056000	4388	2223	10	0	\N
241711	1678	2880083057000	4388	2223	11	0	\N
241712	1678	2880083058000	4388	2223	12	0	\N
241713	1678	2880083059000	4388	2223	13	0	\N
241714	1678	2880083060000	4388	2223	14	0	\N
241715	1678	2880083061000	4388	2223	15	0	\N
241716	1678	2880083062000	4388	2223	16	0	\N
241717	1678	2880083063000	4388	2223	17	0	\N
241718	1678	2880083064000	4388	2223	18	0	\N
241719	1678	2880083065000	4388	2223	19	0	\N
241720	1678	2880083066000	4388	2223	20	0	\N
241721	1678	2880083067000	4388	2223	21	0	\N
241722	1407	0	4388	2223	22	0	\N
241723	1678	2880083068000	4388	2223	24	0	\N
241724	1678	2880083069000	4388	2223	25	0	\N
241725	1678	2880083070000	4388	2223	26	0	\N
241726	1678	2880083071000	4388	2223	27	0	\N
241727	1678	2880083072000	4388	2223	28	0	\N
241728	1678	2880083073000	4388	2223	29	0	\N
241729	1678	2880083074000	4388	2223	30	0	\N
241730	1678	2880083075000	4388	2223	31	0	\N
241731	1678	2880083076000	4388	2223	32	0	\N
241732	1678	2880083077000	4388	2223	33	0	\N
241733	1678	2880083078000	4388	2223	34	0	\N
241734	636	66000100000000	4388	2223	35	0	\N
241735	1678	2880083079000	4388	2223	36	0	\N
241736	1678	2880083080000	4388	2223	37	0	\N
241737	1678	2880083081000	4388	2223	38	0	\N
241738	1678	2880083082000	4388	2223	39	0	\N
241739	1678	2880083083000	4388	2223	40	0	\N
241740	1678	2880083084000	4388	2223	41	0	\N
241741	1678	2880083085000	4388	2223	42	0	\N
241742	1678	2880083086000	4388	2223	43	0	\N
241743	1678	2880083087000	4388	2223	44	0	\N
241744	1678	2880083088000	4388	2223	45	0	\N
241745	1678	2880083089000	4388	2223	46	0	\N
241746	1678	2880083090000	4388	2223	47	0	\N
241747	1678	2880083091000	4388	2223	48	0	\N
241748	1678	2880083092000	4388	2223	49	0	\N
241749	1678	2880083093000	4388	2223	50	0	\N
241750	1678	2880083094000	4388	2223	51	0	\N
241751	1678	2880083095000	4388	2223	52	0	\N
241752	1678	2880083096000	4388	2223	53	0	\N
241753	1678	2880083097000	4388	2223	54	0	\N
241754	1678	2880083098000	4388	2223	55	0	\N
241755	1678	2880083099000	4388	2223	56	0	\N
241756	1678	2880083100000	4388	2223	57	0	\N
241757	1678	2880083101000	4388	2223	58	0	\N
241758	1678	2880083102000	4388	2223	59	0	\N
241759	1678	2880083103000	4388	2223	60	0	\N
241760	1678	2880083104000	4388	2223	61	0	\N
241761	1678	2880083105000	4388	2223	62	0	\N
241762	1678	2880083106000	4388	2223	63	0	\N
241763	1678	2880083107000	4388	2223	64	0	\N
241764	1678	2880083108000	4388	2223	65	0	\N
241765	1678	2880083109000	4388	2223	66	0	\N
241766	1678	2880083110000	4388	2223	67	0	\N
241767	1678	2880083111000	4388	2223	68	0	\N
241768	1678	2880083112000	4388	2223	69	0	\N
241769	1678	2880083113000	4388	2223	70	0	\N
241770	1678	2880083114000	4388	2223	71	0	\N
241771	1678	2880083115000	4388	2223	72	0	\N
241772	1678	2880083116000	4388	2223	73	0	\N
241773	1678	2880083117000	4388	2223	74	0	\N
241774	1678	2880083118000	4388	2223	75	0	\N
241775	1678	2880083119000	4388	2223	76	0	\N
241776	1388	1697107201851650	4389	2276	0	0	\N
241777	569	66153481816426	4389	2276	1	0	\N
241778	1678	2880083120000	4389	2276	2	0	\N
241786	1388	1697107201851650	4392	2275	0	0	\N
241787	569	66153481816426	4392	2275	1	0	\N
241788	745	2004650964107	4392	2275	2	0	\N
241789	225	66153481816426	4392	2275	3	0	\N
241790	1678	2880083119000	4392	2275	4	0	\N
241791	1678	2880083120000	4392	2275	5	0	\N
241792	1678	2880083121000	4392	2275	6	0	\N
241793	191	66153481816426	4392	2275	7	0	\N
241677	1678	2880083007000	4368	2265	0	0	0
241678	1678	2880083008000	4368	2265	1	0	0
241679	1678	2880083108000	4368	2265	2	0	0
241680	1407	0	4368	2265	3	0	0
241681	1678	2880083109000	4368	2265	4	0	0
241683	1678	2880083111000	4370	2267	0	0	0
241685	1678	2880083112000	4372	2268	0	0	0
241689	1678	2880083113000	4377	2269	0	0	0
241690	1678	2880083114000	4378	2270	0	0	0
241691	1678	2880083115000	4379	2271	0	0	0
241696	1678	2880083117000	4384	2273	0	0	0
241698	1678	2880083118000	4386	2274	0	0	0
241699	1678	2880083119000	4387	2275	0	0	0
241779	1388	1697107201851650	4390	2276	0	0	0
241781	1678	2880083120000	4390	2276	2	0	0
241782	745	2004650964107	4391	2277	0	0	0
241783	225	66153481816426	4391	2277	1	0	0
241784	1678	2880083121000	4391	2277	2	0	0
241785	191	66153481816426	4391	2277	3	0	0
241795	1262	609026510100000	4393	2278	1	0	0
241796	1678	2880083122000	4393	2278	2	0	0
241797	304	66153481816426	4393	2278	3	0	0
241798	373	66153481816426	4393	2278	4	0	0
241799	877	203265353117107	4393	2278	5	0	1
241801	309	66153481816426	4393	2278	7	0	0
241802	731	2004650964107	4393	2278	8	0	0
241803	275	66153481816426	4393	2278	9	0	0
241804	138	66153481816426	4393	2278	10	0	0
241806	205	66153481816426	4394	2279	0	0	0
241807	1022	503705963100000	4394	2279	1	0	0
241808	402	66153481816426	4394	2279	2	0	0
241817	205	66153481816426	4395	2279	0	0	\N
241818	1022	503705963100000	4395	2279	1	0	\N
241819	402	66153481816426	4395	2279	2	0	\N
241820	1678	2880083123000	4395	2279	3	0	\N
241821	397	66153481816426	4395	2279	4	0	\N
241822	205	66153481816426	4396	2279	0	0	\N
241823	1022	503705963100000	4396	2279	1	0	\N
241824	402	66153481816426	4396	2279	2	0	\N
241825	1678	2880083123000	4396	2279	3	0	\N
241826	397	66153481816426	4396	2279	4	0	\N
241827	690	66153481816426	4396	2279	5	0	\N
241828	894	307536427785643	4396	2279	7	0	\N
241829	106	66153481816426	4396	2279	8	0	\N
241830	534	66153481816426	4396	2279	9	0	\N
241831	5	6712573753375	4396	2279	10	0	\N
241832	339	66153481816426	4396	2279	11	0	\N
241833	1678	2880083124000	4397	2280	0	0	\N
241834	206	66153481816426	4397	2280	1	0	\N
241835	122	66153481816426	4397	2280	2	0	\N
241836	91	66153481816426	4397	2280	3	0	\N
241837	99	66153481816426	4397	2280	4	0	\N
241838	399	66153481816426	4397	2280	5	0	\N
241839	408	66153481816426	4397	2280	6	0	\N
241840	420	66153481816426	4397	2280	7	0	\N
241841	438	66153481816426	4397	2280	8	0	\N
241842	570	66153481816426	4397	2280	9	0	\N
241863	1678	2880083125000	4400	2281	0	0	\N
241864	105	66153481816426	4400	2281	1	0	\N
241865	910	503946947018047	4400	2281	2	0	\N
241866	322	66153481816426	4400	2281	3	0	\N
241867	29	7016278374459	4400	2281	4	0	\N
241868	92	66153481816426	4400	2281	5	0	\N
241869	89	66153481816426	4400	2281	6	0	\N
241870	146	66153481816426	4400	2281	7	0	\N
241871	251	66153481816426	4400	2281	8	0	\N
241872	500	66153481816426	4400	2281	9	0	\N
241873	1678	2880083125000	4401	2281	0	0	\N
241874	105	66153481816426	4401	2281	1	0	\N
241875	910	503946947018047	4401	2281	2	0	\N
241876	322	66153481816426	4401	2281	3	0	\N
241877	29	7016278374459	4401	2281	4	0	\N
241878	92	66153481816426	4401	2281	5	0	\N
241879	89	66153481816426	4401	2281	6	0	\N
241880	146	66153481816426	4401	2281	7	0	\N
241881	251	66153481816426	4401	2281	8	0	\N
241882	500	66153481816426	4401	2281	9	0	\N
241883	1678	2880083125000	4402	2281	0	0	\N
241884	105	66153481816426	4402	2281	1	0	\N
241885	910	503946947018047	4402	2281	2	0	\N
241886	322	66153481816426	4402	2281	3	0	\N
241887	29	7016278374459	4402	2281	4	0	\N
241888	92	66153481816426	4402	2281	5	0	\N
241889	89	66153481816426	4402	2281	6	0	\N
241890	146	66153481816426	4402	2281	7	0	\N
241891	251	66153481816426	4402	2281	8	0	\N
241892	500	66153481816426	4402	2281	9	0	\N
241903	395	66150451816426	4404	2282	0	0	\N
241904	1678	2880083126000	4404	2282	1	0	\N
241905	84	66153481816426	4404	2282	2	0	\N
241906	320	66153481816426	4404	2282	3	0	\N
241907	587	66153481816426	4404	2282	4	0	\N
241908	611	66153481816426	4404	2282	5	0	\N
241909	678	66153481816426	4404	2282	6	0	\N
241910	710	5011627410323	4404	2282	7	0	\N
241911	295	66153481816426	4404	2282	8	0	\N
241912	721	2004650964107	4404	2282	9	0	\N
241913	1678	2880083127000	4405	2283	0	0	\N
241914	392	66153481816426	4405	2283	1	0	\N
241915	560	66153481816426	4405	2283	2	0	\N
241916	194	66153481816426	4405	2283	3	0	\N
241917	252	66153481816426	4405	2283	4	0	\N
241918	150	66153481816426	4405	2283	5	0	\N
241919	450	66153481816426	4405	2283	6	0	\N
241920	653	66153481816426	4405	2283	7	0	\N
241921	421	66153481816426	4405	2283	8	0	\N
241931	1797	200000000	4407	2212	0	0	\N
241932	1798	200000000	4407	2212	1	0	\N
241933	1799	200000000	4407	2212	2	0	\N
241934	1800	200000000	4407	2212	3	0	\N
241935	1802	200000000	4407	2212	4	0	\N
241936	1803	200000000	4407	2212	5	0	\N
241937	1678	2880082938000	4407	2212	6	0	\N
241938	1678	2880083038000	4407	2212	7	0	\N
241939	1407	0	4407	2212	8	0	\N
241940	1678	2880083039000	4407	2212	9	0	\N
241941	1678	2880083040000	4407	2212	10	0	\N
241942	1678	2880083041000	4407	2212	11	0	\N
241943	1678	2880083042000	4407	2212	12	0	\N
241944	1678	2880083043000	4407	2212	13	0	\N
241811	690	66153481816426	4394	2279	5	0	0
241812	894	307536427785643	4394	2279	7	0	0
241813	106	66153481816426	4394	2279	8	0	0
241814	534	66153481816426	4394	2279	9	0	0
241815	5	6712573753375	4394	2279	10	0	0
241843	1678	2880083124000	4398	2280	0	0	0
241844	206	66153481816426	4398	2280	1	0	0
241845	122	66153481816426	4398	2280	2	0	0
241846	91	66153481816426	4398	2280	3	0	0
241847	99	66153481816426	4398	2280	4	0	0
241849	408	66153481816426	4398	2280	6	0	0
241850	420	66153481816426	4398	2280	7	0	0
241851	438	66153481816426	4398	2280	8	0	0
241852	570	66153481816426	4398	2280	9	0	0
241854	105	66153481816426	4399	2281	1	0	0
241855	910	503946947018047	4399	2281	2	0	0
241856	322	66153481816426	4399	2281	3	0	0
241857	29	7016278374459	4399	2281	4	0	0
241858	92	66153481816426	4399	2281	5	0	0
241860	146	66153481816426	4399	2281	7	0	0
241861	251	66153481816426	4399	2281	8	0	0
241862	500	66153481816426	4399	2281	9	0	0
241893	395	66150451816426	4403	2282	0	0	1
241894	1678	2880083126000	4403	2282	1	0	0
241896	320	66153481816426	4403	2282	3	0	0
241897	587	66153481816426	4403	2282	4	0	0
241898	611	66153481816426	4403	2282	5	0	0
241899	678	66153481816426	4403	2282	6	0	0
241901	295	66153481816426	4403	2282	8	0	0
241902	721	2004650964107	4403	2282	9	0	0
241922	1678	2880083127000	4406	2283	0	0	0
241923	392	66153481816426	4406	2283	1	0	0
241924	560	66153481816426	4406	2283	2	0	0
241926	252	66153481816426	4406	2283	4	0	0
241927	150	66153481816426	4406	2283	5	0	0
241928	450	66153481816426	4406	2283	6	0	0
241929	653	66153481816426	4406	2283	7	0	0
241930	421	66153481816426	4406	2283	8	0	0
241945	1678	2880083044000	4407	2212	14	0	\N
241946	1678	2880083045000	4407	2212	15	0	\N
241947	1678	2880083046000	4407	2212	16	0	\N
241948	1678	2880083047000	4407	2212	17	0	\N
241949	1388	1697107201851650	4407	2212	19	0	\N
241950	1142	902636269100000	4407	2212	20	0	\N
241951	1262	609026510100000	4407	2212	21	0	\N
241952	1022	503705963100000	4407	2212	22	0	\N
241953	1678	2880083048000	4407	2212	23	0	\N
241954	1678	2880083049000	4407	2212	24	0	\N
241955	1678	2880083050000	4407	2212	25	0	\N
241956	1678	2880083051000	4407	2212	26	0	\N
241957	1678	2880083052000	4407	2212	27	0	\N
241958	1678	2880083053000	4407	2212	28	0	\N
241959	1678	2880083054000	4407	2212	29	0	\N
241960	1678	2880083055000	4407	2212	30	0	\N
241961	1678	2880083056000	4407	2212	31	0	\N
241962	1678	2880083057000	4407	2212	32	0	\N
241963	1678	2880083058000	4407	2212	33	0	\N
241964	1678	2880083059000	4407	2212	34	0	\N
241965	1678	2880083060000	4407	2212	35	0	\N
241966	1678	2880083061000	4407	2212	36	0	\N
241967	1678	2880083062000	4407	2212	37	0	\N
241968	1678	2880083063000	4407	2212	38	0	\N
241969	1678	2880083064000	4407	2212	39	0	\N
241970	1678	2880083065000	4407	2212	40	0	\N
241971	1678	2880083066000	4407	2212	41	0	\N
241972	1678	2880083067000	4407	2212	42	0	\N
241973	1678	2880083068000	4407	2212	43	0	\N
241974	1678	2880083069000	4407	2212	44	0	\N
241975	1678	2880083070000	4407	2212	45	0	\N
241976	1678	2880083071000	4407	2212	46	0	\N
241977	1678	2880083072000	4407	2212	47	0	\N
241978	1678	2880083073000	4407	2212	48	0	\N
241979	1678	2880083074000	4407	2212	49	0	\N
241980	1678	2880083075000	4407	2212	50	0	\N
241981	1678	2880083076000	4407	2212	51	0	\N
241982	1678	2880083077000	4407	2212	52	0	\N
241983	1678	2880083078000	4407	2212	53	0	\N
241984	636	66000100000000	4407	2212	54	0	\N
241985	569	66153481816426	4407	2212	55	0	\N
241986	745	2004650964107	4407	2212	56	0	\N
241987	225	66153481816426	4407	2212	57	0	\N
241988	191	66153481816426	4407	2212	58	0	\N
241989	304	66153481816426	4407	2212	59	0	\N
241990	373	66153481816426	4407	2212	60	0	\N
241991	877	203265353117107	4407	2212	61	0	\N
241992	217	66153481816426	4407	2212	62	0	\N
241993	309	66153481816426	4407	2212	63	0	\N
241994	731	2004650964107	4407	2212	64	0	\N
241995	275	66153481816426	4407	2212	65	0	\N
241996	138	66153481816426	4407	2212	66	0	\N
241997	1030	903068611238925	4407	2212	67	0	\N
241998	205	66153481816426	4407	2212	68	0	\N
241999	402	66153481816426	4407	2212	69	0	\N
242000	397	66153481816426	4407	2212	70	0	\N
242001	690	66153481816426	4407	2212	71	0	\N
242002	894	307536427785643	4407	2212	72	0	\N
242003	106	66153481816426	4407	2212	73	0	\N
242004	534	66153481816426	4407	2212	74	0	\N
242005	5	6712573753375	4407	2212	75	0	\N
242006	339	66153481816426	4407	2212	76	0	\N
242007	206	66153481816426	4407	2212	77	0	\N
242008	122	66153481816426	4407	2212	78	0	\N
242009	91	66153481816426	4407	2212	79	0	\N
242010	99	66153481816426	4407	2212	80	0	\N
242011	399	66153481816426	4407	2212	81	0	\N
242012	408	66153481816426	4407	2212	82	0	\N
242013	420	66153481816426	4407	2212	83	0	\N
242014	438	66153481816426	4407	2212	84	0	\N
242015	570	66153481816426	4407	2212	85	0	\N
242016	105	66153481816426	4407	2212	86	0	\N
242017	910	503946947018047	4407	2212	87	0	\N
242018	322	66153481816426	4407	2212	88	0	\N
242019	29	7016278374459	4407	2212	89	0	\N
242020	92	66153481816426	4407	2212	90	0	\N
242021	1678	2880083079000	4407	2212	91	0	\N
242022	1678	2880083080000	4407	2212	92	0	\N
242023	1678	2880083081000	4407	2212	93	0	\N
242024	1678	2880083082000	4407	2212	94	0	\N
242025	1678	2880083083000	4407	2212	95	0	\N
242026	1678	2880083084000	4407	2212	96	0	\N
242027	1678	2880083085000	4407	2212	97	0	\N
242028	1678	2880083086000	4407	2212	98	0	\N
242029	1678	2880083087000	4407	2212	99	0	\N
242030	1678	2880083088000	4407	2212	100	0	\N
242031	1678	2880083089000	4407	2212	101	0	\N
242032	1678	2880083090000	4407	2212	102	0	\N
242033	1678	2880083091000	4407	2212	103	0	\N
242034	1678	2880083092000	4407	2212	104	0	\N
242035	1678	2880083093000	4407	2212	105	0	\N
242036	1678	2880083094000	4407	2212	106	0	\N
242037	1678	2880083095000	4407	2212	107	0	\N
242038	1678	2880083096000	4407	2212	108	0	\N
242039	1678	2880083097000	4407	2212	109	0	\N
242040	1678	2880083098000	4407	2212	110	0	\N
242041	1678	2880083099000	4407	2212	111	0	\N
242042	1678	2880083100000	4407	2212	112	0	\N
242043	1678	2880083101000	4407	2212	113	0	\N
242044	1678	2880083102000	4407	2212	114	0	\N
242045	1678	2880083103000	4407	2212	115	0	\N
242046	1678	2880083104000	4407	2212	116	0	\N
242047	1678	2880083105000	4407	2212	117	0	\N
242048	1678	2880083106000	4407	2212	118	0	\N
242049	1678	2880083107000	4407	2212	119	0	\N
242050	1678	2880083108000	4407	2212	120	0	\N
242051	1678	2880083109000	4407	2212	121	0	\N
242052	1678	2880083110000	4407	2212	123	0	\N
242053	1678	2880083111000	4407	2212	124	0	\N
242054	1678	2880083112000	4407	2212	125	0	\N
242057	520	66153481816426	4408	2284	2	0	0
242058	620	66153481816426	4408	2284	3	0	0
242059	37	65479919092470	4408	2284	4	0	0
242060	622	66156461816426	4408	2284	5	0	1
242061	54	66153481816426	4408	2284	6	0	0
242063	594	66153481816426	4408	2284	8	0	0
242064	739	10023254820647	4408	2284	9	0	0
242065	163	66153481816426	4409	2285	0	0	0
242066	1678	2880083129000	4409	2285	1	0	0
242067	1150	609318386916143	4409	2285	2	0	0
242069	193	66153481816426	4409	2285	4	0	0
242070	391	66153481816426	4409	2285	5	0	0
242071	593	66153481816426	4409	2285	6	0	0
242072	660	66153481816426	4409	2285	7	0	0
242074	504	66153481816426	4409	2285	9	0	0
242075	658	66153481816426	4410	2286	0	0	0
242076	1276	1697919862712040	4410	2286	1	0	0
242077	180	66153481816426	4410	2286	2	0	0
242078	1678	2880083130000	4410	2286	3	0	0
242080	893	307536427785643	4410	2286	5	0	0
242085	1678	2880083131000	4411	2287	0	0	\N
242086	352	66153481816426	4411	2287	1	0	\N
242087	266	66153481816426	4411	2287	2	0	\N
242088	600	66153481816426	4411	2287	3	0	\N
242089	691	66153481816426	4411	2287	4	0	\N
242090	377	66153481816426	4411	2287	5	0	\N
242091	63	66153481816426	4411	2287	6	0	\N
242092	103	66153481816426	4411	2287	7	0	\N
242093	361	66153481816426	4411	2287	8	0	\N
242094	82	66153481816426	4411	2287	9	0	\N
242127	680	66153481816426	4415	2289	0	0	\N
242128	49	66153481816426	4415	2289	1	0	\N
242129	1678	2880083133000	4415	2289	2	0	\N
242130	1678	2880083134000	4415	2289	3	0	\N
242131	1678	2880083135000	4415	2289	4	0	\N
242132	1678	2880083136000	4415	2289	5	0	\N
242133	112	66153481816426	4415	2289	6	0	\N
242134	186	66153481816426	4415	2289	7	0	\N
242135	551	66153481816426	4415	2289	8	0	\N
242136	878	203266353117107	4415	2289	9	0	\N
242137	41	66153481816426	4415	2289	11	0	\N
242138	308	66153481816426	4415	2289	12	0	\N
242139	680	66153481816426	4416	2289	0	0	\N
242140	49	66153481816426	4416	2289	1	0	\N
242141	1678	2880083133000	4416	2289	2	0	\N
242142	1678	2880083134000	4416	2289	3	0	\N
242143	1678	2880083135000	4416	2289	4	0	\N
242144	1678	2880083136000	4416	2289	5	0	\N
242145	112	66153481816426	4416	2289	6	0	\N
242146	186	66153481816426	4416	2289	7	0	\N
242147	551	66153481816426	4416	2289	8	0	\N
242148	878	203266353117107	4416	2289	9	0	\N
242149	41	66153481816426	4416	2289	11	0	\N
242150	308	66153481816426	4416	2289	12	0	\N
242159	1678	2880083137000	4419	2290	0	0	\N
242160	878	203266353117107	4419	2290	1	0	\N
242161	41	66153481816426	4419	2290	2	0	\N
242162	1678	2880083138000	4419	2290	3	0	\N
242163	308	66153481816426	4419	2290	4	0	\N
242164	237	66000100000000	4419	2290	5	0	\N
242165	44	71040180000000	4419	2290	6	0	\N
242166	44	71040180000000	4419	2290	8	0	\N
242172	1678	2880083140000	4422	2292	0	0	\N
242173	1678	2880083141000	4422	2292	1	0	\N
242175	1802	200000000	4424	2241	0	0	\N
242176	1803	200000000	4424	2241	1	0	\N
242177	1804	200000000	4424	2241	2	0	\N
242178	1805	200000000	4424	2241	3	0	\N
242179	1806	200000000	4424	2241	4	0	\N
242180	240	66001200000000	4424	2241	5	0	\N
242181	1807	200000000	4424	2241	6	0	\N
242182	1808	200000000	4424	2241	7	0	\N
242183	569	66153481816426	4424	2241	8	0	\N
242184	745	2004650964107	4424	2241	9	0	\N
242185	225	66153481816426	4424	2241	10	0	\N
242186	1678	2880083073000	4424	2241	11	0	\N
242187	1407	0	4424	2241	12	0	\N
242188	1388	1697107201851650	4424	2241	14	0	\N
242189	1142	902636269100000	4424	2241	15	0	\N
242190	1262	609026510100000	4424	2241	16	0	\N
242191	1022	503705963100000	4424	2241	17	0	\N
242192	191	66153481816426	4424	2241	18	0	\N
242193	304	66153481816426	4424	2241	19	0	\N
242194	373	66153481816426	4424	2241	20	0	\N
242195	877	203265353117107	4424	2241	21	0	\N
242199	1678	2880083145000	4427	2296	0	0	\N
242202	1678	2880083146000	4430	2297	0	0	\N
242203	1804	200000000	4431	2283	0	0	\N
242204	1805	200000000	4431	2283	1	0	\N
242205	1806	200000000	4431	2283	2	0	\N
242206	240	66001200000000	4431	2283	3	0	\N
242207	1807	200000000	4431	2283	4	0	\N
242208	1808	200000000	4431	2283	5	0	\N
242209	1678	2880083127000	4431	2283	6	0	\N
242210	1678	2880083128000	4431	2283	7	0	\N
242211	1678	2880083129000	4431	2283	8	0	\N
242212	1678	2880083130000	4431	2283	9	0	\N
242213	1678	2880083131000	4431	2283	10	0	\N
242214	1678	2880083132000	4431	2283	11	0	\N
242215	1678	2880083133000	4431	2283	12	0	\N
242216	1678	2880083134000	4431	2283	13	0	\N
242083	108	66153481816426	4410	2286	8	0	0
242084	601	66153481816426	4410	2286	9	0	0
242095	1678	2880083131000	4412	2287	0	0	0
242096	352	66153481816426	4412	2287	1	0	0
242097	266	66153481816426	4412	2287	2	0	0
242099	691	66153481816426	4412	2287	4	0	0
242100	377	66153481816426	4412	2287	5	0	0
242101	63	66153481816426	4412	2287	6	0	0
242102	103	66153481816426	4412	2287	7	0	0
242103	361	66153481816426	4412	2287	8	0	0
242105	1804	200000000	4413	2288	0	0	0
242106	1805	200000000	4413	2288	1	0	0
242107	1806	200000000	4413	2288	2	0	0
242108	240	66001200000000	4413	2288	3	0	0
242110	201	66153481816426	4413	2288	5	0	0
242111	1678	2880083132000	4413	2288	6	0	0
242112	453	66153481816426	4413	2288	7	0	0
242113	499	66153481816426	4413	2288	8	0	0
242114	35	19244649255674	4413	2288	9	0	0
242116	663	66153481816426	4413	2288	11	0	0
242117	127	66153481816426	4413	2288	12	0	0
242118	680	66153481816426	4414	2289	0	0	0
242119	49	66153481816426	4414	2289	1	0	0
242120	1678	2880083133000	4414	2289	2	0	0
242122	1678	2880083135000	4414	2289	4	0	0
242123	1678	2880083136000	4414	2289	5	0	0
242124	112	66153481816426	4414	2289	6	0	0
242125	186	66153481816426	4414	2289	7	0	0
242151	1678	2880083137000	4417	2290	0	0	0
242152	878	203266353117107	4417	2290	1	0	1
242153	41	66153481816426	4417	2290	2	0	0
242154	1678	2880083138000	4417	2290	3	0	0
242155	308	66153481816426	4417	2290	4	0	0
242157	44	71040180000000	4417	2290	6	0	0
242158	44	71040180000000	4417	2290	8	0	0
242167	1807	200000000	4420	2291	0	0	0
242168	1778	1000090000000	4420	2291	1	0	1
242169	1678	2880083139000	4420	2291	2	0	0
242171	1678	2880083141000	4421	2292	1	0	0
242174	1678	2880083142000	4423	2293	0	0	0
242196	1808	200000000	4425	2294	0	0	0
242197	1678	2880083143000	4425	2294	1	0	0
242200	1678	2880083145000	4428	2296	0	0	0
242201	1678	2880083146000	4429	2297	0	0	0
242217	1678	2880083135000	4431	2283	14	0	\N
242218	1678	2880083136000	4431	2283	15	0	\N
242219	1678	2880083137000	4431	2283	16	0	\N
242220	1678	2880083138000	4431	2283	17	0	\N
242221	1678	2880083139000	4431	2283	18	0	\N
242222	1678	2880083140000	4431	2283	19	0	\N
242223	1678	2880083141000	4431	2283	20	0	\N
242224	1678	2880083142000	4431	2283	21	0	\N
242225	1678	2880083143000	4431	2283	22	0	\N
242226	1678	2880083144000	4431	2283	23	0	\N
242227	1678	2880083145000	4431	2283	24	0	\N
242228	1678	2880083146000	4431	2283	25	0	\N
242229	44	71040180000000	4431	2283	26	0	\N
242230	44	71040180000000	4431	2283	28	0	\N
242231	1809	200000000	4432	2298	0	0	\N
242232	1678	2880083147000	4432	2298	1	0	\N
242233	1678	2880083148000	4432	2298	2	0	\N
242234	1537	0	4432	2298	3	0	\N
242239	1678	2880083149000	4434	2299	0	0	\N
242240	1678	2880083150000	4434	2299	1	0	\N
242243	1678	2880083149000	4436	2299	0	0	\N
242244	1678	2880083150000	4436	2299	1	0	\N
242247	1678	2880083151000	4438	2300	0	0	\N
242248	1678	2880083152000	4438	2300	1	0	\N
242250	1678	2880083154000	4440	2302	0	0	\N
242252	1810	200000000	4442	2303	0	0	\N
242253	1804	1400000000	4442	2303	1	0	\N
242254	1678	2880083155000	4442	2303	2	0	\N
242255	1811	100000000	4442	2303	3	0	\N
242256	1810	200000000	4443	2303	0	0	\N
242257	1804	1400000000	4443	2303	1	0	\N
242258	1678	2880083155000	4443	2303	2	0	\N
242259	1811	100000000	4443	2303	3	0	\N
242264	1678	2880083156000	4445	2304	0	0	\N
242265	1678	2880083156000	4446	2304	0	0	\N
242267	1678	2880083156000	4448	2304	0	0	\N
242268	1804	200000000	4449	2213	0	0	\N
242269	1805	200000000	4449	2213	1	0	\N
242270	1806	200000000	4449	2213	2	0	\N
242271	240	66001200000000	4449	2213	3	0	\N
242272	1807	200000000	4449	2213	4	0	\N
242273	1808	200000000	4449	2213	5	0	\N
242274	1809	200000000	4449	2213	6	0	\N
242275	1810	200000000	4449	2213	7	0	\N
242276	1804	1400000000	4449	2213	8	0	\N
242277	1678	2880083113000	4449	2213	9	0	\N
242278	1678	2880083114000	4449	2213	10	0	\N
242279	1678	2880083115000	4449	2213	11	0	\N
242280	1678	2880083116000	4449	2213	12	0	\N
242281	1678	2880083117000	4449	2213	13	0	\N
242282	1678	2880083118000	4449	2213	14	0	\N
242283	1678	2880083119000	4449	2213	15	0	\N
242284	1678	2880083120000	4449	2213	16	0	\N
242285	1678	2880083121000	4449	2213	17	0	\N
242286	1678	2880083122000	4449	2213	18	0	\N
242287	1678	2880083123000	4449	2213	19	0	\N
242288	1678	2880083124000	4449	2213	20	0	\N
242289	1678	2880083125000	4449	2213	21	0	\N
242290	1678	2880083126000	4449	2213	22	0	\N
242291	1678	2880083127000	4449	2213	23	0	\N
242292	1678	2880083156000	4450	2304	0	0	\N
242298	1678	2880083161000	4455	2309	0	0	\N
242299	1678	2880083161000	4456	2309	0	0	\N
242309	1796	200000000	4461	2193	0	0	\N
242310	1737	1300001100	4461	2193	1	0	\N
242311	1797	200000000	4461	2193	2	0	\N
242312	1798	200000000	4461	2193	3	0	\N
242313	1799	200000000	4461	2193	4	0	\N
242314	1800	200000000	4461	2193	5	0	\N
242315	1802	200000000	4461	2193	6	0	\N
242316	1803	200000000	4461	2193	7	0	\N
242317	1804	200000000	4461	2193	8	0	\N
242318	1805	200000000	4461	2193	9	0	\N
242319	1806	200000000	4461	2193	10	0	\N
242320	240	66001200000000	4461	2193	11	0	\N
242321	1807	200000000	4461	2193	12	0	\N
242322	1808	200000000	4461	2193	13	0	\N
242323	1809	200000000	4461	2193	14	0	\N
242324	1810	200000000	4461	2193	15	0	\N
242325	1804	1400000000	4461	2193	16	0	\N
242326	1813	200000000	4461	2193	17	0	\N
242327	1814	200000000	4461	2193	18	0	\N
242328	1815	200000000	4461	2193	19	0	\N
242329	1678	2880083001000	4461	2193	20	0	\N
242330	1407	0	4461	2193	21	0	\N
242331	1388	1697107201851650	4461	2193	23	0	\N
242332	1142	902636269100000	4461	2193	24	0	\N
242333	1262	609026510100000	4461	2193	25	0	\N
242334	1022	503705963100000	4461	2193	26	0	\N
242335	636	66000100000000	4461	2193	27	0	\N
242336	569	66153481816426	4461	2193	28	0	\N
242337	745	2004650964107	4461	2193	29	0	\N
242338	225	66153481816426	4461	2193	30	0	\N
242339	191	66153481816426	4461	2193	31	0	\N
242340	304	66153481816426	4461	2193	32	0	\N
242341	373	66153481816426	4461	2193	33	0	\N
242342	877	203265353117107	4461	2193	34	0	\N
242343	217	66153481816426	4461	2193	35	0	\N
242344	309	66153481816426	4461	2193	36	0	\N
242345	731	2004650964107	4461	2193	37	0	\N
242346	275	66153481816426	4461	2193	38	0	\N
242347	138	66153481816426	4461	2193	39	0	\N
242348	1030	903068611238925	4461	2193	40	0	\N
242349	205	66153481816426	4461	2193	41	0	\N
242350	402	66153481816426	4461	2193	42	0	\N
242351	397	66153481816426	4461	2193	43	0	\N
242352	690	66153481816426	4461	2193	44	0	\N
242237	1678	2880083148000	4433	2298	2	0	0
242238	1537	0	4433	2298	3	0	0
242241	1678	2880083149000	4435	2299	0	0	0
242242	1678	2880083150000	4435	2299	1	0	0
242245	1678	2880083151000	4437	2300	0	0	0
242249	1678	2880083153000	4439	2301	0	0	0
242251	1678	2880083154000	4441	2302	0	0	0
242260	1810	200000000	4444	2303	0	0	0
242261	1804	1400000000	4444	2303	1	0	0
242262	1678	2880083155000	4444	2303	2	0	0
242266	1678	2880083156000	4447	2304	0	0	0
242293	1678	2880083157000	4451	2305	0	0	0
242294	1678	2880083158000	4452	2306	0	0	0
242295	1678	2880083159000	4453	2307	0	0	0
242297	1678	2880083160000	4454	2308	0	0	0
242300	1678	2880083161000	4457	2309	0	0	0
242301	1813	200000000	4458	2310	0	0	0
242302	1678	2880083162000	4458	2310	1	0	0
242303	1678	2880083163000	4458	2310	2	0	0
242305	1814	200000000	4460	2312	0	0	0
242306	1815	200000000	4460	2312	1	0	0
242307	1678	2880083165000	4460	2312	2	0	0
242308	1483	0	4460	2312	3	0	0
242353	894	307536427785643	4461	2193	45	0	\N
242354	106	66153481816426	4461	2193	46	0	\N
242355	534	66153481816426	4461	2193	47	0	\N
242356	5	6712573753375	4461	2193	48	0	\N
242357	339	66153481816426	4461	2193	49	0	\N
242358	206	66153481816426	4461	2193	50	0	\N
242359	122	66153481816426	4461	2193	51	0	\N
242360	91	66153481816426	4461	2193	52	0	\N
242361	99	66153481816426	4461	2193	53	0	\N
242362	399	66153481816426	4461	2193	54	0	\N
242363	408	66153481816426	4461	2193	55	0	\N
242364	420	66153481816426	4461	2193	56	0	\N
242365	438	66153481816426	4461	2193	57	0	\N
242366	570	66153481816426	4461	2193	58	0	\N
242367	105	66153481816426	4461	2193	59	0	\N
242368	910	503946947018047	4461	2193	60	0	\N
242369	322	66153481816426	4461	2193	61	0	\N
242370	29	7016278374459	4461	2193	62	0	\N
242371	92	66153481816426	4461	2193	63	0	\N
242372	89	66153481816426	4461	2193	64	0	\N
242373	146	66153481816426	4461	2193	65	0	\N
242374	251	66153481816426	4461	2193	66	0	\N
242375	500	66153481816426	4461	2193	67	0	\N
242376	395	66150451816426	4461	2193	68	0	\N
242377	84	66153481816426	4461	2193	69	0	\N
242378	320	66153481816426	4461	2193	70	0	\N
242379	587	66153481816426	4461	2193	71	0	\N
242380	611	66153481816426	4461	2193	72	0	\N
242381	678	66153481816426	4461	2193	73	0	\N
242382	710	5011627410323	4461	2193	74	0	\N
242383	295	66153481816426	4461	2193	76	0	\N
242384	721	2004650964107	4461	2193	77	0	\N
242385	392	66153481816426	4461	2193	78	0	\N
242386	560	66153481816426	4461	2193	79	0	\N
242387	194	66153481816426	4461	2193	80	0	\N
242388	252	66153481816426	4461	2193	81	0	\N
242389	150	66153481816426	4461	2193	82	0	\N
242390	450	66153481816426	4461	2193	83	0	\N
242391	653	66153481816426	4461	2193	84	0	\N
242392	421	66153481816426	4461	2193	85	0	\N
242393	245	66153481816426	4461	2193	86	0	\N
242394	520	66153481816426	4461	2193	87	0	\N
242395	620	66153481816426	4461	2193	88	0	\N
242396	37	65479919092470	4461	2193	89	0	\N
242397	622	66156461816426	4461	2193	90	0	\N
242398	54	66153481816426	4461	2193	91	0	\N
242399	78	66153481816426	4461	2193	92	0	\N
242400	594	66153481816426	4461	2193	93	0	\N
242401	739	10023254820647	4461	2193	94	0	\N
242402	163	66153481816426	4461	2193	95	0	\N
242403	1150	609318386916143	4461	2193	96	0	\N
242404	452	66153481816426	4461	2193	97	0	\N
242405	193	66153481816426	4461	2193	98	0	\N
242406	391	66153481816426	4461	2193	99	0	\N
242407	593	66153481816426	4461	2193	100	0	\N
242408	660	66153481816426	4461	2193	101	0	\N
242409	6	32633713045112	4461	2193	102	0	\N
242410	504	66153481816426	4461	2193	103	0	\N
242411	658	66153481816426	4461	2193	104	0	\N
242412	1276	1697919862712040	4461	2193	105	0	\N
242413	180	66153481816426	4461	2193	106	0	\N
242414	652	66153481816426	4461	2193	107	0	\N
242415	893	307536427785643	4461	2193	108	0	\N
242416	390	66153481816426	4461	2193	109	0	\N
242417	353	66153481816426	4461	2193	110	0	\N
242418	108	66153481816426	4461	2193	111	0	\N
242419	601	66153481816426	4461	2193	112	0	\N
242420	352	66153481816426	4461	2193	113	0	\N
242421	266	66153481816426	4461	2193	114	0	\N
242422	600	66153481816426	4461	2193	115	0	\N
242423	691	66153481816426	4461	2193	116	0	\N
242424	377	66153481816426	4461	2193	117	0	\N
242425	63	66153481816426	4461	2193	118	0	\N
242426	103	66153481816426	4461	2193	119	0	\N
242427	361	66153481816426	4461	2193	120	0	\N
242428	82	66153481816426	4461	2193	121	0	\N
242429	261	66153481816426	4461	2193	122	0	\N
242430	201	66153481816426	4461	2193	123	0	\N
242431	453	66153481816426	4461	2193	124	0	\N
242432	499	66153481816426	4461	2193	125	0	\N
242433	1678	2880083166000	4462	2313	0	0	\N
242434	1678	2880083166000	4463	2313	0	0	\N
242435	1678	2880083166000	4464	2313	0	0	\N
242437	1678	2880083167000	4466	2314	0	0	\N
242438	1678	2880083167000	4467	2314	0	0	\N
242446	96	66001200000000	4472	2317	0	0	\N
242447	1678	2880083171000	4472	2317	1	0	\N
242448	1678	2880083172000	4472	2317	2	0	\N
242455	1678	2880083178000	4474	2319	0	0	\N
242456	1678	2880083178000	4475	2319	0	0	\N
242458	1678	2880083179000	4477	2320	1	0	\N
242459	1678	2880083179000	4479	2321	2	0	\N
242460	1678	2880083180000	4479	2321	3	0	\N
242463	1678	2880083179000	4481	2321	2	0	\N
242464	1678	2880083179000	4482	2321	2	0	\N
242465	1678	2880083180000	4482	2321	3	0	\N
242466	1678	2880083181000	4483	2322	0	0	\N
242469	1678	2880083183000	4486	2324	0	0	\N
242473	1678	2880083185000	4490	2326	0	0	\N
242474	1678	2880083186000	4491	2327	0	0	\N
242475	1811	153090000000	4491	2327	1	0	\N
242476	1811	228090000000	4491	2327	2	0	\N
242477	1678	2880083186000	4492	2327	0	0	\N
242478	1811	153090000000	4492	2327	1	0	\N
242479	1811	228090000000	4492	2327	2	0	\N
242483	1678	2880083186000	4495	2327	0	0	\N
242484	1811	153090000000	4495	2327	1	0	\N
242485	1811	228090000000	4495	2327	2	0	\N
242486	1817	200000000	4496	2328	0	0	\N
242487	1811	251090000000	4496	2328	1	0	\N
242488	1678	2880083187000	4496	2328	2	0	\N
242440	1678	2880083168000	4469	2315	1	0	0
242441	1678	2880083169000	4469	2315	2	0	0
242442	1678	2880083170000	4470	2316	0	0	0
242443	96	66001200000000	4471	2317	0	0	0
242444	1678	2880083171000	4471	2317	1	0	0
242449	1816	100000000	4473	2318	0	0	0
242450	1678	2880083173000	4473	2318	1	0	0
242451	1678	2880083174000	4473	2318	2	0	0
242452	1678	2880083175000	4473	2318	3	0	0
242453	1678	2880083176000	4473	2318	4	0	0
242457	1678	2880083178000	4476	2319	0	0	0
242461	1678	2880083179000	4480	2321	2	0	0
242462	1678	2880083180000	4480	2321	3	0	0
242467	1678	2880083181000	4484	2322	0	0	0
242470	1678	2880083183000	4487	2324	0	0	0
242471	1678	2880083184000	4488	2325	0	0	0
242472	1678	2880083185000	4489	2326	0	0	0
242480	1678	2880083186000	4494	2327	0	0	0
242481	1811	153090000000	4494	2327	1	0	1
242489	1678	2880083188000	4496	2328	3	0	\N
242490	1811	266090000000	4496	2328	4	0	\N
242491	1817	200000000	4497	2328	0	0	\N
242492	1811	251090000000	4497	2328	1	0	\N
242493	1678	2880083187000	4497	2328	2	0	\N
242494	1678	2880083188000	4497	2328	3	0	\N
242495	1811	266090000000	4497	2328	4	0	\N
242501	1811	153090000000	4499	2326	0	0	\N
242502	1678	2880083185000	4499	2326	1	0	\N
242510	1678	2880083193000	4503	2331	0	0	\N
242511	1678	2880083194000	4503	2331	1	0	\N
242512	1678	2880083195000	4504	2332	0	0	\N
242514	1678	2880083195000	4506	2332	0	0	\N
242515	1678	2880083196000	4507	2333	0	0	\N
242516	1678	2880083196000	4508	2333	0	0	\N
242518	1678	2880083196000	4510	2333	0	0	\N
242519	1813	200000000	4511	2305	0	0	\N
242520	1814	200000000	4511	2305	1	0	\N
242521	1815	200000000	4511	2305	2	0	\N
242522	96	66001200000000	4511	2305	3	0	\N
242523	1817	200000000	4511	2305	4	0	\N
242524	1811	150100000000	4511	2305	5	0	\N
242525	1816	100000000	4511	2305	6	0	\N
242526	1483	0	4511	2305	7	0	\N
242527	1811	303100000000	4511	2305	8	0	\N
242528	1483	0	4511	2305	9	0	\N
242529	1811	326090000000	4511	2305	10	0	\N
242530	1811	401090000000	4511	2305	11	0	\N
242531	1678	2880083157000	4511	2305	12	0	\N
242532	1678	2880083158000	4511	2305	13	0	\N
242533	1678	2880083159000	4511	2305	14	0	\N
242534	1811	416090000000	4511	2305	15	0	\N
242535	1678	2880083160000	4511	2305	16	0	\N
242536	1678	2880083161000	4511	2305	17	0	\N
242537	1678	2880083162000	4511	2305	18	0	\N
242538	1678	2880083163000	4511	2305	19	0	\N
242539	1678	2880083164000	4511	2305	20	0	\N
242540	1678	2880083165000	4511	2305	21	0	\N
242541	1678	2880083166000	4511	2305	22	0	\N
242542	1678	2880083167000	4511	2305	23	0	\N
242543	1678	2880083168000	4511	2305	24	0	\N
242544	1678	2880083169000	4511	2305	25	0	\N
242545	1678	2880083170000	4511	2305	26	0	\N
242546	1678	2880083171000	4511	2305	27	0	\N
242547	1678	2880083172000	4511	2305	28	0	\N
242548	1678	2880083173000	4511	2305	29	0	\N
242549	1678	2880083174000	4511	2305	30	0	\N
242550	1678	2880083175000	4511	2305	31	0	\N
242551	1678	2880083176000	4511	2305	32	0	\N
242552	1678	2880083177000	4511	2305	33	0	\N
242553	1678	2880083178000	4511	2305	34	0	\N
242554	1678	2880083179000	4511	2305	35	0	\N
242555	1678	2880083180000	4511	2305	36	0	\N
242556	1678	2880083181000	4511	2305	37	0	\N
242557	1678	2880083182000	4511	2305	38	0	\N
242558	1678	2880083183000	4511	2305	39	0	\N
242559	1678	2880083184000	4511	2305	40	0	\N
242560	1678	2880083185000	4511	2305	41	0	\N
242561	1678	2880083186000	4511	2305	42	0	\N
242562	1678	2880083187000	4511	2305	43	0	\N
242563	1678	2880083188000	4511	2305	44	0	\N
242564	1678	2880083189000	4511	2305	45	0	\N
242565	1678	2880083190000	4511	2305	46	0	\N
242566	1678	2880083191000	4511	2305	47	0	\N
242567	1678	2880083192000	4511	2305	48	0	\N
242568	1678	2880083193000	4511	2305	49	0	\N
242569	1678	2880083194000	4511	2305	50	0	\N
242570	1678	2880083195000	4511	2305	51	0	\N
242571	1678	2880083196000	4511	2305	52	0	\N
242574	1678	2880083197000	4513	2334	0	0	\N
242575	1678	2880083198000	4513	2334	1	0	\N
242577	1678	2880083200000	4515	2336	0	0	\N
242578	1678	2880083200000	4516	2336	0	0	\N
242579	1678	2880083200000	4517	2336	0	0	\N
242585	1678	2880083205000	4522	2340	0	0	\N
242588	1678	2880083206000	4525	2341	0	0	\N
242589	1678	2880083207000	4526	2342	0	0	\N
242591	1678	2880083208000	4528	2343	0	0	\N
242592	1678	2880083208000	4529	2343	0	0	\N
242594	1678	2880083209000	4531	2344	0	0	\N
242596	1678	2880083197000	4533	2306	0	0	\N
242597	1678	2880083198000	4533	2306	1	0	\N
242598	1678	2880083199000	4533	2306	2	0	\N
242599	1678	2880083200000	4533	2306	3	0	\N
242600	1678	2880083201000	4533	2306	4	0	\N
242601	1678	2880083202000	4533	2306	6	0	\N
242602	1678	2880083203000	4533	2306	7	0	\N
242603	1678	2880083204000	4533	2306	8	0	\N
242604	1678	2880083205000	4533	2306	9	0	\N
242605	1678	2880083206000	4533	2306	10	0	\N
242606	1678	2880083207000	4533	2306	11	0	\N
242607	1678	2880083208000	4533	2306	12	0	\N
242608	1678	2880083209000	4533	2306	13	0	\N
242610	1678	2880083210000	4535	2345	0	0	\N
242611	1678	2880083211000	4536	2346	0	0	\N
242612	1678	2880083211000	4537	2346	0	0	\N
242617	1678	2880083214000	4542	2349	0	0	\N
242498	1678	2880083187000	4498	2328	2	0	0
242499	1678	2880083188000	4498	2328	3	0	0
242500	1811	266090000000	4498	2328	4	0	1
242503	1811	416090000000	4500	2329	0	0	1
242504	1678	2880083189000	4500	2329	1	0	0
242506	1678	2880083191000	4500	2329	3	0	0
242507	1678	2880083192000	4501	2330	0	0	0
242508	1678	2880083193000	4502	2331	0	0	0
242509	1678	2880083194000	4502	2331	1	0	0
242513	1678	2880083195000	4505	2332	0	0	0
242572	1678	2880083197000	4512	2334	0	0	0
242573	1678	2880083198000	4512	2334	1	0	0
242576	1678	2880083199000	4514	2335	0	0	0
242580	1678	2880083200000	4518	2336	0	0	0
242582	1678	2880083202000	4519	2337	1	0	0
242583	1678	2880083203000	4520	2338	0	0	0
242584	1678	2880083204000	4521	2339	0	0	0
242586	1678	2880083205000	4523	2340	0	0	0
242587	1678	2880083206000	4524	2341	0	0	0
242593	1678	2880083208000	4530	2343	0	0	0
242595	1678	2880083209000	4532	2344	0	0	0
242609	1678	2880083210000	4534	2345	0	0	0
242613	1678	2880083211000	4538	2346	0	0	0
242614	1678	2880083212000	4539	2347	0	0	0
242616	1678	2880083214000	4541	2349	0	0	0
242618	1678	2880083215000	4543	2350	0	0	0
242619	1678	2880083216000	4543	2350	1	0	0
242620	1818	0	4544	2351	0	0	0
242622	1678	2880083218000	4545	2352	0	0	0
242623	1678	2880083219000	4545	2352	1	0	0
242624	1678	2880083220000	4547	2353	0	0	0
242627	1678	2880083222000	4549	2355	0	0	\N
242643	1819	200000000	4555	2356	0	0	\N
242644	354	66001200000000	4555	2356	1	0	\N
242645	354	66002400000000	4555	2356	2	0	\N
242646	458	66001200000000	4555	2356	3	0	\N
242647	458	66002400000000	4555	2356	4	0	\N
242648	711	3001200000000	4555	2356	6	0	\N
242649	711	3002400000000	4555	2356	7	0	\N
242650	748	2001200000000	4555	2356	8	0	\N
242651	748	2002400000000	4555	2356	9	0	\N
242652	1488	1200000000	4555	2356	10	0	\N
242653	1488	2400000000	4555	2356	11	0	\N
242654	1678	2880083223000	4555	2356	12	0	\N
242655	1678	2880083224000	4555	2356	13	0	\N
242656	1678	2880083225000	4555	2356	14	0	\N
242657	1678	2880083226000	4558	2357	0	0	\N
242658	1678	2880083226000	4559	2357	0	0	\N
242659	1819	200000000	4560	2356	0	0	\N
242660	354	66001200000000	4560	2356	1	0	\N
242661	354	66002400000000	4560	2356	2	0	\N
242662	458	66001200000000	4560	2356	3	0	\N
242663	458	66002400000000	4560	2356	4	0	\N
242664	711	3001200000000	4560	2356	6	0	\N
242665	711	3002400000000	4560	2356	7	0	\N
242666	748	2001200000000	4560	2356	8	0	\N
242667	748	2002400000000	4560	2356	9	0	\N
242668	1488	1200000000	4560	2356	10	0	\N
242669	1488	2400000000	4560	2356	11	0	\N
242670	1678	2880083223000	4560	2356	12	0	\N
242671	1678	2880083224000	4560	2356	13	0	\N
242672	1678	2880083225000	4560	2356	14	0	\N
242673	1819	200000000	4561	2356	0	0	\N
242674	354	66001200000000	4561	2356	1	0	\N
242675	354	66002400000000	4561	2356	2	0	\N
242676	458	66001200000000	4561	2356	3	0	\N
242677	458	66002400000000	4561	2356	4	0	\N
242678	711	3001200000000	4561	2356	6	0	\N
242679	711	3002400000000	4561	2356	7	0	\N
242680	748	2001200000000	4561	2356	8	0	\N
242681	748	2002400000000	4561	2356	9	0	\N
242682	1488	1200000000	4561	2356	10	0	\N
242683	1488	2400000000	4561	2356	11	0	\N
242684	1678	2880083223000	4561	2356	12	0	\N
242685	1678	2880083224000	4561	2356	13	0	\N
242686	1678	2880083225000	4561	2356	14	0	\N
242691	1483	0	4565	2361	0	0	\N
242692	281	66001500000000	4565	2361	1	0	\N
242693	1678	2880083230000	4565	2361	2	0	\N
242699	1678	2880083232000	4569	2363	0	0	\N
242701	1483	0	4571	2260	0	0	\N
242702	1803	200000000	4571	2260	1	0	\N
242703	1804	200000000	4571	2260	2	0	\N
242704	1805	200000000	4571	2260	3	0	\N
242705	1806	200000000	4571	2260	4	0	\N
242706	240	66001200000000	4571	2260	5	0	\N
242707	1807	200000000	4571	2260	6	0	\N
242708	1808	200000000	4571	2260	7	0	\N
242709	1809	200000000	4571	2260	8	0	\N
242710	1810	200000000	4571	2260	9	0	\N
242711	1804	1400000000	4571	2260	10	0	\N
242712	1813	200000000	4571	2260	11	0	\N
242713	1814	200000000	4571	2260	12	0	\N
242714	1815	200000000	4571	2260	13	0	\N
242715	96	66001200000000	4571	2260	14	0	\N
242716	1817	200000000	4571	2260	15	0	\N
242717	1819	200000000	4571	2260	16	0	\N
242718	354	66001200000000	4571	2260	17	0	\N
242719	354	66002400000000	4571	2260	18	0	\N
242720	458	66001200000000	4571	2260	19	0	\N
242721	458	66002400000000	4571	2260	20	0	\N
242722	711	3001200000000	4571	2260	21	0	\N
242723	711	3002400000000	4571	2260	22	0	\N
242724	748	2001200000000	4571	2260	23	0	\N
242725	748	2002400000000	4571	2260	24	0	\N
242726	1488	1200000000	4571	2260	25	0	\N
242727	1488	2400000000	4571	2260	26	0	\N
242728	281	66001500000000	4571	2260	27	0	\N
242729	1818	0	4571	2260	28	0	\N
242730	542	66001000000000	4571	2260	29	0	\N
242731	569	66153481816426	4571	2260	30	0	\N
242732	745	2004650964107	4571	2260	31	0	\N
242733	225	66153481816426	4571	2260	32	0	\N
242734	1537	0	4571	2260	33	0	\N
242735	1678	2880083001000	4571	2260	34	0	\N
242736	1678	2880083002000	4571	2260	35	0	\N
242737	1678	2880083102000	4571	2260	36	0	\N
242738	1407	0	4571	2260	37	0	\N
242739	1388	1697107201851650	4571	2260	39	0	\N
242740	1142	902636269100000	4571	2260	40	0	\N
242741	1262	609026510100000	4571	2260	41	0	\N
242742	1022	503705963100000	4571	2260	42	0	\N
242743	191	66153481816426	4571	2260	43	0	\N
242744	304	66153481816426	4571	2260	44	0	\N
242745	373	66153481816426	4571	2260	45	0	\N
242746	877	203265353117107	4571	2260	46	0	\N
242747	217	66153481816426	4571	2260	47	0	\N
242748	309	66153481816426	4571	2260	48	0	\N
242749	731	2004650964107	4571	2260	49	0	\N
242750	275	66153481816426	4571	2260	50	0	\N
242751	138	66153481816426	4571	2260	51	0	\N
242752	1030	903068611238925	4571	2260	52	0	\N
242753	205	66153481816426	4571	2260	53	0	\N
242754	402	66153481816426	4571	2260	54	0	\N
242755	397	66153481816426	4571	2260	55	0	\N
242756	690	66153481816426	4571	2260	56	0	\N
242757	894	307536427785643	4571	2260	57	0	\N
242758	106	66153481816426	4571	2260	58	0	\N
242759	534	66153481816426	4571	2260	59	0	\N
242760	5	6712573753375	4571	2260	60	0	\N
242628	1678	2880083222000	4550	2355	0	0	0
242629	1819	200000000	4553	2356	0	0	0
242630	354	66001200000000	4553	2356	1	0	0
242631	354	66002400000000	4553	2356	2	0	0
242632	458	66001200000000	4553	2356	3	0	0
242634	711	3001200000000	4553	2356	6	0	0
242635	711	3002400000000	4553	2356	7	0	0
242636	748	2001200000000	4553	2356	8	0	0
242637	748	2002400000000	4553	2356	9	0	0
242638	1488	1200000000	4553	2356	10	0	0
242640	1678	2880083223000	4553	2356	12	0	0
242641	1678	2880083224000	4553	2356	13	0	0
242642	1678	2880083225000	4553	2356	14	0	0
242687	1678	2880083226000	4562	2358	0	0	0
242689	1678	2880083228000	4564	2360	0	0	0
242690	1678	2880083229000	4564	2360	1	0	0
242694	1483	0	4566	2361	0	0	0
242695	1678	2880083230000	4566	2361	1	0	0
242696	281	66001500000000	4567	2362	0	0	0
242698	1678	2880083232000	4568	2363	0	0	0
242700	1678	2880083233000	4570	2364	0	0	0
242761	339	66153481816426	4571	2260	61	0	\N
242762	206	66153481816426	4571	2260	62	0	\N
242763	122	66153481816426	4571	2260	63	0	\N
242764	91	66153481816426	4571	2260	64	0	\N
242765	99	66153481816426	4571	2260	65	0	\N
242766	399	66153481816426	4571	2260	66	0	\N
242767	408	66153481816426	4571	2260	67	0	\N
242768	420	66153481816426	4571	2260	68	0	\N
242769	438	66153481816426	4571	2260	69	0	\N
242770	570	66153481816426	4571	2260	70	0	\N
242771	105	66153481816426	4571	2260	71	0	\N
242772	910	503946947018047	4571	2260	72	0	\N
242773	322	66153481816426	4571	2260	73	0	\N
242774	29	7016278374459	4571	2260	74	0	\N
242775	92	66153481816426	4571	2260	75	0	\N
242776	89	66153481816426	4571	2260	76	0	\N
242777	146	66153481816426	4571	2260	77	0	\N
242778	251	66153481816426	4571	2260	78	0	\N
242779	500	66153481816426	4571	2260	79	0	\N
242780	395	66150451816426	4571	2260	80	0	\N
242781	84	66153481816426	4571	2260	81	0	\N
242782	320	66153481816426	4571	2260	82	0	\N
242783	587	66153481816426	4571	2260	83	0	\N
242784	611	66153481816426	4571	2260	84	0	\N
242785	678	66153481816426	4571	2260	85	0	\N
242786	710	5011627410323	4571	2260	87	0	\N
242787	295	66153481816426	4571	2260	88	0	\N
242788	721	2004650964107	4571	2260	89	0	\N
242789	392	66153481816426	4571	2260	90	0	\N
242790	560	66153481816426	4571	2260	91	0	\N
242791	194	66153481816426	4571	2260	92	0	\N
242792	252	66153481816426	4571	2260	93	0	\N
242793	150	66153481816426	4571	2260	94	0	\N
242794	450	66153481816426	4571	2260	95	0	\N
242795	653	66153481816426	4571	2260	96	0	\N
242796	421	66153481816426	4571	2260	97	0	\N
242797	245	66153481816426	4571	2260	98	0	\N
242798	520	66153481816426	4571	2260	99	0	\N
242799	620	66153481816426	4571	2260	100	0	\N
242800	37	65479919092470	4571	2260	101	0	\N
242801	622	66156461816426	4571	2260	102	0	\N
242802	54	66153481816426	4571	2260	103	0	\N
242803	78	66153481816426	4571	2260	104	0	\N
242804	594	66153481816426	4571	2260	105	0	\N
242805	739	10023254820647	4571	2260	106	0	\N
242806	163	66153481816426	4571	2260	107	0	\N
242807	1150	609318386916143	4571	2260	108	0	\N
242808	452	66153481816426	4571	2260	109	0	\N
242809	193	66153481816426	4571	2260	110	0	\N
242810	391	66153481816426	4571	2260	111	0	\N
242811	593	66153481816426	4571	2260	112	0	\N
242812	660	66153481816426	4571	2260	113	0	\N
242813	6	32633713045112	4571	2260	114	0	\N
242814	504	66153481816426	4571	2260	115	0	\N
242815	658	66153481816426	4571	2260	116	0	\N
242816	1276	1697919862712040	4571	2260	117	0	\N
242817	180	66153481816426	4571	2260	118	0	\N
242818	652	66153481816426	4571	2260	119	0	\N
242819	893	307536427785643	4571	2260	120	0	\N
242820	390	66153481816426	4571	2260	121	0	\N
242821	353	66153481816426	4571	2260	122	0	\N
242822	108	66153481816426	4571	2260	123	0	\N
242823	601	66153481816426	4571	2260	124	0	\N
242824	352	66153481816426	4571	2260	125	0	\N
242830	1678	2880083237000	4575	2367	0	0	\N
242831	1678	2880083238000	4576	2368	0	0	\N
242832	1678	2880083239000	4576	2368	1	0	\N
242835	1678	2880083240000	4578	2369	0	0	\N
242837	1678	2880083241000	4580	2370	0	0	\N
242838	1678	2880083241000	4581	2370	0	0	\N
242839	1678	2880083241000	4582	2370	0	0	\N
242847	1820	200000000	4586	2372	0	0	\N
242848	1678	2880083243000	4586	2372	1	0	\N
242849	1678	2880083244000	4586	2372	2	0	\N
242850	1678	2880083245000	4586	2372	3	0	\N
242851	1678	2880083246000	4586	2372	4	0	\N
242852	1820	200000000	4587	2372	0	0	\N
242853	1678	2880083243000	4587	2372	1	0	\N
242854	1678	2880083244000	4587	2372	2	0	\N
242855	1678	2880083245000	4587	2372	3	0	\N
242856	1678	2880083246000	4587	2372	4	0	\N
242857	1820	200000000	4588	2372	0	0	\N
242858	1678	2880083243000	4588	2372	1	0	\N
242859	1678	2880083244000	4588	2372	2	0	\N
242860	1678	2880083245000	4588	2372	3	0	\N
242861	1678	2880083246000	4588	2372	4	0	\N
242862	1483	0	4589	2323	0	0	\N
242863	1817	200000000	4589	2323	1	0	\N
242864	1819	200000000	4589	2323	2	0	\N
242865	354	66001200000000	4589	2323	3	0	\N
242866	354	66002400000000	4589	2323	4	0	\N
242867	458	66001200000000	4589	2323	5	0	\N
242868	458	66002400000000	4589	2323	6	0	\N
242869	711	3001200000000	4589	2323	7	0	\N
242870	711	3002400000000	4589	2323	8	0	\N
242871	748	2001200000000	4589	2323	9	0	\N
242872	748	2002400000000	4589	2323	10	0	\N
242873	1488	1200000000	4589	2323	11	0	\N
242874	1488	2400000000	4589	2323	12	0	\N
242875	281	66001500000000	4589	2323	13	0	\N
242876	1781	1200000000	4589	2323	14	0	\N
242877	1820	200000000	4589	2323	15	0	\N
242878	1818	0	4589	2323	16	0	\N
242879	542	66001000000000	4589	2323	17	0	\N
242880	1811	150090000000	4589	2323	18	0	\N
242881	1678	2880083182000	4589	2323	19	0	\N
242882	1678	2880083183000	4589	2323	20	0	\N
242883	1678	2880083184000	4589	2323	21	0	\N
242884	1811	303090000000	4589	2323	22	0	\N
242885	1811	326090000000	4589	2323	23	0	\N
242886	1811	401090000000	4589	2323	24	0	\N
242887	1678	2880083185000	4589	2323	25	0	\N
242888	1678	2880083186000	4589	2323	26	0	\N
242889	1678	2880083187000	4589	2323	27	0	\N
242890	1678	2880083188000	4589	2323	28	0	\N
242891	1678	2880083189000	4589	2323	29	0	\N
242892	1678	2880083190000	4589	2323	30	0	\N
242893	1678	2880083191000	4589	2323	31	0	\N
242894	1678	2880083192000	4589	2323	32	0	\N
242895	1678	2880083193000	4589	2323	33	0	\N
242896	1678	2880083194000	4589	2323	34	0	\N
242827	1781	1200000000	4573	2366	0	0	0
242828	1678	2880083236000	4573	2366	1	0	0
242829	1678	2880083237000	4574	2367	0	0	0
242833	1678	2880083238000	4577	2368	0	0	0
242834	1678	2880083239000	4577	2368	1	0	0
242840	1678	2880083241000	4583	2370	0	0	0
242841	1678	2880083242000	4584	2371	0	0	0
242842	1820	200000000	4585	2372	0	0	0
242843	1678	2880083243000	4585	2372	1	0	0
242844	1678	2880083244000	4585	2372	2	0	0
242846	1678	2880083246000	4585	2372	4	0	0
242897	1678	2880083195000	4589	2323	35	0	\N
242898	1678	2880083196000	4589	2323	36	0	\N
242899	1678	2880083197000	4589	2323	37	0	\N
242900	1678	2880083198000	4589	2323	38	0	\N
242901	1678	2880083199000	4589	2323	39	0	\N
242902	1678	2880083200000	4589	2323	40	0	\N
242903	1678	2880083201000	4589	2323	41	0	\N
242904	1678	2880083202000	4589	2323	42	0	\N
242905	1678	2880083203000	4589	2323	43	0	\N
242906	1678	2880083204000	4589	2323	44	0	\N
242907	1678	2880083205000	4589	2323	45	0	\N
242908	1678	2880083206000	4589	2323	46	0	\N
242909	1678	2880083207000	4589	2323	47	0	\N
242910	1678	2880083208000	4589	2323	48	0	\N
242911	1678	2880083209000	4589	2323	49	0	\N
242912	1678	2880083210000	4589	2323	50	0	\N
242913	1678	2880083211000	4589	2323	51	0	\N
242914	1678	2880083212000	4589	2323	52	0	\N
242915	1678	2880083213000	4589	2323	53	0	\N
242916	1678	2880083214000	4589	2323	54	0	\N
242917	1678	2880083215000	4589	2323	55	0	\N
242918	1678	2880083216000	4589	2323	56	0	\N
242919	1678	2880083217000	4589	2323	57	0	\N
242920	1678	2880083218000	4589	2323	58	0	\N
242921	1678	2880083219000	4589	2323	59	0	\N
242922	1678	2880083220000	4589	2323	60	0	\N
242923	1678	2880083221000	4589	2323	61	0	\N
242924	1678	2880083222000	4589	2323	62	0	\N
242925	1678	2880083223000	4589	2323	63	0	\N
242926	1678	2880083224000	4589	2323	64	0	\N
242927	1678	2880083225000	4589	2323	65	0	\N
242928	1678	2880083226000	4589	2323	66	0	\N
242929	1678	2880083227000	4589	2323	67	0	\N
242930	1678	2880083228000	4589	2323	68	0	\N
242931	1678	2880083229000	4589	2323	69	0	\N
242932	1678	2880083230000	4589	2323	70	0	\N
242933	1678	2880083231000	4589	2323	71	0	\N
242934	1678	2880083232000	4589	2323	72	0	\N
242935	1678	2880083233000	4589	2323	73	0	\N
242936	1678	2880083234000	4589	2323	74	0	\N
242937	1678	2880083235000	4589	2323	75	0	\N
242938	1678	2880083236000	4589	2323	76	0	\N
242939	1678	2880083237000	4589	2323	77	0	\N
242940	1678	2880083238000	4589	2323	78	0	\N
242941	1678	2880083239000	4589	2323	79	0	\N
242942	1678	2880083240000	4589	2323	80	0	\N
242943	1678	2880083241000	4589	2323	81	0	\N
242944	1678	2880083242000	4589	2323	82	0	\N
242945	1678	2880083243000	4589	2323	83	0	\N
242946	1678	2880083244000	4589	2323	84	0	\N
242947	1678	2880083245000	4589	2323	85	0	\N
242948	1678	2880083246000	4589	2323	86	0	\N
242949	1811	416090000000	4589	2323	87	0	\N
242954	1483	0	4591	2194	0	0	\N
242955	96	66001200000000	4591	2194	1	0	\N
242956	1817	200000000	4591	2194	2	0	\N
242957	1819	200000000	4591	2194	3	0	\N
242958	354	66001200000000	4591	2194	4	0	\N
242959	354	66002400000000	4591	2194	5	0	\N
242960	458	66001200000000	4591	2194	6	0	\N
242961	458	66002400000000	4591	2194	7	0	\N
242962	711	3001200000000	4591	2194	8	0	\N
242963	711	3002400000000	4591	2194	9	0	\N
242964	748	2001200000000	4591	2194	10	0	\N
242965	748	2002400000000	4591	2194	11	0	\N
242966	1488	1200000000	4591	2194	12	0	\N
242967	1488	2400000000	4591	2194	13	0	\N
242968	281	66001500000000	4591	2194	14	0	\N
242969	1781	1200000000	4591	2194	15	0	\N
242970	1820	200000000	4591	2194	16	0	\N
242971	1818	0	4591	2194	17	0	\N
242972	542	66001000000000	4591	2194	18	0	\N
242973	1811	149000000000	4591	2194	19	0	\N
242974	1811	172000000000	4591	2194	20	0	\N
242975	1811	247000000000	4591	2194	21	0	\N
242976	1811	262000000000	4591	2194	22	0	\N
242977	44	71040180000000	4591	2194	23	0	\N
242978	44	71040180000000	4591	2194	25	0	\N
242984	1678	2880083255000	4595	2377	0	0	\N
242985	1483	0	4595	2377	1	0	\N
242986	1678	2880083256000	4595	2377	2	0	\N
242998	1678	2880083264000	4603	2382	0	0	\N
242999	1678	2880083265000	4604	2383	0	0	\N
243001	1678	2880083266000	4606	2384	0	0	\N
243007	1678	2880083271000	4611	2388	0	0	\N
243008	1678	2880083271000	4612	2388	0	0	\N
243013	1540	720010000000	4616	2390	0	0	\N
243014	1678	2880083272000	4616	2390	1	0	\N
243015	1678	2880083273000	4616	2390	2	0	\N
243016	1483	0	4617	2284	0	0	\N
243017	1540	720010000000	4617	2284	1	0	\N
243018	1809	200000000	4617	2284	2	0	\N
243019	1810	200000000	4617	2284	3	0	\N
243020	1804	1400000000	4617	2284	4	0	\N
243021	1813	200000000	4617	2284	5	0	\N
243022	1814	200000000	4617	2284	6	0	\N
243023	1815	200000000	4617	2284	7	0	\N
243024	96	66001200000000	4617	2284	8	0	\N
243025	1817	200000000	4617	2284	9	0	\N
243026	1819	200000000	4617	2284	10	0	\N
243027	354	66001200000000	4617	2284	11	0	\N
243028	354	66002400000000	4617	2284	12	0	\N
243029	458	66001200000000	4617	2284	13	0	\N
243030	458	66002400000000	4617	2284	14	0	\N
243031	711	3001200000000	4617	2284	15	0	\N
243032	711	3002400000000	4617	2284	16	0	\N
242952	1678	2880083249000	4590	2373	2	0	0
242953	1678	2880083250000	4590	2373	3	0	0
242979	1678	2880083251000	4592	2374	0	0	0
242980	1678	2880083252000	4593	2375	0	0	0
242981	1678	2880083253000	4593	2375	1	0	0
242983	1678	2880083254000	4594	2376	1	0	0
242987	1678	2880083255000	4596	2377	0	0	0
242988	1483	0	4596	2377	1	0	0
242989	1678	2880083256000	4596	2377	2	0	0
242990	1678	2880083257000	4598	2378	0	0	0
242992	1678	2880083259000	4599	2379	1	0	0
242993	1678	2880083260000	4599	2379	2	0	0
242994	1678	2880083261000	4600	2380	0	0	0
242995	1678	2880083262000	4601	2381	0	0	0
242997	1678	2880083264000	4602	2382	0	0	0
243000	1678	2880083265000	4605	2383	0	0	0
243002	1678	2880083266000	4607	2384	0	0	0
243003	1678	2880083267000	4608	2385	0	0	0
243004	1678	2880083268000	4609	2386	0	0	0
243006	1678	2880083270000	4610	2387	0	0	0
243009	1678	2880083271000	4613	2388	0	0	0
243010	1540	720010000000	4615	2390	0	0	0
243011	1678	2880083272000	4615	2390	1	0	0
243012	1678	2880083273000	4615	2390	2	0	0
243033	748	2001200000000	4617	2284	17	0	\N
243034	748	2002400000000	4617	2284	18	0	\N
243035	1488	1200000000	4617	2284	19	0	\N
243036	1488	2400000000	4617	2284	20	0	\N
243037	281	66001500000000	4617	2284	21	0	\N
243038	1781	1200000000	4617	2284	22	0	\N
243039	1820	200000000	4617	2284	23	0	\N
243040	1818	0	4617	2284	24	0	\N
243041	542	66001000000000	4617	2284	25	0	\N
243042	1678	2880083147000	4617	2284	26	0	\N
243043	1678	2880083148000	4617	2284	27	0	\N
243044	1537	0	4617	2284	28	0	\N
243045	1678	2880083149000	4617	2284	29	0	\N
243046	1678	2880083150000	4617	2284	30	0	\N
243047	1678	2880083151000	4617	2284	31	0	\N
243048	1678	2880083152000	4617	2284	32	0	\N
243049	1678	2880083153000	4617	2284	33	0	\N
243050	1678	2880083154000	4617	2284	34	0	\N
243051	1678	2880083155000	4617	2284	35	0	\N
243052	1678	2880083156000	4617	2284	36	0	\N
243053	1678	2880083157000	4617	2284	37	0	\N
243054	1678	2880083158000	4617	2284	38	0	\N
243055	1678	2880083159000	4617	2284	39	0	\N
243056	1811	14000000000	4617	2284	40	0	\N
243057	1678	2880083160000	4617	2284	41	0	\N
243058	1678	2880083161000	4617	2284	42	0	\N
243059	1678	2880083162000	4617	2284	43	0	\N
243060	1678	2880083163000	4617	2284	44	0	\N
243061	1678	2880083164000	4617	2284	45	0	\N
243062	1678	2880083165000	4617	2284	46	0	\N
243063	1678	2880083166000	4617	2284	47	0	\N
243064	1678	2880083167000	4617	2284	48	0	\N
243065	1678	2880083168000	4617	2284	49	0	\N
243066	1678	2880083169000	4617	2284	50	0	\N
243067	1678	2880083170000	4617	2284	51	0	\N
243068	1678	2880083171000	4617	2284	52	0	\N
243069	1678	2880083172000	4617	2284	54	0	\N
243070	1678	2880083173000	4617	2284	55	0	\N
243071	1678	2880083174000	4617	2284	56	0	\N
243072	1678	2880083175000	4617	2284	57	0	\N
243073	1678	2880083176000	4617	2284	58	0	\N
243074	1678	2880083177000	4617	2284	59	0	\N
243075	1678	2880083178000	4617	2284	60	0	\N
243076	1678	2880083179000	4617	2284	61	0	\N
243077	1678	2880083180000	4617	2284	62	0	\N
243078	1678	2880083181000	4617	2284	63	0	\N
243079	1678	2880083182000	4617	2284	64	0	\N
243080	1678	2880083183000	4617	2284	65	0	\N
243081	1678	2880083184000	4617	2284	66	0	\N
243082	1678	2880083185000	4617	2284	67	0	\N
243083	1678	2880083186000	4617	2284	68	0	\N
243084	1678	2880083187000	4617	2284	69	0	\N
243085	1678	2880083188000	4617	2284	70	0	\N
243086	1678	2880083189000	4617	2284	71	0	\N
243087	1678	2880083190000	4617	2284	72	0	\N
243088	1678	2880083191000	4617	2284	73	0	\N
243089	1678	2880083192000	4617	2284	74	0	\N
243090	1678	2880083193000	4617	2284	75	0	\N
243091	1678	2880083194000	4617	2284	76	0	\N
243092	1678	2880083195000	4617	2284	77	0	\N
243093	1678	2880083196000	4617	2284	78	0	\N
243094	1678	2880083197000	4617	2284	79	0	\N
243095	1678	2880083198000	4617	2284	80	0	\N
243096	1678	2880083199000	4617	2284	81	0	\N
243097	1678	2880083200000	4617	2284	82	0	\N
243098	1678	2880083201000	4617	2284	83	0	\N
243099	1678	2880083202000	4617	2284	84	0	\N
243100	1678	2880083203000	4617	2284	85	0	\N
243101	1678	2880083204000	4617	2284	86	0	\N
243102	1678	2880083205000	4617	2284	87	0	\N
243103	1678	2880083206000	4617	2284	88	0	\N
243104	1678	2880083207000	4617	2284	89	0	\N
243105	1678	2880083208000	4617	2284	90	0	\N
243106	1678	2880083209000	4617	2284	91	0	\N
243107	1678	2880083210000	4617	2284	92	0	\N
243108	1678	2880083211000	4617	2284	93	0	\N
243109	1678	2880083212000	4617	2284	94	0	\N
243110	1678	2880083213000	4617	2284	95	0	\N
243111	1678	2880083214000	4617	2284	96	0	\N
243112	1678	2880083215000	4617	2284	97	0	\N
243113	1678	2880083216000	4617	2284	98	0	\N
243115	1678	2880083274000	4619	2391	0	0	\N
243117	1678	2880083275000	4621	2392	0	0	\N
243118	1678	2880083275000	4622	2392	0	0	\N
243119	1678	2880083276000	4623	2393	0	0	\N
243120	1678	2880083276000	4624	2393	0	0	\N
243121	1678	2880083276000	4625	2393	0	0	\N
243123	1678	2880083277000	4627	2394	0	0	\N
243124	1678	2880083278000	4627	2394	1	0	\N
243125	1678	2880083279000	4627	2394	2	0	\N
243130	1678	2880083281000	4630	2396	0	0	\N
243131	1678	2880083281000	4631	2396	0	0	\N
243132	1678	2880083281000	4632	2396	0	0	\N
243135	1678	2880083282000	4635	2397	0	0	\N
243136	1678	2880083282000	4636	2397	0	0	\N
243140	1678	2880083285000	4639	2399	0	0	\N
243141	1678	2880083285000	4640	2399	0	0	\N
243142	1678	2880083285000	4641	2399	0	0	\N
243143	1678	2880083286000	4642	2400	0	0	\N
243144	1483	0	4643	2329	0	0	\N
243145	1540	720010000000	4643	2329	1	0	\N
243146	1819	200000000	4643	2329	2	0	\N
243147	354	66001200000000	4643	2329	3	0	\N
243148	354	66002400000000	4643	2329	4	0	\N
243149	458	66001200000000	4643	2329	5	0	\N
243150	458	66002400000000	4643	2329	6	0	\N
243151	711	3001200000000	4643	2329	7	0	\N
243152	711	3002400000000	4643	2329	8	0	\N
243153	748	2001200000000	4643	2329	9	0	\N
243154	748	2002400000000	4643	2329	10	0	\N
243155	1488	1200000000	4643	2329	11	0	\N
243156	1488	2400000000	4643	2329	12	0	\N
243157	281	66001500000000	4643	2329	13	0	\N
243158	1781	1200000000	4643	2329	14	0	\N
243159	1820	200000000	4643	2329	15	0	\N
243160	1818	0	4643	2329	16	0	\N
243161	542	66001000000000	4643	2329	17	0	\N
243164	1678	2880083287000	4646	2401	0	0	\N
243165	1678	2880083287000	4647	2401	0	0	\N
243166	1678	2880083287000	4648	2401	0	0	\N
243167	1678	2880083287000	4649	2401	0	0	\N
243122	1678	2880083276000	4626	2393	0	0	0
243126	1678	2880083277000	4628	2394	0	0	0
243127	1678	2880083278000	4628	2394	1	0	0
243128	1678	2880083279000	4628	2394	2	0	0
243129	1678	2880083280000	4629	2395	0	0	0
243134	1678	2880083282000	4634	2397	0	0	0
243137	1678	2880083283000	4637	2398	0	0	0
243138	1678	2880083284000	4637	2398	1	0	0
243139	1678	2880083285000	4638	2399	0	0	0
243162	1678	2880083286000	4644	2400	0	0	0
243168	1678	2880083288000	4650	2402	0	0	0
243174	1678	2880083292000	4653	2404	0	0	\N
243175	1773	2736097999988	4653	2404	1	0	\N
243176	1678	2880083292000	4654	2404	0	0	\N
243177	1773	2736097999988	4654	2404	1	0	\N
243189	1678	2880083297000	4660	2409	0	0	\N
243191	1678	2880083298000	4662	2410	0	0	\N
243192	1678	2880083298000	4663	2410	0	0	\N
243195	1678	2880083301000	4666	2413	0	0	\N
243198	1678	2880083302000	4669	2414	0	0	\N
243201	1591	400000000	4671	2415	0	0	\N
243202	1678	2880083303000	4671	2415	1	0	\N
243203	1591	400000000	4672	2415	0	0	\N
243204	1678	2880083303000	4672	2415	1	0	\N
243206	1483	0	4674	2325	0	0	\N
243207	1540	720010000000	4674	2325	1	0	\N
243208	1817	200000000	4674	2325	2	0	\N
243209	1819	200000000	4674	2325	3	0	\N
243210	354	66001200000000	4674	2325	4	0	\N
243211	354	66002400000000	4674	2325	5	0	\N
243212	458	66001200000000	4674	2325	6	0	\N
243213	458	66002400000000	4674	2325	7	0	\N
243214	711	3001200000000	4674	2325	8	0	\N
243215	711	3002400000000	4674	2325	9	0	\N
243216	748	2001200000000	4674	2325	10	0	\N
243217	748	2002400000000	4674	2325	11	0	\N
243218	1488	1200000000	4674	2325	12	0	\N
243219	1488	2400000000	4674	2325	13	0	\N
243220	281	66001500000000	4674	2325	14	0	\N
243221	1781	1200000000	4674	2325	15	0	\N
243222	1820	200000000	4674	2325	16	0	\N
243223	1818	0	4674	2325	17	0	\N
243224	542	66001000000000	4674	2325	18	0	\N
243225	1678	2880083184000	4674	2325	19	0	\N
243226	1811	150090000000	4674	2325	20	0	\N
243227	1773	2736097999988	4674	2325	21	0	\N
243228	1811	303090000000	4674	2325	22	0	\N
243229	1811	326090000000	4674	2325	23	0	\N
243230	1811	401090000000	4674	2325	24	0	\N
243231	1678	2880083185000	4674	2325	25	0	\N
243232	1678	2880083186000	4674	2325	26	0	\N
243233	1678	2880083187000	4674	2325	27	0	\N
243234	1678	2880083188000	4674	2325	28	0	\N
243235	1678	2880083189000	4674	2325	29	0	\N
243236	1678	2880083190000	4674	2325	30	0	\N
243237	1678	2880083191000	4674	2325	31	0	\N
243238	1678	2880083192000	4674	2325	32	0	\N
243239	1678	2880083193000	4674	2325	33	0	\N
243240	1678	2880083194000	4674	2325	34	0	\N
243241	1678	2880083195000	4674	2325	35	0	\N
243242	1678	2880083196000	4674	2325	36	0	\N
243243	1678	2880083197000	4674	2325	37	0	\N
243244	1678	2880083198000	4674	2325	38	0	\N
243245	1678	2880083199000	4674	2325	39	0	\N
243246	1678	2880083200000	4674	2325	40	0	\N
243247	1678	2880083201000	4674	2325	41	0	\N
243248	1678	2880083202000	4674	2325	42	0	\N
243249	1678	2880083203000	4674	2325	43	0	\N
243250	1678	2880083204000	4674	2325	44	0	\N
243251	1678	2880083205000	4674	2325	45	0	\N
243252	1678	2880083206000	4674	2325	46	0	\N
243253	1678	2880083207000	4674	2325	47	0	\N
243254	1678	2880083208000	4674	2325	48	0	\N
243255	1678	2880083209000	4674	2325	49	0	\N
243256	1678	2880083210000	4674	2325	50	0	\N
243257	1678	2880083211000	4674	2325	51	0	\N
243258	1678	2880083212000	4674	2325	52	0	\N
243259	1678	2880083213000	4674	2325	53	0	\N
243260	1678	2880083214000	4674	2325	54	0	\N
243261	1678	2880083215000	4674	2325	55	0	\N
243262	1678	2880083216000	4674	2325	56	0	\N
243263	1678	2880083217000	4674	2325	57	0	\N
243264	1678	2880083218000	4674	2325	58	0	\N
243265	1678	2880083219000	4674	2325	59	0	\N
243266	1678	2880083220000	4674	2325	60	0	\N
243267	1678	2880083221000	4674	2325	61	0	\N
243268	1678	2880083222000	4674	2325	62	0	\N
243269	1678	2880083223000	4674	2325	63	0	\N
243270	1678	2880083224000	4674	2325	64	0	\N
243271	1678	2880083225000	4674	2325	65	0	\N
243272	1678	2880083226000	4674	2325	66	0	\N
243273	1678	2880083227000	4674	2325	67	0	\N
243274	1678	2880083228000	4674	2325	68	0	\N
243275	1678	2880083229000	4674	2325	69	0	\N
243276	1678	2880083230000	4674	2325	70	0	\N
243277	1678	2880083231000	4674	2325	71	0	\N
243278	1678	2880083232000	4674	2325	72	0	\N
243279	1678	2880083233000	4674	2325	73	0	\N
243280	1678	2880083234000	4674	2325	74	0	\N
243281	1678	2880083235000	4674	2325	75	0	\N
243282	1678	2880083236000	4674	2325	76	0	\N
243283	1678	2880083237000	4674	2325	77	0	\N
243284	1678	2880083238000	4674	2325	78	0	\N
243285	1678	2880083239000	4674	2325	79	0	\N
243286	1678	2880083240000	4674	2325	80	0	\N
243287	1678	2880083241000	4674	2325	81	0	\N
243288	1678	2880083242000	4674	2325	82	0	\N
243289	1678	2880083243000	4674	2325	83	0	\N
243290	1678	2880083244000	4674	2325	84	0	\N
243291	1678	2880083245000	4674	2325	85	0	\N
243292	1678	2880083246000	4674	2325	86	0	\N
243293	1678	2880083247000	4674	2325	87	0	\N
243294	1678	2880083248000	4674	2325	88	0	\N
243295	1678	2880083249000	4674	2325	89	0	\N
243296	1678	2880083250000	4674	2325	90	0	\N
243297	1678	2880083251000	4674	2325	91	0	\N
243298	1678	2880083252000	4674	2325	92	0	\N
243299	1678	2880083253000	4674	2325	93	0	\N
243300	1678	2880083254000	4674	2325	94	0	\N
243301	1678	2880083255000	4674	2325	95	0	\N
243302	1678	2880083256000	4674	2325	96	0	\N
243303	1678	2880083257000	4674	2325	97	0	\N
243304	1678	2880083258000	4674	2325	98	0	\N
243171	1678	2880083291000	4651	2403	2	0	0
243172	1678	2880083292000	4652	2404	0	0	0
243173	1773	2736097999988	4652	2404	1	0	6
243178	1678	2880083293000	4655	2405	0	0	0
243179	182	66201286260032	4656	2406	0	0	0
243181	927	504309970158507	4656	2406	2	0	0
243182	1047	903719145596202	4656	2406	3	0	0
243183	1167	608757314409807	4656	2406	4	0	1
243184	1293	1699142975987024	4656	2406	5	0	0
243185	1678	2880083294000	4656	2406	6	0	0
243187	1678	2880083296000	4658	2408	0	0	0
243188	1678	2880083297000	4659	2409	0	0	0
243190	1678	2880083298000	4661	2410	0	0	0
243193	1678	2880083299000	4664	2411	0	0	0
243196	1678	2880083301000	4667	2413	0	0	0
243197	1678	2880083302000	4668	2414	0	0	0
243199	1591	400000000	4670	2415	0	0	0
243200	1678	2880083303000	4670	2415	1	0	0
243205	1678	2880083304000	4673	2416	0	0	0
243305	1678	2880083259000	4674	2325	99	0	\N
243306	1678	2880083260000	4674	2325	100	0	\N
243307	1678	2880083261000	4674	2325	101	0	\N
243308	1678	2880083262000	4674	2325	102	0	\N
243309	1678	2880083263000	4674	2325	103	0	\N
243310	1678	2880083264000	4674	2325	104	0	\N
243311	1678	2880083265000	4674	2325	105	0	\N
243312	1678	2880083266000	4674	2325	106	0	\N
243313	1678	2880083267000	4674	2325	107	0	\N
243314	1811	416090000000	4674	2325	108	0	\N
243315	1678	2880083268000	4674	2325	109	0	\N
243316	1678	2880083269000	4674	2325	110	0	\N
243317	1678	2880083270000	4674	2325	111	0	\N
243318	1678	2880083271000	4674	2325	112	0	\N
243319	1678	2880083272000	4674	2325	113	0	\N
243320	1678	2880083273000	4674	2325	115	0	\N
243321	1678	2880083274000	4674	2325	116	0	\N
243322	1678	2880083275000	4674	2325	117	0	\N
243323	1678	2880083276000	4674	2325	118	0	\N
243324	1678	2880083277000	4674	2325	119	0	\N
243325	1678	2880083278000	4674	2325	120	0	\N
243326	1678	2880083279000	4674	2325	121	0	\N
243327	1678	2880083280000	4674	2325	122	0	\N
243328	1678	2880083281000	4674	2325	123	0	\N
243329	1678	2880083282000	4674	2325	124	0	\N
243330	1678	2880083283000	4674	2325	125	0	\N
243332	1678	2880083305000	4676	2417	0	0	\N
243335	1678	2880083306000	4678	2418	0	0	\N
243336	1678	2880083307000	4678	2418	1	0	\N
243337	1678	2880083308000	4679	2419	0	0	\N
243338	1678	2880083308000	4680	2419	0	0	\N
243340	1678	2880083309000	4682	2420	0	0	\N
243343	1678	2880083311000	4685	2422	0	0	\N
243347	1678	2880083313000	4689	2424	0	0	\N
243348	1678	2880083310000	4690	2421	0	0	\N
243349	1678	2880083311000	4690	2421	1	0	\N
243350	1678	2880083312000	4690	2421	2	0	\N
243351	1678	2880083313000	4690	2421	3	0	\N
243352	1678	2880083314000	4690	2421	4	0	\N
243355	1540	720010000000	4693	2195	0	0	\N
243356	1591	400000000	4693	2195	1	0	\N
243357	1773	2736097999988	4693	2195	2	0	\N
243358	1483	0	4693	2195	3	0	\N
243359	1483	0	4693	2195	4	0	\N
243364	1678	2880083318000	4698	2429	0	0	\N
243365	1678	3600093319000	4699	2430	0	0	\N
243367	1678	3600093319000	4701	2430	0	0	\N
243369	1678	3600093320000	4703	2431	0	0	\N
243370	1678	3600093320000	4704	2431	0	0	\N
243371	1591	400000000	4705	2411	0	0	\N
243372	1678	2880083299000	4705	2411	1	0	\N
243373	1678	2880083300000	4705	2411	2	0	\N
243374	1678	2880083301000	4705	2411	3	0	\N
243375	1678	2880083302000	4705	2411	4	0	\N
243376	1821	0	4705	2411	5	0	\N
243377	1678	2880083303000	4705	2411	6	0	\N
243378	1678	2880083304000	4705	2411	7	0	\N
243379	1678	2880083305000	4705	2411	8	0	\N
243380	1678	2880083306000	4705	2411	9	0	\N
243381	1678	2880083307000	4705	2411	10	0	\N
243382	1678	2880083308000	4705	2411	11	0	\N
243383	1678	2880083309000	4705	2411	12	0	\N
243384	1678	2880083310000	4705	2411	13	0	\N
243385	1678	2880083311000	4705	2411	14	0	\N
243386	1678	2880083312000	4705	2411	15	0	\N
243387	1678	2880083313000	4705	2411	16	0	\N
243388	1678	2880083314000	4705	2411	17	0	\N
243389	1678	2880083315000	4705	2411	18	0	\N
243390	1678	2880083316000	4705	2411	19	0	\N
243391	1678	2880083317000	4705	2411	20	0	\N
243392	1678	2880083318000	4705	2411	21	0	\N
243393	1678	2880083319000	4705	2411	22	0	\N
243394	1678	2880083320000	4705	2411	23	0	\N
243396	1678	3600093321000	4707	2432	0	0	\N
243402	1678	3600093326000	4712	2436	0	0	\N
243403	1678	3600093327000	4713	2437	0	0	\N
243405	1678	3600093328000	4715	2438	0	0	\N
243407	1678	3600093329000	4717	2439	0	0	\N
243415	1678	3600093335000	4723	2444	0	0	\N
243416	1678	3600093336000	4723	2444	1	0	\N
243417	1678	3600093335000	4724	2444	0	0	\N
243418	1678	3600093336000	4724	2444	1	0	\N
243421	1678	3600093335000	4726	2444	0	0	\N
243422	1678	3600093336000	4726	2444	1	0	\N
243423	1678	3600093337000	4727	2445	0	0	\N
243424	1818	100000000	4727	2445	1	0	\N
243425	1678	3600093337000	4728	2445	0	0	\N
243426	1818	100000000	4728	2445	1	0	\N
243429	1678	3600093337000	4730	2445	0	0	\N
243430	1818	100000000	4730	2445	1	0	\N
243434	1492	21000000	4732	2446	0	0	\N
243435	1678	3600093338000	4732	2446	1	0	\N
243436	1678	3600093339000	4732	2446	2	0	\N
243438	1678	3600093340000	4734	2447	0	0	\N
243439	1678	3600093341000	4735	2448	0	0	\N
243334	1678	2880083307000	4677	2418	1	0	0
243339	1678	2880083308000	4681	2419	0	0	0
243341	1678	2880083309000	4683	2420	0	0	0
243342	1678	2880083310000	4684	2421	0	0	0
243344	1678	2880083311000	4686	2422	0	0	0
243346	1678	2880083313000	4688	2424	0	0	0
243353	1678	2880083314000	4691	2425	0	0	0
243354	1678	2880083315000	4692	2426	0	0	0
243360	1678	2880083316000	4696	2428	0	0	0
243361	1678	2880083317000	4696	2428	1	0	0
243363	1678	2880083318000	4697	2429	0	0	0
243366	1678	3600093319000	4700	2430	0	0	0
243368	1678	3600093320000	4702	2431	0	0	0
243395	1678	3600093321000	4706	2432	0	0	0
243398	1678	3600093323000	4709	2434	0	0	0
243399	1678	3600093324000	4709	2434	1	0	0
243400	1678	3600093325000	4710	2435	0	0	0
243401	1678	3600093326000	4711	2436	0	0	0
243404	1678	3600093327000	4714	2437	0	0	0
243408	1678	3600093329000	4718	2439	0	0	0
243409	1678	3600093330000	4718	2439	1	0	0
243410	1678	3600093331000	4719	2440	0	0	0
243411	1816	100000000	4719	2440	1	0	1
243412	1678	3600093332000	4720	2441	0	0	0
243414	1678	3600093334000	4722	2443	0	0	0
243419	1678	3600093335000	4725	2444	0	0	0
243420	1678	3600093336000	4725	2444	1	0	0
243427	1678	3600093337000	4729	2445	0	0	0
243431	1492	21000000	4731	2446	0	0	0
243432	1678	3600093338000	4731	2446	1	0	0
243433	1678	3600093339000	4731	2446	2	0	0
243437	1678	3600093340000	4733	2447	0	0	0
243440	1678	3600093341000	4736	2448	0	0	0
243446	1678	3600093346000	4740	2452	0	0	\N
243447	1678	3600093347000	4740	2452	1	0	\N
243450	1678	3600093328000	4742	2438	0	0	\N
243451	1678	3600093329000	4742	2438	1	0	\N
243452	1678	3600093330000	4742	2438	2	0	\N
243453	1678	3600093331000	4742	2438	3	0	\N
243454	1821	150000000000	4742	2438	4	0	\N
243455	1678	3600093332000	4742	2438	5	0	\N
243456	1816	100000000	4742	2438	6	0	\N
243457	1818	100000000	4742	2438	7	0	\N
243458	1678	3600093333000	4742	2438	8	0	\N
243459	1678	3600093334000	4742	2438	9	0	\N
243460	1678	3600093335000	4742	2438	10	0	\N
243461	1678	3600093336000	4742	2438	11	0	\N
243462	1678	3600093337000	4742	2438	12	0	\N
243463	1678	3600093338000	4742	2438	13	0	\N
243464	1678	3600093339000	4742	2438	14	0	\N
243465	1678	3600093340000	4742	2438	15	0	\N
243466	1678	3600093341000	4742	2438	16	0	\N
243467	1678	3600093342000	4742	2438	17	0	\N
243468	1678	3600093343000	4742	2438	18	0	\N
243469	1678	3600093344000	4742	2438	19	0	\N
243470	1678	3600093345000	4742	2438	20	0	\N
243471	1678	3600093346000	4742	2438	21	0	\N
243472	1678	3600093347000	4742	2438	22	0	\N
243475	1678	3600093348000	4744	2453	0	0	\N
243476	1678	3600093349000	4744	2453	1	0	\N
243477	1678	3600093348000	4746	2453	0	0	\N
243478	1678	3600093349000	4746	2453	1	0	\N
243482	1678	3600093350000	4748	2454	0	0	\N
243483	1678	3600093351000	4748	2454	1	0	\N
243484	1678	3600093352000	4748	2454	2	0	\N
243485	1678	3600093350000	4749	2454	0	0	\N
243486	1678	3600093351000	4749	2454	1	0	\N
243487	1678	3600093352000	4749	2454	2	0	\N
243489	1678	3600093353000	4751	2455	0	0	\N
243490	1678	3600093353000	4752	2455	0	0	\N
243492	1678	3600093355000	4754	2457	0	0	\N
243496	1483	0	4757	2457	0	0	\N
243497	1483	0	4758	2458	0	0	\N
243500	1678	3600093359000	4760	2460	0	0	\N
243501	1678	3600093359000	4761	2460	0	0	\N
243504	1483	0	4764	2278	0	0	\N
243505	1540	720010000000	4764	2278	1	0	\N
243506	1804	200000000	4764	2278	2	0	\N
243507	1805	200000000	4764	2278	3	0	\N
243508	1806	200000000	4764	2278	4	0	\N
243509	240	66001200000000	4764	2278	5	0	\N
243510	1807	200000000	4764	2278	6	0	\N
243511	1808	200000000	4764	2278	7	0	\N
243512	1809	200000000	4764	2278	8	0	\N
243513	1810	200000000	4764	2278	9	0	\N
243514	1818	0	4764	2278	10	0	\N
243515	542	66001000000000	4764	2278	11	0	\N
243516	1773	2736097999988	4764	2278	12	0	\N
243517	1142	902636269100000	4764	2278	13	0	\N
243518	1262	609026510100000	4764	2278	14	0	\N
243519	1678	2880083122000	4764	2278	15	0	\N
243520	1537	0	4764	2278	16	0	\N
243521	1022	503705963100000	4764	2278	17	0	\N
243522	304	66153481816426	4764	2278	18	0	\N
243523	1678	2880083123000	4764	2278	19	0	\N
243524	1678	2880083124000	4764	2278	21	0	\N
243525	1678	2880083125000	4764	2278	22	0	\N
243526	1678	2880083126000	4764	2278	23	0	\N
243527	1678	2880083127000	4764	2278	24	0	\N
243528	1678	2880083128000	4764	2278	25	0	\N
243529	1678	2880083129000	4764	2278	26	0	\N
243530	1678	2880083130000	4764	2278	27	0	\N
243531	1678	2880083131000	4764	2278	28	0	\N
243532	1678	2880083132000	4764	2278	29	0	\N
243533	1678	3600093361000	4765	2462	0	0	\N
243536	1678	3600093363000	4768	2464	0	0	\N
243538	1678	3600093364000	4770	2465	0	0	\N
243539	1678	3600093365000	4770	2465	1	0	\N
243540	1678	3600093366000	4770	2465	2	0	\N
243541	1678	3600093367000	4770	2465	3	0	\N
243549	1678	3600093369000	4775	2467	0	0	\N
243550	1678	3600093370000	4775	2467	1	0	\N
243551	1678	3600093368000	4776	2466	0	0	\N
243552	1678	3600093369000	4776	2466	1	0	\N
243553	1678	3600093370000	4776	2466	2	0	\N
243554	1678	3600093371000	4777	2468	0	0	\N
243557	1678	3600093372000	4780	2469	0	0	\N
243563	1678	3600093378000	4785	2474	0	0	\N
243566	1678	3600093380000	4788	2476	0	0	\N
243567	1678	3600093381000	4788	2476	1	0	\N
243572	1678	3600093382000	4791	2477	0	0	\N
243573	1678	3600093383000	4791	2477	1	0	\N
243443	1678	3600093343000	4738	2450	0	0	0
243444	1678	3600093344000	4738	2450	1	0	0
243445	1678	3600093345000	4739	2451	0	0	0
243448	1678	3600093346000	4741	2452	0	0	0
243449	1678	3600093347000	4741	2452	1	0	0
243474	1678	3600093349000	4743	2453	1	0	0
243479	1678	3600093350000	4747	2454	0	0	0
243480	1678	3600093351000	4747	2454	1	0	0
243481	1678	3600093352000	4747	2454	2	0	0
243488	1678	3600093353000	4750	2455	0	0	0
243493	1678	3600093355000	4755	2457	0	0	0
243494	1678	3600093356000	4756	2458	0	0	0
243495	1483	0	4756	2458	1	0	0
243498	1678	3600093357000	4759	2459	0	0	0
243502	1678	3600093359000	4762	2460	0	0	0
243503	1678	3600093360000	4763	2461	0	0	0
243534	1678	3600093361000	4766	2462	0	0	0
243535	1678	3600093362000	4767	2463	0	0	0
243537	1678	3600093363000	4769	2464	0	0	0
243543	1678	3600093365000	4771	2465	1	0	0
243544	1678	3600093366000	4771	2465	2	0	0
243545	1678	3600093367000	4771	2465	3	0	0
243546	1678	3600093368000	4772	2466	0	0	0
243547	1678	3600093369000	4774	2467	0	0	0
243555	1678	3600093371000	4778	2468	0	0	0
243556	1678	3600093372000	4779	2469	0	0	0
243558	1678	3600093373000	4781	2470	0	0	0
243559	1678	3600093374000	4782	2471	0	0	0
243561	1678	3600093376000	4783	2472	1	0	0
243562	1678	3600093377000	4784	2473	0	0	0
243564	1678	3600093378000	4786	2474	0	0	0
243565	1678	3600093379000	4787	2475	0	0	0
243568	1678	3600093380000	4789	2476	0	0	0
243570	1678	3600093382000	4790	2477	0	0	0
243571	1678	3600093383000	4790	2477	1	0	0
243574	1678	3600093384000	4792	2478	0	0	0
243575	1678	3600093385000	4793	2479	0	0	0
243576	1678	3600093386000	4794	2480	0	0	0
243579	1678	3600093388000	4797	2482	0	0	\N
243580	1822	200000000	4798	2483	0	0	\N
243581	1823	200000000	4798	2483	1	0	\N
243582	1824	200000000	4798	2483	2	0	\N
243583	1825	200000000	4798	2483	3	0	\N
243584	1826	200000000	4798	2483	4	0	\N
243585	1827	200000000	4798	2483	5	0	\N
243586	1678	3600093389000	4798	2483	6	0	\N
243595	1678	3600093390000	4801	2484	0	0	\N
243598	1678	3600093392000	4803	2486	0	0	\N
243600	1678	3600093393000	4805	2487	0	0	\N
243604	1678	3600093396000	4809	2490	0	0	\N
243606	1822	200000000	4811	2395	0	0	\N
243607	1823	200000000	4811	2395	1	0	\N
243608	1824	200000000	4811	2395	2	0	\N
243609	1825	200000000	4811	2395	3	0	\N
243610	1591	400000000	4811	2395	4	0	\N
243611	1826	200000000	4811	2395	5	0	\N
243612	1827	200000000	4811	2395	6	0	\N
243613	1826	1400000000	4811	2395	7	0	\N
243614	1773	2736097999988	4811	2395	8	0	\N
243615	1816	100000000	4811	2395	9	0	\N
243616	1818	100000000	4811	2395	10	0	\N
243617	1821	0	4811	2395	11	0	\N
243618	1821	150000000000	4811	2395	12	0	\N
243619	1678	2880083280000	4811	2395	13	0	\N
243620	1678	2880083281000	4811	2395	14	0	\N
243621	1678	2880083282000	4811	2395	15	0	\N
243622	1678	2880083283000	4811	2395	16	0	\N
243623	1678	2880083284000	4811	2395	17	0	\N
243624	1678	2880083285000	4811	2395	18	0	\N
243625	1678	2880083286000	4811	2395	19	0	\N
243626	1678	2880083287000	4811	2395	20	0	\N
243627	1678	2880083288000	4811	2395	21	0	\N
243628	1678	2880083289000	4811	2395	22	0	\N
243629	1678	2880083290000	4811	2395	23	0	\N
243630	1678	2880083291000	4811	2395	24	0	\N
243631	1678	2880083292000	4811	2395	25	0	\N
243632	1678	2880083293000	4811	2395	26	0	\N
243633	1678	2880083294000	4811	2395	27	0	\N
243634	1678	2880083295000	4811	2395	28	0	\N
243635	1678	2880083296000	4811	2395	29	0	\N
243636	1678	2880083297000	4811	2395	30	0	\N
243637	1678	2880083298000	4811	2395	31	0	\N
243638	1678	2880083299000	4811	2395	32	0	\N
243639	1678	2880083300000	4811	2395	33	0	\N
243640	1678	2880083301000	4811	2395	34	0	\N
243641	1678	2880083302000	4811	2395	35	0	\N
243642	1678	2880083303000	4811	2395	36	0	\N
243643	1678	2880083304000	4811	2395	37	0	\N
243644	1678	2880083305000	4811	2395	38	0	\N
243645	1678	2880083306000	4811	2395	39	0	\N
243646	1678	2880083307000	4811	2395	40	0	\N
243647	1678	2880083308000	4811	2395	41	0	\N
243648	1678	2880083309000	4811	2395	42	0	\N
243649	1678	2880083310000	4811	2395	43	0	\N
243650	1678	2880083311000	4811	2395	44	0	\N
243651	1678	2880083312000	4811	2395	45	0	\N
243652	1678	2880083313000	4811	2395	46	0	\N
243653	1678	2880083314000	4811	2395	47	0	\N
243654	1678	2880083315000	4811	2395	48	0	\N
243655	1678	2880083316000	4811	2395	49	0	\N
243656	1678	2880083317000	4811	2395	50	0	\N
243657	1678	2880083318000	4811	2395	51	0	\N
243658	1678	2880083319000	4811	2395	52	0	\N
243659	1678	2880083320000	4811	2395	53	0	\N
243660	1678	2880083321000	4811	2395	54	0	\N
243661	1678	2880083322000	4811	2395	55	0	\N
243662	1678	2880083323000	4811	2395	56	0	\N
243663	1678	2880083324000	4811	2395	57	0	\N
243664	1678	2880083325000	4811	2395	58	0	\N
243665	1678	2880083326000	4811	2395	59	0	\N
243666	1678	2880083327000	4811	2395	60	0	\N
243667	1678	2880083328000	4811	2395	61	0	\N
243668	1678	2880083329000	4811	2395	62	0	\N
243669	1678	2880083330000	4811	2395	63	0	\N
243670	1678	2880083331000	4811	2395	64	0	\N
243671	1678	2880083332000	4811	2395	65	0	\N
243672	1678	2880083333000	4811	2395	66	0	\N
243673	1678	2880083334000	4811	2395	67	0	\N
243674	1678	2880083335000	4811	2395	68	0	\N
243675	1678	2880083336000	4811	2395	69	0	\N
243676	1678	2880083337000	4811	2395	70	0	\N
243677	1678	2880083338000	4811	2395	71	0	\N
243678	1678	2880083339000	4811	2395	72	0	\N
243679	1678	2880083340000	4811	2395	73	0	\N
243680	1678	2880083341000	4811	2395	74	0	\N
243681	1678	2880083342000	4811	2395	75	0	\N
243682	1678	2880083343000	4811	2395	76	0	\N
243683	1678	2880083344000	4811	2395	77	0	\N
243684	1678	2880083345000	4811	2395	78	0	\N
243685	1678	2880083346000	4811	2395	79	0	\N
243686	1678	2880083347000	4811	2395	80	0	\N
243687	1678	2880083348000	4811	2395	81	0	\N
243688	1678	2880083349000	4811	2395	82	0	\N
243689	1678	2880083350000	4811	2395	83	0	\N
243690	1678	2880083351000	4811	2395	84	0	\N
243691	1678	2880083352000	4811	2395	85	0	\N
243692	1678	2880083353000	4811	2395	86	0	\N
243693	1678	2880083354000	4811	2395	87	0	\N
243694	1678	2880083355000	4811	2395	88	0	\N
243695	1678	2880083356000	4811	2395	89	0	\N
243696	1678	2880083357000	4811	2395	90	0	\N
243697	1678	2880083358000	4811	2395	91	0	\N
243698	1678	2880083359000	4811	2395	92	0	\N
243699	1678	2880083360000	4811	2395	93	0	\N
243700	1678	2880083361000	4811	2395	94	0	\N
243701	1678	2880083362000	4811	2395	95	0	\N
243702	1678	2880083363000	4811	2395	96	0	\N
243703	1678	2880083364000	4811	2395	97	0	\N
243704	1678	2880083365000	4811	2395	98	0	\N
243705	1678	2880083366000	4811	2395	99	0	\N
243706	1678	2880083367000	4811	2395	100	0	\N
243707	1678	2880083368000	4811	2395	101	0	\N
243708	1678	2880083369000	4811	2395	102	0	\N
243709	1678	2880083370000	4811	2395	103	0	\N
243710	1678	2880083371000	4811	2395	104	0	\N
243711	1678	2880083372000	4811	2395	105	0	\N
243712	1678	2880083373000	4811	2395	106	0	\N
243587	1822	200000000	4799	2483	0	0	0
243588	1823	200000000	4799	2483	1	0	0
243589	1824	200000000	4799	2483	2	0	0
243590	1825	200000000	4799	2483	3	0	0
243591	1826	200000000	4799	2483	4	0	0
243593	1678	3600093389000	4799	2483	6	0	0
243594	1678	3600093390000	4800	2484	0	0	0
243596	1826	1400000000	4802	2485	0	0	0
243597	1678	3600093391000	4802	2485	1	0	0
243599	1678	3600093392000	4804	2486	0	0	0
243602	1678	3600093394000	4807	2488	0	0	0
243603	1678	3600093395000	4808	2489	0	0	0
243605	1678	3600093396000	4810	2490	0	0	0
243720	1826	200000000	4817	2495	0	0	\N
243721	1678	3600093401000	4817	2495	1	0	\N
243722	1826	200000000	4818	2495	0	0	\N
243723	1678	3600093401000	4818	2495	1	0	\N
243724	1678	3600093402000	4819	2496	0	0	\N
243730	1483	0	4823	2499	0	0	\N
243731	1678	3600093406000	4823	2499	1	0	\N
243734	1822	200000000	4825	2397	0	0	\N
243735	1823	200000000	4825	2397	1	0	\N
243736	1824	200000000	4825	2397	2	0	\N
243737	1825	200000000	4825	2397	3	0	\N
243738	1591	400000000	4825	2397	4	0	\N
243739	1826	200000000	4825	2397	5	0	\N
243740	1827	200000000	4825	2397	6	0	\N
243741	1826	1400000000	4825	2397	7	0	\N
243742	1829	0	4825	2397	8	0	\N
243743	1773	2736097999988	4825	2397	9	0	\N
243744	1678	2880083282000	4825	2397	10	0	\N
243745	1678	2880083283000	4825	2397	11	0	\N
243746	1678	2880083284000	4825	2397	12	0	\N
243747	1678	2880083285000	4825	2397	13	0	\N
243748	1678	2880083286000	4825	2397	14	0	\N
243749	1678	2880083287000	4825	2397	15	0	\N
243750	1483	0	4825	2397	16	0	\N
243751	1816	100000000	4825	2397	17	0	\N
243752	1818	100000000	4825	2397	18	0	\N
243753	1678	2880083288000	4825	2397	19	0	\N
243754	1678	2880083289000	4825	2397	20	0	\N
243755	1678	2880083290000	4825	2397	21	0	\N
243756	1678	2880083291000	4825	2397	22	0	\N
243757	1678	2880083292000	4825	2397	23	0	\N
243758	1678	2880083293000	4825	2397	24	0	\N
243759	1821	0	4825	2397	25	0	\N
243760	1821	150000000000	4825	2397	26	0	\N
243761	1678	2880083294000	4825	2397	27	0	\N
243762	1678	2880083295000	4825	2397	28	0	\N
243763	1678	2880083296000	4825	2397	29	0	\N
243764	1678	2880083297000	4825	2397	30	0	\N
243765	1678	2880083298000	4825	2397	31	0	\N
243766	1678	2880083299000	4825	2397	32	0	\N
243767	1678	2880083300000	4825	2397	33	0	\N
243768	1678	2880083301000	4825	2397	34	0	\N
243769	1678	2880083302000	4825	2397	35	0	\N
243770	1678	2880083303000	4825	2397	36	0	\N
243771	1678	2880083304000	4825	2397	37	0	\N
243772	1678	2880083305000	4825	2397	38	0	\N
243773	1678	2880083306000	4825	2397	39	0	\N
243774	1678	2880083307000	4825	2397	40	0	\N
243775	1678	2880083308000	4825	2397	41	0	\N
243776	1678	2880083309000	4825	2397	42	0	\N
243777	1678	2880083310000	4825	2397	43	0	\N
243778	1678	2880083311000	4825	2397	44	0	\N
243779	1678	2880083312000	4825	2397	45	0	\N
243780	1678	2880083313000	4825	2397	46	0	\N
243781	1678	2880083314000	4825	2397	47	0	\N
243782	1678	2880083315000	4825	2397	48	0	\N
243783	1678	2880083316000	4825	2397	49	0	\N
243784	1678	2880083317000	4825	2397	50	0	\N
243785	1678	2880083318000	4825	2397	51	0	\N
243786	1678	2880083319000	4825	2397	52	0	\N
243787	1678	2880083320000	4825	2397	53	0	\N
243788	1678	2880083321000	4825	2397	54	0	\N
243789	1678	2880083322000	4825	2397	55	0	\N
243790	1678	2880083323000	4825	2397	56	0	\N
243791	1678	2880083324000	4825	2397	57	0	\N
243792	1678	2880083325000	4825	2397	58	0	\N
243793	1678	2880083326000	4825	2397	59	0	\N
243794	1678	2880083327000	4825	2397	60	0	\N
243795	1678	2880083328000	4825	2397	61	0	\N
243796	1678	2880083329000	4825	2397	62	0	\N
243797	1678	2880083330000	4825	2397	63	0	\N
243798	1678	2880083331000	4825	2397	64	0	\N
243799	1678	2880083332000	4825	2397	65	0	\N
243800	1678	2880083333000	4825	2397	66	0	\N
243801	1678	2880083334000	4825	2397	67	0	\N
243802	1678	2880083335000	4825	2397	68	0	\N
243803	1678	2880083336000	4825	2397	69	0	\N
243804	1678	2880083337000	4825	2397	70	0	\N
243805	1678	2880083338000	4825	2397	71	0	\N
243806	1678	2880083339000	4825	2397	72	0	\N
243807	1678	2880083340000	4825	2397	73	0	\N
243808	1678	2880083341000	4825	2397	74	0	\N
243809	1678	2880083342000	4825	2397	75	0	\N
243810	1678	2880083343000	4825	2397	76	0	\N
243811	1678	2880083344000	4825	2397	77	0	\N
243812	1678	2880083345000	4825	2397	78	0	\N
243813	1678	2880083346000	4825	2397	79	0	\N
243814	1678	2880083347000	4825	2397	80	0	\N
243815	1678	2880083348000	4825	2397	81	0	\N
243816	1678	2880083349000	4825	2397	82	0	\N
243817	1678	2880083350000	4825	2397	83	0	\N
243818	1678	2880083351000	4825	2397	84	0	\N
243819	1678	2880083352000	4825	2397	85	0	\N
243820	1678	2880083353000	4825	2397	86	0	\N
243821	1678	2880083354000	4825	2397	87	0	\N
243822	1678	2880083355000	4825	2397	88	0	\N
243823	1678	2880083356000	4825	2397	89	0	\N
243824	1678	2880083357000	4825	2397	90	0	\N
243825	1678	2880083358000	4825	2397	91	0	\N
243826	1678	2880083359000	4825	2397	92	0	\N
243827	1678	2880083360000	4825	2397	93	0	\N
243828	1678	2880083361000	4825	2397	94	0	\N
243829	1678	2880083362000	4825	2397	95	0	\N
243830	1678	2880083363000	4825	2397	96	0	\N
243831	1678	2880083364000	4825	2397	97	0	\N
243832	1678	2880083365000	4825	2397	98	0	\N
243833	1678	2880083366000	4825	2397	99	0	\N
243834	1678	2880083367000	4825	2397	100	0	\N
243835	1678	2880083368000	4825	2397	101	0	\N
243836	1678	2880083369000	4825	2397	103	0	\N
243837	1678	2880083370000	4825	2397	104	0	\N
243838	1678	2880083371000	4825	2397	105	0	\N
243839	1678	2880083372000	4825	2397	106	0	\N
243840	1678	2880083373000	4825	2397	107	0	\N
243841	1678	2880083374000	4825	2397	108	0	\N
243842	1678	2880083375000	4825	2397	109	0	\N
243843	1678	2880083376000	4825	2397	110	0	\N
243844	1678	2880083377000	4825	2397	111	0	\N
243845	1678	2880083378000	4825	2397	112	0	\N
243846	1678	2880083379000	4825	2397	113	0	\N
243847	1678	2880083380000	4825	2397	114	0	\N
243848	1678	2880083381000	4825	2397	115	0	\N
243715	1678	3600093398000	4813	2492	1	0	0
243716	1678	3600093399000	4814	2493	0	0	0
243717	1678	3600093400000	4815	2494	0	0	0
243718	1826	200000000	4816	2495	0	0	1
243719	1678	3600093401000	4816	2495	1	0	0
243726	1829	0	4821	2497	0	0	0
243727	1678	3600093403000	4821	2497	1	0	0
243728	1678	3600093404000	4821	2497	2	0	0
243729	1678	3600093405000	4822	2498	0	0	0
243732	1483	0	4824	2499	0	0	0
243849	1678	2880083382000	4825	2397	116	0	\N
243850	1678	2880083383000	4825	2397	117	0	\N
243851	1678	2880083384000	4825	2397	118	0	\N
243852	1678	2880083385000	4825	2397	119	0	\N
243853	1678	2880083386000	4825	2397	120	0	\N
243854	1678	2880083387000	4825	2397	121	0	\N
243855	1678	2880083388000	4825	2397	122	0	\N
243856	1678	2880083389000	4825	2397	123	0	\N
243857	1678	2880083390000	4825	2397	124	0	\N
243858	1678	2880083391000	4825	2397	125	0	\N
243862	1678	3600093408000	4830	2502	0	0	\N
243863	1678	3600093409000	4830	2502	1	0	\N
243867	1678	2880083392000	4833	2398	0	0	\N
243868	1678	2880083393000	4833	2398	1	0	\N
243869	1678	2880083394000	4833	2398	2	0	\N
243870	1678	2880083395000	4833	2398	3	0	\N
243871	1678	2880083396000	4833	2398	4	0	\N
243872	1678	2880083397000	4833	2398	5	0	\N
243873	1678	2880083398000	4833	2398	6	0	\N
243874	1678	2880083399000	4833	2398	7	0	\N
243875	1678	2880083400000	4833	2398	8	0	\N
243876	1678	2880083401000	4833	2398	9	0	\N
243877	1678	2880083402000	4833	2398	10	0	\N
243878	1678	2880083403000	4833	2398	11	0	\N
243879	1678	2880083404000	4833	2398	12	0	\N
243880	1678	2880083405000	4833	2398	13	0	\N
243881	1678	2880083406000	4833	2398	14	0	\N
243882	1678	2880083407000	4833	2398	15	0	\N
243883	1678	2880083408000	4833	2398	16	0	\N
243884	1678	2880083409000	4833	2398	17	0	\N
243885	1678	2880083410000	4833	2398	18	0	\N
243886	1678	2880083411000	4833	2398	19	0	\N
243887	1678	2880083412000	4833	2398	20	0	\N
243888	1678	3600093411000	4834	2504	0	0	\N
243889	1678	3600093412000	4834	2504	1	0	\N
243890	1678	3600093413000	4835	2505	0	0	\N
243891	1678	3600093414000	4835	2505	1	0	\N
243892	1678	3600093415000	4835	2505	2	0	\N
243896	1678	3600093413000	4837	2505	0	0	\N
243897	1678	3600093414000	4837	2505	1	0	\N
243898	1678	3600093415000	4837	2505	2	0	\N
243903	1540	720010000000	4843	2261	0	0	\N
243904	1781	1200000000	4843	2261	1	0	\N
243905	1820	200000000	4843	2261	2	0	\N
243906	1822	200000000	4843	2261	3	0	\N
243907	1823	200000000	4843	2261	4	0	\N
243908	1824	200000000	4843	2261	5	0	\N
243909	1825	200000000	4843	2261	6	0	\N
243910	1591	400000000	4843	2261	7	0	\N
243911	1826	200000000	4843	2261	8	0	\N
243912	1827	200000000	4843	2261	9	0	\N
243913	1826	1400000000	4843	2261	10	0	\N
243914	1829	0	4843	2261	11	0	\N
243915	1773	2736097999988	4843	2261	12	0	\N
243916	1483	0	4843	2261	13	0	\N
243917	1483	0	4843	2261	14	0	\N
243918	1483	0	4843	2261	15	0	\N
243919	1821	0	4843	2261	16	0	\N
243920	1678	2880083103000	4843	2261	17	0	\N
243921	1678	2880083104000	4843	2261	18	0	\N
243922	1678	2880083105000	4843	2261	19	0	\N
243923	1678	2880083106000	4843	2261	20	0	\N
243924	1678	2880083107000	4843	2261	21	0	\N
243925	1678	2880083108000	4843	2261	22	0	\N
243926	1678	2880083109000	4843	2261	23	0	\N
243927	1678	2880083110000	4843	2261	24	0	\N
243928	1678	2880083111000	4843	2261	25	0	\N
243929	1678	2880083112000	4843	2261	26	0	\N
243930	1678	2880083113000	4843	2261	27	0	\N
243931	1678	2880083114000	4843	2261	28	0	\N
243932	1678	2880083115000	4843	2261	29	0	\N
243933	1678	2880083116000	4843	2261	30	0	\N
243934	1678	2880083117000	4843	2261	31	0	\N
243935	1678	2880083118000	4843	2261	32	0	\N
243936	1678	2880083119000	4843	2261	33	0	\N
243937	1678	2880083120000	4843	2261	34	0	\N
243938	1678	2880083121000	4843	2261	35	0	\N
243939	1678	2880083122000	4843	2261	36	0	\N
243940	1678	2880083123000	4843	2261	37	0	\N
243941	1678	2880083124000	4843	2261	38	0	\N
243942	1678	2880083125000	4843	2261	39	0	\N
243943	1678	2880083126000	4843	2261	40	0	\N
243944	1678	2880083127000	4843	2261	41	0	\N
243945	1678	2880083128000	4843	2261	42	0	\N
243946	1678	2880083129000	4843	2261	43	0	\N
243947	1678	2880083130000	4843	2261	44	0	\N
243948	1678	2880083131000	4843	2261	45	0	\N
243949	1678	2880083132000	4843	2261	46	0	\N
243950	1678	2880083133000	4843	2261	47	0	\N
243951	1678	2880083134000	4843	2261	48	0	\N
243952	1678	2880083135000	4843	2261	49	0	\N
243953	1678	2880083136000	4843	2261	50	0	\N
243954	1678	2880083137000	4843	2261	51	0	\N
243955	1678	2880083138000	4843	2261	52	0	\N
243956	1678	2880083139000	4843	2261	53	0	\N
243957	1678	2880083140000	4843	2261	54	0	\N
243958	1678	2880083141000	4843	2261	55	0	\N
243959	1678	2880083142000	4843	2261	56	0	\N
243960	1678	2880083143000	4843	2261	57	0	\N
243961	1678	2880083144000	4843	2261	58	0	\N
243962	1678	2880083145000	4843	2261	59	0	\N
243963	1678	2880083146000	4843	2261	60	0	\N
243964	1678	2880083147000	4843	2261	61	0	\N
243965	1678	2880083148000	4843	2261	62	0	\N
243966	1678	2880083149000	4843	2261	63	0	\N
243967	1678	2880083150000	4843	2261	64	0	\N
243968	1678	2880083151000	4843	2261	65	0	\N
243969	1678	2880083152000	4843	2261	66	0	\N
243970	1678	2880083153000	4843	2261	67	0	\N
243971	1678	2880083154000	4843	2261	68	0	\N
243972	1678	2880083155000	4843	2261	69	0	\N
243973	1678	2880083156000	4843	2261	70	0	\N
243974	1678	2880083157000	4843	2261	71	0	\N
243975	1678	2880083158000	4843	2261	72	0	\N
243976	1678	2880083159000	4843	2261	73	0	\N
243977	1678	2880083160000	4843	2261	74	0	\N
243978	1678	2880083161000	4843	2261	75	0	\N
243979	1678	2880083162000	4843	2261	76	0	\N
243980	1678	2880083163000	4843	2261	77	0	\N
243981	1678	2880083164000	4843	2261	78	0	\N
243982	1678	2880083165000	4843	2261	79	0	\N
243983	1678	2880083166000	4843	2261	80	0	\N
243984	1678	2880083167000	4843	2261	81	0	\N
243861	1678	3600093409000	4829	2502	1	0	0
243864	1678	3600093410000	4831	2503	0	0	0
243865	1678	3600093411000	4832	2504	0	0	0
243866	1678	3600093412000	4832	2504	1	0	0
243893	1678	3600093413000	4836	2505	0	0	0
243895	1678	3600093415000	4836	2505	2	0	0
243899	1678	3600093416000	4840	2507	0	0	0
243900	1678	3600093417000	4841	2508	0	0	0
243901	1678	3600093418000	4842	2509	0	0	0
243902	1678	3600093419000	4842	2509	1	0	0
243985	1678	2880083168000	4843	2261	82	0	\N
243986	1678	2880083169000	4843	2261	83	0	\N
243987	1678	2880083170000	4843	2261	84	0	\N
243988	1678	2880083171000	4843	2261	85	0	\N
243989	1678	2880083172000	4843	2261	87	0	\N
243990	1678	2880083173000	4843	2261	88	0	\N
243991	1678	2880083174000	4843	2261	89	0	\N
243992	1678	2880083175000	4843	2261	90	0	\N
243993	1678	2880083176000	4843	2261	91	0	\N
243994	1678	2880083177000	4843	2261	92	0	\N
243995	1678	2880083178000	4843	2261	93	0	\N
243996	1678	2880083179000	4843	2261	94	0	\N
243997	1678	2880083180000	4843	2261	95	0	\N
243998	1678	2880083181000	4843	2261	96	0	\N
243999	1678	2880083182000	4843	2261	97	0	\N
244000	1678	2880083183000	4843	2261	98	0	\N
244001	1678	2880083184000	4843	2261	99	0	\N
244002	1678	2880083185000	4843	2261	100	0	\N
244003	1678	2880083186000	4843	2261	101	0	\N
244004	1678	2880083187000	4843	2261	102	0	\N
244005	1678	2880083188000	4843	2261	103	0	\N
244006	1678	2880083189000	4843	2261	104	0	\N
244007	1678	2880083190000	4843	2261	105	0	\N
244008	1678	2880083191000	4843	2261	106	0	\N
244009	1678	2880083192000	4843	2261	107	0	\N
244010	1678	2880083193000	4843	2261	108	0	\N
244011	1678	2880083194000	4843	2261	109	0	\N
244012	1678	2880083195000	4843	2261	110	0	\N
244013	1678	2880083196000	4843	2261	111	0	\N
244014	1678	2880083197000	4843	2261	112	0	\N
244015	1678	2880083198000	4843	2261	113	0	\N
244016	1678	2880083199000	4843	2261	114	0	\N
244017	1678	2880083200000	4843	2261	115	0	\N
244018	1678	2880083201000	4843	2261	116	0	\N
244019	1678	2880083202000	4843	2261	117	0	\N
244020	1678	2880083203000	4843	2261	118	0	\N
244021	1678	2880083204000	4843	2261	119	0	\N
244022	1678	2880083205000	4843	2261	120	0	\N
244023	1678	2880083206000	4843	2261	121	0	\N
244024	1678	2880083207000	4843	2261	122	0	\N
244025	1678	2880083208000	4843	2261	123	0	\N
244026	1678	2880083209000	4843	2261	124	0	\N
244027	1678	2880083210000	4843	2261	125	0	\N
244029	1678	3600093420000	4845	2510	0	0	\N
244030	1678	3600093420000	4846	2510	0	0	\N
244032	1678	3600093422000	4848	2512	0	0	\N
244037	1831	200000000	4852	2515	0	0	\N
244038	1678	3600093425000	4852	2515	1	0	\N
244039	1831	200000000	4853	2515	0	0	\N
244040	1678	3600093425000	4853	2515	1	0	\N
244043	1678	3600093426000	4855	2516	0	0	\N
244044	1678	3600093426000	4856	2516	0	0	\N
244045	1678	3600093426000	4858	2516	0	0	\N
244047	1822	200000000	4860	2431	0	0	\N
244048	1823	200000000	4860	2431	1	0	\N
244049	1824	200000000	4860	2431	2	0	\N
244050	1825	200000000	4860	2431	3	0	\N
244051	1826	200000000	4860	2431	4	0	\N
244052	1827	200000000	4860	2431	5	0	\N
244053	1826	1400000000	4860	2431	6	0	\N
244054	1830	200000000	4860	2431	7	0	\N
244055	1831	200000000	4860	2431	8	0	\N
244056	1829	0	4860	2431	9	0	\N
244057	1678	3600093320000	4860	2431	10	0	\N
244058	1678	3600093321000	4860	2431	11	0	\N
244059	1678	3600093322000	4860	2431	12	0	\N
244060	1678	3600093323000	4860	2431	13	0	\N
244061	1678	3600093324000	4860	2431	14	0	\N
244062	1678	3600093325000	4860	2431	15	0	\N
244063	1821	150000000000	4860	2431	16	0	\N
244064	1678	3600093326000	4860	2431	17	0	\N
244065	1678	3600093327000	4860	2431	18	0	\N
244066	1678	3600093328000	4860	2431	19	0	\N
244067	1678	3600093329000	4860	2431	20	0	\N
244068	1678	3600093330000	4860	2431	21	0	\N
244069	1678	3600093331000	4860	2431	22	0	\N
244070	1483	0	4860	2431	23	0	\N
244071	1678	3600093332000	4860	2431	24	0	\N
244072	1816	100000000	4860	2431	25	0	\N
244073	1818	100000000	4860	2431	26	0	\N
244074	1678	3600093333000	4860	2431	27	0	\N
244075	1678	3600093334000	4860	2431	28	0	\N
244076	1678	3600093335000	4860	2431	29	0	\N
244077	1678	3600093336000	4860	2431	30	0	\N
244078	1678	3600093337000	4860	2431	31	0	\N
244079	1678	3600093338000	4860	2431	32	0	\N
244080	1678	3600093339000	4860	2431	33	0	\N
244081	1678	3600093340000	4860	2431	34	0	\N
244082	1678	3600093341000	4860	2431	35	0	\N
244083	1678	3600093342000	4860	2431	36	0	\N
244084	1678	3600093343000	4860	2431	37	0	\N
244085	1678	3600093344000	4860	2431	38	0	\N
244086	1678	3600093345000	4860	2431	39	0	\N
244087	1678	3600093346000	4860	2431	40	0	\N
244088	1678	3600093347000	4860	2431	41	0	\N
244089	1678	3600093348000	4860	2431	42	0	\N
244090	1678	3600093349000	4860	2431	43	0	\N
244091	1678	3600093350000	4860	2431	44	0	\N
244092	1678	3600093351000	4860	2431	45	0	\N
244093	1678	3600093352000	4860	2431	46	0	\N
244094	1678	3600093353000	4860	2431	47	0	\N
244095	1678	3600093354000	4860	2431	48	0	\N
244096	1678	3600093355000	4860	2431	49	0	\N
244097	1678	3600093356000	4860	2431	50	0	\N
244098	1678	3600093357000	4860	2431	51	0	\N
244099	1678	3600093358000	4860	2431	52	0	\N
244100	1678	3600093359000	4860	2431	53	0	\N
244101	1678	3600093360000	4860	2431	54	0	\N
244102	1678	3600093361000	4860	2431	55	0	\N
244103	1678	3600093362000	4860	2431	56	0	\N
244104	1678	3600093363000	4860	2431	57	0	\N
244105	1678	3600093364000	4860	2431	58	0	\N
244106	1678	3600093365000	4860	2431	59	0	\N
244107	1678	3600093366000	4860	2431	60	0	\N
244108	1678	3600093367000	4860	2431	61	0	\N
244109	1678	3600093368000	4860	2431	62	0	\N
244110	1678	3600093369000	4860	2431	63	0	\N
244111	1678	3600093370000	4860	2431	64	0	\N
244112	1678	3600093371000	4860	2431	65	0	\N
244113	1678	3600093372000	4860	2431	66	0	\N
244114	1678	3600093373000	4860	2431	67	0	\N
244115	1678	3600093374000	4860	2431	68	0	\N
244116	1678	3600093375000	4860	2431	69	0	\N
244117	1678	3600093376000	4860	2431	70	0	\N
244118	1678	3600093377000	4860	2431	71	0	\N
244119	1678	3600093378000	4860	2431	72	0	\N
244120	1678	3600093379000	4860	2431	73	0	\N
244033	1678	3600093422000	4849	2512	0	0	0
244034	1678	3600093423000	4850	2513	0	0	0
244035	1830	200000000	4851	2514	0	0	0
244036	1678	3600093424000	4851	2514	1	0	0
244041	1831	200000000	4854	2515	0	0	0
244046	1678	3600093426000	4859	2516	0	0	0
244121	1678	3600093380000	4860	2431	74	0	\N
244122	1678	3600093381000	4860	2431	75	0	\N
244123	1678	3600093382000	4860	2431	76	0	\N
244124	1678	3600093383000	4860	2431	77	0	\N
244125	1678	3600093384000	4860	2431	78	0	\N
244126	1678	3600093385000	4860	2431	79	0	\N
244127	1678	3600093386000	4860	2431	80	0	\N
244128	1678	3600093387000	4860	2431	81	0	\N
244129	1678	3600093388000	4860	2431	82	0	\N
244130	1678	3600093389000	4860	2431	83	0	\N
244131	1678	3600093390000	4860	2431	84	0	\N
244132	1678	3600093391000	4860	2431	85	0	\N
244133	1678	3600093392000	4860	2431	86	0	\N
244134	1678	3600093393000	4860	2431	87	0	\N
244135	1678	3600093394000	4860	2431	88	0	\N
244136	1678	3600093395000	4860	2431	89	0	\N
244137	1678	3600093396000	4860	2431	90	0	\N
244138	1678	3600093397000	4860	2431	91	0	\N
244139	1678	3600093398000	4860	2431	92	0	\N
244140	1678	3600093399000	4860	2431	93	0	\N
244141	1678	3600093400000	4860	2431	94	0	\N
244142	1678	3600093401000	4860	2431	95	0	\N
244143	1678	3600093402000	4860	2431	96	0	\N
244144	1678	3600093403000	4860	2431	97	0	\N
244145	1678	3600093404000	4860	2431	98	0	\N
244146	1678	3600093405000	4860	2431	99	0	\N
244147	1678	3600093406000	4860	2431	100	0	\N
244148	1678	3600093407000	4860	2431	101	0	\N
244149	1678	3600093408000	4860	2431	102	0	\N
244150	1678	3600093409000	4860	2431	103	0	\N
244151	1678	3600093410000	4860	2431	104	0	\N
244152	1678	3600093411000	4860	2431	105	0	\N
244153	1678	3600093412000	4860	2431	106	0	\N
244154	1678	3600093413000	4860	2431	107	0	\N
244155	1678	3600093414000	4860	2431	108	0	\N
244156	1678	3600093415000	4860	2431	109	0	\N
244157	1678	3600093416000	4860	2431	110	0	\N
244158	1678	3600093417000	4860	2431	111	0	\N
244159	1678	3600093418000	4860	2431	112	0	\N
244160	1678	3600093419000	4860	2431	113	0	\N
244161	1678	3600093420000	4860	2431	114	0	\N
244162	1678	3600093421000	4860	2431	115	0	\N
244163	1678	3600093422000	4860	2431	117	0	\N
244164	1678	3600093423000	4860	2431	118	0	\N
244165	1678	3600093424000	4860	2431	119	0	\N
244166	1678	3600093425000	4860	2431	120	0	\N
244167	1678	3600093426000	4860	2431	121	0	\N
244168	1678	3600093427000	4861	2517	0	0	\N
244169	1678	3600093428000	4861	2517	1	0	\N
244170	1678	3600093429000	4861	2517	2	0	\N
244171	1678	3600093430000	4861	2517	3	0	\N
244176	1678	3600093427000	4863	2517	0	0	\N
244177	1678	3600093428000	4863	2517	1	0	\N
244178	1678	3600093429000	4863	2517	2	0	\N
244179	1678	3600093430000	4863	2517	3	0	\N
244184	1678	3600093435000	4868	2522	0	0	\N
244185	1678	3600093435000	4869	2522	0	0	\N
244187	1678	3600093436000	4871	2523	0	0	\N
244189	1678	3600093436000	4873	2523	0	0	\N
244190	1822	200000000	4874	2326	0	0	\N
244191	1823	200000000	4874	2326	1	0	\N
244192	1824	200000000	4874	2326	2	0	\N
244193	1825	200000000	4874	2326	3	0	\N
244194	1829	0	4874	2326	4	0	\N
244195	1678	2880083284000	4874	2326	5	0	\N
244196	1678	2880083285000	4874	2326	6	0	\N
244197	1678	2880083286000	4874	2326	7	0	\N
244198	1678	2880083287000	4874	2326	8	0	\N
244199	1483	0	4874	2326	9	0	\N
244200	1816	100000000	4874	2326	10	0	\N
244201	1818	100000000	4874	2326	11	0	\N
244202	1678	2880083288000	4874	2326	12	0	\N
244203	1678	2880083289000	4874	2326	13	0	\N
244204	1678	2880083290000	4874	2326	14	0	\N
244205	1678	2880083291000	4874	2326	15	0	\N
244206	1678	2880083292000	4874	2326	16	0	\N
244207	1678	2880083293000	4874	2326	17	0	\N
244208	1821	0	4874	2326	18	0	\N
244209	1821	150000000000	4874	2326	19	0	\N
244210	1678	2880083294000	4874	2326	20	0	\N
244211	1678	2880083295000	4874	2326	21	0	\N
244212	1678	2880083296000	4874	2326	22	0	\N
244213	1678	2880083297000	4874	2326	23	0	\N
244214	1678	2880083298000	4874	2326	24	0	\N
244215	1678	2880083299000	4874	2326	25	0	\N
244216	1678	2880083300000	4874	2326	26	0	\N
244217	1678	2880083301000	4874	2326	27	0	\N
244218	1678	2880083302000	4874	2326	28	0	\N
244219	1678	2880083303000	4874	2326	29	0	\N
244220	1678	2880083304000	4874	2326	30	0	\N
244221	1678	2880083305000	4874	2326	31	0	\N
244222	1678	2880083306000	4874	2326	32	0	\N
244223	1678	2880083307000	4874	2326	33	0	\N
244224	1678	2880083308000	4874	2326	34	0	\N
244225	1678	2880083309000	4874	2326	35	0	\N
244226	1678	2880083310000	4874	2326	36	0	\N
244227	1678	2880083311000	4874	2326	37	0	\N
244228	1678	2880083312000	4874	2326	38	0	\N
244229	1678	2880083313000	4874	2326	39	0	\N
244230	1678	2880083314000	4874	2326	40	0	\N
244231	1678	2880083315000	4874	2326	41	0	\N
244232	1678	2880083316000	4874	2326	42	0	\N
244233	1678	2880083317000	4874	2326	43	0	\N
244234	1678	2880083318000	4874	2326	44	0	\N
244235	1678	2880083319000	4874	2326	45	0	\N
244236	1678	2880083320000	4874	2326	46	0	\N
244237	1678	2880083321000	4874	2326	47	0	\N
244238	1678	2880083322000	4874	2326	48	0	\N
244239	1678	2880083323000	4874	2326	49	0	\N
244240	1678	2880083324000	4874	2326	50	0	\N
244241	1678	2880083325000	4874	2326	51	0	\N
244242	1678	2880083326000	4874	2326	52	0	\N
244243	1678	2880083327000	4874	2326	53	0	\N
244244	1678	2880083328000	4874	2326	54	0	\N
244245	1678	2880083329000	4874	2326	55	0	\N
244246	1678	2880083330000	4874	2326	56	0	\N
244247	1678	2880083331000	4874	2326	57	0	\N
244248	1678	2880083332000	4874	2326	58	0	\N
244249	1678	2880083333000	4874	2326	59	0	\N
244250	1678	2880083334000	4874	2326	60	0	\N
244251	1678	2880083335000	4874	2326	61	0	\N
244252	1678	2880083336000	4874	2326	62	0	\N
244253	1678	2880083337000	4874	2326	63	0	\N
244254	1678	2880083338000	4874	2326	64	0	\N
244255	1678	2880083339000	4874	2326	65	0	\N
244256	1678	2880083340000	4874	2326	66	0	\N
244174	1678	3600093429000	4862	2517	2	0	0
244175	1678	3600093430000	4862	2517	3	0	0
244180	1678	3600093431000	4864	2518	0	0	0
244181	1678	3600093432000	4865	2519	0	0	0
244182	1678	3600093433000	4866	2520	0	0	0
244186	1678	3600093435000	4870	2522	0	0	0
244188	1678	3600093436000	4872	2523	0	0	0
244257	1678	2880083341000	4874	2326	67	0	\N
244258	1678	2880083342000	4874	2326	68	0	\N
244259	1678	2880083343000	4874	2326	69	0	\N
244260	1678	2880083344000	4874	2326	70	0	\N
244261	1678	2880083345000	4874	2326	71	0	\N
244262	1678	2880083346000	4874	2326	72	0	\N
244263	1678	2880083347000	4874	2326	73	0	\N
244264	1678	2880083348000	4874	2326	74	0	\N
244265	1678	2880083349000	4874	2326	75	0	\N
244266	1678	2880083350000	4874	2326	76	0	\N
244267	1678	2880083351000	4874	2326	77	0	\N
244268	1678	2880083352000	4874	2326	78	0	\N
244269	1678	2880083353000	4874	2326	79	0	\N
244270	1678	2880083354000	4874	2326	80	0	\N
244271	1678	2880083355000	4874	2326	81	0	\N
244272	1678	2880083356000	4874	2326	82	0	\N
244273	1678	2880083357000	4874	2326	83	0	\N
244274	1678	2880083358000	4874	2326	84	0	\N
244275	1678	2880083359000	4874	2326	85	0	\N
244276	1678	2880083360000	4874	2326	86	0	\N
244277	1678	2880083361000	4874	2326	87	0	\N
244278	1678	2880083362000	4874	2326	88	0	\N
244279	1678	2880083363000	4874	2326	89	0	\N
244280	1678	2880083364000	4874	2326	90	0	\N
244281	1678	2880083365000	4874	2326	91	0	\N
244282	1678	2880083366000	4874	2326	92	0	\N
244283	1678	2880083367000	4874	2326	93	0	\N
244284	1678	2880083368000	4874	2326	94	0	\N
244285	1678	2880083369000	4874	2326	95	0	\N
244286	1678	2880083370000	4874	2326	96	0	\N
244287	1678	2880083371000	4874	2326	97	0	\N
244288	1678	2880083372000	4874	2326	98	0	\N
244289	1678	2880083373000	4874	2326	99	0	\N
244290	1678	2880083374000	4874	2326	100	0	\N
244291	1678	2880083375000	4874	2326	101	0	\N
244292	1678	2880083376000	4874	2326	102	0	\N
244293	1678	2880083377000	4874	2326	103	0	\N
244294	1678	2880083378000	4874	2326	104	0	\N
244295	1678	2880083379000	4874	2326	105	0	\N
244296	1678	2880083380000	4874	2326	106	0	\N
244297	1678	2880083381000	4874	2326	107	0	\N
244298	1678	2880083382000	4874	2326	108	0	\N
244299	1678	2880083383000	4874	2326	109	0	\N
244300	1678	2880083384000	4874	2326	110	0	\N
244301	1678	2880083385000	4874	2326	111	0	\N
244302	1678	2880083386000	4874	2326	115	0	\N
244303	1678	2880083387000	4874	2326	116	0	\N
244304	1678	2880083388000	4874	2326	117	0	\N
244305	1678	2880083389000	4874	2326	118	0	\N
244306	1678	2880083390000	4874	2326	119	0	\N
244307	1678	2880083391000	4874	2326	120	0	\N
244308	1678	2880083392000	4874	2326	121	0	\N
244309	1678	2880083393000	4874	2326	122	0	\N
244310	1678	2880083394000	4874	2326	123	0	\N
244311	1678	2880083395000	4874	2326	124	0	\N
244312	1678	2880083396000	4874	2326	125	0	\N
244317	1678	3600093441000	4879	2528	0	0	\N
244318	1678	3600093442000	4879	2528	1	0	\N
244319	1678	3600093443000	4879	2528	2	0	\N
244320	1678	3600093441000	4880	2528	0	0	\N
244321	1678	3600093442000	4880	2528	1	0	\N
244322	1678	3600093443000	4880	2528	2	0	\N
244326	1678	3600093441000	4882	2528	0	0	\N
244327	1678	3600093442000	4882	2528	1	0	\N
244328	1678	3600093443000	4882	2528	2	0	\N
244329	1678	3600093441000	4883	2528	0	0	\N
244330	1678	3600093442000	4883	2528	1	0	\N
244331	1678	3600093443000	4883	2528	2	0	\N
244334	1678	3600093446000	4886	2531	0	0	\N
244335	1829	1000000000	4886	2531	1	0	\N
244344	1678	3600093451000	4892	2535	0	0	\N
244345	1678	3600093451000	4893	2535	0	0	\N
244346	1678	3600093451000	4894	2535	0	0	\N
244347	1830	200000000	4895	2262	0	0	\N
244348	1831	200000000	4895	2262	1	0	\N
244349	1678	2880083211000	4895	2262	2	0	\N
244350	1678	2880083212000	4895	2262	3	0	\N
244351	1678	2880083213000	4895	2262	4	0	\N
244352	1678	2880083214000	4895	2262	5	0	\N
244353	1678	2880083215000	4895	2262	6	0	\N
244354	1678	2880083216000	4895	2262	7	0	\N
244355	1678	2880083217000	4895	2262	8	0	\N
244356	1678	2880083218000	4895	2262	9	0	\N
244357	1678	2880083219000	4895	2262	10	0	\N
244358	1678	2880083220000	4895	2262	11	0	\N
244359	1678	2880083221000	4895	2262	12	0	\N
244360	1678	2880083222000	4895	2262	13	0	\N
244361	1678	2880083223000	4895	2262	14	0	\N
244362	1678	2880083224000	4895	2262	15	0	\N
244363	1678	2880083225000	4895	2262	16	0	\N
244364	1678	2880083226000	4895	2262	17	0	\N
244365	1678	2880083227000	4895	2262	18	0	\N
244366	1678	2880083228000	4895	2262	19	0	\N
244367	1678	2880083229000	4895	2262	20	0	\N
244368	1678	2880083230000	4895	2262	21	0	\N
244369	1678	2880083231000	4895	2262	22	0	\N
244370	1678	2880083232000	4895	2262	23	0	\N
244371	1678	2880083233000	4895	2262	24	0	\N
244372	1678	2880083234000	4895	2262	25	0	\N
244373	1678	2880083235000	4895	2262	26	0	\N
244374	1678	2880083236000	4895	2262	27	0	\N
244375	1678	2880083237000	4895	2262	28	0	\N
244376	1678	2880083238000	4895	2262	29	0	\N
244377	1678	2880083239000	4895	2262	30	0	\N
244378	1678	2880083240000	4895	2262	31	0	\N
244379	1678	2880083241000	4895	2262	32	0	\N
244380	1678	2880083242000	4895	2262	33	0	\N
244381	1678	2880083243000	4895	2262	34	0	\N
244382	1678	2880083244000	4895	2262	35	0	\N
244383	1678	2880083245000	4895	2262	36	0	\N
244384	1678	2880083246000	4895	2262	37	0	\N
244385	1678	2880083247000	4895	2262	38	0	\N
244386	1678	2880083248000	4895	2262	39	0	\N
244387	1678	2880083249000	4895	2262	40	0	\N
244388	1678	2880083250000	4895	2262	41	0	\N
244389	1678	2880083251000	4895	2262	42	0	\N
244390	1678	2880083252000	4895	2262	43	0	\N
244391	1678	2880083253000	4895	2262	44	0	\N
244392	1678	2880083254000	4895	2262	45	0	\N
244315	1678	3600093439000	4877	2526	0	0	0
244316	1678	3600093440000	4878	2527	0	0	0
244323	1678	3600093441000	4881	2528	0	0	0
244324	1678	3600093442000	4881	2528	1	0	0
244325	1678	3600093443000	4881	2528	2	0	0
244333	1678	3600093445000	4885	2530	0	0	0
244336	1678	3600093446000	4887	2531	0	0	0
244337	1829	1000000000	4887	2531	1	0	0
244338	1678	3600093447000	4888	2532	0	0	0
244339	1396	20000000	4889	2533	0	0	3
244341	1678	3600093449000	4889	2533	2	0	0
244342	1678	3600093450000	4890	2534	0	0	0
244343	1678	3600093451000	4891	2535	0	0	0
244393	1678	2880083255000	4895	2262	46	0	\N
244394	1678	2880083256000	4895	2262	47	0	\N
244395	1678	2880083257000	4895	2262	48	0	\N
244396	1678	2880083258000	4895	2262	49	0	\N
244397	1678	2880083259000	4895	2262	50	0	\N
244398	1678	2880083260000	4895	2262	51	0	\N
244399	1678	2880083261000	4895	2262	52	0	\N
244400	1678	2880083262000	4895	2262	53	0	\N
244401	1678	2880083263000	4895	2262	54	0	\N
244402	1678	2880083264000	4895	2262	55	0	\N
244403	1678	2880083265000	4895	2262	56	0	\N
244404	1678	2880083266000	4895	2262	57	0	\N
244405	1678	2880083267000	4895	2262	58	0	\N
244406	1678	2880083268000	4895	2262	59	0	\N
244407	1678	2880083269000	4895	2262	60	0	\N
244408	1678	2880083270000	4895	2262	61	0	\N
244409	1678	2880083271000	4895	2262	62	0	\N
244410	1678	2880083272000	4895	2262	63	0	\N
244411	1678	2880083273000	4895	2262	64	0	\N
244412	1678	2880083274000	4895	2262	65	0	\N
244413	1678	2880083275000	4895	2262	66	0	\N
244414	1678	2880083276000	4895	2262	67	0	\N
244415	1678	2880083277000	4895	2262	68	0	\N
244416	1678	2880083278000	4895	2262	69	0	\N
244417	1678	2880083279000	4895	2262	70	0	\N
244418	1678	2880083280000	4895	2262	71	0	\N
244419	1678	2880083281000	4895	2262	72	0	\N
244420	1678	2880083282000	4895	2262	73	0	\N
244421	1678	2880083283000	4895	2262	74	0	\N
244422	1678	2880083284000	4895	2262	75	0	\N
244423	1678	2880083285000	4895	2262	76	0	\N
244424	1678	2880083286000	4895	2262	77	0	\N
244425	1678	2880083287000	4895	2262	78	0	\N
244426	1678	2880083288000	4895	2262	79	0	\N
244427	1678	2880083289000	4895	2262	80	0	\N
244428	1678	2880083290000	4895	2262	81	0	\N
244429	1678	2880083291000	4895	2262	82	0	\N
244430	1678	2880083292000	4895	2262	83	0	\N
244431	1678	2880083293000	4895	2262	84	0	\N
244432	1678	2880083294000	4895	2262	85	0	\N
244433	1678	2880083295000	4895	2262	87	0	\N
244434	1678	2880083296000	4895	2262	88	0	\N
244435	1678	2880083297000	4895	2262	89	0	\N
244436	1678	2880083298000	4895	2262	90	0	\N
244437	1678	2880083299000	4895	2262	91	0	\N
244438	1678	2880083300000	4895	2262	92	0	\N
244439	1678	2880083301000	4895	2262	93	0	\N
244440	1678	2880083302000	4895	2262	94	0	\N
244441	1678	2880083303000	4895	2262	95	0	\N
244442	1678	2880083304000	4895	2262	96	0	\N
244443	1678	2880083305000	4895	2262	97	0	\N
244444	1678	2880083306000	4895	2262	98	0	\N
244445	1678	2880083307000	4895	2262	99	0	\N
244446	1678	2880083308000	4895	2262	100	0	\N
244447	1678	2880083309000	4895	2262	101	0	\N
244448	1678	2880083310000	4895	2262	102	0	\N
244449	1678	2880083311000	4895	2262	103	0	\N
244451	1678	3600093452000	4898	2536	0	0	\N
244453	1678	3600093453000	4901	2537	0	0	\N
244454	1678	3600093454000	4903	2538	0	0	\N
244456	1678	3600093455000	4905	2539	0	0	\N
244461	436	66718610000000	4909	2541	0	0	\N
244462	1678	3600093456000	4909	2541	1	0	\N
244463	1678	3600093457000	4909	2541	2	0	\N
244464	436	66718610000000	4910	2541	0	0	\N
244465	1678	3600093456000	4910	2541	1	0	\N
244466	1678	3600093457000	4910	2541	2	0	\N
244467	436	66718610000000	4911	2541	0	0	\N
244468	1678	3600093456000	4911	2541	1	0	\N
244469	1678	3600093457000	4911	2541	2	0	\N
244470	1678	3600093458000	4912	2542	0	0	\N
244471	1678	3600093458000	4913	2542	0	0	\N
244479	1678	3600093462000	4917	2544	0	0	\N
244480	1678	3600093463000	4917	2544	1	0	\N
244482	1678	3600093464000	4919	2545	0	0	\N
244483	1678	3600093464000	4920	2545	0	0	\N
244486	1678	3600093466000	4923	2547	0	0	\N
244488	1678	3600093467000	4925	2548	0	0	\N
244490	1678	3600093469000	4927	2550	0	0	\N
244495	1678	3600093473000	4930	2552	0	0	\N
244496	1678	3600093474000	4930	2552	1	0	\N
244507	1678	3600093481000	4937	2557	0	0	\N
244509	1822	200000000	4939	2420	0	0	\N
244510	1823	200000000	4939	2420	1	0	\N
244511	1824	200000000	4939	2420	2	0	\N
244512	1825	200000000	4939	2420	3	0	\N
244513	1826	200000000	4939	2420	4	0	\N
244514	1827	200000000	4939	2420	5	0	\N
244515	1826	1400000000	4939	2420	6	0	\N
244516	1830	200000000	4939	2420	7	0	\N
244517	1831	200000000	4939	2420	8	0	\N
244518	1832	200000000	4939	2420	9	0	\N
244519	1833	200000000	4939	2420	10	0	\N
244520	1829	0	4939	2420	11	0	\N
244521	1492	21000000	4939	2420	12	0	\N
244522	1483	0	4939	2420	13	0	\N
244523	1816	100000000	4939	2420	14	0	\N
244524	1818	100000000	4939	2420	15	0	\N
244525	1829	1000000000	4939	2420	16	0	\N
244527	1678	3600093483000	4941	2559	0	0	\N
244455	1678	3600093454000	4904	2538	0	0	0
244457	1678	3600093455000	4906	2539	0	0	0
244458	436	66718610000000	4908	2541	0	0	3
244459	1678	3600093456000	4908	2541	1	0	0
244460	1678	3600093457000	4908	2541	2	0	0
244473	1832	200000000	4915	2543	0	0	0
244474	1678	3600093459000	4915	2543	1	0	0
244475	1678	3600093460000	4915	2543	2	0	0
244476	1678	3600093461000	4915	2543	3	0	0
244477	1678	3600093462000	4916	2544	0	0	0
244481	1678	3600093464000	4918	2545	0	0	0
244484	1678	3600093465000	4921	2546	0	0	0
244485	1678	3600093466000	4922	2547	0	0	0
244487	1678	3600093467000	4924	2548	0	0	0
244491	1678	3600093469000	4928	2550	0	0	0
244492	1678	3600093470000	4929	2551	0	0	0
244493	1678	3600093471000	4929	2551	1	0	0
244494	1678	3600093472000	4929	2551	2	0	0
244497	1678	3600093473000	4931	2552	0	0	0
244499	1678	3600093475000	4932	2553	0	0	0
244500	1678	3600093476000	4932	2553	1	0	0
244501	1678	3600093477000	4932	2553	2	0	0
244502	1833	200000000	4933	2554	0	0	0
244503	1678	3600093478000	4933	2554	1	0	0
244505	1678	3600093479000	4934	2555	1	0	0
244506	1678	3600093480000	4936	2556	0	0	0
244508	1678	3600093481000	4938	2557	0	0	0
244526	1678	3600093482000	4940	2558	0	0	0
244530	1678	3600093484000	4944	2560	0	0	\N
244531	1678	3600093485000	4945	2561	0	0	\N
244532	1678	3600093485000	4946	2561	0	0	\N
244534	1678	3600093486000	4948	2562	0	0	\N
244544	1678	3600093495000	4954	2567	0	0	\N
244548	1678	3600093498000	4958	2570	0	0	\N
244553	1678	3600093501000	4961	2572	0	0	\N
244554	1678	3600093502000	4961	2572	1	0	\N
244557	1678	3600093501000	4963	2572	0	0	\N
244558	1678	3600093502000	4963	2572	1	0	\N
244562	1678	3600093504000	4966	2574	0	0	\N
244563	1678	3600093505000	4966	2574	1	0	\N
244566	1678	3600093508000	4969	2577	0	0	\N
244567	1678	3600093509000	4969	2577	1	0	\N
244570	1678	3600093510000	4971	2578	0	0	\N
244571	1678	3600093510000	4972	2578	0	0	\N
244575	1678	3600093513000	4976	2581	0	0	\N
244576	1678	3600093514000	4976	2581	1	0	\N
244577	1678	3600093515000	4976	2581	2	0	\N
244581	1678	3600093513000	4978	2581	0	0	\N
244582	1678	3600093514000	4978	2581	1	0	\N
244583	1678	3600093515000	4978	2581	2	0	\N
244584	1678	3600093516000	4979	2582	1	0	\N
244585	1678	3600093517000	4979	2582	2	0	\N
244586	1678	3600093518000	4979	2582	3	0	\N
244590	1678	3600093516000	4981	2582	1	0	\N
244591	1678	3600093517000	4981	2582	2	0	\N
244592	1678	3600093518000	4981	2582	3	0	\N
244594	1678	3600093519000	4983	2583	0	0	\N
244598	1678	3600093520000	4985	2584	0	0	\N
244599	1678	3600093521000	4985	2584	1	0	\N
244600	1678	3600093522000	4985	2584	2	0	\N
244601	1678	3600093520000	4986	2584	0	0	\N
244602	1678	3600093521000	4986	2584	1	0	\N
244603	1678	3600093522000	4986	2584	2	0	\N
244604	1678	3600093520000	4987	2584	0	0	\N
244605	1678	3600093521000	4987	2584	1	0	\N
244606	1678	3600093522000	4987	2584	2	0	\N
244610	1678	3600093526000	4990	2587	0	0	\N
244612	1678	3600093526000	4992	2587	0	0	\N
244618	1835	200000000	4995	2589	0	0	\N
244619	1678	3600093528000	4995	2589	1	0	\N
244620	1678	3600093529000	4995	2589	2	0	\N
244621	1678	3600093530000	4995	2589	3	0	\N
244625	1678	3600093534000	4998	2592	0	0	\N
244628	1678	3600093535000	5001	2593	0	0	\N
244629	1678	3600093536000	5002	2594	0	0	\N
244631	1678	3600093536000	5004	2594	0	0	\N
244632	1678	3600093536000	5005	2594	0	0	\N
244633	1678	3600093536000	5006	2594	0	0	\N
244636	1836	200000000	5008	2595	0	0	\N
244637	1678	3600093537000	5008	2595	1	0	\N
244640	1678	3600093540000	5011	2598	0	0	\N
244654	1837	200000000	5022	2608	0	0	\N
244655	1678	3600093553000	5022	2608	1	0	\N
244659	1678	3600093554000	5025	2609	0	0	\N
244660	1678	3600093554000	5026	2609	0	0	\N
244661	1678	3600093554000	5027	2609	0	0	\N
244663	1678	3600093555000	5030	2610	0	0	\N
244535	1678	3600093486000	4949	2562	0	0	0
244536	1678	3600093487000	4950	2563	0	0	0
244537	1678	3600093488000	4950	2563	1	0	0
244538	1678	3600093489000	4950	2563	2	0	0
244539	1678	3600093490000	4950	2563	3	0	0
244541	1678	3600093492000	4951	2564	0	0	0
244542	1678	3600093493000	4952	2565	0	0	0
244543	1678	3600093494000	4953	2566	0	0	0
244545	1678	3600093495000	4955	2567	0	0	0
244546	1678	3600093496000	4956	2568	0	0	0
244549	1678	3600093498000	4959	2570	0	0	0
244550	1834	200000000	4960	2571	0	0	0
244551	1678	3600093499000	4960	2571	1	0	0
244552	1678	3600093500000	4960	2571	2	0	0
244556	1678	3600093502000	4962	2572	1	0	0
244559	1678	3600093503000	4964	2573	0	0	0
244560	1678	3600093504000	4965	2574	0	0	0
244561	1678	3600093505000	4965	2574	1	0	0
244564	1678	3600093506000	4967	2575	0	0	0
244568	1678	3600093508000	4970	2577	0	0	0
244569	1678	3600093509000	4970	2577	1	0	0
244572	1678	3600093510000	4973	2578	0	0	0
244573	1678	3600093511000	4974	2579	1	0	0
244574	1678	3600093512000	4975	2580	0	0	0
244579	1678	3600093514000	4977	2581	1	0	0
244580	1678	3600093515000	4977	2581	2	0	0
244587	1678	3600093516000	4980	2582	1	0	0
244588	1678	3600093517000	4980	2582	2	0	0
244593	1678	3600093519000	4982	2583	0	0	0
244595	1678	3600093520000	4984	2584	0	0	0
244596	1678	3600093521000	4984	2584	1	0	0
244597	1678	3600093522000	4984	2584	2	0	0
244607	1678	3600093523000	4988	2585	0	0	0
244609	1678	3600093525000	4989	2586	1	0	0
244611	1678	3600093526000	4991	2587	0	0	0
244613	1678	3600093527000	4993	2588	0	0	0
244614	1835	200000000	4994	2589	0	0	0
244615	1678	3600093528000	4994	2589	1	0	0
244617	1678	3600093530000	4994	2589	3	0	0
244622	1678	3600093531000	4996	2590	0	0	0
244623	1678	3600093532000	4997	2591	1	0	0
244624	1678	3600093533000	4997	2591	2	0	0
244627	1678	3600093535000	5000	2593	0	0	0
244630	1678	3600093536000	5003	2594	0	0	0
244634	1836	200000000	5007	2595	0	0	0
244635	1678	3600093537000	5007	2595	1	0	0
244638	1678	3600093538000	5009	2596	0	0	0
244641	1678	3600093540000	5012	2598	0	0	0
244642	1678	3600093541000	5013	2599	0	0	0
244643	1678	3600093542000	5014	2600	0	0	0
244644	1678	3600093543000	5015	2601	0	0	0
244645	1678	3600093544000	5016	2602	0	0	0
244647	1678	3600093546000	5017	2603	1	0	0
244648	1678	3600093547000	5018	2604	0	0	0
244649	1678	3600093548000	5019	2605	0	0	0
244650	1678	3600093549000	5019	2605	1	0	0
244652	1678	3600093551000	5021	2607	0	0	0
244653	1678	3600093552000	5021	2607	1	0	0
244656	1837	200000000	5023	2608	0	0	0
244657	1678	3600093553000	5023	2608	1	0	0
244658	1678	3600093554000	5024	2609	0	0	0
244664	1678	3600093556000	5031	2611	0	0	0
244665	1678	3600093556000	5032	2611	0	0	\N
244667	1678	3600093557000	5034	2612	0	0	\N
244668	1678	3600093557000	5035	2612	0	0	\N
244669	1678	3600093557000	5036	2612	0	0	\N
244670	1678	3600093558000	5037	2613	0	0	\N
244671	1678	3600093559000	5037	2613	1	0	\N
244674	1678	3600093560000	5039	2614	0	0	\N
244675	1678	3600093561000	5039	2614	1	0	\N
244678	1678	3600093562000	5041	2615	0	0	\N
244679	1678	3600093562000	5042	2615	0	0	\N
244680	1678	3600093562000	5043	2615	0	0	\N
244681	1678	3600093560000	5044	2614	0	0	\N
244682	1678	3600093561000	5044	2614	1	0	\N
244683	1678	3600093562000	5044	2614	2	0	\N
244697	1678	3600093574000	5053	2623	0	0	\N
244699	1678	3600093573000	5055	2622	0	0	\N
244701	1678	3600093576000	5058	2625	0	0	\N
244702	1678	3600093576000	5059	2625	0	0	\N
244705	1678	3600093578000	5062	2627	0	0	\N
244706	1678	3600093578000	5063	2627	0	0	\N
244708	1678	3600093578000	5065	2627	0	0	\N
244711	1678	3600093581000	5067	2629	0	0	\N
244713	1678	3600093581000	5069	2629	0	0	\N
244714	1678	3600093579000	5070	2628	0	0	\N
244715	1678	3600093580000	5070	2628	1	0	\N
244716	1678	3600093581000	5070	2628	2	0	\N
244719	1678	3600093583000	5073	2631	0	0	\N
244728	1678	3600093591000	5078	2636	0	0	\N
244729	1406	0	5078	2636	1	0	\N
244730	1678	3600093591000	5079	2636	0	0	\N
244731	1406	0	5079	2636	1	0	\N
244732	1678	3600093591000	5080	2636	0	0	\N
244733	1406	0	5080	2636	1	0	\N
244735	1406	0	5082	2636	0	0	\N
244739	1678	3600093593000	5085	2639	0	0	\N
244740	1678	3600093594000	5085	2639	1	0	\N
244741	1678	3600093593000	5086	2639	0	0	\N
244742	1678	3600093594000	5086	2639	1	0	\N
244746	1678	3600093596000	5089	2641	0	0	\N
244747	1678	3600093597000	5089	2641	1	0	\N
244748	1678	3600093596000	5090	2641	0	0	\N
244749	1678	3600093597000	5090	2641	1	0	\N
244756	1678	3600093602000	5095	2645	0	0	\N
244757	1678	3600093603000	5095	2645	1	0	\N
244767	1678	3600093609000	5102	2649	0	0	\N
244768	1678	3600093609000	5103	2649	0	0	\N
244769	1678	3600093610000	5104	2650	0	0	\N
244770	1678	3600093610000	5105	2650	0	0	\N
244774	1678	3600093613000	5109	2653	0	0	\N
244775	1678	3600093613000	5110	2653	0	0	\N
244777	1678	3600093614000	5112	2654	0	0	\N
244779	1678	3600093614000	5114	2654	0	0	\N
244780	1678	3600093614000	5115	2654	0	0	\N
244781	1678	3600093615000	5115	2654	1	0	\N
244782	1678	3600093615000	5116	2655	0	0	\N
244783	1678	3600093615000	5117	2655	0	0	\N
244784	1678	3600093615000	5119	2655	0	0	\N
244785	1678	3600093616000	5119	2655	1	0	\N
244786	1678	3600093615000	5120	2656	0	0	\N
244787	1678	3600093616000	5120	2656	1	0	\N
244790	1678	3600093617000	5122	2657	0	0	\N
244791	1678	3600093618000	5122	2657	1	0	\N
244797	1678	3600093622000	5125	2659	0	0	\N
244798	1678	3600093623000	5125	2659	1	0	\N
244799	1678	3600093622000	5126	2659	0	0	\N
244800	1678	3600093623000	5126	2659	1	0	\N
244673	1678	3600093559000	5038	2613	1	0	0
244676	1678	3600093560000	5040	2614	0	0	0
244677	1678	3600093561000	5040	2614	1	0	0
244684	1678	3600093562000	5046	2616	0	0	0
244685	1678	3600093563000	5046	2616	1	0	0
244687	1678	3600093565000	5048	2618	0	0	0
244688	1678	3600093566000	5048	2618	1	0	0
244689	1678	3600093567000	5048	2618	2	0	0
244690	1678	3600093568000	5048	2618	3	0	0
244691	1678	3600093569000	5049	2619	0	0	0
244693	649	66000100000000	5051	2621	0	0	0
244694	1678	3600093571000	5051	2621	1	0	0
244695	1678	3600093572000	5051	2621	2	0	0
244696	1678	3600093573000	5052	2622	0	0	0
244700	1678	3600093575000	5056	2624	0	0	0
244703	1678	3600093576000	5060	2625	0	0	0
244704	1678	3600093577000	5061	2626	0	0	0
244707	1678	3600093578000	5064	2627	0	0	0
244709	1678	3600093579000	5066	2628	0	0	0
244712	1678	3600093581000	5068	2629	0	0	0
244717	1678	3600093582000	5071	2630	0	0	0
244718	1678	3600093583000	5072	2631	0	0	0
244720	1678	3600093584000	5074	2632	0	0	0
244721	1678	3600093585000	5075	2633	0	0	0
244723	1678	3600093586000	5075	2633	2	0	0
244724	1678	3600093587000	5075	2633	3	0	0
244725	1678	3600093588000	5076	2634	0	0	0
244726	1678	3600093589000	5076	2634	1	0	0
244734	1406	0	5081	2636	0	0	0
244736	1678	3600093591000	5083	2637	0	0	0
244737	1765	40000000	5084	2638	0	0	2
244738	1678	3600093592000	5084	2638	1	0	0
244743	1678	3600093593000	5087	2639	0	0	0
244745	1678	3600093595000	5088	2640	0	0	0
244750	1678	3600093596000	5091	2641	0	0	0
244751	1678	3600093597000	5091	2641	1	0	0
244752	1678	3600093598000	5092	2642	0	0	0
244753	1678	3600093599000	5093	2643	0	0	0
244755	1678	3600093601000	5094	2644	1	0	0
244758	1678	3600093602000	5096	2645	0	0	0
244759	1678	3600093603000	5096	2645	1	0	0
244760	1678	3600093604000	5098	2646	0	0	0
244762	1678	3600093606000	5098	2646	2	0	0
244763	1678	3600093607000	5099	2647	0	0	0
244764	1483	0	5100	2648	0	0	0
244765	1678	3600093608000	5100	2648	1	0	0
244766	1678	3600093609000	5101	2649	0	0	0
244772	1678	3600093611000	5107	2651	0	0	0
244773	1678	3600093612000	5108	2652	0	0	0
244776	1678	3600093613000	5111	2653	0	0	0
244778	1678	3600093614000	5113	2654	0	0	0
244788	1678	3600093615000	5121	2656	0	0	0
244792	1678	3600093617000	5123	2657	0	0	0
244793	1678	3600093618000	5123	2657	1	0	0
244794	1678	3600093619000	5124	2658	0	0	0
244795	1678	3600093620000	5124	2658	1	0	0
244801	1678	3600093622000	5127	2659	0	0	\N
244802	1678	3600093623000	5127	2659	1	0	\N
244803	1678	3600093622000	5128	2659	0	0	\N
244804	1678	3600093623000	5128	2659	1	0	\N
244805	1678	3600093622000	5129	2659	0	0	\N
244806	1678	3600093623000	5129	2659	1	0	\N
244810	1678	3600093624000	5132	2660	0	0	\N
244811	1678	3600093625000	5132	2660	1	0	\N
244812	1678	3600093626000	5132	2660	2	0	\N
244813	1678	3600093625000	5133	2661	0	0	\N
244814	1678	3600093626000	5133	2661	1	0	\N
244815	1678	3600093627000	5133	2661	2	0	\N
244816	1678	3600093628000	5133	2661	3	0	\N
244823	1678	3600093629000	5136	2662	0	0	\N
244826	1838	200000000	5138	2663	0	0	\N
244827	1678	3600093631000	5138	2663	1	0	\N
244828	1838	200000000	5139	2663	0	0	\N
244829	1678	3600093631000	5139	2663	1	0	\N
244830	1838	200000000	5140	2663	0	0	\N
244831	1678	3600093631000	5140	2663	1	0	\N
244832	1838	200000000	5141	2663	0	0	\N
244833	1678	3600093631000	5141	2663	1	0	\N
244842	1678	3600093639000	5147	2669	0	0	\N
244844	1678	3600093640000	5149	2670	0	0	\N
244845	1678	3600093641000	5149	2670	1	0	\N
244849	1678	3600093642000	5152	2671	0	0	\N
244857	1678	3600093650000	5159	2678	0	0	\N
244858	1678	3600093650000	5160	2678	0	0	\N
244859	1678	3600093650000	5161	2678	0	0	\N
244862	1678	3600093651000	5164	2679	0	0	\N
244868	1678	3600093656000	5169	2683	0	0	\N
244873	1678	3600093661000	5175	2687	0	0	\N
244874	1678	3600093662000	5175	2687	1	0	\N
244875	1678	3600093661000	5176	2687	0	0	\N
244876	1678	3600093662000	5176	2687	1	0	\N
244877	1678	3600093661000	5178	2688	0	0	\N
244878	1678	3600093662000	5178	2688	1	0	\N
244879	1678	3600093663000	5178	2688	2	0	\N
244880	1678	3600093661000	5179	2689	0	0	\N
244881	1678	3600093662000	5179	2689	1	0	\N
244882	1678	3600093663000	5179	2689	2	0	\N
244883	1678	3600093664000	5179	2689	3	0	\N
244884	1678	3600093665000	5179	2689	4	0	\N
244897	1678	3600093672000	5187	2695	0	0	\N
244903	1678	3600093678000	5191	2699	0	0	\N
244907	1678	3600093680000	5195	2701	0	0	\N
244909	1678	3600093681000	5197	2702	0	0	\N
244915	1678	3600093684000	5201	2705	0	0	\N
244916	1678	3600093685000	5201	2705	1	0	\N
244917	1678	3600093684000	5202	2705	0	0	\N
244918	1678	3600093685000	5202	2705	1	0	\N
244920	1678	3600093687000	5204	2707	0	0	\N
244931	1678	3600093696000	5218	2714	0	0	\N
244932	1678	3600093697000	5218	2714	1	0	\N
244933	1678	3600093696000	5219	2714	0	0	\N
244934	1678	3600093697000	5219	2714	1	0	\N
244935	1678	3600093696000	5220	2714	0	0	\N
244936	1678	3600093697000	5220	2714	1	0	\N
244809	1678	3600093624000	5131	2660	0	0	0
244817	1678	3600093625000	5134	2661	0	0	0
244818	1678	3600093626000	5134	2661	1	0	0
244819	1678	3600093627000	5134	2661	2	0	0
244820	1678	3600093628000	5134	2661	3	0	0
244822	1678	3600093630000	5135	2662	1	0	0
244824	1838	200000000	5137	2663	0	0	0
244825	1678	3600093631000	5137	2663	1	0	0
244834	1678	3600093632000	5142	2664	0	0	0
244835	1678	3600093633000	5142	2664	1	0	0
244837	1678	3600093635000	5143	2665	1	0	0
244838	1678	3600093636000	5144	2666	0	0	0
244839	1678	3600093637000	5145	2667	0	0	0
244840	1429	0	5145	2667	1	0	1
244843	1678	3600093639000	5148	2669	0	0	0
244846	1678	3600093640000	5150	2670	0	0	0
244847	1678	3600093641000	5150	2670	1	0	0
244848	1678	3600093642000	5151	2671	0	0	0
244850	1678	3600093643000	5153	2672	0	0	0
244852	1678	3600093645000	5155	2674	0	0	0
244853	1678	3600093646000	5156	2675	0	0	0
244854	1678	3600093647000	5157	2676	0	0	0
244855	1678	3600093648000	5157	2676	1	0	0
244856	1678	3600093649000	5158	2677	0	0	0
244861	1678	3600093651000	5163	2679	0	0	0
244863	1678	3600093652000	5165	2680	0	0	0
244864	1678	3600093653000	5166	2681	0	0	0
244865	1678	3600093654000	5166	2681	1	0	0
244867	1678	3600093656000	5168	2683	0	0	0
244869	1678	3600093657000	5170	2684	0	0	0
244870	1678	3600093658000	5170	2684	1	0	0
244871	1678	3600093659000	5170	2684	2	0	0
244872	1678	3600093660000	5171	2685	0	0	0
244886	1678	3600093662000	5180	2689	1	0	0
244887	1678	3600093663000	5180	2689	2	0	0
244888	1678	3600093664000	5180	2689	3	0	0
244889	1678	3600093665000	5180	2689	4	0	0
244890	1678	3600093666000	5181	2690	0	0	0
244892	1678	3600093668000	5183	2692	0	0	0
244893	1678	3600093669000	5183	2692	1	0	0
244894	1678	3600093670000	5184	2693	0	0	0
244895	1678	3600093671000	5185	2694	0	0	0
244898	1678	3600093673000	5188	2696	0	0	0
244899	1678	3600093674000	5188	2696	1	0	0
244900	1678	3600093675000	5189	2697	0	0	0
244901	1678	3600093676000	5190	2698	0	0	0
244902	1678	3600093677000	5190	2698	1	0	0
244905	1678	3600093679000	5193	2700	0	0	0
244906	1678	3600093680000	5194	2701	0	0	0
244908	1678	3600093681000	5196	2702	0	0	0
244910	1678	3600093682000	5198	2703	0	0	0
244911	1678	3600093683000	5199	2704	0	0	0
244913	1678	3600093684000	5200	2705	0	0	0
244914	1678	3600093685000	5200	2705	1	0	0
244919	1678	3600093686000	5203	2706	0	0	0
244921	1678	3600093687000	5205	2707	0	0	0
244923	1678	3600093689000	5208	2709	0	0	0
244924	1678	3600093690000	5209	2710	0	0	0
244925	1678	3600093691000	5209	2710	1	0	0
244926	1839	200000000	5215	2711	0	0	0
244927	1678	3600093692000	5215	2711	1	0	0
244929	1678	3600093694000	5216	2712	0	0	0
244930	1678	3600093695000	5217	2713	0	0	0
244940	1678	3600093698000	5223	2715	0	0	\N
244941	1678	3600093699000	5224	2716	0	0	\N
244943	1678	3600093699000	5226	2716	0	0	\N
244946	1678	3600093702000	5229	2719	0	0	\N
244947	1678	3600093703000	5229	2719	1	0	\N
244948	1678	3600093702000	5230	2719	0	0	\N
244949	1678	3600093703000	5230	2719	1	0	\N
244952	1678	3600093704000	5237	2720	0	0	\N
244953	1678	3600093705000	5237	2720	1	0	\N
244954	1678	3600093706000	5237	2720	2	0	\N
244955	1678	3600093704000	5238	2720	0	0	\N
244956	1678	3600093705000	5238	2720	1	0	\N
244957	1678	3600093706000	5238	2720	2	0	\N
244961	1678	3600093704000	5241	2720	0	0	\N
244962	1678	3600093705000	5241	2720	1	0	\N
244963	1678	3600093706000	5241	2720	2	0	\N
244966	1678	3600093708000	5246	2722	0	0	\N
244969	1678	3600093711000	5252	2726	0	0	\N
244970	1678	3600093712000	5252	2726	1	0	\N
244976	1678	3600093715000	5261	2730	0	0	\N
244983	1678	3600093721000	5265	2734	0	0	\N
244987	1483	0	5268	2735	0	0	\N
244988	1678	3600093722000	5268	2735	1	0	\N
244991	1678	3600093723000	5270	2736	0	0	\N
244992	1678	3600093724000	5270	2736	1	0	\N
245000	1678	3600093732000	5276	2742	0	0	\N
245001	1678	3600093733000	5276	2742	1	0	\N
245004	1678	3600093732000	5278	2742	0	0	\N
245005	1678	3600093733000	5278	2742	1	0	\N
245006	1678	3600093732000	5279	2742	0	0	\N
245007	1678	3600093733000	5279	2742	1	0	\N
245008	1678	3600093734000	5280	2743	0	0	\N
245010	1678	3600093734000	5282	2743	0	0	\N
245011	1678	3600093734000	5283	2743	0	0	\N
245015	1678	3600093738000	5287	2747	0	0	\N
245016	1678	3600093739000	5287	2747	1	0	\N
245019	1678	3600093740000	5289	2748	0	0	\N
245021	1678	3600093741000	5291	2749	0	0	\N
245022	1678	3600093741000	5292	2749	0	0	\N
245026	1678	3600093744000	5296	2752	0	0	\N
245028	1678	3600093744000	5298	2752	0	0	\N
245029	1678	3600093745000	5299	2753	0	0	\N
245030	1678	3600093746000	5299	2753	1	0	\N
245034	1678	3600093748000	5302	2755	0	0	\N
245041	1678	3600093753000	5307	2759	0	0	\N
245046	1678	3600093757000	5311	2762	0	0	\N
245047	1678	3600093757000	5312	2762	0	0	\N
245049	1678	3600093758000	5314	2763	0	0	\N
245050	1678	3600093758000	5315	2763	0	0	\N
245052	1678	3600093759000	5317	2764	0	0	\N
245053	1678	3600093759000	5318	2764	0	0	\N
245055	1678	3600093759000	5320	2764	0	0	\N
245056	1678	3600093759000	5321	2764	0	0	\N
245058	1678	3600093760000	5323	2765	0	0	\N
245059	1678	3600093760000	5324	2765	0	0	\N
245060	1838	200000000	5325	2656	0	0	\N
245061	1839	200000000	5325	2656	1	0	\N
245062	1678	3600093616000	5325	2656	2	0	\N
245063	1483	0	5325	2656	3	0	\N
245064	1816	100000000	5325	2656	4	0	\N
245065	1483	0	5325	2656	5	0	\N
245066	1678	3600093617000	5325	2656	6	0	\N
245067	1678	3600093618000	5325	2656	7	0	\N
245068	1678	3600093619000	5325	2656	8	0	\N
245069	1678	3600093620000	5325	2656	9	0	\N
245070	1429	0	5325	2656	10	0	\N
245071	1678	3600093621000	5325	2656	11	0	\N
245072	1678	3600093622000	5325	2656	12	0	\N
244939	1678	3600093698000	5222	2715	0	0	0
244942	1678	3600093699000	5225	2716	0	0	0
244944	1678	3600093700000	5227	2717	0	0	0
244945	1678	3600093701000	5228	2718	0	0	0
244950	1678	3600093702000	5231	2719	0	0	0
244958	1678	3600093704000	5239	2720	0	0	0
244959	1678	3600093705000	5239	2720	1	0	0
244960	1678	3600093706000	5239	2720	2	0	0
244964	1678	3600093707000	5244	2721	0	0	0
244965	1678	3600093708000	5245	2722	0	0	0
244968	1678	3600093710000	5248	2724	0	0	0
244971	1678	3600093711000	5253	2726	0	0	0
244972	1678	3600093712000	5253	2726	1	0	0
244973	1678	3600093713000	5256	2728	0	0	0
244975	1678	3600093715000	5260	2730	0	0	0
244977	1678	3600093716000	5262	2731	0	0	0
244978	1678	3600093717000	5262	2731	1	0	0
244979	1678	3600093718000	5263	2732	0	0	0
244980	1678	3600093719000	5263	2732	1	0	0
244982	1483	0	5264	2733	1	0	0
244984	1678	3600093721000	5266	2734	0	0	0
244985	1483	0	5267	2735	0	0	0
244986	1678	3600093722000	5267	2735	1	0	0
244989	1678	3600093723000	5269	2736	0	0	0
244993	1678	3600093725000	5271	2737	0	0	0
244994	1678	3600093726000	5272	2738	0	0	0
244995	1678	3600093727000	5272	2738	1	0	0
244996	1678	3600093728000	5273	2739	0	0	0
244998	1678	3600093730000	5274	2740	0	0	0
244999	1678	3600093731000	5275	2741	0	0	0
245002	1678	3600093732000	5277	2742	0	0	0
245003	1678	3600093733000	5277	2742	1	0	0
245009	1678	3600093734000	5281	2743	0	0	0
245013	1678	3600093736000	5285	2745	0	0	0
245014	1678	3600093737000	5286	2746	0	0	0
245017	1678	3600093738000	5288	2747	0	0	0
245018	1678	3600093739000	5288	2747	1	0	0
245020	1678	3600093740000	5290	2748	0	0	0
245024	1678	3600093742000	5294	2750	0	0	0
245025	1678	3600093743000	5295	2751	0	0	0
245027	1678	3600093744000	5297	2752	0	0	0
245031	1678	3600093745000	5300	2753	0	0	0
245033	1678	3600093747000	5301	2754	0	0	0
245035	1678	3600093748000	5303	2755	0	0	0
245036	1678	3600093749000	5304	2756	0	0	0
245037	1678	3600093750000	5305	2757	0	0	0
245038	1678	3600093751000	5305	2757	1	0	0
245040	1840	1000000000	5306	2758	1	0	0
245042	1678	3600093753000	5308	2759	0	0	0
245043	1678	3600093754000	5309	2760	0	0	0
245044	1678	3600093755000	5310	2761	0	0	0
245045	1678	3600093756000	5310	2761	1	0	0
245051	1678	3600093758000	5316	2763	0	0	0
245054	1678	3600093759000	5319	2764	0	0	0
245057	1678	3600093760000	5322	2765	0	0	0
245073	1678	3600093623000	5325	2656	13	0	\N
245074	1678	3600093624000	5325	2656	14	0	\N
245075	1678	3600093625000	5325	2656	15	0	\N
245076	1678	3600093626000	5325	2656	16	0	\N
245077	1678	3600093627000	5325	2656	17	0	\N
245078	1678	3600093628000	5325	2656	18	0	\N
245079	1678	3600093629000	5325	2656	19	0	\N
245080	1678	3600093630000	5325	2656	20	0	\N
245081	1678	3600093631000	5325	2656	21	0	\N
245082	1678	3600093632000	5325	2656	22	0	\N
245083	1678	3600093633000	5325	2656	23	0	\N
245084	1678	3600093634000	5325	2656	24	0	\N
245085	1678	3600093635000	5325	2656	25	0	\N
245086	1678	3600093636000	5325	2656	26	0	\N
245087	1678	3600093637000	5325	2656	27	0	\N
245088	1678	3600093638000	5325	2656	28	0	\N
245089	1678	3600093639000	5325	2656	29	0	\N
245090	1678	3600093640000	5325	2656	30	0	\N
245091	1678	3600093641000	5325	2656	31	0	\N
245092	1678	3600093642000	5325	2656	32	0	\N
245093	1678	3600093643000	5325	2656	33	0	\N
245094	1678	3600093644000	5325	2656	34	0	\N
245095	1678	3600093645000	5325	2656	35	0	\N
245096	1678	3600093646000	5325	2656	36	0	\N
245097	1678	3600093647000	5325	2656	37	0	\N
245098	1678	3600093648000	5325	2656	38	0	\N
245099	1678	3600093649000	5325	2656	39	0	\N
245100	1678	3600093650000	5325	2656	40	0	\N
245101	1678	3600093651000	5325	2656	41	0	\N
245102	1678	3600093652000	5325	2656	42	0	\N
245103	1678	3600093653000	5325	2656	43	0	\N
245104	1678	3600093654000	5325	2656	44	0	\N
245105	1678	3600093655000	5325	2656	45	0	\N
245106	1678	3600093656000	5325	2656	46	0	\N
245107	1678	3600093657000	5325	2656	47	0	\N
245108	1678	3600093658000	5325	2656	48	0	\N
245109	1678	3600093659000	5325	2656	49	0	\N
245110	1678	3600093660000	5325	2656	50	0	\N
245111	1678	3600093661000	5325	2656	51	0	\N
245112	1678	3600093662000	5325	2656	52	0	\N
245113	1678	3600093663000	5325	2656	53	0	\N
245114	1678	3600093664000	5325	2656	54	0	\N
245115	1678	3600093665000	5325	2656	55	0	\N
245116	1678	3600093666000	5325	2656	56	0	\N
245117	1678	3600093667000	5325	2656	57	0	\N
245118	1678	3600093668000	5325	2656	58	0	\N
245119	1678	3600093669000	5325	2656	59	0	\N
245120	1678	3600093670000	5325	2656	60	0	\N
245121	1678	3600093671000	5325	2656	61	0	\N
245122	1678	3600093672000	5325	2656	62	0	\N
245123	1678	3600093673000	5325	2656	63	0	\N
245124	1678	3600093674000	5325	2656	64	0	\N
245125	1678	3600093675000	5325	2656	65	0	\N
245126	1678	3600093676000	5325	2656	66	0	\N
245127	1678	3600093677000	5325	2656	67	0	\N
245128	1678	3600093678000	5325	2656	68	0	\N
245129	1678	3600093679000	5325	2656	69	0	\N
245130	1678	3600093680000	5325	2656	70	0	\N
245131	1678	3600093681000	5325	2656	71	0	\N
245132	1678	3600093682000	5325	2656	72	0	\N
245133	1678	3600093683000	5325	2656	73	0	\N
245134	1678	3600093684000	5325	2656	74	0	\N
245135	1678	3600093685000	5325	2656	75	0	\N
245136	1678	3600093686000	5325	2656	76	0	\N
245137	1678	3600093687000	5325	2656	77	0	\N
245138	1678	3600093688000	5325	2656	78	0	\N
245139	1678	3600093689000	5325	2656	79	0	\N
245140	1678	3600093690000	5325	2656	80	0	\N
245141	1678	3600093691000	5325	2656	81	0	\N
245142	1678	3600093692000	5325	2656	82	0	\N
245143	1678	3600093693000	5325	2656	83	0	\N
245144	1678	3600093694000	5325	2656	84	0	\N
245145	1678	3600093695000	5325	2656	85	0	\N
245146	1678	3600093696000	5325	2656	86	0	\N
245147	1678	3600093697000	5325	2656	87	0	\N
245148	1678	3600093698000	5325	2656	88	0	\N
245149	1678	3600093699000	5325	2656	89	0	\N
245150	1678	3600093700000	5325	2656	90	0	\N
245151	1678	3600093701000	5325	2656	91	0	\N
245152	1678	3600093702000	5325	2656	92	0	\N
245153	1678	3600093703000	5325	2656	93	0	\N
245154	1678	3600093704000	5325	2656	94	0	\N
245155	1678	3600093705000	5325	2656	95	0	\N
245156	1678	3600093706000	5325	2656	96	0	\N
245157	1678	3600093707000	5325	2656	97	0	\N
245158	1678	3600093708000	5325	2656	98	0	\N
245159	1678	3600093709000	5325	2656	99	0	\N
245160	1678	3600093710000	5325	2656	100	0	\N
245161	1678	3600093711000	5325	2656	101	0	\N
245162	1678	3600093712000	5325	2656	102	0	\N
245163	1678	3600093713000	5325	2656	103	0	\N
245164	1678	3600093714000	5325	2656	104	0	\N
245166	1678	3600093761000	5327	2766	0	0	\N
245167	1678	3600093761000	5328	2766	0	0	\N
245168	1678	3600093762000	5329	2767	0	0	\N
245169	1678	3600093762000	5330	2767	0	0	\N
245170	1678	3600093762000	5331	2767	0	0	\N
245173	1678	3600093764000	5334	2769	0	0	\N
245174	1678	3600093764000	5335	2769	0	0	\N
245176	1678	3600093764000	5337	2769	0	0	\N
245177	1678	3600093764000	5338	2769	0	0	\N
245179	1678	3600093765000	5340	2770	0	0	\N
245182	1678	3600093766000	5343	2771	0	0	\N
245183	1678	3600093767000	5343	2771	1	0	\N
245184	1678	3600093768000	5343	2771	2	0	\N
245185	1678	3600093769000	5343	2771	3	0	\N
245190	1678	3600093771000	5346	2774	0	0	\N
245193	1678	3600093774000	5350	2777	0	0	\N
245197	1678	3600093777000	5354	2780	0	0	\N
245198	1678	3600093777000	5355	2780	0	0	\N
245202	1678	3600093780000	5358	2782	0	0	\N
245206	1678	3600093761000	5361	2766	0	0	\N
245207	1678	3600093762000	5361	2766	1	0	\N
245208	1678	3600093763000	5361	2766	2	0	\N
245172	1678	3600093763000	5333	2768	0	0	0
245175	1678	3600093764000	5336	2769	0	0	0
245178	1678	3600093765000	5339	2770	0	0	0
245180	1678	3600093766000	5341	2771	0	0	0
245181	1678	3600093767000	5342	2772	0	0	0
245187	1678	3600093769000	5344	2773	1	0	0
245188	1678	3600093770000	5344	2773	2	0	0
245189	1678	3600093771000	5345	2774	0	0	0
245191	1678	3600093772000	5347	2775	0	0	0
245192	1678	3600093773000	5348	2776	0	0	0
245195	1678	3600093775000	5352	2778	0	0	0
245196	1678	3600093776000	5353	2779	0	0	0
245199	1678	3600093777000	5356	2780	0	0	0
245200	1678	3600093778000	5357	2781	0	0	0
245203	1678	3600093780000	5359	2782	0	0	0
245204	1678	3600093781000	5360	2783	0	0	0
245205	1678	3600093782000	5360	2783	1	0	0
245209	1678	3600093764000	5361	2766	3	0	\N
245210	1678	3600093765000	5361	2766	4	0	\N
245211	1678	3600093766000	5361	2766	5	0	\N
245212	1678	3600093767000	5361	2766	6	0	\N
245213	1678	3600093768000	5361	2766	7	0	\N
245214	1678	3600093769000	5361	2766	8	0	\N
245215	1678	3600093770000	5361	2766	9	0	\N
245216	1678	3600093771000	5361	2766	10	0	\N
245217	1678	3600093772000	5361	2766	11	0	\N
245218	1678	3600093773000	5361	2766	12	0	\N
245219	1678	3600093774000	5361	2766	13	0	\N
245220	1678	3600093775000	5361	2766	14	0	\N
245221	1678	3600093776000	5361	2766	15	0	\N
245222	1678	3600093777000	5361	2766	16	0	\N
245223	1678	3600093778000	5361	2766	17	0	\N
245224	1678	3600093779000	5361	2766	18	0	\N
245225	1678	3600093780000	5361	2766	19	0	\N
245226	1678	3600093781000	5361	2766	20	0	\N
245227	1678	3600093782000	5361	2766	21	0	\N
245233	1678	3600093788000	5365	2787	0	0	\N
245241	1639	718119000000	5380	2799	0	0	\N
245244	1678	3600093783000	5414	2767	0	0	\N
245245	1678	3600093784000	5414	2767	1	0	\N
245246	1678	3600093785000	5414	2767	2	0	\N
245247	1678	3600093786000	5414	2767	3	0	\N
245248	1678	3600093787000	5414	2767	4	0	\N
245249	1678	3600093788000	5414	2767	5	0	\N
245250	1678	3600093789000	5414	2767	6	0	\N
245251	1678	3600093790000	5414	2767	7	0	\N
245252	1678	3600093791000	5414	2767	8	0	\N
245253	1678	3600093792000	5414	2767	9	0	\N
245254	1678	3600093793000	5414	2767	10	0	\N
245255	1639	718119000000	5414	2767	11	0	\N
245256	1841	1000000000	5414	2767	12	0	\N
245257	1841	1789000000	5415	2818	0	0	\N
245259	1841	1000000000	5418	2805	1	0	\N
245261	1841	1000000000	5432	2813	2	0	\N
245262	1841	718013000000	5439	2831	0	0	\N
245263	1841	718013000000	5440	2831	0	0	\N
245264	1841	718013000000	5441	2831	0	0	\N
245267	1842	100000000	5450	2836	0	0	\N
245268	1678	3600093695000	5453	2713	0	0	\N
245269	1678	3600093696000	5453	2713	1	0	\N
245270	1678	3600093697000	5453	2713	2	0	\N
245271	1678	3600093698000	5453	2713	3	0	\N
245272	1678	3600093699000	5453	2713	4	0	\N
245273	1678	3600093700000	5453	2713	5	0	\N
245274	1678	3600093701000	5453	2713	6	0	\N
245275	1678	3600093702000	5453	2713	7	0	\N
245276	1678	3600093703000	5453	2713	8	0	\N
245277	1678	3600093704000	5453	2713	9	0	\N
245278	1678	3600093705000	5453	2713	10	0	\N
245279	1678	3600093706000	5453	2713	11	0	\N
245280	1678	3600093707000	5453	2713	12	0	\N
245281	1678	3600093708000	5453	2713	13	0	\N
245282	1678	3600093709000	5453	2713	14	0	\N
245283	1678	3600093710000	5453	2713	15	0	\N
245284	1678	3600093711000	5453	2713	16	0	\N
245285	1678	3600093712000	5453	2713	17	0	\N
245286	1678	3600093713000	5453	2713	18	0	\N
245287	1678	3600093714000	5453	2713	19	0	\N
245288	1678	3600093715000	5453	2713	20	0	\N
245289	1678	3600093716000	5453	2713	21	0	\N
245290	1678	3600093717000	5453	2713	22	0	\N
245291	1678	3600093718000	5453	2713	23	0	\N
245292	1678	3600093719000	5453	2713	24	0	\N
245293	1678	3600093720000	5453	2713	25	0	\N
245294	1678	3600093721000	5453	2713	26	0	\N
245295	1678	3600093722000	5453	2713	27	0	\N
245296	1678	3600093723000	5453	2713	28	0	\N
245297	1678	3600093724000	5453	2713	29	0	\N
245298	1678	3600093725000	5453	2713	30	0	\N
245299	1678	3600093726000	5453	2713	31	0	\N
245300	1678	3600093727000	5453	2713	32	0	\N
245301	1678	3600093728000	5453	2713	33	0	\N
245302	1678	3600093729000	5453	2713	34	0	\N
245303	1678	3600093730000	5453	2713	35	0	\N
245304	1678	3600093731000	5453	2713	36	0	\N
245305	1678	3600093732000	5453	2713	37	0	\N
245306	1678	3600093733000	5453	2713	38	0	\N
245307	1843	200000000	5457	2840	0	0	\N
245308	1844	200000000	5457	2840	1	0	\N
245309	1845	200000000	5457	2840	2	0	\N
245310	1846	200000000	5457	2840	3	0	\N
245311	1847	200000000	5457	2840	4	0	\N
245312	1848	200000000	5457	2840	5	0	\N
245313	1849	200000000	5457	2840	6	0	\N
245323	1833	390000000	5512	2868	0	0	\N
245325	1839	200000000	5514	2708	0	0	\N
245326	1843	200000000	5514	2708	1	0	\N
245327	1844	200000000	5514	2708	2	0	\N
245328	1845	200000000	5514	2708	3	0	\N
245329	1846	200000000	5514	2708	4	0	\N
245330	1847	200000000	5514	2708	5	0	\N
245331	1848	200000000	5514	2708	6	0	\N
245332	1849	200000000	5514	2708	7	0	\N
245333	1844	1400000000	5514	2708	8	0	\N
245334	1483	0	5514	2708	9	0	\N
245335	1483	0	5514	2708	10	0	\N
245336	1678	3600093688000	5514	2708	11	0	\N
245337	1678	3600093689000	5514	2708	12	0	\N
245338	1833	390000000	5514	2708	13	0	\N
245339	1678	3600093690000	5514	2708	14	0	\N
245340	1678	3600093691000	5514	2708	15	0	\N
245341	1678	3600093692000	5514	2708	16	0	\N
245342	1678	3600093693000	5514	2708	17	0	\N
245343	1678	3600093694000	5514	2708	18	0	\N
245344	1678	3600093695000	5514	2708	19	0	\N
245230	1678	3600093785000	5363	2785	0	0	0
245231	1678	3600093786000	5364	2786	0	0	0
245232	1678	3600093787000	5364	2786	1	0	0
245234	1678	3600093788000	5366	2787	0	0	0
245235	1678	3600093789000	5367	2788	0	0	0
245237	1678	3600093791000	5368	2789	0	0	0
245238	1678	3600093792000	5369	2790	0	0	0
245239	1678	3600093793000	5369	2790	1	0	0
245240	1639	718119000000	5379	2799	0	0	1
245242	1841	1000000000	5404	2813	0	0	0
245258	1841	1789000000	5416	2818	0	0	1
245260	1841	1796000000	5422	2820	0	0	1
245265	1841	718013000000	5442	2831	0	0	1
245266	1842	100000000	5449	2836	0	0	0
245315	1844	200000000	5458	2840	1	0	0
245316	1845	200000000	5458	2840	2	0	0
245317	1846	200000000	5458	2840	3	0	0
245318	1847	200000000	5458	2840	4	0	0
245319	1848	200000000	5458	2840	5	0	0
245321	44	73920330000000	5459	2841	0	0	0
245322	1844	1400000000	5504	2863	0	0	0
245324	1833	390000000	5513	2868	0	0	0
245345	1678	3600093696000	5514	2708	20	0	\N
245346	1678	3600093697000	5514	2708	21	0	\N
245347	1678	3600093698000	5514	2708	22	0	\N
245348	1678	3600093699000	5514	2708	23	0	\N
245349	1678	3600093700000	5514	2708	24	0	\N
245350	1678	3600093701000	5514	2708	25	0	\N
245351	1678	3600093702000	5514	2708	26	0	\N
245352	1678	3600093703000	5514	2708	27	0	\N
245353	1678	3600093704000	5514	2708	28	0	\N
245354	1678	3600093705000	5514	2708	29	0	\N
245355	1678	3600093706000	5514	2708	30	0	\N
245356	1678	3600093707000	5514	2708	31	0	\N
245357	1678	3600093708000	5514	2708	32	0	\N
245358	1678	3600093709000	5514	2708	33	0	\N
245359	1678	3600093710000	5514	2708	34	0	\N
245360	1678	3600093711000	5514	2708	35	0	\N
245361	1678	3600093712000	5514	2708	36	0	\N
245362	1678	3600093713000	5514	2708	37	0	\N
245363	1678	3600093714000	5514	2708	38	0	\N
245364	1678	3600093715000	5514	2708	39	0	\N
245365	1678	3600093716000	5514	2708	40	0	\N
245366	1678	3600093717000	5514	2708	41	0	\N
245367	1678	3600093718000	5514	2708	42	0	\N
245368	1678	3600093719000	5514	2708	43	0	\N
245369	1678	3600093720000	5514	2708	44	0	\N
245370	1678	3600093721000	5514	2708	45	0	\N
245371	1678	3600093722000	5514	2708	46	0	\N
245372	1678	3600093723000	5514	2708	47	0	\N
245373	1678	3600093724000	5514	2708	48	0	\N
245374	1678	3600093725000	5514	2708	49	0	\N
245375	1678	3600093726000	5514	2708	50	0	\N
245376	1678	3600093727000	5514	2708	51	0	\N
245377	1678	3600093728000	5514	2708	52	0	\N
245378	1678	3600093729000	5514	2708	53	0	\N
245379	1678	3600093730000	5514	2708	54	0	\N
245380	1678	3600093731000	5514	2708	55	0	\N
245381	1678	3600093732000	5514	2708	56	0	\N
245383	1483	0	5540	2880	0	0	\N
245384	1483	0	5560	2869	0	0	\N
245385	1483	0	5570	2877	0	0	\N
245386	1843	200000000	5596	2837	0	0	\N
245387	1483	0	5596	2837	1	0	\N
245388	1844	200000000	5596	2837	2	0	\N
245389	1845	200000000	5596	2837	3	0	\N
245390	1846	200000000	5596	2837	4	0	\N
245391	1847	200000000	5596	2837	5	0	\N
245392	1848	200000000	5596	2837	6	0	\N
245393	1849	200000000	5596	2837	7	0	\N
245394	1844	1400000000	5596	2837	8	0	\N
245395	1833	390000000	5596	2837	9	0	\N
245396	44	73920330000000	5596	2837	10	0	\N
245397	492	66719000000000	5630	2925	0	0	\N
245399	1843	200000000	5656	2814	0	0	\N
245400	1483	0	5656	2814	1	0	\N
245401	1844	200000000	5656	2814	2	0	\N
245402	1845	200000000	5656	2814	3	0	\N
245403	1846	200000000	5656	2814	4	0	\N
245404	1847	200000000	5656	2814	5	0	\N
245405	1848	200000000	5656	2814	6	0	\N
245406	1849	200000000	5656	2814	7	0	\N
245407	1844	1400000000	5656	2814	8	0	\N
245408	1833	390000000	5656	2814	9	0	\N
245409	1842	100000000	5656	2814	10	0	\N
245410	44	73920330000000	5656	2814	12	0	\N
245411	1843	200000000	5678	2830	0	0	\N
245412	1483	0	5678	2830	1	0	\N
245413	1844	200000000	5678	2830	2	0	\N
245414	1845	200000000	5678	2830	3	0	\N
245415	1846	200000000	5678	2830	4	0	\N
245416	1847	200000000	5678	2830	5	0	\N
245417	1848	200000000	5678	2830	6	0	\N
245418	1849	200000000	5678	2830	7	0	\N
245419	1844	1400000000	5678	2830	8	0	\N
245420	1833	390000000	5678	2830	9	0	\N
245421	1842	100000000	5678	2830	10	0	\N
245422	44	73920330000000	5678	2830	11	0	\N
245423	1841	718013000000	5678	2830	12	0	\N
245426	1850	8625000000000	5681	2945	0	0	\N
245427	1850	8625000000000	5682	2945	0	0	\N
245428	1850	8625000000000	5683	2945	0	0	\N
245430	1651	0	5700	2955	0	0	\N
245432	1851	200000000	5714	2838	0	0	\N
245433	1850	1000000000	5714	2838	1	0	\N
245434	1850	8625000000000	5714	2838	2	0	\N
245435	1651	0	5714	2838	3	0	\N
245436	1483	0	5716	2964	0	0	\N
245437	1483	0	5716	2964	1	0	\N
245440	1483	0	5718	2964	0	0	\N
245441	1483	0	5718	2964	1	0	\N
245442	1483	0	5726	2967	0	0	\N
245444	1678	3600093794000	5739	2974	0	0	\N
245447	1678	3600093795000	5742	2975	0	0	\N
245454	1678	3600093801000	5749	2980	0	0	\N
245455	1678	3600093802000	5750	2981	0	0	\N
245458	1678	3600093804000	5753	2983	0	0	\N
245459	1678	3600093805000	5753	2983	1	0	\N
245460	1678	3600093806000	5753	2983	2	0	\N
245466	1678	3600093808000	5758	2985	0	0	\N
245469	1678	3600093809000	5760	2986	0	0	\N
245470	1678	3600093810000	5760	2986	1	0	\N
245474	1678	3600093814000	5763	2989	0	0	\N
245475	1678	3600093815000	5763	2989	1	0	\N
245476	1678	3600093816000	5763	2989	2	0	\N
245424	1850	1000000000	5679	2944	0	0	0
245425	1850	8625000000000	5680	2945	0	0	0
245429	1651	0	5699	2955	0	0	0
245431	1851	200000000	5710	2961	0	0	0
245438	1483	0	5717	2964	0	0	0
245443	1483	0	5727	2967	0	0	0
245445	1678	3600093794000	5740	2974	0	0	0
245446	1678	3600093795000	5741	2975	0	0	0
245448	1678	3600093796000	5744	2976	0	0	0
245449	1678	3600093797000	5744	2976	1	0	0
245451	1678	3600093799000	5746	2978	0	0	0
245452	1678	3600093800000	5747	2979	0	0	0
245453	1678	3600093801000	5748	2980	0	0	0
245456	1678	3600093802000	5751	2981	0	0	0
245461	1678	3600093804000	5754	2983	0	0	0
245462	1678	3600093805000	5754	2983	1	0	0
245463	1678	3600093806000	5754	2983	2	0	0
245464	1678	3600093807000	5756	2984	0	0	0
245465	1678	3600093808000	5757	2985	0	0	0
245468	1678	3600093810000	5759	2986	1	0	0
245471	1678	3600093811000	5761	2987	0	0	0
245472	1678	3600093812000	5762	2988	0	0	0
245473	1678	3600093813000	5762	2988	1	0	0
245477	1678	3600093814000	5764	2989	0	0	0
245479	1678	3600093816000	5764	2989	2	0	0
245480	1678	3600093817000	5765	2990	0	0	0
245486	1678	3600093822000	5769	2992	0	0	\N
245487	1678	3600093823000	5770	2993	0	0	\N
245505	1483	0	5783	2945	0	0	\N
245506	1483	0	5783	2945	1	0	\N
245507	1483	0	5783	2945	2	0	\N
245508	1851	200000000	5783	2945	3	0	\N
245509	1678	3600093794000	5783	2945	4	0	\N
245510	1678	3600093795000	5783	2945	5	0	\N
245511	1678	3600093796000	5783	2945	6	0	\N
245512	1678	3600093797000	5783	2945	7	0	\N
245513	1678	3600093798000	5783	2945	8	0	\N
245514	1678	3600093799000	5783	2945	9	0	\N
245515	1678	3600093800000	5783	2945	10	0	\N
245516	1678	3600093801000	5783	2945	11	0	\N
245517	1678	3600093802000	5783	2945	12	0	\N
245518	1678	3600093803000	5783	2945	13	0	\N
245519	1678	3600093804000	5783	2945	14	0	\N
245520	1678	3600093805000	5783	2945	15	0	\N
245521	1678	3600093806000	5783	2945	16	0	\N
245522	1678	3600093807000	5783	2945	17	0	\N
245523	1678	3600093808000	5783	2945	18	0	\N
245524	1678	3600093809000	5783	2945	19	0	\N
245525	1678	3600093810000	5783	2945	20	0	\N
245526	1850	8625000000000	5783	2945	21	0	\N
245527	1651	0	5783	2945	22	0	\N
245528	1678	3600093811000	5783	2945	23	0	\N
245529	1678	3600093812000	5783	2945	24	0	\N
245530	1678	3600093813000	5783	2945	25	0	\N
245531	1678	3600093814000	5783	2945	26	0	\N
245532	1678	3600093815000	5783	2945	27	0	\N
245533	1678	3600093816000	5783	2945	28	0	\N
245534	1678	3600093817000	5783	2945	29	0	\N
245535	1678	3600093818000	5783	2945	30	0	\N
245536	1678	3600093819000	5783	2945	31	0	\N
245537	1678	3600093820000	5783	2945	32	0	\N
245538	1678	3600093821000	5783	2945	33	0	\N
245539	1678	3600093822000	5783	2945	34	0	\N
245540	1678	3600093823000	5783	2945	35	0	\N
245541	1678	3600093824000	5783	2945	36	0	\N
245542	1678	3600093825000	5783	2945	37	0	\N
245543	1678	3600093826000	5783	2945	38	0	\N
245544	1678	3600093827000	5783	2945	39	0	\N
245545	1678	3600093828000	5783	2945	40	0	\N
245546	1678	3600093829000	5783	2945	41	0	\N
245547	1678	3600093830000	5783	2945	42	0	\N
245548	1678	3600093831000	5783	2945	43	0	\N
245549	1678	3600093832000	5783	2945	44	0	\N
245550	1678	3600093833000	5783	2945	45	0	\N
245551	1678	3600093834000	5783	2945	46	0	\N
245552	1678	3600093835000	5783	2945	47	0	\N
245553	1678	3600093836000	5783	2945	48	0	\N
245554	1678	3600093837000	5783	2945	49	0	\N
245555	1678	3600093838000	5783	2945	50	0	\N
245556	1678	3600093839000	5783	2945	51	0	\N
245557	1678	3600093840000	5783	2945	52	0	\N
245558	1678	3600093841000	5783	2945	53	0	\N
245561	1852	200000000	5785	3003	0	0	\N
245562	1853	200000000	5785	3003	1	0	\N
245563	1678	3600093842000	5785	3003	2	0	\N
245564	1852	200000000	5787	3003	0	0	\N
245565	1853	200000000	5787	3003	1	0	\N
245566	1678	3600093842000	5787	3003	2	0	\N
245570	1852	200000000	5789	3003	0	0	\N
245571	1853	200000000	5789	3003	1	0	\N
245572	1678	3600093842000	5789	3003	2	0	\N
245573	1678	3600093843000	5790	3004	0	0	\N
245578	1678	3600093845000	5795	3006	0	0	\N
245579	1678	3600093846000	5795	3006	1	0	\N
245580	1678	3600093845000	5796	3006	0	0	\N
245581	1678	3600093846000	5796	3006	1	0	\N
245583	1678	3600093848000	5798	3008	0	0	\N
245584	1678	3600093849000	5798	3008	1	0	\N
245589	1678	3600093852000	5801	3010	0	0	\N
245595	1678	3600093857000	5808	3014	0	0	\N
245597	1678	3600093857000	5810	3014	0	0	\N
245598	1678	3600093858000	5811	3015	0	0	\N
245599	1678	3600093859000	5811	3015	1	0	\N
245606	1678	3600093864000	5816	3019	0	0	\N
245607	1678	3600093865000	5816	3019	1	0	\N
245611	1678	3600093867000	5820	3021	0	0	\N
245612	1678	3600093867000	5821	3021	0	0	\N
245614	1678	3600093868000	5823	3022	0	0	\N
245615	1678	3600093868000	5824	3022	0	0	\N
245483	1678	3600093820000	5766	2991	0	0	0
245484	1678	3600093821000	5766	2991	1	0	0
245485	1678	3600093822000	5768	2992	0	0	0
245488	1678	3600093823000	5771	2993	0	0	0
245489	1678	3600093824000	5774	2994	0	0	0
245491	1678	3600093826000	5775	2995	0	0	0
245492	1678	3600093827000	5775	2995	1	0	0
245493	1678	3600093828000	5777	2996	0	0	0
245494	1678	3600093829000	5777	2996	1	0	0
245495	1678	3600093830000	5777	2996	2	0	0
245497	1678	3600093832000	5778	2997	0	0	0
245498	1678	3600093833000	5778	2997	1	0	0
245499	1678	3600093834000	5779	2998	0	0	0
245500	1678	3600093835000	5780	2999	0	0	0
245502	1678	3600093837000	5781	3000	0	0	0
245503	1678	3600093838000	5782	3001	0	0	0
245504	1678	3600093839000	5782	3001	1	0	0
245559	1678	3600093840000	5784	3002	0	0	0
245560	1678	3600093841000	5784	3002	1	0	0
245568	1853	200000000	5788	3003	1	0	0
245569	1678	3600093842000	5788	3003	2	0	0
245574	1678	3600093843000	5791	3004	0	0	0
245575	1678	3600093844000	5793	3005	0	0	0
245576	1678	3600093845000	5794	3006	0	0	0
245582	1678	3600093847000	5797	3007	0	0	0
245585	1678	3600093848000	5799	3008	0	0	0
245586	1678	3600093849000	5799	3008	1	0	0
245587	1678	3600093850000	5800	3009	0	0	0
245590	1678	3600093852000	5802	3010	0	0	0
245591	1678	3600093853000	5803	3011	0	0	0
245592	1678	3600093854000	5805	3012	0	0	0
245593	1678	3600093855000	5805	3012	1	0	0
245594	1678	3600093856000	5807	3013	0	0	0
245600	1678	3600093858000	5812	3015	0	0	0
245601	1678	3600093859000	5812	3015	1	0	0
245602	1678	3600093860000	5813	3016	0	0	0
245603	1678	3600093861000	5814	3017	0	0	0
245604	1678	3600093862000	5815	3018	0	0	0
245608	1678	3600093864000	5817	3019	0	0	0
245609	1678	3600093865000	5817	3019	1	0	0
245610	1678	3600093866000	5818	3020	0	0	0
245613	1678	3600093867000	5822	3021	0	0	0
245617	1678	3600093868000	5826	3022	0	0	\N
245618	1678	3600093869000	5827	3023	0	0	\N
245624	1678	3600093873000	5832	3026	0	0	\N
245626	1678	3600093875000	5834	3028	0	0	\N
245628	1854	200000000	5836	3029	0	0	\N
245629	1855	200000000	5836	3029	2	0	\N
245630	1678	3600093876000	5836	3029	3	0	\N
245631	1678	3600093877000	5836	3029	4	0	\N
245632	1854	200000000	5837	3029	0	0	\N
245633	1855	200000000	5837	3029	2	0	\N
245634	1678	3600093876000	5837	3029	3	0	\N
245635	1678	3600093877000	5837	3029	4	0	\N
245640	1854	200000000	5839	3029	0	0	\N
245641	1855	200000000	5839	3029	2	0	\N
245642	1678	3600093876000	5839	3029	3	0	\N
245643	1678	3600093877000	5839	3029	4	0	\N
245644	1854	200000000	5840	3029	0	0	\N
245645	1855	200000000	5840	3029	2	0	\N
245646	1678	3600093876000	5840	3029	3	0	\N
245647	1678	3600093877000	5840	3029	4	0	\N
245652	1678	3600093879000	5843	3031	0	0	\N
245653	1678	3600093880000	5843	3031	1	0	\N
245654	1678	3600093881000	5843	3031	2	0	\N
245656	1678	3600093882000	5845	3032	0	0	\N
245657	1678	3600093883000	5846	3033	0	0	\N
245659	1678	3600093883000	5848	3033	0	0	\N
245662	1678	3600093885000	5851	3035	0	0	\N
245667	1678	3600093889000	5855	3038	0	0	\N
245670	1678	3600093892000	5863	3040	0	0	\N
245671	1678	3600093893000	5863	3040	1	0	\N
245672	1678	3600093892000	5864	3040	0	0	\N
245673	1678	3600093893000	5864	3040	1	0	\N
245676	1852	200000000	5866	2946	0	0	\N
245677	1853	200000000	5866	2946	1	0	\N
245678	1854	200000000	5866	2946	2	0	\N
245679	1855	200000000	5866	2946	3	0	\N
245680	1678	3600093842000	5866	2946	4	0	\N
245681	1678	3600093843000	5866	2946	5	0	\N
245682	1678	3600093844000	5866	2946	6	0	\N
245683	1678	3600093845000	5866	2946	7	0	\N
245684	1678	3600093846000	5866	2946	8	0	\N
245685	1678	3600093847000	5866	2946	9	0	\N
245686	1678	3600093848000	5866	2946	10	0	\N
245687	1678	3600093849000	5866	2946	11	0	\N
245688	1678	3600093850000	5866	2946	12	0	\N
245689	1678	3600093851000	5866	2946	13	0	\N
245690	1678	3600093852000	5866	2946	14	0	\N
245691	1678	3600093853000	5866	2946	15	0	\N
245692	1678	3600093854000	5866	2946	16	0	\N
245693	1678	3600093855000	5866	2946	17	0	\N
245694	1678	3600093856000	5866	2946	18	0	\N
245695	1678	3600093857000	5866	2946	19	0	\N
245696	1678	3600093858000	5866	2946	20	0	\N
245697	1678	3600093859000	5866	2946	21	0	\N
245698	1678	3600093860000	5866	2946	22	0	\N
245699	1678	3600093861000	5866	2946	23	0	\N
245700	1678	3600093862000	5866	2946	24	0	\N
245701	1678	3600093863000	5866	2946	25	0	\N
245702	1678	3600093864000	5866	2946	26	0	\N
245703	1678	3600093865000	5866	2946	27	0	\N
245704	1678	3600093866000	5866	2946	28	0	\N
245705	1678	3600093867000	5866	2946	29	0	\N
245706	1678	3600093868000	5866	2946	30	0	\N
245707	1678	3600093869000	5866	2946	31	0	\N
245708	1678	3600093870000	5866	2946	32	0	\N
245709	1678	3600093871000	5866	2946	33	0	\N
245710	1678	3600093872000	5866	2946	34	0	\N
245711	1678	3600093873000	5866	2946	35	0	\N
245712	1678	3600093874000	5866	2946	36	0	\N
245713	1678	3600093875000	5866	2946	37	0	\N
245714	1678	3600093876000	5866	2946	38	0	\N
245715	1678	3600093877000	5866	2946	39	0	\N
245716	1678	3600093878000	5866	2946	40	0	\N
245717	1678	3600093879000	5866	2946	41	0	\N
245718	1678	3600093880000	5866	2946	42	0	\N
245719	1678	3600093881000	5866	2946	43	0	\N
245720	1678	3600093882000	5866	2946	44	0	\N
245721	1678	3600093883000	5866	2946	45	0	\N
245722	1678	3600093884000	5866	2946	46	0	\N
245723	1678	3600093885000	5866	2946	47	0	\N
245724	1678	3600093886000	5866	2946	48	0	\N
245725	1678	3600093887000	5866	2946	49	0	\N
245726	1678	3600093888000	5866	2946	50	0	\N
245727	1678	3600093889000	5866	2946	51	0	\N
245728	1678	3600093890000	5866	2946	53	0	\N
245729	1678	3600093891000	5866	2946	54	0	\N
245730	1678	3600093892000	5866	2946	55	0	\N
245731	1678	3600093892000	5867	3040	0	0	\N
245732	1678	3600093893000	5867	3040	1	0	\N
245733	1678	3600093894000	5868	3041	0	0	\N
245734	1678	3600093895000	5868	3041	1	0	\N
245735	1678	3600093896000	5868	3041	2	0	\N
245744	1678	3600093902000	5873	3045	0	0	\N
245745	1678	3600093903000	5873	3045	1	0	\N
245749	1678	3600093905000	5876	3047	0	0	\N
245750	1678	3600093905000	5877	3047	0	0	\N
245621	1678	3600093871000	5829	3024	1	0	0
245622	1678	3600093872000	5830	3025	0	0	0
245623	1678	3600093873000	5831	3026	0	0	0
245625	1678	3600093874000	5833	3027	0	0	0
245627	1678	3600093875000	5835	3028	0	0	0
245637	1855	200000000	5838	3029	2	0	0
245638	1678	3600093876000	5838	3029	3	0	0
245639	1678	3600093877000	5838	3029	4	0	0
245648	1678	3600093878000	5841	3030	0	0	0
245649	1678	3600093879000	5842	3031	0	0	0
245651	1678	3600093881000	5842	3031	2	0	0
245655	1678	3600093882000	5844	3032	0	0	0
245658	1678	3600093883000	5847	3033	0	0	0
245660	1678	3600093884000	5849	3034	0	0	0
245663	1678	3600093886000	5852	3036	0	0	0
245664	1678	3600093887000	5853	3037	0	0	0
245665	1678	3600093888000	5853	3037	1	0	0
245666	1678	3600093889000	5854	3038	0	0	0
245668	1678	3600093890000	5857	3039	0	0	0
245674	1678	3600093892000	5865	3040	0	0	0
245675	1678	3600093893000	5865	3040	1	0	0
245736	1678	3600093894000	5869	3041	0	0	0
245737	1678	3600093895000	5869	3041	1	0	0
245738	1678	3600093896000	5869	3041	2	0	0
245740	1678	3600093898000	5870	3042	1	0	0
245741	1678	3600093899000	5871	3043	0	0	0
245742	1678	3600093900000	5872	3044	0	0	0
245743	1678	3600093901000	5872	3044	1	0	0
245747	1678	3600093903000	5874	3045	1	0	0
245748	1678	3600093904000	5875	3046	0	0	0
245751	1678	3600093905000	5878	3047	0	0	0
245752	1678	3600093906000	5879	3048	0	0	0
245754	1678	3600093906000	5880	3048	0	0	\N
245755	1678	3600093907000	5880	3048	1	0	\N
245765	1678	3600093909000	5892	3054	0	0	\N
245766	1678	3600093910000	5892	3054	1	0	\N
245767	1678	3600093911000	5892	3054	2	0	\N
245768	1678	3600093912000	5892	3054	3	0	\N
245769	1678	3600093913000	5892	3054	4	0	\N
245770	1678	3600093909000	5893	3054	0	0	\N
245771	1678	3600093910000	5893	3054	1	0	\N
245772	1678	3600093911000	5893	3054	2	0	\N
245773	1678	3600093912000	5893	3054	3	0	\N
245774	1678	3600093913000	5893	3054	4	0	\N
245775	1678	3600093914000	5894	3055	0	0	\N
245783	1678	4320143921000	5898	3058	0	0	\N
245784	1678	4320143921000	5899	3058	0	0	\N
245788	1678	4320143923000	5903	3060	0	0	\N
245789	1678	4320143924000	5904	3061	0	0	\N
245791	1678	4320143924000	5907	3061	0	0	\N
245795	1678	4320143928000	5910	3064	0	0	\N
245799	1678	4320143931000	5915	3067	0	0	\N
245800	1678	4320143932000	5915	3067	1	0	\N
245801	1678	4320143933000	5915	3067	2	0	\N
245805	1678	4320143931000	5917	3067	0	0	\N
245806	1678	4320143932000	5917	3067	1	0	\N
245807	1678	4320143933000	5917	3067	2	0	\N
245808	1678	4320143931000	5918	3067	0	0	\N
245809	1678	4320143932000	5918	3067	1	0	\N
245810	1678	4320143933000	5918	3067	2	0	\N
245811	1678	4320143931000	5919	3067	0	0	\N
245812	1678	4320143932000	5919	3067	1	0	\N
245813	1678	4320143933000	5919	3067	2	0	\N
245815	1678	4320143934000	5921	3068	0	0	\N
245816	1678	4320143934000	5922	3068	0	0	\N
245817	1678	4320143934000	5923	3068	0	0	\N
245820	1678	4320143936000	5926	3070	0	0	\N
245821	1678	4320143936000	5927	3070	0	0	\N
245822	1678	4320143937000	5928	3071	0	0	\N
245823	1678	4320143938000	5928	3071	1	0	\N
245824	1678	4320143937000	5929	3071	0	0	\N
245825	1678	4320143938000	5929	3071	1	0	\N
245831	1678	3600093914000	5933	3055	0	0	\N
245832	1678	3600093915000	5933	3055	1	0	\N
245833	1678	3600093916000	5933	3055	2	0	\N
245834	1678	3600093917000	5933	3055	3	0	\N
245835	1678	3600093918000	5933	3055	4	0	\N
245836	1678	3600093919000	5933	3055	5	0	\N
245837	1678	3600093920000	5933	3055	6	0	\N
245838	1678	3600093921000	5933	3055	7	0	\N
245839	1678	3600093922000	5933	3055	8	0	\N
245840	1678	3600093923000	5933	3055	9	0	\N
245841	1678	3600093924000	5933	3055	10	0	\N
245842	1678	3600093925000	5933	3055	11	0	\N
245843	1678	3600093926000	5933	3055	12	0	\N
245844	1678	3600093927000	5933	3055	13	0	\N
245845	1678	3600093928000	5933	3055	14	0	\N
245846	1678	3600093929000	5933	3055	15	0	\N
245847	1678	3600093930000	5933	3055	16	0	\N
245848	1678	3600093931000	5933	3055	17	0	\N
245849	1678	3600093932000	5933	3055	18	0	\N
245850	1678	3600093933000	5933	3055	19	0	\N
245851	1678	3600093934000	5933	3055	20	0	\N
245852	1678	3600093935000	5933	3055	21	0	\N
245853	1678	3600093936000	5933	3055	22	0	\N
245854	1678	3600093937000	5933	3055	23	0	\N
245855	1678	3600093938000	5933	3055	24	0	\N
245856	1678	3600093939000	5933	3055	25	0	\N
245857	1678	3600093940000	5933	3055	26	0	\N
245858	1678	3600093941000	5933	3055	27	0	\N
245859	1678	4320143942000	5934	3074	0	0	\N
245860	1678	4320143942000	5935	3074	0	0	\N
245868	1678	4320143946000	5941	3078	0	0	\N
245869	1678	4320143947000	5941	3078	1	0	\N
245870	1678	4320143948000	5941	3078	2	0	\N
245871	1678	4320143946000	5942	3078	0	0	\N
245872	1678	4320143947000	5942	3078	1	0	\N
245873	1678	4320143948000	5942	3078	2	0	\N
245878	1678	4320143953000	5946	3082	0	0	\N
245879	1678	4320143954000	5946	3082	1	0	\N
245882	1678	4320143955000	5948	3083	0	0	\N
245885	1678	4320143956000	5951	3084	0	0	\N
245886	1678	4320143956000	5952	3084	0	0	\N
245757	1856	200000000	5884	3051	0	0	0
245758	1857	200000000	5884	3051	1	0	0
245759	1858	200000000	5884	3051	2	0	0
245760	1678	3600093909000	5891	3054	0	0	0
245761	1678	3600093910000	5891	3054	1	0	0
245763	1678	3600093912000	5891	3054	3	0	0
245764	1678	3600093913000	5891	3054	4	0	0
245776	1678	3600093914000	5895	3055	0	0	0
245777	1678	3600093915000	5896	3056	0	0	0
245778	1678	3600093916000	5896	3056	1	0	0
245780	1678	3600093918000	5896	3056	3	0	0
245781	1678	3600093919000	5896	3056	4	0	0
245782	1678	4320143920000	5897	3057	0	0	0
245785	1678	4320143921000	5900	3058	0	0	0
245787	1678	4320143923000	5902	3060	0	0	0
245790	1678	4320143924000	5905	3061	0	0	0
245792	1678	4320143925000	5908	3062	0	0	0
245793	1678	4320143926000	5908	3062	1	0	0
245794	1678	4320143927000	5909	3063	0	0	0
245797	1678	4320143929000	5913	3065	0	0	0
245798	1678	4320143930000	5914	3066	0	0	0
245802	1678	4320143931000	5916	3067	0	0	0
245803	1678	4320143932000	5916	3067	1	0	0
245804	1678	4320143933000	5916	3067	2	0	0
245818	1678	4320143935000	5924	3069	0	0	0
245819	1678	4320143936000	5925	3070	0	0	0
245826	1678	4320143937000	5930	3071	0	0	0
245827	1678	4320143938000	5930	3071	1	0	0
245829	1678	4320143940000	5931	3072	1	0	0
245830	1678	4320143941000	5932	3073	0	0	0
245861	1678	4320143942000	5936	3074	0	0	0
245862	1678	4320143943000	5937	3075	0	0	0
245863	1678	4320143944000	5938	3076	0	0	0
245865	1678	4320143946000	5940	3078	0	0	0
245866	1678	4320143947000	5940	3078	1	0	0
245867	1678	4320143948000	5940	3078	2	0	0
245874	1678	4320143949000	5943	3079	0	0	0
245875	1678	4320143950000	5944	3080	0	0	0
245877	1678	4320143952000	5945	3081	1	0	0
245880	1678	4320143953000	5947	3082	0	0	0
245881	1678	4320143954000	5947	3082	1	0	0
245883	1678	4320143955000	5949	3083	0	0	0
245887	1678	4320143957000	5953	3085	0	0	0
245888	1678	4320143958000	5954	3086	0	0	0
245892	1678	4320143961000	5957	3088	0	0	\N
245903	1678	4320143968000	5963	3093	0	0	\N
245904	1678	4320143968000	5964	3093	0	0	\N
245905	1678	4320143968000	5965	3093	0	0	\N
245909	1678	4320143970000	5968	3095	0	0	\N
245910	1678	4320143971000	5968	3095	1	0	\N
245913	1678	4320143974000	5970	3097	0	0	\N
245914	1678	4320143975000	5970	3097	1	0	\N
245918	1678	4320143977000	5973	3099	0	0	\N
245922	1678	4320143980000	5977	3102	0	0	\N
245923	1678	4320143980000	5978	3102	0	0	\N
245925	1678	4320143980000	5980	3102	0	0	\N
245928	1678	4320143981000	5982	3103	0	0	\N
245929	1678	4320143982000	5982	3103	1	0	\N
245931	1678	4320143984000	5984	3105	0	0	\N
245932	1678	4320143985000	5984	3105	1	0	\N
245935	1678	4320143984000	5986	3105	0	0	\N
245936	1678	4320143985000	5986	3105	1	0	\N
245938	1678	4320143986000	5988	3106	0	0	\N
245939	1678	4320143987000	5989	3107	0	0	\N
245943	1678	4320143990000	5993	3110	0	0	\N
245944	1678	4320143991000	5993	3110	1	0	\N
245945	1678	4320143990000	5994	3110	0	0	\N
245946	1678	4320143991000	5994	3110	1	0	\N
245954	1678	4320143992000	5997	3111	0	0	\N
245955	1678	4320143993000	5997	3111	1	0	\N
245956	1678	4320143994000	5997	3111	2	0	\N
245957	1678	4320143995000	5997	3111	3	0	\N
245958	1678	4320143996000	5997	3111	4	0	\N
245960	1678	4320143998000	5999	3113	0	0	\N
245961	1678	4320143999000	5999	3113	3	0	\N
245964	1678	4320144000000	6001	3114	0	0	\N
245965	1678	4320144000000	6002	3114	0	0	\N
245968	1678	4320144002000	6005	3116	0	0	\N
245973	1678	4320144005000	6009	3118	0	0	\N
245974	1854	200000000	6010	3010	0	0	\N
245975	1855	200000000	6010	3010	1	0	\N
245976	1856	200000000	6010	3010	2	0	\N
245977	1857	200000000	6010	3010	3	0	\N
245978	1858	200000000	6010	3010	4	0	\N
245979	1772	728750000000	6010	3010	7	0	\N
245980	1772	880750000000	6010	3010	8	0	\N
245981	1772	1091750000000	6010	3010	9	0	\N
245983	1678	4320144006000	6012	3119	0	0	\N
245984	1678	4320144007000	6013	3120	0	0	\N
245985	1678	4320144007000	6014	3120	0	0	\N
245987	1678	4320144008000	6016	3121	0	0	\N
245990	1678	4320144009000	6019	3122	0	0	\N
245994	1678	4320144013000	6022	3125	0	0	\N
245995	1678	4320144014000	6022	3125	1	0	\N
245998	1678	4320144013000	6024	3125	0	0	\N
245999	1678	4320144014000	6024	3125	1	0	\N
246006	1678	4320144019000	6027	3127	0	0	\N
246007	1678	4320144020000	6028	3128	0	0	\N
246008	1678	4320144021000	6028	3128	1	0	\N
246009	1678	4320144022000	6028	3128	2	0	\N
246010	1678	4320144020000	6029	3128	0	0	\N
246011	1678	4320144021000	6029	3128	1	0	\N
246012	1678	4320144022000	6029	3128	2	0	\N
246020	1678	4320144025000	6033	3131	0	0	\N
245891	1678	4320143961000	5956	3088	0	0	0
245893	1678	4320143962000	5958	3089	0	0	0
245894	1678	4320143963000	5958	3089	1	0	0
245895	1678	4320143964000	5959	3090	0	0	0
245896	1678	4320143965000	5959	3090	1	0	0
245898	1772	880750000000	5959	3090	3	0	1
245899	1772	1091750000000	5959	3090	4	0	1
245900	1678	4320143966000	5960	3091	0	0	0
245901	1678	4320143967000	5961	3092	0	0	0
245902	1678	4320143968000	5962	3093	0	0	0
245907	1678	4320143970000	5967	3095	0	0	0
245908	1678	4320143971000	5967	3095	1	0	0
245911	1678	4320143972000	5969	3096	0	0	0
245912	1678	4320143973000	5969	3096	1	0	0
245916	1678	4320143975000	5971	3097	1	0	0
245917	1678	4320143976000	5972	3098	0	0	0
245919	1678	4320143977000	5974	3099	0	0	0
245920	1678	4320143978000	5975	3100	0	0	0
245921	1678	4320143979000	5976	3101	0	0	0
245926	1678	4320143981000	5981	3103	0	0	0
245927	1678	4320143982000	5981	3103	1	0	0
245930	1678	4320143983000	5983	3104	0	0	0
245933	1678	4320143984000	5985	3105	0	0	0
245934	1678	4320143985000	5985	3105	1	0	0
245940	1678	4320143987000	5990	3107	0	0	0
245941	1678	4320143988000	5991	3108	0	0	0
245942	1678	4320143989000	5992	3109	0	0	0
245947	1678	4320143990000	5995	3110	0	0	0
245949	1678	4320143992000	5996	3111	0	0	0
245950	1678	4320143993000	5996	3111	1	0	0
245951	1678	4320143994000	5996	3111	2	0	0
245952	1678	4320143995000	5996	3111	3	0	0
245953	1678	4320143996000	5996	3111	4	0	0
245962	1678	4320143998000	6000	3113	0	0	0
245963	1678	4320143999000	6000	3113	3	0	0
245966	1678	4320144000000	6003	3114	0	0	0
245967	1678	4320144001000	6004	3115	0	0	0
245969	1678	4320144002000	6006	3116	0	0	0
245971	1678	4320144004000	6007	3117	1	0	0
245972	1678	4320144005000	6008	3118	0	0	0
245982	1678	4320144006000	6011	3119	0	0	0
245986	1678	4320144007000	6015	3120	0	0	0
245989	1678	4320144009000	6018	3122	0	0	0
245991	1678	4320144010000	6020	3123	0	0	0
245992	1678	4320144011000	6021	3124	1	0	0
245993	1678	4320144012000	6021	3124	2	0	0
245996	1678	4320144013000	6023	3125	0	0	0
246000	1678	4320144015000	6025	3126	0	0	0
246001	1678	4320144016000	6025	3126	1	0	0
246002	1678	4320144017000	6025	3126	2	0	0
246003	1678	4320144018000	6025	3126	3	0	0
246004	1860	10000000	6025	3126	4	0	0
246013	1678	4320144020000	6030	3128	0	0	0
246014	1678	4320144021000	6030	3128	1	0	0
246015	1678	4320144022000	6030	3128	2	0	0
246016	1860	100020000000	6031	3129	0	0	0
246018	1861	1010000000	6031	3129	2	0	0
246019	1678	4320144024000	6032	3130	0	0	0
246021	1678	4320144025000	6034	3131	0	0	0
246022	1862	10000000	6035	3132	0	0	0
246023	1678	4320144026000	6035	3132	1	0	0
246031	1678	4320144030000	6040	3136	0	0	\N
246038	1678	4320144036000	6045	3141	0	0	\N
246041	1678	4320144037000	6048	3142	0	0	\N
246044	1678	4320144038000	6050	3143	0	0	\N
246045	1678	4320144039000	6050	3143	1	0	\N
246046	1861	1010000000	6051	3100	3	0	\N
246047	1860	10000000	6051	3100	4	0	\N
246048	1860	100020000000	6051	3100	5	0	\N
246049	1860	43900020000000	6051	3100	6	0	\N
246051	1678	4320144040000	6053	3144	0	0	\N
246054	1678	4320144042000	6056	3146	0	0	\N
246055	1678	4320144042000	6057	3146	0	0	\N
246056	1678	4320144042000	6058	3146	0	0	\N
246061	1678	4320144045000	6061	3148	0	0	\N
246062	1678	4320144046000	6061	3148	1	0	\N
246063	1678	4320144045000	6062	3148	0	0	\N
246064	1678	4320144046000	6062	3148	1	0	\N
246065	1678	4320144047000	6063	3149	0	0	\N
246071	1678	4320144049000	6067	3151	0	0	\N
246072	1678	4320144050000	6067	3151	1	0	\N
246073	1678	4320144051000	6067	3151	2	0	\N
246077	1678	4320144054000	6070	3153	0	0	\N
246078	1678	4320144054000	6071	3153	0	0	\N
246080	1678	4320144055000	6073	3154	0	0	\N
246082	1678	4320144057000	6075	3156	0	0	\N
246083	1678	4320144058000	6075	3156	1	0	\N
246084	1678	4320144057000	6076	3156	0	0	\N
246085	1678	4320144058000	6076	3156	1	0	\N
246088	1678	4320144057000	6078	3156	0	0	\N
246089	1678	4320144058000	6078	3156	1	0	\N
246090	1678	4320144059000	6079	3157	0	0	\N
246091	1678	4320144060000	6079	3157	1	0	\N
246092	1678	4320144059000	6080	3157	0	0	\N
246095	1678	4320144059000	6082	3157	0	0	\N
246096	1678	4320144060000	6082	3157	1	0	\N
246098	1678	4320144061000	6086	3159	0	0	\N
246099	1678	4320144062000	6087	3160	0	0	\N
246102	1678	4320144063000	6090	3161	0	0	\N
246103	1678	4320144064000	6090	3161	1	0	\N
246107	1678	4320144064000	6092	3162	0	0	\N
246108	1678	4320144065000	6092	3162	1	0	\N
246109	1678	4320144066000	6092	3162	2	0	\N
246110	1678	4320144064000	6093	3162	0	0	\N
246111	1678	4320144065000	6093	3162	1	0	\N
246112	1678	4320144066000	6093	3162	2	0	\N
246116	1678	4320144067000	6095	3163	0	0	\N
246117	1678	4320144068000	6095	3163	1	0	\N
246118	1678	4320144069000	6095	3163	2	0	\N
246123	1678	4320144072000	6098	3165	0	0	\N
246124	1678	4320144073000	6098	3165	1	0	\N
246125	1678	4320144072000	6099	3165	0	0	\N
246126	1678	4320144073000	6099	3165	1	0	\N
246127	1678	4320144074000	6100	3166	0	0	\N
246129	1678	4320144075000	6102	3167	0	0	\N
246130	1678	4320144075000	6103	3167	0	0	\N
246132	1861	1010000000	6105	3011	1	0	\N
246133	1860	10000000	6105	3011	2	0	\N
246134	1860	100020000000	6105	3011	3	0	\N
246135	1860	43900020000000	6105	3011	4	0	\N
246136	1678	4320144075000	6106	3167	0	0	\N
246141	1863	0	6108	3168	0	0	\N
246142	1864	110000000000	6108	3168	1	0	\N
246143	1678	4320144076000	6108	3168	2	0	\N
246144	1678	4320144077000	6108	3168	3	0	\N
246145	1863	0	6109	3168	0	0	\N
246146	1864	110000000000	6109	3168	1	0	\N
246147	1678	4320144076000	6109	3168	2	0	\N
246148	1678	4320144077000	6109	3168	3	0	\N
246149	1678	4320144078000	6110	3169	0	0	\N
246150	1678	4320144078000	6111	3169	0	0	\N
246153	1678	4320144079000	6114	3170	0	0	\N
246155	1678	4320144080000	6116	3171	0	0	\N
246160	1678	4320144084000	6120	3173	0	0	\N
246027	1678	4320144028000	6037	3134	1	0	0
246028	1860	43899000000000	6038	3135	0	0	1
246029	1678	4320144029000	6038	3135	1	0	0
246030	1678	4320144030000	6039	3136	0	0	0
246032	1665	870000000	6041	3137	0	0	4
246034	1678	4320144032000	6042	3138	0	0	0
246035	1678	4320144033000	6042	3138	1	0	0
246036	1678	4320144034000	6043	3139	0	0	0
246037	1678	4320144035000	6044	3140	0	0	0
246039	1678	4320144036000	6046	3141	0	0	0
246042	1678	4320144038000	6049	3143	0	0	0
246043	1678	4320144039000	6049	3143	1	0	0
246050	1678	4320144040000	6052	3144	0	0	0
246052	1678	4320144041000	6054	3145	0	0	0
246057	1678	4320144043000	6059	3147	0	0	0
246058	1678	4320144044000	6059	3147	1	0	0
246059	1678	4320144045000	6060	3148	0	0	0
246060	1678	4320144046000	6060	3148	1	0	0
246066	1678	4320144047000	6064	3149	0	0	0
246068	1678	4320144049000	6066	3151	0	0	0
246069	1678	4320144050000	6066	3151	1	0	0
246070	1678	4320144051000	6066	3151	2	0	0
246074	1678	4320144052000	6068	3152	0	0	0
246075	1678	4320144053000	6068	3152	1	0	0
246079	1678	4320144055000	6072	3154	0	0	0
246081	1678	4320144056000	6074	3155	0	0	0
246086	1678	4320144057000	6077	3156	0	0	0
246087	1678	4320144058000	6077	3156	1	0	0
246094	1678	4320144060000	6081	3157	1	0	0
246097	1678	4320144061000	6085	3159	0	0	0
246100	1678	4320144062000	6088	3160	0	0	0
246101	1678	4320144063000	6089	3161	0	0	0
246104	1678	4320144064000	6091	3162	0	0	0
246106	1678	4320144066000	6091	3162	2	0	0
246113	1678	4320144067000	6094	3163	0	0	0
246114	1678	4320144068000	6094	3163	1	0	0
246115	1678	4320144069000	6094	3163	2	0	0
246119	1678	4320144070000	6096	3164	0	0	0
246121	1678	4320144072000	6097	3165	0	0	0
246122	1678	4320144073000	6097	3165	1	0	0
246128	1678	4320144074000	6101	3166	0	0	0
246131	1678	4320144075000	6104	3167	0	0	0
246138	1864	110000000000	6107	3168	1	0	0
246139	1678	4320144076000	6107	3168	2	0	0
246140	1678	4320144077000	6107	3168	3	0	0
246151	1678	4320144078000	6112	3169	0	0	0
246152	1678	4320144079000	6113	3170	0	0	0
246156	1678	4320144081000	6118	3172	0	0	0
246157	1678	4320144082000	6118	3172	1	0	0
246158	1678	4320144083000	6118	3172	2	0	0
246159	1678	4320144084000	6119	3173	0	0	0
246161	1678	4320144084000	6121	3173	0	0	\N
246169	1678	4320144090000	6127	3178	0	0	\N
246170	1678	4320144090000	6128	3178	0	0	\N
246171	1678	4320144091000	6129	3179	0	0	\N
246173	1678	4320144091000	6131	3179	0	0	\N
246174	1678	4320144092000	6131	3179	1	0	\N
246175	1678	4320144091000	6132	3179	0	0	\N
246177	1678	4320144092000	6134	3180	0	0	\N
246179	1678	4320144094000	6136	3182	0	0	\N
246180	1678	4320144094000	6137	3182	0	0	\N
246184	1678	4320144096000	6141	3184	0	0	\N
246185	1678	4320144096000	6142	3184	0	0	\N
246187	1678	4320144097000	6145	3185	0	0	\N
246190	1678	4320144100000	6151	3187	0	0	\N
246192	1678	4320144101000	6153	3188	0	0	\N
246194	1678	4320144101000	6155	3188	0	0	\N
246195	1678	4320144102000	6156	3189	0	0	\N
246197	1678	4320144103000	6158	3190	0	0	\N
246199	1678	4320144104000	6160	3191	0	0	\N
246200	1678	4320144104000	6161	3191	0	0	\N
246205	1678	4320144108000	6164	3193	0	0	\N
246206	1678	4320144108000	6165	3193	0	0	\N
246208	1678	4320144109000	6167	3194	0	0	\N
246210	1678	4320144109000	6169	3194	0	0	\N
246211	1678	4320144110000	6170	3195	0	0	\N
246218	1678	4320144112000	6174	3197	0	0	\N
246219	1678	4320144113000	6174	3197	1	0	\N
246220	1678	4320144114000	6174	3197	2	0	\N
246221	1678	4320144115000	6174	3197	3	0	\N
246222	1678	4320144112000	6175	3197	0	0	\N
246223	1678	4320144113000	6175	3197	1	0	\N
246224	1678	4320144114000	6175	3197	2	0	\N
246225	1678	4320144115000	6175	3197	3	0	\N
246227	1678	4320144117000	6177	3199	0	0	\N
246228	1678	4320144118000	6177	3199	1	0	\N
246229	1678	4320144119000	6177	3199	2	0	\N
246230	1678	4320144120000	6177	3199	3	0	\N
246231	1678	4320144121000	6177	3199	4	0	\N
246232	1678	4320144117000	6178	3199	0	0	\N
246233	1678	4320144118000	6178	3199	1	0	\N
246234	1678	4320144119000	6178	3199	2	0	\N
246235	1678	4320144120000	6178	3199	3	0	\N
246236	1678	4320144121000	6178	3199	4	0	\N
246242	1678	4320144122000	6180	3200	0	0	\N
246244	1678	4320144123000	6182	3201	0	0	\N
246245	1678	4320144124000	6182	3201	1	0	\N
246248	1678	4320144123000	6184	3201	0	0	\N
246249	1678	4320144124000	6184	3201	1	0	\N
246258	1483	0	6188	3204	0	0	\N
246259	1866	12152037273550	6188	3204	1	0	\N
246260	1678	5040154128000	6188	3204	2	0	\N
246262	1678	5040154129000	6190	3205	0	0	\N
246263	1678	5040154129000	6191	3205	0	0	\N
246264	1678	5040154129000	6192	3205	0	0	\N
246270	1678	5040154133000	6196	3208	0	0	\N
246271	1678	5040154133000	6197	3208	0	0	\N
246272	1678	5040154133000	6198	3208	0	0	\N
246273	1678	5040154133000	6199	3208	0	0	\N
246274	1678	5040154133000	6200	3208	0	0	\N
246275	481	66156469944195	6202	3210	0	0	\N
246276	734	2004741513431	6202	3210	1	0	\N
246277	845	574692567058364	6202	3210	2	0	\N
246278	846	574692567058364	6202	3210	3	0	\N
246279	936	504035868169406	6202	3210	4	0	\N
246280	1056	903227957180224	6202	3210	5	0	\N
246281	1176	609425900797934	6202	3210	6	0	\N
246282	1302	1698219459703282	6202	3210	7	0	\N
246283	1678	5040154134000	6202	3210	8	0	\N
246284	1678	5040154135000	6202	3210	9	0	\N
246296	1678	5040154136000	6205	3211	0	0	\N
246164	1678	4320144086000	6123	3175	1	0	0
246165	1678	4320144087000	6125	3177	0	0	0
246166	1678	4320144088000	6125	3177	1	0	0
246167	1678	4320144089000	6125	3177	2	0	0
246168	1678	4320144090000	6126	3178	0	0	0
246176	1678	4320144092000	6133	3180	0	0	0
246178	1678	4320144093000	6135	3181	0	0	0
246181	1678	4320144094000	6138	3182	0	0	0
246182	1678	4320144095000	6139	3183	0	0	0
246183	1678	4320144096000	6140	3184	0	0	0
246188	1678	4320144098000	6150	3186	0	0	0
246189	1678	4320144099000	6150	3186	1	0	0
246191	1678	4320144100000	6152	3187	0	0	0
246193	1678	4320144101000	6154	3188	0	0	0
246198	1678	4320144103000	6159	3190	0	0	0
246201	1678	4320144104000	6162	3191	0	0	0
246202	1678	4320144105000	6163	3192	0	0	0
246203	1678	4320144106000	6163	3192	1	0	0
246204	1678	4320144107000	6163	3192	2	0	0
246209	1678	4320144109000	6168	3194	0	0	0
246212	1678	4320144110000	6171	3195	0	0	0
246213	1678	4320144111000	6172	3196	0	0	0
246214	1678	4320144112000	6173	3197	0	0	0
246215	1678	4320144113000	6173	3197	1	0	0
246217	1678	4320144115000	6173	3197	3	0	0
246226	1678	4320144116000	6176	3198	0	0	0
246237	1678	4320144117000	6179	3199	0	0	0
246238	1678	4320144118000	6179	3199	1	0	0
246240	1678	4320144120000	6179	3199	3	0	0
246241	1678	4320144121000	6179	3199	4	0	0
246243	1678	4320144122000	6181	3200	0	0	0
246246	1678	4320144123000	6183	3201	0	0	0
246247	1678	4320144124000	6183	3201	1	0	0
246251	1863	1000000000	6185	3202	1	0	0
246252	1678	4320144125000	6185	3202	2	0	0
246253	1678	4320144126000	6185	3202	3	0	0
246254	1678	4320144127000	6186	3203	0	0	0
246255	1483	0	6187	3204	0	0	0
246257	1678	5040154128000	6187	3204	2	0	0
246261	1678	5040154129000	6189	3205	0	0	0
246265	1866	12153037273550	6193	3206	0	0	0
246266	1678	5040154130000	6193	3206	1	0	0
246268	1678	5040154132000	6194	3207	0	0	0
246269	1678	5040154133000	6195	3208	0	0	0
246285	481	66156469944195	6203	3210	0	0	0
246286	734	2004741513431	6203	3210	1	0	0
246287	845	574692567058364	6203	3210	2	0	0
246289	936	504035868169406	6203	3210	4	0	0
246290	1056	903227957180224	6203	3210	5	0	0
246291	1176	609425900797934	6203	3210	6	0	0
246292	1302	1698219459703282	6203	3210	7	0	0
246293	1678	5040154134000	6203	3210	8	0	0
246295	1678	5040154136000	6204	3211	0	0	0
246297	1678	5040154137000	6205	3211	1	0	\N
246298	1678	5040154138000	6205	3211	2	0	\N
246301	1678	5040154137000	6207	3212	0	0	\N
246302	1678	5040154138000	6207	3212	1	0	\N
246304	1678	5040154140000	6209	3214	0	0	\N
246305	1678	5040154140000	6210	3214	0	0	\N
246307	1863	1000000000	6212	3215	0	0	\N
246308	1678	5040154141000	6212	3215	1	0	\N
246309	1678	5040154142000	6212	3215	2	0	\N
246310	1678	5040154143000	6212	3215	3	0	\N
246315	1863	1000000000	6214	3215	0	0	\N
246316	1678	5040154141000	6214	3215	1	0	\N
246317	1678	5040154142000	6214	3215	2	0	\N
246318	1678	5040154143000	6214	3215	3	0	\N
246320	42	74637920000000	6216	3217	0	0	\N
246321	1678	5040154145000	6216	3217	2	0	\N
246324	1678	5040154146000	6218	3218	0	0	\N
246325	1678	5040154146000	6219	3218	0	0	\N
246333	1678	5040154152000	6223	3221	0	0	\N
246334	1678	5040154152000	6224	3221	0	0	\N
246335	1678	5040154152000	6225	3221	0	0	\N
246339	42	74638020000000	6228	3213	0	0	\N
246340	1867	200000000	6228	3213	1	0	\N
246341	1863	900000000	6228	3213	2	0	\N
246342	1678	5040154139000	6228	3213	4	0	\N
246343	1678	5040154140000	6228	3213	5	0	\N
246344	1678	5040154141000	6228	3213	6	0	\N
246345	1678	5040154142000	6228	3213	7	0	\N
246346	1678	5040154143000	6228	3213	8	0	\N
246347	1678	5040154144000	6228	3213	9	0	\N
246348	1678	5040154145000	6228	3213	10	0	\N
246349	1678	5040154146000	6228	3213	11	0	\N
246350	1678	5040154147000	6228	3213	12	0	\N
246351	1678	5040154148000	6228	3213	13	0	\N
246352	1678	5040154149000	6228	3213	14	0	\N
246353	1678	5040154150000	6228	3213	15	0	\N
246354	1678	5040154151000	6228	3213	16	0	\N
246355	1678	5040154152000	6228	3213	17	0	\N
246356	1678	5040154153000	6228	3213	18	0	\N
246357	1678	5040154154000	6228	3213	19	0	\N
246359	1678	5040154156000	6230	3224	0	0	\N
246360	1678	5040154157000	6230	3224	1	0	\N
246361	1678	5040154158000	6230	3224	2	0	\N
246365	1866	9000000000	6232	3012	0	0	\N
246366	1865	200000000	6232	3012	1	0	\N
246367	1867	200000000	6232	3012	2	0	\N
246368	1863	0	6232	3012	3	0	\N
246369	1863	1000000000	6232	3012	4	0	\N
246370	1483	0	6232	3012	5	0	\N
246371	1866	12152037273550	6232	3012	6	0	\N
246372	1866	12153037273550	6232	3012	7	0	\N
246373	1863	1000000000	6232	3012	8	0	\N
246374	1864	110000000000	6232	3012	10	0	\N
246376	1678	5040154160000	6234	3226	0	0	\N
246377	1678	5040154161000	6234	3226	1	0	\N
246380	1678	5040154160000	6236	3226	0	0	\N
246381	1678	5040154161000	6236	3226	1	0	\N
246382	1678	5040154160000	6237	3226	0	0	\N
246383	1678	5040154161000	6237	3226	1	0	\N
246384	1678	5040154160000	6238	3226	0	0	\N
246385	1678	5040154161000	6238	3226	1	0	\N
246388	1678	5040154162000	6240	3227	0	0	\N
246389	1678	5040154163000	6240	3227	1	0	\N
246393	1678	5040154165000	6243	3229	0	0	\N
246394	1678	5040154166000	6243	3229	1	0	\N
246396	1678	5040154167000	6245	3230	0	0	\N
246399	1678	5040154169000	6248	3232	0	0	\N
246400	1678	5040154170000	6249	3233	0	0	\N
246401	1678	5040154171000	6249	3233	1	0	\N
246412	1678	5040154177000	6255	3237	0	0	\N
246413	498	66001000000000	6255	3237	1	0	\N
246424	1678	5040154186000	6262	3243	0	0	\N
246425	1678	5040154186000	6263	3243	0	0	\N
246427	1678	5040154188000	6265	3245	0	0	\N
246428	1678	5040154189000	6265	3245	1	0	\N
246303	1678	5040154139000	6208	3213	0	0	0
246306	1678	5040154140000	6211	3214	0	0	0
246311	1863	1000000000	6213	3215	0	0	0
246312	1678	5040154141000	6213	3215	1	0	0
246313	1678	5040154142000	6213	3215	2	0	0
246319	1678	5040154144000	6215	3216	0	0	0
246322	42	74637920000000	6217	3217	0	0	3
246323	1678	5040154145000	6217	3217	2	0	0
246326	1678	5040154146000	6220	3218	0	0	0
246327	1867	200000000	6221	3219	0	0	0
246329	1678	5040154148000	6221	3219	2	0	0
246330	1678	5040154149000	6221	3219	3	0	0
246331	1678	5040154150000	6222	3220	0	0	0
246332	1678	5040154151000	6222	3220	1	0	0
246337	1678	5040154153000	6227	3222	0	0	0
246338	1678	5040154154000	6227	3222	1	0	0
246358	1678	5040154155000	6229	3223	0	0	0
246362	1678	5040154156000	6231	3224	0	0	0
246363	1678	5040154157000	6231	3224	1	0	0
246375	1678	5040154159000	6233	3225	0	0	0
246378	1678	5040154160000	6235	3226	0	0	0
246379	1678	5040154161000	6235	3226	1	0	0
246386	1678	5040154162000	6239	3227	0	0	0
246387	1678	5040154163000	6239	3227	1	0	0
246391	1678	5040154165000	6242	3229	0	0	0
246392	1678	5040154166000	6242	3229	1	0	0
246395	1678	5040154167000	6244	3230	0	0	0
246397	1678	5040154168000	6246	3231	0	0	0
246402	1678	5040154170000	6250	3233	0	0	0
246403	1678	5040154171000	6250	3233	1	0	0
246404	1678	5040154172000	6251	3234	0	0	0
246405	1678	5040154173000	6252	3235	0	0	0
246406	1678	5040154174000	6252	3235	1	0	0
246408	1868	9000000000	6252	3235	3	0	0
246409	1678	5040154176000	6253	3236	0	0	0
246410	1678	5040154177000	6254	3237	0	0	0
246411	498	66001000000000	6254	3237	1	0	0
246414	724	20001000000000	6256	3238	0	0	0
246416	1678	5040154179000	6256	3238	2	0	0
246417	1678	5040154180000	6256	3238	3	0	0
246418	1678	5040154181000	6257	3239	0	0	0
246419	1678	5040154182000	6258	3240	0	0	0
246421	1678	5040154184000	6260	3242	0	0	0
246422	1678	5040154185000	6260	3242	1	0	0
246423	1678	5040154186000	6261	3243	0	0	0
246426	1678	5040154187000	6264	3244	0	0	0
246429	1678	5040154188000	6266	3245	0	0	0
246431	1678	5040154190000	6267	3246	0	0	0
246432	1678	5040154191000	6268	3247	0	0	0
246438	1678	5040154197000	6271	3250	0	0	\N
246439	1678	5040154198000	6271	3250	1	0	\N
246440	1678	5040154199000	6271	3250	2	0	\N
246441	1678	5040154200000	6271	3250	3	0	\N
246442	1678	5040154197000	6272	3250	0	0	\N
246443	1678	5040154198000	6272	3250	1	0	\N
246444	1678	5040154199000	6272	3250	2	0	\N
246445	1678	5040154200000	6272	3250	3	0	\N
246450	1678	5040154197000	6274	3250	0	0	\N
246451	1678	5040154198000	6274	3250	1	0	\N
246452	1678	5040154199000	6274	3250	2	0	\N
246453	1678	5040154200000	6274	3250	3	0	\N
246454	1678	5040154197000	6275	3250	0	0	\N
246455	1678	5040154198000	6275	3250	1	0	\N
246456	1678	5040154199000	6275	3250	2	0	\N
246457	1678	5040154200000	6275	3250	3	0	\N
246458	1678	5040154201000	6276	3251	0	0	\N
246459	1678	5040154201000	6277	3251	0	0	\N
246462	1678	5040154203000	6280	3253	0	0	\N
246463	1678	5040154203000	6281	3253	0	0	\N
246465	1678	5040154204000	6283	3254	0	0	\N
246469	1678	5040154207000	6287	3257	0	0	\N
246474	1678	5040154211000	6291	3260	0	0	\N
246476	1678	5040154211000	6293	3260	0	0	\N
246477	1678	5040154211000	6294	3260	0	0	\N
246478	1678	5040154211000	6295	3260	0	0	\N
246479	1678	5040154212000	6296	3261	0	0	\N
246481	1678	5040154212000	6298	3261	0	0	\N
246482	1678	5040154212000	6299	3261	0	0	\N
246483	1678	5040154212000	6300	3261	0	0	\N
246485	1678	5040154213000	6302	3262	0	0	\N
246486	1868	9000000000	6303	3013	0	0	\N
246490	1869	200000000	6306	3265	0	0	\N
246491	1870	200000000	6306	3265	1	0	\N
246492	1678	5040154217000	6306	3265	2	0	\N
246493	1678	5040154218000	6306	3265	3	0	\N
246494	1678	5040154219000	6306	3265	4	0	\N
246495	1869	200000000	6307	3265	0	0	\N
246496	1870	200000000	6307	3265	1	0	\N
246497	1678	5040154217000	6307	3265	2	0	\N
246498	1678	5040154218000	6307	3265	3	0	\N
246499	1678	5040154219000	6307	3265	4	0	\N
246505	1678	5040154220000	6309	3266	0	0	\N
246510	1678	5040154223000	6313	3268	0	0	\N
246511	1678	5040154224000	6314	3269	0	0	\N
246512	1678	5040154225000	6314	3269	1	0	\N
246513	1678	5040154226000	6314	3269	2	0	\N
246517	1678	5040154227000	6316	3270	0	0	\N
246519	1678	5040154228000	6318	3271	0	0	\N
246520	1678	5040154228000	6319	3271	0	0	\N
246522	1678	5040154229000	6321	3272	0	0	\N
246524	1678	5040154229000	6323	3272	0	0	\N
246526	1678	5040154230000	6325	3273	0	0	\N
246528	1678	5040154232000	6327	3275	0	0	\N
246535	1678	5040154237000	6332	3278	0	0	\N
246536	1678	5040154237000	6333	3278	0	0	\N
246537	1869	200000000	6334	3014	0	0	\N
246538	1870	200000000	6334	3014	1	0	\N
246539	1678	5040154238000	6335	3279	0	0	\N
246544	1866	9000000000	6339	3048	0	0	\N
246545	1856	200000000	6339	3048	1	0	\N
246546	1857	200000000	6339	3048	2	0	\N
246547	1863	0	6339	3048	3	0	\N
246548	1863	1000000000	6339	3048	4	0	\N
246549	1858	200000000	6339	3048	5	0	\N
246550	1865	200000000	6339	3048	6	0	\N
246551	1867	200000000	6339	3048	7	0	\N
246552	1869	200000000	6339	3048	8	0	\N
246553	1870	200000000	6339	3048	9	0	\N
246554	1483	0	6339	3048	10	0	\N
246555	1866	12152037273550	6339	3048	11	0	\N
246556	1866	12153037273550	6339	3048	12	0	\N
246557	1863	1000000000	6339	3048	13	0	\N
246558	1678	3600093906000	6339	3048	15	0	\N
246559	1864	110000000000	6339	3048	16	0	\N
246560	1772	728750000000	6339	3048	19	0	\N
246561	1861	1010000000	6339	3048	21	0	\N
246562	1678	3600093907000	6339	3048	22	0	\N
246563	1678	3600093908000	6339	3048	23	0	\N
246564	1678	3600093909000	6339	3048	24	0	\N
246565	1860	10000000	6339	3048	25	0	\N
246566	1860	100020000000	6339	3048	26	0	\N
246567	1860	43900020000000	6339	3048	27	0	\N
246568	1678	3600093910000	6339	3048	28	0	\N
246435	1678	5040154194000	6270	3249	0	0	0
246436	1678	5040154195000	6270	3249	1	0	0
246437	1678	5040154196000	6270	3249	2	0	0
246446	1678	5040154197000	6273	3250	0	0	0
246447	1678	5040154198000	6273	3250	1	0	0
246449	1678	5040154200000	6273	3250	3	0	0
246460	1678	5040154201000	6278	3251	0	0	0
246461	1678	5040154202000	6279	3252	0	0	0
246464	1678	5040154203000	6282	3253	0	0	0
246466	1678	5040154204000	6284	3254	0	0	0
246468	1678	5040154206000	6286	3256	0	0	0
246470	1678	5040154207000	6288	3257	0	0	0
246471	1678	5040154208000	6289	3258	0	0	0
246472	1678	5040154209000	6289	3258	1	0	0
246475	1678	5040154211000	6292	3260	0	0	0
246480	1678	5040154212000	6297	3261	0	0	0
246484	1678	5040154213000	6301	3262	0	0	0
246487	1678	5040154214000	6304	3263	0	0	0
246488	1678	5040154215000	6304	3263	1	0	0
246500	1869	200000000	6308	3265	0	0	0
246501	1870	200000000	6308	3265	1	0	0
246502	1678	5040154217000	6308	3265	2	0	0
246503	1678	5040154218000	6308	3265	3	0	0
246504	1678	5040154219000	6308	3265	4	0	0
246507	1678	5040154221000	6311	3267	0	0	0
246508	1678	5040154222000	6311	3267	1	0	0
246509	1678	5040154223000	6312	3268	0	0	0
246514	1678	5040154224000	6315	3269	0	0	0
246516	1678	5040154226000	6315	3269	2	0	0
246518	1678	5040154227000	6317	3270	0	0	0
246521	1678	5040154228000	6320	3271	0	0	0
246523	1678	5040154229000	6322	3272	0	0	0
246525	1678	5040154230000	6324	3273	0	0	0
246529	1678	5040154232000	6328	3275	0	0	0
246530	1678	5040154233000	6329	3276	0	0	0
246531	1678	5040154234000	6330	3277	0	0	0
246532	1678	5040154235000	6330	3277	1	0	0
246533	1678	5040154236000	6330	3277	2	0	0
246540	1678	5040154238000	6336	3279	0	0	0
246541	1678	5040154239000	6337	3280	0	0	0
246542	1678	5040154240000	6338	3281	0	0	0
246543	1678	5040154241000	6338	3281	1	0	0
246569	1678	3600093911000	6339	3048	29	0	\N
246570	1678	3600093912000	6339	3048	30	0	\N
246571	1678	3600093913000	6339	3048	31	0	\N
246572	1678	3600093914000	6339	3048	32	0	\N
246573	1678	3600093915000	6339	3048	33	0	\N
246574	1678	3600093916000	6339	3048	34	0	\N
246575	1678	3600093917000	6339	3048	35	0	\N
246576	1678	3600093918000	6339	3048	36	0	\N
246577	1678	3600093919000	6339	3048	37	0	\N
246578	1678	3600093920000	6339	3048	38	0	\N
246579	1678	3600093921000	6339	3048	39	0	\N
246580	1678	3600093922000	6339	3048	40	0	\N
246581	1678	3600093923000	6339	3048	41	0	\N
246582	1678	3600093924000	6339	3048	42	0	\N
246583	1678	3600093925000	6339	3048	43	0	\N
246584	1678	3600093926000	6339	3048	44	0	\N
246585	1678	3600093927000	6339	3048	45	0	\N
246586	1678	3600093928000	6339	3048	46	0	\N
246587	1678	3600093929000	6339	3048	47	0	\N
246588	1678	3600093930000	6339	3048	48	0	\N
246589	1678	3600093931000	6339	3048	49	0	\N
246590	1678	3600093932000	6339	3048	50	0	\N
246591	1772	880750000000	6339	3048	51	0	\N
246592	1678	3600093933000	6339	3048	52	0	\N
246593	1678	3600093934000	6339	3048	53	0	\N
246594	1678	3600093935000	6339	3048	54	0	\N
246595	1678	3600093936000	6339	3048	55	0	\N
246596	1678	3600093937000	6339	3048	56	0	\N
246597	1678	3600093938000	6339	3048	57	0	\N
246598	1678	3600093939000	6339	3048	59	0	\N
246599	1678	3600093940000	6339	3048	60	0	\N
246600	1678	3600093941000	6339	3048	61	0	\N
246601	1678	3600093942000	6339	3048	62	0	\N
246602	1678	3600093943000	6339	3048	63	0	\N
246603	1678	3600093944000	6339	3048	64	0	\N
246604	1678	3600093945000	6339	3048	65	0	\N
246605	1678	3600093946000	6339	3048	66	0	\N
246606	1678	3600093947000	6339	3048	67	0	\N
246607	1678	3600093948000	6339	3048	68	0	\N
246608	1678	3600093949000	6339	3048	69	0	\N
246609	1678	3600093950000	6339	3048	70	0	\N
246610	1678	3600093951000	6339	3048	71	0	\N
246611	1678	3600093952000	6339	3048	72	0	\N
246612	1678	3600093953000	6339	3048	73	0	\N
246613	1678	3600093954000	6339	3048	74	0	\N
246614	1678	3600093955000	6339	3048	75	0	\N
246615	1678	3600093956000	6339	3048	76	0	\N
246616	1678	3600093957000	6339	3048	77	0	\N
246617	1678	3600093958000	6339	3048	78	0	\N
246618	1678	3600093959000	6339	3048	79	0	\N
246619	1678	3600093960000	6339	3048	80	0	\N
246620	1678	3600093961000	6339	3048	81	0	\N
246621	1678	3600093962000	6339	3048	82	0	\N
246622	1678	3600093963000	6339	3048	83	0	\N
246623	1678	3600093964000	6339	3048	84	0	\N
246624	1678	3600093965000	6339	3048	85	0	\N
246625	1678	3600093966000	6339	3048	86	0	\N
246626	1678	3600093967000	6339	3048	87	0	\N
246627	1678	3600093968000	6339	3048	88	0	\N
246628	1678	3600093969000	6339	3048	89	0	\N
246629	1678	3600093970000	6339	3048	90	0	\N
246630	1678	3600093971000	6339	3048	91	0	\N
246631	1678	3600093972000	6339	3048	92	0	\N
246632	1678	3600093973000	6339	3048	93	0	\N
246633	1678	3600093974000	6339	3048	94	0	\N
246634	1678	3600093975000	6339	3048	95	0	\N
246635	1678	3600093976000	6339	3048	96	0	\N
246636	1678	3600093977000	6339	3048	97	0	\N
246637	1678	3600093978000	6339	3048	98	0	\N
246638	1678	3600093979000	6339	3048	99	0	\N
246639	1678	3600093980000	6339	3048	100	0	\N
246640	1678	3600093981000	6339	3048	101	0	\N
246641	1678	3600093982000	6339	3048	102	0	\N
246642	1678	3600093983000	6339	3048	103	0	\N
246643	1678	3600093984000	6339	3048	104	0	\N
246644	1678	3600093985000	6339	3048	105	0	\N
246645	1678	3600093986000	6339	3048	106	0	\N
246646	1678	3600093987000	6339	3048	107	0	\N
246647	1678	3600093988000	6339	3048	108	0	\N
246648	1678	3600093989000	6339	3048	109	0	\N
246649	1678	3600093990000	6339	3048	110	0	\N
246650	1678	3600093991000	6339	3048	111	0	\N
246651	1678	3600093992000	6339	3048	112	0	\N
246652	1678	3600093993000	6339	3048	113	0	\N
246653	1678	3600093994000	6339	3048	114	0	\N
246654	1678	3600093995000	6339	3048	115	0	\N
246655	1678	3600093996000	6339	3048	116	0	\N
246656	1678	3600093997000	6339	3048	117	0	\N
246657	1678	3600093998000	6339	3048	118	0	\N
246658	1678	3600093999000	6339	3048	119	0	\N
246659	1678	3600094000000	6339	3048	120	0	\N
246660	1678	3600094001000	6339	3048	121	0	\N
246661	1678	3600094002000	6339	3048	122	0	\N
246662	1678	3600094003000	6339	3048	123	0	\N
246663	1678	3600094004000	6339	3048	124	0	\N
246664	1678	3600094005000	6339	3048	125	0	\N
246665	1678	5040154242000	6340	3282	0	0	\N
246667	1678	5040154242000	6342	3282	0	0	\N
246669	1678	5040154244000	6344	3284	0	0	\N
246670	1678	5040154244000	6345	3284	0	0	\N
246671	1678	3600094006000	6346	3049	0	0	\N
246672	1678	3600094007000	6346	3049	1	0	\N
246673	1678	3600094008000	6346	3049	2	0	\N
246674	1678	3600094009000	6346	3049	3	0	\N
246675	1678	3600094010000	6346	3049	4	0	\N
246676	1678	3600094011000	6346	3049	5	0	\N
246677	1678	3600094012000	6346	3049	6	0	\N
246678	1678	3600094013000	6346	3049	7	0	\N
246679	1678	3600094014000	6346	3049	8	0	\N
246680	1678	3600094015000	6346	3049	9	0	\N
246681	1678	3600094016000	6346	3049	10	0	\N
246682	1678	3600094017000	6346	3049	11	0	\N
246683	1678	3600094018000	6346	3049	12	0	\N
246684	1678	3600094019000	6346	3049	13	0	\N
246685	1678	3600094020000	6346	3049	14	0	\N
246686	1678	3600094021000	6346	3049	15	0	\N
246687	1678	3600094022000	6346	3049	16	0	\N
246688	1678	3600094023000	6346	3049	17	0	\N
246689	1678	3600094024000	6346	3049	18	0	\N
246690	1678	3600094025000	6346	3049	19	0	\N
246691	1678	3600094026000	6346	3049	20	0	\N
246692	1772	1091750000000	6346	3049	21	0	\N
246693	1678	3600094027000	6346	3049	22	0	\N
246694	1678	3600094028000	6346	3049	23	0	\N
246695	1678	3600094029000	6346	3049	24	0	\N
246696	1678	3600094030000	6346	3049	25	0	\N
246697	1678	3600094031000	6346	3049	26	0	\N
246698	1678	3600094032000	6346	3049	27	0	\N
246699	1678	3600094033000	6346	3049	28	0	\N
246700	1678	3600094034000	6346	3049	29	0	\N
246701	1678	3600094035000	6346	3049	30	0	\N
246702	1678	3600094036000	6346	3049	31	0	\N
246703	1678	3600094037000	6346	3049	32	0	\N
246704	1678	3600094038000	6346	3049	33	0	\N
246705	1678	3600094039000	6346	3049	34	0	\N
246706	1678	3600094040000	6346	3049	35	0	\N
246707	1678	3600094041000	6346	3049	36	0	\N
246708	1678	3600094042000	6346	3049	37	0	\N
246709	1678	3600094043000	6346	3049	38	0	\N
246710	1678	3600094044000	6346	3049	39	0	\N
246711	1678	3600094045000	6346	3049	40	0	\N
246712	1678	3600094046000	6346	3049	41	0	\N
246713	1678	3600094047000	6346	3049	42	0	\N
246714	1678	3600094048000	6346	3049	43	0	\N
246715	1678	3600094049000	6346	3049	44	0	\N
246716	1678	3600094050000	6346	3049	45	0	\N
246717	1678	3600094051000	6346	3049	46	0	\N
246718	1678	3600094052000	6346	3049	47	0	\N
246719	1678	3600094053000	6346	3049	48	0	\N
246720	1678	3600094054000	6346	3049	49	0	\N
246721	1678	3600094055000	6346	3049	50	0	\N
246722	1678	3600094056000	6346	3049	51	0	\N
246723	1678	3600094057000	6346	3049	52	0	\N
246724	1678	3600094058000	6346	3049	53	0	\N
246725	1678	3600094059000	6346	3049	54	0	\N
246726	1678	3600094060000	6346	3049	55	0	\N
246727	1678	3600094061000	6346	3049	56	0	\N
246728	1678	3600094062000	6346	3049	57	0	\N
246729	1678	3600094063000	6346	3049	59	0	\N
246730	1678	3600094064000	6346	3049	60	0	\N
246731	1678	3600094065000	6346	3049	61	0	\N
246732	1678	3600094066000	6346	3049	62	0	\N
246733	1678	3600094067000	6346	3049	63	0	\N
246734	1678	3600094068000	6346	3049	64	0	\N
246735	1678	3600094069000	6346	3049	65	0	\N
246736	1678	3600094070000	6346	3049	66	0	\N
246737	1678	3600094071000	6346	3049	67	0	\N
246738	1678	3600094072000	6346	3049	68	0	\N
246739	1678	3600094073000	6346	3049	69	0	\N
246740	1678	3600094074000	6346	3049	70	0	\N
246741	1678	3600094075000	6346	3049	71	0	\N
246742	1678	3600094076000	6346	3049	72	0	\N
246743	1678	3600094077000	6346	3049	73	0	\N
246744	1678	3600094078000	6346	3049	74	0	\N
246745	1678	3600094079000	6346	3049	75	0	\N
246746	1678	3600094080000	6346	3049	76	0	\N
246747	1678	3600094081000	6346	3049	77	0	\N
246748	1678	3600094082000	6346	3049	78	0	\N
246749	1678	3600094083000	6346	3049	79	0	\N
246750	1678	3600094084000	6346	3049	80	0	\N
246751	1678	3600094085000	6346	3049	81	0	\N
246752	1678	3600094086000	6346	3049	82	0	\N
246753	1678	3600094087000	6346	3049	83	0	\N
246754	1678	3600094088000	6346	3049	84	0	\N
246755	1678	3600094089000	6346	3049	85	0	\N
246756	1678	3600094090000	6346	3049	86	0	\N
246757	1678	3600094091000	6346	3049	87	0	\N
246758	1678	3600094092000	6346	3049	88	0	\N
246759	1678	3600094093000	6346	3049	89	0	\N
246760	1678	3600094094000	6346	3049	90	0	\N
246761	1678	3600094095000	6346	3049	91	0	\N
246762	1678	3600094096000	6346	3049	92	0	\N
246763	1678	3600094097000	6346	3049	93	0	\N
246764	1678	3600094098000	6346	3049	94	0	\N
246765	1678	3600094099000	6346	3049	95	0	\N
246766	1678	3600094100000	6346	3049	96	0	\N
246767	1678	3600094101000	6346	3049	97	0	\N
246768	1678	3600094102000	6346	3049	98	0	\N
246769	1678	3600094103000	6346	3049	99	0	\N
246770	1678	3600094104000	6346	3049	100	0	\N
246771	1678	3600094105000	6346	3049	101	0	\N
246772	1678	3600094106000	6346	3049	102	0	\N
246773	1678	3600094107000	6346	3049	103	0	\N
246774	1678	3600094108000	6346	3049	104	0	\N
246775	1678	3600094109000	6346	3049	105	0	\N
246776	1678	3600094110000	6346	3049	106	0	\N
246777	1678	3600094111000	6346	3049	107	0	\N
246778	1678	3600094112000	6346	3049	108	0	\N
246779	1678	3600094113000	6346	3049	109	0	\N
246780	1678	3600094114000	6346	3049	110	0	\N
246781	1678	3600094115000	6346	3049	111	0	\N
246782	1678	3600094116000	6346	3049	112	0	\N
246783	1678	3600094117000	6346	3049	113	0	\N
246784	1678	3600094118000	6346	3049	114	0	\N
246785	1678	3600094119000	6346	3049	115	0	\N
246786	1678	3600094120000	6346	3049	116	0	\N
246787	1678	3600094121000	6346	3049	117	0	\N
246788	1678	3600094122000	6346	3049	118	0	\N
246789	1678	3600094123000	6346	3049	119	0	\N
246790	1678	3600094124000	6346	3049	120	0	\N
246791	1678	3600094125000	6346	3049	121	0	\N
246792	1678	3600094126000	6346	3049	122	0	\N
246793	1678	3600094127000	6346	3049	123	0	\N
246794	1678	3600094128000	6346	3049	124	0	\N
246795	1678	3600094129000	6346	3049	125	0	\N
246798	1678	5040154245000	6349	3285	0	0	\N
246802	1678	5040154247000	6352	3287	0	0	\N
246803	1678	5040154248000	6352	3287	1	0	\N
246804	1678	5040154247000	6353	3287	0	0	\N
246805	1678	5040154248000	6353	3287	1	0	\N
246809	1678	5040154249000	6355	3288	0	0	\N
246810	1678	5040154250000	6355	3288	1	0	\N
246811	1678	5040154251000	6355	3288	2	0	\N
246818	1866	9000000000	6360	3185	0	0	\N
246819	1867	200000000	6360	3185	1	0	\N
246820	1863	1000000000	6360	3185	2	0	\N
246821	1869	200000000	6360	3185	3	0	\N
246822	1870	200000000	6360	3185	4	0	\N
246823	1483	0	6360	3185	5	0	\N
246824	1866	12152037273550	6360	3185	6	0	\N
246825	1866	12153037273550	6360	3185	7	0	\N
246826	1863	1000000000	6360	3185	8	0	\N
246827	1868	9000000000	6360	3185	10	0	\N
246831	1678	5040154261000	6363	3295	0	0	\N
246833	1678	5040154262000	6365	3296	0	0	\N
246835	1678	5040154263000	6367	3297	0	0	\N
246799	1678	5040154246000	6350	3286	0	0	0
246800	1678	5040154247000	6351	3287	0	0	0
246801	1678	5040154248000	6351	3287	1	0	0
246806	1678	5040154249000	6354	3288	0	0	0
246807	1678	5040154250000	6354	3288	1	0	0
246812	1678	5040154252000	6356	3289	0	0	0
246813	1678	5040154253000	6356	3289	1	0	0
246814	1678	5040154254000	6357	3290	0	0	0
246815	1678	5040154255000	6358	3291	0	0	0
246816	1678	5040154256000	6358	3291	1	0	0
246828	1678	5040154258000	6361	3293	0	0	0
246829	1678	5040154259000	6361	3293	1	0	0
246830	1678	5040154260000	6362	3294	0	0	0
246832	1678	5040154261000	6364	3295	0	0	0
246836	1678	5040154263000	6368	3297	0	0	0
246837	1678	5040154264000	6369	3298	0	0	0
246838	1678	5040154265000	6370	3299	0	0	0
246839	1678	5040154266000	6370	3299	1	0	0
246840	1678	5040154267000	6370	3299	2	0	0
246842	1678	5040154269000	6372	3301	0	0	\N
246843	1678	5040154270000	6372	3301	1	0	\N
246844	1678	5040154271000	6372	3301	2	0	\N
246848	1678	5040154272000	6374	3302	0	0	\N
246849	1678	5040154272000	6375	3302	0	0	\N
246851	1678	5040154273000	6377	3303	0	0	\N
246859	1678	5040154278000	6382	3307	0	0	\N
246864	1678	5040154281000	6387	3310	0	0	\N
246867	1678	5040154282000	6389	3311	0	0	\N
246868	1678	5040154283000	6389	3311	1	0	\N
246871	1678	5040154285000	6392	3313	0	0	\N
246872	1678	5040154286000	6393	3314	0	0	\N
246873	1678	5040154287000	6393	3314	1	0	\N
246876	1678	5040154288000	6399	3316	0	0	\N
246877	1678	5040154289000	6399	3316	1	0	\N
246878	1678	5040154290000	6399	3316	2	0	\N
246879	1678	5040154288000	6400	3316	0	0	\N
246880	1678	5040154289000	6400	3316	1	0	\N
246881	1678	5040154290000	6400	3316	2	0	\N
246886	1678	5040154292000	6403	3318	0	0	\N
246887	1678	5040154293000	6403	3318	1	0	\N
246888	1678	5040154294000	6403	3318	2	0	\N
246889	1678	5040154295000	6403	3318	3	0	\N
246894	1872	200000000	6405	3281	0	0	\N
246895	1873	200000000	6405	3281	1	0	\N
246896	1678	5040154296000	6406	3319	0	0	\N
246897	1678	5040154297000	6406	3319	1	0	\N
246898	1678	5040154298000	6406	3319	2	0	\N
246910	1678	5040154306000	6412	3323	0	0	\N
246911	1678	5040154307000	6413	3324	0	0	\N
246912	1678	5040154308000	6413	3324	2	0	\N
246913	1678	5040154309000	6413	3324	3	0	\N
246917	1678	5040154307000	6415	3324	0	0	\N
246918	1678	5040154308000	6415	3324	2	0	\N
246919	1678	5040154309000	6415	3324	3	0	\N
246920	1678	5040154307000	6416	3324	0	0	\N
246921	1678	5040154308000	6416	3324	2	0	\N
246922	1678	5040154309000	6416	3324	3	0	\N
246923	1678	5040154310000	6417	3325	0	0	\N
246924	1678	5040154310000	6418	3325	0	0	\N
246925	1678	5040154310000	6419	3325	0	0	\N
246926	1678	5040154310000	6420	3325	0	0	\N
246928	1872	200000000	6422	3050	0	0	\N
246929	1873	200000000	6422	3050	1	0	\N
246930	1678	3600094130000	6422	3050	3	0	\N
246931	1678	3600094131000	6422	3050	4	0	\N
246932	1678	3600094132000	6422	3050	5	0	\N
246933	1678	3600094133000	6422	3050	6	0	\N
246934	1678	3600094134000	6422	3050	11	0	\N
246935	1678	3600094135000	6422	3050	12	0	\N
246936	1678	3600094136000	6422	3050	13	0	\N
246937	1678	3600094137000	6422	3050	14	0	\N
246938	1678	3600094138000	6422	3050	15	0	\N
246939	1678	3600094139000	6422	3050	16	0	\N
246940	1678	3600094140000	6422	3050	17	0	\N
246941	1678	3600094141000	6422	3050	18	0	\N
246942	1678	3600094142000	6422	3050	19	0	\N
246943	1678	3600094143000	6422	3050	20	0	\N
246944	1678	3600094144000	6422	3050	21	0	\N
246945	1678	3600094145000	6422	3050	22	0	\N
246946	1678	3600094146000	6422	3050	23	0	\N
246947	1678	3600094147000	6422	3050	24	0	\N
246948	1678	3600094148000	6422	3050	25	0	\N
246949	1678	3600094149000	6422	3050	26	0	\N
246950	1678	3600094150000	6422	3050	27	0	\N
246951	1678	3600094151000	6422	3050	28	0	\N
246952	1678	3600094152000	6422	3050	30	0	\N
246953	1678	3600094153000	6422	3050	31	0	\N
246954	1678	3600094154000	6422	3050	32	0	\N
246955	1678	3600094155000	6422	3050	33	0	\N
246956	1678	3600094156000	6422	3050	34	0	\N
246957	1678	3600094157000	6422	3050	35	0	\N
246958	1678	3600094158000	6422	3050	36	0	\N
246959	1678	3600094159000	6422	3050	37	0	\N
246960	1678	3600094160000	6422	3050	38	0	\N
246961	1678	3600094161000	6422	3050	39	0	\N
246962	1678	3600094162000	6422	3050	40	0	\N
246963	1678	3600094163000	6422	3050	41	0	\N
246964	1678	3600094164000	6422	3050	42	0	\N
246965	1678	3600094165000	6422	3050	43	0	\N
246966	1678	3600094166000	6422	3050	44	0	\N
246967	1678	3600094167000	6422	3050	45	0	\N
246968	1678	3600094168000	6422	3050	46	0	\N
246969	1678	3600094169000	6422	3050	47	0	\N
246970	1678	3600094170000	6422	3050	48	0	\N
246971	1678	3600094171000	6422	3050	49	0	\N
246972	1678	3600094172000	6422	3050	50	0	\N
246973	1678	3600094173000	6422	3050	51	0	\N
246974	1678	3600094174000	6422	3050	52	0	\N
246975	1678	3600094175000	6422	3050	53	0	\N
246976	1678	3600094176000	6422	3050	54	0	\N
246846	1678	5040154270000	6373	3301	1	0	0
246847	1678	5040154271000	6373	3301	2	0	0
246850	1678	5040154272000	6376	3302	0	0	0
246852	1678	5040154273000	6378	3303	0	0	0
246853	1872	200000000	6379	3304	0	0	0
246855	1873	200000000	6380	3305	0	0	0
246856	1678	5040154275000	6380	3305	1	0	0
246857	1678	5040154276000	6380	3305	2	0	0
246858	1678	5040154277000	6381	3306	0	0	0
246860	1678	5040154278000	6383	3307	0	0	0
246862	1678	5040154280000	6385	3309	0	0	0
246863	1678	5040154281000	6386	3310	0	0	0
246865	1678	5040154282000	6388	3311	0	0	0
246866	1678	5040154283000	6388	3311	1	0	0
246870	1678	5040154285000	6391	3313	0	0	0
246874	1678	5040154286000	6394	3314	0	0	0
246875	1678	5040154287000	6394	3314	1	0	0
246882	1678	5040154288000	6401	3316	0	0	0
246883	1678	5040154289000	6401	3316	1	0	0
246885	1678	5040154291000	6402	3317	0	0	0
246890	1678	5040154292000	6404	3318	0	0	0
246891	1678	5040154293000	6404	3318	1	0	0
246892	1678	5040154294000	6404	3318	2	0	0
246893	1678	5040154295000	6404	3318	3	0	0
246900	1678	5040154297000	6407	3319	1	0	0
246901	1678	5040154298000	6407	3319	2	0	0
246902	1678	5040154299000	6408	3320	0	0	0
246903	1678	5040154300000	6408	3320	1	0	0
246905	1678	5040154302000	6408	3320	3	0	0
246906	1678	5040154303000	6409	3321	0	0	0
246907	1678	5040154304000	6410	3322	0	0	0
246908	1678	5040154305000	6410	3322	2	0	0
246909	1678	5040154306000	6411	3323	0	0	0
246915	1678	5040154308000	6414	3324	2	0	0
246916	1678	5040154309000	6414	3324	3	0	0
246927	1678	5040154310000	6421	3325	0	0	0
246977	1678	3600094177000	6422	3050	55	0	\N
246978	1678	3600094178000	6422	3050	56	0	\N
246979	1678	3600094179000	6422	3050	57	0	\N
246980	1678	3600094180000	6422	3050	59	0	\N
246981	1678	3600094181000	6422	3050	60	0	\N
246982	1678	3600094182000	6422	3050	61	0	\N
246983	1678	3600094183000	6422	3050	62	0	\N
246984	1678	3600094184000	6422	3050	63	0	\N
246985	1678	3600094185000	6422	3050	64	0	\N
246986	1678	3600094186000	6422	3050	65	0	\N
246987	1678	3600094187000	6422	3050	66	0	\N
246988	1678	3600094188000	6422	3050	67	0	\N
246989	1678	3600094189000	6422	3050	68	0	\N
246990	1678	3600094190000	6422	3050	69	0	\N
246991	1678	3600094191000	6422	3050	70	0	\N
246992	1678	3600094192000	6422	3050	71	0	\N
246993	1678	3600094193000	6422	3050	72	0	\N
246994	1678	3600094194000	6422	3050	73	0	\N
246995	1678	3600094195000	6422	3050	74	0	\N
246996	1678	3600094196000	6422	3050	75	0	\N
246997	1678	3600094197000	6422	3050	76	0	\N
246998	1678	3600094198000	6422	3050	77	0	\N
246999	1678	3600094199000	6422	3050	78	0	\N
247000	1678	3600094200000	6422	3050	79	0	\N
247001	1678	3600094201000	6422	3050	80	0	\N
247002	1678	3600094202000	6422	3050	81	0	\N
247003	1678	3600094203000	6422	3050	82	0	\N
247004	1678	3600094204000	6422	3050	83	0	\N
247005	1678	3600094205000	6422	3050	84	0	\N
247006	1678	3600094206000	6422	3050	85	0	\N
247007	1678	3600094207000	6422	3050	86	0	\N
247008	1678	3600094208000	6422	3050	87	0	\N
247009	1678	3600094209000	6422	3050	88	0	\N
247010	1678	3600094210000	6422	3050	89	0	\N
247012	1678	5040154311000	6424	3326	1	0	\N
247014	1678	5040154313000	6427	3328	2	0	\N
247015	1678	5040154314000	6427	3328	3	0	\N
247016	1678	5040154313000	6428	3328	2	0	\N
247017	1678	5040154314000	6428	3328	3	0	\N
247018	1678	5040154313000	6429	3328	2	0	\N
247019	1678	5040154314000	6429	3328	3	0	\N
247023	1678	5040154316000	6432	3330	0	0	\N
247024	1678	5040154316000	6433	3330	0	0	\N
247026	1678	5040154316000	6435	3330	0	0	\N
247028	1678	5040154317000	6437	3331	0	0	\N
247029	1678	5040154317000	6438	3331	0	0	\N
247037	1678	5040154324000	6442	3334	1	0	\N
247039	1678	5040154325000	6445	3335	1	0	\N
247043	1678	5040154328000	6449	3338	0	0	\N
247047	1678	5040154330000	6453	3341	0	0	\N
247048	1678	5040154331000	6453	3341	2	0	\N
247056	1678	5040154337000	6459	3346	0	0	\N
247057	1678	5040154338000	6459	3346	1	0	\N
247058	1678	5040154337000	6460	3346	0	0	\N
247059	1678	5040154338000	6460	3346	1	0	\N
247062	1678	5040154339000	6462	3347	2	0	\N
247063	1678	5040154340000	6462	3347	3	0	\N
247068	1678	5040154344000	6466	3350	0	0	\N
247069	1678	5040154345000	6467	3351	0	0	\N
247070	1874	200000000	6467	3351	1	0	\N
247078	1678	5040154350000	6472	3355	0	0	\N
247079	1874	200001000	6472	3355	1	0	\N
247084	1874	200002000	6475	3356	0	0	\N
247085	1678	5040154351000	6475	3356	1	0	\N
247086	1678	5040154352000	6476	3357	0	0	\N
247087	1874	200003000	6476	3357	1	0	\N
247094	1874	200006000	6479	3359	0	0	\N
247095	1678	5040154355000	6479	3359	1	0	\N
247096	1874	200006000	6480	3359	0	0	\N
247097	1678	5040154355000	6480	3359	1	0	\N
247098	1874	200006000	6481	3359	0	0	\N
247099	1678	5040154355000	6481	3359	1	0	\N
247102	1678	5040154356000	6483	3360	0	0	\N
247103	1874	200007000	6483	3360	1	0	\N
247108	1874	200008000	6486	3361	0	0	\N
247109	1678	5040154357000	6486	3361	1	0	\N
247112	1869	200000000	6488	3256	0	0	\N
247020	1678	5040154313000	6430	3328	2	0	0
247021	1678	5040154314000	6430	3328	3	0	0
247022	1678	5040154315000	6431	3329	0	0	0
247025	1678	5040154316000	6434	3330	0	0	0
247027	1678	5040154317000	6436	3331	0	0	0
247031	1678	5040154319000	6439	3332	4	0	0
247032	1678	5040154320000	6439	3332	5	0	0
247033	1678	5040154321000	6440	3333	2	0	0
247034	1678	5040154322000	6440	3333	4	0	0
247035	1678	5040154323000	6440	3333	5	0	0
247038	1678	5040154325000	6444	3335	1	0	0
247040	1678	5040154326000	6446	3336	1	0	0
247041	1678	5040154327000	6447	3337	0	0	0
247042	1678	5040154328000	6448	3338	0	0	0
247045	1678	5040154330000	6452	3341	0	0	0
247046	1678	5040154331000	6452	3341	2	0	0
247049	1678	5040154332000	6454	3342	0	0	0
247050	1678	5040154333000	6456	3344	2	0	0
247051	1678	5040154334000	6456	3344	3	0	0
247053	1678	5040154336000	6457	3345	1	0	0
247054	1678	5040154337000	6458	3346	0	0	0
247055	1678	5040154338000	6458	3346	1	0	0
247060	1678	5040154339000	6461	3347	2	0	0
247061	1678	5040154340000	6461	3347	3	0	0
247065	1678	5040154342000	6464	3349	1	0	0
247066	1678	5040154343000	6464	3349	2	0	0
247067	1678	5040154344000	6465	3350	0	0	0
247071	1678	5040154345000	6468	3351	0	0	0
247073	1678	5040154346000	6469	3352	0	0	0
247074	1678	5040154347000	6470	3353	0	0	0
247075	1875	200000000	6471	3354	0	0	0
247076	1678	5040154348000	6471	3354	1	0	0
247077	1678	5040154349000	6471	3354	2	0	0
247081	1874	200001000	6473	3355	1	0	0
247082	1874	200002000	6474	3356	0	0	0
247083	1678	5040154351000	6474	3356	1	0	0
247088	1678	5040154352000	6477	3357	0	0	0
247089	1874	200003000	6477	3357	1	0	0
247091	1678	5040154354000	6478	3358	1	0	0
247092	1874	200004000	6478	3358	2	0	0
247093	1874	200005000	6478	3358	3	0	0
247100	1874	200006000	6482	3359	0	0	0
247104	1678	5040154356000	6484	3360	0	0	0
247105	1874	200007000	6484	3360	1	0	0
247106	1874	200008000	6485	3361	0	0	0
247107	1678	5040154357000	6485	3361	1	0	0
247110	1678	5040154358000	6487	3362	0	0	0
247113	1870	200000000	6488	3256	1	0	\N
247114	1872	200000000	6488	3256	2	0	\N
247115	1873	200000000	6488	3256	3	0	\N
247116	1874	200000000	6488	3256	42	0	\N
247117	1875	200000000	6488	3256	43	0	\N
247118	1874	200001000	6488	3256	44	0	\N
247119	1874	200002000	6488	3256	45	0	\N
247120	1874	200003000	6488	3256	46	0	\N
247121	1874	200004000	6488	3256	47	0	\N
247122	1874	200005000	6488	3256	48	0	\N
247123	1874	200006000	6488	3256	49	0	\N
247124	1874	200007000	6488	3256	50	0	\N
247125	1874	200008000	6488	3256	51	0	\N
247126	1874	200009000	6488	3256	52	0	\N
247127	1874	200010000	6488	3256	53	0	\N
247128	1678	5040154359000	6489	3363	0	0	\N
247129	1678	5040154360000	6489	3363	1	0	\N
247130	1874	200010000	6489	3363	2	0	\N
247131	1874	200011000	6489	3363	3	0	\N
247140	1874	200013000	6493	3365	0	0	\N
247141	1678	5040154362000	6493	3365	1	0	\N
247142	1678	5040154363000	6494	3366	0	0	\N
247143	1874	200014000	6494	3366	1	0	\N
247146	1874	200015000	6496	3367	0	0	\N
247147	1874	200016000	6496	3367	1	0	\N
247148	1678	5040154364000	6496	3367	2	0	\N
247149	1678	5040154365000	6496	3367	3	0	\N
247154	1874	200017000	6499	3368	0	0	\N
247155	1678	5040154366000	6499	3368	1	0	\N
247162	1678	5040154369000	6503	3371	0	0	\N
247163	1874	200020000	6503	3371	1	0	\N
247174	1678	5040154373000	6508	3374	0	0	\N
247175	1874	200024000	6508	3374	1	0	\N
247178	1678	5040154374000	6510	3375	0	0	\N
247179	1874	200025000	6510	3375	1	0	\N
247180	1678	5040154374000	6511	3375	0	0	\N
247181	1874	200025000	6511	3375	1	0	\N
247182	1678	5040154374000	6512	3375	0	0	\N
247183	1874	200025000	6512	3375	1	0	\N
247190	1874	200027000	6515	3377	0	0	\N
247191	1874	200028000	6515	3377	1	0	\N
247192	1678	5040154376000	6515	3377	2	0	\N
247193	1678	5040154377000	6515	3377	3	0	\N
247194	1874	200027000	6517	3377	0	0	\N
247195	1874	200028000	6517	3377	1	0	\N
247196	1678	5040154376000	6517	3377	2	0	\N
247197	1678	5040154377000	6517	3377	3	0	\N
247200	1678	5040154379000	6519	3379	0	0	\N
247201	1874	200030000	6519	3379	1	0	\N
247202	1678	5040154379000	6520	3379	0	0	\N
247203	1874	200030000	6520	3379	1	0	\N
247208	1874	200031000	6523	3380	0	0	\N
247209	1678	5040154380000	6523	3380	1	0	\N
247210	1874	200031000	6524	3380	0	0	\N
247211	1678	5040154380000	6524	3380	1	0	\N
247220	1874	200035000	6529	3384	0	0	\N
247221	1678	5040154384000	6529	3384	1	0	\N
247222	1874	200035000	6530	3384	0	0	\N
247223	1678	5040154384000	6530	3384	1	0	\N
247224	1678	5040154385000	6531	3385	0	0	\N
247225	1874	200036000	6531	3385	1	0	\N
247228	1678	5040154385000	6533	3385	0	0	\N
247229	1874	200036000	6533	3385	1	0	\N
247232	1874	200038000	6535	3387	0	0	\N
247233	1678	5040154387000	6535	3387	1	0	\N
247236	1874	200038000	6538	3387	0	0	\N
247237	1678	5040154387000	6538	3387	1	0	\N
247240	1678	5040154388000	6540	3388	0	0	\N
247241	1874	200039000	6540	3388	1	0	\N
247244	1874	200041000	6542	3390	0	0	\N
247245	1678	5040154390000	6542	3390	1	0	\N
247134	1874	200010000	6490	3363	2	0	0
247135	1874	200011000	6490	3363	3	0	0
247136	1874	200012000	6491	3364	0	0	0
247137	1678	5040154361000	6491	3364	1	0	0
247138	1874	200013000	6492	3365	0	0	0
247144	1678	5040154363000	6495	3366	0	0	0
247145	1874	200014000	6495	3366	1	0	0
247150	1874	200015000	6497	3367	0	0	0
247151	1874	200016000	6497	3367	1	0	0
247152	1678	5040154364000	6497	3367	2	0	0
247156	1874	200017000	6500	3368	0	0	0
247157	1678	5040154366000	6500	3368	1	0	0
247158	1678	5040154367000	6501	3369	0	0	0
247159	1874	200018000	6501	3369	1	0	0
247161	1874	200019000	6502	3370	1	0	0
247164	1678	5040154369000	6504	3371	0	0	0
247165	1874	200020000	6504	3371	1	0	0
247166	1678	5040154370000	6505	3372	0	0	0
247167	1874	200021000	6505	3372	1	0	0
247169	1678	5040154372000	6506	3373	1	0	0
247170	1874	200022000	6506	3373	2	0	0
247171	1874	200023000	6506	3373	3	0	0
247172	1678	5040154373000	6507	3374	0	0	0
247173	1874	200024000	6507	3374	1	0	0
247177	1874	200025000	6509	3375	1	0	0
247184	1874	200026000	6513	3376	0	0	0
247185	1678	5040154375000	6513	3376	1	0	0
247186	1874	200027000	6514	3377	0	0	0
247188	1678	5040154376000	6514	3377	2	0	0
247189	1678	5040154377000	6514	3377	3	0	0
247198	1874	200029000	6518	3378	0	0	0
247199	1678	5040154378000	6518	3378	1	0	0
247204	1678	5040154379000	6521	3379	0	0	0
247206	1874	200031000	6522	3380	0	0	0
247207	1678	5040154380000	6522	3380	1	0	0
247212	1874	200032000	6525	3381	0	0	0
247213	1678	5040154381000	6525	3381	1	0	0
247214	1678	5040154382000	6526	3382	0	0	0
247216	1678	5040154383000	6527	3383	0	0	0
247217	1874	200034000	6527	3383	1	0	0
247218	1874	200035000	6528	3384	0	0	0
247219	1678	5040154384000	6528	3384	1	0	0
247227	1874	200036000	6532	3385	1	0	0
247230	1678	5040154386000	6534	3386	0	0	0
247231	1874	200037000	6534	3386	1	0	0
247234	1874	200038000	6537	3387	0	0	0
247235	1678	5040154387000	6537	3387	1	0	0
247239	1874	200039000	6539	3388	1	0	0
247242	1678	5040154389000	6541	3389	0	0	0
247243	1874	200040000	6541	3389	1	0	0
247246	1874	200041000	6543	3390	0	0	0
247247	1678	5040154390000	6543	3390	1	0	0
247262	1678	5040154397000	6551	3395	0	0	\N
247263	1874	200048000	6551	3395	1	0	\N
247264	1678	5040154397000	6552	3395	0	0	\N
247265	1874	200048000	6552	3395	1	0	\N
247269	1678	5040154398000	6554	3396	0	0	\N
247270	1874	200049000	6554	3396	1	0	\N
247271	1876	4000000000	6554	3396	2	0	\N
247272	1874	200050000	6555	3397	0	0	\N
247273	1678	5040154399000	6555	3397	1	0	\N
247276	1874	200050000	6558	3397	0	0	\N
247277	1678	5040154399000	6558	3397	1	0	\N
247279	1678	5040154401000	6560	3399	0	0	\N
247280	1874	200051000	6560	3399	1	0	\N
247281	1678	5040154401000	6561	3399	0	0	\N
247282	1874	200051000	6561	3399	1	0	\N
247283	1678	5040154401000	6562	3399	0	0	\N
247284	1874	200051000	6562	3399	1	0	\N
247285	1678	5040154401000	6563	3399	0	0	\N
247286	1874	200051000	6563	3399	1	0	\N
247287	1876	4000000000	6564	3389	0	0	\N
247288	1678	5040154401000	6565	3399	0	0	\N
247289	1874	200051000	6565	3399	1	0	\N
247296	1678	5040154404000	6569	3402	0	0	\N
247297	1874	200054000	6569	3402	1	0	\N
247298	1678	5040154404000	6570	3402	0	0	\N
247299	1874	200054000	6570	3402	1	0	\N
247306	1678	5040154405000	6573	3403	0	0	\N
247307	1678	5040154406000	6573	3403	1	0	\N
247308	1874	200055000	6573	3403	2	0	\N
247309	1874	200056000	6573	3403	3	0	\N
247310	1678	5040154405000	6574	3403	0	0	\N
247311	1678	5040154406000	6574	3403	1	0	\N
247312	1874	200055000	6574	3403	2	0	\N
247313	1874	200056000	6574	3403	3	0	\N
247314	1874	200057000	6575	3404	0	0	\N
247315	1678	5040154407000	6575	3404	1	0	\N
247320	1874	200058000	6578	3405	0	0	\N
247321	1678	5040154408000	6578	3405	1	0	\N
247322	1874	200058000	6579	3405	0	0	\N
247323	1678	5040154408000	6579	3405	1	0	\N
247324	1874	200058000	6580	3405	0	0	\N
247325	1678	5040154408000	6580	3405	1	0	\N
247326	1874	200058000	6581	3405	0	0	\N
247327	1678	5040154408000	6581	3405	1	0	\N
247328	1876	4000000000	6582	3365	0	0	\N
247332	1540	715009000000	6584	3407	0	0	\N
247333	1678	5040154410000	6584	3407	1	0	\N
247334	1678	5040154411000	6584	3407	2	0	\N
247335	1874	200060000	6584	3407	3	0	\N
247336	1874	200061000	6584	3407	4	0	\N
247342	1540	715009000000	6586	3407	0	0	\N
247343	1678	5040154410000	6586	3407	1	0	\N
247344	1678	5040154411000	6586	3407	2	0	\N
247345	1874	200060000	6586	3407	3	0	\N
247346	1874	200061000	6586	3407	4	0	\N
247347	1876	351700000000	6587	3366	0	0	\N
247348	1874	200062000	6588	3408	0	0	\N
247349	1874	200063000	6588	3408	1	0	\N
247350	1678	5040154412000	6588	3408	2	0	\N
247351	1878	0	6588	3408	3	0	\N
247352	1874	200064000	6588	3408	4	0	\N
247353	1874	200065000	6588	3408	5	0	\N
247354	1678	5040154413000	6588	3408	6	0	\N
247355	1678	5040154414000	6588	3408	7	0	\N
247356	1876	350670000000	6588	3408	8	0	\N
247372	1678	5040154417000	6593	3411	0	0	\N
247373	1874	200068000	6593	3411	1	0	\N
247374	1678	5040154417000	6594	3411	0	0	\N
247375	1874	200068000	6594	3411	1	0	\N
247378	1678	5040154419000	6597	3413	0	0	\N
247379	1678	5040154420000	6597	3413	1	0	\N
247380	1874	200070000	6597	3413	2	0	\N
247381	1874	200071000	6597	3413	3	0	\N
247382	1678	5040154419000	6598	3413	0	0	\N
247383	1678	5040154420000	6598	3413	1	0	\N
247384	1874	200070000	6598	3413	2	0	\N
247251	1874	200044000	6546	3392	1	0	0
247252	1678	5040154392000	6546	3392	2	0	0
247253	1678	5040154393000	6546	3392	3	0	0
247254	1678	5040154394000	6546	3392	4	0	0
247255	1874	200045000	6546	3392	5	0	0
247257	1874	200046000	6547	3393	1	0	0
247258	1678	5040154396000	6548	3394	0	0	0
247259	1874	200047000	6548	3394	1	0	0
247260	1678	5040154397000	6550	3395	0	0	0
247261	1874	200048000	6550	3395	1	0	0
247267	1874	200049000	6553	3396	1	0	0
247268	1876	4000000000	6553	3396	2	0	0
247274	1874	200050000	6557	3397	0	0	0
247275	1678	5040154399000	6557	3397	1	0	0
247290	1678	5040154401000	6566	3399	0	0	0
247291	1874	200051000	6566	3399	1	0	0
247292	1874	200052000	6567	3400	0	0	0
247293	1678	5040154402000	6567	3400	1	0	0
247294	1678	5040154403000	6568	3401	0	0	0
247300	1678	5040154404000	6571	3402	0	0	0
247301	1874	200054000	6571	3402	1	0	0
247302	1678	5040154405000	6572	3403	0	0	0
247303	1678	5040154406000	6572	3403	1	0	0
247304	1874	200055000	6572	3403	2	0	0
247316	1874	200057000	6576	3404	0	0	0
247317	1678	5040154407000	6576	3404	1	0	0
247318	1874	200058000	6577	3405	0	0	0
247319	1678	5040154408000	6577	3405	1	0	0
247330	1874	200059000	6583	3406	1	0	0
247331	1678	5040154409000	6583	3406	2	0	0
247337	1540	715009000000	6585	3407	0	0	1
247338	1678	5040154410000	6585	3407	1	0	0
247339	1678	5040154411000	6585	3407	2	0	0
247341	1874	200061000	6585	3407	4	0	0
247357	1874	200062000	6589	3408	0	0	0
247358	1874	200063000	6589	3408	1	0	0
247359	1678	5040154412000	6589	3408	2	0	0
247360	1878	0	6589	3408	3	0	0
247362	1874	200065000	6589	3408	5	0	0
247363	1678	5040154413000	6589	3408	6	0	0
247364	1678	5040154414000	6589	3408	7	0	0
247365	1876	350670000000	6589	3408	8	0	3
247367	1678	5040154415000	6590	3409	1	0	0
247368	1874	200067000	6591	3410	0	0	0
247369	1678	5040154416000	6591	3410	1	0	0
247370	1678	5040154417000	6592	3411	0	0	0
247371	1874	200068000	6592	3411	1	0	0
247377	1874	200069000	6595	3412	1	0	0
247385	1874	200071000	6598	3413	3	0	\N
247386	1678	5040154419000	6599	3413	0	0	\N
247387	1678	5040154420000	6599	3413	1	0	\N
247388	1874	200070000	6599	3413	2	0	\N
247389	1874	200071000	6599	3413	3	0	\N
247390	1678	5040154419000	6600	3413	0	0	\N
247391	1678	5040154420000	6600	3413	1	0	\N
247392	1874	200070000	6600	3413	2	0	\N
247393	1874	200071000	6600	3413	3	0	\N
247394	1876	4000000000	6601	3328	0	0	\N
247395	1876	351700000000	6601	3328	1	0	\N
247406	1678	5040154422000	6604	3415	0	0	\N
247407	1678	5040154423000	6604	3415	1	0	\N
247408	1874	200073000	6604	3415	2	0	\N
247409	1874	200074000	6604	3415	3	0	\N
247412	1678	5040154425000	6606	3417	0	0	\N
247413	1678	5040154426000	6606	3417	1	0	\N
247414	1678	5040154427000	6606	3417	2	0	\N
247415	1874	200076000	6606	3417	3	0	\N
247416	1678	5040154428000	6606	3417	4	0	\N
247417	1874	200077000	6606	3417	5	0	\N
247418	1874	200078000	6606	3417	6	0	\N
247419	1874	200079000	6606	3417	7	0	\N
247430	1874	200081000	6609	3419	0	0	\N
247431	1678	5040154430000	6609	3419	1	0	\N
247434	1874	200081000	6611	3419	0	0	\N
247435	1678	5040154430000	6611	3419	1	0	\N
247436	1874	200081000	6612	3419	0	0	\N
247437	1678	5040154430000	6612	3419	1	0	\N
247446	1678	5040154435000	6620	3424	0	0	\N
247447	1874	200086000	6620	3424	1	0	\N
247450	1678	5040154435000	6622	3424	0	0	\N
247451	1874	200086000	6622	3424	1	0	\N
247456	1678	5040154438000	6624	3426	0	0	\N
247457	1678	5040154439000	6624	3426	1	0	\N
247458	1678	5040154440000	6624	3426	2	0	\N
247459	1295	1693980647751650	6624	3426	3	0	\N
247460	1874	200089000	6625	3426	0	0	\N
247461	1874	200090000	6625	3426	1	0	\N
247462	1874	200091000	6625	3426	2	0	\N
247463	1678	5040154438000	6625	3426	3	0	\N
247464	1678	5040154439000	6625	3426	4	0	\N
247465	1678	5040154440000	6625	3426	5	0	\N
247466	1295	1693980647751650	6625	3426	6	0	\N
247478	1874	200092000	6632	3427	0	0	\N
247479	1678	5040154441000	6632	3427	2	0	\N
247480	1678	5040154442000	6632	3427	3	0	\N
247481	1874	200093000	6632	3427	4	0	\N
247482	1678	5040154443000	6633	3428	0	0	\N
247483	1874	200094000	6633	3428	1	0	\N
247484	1678	5040154443000	6634	3428	0	0	\N
247485	1874	200094000	6634	3428	1	0	\N
247490	1874	200095000	6637	3429	0	0	\N
247491	1678	5040154444000	6637	3429	1	0	\N
247516	1678	5040154456000	6645	3436	0	0	\N
247517	1874	200107000	6645	3436	1	0	\N
247518	1678	5040154456000	6646	3436	0	0	\N
247519	1874	200107000	6646	3436	1	0	\N
247398	1678	5040154421000	6602	3414	2	0	0
247399	1874	200070000	6602	3414	3	0	0
247400	1874	200071000	6602	3414	4	0	0
247401	1874	200072000	6602	3414	5	0	0
247402	1678	5040154422000	6603	3415	0	0	0
247404	1874	200073000	6603	3415	2	0	0
247405	1874	200074000	6603	3415	3	0	0
247410	1678	5040154424000	6605	3416	0	0	0
247411	1874	200075000	6605	3416	1	0	0
247420	1678	5040154425000	6607	3417	0	0	0
247422	1678	5040154427000	6607	3417	2	0	0
247423	1874	200076000	6607	3417	3	0	0
247424	1678	5040154428000	6607	3417	4	0	0
247425	1874	200077000	6607	3417	5	0	0
247427	1874	200079000	6607	3417	7	0	0
247428	1874	200080000	6608	3418	0	0	0
247429	1678	5040154429000	6608	3418	1	0	0
247432	1874	200081000	6610	3419	0	0	0
247433	1678	5040154430000	6610	3419	1	0	0
247439	1678	5040154431000	6616	3420	1	0	0
247440	1874	200083000	6617	3421	0	0	0
247441	1678	5040154432000	6617	3421	1	0	0
247442	1678	5040154433000	6618	3422	0	0	0
247443	1874	200084000	6618	3422	1	0	0
247445	1874	200085000	6619	3423	1	0	0
247448	1678	5040154435000	6621	3424	0	0	0
247449	1874	200086000	6621	3424	1	0	0
247452	1678	5040154436000	6623	3425	0	0	0
247454	1874	200087000	6623	3425	2	0	0
247455	1874	200088000	6623	3425	3	0	0
247467	1874	200089000	6626	3426	0	0	0
247468	1874	200090000	6626	3426	1	0	0
247469	1874	200091000	6626	3426	2	0	0
247471	1678	5040154439000	6626	3426	4	0	0
247472	1678	5040154440000	6626	3426	5	0	0
247473	1295	1693980647751650	6626	3426	6	0	0
247474	1874	200092000	6631	3427	0	0	0
247475	1678	5040154441000	6631	3427	2	0	0
247477	1874	200093000	6631	3427	4	0	0
247486	1678	5040154443000	6635	3428	0	0	0
247487	1874	200094000	6635	3428	1	0	0
247488	1874	200095000	6636	3429	0	0	0
247492	1874	200096000	6638	3430	0	0	0
247493	1678	5040154445000	6638	3430	1	0	0
247494	1678	5040154446000	6638	3430	2	0	0
247495	1678	5040154447000	6638	3430	3	0	0
247496	1874	200097000	6638	3430	4	0	0
247498	1678	5040154448000	6639	3431	0	0	0
247499	1678	5040154449000	6639	3431	1	0	0
247500	1874	200099000	6639	3431	2	0	0
247501	1874	200100000	6639	3431	3	0	0
247502	1874	200101000	6640	3432	0	0	0
247504	1874	200102000	6641	3433	0	0	0
247505	1874	200103000	6641	3433	1	0	0
247506	1678	5040154451000	6641	3433	2	0	0
247507	1678	5040154452000	6641	3433	3	0	0
247509	1678	5040154454000	6642	3434	1	0	0
247510	1874	200104000	6642	3434	2	0	0
247511	1874	200105000	6642	3434	3	0	0
247512	1874	200106000	6643	3435	0	0	0
247513	1678	5040154455000	6643	3435	1	0	0
247515	1874	200107000	6644	3436	1	0	0
247520	1874	200108000	6647	3437	0	0	0
247522	1874	200108000	6648	3437	0	0	\N
247523	1678	5040154457000	6648	3437	1	0	\N
247528	1678	5040154460000	6650	3439	0	0	\N
247529	1874	200111000	6650	3439	1	0	\N
247534	1678	5040154461000	6653	3440	0	0	\N
247535	1874	200112000	6653	3440	1	0	\N
247542	1678	5040154465000	6655	3442	0	0	\N
247543	1874	200116000	6655	3442	1	0	\N
247544	1678	5040154465000	6656	3442	0	0	\N
247545	1874	200116000	6656	3442	1	0	\N
247546	1678	5040154465000	6657	3442	0	0	\N
247547	1874	200116000	6657	3442	1	0	\N
247550	1874	200117000	6659	3443	0	0	\N
247551	1678	5040154466000	6659	3443	1	0	\N
247553	1874	200117000	6661	3443	0	0	\N
247554	1678	5040154466000	6661	3443	1	0	\N
247555	1874	200118000	6662	3444	0	0	\N
247556	1678	5040154466000	6662	3444	1	0	\N
247557	1678	5040154467000	6662	3444	2	0	\N
247561	1874	200117000	6664	3443	0	0	\N
247562	1874	200118000	6664	3443	1	0	\N
247563	1678	5040154466000	6664	3443	2	0	\N
247564	1678	5040154467000	6664	3443	3	0	\N
247565	1874	200119000	6665	3445	0	0	\N
247566	1678	5040154468000	6665	3445	1	0	\N
247567	1874	200119000	6666	3445	0	0	\N
247568	1678	5040154468000	6666	3445	1	0	\N
247573	1678	5040154470000	6669	3447	0	0	\N
247574	1678	5040154471000	6669	3447	1	0	\N
247575	1874	200121000	6669	3447	2	0	\N
247576	1874	200122000	6669	3447	3	0	\N
247581	1678	5040154470000	6671	3447	0	0	\N
247582	1678	5040154471000	6671	3447	1	0	\N
247583	1874	200121000	6671	3447	2	0	\N
247584	1874	200122000	6671	3447	3	0	\N
247589	1295	1693980647751650	6674	3310	5	0	\N
247590	1295	1693980647751650	6675	3367	0	0	\N
247599	1726	881649872000	6679	3453	0	0	\N
247600	1874	200129000	6679	3453	1	0	\N
247601	1874	200130000	6679	3453	3	0	\N
247602	1678	5040154478000	6679	3453	4	0	\N
247603	1678	5040154479000	6679	3453	5	0	\N
247609	1726	881649872000	6681	3453	0	0	\N
247610	1874	200129000	6681	3453	1	0	\N
247611	1874	200130000	6681	3453	3	0	\N
247612	1678	5040154478000	6681	3453	4	0	\N
247613	1678	5040154479000	6681	3453	5	0	\N
247617	1678	5040154481000	6683	3455	0	0	\N
247618	1678	5040154482000	6683	3455	1	0	\N
247619	1874	200132000	6683	3455	2	0	\N
247620	1874	200133000	6683	3455	3	0	\N
247621	1678	5040154481000	6684	3455	0	0	\N
247622	1678	5040154482000	6684	3455	1	0	\N
247623	1874	200132000	6684	3455	2	0	\N
247624	1874	200133000	6684	3455	3	0	\N
247629	1726	882819989000	6686	3368	0	0	\N
247630	1726	882829989000	6686	3368	1	0	\N
247631	1726	882830989000	6686	3368	2	0	\N
247632	1726	882831989000	6686	3368	3	0	\N
247633	1726	882832989000	6686	3368	4	0	\N
247634	1726	882833989000	6686	3368	5	0	\N
247635	1726	882834989000	6686	3368	6	0	\N
247651	1726	886930000000	6689	3283	0	0	\N
247652	1726	886940000000	6689	3283	1	0	\N
247653	1295	1693980647751650	6689	3283	17	0	\N
247654	1874	200000000	6689	3283	33	0	\N
247655	1875	200000000	6689	3283	34	0	\N
247656	1874	200001000	6689	3283	35	0	\N
247525	1874	200110000	6649	3438	1	0	0
247526	1678	5040154458000	6649	3438	2	0	0
247527	1678	5040154459000	6649	3438	3	0	0
247530	1678	5040154460000	6651	3439	0	0	0
247531	1874	200111000	6651	3439	1	0	0
247533	1874	200112000	6652	3440	1	0	0
247536	1678	5040154462000	6654	3441	0	0	0
247537	1678	5040154463000	6654	3441	1	0	0
247538	1678	5040154464000	6654	3441	2	0	0
247539	1874	200113000	6654	3441	3	0	0
247541	1874	200115000	6654	3441	5	0	0
247548	1678	5040154465000	6658	3442	0	0	0
247549	1874	200116000	6658	3442	1	0	0
247552	1874	200117000	6660	3443	0	0	0
247559	1678	5040154466000	6663	3444	1	0	0
247560	1678	5040154467000	6663	3444	2	0	0
247569	1874	200119000	6667	3445	0	0	0
247570	1678	5040154468000	6667	3445	1	0	0
247571	1874	200120000	6668	3446	0	0	0
247577	1678	5040154470000	6670	3447	0	0	0
247578	1678	5040154471000	6670	3447	1	0	0
247579	1874	200121000	6670	3447	2	0	0
247580	1874	200122000	6670	3447	3	0	0
247585	1874	200123000	6672	3448	0	0	0
247587	1874	200124000	6673	3449	0	0	0
247588	1678	5040154473000	6673	3449	1	0	0
247591	1874	200125000	6676	3450	0	0	0
247592	1874	200126000	6676	3450	1	0	0
247594	1678	5040154475000	6676	3450	3	0	0
247595	1678	5040154476000	6677	3451	0	0	0
247596	1874	200127000	6677	3451	1	0	0
247597	1678	5040154477000	6678	3452	0	0	0
247598	1874	200128000	6678	3452	1	0	0
247605	1874	200129000	6680	3453	1	0	0
247606	1874	200130000	6680	3453	3	0	0
247607	1678	5040154478000	6680	3453	4	0	0
247608	1678	5040154479000	6680	3453	5	0	0
247614	1678	5040154480000	6682	3454	0	0	0
247616	1874	200131000	6682	3454	2	0	0
247625	1678	5040154481000	6685	3455	0	0	0
247626	1678	5040154482000	6685	3455	1	0	0
247627	1874	200132000	6685	3455	2	0	0
247636	1874	200134000	6687	3456	0	0	0
247637	1874	200135000	6687	3456	1	0	0
247638	1874	200136000	6687	3456	2	0	0
247639	1678	5040154483000	6687	3456	3	0	0
247640	1678	5040154484000	6687	3456	4	0	0
247642	1726	881580864000	6687	3456	6	0	263
247643	1726	881581864000	6687	3456	7	0	263
247644	1726	881582864000	6687	3456	8	0	263
247645	1726	881583864000	6687	3456	9	0	263
247646	1726	881584864000	6687	3456	10	0	263
247648	1874	200138000	6688	3457	1	0	0
247649	1678	5040154486000	6688	3457	2	0	0
247650	1678	5040154487000	6688	3457	3	0	0
247657	1874	200002000	6689	3283	36	0	\N
247658	1874	200003000	6689	3283	37	0	\N
247659	1874	200004000	6689	3283	38	0	\N
247660	1874	200005000	6689	3283	39	0	\N
247661	1874	200006000	6689	3283	40	0	\N
247662	1874	200007000	6689	3283	41	0	\N
247663	1874	200008000	6689	3283	42	0	\N
247664	1874	200009000	6689	3283	43	0	\N
247665	1874	200010000	6689	3283	44	0	\N
247666	1874	200011000	6689	3283	45	0	\N
247667	1874	200012000	6689	3283	46	0	\N
247668	1874	200013000	6689	3283	47	0	\N
247669	1874	200014000	6689	3283	48	0	\N
247670	1874	200015000	6689	3283	49	0	\N
247671	1874	200016000	6689	3283	50	0	\N
247672	1874	200017000	6689	3283	51	0	\N
247673	1874	200018000	6689	3283	52	0	\N
247674	1874	200019000	6689	3283	53	0	\N
247675	1874	200020000	6689	3283	54	0	\N
247676	1874	200021000	6689	3283	55	0	\N
247677	1874	200022000	6689	3283	56	0	\N
247678	1874	200023000	6689	3283	57	0	\N
247679	1874	200024000	6689	3283	58	0	\N
247680	1874	200025000	6689	3283	59	0	\N
247681	1874	200026000	6689	3283	60	0	\N
247682	1874	200027000	6689	3283	61	0	\N
247683	1874	200028000	6689	3283	62	0	\N
247684	1874	200029000	6689	3283	63	0	\N
247685	1874	200030000	6689	3283	64	0	\N
247686	1874	200031000	6689	3283	65	0	\N
247687	1874	200032000	6689	3283	66	0	\N
247688	1874	200033000	6689	3283	67	0	\N
247689	1874	200034000	6689	3283	68	0	\N
247690	1874	200035000	6689	3283	69	0	\N
247691	1874	200036000	6689	3283	70	0	\N
247692	1874	200037000	6689	3283	71	0	\N
247693	1874	200038000	6689	3283	72	0	\N
247694	1874	200039000	6689	3283	73	0	\N
247695	1874	200040000	6689	3283	74	0	\N
247696	1874	200041000	6689	3283	75	0	\N
247697	1874	200042000	6689	3283	76	0	\N
247698	1874	200043000	6689	3283	77	0	\N
247699	1874	200044000	6689	3283	78	0	\N
247700	1874	200045000	6689	3283	79	0	\N
247701	1874	200046000	6689	3283	80	0	\N
247702	1874	200047000	6689	3283	81	0	\N
247703	1874	200048000	6689	3283	82	0	\N
247704	1874	200049000	6689	3283	83	0	\N
247705	1874	200050000	6689	3283	84	0	\N
247706	1874	200051000	6689	3283	85	0	\N
247707	1874	200052000	6689	3283	86	0	\N
247708	1874	200053000	6689	3283	87	0	\N
247709	1874	200054000	6689	3283	88	0	\N
247710	1874	200055000	6689	3283	89	0	\N
247711	1874	200056000	6689	3283	90	0	\N
247712	1874	200057000	6689	3283	91	0	\N
247713	1874	200058000	6689	3283	92	0	\N
247714	1874	200059000	6689	3283	93	0	\N
247715	1874	200060000	6689	3283	94	0	\N
247716	1874	200061000	6689	3283	95	0	\N
247717	1874	200062000	6689	3283	96	0	\N
247718	1874	200063000	6689	3283	97	0	\N
247719	1874	200064000	6689	3283	98	0	\N
247720	1874	200065000	6689	3283	99	0	\N
247721	1874	200066000	6689	3283	100	0	\N
247722	1874	200067000	6689	3283	101	0	\N
247723	1874	200068000	6689	3283	102	0	\N
247724	1874	200069000	6689	3283	103	0	\N
247725	1874	200070000	6689	3283	105	0	\N
247726	1874	200071000	6689	3283	106	0	\N
247727	1874	200072000	6689	3283	107	0	\N
247728	1874	200073000	6689	3283	108	0	\N
247729	1874	200074000	6689	3283	109	0	\N
247730	1874	200075000	6689	3283	110	0	\N
247731	1874	200076000	6689	3283	111	0	\N
247732	1874	200077000	6689	3283	112	0	\N
247733	1874	200078000	6689	3283	113	0	\N
247734	1874	200079000	6689	3283	114	0	\N
247735	1874	200080000	6689	3283	115	0	\N
247736	1874	200081000	6689	3283	116	0	\N
247737	1874	200082000	6689	3283	117	0	\N
247738	1874	200083000	6689	3283	118	0	\N
247739	1874	200084000	6689	3283	119	0	\N
247740	1874	200085000	6689	3283	120	0	\N
247741	1874	200086000	6689	3283	121	0	\N
247742	1874	200087000	6689	3283	122	0	\N
247743	1874	200088000	6689	3283	123	0	\N
247744	1874	200089000	6689	3283	124	0	\N
247745	1874	200081000	6690	3419	0	0	\N
247746	1874	200082000	6690	3419	1	0	\N
247747	1874	200083000	6690	3419	2	0	\N
247748	1726	882099917000	6690	3419	3	0	\N
247749	1726	882109917000	6690	3419	4	0	\N
247750	1678	5040154430000	6690	3419	5	0	\N
247751	1678	5040154431000	6690	3419	6	0	\N
247752	1678	5040154432000	6690	3419	7	0	\N
247753	1678	5040154433000	6690	3419	8	0	\N
247754	1678	5040154434000	6690	3419	9	0	\N
247755	1678	5040154435000	6690	3419	10	0	\N
247756	1678	5040154436000	6690	3419	11	0	\N
247757	1678	5040154437000	6690	3419	12	0	\N
247758	1678	5040154438000	6690	3419	13	0	\N
247759	1874	200084000	6690	3419	14	0	\N
247760	1874	200085000	6690	3419	15	0	\N
247761	1874	200086000	6690	3419	16	0	\N
247762	1874	200087000	6690	3419	17	0	\N
247763	1874	200088000	6690	3419	18	0	\N
247764	1874	200089000	6690	3419	19	0	\N
247765	1874	200090000	6690	3419	20	0	\N
247766	1874	200091000	6690	3419	21	0	\N
247767	1874	200092000	6690	3419	22	0	\N
247768	1874	200093000	6690	3419	23	0	\N
247769	1874	200094000	6690	3419	24	0	\N
247770	1874	200095000	6690	3419	25	0	\N
247771	1874	200096000	6690	3419	26	0	\N
247772	1874	200097000	6690	3419	27	0	\N
247773	1874	200098000	6690	3419	28	0	\N
247774	1874	200099000	6690	3419	29	0	\N
247775	1874	200100000	6690	3419	30	0	\N
247776	1874	200101000	6690	3419	31	0	\N
247777	1874	200102000	6690	3419	32	0	\N
247778	1874	200103000	6690	3419	33	0	\N
247779	1678	5040154439000	6690	3419	34	0	\N
247780	1678	5040154440000	6690	3419	35	0	\N
247781	1678	5040154441000	6690	3419	36	0	\N
247782	1678	5040154442000	6690	3419	37	0	\N
247783	1678	5040154443000	6690	3419	38	0	\N
247784	1678	5040154444000	6690	3419	39	0	\N
247785	1678	5040154445000	6690	3419	41	0	\N
247786	1678	5040154446000	6690	3419	42	0	\N
247787	1678	5040154447000	6690	3419	43	0	\N
247788	1678	5040154448000	6690	3419	44	0	\N
247789	1678	5040154449000	6690	3419	45	0	\N
247790	1678	5040154450000	6690	3419	46	0	\N
247791	1678	5040154451000	6690	3419	47	0	\N
247792	1678	5040154452000	6690	3419	48	0	\N
247793	1678	5040154453000	6690	3419	49	0	\N
247794	1678	5040154454000	6690	3419	50	0	\N
247795	1295	1693980647751650	6690	3419	51	0	\N
247796	1678	5040154455000	6690	3419	52	0	\N
247797	1678	5040154456000	6690	3419	53	0	\N
247798	1678	5040154457000	6690	3419	54	0	\N
247799	1678	5040154458000	6690	3419	55	0	\N
247800	1678	5040154459000	6690	3419	56	0	\N
247801	1678	5040154460000	6690	3419	57	0	\N
247802	1678	5040154461000	6690	3419	58	0	\N
247803	1678	5040154462000	6690	3419	59	0	\N
247804	1678	5040154463000	6690	3419	60	0	\N
247805	1678	5040154464000	6690	3419	61	0	\N
247806	1678	5040154465000	6690	3419	62	0	\N
247807	1678	5040154466000	6690	3419	63	0	\N
247808	1678	5040154467000	6690	3419	64	0	\N
247809	1874	200104000	6690	3419	65	0	\N
247810	1874	200105000	6690	3419	66	0	\N
247811	1874	200106000	6690	3419	67	0	\N
247812	1874	200107000	6690	3419	68	0	\N
247813	1874	200108000	6690	3419	69	0	\N
247814	1874	200109000	6690	3419	70	0	\N
247815	1874	200110000	6690	3419	71	0	\N
247816	1874	200111000	6690	3419	72	0	\N
247817	1874	200112000	6690	3419	73	0	\N
247818	1874	200113000	6690	3419	74	0	\N
247819	1874	200114000	6690	3419	75	0	\N
247820	1874	200115000	6690	3419	76	0	\N
247821	1874	200116000	6690	3419	77	0	\N
247822	1874	200117000	6690	3419	78	0	\N
247823	1874	200118000	6690	3419	79	0	\N
247824	1874	200119000	6690	3419	80	0	\N
247825	1874	200120000	6690	3419	81	0	\N
247826	1874	200121000	6690	3419	82	0	\N
247827	1874	200122000	6690	3419	83	0	\N
247828	1874	200123000	6690	3419	84	0	\N
247829	1874	200124000	6690	3419	85	0	\N
247830	1874	200125000	6690	3419	86	0	\N
247831	1874	200126000	6690	3419	87	0	\N
247832	1874	200127000	6690	3419	88	0	\N
247833	1874	200128000	6690	3419	89	0	\N
247834	1874	200129000	6690	3419	90	0	\N
247835	1874	200130000	6690	3419	91	0	\N
247836	1874	200131000	6690	3419	92	0	\N
247837	1874	200132000	6690	3419	93	0	\N
247838	1874	200133000	6690	3419	94	0	\N
247839	1874	200134000	6690	3419	95	0	\N
247840	1874	200135000	6690	3419	96	0	\N
247841	1874	200136000	6690	3419	97	0	\N
247842	1874	200137000	6690	3419	98	0	\N
247843	1874	200138000	6690	3419	99	0	\N
247844	1874	200139000	6690	3419	100	0	\N
247845	1678	5040154468000	6690	3419	101	0	\N
247846	1678	5040154469000	6690	3419	102	0	\N
247847	1678	5040154470000	6690	3419	103	0	\N
247848	1678	5040154471000	6690	3419	104	0	\N
247849	1678	5040154472000	6690	3419	105	0	\N
247850	1678	5040154473000	6690	3419	106	0	\N
247851	1678	5040154474000	6690	3419	107	0	\N
247852	1678	5040154475000	6690	3419	108	0	\N
247853	1678	5040154476000	6690	3419	109	0	\N
247854	1678	5040154477000	6690	3419	110	0	\N
247855	1678	5040154478000	6690	3419	111	0	\N
247856	1678	5040154479000	6690	3419	112	0	\N
247857	1678	5040154480000	6690	3419	113	0	\N
247858	1678	5040154481000	6690	3419	114	0	\N
247859	1678	5040154482000	6690	3419	115	0	\N
247860	1678	5040154483000	6690	3419	116	0	\N
247861	1678	5040154484000	6690	3419	117	0	\N
247862	1678	5040154485000	6690	3419	118	0	\N
247863	1678	5040154486000	6690	3419	119	0	\N
247864	1678	5040154487000	6690	3419	120	0	\N
247865	1678	5040154488000	6690	3419	121	0	\N
247866	1726	881550861000	6690	3419	122	0	\N
247867	1726	881551861000	6690	3419	123	0	\N
247868	1726	881552861000	6690	3419	124	0	\N
247869	1726	881553861000	6690	3419	125	0	\N
247870	1874	200139000	6691	3458	0	0	\N
247871	1874	200140000	6691	3458	1	0	\N
247872	1678	5040154488000	6691	3458	2	0	\N
247873	1678	5040154489000	6691	3458	3	0	\N
247886	1874	200145000	6695	3461	0	0	\N
247887	1874	200146000	6695	3461	1	0	\N
247888	1678	5040154494000	6695	3461	2	0	\N
247889	1678	5040154495000	6695	3461	3	0	\N
247898	1874	200147000	6698	3462	0	0	\N
247899	1874	200148000	6698	3462	1	0	\N
247900	1678	5040154496000	6698	3462	2	0	\N
247901	1678	5040154497000	6698	3462	3	0	\N
247904	1874	200150000	6700	3464	0	0	\N
247905	1678	5040154499000	6700	3464	1	0	\N
247908	1540	715009000000	6702	3402	0	0	\N
247909	1726	882399947000	6702	3402	1	0	\N
247910	1726	882409947000	6702	3402	3	0	\N
247911	1540	715009000000	6702	3402	4	0	\N
247912	1878	0	6702	3402	5	0	\N
247913	1678	5040154404000	6702	3402	6	0	\N
247914	1678	5040154405000	6702	3402	7	0	\N
247915	1678	5040154406000	6702	3402	8	0	\N
247916	1678	5040154407000	6702	3402	9	0	\N
247917	1678	5040154408000	6702	3402	10	0	\N
247918	1678	5040154409000	6702	3402	11	0	\N
247919	1874	200054000	6702	3402	12	0	\N
247920	1874	200055000	6702	3402	13	0	\N
247921	1678	5040154410000	6702	3402	14	0	\N
247922	1678	5040154411000	6702	3402	15	0	\N
247923	1678	5040154412000	6702	3402	16	0	\N
247924	1678	5040154413000	6702	3402	17	0	\N
247925	1678	5040154414000	6702	3402	18	0	\N
247926	1295	1693980647751650	6702	3402	19	0	\N
247927	1678	5040154415000	6702	3402	20	0	\N
247928	1678	5040154416000	6702	3402	21	0	\N
247876	1678	5040154488000	6692	3458	2	0	0
247877	1678	5040154489000	6692	3458	3	0	0
247878	1678	5040154490000	6693	3459	0	0	0
247879	1874	200141000	6693	3459	1	0	0
247880	1678	5040154491000	6694	3460	0	0	0
247882	1678	5040154493000	6694	3460	2	0	0
247883	1874	200142000	6694	3460	3	0	0
247884	1874	200143000	6694	3460	4	0	0
247885	1874	200144000	6694	3460	5	0	0
247890	1874	200145000	6696	3461	0	0	0
247892	1678	5040154494000	6696	3461	2	0	0
247893	1678	5040154495000	6696	3461	3	0	0
247894	1874	200147000	6697	3462	0	0	0
247895	1874	200148000	6697	3462	1	0	0
247897	1678	5040154497000	6697	3462	3	0	0
247902	1678	5040154498000	6699	3463	0	0	0
247903	1874	200149000	6699	3463	1	0	0
247906	1874	200150000	6701	3464	0	0	0
247907	1678	5040154499000	6701	3464	1	0	0
247929	1678	5040154417000	6702	3402	22	0	\N
247930	1678	5040154418000	6702	3402	23	0	\N
247931	1678	5040154419000	6702	3402	24	0	\N
247932	1678	5040154420000	6702	3402	25	0	\N
247933	1678	5040154421000	6702	3402	26	0	\N
247934	1678	5040154422000	6702	3402	27	0	\N
247935	1678	5040154423000	6702	3402	28	0	\N
247936	1678	5040154424000	6702	3402	29	0	\N
247937	1678	5040154425000	6702	3402	30	0	\N
247938	1678	5040154426000	6702	3402	31	0	\N
247939	1678	5040154427000	6702	3402	32	0	\N
247940	1678	5040154428000	6702	3402	33	0	\N
247941	1678	5040154429000	6702	3402	34	0	\N
247942	1678	5040154430000	6702	3402	35	0	\N
247943	1678	5040154431000	6702	3402	36	0	\N
247944	1678	5040154432000	6702	3402	37	0	\N
247945	1678	5040154433000	6702	3402	38	0	\N
247946	1678	5040154434000	6702	3402	39	0	\N
247947	1678	5040154435000	6702	3402	40	0	\N
247948	1678	5040154436000	6702	3402	41	0	\N
247949	1678	5040154437000	6702	3402	42	0	\N
247950	1678	5040154438000	6702	3402	43	0	\N
247951	1678	5040154439000	6702	3402	44	0	\N
247952	1678	5040154440000	6702	3402	45	0	\N
247953	1678	5040154441000	6702	3402	46	0	\N
247954	1678	5040154442000	6702	3402	47	0	\N
247955	1678	5040154443000	6702	3402	48	0	\N
247956	1678	5040154444000	6702	3402	49	0	\N
247957	1678	5040154445000	6702	3402	50	0	\N
247958	1678	5040154446000	6702	3402	51	0	\N
247959	1678	5040154447000	6702	3402	52	0	\N
247960	1678	5040154448000	6702	3402	53	0	\N
247961	1678	5040154449000	6702	3402	54	0	\N
247962	1678	5040154450000	6702	3402	55	0	\N
247963	1678	5040154451000	6702	3402	56	0	\N
247964	1678	5040154452000	6702	3402	57	0	\N
247965	1678	5040154453000	6702	3402	58	0	\N
247966	1678	5040154454000	6702	3402	59	0	\N
247967	1678	5040154455000	6702	3402	60	0	\N
247968	1678	5040154456000	6702	3402	61	0	\N
247969	1678	5040154457000	6702	3402	62	0	\N
247970	1678	5040154458000	6702	3402	63	0	\N
247971	1678	5040154459000	6702	3402	64	0	\N
247972	1678	5040154460000	6702	3402	65	0	\N
247973	1678	5040154461000	6702	3402	66	0	\N
247974	1678	5040154462000	6702	3402	67	0	\N
247975	1678	5040154463000	6702	3402	68	0	\N
247976	1678	5040154464000	6702	3402	69	0	\N
247977	1678	5040154465000	6702	3402	70	0	\N
247978	1678	5040154466000	6702	3402	71	0	\N
247979	1678	5040154467000	6702	3402	72	0	\N
247980	1874	200056000	6702	3402	73	0	\N
247981	1874	200057000	6702	3402	74	0	\N
247982	1874	200058000	6702	3402	75	0	\N
247983	1874	200059000	6702	3402	76	0	\N
247984	1874	200060000	6702	3402	77	0	\N
247985	1874	200061000	6702	3402	78	0	\N
247986	1874	200062000	6702	3402	79	0	\N
247987	1874	200063000	6702	3402	80	0	\N
247988	1874	200064000	6702	3402	81	0	\N
247989	1874	200065000	6702	3402	82	0	\N
247990	1874	200066000	6702	3402	83	0	\N
247991	1874	200067000	6702	3402	84	0	\N
247992	1874	200068000	6702	3402	85	0	\N
247993	1874	200069000	6702	3402	86	0	\N
247994	1874	200070000	6702	3402	87	0	\N
247995	1874	200071000	6702	3402	88	0	\N
247996	1874	200072000	6702	3402	89	0	\N
247997	1874	200073000	6702	3402	90	0	\N
247998	1874	200074000	6702	3402	91	0	\N
247999	1874	200075000	6702	3402	92	0	\N
248000	1874	200076000	6702	3402	93	0	\N
248001	1874	200077000	6702	3402	94	0	\N
248002	1874	200078000	6702	3402	95	0	\N
248003	1874	200079000	6702	3402	96	0	\N
248004	1874	200080000	6702	3402	97	0	\N
248005	1874	200081000	6702	3402	98	0	\N
248006	1874	200082000	6702	3402	99	0	\N
248007	1874	200083000	6702	3402	100	0	\N
248008	1874	200084000	6702	3402	101	0	\N
248009	1874	200085000	6702	3402	102	0	\N
248010	1874	200086000	6702	3402	103	0	\N
248011	1874	200087000	6702	3402	104	0	\N
248012	1874	200088000	6702	3402	105	0	\N
248013	1874	200089000	6702	3402	106	0	\N
248014	1874	200090000	6702	3402	107	0	\N
248015	1874	200091000	6702	3402	108	0	\N
248016	1874	200092000	6702	3402	109	0	\N
248017	1874	200093000	6702	3402	110	0	\N
248018	1874	200094000	6702	3402	111	0	\N
248019	1874	200095000	6702	3402	112	0	\N
248020	1874	200096000	6702	3402	113	0	\N
248021	1874	200097000	6702	3402	114	0	\N
248022	1874	200098000	6702	3402	115	0	\N
248023	1874	200099000	6702	3402	116	0	\N
248024	1874	200100000	6702	3402	117	0	\N
248025	1874	200101000	6702	3402	118	0	\N
248026	1874	200102000	6702	3402	119	0	\N
248027	1874	200103000	6702	3402	120	0	\N
248028	1874	200104000	6702	3402	121	0	\N
248029	1874	200105000	6702	3402	122	0	\N
248030	1874	200106000	6702	3402	123	0	\N
248031	1874	200107000	6702	3402	124	0	\N
248032	1874	200108000	6702	3402	125	0	\N
248057	1874	200162000	6711	3471	0	0	\N
248058	1678	5040154511000	6711	3471	1	0	\N
248059	1874	200162000	6712	3471	0	0	\N
248060	1678	5040154511000	6712	3471	1	0	\N
248035	1678	5040154500000	6703	3465	2	0	0
248036	1678	5040154501000	6703	3465	3	0	0
248037	1874	200153000	6704	3466	0	0	0
248038	1874	200154000	6704	3466	1	0	0
248039	1874	200155000	6704	3466	2	0	0
248041	1678	5040154503000	6704	3466	4	0	0
248042	1678	5040154504000	6704	3466	5	0	0
248043	1874	200156000	6705	3467	0	0	0
248044	1678	5040154505000	6705	3467	1	0	0
248045	1678	5040154506000	6707	3468	0	0	0
248047	1678	5040154508000	6707	3468	2	0	0
248048	1874	200157000	6707	3468	3	0	0
248049	1874	200158000	6707	3468	4	0	0
248050	1874	200159000	6707	3468	5	0	0
248052	1678	5040154509000	6708	3469	1	0	0
248053	1678	5040154510000	6709	3470	0	0	0
248054	1874	200161000	6709	3470	1	0	0
248055	1874	200162000	6710	3471	0	0	0
248056	1678	5040154511000	6710	3471	1	0	0
248062	1678	5040154512000	6713	3472	1	0	0
248063	1874	200164000	6714	3473	0	0	0
248064	1678	5040154513000	6714	3473	1	0	0
248065	1874	200164000	6715	3473	0	0	\N
248066	1678	5040154513000	6715	3473	1	0	\N
248081	1540	715009000000	6720	3390	0	0	\N
248082	1726	882549962000	6720	3390	1	0	\N
248083	1726	882559962000	6720	3390	2	0	\N
248084	1540	715009000000	6720	3390	3	0	\N
248085	1878	0	6720	3390	4	0	\N
248086	1295	1693980647751650	6720	3390	5	0	\N
248087	1726	882560962000	6720	3390	6	0	\N
248088	1726	882561962000	6720	3390	7	0	\N
248089	1876	350670000000	6720	3390	8	0	\N
248090	1726	882562962000	6720	3390	9	0	\N
248091	1726	882563962000	6720	3390	10	0	\N
248092	1726	882564962000	6720	3390	11	0	\N
248097	1678	5040154521000	6722	3478	0	0	\N
248098	1874	200172000	6722	3478	1	0	\N
248099	1874	200173000	6722	3478	2	0	\N
248100	1678	5040154522000	6722	3478	3	0	\N
248101	1874	200174000	6723	3479	0	0	\N
248102	1678	5040154523000	6723	3479	1	0	\N
248105	1874	200174000	6725	3479	0	0	\N
248106	1678	5040154523000	6725	3479	1	0	\N
248113	1874	200178000	6730	3483	0	0	\N
248114	1678	5040154527000	6730	3483	1	0	\N
248117	1874	200179000	6732	3484	0	0	\N
248118	1874	200180000	6732	3484	1	0	\N
248119	1678	5040154528000	6732	3484	2	0	\N
248120	1678	5040154529000	6732	3484	3	0	\N
248127	1678	5040154530000	6735	3485	0	0	\N
248128	1874	200181000	6735	3485	1	0	\N
248129	1678	5040154531000	6736	3486	0	0	\N
248130	1874	200182000	6736	3486	1	0	\N
248131	1678	5040154531000	6737	3486	0	0	\N
248132	1874	200182000	6737	3486	1	0	\N
248135	1874	200183000	6739	3487	0	0	\N
248136	1678	5040154532000	6739	3487	1	0	\N
248141	1678	5040154534000	6742	3489	0	0	\N
248142	1874	200185000	6742	3489	1	0	\N
248145	1678	5040154534000	6744	3489	0	0	\N
248146	1874	200185000	6744	3489	1	0	\N
248157	1678	5040154538000	6749	3493	0	0	\N
248158	1874	200189000	6749	3493	1	0	\N
248159	1874	200190000	6749	3493	2	0	\N
248160	1678	5040154539000	6749	3493	3	0	\N
248165	1874	200192000	6752	3495	0	0	\N
248166	1678	5040154541000	6752	3495	1	0	\N
248169	1874	200193000	6754	3496	0	0	\N
248170	1678	5040154542000	6754	3496	1	0	\N
248171	1678	5040154543000	6755	3497	0	0	\N
248172	1874	200194000	6755	3497	1	0	\N
248177	1874	200195000	6758	3498	0	0	\N
248178	1678	5040154544000	6758	3498	1	0	\N
248187	1874	200196000	6760	3499	0	0	\N
248188	1678	5040154545000	6760	3499	1	0	\N
248189	1874	200197000	6760	3499	2	0	\N
248190	1874	200198000	6760	3499	3	0	\N
248191	1874	200199000	6760	3499	4	0	\N
248192	1678	5040154546000	6760	3499	5	0	\N
248193	1678	5040154547000	6760	3499	6	0	\N
248194	1678	5040154548000	6760	3499	7	0	\N
248195	1874	200196000	6761	3499	0	0	\N
248196	1678	5040154545000	6761	3499	1	0	\N
248197	1874	200197000	6761	3499	2	0	\N
248198	1874	200198000	6761	3499	3	0	\N
248199	1874	200199000	6761	3499	4	0	\N
248200	1678	5040154546000	6761	3499	5	0	\N
248069	1678	5040154515000	6716	3474	2	0	0
248070	1874	200166000	6716	3474	3	0	0
248071	1678	5040154516000	6717	3475	0	0	0
248072	1874	200167000	6717	3475	1	0	0
248073	1874	200168000	6718	3476	0	0	0
248075	1678	5040154518000	6718	3476	2	0	0
248076	1874	200169000	6718	3476	3	0	0
248077	1678	5040154519000	6719	3477	0	0	0
248078	1678	5040154520000	6719	3477	1	0	0
248079	1874	200170000	6719	3477	2	0	0
248093	1678	5040154521000	6721	3478	0	0	0
248094	1874	200172000	6721	3478	1	0	0
248095	1874	200173000	6721	3478	2	0	0
248096	1678	5040154522000	6721	3478	3	0	0
248104	1678	5040154523000	6724	3479	1	0	0
248107	1874	200175000	6726	3480	0	0	0
248108	1678	5040154524000	6726	3480	1	0	0
248109	1678	5040154525000	6727	3481	0	0	0
248110	1874	200176000	6727	3481	1	0	0
248112	1678	5040154526000	6729	3482	1	0	0
248115	1874	200178000	6731	3483	0	0	0
248116	1678	5040154527000	6731	3483	1	0	0
248121	1874	200179000	6733	3484	0	0	0
248122	1874	200180000	6733	3484	1	0	0
248124	1678	5040154529000	6733	3484	3	0	0
248125	1678	5040154530000	6734	3485	0	0	0
248126	1874	200181000	6734	3485	1	0	0
248133	1678	5040154531000	6738	3486	0	0	0
248137	1874	200183000	6740	3487	0	0	0
248138	1678	5040154532000	6740	3487	1	0	0
248139	1874	200184000	6741	3488	0	0	0
248140	1678	5040154533000	6741	3488	1	0	0
248143	1678	5040154534000	6743	3489	0	0	0
248147	1874	200186000	6745	3490	0	0	0
248148	1678	5040154535000	6745	3490	1	0	0
248149	1678	5040154536000	6746	3491	0	0	0
248150	1874	200187000	6746	3491	1	0	0
248151	1874	200188000	6747	3492	0	0	0
248153	1678	5040154538000	6748	3493	0	0	0
248154	1874	200189000	6748	3493	1	0	0
248155	1874	200190000	6748	3493	2	0	0
248156	1678	5040154539000	6748	3493	3	0	0
248162	1874	200191000	6750	3494	1	0	0
248163	1874	200192000	6751	3495	0	0	0
248164	1678	5040154541000	6751	3495	1	0	0
248167	1874	200193000	6753	3496	0	0	0
248168	1678	5040154542000	6753	3496	1	0	0
248174	1874	200194000	6756	3497	1	0	0
248175	1874	200195000	6757	3498	0	0	0
248176	1678	5040154544000	6757	3498	1	0	0
248179	1874	200196000	6759	3499	0	0	0
248180	1678	5040154545000	6759	3499	1	0	0
248182	1874	200198000	6759	3499	3	0	0
248183	1874	200199000	6759	3499	4	0	0
248184	1678	5040154546000	6759	3499	5	0	0
248185	1678	5040154547000	6759	3499	6	0	0
248201	1678	5040154547000	6761	3499	6	0	\N
248202	1678	5040154548000	6761	3499	7	0	\N
248203	1880	200000000	6762	3500	0	0	\N
248204	1881	200000000	6762	3500	1	0	\N
248205	1678	5040154549000	6762	3500	2	0	\N
248206	1874	200200000	6762	3500	3	0	\N
248207	1882	200000000	6762	3500	4	0	\N
248213	1883	200000000	6764	3501	0	0	\N
248214	1678	5040154550000	6764	3501	1	0	\N
248215	1874	200201000	6764	3501	2	0	\N
248220	1678	5040154552000	6768	3504	0	0	\N
248221	1678	5040154553000	6768	3504	1	0	\N
248222	1874	200202000	6768	3504	2	0	\N
248223	1874	200203000	6768	3504	3	0	\N
248230	1874	200205000	6772	3506	0	0	\N
248231	1678	5040154555000	6772	3506	1	0	\N
248234	1874	200205000	6774	3506	0	0	\N
248235	1678	5040154555000	6774	3506	1	0	\N
248236	1874	200205000	6775	3506	0	0	\N
248237	1678	5040154555000	6775	3506	1	0	\N
248248	1874	200211000	6782	3512	0	0	\N
248249	1678	5040154561000	6782	3512	1	0	\N
248258	1678	5040154563000	6787	3514	0	0	\N
248259	1678	5040154564000	6787	3514	1	0	\N
248260	1874	200213000	6787	3514	2	0	\N
248261	1874	200214000	6787	3514	3	0	\N
248264	1678	5040154565000	6789	3515	0	0	\N
248265	1874	200215000	6789	3515	1	0	\N
248266	1678	5040154565000	6790	3515	0	0	\N
248267	1874	200215000	6790	3515	1	0	\N
248272	1678	5040154566000	6792	3516	0	0	\N
248273	1678	5040154567000	6792	3516	1	0	\N
248274	1874	200216000	6792	3516	2	0	\N
248275	1874	200217000	6792	3516	3	0	\N
248278	1874	200219000	6794	3518	0	0	\N
248279	1678	5040154569000	6794	3518	1	0	\N
248282	1874	200219000	6796	3518	0	0	\N
248283	1678	5040154569000	6796	3518	1	0	\N
248296	1874	200225000	6801	3522	0	0	\N
248297	1678	5040154574000	6801	3522	1	0	\N
248298	1678	5040154574000	6802	3522	0	0	\N
248299	1678	5040154574000	6804	3522	0	0	\N
248300	1678	5040154575000	6805	3523	0	0	\N
248301	1678	5040154575000	6806	3523	0	0	\N
248302	1874	200226000	6806	3523	1	0	\N
248309	1874	200227000	6809	3524	0	0	\N
248310	1678	5040154576000	6809	3524	1	0	\N
248311	1678	5040154577000	6809	3524	2	0	\N
248312	1874	200228000	6809	3524	3	0	\N
248313	1874	200227000	6810	3524	0	0	\N
248314	1678	5040154576000	6810	3524	1	0	\N
248315	1678	5040154577000	6810	3524	2	0	\N
248316	1874	200228000	6810	3524	3	0	\N
248325	1874	200231000	6814	3527	0	0	\N
248326	1886	200000000	6814	3527	1	0	\N
248327	1887	200000000	6814	3527	2	0	\N
248328	1678	5040154580000	6814	3527	3	0	\N
248329	1874	200232000	6815	3528	0	0	\N
248330	1874	200233000	6815	3528	1	0	\N
248331	1678	5040154581000	6815	3528	2	0	\N
248332	1678	5040154582000	6815	3528	3	0	\N
248210	1678	5040154549000	6763	3500	2	0	0
248211	1874	200200000	6763	3500	3	0	0
248212	1882	200000000	6763	3500	4	0	0
248216	1883	200000000	6765	3501	0	0	0
248217	1678	5040154550000	6765	3501	1	0	0
248219	1678	5040154551000	6766	3502	0	0	0
248224	1678	5040154552000	6769	3504	0	0	0
248225	1678	5040154553000	6769	3504	1	0	0
248226	1874	200202000	6769	3504	2	0	0
248227	1874	200203000	6769	3504	3	0	0
248229	1678	5040154554000	6770	3505	1	0	0
248232	1874	200205000	6773	3506	0	0	0
248233	1678	5040154555000	6773	3506	1	0	0
248238	1678	5040154556000	6776	3507	0	0	0
248240	1874	200207000	6777	3508	0	0	0
248241	1678	5040154557000	6777	3508	1	0	0
248242	1874	200208000	6778	3509	0	0	0
248243	1678	5040154558000	6778	3509	1	0	0
248244	1874	200209000	6779	3510	0	0	0
248246	1678	5040154560000	6781	3511	0	0	0
248247	1874	200210000	6781	3511	1	0	0
248250	1874	200211000	6783	3512	0	0	0
248251	1678	5040154561000	6783	3512	1	0	0
248252	1678	5040154562000	6784	3513	0	0	0
248254	1678	5040154563000	6786	3514	0	0	0
248255	1678	5040154564000	6786	3514	1	0	0
248256	1874	200213000	6786	3514	2	0	0
248257	1874	200214000	6786	3514	3	0	0
248263	1874	200215000	6788	3515	1	0	0
248268	1678	5040154566000	6791	3516	0	0	0
248269	1678	5040154567000	6791	3516	1	0	0
248270	1874	200216000	6791	3516	2	0	0
248271	1874	200217000	6791	3516	3	0	0
248277	1874	200218000	6793	3517	1	0	0
248280	1874	200219000	6795	3518	0	0	0
248281	1678	5040154569000	6795	3518	1	0	0
248284	1678	5040154570000	6797	3519	0	0	0
248285	1678	5040154571000	6797	3519	1	0	0
248287	1885	200000000	6798	3520	1	0	0
248288	1678	5040154572000	6798	3520	2	0	0
248289	1874	200221000	6798	3520	3	0	0
248290	1874	200222000	6798	3520	4	0	0
248292	1874	200224000	6799	3521	0	0	0
248293	1678	5040154573000	6799	3521	1	0	0
248294	1874	200225000	6800	3522	0	0	0
248295	1678	5040154574000	6800	3522	1	0	0
248303	1678	5040154575000	6807	3523	0	0	0
248305	1874	200227000	6808	3524	0	0	0
248306	1678	5040154576000	6808	3524	1	0	0
248307	1678	5040154577000	6808	3524	2	0	0
248308	1874	200228000	6808	3524	3	0	0
248317	1678	5040154578000	6811	3525	0	0	0
248319	1874	200230000	6812	3526	0	0	0
248320	1678	5040154579000	6812	3526	1	0	0
248321	1874	200231000	6813	3527	0	0	0
248322	1886	200000000	6813	3527	1	0	0
248324	1678	5040154580000	6813	3527	3	0	0
248333	1874	200232000	6816	3528	0	0	0
248334	1874	200233000	6816	3528	1	0	0
248335	1678	5040154581000	6816	3528	2	0	0
248336	1678	5040154582000	6816	3528	3	0	0
248342	1678	5040154584000	6819	3530	0	0	\N
248343	1874	200235000	6819	3530	1	0	\N
248352	1874	200240000	6822	3533	0	0	\N
248353	1678	5040154589000	6822	3533	1	0	\N
248354	1874	200240000	6823	3533	0	0	\N
248355	1678	5040154589000	6823	3533	1	0	\N
248358	1874	200241000	6825	3534	0	0	\N
248359	1678	5040154590000	6825	3534	1	0	\N
248370	1678	5040154591000	6828	3535	0	0	\N
248371	1874	200242000	6828	3535	1	0	\N
248372	1874	200243000	6828	3535	2	0	\N
248373	1874	200244000	6828	3535	3	0	\N
248374	1874	200245000	6828	3535	4	0	\N
248375	1678	5040154592000	6828	3535	5	0	\N
248376	1678	5040154593000	6828	3535	6	0	\N
248377	1678	5040154594000	6828	3535	7	0	\N
248378	1874	200246000	6829	3536	0	0	\N
248379	1678	5040154595000	6829	3536	1	0	\N
248380	1874	200246000	6830	3536	0	0	\N
248381	1678	5040154595000	6830	3536	1	0	\N
248384	1874	200246000	6832	3536	0	0	\N
248385	1678	5040154595000	6832	3536	1	0	\N
248386	1678	5040154595000	6833	3536	0	0	\N
248389	1874	200248000	6835	3538	0	0	\N
248390	1678	5040154597000	6835	3538	1	0	\N
248391	1874	200248000	6836	3538	0	0	\N
248392	1678	5040154597000	6836	3538	1	0	\N
248395	1874	200248000	6838	3538	0	0	\N
248396	1678	5040154597000	6838	3538	1	0	\N
248397	1678	5040154598000	6839	3539	0	0	\N
248398	1678	5040154599000	6839	3539	1	0	\N
248399	1874	200249000	6839	3539	2	0	\N
248400	1874	200250000	6839	3539	3	0	\N
248405	1678	5040154600000	6841	3540	0	0	\N
248406	1874	200251000	6841	3540	1	0	\N
248407	1678	5040154600000	6842	3540	0	0	\N
248408	1874	200251000	6842	3540	1	0	\N
248413	1874	200253000	6845	3542	0	0	\N
248414	1874	200254000	6845	3542	1	0	\N
248415	1874	200255000	6845	3542	2	0	\N
248416	1678	5040154602000	6845	3542	3	0	\N
248417	1678	5040154603000	6845	3542	4	0	\N
248418	1678	5040154604000	6845	3542	5	0	\N
248419	1874	200253000	6846	3542	0	0	\N
248420	1874	200254000	6846	3542	1	0	\N
248421	1874	200255000	6846	3542	2	0	\N
248422	1678	5040154602000	6846	3542	3	0	\N
248423	1678	5040154603000	6846	3542	4	0	\N
248424	1678	5040154604000	6846	3542	5	0	\N
248431	1678	5040154602000	6848	3542	0	0	\N
248432	1678	5040154603000	6848	3542	1	0	\N
248433	1678	5040154604000	6848	3542	2	0	\N
248434	1874	200253000	6849	3542	0	0	\N
248435	1874	200254000	6849	3542	1	0	\N
248436	1874	200255000	6849	3542	2	0	\N
248437	1678	5040154602000	6849	3542	3	0	\N
248438	1678	5040154603000	6849	3542	4	0	\N
248439	1678	5040154604000	6849	3542	5	0	\N
248440	1874	200253000	6850	3542	0	0	\N
248441	1874	200254000	6850	3542	1	0	\N
248442	1874	200255000	6850	3542	2	0	\N
248443	1678	5040154602000	6850	3542	3	0	\N
248444	1678	5040154603000	6850	3542	4	0	\N
248445	1678	5040154604000	6850	3542	5	0	\N
248446	1678	5040154605000	6850	3542	6	0	\N
248449	1678	5040154605000	6852	3543	0	0	\N
248450	1678	5040154606000	6852	3543	1	0	\N
248451	1874	200256000	6852	3543	2	0	\N
248458	1874	200258000	6855	3545	0	0	\N
248459	1874	200259000	6855	3545	1	0	\N
248460	1678	5040154607000	6855	3545	2	0	\N
248461	1678	5040154608000	6855	3545	3	0	\N
248470	1874	200260000	6857	3546	1	0	\N
248471	1874	200261000	6857	3546	2	0	\N
248472	1874	200262000	6857	3546	3	0	\N
248339	1888	200000000	6817	3529	2	0	0
248340	1678	5040154584000	6818	3530	0	0	0
248341	1874	200235000	6818	3530	1	0	0
248344	1678	5040154585000	6820	3531	0	0	0
248345	1874	200236000	6820	3531	2	0	0
248347	1678	5040154587000	6821	3532	1	0	0
248348	1678	5040154588000	6821	3532	2	0	0
248349	1874	200237000	6821	3532	3	0	0
248350	1874	200238000	6821	3532	4	0	0
248351	1874	200239000	6821	3532	5	0	0
248357	1678	5040154589000	6824	3533	1	0	0
248360	1874	200241000	6826	3534	0	0	0
248361	1678	5040154590000	6826	3534	1	0	0
248362	1678	5040154591000	6827	3535	0	0	0
248364	1874	200243000	6827	3535	2	0	0
248365	1874	200244000	6827	3535	3	0	0
248366	1874	200245000	6827	3535	4	0	0
248367	1678	5040154592000	6827	3535	5	0	0
248368	1678	5040154593000	6827	3535	6	0	0
248382	1874	200246000	6831	3536	0	0	0
248383	1678	5040154595000	6831	3536	1	0	0
248387	1678	5040154596000	6834	3537	0	0	0
248388	1874	200247000	6834	3537	1	0	0
248393	1874	200248000	6837	3538	0	0	0
248401	1678	5040154598000	6840	3539	0	0	0
248402	1678	5040154599000	6840	3539	1	0	0
248403	1874	200249000	6840	3539	2	0	0
248404	1874	200250000	6840	3539	3	0	0
248410	1678	5040154601000	6844	3541	0	0	0
248411	1874	200251000	6844	3541	1	0	0
248412	1874	200252000	6844	3541	2	0	0
248425	1874	200253000	6847	3542	0	0	0
248426	1874	200254000	6847	3542	1	0	0
248428	1678	5040154602000	6847	3542	3	0	0
248429	1678	5040154603000	6847	3542	4	0	0
248430	1678	5040154604000	6847	3542	5	0	0
248447	1678	5040154605000	6851	3543	0	0	0
248448	1874	200256000	6851	3543	1	0	0
248453	1678	5040154606000	6853	3544	1	0	0
248454	1874	200258000	6854	3545	0	0	0
248455	1874	200259000	6854	3545	1	0	0
248456	1678	5040154607000	6854	3545	2	0	0
248462	1874	200260000	6856	3546	1	0	0
248463	1874	200261000	6856	3546	2	0	0
248464	1874	200262000	6856	3546	3	0	0
248465	1874	200263000	6856	3546	4	0	0
248466	1678	5040154609000	6856	3546	5	0	0
248468	1678	5040154611000	6856	3546	7	0	0
248469	1678	5040154612000	6856	3546	8	0	0
248473	1874	200263000	6857	3546	4	0	\N
248474	1678	5040154609000	6857	3546	5	0	\N
248475	1678	5040154610000	6857	3546	6	0	\N
248476	1678	5040154611000	6857	3546	7	0	\N
248477	1678	5040154612000	6857	3546	8	0	\N
248480	1678	5040154613000	6859	3547	0	0	\N
248481	1874	200264000	6859	3547	1	0	\N
248484	1678	5040154614000	6861	3548	0	0	\N
248485	1874	200265000	6861	3548	1	0	\N
248497	1678	5040154618000	6865	3551	0	0	\N
248498	1678	5040154619000	6865	3551	1	0	\N
248499	1874	200269000	6865	3551	2	0	\N
248500	1890	200000000	6865	3551	3	0	\N
248501	1874	200270000	6865	3551	4	0	\N
248510	1678	5040154624000	6869	3554	0	0	\N
248511	1874	200275000	6869	3554	1	0	\N
248512	1678	5040154624000	6870	3554	0	0	\N
248513	1874	200275000	6870	3554	1	0	\N
248514	1678	5040154624000	6871	3554	0	0	\N
248515	1874	200275000	6871	3554	1	0	\N
248518	1678	5040154624000	6873	3554	0	0	\N
248519	1874	200275000	6873	3554	1	0	\N
248520	1678	5040154624000	6874	3554	0	0	\N
248521	1874	200275000	6874	3554	1	0	\N
248522	1678	5040154624000	6875	3554	0	0	\N
248523	1874	200275000	6875	3554	1	0	\N
248528	1874	200140000	6878	3420	0	0	\N
248529	1678	5040154489000	6878	3420	1	0	\N
248530	1678	5040154490000	6878	3420	2	0	\N
248531	1678	5040154491000	6878	3420	3	0	\N
248532	1678	5040154492000	6878	3420	4	0	\N
248533	1678	5040154493000	6878	3420	5	0	\N
248534	1678	5040154494000	6878	3420	6	0	\N
248535	1874	200141000	6878	3420	7	0	\N
248536	1874	200142000	6878	3420	8	0	\N
248537	1874	200143000	6878	3420	9	0	\N
248538	1874	200144000	6878	3420	10	0	\N
248539	1874	200145000	6878	3420	11	0	\N
248540	1874	200146000	6878	3420	12	0	\N
248541	1874	200147000	6878	3420	13	0	\N
248542	1874	200148000	6878	3420	14	0	\N
248543	1874	200149000	6878	3420	15	0	\N
248544	1874	200150000	6878	3420	16	0	\N
248545	1874	200151000	6878	3420	17	0	\N
248546	1874	200152000	6878	3420	18	0	\N
248547	1874	200153000	6878	3420	19	0	\N
248548	1874	200154000	6878	3420	20	0	\N
248549	1874	200155000	6878	3420	21	0	\N
248550	1874	200156000	6878	3420	22	0	\N
248551	1874	200157000	6878	3420	23	0	\N
248552	1874	200158000	6878	3420	24	0	\N
248553	1874	200159000	6878	3420	25	0	\N
248554	1874	200160000	6878	3420	26	0	\N
248555	1874	200161000	6878	3420	27	0	\N
248556	1874	200162000	6878	3420	28	0	\N
248557	1874	200163000	6878	3420	29	0	\N
248558	1874	200164000	6878	3420	30	0	\N
248559	1874	200165000	6878	3420	31	0	\N
248560	1874	200166000	6878	3420	32	0	\N
248561	1874	200167000	6878	3420	33	0	\N
248562	1874	200168000	6878	3420	34	0	\N
248563	1874	200169000	6878	3420	35	0	\N
248564	1874	200170000	6878	3420	36	0	\N
248565	1874	200171000	6878	3420	37	0	\N
248566	1874	200172000	6878	3420	38	0	\N
248567	1874	200173000	6878	3420	39	0	\N
248568	1874	200174000	6878	3420	41	0	\N
248569	1874	200175000	6878	3420	42	0	\N
248570	1874	200176000	6878	3420	43	0	\N
248571	1874	200177000	6878	3420	44	0	\N
248572	1874	200178000	6878	3420	45	0	\N
248573	1874	200179000	6878	3420	46	0	\N
248574	1874	200180000	6878	3420	47	0	\N
248575	1874	200181000	6878	3420	48	0	\N
248576	1874	200182000	6878	3420	49	0	\N
248577	1874	200183000	6878	3420	50	0	\N
248578	1874	200184000	6878	3420	51	0	\N
248579	1874	200185000	6878	3420	52	0	\N
248580	1874	200186000	6878	3420	53	0	\N
248581	1874	200187000	6878	3420	54	0	\N
248582	1874	200188000	6878	3420	55	0	\N
248583	1874	200189000	6878	3420	56	0	\N
248584	1874	200190000	6878	3420	57	0	\N
248585	1874	200191000	6878	3420	58	0	\N
248586	1874	200192000	6878	3420	59	0	\N
248587	1874	200193000	6878	3420	60	0	\N
248588	1874	200194000	6878	3420	61	0	\N
248589	1874	200195000	6878	3420	62	0	\N
248590	1874	200196000	6878	3420	63	0	\N
248591	1874	200197000	6878	3420	64	0	\N
248592	1874	200198000	6878	3420	65	0	\N
248593	1874	200199000	6878	3420	66	0	\N
248594	1880	200000000	6878	3420	67	0	\N
248595	1881	200000000	6878	3420	68	0	\N
248596	1874	200200000	6878	3420	69	0	\N
248597	1882	200000000	6878	3420	70	0	\N
248598	1883	200000000	6878	3420	71	0	\N
248599	1874	200201000	6878	3420	72	0	\N
248600	1874	200202000	6878	3420	73	0	\N
248601	1874	200203000	6878	3420	74	0	\N
248602	1874	200204000	6878	3420	75	0	\N
248603	1874	200205000	6878	3420	76	0	\N
248604	1874	200206000	6878	3420	77	0	\N
248605	1874	200207000	6878	3420	78	0	\N
248606	1874	200208000	6878	3420	79	0	\N
248607	1874	200209000	6878	3420	80	0	\N
248608	1874	200210000	6878	3420	81	0	\N
248482	1678	5040154614000	6860	3548	0	0	0
248483	1874	200265000	6860	3548	1	0	0
248486	1678	5040154615000	6862	3549	0	0	0
248487	1678	5040154616000	6862	3549	1	0	0
248488	1874	200266000	6862	3549	2	0	0
248490	1678	5040154617000	6863	3550	0	0	0
248491	1874	200268000	6863	3550	1	0	0
248492	1678	5040154618000	6864	3551	0	0	0
248493	1678	5040154619000	6864	3551	1	0	0
248494	1874	200269000	6864	3551	2	0	0
248496	1874	200270000	6864	3551	4	0	0
248502	1874	200271000	6867	3552	0	0	0
248503	1678	5040154620000	6867	3552	1	0	0
248504	1874	200272000	6868	3553	0	0	0
248506	1874	200274000	6868	3553	2	0	0
248507	1678	5040154621000	6868	3553	3	0	0
248508	1678	5040154622000	6868	3553	4	0	0
248509	1678	5040154623000	6868	3553	5	0	0
248516	1678	5040154624000	6872	3554	0	0	0
248524	1678	5040154625000	6876	3555	0	0	0
248525	1874	200276000	6876	3555	1	0	0
248526	1874	200277000	6877	3556	0	0	0
248527	1678	5040154626000	6877	3556	1	0	0
248609	1874	200211000	6878	3420	82	0	\N
248610	1874	200212000	6878	3420	83	0	\N
248611	1874	200213000	6878	3420	84	0	\N
248612	1874	200214000	6878	3420	85	0	\N
248613	1874	200215000	6878	3420	86	0	\N
248614	1874	200216000	6878	3420	87	0	\N
248615	1874	200217000	6878	3420	88	0	\N
248616	1874	200218000	6878	3420	89	0	\N
248617	1874	200219000	6878	3420	90	0	\N
248618	1874	200220000	6878	3420	91	0	\N
248619	1885	200000000	6878	3420	92	0	\N
248620	1874	200221000	6878	3420	93	0	\N
248621	1874	200222000	6878	3420	94	0	\N
248622	1874	200223000	6878	3420	95	0	\N
248623	1874	200224000	6878	3420	96	0	\N
248624	1874	200225000	6878	3420	97	0	\N
248625	1874	200226000	6878	3420	98	0	\N
248626	1874	200227000	6878	3420	99	0	\N
248627	1874	200228000	6878	3420	100	0	\N
248628	1874	200229000	6878	3420	101	0	\N
248629	1874	200230000	6878	3420	102	0	\N
248630	1874	200231000	6878	3420	103	0	\N
248631	1886	200000000	6878	3420	104	0	\N
248632	1887	200000000	6878	3420	105	0	\N
248633	1874	200232000	6878	3420	106	0	\N
248634	1874	200233000	6878	3420	107	0	\N
248635	1874	200234000	6878	3420	108	0	\N
248636	1888	200000000	6878	3420	109	0	\N
248637	1874	200235000	6878	3420	110	0	\N
248638	1874	200236000	6878	3420	111	0	\N
248639	1874	200237000	6878	3420	112	0	\N
248640	1874	200238000	6878	3420	113	0	\N
248641	1874	200239000	6878	3420	114	0	\N
248642	1874	200240000	6878	3420	115	0	\N
248643	1874	200241000	6878	3420	116	0	\N
248644	1874	200242000	6878	3420	117	0	\N
248645	1874	200243000	6878	3420	118	0	\N
248646	1874	200244000	6878	3420	119	0	\N
248647	1874	200245000	6878	3420	120	0	\N
248648	1874	200246000	6878	3420	121	0	\N
248649	1874	200247000	6878	3420	122	0	\N
248650	1874	200248000	6878	3420	123	0	\N
248651	1874	200249000	6878	3420	124	0	\N
248652	1874	200250000	6878	3420	125	0	\N
248653	1678	5040154627000	6879	3557	0	0	\N
248654	1678	5040154628000	6879	3557	1	0	\N
248655	1406	0	6879	3557	2	0	\N
248656	1678	5040154627000	6880	3557	0	0	\N
248657	1874	200278000	6880	3557	1	0	\N
248658	1874	200279000	6880	3557	2	0	\N
248659	1678	5040154628000	6880	3557	3	0	\N
248660	1406	0	6880	3557	4	0	\N
248661	1678	5040154627000	6881	3557	0	0	\N
248662	1874	200278000	6881	3557	1	0	\N
248663	1874	200279000	6881	3557	2	0	\N
248664	1678	5040154628000	6881	3557	3	0	\N
248665	1406	0	6881	3557	4	0	\N
248666	1678	5040154627000	6882	3557	0	0	\N
248667	1874	200278000	6882	3557	1	0	\N
248668	1874	200279000	6882	3557	2	0	\N
248669	1678	5040154628000	6882	3557	3	0	\N
248670	1406	0	6882	3557	4	0	\N
248676	1678	5040154627000	6884	3557	0	0	\N
248677	1678	5040154628000	6884	3557	1	0	\N
248678	1406	0	6884	3557	2	0	\N
248679	1678	5040154627000	6885	3557	0	0	\N
248680	1874	200278000	6885	3557	1	0	\N
248681	1874	200279000	6885	3557	2	0	\N
248682	1678	5040154628000	6885	3557	3	0	\N
248683	1406	0	6885	3557	4	0	\N
248684	1678	5040154629000	6886	3558	0	0	\N
248685	1874	200280000	6886	3558	1	0	\N
248688	1678	5040154629000	6888	3558	0	0	\N
248689	1874	200280000	6888	3558	1	0	\N
248690	1406	0	6889	3370	0	0	\N
248691	1407	0	6889	3370	1	0	\N
248701	1678	5040154632000	6893	3561	0	0	\N
248702	1874	200283000	6893	3561	1	0	\N
248703	1874	200284000	6893	3561	2	0	\N
248704	1678	5040154633000	6893	3561	3	0	\N
248713	1678	5040154638000	6899	3565	0	0	\N
248714	1874	200289000	6899	3565	1	0	\N
248715	1678	5040154638000	6900	3565	0	0	\N
248716	1874	200289000	6900	3565	1	0	\N
248719	1874	200290000	6902	3566	0	0	\N
248720	1678	5040154639000	6902	3566	1	0	\N
248729	1678	5040154642000	6906	3568	0	0	\N
248730	1874	200293000	6906	3568	1	0	\N
248733	1874	200294000	6908	3569	0	0	\N
248734	1678	5040154643000	6908	3569	1	0	\N
248735	1678	5040154644000	6909	3570	0	0	\N
248736	1678	5040154644000	6910	3570	0	0	\N
248737	1874	200295000	6910	3570	1	0	\N
248738	1678	5040154644000	6911	3570	0	0	\N
248739	1874	200295000	6911	3570	1	0	\N
248742	1678	5040154644000	6913	3570	0	0	\N
248673	1874	200279000	6883	3557	2	0	0
248674	1678	5040154628000	6883	3557	3	0	0
248675	1406	0	6883	3557	4	0	0
248686	1678	5040154629000	6887	3558	0	0	0
248687	1874	200280000	6887	3558	1	0	0
248693	1407	0	6890	3559	1	0	0
248694	1874	200281000	6890	3559	2	0	0
248695	1678	5040154631000	6891	3560	0	0	0
248696	1874	200282000	6891	3560	1	0	0
248697	1678	5040154632000	6892	3561	0	0	0
248699	1874	200284000	6892	3561	2	0	0
248700	1678	5040154633000	6892	3561	3	0	0
248705	1874	200285000	6895	3562	0	0	0
248706	1874	200286000	6895	3562	1	0	0
248708	1678	5040154635000	6895	3562	3	0	0
248709	1678	5040154636000	6896	3563	0	0	0
248710	1874	200287000	6896	3563	1	0	0
248711	1678	5040154637000	6898	3564	0	0	0
248712	1874	200288000	6898	3564	1	0	0
248718	1874	200289000	6901	3565	1	0	0
248721	1874	200290000	6903	3566	0	0	0
248722	1678	5040154639000	6903	3566	1	0	0
248723	1874	200291000	6904	3567	0	0	0
248724	1678	5040154640000	6904	3567	1	0	0
248726	1678	5040154641000	6904	3567	3	0	0
248727	1678	5040154642000	6905	3568	0	0	0
248728	1874	200293000	6905	3568	1	0	0
248731	1874	200294000	6907	3569	0	0	0
248740	1678	5040154644000	6912	3570	0	0	0
248741	1874	200295000	6912	3570	1	0	0
248743	1874	200296000	6914	3571	0	0	0
248744	1678	5040154645000	6914	3571	1	0	0
248745	1874	200296000	6915	3571	0	0	\N
248746	1678	5040154645000	6915	3571	1	0	\N
248747	1874	200297000	6916	3572	0	0	\N
248748	1678	5040154646000	6916	3572	1	0	\N
248749	1874	200297000	6917	3572	0	0	\N
248750	1678	5040154646000	6917	3572	1	0	\N
248751	1874	200297000	6918	3572	0	0	\N
248752	1678	5040154646000	6918	3572	1	0	\N
248753	1874	200297000	6919	3572	0	0	\N
248754	1678	5040154646000	6919	3572	1	0	\N
248757	1678	5040154647000	6921	3573	0	0	\N
248758	1678	5040154648000	6921	3573	1	0	\N
248759	1874	200298000	6921	3573	2	0	\N
248760	1874	200299000	6921	3573	3	0	\N
248765	1678	5040154647000	6923	3573	0	0	\N
248766	1678	5040154648000	6923	3573	1	0	\N
248771	1678	5040154650000	6926	3575	0	0	\N
248772	1678	5040154650000	6927	3575	0	0	\N
248773	1874	200301000	6927	3575	1	0	\N
248776	1874	200302000	6929	3576	0	0	\N
248777	1678	5040154651000	6929	3576	1	0	\N
248778	1874	200303000	6930	3577	0	0	\N
248779	1874	200304000	6930	3577	1	0	\N
248780	1678	5040154652000	6930	3577	2	0	\N
248781	1678	5040154653000	6930	3577	3	0	\N
248800	1874	200311000	6942	3583	0	0	\N
248801	1678	5040154660000	6942	3583	1	0	\N
248802	1678	5040154660000	6943	3583	0	0	\N
248807	1874	200314000	6946	3585	0	0	\N
248808	1891	200000000	6946	3585	1	0	\N
248809	1678	5040154663000	6946	3585	2	0	\N
248814	1678	5040154665000	6950	3587	0	0	\N
248815	1678	5040154666000	6950	3587	1	0	\N
248816	1678	5040154667000	6950	3587	2	0	\N
248820	1874	200315000	6952	3587	0	0	\N
248821	1874	200316000	6952	3587	1	0	\N
248822	1678	5040154665000	6952	3587	2	0	\N
248823	1678	5040154666000	6952	3587	3	0	\N
248824	1874	200317000	6952	3587	4	0	\N
248825	1874	200318000	6952	3587	5	0	\N
248826	1678	5040154667000	6952	3587	6	0	\N
248827	1874	200315000	6953	3587	0	0	\N
248828	1874	200316000	6953	3587	1	0	\N
248829	1678	5040154665000	6953	3587	2	0	\N
248830	1678	5040154666000	6953	3587	3	0	\N
248831	1874	200317000	6953	3587	4	0	\N
248832	1874	200318000	6953	3587	5	0	\N
248833	1678	5040154667000	6953	3587	6	0	\N
248834	1678	5040154631000	6954	3560	0	0	\N
248835	1678	5040154632000	6954	3560	1	0	\N
248836	1874	200282000	6954	3560	2	0	\N
248837	1874	200283000	6954	3560	3	0	\N
248838	1874	200284000	6954	3560	4	0	\N
248839	1874	200285000	6954	3560	5	0	\N
248840	1874	200286000	6954	3560	6	0	\N
248841	1874	200287000	6954	3560	7	0	\N
248842	1874	200288000	6954	3560	8	0	\N
248843	1874	200289000	6954	3560	9	0	\N
248844	1874	200290000	6954	3560	10	0	\N
248845	1874	200291000	6954	3560	11	0	\N
248846	1678	5040154633000	6954	3560	12	0	\N
248847	1678	5040154634000	6954	3560	13	0	\N
248848	1678	5040154635000	6954	3560	14	0	\N
248849	1678	5040154636000	6954	3560	15	0	\N
248850	1678	5040154637000	6954	3560	16	0	\N
248851	1678	5040154638000	6954	3560	17	0	\N
248852	1874	200292000	6954	3560	18	0	\N
248853	1874	200293000	6954	3560	19	0	\N
248854	1678	5040154639000	6954	3560	20	0	\N
248855	1678	5040154640000	6954	3560	21	0	\N
248856	1874	200294000	6954	3560	22	0	\N
248857	1678	5040154641000	6954	3560	23	0	\N
248858	1678	5040154642000	6954	3560	24	0	\N
248859	1678	5040154643000	6954	3560	25	0	\N
248860	1678	5040154644000	6954	3560	26	0	\N
248861	1874	200295000	6954	3560	27	0	\N
248862	1874	200296000	6954	3560	28	0	\N
248863	1874	200297000	6954	3560	29	0	\N
248864	1678	5040154645000	6954	3560	30	0	\N
248865	1678	5040154646000	6954	3560	31	0	\N
248866	1678	5040154647000	6954	3560	32	0	\N
248867	1678	5040154648000	6954	3560	33	0	\N
248868	1678	5040154649000	6954	3560	34	0	\N
248869	1678	5040154650000	6954	3560	35	0	\N
248870	1678	5040154651000	6954	3560	36	0	\N
248871	1678	5040154652000	6954	3560	37	0	\N
248872	1678	5040154653000	6954	3560	38	0	\N
248873	1678	5040154654000	6954	3560	39	0	\N
248874	1678	5040154655000	6954	3560	40	0	\N
248875	1678	5040154656000	6954	3560	41	0	\N
248876	1678	5040154657000	6954	3560	42	0	\N
248877	1678	5040154658000	6954	3560	43	0	\N
248878	1678	5040154659000	6954	3560	44	0	\N
248879	1678	5040154660000	6954	3560	45	0	\N
248880	1678	5040154661000	6954	3560	46	0	\N
248761	1678	5040154647000	6922	3573	0	0	0
248762	1678	5040154648000	6922	3573	1	0	0
248763	1874	200298000	6922	3573	2	0	0
248764	1874	200299000	6922	3573	3	0	0
248767	1874	200300000	6924	3574	0	0	0
248769	1678	5040154650000	6925	3575	0	0	0
248770	1874	200301000	6925	3575	1	0	0
248774	1874	200302000	6928	3576	0	0	0
248775	1678	5040154651000	6928	3576	1	0	0
248782	1874	200303000	6931	3577	0	0	0
248784	1678	5040154652000	6931	3577	2	0	0
248785	1678	5040154653000	6931	3577	3	0	0
248786	1874	200305000	6934	3578	0	0	0
248787	1678	5040154654000	6934	3578	1	0	0
248789	1874	200307000	6937	3579	1	0	0
248790	1678	5040154655000	6937	3579	2	0	0
248791	1678	5040154656000	6937	3579	3	0	0
248792	1678	5040154657000	6938	3580	0	0	0
248793	1874	200308000	6938	3580	1	0	0
248795	1874	200309000	6939	3581	1	0	0
248796	1874	200310000	6940	3582	0	0	0
248797	1678	5040154659000	6940	3582	1	0	0
248798	1874	200311000	6941	3583	0	0	0
248799	1678	5040154660000	6941	3583	1	0	0
248804	1874	200313000	6945	3584	1	0	0
248805	1678	5040154661000	6945	3584	2	0	0
248806	1678	5040154662000	6945	3584	3	0	0
248810	1874	200314000	6947	3585	0	0	0
248812	1678	5040154663000	6947	3585	2	0	0
248813	1678	5040154664000	6949	3586	0	0	0
248817	1678	5040154665000	6951	3587	0	0	0
248818	1678	5040154666000	6951	3587	1	0	0
248819	1678	5040154667000	6951	3587	2	0	0
248881	1678	5040154662000	6954	3560	47	0	\N
248882	1678	5040154663000	6954	3560	48	0	\N
248883	1678	5040154664000	6954	3560	49	0	\N
248884	1678	5040154665000	6954	3560	50	0	\N
248885	1678	5040154666000	6954	3560	51	0	\N
248886	1678	5040154667000	6954	3560	52	0	\N
248887	1874	200298000	6954	3560	53	0	\N
248888	1874	200299000	6954	3560	54	0	\N
248889	1874	200300000	6954	3560	55	0	\N
248890	1874	200301000	6954	3560	56	0	\N
248891	1874	200302000	6954	3560	57	0	\N
248892	1874	200303000	6954	3560	58	0	\N
248893	1874	200304000	6954	3560	59	0	\N
248894	1874	200305000	6954	3560	60	0	\N
248895	1874	200306000	6954	3560	61	0	\N
248896	1874	200307000	6954	3560	62	0	\N
248897	1874	200308000	6954	3560	63	0	\N
248898	1874	200309000	6954	3560	64	0	\N
248899	1874	200310000	6954	3560	65	0	\N
248900	1874	200311000	6954	3560	66	0	\N
248901	1874	200312000	6954	3560	67	0	\N
248902	1874	200313000	6954	3560	68	0	\N
248903	1874	200314000	6954	3560	69	0	\N
248904	1891	200000000	6954	3560	70	0	\N
248905	1874	200315000	6954	3560	71	0	\N
248906	1874	200316000	6954	3560	72	0	\N
248907	1874	200317000	6954	3560	73	0	\N
248908	1874	200318000	6954	3560	74	0	\N
248909	1874	200319000	6954	3560	75	0	\N
248918	1874	200320000	6957	3589	0	0	\N
248919	1678	5040154669000	6957	3589	1	0	\N
248922	1874	200321000	6959	3590	0	0	\N
248923	1678	5040154670000	6959	3590	1	0	\N
248924	1874	200321000	6960	3590	0	0	\N
248925	1678	5040154670000	6960	3590	1	0	\N
248926	1678	5040154671000	6961	3591	0	0	\N
248929	1874	200323000	6963	3592	0	0	\N
248930	1678	5040154672000	6963	3592	1	0	\N
248937	1874	200325000	6967	3594	0	0	\N
248938	1678	5040154674000	6967	3594	1	0	\N
248952	1874	200332000	6972	3598	0	0	\N
248953	1678	5040154681000	6972	3598	1	0	\N
248954	1874	200332000	6973	3598	0	0	\N
248955	1678	5040154681000	6973	3598	1	0	\N
248956	1874	200332000	6974	3598	0	0	\N
248957	1678	5040154681000	6974	3598	1	0	\N
248958	1874	200332000	6975	3598	0	0	\N
248959	1678	5040154681000	6975	3598	1	0	\N
248963	1678	5040154682000	6977	3599	0	0	\N
248964	1874	200332000	6977	3599	1	0	\N
248965	1874	200333000	6977	3599	2	0	\N
248968	1874	200335000	6979	3601	0	0	\N
248969	1678	5040154684000	6979	3601	1	0	\N
248976	1678	5040154685000	6982	3602	0	0	\N
248977	1678	5040154686000	6982	3602	1	0	\N
248978	1874	200336000	6982	3602	2	0	\N
248979	1874	200337000	6982	3602	3	0	\N
248992	1874	200343000	6988	3607	0	0	\N
248993	1678	5040154692000	6988	3607	1	0	\N
249000	1874	200345000	6991	3609	0	0	\N
249001	1678	5040154694000	6991	3609	1	0	\N
249002	1874	200346000	6991	3609	2	0	\N
249003	1678	5040154695000	6991	3609	3	0	\N
249004	1874	200347000	6992	3610	0	0	\N
249005	1718	200000000	6992	3610	1	0	\N
249006	1678	5040154696000	6992	3610	2	0	\N
249007	1874	200348000	6992	3610	3	0	\N
249008	1678	5040154697000	6992	3610	4	0	\N
249009	1678	5040154698000	6992	3610	5	0	\N
249010	1678	5040154699000	6992	3610	6	0	\N
249011	1874	200349000	6992	3610	7	0	\N
249012	1874	200350000	6992	3610	8	0	\N
249013	1874	200347000	6993	3610	0	0	\N
249014	1718	200000000	6993	3610	1	0	\N
249015	1678	5040154696000	6993	3610	2	0	\N
249016	1874	200348000	6993	3610	3	0	\N
248912	1874	200316000	6955	3588	2	0	0
248913	1874	200317000	6955	3588	3	0	0
248914	1874	200318000	6955	3588	4	0	0
248915	1874	200319000	6955	3588	5	0	0
248916	1874	200320000	6956	3589	0	0	0
248920	1874	200321000	6958	3590	0	0	0
248921	1678	5040154670000	6958	3590	1	0	0
248927	1678	5040154671000	6962	3591	0	0	0
248928	1874	200322000	6962	3591	1	0	0
248931	1874	200323000	6964	3592	0	0	0
248933	1678	5040154673000	6965	3593	0	0	0
248934	1874	200324000	6965	3593	1	0	0
248935	1874	200325000	6966	3594	0	0	0
248936	1678	5040154674000	6966	3594	1	0	0
248940	1874	200326000	6968	3595	1	0	0
248941	1678	5040154676000	6969	3596	0	0	0
248942	1874	200327000	6970	3597	0	0	0
248943	1874	200328000	6970	3597	1	0	0
248944	1678	5040154677000	6970	3597	2	0	0
248946	1678	5040154679000	6970	3597	4	0	0
248947	1678	5040154680000	6970	3597	5	0	0
248948	1874	200329000	6970	3597	6	0	0
248949	1874	200330000	6970	3597	7	0	0
248950	1874	200331000	6970	3597	8	0	0
248960	1678	5040154682000	6976	3599	0	0	0
248961	1874	200332000	6976	3599	1	0	0
248962	1874	200333000	6976	3599	2	0	0
248966	1678	5040154683000	6978	3600	0	0	0
248970	1874	200335000	6980	3601	0	0	0
248971	1678	5040154684000	6980	3601	1	0	0
248972	1678	5040154685000	6981	3602	0	0	0
248973	1678	5040154686000	6981	3602	1	0	0
248974	1874	200336000	6981	3602	2	0	0
248980	1874	200338000	6983	3603	0	0	0
248981	1678	5040154687000	6983	3603	1	0	0
248982	1678	5040154688000	6984	3604	0	0	0
248983	1678	5040154689000	6984	3604	1	0	0
248984	1874	200339000	6984	3604	2	0	0
248986	1874	200341000	6985	3605	0	0	0
248987	1678	5040154690000	6985	3605	1	0	0
248988	1678	5040154691000	6986	3606	0	0	0
248989	1874	200342000	6986	3606	1	0	0
248991	1678	5040154692000	6987	3607	1	0	0
248994	1678	5040154693000	6989	3608	0	0	0
248995	1874	200344000	6989	3608	1	0	0
248996	1874	200345000	6990	3609	0	0	0
248997	1678	5040154694000	6990	3609	1	0	0
248999	1678	5040154695000	6990	3609	3	0	0
249017	1678	5040154697000	6993	3610	4	0	\N
249018	1678	5040154698000	6993	3610	5	0	\N
249019	1678	5040154699000	6993	3610	6	0	\N
249020	1874	200349000	6993	3610	7	0	\N
249021	1874	200350000	6993	3610	8	0	\N
249031	1678	5040154700000	6995	3611	0	0	\N
249032	1874	200351000	6995	3611	1	0	\N
249039	1678	5040154702000	7000	3613	0	0	\N
249040	1874	200353000	7000	3613	1	0	\N
249041	1874	200354000	7005	3614	0	0	\N
249042	1678	5040154703000	7005	3614	1	0	\N
249043	1874	200354000	7006	3614	0	0	\N
249044	1678	5040154703000	7006	3614	1	0	\N
249047	1678	5040154704000	7008	3615	0	0	\N
249048	1678	5040154705000	7008	3615	1	0	\N
249049	1874	200355000	7008	3615	2	0	\N
249050	1874	200356000	7008	3615	3	0	\N
249051	544	67439000000000	7008	3615	4	0	\N
249057	1678	5040154704000	7010	3615	0	0	\N
249058	1678	5040154705000	7010	3615	1	0	\N
249059	1874	200355000	7010	3615	2	0	\N
249060	1874	200356000	7010	3615	3	0	\N
249061	544	67439000000000	7010	3615	4	0	\N
249062	1678	5040154704000	7011	3615	0	0	\N
249063	1678	5040154705000	7011	3615	1	0	\N
249064	1874	200355000	7011	3615	2	0	\N
249065	1874	200356000	7011	3615	3	0	\N
249066	544	67439000000000	7011	3615	4	0	\N
249067	1874	200357000	7012	3616	0	0	\N
249068	1678	5040154706000	7012	3616	1	0	\N
249071	1874	200357000	7014	3616	0	0	\N
249072	1678	5040154706000	7014	3616	1	0	\N
249079	1874	200359000	7017	3618	0	0	\N
249080	1874	200360000	7017	3618	1	0	\N
249081	1678	5040154708000	7017	3618	2	0	\N
249082	1678	5040154709000	7017	3618	3	0	\N
249087	1678	5040154710000	7019	3619	0	0	\N
249088	1874	200361000	7019	3619	1	0	\N
249089	1874	200362000	7019	3619	2	0	\N
249090	1678	5040154711000	7019	3619	3	0	\N
249091	1678	5040154710000	7020	3619	0	0	\N
249092	1874	200361000	7020	3619	1	0	\N
249093	1874	200362000	7020	3619	2	0	\N
249094	1678	5040154711000	7020	3619	3	0	\N
249099	1678	5040154714000	7022	3621	0	0	\N
249100	1678	5040154715000	7022	3621	1	0	\N
249101	1874	200365000	7022	3621	2	0	\N
249102	1874	200366000	7022	3621	3	0	\N
249103	1874	200367000	7022	3621	4	0	\N
249104	1678	5040154716000	7022	3621	5	0	\N
249111	1874	200368000	7024	3622	0	0	\N
249112	1678	5040154717000	7024	3622	1	0	\N
249113	1678	5040154718000	7024	3622	2	0	\N
249114	1874	200369000	7024	3622	3	0	\N
249119	1874	200368000	7026	3622	0	0	\N
249120	1678	5040154717000	7026	3622	1	0	\N
249121	1678	5040154718000	7026	3622	2	0	\N
249122	1874	200369000	7026	3622	3	0	\N
249123	1874	200370000	7027	3623	0	0	\N
249124	1678	5040154719000	7027	3623	1	0	\N
249131	1678	5040154720000	7030	3624	0	0	\N
249132	1678	5040154721000	7030	3624	1	0	\N
249133	1874	200371000	7030	3624	2	0	\N
249134	1874	200372000	7030	3624	3	0	\N
249024	1678	5040154696000	6994	3610	2	0	0
249025	1874	200348000	6994	3610	3	0	0
249026	1678	5040154697000	6994	3610	4	0	0
249027	1678	5040154698000	6994	3610	5	0	0
249028	1678	5040154699000	6994	3610	6	0	0
249030	1874	200350000	6994	3610	8	0	0
249033	1678	5040154700000	6996	3611	0	0	0
249034	1874	200351000	6996	3611	1	0	0
249035	1678	5040154701000	6997	3612	0	0	0
249036	1874	200352000	6997	3612	1	0	0
249038	1874	200353000	6999	3613	1	0	0
249045	1874	200354000	7007	3614	0	0	0
249046	1678	5040154703000	7007	3614	1	0	0
249052	1678	5040154704000	7009	3615	0	0	0
249054	1874	200355000	7009	3615	2	0	0
249055	1874	200356000	7009	3615	3	0	0
249056	544	67439000000000	7009	3615	4	0	0
249069	1874	200357000	7013	3616	0	0	0
249070	1678	5040154706000	7013	3616	1	0	0
249074	1678	5040154707000	7015	3617	1	0	0
249075	1874	200359000	7016	3618	0	0	0
249076	1874	200360000	7016	3618	1	0	0
249077	1678	5040154708000	7016	3618	2	0	0
249078	1678	5040154709000	7016	3618	3	0	0
249084	1874	200361000	7018	3619	1	0	0
249085	1874	200362000	7018	3619	2	0	0
249086	1678	5040154711000	7018	3619	3	0	0
249095	1678	5040154712000	7021	3620	0	0	0
249097	1874	200363000	7021	3620	2	0	0
249098	1874	200364000	7021	3620	3	0	0
249105	1678	5040154714000	7023	3621	0	0	0
249106	1678	5040154715000	7023	3621	1	0	0
249107	1874	200365000	7023	3621	2	0	0
249109	1874	200367000	7023	3621	4	0	0
249110	1678	5040154716000	7023	3621	5	0	0
249115	1874	200368000	7025	3622	0	0	0
249116	1678	5040154717000	7025	3622	1	0	0
249117	1678	5040154718000	7025	3622	2	0	0
249125	1874	200370000	7028	3623	0	0	0
249126	1678	5040154719000	7028	3623	1	0	0
249127	1678	5040154720000	7029	3624	0	0	0
249128	1678	5040154721000	7029	3624	1	0	0
249130	1874	200372000	7029	3624	3	0	0
249135	1678	5040154722000	7031	3625	0	0	0
249136	1874	200373000	7031	3625	1	0	0
249137	1874	200374000	7032	3626	0	0	0
249138	1874	200375000	7032	3626	1	0	0
249140	1678	5040154724000	7032	3626	3	0	0
249141	1874	200376000	7033	3627	0	0	0
249142	1678	5040154725000	7033	3627	1	0	0
249143	1678	5040154726000	7034	3628	0	0	0
249144	1874	200377000	7034	3628	1	0	0
249146	1874	200378000	7035	3629	1	0	0
249147	1874	200379000	7035	3629	2	0	0
249148	1678	5040154728000	7035	3629	3	0	0
249149	1678	5040154729000	7036	3630	0	0	0
249151	1874	200381000	7037	3631	0	0	0
249152	1678	5040154730000	7037	3631	1	0	0
249155	1678	5040154731000	7039	3632	0	0	\N
249156	1874	200382000	7039	3632	1	0	\N
249157	1678	5040154732000	7040	3633	0	0	\N
249158	1874	200383000	7040	3633	1	0	\N
249166	1874	200386000	7043	3635	0	0	\N
249167	1874	200387000	7043	3635	1	0	\N
249168	1678	5040154735000	7043	3635	2	0	\N
249169	1678	5040154736000	7043	3635	3	0	\N
249180	1678	5040154738000	7047	3637	0	0	\N
249181	1678	5040154739000	7047	3637	1	0	\N
249182	1874	200389000	7047	3637	2	0	\N
249183	1874	200390000	7047	3637	3	0	\N
249184	1678	5040154738000	7048	3637	0	0	\N
249185	1678	5040154739000	7048	3637	1	0	\N
249186	1874	200389000	7048	3637	2	0	\N
249187	1874	200390000	7048	3637	3	0	\N
249192	1678	5040154742000	7051	3640	0	0	\N
249193	1874	200393000	7051	3640	1	0	\N
249194	1678	5040154742000	7052	3640	0	0	\N
249195	1874	200393000	7052	3640	1	0	\N
249198	1678	5040154743000	7054	3641	0	0	\N
249199	1678	5040154744000	7054	3641	1	0	\N
249200	1874	200394000	7054	3641	2	0	\N
249201	1874	200395000	7054	3641	3	0	\N
249210	1874	200398000	7058	3644	0	0	\N
249211	1678	5040154747000	7058	3644	1	0	\N
249220	1874	200402000	7064	3647	0	0	\N
249221	1874	200403000	7064	3647	1	0	\N
249222	1678	5040154751000	7064	3647	2	0	\N
249223	1678	5040154752000	7064	3647	3	0	\N
249228	1874	200404000	7066	3648	0	0	\N
249229	1893	200000000	7066	3648	1	0	\N
249230	1678	5040154753000	7066	3648	2	0	\N
249231	1874	200404000	7067	3648	0	0	\N
249232	1893	200000000	7067	3648	1	0	\N
249233	1678	5040154753000	7067	3648	2	0	\N
249234	1874	200404000	7068	3648	0	0	\N
249235	1893	200000000	7068	3648	1	0	\N
249236	1678	5040154753000	7068	3648	2	0	\N
249237	1874	200370000	7070	3623	0	0	\N
249238	1874	200371000	7070	3623	1	0	\N
249239	1874	200372000	7070	3623	2	0	\N
249240	1874	200373000	7070	3623	3	0	\N
249241	1874	200374000	7070	3623	4	0	\N
249242	1874	200375000	7070	3623	5	0	\N
249243	1874	200376000	7070	3623	6	0	\N
249244	1678	5040154719000	7070	3623	7	0	\N
249245	1678	5040154720000	7070	3623	8	0	\N
249246	1678	5040154721000	7070	3623	9	0	\N
249247	1678	5040154722000	7070	3623	10	0	\N
249248	1678	5040154723000	7070	3623	11	0	\N
249249	1678	5040154724000	7070	3623	12	0	\N
249250	1678	5040154725000	7070	3623	13	0	\N
249251	1678	5040154726000	7070	3623	14	0	\N
249252	1678	5040154727000	7070	3623	15	0	\N
249253	1678	5040154728000	7070	3623	16	0	\N
249254	1678	5040154729000	7070	3623	17	0	\N
249255	1678	5040154730000	7070	3623	18	0	\N
249256	1678	5040154731000	7070	3623	19	0	\N
249257	1678	5040154732000	7070	3623	20	0	\N
249258	1678	5040154733000	7070	3623	21	0	\N
249259	1678	5040154734000	7070	3623	22	0	\N
249260	1678	5040154735000	7070	3623	23	0	\N
249261	1678	5040154736000	7070	3623	24	0	\N
249262	1678	5040154737000	7070	3623	25	0	\N
249263	1678	5040154738000	7070	3623	26	0	\N
249264	1678	5040154739000	7070	3623	27	0	\N
249265	1678	5040154740000	7070	3623	28	0	\N
249266	1678	5040154741000	7070	3623	29	0	\N
249267	1678	5040154742000	7070	3623	30	0	\N
249268	1678	5040154743000	7070	3623	31	0	\N
249269	1678	5040154744000	7070	3623	32	0	\N
249270	1678	5040154745000	7070	3623	33	0	\N
249271	1678	5040154746000	7070	3623	34	0	\N
249272	1678	5040154747000	7070	3623	35	0	\N
249273	1678	5040154748000	7070	3623	36	0	\N
249274	1678	5040154749000	7070	3623	37	0	\N
249275	1678	5040154750000	7070	3623	38	0	\N
249276	1678	5040154751000	7070	3623	39	0	\N
249277	1678	5040154752000	7070	3623	40	0	\N
249278	1874	200377000	7070	3623	41	0	\N
249279	1874	200378000	7070	3623	42	0	\N
249280	1874	200379000	7070	3623	43	0	\N
249281	1874	200380000	7070	3623	44	0	\N
249282	1874	200381000	7070	3623	45	0	\N
249283	1874	200382000	7070	3623	46	0	\N
249284	1874	200383000	7070	3623	47	0	\N
249285	1892	200000000	7070	3623	48	0	\N
249286	1874	200384000	7070	3623	49	0	\N
249287	1874	200385000	7070	3623	50	0	\N
249288	1874	200386000	7070	3623	51	0	\N
249159	1678	5040154732000	7041	3633	0	0	0
249160	1874	200383000	7041	3633	1	0	0
249161	1892	200000000	7042	3634	0	0	0
249162	1678	5040154733000	7042	3634	1	0	0
249163	1678	5040154734000	7042	3634	2	0	0
249165	1874	200385000	7042	3634	5	0	0
249170	1874	200386000	7044	3635	0	0	0
249171	1874	200387000	7044	3635	1	0	0
249172	1678	5040154735000	7044	3635	2	0	0
249173	1678	5040154736000	7044	3635	3	0	0
249175	1678	5040154737000	7045	3636	1	0	0
249176	1678	5040154738000	7046	3637	0	0	0
249177	1678	5040154739000	7046	3637	1	0	0
249178	1874	200389000	7046	3637	2	0	0
249188	1678	5040154740000	7049	3638	0	0	0
249189	1874	200391000	7049	3638	1	0	0
249190	1678	5040154741000	7050	3639	0	0	0
249191	1874	200392000	7050	3639	1	0	0
249196	1678	5040154742000	7053	3640	0	0	0
249202	1678	5040154743000	7055	3641	0	0	0
249203	1678	5040154744000	7055	3641	1	0	0
249204	1874	200394000	7055	3641	2	0	0
249205	1874	200395000	7055	3641	3	0	0
249206	1678	5040154745000	7056	3642	0	0	0
249208	1678	5040154746000	7057	3643	0	0	0
249209	1874	200397000	7057	3643	1	0	0
249212	1874	200398000	7059	3644	0	0	0
249213	1678	5040154747000	7059	3644	1	0	0
249215	1678	5040154749000	7060	3645	1	0	0
249216	1874	200399000	7060	3645	2	0	0
249217	1874	200400000	7060	3645	3	0	0
249218	1874	200401000	7062	3646	0	0	0
249219	1678	5040154750000	7062	3646	1	0	0
249225	1874	200403000	7065	3647	1	0	0
249226	1678	5040154751000	7065	3647	2	0	0
249227	1678	5040154752000	7065	3647	3	0	0
249289	1874	200387000	7070	3623	52	0	\N
249290	1874	200388000	7070	3623	54	0	\N
249291	1874	200389000	7070	3623	55	0	\N
249292	1874	200390000	7070	3623	56	0	\N
249293	1874	200391000	7070	3623	57	0	\N
249294	1874	200392000	7070	3623	58	0	\N
249295	1874	200393000	7070	3623	59	0	\N
249296	1874	200394000	7070	3623	60	0	\N
249297	1874	200395000	7070	3623	61	0	\N
249298	1874	200396000	7070	3623	62	0	\N
249299	1874	200397000	7070	3623	63	0	\N
249300	1874	200398000	7070	3623	64	0	\N
249301	1874	200399000	7070	3623	65	0	\N
249302	1874	200400000	7070	3623	66	0	\N
249303	1874	200401000	7070	3623	67	0	\N
249304	1874	200402000	7070	3623	68	0	\N
249305	1874	200403000	7070	3623	69	0	\N
249306	1874	200404000	7070	3623	70	0	\N
249307	1893	200000000	7070	3623	71	0	\N
249308	1678	5040154753000	7070	3623	72	0	\N
249316	1874	200406000	7073	3651	0	0	\N
249317	1678	5040154756000	7073	3651	1	0	\N
249318	1874	200406000	7074	3651	0	0	\N
249319	1678	5040154756000	7074	3651	1	0	\N
249333	327	66000100000000	7077	3652	0	0	\N
249334	1874	200406000	7077	3652	1	0	\N
249335	1874	200407000	7077	3652	2	0	\N
249336	1874	200408000	7077	3652	3	0	\N
249337	1874	200409000	7077	3652	4	0	\N
249338	1874	200410000	7077	3652	5	0	\N
249339	1874	200411000	7077	3652	6	0	\N
249340	1678	5040154756000	7077	3652	7	0	\N
249341	1678	5040154757000	7077	3652	8	0	\N
249342	1678	5040154758000	7077	3652	9	0	\N
249343	1678	5040154759000	7077	3652	10	0	\N
249344	1678	5040154760000	7077	3652	11	0	\N
249345	1678	5040154761000	7077	3652	12	0	\N
249346	1874	200354000	7078	3614	0	0	\N
249347	1678	5040154703000	7078	3614	1	0	\N
249348	327	66000100000000	7078	3614	2	0	\N
249349	1678	5040154704000	7078	3614	3	0	\N
249350	1678	5040154705000	7078	3614	4	0	\N
249351	1874	200355000	7078	3614	5	0	\N
249352	1874	200356000	7078	3614	6	0	\N
249353	1874	200357000	7078	3614	7	0	\N
249354	1874	200358000	7078	3614	8	0	\N
249355	1874	200359000	7078	3614	9	0	\N
249356	1874	200360000	7078	3614	10	0	\N
249357	1874	200361000	7078	3614	11	0	\N
249358	1874	200362000	7078	3614	12	0	\N
249359	1874	200363000	7078	3614	13	0	\N
249360	1874	200364000	7078	3614	14	0	\N
249361	1678	5040154706000	7078	3614	15	0	\N
249362	1678	5040154707000	7078	3614	16	0	\N
249363	1678	5040154708000	7078	3614	17	0	\N
249364	1678	5040154709000	7078	3614	18	0	\N
249365	1678	5040154710000	7078	3614	19	0	\N
249366	1874	200365000	7078	3614	20	0	\N
249367	1874	200366000	7078	3614	21	0	\N
249368	1874	200367000	7078	3614	22	0	\N
249369	1874	200368000	7078	3614	23	0	\N
249370	1874	200369000	7078	3614	24	0	\N
249371	1678	5040154711000	7078	3614	25	0	\N
249372	1678	5040154712000	7078	3614	26	0	\N
249373	1678	5040154713000	7078	3614	27	0	\N
249374	1678	5040154714000	7078	3614	28	0	\N
249375	1678	5040154715000	7078	3614	29	0	\N
249376	1678	5040154716000	7078	3614	30	0	\N
249377	1678	5040154717000	7078	3614	31	0	\N
249378	1678	5040154718000	7078	3614	32	0	\N
249379	1874	200370000	7078	3614	33	0	\N
249380	1874	200371000	7078	3614	34	0	\N
249381	1874	200372000	7078	3614	35	0	\N
249382	1874	200373000	7078	3614	36	0	\N
249383	1874	200374000	7078	3614	37	0	\N
249384	1874	200375000	7078	3614	38	0	\N
249385	1874	200376000	7078	3614	39	0	\N
249386	1678	5040154719000	7078	3614	40	0	\N
249387	1678	5040154720000	7078	3614	41	0	\N
249388	1678	5040154721000	7078	3614	42	0	\N
249389	1678	5040154722000	7078	3614	43	0	\N
249390	1678	5040154723000	7078	3614	44	0	\N
249391	1678	5040154724000	7078	3614	45	0	\N
249392	1678	5040154725000	7078	3614	46	0	\N
249393	1678	5040154726000	7078	3614	47	0	\N
249394	1678	5040154727000	7078	3614	48	0	\N
249395	1678	5040154728000	7078	3614	49	0	\N
249396	1678	5040154729000	7078	3614	50	0	\N
249397	1678	5040154730000	7078	3614	51	0	\N
249398	1678	5040154731000	7078	3614	52	0	\N
249399	1678	5040154732000	7078	3614	53	0	\N
249400	1678	5040154733000	7078	3614	54	0	\N
249401	1678	5040154734000	7078	3614	55	0	\N
249402	1678	5040154735000	7078	3614	56	0	\N
249403	1678	5040154736000	7078	3614	57	0	\N
249404	1678	5040154737000	7078	3614	58	0	\N
249405	1678	5040154738000	7078	3614	59	0	\N
249406	1678	5040154739000	7078	3614	60	0	\N
249407	1678	5040154740000	7078	3614	61	0	\N
249408	1678	5040154741000	7078	3614	62	0	\N
249409	1678	5040154742000	7078	3614	63	0	\N
249410	1678	5040154743000	7078	3614	64	0	\N
249411	1678	5040154744000	7078	3614	65	0	\N
249412	1678	5040154745000	7078	3614	66	0	\N
249413	1678	5040154746000	7078	3614	67	0	\N
249414	1678	5040154747000	7078	3614	68	0	\N
249415	1678	5040154748000	7078	3614	69	0	\N
249416	1678	5040154749000	7078	3614	70	0	\N
249417	1678	5040154750000	7078	3614	71	0	\N
249418	1678	5040154751000	7078	3614	72	0	\N
249419	1678	5040154752000	7078	3614	73	0	\N
249420	1874	200377000	7078	3614	74	0	\N
249421	1874	200378000	7078	3614	75	0	\N
249422	1874	200379000	7078	3614	76	0	\N
249423	1874	200380000	7078	3614	77	0	\N
249424	1874	200381000	7078	3614	78	0	\N
249311	1894	200000000	7071	3649	2	0	0
249312	1874	200405000	7071	3649	3	0	0
249313	1678	5040154753000	7071	3649	4	0	0
249314	1678	5040154754000	7071	3649	5	0	0
249315	1678	5040154755000	7072	3650	0	0	0
249321	1874	200406000	7076	3652	1	0	0
249322	1874	200407000	7076	3652	2	0	0
249323	1874	200408000	7076	3652	3	0	0
249324	1874	200409000	7076	3652	4	0	0
249325	1874	200410000	7076	3652	5	0	0
249327	1678	5040154756000	7076	3652	7	0	0
249328	1678	5040154757000	7076	3652	8	0	0
249329	1678	5040154758000	7076	3652	9	0	0
249330	1678	5040154759000	7076	3652	10	0	0
249332	1678	5040154761000	7076	3652	12	0	0
249425	1874	200382000	7078	3614	79	0	\N
249426	1874	200383000	7078	3614	80	0	\N
249427	1892	200000000	7078	3614	81	0	\N
249428	1874	200384000	7078	3614	82	0	\N
249429	1874	200385000	7078	3614	83	0	\N
249430	1874	200386000	7078	3614	84	0	\N
249431	1874	200387000	7078	3614	85	0	\N
249432	1874	200388000	7078	3614	86	0	\N
249433	1874	200389000	7078	3614	87	0	\N
249434	1874	200390000	7078	3614	88	0	\N
249435	1874	200391000	7078	3614	89	0	\N
249436	1874	200392000	7078	3614	90	0	\N
249437	1874	200393000	7078	3614	91	0	\N
249438	1874	200394000	7078	3614	92	0	\N
249439	1874	200395000	7078	3614	93	0	\N
249440	1874	200396000	7078	3614	94	0	\N
249441	1874	200397000	7078	3614	95	0	\N
249442	1874	200398000	7078	3614	96	0	\N
249443	1874	200399000	7078	3614	97	0	\N
249444	1874	200400000	7078	3614	98	0	\N
249445	1874	200401000	7078	3614	99	0	\N
249446	1874	200402000	7078	3614	100	0	\N
249447	1874	200403000	7078	3614	101	0	\N
249448	1874	200404000	7078	3614	102	0	\N
249449	1893	200000000	7078	3614	103	0	\N
249450	1894	200000000	7078	3614	105	0	\N
249451	1874	200405000	7078	3614	106	0	\N
249452	1874	200406000	7078	3614	107	0	\N
249453	1874	200407000	7078	3614	108	0	\N
249454	1874	200408000	7078	3614	109	0	\N
249455	1874	200409000	7078	3614	110	0	\N
249456	1874	200410000	7078	3614	111	0	\N
249457	1874	200411000	7078	3614	112	0	\N
249458	1678	5040154753000	7078	3614	113	0	\N
249459	1678	5040154754000	7078	3614	114	0	\N
249460	1678	5040154755000	7078	3614	115	0	\N
249461	1678	5040154756000	7078	3614	116	0	\N
249462	1678	5040154757000	7078	3614	117	0	\N
249463	1678	5040154758000	7078	3614	118	0	\N
249464	1678	5040154759000	7078	3614	119	0	\N
249465	1678	5040154760000	7078	3614	120	0	\N
249466	1678	5040154761000	7078	3614	121	0	\N
249467	544	67439000000000	7078	3614	122	0	\N
249468	1874	200412000	7079	3653	0	0	\N
249469	1678	5040154762000	7079	3653	1	0	\N
249470	1678	5040154763000	7079	3653	2	0	\N
249471	1874	200413000	7079	3653	3	0	\N
249480	1678	5040154766000	7082	3655	0	0	\N
249481	1678	5040154767000	7082	3655	1	0	\N
249482	1874	200416000	7082	3655	2	0	\N
249483	1874	200417000	7082	3655	3	0	\N
249488	1678	5040154766000	7084	3655	0	0	\N
249489	1678	5040154767000	7084	3655	1	0	\N
249490	1874	200416000	7084	3655	2	0	\N
249491	1874	200417000	7084	3655	3	0	\N
249494	1874	200418000	7086	3656	0	0	\N
249495	1678	5040154768000	7086	3656	1	0	\N
249505	1678	5040154773000	7092	3662	0	0	\N
249506	1874	200424000	7092	3662	1	0	\N
249507	1678	5040154774000	7092	3662	2	0	\N
249511	1678	5040154775000	7094	3663	0	0	\N
249514	1678	5040154776000	7096	3664	0	0	\N
249515	1874	200426000	7096	3664	1	0	\N
249516	1678	5040154776000	7097	3664	0	0	\N
249517	1874	200426000	7097	3664	1	0	\N
249520	1874	200427000	7099	3665	0	0	\N
249521	1678	5040154777000	7099	3665	1	0	\N
249522	1874	200427000	7100	3665	0	0	\N
249523	1678	5040154777000	7100	3665	1	0	\N
249526	1874	200427000	7102	3665	0	0	\N
249532	1678	5040154780000	7105	3668	0	0	\N
249533	1874	200431000	7105	3668	1	0	\N
249538	1874	200433000	7108	3670	0	0	\N
249539	1874	200434000	7108	3670	1	0	\N
249540	1678	5040154782000	7108	3670	2	0	\N
249541	1678	5040154783000	7108	3670	3	0	\N
249550	1678	5040154786000	7111	3672	0	0	\N
249551	1678	5040154787000	7111	3672	1	0	\N
249552	1874	200437000	7111	3672	2	0	\N
249553	1874	200438000	7111	3672	3	0	\N
249474	1678	5040154763000	7080	3653	2	0	0
249475	1874	200413000	7080	3653	3	0	0
249476	1874	200414000	7081	3654	0	0	0
249477	1874	200415000	7081	3654	1	0	0
249478	1678	5040154764000	7081	3654	2	0	0
249484	1678	5040154766000	7083	3655	0	0	0
249485	1678	5040154767000	7083	3655	1	0	0
249486	1874	200416000	7083	3655	2	0	0
249487	1874	200417000	7083	3655	3	0	0
249492	1874	200418000	7085	3656	0	0	0
249496	1874	200419000	7087	3657	0	0	0
249497	1678	5040154769000	7087	3657	1	0	0
249498	1678	5040154770000	7088	3658	0	0	0
249499	1874	200420000	7088	3658	1	0	0
249501	1874	200421000	7089	3659	1	0	0
249502	1874	200422000	7090	3660	0	0	0
249503	1678	5040154772000	7090	3660	1	0	0
249504	1874	200423000	7091	3661	0	0	0
249508	1678	5040154773000	7093	3662	0	0	0
249510	1678	5040154774000	7093	3662	2	0	0
249512	1678	5040154775000	7095	3663	0	0	0
249513	1874	200425000	7095	3663	1	0	0
249518	1678	5040154776000	7098	3664	0	0	0
249519	1874	200426000	7098	3664	1	0	0
249525	1678	5040154777000	7101	3665	1	0	0
249527	1678	5040154778000	7103	3666	0	0	0
249528	1874	200428000	7103	3666	1	0	0
249529	1874	200429000	7104	3667	0	0	0
249531	1678	5040154779000	7104	3667	2	0	0
249534	1678	5040154780000	7106	3668	0	0	0
249535	1874	200431000	7106	3668	1	0	0
249536	1678	5040154781000	7107	3669	0	0	0
249537	1874	200432000	7107	3669	1	0	0
249543	1874	200434000	7109	3670	1	0	0
249544	1678	5040154782000	7109	3670	2	0	0
249545	1678	5040154783000	7109	3670	3	0	0
249546	1874	200435000	7110	3671	0	0	0
249547	1874	200436000	7110	3671	1	0	0
249549	1678	5040154785000	7110	3671	3	0	0
249554	1678	5040154786000	7112	3672	0	0	0
249555	1678	5040154787000	7112	3672	1	0	0
249556	1874	200437000	7112	3672	2	0	0
249558	1874	200439000	7113	3673	0	0	0
249559	1874	200440000	7113	3673	1	0	0
249560	1874	200441000	7113	3673	2	0	0
249575	1874	200447000	7117	3677	0	0	\N
249576	1874	200448000	7117	3677	1	0	\N
249577	1874	200449000	7117	3677	2	0	\N
249578	1874	200450000	7117	3677	3	0	\N
249579	1678	5040154796000	7117	3677	4	0	\N
249580	1678	5040154797000	7117	3677	5	0	\N
249581	1678	5040154798000	7117	3677	6	0	\N
249582	1678	5040154799000	7117	3677	7	0	\N
249583	1874	200451000	7117	3677	8	0	\N
249584	1678	5040154800000	7117	3677	9	0	\N
249585	154	66000100000000	7117	3677	10	0	\N
249597	1678	5040154801000	7119	3678	0	0	\N
249598	1874	200452000	7119	3678	1	0	\N
249606	1874	200455000	7122	3680	0	0	\N
249607	1874	200456000	7122	3680	1	0	\N
249608	1678	5040154804000	7122	3680	2	0	\N
249609	1678	5040154805000	7122	3680	3	0	\N
249610	1678	5040154806000	7122	3680	4	0	\N
249611	1874	200457000	7122	3680	5	0	\N
249618	1678	5040154807000	7124	3681	0	0	\N
249619	1874	200458000	7124	3681	1	0	\N
249628	1678	5040154810000	7129	3684	0	0	\N
249629	1874	200461000	7129	3684	1	0	\N
249632	1678	5040154811000	7131	3685	0	0	\N
249633	1874	200462000	7131	3685	1	0	\N
249636	1678	5040154813000	7133	3687	0	0	\N
249637	1874	200464000	7133	3687	1	0	\N
249638	1874	200465000	7133	3687	2	0	\N
249642	1678	5040154813000	7135	3687	0	0	\N
249643	1874	200464000	7135	3687	1	0	\N
249644	1874	200465000	7135	3687	2	0	\N
249645	1874	200466000	7136	3688	0	0	\N
249646	1874	200467000	7136	3688	1	0	\N
249647	1874	200466000	7137	3688	0	0	\N
249648	1874	200467000	7137	3688	1	0	\N
249653	1713	510000000	7142	3691	0	0	\N
249654	1874	200470000	7142	3691	1	0	\N
249655	1874	200471000	7142	3691	2	0	\N
249661	1874	200473000	7146	3693	0	0	\N
249662	1874	200473000	7147	3693	0	0	\N
249663	1897	200000000	7148	3694	0	0	\N
249664	1874	200474000	7148	3694	1	0	\N
249667	1894	200000000	7150	3624	0	0	\N
249668	327	66000100000000	7150	3624	1	0	\N
249669	1874	200405000	7150	3624	2	0	\N
249670	1874	200406000	7150	3624	3	0	\N
249671	1874	200407000	7150	3624	4	0	\N
249672	1874	200408000	7150	3624	5	0	\N
249673	1874	200409000	7150	3624	6	0	\N
249674	1874	200410000	7150	3624	7	0	\N
249675	1874	200411000	7150	3624	8	0	\N
249676	1874	200412000	7150	3624	9	0	\N
249677	1678	5040154754000	7150	3624	10	0	\N
249678	1678	5040154755000	7150	3624	11	0	\N
249679	1678	5040154756000	7150	3624	12	0	\N
249680	1678	5040154757000	7150	3624	13	0	\N
249681	1678	5040154758000	7150	3624	14	0	\N
249682	1678	5040154759000	7150	3624	15	0	\N
249683	1678	5040154760000	7150	3624	16	0	\N
249684	1678	5040154761000	7150	3624	17	0	\N
249685	1678	5040154762000	7150	3624	18	0	\N
249686	1678	5040154763000	7150	3624	19	0	\N
249687	1678	5040154764000	7150	3624	20	0	\N
249688	1678	5040154765000	7150	3624	21	0	\N
249689	1678	5040154766000	7150	3624	22	0	\N
249690	1678	5040154767000	7150	3624	23	0	\N
249691	1678	5040154768000	7150	3624	24	0	\N
249692	1678	5040154769000	7150	3624	25	0	\N
249693	1678	5040154770000	7150	3624	26	0	\N
249694	1678	5040154771000	7150	3624	27	0	\N
249695	1678	5040154772000	7150	3624	28	0	\N
249696	1678	5040154773000	7150	3624	29	0	\N
249563	1678	5040154790000	7113	3673	5	0	0
249564	1874	200442000	7114	3674	0	0	0
249565	1895	200000000	7114	3674	1	0	0
249566	1678	5040154791000	7114	3674	2	0	0
249567	1874	200443000	7115	3675	0	0	0
249569	1678	5040154792000	7115	3675	2	0	0
249570	1678	5040154793000	7115	3675	3	0	0
249571	1678	5040154794000	7116	3676	0	0	0
249572	1678	5040154795000	7116	3676	1	0	0
249573	1874	200445000	7116	3676	2	0	0
249586	1874	200447000	7118	3677	0	0	0
249587	1874	200448000	7118	3677	1	0	0
249588	1874	200449000	7118	3677	2	0	0
249589	1874	200450000	7118	3677	3	0	0
249591	1678	5040154797000	7118	3677	5	0	0
249592	1678	5040154798000	7118	3677	6	0	0
249593	1678	5040154799000	7118	3677	7	0	0
249594	1874	200451000	7118	3677	8	0	0
249595	1678	5040154800000	7118	3677	9	0	0
249599	1678	5040154801000	7120	3678	0	0	0
249600	1874	200452000	7120	3678	1	0	0
249601	1678	5040154802000	7121	3679	0	0	0
249602	1678	5040154803000	7121	3679	1	0	0
249603	1874	200453000	7121	3679	2	0	0
249605	1874	200454000	7121	3679	4	0	0
249612	1874	200455000	7123	3680	0	0	0
249613	1874	200456000	7123	3680	1	0	0
249614	1678	5040154804000	7123	3680	2	0	0
249616	1678	5040154806000	7123	3680	4	0	0
249617	1874	200457000	7123	3680	5	0	0
249620	1678	5040154807000	7125	3681	0	0	0
249621	1874	200458000	7125	3681	1	0	0
249622	1678	5040154808000	7126	3682	0	0	0
249624	1874	200460000	7127	3683	0	0	0
249625	1678	5040154809000	7127	3683	1	0	0
249626	1678	5040154810000	7128	3684	0	0	0
249627	1874	200461000	7128	3684	1	0	0
249630	1678	5040154811000	7130	3685	0	0	0
249634	1678	5040154812000	7132	3686	0	0	0
249635	1874	200463000	7132	3686	1	0	0
249639	1678	5040154813000	7134	3687	0	0	0
249640	1874	200464000	7134	3687	1	0	0
249649	1874	200466000	7138	3688	0	0	0
249650	1874	200467000	7138	3688	1	0	0
249651	1874	200468000	7139	3689	0	0	0
249652	1874	200469000	7141	3690	0	0	0
249656	1713	510000000	7143	3691	0	0	0
249658	1874	200471000	7143	3691	2	0	0
249659	1874	200472000	7144	3692	0	0	0
249660	1874	200473000	7145	3693	0	0	0
249665	1897	200000000	7149	3694	0	0	0
249666	1874	200474000	7149	3694	1	0	0
249697	1678	5040154774000	7150	3624	30	0	\N
249698	1678	5040154775000	7150	3624	31	0	\N
249699	1678	5040154776000	7150	3624	32	0	\N
249700	1874	200413000	7150	3624	33	0	\N
249701	1874	200414000	7150	3624	34	0	\N
249702	1874	200415000	7150	3624	35	0	\N
249703	1874	200416000	7150	3624	36	0	\N
249704	1874	200417000	7150	3624	37	0	\N
249705	1874	200418000	7150	3624	38	0	\N
249706	1874	200419000	7150	3624	39	0	\N
249707	1874	200420000	7150	3624	40	0	\N
249708	1874	200421000	7150	3624	41	0	\N
249709	1874	200422000	7150	3624	42	0	\N
249710	1874	200423000	7150	3624	43	0	\N
249711	1874	200424000	7150	3624	44	0	\N
249712	1874	200425000	7150	3624	45	0	\N
249713	1874	200426000	7150	3624	46	0	\N
249714	1874	200427000	7150	3624	47	0	\N
249715	1874	200428000	7150	3624	48	0	\N
249716	1874	200429000	7150	3624	49	0	\N
249717	1874	200430000	7150	3624	50	0	\N
249718	1678	5040154777000	7150	3624	51	0	\N
249719	1678	5040154778000	7150	3624	52	0	\N
249720	1678	5040154779000	7150	3624	53	0	\N
249721	1678	5040154780000	7150	3624	54	0	\N
249722	1678	5040154781000	7150	3624	55	0	\N
249723	1678	5040154782000	7150	3624	56	0	\N
249724	1678	5040154783000	7150	3624	57	0	\N
249725	1678	5040154784000	7150	3624	58	0	\N
249726	1678	5040154785000	7150	3624	59	0	\N
249727	1678	5040154786000	7150	3624	60	0	\N
249728	1678	5040154787000	7150	3624	61	0	\N
249729	1678	5040154788000	7150	3624	62	0	\N
249730	1678	5040154789000	7150	3624	63	0	\N
249731	1678	5040154790000	7150	3624	64	0	\N
249732	1678	5040154791000	7150	3624	65	0	\N
249733	1678	5040154792000	7150	3624	66	0	\N
249734	1678	5040154793000	7150	3624	67	0	\N
249735	1678	5040154794000	7150	3624	68	0	\N
249736	1678	5040154795000	7150	3624	69	0	\N
249737	1678	5040154796000	7150	3624	70	0	\N
249738	1678	5040154797000	7150	3624	71	0	\N
249739	1678	5040154798000	7150	3624	72	0	\N
249740	1678	5040154799000	7150	3624	73	0	\N
249741	1678	5040154800000	7150	3624	74	0	\N
249742	1678	5040154801000	7150	3624	75	0	\N
249743	1678	5040154802000	7150	3624	76	0	\N
249744	1678	5040154803000	7150	3624	77	0	\N
249745	1678	5040154804000	7150	3624	78	0	\N
249746	1678	5040154805000	7150	3624	79	0	\N
249747	1678	5040154806000	7150	3624	80	0	\N
249748	1678	5040154807000	7150	3624	81	0	\N
249749	1678	5040154808000	7150	3624	82	0	\N
249750	1678	5040154809000	7150	3624	83	0	\N
249751	1678	5040154810000	7150	3624	84	0	\N
249752	1678	5040154811000	7150	3624	85	0	\N
249753	1678	5040154812000	7150	3624	86	0	\N
249754	1678	5040154813000	7150	3624	87	0	\N
249755	154	66000100000000	7150	3624	88	0	\N
249756	1874	200431000	7150	3624	89	0	\N
249757	1874	200432000	7150	3624	90	0	\N
249758	1874	200433000	7150	3624	91	0	\N
249759	1874	200434000	7150	3624	92	0	\N
249760	1874	200435000	7150	3624	93	0	\N
249761	1874	200436000	7150	3624	94	0	\N
249762	1874	200437000	7150	3624	95	0	\N
249763	1874	200438000	7150	3624	96	0	\N
249764	1874	200439000	7150	3624	97	0	\N
249765	1874	200440000	7150	3624	98	0	\N
249766	1874	200441000	7150	3624	99	0	\N
249767	1874	200442000	7150	3624	100	0	\N
249768	1895	200000000	7150	3624	101	0	\N
249769	1874	200443000	7150	3624	102	0	\N
249770	1874	200444000	7150	3624	103	0	\N
249771	1874	200445000	7150	3624	104	0	\N
249772	1874	200446000	7150	3624	105	0	\N
249773	1874	200447000	7150	3624	107	0	\N
249774	1874	200448000	7150	3624	108	0	\N
249775	1874	200449000	7150	3624	109	0	\N
249776	1874	200450000	7150	3624	110	0	\N
249777	1874	200451000	7150	3624	111	0	\N
249778	1874	200452000	7150	3624	112	0	\N
249779	1874	200453000	7150	3624	113	0	\N
249780	1896	200000000	7150	3624	114	0	\N
249781	1874	200454000	7150	3624	115	0	\N
249782	1874	200455000	7150	3624	116	0	\N
249783	1874	200456000	7150	3624	117	0	\N
249784	1874	200457000	7150	3624	118	0	\N
249785	1874	200458000	7150	3624	119	0	\N
249786	1874	200459000	7150	3624	120	0	\N
249787	1874	200460000	7150	3624	121	0	\N
249788	1874	200461000	7150	3624	122	0	\N
249789	1874	200462000	7150	3624	123	0	\N
249790	1874	200463000	7150	3624	124	0	\N
249791	1874	200464000	7150	3624	125	0	\N
249796	1874	200477000	7153	3696	0	0	\N
249797	1874	200478000	7153	3696	1	0	\N
249799	1874	200479000	7155	3697	0	0	\N
249800	1874	200479000	7156	3697	0	0	\N
249801	1898	0	7157	3698	0	0	\N
249802	1874	200480000	7157	3698	1	0	\N
249803	1874	200481000	7157	3698	2	0	\N
249804	1898	0	7158	3698	0	0	\N
249805	1874	200480000	7158	3698	1	0	\N
249806	1874	200481000	7158	3698	2	0	\N
249807	1898	0	7159	3698	0	0	\N
249808	1874	200480000	7159	3698	1	0	\N
249809	1874	200481000	7159	3698	2	0	\N
249813	1898	0	7161	3698	0	0	\N
249814	1874	200480000	7161	3698	1	0	\N
249815	1874	200481000	7161	3698	2	0	\N
249818	1874	200483000	7164	3700	0	0	\N
249820	1874	200484000	7166	3701	0	0	\N
249821	1874	200484000	7167	3701	0	0	\N
249823	1874	200485000	7169	3702	0	0	\N
249824	1874	200486000	7170	3703	0	0	\N
249794	1874	200477000	7152	3696	0	0	0
249795	1874	200478000	7152	3696	1	0	0
249798	1874	200479000	7154	3697	0	0	0
249810	1898	0	7160	3698	0	0	0
249811	1874	200480000	7160	3698	1	0	0
249816	1874	200482000	7162	3699	0	0	0
249817	1874	200483000	7163	3700	0	0	0
249819	1874	200484000	7165	3701	0	0	0
249822	1874	200485000	7168	3702	0	0	0
249825	1874	200486000	7171	3703	0	0	0
249827	1874	200488000	7172	3704	1	0	0
249828	1874	200489000	7172	3704	2	0	0
249829	1874	200490000	7172	3704	3	0	0
249830	1483	0	7172	3704	4	0	0
249832	1874	200492000	7173	3705	1	0	0
249833	1874	200491000	7174	3705	0	0	\N
249834	1874	200492000	7174	3705	1	0	\N
249838	1874	200496000	7176	3707	0	0	\N
249840	1874	200496000	7178	3707	0	0	\N
249841	1874	200496000	7179	3707	0	0	\N
249850	1874	200504000	7188	3715	0	0	\N
249855	1874	200509000	7192	3719	0	0	\N
249856	1874	200510000	7192	3719	2	0	\N
249857	1874	200509000	7193	3719	0	0	\N
249858	1874	200510000	7193	3719	2	0	\N
249865	1874	200513000	7197	3721	0	0	\N
249866	1874	200514000	7197	3721	1	0	\N
249867	1874	200511000	7198	3720	0	0	\N
249868	1874	200512000	7198	3720	1	0	\N
249869	1874	200513000	7198	3720	2	0	\N
249870	1874	200514000	7198	3720	3	0	\N
249871	1874	200515000	7199	3722	0	0	\N
249872	1874	200515000	7200	3722	0	0	\N
249874	1874	200516000	7202	3723	0	0	\N
249875	1874	200517000	7202	3723	1	0	\N
249876	1874	200516000	7203	3723	0	0	\N
249877	1874	200517000	7203	3723	1	0	\N
249878	1874	200516000	7204	3723	0	0	\N
249879	1874	200517000	7204	3723	1	0	\N
249887	1874	200522000	7209	3726	0	0	\N
249890	1874	200524000	7212	3728	0	0	\N
249893	1874	200527000	7215	3731	0	0	\N
249894	1874	200528000	7215	3731	1	0	\N
249895	1874	200529000	7215	3731	2	0	\N
249900	1874	200530000	7218	3732	0	0	\N
249901	1874	200531000	7219	3733	0	0	\N
249902	1874	200531000	7220	3733	0	0	\N
249903	1874	200531000	7221	3733	0	0	\N
249905	1483	0	7223	3734	0	0	\N
249906	1874	200532000	7223	3734	1	0	\N
249907	1483	0	7224	3734	0	0	\N
249908	1874	200532000	7224	3734	1	0	\N
249913	1874	200535000	7228	3737	0	0	\N
249915	1874	200357000	7230	3616	0	0	\N
249916	327	66000100000000	7230	3616	1	0	\N
249917	1874	200358000	7230	3616	2	0	\N
249918	1874	200359000	7230	3616	3	0	\N
249919	1874	200360000	7230	3616	4	0	\N
249920	1874	200361000	7230	3616	5	0	\N
249921	1874	200362000	7230	3616	6	0	\N
249922	1874	200363000	7230	3616	7	0	\N
249923	1874	200364000	7230	3616	8	0	\N
249924	1678	5040154706000	7230	3616	9	0	\N
249925	1678	5040154707000	7230	3616	10	0	\N
249926	1678	5040154708000	7230	3616	11	0	\N
249927	1678	5040154709000	7230	3616	12	0	\N
249928	1678	5040154710000	7230	3616	13	0	\N
249929	1874	200365000	7230	3616	14	0	\N
249930	1874	200366000	7230	3616	15	0	\N
249931	1874	200367000	7230	3616	16	0	\N
249932	1874	200368000	7230	3616	17	0	\N
249933	1874	200369000	7230	3616	18	0	\N
249934	1678	5040154711000	7230	3616	19	0	\N
249935	1678	5040154712000	7230	3616	20	0	\N
249936	1678	5040154713000	7230	3616	21	0	\N
249937	1678	5040154714000	7230	3616	22	0	\N
249938	1678	5040154715000	7230	3616	23	0	\N
249939	1678	5040154716000	7230	3616	24	0	\N
249940	1678	5040154717000	7230	3616	25	0	\N
249941	1678	5040154718000	7230	3616	26	0	\N
249942	1874	200370000	7230	3616	27	0	\N
249943	1874	200371000	7230	3616	28	0	\N
249944	1874	200372000	7230	3616	29	0	\N
249945	1874	200373000	7230	3616	30	0	\N
249946	1874	200374000	7230	3616	31	0	\N
249947	1874	200375000	7230	3616	32	0	\N
249948	1874	200376000	7230	3616	33	0	\N
249949	1678	5040154719000	7230	3616	34	0	\N
249950	1678	5040154720000	7230	3616	35	0	\N
249951	1678	5040154721000	7230	3616	36	0	\N
249952	1678	5040154722000	7230	3616	37	0	\N
249953	1678	5040154723000	7230	3616	38	0	\N
249954	1678	5040154724000	7230	3616	39	0	\N
249955	1678	5040154725000	7230	3616	40	0	\N
249956	1678	5040154726000	7230	3616	41	0	\N
249957	1678	5040154727000	7230	3616	42	0	\N
249958	1678	5040154728000	7230	3616	43	0	\N
249959	1678	5040154729000	7230	3616	44	0	\N
249960	1678	5040154730000	7230	3616	45	0	\N
249961	1678	5040154731000	7230	3616	46	0	\N
249962	1678	5040154732000	7230	3616	47	0	\N
249963	1678	5040154733000	7230	3616	48	0	\N
249964	1678	5040154734000	7230	3616	49	0	\N
249965	1678	5040154735000	7230	3616	50	0	\N
249966	1678	5040154736000	7230	3616	51	0	\N
249967	1678	5040154737000	7230	3616	52	0	\N
249968	1678	5040154738000	7230	3616	53	0	\N
249837	1874	200495000	7175	3706	2	0	0
249839	1874	200496000	7177	3707	0	0	0
249842	1874	200497000	7180	3708	0	0	0
249843	1874	200498000	7181	3709	0	0	0
249844	1874	200499000	7182	3710	0	0	0
249846	1874	200501000	7184	3712	0	0	0
249847	1874	200502000	7185	3713	0	0	0
249848	1874	200503000	7186	3714	0	0	0
249849	1874	200504000	7187	3715	0	0	0
249851	1874	200505000	7189	3716	0	0	0
249853	1874	200507000	7191	3718	0	0	0
249854	1874	200508000	7191	3718	1	0	0
249859	1874	200509000	7194	3719	0	0	0
249860	1874	200510000	7194	3719	2	0	0
249862	1874	200512000	7195	3720	1	0	0
249863	1874	200513000	7196	3721	0	0	0
249864	1874	200514000	7196	3721	1	0	0
249873	1874	200515000	7201	3722	0	0	0
249880	1874	200516000	7205	3723	0	0	0
249882	1874	200518000	7206	3724	0	0	0
249883	1874	200519000	7207	3725	0	0	0
249884	1874	200520000	7207	3725	1	0	0
249885	1874	200521000	7207	3725	2	0	0
249886	1874	200522000	7208	3726	0	0	0
249889	1874	200524000	7211	3728	0	0	0
249891	1874	200525000	7213	3729	0	0	0
249892	1874	200526000	7214	3730	0	0	0
249896	1874	200527000	7216	3731	0	0	0
249898	1874	200529000	7216	3731	2	0	0
249899	1874	200530000	7217	3732	0	0	0
249904	1874	200531000	7222	3733	0	0	0
249909	1483	0	7225	3734	0	0	0
249910	1874	200532000	7225	3734	1	0	0
249912	1874	200534000	7227	3736	0	0	0
249914	1874	200535000	7229	3737	0	0	0
249969	1678	5040154739000	7230	3616	54	0	\N
249970	1678	5040154740000	7230	3616	55	0	\N
249971	1678	5040154741000	7230	3616	56	0	\N
249972	1678	5040154742000	7230	3616	57	0	\N
249973	1678	5040154743000	7230	3616	58	0	\N
249974	1678	5040154744000	7230	3616	59	0	\N
249975	1678	5040154745000	7230	3616	60	0	\N
249976	1678	5040154746000	7230	3616	61	0	\N
249977	1678	5040154747000	7230	3616	62	0	\N
249978	1678	5040154748000	7230	3616	63	0	\N
249979	1678	5040154749000	7230	3616	64	0	\N
249980	1678	5040154750000	7230	3616	65	0	\N
249981	1678	5040154751000	7230	3616	66	0	\N
249982	1678	5040154752000	7230	3616	67	0	\N
249983	1874	200377000	7230	3616	68	0	\N
249984	1874	200378000	7230	3616	69	0	\N
249985	1874	200379000	7230	3616	70	0	\N
249986	1874	200380000	7230	3616	71	0	\N
249987	1874	200381000	7230	3616	72	0	\N
249988	1874	200382000	7230	3616	73	0	\N
249989	1874	200383000	7230	3616	74	0	\N
249990	1892	200000000	7230	3616	75	0	\N
249991	1874	200384000	7230	3616	76	0	\N
249992	1874	200385000	7230	3616	77	0	\N
249993	1874	200386000	7230	3616	78	0	\N
249994	1874	200387000	7230	3616	79	0	\N
249995	1874	200388000	7230	3616	80	0	\N
249996	1874	200389000	7230	3616	81	0	\N
249997	1874	200390000	7230	3616	82	0	\N
249998	1874	200391000	7230	3616	83	0	\N
249999	1874	200392000	7230	3616	84	0	\N
250000	1874	200393000	7230	3616	85	0	\N
250001	1874	200394000	7230	3616	86	0	\N
250002	1874	200395000	7230	3616	87	0	\N
250003	1874	200396000	7230	3616	88	0	\N
250004	1874	200397000	7230	3616	89	0	\N
250005	1874	200398000	7230	3616	90	0	\N
250006	1874	200399000	7230	3616	91	0	\N
250007	1874	200400000	7230	3616	92	0	\N
250008	1874	200401000	7230	3616	94	0	\N
250009	1874	200402000	7230	3616	95	0	\N
250010	1874	200403000	7230	3616	96	0	\N
250011	1874	200404000	7230	3616	97	0	\N
250012	1893	200000000	7230	3616	98	0	\N
250013	1894	200000000	7230	3616	99	0	\N
250014	1874	200405000	7230	3616	100	0	\N
250015	1874	200406000	7230	3616	101	0	\N
250016	1874	200407000	7230	3616	102	0	\N
250017	1874	200408000	7230	3616	103	0	\N
250018	1874	200409000	7230	3616	104	0	\N
250019	1874	200410000	7230	3616	105	0	\N
250020	1874	200411000	7230	3616	106	0	\N
250021	1678	5040154753000	7230	3616	107	0	\N
250022	1678	5040154754000	7230	3616	108	0	\N
250023	1678	5040154755000	7230	3616	109	0	\N
250024	1678	5040154756000	7230	3616	110	0	\N
250025	1678	5040154757000	7230	3616	111	0	\N
250026	1678	5040154758000	7230	3616	112	0	\N
250027	1678	5040154759000	7230	3616	113	0	\N
250028	1678	5040154760000	7230	3616	114	0	\N
250029	1678	5040154761000	7230	3616	115	0	\N
250030	1874	200536000	7231	3738	0	0	\N
250031	1874	200537000	7231	3738	1	0	\N
250034	1874	200538000	7233	3739	0	0	\N
250038	1874	200539000	7236	3740	0	0	\N
250039	1874	200540000	7236	3740	1	0	\N
250040	1874	200541000	7237	3741	0	0	\N
250041	1874	200541000	7238	3741	0	0	\N
250044	1874	200542000	7241	3742	0	0	\N
250045	1874	200543000	7243	3744	0	0	\N
250046	1874	200544000	7243	3744	1	0	\N
250047	1874	200545000	7243	3744	2	0	\N
250055	1874	200550000	7248	3748	0	0	\N
250056	1874	200551000	7248	3748	1	0	\N
250059	1874	200552000	7250	3749	0	0	\N
250062	1874	200554000	7253	3751	0	0	\N
250066	1874	200556000	7257	3753	0	0	\N
250069	1898	0	7260	3677	0	0	\N
250070	1483	0	7260	3677	1	0	\N
250071	1874	200447000	7260	3677	2	0	\N
250072	1874	200448000	7260	3677	3	0	\N
250073	1874	200449000	7260	3677	4	0	\N
250074	1874	200450000	7260	3677	5	0	\N
250075	1678	5040154796000	7260	3677	6	0	\N
250076	1678	5040154797000	7260	3677	7	0	\N
250077	1678	5040154798000	7260	3677	8	0	\N
250078	1678	5040154799000	7260	3677	9	0	\N
250079	1874	200451000	7260	3677	10	0	\N
250080	1874	200452000	7260	3677	11	0	\N
250081	1678	5040154800000	7260	3677	12	0	\N
250082	1678	5040154801000	7260	3677	13	0	\N
250083	1678	5040154802000	7260	3677	14	0	\N
250084	1678	5040154803000	7260	3677	15	0	\N
250085	1678	5040154804000	7260	3677	16	0	\N
250086	1678	5040154805000	7260	3677	17	0	\N
250087	1678	5040154806000	7260	3677	18	0	\N
250088	1678	5040154807000	7260	3677	19	0	\N
250089	1678	5040154808000	7260	3677	20	0	\N
250090	1678	5040154809000	7260	3677	21	0	\N
250091	1678	5040154810000	7260	3677	22	0	\N
250092	1678	5040154811000	7260	3677	23	0	\N
250093	1678	5040154812000	7260	3677	24	0	\N
250094	1678	5040154813000	7260	3677	25	0	\N
250095	1874	200453000	7260	3677	26	0	\N
250096	1896	200000000	7260	3677	27	0	\N
250097	1874	200454000	7260	3677	28	0	\N
250098	1874	200455000	7260	3677	29	0	\N
250099	1874	200456000	7260	3677	30	0	\N
250100	1874	200457000	7260	3677	31	0	\N
250101	1874	200458000	7260	3677	32	0	\N
250102	1874	200459000	7260	3677	33	0	\N
250103	1874	200460000	7260	3677	34	0	\N
250104	1874	200461000	7260	3677	35	0	\N
250035	1874	200538000	7234	3739	0	0	0
250036	1874	200539000	7235	3740	0	0	0
250037	1874	200540000	7235	3740	1	0	0
250042	1874	200541000	7239	3741	0	0	0
250043	1874	200542000	7240	3742	0	0	0
250049	1874	200544000	7244	3744	1	0	0
250050	1874	200545000	7244	3744	2	0	0
250051	1874	200546000	7245	3745	0	0	0
250052	1874	200547000	7245	3745	1	0	0
250053	1874	200548000	7246	3746	0	0	0
250057	1874	200550000	7249	3748	0	0	0
250058	1874	200551000	7249	3748	1	0	0
250060	1874	200552000	7251	3749	0	0	0
250061	1874	200553000	7252	3750	0	0	0
250064	1874	200555000	7255	3752	0	0	0
250065	1874	200556000	7256	3753	0	0	0
250067	1874	200557000	7258	3754	0	0	0
250068	1874	200558000	7259	3755	0	0	0
250105	1874	200462000	7260	3677	36	0	\N
250106	1874	200463000	7260	3677	37	0	\N
250107	1874	200464000	7260	3677	38	0	\N
250108	1874	200465000	7260	3677	39	0	\N
250109	1874	200466000	7260	3677	40	0	\N
250110	1874	200467000	7260	3677	41	0	\N
250111	1874	200468000	7260	3677	42	0	\N
250112	1874	200469000	7260	3677	44	0	\N
250113	1874	200470000	7260	3677	45	0	\N
250114	154	66000100000000	7260	3677	46	0	\N
250115	1874	200471000	7260	3677	47	0	\N
250116	1874	200472000	7260	3677	48	0	\N
250117	1874	200473000	7260	3677	49	0	\N
250118	1897	200000000	7260	3677	50	0	\N
250119	1874	200474000	7260	3677	51	0	\N
250120	1874	200475000	7260	3677	52	0	\N
250121	1874	200476000	7260	3677	53	0	\N
250122	1874	200477000	7260	3677	54	0	\N
250123	1874	200478000	7260	3677	55	0	\N
250124	1874	200479000	7260	3677	56	0	\N
250125	1874	200480000	7260	3677	57	0	\N
250126	1874	200481000	7260	3677	58	0	\N
250127	1874	200482000	7260	3677	59	0	\N
250128	1874	200483000	7260	3677	60	0	\N
250129	1874	200484000	7260	3677	61	0	\N
250130	1874	200485000	7260	3677	62	0	\N
250131	1874	200486000	7260	3677	63	0	\N
250132	1874	200487000	7260	3677	64	0	\N
250133	1874	200488000	7260	3677	65	0	\N
250134	1874	200489000	7260	3677	66	0	\N
250135	1874	200490000	7260	3677	67	0	\N
250136	1874	200491000	7260	3677	68	0	\N
250137	1874	200492000	7260	3677	69	0	\N
250138	1874	200493000	7260	3677	70	0	\N
250139	1874	200494000	7260	3677	71	0	\N
250140	1874	200495000	7260	3677	72	0	\N
250141	1874	200496000	7260	3677	73	0	\N
250142	1874	200497000	7260	3677	74	0	\N
250143	1874	200498000	7260	3677	75	0	\N
250144	1874	200499000	7260	3677	76	0	\N
250145	1874	200500000	7260	3677	77	0	\N
250146	1874	200501000	7260	3677	78	0	\N
250147	1874	200502000	7260	3677	79	0	\N
250148	1874	200503000	7260	3677	80	0	\N
250149	1874	200504000	7260	3677	81	0	\N
250150	1874	200505000	7260	3677	82	0	\N
250151	1874	200506000	7260	3677	83	0	\N
250152	1874	200507000	7260	3677	84	0	\N
250153	1874	200508000	7260	3677	85	0	\N
250154	1874	200509000	7260	3677	86	0	\N
250155	1874	200510000	7260	3677	87	0	\N
250156	1874	200511000	7260	3677	88	0	\N
250157	1874	200512000	7260	3677	89	0	\N
250158	1874	200513000	7260	3677	90	0	\N
250159	1874	200514000	7260	3677	91	0	\N
250160	1874	200515000	7260	3677	92	0	\N
250161	1874	200516000	7260	3677	93	0	\N
250162	1874	200517000	7260	3677	94	0	\N
250163	1874	200518000	7260	3677	95	0	\N
250164	1874	200519000	7260	3677	96	0	\N
250165	1874	200520000	7260	3677	97	0	\N
250166	1874	200521000	7260	3677	98	0	\N
250167	1874	200522000	7260	3677	99	0	\N
250168	1874	200523000	7260	3677	100	0	\N
250169	1874	200524000	7260	3677	101	0	\N
250170	1874	200525000	7260	3677	102	0	\N
250171	1874	200526000	7260	3677	103	0	\N
250172	1874	200527000	7260	3677	104	0	\N
250173	1874	200528000	7260	3677	105	0	\N
250174	1874	200529000	7260	3677	106	0	\N
250175	1874	200530000	7260	3677	107	0	\N
250176	1874	200531000	7260	3677	108	0	\N
250177	1874	200532000	7260	3677	109	0	\N
250178	1874	200533000	7260	3677	110	0	\N
250179	1874	200534000	7260	3677	111	0	\N
250180	1874	200535000	7260	3677	112	0	\N
250181	1874	200536000	7260	3677	113	0	\N
250182	1874	200537000	7260	3677	114	0	\N
250183	1874	200538000	7260	3677	115	0	\N
250184	1874	200539000	7260	3677	116	0	\N
250185	1874	200540000	7260	3677	117	0	\N
250186	1874	200541000	7260	3677	118	0	\N
250187	1874	200542000	7260	3677	119	0	\N
250188	1874	200543000	7260	3677	120	0	\N
250189	1874	200544000	7260	3677	121	0	\N
250190	1874	200545000	7260	3677	122	0	\N
250191	1874	200546000	7260	3677	123	0	\N
250192	1874	200547000	7260	3677	124	0	\N
250193	1874	200548000	7260	3677	125	0	\N
250197	1874	200562000	7262	3757	0	0	\N
250199	1874	200562000	7264	3757	0	0	\N
250200	1874	200562000	7265	3757	0	0	\N
250201	1874	200562000	7266	3757	0	0	\N
250202	1874	200562000	7267	3757	0	0	\N
250203	1874	200563000	7268	3758	0	0	\N
250204	1874	200563000	7269	3758	0	0	\N
250208	1874	200566000	7272	3760	0	0	\N
250212	1874	200569000	7275	3762	0	0	\N
250213	1874	200569000	7276	3762	0	0	\N
250214	1874	200569000	7277	3762	0	0	\N
250215	1874	200569000	7280	3763	0	0	\N
250216	1874	200570000	7280	3763	1	0	\N
250219	1874	200571000	7282	3764	0	0	\N
250223	1874	200574000	7285	3766	0	0	\N
250227	1874	200575000	7288	3767	0	0	\N
250228	1874	200576000	7288	3767	1	0	\N
250229	1874	200577000	7289	3768	0	0	\N
250231	1874	200578000	7291	3769	0	0	\N
250233	1874	200579000	7293	3770	0	0	\N
250234	1874	200580000	7293	3770	1	0	\N
250237	1874	200579000	7295	3770	0	0	\N
250238	1874	200580000	7295	3770	1	0	\N
250196	1874	200561000	7261	3756	2	0	0
250198	1874	200562000	7263	3757	0	0	0
250205	1874	200563000	7270	3758	0	0	0
250206	1874	200564000	7271	3759	0	0	0
250207	1874	200565000	7271	3759	1	0	0
250210	1874	200567000	7274	3761	0	0	0
250211	1874	200568000	7274	3761	1	0	0
250217	1874	200569000	7281	3763	0	0	0
250218	1874	200570000	7281	3763	1	0	0
250220	1874	200571000	7283	3764	0	0	0
250222	1874	200573000	7284	3765	1	0	0
250224	1874	200574000	7286	3766	0	0	0
250225	1874	200575000	7287	3767	0	0	0
250226	1874	200576000	7287	3767	1	0	0
250232	1874	200578000	7292	3769	0	0	0
250235	1874	200579000	7294	3770	0	0	0
250236	1874	200580000	7294	3770	1	0	0
250239	1874	200581000	7298	3771	0	0	0
250240	1874	200582000	7298	3771	1	0	0
250242	1874	200581000	7300	3771	0	0	\N
250243	1874	200582000	7300	3771	1	0	\N
250244	1874	200583000	7300	3771	2	0	\N
250246	1874	200585000	7302	3773	0	0	\N
250247	1874	200586000	7302	3773	1	0	\N
250248	1874	200587000	7302	3773	2	0	\N
250249	1874	200588000	7302	3773	3	0	\N
250250	1874	200589000	7302	3773	4	0	\N
250256	1874	200590000	7304	3774	0	0	\N
250257	1874	200590000	7306	3775	0	0	\N
250258	1874	200591000	7306	3775	1	0	\N
250268	1874	200596000	7311	3778	1	0	\N
250269	1874	200597000	7311	3778	2	0	\N
250270	1874	200598000	7311	3778	3	0	\N
250271	1874	200599000	7312	3779	0	0	\N
250274	1874	200601000	7315	3781	0	0	\N
250275	1874	200602000	7315	3781	1	0	\N
250281	1874	200603000	7318	3782	0	0	\N
250282	1874	200604000	7318	3782	1	0	\N
250283	1874	200605000	7318	3782	2	0	\N
250285	1874	200606000	7320	3783	0	0	\N
250288	1874	200608000	7323	3785	0	0	\N
250289	1874	200608000	7324	3785	0	0	\N
250291	1874	200610000	7326	3787	0	0	\N
250293	1874	200611000	7328	3788	0	0	\N
250295	1874	200611000	7330	3788	0	0	\N
250297	1874	200612000	7333	3789	0	0	\N
250299	1299	1698983378602650	7335	3791	0	0	\N
250300	1053	903634158149000	7335	3791	1	0	\N
250301	1173	609699822388700	7335	3791	2	0	\N
250302	933	504262795497600	7335	3791	3	0	\N
250303	1874	200614000	7335	3791	4	0	\N
250309	1299	1698983378602650	7337	3791	0	0	\N
250310	1053	903634158149000	7337	3791	1	0	\N
250311	1173	609699822388700	7337	3791	2	0	\N
250312	933	504262795497600	7337	3791	3	0	\N
250313	1874	200614000	7337	3791	4	0	\N
250318	1483	0	7340	3700	0	0	\N
250319	1299	1698983378602650	7340	3700	1	0	\N
250320	1053	903634158149000	7340	3700	2	0	\N
250321	1173	609699822388700	7340	3700	3	0	\N
250322	933	504262795497600	7340	3700	4	0	\N
250323	1898	0	7341	3695	0	0	\N
250324	1483	0	7341	3695	1	0	\N
250325	1299	1698983378602650	7341	3695	2	0	\N
250326	1053	903634158149000	7341	3695	3	0	\N
250327	1173	609699822388700	7341	3695	4	0	\N
250328	933	504262795497600	7341	3695	5	0	\N
250329	1874	200475000	7341	3695	6	0	\N
250330	1874	200476000	7341	3695	7	0	\N
250331	1874	200477000	7341	3695	8	0	\N
250332	1874	200478000	7341	3695	9	0	\N
250333	1874	200479000	7341	3695	10	0	\N
250334	1483	0	7341	3695	12	0	\N
250335	1874	200480000	7341	3695	13	0	\N
250336	1874	200481000	7341	3695	14	0	\N
250337	1874	200482000	7341	3695	15	0	\N
250338	1874	200483000	7341	3695	16	0	\N
250339	1874	200484000	7341	3695	17	0	\N
250340	1874	200485000	7341	3695	18	0	\N
250341	1874	200486000	7341	3695	19	0	\N
250342	1874	200487000	7341	3695	20	0	\N
250343	1874	200488000	7341	3695	21	0	\N
250344	1874	200489000	7341	3695	22	0	\N
250345	1874	200490000	7341	3695	23	0	\N
250346	1874	200491000	7341	3695	24	0	\N
250347	1874	200492000	7341	3695	25	0	\N
250348	1874	200493000	7341	3695	26	0	\N
250349	1874	200494000	7341	3695	27	0	\N
250350	1874	200495000	7341	3695	28	0	\N
250351	1874	200496000	7341	3695	29	0	\N
250352	1874	200497000	7341	3695	30	0	\N
250353	1874	200498000	7341	3695	31	0	\N
250354	1874	200499000	7341	3695	32	0	\N
250355	1874	200500000	7341	3695	33	0	\N
250356	1874	200501000	7341	3695	34	0	\N
250357	1874	200502000	7341	3695	35	0	\N
250358	1874	200503000	7341	3695	36	0	\N
250359	1874	200504000	7341	3695	37	0	\N
250360	1874	200505000	7341	3695	38	0	\N
250361	1874	200506000	7341	3695	39	0	\N
250362	1874	200507000	7341	3695	40	0	\N
250363	1874	200508000	7341	3695	41	0	\N
250364	1874	200509000	7341	3695	42	0	\N
250365	1874	200510000	7341	3695	43	0	\N
250366	1874	200511000	7341	3695	44	0	\N
250367	1874	200512000	7341	3695	45	0	\N
250368	1874	200513000	7341	3695	46	0	\N
250369	1874	200514000	7341	3695	47	0	\N
250370	1874	200515000	7341	3695	48	0	\N
250371	1874	200516000	7341	3695	49	0	\N
250372	1874	200517000	7341	3695	50	0	\N
250373	1874	200518000	7341	3695	51	0	\N
250374	1874	200519000	7341	3695	52	0	\N
250375	1874	200520000	7341	3695	53	0	\N
250376	1874	200521000	7341	3695	54	0	\N
250251	1874	200585000	7303	3773	0	0	0
250252	1874	200586000	7303	3773	1	0	0
250253	1874	200587000	7303	3773	2	0	0
250254	1874	200588000	7303	3773	3	0	0
250255	1874	200589000	7303	3773	4	0	0
250260	1874	200591000	7307	3775	1	0	0
250261	1874	200592000	7308	3776	0	0	0
250262	1874	200593000	7309	3777	0	0	0
250263	1874	200594000	7309	3777	1	0	0
250264	1874	200595000	7309	3777	2	0	0
250266	1874	200597000	7310	3778	2	0	0
250267	1874	200598000	7310	3778	3	0	0
250272	1874	200599000	7313	3779	0	0	0
250273	1874	200600000	7314	3780	0	0	0
250277	1874	200602000	7316	3781	1	0	0
250278	1874	200603000	7317	3782	0	0	0
250279	1874	200604000	7317	3782	1	0	0
250280	1874	200605000	7317	3782	2	0	0
250284	1874	200606000	7319	3783	0	0	0
250287	1874	200608000	7322	3785	0	0	0
250290	1874	200609000	7325	3786	0	0	0
250292	1874	200610000	7327	3787	0	0	0
250294	1874	200611000	7329	3788	0	0	0
250296	1874	200612000	7332	3789	0	0	0
250304	1299	1698983378602650	7336	3791	0	0	0
250305	1053	903634158149000	7336	3791	1	0	0
250306	1173	609699822388700	7336	3791	2	0	0
250307	933	504262795497600	7336	3791	3	0	0
250314	1874	200615000	7338	3792	0	0	0
250315	1874	200616000	7338	3792	2	0	0
250316	1874	200617000	7338	3792	3	0	0
250317	1874	200618000	7339	3793	0	0	0
250377	1874	200522000	7341	3695	55	0	\N
250378	1874	200523000	7341	3695	56	0	\N
250379	1874	200524000	7341	3695	57	0	\N
250380	1874	200525000	7341	3695	58	0	\N
250381	1874	200526000	7341	3695	59	0	\N
250382	1874	200527000	7341	3695	60	0	\N
250383	1874	200528000	7341	3695	61	0	\N
250384	1874	200529000	7341	3695	62	0	\N
250385	1874	200530000	7341	3695	63	0	\N
250386	1874	200531000	7341	3695	64	0	\N
250387	1874	200532000	7341	3695	65	0	\N
250388	1874	200533000	7341	3695	66	0	\N
250389	1874	200534000	7341	3695	67	0	\N
250390	1874	200535000	7341	3695	68	0	\N
250391	1874	200536000	7341	3695	69	0	\N
250392	1874	200537000	7341	3695	70	0	\N
250393	1874	200538000	7341	3695	71	0	\N
250394	1874	200539000	7341	3695	72	0	\N
250395	1874	200540000	7341	3695	73	0	\N
250396	1874	200541000	7341	3695	74	0	\N
250397	1874	200542000	7341	3695	75	0	\N
250398	1874	200543000	7341	3695	76	0	\N
250399	1874	200544000	7341	3695	77	0	\N
250400	1874	200545000	7341	3695	78	0	\N
250401	1874	200546000	7341	3695	79	0	\N
250402	1874	200547000	7341	3695	80	0	\N
250403	1874	200548000	7341	3695	81	0	\N
250404	1874	200549000	7341	3695	82	0	\N
250405	1874	200550000	7341	3695	83	0	\N
250406	1874	200551000	7341	3695	84	0	\N
250407	1874	200552000	7341	3695	86	0	\N
250408	1874	200553000	7341	3695	87	0	\N
250409	1874	200554000	7341	3695	88	0	\N
250410	1874	200555000	7341	3695	89	0	\N
250411	1874	200556000	7341	3695	90	0	\N
250412	1874	200557000	7341	3695	91	0	\N
250413	1874	200558000	7341	3695	92	0	\N
250414	1874	200559000	7341	3695	93	0	\N
250415	1874	200560000	7341	3695	94	0	\N
250416	1874	200561000	7341	3695	95	0	\N
250417	1874	200562000	7341	3695	96	0	\N
250418	1874	200563000	7341	3695	97	0	\N
250419	1874	200564000	7341	3695	98	0	\N
250420	1874	200565000	7341	3695	99	0	\N
250421	1874	200566000	7341	3695	100	0	\N
250422	1874	200567000	7341	3695	101	0	\N
250423	1874	200568000	7341	3695	102	0	\N
250424	1874	200569000	7341	3695	103	0	\N
250425	1874	200570000	7341	3695	104	0	\N
250426	1874	200571000	7341	3695	105	0	\N
250427	1874	200572000	7341	3695	106	0	\N
250428	1874	200573000	7341	3695	107	0	\N
250429	1874	200574000	7341	3695	108	0	\N
250430	1874	200575000	7341	3695	109	0	\N
250431	1874	200576000	7341	3695	110	0	\N
250432	1874	200577000	7341	3695	111	0	\N
250433	1874	200578000	7341	3695	112	0	\N
250434	1874	200579000	7341	3695	113	0	\N
250435	1874	200580000	7341	3695	114	0	\N
250436	1874	200581000	7341	3695	115	0	\N
250437	1874	200582000	7341	3695	116	0	\N
250438	1874	200583000	7341	3695	117	0	\N
250439	1874	200584000	7341	3695	118	0	\N
250440	1874	200585000	7341	3695	119	0	\N
250441	1874	200586000	7341	3695	120	0	\N
250442	1874	200587000	7341	3695	121	0	\N
250443	1874	200588000	7341	3695	122	0	\N
250444	1874	200589000	7341	3695	123	0	\N
250445	1874	200590000	7341	3695	124	0	\N
250446	1874	200591000	7341	3695	125	0	\N
250451	1874	200623000	7344	3796	0	0	\N
250459	309	66282077824773	7347	3797	0	0	\N
250460	1874	200624000	7347	3797	1	0	\N
250461	150	66282077824773	7347	3797	2	0	\N
250462	92	66282077824773	7347	3797	3	0	\N
250463	63	66282077824773	7347	3797	4	0	\N
250464	450	66282077824773	7347	3797	5	0	\N
250475	594	66282077824773	7349	3799	0	0	\N
250476	601	66282077824773	7349	3799	1	0	\N
250477	680	66282077824773	7349	3799	2	0	\N
250478	1874	200626000	7349	3799	3	0	\N
250479	392	66282077824773	7349	3799	4	0	\N
250480	690	66282077824773	7349	3799	5	0	\N
250481	186	66282077824773	7349	3799	6	0	\N
250482	89	66282077824773	7349	3799	7	0	\N
250491	594	66282077824773	7351	3799	0	0	\N
250492	601	66282077824773	7351	3799	1	0	\N
250493	680	66282077824773	7351	3799	2	0	\N
250494	1874	200626000	7351	3799	3	0	\N
250495	392	66282077824773	7351	3799	4	0	\N
250496	690	66282077824773	7351	3799	5	0	\N
250497	186	66282077824773	7351	3799	6	0	\N
250498	89	66282077824773	7351	3799	7	0	\N
250507	1811	544686008347	7353	3800	0	0	\N
250508	383	66282077824773	7353	3800	1	0	\N
250509	308	66282077824773	7353	3800	2	0	\N
250510	1811	671972675517	7353	3800	3	0	\N
250511	1150	610502785413452	7353	3800	4	0	\N
250512	84	66282077824773	7353	3800	5	0	\N
250449	1874	200621000	7342	3794	2	0	0
250450	1874	200622000	7343	3795	0	0	0
250452	1874	200623000	7345	3796	0	0	0
250453	309	66282077824773	7346	3797	0	0	0
250454	1874	200624000	7346	3797	1	0	0
250456	92	66282077824773	7346	3797	3	0	0
250457	63	66282077824773	7346	3797	4	0	0
250458	450	66282077824773	7346	3797	5	0	0
250465	1874	200625000	7348	3798	0	0	0
250466	452	66282077824773	7348	3798	1	0	0
250468	373	66282077824773	7348	3798	3	0	0
250469	408	66282077824773	7348	3798	4	0	0
250470	453	66282077824773	7348	3798	5	0	0
250471	593	66282077824773	7348	3798	6	0	0
250473	438	66282077824773	7348	3798	8	0	0
250474	339	66282077824773	7348	3798	9	0	0
250483	594	66282077824773	7350	3799	0	0	0
250484	601	66282077824773	7350	3799	1	0	0
250485	680	66282077824773	7350	3799	2	0	0
250487	392	66282077824773	7350	3799	4	0	0
250488	690	66282077824773	7350	3799	5	0	0
250489	186	66282077824773	7350	3799	6	0	0
250490	89	66282077824773	7350	3799	7	0	0
250499	1811	544686008347	7352	3800	0	0	1
250501	308	66282077824773	7352	3800	2	0	0
250502	1811	671972675517	7352	3800	3	0	1
250503	1150	610502785413452	7352	3800	4	0	0
250504	84	66282077824773	7352	3800	5	0	0
250506	1874	200627000	7352	3800	7	0	0
250513	678	66282077824773	7353	3800	6	0	\N
250514	1874	200627000	7353	3800	7	0	\N
250515	309	66282077824773	7354	3780	0	0	\N
250516	150	66282077824773	7354	3780	1	0	\N
250517	92	66282077824773	7354	3780	2	0	\N
250518	63	66282077824773	7354	3780	3	0	\N
250519	1874	200600000	7354	3780	4	0	\N
250520	1874	200601000	7354	3780	5	0	\N
250521	1874	200602000	7354	3780	6	0	\N
250522	1874	200603000	7354	3780	7	0	\N
250523	1874	200604000	7354	3780	8	0	\N
250524	1874	200605000	7354	3780	9	0	\N
250525	1874	200606000	7354	3780	10	0	\N
250526	1299	1698983378602650	7354	3780	11	0	\N
250527	1053	903634158149000	7354	3780	12	0	\N
250528	1173	609699822388700	7354	3780	13	0	\N
250529	933	504262795497600	7354	3780	14	0	\N
250530	1874	200607000	7354	3780	15	0	\N
250531	1874	200608000	7354	3780	16	0	\N
250532	1874	200609000	7354	3780	17	0	\N
250533	1874	200610000	7354	3780	18	0	\N
250534	450	66282077824773	7354	3780	19	0	\N
250535	452	66282077824773	7354	3780	20	0	\N
250536	322	66282077824773	7354	3780	21	0	\N
250537	373	66282077824773	7354	3780	22	0	\N
250538	408	66282077824773	7354	3780	23	0	\N
250539	453	66282077824773	7354	3780	24	0	\N
250540	593	66282077824773	7354	3780	25	0	\N
250541	91	66282077824773	7354	3780	26	0	\N
250542	438	66282077824773	7354	3780	27	0	\N
250543	339	66282077824773	7354	3780	28	0	\N
250544	594	66282077824773	7354	3780	29	0	\N
250545	601	66282077824773	7354	3780	30	0	\N
250546	680	66282077824773	7354	3780	31	0	\N
250547	392	66282077824773	7354	3780	32	0	\N
250548	690	66282077824773	7354	3780	33	0	\N
250549	186	66282077824773	7354	3780	34	0	\N
250550	89	66282077824773	7354	3780	35	0	\N
250551	1811	544686008347	7354	3780	36	0	\N
250552	383	66282077824773	7354	3780	37	0	\N
250553	308	66282077824773	7354	3780	38	0	\N
250554	1811	671972675517	7354	3780	39	0	\N
250555	1150	610502785413452	7354	3780	40	0	\N
250556	1874	200611000	7354	3780	41	0	\N
250557	1874	200612000	7354	3780	42	0	\N
250558	1874	200613000	7354	3780	43	0	\N
250559	1874	200614000	7354	3780	45	0	\N
250560	1874	200615000	7354	3780	46	0	\N
250561	1874	200616000	7354	3780	47	0	\N
250562	1874	200617000	7354	3780	48	0	\N
250563	1874	200618000	7354	3780	49	0	\N
250564	1874	200619000	7354	3780	50	0	\N
250565	1874	200620000	7354	3780	51	0	\N
250566	1874	200621000	7354	3780	52	0	\N
250567	1874	200622000	7354	3780	53	0	\N
250568	1874	200623000	7354	3780	54	0	\N
250569	1874	200624000	7354	3780	55	0	\N
250570	1874	200625000	7354	3780	56	0	\N
250571	1874	200626000	7354	3780	57	0	\N
250581	731	2008547812829	7356	3801	0	0	\N
250582	1874	200628000	7356	3801	1	0	\N
250583	295	66282077824773	7356	3801	2	0	\N
250584	551	66282077824773	7356	3801	3	0	\N
250585	520	66282077824773	7356	3801	4	0	\N
250586	653	66282077824773	7356	3801	5	0	\N
250587	622	66285057824773	7356	3801	6	0	\N
250588	105	66282077824773	7356	3801	7	0	\N
250589	122	66282077824773	7356	3801	8	0	\N
250608	721	2008547812829	7358	3802	0	0	\N
250609	1874	200629000	7358	3802	1	0	\N
250610	1874	200630000	7358	3802	2	0	\N
250611	206	66282077824773	7358	3802	3	0	\N
250612	304	66282077824773	7358	3802	4	0	\N
250613	399	66282077824773	7358	3802	5	0	\N
250614	194	66282077824773	7358	3802	6	0	\N
250615	1276	1701220294435610	7358	3802	7	0	\N
250616	877	203449976855173	7358	3802	8	0	\N
250617	878	203450976855173	7358	3802	9	0	\N
250618	193	66282077824773	7358	3802	10	0	\N
250619	504	66282077824773	7358	3802	11	0	\N
250620	1811	685021273493	7358	3802	12	0	\N
250621	78	66282077824773	7358	3802	13	0	\N
250622	658	66282077824773	7358	3802	14	0	\N
250623	205	66282077824773	7358	3802	15	0	\N
250624	660	66282077824773	7358	3802	16	0	\N
250625	745	2008547812829	7358	3802	17	0	\N
250626	1874	200631000	7359	3803	0	0	\N
250627	29	7029917345033	7359	3803	1	0	\N
250628	138	66282077824773	7359	3803	2	0	\N
250629	146	66282077824773	7359	3803	3	0	\N
250630	395	66279047824773	7359	3803	4	0	\N
250631	587	66282077824773	7359	3803	5	0	\N
250632	910	504926523573708	7359	3803	6	0	\N
250633	500	66282077824773	7359	3803	7	0	\N
250634	611	66282077824773	7359	3803	8	0	\N
250644	1874	200631000	7361	3803	0	0	\N
250645	29	7029917345033	7361	3803	1	0	\N
250646	138	66282077824773	7361	3803	2	0	\N
250647	146	66282077824773	7361	3803	3	0	\N
250648	395	66279047824773	7361	3803	4	0	\N
250574	295	66282077824773	7355	3801	2	0	0
250575	551	66282077824773	7355	3801	3	0	0
250576	520	66282077824773	7355	3801	4	0	0
250577	653	66282077824773	7355	3801	5	0	0
250578	622	66285057824773	7355	3801	6	0	1
250580	122	66282077824773	7355	3801	8	0	0
250590	721	2008547812829	7357	3802	0	0	0
250591	1874	200629000	7357	3802	1	0	0
250592	1874	200630000	7357	3802	2	0	0
250593	206	66282077824773	7357	3802	3	0	0
250595	399	66282077824773	7357	3802	5	0	0
250596	194	66282077824773	7357	3802	6	0	0
250597	1276	1701220294435610	7357	3802	7	0	0
250598	877	203449976855173	7357	3802	8	0	2
250600	193	66282077824773	7357	3802	10	0	0
250601	504	66282077824773	7357	3802	11	0	0
250602	1811	685021273493	7357	3802	12	0	1
250603	78	66282077824773	7357	3802	13	0	0
250604	658	66282077824773	7357	3802	14	0	0
250606	660	66282077824773	7357	3802	16	0	0
250607	745	2008547812829	7357	3802	17	0	0
250635	1874	200631000	7360	3803	0	0	0
250636	29	7029917345033	7360	3803	1	0	0
250637	138	66282077824773	7360	3803	2	0	0
250639	395	66279047824773	7360	3803	4	0	1
250640	587	66282077824773	7360	3803	5	0	0
250641	910	504926523573708	7360	3803	6	0	0
250642	500	66282077824773	7360	3803	7	0	0
250649	587	66282077824773	7361	3803	5	0	\N
250650	910	504926523573708	7361	3803	6	0	\N
250651	500	66282077824773	7361	3803	7	0	\N
250652	611	66282077824773	7361	3803	8	0	\N
250653	225	66282077824773	7362	3804	0	0	\N
250654	377	66282077824773	7362	3804	1	0	\N
250655	560	66282077824773	7362	3804	2	0	\N
250656	252	66282077824773	7362	3804	3	0	\N
250657	1874	200632000	7362	3804	4	0	\N
250658	390	66282077824773	7362	3804	5	0	\N
250659	108	66282077824773	7362	3804	6	0	\N
250660	894	308134249033327	7362	3804	7	0	\N
250661	225	66282077824773	7363	3804	0	0	\N
250662	377	66282077824773	7363	3804	1	0	\N
250663	560	66282077824773	7363	3804	2	0	\N
250664	252	66282077824773	7363	3804	3	0	\N
250665	1874	200632000	7363	3804	4	0	\N
250666	390	66282077824773	7363	3804	5	0	\N
250667	108	66282077824773	7363	3804	6	0	\N
250668	894	308134249033327	7363	3804	7	0	\N
250669	225	66282077824773	7364	3804	0	0	\N
250670	377	66282077824773	7364	3804	1	0	\N
250671	560	66282077824773	7364	3804	2	0	\N
250672	252	66282077824773	7364	3804	3	0	\N
250673	1874	200632000	7364	3804	4	0	\N
250674	390	66282077824773	7364	3804	5	0	\N
250675	108	66282077824773	7364	3804	6	0	\N
250676	894	308134249033327	7364	3804	7	0	\N
250685	1874	200633000	7366	3805	0	0	\N
250686	569	66282077824773	7366	3805	1	0	\N
250687	99	66282077824773	7366	3805	2	0	\N
250688	570	66282077824773	7366	3805	3	0	\N
250689	49	66282077824773	7366	3805	4	0	\N
250690	127	66130067824773	7366	3805	5	0	\N
250691	251	66282077824773	7366	3805	6	0	\N
250692	1874	200633000	7367	3805	0	0	\N
250693	569	66282077824773	7367	3805	1	0	\N
250694	99	66282077824773	7367	3805	2	0	\N
250695	570	66282077824773	7367	3805	3	0	\N
250696	49	66282077824773	7367	3805	4	0	\N
250697	127	66130067824773	7367	3805	5	0	\N
250698	251	66282077824773	7367	3805	6	0	\N
250706	35	19282059003548	7369	3806	0	0	\N
250707	1874	200634000	7369	3806	1	0	\N
250708	320	66282077824773	7369	3806	2	0	\N
250709	1030	904824004033700	7369	3806	3	0	\N
250710	663	66282077824773	7369	3806	4	0	\N
250711	499	66282077824773	7369	3806	5	0	\N
250712	54	66282077824773	7369	3806	6	0	\N
250713	35	19282059003548	7370	3806	0	0	\N
250714	1874	200634000	7370	3806	1	0	\N
250715	320	66282077824773	7370	3806	2	0	\N
250716	1030	904824004033700	7370	3806	3	0	\N
250717	663	66282077824773	7370	3806	4	0	\N
250718	499	66282077824773	7370	3806	5	0	\N
250719	54	66282077824773	7370	3806	6	0	\N
250755	1874	200635000	7373	3807	1	0	\N
250756	1900	100000000	7373	3807	2	0	\N
250757	710	5021369532156	7373	3807	3	0	\N
250758	1811	704505517164	7373	3807	4	0	\N
250759	217	66282077824773	7373	3807	5	0	\N
250760	103	66282077824773	7373	3807	6	0	\N
250761	534	66282077824773	7373	3807	7	0	\N
250762	245	66282077824773	7373	3807	8	0	\N
250763	421	66282077824773	7373	3807	9	0	\N
250764	620	66282077824773	7373	3807	10	0	\N
250765	352	66282077824773	7373	3807	11	0	\N
250766	691	66282077824773	7373	3807	12	0	\N
250767	191	66282077824773	7373	3807	13	0	\N
250768	266	66282077824773	7373	3807	14	0	\N
250769	353	66282077824773	7373	3807	15	0	\N
250770	600	66282077824773	7373	3807	16	0	\N
250771	420	66282077824773	7373	3807	17	0	\N
250772	893	308134249033327	7373	3807	18	0	\N
250773	180	66282077824773	7373	3807	19	0	\N
250774	112	66131057824773	7373	3807	20	0	\N
250775	106	66282077824773	7373	3807	21	0	\N
250776	1811	767942317749	7373	3807	22	0	\N
250777	652	66282077824773	7373	3807	23	0	\N
250778	397	66282077824773	7373	3807	24	0	\N
250779	391	66282077824773	7373	3807	25	0	\N
250780	201	66282077824773	7373	3807	26	0	\N
250781	1874	200636000	7373	3807	27	0	\N
250782	261	66282077824773	7373	3807	28	0	\N
250784	1874	200637000	7375	3808	0	0	\N
250679	560	66282077824773	7365	3804	2	0	0
250680	252	66282077824773	7365	3804	3	0	0
250681	1874	200632000	7365	3804	4	0	0
250682	390	66282077824773	7365	3804	5	0	0
250683	108	66282077824773	7365	3804	6	0	0
250699	1874	200633000	7368	3805	0	0	0
250700	569	66282077824773	7368	3805	1	0	0
250701	99	66282077824773	7368	3805	2	0	0
250702	570	66282077824773	7368	3805	3	0	0
250703	49	66282077824773	7368	3805	4	0	0
250705	251	66282077824773	7368	3805	6	0	0
250720	35	19282059003548	7371	3806	0	0	0
250721	1874	200634000	7371	3806	1	0	0
250722	320	66282077824773	7371	3806	2	0	0
250724	663	66282077824773	7371	3806	4	0	0
250725	499	66282077824773	7371	3806	5	0	0
250726	1874	200635000	7372	3807	1	0	0
250727	1900	100000000	7372	3807	2	0	0
250728	54	66282077824773	7372	3807	3	0	0
250730	1811	704505517164	7372	3807	5	0	1
250731	217	66282077824773	7372	3807	6	0	0
250732	103	66282077824773	7372	3807	7	0	0
250733	534	66282077824773	7372	3807	8	0	0
250734	245	66282077824773	7372	3807	9	0	0
250736	620	66282077824773	7372	3807	11	0	0
250737	352	66282077824773	7372	3807	12	0	0
250738	691	66282077824773	7372	3807	13	0	0
250739	191	66282077824773	7372	3807	14	0	0
250741	353	66282077824773	7372	3807	16	0	0
250742	600	66282077824773	7372	3807	17	0	0
250743	420	66282077824773	7372	3807	18	0	0
250744	893	308134249033327	7372	3807	19	0	0
250745	180	66282077824773	7372	3807	20	0	0
250747	106	66282077824773	7372	3807	22	0	0
250748	1811	767942317749	7372	3807	23	0	1
250749	652	66282077824773	7372	3807	24	0	0
250750	397	66282077824773	7372	3807	25	0	0
250751	391	66282077824773	7372	3807	26	0	0
250753	1874	200636000	7372	3807	28	0	0
250754	261	66282077824773	7372	3807	29	0	0
250783	1874	200637000	7374	3808	0	0	0
250785	1874	200637000	7376	3808	0	0	\N
250787	1874	200638000	7378	3809	0	0	\N
250788	1874	200638000	7379	3809	0	0	\N
250791	1874	200641000	7382	3812	0	0	\N
250793	1874	200641000	7384	3812	0	0	\N
250799	1874	200646000	7388	3815	0	0	\N
250808	1874	200649000	7391	3817	0	0	\N
250809	163	66282077824773	7391	3817	1	0	\N
250810	82	66282077824773	7391	3817	2	0	\N
250811	275	66282077824773	7391	3817	3	0	\N
250812	361	66282077824773	7391	3817	4	0	\N
250814	1874	200650000	7393	3818	0	0	\N
250817	1874	200652000	7395	3820	0	0	\N
250818	1874	200653000	7395	3820	1	0	\N
250821	1874	200654000	7397	3821	0	0	\N
250833	1816	100000000	7402	3825	0	0	\N
250834	1874	200663000	7402	3825	1	0	\N
250835	1874	200664000	7402	3825	2	0	\N
250840	1874	200665000	7405	3826	0	0	\N
250848	1874	200670000	7410	3830	0	0	\N
250849	1874	200671000	7410	3830	1	0	\N
250850	1874	200672000	7411	3831	0	0	\N
250852	1874	200672000	7413	3831	0	0	\N
250853	1874	200673000	7413	3831	1	0	\N
250854	1874	200673000	7414	3832	0	0	\N
250855	1903	197000000000	7414	3832	2	0	\N
250856	1874	200673000	7415	3832	0	0	\N
250857	1903	197000000000	7415	3832	2	0	\N
250858	1874	200673000	7416	3832	0	0	\N
250859	1903	197000000000	7416	3832	2	0	\N
250861	1874	200674000	7418	3833	0	0	\N
250862	44	77520830000000	7418	3833	1	0	\N
250870	1898	0	7424	3561	0	0	\N
250871	1678	5040154668000	7424	3561	1	0	\N
250872	327	66000100000000	7424	3561	2	0	\N
250873	1874	200320000	7424	3561	3	0	\N
250874	1816	100000000	7424	3561	4	0	\N
250875	1299	1698983378602650	7424	3561	5	0	\N
250876	1053	903634158149000	7424	3561	6	0	\N
250877	1173	609699822388700	7424	3561	7	0	\N
250878	933	504262795497600	7424	3561	8	0	\N
250879	1874	200321000	7424	3561	9	0	\N
250880	1903	98000000000	7424	3561	10	0	\N
250881	1678	5040154669000	7424	3561	13	0	\N
250882	1678	5040154670000	7424	3561	14	0	\N
250883	1678	5040154671000	7424	3561	15	0	\N
250884	1874	200322000	7424	3561	16	0	\N
250885	1874	200323000	7424	3561	17	0	\N
250886	1874	200324000	7424	3561	18	0	\N
250887	1874	200325000	7424	3561	19	0	\N
250888	1874	200326000	7424	3561	20	0	\N
250889	1874	200327000	7424	3561	21	0	\N
250890	1874	200328000	7424	3561	22	0	\N
250891	1874	200329000	7424	3561	23	0	\N
250892	1874	200330000	7424	3561	25	0	\N
250893	1874	200331000	7424	3561	26	0	\N
250894	1874	200332000	7424	3561	27	0	\N
250895	1874	200333000	7424	3561	28	0	\N
250896	1874	200334000	7424	3561	29	0	\N
250897	1874	200335000	7424	3561	30	0	\N
250898	1874	200336000	7424	3561	31	0	\N
250899	1874	200337000	7424	3561	32	0	\N
250900	1874	200338000	7424	3561	33	0	\N
250901	1874	200339000	7424	3561	34	0	\N
250902	1678	5040154672000	7424	3561	35	0	\N
250903	1678	5040154673000	7424	3561	36	0	\N
250904	1874	200340000	7424	3561	37	0	\N
250905	1874	200341000	7424	3561	38	0	\N
250906	1874	200342000	7424	3561	39	0	\N
250907	1874	200343000	7424	3561	40	0	\N
250908	1874	200344000	7424	3561	41	0	\N
250909	1874	200345000	7424	3561	42	0	\N
250910	1874	200346000	7424	3561	43	0	\N
250911	1874	200347000	7424	3561	44	0	\N
250912	1718	200000000	7424	3561	45	0	\N
250913	1874	200348000	7424	3561	46	0	\N
250914	1874	200349000	7424	3561	47	0	\N
250915	1874	200350000	7424	3561	48	0	\N
250916	1874	200351000	7424	3561	49	0	\N
250917	1678	5040154674000	7424	3561	50	0	\N
250918	1678	5040154675000	7424	3561	51	0	\N
250919	1678	5040154676000	7424	3561	52	0	\N
250920	1678	5040154677000	7424	3561	53	0	\N
250790	1874	200640000	7381	3811	0	0	0
250792	1874	200641000	7383	3812	0	0	0
250794	1874	200642000	7385	3813	0	0	0
250795	1874	200643000	7385	3813	1	0	0
250796	1874	200644000	7386	3814	0	0	0
250798	1874	200646000	7387	3815	0	0	0
250800	1874	200647000	7389	3816	0	0	0
250801	402	66282077824773	7389	3816	1	0	0
250802	1874	200648000	7389	3816	2	0	0
250803	1874	200649000	7390	3817	0	0	0
250805	82	66282077824773	7390	3817	2	0	0
250806	275	66282077824773	7390	3817	3	0	0
250807	361	66282077824773	7390	3817	4	0	0
250813	1874	200650000	7392	3818	0	0	0
250816	554	66010000000000	7394	3819	1	0	0
250819	1874	200652000	7396	3820	0	0	0
250820	1874	200653000	7396	3820	1	0	0
250822	1874	200654000	7398	3821	0	0	0
250823	1874	200655000	7399	3822	0	0	0
250825	1874	200657000	7400	3823	1	0	0
250826	1901	200000000	7400	3823	2	0	0
250827	1902	200000000	7400	3823	3	0	0
250828	1874	200658000	7400	3823	4	0	0
250829	1874	200659000	7400	3823	5	0	0
250831	1874	200661000	7400	3823	7	0	0
250832	1874	200662000	7401	3824	0	0	0
250836	1816	100000000	7403	3825	0	0	1
250837	1874	200663000	7403	3825	1	0	0
250839	1874	200665000	7404	3826	0	0	0
250841	1874	200666000	7406	3827	0	0	0
250842	1874	200667000	7407	3828	0	0	0
250843	1874	200668000	7408	3829	0	0	0
250844	1874	200669000	7408	3829	1	0	0
250846	1874	200670000	7409	3830	0	0	0
250847	1874	200671000	7409	3830	1	0	0
250851	1874	200672000	7412	3831	0	0	0
250860	1903	197000000000	7417	3832	0	0	0
250863	1874	200673000	7419	3833	0	0	0
250865	44	77520830000000	7419	3833	2	0	0
250866	1874	200675000	7421	3834	0	0	0
250867	1874	200676000	7421	3834	1	0	0
250868	1874	200677000	7422	3835	0	0	0
250921	1678	5040154678000	7424	3561	54	0	\N
250922	1678	5040154679000	7424	3561	55	0	\N
250923	1678	5040154680000	7424	3561	56	0	\N
250924	1678	5040154681000	7424	3561	57	0	\N
250925	1678	5040154682000	7424	3561	58	0	\N
250926	1678	5040154683000	7424	3561	59	0	\N
250927	1678	5040154684000	7424	3561	60	0	\N
250928	1678	5040154685000	7424	3561	61	0	\N
250929	1678	5040154686000	7424	3561	62	0	\N
250930	1678	5040154687000	7424	3561	63	0	\N
250931	1678	5040154688000	7424	3561	64	0	\N
250932	1678	5040154689000	7424	3561	65	0	\N
250933	1678	5040154690000	7424	3561	66	0	\N
250934	1678	5040154691000	7424	3561	67	0	\N
250935	1874	200352000	7424	3561	68	0	\N
250936	1874	200353000	7424	3561	69	0	\N
250937	1874	200354000	7424	3561	70	0	\N
250938	1874	200355000	7424	3561	71	0	\N
250939	1874	200356000	7424	3561	72	0	\N
250940	1874	200357000	7424	3561	73	0	\N
250941	1874	200358000	7424	3561	74	0	\N
250942	1874	200359000	7424	3561	75	0	\N
250943	1874	200360000	7424	3561	76	0	\N
250944	1874	200361000	7424	3561	77	0	\N
250945	1874	200362000	7424	3561	78	0	\N
250946	1874	200363000	7424	3561	79	0	\N
250947	1874	200364000	7424	3561	80	0	\N
250948	1874	200365000	7424	3561	81	0	\N
250949	1874	200366000	7424	3561	82	0	\N
250950	1874	200367000	7424	3561	83	0	\N
250951	1874	200368000	7424	3561	84	0	\N
250952	1874	200369000	7424	3561	85	0	\N
250953	1874	200370000	7424	3561	86	0	\N
250954	1874	200371000	7424	3561	87	0	\N
250955	1874	200372000	7424	3561	88	0	\N
250956	1874	200373000	7424	3561	89	0	\N
250957	1874	200374000	7424	3561	90	0	\N
250958	1874	200375000	7424	3561	91	0	\N
250959	1874	200376000	7424	3561	92	0	\N
250960	554	66010000000000	7424	3561	93	0	\N
250961	154	66000100000000	7424	3561	94	0	\N
250962	309	66282077824773	7424	3561	95	0	\N
250963	150	66282077824773	7424	3561	96	0	\N
250964	92	66282077824773	7424	3561	97	0	\N
250965	63	66282077824773	7424	3561	98	0	\N
250966	450	66282077824773	7424	3561	99	0	\N
250967	452	66282077824773	7424	3561	100	0	\N
250968	322	66282077824773	7424	3561	101	0	\N
250969	373	66282077824773	7424	3561	102	0	\N
250970	408	66282077824773	7424	3561	103	0	\N
250971	453	66282077824773	7424	3561	104	0	\N
250972	593	66282077824773	7424	3561	105	0	\N
250973	91	66282077824773	7424	3561	106	0	\N
250974	438	66282077824773	7424	3561	107	0	\N
250975	339	66282077824773	7424	3561	108	0	\N
250976	594	66282077824773	7424	3561	109	0	\N
250977	601	66282077824773	7424	3561	110	0	\N
250978	680	66282077824773	7424	3561	111	0	\N
250979	392	66282077824773	7424	3561	112	0	\N
250980	690	66282077824773	7424	3561	113	0	\N
250981	186	66282077824773	7424	3561	114	0	\N
250982	89	66282077824773	7424	3561	115	0	\N
250983	1811	544686008347	7424	3561	116	0	\N
250984	383	66282077824773	7424	3561	117	0	\N
250985	308	66282077824773	7424	3561	118	0	\N
250986	1811	671972675517	7424	3561	119	0	\N
250987	1150	610502785413452	7424	3561	120	0	\N
250988	84	66282077824773	7424	3561	121	0	\N
250989	678	66282077824773	7424	3561	122	0	\N
250990	731	2008547812829	7424	3561	123	0	\N
250991	295	66282077824773	7424	3561	124	0	\N
250992	551	66282077824773	7424	3561	125	0	\N
250993	1874	200679000	7425	3837	0	0	\N
250994	1874	200680000	7425	3837	1	0	\N
250995	1874	200681000	7425	3837	2	0	\N
251001	1874	200682000	7428	3838	0	0	\N
251002	1874	200683000	7428	3838	1	0	\N
251003	1874	200684000	7429	3839	0	0	\N
251005	1874	200684000	7431	3839	0	0	\N
251006	1874	200685000	7431	3839	1	0	\N
251007	1874	200685000	7432	3840	0	0	\N
251014	1874	200691000	7438	3845	0	0	\N
251016	1874	200691000	7440	3845	0	0	\N
251020	1874	200694000	7443	3848	0	0	\N
251021	1874	200694000	7444	3848	0	0	\N
251030	1874	200700000	7451	3853	0	0	\N
251031	1874	200701000	7451	3853	1	0	\N
251037	1874	200706000	7454	3856	0	0	\N
251039	1874	200707000	7456	3857	0	0	\N
251041	1874	200707000	7458	3857	0	0	\N
251043	1874	200709000	7460	3859	0	0	\N
251044	1874	200710000	7460	3859	1	0	\N
251045	1874	200711000	7460	3859	2	0	\N
251046	1874	200709000	7461	3859	0	0	\N
251047	1874	200710000	7461	3859	1	0	\N
251048	1874	200711000	7461	3859	2	0	\N
251056	1874	200715000	7467	3863	0	0	\N
250998	1874	200681000	7426	3837	2	0	0
250999	1874	200682000	7427	3838	0	0	0
251000	1874	200683000	7427	3838	1	0	0
251004	1874	200684000	7430	3839	0	0	0
251008	1874	200685000	7433	3840	0	0	0
251010	1874	200687000	7435	3842	0	0	0
251011	1874	200688000	7435	3842	1	0	0
251012	1874	200689000	7436	3843	0	0	0
251013	1874	200690000	7437	3844	0	0	0
251015	1874	200691000	7439	3845	0	0	0
251018	1874	200692000	7441	3846	1	0	0
251019	1874	200693000	7442	3847	0	0	0
251022	1874	200694000	7445	3848	0	0	0
251023	1874	200695000	7446	3849	0	0	0
251025	1874	200697000	7448	3851	0	0	0
251026	1874	200698000	7449	3852	0	0	0
251027	1874	200699000	7449	3852	1	0	0
251028	1874	200700000	7450	3853	0	0	0
251029	1874	200701000	7450	3853	1	0	0
251033	1874	200703000	7452	3854	1	0	0
251034	1898	20000000	7453	3855	0	0	0
251035	1874	200704000	7453	3855	1	0	0
251036	1874	200705000	7453	3855	2	0	0
251038	1874	200706000	7455	3856	0	0	0
251042	1874	200708000	7459	3858	0	0	0
251049	1874	200709000	7462	3859	0	0	0
251050	1874	200710000	7462	3859	1	0	0
251051	1874	200711000	7462	3859	2	0	0
251053	1874	200713000	7464	3861	0	0	0
251054	1874	200714000	7465	3862	0	0	0
251055	1874	200715000	7466	3863	0	0	0
251057	1874	200715000	7468	3863	0	0	\N
251058	1874	200715000	7469	3863	0	0	\N
251062	1874	200718000	7472	3865	0	0	\N
251063	1898	10000000	7473	3787	1	0	\N
251064	1898	20000000	7473	3787	2	0	\N
251065	309	66282077824773	7473	3787	3	0	\N
251066	150	66282077824773	7473	3787	4	0	\N
251067	92	66282077824773	7473	3787	5	0	\N
251068	63	66282077824773	7473	3787	6	0	\N
251069	1816	100000000	7473	3787	7	0	\N
251070	1299	1698983378602650	7473	3787	8	0	\N
251071	1053	903634158149000	7473	3787	9	0	\N
251072	1173	609699822388700	7473	3787	10	0	\N
251073	933	504262795497600	7473	3787	11	0	\N
251074	1903	98000000000	7473	3787	12	0	\N
251075	450	66282077824773	7473	3787	13	0	\N
251076	452	66282077824773	7473	3787	14	0	\N
251077	322	66282077824773	7473	3787	15	0	\N
251078	373	66282077824773	7473	3787	16	0	\N
251079	408	66282077824773	7473	3787	17	0	\N
251080	453	66282077824773	7473	3787	18	0	\N
251081	593	66282077824773	7473	3787	19	0	\N
251082	91	66282077824773	7473	3787	21	0	\N
251085	1874	200721000	7475	3867	0	0	\N
251086	1540	367308000000	7475	3867	1	0	\N
251087	1874	200721000	7476	3867	0	0	\N
251088	1540	367308000000	7476	3867	1	0	\N
251089	1874	200721000	7477	3867	0	0	\N
251090	1540	367308000000	7477	3867	1	0	\N
251097	1874	200723000	7482	3870	0	0	\N
251098	1874	200724000	7482	3870	1	0	\N
251099	1540	367308000000	7482	3870	2	0	\N
251100	1874	200723000	7483	3870	0	0	\N
251101	1874	200724000	7483	3870	1	0	\N
251102	1540	367308000000	7483	3870	2	0	\N
251104	1874	200725000	7485	3871	0	0	\N
251108	1874	200727000	7488	3873	0	0	\N
251109	1874	200728000	7488	3873	1	0	\N
251110	1874	200727000	7489	3873	0	0	\N
251111	1874	200728000	7489	3873	1	0	\N
251112	1874	200727000	7490	3873	0	0	\N
251113	1874	200728000	7490	3873	1	0	\N
251115	1874	200729000	7492	3874	0	0	\N
251127	1874	200739000	7499	3881	0	0	\N
251128	1874	200739000	7500	3881	0	0	\N
251133	1874	200741000	7504	3883	0	0	\N
251134	1874	200742000	7504	3883	1	0	\N
251141	1874	200748000	7509	3888	0	0	\N
251142	1874	200749000	7509	3888	1	0	\N
251143	1874	200750000	7509	3888	2	0	\N
251144	1864	332000000000	7509	3888	3	0	\N
251145	1874	200748000	7510	3888	0	0	\N
251146	1874	200749000	7510	3888	1	0	\N
251147	1874	200750000	7510	3888	2	0	\N
251148	1864	332000000000	7510	3888	3	0	\N
251149	1898	10000000	7511	3818	0	0	\N
251150	1898	20000000	7511	3818	1	0	\N
251151	1874	200650000	7511	3818	2	0	\N
251152	1816	100000000	7511	3818	3	0	\N
251153	1874	200651000	7511	3818	4	0	\N
251154	1874	200652000	7511	3818	5	0	\N
251155	1874	200653000	7511	3818	6	0	\N
251156	1903	98000000000	7511	3818	7	0	\N
251157	1540	367308000000	7511	3818	8	0	\N
251158	1874	200654000	7511	3818	9	0	\N
251159	1874	200655000	7511	3818	10	0	\N
251160	1874	200656000	7511	3818	11	0	\N
251161	1874	200657000	7511	3818	12	0	\N
251162	1901	200000000	7511	3818	13	0	\N
251163	1902	200000000	7511	3818	14	0	\N
251164	1874	200658000	7511	3818	15	0	\N
251165	1874	200659000	7511	3818	16	0	\N
251166	1874	200660000	7511	3818	17	0	\N
251167	1874	200661000	7511	3818	18	0	\N
251168	1874	200662000	7511	3818	19	0	\N
251169	1874	200663000	7511	3818	20	0	\N
251170	1874	200664000	7511	3818	21	0	\N
251171	1874	200665000	7511	3818	22	0	\N
251172	1874	200666000	7511	3818	23	0	\N
251173	1874	200667000	7511	3818	24	0	\N
251174	1874	200668000	7511	3818	25	0	\N
251175	1874	200669000	7511	3818	26	0	\N
251176	1874	200670000	7511	3818	27	0	\N
251177	1874	200671000	7511	3818	28	0	\N
251178	1874	200672000	7511	3818	29	0	\N
251179	1874	200673000	7511	3818	30	0	\N
251180	1874	200674000	7511	3818	31	0	\N
251181	1874	200675000	7511	3818	32	0	\N
251182	1874	200676000	7511	3818	33	0	\N
251183	1874	200677000	7511	3818	34	0	\N
251184	1874	200678000	7511	3818	35	0	\N
251185	1874	200679000	7511	3818	36	0	\N
251186	1874	200680000	7511	3818	37	0	\N
251187	1874	200681000	7511	3818	38	0	\N
251188	1874	200682000	7511	3818	39	0	\N
251189	1874	200683000	7511	3818	40	0	\N
251190	1874	200684000	7511	3818	41	0	\N
251191	1874	200685000	7511	3818	42	0	\N
251192	1874	200686000	7511	3818	43	0	\N
251061	1874	200718000	7471	3865	0	0	0
251083	1874	200719000	7474	3866	0	0	0
251084	1874	200720000	7474	3866	1	0	0
251091	1874	200721000	7478	3867	0	0	0
251092	1540	367308000000	7478	3867	1	0	2
251094	1874	200723000	7481	3870	0	0	0
251095	1874	200724000	7481	3870	1	0	0
251096	1540	367308000000	7481	3870	2	0	2
251103	1874	200725000	7484	3871	0	0	0
251105	1874	200726000	7486	3872	0	0	0
251107	1874	200728000	7487	3873	1	0	0
251114	1874	200729000	7491	3874	0	0	0
251116	1874	200730000	7493	3875	0	0	0
251117	1406	0	7494	3876	0	0	0
251119	1874	200732000	7495	3877	0	0	0
251120	1874	200733000	7495	3877	1	0	0
251121	1403	0	7496	3878	0	0	0
251122	1874	200734000	7496	3878	1	0	0
251123	1874	200735000	7497	3879	0	0	0
251125	1874	200737000	7498	3880	1	0	0
251126	1874	200738000	7498	3880	2	0	0
251129	1874	200739000	7501	3881	0	0	0
251130	1874	200740000	7502	3882	0	0	0
251131	1874	200741000	7503	3883	0	0	0
251135	1874	200743000	7505	3884	0	0	0
251136	1874	200744000	7505	3884	1	0	0
251137	321	66010000000000	7506	3885	0	0	0
251138	1874	200745000	7506	3885	1	0	0
251140	1874	200747000	7508	3887	0	0	0
251193	1874	200687000	7511	3818	44	0	\N
251194	1874	200688000	7511	3818	45	0	\N
251195	1874	200689000	7511	3818	46	0	\N
251196	1874	200690000	7511	3818	47	0	\N
251197	1874	200691000	7511	3818	48	0	\N
251198	1874	200692000	7511	3818	49	0	\N
251199	1874	200693000	7511	3818	50	0	\N
251200	1874	200694000	7511	3818	51	0	\N
251201	1874	200695000	7511	3818	52	0	\N
251202	1874	200696000	7511	3818	53	0	\N
251203	1874	200697000	7511	3818	54	0	\N
251204	1874	200698000	7511	3818	55	0	\N
251205	1874	200699000	7511	3818	56	0	\N
251206	1874	200700000	7511	3818	58	0	\N
251207	1874	200701000	7511	3818	59	0	\N
251208	1874	200702000	7511	3818	60	0	\N
251209	1874	200703000	7511	3818	61	0	\N
251210	1874	200704000	7511	3818	62	0	\N
251211	1874	200705000	7511	3818	63	0	\N
251212	1874	200706000	7511	3818	64	0	\N
251213	1874	200707000	7511	3818	65	0	\N
251214	1874	200708000	7511	3818	66	0	\N
251215	1874	200709000	7511	3818	67	0	\N
251216	1874	200710000	7511	3818	68	0	\N
251217	1874	200711000	7511	3818	69	0	\N
251218	1874	200712000	7511	3818	70	0	\N
251219	1874	200713000	7511	3818	71	0	\N
251220	1874	200714000	7511	3818	72	0	\N
251221	1874	200715000	7511	3818	73	0	\N
251222	1874	200716000	7511	3818	74	0	\N
251223	1874	200717000	7511	3818	75	0	\N
251224	1874	200718000	7511	3818	76	0	\N
251225	1874	200719000	7511	3818	77	0	\N
251226	1874	200720000	7511	3818	78	0	\N
251227	1874	200721000	7511	3818	79	0	\N
251228	1874	200722000	7511	3818	80	0	\N
251229	1874	200723000	7511	3818	81	0	\N
251230	1874	200724000	7511	3818	82	0	\N
251231	1874	200725000	7511	3818	83	0	\N
251232	1874	200726000	7511	3818	84	0	\N
251233	1874	200727000	7511	3818	85	0	\N
251234	1874	200728000	7511	3818	86	0	\N
251235	1874	200729000	7511	3818	87	0	\N
251236	1874	200730000	7511	3818	88	0	\N
251237	1874	200731000	7511	3818	89	0	\N
251238	1874	200732000	7511	3818	90	0	\N
251239	1874	200733000	7511	3818	91	0	\N
251240	1874	200734000	7511	3818	92	0	\N
251241	1874	200735000	7511	3818	93	0	\N
251242	1874	200736000	7511	3818	94	0	\N
251243	1874	200737000	7511	3818	95	0	\N
251244	554	66010000000000	7511	3818	96	0	\N
251245	1874	200738000	7511	3818	97	0	\N
251246	1874	200739000	7511	3818	98	0	\N
251247	1874	200740000	7511	3818	99	0	\N
251248	1874	200741000	7511	3818	100	0	\N
251249	1874	200742000	7511	3818	101	0	\N
251250	1874	200743000	7511	3818	102	0	\N
251251	1874	200744000	7511	3818	103	0	\N
251252	1874	200745000	7511	3818	104	0	\N
251253	1874	200746000	7511	3818	105	0	\N
251254	1874	200747000	7511	3818	106	0	\N
251255	1874	200748000	7511	3818	107	0	\N
251256	1874	200749000	7511	3818	108	0	\N
251257	1874	200750000	7511	3818	109	0	\N
251258	1903	197000000000	7511	3818	110	0	\N
251259	321	66010000000000	7511	3818	111	0	\N
251260	1864	332000000000	7511	3818	112	0	\N
251261	1540	367308000000	7511	3818	113	0	\N
251262	1406	0	7511	3818	114	0	\N
251263	1403	0	7511	3818	115	0	\N
251264	44	77520830000000	7511	3818	116	0	\N
251269	1874	200748000	7513	3888	0	0	\N
251270	1874	200749000	7513	3888	1	0	\N
251271	1874	200750000	7513	3888	2	0	\N
251272	1864	332000000000	7513	3888	3	0	\N
251277	1874	200753000	7518	3892	0	0	\N
251278	1874	200754000	7519	3893	0	0	\N
251279	1874	200755000	7519	3893	1	0	\N
251280	1874	200756000	7519	3893	2	0	\N
251284	1874	200754000	7521	3893	0	0	\N
251285	1874	200755000	7521	3893	1	0	\N
251286	1874	200756000	7521	3893	2	0	\N
251290	1874	200759000	7525	3896	0	0	\N
251293	1898	10000000	7528	3678	0	0	\N
251294	1898	20000000	7528	3678	1	0	\N
251295	309	66282077824773	7528	3678	2	0	\N
251296	1874	200549000	7528	3678	3	0	\N
251297	150	66282077824773	7528	3678	4	0	\N
251298	92	66282077824773	7528	3678	5	0	\N
251299	63	66282077824773	7528	3678	6	0	\N
251300	1540	367308000000	7528	3678	7	0	\N
251301	1816	100000000	7528	3678	8	0	\N
251302	1299	1698983378602650	7528	3678	9	0	\N
251303	1053	903634158149000	7528	3678	10	0	\N
251304	1173	609699822388700	7528	3678	11	0	\N
251305	933	504262795497600	7528	3678	12	0	\N
251306	1903	98000000000	7528	3678	13	0	\N
251307	1874	200550000	7528	3678	16	0	\N
251308	1874	200551000	7528	3678	17	0	\N
251309	1874	200552000	7528	3678	18	0	\N
251310	1874	200553000	7528	3678	19	0	\N
251311	1874	200554000	7528	3678	20	0	\N
251312	1874	200555000	7528	3678	21	0	\N
251313	1874	200556000	7528	3678	22	0	\N
251314	1874	200557000	7528	3678	23	0	\N
251315	1874	200558000	7528	3678	24	0	\N
251316	1874	200559000	7528	3678	25	0	\N
251317	1874	200560000	7528	3678	26	0	\N
251318	1874	200561000	7528	3678	27	0	\N
251319	1874	200562000	7528	3678	28	0	\N
251320	1874	200563000	7528	3678	29	0	\N
251321	1874	200564000	7528	3678	30	0	\N
251322	1874	200565000	7528	3678	31	0	\N
251323	1874	200566000	7528	3678	32	0	\N
251324	1874	200567000	7528	3678	33	0	\N
251325	1874	200568000	7528	3678	34	0	\N
251326	1874	200569000	7528	3678	35	0	\N
251327	1874	200570000	7528	3678	36	0	\N
251328	1874	200571000	7528	3678	37	0	\N
251267	1874	200750000	7512	3888	2	0	0
251268	1864	332000000000	7512	3888	3	0	0
251273	1540	367308000000	7514	3889	0	0	2
251274	1874	200751000	7515	3890	0	0	0
251275	1874	200752000	7516	3891	0	0	0
251281	1874	200754000	7520	3893	0	0	0
251282	1874	200755000	7520	3893	1	0	0
251283	1874	200756000	7520	3893	2	0	0
251287	1874	200757000	7522	3894	0	0	0
251288	1874	200758000	7523	3895	0	0	0
251291	1874	200760000	7527	3897	0	0	0
251292	1874	200761000	7527	3897	1	0	0
251329	1874	200572000	7528	3678	38	0	\N
251330	1874	200573000	7528	3678	39	0	\N
251331	1874	200574000	7528	3678	40	0	\N
251332	1874	200575000	7528	3678	41	0	\N
251333	1874	200576000	7528	3678	42	0	\N
251334	1874	200577000	7528	3678	44	0	\N
251335	1874	200578000	7528	3678	45	0	\N
251336	1874	200579000	7528	3678	46	0	\N
251337	1874	200580000	7528	3678	47	0	\N
251338	1874	200581000	7528	3678	48	0	\N
251339	1874	200582000	7528	3678	49	0	\N
251340	1874	200583000	7528	3678	50	0	\N
251341	1874	200584000	7528	3678	51	0	\N
251342	1874	200585000	7528	3678	52	0	\N
251343	1874	200586000	7528	3678	53	0	\N
251344	1874	200587000	7528	3678	54	0	\N
251345	1874	200588000	7528	3678	55	0	\N
251346	1874	200589000	7528	3678	56	0	\N
251347	1874	200590000	7528	3678	57	0	\N
251348	1874	200591000	7528	3678	58	0	\N
251349	1874	200592000	7528	3678	59	0	\N
251350	1874	200593000	7528	3678	60	0	\N
251351	1874	200594000	7528	3678	61	0	\N
251352	1874	200595000	7528	3678	62	0	\N
251353	1874	200596000	7528	3678	63	0	\N
251354	1874	200597000	7528	3678	64	0	\N
251355	1874	200598000	7528	3678	65	0	\N
251356	1874	200599000	7528	3678	66	0	\N
251357	1874	200600000	7528	3678	67	0	\N
251358	1874	200601000	7528	3678	68	0	\N
251359	1874	200602000	7528	3678	69	0	\N
251360	1874	200603000	7528	3678	70	0	\N
251361	1874	200604000	7528	3678	71	0	\N
251362	1874	200605000	7528	3678	72	0	\N
251363	1874	200606000	7528	3678	73	0	\N
251364	1874	200607000	7528	3678	74	0	\N
251365	1874	200608000	7528	3678	75	0	\N
251366	1874	200609000	7528	3678	76	0	\N
251367	1874	200610000	7528	3678	77	0	\N
251368	450	66282077824773	7528	3678	78	0	\N
251369	452	66282077824773	7528	3678	79	0	\N
251370	322	66282077824773	7528	3678	80	0	\N
251371	373	66282077824773	7528	3678	81	0	\N
251372	408	66282077824773	7528	3678	82	0	\N
251373	453	66282077824773	7528	3678	83	0	\N
251374	593	66282077824773	7528	3678	84	0	\N
251375	91	66282077824773	7528	3678	85	0	\N
251376	438	66282077824773	7528	3678	86	0	\N
251377	339	66282077824773	7528	3678	87	0	\N
251378	594	66282077824773	7528	3678	88	0	\N
251379	601	66282077824773	7528	3678	89	0	\N
251380	680	66282077824773	7528	3678	90	0	\N
251381	392	66282077824773	7528	3678	91	0	\N
251382	690	66282077824773	7528	3678	92	0	\N
251383	186	66282077824773	7528	3678	93	0	\N
251384	89	66282077824773	7528	3678	94	0	\N
251385	1811	544686008347	7528	3678	95	0	\N
251386	383	66282077824773	7528	3678	96	0	\N
251387	308	66282077824773	7528	3678	97	0	\N
251388	1811	671972675517	7528	3678	98	0	\N
251389	1150	610502785413452	7528	3678	99	0	\N
251390	84	66282077824773	7528	3678	100	0	\N
251391	678	66282077824773	7528	3678	101	0	\N
251392	731	2008547812829	7528	3678	102	0	\N
251393	295	66282077824773	7528	3678	103	0	\N
251394	551	66282077824773	7528	3678	104	0	\N
251395	554	66010000000000	7528	3678	105	0	\N
251396	1874	200611000	7528	3678	106	0	\N
251397	1874	200612000	7528	3678	107	0	\N
251398	1874	200613000	7528	3678	108	0	\N
251399	1874	200614000	7528	3678	109	0	\N
251400	1874	200615000	7528	3678	110	0	\N
251401	1874	200616000	7528	3678	111	0	\N
251402	1874	200617000	7528	3678	112	0	\N
251403	1874	200618000	7528	3678	113	0	\N
251404	1874	200619000	7528	3678	114	0	\N
251405	1874	200620000	7528	3678	115	0	\N
251406	1874	200621000	7528	3678	116	0	\N
251407	1874	200622000	7528	3678	117	0	\N
251408	1874	200623000	7528	3678	118	0	\N
251409	1874	200624000	7528	3678	119	0	\N
251410	1874	200625000	7528	3678	120	0	\N
251411	1874	200626000	7528	3678	121	0	\N
251412	1874	200627000	7528	3678	122	0	\N
251413	1874	200628000	7528	3678	123	0	\N
251414	1874	200629000	7528	3678	124	0	\N
251415	1874	200630000	7528	3678	125	0	\N
251416	1898	10000000	7529	3696	1	0	\N
251417	1898	20000000	7529	3696	2	0	\N
251418	309	66282077824773	7529	3696	3	0	\N
251419	150	66282077824773	7529	3696	4	0	\N
251420	92	66282077824773	7529	3696	5	0	\N
251421	63	66282077824773	7529	3696	6	0	\N
251422	1540	367308000000	7529	3696	7	0	\N
251423	1816	100000000	7529	3696	8	0	\N
251424	1903	98000000000	7529	3696	9	0	\N
251425	1874	200592000	7529	3696	10	0	\N
251426	1874	200593000	7529	3696	11	0	\N
251427	1874	200594000	7529	3696	12	0	\N
251428	1874	200595000	7529	3696	13	0	\N
251429	1874	200596000	7529	3696	14	0	\N
251430	1874	200597000	7529	3696	15	0	\N
251431	1874	200598000	7529	3696	16	0	\N
251432	1874	200599000	7529	3696	17	0	\N
251433	1874	200600000	7529	3696	18	0	\N
251434	1874	200601000	7529	3696	19	0	\N
251435	1874	200602000	7529	3696	20	0	\N
251436	1874	200603000	7529	3696	21	0	\N
251437	1874	200604000	7529	3696	22	0	\N
251438	1874	200605000	7529	3696	23	0	\N
251439	1874	200606000	7529	3696	24	0	\N
251440	1874	200607000	7529	3696	25	0	\N
251441	1874	200608000	7529	3696	26	0	\N
251442	1874	200609000	7529	3696	27	0	\N
251443	1874	200610000	7529	3696	28	0	\N
251444	450	66282077824773	7529	3696	29	0	\N
251445	452	66282077824773	7529	3696	30	0	\N
251446	322	66282077824773	7529	3696	31	0	\N
251447	373	66282077824773	7529	3696	32	0	\N
251448	408	66282077824773	7529	3696	33	0	\N
251449	453	66282077824773	7529	3696	34	0	\N
251450	593	66282077824773	7529	3696	35	0	\N
251451	91	66282077824773	7529	3696	36	0	\N
251452	438	66282077824773	7529	3696	37	0	\N
251453	339	66282077824773	7529	3696	38	0	\N
251454	594	66282077824773	7529	3696	39	0	\N
251455	601	66282077824773	7529	3696	40	0	\N
251456	680	66282077824773	7529	3696	41	0	\N
251457	392	66282077824773	7529	3696	42	0	\N
251458	690	66282077824773	7529	3696	43	0	\N
251459	186	66282077824773	7529	3696	44	0	\N
251460	89	66282077824773	7529	3696	45	0	\N
251461	1811	544686008347	7529	3696	46	0	\N
251462	383	66282077824773	7529	3696	47	0	\N
251463	308	66282077824773	7529	3696	48	0	\N
251464	1811	671972675517	7529	3696	49	0	\N
251465	1150	610502785413452	7529	3696	50	0	\N
251466	84	66282077824773	7529	3696	51	0	\N
251467	678	66282077824773	7529	3696	52	0	\N
251468	731	2008547812829	7529	3696	53	0	\N
251469	295	66282077824773	7529	3696	54	0	\N
251470	551	66282077824773	7529	3696	55	0	\N
251471	554	66010000000000	7529	3696	56	0	\N
251472	1874	200611000	7529	3696	57	0	\N
251473	1874	200612000	7529	3696	58	0	\N
251474	1874	200613000	7529	3696	59	0	\N
251475	1874	200614000	7529	3696	60	0	\N
251476	1874	200615000	7529	3696	61	0	\N
251477	1874	200616000	7529	3696	62	0	\N
251478	1874	200617000	7529	3696	63	0	\N
251479	1874	200618000	7529	3696	64	0	\N
251480	1874	200619000	7529	3696	65	0	\N
251481	1874	200620000	7529	3696	66	0	\N
251482	1874	200621000	7529	3696	67	0	\N
251483	1874	200622000	7529	3696	68	0	\N
251484	1874	200623000	7529	3696	69	0	\N
251485	1874	200624000	7529	3696	70	0	\N
251486	1874	200625000	7529	3696	71	0	\N
251487	1874	200626000	7529	3696	72	0	\N
251488	1874	200627000	7529	3696	73	0	\N
251489	1874	200628000	7529	3696	74	0	\N
251490	1874	200629000	7529	3696	75	0	\N
251491	1874	200630000	7529	3696	76	0	\N
251492	1874	200631000	7529	3696	77	0	\N
251493	1874	200632000	7529	3696	78	0	\N
251494	1874	200633000	7529	3696	79	0	\N
251495	1874	200634000	7529	3696	80	0	\N
251496	1874	200635000	7529	3696	81	0	\N
251497	1874	200636000	7529	3696	82	0	\N
251498	1874	200637000	7529	3696	83	0	\N
251499	1874	200638000	7529	3696	84	0	\N
251500	1874	200639000	7529	3696	86	0	\N
251501	1874	200640000	7529	3696	87	0	\N
251502	1874	200641000	7529	3696	88	0	\N
251503	1874	200642000	7529	3696	89	0	\N
251504	1874	200643000	7529	3696	90	0	\N
251505	1874	200644000	7529	3696	91	0	\N
251506	1874	200645000	7529	3696	92	0	\N
251507	1874	200646000	7529	3696	93	0	\N
251508	1874	200647000	7529	3696	94	0	\N
251509	520	66282077824773	7529	3696	95	0	\N
251510	653	66282077824773	7529	3696	96	0	\N
251511	622	66285057824773	7529	3696	97	0	\N
251512	105	66282077824773	7529	3696	98	0	\N
251513	122	66282077824773	7529	3696	99	0	\N
251514	721	2008547812829	7529	3696	100	0	\N
251515	206	66282077824773	7529	3696	101	0	\N
251516	304	66282077824773	7529	3696	102	0	\N
251517	399	66282077824773	7529	3696	103	0	\N
251518	194	66282077824773	7529	3696	104	0	\N
251519	1276	1701220294435610	7529	3696	105	0	\N
251520	877	203449976855173	7529	3696	106	0	\N
251521	878	203450976855173	7529	3696	107	0	\N
251522	193	66282077824773	7529	3696	108	0	\N
251523	504	66282077824773	7529	3696	109	0	\N
251524	1811	685021273493	7529	3696	110	0	\N
251525	78	66282077824773	7529	3696	111	0	\N
251526	658	66282077824773	7529	3696	112	0	\N
251527	205	66282077824773	7529	3696	113	0	\N
251528	660	66282077824773	7529	3696	114	0	\N
251529	745	2008547812829	7529	3696	115	0	\N
251530	29	7029917345033	7529	3696	116	0	\N
251531	138	66282077824773	7529	3696	117	0	\N
251532	146	66282077824773	7529	3696	118	0	\N
251533	395	66279047824773	7529	3696	119	0	\N
251534	587	66282077824773	7529	3696	120	0	\N
251535	910	504926523573708	7529	3696	121	0	\N
251536	500	66282077824773	7529	3696	122	0	\N
251537	611	66282077824773	7529	3696	123	0	\N
251538	225	66282077824773	7529	3696	124	0	\N
251539	377	66282077824773	7529	3696	125	0	\N
251540	1874	200762000	7530	3898	0	0	\N
251543	1874	200762000	7533	3898	0	0	\N
251544	1874	200763000	7533	3898	1	0	\N
251545	1874	200762000	7534	3898	0	0	\N
251546	1874	200763000	7534	3898	1	0	\N
251547	1874	200764000	7534	3898	2	0	\N
251550	1874	200766000	7537	3902	0	0	\N
251552	1874	200766000	7539	3902	0	0	\N
251554	1874	200768000	7541	3904	0	0	\N
251558	1874	200769000	7544	3905	0	0	\N
251559	1874	200770000	7544	3905	1	0	\N
251560	1874	200769000	7545	3905	0	0	\N
251561	1874	200770000	7545	3905	1	0	\N
251568	1874	200776000	7551	3910	0	0	\N
251571	1874	200779000	7553	3912	0	0	\N
251572	1874	200779000	7554	3912	0	0	\N
251574	1874	200780000	7556	3913	0	0	\N
251577	1874	200781000	7559	3914	0	0	\N
251578	1874	200782000	7560	3915	0	0	\N
251580	1874	200783000	7562	3916	0	0	\N
251581	1874	200783000	7563	3916	0	0	\N
251584	1874	200784000	7566	3917	0	0	\N
251585	1874	200784000	7567	3917	0	0	\N
251587	1874	200785000	7569	3918	0	0	\N
251588	1874	200786000	7570	3919	0	0	\N
251589	1874	200786000	7571	3919	0	0	\N
251590	1540	367308000000	7572	3886	0	0	\N
251591	1874	200786000	7573	3919	0	0	\N
251593	1874	200787000	7575	3920	0	0	\N
251594	1874	200787000	7576	3920	0	0	\N
251596	1874	200788000	7578	3921	0	0	\N
251597	321	66010000000000	7579	3881	0	0	\N
251598	1540	367308000000	7579	3881	1	0	\N
251599	1874	200739000	7579	3881	2	0	\N
251600	1874	200740000	7579	3881	3	0	\N
251548	1874	200764000	7535	3900	0	0	0
251549	1874	200765000	7536	3901	0	0	0
251551	1874	200766000	7538	3902	0	0	0
251553	1874	200767000	7540	3903	0	0	0
251555	1874	200768000	7542	3904	0	0	0
251557	1874	200770000	7543	3905	1	0	0
251562	1874	200771000	7546	3906	0	0	0
251563	1874	200772000	7547	3907	0	0	0
251564	1874	200773000	7547	3907	1	0	0
251565	1874	200774000	7548	3908	0	0	0
251567	1874	200776000	7550	3910	0	0	0
251569	1874	200777000	7552	3911	0	0	0
251570	1874	200778000	7552	3911	1	0	0
251573	1874	200779000	7555	3912	0	0	0
251576	1874	200781000	7558	3914	0	0	0
251579	1874	200782000	7561	3915	0	0	0
251582	1874	200783000	7564	3916	0	0	0
251583	1874	200784000	7565	3917	0	0	0
251586	1874	200785000	7568	3918	0	0	0
251595	1874	200787000	7577	3920	0	0	0
251601	1874	200741000	7579	3881	4	0	\N
251602	1874	200742000	7579	3881	5	0	\N
251603	1874	200743000	7579	3881	6	0	\N
251604	1874	200744000	7579	3881	7	0	\N
251605	1874	200745000	7579	3881	8	0	\N
251606	1874	200746000	7579	3881	9	0	\N
251607	1874	200747000	7579	3881	10	0	\N
251608	1874	200748000	7579	3881	11	0	\N
251609	1874	200749000	7579	3881	12	0	\N
251610	1874	200750000	7579	3881	13	0	\N
251611	1874	200751000	7579	3881	14	0	\N
251612	1874	200752000	7579	3881	15	0	\N
251613	1874	200753000	7579	3881	16	0	\N
251614	1874	200754000	7579	3881	17	0	\N
251615	1874	200755000	7579	3881	18	0	\N
251616	1874	200756000	7579	3881	19	0	\N
251617	1874	200757000	7579	3881	20	0	\N
251618	1874	200758000	7579	3881	21	0	\N
251619	1874	200759000	7579	3881	22	0	\N
251620	1874	200760000	7579	3881	23	0	\N
251621	1874	200761000	7579	3881	24	0	\N
251622	1874	200762000	7579	3881	25	0	\N
251623	1874	200763000	7579	3881	26	0	\N
251624	1874	200764000	7579	3881	27	0	\N
251625	1874	200765000	7579	3881	28	0	\N
251626	1874	200766000	7579	3881	29	0	\N
251627	1874	200767000	7579	3881	30	0	\N
251628	1874	200768000	7579	3881	31	0	\N
251629	1874	200769000	7579	3881	32	0	\N
251630	1874	200770000	7579	3881	33	0	\N
251631	1874	200771000	7579	3881	34	0	\N
251632	1874	200772000	7579	3881	35	0	\N
251633	1874	200773000	7579	3881	36	0	\N
251634	1874	200774000	7579	3881	37	0	\N
251635	1874	200775000	7579	3881	38	0	\N
251636	1874	200776000	7579	3881	39	0	\N
251637	1874	200777000	7579	3881	40	0	\N
251638	1874	200778000	7579	3881	41	0	\N
251639	1874	200779000	7579	3881	42	0	\N
251640	1874	200780000	7579	3881	43	0	\N
251641	1874	200781000	7579	3881	44	0	\N
251642	1874	200782000	7579	3881	45	0	\N
251643	1874	200783000	7579	3881	46	0	\N
251644	1874	200784000	7579	3881	47	0	\N
251645	1874	200785000	7579	3881	48	0	\N
251646	1874	200786000	7579	3881	49	0	\N
251647	1874	200787000	7579	3881	50	0	\N
251648	1864	332000000000	7579	3881	51	0	\N
251649	1874	200788000	7580	3921	0	0	\N
251650	1874	200788000	7581	3921	0	0	\N
251658	1874	200791000	7586	3924	0	0	\N
251659	1874	200792000	7586	3924	1	0	\N
251660	1874	200793000	7586	3924	2	0	\N
251661	1874	200794000	7586	3924	3	0	\N
251662	1874	200795000	7587	3925	0	0	\N
251663	1874	200795000	7588	3925	0	0	\N
251665	1874	200795000	7590	3925	0	0	\N
251666	1874	200796000	7590	3925	1	0	\N
251667	1874	200796000	7591	3926	0	0	\N
251668	1904	0	7591	3926	1	0	\N
251677	1874	200796000	7594	3927	0	0	\N
251678	1874	200797000	7594	3927	1	0	\N
251679	1874	200798000	7594	3927	2	0	\N
251680	1874	200799000	7594	3927	3	0	\N
251681	1874	200800000	7594	3927	4	0	\N
251682	1905	200000000	7594	3927	5	0	\N
251683	1906	200000000	7594	3927	6	0	\N
251685	1874	200802000	7596	3929	0	0	\N
251687	1874	200751000	7598	3819	0	0	\N
251688	1540	367308000000	7598	3819	1	0	\N
251689	1874	200752000	7598	3819	2	0	\N
251690	1874	200753000	7598	3819	3	0	\N
251691	1874	200754000	7598	3819	4	0	\N
251692	1874	200755000	7598	3819	5	0	\N
251693	1874	200756000	7598	3819	6	0	\N
251694	1874	200757000	7598	3819	7	0	\N
251695	1874	200758000	7598	3819	8	0	\N
251696	1874	200759000	7598	3819	9	0	\N
251697	1874	200760000	7598	3819	10	0	\N
251698	1874	200761000	7598	3819	11	0	\N
251699	1874	200762000	7598	3819	12	0	\N
251700	1874	200763000	7598	3819	13	0	\N
251701	1874	200764000	7598	3819	14	0	\N
251702	1874	200765000	7598	3819	15	0	\N
251703	1874	200766000	7598	3819	16	0	\N
251704	1874	200767000	7598	3819	17	0	\N
251705	1874	200768000	7598	3819	18	0	\N
251706	1874	200769000	7598	3819	19	0	\N
251707	1874	200770000	7598	3819	20	0	\N
251708	1874	200771000	7598	3819	21	0	\N
251709	1874	200772000	7598	3819	22	0	\N
251710	1874	200773000	7598	3819	23	0	\N
251711	1874	200774000	7598	3819	24	0	\N
251712	1874	200775000	7598	3819	25	0	\N
251713	1874	200776000	7598	3819	26	0	\N
251714	1874	200777000	7598	3819	27	0	\N
251715	1874	200778000	7598	3819	28	0	\N
251716	1874	200779000	7598	3819	29	0	\N
251717	1874	200780000	7598	3819	30	0	\N
251718	1874	200781000	7598	3819	31	0	\N
251719	1874	200782000	7598	3819	32	0	\N
251720	1874	200783000	7598	3819	33	0	\N
251721	1874	200784000	7598	3819	34	0	\N
251722	1874	200785000	7598	3819	35	0	\N
251723	1874	200786000	7598	3819	36	0	\N
251724	1874	200787000	7598	3819	37	0	\N
251725	1874	200788000	7598	3819	38	0	\N
251726	1874	200789000	7598	3819	39	0	\N
251727	1874	200790000	7598	3819	40	0	\N
251728	1874	200791000	7598	3819	41	0	\N
251729	1874	200792000	7598	3819	42	0	\N
251730	1874	200793000	7598	3819	43	0	\N
251731	1874	200794000	7598	3819	44	0	\N
251732	1874	200795000	7598	3819	45	0	\N
251733	1874	200796000	7598	3819	46	0	\N
251734	1874	200797000	7598	3819	47	0	\N
251735	1874	200798000	7598	3819	48	0	\N
251736	1874	200799000	7598	3819	49	0	\N
251653	1874	200790000	7584	3923	0	0	0
251654	1874	200791000	7585	3924	0	0	0
251655	1874	200792000	7585	3924	1	0	0
251656	1874	200793000	7585	3924	2	0	0
251657	1874	200794000	7585	3924	3	0	0
251669	1904	0	7592	3926	0	0	0
251670	1874	200796000	7593	3927	0	0	0
251671	1874	200797000	7593	3927	1	0	0
251672	1874	200798000	7593	3927	2	0	0
251673	1874	200799000	7593	3927	3	0	0
251675	1905	200000000	7593	3927	5	0	0
251676	1906	200000000	7593	3927	6	0	0
251684	1874	200801000	7595	3928	0	0	0
251686	1874	200802000	7597	3929	0	0	0
251737	1874	200800000	7598	3819	50	0	\N
251738	1905	200000000	7598	3819	51	0	\N
251739	1906	200000000	7598	3819	52	0	\N
251740	1874	200801000	7598	3819	53	0	\N
251741	1874	200802000	7598	3819	54	0	\N
251754	1874	200813000	7606	3937	0	0	\N
251757	1874	200814000	7611	3938	0	0	\N
251758	1908	0	7611	3938	1	0	\N
251759	1874	200815000	7611	3938	2	0	\N
251760	1874	200814000	7612	3939	0	0	\N
251761	1874	200815000	7612	3939	1	0	\N
251762	1874	200816000	7612	3939	2	0	\N
251766	1874	200814000	7614	3939	0	0	\N
251767	1874	200815000	7614	3939	1	0	\N
251768	1874	200816000	7614	3939	2	0	\N
251769	1874	200817000	7615	3940	0	0	\N
251770	1874	200818000	7615	3940	1	0	\N
251774	1874	200819000	7619	3941	0	0	\N
251775	1874	200820000	7621	3943	0	0	\N
251776	1874	200821000	7621	3943	1	0	\N
251777	1773	6156202499973	7621	3943	2	0	\N
251785	321	66010000000000	7624	3874	0	0	\N
251786	1540	367308000000	7624	3874	1	0	\N
251787	1904	0	7624	3874	2	0	\N
251788	1908	0	7624	3874	3	0	\N
251789	1864	332000000000	7624	3874	4	0	\N
251790	1773	6156202499973	7624	3874	5	0	\N
251791	1874	200826000	7625	3945	0	0	\N
251792	1874	200827000	7625	3945	1	0	\N
251795	1874	200826000	7627	3945	0	0	\N
251796	1874	200827000	7627	3945	1	0	\N
251810	1874	200839000	7636	3952	0	0	\N
251812	1874	200840000	7638	3953	0	0	\N
251813	1874	200840000	7639	3953	0	0	\N
251823	1910	0	7641	3953	0	0	\N
251824	182	66307853597696	7642	3954	0	0	\N
251825	1874	200841000	7642	3954	1	0	\N
251826	1910	0	7642	3954	2	0	\N
251827	1874	200842000	7642	3954	3	0	\N
251828	702	44205235731806	7642	3954	4	0	\N
251829	927	505121132301246	7642	3954	5	0	\N
251830	1047	905172741205956	7642	3954	6	0	\N
251831	1167	609738084332646	7642	3954	7	0	\N
251832	1293	1701875978582222	7642	3954	8	0	\N
251833	182	66307853597696	7643	3954	0	0	\N
251834	1874	200841000	7643	3954	1	0	\N
251835	1910	0	7643	3954	2	0	\N
251836	1874	200842000	7643	3954	3	0	\N
251837	702	44205235731806	7643	3954	4	0	\N
251838	927	505121132301246	7643	3954	5	0	\N
251839	1047	905172741205956	7643	3954	6	0	\N
251840	1167	609738084332646	7643	3954	7	0	\N
251841	1293	1701875978582222	7643	3954	8	0	\N
251842	1540	367308000000	7644	3820	0	0	\N
251843	1874	200803000	7644	3820	1	0	\N
251844	1874	200804000	7644	3820	2	0	\N
251845	1874	200805000	7644	3820	3	0	\N
251846	1874	200806000	7644	3820	4	0	\N
251847	1874	200807000	7644	3820	5	0	\N
251848	1907	200000000	7644	3820	6	0	\N
251849	1874	200808000	7644	3820	8	0	\N
251850	1874	200809000	7644	3820	9	0	\N
251851	1874	200810000	7644	3820	10	0	\N
251852	1874	200811000	7644	3820	11	0	\N
251853	1874	200812000	7644	3820	12	0	\N
251854	1874	200813000	7644	3820	13	0	\N
251855	1874	200814000	7644	3820	14	0	\N
251856	1874	200815000	7644	3820	15	0	\N
251857	1874	200816000	7644	3820	16	0	\N
251858	1874	200817000	7644	3820	17	0	\N
251859	1874	200818000	7644	3820	18	0	\N
251860	1874	200819000	7644	3820	19	0	\N
251861	1874	200820000	7644	3820	20	0	\N
251862	1874	200821000	7644	3820	21	0	\N
251863	1874	200822000	7644	3820	22	0	\N
251864	1874	200823000	7644	3820	23	0	\N
251865	1874	200824000	7644	3820	24	0	\N
251866	1874	200825000	7644	3820	25	0	\N
251867	1874	200826000	7644	3820	26	0	\N
251868	1874	200827000	7644	3820	27	0	\N
251869	1874	200828000	7644	3820	28	0	\N
251870	1874	200829000	7644	3820	29	0	\N
251871	1874	200830000	7644	3820	30	0	\N
251872	1874	200831000	7644	3820	31	0	\N
251744	1874	200805000	7600	3931	1	0	0
251745	1540	367308000000	7601	3932	0	0	2
251746	1874	200806000	7601	3932	1	0	0
251747	1874	200807000	7601	3932	2	0	0
251748	1907	200000000	7601	3932	3	0	0
251750	1874	200809000	7602	3933	0	0	0
251751	1874	200810000	7603	3934	0	0	0
251752	1874	200811000	7604	3935	0	0	0
251753	1874	200812000	7605	3936	0	0	0
251755	1874	200813000	7608	3937	0	0	0
251763	1874	200814000	7613	3939	0	0	0
251764	1874	200815000	7613	3939	1	0	0
251765	1874	200816000	7613	3939	2	0	0
251771	1874	200817000	7616	3940	0	0	0
251773	1874	200819000	7618	3941	0	0	0
251778	1874	200820000	7622	3943	0	0	0
251779	1874	200821000	7622	3943	1	0	0
251780	1773	6156202499973	7622	3943	2	0	12
251781	1874	200822000	7623	3944	0	0	0
251783	1874	200824000	7623	3944	2	0	0
251784	1874	200825000	7623	3944	3	0	0
251793	1874	200826000	7626	3945	0	0	0
251794	1874	200827000	7626	3945	1	0	0
251797	1874	200828000	7629	3946	0	0	0
251799	1874	200830000	7629	3946	2	0	0
251800	1909	0	7629	3946	3	0	0
251801	1874	200831000	7629	3946	4	0	0
251802	1874	200832000	7629	3946	5	0	0
251804	1874	200834000	7631	3948	0	0	0
251805	1874	200835000	7632	3949	0	0	0
251806	1874	200836000	7632	3949	1	0	0
251807	1874	200837000	7633	3950	0	0	0
251808	1874	200838000	7634	3951	0	0	0
251811	1874	200840000	7637	3953	0	0	0
251814	182	66307853597696	7640	3954	0	0	0
251815	1874	200841000	7640	3954	1	0	0
251816	1910	0	7640	3954	2	0	0
251817	1874	200842000	7640	3954	3	0	0
251819	927	505121132301246	7640	3954	5	0	0
251820	1047	905172741205956	7640	3954	6	0	0
251821	1167	609738084332646	7640	3954	7	0	1
251822	1293	1701875978582222	7640	3954	8	0	0
251873	1874	200832000	7644	3820	32	0	\N
251874	1874	200833000	7644	3820	33	0	\N
251875	1874	200834000	7644	3820	34	0	\N
251876	1874	200835000	7644	3820	35	0	\N
251877	1874	200836000	7644	3820	36	0	\N
251878	1874	200837000	7644	3820	37	0	\N
251879	1874	200838000	7644	3820	38	0	\N
251880	1874	200839000	7644	3820	39	0	\N
251881	1874	200840000	7644	3820	40	0	\N
251882	1874	200841000	7644	3820	41	0	\N
251883	1874	200842000	7644	3820	42	0	\N
251884	1773	6156202499973	7644	3820	43	0	\N
251889	1874	200847000	7648	3958	0	0	\N
251890	1874	200848000	7648	3958	1	0	\N
251893	1874	200843000	7651	3821	0	0	\N
251894	1874	200844000	7651	3821	1	0	\N
251895	1874	200845000	7651	3821	2	0	\N
251896	1874	200846000	7651	3821	3	0	\N
251897	1874	200847000	7651	3821	4	0	\N
251898	1874	200848000	7651	3821	5	0	\N
251899	1874	200849000	7651	3821	6	0	\N
251900	1874	200850000	7651	3821	7	0	\N
251906	1874	200851000	7654	3961	0	0	\N
251907	1874	200852000	7654	3961	1	0	\N
251911	1874	200855000	7657	3963	0	0	\N
251914	1874	200858000	7661	3966	0	0	\N
251915	1874	200859000	7661	3966	1	0	\N
251916	1874	200858000	7663	3966	0	0	\N
251917	1874	200859000	7663	3966	1	0	\N
251925	1874	200861000	7666	3969	0	0	\N
251926	1874	200862000	7666	3969	1	0	\N
251927	1874	200861000	7667	3969	0	0	\N
251928	1874	200862000	7667	3969	1	0	\N
251929	1874	200861000	7668	3969	0	0	\N
251930	1874	200862000	7668	3969	1	0	\N
251933	1874	200863000	7670	3970	0	0	\N
251942	1772	1489440235728	7675	3973	0	0	\N
251943	1772	1619388060501	7675	3973	1	0	\N
251944	1913	0	7675	3973	2	0	\N
251945	1874	200866000	7675	3973	3	0	\N
251946	1772	2016078296229	7675	3973	4	0	\N
251952	1874	200872000	7679	3977	0	0	\N
251954	1874	200873000	7682	3978	0	0	\N
251958	1874	200873000	7684	3979	0	0	\N
251959	1874	200874000	7684	3979	1	0	\N
251960	1874	200875000	7684	3979	2	0	\N
251965	1874	200879000	7688	3982	0	0	\N
251970	1874	200884000	7692	3985	0	0	\N
251974	1874	200886000	7694	3987	0	0	\N
251976	1874	200887000	7696	3988	0	0	\N
251978	1874	200888000	7698	3989	0	0	\N
251980	1874	200888000	7700	3989	0	0	\N
251982	1874	200890000	7702	3991	0	0	\N
251984	1874	200890000	7704	3991	0	0	\N
251985	1874	200890000	7705	3991	0	0	\N
251987	1874	200889000	7707	3990	0	0	\N
251988	1874	200890000	7707	3990	1	0	\N
251989	1874	200891000	7707	3990	2	0	\N
251990	1874	200892000	7708	3993	0	0	\N
251991	1874	200893000	7708	3993	1	0	\N
251994	1874	200894000	7710	3994	0	0	\N
251996	1874	200894000	7712	3994	0	0	\N
251999	1874	200896000	7715	3996	0	0	\N
252002	1874	200898000	7718	3998	0	0	\N
252003	1874	200898000	7719	3998	0	0	\N
252004	1874	200898000	7720	3998	0	0	\N
252005	1874	200898000	7721	3998	0	0	\N
252007	1874	200899000	7723	3999	0	0	\N
251887	1874	200845000	7646	3956	1	0	0
251888	1874	200846000	7647	3957	0	0	0
251891	1874	200847000	7649	3958	0	0	0
251892	1874	200848000	7649	3958	1	0	0
251901	1874	200849000	7652	3960	0	0	0
251903	1911	0	7652	3960	2	0	0
251904	1874	200851000	7653	3961	0	0	0
251905	1874	200852000	7653	3961	1	0	0
251908	1874	200853000	7655	3962	0	0	0
251909	1874	200854000	7655	3962	1	0	0
251912	1874	200856000	7659	3964	0	0	0
251913	1874	200857000	7660	3965	0	0	0
251918	1912	0	7664	3967	0	0	0
251919	1874	200858000	7664	3967	1	0	0
251921	1874	200860000	7664	3967	3	0	0
251922	1483	0	7665	3968	0	0	0
251923	1483	0	7665	3968	1	0	0
251924	1483	0	7665	3968	2	0	0
251931	1874	200861000	7669	3969	0	0	0
251934	1874	200863000	7671	3970	0	0	0
251935	1874	200864000	7672	3971	0	0	0
251936	1874	200865000	7673	3972	0	0	0
251937	1772	1489440235728	7674	3973	0	0	1
251938	1772	1619388060501	7674	3973	1	0	1
251940	1874	200866000	7674	3973	3	0	0
251941	1772	2016078296229	7674	3973	4	0	1
251947	1874	200867000	7677	3975	0	0	0
251948	1874	200868000	7677	3975	2	0	0
251950	1874	200870000	7677	3975	4	0	0
251951	1874	200871000	7678	3976	0	0	0
251953	1874	200872000	7680	3977	0	0	0
251955	1874	200873000	7683	3979	0	0	0
251956	1874	200874000	7683	3979	1	0	0
251961	1874	200876000	7685	3980	0	0	0
251962	1874	200877000	7685	3980	1	0	0
251963	1874	200878000	7686	3981	0	0	0
251964	1874	200879000	7687	3982	0	0	0
251966	1874	200880000	7689	3983	0	0	0
251968	1874	200882000	7689	3983	2	0	0
251969	1874	200883000	7690	3984	0	0	0
251971	189	66000200000000	7693	3986	0	0	0
251972	1874	200884000	7693	3986	1	0	0
251975	1874	200886000	7695	3987	0	0	0
251977	1874	200887000	7697	3988	0	0	0
251979	1874	200888000	7699	3989	0	0	0
251981	1874	200889000	7701	3990	0	0	0
251983	1874	200890000	7703	3991	0	0	0
251992	1874	200892000	7709	3993	0	0	0
251993	1874	200893000	7709	3993	1	0	0
251995	1874	200894000	7711	3994	0	0	0
251997	1874	200895000	7713	3995	0	0	0
251998	1874	200896000	7714	3996	0	0	0
252001	1874	200898000	7717	3998	0	0	0
252006	1874	200899000	7722	3999	0	0	0
252008	1874	200900000	7724	4000	0	0	0
252018	1874	200908000	7731	4005	0	0	\N
252023	1874	200913000	7734	4008	0	0	\N
252025	1874	200896000	7736	3996	0	0	\N
252026	1874	200897000	7736	3996	1	0	\N
252027	1874	200898000	7736	3996	2	0	\N
252028	1874	200899000	7736	3996	3	0	\N
252029	1874	200900000	7736	3996	4	0	\N
252030	1874	200901000	7736	3996	5	0	\N
252031	1874	200902000	7736	3996	6	0	\N
252032	1874	200903000	7736	3996	7	0	\N
252033	1874	200904000	7736	3996	8	0	\N
252034	1874	200905000	7736	3996	9	0	\N
252035	1914	200000000	7736	3996	10	0	\N
252036	1874	200906000	7736	3996	11	0	\N
252037	1874	200907000	7736	3996	12	0	\N
252038	1874	200908000	7736	3996	13	0	\N
252039	1874	200909000	7736	3996	14	0	\N
252040	1874	200910000	7736	3996	15	0	\N
252041	1874	200911000	7736	3996	16	0	\N
252042	1874	200912000	7736	3996	17	0	\N
252043	1874	200913000	7736	3996	18	0	\N
252049	1874	200918000	7742	4012	0	0	\N
252053	1874	200919000	7746	4015	0	0	\N
252054	1874	200920000	7746	4015	1	0	\N
252055	1874	200921000	7746	4015	2	0	\N
252057	1874	200922000	7748	4016	0	0	\N
252061	1874	200926000	7751	4019	0	0	\N
252062	1874	200926000	7752	4019	0	0	\N
252063	1874	200926000	7753	4019	0	0	\N
252065	1874	200926000	7755	4019	0	0	\N
252069	1874	200929000	7759	4022	0	0	\N
252070	1874	200928000	7760	4021	0	0	\N
252071	1874	200929000	7760	4021	1	0	\N
252075	1874	200933000	7763	4025	0	0	\N
252077	1874	200933000	7765	4025	0	0	\N
252086	1874	200941000	7771	4030	0	0	\N
252087	1874	200941000	7772	4030	0	0	\N
252089	1874	200942000	7774	4031	0	0	\N
252090	1874	200943000	7775	4032	0	0	\N
252092	1874	200944000	7777	4033	0	0	\N
252094	1874	200944000	7779	4033	0	0	\N
252096	1874	200946000	7782	4035	0	0	\N
252098	1874	200947000	7784	4036	0	0	\N
252099	1874	200948000	7784	4036	1	0	\N
252106	1874	200951000	7788	4038	0	0	\N
252111	1874	200953000	7791	4040	0	0	\N
252112	1874	200954000	7792	4041	0	0	\N
252114	1874	200954000	7794	4041	0	0	\N
252115	1874	200954000	7795	4041	0	0	\N
252117	1874	200956000	7797	4043	0	0	\N
252121	1874	200959000	7800	4045	0	0	\N
252123	1874	200959000	7802	4045	0	0	\N
252126	1874	200961000	7805	4047	0	0	\N
252127	1874	200962000	7806	4048	0	0	\N
252128	1874	200962000	7807	4048	0	0	\N
252129	1874	200962000	7808	4048	0	0	\N
252131	1874	200963000	7810	4049	0	0	\N
252132	1874	200964000	7810	4049	1	0	\N
252135	1874	200965000	7812	4050	0	0	\N
252138	1874	200966000	7815	4051	0	0	\N
252139	1874	200966000	7816	4051	0	0	\N
252141	1874	200968000	7819	4054	0	0	\N
252142	1874	200969000	7819	4054	1	0	\N
252143	1874	200970000	7819	4054	2	0	\N
252144	1874	200971000	7819	4054	3	0	\N
252011	1874	200903000	7726	4002	0	0	0
252012	1874	200904000	7727	4003	0	0	0
252013	1874	200905000	7727	4003	1	0	0
252014	1914	200000000	7729	4004	0	0	0
252015	1874	200906000	7729	4004	1	0	0
252017	1874	200908000	7730	4005	0	0	0
252019	1874	200909000	7732	4006	0	0	0
252020	1874	200910000	7733	4007	0	0	0
252021	1874	200911000	7733	4007	1	0	0
252022	1874	200912000	7733	4007	2	0	0
252044	1874	200914000	7737	4009	0	0	0
252045	1874	200915000	7738	4010	0	0	0
252046	1874	200916000	7738	4010	1	0	0
252047	1874	200917000	7740	4011	0	0	0
252050	1874	200919000	7745	4015	0	0	0
252051	1874	200920000	7745	4015	1	0	0
252052	1874	200921000	7745	4015	2	0	0
252056	1874	200922000	7747	4016	0	0	0
252058	1874	200923000	7749	4017	0	0	0
252060	1874	200925000	7750	4018	1	0	0
252064	1874	200926000	7754	4019	0	0	0
252066	1874	200927000	7756	4020	0	0	0
252067	1874	200928000	7757	4021	0	0	0
252068	1874	200929000	7758	4022	0	0	0
252073	1874	200931000	7762	4024	1	0	0
252074	1874	200932000	7762	4024	2	0	0
252076	1874	200933000	7764	4025	0	0	0
252078	1874	200934000	7767	4027	0	0	0
252080	1874	200936000	7767	4027	2	0	0
252081	1874	200937000	7768	4028	0	0	0
252082	1874	200938000	7768	4028	1	0	0
252083	1874	200939000	7768	4028	2	0	0
252084	1874	200940000	7769	4029	0	0	0
252088	1874	200942000	7773	4031	0	0	0
252091	1874	200943000	7776	4032	0	0	0
252093	1874	200944000	7778	4033	0	0	0
252095	1874	200945000	7781	4034	0	0	0
252097	1874	200946000	7783	4035	0	0	0
252101	1874	200948000	7785	4036	1	0	0
252102	1874	200949000	7786	4037	0	0	0
252103	1874	200950000	7786	4037	1	0	0
252104	1498	0	7786	4037	2	0	0
252107	1874	200952000	7789	4039	0	0	0
252108	1915	200000000	7789	4039	1	0	0
252109	1916	200000000	7789	4039	2	0	0
252110	1874	200953000	7790	4040	0	0	0
252113	1874	200954000	7793	4041	0	0	0
252118	1874	200956000	7798	4043	0	0	0
252119	1874	200957000	7799	4044	0	0	0
252120	1874	200958000	7799	4044	1	0	0
252122	1874	200959000	7801	4045	0	0	0
252124	1874	200960000	7803	4046	0	0	0
252130	1874	200962000	7809	4048	0	0	0
252133	1874	200963000	7811	4049	0	0	0
252134	1874	200964000	7811	4049	1	0	0
252136	1874	200965000	7813	4050	0	0	0
252140	1874	200967000	7817	4052	0	0	0
252149	1874	200972000	7821	4055	0	0	\N
252150	1874	200973000	7821	4055	1	0	\N
252153	1874	200974000	7823	4056	0	0	\N
252156	1874	200976000	7826	4058	0	0	\N
252159	1874	200978000	7829	4060	0	0	\N
252161	1874	200978000	7831	4060	0	0	\N
252162	1874	200978000	7832	4060	0	0	\N
252164	1874	200980000	7834	4062	0	0	\N
252166	1874	200980000	7836	4062	0	0	\N
252167	1874	200980000	7837	4062	0	0	\N
252168	1874	200981000	7838	4063	0	0	\N
252170	1917	0	7841	4064	0	0	\N
252171	1874	200982000	7841	4064	1	0	\N
252172	1874	200983000	7841	4064	2	0	\N
252173	1874	200984000	7841	4064	3	0	\N
252174	1874	200985000	7841	4064	4	0	\N
252175	1874	200986000	7841	4064	5	0	\N
252183	1874	200988000	7844	4066	0	0	\N
252184	1874	200989000	7844	4066	1	0	\N
252187	1874	200990000	7846	4067	0	0	\N
252188	1874	200990000	7847	4067	0	0	\N
252193	1874	200993000	7851	4069	0	0	\N
252198	1874	200998000	7854	4072	0	0	\N
252202	1874	201000000	7858	4074	0	0	\N
252204	1874	201001000	7860	4075	0	0	\N
252205	1874	201002000	7861	4076	0	0	\N
252206	1874	201002000	7862	4076	0	0	\N
252208	1874	201002000	7865	4076	0	0	\N
252209	1483	0	7866	3793	0	0	\N
252210	1483	0	7866	3793	1	0	\N
252211	189	66000200000000	7866	3793	2	0	\N
252212	1483	0	7866	3793	3	0	\N
252213	1898	10000000	7866	3793	5	0	\N
252214	1898	20000000	7866	3793	6	0	\N
252215	1540	367308000000	7866	3793	7	0	\N
252216	1816	100000000	7866	3793	8	0	\N
252217	1903	98000000000	7866	3793	9	0	\N
252218	1498	0	7866	3793	10	0	\N
252219	554	66010000000000	7866	3793	11	0	\N
252220	1903	197000000000	7866	3793	12	0	\N
252221	321	66010000000000	7866	3793	13	0	\N
252222	1864	332000000000	7866	3793	14	0	\N
252223	1773	6156202499973	7866	3793	15	0	\N
252228	1874	201005000	7870	4079	0	0	\N
252229	1874	201006000	7870	4079	1	0	\N
252230	1874	201005000	7871	4079	0	0	\N
252231	1874	201006000	7871	4079	1	0	\N
252232	1874	201005000	7872	4079	0	0	\N
252233	1874	201006000	7872	4079	1	0	\N
252234	1874	201007000	7873	4080	0	0	\N
252238	1874	201008000	7876	4081	0	0	\N
252239	1874	201009000	7876	4081	1	0	\N
252240	1874	201008000	7877	4081	0	0	\N
252241	1874	201009000	7877	4081	1	0	\N
252246	1874	201012000	7880	4083	0	0	\N
252247	1874	201012000	7881	4083	0	0	\N
252250	1874	201015000	7883	4085	0	0	\N
252252	1874	201015000	7885	4085	0	0	\N
252258	1874	201020000	7891	4090	0	0	\N
252259	1874	201020000	7892	4090	0	0	\N
252260	1874	201020000	7893	4090	0	0	\N
252262	1874	201021000	7895	4091	0	0	\N
252263	1874	201022000	7896	4092	0	0	\N
252264	1874	201022000	7897	4092	0	0	\N
252266	1874	201023000	7899	4093	0	0	\N
252267	1874	201024000	7899	4093	1	0	\N
252268	1874	201023000	7900	4093	0	0	\N
252269	1874	201024000	7900	4093	1	0	\N
252272	1874	201025000	7902	4094	0	0	\N
252273	1456	1438139000000	7902	4094	1	0	\N
252276	1874	201025000	7904	4094	0	0	\N
252277	1456	1438139000000	7904	4094	1	0	\N
252278	1874	201025000	7905	4094	0	0	\N
252279	1456	1438139000000	7905	4094	1	0	\N
252147	1874	200970000	7820	4054	2	0	0
252148	1874	200971000	7820	4054	3	0	0
252151	1874	200972000	7822	4055	0	0	0
252152	1874	200973000	7822	4055	1	0	0
252154	1874	200974000	7824	4056	0	0	0
252157	1874	200976000	7827	4058	0	0	0
252158	1874	200977000	7828	4059	0	0	0
252160	1874	200978000	7830	4060	0	0	0
252163	1874	200979000	7833	4061	0	0	0
252165	1874	200980000	7835	4062	0	0	0
252176	1917	0	7842	4064	0	0	0
252177	1874	200982000	7842	4064	1	0	0
252178	1874	200983000	7842	4064	2	0	0
252179	1874	200984000	7842	4064	3	0	0
252181	1874	200986000	7842	4064	5	0	0
252182	1874	200987000	7843	4065	0	0	0
252185	1874	200988000	7845	4066	0	0	0
252186	1874	200989000	7845	4066	1	0	0
252189	1874	200990000	7848	4067	0	0	0
252191	1874	200992000	7849	4068	1	0	0
252192	1874	200993000	7850	4069	0	0	0
252194	1874	200994000	7852	4070	0	0	0
252195	1874	200995000	7852	4070	1	0	0
252196	1874	200996000	7852	4070	2	0	0
252199	1874	200998000	7855	4072	0	0	0
252200	1874	200999000	7856	4073	0	0	0
252201	1874	201000000	7857	4074	0	0	0
252203	1874	201001000	7859	4075	0	0	0
252224	1874	201003000	7867	4077	0	0	0
252225	1874	201004000	7868	4078	0	0	0
252226	1874	201005000	7869	4079	0	0	0
252227	1874	201006000	7869	4079	1	0	0
252235	1874	201007000	7874	4080	0	0	0
252237	1874	201009000	7875	4081	1	0	0
252242	1874	201010000	7878	4082	0	0	0
252243	1874	201011000	7878	4082	1	0	0
252244	1918	1000000000	7878	4082	2	0	0
252245	1874	201012000	7879	4083	0	0	0
252249	1874	201014000	7882	4084	1	0	0
252251	1874	201015000	7884	4085	0	0	0
252253	1874	201016000	7886	4086	0	0	0
252254	1874	201017000	7887	4087	0	0	0
252256	1874	201019000	7889	4089	0	0	0
252257	1874	201020000	7890	4090	0	0	0
252261	1874	201021000	7894	4091	0	0	0
252265	1874	201022000	7898	4092	0	0	0
252270	1874	201023000	7901	4093	0	0	0
252274	1874	201025000	7903	4094	0	0	0
252275	1456	1438139000000	7903	4094	1	0	1
252280	1874	201026000	7906	4095	0	0	0
252282	1874	201028000	7908	4097	0	0	\N
252289	1874	201032000	7914	4101	0	0	\N
252290	1874	201033000	7914	4101	1	0	\N
252293	1874	201035000	7917	4103	0	0	\N
252297	1874	201036000	7919	4104	0	0	\N
252298	1874	201037000	7919	4104	1	0	\N
252299	1874	201038000	7919	4104	2	0	\N
252302	1874	201041000	7921	4106	0	0	\N
252303	1874	201042000	7921	4106	1	0	\N
252310	1874	201045000	7925	4108	0	0	\N
252313	1874	201046000	7927	4109	0	0	\N
252314	1874	201047000	7927	4109	1	0	\N
252317	1874	201049000	7930	4111	0	0	\N
252318	1874	201049000	7931	4111	0	0	\N
252319	1874	200914000	7932	3997	0	0	\N
252320	1874	200915000	7932	3997	1	0	\N
252321	1917	0	7932	3997	2	0	\N
252322	1874	200916000	7932	3997	3	0	\N
252323	1498	0	7932	3997	4	0	\N
252324	1874	200917000	7932	3997	5	0	\N
252325	1874	200918000	7932	3997	6	0	\N
252326	1874	200919000	7932	3997	7	0	\N
252327	1874	200920000	7932	3997	8	0	\N
252328	1874	200921000	7932	3997	9	0	\N
252329	1874	200922000	7932	3997	10	0	\N
252330	1874	200923000	7932	3997	11	0	\N
252331	1874	200924000	7932	3997	12	0	\N
252332	1874	200925000	7932	3997	13	0	\N
252333	1874	200926000	7932	3997	14	0	\N
252334	1874	200927000	7932	3997	15	0	\N
252335	1874	200928000	7932	3997	16	0	\N
252336	1874	200929000	7932	3997	17	0	\N
252337	1874	200930000	7932	3997	18	0	\N
252338	1874	200931000	7932	3997	19	0	\N
252339	1874	200932000	7932	3997	20	0	\N
252340	1874	200933000	7932	3997	21	0	\N
252341	1874	200934000	7932	3997	22	0	\N
252342	1874	200935000	7932	3997	23	0	\N
252343	1874	200936000	7932	3997	24	0	\N
252344	1874	200937000	7932	3997	25	0	\N
252345	1874	200938000	7932	3997	26	0	\N
252346	1874	200939000	7932	3997	27	0	\N
252347	1874	200940000	7932	3997	28	0	\N
252348	1874	200941000	7932	3997	29	0	\N
252349	1874	200942000	7932	3997	30	0	\N
252350	1874	200943000	7932	3997	31	0	\N
252351	1874	200944000	7932	3997	32	0	\N
252352	1874	200945000	7932	3997	33	0	\N
252353	1874	200946000	7932	3997	34	0	\N
252354	1874	200947000	7932	3997	35	0	\N
252355	1874	200948000	7932	3997	36	0	\N
252356	1874	200949000	7932	3997	38	0	\N
252357	1874	200950000	7932	3997	39	0	\N
252358	1874	200951000	7932	3997	40	0	\N
252359	1874	200952000	7932	3997	41	0	\N
252360	1915	200000000	7932	3997	42	0	\N
252361	1916	200000000	7932	3997	43	0	\N
252362	1874	200953000	7932	3997	44	0	\N
252363	1874	200954000	7932	3997	45	0	\N
252364	1874	200955000	7932	3997	46	0	\N
252365	1874	200956000	7932	3997	47	0	\N
252366	1874	200957000	7932	3997	48	0	\N
252367	1874	200958000	7932	3997	49	0	\N
252368	1874	200959000	7932	3997	50	0	\N
252369	1874	200960000	7932	3997	51	0	\N
252370	1874	200961000	7932	3997	52	0	\N
252371	1874	200962000	7932	3997	53	0	\N
252372	1874	200963000	7932	3997	54	0	\N
252373	1874	200964000	7932	3997	55	0	\N
252374	1874	200965000	7932	3997	56	0	\N
252375	1874	200966000	7932	3997	57	0	\N
252376	1874	200967000	7932	3997	58	0	\N
252377	1874	200968000	7932	3997	59	0	\N
252378	1874	200969000	7932	3997	60	0	\N
252379	1874	200970000	7932	3997	61	0	\N
252380	1874	200971000	7932	3997	62	0	\N
252381	1874	200972000	7932	3997	63	0	\N
252382	1874	200973000	7932	3997	64	0	\N
252383	1874	200974000	7932	3997	65	0	\N
252384	1874	200975000	7932	3997	66	0	\N
252385	1874	200976000	7932	3997	67	0	\N
252386	1874	200977000	7932	3997	68	0	\N
252387	1874	200978000	7932	3997	69	0	\N
252388	1874	200979000	7932	3997	70	0	\N
252389	1874	200980000	7932	3997	71	0	\N
252390	1874	200981000	7932	3997	72	0	\N
252391	1874	200982000	7932	3997	73	0	\N
252392	1874	200983000	7932	3997	74	0	\N
252393	1874	200984000	7932	3997	75	0	\N
252394	1874	200985000	7932	3997	76	0	\N
252395	1874	200986000	7932	3997	77	0	\N
252396	1874	200987000	7932	3997	78	0	\N
252397	1874	200988000	7932	3997	79	0	\N
252398	1874	200989000	7932	3997	80	0	\N
252399	1874	200990000	7932	3997	81	0	\N
252400	1874	200991000	7932	3997	82	0	\N
252401	1874	200992000	7932	3997	83	0	\N
252402	1874	200993000	7932	3997	84	0	\N
252403	1874	200994000	7932	3997	85	0	\N
252404	1874	200995000	7932	3997	86	0	\N
252405	1874	200996000	7932	3997	87	0	\N
252406	1874	200997000	7932	3997	88	0	\N
252407	1874	200998000	7932	3997	89	0	\N
252408	1874	200999000	7932	3997	90	0	\N
252409	1874	201000000	7932	3997	91	0	\N
252410	1874	201001000	7932	3997	92	0	\N
252411	1874	201002000	7932	3997	93	0	\N
252412	1874	201003000	7932	3997	94	0	\N
252413	1874	201004000	7932	3997	95	0	\N
252414	1874	201005000	7932	3997	96	0	\N
252415	1874	201006000	7932	3997	97	0	\N
252416	1874	201007000	7932	3997	98	0	\N
252284	1874	201029000	7910	4098	0	0	0
252285	1874	201030000	7911	4099	0	0	0
252286	1874	201031000	7912	4100	0	0	0
252287	1874	201032000	7913	4101	0	0	0
252288	1874	201033000	7913	4101	1	0	0
252292	1874	201035000	7916	4103	0	0	0
252294	1874	201036000	7918	4104	0	0	0
252295	1874	201037000	7918	4104	1	0	0
252296	1874	201038000	7918	4104	2	0	0
252300	1874	201039000	7920	4105	0	0	0
252304	1874	201041000	7922	4106	0	0	0
252305	1874	201042000	7922	4106	1	0	0
252306	1874	201043000	7923	4107	0	0	0
252307	1874	201044000	7923	4107	1	0	0
252309	1874	201045000	7924	4108	0	0	0
252311	1874	201046000	7926	4109	0	0	0
252312	1874	201047000	7926	4109	1	0	0
252315	1874	201048000	7928	4110	0	0	0
252316	1874	201049000	7929	4111	0	0	0
252417	1874	201008000	7932	3997	99	0	\N
252418	1874	201009000	7932	3997	100	0	\N
252419	1874	201010000	7932	3997	101	0	\N
252420	1874	201011000	7932	3997	102	0	\N
252421	1874	201012000	7932	3997	103	0	\N
252422	1874	201013000	7932	3997	104	0	\N
252423	1874	201014000	7932	3997	105	0	\N
252424	1874	201015000	7932	3997	106	0	\N
252425	1874	201016000	7932	3997	107	0	\N
252426	1874	201017000	7932	3997	108	0	\N
252427	1874	201018000	7932	3997	109	0	\N
252428	1874	201019000	7932	3997	110	0	\N
252429	1874	201020000	7932	3997	111	0	\N
252430	1874	201021000	7932	3997	112	0	\N
252431	1874	201022000	7932	3997	113	0	\N
252432	1874	201023000	7932	3997	114	0	\N
252433	1874	201024000	7932	3997	115	0	\N
252434	1874	201025000	7932	3997	116	0	\N
252435	1874	201026000	7932	3997	117	0	\N
252436	1874	201027000	7932	3997	118	0	\N
252437	1874	201028000	7932	3997	119	0	\N
252438	1874	201029000	7932	3997	120	0	\N
252439	1874	201030000	7932	3997	121	0	\N
252440	1874	201031000	7932	3997	122	0	\N
252441	1874	201032000	7932	3997	123	0	\N
252442	1874	201033000	7932	3997	124	0	\N
252443	1874	201034000	7932	3997	125	0	\N
252444	1874	201046000	7933	4109	0	0	\N
252445	1874	201047000	7933	4109	1	0	\N
252446	1874	201048000	7933	4109	2	0	\N
252447	1874	201049000	7933	4109	3	0	\N
252450	1874	201051000	7936	4113	0	0	\N
252452	1874	201052000	7938	4114	0	0	\N
252454	1874	201053000	7940	4115	0	0	\N
252455	1874	201053000	7941	4115	0	0	\N
252456	1874	201053000	7942	4115	0	0	\N
252457	1874	201054000	7943	4116	0	0	\N
252458	1874	201054000	7944	4116	0	0	\N
252460	1874	201054000	7946	4116	0	0	\N
252462	1874	201056000	7948	4118	0	0	\N
252463	1874	201056000	7949	4118	0	0	\N
252466	1874	201058000	7952	4120	0	0	\N
252472	1874	201063000	7957	4124	0	0	\N
252473	1874	201063000	7958	4124	0	0	\N
252474	1874	201035000	7959	3998	0	0	\N
252475	1874	201036000	7959	3998	1	0	\N
252476	1874	201037000	7959	3998	2	0	\N
252477	1874	201038000	7959	3998	3	0	\N
252478	1874	201039000	7959	3998	4	0	\N
252479	1874	201040000	7959	3998	5	0	\N
252480	1874	201041000	7959	3998	6	0	\N
252481	1874	201042000	7959	3998	7	0	\N
252482	1874	201043000	7959	3998	8	0	\N
252483	1874	201044000	7959	3998	9	0	\N
252484	1874	201045000	7959	3998	10	0	\N
252485	1874	201046000	7959	3998	11	0	\N
252486	1874	201047000	7959	3998	12	0	\N
252487	1874	201048000	7959	3998	13	0	\N
252488	1874	201049000	7959	3998	14	0	\N
252489	1874	201050000	7959	3998	15	0	\N
252490	1874	201051000	7959	3998	16	0	\N
252491	1874	201052000	7959	3998	17	0	\N
252492	1874	201053000	7959	3998	18	0	\N
252493	1874	201054000	7959	3998	19	0	\N
252494	1874	201055000	7959	3998	20	0	\N
252495	1874	201056000	7959	3998	21	0	\N
252496	1874	201057000	7959	3998	22	0	\N
252497	1874	201058000	7959	3998	23	0	\N
252498	1874	201059000	7959	3998	24	0	\N
252499	1874	201060000	7959	3998	25	0	\N
252500	1874	201061000	7959	3998	26	0	\N
252501	1874	201062000	7959	3998	27	0	\N
252502	1874	201063000	7959	3998	28	0	\N
252503	1918	1000000000	7959	3998	29	0	\N
252504	1918	1439138000000	7959	3998	30	0	\N
252512	1874	201070000	7963	4127	0	0	\N
252514	1874	201071000	7969	4129	0	0	\N
252515	1874	201072000	7969	4129	1	0	\N
252516	1874	201073000	7969	4129	2	0	\N
252517	1474	12954293000000	7969	4129	3	0	\N
252518	1874	201074000	7969	4129	4	0	\N
252519	1474	12954293000000	7970	4129	0	0	\N
252533	1874	201082000	7977	4134	0	0	\N
252535	1874	201083000	7979	4135	0	0	\N
252536	1874	201084000	7980	4136	0	0	\N
252537	1874	201085000	7980	4136	1	0	\N
252538	366	66000100000000	7980	4136	2	0	\N
252539	1874	201084000	7981	4136	0	0	\N
252540	1874	201085000	7981	4136	1	0	\N
252541	366	66000100000000	7981	4136	2	0	\N
252451	1874	201052000	7937	4114	0	0	0
252453	1874	201053000	7939	4115	0	0	0
252459	1874	201054000	7945	4116	0	0	0
252461	1874	201055000	7947	4117	0	0	0
252464	1874	201056000	7950	4118	0	0	0
252467	1874	201058000	7953	4120	0	0	0
252468	1874	201059000	7954	4121	0	0	0
252469	1874	201060000	7955	4122	0	0	0
252470	1874	201061000	7956	4123	0	0	0
252471	1874	201062000	7956	4123	1	0	0
252506	1874	201064000	7961	4125	0	0	0
252507	1874	201065000	7961	4125	1	0	0
252508	1874	201066000	7961	4125	2	0	0
252509	1874	201067000	7962	4126	0	0	0
252511	1874	201069000	7962	4126	2	0	0
252513	1874	201070000	7964	4127	0	0	0
252520	1874	201071000	7971	4129	0	0	0
252521	1874	201072000	7971	4129	1	0	0
252522	1874	201073000	7971	4129	2	0	0
252524	1874	201074000	7971	4129	4	0	0
252525	1874	201075000	7972	4130	0	0	0
252526	1874	201076000	7973	4131	0	0	0
252527	1874	201077000	7974	4132	0	0	0
252528	1874	201078000	7974	4132	1	0	0
252530	1874	201080000	7975	4133	1	0	0
252531	1874	201081000	7975	4133	2	0	0
252532	1874	201082000	7976	4134	0	0	0
252534	1874	201083000	7978	4135	0	0	0
252543	1874	201085000	7982	4136	1	0	0
252544	366	66000100000000	7982	4136	2	0	0
252545	1874	201086000	7983	4137	0	0	0
252546	1474	12955293000000	7984	4138	0	0	3
252547	1874	201087000	7984	4138	1	0	0
252549	1474	13235293000000	7985	4139	0	0	3
252550	1874	201089000	7985	4139	1	0	0
252551	1874	201090000	7985	4139	2	0	0
252552	1483	0	7986	4140	0	0	0
252555	1874	201093000	7987	4141	0	0	\N
252556	1874	201094000	7987	4141	1	0	\N
252557	1874	201095000	7987	4141	2	0	\N
252563	1874	201096000	7990	4142	0	0	\N
252564	1874	201097000	7990	4142	1	0	\N
252569	1874	201100000	7994	4145	0	0	\N
252570	1874	201101000	7994	4145	1	0	\N
252573	1874	201104000	7996	4147	0	0	\N
252574	1874	201104000	7997	4147	0	0	\N
252575	1874	201104000	7998	4147	0	0	\N
252577	1874	201104000	8001	4147	0	0	\N
252578	1874	201105000	8004	4148	0	0	\N
252579	1874	201106000	8004	4148	1	0	\N
252580	1874	201105000	8005	4148	0	0	\N
252581	1874	201106000	8005	4148	1	0	\N
252586	1874	201109000	8009	4151	0	0	\N
252589	1874	201111000	8012	4153	0	0	\N
252590	1745	8406000000	8012	4153	1	0	\N
252591	1874	201111000	8013	4153	0	0	\N
252592	1745	8406000000	8013	4153	1	0	\N
252593	1874	201111000	8014	4153	0	0	\N
252594	1745	8406000000	8014	4153	1	0	\N
252603	1874	201118000	8020	4158	0	0	\N
252604	1874	201119000	8020	4158	1	0	\N
252610	1874	201123000	8024	4161	0	0	\N
252611	1874	201124000	8024	4161	1	0	\N
252612	1874	201123000	8025	4161	0	0	\N
252613	1874	201124000	8025	4161	1	0	\N
252616	1874	201125000	8027	4162	0	0	\N
252617	1874	201125000	8028	4162	0	0	\N
252619	1874	201126000	8030	4163	0	0	\N
252620	1874	201127000	8030	4163	1	0	\N
252621	1874	201128000	8030	4163	2	0	\N
252622	1874	201126000	8032	4163	0	0	\N
252623	1874	201127000	8032	4163	1	0	\N
252624	1874	201128000	8032	4163	2	0	\N
252625	1874	201126000	8033	4164	0	0	\N
252626	1874	201127000	8033	4164	1	0	\N
252627	1874	201128000	8033	4164	2	0	\N
252628	1874	201129000	8033	4164	3	0	\N
252629	603	66001200000000	8033	4164	4	0	\N
252630	1919	200000000	8033	4164	5	0	\N
252631	1920	200000000	8033	4164	6	0	\N
252632	1921	200000000	8033	4164	7	0	\N
252633	1922	200000000	8033	4164	8	0	\N
252634	1874	201130000	8033	4164	9	0	\N
252635	1923	200000000	8033	4164	10	0	\N
252636	1874	201131000	8033	4164	11	0	\N
252649	1874	201126000	8035	4164	0	0	\N
252650	1874	201127000	8035	4164	1	0	\N
252651	1874	201128000	8035	4164	2	0	\N
252652	1874	201129000	8035	4164	3	0	\N
252653	603	66001200000000	8035	4164	4	0	\N
252654	1919	200000000	8035	4164	5	0	\N
252655	1920	200000000	8035	4164	6	0	\N
252656	1921	200000000	8035	4164	7	0	\N
252657	1922	200000000	8035	4164	8	0	\N
252658	1874	201130000	8035	4164	9	0	\N
252659	1923	200000000	8035	4164	10	0	\N
252660	1874	201131000	8035	4164	11	0	\N
252662	1874	201133000	8037	4166	0	0	\N
252664	1874	201134000	8039	4167	0	0	\N
252666	1874	201135000	8041	4168	0	0	\N
252668	1874	201135000	8043	4168	0	0	\N
252669	1874	201135000	8044	4168	0	0	\N
252670	1874	201135000	8045	4168	0	0	\N
252671	1874	201136000	8046	4169	0	0	\N
252673	1874	201137000	8048	4170	0	0	\N
252675	1874	201137000	8050	4170	0	0	\N
252676	1874	201138000	8051	4171	0	0	\N
252677	1874	201139000	8051	4171	1	0	\N
252678	1874	201140000	8051	4171	2	0	\N
252683	1874	201141000	8054	4172	0	0	\N
252687	1874	201145000	8058	4176	0	0	\N
252688	1874	201146000	8058	4176	1	0	\N
252558	1874	201093000	7988	4141	0	0	0
252559	1874	201094000	7988	4141	1	0	0
252560	1874	201095000	7988	4141	2	0	0
252561	1874	201096000	7989	4142	0	0	0
252562	1874	201097000	7989	4142	1	0	0
252566	1874	201099000	7992	4144	0	0	0
252567	1874	201100000	7993	4145	0	0	0
252568	1874	201101000	7993	4145	1	0	0
252571	1874	201102000	7995	4146	0	0	0
252572	1874	201103000	7995	4146	1	0	0
252582	1874	201105000	8006	4148	0	0	0
252583	1874	201106000	8006	4148	1	0	0
252584	1874	201107000	8007	4149	0	0	0
252585	1874	201108000	8007	4149	1	0	0
252588	1874	201110000	8011	4152	0	0	0
252595	1874	201111000	8015	4153	0	0	0
252596	1745	8406000000	8015	4153	1	0	2
252597	1874	201112000	8016	4154	0	0	0
252598	1874	201113000	8016	4154	1	0	0
252600	1874	201115000	8017	4155	0	0	0
252601	1874	201116000	8018	4156	0	0	0
252602	1874	201117000	8019	4157	0	0	0
252605	1874	201118000	8021	4158	0	0	0
252606	1874	201119000	8021	4158	1	0	0
252608	1874	201121000	8022	4159	1	0	0
252609	1874	201122000	8023	4160	0	0	0
252614	1874	201123000	8026	4161	0	0	0
252615	1874	201124000	8026	4161	1	0	0
252637	1874	201126000	8034	4164	0	0	0
252638	1874	201127000	8034	4164	1	0	0
252639	1874	201128000	8034	4164	2	0	0
252640	1874	201129000	8034	4164	3	0	0
252641	603	66001200000000	8034	4164	4	0	0
252643	1920	200000000	8034	4164	6	0	0
252644	1921	200000000	8034	4164	7	0	0
252645	1922	200000000	8034	4164	8	0	0
252646	1874	201130000	8034	4164	9	0	0
252647	1923	200000000	8034	4164	10	0	0
252661	1874	201132000	8036	4165	0	0	0
252663	1874	201133000	8038	4166	0	0	0
252665	1874	201134000	8040	4167	0	0	0
252667	1874	201135000	8042	4168	0	0	0
252674	1874	201137000	8049	4170	0	0	0
252679	1874	201138000	8052	4171	0	0	0
252680	1874	201139000	8052	4171	1	0	0
252681	1874	201140000	8052	4171	2	0	0
252682	1874	201141000	8053	4172	0	0	0
252685	1874	201143000	8056	4174	0	0	0
252686	1874	201144000	8057	4175	0	0	0
252691	1874	201145000	8060	4176	0	0	\N
252692	1874	201146000	8060	4176	1	0	\N
252696	298	71039170000000	8063	4178	0	0	\N
252697	1874	201148000	8063	4178	1	0	\N
252701	1874	201150000	8066	4180	0	0	\N
252702	1745	8406000000	8066	4180	1	0	\N
252703	1874	201150000	8067	4180	0	0	\N
252704	1745	8406000000	8067	4180	1	0	\N
252710	1874	201154000	8072	4184	0	0	\N
252711	1874	201155000	8072	4184	1	0	\N
252718	1874	201157000	8075	4186	0	0	\N
252719	1874	201158000	8075	4186	1	0	\N
252720	1745	8406000000	8075	4186	2	0	\N
252721	1924	1200000000	8075	4186	3	0	\N
252724	1874	201161000	8077	4188	0	0	\N
252726	1874	201161000	8079	4188	0	0	\N
252736	1874	201165000	8083	4192	0	0	\N
252738	1874	201165000	8085	4192	0	0	\N
252743	1874	201168000	8089	4195	0	0	\N
252744	1874	201168000	8090	4195	0	0	\N
252745	1874	201169000	8091	4196	0	0	\N
252747	1874	201169000	8093	4196	0	0	\N
252748	1874	201169000	8094	4196	0	0	\N
252751	1874	201170000	8096	4197	0	0	\N
252752	1745	1803000000	8096	4197	1	0	\N
252753	1874	201170000	8097	4197	0	0	\N
252754	1745	1803000000	8097	4197	1	0	\N
252755	1874	201170000	8098	4197	0	0	\N
252756	1745	1803000000	8098	4197	1	0	\N
252757	1874	201171000	8099	4198	0	0	\N
252758	1745	1803000000	8099	4198	1	0	\N
252759	1874	201171000	8100	4198	0	0	\N
252760	1745	1803000000	8100	4198	1	0	\N
252764	1927	200000000	8103	4200	0	0	\N
252765	1874	201172000	8103	4200	1	0	\N
252766	1874	201173000	8103	4200	2	0	\N
252767	1745	1803000000	8103	4200	3	0	\N
252773	1874	201175000	8106	4202	0	0	\N
252780	1874	201180000	8112	4206	0	0	\N
252781	1874	201180000	8113	4206	0	0	\N
252790	1874	201187000	8116	4208	0	0	\N
252791	1874	201187000	8117	4208	0	0	\N
252793	1874	201189000	8119	4210	0	0	\N
252795	1874	201190000	8122	4211	0	0	\N
252796	1874	201191000	8122	4211	1	0	\N
252797	1874	201190000	8123	4211	0	0	\N
252798	1874	201191000	8123	4211	1	0	\N
252805	1874	201194000	8126	4213	0	0	\N
252807	1874	201195000	8129	4214	0	0	\N
252808	1874	201195000	8130	4214	0	0	\N
252812	1874	201199000	8133	4217	0	0	\N
252813	1874	201200000	8133	4217	1	0	\N
252820	1874	201205000	8139	4221	0	0	\N
252821	1874	201206000	8139	4221	1	0	\N
252824	1874	201207000	8141	4222	0	0	\N
252693	1874	201147000	8061	4177	0	0	0
252694	298	71039170000000	8062	4178	0	0	3
252695	1874	201148000	8062	4178	1	0	0
252698	1874	201149000	8064	4179	0	0	0
252699	1874	201150000	8065	4180	0	0	0
252705	1874	201151000	8069	4182	0	0	0
252706	1874	201152000	8070	4183	0	0	0
252707	1874	201153000	8070	4183	1	0	0
252708	1874	201154000	8071	4184	0	0	0
252709	1874	201155000	8071	4184	1	0	0
252713	1745	8406000000	8073	4185	1	0	2
252714	1874	201157000	8074	4186	0	0	0
252715	1874	201158000	8074	4186	1	0	0
252716	1745	8406000000	8074	4186	2	0	2
252722	1874	201159000	8076	4187	0	0	0
252723	1874	201160000	8076	4187	1	0	0
252725	1874	201161000	8078	4188	0	0	0
252727	1874	201162000	8080	4189	0	0	0
252728	1925	1200000000	8080	4189	1	0	0
252730	1745	4004000000	8081	4190	1	0	4
252731	1926	1200000000	8081	4190	2	0	0
252732	1483	0	8082	4191	0	0	0
252733	1874	201164000	8082	4191	1	0	0
252734	1745	1803000000	8082	4191	2	0	5
252737	1874	201165000	8084	4192	0	0	0
252739	1874	201166000	8086	4193	0	0	0
252740	1735	3580020000000	8086	4193	1	0	7
252741	1874	201167000	8087	4194	0	0	0
252746	1874	201169000	8092	4196	0	0	0
252749	1874	201170000	8095	4197	0	0	0
252750	1745	1803000000	8095	4197	1	0	5
252761	1874	201171000	8101	4198	0	0	0
252762	1745	1803000000	8102	4199	0	0	5
252768	1927	200000000	8104	4200	0	0	0
252769	1874	201172000	8104	4200	1	0	0
252770	1874	201173000	8104	4200	2	0	0
252771	1745	1803000000	8104	4200	3	0	5
252772	1874	201174000	8105	4201	0	0	0
252775	1874	201176000	8108	4203	0	0	0
252776	1874	201177000	8109	4204	0	0	0
252777	1874	201178000	8110	4205	0	0	0
252778	1874	201179000	8110	4205	1	0	0
252782	1874	201181000	8114	4207	0	0	0
252783	1874	201182000	8114	4207	1	0	0
252784	1874	201183000	8114	4207	2	0	0
252785	1874	201184000	8114	4207	3	0	0
252786	1874	201185000	8114	4207	4	0	0
252788	1745	1803000000	8114	4207	6	0	5
252789	1874	201187000	8115	4208	0	0	0
252792	1874	201188000	8118	4209	0	0	0
252794	1874	201189000	8120	4210	0	0	0
252799	1483	0	8124	4212	0	0	0
252801	1874	201191000	8124	4212	2	0	0
252802	1874	201192000	8124	4212	3	0	0
252803	1874	201193000	8124	4212	4	0	0
252804	1874	201194000	8125	4213	0	0	0
252809	1874	201196000	8131	4215	0	0	0
252810	1874	201197000	8132	4216	0	0	0
252811	1874	201198000	8132	4216	1	0	0
252814	1874	201199000	8134	4217	0	0	0
252815	1874	201200000	8134	4217	1	0	0
252817	1874	201202000	8136	4219	0	0	0
252818	1874	201203000	8137	4220	0	0	0
252819	1874	201204000	8137	4220	1	0	0
252822	1874	201205000	8140	4221	0	0	0
252823	1874	201206000	8140	4221	1	0	0
252826	1874	201207000	8143	4222	0	0	\N
252827	1874	201208000	8144	4223	0	0	\N
252828	1874	201209000	8144	4223	1	0	\N
252829	1874	201208000	8145	4223	0	0	\N
252830	1874	201209000	8145	4223	1	0	\N
252831	1874	201208000	8146	4223	0	0	\N
252832	1874	201209000	8146	4223	1	0	\N
252836	1483	0	8149	4205	0	0	\N
252837	1745	1803000000	8149	4205	1	0	\N
252842	1874	201211000	8151	4225	0	0	\N
252843	1874	201212000	8151	4225	1	0	\N
252844	1928	200000000	8151	4225	2	0	\N
252845	1874	201213000	8151	4225	3	0	\N
252847	1483	0	8153	4201	0	0	\N
252848	1874	201174000	8153	4201	1	0	\N
252849	1874	201175000	8153	4201	2	0	\N
252850	1874	201176000	8153	4201	3	0	\N
252851	1874	201177000	8153	4201	4	0	\N
252852	1874	201178000	8153	4201	5	0	\N
252853	1874	201179000	8153	4201	6	0	\N
252854	1874	201180000	8153	4201	7	0	\N
252855	1874	201181000	8153	4201	8	0	\N
252856	1874	201182000	8153	4201	9	0	\N
252857	1874	201183000	8153	4201	10	0	\N
252858	1874	201184000	8153	4201	11	0	\N
252859	1874	201185000	8153	4201	12	0	\N
252860	1874	201186000	8153	4201	13	0	\N
252861	1874	201187000	8153	4201	14	0	\N
252862	1874	201188000	8153	4201	15	0	\N
252863	1874	201189000	8153	4201	16	0	\N
252864	1874	201190000	8153	4201	17	0	\N
252865	1874	201191000	8153	4201	18	0	\N
252866	1874	201192000	8153	4201	19	0	\N
252867	1874	201193000	8153	4201	20	0	\N
252868	1874	201194000	8153	4201	21	0	\N
252869	1874	201195000	8153	4201	22	0	\N
252870	1874	201196000	8153	4201	23	0	\N
252871	1874	201197000	8153	4201	24	0	\N
252872	1874	201198000	8153	4201	25	0	\N
252873	1874	201199000	8153	4201	26	0	\N
252874	1874	201200000	8153	4201	27	0	\N
252875	1874	201201000	8153	4201	28	0	\N
252876	1874	201202000	8153	4201	29	0	\N
252877	1874	201203000	8153	4201	30	0	\N
252878	1874	201204000	8153	4201	31	0	\N
252879	1874	201205000	8153	4201	32	0	\N
252880	1874	201206000	8153	4201	33	0	\N
252881	1874	201207000	8153	4201	34	0	\N
252882	1874	201208000	8153	4201	35	0	\N
252883	1874	201209000	8153	4201	36	0	\N
252884	1874	201210000	8153	4201	37	0	\N
252885	1874	201211000	8153	4201	38	0	\N
252886	1874	201212000	8153	4201	39	0	\N
252887	1928	200000000	8153	4201	40	0	\N
252888	1874	201213000	8153	4201	41	0	\N
252889	1874	201214000	8153	4201	42	0	\N
252890	1745	1803000000	8153	4201	43	0	\N
252892	1874	201216000	8155	4228	0	0	\N
252894	1874	201216000	8157	4228	0	0	\N
252896	1874	201218000	8159	4230	0	0	\N
252897	1874	201218000	8160	4230	0	0	\N
252899	1874	201215000	8162	4202	0	0	\N
252900	1874	201216000	8162	4202	1	0	\N
252901	1874	201217000	8162	4202	2	0	\N
252902	1874	201218000	8162	4202	3	0	\N
252906	1874	201221000	8166	4232	0	0	\N
252907	1874	201222000	8167	4233	0	0	\N
252908	1874	201223000	8167	4233	1	0	\N
252909	1874	201222000	8168	4233	0	0	\N
252910	1874	201223000	8168	4233	1	0	\N
252913	1874	201224000	8170	4234	0	0	\N
252915	1874	201224000	8172	4234	0	0	\N
252916	1874	201224000	8173	4234	0	0	\N
252918	1874	201226000	8175	4236	0	0	\N
252919	1874	201227000	8175	4236	1	0	\N
252920	1874	201226000	8176	4236	0	0	\N
252921	1874	201227000	8176	4236	1	0	\N
252922	1874	201226000	8177	4236	0	0	\N
252923	1874	201227000	8177	4236	1	0	\N
252934	1874	201232000	8183	4240	0	0	\N
252935	1874	201233000	8183	4240	1	0	\N
252936	1874	201234000	8183	4240	2	0	\N
252937	1874	201235000	8183	4240	3	0	\N
252940	1874	201238000	8186	4243	0	0	\N
252945	1874	201241000	8191	4246	0	0	\N
252946	1874	201242000	8192	4247	0	0	\N
252947	1874	201243000	8192	4247	1	0	\N
252951	1874	201242000	8195	4248	0	0	\N
252952	1874	201243000	8195	4248	1	0	\N
252953	1874	201244000	8195	4248	2	0	\N
252954	1874	201242000	8196	4248	0	0	\N
252955	1874	201243000	8196	4248	1	0	\N
252956	1874	201244000	8196	4248	2	0	\N
252958	1874	201245000	8198	4249	0	0	\N
252959	1874	201246000	8199	4250	0	0	\N
252834	1874	201209000	8147	4223	1	0	0
252835	1874	201210000	8148	4224	0	0	0
252838	1874	201211000	8150	4225	0	0	0
252839	1874	201212000	8150	4225	1	0	0
252840	1928	200000000	8150	4225	2	0	0
252846	1874	201214000	8152	4226	0	0	0
252891	1874	201215000	8154	4227	0	0	0
252893	1874	201216000	8156	4228	0	0	0
252895	1874	201217000	8158	4229	0	0	0
252898	1874	201218000	8161	4230	0	0	0
252904	1874	201220000	8163	4231	1	0	0
252905	1874	201221000	8165	4232	0	0	0
252911	1874	201222000	8169	4233	0	0	0
252912	1874	201223000	8169	4233	1	0	0
252917	1874	201225000	8174	4235	0	0	0
252924	1874	201226000	8178	4236	0	0	0
252925	1874	201227000	8178	4236	1	0	0
252926	1874	201228000	8179	4237	0	0	0
252927	1874	201229000	8180	4238	0	0	0
252929	1874	201231000	8181	4239	1	0	0
252930	1874	201232000	8182	4240	0	0	0
252931	1874	201233000	8182	4240	1	0	0
252932	1874	201234000	8182	4240	2	0	0
252933	1874	201235000	8182	4240	3	0	0
252939	1874	201237000	8185	4242	0	0	0
252941	1874	201238000	8187	4243	0	0	0
252942	1874	201239000	8188	4244	0	0	0
252943	1874	201240000	8189	4245	0	0	0
252948	1874	201242000	8194	4248	0	0	0
252949	1874	201243000	8194	4248	1	0	0
252950	1874	201244000	8194	4248	2	0	0
252957	1874	201245000	8197	4249	0	0	0
252960	1874	201246000	8200	4250	0	0	0
252962	1929	200000000	8202	4252	0	0	\N
252963	1929	1400000000	8202	4252	1	0	\N
252964	1874	201248000	8202	4252	2	0	\N
252968	1929	200000000	8204	4252	0	0	\N
252969	1929	1400000000	8204	4252	1	0	\N
252970	1874	201248000	8204	4252	2	0	\N
252973	1874	201251000	8207	4255	0	0	\N
252974	1874	201251000	8208	4255	0	0	\N
252976	1874	201197000	8210	4216	0	0	\N
252977	1874	201198000	8210	4216	1	0	\N
252978	1874	201199000	8210	4216	2	0	\N
252979	1874	201200000	8210	4216	3	0	\N
252980	1874	201201000	8210	4216	4	0	\N
252981	1874	201202000	8210	4216	5	0	\N
252982	1874	201203000	8210	4216	6	0	\N
252983	1874	201204000	8210	4216	7	0	\N
252984	1874	201205000	8210	4216	8	0	\N
252985	1874	201206000	8210	4216	9	0	\N
252986	1874	201207000	8210	4216	10	0	\N
252987	1874	201208000	8210	4216	11	0	\N
252988	1874	201209000	8210	4216	12	0	\N
252989	1874	201210000	8210	4216	13	0	\N
252990	1874	201211000	8210	4216	14	0	\N
252991	1874	201212000	8210	4216	15	0	\N
252992	1928	200000000	8210	4216	16	0	\N
252993	1874	201213000	8210	4216	17	0	\N
252994	1874	201214000	8210	4216	18	0	\N
252995	1874	201215000	8210	4216	19	0	\N
252996	1874	201216000	8210	4216	20	0	\N
252997	1874	201217000	8210	4216	21	0	\N
252998	1874	201218000	8210	4216	22	0	\N
252999	1874	201219000	8210	4216	23	0	\N
253000	1874	201220000	8210	4216	24	0	\N
253001	1874	201221000	8210	4216	25	0	\N
253002	1874	201222000	8210	4216	26	0	\N
253003	1874	201223000	8210	4216	27	0	\N
253004	1874	201224000	8210	4216	28	0	\N
253005	1874	201225000	8210	4216	29	0	\N
253006	1874	201226000	8210	4216	30	0	\N
253007	1874	201227000	8210	4216	31	0	\N
253008	1874	201228000	8210	4216	32	0	\N
253009	1874	201229000	8210	4216	33	0	\N
253010	1874	201230000	8210	4216	34	0	\N
253011	1874	201231000	8210	4216	35	0	\N
253012	1874	201232000	8210	4216	36	0	\N
253013	1874	201233000	8210	4216	37	0	\N
253014	1874	201234000	8210	4216	38	0	\N
253015	1874	201235000	8210	4216	39	0	\N
253016	1874	201236000	8210	4216	40	0	\N
253017	1874	201237000	8210	4216	41	0	\N
253018	1874	201238000	8210	4216	42	0	\N
253019	1874	201239000	8210	4216	43	0	\N
253020	1874	201240000	8210	4216	44	0	\N
253021	1874	201241000	8210	4216	45	0	\N
253022	1874	201242000	8210	4216	46	0	\N
253023	1874	201243000	8210	4216	47	0	\N
253024	1874	201244000	8210	4216	48	0	\N
253025	1874	201245000	8210	4216	49	0	\N
253026	1874	201246000	8210	4216	50	0	\N
253027	1874	201247000	8210	4216	51	0	\N
253028	1929	200000000	8210	4216	52	0	\N
253029	1929	1400000000	8210	4216	53	0	\N
253030	1874	201248000	8210	4216	54	0	\N
253031	1874	201249000	8210	4216	55	0	\N
253032	1874	201250000	8210	4216	57	0	\N
253033	1874	201251000	8210	4216	58	0	\N
253037	1874	201255000	8213	4258	0	0	\N
253040	1874	201256000	8216	4259	0	0	\N
253043	1874	201257000	8218	4260	0	0	\N
253044	1930	200000000	8218	4260	1	0	\N
253045	1874	201257000	8219	4260	0	0	\N
253046	1930	200000000	8219	4260	1	0	\N
253047	1874	201257000	8220	4260	0	0	\N
253048	1930	200000000	8220	4260	1	0	\N
253051	1874	201259000	8223	4262	0	0	\N
253052	1874	201260000	8224	4263	0	0	\N
253054	1874	201261000	8226	4264	0	0	\N
253056	1874	201261000	8228	4264	0	0	\N
253061	1874	201263000	8231	4266	0	0	\N
253062	1874	201264000	8231	4266	1	0	\N
253063	1874	201265000	8231	4266	2	0	\N
253064	1874	201263000	8232	4266	0	0	\N
253065	1874	201264000	8232	4266	1	0	\N
253066	1874	201265000	8232	4266	2	0	\N
253067	1874	201263000	8233	4266	0	0	\N
253068	1874	201264000	8233	4266	1	0	\N
253069	1874	201265000	8233	4266	2	0	\N
253070	1874	201263000	8234	4266	0	0	\N
253071	1874	201264000	8234	4266	1	0	\N
253072	1874	201265000	8234	4266	2	0	\N
253076	1874	201269000	8238	4269	0	0	\N
253077	1874	201269000	8239	4269	0	0	\N
253078	1874	201269000	8240	4269	0	0	\N
253079	1874	201269000	8242	4269	0	0	\N
253083	1874	201269000	8244	4270	0	0	\N
253084	1874	201270000	8244	4270	1	0	\N
253085	1874	201269000	8245	4270	0	0	\N
253086	1874	201270000	8245	4270	1	0	\N
253087	1874	201271000	8245	4270	3	0	\N
253088	1874	201269000	8246	4270	0	0	\N
253089	1874	201270000	8246	4270	1	0	\N
253090	1874	201271000	8246	4270	3	0	\N
253092	1874	201272000	8248	4271	0	0	\N
253094	1874	201274000	8250	4273	0	0	\N
253095	1874	201274000	8251	4273	0	0	\N
253096	1874	201274000	8252	4273	0	0	\N
252966	1929	1400000000	8203	4252	1	0	0
252967	1874	201248000	8203	4252	2	0	0
252971	1874	201249000	8205	4253	0	0	0
252972	1874	201250000	8206	4254	0	0	0
252975	1874	201251000	8209	4255	0	0	0
253035	1874	201253000	8212	4257	0	0	0
253036	1874	201254000	8212	4257	1	0	0
253038	1874	201255000	8214	4258	0	0	0
253039	1874	201256000	8215	4259	0	0	0
253041	1874	201257000	8217	4260	0	0	0
253049	1874	201258000	8221	4261	0	0	0
253050	1874	201259000	8222	4262	0	0	0
253053	1874	201260000	8225	4263	0	0	0
253055	1874	201261000	8227	4264	0	0	0
253058	1874	201263000	8230	4266	0	0	0
253059	1874	201264000	8230	4266	1	0	0
253060	1874	201265000	8230	4266	2	0	0
253073	1874	201266000	8235	4267	0	0	0
253074	1874	201267000	8235	4267	1	0	0
253080	1874	201269000	8243	4270	0	0	0
253081	1874	201270000	8243	4270	1	0	0
253082	1874	201271000	8243	4270	3	0	0
253091	1874	201272000	8247	4271	0	0	0
253093	1874	201273000	8249	4272	0	0	0
253098	1874	201275000	8254	4274	0	0	\N
253099	310	66000010000000	8254	4274	1	0	\N
253102	1874	201275000	8256	4274	0	0	\N
253103	310	66000010000000	8256	4274	1	0	\N
253105	1874	201277000	8259	4277	0	0	\N
253106	1874	201278000	8259	4277	1	0	\N
253109	1874	201277000	8261	4277	0	0	\N
253110	1874	201278000	8261	4277	1	0	\N
253116	1874	201279000	8263	4278	1	0	\N
253117	1874	201280000	8263	4278	2	0	\N
253118	1874	201281000	8263	4278	3	0	\N
253119	1874	201282000	8263	4278	4	0	\N
253120	1874	201283000	8263	4278	5	0	\N
253128	1874	201287000	8267	4281	0	0	\N
253129	1874	201288000	8267	4281	1	0	\N
253130	305	66000010000000	8267	4281	2	0	\N
253131	1521	2877088000000	8268	4282	0	0	\N
253133	1874	201289000	8270	4283	0	0	\N
253139	1874	201291000	8274	4285	0	0	\N
253140	1874	201292000	8274	4285	1	0	\N
253141	1874	201293000	8274	4285	2	0	\N
253146	1874	201297000	8277	4288	0	0	\N
253147	1521	2876077000000	8277	4288	1	0	\N
253148	1874	201297000	8278	4288	0	0	\N
253149	1521	2876077000000	8278	4288	1	0	\N
253150	1874	201297000	8279	4288	0	0	\N
253151	1521	2876077000000	8279	4288	1	0	\N
253155	1874	201299000	8282	4290	0	0	\N
253157	1874	201299000	8284	4290	0	0	\N
253158	1874	201299000	8285	4290	0	0	\N
253162	1874	201303000	8288	4293	0	0	\N
253163	1932	21000000000	8288	4293	1	0	\N
253166	1874	201304000	8290	4294	0	0	\N
253167	1874	201305000	8290	4294	1	0	\N
253168	1931	2874486000000	8290	4294	2	0	\N
253172	1874	201306000	8293	4295	0	0	\N
253173	1874	201307000	8293	4295	1	0	\N
253174	1874	201306000	8294	4295	0	0	\N
253175	1874	201307000	8294	4295	1	0	\N
253178	1874	201306000	8296	4295	0	0	\N
253179	1874	201307000	8296	4295	1	0	\N
253180	1483	0	8297	4296	0	0	\N
253183	1874	201309000	8299	4297	0	0	\N
253184	1874	201309000	8300	4297	0	0	\N
253186	1874	201310000	8302	4298	0	0	\N
253187	1718	2160240000000	8302	4298	1	0	\N
253190	1874	201311000	8304	4299	0	0	\N
253191	1874	201311000	8305	4299	0	0	\N
253192	1874	201311000	8306	4299	0	0	\N
253194	342	66001200000000	8308	4300	0	0	\N
253195	1874	201312000	8308	4300	1	0	\N
253196	166	66000010000000	8308	4300	2	0	\N
253200	1874	201217000	8310	4229	0	0	\N
253201	1874	201218000	8310	4229	1	0	\N
253202	1874	201219000	8310	4229	2	0	\N
253203	1874	201220000	8310	4229	3	0	\N
253204	1874	201221000	8310	4229	4	0	\N
253205	1874	201222000	8310	4229	5	0	\N
253206	1874	201223000	8310	4229	6	0	\N
253207	1874	201224000	8310	4229	7	0	\N
253208	1874	201225000	8310	4229	8	0	\N
253209	1874	201226000	8310	4229	10	0	\N
253210	1874	201227000	8310	4229	11	0	\N
253211	1874	201228000	8310	4229	12	0	\N
253212	1874	201229000	8310	4229	13	0	\N
253213	1874	201230000	8310	4229	14	0	\N
253214	1874	201231000	8310	4229	15	0	\N
253215	1874	201232000	8310	4229	16	0	\N
253216	1874	201233000	8310	4229	17	0	\N
253217	1874	201234000	8310	4229	18	0	\N
253218	1874	201235000	8310	4229	19	0	\N
253219	1874	201236000	8310	4229	20	0	\N
253220	1874	201237000	8310	4229	21	0	\N
253221	1874	201238000	8310	4229	22	0	\N
253222	1874	201239000	8310	4229	23	0	\N
253223	1874	201240000	8310	4229	24	0	\N
253224	1874	201241000	8310	4229	25	0	\N
253225	1874	201242000	8310	4229	26	0	\N
253226	1874	201243000	8310	4229	27	0	\N
253227	1874	201244000	8310	4229	28	0	\N
253228	1874	201245000	8310	4229	29	0	\N
253229	1874	201246000	8310	4229	30	0	\N
253230	1874	201247000	8310	4229	31	0	\N
253231	1929	200000000	8310	4229	32	0	\N
253232	1929	1400000000	8310	4229	33	0	\N
253101	310	66000010000000	8255	4274	1	0	0
253104	1874	201276000	8258	4276	0	0	0
253107	1874	201277000	8260	4277	0	0	0
253108	1874	201278000	8260	4277	1	0	0
253111	1874	201279000	8262	4278	1	0	0
253113	1874	201281000	8262	4278	3	0	0
253114	1874	201282000	8262	4278	4	0	0
253115	1874	201283000	8262	4278	5	0	0
253121	1874	201284000	8264	4279	0	0	0
253122	1521	2877099000000	8264	4279	1	0	2
253124	1874	201286000	8265	4280	1	0	0
253125	1874	201287000	8266	4281	0	0	0
253126	1874	201288000	8266	4281	1	0	0
253127	305	66000010000000	8266	4281	2	0	0
253134	1874	201289000	8271	4283	0	0	0
253135	1874	201290000	8272	4284	0	0	0
253136	1874	201291000	8273	4285	0	0	0
253137	1874	201292000	8273	4285	1	0	0
253138	1874	201293000	8273	4285	2	0	0
253143	1874	201295000	8275	4286	1	0	0
253144	1931	10000000	8275	4286	2	0	0
253145	1874	201296000	8276	4287	0	0	0
253152	1874	201297000	8280	4288	0	0	0
253153	1521	2876077000000	8280	4288	1	0	4
253156	1874	201299000	8283	4290	0	0	0
253159	1874	201300000	8286	4291	0	0	0
253160	1874	201301000	8286	4291	1	0	0
253161	1874	201302000	8287	4292	0	0	0
253165	1932	21000000000	8289	4293	1	0	0
253169	1874	201304000	8291	4294	0	0	0
253170	1874	201305000	8291	4294	1	0	0
253171	1931	2874486000000	8291	4294	2	0	1
253176	1874	201306000	8295	4295	0	0	0
253181	1874	201308000	8298	4296	0	0	0
253182	1483	0	8298	4296	1	0	0
253185	1874	201309000	8301	4297	0	0	0
253188	1874	201310000	8303	4298	0	0	0
253189	1718	2160240000000	8303	4298	1	0	0
253197	342	66001200000000	8309	4300	0	0	0
253198	1874	201312000	8309	4300	1	0	0
253199	166	66000010000000	8309	4300	2	0	0
253233	1874	201248000	8310	4229	34	0	\N
253234	1874	201249000	8310	4229	35	0	\N
253235	1874	201250000	8310	4229	36	0	\N
253236	1874	201251000	8310	4229	37	0	\N
253237	1874	201252000	8310	4229	38	0	\N
253238	1874	201253000	8310	4229	39	0	\N
253239	1874	201254000	8310	4229	40	0	\N
253240	1874	201255000	8310	4229	41	0	\N
253241	1874	201256000	8310	4229	42	0	\N
253242	1874	201257000	8310	4229	43	0	\N
253243	1930	200000000	8310	4229	44	0	\N
253244	1874	201258000	8310	4229	45	0	\N
253245	1874	201259000	8310	4229	46	0	\N
253246	1874	201260000	8310	4229	47	0	\N
253247	1874	201261000	8310	4229	48	0	\N
253248	1874	201262000	8310	4229	49	0	\N
253249	1874	201263000	8310	4229	50	0	\N
253250	1874	201264000	8310	4229	51	0	\N
253251	1874	201265000	8310	4229	52	0	\N
253252	1874	201266000	8310	4229	53	0	\N
253253	1874	201267000	8310	4229	54	0	\N
253254	1874	201268000	8310	4229	55	0	\N
253255	1874	201269000	8310	4229	56	0	\N
253256	1874	201270000	8310	4229	57	0	\N
253257	1874	201271000	8310	4229	58	0	\N
253258	1874	201272000	8310	4229	59	0	\N
253259	1874	201273000	8310	4229	60	0	\N
253260	1874	201274000	8310	4229	61	0	\N
253261	1874	201275000	8310	4229	62	0	\N
253262	1874	201276000	8310	4229	63	0	\N
253263	1874	201277000	8310	4229	64	0	\N
253264	1874	201278000	8310	4229	65	0	\N
253265	1874	201279000	8310	4229	66	0	\N
253266	1874	201280000	8310	4229	67	0	\N
253267	1874	201281000	8310	4229	68	0	\N
253268	1874	201282000	8310	4229	69	0	\N
253269	1874	201283000	8310	4229	70	0	\N
253270	1874	201284000	8310	4229	71	0	\N
253271	1874	201285000	8310	4229	72	0	\N
253272	1874	201286000	8310	4229	73	0	\N
253273	1874	201287000	8310	4229	74	0	\N
253274	1874	201288000	8310	4229	75	0	\N
253275	1874	201289000	8310	4229	76	0	\N
253276	1874	201290000	8310	4229	77	0	\N
253277	1874	201291000	8310	4229	78	0	\N
253278	1874	201292000	8310	4229	79	0	\N
253279	1874	201293000	8310	4229	80	0	\N
253280	1874	201294000	8310	4229	81	0	\N
253281	1874	201295000	8310	4229	82	0	\N
253282	1874	201296000	8310	4229	83	0	\N
253283	1874	201297000	8310	4229	84	0	\N
253284	1874	201298000	8310	4229	85	0	\N
253285	1874	201299000	8310	4229	86	0	\N
253286	1874	201300000	8310	4229	87	0	\N
253287	1874	201301000	8310	4229	88	0	\N
253288	1874	201302000	8310	4229	89	0	\N
253289	1874	201303000	8310	4229	90	0	\N
253290	1874	201304000	8310	4229	91	0	\N
253291	1874	201305000	8310	4229	92	0	\N
253292	1874	201306000	8310	4229	93	0	\N
253293	1874	201307000	8310	4229	94	0	\N
253294	1874	201308000	8310	4229	95	0	\N
253295	1874	201309000	8310	4229	96	0	\N
253296	1874	201310000	8310	4229	97	0	\N
253297	1874	201311000	8310	4229	98	0	\N
253298	1932	21000000000	8310	4229	99	0	\N
253299	1483	0	8310	4229	100	0	\N
253300	310	66000010000000	8310	4229	101	0	\N
253301	305	66000010000000	8310	4229	102	0	\N
253302	1718	1440230000000	8310	4229	103	0	\N
253303	1931	10000000	8310	4229	104	0	\N
253304	1874	201313000	8311	4301	0	0	\N
253315	1483	0	8317	4305	0	0	\N
253316	1874	201317000	8317	4305	1	0	\N
253317	1874	201318000	8317	4305	2	0	\N
253318	1874	201319000	8317	4305	3	0	\N
253319	1541	36000000	8317	4305	4	0	\N
253320	1483	0	8318	4305	0	0	\N
253321	1874	201317000	8318	4305	1	0	\N
253322	1874	201318000	8318	4305	2	0	\N
253323	1874	201319000	8318	4305	3	0	\N
253324	1541	36000000	8318	4305	4	0	\N
253326	1521	1588000000	8320	4307	0	0	\N
253328	1521	1588000000	8322	4307	0	0	\N
253331	1874	201323000	8324	4309	0	0	\N
253332	1874	201324000	8324	4309	1	0	\N
253335	1874	201325000	8326	4310	0	0	\N
253337	1874	201325000	8328	4310	0	0	\N
253347	1874	201334000	8337	4318	0	0	\N
253348	1874	201335000	8339	4319	0	0	\N
253349	1874	201335000	8340	4319	0	0	\N
253350	1874	201335000	8341	4319	0	0	\N
253354	1874	201335000	8343	4320	0	0	\N
253355	1874	201336000	8343	4320	1	0	\N
253356	1930	1400000000	8343	4320	2	0	\N
253365	1874	201340000	8347	4324	0	0	\N
253366	1874	201341000	8347	4324	1	0	\N
253367	1939	9000000000	8347	4324	2	0	\N
253368	1874	201340000	8348	4324	0	0	\N
253307	1874	201315000	8313	4302	1	0	0
253308	1718	10077440000000	8313	4302	2	0	0
253309	1874	201316000	8314	4303	0	0	0
253310	1483	0	8316	4305	0	0	0
253311	1874	201317000	8316	4305	1	0	0
253313	1874	201319000	8316	4305	3	0	0
253314	1541	36000000	8316	4305	4	0	4
253325	1874	201320000	8319	4306	0	0	0
253327	1521	1588000000	8321	4307	0	0	6
253329	1874	201321000	8323	4308	0	0	0
253333	1874	201323000	8325	4309	0	0	0
253334	1874	201324000	8325	4309	1	0	0
253336	1874	201325000	8327	4310	0	0	0
253338	1874	201326000	8329	4311	0	0	0
253340	1874	201328000	8331	4313	0	0	0
253341	1874	201329000	8332	4314	0	0	0
253342	1874	201330000	8333	4315	0	0	0
253343	1874	201331000	8334	4316	0	0	0
253344	1874	201332000	8335	4317	0	0	0
253346	1874	201334000	8336	4318	0	0	0
253351	1874	201335000	8342	4320	0	0	0
253352	1874	201336000	8342	4320	1	0	0
253353	1930	1400000000	8342	4320	2	0	0
253357	1934	200000000	8344	4321	0	0	0
253359	1935	200000000	8344	4321	2	0	0
253360	1936	200000000	8344	4321	3	0	0
253361	1937	200000000	8344	4321	4	0	0
253362	1938	200000000	8344	4321	5	0	0
253364	1874	201339000	8346	4323	0	0	0
253369	1874	201341000	8348	4324	1	0	\N
253370	1939	9000000000	8348	4324	2	0	\N
253374	1874	201342000	8350	4325	0	0	\N
253375	1874	201343000	8350	4325	1	0	\N
253376	1578	0	8350	4325	2	0	\N
253377	1874	201342000	8351	4325	0	0	\N
253378	1874	201343000	8351	4325	1	0	\N
253379	1578	0	8351	4325	2	0	\N
253383	1874	201342000	8353	4325	0	0	\N
253384	1874	201343000	8353	4325	1	0	\N
253385	1578	0	8353	4325	2	0	\N
253389	1874	201347000	8355	4327	0	0	\N
253390	1874	201348000	8355	4327	1	0	\N
253395	1874	201349000	8358	4328	0	0	\N
253396	667	66000100000000	8358	4328	1	0	\N
253406	1874	201359000	8364	4334	0	0	\N
253409	1874	201361000	8367	4336	0	0	\N
253411	1874	201361000	8369	4336	0	0	\N
253415	1874	201364000	8372	4338	0	0	\N
253425	1483	0	8377	4342	0	0	\N
253426	903	114218769973438	8377	4342	1	0	\N
253427	1874	201368000	8377	4342	2	0	\N
253428	1874	201369000	8377	4342	3	0	\N
253429	1483	0	8378	4342	0	0	\N
253430	903	114218769973438	8378	4342	1	0	\N
253431	1874	201368000	8378	4342	2	0	\N
253432	1874	201369000	8378	4342	3	0	\N
253433	1483	0	8379	4342	0	0	\N
253434	903	114218769973438	8379	4342	1	0	\N
253435	1874	201368000	8379	4342	2	0	\N
253436	1874	201369000	8379	4342	3	0	\N
253437	1483	0	8380	4342	0	0	\N
253438	903	114218769973438	8380	4342	1	0	\N
253439	1874	201368000	8380	4342	2	0	\N
253440	1874	201369000	8380	4342	3	0	\N
253441	1874	201370000	8381	4343	0	0	\N
253442	1874	201371000	8381	4343	1	0	\N
253450	1874	201375000	8384	4345	0	0	\N
253453	1874	201376000	8387	4346	0	0	\N
253454	1874	201221000	8388	4232	0	0	\N
253455	1874	201222000	8388	4232	1	0	\N
253456	1874	201223000	8388	4232	2	0	\N
253457	1874	201224000	8388	4232	3	0	\N
253458	1874	201225000	8388	4232	4	0	\N
253459	1874	201226000	8388	4232	5	0	\N
253460	1874	201227000	8388	4232	6	0	\N
253461	1874	201228000	8388	4232	7	0	\N
253462	1874	201229000	8388	4232	8	0	\N
253463	1874	201230000	8388	4232	9	0	\N
253464	1874	201231000	8388	4232	10	0	\N
253465	1874	201232000	8388	4232	11	0	\N
253466	1874	201233000	8388	4232	12	0	\N
253467	1874	201234000	8388	4232	13	0	\N
253468	1939	9000000000	8388	4232	14	0	\N
253469	1874	201235000	8388	4232	15	0	\N
253470	1874	201236000	8388	4232	16	0	\N
253471	1874	201237000	8388	4232	17	0	\N
253472	1874	201238000	8388	4232	18	0	\N
253473	1874	201239000	8388	4232	19	0	\N
253474	1874	201240000	8388	4232	20	0	\N
253475	1874	201241000	8388	4232	21	0	\N
253476	1874	201242000	8388	4232	22	0	\N
253477	1874	201243000	8388	4232	23	0	\N
253478	1874	201244000	8388	4232	24	0	\N
253479	1874	201245000	8388	4232	25	0	\N
253480	1874	201246000	8388	4232	26	0	\N
253481	1874	201247000	8388	4232	27	0	\N
253482	1929	200000000	8388	4232	28	0	\N
253483	1929	1400000000	8388	4232	29	0	\N
253484	1874	201248000	8388	4232	30	0	\N
253485	1874	201249000	8388	4232	31	0	\N
253486	1874	201250000	8388	4232	32	0	\N
253487	1874	201251000	8388	4232	33	0	\N
253488	1874	201252000	8388	4232	34	0	\N
253489	1874	201253000	8388	4232	35	0	\N
253490	1874	201254000	8388	4232	36	0	\N
253491	1874	201255000	8388	4232	37	0	\N
253492	1874	201256000	8388	4232	38	0	\N
253493	1874	201257000	8388	4232	39	0	\N
253494	1930	200000000	8388	4232	40	0	\N
253495	1874	201258000	8388	4232	41	0	\N
253496	1874	201259000	8388	4232	42	0	\N
253497	1874	201260000	8388	4232	43	0	\N
253498	1874	201261000	8388	4232	44	0	\N
253499	1874	201262000	8388	4232	45	0	\N
253500	1874	201263000	8388	4232	46	0	\N
253501	1874	201264000	8388	4232	47	0	\N
253502	1874	201265000	8388	4232	48	0	\N
253503	1874	201266000	8388	4232	49	0	\N
253504	1874	201267000	8388	4232	50	0	\N
253373	1939	9000000000	8349	4324	2	0	0
253380	1874	201342000	8352	4325	0	0	0
253381	1874	201343000	8352	4325	1	0	0
253382	1578	0	8352	4325	2	0	0
253386	1874	201344000	8354	4326	0	0	0
253388	1874	201346000	8354	4326	2	0	0
253391	1874	201347000	8356	4327	0	0	0
253392	1874	201348000	8356	4327	1	0	0
253393	1874	201349000	8357	4328	0	0	0
253394	667	66000100000000	8357	4328	1	0	0
253398	1874	201351000	8359	4329	1	0	0
253399	1874	201352000	8360	4330	0	0	0
253400	1874	201353000	8360	4330	1	0	0
253401	1874	201354000	8361	4331	0	0	0
253403	1874	201356000	8362	4332	0	0	0
253404	1874	201357000	8363	4333	0	0	0
253405	1874	201358000	8363	4333	1	0	0
253407	1874	201359000	8365	4334	0	0	0
253408	1874	201360000	8366	4335	0	0	0
253412	1874	201362000	8370	4337	0	0	0
253413	1874	201363000	8370	4337	1	0	0
253414	1874	201364000	8371	4338	0	0	0
253416	1874	201365000	8373	4339	0	0	0
253417	1941	500000000	8373	4339	1	0	0
253419	1874	201367000	8375	4341	0	0	0
253420	1483	0	8375	4341	1	0	0
253421	1483	0	8376	4342	0	0	0
253422	903	114218769973438	8376	4342	1	0	0
253424	1874	201369000	8376	4342	3	0	0
253443	1874	201370000	8382	4343	0	0	0
253444	1874	201371000	8382	4343	1	0	0
253445	1874	201372000	8383	4344	0	0	0
253446	1874	201373000	8383	4344	1	0	0
253448	1941	718961000000	8383	4344	3	0	1
253449	904	114218764973438	8383	4344	4	0	0
253451	1874	201375000	8385	4345	0	0	0
253452	1874	201376000	8386	4346	0	0	0
253505	1874	201268000	8388	4232	51	0	\N
253506	1874	201269000	8388	4232	52	0	\N
253507	1874	201270000	8388	4232	53	0	\N
253508	1874	201271000	8388	4232	54	0	\N
253509	1874	201272000	8388	4232	55	0	\N
253510	1874	201273000	8388	4232	56	0	\N
253511	1874	201274000	8388	4232	57	0	\N
253512	1874	201275000	8388	4232	58	0	\N
253513	1874	201276000	8388	4232	59	0	\N
253514	1874	201277000	8388	4232	60	0	\N
253515	1874	201278000	8388	4232	61	0	\N
253516	1874	201279000	8388	4232	62	0	\N
253517	1874	201280000	8388	4232	63	0	\N
253518	1874	201281000	8388	4232	64	0	\N
253519	1874	201282000	8388	4232	65	0	\N
253520	1874	201283000	8388	4232	66	0	\N
253521	1874	201284000	8388	4232	67	0	\N
253522	1874	201285000	8388	4232	68	0	\N
253523	1874	201286000	8388	4232	69	0	\N
253524	1874	201287000	8388	4232	70	0	\N
253525	1874	201288000	8388	4232	71	0	\N
253526	1874	201289000	8388	4232	72	0	\N
253527	1874	201290000	8388	4232	73	0	\N
253528	1874	201291000	8388	4232	74	0	\N
253529	1874	201292000	8388	4232	75	0	\N
253530	1874	201293000	8388	4232	76	0	\N
253531	1874	201294000	8388	4232	77	0	\N
253532	1874	201295000	8388	4232	78	0	\N
253533	1874	201296000	8388	4232	79	0	\N
253534	1874	201297000	8388	4232	80	0	\N
253535	1874	201298000	8388	4232	81	0	\N
253536	1874	201299000	8388	4232	82	0	\N
253537	1874	201300000	8388	4232	83	0	\N
253538	1874	201301000	8388	4232	84	0	\N
253539	1874	201302000	8388	4232	85	0	\N
253540	1874	201303000	8388	4232	86	0	\N
253541	1874	201304000	8388	4232	87	0	\N
253542	1874	201305000	8388	4232	88	0	\N
253543	1874	201306000	8388	4232	89	0	\N
253544	1874	201307000	8388	4232	90	0	\N
253545	1874	201308000	8388	4232	91	0	\N
253546	1874	201309000	8388	4232	92	0	\N
253547	1874	201310000	8388	4232	93	0	\N
253548	1874	201311000	8388	4232	94	0	\N
253549	342	66001200000000	8388	4232	95	0	\N
253550	1874	201312000	8388	4232	96	0	\N
253551	1874	201313000	8388	4232	97	0	\N
253552	1874	201314000	8388	4232	98	0	\N
253553	1874	201315000	8388	4232	99	0	\N
253554	1874	201316000	8388	4232	100	0	\N
253555	1874	201317000	8388	4232	101	0	\N
253556	1874	201318000	8388	4232	102	0	\N
253557	1874	201319000	8388	4232	103	0	\N
253558	1874	201320000	8388	4232	104	0	\N
253559	1874	201321000	8388	4232	105	0	\N
253560	1874	201322000	8388	4232	106	0	\N
253561	1874	201323000	8388	4232	107	0	\N
253562	1874	201324000	8388	4232	108	0	\N
253563	1874	201325000	8388	4232	109	0	\N
253564	1874	201326000	8388	4232	110	0	\N
253565	1874	201327000	8388	4232	111	0	\N
253566	1874	201328000	8388	4232	112	0	\N
253567	1874	201329000	8388	4232	113	0	\N
253568	1874	201330000	8388	4232	114	0	\N
253569	1874	201331000	8388	4232	115	0	\N
253570	1874	201332000	8388	4232	116	0	\N
253571	1874	201333000	8388	4232	117	0	\N
253572	1874	201334000	8388	4232	118	0	\N
253573	1874	201335000	8388	4232	119	0	\N
253574	1874	201336000	8388	4232	120	0	\N
253575	1930	1400000000	8388	4232	121	0	\N
253576	1934	200000000	8388	4232	122	0	\N
253577	1874	201337000	8388	4232	123	0	\N
253578	1935	200000000	8388	4232	124	0	\N
253579	1936	200000000	8388	4232	125	0	\N
253582	1874	201377000	8390	4347	0	0	\N
253583	1941	718971000000	8390	4347	1	0	\N
253586	1874	201379000	8393	4349	0	0	\N
253587	1874	201380000	8394	4350	0	0	\N
253588	1511	0	8394	4350	1	0	\N
253589	1874	201380000	8395	4350	0	0	\N
253590	1511	0	8395	4350	1	0	\N
253595	1874	201383000	8399	4353	0	0	\N
253597	1874	201384000	8401	4354	0	0	\N
253599	1874	201384000	8403	4354	0	0	\N
253601	1874	201386000	8405	4356	0	0	\N
253603	1874	201386000	8407	4356	0	0	\N
253606	1874	201388000	8410	4358	0	0	\N
253607	1874	201389000	8411	4359	0	0	\N
253608	1942	200000000	8411	4359	1	0	\N
253609	1874	201390000	8411	4359	2	0	\N
253613	1874	201389000	8413	4359	0	0	\N
253614	1942	200000000	8413	4359	1	0	\N
253615	1874	201390000	8413	4359	2	0	\N
253621	1874	201391000	8450	4378	0	0	\N
253622	1944	200000000	8450	4378	1	0	\N
253623	1874	201392000	8450	4378	2	0	\N
253624	1874	201393000	8451	4379	0	0	\N
253627	1874	201394000	8454	4380	0	0	\N
253629	1874	201396000	8456	4382	0	0	\N
253630	1874	201396000	8457	4382	0	0	\N
253632	1874	201396000	8459	4382	0	0	\N
253633	1941	500000000	8460	4337	0	0	\N
253634	1941	718991000000	8460	4337	1	0	\N
253635	1874	201362000	8460	4337	2	0	\N
253636	1874	201363000	8460	4337	3	0	\N
253637	1874	201364000	8460	4337	4	0	\N
253638	1874	201365000	8460	4337	5	0	\N
253639	1874	201397000	8461	4383	0	0	\N
253584	1874	201378000	8391	4348	0	0	0
253585	1874	201379000	8392	4349	0	0	0
253591	1874	201380000	8396	4350	0	0	0
253592	1511	0	8396	4350	1	0	2
253593	1874	201381000	8397	4351	0	0	0
253596	1874	201383000	8400	4353	0	0	0
253598	1874	201384000	8402	4354	0	0	0
253600	1874	201385000	8404	4355	0	0	0
253602	1874	201386000	8406	4356	0	0	0
253604	1874	201387000	8408	4357	0	0	0
253610	1874	201389000	8412	4359	0	0	0
253611	1942	200000000	8412	4359	1	0	0
253612	1874	201390000	8412	4359	2	0	0
253616	210	66000000000000	8447	4376	0	0	0
253618	1874	201391000	8449	4378	0	0	0
253619	1944	200000000	8449	4378	1	0	0
253620	1874	201392000	8449	4378	2	0	0
253625	1874	201393000	8452	4379	0	0	0
253626	1874	201394000	8453	4380	0	0	0
253631	1874	201396000	8458	4382	0	0	0
253640	1874	201397000	8462	4383	0	0	0
253643	1874	201400000	8465	4386	0	0	\N
253645	1874	201400000	8467	4386	0	0	\N
253651	1874	201401000	8469	4387	0	0	\N
253652	1874	201402000	8469	4387	1	0	\N
253653	1874	201403000	8469	4387	2	0	\N
253654	1874	201404000	8469	4387	3	0	\N
253655	640	66000010000000	8469	4387	4	0	\N
253657	1874	201405000	8471	4388	0	0	\N
253658	1874	201406000	8472	4389	0	0	\N
253660	1874	201406000	8474	4389	0	0	\N
253665	1874	201409000	8478	4392	0	0	\N
253666	1945	200000000	8478	4392	1	0	\N
253667	1874	201410000	8479	4393	0	0	\N
253671	1483	0	8482	4394	0	0	\N
253672	1874	201411000	8482	4394	1	0	\N
253673	1483	0	8483	4394	0	0	\N
253674	1874	201411000	8483	4394	1	0	\N
253675	1874	201412000	8484	4395	0	0	\N
253676	1874	201413000	8484	4395	1	0	\N
253677	1874	201412000	8485	4395	0	0	\N
253678	1874	201413000	8485	4395	1	0	\N
253682	1874	201414000	8488	4396	0	0	\N
253684	1874	201416000	8490	4398	0	0	\N
253685	695	66720000000000	8490	4398	1	0	\N
253686	1874	201417000	8490	4398	2	0	\N
253690	1874	201418000	8492	4399	0	0	\N
253692	1874	201419000	8494	4400	0	0	\N
253694	1874	201420000	8496	4401	0	0	\N
253695	1874	201420000	8497	4401	0	0	\N
253698	1874	201421000	8500	4402	0	0	\N
253699	1874	201422000	8501	4403	0	0	\N
253704	1874	201425000	8506	4406	0	0	\N
253706	1874	201426000	8508	4407	0	0	\N
253707	1874	201426000	8509	4407	0	0	\N
253709	1874	201428000	8511	4409	0	0	\N
253713	1874	201431000	8515	4412	0	0	\N
253715	1874	201432000	8517	4413	0	0	\N
253716	1874	201433000	8517	4413	1	0	\N
253717	1874	201432000	8518	4413	0	0	\N
253718	1874	201433000	8518	4413	1	0	\N
253719	1874	201432000	8519	4413	0	0	\N
253720	1874	201433000	8519	4413	1	0	\N
253729	1874	201439000	8524	4417	0	0	\N
253732	1874	201440000	8527	4418	0	0	\N
253733	1874	201440000	8528	4418	0	0	\N
253734	1874	201441000	8530	4419	0	0	\N
253735	1874	201442000	8530	4419	1	0	\N
253738	1874	201443000	8532	4420	0	0	\N
253741	1874	201445000	8535	4422	0	0	\N
253747	1874	201450000	8538	4424	0	0	\N
253748	1874	201450000	8539	4424	0	0	\N
253751	1874	201452000	8542	4426	0	0	\N
253752	1874	201453000	8542	4426	1	0	\N
253755	1874	201452000	8544	4426	0	0	\N
253756	1874	201453000	8544	4426	1	0	\N
253758	1874	201455000	8546	4428	0	0	\N
253759	1874	201456000	8546	4428	1	0	\N
253763	1874	201457000	8549	4429	0	0	\N
253769	1874	201463000	8557	4435	0	0	\N
253771	1874	201464000	8559	4436	0	0	\N
253776	1874	201468000	8563	4439	0	0	\N
253644	1874	201400000	8466	4386	0	0	0
253646	1874	201401000	8468	4387	0	0	0
253647	1874	201402000	8468	4387	1	0	0
253648	1874	201403000	8468	4387	2	0	0
253649	1874	201404000	8468	4387	3	0	0
253656	1874	201405000	8470	4388	0	0	0
253659	1874	201406000	8473	4389	0	0	0
253661	1874	201407000	8475	4390	0	0	0
253662	1874	201408000	8476	4391	0	0	0
253663	1874	201409000	8477	4392	0	0	0
253668	1874	201410000	8480	4393	0	0	0
253669	1483	0	8481	4394	0	0	0
253670	1874	201411000	8481	4394	1	0	0
253679	1874	201412000	8486	4395	0	0	0
253681	1874	201414000	8487	4396	0	0	0
253683	1874	201415000	8489	4397	0	0	0
253687	1874	201416000	8491	4398	0	0	0
253688	695	66720000000000	8491	4398	1	0	0
253689	1874	201417000	8491	4398	2	0	0
253693	1874	201419000	8495	4400	0	0	0
253696	1874	201420000	8498	4401	0	0	0
253697	1874	201421000	8499	4402	0	0	0
253700	1874	201422000	8502	4403	0	0	0
253701	1874	201423000	8503	4404	0	0	0
253703	1874	201425000	8505	4406	0	0	0
253705	1874	201426000	8507	4407	0	0	0
253708	1874	201427000	8510	4408	0	0	0
253710	1874	201428000	8512	4409	0	0	0
253712	1874	201430000	8514	4411	0	0	0
253714	1874	201431000	8516	4412	0	0	0
253721	1874	201432000	8520	4413	0	0	0
253722	1874	201433000	8520	4413	1	0	0
253723	1874	201434000	8521	4414	0	0	0
253725	1874	201436000	8522	4415	1	0	0
253726	1939	709000000000	8522	4415	2	0	0
253727	1874	201437000	8523	4416	0	0	0
253728	1874	201438000	8523	4416	1	0	0
253730	1874	201439000	8525	4417	0	0	0
253736	1874	201441000	8531	4419	0	0	0
253737	1874	201442000	8531	4419	1	0	0
253739	1874	201443000	8533	4420	0	0	0
253740	1874	201444000	8534	4421	0	0	0
253743	1874	201446000	8537	4423	0	0	0
253744	1874	201447000	8537	4423	1	0	0
253745	1874	201448000	8537	4423	2	0	0
253746	1874	201449000	8537	4423	3	0	0
253749	1874	201450000	8540	4424	0	0	0
253753	1874	201452000	8543	4426	0	0	0
253754	1874	201453000	8543	4426	1	0	0
253757	1874	201454000	8545	4427	0	0	0
253760	1874	201455000	8547	4428	0	0	0
253761	1874	201456000	8547	4428	1	0	0
253764	1874	201458000	8550	4430	0	0	0
253765	1874	201459000	8553	4431	0	0	0
253766	1874	201460000	8554	4432	0	0	0
253767	1874	201461000	8555	4433	0	0	0
253770	1874	201463000	8558	4435	0	0	0
253772	1874	201464000	8560	4436	0	0	0
253773	1874	201465000	8561	4437	0	0	0
253774	1874	201466000	8562	4438	0	0	0
253775	1874	201467000	8562	4438	1	0	0
253777	1874	201469000	8563	4439	1	0	\N
253780	1874	201470000	8565	4440	0	0	\N
253782	1874	201470000	8567	4440	0	0	\N
253783	1874	201471000	8568	4441	0	0	\N
253785	1874	201472000	8570	4442	0	0	\N
253786	1874	201473000	8570	4442	1	0	\N
253789	1874	201474000	8572	4443	0	0	\N
253790	1874	201475000	8572	4443	1	0	\N
253794	1874	201476000	8575	4444	0	0	\N
253800	1874	201482000	8580	4449	0	0	\N
253802	1874	201482000	8582	4449	0	0	\N
253804	1483	0	8584	4367	0	0	\N
253805	210	66000000000000	8584	4367	1	0	\N
253806	695	66720000000000	8584	4367	2	0	\N
253807	1874	201391000	8584	4367	3	0	\N
253808	1944	200000000	8584	4367	4	0	\N
253809	1874	201392000	8584	4367	5	0	\N
253810	1874	201393000	8584	4367	6	0	\N
253811	1874	201394000	8584	4367	7	0	\N
253812	1874	201395000	8584	4367	8	0	\N
253813	1874	201396000	8584	4367	9	0	\N
253814	1874	201397000	8584	4367	10	0	\N
253815	1874	201398000	8584	4367	11	0	\N
253816	1874	201399000	8584	4367	12	0	\N
253817	1874	201400000	8584	4367	13	0	\N
253818	1874	201401000	8584	4367	14	0	\N
253819	1874	201402000	8584	4367	15	0	\N
253820	1874	201403000	8584	4367	16	0	\N
253821	1874	201404000	8584	4367	17	0	\N
253822	640	66000010000000	8584	4367	18	0	\N
253823	1874	201405000	8584	4367	19	0	\N
253824	1874	201406000	8584	4367	20	0	\N
253825	1874	201407000	8584	4367	21	0	\N
253826	1874	201408000	8584	4367	22	0	\N
253827	1874	201409000	8584	4367	23	0	\N
253828	1945	200000000	8584	4367	24	0	\N
253829	1874	201410000	8584	4367	25	0	\N
253830	1874	201411000	8584	4367	26	0	\N
253831	1874	201412000	8584	4367	27	0	\N
253832	1874	201413000	8584	4367	28	0	\N
253833	1874	201414000	8584	4367	29	0	\N
253834	1874	201415000	8584	4367	30	0	\N
253835	1874	201416000	8584	4367	31	0	\N
253836	1874	201417000	8584	4367	32	0	\N
253837	1874	201418000	8584	4367	33	0	\N
253838	1874	201419000	8584	4367	34	0	\N
253839	1874	201420000	8584	4367	35	0	\N
253840	1874	201421000	8584	4367	36	0	\N
253841	1874	201422000	8584	4367	37	0	\N
253842	1874	201423000	8584	4367	38	0	\N
253843	1874	201424000	8584	4367	39	0	\N
253844	1874	201425000	8584	4367	40	0	\N
253845	1874	201426000	8584	4367	41	0	\N
253846	1874	201427000	8584	4367	42	0	\N
253847	1874	201428000	8584	4367	44	0	\N
253848	1874	201429000	8584	4367	45	0	\N
253849	1874	201430000	8584	4367	46	0	\N
253850	1874	201431000	8584	4367	47	0	\N
253851	1874	201432000	8584	4367	48	0	\N
253852	1874	201433000	8584	4367	49	0	\N
253853	1874	201434000	8584	4367	50	0	\N
253854	1874	201435000	8584	4367	51	0	\N
253855	1874	201436000	8584	4367	52	0	\N
253856	1874	201437000	8584	4367	53	0	\N
253857	1874	201438000	8584	4367	54	0	\N
253858	1874	201439000	8584	4367	55	0	\N
253859	1874	201440000	8584	4367	56	0	\N
253860	1874	201441000	8584	4367	57	0	\N
253861	1874	201442000	8584	4367	58	0	\N
253862	1874	201443000	8584	4367	59	0	\N
253863	1874	201444000	8584	4367	60	0	\N
253864	1874	201445000	8584	4367	61	0	\N
253865	1874	201446000	8584	4367	62	0	\N
253866	1874	201447000	8584	4367	63	0	\N
253867	1874	201448000	8584	4367	64	0	\N
253868	1874	201449000	8584	4367	65	0	\N
253869	1874	201450000	8584	4367	66	0	\N
253870	1874	201451000	8584	4367	67	0	\N
253871	1874	201452000	8584	4367	68	0	\N
253872	1874	201453000	8584	4367	69	0	\N
253873	1874	201454000	8584	4367	70	0	\N
253874	1874	201455000	8584	4367	71	0	\N
253875	1874	201456000	8584	4367	72	0	\N
253876	1874	201457000	8584	4367	73	0	\N
253877	1874	201458000	8584	4367	74	0	\N
253878	1874	201459000	8584	4367	75	0	\N
253879	1874	201460000	8584	4367	76	0	\N
253880	1874	201461000	8584	4367	77	0	\N
253881	1874	201462000	8584	4367	78	0	\N
253882	1874	201463000	8584	4367	79	0	\N
253883	1874	201464000	8584	4367	80	0	\N
253884	1874	201465000	8584	4367	81	0	\N
253885	1874	201466000	8584	4367	82	0	\N
253886	1874	201467000	8584	4367	83	0	\N
253887	1874	201468000	8584	4367	84	0	\N
253888	1874	201469000	8584	4367	85	0	\N
253889	1874	201470000	8584	4367	86	0	\N
253890	1874	201471000	8584	4367	87	0	\N
253891	1874	201472000	8584	4367	88	0	\N
253892	1874	201473000	8584	4367	89	0	\N
253893	1874	201474000	8584	4367	90	0	\N
253894	1874	201475000	8584	4367	91	0	\N
253895	1874	201476000	8584	4367	92	0	\N
253896	1874	201477000	8584	4367	93	0	\N
253897	1874	201478000	8584	4367	94	0	\N
253898	1874	201479000	8584	4367	95	0	\N
253899	1874	201480000	8584	4367	96	0	\N
253900	1874	201481000	8584	4367	97	0	\N
253901	1874	201482000	8584	4367	98	0	\N
253902	1874	201483000	8584	4367	99	0	\N
253903	1939	709000000000	8584	4367	100	0	\N
253904	592	66720000000000	8584	4367	101	0	\N
253907	1874	201486000	8587	4453	0	0	\N
253908	1874	201486000	8588	4453	0	0	\N
253781	1874	201470000	8566	4440	0	0	0
253784	1874	201471000	8569	4441	0	0	0
253787	1874	201472000	8571	4442	0	0	0
253788	1874	201473000	8571	4442	1	0	0
253791	1874	201474000	8573	4443	0	0	0
253793	1874	201476000	8574	4444	0	0	0
253795	1874	201477000	8576	4445	0	0	0
253796	1874	201478000	8576	4445	1	0	0
253797	1874	201479000	8577	4446	0	0	0
253798	1874	201480000	8578	4447	0	0	0
253801	1874	201482000	8581	4449	0	0	0
253803	1874	201483000	8583	4450	0	0	0
253905	1874	201484000	8585	4451	0	0	0
253906	1874	201485000	8586	4452	0	0	0
253910	1874	201487000	8590	4454	0	0	0
253911	1874	201488000	8590	4454	1	0	0
253912	1874	201489000	8591	4455	0	0	0
253913	1874	201489000	8592	4455	0	0	\N
253914	1874	201489000	8593	4455	0	0	\N
253915	1874	201489000	8594	4455	0	0	\N
253918	1874	201491000	8596	4457	0	0	\N
253922	1874	201493000	8600	4459	0	0	\N
253924	1874	201494000	8602	4460	0	0	\N
253925	1874	201495000	8603	4461	0	0	\N
253926	1874	201496000	8603	4461	1	0	\N
253927	1874	201497000	8603	4461	2	0	\N
253928	1874	201498000	8603	4461	3	0	\N
253929	1874	201499000	8603	4461	4	0	\N
253930	1874	201500000	8603	4461	5	0	\N
253931	1874	201501000	8603	4461	6	0	\N
253932	1874	201502000	8603	4461	8	0	\N
253933	1904	1000000000	8603	4461	9	0	\N
253934	1904	2000000000	8603	4461	10	0	\N
253935	1908	1000000000	8603	4461	11	0	\N
253936	1909	1000000000	8603	4461	12	0	\N
253937	1910	1000000000	8603	4461	13	0	\N
253938	1911	1000000000	8603	4461	14	0	\N
253939	1912	1000000000	8603	4461	15	0	\N
253940	1913	1000000000	8603	4461	16	0	\N
253941	1917	1000000000	8603	4461	17	0	\N
253942	1946	1000000000	8603	4461	18	0	\N
253961	1874	201495000	8605	4461	0	0	\N
253962	1874	201496000	8605	4461	1	0	\N
253963	1874	201497000	8605	4461	2	0	\N
253964	1874	201498000	8605	4461	3	0	\N
253965	1874	201499000	8605	4461	4	0	\N
253966	1874	201500000	8605	4461	5	0	\N
253967	1874	201501000	8605	4461	6	0	\N
253968	1874	201502000	8605	4461	8	0	\N
253969	1904	1000000000	8605	4461	9	0	\N
253970	1904	2000000000	8605	4461	10	0	\N
253971	1908	1000000000	8605	4461	11	0	\N
253972	1909	1000000000	8605	4461	12	0	\N
253973	1910	1000000000	8605	4461	13	0	\N
253974	1911	1000000000	8605	4461	14	0	\N
253975	1912	1000000000	8605	4461	15	0	\N
253976	1913	1000000000	8605	4461	16	0	\N
253977	1917	1000000000	8605	4461	17	0	\N
253978	1946	1000000000	8605	4461	18	0	\N
253979	1874	201484000	8606	4368	0	0	\N
253980	1874	201485000	8606	4368	1	0	\N
253981	1874	201486000	8606	4368	2	0	\N
253982	1874	201487000	8606	4368	3	0	\N
253983	1874	201488000	8606	4368	4	0	\N
253984	1874	201489000	8606	4368	5	0	\N
253985	1874	201490000	8606	4368	6	0	\N
253986	1874	201491000	8606	4368	7	0	\N
253987	1874	201492000	8606	4368	8	0	\N
253988	1874	201493000	8606	4368	9	0	\N
253989	1874	201494000	8606	4368	10	0	\N
253990	1874	201495000	8606	4368	11	0	\N
253991	1874	201496000	8606	4368	12	0	\N
253992	1874	201497000	8606	4368	13	0	\N
253993	1874	201498000	8606	4368	14	0	\N
253994	1874	201499000	8606	4368	15	0	\N
253995	1874	201500000	8606	4368	16	0	\N
253996	1874	201501000	8606	4368	17	0	\N
253997	1874	201502000	8606	4368	18	0	\N
253998	1874	201503000	8606	4368	19	0	\N
253999	1874	201504000	8606	4368	20	0	\N
254000	1874	201505000	8606	4368	21	0	\N
254001	1946	0	8606	4368	22	0	\N
254002	1904	1000000000	8606	4368	23	0	\N
254003	1904	2000000000	8606	4368	24	0	\N
254004	1908	1000000000	8606	4368	25	0	\N
254005	1909	1000000000	8606	4368	26	0	\N
254006	1910	1000000000	8606	4368	27	0	\N
254007	1911	1000000000	8606	4368	28	0	\N
254008	1912	1000000000	8606	4368	29	0	\N
254009	1913	1000000000	8606	4368	30	0	\N
254010	1917	1000000000	8606	4368	31	0	\N
254011	1946	1000000000	8606	4368	32	0	\N
254016	1874	201507000	8608	4463	0	0	\N
254018	1483	0	8610	4332	0	0	\N
254019	1874	201356000	8610	4332	1	0	\N
254020	695	66720000000000	8610	4332	2	0	\N
254021	1874	201357000	8610	4332	3	0	\N
254022	1874	201358000	8610	4332	4	0	\N
254023	1874	201359000	8610	4332	5	0	\N
254024	1874	201360000	8610	4332	6	0	\N
254025	1874	201361000	8610	4332	7	0	\N
254026	1941	500000000	8610	4332	8	0	\N
254027	1941	718991000000	8610	4332	9	0	\N
254028	1874	201362000	8610	4332	10	0	\N
254029	1874	201363000	8610	4332	11	0	\N
254030	1874	201364000	8610	4332	12	0	\N
254031	1874	201365000	8610	4332	13	0	\N
254032	1874	201366000	8610	4332	14	0	\N
254033	1874	201367000	8610	4332	15	0	\N
254034	1874	201368000	8610	4332	16	0	\N
254035	1874	201369000	8610	4332	17	0	\N
254036	1874	201370000	8610	4332	18	0	\N
254037	1874	201371000	8610	4332	19	0	\N
254038	1874	201372000	8610	4332	20	0	\N
254039	1874	201373000	8610	4332	21	0	\N
254041	1874	201509000	8612	4465	0	0	\N
254042	1874	201510000	8612	4465	1	0	\N
254045	1874	201509000	8614	4465	0	0	\N
254046	1874	201510000	8614	4465	1	0	\N
254047	1874	201511000	8615	4466	0	0	\N
253919	1874	201491000	8597	4457	0	0	0
253920	1874	201492000	8598	4458	0	0	0
253921	1874	201493000	8599	4459	0	0	0
253923	1874	201494000	8601	4460	0	0	0
253943	1874	201495000	8604	4461	0	0	0
253945	1874	201497000	8604	4461	2	0	0
253946	1874	201498000	8604	4461	3	0	0
253947	1874	201499000	8604	4461	4	0	0
253948	1874	201500000	8604	4461	5	0	0
253949	1874	201501000	8604	4461	6	0	0
253951	1904	1000000000	8604	4461	9	0	0
253952	1904	2000000000	8604	4461	10	0	0
253953	1908	1000000000	8604	4461	11	0	0
253954	1909	1000000000	8604	4461	12	0	0
253956	1911	1000000000	8604	4461	14	0	0
253957	1912	1000000000	8604	4461	15	0	0
253958	1913	1000000000	8604	4461	16	0	0
253959	1917	1000000000	8604	4461	17	0	0
253960	1946	1000000000	8604	4461	18	0	0
254013	1874	201504000	8607	4462	1	0	0
254014	1874	201505000	8607	4462	2	0	0
254015	1874	201506000	8607	4462	3	0	0
254017	1874	201507000	8609	4463	0	0	0
254040	1874	201508000	8611	4464	0	0	0
254044	1874	201510000	8613	4465	1	0	0
254048	1874	201511000	8616	4466	0	0	0
254049	1874	201512000	8617	4467	0	0	\N
254052	1874	201514000	8620	4469	0	0	\N
254054	1874	201515000	8622	4470	0	0	\N
254055	1874	201516000	8624	4471	0	0	\N
254058	1483	0	8626	4336	0	0	\N
254059	695	66720000000000	8626	4336	1	0	\N
254060	1874	201361000	8626	4336	2	0	\N
254061	1941	500000000	8626	4336	3	0	\N
254062	1941	718991000000	8626	4336	4	0	\N
254063	1874	201362000	8626	4336	5	0	\N
254064	1874	201363000	8626	4336	6	0	\N
254065	1874	201364000	8626	4336	7	0	\N
254066	1874	201365000	8626	4336	8	0	\N
254067	1874	201366000	8626	4336	10	0	\N
254068	1874	201367000	8626	4336	11	0	\N
254069	1874	201368000	8626	4336	12	0	\N
254070	1874	201369000	8626	4336	13	0	\N
254071	1874	201370000	8626	4336	14	0	\N
254072	1874	201371000	8626	4336	15	0	\N
254073	1874	201372000	8626	4336	16	0	\N
254074	1874	201373000	8626	4336	17	0	\N
254075	1874	201374000	8626	4336	18	0	\N
254076	1874	201375000	8626	4336	19	0	\N
254077	1874	201376000	8626	4336	20	0	\N
254078	1874	201377000	8626	4336	21	0	\N
254079	1874	201378000	8626	4336	22	0	\N
254080	1874	201379000	8626	4336	23	0	\N
254081	1874	201380000	8626	4336	24	0	\N
254082	1874	201381000	8626	4336	25	0	\N
254083	1874	201382000	8626	4336	26	0	\N
254084	1874	201383000	8626	4336	27	0	\N
254085	1874	201384000	8626	4336	28	0	\N
254086	1874	201385000	8626	4336	29	0	\N
254087	1874	201386000	8626	4336	30	0	\N
254088	1874	201387000	8626	4336	31	0	\N
254089	1874	201388000	8626	4336	32	0	\N
254090	1874	201389000	8626	4336	33	0	\N
254091	1942	200000000	8626	4336	34	0	\N
254092	1874	201390000	8626	4336	35	0	\N
254093	1874	201391000	8626	4336	36	0	\N
254094	1944	200000000	8626	4336	37	0	\N
254095	1874	201392000	8626	4336	38	0	\N
254096	1874	201393000	8626	4336	39	0	\N
254097	1874	201394000	8626	4336	40	0	\N
254098	1874	201395000	8626	4336	41	0	\N
254099	1874	201396000	8626	4336	42	0	\N
254100	1874	201397000	8626	4336	43	0	\N
254101	1874	201398000	8626	4336	44	0	\N
254102	1874	201399000	8626	4336	45	0	\N
254103	1874	201400000	8626	4336	46	0	\N
254104	1874	201401000	8626	4336	47	0	\N
254105	1874	201402000	8626	4336	48	0	\N
254106	1874	201403000	8626	4336	49	0	\N
254107	1874	201404000	8626	4336	50	0	\N
254108	640	66000010000000	8626	4336	51	0	\N
254109	1874	201405000	8626	4336	52	0	\N
254110	1874	201406000	8626	4336	53	0	\N
254111	1874	201407000	8626	4336	54	0	\N
254112	1874	201408000	8626	4336	55	0	\N
254113	1874	201409000	8626	4336	56	0	\N
254114	1945	200000000	8626	4336	57	0	\N
254115	1874	201410000	8626	4336	58	0	\N
254116	1874	201411000	8626	4336	59	0	\N
254117	1874	201412000	8626	4336	60	0	\N
254118	1874	201413000	8626	4336	61	0	\N
254119	1874	201414000	8626	4336	62	0	\N
254120	1874	201415000	8626	4336	63	0	\N
254121	1874	201416000	8626	4336	64	0	\N
254122	1874	201417000	8626	4336	65	0	\N
254123	1874	201418000	8626	4336	66	0	\N
254124	1874	201419000	8626	4336	67	0	\N
254125	1874	201420000	8626	4336	68	0	\N
254126	1874	201421000	8626	4336	69	0	\N
254127	1874	201422000	8626	4336	70	0	\N
254128	1874	201423000	8626	4336	71	0	\N
254129	1874	201424000	8626	4336	72	0	\N
254130	1874	201425000	8626	4336	73	0	\N
254131	1874	201426000	8626	4336	74	0	\N
254132	1874	201427000	8626	4336	75	0	\N
254133	1874	201428000	8626	4336	76	0	\N
254134	1874	201429000	8626	4336	77	0	\N
254135	1874	201430000	8626	4336	78	0	\N
254136	1874	201431000	8626	4336	79	0	\N
254137	1874	201432000	8626	4336	80	0	\N
254138	1874	201433000	8626	4336	81	0	\N
254139	1874	201434000	8626	4336	82	0	\N
254140	1874	201435000	8626	4336	83	0	\N
254141	1874	201436000	8626	4336	84	0	\N
254142	1874	201437000	8626	4336	85	0	\N
254143	1874	201438000	8626	4336	86	0	\N
254144	1874	201439000	8626	4336	87	0	\N
254145	1874	201440000	8626	4336	88	0	\N
254146	1874	201441000	8626	4336	89	0	\N
254147	1874	201442000	8626	4336	90	0	\N
254148	1874	201443000	8626	4336	91	0	\N
254149	1874	201444000	8626	4336	92	0	\N
254150	1874	201445000	8626	4336	93	0	\N
254151	1874	201446000	8626	4336	94	0	\N
254152	1874	201447000	8626	4336	95	0	\N
254153	1874	201448000	8626	4336	96	0	\N
254154	1874	201449000	8626	4336	97	0	\N
254155	1874	201450000	8626	4336	98	0	\N
254156	1874	201451000	8626	4336	99	0	\N
254157	1874	201452000	8626	4336	100	0	\N
254158	1874	201453000	8626	4336	101	0	\N
254159	1874	201454000	8626	4336	102	0	\N
254160	1874	201455000	8626	4336	103	0	\N
254161	1874	201456000	8626	4336	104	0	\N
254162	1874	201457000	8626	4336	105	0	\N
254163	1874	201458000	8626	4336	106	0	\N
254164	1874	201459000	8626	4336	107	0	\N
254165	1874	201460000	8626	4336	108	0	\N
254166	1874	201461000	8626	4336	109	0	\N
254167	1874	201462000	8626	4336	110	0	\N
254168	1874	201463000	8626	4336	111	0	\N
254169	1874	201464000	8626	4336	112	0	\N
254170	1874	201465000	8626	4336	113	0	\N
254171	1874	201466000	8626	4336	114	0	\N
254172	1874	201467000	8626	4336	115	0	\N
254173	1874	201468000	8626	4336	116	0	\N
254174	1874	201469000	8626	4336	117	0	\N
254175	1874	201470000	8626	4336	118	0	\N
254176	1874	201471000	8626	4336	119	0	\N
254177	1874	201472000	8626	4336	120	0	\N
254178	1874	201473000	8626	4336	121	0	\N
254179	1874	201474000	8626	4336	122	0	\N
254180	1874	201475000	8626	4336	123	0	\N
254181	1874	201517000	8627	4472	0	0	\N
254182	1874	201518000	8627	4472	1	0	\N
254053	1874	201514000	8621	4469	0	0	0
254056	1874	201515000	8625	4471	0	0	0
254057	1874	201516000	8625	4471	1	0	0
254183	1874	201517000	8628	4472	0	0	0
254184	1874	201518000	8628	4472	1	0	0
254185	1874	201517000	8629	4472	0	0	\N
254186	1874	201518000	8629	4472	1	0	\N
254189	1874	201519000	8631	4473	0	0	\N
254190	1874	201520000	8631	4473	1	0	\N
254191	1483	0	8632	4355	0	0	\N
254192	1874	201385000	8632	4355	1	0	\N
254193	1874	201386000	8632	4355	2	0	\N
254194	695	66720000000000	8632	4355	3	0	\N
254195	1874	201387000	8632	4355	4	0	\N
254196	1874	201388000	8632	4355	5	0	\N
254197	1874	201389000	8632	4355	6	0	\N
254198	1942	200000000	8632	4355	7	0	\N
254199	1874	201390000	8632	4355	8	0	\N
254200	1874	201391000	8632	4355	9	0	\N
254201	1944	200000000	8632	4355	10	0	\N
254202	1874	201392000	8632	4355	11	0	\N
254203	1874	201393000	8632	4355	12	0	\N
254204	1874	201394000	8632	4355	13	0	\N
254205	1874	201395000	8632	4355	14	0	\N
254206	1874	201396000	8632	4355	15	0	\N
254207	1874	201397000	8632	4355	16	0	\N
254208	1874	201398000	8632	4355	17	0	\N
254209	1874	201399000	8632	4355	18	0	\N
254210	1874	201400000	8632	4355	19	0	\N
254211	1874	201401000	8632	4355	20	0	\N
254212	1874	201402000	8632	4355	21	0	\N
254213	1874	201403000	8632	4355	22	0	\N
254214	1874	201404000	8632	4355	23	0	\N
254215	640	66000010000000	8632	4355	24	0	\N
254216	1874	201405000	8632	4355	25	0	\N
254217	1874	201406000	8632	4355	26	0	\N
254218	1874	201407000	8632	4355	27	0	\N
254219	1874	201408000	8632	4355	28	0	\N
254220	1874	201409000	8632	4355	29	0	\N
254221	1945	200000000	8632	4355	30	0	\N
254222	1874	201410000	8632	4355	31	0	\N
254223	1874	201411000	8632	4355	32	0	\N
254224	1874	201412000	8632	4355	33	0	\N
254225	1874	201413000	8632	4355	34	0	\N
254226	1874	201414000	8632	4355	35	0	\N
254227	1874	201415000	8632	4355	36	0	\N
254228	1874	201416000	8632	4355	37	0	\N
254229	1874	201417000	8632	4355	38	0	\N
254230	1874	201418000	8632	4355	39	0	\N
254231	1874	201419000	8632	4355	40	0	\N
254232	1874	201420000	8632	4355	41	0	\N
254233	1874	201421000	8632	4355	42	0	\N
254234	1874	201422000	8632	4355	43	0	\N
254235	1874	201423000	8632	4355	44	0	\N
254236	1874	201424000	8632	4355	45	0	\N
254237	1874	201425000	8632	4355	46	0	\N
254238	1874	201426000	8632	4355	47	0	\N
254239	1874	201427000	8632	4355	48	0	\N
254240	1874	201428000	8632	4355	49	0	\N
254241	1874	201429000	8632	4355	50	0	\N
254242	1874	201430000	8632	4355	51	0	\N
254243	1874	201431000	8632	4355	52	0	\N
254244	1874	201432000	8632	4355	53	0	\N
254245	1874	201433000	8632	4355	54	0	\N
254246	1874	201434000	8632	4355	55	0	\N
254247	1874	201435000	8632	4355	56	0	\N
254248	1874	201436000	8632	4355	57	0	\N
254249	1874	201437000	8632	4355	58	0	\N
254250	1874	201438000	8632	4355	59	0	\N
254251	1874	201439000	8632	4355	60	0	\N
254252	1874	201440000	8632	4355	61	0	\N
254253	1874	201441000	8632	4355	62	0	\N
254254	1874	201442000	8632	4355	63	0	\N
254255	1874	201443000	8632	4355	64	0	\N
254256	1874	201444000	8632	4355	65	0	\N
254257	1874	201445000	8632	4355	66	0	\N
254258	1874	201446000	8632	4355	68	0	\N
254259	1874	201447000	8632	4355	69	0	\N
254260	1874	201448000	8632	4355	70	0	\N
254261	1874	201449000	8632	4355	71	0	\N
254262	1874	201450000	8632	4355	72	0	\N
254263	1874	201451000	8632	4355	73	0	\N
254264	1874	201452000	8632	4355	74	0	\N
254265	1874	201453000	8632	4355	75	0	\N
254266	1874	201454000	8632	4355	76	0	\N
254267	1874	201455000	8632	4355	77	0	\N
254268	1874	201456000	8632	4355	78	0	\N
254269	1874	201457000	8632	4355	79	0	\N
254270	1874	201458000	8632	4355	80	0	\N
254271	1874	201459000	8632	4355	81	0	\N
254272	1874	201460000	8632	4355	82	0	\N
254273	1874	201461000	8632	4355	83	0	\N
254274	1874	201462000	8632	4355	84	0	\N
254275	1874	201463000	8632	4355	85	0	\N
254276	1874	201464000	8632	4355	86	0	\N
254277	1874	201465000	8632	4355	87	0	\N
254278	1874	201466000	8632	4355	88	0	\N
254279	1874	201467000	8632	4355	89	0	\N
254280	1874	201468000	8632	4355	90	0	\N
254281	1874	201469000	8632	4355	91	0	\N
254282	1874	201470000	8632	4355	92	0	\N
254283	1874	201471000	8632	4355	93	0	\N
254284	1874	201472000	8632	4355	94	0	\N
254287	1874	201522000	8637	4476	0	0	\N
254289	1874	201522000	8639	4476	0	0	\N
254291	1874	201523000	8641	4477	0	0	\N
254292	1874	201523000	8642	4477	0	0	\N
254293	1874	201523000	8643	4477	0	0	\N
254302	1874	201532000	8647	4480	0	0	\N
254303	1874	201533000	8647	4480	1	0	\N
254311	1874	201538000	8651	4482	0	0	\N
254312	1874	201538000	8652	4482	0	0	\N
254315	1516	16883489191100	8654	4483	0	0	\N
254316	1874	201539000	8654	4483	1	0	\N
254317	1874	201540000	8655	4484	0	0	\N
254318	1874	201540000	8656	4484	0	0	\N
254319	1874	201540000	8657	4484	0	0	\N
254285	1483	0	8636	4475	0	0	0
254286	1874	201521000	8636	4475	1	0	0
254288	1874	201522000	8638	4476	0	0	0
254290	1874	201523000	8640	4477	0	0	0
254294	1874	201524000	8644	4478	0	0	0
254296	1874	201526000	8646	4479	0	0	0
254297	1874	201527000	8646	4479	1	0	0
254298	1874	201528000	8646	4479	2	0	0
254299	1874	201529000	8646	4479	3	0	0
254300	1874	201530000	8646	4479	4	0	0
254304	1874	201532000	8648	4480	0	0	0
254305	1874	201533000	8648	4480	1	0	0
254306	1874	201534000	8649	4481	0	0	0
254307	1874	201535000	8649	4481	1	0	0
254309	1874	201537000	8649	4481	3	0	0
254310	1874	201538000	8650	4482	0	0	0
254313	1516	16883489191100	8653	4483	0	0	2
254314	1874	201539000	8653	4483	1	0	0
254320	1874	201540000	8659	4484	0	0	0
254321	1874	201540000	8660	4484	0	0	\N
254322	1874	201541000	8661	4485	0	0	\N
254323	1874	201541000	8662	4485	0	0	\N
254325	1874	201541000	8664	4485	0	0	\N
254340	1678	8640244816000	8680	4498	0	0	\N
254342	1483	0	8682	4450	0	0	\N
254343	1678	7920234814000	8682	4450	1	0	\N
254344	441	66000020000000	8682	4450	2	0	\N
254345	1874	201483000	8682	4450	3	0	\N
254346	1516	16883489191100	8682	4450	4	0	\N
254347	1874	201484000	8682	4450	5	0	\N
254348	1874	201485000	8682	4450	6	0	\N
254349	1874	201486000	8682	4450	7	0	\N
254350	1874	201487000	8682	4450	8	0	\N
254351	1874	201488000	8682	4450	9	0	\N
254352	1874	201489000	8682	4450	10	0	\N
254353	1874	201490000	8682	4450	11	0	\N
254354	1874	201491000	8682	4450	12	0	\N
254355	1678	7920234815000	8682	4450	13	0	\N
254356	1678	7920234816000	8682	4450	14	0	\N
254357	1678	7920234817000	8682	4450	15	0	\N
254358	1874	201492000	8682	4450	16	0	\N
254359	1874	201493000	8682	4450	17	0	\N
254360	1874	201494000	8682	4450	18	0	\N
254361	1874	201495000	8682	4450	19	0	\N
254362	1874	201496000	8682	4450	20	0	\N
254363	1874	201497000	8682	4450	21	0	\N
254364	1874	201498000	8682	4450	22	0	\N
254365	1874	201499000	8682	4450	23	0	\N
254366	1874	201500000	8682	4450	24	0	\N
254367	1874	201501000	8682	4450	25	0	\N
254368	1874	201502000	8682	4450	26	0	\N
254369	1874	201503000	8682	4450	27	0	\N
254370	1874	201504000	8682	4450	28	0	\N
254371	1874	201505000	8682	4450	29	0	\N
254372	1874	201506000	8682	4450	30	0	\N
254373	1874	201507000	8682	4450	31	0	\N
254374	1874	201508000	8682	4450	32	0	\N
254375	1874	201509000	8682	4450	33	0	\N
254376	1874	201510000	8682	4450	34	0	\N
254377	1874	201511000	8682	4450	35	0	\N
254378	1874	201512000	8682	4450	36	0	\N
254379	1874	201513000	8682	4450	37	0	\N
254380	1874	201514000	8682	4450	38	0	\N
254381	1874	201515000	8682	4450	39	0	\N
254382	1874	201516000	8682	4450	40	0	\N
254383	1874	201517000	8682	4450	41	0	\N
254384	1874	201518000	8682	4450	43	0	\N
254385	1874	201519000	8682	4450	44	0	\N
254386	1874	201520000	8682	4450	45	0	\N
254387	1874	201521000	8682	4450	46	0	\N
254388	1874	201522000	8682	4450	47	0	\N
254389	1874	201523000	8682	4450	48	0	\N
254390	1874	201524000	8682	4450	49	0	\N
254391	1874	201525000	8682	4450	50	0	\N
254392	1874	201526000	8682	4450	51	0	\N
254393	1874	201527000	8682	4450	52	0	\N
254394	1874	201528000	8682	4450	53	0	\N
254395	1874	201529000	8682	4450	54	0	\N
254396	1874	201530000	8682	4450	55	0	\N
254397	1874	201531000	8682	4450	56	0	\N
254398	1874	201532000	8682	4450	57	0	\N
254399	1874	201533000	8682	4450	58	0	\N
254400	1874	201534000	8682	4450	59	0	\N
254401	1874	201535000	8682	4450	60	0	\N
254402	1874	201536000	8682	4450	61	0	\N
254403	1874	201537000	8682	4450	62	0	\N
254404	1874	201538000	8682	4450	63	0	\N
254405	1874	201539000	8682	4450	64	0	\N
254406	1874	201540000	8682	4450	65	0	\N
254407	1874	201541000	8682	4450	66	0	\N
254408	1874	201542000	8682	4450	67	0	\N
254409	1874	201543000	8682	4450	68	0	\N
254410	1874	201544000	8682	4450	69	0	\N
254411	1874	201545000	8682	4450	70	0	\N
254412	1874	201546000	8682	4450	71	0	\N
254413	1874	201547000	8682	4450	72	0	\N
254414	1874	201548000	8682	4450	73	0	\N
254415	1874	201549000	8682	4450	74	0	\N
254416	1874	201550000	8682	4450	75	0	\N
254417	1874	201551000	8682	4450	76	0	\N
254418	1946	0	8682	4450	77	0	\N
254419	1904	1000000000	8682	4450	78	0	\N
254420	1904	2000000000	8682	4450	79	0	\N
254421	1908	1000000000	8682	4450	80	0	\N
254422	1909	1000000000	8682	4450	81	0	\N
254423	1910	1000000000	8682	4450	82	0	\N
254424	1911	1000000000	8682	4450	83	0	\N
254425	1912	1000000000	8682	4450	84	0	\N
254426	1913	1000000000	8682	4450	85	0	\N
254427	1917	1000000000	8682	4450	86	0	\N
254428	1946	1000000000	8682	4450	87	0	\N
254433	1678	8640244820000	8687	4502	0	0	\N
254434	1483	0	8687	4502	1	0	\N
254435	1483	0	8688	4421	0	0	\N
254436	1678	7920234814000	8688	4421	1	0	\N
254437	441	66000020000000	8688	4421	2	0	\N
254438	1516	16883489191100	8688	4421	3	0	\N
254439	1678	7920234815000	8688	4421	4	0	\N
254440	1678	7920234816000	8688	4421	5	0	\N
254441	1678	7920234817000	8688	4421	6	0	\N
254442	1678	7920234818000	8688	4421	7	0	\N
254443	1678	7920234819000	8688	4421	8	0	\N
254444	1678	7920234820000	8688	4421	9	0	\N
254445	1678	7920234821000	8688	4421	10	0	\N
254446	1946	0	8688	4421	11	0	\N
254447	1904	1000000000	8688	4421	12	0	\N
254451	1678	8640244824000	8692	4506	0	0	\N
254452	1678	8640244825000	8692	4506	1	0	\N
254456	1678	8640244827000	8695	4508	0	0	\N
254327	1874	201543000	8665	4486	1	0	0
254328	1874	201544000	8666	4487	0	0	0
254329	1874	201545000	8667	4488	0	0	0
254330	1874	201546000	8667	4488	1	0	0
254331	1874	201547000	8667	4488	2	0	0
254333	1874	201548000	8668	4489	0	0	0
254334	1874	201549000	8668	4489	1	0	0
254335	1874	201550000	8669	4490	0	0	0
254336	1874	201551000	8671	4491	0	0	0
254337	1678	8640244814000	8678	4497	0	0	0
254339	1678	8640244816000	8679	4498	0	0	0
254341	1678	8640244817000	8681	4499	0	0	0
254429	1678	8640244818000	8683	4500	0	0	0
254430	1678	8640244819000	8684	4501	0	0	0
254432	1483	0	8686	4502	1	0	0
254448	1678	8640244821000	8689	4503	0	0	0
254449	1678	8640244822000	8690	4504	0	0	0
254450	1678	8640244823000	8691	4505	0	0	0
254453	1678	8640244824000	8693	4506	0	0	0
254455	1678	8640244826000	8694	4507	0	0	0
254458	1678	8640244827000	8697	4508	0	0	\N
254460	1678	8640244829000	8699	4510	0	0	\N
254461	1678	8640244829000	8700	4510	0	0	\N
254467	1678	8640244830000	8703	4511	0	0	\N
254468	1678	8640244831000	8703	4511	1	0	\N
254469	1678	8640244832000	8703	4511	2	0	\N
254470	1678	8640244833000	8703	4511	3	0	\N
254482	1678	8640244845000	8710	4518	0	0	\N
254483	1678	8640244846000	8710	4518	1	0	\N
254484	1678	8640244847000	8710	4518	2	0	\N
254485	1678	8640244848000	8710	4518	3	0	\N
254486	1678	8640244849000	8710	4518	4	0	\N
254487	1874	201552000	8710	4518	5	0	\N
254488	1947	200000000	8710	4518	6	0	\N
254489	1874	201553000	8710	4518	7	0	\N
254500	1483	0	8713	4374	0	0	\N
254501	210	66000000000000	8713	4374	1	0	\N
254502	1483	0	8713	4374	2	0	\N
254503	1678	7200224814000	8713	4374	3	0	\N
254504	695	66720000000000	8713	4374	4	0	\N
254505	441	66000020000000	8713	4374	5	0	\N
254506	1516	16883489191100	8713	4374	6	0	\N
254507	1678	7200224815000	8713	4374	7	0	\N
254508	1678	7200224816000	8713	4374	8	0	\N
254509	1678	7200224817000	8713	4374	9	0	\N
254510	1678	7200224818000	8713	4374	10	0	\N
254511	1678	7200224819000	8713	4374	11	0	\N
254512	1678	7200224820000	8713	4374	12	0	\N
254513	1678	7200224821000	8713	4374	13	0	\N
254514	1678	7200224822000	8713	4374	14	0	\N
254515	1874	201391000	8713	4374	15	0	\N
254516	1944	200000000	8713	4374	16	0	\N
254517	1874	201392000	8713	4374	17	0	\N
254518	1874	201393000	8713	4374	18	0	\N
254519	1874	201394000	8713	4374	19	0	\N
254520	1874	201395000	8713	4374	20	0	\N
254521	1874	201396000	8713	4374	21	0	\N
254522	1874	201397000	8713	4374	22	0	\N
254523	1874	201398000	8713	4374	23	0	\N
254524	1874	201399000	8713	4374	24	0	\N
254525	1874	201400000	8713	4374	25	0	\N
254526	1874	201401000	8713	4374	26	0	\N
254527	1874	201402000	8713	4374	27	0	\N
254528	1874	201403000	8713	4374	28	0	\N
254529	1874	201404000	8713	4374	29	0	\N
254530	640	66000010000000	8713	4374	30	0	\N
254531	1874	201405000	8713	4374	31	0	\N
254532	1874	201406000	8713	4374	32	0	\N
254533	1874	201407000	8713	4374	33	0	\N
254534	1874	201408000	8713	4374	34	0	\N
254535	1874	201409000	8713	4374	35	0	\N
254536	1945	200000000	8713	4374	37	0	\N
254537	1874	201410000	8713	4374	38	0	\N
254538	1874	201411000	8713	4374	39	0	\N
254539	1874	201412000	8713	4374	40	0	\N
254540	1874	201413000	8713	4374	41	0	\N
254541	1874	201414000	8713	4374	42	0	\N
254542	1874	201415000	8713	4374	43	0	\N
254543	1874	201416000	8713	4374	44	0	\N
254544	1874	201417000	8713	4374	45	0	\N
254545	1874	201418000	8713	4374	46	0	\N
254546	1874	201419000	8713	4374	47	0	\N
254547	1874	201420000	8713	4374	48	0	\N
254548	1874	201421000	8713	4374	49	0	\N
254549	1874	201422000	8713	4374	50	0	\N
254550	1874	201423000	8713	4374	51	0	\N
254551	1874	201424000	8713	4374	52	0	\N
254552	1874	201425000	8713	4374	53	0	\N
254553	1874	201426000	8713	4374	54	0	\N
254554	1874	201427000	8713	4374	55	0	\N
254555	1874	201428000	8713	4374	56	0	\N
254556	1874	201429000	8713	4374	57	0	\N
254557	1874	201430000	8713	4374	58	0	\N
254558	1874	201431000	8713	4374	59	0	\N
254559	1874	201432000	8713	4374	60	0	\N
254560	1874	201433000	8713	4374	61	0	\N
254561	1874	201434000	8713	4374	62	0	\N
254562	1874	201435000	8713	4374	63	0	\N
254563	1874	201436000	8713	4374	64	0	\N
254564	1874	201437000	8713	4374	65	0	\N
254565	1874	201438000	8713	4374	66	0	\N
254566	1874	201439000	8713	4374	67	0	\N
254567	1874	201440000	8713	4374	68	0	\N
254568	1874	201441000	8713	4374	69	0	\N
254569	1874	201442000	8713	4374	70	0	\N
254570	1874	201443000	8713	4374	71	0	\N
254571	1874	201444000	8713	4374	72	0	\N
254572	1874	201445000	8713	4374	73	0	\N
254573	1874	201446000	8713	4374	74	0	\N
254574	1874	201447000	8713	4374	75	0	\N
254575	1874	201448000	8713	4374	76	0	\N
254576	1874	201449000	8713	4374	77	0	\N
254577	1874	201450000	8713	4374	78	0	\N
254578	1874	201451000	8713	4374	79	0	\N
254579	1874	201452000	8713	4374	80	0	\N
254580	1874	201453000	8713	4374	81	0	\N
254581	1874	201454000	8713	4374	82	0	\N
254582	1874	201455000	8713	4374	83	0	\N
254583	1874	201456000	8713	4374	84	0	\N
254584	1874	201457000	8713	4374	85	0	\N
254585	1874	201458000	8713	4374	86	0	\N
254586	1874	201459000	8713	4374	87	0	\N
254587	1874	201460000	8713	4374	88	0	\N
254588	1874	201461000	8713	4374	89	0	\N
254589	1874	201462000	8713	4374	90	0	\N
254590	1874	201463000	8713	4374	91	0	\N
254591	1874	201464000	8713	4374	92	0	\N
254592	1874	201465000	8713	4374	93	0	\N
254462	1678	8640244829000	8701	4510	0	0	0
254463	1678	8640244830000	8702	4511	0	0	0
254464	1678	8640244831000	8702	4511	1	0	0
254465	1678	8640244832000	8702	4511	2	0	0
254466	1678	8640244833000	8702	4511	3	0	0
254472	1678	8640244835000	8704	4512	1	0	0
254473	1678	8640244836000	8705	4513	0	0	0
254474	1678	8640244837000	8706	4514	0	0	0
254475	1678	8640244838000	8706	4514	1	0	0
254476	1678	8640244839000	8706	4514	2	0	0
254478	1678	8640244841000	8707	4515	0	0	0
254479	1678	8640244842000	8707	4515	1	0	0
254480	1678	8640244843000	8708	4516	0	0	0
254481	1678	8640244844000	8709	4517	0	0	0
254491	1678	8640244846000	8711	4518	1	0	0
254492	1678	8640244847000	8711	4518	2	0	0
254493	1678	8640244848000	8711	4518	3	0	0
254494	1678	8640244849000	8711	4518	4	0	0
254495	1874	201552000	8711	4518	5	0	0
254497	1874	201553000	8711	4518	7	0	0
254498	1678	8640244850000	8712	4519	0	0	0
254499	1874	201554000	8712	4519	1	0	0
254593	1874	201466000	8713	4374	94	0	\N
254594	1874	201467000	8713	4374	95	0	\N
254595	1874	201468000	8713	4374	96	0	\N
254596	1874	201469000	8713	4374	97	0	\N
254597	1874	201470000	8713	4374	98	0	\N
254598	1874	201471000	8713	4374	99	0	\N
254599	1874	201472000	8713	4374	100	0	\N
254600	1874	201473000	8713	4374	101	0	\N
254601	1874	201474000	8713	4374	102	0	\N
254602	1874	201475000	8713	4374	103	0	\N
254603	1874	201476000	8713	4374	104	0	\N
254604	1874	201477000	8713	4374	105	0	\N
254605	1874	201478000	8713	4374	106	0	\N
254606	1874	201479000	8713	4374	107	0	\N
254607	1874	201480000	8713	4374	108	0	\N
254608	1874	201481000	8713	4374	109	0	\N
254609	1874	201482000	8713	4374	110	0	\N
254610	1874	201483000	8713	4374	111	0	\N
254611	1874	201484000	8713	4374	112	0	\N
254612	1874	201485000	8713	4374	113	0	\N
254613	1874	201486000	8713	4374	114	0	\N
254614	1874	201487000	8713	4374	115	0	\N
254615	1874	201488000	8713	4374	116	0	\N
254616	1874	201489000	8713	4374	117	0	\N
254617	1874	201490000	8713	4374	118	0	\N
254618	1678	8640244850000	8714	4519	0	0	\N
254619	1874	201554000	8714	4519	1	0	\N
254620	1874	201555000	8715	4520	0	0	\N
254621	1678	8640244851000	8715	4520	1	0	\N
254624	1874	201556000	8718	4521	0	0	\N
254625	1874	201557000	8718	4521	1	0	\N
254626	1678	8640244852000	8718	4521	2	0	\N
254627	1678	8640244853000	8718	4521	3	0	\N
254634	1874	201559000	8721	4523	0	0	\N
254635	1874	201560000	8721	4523	1	0	\N
254636	1678	8640244855000	8721	4523	2	0	\N
254637	1678	8640244856000	8721	4523	3	0	\N
254638	1874	201559000	8722	4523	0	0	\N
254639	1874	201560000	8722	4523	1	0	\N
254640	1678	8640244855000	8722	4523	2	0	\N
254641	1678	8640244856000	8722	4523	3	0	\N
254657	1678	8640244862000	8728	4527	0	0	\N
254658	1678	8640244862000	8729	4527	0	0	\N
254661	1678	8640244863000	8731	4528	0	0	\N
254662	1874	201567000	8731	4528	1	0	\N
254665	1874	201568000	8733	4529	0	0	\N
254666	1678	8640244864000	8733	4529	1	0	\N
254691	1678	8640244875000	8742	4536	0	0	\N
254692	1874	201579000	8742	4536	1	0	\N
254693	1678	8640244876000	8743	4537	0	0	\N
254694	1874	201580000	8743	4537	1	0	\N
254697	1678	8640244876000	8745	4537	0	0	\N
254698	1874	201580000	8745	4537	1	0	\N
254707	1874	201584000	8750	4541	0	0	\N
254708	1678	8640244880000	8750	4541	1	0	\N
254709	1678	8640244881000	8751	4542	0	0	\N
254710	1678	8640244881000	8752	4542	0	0	\N
254711	1874	201585000	8752	4542	1	0	\N
254712	1678	8640244881000	8753	4542	0	0	\N
254713	1874	201585000	8753	4542	1	0	\N
254720	1874	201588000	8757	4545	0	0	\N
254721	1678	8640244884000	8757	4545	1	0	\N
254722	1874	201588000	8758	4545	0	0	\N
254723	1678	8640244884000	8758	4545	1	0	\N
254724	1874	201588000	8759	4545	0	0	\N
254725	1678	8640244884000	8759	4545	1	0	\N
254628	1874	201556000	8719	4521	0	0	0
254629	1874	201557000	8719	4521	1	0	0
254630	1678	8640244852000	8719	4521	2	0	0
254631	1678	8640244853000	8719	4521	3	0	0
254632	1874	201558000	8720	4522	0	0	0
254642	1874	201559000	8723	4523	0	0	0
254643	1874	201560000	8723	4523	1	0	0
254644	1678	8640244855000	8723	4523	2	0	0
254645	1678	8640244856000	8723	4523	3	0	0
254646	208	66000010000000	8724	4524	0	0	0
254648	1874	201562000	8724	4524	2	0	0
254649	1874	201563000	8724	4524	3	0	0
254650	1678	8640244857000	8724	4524	4	0	0
254651	1678	8640244858000	8724	4524	5	0	0
254653	1678	8640244860000	8726	4525	0	0	0
254654	1874	201564000	8726	4525	1	0	0
254655	1874	201565000	8727	4526	0	0	0
254656	1678	8640244861000	8727	4526	1	0	0
254659	1678	8640244862000	8730	4527	0	0	0
254663	1678	8640244863000	8732	4528	0	0	0
254664	1874	201567000	8732	4528	1	0	0
254667	1874	201568000	8734	4529	0	0	0
254668	1678	8640244864000	8734	4529	1	0	0
254669	1874	201569000	8735	4530	0	0	0
254671	1874	201570000	8735	4530	2	0	0
254672	1874	201571000	8735	4530	3	0	0
254673	1678	8640244866000	8735	4530	4	0	0
254674	1678	8640244867000	8735	4530	5	0	0
254676	1678	8640244868000	8736	4531	1	0	0
254677	1874	201573000	8737	4532	0	0	0
254678	1678	8640244869000	8737	4532	1	0	0
254679	1678	8640244870000	8738	4533	0	0	0
254680	1678	8640244871000	8738	4533	1	0	0
254682	1874	201575000	8738	4533	3	0	0
254683	1874	201576000	8739	4534	0	0	0
254684	1874	201577000	8739	4534	1	0	0
254685	1678	8640244872000	8739	4534	2	0	0
254686	1678	8640244873000	8739	4534	3	0	0
254688	1874	201578000	8740	4535	1	0	0
254689	1678	8640244875000	8741	4536	0	0	0
254690	1874	201579000	8741	4536	1	0	0
254695	1678	8640244876000	8744	4537	0	0	0
254699	1678	8640244877000	8746	4538	0	0	0
254700	1874	201581000	8746	4538	1	0	0
254701	1874	201582000	8747	4539	0	0	0
254702	1678	8640244878000	8747	4539	1	0	0
254703	1874	201583000	8748	4540	0	0	0
254705	1874	201584000	8749	4541	0	0	0
254706	1678	8640244880000	8749	4541	1	0	0
254714	1678	8640244881000	8754	4542	0	0	0
254715	1874	201585000	8754	4542	1	0	0
254716	1874	201586000	8755	4543	0	0	0
254718	1678	8640244883000	8756	4544	0	0	0
254719	1874	201587000	8756	4544	1	0	0
254726	1874	201588000	8760	4545	0	0	0
254727	1678	8640244884000	8760	4545	1	0	0
254730	1678	8640244886000	8762	4547	0	0	\N
254731	1874	201590000	8762	4547	1	0	\N
254732	1678	8640244886000	8763	4547	0	0	\N
254733	1874	201590000	8763	4547	1	0	\N
254736	1678	8640244886000	8765	4547	0	0	\N
254737	1874	201590000	8765	4547	1	0	\N
254738	1678	8640244886000	8766	4547	0	0	\N
254739	1874	201590000	8766	4547	1	0	\N
254740	1678	8640244886000	8767	4547	0	0	\N
254741	1874	201590000	8767	4547	1	0	\N
254742	1678	8640244886000	8768	4547	0	0	\N
254743	1874	201590000	8768	4547	1	0	\N
254746	1678	8640244887000	8770	4548	0	0	\N
254747	1874	201591000	8770	4548	1	0	\N
254750	1678	8640244889000	8772	4550	0	0	\N
254751	1678	8640244890000	8772	4550	1	0	\N
254752	1678	8640244891000	8772	4550	2	0	\N
254753	1874	201593000	8772	4550	3	0	\N
254754	1874	201594000	8772	4550	4	0	\N
254755	1874	201595000	8772	4550	5	0	\N
254764	1874	201596000	8775	4551	0	0	\N
254765	1678	8640244892000	8775	4551	1	0	\N
254770	1678	8640244894000	8778	4553	0	0	\N
254771	1874	201598000	8778	4553	1	0	\N
254778	1874	201600000	8781	4555	0	0	\N
254779	1948	200000000	8781	4555	1	0	\N
254780	1678	8640244896000	8781	4555	2	0	\N
254781	1949	200000000	8781	4555	3	0	\N
254782	1874	201600000	8782	4555	0	0	\N
254783	1948	200000000	8782	4555	1	0	\N
254784	1678	8640244896000	8782	4555	2	0	\N
254785	1949	200000000	8782	4555	3	0	\N
254786	1874	201600000	8783	4555	0	0	\N
254787	1948	200000000	8783	4555	1	0	\N
254788	1678	8640244896000	8783	4555	2	0	\N
254789	1949	200000000	8783	4555	3	0	\N
254792	1678	8640244897000	8785	4556	0	0	\N
254793	1874	201601000	8785	4556	1	0	\N
254794	1678	8640244897000	8786	4556	0	0	\N
254795	1874	201601000	8786	4556	1	0	\N
254796	1678	8640244897000	8787	4556	0	0	\N
254797	1874	201601000	8787	4556	1	0	\N
254804	1678	8640244899000	8792	4558	0	0	\N
254805	1678	8640244900000	8792	4558	1	0	\N
254806	1874	201603000	8792	4558	2	0	\N
254807	1874	201604000	8792	4558	3	0	\N
254808	1678	8640244899000	8793	4558	0	0	\N
254809	1678	8640244900000	8793	4558	1	0	\N
254810	1874	201603000	8793	4558	2	0	\N
254811	1874	201604000	8793	4558	3	0	\N
254812	1678	8640244899000	8794	4558	0	0	\N
254813	1678	8640244900000	8794	4558	1	0	\N
254814	1874	201603000	8794	4558	2	0	\N
254815	1874	201604000	8794	4558	3	0	\N
254822	1678	8640244904000	8797	4561	0	0	\N
254823	1874	201608000	8797	4561	1	0	\N
254826	1874	201609000	8799	4562	0	0	\N
254827	1678	8640244905000	8799	4562	1	0	\N
254832	1874	201611000	8802	4564	0	0	\N
254833	1678	8640244907000	8802	4564	1	0	\N
254842	1874	201615000	8807	4567	0	0	\N
254843	1678	8640244911000	8807	4567	1	0	\N
254847	1678	8640244911000	8809	4567	0	0	\N
254848	1678	8640244912000	8810	4568	0	0	\N
254849	1874	201615000	8810	4568	1	0	\N
254850	1874	201616000	8810	4568	2	0	\N
254852	1678	8640244913000	8812	4569	0	0	\N
254853	1874	201617000	8812	4569	1	0	\N
254856	1950	100000000000	8814	4548	0	0	\N
254857	1678	8640244887000	8814	4548	1	0	\N
254858	1874	201591000	8814	4548	2	0	\N
254859	1874	201592000	8814	4548	3	0	\N
254735	1874	201590000	8764	4547	1	0	0
254744	1678	8640244887000	8769	4548	0	0	0
254745	1874	201591000	8769	4548	1	0	0
254748	1678	8640244888000	8771	4549	0	0	0
254749	1874	201592000	8771	4549	1	0	0
254757	1678	8640244890000	8773	4550	1	0	0
254758	1678	8640244891000	8773	4550	2	0	0
254759	1874	201593000	8773	4550	3	0	0
254760	1874	201594000	8773	4550	4	0	0
254761	1874	201595000	8773	4550	5	0	0
254763	1678	8640244892000	8774	4551	1	0	0
254766	1874	201597000	8776	4552	0	0	0
254767	1678	8640244893000	8776	4552	1	0	0
254768	1678	8640244894000	8777	4553	0	0	0
254772	1874	201599000	8779	4554	0	0	0
254773	1678	8640244895000	8779	4554	1	0	0
254774	1874	201600000	8780	4555	0	0	0
254775	1948	200000000	8780	4555	1	0	0
254776	1678	8640244896000	8780	4555	2	0	0
254790	1678	8640244897000	8784	4556	0	0	0
254791	1874	201601000	8784	4556	1	0	0
254798	1874	201602000	8788	4557	0	0	0
254799	1678	8640244898000	8788	4557	1	0	0
254800	1678	8640244899000	8791	4558	0	0	0
254802	1874	201603000	8791	4558	2	0	0
254803	1874	201604000	8791	4558	3	0	0
254816	1874	201605000	8795	4559	0	0	0
254817	1874	201606000	8795	4559	1	0	0
254819	1678	8640244902000	8795	4559	3	0	0
254820	1874	201607000	8796	4560	0	0	0
254821	1678	8640244903000	8796	4560	1	0	0
254824	1678	8640244904000	8798	4561	0	0	0
254825	1874	201608000	8798	4561	1	0	0
254829	1874	201609000	8801	4563	0	0	0
254830	1874	201610000	8801	4563	1	0	0
254831	1678	8640244906000	8801	4563	2	0	0
254834	1874	201611000	8803	4564	0	0	0
254835	1678	8640244907000	8803	4564	1	0	0
254837	1678	8640244908000	8805	4565	1	0	0
254838	1678	8640244909000	8805	4565	2	0	0
254839	1874	201613000	8805	4565	3	0	0
254840	1678	8640244910000	8806	4566	0	0	0
254844	1874	201615000	8808	4567	0	0	0
254845	1678	8640244911000	8808	4567	1	0	0
254846	1874	201616000	8808	4567	2	0	0
254851	1678	8640244912000	8811	4568	0	0	0
254854	1678	8640244913000	8813	4569	0	0	0
254860	1874	201618000	8815	4570	0	0	0
254861	1950	100000000000	8815	4570	1	0	0
254862	1678	8640244914000	8815	4570	2	0	0
254863	1678	8640244915000	8817	4571	0	0	0
254864	1949	1400000000	8817	4571	1	0	0
254866	1678	8640244916000	8818	4572	0	0	\N
254867	1949	2600000000	8818	4572	1	0	\N
254868	1874	201620000	8818	4572	2	0	\N
254872	1678	8640244916000	8820	4572	0	0	\N
254873	1949	2600000000	8820	4572	1	0	\N
254874	1874	201620000	8820	4572	2	0	\N
254883	1678	8640244920000	8824	4575	0	0	\N
254884	1874	201624000	8824	4575	1	0	\N
254888	1678	8640244922000	8826	4577	0	0	\N
254889	1874	201626000	8826	4577	1	0	\N
254890	1874	201627000	8826	4577	2	0	\N
254891	1678	8640244923000	8826	4577	3	0	\N
254892	1874	201628000	8826	4577	4	0	\N
254893	1678	8640244924000	8826	4577	5	0	\N
254894	1678	8640244922000	8827	4577	0	0	\N
254895	1874	201626000	8827	4577	1	0	\N
254896	1874	201627000	8827	4577	2	0	\N
254897	1678	8640244923000	8827	4577	3	0	\N
254898	1874	201628000	8827	4577	4	0	\N
254899	1678	8640244924000	8827	4577	5	0	\N
254900	1678	8640244922000	8828	4577	0	0	\N
254901	1874	201626000	8828	4577	1	0	\N
254902	1874	201627000	8828	4577	2	0	\N
254903	1678	8640244923000	8828	4577	3	0	\N
254904	1874	201628000	8828	4577	4	0	\N
254905	1678	8640244924000	8828	4577	5	0	\N
254912	1678	8640244922000	8830	4577	0	0	\N
254913	1874	201626000	8830	4577	1	0	\N
254914	1874	201627000	8830	4577	2	0	\N
254915	1678	8640244923000	8830	4577	3	0	\N
254916	1874	201628000	8830	4577	4	0	\N
254917	1678	8640244924000	8830	4577	5	0	\N
254929	1678	8640244928000	8834	4580	0	0	\N
254930	1874	201632000	8834	4580	1	0	\N
254934	1396	20000000	8836	4581	0	0	\N
254935	1874	201633000	8836	4581	1	0	\N
254936	1678	8640244929000	8836	4581	2	0	\N
254937	1874	201634000	8837	4582	0	0	\N
254938	1874	201635000	8837	4582	1	0	\N
254939	1678	8640244930000	8837	4582	2	0	\N
254940	1678	8640244931000	8837	4582	3	0	\N
254941	1874	201634000	8838	4582	0	0	\N
254942	1874	201635000	8838	4582	1	0	\N
254943	1678	8640244930000	8838	4582	2	0	\N
254944	1678	8640244931000	8838	4582	3	0	\N
254949	1874	201634000	8840	4582	0	0	\N
254950	1874	201635000	8840	4582	1	0	\N
254951	1678	8640244930000	8840	4582	2	0	\N
254952	1678	8640244931000	8840	4582	3	0	\N
254953	1874	201636000	8841	4583	0	0	\N
254954	1874	201637000	8841	4583	1	0	\N
254955	1874	201638000	8841	4583	2	0	\N
254956	1678	8640244932000	8841	4583	3	0	\N
254957	1678	8640244933000	8841	4583	4	0	\N
254958	1678	8640244934000	8841	4583	5	0	\N
254965	1874	201636000	8843	4583	0	0	\N
254966	1874	201637000	8843	4583	1	0	\N
254967	1874	201638000	8843	4583	2	0	\N
254968	1678	8640244932000	8843	4583	3	0	\N
254969	1678	8640244933000	8843	4583	4	0	\N
254970	1678	8640244934000	8843	4583	5	0	\N
254971	1678	8640244935000	8844	4584	0	0	\N
254972	1874	201639000	8844	4584	1	0	\N
254973	1678	8640244935000	8845	4584	0	0	\N
254975	1678	8640244935000	8847	4584	0	0	\N
254976	1874	201639000	8847	4584	1	0	\N
254982	1678	8640244937000	8850	4586	0	0	\N
254983	1874	201641000	8850	4586	1	0	\N
254984	1874	201642000	8851	4587	0	0	\N
254985	1678	8640244938000	8851	4587	1	0	\N
254986	1874	201642000	8852	4587	0	0	\N
254987	1678	8640244938000	8852	4587	1	0	\N
254990	1874	201642000	8854	4587	0	0	\N
254991	1678	8640244938000	8854	4587	1	0	\N
254992	1874	201642000	8855	4587	0	0	\N
254993	1678	8640244938000	8855	4587	1	0	\N
254870	1949	2600000000	8819	4572	1	0	0
254871	1874	201620000	8819	4572	2	0	0
254875	1874	201621000	8821	4573	0	0	0
254876	1678	8640244917000	8821	4573	1	0	0
254877	1678	8640244918000	8822	4574	0	0	0
254879	1874	201623000	8822	4574	2	0	0
254880	1678	8640244919000	8822	4574	3	0	0
254881	1678	8640244920000	8823	4575	0	0	0
254882	1874	201624000	8823	4575	1	0	0
254885	806	1222212232776490	8825	4576	0	0	0
254887	1874	201625000	8825	4576	2	0	0
254906	1678	8640244922000	8829	4577	0	0	0
254907	1874	201626000	8829	4577	1	0	0
254908	1874	201627000	8829	4577	2	0	0
254910	1874	201628000	8829	4577	4	0	0
254911	1678	8640244924000	8829	4577	5	0	0
254918	1713	560000000	8831	4578	0	0	0
254919	1874	201629000	8831	4578	1	0	0
254920	1678	8640244925000	8831	4578	2	0	0
254922	1678	8640244926000	8832	4579	1	0	0
254923	1874	201630000	8832	4579	2	0	0
254924	1874	201631000	8832	4579	3	0	0
254925	1678	8640244927000	8832	4579	4	0	0
254926	806	1222212452776490	8832	4579	5	0	0
254928	1874	201632000	8833	4580	1	0	0
254931	1396	20000000	8835	4581	0	0	3
254932	1874	201633000	8835	4581	1	0	0
254933	1678	8640244929000	8835	4581	2	0	0
254946	1874	201635000	8839	4582	1	0	0
254947	1678	8640244930000	8839	4582	2	0	0
254948	1678	8640244931000	8839	4582	3	0	0
254959	1874	201636000	8842	4583	0	0	0
254960	1874	201637000	8842	4583	1	0	0
254962	1678	8640244932000	8842	4583	3	0	0
254963	1678	8640244933000	8842	4583	4	0	0
254964	1678	8640244934000	8842	4583	5	0	0
254974	1678	8640244935000	8846	4584	0	0	0
254977	1678	8640244936000	8848	4585	0	0	0
254979	1874	201640000	8848	4585	2	0	0
254980	1678	8640244937000	8849	4586	0	0	0
254981	1874	201641000	8849	4586	1	0	0
254988	1874	201642000	8853	4587	0	0	0
254994	1678	8640244939000	8856	4588	0	0	0
254995	1874	201643000	8856	4588	1	0	0
254996	1874	201644000	8857	4589	0	0	0
254997	1678	8640244940000	8857	4589	1	0	0
254998	1678	8640244941000	8858	4590	0	0	0
255000	1874	201646000	8859	4591	0	0	0
255002	1678	8640244943000	8860	4592	0	0	\N
255003	1874	201647000	8860	4592	1	0	\N
255006	1678	8640244944000	8862	4593	0	0	\N
255007	1874	201648000	8862	4593	1	0	\N
255010	1678	8640244944000	8864	4593	0	0	\N
255011	1874	201648000	8864	4593	1	0	\N
255014	1678	8640244945000	8866	4594	0	0	\N
255015	1874	201649000	8866	4594	1	0	\N
255018	1678	8640244946000	8868	4595	0	0	\N
255019	1874	201650000	8868	4595	1	0	\N
255024	1678	8640244949000	8870	4597	0	0	\N
255025	1874	201653000	8870	4597	1	0	\N
255026	1678	8640244949000	8871	4597	0	0	\N
255027	1874	201653000	8871	4597	1	0	\N
255028	1678	8640244949000	8872	4597	0	0	\N
255029	1874	201653000	8872	4597	1	0	\N
255034	1678	8640244946000	8876	4595	0	0	\N
255035	1678	8640244947000	8876	4595	1	0	\N
255036	1874	201650000	8876	4595	2	0	\N
255037	1874	201651000	8876	4595	3	0	\N
255038	1874	201652000	8876	4595	4	0	\N
255039	1874	201653000	8876	4595	5	0	\N
255040	1874	201654000	8876	4595	6	0	\N
255041	1678	8640244948000	8876	4595	7	0	\N
255042	1678	8640244949000	8876	4595	8	0	\N
255048	1678	8640244951000	8878	4599	0	0	\N
255049	1678	8640244952000	8878	4599	1	0	\N
255050	1678	8640244953000	8878	4599	2	0	\N
255051	1874	201655000	8878	4599	3	0	\N
255052	1874	201656000	8878	4599	4	0	\N
255053	806	1222212232776490	8879	4549	0	0	\N
255054	806	1222212452776490	8879	4549	1	0	\N
255059	1874	201657000	8881	4600	0	0	\N
255060	1678	8640244954000	8881	4600	1	0	\N
255061	1678	8640244955000	8881	4600	2	0	\N
255062	1874	201658000	8881	4600	3	0	\N
255083	1678	8640244965000	8887	4606	0	0	\N
255084	1874	201669000	8887	4606	1	0	\N
255087	1874	201670000	8889	4607	0	0	\N
255088	1678	8640244966000	8889	4607	1	0	\N
255089	1874	201670000	8891	4607	0	0	\N
255090	1678	8640244966000	8891	4607	1	0	\N
255091	1874	201670000	8892	4607	0	0	\N
255092	1678	8640244966000	8892	4607	1	0	\N
255099	1678	8640244969000	8896	4610	0	0	\N
255100	1678	8640244970000	8896	4610	1	0	\N
255101	1874	201671000	8897	4609	0	0	\N
255102	1678	8640244967000	8897	4609	1	0	\N
255103	1678	8640244968000	8897	4609	2	0	\N
255104	1678	8640244969000	8897	4609	3	0	\N
255105	1678	8640244970000	8897	4609	4	0	\N
255106	1874	201672000	8897	4609	5	0	\N
255107	1874	201673000	8897	4609	6	0	\N
255108	1874	201674000	8897	4609	7	0	\N
255109	1678	8640244969000	8898	4610	0	0	\N
255110	1678	8640244970000	8898	4610	1	0	\N
255111	1874	201673000	8898	4610	2	0	\N
255112	1874	201674000	8898	4610	3	0	\N
255117	1678	8640244971000	8900	4611	0	0	\N
255118	1874	201675000	8900	4611	1	0	\N
255119	1952	200000000	8900	4611	2	0	\N
255123	1678	8640244971000	8902	4611	0	0	\N
255124	1874	201675000	8902	4611	1	0	\N
255125	1952	200000000	8902	4611	2	0	\N
255126	1678	8640244971000	8903	4610	0	0	\N
255127	1874	201675000	8903	4610	1	0	\N
255128	1952	200000000	8903	4610	2	0	\N
255129	1678	8640244971000	8904	4611	0	0	\N
255130	1874	201675000	8904	4611	1	0	\N
255005	1874	201647000	8861	4592	1	0	0
255008	1678	8640244944000	8863	4593	0	0	0
255009	1874	201648000	8863	4593	1	0	0
255012	1678	8640244945000	8865	4594	0	0	0
255013	1874	201649000	8865	4594	1	0	0
255017	1874	201650000	8867	4595	1	0	0
255020	1874	201651000	8869	4596	0	0	0
255021	1874	201652000	8869	4596	1	0	0
255022	1678	8640244947000	8869	4596	2	0	0
255023	1678	8640244948000	8869	4596	3	0	0
255031	1874	201653000	8873	4597	1	0	0
255032	1678	8640244950000	8874	4598	0	0	0
255033	1874	201654000	8874	4598	1	0	0
255043	1678	8640244951000	8877	4599	0	0	0
255045	1678	8640244953000	8877	4599	2	0	0
255046	1874	201655000	8877	4599	3	0	0
255047	1874	201656000	8877	4599	4	0	0
255055	1874	201657000	8880	4600	0	0	0
255056	1678	8640244954000	8880	4600	1	0	0
255058	1874	201658000	8880	4600	3	0	0
255063	1460	0	8882	4601	0	0	0
255064	1874	201659000	8882	4601	1	0	0
255065	1874	201660000	8882	4601	2	0	0
255066	1678	8640244956000	8882	4601	3	0	0
255068	1678	8640244957000	8883	4602	1	0	0
255069	1678	8640244958000	8883	4602	2	0	0
255070	1874	201662000	8883	4602	3	0	0
255071	1678	8640244959000	8884	4603	0	0	0
255073	1874	201664000	8885	4604	0	0	0
255074	1678	8640244960000	8885	4604	1	0	0
255075	1678	8640244961000	8886	4605	0	0	0
255076	1678	8640244962000	8886	4605	1	0	0
255077	1874	201665000	8886	4605	2	0	0
255079	1678	8640244964000	8886	4605	4	0	0
255080	1874	201666000	8886	4605	5	0	0
255081	1874	201667000	8886	4605	6	0	0
255082	1874	201668000	8886	4605	7	0	0
255085	1678	8640244965000	8888	4606	0	0	0
255093	1874	201670000	8893	4607	0	0	0
255094	1678	8640244966000	8893	4607	1	0	0
255095	1874	201671000	8895	4609	0	0	0
255096	1678	8640244967000	8895	4609	1	0	0
255098	1874	201672000	8895	4609	3	0	0
255113	1678	8640244969000	8899	4610	0	0	0
255114	1678	8640244970000	8899	4610	1	0	0
255115	1874	201673000	8899	4610	2	0	0
255116	1874	201674000	8899	4610	3	0	0
255121	1874	201675000	8901	4611	1	0	0
255122	1952	200000000	8901	4611	2	0	0
255131	1874	201676000	8905	4612	0	0	0
255132	1678	8640244972000	8905	4612	1	0	0
255133	1678	8640244973000	8906	4613	0	0	0
255135	1874	201678000	8907	4614	0	0	0
255136	1874	201679000	8907	4614	1	0	0
255139	1678	8640244976000	8908	4615	0	0	\N
255140	1874	201680000	8908	4615	1	0	\N
255151	1678	8640244980000	8912	4617	0	0	\N
255152	1874	201684000	8912	4617	1	0	\N
255157	1678	8640244982000	8915	4619	0	0	\N
255163	1678	8640244983000	8917	4620	0	0	\N
255164	1678	8640244984000	8917	4620	1	0	\N
255165	1874	201687000	8917	4620	2	0	\N
255166	1874	201688000	8917	4620	3	0	\N
255167	1569	1810000000	8917	4620	4	0	\N
255170	1874	201689000	8919	4621	0	0	\N
255171	1678	8640244985000	8919	4621	1	0	\N
255181	409	66000001000000	8923	4596	0	0	\N
255182	1569	1810000000	8923	4596	1	0	\N
255187	1874	201696000	8926	4627	0	0	\N
255188	1678	8640244992000	8926	4627	1	0	\N
255191	1874	201696000	8928	4627	0	0	\N
255192	1678	8640244992000	8928	4627	1	0	\N
255203	1874	201702000	8933	4632	0	0	\N
255204	1874	201703000	8933	4632	1	0	\N
255205	1678	8640244998000	8933	4632	2	0	\N
255206	1678	8640244999000	8933	4632	3	0	\N
255211	1678	8640245000000	8935	4633	0	0	\N
255212	1874	201704000	8935	4633	1	0	\N
255217	1874	201706000	8939	4635	0	0	\N
255218	1678	8640245002000	8939	4635	2	0	\N
255219	1678	8640245003000	8939	4635	3	0	\N
255220	1874	201707000	8939	4635	4	0	\N
255233	1678	8640245006000	8943	4638	0	0	\N
255234	1874	201710000	8943	4638	1	0	\N
255238	724	20003750000000	8945	4597	1	0	\N
255239	1678	8640245008000	8946	4640	0	0	\N
255240	1874	201712000	8946	4640	1	0	\N
255246	498	66004000000000	8948	4640	0	0	\N
255247	1678	8640245008000	8948	4640	1	0	\N
255248	1678	8640245009000	8948	4640	2	0	\N
255249	1874	201712000	8948	4640	3	0	\N
255250	1874	201713000	8948	4640	4	0	\N
255257	1678	8640245013000	8953	4644	0	0	\N
255258	1678	8640245014000	8953	4644	1	0	\N
255259	1874	201717000	8953	4644	2	0	\N
255260	1874	201718000	8953	4644	3	0	\N
255265	498	66004000000000	8955	4598	1	0	\N
255266	1874	201719000	8956	4645	0	0	\N
255267	1874	201720000	8956	4645	1	0	\N
255268	1678	8640245015000	8956	4645	2	0	\N
255269	1678	8640245016000	8956	4645	3	0	\N
255141	1678	8640244976000	8909	4615	0	0	0
255142	1874	201680000	8909	4615	1	0	0
255143	1678	8640244977000	8910	4616	0	0	0
255144	1874	201681000	8910	4616	1	0	0
255145	1678	8640244978000	8910	4616	2	0	0
255147	1874	201682000	8910	4616	4	0	0
255148	1874	201683000	8910	4616	5	0	0
255149	1678	8640244980000	8911	4617	0	0	0
255150	1874	201684000	8911	4617	1	0	0
255153	1874	201685000	8913	4618	0	0	0
255155	1874	201686000	8914	4619	0	0	0
255156	1678	8640244982000	8914	4619	1	0	0
255158	1678	8640244983000	8916	4620	0	0	0
255159	1678	8640244984000	8916	4620	1	0	0
255161	1874	201688000	8916	4620	3	0	0
255162	1569	1810000000	8916	4620	4	0	1
255168	1874	201689000	8918	4621	0	0	0
255169	1678	8640244985000	8918	4621	1	0	0
255172	1678	8640244986000	8920	4622	0	0	0
255174	1678	8640244987000	8921	4623	0	0	0
255175	1874	201691000	8921	4623	1	0	0
255176	1874	201692000	8921	4623	2	0	0
255177	1678	8640244988000	8921	4623	3	0	0
255178	409	66000001000000	8921	4623	4	0	0
255180	1874	201693000	8922	4624	1	0	0
255183	1678	8640244990000	8924	4625	0	0	0
255184	1874	201694000	8924	4625	1	0	0
255185	1874	201695000	8925	4626	0	0	0
255189	1874	201696000	8927	4627	0	0	0
255190	1678	8640244992000	8927	4627	1	0	0
255193	1678	8640244993000	8929	4628	0	0	0
255194	1874	201697000	8929	4628	1	0	0
255195	1678	8640244994000	8930	4629	1	0	0
255197	1874	201699000	8931	4630	0	0	0
255198	1874	201700000	8931	4630	1	0	0
255199	1678	8640244995000	8931	4630	2	0	0
255200	1678	8640244996000	8931	4630	3	0	0
255201	1874	201701000	8932	4631	0	0	0
255207	1874	201702000	8934	4632	0	0	0
255208	1874	201703000	8934	4632	1	0	0
255209	1678	8640244998000	8934	4632	2	0	0
255210	1678	8640244999000	8934	4632	3	0	0
255214	1874	201704000	8936	4633	1	0	0
255215	1678	8640245001000	8937	4634	0	0	0
255216	1874	201705000	8937	4634	1	0	0
255221	1874	201706000	8941	4637	0	0	0
255222	1678	8640245002000	8941	4637	1	0	0
255224	1678	8640245004000	8941	4637	3	0	0
255225	1678	8640245005000	8941	4637	4	0	0
255226	1874	201707000	8941	4637	5	0	0
255227	1874	201708000	8941	4637	6	0	0
255228	1874	201709000	8941	4637	7	0	0
255230	1955	200000000	8941	4637	9	0	0
255231	1678	8640245006000	8942	4638	0	0	0
255232	1874	201710000	8942	4638	1	0	0
255235	724	20003750000000	8944	4639	0	0	1
255237	1678	8640245007000	8944	4639	2	0	0
255241	498	66004000000000	8947	4640	0	0	0
255242	1678	8640245008000	8947	4640	1	0	0
255243	1678	8640245009000	8947	4640	2	0	0
255244	1874	201712000	8947	4640	3	0	0
255251	1678	8640245010000	8950	4641	0	0	0
255252	1874	201714000	8950	4641	1	0	0
255253	1874	201715000	8951	4642	1	0	0
255254	1678	8640245011000	8951	4642	2	0	0
255255	1874	201716000	8952	4643	0	0	0
255261	1678	8640245013000	8954	4644	0	0	0
255262	1678	8640245014000	8954	4644	1	0	0
255263	1874	201717000	8954	4644	2	0	0
255264	1874	201718000	8954	4644	3	0	0
255271	1874	201720000	8957	4645	1	0	0
255272	1678	8640245015000	8957	4645	2	0	0
255274	724	20003750000000	8958	4569	1	0	\N
255275	498	66004000000000	8958	4569	2	0	\N
255276	1713	560000000	8958	4569	3	0	\N
255277	1460	0	8958	4569	4	0	\N
255278	806	1222212232776490	8958	4569	5	0	\N
255279	1950	100000000000	8958	4569	6	0	\N
255280	1678	8640244913000	8958	4569	7	0	\N
255281	1874	201617000	8958	4569	8	0	\N
255282	1874	201618000	8958	4569	9	0	\N
255283	1949	1400000000	8958	4569	10	0	\N
255284	1874	201619000	8958	4569	11	0	\N
255285	1949	2600000000	8958	4569	12	0	\N
255286	1874	201620000	8958	4569	13	0	\N
255287	1874	201621000	8958	4569	14	0	\N
255288	1678	8640244914000	8958	4569	15	0	\N
255289	1678	8640244915000	8958	4569	16	0	\N
255290	1678	8640244916000	8958	4569	17	0	\N
255291	1678	8640244917000	8958	4569	18	0	\N
255292	1678	8640244918000	8958	4569	19	0	\N
255293	1874	201622000	8958	4569	20	0	\N
255294	1874	201623000	8958	4569	21	0	\N
255295	1874	201624000	8958	4569	22	0	\N
255296	1874	201625000	8958	4569	23	0	\N
255297	1874	201626000	8958	4569	24	0	\N
255298	1874	201627000	8958	4569	25	0	\N
255299	1874	201628000	8958	4569	26	0	\N
255300	1874	201629000	8958	4569	27	0	\N
255301	1951	200000000	8958	4569	28	0	\N
255302	1874	201630000	8958	4569	29	0	\N
255303	1874	201631000	8958	4569	30	0	\N
255304	1874	201632000	8958	4569	31	0	\N
255305	1874	201633000	8958	4569	32	0	\N
255306	1874	201634000	8958	4569	33	0	\N
255307	1874	201635000	8958	4569	34	0	\N
255308	1874	201636000	8958	4569	35	0	\N
255309	1874	201637000	8958	4569	36	0	\N
255310	1874	201638000	8958	4569	37	0	\N
255311	1874	201639000	8958	4569	38	0	\N
255312	1874	201640000	8958	4569	39	0	\N
255313	1874	201641000	8958	4569	40	0	\N
255314	1874	201642000	8958	4569	41	0	\N
255315	1678	8640244919000	8958	4569	42	0	\N
255316	1678	8640244920000	8958	4569	43	0	\N
255317	1678	8640244921000	8958	4569	44	0	\N
255318	1678	8640244922000	8958	4569	45	0	\N
255319	1678	8640244923000	8958	4569	46	0	\N
255320	1678	8640244924000	8958	4569	47	0	\N
255321	1678	8640244925000	8958	4569	48	0	\N
255322	1678	8640244926000	8958	4569	49	0	\N
255323	1678	8640244927000	8958	4569	50	0	\N
255324	1678	8640244928000	8958	4569	51	0	\N
255325	1678	8640244929000	8958	4569	52	0	\N
255326	1678	8640244930000	8958	4569	53	0	\N
255327	1678	8640244931000	8958	4569	54	0	\N
255328	1678	8640244932000	8958	4569	55	0	\N
255329	1678	8640244933000	8958	4569	56	0	\N
255330	1678	8640244934000	8958	4569	57	0	\N
255331	1678	8640244935000	8958	4569	58	0	\N
255332	1678	8640244936000	8958	4569	59	0	\N
255333	1678	8640244937000	8958	4569	60	0	\N
255334	1678	8640244938000	8958	4569	61	0	\N
255335	1678	8640244939000	8958	4569	62	0	\N
255336	1678	8640244940000	8958	4569	63	0	\N
255337	1678	8640244941000	8958	4569	64	0	\N
255338	1678	8640244942000	8958	4569	65	0	\N
255339	1678	8640244943000	8958	4569	66	0	\N
255340	1678	8640244944000	8958	4569	68	0	\N
255341	1678	8640244945000	8958	4569	69	0	\N
255342	1678	8640244946000	8958	4569	70	0	\N
255343	1678	8640244947000	8958	4569	71	0	\N
255344	806	1222212452776490	8958	4569	72	0	\N
255345	1678	8640244948000	8958	4569	73	0	\N
255346	1678	8640244949000	8958	4569	74	0	\N
255347	1678	8640244950000	8958	4569	75	0	\N
255348	1678	8640244951000	8958	4569	76	0	\N
255349	1678	8640244952000	8958	4569	77	0	\N
255350	1678	8640244953000	8958	4569	78	0	\N
255351	1678	8640244954000	8958	4569	79	0	\N
255352	1678	8640244955000	8958	4569	80	0	\N
255353	1678	8640244956000	8958	4569	81	0	\N
255354	1678	8640244957000	8958	4569	82	0	\N
255355	1678	8640244958000	8958	4569	83	0	\N
255356	1678	8640244959000	8958	4569	84	0	\N
255357	1678	8640244960000	8958	4569	85	0	\N
255358	1678	8640244961000	8958	4569	86	0	\N
255359	1678	8640244962000	8958	4569	87	0	\N
255360	1678	8640244963000	8958	4569	88	0	\N
255361	1678	8640244964000	8958	4569	89	0	\N
255362	1678	8640244965000	8958	4569	90	0	\N
255363	1678	8640244966000	8958	4569	91	0	\N
255364	1678	8640244967000	8958	4569	92	0	\N
255365	1678	8640244968000	8958	4569	93	0	\N
255366	1678	8640244969000	8958	4569	94	0	\N
255367	1678	8640244970000	8958	4569	95	0	\N
255368	1678	8640244971000	8958	4569	96	0	\N
255369	1678	8640244972000	8958	4569	97	0	\N
255370	1678	8640244973000	8958	4569	98	0	\N
255371	1678	8640244974000	8958	4569	99	0	\N
255372	1678	8640244975000	8958	4569	100	0	\N
255373	1678	8640244976000	8958	4569	101	0	\N
255374	1678	8640244977000	8958	4569	102	0	\N
255375	1678	8640244978000	8958	4569	103	0	\N
255376	1678	8640244979000	8958	4569	104	0	\N
255377	1678	8640244980000	8958	4569	105	0	\N
255378	1678	8640244981000	8958	4569	106	0	\N
255379	1678	8640244982000	8958	4569	107	0	\N
255380	1678	8640244983000	8958	4569	108	0	\N
255381	1678	8640244984000	8958	4569	109	0	\N
255382	1678	8640244985000	8958	4569	110	0	\N
255383	1678	8640244986000	8958	4569	111	0	\N
255384	1678	8640244987000	8958	4569	112	0	\N
255385	1678	8640244988000	8958	4569	113	0	\N
255386	1678	8640244989000	8958	4569	114	0	\N
255387	1678	8640244990000	8958	4569	115	0	\N
255388	1678	8640244991000	8958	4569	116	0	\N
255389	1678	8640244992000	8958	4569	117	0	\N
255390	1678	8640244993000	8958	4569	118	0	\N
255391	1678	8640244994000	8958	4569	119	0	\N
255392	1678	8640244995000	8958	4569	120	0	\N
255393	1678	8640244996000	8958	4569	121	0	\N
255394	1678	8640244997000	8958	4569	122	0	\N
255395	1678	8640244998000	8958	4569	123	0	\N
255396	1678	8640244999000	8958	4569	124	0	\N
255397	1678	8640245000000	8958	4569	125	0	\N
255398	1874	201721000	8959	4646	0	0	\N
255399	1678	8640245017000	8959	4646	1	0	\N
255400	1678	8640245018000	8959	4646	2	0	\N
255401	1874	201722000	8959	4646	3	0	\N
255402	1474	14674323000000	8959	4646	4	0	\N
255408	1678	8640245019000	8961	4647	0	0	\N
255404	1678	8640245017000	8960	4646	1	0	0
255405	1678	8640245018000	8960	4646	2	0	0
255406	1874	201722000	8960	4646	3	0	0
255407	1474	14674323000000	8960	4646	4	0	4
255409	1874	201723000	8961	4647	1	0	\N
255420	1474	13954303000000	8966	4599	0	0	\N
255425	1678	8640245024000	8968	4651	0	0	\N
255426	1874	201728000	8968	4651	1	0	\N
255427	1874	201729000	8968	4651	2	0	\N
255428	1678	8640245025000	8968	4651	3	0	\N
255429	1678	8640245026000	8969	4652	0	0	\N
255430	1678	8640245027000	8969	4652	1	0	\N
255431	1874	201730000	8969	4652	2	0	\N
255432	1874	201731000	8969	4652	3	0	\N
255433	1957	10000000	8969	4652	4	0	\N
255449	1678	8640245032000	8974	4655	0	0	\N
255450	1874	201736000	8974	4655	1	0	\N
255451	724	20003750000000	8975	4488	1	0	\N
255452	498	66004000000000	8975	4488	2	0	\N
255453	208	66000010000000	8975	4488	3	0	\N
255454	1874	201545000	8975	4488	4	0	\N
255455	806	1222212232776490	8975	4488	5	0	\N
255456	1678	8640244814000	8975	4488	6	0	\N
255457	1874	201546000	8975	4488	7	0	\N
255458	1874	201547000	8975	4488	8	0	\N
255459	1950	100000000000	8975	4488	9	0	\N
255460	441	66000020000000	8975	4488	10	0	\N
255461	1874	201548000	8975	4488	11	0	\N
255462	1874	201549000	8975	4488	12	0	\N
255463	1678	8640244815000	8975	4488	13	0	\N
255464	1678	8640244816000	8975	4488	14	0	\N
255465	1678	8640244817000	8975	4488	15	0	\N
255466	1678	8640244818000	8975	4488	16	0	\N
255467	1678	8640244819000	8975	4488	17	0	\N
255468	1678	8640244820000	8975	4488	18	0	\N
255469	1678	8640244821000	8975	4488	19	0	\N
255470	1678	8640244822000	8975	4488	21	0	\N
255471	1874	201550000	8975	4488	22	0	\N
255472	1874	201551000	8975	4488	23	0	\N
255473	1874	201552000	8975	4488	24	0	\N
255474	1947	200000000	8975	4488	25	0	\N
255475	1874	201553000	8975	4488	26	0	\N
255476	1874	201554000	8975	4488	27	0	\N
255477	1874	201555000	8975	4488	28	0	\N
255478	1874	201556000	8975	4488	29	0	\N
255479	1874	201557000	8975	4488	30	0	\N
255480	1874	201558000	8975	4488	31	0	\N
255481	1874	201559000	8975	4488	32	0	\N
255482	1874	201560000	8975	4488	33	0	\N
255483	1874	201561000	8975	4488	34	0	\N
255484	1874	201562000	8975	4488	35	0	\N
255485	1874	201563000	8975	4488	36	0	\N
255486	1874	201564000	8975	4488	37	0	\N
255487	1874	201565000	8975	4488	38	0	\N
255488	1874	201566000	8975	4488	39	0	\N
255489	1874	201567000	8975	4488	40	0	\N
255490	1874	201568000	8975	4488	41	0	\N
255491	1874	201569000	8975	4488	42	0	\N
255492	1874	201570000	8975	4488	43	0	\N
255493	1874	201571000	8975	4488	44	0	\N
255494	1874	201572000	8975	4488	45	0	\N
255495	1874	201573000	8975	4488	46	0	\N
255496	1874	201574000	8975	4488	47	0	\N
255497	1874	201575000	8975	4488	48	0	\N
255498	1874	201576000	8975	4488	49	0	\N
255499	1874	201577000	8975	4488	50	0	\N
255500	1874	201578000	8975	4488	51	0	\N
255501	1874	201579000	8975	4488	52	0	\N
255502	1874	201580000	8975	4488	53	0	\N
255503	1874	201581000	8975	4488	54	0	\N
255504	1874	201582000	8975	4488	55	0	\N
255505	1874	201583000	8975	4488	56	0	\N
255506	1874	201584000	8975	4488	57	0	\N
255507	1874	201585000	8975	4488	58	0	\N
255508	1874	201586000	8975	4488	59	0	\N
255509	1874	201587000	8975	4488	60	0	\N
255510	1874	201588000	8975	4488	61	0	\N
255511	1874	201589000	8975	4488	62	0	\N
255514	1874	201737000	8977	4656	0	0	\N
255515	1678	8640245033000	8977	4656	1	0	\N
255518	1874	201739000	8979	4658	0	0	\N
255519	1678	8640245035000	8979	4658	1	0	\N
255522	1874	201739000	8981	4658	0	0	\N
255523	1678	8640245035000	8981	4658	1	0	\N
255526	1678	8640245036000	8983	4659	0	0	\N
255527	1678	8640245037000	8984	4660	0	0	\N
255528	1874	201741000	8984	4660	1	0	\N
255530	1874	201741000	8986	4661	0	0	\N
255531	1678	8640245038000	8986	4661	2	0	\N
255532	1874	201742000	8986	4661	3	0	\N
255533	1874	201743000	8986	4661	4	0	\N
255534	1678	8640245039000	8986	4661	5	0	\N
255535	1874	201741000	8987	4661	0	0	\N
255536	1678	8640245038000	8987	4661	2	0	\N
255537	1874	201742000	8987	4661	3	0	\N
255538	1874	201743000	8987	4661	4	0	\N
255539	1678	8640245039000	8987	4661	5	0	\N
255540	1874	201741000	8988	4661	0	0	\N
255541	1678	8640245038000	8988	4661	2	0	\N
255542	1874	201742000	8988	4661	3	0	\N
255543	1874	201743000	8988	4661	4	0	\N
255544	1678	8640245039000	8988	4661	5	0	\N
255412	1874	201724000	8963	4648	0	0	0
255413	1678	8640245020000	8963	4648	1	0	0
255414	1874	201725000	8964	4649	0	0	0
255415	1678	8640245021000	8964	4649	1	0	0
255416	1678	8640245022000	8964	4649	2	0	0
255418	1678	8640245023000	8965	4650	0	0	0
255419	1874	201727000	8965	4650	1	0	0
255421	1678	8640245024000	8967	4651	0	0	0
255422	1874	201728000	8967	4651	1	0	0
255423	1874	201729000	8967	4651	2	0	0
255434	1678	8640245026000	8970	4652	0	0	0
255435	1678	8640245027000	8970	4652	1	0	0
255436	1874	201730000	8970	4652	2	0	0
255437	1874	201731000	8970	4652	3	0	0
255439	1678	8640245028000	8971	4653	0	0	0
255440	1874	201732000	8971	4653	1	0	0
255441	1678	8640245029000	8972	4654	0	0	0
255442	1678	8640245030000	8972	4654	1	0	0
255443	1678	8640245031000	8972	4654	2	0	0
255445	1874	201734000	8972	4654	4	0	0
255446	1874	201735000	8972	4654	5	0	0
255447	1678	8640245032000	8973	4655	0	0	0
255448	1874	201736000	8973	4655	1	0	0
255512	1874	201737000	8976	4656	0	0	0
255516	1874	201738000	8978	4657	0	0	0
255517	1678	8640245034000	8978	4657	1	0	0
255520	1874	201739000	8980	4658	0	0	0
255521	1678	8640245035000	8980	4658	1	0	0
255525	1678	8640245036000	8982	4659	1	0	0
255529	1678	8640245037000	8985	4660	0	0	0
255545	1874	201741000	8989	4661	0	0	\N
255546	1678	8640245038000	8989	4661	2	0	\N
255547	1874	201742000	8989	4661	3	0	\N
255548	1874	201743000	8989	4661	4	0	\N
255549	1678	8640245039000	8989	4661	5	0	\N
255555	1874	201741000	8991	4661	0	0	\N
255556	1678	8640245038000	8991	4661	2	0	\N
255557	1874	201742000	8991	4661	3	0	\N
255558	1874	201743000	8991	4661	4	0	\N
255559	1678	8640245039000	8991	4661	5	0	\N
255564	1874	201745000	8994	4663	0	0	\N
255565	1678	8640245041000	8994	4663	1	0	\N
255571	1678	8640245042000	8996	4664	0	0	\N
255572	1874	201746000	8996	4664	1	0	\N
255573	1874	201747000	8996	4664	2	0	\N
255574	1678	8640245043000	8996	4664	3	0	\N
255575	1941	717956000000	8996	4664	4	0	\N
255582	1678	8640245044000	8998	4665	0	0	\N
255583	1874	201748000	8998	4665	1	0	\N
255584	1874	201749000	8998	4665	2	0	\N
255585	1874	201750000	8998	4665	3	0	\N
255586	1678	8640245045000	8998	4665	4	0	\N
255587	1678	8640245046000	8998	4665	5	0	\N
255592	1678	8640245049000	9000	4667	0	0	\N
255593	1874	201753000	9000	4667	1	0	\N
255594	1678	8640245049000	9001	4667	0	0	\N
255595	1874	201753000	9001	4667	1	0	\N
255598	1678	8640245049000	9003	4667	0	0	\N
255601	1874	201754000	9005	4668	0	0	\N
255602	1678	8640245050000	9005	4668	1	0	\N
255605	1874	201756000	9009	4670	0	0	\N
255606	1874	201757000	9009	4670	1	0	\N
255607	1678	8640245052000	9009	4670	2	0	\N
255608	1678	8640245053000	9009	4670	3	0	\N
255613	1874	201756000	9011	4670	0	0	\N
255614	1874	201757000	9011	4670	1	0	\N
255615	1678	8640245052000	9011	4670	2	0	\N
255616	1678	8640245053000	9011	4670	3	0	\N
255625	1678	8640245058000	9015	4674	0	0	\N
255626	1874	201762000	9015	4674	1	0	\N
255638	1874	201767000	9019	4677	0	0	\N
255639	1678	8640245063000	9019	4677	1	0	\N
255642	1874	201767000	9021	4677	0	0	\N
255649	1678	8640245065000	9024	4679	0	0	\N
255650	1678	8640245066000	9024	4679	1	0	\N
255651	1874	201769000	9024	4679	2	0	\N
255652	1874	201770000	9024	4679	3	0	\N
255653	1678	8640245067000	9025	4680	0	0	\N
255654	1874	201771000	9025	4680	1	0	\N
255659	1874	201772000	9028	4681	0	0	\N
255660	1678	8640245068000	9028	4681	1	0	\N
255663	1874	201773000	9030	4682	0	0	\N
255664	1678	8640245069000	9030	4682	1	0	\N
255665	1678	8640245070000	9031	4683	0	0	\N
255666	1932	217990000000	9031	4683	1	0	\N
255667	1874	201774000	9031	4683	2	0	\N
255671	1678	8640245070000	9033	4683	0	0	\N
255672	1932	217990000000	9033	4683	1	0	\N
255673	1874	201774000	9033	4683	2	0	\N
255680	1678	8640245073000	9036	4685	0	0	\N
255552	1874	201742000	8990	4661	3	0	0
255553	1874	201743000	8990	4661	4	0	0
255554	1678	8640245039000	8990	4661	5	0	0
255560	1874	201744000	8992	4662	0	0	0
255561	1678	8640245040000	8992	4662	1	0	0
255563	1678	8640245041000	8993	4663	1	0	0
255566	1678	8640245042000	8995	4664	0	0	0
255567	1874	201746000	8995	4664	1	0	0
255568	1874	201747000	8995	4664	2	0	0
255569	1678	8640245043000	8995	4664	3	0	0
255576	1678	8640245044000	8997	4665	0	0	0
255577	1874	201748000	8997	4665	1	0	0
255578	1874	201749000	8997	4665	2	0	0
255579	1874	201750000	8997	4665	3	0	0
255581	1678	8640245046000	8997	4665	5	0	0
255588	1874	201751000	8999	4666	0	0	0
255589	1874	201752000	8999	4666	1	0	0
255590	1678	8640245047000	8999	4666	2	0	0
255591	1678	8640245048000	8999	4666	3	0	0
255597	1874	201753000	9002	4667	1	0	0
255599	1874	201754000	9004	4668	0	0	0
255600	1678	8640245050000	9004	4668	1	0	0
255603	1678	8640245051000	9006	4669	0	0	0
255604	1874	201755000	9006	4669	1	0	0
255610	1874	201757000	9010	4670	1	0	0
255611	1678	8640245052000	9010	4670	2	0	0
255612	1678	8640245053000	9010	4670	3	0	0
255617	1678	8640245054000	9012	4671	0	0	0
255619	1874	201759000	9013	4672	0	0	0
255620	1874	201760000	9013	4672	1	0	0
255621	1678	8640245055000	9013	4672	2	0	0
255622	1678	8640245056000	9013	4672	3	0	0
255623	1678	8640245057000	9014	4673	0	0	0
255627	1678	8640245058000	9016	4674	0	0	0
255628	1874	201762000	9016	4674	1	0	0
255629	1874	201763000	9017	4675	0	0	0
255630	1874	201764000	9017	4675	1	0	0
255631	1678	8640245059000	9017	4675	2	0	0
255633	1678	8640245061000	9018	4676	0	0	0
255634	1874	201765000	9018	4676	1	0	0
255635	1678	8640245062000	9018	4676	2	0	0
255636	1874	201766000	9018	4676	3	0	0
255640	1874	201767000	9020	4677	0	0	0
255641	1678	8640245063000	9020	4677	1	0	0
255643	1678	8640245064000	9022	4678	0	0	0
255644	1874	201768000	9022	4678	1	0	0
255645	1678	8640245065000	9023	4679	0	0	0
255647	1874	201769000	9023	4679	2	0	0
255648	1874	201770000	9023	4679	3	0	0
255655	1678	8640245067000	9026	4680	0	0	0
255656	1874	201771000	9026	4680	1	0	0
255657	1874	201772000	9027	4681	0	0	0
255661	1874	201773000	9029	4682	0	0	0
255662	1678	8640245069000	9029	4682	1	0	0
255668	1678	8640245070000	9032	4683	0	0	0
255669	1932	217990000000	9032	4683	1	0	0
255674	1678	8640245071000	9034	4684	0	0	0
255675	1678	8640245072000	9034	4684	1	0	0
255676	1874	201775000	9034	4684	2	0	0
255677	1874	201776000	9034	4684	3	0	0
255678	1678	8640245073000	9035	4685	0	0	0
255681	1874	201777000	9036	4685	1	0	\N
255684	1874	201778000	9038	4686	0	0	\N
255685	1678	8640245074000	9038	4686	2	0	\N
255688	1678	8640245076000	9040	4688	0	0	\N
255689	1874	201780000	9040	4688	1	0	\N
255692	1874	201781000	9042	4689	0	0	\N
255693	1874	201782000	9042	4689	1	0	\N
255694	1678	8640245077000	9042	4689	2	0	\N
255695	1678	8640245078000	9042	4689	3	0	\N
255696	1958	9000000000	9042	4689	4	0	\N
255702	724	20003750000000	9045	4429	1	0	\N
255703	498	66004000000000	9045	4429	2	0	\N
255704	1874	201783000	9046	4690	0	0	\N
255705	1874	201784000	9046	4690	1	0	\N
255706	1678	8640245079000	9046	4690	2	0	\N
255707	1678	8640245080000	9046	4690	3	0	\N
255725	1678	8640245081000	9049	4691	0	0	\N
255726	1821	279990000000	9049	4691	1	0	\N
255727	1678	8640245082000	9049	4691	2	0	\N
255728	1678	8640245083000	9049	4691	3	0	\N
255729	1678	8640245084000	9049	4691	4	0	\N
255730	1678	8640245085000	9049	4691	5	0	\N
255731	1874	201785000	9049	4691	6	0	\N
255732	1874	201786000	9049	4691	7	0	\N
255733	1874	201787000	9049	4691	8	0	\N
255734	1959	200000000	9049	4691	9	0	\N
255735	1874	201788000	9049	4691	10	0	\N
255736	1874	201789000	9049	4691	11	0	\N
255737	1958	708998000000	9049	4691	12	0	\N
255738	1678	8640245081000	9050	4691	0	0	\N
255739	1821	279990000000	9050	4691	1	0	\N
255740	1678	8640245082000	9050	4691	2	0	\N
255741	1678	8640245083000	9050	4691	3	0	\N
255742	1678	8640245084000	9050	4691	4	0	\N
255743	1678	8640245085000	9050	4691	5	0	\N
255744	1874	201785000	9050	4691	6	0	\N
255745	1874	201786000	9050	4691	7	0	\N
255746	1874	201787000	9050	4691	8	0	\N
255747	1959	200000000	9050	4691	9	0	\N
255748	1874	201788000	9050	4691	10	0	\N
255749	1874	201789000	9050	4691	11	0	\N
255750	1958	708998000000	9050	4691	12	0	\N
255751	1874	201790000	9051	4692	0	0	\N
255752	1678	8640245086000	9051	4692	1	0	\N
255755	1874	201791000	9053	4693	0	0	\N
255756	1678	8640245087000	9053	4693	1	0	\N
255764	1678	8640245088000	9056	4694	0	0	\N
255765	1874	201792000	9056	4694	1	0	\N
255766	1874	201793000	9056	4694	2	0	\N
255767	1678	8640245089000	9056	4694	3	0	\N
255768	1515	10603400	9056	4694	4	0	\N
255769	1678	8640245088000	9057	4694	0	0	\N
255770	1874	201792000	9057	4694	1	0	\N
255771	1874	201793000	9057	4694	2	0	\N
255772	1678	8640245089000	9057	4694	3	0	\N
255773	1515	10603400	9057	4694	4	0	\N
255776	1874	201795000	9059	4696	0	0	\N
255777	1678	8640245091000	9059	4696	1	0	\N
255784	1678	8640245092000	9062	4697	0	0	\N
255785	1678	8640245093000	9062	4697	1	0	\N
255786	1874	201796000	9062	4697	2	0	\N
255787	1874	201797000	9062	4697	3	0	\N
255788	1960	200000000	9063	4698	0	0	\N
255789	1874	201798000	9063	4698	1	0	\N
255790	1678	8640245094000	9063	4698	2	0	\N
255803	1678	8640245098000	9069	4701	0	0	\N
255804	1874	201802000	9069	4701	1	0	\N
255686	1678	8640245075000	9039	4687	0	0	0
255687	1874	201779000	9039	4687	1	0	0
255690	1678	8640245076000	9041	4688	0	0	0
255691	1874	201780000	9041	4688	1	0	0
255697	1874	201781000	9044	4689	0	0	0
255699	1678	8640245077000	9044	4689	2	0	0
255700	1678	8640245078000	9044	4689	3	0	0
255701	1958	9000000000	9044	4689	4	0	0
255708	1874	201783000	9047	4690	0	0	0
255709	1874	201784000	9047	4690	1	0	0
255711	1678	8640245080000	9047	4690	3	0	0
255712	1678	8640245081000	9048	4691	0	0	0
255713	1821	279990000000	9048	4691	1	0	1
255714	1678	8640245082000	9048	4691	2	0	0
255716	1678	8640245084000	9048	4691	4	0	0
255717	1678	8640245085000	9048	4691	5	0	0
255718	1874	201785000	9048	4691	6	0	0
255719	1874	201786000	9048	4691	7	0	0
255720	1874	201787000	9048	4691	8	0	0
255722	1874	201788000	9048	4691	10	0	0
255723	1874	201789000	9048	4691	11	0	0
255724	1958	708998000000	9048	4691	12	0	0
255753	1874	201790000	9052	4692	0	0	0
255754	1678	8640245086000	9052	4692	1	0	0
255758	1678	8640245087000	9054	4693	1	0	0
255759	1678	8640245088000	9055	4694	0	0	0
255760	1874	201792000	9055	4694	1	0	0
255761	1874	201793000	9055	4694	2	0	0
255763	1515	10603400	9055	4694	4	0	1
255774	1678	8640245090000	9058	4695	0	0	0
255775	1874	201794000	9058	4695	1	0	0
255778	1874	201795000	9060	4696	0	0	0
255779	1678	8640245091000	9060	4696	1	0	0
255781	1678	8640245093000	9061	4697	1	0	0
255782	1874	201796000	9061	4697	2	0	0
255783	1874	201797000	9061	4697	3	0	0
255791	1960	200000000	9064	4698	0	0	0
255792	1874	201798000	9064	4698	1	0	0
255794	1678	8640245095000	9065	4699	0	0	0
255795	1874	201799000	9065	4699	1	0	0
255796	1961	281000000000	9067	4700	0	0	0
255797	1678	8640245096000	9067	4700	1	0	0
255799	1874	201800000	9067	4700	3	0	0
255800	1874	201801000	9067	4700	4	0	0
255801	1678	8640245098000	9068	4701	0	0	0
255802	1874	201802000	9068	4701	1	0	0
255805	1516	17533489191100	9070	4702	0	0	2
255807	1874	201804000	9070	4702	2	0	0
255808	1678	8640245099000	9070	4702	3	0	0
255809	1874	201805000	9070	4702	4	0	0
255810	1874	201806000	9070	4702	5	0	0
255811	1874	201807000	9070	4702	6	0	0
255813	1678	8640245101000	9070	4702	8	0	0
255814	1678	8640245102000	9070	4702	9	0	0
255815	1678	8640245103000	9070	4702	10	0	0
255816	1874	201808000	9071	4703	0	0	0
255836	928	505156545079092	9077	4708	0	0	\N
255837	1678	8640245110000	9077	4708	1	0	\N
255838	1678	8640245111000	9077	4708	2	0	\N
255839	1048	905236200600448	9077	4708	4	0	\N
255840	1168	610780902650622	9077	4708	5	0	\N
255841	1874	201814000	9077	4708	6	0	\N
255842	1874	201815000	9077	4708	7	0	\N
255843	1678	8640245112000	9078	4709	0	0	\N
255844	1874	201816000	9078	4709	1	0	\N
255850	1678	8640245113000	9081	4710	0	0	\N
255851	1962	281000000000	9081	4710	1	0	\N
255852	1874	201816000	9081	4710	2	0	\N
255853	1874	201817000	9081	4710	3	0	\N
255854	1678	8640245113000	9082	4710	0	0	\N
255855	1962	281000000000	9082	4710	1	0	\N
255856	1874	201816000	9082	4710	2	0	\N
255857	1678	8640245113000	9083	4710	0	0	\N
255858	1962	281000000000	9083	4710	1	0	\N
255859	1678	8640245114000	9084	4711	0	0	\N
255860	1963	1000000000	9084	4711	1	0	\N
255863	1483	0	9086	4687	0	0	\N
255864	1516	17533489191100	9086	4687	1	0	\N
255865	928	505156545079092	9086	4687	2	0	\N
255866	1678	8640245075000	9086	4687	3	0	\N
255867	1678	8640245076000	9086	4687	4	0	\N
255868	1961	281000000000	9086	4687	5	0	\N
255869	1821	279990000000	9086	4687	6	0	\N
255870	1962	281000000000	9086	4687	7	0	\N
255871	1048	905236200600448	9086	4687	8	0	\N
255872	1168	610780902650622	9086	4687	9	0	\N
255873	1874	201779000	9086	4687	10	0	\N
255874	1874	201780000	9086	4687	11	0	\N
255875	1874	201781000	9086	4687	12	0	\N
255876	1874	201782000	9086	4687	13	0	\N
255877	1874	201783000	9086	4687	14	0	\N
255878	1874	201784000	9086	4687	15	0	\N
255879	1678	8640245077000	9086	4687	16	0	\N
255880	1678	8640245078000	9086	4687	17	0	\N
255881	1678	8640245079000	9086	4687	18	0	\N
255882	1678	8640245080000	9086	4687	19	0	\N
255883	1678	8640245081000	9086	4687	20	0	\N
255884	1678	8640245082000	9086	4687	21	0	\N
255885	1678	8640245083000	9086	4687	22	0	\N
255886	1678	8640245084000	9086	4687	23	0	\N
255887	1678	8640245085000	9086	4687	24	0	\N
255888	1678	8640245086000	9086	4687	25	0	\N
255889	1678	8640245087000	9086	4687	26	0	\N
255890	1678	8640245088000	9086	4687	27	0	\N
255891	1678	8640245089000	9086	4687	28	0	\N
255892	1678	8640245090000	9086	4687	29	0	\N
255893	1678	8640245091000	9086	4687	30	0	\N
255894	1678	8640245092000	9086	4687	31	0	\N
255895	1678	8640245093000	9086	4687	32	0	\N
255896	1678	8640245094000	9086	4687	33	0	\N
255897	1678	8640245095000	9086	4687	34	0	\N
255903	772	1001000000000	9088	4488	0	0	\N
255904	772	1001000000000	9089	4713	0	0	\N
255905	1756	1907615575609	9089	4713	1	0	\N
255906	1678	8640245117000	9089	4713	2	0	\N
255907	1678	8640245118000	9089	4713	3	0	\N
255908	1678	8640245119000	9089	4713	4	0	\N
255909	1874	201820000	9089	4713	5	0	\N
255910	1874	201821000	9089	4713	6	0	\N
255911	1874	201822000	9089	4713	7	0	\N
255912	1964	200000000	9089	4713	8	0	\N
255913	1540	365307000000	9089	4713	9	0	\N
255914	1963	366305000000	9089	4713	10	0	\N
255926	772	1001000000000	9091	4713	0	0	\N
255927	1756	1907615575609	9091	4713	1	0	\N
255928	1678	8640245117000	9091	4713	2	0	\N
255929	1678	8640245118000	9091	4713	3	0	\N
255930	1678	8640245119000	9091	4713	4	0	\N
255931	1874	201820000	9091	4713	5	0	\N
255932	1874	201821000	9091	4713	6	0	\N
255933	1874	201822000	9091	4713	7	0	\N
255934	1964	200000000	9091	4713	8	0	\N
255935	1540	365307000000	9091	4713	9	0	\N
255936	1963	366305000000	9091	4713	10	0	\N
255937	772	1001000000000	9092	4713	0	0	\N
255938	1756	1907615575609	9092	4713	1	0	\N
255939	1678	8640245117000	9092	4713	2	0	\N
255940	1678	8640245118000	9092	4713	3	0	\N
255941	1678	8640245119000	9092	4713	4	0	\N
255942	1874	201820000	9092	4713	5	0	\N
255943	1874	201821000	9092	4713	6	0	\N
255944	1874	201822000	9092	4713	7	0	\N
255945	1964	200000000	9092	4713	8	0	\N
255946	1540	365307000000	9092	4713	9	0	\N
255947	1963	366305000000	9092	4713	10	0	\N
255948	772	1001000000000	9093	4501	0	0	\N
255949	772	1001000000000	9094	4515	0	0	\N
255950	772	1001000000000	9095	4528	0	0	\N
255951	1874	201823000	9096	4714	0	0	\N
255952	1678	8640245120000	9096	4714	1	0	\N
255819	1874	201809000	9072	4704	1	0	0
255820	1874	201810000	9072	4704	2	0	0
255821	1678	8640245105000	9072	4704	3	0	0
255822	1678	8640245106000	9072	4704	4	0	0
255823	1678	8640245107000	9073	4705	0	0	0
255825	1874	201812000	9074	4706	0	0	0
255826	1678	8640245108000	9074	4706	1	0	0
255827	1874	201813000	9075	4707	0	0	0
255828	1678	8640245109000	9075	4707	1	0	0
255829	928	505156545079092	9076	4708	0	0	0
255831	1678	8640245111000	9076	4708	2	0	0
255832	1048	905236200600448	9076	4708	4	0	0
255833	1168	610780902650622	9076	4708	5	0	0
255834	1874	201814000	9076	4708	6	0	0
255845	1678	8640245112000	9079	4709	0	0	0
255846	1678	8640245113000	9080	4710	0	0	0
255847	1962	281000000000	9080	4710	1	0	0
255848	1874	201816000	9080	4710	2	0	0
255849	1874	201817000	9080	4710	3	0	0
255862	1963	1000000000	9085	4711	1	0	0
255898	1294	1701995292845879	9087	4712	0	0	0
255899	1874	201818000	9087	4712	1	0	0
255900	1874	201819000	9087	4712	2	0	0
255901	1678	8640245115000	9087	4712	3	0	0
255915	772	1001000000000	9090	4713	0	0	0
255916	1756	1907615575609	9090	4713	1	0	3
255917	1678	8640245117000	9090	4713	2	0	0
255918	1678	8640245118000	9090	4713	3	0	0
255920	1874	201820000	9090	4713	5	0	0
255921	1874	201821000	9090	4713	6	0	0
255922	1874	201822000	9090	4713	7	0	0
255923	1964	200000000	9090	4713	8	0	0
255924	1540	365307000000	9090	4713	9	0	3
255955	1874	201823000	9098	4714	0	0	\N
255956	1678	8640245120000	9098	4714	1	0	\N
255962	1874	201826000	9101	4717	0	0	\N
255963	1678	8640245123000	9101	4717	1	0	\N
255966	1874	201826000	9103	4717	0	0	\N
255967	1678	8640245123000	9103	4717	1	0	\N
255968	1874	201826000	9104	4717	0	0	\N
255969	1678	8640245123000	9104	4717	1	0	\N
255974	1874	201828000	9107	4719	0	0	\N
255975	1678	8640245125000	9107	4719	1	0	\N
255976	1874	201829000	9108	4720	0	0	\N
255977	1678	8640245126000	9108	4720	1	0	\N
255978	1874	201829000	9109	4720	0	0	\N
255979	1678	8640245126000	9109	4720	1	0	\N
255988	1678	8640245128000	9113	4722	0	0	\N
255989	1678	8640245129000	9113	4722	1	0	\N
255990	1874	201831000	9113	4722	2	0	\N
255991	1874	201832000	9113	4722	3	0	\N
255996	1874	201835000	9116	4724	0	0	\N
255997	1874	201836000	9116	4724	1	0	\N
255998	1678	8640245132000	9116	4724	2	0	\N
255999	1678	8640245133000	9116	4724	3	0	\N
256000	1874	201835000	9117	4724	0	0	\N
256001	1874	201836000	9117	4724	1	0	\N
256002	1678	8640245132000	9117	4724	2	0	\N
256003	1678	8640245133000	9117	4724	3	0	\N
256008	1874	201835000	9119	4724	0	0	\N
256009	1874	201836000	9119	4724	1	0	\N
256010	1678	8640245132000	9119	4724	2	0	\N
256011	1678	8640245133000	9119	4724	3	0	\N
256012	1678	8640245134000	9121	4725	0	0	\N
256013	1874	201837000	9121	4725	1	0	\N
256014	1678	8640245134000	9122	4725	0	0	\N
256015	1874	201837000	9122	4725	1	0	\N
256022	1678	8640245135000	9125	4726	0	0	\N
256023	1678	8640245136000	9125	4726	1	0	\N
256024	1874	201838000	9125	4726	2	0	\N
256025	1874	201839000	9125	4726	3	0	\N
256026	1678	8640245137000	9126	4727	0	0	\N
256027	1874	201840000	9126	4727	1	0	\N
256030	1483	0	9128	4600	0	0	\N
256031	1516	17533489191100	9128	4600	1	0	\N
256032	772	1001000000000	9128	4600	2	0	\N
256033	928	505156545079092	9128	4600	3	0	\N
256034	1961	281000000000	9128	4600	4	0	\N
256035	1932	217990000000	9128	4600	5	0	\N
256036	1821	279990000000	9128	4600	6	0	\N
256037	1962	281000000000	9128	4600	7	0	\N
256038	1048	905236200600448	9128	4600	8	0	\N
256039	1168	610780902650622	9128	4600	9	0	\N
256040	1957	10000000	9128	4600	10	0	\N
256041	44	81840990000000	9128	4600	11	0	\N
256042	1515	10603400	9128	4600	13	0	\N
256043	1963	1000000000	9128	4600	14	0	\N
256044	1963	366306000000	9128	4600	15	0	\N
256045	1958	9000000000	9128	4600	16	0	\N
256046	1958	708998000000	9128	4600	17	0	\N
256051	1678	8640245140000	9130	4729	0	0	\N
256056	1678	8640245141000	9133	4730	0	0	\N
256057	1874	201844000	9133	4730	1	0	\N
256062	1678	8640245143000	9136	4732	0	0	\N
256063	1874	201846000	9136	4732	1	0	\N
256066	1874	201848000	9138	4734	0	0	\N
256067	1678	8640245145000	9138	4734	1	0	\N
256079	1965	200000000	9143	4737	0	0	\N
256080	1678	8640245148000	9143	4737	1	0	\N
256081	1678	8640245149000	9143	4737	2	0	\N
256082	1874	201851000	9143	4737	3	0	\N
256083	1874	201852000	9143	4737	4	0	\N
255957	55	68159050000000	9099	4715	0	0	1
255958	1678	8640245121000	9099	4715	1	0	0
255959	1874	201824000	9099	4715	2	0	0
255960	1678	8640245122000	9100	4716	0	0	0
255961	1874	201825000	9100	4716	1	0	0
255965	1678	8640245123000	9102	4717	1	0	0
255970	1678	8640245124000	9105	4718	0	0	0
255971	1874	201827000	9105	4718	1	0	0
255972	1874	201828000	9106	4719	0	0	0
255973	1678	8640245125000	9106	4719	1	0	0
255981	1678	8640245126000	9110	4720	1	0	0
255982	1678	8640245127000	9111	4721	0	0	0
255983	1874	201830000	9111	4721	1	0	0
255984	1678	8640245128000	9112	4722	0	0	0
255986	1874	201831000	9112	4722	2	0	0
255987	1874	201832000	9112	4722	3	0	0
255992	1678	8640245130000	9114	4723	0	0	0
255993	1874	201833000	9114	4723	1	0	0
255994	1678	8640245131000	9114	4723	2	0	0
256004	1874	201835000	9118	4724	0	0	0
256005	1874	201836000	9118	4724	1	0	0
256006	1678	8640245132000	9118	4724	2	0	0
256007	1678	8640245133000	9118	4724	3	0	0
256016	1678	8640245134000	9123	4725	0	0	0
256018	1678	8640245135000	9124	4726	0	0	0
256019	1678	8640245136000	9124	4726	1	0	0
256020	1874	201838000	9124	4726	2	0	0
256021	1874	201839000	9124	4726	3	0	0
256029	1874	201840000	9127	4727	1	0	0
256047	1874	201841000	9129	4728	0	0	0
256048	1874	201842000	9129	4728	1	0	0
256049	1678	8640245138000	9129	4728	2	0	0
256050	1678	8640245139000	9129	4728	3	0	0
256053	1874	201843000	9131	4729	1	0	0
256054	1678	8640245141000	9132	4730	0	0	0
256055	1874	201844000	9132	4730	1	0	0
256058	1678	8640245142000	9134	4731	0	0	0
256059	1874	201845000	9134	4731	1	0	0
256061	1874	201846000	9135	4732	1	0	0
256064	1678	8640245144000	9137	4733	0	0	0
256065	1874	201847000	9137	4733	2	0	0
256068	1874	201848000	9139	4734	0	0	0
256070	1678	8640245146000	9140	4735	0	0	0
256071	1874	201849000	9140	4735	1	0	0
256072	1678	8640245147000	9141	4736	0	0	0
256073	1874	201850000	9141	4736	1	0	0
256074	1965	200000000	9142	4737	0	0	0
256076	1678	8640245149000	9142	4737	2	0	0
256077	1874	201851000	9142	4737	3	0	0
256078	1874	201852000	9142	4737	4	0	0
256084	1678	8640245150000	9144	4738	0	0	0
256085	1874	201853000	9144	4738	1	0	0
256087	1678	8640245151000	9144	4738	3	0	0
256088	1678	8640245152000	9144	4738	4	0	0
256091	1874	201856000	9145	4739	0	0	\N
256092	1678	8640245153000	9145	4739	1	0	\N
256093	1678	8640245154000	9145	4739	2	0	\N
256094	1874	201857000	9145	4739	3	0	\N
256095	1874	201856000	9146	4739	0	0	\N
256096	1678	8640245153000	9146	4739	1	0	\N
256097	1678	8640245154000	9146	4739	2	0	\N
256098	1874	201857000	9146	4739	3	0	\N
256099	1874	201856000	9147	4739	0	0	\N
256100	1678	8640245153000	9147	4739	1	0	\N
256101	1678	8640245154000	9147	4739	2	0	\N
256102	1874	201857000	9147	4739	3	0	\N
256111	1874	201858000	9150	4740	0	0	\N
256112	1678	8640245155000	9150	4740	1	0	\N
256113	1678	8640245156000	9150	4740	2	0	\N
256114	1874	201859000	9150	4740	3	0	\N
256117	1874	201860000	9152	4741	0	0	\N
256118	1678	8640245157000	9152	4741	1	0	\N
256121	1874	201862000	9154	4743	0	0	\N
256122	1678	8640245159000	9154	4743	1	0	\N
256127	1874	201864000	9157	4745	0	0	\N
256128	1678	8640245161000	9157	4745	1	0	\N
256133	1874	201865000	9160	4746	0	0	\N
256134	1678	8640245162000	9160	4746	1	0	\N
256143	1874	201870000	9162	4748	0	0	\N
256144	1874	201871000	9162	4748	1	0	\N
256145	1678	8640245167000	9162	4748	2	0	\N
256146	1678	8640245168000	9162	4748	3	0	\N
256157	1678	8640245171000	9167	4751	0	0	\N
256158	1874	201874000	9167	4751	1	0	\N
256159	1874	201875000	9169	4752	0	0	\N
256160	1678	8640245172000	9169	4752	1	0	\N
256166	1678	8640245173000	9172	4753	0	0	\N
256167	1874	201876000	9172	4753	1	0	\N
256168	277	66000010000000	9172	4753	2	0	\N
256181	1678	8640245177000	9176	4756	0	0	\N
256182	1874	201880000	9176	4756	1	0	\N
256183	1678	8640245177000	9177	4756	0	0	\N
256184	1874	201880000	9177	4756	1	0	\N
256185	1678	8640245177000	9178	4756	0	0	\N
256186	1874	201880000	9178	4756	1	0	\N
256193	1678	8640245178000	9180	4757	0	0	\N
256194	1874	201881000	9180	4757	1	0	\N
256195	1874	201882000	9180	4757	2	0	\N
256196	1874	201883000	9180	4757	3	0	\N
256197	1678	8640245179000	9180	4757	5	0	\N
256198	1678	8640245180000	9180	4757	6	0	\N
256199	1678	8640245178000	9181	4757	0	0	\N
256200	1874	201881000	9181	4757	1	0	\N
256201	1874	201882000	9181	4757	2	0	\N
256202	1874	201883000	9181	4757	3	0	\N
256203	1678	8640245179000	9181	4757	5	0	\N
256204	1678	8640245180000	9181	4757	6	0	\N
256216	1678	8640245187000	9186	4762	0	0	\N
256217	1678	8640245188000	9186	4762	1	0	\N
256218	1874	201889000	9186	4762	2	0	\N
256219	1874	201890000	9186	4762	3	0	\N
256220	1678	8640245187000	9187	4762	0	0	\N
256221	1678	8640245188000	9187	4762	1	0	\N
256222	1874	201889000	9187	4762	2	0	\N
256223	1874	201890000	9187	4762	3	0	\N
256103	1874	201856000	9148	4739	0	0	0
256104	1678	8640245153000	9148	4739	1	0	0
256105	1678	8640245154000	9148	4739	2	0	0
256106	1874	201857000	9148	4739	3	0	0
256107	1874	201858000	9149	4740	0	0	0
256109	1678	8640245156000	9149	4740	2	0	0
256110	1874	201859000	9149	4740	3	0	0
256115	1874	201860000	9151	4741	0	0	0
256116	1678	8640245157000	9151	4741	1	0	0
256119	1874	201861000	9153	4742	0	0	0
256123	1874	201862000	9155	4743	0	0	0
256124	1678	8640245159000	9155	4743	1	0	0
256125	1874	201863000	9156	4744	0	0	0
256126	1678	8640245160000	9156	4744	1	0	0
256130	1678	8640245161000	9158	4745	1	0	0
256131	1874	201865000	9159	4746	0	0	0
256132	1678	8640245162000	9159	4746	1	0	0
256135	1678	8640245163000	9161	4747	0	0	0
256136	1678	8640245164000	9161	4747	1	0	0
256138	1678	8640245166000	9161	4747	3	0	0
256139	1874	201866000	9161	4747	4	0	0
256140	1874	201867000	9161	4747	5	0	0
256141	1874	201868000	9161	4747	6	0	0
256142	1874	201869000	9161	4747	7	0	0
256148	1874	201871000	9163	4748	1	0	0
256149	1678	8640245167000	9163	4748	2	0	0
256150	1678	8640245168000	9163	4748	3	0	0
256151	1678	8640245169000	9164	4749	0	0	0
256153	1874	201873000	9165	4750	0	0	0
256154	1678	8640245170000	9165	4750	1	0	0
256155	1678	8640245171000	9166	4751	0	0	0
256156	1874	201874000	9166	4751	1	0	0
256161	1874	201875000	9170	4752	0	0	0
256163	1678	8640245173000	9171	4753	0	0	0
256164	1874	201876000	9171	4753	1	0	0
256165	277	66000010000000	9171	4753	2	0	0
256169	1678	8640245174000	9173	4754	0	0	0
256170	1874	201877000	9173	4754	1	0	0
256172	668	66000010000000	9173	4754	3	0	0
256173	1678	8640245175000	9174	4755	0	0	0
256174	1678	8640245176000	9174	4755	1	0	0
256175	1483	0	9174	4755	2	0	0
256177	1874	201878000	9174	4755	4	0	0
256178	1874	201879000	9174	4755	5	0	0
256179	1678	8640245177000	9175	4756	0	0	0
256180	1874	201880000	9175	4756	1	0	0
256187	1678	8640245178000	9179	4757	0	0	0
256189	1874	201882000	9179	4757	2	0	0
256190	1874	201883000	9179	4757	3	0	0
256191	1678	8640245179000	9179	4757	5	0	0
256192	1678	8640245180000	9179	4757	6	0	0
256205	1874	201884000	9182	4758	0	0	0
256207	1678	8640245182000	9183	4759	0	0	0
256208	1874	201885000	9183	4759	1	0	0
256209	1678	8640245183000	9184	4760	0	0	0
256210	1678	8640245184000	9184	4760	1	0	0
256212	1874	201886000	9184	4760	3	0	0
256213	1874	201887000	9184	4760	4	0	0
256214	1874	201888000	9185	4761	0	0	0
256215	1678	8640245186000	9185	4761	1	0	0
256224	1678	8640245187000	9188	4762	0	0	0
256228	1874	201891000	9189	4763	0	0	\N
256229	1874	201892000	9189	4763	1	0	\N
256230	1678	8640245189000	9189	4763	2	0	\N
256231	1678	8640245190000	9189	4763	3	0	\N
256236	1874	201891000	9191	4763	0	0	\N
256237	1874	201892000	9191	4763	1	0	\N
256238	1678	8640245189000	9191	4763	2	0	\N
256239	1678	8640245190000	9191	4763	3	0	\N
256240	277	66000010000000	9192	4601	0	0	\N
256241	425	66000010000000	9192	4601	1	0	\N
256242	668	66000010000000	9192	4601	2	0	\N
256256	278	66254578500000	9196	4766	0	0	\N
256257	1874	201895000	9196	4766	1	0	\N
256258	178	66254578500000	9196	4766	2	0	\N
256259	1678	8640245193000	9196	4766	3	0	\N
256260	1483	0	9197	4570	0	0	\N
256261	1516	17533489191100	9197	4570	1	0	\N
256262	772	1001000000000	9197	4570	2	0	\N
256263	928	505156545079092	9197	4570	3	0	\N
256264	1961	281000000000	9197	4570	4	0	\N
256265	1678	8640245001000	9197	4570	5	0	\N
256266	761	1003857250000	9197	4570	6	0	\N
256267	1678	8640245002000	9197	4570	7	0	\N
256268	1932	217990000000	9197	4570	8	0	\N
256269	1678	8640245003000	9197	4570	9	0	\N
256270	1821	279990000000	9197	4570	10	0	\N
256271	1678	8640245004000	9197	4570	11	0	\N
256272	1678	8640245005000	9197	4570	12	0	\N
256273	1678	8640245006000	9197	4570	13	0	\N
256274	716	3011571750000	9197	4570	14	0	\N
256275	1962	281000000000	9197	4570	15	0	\N
256276	517	66254578500000	9197	4570	16	0	\N
256277	509	66254578500000	9197	4570	17	0	\N
256278	463	66254578500000	9197	4570	18	0	\N
256279	278	66254578500000	9197	4570	19	0	\N
256280	178	66254578500000	9197	4570	20	0	\N
256281	1048	905236200600448	9197	4570	21	0	\N
256282	1168	610780902650622	9197	4570	22	0	\N
256283	1678	8640245007000	9197	4570	23	0	\N
256284	1678	8640245008000	9197	4570	24	0	\N
256285	1678	8640245009000	9197	4570	25	0	\N
256286	1678	8640245010000	9197	4570	26	0	\N
256287	1678	8640245011000	9197	4570	27	0	\N
256288	1678	8640245012000	9197	4570	28	0	\N
256289	1678	8640245013000	9197	4570	29	0	\N
256290	1678	8640245014000	9197	4570	30	0	\N
256291	1678	8640245015000	9197	4570	31	0	\N
256292	1678	8640245016000	9197	4570	32	0	\N
256293	1678	8640245017000	9197	4570	33	0	\N
256294	1678	8640245018000	9197	4570	34	0	\N
256295	1678	8640245019000	9197	4570	35	0	\N
256296	1678	8640245020000	9197	4570	36	0	\N
256297	1678	8640245021000	9197	4570	37	0	\N
256298	1678	8640245022000	9197	4570	38	0	\N
256299	1678	8640245023000	9197	4570	39	0	\N
256300	1678	8640245024000	9197	4570	40	0	\N
256301	1678	8640245025000	9197	4570	41	0	\N
256302	1678	8640245026000	9197	4570	42	0	\N
256303	1678	8640245027000	9197	4570	43	0	\N
256304	1678	8640245028000	9197	4570	44	0	\N
256305	1678	8640245029000	9197	4570	45	0	\N
256306	1678	8640245030000	9197	4570	46	0	\N
256307	1678	8640245031000	9197	4570	47	0	\N
256308	1678	8640245032000	9197	4570	48	0	\N
256309	1678	8640245033000	9197	4570	49	0	\N
256310	1678	8640245034000	9197	4570	50	0	\N
256311	1678	8640245035000	9197	4570	51	0	\N
256312	1678	8640245036000	9197	4570	52	0	\N
256313	1678	8640245037000	9197	4570	53	0	\N
256314	1678	8640245038000	9197	4570	54	0	\N
256315	1678	8640245039000	9197	4570	55	0	\N
256316	1678	8640245040000	9197	4570	56	0	\N
256317	1678	8640245041000	9197	4570	57	0	\N
256318	1678	8640245042000	9197	4570	58	0	\N
256319	1678	8640245043000	9197	4570	59	0	\N
256320	1678	8640245044000	9197	4570	60	0	\N
256321	1678	8640245045000	9197	4570	61	0	\N
256322	1678	8640245046000	9197	4570	62	0	\N
256323	1678	8640245047000	9197	4570	63	0	\N
256324	1678	8640245048000	9197	4570	64	0	\N
256325	1678	8640245049000	9197	4570	65	0	\N
256326	1678	8640245050000	9197	4570	66	0	\N
256327	1678	8640245051000	9197	4570	68	0	\N
256328	1678	8640245052000	9197	4570	69	0	\N
256329	1678	8640245053000	9197	4570	70	0	\N
256330	1678	8640245054000	9197	4570	71	0	\N
256331	1678	8640245055000	9197	4570	72	0	\N
256332	1678	8640245056000	9197	4570	73	0	\N
256333	1678	8640245057000	9197	4570	74	0	\N
256334	1678	8640245058000	9197	4570	75	0	\N
256335	1678	8640245059000	9197	4570	76	0	\N
256336	1678	8640245060000	9197	4570	77	0	\N
256337	1678	8640245061000	9197	4570	78	0	\N
256338	1678	8640245062000	9197	4570	79	0	\N
256339	1678	8640245063000	9197	4570	80	0	\N
256340	1678	8640245064000	9197	4570	81	0	\N
256341	1678	8640245065000	9197	4570	82	0	\N
256342	1678	8640245066000	9197	4570	83	0	\N
256343	1678	8640245067000	9197	4570	84	0	\N
256344	1678	8640245068000	9197	4570	85	0	\N
256345	1678	8640245069000	9197	4570	86	0	\N
256346	1678	8640245070000	9197	4570	87	0	\N
256347	1678	8640245071000	9197	4570	88	0	\N
256348	1678	8640245072000	9197	4570	89	0	\N
256349	1678	8640245073000	9197	4570	90	0	\N
256350	1678	8640245074000	9197	4570	91	0	\N
256351	1678	8640245075000	9197	4570	92	0	\N
256352	1678	8640245076000	9197	4570	93	0	\N
256353	1678	8640245077000	9197	4570	94	0	\N
256354	1678	8640245078000	9197	4570	95	0	\N
256355	1678	8640245079000	9197	4570	96	0	\N
256356	1678	8640245080000	9197	4570	97	0	\N
256357	1678	8640245081000	9197	4570	98	0	\N
256358	1678	8640245082000	9197	4570	99	0	\N
256359	1678	8640245083000	9197	4570	100	0	\N
256360	1678	8640245084000	9197	4570	101	0	\N
256227	1874	201890000	9188	4762	3	0	0
256232	1874	201891000	9190	4763	0	0	0
256233	1874	201892000	9190	4763	1	0	0
256234	1678	8640245189000	9190	4763	2	0	0
256235	1678	8640245190000	9190	4763	3	0	0
256244	1678	8640245191000	9193	4764	1	0	0
256245	1874	201893000	9193	4764	2	0	0
256246	1874	201894000	9194	4765	0	0	0
256247	716	3011571750000	9194	4765	1	0	0
256248	517	66254578500000	9194	4765	2	0	0
256250	463	66254578500000	9194	4765	4	0	0
256251	1678	8640245192000	9194	4765	5	0	0
256252	278	66254578500000	9195	4766	0	0	0
256253	1874	201895000	9195	4766	1	0	0
256255	1678	8640245193000	9195	4766	3	0	0
256361	1678	8640245085000	9197	4570	102	0	\N
256362	1678	8640245086000	9197	4570	103	0	\N
256363	1678	8640245087000	9197	4570	104	0	\N
256364	1678	8640245088000	9197	4570	105	0	\N
256365	1678	8640245089000	9197	4570	106	0	\N
256366	1678	8640245090000	9197	4570	107	0	\N
256367	1678	8640245091000	9197	4570	108	0	\N
256368	1678	8640245092000	9197	4570	109	0	\N
256369	1678	8640245093000	9197	4570	110	0	\N
256370	1678	8640245094000	9197	4570	111	0	\N
256371	1678	8640245095000	9197	4570	112	0	\N
256372	1678	8640245096000	9197	4570	113	0	\N
256373	1678	8640245097000	9197	4570	114	0	\N
256374	1678	8640245098000	9197	4570	115	0	\N
256375	1678	8640245099000	9197	4570	116	0	\N
256376	1678	8640245100000	9197	4570	117	0	\N
256377	1678	8640245101000	9197	4570	118	0	\N
256378	1678	8640245102000	9197	4570	119	0	\N
256379	1678	8640245103000	9197	4570	120	0	\N
256380	1678	8640245104000	9197	4570	121	0	\N
256381	1678	8640245105000	9197	4570	122	0	\N
256382	1678	8640245106000	9197	4570	123	0	\N
256383	1678	8640245107000	9197	4570	124	0	\N
256388	1678	8640245196000	9200	4769	0	0	\N
256389	1874	201898000	9200	4769	1	0	\N
256398	1874	201902000	9205	4773	0	0	\N
256399	1874	201903000	9205	4773	1	0	\N
256400	1874	201904000	9205	4773	2	0	\N
256401	1874	201905000	9205	4773	3	0	\N
256402	1678	8640245200000	9205	4773	4	0	\N
256403	1678	8640245201000	9205	4773	5	0	\N
256404	1678	8640245202000	9205	4773	6	0	\N
256405	1678	8640245203000	9205	4773	7	0	\N
256425	1678	8640245208000	9211	4778	0	0	\N
256426	1874	201910000	9211	4778	1	0	\N
256427	1678	8640245209000	9211	4778	2	0	\N
256428	1874	201911000	9211	4778	3	0	\N
256433	1678	8640245208000	9213	4778	0	0	\N
256434	1874	201910000	9213	4778	1	0	\N
256435	1678	8640245209000	9213	4778	2	0	\N
256436	1874	201911000	9213	4778	3	0	\N
256437	1678	8640245208000	9214	4778	0	0	\N
256438	1874	201910000	9214	4778	1	0	\N
256439	1678	8640245209000	9214	4778	2	0	\N
256440	1874	201911000	9214	4778	3	0	\N
256447	1678	8640245210000	9216	4779	0	0	\N
256448	1678	8640245211000	9216	4779	1	0	\N
256449	1678	8640245212000	9216	4779	2	0	\N
256450	1874	201912000	9216	4779	3	0	\N
256451	1874	201913000	9216	4779	4	0	\N
256452	1874	201914000	9216	4779	5	0	\N
256453	1678	8640245210000	9217	4779	0	0	\N
256454	1678	8640245211000	9217	4779	1	0	\N
256455	1678	8640245212000	9217	4779	2	0	\N
256456	1874	201912000	9217	4779	3	0	\N
256457	1874	201913000	9217	4779	4	0	\N
256458	1874	201914000	9217	4779	5	0	\N
256459	1678	8640245213000	9218	4780	0	0	\N
256460	1678	8640245214000	9218	4780	1	0	\N
256461	1874	201915000	9218	4780	2	0	\N
256462	1874	201916000	9218	4780	3	0	\N
256467	1874	201917000	9220	4781	0	0	\N
256468	1678	8640245215000	9220	4781	1	0	\N
256471	1874	201917000	9222	4781	0	0	\N
256472	1678	8640245215000	9222	4781	1	0	\N
256475	1874	201918000	9224	4782	0	0	\N
256476	1678	8640245216000	9224	4782	1	0	\N
256477	1874	201918000	9225	4782	0	0	\N
256478	1678	8640245216000	9225	4782	1	0	\N
256479	1968	200000000	9226	4783	0	0	\N
256480	1874	201919000	9226	4783	1	0	\N
256481	1678	8640245217000	9226	4783	2	0	\N
256482	1967	360451500000	9227	4775	0	0	\N
256483	1968	200000000	9228	4783	0	0	\N
256484	1874	201919000	9228	4783	1	0	\N
256485	1678	8640245217000	9228	4783	2	0	\N
256486	1968	200000000	9229	4783	0	0	\N
256487	1874	201919000	9229	4783	1	0	\N
256488	1678	8640245217000	9229	4783	2	0	\N
256386	1874	201897000	9199	4768	0	0	0
256387	1678	8640245195000	9199	4768	1	0	0
256390	1678	8640245196000	9201	4769	0	0	0
256391	1874	201898000	9201	4769	1	0	0
256392	1874	201899000	9202	4770	0	0	0
256394	1874	201900000	9203	4771	0	0	0
256395	1678	8640245198000	9203	4771	1	0	0
256396	1678	8640245199000	9204	4772	0	0	0
256397	1874	201901000	9204	4772	1	0	0
256406	1874	201902000	9206	4773	0	0	0
256408	1874	201904000	9206	4773	2	0	0
256409	1874	201905000	9206	4773	3	0	0
256410	1678	8640245200000	9206	4773	4	0	0
256411	1678	8640245201000	9206	4773	5	0	0
256413	1678	8640245203000	9206	4773	7	0	0
256414	62	66254578500000	9207	4774	0	0	0
256415	59	66254578500000	9207	4774	1	0	0
256416	1678	8640245204000	9207	4774	2	0	0
256417	1874	201906000	9207	4774	3	0	0
256419	1874	201907000	9208	4775	1	0	0
256420	1678	8640245206000	9209	4776	0	0	0
256421	1874	201908000	9209	4776	1	0	0
256422	1678	8640245207000	9210	4777	0	0	0
256423	1874	201909000	9210	4777	1	0	0
256429	1678	8640245208000	9212	4778	0	0	0
256430	1874	201910000	9212	4778	1	0	0
256431	1678	8640245209000	9212	4778	2	0	0
256432	1874	201911000	9212	4778	3	0	0
256442	1678	8640245211000	9215	4779	1	0	0
256443	1678	8640245212000	9215	4779	2	0	0
256444	1874	201912000	9215	4779	3	0	0
256445	1874	201913000	9215	4779	4	0	0
256446	1874	201914000	9215	4779	5	0	0
256464	1678	8640245214000	9219	4780	1	0	0
256465	1874	201915000	9219	4780	2	0	0
256466	1874	201916000	9219	4780	3	0	0
256469	1874	201917000	9221	4781	0	0	0
256470	1678	8640245215000	9221	4781	1	0	0
256474	1678	8640245216000	9223	4782	1	0	0
256489	1968	200000000	9230	4783	0	0	0
256490	1874	201919000	9230	4783	1	0	0
256491	1678	8640245217000	9230	4783	2	0	0
256493	1678	8640245219000	9232	4785	0	0	0
256494	1874	201920000	9232	4785	1	0	0
256495	1678	8640245220000	9233	4786	0	0	0
256496	1874	201921000	9233	4786	1	0	0
256501	1678	8640245222000	9236	4788	0	0	\N
256502	1874	201923000	9236	4788	1	0	\N
256515	1874	201930000	9242	4794	0	0	\N
256516	1678	8640245229000	9242	4794	1	0	\N
256517	910	505400512229673	9242	4794	2	0	\N
256518	1874	201930000	9243	4794	0	0	\N
256519	1678	8640245229000	9243	4794	1	0	\N
256520	910	505400512229673	9243	4794	2	0	\N
256521	1874	201930000	9244	4794	0	0	\N
256522	1678	8640245229000	9244	4794	1	0	\N
256523	910	505400512229673	9244	4794	2	0	\N
256581	1678	8640245238000	9250	4799	0	0	\N
256582	1874	201939000	9250	4799	1	0	\N
256583	1678	8640245239000	9250	4799	2	0	\N
256584	1678	8640245240000	9250	4799	3	0	\N
256585	438	66344300665601	9250	4799	4	0	\N
256586	593	66344300665601	9250	4799	5	0	\N
256587	408	66344300665601	9250	4799	7	0	\N
256588	1874	201940000	9250	4799	8	0	\N
256589	373	66344300665601	9250	4799	9	0	\N
256590	322	66344300665601	9250	4799	10	0	\N
256591	453	66344300665601	9250	4799	11	0	\N
256592	450	66344300665601	9250	4799	12	0	\N
256593	63	66344300665601	9250	4799	13	0	\N
256594	1874	201941000	9250	4799	14	0	\N
256595	601	66344300665601	9250	4799	15	0	\N
256596	92	66344300665601	9250	4799	16	0	\N
256597	150	66344300665601	9250	4799	17	0	\N
256598	309	66344300665601	9250	4799	18	0	\N
256599	680	66344300665601	9250	4799	19	0	\N
256600	731	2010433353450	9250	4799	20	0	\N
256601	82	66344300665601	9250	4799	21	0	\N
256602	163	66344300665601	9250	4799	22	0	\N
256603	275	66344300665601	9250	4799	23	0	\N
256604	361	66344300665601	9250	4799	24	0	\N
256629	1678	8640245169000	9252	4749	0	0	\N
256630	1874	201872000	9252	4749	1	0	\N
256631	761	1003857250000	9252	4749	2	0	\N
256632	1874	201873000	9252	4749	3	0	\N
256499	1678	8640245222000	9235	4788	0	0	0
256500	1874	201923000	9235	4788	1	0	0
256503	1874	201924000	9237	4789	0	0	0
256504	1678	8640245223000	9237	4789	1	0	0
256505	1678	8640245224000	9237	4789	2	0	0
256507	1678	8640245225000	9238	4790	0	0	0
256508	1874	201926000	9238	4790	1	0	0
256509	1874	201927000	9239	4791	0	0	0
256510	1678	8640245226000	9239	4791	1	0	0
256511	1678	8640245227000	9240	4792	0	0	0
256513	1874	201929000	9241	4793	0	0	0
256514	1678	8640245228000	9241	4793	1	0	0
256524	1874	201930000	9245	4794	0	0	0
256525	1678	8640245229000	9245	4794	1	0	0
256527	1874	201931000	9246	4795	0	0	0
256528	500	66344300665601	9246	4795	1	0	0
256529	1874	201932000	9246	4795	2	0	0
256530	587	66344300665601	9246	4795	3	0	0
256531	146	66344300665601	9246	4795	4	0	0
256533	611	66344300665601	9246	4795	6	0	0
256534	29	7036516737238	9246	4795	7	0	0
256535	1678	8640245230000	9246	4795	8	0	0
256536	1678	8640245231000	9246	4795	9	0	0
256537	1678	8640245232000	9247	4796	0	0	0
256539	1874	201934000	9247	4796	2	0	0
256540	1874	201935000	9247	4796	3	0	0
256541	1678	8640245233000	9247	4796	4	0	0
256542	138	66344300665601	9247	4796	5	0	0
256544	1678	8640245234000	9247	4796	7	0	0
256545	78	66344300665601	9247	4796	8	0	0
256546	1811	938190609615	9247	4796	9	0	1
256547	504	66344300665601	9247	4796	10	0	0
256548	658	66344300665601	9247	4796	11	0	0
256550	660	66344300665601	9247	4796	13	0	0
256551	1276	1702817277527660	9247	4796	14	0	0
256552	194	66344300665601	9247	4796	15	0	0
256553	304	66344300665601	9247	4796	16	0	0
256554	206	66344300665601	9247	4796	17	0	0
256556	1772	2461166133031	9247	4796	19	0	1
256557	1874	201936000	9248	4797	0	0	0
256558	1678	8640245235000	9248	4797	1	0	0
256559	105	66344300665601	9248	4797	2	0	0
256561	622	66347280665601	9248	4797	4	0	1
256562	520	66344300665601	9248	4797	5	0	0
256563	551	66344300665601	9248	4797	6	0	0
256564	295	66344300665601	9248	4797	7	0	0
256565	1874	201937000	9249	4798	0	0	0
256567	1678	8640245236000	9249	4798	2	0	0
256568	1678	8640245237000	9249	4798	3	0	0
256569	653	66344300665601	9249	4798	4	0	0
256570	721	2010433353450	9249	4798	5	0	0
256571	308	66344300665601	9249	4798	6	0	0
256573	84	66344300665601	9249	4798	8	0	0
256574	89	66344300665601	9249	4798	9	0	0
256575	186	66344300665601	9249	4798	10	0	0
256576	383	66344300665601	9249	4798	11	0	0
256578	678	66344300665601	9249	4798	13	0	0
256579	339	66344300665601	9249	4798	14	0	0
256580	91	66344300665601	9249	4798	15	0	0
256605	1678	8640245238000	9251	4799	0	0	0
256606	1874	201939000	9251	4799	1	0	0
256608	1678	8640245240000	9251	4799	3	0	0
256609	438	66344300665601	9251	4799	4	0	0
256610	593	66344300665601	9251	4799	5	0	0
256611	408	66344300665601	9251	4799	7	0	0
256612	1874	201940000	9251	4799	8	0	0
256614	322	66344300665601	9251	4799	10	0	0
256615	453	66344300665601	9251	4799	11	0	0
256616	450	66344300665601	9251	4799	12	0	0
256617	63	66344300665601	9251	4799	13	0	0
256619	601	66344300665601	9251	4799	15	0	0
256620	92	66344300665601	9251	4799	16	0	0
256621	150	66344300665601	9251	4799	17	0	0
256622	309	66344300665601	9251	4799	18	0	0
256623	680	66344300665601	9251	4799	19	0	0
256625	82	66344300665601	9251	4799	21	0	0
256626	163	66344300665601	9251	4799	22	0	0
256627	275	66344300665601	9251	4799	23	0	0
256628	361	66344300665601	9251	4799	24	0	0
256633	1874	201874000	9252	4749	4	0	\N
256634	1874	201875000	9252	4749	5	0	\N
256635	1874	201876000	9252	4749	6	0	\N
256636	716	3011571750000	9252	4749	7	0	\N
256637	910	505400512229673	9252	4749	8	0	\N
256638	500	66344300665601	9252	4749	9	0	\N
256639	1874	201877000	9252	4749	10	0	\N
256640	517	66254578500000	9252	4749	11	0	\N
256641	509	66254578500000	9252	4749	12	0	\N
256642	463	66254578500000	9252	4749	13	0	\N
256643	278	66254578500000	9252	4749	14	0	\N
256644	178	66254578500000	9252	4749	15	0	\N
256645	62	66254578500000	9252	4749	16	0	\N
256646	1678	8640245170000	9252	4749	17	0	\N
256647	1678	8640245171000	9252	4749	18	0	\N
256648	1678	8640245172000	9252	4749	19	0	\N
256649	1678	8640245173000	9252	4749	20	0	\N
256650	1678	8640245174000	9252	4749	21	0	\N
256651	1678	8640245175000	9252	4749	22	0	\N
256652	1678	8640245176000	9252	4749	23	0	\N
256653	1678	8640245177000	9252	4749	24	0	\N
256654	1678	8640245178000	9252	4749	25	0	\N
256655	1678	8640245179000	9252	4749	26	0	\N
256656	1678	8640245180000	9252	4749	27	0	\N
256657	1678	8640245181000	9252	4749	28	0	\N
256658	1678	8640245182000	9252	4749	29	0	\N
256659	1678	8640245183000	9252	4749	30	0	\N
256660	1678	8640245184000	9252	4749	31	0	\N
256661	1678	8640245185000	9252	4749	32	0	\N
256662	1678	8640245186000	9252	4749	33	0	\N
256663	1678	8640245187000	9252	4749	34	0	\N
256664	1678	8640245188000	9252	4749	35	0	\N
256665	1678	8640245189000	9252	4749	36	0	\N
256666	1678	8640245190000	9252	4749	37	0	\N
256667	1678	8640245191000	9252	4749	38	0	\N
256668	1678	8640245192000	9252	4749	39	0	\N
256669	1678	8640245193000	9252	4749	40	0	\N
256670	1678	8640245194000	9252	4749	41	0	\N
256671	1678	8640245195000	9252	4749	42	0	\N
256672	1678	8640245196000	9252	4749	44	0	\N
256673	1678	8640245197000	9252	4749	45	0	\N
256674	1678	8640245198000	9252	4749	46	0	\N
256675	1678	8640245199000	9252	4749	47	0	\N
256676	59	66254578500000	9252	4749	48	0	\N
256677	1678	8640245200000	9252	4749	49	0	\N
256678	1678	8640245201000	9252	4749	50	0	\N
256679	1678	8640245202000	9252	4749	51	0	\N
256680	1678	8640245203000	9252	4749	52	0	\N
256681	1678	8640245204000	9252	4749	53	0	\N
256682	1678	8640245205000	9252	4749	54	0	\N
256683	1678	8640245206000	9252	4749	55	0	\N
256684	1678	8640245207000	9252	4749	56	0	\N
256685	1678	8640245208000	9252	4749	57	0	\N
256686	1678	8640245209000	9252	4749	58	0	\N
256687	1678	8640245210000	9252	4749	59	0	\N
256688	1678	8640245211000	9252	4749	60	0	\N
256689	1678	8640245212000	9252	4749	61	0	\N
256690	1678	8640245213000	9252	4749	62	0	\N
256691	1678	8640245214000	9252	4749	63	0	\N
256692	1678	8640245215000	9252	4749	64	0	\N
256693	1678	8640245216000	9252	4749	65	0	\N
256694	1874	201878000	9252	4749	66	0	\N
256695	1874	201879000	9252	4749	67	0	\N
256696	1874	201880000	9252	4749	68	0	\N
256697	1874	201881000	9252	4749	69	0	\N
256698	1874	201882000	9252	4749	70	0	\N
256699	1874	201883000	9252	4749	71	0	\N
256700	1874	201884000	9252	4749	72	0	\N
256701	1874	201885000	9252	4749	73	0	\N
256702	1874	201886000	9252	4749	74	0	\N
256703	1874	201887000	9252	4749	75	0	\N
256704	1874	201888000	9252	4749	76	0	\N
256705	1874	201889000	9252	4749	77	0	\N
256706	1874	201890000	9252	4749	78	0	\N
256707	1874	201891000	9252	4749	79	0	\N
256708	1874	201892000	9252	4749	80	0	\N
256709	1874	201893000	9252	4749	81	0	\N
256710	1874	201894000	9252	4749	82	0	\N
256711	1874	201895000	9252	4749	83	0	\N
256712	1874	201896000	9252	4749	84	0	\N
256713	1874	201897000	9252	4749	85	0	\N
256714	1874	201898000	9252	4749	86	0	\N
256715	1874	201899000	9252	4749	87	0	\N
256716	1874	201900000	9252	4749	88	0	\N
256717	1874	201901000	9252	4749	89	0	\N
256718	1874	201902000	9252	4749	90	0	\N
256719	1874	201903000	9252	4749	91	0	\N
256720	1874	201904000	9252	4749	92	0	\N
256721	1874	201905000	9252	4749	93	0	\N
256722	1874	201906000	9252	4749	94	0	\N
256723	1874	201907000	9252	4749	95	0	\N
256724	1874	201908000	9252	4749	96	0	\N
256725	1874	201909000	9252	4749	97	0	\N
256726	1874	201910000	9252	4749	98	0	\N
256727	1874	201911000	9252	4749	99	0	\N
256728	587	66344300665601	9252	4749	100	0	\N
256729	146	66344300665601	9252	4749	101	0	\N
256730	395	66341270665601	9252	4749	102	0	\N
256731	611	66344300665601	9252	4749	103	0	\N
256732	29	7036516737238	9252	4749	104	0	\N
256733	138	66344300665601	9252	4749	105	0	\N
256734	205	66344300665601	9252	4749	106	0	\N
256735	78	66344300665601	9252	4749	107	0	\N
256736	1811	938190609615	9252	4749	108	0	\N
256737	504	66344300665601	9252	4749	109	0	\N
256738	658	66344300665601	9252	4749	110	0	\N
256739	1961	343222840828	9252	4749	111	0	\N
256740	660	66344300665601	9252	4749	112	0	\N
256741	1276	1702817277527660	9252	4749	113	0	\N
256742	194	66344300665601	9252	4749	114	0	\N
256743	304	66344300665601	9252	4749	115	0	\N
256744	206	66344300665601	9252	4749	116	0	\N
256745	399	66344300665601	9252	4749	117	0	\N
256746	1772	2461166133031	9252	4749	118	0	\N
256747	105	66344300665601	9252	4749	119	0	\N
256748	122	66344300665601	9252	4749	120	0	\N
256749	622	66347280665601	9252	4749	121	0	\N
256750	520	66344300665601	9252	4749	122	0	\N
256751	551	66344300665601	9252	4749	123	0	\N
256752	295	66344300665601	9252	4749	124	0	\N
256753	653	66344300665601	9252	4749	125	0	\N
256754	1678	8640245238000	9253	4799	0	0	\N
256755	1874	201939000	9253	4799	1	0	\N
256756	1678	8640245239000	9253	4799	2	0	\N
256757	1678	8640245240000	9253	4799	3	0	\N
256758	438	66344300665601	9253	4799	4	0	\N
256759	593	66344300665601	9253	4799	5	0	\N
256760	408	66344300665601	9253	4799	7	0	\N
256761	1874	201940000	9253	4799	8	0	\N
256762	373	66344300665601	9253	4799	9	0	\N
256763	322	66344300665601	9253	4799	10	0	\N
256764	453	66344300665601	9253	4799	11	0	\N
256765	450	66344300665601	9253	4799	12	0	\N
256766	63	66344300665601	9253	4799	13	0	\N
256767	1874	201941000	9253	4799	14	0	\N
256768	601	66344300665601	9253	4799	15	0	\N
256769	92	66344300665601	9253	4799	16	0	\N
256770	150	66344300665601	9253	4799	17	0	\N
256771	309	66344300665601	9253	4799	18	0	\N
256772	680	66344300665601	9253	4799	19	0	\N
256773	731	2010433353450	9253	4799	20	0	\N
256774	82	66344300665601	9253	4799	21	0	\N
256775	163	66344300665601	9253	4799	22	0	\N
256776	275	66344300665601	9253	4799	23	0	\N
256777	361	66344300665601	9253	4799	24	0	\N
256785	1678	8640245241000	9255	4800	0	0	\N
256786	1874	201942000	9255	4800	1	0	\N
256787	201	66344300665601	9255	4800	2	0	\N
256788	1962	343222840828	9255	4800	3	0	\N
256789	391	66344300665601	9255	4800	4	0	\N
256790	402	66344300665601	9255	4800	5	0	\N
256791	397	66344300665601	9255	4800	6	0	\N
256792	1678	8640245242000	9256	4801	0	0	\N
256793	1874	201943000	9256	4801	1	0	\N
256794	452	66344300665601	9256	4801	2	0	\N
256795	594	66344300665601	9256	4801	3	0	\N
256796	690	66344300665601	9256	4801	4	0	\N
256797	112	66063270665601	9256	4801	5	0	\N
256798	180	66344300665601	9256	4801	6	0	\N
256799	106	66344300665601	9256	4801	7	0	\N
256808	1678	8640245242000	9258	4801	0	0	\N
256809	1874	201943000	9258	4801	1	0	\N
256810	452	66344300665601	9258	4801	2	0	\N
256811	594	66344300665601	9258	4801	3	0	\N
256812	690	66344300665601	9258	4801	4	0	\N
256813	112	66063270665601	9258	4801	5	0	\N
256814	180	66344300665601	9258	4801	6	0	\N
256815	106	66344300665601	9258	4801	7	0	\N
256816	1678	8640245242000	9259	4801	0	0	\N
256817	1874	201943000	9259	4801	1	0	\N
256818	452	66344300665601	9259	4801	2	0	\N
256819	594	66344300665601	9259	4801	3	0	\N
256820	690	66344300665601	9259	4801	4	0	\N
256821	112	66063270665601	9259	4801	5	0	\N
256822	180	66344300665601	9259	4801	6	0	\N
256823	106	66344300665601	9259	4801	7	0	\N
256832	652	66344300665601	9261	4802	0	0	\N
256833	745	2010433353450	9261	4802	1	0	\N
256834	420	66344300665601	9261	4802	2	0	\N
256835	1874	201944000	9261	4802	3	0	\N
256836	353	66344290665601	9261	4802	4	0	\N
256837	266	66344300665601	9261	4802	5	0	\N
256838	191	66344300665601	9261	4802	6	0	\N
256839	1678	8640245243000	9261	4802	7	0	\N
256848	1874	201946000	9263	4804	0	0	\N
256849	1678	8640245245000	9263	4804	1	0	\N
256850	217	66344300665601	9263	4804	2	0	\N
256851	1874	201947000	9263	4804	3	0	\N
256852	1678	8640245246000	9263	4804	4	0	\N
256853	534	66344300665601	9263	4804	5	0	\N
256854	620	66344300665601	9263	4804	6	0	\N
256855	54	66344300665601	9263	4804	7	0	\N
256856	710	5026083383729	9263	4804	8	0	\N
256857	499	66344300665601	9263	4804	9	0	\N
256858	663	66344300665601	9263	4804	10	0	\N
256859	1030	905673387644075	9263	4804	11	0	\N
256860	320	66063100665601	9263	4804	12	0	\N
256861	893	308423512571246	9263	4804	13	0	\N
256862	251	66344300665601	9263	4804	14	0	\N
256878	1483	0	9267	4802	0	0	\N
256899	1678	8640245250000	9270	4807	0	0	\N
256900	1678	8640245251000	9270	4807	1	0	\N
256901	1874	201951000	9270	4807	2	0	\N
256780	201	66344300665601	9254	4800	2	0	0
256781	1962	343222840828	9254	4800	3	0	0
256782	391	66344300665601	9254	4800	4	0	0
256783	402	66344300665601	9254	4800	5	0	0
256784	397	66344300665601	9254	4800	6	0	0
256801	1874	201943000	9257	4801	1	0	0
256802	452	66344300665601	9257	4801	2	0	0
256803	594	66344300665601	9257	4801	3	0	0
256804	690	66344300665601	9257	4801	4	0	0
256805	112	66063270665601	9257	4801	5	0	3
256807	106	66344300665601	9257	4801	7	0	0
256824	652	66344300665601	9260	4802	0	0	0
256825	745	2010433353450	9260	4802	1	0	0
256826	420	66344300665601	9260	4802	2	0	0
256828	353	66344290665601	9260	4802	4	0	1
256829	266	66344300665601	9260	4802	5	0	0
256830	191	66344300665601	9260	4802	6	0	0
256831	1678	8640245243000	9260	4802	7	0	0
256840	1874	201945000	9262	4803	0	0	0
256842	1678	8640245244000	9262	4803	2	0	0
256843	352	66344300665601	9262	4803	3	0	0
256844	691	66344300665601	9262	4803	4	0	0
256845	245	66344300665601	9262	4803	5	0	0
256846	421	66344300665601	9262	4803	6	0	0
256863	1874	201946000	9264	4804	0	0	0
256864	1678	8640245245000	9264	4804	1	0	0
256865	217	66344300665601	9264	4804	2	0	0
256866	1874	201947000	9264	4804	3	0	0
256868	534	66344300665601	9264	4804	5	0	0
256869	620	66344300665601	9264	4804	6	0	0
256870	54	66344300665601	9264	4804	7	0	0
256871	710	5026083383729	9264	4804	8	0	0
256872	499	66344300665601	9264	4804	9	0	0
256874	1030	905673387644075	9264	4804	11	0	0
256875	320	66063100665601	9264	4804	12	0	2
256876	893	308423512571246	9264	4804	13	0	0
256877	251	66344300665601	9264	4804	14	0	0
256879	35	19300160193600	9268	4805	0	0	0
256881	1678	8640245247000	9268	4805	2	0	0
256882	49	66344300665601	9268	4805	3	0	0
256883	570	66344300665601	9268	4805	4	0	0
256884	99	66344300665601	9268	4805	5	0	0
256886	894	308423512571246	9268	4805	7	0	0
256887	1874	201948000	9268	4805	8	0	0
256888	108	66344300665601	9269	4806	0	0	0
256889	390	66344300665601	9269	4806	1	0	0
256890	1678	8640245248000	9269	4806	2	0	0
256892	252	66344300665601	9269	4806	4	0	0
256893	1874	201949000	9269	4806	5	0	0
256894	377	66344300665601	9269	4806	6	0	0
256895	1874	201950000	9269	4806	7	0	0
256896	225	66344300665601	9269	4806	8	0	0
256898	1480	700909000000	9269	4806	10	0	19
256902	1678	8640245250000	9271	4807	0	0	0
256903	1678	8640245251000	9271	4807	1	0	0
256904	1874	201951000	9271	4807	2	0	0
256905	1678	8640245250000	9272	4807	0	0	\N
256906	1678	8640245251000	9272	4807	1	0	\N
256907	1874	201951000	9272	4807	2	0	\N
256908	1678	8640245250000	9273	4807	0	0	\N
256909	1678	8640245251000	9273	4807	1	0	\N
256910	1874	201951000	9273	4807	2	0	\N
256915	1874	201953000	9276	4809	0	0	\N
256916	1678	8640245253000	9276	4809	1	0	\N
256921	1678	8640245256000	9279	4812	0	0	\N
256922	1874	201956000	9279	4812	1	0	\N
256925	1874	201957000	9281	4813	0	0	\N
256926	1678	8640245257000	9281	4813	1	0	\N
256927	1874	201957000	9282	4813	0	0	\N
256928	1678	8640245257000	9282	4813	1	0	\N
256933	1874	201958000	9285	4814	0	0	\N
256941	1678	8640245262000	9289	4818	0	0	\N
256942	1874	201962000	9289	4818	1	0	\N
256945	1483	0	9291	4683	0	0	\N
256946	1516	17533489191100	9291	4683	1	0	\N
256947	772	1001000000000	9291	4683	2	0	\N
256948	928	505156545079092	9291	4683	3	0	\N
256949	1961	281000000000	9291	4683	4	0	\N
256950	761	1003857250000	9291	4683	5	0	\N
256951	1678	8640245070000	9291	4683	6	0	\N
256952	1678	8640245071000	9291	4683	7	0	\N
256953	1678	8640245072000	9291	4683	8	0	\N
256954	1678	8640245073000	9291	4683	9	0	\N
256955	1678	8640245074000	9291	4683	10	0	\N
256956	1678	8640245075000	9291	4683	11	0	\N
256957	1678	8640245076000	9291	4683	12	0	\N
256958	1932	217990000000	9291	4683	13	0	\N
256959	1821	279990000000	9291	4683	14	0	\N
256960	716	3011571750000	9291	4683	15	0	\N
256961	910	505400512229673	9291	4683	17	0	\N
256962	500	66344300665601	9291	4683	18	0	\N
256963	1962	281000000000	9291	4683	19	0	\N
256964	517	66254578500000	9291	4683	20	0	\N
256965	509	66254578500000	9291	4683	21	0	\N
256966	463	66254578500000	9291	4683	22	0	\N
256967	278	66254578500000	9291	4683	23	0	\N
256968	178	66254578500000	9291	4683	24	0	\N
256969	1048	905236200600448	9291	4683	25	0	\N
256970	1168	610780902650622	9291	4683	26	0	\N
256971	587	66344300665601	9291	4683	27	0	\N
256972	146	66344300665601	9291	4683	28	0	\N
256973	395	66341270665601	9291	4683	29	0	\N
256974	611	66344300665601	9291	4683	30	0	\N
256975	29	7036516737238	9291	4683	31	0	\N
256976	138	66344300665601	9291	4683	32	0	\N
256977	205	66344300665601	9291	4683	33	0	\N
256978	78	66344300665601	9291	4683	34	0	\N
256979	1811	938190609615	9291	4683	35	0	\N
256980	504	66344300665601	9291	4683	36	0	\N
256981	658	66344300665601	9291	4683	37	0	\N
256982	1961	343222840828	9291	4683	38	0	\N
256983	660	66344300665601	9291	4683	39	0	\N
256984	1276	1702817277527660	9291	4683	40	0	\N
256985	194	66344300665601	9291	4683	41	0	\N
256986	304	66344300665601	9291	4683	42	0	\N
256987	206	66344300665601	9291	4683	43	0	\N
256988	399	66344300665601	9291	4683	44	0	\N
256989	1772	2461166133031	9291	4683	45	0	\N
256990	105	66344300665601	9291	4683	46	0	\N
256991	122	66344300665601	9291	4683	47	0	\N
256992	622	66347280665601	9291	4683	48	0	\N
256993	520	66344300665601	9291	4683	49	0	\N
256994	551	66344300665601	9291	4683	50	0	\N
256995	295	66344300665601	9291	4683	51	0	\N
256996	653	66344300665601	9291	4683	52	0	\N
256997	721	2010433353450	9291	4683	53	0	\N
256998	308	66344300665601	9291	4683	54	0	\N
256999	1150	611075881460537	9291	4683	55	0	\N
257000	84	66344300665601	9291	4683	56	0	\N
257001	89	66344300665601	9291	4683	57	0	\N
257002	186	66344300665601	9291	4683	58	0	\N
257003	383	66344300665601	9291	4683	59	0	\N
257004	392	66344300665601	9291	4683	60	0	\N
257005	678	66344300665601	9291	4683	61	0	\N
257006	339	66344300665601	9291	4683	62	0	\N
257007	91	66344300665601	9291	4683	63	0	\N
257008	438	66344300665601	9291	4683	64	0	\N
257009	593	66344300665601	9291	4683	65	0	\N
257010	408	66344300665601	9291	4683	66	0	\N
257011	373	66344300665601	9291	4683	67	0	\N
257012	322	66344300665601	9291	4683	68	0	\N
257013	453	66344300665601	9291	4683	69	0	\N
257014	450	66344300665601	9291	4683	70	0	\N
257015	63	66344300665601	9291	4683	71	0	\N
257016	601	66344300665601	9291	4683	72	0	\N
257017	92	66344300665601	9291	4683	73	0	\N
257018	150	66344300665601	9291	4683	74	0	\N
257019	309	66344300665601	9291	4683	75	0	\N
257020	680	66344300665601	9291	4683	76	0	\N
257021	731	2010433353450	9291	4683	77	0	\N
257022	82	66344300665601	9291	4683	78	0	\N
257023	163	66344300665601	9291	4683	79	0	\N
257024	275	66344300665601	9291	4683	80	0	\N
257025	361	66344300665601	9291	4683	81	0	\N
257026	201	66344300665601	9291	4683	82	0	\N
257027	1962	343222840828	9291	4683	83	0	\N
257028	391	66344300665601	9291	4683	84	0	\N
257029	402	66344300665601	9291	4683	85	0	\N
257030	397	66344300665601	9291	4683	86	0	\N
257031	1678	8640245077000	9291	4683	87	0	\N
257032	1678	8640245078000	9291	4683	88	0	\N
257033	1678	8640245079000	9291	4683	89	0	\N
257034	1678	8640245080000	9291	4683	90	0	\N
257035	1678	8640245081000	9291	4683	91	0	\N
257036	1678	8640245082000	9291	4683	92	0	\N
257037	1678	8640245083000	9291	4683	93	0	\N
257038	1678	8640245084000	9291	4683	94	0	\N
257039	1678	8640245085000	9291	4683	95	0	\N
257040	1678	8640245086000	9291	4683	96	0	\N
256913	1874	201953000	9275	4809	0	0	0
256914	1678	8640245253000	9275	4809	1	0	0
256917	1678	8640245254000	9277	4810	0	0	0
256918	1874	201954000	9277	4810	1	0	0
256919	1678	8640245255000	9278	4811	0	0	0
256923	1678	8640245256000	9280	4812	0	0	0
256924	1874	201956000	9280	4812	1	0	0
256929	1874	201957000	9283	4813	0	0	0
256930	1678	8640245257000	9283	4813	1	0	0
256931	1678	8640245258000	9284	4814	0	0	0
256934	1874	201959000	9286	4815	0	0	0
256935	1678	8640245259000	9286	4815	1	0	0
256936	1778	2950090000000	9286	4815	2	0	1
256937	1874	201960000	9287	4816	0	0	0
256939	1678	8640245261000	9288	4817	0	0	0
256940	1874	201961000	9288	4817	1	0	0
256943	1678	8640245262000	9290	4818	0	0	0
256944	1874	201962000	9290	4818	1	0	0
257041	1678	8640245087000	9291	4683	97	0	\N
257042	1678	8640245088000	9291	4683	98	0	\N
257043	1678	8640245089000	9291	4683	99	0	\N
257044	1678	8640245090000	9291	4683	100	0	\N
257045	1678	8640245091000	9291	4683	101	0	\N
257046	1678	8640245092000	9291	4683	102	0	\N
257047	1678	8640245093000	9291	4683	103	0	\N
257048	1678	8640245094000	9291	4683	104	0	\N
257049	1678	8640245095000	9291	4683	105	0	\N
257050	1678	8640245096000	9291	4683	106	0	\N
257051	1678	8640245097000	9291	4683	107	0	\N
257052	1678	8640245098000	9291	4683	108	0	\N
257053	1678	8640245099000	9291	4683	109	0	\N
257054	1678	8640245100000	9291	4683	110	0	\N
257055	1678	8640245101000	9291	4683	111	0	\N
257056	1678	8640245102000	9291	4683	112	0	\N
257057	1678	8640245103000	9291	4683	113	0	\N
257058	1678	8640245104000	9291	4683	114	0	\N
257059	1678	8640245105000	9291	4683	115	0	\N
257060	1678	8640245106000	9291	4683	116	0	\N
257061	1678	8640245107000	9291	4683	117	0	\N
257062	1678	8640245108000	9291	4683	118	0	\N
257063	1678	8640245109000	9291	4683	119	0	\N
257064	1678	8640245110000	9291	4683	120	0	\N
257065	1678	8640245111000	9291	4683	121	0	\N
257066	1678	8640245112000	9291	4683	122	0	\N
257067	1678	8640245113000	9291	4683	123	0	\N
257068	1678	8640245114000	9291	4683	124	0	\N
257069	1678	8640245115000	9291	4683	125	0	\N
257077	1678	8640245266000	9294	4821	0	0	\N
257078	1874	201966000	9294	4821	1	0	\N
257087	1874	201969000	9299	4824	0	0	\N
257088	1678	8640245269000	9299	4824	1	0	\N
257097	1874	201974000	9302	4827	0	0	\N
257098	1678	8640245274000	9302	4827	1	0	\N
257101	1678	8640245275000	9304	4828	0	0	\N
257102	1874	201975000	9304	4828	1	0	\N
257103	1874	201976000	9304	4828	2	0	\N
257104	1874	201977000	9304	4828	3	0	\N
257105	1874	201978000	9304	4828	4	0	\N
257106	1678	8640245276000	9304	4828	5	0	\N
257107	1678	8640245277000	9304	4828	6	0	\N
257108	1678	8640245278000	9304	4828	7	0	\N
257121	1678	8640245279000	9307	4829	0	0	\N
257122	1874	201979000	9307	4829	1	0	\N
257123	1678	8640245280000	9307	4829	2	0	\N
257124	1899	2000000000	9307	4829	3	0	\N
257125	1874	201980000	9308	4830	0	0	\N
257126	1874	201981000	9308	4830	1	0	\N
257127	1678	8640245281000	9308	4830	2	0	\N
257128	1678	8640245282000	9308	4830	3	0	\N
257133	1678	8640245283000	9310	4831	0	0	\N
257134	1874	201982000	9310	4831	1	0	\N
257135	1678	8640245283000	9311	4831	0	0	\N
257136	1874	201982000	9311	4831	1	0	\N
257137	1678	8640245283000	9312	4831	0	0	\N
257138	1874	201982000	9312	4831	1	0	\N
257139	1678	8640245283000	9313	4831	0	0	\N
257140	1874	201982000	9313	4831	1	0	\N
257142	1678	8640245283000	9315	4832	0	0	\N
257143	1678	8640245284000	9315	4832	1	0	\N
257144	1874	201983000	9315	4832	2	0	\N
257148	1678	8640245285000	9317	4833	0	0	\N
257149	1874	201984000	9317	4833	1	0	\N
257150	1678	8640245285000	9318	4833	0	0	\N
257151	1874	201984000	9318	4833	1	0	\N
257154	1678	8640245285000	9320	4833	0	0	\N
257155	1874	201984000	9320	4833	1	0	\N
257156	1874	201984000	9321	4833	0	0	\N
257169	1874	201990000	9325	4836	0	0	\N
257072	1874	201963000	9292	4819	2	0	0
257073	1874	201964000	9292	4819	3	0	0
257074	1678	8640245265000	9293	4820	0	0	0
257075	1874	201965000	9293	4820	1	0	0
257076	1652	490000000	9293	4820	2	0	3
257080	1874	201966000	9295	4821	1	0	0
257081	1874	201967000	9296	4822	0	0	0
257082	1678	8640245267000	9296	4822	1	0	0
257083	1678	8640245268000	9297	4823	0	0	0
257084	1874	201968000	9297	4823	1	0	0
257086	1678	8640245269000	9298	4824	1	0	0
257089	1678	8640245270000	9300	4825	0	0	0
257090	1874	201970000	9300	4825	1	0	0
257091	1874	201971000	9301	4826	0	0	0
257093	1874	201973000	9301	4826	2	0	0
257094	1678	8640245271000	9301	4826	3	0	0
257095	1678	8640245272000	9301	4826	4	0	0
257096	1678	8640245273000	9301	4826	5	0	0
257099	1874	201974000	9303	4827	0	0	0
257109	1678	8640245275000	9305	4828	0	0	0
257110	1874	201975000	9305	4828	1	0	0
257111	1874	201976000	9305	4828	2	0	0
257112	1874	201977000	9305	4828	3	0	0
257113	1874	201978000	9305	4828	4	0	0
257115	1678	8640245277000	9305	4828	6	0	0
257116	1678	8640245278000	9305	4828	7	0	0
257117	1678	8640245279000	9306	4829	0	0	0
257118	1874	201979000	9306	4829	1	0	0
257120	1899	2000000000	9306	4829	3	0	0
257129	1874	201980000	9309	4830	0	0	0
257130	1874	201981000	9309	4830	1	0	0
257131	1678	8640245281000	9309	4830	2	0	0
257132	1678	8640245282000	9309	4830	3	0	0
257145	1678	8640245283000	9316	4832	0	0	0
257146	1678	8640245284000	9316	4832	1	0	0
257147	1874	201983000	9316	4832	2	0	0
257152	1678	8640245285000	9319	4833	0	0	0
257153	1874	201984000	9319	4833	1	0	0
257158	1874	201985000	9322	4834	1	0	0
257159	1874	201986000	9322	4834	2	0	0
257160	1874	201987000	9322	4834	3	0	0
257161	1678	8640245287000	9322	4834	4	0	0
257163	1678	8640245289000	9323	4835	0	0	0
257164	1874	201988000	9323	4835	1	0	0
257165	1874	201989000	9323	4835	2	0	0
257166	1678	8640245290000	9323	4835	3	0	0
257167	1678	8640245291000	9324	4836	0	0	0
257170	1874	201991000	9326	4837	0	0	0
257171	1483	0	9326	4837	1	0	0
257172	1874	201992000	9326	4837	2	0	0
257173	1678	8640245292000	9326	4837	3	0	0
257174	1678	8640245293000	9326	4837	4	0	0
257176	1874	201994000	9327	4838	1	0	0
257180	1678	8640245296000	9328	4839	0	0	\N
257181	1874	201995000	9328	4839	1	0	\N
257182	1678	8640245296000	9329	4839	0	0	\N
257183	1874	201995000	9329	4839	1	0	\N
257196	1678	8640245300000	9335	4843	0	0	\N
257197	1678	8640245301000	9335	4843	1	0	\N
257198	1678	8640245302000	9335	4843	2	0	\N
257199	1874	201999000	9335	4843	3	0	\N
257200	1874	202000000	9335	4843	4	0	\N
257201	1874	202001000	9335	4843	5	0	\N
257202	1899	1999000000	9335	4843	6	0	\N
257210	1678	8640245304000	9338	4845	0	0	\N
257211	1874	202003000	9338	4845	1	0	\N
257214	1874	202004000	9340	4846	0	0	\N
257215	1678	8640245305000	9340	4846	1	0	\N
257218	1678	8640245307000	9342	4848	0	0	\N
257219	1874	202006000	9342	4848	1	0	\N
257220	1678	8640245307000	9343	4848	0	0	\N
257221	1874	202006000	9343	4848	1	0	\N
257226	1874	202008000	9346	4850	0	0	\N
257227	1678	8640245309000	9346	4850	1	0	\N
257230	1874	202008000	9348	4850	0	0	\N
257231	1678	8640245309000	9348	4850	1	0	\N
257239	1678	8640245313000	9351	4853	0	0	\N
257240	1874	202013000	9351	4853	1	0	\N
257243	1678	8640245313000	9353	4853	0	0	\N
257244	1874	202013000	9353	4853	1	0	\N
257247	1678	8640245315000	9355	4855	0	0	\N
257248	1874	202015000	9355	4855	1	0	\N
257254	1678	8640245318000	9364	4858	0	0	\N
257255	1874	202017000	9364	4858	1	0	\N
257256	1678	8640245318000	9365	4858	0	0	\N
257257	1874	202017000	9365	4858	1	0	\N
257262	1678	8640245319000	9368	4859	0	0	\N
257263	1874	202018000	9368	4859	1	0	\N
257270	1969	1000000000	9372	4863	0	0	\N
257271	1403	0	9372	4863	1	0	\N
257276	1874	202023000	9374	4864	0	0	\N
257277	1474	17554314000000	9374	4864	1	0	\N
257278	1678	8640245324000	9374	4864	2	0	\N
257282	1874	202023000	9376	4864	0	0	\N
257283	1474	17554314000000	9376	4864	1	0	\N
257284	1678	8640245324000	9376	4864	2	0	\N
257287	1678	8640245325000	9378	4865	0	0	\N
257288	1874	202024000	9378	4865	1	0	\N
257293	1874	202025000	9380	4866	0	0	\N
257294	1874	202026000	9380	4866	1	0	\N
257295	1678	8640245326000	9380	4866	2	0	\N
257296	1678	8640245327000	9380	4866	4	0	\N
257297	1874	202025000	9381	4866	0	0	\N
257298	1874	202026000	9381	4866	1	0	\N
257299	1678	8640245326000	9381	4866	2	0	\N
257300	1678	8640245327000	9381	4866	4	0	\N
257301	1678	8640245328000	9382	4867	0	0	\N
257304	1969	1000000000	9384	4750	1	0	\N
257305	1483	0	9384	4750	2	0	\N
257306	721	2010433353450	9384	4750	3	0	\N
257307	308	66344300665601	9384	4750	4	0	\N
257308	1150	611075881460537	9384	4750	5	0	\N
257309	1483	0	9384	4750	6	0	\N
257310	84	66344300665601	9384	4750	7	0	\N
257311	89	66344300665601	9384	4750	8	0	\N
257312	186	66344300665601	9384	4750	9	0	\N
257179	1678	8640245295000	9327	4838	5	0	0
257184	1678	8640245296000	9330	4839	0	0	0
257185	1874	201995000	9330	4839	1	0	0
257186	1678	8640245297000	9331	4840	0	0	0
257187	1874	201996000	9331	4840	1	0	0
257189	1874	201997000	9332	4841	1	0	0
257190	1874	201998000	9333	4842	0	0	0
257191	1678	8640245299000	9333	4842	1	0	0
257192	1678	8640245300000	9334	4843	0	0	0
257193	1678	8640245301000	9334	4843	1	0	0
257195	1899	1999000000	9334	4843	3	0	1
257203	1678	8640245303000	9336	4844	0	0	0
257204	1874	201999000	9336	4844	1	0	0
257205	1874	202000000	9336	4844	2	0	0
257207	1874	202002000	9336	4844	4	0	0
257208	1678	8640245304000	9337	4845	0	0	0
257209	1874	202003000	9337	4845	1	0	0
257212	1874	202004000	9339	4846	0	0	0
257213	1678	8640245305000	9339	4846	1	0	0
257217	1874	202005000	9341	4847	1	0	0
257222	1678	8640245307000	9344	4848	0	0	0
257223	1874	202006000	9344	4848	1	0	0
257224	1874	202007000	9345	4849	0	0	0
257225	1678	8640245308000	9345	4849	1	0	0
257229	1678	8640245309000	9347	4850	1	0	0
257232	1678	8640245310000	9349	4851	1	0	0
257233	1678	8640245311000	9349	4851	2	0	0
257234	1874	202009000	9349	4851	3	0	0
257236	1874	202011000	9349	4851	5	0	0
257237	1678	8640245312000	9350	4852	0	0	0
257238	1874	202012000	9350	4852	1	0	0
257241	1678	8640245313000	9352	4853	0	0	0
257242	1874	202013000	9352	4853	1	0	0
257246	1874	202014000	9354	4854	1	0	0
257249	1678	8640245315000	9356	4855	0	0	0
257250	1874	202015000	9356	4855	1	0	0
257251	1678	8640245316000	9358	4856	0	0	0
257252	1678	8640245317000	9363	4857	0	0	0
257258	1678	8640245318000	9366	4858	0	0	0
257259	1874	202017000	9366	4858	1	0	0
257260	1678	8640245319000	9367	4859	0	0	0
257261	1874	202018000	9367	4859	1	0	0
257265	1678	8640245320000	9369	4860	1	0	0
257266	1874	202020000	9370	4861	0	0	0
257267	1678	8640245321000	9370	4861	1	0	0
257268	1874	202021000	9371	4862	0	0	0
257269	1678	8640245322000	9371	4862	1	0	0
257273	1678	8640245323000	9373	4863	1	0	0
257274	1874	202022000	9373	4863	2	0	0
257275	1403	0	9373	4863	3	0	0
257279	1874	202023000	9375	4864	0	0	0
257280	1474	17554314000000	9375	4864	1	0	5
257285	1678	8640245325000	9377	4865	0	0	0
257286	1874	202024000	9377	4865	1	0	0
257289	1874	202025000	9379	4866	0	0	0
257290	1874	202026000	9379	4866	1	0	0
257292	1678	8640245327000	9379	4866	4	0	0
257302	1874	202027000	9383	4867	0	0	0
257303	1678	8640245328000	9383	4867	1	0	0
257313	383	66344300665601	9384	4750	10	0	\N
257314	392	66344300665601	9384	4750	11	0	\N
257315	678	66344300665601	9384	4750	12	0	\N
257316	339	66344300665601	9384	4750	13	0	\N
257317	91	66344300665601	9384	4750	14	0	\N
257318	438	66344300665601	9384	4750	15	0	\N
257319	593	66344300665601	9384	4750	16	0	\N
257320	408	66344300665601	9384	4750	17	0	\N
257321	373	66344300665601	9384	4750	18	0	\N
257322	322	66344300665601	9384	4750	19	0	\N
257323	453	66344300665601	9384	4750	20	0	\N
257324	450	66344300665601	9384	4750	21	0	\N
257325	63	66344300665601	9384	4750	22	0	\N
257326	601	66344300665601	9384	4750	23	0	\N
257327	92	66344300665601	9384	4750	24	0	\N
257328	150	66344300665601	9384	4750	25	0	\N
257329	309	66344300665601	9384	4750	26	0	\N
257330	680	66344300665601	9384	4750	27	0	\N
257331	731	2010433353450	9384	4750	28	0	\N
257332	82	66344300665601	9384	4750	29	0	\N
257333	163	66344300665601	9384	4750	30	0	\N
257334	275	66344300665601	9384	4750	31	0	\N
257335	361	66344300665601	9384	4750	32	0	\N
257336	201	66344300665601	9384	4750	33	0	\N
257337	1962	343212840828	9384	4750	34	0	\N
257338	391	66344300665601	9384	4750	35	0	\N
257339	402	66344300665601	9384	4750	36	0	\N
257340	397	66344300665601	9384	4750	37	0	\N
257341	1678	8640245217000	9384	4750	38	0	\N
257342	1678	8640245218000	9384	4750	39	0	\N
257343	1678	8640245219000	9384	4750	40	0	\N
257344	1678	8640245220000	9384	4750	41	0	\N
257345	1678	8640245221000	9384	4750	42	0	\N
257346	1678	8640245222000	9384	4750	44	0	\N
257347	1678	8640245223000	9384	4750	45	0	\N
257348	1678	8640245224000	9384	4750	46	0	\N
257349	1678	8640245225000	9384	4750	47	0	\N
257350	1678	8640245226000	9384	4750	48	0	\N
257351	1678	8640245227000	9384	4750	49	0	\N
257352	1678	8640245228000	9384	4750	50	0	\N
257353	1678	8640245229000	9384	4750	51	0	\N
257354	452	66344300665601	9384	4750	52	0	\N
257355	594	66344300665601	9384	4750	53	0	\N
257356	690	66344300665601	9384	4750	54	0	\N
257357	112	66063270665601	9384	4750	55	0	\N
257358	180	66344300665601	9384	4750	56	0	\N
257359	106	66344300665601	9384	4750	57	0	\N
257360	652	66344300665601	9384	4750	58	0	\N
257361	745	2010433353450	9384	4750	59	0	\N
257362	420	66344300665601	9384	4750	60	0	\N
257363	353	66344290665601	9384	4750	61	0	\N
257364	266	66344300665601	9384	4750	62	0	\N
257365	191	66344300665601	9384	4750	63	0	\N
257366	600	66344300665601	9384	4750	64	0	\N
257367	352	66344300665601	9384	4750	65	0	\N
257368	691	66344300665601	9384	4750	66	0	\N
257369	245	66344300665601	9384	4750	67	0	\N
257370	421	66344300665601	9384	4750	68	0	\N
257371	103	66344300665601	9384	4750	69	0	\N
257372	217	66344300665601	9384	4750	70	0	\N
257373	534	66344300665601	9384	4750	71	0	\N
257374	620	66344300665601	9384	4750	72	0	\N
257375	54	66344300665601	9384	4750	73	0	\N
257376	710	5026083383729	9384	4750	74	0	\N
257377	499	66344300665601	9384	4750	75	0	\N
257378	663	66344300665601	9384	4750	76	0	\N
257379	1030	905673387644075	9384	4750	77	0	\N
257380	320	66063100665601	9384	4750	78	0	\N
257381	893	308423512571246	9384	4750	79	0	\N
257382	251	66344300665601	9384	4750	80	0	\N
257383	35	19300160193600	9384	4750	81	0	\N
257384	49	66344300665601	9384	4750	82	0	\N
257385	570	66344300665601	9384	4750	83	0	\N
257386	99	66344300665601	9384	4750	84	0	\N
257387	569	66344300665601	9384	4750	85	0	\N
257388	894	308423512571246	9384	4750	86	0	\N
257389	108	66344300665601	9384	4750	87	0	\N
257390	390	66344300665601	9384	4750	88	0	\N
257391	252	66344300665601	9384	4750	89	0	\N
257392	377	66344300665601	9384	4750	90	0	\N
257393	225	66344300665601	9384	4750	91	0	\N
257394	560	66344300665601	9384	4750	92	0	\N
257395	1778	2950090000000	9384	4750	93	0	\N
257396	1874	201912000	9384	4750	94	0	\N
257397	1874	201913000	9384	4750	95	0	\N
257398	1874	201914000	9384	4750	96	0	\N
257399	1874	201915000	9384	4750	97	0	\N
257400	1874	201916000	9384	4750	98	0	\N
257401	1874	201917000	9384	4750	99	0	\N
257402	1874	201918000	9384	4750	100	0	\N
257403	1968	200000000	9384	4750	101	0	\N
257404	1874	201919000	9384	4750	102	0	\N
257405	1874	201920000	9384	4750	103	0	\N
257406	1874	201921000	9384	4750	104	0	\N
257407	1874	201922000	9384	4750	105	0	\N
257408	1874	201923000	9384	4750	106	0	\N
257409	1874	201924000	9384	4750	107	0	\N
257410	1874	201925000	9384	4750	108	0	\N
257411	1874	201926000	9384	4750	109	0	\N
257412	1874	201927000	9384	4750	110	0	\N
257413	1874	201928000	9384	4750	111	0	\N
257414	1874	201929000	9384	4750	112	0	\N
257415	1874	201930000	9384	4750	113	0	\N
257416	1874	201931000	9384	4750	114	0	\N
257417	1874	201932000	9384	4750	115	0	\N
257418	1874	201933000	9384	4750	116	0	\N
257419	1874	201934000	9384	4750	117	0	\N
257420	1874	201935000	9384	4750	118	0	\N
257421	1874	201936000	9384	4750	119	0	\N
257422	1874	201937000	9384	4750	120	0	\N
257423	1874	201938000	9384	4750	121	0	\N
257424	1874	201939000	9384	4750	122	0	\N
257425	1874	201940000	9384	4750	123	0	\N
257426	1874	201941000	9384	4750	124	0	\N
257427	1874	201942000	9384	4750	125	0	\N
257428	1678	8640245329000	9385	4868	0	0	\N
257429	1874	202028000	9385	4868	1	0	\N
257434	1874	202029000	9388	4869	0	0	\N
257435	1678	8640245330000	9388	4869	1	0	\N
257447	1874	202035000	9392	4873	0	0	\N
257448	1874	202036000	9392	4873	1	0	\N
257432	1874	202029000	9387	4869	0	0	0
257433	1678	8640245330000	9387	4869	1	0	0
257436	1678	8640245331000	9389	4870	0	0	0
257437	1874	202030000	9389	4870	1	0	0
257438	1874	202031000	9389	4870	2	0	0
257440	1678	8640245333000	9390	4871	0	0	0
257441	1874	202032000	9390	4871	1	0	0
257442	1932	549980000000	9390	4871	2	0	0
257443	1874	202033000	9391	4872	0	0	0
257444	1678	8640245334000	9391	4872	1	0	0
257446	1874	202034000	9391	4872	3	0	0
257449	1678	8640245336000	9392	4873	2	0	\N
257450	1678	8640245337000	9392	4873	3	0	\N
257451	1874	202035000	9393	4873	0	0	\N
257452	1874	202036000	9393	4873	1	0	\N
257453	1678	8640245336000	9393	4873	2	0	\N
257454	1678	8640245337000	9393	4873	3	0	\N
257470	1874	202041000	9397	4876	0	0	\N
257471	1678	8640245342000	9397	4876	1	0	\N
257472	1874	202041000	9398	4876	0	0	\N
257473	1678	8640245342000	9398	4876	1	0	\N
257476	1874	202042000	9400	4877	0	0	\N
257477	1678	8640245343000	9400	4877	1	0	\N
257478	1678	8640245344000	9400	4877	2	0	\N
257479	1874	202043000	9400	4877	3	0	\N
257484	1874	202042000	9402	4877	0	0	\N
257485	1678	8640245343000	9402	4877	1	0	\N
257486	1678	8640245344000	9402	4877	2	0	\N
257487	1874	202043000	9402	4877	3	0	\N
257500	1874	202049000	9405	4880	0	0	\N
257501	1678	8640245350000	9405	4880	1	0	\N
257518	1874	202056000	9411	4884	0	0	\N
257519	1678	8640245357000	9411	4884	1	0	\N
257520	1874	202056000	9412	4884	0	0	\N
257521	1678	8640245357000	9412	4884	1	0	\N
257522	1874	202056000	9413	4884	0	0	\N
257523	1678	8640245357000	9413	4884	1	0	\N
257530	1678	8640245361000	9416	4887	0	0	\N
257531	1678	8640245362000	9416	4887	1	0	\N
257532	1874	202060000	9416	4887	2	0	\N
257533	1874	202061000	9416	4887	3	0	\N
257538	1678	8640245361000	9418	4887	0	0	\N
257539	1678	8640245362000	9418	4887	1	0	\N
257540	1874	202060000	9418	4887	2	0	\N
257541	1874	202061000	9418	4887	3	0	\N
257554	1939	1409000000000	9427	4890	0	0	\N
257555	1449	730063000459	9428	4879	0	0	\N
257556	1939	1408990000000	9428	4879	1	0	\N
257557	1939	1409000000000	9429	4892	0	0	\N
257562	1678	8640245370000	9431	4893	0	0	\N
257563	1972	200000000	9431	4893	1	0	\N
257566	1678	8640245370000	9433	4893	0	0	\N
257567	1972	200000000	9433	4893	1	0	\N
257568	1678	8640245370000	9434	4893	0	0	\N
257569	1972	200000000	9434	4893	1	0	\N
257570	1678	8640245370000	9435	4893	0	0	\N
257571	1972	200000000	9435	4893	1	0	\N
257572	1449	730063000459	9436	4880	0	0	\N
257573	1939	1408990000000	9436	4880	1	0	\N
257577	1483	0	9438	4656	1	0	\N
257578	1516	17533489191100	9438	4656	2	0	\N
257579	1969	1000000000	9438	4656	3	0	\N
257580	1874	201737000	9438	4656	4	0	\N
257581	1874	201738000	9438	4656	5	0	\N
257582	772	1001000000000	9438	4656	6	0	\N
257583	928	505156545079092	9438	4656	7	0	\N
257584	1950	817990000000	9438	4656	8	0	\N
257457	1678	8640245336000	9394	4873	2	0	0
257458	1678	8640245337000	9394	4873	3	0	0
257459	1678	8640245338000	9395	4874	0	0	0
257460	1874	202037000	9395	4874	1	0	0
257461	1678	8640245339000	9395	4874	2	0	0
257463	1950	817990000000	9396	4875	0	0	1
257464	1874	202039000	9396	4875	1	0	0
257465	1970	200000000	9396	4875	2	0	0
257466	1874	202040000	9396	4875	3	0	0
257467	1934	1200000000	9396	4875	4	0	2
257469	1678	8640245341000	9396	4875	6	0	0
257474	1874	202041000	9399	4876	0	0	0
257475	1678	8640245342000	9399	4876	1	0	0
257480	1874	202042000	9401	4877	0	0	0
257482	1678	8640245344000	9401	4877	2	0	0
257483	1874	202043000	9401	4877	3	0	0
257488	1678	8640245345000	9403	4878	0	0	0
257489	1874	202044000	9403	4878	1	0	0
257490	1971	199000000000	9404	4879	0	0	0
257492	1874	202046000	9404	4879	2	0	0
257493	341	66001000000000	9404	4879	3	0	0
257494	1874	202047000	9404	4879	4	0	0
257495	1874	202048000	9404	4879	5	0	0
257496	1678	8640245346000	9404	4879	6	0	0
257498	1678	8640245348000	9404	4879	8	0	0
257499	1678	8640245349000	9404	4879	9	0	0
257502	1874	202049000	9406	4880	0	0	0
257503	1678	8640245350000	9406	4880	1	0	0
257505	1678	8640245351000	9407	4881	1	0	0
257506	1874	202051000	9408	4882	0	0	0
257507	1678	8640245352000	9408	4882	1	0	0
257508	1678	8640245353000	9409	4883	0	0	0
257509	1874	202052000	9409	4883	1	0	0
257511	1874	202054000	9409	4883	3	0	0
257512	1874	202055000	9409	4883	4	0	0
257513	1678	8640245354000	9409	4883	5	0	0
257514	1678	8640245355000	9409	4883	6	0	0
257515	1678	8640245356000	9409	4883	7	0	0
257517	1678	8640245357000	9410	4884	1	0	0
257524	1678	8640245358000	9414	4885	0	0	0
257525	1874	202057000	9414	4885	1	0	0
257526	1874	202058000	9415	4886	0	0	0
257528	1678	8640245359000	9415	4886	2	0	0
257529	1678	8640245360000	9415	4886	3	0	0
257534	1678	8640245361000	9417	4887	0	0	0
257535	1678	8640245362000	9417	4887	1	0	0
257536	1874	202060000	9417	4887	2	0	0
257542	1874	202062000	9420	4888	0	0	0
257543	1678	8640245363000	9420	4888	1	0	0
257544	1874	202063000	9424	4889	0	0	0
257545	1678	8640245364000	9424	4889	1	0	0
257546	1874	202064000	9425	4890	0	0	0
257548	1678	8640245365000	9425	4890	2	0	0
257549	1678	8640245366000	9425	4890	3	0	0
257550	1678	8640245367000	9426	4891	0	0	0
257551	1678	8640245368000	9426	4891	1	0	0
257553	1874	202067000	9426	4891	3	0	0
257558	1449	730063000459	9430	4892	0	0	2
257559	1678	8640245369000	9430	4892	1	0	0
257560	1874	202068000	9430	4892	2	0	0
257561	1939	1408990000000	9430	4892	3	0	1
257565	1972	200000000	9432	4893	1	0	0
257574	1678	8640245371000	9437	4894	0	0	0
257575	1973	200000000	9437	4894	1	0	0
257576	1874	202069000	9437	4894	2	0	0
257585	1961	281000000000	9438	4656	9	0	\N
257586	1678	8640245033000	9438	4656	10	0	\N
257587	1678	8640245034000	9438	4656	11	0	\N
257588	761	1003857250000	9438	4656	12	0	\N
257589	1874	201739000	9438	4656	13	0	\N
257590	1874	201740000	9438	4656	14	0	\N
257591	1874	201741000	9438	4656	15	0	\N
257592	1449	10023000459	9438	4656	16	0	\N
257593	341	66001000000000	9438	4656	17	0	\N
257594	1932	352990000000	9438	4656	18	0	\N
257595	1932	549980000000	9438	4656	19	0	\N
257596	1821	279990000000	9438	4656	21	0	\N
257597	716	3011571750000	9438	4656	22	0	\N
257598	910	505400512229673	9438	4656	23	0	\N
257599	500	66344300665601	9438	4656	24	0	\N
257600	1962	281000000000	9438	4656	25	0	\N
257603	1874	202070000	9440	4895	0	0	\N
257604	1678	8640245372000	9440	4895	1	0	\N
257611	1678	8640245375000	9443	4897	0	0	\N
257612	1874	202073000	9443	4897	1	0	\N
257613	1678	8640245376000	9444	4898	0	0	\N
257614	1874	202074000	9444	4898	1	0	\N
257615	1874	202075000	9444	4898	2	0	\N
257616	1678	8640245377000	9444	4898	3	0	\N
257621	1678	8640245378000	9446	4899	0	0	\N
257622	1874	202076000	9446	4899	1	0	\N
257627	1678	8640245379000	9449	4900	0	0	\N
257628	1874	202077000	9449	4900	1	0	\N
257631	1678	8640245381000	9451	4902	0	0	\N
257632	1874	202078000	9451	4902	1	0	\N
257633	1874	202079000	9451	4902	2	0	\N
257634	1678	8640245382000	9451	4902	3	0	\N
257635	1899	1999000000	9451	4902	4	0	\N
257641	1678	8640245381000	9453	4902	0	0	\N
257642	1874	202078000	9453	4902	1	0	\N
257643	1874	202079000	9453	4902	2	0	\N
257644	1678	8640245382000	9453	4902	3	0	\N
257645	1899	1999000000	9453	4902	4	0	\N
257646	1678	8640245383000	9454	4903	0	0	\N
257647	1874	202080000	9454	4903	1	0	\N
257650	1678	8640245383000	9457	4903	0	0	\N
257651	1874	202080000	9457	4903	1	0	\N
257652	1874	202081000	9458	4904	0	0	\N
257653	1678	8640245384000	9458	4904	1	0	\N
257656	1874	202082000	9460	4905	0	0	\N
257657	1678	8640245385000	9460	4905	1	0	\N
257661	1874	202083000	9463	4906	0	0	\N
257662	1678	8640245386000	9463	4906	1	0	\N
257663	27	10010000000000	9464	4881	0	0	\N
257664	1899	1999000000	9464	4881	1	0	\N
257674	1678	8640245378000	9468	4899	0	0	\N
257675	1678	8640245379000	9468	4899	1	0	\N
257676	1678	8640245380000	9468	4899	2	0	\N
257677	1678	8640245381000	9468	4899	3	0	\N
257678	1678	8640245382000	9468	4899	4	0	\N
257679	1678	8640245383000	9468	4899	5	0	\N
257680	1678	8640245384000	9468	4899	6	0	\N
257681	1678	8640245385000	9468	4899	7	0	\N
257682	1678	8640245386000	9468	4899	8	0	\N
257683	1678	8640245387000	9468	4899	9	0	\N
257684	1678	8640245388000	9468	4899	10	0	\N
257685	1678	8640245389000	9468	4899	11	0	\N
257686	1678	8640245390000	9468	4899	12	0	\N
257687	1874	202076000	9468	4899	13	0	\N
257688	1874	202077000	9468	4899	14	0	\N
257689	1874	202078000	9468	4899	15	0	\N
257690	1874	202079000	9468	4899	16	0	\N
257691	1874	202080000	9468	4899	17	0	\N
257692	1874	202081000	9468	4899	18	0	\N
257693	1874	202082000	9468	4899	19	0	\N
257694	1874	202083000	9468	4899	20	0	\N
257695	1874	202084000	9468	4899	21	0	\N
257696	1874	202085000	9468	4899	22	0	\N
257697	1874	202086000	9468	4899	23	0	\N
257698	1874	202087000	9468	4899	24	0	\N
257699	27	10010000000000	9468	4899	25	0	\N
257700	1899	1999000000	9468	4899	26	0	\N
257708	1956	1000000000	9470	4911	0	0	\N
257709	1678	8640245394000	9470	4911	1	0	\N
257710	1874	202091000	9470	4911	2	0	\N
257713	1956	1000000000	9472	4911	0	0	\N
257714	1678	8640245394000	9472	4911	1	0	\N
257715	1874	202091000	9472	4911	2	0	\N
257716	1956	1000000000	9473	4719	0	0	\N
257717	1969	1000000000	9473	4719	2	0	\N
257718	1483	0	9473	4719	3	0	\N
257719	1950	817990000000	9473	4719	4	0	\N
257720	1874	201828000	9473	4719	5	0	\N
257605	1678	8640245373000	9441	4896	0	0	0
257606	1678	8640245374000	9441	4896	1	0	0
257607	1874	202071000	9441	4896	2	0	0
257608	1874	202072000	9441	4896	3	0	0
257609	1678	8640245375000	9442	4897	0	0	0
257617	1678	8640245376000	9445	4898	0	0	0
257618	1874	202074000	9445	4898	1	0	0
257619	1874	202075000	9445	4898	2	0	0
257620	1678	8640245377000	9445	4898	3	0	0
257623	1678	8640245378000	9447	4899	0	0	0
257625	1678	8640245379000	9448	4900	0	0	0
257626	1874	202077000	9448	4900	1	0	0
257629	1678	8640245380000	9450	4901	0	0	0
257630	27	10010000000000	9450	4901	1	0	0
257637	1874	202078000	9452	4902	1	0	0
257638	1874	202079000	9452	4902	2	0	0
257639	1678	8640245382000	9452	4902	3	0	0
257640	1899	1999000000	9452	4902	4	0	1
257648	1678	8640245383000	9455	4903	0	0	0
257654	1874	202081000	9459	4904	0	0	0
257655	1678	8640245384000	9459	4904	1	0	0
257658	1874	202082000	9461	4905	0	0	0
257659	1678	8640245385000	9461	4905	1	0	0
257660	1678	8640245386000	9462	4906	0	0	0
257666	1678	8640245387000	9465	4907	1	0	0
257667	1874	202084000	9465	4907	2	0	0
257668	1874	202085000	9466	4908	0	0	0
257669	1874	202086000	9466	4908	1	0	0
257671	1678	8640245389000	9466	4908	3	0	0
257672	1874	202087000	9467	4909	0	0	0
257673	1678	8640245390000	9467	4909	1	0	0
257701	1874	202088000	9469	4910	0	0	0
257702	1678	8640245391000	9469	4910	1	0	0
257704	1678	8640245393000	9469	4910	3	0	0
257705	1874	202089000	9469	4910	4	0	0
257706	1874	202090000	9469	4910	5	0	0
257707	9	32568000000000	9469	4910	6	0	0
257711	1956	1000000000	9471	4911	0	0	0
257721	1874	201829000	9473	4719	6	0	\N
257722	761	1003857250000	9473	4719	7	0	\N
257723	1678	8640245125000	9473	4719	8	0	\N
257724	1678	8640245126000	9473	4719	9	0	\N
257725	1449	10023000459	9473	4719	10	0	\N
257726	1483	0	9473	4719	11	0	\N
257727	341	66001000000000	9473	4719	12	0	\N
257728	1932	549980000000	9473	4719	13	0	\N
257729	716	3011571750000	9473	4719	14	0	\N
257730	910	505400512229673	9473	4719	15	0	\N
257731	500	66344300665601	9473	4719	16	0	\N
257732	1678	8640245127000	9473	4719	17	0	\N
257733	1678	8640245128000	9473	4719	18	0	\N
257734	1678	8640245129000	9473	4719	19	0	\N
257735	1678	8640245130000	9473	4719	20	0	\N
257736	1678	8640245131000	9473	4719	21	0	\N
257737	1678	8640245132000	9473	4719	22	0	\N
257738	1678	8640245133000	9473	4719	23	0	\N
257739	1678	8640245134000	9473	4719	24	0	\N
257740	1678	8640245135000	9473	4719	25	0	\N
257741	1678	8640245136000	9473	4719	26	0	\N
257742	1678	8640245137000	9473	4719	27	0	\N
257743	1678	8640245138000	9473	4719	28	0	\N
257744	1678	8640245139000	9473	4719	29	0	\N
257745	1678	8640245140000	9473	4719	30	0	\N
257746	1678	8640245141000	9473	4719	31	0	\N
257747	1678	8640245142000	9473	4719	32	0	\N
257748	1678	8640245143000	9473	4719	33	0	\N
257749	1678	8640245144000	9473	4719	34	0	\N
257750	1678	8640245145000	9473	4719	35	0	\N
257751	1678	8640245146000	9473	4719	36	0	\N
257752	1678	8640245147000	9473	4719	37	0	\N
257753	1678	8640245148000	9473	4719	38	0	\N
257754	1678	8640245149000	9473	4719	39	0	\N
257755	1678	8640245150000	9473	4719	40	0	\N
257756	1874	201830000	9473	4719	41	0	\N
257757	1874	201831000	9473	4719	42	0	\N
257758	1874	201832000	9473	4719	43	0	\N
257759	1874	201833000	9473	4719	44	0	\N
257760	1874	201834000	9473	4719	45	0	\N
257761	1874	201835000	9473	4719	46	0	\N
257762	1874	201836000	9473	4719	47	0	\N
257763	1874	201837000	9473	4719	48	0	\N
257764	517	66254578500000	9473	4719	49	0	\N
257765	509	66254578500000	9473	4719	50	0	\N
257766	463	66254578500000	9473	4719	51	0	\N
257767	278	66254578500000	9473	4719	52	0	\N
257768	178	66254578500000	9473	4719	53	0	\N
257769	62	66254578500000	9473	4719	54	0	\N
257770	1874	201838000	9473	4719	55	0	\N
257771	1874	201839000	9473	4719	56	0	\N
257772	59	66254578500000	9473	4719	57	0	\N
257773	1678	8640245151000	9473	4719	58	0	\N
257774	1678	8640245152000	9473	4719	59	0	\N
257775	1678	8640245153000	9473	4719	60	0	\N
257776	1678	8640245154000	9473	4719	61	0	\N
257777	1678	8640245155000	9473	4719	62	0	\N
257778	1678	8640245156000	9473	4719	63	0	\N
257779	1678	8640245157000	9473	4719	64	0	\N
257780	1678	8640245158000	9473	4719	65	0	\N
257781	1678	8640245159000	9473	4719	66	0	\N
257782	1678	8640245160000	9473	4719	68	0	\N
257783	1678	8640245161000	9473	4719	69	0	\N
257784	1678	8640245162000	9473	4719	70	0	\N
257785	1678	8640245163000	9473	4719	71	0	\N
257786	1678	8640245164000	9473	4719	72	0	\N
257787	1678	8640245165000	9473	4719	73	0	\N
257788	1678	8640245166000	9473	4719	74	0	\N
257789	1874	201840000	9473	4719	75	0	\N
257790	1874	201841000	9473	4719	76	0	\N
257791	1874	201842000	9473	4719	77	0	\N
257792	1678	8640245167000	9473	4719	78	0	\N
257793	1678	8640245168000	9473	4719	79	0	\N
257794	1678	8640245169000	9473	4719	80	0	\N
257795	1678	8640245170000	9473	4719	81	0	\N
257796	1678	8640245171000	9473	4719	82	0	\N
257797	1678	8640245172000	9473	4719	83	0	\N
257798	1678	8640245173000	9473	4719	84	0	\N
257799	1678	8640245174000	9473	4719	85	0	\N
257800	1678	8640245175000	9473	4719	86	0	\N
257801	1678	8640245176000	9473	4719	87	0	\N
257802	1678	8640245177000	9473	4719	88	0	\N
257803	1678	8640245178000	9473	4719	89	0	\N
257804	1678	8640245179000	9473	4719	90	0	\N
257805	1678	8640245180000	9473	4719	91	0	\N
257806	1678	8640245181000	9473	4719	92	0	\N
257807	1678	8640245182000	9473	4719	93	0	\N
257808	1678	8640245183000	9473	4719	94	0	\N
257809	1678	8640245184000	9473	4719	95	0	\N
257810	1678	8640245185000	9473	4719	96	0	\N
257811	1678	8640245186000	9473	4719	97	0	\N
257812	1678	8640245187000	9473	4719	98	0	\N
257813	1678	8640245188000	9473	4719	99	0	\N
257814	1678	8640245189000	9473	4719	100	0	\N
257815	1678	8640245190000	9473	4719	101	0	\N
257816	1678	8640245191000	9473	4719	102	0	\N
257817	1678	8640245192000	9473	4719	103	0	\N
257818	1678	8640245193000	9473	4719	104	0	\N
257819	1678	8640245194000	9473	4719	105	0	\N
257820	1678	8640245195000	9473	4719	106	0	\N
257821	1678	8640245196000	9473	4719	107	0	\N
257822	1678	8640245197000	9473	4719	108	0	\N
257823	1678	8640245198000	9473	4719	109	0	\N
257824	1678	8640245199000	9473	4719	110	0	\N
257825	1678	8640245200000	9473	4719	111	0	\N
257826	1678	8640245201000	9473	4719	112	0	\N
257827	1678	8640245202000	9473	4719	113	0	\N
257828	1678	8640245203000	9473	4719	114	0	\N
257829	1678	8640245204000	9473	4719	115	0	\N
257830	1678	8640245205000	9473	4719	116	0	\N
257831	1678	8640245206000	9473	4719	117	0	\N
257832	1678	8640245207000	9473	4719	118	0	\N
257833	1678	8640245208000	9473	4719	119	0	\N
257834	1678	8640245209000	9473	4719	120	0	\N
257835	1678	8640245210000	9473	4719	121	0	\N
257836	1678	8640245211000	9473	4719	122	0	\N
257837	1678	8640245212000	9473	4719	123	0	\N
257838	1678	8640245213000	9473	4719	124	0	\N
257839	1678	8640245214000	9473	4719	125	0	\N
257847	1678	8640245398000	9476	4914	0	0	\N
257848	1874	202095000	9476	4914	1	0	\N
257842	1678	8640245395000	9474	4912	2	0	0
257843	1678	8640245396000	9475	4913	0	0	0
257844	1678	8640245397000	9475	4913	1	0	0
257845	1874	202093000	9475	4913	2	0	0
257846	1874	202094000	9475	4913	3	0	0
257850	1874	202095000	9477	4914	1	0	0
257851	1974	200000000	9478	4915	0	0	0
257852	1975	200000000	9478	4915	1	0	0
257853	1678	8640245399000	9478	4915	3	0	0
257854	1874	202096000	9478	4915	4	0	0
257856	1874	202097000	9479	4916	1	0	0
257857	1678	8640245400000	9480	4916	0	0	\N
257858	1874	202097000	9480	4916	1	0	\N
257859	1678	8640245400000	9481	4916	0	0	\N
257860	1874	202097000	9481	4916	1	0	\N
257863	1678	8640245401000	9483	4917	0	0	\N
257864	1874	202098000	9483	4917	1	0	\N
257865	1474	16834304000000	9484	4918	0	0	\N
257866	1874	202099000	9484	4918	1	0	\N
257867	1874	202100000	9484	4918	2	0	\N
257868	1874	202101000	9484	4918	3	0	\N
257869	1678	8640245402000	9484	4918	4	0	\N
257870	1678	8640245403000	9484	4918	5	0	\N
257871	1678	8640245404000	9484	4918	6	0	\N
257885	1874	202104000	9489	4922	0	0	\N
257886	1678	8640245408000	9489	4922	1	0	\N
257894	1956	2000000000	9493	4925	0	0	\N
257895	1874	202107000	9493	4925	1	0	\N
257896	1678	8640245411000	9493	4925	2	0	\N
257897	1678	8640245412000	9493	4925	3	0	\N
257898	1874	202108000	9493	4925	4	0	\N
257904	1874	202109000	9495	4926	0	0	\N
257905	1678	8640245413000	9495	4926	1	0	\N
257908	1874	202109000	9497	4926	0	0	\N
257909	1678	8640245413000	9497	4926	1	0	\N
257910	1874	202109000	9498	4926	0	0	\N
257911	1678	8640245413000	9498	4926	1	0	\N
257918	1874	202112000	9501	4928	0	0	\N
257919	1678	8640245416000	9501	4928	1	0	\N
257920	1956	2000000000	9502	4929	0	0	\N
257921	1874	202113000	9502	4929	1	0	\N
257922	1678	8640245417000	9502	4929	2	0	\N
257923	1956	2000000000	9503	4929	0	0	\N
257924	1874	202113000	9503	4929	1	0	\N
257925	1678	8640245417000	9503	4929	2	0	\N
257926	1956	2000000000	9504	4929	0	0	\N
257927	1874	202113000	9504	4929	1	0	\N
257928	1678	8640245417000	9504	4929	2	0	\N
257929	1956	2000000000	9505	4929	0	0	\N
257930	1874	202113000	9505	4929	1	0	\N
257931	1678	8640245417000	9505	4929	2	0	\N
257935	1874	202114000	9507	4930	0	0	\N
257936	1678	8640245418000	9507	4930	1	0	\N
257941	1874	202116000	9510	4932	0	0	\N
257942	1678	8640245420000	9510	4932	1	0	\N
257943	1678	8640245421000	9510	4932	2	0	\N
257947	1874	202116000	9512	4932	0	0	\N
257948	1678	8640245420000	9512	4932	1	0	\N
257949	1678	8640245421000	9512	4932	2	0	\N
257952	1678	8640245422000	9514	4933	0	0	\N
257953	1874	202117000	9514	4933	1	0	\N
257956	1678	8640245423000	9516	4934	0	0	\N
257957	1874	202118000	9516	4934	1	0	\N
257958	1874	202119000	9517	4935	0	0	\N
257959	1678	8640245424000	9517	4935	1	0	\N
257964	1977	500000000	9520	4937	0	0	\N
257965	1874	202121000	9520	4937	1	0	\N
257966	1950	618080000000	9520	4937	2	0	\N
257967	1678	8640245426000	9520	4937	3	0	\N
257968	1678	8640245427000	9520	4937	4	0	\N
257969	1874	202122000	9520	4937	5	0	\N
257970	1977	500000000	9521	4937	0	0	\N
257971	1874	202121000	9521	4937	1	0	\N
257972	1950	618080000000	9521	4937	2	0	\N
257973	1678	8640245426000	9521	4937	3	0	\N
257974	1678	8640245427000	9521	4937	4	0	\N
257975	1874	202122000	9521	4937	5	0	\N
257976	1977	500000000	9522	4937	0	0	\N
257977	1874	202121000	9522	4937	1	0	\N
257978	1950	618080000000	9522	4937	2	0	\N
257979	1678	8640245426000	9522	4937	3	0	\N
257980	1678	8640245427000	9522	4937	4	0	\N
257981	1874	202122000	9522	4937	5	0	\N
257988	1678	8640245428000	9524	4938	0	0	\N
257989	1678	8640245429000	9524	4938	1	0	\N
257990	1874	202123000	9524	4938	2	0	\N
257991	1874	202124000	9524	4938	3	0	\N
257992	44	82541008000000	9524	4938	4	0	\N
257872	1474	16834304000000	9485	4918	0	0	6
257873	1874	202099000	9485	4918	1	0	0
257874	1874	202100000	9485	4918	2	0	0
257875	1874	202101000	9485	4918	3	0	0
257876	1678	8640245402000	9485	4918	4	0	0
257878	1678	8640245404000	9485	4918	6	0	0
257879	1874	202102000	9486	4919	0	0	0
257880	1678	8640245405000	9486	4919	1	0	0
257881	1678	8640245406000	9487	4920	0	0	0
257882	1874	202103000	9487	4920	1	0	0
257884	1678	8640245407000	9488	4921	1	0	0
257887	1874	202104000	9490	4922	0	0	0
257888	1678	8640245408000	9490	4922	1	0	0
257889	1874	202105000	9491	4923	0	0	0
257891	1956	2000000000	9492	4924	0	0	0
257892	1678	8640245410000	9492	4924	1	0	0
257893	1874	202106000	9492	4924	2	0	0
257899	1956	2000000000	9494	4925	0	0	0
257900	1874	202107000	9494	4925	1	0	0
257902	1678	8640245412000	9494	4925	3	0	0
257903	1874	202108000	9494	4925	4	0	0
257906	1874	202109000	9496	4926	0	0	0
257907	1678	8640245413000	9496	4926	1	0	0
257912	1874	202110000	9499	4927	0	0	0
257914	1678	8640245414000	9499	4927	2	0	0
257915	1678	8640245415000	9499	4927	3	0	0
257916	1874	202112000	9500	4928	0	0	0
257917	1678	8640245416000	9500	4928	1	0	0
257933	1874	202113000	9506	4929	1	0	0
257934	1678	8640245417000	9506	4929	2	0	0
257937	1874	202114000	9508	4930	0	0	0
257938	1678	8640245418000	9508	4930	1	0	0
257939	1874	202115000	9509	4931	0	0	0
257944	1874	202116000	9511	4932	0	0	0
257945	1678	8640245420000	9511	4932	1	0	0
257946	1678	8640245421000	9511	4932	2	0	0
257950	1678	8640245422000	9513	4933	0	0	0
257951	1874	202117000	9513	4933	1	0	0
257955	1874	202118000	9515	4934	1	0	0
257960	1874	202119000	9518	4935	0	0	0
257961	1678	8640245424000	9518	4935	1	0	0
257962	1678	8640245425000	9519	4936	0	0	0
257982	1977	500000000	9523	4937	0	0	0
257983	1874	202121000	9523	4937	1	0	0
257984	1950	618080000000	9523	4937	2	0	2
257985	1678	8640245426000	9523	4937	3	0	0
257986	1678	8640245427000	9523	4937	4	0	0
258005	1036	906130465000000	9529	4942	0	0	\N
258006	1874	202127000	9529	4942	1	0	\N
258007	1874	202128000	9529	4942	2	0	\N
258008	1678	8640245432000	9529	4942	3	0	\N
258009	1678	8640245433000	9529	4942	4	0	\N
258015	1156	611384750000000	9531	4943	0	0	\N
258016	1678	8640245434000	9531	4943	1	0	\N
258017	1678	8640245435000	9531	4943	2	0	\N
258018	1874	202129000	9531	4943	3	0	\N
258019	1874	202130000	9531	4943	4	0	\N
258025	1874	202131000	9533	4944	0	0	\N
258026	1678	8640245436000	9533	4944	1	0	\N
258029	1874	202131000	9535	4944	0	0	\N
258030	1678	8640245436000	9535	4944	1	0	\N
258031	916	505655775000000	9536	4945	0	0	\N
258032	1678	8640245437000	9536	4945	1	0	\N
258033	1874	202132000	9536	4945	2	0	\N
258037	916	505655775000000	9538	4945	0	0	\N
258038	1678	8640245437000	9538	4945	1	0	\N
258048	1874	202134000	9541	4947	0	0	\N
258049	1874	202135000	9541	4947	1	0	\N
258050	1678	8640245440000	9541	4947	2	0	\N
258051	1678	8640245441000	9541	4947	3	0	\N
258052	1874	202134000	9542	4947	0	0	\N
258053	1874	202135000	9542	4947	1	0	\N
258054	1678	8640245440000	9542	4947	2	0	\N
258055	1678	8640245441000	9542	4947	3	0	\N
258062	1678	8640245444000	9546	4950	0	0	\N
258063	1874	202138000	9546	4950	1	0	\N
258072	1678	8640245448000	9550	4953	0	0	\N
258073	1874	202142000	9550	4953	1	0	\N
258074	1678	8640245448000	9551	4953	0	0	\N
258076	1678	8640245449000	9555	4954	0	0	\N
258093	1678	8640245456000	9563	4959	0	0	\N
258094	1874	202149000	9563	4959	1	0	\N
258095	1874	202150000	9563	4959	2	0	\N
258096	1678	8640245457000	9563	4959	3	0	\N
258097	1874	202151000	9564	4960	0	0	\N
258098	1678	8640245458000	9564	4960	1	0	\N
258099	1950	889410000000	9564	4960	2	0	\N
258103	1874	202152000	9566	4961	0	0	\N
258104	1678	8640245459000	9566	4961	1	0	\N
258107	1874	202152000	9568	4961	0	0	\N
258108	1678	8640245459000	9568	4961	1	0	\N
258118	1874	202153000	9570	4962	0	0	\N
258119	1874	202154000	9570	4962	1	0	\N
258120	1874	202155000	9570	4962	2	0	\N
258121	1874	202156000	9570	4962	3	0	\N
258122	1678	8640245460000	9570	4962	4	0	\N
258123	1678	8640245461000	9570	4962	5	0	\N
258124	1678	8640245462000	9570	4962	6	0	\N
258125	1678	8640245463000	9570	4962	7	0	\N
258126	1950	3689410000000	9570	4962	8	0	\N
257995	1874	202123000	9525	4938	2	0	0
257996	1874	202124000	9525	4938	3	0	0
257997	44	82541008000000	9525	4938	4	0	2
257998	1282	1703674637751650	9526	4939	0	0	0
257999	1950	918080000000	9526	4939	1	0	2
258001	1874	202125000	9526	4939	3	0	0
258002	1474	16836304000000	9526	4939	4	0	6
258003	1678	8640245431000	9527	4940	0	0	0
258004	1874	202126000	9527	4940	1	0	0
258010	1036	906130465000000	9530	4942	0	0	0
258012	1874	202128000	9530	4942	2	0	0
258013	1678	8640245432000	9530	4942	3	0	0
258014	1678	8640245433000	9530	4942	4	0	0
258020	1156	611384750000000	9532	4943	0	0	0
258022	1678	8640245435000	9532	4943	2	0	0
258023	1874	202129000	9532	4943	3	0	0
258024	1874	202130000	9532	4943	4	0	0
258027	1874	202131000	9534	4944	0	0	0
258028	1678	8640245436000	9534	4944	1	0	0
258035	1678	8640245437000	9537	4945	1	0	0
258036	1874	202132000	9537	4945	2	0	0
258039	1977	1109500000000	9539	4946	0	0	0
258040	1971	427570000000	9539	4946	1	0	0
258041	1678	8640245438000	9539	4946	2	0	0
258043	1874	202133000	9539	4946	4	0	0
258044	1874	202134000	9540	4947	0	0	0
258045	1874	202135000	9540	4947	1	0	0
258046	1678	8640245440000	9540	4947	2	0	0
258056	1874	202136000	9543	4948	0	0	0
258057	1678	8640245442000	9543	4948	1	0	0
258058	1678	8640245443000	9544	4949	0	0	0
258059	1874	202137000	9544	4949	1	0	0
258060	1678	8640245444000	9545	4950	0	0	0
258064	1678	8640245445000	9547	4951	0	0	0
258065	1678	8640245446000	9547	4951	1	0	0
258066	1874	202139000	9547	4951	2	0	0
258067	1874	202140000	9547	4951	3	0	0
258068	1678	8640245447000	9548	4952	0	0	0
258070	1678	8640245448000	9549	4953	0	0	0
258071	1874	202142000	9549	4953	1	0	0
258075	1678	8640245449000	9553	4954	0	0	0
258077	1678	8640245450000	9558	4955	0	0	0
258079	1874	202143000	9558	4955	2	0	0
258080	1874	202144000	9558	4955	3	0	0
258081	1874	202145000	9559	4956	0	0	0
258082	1874	202146000	9559	4956	1	0	0
258083	1678	8640245452000	9559	4956	2	0	0
258085	1678	8640245454000	9560	4957	0	0	0
258086	1874	202147000	9560	4957	1	0	0
258087	1874	202148000	9561	4958	0	0	0
258088	1678	8640245455000	9561	4958	1	0	0
258089	1678	8640245456000	9562	4959	0	0	0
258091	1874	202150000	9562	4959	2	0	0
258092	1678	8640245457000	9562	4959	3	0	0
258100	1874	202151000	9565	4960	0	0	0
258101	1678	8640245458000	9565	4960	1	0	0
258105	1874	202152000	9567	4961	0	0	0
258106	1678	8640245459000	9567	4961	1	0	0
258109	1874	202153000	9569	4962	0	0	0
258110	1874	202154000	9569	4962	1	0	0
258111	1874	202155000	9569	4962	2	0	0
258113	1678	8640245460000	9569	4962	4	0	0
258114	1678	8640245461000	9569	4962	5	0	0
258115	1678	8640245462000	9569	4962	6	0	0
258116	1678	8640245463000	9569	4962	7	0	0
258117	1950	3689410000000	9569	4962	8	0	3
258128	1678	8640245464000	9571	4963	1	0	0
258130	1678	8640245465000	9572	4964	0	0	\N
258131	1874	202158000	9572	4964	1	0	\N
258142	1874	202162000	9578	4968	0	0	\N
258146	1978	2000000000	9580	4969	0	0	\N
258147	1874	202163000	9580	4969	1	0	\N
258148	1678	8640245470000	9580	4969	2	0	\N
258153	1874	202166000	9583	4972	1	0	\N
258154	1678	8640245473000	9583	4972	2	0	\N
258155	1678	8640245474000	9583	4972	3	0	\N
258159	1874	202167000	9585	4973	0	0	\N
258160	1678	8640245475000	9585	4973	1	0	\N
258163	1874	202168000	9587	4974	0	0	\N
258164	1678	8640245476000	9587	4974	1	0	\N
258167	1874	202168000	9589	4974	0	0	\N
258168	1678	8640245476000	9589	4974	1	0	\N
258171	1874	202169000	9591	4975	0	0	\N
258172	1678	8640245477000	9591	4975	1	0	\N
258173	1874	202170000	9592	4976	0	0	\N
258174	1678	8640245478000	9592	4976	1	0	\N
258175	1874	202170000	9593	4976	0	0	\N
258176	1678	8640245478000	9593	4976	1	0	\N
258189	1874	202174000	9598	4979	0	0	\N
258190	1678	8640245482000	9598	4979	1	0	\N
258191	1874	202175000	9598	4979	2	0	\N
258192	1678	8640245483000	9598	4979	3	0	\N
258193	1874	202176000	9599	4980	0	0	\N
258194	1678	8640245484000	9599	4980	1	0	\N
258195	1950	3989400000000	9599	4980	2	0	\N
258199	1874	202176000	9601	4980	0	0	\N
258200	1678	8640245484000	9601	4980	1	0	\N
258201	1950	3989400000000	9601	4980	2	0	\N
258210	1678	8640245487000	9605	4983	0	0	\N
258211	1874	202178000	9605	4983	1	0	\N
258212	1874	202179000	9605	4983	2	0	\N
258213	1678	8640245488000	9605	4983	3	0	\N
258214	1678	8640245489000	9606	4984	0	0	\N
258215	1874	202180000	9606	4984	1	0	\N
258216	1678	8640245490000	9606	4984	2	0	\N
258217	1874	202181000	9606	4984	3	0	\N
258228	1678	8640245493000	9610	4986	0	0	\N
258229	1874	202184000	9610	4986	1	0	\N
258230	1874	202185000	9611	4987	0	0	\N
258231	1678	8640245494000	9611	4987	1	0	\N
258232	1874	202185000	9612	4987	0	0	\N
258233	1678	8640245494000	9612	4987	1	0	\N
258236	1678	8640245495000	9614	4988	0	0	\N
258237	1874	202186000	9614	4988	1	0	\N
258240	1874	202187000	9616	4989	0	0	\N
258241	1678	8640245496000	9616	4989	1	0	\N
258242	1874	202187000	9617	4989	0	0	\N
258243	1678	8640245496000	9617	4989	1	0	\N
258245	1678	8640245496000	9619	4990	0	0	\N
258246	1678	8640245497000	9619	4990	1	0	\N
258247	1678	8640245498000	9619	4990	2	0	\N
258248	1678	8640245499000	9619	4990	3	0	\N
258249	1678	8640245500000	9619	4990	4	0	\N
258250	1874	202188000	9619	4990	5	0	\N
258251	1874	202189000	9619	4990	6	0	\N
258252	1874	202190000	9619	4990	7	0	\N
258253	1874	202191000	9619	4990	8	0	\N
258263	1678	8640245496000	9621	4990	0	0	\N
258264	1678	8640245497000	9621	4990	1	0	\N
258133	1874	202158000	9573	4964	1	0	0
258134	1678	8640245466000	9574	4965	0	0	0
258135	1874	202159000	9574	4965	1	0	0
258136	1874	202160000	9575	4966	0	0	0
258137	1678	8640245467000	9575	4966	1	0	0
258139	1678	8640245468000	9576	4967	1	0	0
258140	1678	8640245469000	9577	4968	0	0	0
258141	1874	202162000	9577	4968	1	0	0
258143	1978	2000000000	9579	4969	0	0	0
258144	1874	202163000	9579	4969	1	0	0
258149	1874	202164000	9581	4970	0	0	0
258150	1678	8640245471000	9581	4970	1	0	0
258151	1678	8640245472000	9582	4971	0	0	0
258152	1874	202165000	9582	4971	1	0	0
258157	1678	8640245473000	9584	4972	2	0	0
258158	1678	8640245474000	9584	4972	3	0	0
258161	1874	202167000	9586	4973	0	0	0
258162	1678	8640245475000	9586	4973	1	0	0
258165	1874	202168000	9588	4974	0	0	0
258169	1874	202169000	9590	4975	0	0	0
258170	1678	8640245477000	9590	4975	1	0	0
258177	1874	202170000	9594	4976	0	0	0
258178	1678	8640245478000	9594	4976	1	0	0
258179	1874	202171000	9595	4977	0	0	0
258181	1678	8640245479000	9595	4977	2	0	0
258182	1678	8640245480000	9595	4977	3	0	0
258183	1874	202173000	9596	4978	0	0	0
258184	1678	8640245481000	9596	4978	1	0	0
258186	1678	8640245482000	9597	4979	1	0	0
258187	1874	202175000	9597	4979	2	0	0
258188	1678	8640245483000	9597	4979	3	0	0
258196	1874	202176000	9600	4980	0	0	0
258197	1678	8640245484000	9600	4980	1	0	0
258202	1678	8640245485000	9602	4981	0	0	0
258203	1971	1027570000000	9602	4981	1	0	0
258204	1874	202177000	9603	4982	0	0	0
258205	1678	8640245486000	9603	4982	1	0	0
258206	1678	8640245487000	9604	4983	0	0	0
258208	1874	202179000	9604	4983	2	0	0
258209	1678	8640245488000	9604	4983	3	0	0
258218	1678	8640245489000	9607	4984	0	0	0
258219	1874	202180000	9607	4984	1	0	0
258221	1874	202181000	9607	4984	3	0	0
258222	1678	8640245491000	9608	4985	0	0	0
258223	1874	202182000	9608	4985	1	0	0
258224	1678	8640245492000	9608	4985	2	0	0
258225	1874	202183000	9608	4985	3	0	0
258227	1874	202184000	9609	4986	1	0	0
258234	1874	202185000	9613	4987	0	0	0
258235	1678	8640245494000	9613	4987	1	0	0
258238	1678	8640245495000	9615	4988	0	0	0
258239	1874	202186000	9615	4988	1	0	0
258254	1678	8640245496000	9620	4990	0	0	0
258255	1678	8640245497000	9620	4990	1	0	0
258256	1678	8640245498000	9620	4990	2	0	0
258257	1678	8640245499000	9620	4990	3	0	0
258259	1874	202188000	9620	4990	5	0	0
258260	1874	202189000	9620	4990	6	0	0
258261	1874	202190000	9620	4990	7	0	0
258262	1874	202191000	9620	4990	8	0	0
258265	1678	8640245498000	9621	4990	2	0	\N
258266	1678	8640245499000	9621	4990	3	0	\N
258267	1678	8640245500000	9621	4990	4	0	\N
258268	1874	202188000	9621	4990	5	0	\N
258269	1874	202189000	9621	4990	6	0	\N
258270	1874	202190000	9621	4990	7	0	\N
258271	1874	202191000	9621	4990	8	0	\N
258320	1678	8640245510000	9627	4996	0	0	\N
258321	1874	202201000	9627	4996	1	0	\N
258331	1678	8640245511000	9630	4997	0	0	\N
258332	1776	999000000	9630	4997	1	0	\N
258333	1678	8640245512000	9630	4997	2	0	\N
258334	1678	8640245513000	9630	4997	3	0	\N
258335	1874	202202000	9630	4997	4	0	\N
258336	1874	202203000	9630	4997	5	0	\N
258337	1874	202204000	9630	4997	6	0	\N
258342	1678	8640245515000	9633	4999	0	0	\N
258353	1678	8640245519000	9635	5001	0	0	\N
258354	1874	202210000	9635	5001	1	0	\N
258355	1874	202211000	9635	5001	2	0	\N
258356	1678	8640245520000	9635	5001	3	0	\N
258361	1388	1702109704351650	9637	4997	0	0	\N
258362	1142	905296755600000	9637	4997	1	0	\N
258363	1262	610821326200000	9637	4997	2	0	\N
258364	1022	505191064000000	9637	4997	3	0	\N
258365	1678	8640245521000	9638	5002	0	0	\N
258366	1874	202212000	9638	5002	1	0	\N
258367	1678	8640245521000	9639	5002	0	0	\N
258368	1874	202212000	9639	5002	1	0	\N
258369	1678	8640245521000	9640	5002	0	0	\N
258370	1874	202212000	9640	5002	1	0	\N
258371	1678	8640245521000	9641	5002	0	0	\N
258372	1874	202212000	9641	5002	1	0	\N
258375	1678	8640245521000	9643	5002	0	0	\N
258376	1874	202212000	9643	5002	1	0	\N
258383	1678	8640245525000	9648	5006	0	0	\N
258384	1979	16556460000000	9648	5006	1	0	\N
258385	1874	202216000	9648	5006	2	0	\N
258391	1874	202217000	9651	5007	0	0	\N
258392	1678	8640245526000	9651	5007	1	0	\N
258393	1678	8640245527000	9652	5008	0	0	\N
258394	1874	202218000	9652	5008	1	0	\N
258274	1678	8640245503000	9622	4991	2	0	0
258275	1874	202192000	9622	4991	3	0	0
258276	1874	202193000	9622	4991	4	0	0
258277	1874	202194000	9622	4991	5	0	0
258278	1874	202195000	9623	4992	0	0	0
258280	1678	8640245505000	9623	4992	2	0	0
258281	1678	8640245506000	9623	4992	3	0	0
258282	1874	202196000	9623	4992	5	0	0
258283	1874	202197000	9623	4992	6	0	0
258284	1874	202198000	9624	4993	0	0	0
258286	1979	50000000	9624	4993	2	0	0
258287	1874	202199000	9625	4994	0	0	0
258288	1678	8640245508000	9625	4994	1	0	0
258289	1874	202200000	9626	4995	0	0	0
258291	57	66454027022968	9626	4995	2	0	0
258292	1500	0	9626	4995	3	0	0
258293	60	66454027022968	9626	4995	4	0	0
258294	61	66454027022968	9626	4995	5	0	0
258295	21	32781972906270	9626	4995	6	0	0
258297	73	66454027022968	9626	4995	8	0	0
258298	68	66454027022968	9626	4995	9	0	0
258299	67	66454027022968	9626	4995	10	0	0
258300	81	66454027022968	9626	4995	11	0	0
258301	156	66454027022968	9626	4995	12	0	0
258303	129	66454027022968	9626	4995	14	0	0
258304	428	66454027022968	9626	4995	15	0	0
258305	432	66454027022968	9626	4995	16	0	0
258306	433	66454027022968	9626	4995	17	0	0
258308	222	66454027022968	9626	4995	19	0	0
258309	431	66454027022968	9626	4995	20	0	0
258310	574	66454027022968	9626	4995	21	0	0
258311	256	66454027022968	9626	4995	22	0	0
258312	604	66454027022968	9626	4995	23	0	0
258314	371	66454027022968	9626	4995	25	0	0
258315	638	66454027022968	9626	4995	26	0	0
258316	951	506311163363221	9626	4995	27	0	0
258317	1071	907305028977293	9626	4995	28	0	0
258318	1191	612176879988533	9626	4995	29	0	0
258322	1678	8640245510000	9628	4996	0	0	0
258323	1874	202201000	9628	4996	1	0	0
258324	1678	8640245511000	9629	4997	0	0	0
258325	1776	999000000	9629	4997	1	0	1
258327	1678	8640245513000	9629	4997	3	0	0
258328	1874	202202000	9629	4997	4	0	0
258329	1874	202203000	9629	4997	5	0	0
258330	1874	202204000	9629	4997	6	0	0
258338	1678	8640245514000	9631	4998	0	0	0
258340	1874	202206000	9631	4998	2	0	0
258341	1678	8640245515000	9632	4999	0	0	0
258343	1678	8640245516000	9634	5000	0	0	0
258344	1678	8640245517000	9634	5000	1	0	0
258345	1678	8640245518000	9634	5000	2	0	0
258347	1874	202208000	9634	5000	4	0	0
258348	1874	202209000	9634	5000	5	0	0
258349	1388	1702109704351650	9634	5000	6	0	0
258350	1142	905296755600000	9634	5000	7	0	0
258352	1022	505191064000000	9634	5000	9	0	0
258357	1678	8640245519000	9636	5001	0	0	0
258358	1874	202210000	9636	5001	1	0	0
258359	1874	202211000	9636	5001	2	0	0
258360	1678	8640245520000	9636	5001	3	0	0
258374	1874	202212000	9642	5002	1	0	0
258377	1678	8640245522000	9645	5003	0	0	0
258378	1874	202213000	9645	5003	1	0	0
258379	1874	202214000	9646	5004	0	0	0
258380	1678	8640245523000	9646	5004	1	0	0
258382	1678	8640245524000	9647	5005	1	0	0
258386	1678	8640245525000	9649	5006	0	0	0
258387	1979	16556460000000	9649	5006	1	0	2
258388	1874	202216000	9649	5006	2	0	0
258390	1678	8640245526000	9650	5007	1	0	0
258395	1678	8640245527000	9653	5008	0	0	0
258396	1874	202218000	9653	5008	1	0	0
258397	1776	275574970106	9654	5009	0	0	1
258398	1874	202219000	9654	5009	1	0	0
258400	1776	317177389610	9655	5010	0	0	1
258412	1874	202223000	9658	5013	0	0	\N
258413	1678	8640245533000	9658	5013	1	0	\N
258414	1874	202223000	9659	5013	0	0	\N
258415	1678	8640245533000	9659	5013	1	0	\N
258420	1678	8640245535000	9662	5015	0	0	\N
258421	1874	202225000	9662	5015	1	0	\N
258422	1776	1141043942876	9662	5015	2	0	\N
258426	1678	8640245535000	9664	5015	0	0	\N
258427	1874	202225000	9664	5015	1	0	\N
258428	1776	1141043942876	9664	5015	2	0	\N
258433	1678	8640245538000	9666	5017	0	0	\N
258434	1874	202228000	9666	5017	1	0	\N
258439	1678	8640245540000	9669	5019	0	0	\N
258440	1874	202230000	9669	5019	1	0	\N
258441	1678	8640245540000	9670	5019	0	0	\N
258442	1874	202230000	9670	5019	1	0	\N
258445	1678	8640245541000	9672	5020	0	0	\N
258446	1678	8640245542000	9672	5020	1	0	\N
258447	1874	202231000	9672	5020	2	0	\N
258448	1874	202232000	9672	5020	3	0	\N
258449	44	82541008000000	9672	5020	4	0	\N
258450	1678	8640245541000	9673	5020	0	0	\N
258451	1678	8640245542000	9673	5020	1	0	\N
258452	1874	202231000	9673	5020	2	0	\N
258453	1874	202232000	9673	5020	3	0	\N
258454	44	82541008000000	9673	5020	4	0	\N
258465	1678	8640245543000	9676	5021	0	0	\N
258466	1390	1693980637758216	9676	5021	1	0	\N
258467	1144	900973465003492	9676	5021	2	0	\N
258468	1898	30000000	9677	5022	0	0	\N
258469	1898	40000000	9677	5022	1	0	\N
258470	1678	8640245544000	9677	5022	2	0	\N
258471	1024	502777775001948	9677	5022	3	0	\N
258472	1898	30000000	9678	5022	0	0	\N
258473	1874	202233000	9678	5022	1	0	\N
258474	1898	40000000	9678	5022	2	0	\N
258475	1678	8640245544000	9678	5022	3	0	\N
258476	1264	607904750002356	9678	5022	4	0	\N
258477	1024	502777775001948	9678	5022	5	0	\N
258482	1898	30000000	9680	5022	0	0	\N
258483	1874	202233000	9680	5022	1	0	\N
258484	1898	40000000	9680	5022	2	0	\N
258485	1678	8640245544000	9680	5022	3	0	\N
258486	1264	607904750002356	9680	5022	4	0	\N
258487	1024	502777775001948	9680	5022	5	0	\N
258488	1898	30000000	9681	5022	0	0	\N
258489	1898	40000000	9681	5022	1	0	\N
258490	1678	8640245544000	9681	5022	2	0	\N
258491	1024	502777775001948	9681	5022	3	0	\N
258495	1678	8640245546000	9683	5024	0	0	\N
258496	1874	202235000	9683	5024	1	0	\N
258499	1678	8640245546000	9685	5024	0	0	\N
258500	1874	202235000	9685	5024	1	0	\N
258501	1678	8640245546000	9686	5024	0	0	\N
258502	1874	202235000	9686	5024	1	0	\N
258515	1144	904465869724003	9690	5028	0	0	\N
258516	1678	8640245551000	9690	5028	1	0	\N
258517	1264	610261145058365	9690	5028	2	0	\N
258518	1024	504726670882892	9690	5028	3	0	\N
258519	1874	202240000	9690	5028	4	0	\N
258520	1874	202241000	9690	5028	5	0	\N
258521	1874	202242000	9690	5028	6	0	\N
258522	1678	8640245552000	9690	5028	7	0	\N
258523	1678	8640245553000	9690	5028	8	0	\N
258524	700	66001260000000	9690	5028	9	0	\N
258536	1678	8640245554000	9693	5029	0	0	\N
258403	1874	202221000	9656	5011	0	0	0
258404	931	504869452205387	9656	5011	1	0	0
258405	1678	8640245530000	9656	5011	2	0	0
258406	1874	202222000	9657	5012	0	0	0
258407	1678	8640245531000	9657	5012	1	0	0
258409	1051	904721732631329	9657	5012	3	0	0
258410	1171	610433780858977	9657	5012	4	0	0
258411	1297	1701028007113081	9657	5012	5	0	0
258416	1874	202223000	9660	5013	0	0	0
258417	1678	8640245533000	9660	5013	1	0	0
258419	1874	202224000	9661	5014	1	0	0
258423	1678	8640245535000	9663	5015	0	0	0
258424	1874	202225000	9663	5015	1	0	0
258425	1776	1141043942876	9663	5015	2	0	1
258430	1874	202227000	9665	5016	1	0	0
258431	1678	8640245536000	9665	5016	2	0	0
258432	1678	8640245537000	9665	5016	3	0	0
258435	1678	8640245538000	9667	5017	0	0	0
258436	1874	202228000	9667	5017	1	0	0
258438	1678	8640245539000	9668	5018	1	0	0
258443	1678	8640245540000	9671	5019	0	0	0
258444	1874	202230000	9671	5019	1	0	0
258455	1678	8640245541000	9674	5020	0	0	0
258456	1678	8640245542000	9674	5020	1	0	0
258458	1874	202232000	9674	5020	3	0	0
258459	44	82541008000000	9674	5020	4	0	2
258460	1874	202233000	9675	5021	0	0	0
258461	1678	8640245543000	9675	5021	1	0	0
258463	1144	900973465003492	9675	5021	3	0	0
258464	1264	607904750002356	9675	5021	4	0	0
258478	1898	30000000	9679	5022	0	0	0
258479	1898	40000000	9679	5022	1	0	0
258480	1678	8640245544000	9679	5022	2	0	0
258492	1898	50000000	9682	5023	0	0	0
258493	1678	8640245545000	9682	5023	1	0	0
258494	1874	202234000	9682	5023	2	0	0
258497	1678	8640245546000	9684	5024	0	0	0
258498	1874	202235000	9684	5024	1	0	0
258504	1678	8640245547000	9687	5025	1	0	0
258505	1678	8640245548000	9688	5026	0	0	0
258506	1678	8640245549000	9688	5026	1	0	0
258507	1874	202237000	9688	5026	2	0	0
258509	1874	202238000	9688	5026	4	0	0
258510	1981	101000000000	9689	5027	0	0	0
258511	1980	7198000000000	9689	5027	1	0	0
258512	1874	202239000	9689	5027	2	0	0
258513	1390	1700546942100752	9689	5027	3	0	0
258525	1144	904465869724003	9691	5028	0	0	0
258526	1678	8640245551000	9691	5028	1	0	0
258527	1264	610261145058365	9691	5028	2	0	0
258528	1024	504726670882892	9691	5028	3	0	0
258529	1874	202240000	9691	5028	4	0	0
258531	1874	202242000	9691	5028	6	0	0
258532	1678	8640245552000	9691	5028	7	0	0
258533	1678	8640245553000	9691	5028	8	0	0
258534	700	66001260000000	9691	5028	9	0	2
258537	1874	202243000	9694	5030	0	0	\N
258538	1682	11441000000	9694	5030	1	0	\N
258539	1678	8640245555000	9694	5030	2	0	\N
258543	1981	101000000000	9696	5026	0	0	\N
258544	1678	8640245548000	9696	5026	1	0	\N
258545	1678	8640245549000	9696	5026	2	0	\N
258546	1682	11441000000	9696	5026	3	0	\N
258547	1390	1700546942100752	9696	5026	4	0	\N
258548	1144	904465869724003	9696	5026	5	0	\N
258549	1874	202237000	9696	5026	6	0	\N
258550	1980	1000000000	9696	5026	7	0	\N
258551	1980	7198000000000	9696	5026	8	0	\N
258552	1678	8640245550000	9696	5026	9	0	\N
258553	1678	8640245551000	9696	5026	10	0	\N
258554	1264	610261145058365	9696	5026	11	0	\N
258555	1024	504726670882892	9696	5026	12	0	\N
258556	1678	8640245552000	9696	5026	13	0	\N
258557	1678	8640245553000	9696	5026	14	0	\N
258558	1678	8640245554000	9696	5026	15	0	\N
258559	1678	8640245555000	9696	5026	16	0	\N
258560	1874	202238000	9696	5026	17	0	\N
258561	1874	202239000	9696	5026	18	0	\N
258562	1874	202240000	9696	5026	19	0	\N
258563	1874	202241000	9696	5026	20	0	\N
258564	1874	202242000	9696	5026	21	0	\N
258565	1874	202243000	9696	5026	22	0	\N
258566	596	83898262000000	9697	5031	0	0	\N
258567	1678	8640245556000	9697	5031	1	0	\N
258568	1874	202244000	9697	5031	2	0	\N
258569	596	83898262000000	9698	5031	0	0	\N
258570	1678	8640245556000	9698	5031	1	0	\N
258571	1874	202244000	9698	5031	2	0	\N
258572	1277	1701576637751650	9698	5031	3	0	\N
258573	1031	905013465000000	9698	5031	4	0	\N
258574	596	83898262000000	9699	5031	0	0	\N
258575	1678	8640245556000	9699	5031	1	0	\N
258576	1874	202244000	9699	5031	2	0	\N
258577	1678	8640245557000	9699	5031	3	0	\N
258578	1277	1701576637751650	9699	5031	4	0	\N
258579	1031	905013465000000	9699	5031	5	0	\N
258580	1151	610630750000000	9699	5031	6	0	\N
258581	911	505032775000000	9699	5031	7	0	\N
258597	1874	202246000	9703	5033	0	0	\N
258598	1188	611101997260000	9703	5033	1	0	\N
258599	1874	202247000	9703	5033	2	0	\N
258600	1678	8640245558000	9703	5033	3	0	\N
258601	1678	8640245559000	9703	5033	4	0	\N
258602	1314	1702890051511650	9703	5033	5	0	\N
258603	1678	8640245559000	9704	5034	0	0	\N
258604	1678	8640245560000	9704	5034	1	0	\N
258605	1874	202247000	9704	5034	2	0	\N
258606	1874	202248000	9704	5034	3	0	\N
258607	1678	8640245559000	9705	5034	0	0	\N
258608	1678	8640245560000	9705	5034	1	0	\N
258609	1874	202247000	9705	5034	2	0	\N
258610	1874	202248000	9705	5034	3	0	\N
258615	1874	202248000	9707	5034	0	0	\N
258616	1678	8640245560000	9707	5034	1	0	\N
258620	1678	8640245561000	9709	5035	0	0	\N
258621	1874	202249000	9709	5035	1	0	\N
258622	764	1000010000000	9709	5035	2	0	\N
258623	1678	8640245562000	9710	5036	0	0	\N
258625	1678	8640245562000	9712	5036	0	0	\N
258630	1309	1702273637751650	9714	5037	0	0	\N
258631	1874	202250000	9714	5037	1	0	\N
258632	1063	905384465000000	9714	5037	2	0	\N
258633	1678	8640245563000	9714	5037	3	0	\N
258634	1678	8640245469000	9715	4969	0	0	\N
258635	1682	11441000000	9715	4969	2	0	\N
258636	1978	2000000000	9715	4969	3	0	\N
258637	1874	202163000	9715	4969	4	0	\N
258638	1874	202164000	9715	4969	5	0	\N
258639	1874	202165000	9715	4969	6	0	\N
258640	1874	202166000	9715	4969	7	0	\N
258641	764	1000010000000	9715	4969	8	0	\N
258642	1309	1702273637751650	9715	4969	9	0	\N
258643	1063	905384465000000	9715	4969	10	0	\N
258644	1874	202167000	9715	4969	11	0	\N
258645	1874	202168000	9715	4969	12	0	\N
258646	1874	202169000	9715	4969	13	0	\N
258647	1874	202170000	9715	4969	14	0	\N
258648	1950	3989400000000	9715	4969	15	0	\N
258649	1874	202171000	9715	4969	16	0	\N
258650	1874	202172000	9715	4969	17	0	\N
258651	1874	202173000	9715	4969	18	0	\N
258652	1874	202174000	9715	4969	19	0	\N
258653	1874	202175000	9715	4969	20	0	\N
258654	1874	202176000	9715	4969	21	0	\N
258655	1874	202177000	9715	4969	22	0	\N
258656	1874	202178000	9715	4969	23	0	\N
258657	1874	202179000	9715	4969	24	0	\N
258658	1874	202180000	9715	4969	25	0	\N
258659	948	505422111740000	9715	4969	26	0	\N
258660	1068	905712093770000	9715	4969	27	0	\N
258661	1188	611101997260000	9715	4969	28	0	\N
258662	1388	1702109704351650	9715	4969	29	0	\N
258663	1142	905296755600000	9715	4969	30	0	\N
258664	1262	610821326200000	9715	4969	31	0	\N
258665	1022	505191064000000	9715	4969	32	0	\N
258666	1314	1702890051511650	9715	4969	33	0	\N
258667	1277	1701576637751650	9715	4969	35	0	\N
258668	1031	905013465000000	9715	4969	36	0	\N
258669	1151	610630750000000	9715	4969	37	0	\N
258670	911	505032775000000	9715	4969	38	0	\N
258671	1971	1027570000000	9715	4969	39	0	\N
258672	1874	202181000	9715	4969	40	0	\N
258542	1678	8640245555000	9695	5030	2	0	0
258582	596	83898262000000	9700	5031	0	0	1
258583	1678	8640245556000	9700	5031	1	0	0
258584	1874	202244000	9700	5031	2	0	0
258585	1874	202245000	9701	5032	0	0	0
258587	948	505422111740000	9701	5032	2	0	0
258588	1068	905712093770000	9701	5032	3	0	0
258589	1277	1701576637751650	9701	5032	4	0	0
258590	1031	905013465000000	9701	5032	5	0	0
258591	1151	610630750000000	9701	5032	6	0	0
258593	1874	202246000	9702	5033	0	0	0
258594	1188	611101997260000	9702	5033	1	0	0
258595	1678	8640245558000	9702	5033	2	0	0
258596	1314	1702890051511650	9702	5033	3	0	0
258612	1678	8640245560000	9706	5034	1	0	0
258613	1874	202247000	9706	5034	2	0	0
258614	1874	202248000	9706	5034	3	0	0
258617	1678	8640245561000	9708	5035	0	0	0
258618	1874	202249000	9708	5035	1	0	0
258624	1678	8640245562000	9711	5036	0	0	0
258626	1309	1702273637751650	9713	5037	0	0	0
258627	1874	202250000	9713	5037	1	0	0
258628	1063	905384465000000	9713	5037	2	0	0
258629	1678	8640245563000	9713	5037	3	0	0
258673	1874	202182000	9715	4969	41	0	\N
258674	1874	202183000	9715	4969	42	0	\N
258675	1874	202184000	9715	4969	43	0	\N
258676	1874	202185000	9715	4969	44	0	\N
258677	1874	202186000	9715	4969	45	0	\N
258678	1874	202187000	9715	4969	46	0	\N
258679	1678	8640245470000	9715	4969	47	0	\N
258680	1678	8640245471000	9715	4969	48	0	\N
258681	1678	8640245472000	9715	4969	49	0	\N
258682	1678	8640245473000	9715	4969	50	0	\N
258683	1678	8640245474000	9715	4969	51	0	\N
258684	1678	8640245475000	9715	4969	52	0	\N
258685	1678	8640245476000	9715	4969	53	0	\N
258686	1678	8640245477000	9715	4969	54	0	\N
258687	1678	8640245478000	9715	4969	55	0	\N
258688	1678	8640245479000	9715	4969	56	0	\N
258689	1678	8640245480000	9715	4969	57	0	\N
258690	1678	8640245481000	9715	4969	58	0	\N
258691	1678	8640245482000	9715	4969	59	0	\N
258692	1678	8640245483000	9715	4969	60	0	\N
258693	1678	8640245484000	9715	4969	61	0	\N
258694	1678	8640245485000	9715	4969	62	0	\N
258695	1678	8640245486000	9715	4969	63	0	\N
258696	1678	8640245487000	9715	4969	64	0	\N
258697	1678	8640245488000	9715	4969	65	0	\N
258698	1678	8640245489000	9715	4969	66	0	\N
258699	1678	8640245490000	9715	4969	67	0	\N
258700	1678	8640245491000	9715	4969	68	0	\N
258701	1678	8640245492000	9715	4969	69	0	\N
258702	1678	8640245493000	9715	4969	70	0	\N
258703	1678	8640245494000	9715	4969	71	0	\N
258704	1874	202188000	9715	4969	72	0	\N
258705	1874	202189000	9715	4969	73	0	\N
258706	1874	202190000	9715	4969	74	0	\N
258707	1874	202191000	9715	4969	75	0	\N
258708	1874	202192000	9715	4969	76	0	\N
258709	1874	202193000	9715	4969	77	0	\N
258710	1874	202194000	9715	4969	78	0	\N
258711	1874	202195000	9715	4969	79	0	\N
258712	1874	202196000	9715	4969	80	0	\N
258713	1874	202197000	9715	4969	81	0	\N
258714	1874	202198000	9715	4969	82	0	\N
258715	1874	202199000	9715	4969	83	0	\N
258716	1874	202200000	9715	4969	84	0	\N
258717	1874	202201000	9715	4969	85	0	\N
258718	1874	202202000	9715	4969	86	0	\N
258719	1874	202203000	9715	4969	87	0	\N
258720	1874	202204000	9715	4969	88	0	\N
258721	1874	202205000	9715	4969	89	0	\N
258722	1874	202206000	9715	4969	90	0	\N
258723	1874	202207000	9715	4969	91	0	\N
258724	1874	202208000	9715	4969	92	0	\N
258725	1874	202209000	9715	4969	93	0	\N
258726	1874	202210000	9715	4969	94	0	\N
258727	1874	202211000	9715	4969	95	0	\N
258728	1874	202212000	9715	4969	96	0	\N
258729	1874	202213000	9715	4969	97	0	\N
258730	1874	202214000	9715	4969	98	0	\N
258731	1874	202215000	9715	4969	99	0	\N
258732	1874	202216000	9715	4969	100	0	\N
258733	1874	202217000	9715	4969	101	0	\N
258734	1874	202218000	9715	4969	102	0	\N
258735	1874	202219000	9715	4969	103	0	\N
258736	1874	202220000	9715	4969	104	0	\N
258737	1874	202221000	9715	4969	105	0	\N
258738	1874	202222000	9715	4969	106	0	\N
258739	1874	202223000	9715	4969	107	0	\N
258740	1874	202224000	9715	4969	108	0	\N
258741	1874	202225000	9715	4969	109	0	\N
258742	1874	202226000	9715	4969	110	0	\N
258743	1874	202227000	9715	4969	111	0	\N
258744	1874	202228000	9715	4969	112	0	\N
258745	1874	202229000	9715	4969	113	0	\N
258746	1874	202230000	9715	4969	114	0	\N
258747	1979	50000000	9715	4969	115	0	\N
258748	57	66454027022968	9715	4969	122	0	\N
258749	60	66454027022968	9715	4969	123	0	\N
258750	61	66454027022968	9715	4969	124	0	\N
258751	21	32781972906270	9715	4969	125	0	\N
258752	1309	1702273637751650	9716	5037	0	0	\N
258753	1874	202250000	9716	5037	1	0	\N
258754	1063	905384465000000	9716	5037	2	0	\N
258755	1678	8640245563000	9716	5037	3	0	\N
258756	1874	202251000	9717	5038	0	0	\N
258757	1183	610880750000000	9717	5038	1	0	\N
258758	1874	202252000	9717	5038	2	0	\N
258759	1678	8640245564000	9717	5038	3	0	\N
258760	1678	8640245565000	9717	5038	4	0	\N
258761	267	66263331324931	9717	5038	5	0	\N
258762	943	505239775000000	9718	5038	0	0	\N
258763	1874	202251000	9718	5038	1	0	\N
258764	1874	202252000	9718	5038	2	0	\N
258765	1678	8640245564000	9718	5038	3	0	\N
258766	1678	8640245565000	9718	5038	4	0	\N
258767	267	66263331324931	9718	5038	5	0	\N
258768	1874	202251000	9719	5038	0	0	\N
258769	1874	202252000	9719	5038	1	0	\N
258770	1678	8640245564000	9719	5038	2	0	\N
258771	1678	8640245565000	9719	5038	3	0	\N
258772	267	66263331324931	9719	5038	4	0	\N
258779	1874	202253000	9721	5039	0	0	\N
258780	260	66311200000000	9721	5039	1	0	\N
258781	1678	8640245566000	9721	5039	2	0	\N
258782	922	504783792237021	9721	5039	3	0	\N
258787	1956	1000000000	9723	4882	0	0	\N
258788	1956	1000000000	9723	4882	1	0	\N
258789	1956	2000000000	9723	4882	2	0	\N
258790	1956	2000000000	9723	4882	3	0	\N
258791	1474	16834304000000	9723	4882	4	0	\N
258792	1971	427570000000	9723	4882	5	0	\N
258793	1977	500000000	9723	4882	6	0	\N
258794	1282	1703674637751650	9723	4882	7	0	\N
258795	1036	906130465000000	9723	4882	8	0	\N
258796	1156	611384750000000	9723	4882	9	0	\N
258797	916	505655775000000	9723	4882	10	0	\N
258798	1977	1109500000000	9723	4882	11	0	\N
258799	1981	101000000000	9723	4882	12	0	\N
258800	940	505057775000000	9723	4882	13	0	\N
258801	1898	30000000	9723	4882	14	0	\N
258802	1682	11441000000	9723	4882	15	0	\N
258803	1978	2000000000	9723	4882	16	0	\N
258804	1898	40000000	9723	4882	17	0	\N
258805	1898	50000000	9723	4882	18	0	\N
258806	1950	389410000000	9723	4882	19	0	\N
258807	1950	689410000000	9723	4882	20	0	\N
258808	764	1000010000000	9723	4882	21	0	\N
258775	1874	202252000	9720	5038	2	0	0
258776	1678	8640245564000	9720	5038	3	0	0
258777	1678	8640245565000	9720	5038	4	0	0
258778	267	66263331324931	9720	5038	5	0	0
258783	1874	202253000	9722	5039	0	0	0
258785	1678	8640245566000	9722	5039	2	0	0
258786	922	504783792237021	9722	5039	3	0	0
258809	1309	1702273637751650	9723	4882	22	0	\N
258810	260	66311200000000	9723	4882	23	0	\N
258811	1980	1000000000	9723	4882	24	0	\N
258812	1063	905384465000000	9723	4882	25	0	\N
258813	1183	610880750000000	9723	4882	26	0	\N
258814	1950	989410000000	9723	4882	27	0	\N
258815	948	505422111740000	9723	4882	28	0	\N
258816	1068	905712093770000	9723	4882	29	0	\N
258817	1188	611101997260000	9723	4882	30	0	\N
258818	1313	1701968137751650	9723	4882	31	0	\N
258819	1388	1702109704351650	9723	4882	32	0	\N
258820	1142	905296755600000	9723	4882	33	0	\N
258821	1262	610821326200000	9723	4882	34	0	\N
258822	1022	505191064000000	9723	4882	35	0	\N
258823	1314	1702890051511650	9723	4882	36	0	\N
258824	1277	1701576637751650	9723	4882	38	0	\N
258825	1031	905013465000000	9723	4882	39	0	\N
258826	1151	610630750000000	9723	4882	41	0	\N
258827	911	505032775000000	9723	4882	42	0	\N
258828	940	505057775000000	9724	5040	0	0	\N
258829	1874	202254000	9724	5040	1	0	\N
258830	1313	1701968137751650	9724	5040	2	0	\N
258831	1874	202255000	9724	5040	3	0	\N
258832	1678	8640245567000	9724	5040	4	0	\N
258833	1678	8640245568000	9724	5040	5	0	\N
258834	1983	1000000000	9724	5040	6	0	\N
258835	1042	904568230701196	9724	5040	7	0	\N
258836	1162	610330210049358	9724	5040	8	0	\N
258837	940	505057775000000	9725	5040	0	0	\N
258838	1874	202254000	9725	5040	1	0	\N
258839	1313	1701968137751650	9725	5040	2	0	\N
258840	1874	202255000	9725	5040	3	0	\N
258841	1678	8640245567000	9725	5040	4	0	\N
258842	1678	8640245568000	9725	5040	5	0	\N
258843	1983	1000000000	9725	5040	6	0	\N
258844	1042	904568230701196	9725	5040	7	0	\N
258845	1162	610330210049358	9725	5040	8	0	\N
258855	1060	905058465000000	9727	5041	0	0	\N
258856	1180	610661750000000	9727	5041	1	0	\N
258857	1306	1701661637751650	9727	5041	2	0	\N
258858	1983	1390103470000	9727	5041	3	0	\N
258859	1678	8640245569000	9727	5041	4	0	\N
258860	1678	8640245570000	9727	5041	5	0	\N
258861	1678	8640245571000	9727	5041	6	0	\N
258862	1067	905221765000000	9727	5041	7	0	\N
258863	1187	610771150000000	9727	5041	8	0	\N
258864	947	505148475000000	9727	5041	9	0	\N
258865	1874	202256000	9727	5041	10	0	\N
258866	1874	202257000	9727	5041	11	0	\N
258867	1874	202258000	9727	5041	12	0	\N
258881	1060	905058465000000	9729	5041	0	0	\N
258882	1180	610661750000000	9729	5041	1	0	\N
258883	1306	1701661637751650	9729	5041	2	0	\N
258884	1983	1390103470000	9729	5041	3	0	\N
258885	1678	8640245569000	9729	5041	4	0	\N
258886	1678	8640245570000	9729	5041	5	0	\N
258887	1678	8640245571000	9729	5041	6	0	\N
258888	1067	905221765000000	9729	5041	7	0	\N
258889	1187	610771150000000	9729	5041	8	0	\N
258890	947	505148475000000	9729	5041	9	0	\N
258891	1874	202256000	9729	5041	10	0	\N
258892	1874	202257000	9729	5041	11	0	\N
258893	1874	202258000	9729	5041	12	0	\N
258894	1678	8640245572000	9730	5042	0	0	\N
258895	1874	202259000	9730	5042	1	0	\N
258898	1678	8640245572000	9732	5042	0	0	\N
258899	1874	202259000	9732	5042	1	0	\N
258913	260	67247500000000	9734	5043	0	0	\N
258914	943	505239775000000	9734	5043	1	0	\N
258915	1365	1703504133514363	9734	5043	2	0	\N
258916	1678	8640245573000	9734	5043	3	0	\N
258917	1678	8640245574000	9734	5043	4	0	\N
258918	1678	8640245575000	9734	5043	5	0	\N
258919	1119	906038704109009	9734	5043	6	0	\N
258920	1239	611322367758868	9734	5043	7	0	\N
258921	999	505604372838895	9734	5043	8	0	\N
258922	1874	202260000	9734	5043	9	0	\N
258923	1874	202261000	9734	5043	10	0	\N
258924	1874	202262000	9734	5043	11	0	\N
258925	1984	0	9734	5043	12	0	\N
258926	260	67247500000000	9735	5043	0	0	\N
258927	943	505239775000000	9735	5043	1	0	\N
258928	1365	1703504133514363	9735	5043	2	0	\N
258929	1678	8640245573000	9735	5043	3	0	\N
258930	1678	8640245574000	9735	5043	4	0	\N
258931	1678	8640245575000	9735	5043	5	0	\N
258932	1119	906038704109009	9735	5043	6	0	\N
258933	1239	611322367758868	9735	5043	7	0	\N
258934	999	505604372838895	9735	5043	8	0	\N
258935	1874	202260000	9735	5043	9	0	\N
258936	1874	202261000	9735	5043	10	0	\N
258937	1874	202262000	9735	5043	11	0	\N
258938	1984	0	9735	5043	12	0	\N
258942	1678	8640245577000	9737	5045	0	0	\N
258943	1371	1701968637751650	9737	5045	1	0	\N
258944	1874	202264000	9737	5045	2	0	\N
258848	1313	1701968137751650	9726	5040	2	0	0
258849	1874	202255000	9726	5040	3	0	0
258850	1678	8640245567000	9726	5040	4	0	0
258851	1678	8640245568000	9726	5040	5	0	0
258852	1983	1000000000	9726	5040	6	0	0
258854	1162	610330210049358	9726	5040	8	0	0
258868	1060	905058465000000	9728	5041	0	0	0
258869	1180	610661750000000	9728	5041	1	0	0
258870	1306	1701661637751650	9728	5041	2	0	0
258871	1983	1390103470000	9728	5041	3	0	0
258873	1678	8640245570000	9728	5041	5	0	0
258874	1678	8640245571000	9728	5041	6	0	0
258875	1067	905221765000000	9728	5041	7	0	0
258876	1187	610771150000000	9728	5041	8	0	0
258878	1874	202256000	9728	5041	10	0	0
258879	1874	202257000	9728	5041	11	0	0
258880	1874	202258000	9728	5041	12	0	0
258896	1678	8640245572000	9731	5042	0	0	0
258897	1874	202259000	9731	5042	1	0	0
258901	943	505239775000000	9733	5043	1	0	0
258902	1365	1703504133514363	9733	5043	2	0	0
258903	1678	8640245573000	9733	5043	3	0	0
258904	1678	8640245574000	9733	5043	4	0	0
258905	1678	8640245575000	9733	5043	5	0	0
258907	1239	611322367758868	9733	5043	7	0	0
258908	999	505604372838895	9733	5043	8	0	0
258909	1874	202260000	9733	5043	9	0	0
258910	1874	202261000	9733	5043	10	0	0
258912	1984	0	9733	5043	12	0	0
258939	1874	202263000	9736	5044	0	0	0
258940	1288	1700739397839088	9736	5044	1	0	0
258941	1678	8640245576000	9736	5044	2	0	0
258945	1125	905222465000000	9737	5045	3	0	\N
258946	1245	610771750000000	9737	5045	4	0	\N
258947	1005	505148775000000	9737	5045	5	0	\N
258948	1984	1000000000	9737	5045	6	0	\N
258956	1371	1701968637751650	9739	5041	0	0	\N
258957	1125	905222465000000	9739	5041	1	0	\N
258958	1984	0	9739	5041	2	0	\N
258959	1984	1000000000	9739	5041	3	0	\N
258960	1874	202265000	9740	5046	0	0	\N
258961	1874	202266000	9740	5046	1	0	\N
258962	764	2298360000000	9740	5046	2	0	\N
258963	1678	8640245578000	9740	5046	3	0	\N
258964	1678	8640245579000	9740	5046	4	0	\N
258965	538	67245340000000	9740	5046	5	0	\N
258966	909	505147213510546	9740	5046	6	0	\N
258974	1371	1701968637751650	9742	5045	0	0	\N
258975	1125	905222465000000	9742	5045	1	0	\N
258976	1984	1000000000	9742	5045	2	0	\N
258977	909	505147213510546	9742	5045	3	0	\N
258980	1874	202268000	9744	5048	0	0	\N
258981	1874	202269000	9744	5048	1	0	\N
258982	1678	8640245581000	9744	5048	2	0	\N
258983	1678	8640245582000	9744	5048	3	0	\N
258984	1029	905219478509549	9744	5048	4	0	\N
258990	1678	8640245583000	9746	5049	0	0	\N
258991	1874	202270000	9746	5049	1	0	\N
258992	960	505057295000000	9746	5049	2	0	\N
258999	1678	8640245584000	9749	5050	0	0	\N
259004	1874	202272000	9751	5052	0	0	\N
259005	1678	8640245586000	9751	5052	1	0	\N
259006	1275	1701963852521252	9751	5052	2	0	\N
259010	1678	8640245587000	9753	5053	0	0	\N
259011	1874	202273000	9753	5053	1	0	\N
259020	1678	8640245590000	9757	5056	0	0	\N
259021	1874	202276000	9757	5056	1	0	\N
259022	1678	8640245590000	9758	5056	0	0	\N
259023	1874	202276000	9758	5056	1	0	\N
259041	1874	202280000	9764	5060	0	0	\N
259042	1678	8640245595000	9764	5060	1	0	\N
259043	1610	0	9764	5060	2	0	\N
259044	1874	202281000	9765	5061	0	0	\N
259045	1874	202282000	9765	5061	1	0	\N
259046	1678	8640245596000	9765	5061	2	0	\N
259047	1678	8640245597000	9765	5061	3	0	\N
259048	1678	8640245598000	9765	5061	4	0	\N
259049	1874	202283000	9765	5061	5	0	\N
259050	1874	202281000	9766	5061	0	0	\N
259051	1874	202282000	9766	5061	1	0	\N
259052	1678	8640245596000	9766	5061	2	0	\N
259053	1678	8640245597000	9766	5061	3	0	\N
259054	1678	8640245598000	9766	5061	4	0	\N
259055	1874	202283000	9766	5061	5	0	\N
259056	1874	202281000	9767	5061	0	0	\N
259057	1874	202282000	9767	5061	1	0	\N
259058	1678	8640245596000	9767	5061	2	0	\N
259059	1678	8640245597000	9767	5061	3	0	\N
259060	1678	8640245598000	9767	5061	4	0	\N
259061	1874	202283000	9767	5061	5	0	\N
259068	1874	202281000	9769	5061	0	0	\N
259069	1874	202282000	9769	5061	1	0	\N
259070	1678	8640245596000	9769	5061	2	0	\N
259071	1678	8640245597000	9769	5061	3	0	\N
259072	1678	8640245598000	9769	5061	4	0	\N
259073	1874	202283000	9769	5061	5	0	\N
259080	1874	202286000	9773	5064	0	0	\N
258951	1874	202264000	9738	5045	2	0	0
258952	1125	905222465000000	9738	5045	3	0	0
258953	1245	610771750000000	9738	5045	4	0	0
258954	1005	505148775000000	9738	5045	5	0	0
258955	1984	1000000000	9738	5045	6	0	0
258968	1874	202266000	9741	5046	1	0	0
258969	764	2298360000000	9741	5046	2	0	0
258970	1678	8640245578000	9741	5046	3	0	0
258971	1678	8640245579000	9741	5046	4	0	0
258972	538	67245340000000	9741	5046	5	0	0
258978	1678	8640245580000	9743	5047	0	0	0
258979	1874	202267000	9743	5047	1	0	0
258985	1874	202268000	9745	5048	0	0	0
258986	1874	202269000	9745	5048	1	0	0
258988	1678	8640245582000	9745	5048	3	0	0
258989	1029	905219478509549	9745	5048	4	0	0
258993	1678	8640245583000	9747	5049	0	0	0
258994	1874	202270000	9747	5049	1	0	0
258995	960	505057295000000	9747	5049	2	0	0
258997	1678	8640245584000	9748	5050	1	0	0
258998	1149	610769619922689	9748	5050	3	0	0
259000	1326	1701660877751650	9750	5051	0	0	0
259001	1200	610660900000000	9750	5051	1	0	0
259002	1080	905058345000000	9750	5051	2	0	0
259007	1874	202272000	9752	5052	0	0	0
259008	1678	8640245586000	9752	5052	1	0	0
259009	1275	1701963852521252	9752	5052	2	0	0
259012	1678	8640245587000	9754	5053	0	0	0
259014	1678	8640245588000	9755	5054	0	0	0
259015	1874	202274000	9755	5054	1	0	0
259016	908	504480415000000	9756	5055	0	0	0
259017	1874	202275000	9756	5055	1	0	0
259018	1678	8640245589000	9756	5055	2	0	0
259024	1678	8640245590000	9759	5056	0	0	0
259025	1874	202276000	9759	5056	1	0	0
259026	1985	1197000000000	9760	5057	0	0	0
259027	1678	8640245591000	9760	5057	1	0	0
259028	1028	904024575000000	9761	5058	0	0	0
259030	1874	202277000	9761	5058	2	0	0
259031	1148	609963390000000	9762	5059	0	0	0
259032	1274	1699717237751650	9762	5059	1	0	0
259033	1986	222510000000	9762	5059	2	0	0
259035	1678	8640245593000	9762	5059	4	0	0
259036	1678	8640245594000	9762	5059	5	0	0
259037	1874	202279000	9762	5059	6	0	0
259038	1874	202280000	9763	5060	0	0	0
259039	1678	8640245595000	9763	5060	1	0	0
259062	1874	202281000	9768	5061	0	0	0
259063	1874	202282000	9768	5061	1	0	0
259064	1678	8640245596000	9768	5061	2	0	0
259065	1678	8640245597000	9768	5061	3	0	0
259066	1678	8640245598000	9768	5061	4	0	0
259074	1678	8640245599000	9770	5062	0	0	0
259075	1874	202284000	9770	5062	1	0	0
259076	1874	202285000	9771	5063	0	0	0
259077	1678	8640245600000	9771	5063	1	0	0
259079	1678	8640245601000	9772	5064	1	0	0
259081	1678	8640245601000	9773	5064	1	0	\N
259082	1874	202287000	9775	5065	0	0	\N
259083	1678	8640245602000	9775	5065	1	0	\N
259092	1001	505148775000000	9778	5066	0	0	\N
259093	1241	610771750000000	9778	5066	1	0	\N
259094	1121	905222465000000	9778	5066	2	0	\N
259095	1367	1701968637751650	9778	5066	3	0	\N
259103	1987	1000000000	9781	5068	0	0	\N
259104	1678	8640245605000	9781	5068	1	0	\N
259105	1874	202289000	9781	5068	2	0	\N
259106	1678	8640245606000	9782	5069	0	0	\N
259107	1874	202290000	9782	5069	1	0	\N
259108	1874	202291000	9782	5069	2	0	\N
259109	1678	8640245607000	9782	5069	3	0	\N
259130	1874	202296000	9788	5073	0	0	\N
259131	976	505005775000000	9788	5073	1	0	\N
259132	1096	904965465000000	9788	5073	2	0	\N
259133	1003	504419775000000	9788	5073	4	0	\N
259134	1678	8640245612000	9788	5073	5	0	\N
259135	1216	610598750000000	9788	5073	6	0	\N
259136	1342	1701485637751650	9788	5073	7	0	\N
259158	1678	8640245617000	9793	5077	0	0	\N
259159	1874	202301000	9793	5077	1	0	\N
259169	1678	8640245621000	9797	5080	0	0	\N
259170	1874	202305000	9797	5080	1	0	\N
259171	1989	860340000000	9797	5080	2	0	\N
259172	1678	8640245621000	9798	5080	0	0	\N
259173	1874	202305000	9798	5080	1	0	\N
259174	1989	860340000000	9798	5080	2	0	\N
259184	1874	202308000	9800	5082	0	0	\N
259185	1678	8640245624000	9800	5082	1	0	\N
259186	1874	202308000	9801	5082	0	0	\N
259187	1678	8640245624000	9801	5082	1	0	\N
259188	1874	202308000	9802	5082	0	0	\N
259190	1678	8640245624000	9804	5083	0	0	\N
259191	1678	8640245625000	9804	5083	1	0	\N
259201	1874	202310000	9808	5085	0	0	\N
259202	1678	8640245627000	9808	5085	1	0	\N
259203	1974	0	9808	5085	2	0	\N
259204	1974	0	9808	5085	3	0	\N
259205	1874	202310000	9809	5085	0	0	\N
259206	1678	8640245627000	9809	5085	1	0	\N
259207	1974	0	9809	5085	2	0	\N
259208	1974	0	9809	5085	3	0	\N
259086	1874	202288000	9777	5066	0	0	0
259087	1678	8640245603000	9777	5066	1	0	0
259088	1001	505148775000000	9777	5066	2	0	0
259089	1241	610771750000000	9777	5066	3	0	0
259090	1121	905222465000000	9777	5066	4	0	0
259096	1678	8640245604000	9779	5067	0	0	0
259097	581	66300100000000	9779	5067	1	0	0
259098	698	66300100000000	9779	5067	2	0	0
259099	742	5023100000000	9779	5067	3	0	0
259100	1987	1000000000	9780	5068	0	0	0
259102	1874	202289000	9780	5068	2	0	0
259110	1678	8640245606000	9783	5069	0	0	0
259111	1874	202290000	9783	5069	1	0	0
259112	1874	202291000	9783	5069	2	0	0
259114	1874	202292000	9784	5070	0	0	0
259115	1678	8640245608000	9784	5070	1	0	0
259116	1874	202293000	9785	5071	0	0	0
259117	1678	8640245609000	9785	5071	1	0	0
259118	1668	21599130000000	9785	5071	2	0	1
259120	1678	8640245611000	9786	5072	1	0	0
259121	1874	202294000	9786	5072	2	0	0
259122	1874	202295000	9786	5072	3	0	0
259123	1874	202296000	9787	5073	0	0	0
259124	976	505005775000000	9787	5073	1	0	0
259126	1003	504419775000000	9787	5073	4	0	0
259127	1678	8640245612000	9787	5073	5	0	0
259128	1216	610598750000000	9787	5073	6	0	0
259129	1342	1701485637751650	9787	5073	7	0	0
259138	1678	8640245613000	9789	5074	1	0	0
259139	1357	1701226867751650	9789	5074	2	0	0
259140	1111	904827505000000	9789	5074	3	0	0
259141	1231	610505150000000	9789	5074	4	0	0
259142	991	504928475000000	9789	5074	5	0	0
259144	319	66282330000000	9789	5074	7	0	0
259145	1874	202298000	9790	5075	0	0	0
259146	272	67146574000000	9790	5075	1	0	0
259147	1874	202299000	9790	5075	2	0	0
259148	1123	903915465000000	9790	5075	3	0	0
259150	1369	1699510637751650	9790	5075	5	0	0
259151	1678	8640245614000	9790	5075	6	0	0
259152	1678	8640245615000	9790	5075	7	0	0
259153	1678	8640245616000	9791	5076	0	0	0
259155	1988	200000000	9791	5076	2	0	0
259156	1678	8640245617000	9792	5077	0	0	0
259157	1874	202301000	9792	5077	1	0	0
259160	1678	8640245618000	9794	5078	0	0	0
259161	1874	202302000	9794	5078	1	0	0
259163	1678	8640245619000	9794	5078	3	0	0
259164	1678	8640245620000	9795	5079	0	0	0
259165	1874	202304000	9795	5079	1	0	0
259166	1678	8640245621000	9796	5080	0	0	0
259167	1874	202305000	9796	5080	1	0	0
259175	498	66001500000000	9799	5081	0	0	2
259176	919	505376775000000	9799	5081	2	0	0
259177	1039	905630465000000	9799	5081	3	0	0
259178	1678	8640245622000	9799	5081	5	0	0
259180	1874	202306000	9799	5081	7	0	0
259181	1874	202307000	9799	5081	8	0	0
259182	1159	611047750000000	9799	5081	9	0	0
259183	1285	1702736637751650	9799	5081	10	0	0
259189	1874	202308000	9803	5082	0	0	0
259193	1678	8640245625000	9805	5083	1	0	0
259194	1678	8640245626000	9806	5084	0	0	0
259195	1874	202309000	9806	5084	1	0	0
259196	1974	0	9806	5084	2	0	1
259197	1874	202310000	9807	5085	0	0	0
259199	1974	0	9807	5085	2	0	1
259200	1974	0	9807	5085	3	0	1
259209	1874	202311000	9810	5086	0	0	0
259210	1678	8640245628000	9810	5086	1	0	0
259212	1974	0	9810	5086	3	0	1
259213	1974	0	9810	5086	4	0	1
259214	1974	0	9810	5086	5	0	1
259215	1974	0	9810	5086	6	0	1
259216	1974	0	9810	5086	7	0	1
259218	1874	202311000	9811	5086	0	0	\N
259219	1678	8640245628000	9811	5086	1	0	\N
259220	1974	0	9811	5086	2	0	\N
259221	1974	0	9811	5086	3	0	\N
259222	1974	0	9811	5086	4	0	\N
259223	1974	0	9811	5086	5	0	\N
259224	1974	0	9811	5086	6	0	\N
259225	1974	0	9811	5086	7	0	\N
259226	1974	0	9811	5086	8	0	\N
259227	1874	202312000	9812	5087	0	0	\N
259228	956	504783775000000	9812	5087	1	0	\N
259229	1076	904568465000000	9812	5087	2	0	\N
259230	1196	610330750000000	9812	5087	3	0	\N
259231	1322	1700739637751650	9812	5087	4	0	\N
259232	1974	100000000	9812	5087	5	0	\N
259233	1874	202312000	9813	5087	0	0	\N
259234	956	504783775000000	9813	5087	1	0	\N
259235	1076	904568465000000	9813	5087	2	0	\N
259236	1196	610330750000000	9813	5087	3	0	\N
259237	1322	1700739637751650	9813	5087	4	0	\N
259238	1974	100000000	9813	5087	5	0	\N
259239	1874	202312000	9814	5087	0	0	\N
259240	956	504783775000000	9814	5087	1	0	\N
259241	1076	904568465000000	9814	5087	2	0	\N
259242	1196	610330750000000	9814	5087	3	0	\N
259243	1322	1700739637751650	9814	5087	4	0	\N
259244	1974	100000000	9814	5087	5	0	\N
259253	1678	8640245630000	9817	5089	0	0	\N
259254	1874	202314000	9817	5089	1	0	\N
259255	1972	189000000	9817	5089	2	0	\N
259256	1972	189000000	9817	5089	3	0	\N
259257	1972	189000000	9817	5089	4	0	\N
259258	1972	189000000	9817	5089	5	0	\N
259259	1972	189000000	9817	5089	6	0	\N
259260	1972	189000000	9817	5089	7	0	\N
259261	1972	189000000	9817	5089	8	0	\N
259262	1972	189000000	9817	5089	9	0	\N
259263	1972	189000000	9817	5089	10	0	\N
259264	1972	189000000	9817	5089	11	0	\N
259265	1678	8640245630000	9818	5089	0	0	\N
259266	1874	202314000	9818	5089	1	0	\N
259267	1972	189000000	9818	5089	2	0	\N
259268	1972	189000000	9818	5089	3	0	\N
259269	1972	189000000	9818	5089	4	0	\N
259270	1972	189000000	9818	5089	5	0	\N
259271	1972	189000000	9818	5089	6	0	\N
259272	1972	189000000	9818	5089	7	0	\N
259273	1972	189000000	9818	5089	8	0	\N
259274	1972	189000000	9818	5089	9	0	\N
259275	1972	189000000	9818	5089	10	0	\N
259276	1972	189000000	9818	5089	11	0	\N
259289	1678	8640245630000	9820	5089	0	0	\N
259290	1874	202314000	9820	5089	1	0	\N
259291	1972	189000000	9820	5089	2	0	\N
259292	1972	189000000	9820	5089	3	0	\N
259293	1972	189000000	9820	5089	4	0	\N
259294	1972	189000000	9820	5089	5	0	\N
259295	1972	189000000	9820	5089	6	0	\N
259296	1972	189000000	9820	5089	7	0	\N
259297	1972	189000000	9820	5089	8	0	\N
259298	1972	189000000	9820	5089	9	0	\N
259299	1972	189000000	9820	5089	10	0	\N
259300	1972	189000000	9820	5089	11	0	\N
259310	1874	202315000	9822	5090	0	0	\N
259311	1678	8640245631000	9822	5090	1	0	\N
259312	1974	90000000	9822	5090	2	0	\N
259313	1974	90000000	9822	5090	3	0	\N
259314	1974	90000000	9822	5090	4	0	\N
259315	1974	90000000	9822	5090	5	0	\N
259316	1974	90000000	9822	5090	6	0	\N
259317	1972	184000000	9822	5090	7	0	\N
259318	1974	89000000	9822	5090	8	0	\N
259319	1974	89000000	9822	5090	10	0	\N
259320	1874	202315000	9823	5090	0	0	\N
259321	1678	8640245631000	9823	5090	1	0	\N
259322	1974	90000000	9823	5090	2	0	\N
259323	1974	90000000	9823	5090	3	0	\N
259324	1974	90000000	9823	5090	4	0	\N
259325	1974	90000000	9823	5090	5	0	\N
259326	1974	90000000	9823	5090	6	0	\N
259327	1972	184000000	9823	5090	7	0	\N
259328	1974	89000000	9823	5090	8	0	\N
259329	1974	89000000	9823	5090	10	0	\N
259330	1974	89000000	9823	5090	11	0	\N
259331	1974	89000000	9823	5090	12	0	\N
259332	1972	180000000	9823	5090	13	0	\N
259333	1972	180000000	9823	5090	14	0	\N
259334	1972	180000000	9823	5090	15	0	\N
259335	1972	180000000	9823	5090	16	0	\N
259336	1972	180000000	9823	5090	17	0	\N
259337	1972	180000000	9823	5090	18	0	\N
259338	1972	180000000	9823	5090	19	0	\N
259339	1972	180000000	9823	5090	20	0	\N
259340	1972	180000000	9823	5090	21	0	\N
259341	1974	80000000	9823	5090	22	0	\N
259342	498	66001500000000	9824	5014	0	0	\N
259343	908	504480415000000	9824	5014	2	0	\N
259344	1981	101000000000	9824	5014	3	0	\N
259345	940	505057775000000	9824	5014	4	0	\N
259346	1060	905058465000000	9824	5014	5	0	\N
259347	1180	610661750000000	9824	5014	6	0	\N
259348	1306	1701661637751650	9824	5014	7	0	\N
259349	1365	1703504133514363	9824	5014	8	0	\N
259350	1987	1000000000	9824	5014	9	0	\N
259351	976	505005775000000	9824	5014	10	0	\N
259352	1096	904965465000000	9824	5014	11	0	\N
259246	956	504783775000000	9815	5087	1	0	0
259247	1076	904568465000000	9815	5087	2	0	0
259248	1196	610330750000000	9815	5087	3	0	0
259249	1322	1700739637751650	9815	5087	4	0	0
259250	1974	100000000	9815	5087	5	0	1
259252	1678	8640245629000	9816	5088	1	0	0
259277	1678	8640245630000	9819	5089	0	0	0
259278	1874	202314000	9819	5089	1	0	0
259279	1972	189000000	9819	5089	2	0	11
259280	1972	189000000	9819	5089	3	0	11
259282	1972	189000000	9819	5089	5	0	11
259283	1972	189000000	9819	5089	6	0	11
259284	1972	189000000	9819	5089	7	0	11
259285	1972	189000000	9819	5089	8	0	11
259287	1972	189000000	9819	5089	10	0	11
259288	1972	189000000	9819	5089	11	0	11
259301	1874	202315000	9821	5090	0	0	0
259302	1678	8640245631000	9821	5090	1	0	0
259303	1974	90000000	9821	5090	2	0	11
259305	1974	90000000	9821	5090	4	0	11
259306	1974	90000000	9821	5090	5	0	11
259307	1974	90000000	9821	5090	6	0	11
259308	1972	184000000	9821	5090	7	0	16
259309	1974	89000000	9821	5090	8	0	12
259353	1371	1701968637751650	9824	5014	12	0	\N
259354	1682	11441000000	9824	5014	13	0	\N
259355	919	505376775000000	9824	5014	14	0	\N
259356	1039	905630465000000	9824	5014	15	0	\N
259357	1028	904024575000000	9824	5014	16	0	\N
259358	1148	609963390000000	9824	5014	17	0	\N
259359	1125	905222465000000	9824	5014	18	0	\N
259360	1245	610771750000000	9824	5014	19	0	\N
259361	1005	505148775000000	9824	5014	20	0	\N
259362	764	1000010000000	9824	5014	21	0	\N
259363	1309	1702273637751650	9824	5014	22	0	\N
259364	260	66311200000000	9824	5014	23	0	\N
259365	1980	1000000000	9824	5014	24	0	\N
259366	1980	7198000000000	9824	5014	25	0	\N
259367	1063	905384465000000	9824	5014	26	0	\N
259368	1183	610880750000000	9824	5014	27	0	\N
259369	943	505239775000000	9824	5014	28	0	\N
259370	764	2298360000000	9824	5014	29	0	\N
259371	1003	504419775000000	9824	5014	30	0	\N
259372	1119	906038704109009	9824	5014	31	0	\N
259373	1239	611322367758868	9824	5014	32	0	\N
259374	999	505604372838895	9824	5014	33	0	\N
259375	1274	1699717237751650	9824	5014	34	0	\N
259376	1986	222510000000	9824	5014	35	0	\N
259377	538	67245340000000	9824	5014	36	0	\N
259378	948	505422111740000	9824	5014	37	0	\N
259379	1068	905712093770000	9824	5014	38	0	\N
259380	1188	611101997260000	9824	5014	39	0	\N
259381	1313	1701968137751650	9824	5014	40	0	\N
259382	1067	905221765000000	9824	5014	41	0	\N
259383	1187	610771150000000	9824	5014	42	0	\N
259384	947	505148475000000	9824	5014	43	0	\N
259385	260	67247500000000	9824	5014	44	0	\N
259386	1314	1702890051511650	9824	5014	45	0	\N
259387	1216	610598750000000	9824	5014	46	0	\N
259388	1342	1701485637751650	9824	5014	47	0	\N
259389	1277	1701576637751650	9824	5014	48	0	\N
259390	1031	905013465000000	9824	5014	49	0	\N
259391	1151	610630750000000	9824	5014	50	0	\N
259392	911	505032775000000	9824	5014	51	0	\N
259393	960	505057295000000	9824	5014	52	0	\N
259394	1326	1701660877751650	9824	5014	53	0	\N
259395	1200	610660900000000	9824	5014	54	0	\N
259396	1080	905058345000000	9824	5014	55	0	\N
259397	1357	1701226867751650	9824	5014	56	0	\N
259398	1111	904827505000000	9824	5014	57	0	\N
259399	1231	610505150000000	9824	5014	58	0	\N
259400	991	504928475000000	9824	5014	59	0	\N
259401	272	66282330000000	9824	5014	60	0	\N
259402	319	66282330000000	9824	5014	61	0	\N
259403	1123	903915465000000	9824	5014	62	0	\N
259404	1243	609889750000000	9824	5014	63	0	\N
259405	1369	1699510637751650	9824	5014	64	0	\N
259406	1989	860340000000	9824	5014	65	0	\N
259407	1159	611047750000000	9824	5014	66	0	\N
259408	1285	1702736637751650	9824	5014	67	0	\N
259409	1983	1000000000	9824	5014	68	0	\N
259410	1983	1390103470000	9824	5014	69	0	\N
259411	267	66263331324931	9824	5014	70	0	\N
259412	581	66300100000000	9824	5014	71	0	\N
259413	922	504783792237021	9824	5014	73	0	\N
259414	1974	0	9824	5014	74	0	\N
259415	1974	0	9824	5014	75	0	\N
259416	1984	0	9824	5014	76	0	\N
259417	1984	1000000000	9824	5014	77	0	\N
259418	909	505147213510546	9824	5014	78	0	\N
259419	1042	904568230701196	9824	5014	79	0	\N
259420	1974	0	9824	5014	82	0	\N
259421	1974	0	9824	5014	83	0	\N
259422	1974	0	9824	5014	84	0	\N
259423	1974	0	9824	5014	85	0	\N
259424	1974	0	9824	5014	86	0	\N
259425	1974	0	9824	5014	87	0	\N
259426	1974	0	9824	5014	88	0	\N
259427	1974	0	9824	5014	89	0	\N
259428	1974	100000000	9824	5014	90	0	\N
259429	1974	100000000	9824	5014	91	0	\N
259430	1974	100000000	9824	5014	92	0	\N
259431	1974	100000000	9824	5014	93	0	\N
259432	1974	100000000	9824	5014	94	0	\N
259433	1974	100000000	9824	5014	95	0	\N
259434	1974	100000000	9824	5014	96	0	\N
259435	1974	100000000	9824	5014	97	0	\N
259436	1974	100000000	9824	5014	98	0	\N
259437	1974	100000000	9824	5014	99	0	\N
259438	1029	905219478509549	9824	5014	100	0	\N
259439	1149	610769619922689	9824	5014	101	0	\N
259440	1275	1701963852521252	9824	5014	102	0	\N
259441	1984	1254900000000	9824	5014	103	0	\N
259442	698	66300100000000	9824	5014	104	0	\N
259443	742	5023100000000	9824	5014	105	0	\N
259444	1162	610330210049358	9824	5014	106	0	\N
259445	1288	1700739397839088	9824	5014	108	0	\N
259446	1974	100000000	9824	5014	109	0	\N
259447	1001	505148775000000	9824	5014	112	0	\N
259448	1241	610771750000000	9824	5014	113	0	\N
259449	1121	905222465000000	9824	5014	114	0	\N
259450	1367	1701968637751650	9824	5014	115	0	\N
259478	588	66003000000000	9827	5093	0	0	\N
259479	1678	8640245636000	9827	5093	1	0	\N
259480	1678	8640245637000	9827	5093	2	0	\N
259481	1678	8640245638000	9827	5093	3	0	\N
259482	1874	202320000	9827	5093	4	0	\N
259483	1874	202321000	9827	5093	5	0	\N
259484	1874	202322000	9827	5093	6	0	\N
259485	1406	0	9827	5093	7	0	\N
259487	498	66001500000000	9829	5041	0	0	\N
259488	908	504480415000000	9829	5041	2	0	\N
259453	1212	609999750000000	9826	5092	1	0	0
259454	972	504872775000000	9826	5092	2	0	0
259455	1678	8640245632000	9826	5092	3	0	0
259456	1678	8640245633000	9826	5092	4	0	0
259457	1874	202316000	9826	5092	5	0	0
259459	1678	8640245634000	9826	5092	7	0	0
259460	1678	8640245635000	9826	5092	8	0	0
259461	1874	202318000	9826	5092	9	0	0
259462	1874	202319000	9826	5092	10	0	0
259463	1004	505517499000000	9826	5092	11	0	0
259465	1974	89000000	9826	5092	13	0	12
259466	1974	89000000	9826	5092	14	0	12
259467	1972	180000000	9826	5092	15	0	20
259468	1972	180000000	9826	5092	16	0	20
259470	1972	180000000	9826	5092	18	0	20
259471	1972	180000000	9826	5092	19	0	20
259472	1972	180000000	9826	5092	20	0	20
259473	1972	180000000	9826	5092	21	0	20
259474	1972	180000000	9826	5092	22	0	20
259476	1483	0	9826	5092	24	0	0
259477	1974	79000000	9826	5092	25	0	22
259486	588	66003000000000	9828	5093	0	0	0
259489	1338	1699817637751650	9829	5041	3	0	\N
259490	1092	904078465000000	9829	5041	4	0	\N
259491	1212	609999750000000	9829	5041	5	0	\N
259492	972	504872775000000	9829	5041	6	0	\N
259493	588	66003000000000	9829	5041	7	0	\N
259494	943	505239775000000	9829	5041	8	0	\N
259495	1365	1703504133514363	9829	5041	9	0	\N
259496	1987	1000000000	9829	5041	10	0	\N
259497	976	505005775000000	9829	5041	11	0	\N
259498	1096	904965465000000	9829	5041	12	0	\N
259499	1371	1701968637751650	9829	5041	13	0	\N
259500	919	505376775000000	9829	5041	14	0	\N
259501	1039	905630465000000	9829	5041	15	0	\N
259502	1028	904024575000000	9829	5041	16	0	\N
259503	956	504783775000000	9829	5041	17	0	\N
259504	1076	904568465000000	9829	5041	18	0	\N
259505	1148	609963390000000	9829	5041	19	0	\N
259506	1125	905222465000000	9829	5041	20	0	\N
259507	1245	610771750000000	9829	5041	21	0	\N
259508	1005	505148775000000	9829	5041	22	0	\N
259509	764	2298360000000	9829	5041	23	0	\N
259510	1003	504419775000000	9829	5041	24	0	\N
259511	1119	906038704109009	9829	5041	25	0	\N
259512	1239	611322367758868	9829	5041	26	0	\N
259513	999	505604372838895	9829	5041	27	0	\N
259514	1274	1699717237751650	9829	5041	28	0	\N
259515	1986	222510000000	9829	5041	29	0	\N
259516	1067	905221765000000	9829	5041	30	0	\N
259517	1187	610771150000000	9829	5041	31	0	\N
259518	947	505148475000000	9829	5041	32	0	\N
259519	260	67247500000000	9829	5041	33	0	\N
259520	1610	1389113470000	9829	5041	34	0	\N
259521	1288	1700739397839088	9829	5041	35	0	\N
259522	538	67245340000000	9829	5041	36	0	\N
259523	1196	610330750000000	9829	5041	37	0	\N
259524	1322	1700739637751650	9829	5041	38	0	\N
259525	1216	610598750000000	9829	5041	39	0	\N
259526	1342	1701485637751650	9829	5041	40	0	\N
259527	960	505057295000000	9829	5041	41	0	\N
259528	1326	1701660877751650	9829	5041	42	0	\N
259529	1200	610660900000000	9829	5041	43	0	\N
259530	1080	905058345000000	9829	5041	44	0	\N
259531	1985	1197000000000	9829	5041	45	0	\N
259532	1357	1701226867751650	9829	5041	46	0	\N
259533	1111	904827505000000	9829	5041	47	0	\N
259534	1231	610505150000000	9829	5041	48	0	\N
259535	991	504928475000000	9829	5041	49	0	\N
259536	272	66282330000000	9829	5041	50	0	\N
259537	319	66282330000000	9829	5041	51	0	\N
259538	1123	903915465000000	9829	5041	52	0	\N
259539	1243	609889750000000	9829	5041	53	0	\N
259540	1369	1699510637751650	9829	5041	54	0	\N
259541	1989	860340000000	9829	5041	55	0	\N
259542	1159	611047750000000	9829	5041	56	0	\N
259543	1285	1702736637751650	9829	5041	57	0	\N
259544	1004	505517499000000	9829	5041	58	0	\N
259545	581	66300100000000	9829	5041	59	0	\N
259546	1974	0	9829	5041	61	0	\N
259547	1974	0	9829	5041	62	0	\N
259548	1984	0	9829	5041	63	0	\N
259549	1984	1000000000	9829	5041	64	0	\N
259550	909	505147213510546	9829	5041	65	0	\N
259551	1974	0	9829	5041	68	0	\N
259552	1974	0	9829	5041	69	0	\N
259553	1974	0	9829	5041	70	0	\N
259554	1974	0	9829	5041	71	0	\N
259555	1974	0	9829	5041	72	0	\N
259556	1974	0	9829	5041	73	0	\N
259557	1974	0	9829	5041	74	0	\N
259576	1678	8640245643000	9833	5096	0	0	\N
259577	1874	202327000	9833	5096	1	0	\N
259578	1678	8640245644000	9833	5096	2	0	\N
259596	1678	8640245651000	9837	5099	0	0	\N
259597	1874	202334000	9837	5099	1	0	\N
259600	1874	202335000	9839	5100	0	0	\N
259601	1678	8640245652000	9839	5100	1	0	\N
259604	1874	202336000	9841	5101	0	0	\N
259605	1678	8640245653000	9841	5101	1	0	\N
259606	1874	202336000	9842	5101	0	0	\N
259607	1678	8640245653000	9842	5101	1	0	\N
259610	1874	202337000	9844	5102	0	0	\N
259611	1678	8640245654000	9844	5102	1	0	\N
259614	1874	202339000	9846	5104	0	0	\N
259615	1874	202340000	9846	5104	1	0	\N
259616	1678	8640245656000	9846	5104	2	0	\N
259617	1678	8640245657000	9846	5104	3	0	\N
259618	1678	8640245658000	9846	5104	4	0	\N
259560	1678	8640245638000	9830	5094	2	0	0
259561	1678	8640245639000	9830	5094	3	0	0
259562	1874	202320000	9830	5094	4	0	0
259563	1874	202321000	9830	5094	5	0	0
259564	1874	202322000	9830	5094	6	0	0
259566	1406	0	9830	5094	8	0	0
259567	1678	8640245640000	9831	5095	0	0	0
259568	1678	8640245641000	9831	5095	1	0	0
259569	1678	8640245642000	9831	5095	2	0	0
259570	1124	905883026000000	9831	5095	3	0	0
259572	1874	202325000	9831	5095	5	0	0
259573	1874	202326000	9831	5095	6	0	0
259574	1678	8640245643000	9832	5096	0	0	0
259575	1874	202327000	9832	5096	1	0	0
259580	1874	202329000	9834	5097	1	0	0
259581	1874	202330000	9834	5097	2	0	0
259582	1874	202331000	9834	5097	3	0	0
259583	1678	8640245644000	9834	5097	4	0	0
259584	1874	202332000	9834	5097	5	0	0
259586	1678	8640245646000	9834	5097	7	0	0
259587	1678	8640245647000	9834	5097	8	0	0
259588	1678	8640245648000	9834	5097	9	0	0
259589	1678	8640245649000	9834	5097	10	0	0
259590	1244	611217329000000	9834	5097	11	0	0
259592	1678	8640245650000	9835	5098	0	0	0
259593	1874	202333000	9835	5098	1	0	0
259594	1678	8640245651000	9836	5099	0	0	0
259595	1874	202334000	9836	5099	1	0	0
259599	1678	8640245652000	9838	5100	1	0	0
259602	1874	202336000	9840	5101	0	0	0
259603	1678	8640245653000	9840	5101	1	0	0
259608	1874	202337000	9843	5102	0	0	0
259609	1678	8640245654000	9843	5102	1	0	0
259613	1874	202338000	9845	5103	1	0	0
259619	1874	202339000	9847	5104	0	0	0
259620	1874	202340000	9847	5104	1	0	0
259621	1678	8640245656000	9847	5104	2	0	0
259622	1678	8640245657000	9847	5104	3	0	0
259624	1678	8640245659000	9847	5104	5	0	0
259626	1874	202341000	9849	5105	0	0	\N
259636	207	66001110000000	9853	5108	0	0	\N
259637	1678	8640245663000	9853	5108	1	0	\N
259638	1874	202345000	9853	5108	2	0	\N
259662	1874	202355000	9861	5116	0	0	\N
259663	1678	8640245674000	9861	5116	1	0	\N
259664	1874	202355000	9862	5116	0	0	\N
259665	1678	8640245674000	9862	5116	1	0	\N
259666	1874	202355000	9863	5116	0	0	\N
259667	1678	8640245674000	9863	5116	1	0	\N
259670	1678	8640245675000	9865	5117	0	0	\N
259672	1874	202356000	9867	5118	0	0	\N
259673	1678	8640245676000	9867	5118	1	0	\N
259674	1678	8640245677000	9867	5118	2	0	\N
259675	1874	202357000	9867	5118	3	0	\N
259680	1874	202356000	9869	5118	0	0	\N
259681	1678	8640245676000	9869	5118	1	0	\N
259682	1678	8640245677000	9869	5118	2	0	\N
259683	1874	202357000	9869	5118	3	0	\N
259688	1874	202359000	9872	5120	0	0	\N
259689	1678	8640245679000	9872	5120	1	0	\N
259692	1678	8640245680000	9874	5121	0	0	\N
259693	1874	202360000	9874	5121	1	0	\N
259701	1874	202364000	9878	5124	0	0	\N
259702	1678	8640245685000	9878	5124	1	0	\N
259703	1874	202364000	9879	5124	0	0	\N
259704	1678	8640245685000	9879	5124	1	0	\N
259705	1874	202364000	9881	5124	0	0	\N
259706	1678	8640245685000	9881	5124	1	0	\N
259711	1874	202365000	9886	5125	0	0	\N
259712	1678	8640245686000	9886	5125	1	0	\N
259713	1874	202365000	9887	5125	0	0	\N
259714	1678	8640245686000	9887	5125	1	0	\N
259715	1678	8640245687000	9888	5126	0	0	\N
259716	1874	202366000	9888	5126	1	0	\N
259717	1678	8640245687000	9889	5126	0	0	\N
259718	1874	202366000	9889	5126	1	0	\N
259726	1678	8640245690000	9893	5128	0	0	\N
259727	1874	202367000	9894	5127	0	0	\N
259728	1678	8640245688000	9894	5127	1	0	\N
259729	1678	8640245689000	9894	5127	2	0	\N
259730	1678	8640245690000	9894	5127	3	0	\N
259731	1874	202368000	9894	5127	4	0	\N
259738	1874	202371000	9897	5130	0	0	\N
259739	1678	8640245693000	9897	5130	1	0	\N
259742	1874	202373000	9899	5132	0	0	\N
259743	1678	8640245695000	9899	5132	1	0	\N
259754	1874	202376000	9905	5135	0	0	\N
259755	1678	8640245698000	9905	5135	1	0	\N
259756	1678	8640245699000	9905	5135	2	0	\N
259757	1874	202377000	9905	5135	3	0	\N
259628	1678	8640245660000	9850	5106	1	0	0
259629	1678	8640245661000	9851	5107	0	0	0
259630	1874	202343000	9851	5107	1	0	0
259631	1874	202344000	9851	5107	2	0	0
259632	1678	8640245662000	9851	5107	3	0	0
259634	1678	8640245663000	9852	5108	1	0	0
259635	1874	202345000	9852	5108	2	0	0
259639	1678	8640245664000	9854	5109	0	0	0
259640	1678	8640245665000	9856	5111	0	0	0
259641	1874	202346000	9856	5111	1	0	0
259643	1874	202347000	9856	5111	3	0	0
259644	1874	202348000	9856	5111	4	0	0
259645	1678	8640245666000	9856	5111	5	0	0
259646	1678	8640245667000	9856	5111	6	0	0
259648	1678	8640245668000	9857	5112	1	0	0
259649	1678	8640245669000	9858	5113	0	0	0
259650	1874	202350000	9858	5113	1	0	0
259651	1874	202351000	9858	5113	2	0	0
259652	1135	905385124870000	9858	5113	3	0	0
259654	1255	610881384830000	9858	5113	5	0	0
259655	1678	8640245670000	9858	5113	6	0	0
259656	1874	202352000	9859	5114	0	0	0
259657	1874	202353000	9859	5114	1	0	0
259658	1678	8640245671000	9859	5114	2	0	0
259660	1874	202354000	9860	5115	0	0	0
259661	1678	8640245673000	9860	5115	1	0	0
259668	1874	202355000	9864	5116	0	0	0
259669	1678	8640245674000	9864	5116	1	0	0
259676	1874	202356000	9868	5118	0	0	0
259677	1678	8640245676000	9868	5118	1	0	0
259678	1678	8640245677000	9868	5118	2	0	0
259679	1874	202357000	9868	5118	3	0	0
259684	1678	8640245678000	9870	5119	0	0	0
259686	1874	202359000	9871	5120	0	0	0
259687	1678	8640245679000	9871	5120	1	0	0
259690	1678	8640245680000	9873	5121	0	0	0
259691	1874	202360000	9873	5121	1	0	0
259694	1678	8640245681000	9875	5122	0	0	0
259696	1874	202362000	9876	5123	0	0	0
259697	1678	8640245682000	9876	5123	1	0	0
259698	1678	8640245683000	9876	5123	2	0	0
259699	1678	8640245684000	9876	5123	3	0	0
259707	1874	202364000	9882	5124	0	0	0
259708	1678	8640245685000	9882	5124	1	0	0
259709	1874	202365000	9885	5125	0	0	0
259710	1678	8640245686000	9885	5125	1	0	0
259719	1678	8640245687000	9890	5126	0	0	0
259721	1874	202367000	9891	5127	0	0	0
259722	1678	8640245688000	9891	5127	1	0	0
259723	1678	8640245689000	9891	5127	2	0	0
259724	1874	202368000	9891	5127	3	0	0
259725	1678	8640245690000	9892	5128	0	0	0
259733	1874	202370000	9895	5129	1	0	0
259734	1678	8640245691000	9895	5129	2	0	0
259735	1678	8640245692000	9895	5129	3	0	0
259736	1874	202371000	9896	5130	0	0	0
259740	1678	8640245694000	9898	5131	0	0	0
259741	1874	202372000	9898	5131	1	0	0
259744	1874	202373000	9900	5132	0	0	0
259745	1678	8640245695000	9900	5132	1	0	0
259746	1678	8640245696000	9901	5133	0	0	0
259748	1678	8640245697000	9902	5134	0	0	0
259749	1874	202375000	9902	5134	1	0	0
259750	1874	202376000	9903	5135	0	0	0
259751	1678	8640245698000	9903	5135	1	0	0
259752	1678	8640245699000	9904	5136	0	0	0
259758	1874	202378000	9906	5137	0	0	0
259759	1678	8640245700000	9906	5137	1	0	0
259760	1678	8640245701000	9909	5139	0	0	0
259774	1678	8640245706000	9912	5141	0	0	\N
259775	1874	202384000	9912	5141	1	0	\N
259776	1874	202385000	9912	5141	2	0	\N
259777	1678	8640245707000	9912	5141	3	0	\N
259787	1678	8640245713000	9917	5146	0	0	\N
259788	1874	202390000	9917	5146	1	0	\N
259789	619	66000500000000	9917	5146	2	0	\N
259802	1678	8640245718000	9921	5149	0	0	\N
259803	1874	202395000	9921	5149	1	0	\N
259808	1678	8640245720000	9924	5151	0	0	\N
259809	1874	202397000	9924	5151	1	0	\N
259812	1034	904568150819296	9926	5152	0	0	\N
259813	1154	610330156151454	9926	5152	1	0	\N
259814	1280	1700739247647754	9926	5152	2	0	\N
259815	1874	202398000	9926	5152	3	0	\N
259816	1678	8640245721000	9926	5152	4	0	\N
259827	1874	202400000	9932	5155	0	0	\N
259828	1678	8640245724000	9932	5155	1	0	\N
259833	1874	202401000	9934	5156	0	0	\N
259834	1874	202402000	9934	5156	1	0	\N
259835	1678	8640245725000	9934	5156	2	0	\N
259836	1678	8640245726000	9934	5156	3	0	\N
259839	531	66407503985720	9936	5158	0	0	\N
259840	1874	202404000	9936	5158	1	0	\N
259841	984	505877914565232	9936	5158	2	0	\N
259842	1104	906528888538912	9936	5158	3	0	\N
259843	1678	8640245728000	9936	5158	4	0	\N
259844	1224	611653104961338	9936	5158	5	0	\N
259845	1350	1704425762136538	9936	5158	6	0	\N
259853	1874	202405000	9938	5159	0	0	\N
259854	1678	8640245729000	9938	5159	1	0	\N
259855	1874	202405000	9939	5159	0	0	\N
259856	1678	8640245729000	9939	5159	1	0	\N
259857	1874	202405000	9940	5159	0	0	\N
259858	1678	8640245729000	9940	5159	1	0	\N
259859	1874	202405000	9941	5159	0	0	\N
259860	1678	8640245729000	9941	5159	1	0	\N
259876	1874	202413000	9947	5164	0	0	\N
259877	1874	202414000	9947	5164	1	0	\N
259878	1678	8640245736000	9947	5164	2	0	\N
259879	1678	8640245737000	9947	5164	3	0	\N
259880	1678	8640245738000	9947	5164	4	0	\N
259881	1678	8640245739000	9947	5164	5	0	\N
259894	1678	9360265742000	9952	5168	0	0	\N
259896	1678	9360265742000	9954	5168	0	0	\N
259763	1874	202381000	9909	5139	3	0	0
259764	1874	202382000	9909	5139	4	0	0
259765	1678	8640245702000	9909	5139	5	0	0
259766	1678	8640245703000	9909	5139	6	0	0
259767	1678	8640245704000	9909	5139	7	0	0
259769	1678	8640245705000	9910	5140	1	0	0
259770	1678	8640245706000	9911	5141	0	0	0
259771	1874	202384000	9911	5141	1	0	0
259772	1874	202385000	9911	5141	2	0	0
259773	1678	8640245707000	9911	5141	3	0	0
259779	1874	202386000	9914	5143	0	0	0
259780	1678	8640245709000	9914	5143	1	0	0
259781	1678	8640245710000	9915	5144	0	0	0
259782	1678	8640245711000	9915	5144	1	0	0
259784	1874	202388000	9915	5144	3	0	0
259785	1678	8640245712000	9916	5145	0	0	0
259786	1874	202389000	9916	5145	1	0	0
259790	1678	8640245713000	9918	5146	0	0	0
259791	1874	202390000	9918	5146	1	0	0
259793	914	504783747659856	9919	5147	0	0	0
259794	1678	8640245714000	9919	5147	1	0	0
259795	1874	202391000	9919	5147	2	0	0
259796	1678	8640245715000	9919	5147	3	0	0
259797	1678	8640245716000	9919	5147	4	0	0
259799	1874	202393000	9919	5147	6	0	0
259800	1678	8640245717000	9920	5148	0	0	0
259801	1874	202394000	9920	5148	1	0	0
259804	1678	8640245718000	9922	5149	0	0	0
259806	1874	202395000	9923	5150	1	0	0
259807	1874	202396000	9923	5150	2	0	0
259810	1678	8640245720000	9925	5151	0	0	0
259811	1874	202397000	9925	5151	1	0	0
259817	1034	904568150819296	9927	5152	0	0	0
259819	1280	1700739247647754	9927	5152	2	0	0
259820	1874	202398000	9927	5152	3	0	0
259821	1678	8640245721000	9927	5152	4	0	0
259822	1678	8640245722000	9928	5153	0	0	0
259823	1678	8640245723000	9930	5154	0	0	0
259825	1874	202400000	9931	5155	0	0	0
259826	1678	8640245724000	9931	5155	1	0	0
259829	1874	202401000	9933	5156	0	0	0
259830	1874	202402000	9933	5156	1	0	0
259832	1678	8640245726000	9933	5156	3	0	0
259837	1678	8640245727000	9935	5157	0	0	0
259838	1874	202403000	9935	5157	1	0	0
259846	531	66407503985720	9937	5158	0	0	0
259847	1874	202404000	9937	5158	1	0	0
259849	1104	906528888538912	9937	5158	3	0	0
259850	1678	8640245728000	9937	5158	4	0	0
259851	1224	611653104961338	9937	5158	5	0	0
259852	1350	1704425762136538	9937	5158	6	0	0
259861	1874	202405000	9942	5159	0	0	0
259863	1874	202406000	9943	5160	0	0	0
259864	1678	8640245730000	9943	5160	1	0	0
259865	1678	8640245731000	9943	5160	2	0	0
259866	1678	8640245732000	9944	5161	0	0	0
259868	1874	202408000	9945	5162	0	0	0
259869	1678	8640245733000	9945	5162	1	0	0
259870	1678	8640245734000	9946	5163	0	0	0
259871	1678	8640245735000	9946	5163	1	0	0
259872	1874	202409000	9946	5163	2	0	0
259874	1874	202411000	9946	5163	4	0	0
259875	1874	202412000	9946	5163	5	0	0
259882	1874	202413000	9949	5165	0	0	0
259883	1874	202414000	9949	5165	1	0	0
259884	1874	202415000	9949	5165	2	0	0
259886	1678	8640245737000	9949	5165	4	0	0
259887	1678	8640245738000	9949	5165	5	0	0
259888	1678	8640245739000	9949	5165	6	0	0
259889	1678	8640245740000	9949	5165	7	0	0
259891	1678	8640245741000	9950	5166	1	0	0
259892	1939	1435990000000	9951	5167	0	0	1
259893	1874	202417000	9951	5167	1	0	0
259895	1678	9360265742000	9953	5168	0	0	0
259902	1678	9360265743000	9956	5169	0	0	\N
259903	1678	9360265744000	9956	5169	1	0	\N
259904	1874	202418000	9956	5169	2	0	\N
259905	1874	202419000	9956	5169	3	0	\N
259906	1950	4389390000000	9956	5169	4	0	\N
259908	1939	1435990000000	9964	5167	0	0	\N
259909	1874	202417000	9964	5167	1	0	\N
259910	1678	8640245742000	9964	5167	2	0	\N
259911	1678	8640245743000	9964	5167	3	0	\N
259912	1678	8640245744000	9964	5167	4	0	\N
259913	1874	202418000	9964	5167	5	0	\N
259914	1874	202419000	9964	5167	6	0	\N
259915	1874	202420000	9964	5167	7	0	\N
259916	1874	202421000	9964	5167	8	0	\N
259917	1678	8640245745000	9964	5167	9	0	\N
259918	1678	8640245746000	9964	5167	10	0	\N
259919	1678	8640245747000	9964	5167	11	0	\N
259920	1950	4389390000000	9964	5167	12	0	\N
259921	1678	9360265746000	9965	5171	0	0	\N
259922	1874	202420000	9965	5171	1	0	\N
259923	1874	202421000	9965	5171	2	0	\N
259924	1874	202422000	9965	5171	3	0	\N
259925	1678	9360265747000	9965	5171	4	0	\N
259926	1678	9360265748000	9965	5171	5	0	\N
259927	1950	5389390000000	9965	5171	6	0	\N
259935	1874	202420000	9967	5170	0	0	\N
259936	1874	202421000	9967	5170	1	0	\N
259937	1874	202422000	9967	5170	2	0	\N
259938	1678	9360265745000	9967	5170	3	0	\N
259939	1678	9360265746000	9967	5170	4	0	\N
259940	1678	9360265747000	9967	5170	5	0	\N
259941	1678	9360265748000	9967	5170	6	0	\N
259942	1950	5389390000000	9967	5170	7	0	\N
259943	1678	9360265746000	9968	5171	0	0	\N
259944	1874	202420000	9968	5171	1	0	\N
259945	1874	202421000	9968	5171	2	0	\N
259946	1874	202422000	9968	5171	3	0	\N
259947	1678	9360265747000	9968	5171	4	0	\N
259948	1678	9360265748000	9968	5171	5	0	\N
259949	1950	5389390000000	9968	5171	6	0	\N
259950	498	66001500000000	9969	5079	0	0	\N
259951	914	504783747659856	9969	5079	2	0	\N
259952	1034	904568150819296	9969	5079	3	0	\N
259953	1154	610330156151454	9969	5079	4	0	\N
259954	1280	1700739247647754	9969	5079	5	0	\N
259955	1338	1699817637751650	9969	5079	6	0	\N
259956	1092	904078465000000	9969	5079	7	0	\N
259957	1212	609999750000000	9969	5079	8	0	\N
259958	972	504872775000000	9969	5079	9	0	\N
259959	588	66003000000000	9969	5079	10	0	\N
259960	1939	1435990000000	9969	5079	11	0	\N
259961	207	66001110000000	9969	5079	12	0	\N
259962	919	505376775000000	9969	5079	13	0	\N
259963	1039	905630465000000	9969	5079	14	0	\N
259964	531	66407503985720	9969	5079	15	0	\N
259965	1381	1702275295351650	9969	5079	16	0	\N
259966	956	504783775000000	9969	5079	17	0	\N
259967	1076	904568465000000	9969	5079	18	0	\N
259968	1295	1701047467188501	9969	5079	19	0	\N
259969	1049	904732545629265	9969	5079	20	0	\N
259970	984	505877914565232	9969	5079	21	0	\N
259971	1104	906528888538912	9969	5079	22	0	\N
259972	1224	611653104961338	9969	5079	23	0	\N
259973	1196	610330750000000	9969	5079	24	0	\N
259974	1322	1700739637751650	9969	5079	25	0	\N
259975	1350	1704425762136538	9969	5079	26	0	\N
259976	1159	611047750000000	9969	5079	27	0	\N
259977	1285	1702736637751650	9969	5079	28	0	\N
259978	1135	905385124870000	9969	5079	29	0	\N
259979	1015	505239650540000	9969	5079	30	0	\N
259980	1255	610881384830000	9969	5079	31	0	\N
259981	1004	505517499000000	9969	5079	32	0	\N
259982	1124	905883026000000	9969	5079	33	0	\N
259983	1244	611217329000000	9969	5079	34	0	\N
259984	1370	1703211432751650	9969	5079	35	0	\N
259985	619	66000500000000	9969	5079	36	0	\N
259986	1950	4389390000000	9969	5079	37	0	\N
259987	1950	5389390000000	9969	5079	38	0	\N
259988	1974	0	9969	5079	39	0	\N
259989	1974	0	9969	5079	40	0	\N
259990	1974	0	9969	5079	41	0	\N
259991	1974	0	9969	5079	42	0	\N
259992	1974	0	9969	5079	43	0	\N
259993	1974	0	9969	5079	44	0	\N
259994	1974	0	9969	5079	45	0	\N
259995	1974	0	9969	5079	46	0	\N
259996	1974	0	9969	5079	47	0	\N
259997	1974	0	9969	5079	48	0	\N
259998	1974	100000000	9969	5079	49	0	\N
259999	1974	100000000	9969	5079	50	0	\N
260000	1974	100000000	9969	5079	51	0	\N
260001	1974	100000000	9969	5079	52	0	\N
260002	1974	100000000	9969	5079	53	0	\N
260003	1974	100000000	9969	5079	54	0	\N
260004	1974	100000000	9969	5079	55	0	\N
260005	1974	100000000	9969	5079	56	0	\N
260006	1974	100000000	9969	5079	57	0	\N
260007	1974	100000000	9969	5079	58	0	\N
260008	1974	100000000	9969	5079	59	0	\N
260009	1406	0	9969	5079	60	0	\N
260010	1295	1701047467188501	9970	5172	0	0	\N
260011	1049	904732545629265	9970	5172	1	0	\N
260012	1874	202423000	9970	5172	2	0	\N
260013	1678	9360265749000	9970	5172	3	0	\N
260014	1295	1701047467188501	9971	5172	0	0	\N
260015	1049	904732545629265	9971	5172	1	0	\N
260016	1874	202423000	9971	5172	2	0	\N
260017	1678	9360265749000	9971	5172	3	0	\N
260023	1295	1701047467188501	9974	5163	0	0	\N
260024	1049	904732545629265	9974	5163	1	0	\N
260025	1169	610441401885611	9974	5163	2	0	\N
260026	1295	1701047467188501	9975	5154	0	0	\N
260027	1049	904732545629265	9975	5154	1	0	\N
260028	1169	610441401885611	9975	5154	2	0	\N
260029	1678	9360265746000	9976	5171	0	0	\N
260030	1874	202420000	9976	5171	1	0	\N
260031	1874	202421000	9976	5171	2	0	\N
260032	1295	1701047467188501	9976	5171	3	0	\N
259899	1874	202418000	9955	5169	2	0	0
259900	1874	202419000	9955	5169	3	0	0
259901	1950	4389390000000	9955	5169	4	0	5
259907	1678	9360265745000	9961	5170	0	0	0
259928	1678	9360265746000	9966	5171	0	0	0
259930	1874	202421000	9966	5171	2	0	0
259931	1874	202422000	9966	5171	3	0	0
259932	1678	9360265747000	9966	5171	4	0	0
259933	1678	9360265748000	9966	5171	5	0	0
259934	1950	5389390000000	9966	5171	6	0	5
260019	1049	904732545629265	9972	5172	1	0	0
260020	1874	202423000	9972	5172	2	0	0
260021	1678	9360265749000	9972	5172	3	0	0
260022	1678	9360265750000	9973	5173	0	0	0
260033	1678	9360265747000	9976	5171	4	0	\N
260034	1049	904732545629265	9976	5171	5	0	\N
260035	1169	610441401885611	9976	5171	6	0	\N
260041	1678	9360265753000	9978	5175	0	0	\N
260042	1874	202426000	9978	5175	1	0	\N
260045	1874	202427000	9980	5176	0	0	\N
260046	939	504690032035010	9980	5176	1	0	\N
260047	1678	9360265754000	9980	5176	2	0	\N
260048	1678	9360265755000	9980	5176	3	0	\N
260049	1874	202428000	9980	5176	4	0	\N
260050	939	504690042035010	9980	5176	5	0	\N
260051	1874	202427000	9981	5176	0	0	\N
260052	939	504690032035010	9981	5176	1	0	\N
260053	1678	9360265754000	9981	5176	2	0	\N
260054	1678	9360265755000	9981	5176	3	0	\N
260055	1874	202428000	9981	5176	4	0	\N
260056	939	504690042035010	9981	5176	5	0	\N
260063	1874	202427000	9983	5176	0	0	\N
260064	939	504690032035010	9983	5176	1	0	\N
260065	1678	9360265754000	9983	5176	2	0	\N
260066	1678	9360265755000	9983	5176	3	0	\N
260067	1874	202428000	9983	5176	4	0	\N
260068	939	504690042035010	9983	5176	5	0	\N
260074	1874	202422000	9985	5168	0	0	\N
260075	939	504690032035010	9985	5168	1	0	\N
260076	1295	1701047467188501	9985	5168	2	0	\N
260077	1049	904732545629265	9985	5168	3	0	\N
260078	1169	610441401885611	9985	5168	4	0	\N
260079	1678	8640245748000	9985	5168	5	0	\N
260080	1874	202423000	9985	5168	6	0	\N
260081	1874	202424000	9985	5168	7	0	\N
260082	1874	202425000	9985	5168	8	0	\N
260083	1874	202426000	9985	5168	9	0	\N
260084	1874	202427000	9985	5168	10	0	\N
260085	1678	8640245749000	9985	5168	11	0	\N
260086	1874	202428000	9985	5168	12	0	\N
260087	1874	202429000	9985	5168	13	0	\N
260088	1874	202430000	9985	5168	14	0	\N
260089	1678	8640245750000	9985	5168	15	0	\N
260090	1678	8640245751000	9985	5168	16	0	\N
260091	1678	8640245752000	9985	5168	17	0	\N
260092	1678	8640245753000	9985	5168	18	0	\N
260093	1678	8640245754000	9985	5168	19	0	\N
260094	1678	8640245755000	9985	5168	20	0	\N
260095	1678	8640245756000	9985	5168	21	0	\N
260096	1678	8640245757000	9985	5168	22	0	\N
260097	939	504690042035010	9985	5168	23	0	\N
260098	1059	904400213222506	9985	5168	24	0	\N
260099	929	504875928235309	9985	5168	25	0	\N
260100	1950	5389390000000	9985	5168	26	0	\N
260101	1950	6389390000000	9985	5168	27	0	\N
260102	1678	9360265758000	9986	5178	0	0	\N
260103	1049	904732555629265	9986	5178	1	0	\N
260104	1678	9360265759000	9986	5178	2	0	\N
260105	1179	610216845308516	9986	5178	3	0	\N
260106	1305	1700423496908881	9986	5178	4	0	\N
260107	1874	202431000	9986	5178	5	0	\N
260108	1678	9360265758000	9987	5178	0	0	\N
260109	1049	904732555629265	9987	5178	1	0	\N
260110	1678	9360265759000	9987	5178	2	0	\N
260111	1179	610216845308516	9987	5178	3	0	\N
260112	1305	1700423496908881	9987	5178	4	0	\N
260113	1874	202431000	9987	5178	5	0	\N
260114	1678	9360265758000	9988	5178	0	0	\N
260115	1049	904732555629265	9988	5178	1	0	\N
260116	1678	9360265759000	9988	5178	2	0	\N
260117	1179	610216845308516	9988	5178	3	0	\N
260118	1305	1700423496908881	9988	5178	4	0	\N
260119	1874	202431000	9988	5178	5	0	\N
260138	1874	202437000	9994	5183	0	0	\N
260139	1678	9360265765000	9994	5183	1	0	\N
260142	1049	904732555629265	9996	5175	0	0	\N
260143	939	504690032035010	9996	5175	1	0	\N
260144	1678	9360265753000	9996	5175	2	0	\N
260145	1678	9360265754000	9996	5175	3	0	\N
260146	1678	9360265755000	9996	5175	4	0	\N
260147	1678	9360265756000	9996	5175	5	0	\N
260148	1874	202426000	9996	5175	6	0	\N
260149	1874	202427000	9996	5175	7	0	\N
260150	1678	9360265757000	9996	5175	8	0	\N
260151	1678	9360265758000	9996	5175	9	0	\N
260152	1678	9360265759000	9996	5175	10	0	\N
260153	1678	9360265760000	9996	5175	11	0	\N
260154	1678	9360265761000	9996	5175	12	0	\N
260155	1678	9360265762000	9996	5175	13	0	\N
260156	1678	9360265763000	9996	5175	14	0	\N
260157	1678	9360265764000	9996	5175	15	0	\N
260158	1678	9360265765000	9996	5175	16	0	\N
260159	1874	202428000	9996	5175	17	0	\N
260160	1874	202429000	9996	5175	18	0	\N
260161	1169	607904760000000	9996	5175	19	0	\N
260162	1874	202430000	9996	5175	20	0	\N
260163	1874	202431000	9996	5175	21	0	\N
260164	1874	202432000	9996	5175	22	0	\N
260165	939	504690042035010	9996	5175	23	0	\N
260166	1059	904400213222506	9996	5175	24	0	\N
260167	1179	610216845308516	9996	5175	25	0	\N
260168	1305	1700423496908881	9996	5175	26	0	\N
260038	1874	202425000	9977	5174	2	0	0
260039	1678	9360265752000	9977	5174	3	0	0
260040	1950	6389390000000	9977	5174	4	0	5
260043	1678	9360265753000	9979	5175	0	0	0
260044	1874	202426000	9979	5175	1	0	0
260058	939	504690032035010	9982	5176	1	0	0
260059	1678	9360265754000	9982	5176	2	0	0
260060	1678	9360265755000	9982	5176	3	0	0
260061	1874	202428000	9982	5176	4	0	0
260062	939	504690042035010	9982	5176	5	0	0
260070	1059	904400213222506	9984	5177	1	0	0
260071	1874	202429000	9984	5177	2	0	0
260072	1678	9360265757000	9984	5177	3	0	0
260073	1874	202430000	9984	5177	4	0	0
260121	1049	904732555629265	9989	5178	1	0	0
260122	1678	9360265759000	9989	5178	2	0	0
260123	1179	610216845308516	9989	5178	3	0	0
260124	1305	1700423496908881	9989	5178	4	0	0
260125	1874	202431000	9989	5178	5	0	0
260127	1678	9360265760000	9990	5179	1	0	0
260128	1678	9360265761000	9991	5180	0	0	0
260129	1874	202433000	9991	5180	1	0	0
260130	1678	9360265762000	9992	5181	0	0	0
260131	1874	202434000	9992	5181	1	0	0
260133	1678	9360265764000	9993	5182	1	0	0
260134	1169	607904760000000	9993	5182	2	0	0
260135	1874	202435000	9993	5182	3	0	0
260136	1874	202436000	9993	5182	4	0	0
260140	1874	202437000	9995	5183	0	0	0
260141	1678	9360265765000	9995	5183	1	0	0
260169	1874	202433000	9996	5175	27	0	\N
260170	1874	202434000	9996	5175	28	0	\N
260171	1874	202435000	9996	5175	29	0	\N
260172	1874	202436000	9996	5175	30	0	\N
260173	1874	202437000	9996	5175	31	0	\N
260174	1652	490000000	9996	5175	32	0	\N
260175	1874	202437000	9997	5183	0	0	\N
260176	1678	9360265765000	9997	5183	1	0	\N
260177	498	66001500000000	9998	5027	0	0	\N
260178	596	83898262000000	9998	5027	2	0	\N
260179	940	505057775000000	9998	5027	3	0	\N
260180	1060	905058465000000	9998	5027	4	0	\N
260181	1180	610661750000000	9998	5027	5	0	\N
260182	1306	1701661637751650	9998	5027	6	0	\N
260183	908	504480415000000	9998	5027	7	0	\N
260184	914	504783747659856	9998	5027	8	0	\N
260185	1034	904568150819296	9998	5027	9	0	\N
260186	1154	610330156151454	9998	5027	10	0	\N
260187	1280	1700739247647754	9998	5027	11	0	\N
260188	1338	1699817637751650	9998	5027	12	0	\N
260189	1092	904078465000000	9998	5027	13	0	\N
260190	1212	609999750000000	9998	5027	14	0	\N
260191	972	504872775000000	9998	5027	15	0	\N
260192	588	66003000000000	9998	5027	16	0	\N
260193	1939	1435990000000	9998	5027	17	0	\N
260194	207	66001110000000	9998	5027	18	0	\N
260195	1365	1703504133514363	9998	5027	19	0	\N
260196	1987	1000000000	9998	5027	20	0	\N
260197	976	505005775000000	9998	5027	21	0	\N
260198	1096	904965465000000	9998	5027	23	0	\N
260199	1371	1701968637751650	9998	5027	24	0	\N
260200	1678	8640245556000	9998	5027	25	0	\N
260201	1874	202244000	9998	5027	26	0	\N
260202	919	505376775000000	9998	5027	27	0	\N
260203	1039	905630465000000	9998	5027	28	0	\N
260204	1028	904024575000000	9998	5027	29	0	\N
260205	531	66407503985720	9998	5027	30	0	\N
260206	1381	1702275295351650	9998	5027	31	0	\N
260207	956	504783775000000	9998	5027	32	0	\N
260208	1076	904568465000000	9998	5027	33	0	\N
260209	1148	609963390000000	9998	5027	34	0	\N
260210	1125	905222465000000	9998	5027	35	0	\N
260211	1245	610771750000000	9998	5027	36	0	\N
260212	1005	505148775000000	9998	5027	37	0	\N
260213	939	504690032035010	9998	5027	38	0	\N
260214	764	1000010000000	9998	5027	39	0	\N
260215	1309	1702273637751650	9998	5027	40	0	\N
260216	260	66311200000000	9998	5027	41	0	\N
260217	1295	1701047467188501	9998	5027	42	0	\N
260218	1063	905384465000000	9998	5027	43	0	\N
260219	1874	202245000	9998	5027	44	0	\N
260220	1874	202246000	9998	5027	45	0	\N
260221	1183	610880750000000	9998	5027	46	0	\N
260222	943	505239775000000	9998	5027	47	0	\N
260223	764	2298360000000	9998	5027	48	0	\N
260224	1049	904732545629265	9998	5027	49	0	\N
260225	1169	610441401885611	9998	5027	50	0	\N
260226	1003	504419775000000	9998	5027	51	0	\N
260227	1678	8640245557000	9998	5027	52	0	\N
260228	1119	906038704109009	9998	5027	53	0	\N
260229	1239	611322367758868	9998	5027	54	0	\N
260230	999	505604372838895	9998	5027	55	0	\N
260231	984	505877914565232	9998	5027	56	0	\N
260232	1104	906528888538912	9998	5027	57	0	\N
260233	1274	1699717237751650	9998	5027	58	0	\N
260234	1986	222510000000	9998	5027	59	0	\N
260235	1224	611653104961338	9998	5027	60	0	\N
260236	1874	202247000	9998	5027	61	0	\N
260237	1874	202248000	9998	5027	62	0	\N
260238	1874	202249000	9998	5027	63	0	\N
260239	1874	202250000	9998	5027	64	0	\N
260240	1874	202251000	9998	5027	65	0	\N
260241	1874	202252000	9998	5027	66	0	\N
260242	1874	202253000	9998	5027	67	0	\N
260243	1874	202254000	9998	5027	68	0	\N
260244	1678	8640245558000	9998	5027	69	0	\N
260245	1678	8640245559000	9998	5027	70	0	\N
260246	1678	8640245560000	9998	5027	71	0	\N
260247	1678	8640245561000	9998	5027	72	0	\N
260248	1678	8640245562000	9998	5027	73	0	\N
260249	1678	8640245563000	9998	5027	74	0	\N
260250	538	67245340000000	9998	5027	75	0	\N
260251	1678	8640245564000	9998	5027	76	0	\N
260252	1678	8640245565000	9998	5027	77	0	\N
260253	1678	8640245566000	9998	5027	78	0	\N
260254	1196	610330750000000	9998	5027	79	0	\N
260255	1322	1700739637751650	9998	5027	80	0	\N
260256	948	505422111740000	9998	5027	81	0	\N
260257	1068	905712093770000	9998	5027	82	0	\N
260258	1188	611101997260000	9998	5027	83	0	\N
260259	1313	1701968137751650	9998	5027	84	0	\N
260260	1067	905221765000000	9998	5027	85	0	\N
260261	1187	610771150000000	9998	5027	86	0	\N
260262	947	505148475000000	9998	5027	87	0	\N
260263	260	67247500000000	9998	5027	88	0	\N
260264	1874	202255000	9998	5027	89	0	\N
260265	1314	1702890051511650	9998	5027	90	0	\N
260266	1350	1704425762136538	9998	5027	91	0	\N
260267	1216	610598750000000	9998	5027	92	0	\N
260268	1342	1701485637751650	9998	5027	93	0	\N
260269	1678	8640245567000	9998	5027	94	0	\N
260270	1678	8640245568000	9998	5027	95	0	\N
260271	1678	8640245569000	9998	5027	96	0	\N
260272	1678	8640245570000	9998	5027	97	0	\N
260273	1678	8640245571000	9998	5027	98	0	\N
260274	1678	8640245572000	9998	5027	99	0	\N
260275	1678	8640245573000	9998	5027	100	0	\N
260276	1678	8640245574000	9998	5027	101	0	\N
260277	1678	8640245575000	9998	5027	102	0	\N
260278	1678	8640245576000	9998	5027	103	0	\N
260279	1678	8640245577000	9998	5027	104	0	\N
260280	1678	8640245578000	9998	5027	105	0	\N
260281	1678	8640245579000	9998	5027	106	0	\N
260282	1678	8640245580000	9998	5027	107	0	\N
260283	1277	1701576637751650	9998	5027	108	0	\N
260284	1031	905013465000000	9998	5027	109	0	\N
260285	1151	610630750000000	9998	5027	110	0	\N
260286	911	505032775000000	9998	5027	111	0	\N
260287	960	505057295000000	9998	5027	112	0	\N
260288	1326	1701660877751650	9998	5027	113	0	\N
260289	1200	610660900000000	9998	5027	114	0	\N
260290	1080	905058345000000	9998	5027	115	0	\N
260291	1985	1197000000000	9998	5027	116	0	\N
260292	1357	1701226867751650	9998	5027	117	0	\N
260293	939	504690042035010	9998	5027	118	0	\N
260294	1059	904400213222506	9998	5027	119	0	\N
260295	1179	610216845308516	9998	5027	120	0	\N
260296	1305	1700423496908881	9998	5027	121	0	\N
260297	1111	904827505000000	9998	5027	122	0	\N
260298	1231	610505150000000	9998	5027	123	0	\N
260299	991	504928475000000	9998	5027	124	0	\N
260300	272	66282330000000	9998	5027	125	0	\N
260301	1678	9360265766000	9999	5184	0	0	\N
260302	1991	16540007000000	9999	5184	1	0	\N
260303	1678	9360265766000	10000	5184	0	0	\N
260304	1991	16540007000000	10000	5184	1	0	\N
260309	1874	202439000	10003	5186	0	0	\N
260310	1678	9360265768000	10003	5186	1	0	\N
260313	1874	202440000	10005	5187	0	0	\N
260314	1678	9360265769000	10005	5187	1	0	\N
260315	1678	9360265770000	10005	5187	2	0	\N
260316	1678	9360265771000	10005	5187	3	0	\N
260317	1874	202441000	10005	5187	4	0	\N
260318	1874	202440000	10006	5187	0	0	\N
260319	1678	9360265769000	10006	5187	1	0	\N
260320	1678	9360265770000	10006	5187	2	0	\N
260321	1678	9360265771000	10006	5187	3	0	\N
260322	1874	202441000	10006	5187	4	0	\N
260323	1874	202442000	10006	5187	5	0	\N
260324	1722	1441118000000	10006	5187	7	0	\N
260325	83	66251089844466	10006	5187	8	0	\N
260326	348	66251989844466	10006	5187	9	0	\N
260327	380	66251089844466	10006	5187	10	0	\N
260328	530	66251188844466	10006	5187	11	0	\N
260329	675	66251089844466	10006	5187	12	0	\N
260330	959	504689421833169	10006	5187	13	0	\N
260331	1079	904399119746054	10006	5187	14	0	\N
260332	1199	610216107518151	10006	5187	15	0	\N
260333	1325	1700421440990471	10006	5187	16	0	\N
260357	1874	202445000	10011	5190	0	0	\N
260358	1678	9360265774000	10011	5190	1	0	\N
260359	1678	9360265775000	10011	5190	2	0	\N
260360	1874	202446000	10012	5191	0	0	\N
260361	1169	610441411885612	10012	5191	1	0	\N
260362	929	504875928235310	10012	5191	2	0	\N
260363	1678	9360265776000	10012	5191	3	0	\N
260385	1678	9360265782000	10018	5195	0	0	\N
260386	1874	202452000	10018	5195	1	0	\N
260387	1678	8640245758000	10019	5169	0	0	\N
260388	1678	8640245759000	10019	5169	1	0	\N
260389	1179	610216845308516	10019	5169	2	0	\N
260390	1305	1700423496908881	10019	5169	3	0	\N
260391	1678	8640245760000	10019	5169	4	0	\N
260392	1678	8640245761000	10019	5169	5	0	\N
260393	1678	8640245762000	10019	5169	6	0	\N
260394	1678	8640245763000	10019	5169	7	0	\N
260395	1678	8640245764000	10019	5169	8	0	\N
260396	1678	8640245765000	10019	5169	9	0	\N
260397	1874	202431000	10019	5169	10	0	\N
260398	1874	202432000	10019	5169	11	0	\N
260399	1678	8640245766000	10019	5169	12	0	\N
260400	1678	8640245767000	10019	5169	13	0	\N
260401	1678	8640245768000	10019	5169	14	0	\N
260402	1678	8640245769000	10019	5169	15	0	\N
260403	1678	8640245770000	10019	5169	16	0	\N
260404	1678	8640245771000	10019	5169	17	0	\N
260405	1678	8640245772000	10019	5169	18	0	\N
260406	1678	8640245773000	10019	5169	19	0	\N
260407	1678	8640245774000	10019	5169	20	0	\N
260408	1678	8640245775000	10019	5169	21	0	\N
260409	1678	8640245776000	10019	5169	22	0	\N
260410	1678	8640245777000	10019	5169	23	0	\N
260411	1678	8640245778000	10019	5169	24	0	\N
260412	1678	8640245779000	10019	5169	25	0	\N
260413	1678	8640245780000	10019	5169	26	0	\N
260414	1678	8640245781000	10019	5169	27	0	\N
260415	1678	8640245782000	10019	5169	28	0	\N
260416	1874	202433000	10019	5169	29	0	\N
260417	1874	202434000	10019	5169	30	0	\N
260418	1874	202435000	10019	5169	31	0	\N
260419	1874	202436000	10019	5169	32	0	\N
260420	1874	202437000	10019	5169	33	0	\N
260421	1874	202438000	10019	5169	34	0	\N
260422	1874	202439000	10019	5169	35	0	\N
260423	1874	202440000	10019	5169	36	0	\N
260424	1874	202441000	10019	5169	37	0	\N
260425	1874	202442000	10019	5169	38	0	\N
260426	1874	202443000	10019	5169	39	0	\N
260427	1874	202444000	10019	5169	40	0	\N
260428	1874	202445000	10019	5169	41	0	\N
260429	1874	202446000	10019	5169	42	0	\N
260430	1874	202447000	10019	5169	43	0	\N
260431	1874	202448000	10019	5169	44	0	\N
260432	1874	202449000	10019	5169	45	0	\N
260433	1874	202450000	10019	5169	46	0	\N
260434	1874	202451000	10019	5169	47	0	\N
260435	1874	202452000	10019	5169	48	0	\N
260436	1652	490000000	10019	5169	49	0	\N
260437	1722	1441118000000	10019	5169	50	0	\N
260438	1722	1442118000000	10019	5169	51	0	\N
260439	1991	16540007000000	10019	5169	52	0	\N
260440	1678	9360265783000	10020	5196	0	0	\N
260307	1678	9360265767000	10002	5185	0	0	0
260308	1874	202438000	10002	5185	1	0	0
260311	1874	202439000	10004	5186	0	0	0
260312	1678	9360265768000	10004	5186	1	0	0
260334	1874	202440000	10007	5187	0	0	0
260336	1678	9360265770000	10007	5187	2	0	0
260337	1678	9360265771000	10007	5187	3	0	0
260338	1874	202441000	10007	5187	4	0	0
260339	1874	202442000	10007	5187	5	0	0
260340	1722	1441118000000	10007	5187	7	0	10
260342	348	66251989844466	10007	5187	9	0	1
260343	380	66251089844466	10007	5187	10	0	0
260344	530	66251188844466	10007	5187	11	0	1
260345	675	66251089844466	10007	5187	12	0	0
260347	1079	904399119746054	10007	5187	14	0	0
260348	1199	610216107518151	10007	5187	15	0	0
260349	1325	1700421440990471	10007	5187	16	0	0
260350	1678	9360265772000	10008	5188	0	0	0
260351	1874	202443000	10008	5188	1	0	0
260353	1874	202444000	10009	5189	1	0	0
260354	1874	202445000	10010	5190	0	0	0
260355	1678	9360265774000	10010	5190	1	0	0
260356	1678	9360265775000	10010	5190	2	0	0
260364	1874	202446000	10013	5191	0	0	0
260366	929	504875928235310	10013	5191	2	0	0
260367	1678	9360265776000	10013	5191	3	0	0
260368	1678	9360265777000	10014	5192	0	0	0
260369	1874	202447000	10014	5192	1	0	0
260371	1406	0	10014	5192	3	0	0
260372	44	66000000000000	10014	5192	4	0	3
260373	1678	9360265778000	10015	5193	0	0	0
260374	929	504875938235310	10015	5193	1	0	0
260375	1678	9360265779000	10015	5193	2	0	0
260377	1874	202449000	10015	5193	4	0	0
260378	1874	202450000	10016	5194	0	0	0
260379	1678	9360265780000	10016	5194	1	0	0
260380	1874	202451000	10016	5194	2	0	0
260381	1678	9360265781000	10016	5194	3	0	0
260383	1678	9360265782000	10017	5195	0	0	0
260384	1874	202452000	10017	5195	1	0	0
260441	1874	202453000	10020	5196	1	0	\N
260442	1315	1703525637751650	10020	5196	2	0	\N
260443	1993	418411389290	10020	5196	3	0	\N
260448	1678	9360265784000	10022	5197	0	0	\N
260449	1678	9360265785000	10022	5197	1	0	\N
260450	1678	9360265786000	10022	5197	2	0	\N
260451	1874	202454000	10022	5197	3	0	\N
260452	1874	202455000	10022	5197	4	0	\N
260453	1069	906049965000000	10022	5197	5	0	\N
260454	1189	611329750000000	10022	5197	6	0	\N
260455	949	505611775000000	10022	5197	7	0	\N
260456	907	505969095140680	10022	5197	8	0	\N
260457	1027	906692283348880	10022	5197	9	0	\N
260458	1147	611763350695495	10022	5197	10	0	\N
260459	1273	1704732971677270	10022	5197	11	0	\N
260497	1049	904732555629265	10031	5080	0	0	\N
260498	1090	906305713000000	10031	5080	1	0	\N
260499	939	504690032035010	10031	5080	2	0	\N
260500	970	505753031000000	10031	5080	3	0	\N
260501	1336	1704004549751650	10031	5080	4	0	\N
260502	1210	611502734000000	10031	5080	5	0	\N
260503	1169	607904760000000	10031	5080	6	0	\N
260504	1169	610441411885612	10031	5080	7	0	\N
260505	929	504875928235310	10031	5080	8	0	\N
260506	929	504875938235310	10031	5080	9	0	\N
260507	939	504690042035010	10031	5080	10	0	\N
260508	1059	904400213222506	10031	5080	11	0	\N
260509	1179	610216845308516	10031	5080	12	0	\N
260510	1305	1700423496908881	10031	5080	13	0	\N
260511	950	505604375000000	10031	5080	14	0	\N
260512	1315	1703525637751650	10031	5080	15	0	\N
260513	1069	906049965000000	10031	5080	16	0	\N
260514	1652	490000000	10031	5080	17	0	\N
260515	1189	611329750000000	10031	5080	18	0	\N
260516	1991	16540007000000	10031	5080	19	0	\N
260517	1950	6389390000000	10031	5080	20	0	\N
260518	1722	1441118000000	10031	5080	21	0	\N
260519	1722	1442118000000	10031	5080	22	0	\N
260525	1678	9360265798000	10033	5206	0	0	\N
260526	1874	202466000	10033	5206	1	0	\N
260527	1070	906038705000000	10033	5206	2	0	\N
260528	1190	611322370000000	10033	5206	3	0	\N
260529	1316	1703504137751650	10033	5206	4	0	\N
260530	1678	9360265798000	10034	5206	0	0	\N
260531	1874	202466000	10034	5206	1	0	\N
260532	1070	906038705000000	10034	5206	2	0	\N
260533	1190	611322370000000	10034	5206	3	0	\N
260534	1316	1703504137751650	10034	5206	4	0	\N
260542	1874	202467000	10037	5207	0	0	\N
260543	1678	9360265799000	10037	5207	1	0	\N
260544	1874	202468000	10038	5208	0	0	\N
260545	1874	202469000	10038	5208	1	0	\N
260546	1874	202470000	10038	5208	2	0	\N
260547	1678	9360265800000	10038	5208	3	0	\N
260548	1678	9360265801000	10038	5208	4	0	\N
260549	1678	9360265802000	10038	5208	5	0	\N
260559	1678	9360265804000	10042	5210	0	0	\N
260560	1874	202471000	10042	5210	1	0	\N
260561	1678	9360265804000	10043	5210	0	0	\N
260562	1874	202471000	10043	5210	1	0	\N
260563	1678	9360265804000	10044	5210	0	0	\N
260564	1874	202471000	10044	5210	1	0	\N
260565	914	504783747659856	10045	5015	0	0	\N
260566	1034	904568150819296	10045	5015	1	0	\N
260567	1154	610330156151454	10045	5015	2	0	\N
260568	1280	1700739247647754	10045	5015	3	0	\N
260569	1338	1699817637751650	10045	5015	4	0	\N
260570	1092	904078465000000	10045	5015	5	0	\N
260571	1212	609999750000000	10045	5015	6	0	\N
260572	972	504872775000000	10045	5015	7	0	\N
260573	588	66003000000000	10045	5015	8	0	\N
260574	1939	1435990000000	10045	5015	9	0	\N
260575	207	66001110000000	10045	5015	10	0	\N
260576	531	66407503985720	10045	5015	11	0	\N
260446	1315	1703525637751650	10021	5196	2	0	0
260447	1993	418411389290	10021	5196	3	0	0
260460	1678	9360265784000	10023	5197	0	0	0
260461	1678	9360265785000	10023	5197	1	0	0
260462	1678	9360265786000	10023	5197	2	0	0
260464	1874	202455000	10023	5197	4	0	0
260465	1069	906049965000000	10023	5197	5	0	0
260466	1189	611329750000000	10023	5197	6	0	0
260467	949	505611775000000	10023	5197	7	0	0
260468	907	505969095140680	10023	5197	8	0	0
260470	1147	611763350695495	10023	5197	10	0	0
260471	1273	1704732971677270	10023	5197	11	0	0
260472	1678	9360265787000	10024	5198	0	0	0
260473	1090	906305713000000	10024	5198	1	0	0
260475	1336	1704004549751650	10025	5199	0	0	0
260476	1874	202456000	10025	5199	1	0	0
260477	1678	9360265788000	10025	5199	2	0	0
260478	1210	611502734000000	10025	5199	3	0	0
260479	1993	1668411389290	10025	5199	4	0	0
260481	1874	202457000	10026	5200	1	0	0
260482	1764	18599677100000	10026	5200	2	0	4
260483	1764	18719677100000	10026	5200	3	0	4
260484	1678	9360265790000	10027	5201	0	0	0
260485	1874	202458000	10027	5201	1	0	0
260487	1874	202459000	10028	5202	0	0	0
260488	1874	202460000	10028	5202	1	0	0
260489	1678	9360265791000	10028	5202	2	0	0
260490	1678	9360265792000	10028	5202	3	0	0
260492	1874	202461000	10029	5203	1	0	0
260493	1874	202462000	10029	5203	2	0	0
260494	1678	9360265794000	10029	5203	3	0	0
260495	1874	202463000	10030	5204	0	0	0
260496	1678	9360265795000	10030	5204	1	0	0
260521	1874	202464000	10032	5205	1	0	0
260522	1678	9360265797000	10032	5205	2	0	0
260523	1874	202465000	10032	5205	3	0	0
260524	950	505604375000000	10032	5205	4	0	0
260535	1678	9360265798000	10035	5206	0	0	0
260537	1070	906038705000000	10035	5206	2	0	0
260538	1190	611322370000000	10035	5206	3	0	0
260539	1316	1703504137751650	10035	5206	4	0	0
260540	1874	202467000	10036	5207	0	0	0
260550	1874	202468000	10039	5208	0	0	0
260551	1874	202469000	10039	5208	1	0	0
260552	1874	202470000	10039	5208	2	0	0
260553	1678	9360265800000	10040	5209	0	0	0
260554	1678	9360265801000	10040	5209	1	0	0
260556	1678	9360265803000	10040	5209	3	0	0
260557	1678	9360265804000	10041	5210	0	0	0
260558	1874	202471000	10041	5210	1	0	0
260577	1381	1702275295351650	10045	5015	12	0	\N
260578	1090	906305713000000	10045	5015	13	0	\N
260579	939	504690032035010	10045	5015	14	0	\N
260580	1295	1701047467188501	10045	5015	15	0	\N
260581	1049	904732545629265	10045	5015	16	0	\N
260582	1169	610441401885611	10045	5015	17	0	\N
260583	984	505877914565232	10045	5015	18	0	\N
260584	1104	906528888538912	10045	5015	19	0	\N
260585	970	505753031000000	10045	5015	20	0	\N
260586	1336	1704004549751650	10045	5015	21	0	\N
260587	1224	611653104961338	10045	5015	22	0	\N
260588	1210	611502734000000	10045	5015	23	0	\N
260589	1350	1704425762136538	10045	5015	24	0	\N
260590	939	504690042035010	10045	5015	25	0	\N
260591	1059	904400213222506	10045	5015	26	0	\N
260592	1179	610216845308516	10045	5015	27	0	\N
260593	1305	1700423496908881	10045	5015	28	0	\N
260594	1135	905385124870000	10045	5015	29	0	\N
260595	1015	505239650540000	10045	5015	30	0	\N
260596	1255	610881384830000	10045	5015	31	0	\N
260597	929	504875928235309	10045	5015	32	0	\N
260598	1004	505517499000000	10045	5015	33	0	\N
260599	1124	905883026000000	10045	5015	34	0	\N
260600	1244	611217329000000	10045	5015	35	0	\N
260601	1370	1703211432751650	10045	5015	36	0	\N
260602	619	66000500000000	10045	5015	37	0	\N
260603	1950	4389390000000	10045	5015	38	0	\N
260604	950	505604375000000	10045	5015	39	0	\N
260605	1315	1703525637751650	10045	5015	40	0	\N
260606	1069	906049965000000	10045	5015	41	0	\N
260607	1950	5389390000000	10045	5015	42	0	\N
260608	1070	906038705000000	10045	5015	43	0	\N
260609	1189	611329750000000	10045	5015	44	0	\N
260610	1406	0	10045	5015	45	0	\N
260611	1190	611322370000000	10045	5015	46	0	\N
260612	1991	16540007000000	10045	5015	47	0	\N
260613	1316	1703504137751650	10045	5015	48	0	\N
260614	1950	6389390000000	10045	5015	49	0	\N
260615	1722	1441118000000	10045	5015	50	0	\N
260616	1722	1442118000000	10045	5015	51	0	\N
260617	1993	418411389290	10045	5015	52	0	\N
260618	907	505969095140680	10045	5015	53	0	\N
260619	1027	906692283348880	10045	5015	54	0	\N
260620	1147	611763350695495	10045	5015	55	0	\N
260621	1273	1704732971677270	10045	5015	56	0	\N
260622	1993	1668411389290	10045	5015	57	0	\N
260623	1764	15840677100000	10045	5015	58	0	\N
260624	1334	1702537637751650	10045	5015	59	0	\N
260625	1678	9360265805000	10046	5211	0	0	\N
260626	1874	202472000	10046	5211	1	0	\N
260629	1678	9360265805000	10048	5211	0	0	\N
260630	1874	202472000	10048	5211	1	0	\N
260631	1678	9360265805000	10049	5211	0	0	\N
260632	1874	202472000	10049	5211	1	0	\N
260635	1678	9360265806000	10051	5212	0	0	\N
260636	1874	202473000	10051	5212	1	0	\N
260639	1678	9360265808000	10053	5214	0	0	\N
260645	1678	9360265811000	10056	5216	0	0	\N
260646	1874	202477000	10056	5216	1	0	\N
260647	1651	9354000000000	10056	5216	2	0	\N
260651	1874	202478000	10058	5217	0	0	\N
260652	1678	9360265812000	10058	5217	1	0	\N
260654	1874	202478000	10060	5218	0	0	\N
260655	1874	202479000	10060	5218	1	0	\N
260656	1678	9360265813000	10060	5218	2	0	\N
260657	1678	9360265814000	10060	5218	3	0	\N
260658	149	79680447000341	10060	5218	4	0	\N
260659	1651	19840000000000	10060	5218	5	0	\N
260660	1994	200000000	10060	5218	6	0	\N
260661	1995	200000000	10060	5218	7	0	\N
260662	1994	1400000000	10060	5218	8	0	\N
260663	1996	200000000	10060	5218	9	0	\N
260664	1997	200000000	10060	5218	10	0	\N
260665	1874	202480000	10060	5218	11	0	\N
260666	1874	202481000	10060	5218	12	0	\N
260667	1678	9360265815000	10060	5218	13	0	\N
260682	149	78240327000341	10062	5056	0	0	\N
260687	1874	202482000	10064	5219	0	0	\N
260688	199	66263082769232	10064	5219	1	0	\N
260689	214	66263082769232	10064	5219	2	0	\N
260690	1678	9360265816000	10064	5219	3	0	\N
260691	1678	9360265817000	10065	5220	0	0	\N
260692	234	66263082769232	10065	5220	1	0	\N
260693	282	66263082769232	10065	5220	2	0	\N
260694	314	66263082769232	10065	5220	3	0	\N
260695	323	66263082769232	10065	5220	4	0	\N
260696	330	66263082769232	10065	5220	5	0	\N
260697	332	66263082769232	10065	5220	6	0	\N
260698	334	66263082769232	10065	5220	7	0	\N
260699	343	66263082769232	10065	5220	8	0	\N
260700	559	66263082769232	10065	5220	9	0	\N
260711	1874	202482000	10067	5219	0	0	\N
260712	1874	202483000	10067	5219	1	0	\N
260633	1678	9360265806000	10050	5212	0	0	0
260634	1874	202473000	10050	5212	1	0	0
260637	1678	9360265807000	10052	5213	0	0	0
260638	1874	202474000	10052	5213	1	0	0
260640	1678	9360265808000	10054	5214	0	0	0
260642	1874	202476000	10055	5215	1	0	0
260643	1678	9360265809000	10055	5215	2	0	0
260644	1678	9360265810000	10055	5215	3	0	0
260648	1678	9360265811000	10057	5216	0	0	0
260649	1874	202477000	10057	5216	1	0	0
260653	1678	9360265812000	10059	5217	0	0	0
260668	1874	202478000	10061	5218	0	0	0
260669	1874	202479000	10061	5218	1	0	0
260670	1678	9360265813000	10061	5218	2	0	0
260672	149	79680447000341	10061	5218	4	0	0
260673	1651	19840000000000	10061	5218	5	0	0
260674	1994	200000000	10061	5218	6	0	0
260675	1995	200000000	10061	5218	7	0	0
260676	1994	1400000000	10061	5218	8	0	0
260678	1997	200000000	10061	5218	10	0	0
260679	1874	202480000	10061	5218	11	0	0
260680	1874	202481000	10061	5218	12	0	0
260681	1678	9360265815000	10061	5218	13	0	0
260683	1874	202482000	10063	5219	0	0	0
260685	214	66263082769232	10063	5219	2	0	0
260686	1678	9360265816000	10063	5219	3	0	0
260701	1678	9360265817000	10066	5220	0	0	0
260702	234	66263082769232	10066	5220	1	0	0
260704	314	66263082769232	10066	5220	3	0	0
260705	323	66263082769232	10066	5220	4	0	0
260706	330	66263082769232	10066	5220	5	0	0
260707	332	66263082769232	10066	5220	6	0	0
260708	334	66263082769232	10066	5220	7	0	0
260710	559	66263082769232	10066	5220	9	0	0
260713	199	66263082769232	10067	5219	2	0	\N
260714	214	66263082769232	10067	5219	3	0	\N
260715	234	66263082769232	10067	5219	4	0	\N
260716	282	66263082769232	10067	5219	5	0	\N
260717	1678	9360265816000	10067	5219	6	0	\N
260718	1678	9360265817000	10067	5219	7	0	\N
260719	1678	9360265818000	10067	5219	8	0	\N
260720	314	66263082769232	10067	5219	9	0	\N
260721	323	66263082769232	10067	5219	10	0	\N
260722	330	66263082769232	10067	5219	11	0	\N
260723	332	66263082769232	10067	5219	12	0	\N
260724	334	66263082769232	10067	5219	13	0	\N
260725	343	66263082769232	10067	5219	14	0	\N
260726	559	66263082769232	10067	5219	15	0	\N
260727	561	66263082769232	10067	5219	16	0	\N
260728	1874	202483000	10068	5221	0	0	\N
260729	1678	9360265818000	10068	5221	1	0	\N
260730	1745	1803000000	10068	5221	2	0	\N
260734	1090	906305713000000	10070	5170	0	0	\N
260735	199	66263082769232	10070	5170	1	0	\N
260736	214	66263082769232	10070	5170	2	0	\N
260737	149	78960407000341	10070	5170	3	0	\N
260738	1678	8640245783000	10070	5170	4	0	\N
260739	1678	8640245784000	10070	5170	5	0	\N
260740	1678	8640245785000	10070	5170	6	0	\N
260741	1678	8640245786000	10070	5170	7	0	\N
260742	1678	8640245787000	10070	5170	8	0	\N
260743	1651	10486000000000	10070	5170	9	0	\N
260778	1678	9360265828000	10075	5225	0	0	\N
260779	1874	202492000	10075	5225	1	0	\N
260780	1749	15592394000000	10075	5225	2	0	\N
260793	1874	202494000	10078	5227	0	0	\N
260794	1678	9360265830000	10078	5227	1	0	\N
260795	1678	9360265831000	10078	5227	2	0	\N
260796	1874	202495000	10078	5227	3	0	\N
260797	271	66411417920446	10078	5227	4	0	\N
260798	269	66411417920446	10078	5227	5	0	\N
260799	577	66411417920446	10078	5227	6	0	\N
260806	1678	9360265831000	10080	5228	0	0	\N
260807	1874	202495000	10080	5228	1	0	\N
260808	1874	202496000	10080	5228	2	0	\N
260809	683	66146585999999	10080	5228	3	0	\N
260810	1678	9360265832000	10080	5228	4	0	\N
260811	968	505318775000000	10080	5228	5	0	\N
260821	1678	9360265836000	10084	5232	0	0	\N
260822	1678	9360265837000	10084	5232	1	0	\N
260823	1678	9360265838000	10084	5232	2	0	\N
260824	22	22439350095941	10084	5232	3	0	\N
260825	190	66335084938283	10084	5232	4	0	\N
260826	258	66335084938283	10084	5232	5	0	\N
260827	273	66335084938283	10084	5232	6	0	\N
260828	292	66335084938283	10084	5232	7	0	\N
260829	293	66335084938283	10084	5232	8	0	\N
260830	333	66335084938283	10084	5232	9	0	\N
260831	376	66335084938283	10084	5232	10	0	\N
260832	426	66335084938283	10084	5232	11	0	\N
260833	429	66335084938283	10084	5232	12	0	\N
260834	430	66335084938283	10084	5232	13	0	\N
260835	440	66335084938283	10084	5232	14	0	\N
260836	474	66335084938283	10084	5232	15	0	\N
260837	475	66335084938283	10084	5232	16	0	\N
260838	476	66335084938283	10084	5232	17	0	\N
260839	483	66335084938283	10084	5232	18	0	\N
260840	486	66335084938283	10084	5232	19	0	\N
260841	490	66335084938283	10084	5232	20	0	\N
260842	496	66335084938283	10084	5232	21	0	\N
260843	1874	202500000	10084	5232	22	0	\N
260844	1874	202501000	10084	5232	23	0	\N
260845	2001	200000000	10084	5232	24	0	\N
260846	1874	202502000	10084	5232	25	0	\N
260733	1745	1803000000	10069	5221	2	0	5
260744	683	66146584999999	10071	5222	0	0	0
260745	1678	9360265819000	10071	5222	1	0	0
260746	1678	9360265820000	10071	5222	2	0	0
260747	1874	202484000	10071	5222	3	0	0
260749	149	80021597000341	10071	5222	5	0	0
260750	1874	202485000	10071	5222	6	0	0
260751	1999	200000000	10071	5222	7	0	0
260752	1874	202486000	10071	5222	8	0	0
260753	1874	202487000	10071	5222	9	0	0
260755	1678	9360265822000	10071	5222	11	0	0
260756	1088	905524965000000	10071	5222	12	0	0
260757	1208	610975250000000	10071	5222	13	0	0
260758	1678	9360265823000	10072	5223	0	0	0
260760	1281	1702736497751650	10072	5223	2	0	0
260761	1035	905630425000000	10072	5223	3	0	0
260762	1155	611046900000000	10072	5223	4	0	0
260763	915	505376545000000	10072	5223	5	0	0
260764	1764	2542674100000	10072	5223	6	0	7
260766	104	66263082769232	10073	5224	1	0	0
260767	1678	9360265824000	10073	5224	2	0	0
260768	1678	9360265825000	10073	5224	3	0	0
260769	1678	9360265826000	10073	5224	4	0	0
260770	1678	9360265827000	10073	5224	5	0	0
260772	1874	202490000	10073	5224	7	0	0
260773	1874	202491000	10073	5224	8	0	0
260774	1102	906362711758531	10073	5224	9	0	0
260775	1222	611540982176308	10073	5224	10	0	0
260777	1749	14873394000000	10073	5224	12	0	8
260781	561	66263082769232	10076	5226	0	0	0
260782	1678	9360265828000	10076	5226	1	0	0
260783	1678	9360265829000	10076	5226	2	0	0
260784	1874	202492000	10076	5226	3	0	0
260786	2000	200000000	10076	5226	5	0	0
260787	1749	15592394000000	10076	5226	6	0	8
260788	1874	202494000	10077	5227	0	0	0
260789	1678	9360265830000	10077	5227	1	0	0
260790	271	66411417920446	10077	5227	2	0	0
260792	577	66411417920446	10077	5227	4	0	0
260800	1678	9360265831000	10079	5228	0	0	0
260801	1874	202495000	10079	5228	1	0	0
260802	1874	202496000	10079	5228	2	0	0
260804	1678	9360265832000	10079	5228	4	0	0
260805	968	505318775000000	10079	5228	5	0	0
260812	1874	202497000	10081	5229	0	0	0
260813	1678	9360265833000	10081	5229	1	0	0
260814	1874	202498000	10082	5230	0	0	0
260816	1327	1701550637751650	10082	5230	2	0	0
260817	1081	904999465000000	10082	5230	3	0	0
260818	1201	610620750000000	10082	5230	4	0	0
260819	1874	202499000	10083	5231	0	0	0
260820	1678	9360265835000	10083	5231	1	0	0
260848	1678	9360265837000	10085	5232	1	0	0
260873	1874	202503000	10086	5233	0	0	\N
260874	511	66335084938283	10086	5233	1	0	\N
260875	512	66335084938283	10086	5233	2	0	\N
260876	522	66335084938283	10086	5233	3	0	\N
260877	523	66335084938283	10086	5233	4	0	\N
260878	533	66335084938283	10086	5233	5	0	\N
260879	539	66335084938283	10086	5233	6	0	\N
260880	541	66335084938283	10086	5233	7	0	\N
260881	558	66335084938283	10086	5233	8	0	\N
260882	565	66335084938283	10086	5233	9	0	\N
260883	572	66335084938283	10086	5233	10	0	\N
260884	573	66335084938283	10086	5233	11	0	\N
260885	576	84335674938283	10086	5233	12	0	\N
260886	584	66335084938283	10086	5233	13	0	\N
260887	1678	9360265839000	10086	5233	14	0	\N
260888	1678	9360265840000	10086	5233	15	0	\N
260889	1874	202504000	10086	5233	16	0	\N
260890	585	66335084938283	10086	5233	17	0	\N
260891	589	66335084938283	10086	5233	18	0	\N
260892	595	66335084938283	10086	5233	19	0	\N
260893	597	66335084938283	10086	5233	20	0	\N
260894	1745	1803000000	10086	5233	21	0	\N
260895	1874	202503000	10087	5233	0	0	\N
260896	511	66335084938283	10087	5233	1	0	\N
260897	512	66335084938283	10087	5233	2	0	\N
260898	522	66335084938283	10087	5233	3	0	\N
260899	523	66335084938283	10087	5233	4	0	\N
260900	533	66335084938283	10087	5233	5	0	\N
260901	539	66335084938283	10087	5233	6	0	\N
260902	541	66335084938283	10087	5233	7	0	\N
260903	558	66335084938283	10087	5233	8	0	\N
260904	565	66335084938283	10087	5233	9	0	\N
260905	572	66335084938283	10087	5233	10	0	\N
260906	573	66335084938283	10087	5233	11	0	\N
260907	576	84335674938283	10087	5233	12	0	\N
260908	584	66335084938283	10087	5233	13	0	\N
260909	1678	9360265839000	10087	5233	14	0	\N
260910	1678	9360265840000	10087	5233	15	0	\N
260911	1874	202504000	10087	5233	16	0	\N
260912	585	66335084938283	10087	5233	17	0	\N
260913	589	66335084938283	10087	5233	18	0	\N
260914	595	66335084938283	10087	5233	19	0	\N
260915	597	66335084938283	10087	5233	20	0	\N
260916	1745	1803000000	10087	5233	21	0	\N
260951	1090	906305713000000	10090	5172	0	0	\N
260952	939	504690032035010	10090	5172	1	0	\N
260953	1348	1704113322026672	10090	5172	2	0	\N
260954	1295	1701047467188501	10090	5172	3	0	\N
260955	1049	904732545629265	10090	5172	4	0	\N
260956	1169	610441401885611	10090	5172	5	0	\N
260957	1874	202423000	10090	5172	6	0	\N
260958	199	66263082769232	10090	5172	7	0	\N
260959	214	66263082769232	10090	5172	8	0	\N
260960	1874	202424000	10090	5172	9	0	\N
260961	1874	202425000	10090	5172	10	0	\N
260962	22	22439350095941	10090	5172	11	0	\N
260963	190	66335084938283	10090	5172	12	0	\N
260964	258	66335084938283	10090	5172	13	0	\N
260965	273	66335084938283	10090	5172	14	0	\N
260966	149	78960407000341	10090	5172	15	0	\N
260967	1651	10486000000000	10090	5172	16	0	\N
260968	1874	202426000	10090	5172	17	0	\N
260969	1874	202427000	10090	5172	18	0	\N
260970	970	505753031000000	10090	5172	19	0	\N
260971	1336	1704004549751650	10090	5172	20	0	\N
260972	149	79301557000341	10090	5172	21	0	\N
260973	234	66263082769232	10090	5172	22	0	\N
260974	282	66263082769232	10090	5172	23	0	\N
260975	1678	9360265749000	10090	5172	24	0	\N
260976	1210	611502734000000	10090	5172	25	0	\N
260977	314	66263082769232	10090	5172	26	0	\N
260978	323	66263082769232	10090	5172	27	0	\N
260979	330	66263082769232	10090	5172	28	0	\N
260980	332	66263082769232	10090	5172	29	0	\N
260981	334	66263082769232	10090	5172	30	0	\N
260982	343	66263082769232	10090	5172	31	0	\N
260983	292	66335084938283	10090	5172	32	0	\N
260984	293	66335084938283	10090	5172	33	0	\N
260851	190	66335084938283	10085	5232	4	0	0
260852	258	66335084938283	10085	5232	5	0	0
260853	273	66335084938283	10085	5232	6	0	0
260854	292	66335084938283	10085	5232	7	0	0
260855	293	66335084938283	10085	5232	8	0	0
260857	376	66335084938283	10085	5232	10	0	0
260858	426	66335084938283	10085	5232	11	0	0
260859	429	66335084938283	10085	5232	12	0	0
260860	430	66335084938283	10085	5232	13	0	0
260861	440	66335084938283	10085	5232	14	0	0
260863	475	66335084938283	10085	5232	16	0	0
260864	476	66335084938283	10085	5232	17	0	0
260865	483	66335084938283	10085	5232	18	0	0
260866	486	66335084938283	10085	5232	19	0	0
260868	496	66335084938283	10085	5232	21	0	0
260869	1874	202500000	10085	5232	22	0	0
260870	1874	202501000	10085	5232	23	0	0
260871	2001	200000000	10085	5232	24	0	0
260872	1874	202502000	10085	5232	25	0	0
260918	511	66335084938283	10088	5233	1	0	0
260919	512	66335084938283	10088	5233	2	0	0
260920	522	66335084938283	10088	5233	3	0	0
260921	523	66335084938283	10088	5233	4	0	0
260922	533	66335084938283	10088	5233	5	0	0
260924	541	66335084938283	10088	5233	7	0	0
260925	558	66335084938283	10088	5233	8	0	0
260926	565	66335084938283	10088	5233	9	0	0
260927	572	66335084938283	10088	5233	10	0	0
260929	576	84335674938283	10088	5233	12	0	0
260930	584	66335084938283	10088	5233	13	0	0
260931	1678	9360265839000	10088	5233	14	0	0
260932	1678	9360265840000	10088	5233	15	0	0
260933	1874	202504000	10088	5233	16	0	0
260935	589	66335084938283	10088	5233	18	0	0
260936	595	66335084938283	10088	5233	19	0	0
260937	597	66335084938283	10088	5233	20	0	0
260938	1745	1803000000	10088	5233	21	0	5
260939	2002	4000000000	10089	5234	0	0	0
260941	609	66335084938283	10089	5234	2	0	0
260942	612	66335084938283	10089	5234	3	0	0
260943	1874	202505000	10089	5234	4	0	0
260944	615	66335084938283	10089	5234	5	0	0
260946	617	66335084938283	10089	5234	7	0	0
260947	624	66335084938283	10089	5234	8	0	0
260948	625	66335084938283	10089	5234	9	0	0
260949	626	66335084938283	10089	5234	10	0	0
260950	627	66335084938283	10089	5234	11	0	0
260985	333	66335084938283	10090	5172	34	0	\N
260986	376	66335084938283	10090	5172	35	0	\N
260987	426	66335084938283	10090	5172	36	0	\N
260988	429	66335084938283	10090	5172	37	0	\N
260989	430	66335084938283	10090	5172	38	0	\N
260990	440	66335084938283	10090	5172	39	0	\N
260991	474	66335084938283	10090	5172	40	0	\N
260992	475	66335084938283	10090	5172	41	0	\N
260993	476	66335084938283	10090	5172	42	0	\N
260994	483	66335084938283	10090	5172	43	0	\N
260995	486	66335084938283	10090	5172	44	0	\N
260996	490	66335084938283	10090	5172	45	0	\N
260997	496	66335084938283	10090	5172	46	0	\N
260998	511	66335084938283	10090	5172	47	0	\N
260999	512	66335084938283	10090	5172	48	0	\N
261000	522	66335084938283	10090	5172	49	0	\N
261001	523	66335084938283	10090	5172	50	0	\N
261002	533	66335084938283	10090	5172	51	0	\N
261003	539	66335084938283	10090	5172	52	0	\N
261004	541	66335084938283	10090	5172	53	0	\N
261005	558	66335084938283	10090	5172	54	0	\N
261006	565	66335084938283	10090	5172	55	0	\N
261007	572	66335084938283	10090	5172	56	0	\N
261008	573	66335084938283	10090	5172	57	0	\N
261009	576	84335674938283	10090	5172	58	0	\N
261010	584	66335084938283	10090	5172	59	0	\N
261011	1874	202428000	10090	5172	60	0	\N
261012	1874	202429000	10090	5172	61	0	\N
261013	559	66263082769232	10090	5172	62	0	\N
261014	1874	202430000	10090	5172	63	0	\N
261015	1874	202431000	10090	5172	64	0	\N
261016	1874	202432000	10090	5172	65	0	\N
261017	1678	9360265750000	10090	5172	66	0	\N
261018	1678	9360265751000	10090	5172	67	0	\N
261019	1678	9360265752000	10090	5172	68	0	\N
261020	1678	9360265753000	10090	5172	69	0	\N
261021	1678	9360265754000	10090	5172	70	0	\N
261022	1678	9360265755000	10090	5172	71	0	\N
261023	1678	9360265756000	10090	5172	72	0	\N
261024	1678	9360265757000	10090	5172	73	0	\N
261025	1678	9360265758000	10090	5172	74	0	\N
261026	1678	9360265759000	10090	5172	75	0	\N
261027	1678	9360265760000	10090	5172	76	0	\N
261028	1678	9360265761000	10090	5172	77	0	\N
261029	1678	9360265762000	10090	5172	78	0	\N
261030	1678	9360265763000	10090	5172	79	0	\N
261031	1678	9360265764000	10090	5172	80	0	\N
261032	1678	9360265765000	10090	5172	81	0	\N
261033	1678	9360265766000	10090	5172	82	0	\N
261034	1678	9360265767000	10090	5172	83	0	\N
261035	1678	9360265768000	10090	5172	84	0	\N
261036	1678	9360265769000	10090	5172	86	0	\N
261037	1678	9360265770000	10090	5172	87	0	\N
261038	1678	9360265771000	10090	5172	88	0	\N
261039	1678	9360265772000	10090	5172	89	0	\N
261040	1678	9360265773000	10090	5172	90	0	\N
261041	1678	9360265774000	10090	5172	91	0	\N
261042	1678	9360265775000	10090	5172	92	0	\N
261043	1678	9360265776000	10090	5172	93	0	\N
261044	1678	9360265777000	10090	5172	94	0	\N
261045	1678	9360265778000	10090	5172	95	0	\N
261046	1678	9360265779000	10090	5172	96	0	\N
261047	1678	9360265780000	10090	5172	97	0	\N
261048	1678	9360265781000	10090	5172	98	0	\N
261049	1678	9360265782000	10090	5172	99	0	\N
261050	1678	9360265783000	10090	5172	100	0	\N
261051	1678	9360265784000	10090	5172	101	0	\N
261052	1678	9360265785000	10090	5172	102	0	\N
261053	1678	9360265786000	10090	5172	103	0	\N
261054	1678	9360265787000	10090	5172	104	0	\N
261055	1678	9360265788000	10090	5172	105	0	\N
261056	1678	9360265789000	10090	5172	106	0	\N
261057	1678	9360265790000	10090	5172	107	0	\N
261058	1678	9360265791000	10090	5172	108	0	\N
261059	1678	9360265792000	10090	5172	109	0	\N
261060	1678	9360265793000	10090	5172	110	0	\N
261061	939	504690042035010	10090	5172	111	0	\N
261062	1059	904400213222506	10090	5172	112	0	\N
261063	1179	610216845308516	10090	5172	113	0	\N
261097	1768	15997411110000	10093	5236	0	0	\N
261098	1330	1700410637751650	10093	5236	1	0	\N
261099	1958	710988000000	10093	5236	2	0	\N
261100	1874	202507000	10093	5236	3	0	\N
261101	1678	9360265843000	10093	5236	4	0	\N
261102	1678	9360265844000	10093	5236	5	0	\N
261103	681	66335084938283	10093	5236	6	0	\N
261104	720	2010154089039	10093	5236	8	0	\N
261105	722	2010154089039	10093	5236	9	0	\N
261106	760	1005077044519	10093	5236	10	0	\N
261107	763	1005077044519	10093	5236	11	0	\N
261108	767	1005077044519	10093	5236	12	0	\N
261109	769	1005077044519	10093	5236	13	0	\N
261110	958	505385775000000	10093	5236	14	0	\N
261111	1078	905646465000000	10093	5236	15	0	\N
261112	1198	611057750000000	10093	5236	16	0	\N
261113	1324	1702766637751650	10093	5236	17	0	\N
261114	967	504692575000000	10093	5236	18	0	\N
261115	1087	904404765000000	10093	5236	19	0	\N
261116	1207	610219920000000	10093	5236	20	0	\N
261117	1333	1700432137751650	10093	5236	21	0	\N
261118	1768	15997411110000	10094	5236	0	0	\N
261119	1330	1700410637751650	10094	5236	1	0	\N
261120	1958	710988000000	10094	5236	2	0	\N
261066	1874	202506000	10091	5235	2	0	0
261067	1678	9360265842000	10091	5235	3	0	0
261068	637	66335084938283	10091	5235	4	0	0
261069	647	66335084938283	10091	5235	5	0	0
261070	656	66335084938283	10091	5235	6	0	0
261072	666	66335084938283	10091	5235	8	0	0
261073	670	66335084938283	10091	5235	9	0	0
261074	673	66335084938283	10091	5235	10	0	0
261075	674	66335084938283	10091	5235	11	0	0
261076	1768	15997411110000	10092	5236	0	0	0
261078	1958	710988000000	10092	5236	2	0	1
261079	1874	202507000	10092	5236	3	0	0
261080	1678	9360265843000	10092	5236	4	0	0
261081	1678	9360265844000	10092	5236	5	0	0
261083	720	2010154089039	10092	5236	8	0	0
261084	722	2010154089039	10092	5236	9	0	0
261085	760	1005077044519	10092	5236	10	0	0
261086	763	1005077044519	10092	5236	11	0	0
261087	767	1005077044519	10092	5236	12	0	0
261089	958	505385775000000	10092	5236	14	0	0
261090	1078	905646465000000	10092	5236	15	0	0
261091	1198	611057750000000	10092	5236	16	0	0
261092	1324	1702766637751650	10092	5236	17	0	0
261093	967	504692575000000	10092	5236	18	0	0
261095	1207	610219920000000	10092	5236	20	0	0
261096	1333	1700432137751650	10092	5236	21	0	0
261121	1874	202507000	10094	5236	3	0	\N
261122	1678	9360265843000	10094	5236	4	0	\N
261123	1678	9360265844000	10094	5236	5	0	\N
261124	681	66335084938283	10094	5236	6	0	\N
261125	720	2010154089039	10094	5236	8	0	\N
261126	722	2010154089039	10094	5236	9	0	\N
261127	760	1005077044519	10094	5236	10	0	\N
261128	763	1005077044519	10094	5236	11	0	\N
261129	767	1005077044519	10094	5236	12	0	\N
261130	769	1005077044519	10094	5236	13	0	\N
261131	958	505385775000000	10094	5236	14	0	\N
261132	1078	905646465000000	10094	5236	15	0	\N
261133	1198	611057750000000	10094	5236	16	0	\N
261134	1324	1702766637751650	10094	5236	17	0	\N
261135	967	504692575000000	10094	5236	18	0	\N
261136	1087	904404765000000	10094	5236	19	0	\N
261137	1207	610219920000000	10094	5236	20	0	\N
261138	1333	1700432137751650	10094	5236	21	0	\N
261139	1768	15997411110000	10095	5236	0	0	\N
261140	1330	1700410637751650	10095	5236	1	0	\N
261141	1958	710988000000	10095	5236	2	0	\N
261142	1874	202507000	10095	5236	3	0	\N
261143	1678	9360265843000	10095	5236	4	0	\N
261144	1678	9360265844000	10095	5236	5	0	\N
261145	681	66335084938283	10095	5236	6	0	\N
261146	720	2010154089039	10095	5236	8	0	\N
261147	722	2010154089039	10095	5236	9	0	\N
261148	760	1005077044519	10095	5236	10	0	\N
261149	763	1005077044519	10095	5236	11	0	\N
261150	767	1005077044519	10095	5236	12	0	\N
261151	769	1005077044519	10095	5236	13	0	\N
261152	958	505385775000000	10095	5236	14	0	\N
261153	1078	905646465000000	10095	5236	15	0	\N
261154	1198	611057750000000	10095	5236	16	0	\N
261155	1324	1702766637751650	10095	5236	17	0	\N
261156	967	504692575000000	10095	5236	18	0	\N
261157	1087	904404765000000	10095	5236	19	0	\N
261158	1207	610219920000000	10095	5236	20	0	\N
261159	1333	1700432137751650	10095	5236	21	0	\N
261164	1204	610212750000000	10097	5237	0	0	\N
261165	1084	904393465000000	10097	5237	1	0	\N
261166	964	504686775000000	10097	5237	2	0	\N
261167	1678	9360265845000	10097	5237	3	0	\N
261189	1678	9360265855000	10104	5243	0	0	\N
261190	1316	1703504237751650	10104	5243	1	0	\N
261193	1678	9360265855000	10106	5243	0	0	\N
261194	1316	1703504237751650	10106	5243	1	0	\N
261195	1678	9360265856000	10107	5244	0	0	\N
261196	913	504301187001523	10107	5244	1	0	\N
261197	1148	609963489000000	10107	5244	2	0	\N
261208	1678	9360265857000	10111	5245	0	0	\N
261209	1678	9360265858000	10111	5245	1	0	\N
261210	1874	202508000	10111	5245	2	0	\N
261211	1363	1701353666729234	10111	5245	3	0	\N
261212	1117	904894940439233	10111	5245	4	0	\N
261213	1237	610550647619768	10111	5245	5	0	\N
261214	997	504966108810757	10111	5245	6	0	\N
261215	1768	15997411110000	10112	5209	0	0	\N
261216	1330	1700410637751650	10112	5209	1	0	\N
261217	1768	17997411110000	10112	5209	2	0	\N
261218	1762	21598490000000	10112	5209	3	0	\N
261219	1204	610212750000000	10112	5209	4	0	\N
261220	1084	904393465000000	10112	5209	5	0	\N
261221	964	504686775000000	10112	5209	6	0	\N
261222	1348	1704113322026672	10112	5209	7	0	\N
261223	1316	1703504237751650	10112	5209	8	0	\N
261224	482	66000010000000	10112	5209	9	0	\N
261225	913	502777775001523	10112	5209	10	0	\N
261226	913	504301187001523	10112	5209	11	0	\N
261227	199	66263082769232	10112	5209	12	0	\N
261228	214	66263082769232	10112	5209	13	0	\N
261229	22	22439350095941	10112	5209	14	0	\N
261230	190	66335084938283	10112	5209	15	0	\N
261231	258	66335084938283	10112	5209	16	0	\N
261232	273	66335084938283	10112	5209	17	0	\N
261233	149	79680447000341	10112	5209	18	0	\N
261234	1148	609963489000000	10112	5209	19	0	\N
261235	1651	10486000000000	10112	5209	20	0	\N
261236	149	80021597000341	10112	5209	21	0	\N
261237	234	66263082769232	10112	5209	22	0	\N
261238	282	66263082769232	10112	5209	23	0	\N
261239	1874	202471000	10112	5209	24	0	\N
261240	1874	202472000	10112	5209	25	0	\N
261241	314	66263082769232	10112	5209	26	0	\N
261242	323	66263082769232	10112	5209	27	0	\N
261243	330	66263082769232	10112	5209	28	0	\N
261244	332	66263082769232	10112	5209	29	0	\N
261245	334	66263082769232	10112	5209	30	0	\N
261246	343	66263082769232	10112	5209	31	0	\N
261247	292	66335084938283	10112	5209	32	0	\N
261248	293	66335084938283	10112	5209	33	0	\N
261249	333	66335084938283	10112	5209	34	0	\N
261250	376	66335084938283	10112	5209	35	0	\N
261251	426	66335084938283	10112	5209	36	0	\N
261252	429	66335084938283	10112	5209	37	0	\N
261253	430	66335084938283	10112	5209	38	0	\N
261254	440	66335084938283	10112	5209	39	0	\N
261255	474	66335084938283	10112	5209	40	0	\N
261256	475	66335084938283	10112	5209	41	0	\N
261162	964	504686775000000	10096	5237	2	0	0
261163	1678	9360265845000	10096	5237	3	0	0
261168	1958	1005988000000	10098	5238	0	0	1
261169	1678	9360265846000	10098	5238	1	0	0
261170	2003	4268367953	10098	5238	2	0	0
261172	1678	9360265847000	10099	5239	1	0	0
261173	1678	9360265848000	10099	5239	2	0	0
261174	242	66411417920446	10099	5239	3	0	0
261175	2003	351980654821	10099	5239	4	0	0
261176	482	66000010000000	10099	5239	5	0	0
261178	372	66411417920446	10099	5239	7	0	0
261179	1678	9360265849000	10099	5239	8	0	0
261180	1678	9360265850000	10099	5239	9	0	0
261181	1678	9360265851000	10101	5240	0	0	0
261183	913	502777775001523	10103	5242	0	0	0
261184	1678	9360265853000	10103	5242	1	0	0
261185	1678	9360265854000	10103	5242	2	0	0
261186	1055	905710658484311	10103	5242	3	0	0
261187	1175	611101028839126	10103	5242	4	0	0
261191	1678	9360265855000	10105	5243	0	0	0
261192	1316	1703504237751650	10105	5243	1	0	0
261198	1678	9360265856000	10109	5244	0	0	0
261199	913	504301187001523	10109	5244	1	0	0
261200	1148	609963489000000	10109	5244	2	0	0
261202	1678	9360265858000	10110	5245	1	0	0
261203	1874	202508000	10110	5245	2	0	0
261204	1363	1701353666729234	10110	5245	3	0	0
261205	1117	904894940439233	10110	5245	4	0	0
261207	997	504966108810757	10110	5245	6	0	0
261257	476	66335084938283	10112	5209	42	0	\N
261258	483	66335084938283	10112	5209	43	0	\N
261259	486	66335084938283	10112	5209	44	0	\N
261260	490	66335084938283	10112	5209	45	0	\N
261261	496	66335084938283	10112	5209	46	0	\N
261262	511	66335084938283	10112	5209	47	0	\N
261263	512	66335084938283	10112	5209	48	0	\N
261264	522	66335084938283	10112	5209	49	0	\N
261265	523	66335084938283	10112	5209	50	0	\N
261266	533	66335084938283	10112	5209	51	0	\N
261267	539	66335084938283	10112	5209	52	0	\N
261268	541	66335084938283	10112	5209	53	0	\N
261269	558	66335084938283	10112	5209	54	0	\N
261270	565	66335084938283	10112	5209	55	0	\N
261271	572	66335084938283	10112	5209	56	0	\N
261272	573	66335084938283	10112	5209	57	0	\N
261273	576	84335674938283	10112	5209	58	0	\N
261274	584	66335084938283	10112	5209	59	0	\N
261275	559	66263082769232	10112	5209	60	0	\N
261276	1678	9360265803000	10112	5209	61	0	\N
261277	1678	9360265804000	10112	5209	62	0	\N
261278	1678	9360265805000	10112	5209	63	0	\N
261279	1678	9360265806000	10112	5209	64	0	\N
261280	1678	9360265807000	10112	5209	65	0	\N
261281	1678	9360265808000	10112	5209	66	0	\N
261282	1678	9360265809000	10112	5209	67	0	\N
261283	1678	9360265810000	10112	5209	68	0	\N
261284	1678	9360265811000	10112	5209	69	0	\N
261285	1678	9360265812000	10112	5209	70	0	\N
261286	1678	9360265813000	10112	5209	71	0	\N
261287	1678	9360265814000	10112	5209	72	0	\N
261288	1678	9360265815000	10112	5209	73	0	\N
261289	1678	9360265816000	10112	5209	74	0	\N
261290	1678	9360265817000	10112	5209	75	0	\N
261291	1678	9360265818000	10112	5209	76	0	\N
261292	1678	9360265819000	10112	5209	77	0	\N
261293	1678	9360265820000	10112	5209	78	0	\N
261294	1874	202473000	10112	5209	79	0	\N
261295	1874	202474000	10112	5209	80	0	\N
261296	1874	202475000	10112	5209	81	0	\N
261297	1874	202476000	10112	5209	82	0	\N
261298	1874	202477000	10112	5209	83	0	\N
261299	1874	202478000	10112	5209	84	0	\N
261300	1874	202479000	10112	5209	85	0	\N
261301	1994	200000000	10112	5209	86	0	\N
261302	1995	200000000	10112	5209	87	0	\N
261303	1994	1400000000	10112	5209	88	0	\N
261304	1996	200000000	10112	5209	89	0	\N
261305	1997	200000000	10112	5209	90	0	\N
261306	1874	202480000	10112	5209	91	0	\N
261307	1874	202481000	10112	5209	92	0	\N
261308	1874	202482000	10112	5209	93	0	\N
261309	1874	202483000	10112	5209	94	0	\N
261310	1874	202484000	10112	5209	95	0	\N
261311	1998	200000000	10112	5209	96	0	\N
261312	1874	202485000	10112	5209	97	0	\N
261313	1999	200000000	10112	5209	98	0	\N
261314	1874	202486000	10112	5209	99	0	\N
261315	1874	202487000	10112	5209	100	0	\N
261316	1874	202488000	10112	5209	101	0	\N
261317	1874	202489000	10112	5209	102	0	\N
261318	1874	202490000	10112	5209	103	0	\N
261319	1874	202491000	10112	5209	104	0	\N
261320	1874	202492000	10112	5209	105	0	\N
261321	1874	202493000	10112	5209	106	0	\N
261322	2000	200000000	10112	5209	107	0	\N
261323	1874	202494000	10112	5209	108	0	\N
261324	1874	202495000	10112	5209	109	0	\N
261325	1874	202496000	10112	5209	110	0	\N
261326	1874	202497000	10112	5209	111	0	\N
261327	1874	202498000	10112	5209	112	0	\N
261328	1874	202499000	10112	5209	113	0	\N
261329	1874	202500000	10112	5209	115	0	\N
261330	1874	202501000	10112	5209	116	0	\N
261331	2001	200000000	10112	5209	117	0	\N
261332	1874	202502000	10112	5209	118	0	\N
261333	1874	202503000	10112	5209	119	0	\N
261334	1874	202504000	10112	5209	120	0	\N
261335	1874	202505000	10112	5209	121	0	\N
261336	1874	202506000	10112	5209	122	0	\N
261337	1874	202507000	10112	5209	123	0	\N
261338	1874	202508000	10112	5209	124	0	\N
261339	1678	9360265821000	10112	5209	125	0	\N
261351	1874	202509000	10114	5246	0	0	\N
261352	1678	9360265859000	10114	5246	1	0	\N
261353	1874	202510000	10114	5246	2	0	\N
261354	1678	9360265860000	10114	5246	3	0	\N
261355	1153	609746696000000	10114	5246	4	0	\N
261356	1033	903703406000000	10114	5246	5	0	\N
261357	1279	1699113382751650	10114	5246	6	0	\N
261358	986	504874935000000	10114	5246	7	0	\N
261359	1106	904731555000000	10114	5246	8	0	\N
261360	1226	610440410000000	10114	5246	9	0	\N
261361	1352	1701046457751650	10114	5246	10	0	\N
261380	1678	9360265864000	10118	5250	0	0	\N
261381	1874	202514000	10118	5250	1	0	\N
261382	2005	1400000000	10118	5250	2	0	\N
261383	1678	9360265864000	10119	5250	0	0	\N
261384	1874	202514000	10119	5250	1	0	\N
261385	2005	1400000000	10119	5250	2	0	\N
261389	1308	1701277837751650	10121	5251	0	0	\N
261390	1062	904855165000000	10121	5251	1	0	\N
261391	1182	610523450000000	10121	5251	2	0	\N
261392	942	504944375000000	10121	5251	3	0	\N
261342	1874	202510000	10113	5246	2	0	0
261343	1678	9360265860000	10113	5246	3	0	0
261344	1153	609746696000000	10113	5246	4	0	0
261345	1033	903703406000000	10113	5246	5	0	0
261346	1279	1699113382751650	10113	5246	6	0	0
261348	1106	904731555000000	10113	5246	8	0	0
261349	1226	610440410000000	10113	5246	9	0	0
261350	1352	1701046457751650	10113	5246	10	0	0
261362	1678	9360265861000	10115	5247	0	0	0
261363	2003	1384980654821	10115	5247	1	0	0
261365	2004	200000000	10115	5247	3	0	0
261366	2005	200000000	10115	5247	4	0	0
261367	298	66001970000000	10116	5248	0	0	5
261368	298	66002970000000	10116	5248	1	0	5
261370	2006	200000000	10116	5248	3	0	0
261371	1874	202512000	10116	5248	4	0	0
261372	1037	903966955000000	10116	5248	5	0	0
261373	1157	609924520000000	10116	5248	6	0	0
261374	917	504448265000000	10116	5248	7	0	0
261376	2007	1101625000000	10116	5248	9	0	0
261377	1651	3236050115	10117	5249	0	0	6
261378	1678	9360265863000	10117	5249	1	0	0
261379	1874	202513000	10117	5249	2	0	0
261386	1678	9360265864000	10120	5250	0	0	0
261388	2005	1400000000	10120	5250	2	0	0
261393	1678	9360265865000	10121	5251	4	0	\N
261394	1678	9360265866000	10121	5251	5	0	\N
261395	1678	9360265867000	10121	5251	6	0	\N
261396	1874	202515000	10121	5251	7	0	\N
261397	1874	202516000	10121	5251	8	0	\N
261398	1874	202517000	10121	5251	9	0	\N
261399	1678	9360265868000	10121	5251	10	0	\N
261400	1874	202518000	10121	5251	11	0	\N
261401	139	66237840350373	10121	5251	12	0	\N
261415	298	66001970000000	10123	5210	0	0	\N
261416	298	66002970000000	10123	5210	1	0	\N
261417	1308	1701277837751650	10123	5210	2	0	\N
261418	1062	904855165000000	10123	5210	3	0	\N
261419	1182	610523450000000	10123	5210	4	0	\N
261420	942	504944375000000	10123	5210	5	0	\N
261421	1678	9360265822000	10123	5210	6	0	\N
261422	1874	202509000	10123	5210	7	0	\N
261423	1678	9360265823000	10123	5210	8	0	\N
261424	1283	1699608907751650	10123	5210	9	0	\N
261425	1037	903966955000000	10123	5210	10	0	\N
261426	1157	609924520000000	10123	5210	11	0	\N
261427	917	504448265000000	10123	5210	12	0	\N
261428	1874	202510000	10123	5210	13	0	\N
261429	139	66237840350373	10123	5210	14	0	\N
261430	1153	609746696000000	10123	5210	15	0	\N
261431	1033	903703406000000	10123	5210	16	0	\N
261432	1279	1699113382751650	10123	5210	17	0	\N
261433	1678	9360265824000	10123	5210	18	0	\N
261434	1678	9360265825000	10123	5210	19	0	\N
261435	1678	9360265826000	10123	5210	20	0	\N
261436	1678	9360265827000	10123	5210	21	0	\N
261437	1678	9360265828000	10123	5210	22	0	\N
261438	1678	9360265829000	10123	5210	23	0	\N
261439	1678	9360265830000	10123	5210	24	0	\N
261440	1678	9360265831000	10123	5210	25	0	\N
261441	1678	9360265832000	10123	5210	26	0	\N
261442	1678	9360265833000	10123	5210	27	0	\N
261443	1678	9360265834000	10123	5210	28	0	\N
261444	1678	9360265835000	10123	5210	29	0	\N
261445	1678	9360265836000	10123	5210	30	0	\N
261446	1678	9360265837000	10123	5210	31	0	\N
261447	1678	9360265838000	10123	5210	32	0	\N
261448	1678	9360265839000	10123	5210	33	0	\N
261449	1678	9360265840000	10123	5210	34	0	\N
261450	1678	9360265841000	10123	5210	35	0	\N
261451	1678	9360265842000	10123	5210	36	0	\N
261452	1678	9360265843000	10123	5210	37	0	\N
261453	1678	9360265844000	10123	5210	38	0	\N
261454	2003	1032000000000	10123	5210	39	0	\N
261455	1102	906362711758531	10123	5210	40	0	\N
261456	1222	611540982176308	10123	5210	41	0	\N
261457	982	505785181543521	10123	5210	42	0	\N
261458	242	66411417920446	10123	5210	43	0	\N
261459	372	66411417920446	10123	5210	44	0	\N
261460	577	66411417920446	10123	5210	45	0	\N
261461	242	66822835840892	10123	5210	46	0	\N
261462	372	66822835840892	10123	5210	47	0	\N
261463	1281	1702736497751650	10123	5210	48	0	\N
261464	1035	905630425000000	10123	5210	49	0	\N
261465	1155	611046900000000	10123	5210	50	0	\N
261466	1678	9360265845000	10123	5210	51	0	\N
261467	1678	9360265846000	10123	5210	52	0	\N
261468	1678	9360265847000	10123	5210	53	0	\N
261469	1678	9360265848000	10123	5210	54	0	\N
261470	1678	9360265849000	10123	5210	55	0	\N
261471	1678	9360265850000	10123	5210	56	0	\N
261472	1678	9360265851000	10123	5210	57	0	\N
261473	1678	9360265852000	10123	5210	58	0	\N
261474	1678	9360265853000	10123	5210	59	0	\N
261475	1678	9360265854000	10123	5210	60	0	\N
261476	1678	9360265855000	10123	5210	61	0	\N
261477	1678	9360265856000	10123	5210	62	0	\N
261478	1678	9360265857000	10123	5210	63	0	\N
261479	1678	9360265858000	10123	5210	64	0	\N
261480	1678	9360265859000	10123	5210	65	0	\N
261481	1678	9360265860000	10123	5210	66	0	\N
261482	1678	9360265861000	10123	5210	67	0	\N
261483	1678	9360265862000	10123	5210	68	0	\N
261484	1678	9360265863000	10123	5210	69	0	\N
261485	1678	9360265864000	10123	5210	70	0	\N
261486	1678	9360265865000	10123	5210	71	0	\N
261487	1678	9360265866000	10123	5210	72	0	\N
261488	1678	9360265867000	10123	5210	73	0	\N
261489	1678	9360265868000	10123	5210	74	0	\N
261490	1678	9360265869000	10123	5210	75	0	\N
261491	1651	19840000000000	10123	5210	76	0	\N
261492	585	66335084938283	10123	5210	77	0	\N
261493	589	66335084938283	10123	5210	78	0	\N
261494	595	66335084938283	10123	5210	79	0	\N
261495	597	66335084938283	10123	5210	80	0	\N
261496	609	66335084938283	10123	5210	81	0	\N
261497	612	66335084938283	10123	5210	82	0	\N
261498	615	66335084938283	10123	5210	83	0	\N
261499	616	66335084938283	10123	5210	84	0	\N
261500	617	66335084938283	10123	5210	85	0	\N
261501	624	66335084938283	10123	5210	86	0	\N
261502	625	66335084938283	10123	5210	87	0	\N
261503	626	66335084938283	10123	5210	88	0	\N
261504	627	66335084938283	10123	5210	89	0	\N
261505	629	66335084938283	10123	5210	90	0	\N
261506	637	66335084938283	10123	5210	91	0	\N
261507	647	66335084938283	10123	5210	92	0	\N
261508	656	66335084938283	10123	5210	93	0	\N
261509	664	66335084938283	10123	5210	94	0	\N
261510	666	66335084938283	10123	5210	95	0	\N
261511	670	66335084938283	10123	5210	96	0	\N
261512	673	66335084938283	10123	5210	97	0	\N
261513	674	66335084938283	10123	5210	98	0	\N
261514	681	66335084938283	10123	5210	99	0	\N
261515	720	2010154089039	10123	5210	100	0	\N
261516	722	2010154089039	10123	5210	101	0	\N
261517	760	1005077044519	10123	5210	102	0	\N
261518	763	1005077044519	10123	5210	103	0	\N
261519	767	1005077044519	10123	5210	104	0	\N
261520	769	1005077044519	10123	5210	105	0	\N
261521	958	505385775000000	10123	5210	106	0	\N
261522	1078	905646465000000	10123	5210	107	0	\N
261523	1198	611057750000000	10123	5210	108	0	\N
261524	915	505376545000000	10123	5210	109	0	\N
261525	1874	202511000	10123	5210	110	0	\N
261526	2004	200000000	10123	5210	111	0	\N
261527	2005	200000000	10123	5210	112	0	\N
261528	2006	200000000	10123	5210	113	0	\N
261404	1182	610523450000000	10122	5251	2	0	0
261405	942	504944375000000	10122	5251	3	0	0
261406	1678	9360265865000	10122	5251	4	0	0
261407	1678	9360265866000	10122	5251	5	0	0
261408	1678	9360265867000	10122	5251	6	0	0
261410	1874	202516000	10122	5251	8	0	0
261411	1874	202517000	10122	5251	9	0	0
261412	1678	9360265868000	10122	5251	10	0	0
261413	1874	202518000	10122	5251	11	0	0
261414	139	66237840350373	10122	5251	12	0	0
261529	1874	202512000	10123	5210	115	0	\N
261530	1874	202513000	10123	5210	116	0	\N
261531	1874	202514000	10123	5210	117	0	\N
261532	2005	1400000000	10123	5210	118	0	\N
261533	1874	202515000	10123	5210	119	0	\N
261534	1874	202516000	10123	5210	120	0	\N
261535	1874	202517000	10123	5210	121	0	\N
261536	1874	202518000	10123	5210	122	0	\N
261537	1874	202519000	10123	5210	123	0	\N
261538	1363	1701353666729234	10123	5210	124	0	\N
261539	1117	904894940439233	10123	5210	125	0	\N
261542	1874	202519000	10125	5252	0	0	\N
261543	1678	9360265869000	10125	5252	1	0	\N
261544	1874	202519000	10126	5252	0	0	\N
261545	1678	9360265869000	10126	5252	1	0	\N
261550	1678	9360265871000	10128	5254	0	0	\N
261551	1874	202521000	10129	5254	0	0	\N
261552	1678	9360265871000	10129	5254	1	0	\N
261555	1713	660000000	10131	5255	0	0	\N
261556	814	5519833243318203	10131	5255	1	0	\N
261557	1678	9360265872000	10131	5255	2	0	\N
261558	1713	660000000	10132	5255	0	0	\N
261559	1874	202522000	10132	5255	1	0	\N
261560	814	5519833243318203	10132	5255	2	0	\N
261561	1678	9360265872000	10132	5255	3	0	\N
261575	1768	15997411110000	10137	5028	0	0	\N
261576	941	505469525000000	10137	5028	1	0	\N
261577	1330	1700410637751650	10137	5028	2	0	\N
261578	1768	17997411110000	10137	5028	3	0	\N
261579	298	66001970000000	10137	5028	4	0	\N
261580	298	66002970000000	10137	5028	5	0	\N
261581	1308	1701277837751650	10137	5028	6	0	\N
261582	1181	611158820000000	10137	5028	7	0	\N
261583	1762	14932310000000	10137	5028	8	0	\N
261584	1061	905796315000000	10137	5028	9	0	\N
261585	1062	904855165000000	10137	5028	10	0	\N
261586	1204	610212750000000	10137	5028	11	0	\N
261587	1084	904393465000000	10137	5028	12	0	\N
261588	964	504686775000000	10137	5028	13	0	\N
261589	1283	1699608907751650	10137	5028	14	0	\N
261590	1090	906305713000000	10137	5028	15	0	\N
261591	1348	1704113322026672	10137	5028	16	0	\N
261592	1316	1693980737751650	10137	5028	17	0	\N
261593	482	66000010000000	10137	5028	18	0	\N
261594	913	502777775001523	10137	5028	19	0	\N
261595	913	504301187001523	10137	5028	20	0	\N
261596	199	66263082769232	10137	5028	21	0	\N
261597	214	66263082769232	10137	5028	23	0	\N
261598	1037	903966955000000	10137	5028	24	0	\N
261599	1157	609924520000000	10137	5028	25	0	\N
261600	22	22439350095941	10137	5028	26	0	\N
261601	190	66335084938283	10137	5028	27	0	\N
261602	258	66335084938283	10137	5028	28	0	\N
261603	273	66335084938283	10137	5028	29	0	\N
261604	149	67598767000341	10137	5028	30	0	\N
261605	1148	609963489000000	10137	5028	31	0	\N
261606	1651	10486000000000	10137	5028	32	0	\N
261607	970	505753031000000	10137	5028	33	0	\N
261608	1336	1704004549751650	10137	5028	34	0	\N
261609	149	67939917000341	10137	5028	35	0	\N
261610	234	66263082769232	10137	5028	36	0	\N
261611	282	66263082769232	10137	5028	37	0	\N
261612	1210	611502734000000	10137	5028	38	0	\N
261613	314	66263082769232	10137	5028	39	0	\N
261614	323	66263082769232	10137	5028	40	0	\N
261615	330	66263082769232	10137	5028	41	0	\N
261616	332	66263082769232	10137	5028	42	0	\N
261617	334	66263082769232	10137	5028	43	0	\N
261618	343	66263082769232	10137	5028	44	0	\N
261619	139	66237840350373	10137	5028	45	0	\N
261620	813	501803460057033	10137	5028	46	0	\N
261621	814	5519833243318203	10137	5028	47	0	\N
261622	292	66335084938283	10137	5028	48	0	\N
261623	293	66335084938283	10137	5028	49	0	\N
261624	333	66335084938283	10137	5028	50	0	\N
261625	376	66335084938283	10137	5028	51	0	\N
261626	426	66335084938283	10137	5028	52	0	\N
261627	429	66335084938283	10137	5028	53	0	\N
261628	430	66335084938283	10137	5028	54	0	\N
261629	440	66335084938283	10137	5028	55	0	\N
261630	474	66335084938283	10137	5028	56	0	\N
261631	475	66335084938283	10137	5028	57	0	\N
261632	476	66335084938283	10137	5028	58	0	\N
261633	483	66335084938283	10137	5028	59	0	\N
261634	486	66335084938283	10137	5028	60	0	\N
261635	490	66335084938283	10137	5028	61	0	\N
261636	496	66335084938283	10137	5028	62	0	\N
261637	511	66335084938283	10137	5028	63	0	\N
261638	512	66335084938283	10137	5028	64	0	\N
261639	522	66335084938283	10137	5028	65	0	\N
261640	523	66335084938283	10137	5028	66	0	\N
261641	533	66335084938283	10137	5028	67	0	\N
261642	539	66335084938283	10137	5028	68	0	\N
261643	541	66335084938283	10137	5028	69	0	\N
261644	558	66335084938283	10137	5028	70	0	\N
261645	565	66335084938283	10137	5028	71	0	\N
261646	572	66335084938283	10137	5028	72	0	\N
261647	573	66335084938283	10137	5028	73	0	\N
261648	576	84335674938283	10137	5028	74	0	\N
261649	584	66335084938283	10137	5028	75	0	\N
261650	1153	609746696000000	10137	5028	76	0	\N
261651	1033	903703406000000	10137	5028	77	0	\N
261652	1279	1699113382751650	10137	5028	78	0	\N
261653	559	66263082769232	10137	5028	79	0	\N
261654	2003	1032000000000	10137	5028	80	0	\N
261655	1102	906362711758531	10137	5028	81	0	\N
261656	1222	611540982176308	10137	5028	82	0	\N
261657	982	505785181543521	10137	5028	83	0	\N
261658	242	66411417920446	10137	5028	84	0	\N
261659	372	66411417920446	10137	5028	85	0	\N
261660	577	66411417920446	10137	5028	86	0	\N
261661	242	66822835840892	10137	5028	87	0	\N
261662	372	66822835840892	10137	5028	88	0	\N
261663	1281	1702736497751650	10137	5028	89	0	\N
261664	1035	905630425000000	10137	5028	90	0	\N
261546	813	501803460057033	10127	5253	0	0	0
261547	1874	202520000	10127	5253	1	0	0
261548	1678	9360265870000	10127	5253	2	0	0
261549	2008	200000000	10127	5253	3	0	0
261553	1874	202521000	10130	5254	0	0	0
261562	1713	660000000	10133	5255	0	0	0
261563	1874	202522000	10133	5255	1	0	0
261564	814	5519833243318203	10133	5255	2	0	0
261565	941	505469525000000	10134	5256	0	0	0
261566	1874	202523000	10134	5256	1	0	0
261568	1678	9360265872000	10134	5256	3	0	0
261569	1678	9360265873000	10134	5256	4	0	0
261570	1678	9360265874000	10134	5256	5	0	0
261571	1181	611158820000000	10136	5257	0	0	0
261573	1307	1703048397751650	10136	5257	2	0	0
261574	1874	202525000	10136	5257	3	0	0
261665	1155	611046900000000	10137	5028	91	0	\N
261666	1123	903915465000000	10137	5028	92	0	\N
261667	1243	609889750000000	10137	5028	93	0	\N
261668	1369	1699510637751650	10137	5028	94	0	\N
261669	1989	860340000000	10137	5028	95	0	\N
261670	561	66263082769232	10137	5028	96	0	\N
261671	104	66263082769232	10137	5028	97	0	\N
261672	1159	611047750000000	10137	5028	98	0	\N
261673	1678	8640245581000	10137	5028	99	0	\N
261674	1678	8640245582000	10137	5028	100	0	\N
261675	1678	8640245583000	10137	5028	101	0	\N
261676	1651	19840000000000	10137	5028	102	0	\N
261677	585	66335084938283	10137	5028	103	0	\N
261678	589	66335084938283	10137	5028	104	0	\N
261679	595	66335084938283	10137	5028	105	0	\N
261680	597	66335084938283	10137	5028	106	0	\N
261681	609	66335084938283	10137	5028	107	0	\N
261682	612	66335084938283	10137	5028	108	0	\N
261683	615	66335084938283	10137	5028	109	0	\N
261684	616	66335084938283	10137	5028	110	0	\N
261685	617	66335084938283	10137	5028	111	0	\N
261686	624	66335084938283	10137	5028	112	0	\N
261687	625	66335084938283	10137	5028	113	0	\N
261688	626	66335084938283	10137	5028	114	0	\N
261689	627	66335084938283	10137	5028	115	0	\N
261690	629	66335084938283	10137	5028	116	0	\N
261691	637	66335084938283	10137	5028	117	0	\N
261692	647	66335084938283	10137	5028	118	0	\N
261693	656	66335084938283	10137	5028	119	0	\N
261694	664	66335084938283	10137	5028	120	0	\N
261695	666	66335084938283	10137	5028	121	0	\N
261696	670	66335084938283	10137	5028	122	0	\N
261697	673	66335084938283	10137	5028	123	0	\N
261698	674	66335084938283	10137	5028	124	0	\N
261699	681	66335084938283	10137	5028	125	0	\N
261700	941	505469525000000	10138	5256	0	0	\N
261701	1874	202523000	10138	5256	1	0	\N
261702	1874	202524000	10138	5256	2	0	\N
261703	1678	9360265872000	10138	5256	3	0	\N
261704	1678	9360265873000	10138	5256	4	0	\N
261705	1678	9360265874000	10138	5256	5	0	\N
261706	1181	611158820000000	10139	5257	0	0	\N
261707	1061	905796315000000	10139	5257	1	0	\N
261708	1307	1703048397751650	10139	5257	2	0	\N
261709	1874	202525000	10139	5257	3	0	\N
261710	498	66001500000000	10140	5029	0	0	\N
261711	596	83898262000000	10140	5029	2	0	\N
261712	940	505057775000000	10140	5029	3	0	\N
261713	1060	905058465000000	10140	5029	4	0	\N
261714	1180	610661750000000	10140	5029	5	0	\N
261715	1306	1701661637751650	10140	5029	6	0	\N
261716	908	504480415000000	10140	5029	7	0	\N
261717	914	504783747659856	10140	5029	8	0	\N
261718	1034	904568150819296	10140	5029	9	0	\N
261719	1154	610330156151454	10140	5029	10	0	\N
261720	1280	1700739247647754	10140	5029	11	0	\N
261721	1338	1699817637751650	10140	5029	12	0	\N
261722	1092	904078465000000	10140	5029	13	0	\N
261723	1212	609999750000000	10140	5029	14	0	\N
261724	972	504872775000000	10140	5029	15	0	\N
261725	588	66003000000000	10140	5029	16	0	\N
261726	1678	8640245554000	10140	5029	17	0	\N
261727	1939	1435990000000	10140	5029	18	0	\N
261728	207	66001110000000	10140	5029	19	0	\N
261729	1365	1703504133514363	10140	5029	20	0	\N
261739	1678	9360265879000	10144	5260	0	0	\N
261740	1874	202530000	10144	5260	1	0	\N
261743	1678	9360265879000	10146	5260	0	0	\N
261744	1874	202530000	10146	5260	1	0	\N
261745	1874	202531000	10147	5261	0	0	\N
261746	1678	9360265880000	10147	5261	1	0	\N
261747	1874	202531000	10148	5261	0	0	\N
261748	1678	9360265880000	10148	5261	1	0	\N
261749	1874	202531000	10149	5261	0	0	\N
261750	1678	9360265880000	10149	5261	1	0	\N
261753	1678	9360265881000	10151	5262	0	0	\N
261754	1874	202532000	10151	5262	1	0	\N
261759	1678	9360265882000	10154	5263	0	0	\N
261760	1874	202533000	10154	5263	1	0	\N
261761	1874	202534000	10155	5264	0	0	\N
261762	1678	9360265883000	10155	5264	1	0	\N
261763	1678	9360265884000	10155	5264	2	0	\N
261764	1874	202535000	10155	5264	3	0	\N
261769	1874	202536000	10157	5265	0	0	\N
261770	1678	9360265885000	10157	5265	1	0	\N
261773	1874	202536000	10159	5265	0	0	\N
261774	1678	9360265885000	10159	5265	1	0	\N
261775	1874	202536000	10160	5265	0	0	\N
261776	1678	9360265885000	10160	5265	1	0	\N
261779	1678	9360265886000	10162	5266	0	0	\N
261780	1874	202537000	10162	5266	1	0	\N
261781	1008	504732913409273	10163	5267	0	0	\N
261782	1874	202538000	10163	5267	1	0	\N
261783	1678	9360265887000	10163	5267	2	0	\N
261784	1128	904477056277789	10163	5267	3	0	\N
261785	148	66155970757207	10163	5267	4	0	\N
261786	1248	610268692849109	10163	5267	5	0	\N
261787	714	2004726386573	10163	5267	6	0	\N
261788	994	503962494255265	10163	5267	7	0	\N
261789	1114	903096471754765	10163	5267	8	0	\N
261790	1234	609337184961334	10163	5267	9	0	\N
261791	1360	1697972245136441	10163	5267	10	0	\N
261792	1374	1700567974690791	10163	5267	11	0	\N
261732	1779	1000000000	10142	5258	2	0	1
261733	1678	9360265876000	10143	5259	0	0	0
261734	1678	9360265877000	10143	5259	1	0	0
261735	1678	9360265878000	10143	5259	2	0	0
261736	1874	202527000	10143	5259	3	0	0
261738	1874	202529000	10143	5259	5	0	0
261741	1678	9360265879000	10145	5260	0	0	0
261742	1874	202530000	10145	5260	1	0	0
261751	1874	202531000	10150	5261	0	0	0
261752	1678	9360265880000	10150	5261	1	0	0
261756	1874	202532000	10152	5262	1	0	0
261757	1678	9360265882000	10153	5263	0	0	0
261758	1874	202533000	10153	5263	1	0	0
261765	1874	202534000	10156	5264	0	0	0
261767	1678	9360265884000	10156	5264	2	0	0
261768	1874	202535000	10156	5264	3	0	0
261771	1874	202536000	10158	5265	0	0	0
261772	1678	9360265885000	10158	5265	1	0	0
261777	1678	9360265886000	10161	5266	0	0	0
261793	1008	504732913409273	10164	5267	0	0	0
261794	1874	202538000	10164	5267	1	0	0
261795	1678	9360265887000	10164	5267	2	0	0
261796	1128	904477056277789	10164	5267	3	0	0
261797	148	66155970757207	10164	5267	4	0	0
261799	714	2004726386573	10164	5267	6	0	0
261800	994	503962494255265	10164	5267	7	0	0
261807	1874	202540000	10166	5269	0	0	\N
261808	1678	9360265889000	10166	5269	1	0	\N
261809	1874	202540000	10167	5269	0	0	\N
261810	1678	9360265889000	10167	5269	1	0	\N
261813	1874	202540000	10169	5269	0	0	\N
261814	1678	9360265889000	10169	5269	1	0	\N
261815	1874	202540000	10170	5269	0	0	\N
261816	1678	9360265889000	10170	5269	1	0	\N
261817	1678	10080285890000	10171	5270	0	0	\N
261818	1874	202541000	10171	5270	1	0	\N
261841	1678	10080285893000	10176	5273	0	0	\N
261842	1874	202544000	10176	5273	1	0	\N
261843	1874	202545000	10178	5275	0	0	\N
261844	1874	202546000	10178	5275	1	0	\N
261845	1678	10080285894000	10178	5275	2	0	\N
261846	1678	10080285895000	10178	5275	3	0	\N
261847	1874	202545000	10179	5275	0	0	\N
261848	1874	202546000	10179	5275	1	0	\N
261849	1678	10080285894000	10179	5275	2	0	\N
261850	1678	10080285895000	10179	5275	3	0	\N
261851	1874	202545000	10180	5275	0	0	\N
261852	1874	202546000	10180	5275	1	0	\N
261853	1678	10080285894000	10180	5275	2	0	\N
261854	1678	10080285895000	10180	5275	3	0	\N
261859	1874	202545000	10182	5275	0	0	\N
261860	1874	202546000	10182	5275	1	0	\N
261861	1678	10080285894000	10182	5275	2	0	\N
261862	1678	10080285895000	10182	5275	3	0	\N
261863	1874	202545000	10183	5275	0	0	\N
261864	1874	202546000	10183	5275	1	0	\N
261865	1678	10080285894000	10183	5275	2	0	\N
261866	1678	10080285895000	10183	5275	3	0	\N
261867	1874	202545000	10184	5275	0	0	\N
261868	1874	202546000	10184	5275	1	0	\N
261869	1678	10080285894000	10184	5275	2	0	\N
261870	1678	10080285896000	10185	5276	0	0	\N
261871	1874	202547000	10185	5276	1	0	\N
261874	1678	10080285896000	10187	5276	0	0	\N
261875	1874	202547000	10187	5276	1	0	\N
261876	1874	202548000	10188	5277	0	0	\N
261877	1874	202549000	10188	5277	1	0	\N
261878	2010	200000000	10188	5277	2	0	\N
261879	1678	10080285897000	10188	5277	3	0	\N
261880	1678	10080285898000	10188	5277	4	0	\N
261881	1874	202548000	10189	5277	0	0	\N
261882	1874	202549000	10189	5277	1	0	\N
261883	2010	200000000	10189	5277	2	0	\N
261884	1678	10080285897000	10189	5277	3	0	\N
261885	1678	10080285898000	10189	5277	4	0	\N
261891	412	66000000000000	10191	5278	0	0	\N
261892	1874	202550000	10191	5278	1	0	\N
261893	1874	202551000	10191	5278	2	0	\N
261894	1678	10080285899000	10191	5278	3	0	\N
261895	1874	202552000	10191	5278	4	0	\N
261896	1678	10080285900000	10191	5278	5	0	\N
261897	1678	10080285901000	10191	5278	6	0	\N
261909	1678	10080285902000	10194	5279	0	0	\N
261910	1678	10080285903000	10194	5279	1	0	\N
261911	1874	202553000	10194	5279	2	0	\N
261912	1874	202554000	10194	5279	3	0	\N
261913	1678	10080285902000	10195	5279	0	0	\N
261914	1678	10080285903000	10195	5279	1	0	\N
261915	1874	202553000	10195	5279	2	0	\N
261916	1874	202554000	10195	5279	3	0	\N
261917	1874	202555000	10196	5280	0	0	\N
261918	1678	10080285904000	10196	5280	1	0	\N
261921	1874	202555000	10198	5280	0	0	\N
261922	1678	10080285904000	10198	5280	1	0	\N
261927	1874	202558000	10201	5283	0	0	\N
261928	1678	10080285907000	10201	5283	1	0	\N
261933	1874	202559000	10204	5284	0	0	\N
261934	1678	10080285908000	10204	5284	1	0	\N
261803	1360	1697972245136441	10164	5267	10	0	0
261804	1374	1700567974690791	10164	5267	11	0	0
261805	1678	9360265888000	10165	5268	0	0	0
261806	1874	202539000	10165	5268	1	0	0
261811	1874	202540000	10168	5269	0	0	0
261819	1678	10080285890000	10172	5270	0	0	0
261820	1874	202541000	10173	5271	0	0	0
261821	1678	10080285891000	10173	5271	1	0	0
261822	1874	202542000	10173	5271	2	0	0
261823	135	66468147446254	10173	5271	3	0	0
261825	202	66468147446254	10173	5271	5	0	0
261826	264	66468147446254	10173	5271	6	0	0
261827	279	66468147446254	10173	5271	7	0	0
261828	331	66468147446254	10173	5271	8	0	0
261830	388	66468147446254	10173	5271	10	0	0
261831	400	66468147446254	10173	5271	11	0	0
261832	505	66468147446254	10173	5271	12	0	0
261833	925	506165070182596	10173	5271	13	0	0
261834	1045	907043468944920	10173	5271	14	0	0
261836	1291	1705393259269599	10173	5271	16	0	0
261837	1678	10080285892000	10174	5272	0	0	0
261838	1874	202543000	10174	5272	1	0	0
261839	1678	10080285893000	10175	5273	0	0	0
261840	1874	202544000	10175	5273	1	0	0
261856	1874	202546000	10181	5275	1	0	0
261857	1678	10080285894000	10181	5275	2	0	0
261858	1678	10080285895000	10181	5275	3	0	0
261872	1678	10080285896000	10186	5276	0	0	0
261886	1874	202548000	10190	5277	0	0	0
261887	1874	202549000	10190	5277	1	0	0
261888	2010	200000000	10190	5277	2	0	0
261889	1678	10080285897000	10190	5277	3	0	0
261890	1678	10080285898000	10190	5277	4	0	0
261899	1874	202550000	10192	5278	1	0	0
261900	1874	202551000	10192	5278	2	0	0
261901	1678	10080285899000	10192	5278	3	0	0
261902	1874	202552000	10192	5278	4	0	0
261903	1678	10080285900000	10192	5278	5	0	0
261905	1678	10080285902000	10193	5279	0	0	0
261906	1678	10080285903000	10193	5279	1	0	0
261907	1874	202553000	10193	5279	2	0	0
261908	1874	202554000	10193	5279	3	0	0
261920	1678	10080285904000	10197	5280	1	0	0
261923	1678	10080285905000	10199	5281	0	0	0
261924	1874	202556000	10199	5281	1	0	0
261925	1678	10080285906000	10200	5282	0	0	0
261926	1874	202557000	10200	5282	1	0	0
261930	1678	10080285907000	10202	5283	1	0	0
261931	1874	202559000	10203	5284	0	0	0
261932	1678	10080285908000	10203	5284	1	0	0
261935	1678	10080285909000	10205	5285	0	0	0
261936	1874	202560000	10205	5285	1	0	0
261937	1678	10080285909000	10206	5285	0	0	\N
261938	1874	202560000	10206	5285	1	0	\N
261941	1678	10080285910000	10208	5286	0	0	\N
261942	1874	202561000	10208	5286	1	0	\N
261943	1874	202562000	10209	5287	0	0	\N
261944	1678	10080285911000	10209	5287	1	0	\N
261945	2010	1400000000	10209	5287	2	0	\N
261949	1874	202563000	10212	5288	0	0	\N
261950	1874	202564000	10212	5288	1	0	\N
261951	1874	202565000	10212	5288	2	0	\N
261952	1678	10080285912000	10212	5288	3	0	\N
261953	1678	10080285913000	10212	5288	4	0	\N
261954	1678	10080285914000	10212	5288	5	0	\N
261961	1874	202563000	10214	5288	0	0	\N
261962	1874	202564000	10214	5288	1	0	\N
261963	1874	202565000	10214	5288	2	0	\N
261964	1678	10080285912000	10214	5288	3	0	\N
261965	1678	10080285913000	10214	5288	4	0	\N
261966	1678	10080285914000	10214	5288	5	0	\N
261969	1874	202566000	10216	5289	0	0	\N
261970	1678	10080285915000	10216	5289	1	0	\N
261977	1678	10080285918000	10220	5291	0	0	\N
261978	1874	202569000	10220	5291	1	0	\N
261979	1678	10080285918000	10221	5291	0	0	\N
261980	1874	202569000	10221	5291	1	0	\N
261981	412	66000000000000	10223	5029	0	0	\N
261982	1008	504732913409273	10223	5029	1	0	\N
261983	1128	904477056277789	10223	5029	2	0	\N
261984	148	66155970757207	10223	5029	3	0	\N
261985	1248	610268692849109	10223	5029	4	0	\N
261986	714	2004726386573	10223	5029	5	0	\N
261987	994	503962494255265	10223	5029	6	0	\N
261988	1114	903096471754765	10223	5029	7	0	\N
261989	720	2010154089039	10223	5029	8	0	\N
261990	722	2010154089039	10223	5029	9	0	\N
261991	1234	609337184961334	10223	5029	10	0	\N
261992	1360	1697972245136441	10223	5029	11	0	\N
261993	1374	1700567974690791	10223	5029	12	0	\N
261994	760	1005077044519	10223	5029	13	0	\N
261995	763	1005077044519	10223	5029	14	0	\N
261996	767	1005077044519	10223	5029	15	0	\N
261997	769	1005077044519	10223	5029	16	0	\N
261998	958	505385775000000	10223	5029	17	0	\N
261999	1678	8640245584000	10223	5029	18	0	\N
262000	1678	8640245585000	10223	5029	19	0	\N
262001	1678	8640245586000	10223	5029	20	0	\N
262002	1678	8640245587000	10223	5029	21	0	\N
262003	1678	8640245588000	10223	5029	23	0	\N
262004	1678	8640245589000	10223	5029	24	0	\N
262005	1678	8640245590000	10223	5029	25	0	\N
262006	1678	8640245591000	10223	5029	26	0	\N
262007	1678	8640245592000	10223	5029	27	0	\N
262008	1678	8640245593000	10223	5029	28	0	\N
262009	1678	8640245594000	10223	5029	29	0	\N
262010	1678	8640245595000	10223	5029	30	0	\N
262011	1678	8640245596000	10223	5029	31	0	\N
262012	1678	8640245597000	10223	5029	32	0	\N
262013	1678	8640245598000	10223	5029	33	0	\N
262014	1678	8640245599000	10223	5029	34	0	\N
262015	1678	8640245600000	10223	5029	35	0	\N
262016	1678	8640245601000	10223	5029	36	0	\N
262017	1678	8640245602000	10223	5029	37	0	\N
262018	1678	8640245603000	10223	5029	38	0	\N
262019	1678	8640245604000	10223	5029	39	0	\N
262020	1678	8640245605000	10223	5029	40	0	\N
262021	1678	8640245606000	10223	5029	41	0	\N
262022	1678	8640245607000	10223	5029	42	0	\N
262023	1678	8640245608000	10223	5029	43	0	\N
262024	1678	8640245609000	10223	5029	44	0	\N
262025	1678	8640245610000	10223	5029	45	0	\N
262026	1678	8640245611000	10223	5029	46	0	\N
262027	1678	8640245612000	10223	5029	47	0	\N
262028	1678	8640245613000	10223	5029	48	0	\N
262029	1678	8640245614000	10223	5029	49	0	\N
262030	1678	8640245615000	10223	5029	50	0	\N
262031	1678	8640245616000	10223	5029	51	0	\N
262032	1678	8640245617000	10223	5029	52	0	\N
262033	1678	8640245618000	10223	5029	53	0	\N
262034	1678	8640245619000	10223	5029	54	0	\N
262035	1678	8640245620000	10223	5029	55	0	\N
262036	1678	8640245621000	10223	5029	56	0	\N
262037	1678	8640245622000	10223	5029	57	0	\N
262038	1678	8640245623000	10223	5029	58	0	\N
262039	1678	8640245624000	10223	5029	59	0	\N
262040	1678	8640245625000	10223	5029	60	0	\N
262041	1874	202570000	10224	5292	0	0	\N
262042	1874	202571000	10224	5292	1	0	\N
262043	1874	202572000	10224	5292	2	0	\N
262044	1678	10080285919000	10224	5292	3	0	\N
262045	1678	10080285920000	10224	5292	4	0	\N
262046	1678	10080285921000	10224	5292	5	0	\N
262056	1874	202574000	10227	5293	0	0	\N
262057	1874	202574000	10228	5293	0	0	\N
262062	498	66001500000000	10230	5007	0	0	\N
262063	1768	15997411110000	10230	5007	2	0	\N
262064	941	505469525000000	10230	5007	3	0	\N
262065	1330	1700410637751650	10230	5007	4	0	\N
262066	1768	17997411110000	10230	5007	5	0	\N
262067	908	504480415000000	10230	5007	6	0	\N
262068	298	66001970000000	10230	5007	7	0	\N
262069	298	66002970000000	10230	5007	8	0	\N
262070	1308	1701277837751650	10230	5007	9	0	\N
262071	412	66000000000000	10230	5007	10	0	\N
262072	1181	611158820000000	10230	5007	11	0	\N
261946	1874	202562000	10210	5287	0	0	0
261947	1678	10080285911000	10210	5287	1	0	0
261948	2010	1400000000	10210	5287	2	0	0
261955	1874	202563000	10213	5288	0	0	0
261956	1874	202564000	10213	5288	1	0	0
261958	1678	10080285912000	10213	5288	3	0	0
261959	1678	10080285913000	10213	5288	4	0	0
261960	1678	10080285914000	10213	5288	5	0	0
261967	1874	202566000	10215	5289	0	0	0
261968	1678	10080285915000	10215	5289	1	0	0
261972	1874	202567000	10218	5290	1	0	0
261973	1874	202568000	10218	5290	2	0	0
261974	1678	10080285917000	10218	5290	3	0	0
261975	1678	10080285918000	10219	5291	0	0	0
262047	1874	202570000	10225	5292	0	0	0
262048	1874	202571000	10225	5292	1	0	0
262049	1874	202572000	10225	5292	2	0	0
262050	1874	202573000	10225	5292	3	0	0
262051	1678	10080285919000	10225	5292	4	0	0
262053	1678	10080285921000	10225	5292	6	0	0
262054	1678	10080285922000	10225	5292	7	0	0
262055	1874	202574000	10226	5293	0	0	0
262058	1678	10080285923000	10229	5294	0	0	0
262059	1678	10080285924000	10229	5294	1	0	0
262061	1874	202576000	10229	5294	3	0	0
262073	1762	14932310000000	10230	5007	12	0	\N
262074	1061	905796315000000	10230	5007	13	0	\N
262075	914	504783747659856	10230	5007	14	0	\N
262076	1034	904568150819296	10230	5007	16	0	\N
262077	1154	610330156151454	10230	5007	17	0	\N
262078	1280	1700739247647754	10230	5007	18	0	\N
262079	1062	904855165000000	10230	5007	19	0	\N
262080	1204	610212750000000	10230	5007	20	0	\N
262081	1084	904393465000000	10230	5007	21	0	\N
262082	1981	101000000000	10230	5007	22	0	\N
262083	940	505057775000000	10230	5007	23	0	\N
262084	1060	905058465000000	10230	5007	24	0	\N
262085	1180	610661750000000	10230	5007	25	0	\N
262086	1306	1701661637751650	10230	5007	26	0	\N
262087	964	504686775000000	10230	5007	27	0	\N
262088	1338	1699817637751650	10230	5007	28	0	\N
262089	1092	904078465000000	10230	5007	29	0	\N
262090	1212	609999750000000	10230	5007	30	0	\N
262091	972	504872775000000	10230	5007	31	0	\N
262092	588	66003000000000	10230	5007	32	0	\N
262093	1939	1435990000000	10230	5007	33	0	\N
262094	207	66001110000000	10230	5007	34	0	\N
262095	1365	1703504133514363	10230	5007	35	0	\N
262096	1987	1000000000	10230	5007	36	0	\N
262097	976	505005775000000	10230	5007	37	0	\N
262098	1096	904965465000000	10230	5007	38	0	\N
262099	1874	202217000	10230	5007	39	0	\N
262100	1371	1701968637751650	10230	5007	40	0	\N
262101	1898	30000000	10230	5007	41	0	\N
262102	1682	11441000000	10230	5007	42	0	\N
262103	919	505376775000000	10230	5007	43	0	\N
262104	1039	905630465000000	10230	5007	44	0	\N
262105	1028	904024575000000	10230	5007	45	0	\N
262106	531	66407503985720	10230	5007	46	0	\N
262107	1381	1702275295351650	10230	5007	47	0	\N
262108	1148	609963390000000	10230	5007	48	0	\N
262109	1125	905222465000000	10230	5007	49	0	\N
262110	1245	610771750000000	10230	5007	50	0	\N
262111	1005	505148775000000	10230	5007	51	0	\N
262112	1678	8640245526000	10230	5007	52	0	\N
262113	1678	8640245527000	10230	5007	53	0	\N
262114	1283	1699608907751650	10230	5007	54	0	\N
262115	1898	40000000	10230	5007	55	0	\N
262116	1898	50000000	10230	5007	56	0	\N
262117	956	504783775000000	10230	5007	57	0	\N
262118	1076	904568465000000	10230	5007	58	0	\N
262119	1090	906305713000000	10230	5007	59	0	\N
262120	939	504690032035010	10230	5007	60	0	\N
262121	764	1000010000000	10230	5007	61	0	\N
262122	1309	1702273637751650	10230	5007	62	0	\N
262123	1348	1704113322026672	10230	5007	63	0	\N
262124	260	66311200000000	10230	5007	64	0	\N
262125	1980	1000000000	10230	5007	65	0	\N
262126	1980	7198000000000	10230	5007	66	0	\N
262127	1295	1701047467188501	10230	5007	67	0	\N
262128	1063	905384465000000	10230	5007	68	0	\N
262129	1776	275574970106	10230	5007	69	0	\N
262130	1776	317177389610	10230	5007	70	0	\N
262131	931	504869452205387	10230	5007	71	0	\N
262132	482	66000010000000	10230	5007	72	0	\N
262133	913	502777775001523	10230	5007	73	0	\N
262134	913	504301187001523	10230	5007	74	0	\N
262135	1183	610880750000000	10230	5007	75	0	\N
262142	2011	899000000000	10232	5296	0	0	\N
262143	1678	10080285928000	10232	5296	1	0	\N
262144	1874	202580000	10232	5296	2	0	\N
262148	2011	899000000000	10234	5296	0	0	\N
262149	1678	10080285928000	10234	5296	1	0	\N
262150	1874	202580000	10234	5296	2	0	\N
262151	2011	899000000000	10235	5296	0	0	\N
262152	1678	10080285928000	10235	5296	1	0	\N
262153	1874	202580000	10235	5296	2	0	\N
262156	2011	899000000000	10238	5294	0	0	\N
262157	1678	10080285923000	10238	5294	1	0	\N
262158	1678	10080285924000	10238	5294	2	0	\N
262159	1678	10080285925000	10238	5294	3	0	\N
262160	1678	10080285926000	10238	5294	4	0	\N
262161	1678	10080285927000	10238	5294	5	0	\N
262162	1678	10080285928000	10238	5294	6	0	\N
262163	1678	10080285929000	10238	5294	7	0	\N
262164	1874	202575000	10238	5294	8	0	\N
262165	1874	202576000	10238	5294	9	0	\N
262166	1874	202577000	10238	5294	10	0	\N
262167	1874	202578000	10238	5294	11	0	\N
262168	1874	202579000	10238	5294	12	0	\N
262169	1874	202580000	10238	5294	13	0	\N
262170	1874	202582000	10239	5298	0	0	\N
262171	1678	10080285930000	10239	5298	1	0	\N
262178	1678	10080285931000	10245	5299	0	0	\N
262179	1678	10080285932000	10245	5299	1	0	\N
262180	1874	202583000	10245	5299	2	0	\N
262181	1874	202584000	10245	5299	3	0	\N
262192	2011	899000000000	10250	5176	0	0	\N
262193	1768	15997411110000	10250	5176	1	0	\N
262194	941	505469525000000	10250	5176	2	0	\N
262195	1330	1700410637751650	10250	5176	3	0	\N
262196	1768	17997411110000	10250	5176	4	0	\N
262197	298	66001970000000	10250	5176	5	0	\N
262198	298	66002970000000	10250	5176	6	0	\N
262199	1308	1701277837751650	10250	5176	7	0	\N
262200	412	66000000000000	10250	5176	8	0	\N
262201	1181	611158820000000	10250	5176	9	0	\N
262202	1762	15652470000000	10250	5176	10	0	\N
262203	1061	905796315000000	10250	5176	11	0	\N
262204	1062	904855165000000	10250	5176	12	0	\N
262205	1204	610212750000000	10250	5176	13	0	\N
262206	1084	904393465000000	10250	5176	14	0	\N
262207	964	504686775000000	10250	5176	15	0	\N
262208	1008	504732913409273	10250	5176	16	0	\N
262138	1678	10080285927000	10231	5295	2	0	0
262139	1874	202577000	10231	5295	3	0	0
262140	1874	202578000	10231	5295	4	0	0
262141	1874	202579000	10231	5295	5	0	0
262145	2011	899000000000	10233	5296	0	0	0
262147	1874	202580000	10233	5296	2	0	0
262154	1678	10080285929000	10237	5297	0	0	0
262155	1874	202581000	10237	5297	1	0	0
262172	1874	202582000	10240	5298	0	0	0
262173	1678	10080285930000	10240	5298	1	0	0
262175	1678	10080285932000	10242	5299	1	0	0
262176	1874	202583000	10242	5299	2	0	0
262177	1874	202584000	10242	5299	3	0	0
262182	1678	10080285933000	10247	5300	0	0	0
262184	1874	202586000	10248	5301	0	0	0
262185	1874	202587000	10248	5301	1	0	0
262186	1874	202588000	10248	5301	2	0	0
262187	1678	10080285934000	10248	5301	3	0	0
262188	1678	10080285935000	10248	5301	4	0	0
262190	1678	10080285937000	10249	5302	0	0	0
262191	1874	202589000	10249	5302	1	0	0
262209	2003	4268367953	10250	5176	17	0	\N
262210	1283	1699608907751650	10250	5176	18	0	\N
262211	2003	351980654821	10250	5176	19	0	\N
262212	1348	1704113322026672	10250	5176	20	0	\N
262213	1316	1693980737751650	10250	5176	21	0	\N
262214	482	66000010000000	10250	5176	22	0	\N
262215	913	502777775001523	10250	5176	23	0	\N
262216	913	504301187001523	10250	5176	24	0	\N
262217	1301	1702887352934139	10250	5176	25	0	\N
262218	1037	903966955000000	10250	5176	26	0	\N
262219	1157	609924520000000	10250	5176	27	0	\N
262245	1678	10080285946000	10254	5305	0	0	\N
262246	1874	202598000	10254	5305	1	0	\N
262256	2013	200000000	10259	5307	0	0	\N
262257	1678	10080285948000	10259	5307	1	0	\N
262258	1678	10080285949000	10259	5307	2	0	\N
262259	1874	202600000	10259	5307	3	0	\N
262260	1874	202601000	10259	5307	4	0	\N
262261	2013	200000000	10260	5307	0	0	\N
262262	1678	10080285948000	10260	5307	1	0	\N
262263	1678	10080285949000	10260	5307	2	0	\N
262264	1874	202600000	10260	5307	3	0	\N
262265	1874	202601000	10260	5307	4	0	\N
262266	1678	10080285950000	10261	5308	0	0	\N
262267	1678	10080285951000	10261	5308	1	0	\N
262268	1874	202602000	10261	5308	2	0	\N
262269	1874	202603000	10261	5308	3	0	\N
262274	1678	10080285950000	10263	5308	0	0	\N
262275	1678	10080285951000	10263	5308	1	0	\N
262276	1874	202602000	10263	5308	2	0	\N
262277	1874	202603000	10263	5308	3	0	\N
262288	966	505190775000000	10266	5310	0	0	\N
262289	1086	905298465000000	10266	5310	1	0	\N
262290	1206	610822750000000	10266	5310	2	0	\N
262291	1332	1702110637751650	10266	5310	3	0	\N
262292	1874	202605000	10266	5310	4	0	\N
262293	1874	202606000	10266	5310	5	0	\N
262294	1678	10080285953000	10266	5310	6	0	\N
262295	1678	10080285954000	10266	5310	7	0	\N
262298	1678	10080285955000	10268	5311	0	0	\N
262299	1874	202607000	10268	5311	1	0	\N
262328	1012	504236775000000	10277	5319	0	0	\N
262329	1874	202617000	10277	5319	1	0	\N
262330	1874	202618000	10277	5319	3	0	\N
262331	1678	10080285965000	10277	5319	4	0	\N
262332	1678	10080285966000	10277	5319	5	0	\N
262333	1678	10080285967000	10277	5319	6	0	\N
262334	1874	202619000	10277	5319	7	0	\N
262335	1012	504236775000000	10278	5319	0	0	\N
262336	1874	202617000	10278	5319	1	0	\N
262337	1874	202618000	10278	5319	3	0	\N
262338	1678	10080285965000	10278	5319	4	0	\N
262339	1678	10080285966000	10278	5319	5	0	\N
262340	1678	10080285967000	10278	5319	6	0	\N
262341	1874	202619000	10278	5319	7	0	\N
262342	1012	504236775000000	10279	5319	0	0	\N
262343	1874	202617000	10279	5319	1	0	\N
262344	1874	202618000	10279	5319	3	0	\N
262222	1874	202591000	10252	5303	2	0	0
262223	1874	202592000	10252	5303	3	0	0
262224	1678	10080285938000	10252	5303	4	0	0
262225	1678	10080285939000	10252	5303	5	0	0
262226	1678	10080285940000	10252	5303	6	0	0
262228	730	5018666003811	10253	5304	1	0	0
262229	449	66246391250309	10253	5304	2	0	0
262230	489	66246391250309	10253	5304	3	0	0
262231	945	504654745391541	10253	5304	4	0	0
262232	1065	904336979807644	10253	5304	5	0	0
262234	1678	10080285941000	10253	5304	7	0	0
262235	1678	10080285942000	10253	5304	8	0	0
262236	1678	10080285943000	10253	5304	9	0	0
262237	1874	202593000	10253	5304	10	0	0
262239	1678	10080285944000	10253	5304	12	0	0
262240	1678	10080285945000	10253	5304	13	0	0
262241	1874	202594000	10253	5304	14	0	0
262242	1874	202595000	10253	5304	15	0	0
262243	1874	202596000	10253	5304	16	0	0
262247	1678	10080285946000	10255	5305	0	0	0
262248	1874	202598000	10255	5305	1	0	0
262249	1678	10080285947000	10256	5306	0	0	0
262250	1874	202599000	10256	5306	1	0	0
262251	2013	200000000	10258	5307	0	0	0
262253	1678	10080285949000	10258	5307	2	0	0
262254	1874	202600000	10258	5307	3	0	0
262255	1874	202601000	10258	5307	4	0	0
262270	1678	10080285950000	10262	5308	0	0	0
262272	1874	202602000	10262	5308	2	0	0
262273	1874	202603000	10262	5308	3	0	0
262278	1874	202604000	10264	5309	0	0	0
262279	1678	10080285952000	10264	5309	1	0	0
262280	966	505190775000000	10265	5310	0	0	0
262282	1206	610822750000000	10265	5310	2	0	0
262283	1332	1702110637751650	10265	5310	3	0	0
262284	1874	202605000	10265	5310	4	0	0
262285	1874	202606000	10265	5310	5	0	0
262286	1678	10080285953000	10265	5310	6	0	0
262296	1678	10080285955000	10267	5311	0	0	0
262297	1874	202607000	10267	5311	1	0	0
262300	1678	10080285956000	10269	5312	0	0	0
262301	1874	202608000	10269	5312	1	0	0
262303	1678	10080285957000	10270	5313	1	0	0
262304	1874	202610000	10271	5314	0	0	0
262305	1678	10080285958000	10271	5314	1	0	0
262306	1874	202611000	10272	5315	0	0	0
262307	1678	10080285959000	10272	5315	1	0	0
262309	1678	10080285960000	10273	5316	1	0	0
262310	1678	10080285961000	10274	5317	0	0	0
262311	1874	202613000	10274	5317	1	0	0
262312	937	505421913800000	10274	5317	2	0	0
262313	683	66147585999999	10275	5318	0	0	0
262315	1678	10080285963000	10275	5318	2	0	0
262316	1678	10080285964000	10275	5318	3	0	0
262317	1932	1138849152658	10275	5318	4	0	0
262318	1874	202614000	10275	5318	5	0	0
262320	1874	202616000	10275	5318	7	0	0
262321	1012	504236775000000	10276	5319	0	0	0
262322	1874	202617000	10276	5319	1	0	0
262323	1874	202618000	10276	5319	3	0	0
262324	1678	10080285965000	10276	5319	4	0	0
262326	1678	10080285967000	10276	5319	6	0	0
262327	1874	202619000	10276	5319	7	0	0
262345	1678	10080285965000	10279	5319	4	0	\N
262346	1678	10080285966000	10279	5319	5	0	\N
262347	1678	10080285967000	10279	5319	6	0	\N
262348	1874	202619000	10279	5319	7	0	\N
262349	1012	504236775000000	10280	5319	0	0	\N
262350	1874	202617000	10280	5319	1	0	\N
262351	1874	202618000	10280	5319	3	0	\N
262352	1678	10080285965000	10280	5319	4	0	\N
262353	1678	10080285966000	10280	5319	5	0	\N
262354	1678	10080285967000	10280	5319	6	0	\N
262355	1874	202619000	10280	5319	7	0	\N
262369	1874	202623000	10283	5322	0	0	\N
262370	344	66000100000000	10283	5322	1	0	\N
262371	1874	202623000	10284	5322	0	0	\N
262372	344	66000100000000	10284	5322	1	0	\N
262373	1678	10080285971000	10284	5322	2	0	\N
262377	1678	10080285972000	10286	5323	0	0	\N
262378	1177	611102313200000	10286	5323	1	0	\N
262379	1057	905712285400000	10286	5323	2	0	\N
262380	1874	202624000	10286	5323	3	0	\N
262385	1678	10080285972000	10288	5323	0	0	\N
262386	1177	611102313200000	10288	5323	1	0	\N
262387	1057	905712285400000	10288	5323	2	0	\N
262388	1874	202624000	10288	5323	3	0	\N
262389	1678	10080285972000	10289	5323	0	0	\N
262390	1177	611102313200000	10289	5323	1	0	\N
262391	1874	202624000	10289	5323	2	0	\N
262395	1132	903588465000000	10291	5324	0	0	\N
262396	1678	10080285973000	10291	5324	1	0	\N
262397	1874	202625000	10291	5324	2	0	\N
262401	1378	1698896637751650	10293	5326	0	0	\N
262402	1874	202627000	10293	5326	1	0	\N
262403	1874	202628000	10293	5326	2	0	\N
262404	1678	10080285975000	10293	5326	3	0	\N
262405	1678	10080285976000	10293	5326	4	0	\N
262406	1378	1698896637751650	10294	5326	0	0	\N
262407	1874	202627000	10294	5326	1	0	\N
262408	1874	202628000	10294	5326	2	0	\N
262409	1678	10080285975000	10294	5326	3	0	\N
262410	1678	10080285976000	10294	5326	4	0	\N
262416	1874	202629000	10296	5327	0	0	\N
262417	1678	10080285977000	10296	5327	1	0	\N
262420	1874	202629000	10298	5327	0	0	\N
262421	1678	10080285977000	10298	5327	1	0	\N
262432	1874	202633000	10301	5329	0	0	\N
262433	2014	200000000	10301	5329	1	0	\N
262434	1678	10080285981000	10301	5329	2	0	\N
262446	1678	10080285985000	10306	5332	0	0	\N
262447	144	66337270000000	10306	5332	1	0	\N
262448	1874	202637000	10306	5332	2	0	\N
262449	1874	202638000	10306	5332	3	0	\N
262450	1303	1702888985351650	10306	5332	4	0	\N
262451	1678	10080285986000	10306	5332	5	0	\N
262452	1678	10080285985000	10307	5332	0	0	\N
262453	144	66337270000000	10307	5332	1	0	\N
262454	1874	202637000	10307	5332	2	0	\N
262455	1874	202638000	10307	5332	3	0	\N
262456	1303	1702888985351650	10307	5332	4	0	\N
262457	1678	10080285986000	10307	5332	5	0	\N
262458	1678	10080285985000	10308	5332	0	0	\N
262459	144	66337270000000	10308	5332	1	0	\N
262460	1874	202637000	10308	5332	2	0	\N
262461	1874	202638000	10308	5332	3	0	\N
262462	1678	10080285986000	10308	5332	4	0	\N
262463	1678	10080285985000	10309	5332	0	0	\N
262464	144	66337270000000	10309	5332	1	0	\N
262465	1874	202637000	10309	5332	2	0	\N
262466	1874	202638000	10309	5332	3	0	\N
262467	1678	10080285986000	10309	5332	4	0	\N
262476	1874	202641000	10313	5335	0	0	\N
262477	1678	10080285989000	10313	5335	1	0	\N
262478	1874	202641000	10314	5335	0	0	\N
262479	1678	10080285989000	10314	5335	1	0	\N
262358	1252	609669750000000	10282	5321	0	0	0
262359	1678	10080285969000	10282	5321	1	0	0
262360	1678	10080285970000	10282	5321	2	0	0
262361	148	66347655311328	10282	5321	3	0	0
262362	714	2010535009412	10282	5321	4	0	0
262364	1114	905709403145245	10282	5321	6	0	0
262365	1234	611100181836822	10282	5321	7	0	0
262366	1360	1702884992686953	10282	5321	8	0	0
262367	1874	202621000	10282	5321	9	0	0
262368	1874	202622000	10282	5321	10	0	0
262375	344	66000100000000	10285	5322	1	0	0
262376	1678	10080285971000	10285	5322	2	0	0
262381	1678	10080285972000	10287	5323	0	0	0
262382	1177	611102313200000	10287	5323	1	0	0
262384	1874	202624000	10287	5323	3	0	0
262392	1132	903588465000000	10290	5324	0	0	0
262393	1678	10080285973000	10290	5324	1	0	0
262394	1874	202625000	10290	5324	2	0	0
262398	1483	0	10292	5325	0	0	0
262400	1874	202626000	10292	5325	2	0	0
262411	1378	1698896637751650	10295	5326	0	0	0
262412	1874	202627000	10295	5326	1	0	0
262413	1874	202628000	10295	5326	2	0	0
262414	1678	10080285975000	10295	5326	3	0	0
262418	1874	202629000	10297	5327	0	0	0
262419	1678	10080285977000	10297	5327	1	0	0
262422	683	66338585999999	10299	5328	0	0	0
262423	1874	202630000	10299	5328	1	0	0
262425	1678	10080285978000	10299	5328	3	0	0
262426	1874	202632000	10299	5328	4	0	0
262427	1678	10080285979000	10299	5328	5	0	0
262428	1678	10080285980000	10299	5328	6	0	0
262429	1874	202633000	10300	5329	0	0	0
262431	1678	10080285981000	10300	5329	2	0	0
262435	1874	202634000	10303	5330	0	0	0
262436	1678	10080285982000	10303	5330	1	0	0
262437	1874	202635000	10304	5331	0	0	0
262438	1678	10080285983000	10304	5331	1	0	0
262440	1874	202636000	10304	5331	3	0	0
262441	1678	10080285985000	10305	5332	0	0	0
262442	144	66337270000000	10305	5332	1	0	0
262443	1874	202637000	10305	5332	2	0	0
262445	1678	10080285986000	10305	5332	4	0	0
262468	1874	202639000	10310	5333	0	0	0
262469	1678	10080285987000	10310	5333	1	0	0
262470	1303	1702888985351650	10310	5333	2	0	0
262471	1874	202640000	10311	5334	0	0	0
262473	1678	10080285988000	10311	5334	2	0	0
262474	1874	202641000	10312	5335	0	0	0
262475	1678	10080285989000	10312	5335	1	0	0
262480	1874	202642000	10315	5336	0	0	0
262500	182	66426372520656	10318	5338	0	0	\N
262501	1678	10080285995000	10318	5338	1	0	\N
262502	1678	10080285996000	10318	5338	2	0	\N
262503	1874	202647000	10318	5338	3	0	\N
262504	1874	202648000	10318	5338	4	0	\N
262505	702	44284248347116	10318	5338	5	0	\N
262506	927	506022423570956	10318	5338	6	0	\N
262507	1047	906787847439016	10318	5338	7	0	\N
262508	1167	610827828691356	10318	5338	8	0	\N
262509	1293	1704912648132442	10318	5338	10	0	\N
262512	1874	202650000	10320	5340	0	0	\N
262513	1874	202651000	10320	5340	1	0	\N
262514	1678	10080285998000	10320	5340	2	0	\N
262515	1678	10080285999000	10320	5340	3	0	\N
262520	1874	202650000	10322	5340	0	0	\N
262521	1874	202651000	10322	5340	1	0	\N
262522	1678	10080285998000	10322	5340	2	0	\N
262523	1678	10080285999000	10322	5340	3	0	\N
262524	1874	202650000	10323	5340	0	0	\N
262525	1874	202651000	10323	5340	1	0	\N
262526	1678	10080285998000	10323	5340	2	0	\N
262527	1678	10080285999000	10323	5340	3	0	\N
262534	1678	10080286001000	10326	5342	0	0	\N
262535	1678	10080286002000	10326	5342	1	0	\N
262536	1874	202653000	10326	5342	2	0	\N
262537	1874	202654000	10326	5342	3	0	\N
262547	1054	906181830077410	10329	5344	0	0	\N
262548	1174	611418937701728	10329	5344	1	0	\N
262549	1300	1703773234246672	10329	5344	2	0	\N
262550	1678	10080286004000	10329	5344	3	0	\N
262551	1874	202656000	10329	5344	4	0	\N
262575	1678	10080286014000	10335	5349	0	0	\N
262576	1590	5500000000	10335	5349	1	0	\N
262577	1874	202666000	10335	5349	2	0	\N
262578	1678	10080286015000	10336	5350	0	0	\N
262579	1874	202667000	10336	5350	1	0	\N
262588	1678	10080286018000	10340	5352	0	0	\N
262589	1874	202670000	10340	5352	1	0	\N
262590	1678	10080286019000	10340	5352	2	0	\N
262593	1678	10080286019000	10342	5353	0	0	\N
262594	1874	202671000	10342	5353	1	0	\N
262595	1678	10080286019000	10343	5353	0	0	\N
262596	1874	202671000	10343	5353	1	0	\N
262597	1874	202672000	10344	5354	0	0	\N
262598	1874	202673000	10344	5354	1	0	\N
262599	1874	202674000	10344	5354	2	0	\N
262600	1678	10080286020000	10344	5354	3	0	\N
262601	1678	10080286021000	10344	5354	4	0	\N
262602	1678	10080286022000	10344	5354	5	0	\N
262611	1678	10080286023000	10347	5355	0	0	\N
262612	1874	202675000	10347	5355	1	0	\N
262613	1678	10080286024000	10348	5356	0	0	\N
262614	1874	202676000	10348	5356	1	0	\N
262483	1874	202643000	10315	5336	3	0	0
262484	1874	202644000	10315	5336	4	0	0
262485	1678	10080285992000	10315	5336	5	0	0
262486	1874	202645000	10316	5337	0	0	0
262487	1874	202646000	10316	5337	1	0	0
262489	1678	10080285994000	10316	5337	3	0	0
262490	1773	6840402949970	10316	5337	4	0	18
262491	182	66426372520656	10317	5338	0	0	0
262492	1678	10080285995000	10317	5338	1	0	0
262493	1678	10080285996000	10317	5338	2	0	0
262495	1874	202648000	10317	5338	4	0	0
262496	702	44284248347116	10317	5338	5	0	0
262497	927	506022423570956	10317	5338	6	0	0
262498	1047	906787847439016	10317	5338	7	0	0
262510	1874	202649000	10319	5339	0	0	0
262511	1678	10080285997000	10319	5339	1	0	0
262516	1874	202650000	10321	5340	0	0	0
262517	1874	202651000	10321	5340	1	0	0
262518	1678	10080285998000	10321	5340	2	0	0
262528	1678	10080286000000	10324	5341	0	0	0
262529	1874	202652000	10324	5341	1	0	0
262530	1678	10080286001000	10325	5342	0	0	0
262531	1678	10080286002000	10325	5342	1	0	0
262532	1874	202653000	10325	5342	2	0	0
262538	934	505684242622784	10327	5343	0	0	0
262539	1678	10080286003000	10327	5343	1	0	0
262540	1874	202655000	10327	5343	2	0	0
262541	1821	341990000000	10327	5343	3	0	1
262543	1174	611418937701728	10328	5344	1	0	0
262544	1300	1703773234246672	10328	5344	2	0	0
262545	1678	10080286004000	10328	5344	3	0	0
262546	1874	202656000	10328	5344	4	0	0
262552	1678	10080286005000	10330	5345	0	0	0
262554	1874	202657000	10330	5345	2	0	0
262555	1874	202658000	10330	5345	3	0	0
262556	1978	122000000000	10330	5345	4	0	0
262557	1874	202659000	10331	5346	0	0	0
262558	1874	202660000	10331	5346	1	0	0
262560	1874	202662000	10332	5347	1	0	0
262561	1678	10080286007000	10332	5347	2	0	0
262562	1678	10080286008000	10332	5347	3	0	0
262563	1678	10080286009000	10332	5347	4	0	0
262565	1293	1704912648132442	10333	5348	0	0	0
262566	1874	202663000	10333	5348	1	0	0
262567	1678	10080286011000	10333	5348	2	0	0
262568	1678	10080286012000	10333	5348	3	0	0
262569	1874	202664000	10333	5348	4	0	0
262571	1678	10080286013000	10333	5348	6	0	0
262572	1678	10080286014000	10334	5349	0	0	0
262573	1590	5500000000	10334	5349	1	0	4
262574	1874	202666000	10334	5349	2	0	0
262580	1678	10080286015000	10337	5350	0	0	0
262582	1678	10080286016000	10338	5351	0	0	0
262583	1678	10080286017000	10338	5351	1	0	0
262584	1874	202668000	10338	5351	2	0	0
262585	1874	202669000	10338	5351	3	0	0
262587	1874	202670000	10339	5352	1	0	0
262591	1678	10080286019000	10341	5353	0	0	0
262592	1874	202671000	10341	5353	1	0	0
262603	1874	202672000	10345	5354	0	0	0
262604	1874	202673000	10345	5354	1	0	0
262606	1678	10080286020000	10345	5354	3	0	0
262607	1678	10080286021000	10345	5354	4	0	0
262608	1678	10080286022000	10345	5354	5	0	0
262609	1678	10080286023000	10346	5355	0	0	0
262610	1874	202675000	10346	5355	1	0	0
262616	1874	202676000	10349	5356	1	0	0
262617	1678	10080286024000	10350	5356	0	0	\N
262618	1874	202676000	10350	5356	1	0	\N
262619	1874	202677000	10350	5356	2	0	\N
262620	1678	10080286025000	10350	5356	3	0	\N
262625	1874	202677000	10352	5357	0	0	\N
262626	1874	202678000	10352	5357	1	0	\N
262627	1678	10080286025000	10352	5357	2	0	\N
262628	1678	10080286026000	10352	5357	3	0	\N
262629	1874	202679000	10353	5358	0	0	\N
262630	1678	10080286027000	10353	5358	1	0	\N
262631	1874	202679000	10354	5358	0	0	\N
262632	1678	10080286027000	10354	5358	1	0	\N
262635	1874	202680000	10357	5359	0	0	\N
262636	1678	10080286028000	10357	5359	1	0	\N
262639	1874	202680000	10360	5359	0	0	\N
262640	1678	10080286028000	10360	5359	1	0	\N
262647	1874	202682000	10366	5361	0	0	\N
262648	1874	202683000	10366	5361	1	0	\N
262649	1678	10080286030000	10366	5361	2	0	\N
262650	1678	10080286031000	10366	5361	3	0	\N
262651	2015	9000000000	10367	5362	0	0	\N
262652	1678	10080286032000	10367	5362	1	0	\N
262653	1874	202684000	10367	5362	3	0	\N
262654	1874	202685000	10367	5362	4	0	\N
262655	1678	10080286033000	10367	5362	5	0	\N
262661	2015	9000000000	10369	5362	0	0	\N
262662	1678	10080286032000	10369	5362	1	0	\N
262663	1874	202684000	10369	5362	3	0	\N
262664	1874	202685000	10369	5362	4	0	\N
262665	1678	10080286033000	10369	5362	5	0	\N
262668	1874	202686000	10371	5363	0	0	\N
262669	1678	10080286034000	10371	5363	1	0	\N
262670	1874	202686000	10372	5363	0	0	\N
262671	1678	10080286034000	10372	5363	1	0	\N
262672	1678	10080286034000	10373	5363	0	0	\N
262673	1874	202686000	10374	5363	0	0	\N
262674	1678	10080286034000	10374	5363	1	0	\N
262675	1678	10080286034000	10375	5363	0	0	\N
262696	1009	504335775000000	10379	5366	0	0	\N
262697	1129	903765465000000	10379	5366	1	0	\N
262698	1249	609788750000000	10379	5366	2	0	\N
262699	1375	1699230637751650	10379	5366	3	0	\N
262700	1874	202692000	10379	5366	4	0	\N
262701	1678	10080286041000	10379	5366	5	0	\N
262702	1874	202693000	10380	5367	0	0	\N
262703	1874	202694000	10380	5367	1	0	\N
262704	1678	10080286042000	10380	5367	2	0	\N
262705	1678	10080286043000	10380	5367	3	0	\N
262713	2015	333800000000	10383	5368	0	0	\N
262714	1874	202695000	10383	5368	1	0	\N
262717	1678	10080286046000	10385	5370	0	0	\N
262718	1874	202697000	10385	5370	1	0	\N
262721	535	66001000000000	10387	5295	0	0	\N
262722	1009	504335775000000	10387	5295	1	0	\N
262723	1129	903765465000000	10387	5295	2	0	\N
262724	1249	609788750000000	10387	5295	3	0	\N
262725	1375	1699230637751650	10387	5295	4	0	\N
262726	2015	9000000000	10387	5295	5	0	\N
262727	2015	333800000000	10387	5295	6	0	\N
262728	966	505190775000000	10387	5295	7	0	\N
262729	934	505684242622784	10387	5295	8	0	\N
262730	1086	905298465000000	10387	5295	9	0	\N
262731	1206	610822750000000	10387	5295	11	0	\N
262732	1332	1702110637751650	10387	5295	12	0	\N
262733	683	66147585999999	10387	5295	13	0	\N
262734	1054	906181830077410	10387	5295	14	0	\N
262735	1174	611418937701728	10387	5295	15	0	\N
262736	1300	1703773234246672	10387	5295	16	0	\N
262737	1012	504236775000000	10387	5295	17	0	\N
262738	1252	609669750000000	10387	5295	18	0	\N
262739	1132	903588465000000	10387	5295	19	0	\N
262740	1378	1698896637751650	10387	5295	20	0	\N
262741	683	66338585999999	10387	5295	21	0	\N
262742	558	66033774938283	10387	5295	22	0	\N
262743	741	5018666003811	10387	5295	23	0	\N
262744	730	5018666003811	10387	5295	24	0	\N
262745	449	66246391250309	10387	5295	25	0	\N
262746	489	66246391250309	10387	5295	26	0	\N
262747	945	504654745391541	10387	5295	27	0	\N
262748	1065	904336979807644	10387	5295	28	0	\N
262749	1185	610174180476079	10387	5295	29	0	\N
262750	1590	5500000000	10387	5295	30	0	\N
262751	344	66000100000000	10387	5295	31	0	\N
262752	144	66337270000000	10387	5295	32	0	\N
262623	1678	10080286025000	10351	5357	2	0	0
262624	1678	10080286026000	10351	5357	3	0	0
262633	1874	202679000	10355	5358	0	0	0
262634	1678	10080286027000	10355	5358	1	0	0
262637	1874	202680000	10359	5359	0	0	0
262641	1874	202681000	10364	5360	0	0	0
262642	1678	10080286029000	10364	5360	1	0	0
262643	1874	202682000	10365	5361	0	0	0
262644	1874	202683000	10365	5361	1	0	0
262645	1678	10080286030000	10365	5361	2	0	0
262656	2015	9000000000	10368	5362	0	0	0
262657	1678	10080286032000	10368	5362	1	0	0
262658	1874	202684000	10368	5362	3	0	0
262659	1874	202685000	10368	5362	4	0	0
262666	1874	202686000	10370	5363	0	0	0
262667	1678	10080286034000	10370	5363	1	0	0
262676	535	66001000000000	10376	5364	0	0	0
262677	1874	202687000	10376	5364	1	0	0
262678	1874	202688000	10376	5364	2	0	0
262680	1678	10080286036000	10376	5364	4	0	0
262681	558	66033774938283	10377	5365	0	0	3
262682	1874	202689000	10377	5365	1	0	0
262683	1678	10080286037000	10377	5365	2	0	0
262684	1678	10080286038000	10377	5365	3	0	0
262686	1678	10080286040000	10377	5365	5	0	0
262687	1874	202690000	10377	5365	6	0	0
262688	1874	202691000	10377	5365	7	0	0
262689	715	2008389376502	10377	5365	8	0	0
262691	1129	903765465000000	10378	5366	1	0	0
262692	1249	609788750000000	10378	5366	2	0	0
262693	1375	1699230637751650	10378	5366	3	0	0
262694	1874	202692000	10378	5366	4	0	0
262695	1678	10080286041000	10378	5366	5	0	0
262707	1874	202694000	10381	5367	1	0	0
262708	1678	10080286042000	10381	5367	2	0	0
262709	1678	10080286043000	10381	5367	3	0	0
262710	2015	333800000000	10382	5368	0	0	0
262711	1874	202695000	10382	5368	1	0	0
262715	1678	10080286045000	10384	5369	0	0	0
262716	1874	202696000	10384	5369	1	0	0
262719	1678	10080286046000	10386	5370	0	0	0
262720	1874	202697000	10386	5370	1	0	0
262753	100	66337270000000	10387	5295	33	0	\N
262754	1678	10080285930000	10387	5295	34	0	\N
262755	1678	10080285931000	10387	5295	35	0	\N
262756	1678	10080285932000	10387	5295	36	0	\N
262757	1678	10080285933000	10387	5295	37	0	\N
262758	1311	1700304607568145	10387	5295	38	0	\N
262759	1874	202581000	10387	5295	39	0	\N
262760	1874	202582000	10387	5295	40	0	\N
262761	1874	202583000	10387	5295	41	0	\N
262762	1874	202584000	10387	5295	42	0	\N
262763	1874	202585000	10387	5295	43	0	\N
262764	1874	202586000	10387	5295	44	0	\N
262765	1874	202587000	10387	5295	45	0	\N
262766	1874	202588000	10387	5295	46	0	\N
262767	1874	202589000	10387	5295	47	0	\N
262768	2012	200000000	10387	5295	48	0	\N
262769	1874	202590000	10387	5295	49	0	\N
262770	1874	202591000	10387	5295	50	0	\N
262771	1874	202592000	10387	5295	51	0	\N
262772	1874	202593000	10387	5295	52	0	\N
262773	148	66347655311328	10387	5295	53	0	\N
262774	714	2010535009412	10387	5295	54	0	\N
262775	994	505420610261745	10387	5295	55	0	\N
262776	1114	905709403145245	10387	5295	56	0	\N
262777	1234	611100181836822	10387	5295	57	0	\N
262778	1360	1702884992686953	10387	5295	58	0	\N
262779	1932	1138849152658	10387	5295	59	0	\N
262780	937	505421913800000	10387	5295	60	0	\N
262781	1177	611102313200000	10387	5295	61	0	\N
262782	1057	905712285400000	10387	5295	62	0	\N
262783	1303	1702888985351650	10387	5295	63	0	\N
262784	1678	10080285934000	10387	5295	64	0	\N
262785	1678	10080285935000	10387	5295	65	0	\N
262786	1678	10080285936000	10387	5295	66	0	\N
262787	1678	10080285937000	10387	5295	67	0	\N
262788	1874	202594000	10387	5295	68	0	\N
262789	1874	202595000	10387	5295	69	0	\N
262790	1874	202596000	10387	5295	70	0	\N
262791	1678	10080285938000	10387	5295	71	0	\N
262792	1678	10080285939000	10387	5295	72	0	\N
262793	1678	10080285940000	10387	5295	73	0	\N
262794	1678	10080285941000	10387	5295	74	0	\N
262795	1678	10080285942000	10387	5295	75	0	\N
262796	1678	10080285943000	10387	5295	76	0	\N
262797	1678	10080285944000	10387	5295	77	0	\N
262798	1678	10080285945000	10387	5295	78	0	\N
262799	1678	10080285946000	10387	5295	79	0	\N
262800	1678	10080285947000	10387	5295	80	0	\N
262801	1678	10080285948000	10387	5295	81	0	\N
262802	1678	10080285949000	10387	5295	82	0	\N
262803	1678	10080285950000	10387	5295	83	0	\N
262804	1678	10080285951000	10387	5295	84	0	\N
262805	1678	10080285952000	10387	5295	85	0	\N
262806	1678	10080285953000	10387	5295	86	0	\N
262807	1678	10080285954000	10387	5295	87	0	\N
262808	1678	10080285955000	10387	5295	88	0	\N
262809	1678	10080285956000	10387	5295	89	0	\N
262810	1678	10080285957000	10387	5295	90	0	\N
262811	1678	10080285958000	10387	5295	91	0	\N
262812	1678	10080285959000	10387	5295	92	0	\N
262813	1678	10080285960000	10387	5295	93	0	\N
262814	1678	10080285961000	10387	5295	94	0	\N
262815	1678	10080285962000	10387	5295	95	0	\N
262816	1678	10080285963000	10387	5295	96	0	\N
262817	1678	10080285964000	10387	5295	97	0	\N
262818	1678	10080285965000	10387	5295	98	0	\N
262819	1678	10080285966000	10387	5295	99	0	\N
262820	1678	10080285967000	10387	5295	100	0	\N
262821	1678	10080285968000	10387	5295	101	0	\N
262822	1678	10080285969000	10387	5295	102	0	\N
262823	1678	10080285970000	10387	5295	103	0	\N
262824	1678	10080285971000	10387	5295	104	0	\N
262825	1678	10080285972000	10387	5295	105	0	\N
262826	1678	10080285973000	10387	5295	106	0	\N
262827	1678	10080285974000	10387	5295	107	0	\N
262828	1678	10080285975000	10387	5295	108	0	\N
262829	1678	10080285976000	10387	5295	109	0	\N
262830	1678	10080285977000	10387	5295	110	0	\N
262831	1678	10080285978000	10387	5295	111	0	\N
262832	1678	10080285979000	10387	5295	112	0	\N
262833	1678	10080285980000	10387	5295	113	0	\N
262834	1678	10080285981000	10387	5295	114	0	\N
262835	1678	10080285982000	10387	5295	115	0	\N
262836	1678	10080285983000	10387	5295	116	0	\N
262837	1678	10080285984000	10387	5295	117	0	\N
262838	1678	10080285985000	10387	5295	118	0	\N
262839	1678	10080285986000	10387	5295	119	0	\N
262840	1678	10080285987000	10387	5295	120	0	\N
262841	1678	10080285988000	10387	5295	121	0	\N
262842	1678	10080285989000	10387	5295	122	0	\N
262843	1678	10080285990000	10387	5295	123	0	\N
262844	1678	10080285991000	10387	5295	124	0	\N
262845	1678	10080285992000	10387	5295	125	0	\N
262846	1874	202698000	10388	5371	0	0	\N
262847	1678	10080286047000	10388	5371	1	0	\N
262848	1337	1701480937522450	10388	5371	2	0	\N
262849	1678	10080286047000	10389	5371	0	0	\N
262850	1337	1701480937522450	10389	5371	1	0	\N
262858	1874	202701000	10392	5373	0	0	\N
262859	1678	10080286050000	10392	5373	1	0	\N
262862	1874	202701000	10394	5373	0	0	\N
262863	1678	10080286050000	10394	5373	1	0	\N
262866	1874	202701000	10396	5373	0	0	\N
262867	1874	202702000	10396	5373	1	0	\N
262868	1678	10080286050000	10396	5373	2	0	\N
262871	1874	202703000	10398	5375	0	0	\N
262872	1678	10080286052000	10398	5375	1	0	\N
262875	1678	10080286053000	10400	5376	0	0	\N
262876	1874	202704000	10400	5376	1	0	\N
262853	1337	1701480937522450	10390	5371	2	0	0
262854	1874	202699000	10391	5372	0	0	0
262855	1874	202700000	10391	5372	1	0	0
262856	1678	10080286048000	10391	5372	2	0	0
262857	1678	10080286049000	10391	5372	3	0	0
262861	1678	10080286050000	10393	5373	1	0	0
262864	1874	202702000	10395	5374	0	0	0
262865	1678	10080286051000	10395	5374	1	0	0
262869	1874	202703000	10397	5375	0	0	0
262870	1678	10080286052000	10397	5375	1	0	0
262874	1874	202704000	10399	5376	1	0	0
262877	2016	1004000000000	10401	5377	0	0	0
262878	1874	202705000	10401	5377	1	0	0
262879	1678	10080286054000	10401	5377	2	0	0
262881	1874	202707000	10403	5379	0	0	0
262882	1678	10080286055000	10403	5379	1	0	0
262883	1874	202708000	10404	5380	0	0	0
262884	1678	10080286056000	10404	5380	1	0	0
262885	1874	202709000	10405	5381	0	0	0
262887	1678	10080286058000	10405	5381	2	0	0
262888	1678	10080286059000	10405	5381	3	0	0
262893	1678	10080286060000	10407	5382	0	0	\N
262894	1874	202712000	10407	5382	1	0	\N
262899	1874	202715000	10409	5384	0	0	\N
262900	40	66264692170000	10409	5384	1	0	\N
262901	1874	202716000	10409	5384	2	0	\N
262902	1678	10080286063000	10409	5384	3	0	\N
262903	1678	10080286064000	10409	5384	4	0	\N
262913	1678	10080286066000	10413	5386	0	0	\N
262914	1874	202718000	10413	5386	2	0	\N
262922	1678	10080286070000	10415	5388	0	0	\N
262923	32	73922280157000	10415	5388	1	0	\N
262924	1874	202722000	10415	5388	2	0	\N
262925	1678	10080286071000	10415	5388	3	0	\N
262926	1874	202723000	10415	5388	4	0	\N
262932	1874	202724000	10417	5389	0	0	\N
262933	1678	10080286072000	10417	5389	1	0	\N
262934	779	27889620396792	10417	5389	2	0	\N
262935	1874	202724000	10418	5389	0	0	\N
262936	1678	10080286072000	10418	5389	1	0	\N
262937	779	27889620396792	10418	5389	2	0	\N
262952	779	27889620396792	10421	5390	0	0	\N
262953	780	306785556632051	10421	5390	1	0	\N
262954	1874	202725000	10421	5390	2	0	\N
262955	1874	202726000	10421	5390	3	0	\N
262956	1874	202727000	10421	5390	4	0	\N
262957	1874	202728000	10421	5390	5	0	\N
262958	782	2454234815297720	10421	5390	6	0	\N
262959	785	223112450651807	10421	5390	7	0	\N
262960	1678	10080286073000	10421	5390	8	0	\N
262961	1678	10080286074000	10421	5390	9	0	\N
262962	1678	10080286075000	10421	5390	10	0	\N
262963	1678	10080286076000	10421	5390	11	0	\N
262964	779	27889620396792	10422	5390	0	0	\N
262965	780	306785556632051	10422	5390	1	0	\N
262966	1874	202725000	10422	5390	2	0	\N
262967	1874	202726000	10422	5390	3	0	\N
262968	1874	202727000	10422	5390	4	0	\N
262969	1874	202728000	10422	5390	5	0	\N
262970	782	2454234815297720	10422	5390	6	0	\N
262971	785	223112450651807	10422	5390	7	0	\N
262972	1678	10080286073000	10422	5390	8	0	\N
262973	1678	10080286074000	10422	5390	9	0	\N
262974	1678	10080286075000	10422	5390	10	0	\N
262975	1678	10080286076000	10422	5390	11	0	\N
262976	1678	10080286077000	10423	5391	0	0	\N
262977	1874	202729000	10423	5391	1	0	\N
262986	1678	10080286080000	10427	5394	0	0	\N
262987	1678	10080286081000	10427	5394	1	0	\N
262988	791	55779240794584	10427	5394	2	0	\N
262989	799	13943560758181	10427	5394	3	0	\N
262990	800	153379034487607	10427	5394	4	0	\N
262991	801	13946140510666	10427	5394	5	0	\N
262992	1678	10080286082000	10427	5394	6	0	\N
262993	1874	202732000	10427	5394	7	0	\N
262994	1874	202733000	10427	5394	8	0	\N
262995	1874	202734000	10427	5394	9	0	\N
262996	802	153407411737275	10427	5394	10	0	\N
262997	811	107931214459286	10427	5394	11	0	\N
262998	812	1187242322919140	10427	5394	12	0	\N
262999	823	1731919963467760	10427	5394	13	0	\N
263000	824	19051102971730700	10427	5394	14	0	\N
263018	1678	10080286084000	10430	5396	0	0	\N
263019	480	66001000000000	10430	5396	1	0	\N
263020	1874	202736000	10430	5396	2	0	\N
263024	1678	10080286084000	10432	5396	0	0	\N
262891	1678	10080286060000	10406	5382	0	0	0
262892	1874	202712000	10406	5382	1	0	0
262895	1678	10080286061000	10408	5383	0	0	0
262896	1874	202713000	10408	5383	1	0	0
262897	1678	10080286062000	10408	5383	2	0	0
262904	1874	202715000	10410	5384	0	0	0
262905	40	66264692170000	10410	5384	1	0	0
262906	1874	202716000	10410	5384	2	0	0
262907	1678	10080286063000	10410	5384	3	0	0
262908	1678	10080286064000	10410	5384	4	0	0
262910	1874	202717000	10411	5385	1	0	0
262911	1678	10080286066000	10412	5386	0	0	0
262912	1874	202718000	10412	5386	2	0	0
262915	1678	10080286067000	10414	5387	0	0	0
262917	1678	10080286068000	10414	5387	2	0	0
262918	1678	10080286069000	10414	5387	3	0	0
262919	1874	202719000	10414	5387	4	0	0
262920	1874	202720000	10414	5387	5	0	0
262921	1874	202721000	10414	5387	6	0	0
262928	32	73922280157000	10416	5388	1	0	0
262929	1874	202722000	10416	5388	2	0	0
262930	1678	10080286071000	10416	5388	3	0	0
262931	1874	202723000	10416	5388	4	0	0
262938	1874	202724000	10419	5389	0	0	0
262940	779	27889620396792	10420	5390	0	0	0
262941	780	306785556632051	10420	5390	1	0	0
262942	1874	202725000	10420	5390	2	0	0
262943	1874	202726000	10420	5390	3	0	0
262945	1874	202728000	10420	5390	5	0	0
262946	782	2454234815297720	10420	5390	6	0	0
262947	785	223112450651807	10420	5390	7	0	0
262948	1678	10080286073000	10420	5390	8	0	0
262949	1678	10080286074000	10420	5390	9	0	0
262951	1678	10080286076000	10420	5390	11	0	0
262978	1678	10080286077000	10424	5391	0	0	0
262979	1874	202729000	10424	5391	1	0	0
262980	786	2454234815297720	10425	5392	0	0	0
262981	1874	202730000	10425	5392	1	0	0
262983	1678	10080286078000	10425	5392	3	0	0
262984	1874	202731000	10426	5393	0	0	0
262985	1678	10080286079000	10426	5393	1	0	0
263001	1678	10080286080000	10428	5394	0	0	0
263003	791	55779240794584	10428	5394	2	0	0
263004	799	13943560758181	10428	5394	3	0	0
263005	800	153379034487607	10428	5394	4	0	0
263006	801	13946140510666	10428	5394	5	0	0
263007	1678	10080286082000	10428	5394	6	0	0
263009	1874	202733000	10428	5394	8	0	0
263010	1874	202734000	10428	5394	9	0	0
263011	802	153407411737275	10428	5394	10	0	0
263012	811	107931214459286	10428	5394	11	0	0
263013	812	1187242322919140	10428	5394	12	0	0
263015	824	19051102971730700	10428	5394	14	0	0
263016	1874	202735000	10429	5395	0	0	0
263017	1678	10080286083000	10429	5395	1	0	0
263021	1678	10080286084000	10431	5396	0	0	0
263023	1874	202736000	10431	5396	2	0	0
263025	480	66001000000000	10432	5396	1	0	\N
263026	1874	202736000	10432	5396	2	0	\N
263027	1678	10080286084000	10433	5396	0	0	\N
263028	1678	10080286085000	10433	5396	1	0	\N
263029	480	66001000000000	10433	5396	2	0	\N
263030	1874	202736000	10433	5396	3	0	\N
263031	1678	10080286085000	10434	5397	0	0	\N
263032	1874	202737000	10434	5397	1	0	\N
263033	1678	10080286085000	10435	5397	0	0	\N
263034	1874	202737000	10435	5397	1	0	\N
263055	924	504692775000000	10442	5402	0	0	\N
263056	1678	10080286092000	10442	5402	1	0	\N
263057	1874	202743000	10442	5402	2	0	\N
263061	1	374067383793000	10444	5403	0	0	\N
263062	1874	202744000	10444	5403	1	0	\N
263063	1678	10080286093000	10444	5403	2	0	\N
263074	2017	343200000000	10446	5404	0	0	\N
263075	1678	10080286094000	10446	5404	1	0	\N
263076	1678	10080286095000	10446	5404	2	0	\N
263077	841	83729352737298	10446	5404	3	0	\N
263078	843	156101705973667	10446	5404	4	0	\N
263079	849	1155748212256640	10446	5404	5	0	\N
263080	851	2238858698375750	10446	5404	6	0	\N
263081	853	246870194966225	10446	5404	7	0	\N
263082	1874	202745000	10446	5404	8	0	\N
263083	1874	202746000	10446	5404	9	0	\N
263084	535	66001000000000	10447	5243	0	0	\N
263085	1009	504335775000000	10447	5243	1	0	\N
263086	1129	903765465000000	10447	5243	2	0	\N
263087	1249	609788750000000	10447	5243	3	0	\N
263088	1375	1699230637751650	10447	5243	4	0	\N
263089	2011	899000000000	10447	5243	5	0	\N
263090	941	505469525000000	10447	5243	6	0	\N
263091	2015	9000000000	10447	5243	7	0	\N
263092	2015	333800000000	10447	5243	8	0	\N
263093	298	66001970000000	10447	5243	9	0	\N
263094	298	66002970000000	10447	5243	10	0	\N
263095	1308	1701277837751650	10447	5243	11	0	\N
263096	412	66000000000000	10447	5243	12	0	\N
263097	1181	611158820000000	10447	5243	13	0	\N
263098	966	505190775000000	10447	5243	14	0	\N
263099	934	505684242622784	10447	5243	15	0	\N
263100	1086	905298465000000	10447	5243	16	0	\N
263101	1206	610822750000000	10447	5243	17	0	\N
263102	1332	1702110637751650	10447	5243	18	0	\N
263103	1061	905796315000000	10447	5243	19	0	\N
263104	1307	1703048397751650	10447	5243	20	0	\N
263105	2017	343200000000	10447	5243	21	0	\N
263106	1062	904855165000000	10447	5243	22	0	\N
263107	683	66147585999999	10447	5243	23	0	\N
263108	1054	906181830077410	10447	5243	24	0	\N
263109	1182	610523450000000	10447	5243	25	0	\N
263110	942	504944375000000	10447	5243	26	0	\N
263111	1174	611418937701728	10447	5243	27	0	\N
263112	1300	1703773234246672	10447	5243	28	0	\N
263113	1012	504236775000000	10447	5243	29	0	\N
263114	1252	609669750000000	10447	5243	30	0	\N
263115	1132	903588465000000	10447	5243	31	0	\N
263116	1378	1698896637751650	10447	5243	32	0	\N
263117	683	66338585999999	10447	5243	33	0	\N
263118	1008	504732913409273	10447	5243	34	0	\N
263119	558	66033774938283	10447	5243	35	0	\N
263120	1	374067383793000	10447	5243	36	0	\N
263121	1678	9360265855000	10447	5243	37	0	\N
263122	1678	9360265856000	10447	5243	38	0	\N
263123	1678	9360265857000	10447	5243	39	0	\N
263124	1393	75746941148850000	10447	5243	40	0	\N
263125	1651	3236050115	10447	5243	41	0	\N
263126	1678	9360265858000	10447	5243	42	0	\N
263127	2016	1004000000000	10447	5243	43	0	\N
263128	1678	9360265859000	10447	5243	44	0	\N
263129	40	66264692170000	10447	5243	45	0	\N
263130	1283	1699608907751650	10447	5243	46	0	\N
263131	741	5018666003811	10447	5243	47	0	\N
263132	730	5018666003811	10447	5243	48	0	\N
263133	449	66246391250309	10447	5243	49	0	\N
263134	489	66246391250309	10447	5243	50	0	\N
263135	945	504654745391541	10447	5243	51	0	\N
263136	1065	904336979807644	10447	5243	52	0	\N
263137	1185	610174180476079	10447	5243	53	0	\N
263138	1590	5500000000	10447	5243	54	0	\N
263139	344	66000100000000	10447	5243	55	0	\N
263140	144	66337270000000	10447	5243	56	0	\N
263141	100	66337270000000	10447	5243	57	0	\N
263142	1395	57867290193533700	10447	5243	58	0	\N
263143	31	1323893248766000	10447	5243	59	0	\N
263144	32	73922280157000	10447	5243	60	0	\N
263145	1316	1703504237751650	10447	5243	61	0	\N
263146	913	504301187001523	10447	5243	62	0	\N
263147	1037	903966955000000	10447	5243	63	0	\N
263148	1157	609924520000000	10447	5243	64	0	\N
263149	917	504448265000000	10447	5243	65	0	\N
263150	480	66001000000000	10447	5243	66	0	\N
263151	1290	1700432637751650	10447	5243	67	0	\N
263152	1148	609963489000000	10447	5243	68	0	\N
263153	1311	1700304607568145	10447	5243	69	0	\N
263154	1128	904477056277789	10447	5243	70	0	\N
263155	148	66155970757207	10447	5243	71	0	\N
263156	1678	9360265860000	10447	5243	72	0	\N
263157	1678	9360265861000	10447	5243	73	0	\N
263158	1874	202508000	10447	5243	75	0	\N
263159	1874	202509000	10447	5243	76	0	\N
263160	1874	202510000	10447	5243	77	0	\N
263037	1290	1700432637751650	10437	5398	0	0	0
263038	1678	10080286086000	10437	5398	1	0	0
263039	1874	202738000	10437	5398	2	0	0
263040	1044	904405465000000	10437	5398	3	0	0
263041	1678	10080286087000	10438	5399	0	0	0
263043	1164	610220750000000	10438	5399	2	0	0
263044	1678	10080286088000	10438	5399	3	0	0
263045	1393	75746941148850000	10439	5400	0	0	0
263046	1874	202740000	10439	5400	1	0	0
263047	1678	10080286089000	10439	5400	2	0	0
263049	1874	202742000	10440	5401	1	0	0
263050	1395	57867290193533700	10440	5401	2	0	0
263051	1678	10080286090000	10440	5401	3	0	0
263052	1678	10080286091000	10440	5401	4	0	0
263054	1874	202743000	10441	5402	1	0	0
263058	1	374067383793000	10443	5403	0	0	0
263059	1874	202744000	10443	5403	1	0	0
263060	1678	10080286093000	10443	5403	2	0	0
263064	2017	343200000000	10445	5404	0	0	0
263066	1678	10080286095000	10445	5404	2	0	0
263067	841	83729352737298	10445	5404	3	0	0
263068	843	156101705973667	10445	5404	4	0	0
263069	849	1155748212256640	10445	5404	5	0	0
263070	851	2238858698375750	10445	5404	6	0	0
263072	1874	202745000	10445	5404	8	0	0
263073	1874	202746000	10445	5404	9	0	0
263161	139	66237840350373	10447	5243	78	0	\N
263162	813	501803460057033	10447	5243	79	0	\N
263163	814	5519833243318203	10447	5243	80	0	\N
263164	779	27889620396792	10447	5243	81	0	\N
263165	780	306785556632051	10447	5243	82	0	\N
263166	1248	610268692849109	10447	5243	83	0	\N
263167	714	2004726386573	10447	5243	84	0	\N
263168	994	503962494255265	10447	5243	85	0	\N
263169	1114	903096471754765	10447	5243	86	0	\N
263170	1153	609746696000000	10447	5243	87	0	\N
263171	1033	903703406000000	10447	5243	88	0	\N
263172	1279	1699113382751650	10447	5243	89	0	\N
263173	1678	9360265862000	10447	5243	90	0	\N
263174	1678	9360265863000	10447	5243	91	0	\N
263175	1678	9360265864000	10447	5243	92	0	\N
263176	1678	9360265865000	10447	5243	93	0	\N
263177	1678	9360265866000	10447	5243	94	0	\N
263178	1678	9360265867000	10447	5243	95	0	\N
263179	1678	9360265868000	10447	5243	96	0	\N
263180	1678	9360265869000	10447	5243	97	0	\N
263181	1678	9360265870000	10447	5243	98	0	\N
263182	1678	9360265871000	10447	5243	99	0	\N
263183	2003	1384970654821	10447	5243	100	0	\N
263184	937	505421913800000	10447	5243	101	0	\N
263185	1177	611102313200000	10447	5243	102	0	\N
263186	1057	905712285400000	10447	5243	103	0	\N
263187	1303	1702888985351650	10447	5243	104	0	\N
263188	1678	9360265872000	10447	5243	105	0	\N
263189	1678	9360265873000	10447	5243	106	0	\N
263190	1678	9360265874000	10447	5243	107	0	\N
263191	1234	609337184961334	10447	5243	108	0	\N
263192	1360	1697972245136441	10447	5243	109	0	\N
263193	148	66347655311328	10447	5243	110	0	\N
263194	714	2010535009412	10447	5243	111	0	\N
263195	994	505420610261745	10447	5243	112	0	\N
263196	1114	905709403145245	10447	5243	113	0	\N
263197	1234	611100181836822	10447	5243	114	0	\N
263198	1360	1702884992686953	10447	5243	115	0	\N
263199	1374	1700567974690791	10447	5243	116	0	\N
263200	1678	9360265875000	10447	5243	117	0	\N
263201	1678	9360265876000	10447	5243	118	0	\N
263202	1678	9360265877000	10447	5243	119	0	\N
263203	1678	9360265878000	10447	5243	120	0	\N
263204	1678	9360265879000	10447	5243	121	0	\N
263205	1678	9360265880000	10447	5243	122	0	\N
263206	1678	9360265881000	10447	5243	123	0	\N
263207	1678	9360265882000	10447	5243	124	0	\N
263208	1678	9360265883000	10447	5243	125	0	\N
263209	1874	202747000	10448	5405	0	0	\N
263210	855	130585080959125	10448	5405	2	0	\N
263211	1874	202748000	10448	5405	3	0	\N
263212	857	329268330367608	10448	5405	4	0	\N
263213	861	454796316444125	10448	5405	5	0	\N
263214	865	399260132587417	10448	5405	6	0	\N
263215	867	2431584266702000	10448	5405	7	0	\N
263216	869	260039024940845	10448	5405	8	0	\N
263217	2018	200000000	10448	5405	9	0	\N
263218	2019	200000000	10448	5405	10	0	\N
263219	2020	200000000	10448	5405	11	0	\N
263220	1678	10080286096000	10448	5405	12	0	\N
263221	1678	10080286097000	10448	5405	13	0	\N
263222	1874	202747000	10449	5405	0	0	\N
263223	855	130585080959125	10449	5405	2	0	\N
263224	1874	202748000	10449	5405	3	0	\N
263225	857	329268330367608	10449	5405	4	0	\N
263226	861	454796316444125	10449	5405	5	0	\N
263227	865	399260132587417	10449	5405	6	0	\N
263228	867	2431584266702000	10449	5405	7	0	\N
263229	869	260039024940845	10449	5405	8	0	\N
263230	2018	200000000	10449	5405	9	0	\N
263231	2019	200000000	10449	5405	10	0	\N
263232	2020	200000000	10449	5405	11	0	\N
263233	1678	10080286096000	10449	5405	12	0	\N
263234	1678	10080286097000	10449	5405	13	0	\N
263235	1874	202747000	10450	5405	0	0	\N
263236	855	130585080959125	10450	5405	2	0	\N
263237	1874	202748000	10450	5405	3	0	\N
263238	857	329268330367608	10450	5405	4	0	\N
263239	861	454796316444125	10450	5405	5	0	\N
263240	865	399260132587417	10450	5405	6	0	\N
263241	867	2431584266702000	10450	5405	7	0	\N
263242	869	260039024940845	10450	5405	8	0	\N
263243	2018	200000000	10450	5405	9	0	\N
263244	2019	200000000	10450	5405	10	0	\N
263245	2020	200000000	10450	5405	11	0	\N
263246	1678	10080286096000	10450	5405	12	0	\N
263247	1678	10080286097000	10450	5405	13	0	\N
263248	1874	202747000	10451	5405	0	0	\N
263249	855	130585080959125	10451	5405	2	0	\N
263250	1874	202748000	10451	5405	3	0	\N
263251	857	329268330367608	10451	5405	4	0	\N
263252	861	454796316444125	10451	5405	5	0	\N
263253	865	399260132587417	10451	5405	6	0	\N
263254	867	2431584266702000	10451	5405	7	0	\N
263255	869	260039024940845	10451	5405	8	0	\N
263256	2018	200000000	10451	5405	9	0	\N
263257	2019	200000000	10451	5405	10	0	\N
263258	2020	200000000	10451	5405	11	0	\N
263259	1678	10080286096000	10451	5405	12	0	\N
263260	1678	10080286097000	10451	5405	13	0	\N
263261	1874	202747000	10452	5405	0	0	\N
263262	855	130585080959125	10452	5405	2	0	\N
263263	1874	202748000	10452	5405	3	0	\N
263264	857	329268330367608	10452	5405	4	0	\N
263265	861	454796316444125	10452	5405	5	0	\N
263266	865	399260132587417	10452	5405	6	0	\N
263267	867	2431584266702000	10452	5405	7	0	\N
263268	869	260039024940845	10452	5405	8	0	\N
263269	2018	200000000	10452	5405	9	0	\N
263270	2019	200000000	10452	5405	10	0	\N
263271	2020	200000000	10452	5405	11	0	\N
263272	1678	10080286096000	10452	5405	12	0	\N
263273	1678	10080286097000	10452	5405	13	0	\N
263274	1874	202747000	10453	5405	0	0	\N
263275	855	130585080959125	10453	5405	2	0	\N
263276	1874	202748000	10453	5405	3	0	\N
263277	857	329268330367608	10453	5405	4	0	\N
263278	861	454796316444125	10453	5405	5	0	\N
263279	865	399260132587417	10453	5405	6	0	\N
263280	867	2431584266702000	10453	5405	7	0	\N
263281	869	260039024940845	10453	5405	8	0	\N
263282	2018	200000000	10453	5405	9	0	\N
263283	2019	200000000	10453	5405	10	0	\N
263284	2020	200000000	10453	5405	11	0	\N
263285	1678	10080286096000	10453	5405	12	0	\N
263286	1678	10080286097000	10453	5405	13	0	\N
263287	1874	202747000	10454	5405	0	0	\N
263288	855	130585080959125	10454	5405	2	0	\N
263289	1874	202748000	10454	5405	3	0	\N
263290	857	329268330367608	10454	5405	4	0	\N
263291	861	454796316444125	10454	5405	5	0	\N
263292	865	399260132587417	10454	5405	6	0	\N
263293	867	2431584266702000	10454	5405	7	0	\N
263294	869	260039024940845	10454	5405	8	0	\N
263295	2018	200000000	10454	5405	9	0	\N
263296	2019	200000000	10454	5405	10	0	\N
263297	2020	200000000	10454	5405	11	0	\N
263298	1678	10080286096000	10454	5405	12	0	\N
263299	1678	10080286097000	10454	5405	13	0	\N
263313	1874	202747000	10456	5405	0	0	\N
263314	855	130585080959125	10456	5405	2	0	\N
263315	1874	202748000	10456	5405	3	0	\N
263316	857	329268330367608	10456	5405	4	0	\N
263317	861	454796316444125	10456	5405	5	0	\N
263318	865	399260132587417	10456	5405	6	0	\N
263319	867	2431584266702000	10456	5405	7	0	\N
263320	869	260039024940845	10456	5405	8	0	\N
263321	2018	200000000	10456	5405	9	0	\N
263322	2019	200000000	10456	5405	10	0	\N
263323	2020	200000000	10456	5405	11	0	\N
263324	1678	10080286096000	10456	5405	12	0	\N
263325	1678	10080286097000	10456	5405	13	0	\N
263326	1483	0	10457	5406	0	0	\N
263327	1678	10080286098000	10457	5406	1	0	\N
263328	873	2431584266702000	10457	5406	2	0	\N
263329	1874	202749000	10457	5406	3	0	\N
263330	875	213138867772583	10457	5406	4	0	\N
263331	879	135088014785750	10457	5406	5	0	\N
263337	1874	202747000	10459	5405	0	0	\N
263338	855	130585080959125	10459	5405	2	0	\N
263339	1874	202748000	10459	5405	3	0	\N
263340	857	329268330367608	10459	5405	4	0	\N
263341	861	454796316444125	10459	5405	5	0	\N
263342	865	399260132587417	10459	5405	6	0	\N
263343	867	2431584266702000	10459	5405	7	0	\N
263344	869	260039024940845	10459	5405	8	0	\N
263345	2018	200000000	10459	5405	9	0	\N
263346	2019	200000000	10459	5405	10	0	\N
263347	2020	200000000	10459	5405	11	0	\N
263348	1678	10080286096000	10459	5405	12	0	\N
263349	1678	10080286097000	10459	5405	13	0	\N
263350	1483	0	10460	5406	0	0	\N
263351	1678	10080286098000	10460	5406	1	0	\N
263352	873	2431584266702000	10460	5406	2	0	\N
263353	1874	202749000	10460	5406	3	0	\N
263354	875	213138867772583	10460	5406	4	0	\N
263360	1483	0	10462	5406	0	0	\N
263361	1678	10080286098000	10462	5406	1	0	\N
263362	873	2431584266702000	10462	5406	2	0	\N
263363	1874	202749000	10462	5406	3	0	\N
263364	875	213138867772583	10462	5406	4	0	\N
263365	1678	10080286099000	10463	5407	0	0	\N
263366	879	135088014785750	10463	5407	1	0	\N
263367	881	585381397403250	10463	5407	2	0	\N
263368	883	90058676523500	10463	5407	3	0	\N
263369	1874	202750000	10463	5407	4	0	\N
263386	901	117076279480250	10467	5409	0	0	\N
263387	1874	202753000	10467	5409	1	0	\N
263388	1874	202754000	10467	5409	2	0	\N
263389	1874	202755000	10467	5409	3	0	\N
263390	1678	10080286102000	10467	5409	4	0	\N
263391	905	421024312747938	10467	5409	5	0	\N
263392	2022	0	10467	5409	6	0	\N
263393	1678	10080286103000	10467	5409	7	0	\N
263394	1678	10080286104000	10467	5409	8	0	\N
263395	901	117076279480250	10468	5409	0	0	\N
263396	1874	202753000	10468	5409	1	0	\N
263397	1874	202754000	10468	5409	2	0	\N
263398	1874	202755000	10468	5409	3	0	\N
263399	1678	10080286102000	10468	5409	4	0	\N
263400	905	421024312747938	10468	5409	5	0	\N
263401	2022	0	10468	5409	6	0	\N
263402	1678	10080286103000	10468	5409	7	0	\N
263403	1678	10080286104000	10468	5409	8	0	\N
263429	1678	10080286109000	10472	5412	0	0	\N
263430	1874	202760000	10472	5412	1	0	\N
263302	1874	202748000	10455	5405	3	0	0
263303	857	329268330367608	10455	5405	4	0	0
263304	861	454796316444125	10455	5405	5	0	0
263305	865	399260132587417	10455	5405	6	0	0
263306	867	2431584266702000	10455	5405	7	0	0
263308	2018	200000000	10455	5405	9	0	0
263309	2019	200000000	10455	5405	10	0	0
263310	2020	200000000	10455	5405	11	0	0
263311	1678	10080286096000	10455	5405	12	0	0
263312	1678	10080286097000	10455	5405	13	0	0
263333	1678	10080286098000	10458	5406	1	0	0
263334	873	2431584266702000	10458	5406	2	0	0
263335	1874	202749000	10458	5406	3	0	0
263336	875	213138867772583	10458	5406	4	0	0
263356	879	135088014785750	10461	5407	1	0	0
263357	881	585381397403250	10461	5407	2	0	0
263358	883	90058676523500	10461	5407	3	0	0
263359	1874	202750000	10461	5407	4	0	0
263370	1874	202751000	10465	5408	0	0	0
263372	897	65339370990885	10465	5408	2	0	0
263373	899	38948576422990	10465	5408	3	0	0
263374	1678	10080286100000	10465	5408	4	0	0
263375	1874	202752000	10465	5408	5	0	0
263376	1678	10080286101000	10465	5408	6	0	0
263378	1874	202753000	10466	5409	1	0	0
263379	1874	202754000	10466	5409	2	0	0
263380	1874	202755000	10466	5409	3	0	0
263381	1678	10080286102000	10466	5409	4	0	0
263383	2022	0	10466	5409	6	0	0
263384	1678	10080286103000	10466	5409	7	0	0
263385	1678	10080286104000	10466	5409	8	0	0
263404	1874	202756000	10469	5410	0	0	0
263405	1678	10080286105000	10469	5410	1	0	0
263407	1874	202757000	10469	5410	3	0	0
263408	295	66000100665601	10470	5411	0	0	1
263409	1345	1703125874149650	10470	5411	1	0	0
263410	1099	905837520198000	10470	5411	2	0	0
263411	1678	10080286107000	10470	5411	3	0	0
263413	1219	611186624965000	10470	5411	5	0	0
263414	979	505492104495000	10470	5411	6	0	0
263415	1874	202758000	10470	5411	7	0	0
263416	1874	202759000	10470	5411	8	0	0
263418	1406	0	10470	5411	10	0	0
263419	1406	0	10470	5411	11	0	0
263420	1406	0	10470	5411	12	0	0
263421	1406	0	10470	5411	13	0	0
263422	1406	0	10470	5411	14	0	0
263424	1406	0	10470	5411	16	0	0
263425	1406	0	10470	5411	17	0	0
263426	1406	0	10470	5411	18	0	0
263427	1678	10080286109000	10471	5412	0	0	0
263428	1874	202760000	10471	5412	1	0	0
263432	1874	202761000	10473	5413	1	0	0
263439	1874	202763000	10476	5415	0	0	\N
263440	1874	202764000	10476	5415	1	0	\N
263441	1678	10080286112000	10476	5415	2	0	\N
263442	1678	10080286113000	10476	5415	3	0	\N
263443	480	66001010000000	10476	5415	4	0	\N
263449	2023	1000000000	10478	5412	0	0	\N
263450	480	66001010000000	10478	5412	1	0	\N
263453	1678	10080286116000	10480	5418	0	0	\N
263454	1678	10080286117000	10480	5418	1	0	\N
263455	1678	10080286118000	10480	5418	2	0	\N
263456	1874	202767000	10480	5418	3	0	\N
263457	1874	202768000	10480	5418	4	0	\N
263458	1874	202769000	10480	5418	5	0	\N
263459	1678	10080286116000	10481	5418	0	0	\N
263460	1678	10080286117000	10481	5418	1	0	\N
263461	1678	10080286118000	10481	5418	2	0	\N
263462	1874	202767000	10481	5418	3	0	\N
263463	1874	202768000	10481	5418	4	0	\N
263464	1874	202769000	10481	5418	5	0	\N
263480	1874	202770000	10484	5419	0	0	\N
263481	1678	10080286119000	10484	5419	1	0	\N
263482	1678	10080286120000	10484	5419	2	0	\N
263483	1678	10080286121000	10484	5419	3	0	\N
263484	1678	10080286122000	10484	5419	4	0	\N
263485	1678	10080286123000	10484	5419	5	0	\N
263486	1874	202771000	10484	5419	6	0	\N
263487	1874	202772000	10484	5419	7	0	\N
263488	1874	202773000	10484	5419	8	0	\N
263489	1678	10080286124000	10485	5420	0	0	\N
263490	1874	202774000	10485	5420	1	0	\N
263491	1678	10080286124000	10486	5420	0	0	\N
263492	1874	202774000	10486	5420	1	0	\N
263495	1678	10080286124000	10488	5420	0	0	\N
263496	1874	202774000	10488	5420	1	0	\N
263497	1678	10080286124000	10489	5420	0	0	\N
263498	1874	202774000	10489	5420	1	0	\N
263499	1874	202770000	10490	5419	0	0	\N
263500	1678	10080286119000	10490	5419	1	0	\N
263501	1678	10080286120000	10490	5419	2	0	\N
263502	1678	10080286121000	10490	5419	3	0	\N
263503	1678	10080286122000	10490	5419	4	0	\N
263504	1678	10080286123000	10490	5419	5	0	\N
263505	1678	10080286124000	10490	5419	6	0	\N
263506	1874	202771000	10490	5419	7	0	\N
263507	1874	202772000	10490	5419	8	0	\N
263508	1874	202773000	10490	5419	9	0	\N
263509	1874	202774000	10490	5419	10	0	\N
263510	556	66419564339290	10492	5422	0	0	\N
263511	1874	202775000	10492	5422	1	0	\N
263512	1874	202776000	10492	5422	2	0	\N
263513	1874	202777000	10492	5422	3	0	\N
263514	1874	202778000	10492	5422	4	0	\N
263515	1678	10080286125000	10492	5422	5	0	\N
263516	1678	10080286126000	10492	5422	6	0	\N
263517	1678	10080286127000	10492	5422	7	0	\N
263518	1678	10080286128000	10492	5422	8	0	\N
263519	1678	10080286129000	10492	5422	9	0	\N
263520	930	505969095140680	10492	5422	10	0	\N
263521	1050	906692283348880	10492	5422	11	0	\N
263522	1170	611763350695495	10492	5422	12	0	\N
263523	1296	1704732971677270	10492	5422	13	0	\N
263524	451	66176478352080	10492	5422	14	0	\N
263525	487	66176478352080	10492	5422	15	0	\N
263526	744	2005347828843	10492	5422	16	0	\N
263527	988	504121261499270	10492	5422	17	0	\N
263528	1108	903380981295700	10492	5422	18	0	\N
263529	1228	609529149217850	10492	5422	19	0	\N
263530	1354	1698507170605750	10492	5422	20	0	\N
263531	1874	202779000	10492	5422	21	0	\N
263532	556	66419564339290	10493	5422	0	0	\N
263533	1874	202775000	10493	5422	1	0	\N
263534	1874	202776000	10493	5422	2	0	\N
263535	1874	202777000	10493	5422	3	0	\N
263536	1874	202778000	10493	5422	4	0	\N
263537	1678	10080286125000	10493	5422	5	0	\N
263538	1678	10080286126000	10493	5422	6	0	\N
263539	1678	10080286127000	10493	5422	7	0	\N
263540	1678	10080286128000	10493	5422	8	0	\N
263541	1678	10080286129000	10493	5422	9	0	\N
263542	930	505969095140680	10493	5422	10	0	\N
263543	1050	906692283348880	10493	5422	11	0	\N
263544	1170	611763350695495	10493	5422	12	0	\N
263545	1296	1704732971677270	10493	5422	13	0	\N
263546	451	66176478352080	10493	5422	14	0	\N
263547	487	66176478352080	10493	5422	15	0	\N
263548	744	2005347828843	10493	5422	16	0	\N
263549	988	504121261499270	10493	5422	17	0	\N
263550	1108	903380981295700	10493	5422	18	0	\N
263551	1228	609529149217850	10493	5422	19	0	\N
263552	1354	1698507170605750	10493	5422	20	0	\N
263553	1874	202779000	10493	5422	21	0	\N
263435	1874	202762000	10474	5414	1	0	0
263436	1874	202763000	10475	5415	0	0	0
263437	1678	10080286112000	10475	5415	1	0	0
263438	480	66001010000000	10475	5415	2	0	0
263444	2023	1000000000	10477	5416	0	0	0
263446	1874	202765000	10477	5416	2	0	0
263447	1678	10080286113000	10477	5416	3	0	0
263448	1678	10080286114000	10477	5416	4	0	0
263451	1678	10080286115000	10479	5417	0	0	0
263452	1874	202766000	10479	5417	1	0	0
263466	1678	10080286117000	10482	5418	1	0	0
263467	1678	10080286118000	10482	5418	2	0	0
263468	1874	202767000	10482	5418	3	0	0
263469	1874	202768000	10482	5418	4	0	0
263471	1874	202770000	10483	5419	0	0	0
263472	1678	10080286119000	10483	5419	1	0	0
263473	1678	10080286120000	10483	5419	2	0	0
263474	1678	10080286121000	10483	5419	3	0	0
263475	1678	10080286122000	10483	5419	4	0	0
263477	1874	202771000	10483	5419	6	0	0
263478	1874	202772000	10483	5419	7	0	0
263479	1874	202773000	10483	5419	8	0	0
263493	1678	10080286124000	10487	5420	0	0	0
263494	1874	202774000	10487	5420	1	0	0
263555	1874	202775000	10494	5422	1	0	0
263556	1874	202776000	10494	5422	2	0	0
263557	1874	202777000	10494	5422	3	0	0
263558	1874	202778000	10494	5422	4	0	0
263560	1678	10080286126000	10494	5422	6	0	0
263561	1678	10080286127000	10494	5422	7	0	0
263562	1678	10080286128000	10494	5422	8	0	0
263563	1678	10080286129000	10494	5422	9	0	0
263564	930	505969095140680	10494	5422	10	0	0
263566	1170	611763350695495	10494	5422	12	0	0
263567	1296	1704732971677270	10494	5422	13	0	0
263568	451	66176478352080	10494	5422	14	0	0
263588	451	66305884206092	10497	5424	0	0	\N
263589	1874	202781000	10497	5424	1	0	\N
263590	1937	1400000000	10497	5424	2	0	\N
263591	487	66305884206092	10497	5424	3	0	\N
263592	744	2009269218353	10497	5424	4	0	\N
263593	988	505106484932068	10497	5424	5	0	\N
263594	1108	905146493245880	10497	5424	6	0	\N
263595	1228	610720375310940	10497	5424	7	0	\N
263596	1354	1701826628032090	10497	5424	8	0	\N
263597	1678	10080286130000	10497	5424	9	0	\N
263598	1678	10080286131000	10497	5424	10	0	\N
263599	451	66305884206092	10498	5424	0	0	\N
263600	1874	202781000	10498	5424	1	0	\N
263601	1937	1400000000	10498	5424	2	0	\N
263602	487	66305884206092	10498	5424	3	0	\N
263603	744	2009269218353	10498	5424	4	0	\N
263604	988	505106484932068	10498	5424	5	0	\N
263605	1108	905146493245880	10498	5424	6	0	\N
263606	1228	610720375310940	10498	5424	7	0	\N
263607	1354	1701826628032090	10498	5424	8	0	\N
263608	1678	10080286130000	10498	5424	9	0	\N
263609	1678	10080286131000	10498	5424	10	0	\N
263610	451	66305884206092	10499	5424	0	0	\N
263611	1874	202781000	10499	5424	1	0	\N
263612	1937	1400000000	10499	5424	2	0	\N
263613	487	66305884206092	10499	5424	3	0	\N
263614	744	2009269218353	10499	5424	4	0	\N
263615	988	505106484932068	10499	5424	5	0	\N
263616	1108	905146493245880	10499	5424	6	0	\N
263617	1228	610720375310940	10499	5424	7	0	\N
263618	1354	1701826628032090	10499	5424	8	0	\N
263619	1678	10080286130000	10499	5424	9	0	\N
263620	1678	10080286131000	10499	5424	10	0	\N
263621	451	66305884206092	10500	5424	0	0	\N
263622	1874	202781000	10500	5424	1	0	\N
263623	1937	1400000000	10500	5424	2	0	\N
263624	487	66305884206092	10500	5424	3	0	\N
263625	744	2009269218353	10500	5424	4	0	\N
263626	988	505106484932068	10500	5424	5	0	\N
263627	1108	905146493245880	10500	5424	6	0	\N
263628	1228	610720375310940	10500	5424	7	0	\N
263629	1354	1701826628032090	10500	5424	8	0	\N
263630	1678	10080286130000	10500	5424	9	0	\N
263631	1678	10080286131000	10500	5424	10	0	\N
263638	1678	10080286135000	10503	5427	0	0	\N
263639	1874	202785000	10503	5427	1	0	\N
263642	1874	202786000	10505	5428	0	0	\N
263643	1874	202787000	10505	5428	1	0	\N
263644	1874	202788000	10505	5428	2	0	\N
263645	1874	202789000	10505	5428	3	0	\N
263646	1874	202790000	10505	5428	4	0	\N
263647	1678	10080286136000	10505	5428	5	0	\N
263648	1678	10080286137000	10505	5428	6	0	\N
263649	1678	10080286138000	10505	5428	7	0	\N
263650	1678	10080286139000	10505	5428	8	0	\N
263651	1874	202786000	10506	5428	0	0	\N
263652	1874	202787000	10506	5428	1	0	\N
263653	1874	202788000	10506	5428	2	0	\N
263654	1874	202789000	10506	5428	3	0	\N
263655	1874	202790000	10506	5428	4	0	\N
263656	1678	10080286136000	10506	5428	5	0	\N
263657	1678	10080286137000	10506	5428	6	0	\N
263658	1678	10080286138000	10506	5428	7	0	\N
263659	1678	10080286139000	10506	5428	8	0	\N
263669	1874	202791000	10508	5429	0	0	\N
263670	1678	10080286140000	10509	5429	0	0	\N
263671	1874	202791000	10509	5429	1	0	\N
263674	1678	10080286140000	10511	5429	0	0	\N
263675	1874	202791000	10511	5429	1	0	\N
263676	1678	10080286140000	10512	5429	0	0	\N
263677	1874	202791000	10512	5429	1	0	\N
263678	1678	10080286140000	10513	5429	0	0	\N
263679	1874	202791000	10513	5429	1	0	\N
263680	1874	202792000	10513	5429	2	0	\N
263681	1678	10080286141000	10513	5429	3	0	\N
263688	1874	202792000	10515	5430	0	0	\N
263689	1678	10080286141000	10515	5430	1	0	\N
263690	1678	10080286142000	10515	5430	2	0	\N
263691	1678	10080286143000	10515	5430	3	0	\N
263692	1874	202793000	10515	5430	4	0	\N
263693	1874	202794000	10515	5430	5	0	\N
263696	1678	10080286145000	10517	5432	0	0	\N
263697	1874	202796000	10517	5432	1	0	\N
263698	1678	10080286145000	10518	5432	0	0	\N
263699	1874	202796000	10518	5432	1	0	\N
263704	1874	202798000	10521	5434	0	0	\N
263571	988	504121261499270	10494	5422	17	0	0
263572	1108	903380981295700	10494	5422	18	0	0
263573	1228	609529149217850	10494	5422	19	0	0
263574	1354	1698507170605750	10494	5422	20	0	0
263575	1874	202779000	10494	5422	21	0	0
263577	451	66305884206092	10496	5424	0	0	0
263578	1874	202781000	10496	5424	1	0	0
263579	1937	1400000000	10496	5424	2	0	0
263580	487	66305884206092	10496	5424	3	0	0
263581	744	2009269218353	10496	5424	4	0	0
263583	1108	905146493245880	10496	5424	6	0	0
263584	1228	610720375310940	10496	5424	7	0	0
263585	1354	1701826628032090	10496	5424	8	0	0
263586	1678	10080286130000	10496	5424	9	0	0
263632	1874	202782000	10501	5425	0	0	0
263633	1678	10080286132000	10501	5425	1	0	0
263634	1874	202783000	10502	5426	0	0	0
263635	1874	202784000	10502	5426	1	0	0
263636	1678	10080286133000	10502	5426	2	0	0
263640	1678	10080286135000	10504	5427	0	0	0
263641	1874	202785000	10504	5427	1	0	0
263660	1874	202786000	10507	5428	0	0	0
263661	1874	202787000	10507	5428	1	0	0
263662	1874	202788000	10507	5428	2	0	0
263664	1874	202790000	10507	5428	4	0	0
263665	1678	10080286136000	10507	5428	5	0	0
263666	1678	10080286137000	10507	5428	6	0	0
263667	1678	10080286138000	10507	5428	7	0	0
263672	1678	10080286140000	10510	5429	0	0	0
263673	1874	202791000	10510	5429	1	0	0
263682	1874	202792000	10514	5430	0	0	0
263683	1678	10080286141000	10514	5430	1	0	0
263684	1678	10080286142000	10514	5430	2	0	0
263686	1874	202793000	10514	5430	4	0	0
263687	1874	202794000	10514	5430	5	0	0
263694	1874	202795000	10516	5431	0	0	0
263695	1678	10080286144000	10516	5431	1	0	0
263700	1678	10080286145000	10519	5432	0	0	0
263702	1678	10080286146000	10520	5433	0	0	0
263703	1874	202797000	10520	5433	1	0	0
263705	1874	202799000	10521	5434	1	0	\N
263706	1678	10080286147000	10521	5434	2	0	\N
263707	1678	10080286148000	10521	5434	3	0	\N
263708	1874	202798000	10522	5434	0	0	\N
263709	1874	202799000	10522	5434	1	0	\N
263710	1678	10080286147000	10522	5434	2	0	\N
263711	1678	10080286148000	10522	5434	3	0	\N
263712	1874	202798000	10523	5434	0	0	\N
263713	1874	202799000	10523	5434	1	0	\N
263714	1678	10080286147000	10523	5434	2	0	\N
263715	1678	10080286148000	10523	5434	3	0	\N
263728	1678	10800326149000	10526	5435	0	0	\N
263729	1874	202800000	10526	5435	1	0	\N
263730	1874	202801000	10526	5435	2	0	\N
263731	1678	10800326150000	10526	5435	3	0	\N
263732	1678	10800326151000	10526	5435	4	0	\N
263733	1678	10800326152000	10526	5435	5	0	\N
263734	1874	202802000	10526	5435	6	0	\N
263735	1874	202803000	10526	5435	7	0	\N
263736	1874	202786000	10527	5428	0	0	\N
263737	1874	202787000	10527	5428	1	0	\N
263738	1874	202788000	10527	5428	2	0	\N
263739	1874	202789000	10527	5428	3	0	\N
263740	1874	202790000	10527	5428	4	0	\N
263741	1874	202791000	10527	5428	5	0	\N
263742	1874	202792000	10527	5428	6	0	\N
263743	1874	202793000	10527	5428	7	0	\N
263744	1874	202794000	10527	5428	8	0	\N
263745	1874	202795000	10527	5428	9	0	\N
263746	1874	202796000	10527	5428	10	0	\N
263747	1874	202797000	10527	5428	11	0	\N
263748	1874	202798000	10527	5428	12	0	\N
263749	1874	202799000	10527	5428	13	0	\N
263750	1874	202800000	10527	5428	14	0	\N
263751	1874	202801000	10527	5428	15	0	\N
263752	1678	10080286136000	10527	5428	16	0	\N
263753	1678	10080286137000	10527	5428	17	0	\N
263754	1874	202802000	10527	5428	18	0	\N
263755	1874	202803000	10527	5428	19	0	\N
263756	1874	202804000	10527	5428	20	0	\N
263757	1874	202805000	10527	5428	21	0	\N
263758	1678	10080286138000	10527	5428	22	0	\N
263759	1678	10080286139000	10527	5428	23	0	\N
263760	1678	10080286140000	10527	5428	24	0	\N
263761	1678	10080286141000	10527	5428	25	0	\N
263762	1678	10080286142000	10527	5428	26	0	\N
263763	1678	10080286143000	10527	5428	27	0	\N
263764	1678	10080286144000	10527	5428	28	0	\N
263765	1678	10080286145000	10527	5428	29	0	\N
263766	1678	10080286146000	10527	5428	30	0	\N
263767	1678	10080286147000	10527	5428	31	0	\N
263768	1678	10080286148000	10527	5428	32	0	\N
263769	1678	10080286149000	10527	5428	33	0	\N
263770	1678	10080286150000	10527	5428	34	0	\N
263771	1678	10080286151000	10527	5428	35	0	\N
263772	1678	10080286152000	10527	5428	36	0	\N
263773	1678	10080286153000	10527	5428	37	0	\N
263774	1678	10080286154000	10527	5428	38	0	\N
263779	1874	202804000	10529	5436	0	0	\N
263780	1874	202805000	10529	5436	1	0	\N
263781	1678	10800326153000	10529	5436	2	0	\N
263782	1678	10800326154000	10529	5436	3	0	\N
263791	1874	202807000	10532	5438	0	0	\N
263792	1678	10800326156000	10532	5438	1	0	\N
263793	1678	10800326157000	10532	5438	2	0	\N
263794	563	66000527000000	10532	5438	3	0	\N
263802	1874	202810000	10535	5440	0	0	\N
263803	1678	10800326160000	10535	5440	1	0	\N
263815	1678	10800326166000	10541	5446	0	0	\N
263816	1874	202816000	10541	5446	1	0	\N
263819	1678	10800326166000	10543	5446	0	0	\N
263820	1874	202816000	10543	5446	1	0	\N
263821	1678	10800326166000	10544	5446	0	0	\N
263822	1874	202816000	10544	5446	1	0	\N
263823	1874	202815000	10545	5445	0	0	\N
263824	1874	202816000	10545	5445	1	0	\N
263825	1678	10800326165000	10545	5445	2	0	\N
263826	1678	10800326166000	10545	5445	3	0	\N
263827	1678	10800326166000	10546	5446	0	0	\N
263828	1874	202816000	10546	5446	1	0	\N
263829	1874	202817000	10547	5447	0	0	\N
263830	1874	202818000	10547	5447	1	0	\N
263831	1678	10800326167000	10547	5447	2	0	\N
263832	1678	10800326168000	10547	5447	3	0	\N
263833	2025	999000000000	10547	5447	4	0	\N
263834	1874	202817000	10548	5447	0	0	\N
263835	1874	202818000	10548	5447	1	0	\N
263836	1678	10800326167000	10548	5447	2	0	\N
263837	1678	10800326168000	10548	5447	3	0	\N
263838	2025	999000000000	10548	5447	4	0	\N
263718	1678	10080286147000	10524	5434	2	0	0
263719	1678	10080286148000	10524	5434	3	0	0
263720	1678	10800326149000	10525	5435	0	0	0
263721	1874	202800000	10525	5435	1	0	0
263722	1874	202801000	10525	5435	2	0	0
263724	1678	10800326151000	10525	5435	4	0	0
263725	1678	10800326152000	10525	5435	5	0	0
263726	1874	202802000	10525	5435	6	0	0
263727	1874	202803000	10525	5435	7	0	0
263775	1874	202804000	10528	5436	0	0	0
263777	1678	10800326153000	10528	5436	2	0	0
263778	1678	10800326154000	10528	5436	3	0	0
263783	1874	202806000	10530	5437	0	0	0
263784	1678	10800326155000	10530	5437	1	0	0
263786	2024	3000000000	10530	5437	3	0	0
263787	1874	202807000	10531	5438	0	0	0
263788	1678	10800326156000	10531	5438	1	0	0
263789	1678	10800326157000	10531	5438	2	0	0
263790	563	66000527000000	10531	5438	3	0	3
263796	1678	10800326158000	10533	5439	1	0	0
263797	1678	10800326159000	10533	5439	2	0	0
263798	1874	202809000	10533	5439	3	0	0
263799	1483	0	10533	5439	5	0	0
263800	1874	202810000	10534	5440	0	0	0
263804	1874	202811000	10536	5441	0	0	0
263805	1678	10800326161000	10536	5441	1	0	0
263806	1874	202812000	10537	5442	0	0	0
263807	1678	10800326162000	10537	5442	1	0	0
263809	1874	202813000	10538	5443	1	0	0
263810	1678	10800326164000	10539	5444	0	0	0
263811	1874	202814000	10539	5444	1	0	0
263812	2025	1000000000	10539	5444	2	0	0
263813	1874	202815000	10540	5445	0	0	0
263817	1678	10800326166000	10542	5446	0	0	0
263818	1874	202816000	10542	5446	1	0	0
263839	1874	202817000	10549	5447	0	0	0
263840	1874	202818000	10549	5447	1	0	0
263846	1874	202806000	10551	5429	0	0	\N
263847	1874	202807000	10551	5429	1	0	\N
263848	1874	202808000	10551	5429	2	0	\N
263849	1874	202809000	10551	5429	3	0	\N
263850	1874	202810000	10551	5429	4	0	\N
263851	1874	202811000	10551	5429	5	0	\N
263852	1874	202812000	10551	5429	6	0	\N
263853	1678	10080286155000	10551	5429	7	0	\N
263854	1678	10080286156000	10551	5429	8	0	\N
263855	1678	10080286157000	10551	5429	9	0	\N
263856	1678	10080286158000	10551	5429	10	0	\N
263857	1678	10080286159000	10551	5429	11	0	\N
263858	1678	10080286160000	10551	5429	12	0	\N
263859	1678	10080286161000	10551	5429	13	0	\N
263860	1678	10080286162000	10551	5429	14	0	\N
263861	1678	10080286163000	10551	5429	15	0	\N
263862	1678	10080286164000	10551	5429	16	0	\N
263863	1678	10080286165000	10551	5429	17	0	\N
263864	1678	10080286166000	10551	5429	18	0	\N
263865	1678	10080286167000	10551	5429	19	0	\N
263866	1678	10080286168000	10551	5429	20	0	\N
263867	1678	10080286169000	10551	5429	21	0	\N
263868	1678	10080286170000	10551	5429	22	0	\N
263869	1678	10080286171000	10551	5429	23	0	\N
263870	1678	10080286172000	10551	5429	24	0	\N
263871	1874	202813000	10551	5429	25	0	\N
263872	1874	202814000	10551	5429	26	0	\N
263873	1874	202815000	10551	5429	27	0	\N
263874	1874	202816000	10551	5429	28	0	\N
263875	1874	202817000	10551	5429	29	0	\N
263876	1874	202818000	10551	5429	30	0	\N
263877	1874	202819000	10551	5429	31	0	\N
263878	1874	202820000	10551	5429	33	0	\N
263879	1874	202821000	10551	5429	34	0	\N
263880	1874	202822000	10551	5429	35	0	\N
263881	1874	202823000	10551	5429	36	0	\N
263882	563	66000527000000	10551	5429	37	0	\N
263883	1483	0	10551	5429	38	0	\N
263884	2024	1000000000	10551	5429	39	0	\N
263885	2024	3000000000	10551	5429	40	0	\N
263886	2025	1000000000	10551	5429	41	0	\N
263887	2025	999000000000	10551	5429	42	0	\N
263888	1874	202820000	10552	5449	0	0	\N
263889	1874	202821000	10552	5449	1	0	\N
263890	1874	202822000	10552	5449	2	0	\N
263891	1874	202823000	10552	5449	3	0	\N
263892	1678	10800326170000	10552	5449	4	0	\N
263893	1678	10800326171000	10552	5449	5	0	\N
263894	1678	10800326172000	10552	5449	6	0	\N
263904	1874	202820000	10555	5449	0	0	\N
263905	1874	202821000	10555	5449	1	0	\N
263906	1874	202822000	10555	5449	2	0	\N
263907	1874	202823000	10555	5449	3	0	\N
263908	1874	202824000	10555	5449	4	0	\N
263909	1678	10800326170000	10555	5449	5	0	\N
263910	1678	10800326171000	10555	5449	6	0	\N
263911	1678	10800326172000	10555	5449	7	0	\N
263912	1678	10800326173000	10555	5449	8	0	\N
263913	1678	10800326173000	10556	5450	0	0	\N
263914	1874	202824000	10556	5450	1	0	\N
263915	1678	10800326174000	10556	5450	2	0	\N
263920	2023	1000000000	10558	5296	0	0	\N
263921	2017	343200000000	10558	5296	1	0	\N
263922	556	66419564339290	10558	5296	2	0	\N
263923	1	374067383793000	10558	5296	3	0	\N
263924	1393	75746941148850000	10558	5296	4	0	\N
263925	1678	10080285993000	10558	5296	5	0	\N
263926	1678	10080285994000	10558	5296	6	0	\N
263927	1678	10080285995000	10558	5296	7	0	\N
263928	1678	10080285996000	10558	5296	8	0	\N
263929	2016	1004000000000	10558	5296	9	0	\N
263930	40	66264692170000	10558	5296	11	0	\N
263931	1395	57867290193533700	10558	5296	12	0	\N
263932	31	1323893248766000	10558	5296	13	0	\N
263933	32	73922280157000	10558	5296	14	0	\N
263934	930	505969095140680	10558	5296	15	0	\N
263935	480	66001000000000	10558	5296	16	0	\N
263936	1290	1700432637751650	10558	5296	17	0	\N
263937	1050	906692283348880	10558	5296	18	0	\N
263938	1170	611763350695495	10558	5296	19	0	\N
263939	1296	1704732971677270	10558	5296	20	0	\N
263940	779	27889620396792	10558	5296	21	0	\N
263941	780	306785556632051	10558	5296	22	0	\N
263942	2022	0	10558	5296	23	0	\N
263943	1345	1703125874149650	10558	5296	24	0	\N
263944	1099	905837520198000	10558	5296	25	0	\N
263945	1219	611186624965000	10558	5296	26	0	\N
263946	979	505492104495000	10558	5296	27	0	\N
263947	841	83729352737298	10558	5296	28	0	\N
263948	843	156101705973667	10558	5296	29	0	\N
263949	849	1155748212256640	10558	5296	30	0	\N
263950	851	2238858698375750	10558	5296	31	0	\N
263951	853	246870194966225	10558	5296	32	0	\N
263952	855	130585080959125	10558	5296	33	0	\N
263953	857	329268330367608	10558	5296	34	0	\N
263954	861	454796316444125	10558	5296	35	0	\N
263955	865	399260132587417	10558	5296	36	0	\N
263956	867	2431584266702000	10558	5296	37	0	\N
263957	869	260039024940845	10558	5296	38	0	\N
263958	873	2431584266702000	10558	5296	39	0	\N
263959	875	213138867772583	10558	5296	40	0	\N
263960	879	135088014785750	10558	5296	41	0	\N
263961	881	585381397403250	10558	5296	42	0	\N
263962	883	90058676523500	10558	5296	43	0	\N
263963	887	268788225365154	10558	5296	44	0	\N
263964	889	225633308357249	10558	5296	45	0	\N
263965	899	38948576422990	10558	5296	46	0	\N
263966	901	117076279480250	10558	5296	47	0	\N
263967	905	421024312747938	10558	5296	48	0	\N
263968	782	2454234815297720	10558	5296	49	0	\N
263969	785	223112450651807	10558	5296	50	0	\N
263970	786	2454234815297720	10558	5296	51	0	\N
263971	792	613571113264101	10558	5296	52	0	\N
263972	791	55779240794584	10558	5296	53	0	\N
263973	799	13943560758181	10558	5296	54	0	\N
263974	800	153379034487607	10558	5296	55	0	\N
263975	801	13946140510666	10558	5296	56	0	\N
263976	802	153407411737275	10558	5296	57	0	\N
263843	2025	999000000000	10549	5447	4	0	0
263844	1678	10800326169000	10550	5448	0	0	0
263845	1874	202819000	10550	5448	1	0	0
263895	1874	202820000	10553	5449	0	0	0
263896	1874	202821000	10553	5449	1	0	0
263898	1874	202823000	10553	5449	3	0	0
263899	1678	10800326170000	10553	5449	4	0	0
263900	1678	10800326171000	10553	5449	5	0	0
263901	1678	10800326172000	10553	5449	6	0	0
263902	1678	10800326173000	10554	5450	0	0	0
263916	1678	10800326174000	10557	5451	0	0	0
263917	1678	10800326175000	10557	5451	1	0	0
263918	1874	202825000	10557	5451	2	0	0
263919	1874	202826000	10557	5451	3	0	0
263977	811	107931214459286	10558	5296	58	0	\N
263978	812	1187242322919140	10558	5296	59	0	\N
263979	823	1731919963467760	10558	5296	60	0	\N
263980	824	19051102971730700	10558	5296	61	0	\N
263981	451	66176478352080	10558	5296	62	0	\N
263982	487	66176478352080	10558	5296	63	0	\N
263983	744	2005347828843	10558	5296	64	0	\N
263984	988	504121261499270	10558	5296	65	0	\N
263985	1108	903380981295700	10558	5296	66	0	\N
263986	1228	609529149217850	10558	5296	67	0	\N
263987	1354	1698507170605750	10558	5296	68	0	\N
263988	451	66305884206092	10558	5296	69	0	\N
263989	487	66305884206092	10558	5296	70	0	\N
263990	744	2009269218353	10558	5296	71	0	\N
263991	988	505106484932068	10558	5296	72	0	\N
263992	1108	905146493245880	10558	5296	73	0	\N
263993	1228	610720375310940	10558	5296	74	0	\N
263994	1354	1701826628032090	10558	5296	75	0	\N
263995	1678	10080285997000	10558	5296	76	0	\N
263996	1678	10080285998000	10558	5296	77	0	\N
263997	1678	10080285999000	10558	5296	78	0	\N
263998	1678	10080286000000	10558	5296	79	0	\N
263999	1678	10080286001000	10558	5296	80	0	\N
264000	1678	10080286002000	10558	5296	81	0	\N
264001	1678	10080286003000	10558	5296	82	0	\N
264002	1678	10080286004000	10558	5296	83	0	\N
264003	1678	10080286005000	10558	5296	84	0	\N
264004	1678	10080286006000	10558	5296	85	0	\N
264005	1678	10080286007000	10558	5296	86	0	\N
264006	1678	10080286008000	10558	5296	87	0	\N
264007	1678	10080286009000	10558	5296	88	0	\N
264008	1678	10080286010000	10558	5296	89	0	\N
264009	1678	10080286011000	10558	5296	90	0	\N
264010	1678	10080286012000	10558	5296	91	0	\N
264011	1678	10080286013000	10558	5296	92	0	\N
264012	1678	10080286014000	10558	5296	93	0	\N
264013	1678	10080286015000	10558	5296	94	0	\N
264014	1678	10080286016000	10558	5296	95	0	\N
264015	1678	10080286017000	10558	5296	96	0	\N
264016	1678	10080286018000	10558	5296	97	0	\N
264017	1678	10080286019000	10558	5296	98	0	\N
264018	1678	10080286020000	10558	5296	99	0	\N
264019	1678	10080286021000	10558	5296	100	0	\N
264020	1678	10080286022000	10558	5296	101	0	\N
264021	1678	10080286023000	10558	5296	102	0	\N
264022	1678	10080286024000	10558	5296	103	0	\N
264023	1678	10080286025000	10558	5296	104	0	\N
264024	1678	10080286026000	10558	5296	105	0	\N
264025	1678	10080286027000	10558	5296	106	0	\N
264026	1678	10080286028000	10558	5296	107	0	\N
264027	1678	10080286029000	10558	5296	108	0	\N
264028	1678	10080286030000	10558	5296	109	0	\N
264029	1678	10080286031000	10558	5296	110	0	\N
264030	1678	10080286032000	10558	5296	111	0	\N
264031	1678	10080286033000	10558	5296	112	0	\N
264032	1678	10080286034000	10558	5296	113	0	\N
264033	1678	10080286035000	10558	5296	114	0	\N
264034	1678	10080286036000	10558	5296	115	0	\N
264035	1678	10080286037000	10558	5296	116	0	\N
264036	1678	10080286038000	10558	5296	117	0	\N
264037	1678	10080286039000	10558	5296	118	0	\N
264038	1678	10080286040000	10558	5296	119	0	\N
264039	1678	10080286041000	10558	5296	120	0	\N
264040	1044	904405465000000	10558	5296	121	0	\N
264041	1164	610220750000000	10558	5296	122	0	\N
264042	924	504692775000000	10558	5296	123	0	\N
264043	1678	10080286042000	10558	5296	124	0	\N
264044	1678	10080286043000	10558	5296	125	0	\N
264053	1874	202829000	10563	5454	0	0	\N
264054	1678	10800326178000	10563	5454	1	0	\N
264055	1874	202830000	10563	5454	2	0	\N
264056	1678	10800326179000	10563	5454	3	0	\N
264061	1874	202832000	10566	5457	0	0	\N
264062	1678	10800326181000	10566	5457	1	0	\N
264063	1874	202832000	10567	5457	0	0	\N
264064	1678	10800326181000	10567	5457	1	0	\N
264065	1874	202832000	10568	5457	0	0	\N
264066	1678	10800326181000	10568	5457	1	0	\N
264067	1874	202832000	10569	5457	0	0	\N
264068	1678	10800326181000	10569	5457	1	0	\N
264071	1874	202833000	10571	5458	0	0	\N
264072	1678	10800326182000	10571	5458	1	0	\N
264073	1874	202834000	10572	5459	0	0	\N
264074	1678	10800326183000	10572	5459	1	0	\N
264084	1678	10800326188000	10576	5462	0	0	\N
264085	1874	202838000	10576	5462	1	0	\N
264098	1874	202843000	10581	5465	0	0	\N
264099	1678	10800326193000	10581	5465	1	0	\N
264100	1678	10800326194000	10582	5466	0	0	\N
264101	1874	202844000	10582	5466	1	0	\N
264104	1678	10800326194000	10584	5466	0	0	\N
264105	1874	202844000	10584	5466	1	0	\N
264106	1678	10800326194000	10585	5466	0	0	\N
264107	1874	202844000	10585	5466	1	0	\N
264047	1874	202828000	10560	5453	0	0	0
264048	1678	10800326177000	10560	5453	1	0	0
264049	1874	202829000	10561	5454	0	0	0
264050	1678	10800326178000	10561	5454	1	0	0
264051	1874	202830000	10562	5455	0	0	0
264057	1678	10800326180000	10564	5456	0	0	0
264058	1874	202831000	10564	5456	1	0	0
264059	1874	202832000	10565	5457	0	0	0
264060	1678	10800326181000	10565	5457	1	0	0
264069	1874	202833000	10570	5458	0	0	0
264075	1874	202834000	10573	5459	0	0	0
264076	1678	10800326183000	10573	5459	1	0	0
264077	1678	10800326184000	10573	5459	2	0	0
264078	1874	202835000	10574	5460	0	0	0
264080	1678	10800326185000	10574	5460	2	0	0
264081	1678	10800326186000	10575	5461	0	0	0
264082	1678	10800326187000	10575	5461	1	0	0
264083	1874	202837000	10575	5461	2	0	0
264086	1678	10800326188000	10577	5462	0	0	0
264088	1874	202839000	10578	5463	0	0	0
264089	1874	202840000	10578	5463	1	0	0
264090	1874	202841000	10578	5463	2	0	0
264091	1678	10800326189000	10578	5463	3	0	0
264092	1678	10800326190000	10578	5463	4	0	0
264094	1678	10800326192000	10579	5464	0	0	0
264095	1874	202842000	10579	5464	1	0	0
264096	1874	202843000	10580	5465	0	0	0
264097	1678	10800326193000	10580	5465	1	0	0
264103	1874	202844000	10583	5466	1	0	0
264108	1874	202845000	10586	5467	0	0	0
264109	1678	10800326195000	10586	5467	1	0	0
264110	1874	202846000	10587	5468	0	0	0
264111	1678	10800326196000	10587	5468	1	0	0
264114	1874	202848000	10590	5470	0	0	\N
264115	1874	202849000	10590	5470	1	0	\N
264116	1678	10800326198000	10590	5470	2	0	\N
264117	1678	10800326199000	10590	5470	3	0	\N
264122	1874	202848000	10592	5470	0	0	\N
264123	1874	202849000	10592	5470	1	0	\N
264124	1678	10800326198000	10592	5470	2	0	\N
264125	1678	10800326199000	10592	5470	3	0	\N
264126	1678	10800326200000	10593	5471	0	0	\N
264127	1874	202850000	10593	5471	1	0	\N
264134	1874	202851000	10596	5472	0	0	\N
264135	1874	202852000	10596	5472	1	0	\N
264136	1678	10800326201000	10596	5472	2	0	\N
264137	1678	10800326202000	10596	5472	3	0	\N
264144	1874	202855000	10600	5475	0	0	\N
264145	1678	10800326205000	10600	5475	1	0	\N
264146	1874	202856000	10601	5476	0	0	\N
264147	1678	10800326206000	10601	5476	1	0	\N
264150	1874	202856000	10603	5476	0	0	\N
264151	1678	10800326206000	10603	5476	1	0	\N
264152	1874	202857000	10604	5477	0	0	\N
264153	1678	10800326207000	10604	5477	1	0	\N
264158	1874	202859000	10607	5479	0	0	\N
264159	1678	10800326209000	10607	5479	1	0	\N
264160	1874	202859000	10608	5479	0	0	\N
264161	1678	10800326209000	10608	5479	1	0	\N
264164	1678	10800326210000	10610	5480	0	0	\N
264165	1678	10800326211000	10610	5480	1	0	\N
264166	1874	202860000	10610	5480	2	0	\N
264167	1874	202861000	10610	5480	3	0	\N
264174	1874	202862000	10613	5481	0	0	\N
264175	1678	10800326212000	10613	5481	1	0	\N
264181	1874	202864000	10616	5483	0	0	\N
264182	1678	10800326214000	10616	5483	1	0	\N
264183	1678	10800326215000	10617	5484	0	0	\N
264184	1874	202865000	10617	5484	1	0	\N
264185	1678	10080286044000	10618	5297	0	0	\N
264186	1678	10080286045000	10618	5297	1	0	\N
264187	1678	10080286046000	10618	5297	2	0	\N
264188	1678	10080286047000	10618	5297	3	0	\N
264189	1678	10080286048000	10618	5297	4	0	\N
264190	1678	10080286049000	10618	5297	5	0	\N
264191	1678	10080286050000	10618	5297	6	0	\N
264192	1678	10080286051000	10618	5297	7	0	\N
264193	1678	10080286052000	10618	5297	8	0	\N
264194	1678	10080286053000	10618	5297	9	0	\N
264195	1678	10080286054000	10618	5297	11	0	\N
264196	1678	10080286055000	10618	5297	12	0	\N
264197	1678	10080286056000	10618	5297	13	0	\N
264198	1678	10080286057000	10618	5297	14	0	\N
264199	1678	10080286058000	10618	5297	15	0	\N
264200	1678	10080286059000	10618	5297	16	0	\N
264201	1678	10080286060000	10618	5297	17	0	\N
264202	1678	10080286061000	10618	5297	18	0	\N
264203	1678	10080286062000	10618	5297	19	0	\N
264204	1678	10080286063000	10618	5297	20	0	\N
264205	1678	10080286064000	10618	5297	21	0	\N
264206	1678	10080286065000	10618	5297	22	0	\N
264207	1678	10080286066000	10618	5297	23	0	\N
264208	1678	10080286067000	10618	5297	24	0	\N
264209	1678	10080286068000	10618	5297	25	0	\N
264210	1678	10080286069000	10618	5297	26	0	\N
264211	1678	10080286070000	10618	5297	27	0	\N
264212	1678	10080286071000	10618	5297	28	0	\N
264213	1678	10080286072000	10618	5297	29	0	\N
264214	1678	10080286073000	10618	5297	30	0	\N
264215	1678	10080286074000	10618	5297	31	0	\N
264216	1678	10080286075000	10618	5297	32	0	\N
264217	1678	10080286076000	10618	5297	33	0	\N
264218	1678	10080286077000	10618	5297	34	0	\N
264219	1678	10080286078000	10618	5297	35	0	\N
264222	1874	202866000	10620	5485	0	0	\N
264223	1874	202867000	10620	5485	1	0	\N
264224	1678	10800326216000	10620	5485	2	0	\N
264225	1678	10800326217000	10620	5485	3	0	\N
264236	1874	202868000	10623	5486	0	0	\N
264237	1874	202869000	10623	5486	1	0	\N
264238	1874	202870000	10623	5486	2	0	\N
264239	1678	10800326218000	10623	5486	3	0	\N
264240	1678	10800326219000	10623	5486	4	0	\N
264241	1678	10800326220000	10623	5486	5	0	\N
264244	1678	10800326221000	10625	5487	0	0	\N
264245	1874	202871000	10625	5487	1	0	\N
264246	1678	10800326221000	10626	5487	0	0	\N
264247	1874	202871000	10626	5487	1	0	\N
264119	1874	202849000	10591	5470	1	0	0
264120	1678	10800326198000	10591	5470	2	0	0
264121	1678	10800326199000	10591	5470	3	0	0
264128	1678	10800326200000	10594	5471	0	0	0
264129	1874	202850000	10594	5471	1	0	0
264131	1874	202852000	10595	5472	1	0	0
264132	1678	10800326201000	10595	5472	2	0	0
264133	1678	10800326202000	10595	5472	3	0	0
264138	1874	202853000	10597	5473	0	0	0
264139	1678	10800326203000	10597	5473	1	0	0
264141	1678	10800326204000	10598	5474	1	0	0
264142	1874	202855000	10599	5475	0	0	0
264143	1678	10800326205000	10599	5475	1	0	0
264148	1874	202856000	10602	5476	0	0	0
264154	1874	202857000	10605	5477	0	0	0
264155	1678	10800326207000	10605	5477	1	0	0
264156	1678	10800326208000	10606	5478	0	0	0
264157	1874	202858000	10606	5478	1	0	0
264162	1874	202859000	10609	5479	0	0	0
264168	1678	10800326210000	10611	5480	0	0	0
264169	1678	10800326211000	10611	5480	1	0	0
264170	1874	202860000	10611	5480	2	0	0
264171	1874	202861000	10611	5480	3	0	0
264172	1874	202862000	10612	5481	0	0	0
264176	1678	10800326213000	10614	5482	0	0	0
264177	1874	202863000	10614	5482	1	0	0
264178	2026	75200000000	10614	5482	2	0	0
264179	1874	202864000	10615	5483	0	0	0
264220	1678	10800326215000	10619	5484	0	0	0
264221	1874	202865000	10619	5484	1	0	0
264226	1874	202866000	10621	5485	0	0	0
264227	1874	202867000	10621	5485	1	0	0
264228	1678	10800326216000	10621	5485	2	0	0
264230	1874	202868000	10622	5486	0	0	0
264231	1874	202869000	10622	5486	1	0	0
264232	1874	202870000	10622	5486	2	0	0
264233	1678	10800326218000	10622	5486	3	0	0
264234	1678	10800326219000	10622	5486	4	0	0
264242	1678	10800326221000	10624	5487	0	0	0
264243	1874	202871000	10624	5487	1	0	0
264248	1874	202872000	10627	5488	0	0	0
264254	1678	10800326224000	10630	5490	0	0	\N
264255	1874	202874000	10630	5490	1	0	\N
264256	1678	10800326224000	10631	5490	0	0	\N
264257	1874	202874000	10631	5490	1	0	\N
264261	1874	202876000	10633	5492	0	0	\N
264262	1678	10800326225000	10633	5492	1	0	\N
264263	1678	10800326226000	10633	5492	2	0	\N
264266	1874	202876000	10635	5492	0	0	\N
264267	1678	10800326225000	10635	5492	1	0	\N
264278	1874	202881000	10638	5495	0	0	\N
264279	1678	10800326231000	10638	5495	1	0	\N
264287	1874	202883000	10642	5497	0	0	\N
264288	1678	10800326233000	10642	5497	1	0	\N
264289	556	66419564339290	10643	5413	0	0	\N
264290	930	505969095140680	10643	5413	1	0	\N
264291	1050	906692283348880	10643	5413	2	0	\N
264292	1170	611763350695495	10643	5413	3	0	\N
264293	1296	1704732971677270	10643	5413	4	0	\N
264294	451	66176478352080	10643	5413	5	0	\N
264295	487	66176478352080	10643	5413	6	0	\N
264296	744	2005347828843	10643	5413	7	0	\N
264297	988	504121261499270	10643	5413	8	0	\N
264298	1108	903380981295700	10643	5413	9	0	\N
264299	1228	609529149217850	10643	5413	10	0	\N
264300	1354	1698507170605750	10643	5413	11	0	\N
264301	451	66305884206092	10643	5413	12	0	\N
264302	487	66305884206092	10643	5413	13	0	\N
264303	744	2009269218353	10643	5413	14	0	\N
264304	988	505106484932068	10643	5413	15	0	\N
264305	1108	905146493245880	10643	5413	16	0	\N
264306	1228	610720375310940	10643	5413	17	0	\N
264307	1354	1701826628032090	10643	5413	18	0	\N
264308	563	66000527000000	10643	5413	19	0	\N
264309	563	66001527000000	10643	5413	20	0	\N
264310	563	83474527000000	10643	5413	21	0	\N
264311	1483	0	10643	5413	22	0	\N
264312	2024	1000000000	10643	5413	23	0	\N
264313	2024	3000000000	10643	5413	24	0	\N
264314	2025	1000000000	10643	5413	25	0	\N
264315	2025	999000000000	10643	5413	26	0	\N
264316	2026	75200000000	10643	5413	27	0	\N
264317	2024	832330000000	10643	5413	28	0	\N
264318	2027	999000000000	10643	5413	29	0	\N
264327	1678	10800326235000	10646	5499	0	0	\N
264328	1678	10800326236000	10646	5499	1	0	\N
264331	1874	202887000	10648	5500	0	0	\N
264332	1678	10800326237000	10648	5500	1	0	\N
264333	1874	202887000	10649	5500	0	0	\N
264334	1678	10800326237000	10649	5500	1	0	\N
264335	1874	202887000	10650	5500	0	0	\N
264336	1678	10800326237000	10650	5500	1	0	\N
264337	1874	202888000	10651	5501	0	0	\N
264338	1874	202889000	10651	5501	1	0	\N
264339	1678	10800326238000	10651	5501	2	0	\N
264340	1678	10800326239000	10651	5501	3	0	\N
264341	1874	202888000	10652	5501	0	0	\N
264342	1874	202889000	10652	5501	1	0	\N
264343	1678	10800326238000	10652	5501	2	0	\N
264344	1678	10800326239000	10652	5501	3	0	\N
264353	1874	202892000	10656	5504	0	0	\N
264354	1874	202893000	10656	5504	1	0	\N
264355	1678	10800326242000	10656	5504	2	0	\N
264356	1678	10800326243000	10656	5504	3	0	\N
264357	1874	202892000	10657	5504	0	0	\N
264358	1874	202893000	10657	5504	1	0	\N
264359	1678	10800326242000	10657	5504	2	0	\N
264360	1678	10800326243000	10657	5504	3	0	\N
264365	1874	202892000	10659	5504	0	0	\N
264366	1874	202893000	10659	5504	1	0	\N
264367	1678	10800326242000	10659	5504	2	0	\N
264368	1678	10800326243000	10659	5504	3	0	\N
264372	1678	10800326246000	10663	5507	0	0	\N
264373	1874	202895000	10663	5507	1	0	\N
264374	1678	10800326246000	10664	5507	0	0	\N
264375	1874	202895000	10664	5507	1	0	\N
264376	1678	10800326246000	10665	5507	0	0	\N
264377	1874	202895000	10665	5507	1	0	\N
264380	1874	202896000	10667	5508	0	0	\N
264381	1678	10800326247000	10667	5508	1	0	\N
264382	1678	10800326248000	10667	5508	2	0	\N
264383	1874	202897000	10667	5508	3	0	\N
264384	1874	202898000	10667	5508	4	0	\N
264251	1678	10800326223000	10628	5489	0	0	0
264252	1874	202873000	10628	5489	1	0	0
264253	1678	10800326224000	10629	5490	0	0	0
264258	1874	202874000	10632	5491	0	0	0
264259	1874	202875000	10632	5491	1	0	0
264264	1874	202876000	10634	5492	0	0	0
264265	1678	10800326225000	10634	5492	1	0	0
264268	1874	202877000	10636	5493	0	0	0
264269	1678	10800326226000	10636	5493	1	0	0
264270	1678	10800326227000	10636	5493	2	0	0
264272	1874	202879000	10637	5494	1	0	0
264273	1874	202880000	10637	5494	2	0	0
264274	1678	10800326228000	10637	5494	4	0	0
264275	1678	10800326229000	10637	5494	5	0	0
264277	563	66001526000000	10637	5494	7	0	4
264280	1874	202881000	10639	5495	0	0	0
264281	1678	10800326231000	10639	5495	1	0	0
264282	1678	10800326232000	10640	5496	0	0	0
264283	1874	202882000	10640	5496	1	0	0
264285	1874	202883000	10641	5497	0	0	0
264286	1678	10800326233000	10641	5497	1	0	0
264319	1678	10800326234000	10644	5498	0	0	0
264320	1874	202884000	10644	5498	1	0	0
264321	1359	1701967437751650	10644	5498	2	0	0
264323	1678	10800326235000	10645	5499	0	0	0
264324	1874	202885000	10645	5499	1	0	0
264325	1874	202886000	10645	5499	2	0	0
264326	1678	10800326236000	10645	5499	3	0	0
264330	1678	10800326237000	10647	5500	1	0	0
264345	1874	202888000	10653	5501	0	0	0
264346	1874	202889000	10653	5501	1	0	0
264347	1678	10800326238000	10653	5501	2	0	0
264348	1678	10800326239000	10653	5501	3	0	0
264350	1678	10800326241000	10655	5503	1	0	0
264351	1874	202890000	10655	5503	2	0	0
264352	1874	202891000	10655	5503	3	0	0
264361	1874	202892000	10658	5504	0	0	0
264362	1874	202893000	10658	5504	1	0	0
264364	1678	10800326243000	10658	5504	3	0	0
264369	1678	10800326244000	10660	5505	0	0	0
264370	1678	10800326245000	10661	5506	0	0	0
264371	1874	202894000	10661	5506	1	0	0
264379	1874	202895000	10666	5507	1	0	0
264385	1874	202896000	10668	5508	0	0	\N
264386	1678	10800326247000	10668	5508	1	0	\N
264387	1678	10800326248000	10668	5508	2	0	\N
264388	1874	202897000	10668	5508	3	0	\N
264389	1874	202898000	10668	5508	4	0	\N
264395	1678	10800326249000	10670	5509	0	0	\N
264396	1678	10800326250000	10670	5509	1	0	\N
264397	1678	10800326251000	10670	5509	2	0	\N
264398	1874	202899000	10670	5509	3	0	\N
264399	1874	202900000	10670	5509	4	0	\N
264400	1874	202901000	10670	5509	5	0	\N
264407	1678	10800326249000	10672	5509	0	0	\N
264408	1678	10800326250000	10672	5509	1	0	\N
264409	1678	10800326251000	10672	5509	2	0	\N
264410	1874	202899000	10672	5509	3	0	\N
264411	1874	202900000	10672	5509	4	0	\N
264412	1874	202901000	10672	5509	5	0	\N
264413	1678	10800326249000	10673	5509	0	0	\N
264414	1678	10800326250000	10673	5509	1	0	\N
264415	1678	10800326251000	10673	5509	2	0	\N
264416	1678	10800326252000	10673	5509	3	0	\N
264417	1874	202899000	10673	5509	4	0	\N
264418	1874	202900000	10673	5509	5	0	\N
264419	1874	202901000	10673	5509	6	0	\N
264420	1874	202902000	10673	5509	7	0	\N
264427	1874	202904000	10676	5511	0	0	\N
264428	1678	10800326254000	10676	5511	1	0	\N
264429	1874	202904000	10677	5511	0	0	\N
264430	1678	10800326254000	10677	5511	1	0	\N
264433	1678	10800326256000	10679	5513	0	0	\N
264434	1874	202906000	10679	5513	1	0	\N
264437	1874	202907000	10681	5514	0	0	\N
264438	1678	10800326257000	10681	5514	1	0	\N
264448	1874	202910000	10686	5517	0	0	\N
264449	1678	10800326260000	10686	5517	1	0	\N
264450	1740	8640172000000	10686	5517	2	0	\N
264451	1678	10800326261000	10688	5518	0	0	\N
264452	1874	202911000	10688	5518	1	0	\N
264458	1678	10800326263000	10690	5520	0	0	\N
264459	1874	202913000	10690	5520	1	0	\N
264460	1678	10800326263000	10691	5520	0	0	\N
264461	1874	202913000	10691	5520	1	0	\N
264472	1678	10800326269000	10697	5524	0	0	\N
264473	1678	10800326270000	10697	5524	1	0	\N
264474	1874	202916000	10697	5524	2	0	\N
264475	1874	202917000	10697	5524	3	0	\N
264476	1874	202918000	10697	5524	4	0	\N
264477	1874	202919000	10697	5524	5	0	\N
264478	1874	202920000	10697	5524	6	0	\N
264479	993	505148575000000	10697	5524	7	0	\N
264488	1678	10800326269000	10699	5524	0	0	\N
264489	1678	10800326270000	10699	5524	1	0	\N
264490	1874	202916000	10699	5524	2	0	\N
264491	1874	202917000	10699	5524	3	0	\N
264492	1874	202918000	10699	5524	4	0	\N
264493	1874	202919000	10699	5524	5	0	\N
264494	1874	202920000	10699	5524	6	0	\N
264495	993	505148575000000	10699	5524	7	0	\N
264496	1678	10800326269000	10700	5524	0	0	\N
264497	1678	10800326270000	10700	5524	1	0	\N
264498	1874	202916000	10700	5524	2	0	\N
264499	1874	202917000	10700	5524	3	0	\N
264500	1874	202918000	10700	5524	4	0	\N
264501	1874	202919000	10700	5524	5	0	\N
264502	1874	202920000	10700	5524	6	0	\N
264503	993	505148575000000	10700	5524	7	0	\N
264504	1678	10800326269000	10701	5524	0	0	\N
264505	1678	10800326270000	10701	5524	1	0	\N
264506	1874	202916000	10701	5524	2	0	\N
264507	1874	202917000	10701	5524	3	0	\N
264508	1874	202918000	10701	5524	4	0	\N
264509	1874	202919000	10701	5524	5	0	\N
264510	1874	202920000	10701	5524	6	0	\N
264511	993	505148575000000	10701	5524	7	0	\N
264514	1678	10800326271000	10703	5525	0	0	\N
264515	1874	202921000	10703	5525	1	0	\N
264392	1678	10800326248000	10669	5508	2	0	0
264393	1874	202897000	10669	5508	3	0	0
264394	1874	202898000	10669	5508	4	0	0
264401	1678	10800326249000	10671	5509	0	0	0
264402	1678	10800326250000	10671	5509	1	0	0
264404	1874	202899000	10671	5509	3	0	0
264405	1874	202900000	10671	5509	4	0	0
264406	1874	202901000	10671	5509	5	0	0
264421	1874	202902000	10674	5510	0	0	0
264422	1874	202903000	10674	5510	1	0	0
264424	1678	10800326253000	10674	5510	3	0	0
264425	1874	202904000	10675	5511	0	0	0
264426	1678	10800326254000	10675	5511	1	0	0
264431	1678	10800326255000	10678	5512	0	0	0
264435	1678	10800326256000	10680	5513	0	0	0
264436	1874	202906000	10680	5513	1	0	0
264439	1874	202907000	10682	5514	0	0	0
264440	1678	10800326257000	10682	5514	1	0	0
264441	1874	202908000	10683	5515	0	0	0
264443	1874	202909000	10684	5516	0	0	0
264444	1678	10800326259000	10684	5516	1	0	0
264445	1874	202910000	10685	5517	0	0	0
264446	1678	10800326260000	10685	5517	1	0	0
264447	1740	8640172000000	10685	5517	2	0	10
264454	1874	202911000	10689	5519	1	0	0
264455	1874	202912000	10689	5519	2	0	0
264456	1678	10800326262000	10689	5519	3	0	0
264457	563	71239122000000	10689	5519	4	0	7
264463	1874	202913000	10692	5520	1	0	0
264464	1678	10800326264000	10695	5522	0	0	0
264465	1678	10800326265000	10695	5522	1	0	0
264466	1874	202914000	10695	5522	2	0	0
264467	1874	202915000	10695	5522	3	0	0
264469	1678	10800326266000	10696	5523	0	0	0
264470	1678	10800326267000	10696	5523	1	0	0
264471	1678	10800326268000	10696	5523	2	0	0
264480	1678	10800326269000	10698	5524	0	0	0
264481	1678	10800326270000	10698	5524	1	0	0
264483	1874	202917000	10698	5524	3	0	0
264484	1874	202918000	10698	5524	4	0	0
264485	1874	202919000	10698	5524	5	0	0
264486	1874	202920000	10698	5524	6	0	0
264512	1678	10800326271000	10702	5525	0	0	0
264513	1874	202921000	10702	5525	1	0	0
264516	1678	10800326272000	10704	5526	0	0	0
264517	1874	202922000	10704	5526	1	0	0
264518	1874	202923000	10704	5526	2	0	0
264520	1874	202924000	10705	5527	0	0	0
264529	1874	202924000	10706	5527	0	0	\N
264530	1874	202925000	10706	5527	1	0	\N
264531	1874	202926000	10706	5527	2	0	\N
264532	1874	202927000	10706	5527	3	0	\N
264533	1678	10800326274000	10706	5527	4	0	\N
264534	1678	10800326275000	10706	5527	5	0	\N
264535	1678	10800326276000	10706	5527	6	0	\N
264536	1678	10800326277000	10706	5527	7	0	\N
264537	2028	19439100000000	10706	5527	8	0	\N
264538	1678	10800326278000	10707	5528	0	0	\N
264539	1874	202928000	10707	5528	1	0	\N
264543	1874	202929000	10710	5530	0	0	\N
264544	1678	10800326280000	10710	5530	1	0	\N
264547	1678	10800326281000	10712	5531	0	0	\N
264548	1874	202930000	10712	5531	1	0	\N
264549	1678	10800326281000	10713	5531	0	0	\N
264550	1874	202930000	10713	5531	1	0	\N
264551	1678	10800326281000	10714	5531	0	0	\N
264552	1874	202930000	10714	5531	1	0	\N
264555	1678	10800326281000	10716	5531	0	0	\N
264556	1874	202930000	10716	5531	1	0	\N
264557	1874	202931000	10717	5532	0	0	\N
264558	1678	10800326282000	10717	5532	1	0	\N
264561	1874	202931000	10719	5532	0	0	\N
264562	1678	10800326282000	10719	5532	1	0	\N
264565	989	505097925000000	10721	5534	0	0	\N
264566	1678	10800326284000	10721	5534	1	0	\N
264567	1874	202933000	10721	5534	2	0	\N
264568	1874	202934000	10721	5534	3	0	\N
264569	1678	10800326285000	10721	5534	4	0	\N
264570	944	505239650540000	10721	5534	5	0	\N
264577	1874	202935000	10723	5535	0	0	\N
264578	1678	10800326286000	10723	5535	1	0	\N
264581	989	505097925000000	10725	5418	0	0	\N
264582	556	66419564339290	10725	5418	1	0	\N
264583	930	505969095140680	10725	5418	2	0	\N
264584	1050	906692283348880	10725	5418	3	0	\N
264585	1170	611763350695495	10725	5418	4	0	\N
264586	1296	1704732971677270	10725	5418	5	0	\N
264587	1678	10080286116000	10725	5418	6	0	\N
264588	1678	10080286117000	10725	5418	7	0	\N
264589	1678	10080286118000	10725	5418	8	0	\N
264590	1678	10080286119000	10725	5418	9	0	\N
264591	1678	10080286120000	10725	5418	10	0	\N
264592	1678	10080286121000	10725	5418	11	0	\N
264593	1678	10080286122000	10725	5418	12	0	\N
264594	1678	10080286123000	10725	5418	13	0	\N
264595	1678	10080286124000	10725	5418	14	0	\N
264596	1678	10080286125000	10725	5418	15	0	\N
264597	1678	10080286126000	10725	5418	16	0	\N
264598	1678	10080286127000	10725	5418	17	0	\N
264599	1678	10080286128000	10725	5418	18	0	\N
264600	1678	10080286129000	10725	5418	19	0	\N
264601	1874	202767000	10725	5418	20	0	\N
264602	1874	202768000	10725	5418	21	0	\N
264603	1874	202769000	10725	5418	22	0	\N
264604	1874	202770000	10725	5418	24	0	\N
264605	1874	202771000	10725	5418	25	0	\N
264606	1874	202772000	10725	5418	26	0	\N
264607	1874	202773000	10725	5418	27	0	\N
264608	1874	202774000	10725	5418	28	0	\N
264609	1874	202775000	10725	5418	29	0	\N
264610	1874	202776000	10725	5418	30	0	\N
264611	1874	202777000	10725	5418	31	0	\N
264612	1874	202778000	10725	5418	32	0	\N
264613	451	66176478352080	10725	5418	33	0	\N
264614	487	66176478352080	10725	5418	34	0	\N
264615	744	2005347828843	10725	5418	35	0	\N
264616	988	504121261499270	10725	5418	36	0	\N
264617	1108	903380981295700	10725	5418	37	0	\N
264618	1228	609529149217850	10725	5418	38	0	\N
264619	1354	1698507170605750	10725	5418	39	0	\N
264620	451	66305884206092	10725	5418	40	0	\N
264621	487	66305884206092	10725	5418	41	0	\N
264622	744	2009269218353	10725	5418	42	0	\N
264623	988	505106484932068	10725	5418	43	0	\N
264624	1108	905146493245880	10725	5418	44	0	\N
264625	1228	610720375310940	10725	5418	45	0	\N
264626	1354	1701826628032090	10725	5418	46	0	\N
264627	1678	10080286130000	10725	5418	47	0	\N
264628	1678	10080286131000	10725	5418	48	0	\N
264629	1678	10080286132000	10725	5418	49	0	\N
264630	1678	10080286133000	10725	5418	50	0	\N
264631	1678	10080286134000	10725	5418	51	0	\N
264632	1678	10080286135000	10725	5418	52	0	\N
264633	1678	10080286136000	10725	5418	53	0	\N
264634	1678	10080286137000	10725	5418	54	0	\N
264635	1678	10080286138000	10725	5418	55	0	\N
264636	1678	10080286139000	10725	5418	56	0	\N
264637	1678	10080286140000	10725	5418	57	0	\N
264638	1678	10080286141000	10725	5418	58	0	\N
264639	1678	10080286142000	10725	5418	59	0	\N
264640	1678	10080286143000	10725	5418	60	0	\N
264641	1678	10080286144000	10725	5418	61	0	\N
264642	1678	10080286145000	10725	5418	62	0	\N
264643	1678	10080286146000	10725	5418	63	0	\N
264644	1874	202779000	10725	5418	64	0	\N
264645	1874	202780000	10725	5418	65	0	\N
264646	1874	202781000	10725	5418	66	0	\N
264647	1937	1400000000	10725	5418	67	0	\N
264648	1874	202782000	10725	5418	68	0	\N
264649	1874	202783000	10725	5418	69	0	\N
264650	1874	202784000	10725	5418	70	0	\N
264651	1874	202785000	10725	5418	71	0	\N
264652	1874	202786000	10725	5418	72	0	\N
264653	1874	202787000	10725	5418	73	0	\N
264654	1874	202788000	10725	5418	74	0	\N
264655	1874	202789000	10725	5418	75	0	\N
264656	1874	202790000	10725	5418	76	0	\N
264523	1874	202927000	10705	5527	3	0	0
264524	1678	10800326274000	10705	5527	4	0	0
264525	1678	10800326275000	10705	5527	5	0	0
264526	1678	10800326276000	10705	5527	6	0	0
264527	1678	10800326277000	10705	5527	7	0	0
264540	1678	10800326278000	10708	5528	0	0	0
264541	1874	202928000	10708	5528	1	0	0
264542	1678	10800326279000	10709	5529	0	0	0
264545	1874	202929000	10711	5530	0	0	0
264546	1678	10800326280000	10711	5530	1	0	0
264554	1874	202930000	10715	5531	1	0	0
264559	1874	202931000	10718	5532	0	0	0
264560	1678	10800326282000	10718	5532	1	0	0
264563	1874	202932000	10720	5533	0	0	0
264571	989	505097925000000	10722	5534	0	0	0
264572	1678	10800326284000	10722	5534	1	0	0
264573	1874	202933000	10722	5534	2	0	0
264574	1874	202934000	10722	5534	3	0	0
264575	1678	10800326285000	10722	5534	4	0	0
264579	1874	202935000	10724	5535	0	0	0
264580	1678	10800326286000	10724	5535	1	0	0
264657	1874	202791000	10725	5418	77	0	\N
264658	1874	202792000	10725	5418	78	0	\N
264659	1874	202793000	10725	5418	79	0	\N
264660	1874	202794000	10725	5418	80	0	\N
264661	1874	202795000	10725	5418	81	0	\N
264662	1874	202796000	10725	5418	82	0	\N
264663	1874	202797000	10725	5418	83	0	\N
264664	1874	202798000	10725	5418	84	0	\N
264665	1874	202799000	10725	5418	85	0	\N
264666	1874	202800000	10725	5418	86	0	\N
264667	1874	202801000	10725	5418	87	0	\N
264668	1874	202802000	10725	5418	88	0	\N
264669	1874	202803000	10725	5418	89	0	\N
264670	1874	202804000	10725	5418	90	0	\N
264671	1874	202805000	10725	5418	91	0	\N
264672	1874	202806000	10725	5418	92	0	\N
264673	1874	202807000	10725	5418	93	0	\N
264674	1874	202808000	10725	5418	94	0	\N
264675	1874	202809000	10725	5418	95	0	\N
264676	1874	202810000	10725	5418	96	0	\N
264677	1874	202811000	10725	5418	97	0	\N
264678	1874	202812000	10725	5418	98	0	\N
264679	1678	10080286147000	10725	5418	99	0	\N
264680	1678	10080286148000	10725	5418	100	0	\N
264681	1678	10080286149000	10725	5418	101	0	\N
264682	1678	10080286150000	10725	5418	102	0	\N
264683	1678	10080286151000	10725	5418	103	0	\N
264684	1678	10080286152000	10725	5418	104	0	\N
264685	1678	10080286153000	10725	5418	105	0	\N
264686	1678	10080286154000	10725	5418	106	0	\N
264687	1678	10080286155000	10725	5418	107	0	\N
264688	1678	10080286156000	10725	5418	108	0	\N
264689	1678	10080286157000	10725	5418	109	0	\N
264690	1678	10080286158000	10725	5418	110	0	\N
264691	1678	10080286159000	10725	5418	111	0	\N
264692	1678	10080286160000	10725	5418	112	0	\N
264693	1678	10080286161000	10725	5418	113	0	\N
264694	1678	10080286162000	10725	5418	114	0	\N
264695	1678	10080286163000	10725	5418	115	0	\N
264696	1678	10080286164000	10725	5418	116	0	\N
264697	1678	10080286165000	10725	5418	117	0	\N
264698	1678	10080286166000	10725	5418	118	0	\N
264699	1678	10080286167000	10725	5418	119	0	\N
264700	1678	10080286168000	10725	5418	120	0	\N
264701	1678	10080286169000	10725	5418	121	0	\N
264702	1678	10080286170000	10725	5418	122	0	\N
264703	1678	10080286171000	10725	5418	123	0	\N
264704	1678	10080286172000	10725	5418	124	0	\N
264705	1678	10080286173000	10725	5418	125	0	\N
264713	1229	610709990000000	10727	5535	0	0	\N
264714	1109	905131095000000	10727	5535	1	0	\N
264715	1874	202935000	10727	5535	2	0	\N
264716	1678	10800326286000	10727	5535	3	0	\N
264717	1678	10800326287000	10727	5535	4	0	\N
264718	1874	202936000	10727	5535	5	0	\N
264719	1310	1702275295351650	10727	5535	6	0	\N
264720	1184	610881384820000	10727	5535	7	0	\N
264721	1064	905385124870000	10727	5535	8	0	\N
264724	1874	202938000	10729	5538	0	0	\N
264725	1678	10800326289000	10729	5538	1	0	\N
264727	1874	202938000	10731	5538	0	0	\N
264728	1678	10800326289000	10731	5538	1	0	\N
264729	1874	202938000	10732	5538	0	0	\N
264730	1678	10800326289000	10732	5538	1	0	\N
264736	1874	202940000	10735	5540	0	0	\N
264737	1678	10800326291000	10735	5540	1	0	\N
264746	1874	202945000	10738	5543	0	0	\N
264747	1678	10800326296000	10738	5543	1	0	\N
264748	1874	202945000	10739	5543	0	0	\N
264749	1678	10800326296000	10739	5543	1	0	\N
264759	1678	10800326299000	10743	5545	0	0	\N
264760	1874	202948000	10743	5545	1	0	\N
264761	1939	2150990000000	10743	5545	3	0	\N
264764	1874	202949000	10745	5546	0	0	\N
264765	1678	10800326300000	10745	5546	1	0	\N
264766	1874	202950000	10746	5547	0	0	\N
264767	1678	10800326301000	10746	5547	1	0	\N
264770	1678	10800326302000	10748	5548	0	0	\N
264771	1874	202951000	10748	5548	1	0	\N
264772	2030	200000000	10748	5548	2	0	\N
264773	1678	10800326302000	10749	5548	0	0	\N
264774	1874	202951000	10749	5548	1	0	\N
264775	2030	200000000	10749	5548	2	0	\N
264779	1678	10800326302000	10751	5548	0	0	\N
264780	1874	202951000	10751	5548	1	0	\N
264781	2030	200000000	10751	5548	2	0	\N
264708	1678	10800326287000	10726	5536	2	0	0
264709	1874	202936000	10726	5536	3	0	0
264710	1310	1702275295351650	10726	5536	4	0	0
264711	1184	610881384820000	10726	5536	5	0	0
264712	1064	905385124870000	10726	5536	6	0	0
264723	1678	10800326288000	10728	5537	1	0	0
264726	1874	202938000	10730	5538	0	0	0
264731	1678	10800326289000	10733	5539	0	0	0
264732	1678	10800326290000	10733	5539	1	0	0
264733	1874	202939000	10733	5539	2	0	0
264735	1678	10800326291000	10734	5540	1	0	0
264738	1678	10800326292000	10736	5541	0	0	0
264739	1678	10800326293000	10736	5541	1	0	0
264740	1874	202941000	10736	5541	2	0	0
264742	1678	10800326294000	10737	5542	0	0	0
264743	1678	10800326295000	10737	5542	1	0	0
264744	1874	202943000	10737	5542	2	0	0
264745	1874	202944000	10737	5542	3	0	0
264750	1874	202945000	10740	5543	0	0	0
264752	1874	202946000	10741	5544	0	0	0
264753	1874	202947000	10741	5544	1	0	0
264754	1678	10800326297000	10741	5544	2	0	0
264755	1678	10800326298000	10741	5544	3	0	0
264756	1678	10800326299000	10742	5545	0	0	0
264758	1939	2150990000000	10742	5545	3	0	1
264762	1874	202949000	10744	5546	0	0	0
264763	1678	10800326300000	10744	5546	1	0	0
264768	1874	202950000	10747	5547	0	0	0
264776	1678	10800326302000	10750	5548	0	0	0
264777	1874	202951000	10750	5548	1	0	0
264778	2030	200000000	10750	5548	2	0	0
264782	1678	10800326303000	10752	5549	0	0	0
264783	2031	200000000	10752	5549	1	0	0
264785	1874	202953000	10752	5549	3	0	0
264786	1874	202954000	10752	5549	4	0	0
264787	1678	10800326304000	10752	5549	5	0	0
264788	1678	10800326305000	10752	5549	6	0	0
264789	1874	202955000	10753	5550	0	0	0
264791	1874	202957000	10753	5550	2	0	0
264792	1678	10800326306000	10753	5550	3	0	0
264799	1678	10800326310000	10757	5552	0	0	\N
264800	1874	202959000	10757	5552	1	0	\N
264803	1678	10800326312000	10759	5554	0	0	\N
264804	1678	10800326313000	10759	5554	1	0	\N
264805	1874	202961000	10759	5554	2	0	\N
264806	1874	202962000	10759	5554	3	0	\N
264807	1678	10800326312000	10760	5554	0	0	\N
264808	1678	10800326313000	10760	5554	1	0	\N
264809	1874	202961000	10760	5554	2	0	\N
264810	1874	202962000	10760	5554	3	0	\N
264811	1678	10800326312000	10761	5554	0	0	\N
264812	1678	10800326313000	10761	5554	1	0	\N
264813	1874	202961000	10761	5554	2	0	\N
264814	1874	202962000	10761	5554	3	0	\N
264827	1874	202965000	10766	5557	0	0	\N
264828	1874	202966000	10766	5557	1	0	\N
264829	1678	10800326316000	10766	5557	2	0	\N
264830	1678	10800326317000	10766	5557	3	0	\N
264831	1874	202965000	10767	5557	0	0	\N
264832	1874	202966000	10767	5557	1	0	\N
264833	1678	10800326316000	10767	5557	2	0	\N
264834	1678	10800326317000	10767	5557	3	0	\N
264841	1541	1036000000	10770	5559	0	0	\N
264842	1678	11520366318000	10770	5559	1	0	\N
264843	1541	2036000000	10770	5559	2	0	\N
264844	1874	202968000	10770	5559	3	0	\N
264845	1541	1036000000	10771	5559	0	0	\N
264846	1678	11520366318000	10771	5559	1	0	\N
264847	1541	2036000000	10771	5559	2	0	\N
264848	1874	202968000	10771	5559	3	0	\N
264849	1678	11520366319000	10772	5560	0	0	\N
264850	1874	202969000	10772	5560	1	0	\N
264851	1874	202970000	10772	5560	2	0	\N
264852	1678	11520366320000	10772	5560	3	0	\N
264861	1083	904798479693893	10775	5562	0	0	\N
264862	1874	202972000	10775	5562	1	0	\N
264863	1874	202973000	10775	5562	2	0	\N
264864	1678	11520366322000	10775	5562	3	0	\N
264865	1678	11520366323000	10775	5562	4	0	\N
264875	1203	610485563632763	10779	5564	0	0	\N
264876	1678	11520366325000	10779	5564	1	0	\N
264877	1874	202974000	10779	5564	2	0	\N
264878	1203	610485563632763	10780	5564	0	0	\N
264879	1678	11520366325000	10780	5564	1	0	\N
264880	1874	202974000	10780	5564	2	0	\N
264885	1678	11520366326000	10782	5565	0	0	\N
264886	1678	11520366327000	10782	5565	1	0	\N
264887	1874	202975000	10782	5565	2	0	\N
264888	1874	202976000	10782	5565	3	0	\N
264889	1678	11520366326000	10783	5565	0	0	\N
264890	1678	11520366327000	10783	5565	1	0	\N
264891	1874	202975000	10783	5565	2	0	\N
264892	1874	202976000	10783	5565	3	0	\N
264893	989	505097925000000	10784	5443	0	0	\N
264894	1229	610709990000000	10784	5443	1	0	\N
264895	1109	905131095000000	10784	5443	2	0	\N
264896	1355	1701797667751650	10784	5443	3	0	\N
264897	1678	10800326163000	10784	5443	4	0	\N
264898	1678	10800326164000	10784	5443	5	0	\N
264899	987	505420615000000	10784	5443	6	0	\N
264900	1541	1036000000	10784	5443	7	0	\N
264901	1541	2036000000	10784	5443	8	0	\N
264902	963	504912280012457	10784	5443	9	0	\N
264903	1083	904798479693893	10784	5443	10	0	\N
264904	1203	610485563632763	10784	5443	11	0	\N
264905	1678	10800326165000	10784	5443	12	0	\N
264906	1678	10800326166000	10784	5443	13	0	\N
264907	1678	10800326167000	10784	5443	14	0	\N
264908	1678	10800326168000	10784	5443	15	0	\N
264909	1678	10800326169000	10784	5443	16	0	\N
264910	1678	10800326170000	10784	5443	17	0	\N
264911	1678	10800326171000	10784	5443	18	0	\N
264912	1678	10800326172000	10784	5443	19	0	\N
264913	1678	10800326173000	10784	5443	20	0	\N
264914	1678	10800326174000	10784	5443	21	0	\N
264915	1678	10800326175000	10784	5443	22	0	\N
264916	1678	10800326176000	10784	5443	23	0	\N
264917	1678	10800326177000	10784	5443	24	0	\N
264918	1678	10800326178000	10784	5443	25	0	\N
264919	1678	10800326179000	10784	5443	26	0	\N
264920	1678	10800326180000	10784	5443	27	0	\N
264921	1678	10800326181000	10784	5443	28	0	\N
264922	1678	10800326182000	10784	5443	29	0	\N
264923	1678	10800326183000	10784	5443	30	0	\N
264924	1678	10800326184000	10784	5443	31	0	\N
264925	1678	10800326185000	10784	5443	32	0	\N
264926	1678	10800326186000	10784	5443	33	0	\N
264927	1678	10800326187000	10784	5443	34	0	\N
264928	1678	10800326188000	10784	5443	35	0	\N
264795	1678	10800326309000	10754	5551	0	0	0
264796	1874	202958000	10754	5551	1	0	0
264797	1678	10800326310000	10756	5552	0	0	0
264798	1874	202959000	10756	5552	1	0	0
264801	1874	202960000	10758	5553	0	0	0
264815	1678	10800326312000	10762	5554	0	0	0
264816	1678	10800326313000	10762	5554	1	0	0
264817	1874	202961000	10762	5554	2	0	0
264818	1874	202962000	10762	5554	3	0	0
264819	1874	202963000	10763	5555	0	0	0
264821	1874	202964000	10764	5556	0	0	0
264822	1678	10800326315000	10764	5556	1	0	0
264823	1874	202965000	10765	5557	0	0	0
264824	1874	202966000	10765	5557	1	0	0
264826	1678	10800326317000	10765	5557	3	0	0
264835	1874	202967000	10768	5558	0	0	0
264836	95	66000000000000	10768	5558	1	0	0
264837	1541	1036000000	10769	5559	0	0	4
264838	1678	11520366318000	10769	5559	1	0	0
264840	1874	202968000	10769	5559	3	0	0
264853	1678	11520366319000	10773	5560	0	0	0
264854	1874	202969000	10773	5560	1	0	0
264855	1874	202970000	10773	5560	2	0	0
264856	1678	11520366320000	10773	5560	3	0	0
264858	987	505420615000000	10774	5561	1	0	0
264859	1678	11520366321000	10774	5561	2	0	0
264860	963	504912280012457	10774	5561	3	0	0
264866	1083	904798479693893	10776	5562	0	0	0
264868	1874	202973000	10776	5562	2	0	0
264869	1678	11520366322000	10776	5562	3	0	0
264870	1678	11520366323000	10776	5562	4	0	0
264871	1678	11520366324000	10777	5563	0	0	0
264872	1203	610485563632763	10778	5564	0	0	0
264874	1874	202974000	10778	5564	2	0	0
264881	1678	11520366326000	10781	5565	0	0	0
264882	1678	11520366327000	10781	5565	1	0	0
264883	1874	202975000	10781	5565	2	0	0
264884	1874	202976000	10781	5565	3	0	0
264929	1678	10800326189000	10784	5443	36	0	\N
264930	1678	10800326190000	10784	5443	37	0	\N
264931	1678	10800326191000	10784	5443	38	0	\N
264932	1678	10800326192000	10784	5443	39	0	\N
264933	1678	10800326193000	10784	5443	40	0	\N
264934	1678	10800326194000	10784	5443	41	0	\N
264935	1678	10800326195000	10784	5443	42	0	\N
264936	1678	10800326196000	10784	5443	43	0	\N
264937	1678	10800326197000	10784	5443	44	0	\N
264938	1678	10800326198000	10784	5443	45	0	\N
264939	1678	10800326199000	10784	5443	46	0	\N
264940	1678	10800326200000	10784	5443	47	0	\N
264941	1678	10800326201000	10784	5443	48	0	\N
264942	1678	10800326202000	10784	5443	49	0	\N
264943	1678	10800326203000	10784	5443	50	0	\N
264944	1678	10800326204000	10784	5443	51	0	\N
264945	1678	10800326205000	10784	5443	52	0	\N
264946	1678	10800326206000	10784	5443	53	0	\N
264947	1678	10800326207000	10784	5443	54	0	\N
264948	1678	10800326208000	10784	5443	55	0	\N
264949	1678	10800326209000	10784	5443	56	0	\N
264950	1678	10800326210000	10784	5443	57	0	\N
264951	1678	10800326211000	10784	5443	58	0	\N
264952	1678	10800326212000	10784	5443	59	0	\N
264953	1678	10800326213000	10784	5443	60	0	\N
264954	1678	10800326214000	10784	5443	61	0	\N
264955	1678	10800326215000	10784	5443	62	0	\N
264956	1678	10800326216000	10784	5443	63	0	\N
264957	1678	10800326217000	10784	5443	64	0	\N
264958	1678	10800326218000	10784	5443	65	0	\N
264959	1678	10800326219000	10784	5443	66	0	\N
264960	1678	10800326220000	10784	5443	67	0	\N
264961	1678	10800326221000	10784	5443	68	0	\N
264962	1678	10800326222000	10784	5443	69	0	\N
264963	1678	10800326223000	10784	5443	70	0	\N
264964	1678	10800326224000	10784	5443	71	0	\N
264965	1678	10800326225000	10784	5443	72	0	\N
264966	1678	10800326226000	10784	5443	73	0	\N
264967	1678	10800326227000	10784	5443	74	0	\N
264968	1678	10800326228000	10784	5443	75	0	\N
264969	1678	10800326229000	10784	5443	76	0	\N
264970	1678	10800326230000	10784	5443	77	0	\N
264971	1678	10800326231000	10784	5443	78	0	\N
264972	1678	10800326232000	10784	5443	79	0	\N
264973	1678	10800326233000	10784	5443	80	0	\N
264974	1678	10800326234000	10784	5443	81	0	\N
264975	1678	10800326235000	10784	5443	82	0	\N
264976	1678	10800326236000	10784	5443	83	0	\N
264977	1678	10800326237000	10784	5443	84	0	\N
264978	1678	10800326238000	10784	5443	85	0	\N
264979	1678	10800326239000	10784	5443	86	0	\N
264980	1678	10800326240000	10784	5443	87	0	\N
264981	1678	10800326241000	10784	5443	88	0	\N
264982	1678	10800326242000	10784	5443	89	0	\N
264983	1678	10800326243000	10784	5443	90	0	\N
264984	1678	10800326244000	10784	5443	91	0	\N
264985	1678	10800326245000	10784	5443	92	0	\N
264986	1678	10800326246000	10784	5443	93	0	\N
264987	1678	10800326247000	10784	5443	94	0	\N
264988	1678	10800326248000	10784	5443	95	0	\N
264989	1678	10800326249000	10784	5443	96	0	\N
264990	1678	10800326250000	10784	5443	97	0	\N
264991	1678	10800326251000	10784	5443	98	0	\N
264992	1678	10800326252000	10784	5443	99	0	\N
264993	1678	10800326253000	10784	5443	100	0	\N
264994	1678	10800326254000	10784	5443	101	0	\N
264995	1678	10800326255000	10784	5443	102	0	\N
264996	1678	10800326256000	10784	5443	103	0	\N
264997	1678	10800326257000	10784	5443	104	0	\N
264998	1678	10800326258000	10784	5443	105	0	\N
264999	1678	10800326259000	10784	5443	106	0	\N
265000	1678	10800326260000	10784	5443	107	0	\N
265001	1678	10800326261000	10784	5443	108	0	\N
265002	1678	10800326262000	10784	5443	109	0	\N
265003	1678	10800326263000	10784	5443	110	0	\N
265004	1678	10800326264000	10784	5443	111	0	\N
265005	1678	10800326265000	10784	5443	113	0	\N
265006	1678	10800326266000	10784	5443	114	0	\N
265007	1678	10800326267000	10784	5443	115	0	\N
265008	1678	10800326268000	10784	5443	116	0	\N
265009	1678	10800326269000	10784	5443	117	0	\N
265010	1678	10800326270000	10784	5443	118	0	\N
265011	1678	10800326271000	10784	5443	119	0	\N
265012	1678	10800326272000	10784	5443	120	0	\N
265013	1678	10800326273000	10784	5443	121	0	\N
265014	1678	10800326274000	10784	5443	122	0	\N
265015	1678	10800326275000	10784	5443	123	0	\N
265016	1678	10800326276000	10784	5443	124	0	\N
265017	1678	10800326277000	10784	5443	125	0	\N
265022	1329	1701172304412514	10786	5567	0	0	\N
265023	1678	11520366329000	10786	5567	1	0	\N
265024	1874	202978000	10786	5567	2	0	\N
265039	1874	202984000	10791	5571	0	0	\N
265040	1874	202985000	10791	5571	1	0	\N
265041	1874	202986000	10791	5571	2	0	\N
265042	1678	11520366335000	10791	5571	3	0	\N
265043	1678	11520366336000	10791	5571	4	0	\N
265044	1678	11520366337000	10791	5571	5	0	\N
265056	1540	0	10794	5572	0	0	\N
265057	1874	202987000	10794	5572	1	0	\N
265058	1874	202988000	10794	5572	2	0	\N
265059	1678	11520366338000	10794	5572	3	0	\N
265060	1678	11520366339000	10794	5572	4	0	\N
265061	1540	0	10795	5572	0	0	\N
265062	1874	202987000	10795	5572	1	0	\N
265063	1874	202988000	10795	5572	2	0	\N
265064	1678	11520366338000	10795	5572	3	0	\N
265020	1678	11520366328000	10785	5566	2	0	0
265021	1474	9015010660887	10785	5566	3	0	11
265025	1329	1701172304412514	10787	5567	0	0	0
265026	1678	11520366329000	10787	5567	1	0	0
265027	1874	202978000	10787	5567	2	0	0
265029	1678	11520366330000	10788	5568	1	0	0
265030	1678	11520366331000	10788	5568	2	0	0
265031	1874	202980000	10788	5568	3	0	0
265032	1874	202981000	10789	5569	0	0	0
265033	1678	11520366332000	10789	5569	1	0	0
265035	1678	11520366333000	10790	5570	1	0	0
265036	1678	11520366334000	10790	5570	2	0	0
265037	1874	202983000	10790	5570	3	0	0
265038	1474	1824334000023	10790	5570	4	0	12
265046	1874	202985000	10792	5571	1	0	0
265047	1874	202986000	10792	5571	2	0	0
265048	1678	11520366335000	10792	5571	3	0	0
265049	1678	11520366336000	10792	5571	4	0	0
265050	1678	11520366337000	10792	5571	5	0	0
265052	1874	202987000	10793	5572	1	0	0
265053	1874	202988000	10793	5572	2	0	0
265054	1678	11520366338000	10793	5572	3	0	0
265055	1678	11520366339000	10793	5572	4	0	0
265065	1678	11520366339000	10795	5572	4	0	\N
265066	1678	11520366340000	10796	5573	0	0	\N
265067	1874	202989000	10796	5573	1	0	\N
265068	1678	11520366340000	10797	5573	0	0	\N
265069	1874	202989000	10797	5573	1	0	\N
265070	1678	11520366340000	10798	5573	0	0	\N
265071	1874	202989000	10798	5573	1	0	\N
265083	1540	0	10802	5444	0	0	\N
265084	1329	1701172304412514	10802	5444	1	0	\N
265085	1678	10800326278000	10802	5444	2	0	\N
265086	1678	10800326279000	10802	5444	3	0	\N
265087	1678	10800326280000	10802	5444	4	0	\N
265088	1678	10800326281000	10802	5444	5	0	\N
265089	1678	10800326282000	10802	5444	6	0	\N
265090	1227	611100190000000	10802	5444	7	0	\N
265091	1678	10800326283000	10802	5444	8	0	\N
265092	1678	10800326284000	10802	5444	9	0	\N
265093	1678	10800326285000	10802	5444	10	0	\N
265094	1678	10800326286000	10802	5444	11	0	\N
265095	1678	10800326287000	10802	5444	12	0	\N
265096	1678	10800326288000	10802	5444	13	0	\N
265097	1678	10800326289000	10802	5444	14	0	\N
265098	1678	10800326290000	10802	5444	15	0	\N
265099	1678	10800326291000	10802	5444	16	0	\N
265100	1678	10800326292000	10802	5444	17	0	\N
265101	1678	10800326293000	10802	5444	18	0	\N
265102	1678	10800326294000	10802	5444	19	0	\N
265103	1678	10800326295000	10802	5444	20	0	\N
265104	1678	10800326296000	10802	5444	21	0	\N
265105	1678	10800326297000	10802	5444	22	0	\N
265106	1678	10800326298000	10802	5444	23	0	\N
265107	1678	10800326299000	10802	5444	24	0	\N
265108	1678	10800326300000	10802	5444	25	0	\N
265109	1678	10800326301000	10802	5444	26	0	\N
265110	1678	10800326302000	10802	5444	27	0	\N
265111	1678	10800326303000	10802	5444	28	0	\N
265112	1678	10800326304000	10802	5444	29	0	\N
265113	1678	10800326305000	10802	5444	30	0	\N
265114	1678	10800326306000	10802	5444	31	0	\N
265115	1678	10800326307000	10802	5444	32	0	\N
265116	1678	10800326308000	10802	5444	33	0	\N
265117	1678	10800326309000	10802	5444	34	0	\N
265118	1678	10800326310000	10802	5444	35	0	\N
265119	1678	10800326311000	10802	5444	36	0	\N
265120	1678	10800326312000	10802	5444	37	0	\N
265121	1678	10800326313000	10802	5444	38	0	\N
265122	1678	10800326314000	10802	5444	39	0	\N
265123	1678	10800326315000	10802	5444	40	0	\N
265124	1678	10800326316000	10802	5444	41	0	\N
265125	1678	10800326317000	10802	5444	42	0	\N
265126	1678	10800326318000	10802	5444	43	0	\N
265127	1678	10800326319000	10802	5444	44	0	\N
265128	1678	10800326320000	10802	5444	45	0	\N
265129	1678	10800326321000	10802	5444	46	0	\N
265130	1678	10800326322000	10802	5444	47	0	\N
265131	1678	10800326323000	10802	5444	48	0	\N
265132	1678	10800326324000	10802	5444	49	0	\N
265133	1678	10800326325000	10802	5444	50	0	\N
265134	1678	10800326326000	10802	5444	51	0	\N
265135	1678	10800326327000	10802	5444	52	0	\N
265136	1678	10800326328000	10802	5444	53	0	\N
265137	1678	10800326329000	10802	5444	54	0	\N
265138	1678	10800326330000	10802	5444	55	0	\N
265139	1678	10800326331000	10802	5444	56	0	\N
265140	1678	10800326332000	10802	5444	57	0	\N
265141	1678	10800326333000	10802	5444	58	0	\N
265142	1678	10800326334000	10802	5444	59	0	\N
265143	1678	10800326335000	10802	5444	60	0	\N
265144	1678	10800326336000	10802	5444	61	0	\N
265145	1678	10800326337000	10802	5444	62	0	\N
265146	1678	10800326338000	10802	5444	63	0	\N
265147	1678	10800326339000	10802	5444	64	0	\N
265148	1678	10800326340000	10802	5444	65	0	\N
265149	1678	10800326341000	10802	5444	66	0	\N
265150	1678	10800326342000	10802	5444	67	0	\N
265151	1678	10800326343000	10802	5444	68	0	\N
265152	1678	10800326344000	10802	5444	69	0	\N
265153	1874	202813000	10802	5444	70	0	\N
265154	1874	202814000	10802	5444	71	0	\N
265155	1874	202815000	10802	5444	72	0	\N
265156	1874	202816000	10802	5444	73	0	\N
265157	1874	202817000	10802	5444	74	0	\N
265158	1874	202818000	10802	5444	75	0	\N
265159	1874	202819000	10802	5444	76	0	\N
265160	1874	202820000	10802	5444	77	0	\N
265161	1874	202821000	10802	5444	78	0	\N
265162	1874	202822000	10802	5444	79	0	\N
265163	1874	202823000	10802	5444	80	0	\N
265164	1874	202824000	10802	5444	81	0	\N
265165	1874	202825000	10802	5444	82	0	\N
265166	1874	202826000	10802	5444	83	0	\N
265167	1874	202827000	10802	5444	84	0	\N
265168	1874	202828000	10802	5444	85	0	\N
265169	1874	202829000	10802	5444	86	0	\N
265170	1874	202830000	10802	5444	87	0	\N
265171	1874	202831000	10802	5444	88	0	\N
265172	1874	202832000	10802	5444	89	0	\N
265173	1874	202833000	10802	5444	90	0	\N
265174	1874	202834000	10802	5444	91	0	\N
265175	1874	202835000	10802	5444	92	0	\N
265176	1874	202836000	10802	5444	93	0	\N
265177	1874	202837000	10802	5444	94	0	\N
265178	1874	202838000	10802	5444	95	0	\N
265179	1874	202839000	10802	5444	96	0	\N
265180	1874	202840000	10802	5444	97	0	\N
265181	1874	202841000	10802	5444	98	0	\N
265182	1874	202842000	10802	5444	99	0	\N
265183	1874	202843000	10802	5444	100	0	\N
265184	1874	202844000	10802	5444	101	0	\N
265185	1874	202845000	10802	5444	102	0	\N
265186	1874	202846000	10802	5444	103	0	\N
265187	1874	202847000	10802	5444	104	0	\N
265188	1874	202848000	10802	5444	105	0	\N
265189	1874	202849000	10802	5444	106	0	\N
265190	1874	202850000	10802	5444	107	0	\N
265191	1874	202851000	10802	5444	108	0	\N
265192	1874	202852000	10802	5444	109	0	\N
265193	1874	202853000	10802	5444	110	0	\N
265194	1874	202854000	10802	5444	111	0	\N
265195	1874	202855000	10802	5444	113	0	\N
265196	1874	202856000	10802	5444	114	0	\N
265197	1874	202857000	10802	5444	115	0	\N
265198	1874	202858000	10802	5444	116	0	\N
265199	1874	202859000	10802	5444	117	0	\N
265200	1874	202860000	10802	5444	118	0	\N
265074	1678	11520366341000	10800	5574	0	0	0
265075	1874	202990000	10800	5574	1	0	0
265076	1678	11520366342000	10800	5574	2	0	0
265077	1227	611100190000000	10800	5574	3	0	0
265078	1874	202991000	10800	5574	4	0	0
265080	1678	11520366344000	10801	5575	1	0	0
265081	1874	202992000	10801	5575	2	0	0
265082	1874	202993000	10801	5575	3	0	0
265201	1874	202861000	10802	5444	119	0	\N
265202	1874	202862000	10802	5444	120	0	\N
265203	1874	202863000	10802	5444	121	0	\N
265204	1874	202864000	10802	5444	122	0	\N
265205	1874	202865000	10802	5444	123	0	\N
265206	1874	202866000	10802	5444	124	0	\N
265207	1874	202867000	10802	5444	125	0	\N
265208	1874	202994000	10803	5576	0	0	\N
265209	1874	202995000	10803	5576	1	0	\N
265210	1678	11520366345000	10803	5576	2	0	\N
265211	1678	11520366346000	10803	5576	3	0	\N
265218	1678	11520366348000	10806	5578	0	0	\N
265219	1874	202997000	10806	5578	1	0	\N
265220	1107	905709405000000	10806	5578	2	0	\N
265221	1678	11520366348000	10807	5578	0	0	\N
265222	1874	202997000	10807	5578	1	0	\N
265223	1107	905709405000000	10807	5578	2	0	\N
265227	1540	0	10809	5419	0	0	\N
265228	1229	610709990000000	10809	5419	1	0	\N
265229	1109	905131095000000	10809	5419	2	0	\N
265230	1355	1701797667751650	10809	5419	3	0	\N
265231	987	505420615000000	10809	5419	4	0	\N
265232	1541	1036000000	10809	5419	5	0	\N
265233	1678	10080286174000	10809	5419	6	0	\N
265234	1678	10080286175000	10809	5419	7	0	\N
265235	1678	10080286176000	10809	5419	8	0	\N
265236	1678	10080286177000	10809	5419	9	0	\N
265237	1678	10080286178000	10809	5419	10	0	\N
265238	1541	2036000000	10809	5419	11	0	\N
265239	963	504912280012457	10809	5419	12	0	\N
265240	1083	904798479693893	10809	5419	13	0	\N
265241	1203	610485563632763	10809	5419	14	0	\N
265242	1329	1701172304412514	10809	5419	15	0	\N
265243	1678	10080286179000	10809	5419	16	0	\N
265244	1678	10080286180000	10809	5419	17	0	\N
265245	1678	10080286181000	10809	5419	18	0	\N
265246	1227	611100190000000	10809	5419	19	0	\N
265247	1678	10080286182000	10809	5419	20	0	\N
265248	1678	10080286183000	10809	5419	21	0	\N
265249	1678	10080286184000	10809	5419	22	0	\N
265250	1678	10080286185000	10809	5419	24	0	\N
265251	1678	10080286186000	10809	5419	25	0	\N
265252	1678	10080286187000	10809	5419	26	0	\N
265253	1678	10080286188000	10809	5419	27	0	\N
265254	1678	10080286189000	10809	5419	28	0	\N
265255	1678	10080286190000	10809	5419	29	0	\N
265256	1678	10080286191000	10809	5419	30	0	\N
265257	1678	10080286192000	10809	5419	31	0	\N
265258	1678	10080286193000	10809	5419	32	0	\N
265259	1678	10080286194000	10809	5419	33	0	\N
265260	1678	10080286195000	10809	5419	34	0	\N
265261	1678	10080286196000	10809	5419	35	0	\N
265262	1678	10080286197000	10809	5419	36	0	\N
265263	1678	10080286198000	10809	5419	37	0	\N
265264	1678	10080286199000	10809	5419	38	0	\N
265265	1678	10080286200000	10809	5419	39	0	\N
265266	1678	10080286201000	10809	5419	40	0	\N
265267	1678	10080286202000	10809	5419	41	0	\N
265268	1678	10080286203000	10809	5419	42	0	\N
265269	1107	905709405000000	10809	5419	43	0	\N
265270	1678	10080286204000	10809	5419	44	0	\N
265271	1678	10080286205000	10809	5419	45	0	\N
265272	1678	10080286206000	10809	5419	46	0	\N
265273	1678	10080286207000	10809	5419	47	0	\N
265274	1678	10080286208000	10809	5419	48	0	\N
265275	1678	10080286209000	10809	5419	49	0	\N
265276	1678	10080286210000	10809	5419	50	0	\N
265277	1678	10080286211000	10809	5419	51	0	\N
265278	1678	10080286212000	10809	5419	52	0	\N
265279	1678	10080286213000	10809	5419	53	0	\N
265280	1678	10080286214000	10809	5419	54	0	\N
265281	1678	10080286215000	10809	5419	55	0	\N
265282	1678	10080286216000	10809	5419	56	0	\N
265283	1678	10080286217000	10809	5419	57	0	\N
265284	1678	10080286218000	10809	5419	58	0	\N
265285	1678	10080286219000	10809	5419	59	0	\N
265286	1678	10080286220000	10809	5419	60	0	\N
265287	1678	10080286221000	10809	5419	61	0	\N
265288	1678	10080286222000	10809	5419	62	0	\N
265289	1678	10080286223000	10809	5419	63	0	\N
265290	1678	10080286224000	10809	5419	64	0	\N
265291	1678	10080286225000	10809	5419	65	0	\N
265292	1678	10080286226000	10809	5419	66	0	\N
265293	1678	10080286227000	10809	5419	67	0	\N
265294	1678	10080286228000	10809	5419	68	0	\N
265295	1678	10080286229000	10809	5419	69	0	\N
265296	1678	10080286230000	10809	5419	70	0	\N
265297	1678	10080286231000	10809	5419	71	0	\N
265298	1678	10080286232000	10809	5419	72	0	\N
265299	1678	10080286233000	10809	5419	73	0	\N
265300	1678	10080286234000	10809	5419	74	0	\N
265301	1678	10080286235000	10809	5419	75	0	\N
265302	1678	10080286236000	10809	5419	76	0	\N
265303	1678	10080286237000	10809	5419	77	0	\N
265304	1678	10080286238000	10809	5419	78	0	\N
265305	1678	10080286239000	10809	5419	79	0	\N
265306	1678	10080286240000	10809	5419	80	0	\N
265307	1678	10080286241000	10809	5419	81	0	\N
265308	1678	10080286242000	10809	5419	82	0	\N
265309	1678	10080286243000	10809	5419	83	0	\N
265310	1678	10080286244000	10809	5419	84	0	\N
265311	1678	10080286245000	10809	5419	85	0	\N
265312	1678	10080286246000	10809	5419	86	0	\N
265313	1678	10080286247000	10809	5419	87	0	\N
265314	1678	10080286248000	10809	5419	88	0	\N
265315	1678	10080286249000	10809	5419	89	0	\N
265316	1678	10080286250000	10809	5419	90	0	\N
265317	1678	10080286251000	10809	5419	91	0	\N
265318	1678	10080286252000	10809	5419	92	0	\N
265319	1678	10080286253000	10809	5419	93	0	\N
265320	1678	10080286254000	10809	5419	94	0	\N
265321	1678	10080286255000	10809	5419	95	0	\N
265322	1678	10080286256000	10809	5419	96	0	\N
265323	1678	10080286257000	10809	5419	97	0	\N
265324	1678	10080286258000	10809	5419	98	0	\N
265325	1678	10080286259000	10809	5419	99	0	\N
265326	1678	10080286260000	10809	5419	100	0	\N
265327	1678	10080286261000	10809	5419	101	0	\N
265328	1678	10080286262000	10809	5419	102	0	\N
265329	1678	10080286263000	10809	5419	103	0	\N
265330	1678	10080286264000	10809	5419	104	0	\N
265331	1678	10080286265000	10809	5419	105	0	\N
265332	1678	10080286266000	10809	5419	106	0	\N
265333	1678	10080286267000	10809	5419	107	0	\N
265334	1678	10080286268000	10809	5419	108	0	\N
265335	1678	10080286269000	10809	5419	109	0	\N
265336	1678	10080286270000	10809	5419	110	0	\N
265214	1678	11520366345000	10804	5576	2	0	0
265215	1678	11520366346000	10804	5576	3	0	0
265216	1678	11520366347000	10805	5577	0	0	0
265217	1874	202996000	10805	5577	1	0	0
265224	1678	11520366348000	10808	5578	0	0	0
265226	1107	905709405000000	10808	5578	2	0	0
265337	1678	10080286271000	10809	5419	111	0	\N
265338	1678	10080286272000	10809	5419	112	0	\N
265339	1678	10080286273000	10809	5419	113	0	\N
265340	1678	10080286274000	10809	5419	114	0	\N
265341	1678	10080286275000	10809	5419	115	0	\N
265342	1678	10080286276000	10809	5419	116	0	\N
265343	1678	10080286277000	10809	5419	117	0	\N
265344	1678	10080286278000	10809	5419	118	0	\N
265345	1678	10080286279000	10809	5419	119	0	\N
265346	1678	10080286280000	10809	5419	120	0	\N
265347	1678	10080286281000	10809	5419	121	0	\N
265348	1678	10080286282000	10809	5419	122	0	\N
265349	1678	10080286283000	10809	5419	123	0	\N
265350	1678	10080286284000	10809	5419	124	0	\N
265351	1678	10080286285000	10809	5419	125	0	\N
265352	1874	202998000	10810	5579	0	0	\N
265353	1678	11520366349000	10810	5579	1	0	\N
265354	932	504510255942128	10810	5579	2	0	\N
265358	1874	202998000	10812	5579	0	0	\N
265359	1678	11520366349000	10812	5579	1	0	\N
265360	1874	202999000	10813	5580	0	0	\N
265361	1678	11520366350000	10813	5580	1	0	\N
265364	1678	11520366350000	10815	5580	0	0	\N
265375	1874	203003000	10817	5582	1	0	\N
265376	1678	11520366354000	10817	5582	2	0	\N
265379	1678	11520366355000	10819	5583	0	0	\N
265380	1874	203004000	10819	5583	1	0	\N
265383	1678	11520366355000	10821	5583	0	0	\N
265384	1874	203004000	10821	5583	1	0	\N
265391	2034	200000000	10824	5585	0	0	\N
265392	2035	200000000	10824	5585	1	0	\N
265393	1874	203006000	10824	5585	2	0	\N
265394	1678	11520366358000	10825	5586	0	0	\N
265395	2036	200000000	10825	5586	1	0	\N
265396	1874	203007000	10825	5586	2	0	\N
265397	1678	11520366358000	10826	5586	0	0	\N
265398	2036	200000000	10826	5586	1	0	\N
265399	1874	203007000	10826	5586	2	0	\N
265410	1874	203010000	10831	5589	0	0	\N
265411	1678	11520366362000	10831	5589	1	0	\N
265412	1678	11520366359000	10832	5587	0	0	\N
265413	1678	11520366360000	10832	5587	1	0	\N
265414	1678	11520366361000	10832	5587	2	0	\N
265415	1678	11520366362000	10832	5587	3	0	\N
265436	2037	862000000000	10837	5593	0	0	\N
265437	598	66000000000287	10837	5593	1	0	\N
265438	1007	502777775002188	10837	5593	2	0	\N
265439	1247	607904750002645	10837	5593	3	0	\N
265440	1127	900973465003921	10837	5593	4	0	\N
265441	1874	203015000	10837	5593	5	0	\N
265442	1874	203016000	10837	5593	6	0	\N
265443	1678	11520366367000	10837	5593	7	0	\N
265444	1678	11520366368000	10837	5593	8	0	\N
265445	2037	862000000000	10838	5593	0	0	\N
265446	598	66000000000287	10838	5593	1	0	\N
265447	1007	502777775002188	10838	5593	2	0	\N
265448	1247	607904750002645	10838	5593	3	0	\N
265449	1127	900973465003921	10838	5593	4	0	\N
265450	1874	203015000	10838	5593	5	0	\N
265451	1874	203016000	10838	5593	6	0	\N
265452	1678	11520366367000	10838	5593	7	0	\N
265453	1678	11520366368000	10838	5593	8	0	\N
265454	1678	11520366369000	10839	5594	0	0	\N
265455	1373	1693980637759023	10839	5594	1	0	\N
265469	1874	203021000	10843	5596	0	0	\N
265470	1678	11520366372000	10843	5596	1	0	\N
265471	1007	502777775004376	10843	5596	2	0	\N
265472	1247	607904750005290	10843	5596	3	0	\N
265357	932	504510255942128	10811	5579	2	0	0
265362	1874	202999000	10814	5580	0	0	0
265363	1678	11520366350000	10814	5580	1	0	0
265365	1678	11520366351000	10816	5581	0	0	0
265366	1678	11520366352000	10816	5581	1	0	0
265368	1874	203001000	10816	5581	3	0	0
265369	1874	203002000	10816	5581	4	0	0
265370	1678	11520366353000	10816	5581	5	0	0
265371	1353	1702884997751650	10816	5581	6	0	0
265372	1052	904078056004405	10816	5581	7	0	0
265374	1298	1699817787516770	10816	5581	9	0	0
265377	1874	203003000	10818	5582	1	0	0
265378	1678	11520366354000	10818	5582	2	0	0
265381	1678	11520366355000	10820	5583	0	0	0
265385	1874	203005000	10822	5584	0	0	0
265386	1678	11520366356000	10822	5584	1	0	0
265387	1678	11520366357000	10822	5584	2	0	0
265388	2034	200000000	10823	5585	0	0	0
265389	2035	200000000	10823	5585	1	0	0
265400	1678	11520366358000	10827	5586	0	0	0
265401	2036	200000000	10827	5586	1	0	0
265402	1874	203007000	10827	5586	2	0	0
265403	1678	11520366359000	10828	5587	0	0	0
265404	1874	203008000	10828	5587	1	0	0
265406	1678	11520366360000	10828	5587	3	0	0
265407	1678	11520366361000	10829	5588	0	0	0
265408	1874	203010000	10830	5589	0	0	0
265409	1678	11520366362000	10830	5589	1	0	0
265417	1678	11520366364000	10833	5590	1	0	0
265418	1874	203011000	10833	5590	2	0	0
265419	2037	0	10833	5590	3	0	0
265420	1874	203012000	10833	5590	4	0	0
265421	2038	200000000	10833	5590	5	0	0
265423	1874	203014000	10834	5591	1	0	0
265424	1678	11520366365000	10834	5591	2	0	0
265425	1678	11520366366000	10834	5591	3	0	0
265426	2037	862000000000	10836	5593	0	0	0
265427	598	66000000000287	10836	5593	1	0	0
265429	1247	607904750002645	10836	5593	3	0	0
265430	1127	900973465003921	10836	5593	4	0	0
265431	1874	203015000	10836	5593	5	0	0
265432	1874	203016000	10836	5593	6	0	0
265434	1678	11520366367000	10836	5593	8	0	0
265435	1678	11520366368000	10836	5593	9	0	0
265456	1678	11520366369000	10840	5594	0	0	0
265457	1373	1693980637759023	10840	5594	1	0	0
265458	2039	1000000000	10841	5595	0	0	0
265460	1678	11520366370000	10841	5595	2	0	0
265461	598	66000000000574	10841	5595	3	0	0
265462	1678	11520366371000	10841	5595	4	0	0
265463	1874	203019000	10841	5595	5	0	0
265464	1874	203020000	10841	5595	6	0	0
265466	1247	607904750005290	10842	5596	1	0	0
265467	1127	900973465007842	10842	5596	2	0	0
265468	1373	1693980637766396	10842	5596	3	0	0
265473	1127	900973465007842	10843	5596	4	0	\N
265474	1373	1693980637766396	10843	5596	5	0	\N
265475	1874	203021000	10844	5596	0	0	\N
265476	1678	11520366372000	10844	5596	1	0	\N
265477	1007	502777775004376	10844	5596	2	0	\N
265478	1247	607904750005290	10844	5596	3	0	\N
265479	1127	900973465007842	10844	5596	4	0	\N
265480	1373	1693980637766396	10844	5596	5	0	\N
265490	1247	610550725005290	10847	5599	0	0	\N
265491	1127	904895054007842	10847	5599	1	0	\N
265492	1678	11520366375000	10847	5599	2	0	\N
265493	1874	203024000	10847	5599	3	0	\N
265494	1373	1701353880766396	10847	5599	4	0	\N
265508	1874	203027000	10851	5601	0	0	\N
265509	1678	11520366378000	10851	5601	1	0	\N
265520	2039	1000000000	10854	5445	0	0	\N
265521	1874	202868000	10854	5445	2	0	\N
265522	1874	202869000	10854	5445	3	0	\N
265523	1874	202870000	10854	5445	4	0	\N
265524	1874	202871000	10854	5445	5	0	\N
265525	2037	0	10854	5445	6	0	\N
265526	2037	862000000000	10854	5445	7	0	\N
265527	598	66000000000287	10854	5445	8	0	\N
265528	1007	502777775002188	10854	5445	9	0	\N
265529	1247	607904750002645	10854	5445	10	0	\N
265530	1127	900973465003921	10854	5445	11	0	\N
265531	1373	1693980637759023	10854	5445	12	0	\N
265532	598	66000000000574	10854	5445	13	0	\N
265533	1007	502777775004376	10854	5445	14	0	\N
265534	1874	202872000	10854	5445	15	0	\N
265535	1874	202873000	10854	5445	16	0	\N
265536	1247	607904750005290	10854	5445	17	0	\N
265537	1127	900973465007842	10854	5445	18	0	\N
265538	1373	1693980637766396	10854	5445	19	0	\N
265539	598	66287273000574	10854	5445	20	0	\N
265540	1007	504966173004376	10854	5445	21	0	\N
265541	1247	610550725005290	10854	5445	22	0	\N
265542	1127	904895054007842	10854	5445	23	0	\N
265543	1373	1701353880766396	10854	5445	24	0	\N
265544	1678	10800326345000	10854	5445	25	0	\N
265545	1678	10800326346000	10854	5445	26	0	\N
265546	1678	10800326347000	10854	5445	27	0	\N
265547	1678	10800326348000	10854	5445	28	0	\N
265548	1678	10800326349000	10854	5445	29	0	\N
265549	1678	10800326350000	10854	5445	30	0	\N
265550	1678	10800326351000	10854	5445	31	0	\N
265551	1678	10800326352000	10854	5445	32	0	\N
265552	1678	10800326353000	10854	5445	33	0	\N
265553	1678	10800326354000	10854	5445	34	0	\N
265554	1678	10800326355000	10854	5445	35	0	\N
265555	1678	10800326356000	10854	5445	36	0	\N
265556	1678	10800326357000	10854	5445	37	0	\N
265557	1678	10800326358000	10854	5445	38	0	\N
265558	1678	10800326359000	10854	5445	39	0	\N
265559	1678	10800326360000	10854	5445	40	0	\N
265560	1678	10800326361000	10854	5445	41	0	\N
265561	1678	10800326362000	10854	5445	42	0	\N
265562	1678	10800326363000	10854	5445	43	0	\N
265563	1678	10800326364000	10854	5445	44	0	\N
265564	1678	10800326365000	10854	5445	45	0	\N
265565	1678	10800326366000	10854	5445	46	0	\N
265566	1874	202874000	10854	5445	47	0	\N
265567	1874	202875000	10854	5445	48	0	\N
265568	1874	202876000	10854	5445	49	0	\N
265569	1874	202877000	10854	5445	50	0	\N
265570	1874	202878000	10854	5445	51	0	\N
265571	1874	202879000	10854	5445	52	0	\N
265572	1874	202880000	10854	5445	53	0	\N
265573	1874	202881000	10854	5445	54	0	\N
265574	1874	202882000	10854	5445	55	0	\N
265575	1874	202883000	10854	5445	56	0	\N
265576	1874	202884000	10854	5445	57	0	\N
265577	1874	202885000	10854	5445	58	0	\N
265578	1874	202886000	10854	5445	59	0	\N
265579	1874	202887000	10854	5445	60	0	\N
265580	1874	202888000	10854	5445	61	0	\N
265581	1874	202889000	10854	5445	62	0	\N
265582	1678	10800326367000	10854	5445	63	0	\N
265583	1678	10800326368000	10854	5445	64	0	\N
265584	1678	10800326369000	10854	5445	65	0	\N
265585	1678	10800326370000	10854	5445	66	0	\N
265586	1678	10800326371000	10854	5445	67	0	\N
265587	1678	10800326372000	10854	5445	68	0	\N
265588	1678	10800326373000	10854	5445	69	0	\N
265589	1678	10800326374000	10854	5445	70	0	\N
265590	1678	10800326375000	10854	5445	71	0	\N
265591	1678	10800326376000	10854	5445	72	0	\N
265592	1678	10800326377000	10854	5445	73	0	\N
265593	1678	10800326378000	10854	5445	74	0	\N
265594	1678	10800326379000	10854	5445	75	0	\N
265595	1678	10800326380000	10854	5445	76	0	\N
265596	1678	10800326381000	10854	5445	77	0	\N
265597	1678	10800326382000	10854	5445	78	0	\N
265598	1678	10800326383000	10854	5445	79	0	\N
265599	1107	905709405000000	10854	5445	80	0	\N
265600	1353	1702884997751650	10854	5445	81	0	\N
265601	1874	202890000	10854	5445	82	0	\N
265602	1874	202891000	10854	5445	83	0	\N
265603	1874	202892000	10854	5445	84	0	\N
265604	1874	202893000	10854	5445	85	0	\N
265605	1874	202894000	10854	5445	86	0	\N
265606	1874	202895000	10854	5445	87	0	\N
265607	1874	202896000	10854	5445	88	0	\N
265608	1874	202897000	10854	5445	89	0	\N
265483	1874	203021000	10845	5597	2	0	0
265484	1874	203022000	10845	5597	3	0	0
265485	1678	11520366372000	10845	5597	4	0	0
265486	1678	11520366373000	10845	5597	5	0	0
265487	480	66001020000000	10845	5597	6	0	0
265489	1874	203023000	10846	5598	1	0	0
265495	1247	610550725005290	10848	5599	0	0	0
265496	1127	904895054007842	10848	5599	1	0	0
265497	1678	11520366375000	10848	5599	2	0	0
265498	1874	203024000	10848	5599	3	0	0
265500	1678	11520366376000	10849	5600	0	0	0
265501	1678	11520366377000	10849	5600	1	0	0
265502	1874	203025000	10849	5600	2	0	0
265503	1874	203026000	10849	5600	3	0	0
265505	95	66000000000000	10849	5600	5	0	0
265506	1874	203027000	10850	5601	0	0	0
265507	1678	11520366378000	10850	5601	1	0	0
265510	1678	11520366379000	10852	5602	0	0	0
265511	1678	11520366380000	10852	5602	1	0	0
265513	1874	203029000	10852	5602	3	0	0
265514	1678	11520366381000	10853	5603	0	0	0
265515	1678	11520366382000	10853	5603	1	0	0
265516	1874	203030000	10853	5603	2	0	0
265517	1678	11520366383000	10853	5603	3	0	0
265519	1874	203032000	10853	5603	5	0	0
265609	1874	202898000	10854	5445	90	0	\N
265610	1874	202899000	10854	5445	91	0	\N
265611	1874	202900000	10854	5445	92	0	\N
265612	1874	202901000	10854	5445	93	0	\N
265613	1874	202902000	10854	5445	94	0	\N
265614	1874	202903000	10854	5445	95	0	\N
265615	1874	202904000	10854	5445	96	0	\N
265616	1874	202905000	10854	5445	97	0	\N
265617	1874	202906000	10854	5445	98	0	\N
265618	1874	202907000	10854	5445	99	0	\N
265619	1874	202908000	10854	5445	100	0	\N
265620	1874	202909000	10854	5445	101	0	\N
265621	1874	202910000	10854	5445	102	0	\N
265622	1874	202911000	10854	5445	103	0	\N
265623	1874	202912000	10854	5445	104	0	\N
265624	1874	202913000	10854	5445	105	0	\N
265625	1874	202914000	10854	5445	106	0	\N
265626	1874	202915000	10854	5445	107	0	\N
265627	1874	202916000	10854	5445	108	0	\N
265628	1874	202917000	10854	5445	109	0	\N
265629	1874	202918000	10854	5445	110	0	\N
265630	1874	202919000	10854	5445	111	0	\N
265631	1874	202920000	10854	5445	113	0	\N
265632	1874	202921000	10854	5445	114	0	\N
265633	1874	202922000	10854	5445	115	0	\N
265638	1678	11520366385000	10857	5605	0	0	\N
265639	1874	203034000	10857	5605	1	0	\N
265640	1678	11520366385000	10858	5605	0	0	\N
265641	1874	203034000	10858	5605	1	0	\N
265642	1678	11520366385000	10859	5605	0	0	\N
265643	1874	203034000	10859	5605	1	0	\N
265644	1874	203035000	10860	5606	0	0	\N
265645	1678	11520366386000	10860	5606	1	0	\N
265646	1678	11520366387000	10860	5606	2	0	\N
265647	1874	203036000	10860	5606	3	0	\N
265652	1874	203035000	10862	5606	0	0	\N
265653	1678	11520366386000	10862	5606	1	0	\N
265654	1678	11520366387000	10862	5606	2	0	\N
265655	1874	203036000	10862	5606	3	0	\N
265656	1874	203035000	10863	5606	0	0	\N
265657	1678	11520366386000	10863	5606	1	0	\N
265658	1678	11520366387000	10863	5606	2	0	\N
265659	1874	203036000	10863	5606	3	0	\N
265662	1678	11520366388000	10865	5607	0	0	\N
265663	1874	203037000	10865	5607	1	0	\N
265664	723	3016599090000	10866	5608	0	0	\N
265665	1678	11520366389000	10866	5608	1	0	\N
265666	1874	203038000	10866	5608	2	0	\N
265675	1000	502777775002781	10869	5609	0	0	\N
265676	1678	11520366390000	10869	5609	1	0	\N
265677	1678	11520366391000	10869	5609	2	0	\N
265678	1874	203039000	10869	5609	3	0	\N
265679	1874	203040000	10869	5609	4	0	\N
265680	723	3016599090000	10870	5599	0	0	\N
265681	1000	502777775002781	10870	5599	1	0	\N
265682	1247	610550725005290	10870	5599	2	0	\N
265683	1127	904895054007842	10870	5599	3	0	\N
265684	1678	11520366375000	10870	5599	4	0	\N
265685	1678	11520366376000	10870	5599	5	0	\N
265686	1678	11520366377000	10870	5599	6	0	\N
265687	1874	203024000	10870	5599	7	0	\N
265688	1373	1701353880766396	10870	5599	8	0	\N
265689	1874	203025000	10870	5599	9	0	\N
265690	1874	203026000	10870	5599	10	0	\N
265691	1874	203027000	10870	5599	11	0	\N
265692	1874	203028000	10870	5599	12	0	\N
265693	1874	203029000	10870	5599	13	0	\N
265694	1874	203030000	10870	5599	14	0	\N
265695	1678	11520366378000	10870	5599	15	0	\N
265696	1678	11520366379000	10870	5599	16	0	\N
265697	1678	11520366380000	10870	5599	17	0	\N
265698	1678	11520366381000	10870	5599	18	0	\N
265699	1678	11520366382000	10870	5599	19	0	\N
265700	1678	11520366383000	10870	5599	20	0	\N
265701	1678	11520366384000	10870	5599	21	0	\N
265702	1678	11520366385000	10870	5599	22	0	\N
265703	1678	11520366386000	10870	5599	23	0	\N
265704	1678	11520366387000	10870	5599	24	0	\N
265705	1678	11520366388000	10870	5599	25	0	\N
265706	1678	11520366389000	10870	5599	26	0	\N
265707	1678	11520366390000	10870	5599	27	0	\N
265708	1678	11520366391000	10870	5599	28	0	\N
265709	1874	203031000	10870	5599	29	0	\N
265710	1874	203032000	10870	5599	30	0	\N
265711	1874	203033000	10870	5599	31	0	\N
265712	1874	203034000	10870	5599	32	0	\N
265713	1874	203035000	10870	5599	33	0	\N
265714	1874	203036000	10870	5599	34	0	\N
265715	1874	203037000	10870	5599	35	0	\N
265716	1874	203038000	10870	5599	36	0	\N
265717	1874	203039000	10870	5599	37	0	\N
265718	1874	203040000	10870	5599	38	0	\N
265719	95	66000000000000	10870	5599	39	0	\N
265720	95	66000000000000	10870	5599	40	0	\N
265723	1874	203041000	10873	5610	0	0	\N
265724	1678	11520366392000	10873	5610	1	0	\N
265725	1874	203041000	10874	5610	0	0	\N
265726	1678	11520366392000	10874	5610	1	0	\N
265732	1678	11520366393000	10876	5611	0	0	\N
265733	2040	0	10876	5611	1	0	\N
265734	1874	203042000	10876	5611	2	0	\N
265735	1874	203043000	10876	5611	3	0	\N
265736	1678	11520366394000	10876	5611	4	0	\N
265737	1678	11520366393000	10877	5611	0	0	\N
265738	2040	0	10877	5611	1	0	\N
265739	1874	203042000	10877	5611	2	0	\N
265740	1874	203043000	10877	5611	3	0	\N
265741	1678	11520366394000	10877	5611	4	0	\N
265744	2040	0	10879	5605	0	0	\N
265636	1678	11520366385000	10856	5605	0	0	0
265637	1874	203034000	10856	5605	1	0	0
265648	1874	203035000	10861	5606	0	0	0
265649	1678	11520366386000	10861	5606	1	0	0
265650	1678	11520366387000	10861	5606	2	0	0
265660	1678	11520366388000	10864	5607	0	0	0
265661	1874	203037000	10864	5607	1	0	0
265667	723	3016599090000	10867	5608	0	0	0
265668	1678	11520366389000	10867	5608	1	0	0
265669	1874	203038000	10867	5608	2	0	0
265671	1678	11520366390000	10868	5609	1	0	0
265672	1678	11520366391000	10868	5609	2	0	0
265673	1874	203039000	10868	5609	3	0	0
265674	1874	203040000	10868	5609	4	0	0
265722	1678	11520366392000	10872	5610	1	0	0
265727	1678	11520366393000	10875	5611	0	0	0
265728	2040	0	10875	5611	1	0	0
265729	1874	203042000	10875	5611	2	0	0
265730	1874	203043000	10875	5611	3	0	0
265742	1678	11520366395000	10878	5612	0	0	0
265743	1874	203044000	10878	5612	1	0	0
265745	2040	1116040000000	10879	5605	1	0	\N
265746	723	3016599090000	10879	5605	2	0	\N
265747	1000	502777775002781	10879	5605	3	0	\N
265748	1011	505654815000000	10879	5605	4	0	\N
265749	1251	611383360000000	10879	5605	5	0	\N
265755	2040	1116040000000	10881	5613	0	0	\N
265756	1011	505654815000000	10881	5613	1	0	\N
265757	1251	611383360000000	10881	5613	2	0	\N
265758	1874	203045000	10881	5613	3	0	\N
265759	2040	1116040000000	10882	5613	0	0	\N
265760	1678	11520366396000	10882	5613	1	0	\N
265761	1011	505654815000000	10882	5613	2	0	\N
265762	1251	611383360000000	10882	5613	3	0	\N
265763	1874	203045000	10882	5613	4	0	\N
265764	2040	1116040000000	10883	5613	0	0	\N
265765	1678	11520366396000	10883	5613	1	0	\N
265766	1011	505654815000000	10883	5613	2	0	\N
265767	1251	611383360000000	10883	5613	3	0	\N
265768	1874	203045000	10883	5613	4	0	\N
265769	2040	1116040000000	10884	5613	0	0	\N
265770	1678	11520366396000	10884	5613	1	0	\N
265771	1011	505654815000000	10884	5613	2	0	\N
265772	1251	611383360000000	10884	5613	3	0	\N
265773	1874	203045000	10884	5613	4	0	\N
265774	2040	1116040000000	10885	5613	0	0	\N
265775	1678	11520366396000	10885	5613	1	0	\N
265776	1011	505654815000000	10885	5613	2	0	\N
265777	1251	611383360000000	10885	5613	3	0	\N
265778	1874	203045000	10885	5613	4	0	\N
265779	1131	906129095000000	10886	5614	0	0	\N
265780	1678	11520366397000	10886	5614	1	0	\N
265781	1874	203046000	10886	5614	2	0	\N
265782	2039	1440980000000	10886	5614	3	0	\N
265783	1131	906129095000000	10887	5614	0	0	\N
265784	1678	11520366397000	10887	5614	1	0	\N
265785	1874	203046000	10887	5614	2	0	\N
265786	2039	1440980000000	10887	5614	3	0	\N
265791	1874	203047000	10889	5615	0	0	\N
265792	1678	11520366398000	10889	5615	1	0	\N
265801	1874	203048000	10892	5616	0	0	\N
265802	924	504692775000000	10892	5616	1	0	\N
265803	1874	203049000	10892	5616	2	0	\N
265804	1678	11520366399000	10892	5616	3	0	\N
265805	1678	11520366400000	10892	5616	4	0	\N
265808	1678	11520366401000	10894	5617	0	0	\N
265809	1874	203050000	10894	5617	1	0	\N
265810	2040	0	10895	5604	0	0	\N
265811	2040	1116040000000	10895	5604	1	0	\N
265812	723	3016599090000	10895	5604	2	0	\N
265813	1000	502777775002781	10895	5604	3	0	\N
265814	1011	505654815000000	10895	5604	4	0	\N
265815	1251	611383360000000	10895	5604	5	0	\N
265816	1131	906129095000000	10895	5604	6	0	\N
265817	1377	1703674087751650	10895	5604	7	0	\N
265818	1874	203033000	10895	5604	8	0	\N
265819	1874	203034000	10895	5604	9	0	\N
265820	1874	203035000	10895	5604	10	0	\N
265821	1874	203036000	10895	5604	11	0	\N
265822	1874	203037000	10895	5604	12	0	\N
265823	1678	11520366384000	10895	5604	13	0	\N
265824	1678	11520366385000	10895	5604	14	0	\N
265825	1678	11520366386000	10895	5604	15	0	\N
265826	1678	11520366387000	10895	5604	16	0	\N
265827	1678	11520366388000	10895	5604	17	0	\N
265828	1678	11520366389000	10895	5604	18	0	\N
265829	1678	11520366390000	10895	5604	19	0	\N
265830	1678	11520366391000	10895	5604	20	0	\N
265831	1678	11520366392000	10895	5604	21	0	\N
265832	1678	11520366393000	10895	5604	22	0	\N
265833	1678	11520366394000	10895	5604	23	0	\N
265834	1678	11520366395000	10895	5604	24	0	\N
265835	1678	11520366396000	10895	5604	25	0	\N
265836	1678	11520366397000	10895	5604	26	0	\N
265837	1678	11520366398000	10895	5604	27	0	\N
265838	1678	11520366399000	10895	5604	28	0	\N
265839	1678	11520366400000	10895	5604	29	0	\N
265840	1678	11520366401000	10895	5604	30	0	\N
265841	2039	1440980000000	10895	5604	31	0	\N
265842	924	504692775000000	10895	5604	32	0	\N
265843	1874	203038000	10895	5604	33	0	\N
265844	1874	203039000	10895	5604	34	0	\N
265845	1874	203040000	10895	5604	35	0	\N
265846	1874	203041000	10895	5604	36	0	\N
265847	1874	203042000	10895	5604	37	0	\N
265848	1874	203043000	10895	5604	38	0	\N
265849	1874	203044000	10895	5604	39	0	\N
265850	1874	203045000	10895	5604	40	0	\N
265851	1874	203046000	10895	5604	41	0	\N
265852	1874	203047000	10895	5604	42	0	\N
265853	1874	203048000	10895	5604	43	0	\N
265854	1874	203049000	10895	5604	44	0	\N
265855	1874	203050000	10895	5604	45	0	\N
265863	1678	11520366402000	10897	5618	0	0	\N
265864	1678	11520366403000	10897	5618	1	0	\N
265865	1678	11520366404000	10897	5618	2	0	\N
265866	1000	505559659823781	10897	5618	3	0	\N
265867	1874	203051000	10897	5618	4	0	\N
265868	1874	203052000	10897	5618	5	0	\N
265869	1874	203053000	10897	5618	6	0	\N
265870	1678	11520366402000	10898	5618	0	0	\N
265871	1678	11520366403000	10898	5618	1	0	\N
265872	1678	11520366404000	10898	5618	2	0	\N
265873	1000	505559659823781	10898	5618	3	0	\N
265874	1874	203051000	10898	5618	4	0	\N
265875	1874	203052000	10898	5618	5	0	\N
265876	1874	203053000	10898	5618	6	0	\N
265752	1011	505654815000000	10880	5613	2	0	0
265753	1251	611383360000000	10880	5613	3	0	0
265754	1874	203045000	10880	5613	4	0	0
265787	1131	906129095000000	10888	5614	0	0	0
265788	1678	11520366397000	10888	5614	1	0	0
265790	2039	1440980000000	10888	5614	3	0	1
265793	1377	1703674087751650	10890	5615	0	0	0
265794	1874	203047000	10890	5615	1	0	0
265795	1678	11520366398000	10890	5615	2	0	0
265796	1874	203048000	10891	5616	0	0	0
265798	1874	203049000	10891	5616	2	0	0
265799	1678	11520366399000	10891	5616	3	0	0
265800	1678	11520366400000	10891	5616	4	0	0
265806	1678	11520366401000	10893	5617	0	0	0
265856	1678	11520366402000	10896	5618	0	0	0
265857	1678	11520366403000	10896	5618	1	0	0
265858	1678	11520366404000	10896	5618	2	0	0
265859	1000	505559659823781	10896	5618	3	0	0
265860	1874	203051000	10896	5618	4	0	0
265862	1874	203053000	10896	5618	6	0	0
265877	1678	11520366405000	10899	5619	0	0	0
265878	1874	203054000	10900	5620	0	0	0
265879	1678	11520366406000	10900	5620	1	0	0
265880	1240	611268750000000	10901	5621	0	0	0
265905	1678	11520366415000	10905	5625	0	0	\N
265906	1678	11520366416000	10905	5625	1	0	\N
265907	1874	203063000	10905	5625	2	0	\N
265908	1874	203064000	10905	5625	3	0	\N
265919	1755	2156950000000	10909	5627	0	0	\N
265920	1874	203066000	10909	5627	1	0	\N
265921	1678	11520366418000	10909	5627	2	0	\N
265926	1678	11520366420000	10911	5629	0	0	\N
265927	1874	203068000	10911	5629	1	0	\N
265930	1343	1704118637751650	10913	5605	0	0	\N
265931	1097	906366465000000	10913	5605	1	0	\N
265932	1217	611543750000000	10913	5605	3	0	\N
265933	977	505786775000000	10913	5605	4	0	\N
265934	406	66002000000000	10913	5605	5	0	\N
265935	1384	1702260637751650	10913	5605	6	0	\N
265936	1138	905377465000000	10913	5605	7	0	\N
265937	1258	610878750000000	10913	5605	8	0	\N
265938	1018	505235775000000	10913	5605	9	0	\N
265939	1678	11520366402000	10913	5605	10	0	\N
265940	1678	11520366403000	10913	5605	11	0	\N
265941	1678	11520366404000	10913	5605	12	0	\N
265942	1678	11520366405000	10913	5605	13	0	\N
265943	1678	11520366406000	10913	5605	14	0	\N
265944	1000	505559659823781	10913	5605	15	0	\N
265945	1240	611268750000000	10913	5605	16	0	\N
265946	1678	11520366407000	10913	5605	17	0	\N
265947	1120	905959465000000	10913	5605	18	0	\N
265948	1366	1703353637751650	10913	5605	19	0	\N
265949	1874	203051000	10913	5605	20	0	\N
265950	1874	203052000	10913	5605	21	0	\N
265951	1874	203053000	10913	5605	22	0	\N
265952	1874	203054000	10913	5605	23	0	\N
265953	1874	203055000	10913	5605	24	0	\N
265954	1874	203056000	10913	5605	25	0	\N
265955	1678	11520366408000	10913	5605	26	0	\N
265956	1678	11520366409000	10913	5605	27	0	\N
265957	1678	11520366410000	10913	5605	28	0	\N
265958	1678	11520366411000	10913	5605	29	0	\N
265959	1678	11520366412000	10913	5605	30	0	\N
265960	1678	11520366413000	10913	5605	31	0	\N
265961	1678	11520366414000	10913	5605	32	0	\N
265962	1678	11520366415000	10913	5605	33	0	\N
265963	1678	11520366416000	10913	5605	34	0	\N
265964	1678	11520366417000	10913	5605	35	0	\N
265965	1678	11520366418000	10913	5605	36	0	\N
265966	1678	11520366419000	10913	5605	37	0	\N
265967	1678	11520366420000	10913	5605	38	0	\N
265968	1678	11520366421000	10913	5605	39	0	\N
265969	1874	203057000	10913	5605	40	0	\N
265970	1874	203058000	10913	5605	41	0	\N
265971	1874	203059000	10913	5605	42	0	\N
265972	1874	203060000	10913	5605	43	0	\N
265973	1874	203061000	10913	5605	44	0	\N
265974	1874	203062000	10913	5605	45	0	\N
265975	1874	203063000	10913	5605	46	0	\N
265976	1874	203064000	10913	5605	47	0	\N
265977	1874	203065000	10913	5605	48	0	\N
265978	1874	203066000	10913	5605	49	0	\N
265979	1874	203067000	10913	5605	50	0	\N
265980	1874	203068000	10913	5605	51	0	\N
265981	1874	203069000	10913	5605	52	0	\N
265982	1289	1700432637751650	10914	5630	0	0	\N
265983	1043	904405465000000	10914	5630	1	0	\N
265984	1163	610220750000000	10914	5630	2	0	\N
265985	1874	203069000	10914	5630	3	0	\N
265986	1874	203070000	10914	5630	4	0	\N
265987	923	504692775000000	10914	5630	5	0	\N
265988	1678	11520366421000	10914	5630	6	0	\N
265989	1678	11520366422000	10914	5630	7	0	\N
265999	1874	203071000	10917	5631	0	0	\N
266000	1678	11520366423000	10917	5631	1	0	\N
266001	1874	203071000	10918	5631	0	0	\N
266002	1678	11520366423000	10918	5631	1	0	\N
266011	1678	11520366427000	10920	5633	0	0	\N
266014	1678	11520366427000	10922	5633	0	0	\N
266015	1874	203075000	10922	5633	1	0	\N
266016	1678	11520366428000	10923	5634	0	0	\N
265883	1678	11520366407000	10901	5621	3	0	0
265884	1678	11520366408000	10901	5621	4	0	0
265885	1678	11520366409000	10902	5622	0	0	0
265886	1874	203057000	10902	5622	1	0	0
265887	1384	1702260637751650	10903	5623	0	0	0
265889	1258	610878750000000	10903	5623	2	0	0
265890	1018	505235775000000	10903	5623	3	0	0
265891	1678	11520366410000	10903	5623	4	0	0
265892	1874	203058000	10903	5623	5	0	0
265893	1678	11520366411000	10903	5623	6	0	0
265895	1678	11520366412000	10903	5623	8	0	0
265896	1120	905959465000000	10903	5623	9	0	0
265897	1874	203060000	10903	5623	10	0	0
265898	1343	1704118637751650	10904	5624	0	0	0
265900	1366	1703353637751650	10904	5624	2	0	0
265901	1678	11520366413000	10904	5624	3	0	0
265902	1874	203061000	10904	5624	4	0	0
265903	1874	203062000	10904	5624	5	0	0
265904	1678	11520366414000	10904	5624	6	0	0
265910	1678	11520366416000	10906	5625	1	0	0
265911	1874	203063000	10906	5625	2	0	0
265912	1874	203064000	10906	5625	3	0	0
265913	1097	906366465000000	10907	5626	0	0	0
265914	1217	611543750000000	10907	5626	1	0	0
265916	1874	203065000	10907	5626	3	0	0
265917	1678	11520366417000	10907	5626	4	0	0
265918	1755	2156950000000	10908	5627	0	0	1
265922	1874	203066000	10910	5628	0	0	0
265924	1678	11520366418000	10910	5628	2	0	0
265925	1678	11520366419000	10910	5628	3	0	0
265928	1678	11520366420000	10912	5629	0	0	0
265929	1874	203068000	10912	5629	1	0	0
265990	1289	1700432637751650	10915	5630	0	0	0
265992	1163	610220750000000	10915	5630	2	0	0
265993	1874	203069000	10915	5630	3	0	0
265994	1874	203070000	10915	5630	4	0	0
265995	923	504692775000000	10915	5630	5	0	0
265996	1678	11520366421000	10915	5630	6	0	0
265998	1874	203071000	10916	5631	0	0	0
266003	1874	203072000	10919	5632	0	0	0
266004	1340	1700431510151650	10919	5632	1	0	0
266005	1874	203073000	10919	5632	2	0	0
266007	1678	11520366423000	10919	5632	4	0	0
266008	1678	11520366424000	10919	5632	5	0	0
266009	1678	11520366425000	10919	5632	6	0	0
266010	1678	11520366426000	10919	5632	7	0	0
266012	1678	11520366427000	10921	5633	0	0	0
266017	1094	904405024600000	10923	5634	1	0	\N
266018	1214	610220226800000	10923	5634	3	0	\N
266019	1874	203076000	10923	5634	4	0	\N
266020	1678	11520366428000	10924	5634	0	0	\N
266021	1094	904405024600000	10924	5634	1	0	\N
266022	1214	610220226800000	10924	5634	3	0	\N
266023	1874	203076000	10924	5634	4	0	\N
266026	1874	203076000	10926	5634	0	0	\N
266032	1874	203077000	10928	5635	0	0	\N
266033	1678	11520366428000	10928	5635	1	0	\N
266034	1094	904405024600000	10928	5635	2	0	\N
266035	1214	610220226800000	10928	5635	3	0	\N
266036	1874	203078000	10928	5635	4	0	\N
266037	1678	11520366429000	10928	5635	5	0	\N
266038	974	504692496200000	10928	5635	6	0	\N
266039	1091	904962631654234	10928	5635	7	0	\N
266040	1874	203077000	10929	5635	0	0	\N
266041	1678	11520366428000	10929	5635	1	0	\N
266042	1094	904405024600000	10929	5635	2	0	\N
266043	1214	610220226800000	10929	5635	3	0	\N
266044	1874	203078000	10929	5635	4	0	\N
266045	1678	11520366429000	10929	5635	5	0	\N
266046	974	504692496200000	10929	5635	6	0	\N
266047	1091	904962631654234	10929	5635	7	0	\N
266048	1874	203078000	10930	5636	0	0	\N
266049	1678	11520366429000	10930	5636	1	0	\N
266052	1678	11520366429000	10932	5636	0	0	\N
266053	1874	203078000	10933	5636	0	0	\N
266054	1678	11520366429000	10933	5636	1	0	\N
266057	1874	203078000	10935	5636	0	0	\N
266058	1874	203079000	10935	5636	1	0	\N
266059	1678	11520366429000	10935	5636	2	0	\N
266060	1678	11520366430000	10935	5636	3	0	\N
266061	1874	203078000	10936	5636	0	0	\N
266062	1874	203079000	10936	5636	1	0	\N
266063	1678	11520366429000	10936	5636	2	0	\N
266064	1678	11520366430000	10936	5636	3	0	\N
266067	1874	203081000	10938	5639	0	0	\N
266068	1678	11520366432000	10938	5639	1	0	\N
266071	1874	203081000	10940	5639	0	0	\N
266072	1678	11520366432000	10940	5639	1	0	\N
266075	1874	203082000	10942	5640	0	0	\N
266076	1678	11520366433000	10942	5640	1	0	\N
266077	1874	203082000	10943	5640	0	0	\N
266078	1678	11520366433000	10943	5640	1	0	\N
266079	1874	203083000	10944	5641	0	0	\N
266080	1678	11520366434000	10944	5641	1	0	\N
266081	1874	203083000	10945	5641	0	0	\N
266082	1678	11520366434000	10945	5641	1	0	\N
266086	1874	203084000	10948	5643	0	0	\N
266087	1874	203085000	10948	5643	1	0	\N
266088	1874	203086000	10948	5643	2	0	\N
266089	1678	11520366436000	10948	5643	3	0	\N
266090	1678	11520366437000	10948	5643	4	0	\N
266091	1678	11520366438000	10948	5643	5	0	\N
266092	1874	203084000	10949	5643	0	0	\N
266093	1874	203085000	10949	5643	1	0	\N
266094	1874	203086000	10949	5643	2	0	\N
266095	1678	11520366436000	10949	5643	3	0	\N
266096	1678	11520366437000	10949	5643	4	0	\N
266097	1678	11520366438000	10949	5643	5	0	\N
266098	1874	203078000	10950	5636	0	0	\N
266099	1874	203079000	10950	5636	1	0	\N
266100	1874	203080000	10950	5636	2	0	\N
266101	1874	203081000	10950	5636	3	0	\N
266102	1874	203082000	10950	5636	4	0	\N
266103	1874	203083000	10950	5636	5	0	\N
266104	1678	11520366429000	10950	5636	6	0	\N
266105	1678	11520366430000	10950	5636	7	0	\N
266106	1678	11520366431000	10950	5636	8	0	\N
266107	1874	203084000	10950	5636	9	0	\N
266108	1874	203085000	10950	5636	10	0	\N
266109	1874	203086000	10950	5636	11	0	\N
266110	1678	11520366432000	10950	5636	12	0	\N
266111	1678	11520366433000	10950	5636	13	0	\N
266112	1678	11520366434000	10950	5636	14	0	\N
266113	1678	11520366435000	10950	5636	15	0	\N
266114	1678	11520366436000	10950	5636	16	0	\N
266115	1678	11520366437000	10950	5636	17	0	\N
266116	1678	11520366438000	10950	5636	18	0	\N
266123	1874	203087000	10952	5644	0	0	\N
266130	957	505695775000000	10955	5645	0	0	\N
266131	1874	203088000	10955	5645	1	0	\N
266132	1874	203089000	10955	5645	2	0	\N
266133	1678	11520366439000	10955	5645	3	0	\N
266134	1678	11520366440000	10955	5645	4	0	\N
266140	957	505695775000000	10958	5606	0	0	\N
266141	1874	203070000	10958	5606	1	0	\N
266142	1340	1700431510151650	10958	5606	2	0	\N
266143	1094	904405024600000	10958	5606	3	0	\N
266144	1214	610220226800000	10958	5606	4	0	\N
266145	1874	203071000	10958	5606	5	0	\N
266146	1874	203072000	10958	5606	6	0	\N
266147	1874	203073000	10958	5606	7	0	\N
266148	1874	203074000	10958	5606	8	0	\N
266149	1874	203075000	10958	5606	9	0	\N
266150	1874	203076000	10958	5606	10	0	\N
266151	1874	203077000	10958	5606	11	0	\N
266152	1874	203078000	10958	5606	12	0	\N
266027	1874	203077000	10927	5635	0	0	0
266028	1678	11520366428000	10927	5635	1	0	0
266029	1214	610220226800000	10927	5635	2	0	0
266030	974	504692496200000	10927	5635	3	0	0
266031	1091	904962631654234	10927	5635	4	0	0
266051	1678	11520366429000	10931	5636	1	0	0
266055	1678	11520366430000	10934	5637	0	0	0
266056	1874	203079000	10934	5637	1	0	0
266065	1678	11520366431000	10937	5638	0	0	0
266066	1874	203080000	10937	5638	1	0	0
266070	1678	11520366432000	10939	5639	1	0	0
266073	1874	203082000	10941	5640	0	0	0
266074	1678	11520366433000	10941	5640	1	0	0
266083	1874	203083000	10946	5641	0	0	0
266085	1678	11520366435000	10947	5642	0	0	0
266117	1874	203084000	10951	5643	0	0	0
266118	1874	203085000	10951	5643	1	0	0
266119	1874	203086000	10951	5643	2	0	0
266120	1678	11520366436000	10951	5643	3	0	0
266122	1678	11520366438000	10951	5643	5	0	0
266124	1874	203087000	10953	5644	0	0	0
266125	957	505695775000000	10954	5645	0	0	0
266126	1874	203088000	10954	5645	1	0	0
266127	1874	203089000	10954	5645	2	0	0
266129	1678	11520366440000	10954	5645	4	0	0
266135	1678	11520366441000	10956	5646	0	0	0
266136	1874	203090000	10957	5647	0	0	0
266137	1874	203091000	10957	5647	1	0	0
266139	1211	610596320231373	10957	5647	3	0	0
266153	1874	203079000	10958	5606	13	0	\N
266154	1874	203080000	10958	5606	14	0	\N
266155	1874	203081000	10958	5606	15	0	\N
266156	1874	203082000	10958	5606	16	0	\N
266157	1874	203083000	10958	5606	17	0	\N
266158	1289	1700432637751650	10958	5606	18	0	\N
266159	1678	11520366422000	10958	5606	19	0	\N
266160	1874	203084000	10958	5606	20	0	\N
266161	1874	203085000	10958	5606	21	0	\N
266162	1874	203086000	10958	5606	22	0	\N
266163	1874	203087000	10958	5606	23	0	\N
266164	1874	203088000	10958	5606	24	0	\N
266165	1874	203089000	10958	5606	25	0	\N
266166	1874	203090000	10958	5606	26	0	\N
266167	1874	203091000	10958	5606	27	0	\N
266168	974	504692496200000	10958	5606	28	0	\N
266169	1678	11520366423000	10958	5606	29	0	\N
266170	1678	11520366424000	10958	5606	30	0	\N
266171	1678	11520366425000	10958	5606	31	0	\N
266172	1678	11520366426000	10958	5606	32	0	\N
266173	1678	11520366427000	10958	5606	33	0	\N
266174	1678	11520366428000	10958	5606	34	0	\N
266175	1678	11520366429000	10958	5606	35	0	\N
266176	1678	11520366430000	10958	5606	36	0	\N
266177	1678	11520366431000	10958	5606	37	0	\N
266178	1678	11520366432000	10958	5606	38	0	\N
266179	1678	11520366433000	10958	5606	39	0	\N
266180	1678	11520366434000	10958	5606	40	0	\N
266181	1678	11520366435000	10958	5606	41	0	\N
266182	1678	11520366436000	10958	5606	42	0	\N
266183	1678	11520366437000	10958	5606	43	0	\N
266184	1678	11520366438000	10958	5606	44	0	\N
266185	1678	11520366439000	10958	5606	45	0	\N
266186	1678	11520366440000	10958	5606	46	0	\N
266187	1678	11520366441000	10958	5606	47	0	\N
266188	1678	11520366442000	10958	5606	48	0	\N
266189	1091	904962631654234	10958	5606	49	0	\N
266190	1211	610596320231373	10958	5606	50	0	\N
266194	1197	611432750000000	10960	5649	0	0	\N
266195	1077	906202465000000	10960	5649	1	0	\N
266196	1678	11520366444000	10960	5649	2	0	\N
266197	1678	11520366445000	10960	5649	3	0	\N
266198	1874	203093000	10960	5649	4	0	\N
266199	1874	203094000	10960	5649	5	0	\N
266200	1980	9359060000000	10960	5649	6	0	\N
266201	1197	611432750000000	10961	5649	0	0	\N
266202	1077	906202465000000	10961	5649	1	0	\N
266203	1678	11520366444000	10961	5649	2	0	\N
266204	1678	11520366445000	10961	5649	3	0	\N
266205	1874	203093000	10961	5649	4	0	\N
266206	1874	203094000	10961	5649	5	0	\N
266207	1980	9359060000000	10961	5649	6	0	\N
266215	1874	203095000	10963	5650	0	0	\N
266216	1678	11520366446000	10963	5650	1	0	\N
266219	1874	203095000	10965	5650	0	0	\N
266220	1678	11520366446000	10965	5650	1	0	\N
266221	1678	11520366447000	10966	5651	0	0	\N
266222	1874	203096000	10966	5651	1	0	\N
266223	1678	11520366447000	10967	5651	0	0	\N
266224	1874	203096000	10967	5651	1	0	\N
266225	1678	11520366447000	10968	5651	0	0	\N
266226	1874	203096000	10968	5651	1	0	\N
266227	1678	11520366447000	10969	5651	0	0	\N
266228	1874	203096000	10969	5651	1	0	\N
266232	1678	11520366449000	10972	5653	0	0	\N
266233	1874	203097000	10972	5653	1	0	\N
266234	1874	203098000	10972	5653	2	0	\N
266241	1874	203099000	10975	5654	0	0	\N
266242	1678	11520366451000	10975	5654	1	0	\N
266248	1678	11520366454000	10978	5657	0	0	\N
266249	1874	203102000	10978	5657	1	0	\N
266250	1437	0	10978	5657	2	0	\N
266251	1678	11520366454000	10979	5657	0	0	\N
266252	1874	203102000	10979	5657	1	0	\N
266253	1437	0	10979	5657	2	0	\N
266259	1678	11520366455000	10982	5658	0	0	\N
266260	1874	203103000	10982	5658	1	0	\N
266261	1678	11520366455000	10983	5658	0	0	\N
266262	1874	203103000	10983	5658	1	0	\N
266275	1874	203108000	10989	5662	0	0	\N
266276	1874	203109000	10989	5662	1	0	\N
266277	1678	11520366460000	10989	5662	2	0	\N
266278	1678	11520366461000	10989	5662	3	0	\N
266279	1874	203108000	10990	5662	0	0	\N
266280	1874	203109000	10990	5662	1	0	\N
266281	1678	11520366460000	10990	5662	2	0	\N
266282	1678	11520366461000	10990	5662	3	0	\N
266283	1874	203110000	10991	5663	0	0	\N
266284	1874	203111000	10991	5663	1	0	\N
266285	1678	11520366462000	10991	5663	2	0	\N
266286	1678	11520366463000	10991	5663	3	0	\N
266193	1678	11520366443000	10959	5648	2	0	0
266208	1197	611432750000000	10962	5649	0	0	0
266209	1077	906202465000000	10962	5649	1	0	0
266210	1678	11520366444000	10962	5649	2	0	0
266211	1678	11520366445000	10962	5649	3	0	0
266213	1874	203094000	10962	5649	5	0	0
266214	1980	9359060000000	10962	5649	6	0	1
266217	1874	203095000	10964	5650	0	0	0
266218	1678	11520366446000	10964	5650	1	0	0
266229	1678	11520366447000	10970	5651	0	0	0
266231	1678	11520366448000	10971	5652	0	0	0
266235	1678	11520366449000	10973	5653	0	0	0
266236	1678	11520366450000	10973	5653	1	0	0
266237	1874	203097000	10973	5653	2	0	0
266239	1874	203099000	10974	5654	0	0	0
266240	1678	11520366451000	10974	5654	1	0	0
266243	1323	1703811637751650	10976	5655	0	0	0
266244	1678	11520366452000	10976	5655	1	0	0
266245	1874	203100000	10976	5655	2	0	0
266247	1678	11520366453000	10977	5656	1	0	0
266254	1678	11520366454000	10980	5657	0	0	0
266255	1874	203102000	10980	5657	1	0	0
266256	1437	0	10980	5657	2	0	0
266257	1678	11520366455000	10981	5658	0	0	0
266263	1678	11520366456000	10984	5659	0	0	0
266264	1874	203104000	10984	5659	1	0	0
266265	1874	203105000	10985	5660	0	0	0
266266	1874	203106000	10985	5660	1	0	0
266268	1678	11520366458000	10985	5660	3	0	0
266269	1678	11520366459000	10985	5660	4	0	0
266270	1874	203107000	10985	5660	5	0	0
266271	1874	203108000	10988	5662	0	0	0
266272	1874	203109000	10988	5662	1	0	0
266274	1678	11520366461000	10988	5662	3	0	0
266287	1874	203110000	10992	5663	0	0	0
266288	1874	203111000	10992	5663	1	0	0
266291	1874	203110000	10993	5663	0	0	\N
266292	1874	203111000	10993	5663	1	0	\N
266293	1678	11520366462000	10993	5663	2	0	\N
266294	1678	11520366463000	10993	5663	3	0	\N
266301	1874	203115000	10996	5666	0	0	\N
266302	1678	11520366467000	10996	5666	1	0	\N
266303	1874	203115000	10997	5666	0	0	\N
266304	1678	11520366467000	10997	5666	1	0	\N
266307	1874	203116000	10999	5667	0	0	\N
266308	1874	203116000	11001	5667	0	0	\N
266310	1874	203116000	11004	5667	0	0	\N
266311	1678	11520366468000	11006	5667	0	0	\N
266312	1874	203116000	11006	5667	1	0	\N
266313	1874	203117000	11006	5667	2	0	\N
266314	1678	11520366468000	11007	5668	0	0	\N
266315	1678	11520366469000	11007	5668	1	0	\N
266316	1874	203117000	11007	5668	2	0	\N
266317	1874	203118000	11007	5668	3	0	\N
266322	1678	11520366468000	11009	5668	0	0	\N
266323	1678	11520366469000	11009	5668	1	0	\N
266324	1874	203117000	11009	5668	2	0	\N
266325	1874	203118000	11009	5668	3	0	\N
266326	1678	11520366470000	11010	5669	1	0	\N
266327	1874	203119000	11010	5669	2	0	\N
266328	1874	203120000	11010	5669	3	0	\N
266329	1678	11520366471000	11010	5669	4	0	\N
266330	2042	1000000000	11010	5669	5	0	\N
266331	1678	11520366470000	11011	5669	1	0	\N
266332	1874	203119000	11011	5669	2	0	\N
266333	1874	203120000	11011	5669	3	0	\N
266334	1678	11520366471000	11011	5669	4	0	\N
266335	2042	1000000000	11011	5669	5	0	\N
266342	954	505422011687992	11014	5671	0	0	\N
266343	1194	611101876290553	11014	5671	1	0	\N
266344	1074	905711914489072	11014	5671	2	0	\N
266345	1320	1702889714432878	11014	5671	3	0	\N
266346	1874	203121000	11014	5671	4	0	\N
266347	1678	11520366473000	11014	5671	5	0	\N
266354	954	505422011687992	11016	5669	1	0	\N
266355	1194	611101876290553	11016	5669	2	0	\N
266356	1074	905711914489072	11016	5669	3	0	\N
266357	1320	1702889714432878	11016	5669	4	0	\N
266358	1678	11520366470000	11016	5669	5	0	\N
266359	1874	203119000	11016	5669	6	0	\N
266360	1874	203120000	11016	5669	7	0	\N
266361	1874	203121000	11016	5669	8	0	\N
266362	1678	11520366471000	11016	5669	9	0	\N
266363	2042	1000000000	11016	5669	10	0	\N
266364	1678	11520366472000	11016	5669	11	0	\N
266365	1678	11520366473000	11016	5669	12	0	\N
266366	1874	203122000	11017	5670	0	0	\N
266367	1678	11520366474000	11017	5670	1	0	\N
266372	1874	203124000	11019	5673	0	0	\N
266373	1678	11520366476000	11019	5673	1	0	\N
266376	1874	203123000	11021	5671	0	0	\N
266377	1874	203124000	11021	5671	1	0	\N
266378	1678	11520366475000	11021	5671	2	0	\N
266379	1678	11520366476000	11021	5671	3	0	\N
266383	1874	203126000	11023	5675	0	0	\N
266384	1874	203126000	11024	5675	0	0	\N
266386	1874	203127000	11026	5676	0	0	\N
266387	2042	830490000000	11026	5676	1	0	\N
266388	2042	1550490000000	11026	5676	2	0	\N
266389	1678	11520366478000	11026	5676	3	0	\N
266390	1678	11520366479000	11026	5676	4	0	\N
266391	1678	11520366480000	11026	5676	5	0	\N
266392	1678	11520366481000	11026	5676	6	0	\N
266393	1874	203128000	11026	5676	7	0	\N
266394	1874	203129000	11026	5676	8	0	\N
266395	1874	203130000	11026	5676	9	0	\N
266396	1874	203127000	11027	5676	0	0	\N
266397	2042	830490000000	11027	5676	1	0	\N
266398	2042	1550490000000	11027	5676	2	0	\N
266399	1678	11520366478000	11027	5676	3	0	\N
266400	1678	11520366479000	11027	5676	4	0	\N
266401	1678	11520366480000	11027	5676	5	0	\N
266402	1678	11520366481000	11027	5676	6	0	\N
266403	1874	203128000	11027	5676	7	0	\N
266404	1874	203129000	11027	5676	8	0	\N
266405	1874	203130000	11027	5676	9	0	\N
266424	1197	611432750000000	11033	5607	0	0	\N
266295	1874	203112000	10994	5664	0	0	0
266296	1874	203113000	10994	5664	1	0	0
266297	1678	11520366464000	10994	5664	2	0	0
266298	1678	11520366465000	10994	5664	3	0	0
266299	1678	11520366466000	10995	5665	0	0	0
266305	1874	203115000	10998	5666	0	0	0
266306	1678	11520366467000	10998	5666	1	0	0
266309	1874	203116000	11002	5667	0	0	0
266318	1678	11520366468000	11008	5668	0	0	0
266319	1678	11520366469000	11008	5668	1	0	0
266321	1874	203118000	11008	5668	3	0	0
266336	1678	11520366470000	11012	5669	1	0	0
266337	1874	203119000	11012	5669	2	0	0
266338	1874	203120000	11012	5669	3	0	0
266340	2042	1000000000	11012	5669	5	0	0
266341	1678	11520366472000	11013	5670	0	0	0
266348	954	505422011687992	11015	5671	0	0	0
266349	1194	611101876290553	11015	5671	1	0	0
266350	1074	905711914489072	11015	5671	2	0	0
266352	1874	203121000	11015	5671	4	0	0
266353	1678	11520366473000	11015	5671	5	0	0
266368	1874	203122000	11018	5672	0	0	0
266369	1874	203123000	11018	5672	1	0	0
266370	1678	11520366474000	11018	5672	2	0	0
266374	1874	203124000	11020	5673	0	0	0
266375	1678	11520366476000	11020	5673	1	0	0
266380	1678	11520366477000	11022	5674	0	0	0
266381	411	66838420000000	11022	5674	1	0	4
266385	1874	203126000	11025	5675	0	0	0
266406	1874	203127000	11028	5676	0	0	0
266407	2042	830490000000	11028	5676	1	0	1
266408	2042	1550490000000	11028	5676	2	0	1
266409	1678	11520366478000	11028	5676	3	0	0
266411	1678	11520366480000	11028	5676	5	0	0
266412	1678	11520366481000	11028	5676	6	0	0
266413	1874	203128000	11028	5676	7	0	0
266414	1874	203129000	11028	5676	8	0	0
266415	1874	203130000	11028	5676	9	0	0
266417	1874	203131000	11029	5677	1	0	0
266418	1874	203132000	11030	5678	0	0	0
266419	1678	11520366483000	11030	5678	1	0	0
266420	1678	11520366484000	11031	5679	0	0	0
266422	1678	11520366485000	11032	5680	0	0	0
266423	1874	203134000	11032	5680	1	0	0
266425	1077	906202465000000	11033	5607	1	0	\N
266426	1323	1703811637751650	11033	5607	2	0	\N
266427	1534	0	11033	5607	3	0	\N
266428	954	505422011687992	11033	5607	5	0	\N
266429	1194	611101876290553	11033	5607	6	0	\N
266430	1074	905711914489072	11033	5607	7	0	\N
266431	1320	1702889714432878	11033	5607	8	0	\N
266432	1874	203092000	11033	5607	9	0	\N
266433	1874	203093000	11033	5607	10	0	\N
266434	2042	1000000000	11033	5607	11	0	\N
266435	2042	831000000000	11033	5607	12	0	\N
266436	1678	11520366443000	11033	5607	13	0	\N
266437	1678	11520366444000	11033	5607	14	0	\N
266438	1678	11520366445000	11033	5607	15	0	\N
266439	1678	11520366446000	11033	5607	16	0	\N
266440	1678	11520366447000	11033	5607	17	0	\N
266441	1678	11520366448000	11033	5607	18	0	\N
266442	1678	11520366449000	11033	5607	19	0	\N
266443	1678	11520366450000	11033	5607	20	0	\N
266444	1678	11520366451000	11033	5607	21	0	\N
266445	1678	11520366452000	11033	5607	23	0	\N
266446	1678	11520366453000	11033	5607	24	0	\N
266447	1678	11520366454000	11033	5607	25	0	\N
266448	1678	11520366455000	11033	5607	26	0	\N
266449	1678	11520366456000	11033	5607	27	0	\N
266450	1678	11520366457000	11033	5607	28	0	\N
266451	1678	11520366458000	11033	5607	29	0	\N
266452	1678	11520366459000	11033	5607	30	0	\N
266453	1678	11520366460000	11033	5607	31	0	\N
266454	1678	11520366461000	11033	5607	32	0	\N
266455	1678	11520366462000	11033	5607	33	0	\N
266456	1678	11520366463000	11033	5607	34	0	\N
266457	1678	11520366464000	11033	5607	35	0	\N
266458	1678	11520366465000	11033	5607	36	0	\N
266459	1678	11520366466000	11033	5607	37	0	\N
266460	1678	11520366467000	11033	5607	38	0	\N
266461	1678	11520366468000	11033	5607	39	0	\N
266462	1678	11520366469000	11033	5607	40	0	\N
266463	1678	11520366470000	11033	5607	41	0	\N
266464	1678	11520366471000	11033	5607	42	0	\N
266465	1678	11520366472000	11033	5607	43	0	\N
266466	1678	11520366473000	11033	5607	44	0	\N
266467	1678	11520366474000	11033	5607	45	0	\N
266468	1678	11520366475000	11033	5607	46	0	\N
266469	1678	11520366476000	11033	5607	47	0	\N
266470	1678	11520366477000	11033	5607	48	0	\N
266471	1678	11520366478000	11033	5607	49	0	\N
266472	1678	11520366479000	11033	5607	50	0	\N
266473	1678	11520366480000	11033	5607	51	0	\N
266474	1678	11520366481000	11033	5607	52	0	\N
266475	1678	11520366482000	11033	5607	53	0	\N
266476	1678	11520366483000	11033	5607	54	0	\N
266477	1678	11520366484000	11033	5607	55	0	\N
266478	1678	11520366485000	11033	5607	56	0	\N
266479	1874	203094000	11033	5607	57	0	\N
266480	1874	203095000	11033	5607	58	0	\N
266481	1874	203096000	11033	5607	59	0	\N
266482	1874	203097000	11033	5607	60	0	\N
266483	1874	203098000	11033	5607	61	0	\N
266484	1874	203099000	11033	5607	62	0	\N
266485	1874	203100000	11033	5607	63	0	\N
266486	1874	203101000	11033	5607	64	0	\N
266487	1874	203102000	11033	5607	65	0	\N
266488	1874	203103000	11033	5607	66	0	\N
266489	1874	203104000	11033	5607	67	0	\N
266490	1874	203105000	11033	5607	68	0	\N
266491	1874	203106000	11033	5607	69	0	\N
266492	1874	203107000	11033	5607	70	0	\N
266493	1874	203108000	11033	5607	71	0	\N
266494	1874	203109000	11033	5607	72	0	\N
266495	1874	203110000	11033	5607	73	0	\N
266496	1874	203111000	11033	5607	74	0	\N
266497	1874	203112000	11033	5607	75	0	\N
266498	1874	203113000	11033	5607	76	0	\N
266499	1874	203114000	11033	5607	77	0	\N
266500	1874	203115000	11033	5607	78	0	\N
266501	1874	203116000	11033	5607	79	0	\N
266502	1874	203117000	11033	5607	80	0	\N
266503	1874	203118000	11033	5607	81	0	\N
266504	1874	203119000	11033	5607	82	0	\N
266505	1874	203120000	11033	5607	83	0	\N
266506	1874	203121000	11033	5607	84	0	\N
266507	1874	203122000	11033	5607	85	0	\N
266508	1874	203123000	11033	5607	86	0	\N
266509	1874	203124000	11033	5607	87	0	\N
266510	1874	203125000	11033	5607	88	0	\N
266511	1874	203126000	11033	5607	89	0	\N
266512	1874	203127000	11033	5607	90	0	\N
266513	1874	203128000	11033	5607	91	0	\N
266514	1874	203129000	11033	5607	92	0	\N
266515	1874	203130000	11033	5607	93	0	\N
266516	1874	203131000	11033	5607	94	0	\N
266517	1874	203132000	11033	5607	95	0	\N
266518	1874	203133000	11033	5607	96	0	\N
266519	1874	203134000	11033	5607	97	0	\N
266520	1980	8638990000000	11033	5607	98	0	\N
266521	1678	11520366486000	11034	5681	0	0	\N
266522	1874	203135000	11034	5681	1	0	\N
266523	1678	11520366486000	11035	5681	0	0	\N
266526	1678	11520366486000	11037	5681	0	0	\N
266527	1874	203135000	11037	5681	1	0	\N
266528	1678	12240386487000	11038	5682	0	0	\N
266529	1874	203136000	11038	5682	1	0	\N
266532	1678	12240386488000	11040	5683	0	0	\N
266533	1874	203137000	11040	5683	1	0	\N
266534	1678	12240386488000	11041	5683	0	0	\N
266535	1874	203137000	11041	5683	1	0	\N
266536	1678	12240386488000	11042	5683	0	0	\N
266537	1874	203137000	11042	5683	1	0	\N
266538	1678	12240386488000	11043	5683	0	0	\N
266539	1874	203137000	11043	5683	1	0	\N
266542	1678	12240386488000	11045	5683	0	0	\N
266543	1874	203137000	11045	5683	1	0	\N
266544	1874	203138000	11046	5684	0	0	\N
266545	1678	12240386489000	11046	5684	1	0	\N
266546	1874	203138000	11047	5684	0	0	\N
266547	1678	12240386489000	11047	5684	1	0	\N
266552	1678	12240386490000	11050	5685	0	0	\N
266553	1874	203139000	11050	5685	1	0	\N
266554	1874	203138000	11051	5684	0	0	\N
266555	1678	12240386489000	11051	5684	1	0	\N
266530	1678	12240386487000	11039	5682	0	0	0
266531	1874	203136000	11039	5682	1	0	0
266540	1678	12240386488000	11044	5683	0	0	0
266541	1874	203137000	11044	5683	1	0	0
266548	1874	203138000	11048	5684	0	0	0
266550	1678	12240386490000	11049	5685	0	0	0
266551	1874	203139000	11049	5685	1	0	0
266556	1874	203140000	11052	5686	0	0	0
266557	1874	203141000	11052	5686	1	0	0
266558	1678	12240386491000	11052	5686	2	0	0
266560	1874	203142000	11053	5687	0	0	0
266564	1874	203142000	11054	5687	0	0	\N
266565	1874	203143000	11054	5687	1	0	\N
266566	1678	12240386493000	11054	5687	2	0	\N
266567	1678	12240386494000	11054	5687	3	0	\N
266568	411	66838420000000	11055	5673	0	0	\N
266569	2042	830490000000	11055	5673	1	0	\N
266570	2042	1550490000000	11055	5673	2	0	\N
266571	1874	203124000	11055	5673	3	0	\N
266572	1874	203125000	11055	5673	4	0	\N
266573	1874	203126000	11055	5673	5	0	\N
266574	1874	203127000	11055	5673	6	0	\N
266575	1678	11520366476000	11055	5673	7	0	\N
266576	1678	11520366477000	11055	5673	8	0	\N
266577	1678	11520366478000	11055	5673	9	0	\N
266578	1678	11520366479000	11055	5673	10	0	\N
266579	1678	11520366480000	11055	5673	11	0	\N
266580	1678	11520366481000	11055	5673	12	0	\N
266581	1678	11520366482000	11055	5673	13	0	\N
266582	1678	11520366483000	11055	5673	14	0	\N
266583	1678	11520366484000	11055	5673	15	0	\N
266584	1678	11520366485000	11055	5673	16	0	\N
266585	1678	11520366486000	11055	5673	17	0	\N
266586	1678	11520366487000	11055	5673	18	0	\N
266587	1678	11520366488000	11055	5673	19	0	\N
266588	1678	11520366489000	11055	5673	20	0	\N
266589	1678	11520366490000	11055	5673	21	0	\N
266590	1678	11520366491000	11055	5673	22	0	\N
266591	1678	11520366492000	11055	5673	23	0	\N
266592	1678	11520366493000	11055	5673	24	0	\N
266593	1678	11520366494000	11055	5673	25	0	\N
266594	1874	203128000	11055	5673	26	0	\N
266595	1874	203129000	11055	5673	27	0	\N
266596	1874	203130000	11055	5673	28	0	\N
266597	1874	203131000	11055	5673	29	0	\N
266598	1874	203132000	11055	5673	30	0	\N
266599	1874	203133000	11055	5673	31	0	\N
266600	1874	203134000	11055	5673	32	0	\N
266601	1874	203135000	11055	5673	33	0	\N
266602	1874	203136000	11055	5673	34	0	\N
266603	1874	203137000	11055	5673	35	0	\N
266604	1874	203138000	11055	5673	36	0	\N
266605	1874	203139000	11055	5673	37	0	\N
266606	1874	203140000	11055	5673	38	0	\N
266607	1874	203141000	11055	5673	39	0	\N
266608	1874	203142000	11055	5673	40	0	\N
266609	1874	203143000	11055	5673	41	0	\N
266610	1874	203142000	11056	5687	0	0	\N
266611	1874	203143000	11056	5687	1	0	\N
266612	1678	12240386493000	11056	5687	2	0	\N
266613	1678	12240386494000	11056	5687	3	0	\N
266614	1874	203142000	11057	5687	0	0	\N
266615	1874	203143000	11057	5687	1	0	\N
266616	1678	12240386493000	11057	5687	2	0	\N
266617	1678	12240386494000	11057	5687	3	0	\N
266620	1874	203145000	11060	5690	0	0	\N
266621	1874	203146000	11060	5690	1	0	\N
266622	1874	203147000	11060	5690	2	0	\N
266623	1678	12240386496000	11060	5690	3	0	\N
266624	1678	12240386497000	11060	5690	4	0	\N
266625	1678	12240386498000	11060	5690	5	0	\N
266636	1678	12240386499000	11063	5691	0	0	\N
266637	1874	203148000	11063	5691	1	0	\N
266638	1874	203149000	11063	5691	2	0	\N
266639	1678	12240386500000	11063	5691	3	0	\N
266640	1678	12240386501000	11064	5692	0	0	\N
266641	1874	203150000	11064	5692	1	0	\N
266646	1874	203151000	11067	5693	0	0	\N
266647	1678	12240386502000	11067	5693	1	0	\N
266648	1874	203151000	11068	5693	0	0	\N
266649	1678	12240386502000	11068	5693	1	0	\N
266655	1874	203153000	11071	5695	0	0	\N
266656	1678	12240386504000	11071	5695	1	0	\N
266661	1323	1703811637751650	11074	5651	0	0	\N
266662	954	505422011687992	11074	5651	2	0	\N
266663	1194	611101876290553	11074	5651	3	0	\N
266664	1074	905711914489072	11074	5651	4	0	\N
266665	1320	1702889714432878	11074	5651	5	0	\N
266666	257	66001000000000	11074	5651	6	0	\N
266667	1678	11520366447000	11074	5651	7	0	\N
266668	1678	11520366448000	11074	5651	8	0	\N
266669	1678	11520366449000	11074	5651	9	0	\N
266670	1678	11520366450000	11074	5651	10	0	\N
266671	1678	11520366451000	11074	5651	11	0	\N
266672	1678	11520366452000	11074	5651	12	0	\N
266673	1678	11520366453000	11074	5651	13	0	\N
266674	1678	11520366454000	11074	5651	14	0	\N
266675	1678	11520366455000	11074	5651	15	0	\N
266676	1678	11520366456000	11074	5651	16	0	\N
266677	2042	719000000000	11074	5651	17	0	\N
266678	2042	721000000000	11074	5651	18	0	\N
266679	2042	1551000000000	11074	5651	19	0	\N
266680	1874	203096000	11074	5651	20	0	\N
266681	1874	203097000	11074	5651	21	0	\N
266682	1874	203098000	11074	5651	22	0	\N
266683	1874	203099000	11074	5651	23	0	\N
266684	1874	203100000	11074	5651	24	0	\N
266685	1874	203101000	11074	5651	25	0	\N
266686	1874	203102000	11074	5651	26	0	\N
266687	1874	203103000	11074	5651	27	0	\N
266688	1874	203104000	11074	5651	28	0	\N
266689	1874	203105000	11074	5651	29	0	\N
266690	1874	203106000	11074	5651	30	0	\N
266691	1678	11520366457000	11074	5651	31	0	\N
266692	1678	11520366458000	11074	5651	32	0	\N
266693	1678	11520366459000	11074	5651	33	0	\N
266694	1678	11520366460000	11074	5651	34	0	\N
266695	1678	11520366461000	11074	5651	35	0	\N
266696	1678	11520366462000	11074	5651	36	0	\N
266563	1678	12240386494000	11053	5687	3	0	0
266618	1874	203144000	11059	5689	0	0	0
266619	1678	12240386495000	11059	5689	1	0	0
266626	1874	203145000	11061	5690	0	0	0
266627	1874	203146000	11061	5690	1	0	0
266629	1678	12240386496000	11061	5690	3	0	0
266630	1678	12240386497000	11061	5690	4	0	0
266631	1678	12240386498000	11061	5690	5	0	0
266632	1678	12240386499000	11062	5691	0	0	0
266633	1874	203148000	11062	5691	1	0	0
266635	1678	12240386500000	11062	5691	3	0	0
266642	1678	12240386501000	11065	5692	0	0	0
266643	1874	203150000	11065	5692	1	0	0
266644	1874	203151000	11066	5693	0	0	0
266650	257	66001000000000	11069	5694	0	0	0
266651	1874	203152000	11069	5694	1	0	0
266652	1678	12240386503000	11069	5694	2	0	0
266653	1874	203153000	11070	5695	0	0	0
266654	1678	12240386504000	11070	5695	1	0	0
266658	1874	203154000	11072	5696	1	0	0
266659	1874	203155000	11073	5697	0	0	0
266660	1678	12240386506000	11073	5697	1	0	0
266697	1678	11520366463000	11074	5651	37	0	\N
266698	1678	11520366464000	11074	5651	38	0	\N
266699	1678	11520366465000	11074	5651	39	0	\N
266700	1678	11520366466000	11074	5651	40	0	\N
266701	1678	11520366467000	11074	5651	41	0	\N
266702	1678	11520366468000	11074	5651	42	0	\N
266703	1678	11520366469000	11074	5651	43	0	\N
266704	1678	11520366470000	11074	5651	44	0	\N
266705	1678	11520366471000	11074	5651	45	0	\N
266706	1678	11520366472000	11074	5651	46	0	\N
266707	1678	11520366473000	11074	5651	48	0	\N
266708	1678	11520366474000	11074	5651	49	0	\N
266709	1678	11520366475000	11074	5651	50	0	\N
266710	1678	11520366476000	11074	5651	51	0	\N
266711	1678	11520366477000	11074	5651	52	0	\N
266712	1678	11520366478000	11074	5651	53	0	\N
266713	1678	11520366479000	11074	5651	54	0	\N
266714	1678	11520366480000	11074	5651	55	0	\N
266715	1678	11520366481000	11074	5651	56	0	\N
266716	1678	11520366482000	11074	5651	57	0	\N
266717	1678	11520366483000	11074	5651	58	0	\N
266718	1678	11520366484000	11074	5651	59	0	\N
266719	1678	11520366485000	11074	5651	60	0	\N
266720	1678	11520366486000	11074	5651	61	0	\N
266721	1678	11520366487000	11074	5651	62	0	\N
266722	1678	11520366488000	11074	5651	63	0	\N
266723	1678	11520366489000	11074	5651	64	0	\N
266724	1678	11520366490000	11074	5651	65	0	\N
266725	1874	203107000	11074	5651	66	0	\N
266726	1874	203108000	11074	5651	67	0	\N
266727	1874	203109000	11074	5651	68	0	\N
266728	1874	203110000	11074	5651	69	0	\N
266729	1874	203111000	11074	5651	70	0	\N
266730	1874	203112000	11074	5651	71	0	\N
266731	1874	203113000	11074	5651	72	0	\N
266732	1874	203114000	11074	5651	73	0	\N
266733	1874	203115000	11074	5651	74	0	\N
266734	1874	203116000	11074	5651	75	0	\N
266735	1874	203117000	11074	5651	76	0	\N
266736	1874	203118000	11074	5651	77	0	\N
266737	1874	203119000	11074	5651	78	0	\N
266738	1874	203120000	11074	5651	79	0	\N
266739	1874	203121000	11074	5651	80	0	\N
266740	1874	203122000	11074	5651	81	0	\N
266741	1874	203123000	11074	5651	82	0	\N
266742	1874	203124000	11074	5651	83	0	\N
266743	1874	203125000	11074	5651	84	0	\N
266744	1874	203126000	11074	5651	85	0	\N
266745	1874	203127000	11074	5651	86	0	\N
266746	1678	11520366491000	11074	5651	87	0	\N
266747	1678	11520366492000	11074	5651	88	0	\N
266748	1678	11520366493000	11074	5651	89	0	\N
266749	1678	11520366494000	11074	5651	90	0	\N
266750	1678	11520366495000	11074	5651	91	0	\N
266751	1678	11520366496000	11074	5651	92	0	\N
266752	1678	11520366497000	11074	5651	93	0	\N
266753	1678	11520366498000	11074	5651	94	0	\N
266754	1678	11520366499000	11074	5651	95	0	\N
266755	1678	11520366500000	11074	5651	96	0	\N
266756	1678	11520366501000	11074	5651	97	0	\N
266757	1678	11520366502000	11074	5651	98	0	\N
266758	1678	11520366503000	11074	5651	99	0	\N
266759	1678	11520366504000	11074	5651	100	0	\N
266760	1678	11520366505000	11074	5651	101	0	\N
266761	1874	203128000	11074	5651	102	0	\N
266762	1874	203129000	11074	5651	103	0	\N
266763	1874	203130000	11074	5651	104	0	\N
266764	1874	203131000	11074	5651	105	0	\N
266765	1874	203132000	11074	5651	106	0	\N
266766	1874	203133000	11074	5651	107	0	\N
266767	1874	203134000	11074	5651	108	0	\N
266768	1874	203135000	11074	5651	109	0	\N
266769	1874	203136000	11074	5651	110	0	\N
266770	1874	203137000	11074	5651	111	0	\N
266771	1874	203138000	11074	5651	112	0	\N
266772	1874	203139000	11074	5651	113	0	\N
266773	1874	203140000	11074	5651	114	0	\N
266774	1874	203141000	11074	5651	115	0	\N
266775	1874	203142000	11074	5651	116	0	\N
266776	1874	203143000	11074	5651	117	0	\N
266777	1874	203144000	11074	5651	118	0	\N
266778	1874	203145000	11074	5651	119	0	\N
266779	1874	203146000	11074	5651	120	0	\N
266780	1874	203147000	11074	5651	121	0	\N
266781	1874	203148000	11074	5651	122	0	\N
266782	1874	203149000	11074	5651	123	0	\N
266783	1874	203150000	11074	5651	124	0	\N
266784	1874	203151000	11074	5651	125	0	\N
266785	1678	12240386507000	11075	5698	0	0	\N
266786	1874	203156000	11075	5698	1	0	\N
266789	973	505148775000000	11077	5699	0	0	\N
266790	1874	203157000	11077	5699	1	0	\N
266791	1678	12240386508000	11077	5699	2	0	\N
266797	1678	12240386509000	11080	5700	0	0	\N
266798	1874	203158000	11080	5700	1	0	\N
266799	1678	12240386509000	11081	5700	0	0	\N
266800	1874	203158000	11081	5700	1	0	\N
266805	1678	12240386511000	11083	5702	0	0	\N
266806	1874	203160000	11083	5702	1	0	\N
266812	1678	12240386512000	11086	5703	0	0	\N
266813	1339	1701968637751650	11086	5703	1	0	\N
266814	1874	203161000	11086	5703	2	0	\N
266827	1874	203167000	11092	5708	0	0	\N
266828	1678	12240386517000	11092	5708	1	0	\N
266829	257	67245000000000	11092	5708	2	0	\N
266832	1874	203168000	11094	5709	0	0	\N
266792	973	505148775000000	11078	5699	0	0	0
266793	1874	203157000	11078	5699	1	0	0
266794	1678	12240386508000	11078	5699	2	0	0
266795	1678	12240386509000	11079	5700	0	0	0
266796	1874	203158000	11079	5700	1	0	0
266802	1213	610771750000000	11082	5701	1	0	0
266803	1093	905222465000000	11082	5701	2	0	0
266804	1678	12240386510000	11082	5701	3	0	0
266807	1678	12240386511000	11084	5702	0	0	0
266808	1874	203160000	11084	5702	1	0	0
266810	1339	1701968637751650	11085	5703	1	0	0
266811	1874	203161000	11085	5703	2	0	0
266815	1874	203162000	11087	5704	0	0	0
266816	1874	203163000	11087	5704	1	0	0
266818	1678	12240386514000	11087	5704	3	0	0
266819	1874	203164000	11088	5705	0	0	0
266820	1678	12240386515000	11088	5705	1	0	0
266821	1874	203165000	11089	5706	0	0	0
266822	1678	12240386516000	11090	5707	0	0	0
266824	1874	203167000	11091	5708	0	0	0
266825	1678	12240386517000	11091	5708	1	0	0
266826	257	67245000000000	11091	5708	2	0	0
266830	1874	203168000	11093	5709	0	0	0
266831	1678	12240386518000	11093	5709	1	0	0
266833	1678	12240386518000	11094	5709	1	0	\N
266834	1874	203168000	11095	5709	0	0	\N
266835	1678	12240386518000	11095	5709	1	0	\N
266836	1874	203168000	11096	5709	0	0	\N
266837	1678	12240386518000	11096	5709	1	0	\N
266838	1874	203168000	11097	5709	0	0	\N
266839	1678	12240386518000	11097	5709	1	0	\N
266840	1874	203169000	11098	5710	0	0	\N
266841	1678	12240386519000	11098	5710	1	0	\N
266844	192	66227799354186	11100	5697	0	0	\N
266845	973	505148775000000	11100	5697	1	0	\N
266846	918	504510205933512	11100	5697	2	0	\N
266847	1038	904077966389392	11100	5697	3	0	\N
266848	1158	609999418948983	11100	5697	4	0	\N
266849	1284	1699817619025558	11100	5697	5	0	\N
266850	1213	610771750000000	11100	5697	6	0	\N
266851	1093	905222465000000	11100	5697	7	0	\N
266852	1339	1701968637751650	11100	5697	8	0	\N
266853	257	67245000000000	11100	5697	9	0	\N
266863	1874	203170000	11102	5711	0	0	\N
266864	192	66227799354186	11102	5711	1	0	\N
266865	918	504510205933512	11102	5711	2	0	\N
266866	1038	904077966389392	11102	5711	3	0	\N
266867	1158	609999418948983	11102	5711	4	0	\N
266868	1284	1699817619025558	11102	5711	5	0	\N
266869	1678	12240386520000	11102	5711	6	0	\N
266870	1678	12240386521000	11102	5711	7	0	\N
266871	1874	203171000	11102	5711	8	0	\N
266872	1874	203170000	11103	5711	0	0	\N
266873	192	66227799354186	11103	5711	1	0	\N
266874	918	504510205933512	11103	5711	2	0	\N
266875	1038	904077966389392	11103	5711	3	0	\N
266876	1158	609999418948983	11103	5711	4	0	\N
266877	1284	1699817619025558	11103	5711	5	0	\N
266878	1678	12240386520000	11103	5711	6	0	\N
266879	1678	12240386521000	11103	5711	7	0	\N
266880	1874	203171000	11103	5711	8	0	\N
266881	1678	11520366486000	11104	5608	0	0	\N
266882	257	66001000000000	11104	5608	1	0	\N
266883	1874	203135000	11104	5608	2	0	\N
266884	192	66227799354186	11104	5608	3	0	\N
266885	973	505148775000000	11104	5608	4	0	\N
266886	1678	11520366487000	11104	5608	5	0	\N
266887	1874	203136000	11104	5608	6	0	\N
266888	918	504510205933512	11104	5608	7	0	\N
266889	1038	904077966389392	11104	5608	8	0	\N
266890	1158	609999418948983	11104	5608	9	0	\N
266891	1284	1699817619025558	11104	5608	10	0	\N
266892	1213	610771750000000	11104	5608	11	0	\N
266893	1678	11520366488000	11104	5608	12	0	\N
266894	1874	203137000	11104	5608	13	0	\N
266895	1874	203138000	11104	5608	14	0	\N
266896	1874	203139000	11104	5608	15	0	\N
266897	1678	11520366489000	11104	5608	16	0	\N
266898	1678	11520366490000	11104	5608	17	0	\N
266899	1874	203140000	11104	5608	18	0	\N
266900	1874	203141000	11104	5608	19	0	\N
266901	1874	203142000	11104	5608	20	0	\N
266902	1874	203143000	11104	5608	21	0	\N
266903	1874	203144000	11104	5608	22	0	\N
266904	1874	203145000	11104	5608	23	0	\N
266905	1874	203146000	11104	5608	24	0	\N
266906	1874	203147000	11104	5608	25	0	\N
266907	1874	203148000	11104	5608	26	0	\N
266908	1874	203149000	11104	5608	27	0	\N
266909	1874	203150000	11104	5608	28	0	\N
266910	1874	203151000	11104	5608	29	0	\N
266911	1874	203152000	11104	5608	30	0	\N
266912	1874	203153000	11104	5608	31	0	\N
266913	1874	203154000	11104	5608	32	0	\N
266914	1874	203155000	11104	5608	33	0	\N
266915	1874	203156000	11104	5608	34	0	\N
266916	1874	203157000	11104	5608	35	0	\N
266917	1874	203158000	11104	5608	36	0	\N
266918	1874	203159000	11104	5608	37	0	\N
266919	1093	905222465000000	11104	5608	38	0	\N
266920	1339	1701968637751650	11104	5608	39	0	\N
266921	257	67245000000000	11104	5608	40	0	\N
266922	1874	203160000	11104	5608	41	0	\N
266923	1874	203161000	11104	5608	42	0	\N
266924	1874	203162000	11104	5608	43	0	\N
266925	1874	203163000	11104	5608	44	0	\N
266926	1874	203164000	11104	5608	45	0	\N
266927	1874	203165000	11104	5608	46	0	\N
266928	1874	203166000	11104	5608	47	0	\N
266929	1874	203167000	11104	5608	48	0	\N
266930	1874	203168000	11104	5608	50	0	\N
266931	1874	203169000	11104	5608	51	0	\N
266932	1874	203170000	11104	5608	52	0	\N
266933	1874	203171000	11104	5608	53	0	\N
266934	1678	11520366491000	11104	5608	54	0	\N
266935	1678	11520366492000	11104	5608	55	0	\N
266936	1678	11520366493000	11104	5608	56	0	\N
266937	1678	11520366494000	11104	5608	57	0	\N
266938	1678	11520366495000	11104	5608	58	0	\N
266939	1678	11520366496000	11104	5608	59	0	\N
266940	1678	11520366497000	11104	5608	60	0	\N
266941	1678	11520366498000	11104	5608	61	0	\N
266942	1678	11520366499000	11104	5608	62	0	\N
266943	1678	11520366500000	11104	5608	63	0	\N
266944	1678	11520366501000	11104	5608	64	0	\N
266945	1678	11520366502000	11104	5608	65	0	\N
266946	1678	11520366503000	11104	5608	66	0	\N
266947	1678	11520366504000	11104	5608	67	0	\N
266948	1678	11520366505000	11104	5608	68	0	\N
266949	1678	11520366506000	11104	5608	69	0	\N
266950	1678	11520366507000	11104	5608	70	0	\N
266951	1678	11520366508000	11104	5608	71	0	\N
266952	1678	11520366509000	11104	5608	72	0	\N
266953	1678	11520366510000	11104	5608	73	0	\N
266954	1678	11520366511000	11104	5608	74	0	\N
266955	1678	11520366512000	11104	5608	75	0	\N
266956	1678	11520366513000	11104	5608	76	0	\N
266957	1678	11520366514000	11104	5608	77	0	\N
266958	1678	11520366515000	11104	5608	78	0	\N
266959	1678	12240386522000	11105	5712	0	0	\N
266960	1678	12240386523000	11105	5712	1	0	\N
266961	1874	203172000	11105	5712	2	0	\N
266962	1874	203173000	11105	5712	3	0	\N
266963	2043	200000000	11105	5712	4	0	\N
266854	1874	203170000	11101	5711	0	0	0
266855	192	66227799354186	11101	5711	1	0	0
266856	918	504510205933512	11101	5711	2	0	0
266857	1038	904077966389392	11101	5711	3	0	0
266858	1158	609999418948983	11101	5711	4	0	0
266860	1678	12240386520000	11101	5711	6	0	0
266861	1678	12240386521000	11101	5711	7	0	0
266862	1874	203171000	11101	5711	8	0	0
266964	1678	12240386522000	11106	5712	0	0	0
266965	1678	12240386523000	11106	5712	1	0	0
266967	1874	203173000	11106	5712	3	0	0
266968	2043	200000000	11106	5712	4	0	0
266971	1874	203174000	11108	5713	0	0	\N
266972	1678	12240386524000	11108	5713	2	0	\N
266973	1874	203174000	11109	5713	0	0	\N
266974	1678	12240386524000	11109	5713	2	0	\N
266975	1874	203174000	11110	5713	0	0	\N
266976	1678	12240386524000	11110	5713	2	0	\N
266977	1678	12240386525000	11111	5714	0	0	\N
266978	2044	200000000	11111	5714	1	0	\N
266979	1874	203175000	11111	5714	2	0	\N
266980	1678	12240386526000	11111	5714	3	0	\N
266981	1874	203176000	11111	5714	4	0	\N
266991	1678	12240386527000	11114	5715	0	0	\N
266992	1874	203177000	11114	5715	1	0	\N
266993	1874	203178000	11114	5715	2	0	\N
266994	1678	12240386528000	11114	5715	3	0	\N
266995	1678	12240386527000	11115	5715	0	0	\N
266996	1874	203177000	11115	5715	1	0	\N
266997	1874	203178000	11115	5715	2	0	\N
266998	1678	12240386528000	11115	5715	3	0	\N
266999	1678	12240386527000	11116	5715	0	0	\N
267000	1874	203177000	11116	5715	1	0	\N
267001	1874	203178000	11116	5715	2	0	\N
267002	1678	12240386528000	11116	5715	3	0	\N
267003	1678	12240386529000	11118	5716	0	0	\N
267004	1678	12240386530000	11118	5716	1	0	\N
267005	1874	203179000	11118	5716	2	0	\N
267006	1874	203180000	11118	5716	3	0	\N
267013	1874	203182000	11121	5718	0	0	\N
267014	1678	12240386532000	11121	5718	1	0	\N
267015	1874	203182000	11122	5718	0	0	\N
267016	1678	12240386532000	11122	5718	1	0	\N
267021	257	66001000000000	11125	5693	0	0	\N
267022	1874	203151000	11125	5693	1	0	\N
267023	1678	12240386502000	11125	5693	2	0	\N
267024	192	66227799354186	11125	5693	3	0	\N
267025	973	505148775000000	11125	5693	4	0	\N
267026	1874	203152000	11125	5693	5	0	\N
267027	1874	203153000	11125	5693	6	0	\N
267028	918	504510205933512	11125	5693	7	0	\N
267029	1038	904077966389392	11125	5693	8	0	\N
267030	1158	609999418948983	11125	5693	9	0	\N
267031	1284	1699817619025558	11125	5693	10	0	\N
267032	1213	610771750000000	11125	5693	11	0	\N
267033	1874	203154000	11125	5693	12	0	\N
267034	1874	203155000	11125	5693	13	0	\N
267035	1874	203156000	11125	5693	14	0	\N
267036	1874	203157000	11125	5693	15	0	\N
267037	1874	203158000	11125	5693	16	0	\N
267038	1874	203159000	11125	5693	17	0	\N
267039	1678	12240386503000	11125	5693	18	0	\N
267040	1678	12240386504000	11125	5693	19	0	\N
267041	1678	12240386505000	11125	5693	20	0	\N
267042	1678	12240386506000	11125	5693	21	0	\N
267043	1678	12240386507000	11125	5693	22	0	\N
267044	1678	12240386508000	11125	5693	23	0	\N
267045	1678	12240386509000	11125	5693	24	0	\N
267046	1093	905222465000000	11125	5693	25	0	\N
267047	1339	1701968637751650	11125	5693	26	0	\N
267048	257	67245000000000	11125	5693	27	0	\N
267049	1874	203160000	11125	5693	28	0	\N
267050	1874	203161000	11125	5693	29	0	\N
267051	1874	203162000	11125	5693	30	0	\N
267052	1874	203163000	11125	5693	31	0	\N
267053	1874	203164000	11125	5693	32	0	\N
267054	1874	203165000	11125	5693	33	0	\N
267055	1874	203166000	11125	5693	34	0	\N
267056	1874	203167000	11125	5693	35	0	\N
267057	1874	203168000	11125	5693	36	0	\N
267058	1874	203169000	11125	5693	37	0	\N
267059	1874	203170000	11125	5693	38	0	\N
267060	1874	203171000	11125	5693	39	0	\N
267061	1874	203172000	11125	5693	40	0	\N
267062	1874	203173000	11125	5693	41	0	\N
267063	2043	200000000	11125	5693	42	0	\N
267064	1874	203174000	11125	5693	43	0	\N
267065	2044	200000000	11125	5693	44	0	\N
267066	1874	203175000	11125	5693	45	0	\N
267067	1678	12240386510000	11125	5693	46	0	\N
267068	1678	12240386511000	11125	5693	47	0	\N
267069	1678	12240386512000	11125	5693	48	0	\N
267070	1874	203176000	11125	5693	49	0	\N
267071	1874	203177000	11125	5693	50	0	\N
267072	1874	203178000	11125	5693	51	0	\N
267073	1874	203179000	11125	5693	52	0	\N
267074	1874	203180000	11125	5693	53	0	\N
267075	1874	203181000	11125	5693	54	0	\N
267076	1874	203182000	11125	5693	55	0	\N
267077	1874	203183000	11125	5693	56	0	\N
267078	1678	12240386513000	11125	5693	57	0	\N
267079	1678	12240386514000	11125	5693	58	0	\N
267080	1678	12240386515000	11125	5693	59	0	\N
267081	1678	12240386516000	11125	5693	60	0	\N
267082	1678	12240386517000	11125	5693	61	0	\N
267083	1678	12240386518000	11125	5693	62	0	\N
267084	1678	12240386519000	11125	5693	63	0	\N
267085	1678	12240386520000	11125	5693	64	0	\N
267086	1678	12240386521000	11125	5693	65	0	\N
267087	1678	12240386522000	11125	5693	66	0	\N
267088	1678	12240386523000	11125	5693	67	0	\N
267089	1678	12240386524000	11125	5693	68	0	\N
267090	1678	12240386525000	11125	5693	69	0	\N
267091	1678	12240386526000	11125	5693	70	0	\N
267092	1678	12240386527000	11125	5693	71	0	\N
267093	1678	12240386528000	11125	5693	72	0	\N
267094	1678	12240386529000	11125	5693	73	0	\N
267095	1678	12240386530000	11125	5693	74	0	\N
267096	1678	12240386531000	11125	5693	75	0	\N
267097	1678	12240386532000	11125	5693	76	0	\N
267098	1678	12240386533000	11125	5693	77	0	\N
267101	1874	203184000	11127	5720	0	0	\N
267102	1678	12240386534000	11127	5720	1	0	\N
267103	1874	203184000	11128	5720	0	0	\N
267104	1678	12240386534000	11128	5720	1	0	\N
266982	1678	12240386525000	11112	5714	0	0	0
266983	2044	200000000	11112	5714	1	0	0
266984	1874	203175000	11112	5714	2	0	0
266985	1678	12240386526000	11112	5714	3	0	0
266986	1874	203176000	11112	5714	4	0	0
266988	1874	203177000	11113	5715	1	0	0
266989	1874	203178000	11113	5715	2	0	0
266990	1678	12240386528000	11113	5715	3	0	0
267007	1678	12240386529000	11119	5716	0	0	0
267008	1678	12240386530000	11119	5716	1	0	0
267010	1874	203180000	11119	5716	3	0	0
267011	1678	12240386531000	11120	5717	0	0	0
267012	1874	203181000	11120	5717	1	0	0
267017	1874	203182000	11123	5718	0	0	0
267019	1678	12240386533000	11124	5719	0	0	0
267020	1874	203183000	11124	5719	1	0	0
267099	1874	203184000	11126	5720	0	0	0
267100	1678	12240386534000	11126	5720	1	0	0
267105	1678	12240386535000	11129	5721	0	0	\N
267106	1874	203185000	11129	5721	1	0	\N
267107	1874	203186000	11129	5721	2	0	\N
267108	1678	12240386536000	11129	5721	3	0	\N
267113	257	66001000000000	11131	5673	0	0	\N
267114	411	66838420000000	11131	5673	1	0	\N
267115	192	66227799354186	11131	5673	2	0	\N
267116	973	505148775000000	11131	5673	3	0	\N
267117	2042	830490000000	11131	5673	4	0	\N
267118	918	504510205933512	11131	5673	5	0	\N
267119	1038	904077966389392	11131	5673	6	0	\N
267120	1158	609999418948983	11131	5673	7	0	\N
267121	1284	1699817619025558	11131	5673	8	0	\N
267122	1213	610771750000000	11131	5673	9	0	\N
267123	2042	1550490000000	11131	5673	10	0	\N
267124	1874	203124000	11131	5673	11	0	\N
267125	1874	203125000	11131	5673	12	0	\N
267126	1874	203126000	11131	5673	13	0	\N
267127	1874	203127000	11131	5673	14	0	\N
267128	1678	11520366476000	11131	5673	15	0	\N
267129	1678	11520366477000	11131	5673	16	0	\N
267130	1678	11520366478000	11131	5673	17	0	\N
267131	1678	11520366479000	11131	5673	18	0	\N
267132	1678	11520366480000	11131	5673	19	0	\N
267133	1678	11520366481000	11131	5673	20	0	\N
267134	1678	11520366482000	11131	5673	21	0	\N
267135	1678	11520366483000	11131	5673	22	0	\N
267136	1678	11520366484000	11131	5673	23	0	\N
267137	1678	11520366485000	11131	5673	24	0	\N
267138	1678	11520366486000	11131	5673	25	0	\N
267139	1678	11520366487000	11131	5673	26	0	\N
267140	1678	11520366488000	11131	5673	27	0	\N
267141	1678	11520366489000	11131	5673	28	0	\N
267142	1678	11520366490000	11131	5673	29	0	\N
267143	1093	905222465000000	11131	5673	30	0	\N
267144	1339	1701968637751650	11131	5673	31	0	\N
267145	257	67245000000000	11131	5673	32	0	\N
267146	1678	11520366491000	11131	5673	33	0	\N
267147	1678	11520366492000	11131	5673	34	0	\N
267148	1678	11520366493000	11131	5673	35	0	\N
267149	1678	11520366494000	11131	5673	36	0	\N
267150	1678	11520366495000	11131	5673	37	0	\N
267151	1678	11520366496000	11131	5673	38	0	\N
267152	1678	11520366497000	11131	5673	39	0	\N
267153	1678	11520366498000	11131	5673	40	0	\N
267154	1678	11520366499000	11131	5673	41	0	\N
267155	1678	11520366500000	11131	5673	42	0	\N
267156	1678	11520366501000	11131	5673	43	0	\N
267157	1678	11520366502000	11131	5673	44	0	\N
267158	1678	11520366503000	11131	5673	45	0	\N
267159	1678	11520366504000	11131	5673	46	0	\N
267160	1678	11520366505000	11131	5673	47	0	\N
267161	1678	11520366506000	11131	5673	48	0	\N
267162	1678	11520366507000	11131	5673	49	0	\N
267163	1678	11520366508000	11131	5673	50	0	\N
267164	1678	11520366509000	11131	5673	51	0	\N
267165	1678	11520366510000	11131	5673	52	0	\N
267166	1678	11520366511000	11131	5673	53	0	\N
267167	1678	11520366512000	11131	5673	54	0	\N
267168	1874	203128000	11131	5673	55	0	\N
267169	1874	203129000	11131	5673	56	0	\N
267170	1874	203130000	11131	5673	57	0	\N
267171	1874	203131000	11131	5673	58	0	\N
267172	1874	203132000	11131	5673	59	0	\N
267173	1874	203133000	11131	5673	60	0	\N
267174	1874	203134000	11131	5673	61	0	\N
267175	1874	203135000	11131	5673	62	0	\N
267176	1874	203136000	11131	5673	63	0	\N
267177	1874	203137000	11131	5673	64	0	\N
267178	1874	203138000	11131	5673	66	0	\N
267179	1874	203139000	11131	5673	67	0	\N
267180	1874	203140000	11131	5673	68	0	\N
267181	1874	203141000	11131	5673	69	0	\N
267182	1874	203142000	11131	5673	70	0	\N
267183	1874	203143000	11131	5673	71	0	\N
267184	1874	203144000	11131	5673	72	0	\N
267185	1874	203145000	11131	5673	73	0	\N
267186	1874	203146000	11131	5673	74	0	\N
267187	1874	203147000	11131	5673	75	0	\N
267188	1874	203148000	11131	5673	76	0	\N
267189	1874	203149000	11131	5673	77	0	\N
267190	1874	203150000	11131	5673	78	0	\N
267191	1874	203151000	11131	5673	79	0	\N
267192	1874	203152000	11131	5673	80	0	\N
267193	1874	203153000	11131	5673	81	0	\N
267194	1874	203154000	11131	5673	82	0	\N
267195	1874	203155000	11131	5673	83	0	\N
267196	1874	203156000	11131	5673	84	0	\N
267197	1874	203157000	11131	5673	85	0	\N
267198	1874	203158000	11131	5673	86	0	\N
267199	1874	203159000	11131	5673	87	0	\N
267200	1874	203160000	11131	5673	88	0	\N
267201	1874	203161000	11131	5673	89	0	\N
267202	1874	203162000	11131	5673	90	0	\N
267203	1874	203163000	11131	5673	91	0	\N
267204	1874	203164000	11131	5673	92	0	\N
267205	1874	203165000	11131	5673	93	0	\N
267206	1874	203166000	11131	5673	94	0	\N
267207	1874	203167000	11131	5673	95	0	\N
267208	1874	203168000	11131	5673	96	0	\N
267209	1874	203169000	11131	5673	97	0	\N
267210	1874	203170000	11131	5673	98	0	\N
267211	1874	203171000	11131	5673	99	0	\N
267212	1874	203172000	11131	5673	100	0	\N
267213	1874	203173000	11131	5673	101	0	\N
267214	2043	200000000	11131	5673	102	0	\N
267215	1874	203174000	11131	5673	103	0	\N
267216	2044	200000000	11131	5673	104	0	\N
267217	1874	203175000	11131	5673	105	0	\N
267218	1874	203176000	11131	5673	106	0	\N
267219	1874	203177000	11131	5673	107	0	\N
267220	1874	203178000	11131	5673	108	0	\N
267221	1874	203179000	11131	5673	109	0	\N
267222	1874	203180000	11131	5673	110	0	\N
267223	1874	203181000	11131	5673	111	0	\N
267224	1874	203182000	11131	5673	112	0	\N
267225	1874	203183000	11131	5673	113	0	\N
267226	1874	203184000	11131	5673	114	0	\N
267227	1874	203185000	11131	5673	115	0	\N
267228	1874	203186000	11131	5673	116	0	\N
267229	1678	11520366513000	11131	5673	117	0	\N
267230	1678	11520366514000	11131	5673	118	0	\N
267231	1678	11520366515000	11131	5673	119	0	\N
267232	1678	11520366516000	11131	5673	120	0	\N
267233	1678	11520366517000	11131	5673	121	0	\N
267234	1678	11520366518000	11131	5673	122	0	\N
267235	1678	11520366519000	11131	5673	123	0	\N
267236	1678	11520366520000	11131	5673	124	0	\N
267237	1678	11520366521000	11131	5673	125	0	\N
267240	1678	12240386538000	11133	5723	0	0	\N
267111	1874	203186000	11130	5721	2	0	0
267112	1678	12240386536000	11130	5721	3	0	0
267238	1678	12240386537000	11132	5722	0	0	0
267239	1874	203187000	11132	5722	1	0	0
267241	1874	203188000	11133	5723	1	0	\N
267244	1678	12240386538000	11135	5723	0	0	\N
267245	1874	203188000	11135	5723	1	0	\N
267246	1678	12240386538000	11136	5723	0	0	\N
267247	1874	203188000	11136	5723	1	0	\N
267248	1874	203189000	11137	5724	0	0	\N
267249	1874	203190000	11137	5724	1	0	\N
267250	1678	12240386539000	11137	5724	2	0	\N
267251	1678	12240386540000	11137	5724	3	0	\N
267252	1678	12240386541000	11137	5724	4	0	\N
267253	1874	203191000	11137	5724	5	0	\N
267262	1874	203193000	11140	5726	0	0	\N
267263	1678	12240386543000	11140	5726	1	0	\N
267266	1874	203193000	11142	5726	0	0	\N
267267	1678	12240386543000	11142	5726	1	0	\N
267271	1874	203195000	11144	5728	0	0	\N
267272	1874	203196000	11144	5728	1	0	\N
267273	1678	12240386546000	11144	5728	2	0	\N
267274	1678	12240386547000	11144	5728	3	0	\N
267279	1874	203195000	11146	5728	0	0	\N
267280	1874	203196000	11146	5728	1	0	\N
267281	1678	12240386546000	11146	5728	2	0	\N
267282	1678	12240386547000	11146	5728	3	0	\N
267283	1874	203195000	11147	5728	0	0	\N
267284	1874	203196000	11147	5728	1	0	\N
267285	1678	12240386546000	11147	5728	2	0	\N
267286	1678	12240386547000	11147	5728	3	0	\N
267287	1874	203197000	11148	5729	0	0	\N
267288	1678	12240386548000	11148	5729	1	0	\N
267299	1678	12240386553000	11154	5734	0	0	\N
267300	1874	203202000	11154	5734	1	0	\N
267318	1874	203210000	11166	5739	0	0	\N
267319	1678	12240386560000	11166	5739	1	0	\N
267320	1874	203211000	11170	5741	0	0	\N
267321	1874	203212000	11170	5741	1	0	\N
267322	1678	12240386561000	11170	5741	2	0	\N
267323	1678	12240386562000	11170	5741	3	0	\N
267324	1874	203211000	11171	5741	0	0	\N
267325	1874	203212000	11171	5741	1	0	\N
267326	1678	12240386561000	11171	5741	2	0	\N
267327	1678	12240386562000	11171	5741	3	0	\N
267328	1874	203211000	11172	5741	0	0	\N
267329	1874	203212000	11172	5741	1	0	\N
267330	1678	12240386561000	11172	5741	2	0	\N
267331	1678	12240386562000	11172	5741	3	0	\N
267332	1874	203211000	11173	5741	0	0	\N
267333	1874	203212000	11173	5741	1	0	\N
267334	1678	12240386561000	11173	5741	2	0	\N
267335	1678	12240386562000	11173	5741	3	0	\N
267336	1874	203211000	11174	5741	0	0	\N
267337	1874	203212000	11174	5741	1	0	\N
267338	1678	12240386561000	11174	5741	2	0	\N
267339	1678	12240386562000	11174	5741	3	0	\N
267340	1874	203211000	11175	5741	0	0	\N
267341	1874	203212000	11175	5741	1	0	\N
267342	1678	12240386561000	11175	5741	2	0	\N
267343	1678	12240386562000	11175	5741	3	0	\N
267348	957	505695775000000	11177	5617	0	0	\N
267349	1197	611432750000000	11177	5617	1	0	\N
267350	1077	906202465000000	11177	5617	2	0	\N
267351	1323	1703811637751650	11177	5617	3	0	\N
267352	1343	1704118637751650	11177	5617	4	0	\N
267353	1097	906366465000000	11177	5617	5	0	\N
267354	1217	611543750000000	11177	5617	6	0	\N
267355	977	505786775000000	11177	5617	7	0	\N
267356	1534	0	11177	5617	8	0	\N
267357	954	505422011687992	11177	5617	10	0	\N
267358	1194	611101876290553	11177	5617	11	0	\N
267359	1074	905711914489072	11177	5617	12	0	\N
267360	1320	1702889714432878	11177	5617	13	0	\N
267361	406	66002000000000	11177	5617	14	0	\N
267362	1384	1702260637751650	11177	5617	15	0	\N
267363	1138	905377465000000	11177	5617	16	0	\N
267364	1258	610878750000000	11177	5617	17	0	\N
267365	1018	505235775000000	11177	5617	18	0	\N
267366	257	66001000000000	11177	5617	19	0	\N
267367	192	66227799354186	11177	5617	20	0	\N
267368	973	505148775000000	11177	5617	21	0	\N
267369	1678	11520366401000	11177	5617	22	0	\N
267370	1678	11520366402000	11177	5617	23	0	\N
267371	1678	11520366403000	11177	5617	24	0	\N
267372	918	504510205933512	11177	5617	25	0	\N
267373	1038	904077966389392	11177	5617	26	0	\N
267374	1340	1700431510151650	11177	5617	27	0	\N
267375	1094	904405024600000	11177	5617	28	0	\N
267376	1214	610220226800000	11177	5617	29	0	\N
267254	1874	203189000	11138	5724	0	0	0
267255	1874	203190000	11138	5724	1	0	0
267256	1678	12240386539000	11138	5724	2	0	0
267257	1678	12240386540000	11138	5724	3	0	0
267258	1678	12240386541000	11138	5724	4	0	0
267260	1678	12240386542000	11139	5725	0	0	0
267261	1874	203192000	11139	5725	1	0	0
267264	1874	203193000	11141	5726	0	0	0
267265	1678	12240386543000	11141	5726	1	0	0
267268	1678	12240386544000	11143	5727	0	0	0
267270	1874	203194000	11143	5727	2	0	0
267275	1874	203195000	11145	5728	0	0	0
267276	1874	203196000	11145	5728	1	0	0
267277	1678	12240386546000	11145	5728	2	0	0
267289	1874	203197000	11149	5729	0	0	0
267290	1678	12240386548000	11149	5729	1	0	0
267291	1678	12240386549000	11151	5731	0	0	0
267292	1874	203198000	11151	5731	1	0	0
267293	1874	203199000	11151	5731	2	0	0
267295	1874	203200000	11152	5732	0	0	0
267296	1678	12240386551000	11152	5732	1	0	0
267297	1678	12240386552000	11153	5733	0	0	0
267298	1874	203201000	11153	5733	1	0	0
267301	1678	12240386553000	11155	5734	0	0	0
267303	1678	12240386554000	11156	5735	0	0	0
267304	1874	203203000	11156	5735	1	0	0
267305	1874	203204000	11156	5735	2	0	0
267306	1874	203205000	11158	5736	0	0	0
267308	1678	12240386556000	11163	5737	0	0	0
267309	1678	12240386557000	11163	5737	1	0	0
267310	1678	12240386558000	11163	5737	2	0	0
267311	1874	203206000	11163	5737	3	0	0
267312	1874	203207000	11163	5737	4	0	0
267314	1874	203209000	11164	5738	0	0	0
267315	1678	12240386559000	11164	5738	1	0	0
267316	1874	203210000	11165	5739	0	0	0
267317	1678	12240386560000	11165	5739	1	0	0
267344	1874	203211000	11176	5741	0	0	0
267346	1678	12240386561000	11176	5741	2	0	0
267347	1678	12240386562000	11176	5741	3	0	0
267377	1158	609999418948983	11177	5617	30	0	\N
267378	1284	1699817619025558	11177	5617	31	0	\N
267379	1678	11520366404000	11177	5617	32	0	\N
267380	1678	11520366405000	11177	5617	33	0	\N
267381	1213	610771750000000	11177	5617	34	0	\N
267382	1678	11520366406000	11177	5617	35	0	\N
267383	2042	719000000000	11177	5617	36	0	\N
267384	1289	1700432637751650	11177	5617	37	0	\N
267385	1043	904405465000000	11177	5617	38	0	\N
267386	1163	610220750000000	11177	5617	39	0	\N
267387	1000	505559659823781	11177	5617	40	0	\N
267388	1240	611268750000000	11177	5617	41	0	\N
267389	2042	721000000000	11177	5617	42	0	\N
267390	2042	1551000000000	11177	5617	43	0	\N
267391	1678	11520366407000	11177	5617	44	0	\N
267392	1120	905959465000000	11177	5617	45	0	\N
267393	1366	1703353637751650	11177	5617	46	0	\N
267394	923	504692775000000	11177	5617	47	0	\N
267395	1874	203050000	11177	5617	48	0	\N
267396	1093	905222465000000	11177	5617	49	0	\N
267397	1339	1701968637751650	11177	5617	50	0	\N
267398	257	67245000000000	11177	5617	51	0	\N
267399	974	504692496200000	11177	5617	52	0	\N
267400	1874	203051000	11177	5617	53	0	\N
267401	1874	203052000	11177	5617	54	0	\N
267402	1874	203053000	11177	5617	55	0	\N
267403	1874	203054000	11177	5617	56	0	\N
267404	1874	203055000	11177	5617	57	0	\N
267405	1874	203056000	11177	5617	58	0	\N
267406	1678	11520366408000	11177	5617	59	0	\N
267407	1678	11520366409000	11177	5617	60	0	\N
267408	1678	11520366410000	11177	5617	61	0	\N
267409	1678	11520366411000	11177	5617	62	0	\N
267410	1678	11520366412000	11177	5617	63	0	\N
267411	1678	11520366413000	11177	5617	64	0	\N
267412	1678	11520366414000	11177	5617	65	0	\N
267413	1678	11520366415000	11177	5617	66	0	\N
267414	1678	11520366416000	11177	5617	67	0	\N
267415	1678	11520366417000	11177	5617	68	0	\N
267416	1678	11520366418000	11177	5617	69	0	\N
267417	1678	11520366419000	11177	5617	70	0	\N
267418	1678	11520366420000	11177	5617	71	0	\N
267419	1678	11520366421000	11177	5617	72	0	\N
267420	1678	11520366422000	11177	5617	73	0	\N
267421	1678	11520366423000	11177	5617	74	0	\N
267422	1678	11520366424000	11177	5617	75	0	\N
267423	1678	11520366425000	11177	5617	76	0	\N
267424	1678	11520366426000	11177	5617	77	0	\N
267425	1678	11520366427000	11177	5617	78	0	\N
267426	1678	11520366428000	11177	5617	79	0	\N
267427	1678	11520366429000	11177	5617	80	0	\N
267428	1678	11520366430000	11177	5617	81	0	\N
267429	1678	11520366431000	11177	5617	82	0	\N
267430	1678	11520366432000	11177	5617	83	0	\N
267431	1678	11520366433000	11177	5617	84	0	\N
267432	1678	11520366434000	11177	5617	85	0	\N
267433	1678	11520366435000	11177	5617	86	0	\N
267434	1678	11520366436000	11177	5617	87	0	\N
267435	1678	11520366437000	11177	5617	88	0	\N
267436	1678	11520366438000	11177	5617	89	0	\N
267437	1678	11520366439000	11177	5617	90	0	\N
267438	1678	11520366440000	11177	5617	91	0	\N
267439	1678	11520366441000	11177	5617	92	0	\N
267440	1678	11520366442000	11177	5617	93	0	\N
267441	1678	11520366443000	11177	5617	94	0	\N
267442	1678	11520366444000	11177	5617	95	0	\N
267443	1678	11520366445000	11177	5617	96	0	\N
267444	1678	11520366446000	11177	5617	97	0	\N
267445	1678	11520366447000	11177	5617	98	0	\N
267446	1678	11520366448000	11177	5617	99	0	\N
267447	1678	11520366449000	11177	5617	100	0	\N
267448	1678	11520366450000	11177	5617	101	0	\N
267449	1678	11520366451000	11177	5617	102	0	\N
267450	1678	11520366452000	11177	5617	103	0	\N
267451	1678	11520366453000	11177	5617	104	0	\N
267452	1678	11520366454000	11177	5617	105	0	\N
267453	1678	11520366455000	11177	5617	106	0	\N
267454	1678	11520366456000	11177	5617	107	0	\N
267455	1678	11520366457000	11177	5617	109	0	\N
267456	1678	11520366458000	11177	5617	110	0	\N
267457	1678	11520366459000	11177	5617	111	0	\N
267458	1678	11520366460000	11177	5617	112	0	\N
267459	1678	11520366461000	11177	5617	113	0	\N
267460	1678	11520366462000	11177	5617	114	0	\N
267461	1678	11520366463000	11177	5617	115	0	\N
267462	1678	11520366464000	11177	5617	116	0	\N
267463	1678	11520366465000	11177	5617	117	0	\N
267464	1678	11520366466000	11177	5617	118	0	\N
267465	1678	11520366467000	11177	5617	119	0	\N
267466	1678	11520366468000	11177	5617	120	0	\N
267467	1678	11520366469000	11177	5617	121	0	\N
267468	1678	11520366470000	11177	5617	122	0	\N
267469	1678	11520366471000	11177	5617	123	0	\N
267470	1678	11520366472000	11177	5617	124	0	\N
267471	1678	11520366473000	11177	5617	125	0	\N
267472	1874	203213000	11178	5742	0	0	\N
267473	1874	203214000	11178	5742	1	0	\N
267474	1678	12240386563000	11178	5742	2	0	\N
267475	1678	12240386564000	11178	5742	3	0	\N
267476	1874	203213000	11179	5742	0	0	\N
267477	1874	203214000	11179	5742	1	0	\N
267478	1678	12240386563000	11179	5742	2	0	\N
267479	1678	12240386564000	11179	5742	3	0	\N
267488	1678	12240386565000	11182	5743	0	0	\N
267489	1678	12240386566000	11182	5743	1	0	\N
267490	1874	203215000	11182	5743	2	0	\N
267491	1874	203216000	11182	5743	3	0	\N
267492	1678	12240386565000	11184	5743	0	0	\N
267493	1678	12240386566000	11184	5743	1	0	\N
267494	1874	203215000	11184	5743	2	0	\N
267495	1874	203216000	11184	5743	3	0	\N
267496	1874	203217000	11185	5744	0	0	\N
267497	1678	12240386567000	11185	5744	1	0	\N
267498	1874	203217000	11186	5744	0	0	\N
267499	1678	12240386567000	11186	5744	1	0	\N
267502	1874	203217000	11188	5744	0	0	\N
267503	1678	12240386567000	11188	5744	1	0	\N
267507	1874	203218000	11190	5745	0	0	\N
267508	1874	203219000	11190	5745	1	0	\N
267509	1678	12240386568000	11190	5745	2	0	\N
267512	1874	203220000	11192	5746	0	0	\N
267482	1678	12240386563000	11180	5742	2	0	0
267483	1678	12240386564000	11180	5742	3	0	0
267484	1678	12240386565000	11181	5743	0	0	0
267485	1678	12240386566000	11181	5743	1	0	0
267486	1874	203215000	11181	5743	2	0	0
267500	1874	203217000	11187	5744	0	0	0
267501	1678	12240386567000	11187	5744	1	0	0
267504	1874	203218000	11189	5745	0	0	0
267505	1874	203219000	11189	5745	1	0	0
267506	1678	12240386568000	11189	5745	2	0	0
267511	1678	12240386569000	11191	5746	1	0	0
267513	1678	12240386569000	11192	5746	1	0	\N
267516	1678	12240386570000	11194	5747	0	0	\N
267517	1874	203221000	11194	5747	1	0	\N
267518	1678	12240386570000	11195	5747	0	0	\N
267519	1874	203221000	11195	5747	1	0	\N
267530	1678	12240386575000	11200	5751	0	0	\N
267531	1874	203226000	11200	5751	1	0	\N
267537	1874	203228000	11203	5753	0	0	\N
267538	2045	200000000	11203	5753	1	0	\N
267539	1678	12240386577000	11203	5753	2	0	\N
267546	2046	300000000	11205	5754	0	0	\N
267547	1678	12240386578000	11205	5754	1	0	\N
267548	1678	12240386579000	11205	5754	2	0	\N
267549	1874	203229000	11205	5754	3	0	\N
267550	1874	203230000	11205	5754	4	0	\N
267551	2044	200000000	11205	5754	5	0	\N
267552	2046	300000000	11206	5754	0	0	\N
267553	1678	12240386578000	11206	5754	1	0	\N
267554	1678	12240386579000	11206	5754	2	0	\N
267555	1874	203229000	11206	5754	3	0	\N
267556	1874	203230000	11206	5754	4	0	\N
267557	2044	200000000	11206	5754	5	0	\N
267558	2046	300000000	11207	5754	0	0	\N
267559	1678	12240386578000	11207	5754	1	0	\N
267560	1678	12240386579000	11207	5754	2	0	\N
267561	1874	203229000	11207	5754	3	0	\N
267562	1874	203230000	11207	5754	4	0	\N
267563	2044	200000000	11207	5754	5	0	\N
267573	907	505969095140680	11211	5758	0	0	\N
267574	1678	12240386584000	11211	5758	1	0	\N
267575	1874	203235000	11211	5758	2	0	\N
267592	1678	12240386590000	11215	5760	0	0	\N
267593	1678	12240386591000	11215	5760	1	0	\N
267594	1874	203241000	11215	5760	2	0	\N
267605	1874	203246000	11220	5764	0	0	\N
267606	1678	12240386596000	11220	5764	1	0	\N
267611	1874	203249000	11223	5767	0	0	\N
267612	1874	203250000	11223	5767	1	0	\N
267613	1678	12240386599000	11223	5767	2	0	\N
267614	1678	12240386600000	11223	5767	3	0	\N
267628	1678	12240386603000	11228	5770	0	0	\N
267629	1874	203253000	11228	5770	1	0	\N
267630	1874	203254000	11228	5770	2	0	\N
267631	1678	12240386604000	11228	5770	3	0	\N
267632	1874	203255000	11228	5770	4	0	\N
267638	1678	12240386605000	11230	5771	0	0	\N
267639	1678	12240386606000	11230	5771	1	0	\N
267640	1874	203256000	11230	5771	2	0	\N
267641	1874	203257000	11230	5771	3	0	\N
267642	1874	203258000	11230	5771	4	0	\N
267643	1678	12240386605000	11231	5771	0	0	\N
267644	1678	12240386606000	11231	5771	1	0	\N
267645	1874	203256000	11231	5771	2	0	\N
267646	1874	203257000	11231	5771	3	0	\N
267647	1874	203258000	11231	5771	4	0	\N
267648	1678	12240386605000	11232	5771	0	0	\N
267520	1678	12240386571000	11196	5748	0	0	0
267521	1874	203222000	11196	5748	1	0	0
267522	1678	12240386572000	11197	5749	0	0	0
267523	1874	203223000	11197	5749	1	0	0
267524	1874	203224000	11198	5750	0	0	0
267526	1678	12240386574000	11198	5750	2	0	0
267527	1874	203225000	11198	5750	3	0	0
267528	1678	12240386575000	11199	5751	0	0	0
267529	1874	203226000	11199	5751	1	0	0
267532	1874	203227000	11201	5752	0	0	0
267534	1874	203228000	11202	5753	0	0	0
267535	2045	200000000	11202	5753	1	0	0
267536	1678	12240386577000	11202	5753	2	0	0
267540	2046	300000000	11204	5754	0	0	0
267542	1678	12240386579000	11204	5754	2	0	0
267543	1874	203229000	11204	5754	3	0	0
267544	1874	203230000	11204	5754	4	0	0
267545	2044	200000000	11204	5754	5	0	0
267564	1678	12240386580000	11208	5755	0	0	0
267566	1874	203232000	11208	5755	2	0	0
267567	1678	12240386581000	11208	5755	3	0	0
267568	1874	203233000	11209	5756	0	0	0
267569	1678	12240386582000	11209	5756	1	0	0
267570	1937	200000000	11210	5757	0	0	1
267572	1678	12240386583000	11210	5757	2	0	0
267576	907	505969095140680	11212	5758	0	0	0
267577	1678	12240386584000	11212	5758	1	0	0
267578	1874	203235000	11212	5758	2	0	0
267580	1874	203237000	11213	5759	1	0	0
267581	1874	203238000	11213	5759	2	0	0
267582	1874	203239000	11213	5759	3	0	0
267583	1874	203240000	11213	5759	4	0	0
267584	1678	12240386585000	11213	5759	5	0	0
267586	1678	12240386587000	11213	5759	7	0	0
267587	1678	12240386588000	11213	5759	8	0	0
267588	1678	12240386589000	11213	5759	9	0	0
267589	1678	12240386590000	11214	5760	0	0	0
267590	1678	12240386591000	11214	5760	1	0	0
267595	1874	203242000	11216	5761	0	0	0
267596	1678	12240386592000	11216	5761	1	0	0
267597	1874	203243000	11217	5762	0	0	0
267598	1678	12240386593000	11217	5762	1	0	0
267600	1874	203244000	11217	5762	3	0	0
267601	1874	203245000	11218	5763	0	0	0
267602	1678	12240386595000	11218	5763	1	0	0
267603	1874	203246000	11219	5764	0	0	0
267604	1678	12240386596000	11219	5764	1	0	0
267608	1874	203247000	11221	5765	1	0	0
267609	1678	12240386598000	11222	5766	0	0	0
267610	1874	203248000	11222	5766	1	0	0
267615	1874	203249000	11224	5767	0	0	0
267616	1874	203250000	11224	5767	1	0	0
267618	1678	12240386600000	11224	5767	3	0	0
267619	1874	203251000	11225	5768	0	0	0
267620	1678	12240386601000	11225	5768	1	0	0
267621	1874	203252000	11226	5769	0	0	0
267623	1678	12240386603000	11227	5770	0	0	0
267624	1874	203253000	11227	5770	1	0	0
267625	1874	203254000	11227	5770	2	0	0
267626	1678	12240386604000	11227	5770	3	0	0
267627	1874	203255000	11227	5770	4	0	0
267634	1678	12240386606000	11229	5771	1	0	0
267635	1874	203256000	11229	5771	2	0	0
267636	1874	203257000	11229	5771	3	0	0
267637	1874	203258000	11229	5771	4	0	0
267649	1678	12240386606000	11232	5771	1	0	\N
267650	1874	203256000	11232	5771	2	0	\N
267651	1874	203257000	11232	5771	3	0	\N
267652	1874	203258000	11232	5771	4	0	\N
267653	1678	12240386607000	11233	5772	0	0	\N
267654	1678	12240386608000	11233	5772	1	0	\N
267655	1678	12240386609000	11233	5772	2	0	\N
267656	1874	203259000	11233	5772	3	0	\N
267657	1874	203260000	11233	5772	4	0	\N
267658	1874	203261000	11233	5772	5	0	\N
267659	1678	12240386607000	11234	5772	0	0	\N
267660	1678	12240386608000	11234	5772	1	0	\N
267661	1678	12240386609000	11234	5772	2	0	\N
267662	1874	203259000	11234	5772	3	0	\N
267663	1874	203260000	11234	5772	4	0	\N
267664	1874	203261000	11234	5772	5	0	\N
267671	1678	12240386610000	11236	5773	0	0	\N
267672	1874	203262000	11236	5773	1	0	\N
267673	1678	12240386610000	11237	5773	0	0	\N
267674	1874	203262000	11237	5773	1	0	\N
267675	1678	12240386610000	11238	5773	0	0	\N
267676	1874	203262000	11238	5773	1	0	\N
267694	1678	12240386619000	11245	5778	0	0	\N
267695	1678	12240386620000	11245	5778	1	0	\N
267696	1874	203270000	11245	5778	2	0	\N
267697	1874	203271000	11245	5778	3	0	\N
267698	1678	12240386619000	11246	5778	0	0	\N
267699	1678	12240386620000	11246	5778	1	0	\N
267700	1874	203270000	11246	5778	2	0	\N
267701	1874	203271000	11246	5778	3	0	\N
267711	122	66414824089930	11249	5779	0	0	\N
267712	721	2012570426909	11249	5779	1	0	\N
267713	1678	12240386621000	11249	5779	2	0	\N
267714	217	66414824089930	11249	5779	3	0	\N
267715	1874	203272000	11249	5779	4	0	\N
267716	103	66414824089930	11250	5780	0	0	\N
267717	1678	12240386622000	11250	5780	1	0	\N
267718	1811	1131150178317	11250	5780	2	0	\N
267719	1678	12240386623000	11250	5780	3	0	\N
267720	499	66414824089930	11250	5780	4	0	\N
267721	1772	2965629091692	11250	5780	5	0	\N
267722	54	66414824089930	11250	5780	6	0	\N
267723	710	5031426067384	11250	5780	7	0	\N
267724	320	66133624089930	11250	5780	8	0	\N
267725	1030	906636022402500	11250	5780	9	0	\N
267726	663	66414824089930	11250	5780	10	0	\N
267727	35	19320676098855	11250	5780	11	0	\N
267728	49	66414824089930	11250	5780	12	0	\N
267729	1874	203273000	11250	5780	13	0	\N
267730	1874	203274000	11250	5780	14	0	\N
267667	1678	12240386609000	11235	5772	2	0	0
267668	1874	203259000	11235	5772	3	0	0
267669	1874	203260000	11235	5772	4	0	0
267670	1874	203261000	11235	5772	5	0	0
267677	1678	12240386610000	11239	5773	0	0	0
267679	1678	12240386611000	11240	5774	0	0	0
267680	1678	12240386612000	11240	5774	1	0	0
267681	1874	203263000	11240	5774	2	0	0
267682	1678	12240386613000	11241	5775	0	0	0
267683	1678	12240386614000	11241	5775	1	0	0
267685	1874	203264000	11241	5775	3	0	0
267686	1874	203265000	11241	5775	4	0	0
267687	1874	203266000	11241	5775	5	0	0
267688	1678	12240386616000	11243	5776	0	0	0
267690	1678	12240386617000	11244	5777	0	0	0
267691	1678	12240386618000	11244	5777	1	0	0
267692	1874	203268000	11244	5777	2	0	0
267693	1874	203269000	11244	5777	3	0	0
267702	1678	12240386619000	11247	5778	0	0	0
267704	1874	203270000	11247	5778	2	0	0
267705	1874	203271000	11247	5778	3	0	0
267706	122	66414824089930	11248	5779	0	0	0
267707	721	2012570426909	11248	5779	1	0	0
267708	1678	12240386621000	11248	5779	2	0	0
267710	1874	203272000	11248	5779	4	0	0
267731	103	66414824089930	11251	5780	0	0	0
267732	1678	12240386622000	11251	5780	1	0	0
267733	1811	1131150178317	11251	5780	2	0	1
267735	499	66414824089930	11251	5780	4	0	0
267736	1772	2965629091692	11251	5780	5	0	1
267737	54	66414824089930	11251	5780	6	0	0
267738	710	5031426067384	11251	5780	7	0	0
267739	320	66133624089930	11251	5780	8	0	2
267741	663	66414824089930	11251	5780	10	0	0
267742	35	19320676098855	11251	5780	11	0	0
267743	49	66414824089930	11251	5780	12	0	0
267744	1874	203273000	11251	5780	13	0	0
267745	1874	203274000	11251	5780	14	0	0
267747	251	66414824089930	11252	5781	1	0	0
267748	99	66414824089930	11252	5781	2	0	0
267749	570	66414824089930	11252	5781	3	0	0
267750	893	308751364127976	11252	5781	4	0	0
267752	1874	203275000	11252	5781	6	0	0
267753	1678	12240386625000	11253	5782	0	0	0
267754	108	66414824089930	11253	5782	1	0	0
267755	894	308751364127976	11253	5782	2	0	0
267756	569	66414824089930	11253	5782	3	0	0
267758	225	66414824089930	11253	5782	5	0	0
267759	377	66414824089930	11253	5782	6	0	0
267760	1874	203276000	11253	5782	7	0	0
267761	1678	12240386626000	11254	5783	0	0	0
267762	82	66414824089930	11254	5783	1	0	0
267764	560	66414824089930	11254	5783	3	0	0
267765	309	66414824089930	11254	5783	4	0	0
267766	1962	413736265157	11254	5783	5	0	1
267767	201	66414824089930	11254	5783	6	0	0
267769	402	66414824089930	11259	5785	0	0	0
267770	275	66414824089930	11259	5785	1	0	0
267771	163	66414824089930	11259	5785	2	0	0
267772	397	66414824089930	11259	5785	3	0	0
267773	391	66414824089930	11259	5785	4	0	0
267775	106	66414824089930	11259	5785	6	0	0
267776	594	66414824089930	11259	5785	7	0	0
267777	680	66414824089930	11259	5785	8	0	0
267778	690	66414824089930	11259	5785	9	0	0
267779	731	2012570426909	11259	5785	10	0	0
267781	112	66071793089930	11259	5785	12	0	4
267782	353	66414814089930	11259	5785	13	0	1
267783	652	66414824089930	11259	5785	14	0	0
267784	420	66414824089930	11259	5785	15	0	0
267793	402	66414824089930	11260	5785	0	0	\N
267794	275	66414824089930	11260	5785	1	0	\N
267795	163	66414824089930	11260	5785	2	0	\N
267796	397	66414824089930	11260	5785	3	0	\N
267797	391	66414824089930	11260	5785	4	0	\N
267798	452	66414824089930	11260	5785	5	0	\N
267799	106	66414824089930	11260	5785	6	0	\N
267800	594	66414824089930	11260	5785	7	0	\N
267801	680	66414824089930	11260	5785	8	0	\N
267802	690	66414824089930	11260	5785	9	0	\N
267803	731	2012570426909	11260	5785	10	0	\N
267804	180	66414824089930	11260	5785	11	0	\N
267805	112	66071793089930	11260	5785	12	0	\N
267806	353	66414814089930	11260	5785	13	0	\N
267807	652	66414824089930	11260	5785	14	0	\N
267808	420	66414824089930	11260	5785	15	0	\N
267809	352	66414824089930	11260	5785	16	0	\N
267810	691	66414824089930	11260	5785	17	0	\N
267811	1678	12240386627000	11260	5785	18	0	\N
267812	1678	12240386628000	11260	5785	19	0	\N
267813	1678	12240386629000	11260	5785	20	0	\N
267814	1874	203278000	11260	5785	21	0	\N
267815	1874	203279000	11260	5785	22	0	\N
267816	1874	203280000	11260	5785	23	0	\N
267824	191	66414824089930	11262	5786	0	0	\N
267825	266	66414824089930	11262	5786	1	0	\N
267826	534	66414824089930	11262	5786	2	0	\N
267827	245	66414824089930	11262	5786	3	0	\N
267828	421	66414824089930	11262	5786	4	0	\N
267829	600	66414824089930	11262	5786	5	0	\N
267830	1874	203281000	11262	5786	6	0	\N
267831	1678	12240386630000	11263	5787	0	0	\N
267832	1678	12240386631000	11263	5787	1	0	\N
267833	620	66414824089930	11263	5787	2	0	\N
267834	2017	413423424329	11263	5787	3	0	\N
267835	551	66414824089930	11263	5787	4	0	\N
267836	520	66414824089930	11263	5787	5	0	\N
267837	84	66414824089930	11263	5787	6	0	\N
267838	1150	611725390313900	11263	5787	7	0	\N
267839	1874	203282000	11263	5787	8	0	\N
267840	1874	203283000	11263	5787	9	0	\N
267895	194	66414824089930	11269	5790	0	0	\N
267896	1276	1704627191698650	11269	5790	1	0	\N
267897	206	66414824089930	11269	5790	2	0	\N
267898	304	66414824089930	11269	5790	3	0	\N
267899	399	66414824089930	11269	5790	4	0	\N
267900	653	66414824089930	11269	5790	5	0	\N
267901	1678	12240386637000	11269	5790	6	0	\N
267902	1874	203289000	11269	5790	7	0	\N
267911	194	66414824089930	11271	5790	0	0	\N
267912	1678	12240386637000	11271	5790	1	0	\N
267913	1874	203289000	11271	5790	2	0	\N
267914	1678	12240386638000	11272	5791	0	0	\N
267915	1874	203290000	11272	5791	1	0	\N
267918	1678	12240386638000	11274	5791	0	0	\N
267919	1874	203290000	11274	5791	1	0	\N
267787	1678	12240386627000	11259	5785	18	0	0
267788	1678	12240386628000	11259	5785	19	0	0
267789	1678	12240386629000	11259	5785	20	0	0
267790	1874	203278000	11259	5785	21	0	0
267791	1874	203279000	11259	5785	22	0	0
267817	191	66414824089930	11261	5786	0	0	0
267818	266	66414824089930	11261	5786	1	0	0
267819	534	66414824089930	11261	5786	2	0	0
267820	245	66414824089930	11261	5786	3	0	0
267821	421	66414824089930	11261	5786	4	0	0
267823	1874	203281000	11261	5786	6	0	0
267841	1678	12240386630000	11265	5787	0	0	0
267842	1678	12240386631000	11265	5787	1	0	0
267843	620	66414824089930	11265	5787	2	0	0
267845	551	66414824089930	11265	5787	4	0	0
267846	520	66414824089930	11265	5787	5	0	0
267847	84	66414824089930	11265	5787	6	0	0
267848	1150	611725390313900	11265	5787	7	0	0
267849	308	66414824089930	11265	5787	8	0	0
267851	1874	203283000	11265	5787	10	0	0
267852	1678	12240386632000	11266	5788	0	0	0
267853	678	66414824089930	11266	5788	1	0	0
267854	392	66414824089930	11266	5788	2	0	0
267855	89	66414824089930	11266	5788	3	0	0
267857	1678	12240386633000	11266	5788	5	0	0
267858	1678	12240386634000	11266	5788	6	0	0
267859	1678	12240386635000	11266	5788	7	0	0
267860	339	66414824089930	11266	5788	8	0	0
267862	408	66414824089930	11266	5788	10	0	0
267863	745	2012570426909	11266	5788	11	0	0
267864	593	66414824089930	11266	5788	12	0	0
267865	91	66414824089930	11266	5788	13	0	0
267866	438	66414824089930	11266	5788	14	0	0
267868	322	66414824089930	11266	5788	16	0	0
267869	373	66414824089930	11266	5788	17	0	0
267870	150	66414824089930	11266	5788	18	0	0
267871	92	66414824089930	11266	5788	19	0	0
267872	453	66414824089930	11266	5788	20	0	0
267874	146	66414824089930	11266	5788	22	0	0
267875	601	66414824089930	11266	5788	23	0	0
267876	587	66414824089930	11266	5788	24	0	0
267877	910	505937699373100	11266	5788	25	0	0
267879	29	7043996494358	11266	5788	27	0	0
267880	138	66414824089930	11266	5788	28	0	0
267881	78	66414824089930	11266	5788	29	0	0
267882	395	66411794089930	11266	5788	30	0	1
267883	205	66414824089930	11266	5788	31	0	0
267885	1874	203285000	11266	5788	33	0	0
267886	1874	203286000	11266	5788	34	0	0
267887	1874	203287000	11266	5788	35	0	0
267888	1678	12240386636000	11267	5789	0	0	0
267889	611	66414824089930	11267	5789	1	0	0
267891	504	66414824089930	11267	5789	3	0	0
267892	658	66414824089930	11267	5789	4	0	0
267893	660	66414824089930	11267	5789	5	0	0
267894	1874	203288000	11267	5789	6	0	0
267904	1276	1704627191698650	11270	5790	1	0	0
267905	206	66414824089930	11270	5790	2	0	0
267906	304	66414824089930	11270	5790	3	0	0
267907	399	66414824089930	11270	5790	4	0	0
267908	653	66414824089930	11270	5790	5	0	0
267910	1874	203289000	11270	5790	7	0	0
267916	1678	12240386638000	11273	5791	0	0	0
267917	1874	203290000	11273	5791	1	0	0
267920	1874	203291000	11275	5792	0	0	0
267931	1678	12240386641000	11278	5794	0	0	\N
267932	1874	203294000	11278	5794	1	0	\N
267933	2046	300000000	11279	5652	0	0	\N
267934	192	66227799354186	11279	5652	1	0	\N
267935	973	505148775000000	11279	5652	2	0	\N
267936	122	66414824089930	11279	5652	3	0	\N
267937	1874	203152000	11279	5652	4	0	\N
267938	1874	203153000	11279	5652	5	0	\N
267939	721	2012570426909	11279	5652	6	0	\N
267940	1678	11520366506000	11279	5652	7	0	\N
267941	1678	11520366507000	11279	5652	8	0	\N
267942	1678	11520366508000	11279	5652	9	0	\N
267943	1678	11520366509000	11279	5652	10	0	\N
267944	918	504510205933512	11279	5652	11	0	\N
267945	1038	904077966389392	11279	5652	12	0	\N
267946	1349	1698698829951650	11279	5652	13	0	\N
267947	1158	609999418948983	11279	5652	14	0	\N
267948	1284	1699817619025558	11279	5652	15	0	\N
267949	1213	610771750000000	11279	5652	16	0	\N
267950	1223	612622942200000	11279	5652	17	0	\N
267951	1874	203154000	11279	5652	18	0	\N
267952	1874	203155000	11279	5652	19	0	\N
267953	1874	203156000	11279	5652	20	0	\N
267954	1874	203157000	11279	5652	21	0	\N
267955	1874	203158000	11279	5652	22	0	\N
267956	1874	203159000	11279	5652	23	0	\N
267957	217	66414824089930	11279	5652	24	0	\N
267958	103	66414824089930	11279	5652	25	0	\N
267959	1811	1131150178317	11279	5652	26	0	\N
267960	1103	903850752500000	11279	5652	27	0	\N
267961	983	505655062500000	11279	5652	28	0	\N
267962	1093	905222465000000	11279	5652	29	0	\N
267963	1339	1701968637751650	11279	5652	30	0	\N
267964	257	67245000000000	11279	5652	31	0	\N
267965	1874	203160000	11279	5652	32	0	\N
267966	1874	203161000	11279	5652	33	0	\N
267967	1874	203162000	11279	5652	34	0	\N
267968	1874	203163000	11279	5652	35	0	\N
267969	1874	203164000	11279	5652	36	0	\N
267970	1874	203165000	11279	5652	37	0	\N
267971	1874	203166000	11279	5652	38	0	\N
267972	1874	203167000	11279	5652	39	0	\N
267973	1874	203168000	11279	5652	40	0	\N
267974	1874	203169000	11279	5652	41	0	\N
267975	1874	203170000	11279	5652	42	0	\N
267976	1874	203171000	11279	5652	43	0	\N
267977	1874	203172000	11279	5652	44	0	\N
267978	1874	203173000	11279	5652	45	0	\N
267979	2043	200000000	11279	5652	46	0	\N
267980	1874	203174000	11279	5652	48	0	\N
267981	2044	200000000	11279	5652	49	0	\N
267982	1874	203175000	11279	5652	50	0	\N
267983	1678	11520366510000	11279	5652	51	0	\N
267984	1678	11520366511000	11279	5652	52	0	\N
267985	1678	11520366512000	11279	5652	53	0	\N
267986	1874	203176000	11279	5652	54	0	\N
267987	1874	203177000	11279	5652	55	0	\N
267988	1874	203178000	11279	5652	56	0	\N
267989	1874	203179000	11279	5652	57	0	\N
267990	1874	203180000	11279	5652	58	0	\N
267991	1874	203181000	11279	5652	59	0	\N
267992	1874	203182000	11279	5652	60	0	\N
267993	1874	203183000	11279	5652	61	0	\N
267994	1874	203184000	11279	5652	62	0	\N
267995	1874	203185000	11279	5652	63	0	\N
267996	1874	203186000	11279	5652	64	0	\N
267997	1874	203187000	11279	5652	65	0	\N
267998	1874	203188000	11279	5652	66	0	\N
267999	1874	203189000	11279	5652	67	0	\N
268000	1874	203190000	11279	5652	68	0	\N
268001	1874	203191000	11279	5652	69	0	\N
268002	1874	203192000	11279	5652	70	0	\N
268003	1874	203193000	11279	5652	71	0	\N
268004	1874	203194000	11279	5652	72	0	\N
268005	1874	203195000	11279	5652	73	0	\N
268006	1874	203196000	11279	5652	74	0	\N
268007	1874	203197000	11279	5652	75	0	\N
268008	1874	203198000	11279	5652	76	0	\N
268009	1874	203199000	11279	5652	77	0	\N
268010	1874	203200000	11279	5652	78	0	\N
268011	1874	203201000	11279	5652	79	0	\N
268012	1874	203202000	11279	5652	80	0	\N
268013	1874	203203000	11279	5652	81	0	\N
268014	1874	203204000	11279	5652	82	0	\N
268015	1874	203205000	11279	5652	83	0	\N
268016	622	66417804089930	11280	5795	0	0	\N
268017	105	66414824089930	11280	5795	2	0	\N
268018	1678	12240386642000	11280	5795	3	0	\N
268019	1874	203295000	11280	5795	4	0	\N
268020	622	66417804089930	11281	5795	0	0	\N
268021	105	66414824089930	11281	5795	2	0	\N
268022	1678	12240386642000	11281	5795	3	0	\N
268023	1874	203295000	11281	5795	4	0	\N
268030	1678	12240386643000	11284	5796	0	0	\N
268031	1874	203296000	11284	5796	1	0	\N
268032	1678	12240386643000	11285	5796	0	0	\N
268033	1874	203296000	11285	5796	1	0	\N
268036	1678	12240386645000	11287	5798	0	0	\N
268037	1874	203298000	11287	5798	1	0	\N
268042	1678	12240386646000	11290	5799	0	0	\N
268043	1874	203299000	11290	5799	1	0	\N
268046	1678	12240386647000	11292	5800	0	0	\N
268047	1874	203300000	11292	5800	1	0	\N
268056	1678	12240386652000	11295	5803	0	0	\N
267923	1678	12240386640000	11276	5793	2	0	0
267924	1223	612622942200000	11276	5793	3	0	0
267925	1103	903850752500000	11276	5793	4	0	0
267926	983	505655062500000	11276	5793	5	0	0
267927	1874	203292000	11276	5793	6	0	0
267929	1678	12240386641000	11277	5794	0	0	0
267930	1874	203294000	11277	5794	1	0	0
268024	622	66417804089930	11282	5795	0	0	1
268025	105	66414824089930	11282	5795	2	0	0
268026	1678	12240386642000	11282	5795	3	0	0
268028	1678	12240386643000	11283	5796	0	0	0
268029	1874	203296000	11283	5796	1	0	0
268034	1678	12240386644000	11286	5797	0	0	0
268035	1874	203297000	11286	5797	1	0	0
268039	1874	203298000	11288	5798	1	0	0
268040	1678	12240386646000	11289	5799	0	0	0
268041	1874	203299000	11289	5799	1	0	0
268044	1678	12240386647000	11291	5800	0	0	0
268045	1874	203300000	11291	5800	1	0	0
268049	1678	12240386649000	11293	5801	1	0	0
268050	1874	203301000	11293	5801	2	0	0
268051	1874	203302000	11293	5801	3	0	0
268052	1678	12240386650000	11294	5802	0	0	0
268053	1678	12240386651000	11294	5802	1	0	0
268055	1874	203304000	11294	5802	3	0	0
268057	1874	203305000	11295	5803	1	0	\N
268058	1678	12240386652000	11296	5803	0	0	\N
268059	1874	203305000	11296	5803	1	0	\N
268060	1678	12240386652000	11297	5803	0	0	\N
268061	1874	203305000	11297	5803	1	0	\N
268064	1678	12240386653000	11300	5804	0	0	\N
268065	1678	12240386653000	11301	5804	0	0	\N
268067	1678	12240386654000	11303	5805	0	0	\N
268068	1874	203306000	11303	5805	1	0	\N
268073	1874	203308000	11306	5807	0	0	\N
268080	1678	12240386657000	11310	5809	0	0	\N
268081	1678	12240386658000	11310	5809	1	0	\N
268082	1874	203310000	11310	5809	2	0	\N
268083	1678	12240386659000	11311	5810	0	0	\N
268084	1874	203311000	11311	5810	1	0	\N
268085	1678	12240386659000	11312	5810	0	0	\N
268086	1874	203311000	11312	5810	1	0	\N
268091	1678	12240386660000	11315	5811	0	0	\N
268092	1874	203312000	11315	5811	1	0	\N
268093	1874	203312000	11316	5811	0	0	\N
268094	1678	12240386661000	11318	5812	0	0	\N
268095	1874	203313000	11318	5812	1	0	\N
268100	1678	12240386662000	11321	5813	0	0	\N
268101	1874	203314000	11321	5813	1	0	\N
268103	1678	12240386663000	11323	5814	0	0	\N
268104	1678	12240386664000	11324	5815	0	0	\N
268105	1874	203315000	11324	5815	1	0	\N
268108	1678	12240386665000	11326	5816	0	0	\N
268109	1874	203316000	11326	5816	1	0	\N
268116	1678	12240386668000	11330	5819	0	0	\N
268117	1874	203319000	11330	5819	1	0	\N
268128	1678	12240386673000	11334	5822	0	0	\N
268129	1874	203324000	11334	5822	1	0	\N
268130	1678	12240386673000	11335	5822	0	0	\N
268131	1874	203324000	11335	5822	1	0	\N
268134	1678	12240386674000	11337	5823	0	0	\N
268135	1678	12240386675000	11337	5823	1	0	\N
268136	1874	203325000	11337	5823	2	0	\N
268137	1874	203326000	11337	5823	3	0	\N
268138	1678	12240386674000	11338	5823	0	0	\N
268139	1678	12240386675000	11338	5823	1	0	\N
268140	1874	203325000	11338	5823	2	0	\N
268141	1874	203326000	11338	5823	3	0	\N
268152	1678	12240386679000	11343	5826	0	0	\N
268153	1678	12240386680000	11343	5826	1	0	\N
268154	1678	12240386681000	11343	5826	2	0	\N
268155	1874	203330000	11343	5826	3	0	\N
268156	1874	203331000	11343	5826	4	0	\N
268157	1874	203332000	11343	5826	5	0	\N
268164	1678	12240386679000	11345	5826	0	0	\N
268165	1678	12240386680000	11345	5826	1	0	\N
268166	1678	12240386681000	11345	5826	2	0	\N
268167	1874	203330000	11345	5826	3	0	\N
268168	1874	203331000	11345	5826	4	0	\N
268169	1874	203332000	11345	5826	5	0	\N
268172	1678	12240386683000	11347	5828	0	0	\N
268173	1678	12240386684000	11347	5828	1	0	\N
268174	1874	203334000	11347	5828	2	0	\N
268175	1874	203335000	11347	5828	3	0	\N
268180	1678	12240386685000	11349	5829	0	0	\N
268181	1874	203336000	11349	5829	1	0	\N
268182	1678	12240386685000	11350	5829	0	0	\N
268183	1874	203336000	11350	5829	1	0	\N
268187	1874	203337000	11353	5830	0	0	\N
268190	1678	12240386687000	11355	5832	0	0	\N
268191	1874	203339000	11355	5832	1	0	\N
268066	1678	12240386653000	11302	5804	0	0	0
268069	1678	12240386654000	11304	5805	0	0	0
268070	1874	203306000	11304	5805	1	0	0
268071	1678	12240386655000	11305	5806	0	0	0
268072	1874	203307000	11305	5806	1	0	0
268075	1874	203308000	11307	5807	1	0	0
268076	1874	203309000	11308	5808	0	0	0
268077	1678	12240386657000	11309	5809	0	0	0
268078	1678	12240386658000	11309	5809	1	0	0
268079	1874	203310000	11309	5809	2	0	0
268088	1874	203311000	11313	5810	1	0	0
268089	1678	12240386660000	11314	5811	0	0	0
268090	1874	203312000	11314	5811	1	0	0
268096	1678	12240386661000	11319	5812	0	0	0
268098	1678	12240386662000	11320	5813	0	0	0
268099	1874	203314000	11320	5813	1	0	0
268102	1678	12240386663000	11322	5814	0	0	0
268106	1678	12240386664000	11325	5815	0	0	0
268107	1874	203315000	11325	5815	1	0	0
268111	1678	12240386665000	11328	5817	0	0	0
268112	1678	12240386666000	11328	5817	1	0	0
268113	1874	203317000	11328	5817	2	0	0
268114	1678	12240386667000	11329	5818	0	0	0
268115	1874	203318000	11329	5818	1	0	0
268119	1874	203319000	11331	5819	1	0	0
268120	1678	12240386669000	11332	5820	0	0	0
268121	1678	12240386670000	11332	5820	1	0	0
268122	1874	203320000	11332	5820	3	0	0
268124	1678	12240386671000	11333	5821	0	0	0
268125	1678	12240386672000	11333	5821	1	0	0
268126	1874	203322000	11333	5821	2	0	0
268127	1874	203323000	11333	5821	3	0	0
268132	1678	12240386673000	11336	5822	0	0	0
268142	1678	12240386674000	11339	5823	0	0	0
268143	1678	12240386675000	11339	5823	1	0	0
268144	1874	203325000	11339	5823	2	0	0
268145	1874	203326000	11339	5823	3	0	0
268146	1678	12240386676000	11340	5824	0	0	0
268148	1678	12240386677000	11342	5825	0	0	0
268149	1678	12240386678000	11342	5825	1	0	0
268150	1874	203328000	11342	5825	2	0	0
268151	1874	203329000	11342	5825	3	0	0
268159	1678	12240386680000	11344	5826	1	0	0
268160	1678	12240386681000	11344	5826	2	0	0
268161	1874	203330000	11344	5826	3	0	0
268162	1874	203331000	11344	5826	4	0	0
268163	1874	203332000	11344	5826	5	0	0
268171	1874	203333000	11346	5827	1	0	0
268176	1678	12240386683000	11348	5828	0	0	0
268177	1678	12240386684000	11348	5828	1	0	0
268178	1874	203334000	11348	5828	2	0	0
268179	1874	203335000	11348	5828	3	0	0
268185	1874	203336000	11351	5829	1	0	0
268186	1874	203337000	11352	5830	0	0	0
268188	1678	12240386686000	11354	5831	0	0	0
268189	1874	203338000	11354	5831	1	0	0
268194	1678	12240386688000	11357	5833	0	0	\N
268196	1678	12240386688000	11359	5833	0	0	\N
268197	1678	12240386689000	11360	5834	0	0	\N
268198	1678	12240386690000	11360	5834	1	0	\N
268199	1678	12240386691000	11360	5834	2	0	\N
268200	1678	12240386692000	11360	5834	3	0	\N
268201	1678	12240386693000	11360	5834	4	0	\N
268202	1874	203340000	11360	5834	5	0	\N
268203	1874	203341000	11360	5834	6	0	\N
268204	1874	203342000	11360	5834	7	0	\N
268205	1874	203343000	11360	5834	8	0	\N
268206	1874	203344000	11360	5834	9	0	\N
268221	1678	12240386696000	11364	5837	0	0	\N
268222	1678	12240386697000	11364	5837	1	0	\N
268223	1874	203347000	11364	5837	2	0	\N
268224	1874	203348000	11364	5837	3	0	\N
268231	1678	12240386698000	11367	5838	0	0	\N
268232	1874	203349000	11367	5838	1	0	\N
268233	1678	12240386699000	11368	5839	0	0	\N
268234	1678	12240386700000	11368	5839	1	0	\N
268235	1678	12240386701000	11368	5839	2	0	\N
268236	1874	203350000	11368	5839	3	0	\N
268237	1874	203351000	11368	5839	4	0	\N
268238	1874	203352000	11368	5839	5	0	\N
268247	1678	12240386702000	11371	5840	0	0	\N
268248	1874	203353000	11371	5840	1	0	\N
268257	1678	12240386707000	11375	5844	0	0	\N
268258	1874	203358000	11375	5844	1	0	\N
268261	1678	12240386708000	11377	5845	0	0	\N
268262	1678	12240386709000	11377	5845	1	0	\N
268263	1874	203359000	11377	5845	2	0	\N
268264	1874	203360000	11377	5845	3	0	\N
268269	1678	12240386708000	11379	5845	0	0	\N
268270	1678	12240386709000	11379	5845	1	0	\N
268271	1874	203359000	11379	5845	2	0	\N
268272	1874	203360000	11379	5845	3	0	\N
268275	1678	12240386711000	11381	5847	0	0	\N
268276	1874	203362000	11381	5847	1	0	\N
268277	1678	12240386711000	11382	5847	0	0	\N
268278	1874	203362000	11382	5847	1	0	\N
268281	1678	12240386712000	11384	5848	0	0	\N
268282	1874	203363000	11384	5848	1	0	\N
268283	1678	12240386712000	11385	5848	0	0	\N
268284	1874	203363000	11385	5848	1	0	\N
268287	1874	203364000	11387	5849	0	0	\N
268293	1678	12240386713000	11390	5850	0	0	\N
268294	1678	12240386714000	11390	5850	2	0	\N
268295	1874	203365000	11390	5850	3	0	\N
268296	1874	203366000	11390	5850	4	0	\N
268297	1678	12240386713000	11391	5850	0	0	\N
268298	1678	12240386714000	11391	5850	2	0	\N
268299	1874	203365000	11391	5850	3	0	\N
268300	1874	203366000	11391	5850	4	0	\N
268303	1678	12240386715000	11393	5851	0	0	\N
268304	1874	203367000	11393	5851	1	0	\N
268305	1678	12240386715000	11394	5851	0	0	\N
268306	1874	203367000	11394	5851	1	0	\N
268309	1678	12240386716000	11396	5852	0	0	\N
268310	1874	203368000	11396	5852	1	0	\N
268311	1678	12240386716000	11397	5852	0	0	\N
268312	1874	203368000	11397	5852	1	0	\N
268320	1678	12240386719000	11401	5855	0	0	\N
268321	1678	12240386720000	11401	5855	1	0	\N
268322	1874	203370000	11401	5855	2	0	\N
268323	1874	203371000	11401	5855	3	0	\N
268328	1678	12240386722000	11404	5857	0	0	\N
268207	1678	12240386689000	11361	5834	0	0	0
268208	1678	12240386690000	11361	5834	1	0	0
268209	1678	12240386691000	11361	5834	2	0	0
268210	1678	12240386692000	11361	5834	3	0	0
268211	1678	12240386693000	11361	5834	4	0	0
268213	1874	203341000	11361	5834	6	0	0
268214	1874	203342000	11361	5834	7	0	0
268215	1874	203343000	11361	5834	8	0	0
268216	1874	203344000	11361	5834	9	0	0
268217	1678	12240386694000	11362	5835	0	0	0
268219	1678	12240386695000	11363	5836	0	0	0
268220	1874	203346000	11363	5836	1	0	0
268225	1678	12240386696000	11365	5837	0	0	0
268226	1678	12240386697000	11365	5837	1	0	0
268228	1874	203348000	11365	5837	3	0	0
268229	1678	12240386698000	11366	5838	0	0	0
268230	1874	203349000	11366	5838	1	0	0
268239	1678	12240386699000	11369	5839	0	0	0
268240	1678	12240386700000	11369	5839	1	0	0
268242	1874	203350000	11369	5839	3	0	0
268243	1874	203351000	11369	5839	4	0	0
268244	1874	203352000	11369	5839	5	0	0
268245	1678	12240386702000	11370	5840	0	0	0
268246	1874	203353000	11370	5840	1	0	0
268250	1874	203354000	11372	5841	1	0	0
268251	1678	12240386704000	11373	5842	0	0	0
268252	1678	12240386705000	11373	5842	1	0	0
268253	1874	203355000	11373	5842	2	0	0
268255	1678	12240386706000	11374	5843	0	0	0
268256	1874	203357000	11374	5843	1	0	0
268259	1678	12240386707000	11376	5844	0	0	0
268260	1874	203358000	11376	5844	1	0	0
268265	1678	12240386708000	11378	5845	0	0	0
268267	1874	203359000	11378	5845	2	0	0
268268	1874	203360000	11378	5845	3	0	0
268273	1678	12240386710000	11380	5846	0	0	0
268274	1874	203361000	11380	5846	1	0	0
268279	1678	12240386711000	11383	5847	0	0	0
268285	1678	12240386712000	11386	5848	0	0	0
268286	1874	203363000	11386	5848	1	0	0
268288	1874	203364000	11388	5849	0	0	0
268289	1678	12240386713000	11389	5850	0	0	0
268291	1874	203365000	11389	5850	3	0	0
268292	1874	203366000	11389	5850	4	0	0
268301	1678	12240386715000	11392	5851	0	0	0
268302	1874	203367000	11392	5851	1	0	0
268307	1678	12240386716000	11395	5852	0	0	0
268313	1678	12240386717000	11398	5853	0	0	0
268314	1678	12240386718000	11399	5854	0	0	0
268315	1874	203369000	11399	5854	1	0	0
268316	1678	12240386719000	11400	5855	0	0	0
268317	1678	12240386720000	11400	5855	1	0	0
268319	1874	203371000	11400	5855	3	0	0
268324	1678	12240386721000	11402	5856	0	0	0
268325	1874	203372000	11402	5856	1	0	0
268326	1678	12240386722000	11403	5857	0	0	0
268329	1874	203373000	11404	5857	1	0	\N
268334	1678	12240386723000	11406	5858	0	0	\N
268335	1678	12240386724000	11406	5858	1	0	\N
268336	1874	203374000	11406	5858	2	0	\N
268337	1874	203375000	11406	5858	3	0	\N
268346	1678	12240386729000	11409	5861	0	0	\N
268347	1874	203380000	11409	5861	1	0	\N
268348	2048	200000000	11409	5861	2	0	\N
268352	1678	12240386729000	11411	5861	0	0	\N
268353	1874	203380000	11411	5861	1	0	\N
268354	2048	200000000	11411	5861	2	0	\N
268357	1874	203382000	11413	5863	0	0	\N
268358	1874	203382000	11414	5863	0	0	\N
268362	1678	12240386732000	11417	5865	0	0	\N
268363	1874	203384000	11417	5865	1	0	\N
268364	1678	12240386732000	11418	5865	0	0	\N
268365	1874	203384000	11418	5865	1	0	\N
268374	1678	12240386734000	11422	5867	0	0	\N
268375	1678	12240386735000	11422	5867	1	0	\N
268376	1874	203386000	11422	5867	2	0	\N
268377	1874	203387000	11422	5867	3	0	\N
268382	1678	12240386737000	11425	5869	0	0	\N
268383	1874	203389000	11425	5869	1	0	\N
268384	622	66417804089930	11426	5792	0	0	\N
268385	105	66414824089930	11426	5792	1	0	\N
268386	1678	12240386639000	11426	5792	2	0	\N
268387	1349	1698698829951650	11426	5792	3	0	\N
268388	1678	12240386640000	11426	5792	4	0	\N
268389	1678	12240386641000	11426	5792	5	0	\N
268390	1223	612622942200000	11426	5792	6	0	\N
268391	1678	12240386642000	11426	5792	7	0	\N
268392	1678	12240386643000	11426	5792	8	0	\N
268393	1678	12240386644000	11426	5792	9	0	\N
268394	1678	12240386645000	11426	5792	10	0	\N
268395	1678	12240386646000	11426	5792	11	0	\N
268396	1678	12240386647000	11426	5792	12	0	\N
268397	1678	12240386648000	11426	5792	13	0	\N
268398	1678	12240386649000	11426	5792	14	0	\N
268399	1678	12240386650000	11426	5792	15	0	\N
268400	1678	12240386651000	11426	5792	16	0	\N
268401	1103	903850752500000	11426	5792	17	0	\N
268402	983	505655062500000	11426	5792	19	0	\N
268403	1678	12240386652000	11426	5792	20	0	\N
268404	1678	12240386653000	11426	5792	21	0	\N
268405	1678	12240386654000	11426	5792	22	0	\N
268406	1678	12240386655000	11426	5792	23	0	\N
268407	1678	12240386656000	11426	5792	24	0	\N
268408	1678	12240386657000	11426	5792	25	0	\N
268409	1678	12240386658000	11426	5792	26	0	\N
268410	1678	12240386659000	11426	5792	27	0	\N
268411	1678	12240386660000	11426	5792	28	0	\N
268412	1678	12240386661000	11426	5792	29	0	\N
268413	1678	12240386662000	11426	5792	30	0	\N
268414	1678	12240386663000	11426	5792	31	0	\N
268415	1678	12240386664000	11426	5792	32	0	\N
268416	1678	12240386665000	11426	5792	33	0	\N
268417	1678	12240386666000	11426	5792	34	0	\N
268418	1678	12240386667000	11426	5792	35	0	\N
268419	1678	12240386668000	11426	5792	36	0	\N
268420	1678	12240386669000	11426	5792	37	0	\N
268421	1678	12240386670000	11426	5792	38	0	\N
268422	1678	12240386671000	11426	5792	39	0	\N
268423	1678	12240386672000	11426	5792	40	0	\N
268424	1678	12240386673000	11426	5792	41	0	\N
268425	1678	12240386674000	11426	5792	42	0	\N
268426	1678	12240386675000	11426	5792	43	0	\N
268427	1678	12240386676000	11426	5792	44	0	\N
268428	1678	12240386677000	11426	5792	45	0	\N
268429	1678	12240386678000	11426	5792	46	0	\N
268430	1678	12240386679000	11426	5792	47	0	\N
268431	1678	12240386680000	11426	5792	48	0	\N
268432	1678	12240386681000	11426	5792	49	0	\N
268433	1678	12240386682000	11426	5792	50	0	\N
268434	1678	12240386683000	11426	5792	51	0	\N
268435	1678	12240386684000	11426	5792	52	0	\N
268436	1678	12240386685000	11426	5792	53	0	\N
268437	1678	12240386686000	11426	5792	54	0	\N
268438	1678	12240386687000	11426	5792	55	0	\N
268439	1678	12240386688000	11426	5792	56	0	\N
268440	1678	12240386689000	11426	5792	57	0	\N
268441	1678	12240386690000	11426	5792	58	0	\N
268442	1678	12240386691000	11426	5792	59	0	\N
268443	1678	12240386692000	11426	5792	60	0	\N
268444	1678	12240386693000	11426	5792	61	0	\N
268445	1678	12240386694000	11426	5792	62	0	\N
268446	1678	12240386695000	11426	5792	63	0	\N
268447	1678	12240386696000	11426	5792	64	0	\N
268448	1678	12240386697000	11426	5792	65	0	\N
268449	1678	12240386698000	11426	5792	66	0	\N
268450	1678	12240386699000	11426	5792	67	0	\N
268451	1678	12240386700000	11426	5792	68	0	\N
268452	1678	12240386701000	11426	5792	69	0	\N
268453	1678	12240386702000	11426	5792	70	0	\N
268454	1678	12240386703000	11426	5792	71	0	\N
268455	1678	12240386704000	11426	5792	72	0	\N
268456	1678	12240386705000	11426	5792	73	0	\N
268457	1678	12240386706000	11426	5792	74	0	\N
268458	1678	12240386707000	11426	5792	75	0	\N
268459	1678	12240386708000	11426	5792	76	0	\N
268460	1678	12240386709000	11426	5792	77	0	\N
268461	1678	12240386710000	11426	5792	78	0	\N
268462	1678	12240386711000	11426	5792	79	0	\N
268463	1678	12240386712000	11426	5792	80	0	\N
268464	1678	12240386713000	11426	5792	81	0	\N
268332	1874	203374000	11405	5858	2	0	0
268333	1874	203375000	11405	5858	3	0	0
268338	1678	12240386725000	11407	5859	0	0	0
268339	1678	12240386726000	11407	5859	1	0	0
268340	1874	203376000	11407	5859	2	0	0
268342	1678	12240386727000	11408	5860	0	0	0
268343	1678	12240386728000	11408	5860	1	0	0
268344	1874	203378000	11408	5860	2	0	0
268345	1874	203379000	11408	5860	3	0	0
268349	1678	12240386729000	11410	5861	0	0	0
268351	2048	200000000	11410	5861	2	0	0
268355	1678	12240386730000	11412	5862	0	0	0
268356	1874	203381000	11412	5862	1	0	0
268359	1874	203382000	11415	5863	0	0	0
268361	1874	203383000	11416	5864	1	0	0
268366	1678	12240386732000	11419	5865	0	0	0
268367	1874	203384000	11419	5865	1	0	0
268368	1678	12240386733000	11420	5866	0	0	0
268369	1874	203385000	11420	5866	1	0	0
268371	1678	12240386735000	11421	5867	1	0	0
268372	1874	203386000	11421	5867	2	0	0
268373	1874	203387000	11421	5867	3	0	0
268378	1678	12240386736000	11423	5868	0	0	0
268379	1874	203388000	11423	5868	1	0	0
268381	1874	203389000	11424	5869	1	0	0
268465	1678	12240386714000	11426	5792	82	0	\N
268466	1678	12240386715000	11426	5792	83	0	\N
268467	1678	12240386716000	11426	5792	84	0	\N
268468	1678	12240386717000	11426	5792	85	0	\N
268469	1678	12240386718000	11426	5792	86	0	\N
268470	1678	12240386719000	11426	5792	87	0	\N
268471	1678	12240386720000	11426	5792	88	0	\N
268472	1678	12240386721000	11426	5792	89	0	\N
268473	1678	12240386722000	11426	5792	90	0	\N
268474	1678	12240386723000	11426	5792	91	0	\N
268475	1678	12240386724000	11426	5792	92	0	\N
268476	1678	12240386725000	11426	5792	93	0	\N
268477	1678	12240386726000	11426	5792	94	0	\N
268478	1678	12240386727000	11426	5792	95	0	\N
268479	1678	12240386728000	11426	5792	96	0	\N
268480	1678	12240386729000	11426	5792	97	0	\N
268481	1678	12240386730000	11426	5792	98	0	\N
268482	1678	12240386731000	11426	5792	99	0	\N
268483	1678	12240386732000	11426	5792	100	0	\N
268484	1678	12240386733000	11426	5792	101	0	\N
268485	1678	12240386734000	11426	5792	102	0	\N
268486	1678	12240386735000	11426	5792	103	0	\N
268487	1678	12240386736000	11426	5792	104	0	\N
268488	1678	12240386737000	11426	5792	105	0	\N
268489	1874	203291000	11426	5792	106	0	\N
268490	1874	203292000	11426	5792	108	0	\N
268491	1874	203293000	11426	5792	109	0	\N
268492	1874	203294000	11426	5792	110	0	\N
268493	1874	203295000	11426	5792	111	0	\N
268494	1874	203296000	11426	5792	112	0	\N
268495	1874	203297000	11426	5792	113	0	\N
268496	1874	203298000	11426	5792	114	0	\N
268497	1874	203299000	11426	5792	115	0	\N
268498	1874	203300000	11426	5792	116	0	\N
268499	1874	203301000	11426	5792	117	0	\N
268500	1874	203302000	11426	5792	118	0	\N
268501	1874	203303000	11426	5792	119	0	\N
268502	1874	203304000	11426	5792	120	0	\N
268503	1874	203305000	11426	5792	121	0	\N
268504	1874	203306000	11426	5792	122	0	\N
268505	1874	203307000	11426	5792	123	0	\N
268506	1874	203308000	11426	5792	124	0	\N
268507	1874	203309000	11426	5792	125	0	\N
268508	1678	12240386738000	11428	5870	0	0	\N
268509	1678	12240386739000	11428	5870	1	0	\N
268510	1678	12240386740000	11428	5870	2	0	\N
268511	1874	203390000	11428	5870	3	0	\N
268512	1874	203391000	11428	5870	4	0	\N
268524	1678	12240386744000	11432	5873	0	0	\N
268525	1874	203395000	11432	5873	1	0	\N
268526	1678	12240386744000	11433	5873	0	0	\N
268527	1874	203395000	11433	5873	1	0	\N
268528	1678	12240386744000	11434	5873	0	0	\N
268529	1874	203395000	11434	5873	1	0	\N
268537	1678	12240386746000	11439	5876	0	0	\N
268538	1874	203398000	11439	5876	1	0	\N
268543	1678	12240386686000	11441	5831	0	0	\N
268544	1678	12240386687000	11441	5831	1	0	\N
268545	1678	12240386688000	11441	5831	2	0	\N
268546	1678	12240386689000	11441	5831	3	0	\N
268547	1678	12240386690000	11441	5831	4	0	\N
268548	1678	12240386691000	11441	5831	5	0	\N
268549	1678	12240386692000	11441	5831	6	0	\N
268550	1678	12240386693000	11441	5831	7	0	\N
268551	1678	12240386694000	11441	5831	8	0	\N
268552	1678	12240386695000	11441	5831	9	0	\N
268553	1678	12240386696000	11441	5831	10	0	\N
268554	1678	12240386697000	11441	5831	11	0	\N
268555	1678	12240386698000	11441	5831	12	0	\N
268556	1678	12240386699000	11441	5831	13	0	\N
268557	1678	12240386700000	11441	5831	14	0	\N
268558	1678	12240386701000	11441	5831	15	0	\N
268559	1678	12240386702000	11441	5831	16	0	\N
268560	1678	12240386703000	11441	5831	17	0	\N
268561	1678	12240386704000	11441	5831	18	0	\N
268562	1678	12240386705000	11441	5831	19	0	\N
268563	1678	12240386706000	11441	5831	20	0	\N
268564	1678	12240386707000	11441	5831	21	0	\N
268565	1678	12240386708000	11441	5831	22	0	\N
268566	1678	12240386709000	11441	5831	23	0	\N
268567	1678	12240386710000	11441	5831	24	0	\N
268568	1678	12240386711000	11441	5831	25	0	\N
268569	1678	12240386712000	11441	5831	26	0	\N
268570	1678	12240386713000	11441	5831	27	0	\N
268571	1678	12240386714000	11441	5831	28	0	\N
268572	1678	12240386715000	11441	5831	29	0	\N
268573	1678	12240386716000	11441	5831	30	0	\N
268574	1678	12240386717000	11441	5831	31	0	\N
268575	1678	12240386718000	11441	5831	32	0	\N
268576	1678	12240386719000	11441	5831	33	0	\N
268577	1678	12240386720000	11441	5831	34	0	\N
268578	1678	12240386721000	11441	5831	35	0	\N
268579	1678	12240386722000	11441	5831	36	0	\N
268580	1678	12240386723000	11441	5831	37	0	\N
268581	1678	12240386724000	11441	5831	38	0	\N
268582	1678	12240386725000	11441	5831	39	0	\N
268583	1678	12240386726000	11441	5831	40	0	\N
268584	1678	12240386727000	11441	5831	41	0	\N
268585	1678	12240386728000	11441	5831	42	0	\N
268586	1678	12240386729000	11441	5831	43	0	\N
268587	1678	12240386730000	11441	5831	44	0	\N
268588	1678	12240386731000	11441	5831	45	0	\N
268589	1678	12240386732000	11441	5831	46	0	\N
268590	1678	12240386733000	11441	5831	47	0	\N
268591	1678	12240386734000	11441	5831	48	0	\N
268592	1678	12240386735000	11441	5831	49	0	\N
268593	1678	12240386736000	11441	5831	50	0	\N
268594	1678	12240386737000	11441	5831	51	0	\N
268595	1678	12240386738000	11441	5831	52	0	\N
268596	1678	12240386739000	11441	5831	53	0	\N
268597	1678	12240386740000	11441	5831	54	0	\N
268598	1678	12240386741000	11441	5831	55	0	\N
268599	1678	12240386742000	11441	5831	56	0	\N
268600	1678	12240386743000	11441	5831	57	0	\N
268515	1678	12240386740000	11429	5870	2	0	0
268516	1874	203390000	11429	5870	3	0	0
268517	1874	203391000	11429	5870	4	0	0
268518	1678	12240386741000	11430	5871	0	0	0
268519	1874	203392000	11430	5871	1	0	0
268521	1678	12240386743000	11431	5872	1	0	0
268522	1874	203393000	11431	5872	2	0	0
268523	1874	203394000	11431	5872	3	0	0
268530	1678	12240386744000	11435	5873	0	0	0
268531	1874	203395000	11435	5873	1	0	0
268533	1678	12240386745000	11437	5875	0	0	0
268534	1874	203397000	11437	5875	1	0	0
268535	1678	12240386746000	11438	5876	0	0	0
268536	1874	203398000	11438	5876	1	0	0
268540	1678	12240386748000	11440	5877	1	0	0
268541	1874	203399000	11440	5877	2	0	0
268542	1874	203400000	11440	5877	3	0	0
268601	1678	12240386744000	11441	5831	58	0	\N
268602	1678	12240386745000	11441	5831	59	0	\N
268603	1678	12240386746000	11441	5831	60	0	\N
268604	1678	12240386747000	11441	5831	61	0	\N
268605	1678	12240386748000	11441	5831	62	0	\N
268606	1678	12240386749000	11441	5831	63	0	\N
268607	1678	12240386750000	11441	5831	64	0	\N
268608	1874	203338000	11441	5831	65	0	\N
268609	1874	203339000	11441	5831	66	0	\N
268610	1874	203340000	11441	5831	67	0	\N
268611	1874	203341000	11441	5831	68	0	\N
268612	1874	203342000	11441	5831	69	0	\N
268613	1874	203343000	11441	5831	70	0	\N
268614	1874	203344000	11441	5831	71	0	\N
268615	1874	203345000	11441	5831	72	0	\N
268616	1874	203346000	11441	5831	73	0	\N
268617	1874	203347000	11441	5831	74	0	\N
268618	1874	203348000	11441	5831	75	0	\N
268619	1874	203349000	11441	5831	76	0	\N
268620	1874	203350000	11441	5831	77	0	\N
268621	1874	203351000	11441	5831	78	0	\N
268622	1874	203352000	11441	5831	79	0	\N
268623	1874	203353000	11441	5831	80	0	\N
268624	1874	203354000	11441	5831	81	0	\N
268625	1874	203355000	11441	5831	82	0	\N
268626	1874	203356000	11441	5831	83	0	\N
268627	1874	203357000	11441	5831	84	0	\N
268628	1874	203358000	11441	5831	85	0	\N
268629	1874	203359000	11441	5831	86	0	\N
268630	1874	203360000	11441	5831	87	0	\N
268631	1874	203361000	11441	5831	88	0	\N
268632	1874	203362000	11441	5831	89	0	\N
268633	1874	203363000	11441	5831	90	0	\N
268634	1874	203364000	11441	5831	91	0	\N
268635	1874	203365000	11441	5831	92	0	\N
268636	1874	203366000	11441	5831	94	0	\N
268637	1874	203367000	11441	5831	95	0	\N
268638	1874	203368000	11441	5831	96	0	\N
268639	1874	203369000	11441	5831	97	0	\N
268640	1874	203370000	11441	5831	98	0	\N
268641	1874	203371000	11441	5831	99	0	\N
268642	1874	203372000	11441	5831	100	0	\N
268643	1874	203373000	11441	5831	101	0	\N
268644	1874	203374000	11441	5831	102	0	\N
268645	1874	203375000	11441	5831	103	0	\N
268646	1874	203376000	11441	5831	104	0	\N
268647	1874	203377000	11441	5831	105	0	\N
268648	1874	203378000	11441	5831	106	0	\N
268649	1874	203379000	11441	5831	107	0	\N
268650	1874	203380000	11441	5831	108	0	\N
268651	2048	200000000	11441	5831	109	0	\N
268652	1874	203381000	11441	5831	110	0	\N
268653	1874	203382000	11441	5831	111	0	\N
268654	1874	203383000	11441	5831	112	0	\N
268655	1874	203384000	11441	5831	113	0	\N
268656	1874	203385000	11441	5831	114	0	\N
268657	1874	203386000	11441	5831	115	0	\N
268658	1874	203387000	11441	5831	116	0	\N
268659	1874	203388000	11441	5831	117	0	\N
268660	1874	203389000	11441	5831	118	0	\N
268661	1874	203390000	11441	5831	119	0	\N
268662	1874	203391000	11441	5831	120	0	\N
268663	1874	203392000	11441	5831	121	0	\N
268664	1874	203393000	11441	5831	122	0	\N
268665	1874	203394000	11441	5831	123	0	\N
268666	1874	203395000	11441	5831	124	0	\N
268667	1874	203396000	11441	5831	125	0	\N
268672	1678	12240386749000	11443	5878	0	0	\N
268673	1678	12240386750000	11443	5878	1	0	\N
268674	1874	203401000	11443	5878	2	0	\N
268675	1874	203402000	11443	5878	3	0	\N
268682	1678	12240386754000	11445	5880	0	0	\N
268684	1678	12240386754000	11447	5880	0	0	\N
268685	1678	12240386754000	11448	5880	0	0	\N
268686	1678	12240386754000	11449	5880	0	0	\N
268703	122	66414824089930	11456	5777	0	0	\N
268704	721	2012570426909	11456	5777	1	0	\N
268705	1349	1698698829951650	11456	5777	2	0	\N
268706	1223	612622942200000	11456	5777	3	0	\N
268707	217	66414824089930	11456	5777	4	0	\N
268708	103	66414824089930	11456	5777	5	0	\N
268709	1811	1131150178317	11456	5777	6	0	\N
268710	1103	903850752500000	11456	5777	7	0	\N
268711	983	505655062500000	11456	5777	8	0	\N
268712	499	66414824089930	11456	5777	9	0	\N
268713	1772	2965629091692	11456	5777	10	0	\N
268714	54	66414824089930	11456	5777	11	0	\N
268715	710	5031426067384	11456	5777	12	0	\N
268716	320	66133624089930	11456	5777	13	0	\N
268717	1030	906636022402500	11456	5777	14	0	\N
268718	663	66414824089930	11456	5777	15	0	\N
268719	35	19320676098855	11456	5777	16	0	\N
268720	49	66414824089930	11456	5777	17	0	\N
268721	251	66414824089930	11456	5777	18	0	\N
268722	99	66414824089930	11456	5777	19	0	\N
268723	570	66414824089930	11456	5777	20	0	\N
268724	893	308751364127976	11456	5777	21	0	\N
268725	390	66414824089930	11456	5777	22	0	\N
268726	108	66414824089930	11456	5777	23	0	\N
268727	894	308751364127976	11456	5777	24	0	\N
268728	569	66414824089930	11456	5777	25	0	\N
268729	252	66414824089930	11456	5777	26	0	\N
268730	225	66414824089930	11456	5777	27	0	\N
268731	377	66414824089930	11456	5777	28	0	\N
268732	82	66414824089930	11456	5777	29	0	\N
268733	361	66414824089930	11456	5777	30	0	\N
268734	560	66414824089930	11456	5777	31	0	\N
268735	309	66414824089930	11456	5777	32	0	\N
268736	1962	413736265157	11456	5777	33	0	\N
268670	1874	203401000	11442	5878	2	0	0
268671	1874	203402000	11442	5878	3	0	0
268676	1678	12240386751000	11444	5879	0	0	0
268677	1678	12240386752000	11444	5879	1	0	0
268678	1678	12240386753000	11444	5879	2	0	0
268680	1874	203404000	11444	5879	4	0	0
268681	1874	203405000	11444	5879	5	0	0
268683	1678	12240386754000	11446	5880	0	0	0
268687	1874	203406000	11450	5881	0	0	0
268688	1678	12240386755000	11451	5882	0	0	0
268690	1874	203407000	11451	5882	2	0	0
268691	1874	203408000	11451	5882	3	0	0
268692	1678	12240386757000	11452	5883	0	0	0
268693	1678	12240386758000	11452	5883	1	0	0
268695	1874	203410000	11452	5883	3	0	0
268696	1678	12240386759000	11453	5884	0	0	0
268697	1874	203411000	11453	5884	1	0	0
268698	2050	200000000	11454	5885	0	0	0
268699	1678	12240386760000	11454	5885	1	0	0
268701	1678	12240386761000	11455	5886	0	0	0
268702	1874	203413000	11455	5886	1	0	0
268737	201	66414824089930	11456	5777	34	0	\N
268738	402	66414824089930	11456	5777	35	0	\N
268739	275	66414824089930	11456	5777	36	0	\N
268740	163	66414824089930	11456	5777	37	0	\N
268741	397	66414824089930	11456	5777	38	0	\N
268742	391	66414824089930	11456	5777	39	0	\N
268743	452	66414824089930	11456	5777	40	0	\N
268744	106	66414824089930	11456	5777	41	0	\N
268745	594	66414824089930	11456	5777	42	0	\N
268746	680	66414824089930	11456	5777	43	0	\N
268747	690	66414824089930	11456	5777	44	0	\N
268748	731	2012570426909	11456	5777	45	0	\N
268749	180	66414824089930	11456	5777	46	0	\N
268750	112	66071793089930	11456	5777	47	0	\N
268751	353	66414814089930	11456	5777	48	0	\N
268752	652	66414824089930	11456	5777	49	0	\N
268753	420	66414824089930	11456	5777	50	0	\N
268754	352	66414824089930	11456	5777	51	0	\N
268755	691	66414824089930	11456	5777	52	0	\N
268756	191	66414824089930	11456	5777	53	0	\N
268757	266	66414824089930	11456	5777	54	0	\N
268758	534	66414824089930	11456	5777	55	0	\N
268759	245	66414824089930	11456	5777	56	0	\N
268760	421	66414824089930	11456	5777	57	0	\N
268761	600	66414824089930	11456	5777	58	0	\N
268762	620	66414824089930	11456	5777	59	0	\N
268763	2017	413423424329	11456	5777	60	0	\N
268764	551	66414824089930	11456	5777	61	0	\N
268765	520	66414824089930	11456	5777	62	0	\N
268766	84	66414824089930	11456	5777	63	0	\N
268767	1150	611725390313900	11456	5777	64	0	\N
268770	1678	12240386763000	11458	5888	0	0	\N
268771	1874	203415000	11458	5888	1	0	\N
268774	1678	12240386763000	11460	5888	0	0	\N
268775	1874	203415000	11460	5888	1	0	\N
268786	1678	12240386769000	11466	5894	0	0	\N
268787	1874	203421000	11466	5894	1	0	\N
268790	1678	12240386770000	11468	5895	0	0	\N
268791	1874	203422000	11468	5895	1	0	\N
268792	971	505003883106880	11468	5895	2	0	\N
268793	1678	12240386770000	11469	5895	0	0	\N
268794	1874	203422000	11469	5895	1	0	\N
268795	971	505003883106880	11469	5895	2	0	\N
268808	58	70266275999659	11472	5896	1	0	\N
268809	1678	12240386771000	11472	5896	2	0	\N
268810	1678	12240386772000	11472	5896	3	0	\N
268811	1678	12240386773000	11472	5896	4	0	\N
268812	1678	12240386774000	11472	5896	5	0	\N
268813	1874	203423000	11472	5896	6	0	\N
268814	1874	203424000	11472	5896	7	0	\N
268815	1874	203425000	11472	5896	8	0	\N
268816	1874	203426000	11472	5896	9	0	\N
268819	1678	12240386776000	11474	5898	0	0	\N
268820	1874	203428000	11474	5898	1	0	\N
268821	1678	12240386776000	11475	5898	0	0	\N
268822	1874	203428000	11475	5898	1	0	\N
268827	1678	12240386778000	11478	5900	0	0	\N
268828	1678	12240386779000	11478	5900	1	0	\N
268829	1874	203430000	11478	5900	2	0	\N
268830	1874	203431000	11478	5900	3	0	\N
268835	1678	12240386780000	11480	5901	0	0	\N
268836	1874	203432000	11480	5901	1	0	\N
268839	1678	12240386780000	11482	5901	0	0	\N
268840	1874	203432000	11482	5901	1	0	\N
268843	1678	12240386781000	11484	5902	0	0	\N
268844	1874	203433000	11484	5902	1	0	\N
268845	1678	12240386782000	11485	5903	0	0	\N
268846	1678	12240386782000	11487	5903	0	0	\N
268848	1678	12240386782000	11489	5903	0	0	\N
268849	1678	12240386782000	11490	5903	0	0	\N
268850	1678	12240386782000	11491	5903	0	0	\N
268857	1678	12240386783000	11493	5904	1	0	\N
268858	1678	12240386784000	11493	5904	3	0	\N
268859	1678	12240386785000	11493	5904	4	0	\N
268860	1874	203434000	11493	5904	5	0	\N
268861	1874	203435000	11493	5904	6	0	\N
268862	1874	203436000	11493	5904	7	0	\N
268863	1678	12240386786000	11494	5905	0	0	\N
268864	1678	12240386787000	11494	5905	1	0	\N
268865	1704	4320195000000	11494	5905	2	0	\N
268866	1874	203437000	11494	5905	3	0	\N
268867	1874	203438000	11494	5905	4	0	\N
268772	1678	12240386763000	11459	5888	0	0	0
268773	1874	203415000	11459	5888	1	0	0
268776	1678	12240386764000	11461	5889	0	0	0
268777	1874	203416000	11461	5889	1	0	0
268778	1678	12240386765000	11462	5890	0	0	0
268780	1678	12240386766000	11463	5891	0	0	0
268781	1874	203418000	11463	5891	1	0	0
268782	1678	12240386767000	11464	5892	0	0	0
268783	1874	203419000	11464	5892	1	0	0
268784	1678	12240386768000	11465	5893	0	0	0
268788	1678	12240386769000	11467	5894	0	0	0
268789	1874	203421000	11467	5894	1	0	0
268796	1678	12240386770000	11470	5895	0	0	0
268797	1874	203422000	11470	5895	1	0	0
268799	58	70266275999659	11471	5896	1	0	6
268800	1678	12240386771000	11471	5896	2	0	0
268801	1678	12240386772000	11471	5896	3	0	0
268802	1678	12240386773000	11471	5896	4	0	0
268803	1678	12240386774000	11471	5896	5	0	0
268805	1874	203424000	11471	5896	7	0	0
268806	1874	203425000	11471	5896	8	0	0
268807	1874	203426000	11471	5896	9	0	0
268817	1678	12240386775000	11473	5897	1	0	0
268818	1874	203427000	11473	5897	2	0	0
268824	1874	203428000	11476	5898	1	0	0
268825	1678	12240386777000	11477	5899	0	0	0
268826	1874	203429000	11477	5899	1	0	0
268831	1678	12240386778000	11479	5900	0	0	0
268833	1874	203430000	11479	5900	2	0	0
268834	1874	203431000	11479	5900	3	0	0
268837	1678	12240386780000	11481	5901	0	0	0
268838	1874	203432000	11481	5901	1	0	0
268841	1678	12240386781000	11483	5902	0	0	0
268847	1678	12240386782000	11488	5903	0	0	0
268851	1678	12240386783000	11492	5904	1	0	0
268852	1678	12240386784000	11492	5904	3	0	0
268853	1678	12240386785000	11492	5904	4	0	0
268854	1874	203434000	11492	5904	5	0	0
268856	1874	203436000	11492	5904	7	0	0
268868	1678	12240386786000	11495	5905	0	0	0
268869	1678	12240386787000	11495	5905	1	0	0
268870	1704	4320195000000	11495	5905	2	0	0
268872	1874	203438000	11495	5905	4	0	0
268875	1678	12240386788000	11497	5906	0	0	\N
268876	1874	203439000	11497	5906	1	0	\N
268877	58	70266275999659	11498	5832	1	0	\N
268878	1678	12240386751000	11498	5832	3	0	\N
268879	1678	12240386752000	11498	5832	4	0	\N
268880	1678	12240386753000	11498	5832	5	0	\N
268881	1678	12240386754000	11498	5832	6	0	\N
268882	1678	12240386755000	11498	5832	7	0	\N
268883	1678	12240386756000	11498	5832	8	0	\N
268884	1678	12240386757000	11498	5832	9	0	\N
268885	1678	12240386758000	11498	5832	10	0	\N
268886	1678	12240386759000	11498	5832	11	0	\N
268887	1678	12240386760000	11498	5832	12	0	\N
268888	1678	12240386761000	11498	5832	13	0	\N
268889	1678	12240386762000	11498	5832	14	0	\N
268890	1678	12240386763000	11498	5832	15	0	\N
268891	1678	12240386764000	11498	5832	16	0	\N
268892	1678	12240386765000	11498	5832	17	0	\N
268893	1678	12240386766000	11498	5832	18	0	\N
268894	1678	12240386767000	11498	5832	19	0	\N
268895	1678	12240386768000	11498	5832	20	0	\N
268896	1678	12240386769000	11498	5832	21	0	\N
268897	1678	12240386770000	11498	5832	22	0	\N
268898	1678	12240386771000	11498	5832	23	0	\N
268899	1678	12240386772000	11498	5832	24	0	\N
268900	1678	12240386773000	11498	5832	25	0	\N
268901	1678	12240386774000	11498	5832	26	0	\N
268902	1678	12240386775000	11498	5832	27	0	\N
268903	1678	12240386776000	11498	5832	28	0	\N
268904	1678	12240386777000	11498	5832	29	0	\N
268905	1678	12240386778000	11498	5832	30	0	\N
268906	1678	12240386779000	11498	5832	31	0	\N
268907	1678	12240386780000	11498	5832	32	0	\N
268908	1678	12240386781000	11498	5832	33	0	\N
268909	1678	12240386782000	11498	5832	34	0	\N
268910	1678	12240386783000	11498	5832	35	0	\N
268911	1678	12240386784000	11498	5832	36	0	\N
268912	1678	12240386785000	11498	5832	37	0	\N
268913	1678	12240386786000	11498	5832	38	0	\N
268914	1678	12240386787000	11498	5832	39	0	\N
268915	1678	12240386788000	11498	5832	40	0	\N
268916	1704	4320195000000	11498	5832	41	0	\N
268917	971	505003883106880	11498	5832	42	0	\N
268918	1874	203397000	11498	5832	43	0	\N
268919	1874	203398000	11498	5832	44	0	\N
268920	1874	203399000	11498	5832	47	0	\N
268921	1874	203400000	11498	5832	48	0	\N
268922	1874	203401000	11498	5832	49	0	\N
268923	1874	203402000	11498	5832	50	0	\N
268924	1874	203403000	11498	5832	51	0	\N
268925	1874	203404000	11498	5832	52	0	\N
268926	1874	203405000	11498	5832	53	0	\N
268927	1874	203406000	11498	5832	54	0	\N
268928	1874	203407000	11498	5832	55	0	\N
268929	1874	203408000	11498	5832	56	0	\N
268930	1874	203409000	11498	5832	57	0	\N
268931	1874	203410000	11498	5832	58	0	\N
268932	1874	203411000	11498	5832	59	0	\N
268933	2050	200000000	11498	5832	60	0	\N
268934	1874	203412000	11498	5832	61	0	\N
268935	1874	203413000	11498	5832	62	0	\N
268936	1874	203414000	11498	5832	63	0	\N
268937	1874	203415000	11498	5832	64	0	\N
268938	1874	203416000	11498	5832	65	0	\N
268939	1874	203417000	11498	5832	66	0	\N
268940	1874	203418000	11498	5832	67	0	\N
268941	1874	203419000	11498	5832	68	0	\N
268942	1874	203420000	11498	5832	69	0	\N
268943	1874	203421000	11498	5832	70	0	\N
268944	1874	203422000	11498	5832	71	0	\N
268945	1874	203423000	11498	5832	72	0	\N
268946	1874	203424000	11498	5832	73	0	\N
268947	1874	203425000	11498	5832	74	0	\N
268948	1874	203426000	11498	5832	75	0	\N
268949	1874	203427000	11498	5832	76	0	\N
268950	1874	203428000	11498	5832	77	0	\N
268951	1874	203429000	11498	5832	78	0	\N
268952	1874	203430000	11498	5832	79	0	\N
268953	1874	203431000	11498	5832	80	0	\N
268954	1874	203432000	11498	5832	81	0	\N
268955	1874	203433000	11498	5832	82	0	\N
268956	1874	203434000	11498	5832	83	0	\N
268957	1874	203435000	11498	5832	84	0	\N
268958	1874	203436000	11498	5832	85	0	\N
268959	1874	203437000	11498	5832	86	0	\N
268960	1874	203438000	11498	5832	87	0	\N
268961	1874	203439000	11498	5832	88	0	\N
268964	2050	1400000000	11500	5908	0	0	\N
268965	1678	12240386790000	11500	5908	1	0	\N
268966	1321	1701978637751650	11500	5908	3	0	\N
268967	1874	203441000	11500	5908	5	0	\N
268972	2050	1400000000	11502	5908	0	0	\N
268973	1678	12240386790000	11502	5908	1	0	\N
268974	1321	1701978637751650	11502	5908	3	0	\N
268975	1874	203441000	11502	5908	5	0	\N
268979	58	69546264999659	11504	5793	1	0	\N
268980	1678	12240386738000	11504	5793	3	0	\N
268981	1678	12240386739000	11504	5793	4	0	\N
268982	1678	12240386740000	11504	5793	5	0	\N
268983	1678	12240386741000	11504	5793	6	0	\N
268984	1678	12240386742000	11504	5793	7	0	\N
268985	1678	12240386743000	11504	5793	8	0	\N
268986	1678	12240386744000	11504	5793	9	0	\N
268987	1678	12240386745000	11504	5793	10	0	\N
268988	1678	12240386746000	11504	5793	11	0	\N
268989	1678	12240386747000	11504	5793	12	0	\N
268990	1678	12240386748000	11504	5793	13	0	\N
268991	1678	12240386749000	11504	5793	14	0	\N
268992	1678	12240386750000	11504	5793	15	0	\N
268993	1678	12240386751000	11504	5793	16	0	\N
268994	1678	12240386752000	11504	5793	17	0	\N
268995	1678	12240386753000	11504	5793	19	0	\N
268996	1678	12240386754000	11504	5793	20	0	\N
268997	1678	12240386755000	11504	5793	21	0	\N
268998	1678	12240386756000	11504	5793	22	0	\N
268999	1678	12240386757000	11504	5793	23	0	\N
269000	1678	12240386758000	11504	5793	24	0	\N
269001	1678	12240386759000	11504	5793	25	0	\N
269002	1678	12240386760000	11504	5793	26	0	\N
269003	1678	12240386761000	11504	5793	27	0	\N
269004	1678	12240386762000	11504	5793	28	0	\N
269005	1678	12240386763000	11504	5793	29	0	\N
269006	1678	12240386764000	11504	5793	30	0	\N
269007	1678	12240386765000	11504	5793	31	0	\N
269008	1678	12240386766000	11504	5793	32	0	\N
268962	1678	12240386789000	11499	5907	0	0	0
268963	1874	203440000	11499	5907	2	0	0
268968	2050	1400000000	11501	5908	0	0	0
268969	1678	12240386790000	11501	5908	1	0	0
268970	1321	1701978637751650	11501	5908	3	0	0
268976	1678	12240386791000	11503	5909	0	0	0
268977	1075	905227465000000	11503	5909	1	0	0
268978	1874	203442000	11503	5909	2	0	0
269009	1678	12240386767000	11504	5793	33	0	\N
269010	1678	12240386768000	11504	5793	34	0	\N
269011	1678	12240386769000	11504	5793	35	0	\N
269012	1678	12240386770000	11504	5793	36	0	\N
269013	1678	12240386771000	11504	5793	37	0	\N
269014	1678	12240386772000	11504	5793	38	0	\N
269023	1678	12240386795000	11507	5912	0	0	\N
269024	1874	203446000	11507	5912	1	0	\N
269027	1678	12240386795000	11509	5912	0	0	\N
269028	1874	203446000	11509	5912	1	0	\N
269029	1678	12240386796000	11511	5913	0	0	\N
269030	1874	203447000	11511	5913	1	0	\N
269035	1678	12240386797000	11514	5914	0	0	\N
269036	1874	203448000	11514	5914	1	0	\N
269037	1678	12240386797000	11515	5914	0	0	\N
269038	1874	203448000	11515	5914	1	0	\N
269039	1678	12240386798000	11516	5915	0	0	\N
269040	1874	203449000	11516	5915	1	0	\N
269043	1678	12240386798000	11518	5915	0	0	\N
269044	1874	203449000	11518	5915	1	0	\N
269045	1678	12240386788000	11520	5906	0	0	\N
269046	1678	12240386789000	11520	5906	1	0	\N
269047	1678	12240386790000	11520	5906	2	0	\N
269048	1678	12240386791000	11520	5906	3	0	\N
269049	1678	12240386792000	11520	5906	4	0	\N
269050	1678	12240386793000	11520	5906	5	0	\N
269051	1678	12240386794000	11520	5906	6	0	\N
269052	1678	12240386795000	11520	5906	7	0	\N
269053	1678	12240386796000	11520	5906	8	0	\N
269054	1678	12240386797000	11520	5906	9	0	\N
269055	1075	905227465000000	11520	5906	10	0	\N
269056	1321	1701978637751650	11520	5906	11	0	\N
269057	1874	203439000	11520	5906	13	0	\N
269058	1874	203440000	11520	5906	16	0	\N
269059	2050	1400000000	11520	5906	17	0	\N
269060	1874	203441000	11520	5906	18	0	\N
269061	1874	203442000	11520	5906	19	0	\N
269062	1874	203443000	11520	5906	20	0	\N
269063	1874	203444000	11520	5906	21	0	\N
269064	1874	203445000	11520	5906	22	0	\N
269065	1874	203446000	11520	5906	23	0	\N
269066	1874	203447000	11520	5906	24	0	\N
269067	1874	203448000	11520	5906	25	0	\N
269068	1195	610775750000000	11520	5906	26	0	\N
269069	955	505151775000000	11520	5906	27	0	\N
269084	1678	12240386799000	11524	5917	0	0	\N
269085	1678	12240386800000	11524	5917	1	0	\N
269086	1678	12240386801000	11524	5917	2	0	\N
269087	1678	12240386802000	11524	5917	3	0	\N
269088	1678	12240386803000	11524	5917	4	0	\N
269089	1678	12240386804000	11524	5917	5	0	\N
269090	1678	12240386805000	11524	5917	6	0	\N
269091	1874	203450000	11524	5917	7	0	\N
269092	1874	203451000	11524	5917	8	0	\N
269093	1874	203452000	11524	5917	9	0	\N
269094	1874	203453000	11524	5917	10	0	\N
269095	1874	203454000	11524	5917	11	0	\N
269096	1874	203455000	11524	5917	12	0	\N
269097	1874	203456000	11524	5917	13	0	\N
269098	957	505695775000000	11525	5637	0	0	\N
269099	1197	611432750000000	11525	5637	1	0	\N
269100	1077	906202465000000	11525	5637	2	0	\N
269101	1323	1703811637751650	11525	5637	3	0	\N
269102	2046	300000000	11525	5637	4	0	\N
269103	1534	0	11525	5637	5	0	\N
269104	954	505422011687992	11525	5637	7	0	\N
269105	1194	611101876290553	11525	5637	8	0	\N
269106	1074	905711914489072	11525	5637	9	0	\N
269107	1320	1702889714432878	11525	5637	10	0	\N
269108	257	66001000000000	11525	5637	11	0	\N
269109	58	68826244999659	11525	5637	12	0	\N
269110	192	66227799354186	11525	5637	13	0	\N
269111	973	505148775000000	11525	5637	14	0	\N
269112	122	66414824089930	11525	5637	16	0	\N
269113	721	2012570426909	11525	5637	17	0	\N
269114	918	504510205933512	11525	5637	18	0	\N
269115	1038	904077966389392	11525	5637	19	0	\N
269116	1349	1698698829951650	11525	5637	20	0	\N
269117	1158	609999418948983	11525	5637	21	0	\N
269118	1284	1699817619025558	11525	5637	22	0	\N
269119	1213	610771750000000	11525	5637	23	0	\N
269120	1223	612622942200000	11525	5637	24	0	\N
269121	2042	719000000000	11525	5637	25	0	\N
269122	2042	721000000000	11525	5637	26	0	\N
269123	2042	1551000000000	11525	5637	27	0	\N
269124	217	66414824089930	11525	5637	28	0	\N
269125	103	66414824089930	11525	5637	29	0	\N
269126	1811	1131150178317	11525	5637	30	0	\N
269127	1103	903850752500000	11525	5637	31	0	\N
269128	983	505655062500000	11525	5637	32	0	\N
269129	1874	203087000	11525	5637	33	0	\N
269130	1874	203088000	11525	5637	34	0	\N
269131	1874	203089000	11525	5637	35	0	\N
269132	1874	203090000	11525	5637	36	0	\N
269133	1874	203091000	11525	5637	37	0	\N
269134	1874	203092000	11525	5637	38	0	\N
269135	1874	203093000	11525	5637	39	0	\N
269136	1093	905222465000000	11525	5637	40	0	\N
269137	1339	1701968637751650	11525	5637	41	0	\N
269138	257	67245000000000	11525	5637	42	0	\N
269139	1678	11520366439000	11525	5637	43	0	\N
269140	1678	11520366440000	11525	5637	44	0	\N
269141	1678	11520366441000	11525	5637	45	0	\N
269142	1678	11520366442000	11525	5637	46	0	\N
269143	1678	11520366443000	11525	5637	47	0	\N
269144	1678	11520366444000	11525	5637	48	0	\N
269017	1195	610775750000000	11505	5910	2	0	0
269018	1678	12240386793000	11506	5911	0	0	0
269019	1678	12240386794000	11506	5911	1	0	0
269020	1874	203444000	11506	5911	2	0	0
269021	955	505151775000000	11506	5911	3	0	0
269025	1678	12240386795000	11508	5912	0	0	0
269026	1874	203446000	11508	5912	1	0	0
269031	1678	12240386796000	11512	5913	0	0	0
269032	1874	203447000	11512	5913	1	0	0
269033	1678	12240386797000	11513	5914	0	0	0
269041	1678	12240386798000	11517	5915	0	0	0
269042	1874	203449000	11517	5915	1	0	0
269070	1678	12240386799000	11521	5917	0	0	0
269071	1678	12240386800000	11521	5917	1	0	0
269073	1874	203451000	11521	5917	3	0	0
269074	1678	12240386801000	11522	5918	0	0	0
269075	1874	203452000	11522	5918	1	0	0
269076	1678	12240386802000	11523	5919	0	0	0
269077	1678	12240386803000	11523	5919	1	0	0
269079	1678	12240386805000	11523	5919	3	0	0
269080	1874	203453000	11523	5919	4	0	0
269081	1874	203454000	11523	5919	5	0	0
269082	1874	203455000	11523	5919	6	0	0
269083	1874	203456000	11523	5919	7	0	0
269145	1678	11520366445000	11525	5637	49	0	\N
269146	1678	11520366446000	11525	5637	50	0	\N
269147	1678	11520366447000	11525	5637	51	0	\N
269148	1678	11520366448000	11525	5637	52	0	\N
269149	1678	11520366449000	11525	5637	53	0	\N
269150	1678	11520366450000	11525	5637	54	0	\N
269151	1678	11520366451000	11525	5637	55	0	\N
269152	1678	11520366452000	11525	5637	56	0	\N
269153	1678	11520366453000	11525	5637	57	0	\N
269154	1678	11520366454000	11525	5637	58	0	\N
269155	1678	11520366455000	11525	5637	59	0	\N
269156	1678	11520366456000	11525	5637	60	0	\N
269157	1678	11520366457000	11525	5637	61	0	\N
269158	1678	11520366458000	11525	5637	62	0	\N
269159	1678	11520366459000	11525	5637	63	0	\N
269160	1678	11520366460000	11525	5637	64	0	\N
269161	1678	11520366461000	11525	5637	65	0	\N
269162	1678	11520366462000	11525	5637	66	0	\N
269163	1678	11520366463000	11525	5637	67	0	\N
269164	1678	11520366464000	11525	5637	68	0	\N
269165	1678	11520366465000	11525	5637	69	0	\N
269166	1678	11520366466000	11525	5637	70	0	\N
269167	1678	11520366467000	11525	5637	71	0	\N
269168	1678	11520366468000	11525	5637	72	0	\N
269169	1678	11520366469000	11525	5637	73	0	\N
269170	1678	11520366470000	11525	5637	74	0	\N
269171	1678	11520366471000	11525	5637	75	0	\N
269172	1678	11520366472000	11525	5637	76	0	\N
269173	1678	11520366473000	11525	5637	77	0	\N
269174	1678	11520366474000	11525	5637	78	0	\N
269175	1678	11520366475000	11525	5637	79	0	\N
269176	1678	11520366476000	11525	5637	80	0	\N
269177	1678	11520366477000	11525	5637	81	0	\N
269178	1678	11520366478000	11525	5637	82	0	\N
269179	1678	11520366479000	11525	5637	83	0	\N
269180	1678	11520366480000	11525	5637	84	0	\N
269181	1678	11520366481000	11525	5637	85	0	\N
269182	1678	11520366482000	11525	5637	86	0	\N
269183	1678	11520366483000	11525	5637	87	0	\N
269184	1678	11520366484000	11525	5637	88	0	\N
269185	1678	11520366485000	11525	5637	89	0	\N
269186	1678	11520366486000	11525	5637	90	0	\N
269187	1678	11520366487000	11525	5637	91	0	\N
269188	1678	11520366488000	11525	5637	92	0	\N
269189	1678	11520366489000	11525	5637	93	0	\N
269190	1678	11520366490000	11525	5637	94	0	\N
269191	1874	203094000	11525	5637	95	0	\N
269192	1874	203095000	11525	5637	96	0	\N
269193	1874	203096000	11525	5637	97	0	\N
269194	1874	203097000	11525	5637	99	0	\N
269195	1874	203098000	11525	5637	100	0	\N
269196	1874	203099000	11525	5637	101	0	\N
269197	1874	203100000	11525	5637	102	0	\N
269198	1874	203101000	11525	5637	103	0	\N
269199	1874	203102000	11525	5637	104	0	\N
269200	1874	203103000	11525	5637	105	0	\N
269201	1874	203104000	11525	5637	106	0	\N
269202	1874	203105000	11525	5637	107	0	\N
269203	1874	203106000	11525	5637	108	0	\N
269204	1874	203107000	11525	5637	109	0	\N
269205	1874	203108000	11525	5637	110	0	\N
269206	1874	203109000	11525	5637	111	0	\N
269207	1874	203110000	11525	5637	112	0	\N
269208	1874	203111000	11525	5637	113	0	\N
269209	1874	203112000	11525	5637	114	0	\N
269210	1874	203113000	11525	5637	115	0	\N
269211	1874	203114000	11525	5637	116	0	\N
269212	1874	203115000	11525	5637	117	0	\N
269213	1874	203116000	11525	5637	118	0	\N
269214	1874	203117000	11525	5637	119	0	\N
269215	1874	203118000	11525	5637	120	0	\N
269216	1874	203119000	11525	5637	121	0	\N
269217	1874	203120000	11525	5637	122	0	\N
269218	1874	203121000	11525	5637	123	0	\N
269219	1874	203122000	11525	5637	124	0	\N
269220	1874	203123000	11525	5637	125	0	\N
269232	1678	12240386809000	11528	5921	0	0	\N
269233	1678	12240386810000	11528	5921	1	0	\N
269234	1874	203460000	11528	5921	2	0	\N
269235	1874	203461000	11528	5921	3	0	\N
269236	1025	505330736600000	11528	5921	4	0	\N
269250	1678	12240386816000	11534	5927	0	0	\N
269251	1874	203467000	11534	5927	1	0	\N
269252	2051	200000000	11534	5927	2	0	\N
269253	2052	200000000	11534	5927	3	0	\N
269258	44	66000000000000	11536	5928	0	0	\N
269259	1678	12240386817000	11536	5928	1	0	\N
269260	1678	12240386818000	11536	5928	2	0	\N
269261	1678	12240386819000	11536	5928	3	0	\N
269262	1874	203468000	11536	5928	4	0	\N
269263	1874	203469000	11536	5928	5	0	\N
269264	1874	203470000	11536	5928	6	0	\N
269265	44	66000000000000	11537	5928	0	0	\N
269266	1678	12240386817000	11537	5928	1	0	\N
269267	1678	12240386818000	11537	5928	2	0	\N
269268	1678	12240386819000	11537	5928	3	0	\N
269269	1874	203468000	11537	5928	4	0	\N
269270	1874	203469000	11537	5928	5	0	\N
269271	1874	203470000	11537	5928	6	0	\N
269272	44	66000000000000	11538	5928	0	0	\N
269273	1678	12240386817000	11538	5928	1	0	\N
269274	1678	12240386818000	11538	5928	2	0	\N
269275	1678	12240386819000	11538	5928	3	0	\N
269276	1874	203468000	11538	5928	4	0	\N
269277	1874	203469000	11538	5928	5	0	\N
269278	1874	203470000	11538	5928	6	0	\N
269279	44	66000000000000	11539	5928	0	0	\N
269280	1678	12240386817000	11539	5928	1	0	\N
269223	1678	12240386808000	11526	5920	2	0	0
269224	1874	203457000	11526	5920	3	0	0
269225	1874	203458000	11526	5920	4	0	0
269226	1874	203459000	11526	5920	5	0	0
269227	1678	12240386809000	11527	5921	0	0	0
269229	1874	203460000	11527	5921	2	0	0
269230	1874	203461000	11527	5921	3	0	0
269231	1025	505330736600000	11527	5921	4	0	0
269237	1678	12240386811000	11529	5922	0	0	0
269238	1874	203462000	11529	5922	1	0	0
269240	1874	203463000	11530	5923	1	0	0
269241	1678	12240386813000	11531	5924	0	0	0
269242	1874	203464000	11531	5924	1	0	0
269243	1678	12240386814000	11532	5925	0	0	0
269245	1678	12240386815000	11533	5926	0	0	0
269246	1874	203466000	11533	5926	1	0	0
269247	1265	610991477840000	11533	5926	2	0	0
269248	1145	905548494760000	11533	5926	3	0	0
269249	1391	1702582375511650	11533	5926	4	0	0
269255	1874	203467000	11535	5927	1	0	0
269256	2051	200000000	11535	5927	2	0	0
269257	2052	200000000	11535	5927	3	0	0
269281	1678	12240386818000	11539	5928	2	0	\N
269282	1678	12240386819000	11539	5928	3	0	\N
269283	1874	203468000	11539	5928	4	0	\N
269284	1874	203469000	11539	5928	5	0	\N
269285	1874	203470000	11539	5928	6	0	\N
269293	44	66000000000000	11541	5928	0	0	\N
269294	1678	12240386817000	11541	5928	1	0	\N
269295	1678	12240386818000	11541	5928	2	0	\N
269296	1678	12240386819000	11541	5928	3	0	\N
269297	1874	203468000	11541	5928	4	0	\N
269298	1874	203469000	11541	5928	5	0	\N
269299	1874	203470000	11541	5928	6	0	\N
269300	1678	12240386820000	11542	5929	0	0	\N
269301	1874	203471000	11542	5929	1	0	\N
269306	1678	12240386821000	11545	5930	0	0	\N
269307	1874	203472000	11545	5930	1	0	\N
269310	1678	12240386822000	11547	5931	0	0	\N
269311	1874	203473000	11547	5931	1	0	\N
269315	1874	203476000	11552	5935	0	0	\N
269319	1874	203478000	11555	5937	0	0	\N
269320	1874	203479000	11555	5937	1	0	\N
269329	1874	203488000	11561	5943	0	0	\N
269333	1874	203491000	11564	5945	0	0	\N
269335	1874	203491000	11566	5945	0	0	\N
269336	1874	203492000	11567	5946	0	0	\N
269340	1874	203494000	11571	5948	0	0	\N
269343	1874	203496000	11574	5950	0	0	\N
269352	1874	203504000	11580	5956	0	0	\N
269354	1874	203505000	11584	5958	0	0	\N
269359	1874	203508000	11589	5961	0	0	\N
269360	1874	203509000	11590	5962	0	0	\N
269363	1874	203511000	11593	5964	0	0	\N
269365	1874	203512000	11595	5965	0	0	\N
269366	1874	203513000	11595	5965	1	0	\N
269369	1874	203512000	11597	5965	0	0	\N
269370	1874	203513000	11597	5965	1	0	\N
269371	1874	203512000	11598	5965	0	0	\N
269372	1874	203513000	11598	5965	1	0	\N
269373	1874	203514000	11599	5966	0	0	\N
269374	1874	203515000	11599	5966	1	0	\N
269379	58	70266275999659	11604	5818	0	0	\N
269380	1678	12240386667000	11604	5818	1	0	\N
269381	1678	12240386668000	11604	5818	3	0	\N
269382	1678	12240386669000	11604	5818	4	0	\N
269383	1678	12240386670000	11604	5818	5	0	\N
269384	1678	12240386671000	11604	5818	6	0	\N
269385	1678	12240386672000	11604	5818	7	0	\N
269386	1678	12240386673000	11604	5818	8	0	\N
269387	1678	12240386674000	11604	5818	9	0	\N
269388	1678	12240386675000	11604	5818	10	0	\N
269389	1678	12240386676000	11604	5818	11	0	\N
269390	1678	12240386677000	11604	5818	12	0	\N
269391	1678	12240386678000	11604	5818	13	0	\N
269392	1678	12240386679000	11604	5818	14	0	\N
269393	1678	12240386680000	11604	5818	15	0	\N
269394	1678	12240386681000	11604	5818	16	0	\N
269395	1678	12240386682000	11604	5818	17	0	\N
269396	1678	12240386683000	11604	5818	18	0	\N
269397	1678	12240386684000	11604	5818	19	0	\N
269398	1678	12240386685000	11604	5818	20	0	\N
269399	1678	12240386686000	11604	5818	21	0	\N
269400	1678	12240386687000	11604	5818	22	0	\N
269401	1678	12240386688000	11604	5818	23	0	\N
269402	1678	12240386689000	11604	5818	24	0	\N
269403	1678	12240386690000	11604	5818	25	0	\N
269404	1678	12240386691000	11604	5818	26	0	\N
269405	1678	12240386692000	11604	5818	27	0	\N
269406	1678	12240386693000	11604	5818	28	0	\N
269407	1678	12240386694000	11604	5818	29	0	\N
269408	1678	12240386695000	11604	5818	30	0	\N
269409	1678	12240386696000	11604	5818	31	0	\N
269410	1678	12240386697000	11604	5818	33	0	\N
269411	1678	12240386698000	11604	5818	34	0	\N
269412	1678	12240386699000	11604	5818	35	0	\N
269413	1678	12240386700000	11604	5818	36	0	\N
269414	1678	12240386701000	11604	5818	37	0	\N
269415	1678	12240386702000	11604	5818	38	0	\N
269416	1678	12240386703000	11604	5818	39	0	\N
269288	1678	12240386818000	11540	5928	2	0	0
269289	1678	12240386819000	11540	5928	3	0	0
269290	1874	203468000	11540	5928	4	0	0
269291	1874	203469000	11540	5928	5	0	0
269292	1874	203470000	11540	5928	6	0	0
269303	1874	203471000	11543	5929	1	0	0
269304	1678	12240386821000	11544	5930	0	0	0
269305	1874	203472000	11544	5930	1	0	0
269308	1678	12240386822000	11546	5931	0	0	0
269309	1874	203473000	11546	5931	1	0	0
269313	1874	203475000	11550	5934	0	0	0
269314	1874	203476000	11551	5935	0	0	0
269316	1874	203477000	11553	5936	0	0	0
269317	1874	203478000	11554	5937	0	0	0
269321	1874	203480000	11556	5938	0	0	0
269322	1874	203481000	11557	5939	0	0	0
269323	1874	203482000	11558	5940	0	0	0
269324	1874	203483000	11558	5940	1	0	0
269325	1874	203484000	11559	5941	0	0	0
269327	1874	203486000	11560	5942	0	0	0
269328	1874	203487000	11560	5942	1	0	0
269330	1874	203488000	11562	5943	0	0	0
269331	1874	203489000	11563	5944	0	0	0
269332	1874	203490000	11563	5944	1	0	0
269337	1874	203492000	11568	5946	0	0	0
269338	1874	203493000	11569	5947	0	0	0
269339	1874	203494000	11570	5948	0	0	0
269341	1874	203495000	11572	5949	0	0	0
269344	1874	203497000	11575	5951	0	0	0
269345	1874	203498000	11576	5952	0	0	0
269346	1874	203499000	11576	5952	1	0	0
269347	1874	203500000	11577	5953	0	0	0
269348	1931	3594486000000	11577	5953	1	0	1
269350	1874	203502000	11578	5954	1	0	0
269351	1874	203503000	11579	5955	0	0	0
269353	1874	203504000	11581	5956	0	0	0
269355	1874	203505000	11585	5958	0	0	0
269356	1874	203506000	11586	5959	0	0	0
269358	1874	203508000	11588	5961	0	0	0
269361	1874	203509000	11591	5962	0	0	0
269362	1874	203510000	11592	5963	0	0	0
269364	1874	203511000	11594	5964	0	0	0
269368	1874	203513000	11596	5965	1	0	0
269375	1874	203514000	11600	5966	0	0	0
269376	1874	203515000	11600	5966	1	0	0
269377	1874	203516000	11601	5967	0	0	0
269378	1874	203517000	11601	5967	1	0	0
269417	1678	12240386704000	11604	5818	40	0	\N
269418	1678	12240386705000	11604	5818	41	0	\N
269419	1678	12240386706000	11604	5818	42	0	\N
269420	1678	12240386707000	11604	5818	43	0	\N
269421	1678	12240386708000	11604	5818	44	0	\N
269422	1678	12240386709000	11604	5818	45	0	\N
269423	1678	12240386710000	11604	5818	46	0	\N
269424	1678	12240386711000	11604	5818	47	0	\N
269425	1678	12240386712000	11604	5818	48	0	\N
269426	1678	12240386713000	11604	5818	49	0	\N
269427	1678	12240386714000	11604	5818	50	0	\N
269428	1678	12240386715000	11604	5818	51	0	\N
269429	1678	12240386716000	11604	5818	52	0	\N
269430	1678	12240386717000	11604	5818	53	0	\N
269431	1678	12240386718000	11604	5818	54	0	\N
269432	1678	12240386719000	11604	5818	55	0	\N
269433	1678	12240386720000	11604	5818	56	0	\N
269434	1678	12240386721000	11604	5818	57	0	\N
269435	1678	12240386722000	11604	5818	58	0	\N
269436	1678	12240386723000	11604	5818	59	0	\N
269437	1678	12240386724000	11604	5818	60	0	\N
269438	1678	12240386725000	11604	5818	61	0	\N
269439	1678	12240386726000	11604	5818	62	0	\N
269440	1678	12240386727000	11604	5818	63	0	\N
269441	1678	12240386728000	11604	5818	64	0	\N
269442	1678	12240386729000	11604	5818	65	0	\N
269443	1678	12240386730000	11604	5818	66	0	\N
269444	1678	12240386731000	11604	5818	67	0	\N
269445	1678	12240386732000	11604	5818	68	0	\N
269446	1678	12240386733000	11604	5818	69	0	\N
269447	1678	12240386734000	11604	5818	70	0	\N
269448	1678	12240386735000	11604	5818	71	0	\N
269449	1678	12240386736000	11604	5818	72	0	\N
269450	1678	12240386737000	11604	5818	73	0	\N
269451	1678	12240386738000	11604	5818	74	0	\N
269452	1678	12240386739000	11604	5818	75	0	\N
269453	1678	12240386740000	11604	5818	76	0	\N
269454	1678	12240386741000	11604	5818	77	0	\N
269455	1678	12240386742000	11604	5818	78	0	\N
269456	1678	12240386743000	11604	5818	79	0	\N
269457	1678	12240386744000	11604	5818	80	0	\N
269458	1678	12240386745000	11604	5818	81	0	\N
269459	1678	12240386746000	11604	5818	82	0	\N
269460	1678	12240386747000	11604	5818	83	0	\N
269461	1678	12240386748000	11604	5818	84	0	\N
269462	1678	12240386749000	11604	5818	85	0	\N
269463	1678	12240386750000	11604	5818	86	0	\N
269464	1678	12240386751000	11604	5818	87	0	\N
269465	1678	12240386752000	11604	5818	88	0	\N
269466	1678	12240386753000	11604	5818	89	0	\N
269467	1678	12240386754000	11604	5818	90	0	\N
269468	1678	12240386755000	11604	5818	91	0	\N
269469	1678	12240386756000	11604	5818	92	0	\N
269470	1678	12240386757000	11604	5818	93	0	\N
269471	1678	12240386758000	11604	5818	94	0	\N
269472	1678	12240386759000	11604	5818	95	0	\N
269473	1678	12240386760000	11604	5818	96	0	\N
269474	1678	12240386761000	11604	5818	97	0	\N
269475	1678	12240386762000	11604	5818	98	0	\N
269476	1678	12240386763000	11604	5818	99	0	\N
269477	1678	12240386764000	11604	5818	100	0	\N
269478	1678	12240386765000	11604	5818	101	0	\N
269479	1678	12240386766000	11604	5818	102	0	\N
269480	1678	12240386767000	11604	5818	103	0	\N
269481	1678	12240386768000	11604	5818	104	0	\N
269482	1678	12240386769000	11604	5818	105	0	\N
269483	1678	12240386770000	11604	5818	106	0	\N
269484	1678	12240386771000	11604	5818	107	0	\N
269485	1678	12240386772000	11604	5818	108	0	\N
269486	1678	12240386773000	11604	5818	109	0	\N
269487	1678	12240386774000	11604	5818	110	0	\N
269488	1678	12240386775000	11604	5818	111	0	\N
269489	1678	12240386776000	11604	5818	112	0	\N
269490	1678	12240386777000	11604	5818	113	0	\N
269491	1678	12240386778000	11604	5818	114	0	\N
269492	1678	12240386779000	11604	5818	115	0	\N
269493	1678	12240386780000	11604	5818	116	0	\N
269494	1678	12240386781000	11604	5818	117	0	\N
269495	1678	12240386782000	11604	5818	118	0	\N
269496	1678	12240386783000	11604	5818	119	0	\N
269497	1678	12240386784000	11604	5818	120	0	\N
269498	1678	12240386785000	11604	5818	121	0	\N
269499	1678	12240386786000	11604	5818	122	0	\N
269500	1678	12240386787000	11604	5818	123	0	\N
269501	1678	12240386788000	11604	5818	124	0	\N
269507	1874	203523000	11607	5971	0	0	\N
269508	1874	203524000	11607	5971	1	0	\N
269520	44	66000000000000	11613	5928	0	0	\N
269521	1678	12240386817000	11613	5928	1	0	\N
269522	1678	12240386818000	11613	5928	2	0	\N
269523	1678	12240386819000	11613	5928	3	0	\N
269524	1678	12240386820000	11613	5928	4	0	\N
269525	1678	12240386821000	11613	5928	5	0	\N
269526	1678	12240386822000	11613	5928	6	0	\N
269527	1874	203468000	11613	5928	7	0	\N
269528	1874	203469000	11613	5928	8	0	\N
269529	1874	203470000	11613	5928	9	0	\N
269530	1874	203471000	11613	5928	10	0	\N
269531	1874	203472000	11613	5928	11	0	\N
269532	1874	203473000	11613	5928	12	0	\N
269533	1874	203474000	11613	5928	13	0	\N
269534	1874	203475000	11613	5928	14	0	\N
269535	1874	203476000	11613	5928	15	0	\N
269536	1874	203477000	11613	5928	16	0	\N
269537	1874	203478000	11613	5928	17	0	\N
269538	1874	203479000	11613	5928	18	0	\N
269539	1874	203480000	11613	5928	19	0	\N
269540	1874	203481000	11613	5928	20	0	\N
269541	1874	203482000	11613	5928	21	0	\N
269542	1874	203483000	11613	5928	22	0	\N
269543	1874	203484000	11613	5928	23	0	\N
269544	1874	203485000	11613	5928	24	0	\N
269545	1874	203486000	11613	5928	25	0	\N
269546	1874	203487000	11613	5928	26	0	\N
269547	1874	203488000	11613	5928	27	0	\N
269548	1874	203489000	11613	5928	28	0	\N
269549	1874	203490000	11613	5928	29	0	\N
269550	1874	203491000	11613	5928	30	0	\N
269551	1874	203492000	11613	5928	31	0	\N
269552	1874	203493000	11613	5928	32	0	\N
269504	1874	203520000	11605	5969	2	0	0
269505	1874	203521000	11606	5970	0	0	0
269506	1874	203522000	11606	5970	1	0	0
269509	1874	203523000	11608	5971	0	0	0
269510	1874	203524000	11608	5971	1	0	0
269512	1874	203526000	11609	5972	1	0	0
269513	1874	203527000	11609	5972	2	0	0
269514	1874	203528000	11610	5973	0	0	0
269515	1874	203529000	11611	5974	0	0	0
269516	1874	203530000	11611	5974	1	0	0
269518	1874	203532000	11612	5975	0	0	0
269519	1874	203533000	11612	5975	1	0	0
269553	1874	203494000	11613	5928	33	0	\N
269554	1874	203495000	11613	5928	34	0	\N
269555	1874	203496000	11613	5928	35	0	\N
269556	1874	203497000	11613	5928	36	0	\N
269557	1874	203498000	11613	5928	37	0	\N
269558	1874	203499000	11613	5928	38	0	\N
269559	1874	203500000	11613	5928	39	0	\N
269560	1874	203501000	11613	5928	40	0	\N
269561	1874	203502000	11613	5928	41	0	\N
269562	1874	203503000	11613	5928	42	0	\N
269563	1874	203504000	11613	5928	43	0	\N
269564	1874	203505000	11613	5928	44	0	\N
269565	1874	203506000	11613	5928	45	0	\N
269566	1874	203507000	11613	5928	46	0	\N
269567	1874	203508000	11613	5928	47	0	\N
269568	1874	203509000	11613	5928	48	0	\N
269569	1874	203510000	11613	5928	49	0	\N
269570	1874	203511000	11613	5928	50	0	\N
269571	1874	203512000	11613	5928	51	0	\N
269572	1874	203513000	11613	5928	52	0	\N
269573	1874	203514000	11613	5928	53	0	\N
269574	1874	203515000	11613	5928	54	0	\N
269575	1874	203516000	11613	5928	55	0	\N
269576	1874	203517000	11613	5928	56	0	\N
269577	1874	203518000	11613	5928	57	0	\N
269578	1874	203519000	11613	5928	58	0	\N
269579	1874	203520000	11613	5928	59	0	\N
269580	1874	203521000	11613	5928	60	0	\N
269581	1874	203522000	11613	5928	61	0	\N
269582	1874	203523000	11613	5928	62	0	\N
269583	1874	203524000	11613	5928	63	0	\N
269584	1874	203525000	11613	5928	64	0	\N
269585	1874	203526000	11613	5928	65	0	\N
269586	1874	203527000	11613	5928	66	0	\N
269587	1874	203528000	11613	5928	67	0	\N
269588	1874	203529000	11613	5928	68	0	\N
269589	1874	203530000	11613	5928	69	0	\N
269590	1874	203531000	11613	5928	70	0	\N
269591	1874	203532000	11613	5928	71	0	\N
269592	1874	203533000	11613	5928	72	0	\N
269594	1874	203534000	11615	5976	0	0	\N
269597	1874	203535000	11618	5977	0	0	\N
269598	1874	203536000	11618	5977	1	0	\N
269603	1874	203541000	11621	5981	0	0	\N
269604	1874	203541000	11623	5982	0	0	\N
269605	1874	203542000	11623	5982	1	0	\N
269606	1874	203543000	11623	5982	2	0	\N
269618	1874	203550000	11628	5985	0	0	\N
269619	1874	203550000	11629	5985	0	0	\N
269621	1874	203551000	11631	5986	0	0	\N
269622	1874	203551000	11632	5986	0	0	\N
269624	44	66000000000000	11634	5907	0	0	\N
269625	1678	12240386798000	11634	5907	1	0	\N
269626	1678	12240386799000	11634	5907	2	0	\N
269627	1678	12240386800000	11634	5907	3	0	\N
269628	1678	12240386801000	11634	5907	4	0	\N
269629	1678	12240386802000	11634	5907	5	0	\N
269630	1678	12240386803000	11634	5907	6	0	\N
269631	1678	12240386804000	11634	5907	7	0	\N
269632	1678	12240386805000	11634	5907	8	0	\N
269633	1678	12240386806000	11634	5907	9	0	\N
269634	1678	12240386807000	11634	5907	10	0	\N
269635	1678	12240386808000	11634	5907	11	0	\N
269636	1678	12240386809000	11634	5907	12	0	\N
269637	1678	12240386810000	11634	5907	13	0	\N
269638	1678	12240386811000	11634	5907	14	0	\N
269639	1678	12240386812000	11634	5907	15	0	\N
269640	1678	12240386813000	11634	5907	16	0	\N
269641	1678	12240386814000	11634	5907	17	0	\N
269642	1678	12240386815000	11634	5907	18	0	\N
269643	1678	12240386816000	11634	5907	19	0	\N
269644	1678	12240386817000	11634	5907	20	0	\N
269645	1678	12240386818000	11634	5907	21	0	\N
269646	1678	12240386819000	11634	5907	22	0	\N
269647	1678	12240386820000	11634	5907	23	0	\N
269648	1678	12240386821000	11634	5907	24	0	\N
269649	1678	12240386822000	11634	5907	25	0	\N
269650	1874	203449000	11634	5907	26	0	\N
269651	1874	203450000	11634	5907	27	0	\N
269652	1874	203451000	11634	5907	28	0	\N
269653	1874	203452000	11634	5907	29	0	\N
269654	1874	203453000	11634	5907	30	0	\N
269655	1025	505330736600000	11634	5907	31	0	\N
269656	1265	610991477840000	11634	5907	32	0	\N
269657	1145	905548494760000	11634	5907	33	0	\N
269658	1391	1702582375511650	11634	5907	34	0	\N
269659	1874	203454000	11634	5907	35	0	\N
269660	1874	203455000	11634	5907	36	0	\N
269661	1874	203456000	11634	5907	37	0	\N
269662	1874	203457000	11634	5907	38	0	\N
269663	1874	203458000	11634	5907	39	0	\N
269664	1874	203459000	11634	5907	40	0	\N
269665	1874	203460000	11634	5907	41	0	\N
269666	1874	203461000	11634	5907	42	0	\N
269667	1874	203462000	11634	5907	43	0	\N
269668	1874	203463000	11634	5907	44	0	\N
269669	1874	203464000	11634	5907	45	0	\N
269670	1874	203465000	11634	5907	46	0	\N
269671	1874	203466000	11634	5907	47	0	\N
269672	1874	203467000	11634	5907	48	0	\N
269673	2051	200000000	11634	5907	49	0	\N
269674	2052	200000000	11634	5907	50	0	\N
269675	1874	203468000	11634	5907	51	0	\N
269676	1874	203469000	11634	5907	52	0	\N
269677	1874	203470000	11634	5907	53	0	\N
269678	1874	203471000	11634	5907	54	0	\N
269679	1874	203472000	11634	5907	55	0	\N
269680	1874	203473000	11634	5907	56	0	\N
269681	1874	203474000	11634	5907	57	0	\N
269682	1874	203475000	11634	5907	58	0	\N
269683	1874	203476000	11634	5907	59	0	\N
269684	1874	203477000	11634	5907	60	0	\N
269685	1874	203478000	11634	5907	61	0	\N
269686	1874	203479000	11634	5907	62	0	\N
269687	1874	203480000	11634	5907	63	0	\N
269688	1874	203481000	11634	5907	64	0	\N
269596	1874	203536000	11617	5978	0	0	0
269599	1874	203537000	11619	5979	0	0	0
269600	1874	203538000	11619	5979	1	0	0
269601	1874	203539000	11619	5979	2	0	0
269602	1874	203540000	11620	5980	0	0	0
269608	1874	203542000	11624	5982	1	0	0
269609	1874	203543000	11624	5982	2	0	0
269610	1355	1701797667751650	11625	5983	0	0	0
269611	1874	203544000	11625	5983	1	0	0
269612	1874	203545000	11625	5983	2	0	0
269614	1874	203547000	11625	5983	4	0	0
269615	1874	203548000	11626	5984	0	0	0
269616	1874	203549000	11626	5984	1	0	0
269617	1874	203550000	11627	5985	0	0	0
269623	1874	203552000	11633	5987	0	0	0
269689	1874	203482000	11634	5907	65	0	\N
269690	1874	203483000	11634	5907	66	0	\N
269691	1874	203484000	11634	5907	67	0	\N
269692	1874	203485000	11634	5907	68	0	\N
269693	1874	203486000	11634	5907	69	0	\N
269694	1874	203487000	11634	5907	70	0	\N
269695	1874	203488000	11634	5907	71	0	\N
269696	1874	203489000	11634	5907	72	0	\N
269697	1874	203490000	11634	5907	73	0	\N
269698	1874	203491000	11634	5907	74	0	\N
269699	1874	203492000	11634	5907	75	0	\N
269700	1874	203493000	11634	5907	76	0	\N
269701	1874	203494000	11634	5907	77	0	\N
269702	1874	203495000	11634	5907	78	0	\N
269703	1874	203496000	11634	5907	79	0	\N
269704	1874	203497000	11634	5907	80	0	\N
269705	1874	203498000	11634	5907	81	0	\N
269706	1874	203499000	11634	5907	82	0	\N
269707	1874	203500000	11634	5907	84	0	\N
269708	1874	203501000	11634	5907	85	0	\N
269709	1874	203502000	11634	5907	86	0	\N
269710	1874	203503000	11634	5907	87	0	\N
269711	1874	203504000	11634	5907	88	0	\N
269712	1874	203505000	11634	5907	89	0	\N
269713	1874	203506000	11634	5907	90	0	\N
269714	1874	203507000	11634	5907	91	0	\N
269715	1874	203508000	11634	5907	92	0	\N
269716	1874	203509000	11634	5907	93	0	\N
269717	1874	203510000	11634	5907	94	0	\N
269718	1874	203511000	11634	5907	95	0	\N
269719	1874	203512000	11634	5907	96	0	\N
269720	1874	203513000	11634	5907	97	0	\N
269721	1874	203514000	11634	5907	98	0	\N
269722	1874	203515000	11634	5907	99	0	\N
269723	1874	203516000	11634	5907	100	0	\N
269724	1874	203517000	11634	5907	101	0	\N
269725	1874	203518000	11634	5907	102	0	\N
269726	1874	203519000	11634	5907	103	0	\N
269727	1874	203520000	11634	5907	104	0	\N
269728	1874	203521000	11634	5907	105	0	\N
269729	1874	203522000	11634	5907	106	0	\N
269730	1874	203523000	11634	5907	107	0	\N
269731	1874	203524000	11634	5907	108	0	\N
269732	1874	203525000	11634	5907	109	0	\N
269733	1874	203526000	11634	5907	110	0	\N
269734	1874	203527000	11634	5907	111	0	\N
269735	1874	203528000	11634	5907	112	0	\N
269736	1874	203553000	11635	5988	0	0	\N
269737	1874	203554000	11635	5988	1	0	\N
269738	1874	203555000	11635	5988	2	0	\N
269739	1874	203556000	11635	5988	3	0	\N
269747	1874	203558000	11641	5991	0	0	\N
269748	1874	203559000	11641	5991	1	0	\N
269749	1874	203560000	11643	5992	0	0	\N
269750	1874	203560000	11644	5992	0	0	\N
269751	1874	203560000	11645	5992	0	0	\N
269753	1874	203561000	11647	5993	0	0	\N
269754	1874	203562000	11647	5993	1	0	\N
269755	1874	203561000	11648	5993	0	0	\N
269756	1874	203562000	11648	5993	1	0	\N
269757	1874	203561000	11649	5993	0	0	\N
269758	1874	203562000	11649	5993	1	0	\N
269759	1874	203561000	11650	5993	0	0	\N
269760	1874	203562000	11650	5993	1	0	\N
269763	1874	203561000	11652	5993	0	0	\N
269764	1874	203562000	11652	5993	1	0	\N
269765	1874	203563000	11653	5994	0	0	\N
269767	1874	203563000	11655	5994	0	0	\N
269769	1874	203564000	11657	5995	0	0	\N
269771	1874	203565000	11659	5996	0	0	\N
269772	1874	203566000	11660	5997	0	0	\N
269779	1874	203571000	11664	5999	0	0	\N
269780	1874	203571000	11665	5999	0	0	\N
269781	1874	203571000	11666	5999	0	0	\N
269782	1874	203571000	11667	5999	0	0	\N
269783	1874	203571000	11668	5999	0	0	\N
269784	1874	203571000	11669	5999	0	0	\N
269785	1874	203571000	11670	5999	0	0	\N
269786	1874	203571000	11671	5999	0	0	\N
269793	1874	203576000	11678	6004	0	0	\N
269794	1874	203576000	11679	6004	0	0	\N
269809	411	66006400000000	11683	6007	0	0	\N
269810	920	504912280012457	11683	6007	1	0	\N
269811	1040	904798479693893	11683	6007	2	0	\N
269812	1160	610485563632763	11683	6007	3	0	\N
269813	1286	1701172304412514	11683	6007	4	0	\N
269814	1874	203582000	11683	6007	5	0	\N
269815	1874	203583000	11683	6007	6	0	\N
269816	1874	203584000	11683	6007	7	0	\N
269817	1874	203585000	11683	6007	8	0	\N
269818	411	66006400000000	11684	6007	0	0	\N
269819	920	504912280012457	11684	6007	1	0	\N
269820	1040	904798479693893	11684	6007	2	0	\N
269821	1160	610485563632763	11684	6007	3	0	\N
269822	1286	1701172304412514	11684	6007	4	0	\N
269823	1874	203582000	11684	6007	5	0	\N
269824	1874	203583000	11684	6007	6	0	\N
269742	1874	203555000	11636	5988	2	0	0
269743	1874	203556000	11636	5988	3	0	0
269744	1874	203557000	11639	5990	0	0	0
269745	1874	203558000	11640	5991	0	0	0
269746	1874	203559000	11640	5991	1	0	0
269761	1874	203561000	11651	5993	0	0	0
269762	1874	203562000	11651	5993	1	0	0
269766	1874	203563000	11654	5994	0	0	0
269768	1874	203564000	11656	5995	0	0	0
269770	1874	203565000	11658	5996	0	0	0
269774	2053	1000000000	11663	5998	0	0	0
269775	1874	203567000	11663	5998	1	0	0
269776	1874	203568000	11663	5998	2	0	0
269777	1874	203569000	11663	5998	3	0	0
269787	1874	203571000	11672	5999	0	0	0
269788	1874	203572000	11673	6000	0	0	0
269789	1874	203573000	11674	6001	0	0	0
269790	1874	203574000	11675	6002	0	0	0
269791	1874	203575000	11676	6003	0	0	0
269795	1874	203577000	11680	6005	0	0	0
269796	1874	203578000	11680	6005	1	0	0
269797	1874	203579000	11680	6005	2	0	0
269798	1874	203580000	11681	6006	0	0	0
269799	1874	203581000	11681	6006	1	0	0
269801	920	504912280012457	11682	6007	1	0	0
269802	1040	904798479693893	11682	6007	2	0	0
269803	1160	610485563632763	11682	6007	3	0	0
269804	1286	1701172304412514	11682	6007	4	0	0
269806	1874	203583000	11682	6007	6	0	0
269807	1874	203584000	11682	6007	7	0	0
269808	1874	203585000	11682	6007	8	0	0
269825	1874	203584000	11684	6007	7	0	\N
269826	1874	203585000	11684	6007	8	0	\N
269827	411	66006400000000	11685	6007	0	0	\N
269828	920	504912280012457	11685	6007	1	0	\N
269829	1040	904798479693893	11685	6007	2	0	\N
269830	1160	610485563632763	11685	6007	3	0	\N
269831	1286	1701172304412514	11685	6007	4	0	\N
269832	1874	203582000	11685	6007	5	0	\N
269833	1874	203583000	11685	6007	6	0	\N
269834	1874	203584000	11685	6007	7	0	\N
269835	1874	203585000	11685	6007	8	0	\N
269838	1874	203586000	11687	6008	0	0	\N
269839	1874	203587000	11687	6008	1	0	\N
269842	1874	203589000	11690	6010	0	0	\N
269843	1874	203589000	11691	6010	0	0	\N
269844	1874	203590000	11692	6011	0	0	\N
269849	1874	203592000	11696	6013	0	0	\N
269850	1874	203593000	11696	6013	1	0	\N
269853	1874	203595000	11699	6015	0	0	\N
269855	1874	203596000	11701	6016	0	0	\N
269859	1874	203600000	11705	6020	0	0	\N
269860	1874	203600000	11706	6020	0	0	\N
269862	411	66008410000000	11708	5963	0	0	\N
269863	1355	1701797667751650	11708	5963	1	0	\N
269864	2053	1000000000	11708	5963	2	0	\N
269865	920	504912280012457	11708	5963	3	0	\N
269866	1040	904798479693893	11708	5963	4	0	\N
269867	1160	610485563632763	11708	5963	5	0	\N
269868	1286	1701172304412514	11708	5963	6	0	\N
269872	1874	203604000	11714	6024	0	0	\N
269875	1874	203605000	11719	6025	0	0	\N
269877	411	66006400000000	11721	6001	0	0	\N
269878	920	504912280012457	11721	6001	1	0	\N
269879	1040	904798479693893	11721	6001	2	0	\N
269880	1160	610485563632763	11721	6001	3	0	\N
269881	1286	1701172304412514	11721	6001	4	0	\N
269882	1874	203607000	11726	6027	0	0	\N
269885	1874	203607000	11728	6028	0	0	\N
269886	1874	203608000	11728	6028	1	0	\N
269887	1874	203609000	11729	6029	0	0	\N
269888	1874	203609000	11730	6029	0	0	\N
269890	1874	203610000	11732	6030	0	0	\N
269896	1090	906795935800000	11735	6031	0	0	\N
269897	970	506026562600000	11735	6031	1	0	\N
269898	1336	1704926102951650	11735	6031	2	0	\N
269899	1210	611833516400000	11735	6031	3	0	\N
269900	1874	203611000	11735	6031	4	0	\N
269901	1874	203612000	11735	6031	5	0	\N
269902	1874	203613000	11735	6031	6	0	\N
269903	1090	906795935800000	11736	6031	0	0	\N
269904	970	506026562600000	11736	6031	1	0	\N
269905	1336	1704926102951650	11736	6031	2	0	\N
269906	1210	611833516400000	11736	6031	3	0	\N
269907	1874	203611000	11736	6031	4	0	\N
269908	1874	203612000	11736	6031	5	0	\N
269909	1874	203613000	11736	6031	6	0	\N
269910	1090	906795935800000	11737	6031	0	0	\N
269911	970	506026562600000	11737	6031	1	0	\N
269912	1336	1704926102951650	11737	6031	2	0	\N
269913	1210	611833516400000	11737	6031	3	0	\N
269914	1874	203611000	11737	6031	4	0	\N
269915	1874	203612000	11737	6031	5	0	\N
269916	1874	203613000	11737	6031	6	0	\N
269924	1874	203616000	11742	6034	0	0	\N
269928	1874	203618000	11745	6036	0	0	\N
269929	1874	203619000	11745	6036	1	0	\N
269932	1874	203621000	11748	6038	0	0	\N
269933	1874	203622000	11749	6039	0	0	\N
269934	1874	203623000	11749	6039	1	0	\N
269941	1874	203627000	11757	6044	0	0	\N
269944	1874	203628000	11759	6045	0	0	\N
269945	1874	203629000	11759	6045	1	0	\N
269946	1874	203630000	11760	6046	0	0	\N
269947	1874	203631000	11760	6046	1	0	\N
269950	1874	203632000	11762	6047	0	0	\N
269951	1874	203633000	11762	6047	1	0	\N
269960	1023	505067760241128	11766	6050	0	0	\N
269840	1874	203588000	11688	6009	0	0	0
269841	1874	203589000	11689	6010	0	0	0
269845	1874	203590000	11693	6011	0	0	0
269846	1874	203591000	11694	6012	0	0	0
269847	1874	203592000	11695	6013	0	0	0
269851	1874	203594000	11697	6014	0	0	0
269852	1874	203595000	11698	6015	0	0	0
269854	1874	203596000	11700	6016	0	0	0
269856	1874	203597000	11702	6017	0	0	0
269857	1874	203598000	11703	6018	0	0	0
269861	1874	203600000	11707	6020	0	0	0
269869	1874	203601000	11711	6022	0	0	0
269870	1874	203602000	11711	6022	1	0	0
269871	1874	203603000	11712	6023	0	0	0
269874	1874	203605000	11718	6025	0	0	0
269876	1874	203606000	11720	6026	0	0	0
269883	1874	203607000	11727	6028	0	0	0
269884	1874	203608000	11727	6028	1	0	0
269889	1874	203609000	11731	6029	0	0	0
269892	1090	906795935800000	11734	6031	0	0	0
269893	970	506026562600000	11734	6031	1	0	0
269894	1336	1704926102951650	11734	6031	2	0	0
269895	1210	611833516400000	11734	6031	3	0	0
269917	1874	203611000	11739	6032	0	0	0
269919	1874	203613000	11739	6032	2	0	0
269920	1874	203614000	11739	6032	3	0	0
269921	2054	200000000	11739	6032	4	0	0
269922	1874	203615000	11740	6033	0	0	0
269925	1874	203617000	11743	6035	0	0	0
269926	1874	203618000	11744	6036	0	0	0
269927	1874	203619000	11744	6036	1	0	0
269930	1874	203620000	11746	6037	0	0	0
269931	1874	203621000	11747	6038	0	0	0
269936	1874	203623000	11750	6039	1	0	0
269937	1874	203624000	11751	6040	0	0	0
269938	1874	203625000	11752	6041	0	0	0
269939	1874	203626000	11755	6043	0	0	0
269940	1874	203627000	11756	6044	0	0	0
269943	1874	203629000	11758	6045	1	0	0
269948	1874	203630000	11761	6046	0	0	0
269949	1874	203631000	11761	6046	1	0	0
269952	1874	203632000	11763	6047	0	0	0
269954	1771	304915534083	11764	6048	0	0	0
269955	195	66300806891531	11764	6048	1	0	0
269956	1874	203634000	11764	6048	2	0	0
269957	1874	203635000	11764	6048	3	0	0
269958	291	66300806891531	11765	6049	0	0	0
269961	1874	203637000	11766	6050	1	0	\N
269962	1023	505067760241128	11767	6050	0	0	\N
269963	1874	203637000	11767	6050	1	0	\N
269966	1143	905077098931514	11769	6051	0	0	\N
269967	1263	610673553584273	11769	6051	1	0	\N
269968	1874	203638000	11769	6051	2	0	\N
269974	1389	1701696155127528	11772	6052	0	0	\N
269975	1874	203639000	11772	6052	1	0	\N
269976	411	66008410000000	11773	5929	0	0	\N
269977	1771	304915534083	11773	5929	1	0	\N
269978	195	66300806891531	11773	5929	2	0	\N
269979	2053	1000000000	11773	5929	3	0	\N
269980	1090	906795935800000	11773	5929	4	0	\N
269981	291	66300806891531	11773	5929	5	0	\N
269982	1023	505067760241128	11773	5929	6	0	\N
269983	1143	905077098931514	11773	5929	7	0	\N
269984	1263	610673553584273	11773	5929	8	0	\N
269985	1389	1701696155127528	11773	5929	9	0	\N
269986	920	504912280012457	11773	5929	10	0	\N
269987	1040	904798479693893	11773	5929	11	0	\N
269988	1160	610485563632763	11773	5929	12	0	\N
269989	1286	1701172304412514	11773	5929	13	0	\N
269990	970	506026562600000	11773	5929	14	0	\N
269991	1336	1704926102951650	11773	5929	15	0	\N
269992	1210	611833516400000	11773	5929	16	0	\N
269993	1874	203534000	11773	5929	17	0	\N
269994	1874	203535000	11773	5929	18	0	\N
269995	1874	203536000	11773	5929	19	0	\N
269996	1874	203537000	11773	5929	20	0	\N
269997	1874	203538000	11773	5929	21	0	\N
269998	1874	203539000	11773	5929	22	0	\N
269999	1874	203540000	11773	5929	23	0	\N
270000	1874	203541000	11773	5929	24	0	\N
270001	1874	203542000	11773	5929	25	0	\N
270002	1874	203543000	11773	5929	26	0	\N
270003	1874	203544000	11773	5929	27	0	\N
270004	1874	203545000	11773	5929	28	0	\N
270005	1874	203546000	11773	5929	29	0	\N
270006	1874	203547000	11773	5929	30	0	\N
270007	1874	203548000	11773	5929	31	0	\N
270008	1874	203549000	11773	5929	32	0	\N
270009	1874	203550000	11773	5929	33	0	\N
270010	1874	203551000	11773	5929	34	0	\N
270011	1874	203552000	11773	5929	35	0	\N
270012	1874	203553000	11773	5929	36	0	\N
270013	1874	203554000	11773	5929	37	0	\N
270014	1874	203555000	11773	5929	38	0	\N
270015	1874	203556000	11773	5929	39	0	\N
270016	1874	203557000	11773	5929	40	0	\N
270017	1874	203558000	11773	5929	41	0	\N
270018	1874	203559000	11773	5929	42	0	\N
270019	1874	203560000	11773	5929	43	0	\N
270020	1874	203561000	11773	5929	44	0	\N
270021	1874	203562000	11773	5929	45	0	\N
270022	1874	203563000	11773	5929	46	0	\N
270023	1874	203564000	11773	5929	47	0	\N
270024	1874	203565000	11773	5929	48	0	\N
270025	1874	203566000	11773	5929	49	0	\N
270026	1874	203567000	11773	5929	50	0	\N
270027	1874	203568000	11773	5929	52	0	\N
270028	1874	203569000	11773	5929	53	0	\N
270029	1874	203570000	11773	5929	54	0	\N
270030	1874	203571000	11773	5929	55	0	\N
270031	1874	203572000	11773	5929	56	0	\N
270032	1874	203573000	11773	5929	57	0	\N
270033	1874	203574000	11773	5929	58	0	\N
270034	1874	203575000	11773	5929	59	0	\N
270035	1874	203576000	11773	5929	60	0	\N
270036	1874	203577000	11773	5929	61	0	\N
270037	1874	203578000	11773	5929	62	0	\N
270038	1874	203579000	11773	5929	63	0	\N
270039	1874	203580000	11773	5929	64	0	\N
270040	1874	203581000	11773	5929	65	0	\N
270041	1874	203582000	11773	5929	66	0	\N
270042	1874	203583000	11773	5929	67	0	\N
270043	1874	203584000	11773	5929	68	0	\N
270044	1874	203585000	11773	5929	69	0	\N
270045	1874	203586000	11773	5929	70	0	\N
270046	1874	203587000	11773	5929	71	0	\N
270047	1874	203588000	11773	5929	72	0	\N
270048	1874	203589000	11773	5929	73	0	\N
270049	1874	203590000	11773	5929	74	0	\N
270050	1874	203591000	11773	5929	75	0	\N
270051	1874	203592000	11773	5929	76	0	\N
270052	1874	203593000	11773	5929	77	0	\N
270053	1874	203594000	11773	5929	78	0	\N
270054	1874	203595000	11773	5929	79	0	\N
270055	1874	203596000	11773	5929	80	0	\N
270056	1874	203597000	11773	5929	81	0	\N
270057	1874	203598000	11773	5929	82	0	\N
270058	1874	203599000	11773	5929	83	0	\N
270059	1874	203600000	11773	5929	84	0	\N
270060	1874	203601000	11773	5929	85	0	\N
270061	1874	203602000	11773	5929	86	0	\N
270062	1874	203603000	11773	5929	87	0	\N
270063	1874	203604000	11773	5929	88	0	\N
270064	1874	203605000	11773	5929	89	0	\N
270065	1874	203606000	11773	5929	90	0	\N
270066	1874	203607000	11773	5929	91	0	\N
270067	1874	203608000	11773	5929	92	0	\N
270068	1874	203609000	11773	5929	93	0	\N
270069	1874	203610000	11773	5929	94	0	\N
270070	1874	203611000	11773	5929	95	0	\N
270071	1874	203612000	11773	5929	96	0	\N
270072	1874	203613000	11773	5929	97	0	\N
270073	1874	203614000	11773	5929	98	0	\N
270074	2054	200000000	11773	5929	99	0	\N
270075	1874	203615000	11773	5929	100	0	\N
270076	1874	203616000	11773	5929	101	0	\N
270077	1874	203617000	11773	5929	102	0	\N
270078	1874	203618000	11773	5929	103	0	\N
270079	1874	203619000	11773	5929	104	0	\N
270080	1874	203620000	11773	5929	105	0	\N
270081	1874	203621000	11773	5929	106	0	\N
270082	1874	203622000	11773	5929	107	0	\N
270083	1874	203623000	11773	5929	108	0	\N
270084	1874	203624000	11773	5929	109	0	\N
270085	1874	203625000	11773	5929	110	0	\N
270086	1874	203626000	11773	5929	111	0	\N
270087	1874	203627000	11773	5929	112	0	\N
270088	1874	203628000	11773	5929	113	0	\N
270089	1874	203629000	11773	5929	114	0	\N
270090	1874	203630000	11773	5929	115	0	\N
270091	1874	203631000	11773	5929	116	0	\N
270092	1874	203632000	11773	5929	117	0	\N
270093	1874	203633000	11773	5929	118	0	\N
270094	1874	203634000	11773	5929	119	0	\N
270095	1874	203635000	11773	5929	120	0	\N
270096	1874	203636000	11773	5929	121	0	\N
269969	1143	905077098931514	11770	6051	0	0	0
269970	1263	610673553584273	11770	6051	1	0	0
269971	1874	203638000	11770	6051	2	0	0
269972	1389	1701696155127528	11771	6052	0	0	0
269973	1874	203639000	11771	6052	1	0	0
270097	1874	203637000	11773	5929	122	0	\N
270098	1874	203638000	11773	5929	123	0	\N
270099	1874	203639000	11773	5929	124	0	\N
270100	1389	1701696155127528	11774	6052	0	0	\N
270101	1874	203639000	11774	6052	1	0	\N
270102	1874	203640000	11774	6052	2	0	\N
270108	1874	203644000	11778	6056	0	0	\N
270109	1874	203644000	11779	6056	0	0	\N
270111	1874	203645000	11781	6057	0	0	\N
270112	1874	203645000	11782	6057	0	0	\N
270113	1874	203645000	11783	6057	0	0	\N
270117	1874	203646000	11787	6058	0	0	\N
270118	1874	203647000	11787	6058	1	0	\N
270119	1874	203646000	11788	6058	0	0	\N
270120	1874	203647000	11788	6058	1	0	\N
270121	411	66008410000000	11789	5945	0	0	\N
270122	1771	304915534083	11789	5945	1	0	\N
270123	195	66300806891531	11789	5945	2	0	\N
270124	2053	1000000000	11789	5945	3	0	\N
270125	1090	906795935800000	11789	5945	4	0	\N
270126	291	66300806891531	11789	5945	5	0	\N
270127	1023	505067760241128	11789	5945	6	0	\N
270128	1143	905077098931514	11789	5945	7	0	\N
270129	1263	610673553584273	11789	5945	8	0	\N
270130	1389	1701696155127528	11789	5945	9	0	\N
270131	920	504912280012457	11789	5945	10	0	\N
270132	1040	904798479693893	11789	5945	11	0	\N
270133	1160	610485563632763	11789	5945	12	0	\N
270134	1286	1701172304412514	11789	5945	13	0	\N
270135	970	506026562600000	11789	5945	14	0	\N
270136	1336	1704926102951650	11789	5945	15	0	\N
270137	1210	611833516400000	11789	5945	16	0	\N
270138	1874	203491000	11789	5945	17	0	\N
270139	1874	203492000	11789	5945	18	0	\N
270140	1874	203493000	11789	5945	19	0	\N
270141	1874	203494000	11789	5945	20	0	\N
270142	1874	203495000	11789	5945	21	0	\N
270143	1874	203496000	11789	5945	22	0	\N
270144	1874	203497000	11789	5945	23	0	\N
270145	1931	3594486000000	11789	5945	24	0	\N
270146	1874	203498000	11789	5945	25	0	\N
270147	1874	203499000	11789	5945	26	0	\N
270148	1874	203500000	11789	5945	27	0	\N
270149	1874	203501000	11789	5945	28	0	\N
270150	1874	203502000	11789	5945	29	0	\N
270151	1874	203503000	11789	5945	30	0	\N
270152	1874	203504000	11789	5945	31	0	\N
270153	1874	203505000	11789	5945	32	0	\N
270154	1874	203506000	11789	5945	33	0	\N
270155	1874	203507000	11789	5945	34	0	\N
270156	1874	203508000	11789	5945	35	0	\N
270157	1874	203509000	11789	5945	36	0	\N
270158	1874	203510000	11789	5945	37	0	\N
270159	1874	203511000	11789	5945	38	0	\N
270160	1874	203512000	11789	5945	39	0	\N
270161	1874	203513000	11789	5945	40	0	\N
270162	1874	203514000	11789	5945	41	0	\N
270163	1874	203515000	11789	5945	42	0	\N
270164	1874	203516000	11789	5945	43	0	\N
270165	1874	203517000	11789	5945	44	0	\N
270166	1874	203518000	11789	5945	45	0	\N
270167	1874	203519000	11789	5945	46	0	\N
270168	1646	0	11789	5945	47	0	\N
270169	1874	203520000	11789	5945	48	0	\N
270170	1874	203521000	11789	5945	49	0	\N
270171	1874	203522000	11789	5945	50	0	\N
270172	1874	203523000	11789	5945	51	0	\N
270173	1874	203524000	11789	5945	52	0	\N
270174	1874	203525000	11789	5945	53	0	\N
270175	1874	203526000	11789	5945	54	0	\N
270176	1874	203527000	11789	5945	55	0	\N
270177	1874	203528000	11789	5945	56	0	\N
270178	1874	203529000	11789	5945	57	0	\N
270179	1874	203530000	11789	5945	58	0	\N
270180	1874	203531000	11789	5945	59	0	\N
270181	1874	203532000	11789	5945	60	0	\N
270182	1874	203533000	11789	5945	61	0	\N
270183	1874	203534000	11789	5945	62	0	\N
270184	1874	203535000	11789	5945	64	0	\N
270185	1874	203536000	11789	5945	65	0	\N
270186	1874	203537000	11789	5945	66	0	\N
270187	1874	203538000	11789	5945	67	0	\N
270188	1874	203539000	11789	5945	68	0	\N
270189	1874	203540000	11789	5945	69	0	\N
270190	1874	203541000	11789	5945	70	0	\N
270191	1874	203542000	11789	5945	71	0	\N
270192	1874	203543000	11789	5945	72	0	\N
270193	1874	203544000	11789	5945	73	0	\N
270194	1874	203545000	11789	5945	74	0	\N
270195	1874	203546000	11789	5945	75	0	\N
270196	1874	203547000	11789	5945	76	0	\N
270197	1874	203548000	11789	5945	77	0	\N
270198	1874	203549000	11789	5945	78	0	\N
270199	1874	203550000	11789	5945	79	0	\N
270200	1874	203551000	11789	5945	80	0	\N
270201	1874	203552000	11789	5945	81	0	\N
270202	1874	203553000	11789	5945	82	0	\N
270203	1874	203554000	11789	5945	83	0	\N
270204	1874	203555000	11789	5945	84	0	\N
270205	1874	203556000	11789	5945	85	0	\N
270206	1874	203557000	11789	5945	86	0	\N
270207	1874	203558000	11789	5945	87	0	\N
270208	1874	203559000	11789	5945	88	0	\N
270209	1874	203560000	11789	5945	89	0	\N
270210	1874	203561000	11789	5945	90	0	\N
270211	1874	203562000	11789	5945	91	0	\N
270212	1874	203563000	11789	5945	92	0	\N
270213	1874	203564000	11789	5945	93	0	\N
270214	1874	203565000	11789	5945	94	0	\N
270215	1874	203566000	11789	5945	95	0	\N
270216	1874	203567000	11789	5945	96	0	\N
270217	1874	203568000	11789	5945	97	0	\N
270218	1874	203569000	11789	5945	98	0	\N
270219	1874	203570000	11789	5945	99	0	\N
270220	1874	203571000	11789	5945	100	0	\N
270221	1874	203572000	11789	5945	101	0	\N
270222	1874	203573000	11789	5945	102	0	\N
270223	1874	203574000	11789	5945	103	0	\N
270224	1874	203575000	11789	5945	104	0	\N
270225	1874	203576000	11789	5945	105	0	\N
270226	1874	203577000	11789	5945	106	0	\N
270227	1874	203578000	11789	5945	107	0	\N
270228	1874	203579000	11789	5945	108	0	\N
270229	1874	203580000	11789	5945	109	0	\N
270230	1874	203581000	11789	5945	110	0	\N
270231	1874	203582000	11789	5945	111	0	\N
270232	1874	203583000	11789	5945	112	0	\N
270105	1874	203641000	11776	6054	0	0	0
270106	1874	203642000	11776	6054	1	0	0
270107	1874	203643000	11777	6055	0	0	0
270110	1874	203644000	11780	6056	0	0	0
270114	1874	203645000	11784	6057	0	0	0
270116	1874	203647000	11785	6058	1	0	0
270233	1874	203584000	11789	5945	113	0	\N
270234	1874	203585000	11789	5945	114	0	\N
270235	1874	203586000	11789	5945	115	0	\N
270236	1874	203587000	11789	5945	116	0	\N
270237	1874	203588000	11789	5945	117	0	\N
270238	1874	203589000	11789	5945	118	0	\N
270239	1874	203590000	11789	5945	119	0	\N
270240	1874	203591000	11789	5945	120	0	\N
270241	1874	203592000	11789	5945	121	0	\N
270242	1874	203593000	11789	5945	122	0	\N
270243	1874	203594000	11789	5945	123	0	\N
270244	1874	203595000	11789	5945	124	0	\N
270245	1874	203596000	11789	5945	125	0	\N
270249	1874	203649000	11792	6060	0	0	\N
270250	1874	203650000	11792	6060	1	0	\N
270251	1874	203651000	11793	6061	0	0	\N
270253	1874	203651000	11795	6061	0	0	\N
270254	411	66008410000000	11796	5819	0	0	\N
270255	1771	304915534083	11796	5819	1	0	\N
270256	195	66300806891531	11796	5819	2	0	\N
270257	2053	1000000000	11796	5819	3	0	\N
270258	1678	12240386789000	11796	5819	4	0	\N
270259	1678	12240386790000	11796	5819	5	0	\N
270260	1678	12240386791000	11796	5819	6	0	\N
270261	1678	12240386792000	11796	5819	7	0	\N
270262	1678	12240386793000	11796	5819	8	0	\N
270263	1678	12240386794000	11796	5819	9	0	\N
270264	1678	12240386795000	11796	5819	10	0	\N
270265	1678	12240386796000	11796	5819	11	0	\N
270266	1678	12240386797000	11796	5819	12	0	\N
270267	1678	12240386798000	11796	5819	13	0	\N
270268	1678	12240386799000	11796	5819	14	0	\N
270269	1678	12240386800000	11796	5819	15	0	\N
270270	1678	12240386801000	11796	5819	16	0	\N
270271	1678	12240386802000	11796	5819	17	0	\N
270272	1678	12240386803000	11796	5819	18	0	\N
270273	1678	12240386804000	11796	5819	19	0	\N
270274	1678	12240386805000	11796	5819	20	0	\N
270275	1678	12240386806000	11796	5819	21	0	\N
270276	1090	906795935800000	11796	5819	22	0	\N
270277	291	66300806891531	11796	5819	23	0	\N
270278	1023	505067760241128	11796	5819	24	0	\N
270279	1143	905077098931514	11796	5819	25	0	\N
270280	1263	610673553584273	11796	5819	26	0	\N
270281	1389	1701696155127528	11796	5819	27	0	\N
270282	920	504912280012457	11796	5819	28	0	\N
270283	1040	904798479693893	11796	5819	29	0	\N
270284	1160	610485563632763	11796	5819	30	0	\N
270285	1286	1701172304412514	11796	5819	31	0	\N
270286	1678	12240386807000	11796	5819	33	0	\N
270287	1678	12240386808000	11796	5819	34	0	\N
270288	1678	12240386809000	11796	5819	35	0	\N
270289	1678	12240386810000	11796	5819	36	0	\N
270290	1678	12240386811000	11796	5819	37	0	\N
270291	1678	12240386812000	11796	5819	38	0	\N
270292	1678	12240386813000	11796	5819	39	0	\N
270293	1678	12240386814000	11796	5819	40	0	\N
270294	1678	12240386815000	11796	5819	41	0	\N
270295	1678	12240386816000	11796	5819	42	0	\N
270296	1678	12240386817000	11796	5819	43	0	\N
270297	1678	12240386818000	11796	5819	44	0	\N
270298	1678	12240386819000	11796	5819	45	0	\N
270299	1678	12240386820000	11796	5819	46	0	\N
270300	1678	12240386821000	11796	5819	47	0	\N
270301	1678	12240386822000	11796	5819	48	0	\N
270302	970	506026562600000	11796	5819	49	0	\N
270303	1336	1704926102951650	11796	5819	50	0	\N
270304	1210	611833516400000	11796	5819	51	0	\N
270305	1075	905227465000000	11796	5819	52	0	\N
270306	1704	66194000000	11796	5819	53	0	\N
270307	1321	1701978637751650	11796	5819	54	0	\N
270308	1874	203318000	11796	5819	55	0	\N
270309	1874	203319000	11796	5819	56	0	\N
270310	44	66000000000000	11796	5819	58	0	\N
270311	971	505003883106880	11796	5819	59	0	\N
270312	1025	505330736600000	11796	5819	66	0	\N
270313	1265	610991477840000	11796	5819	67	0	\N
270314	1145	905548494760000	11796	5819	68	0	\N
270315	1391	1702582375511650	11796	5819	69	0	\N
270316	1874	203320000	11796	5819	70	0	\N
270317	1646	0	11796	5819	71	0	\N
270318	1195	610775750000000	11796	5819	72	0	\N
270319	955	505151775000000	11796	5819	73	0	\N
270320	1874	203321000	11796	5819	74	0	\N
270321	1874	203322000	11796	5819	75	0	\N
270322	1874	203323000	11796	5819	76	0	\N
270323	1874	203324000	11796	5819	77	0	\N
270324	1874	203325000	11796	5819	78	0	\N
270325	1874	203326000	11796	5819	79	0	\N
270326	1874	203327000	11796	5819	80	0	\N
270327	1874	203328000	11796	5819	81	0	\N
270328	1874	203329000	11796	5819	82	0	\N
270329	1874	203330000	11796	5819	83	0	\N
270330	1874	203331000	11796	5819	84	0	\N
270331	1874	203332000	11796	5819	85	0	\N
270332	1874	203333000	11796	5819	86	0	\N
270333	1874	203334000	11796	5819	87	0	\N
270334	1874	203335000	11796	5819	88	0	\N
270335	1874	203336000	11796	5819	89	0	\N
270336	1874	203337000	11796	5819	90	0	\N
270337	1874	203338000	11796	5819	91	0	\N
270338	1874	203339000	11796	5819	92	0	\N
270339	1874	203340000	11796	5819	93	0	\N
270340	1874	203341000	11796	5819	94	0	\N
270341	1874	203342000	11796	5819	95	0	\N
270342	1874	203343000	11796	5819	96	0	\N
270343	1874	203344000	11796	5819	97	0	\N
270344	1874	203345000	11796	5819	98	0	\N
270345	1874	203346000	11796	5819	99	0	\N
270346	1874	203347000	11796	5819	100	0	\N
270347	1874	203348000	11796	5819	101	0	\N
270348	1874	203349000	11796	5819	102	0	\N
270349	1874	203350000	11796	5819	103	0	\N
270350	1874	203351000	11796	5819	104	0	\N
270351	1874	203352000	11796	5819	105	0	\N
270352	1874	203353000	11796	5819	106	0	\N
270353	1874	203354000	11796	5819	107	0	\N
270354	1874	203355000	11796	5819	108	0	\N
270355	1874	203356000	11796	5819	109	0	\N
270356	1874	203357000	11796	5819	110	0	\N
270357	1874	203358000	11796	5819	111	0	\N
270358	1874	203359000	11796	5819	112	0	\N
270359	1874	203360000	11796	5819	113	0	\N
270360	1874	203361000	11796	5819	114	0	\N
270361	1874	203362000	11796	5819	115	0	\N
270362	1874	203363000	11796	5819	116	0	\N
270363	1874	203364000	11796	5819	117	0	\N
270364	1874	203365000	11796	5819	118	0	\N
270365	1874	203366000	11796	5819	119	0	\N
270366	1874	203367000	11796	5819	120	0	\N
270367	1874	203368000	11796	5819	121	0	\N
270368	1874	203369000	11796	5819	122	0	\N
270248	1874	203650000	11791	6060	1	0	0
270252	1874	203651000	11794	6061	0	0	0
270369	1874	203370000	11796	5819	123	0	\N
270370	1874	203371000	11796	5819	124	0	\N
270374	1874	203655000	11800	6065	0	0	\N
270375	1874	203656000	11800	6065	1	0	\N
270379	1874	203658000	11803	6067	0	0	\N
270380	1874	203658000	11804	6067	0	0	\N
270381	1874	203658000	11805	6067	0	0	\N
270382	1874	203658000	11806	6067	0	0	\N
270386	1874	203660000	11810	6069	0	0	\N
270387	1874	203660000	11811	6069	0	0	\N
270389	1874	203661000	11813	6070	0	0	\N
270390	1874	203661000	11814	6070	0	0	\N
270391	1874	203661000	11815	6070	0	0	\N
270398	1874	203665000	11819	6073	0	0	\N
270399	1874	203666000	11819	6073	1	0	\N
270400	1874	203667000	11819	6073	2	0	\N
270406	1874	203672000	11825	6077	0	0	\N
270419	1874	203676000	11828	6080	0	0	\N
270420	1874	203677000	11828	6080	1	0	\N
270423	1874	203676000	11830	6080	0	0	\N
270424	1874	203677000	11830	6080	1	0	\N
270432	1874	203680000	11833	6082	0	0	\N
270433	1874	203681000	11833	6082	1	0	\N
270434	1874	203682000	11833	6082	2	0	\N
270435	1874	203683000	11833	6082	3	0	\N
270436	1874	203684000	11833	6082	4	0	\N
270437	1874	203680000	11834	6082	0	0	\N
270438	1874	203681000	11834	6082	1	0	\N
270439	1874	203682000	11834	6082	2	0	\N
270440	1874	203683000	11834	6082	3	0	\N
270441	1874	203684000	11834	6082	4	0	\N
270449	1874	203691000	11838	6086	0	0	\N
270455	1874	203695000	11843	6089	0	0	\N
270457	1874	203697000	11845	6091	0	0	\N
270458	1874	203697000	11846	6091	0	0	\N
270459	1874	203697000	11847	6091	0	0	\N
270461	2057	200000000	11850	6092	0	0	\N
270462	1874	203698000	11850	6092	1	0	\N
270466	13	4672715676666	11854	6068	0	0	\N
270467	19	2336860172844	11854	6068	1	0	\N
270468	203	66308156237945	11854	6068	2	0	\N
270469	241	66308156237945	11854	6068	3	0	\N
270470	313	66308156237945	11854	6068	4	0	\N
270471	965	505064219226326	11854	6068	5	0	\N
270472	1085	905070753463320	11854	6068	6	0	\N
270473	1205	610669272170436	11854	6068	7	0	\N
270474	1331	1701684224587218	11854	6068	8	0	\N
270475	1874	203699000	11855	6093	0	0	\N
270478	1874	203700000	11857	6094	0	0	\N
270479	1874	203701000	11857	6094	1	0	\N
270481	1874	203703000	11860	6096	0	0	\N
270483	981	504509746723918	11862	6097	0	0	\N
270484	1874	203704000	11862	6097	1	0	\N
270485	1874	203705000	11862	6097	2	0	\N
270489	411	66008410000000	11864	5918	0	0	\N
270490	13	4672715676666	11864	5918	1	0	\N
270491	1678	12240386806000	11864	5918	2	0	\N
270492	44	66000000000000	11864	5918	3	0	\N
270493	981	504509746723918	11864	5918	4	0	\N
270494	1771	304915534083	11864	5918	5	0	\N
270495	195	66300806891531	11864	5918	6	0	\N
270496	2053	1000000000	11864	5918	7	0	\N
270497	19	2336860172844	11864	5918	8	0	\N
270498	1090	906795935800000	11864	5918	9	0	\N
270499	203	66308156237945	11864	5918	10	0	\N
270500	291	66300806891531	11864	5918	11	0	\N
270501	1023	505067760241128	11864	5918	12	0	\N
270502	1143	905077098931514	11864	5918	13	0	\N
270503	1263	610673553584273	11864	5918	14	0	\N
270504	1389	1701696155127528	11864	5918	15	0	\N
270373	1874	203654000	11799	6064	0	0	0
270376	1874	203655000	11801	6065	0	0	0
270377	1874	203656000	11801	6065	1	0	0
270378	1874	203657000	11802	6066	0	0	0
270383	1874	203658000	11807	6067	0	0	0
270385	1874	203660000	11809	6069	0	0	0
270388	1874	203661000	11812	6070	0	0	0
270392	1874	203662000	11816	6071	0	0	0
270393	1874	203663000	11817	6072	0	0	0
270394	1874	203664000	11817	6072	1	0	0
270396	1874	203666000	11818	6073	1	0	0
270397	1874	203667000	11818	6073	2	0	0
270401	1874	203668000	11820	6074	0	0	0
270402	1874	203669000	11821	6075	0	0	0
270404	1874	203671000	11822	6076	0	0	0
270405	1874	203672000	11824	6077	0	0	0
270407	13	4672715676666	11826	6078	0	0	0
270408	19	2336860172844	11826	6078	1	0	0
270409	203	66308156237945	11826	6078	2	0	0
270411	313	66308156237945	11826	6078	4	0	0
270412	965	505064219226326	11826	6078	5	0	0
270413	1085	905070753463320	11826	6078	6	0	0
270414	1205	610669272170436	11826	6078	7	0	0
270415	1331	1701684224587218	11826	6078	8	0	0
270417	1874	203674000	11826	6078	10	0	0
270418	1874	203675000	11827	6079	0	0	0
270421	1874	203676000	11829	6080	0	0	0
270422	1874	203677000	11829	6080	1	0	0
270426	1874	203679000	11831	6081	1	0	0
270427	1874	203680000	11832	6082	0	0	0
270428	1874	203681000	11832	6082	1	0	0
270429	1874	203682000	11832	6082	2	0	0
270430	1874	203683000	11832	6082	3	0	0
270442	1874	203685000	11835	6083	0	0	0
270443	1874	203686000	11835	6083	1	0	0
270444	1874	203687000	11835	6083	2	0	0
270445	1874	203688000	11835	6083	3	0	0
270446	1874	203689000	11836	6084	0	0	0
270448	1874	203690000	11837	6085	1	0	0
270450	1874	203691000	11839	6086	0	0	0
270451	1874	203692000	11840	6087	0	0	0
270452	1874	203693000	11841	6088	0	0	0
270454	1874	203695000	11842	6089	0	0	0
270456	1874	203696000	11844	6090	0	0	0
270460	1874	203697000	11848	6091	0	0	0
270463	2057	200000000	11851	6092	0	0	0
270464	1874	203698000	11851	6092	1	0	0
270476	1874	203700000	11856	6094	0	0	0
270477	1874	203701000	11856	6094	1	0	0
270480	1874	203702000	11859	6095	0	0	0
270482	1874	203703000	11861	6096	0	0	0
270486	981	504509746723918	11863	6097	0	0	0
270488	1874	203705000	11863	6097	2	0	0
270505	920	504912280012457	11864	5918	16	0	\N
270506	1040	904798479693893	11864	5918	17	0	\N
270507	1160	610485563632763	11864	5918	18	0	\N
270508	1286	1701172304412514	11864	5918	19	0	\N
270509	241	66308156237945	11864	5918	20	0	\N
270510	313	66308156237945	11864	5918	21	0	\N
270511	965	505064219226326	11864	5918	22	0	\N
270512	1085	905070753463320	11864	5918	23	0	\N
270513	1205	610669272170436	11864	5918	24	0	\N
270514	1331	1701684224587218	11864	5918	25	0	\N
270515	1678	12240386807000	11864	5918	26	0	\N
270516	1678	12240386808000	11864	5918	27	0	\N
270517	1678	12240386809000	11864	5918	28	0	\N
270518	1678	12240386810000	11864	5918	29	0	\N
270519	1678	12240386811000	11864	5918	30	0	\N
270520	1678	12240386812000	11864	5918	31	0	\N
270521	1678	12240386813000	11864	5918	32	0	\N
270522	1678	12240386814000	11864	5918	33	0	\N
270523	1678	12240386815000	11864	5918	34	0	\N
270524	1678	12240386816000	11864	5918	35	0	\N
270525	1678	12240386817000	11864	5918	36	0	\N
270526	1678	12240386818000	11864	5918	37	0	\N
270527	1678	12240386819000	11864	5918	38	0	\N
270528	1678	12240386820000	11864	5918	39	0	\N
270529	1678	12240386821000	11864	5918	40	0	\N
270530	1678	12240386822000	11864	5918	41	0	\N
270531	970	506026562600000	11864	5918	42	0	\N
270532	1336	1704926102951650	11864	5918	43	0	\N
270533	1210	611833516400000	11864	5918	44	0	\N
270534	1874	203457000	11864	5918	45	0	\N
270535	1874	203458000	11864	5918	47	0	\N
270536	1025	505330736600000	11864	5918	48	0	\N
270537	1265	610991477840000	11864	5918	49	0	\N
270538	1145	905548494760000	11864	5918	50	0	\N
270539	1391	1702582375511650	11864	5918	51	0	\N
270540	1646	0	11864	5918	52	0	\N
270541	1874	203459000	11864	5918	53	0	\N
270542	1874	203460000	11864	5918	54	0	\N
270543	1874	203461000	11864	5918	55	0	\N
270544	1874	203462000	11864	5918	56	0	\N
270545	1874	203463000	11864	5918	57	0	\N
270546	1874	203464000	11864	5918	58	0	\N
270547	1874	203465000	11864	5918	59	0	\N
270548	1874	203466000	11864	5918	60	0	\N
270549	1874	203467000	11864	5918	61	0	\N
270550	2051	200000000	11864	5918	62	0	\N
270551	2052	200000000	11864	5918	63	0	\N
270552	1874	203468000	11864	5918	64	0	\N
270553	1874	203469000	11864	5918	65	0	\N
270554	1874	203470000	11864	5918	66	0	\N
270555	1874	203471000	11864	5918	67	0	\N
270556	1874	203472000	11864	5918	68	0	\N
270557	1874	203473000	11864	5918	69	0	\N
270558	1874	203474000	11864	5918	70	0	\N
270559	1874	203475000	11864	5918	71	0	\N
270560	1874	203476000	11864	5918	72	0	\N
270561	1874	203477000	11864	5918	73	0	\N
270562	1874	203478000	11864	5918	74	0	\N
270563	1874	203479000	11864	5918	75	0	\N
270564	1874	203480000	11864	5918	76	0	\N
270565	1874	203481000	11864	5918	77	0	\N
270566	1874	203482000	11864	5918	78	0	\N
270567	1874	203483000	11864	5918	79	0	\N
270568	1874	203484000	11864	5918	80	0	\N
270569	1874	203485000	11864	5918	81	0	\N
270570	1874	203486000	11864	5918	82	0	\N
270571	1874	203487000	11864	5918	83	0	\N
270572	1874	203488000	11864	5918	84	0	\N
270573	1874	203489000	11864	5918	85	0	\N
270574	1874	203490000	11864	5918	86	0	\N
270575	1874	203491000	11864	5918	87	0	\N
270576	1874	203492000	11864	5918	88	0	\N
270577	1874	203493000	11864	5918	89	0	\N
270578	1874	203494000	11864	5918	90	0	\N
270579	1874	203495000	11864	5918	91	0	\N
270580	1874	203496000	11864	5918	92	0	\N
270581	1874	203497000	11864	5918	93	0	\N
270582	1874	203498000	11864	5918	94	0	\N
270583	1874	203499000	11864	5918	95	0	\N
270584	1874	203500000	11864	5918	96	0	\N
270585	1874	203501000	11864	5918	97	0	\N
270586	1874	203502000	11864	5918	98	0	\N
270587	1874	203503000	11864	5918	99	0	\N
270588	1874	203504000	11864	5918	100	0	\N
270589	1874	203505000	11864	5918	101	0	\N
270590	1874	203506000	11864	5918	102	0	\N
270591	1874	203507000	11864	5918	103	0	\N
270592	1874	203508000	11864	5918	104	0	\N
270593	1874	203509000	11864	5918	105	0	\N
270594	1874	203510000	11864	5918	106	0	\N
270595	1874	203511000	11864	5918	107	0	\N
270596	1874	203512000	11864	5918	108	0	\N
270597	1874	203513000	11864	5918	109	0	\N
270598	1874	203514000	11864	5918	110	0	\N
270599	1874	203515000	11864	5918	111	0	\N
270600	1874	203516000	11864	5918	112	0	\N
270601	1874	203517000	11864	5918	113	0	\N
270602	1874	203518000	11864	5918	114	0	\N
270603	1874	203519000	11864	5918	115	0	\N
270604	1874	203520000	11864	5918	116	0	\N
270605	1874	203521000	11864	5918	117	0	\N
270606	1874	203522000	11864	5918	118	0	\N
270607	1874	203523000	11864	5918	119	0	\N
270608	1874	203524000	11864	5918	120	0	\N
270609	1874	203525000	11864	5918	121	0	\N
270610	1874	203526000	11864	5918	122	0	\N
270611	1874	203527000	11864	5918	123	0	\N
270612	1874	203528000	11864	5918	124	0	\N
270613	1874	203529000	11864	5918	125	0	\N
270615	1874	203706000	11866	6098	0	0	\N
270616	1874	203707000	11867	6099	0	0	\N
270617	1874	203707000	11868	6099	0	0	\N
270624	1874	203709000	11872	6101	0	0	\N
270625	1874	203710000	11872	6101	1	0	\N
270626	1874	203711000	11872	6101	2	0	\N
270630	1874	203714000	11874	6103	0	0	\N
270631	13	4672715676666	11875	6071	0	0	\N
270632	981	504509746723918	11875	6071	1	0	\N
270633	1101	904077143489721	11875	6071	2	0	\N
270634	1221	609998863722186	11875	6071	3	0	\N
270635	19	2336860172844	11875	6071	4	0	\N
270636	203	66308156237945	11875	6071	5	0	\N
270637	241	66308156237945	11875	6071	6	0	\N
270638	313	66308156237945	11875	6071	7	0	\N
270639	965	505064219226326	11875	6071	8	0	\N
270640	1085	905070753463320	11875	6071	9	0	\N
270619	1101	904077143489721	11870	6100	0	0	0
270620	1874	203708000	11870	6100	1	0	0
270621	1874	203709000	11871	6101	0	0	0
270622	1874	203710000	11871	6101	1	0	0
270623	1874	203711000	11871	6101	2	0	0
270628	1874	203712000	11873	6102	1	0	0
270629	1874	203713000	11873	6102	2	0	0
270641	1205	610669272170436	11875	6071	11	0	\N
270642	1331	1701684224587218	11875	6071	12	0	\N
270643	1874	203662000	11875	6071	13	0	\N
270644	1874	203663000	11875	6071	14	0	\N
270645	1874	203664000	11875	6071	15	0	\N
270646	1874	203665000	11875	6071	16	0	\N
270647	1874	203666000	11875	6071	17	0	\N
270648	1874	203667000	11875	6071	18	0	\N
270649	1874	203668000	11875	6071	19	0	\N
270650	1874	203669000	11875	6071	20	0	\N
270651	1874	203670000	11875	6071	21	0	\N
270652	1874	203671000	11875	6071	22	0	\N
270653	1874	203672000	11875	6071	23	0	\N
270654	1874	203673000	11875	6071	24	0	\N
270655	1874	203674000	11875	6071	25	0	\N
270656	1874	203675000	11875	6071	26	0	\N
270657	1874	203676000	11875	6071	27	0	\N
270658	1874	203677000	11875	6071	28	0	\N
270659	1874	203678000	11875	6071	29	0	\N
270660	1874	203679000	11875	6071	30	0	\N
270661	1874	203680000	11875	6071	31	0	\N
270662	1874	203681000	11875	6071	32	0	\N
270663	1874	203682000	11875	6071	33	0	\N
270664	1874	203683000	11875	6071	34	0	\N
270665	1874	203684000	11875	6071	35	0	\N
270666	1874	203685000	11875	6071	36	0	\N
270667	1874	203686000	11875	6071	37	0	\N
270668	1874	203687000	11875	6071	38	0	\N
270669	1874	203688000	11875	6071	39	0	\N
270670	1874	203689000	11875	6071	40	0	\N
270671	2056	200000000	11875	6071	41	0	\N
270672	1874	203690000	11875	6071	42	0	\N
270673	1874	203691000	11875	6071	43	0	\N
270674	1874	203692000	11875	6071	44	0	\N
270675	1874	203693000	11875	6071	45	0	\N
270676	1874	203694000	11875	6071	46	0	\N
270677	1874	203695000	11875	6071	47	0	\N
270678	1874	203696000	11875	6071	48	0	\N
270679	1874	203697000	11875	6071	49	0	\N
270680	2057	200000000	11875	6071	50	0	\N
270681	1874	203698000	11875	6071	51	0	\N
270682	1874	203699000	11875	6071	52	0	\N
270683	1874	203700000	11875	6071	53	0	\N
270684	1874	203701000	11875	6071	54	0	\N
270685	1874	203702000	11875	6071	55	0	\N
270686	1874	203703000	11875	6071	56	0	\N
270687	1874	203704000	11875	6071	57	0	\N
270688	1874	203705000	11875	6071	58	0	\N
270689	1874	203706000	11875	6071	59	0	\N
270690	1874	203707000	11875	6071	60	0	\N
270691	1874	203708000	11875	6071	61	0	\N
270692	1874	203709000	11875	6071	62	0	\N
270693	1874	203710000	11875	6071	63	0	\N
270694	1874	203711000	11875	6071	64	0	\N
270695	1874	203712000	11875	6071	65	0	\N
270696	1874	203713000	11875	6071	66	0	\N
270697	1874	203714000	11875	6071	67	0	\N
270700	13	4672715676666	11878	6035	0	0	\N
270701	981	504509746723918	11878	6035	1	0	\N
270702	1101	904077143489721	11878	6035	2	0	\N
270703	1221	609998863722186	11878	6035	3	0	\N
270704	1347	1699816071836729	11878	6035	4	0	\N
270705	1771	304915534083	11878	6035	5	0	\N
270706	1347	1699816071836729	11879	6105	0	0	\N
270707	1874	203716000	11879	6105	1	0	\N
270708	1347	1699816071836729	11880	6105	0	0	\N
270709	1874	203716000	11880	6105	1	0	\N
270712	1874	203717000	11882	6106	0	0	\N
270713	1874	203718000	11882	6106	1	0	\N
270714	1874	203719000	11882	6106	2	0	\N
270715	1874	203720000	11882	6106	3	0	\N
270716	1874	203717000	11883	6106	0	0	\N
270717	1874	203718000	11883	6106	1	0	\N
270718	1874	203719000	11883	6106	2	0	\N
270719	1874	203720000	11883	6106	3	0	\N
270726	1874	203722000	11887	6108	0	0	\N
270728	1874	203723000	11889	6109	0	0	\N
270734	411	66008410000000	11894	5909	0	0	\N
270735	13	4672715676666	11894	5909	1	0	\N
270736	981	504509746723918	11894	5909	2	0	\N
270737	1101	904077143489721	11894	5909	3	0	\N
270738	1221	609998863722186	11894	5909	4	0	\N
270739	1347	1699816071836729	11894	5909	5	0	\N
270740	1771	304915534083	11894	5909	6	0	\N
270741	195	66300806891531	11894	5909	7	0	\N
270742	2053	1000000000	11894	5909	8	0	\N
270743	19	2336860172844	11894	5909	9	0	\N
270744	1090	906795935800000	11894	5909	10	0	\N
270745	203	66308156237945	11894	5909	11	0	\N
270746	291	66300806891531	11894	5909	12	0	\N
270747	1023	505067760241128	11894	5909	13	0	\N
270748	1143	905077098931514	11894	5909	14	0	\N
270749	1263	610673553584273	11894	5909	15	0	\N
270750	1389	1701696155127528	11894	5909	16	0	\N
270751	920	504912280012457	11894	5909	17	0	\N
270752	1040	904798479693893	11894	5909	18	0	\N
270753	1160	610485563632763	11894	5909	19	0	\N
270754	1286	1701172304412514	11894	5909	20	0	\N
270755	241	66308156237945	11894	5909	21	0	\N
270756	313	66308156237945	11894	5909	22	0	\N
270757	965	505064219226326	11894	5909	23	0	\N
270758	1085	905070753463320	11894	5909	24	0	\N
270759	1205	610669272170436	11894	5909	25	0	\N
270760	1331	1701684224587218	11894	5909	26	0	\N
270761	970	506026562600000	11894	5909	27	0	\N
270762	1336	1704926102951650	11894	5909	28	0	\N
270763	1210	611833516400000	11894	5909	29	0	\N
270764	1874	203529000	11894	5909	30	0	\N
270765	1874	203530000	11894	5909	31	0	\N
270766	1874	203531000	11894	5909	32	0	\N
270767	1874	203532000	11894	5909	33	0	\N
270768	1874	203533000	11894	5909	34	0	\N
270769	1874	203534000	11894	5909	35	0	\N
270770	1874	203535000	11894	5909	36	0	\N
270771	1646	0	11894	5909	37	0	\N
270772	1874	203536000	11894	5909	38	0	\N
270773	1874	203537000	11894	5909	39	0	\N
270774	1874	203538000	11894	5909	40	0	\N
270775	1874	203539000	11894	5909	41	0	\N
270776	1874	203540000	11894	5909	42	0	\N
270710	1347	1699816071836729	11881	6105	0	0	0
270711	1874	203716000	11881	6105	1	0	0
270720	1874	203717000	11884	6106	0	0	0
270721	1874	203718000	11884	6106	1	0	0
270722	1874	203719000	11884	6106	2	0	0
270724	1874	203721000	11885	6107	0	0	0
270725	1874	203722000	11886	6108	0	0	0
270727	1874	203723000	11888	6109	0	0	0
270729	1874	203724000	11890	6110	0	0	0
270730	1874	203725000	11891	6111	0	0	0
270732	1874	203727000	11893	6113	0	0	0
270733	1874	203728000	11893	6113	1	0	0
270777	1874	203541000	11894	5909	43	0	\N
270778	1874	203542000	11894	5909	44	0	\N
270779	1874	203543000	11894	5909	45	0	\N
270780	1874	203544000	11894	5909	46	0	\N
270781	1874	203545000	11894	5909	47	0	\N
270782	1874	203546000	11894	5909	48	0	\N
270783	1874	203547000	11894	5909	49	0	\N
270784	1874	203548000	11894	5909	50	0	\N
270785	1874	203549000	11894	5909	51	0	\N
270786	1874	203550000	11894	5909	52	0	\N
270787	1874	203551000	11894	5909	53	0	\N
270788	1874	203552000	11894	5909	54	0	\N
270789	1874	203553000	11894	5909	55	0	\N
270790	1874	203554000	11894	5909	56	0	\N
270791	1874	203555000	11894	5909	57	0	\N
270792	1874	203556000	11894	5909	58	0	\N
270793	1874	203557000	11894	5909	59	0	\N
270794	1874	203558000	11894	5909	60	0	\N
270795	1874	203559000	11894	5909	61	0	\N
270796	1874	203560000	11894	5909	62	0	\N
270797	1874	203561000	11894	5909	63	0	\N
270798	1874	203562000	11894	5909	64	0	\N
270799	1874	203563000	11894	5909	65	0	\N
270800	1874	203564000	11894	5909	66	0	\N
270801	1874	203565000	11894	5909	67	0	\N
270802	1874	203566000	11894	5909	68	0	\N
270803	1874	203567000	11894	5909	69	0	\N
270804	1874	203568000	11894	5909	70	0	\N
270805	1874	203569000	11894	5909	71	0	\N
270806	1874	203570000	11894	5909	72	0	\N
270807	1874	203571000	11894	5909	73	0	\N
270808	1874	203572000	11894	5909	74	0	\N
270809	1874	203573000	11894	5909	75	0	\N
270810	1874	203574000	11894	5909	76	0	\N
270811	1874	203575000	11894	5909	77	0	\N
270812	1874	203576000	11894	5909	78	0	\N
270813	1874	203577000	11894	5909	79	0	\N
270814	1874	203578000	11894	5909	80	0	\N
270815	1874	203579000	11894	5909	81	0	\N
270816	1874	203580000	11894	5909	82	0	\N
270817	1874	203581000	11894	5909	83	0	\N
270818	1874	203582000	11894	5909	84	0	\N
270819	1874	203583000	11894	5909	85	0	\N
270820	1874	203584000	11894	5909	86	0	\N
270821	1874	203585000	11894	5909	87	0	\N
270822	1874	203586000	11894	5909	88	0	\N
270823	1874	203587000	11894	5909	89	0	\N
270824	1874	203588000	11894	5909	90	0	\N
270825	1874	203589000	11894	5909	91	0	\N
270826	1874	203590000	11894	5909	92	0	\N
270827	1874	203591000	11894	5909	93	0	\N
270828	1874	203592000	11894	5909	96	0	\N
270829	1874	203593000	11894	5909	97	0	\N
270830	1874	203594000	11894	5909	98	0	\N
270831	1874	203595000	11894	5909	99	0	\N
270832	1874	203596000	11894	5909	100	0	\N
270833	1874	203597000	11894	5909	101	0	\N
270834	1874	203598000	11894	5909	102	0	\N
270835	1874	203599000	11894	5909	103	0	\N
270836	1874	203600000	11894	5909	104	0	\N
270837	1874	203601000	11894	5909	105	0	\N
270838	1874	203602000	11894	5909	106	0	\N
270839	1874	203603000	11894	5909	107	0	\N
270840	1874	203604000	11894	5909	108	0	\N
270841	1874	203605000	11894	5909	109	0	\N
270842	1874	203606000	11894	5909	110	0	\N
270843	1874	203607000	11894	5909	111	0	\N
270844	1874	203608000	11894	5909	112	0	\N
270845	1874	203609000	11894	5909	113	0	\N
270846	1874	203610000	11894	5909	114	0	\N
270847	1874	203611000	11894	5909	115	0	\N
270848	1874	203612000	11894	5909	116	0	\N
270849	1874	203613000	11894	5909	117	0	\N
270850	1874	203614000	11894	5909	118	0	\N
270851	2054	200000000	11894	5909	119	0	\N
270852	1874	203615000	11894	5909	120	0	\N
270853	1874	203616000	11894	5909	121	0	\N
270854	1874	203617000	11894	5909	122	0	\N
270855	1874	203618000	11894	5909	123	0	\N
270856	1874	203619000	11894	5909	124	0	\N
270857	1874	203620000	11894	5909	125	0	\N
270866	1874	203735000	11900	6118	0	0	\N
270867	1874	203736000	11900	6118	1	0	\N
270871	1874	203738000	11903	6120	0	0	\N
270872	1874	203739000	11903	6120	1	0	\N
270880	1874	203747000	11911	6128	0	0	\N
270881	1874	203747000	11912	6128	0	0	\N
270884	13	4672715676666	11915	6024	0	0	\N
270885	981	504509746723918	11915	6024	1	0	\N
270886	1101	904077143489721	11915	6024	2	0	\N
270887	1221	609998863722186	11915	6024	3	0	\N
270888	1347	1699816071836729	11915	6024	4	0	\N
270889	1771	304915534083	11915	6024	5	0	\N
270890	195	66300806891531	11915	6024	6	0	\N
270891	19	2336860172844	11915	6024	7	0	\N
270892	1090	906795935800000	11915	6024	8	0	\N
270893	203	66308156237945	11915	6024	9	0	\N
270894	291	66300806891531	11915	6024	10	0	\N
270895	1023	505067760241128	11915	6024	11	0	\N
270896	1143	905077098931514	11915	6024	12	0	\N
270897	1263	610673553584273	11915	6024	13	0	\N
270898	1389	1701696155127528	11915	6024	14	0	\N
270899	241	66308156237945	11915	6024	15	0	\N
270900	313	66308156237945	11915	6024	16	0	\N
270901	965	505064219226326	11915	6024	17	0	\N
270902	1085	905070753463320	11915	6024	18	0	\N
270903	1205	610669272170436	11915	6024	19	0	\N
270904	1331	1701684224587218	11915	6024	20	0	\N
270905	970	506026562600000	11915	6024	21	0	\N
270906	1336	1704926102951650	11915	6024	22	0	\N
270907	1210	611833516400000	11915	6024	23	0	\N
270908	1646	0	11915	6024	24	0	\N
270909	1874	203749000	11916	6130	0	0	\N
270860	1874	203731000	11896	6115	0	0	0
270861	1874	203732000	11897	6116	0	0	0
270862	1874	203733000	11897	6116	1	0	0
270863	1874	203734000	11898	6117	0	0	0
270864	1874	203735000	11899	6118	0	0	0
270868	1874	203737000	11901	6119	0	0	0
270869	1874	203738000	11902	6120	0	0	0
270870	1874	203739000	11902	6120	1	0	0
270873	1874	203740000	11904	6121	0	0	0
270874	1874	203741000	11905	6122	0	0	0
270876	1874	203743000	11907	6124	0	0	0
270877	1874	203744000	11908	6125	0	0	0
270878	1874	203745000	11909	6126	0	0	0
270879	1874	203746000	11910	6127	0	0	0
270883	1874	203748000	11914	6129	0	0	0
270910	1874	203749000	11917	6130	0	0	0
270911	1874	203750000	11918	6131	0	0	0
270912	1874	203751000	11919	6132	0	0	0
270913	1874	203751000	11920	6132	0	0	\N
270924	1874	203761000	11929	6140	0	0	\N
270925	1874	203762000	11930	6141	0	0	\N
270926	1874	203763000	11930	6141	1	0	\N
270927	1874	203764000	11930	6141	2	0	\N
270931	1874	203765000	11932	6142	0	0	\N
270933	1874	203735000	11934	6118	0	0	\N
270934	1874	203736000	11934	6118	1	0	\N
270935	1874	203737000	11934	6118	2	0	\N
270936	1874	203738000	11934	6118	3	0	\N
270937	1874	203739000	11934	6118	4	0	\N
270938	1874	203740000	11934	6118	5	0	\N
270939	1874	203741000	11934	6118	6	0	\N
270940	1874	203742000	11934	6118	7	0	\N
270941	1874	203743000	11934	6118	8	0	\N
270942	1874	203744000	11934	6118	9	0	\N
270943	1874	203745000	11934	6118	10	0	\N
270944	1874	203746000	11934	6118	11	0	\N
270945	1874	203747000	11934	6118	12	0	\N
270946	1874	203748000	11934	6118	13	0	\N
270947	1874	203749000	11934	6118	14	0	\N
270948	1874	203750000	11934	6118	15	0	\N
270949	1874	203751000	11934	6118	16	0	\N
270950	1874	203752000	11934	6118	17	0	\N
270951	1874	203753000	11934	6118	18	0	\N
270952	1874	203754000	11934	6118	19	0	\N
270953	1874	203755000	11934	6118	20	0	\N
270954	1874	203756000	11934	6118	21	0	\N
270955	1874	203757000	11934	6118	22	0	\N
270956	1874	203758000	11934	6118	23	0	\N
270957	1874	203759000	11934	6118	24	0	\N
270958	1874	203760000	11934	6118	25	0	\N
270959	1874	203761000	11934	6118	26	0	\N
270960	1874	203762000	11934	6118	27	0	\N
270961	1874	203763000	11934	6118	28	0	\N
270962	1874	203764000	11934	6118	29	0	\N
270963	1874	203765000	11934	6118	30	0	\N
270964	1874	203766000	11934	6118	31	0	\N
270966	1874	203766000	11936	6143	0	0	\N
270972	1318	1693980637751650	11941	6148	0	0	\N
270973	1874	203772000	11941	6148	1	0	\N
270974	1874	203773000	11941	6148	2	0	\N
270975	1072	906750465000000	11941	6148	3	0	\N
270976	1192	611801750000000	11941	6148	4	0	\N
270977	952	505841775000000	11941	6148	5	0	\N
270978	1874	203774000	11941	6148	6	0	\N
270979	1874	203775000	11941	6148	7	0	\N
270988	1874	203776000	11943	6149	0	0	\N
270993	1318	1693980637751650	11947	6138	0	0	\N
270994	1072	900973465000000	11947	6138	1	0	\N
270995	1192	607904750000000	11947	6138	2	0	\N
270996	952	502777775000000	11947	6138	3	0	\N
270997	1318	1704299637751650	11947	6138	4	0	\N
270998	1874	203779000	11948	6152	0	0	\N
270999	1874	203780000	11948	6152	1	0	\N
271000	1874	203779000	11949	6152	0	0	\N
271001	1874	203780000	11949	6152	1	0	\N
271002	1318	1693980637751650	11951	5910	0	0	\N
271003	1072	900973465000000	11951	5910	1	0	\N
271004	1192	607904750000000	11951	5910	2	0	\N
271005	952	502777775000000	11951	5910	3	0	\N
271006	1874	203621000	11951	5910	4	0	\N
271007	1318	1704299637751650	11951	5910	5	0	\N
271008	1874	203622000	11951	5910	6	0	\N
271009	1874	203623000	11951	5910	7	0	\N
271010	1874	203624000	11951	5910	8	0	\N
271011	1874	203625000	11951	5910	9	0	\N
271012	1874	203626000	11951	5910	10	0	\N
271013	1874	203627000	11951	5910	11	0	\N
271014	1874	203628000	11951	5910	12	0	\N
271015	1874	203629000	11951	5910	13	0	\N
271016	1874	203630000	11951	5910	14	0	\N
271017	1874	203631000	11951	5910	15	0	\N
271018	1318	1693980637751650	11952	6119	0	0	\N
271019	1072	900973465000000	11952	6119	1	0	\N
271020	1192	607904750000000	11952	6119	2	0	\N
271021	952	502777775000000	11952	6119	3	0	\N
271022	1874	203767000	11952	6119	4	0	\N
271023	1874	203768000	11952	6119	5	0	\N
271024	1874	203769000	11952	6119	6	0	\N
271025	1874	203770000	11952	6119	7	0	\N
271026	1318	1704299637751650	11952	6119	8	0	\N
271027	1874	203771000	11952	6119	9	0	\N
271028	1874	203772000	11952	6119	10	0	\N
271029	1874	203773000	11952	6119	11	0	\N
271030	1874	203774000	11952	6119	12	0	\N
271031	1874	203775000	11952	6119	13	0	\N
271032	1874	203776000	11952	6119	14	0	\N
271033	1874	203777000	11952	6119	15	0	\N
271034	1874	203778000	11952	6119	16	0	\N
271035	1874	203779000	11952	6119	17	0	\N
271036	1874	203780000	11952	6119	18	0	\N
271037	1874	203781000	11952	6119	19	0	\N
271038	1874	203779000	11953	6153	0	0	\N
271039	1874	203780000	11953	6153	1	0	\N
271040	1874	203781000	11953	6153	2	0	\N
271041	1874	203782000	11953	6153	3	0	\N
271046	1874	203783000	11955	6154	0	0	\N
271047	1874	203784000	11955	6154	1	0	\N
270916	1874	203754000	11922	6134	0	0	0
270917	1874	203755000	11923	6135	0	0	0
270918	1874	203756000	11924	6136	0	0	0
270919	1874	203757000	11925	6137	0	0	0
270920	1874	203758000	11925	6137	1	0	0
270922	1874	203760000	11927	6139	0	0	0
270923	1874	203761000	11928	6140	0	0	0
270928	1874	203762000	11931	6141	0	0	0
270929	1874	203763000	11931	6141	1	0	0
270930	1874	203764000	11931	6141	2	0	0
270965	1874	203766000	11935	6143	0	0	0
270967	1874	203767000	11938	6145	0	0	0
270968	1874	203768000	11938	6145	1	0	0
270969	1874	203769000	11938	6145	2	0	0
270971	1874	203771000	11940	6147	1	0	0
270980	1318	1693980637751650	11942	6148	0	0	0
270981	1874	203772000	11942	6148	1	0	0
270982	1874	203773000	11942	6148	2	0	0
270983	1072	906750465000000	11942	6148	3	0	0
270985	952	505841775000000	11942	6148	5	0	0
270986	1874	203774000	11942	6148	6	0	0
270987	1874	203775000	11942	6148	7	0	0
270989	1874	203776000	11944	6149	0	0	0
270990	1874	203777000	11945	6150	0	0	0
270992	1318	1704299637751650	11946	6151	1	0	0
271042	1874	203779000	11954	6153	0	0	0
271043	1874	203780000	11954	6153	1	0	0
271044	1874	203781000	11954	6153	2	0	0
271048	1874	203783000	11956	6154	0	0	0
271051	1874	203785000	11958	6155	0	0	\N
271056	1874	203788000	11961	6157	0	0	\N
271057	1874	203789000	11961	6157	1	0	\N
271058	1318	1693980637751650	11962	6124	0	0	\N
271059	1072	900973465000000	11962	6124	1	0	\N
271060	1192	607904750000000	11962	6124	2	0	\N
271061	952	502777775000000	11962	6124	3	0	\N
271062	1318	1704299637751650	11962	6124	4	0	\N
271063	1874	203790000	11963	6158	0	0	\N
271064	1874	203790000	11964	6158	0	0	\N
271065	1874	203790000	11965	6158	0	0	\N
271066	1874	203790000	11966	6158	0	0	\N
271069	1874	203792000	11969	6160	0	0	\N
271070	1874	203793000	11969	6160	1	0	\N
271071	1874	203792000	11970	6160	0	0	\N
271072	1874	203793000	11970	6160	1	0	\N
271076	1874	203795000	11973	6162	0	0	\N
271081	1874	203797000	11977	6164	0	0	\N
271082	1874	203798000	11977	6164	1	0	\N
271083	1874	203797000	11978	6164	0	0	\N
271084	1874	203798000	11978	6164	1	0	\N
271086	1874	203800000	11980	6166	0	0	\N
271089	1874	203802000	11983	6168	0	0	\N
271092	1874	203804000	11986	6170	0	0	\N
271093	1874	203804000	11987	6170	0	0	\N
271094	1874	203804000	11988	6170	0	0	\N
271096	1874	203805000	11990	6171	0	0	\N
271097	1874	203806000	11990	6171	1	0	\N
271102	1874	203808000	11994	6173	0	0	\N
271103	1874	203808000	11995	6173	0	0	\N
271104	1874	203809000	11996	6174	0	0	\N
271105	1874	203809000	11997	6174	0	0	\N
271108	2047	0	12000	6176	0	0	\N
271109	1874	203811000	12000	6176	1	0	\N
271114	1874	203812000	12003	6177	0	0	\N
271119	1874	203818000	12006	6180	0	0	\N
271120	1874	203818000	12007	6180	0	0	\N
271122	1874	203818000	12009	6180	0	0	\N
271131	1318	1693980637751650	12013	6072	0	0	\N
271132	1072	900973465000000	12013	6072	1	0	\N
271133	1192	607904750000000	12013	6072	2	0	\N
271134	952	502777775000000	12013	6072	3	0	\N
271135	1347	1699816071836729	12013	6072	4	0	\N
271136	2047	0	12013	6072	5	0	\N
271137	2047	10000000	12013	6072	6	0	\N
271138	1318	1704299637751650	12013	6072	7	0	\N
271139	2047	30000000	12013	6072	8	0	\N
271140	1874	203715000	12013	6072	9	0	\N
271141	1874	203716000	12013	6072	10	0	\N
271142	1874	203717000	12013	6072	11	0	\N
271143	1874	203718000	12013	6072	12	0	\N
271144	1874	203719000	12013	6072	13	0	\N
271145	1874	203720000	12013	6072	14	0	\N
271146	1874	203721000	12013	6072	15	0	\N
271147	1874	203722000	12013	6072	16	0	\N
271148	1874	203723000	12013	6072	17	0	\N
271149	1874	203724000	12013	6072	18	0	\N
271150	1874	203725000	12013	6072	19	0	\N
271151	1874	203726000	12013	6072	20	0	\N
271152	1874	203727000	12013	6072	21	0	\N
271153	1874	203728000	12013	6072	22	0	\N
271154	1874	203729000	12013	6072	23	0	\N
271155	1874	203730000	12013	6072	24	0	\N
271156	1874	203731000	12013	6072	25	0	\N
271157	1874	203732000	12013	6072	26	0	\N
271158	1874	203733000	12013	6072	27	0	\N
271159	1874	203734000	12013	6072	28	0	\N
271160	1874	203735000	12013	6072	29	0	\N
271161	1874	203736000	12013	6072	30	0	\N
271162	1874	203737000	12013	6072	31	0	\N
271163	1874	203738000	12013	6072	32	0	\N
271164	1874	203739000	12013	6072	33	0	\N
271165	1874	203740000	12013	6072	34	0	\N
271166	1874	203741000	12013	6072	35	0	\N
271167	1874	203742000	12013	6072	36	0	\N
271168	1874	203743000	12013	6072	37	0	\N
271169	1874	203744000	12013	6072	38	0	\N
271170	1874	203745000	12013	6072	39	0	\N
271171	1874	203746000	12013	6072	40	0	\N
271172	1874	203747000	12013	6072	41	0	\N
271173	1874	203748000	12013	6072	42	0	\N
271174	1874	203749000	12013	6072	43	0	\N
271175	1874	203750000	12013	6072	44	0	\N
271176	1874	203751000	12013	6072	45	0	\N
271177	1874	203752000	12013	6072	46	0	\N
271178	1874	203753000	12013	6072	47	0	\N
271179	1874	203754000	12013	6072	48	0	\N
271180	1874	203755000	12013	6072	49	0	\N
271181	1874	203756000	12013	6072	50	0	\N
271182	1874	203757000	12013	6072	51	0	\N
271183	1874	203758000	12013	6072	52	0	\N
271184	1874	203759000	12013	6072	53	0	\N
271052	1874	203786000	11959	6156	0	0	0
271053	1874	203787000	11959	6156	1	0	0
271054	1874	203788000	11960	6157	0	0	0
271055	1874	203789000	11960	6157	1	0	0
271067	1874	203790000	11967	6158	0	0	0
271073	1874	203792000	11971	6160	0	0	0
271074	1874	203793000	11971	6160	1	0	0
271075	1874	203794000	11972	6161	0	0	0
271077	1874	203795000	11974	6162	0	0	0
271078	1874	203796000	11975	6163	0	0	0
271080	1874	203798000	11976	6164	1	0	0
271085	1874	203799000	11979	6165	0	0	0
271087	1874	203800000	11981	6166	0	0	0
271088	1874	203801000	11982	6167	0	0	0
271091	1874	203803000	11985	6169	0	0	0
271095	1874	203804000	11989	6170	0	0	0
271098	1874	203805000	11991	6171	0	0	0
271099	1874	203806000	11991	6171	1	0	0
271100	1874	203807000	11992	6172	0	0	0
271106	1874	203809000	11998	6174	0	0	0
271107	1874	203810000	11999	6175	0	0	0
271110	2047	0	12001	6176	0	0	0
271111	1874	203811000	12001	6176	1	0	0
271112	1874	203812000	12002	6177	0	0	0
271115	1874	203814000	12004	6178	0	0	0
271116	1874	203815000	12004	6178	1	0	0
271117	1874	203816000	12004	6178	2	0	0
271118	1874	203817000	12005	6179	0	0	0
271123	1874	203819000	12010	6181	0	0	0
271124	1874	203820000	12011	6182	0	0	0
271125	2047	10000000	12011	6182	1	0	0
271126	2047	30000000	12011	6182	2	0	0
271127	1874	203821000	12011	6182	3	0	0
271129	1874	203823000	12011	6182	5	0	0
271130	1874	203824000	12012	6183	0	0	0
271185	1874	203760000	12013	6072	54	0	\N
271186	1874	203761000	12013	6072	55	0	\N
271187	1874	203762000	12013	6072	56	0	\N
271188	1874	203763000	12013	6072	57	0	\N
271189	1874	203764000	12013	6072	58	0	\N
271190	1874	203765000	12013	6072	59	0	\N
271191	1874	203766000	12013	6072	60	0	\N
271192	1874	203767000	12013	6072	61	0	\N
271193	1874	203768000	12013	6072	62	0	\N
271194	1874	203769000	12013	6072	63	0	\N
271195	1874	203770000	12013	6072	64	0	\N
271196	1874	203771000	12013	6072	65	0	\N
271197	1874	203772000	12013	6072	66	0	\N
271198	1874	203773000	12013	6072	67	0	\N
271199	1874	203774000	12013	6072	69	0	\N
271200	1874	203775000	12013	6072	70	0	\N
271201	1874	203776000	12013	6072	71	0	\N
271202	1874	203777000	12013	6072	72	0	\N
271203	1874	203778000	12013	6072	73	0	\N
271204	1874	203779000	12013	6072	74	0	\N
271205	1874	203780000	12013	6072	75	0	\N
271206	1874	203781000	12013	6072	76	0	\N
271207	1874	203782000	12013	6072	77	0	\N
271208	1874	203783000	12013	6072	78	0	\N
271209	1874	203784000	12013	6072	79	0	\N
271210	1874	203785000	12013	6072	80	0	\N
271211	1874	203786000	12013	6072	81	0	\N
271212	1874	203787000	12013	6072	82	0	\N
271213	1874	203788000	12013	6072	83	0	\N
271214	1874	203789000	12013	6072	84	0	\N
271215	1874	203790000	12013	6072	85	0	\N
271216	1874	203791000	12013	6072	86	0	\N
271217	1874	203792000	12013	6072	87	0	\N
271218	1874	203793000	12013	6072	88	0	\N
271219	1874	203794000	12013	6072	89	0	\N
271220	1874	203795000	12013	6072	90	0	\N
271221	1874	203796000	12013	6072	91	0	\N
271222	1874	203797000	12013	6072	92	0	\N
271223	1874	203798000	12013	6072	93	0	\N
271224	1874	203799000	12013	6072	94	0	\N
271225	1874	203800000	12013	6072	95	0	\N
271226	1874	203801000	12013	6072	96	0	\N
271227	1874	203802000	12013	6072	97	0	\N
271228	1874	203803000	12013	6072	98	0	\N
271229	1874	203804000	12013	6072	99	0	\N
271230	1874	203805000	12013	6072	100	0	\N
271231	1874	203806000	12013	6072	101	0	\N
271232	1874	203807000	12013	6072	102	0	\N
271233	1874	203808000	12013	6072	103	0	\N
271234	1874	203809000	12013	6072	104	0	\N
271235	1874	203810000	12013	6072	105	0	\N
271236	1874	203811000	12013	6072	106	0	\N
271237	1874	203812000	12013	6072	107	0	\N
271238	1874	203813000	12013	6072	108	0	\N
271239	1874	203814000	12013	6072	109	0	\N
271240	1874	203815000	12013	6072	110	0	\N
271241	1874	203816000	12013	6072	111	0	\N
271242	1874	203817000	12013	6072	112	0	\N
271243	1874	203818000	12013	6072	113	0	\N
271244	1874	203819000	12013	6072	114	0	\N
271245	1874	203820000	12013	6072	115	0	\N
271246	1874	203821000	12013	6072	116	0	\N
271247	1874	203822000	12013	6072	117	0	\N
271248	1874	203823000	12013	6072	118	0	\N
271249	1874	203824000	12013	6072	119	0	\N
271250	1874	203824000	12014	6183	0	0	\N
271251	1318	1693980637751650	12015	6134	0	0	\N
271252	1072	900973465000000	12015	6134	1	0	\N
271253	1192	607904750000000	12015	6134	2	0	\N
271254	952	502777775000000	12015	6134	3	0	\N
271255	2047	0	12015	6134	4	0	\N
271256	1874	203754000	12015	6134	5	0	\N
271257	1874	203755000	12015	6134	6	0	\N
271258	1874	203756000	12015	6134	7	0	\N
271259	1874	203757000	12015	6134	8	0	\N
271260	2047	10000000	12015	6134	9	0	\N
271261	1874	203758000	12015	6134	10	0	\N
271262	1874	203759000	12015	6134	11	0	\N
271263	1874	203760000	12015	6134	12	0	\N
271264	1318	1704299637751650	12015	6134	13	0	\N
271265	2047	30000000	12015	6134	14	0	\N
271266	1874	203761000	12015	6134	15	0	\N
271267	1874	203762000	12015	6134	16	0	\N
271268	1874	203763000	12015	6134	17	0	\N
271269	1874	203764000	12015	6134	18	0	\N
271270	1874	203765000	12015	6134	19	0	\N
271271	1874	203766000	12015	6134	20	0	\N
271272	1874	203767000	12015	6134	21	0	\N
271273	1874	203768000	12015	6134	22	0	\N
271274	1874	203769000	12015	6134	23	0	\N
271275	1874	203770000	12015	6134	24	0	\N
271276	1874	203771000	12015	6134	25	0	\N
271277	1874	203772000	12015	6134	26	0	\N
271278	1874	203773000	12015	6134	27	0	\N
271279	1874	203774000	12015	6134	28	0	\N
271280	1874	203775000	12015	6134	29	0	\N
271281	1874	203776000	12015	6134	30	0	\N
271282	1874	203777000	12015	6134	31	0	\N
271283	1874	203778000	12015	6134	32	0	\N
271284	1874	203779000	12015	6134	34	0	\N
271285	1874	203780000	12015	6134	35	0	\N
271286	1874	203781000	12015	6134	36	0	\N
271287	1874	203782000	12015	6134	37	0	\N
271288	1874	203783000	12015	6134	38	0	\N
271289	1874	203784000	12015	6134	39	0	\N
271290	1874	203785000	12015	6134	40	0	\N
271291	1874	203786000	12015	6134	41	0	\N
271292	1874	203787000	12015	6134	42	0	\N
271293	1874	203788000	12015	6134	43	0	\N
271294	1874	203789000	12015	6134	44	0	\N
271295	1874	203790000	12015	6134	45	0	\N
271296	1874	203791000	12015	6134	46	0	\N
271297	1874	203792000	12015	6134	47	0	\N
271298	1874	203793000	12015	6134	48	0	\N
271299	1874	203794000	12015	6134	49	0	\N
271300	1874	203795000	12015	6134	50	0	\N
271301	1874	203796000	12015	6134	51	0	\N
271302	1874	203797000	12015	6134	52	0	\N
271303	1874	203798000	12015	6134	53	0	\N
271304	1874	203799000	12015	6134	54	0	\N
271305	1874	203800000	12015	6134	55	0	\N
271306	1874	203801000	12015	6134	56	0	\N
271307	1874	203802000	12015	6134	57	0	\N
271308	1874	203803000	12015	6134	58	0	\N
271309	1874	203804000	12015	6134	59	0	\N
271310	1874	203805000	12015	6134	60	0	\N
271311	1874	203806000	12015	6134	61	0	\N
271312	1874	203807000	12015	6134	62	0	\N
271313	1874	203808000	12015	6134	63	0	\N
271314	1874	203809000	12015	6134	64	0	\N
271315	1874	203810000	12015	6134	65	0	\N
271316	1874	203811000	12015	6134	66	0	\N
271317	1874	203812000	12015	6134	67	0	\N
271318	1874	203813000	12015	6134	68	0	\N
271319	1874	203814000	12015	6134	69	0	\N
271320	1874	203815000	12015	6134	70	0	\N
271321	1874	203816000	12015	6134	71	0	\N
271322	1874	203817000	12015	6134	72	0	\N
271323	1874	203818000	12015	6134	73	0	\N
271324	1874	203819000	12015	6134	74	0	\N
271325	1874	203820000	12015	6134	75	0	\N
271326	1874	203821000	12015	6134	76	0	\N
271327	1874	203822000	12015	6134	77	0	\N
271328	1874	203823000	12015	6134	78	0	\N
271329	1874	203824000	12015	6134	79	0	\N
271333	1874	203828000	12018	6186	0	0	\N
271334	1874	203828000	12019	6186	0	0	\N
271335	1874	203828000	12020	6186	0	0	\N
271336	1874	203828000	12021	6186	0	0	\N
271344	2047	0	12027	6125	0	0	\N
271345	2047	10000000	12027	6125	1	0	\N
271346	2047	30000000	12027	6125	2	0	\N
271347	1874	203835000	12028	6191	0	0	\N
271348	1874	203835000	12029	6191	0	0	\N
271349	1874	203835000	12030	6191	0	0	\N
271358	1874	203842000	12037	6197	0	0	\N
271360	1874	203842000	12039	6197	0	0	\N
271361	1874	203843000	12040	6198	0	0	\N
271364	1874	203845000	12043	6200	0	0	\N
271366	1874	203845000	12045	6200	0	0	\N
271367	1874	203846000	12046	6201	0	0	\N
271369	1874	203847000	12048	6202	0	0	\N
271371	1874	203847000	12050	6202	0	0	\N
271372	1874	203847000	12051	6202	0	0	\N
271377	1874	203851000	12054	6205	0	0	\N
271378	1874	203851000	12055	6205	0	0	\N
271380	1874	203851000	12057	6205	0	0	\N
271382	1449	8053016459	12059	6164	0	0	\N
271383	2047	0	12059	6164	1	0	\N
271384	2058	586000000	12059	6164	2	0	\N
271385	1874	203797000	12059	6164	3	0	\N
271386	2047	10000000	12059	6164	4	0	\N
271387	2047	30000000	12059	6164	6	0	\N
271388	1874	203798000	12059	6164	7	0	\N
271389	1874	203799000	12059	6164	8	0	\N
271390	1874	203800000	12059	6164	9	0	\N
271391	1874	203801000	12059	6164	10	0	\N
271392	1874	203802000	12059	6164	11	0	\N
271393	1874	203803000	12059	6164	12	0	\N
271394	1874	203804000	12059	6164	13	0	\N
271395	1874	203805000	12059	6164	14	0	\N
271396	1874	203806000	12059	6164	15	0	\N
271397	1874	203807000	12059	6164	16	0	\N
271398	1874	203808000	12059	6164	17	0	\N
271399	1874	203809000	12059	6164	18	0	\N
271400	1874	203810000	12059	6164	19	0	\N
271401	1874	203811000	12059	6164	20	0	\N
271402	1874	203812000	12059	6164	21	0	\N
271403	1874	203813000	12059	6164	22	0	\N
271404	1874	203814000	12059	6164	23	0	\N
271405	1874	203815000	12059	6164	24	0	\N
271406	1874	203816000	12059	6164	25	0	\N
271407	1874	203817000	12059	6164	26	0	\N
271408	1874	203818000	12059	6164	27	0	\N
271409	1874	203819000	12059	6164	28	0	\N
271410	1874	203820000	12059	6164	29	0	\N
271411	1874	203821000	12059	6164	30	0	\N
271412	1874	203822000	12059	6164	31	0	\N
271413	1874	203823000	12059	6164	32	0	\N
271414	1874	203824000	12059	6164	33	0	\N
271415	1874	203825000	12059	6164	34	0	\N
271416	1874	203826000	12059	6164	35	0	\N
271417	1874	203827000	12059	6164	36	0	\N
271418	1874	203828000	12059	6164	37	0	\N
271419	1874	203829000	12059	6164	38	0	\N
271420	1874	203830000	12059	6164	39	0	\N
271421	1874	203831000	12059	6164	40	0	\N
271422	1874	203832000	12059	6164	41	0	\N
271423	1874	203833000	12059	6164	42	0	\N
271424	1874	203834000	12059	6164	43	0	\N
271425	1874	203835000	12059	6164	44	0	\N
271426	1874	203836000	12059	6164	45	0	\N
271427	1874	203837000	12059	6164	46	0	\N
271428	1874	203838000	12059	6164	47	0	\N
271429	1874	203839000	12059	6164	48	0	\N
271430	1874	203840000	12059	6164	49	0	\N
271431	1874	203841000	12059	6164	50	0	\N
271432	1874	203842000	12059	6164	51	0	\N
271433	1874	203843000	12059	6164	52	0	\N
271434	1874	203844000	12059	6164	53	0	\N
271435	1874	203845000	12059	6164	54	0	\N
271436	1874	203846000	12059	6164	55	0	\N
271437	1874	203847000	12059	6164	57	0	\N
271438	1874	203848000	12059	6164	58	0	\N
271439	1874	203849000	12059	6164	59	0	\N
271440	1874	203850000	12059	6164	60	0	\N
271441	1874	203851000	12059	6164	61	0	\N
271442	1874	203852000	12059	6164	62	0	\N
271444	1318	1693980637751650	12061	6109	0	0	\N
271445	1072	900973465000000	12061	6109	1	0	\N
271446	1192	607904750000000	12061	6109	2	0	\N
271447	952	502777775000000	12061	6109	3	0	\N
271448	1449	8053016459	12061	6109	4	0	\N
271449	1874	203723000	12061	6109	5	0	\N
271450	1874	203724000	12061	6109	6	0	\N
271451	2047	0	12061	6109	7	0	\N
271452	1874	203725000	12061	6109	8	0	\N
271453	2058	586000000	12061	6109	9	0	\N
271454	2047	10000000	12061	6109	10	0	\N
271455	1874	203726000	12061	6109	11	0	\N
271456	1874	203727000	12061	6109	12	0	\N
271332	1874	203827000	12017	6185	0	0	0
271337	1874	203828000	12022	6186	0	0	0
271338	1874	203829000	12023	6187	0	0	0
271339	1874	203830000	12023	6187	1	0	0
271340	1874	203831000	12024	6188	0	0	0
271342	1874	203833000	12026	6190	0	0	0
271343	1874	203834000	12026	6190	1	0	0
271350	1874	203835000	12031	6191	0	0	0
271351	1874	203836000	12032	6192	0	0	0
271352	1874	203837000	12033	6193	0	0	0
271354	1874	203838000	12034	6194	1	0	0
271355	1874	203839000	12035	6195	0	0	0
271356	1874	203840000	12036	6196	0	0	0
271357	1874	203841000	12036	6196	1	0	0
271362	1874	203843000	12041	6198	0	0	0
271363	1874	203844000	12042	6199	0	0	0
271365	1874	203845000	12044	6200	0	0	0
271368	1874	203846000	12047	6201	0	0	0
271370	1874	203847000	12049	6202	0	0	0
271374	1874	203849000	12053	6204	0	0	0
271375	1874	203850000	12053	6204	1	0	0
271376	2058	586000000	12053	6204	2	0	0
271379	1874	203851000	12056	6205	0	0	0
271381	1874	203852000	12058	6206	0	0	0
271457	1874	203728000	12061	6109	13	0	\N
271458	1874	203729000	12061	6109	14	0	\N
271459	1318	1704299637751650	12061	6109	16	0	\N
271460	2047	30000000	12061	6109	17	0	\N
271461	1874	203730000	12061	6109	18	0	\N
271462	1874	203731000	12061	6109	19	0	\N
271463	1874	203732000	12061	6109	20	0	\N
271464	1874	203733000	12061	6109	21	0	\N
271465	1874	203734000	12061	6109	22	0	\N
271466	1874	203735000	12061	6109	23	0	\N
271467	1874	203736000	12061	6109	24	0	\N
271468	1874	203737000	12061	6109	25	0	\N
271469	1874	203738000	12061	6109	26	0	\N
271470	1874	203739000	12061	6109	27	0	\N
271471	1874	203740000	12061	6109	28	0	\N
271472	1874	203741000	12061	6109	29	0	\N
271473	1874	203742000	12061	6109	30	0	\N
271474	1874	203743000	12061	6109	31	0	\N
271475	1874	203744000	12061	6109	32	0	\N
271476	1874	203745000	12061	6109	33	0	\N
271477	1874	203746000	12061	6109	34	0	\N
271478	1874	203747000	12061	6109	35	0	\N
271479	1874	203748000	12061	6109	36	0	\N
271480	1874	203749000	12061	6109	37	0	\N
271481	1874	203750000	12061	6109	38	0	\N
271482	1874	203751000	12061	6109	39	0	\N
271483	1874	203752000	12061	6109	40	0	\N
271484	1874	203753000	12061	6109	41	0	\N
271485	1874	203754000	12061	6109	42	0	\N
271486	1874	203755000	12061	6109	43	0	\N
271487	1874	203756000	12061	6109	44	0	\N
271488	1874	203757000	12061	6109	45	0	\N
271489	1874	203758000	12061	6109	46	0	\N
271490	1874	203759000	12061	6109	47	0	\N
271491	1874	203760000	12061	6109	48	0	\N
271492	1874	203761000	12061	6109	49	0	\N
271493	1874	203762000	12061	6109	50	0	\N
271494	1874	203763000	12061	6109	51	0	\N
271495	1874	203764000	12061	6109	52	0	\N
271496	1874	203765000	12061	6109	53	0	\N
271497	1874	203766000	12061	6109	54	0	\N
271498	1874	203767000	12061	6109	55	0	\N
271499	1874	203768000	12061	6109	56	0	\N
271500	1874	203769000	12061	6109	57	0	\N
271501	1874	203770000	12061	6109	58	0	\N
271502	1874	203771000	12061	6109	59	0	\N
271503	1874	203772000	12061	6109	60	0	\N
271504	1874	203773000	12061	6109	61	0	\N
271505	1874	203774000	12061	6109	62	0	\N
271506	1874	203775000	12061	6109	63	0	\N
271507	1874	203776000	12061	6109	64	0	\N
271508	1874	203777000	12061	6109	65	0	\N
271509	1874	203778000	12061	6109	66	0	\N
271510	1874	203779000	12061	6109	67	0	\N
271511	1874	203780000	12061	6109	68	0	\N
271512	1874	203781000	12061	6109	69	0	\N
271513	1874	203782000	12061	6109	70	0	\N
271514	1874	203783000	12061	6109	71	0	\N
271515	1874	203784000	12061	6109	72	0	\N
271516	1874	203785000	12061	6109	73	0	\N
271517	1874	203786000	12061	6109	74	0	\N
271518	1874	203787000	12061	6109	75	0	\N
271519	1874	203788000	12061	6109	76	0	\N
271520	1874	203789000	12061	6109	77	0	\N
271521	1874	203790000	12061	6109	78	0	\N
271522	1874	203791000	12061	6109	79	0	\N
271523	1874	203792000	12061	6109	80	0	\N
271524	1874	203793000	12061	6109	81	0	\N
271525	1874	203794000	12061	6109	82	0	\N
271526	1874	203795000	12061	6109	83	0	\N
271527	1874	203796000	12061	6109	84	0	\N
271528	1874	203797000	12061	6109	85	0	\N
271529	1874	203798000	12061	6109	86	0	\N
271530	1874	203799000	12061	6109	87	0	\N
271531	1874	203800000	12061	6109	88	0	\N
271532	1874	203801000	12061	6109	89	0	\N
271533	1874	203802000	12061	6109	90	0	\N
271534	1874	203803000	12061	6109	91	0	\N
271535	1874	203804000	12061	6109	92	0	\N
271536	1874	203805000	12061	6109	93	0	\N
271537	1874	203806000	12061	6109	94	0	\N
271538	1874	203807000	12061	6109	95	0	\N
271539	1874	203808000	12061	6109	96	0	\N
271540	1874	203809000	12061	6109	97	0	\N
271541	1874	203810000	12061	6109	98	0	\N
271542	1874	203811000	12061	6109	99	0	\N
271543	1874	203812000	12061	6109	100	0	\N
271544	1874	203813000	12061	6109	101	0	\N
271545	1874	203814000	12061	6109	102	0	\N
271546	1874	203815000	12061	6109	103	0	\N
271547	1874	203816000	12061	6109	104	0	\N
271548	1874	203817000	12061	6109	105	0	\N
271549	1874	203818000	12061	6109	106	0	\N
271550	1874	203819000	12061	6109	107	0	\N
271551	1874	203820000	12061	6109	108	0	\N
271552	1874	203821000	12061	6109	109	0	\N
271553	1874	203822000	12061	6109	110	0	\N
271554	1874	203823000	12061	6109	111	0	\N
271555	1874	203824000	12061	6109	112	0	\N
271556	1874	203825000	12061	6109	113	0	\N
271557	1874	203826000	12061	6109	115	0	\N
271558	1874	203827000	12061	6109	116	0	\N
271559	1874	203828000	12061	6109	117	0	\N
271560	1874	203829000	12061	6109	118	0	\N
271561	1874	203830000	12061	6109	119	0	\N
271562	1874	203831000	12061	6109	120	0	\N
271563	1874	203832000	12061	6109	121	0	\N
271564	1874	203833000	12061	6109	122	0	\N
271565	1874	203834000	12061	6109	123	0	\N
271566	1874	203835000	12061	6109	124	0	\N
271567	1874	203836000	12061	6109	125	0	\N
271571	1874	203855000	12064	6209	0	0	\N
271572	1874	203856000	12064	6209	1	0	\N
271574	1874	203857000	12066	6210	0	0	\N
271575	1449	8053016459	12067	6120	0	0	\N
271576	2047	0	12067	6120	1	0	\N
271577	2058	586000000	12067	6120	2	0	\N
271578	1874	203782000	12067	6120	3	0	\N
271579	2047	10000000	12067	6120	4	0	\N
271580	2047	30000000	12067	6120	6	0	\N
271581	1874	203783000	12067	6120	7	0	\N
271582	1874	203784000	12067	6120	8	0	\N
271583	1874	203785000	12067	6120	9	0	\N
271584	1874	203786000	12067	6120	12	0	\N
271585	1874	203787000	12067	6120	13	0	\N
271586	1874	203788000	12067	6120	14	0	\N
271587	1874	203789000	12067	6120	15	0	\N
271588	1874	203790000	12067	6120	16	0	\N
271589	1874	203791000	12067	6120	17	0	\N
271590	1874	203792000	12067	6120	18	0	\N
271591	1874	203793000	12067	6120	19	0	\N
271592	1874	203794000	12067	6120	20	0	\N
271570	1874	203856000	12063	6209	1	0	0
271573	1874	203857000	12065	6210	0	0	0
271593	1874	203795000	12067	6120	21	0	\N
271594	1874	203796000	12067	6120	22	0	\N
271595	1874	203797000	12067	6120	23	0	\N
271596	1874	203798000	12067	6120	24	0	\N
271597	1874	203799000	12067	6120	25	0	\N
271598	1874	203800000	12067	6120	26	0	\N
271599	1874	203801000	12067	6120	27	0	\N
271600	1874	203802000	12067	6120	29	0	\N
271601	1874	203803000	12067	6120	30	0	\N
271602	1874	203804000	12067	6120	31	0	\N
271603	1874	203805000	12067	6120	32	0	\N
271604	1874	203806000	12067	6120	33	0	\N
271605	1874	203807000	12067	6120	34	0	\N
271606	1874	203808000	12067	6120	35	0	\N
271607	1874	203809000	12067	6120	36	0	\N
271608	1874	203810000	12067	6120	37	0	\N
271609	1874	203811000	12067	6120	38	0	\N
271610	1874	203812000	12067	6120	39	0	\N
271611	1874	203813000	12067	6120	40	0	\N
271612	1874	203814000	12067	6120	41	0	\N
271613	1874	203815000	12067	6120	42	0	\N
271614	1874	203816000	12067	6120	43	0	\N
271615	1874	203817000	12067	6120	44	0	\N
271616	1874	203818000	12067	6120	45	0	\N
271617	1874	203819000	12067	6120	46	0	\N
271618	1874	203820000	12067	6120	47	0	\N
271619	1874	203821000	12067	6120	48	0	\N
271620	1874	203822000	12067	6120	49	0	\N
271621	1874	203823000	12067	6120	50	0	\N
271622	1874	203824000	12067	6120	51	0	\N
271623	1874	203825000	12067	6120	52	0	\N
271624	1874	203826000	12067	6120	53	0	\N
271625	1874	203827000	12067	6120	54	0	\N
271626	1874	203828000	12067	6120	55	0	\N
271627	1874	203829000	12067	6120	56	0	\N
271628	1874	203830000	12067	6120	57	0	\N
271629	1874	203831000	12067	6120	58	0	\N
271630	1874	203832000	12067	6120	59	0	\N
271631	1874	203833000	12067	6120	60	0	\N
271632	1874	203834000	12067	6120	61	0	\N
271633	1874	203835000	12067	6120	62	0	\N
271634	1874	203836000	12067	6120	63	0	\N
271635	1874	203837000	12067	6120	64	0	\N
271636	1874	203838000	12067	6120	65	0	\N
271637	1874	203839000	12067	6120	66	0	\N
271638	1874	203840000	12067	6120	67	0	\N
271639	1874	203841000	12067	6120	68	0	\N
271640	1874	203842000	12067	6120	69	0	\N
271641	1874	203843000	12067	6120	70	0	\N
271642	1874	203844000	12067	6120	71	0	\N
271643	1874	203845000	12067	6120	72	0	\N
271644	1874	203846000	12067	6120	73	0	\N
271645	1874	203847000	12067	6120	74	0	\N
271646	1874	203848000	12067	6120	75	0	\N
271647	1874	203849000	12067	6120	76	0	\N
271648	1874	203850000	12067	6120	77	0	\N
271649	1874	203851000	12067	6120	78	0	\N
271650	1874	203852000	12067	6120	79	0	\N
271651	1874	203853000	12067	6120	80	0	\N
271652	1874	203854000	12067	6120	81	0	\N
271653	1874	203855000	12067	6120	82	0	\N
271654	1874	203856000	12067	6120	83	0	\N
271655	1874	203857000	12067	6120	84	0	\N
271656	1874	203858000	12067	6120	85	0	\N
271657	2060	200000000	12067	6120	86	0	\N
271658	1874	203859000	12067	6120	87	0	\N
271669	1874	203867000	12074	6217	0	0	\N
271670	1874	203868000	12074	6217	1	0	\N
271675	1874	203870000	12078	6219	0	0	\N
271676	1874	203871000	12079	6220	0	0	\N
271681	1874	203875000	12082	6222	0	0	\N
271682	1874	203876000	12082	6222	1	0	\N
271683	1874	203875000	12083	6222	0	0	\N
271684	1874	203876000	12083	6222	1	0	\N
271685	1874	203875000	12084	6222	0	0	\N
271686	1874	203876000	12084	6222	1	0	\N
271687	1874	203875000	12085	6222	0	0	\N
271688	1874	203876000	12085	6222	1	0	\N
271692	1874	203878000	12088	6224	0	0	\N
271693	2047	40000000	12088	6224	1	0	\N
271694	1874	203878000	12089	6224	0	0	\N
271695	2047	40000000	12089	6224	1	0	\N
271698	1318	1693980637751650	12091	6029	0	0	\N
271699	1072	900973465000000	12091	6029	1	0	\N
271700	1192	607904750000000	12091	6029	2	0	\N
271701	952	502777775000000	12091	6029	3	0	\N
271702	13	4672715676666	12091	6029	4	0	\N
271703	981	504509746723918	12091	6029	5	0	\N
271704	1101	904077143489721	12091	6029	6	0	\N
271705	1221	609998863722186	12091	6029	7	0	\N
271706	1347	1699816071836729	12091	6029	8	0	\N
271707	1771	304915534083	12091	6029	9	0	\N
271708	195	66300806891531	12091	6029	10	0	\N
271709	19	2336860172844	12091	6029	11	0	\N
271710	1449	8053016459	12091	6029	12	0	\N
271711	1090	906795935800000	12091	6029	13	0	\N
271712	203	66308156237945	12091	6029	14	0	\N
271713	291	66300806891531	12091	6029	15	0	\N
271714	1023	505067760241128	12091	6029	16	0	\N
271715	1143	905077098931514	12091	6029	17	0	\N
271716	1263	610673553584273	12091	6029	18	0	\N
271717	1389	1701696155127528	12091	6029	19	0	\N
271718	241	66308156237945	12091	6029	20	0	\N
271719	313	66308156237945	12091	6029	21	0	\N
271720	965	505064219226326	12091	6029	22	0	\N
271721	1085	905070753463320	12091	6029	23	0	\N
271722	1205	610669272170436	12091	6029	24	0	\N
271723	1331	1701684224587218	12091	6029	25	0	\N
271724	970	506026562600000	12091	6029	26	0	\N
271725	1336	1704926102951650	12091	6029	27	0	\N
271726	1210	611833516400000	12091	6029	28	0	\N
271727	2047	0	12091	6029	29	0	\N
271728	2058	586000000	12091	6029	30	0	\N
271661	1874	203859000	12068	6211	2	0	0
271662	1874	203860000	12068	6211	3	0	0
271663	1874	203861000	12069	6212	0	0	0
271664	1874	203862000	12070	6213	1	0	0
271665	1874	203863000	12071	6214	0	0	0
271667	1874	203865000	12073	6216	0	0	0
271668	1874	203866000	12073	6216	2	0	0
271671	1874	203867000	12075	6217	0	0	0
271672	1874	203868000	12075	6217	1	0	0
271673	1874	203869000	12076	6218	0	0	0
271677	1874	203871000	12080	6220	0	0	0
271678	1874	203872000	12081	6221	0	0	0
271679	1874	203873000	12081	6221	1	0	0
271680	1874	203874000	12081	6221	2	0	0
271690	1874	203876000	12086	6222	1	0	0
271691	1874	203877000	12087	6223	0	0	0
271696	1874	203878000	12090	6224	0	0	0
271697	2047	40000000	12090	6224	1	0	0
271731	2058	586000000	12093	6199	0	0	\N
271732	1874	203844000	12093	6199	1	0	\N
271733	2047	40000000	12093	6199	2	0	\N
271734	1874	203845000	12093	6199	4	0	\N
271735	1874	203846000	12093	6199	5	0	\N
271736	1874	203847000	12093	6199	6	0	\N
271737	1874	203848000	12093	6199	7	0	\N
271738	1874	203849000	12093	6199	8	0	\N
271739	1874	203850000	12093	6199	9	0	\N
271740	1874	203851000	12093	6199	10	0	\N
271741	1874	203852000	12093	6199	11	0	\N
271742	1874	203853000	12093	6199	12	0	\N
271743	1874	203854000	12093	6199	13	0	\N
271744	1874	203855000	12093	6199	14	0	\N
271745	1874	203856000	12093	6199	15	0	\N
271746	1874	203857000	12093	6199	16	0	\N
271747	1874	203858000	12093	6199	17	0	\N
271748	2060	200000000	12093	6199	18	0	\N
271749	1874	203859000	12093	6199	19	0	\N
271750	1874	203860000	12093	6199	20	0	\N
271751	1874	203861000	12093	6199	21	0	\N
271752	1874	203862000	12093	6199	22	0	\N
271753	1874	203863000	12093	6199	23	0	\N
271754	1874	203864000	12093	6199	24	0	\N
271755	1874	203865000	12093	6199	25	0	\N
271756	1874	203866000	12093	6199	26	0	\N
271757	1874	203867000	12093	6199	27	0	\N
271758	1874	203868000	12093	6199	28	0	\N
271759	1874	203869000	12093	6199	29	0	\N
271760	1874	203870000	12093	6199	30	0	\N
271761	1874	203871000	12093	6199	31	0	\N
271762	1874	203872000	12093	6199	32	0	\N
271763	1874	203873000	12093	6199	33	0	\N
271764	1874	203874000	12093	6199	34	0	\N
271765	1874	203875000	12093	6199	35	0	\N
271766	1874	203876000	12093	6199	36	0	\N
271767	1874	203877000	12093	6199	37	0	\N
271768	1874	203878000	12093	6199	38	0	\N
271769	1874	203879000	12093	6199	39	0	\N
271770	1874	203880000	12093	6199	40	0	\N
271781	1874	203889000	12099	6230	0	0	\N
271782	1874	203890000	12099	6230	1	0	\N
271783	1874	203891000	12100	6231	0	0	\N
271784	1874	203892000	12100	6231	1	0	\N
271787	2027	1129000000000	12102	6232	0	0	\N
271788	1874	203893000	12102	6232	1	0	\N
271791	1874	203894000	12104	6233	0	0	\N
271793	1874	203895000	12106	6234	0	0	\N
271795	1874	203896000	12109	6236	0	0	\N
271802	1874	203900000	12114	6239	0	0	\N
271803	1874	203901000	12115	6240	0	0	\N
271806	1874	203903000	12119	6243	0	0	\N
271807	1874	203904000	12119	6243	1	0	\N
271811	1874	203905000	12123	6244	0	0	\N
271812	1874	203906000	12124	6245	0	0	\N
271813	1874	203906000	12125	6245	0	0	\N
271818	1874	203909000	12129	6247	0	0	\N
271819	1874	203910000	12130	6248	0	0	\N
271820	1874	203911000	12130	6248	1	0	\N
271821	1874	203912000	12130	6248	2	0	\N
271822	1874	203910000	12132	6248	0	0	\N
271823	1874	203911000	12132	6248	1	0	\N
271824	1874	203912000	12132	6248	2	0	\N
271825	1874	203910000	12133	6248	0	0	\N
271826	1874	203911000	12133	6248	1	0	\N
271827	1874	203912000	12133	6248	2	0	\N
271835	1874	203917000	12141	6254	0	0	\N
271836	1874	203918000	12141	6254	1	0	\N
271839	1874	203917000	12143	6254	0	0	\N
271840	1874	203918000	12143	6254	1	0	\N
271841	1874	203917000	12144	6254	0	0	\N
271842	1874	203918000	12144	6254	1	0	\N
271851	1874	203922000	12150	6258	0	0	\N
271852	1874	203923000	12151	6259	0	0	\N
271854	1874	203924000	12153	6260	0	0	\N
271855	1874	203924000	12154	6260	0	0	\N
271859	2062	200000000	12157	6261	0	0	\N
271860	2062	200000000	12158	6261	0	0	\N
271861	1874	203925000	12158	6261	1	0	\N
271862	2062	200000000	12159	6261	0	0	\N
271863	1874	203926000	12160	6262	0	0	\N
271864	1874	203927000	12160	6262	1	0	\N
271771	1874	203881000	12094	6226	0	0	0
271772	1874	203882000	12094	6226	1	0	0
271773	1874	203883000	12094	6226	2	0	0
271774	1874	203884000	12095	6227	0	0	0
271775	1874	203885000	12095	6227	1	0	0
271777	1874	203887000	12096	6228	0	0	0
271778	1874	203888000	12097	6229	0	0	0
271779	1874	203889000	12098	6230	0	0	0
271780	1874	203890000	12098	6230	1	0	0
271785	1874	203891000	12101	6231	0	0	0
271789	2027	1129000000000	12103	6232	0	0	0
271790	1874	203893000	12103	6232	1	0	0
271792	1874	203894000	12105	6233	0	0	0
271794	1874	203895000	12108	6235	0	0	0
271797	1874	203897000	12111	6237	0	0	0
271798	1874	203898000	12112	6238	0	0	0
271799	1874	203899000	12112	6238	1	0	0
271800	2061	200000000	12112	6238	2	0	0
271801	1874	203900000	12113	6239	0	0	0
271805	1874	203902000	12117	6241	0	0	0
271808	1874	203903000	12121	6243	0	0	0
271809	1874	203904000	12121	6243	1	0	0
271810	1874	203905000	12122	6244	0	0	0
271814	1874	203906000	12126	6245	0	0	0
271816	1874	203908000	12127	6246	1	0	0
271817	1874	203909000	12128	6247	0	0	0
271828	1874	203910000	12134	6248	0	0	0
271829	1874	203911000	12134	6248	1	0	0
271831	1874	203913000	12135	6249	0	0	0
271832	1874	203914000	12136	6250	0	0	0
271833	1874	203915000	12137	6251	0	0	0
271834	1874	203916000	12138	6252	0	0	0
271837	1874	203917000	12142	6254	0	0	0
271843	1874	203919000	12145	6255	0	0	0
271844	1090	907018590600000	12145	6255	1	0	0
271845	970	506150798200000	12145	6255	2	0	0
271846	1336	1705344664151650	12145	6255	3	0	0
271847	1210	611983754800000	12145	6255	4	0	0
271849	1874	203921000	12147	6257	0	0	0
271850	1874	203922000	12149	6258	0	0	0
271853	1874	203923000	12152	6259	0	0	0
271856	1874	203924000	12155	6260	0	0	0
271858	1874	203925000	12156	6261	1	0	0
271865	1874	203928000	12160	6262	2	0	\N
271866	1874	203929000	12160	6262	3	0	\N
271867	1874	203930000	12160	6262	4	0	\N
271868	1874	203926000	12161	6262	0	0	\N
271869	1874	203927000	12161	6262	1	0	\N
271870	1874	203928000	12161	6262	2	0	\N
271871	1874	203929000	12161	6262	3	0	\N
271872	1874	203930000	12161	6262	4	0	\N
271878	1874	203926000	12163	6262	0	0	\N
271879	1874	203927000	12163	6262	1	0	\N
271880	1874	203928000	12163	6262	2	0	\N
271881	1874	203929000	12163	6262	3	0	\N
271882	1874	203930000	12163	6262	4	0	\N
271888	1874	203935000	12169	6265	0	0	\N
271890	1874	203936000	12171	6266	0	0	\N
271896	1874	203939000	12174	6268	0	0	\N
271897	1874	203940000	12174	6268	1	0	\N
271898	1874	203941000	12174	6268	2	0	\N
271899	1874	203942000	12175	6269	0	0	\N
271900	1874	203943000	12175	6269	1	0	\N
271901	1874	203944000	12175	6269	2	0	\N
271905	1874	203945000	12177	6270	0	0	\N
271911	1874	203946000	12180	6271	0	0	\N
271912	1874	203947000	12180	6271	1	0	\N
271913	1874	203948000	12180	6271	2	0	\N
271914	1874	203949000	12180	6271	3	0	\N
271915	1874	203946000	12181	6271	0	0	\N
271916	1874	203947000	12181	6271	1	0	\N
271917	1874	203948000	12181	6271	2	0	\N
271918	1874	203949000	12181	6271	3	0	\N
271921	1874	203951000	12183	6273	0	0	\N
271923	1950	4079853000000	12185	6121	0	0	\N
271924	1874	203860000	12185	6121	1	0	\N
271925	2027	1129000000000	12185	6121	2	0	\N
271926	2047	40000000	12185	6121	3	0	\N
271927	1874	203861000	12185	6121	4	0	\N
271928	1874	203862000	12185	6121	5	0	\N
271929	1874	203863000	12185	6121	6	0	\N
271930	1874	203864000	12185	6121	7	0	\N
271931	1874	203865000	12185	6121	8	0	\N
271932	1874	203866000	12185	6121	9	0	\N
271933	1874	203867000	12185	6121	10	0	\N
271934	1874	203868000	12185	6121	11	0	\N
271935	1874	203869000	12185	6121	12	0	\N
271936	1090	907018590600000	12185	6121	13	0	\N
271937	970	506150798200000	12185	6121	14	0	\N
271938	1874	203870000	12185	6121	15	0	\N
271939	1874	203871000	12185	6121	16	0	\N
271940	1874	203872000	12185	6121	17	0	\N
271941	1874	203873000	12185	6121	18	0	\N
271942	1874	203874000	12185	6121	19	0	\N
271943	1874	203875000	12185	6121	20	0	\N
271944	1874	203876000	12185	6121	21	0	\N
271945	1874	203877000	12185	6121	22	0	\N
271946	1874	203878000	12185	6121	23	0	\N
271947	1874	203879000	12185	6121	24	0	\N
271948	1874	203880000	12185	6121	25	0	\N
271949	1874	203881000	12185	6121	26	0	\N
271950	1874	203882000	12185	6121	27	0	\N
271951	1874	203883000	12185	6121	28	0	\N
271952	1874	203884000	12185	6121	29	0	\N
271953	1874	203885000	12185	6121	30	0	\N
271954	1874	203886000	12185	6121	31	0	\N
271955	1874	203887000	12185	6121	32	0	\N
271956	1874	203888000	12185	6121	33	0	\N
271957	1874	203889000	12185	6121	34	0	\N
271958	1874	203890000	12185	6121	35	0	\N
271959	1336	1705344664151650	12185	6121	36	0	\N
271960	1210	611983754800000	12185	6121	37	0	\N
271961	1874	203891000	12185	6121	38	0	\N
271962	1874	203892000	12185	6121	39	0	\N
271963	1874	203893000	12185	6121	40	0	\N
271964	1874	203894000	12185	6121	41	0	\N
271965	1874	203895000	12185	6121	42	0	\N
271966	1874	203896000	12185	6121	43	0	\N
271967	1874	203897000	12185	6121	44	0	\N
271968	1874	203898000	12185	6121	45	0	\N
271969	1874	203899000	12185	6121	46	0	\N
271970	2061	200000000	12185	6121	47	0	\N
271971	1874	203900000	12185	6121	48	0	\N
271972	1874	203901000	12185	6121	49	0	\N
271973	1874	203902000	12185	6121	50	0	\N
271974	1874	203903000	12185	6121	51	0	\N
271975	1874	203904000	12185	6121	52	0	\N
271976	1874	203905000	12185	6121	53	0	\N
271977	1874	203906000	12185	6121	54	0	\N
271978	1874	203907000	12185	6121	55	0	\N
271979	1874	203908000	12185	6121	56	0	\N
271980	1874	203909000	12185	6121	57	0	\N
271981	1874	203910000	12185	6121	58	0	\N
271982	1874	203911000	12185	6121	59	0	\N
271983	1874	203912000	12185	6121	60	0	\N
271984	1874	203913000	12185	6121	61	0	\N
271985	1874	203914000	12185	6121	62	0	\N
271986	1874	203915000	12185	6121	63	0	\N
271987	1874	203916000	12185	6121	64	0	\N
271988	1874	203917000	12185	6121	65	0	\N
271989	1874	203918000	12185	6121	67	0	\N
271990	1874	203919000	12185	6121	68	0	\N
271991	1874	203920000	12185	6121	69	0	\N
271992	1874	203921000	12185	6121	70	0	\N
271993	1874	203922000	12185	6121	71	0	\N
271994	1874	203923000	12185	6121	72	0	\N
271995	1874	203924000	12185	6121	73	0	\N
271996	2062	200000000	12185	6121	74	0	\N
271997	1874	203925000	12185	6121	75	0	\N
271998	1874	203926000	12185	6121	76	0	\N
271999	1874	203927000	12185	6121	77	0	\N
272000	1874	203928000	12185	6121	78	0	\N
271875	1874	203928000	12162	6262	2	0	0
271876	1874	203929000	12162	6262	3	0	0
271877	1874	203930000	12162	6262	4	0	0
271883	1874	203931000	12166	6264	0	0	0
271884	1874	203932000	12166	6264	1	0	0
271886	1874	203934000	12166	6264	3	0	0
271887	1874	203935000	12168	6265	0	0	0
271889	1874	203936000	12170	6266	0	0	0
271891	1874	203937000	12172	6267	0	0	0
271892	1874	203938000	12172	6267	1	0	0
271894	1874	203940000	12173	6268	1	0	0
271895	1874	203941000	12173	6268	2	0	0
271902	1874	203942000	12176	6269	0	0	0
271903	1874	203943000	12176	6269	1	0	0
271906	1874	203945000	12178	6270	0	0	0
271907	1874	203946000	12179	6271	0	0	0
271908	1874	203947000	12179	6271	1	0	0
271909	1874	203948000	12179	6271	2	0	0
271910	1874	203949000	12179	6271	3	0	0
271920	1874	203950000	12182	6272	1	0	0
271922	1874	203951000	12184	6273	0	0	0
272001	1874	203929000	12185	6121	79	0	\N
272002	1874	203930000	12185	6121	80	0	\N
272003	1874	203931000	12185	6121	81	0	\N
272004	1874	203932000	12185	6121	82	0	\N
272005	1874	203933000	12185	6121	83	0	\N
272006	1874	203934000	12185	6121	84	0	\N
272007	1874	203935000	12185	6121	85	0	\N
272008	1874	203936000	12185	6121	86	0	\N
272009	1874	203937000	12185	6121	87	0	\N
272010	1874	203938000	12185	6121	88	0	\N
272011	1874	203939000	12185	6121	89	0	\N
272012	1874	203940000	12185	6121	90	0	\N
272013	1874	203941000	12185	6121	91	0	\N
272014	1874	203942000	12185	6121	92	0	\N
272015	1874	203943000	12185	6121	93	0	\N
272016	1874	203944000	12185	6121	94	0	\N
272017	1874	203945000	12185	6121	95	0	\N
272018	1874	203946000	12185	6121	96	0	\N
272019	1874	203947000	12185	6121	97	0	\N
272020	1874	203948000	12185	6121	98	0	\N
272021	1874	203949000	12185	6121	99	0	\N
272022	1874	203950000	12185	6121	100	0	\N
272023	1874	203951000	12185	6121	101	0	\N
272024	1874	203952000	12185	6121	102	0	\N
272028	1874	203954000	12188	6275	0	0	\N
272032	1874	203955000	12190	6276	0	0	\N
272033	1874	203956000	12190	6276	1	0	\N
272034	1874	203957000	12190	6276	2	0	\N
272035	1874	203955000	12191	6276	0	0	\N
272036	1874	203956000	12191	6276	1	0	\N
272037	1874	203957000	12191	6276	2	0	\N
272038	1950	3949852000000	12192	6264	0	0	\N
272039	1874	203931000	12192	6264	1	0	\N
272040	1874	203932000	12192	6264	2	0	\N
272041	1874	203933000	12192	6264	3	0	\N
272042	1874	203934000	12192	6264	4	0	\N
272043	1874	203935000	12192	6264	5	0	\N
272044	1874	203936000	12192	6264	6	0	\N
272045	1874	203937000	12192	6264	7	0	\N
272046	1874	203938000	12192	6264	8	0	\N
272047	1874	203939000	12192	6264	9	0	\N
272048	1874	203940000	12192	6264	10	0	\N
272049	1874	203941000	12192	6264	11	0	\N
272050	1874	203942000	12192	6264	12	0	\N
272051	1874	203943000	12192	6264	13	0	\N
272052	1874	203944000	12192	6264	14	0	\N
272053	1874	203945000	12192	6264	15	0	\N
272054	1874	203946000	12192	6264	16	0	\N
272055	1874	203947000	12192	6264	17	0	\N
272056	1874	203948000	12192	6264	18	0	\N
272057	1874	203949000	12192	6264	19	0	\N
272058	1874	203950000	12192	6264	20	0	\N
272059	1874	203951000	12192	6264	21	0	\N
272060	1874	203952000	12192	6264	22	0	\N
272061	1874	203953000	12192	6264	23	0	\N
272062	1874	203954000	12192	6264	24	0	\N
272063	1874	203955000	12192	6264	25	0	\N
272064	1874	203956000	12192	6264	26	0	\N
272065	1874	203957000	12192	6264	27	0	\N
272067	1874	203958000	12194	6277	0	0	\N
272088	1874	203973000	12208	6289	0	0	\N
272089	1713	760000000	12209	6269	0	0	\N
272090	1360	1703067102686953	12209	6269	1	0	\N
272091	1234	611165531836822	12209	6269	2	0	\N
272092	1114	905806273145245	12209	6269	3	0	\N
272093	994	505474640261745	12209	6269	4	0	\N
272094	1950	3949852000000	12209	6269	5	0	\N
272098	1874	203976000	12211	6291	0	0	\N
272099	1874	203976000	12212	6291	0	0	\N
272104	1874	203978000	12216	6293	0	0	\N
272105	1874	203979000	12216	6293	1	0	\N
272106	1318	1693980637751650	12217	6078	0	0	\N
272107	1072	900973465000000	12217	6078	1	0	\N
272108	1192	607904750000000	12217	6078	2	0	\N
272109	952	502777775000000	12217	6078	3	0	\N
272110	1360	1703067102686953	12217	6078	4	0	\N
272111	1234	611165531836822	12217	6078	5	0	\N
272112	1114	905806273145245	12217	6078	6	0	\N
272113	994	505474640261745	12217	6078	7	0	\N
272114	13	4672715676666	12217	6078	8	0	\N
272115	981	504509746723918	12217	6078	9	0	\N
272116	1101	904077143489721	12217	6078	10	0	\N
272117	1221	609998863722186	12217	6078	11	0	\N
272118	1347	1699816071836729	12217	6078	12	0	\N
272119	19	2336860172844	12217	6078	13	0	\N
272120	1449	8053016459	12217	6078	14	0	\N
272121	203	66308156237945	12217	6078	15	0	\N
272122	1950	4079853000000	12217	6078	16	0	\N
272123	241	66308156237945	12217	6078	17	0	\N
272124	313	66308156237945	12217	6078	18	0	\N
272125	965	505064219226326	12217	6078	19	0	\N
272126	1085	905070753463320	12217	6078	20	0	\N
272127	1205	610669272170436	12217	6078	21	0	\N
272128	1331	1701684224587218	12217	6078	22	0	\N
272129	2047	0	12217	6078	23	0	\N
272130	2027	1129000000000	12217	6078	24	0	\N
272131	2058	586000000	12217	6078	25	0	\N
272132	1874	203673000	12217	6078	26	0	\N
272133	2047	10000000	12217	6078	27	0	\N
272134	1318	1704299637751650	12217	6078	29	0	\N
272135	1874	203674000	12217	6078	30	0	\N
272136	1874	203675000	12217	6078	31	0	\N
272027	1874	203954000	12187	6275	0	0	0
272029	1874	203955000	12189	6276	0	0	0
272030	1874	203956000	12189	6276	1	0	0
272031	1874	203957000	12189	6276	2	0	0
272066	1874	203958000	12193	6277	0	0	0
272069	1874	203960000	12196	6279	0	0	0
272070	1874	203961000	12196	6279	1	0	0
272071	1874	203962000	12197	6280	0	0	0
272072	1713	760000000	12198	6281	0	0	0
272073	1874	203963000	12198	6281	1	0	0
272075	1874	203964000	12199	6282	1	0	0
272076	1874	203965000	12199	6282	2	0	0
272077	1874	203966000	12200	6283	0	0	0
272078	1874	203967000	12201	6284	0	0	0
272080	1114	905806273145245	12202	6285	1	0	0
272081	1874	203968000	12202	6285	2	0	0
272082	1874	203969000	12202	6285	3	0	0
272083	994	505474640261745	12203	6286	0	0	0
272084	1874	203970000	12203	6286	2	0	0
272086	1874	203972000	12205	6288	0	0	0
272087	1874	203973000	12206	6289	0	0	0
272095	1874	203974000	12210	6290	0	0	0
272096	1874	203975000	12210	6290	1	0	0
272097	2063	200000000	12210	6290	2	0	0
272101	1874	203977000	12214	6292	0	0	0
272102	1874	203978000	12215	6293	0	0	0
272103	1874	203979000	12215	6293	1	0	0
272137	2047	30000000	12217	6078	32	0	\N
272138	2047	40000000	12217	6078	33	0	\N
272139	1090	907018590600000	12217	6078	34	0	\N
272140	970	506150798200000	12217	6078	35	0	\N
272141	1336	1705344664151650	12217	6078	36	0	\N
272142	1210	611983754800000	12217	6078	37	0	\N
272143	1874	203676000	12217	6078	38	0	\N
272144	1874	203677000	12217	6078	39	0	\N
272145	1874	203678000	12217	6078	40	0	\N
272146	1874	203679000	12217	6078	41	0	\N
272147	1874	203680000	12217	6078	42	0	\N
272148	1874	203681000	12217	6078	43	0	\N
272149	1874	203682000	12217	6078	44	0	\N
272150	1874	203683000	12217	6078	45	0	\N
272151	1874	203684000	12217	6078	46	0	\N
272152	1874	203685000	12217	6078	47	0	\N
272153	1874	203686000	12217	6078	48	0	\N
272154	1874	203687000	12217	6078	49	0	\N
272155	1874	203688000	12217	6078	50	0	\N
272156	1874	203689000	12217	6078	51	0	\N
272157	2056	200000000	12217	6078	52	0	\N
272158	1874	203690000	12217	6078	53	0	\N
272159	1874	203691000	12217	6078	54	0	\N
272160	1874	203692000	12217	6078	55	0	\N
272161	1874	203693000	12217	6078	56	0	\N
272162	1874	203694000	12217	6078	57	0	\N
272163	1874	203695000	12217	6078	58	0	\N
272164	1874	203696000	12217	6078	59	0	\N
272165	1874	203697000	12217	6078	60	0	\N
272166	2057	200000000	12217	6078	61	0	\N
272167	1874	203698000	12217	6078	62	0	\N
272168	1874	203699000	12217	6078	63	0	\N
272169	1874	203700000	12217	6078	64	0	\N
272170	1874	203701000	12217	6078	65	0	\N
272171	1874	203702000	12217	6078	66	0	\N
272172	1874	203703000	12217	6078	67	0	\N
272173	1874	203704000	12217	6078	68	0	\N
272174	1874	203705000	12217	6078	69	0	\N
272175	1874	203706000	12217	6078	70	0	\N
272176	1874	203707000	12217	6078	71	0	\N
272177	1874	203708000	12217	6078	72	0	\N
272178	1874	203709000	12217	6078	73	0	\N
272179	1874	203710000	12217	6078	74	0	\N
272180	1874	203711000	12217	6078	75	0	\N
272181	1874	203712000	12217	6078	76	0	\N
272182	1874	203713000	12217	6078	77	0	\N
272183	1874	203714000	12217	6078	78	0	\N
272184	1874	203715000	12217	6078	79	0	\N
272185	1874	203716000	12217	6078	80	0	\N
272186	1874	203717000	12217	6078	81	0	\N
272187	1874	203718000	12217	6078	82	0	\N
272188	1874	203719000	12217	6078	83	0	\N
272189	1874	203720000	12217	6078	84	0	\N
272190	1874	203721000	12217	6078	85	0	\N
272191	1874	203722000	12217	6078	86	0	\N
272192	1874	203723000	12217	6078	87	0	\N
272193	1874	203724000	12217	6078	88	0	\N
272194	1874	203725000	12217	6078	89	0	\N
272195	1874	203726000	12217	6078	90	0	\N
272196	1874	203727000	12217	6078	91	0	\N
272197	1874	203728000	12217	6078	92	0	\N
272198	1874	203729000	12217	6078	93	0	\N
272199	1874	203730000	12217	6078	94	0	\N
272200	1874	203731000	12217	6078	95	0	\N
272201	1874	203732000	12217	6078	96	0	\N
272202	1874	203733000	12217	6078	97	0	\N
272203	1874	203734000	12217	6078	98	0	\N
272204	1874	203735000	12217	6078	99	0	\N
272205	1874	203736000	12217	6078	100	0	\N
272206	1874	203737000	12217	6078	101	0	\N
272207	1874	203738000	12217	6078	102	0	\N
272208	1874	203739000	12217	6078	103	0	\N
272209	1874	203740000	12217	6078	104	0	\N
272210	1874	203741000	12217	6078	105	0	\N
272211	1874	203742000	12217	6078	106	0	\N
272212	1874	203743000	12217	6078	107	0	\N
272213	1874	203744000	12217	6078	108	0	\N
272214	1874	203745000	12217	6078	109	0	\N
272215	1874	203746000	12217	6078	110	0	\N
272216	1874	203747000	12217	6078	111	0	\N
272217	1874	203748000	12217	6078	112	0	\N
272218	1874	203749000	12217	6078	114	0	\N
272219	1874	203750000	12217	6078	115	0	\N
272220	1874	203751000	12217	6078	116	0	\N
272221	1874	203752000	12217	6078	117	0	\N
272222	1874	203753000	12217	6078	118	0	\N
272223	1874	203754000	12217	6078	119	0	\N
272224	1874	203755000	12217	6078	120	0	\N
272225	1874	203756000	12217	6078	121	0	\N
272226	1874	203757000	12217	6078	122	0	\N
272227	1874	203758000	12217	6078	123	0	\N
272228	1874	203759000	12217	6078	124	0	\N
272229	1874	203760000	12217	6078	125	0	\N
272232	1874	203980000	12219	6294	0	0	\N
272233	1874	203981000	12219	6294	1	0	\N
272234	1874	203980000	12220	6294	0	0	\N
272235	1874	203981000	12220	6294	1	0	\N
272236	1874	203980000	12221	6294	0	0	\N
272237	1874	203981000	12221	6294	1	0	\N
272240	1874	203983000	12224	6296	0	0	\N
272244	1874	203984000	12226	6297	0	0	\N
272245	1874	203985000	12226	6297	1	0	\N
272246	1874	203986000	12226	6297	2	0	\N
272248	1386	1702583637751650	12228	6299	0	0	\N
272249	1386	1702583637751650	12229	6299	0	0	\N
272250	1874	203988000	12229	6299	1	0	\N
272253	1874	203988000	12231	6299	0	0	\N
272259	1874	203991000	12233	6301	0	0	\N
272261	1874	203991000	12235	6301	0	0	\N
272262	1874	203991000	12237	6301	0	0	\N
272263	1874	203992000	12238	6302	0	0	\N
272265	1874	203992000	12240	6302	0	0	\N
272267	1874	203993000	12242	6303	0	0	\N
272238	1874	203982000	12222	6295	0	0	0
272239	1874	203983000	12223	6296	0	0	0
272241	1874	203984000	12225	6297	0	0	0
272242	1874	203985000	12225	6297	1	0	0
272243	1874	203986000	12225	6297	2	0	0
272251	1386	1702583637751650	12230	6299	0	0	0
272252	1874	203988000	12230	6299	1	0	0
272254	1140	905549465000000	12232	6300	0	0	0
272255	1260	610992750000000	12232	6300	1	0	0
272256	1020	505331775000000	12232	6300	2	0	0
272258	1874	203990000	12232	6300	4	0	0
272260	1874	203991000	12234	6301	0	0	0
272264	1874	203992000	12239	6302	0	0	0
272266	1874	203993000	12241	6303	0	0	0
272269	773	1003811812300	12244	6305	0	0	0
272270	1874	203995000	12244	6305	1	0	0
272271	1874	203996000	12244	6305	2	0	0
272272	1021	504692059536962	12245	6306	0	0	0
272276	1387	1700430328056211	12246	6307	0	0	\N
272277	1874	203998000	12246	6307	1	0	\N
272284	478	66251579611955	12249	6308	0	0	\N
272285	1600	0	12249	6308	1	0	\N
272286	1874	203999000	12249	6308	2	0	\N
272287	1874	204000000	12249	6308	3	0	\N
272288	773	1003811812300	12250	6301	0	0	\N
272289	1021	504692059536962	12250	6301	1	0	\N
272290	1141	904403846488639	12250	6301	2	0	\N
272291	1261	610219296745574	12250	6301	3	0	\N
272292	1387	1700430328056211	12250	6301	4	0	\N
272293	478	66251579611955	12250	6301	5	0	\N
272294	1600	0	12250	6301	6	0	\N
272295	1874	203991000	12250	6301	7	0	\N
272296	1874	203992000	12250	6301	8	0	\N
272297	1874	203993000	12250	6301	9	0	\N
272298	1874	203994000	12250	6301	10	0	\N
272299	1874	203995000	12250	6301	11	0	\N
272300	1874	203996000	12250	6301	12	0	\N
272301	1874	203997000	12250	6301	13	0	\N
272302	1874	203998000	12250	6301	14	0	\N
272303	1874	203999000	12250	6301	15	0	\N
272304	1874	204000000	12250	6301	16	0	\N
272305	1874	204001000	12251	6309	0	0	\N
272308	1874	204002000	12256	6310	0	0	\N
272311	1874	204005000	12259	6313	0	0	\N
272312	1874	204006000	12259	6313	1	0	\N
272313	1874	204007000	12259	6313	2	0	\N
272317	1713	760000000	12261	6241	0	0	\N
272318	1360	1703067102686953	12261	6241	1	0	\N
272319	1234	611165531836822	12261	6241	2	0	\N
272320	1114	905806273145245	12261	6241	3	0	\N
272321	994	505474640261745	12261	6241	4	0	\N
272322	1386	1702583637751650	12261	6241	5	0	\N
272323	1140	905549465000000	12261	6241	6	0	\N
272324	1260	610992750000000	12261	6241	7	0	\N
272325	1020	505331775000000	12261	6241	8	0	\N
272326	773	1003811812300	12261	6241	9	0	\N
272327	1021	504692059536962	12261	6241	10	0	\N
272328	1141	904403846488639	12261	6241	11	0	\N
272329	1261	610219296745574	12261	6241	12	0	\N
272330	1387	1700430328056211	12261	6241	13	0	\N
272331	478	66251579611955	12261	6241	14	0	\N
272332	1950	3949852000000	12261	6241	15	0	\N
272333	1600	0	12261	6241	16	0	\N
272334	1874	203902000	12261	6241	17	0	\N
272335	1090	907018590600000	12261	6241	18	0	\N
272336	970	506150798200000	12261	6241	19	0	\N
272337	1874	203903000	12261	6241	20	0	\N
272338	1336	1705344664151650	12261	6241	21	0	\N
272339	1210	611983754800000	12261	6241	22	0	\N
272340	1874	203904000	12261	6241	23	0	\N
272341	1874	203905000	12261	6241	24	0	\N
272342	1874	203906000	12261	6241	25	0	\N
272343	1874	203907000	12261	6241	26	0	\N
272344	1874	203908000	12261	6241	27	0	\N
272345	1874	203909000	12261	6241	28	0	\N
272346	1874	203910000	12261	6241	29	0	\N
272347	1874	203911000	12261	6241	30	0	\N
272348	1874	203912000	12261	6241	31	0	\N
272349	1874	203913000	12261	6241	32	0	\N
272350	1874	203914000	12261	6241	33	0	\N
272351	1874	203915000	12261	6241	34	0	\N
272352	1874	203916000	12261	6241	35	0	\N
272353	1874	203917000	12261	6241	36	0	\N
272354	1874	203918000	12261	6241	37	0	\N
272355	1874	203919000	12261	6241	39	0	\N
272356	1874	203920000	12261	6241	40	0	\N
272357	1874	203921000	12261	6241	41	0	\N
272358	1874	203922000	12261	6241	42	0	\N
272359	1874	203923000	12261	6241	43	0	\N
272360	1874	203924000	12261	6241	44	0	\N
272361	2062	200000000	12261	6241	45	0	\N
272362	1874	203925000	12261	6241	46	0	\N
272363	1874	203926000	12261	6241	47	0	\N
272364	1874	203927000	12261	6241	48	0	\N
272365	1874	203928000	12261	6241	49	0	\N
272366	1874	203929000	12261	6241	50	0	\N
272367	1874	203930000	12261	6241	51	0	\N
272368	1874	203931000	12261	6241	52	0	\N
272369	1874	203932000	12261	6241	53	0	\N
272370	1874	203933000	12261	6241	54	0	\N
272371	1874	203934000	12261	6241	55	0	\N
272372	1874	203935000	12261	6241	56	0	\N
272373	1874	203936000	12261	6241	57	0	\N
272374	1874	203937000	12261	6241	58	0	\N
272375	1874	203938000	12261	6241	59	0	\N
272376	1874	203939000	12261	6241	60	0	\N
272377	1874	203940000	12261	6241	61	0	\N
272378	1874	203941000	12261	6241	62	0	\N
272379	1874	203942000	12261	6241	63	0	\N
272380	1874	203943000	12261	6241	64	0	\N
272381	1874	203944000	12261	6241	65	0	\N
272382	1874	203945000	12261	6241	66	0	\N
272383	1874	203946000	12261	6241	67	0	\N
272384	1874	203947000	12261	6241	68	0	\N
272385	1874	203948000	12261	6241	69	0	\N
272386	1874	203949000	12261	6241	70	0	\N
272387	1874	203950000	12261	6241	71	0	\N
272388	1874	203951000	12261	6241	72	0	\N
272389	1874	203952000	12261	6241	73	0	\N
272390	1874	203953000	12261	6241	74	0	\N
272391	1874	203954000	12261	6241	75	0	\N
272392	1874	203955000	12261	6241	76	0	\N
272393	1874	203956000	12261	6241	77	0	\N
272394	1874	203957000	12261	6241	78	0	\N
272395	1874	203958000	12261	6241	79	0	\N
272396	1874	203959000	12261	6241	80	0	\N
272397	1874	203960000	12261	6241	81	0	\N
272398	1874	203961000	12261	6241	82	0	\N
272399	1874	203962000	12261	6241	83	0	\N
272400	1874	203963000	12261	6241	84	0	\N
272401	1874	203964000	12261	6241	85	0	\N
272402	1874	203965000	12261	6241	86	0	\N
272403	1874	203966000	12261	6241	87	0	\N
272404	1874	203967000	12261	6241	88	0	\N
272405	1874	203968000	12261	6241	89	0	\N
272406	1874	203969000	12261	6241	90	0	\N
272407	1874	203970000	12261	6241	91	0	\N
272408	1874	203971000	12261	6241	92	0	\N
272275	1874	203997000	12245	6306	3	0	0
272278	1387	1700430328056211	12247	6307	0	0	0
272279	1874	203998000	12247	6307	1	0	0
272280	478	66251579611955	12248	6308	0	0	0
272281	1600	0	12248	6308	1	0	0
272283	1874	204000000	12248	6308	3	0	0
272306	1874	204001000	12253	6309	0	0	0
272307	1874	204002000	12254	6310	0	0	0
272309	1874	204003000	12257	6311	0	0	0
272310	1874	204004000	12258	6312	0	0	0
272315	1874	204006000	12260	6313	1	0	0
272316	1874	204007000	12260	6313	2	0	0
272409	1874	203972000	12261	6241	93	0	\N
272410	1874	203973000	12261	6241	94	0	\N
272411	1874	203974000	12261	6241	95	0	\N
272412	1874	203975000	12261	6241	96	0	\N
272413	2063	200000000	12261	6241	97	0	\N
272414	1874	203976000	12261	6241	98	0	\N
272415	1874	203977000	12261	6241	99	0	\N
272416	1874	203978000	12261	6241	100	0	\N
272417	1874	203979000	12261	6241	101	0	\N
272418	1874	203980000	12261	6241	102	0	\N
272419	1874	203981000	12261	6241	103	0	\N
272420	1874	203982000	12261	6241	104	0	\N
272421	1874	203983000	12261	6241	105	0	\N
272422	1874	203984000	12261	6241	106	0	\N
272423	1874	203985000	12261	6241	107	0	\N
272424	1874	203986000	12261	6241	108	0	\N
272425	1874	203987000	12261	6241	109	0	\N
272426	1874	203988000	12261	6241	110	0	\N
272427	1874	203989000	12261	6241	111	0	\N
272428	1874	203990000	12261	6241	112	0	\N
272429	1874	203991000	12261	6241	113	0	\N
272430	1874	203992000	12261	6241	114	0	\N
272431	1874	203993000	12261	6241	115	0	\N
272432	1874	203994000	12261	6241	116	0	\N
272433	1874	203995000	12261	6241	117	0	\N
272434	1874	203996000	12261	6241	118	0	\N
272435	1874	203997000	12261	6241	119	0	\N
272436	1874	203998000	12261	6241	120	0	\N
272437	1874	203999000	12261	6241	121	0	\N
272438	1874	204000000	12261	6241	122	0	\N
272439	1874	204001000	12261	6241	123	0	\N
272440	1874	204002000	12261	6241	124	0	\N
272442	1318	1693980637751650	12263	6036	0	0	\N
272443	1072	900973465000000	12263	6036	1	0	\N
272444	1192	607904750000000	12263	6036	2	0	\N
272445	952	502777775000000	12263	6036	3	0	\N
272446	1360	1703067102686953	12263	6036	4	0	\N
272447	1234	611165531836822	12263	6036	5	0	\N
272448	1114	905806273145245	12263	6036	6	0	\N
272449	994	505474640261745	12263	6036	7	0	\N
272450	1386	1702583637751650	12263	6036	8	0	\N
272451	1140	905549465000000	12263	6036	9	0	\N
272452	195	66300806891531	12263	6036	10	0	\N
272453	1260	610992750000000	12263	6036	11	0	\N
272454	1020	505331775000000	12263	6036	12	0	\N
272455	1874	204008000	12264	6314	0	0	\N
272457	1874	204009000	12266	6315	0	0	\N
272458	1874	204010000	12267	6316	0	0	\N
272468	1874	204013000	12273	6319	0	0	\N
272469	1874	204013000	12275	6319	0	0	\N
272471	1874	204014000	12279	6320	0	0	\N
272472	1874	204015000	12280	6321	0	0	\N
272485	1874	204021000	12288	6327	0	0	\N
272487	759	1001000000000	12290	6139	0	0	\N
272488	1360	1703067102686953	12290	6139	1	0	\N
272489	1234	611165531836822	12290	6139	2	0	\N
272490	1114	905806273145245	12290	6139	3	0	\N
272491	994	505474640261745	12290	6139	4	0	\N
272492	1386	1702583637751650	12290	6139	5	0	\N
272493	1140	905549465000000	12290	6139	6	0	\N
272494	1017	504693775000000	12290	6139	7	0	\N
272495	1257	610220750000000	12290	6139	8	0	\N
272496	1260	610992750000000	12290	6139	9	0	\N
272497	1137	904405465000000	12290	6139	10	0	\N
272498	1383	1700433637751650	12290	6139	11	0	\N
272499	1020	505331775000000	12290	6139	12	0	\N
272500	773	1003811812300	12290	6139	14	0	\N
272501	1021	504692059536962	12290	6139	15	0	\N
272502	1141	904403846488639	12290	6139	16	0	\N
272503	1261	610219296745574	12290	6139	17	0	\N
272504	1364	1700432637751650	12290	6139	18	0	\N
272505	1118	904405465000000	12290	6139	19	0	\N
272506	1238	610220750000000	12290	6139	20	0	\N
272507	1387	1700430328056211	12290	6139	21	0	\N
272514	481	66278185530567	12294	6332	0	0	\N
272515	734	2008429864511	12294	6332	1	0	\N
272516	845	575749894374107	12294	6332	2	0	\N
272517	846	575749894374107	12294	6332	3	0	\N
272518	936	505014385078944	12294	6332	4	0	\N
272519	1056	904981451098176	12294	6332	5	0	\N
272520	1176	610609018085216	12294	6332	6	0	\N
272521	1302	1701516321221218	12294	6332	7	0	\N
272522	1874	204027000	12294	6332	8	0	\N
272523	1874	204028000	12294	6332	9	0	\N
272534	481	66278185530567	12296	6332	0	0	\N
272535	734	2008429864511	12296	6332	1	0	\N
272536	1874	204027000	12296	6332	2	0	\N
272537	1874	204028000	12296	6332	3	0	\N
272541	1874	204031000	12299	6335	0	0	\N
272543	1046	900974465000000	12301	6336	0	0	\N
272544	1874	204032000	12301	6336	1	0	\N
272459	1874	204010000	12268	6316	0	0	0
272460	759	1001000000000	12270	6318	0	0	0
272461	1364	1700432637751650	12270	6318	1	0	0
272462	1118	904405465000000	12270	6318	2	0	0
272463	1238	610220750000000	12270	6318	3	0	0
272465	1874	204011000	12270	6318	5	0	0
272466	1874	204012000	12270	6318	6	0	0
272467	1874	204013000	12272	6319	0	0	0
272470	1874	204014000	12278	6320	0	0	0
272473	1874	204015000	12281	6321	0	0	0
272475	1874	204016000	12282	6322	1	0	0
272476	1874	204017000	12283	6323	0	0	0
272477	1874	204018000	12284	6324	0	0	0
272478	1874	204019000	12284	6324	1	0	0
272480	1257	610220750000000	12285	6325	1	0	0
272481	1137	904405465000000	12285	6325	2	0	0
272482	1383	1700433637751650	12285	6325	3	0	0
272483	1874	204020000	12286	6326	0	0	0
272484	1874	204021000	12287	6327	0	0	0
272508	1874	204023000	12291	6329	0	0	0
272509	1866	9452848201646	12292	6330	0	0	8
272510	1874	204024000	12292	6330	1	0	0
272511	1874	204025000	12292	6330	2	0	0
272512	1292	1693981637751650	12293	6331	0	0	0
272524	481	66278185530567	12295	6332	0	0	0
272525	734	2008429864511	12295	6332	1	0	0
272526	845	575749894374107	12295	6332	2	0	0
272527	846	575749894374107	12295	6332	3	0	0
272529	1056	904981451098176	12295	6332	5	0	0
272530	1176	610609018085216	12295	6332	6	0	0
272531	1302	1701516321221218	12295	6332	7	0	0
272532	1874	204027000	12295	6332	8	0	0
272533	1874	204028000	12295	6332	9	0	0
272539	1292	1702582637751650	12298	6334	0	0	0
272540	1874	204030000	12298	6334	1	0	0
272542	1874	204031000	12300	6335	0	0	0
272547	1046	900974465000000	12303	6336	0	0	\N
272548	1874	204032000	12303	6336	1	0	\N
272551	1166	607905750000000	12305	6338	0	0	\N
272552	1713	770000000	12305	6338	1	0	\N
272553	1874	204034000	12305	6338	2	0	\N
272554	1874	204035000	12305	6338	3	0	\N
272569	1874	204043000	12314	6346	0	0	\N
272571	1874	204044000	12316	6347	0	0	\N
272572	1874	204044000	12317	6347	0	0	\N
272577	1866	9452848201646	12321	6302	0	0	\N
272578	759	1001000000000	12321	6302	1	0	\N
272579	1292	1693981637751650	12321	6302	2	0	\N
272580	1292	1702582637751650	12321	6302	3	0	\N
272581	1046	900974465000000	12321	6302	4	0	\N
272582	1046	905549465000000	12321	6302	5	0	\N
272583	1166	607905750000000	12321	6302	6	0	\N
272584	1166	610992750000000	12321	6302	7	0	\N
272585	926	502778775000000	12321	6302	8	0	\N
272586	926	505331775000000	12321	6302	9	0	\N
272587	1017	504693775000000	12321	6302	10	0	\N
272588	1257	610220750000000	12321	6302	11	0	\N
272589	1474	4814357000023	12321	6302	12	0	\N
272590	1137	904405465000000	12321	6302	13	0	\N
272591	1383	1700433637751650	12321	6302	14	0	\N
272592	1713	770000000	12321	6302	15	0	\N
272593	1364	1700432637751650	12321	6302	16	0	\N
272594	1118	904405465000000	12321	6302	17	0	\N
272595	1238	610220750000000	12321	6302	18	0	\N
272596	998	504693775000000	12321	6302	19	0	\N
272597	1874	204001000	12321	6302	20	0	\N
272598	1874	204002000	12321	6302	21	0	\N
272599	1874	204003000	12321	6302	22	0	\N
272600	1874	204004000	12321	6302	23	0	\N
272601	1874	204005000	12321	6302	24	0	\N
272602	1874	204006000	12321	6302	25	0	\N
272603	1874	204007000	12321	6302	26	0	\N
272604	1874	204008000	12321	6302	27	0	\N
272605	1874	204009000	12321	6302	28	0	\N
272606	1874	204010000	12321	6302	29	0	\N
272607	1874	204011000	12321	6302	30	0	\N
272608	1874	204012000	12321	6302	31	0	\N
272609	1874	204013000	12321	6302	32	0	\N
272610	1874	204014000	12321	6302	33	0	\N
272611	1874	204015000	12321	6302	34	0	\N
272612	1874	204016000	12321	6302	35	0	\N
272613	1874	204017000	12321	6302	36	0	\N
272614	1874	204018000	12321	6302	37	0	\N
272615	1874	204019000	12321	6302	38	0	\N
272616	1874	204020000	12321	6302	39	0	\N
272617	1874	204021000	12321	6302	40	0	\N
272618	1874	204022000	12321	6302	41	0	\N
272619	1874	204023000	12321	6302	42	0	\N
272620	1874	204024000	12321	6302	43	0	\N
272621	1874	204025000	12321	6302	44	0	\N
272622	1874	204026000	12321	6302	45	0	\N
272623	1874	204027000	12321	6302	46	0	\N
272624	1874	204028000	12321	6302	47	0	\N
272625	1874	204029000	12321	6302	48	0	\N
272626	1874	204030000	12321	6302	49	0	\N
272627	1874	204031000	12321	6302	50	0	\N
272628	1874	204032000	12321	6302	51	0	\N
272629	1874	204033000	12321	6302	53	0	\N
272630	1874	204034000	12321	6302	54	0	\N
272631	1874	204035000	12321	6302	55	0	\N
272632	1874	204036000	12321	6302	56	0	\N
272633	1874	204037000	12321	6302	57	0	\N
272644	1874	204054000	12326	6353	0	0	\N
272645	1874	204055000	12326	6353	1	0	\N
272646	1874	204056000	12326	6353	2	0	\N
272647	1874	204057000	12326	6353	3	0	\N
272648	1874	204054000	12327	6353	0	0	\N
272649	1874	204055000	12327	6353	1	0	\N
272650	1874	204056000	12327	6353	2	0	\N
272651	1874	204057000	12327	6353	3	0	\N
272652	1874	204054000	12328	6353	0	0	\N
272653	1874	204055000	12328	6353	1	0	\N
272654	1874	204056000	12328	6353	2	0	\N
272655	1874	204057000	12328	6353	3	0	\N
272658	1874	204059000	12333	6356	0	0	\N
272661	1874	204061000	12338	6359	0	0	\N
272663	1874	204063000	12340	6361	0	0	\N
272664	1874	204064000	12340	6361	1	0	\N
272665	1874	204063000	12341	6361	0	0	\N
272666	1874	204064000	12341	6361	1	0	\N
272673	938	505546858740000	12344	6362	0	0	\N
272674	1874	204065000	12344	6362	1	0	\N
272675	1874	204066000	12344	6362	2	0	\N
272676	1874	204067000	12344	6362	3	0	\N
272549	1046	905549465000000	12304	6337	0	0	0
272550	1874	204033000	12304	6337	1	0	0
272555	1166	607905750000000	12306	6338	0	0	0
272556	1713	770000000	12306	6338	1	0	0
272557	1874	204034000	12306	6338	2	0	0
272559	1874	204036000	12307	6339	0	0	0
272560	1166	610992750000000	12308	6340	0	0	0
272561	1874	204037000	12308	6340	1	0	0
272562	1874	204038000	12309	6341	0	0	0
272563	926	502778775000000	12310	6342	0	0	0
272565	926	505331775000000	12312	6344	0	0	0
272566	1874	204040000	12312	6344	1	0	0
272567	1874	204041000	12313	6345	0	0	0
272568	1874	204042000	12313	6345	1	0	0
272573	1874	204044000	12318	6347	0	0	0
272574	1874	204045000	12319	6348	0	0	0
272575	1874	204046000	12319	6348	1	0	0
272576	1874	204047000	12320	6349	0	0	0
272634	1874	204048000	12322	6350	0	0	0
272636	1874	204050000	12323	6351	0	0	0
272637	1874	204051000	12323	6351	1	0	0
272638	1874	204052000	12324	6352	0	0	0
272639	1874	204053000	12324	6352	1	0	0
272640	1874	204054000	12325	6353	0	0	0
272642	1874	204056000	12325	6353	2	0	0
272643	1874	204057000	12325	6353	3	0	0
272656	1874	204058000	12331	6355	0	0	0
272657	1874	204059000	12332	6356	0	0	0
272660	1874	204061000	12337	6359	0	0	0
272662	1874	204062000	12339	6360	0	0	0
272667	1874	204063000	12342	6361	0	0	0
272668	1874	204064000	12342	6361	1	0	0
272669	938	505546858740000	12343	6362	0	0	0
272671	1874	204066000	12343	6362	2	0	0
272672	1874	204067000	12343	6362	3	0	0
272677	1874	204068000	12345	6363	0	0	0
272678	1874	204069000	12346	6364	0	0	0
272679	1058	903742548740000	12347	6365	0	0	0
272686	1874	204072000	12350	6367	0	0	\N
272687	1874	204073000	12350	6367	1	0	\N
272688	1874	204074000	12352	6369	0	0	\N
272690	1874	204074000	12354	6369	0	0	\N
272696	1874	204079000	12358	6372	0	0	\N
272699	1874	204081000	12361	6374	0	0	\N
272700	1874	204081000	12362	6374	0	0	\N
272701	1874	204081000	12363	6374	0	0	\N
272710	1874	204090000	12368	6379	0	0	\N
272712	1874	204090000	12370	6379	0	0	\N
272715	938	505546858740000	12372	6135	0	0	\N
272716	1058	903742548740000	12372	6135	1	0	\N
272717	1178	612445521340000	12372	6135	2	0	\N
272718	1304	1698521409091650	12372	6135	3	0	\N
272719	1866	9452848201646	12372	6135	4	0	\N
272720	759	1001000000000	12372	6135	5	0	\N
272721	1292	1693981637751650	12372	6135	6	0	\N
272722	1292	1702582637751650	12372	6135	7	0	\N
272723	1046	900974465000000	12372	6135	8	0	\N
272724	1046	905549465000000	12372	6135	9	0	\N
272725	1166	607905750000000	12372	6135	10	0	\N
272726	1166	610992750000000	12372	6135	11	0	\N
272727	926	502778775000000	12372	6135	12	0	\N
272728	1360	1703067102686953	12372	6135	13	0	\N
272729	1234	611165531836822	12372	6135	14	0	\N
272730	1114	905806273145245	12372	6135	15	0	\N
272731	994	505474640261745	12372	6135	16	0	\N
272732	1386	1702583637751650	12372	6135	17	0	\N
272733	1140	905549465000000	12372	6135	18	0	\N
272734	1017	504693775000000	12372	6135	19	0	\N
272735	1257	610220750000000	12372	6135	20	0	\N
272736	1260	610992750000000	12372	6135	21	0	\N
272737	1137	904405465000000	12372	6135	22	0	\N
272738	1383	1700433637751650	12372	6135	23	0	\N
272739	1020	505331775000000	12372	6135	24	0	\N
272740	773	1003811812300	12372	6135	25	0	\N
272741	1021	504692059536962	12372	6135	26	0	\N
272742	1141	904403846488639	12372	6135	27	0	\N
272743	1261	610219296745574	12372	6135	28	0	\N
272744	1364	1700432637751650	12372	6135	29	0	\N
272745	1118	904405465000000	12372	6135	30	0	\N
272746	1238	610220750000000	12372	6135	31	0	\N
272747	1387	1700430328056211	12372	6135	32	0	\N
272748	478	66251579611955	12372	6135	33	0	\N
272749	998	504693775000000	12372	6135	34	0	\N
272750	1449	8053016459	12372	6135	35	0	\N
272751	1950	4079853000000	12372	6135	36	0	\N
272752	1600	0	12372	6135	37	0	\N
272753	1874	203825000	12372	6135	38	0	\N
272754	2027	1129000000000	12372	6135	39	0	\N
272755	1874	203826000	12372	6135	40	0	\N
272756	2058	586000000	12372	6135	41	0	\N
272757	1874	203827000	12372	6135	42	0	\N
272758	1874	203828000	12372	6135	43	0	\N
272759	1874	203829000	12372	6135	44	0	\N
272760	1874	203830000	12372	6135	45	0	\N
272761	2047	40000000	12372	6135	46	0	\N
272762	1874	203831000	12372	6135	48	0	\N
272763	1874	203832000	12372	6135	49	0	\N
272764	1874	203833000	12372	6135	50	0	\N
272765	1874	203834000	12372	6135	51	0	\N
272766	1874	203835000	12372	6135	52	0	\N
272767	1874	203836000	12372	6135	53	0	\N
272768	1874	203837000	12372	6135	54	0	\N
272769	1874	203838000	12372	6135	55	0	\N
272770	1874	203839000	12372	6135	56	0	\N
272771	1874	203840000	12372	6135	57	0	\N
272772	1090	907018590600000	12372	6135	58	0	\N
272773	970	506150798200000	12372	6135	59	0	\N
272774	1336	1705344664151650	12372	6135	60	0	\N
272775	1210	611983754800000	12372	6135	61	0	\N
272776	1874	203841000	12372	6135	62	0	\N
272777	1874	203842000	12372	6135	63	0	\N
272778	1874	203843000	12372	6135	64	0	\N
272779	1874	203844000	12372	6135	65	0	\N
272780	1874	203845000	12372	6135	66	0	\N
272781	1874	203846000	12372	6135	67	0	\N
272782	1874	203847000	12372	6135	68	0	\N
272783	1874	203848000	12372	6135	69	0	\N
272784	1874	203849000	12372	6135	70	0	\N
272785	1874	203850000	12372	6135	71	0	\N
272786	1874	203851000	12372	6135	72	0	\N
272787	1874	203852000	12372	6135	73	0	\N
272788	1874	203853000	12372	6135	74	0	\N
272789	1874	203854000	12372	6135	75	0	\N
272790	1874	203855000	12372	6135	76	0	\N
272791	1874	203856000	12372	6135	77	0	\N
272792	1874	203857000	12372	6135	78	0	\N
272793	1874	203858000	12372	6135	80	0	\N
272794	2060	200000000	12372	6135	81	0	\N
272795	1874	203859000	12372	6135	82	0	\N
272796	1874	203860000	12372	6135	83	0	\N
272797	1874	203861000	12372	6135	84	0	\N
272798	1874	203862000	12372	6135	85	0	\N
272799	1874	203863000	12372	6135	86	0	\N
272800	1874	203864000	12372	6135	87	0	\N
272801	1874	203865000	12372	6135	88	0	\N
272802	1874	203866000	12372	6135	89	0	\N
272803	1874	203867000	12372	6135	90	0	\N
272804	1874	203868000	12372	6135	91	0	\N
272805	1874	203869000	12372	6135	92	0	\N
272806	1874	203870000	12372	6135	93	0	\N
272807	1874	203871000	12372	6135	94	0	\N
272808	1874	203872000	12372	6135	95	0	\N
272809	1874	203873000	12372	6135	96	0	\N
272810	1874	203874000	12372	6135	97	0	\N
272811	1874	203875000	12372	6135	98	0	\N
272812	1874	203876000	12372	6135	99	0	\N
272813	1874	203877000	12372	6135	100	0	\N
272814	1874	203878000	12372	6135	101	0	\N
272815	1874	203879000	12372	6135	102	0	\N
272816	1874	203880000	12372	6135	103	0	\N
272683	1874	204071000	12348	6366	0	0	0
272684	1874	204072000	12349	6367	0	0	0
272685	1874	204073000	12349	6367	1	0	0
272689	1874	204074000	12353	6369	0	0	0
272691	1874	204075000	12355	6370	0	0	0
272693	1874	204077000	12356	6371	0	0	0
272694	1874	204078000	12356	6371	1	0	0
272695	1874	204079000	12357	6372	0	0	0
272697	1874	204080000	12359	6373	0	0	0
272698	1874	204081000	12360	6374	0	0	0
272703	1874	204083000	12364	6375	1	0	0
272704	1874	204084000	12365	6376	0	0	0
272705	1874	204085000	12365	6376	1	0	0
272706	1874	204086000	12366	6377	0	0	0
272708	1874	204088000	12367	6378	1	0	0
272709	1874	204089000	12367	6378	2	0	0
272711	1874	204090000	12369	6379	0	0	0
272713	1874	204091000	12371	6380	0	0	0
272714	1874	204092000	12371	6380	1	0	0
272817	1874	203881000	12372	6135	104	0	\N
272818	1874	203882000	12372	6135	105	0	\N
272819	1874	203883000	12372	6135	106	0	\N
272820	1874	203884000	12372	6135	107	0	\N
272821	1874	203885000	12372	6135	108	0	\N
272822	1874	203886000	12372	6135	109	0	\N
272823	1874	203887000	12372	6135	110	0	\N
272824	1874	203888000	12372	6135	111	0	\N
272825	1874	203889000	12372	6135	112	0	\N
272826	1874	203890000	12372	6135	113	0	\N
272827	1874	203891000	12372	6135	116	0	\N
272828	1874	203892000	12372	6135	117	0	\N
272829	1874	203893000	12372	6135	118	0	\N
272830	1874	203894000	12372	6135	119	0	\N
272831	1874	203895000	12372	6135	120	0	\N
272832	1874	203896000	12372	6135	121	0	\N
272833	1874	203897000	12372	6135	122	0	\N
272834	1874	203898000	12372	6135	123	0	\N
272835	1874	203899000	12372	6135	124	0	\N
272836	2061	200000000	12372	6135	125	0	\N
272839	1874	204094000	12375	6382	0	0	\N
272840	1874	204094000	12376	6382	0	0	\N
272841	1874	204095000	12377	6383	0	0	\N
272843	1874	204095000	12379	6383	0	0	\N
272849	1874	204100000	12385	6388	0	0	\N
272851	1874	204102000	12387	6390	0	0	\N
272852	1874	204102000	12388	6390	0	0	\N
272856	1874	204105000	12392	6392	0	0	\N
272860	1874	204107000	12395	6394	0	0	\N
272861	1874	204108000	12395	6394	1	0	\N
272865	1874	204110000	12398	6396	0	0	\N
272866	1874	204111000	12398	6396	1	0	\N
272867	1874	204110000	12399	6396	0	0	\N
272868	1874	204111000	12399	6396	1	0	\N
272871	1874	204112000	12402	6398	0	0	\N
272872	1874	204113000	12402	6398	1	0	\N
272875	1874	204114000	12404	6399	0	0	\N
272879	1874	204117000	12407	6401	0	0	\N
272880	1874	204117000	12408	6401	0	0	\N
272881	1874	204117000	12409	6401	0	0	\N
272883	1874	204118000	12411	6402	0	0	\N
272884	1874	204118000	12412	6402	0	0	\N
272885	1874	204118000	12413	6402	0	0	\N
272888	1874	204119000	12416	6403	0	0	\N
272889	1874	204119000	12417	6403	0	0	\N
272890	1538	0	12419	6404	0	0	\N
272891	1874	204120000	12419	6404	1	0	\N
272892	1874	204121000	12419	6404	2	0	\N
272896	1874	204114000	12421	6399	0	0	\N
272899	938	505546858740000	12445	6265	0	0	\N
272900	1058	903742548740000	12445	6265	1	0	\N
272901	1178	612445521340000	12445	6265	2	0	\N
272902	1304	1698521409091650	12445	6265	3	0	\N
272903	1866	9452848201646	12445	6265	4	0	\N
272904	759	1001000000000	12445	6265	5	0	\N
272905	1292	1693981637751650	12445	6265	6	0	\N
272906	1292	1702582637751650	12445	6265	7	0	\N
272907	1046	900974465000000	12445	6265	8	0	\N
272908	1046	905549465000000	12445	6265	9	0	\N
272909	1166	607905750000000	12445	6265	10	0	\N
272910	1166	610992750000000	12445	6265	11	0	\N
272911	926	502778775000000	12445	6265	12	0	\N
272912	926	505331775000000	12445	6265	13	0	\N
272913	1713	760000000	12445	6265	14	0	\N
272914	1360	1703067102686953	12445	6265	15	0	\N
272915	1234	611165531836822	12445	6265	16	0	\N
272916	1114	905806273145245	12445	6265	17	0	\N
272917	994	505474640261745	12445	6265	18	0	\N
272918	1386	1702583637751650	12445	6265	19	0	\N
272919	1140	905549465000000	12445	6265	20	0	\N
272920	1017	504693775000000	12445	6265	21	0	\N
272921	1257	610220750000000	12445	6265	22	0	\N
272922	1260	610992750000000	12445	6265	23	0	\N
272923	1137	904405465000000	12445	6265	24	0	\N
272924	1383	1700433637751650	12445	6265	25	0	\N
272925	1713	770000000	12445	6265	26	0	\N
272926	1020	505331775000000	12445	6265	27	0	\N
272927	773	1003811812300	12445	6265	28	0	\N
272928	1021	504692059536962	12445	6265	29	0	\N
272929	1141	904403846488639	12445	6265	30	0	\N
272930	1261	610219296745574	12445	6265	31	0	\N
272931	1364	1700432637751650	12445	6265	32	0	\N
272932	1118	904405465000000	12445	6265	33	0	\N
272933	1238	610220750000000	12445	6265	34	0	\N
272934	1387	1700430328056211	12445	6265	35	0	\N
272935	478	66251579611955	12445	6265	36	0	\N
272936	998	504693775000000	12445	6265	37	0	\N
272937	1600	0	12445	6265	38	0	\N
272938	1874	203958000	12445	6265	39	0	\N
272939	1874	203959000	12445	6265	40	0	\N
272940	1874	203960000	12445	6265	41	0	\N
272941	1874	203961000	12445	6265	42	0	\N
272942	1874	203962000	12445	6265	43	0	\N
272943	1874	203963000	12445	6265	44	0	\N
272944	1874	203964000	12445	6265	45	0	\N
272945	1874	203965000	12445	6265	46	0	\N
272946	1874	203966000	12445	6265	47	0	\N
272947	1874	203967000	12445	6265	48	0	\N
272948	1874	203968000	12445	6265	49	0	\N
272949	1874	203969000	12445	6265	50	0	\N
272950	1874	203970000	12445	6265	51	0	\N
272951	1874	203971000	12445	6265	52	0	\N
272952	1874	203972000	12445	6265	53	0	\N
272842	1874	204095000	12378	6383	0	0	0
272844	1874	204096000	12380	6384	0	0	0
272845	1874	204097000	12381	6385	0	0	0
272846	1874	204098000	12382	6386	0	0	0
272847	1874	204099000	12383	6387	0	0	0
272850	1874	204101000	12386	6389	0	0	0
272853	1874	204102000	12389	6390	0	0	0
272854	1874	204103000	12391	6391	0	0	0
272855	1874	204104000	12391	6391	2	0	0
272857	1874	204105000	12393	6392	0	0	0
272859	1874	204106000	12394	6393	1	0	0
272862	1874	204107000	12396	6394	0	0	0
272863	1874	204108000	12396	6394	1	0	0
272864	1874	204109000	12397	6395	0	0	0
272870	1874	204111000	12400	6396	1	0	0
272873	1874	204112000	12403	6398	0	0	0
272874	1874	204113000	12403	6398	1	0	0
272876	1874	204114000	12405	6399	0	0	0
272877	1874	204115000	12406	6400	0	0	0
272882	1874	204117000	12410	6401	0	0	0
272886	1874	204118000	12414	6402	0	0	0
272887	1874	204119000	12415	6403	0	0	0
272893	1538	0	12420	6404	0	0	0
272894	1874	204120000	12420	6404	1	0	0
272897	1874	204122000	12424	6405	0	0	0
272898	1874	204123000	12424	6405	1	0	0
272953	1874	203973000	12445	6265	54	0	\N
272954	1874	203974000	12445	6265	55	0	\N
272955	1874	203975000	12445	6265	56	0	\N
272956	2063	200000000	12445	6265	57	0	\N
272957	938	505546858740000	12459	6140	0	0	\N
272958	1058	903742548740000	12459	6140	1	0	\N
272959	1178	612445521340000	12459	6140	2	0	\N
272960	1304	1698521409091650	12459	6140	3	0	\N
272961	1866	9452848201646	12459	6140	4	0	\N
272962	1292	1693981637751650	12459	6140	5	0	\N
272963	1292	1702582637751650	12459	6140	6	0	\N
272964	1046	900974465000000	12459	6140	7	0	\N
272965	1046	905549465000000	12459	6140	8	0	\N
272966	1166	607905750000000	12459	6140	9	0	\N
272968	1773	4104187299982	12461	6420	0	0	\N
272976	1773	4104187299982	12472	6389	0	0	\N
272977	1874	204101000	12472	6389	1	0	\N
272978	1874	204102000	12472	6389	2	0	\N
272979	1874	204103000	12472	6389	3	0	\N
272980	1874	204104000	12472	6389	4	0	\N
272981	1874	204105000	12472	6389	5	0	\N
272982	131	66001200000000	12472	6389	6	0	\N
272983	1874	204106000	12472	6389	8	0	\N
272984	1874	204107000	12472	6389	9	0	\N
272985	1269	1000000	12472	6389	10	0	\N
272986	1874	204108000	12472	6389	11	0	\N
272987	1874	204109000	12472	6389	12	0	\N
272988	1874	204110000	12472	6389	13	0	\N
272989	1874	204111000	12472	6389	14	0	\N
272990	1874	204112000	12472	6389	15	0	\N
272991	1874	204113000	12472	6389	16	0	\N
272992	1874	204114000	12472	6389	17	0	\N
272993	1874	204115000	12472	6389	18	0	\N
272994	1874	204116000	12472	6389	19	0	\N
272995	1874	204117000	12472	6389	20	0	\N
272996	1874	204118000	12472	6389	21	0	\N
272997	1874	204119000	12472	6389	22	0	\N
272998	1874	204120000	12472	6389	23	0	\N
272999	1874	204121000	12472	6389	24	0	\N
273000	1874	204122000	12472	6389	25	0	\N
273001	1874	204123000	12472	6389	26	0	\N
273002	1269	2000000	12474	6428	0	0	\N
273004	1874	204124000	12477	6430	0	0	\N
273005	2064	200000000	12477	6430	1	0	\N
273006	2065	200000000	12477	6430	2	0	\N
273007	1874	204124000	12478	6430	0	0	\N
273008	2064	200000000	12478	6430	1	0	\N
273009	2065	200000000	12478	6430	2	0	\N
273020	1874	204130000	12485	6436	0	0	\N
273021	1874	204131000	12485	6436	1	0	\N
273022	1874	204132000	12485	6436	2	0	\N
273023	1874	204133000	12485	6436	3	0	\N
273024	1874	204130000	12486	6436	0	0	\N
273025	1874	204131000	12486	6436	1	0	\N
273026	1874	204132000	12486	6436	2	0	\N
273027	1874	204133000	12486	6436	3	0	\N
273032	1874	204134000	12488	6437	0	0	\N
273033	1874	204134000	12489	6437	0	0	\N
273035	1874	204135000	12491	6438	0	0	\N
273036	1874	204135000	12492	6438	0	0	\N
273038	1874	204135000	12494	6438	0	0	\N
273039	1874	204135000	12495	6438	0	0	\N
273040	1874	204135000	12496	6438	0	0	\N
273043	1678	12960388824000	12498	6440	0	0	\N
273044	1874	204137000	12498	6440	1	0	\N
273045	1678	12960388824000	12499	6440	0	0	\N
273046	1874	204137000	12499	6440	1	0	\N
273051	1678	12960388825000	12502	6441	0	0	\N
273052	1874	204138000	12502	6441	1	0	\N
273053	1678	12960388826000	12503	6442	0	0	\N
273054	1874	204139000	12503	6442	1	0	\N
273055	1678	12960388826000	12504	6442	0	0	\N
273056	1874	204139000	12504	6442	1	0	\N
273057	1678	12960388823000	12505	6438	0	0	\N
273058	1678	12960388824000	12505	6438	1	0	\N
273059	1678	12960388825000	12505	6438	2	0	\N
273060	1678	12960388826000	12505	6438	3	0	\N
273061	1874	204135000	12505	6438	4	0	\N
273062	1874	204136000	12505	6438	5	0	\N
273063	1874	204137000	12505	6438	6	0	\N
273064	1874	204138000	12505	6438	7	0	\N
273065	1874	204139000	12505	6438	8	0	\N
272970	702	44331624528302	12465	6422	1	0	0
272971	927	506563198332782	12465	6422	2	0	0
272972	1047	907756911178852	12465	6422	3	0	0
272973	1167	611481675306582	12465	6422	4	0	1
272974	1293	1706734649862574	12465	6422	5	0	0
273003	1269	2000000	12475	6428	0	0	0
273010	1874	204124000	12479	6430	0	0	0
273011	2064	200000000	12479	6430	1	0	0
273012	2065	200000000	12479	6430	2	0	0
273013	2066	200000000	12480	6431	0	0	0
273015	1874	204125000	12480	6431	2	0	0
273016	1874	204126000	12481	6432	0	0	0
273017	1874	204127000	12482	6433	0	0	0
273018	1874	204128000	12483	6434	0	0	0
273028	1874	204130000	12487	6436	0	0	0
273029	1874	204131000	12487	6436	1	0	0
273030	1874	204132000	12487	6436	2	0	0
273031	1874	204133000	12487	6436	3	0	0
273034	1874	204134000	12490	6437	0	0	0
273041	1678	12960388823000	12497	6439	0	0	0
273042	1874	204136000	12497	6439	1	0	0
273047	1678	12960388824000	12500	6440	0	0	0
273048	1874	204137000	12500	6440	1	0	0
273049	1678	12960388825000	12501	6441	0	0	0
273066	1678	12960388826000	12506	6442	0	0	0
273067	1874	204139000	12506	6442	1	0	0
273068	1874	204140000	12507	6443	0	0	0
273069	1678	12960388827000	12508	6444	0	0	0
273071	1678	12960388828000	12508	6444	2	0	0
273072	1678	12960388829000	12508	6444	3	0	0
273073	1678	12960388830000	12508	6444	4	0	0
273074	1678	12960388831000	12508	6444	5	0	0
273075	1678	12960388832000	12508	6444	6	0	0
273077	1874	204142000	12508	6444	8	0	0
273078	1874	204143000	12508	6444	9	0	0
273079	1874	204144000	12508	6444	10	0	0
273080	1874	204145000	12508	6444	11	0	0
273081	1678	12960388833000	12509	6445	0	0	0
273083	1874	204146000	12509	6445	2	0	0
273084	1874	204147000	12509	6445	3	0	0
273085	1678	12960388835000	12510	6446	0	0	0
273086	1874	204148000	12510	6446	1	0	0
273088	2063	1400000000	12511	6447	1	0	0
273094	1678	12960388839000	12513	6449	0	0	\N
273095	1874	204152000	12513	6449	1	0	\N
273100	1678	12960388841000	12516	6451	0	0	\N
273101	1874	204154000	12516	6451	1	0	\N
273104	1678	12960388842000	12518	6452	0	0	\N
273105	1874	204155000	12518	6452	1	0	\N
273108	1678	12960388842000	12520	6452	0	0	\N
273109	1874	204155000	12520	6452	1	0	\N
273114	1678	12960388843000	12522	6453	0	0	\N
273115	1678	12960388844000	12522	6453	1	0	\N
273116	1874	204156000	12522	6453	2	0	\N
273117	1874	204157000	12522	6453	3	0	\N
273124	1678	12960388845000	12524	6454	0	0	\N
273125	1678	12960388846000	12524	6454	1	0	\N
273126	1678	12960388847000	12524	6454	2	0	\N
273127	1874	204158000	12524	6454	3	0	\N
273128	1874	204159000	12524	6454	4	0	\N
273129	1874	204160000	12524	6454	5	0	\N
273130	1678	12960388845000	12525	6454	0	0	\N
273131	1678	12960388846000	12525	6454	1	0	\N
273132	1678	12960388847000	12525	6454	2	0	\N
273133	1874	204158000	12525	6454	3	0	\N
273134	1874	204159000	12525	6454	4	0	\N
273135	1874	204160000	12525	6454	5	0	\N
273138	1678	12960388849000	12527	6456	0	0	\N
273139	1874	204162000	12527	6456	1	0	\N
273146	1874	204165000	12531	6459	0	0	\N
273147	1678	12960388850000	12532	6457	0	0	\N
273148	1678	12960388851000	12532	6457	1	0	\N
273149	1874	204163000	12532	6457	2	0	\N
273150	1874	204164000	12532	6457	3	0	\N
273151	1874	204165000	12532	6457	4	0	\N
273152	1874	204165000	12533	6459	0	0	\N
273160	1678	12960388855000	12537	6462	0	0	\N
273161	1874	204169000	12537	6462	1	0	\N
273164	1678	12960388855000	12539	6462	0	0	\N
273165	1874	204169000	12539	6462	1	0	\N
273166	1678	12960388856000	12540	6463	0	0	\N
273167	1678	12960388857000	12540	6463	1	0	\N
273168	1874	204170000	12540	6463	2	0	\N
273169	1874	204171000	12540	6463	3	0	\N
273170	1678	12960388856000	12541	6463	0	0	\N
273171	1678	12960388857000	12541	6463	1	0	\N
273172	1874	204170000	12541	6463	2	0	\N
273173	1874	204171000	12541	6463	3	0	\N
273183	1678	12960388858000	12544	6464	0	0	\N
273184	1678	12960388859000	12544	6464	1	0	\N
273185	2068	0	12544	6464	2	0	\N
273186	1874	204172000	12544	6464	3	0	\N
273187	1874	204173000	12544	6464	4	0	\N
273188	1678	12960388860000	12545	6465	0	0	\N
273189	1874	204174000	12545	6465	1	0	\N
273192	1678	12960388860000	12547	6465	0	0	\N
273193	1874	204174000	12547	6465	1	0	\N
273194	1678	12960388861000	12551	6467	0	0	\N
273195	1678	12960388862000	12551	6467	1	0	\N
273196	1874	204175000	12551	6467	2	0	\N
273197	1874	204176000	12551	6467	3	0	\N
273198	938	505546858740000	12552	6352	0	0	\N
273199	1058	903742548740000	12552	6352	1	0	\N
273200	1178	612445521340000	12552	6352	2	0	\N
273201	1304	1698521409091650	12552	6352	4	0	\N
273202	1678	12960388823000	12552	6352	5	0	\N
273203	1678	12960388824000	12552	6352	6	0	\N
273204	1678	12960388825000	12552	6352	7	0	\N
273205	1678	12960388826000	12552	6352	8	0	\N
273206	1678	12960388827000	12552	6352	9	0	\N
273207	1678	12960388828000	12552	6352	10	0	\N
273208	1678	12960388829000	12552	6352	11	0	\N
273209	1678	12960388830000	12552	6352	12	0	\N
273210	1678	12960388831000	12552	6352	13	0	\N
273211	1678	12960388832000	12552	6352	14	0	\N
273212	1678	12960388833000	12552	6352	15	0	\N
273213	1678	12960388834000	12552	6352	16	0	\N
273214	1678	12960388835000	12552	6352	17	0	\N
273215	1678	12960388836000	12552	6352	18	0	\N
273216	1678	12960388837000	12552	6352	19	0	\N
273217	1678	12960388838000	12552	6352	20	0	\N
273218	1678	12960388839000	12552	6352	21	0	\N
273219	1678	12960388840000	12552	6352	22	0	\N
273220	1678	12960388841000	12552	6352	23	0	\N
273221	1678	12960388842000	12552	6352	24	0	\N
273222	1678	12960388843000	12552	6352	25	0	\N
273223	1678	12960388844000	12552	6352	26	0	\N
273224	1678	12960388845000	12552	6352	27	0	\N
273091	1678	12960388838000	12512	6448	1	0	0
273092	1874	204150000	12512	6448	2	0	0
273093	1874	204151000	12512	6448	3	0	0
273096	1678	12960388839000	12514	6449	0	0	0
273097	1874	204152000	12514	6449	1	0	0
273099	1874	204153000	12515	6450	1	0	0
273102	1678	12960388841000	12517	6451	0	0	0
273103	1874	204154000	12517	6451	1	0	0
273106	1678	12960388842000	12519	6452	0	0	0
273107	1874	204155000	12519	6452	1	0	0
273111	1678	12960388844000	12521	6453	1	0	0
273112	1874	204156000	12521	6453	2	0	0
273113	1874	204157000	12521	6453	3	0	0
273118	1678	12960388845000	12523	6454	0	0	0
273120	1678	12960388847000	12523	6454	2	0	0
273121	1874	204158000	12523	6454	3	0	0
273122	1874	204159000	12523	6454	4	0	0
273123	1874	204160000	12523	6454	5	0	0
273136	1678	12960388848000	12526	6455	0	0	0
273140	1678	12960388849000	12528	6456	0	0	0
273141	1874	204162000	12528	6456	1	0	0
273142	1874	204163000	12529	6457	0	0	0
273143	1678	12960388850000	12530	6458	0	0	0
273144	1678	12960388851000	12530	6458	1	0	0
273153	1874	204165000	12534	6459	0	0	0
273154	1678	12960388852000	12535	6460	0	0	0
273155	1874	204166000	12535	6460	1	0	0
273156	1678	12960388853000	12536	6461	0	0	0
273158	1874	204167000	12536	6461	2	0	0
273159	1874	204168000	12536	6461	3	0	0
273162	1678	12960388855000	12538	6462	0	0	0
273163	1874	204169000	12538	6462	1	0	0
273174	1678	12960388856000	12542	6463	0	0	0
273176	1874	204170000	12542	6463	2	0	0
273177	1874	204171000	12542	6463	3	0	0
273178	1678	12960388858000	12543	6464	0	0	0
273179	1678	12960388859000	12543	6464	1	0	0
273180	2068	0	12543	6464	2	0	0
273182	1874	204173000	12543	6464	4	0	0
273190	1678	12960388860000	12546	6465	0	0	0
273191	1874	204174000	12546	6465	1	0	0
273225	1678	12960388846000	12552	6352	28	0	\N
273226	1678	12960388847000	12552	6352	29	0	\N
273227	1678	12960388848000	12552	6352	30	0	\N
273228	1678	12960388849000	12552	6352	31	0	\N
273229	1678	12960388850000	12552	6352	32	0	\N
273230	1678	12960388851000	12552	6352	33	0	\N
273231	1678	12960388852000	12552	6352	34	0	\N
273232	1678	12960388853000	12552	6352	35	0	\N
273233	1678	12960388854000	12552	6352	36	0	\N
273234	1678	12960388855000	12552	6352	37	0	\N
273235	1678	12960388856000	12552	6352	38	0	\N
273236	1678	12960388857000	12552	6352	39	0	\N
273237	1678	12960388858000	12552	6352	40	0	\N
273238	1678	12960388859000	12552	6352	41	0	\N
273239	1678	12960388860000	12552	6352	42	0	\N
273240	1678	12960388861000	12552	6352	43	0	\N
273241	1678	12960388862000	12552	6352	44	0	\N
273242	1678	12960388863000	12552	6352	45	0	\N
273243	1773	4104187299982	12552	6352	46	0	\N
273244	2068	0	12552	6352	47	0	\N
273245	1874	204052000	12552	6352	48	0	\N
273246	1874	204053000	12552	6352	49	0	\N
273247	1874	204054000	12552	6352	50	0	\N
273248	1874	204055000	12552	6352	51	0	\N
273249	1874	204056000	12552	6352	52	0	\N
273250	1874	204057000	12552	6352	53	0	\N
273251	1874	204058000	12552	6352	54	0	\N
273252	1874	204059000	12552	6352	55	0	\N
273253	1269	1000000	12552	6352	56	0	\N
273254	1269	2000000	12552	6352	57	0	\N
273255	1874	204060000	12552	6352	58	0	\N
273256	1874	204061000	12552	6352	59	0	\N
273257	1874	204062000	12552	6352	60	0	\N
273258	1874	204063000	12552	6352	61	0	\N
273259	1874	204064000	12552	6352	62	0	\N
273260	1874	204065000	12552	6352	63	0	\N
273261	1874	204066000	12552	6352	64	0	\N
273262	1874	204067000	12552	6352	65	0	\N
273263	1874	204068000	12552	6352	66	0	\N
273264	1874	204069000	12552	6352	67	0	\N
273265	1874	204070000	12552	6352	68	0	\N
273266	1874	204071000	12552	6352	69	0	\N
273267	1874	204072000	12552	6352	70	0	\N
273268	1874	204073000	12552	6352	71	0	\N
273269	1874	204074000	12552	6352	72	0	\N
273270	1874	204075000	12552	6352	73	0	\N
273271	1874	204076000	12552	6352	74	0	\N
273272	1874	204077000	12552	6352	75	0	\N
273273	1874	204078000	12552	6352	76	0	\N
273274	1874	204079000	12552	6352	77	0	\N
273275	1874	204080000	12552	6352	78	0	\N
273276	1874	204081000	12552	6352	79	0	\N
273277	1874	204082000	12552	6352	80	0	\N
273278	1874	204083000	12552	6352	81	0	\N
273279	1874	204084000	12552	6352	82	0	\N
273280	1874	204085000	12552	6352	83	0	\N
273281	1874	204086000	12552	6352	84	0	\N
273282	1874	204087000	12552	6352	85	0	\N
273283	1874	204088000	12552	6352	86	0	\N
273284	1874	204089000	12552	6352	87	0	\N
273285	1874	204090000	12552	6352	88	0	\N
273286	1874	204091000	12552	6352	89	0	\N
273287	1874	204092000	12552	6352	90	0	\N
273288	1874	204093000	12552	6352	91	0	\N
273289	1874	204094000	12552	6352	92	0	\N
273290	1874	204095000	12552	6352	93	0	\N
273291	1874	204096000	12552	6352	94	0	\N
273292	1874	204097000	12552	6352	95	0	\N
273293	1874	204098000	12552	6352	96	0	\N
273294	1874	204099000	12552	6352	97	0	\N
273295	1874	204100000	12552	6352	98	0	\N
273296	1874	204101000	12552	6352	99	0	\N
273297	1874	204102000	12552	6352	100	0	\N
273298	1874	204103000	12552	6352	101	0	\N
273299	1874	204104000	12552	6352	102	0	\N
273300	1874	204105000	12552	6352	103	0	\N
273301	131	66001200000000	12552	6352	104	0	\N
273302	1874	204106000	12552	6352	105	0	\N
273303	1874	204107000	12552	6352	106	0	\N
273304	1874	204108000	12552	6352	107	0	\N
273305	1874	204109000	12552	6352	108	0	\N
273306	1874	204110000	12552	6352	109	0	\N
273307	1874	204111000	12552	6352	110	0	\N
273308	1874	204112000	12552	6352	111	0	\N
273309	1874	204113000	12552	6352	112	0	\N
273310	1874	204114000	12552	6352	113	0	\N
273311	1874	204115000	12552	6352	114	0	\N
273312	1874	204116000	12552	6352	115	0	\N
273313	1874	204117000	12552	6352	116	0	\N
273314	1874	204118000	12552	6352	117	0	\N
273315	1874	204119000	12552	6352	118	0	\N
273316	1874	204120000	12552	6352	119	0	\N
273317	1874	204121000	12552	6352	120	0	\N
273318	1874	204122000	12552	6352	121	0	\N
273319	1874	204123000	12552	6352	122	0	\N
273320	1874	204124000	12552	6352	123	0	\N
273321	2064	200000000	12552	6352	124	0	\N
273322	2065	200000000	12552	6352	125	0	\N
273337	1678	12960388868000	12556	6471	0	0	\N
273338	1874	204182000	12556	6471	1	0	\N
273339	1678	12960388868000	12557	6471	0	0	\N
273340	1874	204182000	12557	6471	1	0	\N
273343	1678	12960388869000	12559	6472	0	0	\N
273344	1678	12960388870000	12559	6472	1	0	\N
273345	1874	204183000	12559	6472	2	0	\N
273346	1874	204184000	12559	6472	3	0	\N
273347	1678	12960388869000	12560	6472	0	0	\N
273348	1678	12960388870000	12560	6472	1	0	\N
273349	1874	204183000	12560	6472	2	0	\N
273350	1874	204184000	12560	6472	3	0	\N
273357	1678	12960388860000	12563	6465	0	0	\N
273358	1678	12960388861000	12563	6465	1	0	\N
273359	1678	12960388862000	12563	6465	2	0	\N
273360	1678	12960388863000	12563	6465	3	0	\N
273325	1678	12960388863000	12553	6468	2	0	0
273326	1874	204175000	12553	6468	3	0	0
273327	1874	204176000	12553	6468	4	0	0
273328	1874	204177000	12553	6468	5	0	0
273329	1678	12960388864000	12554	6469	0	0	0
273331	1678	12960388865000	12555	6470	0	0	0
273332	1678	12960388866000	12555	6470	1	0	0
273333	1678	12960388867000	12555	6470	2	0	0
273334	1874	204179000	12555	6470	3	0	0
273335	1874	204180000	12555	6470	4	0	0
273341	1678	12960388868000	12558	6471	0	0	0
273342	1874	204182000	12558	6471	1	0	0
273351	1678	12960388869000	12561	6472	0	0	0
273352	1678	12960388870000	12561	6472	1	0	0
273354	1874	204184000	12561	6472	3	0	0
273355	1678	12960388871000	12562	6473	0	0	0
273356	1874	204185000	12562	6473	1	0	0
273361	1678	12960388864000	12563	6465	5	0	\N
273362	1678	12960388865000	12563	6465	6	0	\N
273363	1678	12960388866000	12563	6465	7	0	\N
273364	1678	12960388867000	12563	6465	8	0	\N
273371	1678	12960388874000	12567	6476	0	0	\N
273372	1874	204188000	12567	6476	1	0	\N
273382	1678	12960388879000	12569	6478	0	0	\N
273383	1874	204193000	12569	6478	1	0	\N
273384	1678	12960388879000	12570	6478	0	0	\N
273385	1874	204193000	12570	6478	1	0	\N
273394	1678	12960388882000	12575	6481	0	0	\N
273395	1874	204196000	12575	6481	1	0	\N
273406	1678	12960388886000	12579	6484	0	0	\N
273407	1392	1702113508751650	12579	6484	1	0	\N
273408	1146	905299076000000	12579	6484	2	0	\N
273409	1266	609371411000000	12579	6484	3	0	\N
273410	1026	505191632000000	12579	6484	4	0	\N
273411	1874	204200000	12579	6484	5	0	\N
273418	1678	12960388887000	12581	6485	0	0	\N
273419	1678	12960388887000	12582	6485	0	0	\N
273435	1678	12960388893000	12587	6488	0	0	\N
273436	1678	12960388894000	12587	6488	1	0	\N
273437	1874	204206000	12587	6488	2	0	\N
273438	1874	204207000	12587	6488	3	0	\N
273439	1678	12960388888000	12588	6486	0	0	\N
273440	1678	12960388889000	12588	6486	1	0	\N
273441	1678	12960388890000	12588	6486	2	0	\N
273442	1678	12960388891000	12588	6486	3	0	\N
273443	1678	12960388892000	12588	6486	4	0	\N
273444	1678	12960388893000	12588	6486	5	0	\N
273445	1678	12960388894000	12588	6486	6	0	\N
273446	1678	12960388895000	12588	6486	7	0	\N
273447	1874	204201000	12588	6486	8	0	\N
273448	1874	204202000	12588	6486	9	0	\N
273449	1874	204203000	12588	6486	10	0	\N
273450	1874	204204000	12588	6486	11	0	\N
273451	1874	204205000	12588	6486	12	0	\N
273452	1874	204206000	12588	6486	13	0	\N
273453	1874	204207000	12588	6486	14	0	\N
273454	1874	204208000	12588	6486	15	0	\N
273463	1678	12960388897000	12593	6492	0	0	\N
273464	1678	12960388898000	12593	6492	1	0	\N
273465	1874	204210000	12593	6492	2	0	\N
273466	1874	204211000	12593	6492	3	0	\N
273469	1678	12960388899000	12595	6493	0	0	\N
273470	1874	204212000	12595	6493	1	0	\N
273489	1678	13680399908000	12602	6499	0	0	\N
273490	1874	204221000	12602	6499	1	0	\N
273491	1678	13680399909000	12603	6500	0	0	\N
273492	1678	13680399910000	12603	6500	1	0	\N
273493	1678	13680399911000	12603	6500	2	0	\N
273494	1874	204222000	12603	6500	3	0	\N
273495	1874	204223000	12603	6500	4	0	\N
273496	1874	204224000	12603	6500	5	0	\N
273367	1678	12960388873000	12565	6475	0	0	0
273368	1874	204187000	12565	6475	1	0	0
273369	1678	12960388874000	12566	6476	0	0	0
273370	1874	204188000	12566	6476	1	0	0
273373	1678	12960388875000	12568	6477	0	0	0
273375	1678	12960388877000	12568	6477	2	0	0
273376	1678	12960388878000	12568	6477	3	0	0
273377	2068	1000000000	12568	6477	4	0	0
273378	1874	204189000	12568	6477	5	0	0
273379	1874	204190000	12568	6477	6	0	0
273381	1874	204192000	12568	6477	8	0	0
273386	1678	12960388879000	12571	6478	0	0	0
273387	1874	204193000	12571	6478	1	0	0
273388	1678	12960388880000	12572	6479	0	0	0
273390	1678	12960388881000	12573	6480	0	0	0
273391	1874	204195000	12573	6480	1	0	0
273392	1678	12960388882000	12574	6481	0	0	0
273393	1874	204196000	12574	6481	1	0	0
273396	1678	12960388883000	12576	6482	0	0	0
273398	1874	204197000	12576	6482	2	0	0
273399	1874	204198000	12576	6482	3	0	0
273400	921	504783215943484	12577	6483	0	0	0
273401	1041	904567197988098	12577	6483	1	0	0
273402	1678	12960388885000	12577	6483	2	0	0
273404	1287	1700737456165952	12577	6483	4	0	0
273405	1874	204199000	12577	6483	5	0	0
273412	1678	12960388886000	12580	6484	0	0	0
273413	1392	1702113508751650	12580	6484	1	0	0
273415	1266	609371411000000	12580	6484	3	0	1
273416	1026	505191632000000	12580	6484	4	0	0
273417	1874	204200000	12580	6484	5	0	0
273420	1678	12960388887000	12583	6485	0	0	0
273421	1678	12960388888000	12584	6486	0	0	0
273423	1678	12960388889000	12585	6487	0	0	0
273424	1678	12960388890000	12585	6487	1	0	0
273425	1678	12960388891000	12585	6487	2	0	0
273426	1678	12960388892000	12585	6487	3	0	0
273427	1874	204202000	12585	6487	4	0	0
273429	1874	204204000	12585	6487	6	0	0
273430	1874	204205000	12585	6487	7	0	0
273431	1678	12960388893000	12586	6488	0	0	0
273432	1678	12960388894000	12586	6488	1	0	0
273434	1874	204207000	12586	6488	3	0	0
273455	1678	12960388895000	12589	6489	0	0	0
273456	1874	204208000	12589	6489	1	0	0
273457	1678	12960388896000	12590	6490	0	0	0
273458	1874	204209000	12590	6490	1	0	0
273460	1678	12960388898000	12592	6492	1	0	0
273461	1874	204210000	12592	6492	2	0	0
273462	1874	204211000	12592	6492	3	0	0
273467	1678	12960388899000	12594	6493	0	0	0
273468	1874	204212000	12594	6493	1	0	0
273472	1678	12960388901000	12596	6494	1	0	0
273473	1678	12960388902000	12596	6494	2	0	0
273474	1678	12960388903000	12596	6494	3	0	0
273475	1874	204213000	12596	6494	4	0	0
273477	1874	204215000	12596	6494	6	0	0
273478	1874	204216000	12596	6494	7	0	0
273479	1678	12960388904000	12597	6495	0	0	0
273480	1874	204217000	12597	6495	1	0	0
273481	1678	12960388905000	12598	6496	0	0	0
273483	1678	12960388906000	12599	6497	0	0	0
273484	1874	204219000	12599	6497	1	0	0
273485	1678	13680399907000	12600	6498	0	0	0
273486	1874	204220000	12600	6498	1	0	0
273487	1678	13680399908000	12601	6499	0	0	0
273505	1678	13680399913000	12606	6502	0	0	\N
273506	1874	204226000	12606	6502	1	0	\N
273513	1678	13680399915000	12610	6504	0	0	\N
273514	1874	204228000	12610	6504	1	0	\N
273527	1678	13680399918000	12614	6507	0	0	\N
273528	1678	13680399919000	12614	6507	1	0	\N
273529	1678	13680399920000	12614	6507	2	0	\N
273530	1874	204231000	12614	6507	3	0	\N
273531	1745	1803000000	12614	6507	4	0	\N
273532	1474	6034358000023	12614	6507	5	0	\N
273533	1874	204232000	12614	6507	6	0	\N
273534	1874	204233000	12614	6507	7	0	\N
273537	1678	13680399922000	12616	6509	0	0	\N
273538	1874	204235000	12616	6509	1	0	\N
273565	1678	13680399934000	12626	6516	0	0	\N
273566	1874	204247000	12626	6516	1	0	\N
273567	1678	13680399935000	12631	6517	0	0	\N
273568	1874	204248000	12631	6517	1	0	\N
273571	1678	13680399935000	12633	6517	0	0	\N
273572	1874	204248000	12633	6517	1	0	\N
273573	1678	13680399936000	12634	6518	0	0	\N
273574	1874	204249000	12634	6518	1	0	\N
273577	1678	13680399936000	12636	6518	0	0	\N
273578	1874	204249000	12636	6518	1	0	\N
273591	1678	13680399940000	12639	6520	0	0	\N
273592	1678	13680399941000	12639	6520	1	0	\N
273593	1678	13680399942000	12639	6520	2	0	\N
273594	1874	204253000	12639	6520	3	0	\N
273595	1874	204254000	12639	6520	4	0	\N
273596	1874	204255000	12639	6520	5	0	\N
273597	938	505546858740000	12640	6242	0	0	\N
273598	1058	903742548740000	12640	6242	1	0	\N
273599	1178	612445521340000	12640	6242	2	0	\N
273600	1304	1698521409091650	12640	6242	3	0	\N
273601	1866	9452848201646	12640	6242	4	0	\N
273602	759	1001000000000	12640	6242	5	0	\N
273603	1292	1693981637751650	12640	6242	6	0	\N
273604	1292	1702582637751650	12640	6242	7	0	\N
273605	1046	900974465000000	12640	6242	8	0	\N
273606	1046	905549465000000	12640	6242	9	0	\N
273607	1166	607905750000000	12640	6242	10	0	\N
273608	1166	610992750000000	12640	6242	11	0	\N
273609	926	502778775000000	12640	6242	12	0	\N
273610	926	505331775000000	12640	6242	13	0	\N
273611	921	504783215943484	12640	6242	14	0	\N
273612	1678	12960388823000	12640	6242	15	0	\N
273613	1017	504693775000000	12640	6242	16	0	\N
273614	1257	610220750000000	12640	6242	17	0	\N
273615	1041	904567197988098	12640	6242	18	0	\N
273616	1137	904405465000000	12640	6242	19	0	\N
273617	1383	1700433637751650	12640	6242	20	0	\N
273618	1678	12960388824000	12640	6242	21	0	\N
273619	1678	12960388825000	12640	6242	22	0	\N
273620	1713	770000000	12640	6242	23	0	\N
273621	1161	610329513257268	12640	6242	24	0	\N
273622	1287	1700737456165952	12640	6242	25	0	\N
273623	1364	1700432637751650	12640	6242	26	0	\N
273624	1118	904405465000000	12640	6242	27	0	\N
273625	1238	610220750000000	12640	6242	28	0	\N
273626	998	504693775000000	12640	6242	29	0	\N
273627	1678	12960388826000	12640	6242	30	0	\N
273628	1678	12960388827000	12640	6242	31	0	\N
273629	1678	12960388828000	12640	6242	32	0	\N
273630	1678	12960388829000	12640	6242	33	0	\N
273631	1678	12960388830000	12640	6242	34	0	\N
273632	1678	12960388831000	12640	6242	35	0	\N
273499	1678	13680399911000	12604	6500	2	0	0
273500	1874	204222000	12604	6500	3	0	0
273501	1874	204223000	12604	6500	4	0	0
273502	1874	204224000	12604	6500	5	0	0
273503	1678	13680399912000	12605	6501	0	0	0
273507	1678	13680399913000	12607	6502	0	0	0
273508	1874	204226000	12607	6502	1	0	0
273509	1678	13680399914000	12608	6503	0	0	0
273510	1874	204227000	12608	6503	1	0	0
273511	1678	13680399915000	12609	6504	0	0	0
273515	1678	13680399916000	12611	6505	0	0	0
273516	1874	204229000	12611	6505	1	0	0
273517	1678	13680399917000	12612	6506	0	0	0
273518	1874	204230000	12612	6506	1	0	0
273520	1678	13680399919000	12613	6507	1	0	0
273521	1678	13680399920000	12613	6507	2	0	0
273522	1874	204231000	12613	6507	3	0	0
273523	1745	1803000000	12613	6507	4	0	5
273524	1474	6034358000023	12613	6507	5	0	13
273526	1874	204233000	12613	6507	7	0	0
273535	1678	13680399921000	12615	6508	0	0	0
273536	1874	204234000	12615	6508	1	0	0
273539	1678	13680399922000	12617	6509	0	0	0
273540	1874	204235000	12617	6509	1	0	0
273542	1678	13680399924000	12618	6510	1	0	0
273543	1874	204236000	12618	6510	2	0	0
273544	1874	204237000	12618	6510	3	0	0
273545	1678	13680399925000	12619	6511	0	0	0
273547	1874	204238000	12619	6511	2	0	0
273548	1874	204239000	12619	6511	3	0	0
273549	1678	13680399927000	12620	6512	0	0	0
273550	1874	204240000	12620	6512	1	0	0
273551	1678	13680399928000	12621	6513	0	0	0
273553	1678	13680399930000	12621	6513	2	0	0
273554	1874	204241000	12621	6513	3	0	0
273555	1874	204242000	12621	6513	4	0	0
273556	1874	204243000	12621	6513	5	0	0
273557	1678	13680399931000	12622	6514	0	0	0
273559	1874	204244000	12622	6514	2	0	0
273560	1874	204245000	12622	6514	3	0	0
273561	1678	13680399933000	12623	6515	0	0	0
273562	1874	204246000	12623	6515	1	0	0
273564	1874	204247000	12625	6516	1	0	0
273569	1678	13680399935000	12632	6517	0	0	0
273570	1874	204248000	12632	6517	1	0	0
273575	1678	13680399936000	12635	6518	0	0	0
273576	1874	204249000	12635	6518	1	0	0
273580	1678	13680399938000	12637	6519	1	0	0
273581	1678	13680399939000	12637	6519	2	0	0
273582	1874	204250000	12637	6519	3	0	0
273583	1874	204251000	12637	6519	4	0	0
273584	1874	204252000	12637	6519	5	0	0
273586	1678	13680399941000	12638	6520	1	0	0
273587	1678	13680399942000	12638	6520	2	0	0
273588	1874	204253000	12638	6520	3	0	0
273589	1874	204254000	12638	6520	4	0	0
273633	1678	12960388832000	12640	6242	36	0	\N
273634	1678	12960388833000	12640	6242	37	0	\N
273635	1678	12960388834000	12640	6242	39	0	\N
273636	1678	12960388835000	12640	6242	40	0	\N
273637	1678	12960388836000	12640	6242	41	0	\N
273638	1678	12960388837000	12640	6242	42	0	\N
273639	1678	12960388838000	12640	6242	43	0	\N
273640	1678	12960388839000	12640	6242	44	0	\N
273641	1678	12960388840000	12640	6242	45	0	\N
273642	1678	12960388841000	12640	6242	46	0	\N
273643	1678	12960388842000	12640	6242	47	0	\N
273644	1678	12960388843000	12640	6242	48	0	\N
273645	1678	12960388844000	12640	6242	49	0	\N
273646	1678	12960388845000	12640	6242	50	0	\N
273647	1678	12960388846000	12640	6242	51	0	\N
273648	1678	12960388847000	12640	6242	52	0	\N
273649	1678	12960388848000	12640	6242	53	0	\N
273650	1678	12960388849000	12640	6242	54	0	\N
273651	1678	12960388850000	12640	6242	55	0	\N
273652	1678	12960388851000	12640	6242	56	0	\N
273653	1678	12960388852000	12640	6242	57	0	\N
273654	1678	12960388853000	12640	6242	58	0	\N
273655	1678	12960388854000	12640	6242	59	0	\N
273656	1678	12960388855000	12640	6242	60	0	\N
273657	1678	12960388856000	12640	6242	61	0	\N
273658	1678	12960388857000	12640	6242	62	0	\N
273659	1678	12960388858000	12640	6242	63	0	\N
273660	1678	12960388859000	12640	6242	64	0	\N
273661	1678	12960388860000	12640	6242	65	0	\N
273662	1678	12960388861000	12640	6242	66	0	\N
273663	1678	12960388862000	12640	6242	67	0	\N
273664	1678	12960388863000	12640	6242	68	0	\N
273665	1678	12960388864000	12640	6242	69	0	\N
273666	1678	12960388865000	12640	6242	70	0	\N
273667	1678	12960388866000	12640	6242	71	0	\N
273668	1678	12960388867000	12640	6242	72	0	\N
273669	1678	12960388868000	12640	6242	73	0	\N
273670	1678	12960388869000	12640	6242	74	0	\N
273671	1678	12960388870000	12640	6242	75	0	\N
273672	1678	12960388871000	12640	6242	76	0	\N
273673	1678	12960388872000	12640	6242	77	0	\N
273674	1678	12960388873000	12640	6242	78	0	\N
273675	1678	12960388874000	12640	6242	79	0	\N
273676	1678	12960388875000	12640	6242	80	0	\N
273677	1678	12960388876000	12640	6242	81	0	\N
273678	1678	12960388877000	12640	6242	82	0	\N
273679	1678	12960388878000	12640	6242	83	0	\N
273680	1678	12960388879000	12640	6242	84	0	\N
273681	1678	12960388880000	12640	6242	85	0	\N
273682	1678	12960388881000	12640	6242	86	0	\N
273683	1678	12960388882000	12640	6242	87	0	\N
273684	1678	12960388883000	12640	6242	88	0	\N
273685	1678	12960388884000	12640	6242	89	0	\N
273686	1678	12960388885000	12640	6242	90	0	\N
273687	1678	12960388886000	12640	6242	91	0	\N
273688	1678	12960388887000	12640	6242	92	0	\N
273689	1678	12960388888000	12640	6242	93	0	\N
273690	1678	12960388889000	12640	6242	94	0	\N
273691	1678	12960388890000	12640	6242	95	0	\N
273692	1678	12960388891000	12640	6242	96	0	\N
273693	1678	12960388892000	12640	6242	97	0	\N
273694	1678	12960388893000	12640	6242	98	0	\N
273695	1678	12960388894000	12640	6242	99	0	\N
273696	1678	12960388895000	12640	6242	100	0	\N
273697	1678	12960388896000	12640	6242	101	0	\N
273698	1678	12960388897000	12640	6242	102	0	\N
273699	1678	12960388898000	12640	6242	103	0	\N
273700	1678	12960388899000	12640	6242	104	0	\N
273701	1678	12960388900000	12640	6242	105	0	\N
273702	1678	12960388901000	12640	6242	106	0	\N
273703	1678	12960388902000	12640	6242	107	0	\N
273704	1678	12960388903000	12640	6242	108	0	\N
273705	1678	12960388904000	12640	6242	109	0	\N
273706	1678	12960388905000	12640	6242	110	0	\N
273707	1678	12960388906000	12640	6242	111	0	\N
273708	1678	12960388907000	12640	6242	112	0	\N
273709	1678	12960388908000	12640	6242	113	0	\N
273710	1678	12960388909000	12640	6242	114	0	\N
273711	1678	12960388910000	12640	6242	115	0	\N
273712	1678	12960388911000	12640	6242	116	0	\N
273713	1678	12960388912000	12640	6242	117	0	\N
273714	1678	12960388913000	12640	6242	118	0	\N
273715	1678	12960388914000	12640	6242	119	0	\N
273716	1678	12960388915000	12640	6242	120	0	\N
273717	1678	12960388916000	12640	6242	121	0	\N
273718	1678	12960388917000	12640	6242	122	0	\N
273719	1678	12960388918000	12640	6242	123	0	\N
273720	1678	12960388919000	12640	6242	124	0	\N
273721	1678	12960388920000	12640	6242	125	0	\N
273724	1678	13680399943000	12642	6521	0	0	\N
273725	1874	204256000	12642	6521	1	0	\N
273726	1678	13680399943000	12643	6521	0	0	\N
273727	1874	204256000	12643	6521	1	0	\N
273728	1678	13680399943000	12644	6521	0	0	\N
273729	1678	13680399944000	12644	6521	1	0	\N
273730	1874	204256000	12644	6521	2	0	\N
273735	1678	13680399945000	12647	6523	0	0	\N
273736	1874	204258000	12647	6523	1	0	\N
273737	1678	13680399945000	12648	6523	0	0	\N
273738	1874	204258000	12648	6523	1	0	\N
273748	1678	13680399947000	12651	6525	0	0	\N
273749	1678	13680399948000	12651	6525	1	0	\N
273750	1678	13680399949000	12651	6525	2	0	\N
273751	1745	1803000000	12651	6525	3	0	\N
273752	1874	204260000	12651	6525	4	0	\N
273753	1874	204261000	12651	6525	5	0	\N
273754	1874	204262000	12651	6525	6	0	\N
273759	1678	13680399952000	12654	6528	0	0	\N
273760	1678	13680399953000	12654	6528	1	0	\N
273761	1678	13680399954000	12654	6528	2	0	\N
273762	1874	204265000	12654	6528	3	0	\N
273763	1874	204266000	12654	6528	4	0	\N
273764	1874	204267000	12654	6528	5	0	\N
273765	1745	1803000000	12654	6528	6	0	\N
273731	1678	13680399944000	12645	6522	0	0	0
273732	1874	204257000	12645	6522	1	0	0
273733	1678	13680399945000	12646	6523	0	0	0
273734	1874	204258000	12646	6523	1	0	0
273739	1678	13680399946000	12649	6524	0	0	0
273741	1678	13680399947000	12650	6525	0	0	0
273742	1678	13680399948000	12650	6525	1	0	0
273743	1678	13680399949000	12650	6525	2	0	0
273744	1745	1803000000	12650	6525	3	0	5
273745	1874	204260000	12650	6525	4	0	0
273747	1874	204262000	12650	6525	6	0	0
273755	1678	13680399950000	12652	6526	0	0	0
273756	1874	204263000	12652	6526	1	0	0
273757	1678	13680399951000	12653	6527	0	0	0
273766	1678	13680399952000	12655	6528	0	0	0
273767	1678	13680399953000	12655	6528	1	0	0
273768	1678	13680399954000	12655	6528	2	0	0
273773	1678	13680399952000	12656	6528	0	0	\N
273774	1678	13680399953000	12656	6528	1	0	\N
273775	1678	13680399954000	12656	6528	2	0	\N
273776	1874	204265000	12656	6528	3	0	\N
273777	1874	204266000	12656	6528	4	0	\N
273778	1874	204267000	12656	6528	5	0	\N
273779	1745	1803000000	12656	6528	6	0	\N
273780	1678	13680399955000	12657	6529	0	0	\N
273781	1874	204268000	12657	6529	1	0	\N
273782	1745	1803000000	12657	6529	2	0	\N
273789	1678	13680399956000	12660	6530	0	0	\N
273790	1874	204269000	12660	6530	1	0	\N
273791	1745	1803000000	12660	6530	2	0	\N
273800	1874	204271000	12663	6532	0	0	\N
273801	1678	13680399958000	12664	6532	0	0	\N
273802	1874	204271000	12664	6532	1	0	\N
273808	1678	13680399961000	12666	6534	0	0	\N
273809	1874	204274000	12666	6534	1	0	\N
273810	1745	1803000000	12666	6534	2	0	\N
273814	1678	13680399961000	12668	6534	0	0	\N
273815	1874	204274000	12668	6534	1	0	\N
273816	1745	1803000000	12668	6534	2	0	\N
273824	1678	13680399963000	12672	6536	0	0	\N
273825	1678	13680399964000	12672	6536	1	0	\N
273826	1874	204276000	12672	6536	2	0	\N
273827	1874	204277000	12672	6536	3	0	\N
273828	1745	1803000000	12672	6536	4	0	\N
273829	1678	13680399963000	12673	6536	0	0	\N
273830	1678	13680399964000	12673	6536	1	0	\N
273831	1874	204276000	12673	6536	2	0	\N
273832	1874	204277000	12673	6536	3	0	\N
273833	1745	1803000000	12673	6536	4	0	\N
273836	1678	13680399965000	12675	6537	0	0	\N
273837	1874	204278000	12675	6537	1	0	\N
273838	1678	13680399966000	12676	6538	0	0	\N
273839	1678	13680399967000	12676	6538	1	0	\N
273840	1874	204279000	12676	6538	2	0	\N
273841	1874	204280000	12676	6538	3	0	\N
273848	1678	13680399968000	12679	6539	0	0	\N
273849	1874	204281000	12679	6539	1	0	\N
273850	1678	13680399968000	12680	6539	0	0	\N
273851	1874	204281000	12680	6539	1	0	\N
273858	1678	13680399971000	12683	6541	0	0	\N
273859	1874	204284000	12683	6541	1	0	\N
273862	1678	13680399972000	12685	6542	0	0	\N
273863	1874	204285000	12685	6542	1	0	\N
273864	1678	13680399972000	12686	6542	0	0	\N
273865	1678	13680399973000	12687	6543	0	0	\N
273866	1874	204286000	12687	6543	1	0	\N
273869	1678	13680399974000	12689	6544	0	0	\N
273870	1874	204287000	12689	6544	1	0	\N
273873	1678	13680399975000	12691	6545	0	0	\N
273874	1874	204288000	12691	6545	1	0	\N
273875	1678	13680399975000	12692	6545	0	0	\N
273876	1874	204288000	12692	6545	1	0	\N
273878	1678	13680399976000	12694	6546	0	0	\N
273879	1874	204288000	12694	6546	1	0	\N
273886	1678	13680399979000	12697	6548	0	0	\N
273887	1874	204291000	12697	6548	1	0	\N
273894	1678	13680399982000	12701	6551	0	0	\N
273895	1678	13680399983000	12701	6551	1	0	\N
273896	1874	204294000	12701	6551	2	0	\N
273897	1874	204295000	12701	6551	3	0	\N
273902	1678	13680399984000	12703	6552	0	0	\N
273903	1874	204296000	12703	6552	1	0	\N
273771	1874	204267000	12655	6528	5	0	0
273772	1745	1803000000	12655	6528	6	0	5
273783	1678	13680399955000	12658	6529	0	0	0
273784	1874	204268000	12658	6529	1	0	0
273785	1745	1803000000	12658	6529	2	0	5
273787	1874	204269000	12659	6530	1	0	0
273788	1745	1803000000	12659	6530	2	0	5
273792	1678	13680399957000	12661	6531	0	0	0
273793	1745	1803000000	12661	6531	1	0	5
273794	1874	204270000	12661	6531	2	0	0
273796	2070	200000000	12661	6531	4	0	0
273797	2071	200000000	12661	6531	5	0	0
273798	1678	13680399958000	12662	6532	0	0	0
273799	1874	204271000	12662	6532	1	0	0
273804	1678	13680399960000	12665	6533	1	0	0
273805	1745	1803000000	12665	6533	2	0	5
273806	1874	204272000	12665	6533	3	0	0
273807	1874	204273000	12665	6533	4	0	0
273811	1678	13680399961000	12667	6534	0	0	0
273813	1745	1803000000	12667	6534	2	0	5
273817	1678	13680399962000	12670	6535	0	0	0
273818	1874	204275000	12670	6535	1	0	0
273819	1678	13680399963000	12671	6536	0	0	0
273820	1678	13680399964000	12671	6536	1	0	0
273822	1874	204277000	12671	6536	3	0	0
273823	1745	1803000000	12671	6536	4	0	5
273834	1678	13680399965000	12674	6537	0	0	0
273835	1874	204278000	12674	6537	1	0	0
273843	1678	13680399967000	12677	6538	1	0	0
273844	1874	204279000	12677	6538	2	0	0
273845	1874	204280000	12677	6538	3	0	0
273846	1678	13680399968000	12678	6539	0	0	0
273847	1874	204281000	12678	6539	1	0	0
273853	1678	13680399970000	12681	6540	1	0	0
273854	1874	204282000	12681	6540	3	0	0
273855	1874	204283000	12681	6540	4	0	0
273856	1678	13680399971000	12682	6541	0	0	0
273857	1874	204284000	12682	6541	1	0	0
273861	1874	204285000	12684	6542	1	0	0
273867	1678	13680399973000	12688	6543	0	0	0
273868	1874	204286000	12688	6543	1	0	0
273871	1678	13680399974000	12690	6544	0	0	0
273877	1678	13680399975000	12693	6545	0	0	0
273880	1678	13680399976000	12695	6546	0	0	0
273881	1874	204288000	12695	6546	1	0	0
273882	1678	13680399977000	12696	6547	0	0	0
273883	1678	13680399978000	12696	6547	1	0	0
273885	1874	204290000	12696	6547	3	0	0
273888	1678	13680399979000	12698	6548	0	0	0
273889	1874	204291000	12698	6548	1	0	0
273890	1678	13680399980000	12699	6549	0	0	0
273891	1874	204292000	12699	6549	1	0	0
273893	1874	204293000	12700	6550	1	0	0
273898	1678	13680399982000	12702	6551	0	0	0
273899	1678	13680399983000	12702	6551	1	0	0
273900	1874	204294000	12702	6551	2	0	0
273904	1678	13680399984000	12704	6552	0	0	0
273908	1678	13680399985000	12706	6553	0	0	\N
273909	1874	204297000	12706	6553	1	0	\N
273910	1678	13680399985000	12707	6553	0	0	\N
273911	1874	204297000	12707	6553	1	0	\N
273912	1678	13680399985000	12708	6553	0	0	\N
273913	1874	204297000	12708	6553	1	0	\N
273918	1678	13680399986000	12710	6554	0	0	\N
273919	1678	13680399987000	12710	6554	1	0	\N
273920	1874	204298000	12710	6554	2	0	\N
273921	1874	204299000	12710	6554	3	0	\N
273922	1678	13680399986000	12711	6554	0	0	\N
273923	1678	13680399987000	12711	6554	1	0	\N
273924	1874	204298000	12711	6554	2	0	\N
273925	1874	204299000	12711	6554	3	0	\N
273928	1678	13680399988000	12713	6555	0	0	\N
273929	1874	204300000	12713	6555	1	0	\N
273930	1678	13680399989000	12714	6556	0	0	\N
273931	1678	13680399990000	12714	6556	1	0	\N
273932	1678	13680399991000	12714	6556	2	0	\N
273933	1874	204301000	12714	6556	3	0	\N
273934	1874	204302000	12714	6556	4	0	\N
273935	1874	204303000	12714	6556	5	0	\N
273942	921	504783215943484	12716	6480	0	0	\N
273943	1678	12960388881000	12716	6480	1	0	\N
273944	1678	12960388882000	12716	6480	2	0	\N
273945	1678	12960388883000	12716	6480	3	0	\N
273946	1041	904567197988098	12716	6480	4	0	\N
273947	1161	610329513257268	12716	6480	5	0	\N
273948	1287	1700737456165952	12716	6480	6	0	\N
273949	1678	12960388884000	12716	6480	7	0	\N
273950	1678	12960388885000	12716	6480	8	0	\N
273951	1678	12960388886000	12716	6480	9	0	\N
273952	1678	12960388887000	12716	6480	10	0	\N
273953	1678	12960388888000	12716	6480	11	0	\N
273954	1678	12960388889000	12716	6480	12	0	\N
273955	1678	12960388890000	12716	6480	13	0	\N
273956	1678	12960388891000	12716	6480	14	0	\N
273957	1678	12960388892000	12716	6480	15	0	\N
273958	1678	12960388893000	12716	6480	16	0	\N
273959	1678	12960388894000	12716	6480	17	0	\N
273960	1678	12960388895000	12716	6480	18	0	\N
273961	1678	12960388896000	12716	6480	19	0	\N
273962	1678	12960388897000	12716	6480	20	0	\N
273963	1678	12960388898000	12716	6480	21	0	\N
273964	1678	12960388899000	12716	6480	22	0	\N
273965	1678	12960388900000	12716	6480	23	0	\N
273966	1678	12960388901000	12716	6480	24	0	\N
273967	1678	12960388902000	12716	6480	25	0	\N
273968	1678	12960388903000	12716	6480	26	0	\N
273969	1678	12960388904000	12716	6480	27	0	\N
273970	1678	12960388905000	12716	6480	28	0	\N
273971	1678	12960388906000	12716	6480	29	0	\N
273972	1678	12960388907000	12716	6480	30	0	\N
273973	1678	12960388908000	12716	6480	31	0	\N
273974	1678	12960388909000	12716	6480	32	0	\N
273975	1678	12960388910000	12716	6480	33	0	\N
273976	1678	12960388911000	12716	6480	34	0	\N
273977	1678	12960388912000	12716	6480	35	0	\N
273978	1678	12960388913000	12716	6480	36	0	\N
273979	1678	12960388914000	12716	6480	37	0	\N
273980	1678	12960388915000	12716	6480	38	0	\N
273981	1678	12960388916000	12716	6480	39	0	\N
273982	1678	12960388917000	12716	6480	40	0	\N
273983	1678	12960388918000	12716	6480	41	0	\N
273984	1874	204195000	12716	6480	42	0	\N
273985	1745	1803000000	12716	6480	43	0	\N
273986	1874	204196000	12716	6480	44	0	\N
273987	1874	204197000	12716	6480	45	0	\N
273988	1874	204198000	12716	6480	46	0	\N
273989	1874	204199000	12716	6480	47	0	\N
273990	1745	1803000000	12716	6480	48	0	\N
273991	1392	1702113508751650	12716	6480	49	0	\N
273992	1146	905299076000000	12716	6480	50	0	\N
273993	1266	609371411000000	12716	6480	51	0	\N
273994	1026	505191632000000	12716	6480	52	0	\N
273995	1474	6034358000023	12716	6480	53	0	\N
273996	1874	204200000	12716	6480	54	0	\N
273997	1874	204201000	12716	6480	55	0	\N
273998	1874	204202000	12716	6480	56	0	\N
273999	1874	204203000	12716	6480	57	0	\N
274000	1745	1803000000	12716	6480	58	0	\N
274001	1745	1803000000	12716	6480	59	0	\N
274002	1745	1803000000	12716	6480	60	0	\N
274003	1745	1803000000	12716	6480	62	0	\N
274004	1745	1803000000	12716	6480	63	0	\N
274005	1745	1803000000	12716	6480	64	0	\N
274006	1745	1803000000	12716	6480	65	0	\N
274007	1874	204204000	12716	6480	66	0	\N
274008	1874	204205000	12716	6480	67	0	\N
274009	1874	204206000	12716	6480	68	0	\N
274010	1874	204207000	12716	6480	69	0	\N
274011	1874	204208000	12716	6480	70	0	\N
274012	1874	204209000	12716	6480	71	0	\N
274013	1874	204210000	12716	6480	72	0	\N
274014	1874	204211000	12716	6480	73	0	\N
274015	1874	204212000	12716	6480	74	0	\N
274016	1874	204213000	12716	6480	75	0	\N
274017	1874	204214000	12716	6480	76	0	\N
274018	1874	204215000	12716	6480	77	0	\N
274019	1874	204216000	12716	6480	78	0	\N
274020	1874	204217000	12716	6480	79	0	\N
274021	1874	204218000	12716	6480	80	0	\N
274022	1874	204219000	12716	6480	81	0	\N
274023	1874	204220000	12716	6480	82	0	\N
274024	1874	204221000	12716	6480	83	0	\N
274025	1874	204222000	12716	6480	84	0	\N
274026	1874	204223000	12716	6480	85	0	\N
274027	1874	204224000	12716	6480	86	0	\N
274028	1874	204225000	12716	6480	87	0	\N
274029	1874	204226000	12716	6480	88	0	\N
274030	1874	204227000	12716	6480	89	0	\N
274031	1874	204228000	12716	6480	90	0	\N
274032	1874	204229000	12716	6480	91	0	\N
274033	1874	204230000	12716	6480	92	0	\N
274034	1874	204231000	12716	6480	93	0	\N
274035	1874	204232000	12716	6480	94	0	\N
274036	1874	204233000	12716	6480	95	0	\N
274037	1874	204234000	12716	6480	96	0	\N
274038	1874	204235000	12716	6480	97	0	\N
274039	1874	204236000	12716	6480	98	0	\N
274040	1874	204237000	12716	6480	99	0	\N
273907	1874	204297000	12705	6553	1	0	0
273914	1678	13680399986000	12709	6554	0	0	0
273915	1678	13680399987000	12709	6554	1	0	0
273916	1874	204298000	12709	6554	2	0	0
273917	1874	204299000	12709	6554	3	0	0
273927	1874	204300000	12712	6555	1	0	0
273936	1678	13680399989000	12715	6556	0	0	0
273937	1678	13680399990000	12715	6556	1	0	0
273938	1678	13680399991000	12715	6556	2	0	0
273939	1874	204301000	12715	6556	3	0	0
273941	1874	204303000	12715	6556	5	0	0
274041	1874	204238000	12716	6480	100	0	\N
274042	1874	204239000	12716	6480	101	0	\N
274043	1874	204240000	12716	6480	102	0	\N
274044	1874	204241000	12716	6480	103	0	\N
274045	1874	204242000	12716	6480	104	0	\N
274046	1874	204243000	12716	6480	105	0	\N
274047	1874	204244000	12716	6480	106	0	\N
274048	1874	204245000	12716	6480	107	0	\N
274049	1874	204246000	12716	6480	108	0	\N
274050	1874	204247000	12716	6480	109	0	\N
274051	1874	204248000	12716	6480	110	0	\N
274052	1874	204249000	12716	6480	111	0	\N
274053	1874	204250000	12716	6480	112	0	\N
274054	1874	204251000	12716	6480	113	0	\N
274055	1874	204252000	12716	6480	114	0	\N
274056	1874	204253000	12716	6480	115	0	\N
274057	1874	204254000	12716	6480	116	0	\N
274058	1874	204255000	12716	6480	117	0	\N
274059	1874	204256000	12716	6480	118	0	\N
274060	1874	204257000	12716	6480	119	0	\N
274061	1874	204258000	12716	6480	120	0	\N
274062	1874	204259000	12716	6480	121	0	\N
274063	1874	204260000	12716	6480	122	0	\N
274064	1874	204261000	12716	6480	123	0	\N
274065	1874	204262000	12716	6480	124	0	\N
274066	1874	204263000	12716	6480	125	0	\N
274067	1678	13680399989000	12717	6556	0	0	\N
274068	1678	13680399990000	12717	6556	1	0	\N
274069	1678	13680399991000	12717	6556	2	0	\N
274070	1874	204301000	12717	6556	3	0	\N
274071	1874	204302000	12717	6556	4	0	\N
274072	1874	204303000	12717	6556	5	0	\N
274090	1678	13680400000000	12722	6561	0	0	\N
274091	1678	13680400001000	12722	6561	1	0	\N
274092	1874	204312000	12722	6561	2	0	\N
274093	1874	204313000	12722	6561	3	0	\N
274094	1678	13680400000000	12723	6561	0	0	\N
274095	1678	13680400001000	12723	6561	1	0	\N
274096	1874	204312000	12723	6561	2	0	\N
274097	1874	204313000	12723	6561	3	0	\N
274102	921	504783215943484	12725	6431	0	0	\N
274103	1678	12960388823000	12725	6431	1	0	\N
274104	1041	904567197988098	12725	6431	2	0	\N
274105	1678	12960388824000	12725	6431	3	0	\N
274106	1678	12960388825000	12725	6431	4	0	\N
274107	1161	610329513257268	12725	6431	5	0	\N
274108	1287	1700737456165952	12725	6431	6	0	\N
274109	1678	12960388826000	12725	6431	7	0	\N
274110	1678	12960388827000	12725	6431	8	0	\N
274111	1678	12960388828000	12725	6431	9	0	\N
274112	1678	12960388829000	12725	6431	10	0	\N
274113	1678	12960388830000	12725	6431	11	0	\N
274114	1678	12960388831000	12725	6431	12	0	\N
274115	1678	12960388832000	12725	6431	13	0	\N
274116	1678	12960388833000	12725	6431	14	0	\N
274117	1678	12960388834000	12725	6431	15	0	\N
274118	1678	12960388835000	12725	6431	16	0	\N
274119	1678	12960388836000	12725	6431	17	0	\N
274120	1678	12960388837000	12725	6431	18	0	\N
274121	1678	12960388838000	12725	6431	19	0	\N
274122	1678	12960388839000	12725	6431	20	0	\N
274123	1678	12960388840000	12725	6431	21	0	\N
274124	1678	12960388841000	12725	6431	22	0	\N
274125	1678	12960388842000	12725	6431	23	0	\N
274126	1678	12960388843000	12725	6431	24	0	\N
274127	1678	12960388844000	12725	6431	25	0	\N
274128	1678	12960388845000	12725	6431	26	0	\N
274129	1678	12960388846000	12725	6431	27	0	\N
274130	1678	12960388847000	12725	6431	28	0	\N
274131	1678	12960388848000	12725	6431	29	0	\N
274132	1678	12960388849000	12725	6431	30	0	\N
274133	1678	12960388850000	12725	6431	31	0	\N
274134	1678	12960388851000	12725	6431	32	0	\N
274135	1678	12960388852000	12725	6431	33	0	\N
274136	1678	12960388853000	12725	6431	34	0	\N
274145	1678	13680400006000	12728	6564	0	0	\N
274146	1874	204318000	12728	6564	1	0	\N
274147	1745	1803000000	12729	6481	0	0	\N
274148	1874	204264000	12729	6481	1	0	\N
274149	1874	204265000	12729	6481	2	0	\N
274150	1874	204266000	12729	6481	3	0	\N
274151	1874	204267000	12729	6481	4	0	\N
274152	1874	204268000	12729	6481	5	0	\N
274153	1874	204269000	12729	6481	6	0	\N
274154	1874	204270000	12729	6481	7	0	\N
274155	2069	200000000	12729	6481	8	0	\N
274156	2070	200000000	12729	6481	9	0	\N
274157	2071	200000000	12729	6481	10	0	\N
274158	1874	204271000	12729	6481	11	0	\N
274159	1874	204272000	12729	6481	12	0	\N
274160	1874	204273000	12729	6481	13	0	\N
274161	1874	204274000	12729	6481	14	0	\N
274162	1874	204275000	12729	6481	15	0	\N
274163	1874	204276000	12729	6481	16	0	\N
274164	1874	204277000	12729	6481	17	0	\N
274165	1874	204278000	12729	6481	18	0	\N
274166	1874	204279000	12729	6481	19	0	\N
274167	1874	204280000	12729	6481	20	0	\N
274168	1874	204281000	12729	6481	21	0	\N
274169	1874	204282000	12729	6481	22	0	\N
274170	1874	204283000	12729	6481	23	0	\N
274171	1874	204284000	12729	6481	24	0	\N
274172	1874	204285000	12729	6481	25	0	\N
274173	1874	204286000	12729	6481	26	0	\N
274174	1874	204287000	12729	6481	27	0	\N
274175	1874	204288000	12729	6481	28	0	\N
274176	1874	204289000	12729	6481	29	0	\N
274075	1745	1803000000	12718	6557	2	0	5
274076	1874	204304000	12718	6557	3	0	0
274077	1874	204305000	12718	6557	4	0	0
274078	1678	13680399994000	12719	6558	0	0	0
274079	1678	13680399995000	12719	6558	1	0	0
274081	1874	204307000	12719	6558	3	0	0
274082	1678	13680399996000	12720	6559	0	0	0
274083	1678	13680399997000	12720	6559	1	0	0
274084	1678	13680399998000	12720	6559	2	0	0
274085	1874	204308000	12720	6559	3	0	0
274087	1874	204310000	12720	6559	5	0	0
274088	1678	13680399999000	12721	6560	0	0	0
274089	1874	204311000	12721	6560	1	0	0
274098	1678	13680400000000	12724	6561	0	0	0
274100	1874	204312000	12724	6561	2	0	0
274101	1874	204313000	12724	6561	3	0	0
274137	1678	13680400002000	12726	6562	0	0	0
274138	1874	204314000	12726	6562	1	0	0
274139	1678	13680400003000	12727	6563	0	0	0
274141	1678	13680400005000	12727	6563	2	0	0
274142	1874	204315000	12727	6563	3	0	0
274143	1874	204316000	12727	6563	4	0	0
274144	1874	204317000	12727	6563	5	0	0
274177	1874	204290000	12729	6481	30	0	\N
274178	1874	204291000	12729	6481	31	0	\N
274179	1874	204292000	12729	6481	32	0	\N
274180	1874	204293000	12729	6481	33	0	\N
274181	1874	204294000	12729	6481	34	0	\N
274182	1874	204295000	12729	6481	35	0	\N
274183	1874	204296000	12729	6481	36	0	\N
274184	1874	204297000	12729	6481	37	0	\N
274185	1874	204298000	12729	6481	38	0	\N
274186	1874	204299000	12729	6481	39	0	\N
274187	1874	204300000	12729	6481	40	0	\N
274188	1874	204301000	12729	6481	41	0	\N
274189	1874	204302000	12729	6481	42	0	\N
274190	1874	204303000	12729	6481	43	0	\N
274191	1874	204304000	12729	6481	44	0	\N
274192	1874	204305000	12729	6481	45	0	\N
274193	1874	204306000	12729	6481	46	0	\N
274194	1874	204307000	12729	6481	47	0	\N
274195	1874	204308000	12729	6481	48	0	\N
274196	1874	204309000	12729	6481	49	0	\N
274197	1874	204310000	12729	6481	50	0	\N
274198	1874	204311000	12729	6481	51	0	\N
274199	1874	204312000	12729	6481	52	0	\N
274200	1874	204313000	12729	6481	53	0	\N
274201	1874	204314000	12729	6481	54	0	\N
274202	1874	204315000	12729	6481	55	0	\N
274203	1874	204316000	12729	6481	56	0	\N
274204	1874	204317000	12729	6481	57	0	\N
274205	1874	204318000	12729	6481	58	0	\N
274209	1678	13680400007000	12732	6565	0	0	\N
274210	1874	204319000	12732	6565	1	0	\N
274211	1678	13680400007000	12733	6565	0	0	\N
274212	1874	204319000	12733	6565	1	0	\N
274213	1678	13680400007000	12734	6565	0	0	\N
274214	1874	204319000	12734	6565	1	0	\N
274223	1678	13680400010000	12738	6568	0	0	\N
274224	1678	13680400010000	12739	6568	0	0	\N
274225	1874	204322000	12739	6568	1	0	\N
274226	1678	13680400010000	12740	6568	0	0	\N
274227	1874	204322000	12740	6568	1	0	\N
274232	1678	13680400012000	12743	6570	0	0	\N
274233	1874	204324000	12743	6570	1	0	\N
274234	1678	13680400013000	12744	6571	0	0	\N
274235	1874	204325000	12744	6571	1	0	\N
274236	1678	13680400013000	12745	6571	0	0	\N
274237	1874	204325000	12745	6571	1	0	\N
274240	1678	13680400014000	12747	6572	0	0	\N
274241	1678	13680400015000	12747	6572	1	0	\N
274242	1874	204326000	12747	6572	3	0	\N
274243	1874	204327000	12747	6572	4	0	\N
274244	1678	13680400014000	12748	6572	0	0	\N
274245	1678	13680400015000	12748	6572	1	0	\N
274246	1874	204326000	12748	6572	3	0	\N
274247	1874	204327000	12748	6572	4	0	\N
274255	1678	13680400019000	12751	6574	0	0	\N
274256	1678	13680400020000	12751	6574	1	0	\N
274257	1678	13680400021000	12751	6574	2	0	\N
274258	996	506151457000000	12751	6574	3	0	\N
274259	1678	13680400019000	12752	6574	0	0	\N
274260	1678	13680400020000	12752	6574	1	0	\N
274261	1678	13680400021000	12752	6574	2	0	\N
274262	1874	204328000	12752	6574	3	0	\N
274263	1874	204329000	12752	6574	4	0	\N
274264	1874	204330000	12752	6574	5	0	\N
274265	1874	204331000	12752	6574	6	0	\N
274266	1874	204332000	12752	6574	7	0	\N
274267	1874	204333000	12752	6574	8	0	\N
274268	996	506151457000000	12752	6574	9	0	\N
274279	1678	13680400022000	12754	6575	0	0	\N
274280	1678	13680400023000	12754	6575	1	0	\N
274281	1019	504726670880939	12754	6575	2	0	\N
274282	1139	904465869720511	12754	6575	3	0	\N
274283	1259	610261145056001	12754	6575	4	0	\N
274284	1385	1700546942094178	12754	6575	5	0	\N
274285	1236	611983843000000	12754	6575	6	0	\N
274286	1116	907019073000000	12754	6575	7	0	\N
274287	1362	1705347391751650	12754	6575	8	0	\N
274288	1874	204334000	12754	6575	9	0	\N
274289	1874	204335000	12754	6575	10	0	\N
274309	1678	13680400026000	12758	6577	0	0	\N
274310	1678	13680400027000	12758	6577	1	0	\N
274311	1874	204338000	12758	6577	2	0	\N
274312	1874	204339000	12758	6577	3	0	\N
274208	1678	13680400007000	12731	6565	0	0	0
274215	1678	13680400008000	12736	6567	0	0	0
274216	1678	13680400009000	12736	6567	1	0	0
274217	2072	0	12736	6567	2	0	0
274218	1874	204319000	12736	6567	3	0	0
274220	1874	204321000	12736	6567	5	0	0
274221	1678	13680400010000	12737	6568	0	0	0
274222	1874	204322000	12737	6568	1	0	0
274228	1678	13680400011000	12741	6569	0	0	0
274229	1874	204323000	12741	6569	1	0	0
274231	1874	204324000	12742	6570	1	0	0
274238	1678	13680400013000	12746	6571	0	0	0
274239	1874	204325000	12746	6571	1	0	0
274248	1678	13680400014000	12749	6572	0	0	0
274250	1678	13680400016000	12750	6573	0	0	0
274251	1678	13680400017000	12750	6573	1	0	0
274252	1678	13680400018000	12750	6573	2	0	0
274253	1874	204326000	12750	6573	3	0	0
274254	1874	204327000	12750	6573	4	0	0
274270	1678	13680400020000	12753	6574	1	0	0
274271	1678	13680400021000	12753	6574	2	0	0
274272	1874	204328000	12753	6574	3	0	0
274273	1874	204329000	12753	6574	4	0	0
274274	1874	204330000	12753	6574	5	0	0
274276	1874	204332000	12753	6574	7	0	0
274277	1874	204333000	12753	6574	8	0	0
274278	996	506151457000000	12753	6574	9	0	0
274290	1678	13680400022000	12755	6575	0	0	0
274292	1019	504726670880939	12755	6575	2	0	0
274293	1139	904465869720511	12755	6575	3	0	0
274294	1259	610261145056001	12755	6575	4	0	0
274295	1385	1700546942094178	12755	6575	5	0	0
274296	1236	611983843000000	12755	6575	6	0	0
274298	1362	1705347391751650	12755	6575	8	0	0
274299	1874	204334000	12755	6575	9	0	0
274300	1874	204335000	12755	6575	10	0	0
274301	1678	13680400024000	12756	6576	0	0	0
274302	1678	13680400025000	12756	6576	1	0	0
274304	1874	204337000	12756	6576	3	0	0
274305	1678	13680400026000	12757	6577	0	0	0
274306	1678	13680400027000	12757	6577	1	0	0
274307	1874	204338000	12757	6577	2	0	0
274313	1678	13680400026000	12759	6577	0	0	\N
274314	1678	13680400027000	12759	6577	1	0	\N
274315	1874	204338000	12759	6577	2	0	\N
274316	1874	204339000	12759	6577	3	0	\N
274338	1678	13680400038000	12768	6584	0	0	\N
274339	1874	204350000	12768	6584	1	0	\N
274346	1678	13680400040000	12772	6586	0	0	\N
274347	1874	204352000	12772	6586	1	0	\N
274348	1678	13680400039000	12773	6585	0	0	\N
274349	1874	204351000	12773	6585	1	0	\N
274350	1874	204352000	12773	6585	2	0	\N
274351	1678	13680400040000	12774	6586	0	0	\N
274352	1874	204352000	12774	6586	1	0	\N
274353	1678	13680400040000	12775	6586	0	0	\N
274354	1874	204352000	12775	6586	1	0	\N
274355	1678	13680400040000	12776	6586	0	0	\N
274356	1874	204352000	12776	6586	1	0	\N
274357	1874	204353000	12777	6587	0	0	\N
274360	1678	13680400041000	12779	6587	0	0	\N
274361	1874	204353000	12779	6587	1	0	\N
274363	1678	13680400042000	12781	6589	0	0	\N
274364	1678	13680400043000	12781	6589	1	0	\N
274365	1678	13680400044000	12781	6589	3	0	\N
274366	1874	204355000	12781	6589	4	0	\N
274367	2074	9000000000	12781	6589	5	0	\N
274368	1874	204356000	12781	6589	6	0	\N
274369	1874	204357000	12781	6589	7	0	\N
274381	1678	13680400045000	12784	6590	0	0	\N
274382	1678	13680400046000	12784	6590	1	0	\N
274383	1874	204358000	12784	6590	2	0	\N
274384	1874	204359000	12784	6590	3	0	\N
274385	1678	13680400047000	12785	6591	0	0	\N
274386	1678	13680400048000	12785	6591	1	0	\N
274387	1874	204360000	12785	6591	2	0	\N
274388	1874	204361000	12785	6591	3	0	\N
274398	1678	13680400051000	12790	6594	0	0	\N
274399	1874	204364000	12790	6594	1	0	\N
274405	1678	13680400051000	12792	6595	0	0	\N
274406	1678	13680400052000	12792	6595	1	0	\N
274407	1678	13680400053000	12792	6595	2	0	\N
274408	1678	13680400054000	12792	6595	3	0	\N
274409	1098	904714685000000	12792	6595	4	0	\N
274410	1874	204364000	12792	6595	5	0	\N
274411	1874	204365000	12792	6595	6	0	\N
274412	1874	204366000	12792	6595	7	0	\N
274413	1874	204367000	12792	6595	8	0	\N
274414	1678	13680400055000	12793	6596	0	0	\N
274415	1874	204364000	12793	6596	1	0	\N
274416	1874	204365000	12793	6596	2	0	\N
274417	1874	204366000	12793	6596	3	0	\N
274418	1874	204367000	12793	6596	4	0	\N
274419	1874	204368000	12793	6596	5	0	\N
274420	1218	610429030000000	12793	6596	6	0	\N
274430	1678	13680400056000	12796	6597	0	0	\N
274431	1874	204364000	12796	6597	1	0	\N
274432	1874	204365000	12796	6597	2	0	\N
274433	1874	204366000	12796	6597	3	0	\N
274434	1874	204367000	12796	6597	4	0	\N
274435	1874	204368000	12796	6597	5	0	\N
274443	1678	13680400059000	12800	6600	0	0	\N
274444	1874	204372000	12800	6600	1	0	\N
274319	1874	204340000	12760	6578	2	0	0
274320	2073	0	12760	6578	3	0	0
274321	1874	204341000	12760	6578	4	0	0
274322	1678	13680400030000	12761	6579	0	0	0
274323	1678	13680400031000	12761	6579	1	0	0
274325	1874	204342000	12762	6580	1	0	0
274326	1874	204343000	12762	6580	2	0	0
274327	1874	204344000	12762	6580	3	0	0
274328	1678	13680400033000	12763	6581	0	0	0
274329	1874	204345000	12763	6581	1	0	0
274331	1678	13680400035000	12764	6582	1	0	0
274332	1678	13680400036000	12764	6582	2	0	0
274333	1874	204346000	12764	6582	3	0	0
274334	1874	204347000	12764	6582	4	0	0
274336	1678	13680400037000	12767	6583	0	0	0
274337	1874	204349000	12767	6583	1	0	0
274340	1678	13680400038000	12769	6584	0	0	0
274341	1874	204350000	12769	6584	1	0	0
274342	1678	13680400039000	12770	6585	0	0	0
274344	1678	13680400040000	12771	6586	0	0	0
274345	1874	204352000	12771	6586	1	0	0
274358	1678	13680400041000	12778	6587	0	0	0
274359	1874	204353000	12778	6587	1	0	0
274362	1874	204354000	12780	6588	0	0	0
274371	1678	13680400043000	12782	6589	1	0	0
274372	1678	13680400044000	12782	6589	3	0	0
274373	1874	204355000	12782	6589	4	0	0
274374	2074	9000000000	12782	6589	5	0	0
274376	1874	204357000	12782	6589	7	0	0
274377	1678	13680400045000	12783	6590	0	0	0
274378	1678	13680400046000	12783	6590	1	0	0
274379	1874	204358000	12783	6590	2	0	0
274380	1874	204359000	12783	6590	3	0	0
274390	1678	13680400048000	12787	6592	1	0	0
274391	1678	13680400049000	12787	6592	2	0	0
274392	1874	204360000	12787	6592	3	0	0
274393	1874	204361000	12787	6592	4	0	0
274394	1874	204362000	12787	6592	5	0	0
274396	978	504865525000000	12788	6593	1	0	0
274397	1874	204363000	12788	6593	2	0	0
274400	1678	13680400051000	12791	6595	0	0	0
274401	1678	13680400052000	12791	6595	1	0	0
274403	1678	13680400054000	12791	6595	3	0	0
274404	1098	904714685000000	12791	6595	4	0	0
274421	1678	13680400055000	12794	6596	0	0	0
274422	1218	610429030000000	12794	6596	1	0	0
274423	1678	13680400056000	12795	6597	0	0	0
274425	1874	204365000	12795	6597	2	0	0
274426	1874	204366000	12795	6597	3	0	0
274427	1874	204367000	12795	6597	4	0	0
274428	1874	204368000	12795	6597	5	0	0
274429	1874	204369000	12795	6597	6	0	0
274437	1344	1701014757751650	12797	6598	1	0	0
274438	1874	204370000	12797	6598	2	0	0
274439	1678	13680400058000	12798	6599	0	0	0
274440	1874	204371000	12798	6599	1	0	0
274442	1874	204372000	12799	6600	1	0	0
274445	1678	13680400060000	12801	6601	0	0	0
274446	1874	204373000	12801	6601	1	0	0
274447	2074	1171600000000	12801	6601	2	0	0
274448	1678	13680400061000	12802	6602	0	0	0
274451	1678	13680400062000	12804	6603	0	0	\N
274452	1874	204375000	12804	6603	1	0	\N
274453	1678	13680400062000	12805	6603	0	0	\N
274454	1874	204375000	12805	6603	1	0	\N
274455	1678	13680400063000	12806	6604	0	0	\N
274456	1958	887987000000	12806	6604	1	0	\N
274457	1678	13680400063000	12807	6604	0	0	\N
274458	1958	887987000000	12807	6604	1	0	\N
274459	1874	204375000	12807	6604	2	0	\N
274466	1678	13680400066000	12812	6607	0	0	\N
274467	1678	13680400067000	12812	6607	1	0	\N
274468	1678	13680400068000	12812	6607	2	0	\N
274472	1678	13680400066000	12814	6607	0	0	\N
274473	1678	13680400067000	12814	6607	1	0	\N
274474	1678	13680400068000	12814	6607	2	0	\N
274483	1678	13680400077000	12822	6614	0	0	\N
274488	1678	13680400080000	12827	6617	0	0	\N
274490	1958	887987000000	12829	6595	0	0	\N
274491	1958	1385987000000	12829	6595	1	0	\N
274492	1678	13680400081000	12830	6618	0	0	\N
274493	1678	13680400082000	12831	6619	0	0	\N
274495	1678	13680400082000	12833	6619	0	0	\N
274496	1678	13680400082000	12834	6619	0	0	\N
274497	1678	13680400082000	12835	6619	0	0	\N
274498	1678	13680400083000	12836	6620	0	0	\N
274500	1678	13680400083000	12838	6620	0	0	\N
274506	2075	200000000	12841	6622	0	0	\N
274507	1678	13680400085000	12841	6622	1	0	\N
274508	2076	200000000	12841	6622	2	0	\N
274509	1874	204376000	12841	6622	3	0	\N
274512	1678	13680400086000	12843	6623	0	0	\N
274513	1874	204377000	12843	6623	1	0	\N
274514	1678	13680400086000	12844	6623	0	0	\N
274515	1874	204377000	12844	6623	1	0	\N
274516	1678	13680400087000	12845	6624	0	0	\N
274517	1874	204378000	12845	6624	1	0	\N
274522	1958	887987000000	12848	6585	0	0	\N
274523	1678	13680400039000	12848	6585	1	0	\N
274524	1678	13680400040000	12848	6585	2	0	\N
274525	1678	13680400041000	12848	6585	3	0	\N
274526	1678	13680400042000	12848	6585	4	0	\N
274527	1678	13680400043000	12848	6585	5	0	\N
274528	1678	13680400044000	12848	6585	6	0	\N
274529	1678	13680400045000	12848	6585	7	0	\N
274530	1678	13680400046000	12848	6585	8	0	\N
274531	1678	13680400047000	12848	6585	9	0	\N
274532	1678	13680400048000	12848	6585	10	0	\N
274533	1678	13680400049000	12848	6585	11	0	\N
274534	1678	13680400050000	12848	6585	12	0	\N
274535	1678	13680400051000	12848	6585	13	0	\N
274536	1958	1385987000000	12848	6585	14	0	\N
274537	1678	13680400052000	12848	6585	15	0	\N
274538	1678	13680400053000	12848	6585	16	0	\N
274539	1678	13680400054000	12848	6585	18	0	\N
274540	1678	13680400055000	12848	6585	19	0	\N
274541	1678	13680400056000	12848	6585	20	0	\N
274542	1678	13680400057000	12848	6585	21	0	\N
274543	1678	13680400058000	12848	6585	22	0	\N
274544	1678	13680400059000	12848	6585	23	0	\N
274545	1678	13680400060000	12848	6585	24	0	\N
274546	1678	13680400061000	12848	6585	25	0	\N
274547	1678	13680400062000	12848	6585	26	0	\N
274548	1678	13680400063000	12848	6585	27	0	\N
274549	1678	13680400064000	12848	6585	28	0	\N
274550	1678	13680400065000	12848	6585	29	0	\N
274551	1678	13680400066000	12848	6585	30	0	\N
274552	1678	13680400067000	12848	6585	31	0	\N
274553	1678	13680400068000	12848	6585	32	0	\N
274554	1678	13680400069000	12848	6585	33	0	\N
274555	1678	13680400070000	12848	6585	34	0	\N
274556	1678	13680400071000	12848	6585	35	0	\N
274557	1678	13680400072000	12848	6585	36	0	\N
274558	1678	13680400073000	12848	6585	37	0	\N
274559	1678	13680400074000	12848	6585	38	0	\N
274560	1678	13680400075000	12848	6585	39	0	\N
274561	1678	13680400076000	12848	6585	40	0	\N
274562	1678	13680400077000	12848	6585	41	0	\N
274563	1678	13680400078000	12848	6585	42	0	\N
274564	1678	13680400079000	12848	6585	43	0	\N
274565	1678	13680400080000	12848	6585	44	0	\N
274566	1678	13680400081000	12848	6585	45	0	\N
274567	1678	13680400082000	12848	6585	46	0	\N
274568	1678	13680400083000	12848	6585	47	0	\N
274569	1678	13680400084000	12848	6585	48	0	\N
274570	1678	13680400085000	12848	6585	49	0	\N
274571	1678	13680400086000	12848	6585	50	0	\N
274572	1678	13680400087000	12848	6585	51	0	\N
274573	1678	13680400088000	12848	6585	52	0	\N
274574	1874	204351000	12848	6585	53	0	\N
274575	1874	204352000	12848	6585	54	0	\N
274576	2074	9000000000	12848	6585	55	0	\N
274577	978	504865525000000	12848	6585	56	0	\N
274578	1098	904714685000000	12848	6585	57	0	\N
274579	1874	204353000	12848	6585	58	0	\N
274580	1874	204354000	12848	6585	59	0	\N
274581	1874	204355000	12848	6585	60	0	\N
274582	1874	204356000	12848	6585	61	0	\N
274583	1874	204357000	12848	6585	62	0	\N
274584	1874	204358000	12848	6585	63	0	\N
274460	1678	13680400063000	12808	6604	0	0	0
274461	1958	887987000000	12808	6604	1	0	2
274462	1678	13680400064000	12809	6605	0	0	0
274463	1958	1385987000000	12809	6605	1	0	2
274464	1874	204375000	12809	6605	2	0	0
274469	1678	13680400066000	12813	6607	0	0	0
274470	1678	13680400067000	12813	6607	1	0	0
274471	1678	13680400068000	12813	6607	2	0	0
274475	1678	13680400069000	12815	6608	0	0	0
274476	1678	13680400070000	12815	6608	1	0	0
274478	1678	13680400072000	12818	6610	0	0	0
274479	1678	13680400073000	12819	6611	0	0	0
274480	1678	13680400074000	12820	6612	0	0	0
274481	1678	13680400075000	12821	6613	0	0	0
274484	1678	13680400077000	12823	6614	0	0	0
274485	1678	13680400078000	12824	6615	0	0	0
274486	1678	13680400079000	12825	6616	0	0	0
274487	1678	13680400080000	12826	6617	0	0	0
274489	1678	13680400081000	12828	6618	0	0	0
274499	1678	13680400083000	12837	6620	0	0	0
274501	1678	13680400084000	12839	6621	0	0	0
274502	2075	200000000	12840	6622	0	0	0
274503	1678	13680400085000	12840	6622	1	0	0
274504	2076	200000000	12840	6622	2	0	0
274510	1678	13680400086000	12842	6623	0	0	0
274511	1874	204377000	12842	6623	1	0	0
274518	1678	13680400087000	12846	6624	0	0	0
274519	1874	204378000	12846	6624	1	0	0
274521	1874	204379000	12847	6625	1	0	0
274585	1874	204359000	12848	6585	64	0	\N
274586	1874	204360000	12848	6585	65	0	\N
274587	1874	204361000	12848	6585	66	0	\N
274588	1874	204362000	12848	6585	67	0	\N
274589	1874	204363000	12848	6585	68	0	\N
274590	1874	204364000	12848	6585	69	0	\N
274591	1874	204365000	12848	6585	70	0	\N
274592	1874	204366000	12848	6585	71	0	\N
274593	1874	204367000	12848	6585	72	0	\N
274594	1874	204368000	12848	6585	73	0	\N
274595	1874	204369000	12848	6585	74	0	\N
274596	1874	204370000	12848	6585	75	0	\N
274597	1874	204371000	12848	6585	76	0	\N
274598	1874	204372000	12848	6585	77	0	\N
274599	1874	204373000	12848	6585	78	0	\N
274600	1874	204374000	12848	6585	79	0	\N
274601	1874	204375000	12848	6585	80	0	\N
274602	2075	200000000	12848	6585	81	0	\N
274603	2076	200000000	12848	6585	82	0	\N
274604	1874	204376000	12848	6585	83	0	\N
274605	1874	204377000	12848	6585	84	0	\N
274606	1874	204378000	12848	6585	85	0	\N
274607	1874	204379000	12848	6585	86	0	\N
274608	1218	610429030000000	12848	6585	87	0	\N
274609	1344	1701014757751650	12848	6585	88	0	\N
274610	2074	1171600000000	12848	6585	89	0	\N
274611	1678	13680400089000	12849	6626	0	0	\N
274612	1874	204380000	12849	6626	1	0	\N
274617	1678	13680400090000	12852	6627	0	0	\N
274618	1874	204381000	12852	6627	1	0	\N
274621	1678	13680400091000	12854	6628	0	0	\N
274622	1874	204382000	12854	6628	1	0	\N
274625	1678	13680400093000	12856	6630	0	0	\N
274626	1678	13680400094000	12856	6630	1	0	\N
274627	1874	204384000	12856	6630	2	0	\N
274628	1874	204385000	12856	6630	3	0	\N
274633	1678	13680400095000	12858	6631	0	0	\N
274634	1874	204386000	12858	6631	1	0	\N
274635	1678	13680400095000	12859	6631	0	0	\N
274636	1874	204386000	12859	6631	1	0	\N
274647	1678	13680400095000	12862	6631	0	0	\N
274648	1678	13680400096000	12863	6632	0	0	\N
274649	1678	13680400097000	12863	6632	1	0	\N
274650	1678	13680400098000	12863	6632	2	0	\N
274651	1874	204386000	12863	6632	3	0	\N
274652	2077	1000000000	12863	6632	4	0	\N
274653	2077	3000000000	12863	6632	5	0	\N
274654	1874	204387000	12863	6632	6	0	\N
274655	1874	204388000	12863	6632	7	0	\N
274656	1874	204389000	12863	6632	8	0	\N
274657	1678	13680400099000	12864	6633	0	0	\N
274658	1678	13680400100000	12864	6633	1	0	\N
274659	1678	13680400101000	12864	6633	2	0	\N
274660	1874	204390000	12864	6633	3	0	\N
274661	2078	200000000	12864	6633	4	0	\N
274662	1874	204391000	12864	6633	5	0	\N
274663	1874	204392000	12864	6633	6	0	\N
274685	1678	13680400105000	12868	6635	0	0	\N
274686	1678	13680400106000	12868	6635	1	0	\N
274687	1678	13680400107000	12868	6635	2	0	\N
274688	1678	13680400108000	12868	6635	3	0	\N
274689	1874	204396000	12868	6635	4	0	\N
274690	1874	204397000	12868	6635	5	0	\N
274691	1874	204398000	12868	6635	6	0	\N
274692	1874	204399000	12868	6635	7	0	\N
274704	1678	13680400114000	12871	6638	0	0	\N
274705	1874	204405000	12871	6638	1	0	\N
274708	1678	13680400114000	12873	6638	0	0	\N
274709	1874	204405000	12873	6638	1	0	\N
274710	1678	13680400115000	12874	6639	0	0	\N
274711	1678	13680400116000	12874	6639	1	0	\N
274712	1874	204406000	12874	6639	2	0	\N
274713	1874	204407000	12874	6639	3	0	\N
274718	1678	13680400115000	12876	6639	0	0	\N
274719	1678	13680400116000	12876	6639	1	0	\N
274720	1874	204406000	12876	6639	2	0	\N
274615	1678	13680400090000	12851	6627	0	0	0
274616	1874	204381000	12851	6627	1	0	0
274619	1678	13680400091000	12853	6628	0	0	0
274620	1874	204382000	12853	6628	1	0	0
274623	1678	13680400092000	12855	6629	0	0	0
274629	1678	13680400093000	12857	6630	0	0	0
274630	1678	13680400094000	12857	6630	1	0	0
274631	1874	204384000	12857	6630	2	0	0
274632	1874	204385000	12857	6630	3	0	0
274637	1678	13680400095000	12860	6631	0	0	0
274639	1678	13680400096000	12861	6632	0	0	0
274640	1678	13680400097000	12861	6632	1	0	0
274641	1678	13680400098000	12861	6632	2	0	0
274642	2077	1000000000	12861	6632	3	0	0
274644	1874	204387000	12861	6632	5	0	0
274645	1874	204388000	12861	6632	6	0	0
274646	1874	204389000	12861	6632	7	0	0
274664	1678	13680400099000	12865	6633	0	0	0
274665	1678	13680400100000	12865	6633	1	0	0
274667	1874	204390000	12865	6633	3	0	0
274668	2078	200000000	12865	6633	4	0	0
274669	1874	204391000	12865	6633	5	0	0
274670	1874	204392000	12865	6633	6	0	0
274671	1678	13680400102000	12866	6634	0	0	0
274673	1678	13680400104000	12866	6634	2	0	0
274674	1874	204393000	12866	6634	3	0	0
274675	1874	204394000	12866	6634	4	0	0
274676	1874	204395000	12866	6634	5	0	0
274678	1678	13680400106000	12867	6635	1	0	0
274679	1678	13680400107000	12867	6635	2	0	0
274680	1678	13680400108000	12867	6635	3	0	0
274681	1874	204396000	12867	6635	4	0	0
274682	1874	204397000	12867	6635	5	0	0
274684	1874	204399000	12867	6635	7	0	0
274693	1678	13680400109000	12869	6636	0	0	0
274694	1678	13680400110000	12869	6636	1	0	0
274695	1678	13680400111000	12869	6636	2	0	0
274696	1678	13680400112000	12869	6636	3	0	0
274698	1816	100000000	12869	6636	5	0	1
274699	1874	204401000	12869	6636	6	0	0
274700	1874	204402000	12869	6636	7	0	0
274701	1874	204403000	12869	6636	8	0	0
274703	1874	204404000	12870	6637	1	0	0
274706	1678	13680400114000	12872	6638	0	0	0
274707	1874	204405000	12872	6638	1	0	0
274714	1678	13680400115000	12875	6639	0	0	0
274715	1678	13680400116000	12875	6639	1	0	0
274717	1874	204407000	12875	6639	3	0	0
274721	1874	204407000	12876	6639	3	0	\N
274724	1678	13680400117000	12878	6640	0	0	\N
274725	1874	204408000	12878	6640	1	0	\N
274728	1678	13680400089000	12880	6586	0	0	\N
274729	1678	13680400090000	12880	6586	1	0	\N
274730	1678	13680400091000	12880	6586	2	0	\N
274731	1678	13680400092000	12880	6586	3	0	\N
274732	1678	13680400093000	12880	6586	4	0	\N
274733	1678	13680400094000	12880	6586	5	0	\N
274734	1678	13680400095000	12880	6586	6	0	\N
274735	1678	13680400096000	12880	6586	7	0	\N
274736	1678	13680400097000	12880	6586	8	0	\N
274737	1678	13680400098000	12880	6586	9	0	\N
274738	1678	13680400099000	12880	6586	10	0	\N
274739	1678	13680400100000	12880	6586	11	0	\N
274740	1678	13680400101000	12880	6586	12	0	\N
274741	1678	13680400102000	12880	6586	13	0	\N
274742	1678	13680400103000	12880	6586	14	0	\N
274743	1678	13680400104000	12880	6586	15	0	\N
274744	1678	13680400105000	12880	6586	16	0	\N
274745	1678	13680400106000	12880	6586	17	0	\N
274746	1678	13680400107000	12880	6586	18	0	\N
274747	1678	13680400108000	12880	6586	19	0	\N
274748	1678	13680400109000	12880	6586	20	0	\N
274749	1678	13680400110000	12880	6586	21	0	\N
274750	1678	13680400111000	12880	6586	22	0	\N
274751	1678	13680400112000	12880	6586	23	0	\N
274752	1678	13680400113000	12880	6586	24	0	\N
274753	1678	13680400114000	12880	6586	25	0	\N
274754	1678	13680400115000	12880	6586	26	0	\N
274755	1678	13680400116000	12880	6586	27	0	\N
274756	1678	13680400117000	12880	6586	28	0	\N
274757	1816	100000000	12880	6586	29	0	\N
274758	1874	204380000	12880	6586	30	0	\N
274759	2077	1000000000	12880	6586	31	0	\N
274760	2077	3000000000	12880	6586	32	0	\N
274761	1874	204381000	12880	6586	33	0	\N
274762	1874	204382000	12880	6586	34	0	\N
274763	1874	204383000	12880	6586	35	0	\N
274764	1874	204384000	12880	6586	36	0	\N
274765	1874	204385000	12880	6586	37	0	\N
274766	1874	204386000	12880	6586	38	0	\N
274767	1874	204387000	12880	6586	39	0	\N
274768	1874	204388000	12880	6586	40	0	\N
274769	1874	204389000	12880	6586	41	0	\N
274770	1874	204390000	12880	6586	42	0	\N
274771	2078	200000000	12880	6586	43	0	\N
274772	1874	204391000	12880	6586	44	0	\N
274773	1874	204392000	12880	6586	45	0	\N
274774	1874	204393000	12880	6586	46	0	\N
274775	1874	204394000	12880	6586	47	0	\N
274776	1874	204395000	12880	6586	48	0	\N
274777	1874	204396000	12880	6586	49	0	\N
274778	1874	204397000	12880	6586	50	0	\N
274779	1874	204398000	12880	6586	51	0	\N
274780	1874	204399000	12880	6586	52	0	\N
274781	1874	204400000	12880	6586	54	0	\N
274782	1874	204401000	12880	6586	55	0	\N
274783	1874	204402000	12880	6586	56	0	\N
274784	1874	204403000	12880	6586	57	0	\N
274785	1874	204404000	12880	6586	58	0	\N
274786	1874	204405000	12880	6586	59	0	\N
274787	1874	204406000	12880	6586	60	0	\N
274788	1874	204407000	12880	6586	61	0	\N
274789	1874	204408000	12880	6586	62	0	\N
274790	1678	13680400119000	12881	6642	0	0	\N
274791	1874	204410000	12881	6642	1	0	\N
274794	1678	13680400119000	12883	6642	0	0	\N
274795	1874	204410000	12883	6642	1	0	\N
274796	1678	13680400120000	12885	6643	0	0	\N
274797	1874	204411000	12885	6643	1	0	\N
274800	1678	13680400121000	12887	6644	0	0	\N
274801	1874	204412000	12887	6644	1	0	\N
274804	1678	13680400121000	12889	6644	0	0	\N
274805	1874	204412000	12889	6644	1	0	\N
274806	1678	13680400121000	12890	6644	0	0	\N
274807	1874	204412000	12890	6644	1	0	\N
274808	1678	13680400121000	12891	6644	0	0	\N
274809	1874	204412000	12891	6644	1	0	\N
274812	1678	13680400123000	12894	6646	0	0	\N
274813	1874	204414000	12894	6646	1	0	\N
274820	1678	13680400125000	12899	6648	0	0	\N
274821	1874	204416000	12899	6648	1	0	\N
274822	1678	13680400126000	12900	6649	0	0	\N
274823	1874	204417000	12900	6649	1	0	\N
274826	1678	13680400127000	12902	6650	0	0	\N
274827	1678	13680400128000	12902	6650	1	0	\N
274828	1874	204418000	12902	6650	2	0	\N
274829	1874	204419000	12902	6650	3	0	\N
274834	1678	13680400127000	12904	6650	0	0	\N
274835	1678	13680400128000	12904	6650	1	0	\N
274836	1874	204418000	12904	6650	2	0	\N
274837	1874	204419000	12904	6650	3	0	\N
274844	1678	13680400130000	12907	6652	0	0	\N
274845	1678	13680400131000	12907	6652	1	0	\N
274846	1874	204421000	12907	6652	2	0	\N
274847	1874	204422000	12907	6652	3	0	\N
274850	1874	204423000	12909	6653	0	0	\N
274852	1678	13680400133000	12911	6655	0	0	\N
274853	1678	13680400134000	12911	6655	1	0	\N
274854	1678	13680400135000	12911	6655	2	0	\N
274855	1678	13680400136000	12911	6655	3	0	\N
274856	1874	204425000	12911	6655	4	0	\N
274726	1678	13680400118000	12879	6641	0	0	0
274727	1874	204409000	12879	6641	1	0	0
274792	1678	13680400119000	12882	6642	0	0	0
274793	1874	204410000	12882	6642	1	0	0
274798	1678	13680400120000	12886	6643	0	0	0
274802	1678	13680400121000	12888	6644	0	0	0
274803	1874	204412000	12888	6644	1	0	0
274810	1678	13680400122000	12893	6645	0	0	0
274811	1874	204413000	12893	6645	1	0	0
274814	1678	13680400123000	12896	6646	0	0	0
274816	1678	13680400124000	12897	6647	0	0	0
274817	1874	204415000	12897	6647	1	0	0
274818	1678	13680400125000	12898	6648	0	0	0
274819	1874	204416000	12898	6648	1	0	0
274825	1874	204417000	12901	6649	1	0	0
274830	1678	13680400127000	12903	6650	0	0	0
274831	1678	13680400128000	12903	6650	1	0	0
274832	1874	204418000	12903	6650	2	0	0
274833	1874	204419000	12903	6650	3	0	0
274839	1874	204420000	12905	6651	1	0	0
274840	1678	13680400130000	12906	6652	0	0	0
274841	1678	13680400131000	12906	6652	1	0	0
274842	1874	204421000	12906	6652	2	0	0
274843	1874	204422000	12906	6652	3	0	0
274849	1874	204423000	12908	6653	1	0	0
274851	1874	204424000	12910	6654	0	0	0
274857	1874	204426000	12911	6655	5	0	\N
274858	1874	204427000	12911	6655	6	0	\N
274859	1874	204428000	12911	6655	7	0	\N
274868	1678	13680400133000	12913	6655	0	0	\N
274869	1678	13680400134000	12913	6655	1	0	\N
274870	1678	13680400135000	12913	6655	2	0	\N
274871	1678	13680400136000	12913	6655	3	0	\N
274872	1874	204425000	12913	6655	4	0	\N
274873	1874	204426000	12913	6655	5	0	\N
274874	1874	204427000	12913	6655	6	0	\N
274875	1874	204428000	12913	6655	7	0	\N
274876	1678	13680400137000	12914	6656	0	0	\N
274877	1874	204429000	12914	6656	1	0	\N
274880	1678	13680400117000	12916	6640	0	0	\N
274881	1678	13680400118000	12916	6640	1	0	\N
274882	1678	13680400119000	12916	6640	2	0	\N
274883	1678	13680400120000	12916	6640	3	0	\N
274884	1678	13680400121000	12916	6640	4	0	\N
274885	1678	13680400122000	12916	6640	5	0	\N
274886	1678	13680400123000	12916	6640	6	0	\N
274887	1678	13680400124000	12916	6640	7	0	\N
274888	1678	13680400125000	12916	6640	8	0	\N
274889	1678	13680400126000	12916	6640	9	0	\N
274890	1678	13680400127000	12916	6640	10	0	\N
274891	1678	13680400128000	12916	6640	11	0	\N
274892	1678	13680400129000	12916	6640	12	0	\N
274893	1678	13680400130000	12916	6640	13	0	\N
274894	1678	13680400131000	12916	6640	14	0	\N
274895	1678	13680400132000	12916	6640	16	0	\N
274896	1678	13680400133000	12916	6640	17	0	\N
274897	1678	13680400134000	12916	6640	18	0	\N
274898	1678	13680400135000	12916	6640	19	0	\N
274899	1678	13680400136000	12916	6640	20	0	\N
274900	1678	13680400137000	12916	6640	21	0	\N
274901	1874	204408000	12916	6640	22	0	\N
274902	1874	204409000	12916	6640	23	0	\N
274903	1874	204410000	12916	6640	24	0	\N
274904	1874	204411000	12916	6640	25	0	\N
274905	1874	204412000	12916	6640	26	0	\N
274906	1874	204413000	12916	6640	27	0	\N
274907	1874	204414000	12916	6640	28	0	\N
274908	1874	204415000	12916	6640	29	0	\N
274909	1874	204416000	12916	6640	30	0	\N
274910	1874	204417000	12916	6640	31	0	\N
274911	1874	204418000	12916	6640	32	0	\N
274912	1874	204419000	12916	6640	33	0	\N
274913	1874	204420000	12916	6640	34	0	\N
274914	1874	204421000	12916	6640	35	0	\N
274915	1874	204422000	12916	6640	36	0	\N
274916	1874	204423000	12916	6640	37	0	\N
274917	1874	204424000	12916	6640	38	0	\N
274918	1874	204425000	12916	6640	39	0	\N
274919	1874	204426000	12916	6640	40	0	\N
274920	1874	204427000	12916	6640	41	0	\N
274921	1874	204428000	12916	6640	42	0	\N
274922	1874	204429000	12916	6640	43	0	\N
274927	1678	13680400138000	12918	6657	0	0	\N
274928	1678	13680400139000	12918	6657	1	0	\N
274929	1874	204430000	12918	6657	2	0	\N
274930	1874	204431000	12918	6657	3	0	\N
274935	1678	13680400141000	12921	6659	0	0	\N
274936	1874	204433000	12921	6659	1	0	\N
274941	1678	13680400143000	12924	6661	0	0	\N
274942	1874	204435000	12924	6661	1	0	\N
274947	1678	13680400144000	12926	6662	0	0	\N
274948	1678	13680400145000	12926	6662	1	0	\N
274949	1874	204436000	12926	6662	2	0	\N
274950	1874	204437000	12926	6662	3	0	\N
274955	1678	13680400147000	12929	6664	0	0	\N
274956	1874	204439000	12929	6664	1	0	\N
274957	1678	13680400118000	12930	6587	0	0	\N
274958	1678	13680400119000	12930	6587	1	0	\N
274959	1678	13680400120000	12930	6587	2	0	\N
274960	1678	13680400121000	12930	6587	3	0	\N
274961	1678	13680400122000	12930	6587	4	0	\N
274962	1678	13680400123000	12930	6587	5	0	\N
274963	1678	13680400124000	12930	6587	6	0	\N
274964	1678	13680400125000	12930	6587	7	0	\N
274965	1678	13680400126000	12930	6587	8	0	\N
274966	1678	13680400127000	12930	6587	9	0	\N
274967	1678	13680400128000	12930	6587	10	0	\N
274968	1678	13680400129000	12930	6587	11	0	\N
274969	1678	13680400130000	12930	6587	12	0	\N
274970	1678	13680400131000	12930	6587	13	0	\N
274971	1678	13680400132000	12930	6587	14	0	\N
274972	1678	13680400133000	12930	6587	15	0	\N
274973	1678	13680400134000	12930	6587	16	0	\N
274974	1678	13680400135000	12930	6587	17	0	\N
274975	1678	13680400136000	12930	6587	18	0	\N
274976	1678	13680400137000	12930	6587	19	0	\N
274977	1678	13680400138000	12930	6587	20	0	\N
274978	1678	13680400139000	12930	6587	21	0	\N
274979	1678	13680400140000	12930	6587	22	0	\N
274980	1678	13680400141000	12930	6587	23	0	\N
274981	1678	13680400142000	12930	6587	24	0	\N
274982	1678	13680400143000	12930	6587	25	0	\N
274983	1678	13680400144000	12930	6587	26	0	\N
274984	1678	13680400145000	12930	6587	27	0	\N
274985	1678	13680400146000	12930	6587	28	0	\N
274986	1678	13680400147000	12930	6587	29	0	\N
274987	1874	204409000	12930	6587	30	0	\N
274988	1874	204410000	12930	6587	31	0	\N
274989	1874	204411000	12930	6587	32	0	\N
274990	1874	204412000	12930	6587	33	0	\N
274991	1874	204413000	12930	6587	34	0	\N
274992	1874	204414000	12930	6587	35	0	\N
274862	1678	13680400135000	12912	6655	2	0	0
274863	1678	13680400136000	12912	6655	3	0	0
274864	1874	204425000	12912	6655	4	0	0
274865	1874	204426000	12912	6655	5	0	0
274866	1874	204427000	12912	6655	6	0	0
274878	1678	13680400137000	12915	6656	0	0	0
274879	1874	204429000	12915	6656	1	0	0
274923	1678	13680400138000	12917	6657	0	0	0
274924	1678	13680400139000	12917	6657	1	0	0
274925	1874	204430000	12917	6657	2	0	0
274931	1678	13680400140000	12919	6658	0	0	0
274932	1874	204432000	12919	6658	1	0	0
274933	1678	13680400141000	12920	6659	0	0	0
274934	1874	204433000	12920	6659	1	0	0
274938	1874	204434000	12922	6660	1	0	0
274939	1678	13680400143000	12923	6661	0	0	0
274940	1874	204435000	12923	6661	1	0	0
274943	1678	13680400144000	12925	6662	0	0	0
274944	1678	13680400145000	12925	6662	1	0	0
274946	1874	204437000	12925	6662	3	0	0
274951	1678	13680400146000	12927	6663	0	0	0
274952	1874	204438000	12927	6663	1	0	0
274953	1678	13680400147000	12928	6664	0	0	0
274954	1874	204439000	12928	6664	1	0	0
274993	1874	204415000	12930	6587	36	0	\N
274994	1874	204416000	12930	6587	37	0	\N
274995	1874	204417000	12930	6587	38	0	\N
274996	1874	204418000	12930	6587	39	0	\N
274997	1874	204419000	12930	6587	40	0	\N
274998	1874	204420000	12930	6587	41	0	\N
274999	1874	204421000	12930	6587	42	0	\N
275000	1874	204422000	12930	6587	43	0	\N
275001	1874	204423000	12930	6587	44	0	\N
275002	1874	204424000	12930	6587	45	0	\N
275003	1874	204425000	12930	6587	46	0	\N
275004	1874	204426000	12930	6587	47	0	\N
275005	1874	204427000	12930	6587	48	0	\N
275006	1874	204428000	12930	6587	49	0	\N
275007	1874	204429000	12930	6587	50	0	\N
275008	1874	204430000	12930	6587	51	0	\N
275009	1874	204431000	12930	6587	52	0	\N
275010	1874	204432000	12930	6587	53	0	\N
275011	1874	204433000	12930	6587	54	0	\N
275012	1874	204434000	12930	6587	55	0	\N
275013	1874	204435000	12930	6587	56	0	\N
275014	1874	204436000	12930	6587	57	0	\N
275015	1874	204437000	12930	6587	58	0	\N
275016	1874	204438000	12930	6587	59	0	\N
275017	1874	204439000	12930	6587	60	0	\N
275018	1678	13680400147000	12931	6664	0	0	\N
275019	1874	204439000	12931	6664	1	0	\N
275020	1678	13680400148000	12932	6665	0	0	\N
275021	1874	204440000	12932	6665	1	0	\N
275026	1678	13680400150000	12935	6667	0	0	\N
275027	1678	13680400151000	12935	6667	1	0	\N
275028	1678	13680400152000	12935	6667	2	0	\N
275029	1678	13680400153000	12935	6667	3	0	\N
275030	1874	204442000	12935	6667	4	0	\N
275031	1874	204443000	12935	6667	5	0	\N
275032	1874	204444000	12935	6667	6	0	\N
275033	1874	204445000	12935	6667	7	0	\N
275042	1678	13680400150000	12937	6667	0	0	\N
275043	1678	13680400151000	12937	6667	1	0	\N
275044	1678	13680400152000	12937	6667	2	0	\N
275045	1678	13680400153000	12937	6667	3	0	\N
275046	1874	204442000	12937	6667	4	0	\N
275047	1874	204443000	12937	6667	5	0	\N
275048	1874	204444000	12937	6667	6	0	\N
275049	1874	204445000	12937	6667	7	0	\N
275052	1678	13680400155000	12939	6669	0	0	\N
275053	1874	204447000	12939	6669	1	0	\N
275056	1678	13680400156000	12941	6670	0	0	\N
275057	1874	204448000	12941	6670	1	0	\N
275059	1678	13680400157000	12943	6671	0	0	\N
275060	1874	204448000	12943	6671	2	0	\N
275061	1874	204449000	12943	6671	3	0	\N
275065	1678	13680400158000	12945	6672	0	0	\N
275066	1874	204450000	12945	6672	1	0	\N
275075	1678	13680400162000	12950	6676	0	0	\N
275076	1678	13680400163000	12950	6676	1	0	\N
275077	1874	204454000	12950	6676	2	0	\N
275078	1874	204455000	12950	6676	3	0	\N
275091	1874	204459000	12956	6680	0	0	\N
275092	1678	13680400167000	12957	6680	0	0	\N
275093	1874	204459000	12957	6680	1	0	\N
275106	1678	13680400174000	12963	6685	0	0	\N
275107	1678	13680400175000	12963	6685	1	0	\N
275108	1678	13680400176000	12963	6685	2	0	\N
275109	1874	204466000	12963	6685	3	0	\N
275110	1874	204467000	12963	6685	4	0	\N
275111	1874	204468000	12963	6685	5	0	\N
275122	1678	13680400179000	12967	6688	0	0	\N
275123	1874	204471000	12967	6688	1	0	\N
275124	1678	13680400179000	12968	6688	0	0	\N
275125	1874	204471000	12968	6688	1	0	\N
275024	1678	13680400149000	12934	6666	0	0	0
275025	1874	204441000	12934	6666	1	0	0
275034	1678	13680400150000	12936	6667	0	0	0
275035	1678	13680400151000	12936	6667	1	0	0
275036	1678	13680400152000	12936	6667	2	0	0
275038	1874	204442000	12936	6667	4	0	0
275039	1874	204443000	12936	6667	5	0	0
275040	1874	204444000	12936	6667	6	0	0
275041	1874	204445000	12936	6667	7	0	0
275050	1678	13680400154000	12938	6668	0	0	0
275054	1678	13680400155000	12940	6669	0	0	0
275055	1874	204447000	12940	6669	1	0	0
275058	1678	13680400156000	12942	6670	0	0	0
275062	1678	13680400157000	12944	6671	0	0	0
275064	1874	204449000	12944	6671	3	0	0
275067	1678	13680400158000	12946	6672	0	0	0
275068	1874	204450000	12946	6672	1	0	0
275069	1678	13680400159000	12947	6673	0	0	0
275070	1874	204451000	12947	6673	1	0	0
275072	1874	204452000	12948	6674	1	0	0
275073	1678	13680400161000	12949	6675	0	0	0
275074	1874	204453000	12949	6675	1	0	0
275079	1678	13680400162000	12951	6676	0	0	0
275080	1678	13680400163000	12951	6676	1	0	0
275082	1874	204455000	12951	6676	3	0	0
275083	1678	13680400164000	12952	6677	0	0	0
275084	1874	204456000	12952	6677	1	0	0
275085	1678	13680400165000	12953	6678	0	0	0
275087	1678	13680400166000	12954	6679	0	0	0
275088	1874	204458000	12954	6679	1	0	0
275089	1678	13680400167000	12955	6680	0	0	0
275090	1874	204459000	12955	6680	1	0	0
275094	1678	13680400168000	12958	6681	0	0	0
275096	1678	13680400169000	12959	6682	0	0	0
275097	1874	204461000	12959	6682	1	0	0
275098	1678	13680400170000	12961	6683	0	0	0
275099	1678	13680400171000	12961	6683	1	0	0
275100	1678	13680400172000	12961	6683	2	0	0
275102	1874	204463000	12961	6683	4	0	0
275103	1874	204464000	12961	6683	5	0	0
275104	1678	13680400173000	12962	6684	0	0	0
275105	1874	204465000	12962	6684	1	0	0
275113	1678	13680400175000	12964	6685	1	0	0
275114	1678	13680400176000	12964	6685	2	0	0
275115	1874	204466000	12964	6685	3	0	0
275116	1874	204467000	12964	6685	4	0	0
275117	1874	204468000	12964	6685	5	0	0
275119	1874	204469000	12965	6686	1	0	0
275120	1678	13680400178000	12966	6687	0	0	0
275121	1874	204470000	12966	6687	1	0	0
275126	1678	13680400179000	12969	6688	0	0	0
275127	1874	204471000	12969	6688	1	0	0
275130	1678	13680400180000	12971	6689	0	0	\N
275131	1874	204472000	12971	6689	1	0	\N
275132	1678	13680400180000	12972	6689	0	0	\N
275133	1874	204472000	12972	6689	1	0	\N
275134	1678	13680400180000	12973	6689	0	0	\N
275135	1874	204472000	12973	6689	1	0	\N
275136	1678	13680400180000	12974	6689	0	0	\N
275137	1874	204472000	12974	6689	1	0	\N
275140	1678	13680400180000	12976	6689	0	0	\N
275141	1678	13680400181000	12976	6689	1	0	\N
275142	1874	204472000	12976	6689	2	0	\N
275146	1678	13680400182000	12978	6691	0	0	\N
275147	1678	13680400183000	12978	6691	1	0	\N
275148	1874	204474000	12978	6691	2	0	\N
275153	1678	13680400185000	12981	6693	0	0	\N
275154	1874	204476000	12981	6693	1	0	\N
275155	1678	13680400185000	12982	6693	0	0	\N
275156	1874	204476000	12982	6693	1	0	\N
275157	1874	204476000	12983	6693	0	0	\N
275160	1958	887987000000	12985	6483	0	0	\N
275163	1678	13680400187000	12987	6695	0	0	\N
275164	1874	204478000	12987	6695	1	0	\N
275169	1678	13680400188000	12989	6696	0	0	\N
275170	1678	13680400189000	12989	6696	1	0	\N
275171	1874	204479000	12989	6696	2	0	\N
275172	1874	204480000	12989	6696	3	0	\N
275173	1678	13680400188000	12990	6696	0	0	\N
275174	1678	13680400189000	12990	6696	1	0	\N
275175	1874	204479000	12990	6696	2	0	\N
275176	1874	204480000	12990	6696	3	0	\N
275187	1678	13680400193000	12995	6700	0	0	\N
275188	1678	13680400194000	12995	6700	1	0	\N
275189	1874	204484000	12995	6700	2	0	\N
275190	1874	204485000	12995	6700	3	0	\N
275191	1678	13680400193000	12996	6700	0	0	\N
275192	1678	13680400194000	12996	6700	1	0	\N
275193	1874	204484000	12996	6700	2	0	\N
275194	1874	204485000	12996	6700	3	0	\N
275195	1678	13680400193000	12997	6700	0	0	\N
275196	1678	13680400194000	12997	6700	1	0	\N
275197	1874	204484000	12997	6700	2	0	\N
275198	1874	204485000	12997	6700	3	0	\N
275199	1678	13680400193000	12998	6700	0	0	\N
275200	1678	13680400194000	12998	6700	1	0	\N
275201	1874	204484000	12998	6700	2	0	\N
275202	1874	204485000	12998	6700	3	0	\N
275205	1678	13680400195000	13000	6701	0	0	\N
275206	1874	204486000	13000	6701	1	0	\N
275207	1678	13680400195000	13001	6701	0	0	\N
275208	1874	204486000	13001	6701	1	0	\N
275209	1874	204487000	13002	6702	0	0	\N
275210	1678	13680400196000	13003	6703	0	0	\N
275211	1713	780000000	13003	6703	1	0	\N
275212	1678	13680400197000	13003	6703	2	0	\N
275213	1678	13680400198000	13003	6703	3	0	\N
275214	1874	204488000	13003	6703	4	0	\N
275215	1874	204489000	13003	6703	5	0	\N
275223	1713	780000000	13006	6703	0	0	\N
275224	1678	13680400197000	13006	6703	1	0	\N
275225	1678	13680400198000	13006	6703	2	0	\N
275226	1874	204488000	13006	6703	3	0	\N
275227	1874	204489000	13006	6703	4	0	\N
275238	1678	13680400203000	13010	6706	0	0	\N
275239	1874	204494000	13010	6706	1	0	\N
275240	1678	13680400203000	13011	6706	0	0	\N
275241	1874	204494000	13011	6706	1	0	\N
275246	1678	13680400206000	13014	6709	0	0	\N
275247	1874	204497000	13014	6709	1	0	\N
275250	1678	13680400207000	13016	6710	1	0	\N
275251	1678	13680400208000	13016	6710	2	0	\N
275252	1874	204498000	13016	6710	3	0	\N
275253	1874	204499000	13016	6710	4	0	\N
275263	1483	0	13019	6712	0	0	\N
275264	1678	13680400211000	13019	6712	1	0	\N
275139	1874	204473000	12975	6690	1	0	0
275143	1678	13680400182000	12977	6691	0	0	0
275144	1678	13680400183000	12977	6691	1	0	0
275145	1874	204474000	12977	6691	2	0	0
275149	1678	13680400184000	12979	6692	0	0	0
275151	1678	13680400185000	12980	6693	0	0	0
275152	1874	204476000	12980	6693	1	0	0
275158	1678	13680400186000	12984	6694	0	0	0
275159	1874	204477000	12984	6694	1	0	0
275161	1678	13680400187000	12986	6695	0	0	0
275165	1678	13680400188000	12988	6696	0	0	0
275166	1678	13680400189000	12988	6696	1	0	0
275167	1874	204479000	12988	6696	2	0	0
275168	1874	204480000	12988	6696	3	0	0
275178	1874	204481000	12991	6697	1	0	0
275179	1678	13680400191000	12992	6698	0	0	0
275180	1678	13680400192000	12992	6698	1	0	0
275181	1874	204482000	12992	6698	2	0	0
275182	1874	204483000	12992	6698	3	0	0
275184	1678	13680400194000	12994	6700	1	0	0
275185	1874	204484000	12994	6700	2	0	0
275186	1874	204485000	12994	6700	3	0	0
275203	1678	13680400195000	12999	6701	0	0	0
275204	1874	204486000	12999	6701	1	0	0
275217	1874	204487000	13004	6702	1	0	0
275218	1713	780000000	13005	6703	0	0	0
275219	1678	13680400197000	13005	6703	1	0	0
275220	1678	13680400198000	13005	6703	2	0	0
275222	1874	204489000	13005	6703	4	0	0
275228	1678	13680400199000	13007	6704	0	0	0
275229	1678	13680400200000	13007	6704	1	0	0
275230	1678	13680400201000	13007	6704	2	0	0
275231	1874	204490000	13007	6704	3	0	0
275233	1874	204492000	13007	6704	5	0	0
275234	1678	13680400202000	13008	6705	0	0	0
275235	1874	204493000	13008	6705	1	0	0
275236	1678	13680400203000	13009	6706	0	0	0
275237	1874	204494000	13009	6706	1	0	0
275243	1678	13680400205000	13013	6708	0	0	0
275244	1874	204495000	13013	6708	1	0	0
275245	1874	204496000	13013	6708	2	0	0
275248	1678	13680400206000	13015	6709	0	0	0
275254	1678	13680400207000	13017	6710	1	0	0
275255	1678	13680400208000	13017	6710	2	0	0
275256	1874	204498000	13017	6710	3	0	0
275257	1874	204499000	13017	6710	4	0	0
275258	1678	13680400209000	13018	6711	1	0	0
275260	1874	204500000	13018	6711	3	0	0
275261	1874	204501000	13018	6711	4	0	0
275262	1874	204502000	13018	6711	5	0	0
275265	1874	204503000	13019	6712	2	0	\N
275269	1483	0	13021	6712	0	0	\N
275270	1678	13680400211000	13021	6712	1	0	\N
275271	1874	204503000	13021	6712	2	0	\N
275272	1678	13680400212000	13022	6713	0	0	\N
275273	1874	204504000	13022	6713	1	0	\N
275276	1678	13680400213000	13024	6714	0	0	\N
275277	1874	204505000	13024	6714	1	0	\N
275278	1678	13680400213000	13026	6715	0	0	\N
275279	1678	13680400214000	13026	6715	1	0	\N
275280	1874	204505000	13026	6715	2	0	\N
275281	1874	204506000	13026	6715	3	0	\N
275288	1678	13680400215000	13029	6717	0	0	\N
275289	1678	13680400216000	13029	6717	1	0	\N
275290	1874	204508000	13029	6717	2	0	\N
275291	1483	0	13029	6717	3	0	\N
275292	1874	204509000	13029	6717	4	0	\N
275305	1678	13680400220000	13032	6719	0	0	\N
275306	1874	204513000	13032	6719	1	0	\N
275309	34	67288983391438	13034	6643	1	0	\N
275310	1483	0	13034	6643	2	0	\N
275331	1678	13680400227000	13037	6722	0	0	\N
275332	1874	204525000	13037	6722	1	0	\N
275333	1874	204526000	13037	6722	2	0	\N
275337	1678	13680400227000	13039	6722	0	0	\N
275338	1874	204525000	13039	6722	1	0	\N
275339	1874	204526000	13039	6722	2	0	\N
275340	1678	13680400228000	13040	6723	0	0	\N
275341	1678	13680400229000	13040	6723	1	0	\N
275342	807	27901274526808	13040	6723	2	0	\N
275343	808	306913751943172	13040	6723	3	0	\N
275344	809	60001356617753	13040	6723	4	0	\N
275345	1874	204527000	13040	6723	5	0	\N
275346	1874	204528000	13040	6723	6	0	\N
275347	1874	204529000	13040	6723	7	0	\N
275356	1678	13680400228000	13042	6723	0	0	\N
275357	1678	13680400229000	13042	6723	1	0	\N
275358	807	27901274526808	13042	6723	2	0	\N
275359	808	306913751943172	13042	6723	3	0	\N
275360	809	60001356617753	13042	6723	4	0	\N
275361	1874	204527000	13042	6723	5	0	\N
275362	1874	204528000	13042	6723	6	0	\N
275363	1874	204529000	13042	6723	7	0	\N
275384	1678	13680400235000	13048	6728	0	0	\N
275385	2080	200000000	13048	6728	1	0	\N
275386	1636	1200000000	13048	6728	2	0	\N
275387	1874	204539000	13048	6728	3	0	\N
275388	1874	204540000	13048	6728	4	0	\N
275394	1678	13680400235000	13050	6728	0	0	\N
275395	2080	200000000	13050	6728	1	0	\N
275396	1636	1200000000	13050	6728	2	0	\N
275397	1874	204539000	13050	6728	3	0	\N
275398	1874	204540000	13050	6728	4	0	\N
275399	1678	13680400235000	13051	6728	0	0	\N
275400	2080	200000000	13051	6728	1	0	\N
275268	1874	204503000	13020	6712	2	0	0
275274	1678	13680400212000	13023	6713	0	0	0
275275	1874	204504000	13023	6713	1	0	0
275282	1678	13680400213000	13027	6715	0	0	0
275283	1678	13680400214000	13027	6715	1	0	0
275285	1874	204506000	13027	6715	3	0	0
275286	2073	413000000000	13028	6716	0	0	0
275287	1874	204507000	13028	6716	1	0	0
275293	1678	13680400215000	13030	6717	0	0	0
275294	1678	13680400216000	13030	6717	1	0	0
275296	1483	0	13030	6717	3	0	0
275297	1874	204509000	13030	6717	4	0	0
275298	34	67288983391438	13031	6718	0	0	0
275299	1678	13680400217000	13031	6718	1	0	0
275301	1678	13680400219000	13031	6718	3	0	0
275302	1874	204510000	13031	6718	4	0	0
275303	1874	204511000	13031	6718	5	0	0
275304	1874	204512000	13031	6718	6	0	0
275307	1678	13680400220000	13033	6719	0	0	0
275311	1678	13680400221000	13035	6720	0	0	0
275312	1678	13680400222000	13035	6720	1	0	0
275313	795	55816213249990	13035	6720	2	0	0
275314	796	613977809914895	13035	6720	3	0	0
275315	1678	13680400223000	13035	6720	4	0	0
275317	1678	13680400225000	13035	6720	6	0	0
275318	1874	204514000	13035	6720	7	0	0
275319	1874	204515000	13035	6720	8	0	0
275320	1874	204516000	13035	6720	9	0	0
275322	1874	204518000	13035	6720	11	0	0
275323	1874	204519000	13035	6720	12	0	0
275324	1874	204520000	13035	6720	13	0	0
275325	1874	204521000	13035	6720	14	0	0
275326	1874	204522000	13035	6720	15	0	0
275328	1874	204523000	13035	6720	17	0	0
275329	1678	13680400226000	13036	6721	0	0	0
275330	1874	204524000	13036	6721	1	0	0
275334	1678	13680400227000	13038	6722	0	0	0
275335	1874	204525000	13038	6722	1	0	0
275348	1678	13680400228000	13041	6723	0	0	0
275349	1678	13680400229000	13041	6723	1	0	0
275350	807	27901274526808	13041	6723	2	0	0
275351	808	306913751943172	13041	6723	3	0	0
275353	1874	204527000	13041	6723	5	0	0
275354	1874	204528000	13041	6723	6	0	0
275355	1874	204529000	13041	6723	7	0	0
275364	1507	100000000000	13043	6724	0	0	0
275365	1678	13680400230000	13043	6724	1	0	0
275367	1874	204530000	13043	6724	3	0	0
275368	1874	204531000	13043	6724	4	0	0
275369	1874	204532000	13043	6724	5	0	0
275370	1678	13680400232000	13044	6725	0	0	0
275371	1874	204533000	13044	6725	1	0	0
275373	810	660014346782974	13045	6726	0	0	0
275374	1678	13680400233000	13045	6726	1	0	0
275375	842	83676624395245	13045	6726	2	0	0
275376	844	156003401330624	13045	6726	3	0	0
275378	852	2237448782930877	13045	6726	5	0	0
275379	1874	204535000	13045	6726	6	0	0
275380	1874	204536000	13045	6726	7	0	0
275381	1678	13680400234000	13046	6727	0	0	0
275382	1874	204537000	13046	6727	1	0	0
275389	1678	13680400235000	13049	6728	0	0	0
275390	2080	200000000	13049	6728	1	0	0
275391	1636	1200000000	13049	6728	2	0	0
275392	1874	204539000	13049	6728	3	0	0
275393	1874	204540000	13049	6728	4	0	0
275401	1636	1200000000	13051	6728	2	0	\N
275402	1874	204539000	13051	6728	3	0	\N
275403	1874	204540000	13051	6728	4	0	\N
275404	1678	13680400235000	13052	6728	0	0	\N
275405	2080	200000000	13052	6728	1	0	\N
275406	1636	1200000000	13052	6728	2	0	\N
275407	1874	204539000	13052	6728	3	0	\N
275408	1874	204540000	13052	6728	4	0	\N
275418	1678	13680400237000	13056	6731	0	0	\N
275419	1678	13680400238000	13056	6731	1	0	\N
275420	1874	204544000	13056	6731	2	0	\N
275421	1874	204545000	13056	6731	3	0	\N
275422	1874	204546000	13056	6731	4	0	\N
275423	1678	13680400239000	13057	6732	0	0	\N
275424	1678	13680400240000	13057	6732	1	0	\N
275425	854	246714729103038	13057	6732	2	0	\N
275426	856	130502845343877	13057	6732	3	0	\N
275427	858	329060974492151	13057	6732	4	0	\N
275428	862	454509909646030	13057	6732	5	0	\N
275429	866	399008699557196	13057	6732	6	0	\N
275430	868	2430052982831172	13057	6732	7	0	\N
275431	870	259875266041231	13057	6732	8	0	\N
275432	874	2430052982831172	13057	6732	9	0	\N
275433	876	213004644124518	13057	6732	10	0	\N
275434	880	135002943459175	13057	6732	11	0	\N
275435	1874	204547000	13057	6732	12	0	\N
275436	1874	204548000	13057	6732	13	0	\N
275437	1874	204549000	13057	6732	14	0	\N
275438	1874	204550000	13057	6732	15	0	\N
275439	1678	13680400239000	13058	6732	0	0	\N
275440	1678	13680400240000	13058	6732	1	0	\N
275441	854	246714729103038	13058	6732	2	0	\N
275442	856	130502845343877	13058	6732	3	0	\N
275443	858	329060974492151	13058	6732	4	0	\N
275444	862	454509909646030	13058	6732	5	0	\N
275445	866	399008699557196	13058	6732	6	0	\N
275446	868	2430052982831172	13058	6732	7	0	\N
275447	870	259875266041231	13058	6732	8	0	\N
275448	874	2430052982831172	13058	6732	9	0	\N
275449	876	213004644124518	13058	6732	10	0	\N
275450	880	135002943459175	13058	6732	11	0	\N
275451	1874	204547000	13058	6732	12	0	\N
275452	1874	204548000	13058	6732	13	0	\N
275453	1874	204549000	13058	6732	14	0	\N
275454	1874	204550000	13058	6732	15	0	\N
275455	1678	13680400239000	13059	6732	0	0	\N
275456	1678	13680400240000	13059	6732	1	0	\N
275457	854	246714729103038	13059	6732	2	0	\N
275458	856	130502845343877	13059	6732	3	0	\N
275459	858	329060974492151	13059	6732	4	0	\N
275460	862	454509909646030	13059	6732	5	0	\N
275461	866	399008699557196	13059	6732	6	0	\N
275462	868	2430052982831172	13059	6732	7	0	\N
275463	870	259875266041231	13059	6732	8	0	\N
275464	874	2430052982831172	13059	6732	9	0	\N
275465	876	213004644124518	13059	6732	10	0	\N
275466	880	135002943459175	13059	6732	11	0	\N
275467	1874	204547000	13059	6732	12	0	\N
275468	1874	204548000	13059	6732	13	0	\N
275469	1874	204549000	13059	6732	14	0	\N
275470	1874	204550000	13059	6732	15	0	\N
275509	1678	13680400242000	13063	6734	0	0	\N
275510	1678	13680400243000	13063	6734	1	0	\N
275511	882	585012754989949	13063	6734	2	0	\N
275512	884	90001962306133	13063	6734	3	0	\N
275513	888	268618956679283	13063	6734	4	0	\N
275514	890	225491216368345	13063	6734	5	0	\N
275515	892	495010792683787	13063	6734	6	0	\N
275516	898	65298223692326	13063	6734	7	0	\N
275517	900	38924048658131	13063	6734	8	0	\N
275518	902	117002550997929	13063	6734	9	0	\N
275519	906	420759173781209	13063	6734	10	0	\N
275520	1267	94037399149501	13063	6734	11	0	\N
275521	1268	999659067789	13063	6734	12	0	\N
275522	2081	983784944532	13063	6734	13	0	\N
275523	1874	204555000	13063	6734	14	0	\N
275524	1874	204557000	13063	6734	15	0	\N
275525	1874	204560000	13063	6734	16	0	\N
275526	1874	204562000	13063	6734	17	0	\N
275527	1874	204563000	13063	6734	18	0	\N
275528	1678	14400545244000	13064	6735	0	0	\N
275529	1874	204566000	13064	6735	1	0	\N
275530	1874	204568000	13064	6735	2	0	\N
275531	1874	204569000	13064	6735	3	0	\N
275532	1678	14400545244000	13065	6735	0	0	\N
275533	1874	204566000	13065	6735	1	0	\N
275534	1874	204568000	13065	6735	2	0	\N
275535	1874	204569000	13065	6735	3	0	\N
275411	1874	204542000	13054	6730	0	0	0
275412	1874	204543000	13054	6730	1	0	0
275413	1678	13680400237000	13055	6731	0	0	0
275414	1678	13680400238000	13055	6731	1	0	0
275415	1874	204544000	13055	6731	2	0	0
275417	1874	204546000	13055	6731	4	0	0
275471	1678	13680400239000	13060	6732	0	0	0
275472	1678	13680400240000	13060	6732	1	0	0
275473	854	246714729103038	13060	6732	2	0	0
275474	856	130502845343877	13060	6732	3	0	0
275476	862	454509909646030	13060	6732	5	0	0
275477	866	399008699557196	13060	6732	6	0	0
275478	868	2430052982831172	13060	6732	7	0	0
275479	870	259875266041231	13060	6732	8	0	0
275481	876	213004644124518	13060	6732	10	0	0
275482	880	135002943459175	13060	6732	11	0	0
275483	1874	204547000	13060	6732	12	0	0
275484	1874	204548000	13060	6732	13	0	0
275485	1874	204549000	13060	6732	14	0	0
275487	1678	13680400241000	13061	6733	0	0	0
275488	1874	204553000	13061	6733	1	0	0
275489	1874	204554000	13061	6733	2	0	0
275490	1678	13680400242000	13062	6734	0	0	0
275491	1678	13680400243000	13062	6734	1	0	0
275493	884	90001962306133	13062	6734	3	0	0
275494	888	268618956679283	13062	6734	4	0	0
275495	890	225491216368345	13062	6734	5	0	0
275496	892	495010792683787	13062	6734	6	0	0
275498	900	38924048658131	13062	6734	8	0	0
275499	902	117002550997929	13062	6734	9	0	0
275500	906	420759173781209	13062	6734	10	0	0
275501	1267	94037399149501	13062	6734	11	0	0
275502	1268	999659067789	13062	6734	12	0	3
275504	1874	204555000	13062	6734	14	0	0
275505	1874	204557000	13062	6734	15	0	0
275506	1874	204560000	13062	6734	16	0	0
275507	1874	204562000	13062	6734	17	0	0
275508	1874	204563000	13062	6734	18	0	0
275540	1678	14400545244000	13067	6735	0	0	\N
275541	1874	204566000	13067	6735	1	0	\N
275542	1874	204568000	13067	6735	2	0	\N
275543	1874	204569000	13067	6735	3	0	\N
275544	2082	4000000000	13068	6736	0	0	\N
275545	1678	14400545245000	13068	6736	1	0	\N
275546	1678	14400545246000	13068	6736	2	0	\N
275547	1874	204572000	13068	6736	3	0	\N
275548	1874	204574000	13068	6736	4	0	\N
275549	1874	204575000	13068	6736	5	0	\N
275550	1874	204577000	13068	6736	6	0	\N
275551	1874	204578000	13068	6736	7	0	\N
275560	2082	4000000000	13070	6736	0	0	\N
275561	1678	14400545245000	13070	6736	1	0	\N
275562	1678	14400545246000	13070	6736	2	0	\N
275563	1874	204572000	13070	6736	3	0	\N
275564	1874	204574000	13070	6736	4	0	\N
275565	1874	204575000	13070	6736	5	0	\N
275566	1874	204577000	13070	6736	6	0	\N
275567	1874	204578000	13070	6736	7	0	\N
275568	1678	14400545247000	13071	6737	0	0	\N
275569	1874	204581000	13071	6737	2	0	\N
275570	1874	204583000	13071	6737	3	0	\N
275571	1874	204584000	13071	6737	4	0	\N
275572	1678	14400545247000	13072	6737	0	0	\N
275573	1874	204581000	13072	6737	2	0	\N
275574	1874	204583000	13072	6737	3	0	\N
275575	1874	204584000	13072	6737	4	0	\N
275577	1678	14400545247000	13074	6737	0	0	\N
275588	1678	14400545249000	13077	6739	0	0	\N
275589	1874	204590000	13077	6739	1	0	\N
275590	1874	204593000	13077	6739	2	0	\N
275591	1874	204595000	13077	6739	3	0	\N
275592	1678	14400545250000	13078	6740	0	0	\N
275593	1874	204596000	13078	6740	1	0	\N
275594	1874	204598000	13078	6740	2	0	\N
275598	1678	14400545250000	13080	6740	0	0	\N
275599	1874	204596000	13080	6740	1	0	\N
275600	1874	204598000	13080	6740	2	0	\N
275601	1678	14400545250000	13081	6740	0	0	\N
275602	1874	204596000	13081	6740	1	0	\N
275603	1874	204598000	13081	6740	2	0	\N
275604	1678	14400545251000	13082	6741	0	0	\N
275605	1874	204599000	13082	6741	1	0	\N
275606	1874	204602000	13082	6741	2	0	\N
275607	1874	204604000	13082	6741	3	0	\N
275608	1678	14400545251000	13083	6741	0	0	\N
275609	1874	204599000	13083	6741	1	0	\N
275610	1874	204602000	13083	6741	2	0	\N
275611	1874	204604000	13083	6741	3	0	\N
275612	1678	14400545251000	13084	6741	0	0	\N
275613	1874	204599000	13084	6741	1	0	\N
275614	1874	204602000	13084	6741	2	0	\N
275615	1874	204604000	13084	6741	3	0	\N
275616	1678	14400545251000	13085	6741	0	0	\N
275617	1874	204599000	13085	6741	1	0	\N
275618	1874	204602000	13085	6741	2	0	\N
275619	1874	204604000	13085	6741	3	0	\N
275638	1678	14400545255000	13090	6744	0	0	\N
275639	1874	204617000	13090	6744	1	0	\N
275640	1874	204619000	13090	6744	2	0	\N
275667	1678	14400545262000	13097	6750	0	0	\N
275668	1874	204652000	13097	6750	1	0	\N
275669	1874	204653000	13097	6750	2	0	\N
275670	1874	204655000	13097	6750	3	0	\N
275671	1678	14400545263000	13098	6751	0	0	\N
275672	1874	204658000	13098	6751	1	0	\N
275539	1874	204569000	13066	6735	3	0	0
275552	2082	4000000000	13069	6736	0	0	0
275553	1678	14400545245000	13069	6736	1	0	0
275554	1678	14400545246000	13069	6736	2	0	0
275555	1874	204572000	13069	6736	3	0	0
275557	1874	204575000	13069	6736	5	0	0
275558	1874	204577000	13069	6736	6	0	0
275559	1874	204578000	13069	6736	7	0	0
275576	1678	14400545247000	13073	6737	0	0	0
275578	1678	14400545248000	13075	6738	0	0	0
275580	1874	204583000	13075	6738	2	0	0
275581	1874	204584000	13075	6738	3	0	0
275582	1874	204587000	13075	6738	4	0	0
275583	1874	204589000	13075	6738	5	0	0
275585	1874	204590000	13076	6739	1	0	0
275586	1874	204593000	13076	6739	2	0	0
275587	1874	204595000	13076	6739	3	0	0
275595	1678	14400545250000	13079	6740	0	0	0
275596	1874	204596000	13079	6740	1	0	0
275620	1678	14400545251000	13086	6741	0	0	0
275621	1874	204599000	13086	6741	1	0	0
275622	1874	204602000	13086	6741	2	0	0
275623	1874	204604000	13086	6741	3	0	0
275624	1678	14400545252000	13087	6742	0	0	0
275626	1874	204605000	13087	6742	2	0	0
275627	1874	204608000	13087	6742	3	0	0
275628	1874	204610000	13087	6742	4	0	0
275629	1874	204611000	13087	6742	5	0	0
275631	1874	204613000	13087	6742	7	0	0
275632	1678	14400545254000	13088	6743	0	0	0
275633	1874	204614000	13088	6743	1	0	0
275634	1874	204616000	13088	6743	2	0	0
275635	1678	14400545255000	13089	6744	0	0	0
275637	1874	204619000	13089	6744	2	0	0
275641	1678	14400545256000	13091	6745	0	0	0
275642	1678	14400545257000	13092	6746	0	0	0
275643	1874	204620000	13092	6746	1	0	0
275644	1874	204623000	13092	6746	2	0	0
275646	1874	204626000	13092	6746	4	0	0
275647	1874	204628000	13092	6746	5	0	0
275648	1678	14400545258000	13093	6747	0	0	0
275649	1874	204629000	13093	6747	1	0	0
275651	1678	14400545259000	13094	6748	0	0	0
275652	1874	204634000	13094	6748	1	0	0
275653	1874	204635000	13094	6748	2	0	0
275654	1874	204637000	13094	6748	3	0	0
275655	1678	14400545260000	13095	6749	0	0	0
275657	1874	204640000	13095	6749	2	0	0
275658	1874	204641000	13095	6749	3	0	0
275659	1874	204643000	13095	6749	4	0	0
275660	1874	204646000	13095	6749	5	0	0
275661	1874	204647000	13095	6749	6	0	0
275663	1678	14400545262000	13096	6750	0	0	0
275664	1874	204652000	13096	6750	1	0	0
275665	1874	204653000	13096	6750	2	0	0
275666	1874	204655000	13096	6750	3	0	0
275673	1874	204659000	13098	6751	2	0	\N
275674	1874	204661000	13098	6751	3	0	\N
275679	1678	14400545264000	13100	6752	0	0	\N
275680	1874	204664000	13100	6752	1	0	\N
275681	1874	204665000	13100	6752	2	0	\N
275682	1874	204667000	13100	6752	3	0	\N
275683	1678	14400545264000	13101	6752	0	0	\N
275684	1874	204664000	13101	6752	1	0	\N
275685	1874	204665000	13101	6752	2	0	\N
275686	1874	204667000	13101	6752	3	0	\N
275698	1678	14400545267000	13105	6755	0	0	\N
275699	1678	14400545267000	13107	6755	0	0	\N
275700	1874	204677000	13107	6755	1	0	\N
275701	1874	204680000	13107	6755	2	0	\N
275702	1874	204682000	13107	6755	3	0	\N
275713	1678	14400545270000	13110	6757	0	0	\N
275714	1678	14400545271000	13110	6757	1	0	\N
275715	1874	204691000	13110	6757	2	0	\N
275716	1874	204692000	13110	6757	3	0	\N
275717	1874	204694000	13110	6757	4	0	\N
275718	1874	204697000	13110	6757	5	0	\N
275719	1874	204698000	13110	6757	7	0	\N
275720	1874	204700000	13110	6757	8	0	\N
275721	1678	14400545270000	13111	6757	0	0	\N
275722	1678	14400545271000	13111	6757	1	0	\N
275735	1678	14400545273000	13114	6759	0	0	\N
275736	1874	204707000	13114	6759	1	0	\N
275737	1874	204709000	13114	6759	2	0	\N
275738	1678	14400545273000	13115	6759	0	0	\N
275739	1874	204707000	13115	6759	1	0	\N
275740	1874	204709000	13115	6759	2	0	\N
275755	1678	14400545275000	13119	6761	0	0	\N
275756	1678	14400545276000	13119	6761	1	0	\N
275757	1874	204715000	13119	6761	2	0	\N
275758	1874	204716000	13119	6761	3	0	\N
275759	1874	204718000	13119	6761	4	0	\N
275760	1874	204721000	13119	6761	5	0	\N
275761	1874	204722000	13119	6761	6	0	\N
275762	1874	204724000	13119	6761	7	0	\N
275789	1678	14400545283000	13125	6766	0	0	\N
275790	1874	204758000	13125	6766	1	0	\N
275791	1874	204760000	13125	6766	2	0	\N
275804	1678	14400545284000	13128	6767	0	0	\N
275805	1678	14400545285000	13128	6767	1	0	\N
275806	1678	14400545286000	13128	6767	2	0	\N
275807	1874	204761000	13128	6767	3	0	\N
275808	1874	204764000	13128	6767	4	0	\N
275677	1874	204659000	13099	6751	2	0	0
275678	1874	204661000	13099	6751	3	0	0
275687	1678	14400545264000	13102	6752	0	0	0
275688	1874	204664000	13102	6752	1	0	0
275689	1874	204665000	13102	6752	2	0	0
275691	1678	14400545265000	13103	6753	0	0	0
275692	1874	204668000	13103	6753	1	0	0
275693	1874	204670000	13103	6753	2	0	0
275694	1678	14400545266000	13104	6754	0	0	0
275695	1874	204671000	13104	6754	1	0	0
275697	1874	204676000	13104	6754	3	0	0
275703	1678	14400545267000	13108	6755	0	0	0
275704	1874	204677000	13108	6755	1	0	0
275705	1874	204680000	13108	6755	2	0	0
275707	1678	14400545268000	13109	6756	0	0	0
275708	1678	14400545269000	13109	6756	1	0	0
275709	1874	204683000	13109	6756	2	0	0
275710	1874	204685000	13109	6756	3	0	0
275711	1874	204686000	13109	6756	4	0	0
275723	1678	14400545270000	13112	6757	0	0	0
275724	1678	14400545271000	13112	6757	1	0	0
275725	1874	204691000	13112	6757	2	0	0
275726	1874	204692000	13112	6757	3	0	0
275727	1874	204694000	13112	6757	4	0	0
275729	1874	204698000	13112	6757	7	0	0
275730	1874	204700000	13112	6757	8	0	0
275731	1678	14400545272000	13113	6758	0	0	0
275732	1874	204703000	13113	6758	1	0	0
275734	1874	204706000	13113	6758	3	0	0
275741	1678	14400545273000	13116	6759	0	0	0
275742	1874	204707000	13116	6759	1	0	0
275743	1874	204709000	13116	6759	2	0	0
275744	1678	14400545274000	13117	6760	0	0	0
275746	1874	204712000	13117	6760	2	0	0
275747	1678	14400545275000	13118	6761	0	0	0
275748	1678	14400545276000	13118	6761	1	0	0
275749	1874	204715000	13118	6761	2	0	0
275750	1874	204716000	13118	6761	3	0	0
275752	1874	204721000	13118	6761	5	0	0
275753	1874	204722000	13118	6761	6	0	0
275754	1874	204724000	13118	6761	7	0	0
275763	1678	14400545277000	13120	6762	0	0	0
275765	1874	204728000	13120	6762	2	0	0
275766	1874	204730000	13120	6762	3	0	0
275767	1678	14400545278000	13121	6763	0	0	0
275768	1678	14400545279000	13121	6763	1	0	0
275769	1678	14400545280000	13121	6763	2	0	0
275771	1874	204734000	13121	6763	4	0	0
275772	1874	204736000	13121	6763	5	0	0
275773	1874	204739000	13121	6763	6	0	0
275774	1874	204740000	13121	6763	7	0	0
275775	1874	204742000	13121	6763	8	0	0
275777	1874	204746000	13121	6763	10	0	0
275778	1874	204748000	13121	6763	11	0	0
275779	1678	14400545281000	13122	6764	0	0	0
275780	1874	204749000	13122	6764	1	0	0
275782	1678	14400545282000	13123	6765	0	0	0
275783	1874	204752000	13123	6765	1	0	0
275784	1874	204755000	13123	6765	2	0	0
275785	1874	204757000	13123	6765	3	0	0
275786	1678	14400545283000	13124	6766	0	0	0
275788	1874	204760000	13124	6766	2	0	0
275792	1678	14400545284000	13127	6767	0	0	0
275793	1678	14400545285000	13127	6767	1	0	0
275794	1678	14400545286000	13127	6767	2	0	0
275795	1874	204761000	13127	6767	3	0	0
275797	1874	204766000	13127	6767	5	0	0
275798	1874	204767000	13127	6767	6	0	0
275799	1874	204770000	13127	6767	7	0	0
275800	1874	204772000	13127	6767	8	0	0
275802	1874	204776000	13127	6767	10	0	0
275803	1874	204778000	13127	6767	11	0	0
275809	1874	204766000	13128	6767	5	0	\N
275810	1874	204767000	13128	6767	6	0	\N
275811	1874	204770000	13128	6767	7	0	\N
275812	1874	204772000	13128	6767	8	0	\N
275813	1874	204773000	13128	6767	9	0	\N
275814	1874	204776000	13128	6767	10	0	\N
275815	1874	204778000	13128	6767	11	0	\N
275816	1678	14400545284000	13129	6767	0	0	\N
275817	1678	14400545285000	13129	6767	1	0	\N
275818	1874	204761000	13129	6767	2	0	\N
275819	1874	204764000	13129	6767	3	0	\N
275820	1874	204766000	13129	6767	4	0	\N
275821	1874	204767000	13129	6767	5	0	\N
275822	1874	204770000	13129	6767	6	0	\N
275823	1874	204772000	13129	6767	7	0	\N
275824	1874	204773000	13129	6767	8	0	\N
275825	1874	204776000	13129	6767	9	0	\N
275850	1678	14400545293000	13133	6770	0	0	\N
275851	1874	204814000	13133	6770	1	0	\N
275852	1874	204817000	13133	6770	2	0	\N
275853	1874	204818000	13133	6770	3	0	\N
275858	1678	14400545294000	13135	6771	0	0	\N
275859	1874	204820000	13135	6771	1	0	\N
275860	1874	204823000	13135	6771	2	0	\N
275861	1874	204824000	13135	6771	3	0	\N
275866	1678	14400545294000	13137	6771	0	0	\N
275867	1874	204820000	13137	6771	1	0	\N
275868	1874	204823000	13137	6771	2	0	\N
275869	1678	14400545295000	13138	6772	0	0	\N
275870	1874	204826000	13138	6772	1	0	\N
275871	1874	204829000	13138	6772	2	0	\N
275872	1874	204830000	13138	6772	3	0	\N
275873	1678	14400545295000	13139	6772	0	0	\N
275874	1874	204826000	13139	6772	1	0	\N
275875	1874	204829000	13139	6772	2	0	\N
275876	1874	204830000	13139	6772	3	0	\N
275881	1678	14400545296000	13141	6773	0	0	\N
275882	1678	14400545297000	13141	6773	2	0	\N
275883	1874	204832000	13141	6773	3	0	\N
275884	1874	204835000	13141	6773	4	0	\N
275885	1874	204836000	13141	6773	5	0	\N
275886	1874	204838000	13141	6773	6	0	\N
275887	1874	204841000	13141	6773	7	0	\N
275888	1874	204842000	13141	6773	8	0	\N
275897	1678	14400545298000	13143	6774	0	0	\N
275898	1874	204844000	13143	6774	1	0	\N
275899	1874	204845000	13143	6774	2	0	\N
275900	1678	14400545298000	13144	6774	0	0	\N
275901	1874	204844000	13144	6774	1	0	\N
275902	1874	204845000	13144	6774	2	0	\N
275906	1368	1702661297751650	13146	6775	0	0	\N
275907	1678	14400545299000	13146	6775	1	0	\N
275908	1678	14400545300000	13146	6775	2	0	\N
275909	1678	14400545301000	13146	6775	3	0	\N
275910	1678	14400545302000	13146	6775	4	0	\N
275911	1678	14400545303000	13146	6775	5	0	\N
275912	1678	14400545304000	13146	6775	6	0	\N
275934	1122	905589535000000	13148	6776	0	0	\N
275935	1678	14400545305000	13148	6776	1	0	\N
275936	1874	204875000	13148	6776	2	0	\N
275937	1874	204876000	13148	6776	3	0	\N
275938	1874	204879000	13148	6776	4	0	\N
275828	1874	204782000	13130	6768	2	0	0
275829	1874	204784000	13130	6768	3	0	0
275830	1874	204785000	13130	6768	4	0	0
275831	1874	204787000	13130	6768	5	0	0
275832	1874	204790000	13130	6768	6	0	0
275834	1678	14400545289000	13132	6769	1	0	0
275835	1678	14400545290000	13132	6769	2	0	0
275836	1678	14400545291000	13132	6769	3	0	0
275837	1678	14400545292000	13132	6769	4	0	0
275838	1874	204791000	13132	6769	5	0	0
275840	1874	204794000	13132	6769	7	0	0
275841	1874	204796000	13132	6769	8	0	0
275842	1874	204799000	13132	6769	9	0	0
275843	1874	204800000	13132	6769	10	0	0
275845	1874	204805000	13132	6769	12	0	0
275846	1874	204806000	13132	6769	13	0	0
275847	1874	204808000	13132	6769	14	0	0
275848	1874	204811000	13132	6769	15	0	0
275849	1874	204812000	13132	6769	16	0	0
275855	1874	204814000	13134	6770	1	0	0
275856	1874	204817000	13134	6770	2	0	0
275857	1874	204818000	13134	6770	3	0	0
275862	1678	14400545294000	13136	6771	0	0	0
275863	1874	204820000	13136	6771	1	0	0
275865	1874	204824000	13136	6771	3	0	0
275877	1678	14400545295000	13140	6772	0	0	0
275878	1874	204826000	13140	6772	1	0	0
275879	1874	204829000	13140	6772	2	0	0
275889	1678	14400545296000	13142	6773	0	0	0
275890	1678	14400545297000	13142	6773	2	0	0
275891	1874	204832000	13142	6773	3	0	0
275892	1874	204835000	13142	6773	4	0	0
275893	1874	204836000	13142	6773	5	0	0
275895	1874	204841000	13142	6773	7	0	0
275896	1874	204842000	13142	6773	8	0	0
275903	1678	14400545298000	13145	6774	0	0	0
275904	1874	204844000	13145	6774	1	0	0
275905	1874	204845000	13145	6774	2	0	0
275914	1678	14400545299000	13147	6775	1	0	0
275915	1678	14400545300000	13147	6775	2	0	0
275916	1678	14400545301000	13147	6775	3	0	0
275917	1678	14400545302000	13147	6775	4	0	0
275919	1678	14400545304000	13147	6775	6	0	0
275920	1874	204847000	13147	6775	7	0	0
275921	1874	204849000	13147	6775	8	0	0
275922	1874	204851000	13147	6775	9	0	0
275923	1874	204852000	13147	6775	10	0	0
275925	1874	204857000	13147	6775	12	0	0
275926	1874	204858000	13147	6775	13	0	0
275927	1874	204861000	13147	6775	14	0	0
275928	1874	204863000	13147	6775	15	0	0
275929	1874	204864000	13147	6775	16	0	0
275931	1874	204869000	13147	6775	18	0	0
275932	1874	204870000	13147	6775	19	0	0
275933	1874	204873000	13147	6775	20	0	0
275939	1122	905589535000000	13149	6776	0	0	0
275941	1874	204875000	13149	6776	2	0	0
275942	1874	204876000	13149	6776	3	0	0
275943	1874	204879000	13149	6776	4	0	0
275944	1678	14400545306000	13150	6777	0	0	0
275946	1122	905589535000000	13151	6776	0	0	\N
275947	1678	14400545305000	13151	6776	1	0	\N
275948	1678	14400545306000	13151	6776	2	0	\N
275949	1874	204875000	13151	6776	3	0	\N
275950	1874	204876000	13151	6776	4	0	\N
275951	1874	204879000	13151	6776	5	0	\N
275952	1874	204881000	13151	6776	6	0	\N
275953	1678	14400545306000	13152	6777	0	0	\N
275954	1874	204881000	13152	6777	1	0	\N
275955	1678	14400545306000	13153	6777	0	0	\N
275956	1874	204881000	13153	6777	1	0	\N
275966	1014	505330736600000	13155	6778	0	0	\N
275967	1134	905548877800000	13155	6778	1	0	\N
275968	1678	14400545307000	13155	6778	2	0	\N
275969	1678	14400545308000	13155	6778	3	0	\N
275970	1254	610992052400000	13155	6778	4	0	\N
275971	1380	1702581800951650	13156	6779	0	0	\N
275972	1678	14400545309000	13156	6779	1	0	\N
275973	1874	204891000	13156	6779	2	0	\N
275974	1874	204894000	13156	6779	3	0	\N
275975	1380	1702581800951650	13157	6779	0	0	\N
275976	1678	14400545309000	13157	6779	1	0	\N
275977	1874	204891000	13157	6779	2	0	\N
275978	1874	204894000	13157	6779	3	0	\N
275987	1242	611019160000000	13160	6780	0	0	\N
275988	1678	14400545310000	13160	6780	1	0	\N
275989	1874	204891000	13160	6780	2	0	\N
275990	1874	204894000	13160	6780	3	0	\N
275991	1874	204896000	13160	6780	4	0	\N
275992	1874	204899000	13160	6780	5	0	\N
275993	1242	611019160000000	13161	6780	0	0	\N
275994	1678	14400545310000	13161	6780	1	0	\N
275995	1874	204896000	13161	6780	2	0	\N
275996	1874	204899000	13161	6780	3	0	\N
276008	1678	14400545315000	13164	6783	0	0	\N
276009	1874	204916000	13164	6783	1	0	\N
276010	1874	204919000	13164	6783	2	0	\N
276011	1874	204921000	13164	6783	3	0	\N
276012	1874	204924000	13164	6783	4	0	\N
276018	1678	14400545315000	13166	6783	0	0	\N
276019	1874	204916000	13166	6783	1	0	\N
276020	1874	204919000	13166	6783	2	0	\N
276021	1874	204921000	13166	6783	3	0	\N
276022	1874	204924000	13166	6783	4	0	\N
276027	1678	14400545317000	13169	6785	0	0	\N
276028	1874	204928000	13169	6785	1	0	\N
276029	1368	1702661297751650	13170	6752	0	0	\N
276030	1122	905589535000000	13170	6752	1	0	\N
276031	1242	611019160000000	13170	6752	2	0	\N
276032	1014	505330736600000	13170	6752	3	0	\N
276033	1678	14400545264000	13170	6752	4	0	\N
276034	1002	505354605000000	13170	6752	5	0	\N
276035	1134	905548877800000	13170	6752	6	0	\N
276036	1254	610992052400000	13170	6752	7	0	\N
276037	1380	1702581800951650	13170	6752	8	0	\N
276038	1678	14400545265000	13170	6752	9	0	\N
276039	1678	14400545266000	13170	6752	10	0	\N
276040	1678	14400545267000	13170	6752	11	0	\N
276041	1678	14400545268000	13170	6752	12	0	\N
276042	1678	14400545269000	13170	6752	13	0	\N
276043	1678	14400545270000	13170	6752	14	0	\N
276044	1678	14400545271000	13170	6752	15	0	\N
276045	1678	14400545272000	13170	6752	16	0	\N
276046	1678	14400545273000	13170	6752	17	0	\N
276047	1678	14400545274000	13170	6752	18	0	\N
276048	1678	14400545275000	13170	6752	19	0	\N
276049	1678	14400545276000	13170	6752	20	0	\N
276050	1678	14400545277000	13170	6752	21	0	\N
276051	1678	14400545278000	13170	6752	22	0	\N
276052	1678	14400545279000	13170	6752	23	0	\N
276053	1678	14400545280000	13170	6752	24	0	\N
276054	1678	14400545281000	13170	6752	25	0	\N
276055	1678	14400545282000	13170	6752	26	0	\N
276056	1678	14400545283000	13170	6752	27	0	\N
276057	1678	14400545284000	13170	6752	28	0	\N
276058	1678	14400545285000	13170	6752	29	0	\N
276059	1678	14400545286000	13170	6752	30	0	\N
276060	1678	14400545287000	13170	6752	31	0	\N
276061	1678	14400545288000	13170	6752	32	0	\N
276062	1678	14400545289000	13170	6752	33	0	\N
276063	1678	14400545290000	13170	6752	34	0	\N
276064	1678	14400545291000	13170	6752	35	0	\N
276065	1678	14400545292000	13170	6752	36	0	\N
276066	1678	14400545293000	13170	6752	38	0	\N
276067	1678	14400545294000	13170	6752	39	0	\N
276068	1678	14400545295000	13170	6752	40	0	\N
276069	1678	14400545296000	13170	6752	41	0	\N
276070	1678	14400545297000	13170	6752	42	0	\N
276071	1678	14400545298000	13170	6752	43	0	\N
276072	1678	14400545299000	13170	6752	44	0	\N
276073	1678	14400545300000	13170	6752	45	0	\N
276074	1678	14400545301000	13170	6752	46	0	\N
276075	1678	14400545302000	13170	6752	47	0	\N
276076	1678	14400545303000	13170	6752	48	0	\N
276077	1678	14400545304000	13170	6752	49	0	\N
276078	1678	14400545305000	13170	6752	50	0	\N
276079	1678	14400545306000	13170	6752	51	0	\N
276080	1678	14400545307000	13170	6752	52	0	\N
275958	1134	905548877800000	13154	6778	1	0	0
275959	1678	14400545307000	13154	6778	2	0	0
275960	1678	14400545308000	13154	6778	3	0	0
275961	1254	610992052400000	13154	6778	4	0	0
275962	1874	204883000	13154	6778	5	0	0
275964	1874	204886000	13154	6778	7	0	0
275965	1874	204889000	13154	6778	8	0	0
275979	1380	1702581800951650	13158	6779	0	0	0
275980	1678	14400545309000	13158	6779	1	0	0
275981	1242	611019160000000	13159	6780	0	0	0
275983	1874	204891000	13159	6780	2	0	0
275984	1874	204894000	13159	6780	3	0	0
275985	1874	204896000	13159	6780	4	0	0
275986	1874	204899000	13159	6780	5	0	0
275998	1678	14400545312000	13162	6781	1	0	0
275999	1002	505354605000000	13162	6781	2	0	0
276000	1678	14400545313000	13162	6781	3	0	0
276001	1874	204901000	13162	6781	4	0	0
276002	1874	204904000	13162	6781	5	0	0
276004	1874	204909000	13162	6781	7	0	0
276005	1874	204911000	13162	6781	8	0	0
276006	1874	204914000	13162	6781	9	0	0
276007	1678	14400545314000	13163	6782	0	0	0
276013	1678	14400545315000	13165	6783	0	0	0
276015	1874	204919000	13165	6783	2	0	0
276016	1874	204921000	13165	6783	3	0	0
276017	1874	204924000	13165	6783	4	0	0
276023	1678	14400545316000	13167	6784	0	0	0
276025	1678	14400545317000	13168	6785	0	0	0
276026	1874	204928000	13168	6785	1	0	0
276081	1678	14400545308000	13170	6752	53	0	\N
276082	1678	14400545309000	13170	6752	54	0	\N
276083	1678	14400545310000	13170	6752	55	0	\N
276084	1678	14400545311000	13170	6752	56	0	\N
276085	1678	14400545312000	13170	6752	57	0	\N
276086	1678	14400545313000	13170	6752	58	0	\N
276087	1678	14400545314000	13170	6752	59	0	\N
276088	1678	14400545315000	13170	6752	60	0	\N
276089	1678	14400545316000	13170	6752	61	0	\N
276090	1874	204664000	13170	6752	62	0	\N
276091	1874	204665000	13170	6752	63	0	\N
276092	1874	204667000	13170	6752	64	0	\N
276093	1874	204668000	13170	6752	65	0	\N
276094	1874	204670000	13170	6752	66	0	\N
276095	1874	204671000	13170	6752	67	0	\N
276096	1874	204674000	13170	6752	68	0	\N
276097	1874	204676000	13170	6752	69	0	\N
276098	1874	204677000	13170	6752	70	0	\N
276099	1874	204680000	13170	6752	71	0	\N
276100	1874	204682000	13170	6752	72	0	\N
276101	1874	204683000	13170	6752	73	0	\N
276102	1874	204685000	13170	6752	74	0	\N
276103	1874	204686000	13170	6752	75	0	\N
276104	1874	204688000	13170	6752	76	0	\N
276105	1874	204691000	13170	6752	77	0	\N
276106	1874	204692000	13170	6752	78	0	\N
276107	1874	204694000	13170	6752	79	0	\N
276108	1874	204697000	13170	6752	80	0	\N
276109	1874	204698000	13170	6752	81	0	\N
276110	1874	204700000	13170	6752	82	0	\N
276111	1874	204703000	13170	6752	83	0	\N
276112	1874	204704000	13170	6752	84	0	\N
276113	1874	204706000	13170	6752	85	0	\N
276114	1874	204707000	13170	6752	86	0	\N
276115	1874	204709000	13170	6752	87	0	\N
276116	1874	204710000	13170	6752	88	0	\N
276117	1874	204712000	13170	6752	89	0	\N
276118	1874	204715000	13170	6752	90	0	\N
276119	1874	204716000	13170	6752	91	0	\N
276120	1874	204718000	13170	6752	92	0	\N
276121	1874	204721000	13170	6752	93	0	\N
276122	1874	204722000	13170	6752	94	0	\N
276123	1874	204724000	13170	6752	95	0	\N
276124	1874	204727000	13170	6752	96	0	\N
276125	1874	204728000	13170	6752	97	0	\N
276126	1874	204730000	13170	6752	98	0	\N
276127	1874	204733000	13170	6752	99	0	\N
276128	1874	204734000	13170	6752	100	0	\N
276129	1874	204736000	13170	6752	101	0	\N
276130	1874	204739000	13170	6752	102	0	\N
276131	1874	204740000	13170	6752	103	0	\N
276132	1874	204742000	13170	6752	104	0	\N
276133	1874	204745000	13170	6752	105	0	\N
276134	1874	204746000	13170	6752	106	0	\N
276135	1874	204748000	13170	6752	107	0	\N
276136	1874	204749000	13170	6752	108	0	\N
276137	1874	204751000	13170	6752	109	0	\N
276138	1874	204752000	13170	6752	110	0	\N
276139	1874	204755000	13170	6752	111	0	\N
276140	1874	204757000	13170	6752	112	0	\N
276141	1874	204758000	13170	6752	113	0	\N
276142	1874	204760000	13170	6752	114	0	\N
276143	1874	204761000	13170	6752	115	0	\N
276144	1874	204764000	13170	6752	116	0	\N
276145	1874	204766000	13170	6752	117	0	\N
276146	1874	204767000	13170	6752	118	0	\N
276147	1874	204770000	13170	6752	119	0	\N
276148	1874	204772000	13170	6752	120	0	\N
276149	1874	204773000	13170	6752	121	0	\N
276150	1874	204776000	13170	6752	122	0	\N
276151	1874	204778000	13170	6752	123	0	\N
276152	1874	204779000	13170	6752	124	0	\N
276153	1874	204782000	13170	6752	125	0	\N
276157	1678	14400545319000	13172	6787	0	0	\N
276158	23	32724630000000	13172	6787	1	0	\N
276159	1874	204935000	13172	6787	2	0	\N
276160	1874	204938000	13172	6787	3	0	\N
276161	1678	14400545319000	13173	6787	0	0	\N
276162	23	32724630000000	13173	6787	1	0	\N
276163	1874	204935000	13173	6787	2	0	\N
276164	1874	204938000	13173	6787	3	0	\N
276169	1678	14400545320000	13175	6788	0	0	\N
276170	1678	14400545321000	13175	6788	1	0	\N
276171	756	1005950000000	13175	6788	2	0	\N
276172	1346	1701957637751650	13175	6788	3	0	\N
276173	1678	14400545322000	13175	6788	4	0	\N
276174	1874	204940000	13175	6788	5	0	\N
276175	1874	204943000	13175	6788	6	0	\N
276176	1874	204945000	13175	6788	7	0	\N
276177	1874	204947000	13175	6788	8	0	\N
276178	1874	204950000	13175	6788	9	0	\N
276201	1100	905216465000000	13178	6789	0	0	\N
276202	1678	14400545323000	13178	6789	1	0	\N
276203	1220	610767750000000	13178	6789	2	0	\N
276204	980	505145775000000	13178	6789	4	0	\N
276205	1678	14400545324000	13178	6789	5	0	\N
276206	1678	14400545325000	13178	6789	6	0	\N
276207	1874	204952000	13178	6789	7	0	\N
276208	1874	204955000	13178	6789	8	0	\N
276209	1874	204957000	13178	6789	9	0	\N
276210	1874	204960000	13178	6789	10	0	\N
276211	1874	204962000	13178	6789	11	0	\N
276212	1874	204965000	13178	6789	12	0	\N
276213	1100	905216465000000	13179	6789	0	0	\N
276214	1678	14400545323000	13179	6789	1	0	\N
276215	1220	610767750000000	13179	6789	2	0	\N
276216	980	505145775000000	13179	6789	4	0	\N
276156	1874	204933000	13171	6786	2	0	0
276165	1678	14400545319000	13174	6787	0	0	0
276166	23	32724630000000	13174	6787	1	0	0
276167	1874	204935000	13174	6787	2	0	0
276168	1874	204938000	13174	6787	3	0	0
276180	1678	14400545321000	13176	6788	1	0	0
276181	756	1005950000000	13176	6788	2	0	0
276182	1346	1701957637751650	13176	6788	3	0	0
276183	1678	14400545322000	13176	6788	4	0	0
276184	1874	204940000	13176	6788	5	0	0
276186	1874	204945000	13176	6788	7	0	0
276187	1874	204947000	13176	6788	8	0	0
276188	1874	204950000	13176	6788	9	0	0
276189	1100	905216465000000	13177	6789	0	0	0
276191	1220	610767750000000	13177	6789	2	0	0
276192	980	505145775000000	13177	6789	4	0	0
276193	1678	14400545324000	13177	6789	5	0	0
276194	1678	14400545325000	13177	6789	6	0	0
276195	1874	204952000	13177	6789	7	0	0
276197	1874	204957000	13177	6789	9	0	0
276198	1874	204960000	13177	6789	10	0	0
276199	1874	204962000	13177	6789	11	0	0
276200	1874	204965000	13177	6789	12	0	0
276217	1678	14400545324000	13179	6789	5	0	\N
276218	1678	14400545325000	13179	6789	6	0	\N
276219	1874	204952000	13179	6789	7	0	\N
276220	1874	204955000	13179	6789	8	0	\N
276221	1874	204957000	13179	6789	9	0	\N
276222	1874	204960000	13179	6789	10	0	\N
276223	1874	204962000	13179	6789	11	0	\N
276224	1874	204965000	13179	6789	12	0	\N
276239	1368	1702661297751650	13183	6758	0	0	\N
276240	1122	905589535000000	13183	6758	1	0	\N
276241	1242	611019160000000	13183	6758	2	0	\N
276242	1014	505330736600000	13183	6758	3	0	\N
276243	1002	505354605000000	13183	6758	4	0	\N
276244	1134	905548877800000	13183	6758	5	0	\N
276245	23	32724630000000	13183	6758	6	0	\N
276246	756	1005950000000	13183	6758	7	0	\N
276247	1254	610992052400000	13183	6758	8	0	\N
276248	1380	1702581800951650	13183	6758	9	0	\N
276249	1346	1701957637751650	13183	6758	10	0	\N
276250	1100	905216465000000	13183	6758	11	0	\N
276251	1220	610767750000000	13183	6758	12	0	\N
276252	980	505145775000000	13183	6758	13	0	\N
276253	1678	14400545272000	13183	6758	14	0	\N
276254	1678	14400545273000	13183	6758	15	0	\N
276255	1678	14400545274000	13183	6758	16	0	\N
276256	1678	14400545275000	13183	6758	17	0	\N
276257	1678	14400545276000	13183	6758	18	0	\N
276258	1678	14400545277000	13183	6758	19	0	\N
276259	1678	14400545278000	13183	6758	20	0	\N
276260	1678	14400545279000	13183	6758	21	0	\N
276261	1678	14400545280000	13183	6758	22	0	\N
276262	1678	14400545281000	13183	6758	23	0	\N
276263	1678	14400545282000	13183	6758	24	0	\N
276264	1678	14400545283000	13183	6758	25	0	\N
276265	1678	14400545284000	13183	6758	26	0	\N
276266	1678	14400545285000	13183	6758	27	0	\N
276267	1678	14400545286000	13183	6758	28	0	\N
276268	1678	14400545287000	13183	6758	29	0	\N
276269	1678	14400545288000	13183	6758	30	0	\N
276270	1678	14400545289000	13183	6758	31	0	\N
276271	1678	14400545290000	13183	6758	32	0	\N
276272	1678	14400545291000	13183	6758	33	0	\N
276273	1678	14400545292000	13183	6758	34	0	\N
276274	1678	14400545293000	13183	6758	35	0	\N
276275	1678	14400545294000	13183	6758	36	0	\N
276276	1678	14400545295000	13183	6758	37	0	\N
276277	1678	14400545296000	13183	6758	38	0	\N
276278	1678	14400545297000	13183	6758	39	0	\N
276279	1678	14400545298000	13183	6758	40	0	\N
276280	1678	14400545299000	13183	6758	41	0	\N
276281	1678	14400545300000	13183	6758	42	0	\N
276282	1678	14400545301000	13183	6758	43	0	\N
276283	1678	14400545302000	13183	6758	44	0	\N
276284	1678	14400545303000	13183	6758	45	0	\N
276285	1678	14400545304000	13183	6758	46	0	\N
276286	1678	14400545305000	13183	6758	47	0	\N
276287	1678	14400545306000	13183	6758	48	0	\N
276288	1678	14400545307000	13183	6758	49	0	\N
276289	1678	14400545308000	13183	6758	50	0	\N
276290	1678	14400545309000	13183	6758	51	0	\N
276291	1678	14400545310000	13183	6758	52	0	\N
276292	1678	14400545311000	13183	6758	53	0	\N
276293	1678	14400545312000	13183	6758	54	0	\N
276294	1678	14400545313000	13183	6758	55	0	\N
276295	1678	14400545314000	13183	6758	56	0	\N
276296	1678	14400545315000	13183	6758	57	0	\N
276297	1678	14400545316000	13183	6758	58	0	\N
276298	1678	14400545317000	13183	6758	59	0	\N
276299	1678	14400545318000	13183	6758	60	0	\N
276300	1678	14400545319000	13183	6758	61	0	\N
276301	1678	14400545320000	13183	6758	62	0	\N
276302	1678	14400545321000	13183	6758	63	0	\N
276303	1678	14400545322000	13183	6758	64	0	\N
276304	1678	14400545323000	13183	6758	65	0	\N
276305	1678	14400545324000	13183	6758	66	0	\N
276306	1678	14400545325000	13183	6758	67	0	\N
276307	1678	14400545326000	13183	6758	68	0	\N
276308	1678	14400545327000	13183	6758	69	0	\N
276309	1678	14400545328000	13183	6758	70	0	\N
276310	1678	14400545329000	13183	6758	71	0	\N
276311	1678	14400545330000	13183	6758	72	0	\N
276312	1874	204703000	13183	6758	73	0	\N
276313	1874	204704000	13183	6758	74	0	\N
276314	1874	204706000	13183	6758	75	0	\N
276315	1874	204707000	13183	6758	76	0	\N
276316	1874	204709000	13183	6758	77	0	\N
276317	1874	204710000	13183	6758	78	0	\N
276318	1874	204712000	13183	6758	79	0	\N
276319	1874	204715000	13183	6758	80	0	\N
276320	1874	204716000	13183	6758	81	0	\N
276321	1874	204718000	13183	6758	82	0	\N
276322	1874	204721000	13183	6758	83	0	\N
276323	1874	204722000	13183	6758	84	0	\N
276324	1874	204724000	13183	6758	85	0	\N
276325	1874	204727000	13183	6758	86	0	\N
276326	1874	204728000	13183	6758	87	0	\N
276327	1874	204730000	13183	6758	88	0	\N
276328	1874	204733000	13183	6758	89	0	\N
276329	1874	204734000	13183	6758	90	0	\N
276330	1874	204736000	13183	6758	91	0	\N
276331	1874	204739000	13183	6758	92	0	\N
276332	1874	204740000	13183	6758	93	0	\N
276333	1874	204742000	13183	6758	94	0	\N
276334	1874	204745000	13183	6758	95	0	\N
276335	1874	204746000	13183	6758	96	0	\N
276336	1874	204748000	13183	6758	97	0	\N
276337	1874	204749000	13183	6758	98	0	\N
276338	1874	204751000	13183	6758	99	0	\N
276339	1874	204752000	13183	6758	100	0	\N
276340	1874	204755000	13183	6758	101	0	\N
276341	1874	204757000	13183	6758	102	0	\N
276342	1874	204758000	13183	6758	103	0	\N
276343	1874	204760000	13183	6758	104	0	\N
276344	1874	204761000	13183	6758	105	0	\N
276345	1874	204764000	13183	6758	106	0	\N
276346	1874	204766000	13183	6758	107	0	\N
276347	1874	204767000	13183	6758	108	0	\N
276348	1874	204770000	13183	6758	109	0	\N
276349	1874	204772000	13183	6758	110	0	\N
276350	1874	204773000	13183	6758	111	0	\N
276351	1874	204776000	13183	6758	112	0	\N
276352	1874	204778000	13183	6758	113	0	\N
276227	1678	14400545328000	13180	6790	2	0	0
276228	1874	204967000	13180	6790	3	0	0
276229	1874	204970000	13180	6790	4	0	0
276230	1874	204972000	13180	6790	5	0	0
276231	1874	204975000	13180	6790	6	0	0
276233	1874	204980000	13180	6790	8	0	0
276234	1678	14400545329000	13181	6791	0	0	0
276235	1678	14400545330000	13182	6792	0	0	0
276236	1874	204982000	13182	6792	1	0	0
276237	1874	204985000	13182	6792	2	0	0
276353	1874	204779000	13183	6758	114	0	\N
276354	1874	204782000	13183	6758	115	0	\N
276355	1874	204784000	13183	6758	116	0	\N
276356	1874	204785000	13183	6758	117	0	\N
276357	1874	204787000	13183	6758	118	0	\N
276358	1874	204790000	13183	6758	119	0	\N
276359	1874	204791000	13183	6758	120	0	\N
276360	1874	204793000	13183	6758	121	0	\N
276361	1874	204794000	13183	6758	122	0	\N
276362	1874	204796000	13183	6758	124	0	\N
276363	1874	204799000	13183	6758	125	0	\N
276370	1678	14400545331000	13185	6793	0	0	\N
276371	1678	14400545332000	13185	6793	1	0	\N
276387	1678	14400545338000	13189	6797	0	0	\N
276388	1678	14400545339000	13189	6797	1	0	\N
276389	1678	14400545340000	13189	6797	2	0	\N
276390	1874	205024000	13189	6797	3	0	\N
276391	1874	205027000	13189	6797	4	0	\N
276392	1874	205029000	13189	6797	5	0	\N
276393	1874	205032000	13189	6797	6	0	\N
276394	1874	205034000	13189	6797	7	0	\N
276395	1874	205037000	13189	6797	8	0	\N
276399	1678	14400545341000	13191	6798	0	0	\N
276400	1874	205024000	13191	6798	1	0	\N
276401	1874	205027000	13191	6798	2	0	\N
276402	1874	205029000	13191	6798	3	0	\N
276403	1874	205032000	13191	6798	4	0	\N
276404	1874	205034000	13191	6798	5	0	\N
276405	1874	205037000	13191	6798	6	0	\N
276406	1678	14400545341000	13192	6798	0	0	\N
276407	1874	205024000	13192	6798	1	0	\N
276408	1874	205027000	13192	6798	2	0	\N
276409	1874	205029000	13192	6798	3	0	\N
276410	1874	205032000	13192	6798	4	0	\N
276411	1874	205034000	13192	6798	5	0	\N
276412	1874	205037000	13192	6798	6	0	\N
276413	1874	205039000	13192	6798	7	0	\N
276414	1874	205042000	13192	6798	8	0	\N
276415	1874	205024000	13193	6798	0	0	\N
276416	1874	205027000	13193	6798	1	0	\N
276417	1874	205029000	13193	6798	2	0	\N
276418	1874	205032000	13193	6798	3	0	\N
276419	1874	205034000	13193	6798	4	0	\N
276420	1874	205037000	13193	6798	5	0	\N
276421	1874	205039000	13193	6798	6	0	\N
276422	1874	205042000	13193	6798	7	0	\N
276429	1678	14400545341000	13195	6799	0	0	\N
276430	1678	14400545342000	13195	6799	1	0	\N
276431	1678	14400545341000	13196	6799	0	0	\N
276432	1678	14400545342000	13196	6799	1	0	\N
276433	1874	205039000	13196	6799	2	0	\N
276434	1874	205042000	13196	6799	3	0	\N
276435	1874	205044000	13196	6799	4	0	\N
276436	1874	205047000	13196	6799	5	0	\N
276457	1678	14400545346000	13201	6802	0	0	\N
276458	1678	14400545347000	13201	6802	1	0	\N
276459	1874	205062000	13201	6802	2	0	\N
276460	1874	205064000	13201	6802	3	0	\N
276461	1874	205067000	13201	6802	4	0	\N
276462	1874	205069000	13201	6802	5	0	\N
276466	1874	205072000	13203	6803	0	0	\N
276467	1874	205074000	13203	6803	1	0	\N
276471	1678	14400545349000	13205	6804	0	0	\N
276472	1874	205077000	13205	6804	1	0	\N
276473	1874	205079000	13205	6804	2	0	\N
276474	1678	14400545349000	13206	6804	0	0	\N
276484	1678	14400545353000	13210	6808	0	0	\N
276485	1678	14400545354000	13210	6808	2	0	\N
276486	1874	205097000	13210	6808	3	0	\N
276487	1874	205099000	13210	6808	4	0	\N
276488	1874	205102000	13210	6808	5	0	\N
276366	1874	204990000	13184	6793	2	0	0
276367	1874	204992000	13184	6793	3	0	0
276368	1874	204995000	13184	6793	4	0	0
276369	1874	204997000	13184	6793	5	0	0
276372	1678	14400545333000	13186	6794	0	0	0
276374	1678	14400545335000	13187	6795	0	0	0
276375	1874	204999000	13187	6795	1	0	0
276376	1874	205002000	13187	6795	2	0	0
276377	1874	205004000	13187	6795	3	0	0
276378	1874	205007000	13187	6795	4	0	0
276380	1874	205012000	13187	6795	6	0	0
276381	1678	14400545336000	13188	6796	0	0	0
276382	1678	14400545337000	13188	6796	1	0	0
276383	1874	205014000	13188	6796	2	0	0
276385	1874	205019000	13188	6796	4	0	0
276386	1874	205022000	13188	6796	5	0	0
276396	1678	14400545338000	13190	6797	0	0	0
276397	1678	14400545339000	13190	6797	1	0	0
276398	1678	14400545340000	13190	6797	2	0	0
276424	1874	205027000	13194	6798	1	0	0
276425	1874	205029000	13194	6798	2	0	0
276426	1874	205032000	13194	6798	3	0	0
276427	1874	205034000	13194	6798	4	0	0
276428	1874	205037000	13194	6798	5	0	0
276438	1678	14400545342000	13197	6799	1	0	0
276439	1874	205039000	13197	6799	2	0	0
276440	1874	205042000	13197	6799	3	0	0
276441	1874	205044000	13197	6799	4	0	0
276443	1678	14400545343000	13198	6800	0	0	0
276444	1874	205049000	13198	6800	1	0	0
276445	1874	205052000	13198	6800	2	0	0
276446	1678	14400545344000	13199	6801	0	0	0
276447	1678	14400545345000	13199	6801	1	0	0
276449	1874	205057000	13199	6801	3	0	0
276450	1874	205059000	13199	6801	4	0	0
276451	1678	14400545346000	13200	6802	0	0	0
276452	1678	14400545347000	13200	6802	1	0	0
276453	1874	205062000	13200	6802	2	0	0
276455	1874	205067000	13200	6802	4	0	0
276456	1874	205069000	13200	6802	5	0	0
276463	1678	14400545348000	13202	6803	0	0	0
276464	1874	205072000	13202	6803	1	0	0
276468	1678	14400545349000	13204	6804	0	0	0
276469	1874	205077000	13204	6804	1	0	0
276470	1874	205079000	13204	6804	2	0	0
276475	1678	14400545350000	13207	6805	0	0	0
276476	1874	205082000	13207	6805	1	0	0
276478	1678	14400545351000	13208	6806	0	0	0
276479	1874	205087000	13208	6806	1	0	0
276480	1874	205089000	13208	6806	2	0	0
276481	1678	14400545352000	13209	6807	0	0	0
276482	1874	205092000	13209	6807	1	0	0
276489	1874	205104000	13210	6808	6	0	\N
276499	1678	14400545356000	13213	6810	0	0	\N
276500	1678	14400545357000	13213	6810	1	0	\N
276501	1874	205112000	13213	6810	2	0	\N
276502	1874	205114000	13213	6810	3	0	\N
276503	1874	205116000	13213	6810	4	0	\N
276515	1678	14400545331000	13217	6759	0	0	\N
276516	1678	14400545332000	13217	6759	1	0	\N
276517	1678	14400545333000	13217	6759	2	0	\N
276518	1678	14400545334000	13217	6759	3	0	\N
276519	1678	14400545335000	13217	6759	4	0	\N
276520	1678	14400545336000	13217	6759	5	0	\N
276521	1678	14400545337000	13217	6759	6	0	\N
276522	1678	14400545338000	13217	6759	7	0	\N
276523	1678	14400545339000	13217	6759	8	0	\N
276524	1678	14400545340000	13217	6759	9	0	\N
276525	1678	14400545341000	13217	6759	10	0	\N
276526	1678	14400545342000	13217	6759	11	0	\N
276527	1678	14400545343000	13217	6759	12	0	\N
276528	1678	14400545344000	13217	6759	13	0	\N
276529	1678	14400545345000	13217	6759	14	0	\N
276530	1678	14400545346000	13217	6759	15	0	\N
276531	1678	14400545347000	13217	6759	16	0	\N
276532	1678	14400545348000	13217	6759	17	0	\N
276533	1678	14400545349000	13217	6759	18	0	\N
276534	1678	14400545350000	13217	6759	19	0	\N
276535	1678	14400545351000	13217	6759	20	0	\N
276536	1678	14400545352000	13217	6759	21	0	\N
276537	1678	14400545353000	13217	6759	22	0	\N
276538	1678	14400545354000	13217	6759	23	0	\N
276539	1678	14400545355000	13217	6759	24	0	\N
276540	1678	14400545356000	13217	6759	25	0	\N
276541	1678	14400545357000	13217	6759	26	0	\N
276542	1678	14400545358000	13217	6759	27	0	\N
276543	1678	14400545359000	13217	6759	28	0	\N
276544	1874	204800000	13217	6759	29	0	\N
276545	1874	204802000	13217	6759	30	0	\N
276546	1874	204805000	13217	6759	31	0	\N
276547	1874	204806000	13217	6759	32	0	\N
276548	1874	204808000	13217	6759	33	0	\N
276549	1874	204811000	13217	6759	34	0	\N
276550	1874	204812000	13217	6759	35	0	\N
276551	1874	204814000	13217	6759	36	0	\N
276552	1874	204817000	13217	6759	37	0	\N
276553	1874	204818000	13217	6759	38	0	\N
276554	1874	204820000	13217	6759	39	0	\N
276555	1874	204823000	13217	6759	40	0	\N
276556	1874	204824000	13217	6759	41	0	\N
276557	1874	204826000	13217	6759	42	0	\N
276558	1874	204829000	13217	6759	43	0	\N
276559	1874	204830000	13217	6759	44	0	\N
276560	1874	204832000	13217	6759	45	0	\N
276561	1874	204835000	13217	6759	46	0	\N
276562	1874	204836000	13217	6759	47	0	\N
276563	1874	204838000	13217	6759	48	0	\N
276564	1874	204841000	13217	6759	49	0	\N
276565	1874	204842000	13217	6759	50	0	\N
276566	1874	204844000	13217	6759	51	0	\N
276567	1874	204845000	13217	6759	52	0	\N
276568	1874	204847000	13217	6759	53	0	\N
276569	1874	204849000	13217	6759	54	0	\N
276570	1874	204851000	13217	6759	55	0	\N
276571	1874	204852000	13217	6759	56	0	\N
276572	1874	204855000	13217	6759	57	0	\N
276573	1874	204857000	13217	6759	58	0	\N
276574	1874	204858000	13217	6759	59	0	\N
276575	1874	204861000	13217	6759	60	0	\N
276576	1874	204863000	13217	6759	61	0	\N
276577	1874	204864000	13217	6759	62	0	\N
276578	1874	204867000	13217	6759	63	0	\N
276579	1874	204869000	13217	6759	64	0	\N
276580	1874	204870000	13217	6759	65	0	\N
276581	1874	204873000	13217	6759	66	0	\N
276582	1874	204875000	13217	6759	67	0	\N
276583	1874	204876000	13217	6759	68	0	\N
276584	1874	204879000	13217	6759	69	0	\N
276585	1874	204881000	13217	6759	70	0	\N
276586	1874	204883000	13217	6759	71	0	\N
276587	1874	204884000	13217	6759	72	0	\N
276588	1874	204886000	13217	6759	73	0	\N
276589	1874	204889000	13217	6759	74	0	\N
276590	1874	204891000	13217	6759	75	0	\N
276591	1874	204894000	13217	6759	76	0	\N
276592	1874	204896000	13217	6759	77	0	\N
276593	1874	204899000	13217	6759	78	0	\N
276594	1874	204901000	13217	6759	79	0	\N
276595	1874	204904000	13217	6759	80	0	\N
276596	1874	204906000	13217	6759	81	0	\N
276597	1874	204909000	13217	6759	82	0	\N
276598	1874	204911000	13217	6759	83	0	\N
276599	1874	204914000	13217	6759	84	0	\N
276600	1874	204916000	13217	6759	85	0	\N
276601	1874	204919000	13217	6759	86	0	\N
276602	1874	204921000	13217	6759	87	0	\N
276603	1874	204924000	13217	6759	88	0	\N
276604	1874	204926000	13217	6759	89	0	\N
276605	1874	204928000	13217	6759	90	0	\N
276606	1874	204930000	13217	6759	91	0	\N
276607	1874	204933000	13217	6759	92	0	\N
276608	1874	204935000	13217	6759	93	0	\N
276609	1874	204938000	13217	6759	94	0	\N
276610	1874	204940000	13217	6759	95	0	\N
276611	1874	204943000	13217	6759	96	0	\N
276612	1874	204945000	13217	6759	97	0	\N
276613	1874	204947000	13217	6759	98	0	\N
276614	1874	204950000	13217	6759	99	0	\N
276615	1874	204952000	13217	6759	100	0	\N
276616	1874	204955000	13217	6759	101	0	\N
276617	1874	204957000	13217	6759	102	0	\N
276618	1874	204960000	13217	6759	103	0	\N
276619	1874	204962000	13217	6759	104	0	\N
276620	1874	204965000	13217	6759	105	0	\N
276621	1874	204967000	13217	6759	106	0	\N
276622	1874	204970000	13217	6759	107	0	\N
276623	1874	204972000	13217	6759	108	0	\N
276624	1874	204975000	13217	6759	109	0	\N
276492	1678	14400545355000	13212	6809	0	0	0
276493	1874	205097000	13212	6809	1	0	0
276494	1874	205099000	13212	6809	2	0	0
276495	1874	205102000	13212	6809	3	0	0
276496	1874	205104000	13212	6809	4	0	0
276498	1874	205109000	13212	6809	6	0	0
276504	1678	14400545356000	13214	6810	0	0	0
276505	1678	14400545357000	13214	6810	1	0	0
276506	1874	205112000	13214	6810	2	0	0
276507	1874	205114000	13214	6810	3	0	0
276509	1678	14400545358000	13215	6811	0	0	0
276510	1874	205118000	13215	6811	1	0	0
276511	1874	205121000	13215	6811	2	0	0
276512	1678	14400545359000	13216	6812	0	0	0
276514	1874	205126000	13216	6812	2	0	0
276625	1874	204977000	13217	6759	110	0	\N
276626	1874	204980000	13217	6759	111	0	\N
276627	1874	204982000	13217	6759	112	0	\N
276628	1874	204985000	13217	6759	113	0	\N
276629	1874	204987000	13217	6759	114	0	\N
276630	1874	204990000	13217	6759	115	0	\N
276631	1874	204992000	13217	6759	116	0	\N
276632	1874	204995000	13217	6759	117	0	\N
276633	1874	204997000	13217	6759	118	0	\N
276634	1874	204999000	13217	6759	119	0	\N
276635	1874	205002000	13217	6759	120	0	\N
276636	1874	205004000	13217	6759	121	0	\N
276637	1874	205007000	13217	6759	122	0	\N
276638	1874	205009000	13217	6759	124	0	\N
276639	1874	205012000	13217	6759	125	0	\N
276640	1678	14400545360000	13218	6813	0	0	\N
276641	1678	14400545361000	13218	6813	1	0	\N
276642	1874	205128000	13218	6813	2	0	\N
276643	1874	205131000	13218	6813	3	0	\N
276644	1874	205133000	13218	6813	4	0	\N
276645	1874	205136000	13218	6813	5	0	\N
276648	1678	14400545362000	13220	6814	0	0	\N
276649	1874	205128000	13220	6814	1	0	\N
276650	1874	205131000	13220	6814	2	0	\N
276651	1874	205133000	13220	6814	3	0	\N
276652	1874	205136000	13220	6814	4	0	\N
276653	1874	205138000	13220	6814	5	0	\N
276654	1874	205141000	13220	6814	6	0	\N
276665	1678	14400545363000	13223	6815	0	0	\N
276666	1678	14400545363000	13224	6815	0	0	\N
276667	1874	205143000	13224	6815	1	0	\N
276668	1874	205146000	13224	6815	2	0	\N
276669	1678	14400545363000	13225	6815	0	0	\N
276670	1874	205143000	13225	6815	1	0	\N
276671	1874	205146000	13225	6815	2	0	\N
276672	1242	611019160000000	13226	6778	0	0	\N
276673	1014	505330736600000	13226	6778	1	0	\N
276674	1002	505354605000000	13226	6778	2	0	\N
276675	1134	905548877800000	13226	6778	3	0	\N
276676	23	32724630000000	13226	6778	4	0	\N
276677	756	1005950000000	13226	6778	5	0	\N
276678	1678	14400545307000	13226	6778	6	0	\N
276679	1678	14400545308000	13226	6778	7	0	\N
276680	1678	14400545309000	13226	6778	8	0	\N
276681	1678	14400545310000	13226	6778	9	0	\N
276682	1678	14400545311000	13226	6778	10	0	\N
276683	1678	14400545312000	13226	6778	11	0	\N
276684	1254	610992052400000	13226	6778	12	0	\N
276685	1380	1702581800951650	13226	6778	13	0	\N
276686	1346	1701957637751650	13226	6778	14	0	\N
276687	1100	905216465000000	13226	6778	15	0	\N
276688	1220	610767750000000	13226	6778	16	0	\N
276689	980	505145775000000	13226	6778	17	0	\N
276690	1678	14400545313000	13226	6778	18	0	\N
276691	1678	14400545314000	13226	6778	19	0	\N
276692	1678	14400545315000	13226	6778	20	0	\N
276693	1678	14400545316000	13226	6778	21	0	\N
276694	1678	14400545317000	13226	6778	22	0	\N
276695	1678	14400545318000	13226	6778	23	0	\N
276696	1678	14400545319000	13226	6778	24	0	\N
276697	1678	14400545320000	13226	6778	25	0	\N
276698	1678	14400545321000	13226	6778	26	0	\N
276699	1678	14400545322000	13226	6778	27	0	\N
276700	1678	14400545323000	13226	6778	28	0	\N
276701	1678	14400545324000	13226	6778	29	0	\N
276702	1678	14400545325000	13226	6778	30	0	\N
276703	1678	14400545326000	13226	6778	31	0	\N
276704	1678	14400545327000	13226	6778	32	0	\N
276705	1678	14400545328000	13226	6778	33	0	\N
276706	1678	14400545329000	13226	6778	34	0	\N
276707	1678	14400545330000	13226	6778	35	0	\N
276708	1678	14400545331000	13226	6778	36	0	\N
276709	1678	14400545332000	13226	6778	37	0	\N
276710	1678	14400545333000	13226	6778	38	0	\N
276711	1678	14400545334000	13226	6778	39	0	\N
276712	1678	14400545335000	13226	6778	40	0	\N
276713	1678	14400545336000	13226	6778	41	0	\N
276714	1678	14400545337000	13226	6778	42	0	\N
276715	1678	14400545338000	13226	6778	43	0	\N
276716	1678	14400545339000	13226	6778	44	0	\N
276717	1678	14400545340000	13226	6778	45	0	\N
276718	1678	14400545341000	13226	6778	46	0	\N
276719	1678	14400545342000	13226	6778	47	0	\N
276720	1678	14400545343000	13226	6778	48	0	\N
276721	1678	14400545344000	13226	6778	49	0	\N
276722	1678	14400545345000	13226	6778	50	0	\N
276723	1678	14400545346000	13226	6778	51	0	\N
276724	1678	14400545347000	13226	6778	52	0	\N
276725	1678	14400545348000	13226	6778	53	0	\N
276726	1678	14400545349000	13226	6778	54	0	\N
276727	1678	14400545350000	13226	6778	55	0	\N
276728	1678	14400545351000	13226	6778	56	0	\N
276729	1678	14400545352000	13226	6778	57	0	\N
276730	1678	14400545353000	13226	6778	58	0	\N
276731	1678	14400545354000	13226	6778	59	0	\N
276732	1678	14400545355000	13226	6778	60	0	\N
276733	1678	14400545356000	13226	6778	61	0	\N
276734	1678	14400545357000	13226	6778	62	0	\N
276735	1678	14400545358000	13226	6778	63	0	\N
276736	1678	14400545359000	13226	6778	64	0	\N
276737	1678	14400545360000	13226	6778	65	0	\N
276738	1678	14400545361000	13226	6778	66	0	\N
276739	1678	14400545362000	13226	6778	67	0	\N
276740	1678	14400545363000	13226	6778	68	0	\N
276741	1678	14400545364000	13228	6816	0	0	\N
276742	1678	14400545365000	13228	6816	1	0	\N
276743	1874	205148000	13228	6816	2	0	\N
276744	1874	205151000	13228	6816	3	0	\N
276745	1874	205153000	13228	6816	4	0	\N
276746	1874	205156000	13228	6816	5	0	\N
276747	1678	14400545364000	13229	6816	0	0	\N
276748	1678	14400545365000	13229	6816	1	0	\N
276749	1874	205148000	13229	6816	2	0	\N
276750	1874	205151000	13229	6816	3	0	\N
276751	1874	205153000	13229	6816	4	0	\N
276752	1874	205156000	13229	6816	5	0	\N
276655	1678	14400545362000	13221	6814	0	0	0
276656	1874	205128000	13221	6814	1	0	0
276657	1874	205131000	13221	6814	2	0	0
276658	1874	205133000	13221	6814	3	0	0
276659	1874	205136000	13221	6814	4	0	0
276661	1874	205141000	13221	6814	6	0	0
276662	1678	14400545363000	13222	6815	0	0	0
276663	1874	205143000	13222	6815	1	0	0
276664	1874	205146000	13222	6815	2	0	0
276753	1678	14400545364000	13230	6817	0	0	0
276755	1874	205148000	13230	6817	2	0	0
276756	1874	205151000	13230	6817	3	0	0
276757	1874	205153000	13230	6817	4	0	0
276758	1874	205156000	13230	6817	5	0	0
276760	1874	205161000	13231	6818	0	0	0
276761	1874	205158000	13232	6817	0	0	\N
276762	1874	205161000	13232	6817	1	0	\N
276763	1874	205158000	13233	6817	0	0	\N
276764	1874	205161000	13233	6817	1	0	\N
276765	1678	14400545360000	13234	6760	0	0	\N
276766	1678	14400545361000	13234	6760	1	0	\N
276767	1678	14400545362000	13234	6760	2	0	\N
276768	1678	14400545363000	13234	6760	3	0	\N
276769	1678	14400545364000	13234	6760	4	0	\N
276770	1678	14400545365000	13234	6760	5	0	\N
276771	1874	205014000	13234	6760	6	0	\N
276772	1874	205017000	13234	6760	7	0	\N
276773	1874	205019000	13234	6760	8	0	\N
276774	1874	205022000	13234	6760	9	0	\N
276775	1874	205024000	13234	6760	10	0	\N
276776	1874	205027000	13234	6760	11	0	\N
276777	1874	205029000	13234	6760	12	0	\N
276778	1874	205032000	13234	6760	13	0	\N
276779	1874	205034000	13234	6760	14	0	\N
276780	1874	205037000	13234	6760	15	0	\N
276781	1874	205039000	13234	6760	16	0	\N
276782	1874	205042000	13234	6760	17	0	\N
276783	1874	205044000	13234	6760	18	0	\N
276784	1874	205047000	13234	6760	19	0	\N
276785	1874	205049000	13234	6760	20	0	\N
276786	1874	205052000	13234	6760	21	0	\N
276787	1874	205054000	13234	6760	22	0	\N
276788	1874	205057000	13234	6760	23	0	\N
276789	1874	205059000	13234	6760	24	0	\N
276790	1874	205062000	13234	6760	25	0	\N
276791	1874	205064000	13234	6760	26	0	\N
276792	1874	205067000	13234	6760	27	0	\N
276793	1874	205069000	13234	6760	28	0	\N
276794	1874	205072000	13234	6760	29	0	\N
276795	1874	205074000	13234	6760	30	0	\N
276796	1874	205077000	13234	6760	31	0	\N
276797	1874	205079000	13234	6760	32	0	\N
276798	1874	205082000	13234	6760	33	0	\N
276799	1874	205084000	13234	6760	34	0	\N
276800	1874	205087000	13234	6760	35	0	\N
276801	1874	205089000	13234	6760	36	0	\N
276802	1874	205092000	13234	6760	37	0	\N
276803	1874	205094000	13234	6760	38	0	\N
276804	1874	205097000	13234	6760	39	0	\N
276805	1874	205099000	13234	6760	40	0	\N
276806	1874	205102000	13234	6760	41	0	\N
276807	1874	205104000	13234	6760	42	0	\N
276808	1874	205107000	13234	6760	43	0	\N
276809	1874	205109000	13234	6760	44	0	\N
276810	1874	205112000	13234	6760	45	0	\N
276811	1874	205114000	13234	6760	46	0	\N
276812	1874	205116000	13234	6760	47	0	\N
276813	1874	205118000	13234	6760	48	0	\N
276814	1874	205121000	13234	6760	49	0	\N
276815	1874	205123000	13234	6760	50	0	\N
276816	1874	205126000	13234	6760	51	0	\N
276817	1874	205128000	13234	6760	52	0	\N
276818	1874	205131000	13234	6760	53	0	\N
276819	1874	205133000	13234	6760	54	0	\N
276820	1874	205136000	13234	6760	55	0	\N
276821	1678	14400545366000	13235	6819	0	0	\N
276822	1678	14400545366000	13236	6818	0	0	\N
276823	1874	205163000	13236	6818	1	0	\N
276824	1678	14400545366000	13237	6819	0	0	\N
276825	1874	205163000	13237	6819	1	0	\N
276826	1874	205166000	13237	6819	2	0	\N
276827	1678	14400545366000	13238	6819	0	0	\N
276828	1874	205163000	13238	6819	1	0	\N
276829	1874	205166000	13238	6819	2	0	\N
276831	1678	14400545366000	13240	6819	0	0	\N
276832	1874	205163000	13240	6819	1	0	\N
276833	1874	205166000	13240	6819	2	0	\N
276838	1346	1701957637751650	13242	6787	0	0	\N
276839	1100	905216465000000	13242	6787	1	0	\N
276840	1220	610767750000000	13242	6787	2	0	\N
276841	980	505145775000000	13242	6787	3	0	\N
276842	1678	14400545368000	13243	6821	0	0	\N
276843	1874	205171000	13243	6821	1	0	\N
276844	1874	205173000	13243	6821	2	0	\N
276845	1874	205176000	13243	6821	3	0	\N
276850	1678	14400545369000	13245	6822	0	0	\N
276851	1874	205178000	13245	6822	1	0	\N
276855	1678	14400545370000	13248	6823	0	0	\N
276856	1874	205178000	13248	6823	1	0	\N
276857	1874	205181000	13248	6823	2	0	\N
276858	1874	205183000	13248	6823	3	0	\N
276859	1678	14400545370000	13249	6823	0	0	\N
276860	1874	205178000	13249	6823	1	0	\N
276861	1874	205181000	13249	6823	2	0	\N
276862	1874	205183000	13249	6823	3	0	\N
276885	1678	14400545378000	13257	6829	0	0	\N
276895	1678	14400545381000	13261	6832	0	0	\N
276896	1678	14400545382000	13261	6832	1	0	\N
276835	1874	205163000	13241	6820	1	0	0
276836	1874	205166000	13241	6820	2	0	0
276837	1874	205168000	13241	6820	3	0	0
276846	1678	14400545368000	13244	6821	0	0	0
276847	1874	205171000	13244	6821	1	0	0
276849	1874	205176000	13244	6821	3	0	0
276852	1678	14400545369000	13246	6822	0	0	0
276853	1678	14400545370000	13247	6823	0	0	0
276854	1874	205178000	13247	6823	1	0	0
276863	1678	14400545371000	13250	6824	0	0	0
276865	1874	205183000	13250	6824	2	0	0
276866	1874	205185000	13250	6824	3	0	0
276867	1678	14400545372000	13251	6825	0	0	0
276868	1874	205187000	13251	6825	1	0	0
276870	1678	14400545373000	13252	6826	0	0	0
276871	1874	205192000	13252	6826	1	0	0
276872	1874	205195000	13252	6826	2	0	0
276873	1678	14400545374000	13254	6827	0	0	0
276874	1678	14400545375000	13254	6827	1	0	0
276876	1874	205200000	13254	6827	3	0	0
276877	1874	205202000	13254	6827	4	0	0
276878	1874	205205000	13254	6827	5	0	0
276879	1678	14400545376000	13256	6828	0	0	0
276880	1678	14400545377000	13256	6828	1	0	0
276882	1874	205210000	13256	6828	3	0	0
276883	1874	205212000	13256	6828	4	0	0
276884	1874	205215000	13256	6828	5	0	0
276886	1678	14400545378000	13258	6829	0	0	0
276888	1874	205220000	13258	6829	3	0	0
276889	1678	14400545379000	13259	6830	0	0	0
276890	1678	14400545380000	13260	6831	0	0	0
276891	2085	0	13260	6831	1	0	0
276892	1874	205222000	13260	6831	2	0	0
276894	1874	205227000	13260	6831	5	0	0
276897	1874	205230000	13261	6832	2	0	\N
276898	1874	205232000	13261	6832	3	0	\N
276899	1874	205234000	13261	6832	4	0	\N
276907	1678	14400545381000	13264	6833	0	0	\N
276908	1678	14400545382000	13264	6833	1	0	\N
276909	1678	14400545383000	13264	6833	2	0	\N
276910	1874	205230000	13264	6833	3	0	\N
276911	1874	205232000	13264	6833	4	0	\N
276912	1874	205234000	13264	6833	5	0	\N
276913	1874	205236000	13264	6833	6	0	\N
276914	1874	205239000	13264	6833	7	0	\N
276915	1678	14400545381000	13265	6833	0	0	\N
276916	1678	14400545382000	13265	6833	1	0	\N
276917	1874	205230000	13265	6833	2	0	\N
276918	1874	205232000	13265	6833	3	0	\N
276919	1874	205234000	13265	6833	4	0	\N
276920	1874	205236000	13265	6833	5	0	\N
276921	1874	205239000	13265	6833	6	0	\N
276925	1678	14400545385000	13268	6835	0	0	\N
276926	1874	205243000	13268	6835	1	0	\N
276927	1874	205246000	13268	6835	2	0	\N
276928	1678	14400545385000	13269	6835	0	0	\N
276929	1874	205243000	13269	6835	1	0	\N
276930	1874	205246000	13269	6835	2	0	\N
276934	1678	14400545385000	13271	6835	0	0	\N
276935	1874	205243000	13271	6835	1	0	\N
276936	1874	205246000	13271	6835	2	0	\N
276939	1678	14400545386000	13273	6836	0	0	\N
276940	1874	205248000	13273	6836	1	0	\N
276941	1678	14400545386000	13274	6836	0	0	\N
276942	1874	205248000	13274	6836	1	0	\N
276943	1678	14400545386000	13275	6836	0	0	\N
276944	1874	205248000	13275	6836	1	0	\N
276960	1678	14400545392000	13280	6841	0	0	\N
276961	1678	14400545392000	13282	6841	0	0	\N
276962	1874	205276000	13282	6841	1	0	\N
276963	1874	205278000	13282	6841	2	0	\N
276976	1678	14400545395000	13286	6843	0	0	\N
276977	1874	205291000	13286	6843	1	0	\N
276978	1874	205293000	13286	6843	2	0	\N
276985	1678	14400545397000	13289	6845	0	0	\N
276986	1874	205301000	13289	6845	1	0	\N
276987	1874	205303000	13289	6845	2	0	\N
276991	1678	14400545399000	13291	6847	0	0	\N
276992	1678	14400545400000	13291	6847	1	0	\N
276993	1874	205311000	13291	6847	2	0	\N
276994	1874	205313000	13291	6847	3	0	\N
276995	1874	205316000	13291	6847	4	0	\N
276996	1874	205318000	13291	6847	5	0	\N
277003	1678	14400545399000	13293	6847	0	0	\N
277004	1678	14400545400000	13293	6847	1	0	\N
277005	1874	205311000	13293	6847	2	0	\N
277006	1874	205313000	13293	6847	3	0	\N
277007	1874	205316000	13293	6847	4	0	\N
277008	1874	205318000	13293	6847	5	0	\N
277028	1678	14400545407000	13298	6852	0	0	\N
277029	1874	205345000	13298	6852	1	0	\N
277030	1874	205347000	13298	6852	2	0	\N
276902	1874	205230000	13263	6833	2	0	0
276903	1874	205232000	13263	6833	3	0	0
276904	1874	205234000	13263	6833	4	0	0
276905	1874	205236000	13263	6833	5	0	0
276906	1874	205239000	13263	6833	6	0	0
276923	1678	14400545384000	13267	6834	1	0	0
276924	1874	205241000	13267	6834	2	0	0
276931	1678	14400545385000	13270	6835	0	0	0
276932	1874	205243000	13270	6835	1	0	0
276933	1874	205246000	13270	6835	2	0	0
276938	1874	205248000	13272	6836	1	0	0
276945	1678	14400545387000	13276	6837	0	0	0
276946	1874	205251000	13276	6837	1	0	0
276947	1874	205253000	13276	6837	2	0	0
276949	1874	205256000	13277	6838	1	0	0
276950	1874	205258000	13277	6838	2	0	0
276951	1678	14400545389000	13279	6840	0	0	0
276952	1678	14400545390000	13279	6840	1	0	0
276953	1678	14400545391000	13279	6840	2	0	0
276955	1874	205263000	13279	6840	4	0	0
276956	1874	205266000	13279	6840	5	0	0
276957	1874	205268000	13279	6840	6	0	0
276958	1874	205271000	13279	6840	7	0	0
276959	1874	205273000	13279	6840	8	0	0
276965	1874	205276000	13283	6841	1	0	0
276966	1874	205278000	13283	6841	2	0	0
276967	1678	14400545393000	13284	6842	0	0	0
276968	1678	14400545394000	13284	6842	1	0	0
276970	1874	205283000	13284	6842	3	0	0
276971	1874	205286000	13284	6842	4	0	0
276972	1874	205288000	13284	6842	5	0	0
276973	1678	14400545395000	13285	6843	0	0	0
276974	1874	205291000	13285	6843	1	0	0
276979	1678	14400545396000	13287	6844	0	0	0
276980	1874	205296000	13287	6844	1	0	0
276981	1874	205298000	13287	6844	2	0	0
276982	1678	14400545397000	13288	6845	0	0	0
276983	1874	205301000	13288	6845	1	0	0
276988	1678	14400545398000	13290	6846	0	0	0
276989	1874	205306000	13290	6846	1	0	0
276990	1874	205308000	13290	6846	2	0	0
276997	1678	14400545399000	13292	6847	0	0	0
276999	1874	205311000	13292	6847	2	0	0
277000	1874	205313000	13292	6847	3	0	0
277001	1874	205316000	13292	6847	4	0	0
277002	1874	205318000	13292	6847	5	0	0
277009	1678	14400545401000	13294	6848	0	0	0
277011	961	504913275000000	13294	6848	2	0	0
277012	1874	205320000	13294	6848	3	0	0
277013	1874	205322000	13294	6848	4	0	0
277014	1874	205325000	13294	6848	5	0	0
277015	1678	14400545403000	13295	6849	0	0	0
277017	1874	205330000	13295	6849	2	0	0
277018	1678	14400545404000	13296	6850	0	0	0
277019	2085	1000000000	13296	6850	1	0	0
277020	1874	205332000	13296	6850	2	0	0
277022	2088	12300000	13297	6851	0	0	0
277023	1678	14400545405000	13297	6851	1	0	0
277024	1678	14400545406000	13297	6851	2	0	0
277025	1874	205337000	13297	6851	3	0	0
277026	1874	205340000	13297	6851	4	0	0
277031	1678	14400545407000	13299	6852	0	0	0
277032	1874	205345000	13299	6852	1	0	0
277037	2088	12300000	13301	6830	0	0	\N
277038	1678	14400545379000	13301	6830	1	0	\N
277039	1678	14400545380000	13301	6830	2	0	\N
277040	1678	14400545381000	13301	6830	3	0	\N
277041	1678	14400545382000	13301	6830	4	0	\N
277042	1678	14400545383000	13301	6830	5	0	\N
277043	1678	14400545384000	13301	6830	6	0	\N
277044	1678	14400545385000	13301	6830	8	0	\N
277045	1678	14400545386000	13301	6830	9	0	\N
277046	1678	14400545387000	13301	6830	10	0	\N
277047	1678	14400545388000	13301	6830	11	0	\N
277048	1678	14400545389000	13301	6830	12	0	\N
277049	1678	14400545390000	13301	6830	13	0	\N
277050	1678	14400545391000	13301	6830	14	0	\N
277051	1678	14400545392000	13301	6830	15	0	\N
277052	2085	0	13301	6830	16	0	\N
277053	2085	1000000000	13301	6830	17	0	\N
277054	1678	14400545393000	13301	6830	18	0	\N
277055	1678	14400545394000	13301	6830	19	0	\N
277056	1678	14400545395000	13301	6830	20	0	\N
277057	1678	14400545396000	13301	6830	21	0	\N
277058	1678	14400545397000	13301	6830	22	0	\N
277059	1678	14400545398000	13301	6830	23	0	\N
277060	1678	14400545399000	13301	6830	24	0	\N
277061	1678	14400545400000	13301	6830	25	0	\N
277062	1678	14400545401000	13301	6830	26	0	\N
277063	1678	14400545402000	13301	6830	27	0	\N
277064	1678	14400545403000	13301	6830	28	0	\N
277065	1678	14400545404000	13301	6830	29	0	\N
277066	1678	14400545405000	13301	6830	30	0	\N
277067	1678	14400545406000	13301	6830	31	0	\N
277068	1678	14400545407000	13301	6830	32	0	\N
277069	1678	14400545408000	13301	6830	33	0	\N
277070	1678	14400545409000	13301	6830	34	0	\N
277071	1678	14400545410000	13301	6830	35	0	\N
277072	961	504913275000000	13301	6830	36	0	\N
277073	1874	205222000	13301	6830	37	0	\N
277074	1874	205225000	13301	6830	38	0	\N
277075	1874	205227000	13301	6830	39	0	\N
277076	1874	205230000	13301	6830	40	0	\N
277077	1874	205232000	13301	6830	41	0	\N
277078	1874	205234000	13301	6830	42	0	\N
277079	1874	205236000	13301	6830	43	0	\N
277080	1874	205239000	13301	6830	44	0	\N
277081	1874	205241000	13301	6830	45	0	\N
277082	1874	205243000	13301	6830	46	0	\N
277083	1874	205246000	13301	6830	47	0	\N
277084	1874	205248000	13301	6830	48	0	\N
277085	1874	205251000	13301	6830	49	0	\N
277086	1874	205253000	13301	6830	50	0	\N
277087	1874	205256000	13301	6830	51	0	\N
277088	1874	205258000	13301	6830	52	0	\N
277089	1874	205261000	13301	6830	53	0	\N
277090	1874	205263000	13301	6830	54	0	\N
277091	1874	205266000	13301	6830	55	0	\N
277092	1874	205268000	13301	6830	56	0	\N
277093	1874	205271000	13301	6830	57	0	\N
277094	1874	205273000	13301	6830	58	0	\N
277095	1874	205276000	13301	6830	59	0	\N
277096	1874	205278000	13301	6830	60	0	\N
277097	1874	205281000	13301	6830	61	0	\N
277098	1874	205283000	13301	6830	62	0	\N
277099	1874	205286000	13301	6830	63	0	\N
277100	1874	205288000	13301	6830	64	0	\N
277101	1874	205291000	13301	6830	65	0	\N
277102	1874	205293000	13301	6830	66	0	\N
277103	1874	205296000	13301	6830	67	0	\N
277104	1874	205298000	13301	6830	68	0	\N
277105	1874	205301000	13301	6830	69	0	\N
277106	1874	205303000	13301	6830	70	0	\N
277107	1874	205306000	13301	6830	71	0	\N
277108	1874	205308000	13301	6830	72	0	\N
277109	1874	205311000	13301	6830	73	0	\N
277110	1874	205313000	13301	6830	74	0	\N
277111	1874	205316000	13301	6830	75	0	\N
277112	1874	205318000	13301	6830	76	0	\N
277113	1874	205320000	13301	6830	77	0	\N
277114	1874	205322000	13301	6830	78	0	\N
277115	1874	205325000	13301	6830	79	0	\N
277116	1874	205327000	13301	6830	80	0	\N
277117	1874	205330000	13301	6830	81	0	\N
277118	1874	205332000	13301	6830	82	0	\N
277119	1874	205335000	13301	6830	83	0	\N
277120	1874	205337000	13301	6830	84	0	\N
277121	1874	205340000	13301	6830	85	0	\N
277122	1874	205342000	13301	6830	86	0	\N
277123	1874	205345000	13301	6830	87	0	\N
277124	1874	205347000	13301	6830	88	0	\N
277125	1874	205350000	13301	6830	89	0	\N
277126	1874	205352000	13301	6830	90	0	\N
277127	1874	205355000	13301	6830	91	0	\N
277128	1874	205357000	13301	6830	92	0	\N
277129	1874	205360000	13301	6830	93	0	\N
277130	1874	205362000	13301	6830	94	0	\N
277131	1678	14400545409000	13303	6855	0	0	\N
277132	1678	14400545410000	13303	6855	1	0	\N
277133	1678	14400545411000	13303	6855	2	0	\N
277134	1874	205355000	13303	6855	3	0	\N
277135	1874	205357000	13303	6855	4	0	\N
277136	1874	205360000	13303	6855	5	0	\N
277137	1874	205362000	13303	6855	6	0	\N
277138	1874	205365000	13303	6855	7	0	\N
277139	1874	205367000	13303	6855	8	0	\N
277149	1678	14400545411000	13305	6831	0	0	\N
277150	1678	14400545412000	13305	6831	1	0	\N
277151	1874	205365000	13305	6831	2	0	\N
277152	1874	205367000	13305	6831	3	0	\N
277153	1874	205370000	13305	6831	4	0	\N
277154	1874	205372000	13305	6831	5	0	\N
277158	1678	14400545413000	13307	6857	0	0	\N
277159	1874	205375000	13307	6857	1	0	\N
277160	1874	205377000	13307	6857	2	0	\N
277167	1678	14400545414000	13310	6858	0	0	\N
277168	1874	205380000	13310	6858	1	0	\N
277035	1874	205350000	13300	6853	1	0	0
277036	1874	205352000	13300	6853	2	0	0
277140	1678	14400545409000	13304	6855	0	0	0
277141	1678	14400545410000	13304	6855	1	0	0
277142	1678	14400545411000	13304	6855	2	0	0
277144	1874	205357000	13304	6855	4	0	0
277145	1874	205360000	13304	6855	5	0	0
277146	1874	205362000	13304	6855	6	0	0
277147	1874	205365000	13304	6855	7	0	0
277148	1874	205367000	13304	6855	8	0	0
277156	1874	205370000	13306	6856	1	0	0
277157	1874	205372000	13306	6856	2	0	0
277161	1678	14400545413000	13308	6857	0	0	0
277162	1874	205375000	13308	6857	1	0	0
277164	1678	14400545414000	13309	6858	0	0	0
277165	1874	205380000	13309	6858	1	0	0
277166	1874	205382000	13309	6858	2	0	0
277169	1678	14400545415000	13311	6859	0	0	\N
277170	1874	205385000	13311	6859	1	0	\N
277171	1874	205387000	13311	6859	2	0	\N
277172	1678	14400545415000	13312	6859	0	0	\N
277173	1874	205385000	13312	6859	1	0	\N
277174	1874	205387000	13312	6859	2	0	\N
277175	1678	14400545415000	13313	6859	0	0	\N
277176	1874	205385000	13313	6859	1	0	\N
277177	1874	205387000	13313	6859	2	0	\N
277178	1678	14400545415000	13314	6859	0	0	\N
277179	1874	205385000	13314	6859	1	0	\N
277180	1874	205387000	13314	6859	2	0	\N
277181	1678	14400545415000	13315	6859	0	0	\N
277182	1874	205385000	13315	6859	1	0	\N
277183	1874	205387000	13315	6859	2	0	\N
277201	1678	14400545409000	13322	6855	0	0	\N
277202	1678	14400545410000	13322	6855	1	0	\N
277203	1678	14400545411000	13322	6855	2	0	\N
277204	1678	14400545412000	13322	6855	3	0	\N
277205	1678	14400545413000	13322	6855	4	0	\N
277206	1678	14400545414000	13322	6855	5	0	\N
277207	1678	14400545415000	13322	6855	6	0	\N
277208	1678	14400545416000	13322	6855	7	0	\N
277209	1678	14400545417000	13322	6855	8	0	\N
277210	1678	14400545418000	13322	6855	9	0	\N
277211	1678	14400545419000	13322	6855	10	0	\N
277212	1678	14400545420000	13322	6855	11	0	\N
277213	1678	14400545421000	13322	6855	12	0	\N
277214	1678	14400545422000	13322	6855	13	0	\N
277215	1678	14400545423000	13322	6855	14	0	\N
277216	1874	205355000	13322	6855	15	0	\N
277217	1874	205357000	13322	6855	16	0	\N
277218	1874	205360000	13322	6855	17	0	\N
277219	1874	205362000	13322	6855	18	0	\N
277220	1874	205365000	13322	6855	19	0	\N
277221	1874	205367000	13322	6855	20	0	\N
277222	1874	205370000	13322	6855	21	0	\N
277223	1874	205372000	13322	6855	22	0	\N
277224	1874	205375000	13322	6855	23	0	\N
277225	1874	205377000	13322	6855	24	0	\N
277226	1874	205380000	13322	6855	25	0	\N
277227	1874	205382000	13322	6855	26	0	\N
277228	1874	205385000	13322	6855	27	0	\N
277229	1874	205387000	13322	6855	28	0	\N
277230	1874	205390000	13322	6855	29	0	\N
277231	1874	205392000	13322	6855	30	0	\N
277232	1874	205395000	13322	6855	31	0	\N
277233	1874	205397000	13322	6855	32	0	\N
277234	1874	205400000	13322	6855	33	0	\N
277235	1874	205402000	13322	6855	34	0	\N
277236	1874	205405000	13322	6855	35	0	\N
277237	1874	205407000	13322	6855	36	0	\N
277238	1874	205410000	13322	6855	37	0	\N
277239	1874	205412000	13322	6855	38	0	\N
277240	1874	205415000	13322	6855	39	0	\N
277241	1874	205417000	13322	6855	40	0	\N
277242	1874	205420000	13322	6855	41	0	\N
277243	1874	205422000	13322	6855	42	0	\N
277244	1874	205425000	13322	6855	43	0	\N
277265	2088	12300000	13327	6790	0	0	\N
277266	2085	0	13327	6790	2	0	\N
277267	2085	1000000000	13327	6790	3	0	\N
277268	1678	14400545326000	13327	6790	4	0	\N
277269	1678	14400545327000	13327	6790	5	0	\N
277270	1678	14400545328000	13327	6790	6	0	\N
277271	1678	14400545329000	13327	6790	7	0	\N
277272	1678	14400545330000	13327	6790	8	0	\N
277273	1678	14400545331000	13327	6790	9	0	\N
277274	1678	14400545332000	13327	6790	10	0	\N
277275	1678	14400545333000	13327	6790	11	0	\N
277276	1678	14400545334000	13327	6790	12	0	\N
277277	1678	14400545335000	13327	6790	13	0	\N
277278	1678	14400545336000	13327	6790	14	0	\N
277279	1678	14400545337000	13327	6790	15	0	\N
277280	1678	14400545338000	13327	6790	16	0	\N
277281	1678	14400545339000	13327	6790	17	0	\N
277282	1678	14400545340000	13327	6790	18	0	\N
277283	1678	14400545341000	13327	6790	19	0	\N
277284	1678	14400545342000	13327	6790	20	0	\N
277285	1678	14400545343000	13327	6790	21	0	\N
277286	1678	14400545344000	13327	6790	22	0	\N
277287	1678	14400545345000	13327	6790	23	0	\N
277288	1678	14400545346000	13327	6790	24	0	\N
277289	1678	14400545347000	13327	6790	25	0	\N
277290	1678	14400545348000	13327	6790	26	0	\N
277291	1678	14400545349000	13327	6790	27	0	\N
277292	1678	14400545350000	13327	6790	28	0	\N
277293	1678	14400545351000	13327	6790	29	0	\N
277294	1678	14400545352000	13327	6790	30	0	\N
277295	1678	14400545353000	13327	6790	31	0	\N
277296	1678	14400545354000	13327	6790	32	0	\N
277297	1678	14400545355000	13327	6790	33	0	\N
277298	1678	14400545356000	13327	6790	34	0	\N
277299	1678	14400545357000	13327	6790	35	0	\N
277300	1678	14400545358000	13327	6790	36	0	\N
277301	1678	14400545359000	13327	6790	37	0	\N
277302	1678	14400545360000	13327	6790	38	0	\N
277303	1678	14400545361000	13327	6790	39	0	\N
277304	1678	14400545362000	13327	6790	40	0	\N
277186	1874	205387000	13316	6859	2	0	0
277187	1678	14400545416000	13317	6860	0	0	0
277188	1874	205390000	13317	6860	1	0	0
277189	1874	205392000	13317	6860	2	0	0
277190	1678	14400545417000	13318	6861	0	0	0
277192	1678	14400545418000	13319	6862	0	0	0
277193	1874	205397000	13319	6862	1	0	0
277194	1874	205400000	13319	6862	2	0	0
277195	1678	14400545419000	13320	6863	0	0	0
277196	1874	205402000	13320	6863	1	0	0
277198	1678	14400545420000	13321	6864	0	0	0
277199	1874	205407000	13321	6864	1	0	0
277200	1874	205410000	13321	6864	2	0	0
277245	1678	14400545421000	13323	6865	0	0	0
277247	1678	14400545423000	13323	6865	2	0	0
277248	1874	205412000	13323	6865	3	0	0
277249	1874	205415000	13323	6865	4	0	0
277250	1874	205417000	13323	6865	5	0	0
277251	1874	205420000	13323	6865	6	0	0
277253	1874	205425000	13323	6865	8	0	0
277254	1678	14400545424000	13324	6866	0	0	0
277255	1874	205427000	13324	6866	1	0	0
277256	1874	205430000	13324	6866	2	0	0
277257	1678	14400545425000	13325	6867	0	0	0
277259	1678	14400545427000	13326	6868	1	0	0
277260	1874	205432000	13326	6868	2	0	0
277261	1874	205435000	13326	6868	3	0	0
277262	1874	205437000	13326	6868	4	0	0
277264	1874	205442000	13326	6868	6	0	0
277305	1678	14400545363000	13327	6790	41	0	\N
277306	1678	14400545364000	13327	6790	42	0	\N
277307	1678	14400545365000	13327	6790	43	0	\N
277308	1678	14400545366000	13327	6790	44	0	\N
277309	1678	14400545367000	13327	6790	45	0	\N
277310	1678	14400545368000	13327	6790	46	0	\N
277311	1678	14400545369000	13327	6790	47	0	\N
277312	1678	14400545370000	13327	6790	48	0	\N
277313	1678	14400545371000	13327	6790	49	0	\N
277314	1678	14400545372000	13327	6790	50	0	\N
277315	1678	14400545373000	13327	6790	51	0	\N
277316	1678	14400545374000	13327	6790	52	0	\N
277317	1678	14400545375000	13327	6790	53	0	\N
277318	1678	14400545376000	13327	6790	54	0	\N
277319	1678	14400545377000	13327	6790	55	0	\N
277320	1678	14400545378000	13327	6790	56	0	\N
277321	1678	14400545379000	13327	6790	57	0	\N
277322	1678	14400545380000	13327	6790	58	0	\N
277323	1678	14400545381000	13327	6790	59	0	\N
277324	1678	14400545382000	13327	6790	60	0	\N
277325	1678	14400545383000	13327	6790	61	0	\N
277326	1678	14400545384000	13327	6790	62	0	\N
277327	1678	14400545385000	13327	6790	63	0	\N
277328	1678	14400545386000	13327	6790	64	0	\N
277329	1678	14400545387000	13327	6790	65	0	\N
277330	1678	14400545388000	13327	6790	66	0	\N
277331	1678	14400545389000	13327	6790	67	0	\N
277332	1678	14400545390000	13327	6790	68	0	\N
277333	1678	14400545391000	13327	6790	69	0	\N
277334	1678	14400545392000	13327	6790	70	0	\N
277335	1678	14400545393000	13327	6790	71	0	\N
277336	1678	14400545394000	13327	6790	72	0	\N
277337	1678	14400545395000	13327	6790	73	0	\N
277338	1678	14400545396000	13327	6790	74	0	\N
277339	1678	14400545397000	13327	6790	75	0	\N
277340	1678	14400545398000	13327	6790	76	0	\N
277341	1678	14400545399000	13327	6790	77	0	\N
277342	1678	14400545400000	13327	6790	78	0	\N
277343	1678	14400545401000	13327	6790	79	0	\N
277344	1678	14400545402000	13327	6790	80	0	\N
277345	1678	14400545403000	13327	6790	81	0	\N
277346	1678	14400545404000	13327	6790	82	0	\N
277347	1678	14400545405000	13327	6790	83	0	\N
277348	1678	14400545406000	13327	6790	84	0	\N
277349	1678	14400545407000	13327	6790	85	0	\N
277350	1678	14400545408000	13327	6790	86	0	\N
277351	1678	14400545409000	13327	6790	87	0	\N
277352	1678	14400545410000	13327	6790	88	0	\N
277353	1678	14400545411000	13327	6790	89	0	\N
277354	1678	14400545412000	13327	6790	90	0	\N
277355	1678	14400545413000	13327	6790	91	0	\N
277356	1678	14400545414000	13327	6790	92	0	\N
277357	1678	14400545415000	13327	6790	93	0	\N
277358	1678	14400545416000	13327	6790	94	0	\N
277359	1678	14400545417000	13327	6790	95	0	\N
277360	1678	14400545418000	13327	6790	96	0	\N
277361	1678	14400545419000	13327	6790	97	0	\N
277362	1678	14400545420000	13327	6790	98	0	\N
277363	1678	14400545421000	13327	6790	99	0	\N
277364	1678	14400545422000	13327	6790	100	0	\N
277365	1678	14400545423000	13327	6790	101	0	\N
277366	1678	14400545424000	13327	6790	102	0	\N
277367	1678	14400545425000	13327	6790	103	0	\N
277368	1678	14400545426000	13327	6790	104	0	\N
277369	1678	14400545427000	13327	6790	105	0	\N
277370	961	504913275000000	13327	6790	106	0	\N
277371	1874	204967000	13327	6790	107	0	\N
277372	1874	204970000	13327	6790	108	0	\N
277373	1874	204972000	13327	6790	109	0	\N
277374	1678	14400545428000	13328	6869	0	0	\N
277375	1874	205445000	13328	6869	1	0	\N
277376	1874	205447000	13328	6869	2	0	\N
277392	1678	14400545431000	13333	6872	0	0	\N
277393	1678	14400545432000	13333	6872	1	0	\N
277394	1874	205457000	13333	6872	2	0	\N
277395	1874	205460000	13333	6872	3	0	\N
277396	1745	1803000000	13333	6872	4	0	\N
277397	1874	205461000	13333	6872	5	0	\N
277398	2091	200000000	13333	6872	6	0	\N
277399	1874	205463000	13333	6872	7	0	\N
277400	1874	205466000	13333	6872	8	0	\N
277401	1874	205467000	13333	6872	9	0	\N
277402	1678	14400545431000	13334	6872	0	0	\N
277403	1678	14400545432000	13334	6872	1	0	\N
277404	1874	205457000	13334	6872	2	0	\N
277405	1874	205460000	13334	6872	3	0	\N
277406	1745	1803000000	13334	6872	4	0	\N
277407	1874	205461000	13334	6872	5	0	\N
277408	2091	200000000	13334	6872	6	0	\N
277409	1874	205463000	13334	6872	7	0	\N
277410	1874	205466000	13334	6872	8	0	\N
277411	1874	205467000	13334	6872	9	0	\N
277412	1678	14400545431000	13335	6872	0	0	\N
277413	1678	14400545432000	13335	6872	1	0	\N
277414	1874	205457000	13335	6872	2	0	\N
277415	1874	205460000	13335	6872	3	0	\N
277416	1745	1803000000	13335	6872	4	0	\N
277417	1874	205461000	13335	6872	5	0	\N
277418	2091	200000000	13335	6872	6	0	\N
277419	1874	205463000	13335	6872	7	0	\N
277420	1874	205466000	13335	6872	8	0	\N
277421	1874	205467000	13335	6872	9	0	\N
277422	1678	14400545431000	13336	6872	0	0	\N
277423	1678	14400545432000	13336	6872	1	0	\N
277424	1874	205457000	13336	6872	2	0	\N
277425	1874	205460000	13336	6872	3	0	\N
277426	1745	1803000000	13336	6872	4	0	\N
277427	1874	205461000	13336	6872	5	0	\N
277428	2091	200000000	13336	6872	6	0	\N
277429	1874	205463000	13336	6872	7	0	\N
277430	1874	205466000	13336	6872	8	0	\N
277431	1874	205467000	13336	6872	9	0	\N
277379	1874	205447000	13329	6869	2	0	0
277380	1678	14400545429000	13330	6870	0	0	0
277381	1745	1803000000	13330	6870	1	0	5
277382	1874	205450000	13330	6870	2	0	0
277383	1874	205452000	13330	6870	3	0	0
277385	1874	205454000	13331	6871	1	0	0
277386	1874	205455000	13331	6871	2	0	0
277387	2089	200000000	13331	6871	3	0	0
277388	2090	200000000	13331	6871	4	0	0
277389	1678	14400545431000	13332	6872	0	0	0
277391	1745	1803000000	13332	6872	2	0	5
277432	1678	14400545433000	13337	6873	0	0	0
277433	1745	1803000000	13337	6873	1	0	5
277434	1874	205457000	13337	6873	2	0	0
277436	1874	205461000	13337	6873	4	0	0
277437	2091	200000000	13337	6873	5	0	0
277438	1874	205463000	13337	6873	6	0	0
277439	1874	205466000	13337	6873	7	0	0
277440	1874	205467000	13337	6873	8	0	0
277448	1678	14400545434000	13339	6874	0	0	\N
277449	1874	205475000	13339	6874	1	0	\N
277450	1874	205478000	13339	6874	2	0	\N
277451	1874	205479000	13339	6874	3	0	\N
277460	1678	14400545435000	13341	6875	0	0	\N
277461	1678	14400545436000	13341	6875	2	0	\N
277462	1874	205481000	13341	6875	3	0	\N
277463	1874	205484000	13341	6875	4	0	\N
277464	1874	205485000	13341	6875	5	0	\N
277465	1874	205487000	13341	6875	6	0	\N
277466	1874	205490000	13341	6875	7	0	\N
277467	1874	205491000	13341	6875	8	0	\N
277476	1678	14400545438000	13344	6877	0	0	\N
277477	1874	205499000	13344	6877	1	0	\N
277478	1874	205502000	13344	6877	2	0	\N
277479	1874	205503000	13344	6877	3	0	\N
277487	1678	14400545440000	13347	6880	0	0	\N
277488	1874	205517000	13347	6880	1	0	\N
277489	1726	683868483000	13347	6880	2	0	\N
277490	1874	520000	13347	6880	3	0	\N
277491	1874	521000	13347	6880	4	0	\N
277497	1678	14400545441000	13349	6881	0	0	\N
277498	1874	523000	13349	6881	1	0	\N
277499	1874	526000	13349	6881	2	0	\N
277500	1874	527000	13349	6881	3	0	\N
277501	1678	14400545441000	13350	6881	0	0	\N
277502	1874	523000	13350	6881	1	0	\N
277503	1874	526000	13350	6881	2	0	\N
277504	1874	527000	13350	6881	3	0	\N
277513	1678	14400545442000	13353	6882	0	0	\N
277514	1874	529000	13353	6882	1	0	\N
277515	1874	532000	13353	6882	2	0	\N
277516	1678	14400545443000	13354	6883	0	0	\N
277517	1874	535000	13354	6883	1	0	\N
277518	1874	536000	13354	6883	2	0	\N
277522	1678	14400545443000	13356	6883	0	0	\N
277523	1874	535000	13356	6883	1	0	\N
277524	1874	536000	13356	6883	2	0	\N
277525	1678	14400545443000	13357	6883	0	0	\N
277526	1874	533000	13357	6883	1	0	\N
277527	1874	535000	13357	6883	2	0	\N
277528	1874	536000	13357	6883	3	0	\N
277529	1678	14400545443000	13358	6883	0	0	\N
277530	1874	535000	13358	6883	1	0	\N
277531	1678	14400545443000	13359	6883	0	0	\N
277532	1874	533000	13359	6883	1	0	\N
277533	1874	535000	13359	6883	2	0	\N
277538	1678	14400545444000	13361	6884	0	0	\N
277539	1874	538000	13361	6884	1	0	\N
277540	1874	539000	13361	6884	2	0	\N
277541	1745	1803000000	13361	6884	3	0	\N
277542	2088	12300000	13362	6743	0	0	\N
277543	1368	1702661297751650	13362	6743	1	0	\N
277544	1122	905589535000000	13362	6743	2	0	\N
277545	1242	611019160000000	13362	6743	3	0	\N
277546	1014	505330736600000	13362	6743	4	0	\N
277547	1002	505354605000000	13362	6743	5	0	\N
277548	1134	905548877800000	13362	6743	6	0	\N
277549	23	32724630000000	13362	6743	7	0	\N
277550	756	1005950000000	13362	6743	8	0	\N
277551	1254	610992052400000	13362	6743	9	0	\N
277552	1380	1702581800951650	13362	6743	10	0	\N
277553	1346	1701957637751650	13362	6743	11	0	\N
277554	1100	905216465000000	13362	6743	12	0	\N
277555	1220	610767750000000	13362	6743	13	0	\N
277556	980	505145775000000	13362	6743	14	0	\N
277557	2085	0	13362	6743	16	0	\N
277558	2085	1000000000	13362	6743	17	0	\N
277559	1678	14400545254000	13362	6743	18	0	\N
277560	1678	14400545255000	13362	6743	19	0	\N
277561	1678	14400545256000	13362	6743	20	0	\N
277562	1678	14400545257000	13362	6743	21	0	\N
277563	1678	14400545258000	13362	6743	22	0	\N
277564	1678	14400545259000	13362	6743	23	0	\N
277565	1678	14400545260000	13362	6743	24	0	\N
277566	1678	14400545261000	13362	6743	25	0	\N
277567	1678	14400545262000	13362	6743	26	0	\N
277568	1678	14400545263000	13362	6743	27	0	\N
277569	1678	14400545264000	13362	6743	28	0	\N
277570	1678	14400545265000	13362	6743	29	0	\N
277571	1678	14400545266000	13362	6743	30	0	\N
277572	1678	14400545267000	13362	6743	31	0	\N
277573	1678	14400545268000	13362	6743	32	0	\N
277574	1678	14400545269000	13362	6743	33	0	\N
277575	1678	14400545270000	13362	6743	34	0	\N
277576	1678	14400545271000	13362	6743	35	0	\N
277443	1874	205473000	13337	6873	11	0	0
277444	1678	14400545434000	13338	6874	0	0	0
277445	1874	205475000	13338	6874	1	0	0
277446	1874	205478000	13338	6874	2	0	0
277447	1874	205479000	13338	6874	3	0	0
277453	1678	14400545436000	13340	6875	2	0	0
277454	1874	205481000	13340	6875	3	0	0
277455	1874	205484000	13340	6875	4	0	0
277456	1874	205485000	13340	6875	5	0	0
277457	1874	205487000	13340	6875	6	0	0
277459	1874	205491000	13340	6875	8	0	0
277468	1678	14400545437000	13342	6876	0	0	0
277469	1874	205493000	13342	6876	1	0	0
277470	1874	205496000	13342	6876	2	0	0
277472	1678	14400545438000	13343	6877	0	0	0
277473	1874	205499000	13343	6877	1	0	0
277474	1874	205502000	13343	6877	2	0	0
277475	1874	205503000	13343	6877	3	0	0
277480	1874	205505000	13345	6878	0	0	0
277482	1874	205509000	13345	6878	2	0	0
277483	1678	14400545439000	13346	6879	0	0	0
277484	1874	205511000	13346	6879	1	0	0
277485	1874	205514000	13346	6879	2	0	0
277486	1874	205515000	13346	6879	3	0	0
277493	1874	205517000	13348	6880	1	0	0
277494	1726	683868483000	13348	6880	2	0	5250
277495	1874	520000	13348	6880	3	0	1
277496	1874	521000	13348	6880	4	0	1
277506	1678	14400545442000	13352	6882	0	0	0
277507	1874	523000	13352	6882	1	0	1
277508	1874	526000	13352	6882	2	0	1
277509	1874	527000	13352	6882	3	0	1
277510	1874	529000	13352	6882	4	0	1
277512	1874	533000	13352	6882	6	0	1
277519	1678	14400545443000	13355	6883	0	0	0
277520	1874	535000	13355	6883	1	0	1
277521	1874	536000	13355	6883	2	0	1
277534	1678	14400545444000	13360	6884	0	0	0
277536	1874	539000	13360	6884	2	0	1
277537	1745	1803000000	13360	6884	3	0	5
277577	1678	14400545272000	13362	6743	36	0	\N
277578	1678	14400545273000	13362	6743	37	0	\N
277579	1678	14400545274000	13362	6743	38	0	\N
277580	1678	14400545275000	13362	6743	39	0	\N
277581	1678	14400545276000	13362	6743	40	0	\N
277582	1678	14400545277000	13362	6743	41	0	\N
277583	1678	14400545278000	13362	6743	42	0	\N
277584	1678	14400545279000	13362	6743	43	0	\N
277585	1678	14400545280000	13362	6743	44	0	\N
277586	1678	14400545281000	13362	6743	45	0	\N
277587	1678	14400545282000	13362	6743	46	0	\N
277588	1678	14400545283000	13362	6743	47	0	\N
277589	1678	14400545284000	13362	6743	48	0	\N
277590	1678	14400545285000	13362	6743	49	0	\N
277591	1678	14400545286000	13362	6743	50	0	\N
277592	1678	14400545287000	13362	6743	51	0	\N
277593	1678	14400545288000	13362	6743	52	0	\N
277594	1678	14400545289000	13362	6743	53	0	\N
277595	1678	14400545290000	13362	6743	54	0	\N
277596	1678	14400545291000	13362	6743	55	0	\N
277597	1678	14400545292000	13362	6743	56	0	\N
277598	1678	14400545293000	13362	6743	57	0	\N
277599	1678	14400545294000	13362	6743	58	0	\N
277600	1678	14400545295000	13362	6743	59	0	\N
277601	1678	14400545296000	13362	6743	60	0	\N
277602	1678	14400545297000	13362	6743	61	0	\N
277603	1678	14400545298000	13362	6743	62	0	\N
277604	1678	14400545299000	13362	6743	63	0	\N
277605	1678	14400545300000	13362	6743	64	0	\N
277606	1678	14400545301000	13362	6743	65	0	\N
277607	1678	14400545302000	13362	6743	66	0	\N
277608	1678	14400545303000	13362	6743	67	0	\N
277609	1678	14400545304000	13362	6743	68	0	\N
277610	1678	14400545305000	13362	6743	69	0	\N
277611	1678	14400545306000	13362	6743	70	0	\N
277612	1678	14400545307000	13362	6743	71	0	\N
277613	1678	14400545308000	13362	6743	72	0	\N
277614	1678	14400545309000	13362	6743	73	0	\N
277615	1678	14400545310000	13362	6743	74	0	\N
277616	1678	14400545311000	13362	6743	75	0	\N
277617	1678	14400545312000	13362	6743	76	0	\N
277618	1678	14400545313000	13362	6743	77	0	\N
277619	1678	14400545314000	13362	6743	78	0	\N
277620	1678	14400545315000	13362	6743	79	0	\N
277621	1678	14400545316000	13362	6743	80	0	\N
277622	1678	14400545317000	13362	6743	81	0	\N
277623	1678	14400545318000	13362	6743	82	0	\N
277624	1678	14400545319000	13362	6743	83	0	\N
277625	1678	14400545320000	13362	6743	84	0	\N
277626	1678	14400545321000	13362	6743	85	0	\N
277627	1678	14400545322000	13362	6743	86	0	\N
277628	1678	14400545323000	13362	6743	87	0	\N
277629	1678	14400545324000	13362	6743	88	0	\N
277630	1678	14400545325000	13362	6743	89	0	\N
277631	1678	14400545326000	13362	6743	90	0	\N
277632	1678	14400545327000	13362	6743	92	0	\N
277633	1678	14400545328000	13362	6743	93	0	\N
277634	1678	14400545329000	13362	6743	94	0	\N
277635	1678	14400545330000	13362	6743	95	0	\N
277636	1678	14400545331000	13362	6743	96	0	\N
277637	1678	14400545332000	13362	6743	97	0	\N
277638	1678	14400545333000	13362	6743	98	0	\N
277639	1678	14400545334000	13362	6743	99	0	\N
277640	1678	14400545335000	13362	6743	100	0	\N
277641	1678	14400545336000	13362	6743	101	0	\N
277642	1678	14400545337000	13362	6743	102	0	\N
277643	1678	14400545338000	13362	6743	103	0	\N
277644	1678	14400545339000	13362	6743	104	0	\N
277645	1678	14400545340000	13362	6743	105	0	\N
277646	1678	14400545341000	13362	6743	106	0	\N
277647	1678	14400545342000	13362	6743	107	0	\N
277648	1678	14400545343000	13362	6743	108	0	\N
277649	1678	14400545344000	13362	6743	109	0	\N
277650	1678	14400545345000	13362	6743	110	0	\N
277651	1678	14400545346000	13362	6743	111	0	\N
277652	1678	14400545347000	13362	6743	112	0	\N
277653	1678	14400545348000	13362	6743	113	0	\N
277654	1678	14400545349000	13362	6743	114	0	\N
277655	1678	14400545350000	13362	6743	115	0	\N
277656	1678	14400545351000	13362	6743	116	0	\N
277657	1678	14400545352000	13362	6743	117	0	\N
277658	1678	14400545353000	13362	6743	118	0	\N
277659	1678	14400545354000	13362	6743	119	0	\N
277660	1678	14400545355000	13362	6743	120	0	\N
277661	1678	14400545356000	13362	6743	121	0	\N
277662	1678	14400545357000	13362	6743	122	0	\N
277663	1678	14400545358000	13362	6743	123	0	\N
277664	1678	14400545359000	13362	6743	124	0	\N
277665	1678	14400545360000	13362	6743	125	0	\N
277676	2088	12300000	13366	6781	0	0	\N
277677	1346	1701957637751650	13366	6781	1	0	\N
277678	1100	905216465000000	13366	6781	2	0	\N
277679	1220	610767750000000	13366	6781	3	0	\N
277680	980	505145775000000	13366	6781	4	0	\N
277681	2085	0	13366	6781	6	0	\N
277682	2085	1000000000	13366	6781	7	0	\N
277683	1745	1803000000	13366	6781	8	0	\N
277684	961	504913275000000	13366	6781	9	0	\N
277685	1745	1803000000	13366	6781	10	0	\N
277686	1745	1803000000	13366	6781	11	0	\N
277687	1745	1803000000	13366	6781	12	0	\N
277688	1678	14400545448000	13367	6888	0	0	\N
277689	1678	14400545449000	13367	6888	1	0	\N
277690	1874	554000	13367	6888	2	0	\N
277691	1874	556000	13367	6888	3	0	\N
277692	1874	557000	13367	6888	4	0	\N
277693	1874	560000	13367	6888	5	0	\N
277694	1874	562000	13367	6888	6	0	\N
277710	1678	14400545428000	13370	6791	0	0	\N
277711	1678	14400545429000	13370	6791	1	0	\N
277712	1678	14400545430000	13370	6791	2	0	\N
277668	1874	541000	13364	6886	1	0	1
277669	1874	544000	13364	6886	2	0	1
277670	1874	545000	13364	6886	3	0	1
277671	1874	547000	13364	6886	4	0	1
277672	1874	550000	13364	6886	5	0	1
277674	1874	551000	13365	6887	1	0	1
277675	1874	553000	13365	6887	2	0	1
277695	1678	14400545448000	13368	6888	0	0	0
277696	1678	14400545449000	13368	6888	1	0	0
277697	1874	554000	13368	6888	2	0	1
277699	1874	557000	13368	6888	4	0	1
277700	1874	560000	13368	6888	5	0	1
277701	1874	562000	13368	6888	6	0	1
277702	1678	14400545450000	13369	6889	0	0	0
277704	1874	563000	13369	6889	2	0	1
277705	1874	566000	13369	6889	3	0	1
277706	1874	568000	13369	6889	4	0	1
277707	1874	569000	13369	6889	5	0	1
277708	1874	572000	13369	6889	6	0	1
277713	1678	14400545431000	13370	6791	4	0	\N
277714	1678	14400545432000	13370	6791	5	0	\N
277715	1678	14400545433000	13370	6791	6	0	\N
277716	1678	14400545434000	13370	6791	7	0	\N
277728	1678	14400545452000	13372	6890	0	0	\N
277729	1678	14400545453000	13372	6890	1	0	\N
277730	1678	14400545454000	13372	6890	2	0	\N
277735	1678	14400545455000	13374	6891	0	0	\N
277736	1874	590000	13374	6891	1	0	\N
277737	1874	593000	13374	6891	2	0	\N
277738	1874	595000	13374	6891	3	0	\N
277739	1678	14400545455000	13375	6891	0	0	\N
277740	1874	590000	13375	6891	1	0	\N
277741	1874	593000	13375	6891	2	0	\N
277742	1874	595000	13375	6891	3	0	\N
277756	1678	14400545459000	13379	6895	0	0	\N
277757	1874	614000	13379	6895	1	0	\N
277758	1874	617000	13379	6895	2	0	\N
277759	1874	619000	13379	6895	3	0	\N
277776	1678	14400545463000	13382	6897	0	0	\N
277777	1678	14400545464000	13382	6897	1	0	\N
277778	1874	635000	13382	6897	2	0	\N
277779	1874	638000	13382	6897	3	0	\N
277780	1874	640000	13382	6897	4	0	\N
277781	1874	641000	13382	6897	5	0	\N
277782	1874	644000	13382	6897	6	0	\N
277783	1874	646000	13382	6897	7	0	\N
277792	1678	14400545463000	13384	6897	0	0	\N
277793	1678	14400545464000	13384	6897	1	0	\N
277794	1874	635000	13384	6897	2	0	\N
277795	1874	638000	13384	6897	3	0	\N
277796	1874	640000	13384	6897	4	0	\N
277797	1874	641000	13384	6897	5	0	\N
277798	1874	644000	13384	6897	6	0	\N
277799	1874	646000	13384	6897	7	0	\N
277806	1678	14400545466000	13387	6899	0	0	\N
277807	1874	650000	13387	6899	1	0	\N
277808	1874	652000	13387	6899	2	0	\N
277812	1678	14400545468000	13390	6901	0	0	\N
277813	1874	656000	13390	6901	1	0	\N
277814	1874	658000	13390	6901	2	0	\N
277815	1678	14400545468000	13391	6901	0	0	\N
277816	1874	656000	13391	6901	1	0	\N
277817	1874	658000	13391	6901	2	0	\N
277821	1678	14400545469000	13393	6902	0	0	\N
277822	1678	14400545470000	13393	6902	1	0	\N
277823	1874	661000	13393	6902	2	0	\N
277824	1874	662000	13393	6902	3	0	\N
277825	1874	664000	13393	6902	4	0	\N
277826	1874	665000	13393	6902	5	0	\N
277827	1874	667000	13393	6902	6	0	\N
277835	1678	14400545469000	13395	6902	0	0	\N
277836	1678	14400545470000	13395	6902	1	0	\N
277837	1874	661000	13395	6902	2	0	\N
277838	1874	662000	13395	6902	3	0	\N
277839	1874	664000	13395	6902	4	0	\N
277840	1874	665000	13395	6902	5	0	\N
277841	1874	667000	13395	6902	6	0	\N
277719	1678	14400545454000	13371	6890	2	0	0
277720	1874	575000	13371	6890	3	0	1
277721	1874	578000	13371	6890	4	0	1
277722	1874	580000	13371	6890	5	0	1
277723	1874	581000	13371	6890	6	0	1
277725	1874	584000	13371	6890	8	0	1
277726	1874	587000	13371	6890	9	0	1
277727	1874	589000	13371	6890	10	0	1
277731	1678	14400545455000	13373	6891	0	0	0
277732	1874	590000	13373	6891	1	0	1
277734	1874	595000	13373	6891	3	0	1
277743	1678	14400545456000	13376	6892	0	0	0
277744	1874	596000	13376	6892	1	0	1
277745	1874	599000	13376	6892	2	0	1
277747	1678	14400545457000	13377	6893	0	0	0
277748	1874	602000	13377	6893	1	0	1
277749	1874	605000	13377	6893	2	0	1
277750	1874	607000	13377	6893	3	0	1
277751	1678	14400545458000	13378	6894	0	0	0
277753	1874	608000	13378	6894	2	0	1
277754	1874	611000	13378	6894	3	0	1
277755	1874	613000	13378	6894	4	0	1
277760	1678	14400545459000	13380	6895	0	0	0
277761	1678	14400545460000	13381	6896	0	0	0
277763	1678	14400545462000	13381	6896	2	0	0
277764	1874	614000	13381	6896	3	0	1
277765	1874	617000	13381	6896	4	0	1
277766	1874	619000	13381	6896	5	0	1
277768	1874	623000	13381	6896	7	0	1
277769	1874	625000	13381	6896	8	0	1
277770	1874	626000	13381	6896	9	0	1
277771	1874	628000	13381	6896	10	0	1
277772	2092	200000000	13381	6896	11	0	0
277774	1874	632000	13381	6896	13	0	1
277775	1874	634000	13381	6896	14	0	1
277784	1678	14400545463000	13383	6897	0	0	0
277785	1678	14400545464000	13383	6897	1	0	0
277786	1874	635000	13383	6897	2	0	1
277788	1874	640000	13383	6897	4	0	1
277789	1874	641000	13383	6897	5	0	1
277790	1874	644000	13383	6897	6	0	1
277791	1874	646000	13383	6897	7	0	1
277801	1874	647000	13385	6898	1	0	1
277802	1874	649000	13385	6898	2	0	1
277803	1678	14400545466000	13386	6899	0	0	0
277804	1874	650000	13386	6899	1	0	1
277805	1874	652000	13386	6899	2	0	1
277810	1874	653000	13388	6900	1	0	1
277811	1874	655000	13388	6900	2	0	1
277818	1678	14400545468000	13392	6901	0	0	0
277819	1874	656000	13392	6901	1	0	1
277820	1874	658000	13392	6901	2	0	1
277829	1678	14400545470000	13394	6902	1	0	0
277830	1874	661000	13394	6902	2	0	1
277831	1874	662000	13394	6902	3	0	1
277832	1874	664000	13394	6902	4	0	1
277834	1874	667000	13394	6902	6	0	1
277842	1678	14400545471000	13396	6903	0	0	0
277843	1678	14400545472000	13396	6903	1	0	0
277844	1874	668000	13396	6903	2	0	1
277845	1874	671000	13396	6903	3	0	1
277847	1874	674000	13396	6903	5	0	1
277848	1874	676000	13396	6903	6	0	1
277849	1678	14400545471000	13397	6903	0	0	\N
277850	1678	14400545472000	13397	6903	1	0	\N
277851	1874	668000	13397	6903	2	0	\N
277852	1874	671000	13397	6903	3	0	\N
277853	1874	673000	13397	6903	4	0	\N
277854	1874	674000	13397	6903	5	0	\N
277855	1874	676000	13397	6903	6	0	\N
277856	1678	14400545471000	13398	6903	0	0	\N
277857	1678	14400545472000	13398	6903	1	0	\N
277858	1874	668000	13398	6903	2	0	\N
277859	1874	671000	13398	6903	3	0	\N
277860	1874	673000	13398	6903	4	0	\N
277861	1874	674000	13398	6903	5	0	\N
277862	1874	676000	13398	6903	6	0	\N
277863	1874	677000	13398	6903	7	0	\N
277864	1678	14400545473000	13399	6904	0	0	\N
277865	1678	14400545474000	13399	6904	1	0	\N
277866	1874	677000	13399	6904	2	0	\N
277867	1874	679000	13399	6904	3	0	\N
277868	1874	680000	13399	6904	4	0	\N
277869	1874	683000	13399	6904	5	0	\N
277870	1874	685000	13399	6904	6	0	\N
277884	1678	14400545475000	13402	6905	0	0	\N
277885	1678	14400545476000	13402	6905	1	0	\N
277886	1874	686000	13402	6905	2	0	\N
277887	1874	688000	13402	6905	3	0	\N
277888	1874	689000	13402	6905	4	0	\N
277889	1874	691000	13402	6905	5	0	\N
277890	1678	14400545475000	13403	6905	0	0	\N
277891	1678	14400545476000	13403	6905	1	0	\N
277892	1874	686000	13403	6905	2	0	\N
277893	1678	14400545475000	13404	6905	0	0	\N
277894	1678	14400545476000	13404	6905	1	0	\N
277895	1874	686000	13404	6905	2	0	\N
277896	1874	688000	13404	6905	3	0	\N
277897	1874	689000	13404	6905	4	0	\N
277898	1874	691000	13404	6905	5	0	\N
277899	1678	14400545475000	13405	6905	0	0	\N
277900	1678	14400545476000	13405	6905	1	0	\N
277901	1678	14400545477000	13406	6906	0	0	\N
277906	1678	14400545477000	13408	6906	0	0	\N
277907	1874	692000	13408	6906	1	0	\N
277908	1874	695000	13408	6906	2	0	\N
277909	1874	697000	13408	6906	3	0	\N
277928	1678	14400545483000	13413	6910	0	0	\N
277929	1678	14400545484000	13413	6910	1	0	\N
277962	1678	14400545493000	13422	6916	0	0	\N
277963	1678	14400545494000	13422	6916	1	0	\N
277964	1874	745000	13422	6916	2	0	\N
277965	1874	748000	13422	6916	3	0	\N
277966	1874	750000	13422	6916	4	0	\N
277967	1874	751000	13422	6916	5	0	\N
277968	1874	754000	13422	6916	6	0	\N
277969	1874	756000	13422	6916	7	0	\N
277970	1745	1803000000	13422	6916	8	0	\N
277971	1678	14400545493000	13423	6916	0	0	\N
277972	1678	14400545494000	13423	6916	1	0	\N
277973	1874	745000	13423	6916	2	0	\N
277974	1874	748000	13423	6916	3	0	\N
277975	1874	750000	13423	6916	4	0	\N
277976	1874	751000	13423	6916	5	0	\N
277977	1874	754000	13423	6916	6	0	\N
277978	1874	756000	13423	6916	7	0	\N
277979	1745	1803000000	13423	6916	8	0	\N
277873	1874	677000	13400	6904	2	0	1
277874	1874	679000	13400	6904	3	0	1
277875	1874	680000	13400	6904	4	0	1
277876	1874	683000	13400	6904	5	0	1
277877	1874	685000	13400	6904	6	0	1
277879	1678	14400545476000	13401	6905	1	0	0
277880	1874	686000	13401	6905	2	0	1
277881	1874	688000	13401	6905	3	0	1
277882	1874	689000	13401	6905	4	0	1
277883	1874	691000	13401	6905	5	0	1
277903	1874	692000	13407	6906	1	0	1
277904	1874	695000	13407	6906	2	0	1
277905	1874	697000	13407	6906	3	0	1
277910	1678	14400545478000	13409	6907	0	0	0
277912	1874	698000	13409	6907	2	0	1
277913	1874	700000	13409	6907	3	0	1
277914	1874	701000	13409	6907	4	0	1
277915	1874	704000	13409	6907	5	0	1
277916	1874	706000	13409	6907	6	0	1
277918	1678	14400545480000	13411	6908	0	0	0
277919	1874	707000	13411	6908	1	0	1
277920	1874	710000	13411	6908	2	0	1
277921	1874	712000	13411	6908	3	0	1
277922	1678	14400545481000	13412	6909	0	0	0
277924	1874	713000	13412	6909	2	0	1
277925	1874	715000	13412	6909	3	0	1
277926	1874	716000	13412	6909	4	0	1
277927	1874	718000	13412	6909	5	0	1
277931	1678	14400545484000	13414	6910	1	0	0
277932	1874	719000	13414	6910	2	0	1
277933	1874	721000	13414	6910	3	0	1
277934	1874	722000	13414	6910	4	0	1
277935	1678	14400545485000	13415	6911	0	0	0
277937	1678	14400545487000	13416	6912	0	0	0
277938	1678	14400545488000	13416	6912	1	0	0
277939	1874	724000	13416	6912	2	0	1
277940	1874	725000	13416	6912	3	0	1
277941	1874	727000	13416	6912	4	0	1
277943	1874	730000	13416	6912	6	0	1
277944	1874	731000	13416	6912	7	0	1
277945	1874	733000	13416	6912	8	0	1
277946	1874	734000	13416	6912	9	0	1
277948	1874	736000	13418	6913	1	0	1
277949	1874	737000	13418	6913	2	0	1
277950	1678	14400545490000	13419	6914	0	0	0
277951	1874	739000	13419	6914	1	0	1
277952	1874	740000	13419	6914	2	0	1
277954	1678	14400545492000	13420	6915	1	0	0
277955	1745	1803000000	13420	6915	2	0	5
277956	1874	741000	13420	6915	3	0	1
277957	1874	742000	13420	6915	4	0	1
277958	1874	744000	13420	6915	5	0	1
277960	1678	14400545494000	13421	6916	1	0	0
277961	1745	1803000000	13421	6916	2	0	5
277980	1678	14400545495000	13424	6917	0	0	0
277981	1874	745000	13424	6917	1	0	1
277983	1874	750000	13424	6917	3	0	1
277984	1874	751000	13424	6917	4	0	1
277990	1678	14400545496000	13425	6918	0	0	\N
277991	1874	763000	13425	6918	1	0	\N
277992	1874	766000	13425	6918	2	0	\N
277993	1874	768000	13425	6918	3	0	\N
277994	1678	14400545496000	13426	6918	0	0	\N
277999	1678	14400545496000	13428	6918	0	0	\N
278004	1678	14400545497000	13430	6919	0	0	\N
278005	1874	769000	13430	6919	1	0	\N
278006	1874	772000	13430	6919	2	0	\N
278007	1874	774000	13430	6919	3	0	\N
278031	1678	14400545503000	13435	6923	0	0	\N
278032	1874	802000	13435	6923	1	0	\N
278033	1874	805000	13435	6923	2	0	\N
278034	1874	807000	13435	6923	3	0	\N
278035	1678	14400545504000	13436	6924	0	0	\N
278040	1678	14400545504000	13438	6924	0	0	\N
278041	1678	14400545504000	13439	6924	0	0	\N
278042	1874	808000	13439	6924	1	0	\N
278043	1874	811000	13439	6924	2	0	\N
278044	1874	813000	13439	6924	3	0	\N
278061	1678	14400545510000	13443	6927	0	0	\N
278062	1874	835000	13443	6927	1	0	\N
278063	1874	837000	13443	6927	2	0	\N
278064	1874	840000	13443	6927	3	0	\N
278065	1874	841000	13443	6927	4	0	\N
278066	1874	843000	13443	6927	5	0	\N
278077	1678	14400545511000	13446	6928	0	0	\N
278078	1874	835000	13446	6928	1	0	\N
278079	1874	837000	13446	6928	2	0	\N
278080	1874	840000	13446	6928	4	0	\N
278081	1874	841000	13446	6928	5	0	\N
278082	1874	843000	13446	6928	6	0	\N
278083	1874	846000	13446	6928	7	0	\N
278084	1874	847000	13446	6928	8	0	\N
278085	1874	849000	13446	6928	9	0	\N
278086	1678	14400545511000	13447	6928	0	0	\N
278087	1874	835000	13447	6928	1	0	\N
278088	1874	837000	13447	6928	2	0	\N
278089	1874	840000	13447	6928	4	0	\N
278090	1874	841000	13447	6928	5	0	\N
278091	1874	843000	13447	6928	6	0	\N
278092	1874	846000	13447	6928	7	0	\N
278093	1874	847000	13447	6928	8	0	\N
278094	1874	849000	13447	6928	9	0	\N
278095	1874	835000	13448	6928	0	0	\N
278096	1874	837000	13448	6928	1	0	\N
278097	1874	840000	13448	6928	2	0	\N
278098	1874	841000	13448	6928	4	0	\N
278099	1874	843000	13448	6928	5	0	\N
278100	1874	846000	13448	6928	6	0	\N
278101	1874	847000	13448	6928	7	0	\N
278102	1874	849000	13448	6928	8	0	\N
278106	1678	14400545512000	13450	6929	0	0	\N
278107	1874	852000	13451	6929	0	0	\N
278108	1874	853000	13451	6929	1	0	\N
278109	1874	855000	13451	6929	2	0	\N
278115	1678	14400545512000	13453	6930	0	0	\N
278116	1678	14400545513000	13453	6930	1	0	\N
278117	1874	858000	13453	6930	2	0	\N
278118	1874	859000	13453	6930	3	0	\N
278119	1874	861000	13453	6930	4	0	\N
278120	1678	14400545512000	13454	6930	0	0	\N
277987	1874	757000	13424	6917	7	0	1
277988	1874	760000	13424	6917	8	0	1
277989	1874	762000	13424	6917	9	0	1
277995	1678	14400545496000	13427	6918	0	0	0
277996	1874	763000	13427	6918	1	0	1
277998	1874	768000	13427	6918	3	0	1
278000	1678	14400545497000	13429	6919	0	0	0
278001	1874	769000	13429	6919	1	0	1
278002	1874	772000	13429	6919	2	0	1
278003	1874	774000	13429	6919	3	0	1
278009	1874	775000	13431	6920	1	0	1
278010	1874	777000	13431	6920	2	0	1
278011	1678	14400545499000	13432	6921	0	0	0
278012	1678	14400545500000	13432	6921	1	0	0
278014	1874	778000	13432	6921	3	0	1
278015	1874	780000	13432	6921	4	0	1
278016	1874	783000	13432	6921	5	0	1
278017	1874	784000	13432	6921	6	0	1
278018	1874	786000	13432	6921	7	0	1
278020	1874	790000	13432	6921	9	0	1
278021	1874	792000	13432	6921	10	0	1
278022	1874	795000	13432	6921	11	0	1
278023	1678	14400545502000	13433	6922	0	0	0
278024	1874	796000	13433	6922	1	0	1
278026	1874	801000	13433	6922	3	0	1
278027	1678	14400545503000	13434	6923	0	0	0
278028	1874	802000	13434	6923	1	0	1
278029	1874	805000	13434	6923	2	0	1
278036	1678	14400545504000	13437	6924	0	0	0
278037	1874	808000	13437	6924	1	0	1
278038	1874	811000	13437	6924	2	0	1
278039	1874	813000	13437	6924	3	0	1
278045	1678	14400545505000	13441	6925	0	0	0
278047	1678	14400545507000	13441	6925	2	0	0
278048	1678	14400545508000	13441	6925	3	0	0
278049	1874	814000	13441	6925	4	0	1
278050	1874	816000	13441	6925	5	0	1
278051	1874	817000	13441	6925	6	0	1
278053	1874	822000	13441	6925	8	0	1
278054	1874	823000	13441	6925	9	0	1
278055	1874	825000	13441	6925	10	0	1
278056	1874	828000	13441	6925	11	0	1
278058	1874	831000	13441	6925	13	0	1
278059	1874	834000	13441	6925	14	0	1
278060	1678	14400545509000	13442	6926	0	0	0
278067	1678	14400545510000	13444	6927	0	0	0
278068	1678	14400545511000	13445	6928	0	0	0
278070	1874	837000	13445	6928	2	0	1
278071	1874	840000	13445	6928	4	0	1
278072	1874	841000	13445	6928	5	0	1
278073	1874	843000	13445	6928	6	0	1
278074	1874	846000	13445	6928	7	0	1
278076	1874	849000	13445	6928	9	0	1
278103	1874	852000	13449	6929	0	0	1
278104	1874	853000	13449	6929	1	0	1
278105	1874	855000	13449	6929	2	0	1
278111	1678	14400545513000	13452	6930	1	0	0
278112	1874	858000	13452	6930	2	0	1
278113	1874	859000	13452	6930	3	0	1
278114	1874	861000	13452	6930	4	0	1
278121	1874	858000	13454	6930	1	0	\N
278122	1874	859000	13454	6930	2	0	\N
278123	1874	861000	13454	6930	3	0	\N
278135	1678	14400545515000	13458	6933	0	0	\N
278136	1678	14400545516000	13458	6933	1	0	\N
278137	1874	865000	13458	6933	2	0	\N
278144	1678	14400545518000	13463	6935	0	0	\N
278145	1874	877000	13463	6935	1	0	\N
278146	1874	879000	13463	6935	2	0	\N
278150	1678	14400545519000	13465	6936	0	0	\N
278151	1874	880000	13465	6936	1	0	\N
278152	1874	882000	13465	6936	2	0	\N
278153	2088	12300000	13466	6753	0	0	\N
278154	1678	14400545317000	13466	6753	1	0	\N
278155	1678	14400545318000	13466	6753	2	0	\N
278156	1678	14400545319000	13466	6753	3	0	\N
278157	1678	14400545320000	13466	6753	4	0	\N
278158	1678	14400545321000	13466	6753	5	0	\N
278159	23	32724630000000	13466	6753	6	0	\N
278160	756	1005950000000	13466	6753	7	0	\N
278161	1346	1701957637751650	13466	6753	8	0	\N
278162	1100	905216465000000	13466	6753	9	0	\N
278163	1220	610767750000000	13466	6753	10	0	\N
278164	980	505145775000000	13466	6753	11	0	\N
278165	2085	0	13466	6753	13	0	\N
278166	2085	1000000000	13466	6753	14	0	\N
278167	1678	14400545322000	13466	6753	15	0	\N
278168	1678	14400545323000	13466	6753	16	0	\N
278169	1678	14400545324000	13466	6753	17	0	\N
278170	1678	14400545325000	13466	6753	18	0	\N
278171	1678	14400545326000	13466	6753	19	0	\N
278172	1678	14400545327000	13466	6753	20	0	\N
278173	1678	14400545328000	13466	6753	21	0	\N
278174	1678	14400545329000	13466	6753	22	0	\N
278175	1678	14400545330000	13466	6753	23	0	\N
278176	1678	14400545331000	13466	6753	24	0	\N
278177	1678	14400545332000	13466	6753	25	0	\N
278178	1678	14400545333000	13466	6753	26	0	\N
278179	1678	14400545334000	13466	6753	27	0	\N
278180	1678	14400545335000	13466	6753	28	0	\N
278181	1678	14400545336000	13466	6753	29	0	\N
278182	1678	14400545337000	13466	6753	30	0	\N
278183	1678	14400545338000	13466	6753	31	0	\N
278184	1678	14400545339000	13466	6753	32	0	\N
278185	1678	14400545340000	13466	6753	33	0	\N
278186	1678	14400545341000	13466	6753	34	0	\N
278187	1678	14400545342000	13466	6753	35	0	\N
278188	1678	14400545343000	13466	6753	36	0	\N
278189	1678	14400545344000	13466	6753	38	0	\N
278190	1678	14400545345000	13466	6753	39	0	\N
278191	1678	14400545346000	13466	6753	40	0	\N
278192	1678	14400545347000	13466	6753	41	0	\N
278193	1678	14400545348000	13466	6753	42	0	\N
278194	1678	14400545349000	13466	6753	43	0	\N
278195	1678	14400545350000	13466	6753	44	0	\N
278196	1678	14400545351000	13466	6753	45	0	\N
278197	1678	14400545352000	13466	6753	46	0	\N
278198	1678	14400545353000	13466	6753	47	0	\N
278199	1678	14400545354000	13466	6753	48	0	\N
278200	1678	14400545355000	13466	6753	49	0	\N
278201	1678	14400545356000	13466	6753	50	0	\N
278202	1678	14400545357000	13466	6753	51	0	\N
278203	1678	14400545358000	13466	6753	52	0	\N
278204	1678	14400545359000	13466	6753	53	0	\N
278205	1678	14400545360000	13466	6753	54	0	\N
278206	1678	14400545361000	13466	6753	55	0	\N
278207	1678	14400545362000	13466	6753	56	0	\N
278208	1678	14400545363000	13466	6753	57	0	\N
278209	1678	14400545364000	13466	6753	58	0	\N
278210	1678	14400545365000	13466	6753	59	0	\N
278211	1678	14400545366000	13466	6753	60	0	\N
278212	1678	14400545367000	13466	6753	61	0	\N
278213	1678	14400545368000	13466	6753	62	0	\N
278214	1678	14400545369000	13466	6753	63	0	\N
278215	1678	14400545370000	13466	6753	64	0	\N
278216	1678	14400545371000	13466	6753	65	0	\N
278217	1678	14400545372000	13466	6753	66	0	\N
278218	1678	14400545373000	13466	6753	67	0	\N
278219	1678	14400545374000	13466	6753	68	0	\N
278220	1678	14400545375000	13466	6753	69	0	\N
278221	1678	14400545376000	13466	6753	70	0	\N
278222	1678	14400545377000	13466	6753	71	0	\N
278223	1678	14400545378000	13466	6753	72	0	\N
278224	1678	14400545379000	13466	6753	73	0	\N
278225	1678	14400545380000	13466	6753	74	0	\N
278226	1678	14400545381000	13466	6753	75	0	\N
278233	1678	14400545521000	13470	6938	0	0	\N
278234	1874	886000	13470	6938	1	0	\N
278235	1874	888000	13470	6938	2	0	\N
278243	1678	14400545524000	13472	6940	0	0	\N
278244	1874	900000	13472	6940	1	0	\N
278245	1874	901000	13472	6940	2	0	\N
278246	1874	903000	13472	6940	3	0	\N
278247	1678	14400545524000	13473	6940	0	0	\N
278248	1874	900000	13473	6940	1	0	\N
278249	1874	901000	13473	6940	2	0	\N
278250	1874	903000	13473	6940	3	0	\N
278251	1678	14400545524000	13474	6940	0	0	\N
278253	1678	14400545525000	13476	6941	0	0	\N
278254	1874	900000	13476	6941	1	0	\N
278255	1874	901000	13476	6941	2	0	\N
278256	1874	903000	13476	6941	3	0	\N
278126	1874	864000	13455	6931	2	0	1
278127	1678	14400545515000	13457	6933	0	0	0
278128	1678	14400545516000	13457	6933	1	0	0
278129	1874	865000	13457	6933	2	0	1
278130	1874	867000	13457	6933	3	0	1
278132	1874	870000	13457	6933	5	0	1
278133	1874	871000	13457	6933	6	0	1
278134	1874	873000	13457	6933	7	0	1
278138	1678	14400545517000	13461	6934	0	0	0
278139	1874	874000	13461	6934	1	0	1
278141	1678	14400545518000	13462	6935	0	0	0
278142	1874	877000	13462	6935	1	0	1
278143	1874	879000	13462	6935	2	0	1
278147	1678	14400545519000	13464	6936	0	0	0
278149	1874	882000	13464	6936	2	0	1
278227	1678	14400545520000	13467	6937	0	0	0
278228	1874	883000	13467	6937	1	0	1
278229	1874	885000	13467	6937	2	0	1
278230	1678	14400545521000	13469	6938	0	0	0
278232	1874	888000	13469	6938	2	0	1
278236	1678	14400545522000	13471	6939	0	0	0
278237	1678	14400545523000	13471	6939	1	0	0
278238	1874	889000	13471	6939	2	0	1
278239	1874	891000	13471	6939	3	0	1
278241	1874	895000	13471	6939	5	0	1
278242	1874	897000	13471	6939	6	0	1
278252	1678	14400545524000	13475	6940	0	0	0
278257	1874	906000	13476	6941	4	0	\N
278258	1874	907000	13476	6941	5	0	\N
278259	1874	909000	13476	6941	6	0	\N
278260	1678	14400545525000	13477	6941	0	0	\N
278261	1874	900000	13477	6941	1	0	\N
278262	1874	901000	13477	6941	2	0	\N
278263	1874	903000	13477	6941	3	0	\N
278264	1874	906000	13477	6941	4	0	\N
278265	1874	907000	13477	6941	5	0	\N
278266	1874	909000	13477	6941	6	0	\N
278267	1678	14400545525000	13478	6941	0	0	\N
278268	1678	14400545525000	13479	6941	0	0	\N
278269	1874	900000	13479	6941	1	0	\N
278270	1874	901000	13479	6941	2	0	\N
278271	1874	903000	13479	6941	3	0	\N
278294	1678	14400545531000	13482	6943	0	0	\N
278295	1678	14400545532000	13482	6943	1	0	\N
278296	1678	14400545533000	13482	6943	2	0	\N
278297	1874	924000	13482	6943	3	0	\N
278298	1874	925000	13482	6943	4	0	\N
278299	1874	927000	13482	6943	5	0	\N
278300	1874	928000	13482	6943	6	0	\N
278301	1874	930000	13482	6943	7	0	\N
278302	1874	931000	13482	6943	8	0	\N
278312	1678	14400545531000	13484	6943	0	0	\N
278313	1678	14400545532000	13484	6943	1	0	\N
278314	1678	14400545533000	13484	6943	2	0	\N
278315	1874	924000	13484	6943	3	0	\N
278316	1874	925000	13484	6943	4	0	\N
278317	1874	927000	13484	6943	5	0	\N
278318	1874	928000	13484	6943	6	0	\N
278319	1874	930000	13484	6943	7	0	\N
278320	1874	931000	13484	6943	8	0	\N
278341	1678	14400545540000	13487	6946	0	0	\N
278342	1678	14400545541000	13487	6946	1	0	\N
278343	1874	951000	13487	6946	2	0	\N
278344	1874	952000	13487	6946	3	0	\N
278345	1874	954000	13487	6946	4	0	\N
278346	1874	955000	13487	6946	5	0	\N
278351	1678	14400545542000	13489	6947	0	0	\N
278357	1678	14400545543000	13491	6948	0	0	\N
278358	1678	14400545544000	13491	6948	1	0	\N
278359	1678	14400545545000	13491	6948	2	0	\N
278360	1874	960000	13491	6948	3	0	\N
278361	1874	961000	13491	6948	4	0	\N
278362	1678	14400545543000	13492	6948	0	0	\N
278363	1678	14400545544000	13492	6948	1	0	\N
278364	1678	14400545545000	13492	6948	2	0	\N
278365	1874	960000	13492	6948	3	0	\N
278366	1874	961000	13492	6948	4	0	\N
278367	1874	963000	13492	6948	5	0	\N
278368	1874	964000	13492	6948	6	0	\N
278369	1874	966000	13492	6948	7	0	\N
278370	1874	967000	13492	6948	8	0	\N
278380	1678	14400545546000	13494	6949	0	0	\N
278381	1874	969000	13494	6949	1	0	\N
278382	1874	970000	13494	6949	2	0	\N
278384	1678	14400545547000	13496	6950	0	0	\N
278385	1874	969000	13496	6950	1	0	\N
278386	1874	970000	13496	6950	2	0	\N
278387	1874	972000	13496	6950	3	0	\N
278274	1874	901000	13480	6941	2	0	1
278275	1874	903000	13480	6941	3	0	1
278276	1678	14400545526000	13481	6942	0	0	0
278277	1678	14400545527000	13481	6942	1	0	0
278278	1678	14400545528000	13481	6942	2	0	0
278280	1678	14400545530000	13481	6942	4	0	0
278281	2077	1439000000000	13481	6942	5	0	0
278282	1874	906000	13481	6942	6	0	1
278283	1874	907000	13481	6942	7	0	1
278284	1874	909000	13481	6942	8	0	1
278286	1874	912000	13481	6942	10	0	1
278287	1874	913000	13481	6942	11	0	1
278288	1874	915000	13481	6942	12	0	1
278289	1874	916000	13481	6942	13	0	1
278291	1874	919000	13481	6942	15	0	1
278292	1874	921000	13481	6942	16	0	1
278293	1874	922000	13481	6942	17	0	1
278303	1678	14400545531000	13483	6943	0	0	0
278304	1678	14400545532000	13483	6943	1	0	0
278306	1874	924000	13483	6943	3	0	1
278307	1874	925000	13483	6943	4	0	1
278308	1874	927000	13483	6943	5	0	1
278309	1874	928000	13483	6943	6	0	1
278310	1874	930000	13483	6943	7	0	1
278321	1678	14400545534000	13485	6944	0	0	0
278322	1678	14400545535000	13485	6944	1	0	0
278323	1678	14400545536000	13485	6944	2	0	0
278324	1874	933000	13485	6944	3	0	1
278326	1874	936000	13485	6944	5	0	1
278327	1874	937000	13485	6944	6	0	1
278328	1874	939000	13485	6944	7	0	1
278329	1874	940000	13485	6944	8	0	1
278330	1678	14400545537000	13486	6945	0	0	0
278332	1678	14400545539000	13486	6945	2	0	0
278333	1874	942000	13486	6945	3	0	1
278334	1874	943000	13486	6945	4	0	1
278335	1874	945000	13486	6945	5	0	1
278336	1874	946000	13486	6945	7	0	1
278338	1874	949000	13486	6945	9	0	1
278339	2093	200000000	13486	6945	10	0	0
278340	2094	200000000	13486	6945	11	0	0
278347	1678	14400545540000	13488	6946	0	0	0
278349	1874	951000	13488	6946	2	0	1
278350	1874	952000	13488	6946	3	0	1
278352	1678	14400545542000	13490	6947	0	0	0
278353	1874	954000	13490	6947	1	0	1
278354	1874	955000	13490	6947	2	0	1
278356	1874	958000	13490	6947	4	0	1
278371	1678	14400545543000	13493	6948	0	0	0
278372	1678	14400545544000	13493	6948	1	0	0
278373	1678	14400545545000	13493	6948	2	0	0
278374	1874	960000	13493	6948	3	0	1
278376	1874	963000	13493	6948	5	0	1
278377	1874	964000	13493	6948	6	0	1
278378	1874	966000	13493	6948	7	0	1
278379	1874	967000	13493	6948	8	0	1
278388	1678	14400545547000	13497	6950	0	0	0
278389	1874	969000	13497	6950	1	0	1
278390	1874	970000	13497	6950	2	0	1
278391	1874	972000	13497	6950	3	0	1
278392	1874	973000	13497	6950	4	0	1
278394	1678	14400545547000	13498	6950	0	0	\N
278398	1678	14400545548000	13500	6951	0	0	\N
278399	1874	975000	13500	6951	1	0	\N
278400	1874	976000	13500	6951	2	0	\N
278401	1678	14400545548000	13501	6951	0	0	\N
278405	1678	14400545550000	13503	6953	0	0	\N
278406	1874	981000	13503	6953	1	0	\N
278407	1874	982000	13503	6953	2	0	\N
278408	1678	14400545550000	13504	6953	0	0	\N
278409	1874	981000	13504	6953	1	0	\N
278410	1874	982000	13504	6953	2	0	\N
278414	1678	14400545550000	13506	6953	0	0	\N
278428	1678	14400545551000	13509	6954	0	0	\N
278429	1678	14400545552000	13509	6954	1	0	\N
278430	1678	14400545553000	13509	6954	2	0	\N
278431	1678	14400545554000	13509	6954	3	0	\N
278432	1678	14400545555000	13509	6954	4	0	\N
278433	1874	984000	13509	6954	5	0	\N
278434	1874	985000	13509	6954	6	0	\N
278435	1874	987000	13509	6954	7	0	\N
278436	1874	988000	13509	6954	8	0	\N
278437	1874	990000	13509	6954	9	0	\N
278438	1874	991000	13509	6954	10	0	\N
278439	2096	200000000	13509	6954	11	0	\N
278440	1874	993000	13509	6954	12	0	\N
278441	1874	994000	13509	6954	13	0	\N
278442	1874	996000	13509	6954	14	0	\N
278443	1874	997000	13509	6954	15	0	\N
278444	1678	14400545513000	13510	6931	0	0	\N
278445	1678	14400545514000	13510	6931	1	0	\N
278446	1678	14400545515000	13510	6931	2	0	\N
278447	1678	14400545516000	13510	6931	3	0	\N
278448	1678	14400545517000	13510	6931	4	0	\N
278449	1678	14400545518000	13510	6931	5	0	\N
278450	1678	14400545519000	13510	6931	6	0	\N
278451	1678	14400545520000	13510	6931	7	0	\N
278452	1678	14400545521000	13510	6931	8	0	\N
278453	1678	14400545522000	13510	6931	9	0	\N
278454	1678	14400545523000	13510	6931	10	0	\N
278455	1678	14400545524000	13510	6931	11	0	\N
278456	1678	14400545525000	13510	6931	12	0	\N
278457	1678	14400545526000	13510	6931	13	0	\N
278458	1678	14400545527000	13510	6931	14	0	\N
278459	1678	14400545528000	13510	6931	15	0	\N
278460	1678	14400545529000	13510	6931	16	0	\N
278461	1678	14400545530000	13510	6931	17	0	\N
278462	1678	14400545531000	13510	6931	18	0	\N
278463	1678	14400545532000	13510	6931	19	0	\N
278464	1678	14400545533000	13510	6931	20	0	\N
278465	1678	14400545534000	13510	6931	21	0	\N
278466	1678	14400545535000	13510	6931	22	0	\N
278467	1678	14400545536000	13510	6931	23	0	\N
278468	1678	14400545537000	13510	6931	24	0	\N
278469	1678	14400545538000	13510	6931	25	0	\N
278470	1678	14400545539000	13510	6931	26	0	\N
278471	1678	14400545540000	13510	6931	27	0	\N
278472	1678	14400545541000	13510	6931	28	0	\N
278473	1678	14400545542000	13510	6931	29	0	\N
278474	1678	14400545543000	13510	6931	30	0	\N
278475	1678	14400545544000	13510	6931	31	0	\N
278476	1678	14400545545000	13510	6931	32	0	\N
278477	1678	14400545546000	13510	6931	33	0	\N
278478	1678	14400545547000	13510	6931	34	0	\N
278479	1678	14400545548000	13510	6931	35	0	\N
278480	1678	14400545549000	13510	6931	36	0	\N
278481	1678	14400545550000	13510	6931	37	0	\N
278482	1678	14400545551000	13510	6931	38	0	\N
278483	1678	14400545552000	13510	6931	39	0	\N
278484	1678	14400545553000	13510	6931	40	0	\N
278485	1678	14400545554000	13510	6931	41	0	\N
278486	1678	14400545555000	13510	6931	42	0	\N
278487	2077	1439000000000	13510	6931	43	0	\N
278500	1745	1803000000	13515	6906	0	0	\N
278501	2077	1439000000000	13515	6906	1	0	\N
278502	1745	1803000000	13515	6906	2	0	\N
278503	1678	14400545559000	13516	6959	0	0	\N
278511	1678	14400545561000	13519	6961	0	0	\N
278512	1874	1014000	13519	6961	1	0	\N
278513	1874	1015000	13519	6961	2	0	\N
278514	1653	8000000	13519	6961	3	0	\N
278515	1678	14400545561000	13520	6961	0	0	\N
278516	1874	1014000	13520	6961	1	0	\N
278517	1874	1015000	13520	6961	2	0	\N
278518	1653	8000000	13520	6961	3	0	\N
278526	1678	14400545563000	13523	6963	0	0	\N
278527	1874	1020000	13523	6963	1	0	\N
278528	1874	1021000	13523	6963	2	0	\N
278396	1874	975000	13499	6951	1	0	1
278397	1874	976000	13499	6951	2	0	1
278402	1678	14400545549000	13502	6952	0	0	0
278403	1874	978000	13502	6952	1	0	1
278404	1874	979000	13502	6952	2	0	1
278412	1874	981000	13505	6953	1	0	1
278413	1874	982000	13505	6953	2	0	1
278415	1678	14400545551000	13507	6954	0	0	0
278416	1678	14400545552000	13507	6954	1	0	0
278417	1678	14400545553000	13507	6954	2	0	0
278419	1874	985000	13507	6954	4	0	1
278420	1874	987000	13507	6954	5	0	1
278421	1874	988000	13507	6954	6	0	1
278422	1874	990000	13507	6954	7	0	1
278424	2096	200000000	13507	6954	9	0	0
278425	1678	14400545554000	13508	6955	0	0	0
278426	1874	993000	13508	6955	1	0	1
278427	1874	994000	13508	6955	2	0	1
278488	1678	14400545555000	13511	6956	0	0	0
278490	1874	997000	13511	6956	2	0	1
278491	1678	14400545556000	13512	6957	0	0	0
278492	1874	999000	13512	6957	1	0	1
278493	1874	1000000	13512	6957	2	0	1
278494	1678	14400545557000	13513	6958	0	0	0
278496	1874	1002000	13513	6958	2	0	1
278497	1874	1003000	13513	6958	3	0	1
278498	1874	1005000	13513	6958	4	0	1
278499	1874	1006000	13513	6958	5	0	1
278505	1874	1008000	13517	6959	1	0	1
278506	1874	1009000	13517	6959	2	0	1
278507	1678	14400545560000	13518	6960	0	0	0
278508	1874	1011000	13518	6960	1	0	1
278509	1874	1012000	13518	6960	2	0	1
278519	1678	14400545561000	13521	6961	0	0	0
278520	1874	1014000	13521	6961	1	0	1
278521	1874	1015000	13521	6961	2	0	1
278522	1653	8000000	13521	6961	3	0	3
278523	1678	14400545562000	13522	6962	0	0	0
278525	1874	1018000	13522	6962	2	0	1
278529	2097	200000000	13523	6963	3	0	\N
278534	1678	14400545563000	13525	6963	0	0	\N
278535	1874	1020000	13525	6963	1	0	\N
278536	1874	1021000	13525	6963	2	0	\N
278537	2097	200000000	13525	6963	3	0	\N
278538	1678	14400545564000	13527	6964	0	0	\N
278539	1678	14400545565000	13527	6964	1	0	\N
278540	1874	1023000	13527	6964	2	0	\N
278541	1874	1024000	13527	6964	3	0	\N
278542	1874	1026000	13527	6964	4	0	\N
278543	1874	1027000	13527	6964	6	0	\N
278544	1678	14400545564000	13528	6964	0	0	\N
278545	1678	14400545565000	13528	6964	1	0	\N
278546	1874	1023000	13528	6964	2	0	\N
278547	1874	1024000	13528	6964	3	0	\N
278548	1874	1026000	13528	6964	4	0	\N
278549	1874	1027000	13528	6964	6	0	\N
278560	1678	14400545567000	13532	6967	0	0	\N
278561	1874	1033000	13532	6967	1	0	\N
278562	1874	1035000	13532	6967	2	0	\N
278566	1678	14400545567000	13534	6967	0	0	\N
278567	1678	14400545568000	13535	6968	0	0	\N
278568	1874	1033000	13535	6968	1	0	\N
278569	1874	1035000	13535	6968	2	0	\N
278570	1874	1036000	13535	6968	3	0	\N
278571	1874	1038000	13535	6968	4	0	\N
278575	1678	14400545568000	13538	6968	0	0	\N
278576	1874	1036000	13538	6968	1	0	\N
278577	1874	1038000	13538	6968	2	0	\N
278581	1678	14400545569000	13540	6969	0	0	\N
278582	1874	1039000	13540	6969	1	0	\N
278583	1874	1041000	13540	6969	2	0	\N
278584	1678	14400545570000	13541	6970	0	0	\N
278585	1874	1042000	13541	6970	1	0	\N
278586	1874	1044000	13541	6970	2	0	\N
278587	1678	14400545570000	13542	6970	0	0	\N
278588	1874	1042000	13542	6970	1	0	\N
278589	1874	1044000	13542	6970	2	0	\N
278590	1678	14400545570000	13543	6970	0	0	\N
278591	1874	1042000	13543	6970	1	0	\N
278592	1874	1044000	13543	6970	2	0	\N
278596	1678	14400545571000	13545	6971	0	0	\N
278597	1874	1045000	13545	6971	1	0	\N
278598	1874	1047000	13545	6971	2	0	\N
278599	1678	14400545571000	13546	6971	0	0	\N
278601	1678	14400545571000	13548	6971	0	0	\N
278602	1874	1045000	13548	6971	1	0	\N
278603	1874	1047000	13548	6971	2	0	\N
278604	1678	14400545572000	13549	6972	0	0	\N
278605	1874	1045000	13549	6972	1	0	\N
278606	1874	1047000	13549	6972	2	0	\N
278607	1874	1048000	13549	6972	3	0	\N
278608	1874	1050000	13549	6972	4	0	\N
278609	1678	14400545572000	13550	6972	0	0	\N
278610	1874	1045000	13550	6972	1	0	\N
278611	1874	1047000	13550	6972	2	0	\N
278612	1874	1048000	13550	6972	3	0	\N
278613	1874	1050000	13550	6972	4	0	\N
278615	1678	14400545571000	13552	6971	0	0	\N
278616	1678	14400545573000	13556	6973	0	0	\N
278617	1874	1045000	13556	6973	1	0	\N
278618	1874	1047000	13556	6973	2	0	\N
278619	1874	1048000	13556	6973	3	0	\N
278620	1874	1050000	13556	6973	4	0	\N
278621	1874	1051000	13556	6973	5	0	\N
278622	1874	1053000	13556	6973	6	0	\N
278623	1678	14400545573000	13557	6973	0	0	\N
278631	1678	14400545574000	13559	6974	0	0	\N
278632	1874	1054000	13559	6974	1	0	\N
278633	1874	1056000	13559	6974	2	0	\N
278637	1678	14400545574000	13561	6974	0	0	\N
278638	1874	1054000	13561	6974	1	0	\N
278661	1678	14400545580000	13566	6978	0	0	\N
278662	169	66178742095387	13566	6978	1	0	\N
278663	990	504145483631720	13566	6978	2	0	\N
278664	1110	903424387149520	13566	6978	3	0	\N
278532	1874	1021000	13524	6963	2	0	1
278533	2097	200000000	13524	6963	3	0	0
278550	1678	14400545564000	13529	6964	0	0	0
278551	1678	14400545565000	13529	6964	1	0	0
278552	1874	1023000	13529	6964	2	0	1
278554	1874	1026000	13529	6964	4	0	1
278555	1874	1027000	13529	6964	6	0	1
278556	1874	1029000	13530	6965	0	0	1
278557	1678	14400545566000	13531	6966	0	0	0
278558	1874	1030000	13531	6966	1	0	1
278563	1678	14400545567000	13533	6967	0	0	0
278564	1874	1033000	13533	6967	1	0	1
278565	1874	1035000	13533	6967	2	0	1
278572	1678	14400545568000	13536	6968	0	0	0
278574	1874	1038000	13536	6968	2	0	1
278578	1678	14400545569000	13539	6969	0	0	0
278579	1874	1039000	13539	6969	1	0	1
278580	1874	1041000	13539	6969	2	0	1
278593	1678	14400545570000	13544	6970	0	0	0
278595	1874	1044000	13544	6970	2	0	1
278600	1678	14400545571000	13547	6971	0	0	0
278614	1678	14400545572000	13551	6972	0	0	0
278624	1678	14400545573000	13558	6973	0	0	0
278625	1874	1045000	13558	6973	1	0	1
278627	1874	1048000	13558	6973	3	0	1
278628	1874	1050000	13558	6973	4	0	1
278629	1874	1051000	13558	6973	5	0	1
278630	1874	1053000	13558	6973	6	0	1
278635	1874	1054000	13560	6974	1	0	1
278636	1874	1056000	13560	6974	2	0	1
278639	1678	14400545575000	13562	6975	0	0	0
278640	1678	14400545576000	13563	6976	0	0	0
278641	1678	14400545577000	13563	6976	1	0	0
278643	1874	1057000	13563	6976	3	0	1
278644	1874	1059000	13563	6976	4	0	1
278645	1874	1060000	13563	6976	5	0	1
278646	1874	1062000	13563	6976	6	0	1
278647	1874	1063000	13563	6976	7	0	1
278649	1874	1066000	13563	6976	9	0	1
278650	1678	14400545579000	13564	6977	0	0	0
278651	1874	1068000	13564	6977	1	0	1
278652	1874	1069000	13564	6977	2	0	1
278654	169	66178742095387	13565	6978	1	0	0
278655	990	504145483631720	13565	6978	2	0	0
278656	1110	903424387149520	13565	6978	3	0	0
278657	1230	609558436012355	13565	6978	4	0	0
278658	1356	1698588780862630	13565	6978	5	0	0
278660	1874	1072000	13565	6978	7	0	1
278665	1230	609558436012355	13566	6978	4	0	\N
278666	1356	1698588780862630	13566	6978	5	0	\N
278667	1874	1071000	13566	6978	6	0	\N
278668	1874	1072000	13566	6978	7	0	\N
278669	1678	14400545580000	13567	6978	0	0	\N
278670	169	66178742095387	13567	6978	1	0	\N
278671	990	504145483631720	13567	6978	2	0	\N
278672	1110	903424387149520	13567	6978	3	0	\N
278673	1230	609558436012355	13567	6978	4	0	\N
278674	1356	1698588780862630	13567	6978	5	0	\N
278675	1874	1071000	13567	6978	6	0	\N
278676	1874	1072000	13567	6978	7	0	\N
278677	1678	14400545548000	13568	6951	0	0	\N
278678	1678	14400545549000	13568	6951	1	0	\N
278679	1678	14400545550000	13568	6951	2	0	\N
278680	1678	14400545551000	13568	6951	3	0	\N
278681	1678	14400545552000	13568	6951	4	0	\N
278682	1678	14400545553000	13568	6951	5	0	\N
278683	1678	14400545554000	13568	6951	6	0	\N
278684	1678	14400545555000	13568	6951	7	0	\N
278685	1678	14400545556000	13568	6951	8	0	\N
278686	1678	14400545557000	13568	6951	9	0	\N
278687	1678	14400545558000	13568	6951	10	0	\N
278688	1678	14400545559000	13568	6951	11	0	\N
278689	1678	14400545560000	13568	6951	12	0	\N
278690	1678	14400545561000	13568	6951	13	0	\N
278691	1678	14400545562000	13568	6951	14	0	\N
278692	1678	14400545563000	13568	6951	15	0	\N
278693	1678	14400545564000	13568	6951	16	0	\N
278694	1678	14400545565000	13568	6951	17	0	\N
278695	1678	14400545566000	13568	6951	18	0	\N
278696	1678	14400545567000	13568	6951	19	0	\N
278697	1678	14400545568000	13568	6951	20	0	\N
278698	1678	14400545569000	13568	6951	21	0	\N
278699	1678	14400545570000	13568	6951	22	0	\N
278700	1678	14400545571000	13568	6951	23	0	\N
278701	1678	14400545572000	13568	6951	24	0	\N
278702	1678	14400545573000	13568	6951	25	0	\N
278703	1678	14400545574000	13568	6951	26	0	\N
278704	169	66178742095387	13568	6951	27	0	\N
278705	990	504145483631720	13568	6951	28	0	\N
278706	1110	903424387149520	13568	6951	29	0	\N
278707	1230	609558436012355	13568	6951	30	0	\N
278708	1356	1698588780862630	13568	6951	31	0	\N
278709	1678	14400545575000	13568	6951	32	0	\N
278710	1678	14400545576000	13568	6951	33	0	\N
278711	1678	14400545577000	13568	6951	34	0	\N
278712	1678	14400545578000	13568	6951	35	0	\N
278713	1678	14400545579000	13568	6951	36	0	\N
278714	1678	14400545580000	13568	6951	37	0	\N
278715	1653	8000000	13568	6951	38	0	\N
278716	1653	8000000	13568	6951	39	0	\N
278720	1678	14400545581000	13570	6979	0	0	\N
278721	1874	1074000	13570	6979	1	0	\N
278722	1874	1075000	13570	6979	2	0	\N
278723	1678	14400545556000	13571	6932	0	0	\N
278724	1678	14400545557000	13571	6932	1	0	\N
278725	1678	14400545558000	13571	6932	2	0	\N
278726	1678	14400545559000	13571	6932	3	0	\N
278727	1678	14400545560000	13571	6932	4	0	\N
278728	1678	14400545561000	13571	6932	5	0	\N
278729	1678	14400545562000	13571	6932	6	0	\N
278730	1678	14400545563000	13571	6932	7	0	\N
278731	1678	14400545564000	13571	6932	8	0	\N
278732	1678	14400545565000	13571	6932	9	0	\N
278733	1678	14400545566000	13571	6932	10	0	\N
278734	1678	14400545567000	13571	6932	11	0	\N
278735	1678	14400545568000	13571	6932	12	0	\N
278736	1678	14400545569000	13571	6932	13	0	\N
278737	1678	14400545570000	13571	6932	14	0	\N
278738	1678	14400545571000	13571	6932	15	0	\N
278739	1678	14400545572000	13571	6932	16	0	\N
278740	1678	14400545573000	13571	6932	17	0	\N
278741	1678	14400545574000	13571	6932	18	0	\N
278742	169	66178742095387	13571	6932	19	0	\N
278743	990	504145483631720	13571	6932	20	0	\N
278744	1110	903424387149520	13571	6932	21	0	\N
278745	1230	609558436012355	13571	6932	22	0	\N
278746	1356	1698588780862630	13571	6932	23	0	\N
278747	1678	14400545575000	13571	6932	24	0	\N
278748	1678	14400545576000	13571	6932	25	0	\N
278749	1678	14400545577000	13571	6932	26	0	\N
278750	1678	14400545578000	13571	6932	27	0	\N
278751	1678	14400545579000	13571	6932	28	0	\N
278752	1678	14400545580000	13571	6932	29	0	\N
278753	1678	14400545581000	13571	6932	30	0	\N
278754	1653	8000000	13571	6932	31	0	\N
278755	1653	8000000	13571	6932	32	0	\N
278756	1678	14400545581000	13572	6979	0	0	\N
278757	1874	1074000	13572	6979	1	0	\N
278758	1874	1075000	13572	6979	2	0	\N
278759	1678	14400545582000	13573	6980	0	0	\N
278760	1874	1077000	13573	6980	1	0	\N
278761	1874	1078000	13573	6980	2	0	\N
278765	1678	14400545583000	13575	6981	0	0	\N
278766	1874	1080000	13575	6981	1	0	\N
278767	1874	1081000	13575	6981	2	0	\N
278719	1874	1075000	13569	6979	2	0	1
278762	1678	14400545582000	13574	6980	0	0	0
278763	1874	1077000	13574	6980	1	0	1
278764	1874	1078000	13574	6980	2	0	1
278768	1678	14400545583000	13576	6981	0	0	0
278770	1874	1081000	13576	6981	2	0	1
278771	1678	14400545584000	13577	6982	0	0	0
278772	1678	14400545585000	13577	6982	1	0	0
278773	1678	14400545586000	13577	6982	2	0	0
278774	1874	1083000	13577	6982	3	0	1
278776	1874	1086000	13577	6982	5	0	1
278777	1874	1087000	13577	6982	6	0	1
278778	1874	1089000	13577	6982	7	0	1
278779	1874	1090000	13577	6982	8	0	1
278781	1678	14400545587000	13578	6983	1	0	0
278782	1874	1092000	13578	6983	2	0	1
278783	1874	1093000	13578	6983	3	0	1
278784	1678	14400545588000	13579	6984	0	0	0
278785	1678	14400545589000	13579	6984	1	0	0
278787	1874	1096000	13579	6984	3	0	1
278788	1874	1098000	13579	6984	4	0	1
278789	1874	1101000	13579	6984	5	0	1
278790	1874	1102000	13579	6984	6	0	1
278791	1678	14400545590000	13580	6985	0	0	0
278793	1678	14400545592000	13580	6985	2	0	0
278794	1874	1104000	13580	6985	3	0	1
278795	1874	1107000	13580	6985	4	0	1
278796	1874	1108000	13580	6985	6	0	1
278798	1874	1113000	13580	6985	8	0	1
278799	1874	1114000	13580	6985	9	0	1
278800	1874	1116000	13580	6985	10	0	1
278803	1678	14400545593000	13581	6986	0	0	\N
278804	1874	1122000	13581	6986	1	0	\N
278805	1874	1125000	13581	6986	2	0	\N
278806	1874	1126000	13581	6986	3	0	\N
278811	1678	14400545593000	13583	6986	0	0	\N
278812	1874	1122000	13583	6986	1	0	\N
278813	1874	1125000	13583	6986	2	0	\N
278814	1874	1126000	13583	6986	3	0	\N
278819	1678	14400545594000	13585	6987	1	0	\N
278820	1874	1128000	13585	6987	2	0	\N
278821	1874	1131000	13585	6987	3	0	\N
278822	1874	1132000	13585	6987	4	0	\N
278823	1678	14400545595000	13586	6988	0	0	\N
278824	1874	1134000	13586	6988	1	0	\N
278825	1874	1137000	13586	6988	2	0	\N
278826	1874	1138000	13586	6988	3	0	\N
278836	2098	200000000	13589	6989	0	0	\N
278837	1678	14400545596000	13589	6989	1	0	\N
278838	1874	1140000	13589	6989	2	0	\N
278839	1874	1143000	13589	6989	3	0	\N
278840	1874	1144000	13589	6989	4	0	\N
278841	2098	200000000	13590	6989	0	0	\N
278842	1678	14400545596000	13590	6989	1	0	\N
278843	1874	1140000	13590	6989	2	0	\N
278844	1874	1143000	13590	6989	3	0	\N
278845	1874	1144000	13590	6989	4	0	\N
278846	1678	14400545597000	13591	6990	0	0	\N
278847	1874	1146000	13591	6990	1	0	\N
278848	1874	1149000	13591	6990	2	0	\N
278856	1678	14400545598000	13594	6991	0	0	\N
278857	1874	1150000	13594	6991	1	0	\N
278858	1874	1152000	13594	6991	2	0	\N
278859	1874	1155000	13594	6991	3	0	\N
278860	1678	14400545598000	13595	6991	0	0	\N
278861	1874	1150000	13595	6991	1	0	\N
278862	1874	1152000	13595	6991	2	0	\N
278863	1874	1155000	13595	6991	3	0	\N
278864	1678	14400545599000	13596	6992	0	0	\N
278865	1874	1157000	13596	6992	1	0	\N
278866	1874	1160000	13596	6992	2	0	\N
278867	1678	14400545599000	13597	6992	0	0	\N
278868	1874	1157000	13597	6992	1	0	\N
278869	1874	1160000	13597	6992	2	0	\N
278870	1678	14400545599000	13598	6992	0	0	\N
278871	1874	1157000	13598	6992	1	0	\N
278872	1874	1160000	13598	6992	2	0	\N
278876	1678	14400545599000	13600	6992	0	0	\N
278877	1874	1157000	13600	6992	1	0	\N
278878	1874	1160000	13600	6992	2	0	\N
278879	1678	14400545599000	13601	6992	0	0	\N
278884	1678	14400545601000	13603	6994	0	0	\N
278885	1678	14400545602000	13603	6994	1	0	\N
278886	1678	14400545603000	13603	6994	2	0	\N
278887	1678	14400545604000	13603	6994	3	0	\N
278888	1678	14400545605000	13603	6994	4	0	\N
278889	1678	14400545606000	13603	6994	5	0	\N
278890	1678	14400545607000	13603	6994	6	0	\N
278891	1874	1168000	13603	6994	7	0	\N
278892	1874	1171000	13603	6994	8	0	\N
278893	1874	1173000	13603	6994	9	0	\N
278894	1874	1176000	13603	6994	10	0	\N
278895	1874	1177000	13603	6994	11	0	\N
278896	1874	1179000	13603	6994	12	0	\N
278897	1874	1182000	13603	6994	13	0	\N
278898	1874	1183000	13603	6994	14	0	\N
278899	1874	1185000	13603	6994	15	0	\N
278900	1874	1188000	13603	6994	16	0	\N
278901	1874	1189000	13603	6994	17	0	\N
278902	1874	1191000	13603	6994	18	0	\N
278903	1874	1194000	13603	6994	19	0	\N
278904	1874	1195000	13603	6994	20	0	\N
278905	1874	1197000	13603	6994	21	0	\N
278906	1874	1200000	13603	6994	22	0	\N
278907	1874	1201000	13603	6994	23	0	\N
278908	1874	1203000	13603	6994	24	0	\N
278909	1874	1206000	13603	6994	25	0	\N
278910	1874	1207000	13603	6994	26	0	\N
278807	1678	14400545593000	13582	6986	0	0	0
278808	1874	1122000	13582	6986	1	0	1
278809	1874	1125000	13582	6986	2	0	1
278810	1874	1126000	13582	6986	3	0	1
278815	1678	14400545594000	13584	6987	1	0	0
278817	1874	1131000	13584	6987	3	0	1
278818	1874	1132000	13584	6987	4	0	1
278827	1678	14400545595000	13587	6988	0	0	0
278828	1874	1134000	13587	6988	1	0	1
278829	1874	1137000	13587	6988	2	0	1
278831	2098	200000000	13588	6989	0	0	0
278832	1678	14400545596000	13588	6989	1	0	0
278833	1874	1140000	13588	6989	2	0	1
278834	1874	1143000	13588	6989	3	0	1
278849	1678	14400545597000	13592	6990	0	0	0
278850	1874	1146000	13592	6990	1	0	1
278851	1874	1149000	13592	6990	2	0	1
278852	1678	14400545598000	13593	6991	0	0	0
278853	1874	1150000	13593	6991	1	0	1
278855	1874	1155000	13593	6991	3	0	1
278873	1678	14400545599000	13599	6992	0	0	0
278874	1874	1157000	13599	6992	1	0	1
278875	1874	1160000	13599	6992	2	0	1
278880	1678	14400545600000	13602	6993	0	0	0
278882	1874	1163000	13602	6993	2	0	1
278883	1874	1166000	13602	6993	3	0	1
278911	1678	14400545601000	13604	6994	0	0	0
278912	1678	14400545602000	13604	6994	1	0	0
278914	1678	14400545604000	13604	6994	3	0	0
278915	1678	14400545605000	13604	6994	4	0	0
278916	1678	14400545606000	13604	6994	5	0	0
278917	1678	14400545607000	13604	6994	6	0	0
278918	1874	1168000	13604	6994	7	0	1
278920	1874	1173000	13604	6994	9	0	1
278921	1874	1176000	13604	6994	10	0	1
278922	1874	1177000	13604	6994	11	0	1
278923	1874	1179000	13604	6994	12	0	1
278924	1874	1182000	13604	6994	13	0	1
278926	1874	1185000	13604	6994	15	0	1
278927	1874	1188000	13604	6994	16	0	1
278928	1874	1189000	13604	6994	17	0	1
278929	1874	1191000	13604	6994	18	0	1
278931	1874	1195000	13604	6994	20	0	1
278932	1874	1197000	13604	6994	21	0	1
278933	1874	1200000	13604	6994	22	0	1
278934	1874	1201000	13604	6994	23	0	1
278935	1874	1203000	13604	6994	24	0	1
278938	1678	14400545608000	13606	6995	0	0	\N
278939	1874	1209000	13606	6995	1	0	\N
278940	1874	1212000	13606	6995	2	0	\N
278941	1874	1213000	13606	6995	3	0	\N
278950	1678	14400545608000	13608	6996	0	0	\N
278951	1678	14400545609000	13608	6996	1	0	\N
278952	1874	1209000	13608	6996	2	0	\N
278953	1874	1212000	13608	6996	3	0	\N
278954	1874	1213000	13608	6996	4	0	\N
278955	1874	1215000	13608	6996	5	0	\N
278956	1874	1218000	13608	6996	6	0	\N
278957	1874	1219000	13608	6996	7	0	\N
278969	1678	14400545612000	13612	6998	0	0	\N
278970	1874	1233000	13612	6998	1	0	\N
278971	1874	1236000	13612	6998	2	0	\N
278976	1678	14400545613000	13614	6999	0	0	\N
278977	1874	1237000	13614	6999	1	0	\N
278978	1874	1239000	13614	6999	2	0	\N
278979	1874	1242000	13614	6999	3	0	\N
278984	1678	14400545615000	13616	7001	0	0	\N
278985	1874	1249000	13616	7001	1	0	\N
278986	1874	1251000	13616	7001	3	0	\N
278987	1874	1254000	13616	7001	4	0	\N
278988	1678	14400545615000	13617	7001	0	0	\N
278989	1874	1249000	13617	7001	1	0	\N
278990	1874	1251000	13617	7001	3	0	\N
278991	1874	1254000	13617	7001	4	0	\N
279000	1678	14400545617000	13620	7003	0	0	\N
279001	1874	1261000	13620	7003	1	0	\N
279002	1874	1263000	13620	7003	2	0	\N
279003	1874	1266000	13620	7003	3	0	\N
279004	1678	14400545617000	13621	7003	0	0	\N
279005	1874	1261000	13621	7003	1	0	\N
279006	1874	1263000	13621	7003	2	0	\N
279007	1874	1266000	13621	7003	3	0	\N
279008	1678	14400545617000	13622	7003	0	0	\N
279017	1678	14400545618000	13625	7004	0	0	\N
279018	1678	14400545619000	13626	7005	0	0	\N
279019	1678	14400545620000	13626	7005	1	0	\N
279020	1678	14400545621000	13626	7005	2	0	\N
279021	1874	1273000	13626	7005	3	0	\N
279022	1874	1275000	13626	7005	4	0	\N
279023	1874	1278000	13626	7005	5	0	\N
279024	1874	1279000	13626	7005	6	0	\N
279025	1874	1281000	13626	7005	7	0	\N
279026	1874	1284000	13626	7005	8	0	\N
279027	1874	1285000	13626	7005	9	0	\N
279028	1874	1287000	13626	7005	10	0	\N
279029	1874	1290000	13626	7005	11	0	\N
279030	1678	14400545619000	13627	7005	0	0	\N
279031	1678	14400545620000	13627	7005	1	0	\N
279032	1678	14400545621000	13627	7005	2	0	\N
279033	1874	1273000	13627	7005	3	0	\N
279034	1874	1275000	13627	7005	4	0	\N
279035	1874	1278000	13627	7005	5	0	\N
279036	1874	1279000	13627	7005	6	0	\N
279037	1874	1281000	13627	7005	7	0	\N
279038	1874	1284000	13627	7005	8	0	\N
279039	1874	1285000	13627	7005	9	0	\N
279040	1874	1287000	13627	7005	10	0	\N
279041	1874	1290000	13627	7005	11	0	\N
279042	1678	14400545619000	13628	7005	0	0	\N
279043	1678	14400545620000	13628	7005	1	0	\N
279044	1678	14400545621000	13628	7005	2	0	\N
279045	1874	1273000	13628	7005	3	0	\N
279046	1874	1275000	13628	7005	4	0	\N
279047	1874	1278000	13628	7005	5	0	\N
279048	1874	1279000	13628	7005	6	0	\N
279049	1874	1281000	13628	7005	7	0	\N
279050	1874	1284000	13628	7005	8	0	\N
279051	1874	1285000	13628	7005	9	0	\N
279052	1874	1287000	13628	7005	10	0	\N
279053	1874	1290000	13628	7005	11	0	\N
278943	1678	14400545609000	13607	6996	1	0	0
278944	1874	1209000	13607	6996	2	0	1
278945	1874	1212000	13607	6996	3	0	1
278946	1874	1213000	13607	6996	4	0	1
278947	1874	1215000	13607	6996	5	0	1
278949	1874	1219000	13607	6996	7	0	1
278958	1678	14400545610000	13610	6997	1	0	0
278959	1678	14400545611000	13610	6997	2	0	0
278960	1874	1221000	13610	6997	3	0	1
278961	1874	1224000	13610	6997	4	0	1
278963	1874	1227000	13610	6997	6	0	1
278964	1874	1230000	13610	6997	7	0	1
278965	1874	1231000	13610	6997	8	0	1
278966	1678	14400545612000	13611	6998	0	0	0
278968	1874	1236000	13611	6998	2	0	1
278972	1678	14400545613000	13613	6999	0	0	0
278973	1874	1237000	13613	6999	1	0	1
278974	1874	1239000	13613	6999	2	0	1
278975	1874	1242000	13613	6999	3	0	1
278981	1874	1243000	13615	7000	1	0	1
278982	1874	1245000	13615	7000	2	0	1
278983	1874	1248000	13615	7000	3	0	1
278992	1678	14400545615000	13618	7001	0	0	0
278993	1874	1249000	13618	7001	1	0	1
278995	1874	1254000	13618	7001	4	0	1
278996	1678	14400545616000	13619	7002	0	0	0
278997	1874	1255000	13619	7002	1	0	1
278998	1874	1257000	13619	7002	2	0	1
279009	1678	14400545617000	13623	7003	0	0	0
279010	1874	1261000	13623	7003	1	0	1
279011	1874	1263000	13623	7003	2	0	1
279012	1874	1266000	13623	7003	3	0	1
279013	1678	14400545618000	13624	7004	0	0	0
279015	1874	1269000	13624	7004	2	0	1
279016	1874	1272000	13624	7004	3	0	1
279054	1678	14400545619000	13630	7006	0	0	0
279055	1678	14400545620000	13630	7006	1	0	0
279056	1678	14400545621000	13630	7006	2	0	0
279058	1874	1273000	13630	7006	4	0	1
279059	1874	1275000	13630	7006	5	0	1
279060	1874	1278000	13630	7006	6	0	1
279061	1874	1279000	13630	7006	7	0	1
279063	1874	1284000	13630	7006	9	0	1
279064	1874	1285000	13630	7006	10	0	1
279065	1874	1287000	13630	7006	11	0	1
279066	1874	1290000	13630	7006	12	0	1
279067	1874	1291000	13630	7006	13	0	1
279069	1874	1296000	13630	7006	15	0	1
279070	1678	14400545623000	13631	7007	0	0	0
279071	1874	1297000	13631	7007	1	0	1
279072	1874	1299000	13631	7007	2	0	1
279079	1678	14400545627000	13634	7010	0	0	\N
279080	1678	14400545628000	13634	7010	1	0	\N
279081	1874	1309000	13634	7010	2	0	\N
279082	1874	1310000	13634	7010	3	0	\N
279083	1874	1313000	13634	7010	4	0	\N
279084	1874	1315000	13634	7010	5	0	\N
279085	1874	1316000	13634	7010	6	0	\N
279086	1874	1319000	13634	7010	7	0	\N
279087	1874	1321000	13634	7010	8	0	\N
279088	1874	1322000	13634	7010	9	0	\N
279089	1874	1325000	13634	7010	10	0	\N
279090	1874	1327000	13634	7010	11	0	\N
279091	1874	1328000	13634	7010	12	0	\N
279092	1874	1331000	13634	7010	13	0	\N
279093	1678	14400545627000	13635	7010	0	0	\N
279094	1678	14400545628000	13635	7010	1	0	\N
279095	1874	1309000	13635	7010	2	0	\N
279096	1874	1310000	13635	7010	3	0	\N
279097	1874	1313000	13635	7010	4	0	\N
279098	1874	1315000	13635	7010	5	0	\N
279099	1874	1316000	13635	7010	6	0	\N
279100	1874	1319000	13635	7010	7	0	\N
279101	1874	1321000	13635	7010	8	0	\N
279102	1874	1322000	13635	7010	9	0	\N
279103	1874	1325000	13635	7010	10	0	\N
279104	1874	1327000	13635	7010	11	0	\N
279105	1874	1328000	13635	7010	12	0	\N
279106	1874	1331000	13635	7010	13	0	\N
279121	1678	14400545627000	13637	7010	0	0	\N
279122	1678	14400545628000	13637	7010	1	0	\N
279123	1874	1309000	13637	7010	2	0	\N
279124	1874	1310000	13637	7010	3	0	\N
279125	1874	1313000	13637	7010	4	0	\N
279126	1874	1315000	13637	7010	5	0	\N
279127	1874	1316000	13637	7010	6	0	\N
279128	1874	1319000	13637	7010	7	0	\N
279129	1874	1321000	13637	7010	8	0	\N
279130	1874	1322000	13637	7010	9	0	\N
279131	1874	1325000	13637	7010	10	0	\N
279132	1874	1327000	13637	7010	11	0	\N
279133	1874	1328000	13637	7010	12	0	\N
279134	1874	1331000	13637	7010	13	0	\N
279135	1678	14400545627000	13638	7010	0	0	\N
279136	1678	14400545628000	13638	7010	1	0	\N
279137	1678	14400545629000	13639	7011	0	0	\N
279138	1678	14400545630000	13639	7011	1	0	\N
279139	1678	14400545631000	13639	7011	2	0	\N
279140	1678	14400545632000	13639	7011	3	0	\N
279141	1874	1333000	13639	7011	4	0	\N
279142	1874	1334000	13639	7011	5	0	\N
279143	1874	1337000	13639	7011	6	0	\N
279144	1874	1339000	13639	7011	7	0	\N
279145	1874	1340000	13639	7011	8	0	\N
279146	1874	1343000	13639	7011	9	0	\N
279147	1874	1345000	13639	7011	10	0	\N
279148	1874	1346000	13639	7011	11	0	\N
279149	1874	1349000	13639	7011	12	0	\N
279150	1874	1351000	13639	7011	13	0	\N
279151	1874	1352000	13639	7011	14	0	\N
279152	1874	1355000	13639	7011	15	0	\N
279177	1678	14400545635000	13643	7014	0	0	\N
279178	1874	1368000	13643	7014	1	0	\N
279179	1874	1371000	13643	7014	2	0	\N
279180	1678	14400545635000	13644	7014	0	0	\N
279181	1874	1368000	13644	7014	1	0	\N
279182	1874	1371000	13644	7014	2	0	\N
279183	1678	14400545635000	13645	7014	0	0	\N
279184	1874	1368000	13645	7014	1	0	\N
279185	1874	1371000	13645	7014	2	0	\N
279186	1678	14400545635000	13646	7014	0	0	\N
279187	1874	1368000	13646	7014	1	0	\N
279188	1874	1371000	13646	7014	2	0	\N
279197	1678	14400545637000	13650	7016	0	0	\N
279204	1678	14400545640000	13653	7019	0	0	\N
279205	1874	1389000	13653	7019	2	0	\N
279206	1874	1390000	13653	7019	3	0	\N
279207	1678	14400545640000	13655	7019	0	0	\N
279208	1874	1389000	13655	7019	2	0	\N
279075	1874	1304000	13632	7008	1	0	1
279076	1874	1307000	13632	7008	2	0	1
279077	1678	14400545625000	13633	7009	0	0	0
279078	1678	14400545626000	13633	7009	1	0	0
279107	1678	14400545627000	13636	7010	0	0	0
279109	1874	1309000	13636	7010	2	0	1
279110	1874	1310000	13636	7010	3	0	1
279111	1874	1313000	13636	7010	4	0	1
279112	1874	1315000	13636	7010	5	0	1
279113	1874	1316000	13636	7010	6	0	1
279115	1874	1321000	13636	7010	8	0	1
279116	1874	1322000	13636	7010	9	0	1
279117	1874	1325000	13636	7010	10	0	1
279118	1874	1327000	13636	7010	11	0	1
279120	1874	1331000	13636	7010	13	0	1
279153	1678	14400545629000	13640	7011	0	0	0
279154	1678	14400545630000	13640	7011	1	0	0
279155	1678	14400545631000	13640	7011	2	0	0
279156	1678	14400545632000	13640	7011	3	0	0
279158	1874	1334000	13640	7011	5	0	1
279159	1874	1337000	13640	7011	6	0	1
279160	1874	1339000	13640	7011	7	0	1
279161	1874	1340000	13640	7011	8	0	1
279162	1874	1343000	13640	7011	9	0	1
279164	1874	1346000	13640	7011	11	0	1
279165	1874	1349000	13640	7011	12	0	1
279166	1874	1351000	13640	7011	13	0	1
279167	1874	1352000	13640	7011	14	0	1
279169	1678	14400545633000	13641	7012	0	0	0
279170	1874	1357000	13641	7012	1	0	1
279171	1874	1358000	13641	7012	2	0	1
279172	1874	1361000	13641	7012	3	0	1
279173	1678	14400545634000	13642	7013	0	0	0
279175	1874	1364000	13642	7013	2	0	1
279176	1874	1367000	13642	7013	3	0	1
279189	1678	14400545635000	13647	7014	0	0	0
279190	1874	1368000	13647	7014	1	0	1
279191	1874	1371000	13647	7014	2	0	1
279193	1874	1372000	13648	7015	1	0	1
279194	1874	1375000	13648	7015	2	0	1
279195	1678	14400545637000	13649	7016	0	0	0
279196	1874	1378000	13649	7016	1	0	1
279199	1874	1381000	13651	7017	1	0	1
279200	1874	1382000	13651	7017	2	0	1
279201	1678	14400545639000	13652	7018	0	0	0
279202	1874	1385000	13652	7018	1	0	1
279203	1874	1386000	13652	7018	2	0	1
279209	1874	1390000	13655	7019	3	0	\N
279210	2082	4000000000	13657	6731	0	0	\N
279211	2047	40500000	13657	6731	1	0	\N
279212	2088	12300000	13657	6731	3	0	\N
279213	1368	1702661297751650	13657	6731	4	0	\N
279214	1678	13680400237000	13657	6731	5	0	\N
279215	1122	905589535000000	13657	6731	6	0	\N
279216	1242	611019160000000	13657	6731	7	0	\N
279217	1014	505330736600000	13657	6731	8	0	\N
279218	1002	505354605000000	13657	6731	9	0	\N
279219	1134	905548877800000	13657	6731	10	0	\N
279220	23	32724630000000	13657	6731	11	0	\N
279221	756	1005950000000	13657	6731	12	0	\N
279222	1678	13680400238000	13657	6731	13	0	\N
279223	1678	13680400239000	13657	6731	14	0	\N
279224	1254	610992052400000	13657	6731	15	0	\N
279225	1380	1702581800951650	13657	6731	16	0	\N
279226	1678	13680400240000	13657	6731	17	0	\N
279227	1678	13680400241000	13657	6731	18	0	\N
279228	1678	13680400242000	13657	6731	19	0	\N
279229	1678	13680400243000	13657	6731	20	0	\N
279230	1678	13680400244000	13657	6731	21	0	\N
279231	1678	13680400245000	13657	6731	22	0	\N
279232	1346	1701957637751650	13657	6731	23	0	\N
279233	1100	905216465000000	13657	6731	24	0	\N
279234	1220	610767750000000	13657	6731	25	0	\N
279235	980	505145775000000	13657	6731	26	0	\N
279236	1678	13680400246000	13657	6731	27	0	\N
279237	1678	13680400247000	13657	6731	28	0	\N
279238	1678	13680400248000	13657	6731	29	0	\N
279239	1678	13680400249000	13657	6731	30	0	\N
279240	1678	13680400250000	13657	6731	31	0	\N
279241	1678	13680400251000	13657	6731	32	0	\N
279242	1678	13680400252000	13657	6731	33	0	\N
279243	2085	0	13657	6731	35	0	\N
279244	2085	1000000000	13657	6731	36	0	\N
279245	169	66178742095387	13657	6731	37	0	\N
279246	990	504145483631720	13657	6731	38	0	\N
279247	1110	903424387149520	13657	6731	39	0	\N
279248	1230	609558436012355	13657	6731	40	0	\N
279249	1356	1698588780862630	13657	6731	41	0	\N
279250	854	246714729103038	13657	6731	42	0	\N
279251	856	130502845343877	13657	6731	43	0	\N
279252	858	329060974492151	13657	6731	44	0	\N
279253	862	454509909646030	13657	6731	45	0	\N
279254	866	399008699557196	13657	6731	46	0	\N
279255	868	2430052982831172	13657	6731	47	0	\N
279256	870	259875266041231	13657	6731	48	0	\N
279257	874	2430052982831172	13657	6731	49	0	\N
279258	876	213004644124518	13657	6731	50	0	\N
279259	880	135002943459175	13657	6731	51	0	\N
279260	882	585012754989949	13657	6731	52	0	\N
279261	884	90001962306133	13657	6731	53	0	\N
279262	888	268618956679283	13657	6731	54	0	\N
279263	890	225491216368345	13657	6731	55	0	\N
279264	892	495010792683787	13657	6731	56	0	\N
279265	898	65298223692326	13657	6731	57	0	\N
279266	900	38924048658131	13657	6731	58	0	\N
279267	902	117002550997929	13657	6731	59	0	\N
279268	906	420759173781209	13657	6731	60	0	\N
279269	1678	13680400253000	13657	6731	61	0	\N
279270	1678	13680400254000	13657	6731	62	0	\N
279271	1678	13680400255000	13657	6731	63	0	\N
279272	1678	13680400256000	13657	6731	64	0	\N
279273	1678	13680400257000	13657	6731	65	0	\N
279274	1678	13680400258000	13657	6731	66	0	\N
279275	1678	13680400259000	13657	6731	67	0	\N
279276	1678	13680400260000	13657	6731	69	0	\N
279277	1678	13680400261000	13657	6731	70	0	\N
279278	1678	13680400262000	13657	6731	71	0	\N
279279	1678	13680400263000	13657	6731	72	0	\N
279280	1678	13680400264000	13657	6731	73	0	\N
279281	1678	13680400265000	13657	6731	74	0	\N
279282	1678	13680400266000	13657	6731	75	0	\N
279283	1678	13680400267000	13657	6731	76	0	\N
279284	1678	13680400268000	13657	6731	77	0	\N
279285	1678	13680400269000	13657	6731	78	0	\N
279286	1678	13680400270000	13657	6731	79	0	\N
279287	1678	13680400271000	13657	6731	80	0	\N
279288	1678	13680400272000	13657	6731	81	0	\N
279289	1678	13680400273000	13657	6731	82	0	\N
279290	1678	13680400274000	13657	6731	83	0	\N
279291	1678	13680400275000	13657	6731	84	0	\N
279292	1678	13680400276000	13657	6731	85	0	\N
279293	1678	13680400277000	13657	6731	86	0	\N
279294	1678	13680400278000	13657	6731	87	0	\N
279295	1678	13680400279000	13657	6731	88	0	\N
279296	1678	13680400280000	13657	6731	89	0	\N
279297	1678	13680400281000	13657	6731	90	0	\N
279298	1678	13680400282000	13657	6731	91	0	\N
279299	1678	13680400283000	13657	6731	92	0	\N
279300	1678	13680400284000	13657	6731	93	0	\N
279301	1678	13680400285000	13657	6731	94	0	\N
279302	1678	13680400286000	13657	6731	95	0	\N
279303	1678	13680400287000	13657	6731	96	0	\N
279304	1678	13680400288000	13657	6731	97	0	\N
279305	1678	13680400289000	13657	6731	98	0	\N
279306	1678	13680400290000	13657	6731	99	0	\N
279307	1678	13680400291000	13657	6731	100	0	\N
279308	1678	13680400292000	13657	6731	101	0	\N
279309	1678	13680400293000	13657	6731	102	0	\N
279310	1678	13680400294000	13657	6731	103	0	\N
279311	1678	13680400295000	13657	6731	104	0	\N
279312	1678	13680400296000	13657	6731	105	0	\N
279313	1678	13680400297000	13657	6731	106	0	\N
279314	1678	13680400298000	13657	6731	107	0	\N
279315	1678	13680400299000	13657	6731	108	0	\N
279316	1678	13680400300000	13657	6731	109	0	\N
279317	1678	13680400301000	13657	6731	110	0	\N
279318	1678	13680400302000	13657	6731	111	0	\N
279319	1678	13680400303000	13657	6731	112	0	\N
279320	1678	13680400304000	13657	6731	113	0	\N
279321	1678	13680400305000	13657	6731	114	0	\N
279322	1678	13680400306000	13657	6731	115	0	\N
279323	1678	13680400307000	13657	6731	116	0	\N
279324	1678	13680400308000	13657	6731	117	0	\N
279325	1678	13680400309000	13657	6731	118	0	\N
279326	1678	13680400310000	13657	6731	119	0	\N
279327	1678	13680400311000	13657	6731	120	0	\N
279328	1678	13680400312000	13657	6731	121	0	\N
279329	1678	13680400313000	13657	6731	122	0	\N
279330	1678	13680400314000	13657	6731	123	0	\N
279331	1678	13680400315000	13657	6731	124	0	\N
279332	1678	13680400316000	13657	6731	125	0	\N
279333	1678	14400545640000	13659	7021	0	0	\N
279334	1678	14400545641000	13659	7021	1	0	\N
279335	1678	14400545642000	13659	7021	2	0	\N
279336	1678	14400545643000	13659	7021	3	0	\N
279337	1678	14400545644000	13659	7021	4	0	\N
279338	1874	1389000	13659	7021	5	0	\N
279339	1874	1390000	13659	7021	6	0	\N
279340	1874	1393000	13659	7021	7	0	\N
279341	1874	1396000	13659	7021	8	0	\N
279342	1874	1397000	13659	7021	9	0	\N
279343	1874	1400000	13659	7021	10	0	\N
279344	1874	1401000	13659	7021	11	0	\N
279345	1874	1404000	13659	7021	12	0	\N
279346	1874	1405000	13659	7021	13	0	\N
279347	1678	14400545640000	13660	7021	0	0	\N
279348	1678	14400545641000	13660	7021	1	0	\N
279349	1678	14400545642000	13660	7021	2	0	\N
279350	1678	14400545643000	13660	7021	3	0	\N
279351	1678	14400545644000	13660	7021	4	0	\N
279352	1874	1389000	13660	7021	5	0	\N
279353	1874	1390000	13660	7021	6	0	\N
279354	1874	1393000	13660	7021	7	0	\N
279355	1874	1396000	13660	7021	8	0	\N
279356	1874	1397000	13660	7021	9	0	\N
279357	1874	1400000	13660	7021	10	0	\N
279358	1874	1401000	13660	7021	11	0	\N
279359	1874	1404000	13660	7021	12	0	\N
279374	1388	1705861704351650	13662	7022	0	0	\N
279375	1678	14400545645000	13662	7022	1	0	\N
279376	1678	14400545646000	13662	7022	2	0	\N
279377	1142	907292755600000	13662	7022	3	0	\N
279378	1262	612167826200000	13662	7022	4	0	\N
279379	1022	506305064000000	13662	7022	5	0	\N
279380	1678	14400545647000	13662	7022	6	0	\N
279381	1678	14400545648000	13662	7022	7	0	\N
279382	1874	1405000	13662	7022	8	0	\N
279383	1874	1408000	13662	7022	9	0	\N
279384	1874	1409000	13662	7022	10	0	\N
279385	1874	1412000	13662	7022	11	0	\N
279386	1874	1413000	13662	7022	12	0	\N
279387	1874	1416000	13662	7022	13	0	\N
279388	1874	1417000	13662	7022	14	0	\N
279389	1874	1420000	13662	7022	15	0	\N
279390	1874	1421000	13662	7022	16	0	\N
279391	1388	1705861704351650	13663	7022	0	0	\N
279392	1678	14400545645000	13663	7022	1	0	\N
279393	1678	14400545646000	13663	7022	2	0	\N
279394	1142	907292755600000	13663	7022	3	0	\N
279395	1262	612167826200000	13663	7022	4	0	\N
279396	1022	506305064000000	13663	7022	5	0	\N
279397	1678	14400545647000	13663	7022	6	0	\N
279398	1678	14400545648000	13663	7022	7	0	\N
279399	1874	1405000	13663	7022	8	0	\N
279400	1874	1408000	13663	7022	9	0	\N
279401	1874	1409000	13663	7022	10	0	\N
279402	1874	1412000	13663	7022	11	0	\N
279403	1874	1413000	13663	7022	12	0	\N
279404	1874	1416000	13663	7022	13	0	\N
279405	1874	1417000	13663	7022	14	0	\N
279406	1874	1420000	13663	7022	15	0	\N
279407	1874	1421000	13663	7022	16	0	\N
279427	1678	14400545649000	13667	7023	0	0	\N
279428	1874	1424000	13667	7023	1	0	\N
279429	1874	1425000	13667	7023	2	0	\N
279430	1874	1424000	13668	7023	0	0	\N
279431	1678	14400545650000	13669	7024	0	0	\N
279432	1874	1428000	13669	7024	1	0	\N
279433	1874	1429000	13669	7024	2	0	\N
279437	1678	14400545649000	13671	7024	0	0	\N
279438	1874	1425000	13671	7024	1	0	\N
279444	1678	14400545652000	13674	7026	0	0	\N
279445	1874	1433000	13674	7026	1	0	\N
279446	1874	1436000	13674	7026	2	0	\N
279447	1678	14400545653000	13675	7027	0	0	\N
279448	1874	1437000	13675	7027	1	0	\N
279449	1874	1440000	13675	7027	2	0	\N
279456	1678	14400545655000	13678	7029	0	0	\N
279457	1874	1445000	13678	7029	1	0	\N
279458	1874	1448000	13678	7029	2	0	\N
279464	1678	14400545656000	13681	7030	0	0	\N
279465	1874	1451000	13681	7030	1	0	\N
279466	1678	14400545656000	13682	7030	0	0	\N
279467	1874	1451000	13682	7030	1	0	\N
279475	1678	14400545660000	13684	7032	0	0	\N
279476	1874	1463000	13684	7032	1	0	\N
279477	1678	14400545660000	13685	7032	0	0	\N
279478	1874	1463000	13685	7032	1	0	\N
279362	1678	14400545642000	13661	7021	2	0	0
279363	1678	14400545643000	13661	7021	3	0	0
279364	1678	14400545644000	13661	7021	4	0	0
279365	1874	1389000	13661	7021	5	0	1
279366	1874	1390000	13661	7021	6	0	1
279368	1874	1396000	13661	7021	8	0	1
279369	1874	1397000	13661	7021	9	0	1
279370	1874	1400000	13661	7021	10	0	1
279371	1874	1401000	13661	7021	11	0	1
279372	1874	1404000	13661	7021	12	0	1
279408	1388	1705861704351650	13664	7022	0	0	0
279409	1678	14400545645000	13664	7022	1	0	0
279410	1678	14400545646000	13664	7022	2	0	0
279411	1142	907292755600000	13664	7022	3	0	0
279413	1022	506305064000000	13664	7022	5	0	0
279414	1678	14400545647000	13664	7022	6	0	0
279415	1678	14400545648000	13664	7022	7	0	0
279416	1874	1408000	13664	7022	8	0	1
279417	1874	1409000	13664	7022	9	0	1
279419	1874	1413000	13664	7022	11	0	1
279420	1874	1416000	13664	7022	12	0	1
279421	1874	1417000	13664	7022	13	0	1
279422	1874	1420000	13664	7022	14	0	1
279423	1874	1421000	13664	7022	15	0	1
279425	1874	1424000	13666	7023	1	0	1
279426	1874	1425000	13666	7023	2	0	1
279434	1678	14400545650000	13670	7024	0	0	0
279435	1874	1428000	13670	7024	1	0	1
279439	1678	14400545651000	13672	7025	0	0	0
279440	1874	1432000	13672	7025	1	0	1
279441	1678	14400545652000	13673	7026	0	0	0
279442	1874	1433000	13673	7026	1	0	1
279443	1874	1436000	13673	7026	2	0	1
279451	1874	1437000	13676	7027	1	0	1
279452	1874	1440000	13676	7027	2	0	1
279453	1678	14400545654000	13677	7028	0	0	0
279454	1874	1441000	13677	7028	1	0	1
279455	1874	1444000	13677	7028	2	0	1
279460	1874	1445000	13679	7029	1	0	1
279461	1874	1448000	13679	7029	2	0	1
279462	1678	14400545656000	13680	7030	0	0	0
279463	1874	1451000	13680	7030	1	0	1
279469	1678	14400545658000	13683	7031	1	0	0
279470	1678	14400545659000	13683	7031	2	0	0
279471	887	268788225365154	13683	7031	3	0	0
279472	1874	1454000	13683	7031	4	0	1
279473	1874	1457000	13683	7031	5	0	1
279479	1678	14400545660000	13686	7032	0	0	0
279480	1874	1463000	13686	7032	1	0	1
279481	1678	14400545660000	13687	7032	0	0	\N
279482	1874	1463000	13687	7032	1	0	\N
279483	889	225633308357249	13688	7033	0	0	\N
279484	1874	1466000	13688	7033	1	0	\N
279487	1678	14400545661000	13690	7034	0	0	\N
279488	1874	1469000	13690	7034	1	0	\N
279491	1678	14400545662000	13692	7035	0	0	\N
279492	1678	14400545663000	13692	7035	1	0	\N
279493	1874	1472000	13692	7035	2	0	\N
279494	1874	1475000	13692	7035	3	0	\N
279499	2047	40500000	13694	6952	1	0	\N
279500	1388	1705861704351650	13694	6952	3	0	\N
279501	1678	14400545581000	13694	6952	4	0	\N
279502	887	268788225365154	13694	6952	5	0	\N
279503	1142	907292755600000	13694	6952	6	0	\N
279504	1262	612167826200000	13694	6952	7	0	\N
279505	1022	506305064000000	13694	6952	8	0	\N
279506	1678	14400545582000	13694	6952	9	0	\N
279507	1678	14400545583000	13694	6952	10	0	\N
279508	1678	14400545584000	13694	6952	11	0	\N
279509	1678	14400545585000	13694	6952	12	0	\N
279510	1678	14400545586000	13694	6952	13	0	\N
279511	1678	14400545587000	13694	6952	14	0	\N
279512	1678	14400545588000	13694	6952	15	0	\N
279513	1678	14400545589000	13694	6952	16	0	\N
279514	1678	14400545590000	13694	6952	17	0	\N
279515	1678	14400545591000	13694	6952	18	0	\N
279516	1678	14400545592000	13694	6952	19	0	\N
279517	1678	14400545593000	13694	6952	20	0	\N
279518	1678	14400545594000	13694	6952	21	0	\N
279519	1678	14400545595000	13694	6952	22	0	\N
279520	1678	14400545596000	13694	6952	23	0	\N
279521	1678	14400545597000	13694	6952	24	0	\N
279522	1678	14400545598000	13694	6952	25	0	\N
279523	1678	14400545599000	13694	6952	26	0	\N
279524	1678	14400545600000	13694	6952	27	0	\N
279525	1678	14400545601000	13694	6952	28	0	\N
279526	1678	14400545602000	13694	6952	29	0	\N
279527	1678	14400545603000	13694	6952	30	0	\N
279528	1678	14400545604000	13694	6952	31	0	\N
279529	1678	14400545605000	13694	6952	32	0	\N
279530	1678	14400545606000	13694	6952	33	0	\N
279531	1678	14400545607000	13694	6952	34	0	\N
279532	1678	14400545608000	13694	6952	35	0	\N
279533	1678	14400545609000	13694	6952	36	0	\N
279534	1678	14400545610000	13694	6952	37	0	\N
279535	1678	14400545611000	13694	6952	38	0	\N
279536	1678	14400545612000	13694	6952	39	0	\N
279537	889	225633308357249	13694	6952	40	0	\N
279538	1678	14400545613000	13694	6952	42	0	\N
279539	1678	14400545614000	13694	6952	43	0	\N
279540	1678	14400545615000	13694	6952	44	0	\N
279541	1678	14400545616000	13694	6952	45	0	\N
279542	1678	14400545617000	13694	6952	46	0	\N
279543	1678	14400545618000	13694	6952	47	0	\N
279544	1678	14400545619000	13694	6952	48	0	\N
279545	1678	14400545620000	13694	6952	49	0	\N
279546	1678	14400545621000	13694	6952	50	0	\N
279547	1678	14400545622000	13694	6952	51	0	\N
279548	1678	14400545623000	13694	6952	52	0	\N
279549	1678	14400545624000	13694	6952	53	0	\N
279550	1678	14400545625000	13694	6952	54	0	\N
279551	1678	14400545626000	13694	6952	55	0	\N
279552	1678	14400545627000	13694	6952	56	0	\N
279553	1678	14400545628000	13694	6952	57	0	\N
279554	1678	14400545629000	13694	6952	58	0	\N
279555	1678	14400545630000	13694	6952	59	0	\N
279556	1678	14400545631000	13694	6952	60	0	\N
279557	1678	14400545632000	13694	6952	61	0	\N
279558	1678	14400545633000	13694	6952	62	0	\N
279559	1678	14400545634000	13694	6952	63	0	\N
279560	1678	14400545635000	13694	6952	64	0	\N
279561	1678	14400545636000	13694	6952	65	0	\N
279562	1678	14400545637000	13694	6952	66	0	\N
279563	1678	14400545638000	13694	6952	67	0	\N
279564	1678	14400545639000	13694	6952	68	0	\N
279565	1678	14400545640000	13694	6952	69	0	\N
279566	1678	14400545641000	13694	6952	70	0	\N
279567	1678	14400545642000	13694	6952	71	0	\N
279568	1678	14400545643000	13694	6952	72	0	\N
279569	1678	14400545644000	13694	6952	73	0	\N
279570	1678	14400545645000	13694	6952	74	0	\N
279571	1678	14400545646000	13694	6952	75	0	\N
279572	1678	14400545647000	13694	6952	76	0	\N
279573	1678	14400545648000	13694	6952	77	0	\N
279574	1678	14400545649000	13694	6952	78	0	\N
279575	1678	14400545650000	13694	6952	79	0	\N
279576	1678	14400545651000	13694	6952	80	0	\N
279577	1678	14400545652000	13694	6952	81	0	\N
279578	1678	14400545653000	13694	6952	82	0	\N
279579	1678	14400545654000	13694	6952	83	0	\N
279580	1678	14400545655000	13694	6952	84	0	\N
279581	1678	14400545656000	13694	6952	85	0	\N
279582	1678	14400545657000	13694	6952	86	0	\N
279583	1678	14400545658000	13694	6952	87	0	\N
279584	1678	14400545659000	13694	6952	88	0	\N
279591	1678	14400545667000	13696	7037	0	0	\N
279592	1874	1487000	13696	7037	1	0	\N
279601	1678	14400545670000	13701	7040	0	0	\N
279602	1874	1496000	13701	7040	1	0	\N
279607	1678	14400545671000	13703	7041	0	0	\N
279608	1678	14400545672000	13703	7041	1	0	\N
279609	1874	1499000	13703	7041	2	0	\N
279610	1874	1502000	13703	7041	3	0	\N
279611	2047	40500000	13704	6907	0	0	\N
279612	1388	1705861704351650	13704	6907	2	0	\N
279613	887	268788225365154	13704	6907	3	0	\N
279614	1142	907292755600000	13704	6907	4	0	\N
279615	1262	612167826200000	13704	6907	5	0	\N
279616	1022	506305064000000	13704	6907	6	0	\N
279489	1678	14400545661000	13691	7034	0	0	0
279490	1874	1469000	13691	7034	1	0	1
279495	1678	14400545662000	13693	7035	0	0	0
279496	1678	14400545663000	13693	7035	1	0	0
279497	1874	1472000	13693	7035	2	0	1
279585	1678	14400545664000	13695	7036	0	0	0
279586	1678	14400545665000	13695	7036	1	0	0
279587	1678	14400545666000	13695	7036	2	0	0
279588	1874	1478000	13695	7036	3	0	1
279589	1874	1481000	13695	7036	4	0	1
279593	1678	14400545667000	13697	7037	0	0	0
279594	1874	1487000	13697	7037	1	0	1
279595	1678	14400545668000	13698	7038	0	0	0
279596	1874	1490000	13698	7038	1	0	1
279598	1874	1493000	13699	7039	1	0	1
279599	1678	14400545670000	13700	7040	0	0	0
279600	1874	1496000	13700	7040	1	0	1
279603	1678	14400545671000	13702	7041	0	0	0
279604	1678	14400545672000	13702	7041	1	0	0
279606	1874	1502000	13702	7041	3	0	1
279617	169	66178742095387	13704	6907	7	0	\N
279618	990	504145483631720	13704	6907	8	0	\N
279619	1110	903424387149520	13704	6907	9	0	\N
279620	1230	609558436012355	13704	6907	10	0	\N
279621	1356	1698588780862630	13704	6907	11	0	\N
279622	889	225633308357249	13704	6907	12	0	\N
279623	1653	8000000	13704	6907	13	0	\N
279624	1653	8000000	13704	6907	14	0	\N
279637	1678	14400545678000	13709	7046	0	0	\N
279638	1874	1522000	13709	7046	1	0	\N
279639	1874	1523000	13709	7046	2	0	\N
279640	1874	1526000	13709	7046	3	0	\N
279641	1678	14400545678000	13710	7046	0	0	\N
279642	1874	1522000	13710	7046	1	0	\N
279643	1874	1523000	13710	7046	2	0	\N
279644	1874	1526000	13710	7046	3	0	\N
279645	1678	14400545678000	13711	7046	0	0	\N
279646	1874	1522000	13711	7046	1	0	\N
279647	1874	1523000	13711	7046	2	0	\N
279648	1874	1526000	13711	7046	3	0	\N
279662	2099	500000000	13714	7047	0	0	\N
279663	1678	14400545679000	13714	7047	1	0	\N
279664	1678	14400545680000	13714	7047	2	0	\N
279665	1874	1528000	13714	7047	3	0	\N
279666	1874	1529000	13714	7047	4	0	\N
279667	1874	1532000	13714	7047	5	0	\N
279668	1874	1534000	13714	7047	6	0	\N
279669	1874	1535000	13714	7047	7	0	\N
279670	1874	1538000	13714	7047	8	0	\N
279696	1678	14400545687000	13718	7051	0	0	\N
279697	1874	1574000	13718	7051	1	0	\N
279698	1874	1576000	13718	7051	2	0	\N
279699	1874	1577000	13718	7051	3	0	\N
279704	1678	14400545687000	13720	7051	0	0	\N
279705	1874	1574000	13720	7051	1	0	\N
279706	1874	1576000	13720	7051	2	0	\N
279707	1874	1577000	13720	7051	3	0	\N
279708	1678	14400545688000	13721	7052	0	0	\N
279709	1874	1580000	13721	7052	1	0	\N
279710	1874	1582000	13721	7052	2	0	\N
279711	1874	1583000	13721	7052	3	0	\N
279725	1678	14400545690000	13725	7054	0	0	\N
279726	1874	1592000	13725	7054	1	0	\N
279727	1874	1594000	13725	7054	2	0	\N
279728	1874	1595000	13725	7054	3	0	\N
279729	631	66000801000000	13725	7054	4	0	\N
279730	1678	14400545691000	13726	7055	0	0	\N
279731	1874	1598000	13726	7055	1	0	\N
279732	1874	1600000	13726	7055	2	0	\N
279733	1874	1601000	13726	7055	3	0	\N
279742	1678	14400545692000	13729	7056	0	0	\N
279743	1874	1598000	13729	7056	1	0	\N
279744	1874	1600000	13729	7056	2	0	\N
279745	1874	1601000	13729	7056	3	0	\N
279746	1874	1604000	13729	7056	4	0	\N
279747	1874	1606000	13729	7056	5	0	\N
279748	1874	1607000	13729	7056	6	0	\N
279627	1678	14400545674000	13706	7043	0	0	0
279628	1678	14400545675000	13706	7043	1	0	0
279629	1874	1508000	13706	7043	2	0	1
279630	1874	1511000	13706	7043	3	0	1
279631	1678	14400545676000	13707	7044	0	0	0
279633	1678	14400545677000	13708	7045	0	0	0
279634	1874	1516000	13708	7045	1	0	1
279635	1874	1517000	13708	7045	2	0	1
279636	1874	1520000	13708	7045	3	0	1
279649	1678	14400545678000	13712	7046	0	0	0
279651	1874	1523000	13712	7046	2	0	1
279652	1874	1526000	13712	7046	3	0	1
279653	2099	500000000	13713	7047	0	0	0
279654	1678	14400545679000	13713	7047	1	0	0
279656	1874	1528000	13713	7047	3	0	1
279657	1874	1529000	13713	7047	4	0	1
279658	1874	1532000	13713	7047	5	0	1
279659	1874	1534000	13713	7047	6	0	1
279660	1874	1535000	13713	7047	7	0	1
279671	2099	718500000000	13715	7048	0	0	0
279672	1678	14400545681000	13715	7048	1	0	0
279673	1678	14400545682000	13715	7048	2	0	0
279674	1874	1540000	13715	7048	3	0	1
279675	1874	1541000	13715	7048	4	0	1
279677	1874	1546000	13715	7048	6	0	1
279678	1874	1547000	13715	7048	7	0	1
279679	1874	1550000	13715	7048	8	0	1
279680	1678	14400545683000	13716	7049	0	0	0
279682	1874	1552000	13716	7049	2	0	1
279683	1874	1553000	13716	7049	3	0	1
279684	1874	1556000	13716	7049	4	0	1
279685	1874	1558000	13716	7049	5	0	1
279686	1874	1559000	13716	7049	6	0	1
279688	631	66000801000000	13716	7049	8	0	2
279689	1678	14400545685000	13717	7050	0	0	0
279690	1678	14400545686000	13717	7050	1	0	0
279691	1874	1564000	13717	7050	2	0	1
279692	1874	1565000	13717	7050	3	0	1
279694	1874	1570000	13717	7050	5	0	1
279695	1874	1571000	13717	7050	6	0	1
279700	1678	14400545687000	13719	7051	0	0	0
279701	1874	1574000	13719	7051	1	0	1
279703	1874	1577000	13719	7051	3	0	1
279712	1678	14400545688000	13722	7052	0	0	0
279713	1874	1580000	13722	7052	1	0	1
279714	1874	1582000	13722	7052	2	0	1
279715	1874	1583000	13722	7052	3	0	1
279717	1874	1586000	13723	7053	1	0	1
279718	1874	1588000	13723	7053	2	0	1
279719	1874	1589000	13723	7053	3	0	1
279720	1678	14400545690000	13724	7054	0	0	0
279721	1874	1592000	13724	7054	1	0	1
279723	1874	1595000	13724	7054	3	0	1
279724	631	66000801000000	13724	7054	4	0	2
279734	1678	14400545691000	13727	7055	0	0	0
279735	1678	14400545692000	13728	7056	0	0	0
279737	1874	1600000	13728	7056	2	0	1
279738	1874	1601000	13728	7056	3	0	1
279739	1874	1604000	13728	7056	4	0	1
279740	1874	1606000	13728	7056	5	0	1
279741	1874	1607000	13728	7056	6	0	1
279750	1874	1610000	13730	7057	1	0	1
279751	1874	1612000	13730	7057	2	0	1
279752	1874	1613000	13730	7057	3	0	1
279757	1678	14400545695000	13732	7059	0	0	\N
279758	1874	1622000	13732	7059	1	0	\N
279759	1874	1624000	13732	7059	2	0	\N
279760	1874	1625000	13732	7059	3	0	\N
279765	1678	14400545695000	13734	7059	0	0	\N
279766	1874	1622000	13734	7059	1	0	\N
279767	1874	1624000	13734	7059	2	0	\N
279768	1874	1625000	13734	7059	3	0	\N
279769	1678	14400545695000	13735	7059	0	0	\N
279770	1874	1622000	13735	7059	1	0	\N
279771	1874	1624000	13735	7059	2	0	\N
279772	1678	14400545696000	13736	7060	0	0	\N
279773	1874	1628000	13736	7060	1	0	\N
279774	1874	1630000	13736	7060	2	0	\N
279778	1678	14400545697000	13738	7061	0	0	\N
279779	1874	1631000	13738	7061	1	0	\N
279780	1874	1634000	13738	7061	2	0	\N
279781	1874	1636000	13738	7061	3	0	\N
279786	1678	14400545697000	13740	7061	0	0	\N
279787	1874	1631000	13740	7061	1	0	\N
279788	1874	1634000	13740	7061	2	0	\N
279789	1874	1636000	13740	7061	3	0	\N
279810	1678	14400545698000	13742	7062	0	0	\N
279811	1678	14400545699000	13742	7062	1	0	\N
279812	1678	14400545700000	13742	7062	2	0	\N
279813	1678	14400545701000	13742	7062	3	0	\N
279814	1678	14400545702000	13742	7062	4	0	\N
279815	1874	1637000	13742	7062	5	0	\N
279816	1874	1640000	13742	7062	6	0	\N
279817	1874	1642000	13742	7062	7	0	\N
279818	1874	1643000	13742	7062	8	0	\N
279819	1874	1646000	13742	7062	9	0	\N
279820	1874	1648000	13742	7062	10	0	\N
279821	1874	1649000	13742	7062	11	0	\N
279822	1874	1652000	13742	7062	12	0	\N
279823	1874	1654000	13742	7062	13	0	\N
279824	1874	1655000	13742	7062	14	0	\N
279825	1874	1658000	13742	7062	15	0	\N
279826	1874	1660000	13742	7062	16	0	\N
279827	1874	1661000	13742	7062	17	0	\N
279828	1874	1664000	13742	7062	18	0	\N
279829	1874	1666000	13742	7062	19	0	\N
279830	1678	14400545698000	13743	7062	0	0	\N
279831	1678	14400545699000	13743	7062	1	0	\N
279832	1678	14400545700000	13743	7062	2	0	\N
279833	1678	14400545701000	13743	7062	3	0	\N
279834	1678	14400545702000	13743	7062	4	0	\N
279835	1874	1637000	13743	7062	5	0	\N
279836	1874	1640000	13743	7062	6	0	\N
279837	1874	1642000	13743	7062	7	0	\N
279838	1874	1643000	13743	7062	8	0	\N
279839	1874	1646000	13743	7062	9	0	\N
279840	1874	1648000	13743	7062	10	0	\N
279841	1874	1649000	13743	7062	11	0	\N
279842	1874	1652000	13743	7062	12	0	\N
279843	1874	1654000	13743	7062	13	0	\N
279844	1874	1655000	13743	7062	14	0	\N
279845	1874	1658000	13743	7062	15	0	\N
279846	1874	1660000	13743	7062	16	0	\N
279847	1874	1661000	13743	7062	17	0	\N
279848	1874	1664000	13743	7062	18	0	\N
279849	1874	1666000	13743	7062	19	0	\N
279850	1678	14400545698000	13744	7062	0	0	\N
279851	1678	14400545699000	13744	7062	1	0	\N
279852	1678	14400545700000	13744	7062	2	0	\N
279853	1678	14400545701000	13744	7062	3	0	\N
279854	1678	14400545702000	13744	7062	4	0	\N
279855	1874	1637000	13744	7062	5	0	\N
279856	1874	1640000	13744	7062	6	0	\N
279857	1874	1642000	13744	7062	7	0	\N
279858	1874	1643000	13744	7062	8	0	\N
279859	1874	1646000	13744	7062	9	0	\N
279860	1874	1648000	13744	7062	10	0	\N
279861	1874	1649000	13744	7062	11	0	\N
279862	1874	1652000	13744	7062	12	0	\N
279863	1874	1654000	13744	7062	13	0	\N
279864	1874	1655000	13744	7062	14	0	\N
279865	1874	1658000	13744	7062	15	0	\N
279866	1874	1660000	13744	7062	16	0	\N
279867	1874	1661000	13744	7062	17	0	\N
279868	1874	1664000	13744	7062	18	0	\N
279869	1874	1666000	13744	7062	19	0	\N
279870	1678	14400545698000	13745	7062	0	0	\N
279871	1678	14400545699000	13745	7062	1	0	\N
279872	1678	14400545700000	13745	7062	2	0	\N
279873	1678	14400545701000	13745	7062	3	0	\N
279874	1678	14400545702000	13745	7062	4	0	\N
279879	1678	14400545703000	13747	7063	0	0	\N
279880	1678	14400545704000	13748	7064	0	0	\N
279881	1678	14400545705000	13748	7064	1	0	\N
279882	1874	1673000	13748	7064	2	0	\N
279883	1874	1676000	13748	7064	3	0	\N
279884	1874	1678000	13748	7064	4	0	\N
279885	1874	1679000	13748	7064	5	0	\N
279886	1874	1682000	13748	7064	6	0	\N
279755	1874	1618000	13731	7058	2	0	1
279756	1874	1619000	13731	7058	3	0	1
279761	1678	14400545695000	13733	7059	0	0	0
279762	1874	1622000	13733	7059	1	0	1
279763	1874	1624000	13733	7059	2	0	1
279775	1678	14400545696000	13737	7060	0	0	0
279776	1874	1628000	13737	7060	1	0	1
279777	1874	1630000	13737	7060	2	0	1
279782	1678	14400545697000	13739	7061	0	0	0
279783	1874	1631000	13739	7061	1	0	1
279785	1874	1636000	13739	7061	3	0	1
279790	1678	14400545698000	13741	7062	0	0	0
279791	1678	14400545699000	13741	7062	1	0	0
279792	1678	14400545700000	13741	7062	2	0	0
279794	1678	14400545702000	13741	7062	4	0	0
279795	1874	1637000	13741	7062	5	0	1
279796	1874	1640000	13741	7062	6	0	1
279797	1874	1642000	13741	7062	7	0	1
279798	1874	1643000	13741	7062	8	0	1
279800	1874	1648000	13741	7062	10	0	1
279801	1874	1649000	13741	7062	11	0	1
279802	1874	1652000	13741	7062	12	0	1
279803	1874	1654000	13741	7062	13	0	1
279804	1874	1655000	13741	7062	14	0	1
279806	1874	1660000	13741	7062	16	0	1
279807	1874	1661000	13741	7062	17	0	1
279808	1874	1664000	13741	7062	18	0	1
279809	1874	1666000	13741	7062	19	0	1
279876	1874	1667000	13746	7063	1	0	1
279877	1874	1670000	13746	7063	2	0	1
279878	1874	1672000	13746	7063	3	0	1
279887	1678	14400545704000	13749	7064	0	0	0
279888	1678	14400545705000	13749	7064	1	0	0
279894	1678	14400545706000	13750	7065	0	0	\N
279895	1874	1684000	13750	7065	1	0	\N
279896	1874	1685000	13750	7065	2	0	\N
279897	1874	1688000	13750	7065	3	0	\N
279898	1874	1690000	13750	7065	4	0	\N
279899	1874	1691000	13750	7065	5	0	\N
279900	1874	1694000	13750	7065	6	0	\N
279916	1678	14400545708000	13754	7067	0	0	\N
279917	1874	1702000	13754	7067	1	0	\N
279918	1874	1703000	13754	7067	2	0	\N
279919	1874	1706000	13754	7067	3	0	\N
279924	1678	14400545710000	13756	7069	0	0	\N
279925	1678	14400545711000	13756	7069	1	0	\N
279926	1874	1714000	13756	7069	2	0	\N
279927	1874	1715000	13756	7069	3	0	\N
279928	1874	1718000	13756	7069	4	0	\N
279929	1874	1720000	13756	7069	5	0	\N
279930	1874	1721000	13756	7069	6	0	\N
279931	1874	1724000	13756	7069	7	0	\N
279940	1678	14400545710000	13758	7069	0	0	\N
279941	1678	14400545711000	13758	7069	1	0	\N
279942	1874	1714000	13758	7069	2	0	\N
279943	1874	1715000	13758	7069	3	0	\N
279944	1874	1718000	13758	7069	4	0	\N
279945	1874	1720000	13758	7069	5	0	\N
279946	1874	1721000	13758	7069	6	0	\N
279947	1874	1724000	13758	7069	7	0	\N
279948	1678	14400545710000	13759	7069	0	0	\N
279949	1678	14400545711000	13759	7069	1	0	\N
279950	1874	1714000	13759	7069	2	0	\N
279951	1874	1715000	13759	7069	3	0	\N
279952	1874	1718000	13759	7069	4	0	\N
279953	1874	1720000	13759	7069	5	0	\N
279954	1874	1721000	13759	7069	6	0	\N
279955	1874	1724000	13759	7069	7	0	\N
279956	1678	14400545710000	13760	7069	0	0	\N
279957	1678	14400545711000	13760	7069	1	0	\N
279958	1874	1714000	13760	7069	2	0	\N
279959	1678	14400545712000	13761	7070	0	0	\N
279964	1678	14400545713000	13763	7071	0	0	\N
279965	1874	1732000	13763	7071	1	0	\N
279966	1874	1733000	13763	7071	2	0	\N
279967	1874	1736000	13763	7071	3	0	\N
279976	1678	14400545714000	13766	7072	0	0	\N
279977	1874	1738000	13766	7072	1	0	\N
279978	1874	1739000	13766	7072	2	0	\N
279979	1874	1742000	13766	7072	3	0	\N
279992	1678	14400545716000	13769	7074	0	0	\N
279993	1678	14400545717000	13769	7074	1	0	\N
279994	1874	1750000	13769	7074	2	0	\N
279995	1874	1751000	13769	7074	3	0	\N
279996	1874	1754000	13769	7074	4	0	\N
279997	1874	1756000	13769	7074	5	0	\N
279998	1874	1757000	13769	7074	6	0	\N
279999	1874	1760000	13769	7074	7	0	\N
280000	1678	14400545718000	13770	7075	0	0	\N
280009	1678	14400545719000	13773	7076	0	0	\N
280010	1874	1768000	13773	7076	1	0	\N
280011	1874	1769000	13773	7076	2	0	\N
280012	1874	1772000	13773	7076	3	0	\N
280013	1678	14400545720000	13776	7078	0	0	\N
280014	1678	14400545721000	13776	7078	1	0	\N
280015	1678	14400545722000	13776	7078	2	0	\N
280016	1678	14400545723000	13776	7078	3	0	\N
280017	1874	1774000	13776	7078	4	0	\N
280018	1874	1775000	13776	7078	5	0	\N
280019	1874	1778000	13776	7078	6	0	\N
280020	1874	1780000	13776	7078	7	0	\N
280021	1874	1781000	13776	7078	8	0	\N
280022	1874	1784000	13776	7078	9	0	\N
280023	1874	1786000	13776	7078	10	0	\N
280024	1874	1787000	13776	7078	11	0	\N
279891	1874	1678000	13749	7064	4	0	1
279892	1874	1679000	13749	7064	5	0	1
279893	1874	1682000	13749	7064	6	0	1
279901	1678	14400545706000	13751	7065	0	0	0
279902	1874	1684000	13751	7065	1	0	1
279904	1874	1688000	13751	7065	3	0	1
279905	1874	1690000	13751	7065	4	0	1
279906	1874	1691000	13751	7065	5	0	1
279907	1874	1694000	13751	7065	6	0	1
279908	1678	14400545707000	13752	7066	0	0	0
279910	1874	1697000	13752	7066	2	0	1
279911	1874	1700000	13752	7066	3	0	1
279912	1678	14400545708000	13753	7067	0	0	0
279913	1874	1702000	13753	7067	1	0	1
279915	1874	1706000	13753	7067	3	0	1
279920	1678	14400545709000	13755	7068	0	0	0
279921	1874	1708000	13755	7068	1	0	1
279922	1874	1709000	13755	7068	2	0	1
279923	1874	1712000	13755	7068	3	0	1
279933	1678	14400545711000	13757	7069	1	0	0
279934	1874	1714000	13757	7069	2	0	1
279935	1874	1715000	13757	7069	3	0	1
279936	1874	1718000	13757	7069	4	0	1
279937	1874	1720000	13757	7069	5	0	1
279939	1874	1724000	13757	7069	7	0	1
279960	1678	14400545712000	13762	7070	0	0	0
279961	1874	1726000	13762	7070	1	0	1
279962	1874	1727000	13762	7070	2	0	1
279968	1678	14400545713000	13764	7071	0	0	0
279969	1874	1732000	13764	7071	1	0	1
279970	1874	1733000	13764	7071	2	0	1
279971	1874	1736000	13764	7071	3	0	1
279972	1678	14400545714000	13765	7072	0	0	0
279974	1874	1739000	13765	7072	2	0	1
279975	1874	1742000	13765	7072	3	0	1
279980	1678	14400545715000	13767	7073	0	0	0
279981	1874	1744000	13767	7073	1	0	1
279982	1874	1745000	13767	7073	2	0	1
279984	1678	14400545716000	13768	7074	0	0	0
279985	1678	14400545717000	13768	7074	1	0	0
279986	1874	1750000	13768	7074	2	0	1
279987	1874	1751000	13768	7074	3	0	1
279989	1874	1756000	13768	7074	5	0	1
279990	1874	1757000	13768	7074	6	0	1
279991	1874	1760000	13768	7074	7	0	1
280001	1678	14400545718000	13771	7075	0	0	0
280002	1874	1762000	13771	7075	1	0	1
280004	1874	1766000	13771	7075	3	0	1
280005	1678	14400545719000	13772	7076	0	0	0
280006	1874	1768000	13772	7076	1	0	1
280007	1874	1769000	13772	7076	2	0	1
280008	1874	1772000	13772	7076	3	0	1
280025	1874	1790000	13776	7078	12	0	\N
280026	1874	1792000	13776	7078	13	0	\N
280027	1874	1793000	13776	7078	14	0	\N
280028	1874	1796000	13776	7078	15	0	\N
280045	2099	500000000	13781	7030	0	0	\N
280046	2099	718500000000	13781	7030	1	0	\N
280047	1678	14400545656000	13781	7030	2	0	\N
280048	1678	14400545657000	13781	7030	3	0	\N
280049	1678	14400545658000	13781	7030	4	0	\N
280050	1678	14400545659000	13781	7030	5	0	\N
280051	887	268788225365154	13781	7030	6	0	\N
280052	1678	14400545660000	13781	7030	7	0	\N
280053	1678	14400545661000	13781	7030	8	0	\N
280054	1678	14400545662000	13781	7030	9	0	\N
280055	1678	14400545663000	13781	7030	10	0	\N
280056	889	225633308357249	13781	7030	11	0	\N
280057	1678	14400545664000	13781	7030	12	0	\N
280058	1678	14400545665000	13781	7030	13	0	\N
280059	1678	14400545666000	13781	7030	14	0	\N
280060	1678	14400545667000	13781	7030	15	0	\N
280061	1678	14400545668000	13781	7030	16	0	\N
280062	1678	14400545669000	13781	7030	17	0	\N
280063	1678	14400545670000	13781	7030	18	0	\N
280064	1678	14400545671000	13781	7030	19	0	\N
280065	1678	14400545672000	13781	7030	20	0	\N
280066	1678	14400545673000	13781	7030	21	0	\N
280067	1678	14400545674000	13781	7030	22	0	\N
280068	1678	14400545675000	13781	7030	23	0	\N
280069	1678	14400545676000	13781	7030	24	0	\N
280070	1678	14400545677000	13781	7030	25	0	\N
280071	1678	14400545678000	13781	7030	26	0	\N
280072	1678	14400545679000	13781	7030	27	0	\N
280073	1678	14400545680000	13781	7030	28	0	\N
280074	1678	14400545681000	13781	7030	29	0	\N
280075	1678	14400545682000	13781	7030	30	0	\N
280076	1678	14400545683000	13781	7030	31	0	\N
280077	1678	14400545684000	13781	7030	32	0	\N
280078	1678	14400545685000	13781	7030	33	0	\N
280079	1678	14400545686000	13781	7030	34	0	\N
280080	1678	14400545687000	13781	7030	35	0	\N
280081	1678	14400545688000	13781	7030	36	0	\N
280082	1678	14400545689000	13781	7030	37	0	\N
280083	1678	14400545690000	13781	7030	38	0	\N
280084	1678	14400545691000	13781	7030	39	0	\N
280085	1678	14400545692000	13781	7030	40	0	\N
280086	1678	14400545693000	13781	7030	41	0	\N
280087	1678	14400545694000	13781	7030	42	0	\N
280088	1678	14400545695000	13781	7030	43	0	\N
280089	1678	14400545696000	13781	7030	44	0	\N
280090	1678	14400545697000	13781	7030	45	0	\N
280091	1678	14400545698000	13781	7030	46	0	\N
280092	1678	14400545699000	13781	7030	47	0	\N
280093	1678	14400545700000	13781	7030	48	0	\N
280094	1678	14400545701000	13781	7030	49	0	\N
280095	1678	14400545702000	13781	7030	50	0	\N
280096	1678	14400545703000	13781	7030	51	0	\N
280097	1678	14400545704000	13781	7030	52	0	\N
280098	1678	14400545705000	13781	7030	53	0	\N
280099	1678	14400545706000	13781	7030	54	0	\N
280100	1678	14400545707000	13781	7030	55	0	\N
280101	1678	14400545708000	13781	7030	56	0	\N
280102	1678	14400545709000	13781	7030	57	0	\N
280103	1678	14400545710000	13781	7030	58	0	\N
280104	1678	14400545711000	13781	7030	60	0	\N
280105	1678	14400545712000	13781	7030	61	0	\N
280106	1678	14400545713000	13781	7030	62	0	\N
280107	1678	14400545714000	13781	7030	63	0	\N
280108	1678	14400545715000	13781	7030	64	0	\N
280109	1678	14400545716000	13781	7030	65	0	\N
280110	1678	14400545717000	13781	7030	66	0	\N
280111	1678	14400545718000	13781	7030	67	0	\N
280112	1678	14400545719000	13781	7030	68	0	\N
280113	1678	14400545720000	13781	7030	69	0	\N
280114	1678	14400545721000	13781	7030	70	0	\N
280115	1678	14400545722000	13781	7030	71	0	\N
280116	1678	14400545723000	13781	7030	72	0	\N
280117	1678	14400545724000	13781	7030	73	0	\N
280118	1874	1451000	13781	7030	74	0	\N
280119	1874	1454000	13781	7030	75	0	\N
280120	1874	1457000	13781	7030	76	0	\N
280121	1874	1460000	13781	7030	77	0	\N
280122	1874	1463000	13781	7030	78	0	\N
280123	1874	1466000	13781	7030	79	0	\N
280124	1874	1469000	13781	7030	80	0	\N
280125	1874	1472000	13781	7030	81	0	\N
280126	1874	1475000	13781	7030	82	0	\N
280127	1874	1478000	13781	7030	83	0	\N
280128	1874	1481000	13781	7030	84	0	\N
280129	1874	1484000	13781	7030	85	0	\N
280130	1874	1487000	13781	7030	86	0	\N
280131	1874	1490000	13781	7030	87	0	\N
280132	1874	1493000	13781	7030	88	0	\N
280133	1874	1496000	13781	7030	89	0	\N
280134	1874	1499000	13781	7030	90	0	\N
280135	1874	1502000	13781	7030	91	0	\N
280136	1874	1505000	13781	7030	92	0	\N
280137	1874	1508000	13781	7030	93	0	\N
280138	1874	1511000	13781	7030	94	0	\N
280139	1874	1514000	13781	7030	95	0	\N
280140	1874	1516000	13781	7030	96	0	\N
280141	1874	1517000	13781	7030	97	0	\N
280142	1874	1520000	13781	7030	98	0	\N
280143	1874	1522000	13781	7030	99	0	\N
280144	1874	1523000	13781	7030	100	0	\N
280145	1874	1526000	13781	7030	101	0	\N
280146	1874	1528000	13781	7030	102	0	\N
280147	1874	1529000	13781	7030	103	0	\N
280148	1874	1532000	13781	7030	104	0	\N
280149	1874	1534000	13781	7030	105	0	\N
280150	1874	1535000	13781	7030	106	0	\N
280151	1874	1538000	13781	7030	107	0	\N
280152	1874	1540000	13781	7030	108	0	\N
280153	1874	1541000	13781	7030	109	0	\N
280154	1874	1544000	13781	7030	110	0	\N
280155	1874	1546000	13781	7030	111	0	\N
280156	1874	1547000	13781	7030	112	0	\N
280157	1874	1550000	13781	7030	113	0	\N
280158	1874	1552000	13781	7030	114	0	\N
280159	1874	1553000	13781	7030	115	0	\N
280160	1874	1556000	13781	7030	116	0	\N
280031	1678	14400545722000	13778	7078	2	0	0
280032	1678	14400545723000	13778	7078	3	0	0
280033	1874	1774000	13778	7078	4	0	1
280034	1874	1775000	13778	7078	5	0	1
280035	1874	1778000	13778	7078	6	0	1
280037	1874	1781000	13778	7078	8	0	1
280038	1874	1784000	13778	7078	9	0	1
280039	1874	1786000	13778	7078	10	0	1
280040	1874	1787000	13778	7078	11	0	1
280041	1874	1790000	13778	7078	12	0	1
280043	1874	1793000	13778	7078	14	0	1
280044	1874	1796000	13778	7078	15	0	1
280161	1874	1558000	13781	7030	117	0	\N
280162	1874	1559000	13781	7030	118	0	\N
280163	1874	1562000	13781	7030	119	0	\N
280164	1874	1564000	13781	7030	120	0	\N
280165	1874	1565000	13781	7030	121	0	\N
280166	1874	1568000	13781	7030	122	0	\N
280167	1874	1570000	13781	7030	123	0	\N
280168	1874	1571000	13781	7030	124	0	\N
280169	1874	1574000	13781	7030	125	0	\N
280174	1678	14400545725000	13783	7080	0	0	\N
280175	1678	14400545726000	13783	7080	1	0	\N
280176	1874	1804000	13783	7080	2	0	\N
280177	1874	1807000	13783	7080	3	0	\N
280178	1874	1809000	13783	7080	4	0	\N
280179	1874	1812000	13783	7080	5	0	\N
280191	1678	14400545728000	13786	7082	0	0	\N
280192	1678	14400545729000	13786	7082	1	0	\N
280193	1874	1820000	13786	7082	2	0	\N
280194	1874	1823000	13786	7082	3	0	\N
280195	1874	1824000	13786	7082	4	0	\N
280196	1874	1826000	13786	7082	5	0	\N
280197	1874	1829000	13786	7082	6	0	\N
280198	1874	1830000	13786	7082	7	0	\N
280199	1678	14400545728000	13787	7082	0	0	\N
280200	1678	14400545729000	13787	7082	1	0	\N
280201	1874	1820000	13787	7082	2	0	\N
280202	1874	1823000	13787	7082	3	0	\N
280203	1874	1824000	13787	7082	4	0	\N
280204	1874	1826000	13787	7082	5	0	\N
280205	1874	1829000	13787	7082	6	0	\N
280206	1874	1830000	13787	7082	7	0	\N
280207	1678	14400545728000	13788	7082	0	0	\N
280208	1678	14400545729000	13788	7082	1	0	\N
280209	1874	1820000	13788	7082	2	0	\N
280210	1874	1823000	13788	7082	3	0	\N
280211	1874	1824000	13788	7082	4	0	\N
280212	1874	1826000	13788	7082	5	0	\N
280213	1874	1829000	13788	7082	6	0	\N
280214	1874	1830000	13788	7082	7	0	\N
280223	1678	14400545730000	13790	7083	0	0	\N
280224	1591	718512000000	13790	7083	1	0	\N
280225	1874	1832000	13790	7083	2	0	\N
280226	1874	1835000	13790	7083	3	0	\N
280227	1874	1836000	13790	7083	4	0	\N
280228	1678	14400545730000	13791	7083	0	0	\N
280229	1874	1832000	13791	7083	1	0	\N
280230	1874	1835000	13791	7083	2	0	\N
280231	1874	1836000	13791	7083	3	0	\N
280237	1678	14400545731000	13793	7084	0	0	\N
280238	1874	1838000	13793	7084	1	0	\N
280239	1874	1841000	13793	7084	2	0	\N
280240	1874	1842000	13793	7084	3	0	\N
280241	1678	14400545731000	13794	7084	0	0	\N
280251	1678	14400545732000	13797	7085	0	0	\N
280252	1874	1844000	13797	7085	1	0	\N
280253	1874	1847000	13797	7085	2	0	\N
280254	1874	1848000	13797	7085	3	0	\N
280255	1678	14400545732000	13798	7085	0	0	\N
280256	1874	1844000	13798	7085	1	0	\N
280257	1874	1847000	13798	7085	2	0	\N
280258	1874	1848000	13798	7085	3	0	\N
280263	1678	14400545730000	13800	7083	0	0	\N
280264	1678	14400545731000	13800	7083	1	0	\N
280265	1678	14400545732000	13800	7083	2	0	\N
280266	1678	14400545733000	13800	7083	3	0	\N
280267	2100	718000000000	13800	7083	4	0	\N
280278	1678	14400545736000	13802	7088	0	0	\N
280279	1874	1868000	13802	7088	1	0	\N
280280	1874	1871000	13802	7088	2	0	\N
280281	1874	1872000	13802	7088	3	0	\N
280291	1678	14400545737000	13805	7089	0	0	\N
280292	1678	14400545738000	13805	7089	1	0	\N
280293	1874	1874000	13805	7089	2	0	\N
280294	1874	1877000	13805	7089	3	0	\N
280295	1874	1878000	13805	7089	4	0	\N
280296	1874	1880000	13805	7089	5	0	\N
280172	1874	1799000	13782	7079	2	0	1
280173	1874	1802000	13782	7079	3	0	1
280180	1678	14400545725000	13784	7080	0	0	0
280181	1678	14400545726000	13784	7080	1	0	0
280182	1874	1804000	13784	7080	2	0	1
280184	1874	1809000	13784	7080	4	0	1
280185	1874	1812000	13784	7080	5	0	1
280186	1678	14400545727000	13785	7081	0	0	0
280187	2100	1000000000	13785	7081	1	0	0
280188	1874	1814000	13785	7081	2	0	1
280190	1874	1818000	13785	7081	4	0	1
280215	1678	14400545728000	13789	7082	0	0	0
280216	1678	14400545729000	13789	7082	1	0	0
280217	1874	1820000	13789	7082	2	0	1
280219	1874	1824000	13789	7082	4	0	1
280220	1874	1826000	13789	7082	5	0	1
280221	1874	1829000	13789	7082	6	0	1
280222	1874	1830000	13789	7082	7	0	1
280232	1678	14400545730000	13792	7083	0	0	0
280234	1874	1832000	13792	7083	2	0	1
280235	1874	1835000	13792	7083	3	0	1
280236	1874	1836000	13792	7083	4	0	1
280242	1678	14400545731000	13795	7084	0	0	0
280243	1874	1838000	13795	7084	1	0	1
280245	1874	1842000	13795	7084	3	0	1
280246	1678	14400545732000	13796	7085	0	0	0
280247	1874	1844000	13796	7085	1	0	1
280248	2100	717890000000	13796	7085	2	0	1
280250	1874	1848000	13796	7085	4	0	1
280259	1678	14400545733000	13799	7086	0	0	0
280260	1874	1850000	13799	7086	1	0	1
280261	1874	1853000	13799	7086	2	0	1
280262	1874	1854000	13799	7086	3	0	1
280269	1678	14400545735000	13801	7087	1	0	0
280270	1874	1856000	13801	7087	2	0	1
280271	1874	1859000	13801	7087	3	0	1
280272	1874	1860000	13801	7087	4	0	1
280273	2101	200000000	13801	7087	5	0	0
280275	1874	1862000	13801	7087	7	0	1
280276	1874	1865000	13801	7087	8	0	1
280277	1874	1866000	13801	7087	9	0	1
280282	1678	14400545736000	13803	7088	0	0	0
280284	1874	1871000	13803	7088	2	0	1
280285	1874	1872000	13803	7088	3	0	1
280286	1678	14400545737000	13804	7089	0	0	0
280287	1678	14400545738000	13804	7089	1	0	0
280288	1874	1874000	13804	7089	2	0	1
280290	1874	1878000	13804	7089	4	0	1
280297	1678	14400545739000	13806	7090	0	0	\N
280298	1678	14400545739000	13807	7090	0	0	\N
280299	1874	1880000	13807	7090	1	0	\N
280300	1874	1883000	13807	7090	2	0	\N
280301	1874	1884000	13807	7090	3	0	\N
280302	1874	1886000	13807	7090	4	0	\N
280303	1874	1889000	13807	7090	5	0	\N
280304	1874	1890000	13807	7090	6	0	\N
280312	1678	14400545739000	13809	7090	0	0	\N
280318	1678	14400545740000	13811	7091	0	0	\N
280319	1591	1511000000	13811	7091	1	0	\N
280320	1874	1892000	13811	7091	2	0	\N
280321	1874	1895000	13811	7091	3	0	\N
280322	1874	1896000	13811	7091	4	0	\N
280331	1678	14400545741000	13813	7092	0	0	\N
280332	1678	14400545742000	13813	7092	1	0	\N
280333	1874	1898000	13813	7092	2	0	\N
280334	1874	1901000	13813	7092	3	0	\N
280335	1874	1902000	13813	7092	4	0	\N
280336	1874	1904000	13813	7092	5	0	\N
280337	1874	1907000	13813	7092	6	0	\N
280338	1874	1908000	13813	7092	7	0	\N
280339	1678	14400545741000	13814	7092	0	0	\N
280340	1678	14400545742000	13814	7092	1	0	\N
280345	1678	14400545743000	13816	7093	0	0	\N
280346	1678	14400545744000	13816	7093	2	0	\N
280347	1678	14400545745000	13816	7093	3	0	\N
280348	1678	14400545746000	13816	7093	4	0	\N
280365	1678	14400545744000	13818	7094	0	0	\N
280366	1678	14400545745000	13818	7094	1	0	\N
280367	1678	14400545746000	13818	7094	2	0	\N
280368	1678	14400545747000	13818	7094	3	0	\N
280369	1874	1916000	13818	7094	4	0	\N
280370	1874	1919000	13818	7094	5	0	\N
280371	1874	1920000	13818	7094	6	0	\N
280372	1874	1922000	13818	7094	7	0	\N
280373	1874	1925000	13818	7094	8	0	\N
280374	1874	1926000	13818	7094	9	0	\N
280375	1874	1928000	13818	7094	10	0	\N
280376	1874	1931000	13818	7094	11	0	\N
280377	1874	1932000	13818	7094	12	0	\N
280378	1874	1934000	13818	7094	13	0	\N
280379	1874	1937000	13818	7094	14	0	\N
280380	1874	1938000	13818	7094	15	0	\N
280382	1678	14400545749000	13820	7096	0	0	\N
280383	1874	1940000	13820	7096	1	0	\N
280384	1874	1943000	13820	7096	2	0	\N
280385	1874	1944000	13820	7096	3	0	\N
280386	1874	1946000	13820	7096	4	0	\N
280387	1874	1949000	13820	7096	5	0	\N
280388	1874	1950000	13820	7096	6	0	\N
280389	1678	14400545749000	13821	7096	0	0	\N
280390	1874	1940000	13821	7096	1	0	\N
280391	1874	1943000	13821	7096	2	0	\N
280392	1874	1944000	13821	7096	3	0	\N
280393	1874	1946000	13821	7096	4	0	\N
280394	1874	1949000	13821	7096	5	0	\N
280395	1874	1950000	13821	7096	6	0	\N
280410	1678	14400545752000	13824	7098	0	0	\N
280411	1678	14400545753000	13824	7098	1	0	\N
280412	1678	14400545754000	13824	7098	2	0	\N
280307	1874	1883000	13808	7090	2	0	1
280308	1874	1884000	13808	7090	3	0	1
280309	1874	1886000	13808	7090	4	0	1
280310	1874	1889000	13808	7090	5	0	1
280311	1874	1890000	13808	7090	6	0	1
280314	1591	1511000000	13810	7091	1	0	2
280315	1874	1892000	13810	7091	2	0	1
280316	1874	1895000	13810	7091	3	0	1
280317	1874	1896000	13810	7091	4	0	1
280323	1678	14400545741000	13812	7092	0	0	0
280325	1874	1898000	13812	7092	2	0	1
280326	1874	1901000	13812	7092	3	0	1
280327	1874	1902000	13812	7092	4	0	1
280328	1874	1904000	13812	7092	5	0	1
280330	1874	1908000	13812	7092	7	0	1
280341	1678	14400545743000	13815	7093	0	0	0
280342	1874	1910000	13815	7093	2	0	1
280343	1874	1913000	13815	7093	3	0	1
280344	1874	1914000	13815	7093	4	0	1
280350	1678	14400545745000	13817	7094	1	0	0
280351	1678	14400545746000	13817	7094	2	0	0
280352	1678	14400545747000	13817	7094	3	0	0
280353	1874	1916000	13817	7094	4	0	1
280354	1874	1919000	13817	7094	5	0	1
280356	1874	1922000	13817	7094	7	0	1
280357	1874	1925000	13817	7094	8	0	1
280358	1874	1926000	13817	7094	9	0	1
280359	1874	1928000	13817	7094	10	0	1
280361	1874	1932000	13817	7094	12	0	1
280362	1874	1934000	13817	7094	13	0	1
280363	1874	1937000	13817	7094	14	0	1
280364	1874	1938000	13817	7094	15	0	1
280381	1678	14400545748000	13819	7095	0	0	0
280397	1874	1940000	13822	7096	1	0	1
280398	1874	1943000	13822	7096	2	0	1
280399	1874	1944000	13822	7096	3	0	1
280400	1874	1946000	13822	7096	4	0	1
280401	1874	1949000	13822	7096	5	0	1
280403	1678	14400545750000	13823	7097	0	0	0
280404	1678	14400545751000	13823	7097	1	0	0
280405	1874	1952000	13823	7097	2	0	1
280406	1874	1955000	13823	7097	3	0	1
280408	1874	1959000	13823	7097	5	0	1
280409	1874	1960000	13823	7097	6	0	1
280413	1678	14400545752000	13826	7098	0	0	0
280414	1678	14400545753000	13826	7098	1	0	0
280415	1678	14400545754000	13826	7098	2	0	0
280417	1874	1965000	13826	7098	4	0	1
280418	1874	1966000	13826	7098	5	0	1
280419	1874	1969000	13826	7098	6	0	1
280420	1874	1971000	13826	7098	7	0	1
280421	1874	1972000	13826	7098	8	0	1
280423	1874	1977000	13826	7098	10	0	1
280424	1874	1978000	13826	7098	11	0	1
280425	1678	14400545755000	13827	7099	0	0	0
280426	1678	14400545756000	13827	7099	1	0	0
280428	1678	14400545758000	13827	7099	3	0	0
280429	1874	1981000	13827	7099	4	0	1
280430	1874	1983000	13827	7099	5	0	1
280431	1874	1984000	13827	7099	6	0	1
280432	1874	1987000	13827	7099	7	0	1
280442	1678	14400545760000	13830	7101	0	0	\N
280443	1678	14400545761000	13830	7101	1	0	\N
280444	1678	14400545762000	13830	7101	2	0	\N
280445	1678	14400545763000	13830	7101	3	0	\N
280446	1678	14400545764000	13830	7101	4	0	\N
280447	1874	2005000	13830	7101	5	0	\N
280448	1874	2007000	13830	7101	6	0	\N
280449	1874	2008000	13830	7101	7	0	\N
280450	1874	2011000	13830	7101	8	0	\N
280451	1874	2013000	13830	7101	9	0	\N
280452	1874	2014000	13830	7101	10	0	\N
280453	1874	2017000	13830	7101	11	0	\N
280454	1874	2019000	13830	7101	12	0	\N
280455	1874	2020000	13830	7101	13	0	\N
280456	1874	2023000	13830	7101	14	0	\N
280457	1874	2025000	13830	7101	15	0	\N
280458	1874	2026000	13830	7101	16	0	\N
280459	1874	2029000	13830	7101	17	0	\N
280460	1874	2031000	13830	7101	18	0	\N
280461	1874	2032000	13830	7101	19	0	\N
280462	1874	2035000	13830	7101	20	0	\N
280463	1874	2037000	13830	7101	21	0	\N
280464	1874	2038000	13830	7101	22	0	\N
280492	1678	14400545766000	13833	7103	0	0	\N
280493	1678	14400545766000	13834	7103	0	0	\N
280494	1874	2047000	13834	7103	1	0	\N
280495	1874	2049000	13834	7103	2	0	\N
280496	1678	14400545766000	13835	7103	0	0	\N
280497	1874	2047000	13835	7103	1	0	\N
280498	1874	2049000	13835	7103	2	0	\N
280502	1678	14400545720000	13837	7078	0	0	\N
280503	1678	14400545721000	13837	7078	1	0	\N
280504	1678	14400545722000	13837	7078	2	0	\N
280505	1678	14400545723000	13837	7078	3	0	\N
280506	1678	14400545724000	13837	7078	4	0	\N
280507	1678	14400545725000	13837	7078	5	0	\N
280508	1678	14400545726000	13837	7078	6	0	\N
280509	1678	14400545727000	13837	7078	7	0	\N
280510	1678	14400545728000	13837	7078	8	0	\N
280511	1678	14400545729000	13837	7078	9	0	\N
280512	1678	14400545730000	13837	7078	10	0	\N
280513	1678	14400545731000	13837	7078	11	0	\N
280514	1678	14400545732000	13837	7078	12	0	\N
280515	1678	14400545733000	13837	7078	13	0	\N
280516	1678	14400545734000	13837	7078	14	0	\N
280517	1678	14400545735000	13837	7078	15	0	\N
280518	1678	14400545736000	13837	7078	16	0	\N
280519	1678	14400545737000	13837	7078	17	0	\N
280520	1678	14400545738000	13837	7078	18	0	\N
280521	1678	14400545739000	13837	7078	19	0	\N
280522	1678	14400545740000	13837	7078	20	0	\N
280523	1678	14400545741000	13837	7078	21	0	\N
280524	1678	14400545742000	13837	7078	22	0	\N
280525	1678	14400545743000	13837	7078	23	0	\N
280526	1678	14400545744000	13837	7078	24	0	\N
280527	1678	14400545745000	13837	7078	25	0	\N
280528	1678	14400545746000	13837	7078	26	0	\N
280529	1678	14400545747000	13837	7078	27	0	\N
280530	1678	14400545748000	13837	7078	28	0	\N
280531	1678	14400545749000	13837	7078	29	0	\N
280532	1678	14400545750000	13837	7078	30	0	\N
280533	1678	14400545751000	13837	7078	31	0	\N
280534	1678	14400545752000	13837	7078	32	0	\N
280535	1678	14400545753000	13837	7078	33	0	\N
280536	1678	14400545754000	13837	7078	34	0	\N
280537	1678	14400545755000	13837	7078	35	0	\N
280538	1678	14400545756000	13837	7078	36	0	\N
280539	1678	14400545757000	13837	7078	37	0	\N
280540	1678	14400545758000	13837	7078	38	0	\N
280541	1678	14400545759000	13837	7078	39	0	\N
280542	1678	14400545760000	13837	7078	40	0	\N
280543	1678	14400545761000	13837	7078	41	0	\N
280544	1678	14400545762000	13837	7078	42	0	\N
280545	1678	14400545763000	13837	7078	43	0	\N
280546	1678	14400545764000	13837	7078	44	0	\N
280547	1678	14400545765000	13837	7078	45	0	\N
280548	1678	14400545766000	13837	7078	46	0	\N
280549	1874	1774000	13837	7078	47	0	\N
280550	1874	1775000	13837	7078	48	0	\N
280551	1874	1778000	13837	7078	49	0	\N
280552	1874	1780000	13837	7078	50	0	\N
280553	1874	1781000	13837	7078	51	0	\N
280554	1874	1784000	13837	7078	52	0	\N
280555	1874	1786000	13837	7078	53	0	\N
280556	1874	1787000	13837	7078	54	0	\N
280557	1874	1790000	13837	7078	55	0	\N
280558	1874	1792000	13837	7078	56	0	\N
280559	1874	1793000	13837	7078	57	0	\N
280560	1874	1796000	13837	7078	58	0	\N
280561	1874	1798000	13837	7078	59	0	\N
280562	1874	1799000	13837	7078	60	0	\N
280563	1874	1802000	13837	7078	61	0	\N
280564	1874	1804000	13837	7078	62	0	\N
280565	1874	1807000	13837	7078	63	0	\N
280566	1874	1809000	13837	7078	64	0	\N
280567	1874	1812000	13837	7078	65	0	\N
280568	2100	1000000000	13837	7078	66	0	\N
280435	1874	1993000	13827	7099	10	0	1
280436	1874	1995000	13827	7099	11	0	1
280437	1874	1996000	13827	7099	12	0	1
280438	1874	1999000	13827	7099	13	0	1
280439	1874	2001000	13827	7099	14	0	1
280441	1678	14400545759000	13828	7100	0	0	0
280465	1678	14400545760000	13831	7101	0	0	0
280466	1678	14400545761000	13831	7101	1	0	0
280467	1678	14400545762000	13831	7101	2	0	0
280468	1678	14400545763000	13831	7101	3	0	0
280470	1874	2005000	13831	7101	5	0	1
280471	1678	14400545765000	13832	7102	0	0	0
280472	1874	2007000	13832	7102	1	0	1
280473	1874	2008000	13832	7102	2	0	1
280475	1874	2013000	13832	7102	4	0	1
280476	1874	2014000	13832	7102	5	0	1
280477	1874	2017000	13832	7102	6	0	1
280478	1874	2019000	13832	7102	7	0	1
280479	1874	2020000	13832	7102	8	0	1
280481	1874	2025000	13832	7102	10	0	1
280482	1874	2026000	13832	7102	11	0	1
280483	1874	2029000	13832	7102	12	0	1
280484	1874	2031000	13832	7102	13	0	1
280485	1874	2032000	13832	7102	14	0	1
280487	1874	2037000	13832	7102	16	0	1
280488	1874	2038000	13832	7102	17	0	1
280489	1874	2041000	13832	7102	18	0	1
280490	1874	2043000	13832	7102	19	0	1
280499	1678	14400545766000	13836	7103	0	0	0
280500	1874	2047000	13836	7103	1	0	1
280501	1874	2049000	13836	7103	2	0	1
280569	2100	718000000000	13837	7078	67	0	\N
280570	1874	1814000	13837	7078	68	0	\N
280571	1874	1817000	13837	7078	69	0	\N
280572	1874	1818000	13837	7078	70	0	\N
280573	1874	1820000	13837	7078	71	0	\N
280574	1874	1823000	13837	7078	72	0	\N
280575	1874	1824000	13837	7078	73	0	\N
280576	1874	1826000	13837	7078	74	0	\N
280577	1874	1829000	13837	7078	75	0	\N
280578	1874	1830000	13837	7078	76	0	\N
280579	1874	1832000	13837	7078	77	0	\N
280580	1874	1835000	13837	7078	78	0	\N
280581	1874	1836000	13837	7078	79	0	\N
280582	1874	1838000	13837	7078	80	0	\N
280583	1874	1841000	13837	7078	81	0	\N
280584	1874	1842000	13837	7078	82	0	\N
280585	1874	1844000	13837	7078	83	0	\N
280586	1874	1847000	13837	7078	84	0	\N
280587	1874	1848000	13837	7078	85	0	\N
280588	1874	1850000	13837	7078	86	0	\N
280589	1874	1853000	13837	7078	87	0	\N
280590	1874	1854000	13837	7078	88	0	\N
280591	1874	1856000	13837	7078	89	0	\N
280592	1874	1859000	13837	7078	90	0	\N
280593	1874	1860000	13837	7078	91	0	\N
280594	2101	200000000	13837	7078	92	0	\N
280595	2102	200000000	13837	7078	93	0	\N
280596	1874	1862000	13837	7078	94	0	\N
280597	1874	1865000	13837	7078	95	0	\N
280598	1874	1866000	13837	7078	96	0	\N
280599	1874	1868000	13837	7078	97	0	\N
280600	1874	1871000	13837	7078	98	0	\N
280601	1874	1872000	13837	7078	99	0	\N
280602	1874	1874000	13837	7078	100	0	\N
280603	1874	1877000	13837	7078	101	0	\N
280604	1874	1878000	13837	7078	102	0	\N
280605	1874	1880000	13837	7078	103	0	\N
280606	1874	1883000	13837	7078	104	0	\N
280607	1874	1884000	13837	7078	105	0	\N
280608	1874	1886000	13837	7078	106	0	\N
280609	1874	1889000	13837	7078	107	0	\N
280610	1874	1890000	13837	7078	108	0	\N
280611	1874	1892000	13837	7078	109	0	\N
280612	1874	1895000	13837	7078	110	0	\N
280613	1874	1896000	13837	7078	111	0	\N
280614	1874	1898000	13837	7078	112	0	\N
280615	1874	1901000	13837	7078	113	0	\N
280616	1874	1902000	13837	7078	114	0	\N
280617	1874	1904000	13837	7078	115	0	\N
280618	1874	1907000	13837	7078	116	0	\N
280619	1874	1908000	13837	7078	117	0	\N
280620	1874	1910000	13837	7078	118	0	\N
280621	1874	1913000	13837	7078	119	0	\N
280622	1874	1914000	13837	7078	120	0	\N
280623	1874	1916000	13837	7078	121	0	\N
280624	1874	1919000	13837	7078	122	0	\N
280625	1874	1920000	13837	7078	123	0	\N
280626	1874	1922000	13837	7078	124	0	\N
280627	1874	1925000	13837	7078	125	0	\N
280628	1678	14400545765000	13838	7102	0	0	\N
280629	1678	14400545766000	13838	7102	1	0	\N
280630	1874	2007000	13838	7102	2	0	\N
280631	1874	2008000	13838	7102	3	0	\N
280632	1874	2011000	13838	7102	4	0	\N
280633	1874	2013000	13838	7102	5	0	\N
280634	1874	2014000	13838	7102	6	0	\N
280635	1874	2017000	13838	7102	7	0	\N
280636	1874	2019000	13838	7102	8	0	\N
280637	1874	2020000	13838	7102	9	0	\N
280638	1874	2023000	13838	7102	10	0	\N
280639	1874	2025000	13838	7102	11	0	\N
280640	1874	2026000	13838	7102	12	0	\N
280641	1874	2029000	13838	7102	13	0	\N
280642	1874	2031000	13838	7102	14	0	\N
280643	1874	2032000	13838	7102	15	0	\N
280644	1874	2035000	13838	7102	16	0	\N
280645	1874	2037000	13838	7102	17	0	\N
280646	1874	2038000	13838	7102	18	0	\N
280647	1874	2041000	13838	7102	19	0	\N
280664	1678	14400545769000	13841	7105	0	0	\N
280665	1678	14400545770000	13841	7105	1	0	\N
280666	1874	2062000	13841	7105	3	0	\N
280667	1874	2065000	13841	7105	4	0	\N
280668	1874	2067000	13841	7105	5	0	\N
280669	1874	2068000	13841	7105	6	0	\N
280670	1874	2071000	13841	7105	7	0	\N
280671	1874	2073000	13841	7105	8	0	\N
280672	1678	14400545769000	13842	7105	0	0	\N
280673	1678	14400545770000	13842	7105	1	0	\N
280674	1874	2062000	13842	7105	3	0	\N
280675	1874	2065000	13842	7105	4	0	\N
280676	1874	2067000	13842	7105	5	0	\N
280677	1874	2068000	13842	7105	6	0	\N
280678	1874	2071000	13842	7105	7	0	\N
280679	1874	2073000	13842	7105	8	0	\N
280680	1678	14400545771000	13843	7106	0	0	\N
280681	1678	14400545772000	13843	7106	1	0	\N
280682	1678	14400545773000	13843	7106	2	0	\N
280683	1678	14400545774000	13843	7106	3	0	\N
280684	1874	2074000	13843	7106	4	0	\N
280685	1874	2077000	13843	7106	5	0	\N
280686	1874	2079000	13843	7106	6	0	\N
280687	1874	2080000	13843	7106	7	0	\N
280688	1874	2083000	13843	7106	8	0	\N
280689	1874	2085000	13843	7106	9	0	\N
280690	1874	2086000	13843	7106	10	0	\N
280691	1874	2089000	13843	7106	11	0	\N
280692	1874	2091000	13843	7106	12	0	\N
280693	1874	2092000	13843	7106	13	0	\N
280694	1874	2095000	13843	7106	14	0	\N
280695	1874	2097000	13843	7106	15	0	\N
280700	1678	14400545771000	13845	7106	0	0	\N
280701	1678	14400545772000	13845	7106	1	0	\N
280702	1678	14400545773000	13845	7106	2	0	\N
280703	1678	14400545774000	13845	7106	3	0	\N
280704	1874	2074000	13845	7106	4	0	\N
280650	1874	2050000	13839	7104	2	0	1
280651	1874	2053000	13839	7104	3	0	1
280652	1874	2055000	13839	7104	4	0	1
280653	1874	2056000	13839	7104	5	0	1
280654	1874	2059000	13839	7104	6	0	1
280656	1678	14400545769000	13840	7105	0	0	0
280657	1678	14400545770000	13840	7105	1	0	0
280658	1874	2062000	13840	7105	3	0	1
280659	1874	2065000	13840	7105	4	0	1
280660	1874	2067000	13840	7105	5	0	1
280662	1874	2071000	13840	7105	7	0	1
280663	1874	2073000	13840	7105	8	0	1
280696	1678	14400545771000	13844	7106	0	0	0
280697	1678	14400545772000	13844	7106	1	0	0
280699	1678	14400545774000	13844	7106	3	0	0
280705	1678	14400545771000	13846	7106	0	0	\N
280706	1678	14400545772000	13846	7106	1	0	\N
280707	1678	14400545773000	13846	7106	2	0	\N
280708	1678	14400545774000	13846	7106	3	0	\N
280709	1874	2074000	13846	7106	4	0	\N
280710	1874	2077000	13846	7106	5	0	\N
280711	1874	2079000	13846	7106	6	0	\N
280712	1874	2080000	13846	7106	7	0	\N
280713	1874	2083000	13846	7106	8	0	\N
280714	1874	2085000	13846	7106	9	0	\N
280715	1874	2086000	13846	7106	10	0	\N
280716	1874	2089000	13846	7106	11	0	\N
280717	1874	2091000	13846	7106	12	0	\N
280718	1874	2092000	13846	7106	13	0	\N
280719	1874	2095000	13846	7106	14	0	\N
280720	1874	2097000	13846	7106	15	0	\N
280734	1678	14400545775000	13848	7107	0	0	\N
280735	1874	2074000	13848	7107	1	0	\N
280736	1874	2077000	13848	7107	2	0	\N
280737	1874	2079000	13848	7107	3	0	\N
280738	1874	2080000	13848	7107	4	0	\N
280739	1874	2083000	13848	7107	5	0	\N
280740	1874	2085000	13848	7107	6	0	\N
280741	1874	2086000	13848	7107	7	0	\N
280742	1874	2089000	13848	7107	8	0	\N
280743	1874	2091000	13848	7107	9	0	\N
280744	1874	2092000	13848	7107	10	0	\N
280745	1874	2095000	13848	7107	11	0	\N
280746	1874	2097000	13848	7107	12	0	\N
280747	1874	2098000	13848	7107	13	0	\N
280748	1874	2101000	13848	7107	14	0	\N
280749	1874	2103000	13848	7107	15	0	\N
280750	1678	14400545775000	13849	7107	0	0	\N
280752	1678	14400545776000	13851	7108	0	0	\N
280753	1874	2098000	13851	7108	1	0	\N
280754	1874	2101000	13851	7108	2	0	\N
280755	1874	2103000	13851	7108	3	0	\N
280756	1874	2104000	13851	7108	4	0	\N
280757	1874	2107000	13851	7108	5	0	\N
280758	1874	2109000	13851	7108	6	0	\N
280759	1678	14400545776000	13852	7108	0	0	\N
280760	1874	2098000	13852	7108	1	0	\N
280761	1874	2101000	13852	7108	2	0	\N
280762	1874	2103000	13852	7108	3	0	\N
280763	1874	2104000	13852	7108	4	0	\N
280764	1874	2107000	13852	7108	5	0	\N
280765	1874	2109000	13852	7108	6	0	\N
280766	1678	14400545776000	13853	7108	0	0	\N
280767	1678	14400545777000	13854	7109	0	0	\N
280768	1874	2098000	13854	7109	1	0	\N
280769	1874	2101000	13854	7109	2	0	\N
280770	1874	2103000	13854	7109	3	0	\N
280771	1874	2104000	13854	7109	4	0	\N
280772	1874	2107000	13854	7109	5	0	\N
280773	1874	2109000	13854	7109	6	0	\N
280774	1874	2110000	13854	7109	7	0	\N
280775	1874	2113000	13854	7109	8	0	\N
280776	1874	2115000	13854	7109	9	0	\N
280803	1678	14400545782000	13859	7113	0	0	\N
280804	1874	2140000	13859	7113	1	0	\N
280805	1874	2143000	13859	7113	2	0	\N
280806	1874	2145000	13859	7113	3	0	\N
280807	1678	14400545782000	13860	7113	0	0	\N
280808	1874	2140000	13860	7113	1	0	\N
280809	1874	2143000	13860	7113	2	0	\N
280810	1874	2145000	13860	7113	3	0	\N
280812	1678	14400545783000	13862	7114	0	0	\N
280813	1874	2140000	13862	7114	1	0	\N
280814	1874	2143000	13862	7114	2	0	\N
280815	1874	2145000	13862	7114	3	0	\N
280816	1874	2146000	13862	7114	4	0	\N
280817	1874	2149000	13862	7114	5	0	\N
280818	1874	2151000	13862	7114	6	0	\N
280723	1874	2077000	13847	7107	2	0	1
280724	1874	2079000	13847	7107	3	0	1
280725	1874	2080000	13847	7107	4	0	1
280726	1874	2083000	13847	7107	5	0	1
280727	1874	2085000	13847	7107	6	0	1
280729	1874	2089000	13847	7107	8	0	1
280730	1874	2091000	13847	7107	9	0	1
280731	1874	2092000	13847	7107	10	0	1
280732	1874	2095000	13847	7107	11	0	1
280733	1874	2097000	13847	7107	12	0	1
280777	1678	14400545777000	13855	7109	0	0	0
280778	1874	2098000	13855	7109	1	0	1
280779	1874	2101000	13855	7109	2	0	1
280780	1874	2103000	13855	7109	3	0	1
280782	1874	2107000	13855	7109	5	0	1
280783	1874	2109000	13855	7109	6	0	1
280784	1874	2110000	13855	7109	7	0	1
280785	1874	2113000	13855	7109	8	0	1
280786	1874	2115000	13855	7109	9	0	1
280788	1678	14400545779000	13856	7110	1	0	0
280789	1874	2116000	13856	7110	2	0	1
280790	1874	2119000	13856	7110	3	0	1
280791	1874	2121000	13856	7110	4	0	1
280792	1874	2122000	13856	7110	5	0	1
280794	1874	2127000	13856	7110	7	0	1
280795	1678	14400545780000	13857	7111	0	0	0
280796	1874	2128000	13857	7111	1	0	1
280797	1874	2131000	13857	7111	2	0	1
280799	1678	14400545781000	13858	7112	0	0	0
280800	1874	2134000	13858	7112	1	0	1
280801	1874	2137000	13858	7112	2	0	1
280802	1874	2139000	13858	7112	3	0	1
280811	1678	14400545782000	13861	7113	0	0	0
280820	1678	14400545784000	13864	7115	0	0	0
280821	1874	2140000	13864	7115	1	0	1
280822	1874	2143000	13864	7115	2	0	1
280823	1874	2145000	13864	7115	3	0	1
280824	1874	2146000	13864	7115	4	0	1
280826	1874	2151000	13864	7115	6	0	1
280827	1874	2152000	13864	7115	7	0	1
280828	1874	2155000	13864	7115	8	0	1
280829	1874	2157000	13864	7115	9	0	1
280831	1874	2158000	13865	7116	1	0	1
280832	1874	2161000	13865	7116	2	0	1
280833	1874	2163000	13865	7116	3	0	1
280834	1678	14400545786000	13866	7117	0	0	0
280835	1874	2164000	13866	7117	1	0	1
280837	1874	2169000	13866	7117	3	0	1
280838	1874	2170000	13866	7117	4	0	1
280839	1874	2173000	13866	7117	5	0	1
280840	1874	2175000	13866	7117	6	0	1
280841	1678	14400545787000	13867	7118	0	0	\N
280842	1678	14400545788000	13867	7118	1	0	\N
280843	1874	2176000	13867	7118	2	0	\N
280844	1874	2179000	13867	7118	3	0	\N
280845	1874	2181000	13867	7118	4	0	\N
280846	1874	2182000	13867	7118	5	0	\N
280847	1874	2185000	13867	7118	6	0	\N
280848	1874	2187000	13867	7118	7	0	\N
280849	1678	14400545787000	13868	7118	0	0	\N
280850	1678	14400545788000	13868	7118	1	0	\N
280859	1678	14400545787000	13870	7118	0	0	\N
280860	1678	14400545788000	13870	7118	1	0	\N
280861	1874	2176000	13870	7118	2	0	\N
280862	1874	2179000	13870	7118	3	0	\N
280863	1874	2181000	13870	7118	4	0	\N
280864	1874	2182000	13870	7118	5	0	\N
280865	1874	2185000	13870	7118	6	0	\N
280866	1874	2187000	13870	7118	7	0	\N
280867	1678	14400545787000	13871	7118	0	0	\N
280868	1678	14400545788000	13871	7118	1	0	\N
280880	1678	14400545792000	13874	7121	0	0	\N
280881	1678	14400545793000	13874	7121	1	0	\N
280882	1678	14400545794000	13874	7121	2	0	\N
280883	1950	4949852000000	13874	7121	4	0	\N
280897	1678	14400545795000	13876	7122	0	0	\N
280898	1678	14400545796000	13876	7122	1	0	\N
280899	1874	2223000	13876	7122	2	0	\N
280900	1874	2224000	13876	7122	3	0	\N
280901	1874	2227000	13876	7122	4	0	\N
280902	1874	2229000	13876	7122	5	0	\N
280903	1874	2230000	13876	7122	6	0	\N
280904	1874	2233000	13876	7122	7	0	\N
280905	1678	14400545795000	13878	7122	0	0	\N
280906	1678	14400545796000	13878	7122	1	0	\N
280907	1874	2223000	13878	7122	2	0	\N
280908	1874	2224000	13878	7122	3	0	\N
280909	1874	2227000	13878	7122	4	0	\N
280910	1874	2229000	13878	7122	5	0	\N
280911	1874	2230000	13878	7122	6	0	\N
280912	1874	2233000	13878	7122	7	0	\N
280921	1678	14400545795000	13880	7122	0	0	\N
280922	1678	14400545796000	13880	7122	1	0	\N
280923	1678	14400545797000	13882	7123	0	0	\N
280924	1678	14400545798000	13882	7123	1	0	\N
280925	1874	2205000	13882	7123	2	0	\N
280926	1874	2206000	13882	7123	3	0	\N
280927	1874	2209000	13882	7123	4	0	\N
280928	1874	2211000	13882	7123	5	0	\N
280929	1874	2212000	13882	7123	6	0	\N
280930	1874	2215000	13882	7123	7	0	\N
280931	1874	2217000	13882	7123	8	0	\N
280932	1874	2218000	13882	7123	9	0	\N
280933	1874	2221000	13882	7123	10	0	\N
280934	1874	2223000	13882	7123	11	0	\N
280935	1874	2224000	13882	7123	12	0	\N
280936	1874	2227000	13882	7123	13	0	\N
280937	1874	2229000	13882	7123	14	0	\N
280938	1874	2230000	13882	7123	15	0	\N
280939	1874	2233000	13882	7123	16	0	\N
280940	1874	2235000	13882	7123	17	0	\N
280941	1874	2236000	13882	7123	18	0	\N
280942	1874	2239000	13882	7123	19	0	\N
280943	1874	2241000	13882	7123	20	0	\N
280944	1874	2242000	13882	7123	21	0	\N
280945	1874	2245000	13882	7123	22	0	\N
280969	1678	14400545802000	13887	7126	0	0	\N
280970	1874	2263000	13887	7126	1	0	\N
280971	1874	2265000	13887	7126	2	0	\N
280972	1874	2266000	13887	7126	3	0	\N
280973	1678	14400545802000	13888	7126	0	0	\N
280974	1874	2263000	13888	7126	1	0	\N
280975	1874	2265000	13888	7126	2	0	\N
280976	1874	2266000	13888	7126	3	0	\N
280853	1874	2176000	13869	7118	2	0	1
280854	1874	2179000	13869	7118	3	0	1
280855	1874	2181000	13869	7118	4	0	1
280856	1874	2182000	13869	7118	5	0	1
280857	1874	2185000	13869	7118	6	0	1
280869	1678	14400545789000	13872	7119	0	0	0
280870	1874	2188000	13872	7119	1	0	1
280871	1874	2191000	13872	7119	2	0	1
280872	1874	2193000	13872	7119	3	0	1
280873	1678	14400545790000	13873	7120	0	0	0
280875	1874	2194000	13873	7120	2	0	1
280876	1874	2197000	13873	7120	3	0	1
280877	1874	2199000	13873	7120	4	0	1
280878	1874	2200000	13873	7120	5	0	1
280884	1678	14400545792000	13875	7121	0	0	0
280885	1678	14400545793000	13875	7121	1	0	0
280886	1678	14400545794000	13875	7121	2	0	0
280887	1874	2205000	13875	7121	4	0	1
280888	1874	2206000	13875	7121	5	0	1
280890	1950	4949852000000	13875	7121	7	0	13
280891	1874	2211000	13875	7121	8	0	1
280892	1874	2212000	13875	7121	9	0	1
280893	1874	2215000	13875	7121	10	0	1
280894	1874	2217000	13875	7121	11	0	1
280896	1874	2221000	13875	7121	13	0	1
280913	1678	14400545795000	13879	7122	0	0	0
280914	1678	14400545796000	13879	7122	1	0	0
280915	1874	2223000	13879	7122	2	0	1
280917	1874	2227000	13879	7122	4	0	1
280918	1874	2229000	13879	7122	5	0	1
280919	1874	2230000	13879	7122	6	0	1
280920	1874	2233000	13879	7122	7	0	1
280946	1678	14400545797000	13883	7123	0	0	0
280948	1874	2235000	13883	7123	2	0	1
280949	1678	14400545799000	13884	7124	0	0	0
280950	1678	14400545800000	13884	7124	1	0	0
280951	1874	2236000	13884	7124	2	0	1
280952	1874	2239000	13884	7124	3	0	1
280954	1874	2242000	13884	7124	5	0	1
280955	1874	2245000	13884	7124	6	0	1
280956	1874	2247000	13884	7124	7	0	1
280957	1874	2248000	13884	7124	8	0	1
280959	1874	2253000	13884	7124	10	0	1
280960	1874	2254000	13884	7124	11	0	1
280961	1874	2257000	13884	7124	12	0	1
280962	1678	14400545801000	13885	7125	0	0	0
280963	1874	2259000	13885	7125	1	0	1
280965	1678	14400545802000	13886	7126	0	0	0
280966	1874	2263000	13886	7126	1	0	1
280967	1874	2265000	13886	7126	2	0	1
280968	1874	2266000	13886	7126	3	0	1
280977	1678	14400545802000	13889	7126	0	0	\N
280978	1678	14400545803000	13890	7127	0	0	\N
280979	1874	2263000	13890	7127	1	0	\N
280980	1874	2265000	13890	7127	2	0	\N
280981	1874	2266000	13890	7127	3	0	\N
280982	1874	2269000	13890	7127	4	0	\N
280983	1874	2271000	13890	7127	5	0	\N
280984	1874	2272000	13890	7127	6	0	\N
280987	1678	14400545805000	13893	7129	0	0	\N
280988	1678	14400545806000	13893	7129	1	0	\N
280989	1874	2269000	13893	7129	2	0	\N
280990	1874	2271000	13893	7129	3	0	\N
280991	1874	2272000	13893	7129	4	0	\N
280992	1874	2275000	13893	7129	5	0	\N
280993	1874	2277000	13893	7129	6	0	\N
280994	1874	2278000	13893	7129	7	0	\N
280995	1874	2281000	13893	7129	8	0	\N
280996	1874	2283000	13893	7129	9	0	\N
280997	1874	2284000	13893	7129	10	0	\N
280998	1874	2287000	13893	7129	11	0	\N
280999	1874	2289000	13893	7129	12	0	\N
281000	1874	2290000	13893	7129	13	0	\N
281001	1678	14400545805000	13894	7129	0	0	\N
281002	1678	14400545806000	13894	7129	1	0	\N
281003	1874	2269000	13894	7129	2	0	\N
281004	1874	2271000	13894	7129	3	0	\N
281005	1874	2272000	13894	7129	4	0	\N
281006	1874	2275000	13894	7129	5	0	\N
281007	1874	2277000	13894	7129	6	0	\N
281008	1874	2278000	13894	7129	7	0	\N
281009	1874	2281000	13894	7129	8	0	\N
281010	1874	2283000	13894	7129	9	0	\N
281011	1874	2284000	13894	7129	10	0	\N
281012	1874	2287000	13894	7129	11	0	\N
281013	1874	2289000	13894	7129	12	0	\N
281014	1874	2290000	13894	7129	13	0	\N
281015	1678	14400545805000	13895	7129	0	0	\N
281016	1678	14400545806000	13895	7129	1	0	\N
281017	1874	2269000	13895	7129	2	0	\N
281018	1874	2271000	13895	7129	3	0	\N
281019	1874	2272000	13895	7129	4	0	\N
281020	1874	2275000	13895	7129	5	0	\N
281021	1874	2277000	13895	7129	6	0	\N
281022	1874	2278000	13895	7129	7	0	\N
281023	1874	2281000	13895	7129	8	0	\N
281024	1874	2283000	13895	7129	9	0	\N
281025	1874	2284000	13895	7129	10	0	\N
281026	1874	2287000	13895	7129	11	0	\N
281027	1874	2289000	13895	7129	12	0	\N
281028	1874	2290000	13895	7129	13	0	\N
281029	1678	14400545805000	13896	7129	0	0	\N
281030	1678	14400545806000	13896	7129	1	0	\N
281031	1874	2269000	13896	7129	2	0	\N
281032	1874	2271000	13896	7129	3	0	\N
281033	1874	2272000	13896	7129	4	0	\N
281034	1874	2275000	13896	7129	5	0	\N
281035	1874	2277000	13896	7129	6	0	\N
281036	1874	2278000	13896	7129	7	0	\N
281037	1874	2281000	13896	7129	8	0	\N
281038	1874	2283000	13896	7129	9	0	\N
281039	1874	2284000	13896	7129	10	0	\N
281040	1874	2287000	13896	7129	11	0	\N
281041	1874	2289000	13896	7129	12	0	\N
281042	1874	2290000	13896	7129	13	0	\N
281045	1678	14400545807000	13898	7130	0	0	\N
281046	1678	14400545808000	13898	7130	1	0	\N
281047	1678	14400545809000	13898	7130	2	0	\N
281048	1678	14400545810000	13898	7130	3	0	\N
281049	1678	14400545811000	13898	7130	4	0	\N
281050	1874	2269000	13898	7130	5	0	\N
281051	1874	2271000	13898	7130	6	0	\N
281052	1874	2272000	13898	7130	7	0	\N
281053	1874	2275000	13898	7130	8	0	\N
281054	1874	2277000	13898	7130	9	0	\N
281055	1874	2278000	13898	7130	10	0	\N
281056	1874	2281000	13898	7130	11	0	\N
281057	1874	2283000	13898	7130	12	0	\N
281058	1874	2284000	13898	7130	13	0	\N
281059	1874	2287000	13898	7130	14	0	\N
281060	1874	2289000	13898	7130	15	0	\N
281061	1874	2290000	13898	7130	16	0	\N
281062	1874	2293000	13898	7130	17	0	\N
281063	1874	2295000	13898	7130	18	0	\N
281064	1874	2296000	13898	7130	19	0	\N
281065	1874	2298000	13898	7130	20	0	\N
281066	1874	2299000	13898	7130	21	0	\N
281067	1874	2301000	13898	7130	22	0	\N
281068	1874	2304000	13898	7130	23	0	\N
281069	1874	2305000	13898	7130	24	0	\N
281070	1874	2307000	13898	7130	25	0	\N
281071	1874	2310000	13898	7130	26	0	\N
281072	1874	2311000	13898	7130	27	0	\N
281073	1874	2313000	13898	7130	28	0	\N
281074	1874	2316000	13898	7130	29	0	\N
281075	1874	2317000	13898	7130	30	0	\N
281107	1678	14400545807000	13900	7130	0	0	\N
281108	1678	14400545808000	13900	7130	1	0	\N
281109	1678	14400545809000	13900	7130	2	0	\N
281110	1678	14400545810000	13900	7130	3	0	\N
281111	1678	14400545811000	13900	7130	4	0	\N
281112	1874	2269000	13900	7130	5	0	\N
281043	1678	14400545805000	13897	7129	0	0	0
281044	1678	14400545806000	13897	7129	1	0	0
281076	1678	14400545807000	13899	7130	0	0	0
281077	1678	14400545808000	13899	7130	1	0	0
281078	1678	14400545809000	13899	7130	2	0	0
281080	1678	14400545811000	13899	7130	4	0	0
281081	1874	2269000	13899	7130	5	0	1
281082	1874	2271000	13899	7130	6	0	1
281083	1874	2272000	13899	7130	7	0	1
281084	1874	2275000	13899	7130	8	0	1
281086	1874	2278000	13899	7130	10	0	1
281087	1874	2281000	13899	7130	11	0	1
281088	1874	2283000	13899	7130	12	0	1
281089	1874	2284000	13899	7130	13	0	1
281091	1874	2289000	13899	7130	15	0	1
281092	1874	2290000	13899	7130	16	0	1
281093	1874	2293000	13899	7130	17	0	1
281094	1874	2295000	13899	7130	18	0	1
281095	1874	2296000	13899	7130	19	0	1
281097	1874	2299000	13899	7130	21	0	1
281098	1874	2301000	13899	7130	22	0	1
281099	1874	2304000	13899	7130	23	0	1
281100	1874	2305000	13899	7130	24	0	1
281101	1874	2307000	13899	7130	25	0	1
281103	1874	2311000	13899	7130	27	0	1
281104	1874	2313000	13899	7130	28	0	1
281105	1874	2316000	13899	7130	29	0	1
281106	1874	2317000	13899	7130	30	0	1
281113	1874	2271000	13900	7130	6	0	\N
281114	1874	2272000	13900	7130	7	0	\N
281115	1874	2275000	13900	7130	8	0	\N
281116	1874	2277000	13900	7130	9	0	\N
281117	1874	2278000	13900	7130	10	0	\N
281118	1874	2281000	13900	7130	11	0	\N
281119	1874	2283000	13900	7130	12	0	\N
281120	1874	2284000	13900	7130	13	0	\N
281121	1874	2287000	13900	7130	14	0	\N
281122	1874	2289000	13900	7130	15	0	\N
281123	1874	2290000	13900	7130	16	0	\N
281124	1678	14400545807000	13901	7130	0	0	\N
281125	1678	14400545808000	13901	7130	1	0	\N
281126	1678	14400545809000	13901	7130	2	0	\N
281127	1678	14400545810000	13901	7130	3	0	\N
281128	1678	14400545811000	13901	7130	4	0	\N
281129	1874	2269000	13901	7130	5	0	\N
281130	1874	2271000	13901	7130	6	0	\N
281131	1874	2272000	13901	7130	7	0	\N
281132	1874	2275000	13901	7130	8	0	\N
281133	1874	2277000	13901	7130	9	0	\N
281134	1874	2278000	13901	7130	10	0	\N
281135	1874	2281000	13901	7130	11	0	\N
281136	1874	2283000	13901	7130	12	0	\N
281137	1874	2284000	13901	7130	13	0	\N
281138	1874	2287000	13901	7130	14	0	\N
281139	1874	2289000	13901	7130	15	0	\N
281140	1874	2290000	13901	7130	16	0	\N
281141	1874	2293000	13901	7130	17	0	\N
281142	1874	2295000	13901	7130	18	0	\N
281143	1874	2296000	13901	7130	19	0	\N
281144	1874	2298000	13901	7130	20	0	\N
281145	1874	2299000	13901	7130	21	0	\N
281146	1874	2301000	13901	7130	22	0	\N
281147	1874	2304000	13901	7130	23	0	\N
281148	1874	2305000	13901	7130	24	0	\N
281149	1874	2307000	13901	7130	25	0	\N
281150	1874	2310000	13901	7130	26	0	\N
281151	1874	2311000	13901	7130	27	0	\N
281152	1874	2313000	13901	7130	28	0	\N
281153	1874	2316000	13901	7130	29	0	\N
281154	1874	2317000	13901	7130	30	0	\N
281155	1678	14400545807000	13902	7130	0	0	\N
281156	1678	14400545808000	13902	7130	1	0	\N
281157	1678	14400545809000	13902	7130	2	0	\N
281158	1678	14400545810000	13902	7130	3	0	\N
281159	1678	14400545811000	13902	7130	4	0	\N
281160	1874	2269000	13902	7130	5	0	\N
281161	1874	2271000	13902	7130	6	0	\N
281162	1874	2272000	13902	7130	7	0	\N
281163	1874	2275000	13902	7130	8	0	\N
281164	1874	2277000	13902	7130	9	0	\N
281165	1874	2278000	13902	7130	10	0	\N
281166	1874	2281000	13902	7130	11	0	\N
281167	1874	2283000	13902	7130	12	0	\N
281168	1874	2284000	13902	7130	13	0	\N
281169	1874	2287000	13902	7130	14	0	\N
281170	1874	2289000	13902	7130	15	0	\N
281171	1874	2290000	13902	7130	16	0	\N
281172	1874	2293000	13902	7130	17	0	\N
281173	1874	2295000	13902	7130	18	0	\N
281174	1874	2296000	13902	7130	19	0	\N
281175	1874	2298000	13902	7130	20	0	\N
281176	1874	2299000	13902	7130	21	0	\N
281177	1874	2301000	13902	7130	22	0	\N
281178	1874	2304000	13902	7130	23	0	\N
281179	1874	2305000	13902	7130	24	0	\N
281180	1874	2307000	13902	7130	25	0	\N
281181	1874	2310000	13902	7130	26	0	\N
281182	1874	2311000	13902	7130	27	0	\N
281183	1874	2313000	13902	7130	28	0	\N
281184	1874	2316000	13902	7130	29	0	\N
281185	1874	2317000	13902	7130	30	0	\N
281186	1678	14400545807000	13903	7130	0	0	\N
281187	1678	14400545808000	13903	7130	1	0	\N
281188	1678	14400545809000	13903	7130	2	0	\N
281189	1678	14400545810000	13903	7130	3	0	\N
281190	1678	14400545811000	13903	7130	4	0	\N
281191	1874	2269000	13903	7130	5	0	\N
281192	1874	2271000	13903	7130	6	0	\N
281193	1874	2272000	13903	7130	7	0	\N
281194	1874	2275000	13903	7130	8	0	\N
281195	1874	2277000	13903	7130	9	0	\N
281196	1874	2278000	13903	7130	10	0	\N
281197	1874	2281000	13903	7130	11	0	\N
281198	1874	2283000	13903	7130	12	0	\N
281199	1874	2284000	13903	7130	13	0	\N
281200	1874	2287000	13903	7130	14	0	\N
281201	1874	2289000	13903	7130	15	0	\N
281202	1874	2290000	13903	7130	16	0	\N
281207	1678	14400545812000	13905	7131	0	0	\N
281208	1874	2319000	13905	7131	1	0	\N
281209	1874	2322000	13905	7131	2	0	\N
281210	1874	2323000	13905	7131	3	0	\N
281215	1678	14400545814000	13907	7133	0	0	\N
281216	1678	14400545815000	13907	7133	1	0	\N
281217	1874	2331000	13907	7133	2	0	\N
281218	1874	2334000	13907	7133	3	0	\N
281219	1874	2335000	13907	7133	4	0	\N
281220	1874	2337000	13907	7133	5	0	\N
281221	1874	2340000	13907	7133	6	0	\N
281222	1874	2341000	13907	7133	7	0	\N
281231	1678	14400545814000	13909	7133	0	0	\N
281232	1678	14400545815000	13909	7133	1	0	\N
281237	1678	14400545816000	13911	7134	0	0	\N
281238	1874	2343000	13911	7134	1	0	\N
281239	1874	2346000	13911	7134	2	0	\N
281240	1874	2347000	13911	7134	3	0	\N
281241	1678	14400545816000	13912	7134	0	0	\N
281242	1874	2343000	13912	7134	1	0	\N
281243	1874	2346000	13912	7134	2	0	\N
281245	1678	14400545817000	13914	7135	0	0	\N
281246	1874	2263000	13915	7127	0	0	\N
281247	1874	2265000	13915	7127	1	0	\N
281248	1874	2266000	13915	7127	2	0	\N
281205	1874	2322000	13904	7131	2	0	1
281206	1874	2323000	13904	7131	3	0	1
281211	1678	14400545813000	13906	7132	0	0	0
281212	1874	2325000	13906	7132	1	0	1
281213	1874	2328000	13906	7132	2	0	1
281223	1678	14400545814000	13908	7133	0	0	0
281224	1678	14400545815000	13908	7133	1	0	0
281225	1874	2331000	13908	7133	2	0	1
281226	1874	2334000	13908	7133	3	0	1
281227	1874	2335000	13908	7133	4	0	1
281229	1874	2340000	13908	7133	6	0	1
281230	1874	2341000	13908	7133	7	0	1
281233	1678	14400545816000	13910	7134	0	0	0
281234	1874	2343000	13910	7134	1	0	1
281236	1874	2347000	13910	7134	3	0	1
281244	1678	14400545817000	13913	7135	0	0	0
281249	1678	14400545817000	13916	7135	0	0	\N
281250	1874	2349000	13916	7135	1	0	\N
281251	1874	2352000	13916	7135	2	0	\N
281252	1874	2353000	13916	7135	4	0	\N
281253	1678	14400545817000	13917	7135	0	0	\N
281254	1874	2349000	13917	7135	1	0	\N
281255	1874	2352000	13917	7135	2	0	\N
281256	1874	2353000	13917	7135	4	0	\N
281268	1678	14400545820000	13921	7138	0	0	\N
281269	1874	2367000	13921	7138	1	0	\N
281270	1874	2370000	13921	7138	2	0	\N
281271	1874	2371000	13921	7138	3	0	\N
281276	1678	14400545820000	13923	7138	0	0	\N
281277	1874	2367000	13923	7138	1	0	\N
281278	1874	2370000	13923	7138	2	0	\N
281279	1874	2371000	13923	7138	3	0	\N
281280	1678	14400545820000	13924	7138	0	0	\N
281281	1874	2367000	13924	7138	1	0	\N
281282	1874	2370000	13924	7138	2	0	\N
281283	1874	2371000	13924	7138	3	0	\N
281284	1678	14400545820000	13925	7138	0	0	\N
281285	1874	2367000	13925	7138	1	0	\N
281286	1874	2370000	13925	7138	2	0	\N
281287	1874	2371000	13925	7138	3	0	\N
281288	1678	14400545820000	13926	7138	0	0	\N
281290	1678	14400545821000	13928	7139	0	0	\N
281291	1874	2373000	13928	7139	1	0	\N
281292	1874	2376000	13928	7139	2	0	\N
281293	1678	14400545821000	13929	7139	0	0	\N
281294	1874	2373000	13929	7139	1	0	\N
281295	1874	2376000	13929	7139	2	0	\N
281313	1678	14400545826000	13934	7142	0	0	\N
281314	1874	2402000	13934	7142	1	0	\N
281315	1874	2404000	13934	7142	2	0	\N
281316	1874	2405000	13934	7142	3	0	\N
281321	1678	14400545826000	13936	7142	0	0	\N
281322	1678	14400545826000	13937	7142	0	0	\N
281323	1874	2402000	13937	7142	1	0	\N
281324	1874	2404000	13937	7142	2	0	\N
281325	1874	2405000	13937	7142	3	0	\N
281326	1678	14400545826000	13938	7142	0	0	\N
281331	1678	14400545827000	13941	7143	0	0	\N
281332	1874	2402000	13941	7143	1	0	\N
281333	1874	2404000	13941	7143	2	0	\N
281334	1874	2405000	13941	7143	3	0	\N
281335	1874	2408000	13941	7143	4	0	\N
281336	1874	2410000	13941	7143	5	0	\N
281337	1874	2411000	13941	7143	6	0	\N
281342	1678	14400545828000	13943	7144	0	0	\N
281343	1874	2413000	13943	7144	1	0	\N
281344	1950	5449852000000	13943	7144	2	0	\N
281345	1874	2414000	13943	7144	3	0	\N
281354	1678	14400545830000	13946	7146	0	0	\N
281355	1874	2422000	13946	7146	1	0	\N
281356	1874	2425000	13946	7146	2	0	\N
281357	1874	2426000	13946	7146	3	0	\N
281358	1678	14400545831000	13947	7147	0	0	\N
281367	1678	14400545833000	13950	7149	0	0	\N
281368	1874	2440000	13950	7149	1	0	\N
281369	1874	2443000	13950	7149	2	0	\N
281370	1874	2444000	13950	7149	3	0	\N
281372	1678	14400545833000	13952	7149	0	0	\N
281259	1874	2349000	13920	7137	2	0	1
281260	1874	2352000	13920	7137	3	0	1
281261	1874	2353000	13920	7137	4	0	1
281262	1874	2355000	13920	7137	5	0	1
281263	1874	2358000	13920	7137	6	0	1
281265	1874	2361000	13920	7137	8	0	1
281266	1874	2364000	13920	7137	9	0	1
281267	1874	2365000	13920	7137	10	0	1
281272	1678	14400545820000	13922	7138	0	0	0
281273	1874	2367000	13922	7138	1	0	1
281275	1874	2371000	13922	7138	3	0	1
281289	1678	14400545821000	13927	7139	0	0	0
281296	1678	14400545822000	13930	7140	0	0	0
281297	1874	2373000	13930	7140	1	0	1
281299	1874	2377000	13930	7140	3	0	1
281300	1874	2379000	13930	7140	4	0	1
281301	1874	2382000	13930	7140	5	0	1
281302	1678	14400545823000	13932	7141	0	0	0
281303	1678	14400545824000	13932	7141	1	0	0
281305	1874	2385000	13932	7141	3	0	1
281306	1874	2387000	13932	7141	4	0	1
281307	1874	2390000	13932	7141	5	0	1
281308	1874	2392000	13932	7141	6	0	1
281309	1874	2393000	13932	7141	7	0	1
281311	1874	2398000	13932	7141	9	0	1
281312	1874	2399000	13932	7141	10	0	1
281317	1678	14400545826000	13935	7142	0	0	0
281318	1874	2402000	13935	7142	1	0	1
281320	1874	2405000	13935	7142	3	0	1
281327	1678	14400545827000	13940	7143	0	0	0
281328	1874	2408000	13940	7143	1	0	1
281329	1874	2410000	13940	7143	2	0	1
281330	1874	2411000	13940	7143	3	0	1
281339	1874	2413000	13942	7144	1	0	1
281340	1950	5449852000000	13942	7144	2	0	13
281341	1874	2414000	13942	7144	3	0	1
281346	1678	14400545829000	13944	7145	0	0	0
281347	1874	2416000	13944	7145	1	0	1
281349	1874	2420000	13944	7145	3	0	1
281350	1678	14400545830000	13945	7146	0	0	0
281351	1874	2422000	13945	7146	1	0	1
281352	1874	2425000	13945	7146	2	0	1
281359	1678	14400545831000	13948	7147	0	0	0
281360	1874	2428000	13948	7147	1	0	1
281361	1874	2431000	13948	7147	2	0	1
281362	1874	2432000	13948	7147	3	0	1
281363	1678	14400545832000	13949	7148	0	0	0
281365	1874	2437000	13949	7148	2	0	1
281366	1874	2438000	13949	7148	3	0	1
281371	1678	14400545833000	13951	7149	0	0	0
281373	1874	2440000	13953	7150	0	0	1
281374	1874	2443000	13953	7150	1	0	1
281376	1678	14400545834000	13954	7151	0	0	0
281377	1874	2446000	13954	7151	1	0	1
281378	1874	2449000	13954	7151	2	0	1
281379	1874	2450000	13954	7151	3	0	1
281381	1874	2455000	13954	7151	5	0	1
281382	1874	2456000	13954	7151	6	0	1
281383	1678	14400545835000	13955	7152	0	0	0
281384	1678	14400545836000	13955	7152	1	0	0
281390	1678	14400545837000	13956	7153	0	0	\N
281391	1874	2468000	13956	7153	1	0	\N
281392	1874	2470000	13956	7153	2	0	\N
281393	1874	2473000	13956	7153	3	0	\N
281395	1678	14400545837000	13958	7153	0	0	\N
281396	1678	14400545838000	13959	7154	0	0	\N
281397	1678	14400545839000	13959	7154	1	0	\N
281398	1874	2468000	13959	7154	2	0	\N
281399	1874	2470000	13959	7154	3	0	\N
281400	1874	2473000	13959	7154	4	0	\N
281401	1874	2474000	13959	7154	5	0	\N
281402	1874	2476000	13959	7154	6	0	\N
281403	1874	2479000	13959	7154	7	0	\N
281404	1874	2480000	13959	7154	8	0	\N
281405	1874	2482000	13959	7154	9	0	\N
281406	1874	2485000	13959	7154	10	0	\N
281447	1678	14400545840000	13963	7156	0	0	\N
281448	1950	5499852000000	13963	7156	1	0	\N
281449	1678	14400545841000	13963	7156	2	0	\N
281450	1678	14400545842000	13963	7156	3	0	\N
281451	1678	14400545843000	13963	7156	4	0	\N
281452	1678	14400545844000	13963	7156	5	0	\N
281453	1678	14400545845000	13963	7156	6	0	\N
281454	1678	14400545846000	13963	7156	7	0	\N
281455	1874	2486000	13963	7156	8	0	\N
281456	1874	2488000	13963	7156	9	0	\N
281457	1874	2491000	13963	7156	10	0	\N
281458	1874	2492000	13963	7156	11	0	\N
281459	1874	2494000	13963	7156	12	0	\N
281460	1678	14400545840000	13964	7156	0	0	\N
281461	1950	5499852000000	13964	7156	1	0	\N
281462	1678	14400545841000	13964	7156	2	0	\N
281463	1678	14400545842000	13964	7156	3	0	\N
281464	1678	14400545843000	13964	7156	4	0	\N
281465	1678	14400545844000	13964	7156	5	0	\N
281466	1678	14400545845000	13964	7156	6	0	\N
281467	1678	14400545846000	13964	7156	7	0	\N
281468	1874	2486000	13964	7156	8	0	\N
281469	1874	2488000	13964	7156	9	0	\N
281470	1874	2491000	13964	7156	10	0	\N
281471	1874	2492000	13964	7156	11	0	\N
281472	1874	2494000	13964	7156	12	0	\N
281477	1678	14400545847000	13966	7157	0	0	\N
281478	1678	14400545848000	13967	7158	0	0	\N
281479	1874	2534000	13967	7158	1	0	\N
281480	1874	2536000	13967	7158	2	0	\N
281481	1874	2539000	13967	7158	3	0	\N
281483	1950	6169852000000	13969	7159	0	0	\N
281484	1678	14400545849000	13969	7159	1	0	\N
281485	1678	14400545850000	13969	7159	2	0	\N
281486	1874	2534000	13969	7159	3	0	\N
281487	1874	2536000	13969	7159	4	0	\N
281488	1874	2539000	13969	7159	5	0	\N
281489	1874	2541000	13969	7159	6	0	\N
281490	1874	2542000	13969	7159	7	0	\N
281491	1874	2545000	13969	7159	8	0	\N
281492	1874	2547000	13969	7159	9	0	\N
281493	1874	2548000	13969	7159	10	0	\N
281494	1874	2551000	13969	7159	11	0	\N
281507	1950	6169852000000	13971	7159	0	0	\N
281508	1678	14400545849000	13971	7159	1	0	\N
281509	1678	14400545850000	13971	7159	2	0	\N
281518	1678	15120584851000	13973	7160	0	0	\N
281519	1678	15120584852000	13973	7160	1	0	\N
281520	1678	15120584851000	13974	7160	0	0	\N
281387	1874	2462000	13955	7152	4	0	1
281388	1874	2464000	13955	7152	5	0	1
281389	1874	2467000	13955	7152	6	0	1
281394	1678	14400545837000	13957	7153	0	0	0
281407	1678	14400545838000	13960	7154	0	0	0
281409	1874	2468000	13960	7154	2	0	1
281410	1874	2470000	13960	7154	3	0	1
281411	1874	2473000	13960	7154	4	0	1
281412	1874	2474000	13960	7154	5	0	1
281413	1874	2476000	13960	7154	6	0	1
281415	1874	2480000	13960	7154	8	0	1
281416	1874	2482000	13960	7154	9	0	1
281417	1874	2485000	13960	7154	10	0	1
281418	1678	14400545840000	13962	7156	0	0	0
281420	1678	14400545841000	13962	7156	2	0	0
281421	1678	14400545842000	13962	7156	3	0	0
281422	1678	14400545843000	13962	7156	4	0	0
281423	1678	14400545844000	13962	7156	5	0	0
281424	1678	14400545845000	13962	7156	6	0	0
281426	1874	2486000	13962	7156	8	0	1
281427	1874	2488000	13962	7156	9	0	1
281428	1874	2491000	13962	7156	10	0	1
281429	1874	2492000	13962	7156	11	0	1
281430	1874	2494000	13962	7156	12	0	1
281432	1874	2498000	13962	7156	14	0	1
281433	1874	2500000	13962	7156	15	0	1
281434	1874	2503000	13962	7156	16	0	1
281435	1874	2504000	13962	7156	17	0	1
281437	1874	2509000	13962	7156	19	0	1
281438	1874	2510000	13962	7156	20	0	1
281439	1874	2512000	13962	7156	21	0	1
281440	1874	2515000	13962	7156	22	0	1
281441	1874	2516000	13962	7156	23	0	1
281443	1874	2521000	13962	7156	25	0	1
281444	1874	2522000	13962	7156	26	0	1
281445	1874	2524000	13962	7156	27	0	1
281446	1874	2527000	13962	7156	28	0	1
281473	1678	14400545847000	13965	7157	0	0	0
281475	1874	2530000	13965	7157	2	0	1
281476	1874	2533000	13965	7157	3	0	1
281482	1678	14400545848000	13968	7158	0	0	0
281495	1950	6169852000000	13970	7159	0	0	13
281497	1678	14400545850000	13970	7159	2	0	0
281498	1874	2534000	13970	7159	3	0	1
281499	1874	2536000	13970	7159	4	0	1
281500	1874	2539000	13970	7159	5	0	1
281501	1874	2541000	13970	7159	6	0	1
281503	1874	2545000	13970	7159	8	0	1
281504	1874	2547000	13970	7159	9	0	1
281505	1874	2548000	13970	7159	10	0	1
281506	1874	2551000	13970	7159	11	0	1
281510	1678	15120584851000	13972	7160	0	0	0
281512	1874	2553000	13972	7160	2	0	1
281513	1874	2554000	13972	7160	3	0	1
281514	1874	2557000	13972	7160	4	0	1
281515	1874	2559000	13972	7160	5	0	1
281517	1874	2563000	13972	7160	7	0	1
281521	1678	15120584852000	13974	7160	1	0	\N
281522	1874	2553000	13974	7160	2	0	\N
281523	1874	2554000	13974	7160	3	0	\N
281524	1874	2557000	13974	7160	4	0	\N
281525	1874	2559000	13974	7160	5	0	\N
281526	1874	2560000	13974	7160	6	0	\N
281527	1874	2563000	13974	7160	7	0	\N
281532	1678	15120584853000	13976	7161	0	0	\N
281533	1874	2565000	13976	7161	1	0	\N
281534	1874	2566000	13976	7161	2	0	\N
281535	1874	2569000	13976	7161	3	0	\N
281536	1678	15120584853000	13977	7161	0	0	\N
281537	1874	2565000	13977	7161	1	0	\N
281538	1874	2566000	13977	7161	2	0	\N
281539	1874	2569000	13977	7161	3	0	\N
281540	1678	15120584854000	13978	7162	0	0	\N
281541	1678	15120584855000	13978	7162	1	0	\N
281542	1678	15120584856000	13978	7162	2	0	\N
281543	1874	2571000	13978	7162	3	0	\N
281544	1874	2572000	13978	7162	4	0	\N
281545	1874	2575000	13978	7162	5	0	\N
281546	1874	2577000	13978	7162	6	0	\N
281547	1874	2578000	13978	7162	7	0	\N
281548	1874	2581000	13978	7162	8	0	\N
281549	1874	2583000	13978	7162	9	0	\N
281550	1874	2584000	13978	7162	10	0	\N
281551	1874	2587000	13978	7162	11	0	\N
281556	1678	15120584857000	13980	7163	0	0	\N
281557	1678	15120584858000	13980	7163	1	0	\N
281558	1874	2572000	13980	7163	2	0	\N
281559	1874	2575000	13980	7163	3	0	\N
281560	1874	2577000	13980	7163	4	0	\N
281561	1874	2578000	13980	7163	5	0	\N
281562	1874	2581000	13980	7163	6	0	\N
281563	1874	2583000	13980	7163	7	0	\N
281564	1874	2584000	13980	7163	8	0	\N
281565	1874	2587000	13980	7163	9	0	\N
281566	1874	2589000	13980	7163	10	0	\N
281567	1874	2590000	13980	7163	11	0	\N
281568	1874	2593000	13980	7163	12	0	\N
281569	1874	2595000	13980	7163	13	0	\N
281570	1874	2596000	13980	7163	14	0	\N
281571	1874	2599000	13980	7163	15	0	\N
281588	1678	15120584857000	13982	7163	0	0	\N
281589	1678	15120584858000	13982	7163	1	0	\N
281590	1678	15120584859000	13982	7163	2	0	\N
281591	1874	2572000	13982	7163	3	0	\N
281592	1874	2575000	13982	7163	4	0	\N
281593	1874	2577000	13982	7163	5	0	\N
281594	1874	2578000	13982	7163	6	0	\N
281595	1874	2581000	13982	7163	7	0	\N
281596	1874	2583000	13982	7163	8	0	\N
281597	1874	2584000	13982	7163	9	0	\N
281598	1874	2587000	13982	7163	10	0	\N
281603	1950	4999852000000	13984	7128	0	0	\N
281604	1950	5669852000000	13984	7128	1	0	\N
281605	1950	6169852000000	13984	7128	2	0	\N
281616	1678	15120584862000	13987	7167	0	0	\N
281617	1874	2623000	13987	7167	1	0	\N
281618	1874	2625000	13987	7167	2	0	\N
281619	1874	2626000	13987	7167	3	0	\N
281632	1678	15120584865000	13990	7169	0	0	\N
281633	1874	2638000	13990	7169	1	0	\N
281634	1874	2641000	13990	7169	2	0	\N
281635	1874	2643000	13990	7169	3	0	\N
281636	1678	15120584865000	13991	7169	0	0	\N
281637	1874	2638000	13991	7169	1	0	\N
281638	1874	2641000	13991	7169	2	0	\N
281639	1874	2643000	13991	7169	3	0	\N
281640	1678	15120584865000	13992	7169	0	0	\N
281641	1874	2638000	13992	7169	1	0	\N
281642	1874	2641000	13992	7169	2	0	\N
281643	1874	2643000	13992	7169	3	0	\N
281653	1678	15120584866000	13995	7170	0	0	\N
281654	1874	2638000	13995	7170	1	0	\N
281655	1745	1803000000	13995	7170	2	0	\N
281656	1874	2641000	13995	7170	3	0	\N
281530	1874	2566000	13975	7161	2	0	1
281531	1874	2569000	13975	7161	3	0	1
281552	1678	15120584854000	13979	7162	0	0	0
281553	1678	15120584855000	13979	7162	1	0	0
281554	1678	15120584856000	13979	7162	2	0	0
281572	1678	15120584857000	13981	7163	0	0	0
281573	1678	15120584858000	13981	7163	1	0	0
281574	1874	2572000	13981	7163	2	0	1
281575	1874	2575000	13981	7163	3	0	1
281576	1874	2577000	13981	7163	4	0	1
281578	1874	2581000	13981	7163	6	0	1
281579	1874	2583000	13981	7163	7	0	1
281580	1874	2584000	13981	7163	8	0	1
281581	1874	2587000	13981	7163	9	0	1
281583	1874	2590000	13981	7163	11	0	1
281584	1874	2593000	13981	7163	12	0	1
281585	1874	2595000	13981	7163	13	0	1
281586	1874	2596000	13981	7163	14	0	1
281587	1874	2599000	13981	7163	15	0	1
281600	1874	2601000	13983	7164	1	0	1
281601	1874	2602000	13983	7164	2	0	1
281602	1874	2605000	13983	7164	3	0	1
281606	1678	15120584860000	13985	7165	0	0	0
281607	1874	2607000	13985	7165	1	0	1
281609	1874	2611000	13985	7165	3	0	1
281610	1874	2613000	13985	7165	4	0	1
281611	1874	2614000	13985	7165	5	0	1
281612	1678	15120584861000	13986	7166	0	0	0
281614	1874	2619000	13986	7166	2	0	1
281615	1874	2620000	13986	7166	3	0	1
281620	1678	15120584862000	13988	7167	0	0	0
281621	1874	2623000	13988	7167	1	0	1
281622	1874	2625000	13988	7167	2	0	1
281624	1678	15120584863000	13989	7168	0	0	0
281625	1678	15120584864000	13989	7168	1	0	0
281626	1483	10000000	13989	7168	2	0	0
281627	1874	2629000	13989	7168	3	0	1
281628	1874	2631000	13989	7168	4	0	1
281630	1874	2635000	13989	7168	6	0	1
281631	1874	2637000	13989	7168	8	0	1
281644	1678	15120584865000	13993	7169	0	0	0
281645	1678	15120584866000	13994	7170	0	0	0
281647	1745	1803000000	13994	7170	2	0	5
281648	1874	2641000	13994	7170	3	0	1
281649	1874	2643000	13994	7170	4	0	1
281650	1874	2644000	13994	7170	5	0	1
281651	1874	2647000	13994	7170	6	0	1
281657	1874	2643000	13995	7170	4	0	\N
281667	1678	15120584867000	13997	7171	0	0	\N
281668	1678	15120584868000	13997	7171	1	0	\N
281669	1406	0	13997	7171	2	0	\N
281670	1423	2913248999985	13997	7171	3	0	\N
281671	1874	2652000	13997	7171	4	0	\N
281672	1874	2654000	13997	7171	5	0	\N
281673	1874	2657000	13997	7171	6	0	\N
281674	1874	2658000	13997	7171	7	0	\N
281675	1874	2660000	13997	7171	8	0	\N
281676	1678	15120584869000	13998	7172	0	0	\N
281677	1874	2663000	13998	7172	1	0	\N
281678	1874	2664000	13998	7172	2	0	\N
281679	1874	2666000	13998	7172	3	0	\N
281681	1483	10000000	14000	7129	0	0	\N
281682	1406	0	14000	7129	1	0	\N
281683	1402	35854146319298	14000	7129	2	0	\N
281684	1745	1803000000	14000	7129	3	0	\N
281685	1423	2913248999985	14000	7129	4	0	\N
281718	2047	41290000	14005	7177	0	0	\N
281719	1678	15120584877000	14005	7177	1	0	\N
281720	1678	15120584878000	14005	7177	2	0	\N
281721	1678	15120584879000	14005	7177	3	0	\N
281722	1874	2708000	14005	7177	4	0	\N
281723	1874	2711000	14005	7177	5	0	\N
281724	1874	2712000	14005	7177	6	0	\N
281725	1874	2714000	14005	7177	7	0	\N
281726	1874	2717000	14005	7177	8	0	\N
281727	1874	2718000	14005	7177	9	0	\N
281728	1874	2720000	14005	7177	10	0	\N
281729	1874	2723000	14005	7177	11	0	\N
281730	1874	2724000	14005	7177	12	0	\N
281748	1678	15120584881000	14008	7179	0	0	\N
281749	1745	1803000000	14008	7179	1	0	\N
281750	1874	2732000	14008	7179	2	0	\N
281751	1874	2735000	14008	7179	3	0	\N
281752	1874	2736000	14008	7179	4	0	\N
281771	1678	15120584884000	14013	7182	0	0	\N
281772	1745	1803000000	14013	7182	1	0	\N
281773	1678	15120584885000	14014	7183	0	0	\N
281774	613	66000000000000	14014	7183	1	0	\N
281775	1874	2753000	14014	7183	2	0	\N
281776	1874	2755000	14014	7183	3	0	\N
281777	1874	2758000	14014	7183	4	0	\N
281778	1678	15120584885000	14015	7183	0	0	\N
281779	613	66000000000000	14015	7183	1	0	\N
281780	1874	2753000	14015	7183	2	0	\N
281781	1874	2755000	14015	7183	3	0	\N
281782	1874	2758000	14015	7183	4	0	\N
281789	2047	41200000	14018	7131	0	0	\N
281790	2047	41290000	14018	7131	1	0	\N
281791	1950	4999852000000	14018	7131	2	0	\N
281792	1950	5669852000000	14018	7131	3	0	\N
281660	1406	0	13996	7171	2	0	0
281661	1423	2913248999985	13996	7171	3	0	15
281662	1874	2652000	13996	7171	4	0	1
281663	1874	2654000	13996	7171	5	0	1
281664	1874	2657000	13996	7171	6	0	1
281666	1874	2660000	13996	7171	8	0	1
281680	1678	15120584869000	13999	7172	0	0	0
281686	1678	15120584870000	14001	7173	0	0	0
281687	1678	15120584871000	14001	7173	1	0	0
281688	1678	15120584872000	14001	7173	2	0	0
281690	1402	36574159319298	14001	7173	4	0	33
281691	1874	2664000	14001	7173	5	0	1
281692	1874	2666000	14001	7173	6	0	1
281693	1874	2669000	14001	7173	7	0	1
281695	1874	2672000	14001	7173	9	0	1
281696	1874	2675000	14001	7173	10	0	1
281697	1874	2676000	14001	7173	11	0	1
281698	1874	2678000	14001	7173	12	0	1
281699	1874	2681000	14001	7173	13	0	1
281701	1874	2684000	14001	7173	15	0	1
281702	1678	15120584873000	14002	7174	0	0	0
281703	1678	15120584874000	14003	7175	0	0	0
281704	2047	41200000	14004	7176	0	0	0
281705	1678	15120584875000	14004	7176	1	0	0
281707	1874	2687000	14004	7176	3	0	1
281708	1874	2688000	14004	7176	4	0	1
281709	1874	2690000	14004	7176	5	0	1
281710	1874	2693000	14004	7176	6	0	1
281712	1874	2696000	14004	7176	8	0	1
281713	1874	2699000	14004	7176	9	0	1
281714	1874	2700000	14004	7176	10	0	1
281715	1874	2702000	14004	7176	11	0	1
281716	1874	2705000	14004	7176	12	0	1
281731	2047	41290000	14006	7177	0	0	0
281732	1678	15120584877000	14006	7177	1	0	0
281733	1678	15120584878000	14006	7177	2	0	0
281734	1678	15120584879000	14006	7177	3	0	0
281735	1678	15120584880000	14007	7178	0	0	0
281737	1874	2711000	14007	7178	2	0	1
281738	1874	2712000	14007	7178	3	0	1
281739	1874	2714000	14007	7178	4	0	1
281740	1874	2717000	14007	7178	5	0	1
281742	1874	2720000	14007	7178	7	0	1
281743	1874	2723000	14007	7178	8	0	1
281744	1874	2724000	14007	7178	9	0	1
281745	1874	2726000	14007	7178	10	0	1
281746	1874	2729000	14007	7178	11	0	1
281753	1678	15120584881000	14009	7179	0	0	0
281754	1745	1803000000	14009	7179	1	0	5
281755	1678	15120584882000	14010	7180	0	0	0
281756	1874	2732000	14010	7180	1	0	1
281757	1874	2735000	14010	7180	2	0	1
281759	1874	2738000	14010	7180	4	0	1
281760	1874	2741000	14010	7180	5	0	1
281761	1678	15120584883000	14011	7181	0	0	0
281762	1745	1803000000	14011	7181	1	0	5
281764	1874	2746000	14011	7181	3	0	1
281765	1745	1803000000	14011	7181	4	0	5
281766	1678	15120584884000	14012	7182	0	0	0
281767	1745	1803000000	14012	7182	1	0	5
281768	1874	2747000	14012	7182	2	0	1
281770	1874	2752000	14012	7182	4	0	1
281783	1678	15120584885000	14016	7183	0	0	0
281784	613	66000000000000	14016	7183	1	0	0
281785	1874	2753000	14016	7183	2	0	1
281786	1874	2755000	14016	7183	3	0	1
281788	1678	15120584886000	14017	7184	0	0	0
281793	1483	10000000	14018	7131	4	0	\N
281794	1406	0	14018	7131	5	0	\N
281795	1745	1803000000	14018	7131	6	0	\N
281796	1402	35854146319298	14018	7131	7	0	\N
281797	1745	1803000000	14018	7131	8	0	\N
281798	1745	1803000000	14018	7131	9	0	\N
281799	1745	1803000000	14018	7131	10	0	\N
281800	1745	1803000000	14018	7131	11	0	\N
281801	1423	2913248999985	14018	7131	12	0	\N
281802	1950	6169852000000	14018	7131	13	0	\N
281803	1745	1803000000	14018	7131	14	0	\N
281804	613	66000000000000	14018	7131	15	0	\N
281815	1678	15120584887000	14021	7185	0	0	\N
281816	1678	15120584888000	14021	7185	1	0	\N
281817	1745	1803000000	14021	7185	2	0	\N
281818	1874	2760000	14021	7185	3	0	\N
281819	1874	2763000	14021	7185	4	0	\N
281820	1874	2765000	14021	7185	5	0	\N
281821	1874	2768000	14021	7185	6	0	\N
281822	1874	2770000	14021	7185	7	0	\N
281823	1874	2771000	14021	7185	8	0	\N
281824	1874	2774000	14021	7185	9	0	\N
281825	1678	15120584887000	14022	7185	0	0	\N
281826	1678	15120584888000	14022	7185	1	0	\N
281827	1745	1803000000	14022	7185	2	0	\N
281828	1874	2760000	14022	7185	3	0	\N
281829	1874	2763000	14022	7185	4	0	\N
281830	1874	2765000	14022	7185	5	0	\N
281831	1874	2768000	14022	7185	6	0	\N
281832	1874	2770000	14022	7185	7	0	\N
281833	1874	2771000	14022	7185	8	0	\N
281834	1874	2774000	14022	7185	9	0	\N
281835	1678	15120584887000	14023	7185	0	0	\N
281836	1678	15120584888000	14023	7185	1	0	\N
281837	1745	1803000000	14023	7185	2	0	\N
281838	1678	15120584887000	14024	7185	0	0	\N
281839	1678	15120584888000	14024	7185	1	0	\N
281840	1745	1803000000	14024	7185	2	0	\N
281841	1874	2760000	14024	7185	3	0	\N
281842	1874	2763000	14024	7185	4	0	\N
281843	1874	2765000	14024	7185	5	0	\N
281844	1874	2768000	14024	7185	6	0	\N
281845	1874	2770000	14024	7185	7	0	\N
281846	1874	2771000	14024	7185	8	0	\N
281847	1874	2774000	14024	7185	9	0	\N
281848	1678	15120584887000	14025	7185	0	0	\N
281849	1678	15120584888000	14025	7185	1	0	\N
281850	1745	1803000000	14025	7185	2	0	\N
281851	1874	2760000	14025	7185	3	0	\N
281852	1874	2763000	14025	7185	4	0	\N
281853	1874	2765000	14025	7185	5	0	\N
281854	1874	2768000	14025	7185	6	0	\N
281855	1874	2770000	14025	7185	7	0	\N
281856	1874	2771000	14025	7185	8	0	\N
281857	1874	2774000	14025	7185	9	0	\N
281858	1678	15120584887000	14026	7185	0	0	\N
281859	1678	15120584888000	14026	7185	1	0	\N
281860	1745	1803000000	14026	7185	2	0	\N
281861	1874	2760000	14026	7185	3	0	\N
281862	1874	2763000	14026	7185	4	0	\N
281863	1874	2765000	14026	7185	5	0	\N
281864	1874	2768000	14026	7185	6	0	\N
281865	1874	2770000	14026	7185	7	0	\N
281866	1874	2771000	14026	7185	8	0	\N
281867	1874	2774000	14026	7185	9	0	\N
281874	1678	15120584891000	14029	7188	0	0	\N
281881	1678	15120584890000	14031	7187	0	0	\N
281882	1678	15120584891000	14031	7187	1	0	\N
281883	1678	15120584891000	14032	7188	0	0	\N
281884	1874	2782000	14032	7188	1	0	\N
281885	1874	2783000	14032	7188	2	0	\N
281886	1874	2786000	14032	7188	3	0	\N
281887	1874	2788000	14032	7188	4	0	\N
281888	1874	2791000	14032	7188	5	0	\N
281889	1678	15120584891000	14033	7188	0	0	\N
281890	1678	15120584892000	14034	7189	0	0	\N
281891	1874	2793000	14034	7189	1	0	\N
281892	1874	2796000	14034	7189	2	0	\N
281894	1678	15120584892000	14036	7189	0	0	\N
281895	1874	2793000	14036	7189	1	0	\N
281896	1874	2796000	14036	7189	2	0	\N
281897	1678	15120584892000	14037	7189	0	0	\N
281898	1678	15120584893000	14038	7190	0	0	\N
281899	1678	15120584894000	14038	7190	1	0	\N
281908	1678	15120584895000	14040	7191	0	0	\N
281909	1678	15120584896000	14040	7191	1	0	\N
281910	1874	2807000	14040	7191	2	0	\N
281911	1874	2808000	14040	7191	3	0	\N
281912	1874	2810000	14040	7191	4	0	\N
281913	1874	2813000	14040	7191	5	0	\N
281914	1874	2814000	14040	7191	6	0	\N
281915	1874	2816000	14040	7191	7	0	\N
281924	1678	15120584897000	14042	7192	0	0	\N
281925	1678	15120584898000	14042	7192	1	0	\N
281926	1874	2819000	14042	7192	2	0	\N
281927	1874	2820000	14042	7192	3	0	\N
281928	1874	2822000	14042	7192	4	0	\N
281807	1745	1803000000	14020	7185	2	0	5
281808	1874	2760000	14020	7185	3	0	1
281809	1874	2763000	14020	7185	4	0	1
281810	1874	2765000	14020	7185	5	0	1
281811	1874	2768000	14020	7185	6	0	1
281813	1874	2771000	14020	7185	8	0	1
281814	1874	2774000	14020	7185	9	0	1
281868	1678	15120584889000	14027	7186	0	0	0
281869	1874	2776000	14027	7186	1	0	1
281870	1874	2777000	14027	7186	2	0	1
281872	1745	1803000000	14027	7186	4	0	5
281873	1678	15120584890000	14028	7187	0	0	0
281875	1678	15120584891000	14030	7188	0	0	0
281876	1874	2782000	14030	7188	1	0	1
281878	1874	2786000	14030	7188	3	0	1
281879	1874	2788000	14030	7188	4	0	1
281880	1874	2791000	14030	7188	5	0	1
281893	1678	15120584892000	14035	7189	0	0	0
281900	1678	15120584893000	14039	7190	0	0	0
281902	1874	2793000	14039	7190	2	0	1
281903	1874	2796000	14039	7190	3	0	1
281904	1874	2798000	14039	7190	4	0	1
281905	1874	2801000	14039	7190	5	0	1
281906	1874	2802000	14039	7190	6	0	1
281916	1678	15120584895000	14041	7191	0	0	0
281917	1678	15120584896000	14041	7191	1	0	0
281918	1874	2807000	14041	7191	2	0	1
281919	1874	2808000	14041	7191	3	0	1
281921	1874	2813000	14041	7191	5	0	1
281922	1874	2814000	14041	7191	6	0	1
281923	1874	2816000	14041	7191	7	0	1
281929	1874	2825000	14042	7192	5	0	\N
281930	1874	2826000	14042	7192	6	0	\N
281931	1874	2828000	14042	7192	7	0	\N
281934	1678	15120584899000	14044	7193	1	0	\N
281935	1874	2819000	14044	7193	2	0	\N
281936	1874	2820000	14044	7193	3	0	\N
281937	1874	2822000	14044	7193	4	0	\N
281938	1874	2825000	14044	7193	5	0	\N
281939	1874	2826000	14044	7193	6	0	\N
281940	1874	2828000	14044	7193	7	0	\N
281951	1678	15120584899000	14046	7193	1	0	\N
281952	1874	2819000	14046	7193	2	0	\N
281953	1874	2820000	14046	7193	3	0	\N
281954	1874	2822000	14046	7193	4	0	\N
281955	1874	2825000	14046	7193	5	0	\N
281956	1874	2826000	14046	7193	6	0	\N
281957	1874	2828000	14046	7193	7	0	\N
281958	1874	2831000	14046	7193	8	0	\N
281959	1874	2832000	14046	7193	9	0	\N
281960	1874	2834000	14046	7193	10	0	\N
281961	1874	2819000	14047	7193	1	0	\N
281962	1874	2820000	14047	7193	2	0	\N
281963	1874	2822000	14047	7193	3	0	\N
281964	1874	2825000	14047	7193	4	0	\N
281965	1874	2826000	14047	7193	5	0	\N
281966	1874	2828000	14047	7193	6	0	\N
281967	1874	2831000	14047	7193	7	0	\N
281968	1874	2832000	14047	7193	8	0	\N
281969	1874	2834000	14047	7193	9	0	\N
281970	1678	15120584899000	14048	7193	1	0	\N
281971	1874	2819000	14048	7193	2	0	\N
281972	1874	2820000	14048	7193	3	0	\N
281973	1874	2822000	14048	7193	4	0	\N
281974	1874	2825000	14048	7193	5	0	\N
281975	1874	2826000	14048	7193	6	0	\N
281976	1874	2828000	14048	7193	7	0	\N
281977	1874	2831000	14048	7193	8	0	\N
281978	1874	2832000	14048	7193	9	0	\N
281979	1874	2834000	14048	7193	10	0	\N
281980	1678	15120584899000	14049	7193	1	0	\N
281981	1678	15120584899000	14050	7193	1	0	\N
281982	1874	2819000	14050	7193	2	0	\N
281983	1874	2820000	14050	7193	3	0	\N
281984	1874	2822000	14050	7193	4	0	\N
281985	1874	2825000	14050	7193	5	0	\N
281986	1874	2826000	14050	7193	6	0	\N
281987	1874	2828000	14050	7193	7	0	\N
281988	1874	2831000	14050	7193	8	0	\N
281989	1874	2832000	14050	7193	9	0	\N
281990	1874	2834000	14050	7193	10	0	\N
281996	1678	15120584900000	14052	7194	0	0	\N
281997	1745	1803000000	14052	7194	1	0	\N
281998	1874	2837000	14052	7194	2	0	\N
281999	1874	2838000	14052	7194	3	0	\N
282000	1874	2840000	14052	7194	4	0	\N
282001	1678	15120584901000	14053	7195	0	0	\N
282002	1678	15120584902000	14053	7195	1	0	\N
282015	1678	15120584903000	14056	7196	0	0	\N
282016	1874	2855000	14056	7196	1	0	\N
282017	1874	2856000	14056	7196	2	0	\N
282018	1874	2858000	14056	7196	3	0	\N
282019	1874	2855000	14057	7196	0	0	\N
282020	1874	2856000	14057	7196	1	0	\N
282021	1874	2858000	14057	7196	2	0	\N
282022	1874	2855000	14058	7196	0	0	\N
282023	1874	2856000	14058	7196	1	0	\N
282024	1874	2858000	14058	7196	2	0	\N
282033	1678	15120584904000	14060	7197	0	0	\N
282034	1874	2861000	14060	7197	1	0	\N
282035	1652	490000000	14060	7197	2	0	\N
282036	1874	2862000	14060	7197	3	0	\N
282037	1874	2864000	14060	7197	4	0	\N
282038	1874	2867000	14060	7197	5	0	\N
282039	1874	2868000	14060	7197	6	0	\N
282040	1874	2870000	14060	7197	7	0	\N
282041	1678	15120584905000	14061	7198	0	0	\N
282042	1874	2873000	14061	7198	1	0	\N
282043	1874	2874000	14061	7198	2	0	\N
282044	1874	2876000	14061	7198	3	0	\N
282045	1678	15120584905000	14062	7198	0	0	\N
282054	1678	15120584907000	14067	7200	0	0	\N
282055	1678	15120584907000	14068	7200	0	0	\N
282056	1874	2885000	14068	7200	1	0	\N
282057	1874	2886000	14068	7200	2	0	\N
282058	1874	2888000	14068	7200	3	0	\N
282063	1678	15120584907000	14070	7200	0	0	\N
282064	1874	2885000	14070	7200	1	0	\N
281941	1678	15120584899000	14045	7193	1	0	0
281942	1874	2819000	14045	7193	2	0	1
281943	1874	2820000	14045	7193	3	0	1
281944	1874	2822000	14045	7193	4	0	1
281945	1874	2825000	14045	7193	5	0	1
281947	1874	2828000	14045	7193	7	0	1
281948	1874	2831000	14045	7193	8	0	1
281949	1874	2832000	14045	7193	9	0	1
281950	1874	2834000	14045	7193	10	0	1
281991	1678	15120584900000	14051	7194	0	0	0
281993	1874	2837000	14051	7194	2	0	1
281994	1874	2838000	14051	7194	3	0	1
281995	1874	2840000	14051	7194	4	0	1
282003	1678	15120584901000	14054	7195	0	0	0
282005	1874	2843000	14054	7195	2	0	1
282006	1874	2844000	14054	7195	3	0	1
282007	1874	2846000	14054	7195	4	0	1
282008	1874	2849000	14054	7195	5	0	1
282009	1874	2850000	14054	7195	6	0	1
282011	1678	15120584903000	14055	7196	0	0	0
282012	1874	2855000	14055	7196	1	0	1
282013	1874	2856000	14055	7196	2	0	1
282014	1874	2858000	14055	7196	3	0	1
282025	1678	15120584904000	14059	7197	0	0	0
282027	1652	490000000	14059	7197	2	0	3
282028	1874	2862000	14059	7197	3	0	1
282029	1874	2864000	14059	7197	4	0	1
282030	1874	2867000	14059	7197	5	0	1
282032	1874	2870000	14059	7197	7	0	1
282046	1678	15120584905000	14064	7198	0	0	0
282047	1874	2873000	14064	7198	1	0	1
282048	1874	2874000	14064	7198	2	0	1
282049	1874	2876000	14064	7198	3	0	1
282051	1874	2879000	14066	7199	1	0	1
282052	1874	2880000	14066	7199	2	0	1
282053	1874	2882000	14066	7199	3	0	1
282059	1678	15120584907000	14069	7200	0	0	0
282060	1874	2885000	14069	7200	1	0	1
282062	1874	2888000	14069	7200	3	0	1
282065	1874	2886000	14070	7200	2	0	\N
282066	1874	2888000	14070	7200	3	0	\N
282067	2047	41200000	14071	7130	0	0	\N
282068	2047	41290000	14071	7130	1	0	\N
282069	1745	1803000000	14071	7130	3	0	\N
282070	1745	1803000000	14071	7130	4	0	\N
282071	1745	1803000000	14071	7130	5	0	\N
282072	1745	1803000000	14071	7130	6	0	\N
282073	1745	1803000000	14071	7130	7	0	\N
282074	613	66000000000000	14071	7130	8	0	\N
282075	1745	1803000000	14071	7130	9	0	\N
282076	1745	1803000000	14071	7130	10	0	\N
282077	1652	490000000	14071	7130	12	0	\N
282078	1678	15120584908000	14072	7201	0	0	\N
282079	1874	2891000	14072	7201	1	0	\N
282080	1874	2892000	14072	7201	2	0	\N
282081	1874	2894000	14072	7201	3	0	\N
282100	1678	15120584911000	14084	7204	0	0	\N
282101	1874	2909000	14084	7204	1	0	\N
282102	2103	200000000	14084	7204	2	0	\N
282103	2104	200000000	14084	7204	3	0	\N
282104	1874	2910000	14084	7204	4	0	\N
282105	1874	2912000	14084	7204	5	0	\N
282106	2103	1400000000	14085	7205	0	0	\N
282107	1678	15120584912000	14085	7205	1	0	\N
282108	1678	15120584913000	14085	7205	2	0	\N
282109	1874	2915000	14085	7205	3	0	\N
282110	1874	2916000	14085	7205	4	0	\N
282111	1874	2918000	14085	7205	5	0	\N
282112	1874	2921000	14085	7205	6	0	\N
282113	1874	2922000	14085	7205	7	0	\N
282114	1874	2924000	14085	7205	8	0	\N
282115	2103	1400000000	14086	7205	0	0	\N
282116	1678	15120584912000	14086	7205	1	0	\N
282117	1678	15120584913000	14086	7205	2	0	\N
282118	1874	2915000	14086	7205	3	0	\N
282119	1874	2916000	14086	7205	4	0	\N
282120	1874	2918000	14086	7205	5	0	\N
282121	1874	2921000	14086	7205	6	0	\N
282122	1874	2922000	14086	7205	7	0	\N
282123	1874	2924000	14086	7205	8	0	\N
282133	2103	1400000000	14088	7205	0	0	\N
282134	1678	15120584912000	14088	7205	1	0	\N
282135	1678	15120584913000	14088	7205	2	0	\N
282136	1874	2915000	14088	7205	3	0	\N
282137	1874	2916000	14088	7205	4	0	\N
282138	1874	2918000	14088	7205	5	0	\N
282139	1874	2921000	14088	7205	6	0	\N
282140	1874	2922000	14088	7205	7	0	\N
282141	1874	2924000	14088	7205	8	0	\N
282143	1678	15120584914000	14090	7206	0	0	\N
282144	1874	2927000	14090	7206	1	0	\N
282145	1874	2928000	14090	7206	2	0	\N
282146	1874	2930000	14090	7206	3	0	\N
282147	1678	15120584914000	14091	7206	0	0	\N
282148	1874	2927000	14091	7206	1	0	\N
282149	1874	2928000	14091	7206	2	0	\N
282150	1874	2930000	14091	7206	3	0	\N
282151	1678	15120584914000	14092	7206	0	0	\N
282152	1874	2927000	14092	7206	1	0	\N
282153	1874	2928000	14092	7206	2	0	\N
282154	1874	2930000	14092	7206	3	0	\N
282155	1678	15120584914000	14093	7206	0	0	\N
282158	1678	15120584915000	14095	7207	0	0	\N
282159	1745	1803000000	14095	7207	1	0	\N
282160	1874	2927000	14095	7207	2	0	\N
282161	1874	2928000	14095	7207	3	0	\N
282162	1874	2930000	14095	7207	4	0	\N
282163	1874	2933000	14095	7207	5	0	\N
282164	1874	2934000	14095	7207	6	0	\N
282165	1678	15120584915000	14096	7207	0	0	\N
282166	1745	1803000000	14096	7207	1	0	\N
282167	1874	2927000	14096	7207	2	0	\N
282168	1874	2928000	14096	7207	3	0	\N
282169	1874	2930000	14096	7207	4	0	\N
282170	1874	2933000	14096	7207	5	0	\N
282171	1874	2934000	14096	7207	6	0	\N
282181	1678	15120584916000	14098	7208	0	0	\N
282182	1874	2927000	14098	7208	1	0	\N
282183	1874	2928000	14098	7208	2	0	\N
282184	1874	2930000	14098	7208	3	0	\N
282185	1874	2933000	14098	7208	4	0	\N
282186	1874	2934000	14098	7208	5	0	\N
282187	1874	2937000	14098	7208	6	0	\N
282188	1874	2939000	14098	7208	7	0	\N
282189	1874	2940000	14098	7208	8	0	\N
282191	1678	15120584917000	14100	7209	0	0	\N
282192	1874	2943000	14100	7209	1	0	\N
282193	1874	2945000	14100	7209	2	0	\N
282194	1874	2946000	14100	7209	3	0	\N
282084	1874	2892000	14073	7201	2	0	1
282085	1874	2894000	14073	7201	3	0	1
282086	1678	15120584909000	14077	7203	0	0	0
282087	1678	15120584910000	14077	7203	1	0	0
282088	1874	2897000	14077	7203	2	0	1
282090	1874	2900000	14077	7203	4	0	1
282091	1874	2903000	14077	7203	5	0	1
282092	1874	2904000	14077	7203	6	0	1
282093	1874	2906000	14077	7203	7	0	1
282094	1678	15120584911000	14083	7204	0	0	0
282096	2103	200000000	14083	7204	2	0	0
282097	2104	200000000	14083	7204	3	0	0
282098	1874	2910000	14083	7204	4	0	1
282099	1874	2912000	14083	7204	5	0	1
282125	1678	15120584912000	14087	7205	1	0	0
282126	1678	15120584913000	14087	7205	2	0	0
282127	1874	2915000	14087	7205	3	0	1
282128	1874	2916000	14087	7205	4	0	1
282129	1874	2918000	14087	7205	5	0	1
282131	1874	2922000	14087	7205	7	0	1
282132	1874	2924000	14087	7205	8	0	1
282142	1678	15120584914000	14089	7206	0	0	0
282156	1678	15120584915000	14094	7207	0	0	0
282157	1745	1803000000	14094	7207	1	0	5
282173	1874	2927000	14097	7208	1	0	1
282174	1874	2928000	14097	7208	2	0	1
282175	1874	2930000	14097	7208	3	0	1
282176	1874	2933000	14097	7208	4	0	1
282178	1874	2937000	14097	7208	6	0	1
282179	1874	2939000	14097	7208	7	0	1
282180	1874	2940000	14097	7208	8	0	1
282190	1678	15120584917000	14099	7209	0	0	0
282195	1678	15120584918000	14102	7210	0	0	0
282197	1874	2945000	14102	7210	2	0	1
282198	1874	2946000	14102	7210	3	0	1
282199	1874	2949000	14102	7210	4	0	1
282200	1874	2951000	14102	7210	5	0	1
282201	1745	1803000000	14103	7132	1	0	\N
282202	1652	490000000	14103	7132	2	0	\N
282203	1745	1803000000	14103	7132	3	0	\N
282204	1745	1803000000	14103	7132	4	0	\N
282209	1678	15120584919000	14105	7211	0	0	\N
282210	1678	15120584919000	14106	7211	0	0	\N
282211	1874	2952000	14106	7211	1	0	\N
282212	1874	2955000	14106	7211	2	0	\N
282213	1874	2957000	14106	7211	3	0	\N
282218	1678	15120584920000	14108	7212	0	0	\N
282219	1874	2958000	14108	7212	1	0	\N
282220	1874	2961000	14108	7212	2	0	\N
282221	1874	2963000	14108	7212	3	0	\N
282222	1678	15120584920000	14109	7212	0	0	\N
282223	1678	15120584921000	14109	7212	1	0	\N
282224	1874	2958000	14109	7212	2	0	\N
282225	1874	2961000	14109	7212	3	0	\N
282226	1874	2963000	14109	7212	4	0	\N
282227	1678	15120584920000	14110	7212	0	0	\N
282228	1678	15120584921000	14110	7212	1	0	\N
282229	1874	2958000	14110	7212	2	0	\N
282230	1874	2961000	14110	7212	3	0	\N
282231	1874	2963000	14110	7212	4	0	\N
282232	1874	2964000	14110	7212	5	0	\N
282233	1678	15120584921000	14111	7213	0	0	\N
282234	1874	2964000	14111	7213	1	0	\N
282235	1874	2967000	14111	7213	2	0	\N
282236	1874	2969000	14111	7213	3	0	\N
282237	1678	15120584921000	14112	7213	0	0	\N
282238	1874	2964000	14112	7213	1	0	\N
282239	1874	2967000	14112	7213	2	0	\N
282240	1874	2969000	14112	7213	3	0	\N
282265	1678	15120584927000	14118	7217	0	0	\N
282266	1874	3000000	14118	7217	1	0	\N
282267	1874	3003000	14118	7217	2	0	\N
282268	1874	3005000	14118	7217	3	0	\N
282273	1678	15120584927000	14120	7217	0	0	\N
282278	1678	15120584928000	14122	7218	0	0	\N
282279	1874	3006000	14122	7218	1	0	\N
282280	1874	3009000	14122	7218	2	0	\N
282281	1874	3011000	14122	7218	3	0	\N
282282	1678	15120584928000	14123	7218	0	0	\N
282283	1874	3006000	14123	7218	1	0	\N
282284	1874	3009000	14123	7218	2	0	\N
282285	1874	3011000	14123	7218	3	0	\N
282286	1678	15120584929000	14125	7219	0	0	\N
282287	1874	3014000	14125	7219	1	0	\N
282288	1874	3015000	14125	7219	2	0	\N
282289	1874	3017000	14125	7219	3	0	\N
282294	1874	3014000	14127	7219	0	0	\N
282295	1874	3015000	14127	7219	1	0	\N
282296	1874	3017000	14127	7219	2	0	\N
282297	1678	15120584929000	14128	7219	0	0	\N
282298	1874	3014000	14128	7219	1	0	\N
282299	1874	3015000	14128	7219	2	0	\N
282300	1678	15120584922000	14129	7214	0	0	\N
282301	1678	15120584923000	14129	7214	1	0	\N
282302	1678	15120584924000	14129	7214	2	0	\N
282303	1678	15120584925000	14129	7214	3	0	\N
282304	1678	15120584926000	14129	7214	4	0	\N
282305	1678	15120584927000	14129	7214	5	0	\N
282306	1678	15120584928000	14129	7214	6	0	\N
282307	1678	15120584929000	14129	7214	7	0	\N
282308	1874	2964000	14129	7214	8	0	\N
282309	1874	2967000	14129	7214	9	0	\N
282310	1874	2969000	14129	7214	10	0	\N
282311	1874	2970000	14129	7214	11	0	\N
282312	1874	2973000	14129	7214	12	0	\N
282313	1874	2975000	14129	7214	13	0	\N
282314	1874	2976000	14129	7214	14	0	\N
282315	1874	2979000	14129	7214	15	0	\N
282316	1874	2981000	14129	7214	16	0	\N
282317	1874	2982000	14129	7214	17	0	\N
282318	1874	2985000	14129	7214	18	0	\N
282319	1874	2987000	14129	7214	19	0	\N
282320	1874	2988000	14129	7214	20	0	\N
282321	1874	2991000	14129	7214	21	0	\N
282322	1874	2993000	14129	7214	22	0	\N
282323	1874	2994000	14129	7214	23	0	\N
282324	1874	2997000	14129	7214	24	0	\N
282325	1874	2999000	14129	7214	25	0	\N
282326	1874	3000000	14129	7214	26	0	\N
282327	1874	3003000	14129	7214	27	0	\N
282328	1874	3005000	14129	7214	28	0	\N
282329	1874	3006000	14129	7214	29	0	\N
282330	1874	3009000	14129	7214	30	0	\N
282331	1874	3011000	14129	7214	31	0	\N
282332	1874	3014000	14129	7214	32	0	\N
282333	1874	3015000	14129	7214	33	0	\N
282334	1678	15120584930000	14130	7220	0	0	\N
282335	1678	15120584931000	14130	7220	1	0	\N
282336	1678	15120584932000	14130	7220	2	0	\N
282207	1874	2955000	14104	7211	2	0	1
282208	1874	2957000	14104	7211	3	0	1
282214	1678	15120584920000	14107	7212	0	0	0
282215	1874	2958000	14107	7212	1	0	1
282216	1874	2961000	14107	7212	2	0	1
282241	1678	15120584921000	14113	7213	0	0	0
282242	1678	15120584922000	14115	7214	0	0	0
282243	1678	15120584923000	14115	7214	1	0	0
282244	1678	15120584924000	14115	7214	2	0	0
282245	1874	2964000	14115	7214	3	0	1
282247	1874	2969000	14115	7214	5	0	1
282248	1874	2970000	14115	7214	6	0	1
282249	1874	2973000	14115	7214	7	0	1
282250	1874	2975000	14115	7214	8	0	1
282252	1874	2979000	14115	7214	10	0	1
282253	1874	2981000	14115	7214	11	0	1
282254	1874	2982000	14115	7214	12	0	1
282255	1874	2985000	14115	7214	13	0	1
282256	1874	2987000	14115	7214	14	0	1
282258	1874	2988000	14116	7215	1	0	1
282259	1874	2991000	14116	7215	2	0	1
282260	1874	2993000	14116	7215	3	0	1
282261	1678	15120584926000	14117	7216	0	0	0
282262	1874	2994000	14117	7216	1	0	1
282264	1874	2999000	14117	7216	3	0	1
282269	1678	15120584927000	14119	7217	0	0	0
282270	1874	3000000	14119	7217	1	0	1
282271	1874	3003000	14119	7217	2	0	1
282274	1678	15120584928000	14121	7218	0	0	0
282275	1874	3006000	14121	7218	1	0	1
282276	1874	3009000	14121	7218	2	0	1
282277	1874	3011000	14121	7218	3	0	1
282290	1678	15120584929000	14126	7219	0	0	0
282292	1874	3015000	14126	7219	2	0	1
282293	1874	3017000	14126	7219	3	0	1
282337	1874	3020000	14130	7220	3	0	\N
282338	1874	3022000	14130	7220	4	0	\N
282339	1874	3025000	14130	7220	5	0	\N
282340	1874	3026000	14130	7220	6	0	\N
282341	1678	15120584930000	14131	7220	0	0	\N
282342	1678	15120584931000	14131	7220	1	0	\N
282343	1678	15120584932000	14131	7220	2	0	\N
282344	1874	3020000	14131	7220	3	0	\N
282345	1874	3022000	14131	7220	4	0	\N
282346	1874	3025000	14131	7220	5	0	\N
282347	1874	3026000	14131	7220	6	0	\N
282348	1874	3028000	14131	7220	8	0	\N
282349	1874	3031000	14131	7220	9	0	\N
282350	1874	3032000	14131	7220	10	0	\N
282351	1874	3034000	14131	7220	11	0	\N
282352	1678	15120584930000	14132	7220	0	0	\N
282353	1678	15120584931000	14132	7220	1	0	\N
282354	1678	15120584932000	14132	7220	2	0	\N
282355	1874	3020000	14132	7220	3	0	\N
282356	1874	3022000	14132	7220	4	0	\N
282357	1874	3025000	14132	7220	5	0	\N
282358	1874	3026000	14132	7220	6	0	\N
282359	1874	3028000	14132	7220	8	0	\N
282360	1874	3031000	14132	7220	9	0	\N
282361	1874	3032000	14132	7220	10	0	\N
282362	1874	3034000	14132	7220	11	0	\N
282363	1678	15120584930000	14133	7220	0	0	\N
282364	1678	15120584931000	14133	7220	1	0	\N
282365	1678	15120584932000	14133	7220	2	0	\N
282366	1874	3020000	14133	7220	3	0	\N
282367	1874	3022000	14133	7220	4	0	\N
282368	1874	3025000	14133	7220	5	0	\N
282369	1874	3026000	14133	7220	6	0	\N
282370	1874	3028000	14133	7220	8	0	\N
282371	1874	3031000	14133	7220	9	0	\N
282372	1874	3032000	14133	7220	10	0	\N
282373	1874	3034000	14133	7220	11	0	\N
282385	1678	15120584930000	14135	7220	0	0	\N
282386	1678	15120584931000	14135	7220	1	0	\N
282387	1678	15120584932000	14135	7220	2	0	\N
282388	1874	3020000	14135	7220	3	0	\N
282389	1874	3022000	14135	7220	4	0	\N
282390	1874	3025000	14135	7220	5	0	\N
282391	1874	3026000	14135	7220	6	0	\N
282392	1874	3028000	14135	7220	8	0	\N
282393	1874	3031000	14135	7220	9	0	\N
282394	1874	3032000	14135	7220	10	0	\N
282395	1874	3034000	14135	7220	11	0	\N
282396	1678	15120584933000	14136	7221	0	0	\N
282397	1874	3037000	14136	7221	1	0	\N
282398	1874	3038000	14136	7221	2	0	\N
282399	1678	15120584930000	14137	7215	0	0	\N
282400	1678	15120584931000	14137	7215	1	0	\N
282401	1678	15120584932000	14137	7215	2	0	\N
282402	1678	15120584933000	14137	7215	3	0	\N
282403	1874	3017000	14137	7215	4	0	\N
282404	1874	3020000	14137	7215	5	0	\N
282405	1874	3022000	14137	7215	6	0	\N
282406	1874	3025000	14137	7215	7	0	\N
282407	1874	3026000	14137	7215	8	0	\N
282408	1874	3028000	14137	7215	9	0	\N
282409	1874	3031000	14137	7215	10	0	\N
282410	1874	3032000	14137	7215	11	0	\N
282411	1874	3034000	14137	7215	12	0	\N
282412	1874	3037000	14137	7215	13	0	\N
282413	1874	3038000	14137	7215	14	0	\N
282423	2047	41200000	14140	7110	0	0	\N
282424	2047	41290000	14140	7110	1	0	\N
282425	1678	14400545778000	14140	7110	3	0	\N
282426	1950	3999852000000	14140	7110	4	0	\N
282427	1950	4669852000000	14140	7110	5	0	\N
282428	1678	14400545779000	14140	7110	6	0	\N
282429	1678	14400545780000	14140	7110	7	0	\N
282430	1678	14400545781000	14140	7110	8	0	\N
282431	1678	14400545782000	14140	7110	9	0	\N
282432	1678	14400545783000	14140	7110	10	0	\N
282433	1678	14400545784000	14140	7110	11	0	\N
282434	1678	14400545785000	14140	7110	12	0	\N
282435	1678	14400545786000	14140	7110	13	0	\N
282436	1678	14400545787000	14140	7110	14	0	\N
282437	1678	14400545788000	14140	7110	15	0	\N
282438	1678	14400545789000	14140	7110	16	0	\N
282439	1678	14400545790000	14140	7110	17	0	\N
282440	1678	14400545791000	14140	7110	18	0	\N
282441	1678	14400545792000	14140	7110	19	0	\N
282442	1678	14400545793000	14140	7110	20	0	\N
282443	1678	14400545794000	14140	7110	21	0	\N
282444	1678	14400545795000	14140	7110	22	0	\N
282445	1678	14400545796000	14140	7110	23	0	\N
282446	1678	14400545797000	14140	7110	24	0	\N
282447	1678	14400545798000	14140	7110	25	0	\N
282448	1678	14400545799000	14140	7110	26	0	\N
282449	1678	14400545800000	14140	7110	27	0	\N
282450	1678	14400545801000	14140	7110	28	0	\N
282451	1678	14400545802000	14140	7110	29	0	\N
282452	1678	14400545803000	14140	7110	30	0	\N
282453	1678	14400545804000	14140	7110	31	0	\N
282454	1678	14400545805000	14140	7110	32	0	\N
282455	1678	14400545806000	14140	7110	33	0	\N
282456	1678	14400545807000	14140	7110	34	0	\N
282457	1678	14400545808000	14140	7110	35	0	\N
282458	1678	14400545809000	14140	7110	36	0	\N
282459	1678	14400545810000	14140	7110	37	0	\N
282460	1678	14400545811000	14140	7110	38	0	\N
282461	1678	14400545812000	14140	7110	39	0	\N
282462	1678	14400545813000	14140	7110	40	0	\N
282463	1678	14400545814000	14140	7110	41	0	\N
282464	1678	14400545815000	14140	7110	42	0	\N
282465	1678	14400545816000	14140	7110	43	0	\N
282466	1678	14400545817000	14140	7110	44	0	\N
282467	1678	14400545818000	14140	7110	45	0	\N
282468	1678	14400545819000	14140	7110	46	0	\N
282469	1678	14400545820000	14140	7110	47	0	\N
282470	1678	14400545821000	14140	7110	48	0	\N
282471	1678	14400545822000	14140	7110	49	0	\N
282472	1678	14400545823000	14140	7110	50	0	\N
282376	1678	15120584932000	14134	7220	2	0	0
282377	1874	3020000	14134	7220	3	0	1
282378	1874	3022000	14134	7220	4	0	1
282379	1874	3025000	14134	7220	5	0	1
282380	1874	3026000	14134	7220	6	0	1
282382	1874	3031000	14134	7220	9	0	1
282383	1874	3032000	14134	7220	10	0	1
282384	1874	3034000	14134	7220	11	0	1
282414	1678	15120584933000	14138	7221	0	0	0
282415	1874	3037000	14138	7221	1	0	1
282417	1678	15120584934000	14139	7222	0	0	0
282418	1678	15120584935000	14139	7222	1	0	0
282419	1874	3040000	14139	7222	2	0	1
282420	1874	3041000	14139	7222	3	0	1
282422	1874	3046000	14139	7222	5	0	1
282473	1678	14400545824000	14140	7110	51	0	\N
282474	1678	14400545825000	14140	7110	52	0	\N
282475	1678	14400545826000	14140	7110	53	0	\N
282476	1678	14400545827000	14140	7110	54	0	\N
282477	1678	14400545828000	14140	7110	55	0	\N
282478	1678	14400545829000	14140	7110	56	0	\N
282479	1678	14400545830000	14140	7110	57	0	\N
282480	1678	14400545831000	14140	7110	58	0	\N
282481	1678	14400545832000	14140	7110	59	0	\N
282482	1678	14400545833000	14140	7110	60	0	\N
282483	1678	14400545834000	14140	7110	61	0	\N
282484	1678	14400545835000	14140	7110	62	0	\N
282485	1678	14400545836000	14140	7110	63	0	\N
282486	1678	14400545837000	14140	7110	64	0	\N
282487	1678	14400545838000	14140	7110	65	0	\N
282488	1678	14400545839000	14140	7110	66	0	\N
282489	1678	14400545840000	14140	7110	67	0	\N
282490	1678	14400545841000	14140	7110	68	0	\N
282491	1678	14400545842000	14140	7110	69	0	\N
282492	1678	14400545843000	14140	7110	70	0	\N
282493	1678	14400545844000	14140	7110	71	0	\N
282494	1678	14400545845000	14140	7110	72	0	\N
282495	1678	14400545846000	14140	7110	73	0	\N
282496	1678	14400545847000	14140	7110	74	0	\N
282497	1678	14400545848000	14140	7110	75	0	\N
282498	1678	14400545849000	14140	7110	76	0	\N
282499	1678	14400545850000	14140	7110	77	0	\N
282500	1678	14400545851000	14140	7110	78	0	\N
282501	1678	14400545852000	14140	7110	79	0	\N
282502	1678	14400545853000	14140	7110	80	0	\N
282503	1678	14400545854000	14140	7110	81	0	\N
282504	1678	14400545855000	14140	7110	82	0	\N
282505	1678	14400545856000	14140	7110	84	0	\N
282506	1678	14400545857000	14140	7110	85	0	\N
282507	1678	14400545858000	14140	7110	86	0	\N
282508	1678	14400545859000	14140	7110	87	0	\N
282509	1678	14400545860000	14140	7110	88	0	\N
282510	1678	14400545861000	14140	7110	89	0	\N
282511	1678	14400545862000	14140	7110	90	0	\N
282512	1678	14400545863000	14140	7110	91	0	\N
282513	1678	14400545864000	14140	7110	92	0	\N
282514	1678	14400545865000	14140	7110	93	0	\N
282515	1678	14400545866000	14140	7110	94	0	\N
282516	1678	14400545867000	14140	7110	95	0	\N
282517	1678	14400545868000	14140	7110	96	0	\N
282518	1678	14400545869000	14140	7110	97	0	\N
282519	1678	14400545870000	14140	7110	98	0	\N
282520	1678	14400545871000	14140	7110	99	0	\N
282521	1678	14400545872000	14140	7110	100	0	\N
282522	1678	14400545873000	14140	7110	101	0	\N
282523	1678	14400545874000	14140	7110	102	0	\N
282524	1678	14400545875000	14140	7110	103	0	\N
282525	1678	14400545876000	14140	7110	104	0	\N
282526	1678	14400545877000	14140	7110	105	0	\N
282527	1678	14400545878000	14140	7110	106	0	\N
282528	1678	14400545879000	14140	7110	107	0	\N
282529	1678	14400545880000	14140	7110	108	0	\N
282530	1678	14400545881000	14140	7110	109	0	\N
282531	1678	14400545882000	14140	7110	110	0	\N
282532	1678	14400545883000	14140	7110	111	0	\N
282533	1678	14400545884000	14140	7110	112	0	\N
282534	1678	14400545885000	14140	7110	113	0	\N
282535	1678	14400545886000	14140	7110	114	0	\N
282536	1678	14400545887000	14140	7110	115	0	\N
282537	1678	14400545888000	14140	7110	116	0	\N
282538	1678	14400545889000	14140	7110	117	0	\N
282539	1678	14400545890000	14140	7110	118	0	\N
282540	1678	14400545891000	14140	7110	119	0	\N
282541	1678	14400545892000	14140	7110	120	0	\N
282542	1678	14400545893000	14140	7110	121	0	\N
282543	1678	14400545894000	14140	7110	122	0	\N
282544	1678	14400545895000	14140	7110	123	0	\N
282545	1678	14400545896000	14140	7110	124	0	\N
282546	1678	14400545897000	14140	7110	125	0	\N
282547	1678	15120584934000	14141	7222	0	0	\N
282548	1678	15120584935000	14141	7222	1	0	\N
282549	1874	3040000	14141	7222	2	0	\N
282550	1874	3041000	14141	7222	3	0	\N
282551	1874	3043000	14141	7222	4	0	\N
282552	1874	3046000	14141	7222	5	0	\N
282553	1678	15120584934000	14142	7222	0	0	\N
282554	1678	15120584935000	14142	7222	1	0	\N
282555	1874	3040000	14142	7222	2	0	\N
282556	1874	3041000	14142	7222	3	0	\N
282557	1874	3043000	14142	7222	4	0	\N
282558	1874	3046000	14142	7222	5	0	\N
282559	1678	15120584934000	14143	7222	0	0	\N
282560	1678	15120584935000	14143	7222	1	0	\N
282561	1874	3040000	14143	7222	2	0	\N
282562	1874	3041000	14143	7222	3	0	\N
282563	1874	3043000	14143	7222	4	0	\N
282564	1874	3046000	14143	7222	5	0	\N
282565	1678	15120584934000	14144	7222	0	0	\N
282566	1678	15120584935000	14144	7222	1	0	\N
282567	1874	3040000	14144	7222	2	0	\N
282568	1874	3041000	14144	7222	3	0	\N
282569	1874	3043000	14144	7222	4	0	\N
282570	1874	3046000	14144	7222	5	0	\N
282571	1678	15120584933000	14145	7221	0	0	\N
282572	1678	15120584934000	14145	7221	1	0	\N
282573	1678	15120584935000	14145	7221	2	0	\N
282574	1874	3037000	14145	7221	3	0	\N
282575	1874	3038000	14145	7221	4	0	\N
282576	1874	3040000	14145	7221	5	0	\N
282577	1874	3041000	14145	7221	6	0	\N
282578	1874	3043000	14145	7221	7	0	\N
282579	1874	3046000	14145	7221	8	0	\N
282580	1678	15120584936000	14146	7223	0	0	\N
282581	1874	3048000	14146	7223	1	0	\N
282582	1874	3051000	14146	7223	2	0	\N
282586	1874	3048000	14148	7223	0	0	\N
282587	1678	15120584936000	14149	7223	0	0	\N
282588	1874	3048000	14149	7223	1	0	\N
282589	1874	3051000	14149	7223	2	0	\N
282590	1678	15120584936000	14150	7223	0	0	\N
282591	1874	3048000	14150	7223	1	0	\N
282592	1874	3051000	14150	7223	2	0	\N
282593	1678	15120584937000	14151	7224	0	0	\N
282594	1874	3053000	14151	7224	1	0	\N
282595	1874	3056000	14151	7224	2	0	\N
282608	1678	15120584940000	14157	7226	0	0	\N
282585	1874	3051000	14147	7223	2	0	1
282596	1678	15120584937000	14152	7224	0	0	0
282597	1678	15120584938000	14153	7225	0	0	0
282598	1678	15120584939000	14153	7225	1	0	0
282599	1874	3053000	14153	7225	2	0	1
282601	1874	3058000	14153	7225	4	0	1
282602	1874	3061000	14153	7225	5	0	1
282603	1874	3063000	14153	7225	6	0	1
282604	1874	3066000	14153	7225	7	0	1
282605	1678	15120584940000	14154	7226	0	0	0
282607	1874	3071000	14154	7226	2	0	1
282609	1874	3068000	14157	7226	1	0	\N
282610	1874	3071000	14157	7226	2	0	\N
282611	1678	15120584941000	14159	7227	0	0	\N
282612	1874	3073000	14159	7227	1	0	\N
282613	1874	3076000	14159	7227	2	0	\N
282617	1678	15120584942000	14161	7228	0	0	\N
282618	1874	3078000	14161	7228	1	0	\N
282619	1874	3081000	14161	7228	2	0	\N
282628	1678	15120584944000	14164	7230	0	0	\N
282629	1874	3093000	14164	7230	1	0	\N
282630	1874	3096000	14164	7230	2	0	\N
282634	1678	15120584944000	14166	7230	0	0	\N
282635	1874	3093000	14166	7230	1	0	\N
282636	1874	3096000	14166	7230	2	0	\N
282661	1678	15120584951000	14172	7235	0	0	\N
282662	1874	3130000	14172	7235	1	0	\N
282663	1874	3131000	14172	7235	2	0	\N
282664	1874	3134000	14172	7235	3	0	\N
282678	1678	15120584953000	14175	7237	0	0	\N
282679	1678	15120584954000	14175	7237	1	0	\N
282680	1678	15120584953000	14176	7237	0	0	\N
282681	1678	15120584954000	14176	7237	1	0	\N
282682	1874	3142000	14176	7237	2	0	\N
282683	1874	3143000	14176	7237	3	0	\N
282684	1874	3146000	14176	7237	4	0	\N
282685	1874	3148000	14176	7237	5	0	\N
282686	1874	3149000	14176	7237	6	0	\N
282687	1874	3152000	14176	7237	7	0	\N
282688	1678	15120584955000	14178	7238	0	0	\N
282689	1678	15120584956000	14178	7238	1	0	\N
282690	1678	15120584955000	14179	7238	0	0	\N
282691	1678	15120584956000	14179	7238	1	0	\N
282692	1874	3154000	14179	7238	2	0	\N
282693	1874	3155000	14179	7238	3	0	\N
282694	1874	3157000	14179	7238	4	0	\N
282695	1874	3158000	14179	7238	5	0	\N
282696	1678	15120584955000	14180	7238	0	0	\N
282697	1678	15120584956000	14180	7238	1	0	\N
282698	1874	3154000	14180	7238	2	0	\N
282699	1874	3155000	14180	7238	3	0	\N
282700	1874	3157000	14180	7238	4	0	\N
282701	1874	3158000	14180	7238	5	0	\N
282702	1678	15120584955000	14181	7238	0	0	\N
282703	1678	15120584956000	14181	7238	1	0	\N
282704	1678	15120584955000	14182	7238	0	0	\N
282705	1678	15120584956000	14182	7238	1	0	\N
282706	1874	3154000	14182	7238	2	0	\N
282707	1874	3155000	14182	7238	3	0	\N
282708	1874	3157000	14182	7238	4	0	\N
282709	1874	3158000	14182	7238	5	0	\N
282710	1678	15120584955000	14183	7238	0	0	\N
282711	1678	15120584956000	14183	7238	1	0	\N
282712	1874	3154000	14183	7238	2	0	\N
282713	1874	3155000	14183	7238	3	0	\N
282714	1874	3157000	14183	7238	4	0	\N
282715	1874	3158000	14183	7238	5	0	\N
282716	1678	15120584955000	14184	7238	0	0	\N
282717	1678	15120584956000	14184	7238	1	0	\N
282729	1678	15120584957000	14188	7239	0	0	\N
282730	1678	15120584958000	14188	7239	1	0	\N
282731	1874	3161000	14188	7239	2	0	\N
282732	1874	3163000	14188	7239	3	0	\N
282733	1874	3164000	14188	7239	5	0	\N
282734	1874	3166000	14188	7239	6	0	\N
282739	1678	15120584960000	14190	7242	0	0	\N
282740	1874	3174000	14190	7242	1	0	\N
282741	1874	3175000	14190	7242	2	0	\N
282742	1874	3177000	14190	7242	3	0	\N
282743	1678	15120584960000	14191	7242	0	0	\N
282744	1874	3174000	14191	7242	1	0	\N
282616	1874	3076000	14160	7227	2	0	1
282620	1874	3078000	14162	7228	0	0	1
282621	1678	15120584942000	14163	7229	0	0	0
282622	1678	15120584943000	14163	7229	1	0	0
282623	1874	3081000	14163	7229	2	0	1
282625	1874	3086000	14163	7229	4	0	1
282626	1874	3088000	14163	7229	5	0	1
282627	1874	3091000	14163	7229	6	0	1
282631	1678	15120584944000	14165	7230	0	0	0
282632	1874	3093000	14165	7230	1	0	1
282637	1678	15120584945000	14167	7231	0	0	0
282638	1874	3098000	14167	7231	1	0	1
282639	1874	3101000	14167	7231	2	0	1
282640	1678	15120584946000	14168	7232	0	0	0
282642	1874	3103000	14168	7232	2	0	1
282643	1874	3106000	14168	7232	3	0	1
282644	1874	3108000	14168	7232	4	0	1
282645	1874	3111000	14168	7232	5	0	1
282646	1678	15120584948000	14169	7233	0	0	0
282648	1678	15120584950000	14170	7234	1	0	0
282649	1874	3113000	14170	7234	2	0	1
282650	1874	3116000	14170	7234	3	0	1
282651	1874	3118000	14170	7234	4	0	1
282652	1874	3119000	14170	7234	5	0	1
282654	1874	3124000	14170	7234	7	0	1
282655	1874	3125000	14170	7234	8	0	1
282656	1874	3128000	14170	7234	9	0	1
282657	1678	15120584951000	14171	7235	0	0	0
282659	1874	3131000	14171	7235	2	0	1
282660	1874	3134000	14171	7235	3	0	1
282665	1678	15120584952000	14173	7236	0	0	0
282666	1874	3136000	14173	7236	1	0	1
282667	2105	200000000	14173	7236	2	0	0
282669	1874	3140000	14173	7236	4	0	1
282670	1678	15120584953000	14174	7237	0	0	0
282671	1678	15120584954000	14174	7237	1	0	0
282672	1874	3142000	14174	7237	2	0	1
282673	1874	3143000	14174	7237	3	0	1
282675	1874	3148000	14174	7237	5	0	1
282676	1874	3149000	14174	7237	6	0	1
282677	1874	3152000	14174	7237	7	0	1
282718	1678	15120584955000	14185	7238	0	0	0
282720	1678	15120584957000	14186	7239	0	0	0
282721	1874	3154000	14186	7239	1	0	1
282722	1874	3155000	14186	7239	2	0	1
282723	1874	3157000	14186	7239	3	0	1
282724	1874	3158000	14186	7239	4	0	1
282726	1874	3163000	14186	7239	6	0	1
282727	1874	3164000	14186	7239	7	0	1
282728	1678	15120584958000	14187	7240	0	0	0
282735	1678	15120584959000	14189	7241	0	0	0
282736	1874	3166000	14189	7241	1	0	1
282738	1874	3171000	14189	7241	3	0	1
282745	1874	3175000	14191	7242	2	0	\N
282746	1874	3177000	14191	7242	3	0	\N
282747	1678	15120584960000	14192	7242	0	0	\N
282748	1678	15120584960000	14193	7242	0	0	\N
282749	1874	3174000	14193	7242	1	0	\N
282750	1874	3175000	14193	7242	2	0	\N
282751	1874	3177000	14193	7242	3	0	\N
282756	1678	15120584960000	14195	7242	0	0	\N
282763	1678	15120584963000	14197	7244	0	0	\N
282788	1678	15840599969000	14204	7249	0	0	\N
282789	1678	15840599970000	14204	7249	1	0	\N
282790	1874	3217000	14204	7249	2	0	\N
282791	1874	3219000	14204	7249	3	0	\N
282792	1874	3222000	14204	7249	4	0	\N
282793	1874	3223000	14204	7249	5	0	\N
282794	1874	3225000	14204	7249	6	0	\N
282795	1874	3228000	14204	7249	7	0	\N
282796	1678	15840599969000	14205	7249	0	0	\N
282797	1678	15840599970000	14205	7249	1	0	\N
282798	1874	3217000	14205	7249	2	0	\N
282799	1874	3219000	14205	7249	3	0	\N
282800	1874	3222000	14205	7249	4	0	\N
282801	1874	3223000	14205	7249	5	0	\N
282802	1874	3225000	14205	7249	6	0	\N
282803	1874	3228000	14205	7249	7	0	\N
282821	1678	15840599974000	14209	7253	0	0	\N
282822	1874	3245000	14209	7253	1	0	\N
282823	1874	3248000	14209	7253	2	0	\N
282824	1874	3250000	14209	7253	3	0	\N
282837	1678	15120584957000	14213	7239	0	0	\N
282838	1678	15120584958000	14213	7239	1	0	\N
282839	1678	15120584959000	14213	7239	2	0	\N
282840	1678	15120584960000	14213	7239	3	0	\N
282841	1678	15120584961000	14213	7239	5	0	\N
282842	1678	15120584962000	14213	7239	6	0	\N
282843	1678	15120584963000	14213	7239	7	0	\N
282844	1678	15120584964000	14213	7239	8	0	\N
282845	1678	15120584965000	14213	7239	9	0	\N
282846	1678	15120584966000	14213	7239	10	0	\N
282847	1678	15120584967000	14213	7239	11	0	\N
282848	1678	15120584968000	14213	7239	12	0	\N
282849	1678	15120584969000	14213	7239	13	0	\N
282850	1678	15120584970000	14213	7239	14	0	\N
282855	1678	15840599977000	14215	7256	0	0	\N
282856	1874	3263000	14215	7256	1	0	\N
282857	1874	3265000	14215	7256	2	0	\N
282858	1874	3268000	14215	7256	3	0	\N
282863	1678	15840599978000	14217	7257	0	0	\N
282864	1874	3269000	14217	7257	1	0	\N
282865	1874	3271000	14217	7257	2	0	\N
282866	1874	3274000	14217	7257	3	0	\N
282754	1874	3175000	14194	7242	2	0	1
282755	1874	3177000	14194	7242	3	0	1
282757	1678	15120584961000	14196	7243	0	0	0
282758	1678	15120584962000	14196	7243	1	0	0
282759	1874	3180000	14196	7243	2	0	1
282761	1874	3184000	14196	7243	4	0	1
282762	1874	3186000	14196	7243	5	0	1
282764	1678	15120584963000	14198	7244	0	0	0
282765	1874	3189000	14198	7244	1	0	1
282766	1874	3191000	14198	7244	2	0	1
282768	1678	15120584964000	14199	7245	0	0	0
282769	1874	3193000	14199	7245	1	0	1
282770	1874	3195000	14199	7245	2	0	1
282771	1678	15120584965000	14200	7246	0	0	0
282773	1874	3196000	14200	7246	2	0	1
282774	1874	3199000	14200	7246	3	0	1
282775	1874	3201000	14200	7246	4	0	1
282776	1874	3202000	14200	7246	5	0	1
282777	1874	3205000	14200	7246	6	0	1
282779	1678	15120584967000	14201	7247	0	0	0
282780	1678	15120584968000	14202	7248	0	0	0
282781	1874	3208000	14202	7248	1	0	1
282782	1874	3210000	14202	7248	2	0	1
282783	1874	3211000	14202	7248	3	0	1
282785	1874	3216000	14202	7248	5	0	1
282786	1678	15840599969000	14203	7249	0	0	0
282787	1678	15840599970000	14203	7249	1	0	0
282804	1678	15840599971000	14206	7250	0	0	0
282806	1874	3219000	14206	7250	2	0	1
282807	1874	3222000	14206	7250	3	0	1
282808	1874	3223000	14206	7250	4	0	1
282809	1874	3225000	14206	7250	5	0	1
282810	1874	3228000	14206	7250	6	0	1
282812	1874	3232000	14206	7250	8	0	1
282813	1678	15840599972000	14207	7251	0	0	0
282814	1874	3233000	14207	7251	1	0	1
282815	1874	3236000	14207	7251	2	0	1
282816	1874	3238000	14207	7251	3	0	1
282818	1874	3239000	14208	7252	1	0	1
282819	1874	3242000	14208	7252	2	0	1
282820	1874	3244000	14208	7252	3	0	1
282825	1678	15840599974000	14210	7253	0	0	0
282827	1874	3248000	14210	7253	2	0	1
282828	1874	3250000	14210	7253	3	0	1
282829	1678	15840599975000	14211	7254	0	0	0
282830	1874	3251000	14211	7254	1	0	1
282831	1874	3254000	14211	7254	2	0	1
282833	1678	15840599976000	14212	7255	0	0	0
282834	1874	3257000	14212	7255	1	0	1
282835	1874	3259000	14212	7255	2	0	1
282836	1874	3262000	14212	7255	3	0	1
282851	1678	15840599977000	14214	7256	0	0	0
282853	1874	3265000	14214	7256	2	0	1
282854	1874	3268000	14214	7256	3	0	1
282859	1678	15840599978000	14216	7257	0	0	0
282860	1874	3269000	14216	7257	1	0	1
282862	1874	3274000	14216	7257	3	0	1
282867	1678	15840599979000	14218	7258	0	0	0
282868	1678	15840599980000	14218	7258	1	0	0
282869	1678	15840599981000	14218	7258	2	0	0
282870	1874	3275000	14218	7258	3	0	1
282872	1874	3280000	14218	7258	5	0	1
282873	1874	3281000	14218	7258	6	0	1
282874	1874	3283000	14218	7258	7	0	1
282875	1874	3286000	14218	7258	8	0	1
282876	1874	3287000	14218	7258	9	0	1
282878	1678	15840599982000	14219	7259	0	0	0
282879	1874	3292000	14219	7259	2	0	1
282880	1874	3293000	14219	7259	3	0	1
282882	1678	15840599982000	14221	7259	0	0	\N
282883	1874	3292000	14221	7259	2	0	\N
282884	1874	3293000	14221	7259	3	0	\N
282885	1874	3295000	14221	7259	4	0	\N
282898	1678	15840599983000	14225	7261	0	0	\N
282899	1678	15840599984000	14225	7261	1	0	\N
282900	1678	15840599985000	14225	7261	2	0	\N
282901	1874	3301000	14225	7261	3	0	\N
282902	1874	3302000	14225	7261	4	0	\N
282903	1874	3304000	14225	7261	5	0	\N
282904	1874	3307000	14225	7261	6	0	\N
282905	1874	3308000	14225	7261	7	0	\N
282906	1874	3310000	14225	7261	8	0	\N
282907	1874	3313000	14225	7261	9	0	\N
282920	1678	15840599988000	14229	7265	0	0	\N
282921	1874	3326000	14229	7265	1	0	\N
282922	1874	3328000	14229	7265	2	0	\N
282923	1874	3331000	14229	7265	3	0	\N
282924	1678	15840599988000	14230	7265	0	0	\N
282925	1874	3326000	14230	7265	1	0	\N
282926	1874	3328000	14230	7265	2	0	\N
282927	1874	3331000	14230	7265	3	0	\N
282928	1678	15840599989000	14231	7266	0	0	\N
282929	1874	3332000	14231	7266	1	0	\N
282930	1874	3334000	14231	7266	2	0	\N
282931	1874	3337000	14231	7266	3	0	\N
282936	1678	15840599990000	14233	7267	0	0	\N
282937	1874	3338000	14233	7267	1	0	\N
282938	1874	3340000	14233	7267	2	0	\N
282939	1874	3343000	14233	7267	3	0	\N
282940	1678	15840599990000	14234	7267	0	0	\N
282941	1874	3338000	14234	7267	1	0	\N
282942	1874	3340000	14234	7267	2	0	\N
282943	1874	3343000	14234	7267	3	0	\N
282944	1678	15840599990000	14235	7267	0	0	\N
282945	1874	3338000	14235	7267	1	0	\N
282946	1874	3340000	14235	7267	2	0	\N
282947	1874	3343000	14235	7267	3	0	\N
282952	1678	15840599991000	14237	7268	0	0	\N
282953	1874	3344000	14237	7268	1	0	\N
282954	1874	3346000	14237	7268	2	0	\N
282955	1874	3349000	14237	7268	3	0	\N
282956	1874	3350000	14237	7268	4	0	\N
282957	1874	3352000	14237	7268	5	0	\N
282958	1874	3355000	14237	7268	6	0	\N
282959	1678	15840599991000	14238	7268	0	0	\N
282960	1678	15840599991000	14239	7268	0	0	\N
282961	1874	3344000	14239	7268	1	0	\N
282962	1874	3346000	14239	7268	2	0	\N
282963	1874	3349000	14239	7268	3	0	\N
282964	1874	3350000	14239	7268	4	0	\N
282965	1874	3352000	14239	7268	5	0	\N
282966	1874	3355000	14239	7268	6	0	\N
282986	1874	3368000	14243	7270	0	0	\N
282987	1874	3370000	14243	7270	1	0	\N
282995	1678	15840599996000	14246	7272	0	0	\N
282996	1874	3380000	14246	7272	1	0	\N
282997	1874	3382000	14246	7272	2	0	\N
282887	1874	3299000	14222	7260	1	0	1
282888	1678	15840599983000	14223	7261	0	0	0
282889	1678	15840599984000	14223	7261	1	0	0
282890	1874	3301000	14223	7261	2	0	1
282891	1874	3302000	14223	7261	3	0	1
282893	1874	3307000	14223	7261	5	0	1
282894	1678	15840599985000	14224	7262	0	0	0
282895	1874	3308000	14224	7262	1	0	1
282896	1874	3310000	14224	7262	2	0	1
282897	1874	3313000	14224	7262	3	0	1
282909	1874	3314000	14226	7263	1	0	1
282910	1874	3316000	14226	7263	2	0	1
282911	1874	3319000	14226	7263	3	0	1
282912	1678	15840599987000	14227	7264	0	0	0
282914	1874	3322000	14227	7264	2	0	1
282915	1874	3325000	14227	7264	3	0	1
282916	1678	15840599988000	14228	7265	0	0	0
282917	1874	3326000	14228	7265	1	0	1
282918	1874	3328000	14228	7265	2	0	1
282932	1678	15840599989000	14232	7266	0	0	0
282933	1874	3332000	14232	7266	1	0	1
282934	1874	3334000	14232	7266	2	0	1
282935	1874	3337000	14232	7266	3	0	1
282948	1678	15840599990000	14236	7267	0	0	0
282950	1874	3340000	14236	7267	2	0	1
282951	1874	3343000	14236	7267	3	0	1
282967	1874	3344000	14240	7268	0	0	1
282968	1874	3346000	14240	7268	1	0	1
282970	1874	3350000	14240	7268	3	0	1
282971	1874	3352000	14240	7268	4	0	1
282972	1874	3355000	14240	7268	5	0	1
282973	1678	15840599991000	14241	7269	0	0	0
282974	1678	15840599992000	14241	7269	1	0	0
282976	1874	3356000	14241	7269	3	0	1
282977	1874	3358000	14241	7269	4	0	1
282978	1874	3361000	14241	7269	5	0	1
282979	1874	3362000	14241	7269	6	0	1
282980	1874	3364000	14241	7269	7	0	1
282982	1678	15840599994000	14242	7270	0	0	0
282983	1874	3368000	14242	7270	1	0	1
282984	1874	3370000	14242	7270	2	0	1
282985	1874	3373000	14242	7270	3	0	1
282989	1874	3374000	14244	7271	1	0	1
282990	1874	3376000	14244	7271	2	0	1
282991	1874	3379000	14244	7271	3	0	1
282992	1678	15840599996000	14245	7272	0	0	0
282993	1874	3380000	14245	7272	1	0	1
282998	1678	15840599997000	14247	7273	0	0	0
282999	1678	15840599998000	14247	7273	1	0	0
283000	1874	3383000	14247	7273	2	0	1
283001	1874	3385000	14247	7273	3	0	1
283002	1874	3388000	14247	7273	4	0	1
283004	1874	3391000	14247	7273	6	0	1
283005	1874	3394000	14247	7273	7	0	1
283006	1678	15840599999000	14248	7274	0	0	0
283007	1874	3395000	14248	7274	1	0	1
283009	1874	3400000	14248	7274	3	0	1
283010	1678	15840600000000	14249	7275	0	0	0
283011	1874	3401000	14249	7275	1	0	1
283012	1874	3403000	14249	7275	2	0	1
283013	1874	3406000	14249	7275	3	0	1
283015	1874	3407000	14250	7276	1	0	1
283016	1874	3409000	14250	7276	2	0	1
283017	1678	15840600002000	14251	7277	0	0	\N
283018	1678	15840600003000	14251	7277	1	0	\N
283019	1874	3412000	14251	7277	2	0	\N
283020	1874	3413000	14251	7277	3	0	\N
283021	1874	3415000	14251	7277	4	0	\N
283022	1874	3418000	14251	7277	5	0	\N
283023	1874	3419000	14251	7277	6	0	\N
283024	1874	3421000	14251	7277	7	0	\N
283025	1678	15840600002000	14252	7277	0	0	\N
283026	1678	15840600003000	14252	7277	1	0	\N
283027	1874	3412000	14252	7277	2	0	\N
283028	1874	3413000	14252	7277	3	0	\N
283029	1874	3415000	14252	7277	4	0	\N
283030	1874	3418000	14252	7277	5	0	\N
283031	1874	3419000	14252	7277	6	0	\N
283032	1874	3421000	14252	7277	7	0	\N
283033	1678	15840600002000	14253	7277	0	0	\N
283034	1678	15840600003000	14253	7277	1	0	\N
283035	1874	3412000	14253	7277	2	0	\N
283036	1874	3413000	14253	7277	3	0	\N
283037	1874	3415000	14253	7277	4	0	\N
283038	1874	3418000	14253	7277	5	0	\N
283039	1874	3419000	14253	7277	6	0	\N
283040	1874	3421000	14253	7277	7	0	\N
283041	1678	15840600002000	14254	7277	0	0	\N
283042	1678	15840600003000	14254	7277	1	0	\N
283043	1874	3412000	14254	7277	2	0	\N
283044	1874	3413000	14254	7277	3	0	\N
283045	1874	3415000	14254	7277	4	0	\N
283046	1874	3418000	14254	7277	5	0	\N
283047	1874	3419000	14254	7277	6	0	\N
283048	1874	3421000	14254	7277	7	0	\N
283069	1678	15840600006000	14259	7280	0	0	\N
283070	1874	3435000	14259	7280	1	0	\N
283071	1874	3436000	14259	7280	2	0	\N
283072	1874	3439000	14259	7280	3	0	\N
283077	1678	15840600007000	14261	7281	0	0	\N
283078	1874	3441000	14261	7281	1	0	\N
283079	1874	3442000	14261	7281	2	0	\N
283080	1874	3445000	14261	7281	3	0	\N
283085	2103	1400000000	14263	7205	0	0	\N
283086	1678	15120584912000	14263	7205	1	0	\N
283087	1678	15120584913000	14263	7205	2	0	\N
283088	1678	15120584914000	14263	7205	3	0	\N
283089	1678	15120584915000	14263	7205	4	0	\N
283090	1678	15120584916000	14263	7205	5	0	\N
283091	1678	15120584917000	14263	7205	6	0	\N
283092	1678	15120584918000	14263	7205	7	0	\N
283093	1678	15120584919000	14263	7205	8	0	\N
283094	1678	15120584920000	14263	7205	9	0	\N
283095	1678	15120584921000	14263	7205	10	0	\N
283096	1678	15120584922000	14263	7205	11	0	\N
283097	1678	15120584923000	14263	7205	12	0	\N
283098	1678	15120584924000	14263	7205	13	0	\N
283099	1678	15120584925000	14263	7205	14	0	\N
283100	1678	15120584926000	14263	7205	15	0	\N
283101	1678	15120584927000	14263	7205	16	0	\N
283102	1678	15120584928000	14263	7205	17	0	\N
283103	1678	15120584929000	14263	7205	18	0	\N
283104	1678	15120584930000	14263	7205	19	0	\N
283105	1678	15120584931000	14263	7205	20	0	\N
283106	1678	15120584932000	14263	7205	21	0	\N
283107	1678	15120584933000	14263	7205	22	0	\N
283108	1678	15120584934000	14263	7205	23	0	\N
283109	1678	15120584935000	14263	7205	24	0	\N
283110	1678	15120584936000	14263	7205	25	0	\N
283111	1678	15120584937000	14263	7205	26	0	\N
283112	1678	15120584938000	14263	7205	27	0	\N
283113	1678	15120584939000	14263	7205	28	0	\N
283114	1678	15120584940000	14263	7205	29	0	\N
283115	1678	15120584941000	14263	7205	30	0	\N
283116	1678	15120584942000	14263	7205	31	0	\N
283117	1678	15120584943000	14263	7205	32	0	\N
283118	1678	15120584944000	14263	7205	33	0	\N
283119	1678	15120584945000	14263	7205	34	0	\N
283120	1678	15120584946000	14263	7205	35	0	\N
283121	1678	15120584947000	14263	7205	36	0	\N
283122	1678	15120584948000	14263	7205	37	0	\N
283123	1678	15120584949000	14263	7205	38	0	\N
283124	1678	15120584950000	14263	7205	39	0	\N
283125	1678	15120584951000	14263	7205	40	0	\N
283126	1678	15120584952000	14263	7205	41	0	\N
283127	1678	15120584953000	14263	7205	42	0	\N
283128	1678	15120584954000	14263	7205	43	0	\N
283129	1678	15120584955000	14263	7205	44	0	\N
283130	1678	15120584956000	14263	7205	45	0	\N
283131	1678	15120584957000	14263	7205	46	0	\N
283132	1678	15120584958000	14263	7205	47	0	\N
283133	1678	15120584959000	14263	7205	48	0	\N
283134	1678	15120584960000	14263	7205	49	0	\N
283135	1678	15120584961000	14263	7205	50	0	\N
283136	1678	15120584962000	14263	7205	51	0	\N
283137	1678	15120584963000	14263	7205	52	0	\N
283138	1678	15120584964000	14263	7205	53	0	\N
283139	1678	15120584965000	14263	7205	54	0	\N
283140	1678	15120584966000	14263	7205	55	0	\N
283141	1678	15120584967000	14263	7205	56	0	\N
283142	1678	15120584968000	14263	7205	57	0	\N
283143	1678	15120584969000	14263	7205	58	0	\N
283144	1678	15120584970000	14263	7205	59	0	\N
283145	1678	15120584971000	14263	7205	60	0	\N
283146	1678	15120584972000	14263	7205	61	0	\N
283147	1678	15120584973000	14263	7205	62	0	\N
283148	1678	15120584974000	14263	7205	63	0	\N
283149	1678	15120584975000	14263	7205	64	0	\N
283150	1678	15120584976000	14263	7205	65	0	\N
283151	1678	15120584977000	14263	7205	66	0	\N
283152	1678	15120584978000	14263	7205	67	0	\N
283051	1678	15840600004000	14256	7278	0	0	0
283052	1874	3412000	14256	7278	1	0	1
283053	1874	3413000	14256	7278	2	0	1
283054	1874	3415000	14256	7278	3	0	1
283055	1874	3418000	14256	7278	4	0	1
283057	1874	3421000	14256	7278	6	0	1
283058	1874	3424000	14256	7278	8	0	1
283059	1874	3425000	14256	7278	9	0	1
283060	1874	3427000	14256	7278	10	0	1
283061	1678	15840600005000	14257	7279	0	0	0
283063	1874	3430000	14257	7279	2	0	1
283064	1874	3433000	14257	7279	3	0	1
283065	1678	15840600006000	14258	7280	0	0	0
283066	1874	3435000	14258	7280	1	0	1
283068	1874	3439000	14258	7280	3	0	1
283073	1678	15840600007000	14260	7281	0	0	0
283074	1874	3441000	14260	7281	1	0	1
283075	1874	3442000	14260	7281	2	0	1
283076	1874	3445000	14260	7281	3	0	1
283082	1874	3447000	14262	7282	1	0	1
283083	1874	3448000	14262	7282	2	0	1
283084	1874	3451000	14262	7282	3	0	1
283153	1678	15120584979000	14263	7205	68	0	\N
283154	1678	15120584980000	14263	7205	69	0	\N
283155	1678	15120584981000	14263	7205	70	0	\N
283156	1678	15120584982000	14263	7205	71	0	\N
283157	1678	15120584983000	14263	7205	72	0	\N
283158	1678	15120584984000	14263	7205	73	0	\N
283159	1678	15120584985000	14263	7205	74	0	\N
283160	1678	15120584986000	14263	7205	75	0	\N
283161	1678	15120584987000	14263	7205	76	0	\N
283162	1678	15120584988000	14263	7205	77	0	\N
283163	1678	15120584989000	14263	7205	78	0	\N
283164	1678	15120584990000	14263	7205	79	0	\N
283165	1678	15120584991000	14263	7205	80	0	\N
283166	1678	15120584992000	14263	7205	81	0	\N
283167	1678	15120584993000	14263	7205	82	0	\N
283168	1678	15120584994000	14263	7205	83	0	\N
283169	1678	15120584995000	14263	7205	84	0	\N
283170	1678	15120584996000	14263	7205	85	0	\N
283171	1678	15120584997000	14263	7205	86	0	\N
283172	1678	15120584998000	14263	7205	87	0	\N
283173	1678	15120584999000	14263	7205	88	0	\N
283174	1678	15120585000000	14263	7205	89	0	\N
283175	1678	15120585001000	14263	7205	90	0	\N
283176	1678	15120585002000	14263	7205	91	0	\N
283177	1678	15120585003000	14263	7205	92	0	\N
283178	1678	15120585004000	14263	7205	93	0	\N
283179	1678	15120585005000	14263	7205	94	0	\N
283180	1678	15120585006000	14263	7205	95	0	\N
283181	1678	15120585007000	14263	7205	96	0	\N
283182	1745	1803000000	14263	7205	97	0	\N
283183	1874	2915000	14263	7205	98	0	\N
283184	1874	2916000	14263	7205	99	0	\N
283185	1874	2918000	14263	7205	100	0	\N
283186	1874	2921000	14263	7205	101	0	\N
283187	1874	2922000	14263	7205	102	0	\N
283188	1874	2924000	14263	7205	103	0	\N
283189	1874	2927000	14263	7205	104	0	\N
283190	1874	2928000	14263	7205	105	0	\N
283191	1874	2930000	14263	7205	106	0	\N
283192	1874	2933000	14263	7205	107	0	\N
283193	1874	2935000	14263	7205	108	0	\N
283194	1874	2938000	14263	7205	110	0	\N
283195	1874	2940000	14263	7205	111	0	\N
283196	1874	2941000	14263	7205	112	0	\N
283197	1874	2944000	14263	7205	113	0	\N
283198	1874	2946000	14263	7205	114	0	\N
283199	1874	2947000	14263	7205	115	0	\N
283200	1874	2950000	14263	7205	116	0	\N
283201	1874	2952000	14263	7205	117	0	\N
283202	1874	2953000	14263	7205	118	0	\N
283203	1874	2956000	14263	7205	119	0	\N
283204	1874	2958000	14263	7205	120	0	\N
283205	1874	2959000	14263	7205	121	0	\N
283206	1874	2962000	14263	7205	122	0	\N
283207	1874	2964000	14263	7205	123	0	\N
283208	1874	2965000	14263	7205	124	0	\N
283209	1874	2968000	14263	7205	125	0	\N
283214	1678	15840600009000	14265	7283	0	0	\N
283215	1874	3453000	14265	7283	1	0	\N
283216	1874	3454000	14265	7283	2	0	\N
283217	1874	3457000	14265	7283	3	0	\N
283230	1678	15840600010000	14267	7284	0	0	\N
283231	1678	15840600011000	14267	7284	1	0	\N
283232	1678	15840600012000	14267	7284	2	0	\N
283233	1874	3459000	14267	7284	3	0	\N
283234	1874	3460000	14267	7284	4	0	\N
283235	1874	3463000	14267	7284	5	0	\N
283236	1874	3465000	14267	7284	6	0	\N
283237	1874	3466000	14267	7284	7	0	\N
283238	1874	3469000	14267	7284	8	0	\N
283239	1874	3471000	14267	7284	9	0	\N
283240	1874	3472000	14267	7284	10	0	\N
283241	1874	3475000	14267	7284	11	0	\N
283242	1678	15840600010000	14268	7284	0	0	\N
283243	1678	15840600011000	14268	7284	1	0	\N
283244	1678	15840600012000	14268	7284	2	0	\N
283245	1874	3459000	14268	7284	3	0	\N
283246	1874	3460000	14268	7284	4	0	\N
283247	1874	3463000	14268	7284	5	0	\N
283248	1874	3465000	14268	7284	6	0	\N
283249	1874	3466000	14268	7284	7	0	\N
283250	1874	3469000	14268	7284	8	0	\N
283251	1874	3471000	14268	7284	9	0	\N
283252	1874	3472000	14268	7284	10	0	\N
283253	1874	3475000	14268	7284	11	0	\N
283254	1678	15840600013000	14269	7285	0	0	\N
283255	1678	15840600013000	14270	7285	0	0	\N
283256	1874	3477000	14270	7285	1	0	\N
283257	1874	3478000	14270	7285	2	0	\N
283258	1874	3481000	14270	7285	3	0	\N
283271	1678	15840600014000	14273	7286	0	0	\N
283272	1678	15840600015000	14273	7286	1	0	\N
283273	1874	3483000	14273	7286	2	0	\N
283274	1874	3484000	14273	7286	3	0	\N
283275	1874	3487000	14273	7286	4	0	\N
283276	1874	3489000	14273	7286	5	0	\N
283277	1874	3490000	14273	7286	6	0	\N
283278	1874	3493000	14273	7286	7	0	\N
283279	1678	15840600014000	14274	7286	0	0	\N
283280	1678	15840600015000	14274	7286	1	0	\N
283212	1874	3454000	14264	7283	2	0	1
283213	1874	3457000	14264	7283	3	0	1
283218	1678	15840600010000	14266	7284	0	0	0
283219	1678	15840600011000	14266	7284	1	0	0
283220	1678	15840600012000	14266	7284	2	0	0
283222	1874	3460000	14266	7284	4	0	1
283223	1874	3463000	14266	7284	5	0	1
283224	1874	3465000	14266	7284	6	0	1
283225	1874	3466000	14266	7284	7	0	1
283226	1874	3469000	14266	7284	8	0	1
283228	1874	3472000	14266	7284	10	0	1
283229	1874	3475000	14266	7284	11	0	1
283259	1678	15840600013000	14271	7285	0	0	0
283260	1874	3477000	14271	7285	1	0	1
283262	1874	3481000	14271	7285	3	0	1
283263	1678	15840600014000	14272	7286	0	0	0
283264	1678	15840600015000	14272	7286	1	0	0
283265	1874	3483000	14272	7286	2	0	1
283266	1874	3484000	14272	7286	3	0	1
283268	1874	3489000	14272	7286	5	0	1
283269	1874	3490000	14272	7286	6	0	1
283270	1874	3493000	14272	7286	7	0	1
283281	1678	15840600016000	14275	7287	0	0	0
283282	1874	3495000	14275	7287	1	0	1
283284	1010	506397153064601	14276	7288	0	0	0
283285	1130	907459359480949	14276	7288	1	0	0
283286	1250	612280912246859	14276	7288	2	0	0
283287	1376	1706175202959202	14276	7288	3	0	0
283290	1010	506397153064601	14277	7288	0	0	\N
283291	1130	907459359480949	14277	7288	1	0	\N
283292	1250	612280912246859	14277	7288	2	0	\N
283293	1376	1706175202959202	14277	7288	3	0	\N
283294	1678	15840600017000	14277	7288	4	0	\N
283295	1678	15840600018000	14277	7288	5	0	\N
283296	1874	3499000	14277	7288	6	0	\N
283297	1874	3501000	14277	7288	7	0	\N
283298	1874	3502000	14277	7288	8	0	\N
283299	1874	3505000	14277	7288	9	0	\N
283300	1874	3507000	14277	7288	10	0	\N
283301	1874	3508000	14277	7288	11	0	\N
283314	1678	15840600020000	14280	7290	0	0	\N
283315	1678	15840600021000	14280	7290	1	0	\N
283316	1874	3517000	14280	7290	2	0	\N
283317	1874	3519000	14280	7290	3	0	\N
283318	1874	3520000	14280	7290	4	0	\N
283319	1874	3523000	14280	7290	5	0	\N
283320	1874	3525000	14280	7290	6	0	\N
283321	1874	3526000	14280	7290	7	0	\N
283322	1678	15840600020000	14281	7290	0	0	\N
283323	1678	15840600021000	14281	7290	1	0	\N
283324	1874	3517000	14281	7290	2	0	\N
283325	1874	3519000	14281	7290	3	0	\N
283326	1874	3520000	14281	7290	4	0	\N
283327	1874	3523000	14281	7290	5	0	\N
283328	1874	3525000	14281	7290	6	0	\N
283329	1874	3526000	14281	7290	7	0	\N
283330	1010	506397153064601	14282	7207	0	0	\N
283331	1130	907459359480949	14282	7207	1	0	\N
283332	1250	612280912246859	14282	7207	2	0	\N
283333	1376	1706175202959202	14282	7207	3	0	\N
283334	1678	15120584915000	14282	7207	4	0	\N
283335	1678	15120584916000	14282	7207	5	0	\N
283336	1678	15120584917000	14282	7207	6	0	\N
283337	1678	15120584918000	14282	7207	7	0	\N
283338	1678	15120584919000	14282	7207	8	0	\N
283339	1678	15120584920000	14282	7207	9	0	\N
283340	1678	15120584921000	14282	7207	10	0	\N
283341	1678	15120584922000	14282	7207	11	0	\N
283342	1678	15120584923000	14282	7207	12	0	\N
283343	1678	15120584924000	14282	7207	13	0	\N
283344	1678	15120584925000	14282	7207	14	0	\N
283345	1678	15120584926000	14282	7207	15	0	\N
283346	1678	15120584927000	14282	7207	16	0	\N
283347	1678	15120584928000	14282	7207	17	0	\N
283348	1678	15120584929000	14282	7207	18	0	\N
283349	1678	15120584930000	14282	7207	19	0	\N
283350	1678	15120584931000	14282	7207	20	0	\N
283351	1678	15120584932000	14282	7207	21	0	\N
283352	1678	15120584933000	14282	7207	22	0	\N
283353	1678	15120584934000	14282	7207	23	0	\N
283354	1678	15120584935000	14282	7207	24	0	\N
283355	1678	15120584936000	14282	7207	25	0	\N
283356	1678	15120584937000	14282	7207	26	0	\N
283357	1678	15120584938000	14282	7207	27	0	\N
283358	1678	15120584939000	14282	7207	28	0	\N
283359	1678	15120584940000	14282	7207	29	0	\N
283360	1678	15120584941000	14282	7207	30	0	\N
283361	1678	15120584942000	14282	7207	31	0	\N
283362	1678	15120584943000	14282	7207	32	0	\N
283363	1678	15120584944000	14282	7207	33	0	\N
283364	1678	15120584945000	14282	7207	34	0	\N
283365	1678	15120584946000	14282	7207	35	0	\N
283366	1678	15120584947000	14282	7207	36	0	\N
283367	1678	15120584948000	14282	7207	37	0	\N
283368	1678	15120584949000	14282	7207	38	0	\N
283369	1678	15120584950000	14282	7207	39	0	\N
283370	1678	15120584951000	14282	7207	40	0	\N
283371	1678	15120584952000	14282	7207	41	0	\N
283372	1678	15120584953000	14282	7207	42	0	\N
283373	1678	15120584954000	14282	7207	43	0	\N
283374	1678	15120584955000	14282	7207	44	0	\N
283375	1678	15120584956000	14282	7207	45	0	\N
283376	1678	15120584957000	14282	7207	46	0	\N
283377	1678	15120584958000	14282	7207	47	0	\N
283378	1678	15120584959000	14282	7207	48	0	\N
283379	1678	15120584960000	14282	7207	49	0	\N
283380	1678	15120584961000	14282	7207	50	0	\N
283381	1678	15120584962000	14282	7207	51	0	\N
283382	1678	15120584963000	14282	7207	52	0	\N
283383	1678	15120584964000	14282	7207	53	0	\N
283384	1678	15120584965000	14282	7207	54	0	\N
283385	1678	15120584966000	14282	7207	55	0	\N
283386	1678	15120584967000	14282	7207	56	0	\N
283387	1678	15120584968000	14282	7207	57	0	\N
283388	1678	15120584969000	14282	7207	58	0	\N
283389	1678	15120584970000	14282	7207	59	0	\N
283390	1678	15120584971000	14282	7207	60	0	\N
283391	1678	15120584972000	14282	7207	61	0	\N
283392	1678	15120584973000	14282	7207	62	0	\N
283393	1678	15120584974000	14282	7207	63	0	\N
283394	1678	15120584975000	14282	7207	64	0	\N
283395	1678	15120584976000	14282	7207	65	0	\N
283396	1678	15120584977000	14282	7207	66	0	\N
283397	1678	15120584978000	14282	7207	67	0	\N
283398	1678	15120584979000	14282	7207	68	0	\N
283399	1678	15120584980000	14282	7207	69	0	\N
283400	1678	15120584981000	14282	7207	70	0	\N
283401	1678	15120584982000	14282	7207	71	0	\N
283402	1678	15120584983000	14282	7207	72	0	\N
283403	1678	15120584984000	14282	7207	73	0	\N
283404	1678	15120584985000	14282	7207	74	0	\N
283405	1678	15120584986000	14282	7207	75	0	\N
283406	1678	15120584987000	14282	7207	76	0	\N
283407	1678	15120584988000	14282	7207	77	0	\N
283408	1678	15120584989000	14282	7207	78	0	\N
283409	1678	15120584990000	14282	7207	79	0	\N
283410	1678	15120584991000	14282	7207	80	0	\N
283411	1678	15120584992000	14282	7207	81	0	\N
283412	1678	15120584993000	14282	7207	82	0	\N
283413	1678	15120584994000	14282	7207	83	0	\N
283414	1678	15120584995000	14282	7207	84	0	\N
283415	1678	15120584996000	14282	7207	85	0	\N
283416	1678	15120584997000	14282	7207	86	0	\N
283417	1678	15120584998000	14282	7207	87	0	\N
283418	1678	15120584999000	14282	7207	88	0	\N
283419	1678	15120585000000	14282	7207	89	0	\N
283420	1678	15120585001000	14282	7207	90	0	\N
283421	1678	15120585002000	14282	7207	91	0	\N
283422	1678	15120585003000	14282	7207	92	0	\N
283423	1678	15120585004000	14282	7207	93	0	\N
283424	1678	15120585005000	14282	7207	94	0	\N
283303	1874	3499000	14278	7289	1	0	1
283304	1874	3501000	14278	7289	2	0	1
283305	1874	3502000	14278	7289	3	0	1
283306	1874	3505000	14278	7289	4	0	1
283307	1874	3507000	14278	7289	5	0	1
283309	1874	3511000	14278	7289	7	0	1
283310	1874	3513000	14278	7289	8	0	1
283311	1874	3514000	14278	7289	9	0	1
283312	1678	15840600020000	14279	7290	0	0	0
283313	1678	15840600021000	14279	7290	1	0	0
283425	1678	15120585006000	14282	7207	96	0	\N
283426	1678	15120585007000	14282	7207	97	0	\N
283427	1678	15120585008000	14282	7207	98	0	\N
283428	1678	15120585009000	14282	7207	99	0	\N
283429	1678	15120585010000	14282	7207	100	0	\N
283430	1678	15120585011000	14282	7207	101	0	\N
283431	1678	15120585012000	14282	7207	102	0	\N
283432	1678	15120585013000	14282	7207	103	0	\N
283433	1678	15120585014000	14282	7207	104	0	\N
283434	1678	15120585015000	14282	7207	105	0	\N
283435	1678	15120585016000	14282	7207	106	0	\N
283436	1678	15120585017000	14282	7207	107	0	\N
283437	1678	15120585018000	14282	7207	108	0	\N
283438	1678	15120585019000	14282	7207	109	0	\N
283439	1678	15120585020000	14282	7207	110	0	\N
283440	1678	15120585021000	14282	7207	111	0	\N
283441	1745	1803000000	14282	7207	112	0	\N
283442	1874	2927000	14282	7207	113	0	\N
283457	1678	15840600024000	14284	7292	0	0	\N
283458	1874	3541000	14284	7292	1	0	\N
283459	1874	3543000	14284	7292	2	0	\N
283460	1874	3544000	14284	7292	3	0	\N
283461	1678	15840600024000	14285	7292	0	0	\N
283462	1874	3541000	14285	7292	1	0	\N
283463	1874	3543000	14285	7292	2	0	\N
283464	1874	3544000	14285	7292	3	0	\N
283469	1678	15840600024000	14287	7292	0	0	\N
283470	1874	3541000	14287	7292	1	0	\N
283471	1874	3543000	14287	7292	2	0	\N
283472	1874	3544000	14287	7292	3	0	\N
283473	1678	15840600024000	14288	7292	0	0	\N
283474	1874	3541000	14288	7292	1	0	\N
283475	1874	3543000	14288	7292	2	0	\N
283476	1874	3544000	14288	7292	3	0	\N
283477	1874	3547000	14288	7292	4	0	\N
283478	1874	3549000	14288	7292	5	0	\N
283479	1678	15840600025000	14289	7293	0	0	\N
283480	1678	15840600026000	14289	7293	1	0	\N
283481	1874	3547000	14289	7293	2	0	\N
283482	1874	3549000	14289	7293	3	0	\N
283483	1874	3550000	14289	7293	4	0	\N
283484	1874	3553000	14289	7293	5	0	\N
283485	1874	3555000	14289	7293	6	0	\N
283486	1678	15840600025000	14290	7293	0	0	\N
283487	1678	15840600026000	14290	7293	1	0	\N
283488	1874	3547000	14290	7293	2	0	\N
283489	1874	3549000	14290	7293	3	0	\N
283490	1874	3550000	14290	7293	4	0	\N
283491	1874	3553000	14290	7293	5	0	\N
283492	1874	3555000	14290	7293	6	0	\N
283500	1678	15840600027000	14293	7294	0	0	\N
283501	1874	3556000	14293	7294	2	0	\N
283502	1874	3558000	14293	7294	3	0	\N
283503	1874	3561000	14293	7294	4	0	\N
283508	1874	3556000	14295	7294	0	0	\N
283509	1874	3558000	14295	7294	2	0	\N
283510	1874	3561000	14295	7294	3	0	\N
283534	1010	506397153064601	14300	7221	0	0	\N
283535	1130	907459359480949	14300	7221	1	0	\N
283536	1250	612280912246859	14300	7221	2	0	\N
283537	1376	1706175202959202	14300	7221	3	0	\N
283538	2107	0	14300	7221	4	0	\N
283539	1678	15840600033000	14301	7299	0	0	\N
283540	1678	15840600034000	14301	7299	1	0	\N
283541	1678	15840600035000	14301	7299	2	0	\N
283542	1678	15840600033000	14302	7299	0	0	\N
283543	1678	15840600034000	14302	7299	1	0	\N
283544	1678	15840600035000	14302	7299	2	0	\N
283545	1874	3597000	14302	7299	3	0	\N
283546	1874	3599000	14302	7299	4	0	\N
283547	1874	3602000	14302	7299	5	0	\N
283548	1874	3603000	14302	7299	6	0	\N
283549	1874	3605000	14302	7299	7	0	\N
283550	1874	3608000	14302	7299	8	0	\N
283551	1874	3609000	14302	7299	9	0	\N
283552	1874	3611000	14302	7299	10	0	\N
283553	1874	3614000	14302	7299	11	0	\N
283445	1874	3517000	14283	7291	2	0	1
283446	1874	3519000	14283	7291	3	0	1
283447	1874	3520000	14283	7291	4	0	1
283448	1874	3523000	14283	7291	5	0	1
283449	1874	3525000	14283	7291	6	0	1
283451	1874	3529000	14283	7291	8	0	1
283452	1874	3531000	14283	7291	9	0	1
283453	1874	3532000	14283	7291	10	0	1
283454	1874	3535000	14283	7291	11	0	1
283455	1874	3537000	14283	7291	12	0	1
283465	1678	15840600024000	14286	7292	0	0	0
283466	1874	3541000	14286	7292	1	0	1
283467	1874	3543000	14286	7292	2	0	1
283468	1874	3544000	14286	7292	3	0	1
283494	1678	15840600026000	14291	7293	1	0	0
283495	1874	3547000	14291	7293	2	0	1
283496	1874	3549000	14291	7293	3	0	1
283497	1874	3550000	14291	7293	4	0	1
283498	1874	3553000	14291	7293	5	0	1
283504	1678	15840600027000	14294	7294	0	0	0
283505	1874	3556000	14294	7294	2	0	1
283506	1874	3558000	14294	7294	3	0	1
283507	1874	3561000	14294	7294	4	0	1
283511	1874	3563000	14296	7295	0	0	1
283513	1678	15840600028000	14297	7296	0	0	0
283514	1678	15840600029000	14297	7296	1	0	0
283515	1874	3568000	14297	7296	2	0	1
283516	1874	3569000	14297	7296	3	0	1
283518	2107	0	14297	7296	5	0	0
283519	1874	3574000	14297	7296	6	0	1
283520	1874	3575000	14297	7296	7	0	1
283521	1874	3578000	14297	7296	8	0	1
283522	1678	15840600030000	14298	7297	0	0	0
283524	1874	3581000	14298	7297	2	0	1
283525	1874	3584000	14298	7297	3	0	1
283526	1678	15840600031000	14299	7298	0	0	0
283527	1678	15840600032000	14299	7298	1	0	0
283528	1874	3586000	14299	7298	2	0	1
283530	1874	3590000	14299	7298	4	0	1
283531	1874	3592000	14299	7298	5	0	1
283532	1874	3593000	14299	7298	6	0	1
283533	1874	3596000	14299	7298	7	0	1
283555	1678	15840600034000	14303	7299	1	0	0
283556	1678	15840600035000	14303	7299	2	0	0
283557	1874	3597000	14303	7299	3	0	1
283558	1874	3599000	14303	7299	4	0	1
283559	1874	3602000	14303	7299	5	0	1
283566	1678	15120585008000	14304	7206	0	0	\N
283567	1010	506397153064601	14304	7206	1	0	\N
283568	1130	907459359480949	14304	7206	2	0	\N
283569	1250	612280912246859	14304	7206	3	0	\N
283570	1376	1706175202959202	14304	7206	4	0	\N
283571	1678	15120585009000	14304	7206	5	0	\N
283572	1678	15120585010000	14304	7206	6	0	\N
283573	1678	15120585011000	14304	7206	7	0	\N
283574	1678	15120585012000	14304	7206	8	0	\N
283575	1678	15120585013000	14304	7206	9	0	\N
283576	1678	15120585014000	14304	7206	10	0	\N
283577	1678	15120585015000	14304	7206	11	0	\N
283578	1678	15120585016000	14304	7206	12	0	\N
283579	1678	15120585017000	14304	7206	13	0	\N
283580	1678	15120585018000	14304	7206	14	0	\N
283581	1678	15120585019000	14304	7206	15	0	\N
283582	1678	15120585020000	14304	7206	16	0	\N
283583	1678	15120585021000	14304	7206	17	0	\N
283584	1678	15120585022000	14304	7206	18	0	\N
283585	1678	15120585023000	14304	7206	19	0	\N
283586	1678	15120585024000	14304	7206	20	0	\N
283587	1678	15120585025000	14304	7206	21	0	\N
283588	1678	15120585026000	14304	7206	22	0	\N
283589	1678	15120585027000	14304	7206	23	0	\N
283590	1678	15120585028000	14304	7206	24	0	\N
283591	1678	15120585029000	14304	7206	25	0	\N
283592	1678	15120585030000	14304	7206	26	0	\N
283593	1678	15120585031000	14304	7206	27	0	\N
283594	1678	15120585032000	14304	7206	28	0	\N
283595	1678	15120585033000	14304	7206	29	0	\N
283596	1678	15120585034000	14304	7206	30	0	\N
283597	1678	15120585035000	14304	7206	31	0	\N
283598	1874	2970000	14304	7206	32	0	\N
283599	1874	2971000	14304	7206	33	0	\N
283600	1874	2974000	14304	7206	34	0	\N
283601	1874	2976000	14304	7206	35	0	\N
283602	1874	2977000	14304	7206	36	0	\N
283603	2107	0	14304	7206	37	0	\N
283604	1874	2980000	14304	7206	38	0	\N
283605	1874	2982000	14304	7206	39	0	\N
283606	1874	2983000	14304	7206	40	0	\N
283607	1874	2986000	14304	7206	41	0	\N
283608	1874	2988000	14304	7206	42	0	\N
283609	1874	2989000	14304	7206	43	0	\N
283610	1874	2992000	14304	7206	44	0	\N
283611	1874	2994000	14304	7206	45	0	\N
283612	1874	2995000	14304	7206	46	0	\N
283613	1874	2998000	14304	7206	47	0	\N
283614	1874	3000000	14304	7206	48	0	\N
283615	1874	3001000	14304	7206	49	0	\N
283616	1874	3004000	14304	7206	50	0	\N
283617	1874	3006000	14304	7206	51	0	\N
283618	1874	3007000	14304	7206	52	0	\N
283619	1874	3010000	14304	7206	53	0	\N
283620	1874	3012000	14304	7206	54	0	\N
283621	1874	3015000	14304	7206	55	0	\N
283622	1874	3016000	14304	7206	56	0	\N
283623	1874	3018000	14304	7206	57	0	\N
283624	1874	3021000	14304	7206	58	0	\N
283625	1874	3023000	14304	7206	59	0	\N
283626	1874	3026000	14304	7206	60	0	\N
283627	1874	3027000	14304	7206	61	0	\N
283628	1874	3029000	14304	7206	62	0	\N
283629	1874	3032000	14304	7206	63	0	\N
283630	1874	3033000	14304	7206	64	0	\N
283631	1874	3035000	14304	7206	65	0	\N
283632	1874	3038000	14304	7206	66	0	\N
283633	1874	3039000	14304	7206	67	0	\N
283634	1874	3041000	14304	7206	68	0	\N
283635	1874	3042000	14304	7206	69	0	\N
283636	1874	3044000	14304	7206	70	0	\N
283637	1874	3047000	14304	7206	71	0	\N
283638	1874	3049000	14304	7206	72	0	\N
283639	1874	3052000	14304	7206	73	0	\N
283640	1874	3054000	14304	7206	74	0	\N
283641	1874	3057000	14304	7206	75	0	\N
283642	1874	3059000	14304	7206	76	0	\N
283643	1874	3062000	14304	7206	77	0	\N
283644	1874	3064000	14304	7206	78	0	\N
283645	1874	3067000	14304	7206	79	0	\N
283646	1874	3069000	14304	7206	80	0	\N
283647	1874	3072000	14304	7206	81	0	\N
283648	1874	3074000	14304	7206	82	0	\N
283649	1874	3077000	14304	7206	83	0	\N
283650	1874	3079000	14304	7206	84	0	\N
283651	1874	3082000	14304	7206	85	0	\N
283652	1874	3084000	14304	7206	86	0	\N
283653	1874	3087000	14304	7206	87	0	\N
283654	1874	3089000	14304	7206	88	0	\N
283655	1874	3092000	14304	7206	89	0	\N
283656	1874	3094000	14304	7206	90	0	\N
283657	1874	3097000	14304	7206	91	0	\N
283658	1874	3099000	14304	7206	92	0	\N
283659	1874	3102000	14304	7206	93	0	\N
283660	1874	3104000	14304	7206	94	0	\N
283661	1874	3107000	14304	7206	95	0	\N
283662	1874	3109000	14304	7206	96	0	\N
283663	1874	3112000	14304	7206	97	0	\N
283664	1874	3114000	14304	7206	98	0	\N
283665	1874	3117000	14304	7206	99	0	\N
283666	1874	3119000	14304	7206	100	0	\N
283667	1874	3120000	14304	7206	101	0	\N
283668	1874	3123000	14304	7206	102	0	\N
283669	1874	3125000	14304	7206	103	0	\N
283670	1874	3126000	14304	7206	104	0	\N
283671	1874	3129000	14304	7206	105	0	\N
283672	1874	3131000	14304	7206	106	0	\N
283673	1874	3132000	14304	7206	107	0	\N
283674	1874	3135000	14304	7206	108	0	\N
283675	1874	3137000	14304	7206	110	0	\N
283676	2105	200000000	14304	7206	111	0	\N
283677	1874	3138000	14304	7206	112	0	\N
283678	1874	3141000	14304	7206	113	0	\N
283679	1874	3143000	14304	7206	114	0	\N
283680	1874	3144000	14304	7206	115	0	\N
283681	1874	3147000	14304	7206	116	0	\N
283682	1874	3149000	14304	7206	117	0	\N
283683	1874	3150000	14304	7206	118	0	\N
283684	1874	3153000	14304	7206	119	0	\N
283685	1874	3155000	14304	7206	120	0	\N
283686	1874	3156000	14304	7206	121	0	\N
283687	1874	3158000	14304	7206	122	0	\N
283688	1874	3159000	14304	7206	123	0	\N
283689	1874	3162000	14304	7206	124	0	\N
283690	1874	3164000	14304	7206	125	0	\N
283563	1874	3609000	14303	7299	9	0	1
283564	1874	3611000	14303	7299	10	0	1
283565	1874	3614000	14303	7299	11	0	1
283691	1678	15840600036000	14305	7300	0	0	0
283692	1678	15840600037000	14305	7300	1	0	0
283694	1874	3617000	14305	7300	3	0	1
283695	1874	3620000	14305	7300	4	0	1
283696	1874	3622000	14305	7300	5	0	1
283698	1678	15840600036000	14306	7300	0	0	\N
283699	1678	15840600037000	14306	7300	1	0	\N
283700	1874	3615000	14306	7300	2	0	\N
283701	1874	3617000	14306	7300	3	0	\N
283702	1874	3620000	14306	7300	4	0	\N
283703	1874	3622000	14306	7300	5	0	\N
283704	1874	3625000	14306	7300	6	0	\N
283712	1678	15840600038000	14308	7301	0	0	\N
283713	1678	15840600039000	14308	7301	1	0	\N
283714	1874	3626000	14308	7301	2	0	\N
283715	1874	3629000	14308	7301	3	0	\N
283716	1874	3630000	14308	7301	4	0	\N
283717	1874	3632000	14308	7301	5	0	\N
283718	1874	3635000	14308	7301	6	0	\N
283722	1678	15840600041000	14310	7303	0	0	\N
283723	1874	3640000	14310	7303	1	0	\N
283724	1874	3642000	14310	7303	2	0	\N
283725	1874	3645000	14310	7303	3	0	\N
283730	1678	15840600042000	14312	7304	0	0	\N
283731	1874	3647000	14312	7304	1	0	\N
283732	1874	3650000	14312	7304	2	0	\N
283733	1678	15840600042000	14313	7304	0	0	\N
283734	1874	3647000	14313	7304	1	0	\N
283735	1874	3650000	14313	7304	2	0	\N
283739	1678	15840600043000	14315	7305	0	0	\N
283740	1874	3652000	14315	7305	1	0	\N
283741	1874	3653000	14315	7305	2	0	\N
283742	1678	15840600043000	14316	7305	0	0	\N
283743	1874	3652000	14316	7305	1	0	\N
283744	1874	3653000	14316	7305	2	0	\N
283748	1678	15840600043000	14318	7305	0	0	\N
283749	1874	3652000	14318	7305	1	0	\N
283750	1874	3653000	14318	7305	2	0	\N
283751	1678	15840600044000	14319	7306	0	0	\N
283752	1874	3655000	14319	7306	1	0	\N
283753	1874	3656000	14319	7306	2	0	\N
283754	1874	3659000	14319	7306	3	0	\N
283759	1678	15840600044000	14321	7306	0	0	\N
283760	1874	3655000	14321	7306	1	0	\N
283761	1874	3656000	14321	7306	2	0	\N
283762	1874	3659000	14321	7306	3	0	\N
283770	1678	15840600047000	14323	7308	0	0	\N
283771	1874	3671000	14323	7308	1	0	\N
283772	1874	3673000	14323	7308	2	0	\N
283773	1874	3674000	14323	7308	3	0	\N
283782	1678	15840600048000	14326	7309	0	0	\N
283783	1874	3677000	14326	7309	1	0	\N
283784	1874	3679000	14326	7309	2	0	\N
283796	1678	15840600051000	14330	7312	0	0	\N
283797	1874	3695000	14330	7312	1	0	\N
283802	1678	15840600052000	14332	7313	0	0	\N
283803	1874	3698000	14332	7313	1	0	\N
283804	1874	3701000	14332	7313	2	0	\N
283805	1874	3703000	14332	7313	3	0	\N
283706	1678	15840600039000	14307	7301	1	0	0
283707	1874	3626000	14307	7301	2	0	1
283708	1874	3629000	14307	7301	3	0	1
283709	1874	3630000	14307	7301	4	0	1
283710	1874	3632000	14307	7301	5	0	1
283719	1678	15840600040000	14309	7302	0	0	0
283720	1874	3636000	14309	7302	1	0	1
283721	1874	3639000	14309	7302	2	0	1
283726	1678	15840600041000	14311	7303	0	0	0
283727	1874	3640000	14311	7303	1	0	1
283729	1874	3645000	14311	7303	3	0	1
283736	1678	15840600042000	14314	7304	0	0	0
283737	1874	3647000	14314	7304	1	0	1
283738	1874	3650000	14314	7304	2	0	1
283746	1874	3652000	14317	7305	1	0	1
283747	1874	3653000	14317	7305	2	0	1
283755	1678	15840600044000	14320	7306	0	0	0
283756	1874	3655000	14320	7306	1	0	1
283757	1874	3656000	14320	7306	2	0	1
283763	1678	15840600045000	14322	7307	0	0	0
283764	1678	15840600046000	14322	7307	1	0	0
283765	1874	3661000	14322	7307	2	0	1
283766	1874	3662000	14322	7307	3	0	1
283767	1874	3665000	14322	7307	4	0	1
283769	1874	3668000	14322	7307	6	0	1
283774	1678	15840600047000	14324	7308	0	0	0
283775	1874	3671000	14324	7308	1	0	1
283776	1874	3673000	14324	7308	2	0	1
283778	1678	15840600048000	14325	7309	0	0	0
283779	1874	3677000	14325	7309	1	0	1
283780	1874	3679000	14325	7309	2	0	1
283781	1874	3680000	14325	7309	3	0	1
283785	1678	15840600049000	14327	7310	0	0	0
283787	1874	3685000	14327	7310	2	0	1
283788	1874	3686000	14327	7310	3	0	1
283789	1678	15840600050000	14328	7311	0	0	0
283790	1874	3689000	14328	7311	1	0	1
283791	1874	3691000	14328	7311	2	0	1
283793	1678	15840600051000	14329	7312	0	0	0
283794	1874	3695000	14329	7312	1	0	1
283795	1874	3697000	14329	7312	2	0	1
283798	1678	15840600052000	14331	7313	0	0	0
283800	1874	3701000	14331	7313	2	0	1
283801	1874	3703000	14331	7313	3	0	1
283806	1678	15840600053000	14333	7314	0	0	0
283807	1678	15840600054000	14333	7314	1	0	0
283808	1874	3706000	14333	7314	2	0	1
283810	1874	3708000	14333	7314	4	0	1
283811	1874	3709000	14333	7314	5	0	1
283812	1874	3712000	14333	7314	6	0	1
283813	1874	3714000	14333	7314	7	0	1
283814	1678	15840600055000	14334	7315	0	0	0
283816	1874	3718000	14334	7315	2	0	1
283817	1874	3720000	14334	7315	3	0	1
283818	1678	15840600056000	14335	7316	0	0	0
283819	1678	15840600057000	14335	7316	1	0	0
283821	1874	3724000	14335	7316	3	0	1
283822	1874	3726000	14335	7316	4	0	1
283823	1874	3727000	14335	7316	5	0	1
283824	1874	3730000	14335	7316	6	0	1
283825	1874	3732000	14335	7316	7	0	1
283827	1874	3733000	14336	7317	1	0	1
283828	1874	3736000	14336	7317	2	0	1
283829	1874	3738000	14336	7317	3	0	1
283830	1678	15840600059000	14337	7318	0	0	0
283831	1874	3739000	14337	7318	1	0	1
283834	1678	15840600059000	14338	7318	0	0	\N
283835	1874	3739000	14338	7318	1	0	\N
283836	1874	3742000	14338	7318	2	0	\N
283837	1874	3744000	14338	7318	3	0	\N
283846	1678	15840600062000	14340	7320	0	0	\N
283847	1874	3757000	14340	7320	1	0	\N
283848	1874	3760000	14340	7320	2	0	\N
283849	1874	3762000	14340	7320	3	0	\N
283854	1678	15840600063000	14342	7321	0	0	\N
283855	1874	3763000	14342	7321	1	0	\N
283856	1874	3766000	14342	7321	2	0	\N
283857	1874	3768000	14342	7321	3	0	\N
283858	1874	3769000	14342	7321	4	0	\N
283859	1874	3772000	14342	7321	5	0	\N
283860	1874	3774000	14342	7321	6	0	\N
283861	1678	15840600063000	14343	7321	0	0	\N
283862	1874	3763000	14343	7321	1	0	\N
283863	1874	3766000	14343	7321	2	0	\N
283864	1874	3768000	14343	7321	3	0	\N
283865	1874	3769000	14343	7321	4	0	\N
283866	1874	3772000	14343	7321	5	0	\N
283867	1874	3774000	14343	7321	6	0	\N
283883	1678	15840600064000	14346	7322	0	0	\N
283884	1678	15840600065000	14346	7322	1	0	\N
283885	1874	3775000	14346	7322	2	0	\N
283886	1874	3778000	14346	7322	3	0	\N
283887	1874	3780000	14346	7322	4	0	\N
283888	1874	3781000	14346	7322	5	0	\N
283889	1874	3784000	14346	7322	6	0	\N
283890	1874	3786000	14346	7322	7	0	\N
283895	1678	15120584897000	14348	7192	1	0	\N
283896	1678	15120584898000	14348	7192	2	0	\N
283897	1678	15120584899000	14348	7192	3	0	\N
283898	1678	15120584900000	14348	7192	4	0	\N
283899	1678	15120584901000	14348	7192	5	0	\N
283900	1678	15120584902000	14348	7192	6	0	\N
283901	1010	506397153064601	14348	7192	7	0	\N
283902	1130	907459359480949	14348	7192	8	0	\N
283903	1250	612280912246859	14348	7192	9	0	\N
283904	1376	1706175202959202	14348	7192	10	0	\N
283905	1678	15120584903000	14348	7192	11	0	\N
283906	1678	15120584904000	14348	7192	12	0	\N
283907	1678	15120584905000	14348	7192	13	0	\N
283908	1678	15120584906000	14348	7192	14	0	\N
283909	1678	15120584907000	14348	7192	15	0	\N
283910	1678	15120584908000	14348	7192	16	0	\N
283911	1678	15120584909000	14348	7192	17	0	\N
283912	1678	15120584910000	14348	7192	18	0	\N
283913	1678	15120584911000	14348	7192	19	0	\N
283914	1678	15120584912000	14348	7192	20	0	\N
283915	1678	15120584913000	14348	7192	21	0	\N
283916	1678	15120584914000	14348	7192	22	0	\N
283917	1678	15120584915000	14348	7192	23	0	\N
283918	1678	15120584916000	14348	7192	24	0	\N
283919	1678	15120584917000	14348	7192	25	0	\N
283920	1678	15120584918000	14348	7192	26	0	\N
283921	1678	15120584919000	14348	7192	27	0	\N
283922	1678	15120584920000	14348	7192	28	0	\N
283923	1678	15120584921000	14348	7192	29	0	\N
283924	1678	15120584922000	14348	7192	30	0	\N
283925	1678	15120584923000	14348	7192	31	0	\N
283926	1678	15120584924000	14348	7192	32	0	\N
283927	1678	15120584925000	14348	7192	33	0	\N
283928	1678	15120584926000	14348	7192	34	0	\N
283929	1678	15120584927000	14348	7192	35	0	\N
283930	1678	15120584928000	14348	7192	36	0	\N
283931	1678	15120584929000	14348	7192	37	0	\N
283932	1678	15120584930000	14348	7192	38	0	\N
283933	1678	15120584931000	14348	7192	39	0	\N
283934	1678	15120584932000	14348	7192	40	0	\N
283935	1678	15120584933000	14348	7192	41	0	\N
283936	1678	15120584934000	14348	7192	42	0	\N
283937	1678	15120584935000	14348	7192	43	0	\N
283938	1678	15120584936000	14348	7192	44	0	\N
283939	1678	15120584937000	14348	7192	45	0	\N
283940	1678	15120584938000	14348	7192	46	0	\N
283941	1678	15120584939000	14348	7192	47	0	\N
283942	1678	15120584940000	14348	7192	48	0	\N
283943	1678	15120584941000	14348	7192	49	0	\N
283944	1678	15120584942000	14348	7192	50	0	\N
283945	1678	15120584943000	14348	7192	51	0	\N
283946	1678	15120584944000	14348	7192	52	0	\N
283947	1678	15120584945000	14348	7192	53	0	\N
283948	1678	15120584946000	14348	7192	54	0	\N
283949	1678	15120584947000	14348	7192	55	0	\N
283950	1678	15120584948000	14348	7192	56	0	\N
283951	1678	15120584949000	14348	7192	57	0	\N
283952	1678	15120584950000	14348	7192	58	0	\N
283953	1678	15120584951000	14348	7192	59	0	\N
283954	1678	15120584952000	14348	7192	60	0	\N
283955	1678	15120584953000	14348	7192	61	0	\N
283956	1678	15120584954000	14348	7192	62	0	\N
283957	1678	15120584955000	14348	7192	63	0	\N
283958	1678	15120584956000	14348	7192	64	0	\N
283959	1678	15120584957000	14348	7192	65	0	\N
283960	1678	15120584958000	14348	7192	66	0	\N
283961	1678	15120584959000	14348	7192	67	0	\N
283962	1678	15120584960000	14348	7192	68	0	\N
283963	1678	15120584961000	14348	7192	69	0	\N
283964	1678	15120584962000	14348	7192	70	0	\N
283965	1678	15120584963000	14348	7192	71	0	\N
283966	1678	15120584964000	14348	7192	72	0	\N
283967	1678	15120584965000	14348	7192	73	0	\N
283968	1678	15120584966000	14348	7192	75	0	\N
283839	1678	15840600061000	14339	7319	1	0	0
283840	1874	3745000	14339	7319	2	0	1
283841	1874	3748000	14339	7319	3	0	1
283842	1874	3750000	14339	7319	4	0	1
283843	1874	3751000	14339	7319	5	0	1
283845	1874	3756000	14339	7319	7	0	1
283850	1678	15840600062000	14341	7320	0	0	0
283851	1874	3757000	14341	7320	1	0	1
283852	1874	3760000	14341	7320	2	0	1
283853	1874	3762000	14341	7320	3	0	1
283869	1874	3763000	14344	7321	1	0	1
283870	1874	3766000	14344	7321	2	0	1
283871	1874	3768000	14344	7321	3	0	1
283872	1874	3769000	14344	7321	4	0	1
283874	1874	3774000	14344	7321	6	0	1
283875	1678	15840600064000	14345	7322	0	0	0
283876	1678	15840600065000	14345	7322	1	0	0
283877	1874	3775000	14345	7322	2	0	1
283878	1874	3778000	14345	7322	3	0	1
283880	1874	3781000	14345	7322	5	0	1
283881	1874	3784000	14345	7322	6	0	1
283882	1874	3786000	14345	7322	7	0	1
283891	1678	15840600066000	14347	7323	0	0	0
283892	1874	3787000	14347	7323	1	0	1
283894	1874	3792000	14347	7323	3	0	1
283969	1678	15120584967000	14348	7192	76	0	\N
283970	1678	15120584968000	14348	7192	77	0	\N
283971	1678	15120584969000	14348	7192	78	0	\N
283972	1678	15120584970000	14348	7192	79	0	\N
283973	1678	15120584971000	14348	7192	80	0	\N
283974	1678	15120584972000	14348	7192	81	0	\N
283975	1678	15120584973000	14348	7192	82	0	\N
283976	1678	15120584974000	14348	7192	83	0	\N
283977	1678	15120584975000	14348	7192	84	0	\N
283978	1678	15120584976000	14348	7192	85	0	\N
283979	1678	15120584977000	14348	7192	86	0	\N
283980	1678	15120584978000	14348	7192	87	0	\N
283981	1678	15120584979000	14348	7192	88	0	\N
283982	1678	15120584980000	14348	7192	89	0	\N
283983	1678	15120584981000	14348	7192	90	0	\N
283984	1678	15120584982000	14348	7192	91	0	\N
283985	1678	15120584983000	14348	7192	92	0	\N
283986	1678	15120584984000	14348	7192	93	0	\N
283987	1678	15120584985000	14348	7192	94	0	\N
283988	1678	15120584986000	14348	7192	95	0	\N
283989	1678	15120584987000	14348	7192	96	0	\N
283990	1678	15120584988000	14348	7192	97	0	\N
283991	1678	15120584989000	14348	7192	98	0	\N
283992	1678	15120584990000	14348	7192	99	0	\N
283993	1678	15120584991000	14348	7192	100	0	\N
283994	1678	15120584992000	14348	7192	101	0	\N
283995	1678	15120584993000	14348	7192	102	0	\N
283996	1678	15120584994000	14348	7192	103	0	\N
283997	1678	15120584995000	14348	7192	104	0	\N
283998	1678	15120584996000	14348	7192	105	0	\N
283999	1678	15120584997000	14348	7192	106	0	\N
284000	1678	15120584998000	14348	7192	107	0	\N
284001	1678	15120584999000	14348	7192	108	0	\N
284002	1678	15120585000000	14348	7192	109	0	\N
284003	1678	15120585001000	14348	7192	110	0	\N
284004	1678	15120585002000	14348	7192	111	0	\N
284005	1678	15120585003000	14348	7192	112	0	\N
284006	1678	15120585004000	14348	7192	113	0	\N
284007	1678	15120585005000	14348	7192	114	0	\N
284008	1678	15120585006000	14348	7192	115	0	\N
284009	1678	15120585007000	14348	7192	116	0	\N
284010	1678	15120585008000	14348	7192	117	0	\N
284011	1678	15120585009000	14348	7192	118	0	\N
284012	1678	15120585010000	14348	7192	119	0	\N
284013	1678	15120585011000	14348	7192	120	0	\N
284014	1678	15120585012000	14348	7192	121	0	\N
284015	1678	15120585013000	14348	7192	122	0	\N
284016	1678	15120585014000	14348	7192	123	0	\N
284017	1678	15120585015000	14348	7192	124	0	\N
284018	1678	15120585016000	14348	7192	125	0	\N
284029	1678	15840600068000	14351	7325	0	0	\N
284030	1678	15840600069000	14351	7325	1	0	\N
284031	1874	3798000	14351	7325	2	0	\N
284032	1874	3799000	14351	7325	3	0	\N
284033	1874	3801000	14351	7325	4	0	\N
284034	1874	3804000	14351	7325	5	0	\N
284035	1874	3805000	14351	7325	6	0	\N
284040	1678	15840600071000	14353	7327	0	0	\N
284041	1874	3813000	14353	7327	1	0	\N
284042	1874	3816000	14353	7327	2	0	\N
284043	1874	3817000	14353	7327	3	0	\N
284057	141	66000100000000	14357	7227	0	0	\N
284058	1010	506397153064601	14357	7227	1	0	\N
284059	1130	907459359480949	14357	7227	2	0	\N
284060	1250	612280912246859	14357	7227	3	0	\N
284061	1376	1706175202959202	14357	7227	4	0	\N
284062	2107	0	14357	7227	5	0	\N
284067	1678	15840600074000	14359	7330	0	0	\N
284068	1874	3831000	14359	7330	1	0	\N
284069	1874	3834000	14359	7330	2	0	\N
284070	1874	3835000	14359	7330	3	0	\N
284071	1678	15840600074000	14360	7330	0	0	\N
284072	1874	3831000	14360	7330	1	0	\N
284073	1874	3834000	14360	7330	2	0	\N
284074	1874	3835000	14360	7330	3	0	\N
284075	1678	15840600074000	14361	7330	0	0	\N
284076	1874	3831000	14361	7330	1	0	\N
284077	1874	3834000	14361	7330	2	0	\N
284078	1874	3835000	14361	7330	3	0	\N
284079	141	66000100000000	14362	7238	0	0	\N
284080	1010	506397153064601	14362	7238	1	0	\N
284081	1130	907459359480949	14362	7238	2	0	\N
284082	1250	612280912246859	14362	7238	3	0	\N
284083	1376	1706175202959202	14362	7238	4	0	\N
284084	1678	15120584955000	14362	7238	5	0	\N
284085	1678	15120584956000	14362	7238	6	0	\N
284086	1678	15120584957000	14362	7238	7	0	\N
284087	1678	15120584958000	14362	7238	8	0	\N
284088	1678	15120584959000	14362	7238	9	0	\N
284089	1678	15120584960000	14362	7238	10	0	\N
284090	1678	15120584961000	14362	7238	11	0	\N
284091	1678	15120584962000	14362	7238	13	0	\N
284092	1678	15120584963000	14362	7238	14	0	\N
284093	1678	15120584964000	14362	7238	15	0	\N
284094	1678	15120584965000	14362	7238	16	0	\N
284095	1678	15120584966000	14362	7238	17	0	\N
284096	1678	15120584967000	14362	7238	18	0	\N
284097	1678	15120584968000	14362	7238	19	0	\N
284098	1678	15120584969000	14362	7238	20	0	\N
284099	1678	15120584970000	14362	7238	21	0	\N
284100	1678	15120584971000	14362	7238	22	0	\N
284101	1678	15120584972000	14362	7238	23	0	\N
284102	1678	15120584973000	14362	7238	24	0	\N
284103	1678	15120584974000	14362	7238	25	0	\N
284104	1678	15120584975000	14362	7238	26	0	\N
284021	1874	3795000	14349	7324	2	0	1
284022	1678	15840600068000	14350	7325	0	0	0
284023	1678	15840600069000	14350	7325	1	0	0
284024	1874	3798000	14350	7325	2	0	1
284025	1874	3799000	14350	7325	3	0	1
284027	1874	3804000	14350	7325	5	0	1
284028	1874	3805000	14350	7325	6	0	1
284036	1678	15840600070000	14352	7326	0	0	0
284037	1874	3807000	14352	7326	1	0	1
284038	1874	3810000	14352	7326	2	0	1
284044	1678	15840600071000	14354	7327	0	0	0
284045	1874	3813000	14354	7327	1	0	1
284046	1874	3816000	14354	7327	2	0	1
284047	1874	3817000	14354	7327	3	0	1
284049	1678	15840600073000	14356	7329	0	0	0
284050	141	66000100000000	14356	7329	1	0	0
284051	1874	3819000	14356	7329	2	0	1
284052	1874	3822000	14356	7329	3	0	1
284053	1874	3823000	14356	7329	4	0	1
284055	1874	3828000	14356	7329	6	0	1
284056	1874	3829000	14356	7329	7	0	1
284063	1678	15840600074000	14358	7330	0	0	0
284064	1874	3831000	14358	7330	1	0	1
284065	1874	3834000	14358	7330	2	0	1
284105	1678	15120584976000	14362	7238	27	0	\N
284106	1678	15120584977000	14362	7238	28	0	\N
284107	1678	15120584978000	14362	7238	29	0	\N
284108	1678	15120584979000	14362	7238	30	0	\N
284109	1678	15120584980000	14362	7238	31	0	\N
284110	1678	15120584981000	14362	7238	32	0	\N
284111	1678	15120584982000	14362	7238	33	0	\N
284112	1678	15120584983000	14362	7238	34	0	\N
284113	1678	15120584984000	14362	7238	35	0	\N
284114	1678	15120584985000	14362	7238	36	0	\N
284115	1678	15120584986000	14362	7238	37	0	\N
284116	1678	15120584987000	14362	7238	38	0	\N
284117	1678	15120584988000	14362	7238	39	0	\N
284118	1678	15120584989000	14362	7238	40	0	\N
284119	1678	15120584990000	14362	7238	41	0	\N
284120	1678	15120584991000	14362	7238	42	0	\N
284121	1678	15120584992000	14362	7238	43	0	\N
284122	1678	15120584993000	14362	7238	44	0	\N
284123	1678	15120584994000	14362	7238	45	0	\N
284124	1678	15120584995000	14362	7238	46	0	\N
284125	1678	15120584996000	14362	7238	47	0	\N
284126	1678	15120584997000	14362	7238	48	0	\N
284127	1678	15120584998000	14362	7238	49	0	\N
284128	1678	15120584999000	14362	7238	50	0	\N
284129	1678	15120585000000	14362	7238	51	0	\N
284130	1678	15120585001000	14362	7238	52	0	\N
284131	1678	15120585002000	14362	7238	53	0	\N
284132	1678	15120585003000	14362	7238	54	0	\N
284133	1678	15120585004000	14362	7238	55	0	\N
284134	1678	15120585005000	14362	7238	56	0	\N
284135	1678	15120585006000	14362	7238	57	0	\N
284136	1678	15120585007000	14362	7238	58	0	\N
284137	1678	15120585008000	14362	7238	59	0	\N
284138	1678	15120585009000	14362	7238	60	0	\N
284139	1678	15120585010000	14362	7238	61	0	\N
284140	1678	15120585011000	14362	7238	62	0	\N
284141	1678	15120585012000	14362	7238	63	0	\N
284142	1678	15120585013000	14362	7238	64	0	\N
284143	1678	15120585014000	14362	7238	65	0	\N
284144	1678	15120585015000	14362	7238	66	0	\N
284145	1678	15120585016000	14362	7238	67	0	\N
284146	1678	15120585017000	14362	7238	68	0	\N
284147	1678	15120585018000	14362	7238	69	0	\N
284148	1678	15120585019000	14362	7238	70	0	\N
284149	1678	15120585020000	14362	7238	71	0	\N
284150	1678	15120585021000	14362	7238	72	0	\N
284151	1678	15120585022000	14362	7238	73	0	\N
284152	1678	15120585023000	14362	7238	74	0	\N
284153	1678	15120585024000	14362	7238	75	0	\N
284154	1678	15120585025000	14362	7238	76	0	\N
284155	1678	15120585026000	14362	7238	77	0	\N
284156	1678	15120585027000	14362	7238	78	0	\N
284157	1678	15120585028000	14362	7238	79	0	\N
284158	1678	15120585029000	14362	7238	80	0	\N
284159	1678	15120585030000	14362	7238	81	0	\N
284160	1678	15120585031000	14362	7238	82	0	\N
284161	1678	15120585032000	14362	7238	83	0	\N
284162	1678	15120585033000	14362	7238	84	0	\N
284163	1678	15120585034000	14362	7238	85	0	\N
284164	1678	15120585035000	14362	7238	86	0	\N
284165	1678	15120585036000	14362	7238	87	0	\N
284166	1678	15120585037000	14362	7238	88	0	\N
284167	1678	15120585038000	14362	7238	89	0	\N
284168	1678	15120585039000	14362	7238	90	0	\N
284169	1678	15120585040000	14362	7238	91	0	\N
284170	1678	15120585041000	14362	7238	92	0	\N
284171	1678	15120585042000	14362	7238	93	0	\N
284172	1678	15120585043000	14362	7238	94	0	\N
284173	1678	15120585044000	14362	7238	95	0	\N
284174	1678	15120585045000	14362	7238	96	0	\N
284175	1678	15120585046000	14362	7238	97	0	\N
284176	1678	15120585047000	14362	7238	98	0	\N
284177	1678	15120585048000	14362	7238	99	0	\N
284178	1678	15120585049000	14362	7238	100	0	\N
284179	1678	15120585050000	14362	7238	101	0	\N
284180	1678	15120585051000	14362	7238	102	0	\N
284181	1678	15120585052000	14362	7238	103	0	\N
284182	1678	15120585053000	14362	7238	104	0	\N
284183	1678	15120585054000	14362	7238	105	0	\N
284184	1678	15120585055000	14362	7238	106	0	\N
284185	1678	15120585056000	14362	7238	107	0	\N
284186	1678	15120585057000	14362	7238	108	0	\N
284187	1678	15120585058000	14362	7238	109	0	\N
284188	1678	15120585059000	14362	7238	110	0	\N
284189	1678	15120585060000	14362	7238	111	0	\N
284190	1678	15120585061000	14362	7238	112	0	\N
284191	1678	15120585062000	14362	7238	113	0	\N
284192	1678	15120585063000	14362	7238	114	0	\N
284193	1678	15120585064000	14362	7238	115	0	\N
284194	1678	15120585065000	14362	7238	116	0	\N
284195	1678	15120585066000	14362	7238	117	0	\N
284196	1678	15120585067000	14362	7238	118	0	\N
284197	1678	15120585068000	14362	7238	119	0	\N
284198	1678	15120585069000	14362	7238	120	0	\N
284199	1678	15120585070000	14362	7238	121	0	\N
284200	1678	15120585071000	14362	7238	122	0	\N
284201	1678	15120585072000	14362	7238	123	0	\N
284202	1678	15120585073000	14362	7238	124	0	\N
284203	1678	15120585074000	14362	7238	125	0	\N
284204	1678	15840600074000	14363	7330	0	0	\N
284205	1874	3831000	14363	7330	1	0	\N
284206	1874	3834000	14363	7330	2	0	\N
284207	1874	3835000	14363	7330	3	0	\N
284208	141	66000100000000	14364	7193	0	0	\N
284209	1678	15120585017000	14364	7193	1	0	\N
284210	1678	15120585018000	14364	7193	2	0	\N
284211	1678	15120585019000	14364	7193	3	0	\N
284212	1678	15120585020000	14364	7193	4	0	\N
284213	1678	15120585021000	14364	7193	5	0	\N
284214	1678	15120585022000	14364	7193	6	0	\N
284215	1678	15120585023000	14364	7193	7	0	\N
284216	1678	15120585024000	14364	7193	8	0	\N
284217	1678	15120585025000	14364	7193	9	0	\N
284218	1678	15120585026000	14364	7193	10	0	\N
284219	1678	15120585027000	14364	7193	11	0	\N
284220	1678	15120585028000	14364	7193	12	0	\N
284221	1678	15120585029000	14364	7193	13	0	\N
284222	1678	15120585030000	14364	7193	14	0	\N
284223	1678	15120585031000	14364	7193	15	0	\N
284224	1678	15120585032000	14364	7193	16	0	\N
284225	1678	15120585033000	14364	7193	17	0	\N
284226	1678	15120585034000	14364	7193	18	0	\N
284227	1678	15120585035000	14364	7193	19	0	\N
284228	1678	15120585036000	14364	7193	20	0	\N
284229	1678	15120585037000	14364	7193	21	0	\N
284230	1678	15120585038000	14364	7193	22	0	\N
284231	1678	15120585039000	14364	7193	23	0	\N
284232	1678	15120585040000	14364	7193	24	0	\N
284233	1678	15120585041000	14364	7193	25	0	\N
284234	1678	15120585042000	14364	7193	26	0	\N
284235	1678	15120585043000	14364	7193	27	0	\N
284236	1678	15120585044000	14364	7193	28	0	\N
284237	1678	15120585045000	14364	7193	29	0	\N
284238	1678	15120585046000	14364	7193	30	0	\N
284239	1678	15120585047000	14364	7193	31	0	\N
284240	1678	15120585048000	14364	7193	32	0	\N
284241	1678	15120585049000	14364	7193	33	0	\N
284242	1678	15120585050000	14364	7193	34	0	\N
284243	1678	15120585051000	14364	7193	35	0	\N
284244	1678	15120585052000	14364	7193	36	0	\N
284245	1678	15120585053000	14364	7193	37	0	\N
284246	1678	15120585054000	14364	7193	38	0	\N
284247	1678	15120585055000	14364	7193	39	0	\N
284248	1678	15120585056000	14364	7193	40	0	\N
284249	1678	15120585057000	14364	7193	41	0	\N
284250	1678	15120585058000	14364	7193	42	0	\N
284251	1678	15120585059000	14364	7193	43	0	\N
284252	1678	15120585060000	14364	7193	44	0	\N
284253	1678	15120585061000	14364	7193	45	0	\N
284254	1678	15120585062000	14364	7193	46	0	\N
284255	1678	15120585063000	14364	7193	47	0	\N
284256	1678	15120585064000	14364	7193	48	0	\N
284257	1678	15120585065000	14364	7193	49	0	\N
284258	1678	15120585066000	14364	7193	50	0	\N
284259	1678	15120585067000	14364	7193	51	0	\N
284260	1678	15120585068000	14364	7193	52	0	\N
284261	1678	15120585069000	14364	7193	53	0	\N
284262	1678	15120585070000	14364	7193	54	0	\N
284263	1678	15120585071000	14364	7193	55	0	\N
284264	1678	15120585072000	14364	7193	56	0	\N
284265	1678	15120585073000	14364	7193	57	0	\N
284266	1678	15120585074000	14364	7193	58	0	\N
284267	1678	15120585075000	14364	7193	59	0	\N
284268	1874	2819000	14364	7193	60	0	\N
284269	1745	1803000000	14364	7193	61	0	\N
284270	1652	490000000	14364	7193	62	0	\N
284271	1745	1803000000	14364	7193	63	0	\N
284272	2107	0	14364	7193	64	0	\N
284273	1874	2820000	14364	7193	65	0	\N
284274	1874	2822000	14364	7193	66	0	\N
284275	1874	2825000	14364	7193	67	0	\N
284276	1874	2826000	14364	7193	68	0	\N
284277	1874	2828000	14364	7193	69	0	\N
284278	1874	2831000	14364	7193	70	0	\N
284279	1874	2832000	14364	7193	71	0	\N
284280	1874	2834000	14364	7193	72	0	\N
284281	1874	2837000	14364	7193	73	0	\N
284282	1874	2838000	14364	7193	75	0	\N
284283	1874	2840000	14364	7193	76	0	\N
284284	1874	2843000	14364	7193	77	0	\N
284285	1874	2844000	14364	7193	78	0	\N
284286	1874	2846000	14364	7193	79	0	\N
284287	1874	2849000	14364	7193	80	0	\N
284288	1874	2850000	14364	7193	81	0	\N
284289	1874	2852000	14364	7193	82	0	\N
284290	1874	2855000	14364	7193	83	0	\N
284291	1874	2856000	14364	7193	84	0	\N
284292	1874	2858000	14364	7193	85	0	\N
284293	1874	2861000	14364	7193	86	0	\N
284294	1874	2862000	14364	7193	87	0	\N
284295	1874	2864000	14364	7193	88	0	\N
284296	1874	2867000	14364	7193	89	0	\N
284297	1874	2868000	14364	7193	90	0	\N
284298	1874	2870000	14364	7193	91	0	\N
284299	1874	2873000	14364	7193	92	0	\N
284300	1874	2874000	14364	7193	93	0	\N
284301	1874	2876000	14364	7193	94	0	\N
284302	1874	2879000	14364	7193	95	0	\N
284303	1874	2880000	14364	7193	96	0	\N
284304	1874	2882000	14364	7193	97	0	\N
284305	1874	2885000	14364	7193	98	0	\N
284306	1874	2886000	14364	7193	99	0	\N
284307	1874	2888000	14364	7193	100	0	\N
284308	1874	2891000	14364	7193	101	0	\N
284309	1874	2892000	14364	7193	102	0	\N
284310	1874	2894000	14364	7193	103	0	\N
284311	1874	2897000	14364	7193	104	0	\N
284312	1874	2898000	14364	7193	105	0	\N
284313	1874	2900000	14364	7193	106	0	\N
284314	1874	2903000	14364	7193	107	0	\N
284315	1874	2904000	14364	7193	108	0	\N
284316	1874	2906000	14364	7193	109	0	\N
284317	1874	2909000	14364	7193	110	0	\N
284318	2103	200000000	14364	7193	111	0	\N
284319	2104	200000000	14364	7193	112	0	\N
284320	1874	2910000	14364	7193	113	0	\N
284321	1874	2912000	14364	7193	114	0	\N
284322	2103	1400000000	14364	7193	115	0	\N
284323	1874	2915000	14364	7193	116	0	\N
284324	1874	2916000	14364	7193	117	0	\N
284325	1874	2918000	14364	7193	118	0	\N
284326	1874	2921000	14364	7193	119	0	\N
284327	1874	2922000	14364	7193	120	0	\N
284328	1874	2924000	14364	7193	121	0	\N
284329	1874	2927000	14364	7193	122	0	\N
284330	1874	2928000	14364	7193	123	0	\N
284331	1874	2930000	14364	7193	124	0	\N
284332	1874	2933000	14364	7193	125	0	\N
284340	1678	15840600076000	14367	7332	0	0	\N
284341	1874	3842000	14367	7332	1	0	\N
284342	1874	3845000	14367	7332	2	0	\N
284343	1678	15840600076000	14368	7332	0	0	\N
284344	1874	3842000	14368	7332	1	0	\N
284345	1874	3845000	14368	7332	2	0	\N
284346	1678	15840600076000	14369	7332	0	0	\N
284347	1874	3842000	14369	7332	1	0	\N
284348	1874	3845000	14369	7332	2	0	\N
284349	1678	15840600077000	14370	7333	0	0	\N
284350	1874	3847000	14370	7333	1	0	\N
284351	1874	3850000	14370	7333	2	0	\N
284355	1678	15840600078000	14374	7334	0	0	\N
284356	1874	3852000	14374	7334	1	0	\N
284357	1874	3855000	14374	7334	2	0	\N
284358	1678	15120584934000	14376	7222	0	0	\N
284359	141	66000100000000	14376	7222	1	0	\N
284360	1010	506397153064601	14376	7222	2	0	\N
284361	1130	907459359480949	14376	7222	3	0	\N
284362	1250	612280912246859	14376	7222	4	0	\N
284363	1376	1706175202959202	14376	7222	5	0	\N
284364	1678	15120584935000	14376	7222	6	0	\N
284365	1678	15120584936000	14376	7222	7	0	\N
284366	1678	15120584937000	14376	7222	8	0	\N
284367	1678	15120584938000	14376	7222	9	0	\N
284368	1678	15120584939000	14376	7222	10	0	\N
284369	1678	15120584940000	14376	7222	11	0	\N
284370	1678	15120584941000	14376	7222	12	0	\N
284371	1678	15120584942000	14376	7222	13	0	\N
284372	1678	15120584943000	14376	7222	14	0	\N
284373	1678	15120584944000	14376	7222	15	0	\N
284374	1678	15120584945000	14376	7222	16	0	\N
284375	1678	15120584946000	14376	7222	17	0	\N
284376	1678	15120584947000	14376	7222	18	0	\N
284335	1874	3840000	14365	7331	2	0	1
284336	2109	200000000	14365	7331	3	0	0
284337	1678	15840600076000	14366	7332	0	0	0
284338	1874	3842000	14366	7332	1	0	1
284339	1874	3845000	14366	7332	2	0	1
284353	1874	3847000	14371	7333	1	0	1
284354	1874	3850000	14371	7333	2	0	1
284377	1678	15120584948000	14376	7222	19	0	\N
284378	1678	15120584949000	14376	7222	20	0	\N
284379	1678	15120584950000	14376	7222	21	0	\N
284380	1678	15120584951000	14376	7222	22	0	\N
284381	1678	15120584952000	14376	7222	23	0	\N
284382	1678	15120584953000	14376	7222	24	0	\N
284383	1678	15120584954000	14376	7222	25	0	\N
284384	1678	15120584955000	14376	7222	26	0	\N
284385	1678	15120584956000	14376	7222	27	0	\N
284386	1678	15120584957000	14376	7222	28	0	\N
284387	1678	15120584958000	14376	7222	29	0	\N
284388	1678	15120584959000	14376	7222	30	0	\N
284389	1678	15120584960000	14376	7222	31	0	\N
284390	1678	15120584961000	14376	7222	32	0	\N
284391	1678	15120584962000	14376	7222	33	0	\N
284392	1678	15120584963000	14376	7222	34	0	\N
284393	1678	15120584964000	14376	7222	35	0	\N
284394	1678	15120584965000	14376	7222	36	0	\N
284395	1678	15120584966000	14376	7222	37	0	\N
284396	1678	15120584967000	14376	7222	38	0	\N
284397	1678	15120584968000	14376	7222	39	0	\N
284398	1678	15120584969000	14376	7222	40	0	\N
284399	1678	15120584970000	14376	7222	41	0	\N
284400	1678	15120584971000	14376	7222	42	0	\N
284401	1678	15120584972000	14376	7222	43	0	\N
284402	1678	15120584973000	14376	7222	44	0	\N
284403	1678	15120584974000	14376	7222	45	0	\N
284404	1678	15120584975000	14376	7222	46	0	\N
284405	1678	15120584976000	14376	7222	47	0	\N
284406	1678	15120584977000	14376	7222	48	0	\N
284407	1678	15120584978000	14376	7222	49	0	\N
284408	1678	15120584979000	14376	7222	50	0	\N
284409	1678	15120584980000	14376	7222	51	0	\N
284410	1678	15120584981000	14376	7222	52	0	\N
284411	1678	15120584982000	14376	7222	53	0	\N
284412	1678	15120584983000	14376	7222	54	0	\N
284413	1678	15120584984000	14376	7222	55	0	\N
284414	1678	15120584985000	14376	7222	56	0	\N
284415	1678	15120584986000	14376	7222	57	0	\N
284416	1678	15120584987000	14376	7222	58	0	\N
284417	1678	15120584988000	14376	7222	59	0	\N
284418	1678	15120584989000	14376	7222	60	0	\N
284419	1678	15120584990000	14376	7222	61	0	\N
284420	1678	15120584991000	14376	7222	62	0	\N
284421	1678	15120584992000	14376	7222	63	0	\N
284422	1678	15120584993000	14376	7222	64	0	\N
284423	1678	15120584994000	14376	7222	65	0	\N
284424	1678	15120584995000	14376	7222	66	0	\N
284425	1678	15120584996000	14376	7222	67	0	\N
284426	1678	15120584997000	14376	7222	68	0	\N
284427	1678	15120584998000	14376	7222	69	0	\N
284428	1678	15120584999000	14376	7222	70	0	\N
284429	1678	15120585000000	14376	7222	71	0	\N
284430	1678	15120585001000	14376	7222	72	0	\N
284431	1678	15120585002000	14376	7222	73	0	\N
284432	1678	15120585003000	14376	7222	74	0	\N
284433	1678	15120585004000	14376	7222	75	0	\N
284434	1678	15120585005000	14376	7222	76	0	\N
284435	1678	15120585006000	14376	7222	77	0	\N
284436	1678	15120585007000	14376	7222	78	0	\N
284437	1678	15120585008000	14376	7222	79	0	\N
284438	1678	15120585009000	14376	7222	80	0	\N
284439	1678	15120585010000	14376	7222	81	0	\N
284440	1678	15120585011000	14376	7222	82	0	\N
284441	1678	15120585012000	14376	7222	83	0	\N
284442	1678	15120585013000	14376	7222	84	0	\N
284443	1678	15120585014000	14376	7222	85	0	\N
284444	1678	15120585015000	14376	7222	86	0	\N
284445	1678	15120585016000	14376	7222	87	0	\N
284446	1678	15120585017000	14376	7222	88	0	\N
284447	1678	15120585018000	14376	7222	89	0	\N
284448	1678	15120585019000	14376	7222	90	0	\N
284449	1678	15120585020000	14376	7222	91	0	\N
284450	1678	15120585021000	14376	7222	92	0	\N
284451	1678	15120585022000	14376	7222	93	0	\N
284452	1678	15120585023000	14376	7222	94	0	\N
284453	1678	15120585024000	14376	7222	95	0	\N
284454	1678	15120585025000	14376	7222	96	0	\N
284455	1678	15120585026000	14376	7222	97	0	\N
284456	1678	15120585027000	14376	7222	98	0	\N
284457	1678	15120585028000	14376	7222	99	0	\N
284458	1678	15120585029000	14376	7222	100	0	\N
284459	1678	15120585030000	14376	7222	101	0	\N
284460	1678	15120585031000	14376	7222	102	0	\N
284461	1678	15120585032000	14376	7222	103	0	\N
284462	1678	15120585033000	14376	7222	104	0	\N
284463	1678	15120585034000	14376	7222	105	0	\N
284464	1678	15120585035000	14376	7222	106	0	\N
284465	1678	15120585036000	14376	7222	107	0	\N
284466	1678	15120585037000	14376	7222	108	0	\N
284467	1678	15120585038000	14376	7222	109	0	\N
284468	1678	15120585039000	14376	7222	110	0	\N
284469	1678	15120585040000	14376	7222	111	0	\N
284470	1678	15120585041000	14376	7222	112	0	\N
284471	1678	15120585042000	14376	7222	113	0	\N
284472	1678	15120585043000	14376	7222	114	0	\N
284473	1678	15120585044000	14376	7222	115	0	\N
284474	1678	15120585045000	14376	7222	117	0	\N
284475	1678	15120585046000	14376	7222	118	0	\N
284476	1678	15120585047000	14376	7222	119	0	\N
284477	1678	15120585048000	14376	7222	120	0	\N
284478	1678	15120585049000	14376	7222	121	0	\N
284479	1678	15120585050000	14376	7222	122	0	\N
284480	1678	15120585051000	14376	7222	123	0	\N
284481	1678	15120585052000	14376	7222	124	0	\N
284482	1678	15120585053000	14376	7222	125	0	\N
284483	2047	41200000	14377	7164	0	0	\N
284484	2047	41290000	14377	7164	1	0	\N
284485	1678	15120584860000	14377	7164	3	0	\N
284486	141	66000100000000	14377	7164	4	0	\N
284487	1678	15120584861000	14377	7164	5	0	\N
284488	1678	15120584862000	14377	7164	6	0	\N
284489	1678	15120584863000	14377	7164	7	0	\N
284490	1678	15120584864000	14377	7164	8	0	\N
284491	1010	506397153064601	14377	7164	9	0	\N
284492	1130	907459359480949	14377	7164	10	0	\N
284493	1250	612280912246859	14377	7164	11	0	\N
284494	1376	1706175202959202	14377	7164	12	0	\N
284495	1678	15120584865000	14377	7164	13	0	\N
284496	1678	15120584866000	14377	7164	14	0	\N
284497	1678	15120584867000	14377	7164	15	0	\N
284498	1678	15120584868000	14377	7164	16	0	\N
284499	1678	15120584869000	14377	7164	17	0	\N
284500	1678	15120584870000	14377	7164	18	0	\N
284501	1678	15120584871000	14377	7164	19	0	\N
284502	1678	15120584872000	14377	7164	20	0	\N
284503	1678	15120584873000	14377	7164	21	0	\N
284504	1678	15120584874000	14377	7164	22	0	\N
284505	1678	15120584875000	14377	7164	23	0	\N
284506	1678	15120584876000	14377	7164	24	0	\N
284507	1678	15120584877000	14377	7164	25	0	\N
284508	1678	15120584878000	14377	7164	26	0	\N
284509	1678	15120584879000	14377	7164	27	0	\N
284510	1678	15120584880000	14377	7164	28	0	\N
284511	1678	15120584881000	14377	7164	29	0	\N
284512	1678	15120584882000	14377	7164	30	0	\N
284513	1678	15120584883000	14377	7164	31	0	\N
284514	1678	15120584884000	14377	7164	32	0	\N
284515	1678	15120584885000	14377	7164	33	0	\N
284516	1678	15120584886000	14377	7164	34	0	\N
284517	1678	15120584887000	14377	7164	35	0	\N
284518	1678	15120584888000	14377	7164	36	0	\N
284519	1678	15120584889000	14377	7164	37	0	\N
284520	1678	15120584890000	14377	7164	39	0	\N
284521	1678	15120584891000	14377	7164	40	0	\N
284522	1678	15120584892000	14377	7164	41	0	\N
284523	1678	15120584893000	14377	7164	42	0	\N
284524	1678	15120584894000	14377	7164	43	0	\N
284525	1678	15120584895000	14377	7164	44	0	\N
284526	1678	15120584896000	14377	7164	45	0	\N
284527	1678	15120584897000	14377	7164	46	0	\N
284528	1678	15120584898000	14377	7164	47	0	\N
284529	1678	15120584899000	14377	7164	48	0	\N
284530	1678	15120584900000	14377	7164	49	0	\N
284531	1678	15120584901000	14377	7164	50	0	\N
284532	1678	15120584902000	14377	7164	51	0	\N
284533	1678	15120584903000	14377	7164	52	0	\N
284534	1678	15120584904000	14377	7164	53	0	\N
284535	1678	15120584905000	14377	7164	54	0	\N
284536	1678	15120584906000	14377	7164	55	0	\N
284537	1678	15120584907000	14377	7164	56	0	\N
284538	1678	15120584908000	14377	7164	57	0	\N
284539	1678	15120584909000	14377	7164	58	0	\N
284540	1678	15120584910000	14377	7164	59	0	\N
284541	1678	15120584911000	14377	7164	60	0	\N
284542	1678	15120584912000	14377	7164	61	0	\N
284543	1678	15120584913000	14377	7164	62	0	\N
284544	1678	15120584914000	14377	7164	63	0	\N
284545	1678	15120584915000	14377	7164	64	0	\N
284546	1678	15120584916000	14377	7164	65	0	\N
284547	1678	15120584917000	14377	7164	66	0	\N
284552	1678	15840600082000	14379	7337	0	0	\N
284553	1874	3852000	14379	7337	1	0	\N
284554	1874	3855000	14379	7337	2	0	\N
284555	1874	3857000	14379	7337	3	0	\N
284556	1874	3860000	14379	7337	4	0	\N
284557	1874	3862000	14379	7337	5	0	\N
284558	1874	3865000	14379	7337	6	0	\N
284559	1874	3867000	14379	7337	7	0	\N
284560	1874	3870000	14379	7337	8	0	\N
284561	1874	3872000	14379	7337	9	0	\N
284562	1874	3875000	14379	7337	10	0	\N
284563	1678	15840600082000	14380	7337	0	0	\N
284584	1678	15840600086000	14384	7340	0	0	\N
284585	1678	15840600087000	14384	7340	1	0	\N
284586	1874	3892000	14384	7340	2	0	\N
284587	1874	3895000	14384	7340	3	0	\N
284588	1874	3897000	14384	7340	4	0	\N
284589	1874	3900000	14384	7340	5	0	\N
284599	141	66000100000000	14388	7133	0	0	\N
284600	1010	506397153064601	14388	7133	1	0	\N
284601	1130	907459359480949	14388	7133	2	0	\N
284602	1250	612280912246859	14388	7133	3	0	\N
284603	1376	1706175202959202	14388	7133	4	0	\N
284604	2107	0	14388	7133	5	0	\N
284622	1678	15840600094000	14391	7343	0	0	\N
284623	1874	3930000	14391	7343	1	0	\N
284624	1874	3932000	14391	7343	2	0	\N
284625	1678	15840600094000	14392	7343	0	0	\N
284635	1678	15840600098000	14397	7347	0	0	\N
284636	1874	3950000	14397	7347	1	0	\N
284637	1678	15840600098000	14398	7347	0	0	\N
284638	1874	3950000	14398	7347	1	0	\N
284639	1874	3952000	14398	7347	2	0	\N
284643	1678	15840600098000	14400	7347	0	0	\N
284644	1874	3950000	14400	7347	1	0	\N
284645	1874	3952000	14400	7347	2	0	\N
284550	1678	15840600080000	14378	7336	2	0	0
284551	1678	15840600081000	14378	7336	3	0	0
284564	1678	15840600082000	14381	7337	0	0	0
284565	1874	3852000	14381	7337	1	0	1
284566	1874	3855000	14381	7337	2	0	1
284568	1874	3860000	14381	7337	4	0	1
284569	1874	3862000	14381	7337	5	0	1
284570	1874	3865000	14381	7337	6	0	1
284571	1874	3867000	14381	7337	7	0	1
284572	1874	3870000	14381	7337	8	0	1
284574	1874	3875000	14381	7337	10	0	1
284575	1678	15840600083000	14382	7338	0	0	0
284576	1678	15840600084000	14382	7338	1	0	0
284577	1874	3877000	14382	7338	2	0	1
284579	1874	3882000	14382	7338	4	0	1
284580	1874	3885000	14382	7338	5	0	1
284581	1678	15840600085000	14383	7339	0	0	0
284582	1874	3887000	14383	7339	1	0	1
284583	1874	3890000	14383	7339	2	0	1
284591	1678	15840600087000	14385	7340	1	0	0
284592	1874	3892000	14385	7340	2	0	1
284593	1874	3895000	14385	7340	3	0	1
284594	1874	3897000	14385	7340	4	0	1
284595	1874	3900000	14385	7340	5	0	1
284597	1874	3902000	14386	7341	1	0	1
284598	1874	3905000	14386	7341	2	0	1
284605	1678	15840600089000	14389	7342	0	0	0
284606	1678	15840600090000	14389	7342	1	0	0
284608	1678	15840600092000	14389	7342	3	0	0
284609	1678	15840600093000	14389	7342	4	0	0
284610	1874	3907000	14389	7342	5	0	1
284611	1874	3910000	14389	7342	6	0	1
284612	1874	3912000	14389	7342	7	0	1
284614	1874	3917000	14389	7342	9	0	1
284615	1874	3920000	14389	7342	10	0	1
284616	1874	3922000	14389	7342	11	0	1
284617	1874	3925000	14389	7342	12	0	1
284618	1874	3927000	14389	7342	13	0	1
284620	1874	3930000	14390	7343	1	0	1
284621	1874	3932000	14390	7343	2	0	1
284626	1678	15840600095000	14393	7344	0	0	0
284627	1874	3935000	14393	7344	1	0	1
284629	1678	15840600096000	14394	7345	0	0	0
284630	1874	3940000	14394	7345	1	0	1
284631	1874	3942000	14394	7345	2	0	1
284632	1678	15840600097000	14395	7346	0	0	0
284633	1874	3945000	14395	7346	1	0	1
284640	1678	15840600098000	14399	7347	0	0	0
284641	1874	3950000	14399	7347	1	0	1
284642	1874	3952000	14399	7347	2	0	1
284646	1678	15840600099000	14401	7348	0	0	0
284647	1874	3955000	14401	7348	1	0	1
284649	1678	15840600100000	14402	7349	0	0	\N
284650	44	66000000000000	14402	7349	1	0	\N
284651	1874	3960000	14402	7349	2	0	\N
284652	1874	3962000	14402	7349	3	0	\N
284657	141	66000100000000	14404	7230	0	0	\N
284658	1010	506397153064601	14404	7230	1	0	\N
284659	1130	907459359480949	14404	7230	2	0	\N
284660	1250	612280912246859	14404	7230	3	0	\N
284661	1376	1706175202959202	14404	7230	4	0	\N
284662	2107	0	14404	7230	5	0	\N
284663	1874	3965000	14405	7350	0	0	\N
284664	1874	3967000	14405	7350	1	0	\N
284665	1874	3965000	14406	7350	0	0	\N
284666	1874	3967000	14406	7350	1	0	\N
284669	1874	3965000	14408	7350	0	0	\N
284670	1874	3967000	14408	7350	1	0	\N
284671	1874	3965000	14409	7350	0	0	\N
284672	1874	3967000	14409	7350	1	0	\N
284673	44	66000000000000	14410	7134	0	0	\N
284691	1678	15840600107000	14414	7353	0	0	\N
284692	1678	15840600108000	14414	7353	1	0	\N
284693	1874	3976000	14414	7353	3	0	\N
284694	1874	3979000	14414	7353	4	0	\N
284695	1874	3981000	14414	7353	5	0	\N
284696	1874	3984000	14414	7353	6	0	\N
284697	1874	3986000	14414	7353	7	0	\N
284698	1874	3989000	14414	7353	8	0	\N
284699	1874	3991000	14414	7353	9	0	\N
284700	1874	3994000	14414	7353	10	0	\N
284701	1874	3996000	14414	7353	11	0	\N
284702	1874	3999000	14414	7353	12	0	\N
284716	1678	15840600110000	14417	7355	0	0	\N
284717	1874	4004000	14417	7355	1	0	\N
284718	1874	4007000	14417	7355	2	0	\N
284719	1678	15840600110000	14418	7355	0	0	\N
284721	1678	15840600111000	14420	7356	0	0	\N
284722	1678	15840600112000	14421	7357	0	0	\N
284723	1874	4009000	14421	7357	1	0	\N
284724	1874	4012000	14421	7357	2	0	\N
284725	1874	4014000	14421	7357	3	0	\N
284726	1874	4017000	14421	7357	4	0	\N
284737	44	66000000000000	14425	7231	0	0	\N
284742	1678	15840600115000	14427	7360	0	0	\N
284743	1874	4027000	14427	7360	1	0	\N
284744	1874	4029000	14427	7360	2	0	\N
284745	1874	4030000	14427	7360	3	0	\N
284754	1678	15120584918000	14430	7166	0	0	\N
284755	1678	15120584919000	14430	7166	1	0	\N
284756	1678	15120584920000	14430	7166	2	0	\N
284757	1678	15120584921000	14430	7166	3	0	\N
284758	1678	15120584922000	14430	7166	4	0	\N
284759	1678	15120584923000	14430	7166	5	0	\N
284760	1678	15120584924000	14430	7166	6	0	\N
284761	1678	15120584925000	14430	7166	7	0	\N
284762	1678	15120584926000	14430	7166	8	0	\N
284763	1678	15120584927000	14430	7166	9	0	\N
284764	1678	15120584928000	14430	7166	10	0	\N
284765	1678	15120584929000	14430	7166	11	0	\N
284766	1678	15120584930000	14430	7166	12	0	\N
284767	1678	15120584931000	14430	7166	13	0	\N
284768	1678	15120584932000	14430	7166	14	0	\N
284769	1678	15120584933000	14430	7166	15	0	\N
284770	1678	15120584934000	14430	7166	16	0	\N
284771	1678	15120584935000	14430	7166	17	0	\N
284772	1678	15120584936000	14430	7166	18	0	\N
284773	1678	15120584937000	14430	7166	19	0	\N
284774	1678	15120584938000	14430	7166	20	0	\N
284775	1678	15120584939000	14430	7166	21	0	\N
284776	1678	15120584940000	14430	7166	22	0	\N
284777	1678	15120584941000	14430	7166	23	0	\N
284778	1678	15120584942000	14430	7166	24	0	\N
284779	1678	15120584943000	14430	7166	25	0	\N
284780	1678	15120584944000	14430	7166	26	0	\N
284781	1678	15120584945000	14430	7166	27	0	\N
284782	1678	15120584946000	14430	7166	28	0	\N
284783	1678	15120584947000	14430	7166	29	0	\N
284784	1678	15120584948000	14430	7166	30	0	\N
284655	1874	3960000	14403	7349	2	0	1
284656	1874	3962000	14403	7349	3	0	1
284667	1874	3965000	14407	7350	0	0	1
284668	1874	3967000	14407	7350	1	0	1
284674	1678	15840600101000	14411	7351	0	0	0
284676	1678	15840600103000	14412	7352	1	0	0
284677	1678	15840600104000	14412	7352	2	0	0
284678	1678	15840600105000	14412	7352	3	0	0
284679	1678	15840600106000	14412	7352	4	0	0
284680	1874	3968000	14412	7352	5	0	1
284682	1874	3970000	14412	7352	7	0	1
284683	1874	3971000	14412	7352	8	0	1
284684	1874	3973000	14412	7352	9	0	1
284685	1874	3974000	14412	7352	10	0	1
284687	1678	15840600108000	14413	7353	1	0	0
284688	1874	3975000	14413	7353	3	0	1
284689	1874	3978000	14413	7353	4	0	1
284690	1874	3979000	14413	7353	5	0	1
284703	1678	15840600109000	14415	7354	0	0	0
284705	1874	3984000	14415	7354	2	0	1
284706	1874	3987000	14415	7354	3	0	1
284707	1874	3989000	14415	7354	4	0	1
284708	1874	3992000	14415	7354	5	0	1
284709	1874	3994000	14415	7354	6	0	1
284711	1874	3999000	14415	7354	8	0	1
284712	1874	4002000	14415	7354	9	0	1
284713	1678	15840600110000	14416	7355	0	0	0
284714	1874	4004000	14416	7355	1	0	1
284720	1678	15840600111000	14419	7356	0	0	0
284727	1678	15840600112000	14422	7357	0	0	0
284728	1874	4009000	14422	7357	1	0	1
284729	1874	4012000	14422	7357	2	0	1
284730	1874	4014000	14422	7357	3	0	1
284732	1678	15840600113000	14423	7358	0	0	0
284733	1874	4019000	14423	7358	1	0	1
284734	1678	15840600114000	14424	7359	0	0	0
284735	1874	4022000	14424	7359	1	0	1
284736	1874	4024000	14424	7359	2	0	1
284739	1874	4027000	14426	7360	1	0	1
284740	1874	4029000	14426	7360	2	0	1
284741	1874	4030000	14426	7360	3	0	1
284746	1678	15840600116000	14428	7361	0	0	0
284748	1874	4033000	14428	7361	2	0	1
284749	1874	4035000	14428	7361	3	0	1
284750	1874	4036000	14428	7361	4	0	1
284751	1874	4039000	14428	7361	5	0	1
284752	1874	4041000	14428	7361	6	0	1
284785	1678	15120584949000	14430	7166	31	0	\N
284786	1678	15120584950000	14430	7166	32	0	\N
284787	1678	15120584951000	14430	7166	33	0	\N
284788	1678	15120584952000	14430	7166	34	0	\N
284789	1678	15120584953000	14430	7166	35	0	\N
284790	1678	15120584954000	14430	7166	36	0	\N
284791	1678	15120584955000	14430	7166	37	0	\N
284792	1678	15120584956000	14430	7166	38	0	\N
284793	1678	15120584957000	14430	7166	39	0	\N
284794	1678	15120584958000	14430	7166	40	0	\N
284795	1678	15120584959000	14430	7166	41	0	\N
284796	1678	15120584960000	14430	7166	42	0	\N
284797	1678	15120584961000	14430	7166	43	0	\N
284798	1678	15120584962000	14430	7166	44	0	\N
284811	1483	10000000	14433	7364	0	0	\N
284812	1678	15840600121000	14433	7364	1	0	\N
284813	1874	4063000	14433	7364	2	0	\N
284814	1874	4065000	14433	7364	3	0	\N
284815	1874	4066000	14433	7364	4	0	\N
284828	1678	15840600124000	14436	7366	0	0	\N
284829	1874	4078000	14436	7366	1	0	\N
284830	1874	4081000	14436	7366	2	0	\N
284848	1678	15840600129000	14441	7370	0	0	\N
284849	1874	4101000	14441	7370	1	0	\N
284850	1874	4103000	14441	7370	2	0	\N
284851	1874	4106000	14441	7370	3	0	\N
284859	141	66000100000000	14444	7289	0	0	\N
284860	44	66000000000000	14444	7289	1	0	\N
284861	1874	3499000	14444	7289	3	0	\N
284862	1874	3501000	14444	7289	4	0	\N
284863	2107	0	14444	7289	5	0	\N
284864	1874	3502000	14444	7289	6	0	\N
284865	1874	3505000	14444	7289	7	0	\N
284866	1874	3507000	14444	7289	8	0	\N
284867	1874	3508000	14444	7289	9	0	\N
284871	1874	4115000	14446	7373	0	0	\N
284872	1874	4116000	14446	7373	1	0	\N
284873	1874	4118000	14446	7373	2	0	\N
284883	1874	4133000	14449	7375	0	0	\N
284884	1874	4135000	14449	7375	1	0	\N
284890	1678	15840600133000	14452	7377	0	0	\N
284891	1874	4143000	14452	7377	1	0	\N
284892	1874	4145000	14452	7377	2	0	\N
284900	1678	15840600134000	14455	7378	0	0	\N
284901	1874	4146000	14455	7378	1	0	\N
284902	1874	4149000	14455	7378	2	0	\N
284903	1874	4151000	14455	7378	3	0	\N
284801	1678	15840600120000	14432	7363	1	0	0
284802	1874	4045000	14432	7363	2	0	1
284803	1874	4047000	14432	7363	3	0	1
284804	1874	4048000	14432	7363	4	0	1
284805	1874	4051000	14432	7363	5	0	1
284807	1874	4054000	14432	7363	7	0	1
284808	1874	4057000	14432	7363	8	0	1
284809	1874	4059000	14432	7363	9	0	1
284810	1874	4060000	14432	7363	10	0	1
284816	1483	10000000	14434	7364	0	0	0
284818	1874	4063000	14434	7364	2	0	1
284819	1874	4065000	14434	7364	3	0	1
284820	1678	15840600122000	14435	7365	0	0	0
284821	1678	15840600123000	14435	7365	1	0	0
284823	1874	4069000	14435	7365	3	0	1
284824	1874	4071000	14435	7365	4	0	1
284825	1874	4072000	14435	7365	5	0	1
284826	1874	4075000	14435	7365	6	0	1
284827	1874	4077000	14435	7365	7	0	1
284832	1874	4078000	14437	7366	1	0	1
284833	1874	4081000	14437	7366	2	0	1
284834	1678	15840600125000	14438	7367	0	0	0
284835	1874	4082000	14438	7367	1	0	1
284836	1874	4084000	14438	7367	2	0	1
284838	1678	15840600126000	14439	7368	0	0	0
284839	1678	15840600127000	14439	7368	1	0	0
284840	1874	4088000	14439	7368	2	0	1
284841	1874	4089000	14439	7368	3	0	1
284843	1874	4094000	14439	7368	5	0	1
284844	1678	15840600128000	14440	7369	0	0	0
284845	1874	4095000	14440	7369	1	0	1
284846	1874	4097000	14440	7369	3	0	1
284847	1874	4100000	14440	7369	4	0	1
284853	1874	4101000	14442	7370	1	0	1
284854	1874	4103000	14442	7370	2	0	1
284855	1874	4106000	14442	7370	3	0	1
284856	1678	15840600130000	14443	7371	0	0	0
284857	1874	4107000	14443	7371	1	0	1
284868	1678	15840600131000	14445	7372	0	0	0
284869	1874	4110000	14445	7372	1	0	1
284870	1874	4112000	14445	7372	2	0	1
284874	1874	4115000	14447	7373	0	0	1
284876	1874	4118000	14447	7373	2	0	1
284877	1874	4121000	14448	7374	0	0	1
284878	1874	4122000	14448	7374	1	0	1
284879	1874	4124000	14448	7374	2	0	1
284880	1874	4127000	14448	7374	3	0	1
284882	1874	4130000	14448	7374	5	0	1
284885	1874	4133000	14450	7375	0	0	1
284886	1874	4135000	14450	7375	1	0	1
284887	1678	15840600132000	14451	7376	0	0	0
284888	1874	4138000	14451	7376	1	0	1
284893	1678	15840600133000	14453	7377	0	0	0
284894	1874	4143000	14453	7377	1	0	1
284895	1874	4145000	14453	7377	2	0	1
284896	1678	15840600134000	14454	7378	0	0	0
284898	1874	4149000	14454	7378	2	0	1
284899	1874	4151000	14454	7378	3	0	1
284904	1678	15840600135000	14456	7379	0	0	0
284905	1678	15840600136000	14456	7379	1	0	0
284906	1874	4152000	14456	7379	2	0	1
284908	1874	4157000	14456	7379	4	0	1
284909	1874	4158000	14456	7379	5	0	1
284910	1874	4161000	14456	7379	6	0	1
284911	1874	4163000	14456	7379	7	0	1
284912	1678	15840600137000	14457	7380	0	0	0
284914	1874	4167000	14457	7380	2	0	1
284915	1874	4169000	14457	7380	3	0	1
284916	1678	15840600138000	14458	7381	0	0	0
284917	1678	15840600139000	14458	7381	1	0	0
284919	1874	4173000	14458	7381	3	0	1
284920	1874	4175000	14458	7381	4	0	1
284923	1678	15840600140000	14459	7382	0	0	\N
284924	1874	4181000	14459	7382	1	0	\N
284925	1874	4182000	14459	7382	2	0	\N
284926	1874	4185000	14459	7382	3	0	\N
284931	1678	15840600141000	14461	7383	0	0	\N
284932	1874	4187000	14461	7383	1	0	\N
284933	1874	4188000	14461	7383	2	0	\N
284934	1874	4191000	14461	7383	3	0	\N
284935	1678	15840600141000	14462	7383	0	0	\N
284936	1874	4187000	14462	7383	1	0	\N
284937	1874	4188000	14462	7383	2	0	\N
284938	1874	4191000	14462	7383	3	0	\N
284943	1678	15840600141000	14464	7383	0	0	\N
284944	1874	4187000	14464	7383	1	0	\N
284945	1874	4188000	14464	7383	2	0	\N
284946	1874	4191000	14464	7383	3	0	\N
284947	1678	15840600141000	14465	7383	0	0	\N
284956	1678	15840600144000	14467	7385	0	0	\N
284957	1874	4205000	14467	7385	1	0	\N
284958	1874	4206000	14467	7385	2	0	\N
284959	1874	4209000	14467	7385	3	0	\N
284960	1678	15840600144000	14468	7385	0	0	\N
284961	1874	4205000	14468	7385	1	0	\N
284962	1874	4206000	14468	7385	2	0	\N
284963	1874	4209000	14468	7385	3	0	\N
284968	1678	15840600141000	14470	7383	0	0	\N
284969	1678	15840600142000	14470	7383	1	0	\N
284970	1678	15840600143000	14470	7383	2	0	\N
284971	1678	15840600144000	14470	7383	3	0	\N
284972	1874	4187000	14470	7383	4	0	\N
284973	1874	4188000	14470	7383	5	0	\N
284974	1874	4191000	14470	7383	6	0	\N
284975	1874	4193000	14470	7383	7	0	\N
284976	1874	4194000	14470	7383	8	0	\N
284977	1874	4197000	14470	7383	9	0	\N
284978	1874	4199000	14470	7383	10	0	\N
284979	1874	4200000	14470	7383	11	0	\N
284980	1874	4203000	14470	7383	12	0	\N
284981	1874	4205000	14470	7383	13	0	\N
284982	1874	4206000	14470	7383	14	0	\N
284983	1874	4209000	14470	7383	15	0	\N
284987	1678	15840600146000	14472	7387	0	0	\N
285007	1483	10000000	14475	7351	0	0	\N
285008	1678	15840600147000	14477	7388	0	0	\N
285009	1678	15840600148000	14477	7388	1	0	\N
285010	1678	15840600149000	14477	7388	2	0	\N
285011	1678	15840600150000	14477	7388	3	0	\N
285012	1874	4221000	14477	7388	4	0	\N
285021	1678	15840600151000	14479	7389	0	0	\N
285022	1678	15840600152000	14479	7389	1	0	\N
285023	1874	4242000	14479	7389	2	0	\N
285024	1874	4244000	14479	7389	3	0	\N
285025	1874	4247000	14479	7389	4	0	\N
285026	1874	4248000	14479	7389	5	0	\N
285027	1874	4250000	14479	7389	6	0	\N
285028	1874	4253000	14479	7389	7	0	\N
285041	1678	15840600156000	14481	7391	0	0	\N
285042	1874	4273000	14481	7391	1	0	\N
285043	1874	4274000	14481	7391	2	0	\N
285044	1874	4277000	14481	7391	3	0	\N
285045	1678	15840600156000	14483	7391	0	0	\N
285051	1678	15840600157000	14486	7392	0	0	\N
285052	1874	4279000	14486	7392	1	0	\N
285053	1874	4280000	14486	7392	2	0	\N
285054	1874	4283000	14486	7392	3	0	\N
285055	1678	15840600157000	14487	7392	0	0	\N
285056	1874	4279000	14487	7392	1	0	\N
284927	1678	15840600140000	14460	7382	0	0	0
284928	1874	4181000	14460	7382	1	0	1
284929	1874	4182000	14460	7382	2	0	1
284930	1874	4185000	14460	7382	3	0	1
284939	1678	15840600141000	14463	7383	0	0	0
284941	1874	4188000	14463	7383	2	0	1
284942	1874	4191000	14463	7383	3	0	1
284948	1678	15840600142000	14466	7384	0	0	0
284949	1678	15840600143000	14466	7384	1	0	0
284950	1874	4193000	14466	7384	2	0	1
284952	1874	4197000	14466	7384	4	0	1
284953	1874	4199000	14466	7384	5	0	1
284954	1874	4200000	14466	7384	6	0	1
284955	1874	4203000	14466	7384	7	0	1
284965	1874	4205000	14469	7385	1	0	1
284966	1874	4206000	14469	7385	2	0	1
284967	1874	4209000	14469	7385	3	0	1
284984	1678	15840600145000	14471	7386	0	0	0
284985	1874	4211000	14471	7386	1	0	1
284988	1678	15840600146000	14473	7387	0	0	0
284989	1874	4215000	14473	7387	1	0	1
284990	1874	4217000	14473	7387	2	0	1
284991	1874	4218000	14473	7387	3	0	1
284992	1678	15840600147000	14474	7388	0	0	0
284994	1678	15840600149000	14474	7388	2	0	0
284995	1678	15840600150000	14474	7388	3	0	0
284996	1874	4221000	14474	7388	4	0	1
284997	1874	4223000	14474	7388	5	0	1
284999	1874	4227000	14474	7388	7	0	1
285000	1874	4229000	14474	7388	8	0	1
285001	1874	4230000	14474	7388	9	0	1
285002	1874	4233000	14474	7388	11	0	1
285003	1874	4235000	14474	7388	12	0	1
285005	1874	4238000	14474	7388	14	0	1
285006	1874	4241000	14474	7388	15	0	1
285013	1678	15840600151000	14478	7389	0	0	0
285014	1678	15840600152000	14478	7389	1	0	0
285015	1874	4242000	14478	7389	2	0	1
285017	1874	4247000	14478	7389	4	0	1
285018	1874	4248000	14478	7389	5	0	1
285019	1874	4250000	14478	7389	6	0	1
285020	1874	4253000	14478	7389	7	0	1
285030	1678	15840600154000	14480	7390	1	0	0
285031	1678	15840600155000	14480	7390	2	0	0
285032	1874	4255000	14480	7390	3	0	1
285033	1874	4256000	14480	7390	4	0	1
285034	1874	4259000	14480	7390	5	0	1
285036	1874	4262000	14480	7390	7	0	1
285037	1874	4265000	14480	7390	8	0	1
285038	1874	4267000	14480	7390	9	0	1
285039	1874	4268000	14480	7390	10	0	1
285040	1874	4271000	14480	7390	11	0	1
285047	1874	4273000	14484	7391	1	0	1
285048	1874	4274000	14484	7391	2	0	1
285049	1874	4277000	14484	7391	3	0	1
285050	1678	15840600157000	14485	7392	0	0	0
285057	1874	4280000	14487	7392	2	0	\N
285058	1874	4283000	14487	7392	3	0	\N
285059	141	66000100000000	14488	7252	0	0	\N
285060	1010	506397153064601	14488	7252	1	0	\N
285061	1130	907459359480949	14488	7252	2	0	\N
285062	1250	612280912246859	14488	7252	3	0	\N
285063	1376	1706175202959202	14488	7252	4	0	\N
285064	44	66000000000000	14488	7252	5	0	\N
285065	2107	0	14488	7252	7	0	\N
285073	1678	15840600163000	14490	7394	0	0	\N
285074	1874	4283000	14490	7394	1	0	\N
285075	1874	4284000	14490	7394	2	0	\N
285076	1874	4286000	14490	7394	3	0	\N
285077	1874	4289000	14490	7394	4	0	\N
285078	1874	4291000	14490	7394	5	0	\N
285079	1874	4292000	14490	7394	6	0	\N
285080	1874	4295000	14490	7394	7	0	\N
285081	1874	4297000	14490	7394	8	0	\N
285082	1874	4298000	14490	7394	9	0	\N
285083	1874	4301000	14490	7394	10	0	\N
285084	1874	4303000	14490	7394	11	0	\N
285085	1874	4304000	14490	7394	12	0	\N
285086	1874	4307000	14490	7394	13	0	\N
285087	1874	4309000	14490	7394	14	0	\N
285088	1874	4310000	14490	7394	15	0	\N
285089	1874	4313000	14490	7394	16	0	\N
285107	1483	10000000	14492	7239	0	0	\N
285108	1678	15120585075000	14492	7239	1	0	\N
285109	1678	15120585076000	14492	7239	2	0	\N
285110	1678	15120585077000	14492	7239	3	0	\N
285111	1678	15120585078000	14492	7239	4	0	\N
285112	1678	15120585079000	14492	7239	5	0	\N
285113	1678	15120585080000	14492	7239	6	0	\N
285114	1678	15120585081000	14492	7239	7	0	\N
285115	1678	15120585082000	14492	7239	8	0	\N
285116	1678	15120585083000	14492	7239	9	0	\N
285117	1678	15120585084000	14492	7239	10	0	\N
285118	1678	15120585085000	14492	7239	11	0	\N
285119	1678	15120585086000	14492	7239	13	0	\N
285120	1678	15120585087000	14492	7239	14	0	\N
285121	1678	15120585088000	14492	7239	15	0	\N
285122	1678	15120585089000	14492	7239	16	0	\N
285123	1678	15120585090000	14492	7239	17	0	\N
285124	1678	15120585091000	14492	7239	18	0	\N
285125	1678	15120585092000	14492	7239	19	0	\N
285126	1678	15120585093000	14492	7239	20	0	\N
285127	1678	15120585094000	14492	7239	21	0	\N
285128	1678	15120585095000	14492	7239	22	0	\N
285129	1678	15120585096000	14492	7239	23	0	\N
285130	1678	15120585097000	14492	7239	24	0	\N
285131	1678	15120585098000	14492	7239	25	0	\N
285132	1678	15120585099000	14492	7239	26	0	\N
285133	1678	15120585100000	14492	7239	27	0	\N
285134	1678	15120585101000	14492	7239	28	0	\N
285135	1678	15120585102000	14492	7239	29	0	\N
285136	1678	15120585103000	14492	7239	30	0	\N
285137	1678	15120585104000	14492	7239	31	0	\N
285138	1678	15120585105000	14492	7239	32	0	\N
285139	1678	15120585106000	14492	7239	33	0	\N
285140	1678	15120585107000	14492	7239	34	0	\N
285141	1678	15120585108000	14492	7239	35	0	\N
285142	1678	15120585109000	14492	7239	36	0	\N
285143	1678	15120585110000	14492	7239	37	0	\N
285144	1678	15120585111000	14492	7239	38	0	\N
285145	1678	15120585112000	14492	7239	39	0	\N
285146	1678	15120585113000	14492	7239	40	0	\N
285147	1678	15120585114000	14492	7239	41	0	\N
285148	1678	15120585115000	14492	7239	42	0	\N
285149	1678	15120585116000	14492	7239	43	0	\N
285150	1678	15120585117000	14492	7239	44	0	\N
285151	1678	15120585118000	14492	7239	45	0	\N
285152	1678	15840600164000	14493	7395	0	0	\N
285153	1874	4315000	14493	7395	1	0	\N
285154	1874	4316000	14493	7395	2	0	\N
285155	1874	4319000	14493	7395	3	0	\N
285160	1678	15840600164000	14495	7395	0	0	\N
285161	1874	4315000	14495	7395	1	0	\N
285162	1874	4316000	14495	7395	2	0	\N
285163	1874	4319000	14495	7395	3	0	\N
285164	1483	10000000	14496	7228	0	0	\N
285165	44	66000000000000	14496	7228	1	0	\N
285166	1678	15840600165000	14497	7396	0	0	\N
285167	1874	4321000	14497	7396	1	0	\N
285168	1874	4322000	14497	7396	2	0	\N
285169	1678	15840600165000	14498	7396	0	0	\N
285172	1678	15840600165000	14500	7397	0	0	\N
285173	1678	15840600166000	14500	7397	1	0	\N
285174	1678	15840600167000	14500	7397	2	0	\N
285175	1678	15840600165000	14501	7397	0	0	\N
285176	1678	15840600166000	14501	7397	1	0	\N
285177	1678	15840600167000	14501	7397	2	0	\N
285178	1874	4325000	14501	7397	3	0	\N
285179	1874	4327000	14501	7397	4	0	\N
285180	1874	4328000	14501	7397	5	0	\N
285181	1874	4331000	14501	7397	6	0	\N
285182	1874	4332000	14501	7397	7	0	\N
285192	1678	15840600168000	14504	7398	0	0	\N
285068	1678	15840600160000	14489	7393	2	0	0
285069	1678	15840600161000	14489	7393	3	0	0
285070	1678	15840600162000	14489	7393	4	0	0
285071	1874	4279000	14489	7393	5	0	1
285072	1874	4280000	14489	7393	6	0	1
285091	1874	4283000	14491	7394	1	0	1
285092	1874	4284000	14491	7394	2	0	1
285093	1874	4286000	14491	7394	3	0	1
285094	1874	4289000	14491	7394	4	0	1
285095	1874	4291000	14491	7394	5	0	1
285097	1874	4295000	14491	7394	7	0	1
285098	1874	4297000	14491	7394	8	0	1
285099	1874	4298000	14491	7394	9	0	1
285100	1874	4301000	14491	7394	10	0	1
285102	1874	4304000	14491	7394	12	0	1
285103	1874	4307000	14491	7394	13	0	1
285104	1874	4309000	14491	7394	14	0	1
285105	1874	4310000	14491	7394	15	0	1
285106	1874	4313000	14491	7394	16	0	1
285157	1874	4315000	14494	7395	1	0	1
285158	1874	4316000	14494	7395	2	0	1
285159	1874	4319000	14494	7395	3	0	1
285170	1874	4321000	14499	7396	0	0	1
285171	1874	4322000	14499	7396	1	0	1
285184	1678	15840600166000	14502	7397	1	0	0
285185	1678	15840600167000	14502	7397	2	0	0
285186	1874	4325000	14502	7397	3	0	1
285187	1874	4327000	14502	7397	4	0	1
285189	1874	4331000	14502	7397	6	0	1
285190	1874	4332000	14502	7397	7	0	1
285191	1678	15840600168000	14503	7398	0	0	0
285193	1874	4335000	14504	7398	1	0	\N
285194	1874	4337000	14504	7398	2	0	\N
285195	1874	4338000	14504	7398	3	0	\N
285228	1678	15840600177000	14509	7402	0	0	\N
285236	1678	15840600177000	14511	7402	0	0	\N
285237	1874	4382000	14511	7402	1	0	\N
285238	1874	4383000	14511	7402	2	0	\N
285239	1874	4386000	14511	7402	3	0	\N
285240	1874	4388000	14511	7402	4	0	\N
285241	1874	4389000	14511	7402	5	0	\N
285242	1874	4392000	14511	7402	6	0	\N
285243	1678	15840600178000	14512	7403	0	0	\N
285244	1678	15840600179000	14512	7403	1	0	\N
285245	1874	4393000	14512	7403	2	0	\N
285246	1874	4395000	14512	7403	3	0	\N
285247	1874	4398000	14512	7403	4	0	\N
285248	1874	4399000	14512	7403	5	0	\N
285255	1678	15840600178000	14514	7403	0	0	\N
285256	1678	15840600179000	14514	7403	1	0	\N
285257	1874	4394000	14514	7403	2	0	\N
285258	1874	4396000	14514	7403	3	0	\N
285259	1874	4399000	14514	7403	4	0	\N
285260	1874	4400000	14514	7403	5	0	\N
285261	1678	15840600178000	14515	7403	0	0	\N
285262	1678	15840600179000	14515	7403	1	0	\N
285263	1874	4394000	14515	7403	2	0	\N
285264	1874	4396000	14515	7403	3	0	\N
285265	1874	4399000	14515	7403	4	0	\N
285266	1874	4400000	14515	7403	5	0	\N
285267	1678	15840600180000	14516	7404	0	0	\N
285268	1874	4402000	14516	7404	1	0	\N
285269	1678	15840600180000	14517	7404	0	0	\N
285270	1874	4402000	14517	7404	1	0	\N
285271	1678	15840600180000	14518	7404	0	0	\N
285272	1874	4402000	14518	7404	1	0	\N
285298	1678	15840600189000	14526	7410	0	0	\N
285299	1874	4441000	14526	7410	1	0	\N
285300	1678	15840600189000	14527	7410	0	0	\N
285301	1874	4441000	14527	7410	1	0	\N
285302	1678	15840600189000	14528	7410	0	0	\N
285303	1874	4441000	14528	7410	1	0	\N
285306	1678	15840600190000	14530	7411	0	0	\N
285307	1874	4443000	14530	7411	1	0	\N
285310	1678	15840600191000	14533	7412	0	0	\N
285311	1874	4445000	14533	7412	1	0	\N
285314	1678	15840600191000	14535	7412	0	0	\N
285315	1874	4445000	14535	7412	1	0	\N
285198	1678	15840600171000	14505	7399	2	0	0
285199	1678	15840600172000	14505	7399	3	0	0
285200	1874	4335000	14505	7399	4	0	1
285201	1874	4337000	14505	7399	5	0	1
285202	1874	4338000	14505	7399	6	0	1
285204	1874	4343000	14505	7399	8	0	1
285205	1874	4344000	14505	7399	9	0	1
285206	1874	4347000	14505	7399	10	0	1
285207	1874	4349000	14505	7399	11	0	1
285208	1874	4350000	14505	7399	12	0	1
285210	1874	4355000	14505	7399	14	0	1
285211	1874	4356000	14505	7399	15	0	1
285212	1874	4359000	14505	7399	16	0	1
285213	1874	4361000	14505	7399	17	0	1
285215	1678	15840600173000	14506	7400	0	0	0
285216	1678	15840600174000	14506	7400	1	0	0
285217	1874	4365000	14506	7400	2	0	1
285218	1874	4367000	14506	7400	3	0	1
285219	1874	4368000	14506	7400	4	0	1
285221	1874	4373000	14506	7400	6	0	1
285222	1874	4374000	14506	7400	7	0	1
285223	1678	15840600175000	14507	7401	0	0	0
285224	1678	15840600176000	14507	7401	1	0	0
285225	1874	4376000	14507	7401	2	0	1
285227	1874	4380000	14507	7401	4	0	1
285229	1678	15840600177000	14510	7402	0	0	0
285230	1874	4382000	14510	7402	1	0	1
285231	1874	4383000	14510	7402	2	0	1
285233	1874	4388000	14510	7402	4	0	1
285234	1874	4389000	14510	7402	5	0	1
285235	1874	4392000	14510	7402	6	0	1
285249	1678	15840600178000	14513	7403	0	0	0
285250	1678	15840600179000	14513	7403	1	0	0
285252	1874	4396000	14513	7403	3	0	1
285253	1874	4399000	14513	7403	4	0	1
285254	1874	4400000	14513	7403	5	0	1
285273	1678	15840600180000	14520	7404	0	0	0
285274	1874	4402000	14520	7404	1	0	1
285276	1678	15840600182000	14521	7405	1	0	0
285277	1874	4404000	14521	7405	2	0	1
285278	1874	4407000	14521	7405	3	0	1
285279	1874	4409000	14521	7405	4	0	1
285281	1678	15840600183000	14522	7406	0	0	0
285282	1874	4414000	14522	7406	1	0	1
285283	1874	4417000	14522	7406	2	0	1
285284	1678	15840600184000	14523	7407	0	0	0
285285	1874	4419000	14523	7407	1	0	1
285287	1678	15840600186000	14524	7408	1	0	0
285288	1874	4421000	14524	7408	2	0	1
285289	1874	4424000	14524	7408	3	0	1
285290	1874	4426000	14524	7408	4	0	1
285291	1874	4429000	14524	7408	5	0	1
285293	1678	15840600188000	14525	7409	1	0	0
285294	1874	4431000	14525	7409	2	0	1
285295	1874	4434000	14525	7409	3	0	1
285296	1874	4436000	14525	7409	4	0	1
285304	1678	15840600189000	14529	7410	0	0	0
285305	1874	4441000	14529	7410	1	0	1
285308	1678	15840600190000	14531	7411	0	0	0
285309	1874	4443000	14531	7411	1	0	1
285312	1678	15840600191000	14534	7412	0	0	0
285316	1678	15840600192000	14536	7413	0	0	0
285317	1874	4447000	14536	7413	1	0	1
285318	1678	15840600193000	14537	7414	0	0	0
285319	1678	15840600194000	14537	7414	1	0	0
285320	1874	4449000	14537	7414	2	0	1
285322	1678	15840600195000	14538	7415	0	0	0
285323	1678	15840600196000	14538	7415	1	0	0
285324	1874	4453000	14538	7415	2	0	1
285325	1874	4455000	14538	7415	3	0	1
285327	1678	15840600198000	14539	7416	1	0	0
285328	1874	4458000	14539	7416	2	0	1
285335	1678	15840600200000	14541	7418	0	0	\N
285336	1678	15840600201000	14541	7418	1	0	\N
285337	1874	4473000	14541	7418	2	0	\N
285338	1874	4475000	14541	7418	3	0	\N
285339	1874	4478000	14541	7418	4	0	\N
285340	1874	4480000	14541	7418	5	0	\N
285341	1678	15840600200000	14542	7418	0	0	\N
285342	1678	15840600201000	14542	7418	1	0	\N
285343	1874	4473000	14542	7418	2	0	\N
285344	1874	4475000	14542	7418	3	0	\N
285345	1874	4478000	14542	7418	4	0	\N
285346	1874	4480000	14542	7418	5	0	\N
285355	1678	15840600203000	14545	7420	0	0	\N
285356	1678	15840600204000	14545	7420	1	0	\N
285357	1874	4486000	14545	7420	2	0	\N
285358	1874	4488000	14545	7420	3	0	\N
285375	1678	15840600205000	14548	7421	0	0	\N
285376	1678	15840600206000	14548	7421	1	0	\N
285377	1678	15840600207000	14548	7421	2	0	\N
285378	1678	15840600208000	14548	7421	3	0	\N
285379	1874	4491000	14548	7421	4	0	\N
285380	1874	4493000	14548	7421	5	0	\N
285381	1874	4496000	14548	7421	6	0	\N
285382	1874	4498000	14548	7421	7	0	\N
285383	1874	4501000	14548	7421	8	0	\N
285384	1874	4503000	14548	7421	9	0	\N
285385	1874	4506000	14548	7421	10	0	\N
285386	1874	4508000	14548	7421	11	0	\N
285387	2113	99000000000	14550	7422	0	0	\N
285388	1678	15840600209000	14550	7422	1	0	\N
285389	1678	15840600210000	14550	7422	2	0	\N
285390	1678	15840600211000	14550	7422	3	0	\N
285391	1874	4511000	14550	7422	4	0	\N
285392	1874	4513000	14550	7422	5	0	\N
285393	1874	4516000	14550	7422	6	0	\N
285394	1874	4518000	14550	7422	7	0	\N
285395	1874	4521000	14550	7422	8	0	\N
285396	1874	4523000	14550	7422	9	0	\N
285397	2113	99000000000	14551	7422	0	0	\N
285398	1678	15840600209000	14551	7422	1	0	\N
285399	1678	15840600210000	14551	7422	2	0	\N
285400	1678	15840600211000	14551	7422	3	0	\N
285401	1874	4511000	14551	7422	4	0	\N
285402	1874	4513000	14551	7422	5	0	\N
285403	1874	4516000	14551	7422	6	0	\N
285404	1874	4518000	14551	7422	7	0	\N
285405	1874	4521000	14551	7422	8	0	\N
285406	1874	4523000	14551	7422	9	0	\N
285417	1678	15840600212000	14553	7423	0	0	\N
285418	1874	4526000	14553	7423	1	0	\N
285419	1874	4528000	14553	7423	2	0	\N
285420	1678	15840600212000	14554	7423	0	0	\N
285421	1874	4526000	14554	7423	1	0	\N
285422	1874	4528000	14554	7423	2	0	\N
285426	1678	15840600212000	14556	7423	0	0	\N
285427	1874	4526000	14556	7423	1	0	\N
285428	1874	4528000	14556	7423	2	0	\N
285429	1678	15840600212000	14557	7423	0	0	\N
285430	1874	4526000	14557	7423	1	0	\N
285431	1874	4528000	14557	7423	2	0	\N
285440	2113	99000000000	14562	7384	0	0	\N
285441	1678	15840600145000	14562	7384	1	0	\N
285442	1678	15840600146000	14562	7384	2	0	\N
285443	1678	15840600147000	14562	7384	3	0	\N
285444	1678	15840600148000	14562	7384	4	0	\N
285445	1678	15840600149000	14562	7384	5	0	\N
285446	1678	15840600150000	14562	7384	6	0	\N
285447	1678	15840600151000	14562	7384	7	0	\N
285448	1678	15840600152000	14562	7384	8	0	\N
285449	1678	15840600153000	14562	7384	9	0	\N
285450	1678	15840600154000	14562	7384	10	0	\N
285451	1678	15840600155000	14562	7384	11	0	\N
285452	1678	15840600156000	14562	7384	12	0	\N
285453	1678	15840600157000	14562	7384	13	0	\N
285454	1678	15840600158000	14562	7384	14	0	\N
285455	1678	15840600159000	14562	7384	15	0	\N
285456	1678	15840600160000	14562	7384	16	0	\N
285457	1678	15840600161000	14562	7384	17	0	\N
285458	1678	15840600162000	14562	7384	18	0	\N
285459	1678	15840600163000	14562	7384	19	0	\N
285460	1678	15840600164000	14562	7384	20	0	\N
285461	1678	15840600165000	14562	7384	21	0	\N
285462	1678	15840600166000	14562	7384	22	0	\N
285463	1678	15840600167000	14562	7384	23	0	\N
285464	1678	15840600168000	14562	7384	24	0	\N
285331	1874	4465000	14539	7416	5	0	1
285332	1678	15840600199000	14540	7417	0	0	0
285333	1874	4468000	14540	7417	1	0	1
285334	1874	4470000	14540	7417	2	0	1
285347	1678	15840600200000	14543	7418	0	0	0
285349	1874	4473000	14543	7418	2	0	1
285350	1874	4475000	14543	7418	3	0	1
285351	1874	4478000	14543	7418	4	0	1
285352	1874	4480000	14543	7418	5	0	1
285353	1678	15840600202000	14544	7419	0	0	0
285359	1678	15840600203000	14546	7420	0	0	0
285360	1678	15840600204000	14546	7420	1	0	0
285361	1874	4486000	14546	7420	2	0	1
285362	1874	4488000	14546	7420	3	0	1
285364	1678	15840600206000	14547	7421	1	0	0
285365	1678	15840600207000	14547	7421	2	0	0
285366	1678	15840600208000	14547	7421	3	0	0
285367	1874	4491000	14547	7421	4	0	1
285368	1874	4493000	14547	7421	5	0	1
285370	1874	4498000	14547	7421	7	0	1
285371	1874	4501000	14547	7421	8	0	1
285372	1874	4503000	14547	7421	9	0	1
285373	1874	4506000	14547	7421	10	0	1
285374	1874	4508000	14547	7421	11	0	1
285408	1678	15840600209000	14552	7422	1	0	0
285409	1678	15840600210000	14552	7422	2	0	0
285410	1678	15840600211000	14552	7422	3	0	0
285411	1874	4511000	14552	7422	4	0	1
285413	1874	4516000	14552	7422	6	0	1
285414	1874	4518000	14552	7422	7	0	1
285415	1874	4521000	14552	7422	8	0	1
285416	1874	4523000	14552	7422	9	0	1
285423	1678	15840600212000	14555	7423	0	0	0
285425	1874	4528000	14555	7423	2	0	1
285432	1678	15840600213000	14558	7424	0	0	0
285433	2113	333983938283	14558	7424	1	0	0
285434	1874	4531000	14558	7424	2	0	1
285435	1678	15840600214000	14559	7425	0	0	0
285437	1874	4536000	14559	7425	2	0	1
285438	1678	15840600215000	14561	7426	0	0	0
285439	1874	4539000	14561	7426	1	0	1
285465	1678	15840600169000	14562	7384	26	0	\N
285466	1678	15840600170000	14562	7384	27	0	\N
285467	1678	15840600171000	14562	7384	28	0	\N
285468	1678	15840600172000	14562	7384	29	0	\N
285469	1678	15840600173000	14562	7384	30	0	\N
285470	1678	15840600174000	14562	7384	31	0	\N
285471	1678	15840600175000	14562	7384	32	0	\N
285472	1678	15840600176000	14562	7384	33	0	\N
285473	1678	15840600177000	14562	7384	34	0	\N
285474	1678	15840600178000	14562	7384	35	0	\N
285475	1678	15840600179000	14562	7384	36	0	\N
285476	1678	15840600180000	14562	7384	37	0	\N
285477	1678	15840600181000	14562	7384	38	0	\N
285478	1678	15840600182000	14562	7384	39	0	\N
285479	1678	15840600183000	14562	7384	40	0	\N
285480	1678	15840600184000	14562	7384	41	0	\N
285481	1678	15840600185000	14562	7384	42	0	\N
285482	1678	15840600186000	14562	7384	43	0	\N
285483	1678	15840600187000	14562	7384	44	0	\N
285484	1678	15840600188000	14562	7384	45	0	\N
285485	1678	15840600189000	14562	7384	46	0	\N
285486	1678	15840600190000	14562	7384	47	0	\N
285487	1678	15840600191000	14562	7384	48	0	\N
285488	1678	15840600192000	14562	7384	49	0	\N
285489	1678	15840600193000	14562	7384	50	0	\N
285490	1678	15840600194000	14562	7384	51	0	\N
285491	1678	15840600195000	14562	7384	52	0	\N
285492	1678	15840600196000	14562	7384	53	0	\N
285493	1678	15840600197000	14562	7384	54	0	\N
285494	1678	15840600198000	14562	7384	55	0	\N
285495	1678	15840600199000	14562	7384	56	0	\N
285496	1678	15840600200000	14562	7384	57	0	\N
285497	1678	15840600201000	14562	7384	58	0	\N
285498	1678	15840600202000	14562	7384	59	0	\N
285499	1678	15840600203000	14562	7384	60	0	\N
285500	1678	15840600204000	14562	7384	61	0	\N
285501	1678	15840600205000	14562	7384	62	0	\N
285502	1678	15840600206000	14562	7384	63	0	\N
285503	1678	15840600207000	14562	7384	64	0	\N
285504	1678	15840600208000	14562	7384	65	0	\N
285505	1678	15840600209000	14562	7384	66	0	\N
285506	1678	15840600210000	14562	7384	67	0	\N
285507	1678	15840600211000	14562	7384	68	0	\N
285508	1678	15840600212000	14562	7384	69	0	\N
285509	1678	15840600213000	14562	7384	70	0	\N
285510	1678	15840600214000	14562	7384	71	0	\N
285511	1678	15840600215000	14562	7384	72	0	\N
285512	2113	333983938283	14562	7384	73	0	\N
285513	1874	4211000	14562	7384	74	0	\N
285514	1874	4212000	14562	7384	75	0	\N
285515	1874	4215000	14562	7384	76	0	\N
285516	1874	4217000	14562	7384	77	0	\N
285517	1874	4218000	14562	7384	78	0	\N
285518	1874	4221000	14562	7384	79	0	\N
285519	1874	4223000	14562	7384	80	0	\N
285520	1874	4224000	14562	7384	81	0	\N
285521	1874	4227000	14562	7384	82	0	\N
285522	1874	4229000	14562	7384	83	0	\N
285523	1874	4230000	14562	7384	84	0	\N
285524	1874	4233000	14562	7384	85	0	\N
285525	1874	4235000	14562	7384	86	0	\N
285526	1874	4236000	14562	7384	87	0	\N
285527	1874	4238000	14562	7384	88	0	\N
285528	1874	4241000	14562	7384	89	0	\N
285529	1874	4242000	14562	7384	90	0	\N
285530	1874	4244000	14562	7384	91	0	\N
285531	1874	4247000	14562	7384	92	0	\N
285532	1874	4248000	14562	7384	93	0	\N
285533	1874	4250000	14562	7384	94	0	\N
285534	1874	4253000	14562	7384	95	0	\N
285535	1874	4255000	14562	7384	96	0	\N
285536	1874	4256000	14562	7384	97	0	\N
285537	1874	4259000	14562	7384	98	0	\N
285538	1874	4261000	14562	7384	99	0	\N
285539	1874	4262000	14562	7384	100	0	\N
285540	1874	4265000	14562	7384	101	0	\N
285541	1874	4267000	14562	7384	102	0	\N
285542	1874	4268000	14562	7384	103	0	\N
285543	1874	4271000	14562	7384	104	0	\N
285544	1874	4273000	14562	7384	105	0	\N
285545	1874	4274000	14562	7384	106	0	\N
285546	1874	4277000	14562	7384	107	0	\N
285547	1874	4279000	14562	7384	108	0	\N
285548	1874	4280000	14562	7384	109	0	\N
285549	1874	4283000	14562	7384	110	0	\N
285550	1874	4284000	14562	7384	111	0	\N
285551	1874	4286000	14562	7384	112	0	\N
285552	1874	4289000	14562	7384	113	0	\N
285553	1874	4291000	14562	7384	114	0	\N
285554	1874	4292000	14562	7384	115	0	\N
285555	1874	4295000	14562	7384	116	0	\N
285556	1874	4297000	14562	7384	117	0	\N
285557	1874	4298000	14562	7384	118	0	\N
285558	1874	4301000	14562	7384	119	0	\N
285559	1874	4303000	14562	7384	120	0	\N
285560	1874	4304000	14562	7384	121	0	\N
285561	1874	4307000	14562	7384	122	0	\N
285562	1874	4309000	14562	7384	123	0	\N
285563	1874	4310000	14562	7384	124	0	\N
285564	1874	4313000	14562	7384	125	0	\N
285565	1678	15840600216000	14563	7427	0	0	\N
285566	1874	4542000	14563	7427	1	0	\N
285567	1678	15840600216000	14564	7427	0	0	\N
285568	1874	4542000	14564	7427	1	0	\N
285570	1678	15840600216000	14566	7427	0	0	\N
285571	1874	4542000	14566	7427	1	0	\N
285584	1678	15840600219000	14569	7429	0	0	\N
285585	1678	15840600220000	14569	7429	1	0	\N
285586	1678	15840600221000	14569	7429	2	0	\N
285587	1874	4551000	14569	7429	3	0	\N
285588	1874	4554000	14569	7429	4	0	\N
285589	1874	4557000	14569	7429	5	0	\N
285590	1678	15840600219000	14570	7429	0	0	\N
285591	1678	15840600220000	14570	7429	1	0	\N
285592	1678	15840600221000	14570	7429	2	0	\N
285593	1874	4551000	14570	7429	3	0	\N
285594	1874	4554000	14570	7429	4	0	\N
285595	1874	4557000	14570	7429	5	0	\N
285596	1678	15840600219000	14571	7429	0	0	\N
285597	1678	15840600220000	14571	7429	1	0	\N
285598	1678	15840600221000	14571	7429	2	0	\N
285599	1874	4551000	14571	7429	3	0	\N
285600	1874	4554000	14571	7429	4	0	\N
285573	1678	15840600217000	14567	7428	1	0	0
285574	1678	15840600218000	14567	7428	2	0	0
285575	1560	10674249277001	14567	7428	3	0	15
285576	1874	4545000	14567	7428	4	0	1
285577	1874	4548000	14567	7428	5	0	1
285579	1678	15840600220000	14568	7429	1	0	0
285580	1678	15840600221000	14568	7429	2	0	0
285581	1874	4551000	14568	7429	3	0	1
285582	1874	4554000	14568	7429	4	0	1
285583	1874	4557000	14568	7429	5	0	1
285601	1874	4557000	14571	7429	5	0	\N
285602	1678	15840600222000	14572	7430	0	0	\N
285603	1874	4560000	14572	7430	1	0	\N
285604	1678	15840600222000	14573	7430	0	0	\N
285605	1874	4560000	14573	7430	1	0	\N
285610	1678	15840600223000	14576	7431	0	0	\N
285611	1874	4563000	14576	7431	1	0	\N
285614	1678	15840600224000	14578	7432	0	0	\N
285615	1874	4566000	14578	7432	1	0	\N
285618	1874	4575000	14581	7435	0	0	\N
285620	1874	4578000	14583	7436	0	0	\N
285624	1678	15840600225000	14586	7438	0	0	\N
285625	1874	4585000	14586	7438	1	0	\N
285626	1874	4588000	14586	7438	2	0	\N
285633	1678	15840600226000	14589	7439	0	0	\N
285634	1874	4590000	14589	7439	1	0	\N
285635	1874	4593000	14589	7439	2	0	\N
285636	1678	15840600226000	14590	7439	0	0	\N
285637	1874	4590000	14590	7439	1	0	\N
285638	1874	4593000	14590	7439	2	0	\N
285648	1678	15840600229000	14594	7442	0	0	\N
285649	1874	4605000	14594	7442	1	0	\N
285650	1874	4608000	14594	7442	2	0	\N
285651	1678	15840600229000	14595	7442	0	0	\N
285652	1874	4605000	14595	7442	1	0	\N
285653	1874	4608000	14595	7442	2	0	\N
285654	1678	15840600229000	14596	7442	0	0	\N
285655	1874	4605000	14596	7442	1	0	\N
285656	1874	4608000	14596	7442	2	0	\N
285657	1678	15840600230000	14597	7443	0	0	\N
285658	1874	4610000	14597	7443	1	0	\N
285659	1874	4613000	14597	7443	2	0	\N
285663	1678	15840600230000	14600	7443	0	0	\N
285664	1874	4610000	14600	7443	1	0	\N
285665	1874	4613000	14600	7443	2	0	\N
285666	1678	15840600231000	14601	7444	0	0	\N
285667	1874	4615000	14601	7444	1	0	\N
285668	1874	4618000	14601	7444	2	0	\N
285672	1678	15840600231000	14603	7444	0	0	\N
285673	1874	4615000	14603	7444	1	0	\N
285674	1874	4618000	14603	7444	2	0	\N
285681	2113	99000000000	14606	7229	0	0	\N
285682	2113	333983938283	14606	7229	1	0	\N
285683	1678	15840600234000	14607	7447	0	0	\N
285684	1874	4630000	14607	7447	1	0	\N
285685	1874	4633000	14607	7447	2	0	\N
285700	1678	15840600235000	14610	7448	0	0	\N
285701	1678	15840600236000	14610	7448	1	0	\N
285702	1678	15840600237000	14610	7448	2	0	\N
285703	1678	15840600238000	14610	7448	3	0	\N
285704	1874	4635000	14610	7448	4	0	\N
285705	1874	4638000	14610	7448	5	0	\N
285706	1874	4640000	14610	7448	6	0	\N
285707	1874	4643000	14610	7448	7	0	\N
285708	1874	4645000	14610	7448	8	0	\N
285709	1874	4648000	14610	7448	9	0	\N
285710	1874	4650000	14610	7448	10	0	\N
285713	1678	15840600240000	14612	7450	0	0	\N
285714	1874	4655000	14612	7450	1	0	\N
285715	1874	4658000	14612	7450	2	0	\N
285716	1678	15840600240000	14613	7450	0	0	\N
285717	1874	4655000	14613	7450	1	0	\N
285718	1874	4658000	14613	7450	2	0	\N
285722	1678	15840600240000	14615	7450	0	0	\N
285723	1874	4655000	14615	7450	1	0	\N
285724	1874	4658000	14615	7450	2	0	\N
285608	1678	15840600223000	14575	7431	0	0	0
285609	1874	4563000	14575	7431	1	0	1
285612	1678	15840600224000	14577	7432	0	0	0
285613	1874	4566000	14577	7432	1	0	1
285616	1874	4569000	14579	7433	0	0	1
285619	1874	4575000	14582	7435	0	0	1
285621	1874	4578000	14584	7436	0	0	1
285622	1874	4580000	14585	7437	0	0	1
285623	1874	4583000	14585	7437	1	0	1
285627	1678	15840600225000	14587	7438	0	0	0
285629	1874	4588000	14587	7438	2	0	1
285630	1678	15840600226000	14588	7439	0	0	0
285631	1874	4590000	14588	7439	1	0	1
285632	1874	4593000	14588	7439	2	0	1
285640	1874	4595000	14591	7440	1	0	1
285641	1874	4598000	14591	7440	2	0	1
285642	1678	15840600228000	14592	7441	0	0	0
285643	1874	4600000	14592	7441	1	0	1
285644	1874	4603000	14592	7441	2	0	1
285646	1874	4605000	14593	7442	1	0	1
285647	1874	4608000	14593	7442	2	0	1
285660	1678	15840600230000	14598	7443	0	0	0
285661	1874	4610000	14598	7443	1	0	1
285662	1874	4613000	14598	7443	2	0	1
285670	1874	4615000	14602	7444	1	0	1
285671	1874	4618000	14602	7444	2	0	1
285675	1678	15840600232000	14604	7445	0	0	0
285676	1874	4620000	14604	7445	1	0	1
285678	1678	15840600233000	14605	7446	0	0	0
285679	1874	4625000	14605	7446	1	0	1
285680	1874	4628000	14605	7446	2	0	1
285686	1678	15840600234000	14608	7447	0	0	0
285687	1874	4630000	14608	7447	1	0	1
285689	1678	15840600235000	14609	7448	0	0	0
285690	1678	15840600236000	14609	7448	1	0	0
285691	1678	15840600237000	14609	7448	2	0	0
285692	1678	15840600238000	14609	7448	3	0	0
285693	1874	4635000	14609	7448	4	0	1
285695	1874	4640000	14609	7448	6	0	1
285696	1874	4643000	14609	7448	7	0	1
285697	1874	4645000	14609	7448	8	0	1
285698	1874	4648000	14609	7448	9	0	1
285711	1678	15840600239000	14611	7449	0	0	0
285712	1874	4653000	14611	7449	1	0	1
285719	1678	15840600240000	14614	7450	0	0	0
285720	1874	4655000	14614	7450	1	0	1
285721	1874	4658000	14614	7450	2	0	1
285726	1874	4660000	14616	7451	1	0	1
285727	1874	4663000	14616	7451	2	0	1
285728	1678	15840600242000	14617	7452	0	0	0
285729	1678	15840600243000	14617	7452	1	0	0
285730	1678	15840600244000	14617	7452	2	0	0
285732	1874	4668000	14617	7452	4	0	1
285733	1874	4670000	14617	7452	5	0	1
285734	1874	4673000	14617	7452	6	0	1
285735	1874	4675000	14617	7452	7	0	1
285740	1678	15840600245000	14620	7453	0	0	\N
285741	1874	4680000	14620	7453	1	0	\N
285742	1874	4683000	14620	7453	2	0	\N
285743	1678	15840600245000	14621	7453	0	0	\N
285744	1874	4680000	14621	7453	1	0	\N
285745	1874	4683000	14621	7453	2	0	\N
285746	1678	15840600245000	14622	7453	0	0	\N
285747	1874	4680000	14622	7453	1	0	\N
285748	1874	4683000	14622	7453	2	0	\N
285752	1678	15840600247000	14624	7455	0	0	\N
285753	1874	4690000	14624	7455	1	0	\N
285754	1874	4693000	14624	7455	2	0	\N
285755	1678	15840600247000	14625	7455	0	0	\N
285756	1874	4690000	14625	7455	1	0	\N
285757	1874	4693000	14625	7455	2	0	\N
285770	1678	15840600251000	14629	7458	0	0	\N
285771	1874	4710000	14629	7458	1	0	\N
285772	1874	4713000	14629	7458	2	0	\N
285776	1678	15840600251000	14631	7458	0	0	\N
285777	1874	4710000	14631	7458	1	0	\N
285778	1874	4713000	14631	7458	2	0	\N
285779	1678	15840600252000	14632	7459	0	0	\N
285780	1678	15840600253000	14632	7459	1	0	\N
285781	1678	15840600254000	14632	7459	2	0	\N
285782	1874	4715000	14632	7459	3	0	\N
285783	1874	4718000	14632	7459	4	0	\N
285784	1874	4720000	14632	7459	5	0	\N
285785	1874	4723000	14632	7459	6	0	\N
285786	1874	4725000	14632	7459	7	0	\N
285787	1874	4728000	14632	7459	8	0	\N
285797	1678	15840600255000	14636	7460	0	0	\N
285798	1678	15840600256000	14636	7460	1	0	\N
285799	1874	4730000	14636	7460	2	0	\N
285800	1874	4733000	14636	7460	3	0	\N
285801	1874	4735000	14636	7460	4	0	\N
285802	1874	4738000	14636	7460	5	0	\N
285809	1678	15840600255000	14638	7460	0	0	\N
285810	1678	15840600256000	14638	7460	1	0	\N
285811	1874	4730000	14638	7460	2	0	\N
285812	1874	4733000	14638	7460	3	0	\N
285813	1874	4735000	14638	7460	4	0	\N
285814	1874	4738000	14638	7460	5	0	\N
285815	1874	4740000	14639	7461	0	0	\N
285816	1874	4743000	14639	7461	1	0	\N
285819	1874	4740000	14641	7461	0	0	\N
285820	1874	4743000	14641	7461	1	0	\N
285821	1483	10000000	14642	7361	0	0	\N
285822	2113	99000000000	14642	7361	1	0	\N
285823	1678	15840600116000	14642	7361	2	0	\N
285824	1678	15840600117000	14642	7361	3	0	\N
285825	1678	15840600118000	14642	7361	4	0	\N
285826	1678	15840600119000	14642	7361	5	0	\N
285827	1678	15840600120000	14642	7361	6	0	\N
285828	1678	15840600121000	14642	7361	7	0	\N
285829	1678	15840600122000	14642	7361	8	0	\N
285830	1678	15840600123000	14642	7361	9	0	\N
285831	1678	15840600124000	14642	7361	10	0	\N
285832	1678	15840600125000	14642	7361	11	0	\N
285833	1678	15840600126000	14642	7361	12	0	\N
285834	1678	15840600127000	14642	7361	13	0	\N
285835	1678	15840600128000	14642	7361	14	0	\N
285836	1678	15840600129000	14642	7361	15	0	\N
285837	1678	15840600130000	14642	7361	16	0	\N
285838	1678	15840600131000	14642	7361	17	0	\N
285839	1678	15840600132000	14642	7361	18	0	\N
285840	1678	15840600133000	14642	7361	19	0	\N
285841	1678	15840600134000	14642	7361	20	0	\N
285842	1678	15840600135000	14642	7361	21	0	\N
285843	1678	15840600136000	14642	7361	22	0	\N
285844	1678	15840600137000	14642	7361	23	0	\N
285845	1678	15840600138000	14642	7361	24	0	\N
285846	1678	15840600139000	14642	7361	25	0	\N
285847	1678	15840600140000	14642	7361	26	0	\N
285848	1678	15840600141000	14642	7361	27	0	\N
285849	1678	15840600142000	14642	7361	28	0	\N
285850	1678	15840600143000	14642	7361	29	0	\N
285851	1678	15840600144000	14642	7361	30	0	\N
285852	1678	15840600145000	14642	7361	31	0	\N
285853	1678	15840600146000	14642	7361	32	0	\N
285854	1678	15840600147000	14642	7361	33	0	\N
285855	1678	15840600148000	14642	7361	34	0	\N
285856	1678	15840600149000	14642	7361	35	0	\N
285857	1678	15840600150000	14642	7361	36	0	\N
285858	1678	15840600151000	14642	7361	37	0	\N
285859	1678	15840600152000	14642	7361	38	0	\N
285860	1678	15840600153000	14642	7361	39	0	\N
285861	1678	15840600154000	14642	7361	40	0	\N
285862	1678	15840600155000	14642	7361	41	0	\N
285863	1678	15840600156000	14642	7361	42	0	\N
285864	1678	15840600157000	14642	7361	43	0	\N
285865	1678	15840600158000	14642	7361	44	0	\N
285866	1678	15840600159000	14642	7361	45	0	\N
285867	1678	15840600160000	14642	7361	46	0	\N
285868	1678	15840600161000	14642	7361	47	0	\N
285869	1678	15840600162000	14642	7361	48	0	\N
285870	1678	15840600163000	14642	7361	49	0	\N
285871	1678	15840600164000	14642	7361	50	0	\N
285872	1678	15840600165000	14642	7361	51	0	\N
285739	1874	4683000	14618	7453	2	0	1
285749	1678	15840600246000	14623	7454	0	0	0
285750	1874	4685000	14623	7454	1	0	1
285751	1874	4688000	14623	7454	2	0	1
285758	1678	15840600247000	14626	7455	0	0	0
285760	1874	4693000	14626	7455	2	0	1
285761	1678	15840600248000	14627	7456	0	0	0
285762	1678	15840600249000	14627	7456	1	0	0
285763	1874	4695000	14627	7456	2	0	1
285764	1874	4698000	14627	7456	3	0	1
285766	1874	4703000	14627	7456	5	0	1
285767	1678	15840600250000	14628	7457	0	0	0
285768	1874	4705000	14628	7457	1	0	1
285769	1874	4708000	14628	7457	2	0	1
285774	1874	4710000	14630	7458	1	0	1
285775	1874	4713000	14630	7458	2	0	1
285788	1678	15840600252000	14633	7459	0	0	0
285789	1678	15840600253000	14633	7459	1	0	0
285790	1678	15840600254000	14633	7459	2	0	0
285792	1874	4718000	14633	7459	4	0	1
285793	1874	4720000	14633	7459	5	0	1
285794	1874	4723000	14633	7459	6	0	1
285795	1874	4725000	14633	7459	7	0	1
285796	1874	4728000	14633	7459	8	0	1
285804	1678	15840600256000	14637	7460	1	0	0
285805	1874	4730000	14637	7460	2	0	1
285806	1874	4733000	14637	7460	3	0	1
285807	1874	4735000	14637	7460	4	0	1
285817	1874	4740000	14640	7461	0	0	1
285818	1874	4743000	14640	7461	1	0	1
285873	1678	15840600166000	14642	7361	52	0	\N
285874	1678	15840600167000	14642	7361	53	0	\N
285875	1678	15840600168000	14642	7361	54	0	\N
285876	1678	15840600169000	14642	7361	55	0	\N
285877	1678	15840600170000	14642	7361	56	0	\N
285878	1678	15840600171000	14642	7361	57	0	\N
285879	1678	15840600172000	14642	7361	58	0	\N
285880	1678	15840600173000	14642	7361	59	0	\N
285881	1678	15840600174000	14642	7361	60	0	\N
285882	1678	15840600175000	14642	7361	61	0	\N
285883	1678	15840600176000	14642	7361	62	0	\N
285884	1678	15840600177000	14642	7361	64	0	\N
285885	1678	15840600178000	14642	7361	65	0	\N
285886	1678	15840600179000	14642	7361	66	0	\N
285887	1678	15840600180000	14642	7361	67	0	\N
285888	1678	15840600181000	14642	7361	68	0	\N
285889	1678	15840600182000	14642	7361	69	0	\N
285890	1678	15840600183000	14642	7361	70	0	\N
285891	1678	15840600184000	14642	7361	71	0	\N
285892	1678	15840600185000	14642	7361	72	0	\N
285893	1678	15840600186000	14642	7361	73	0	\N
285894	1678	15840600187000	14642	7361	74	0	\N
285895	1678	15840600188000	14642	7361	75	0	\N
285896	1678	15840600189000	14642	7361	76	0	\N
285897	1678	15840600190000	14642	7361	77	0	\N
285898	1678	15840600191000	14642	7361	78	0	\N
285899	1678	15840600192000	14642	7361	79	0	\N
285900	1678	15840600193000	14642	7361	80	0	\N
285901	1678	15840600194000	14642	7361	81	0	\N
285902	1678	15840600195000	14642	7361	82	0	\N
285903	1678	15840600196000	14642	7361	83	0	\N
285904	1678	15840600197000	14642	7361	84	0	\N
285905	1678	15840600198000	14642	7361	85	0	\N
285906	1678	15840600199000	14642	7361	86	0	\N
285907	1678	15840600200000	14642	7361	87	0	\N
285908	1678	15840600201000	14642	7361	88	0	\N
285909	1678	15840600202000	14642	7361	89	0	\N
285910	1678	15840600203000	14642	7361	90	0	\N
285911	1678	15840600204000	14642	7361	91	0	\N
285912	1678	15840600205000	14642	7361	92	0	\N
285913	1678	15840600206000	14642	7361	93	0	\N
285914	1678	15840600207000	14642	7361	94	0	\N
285915	1678	15840600208000	14642	7361	95	0	\N
285916	1678	15840600209000	14642	7361	96	0	\N
285917	1678	15840600210000	14642	7361	97	0	\N
285918	1678	15840600211000	14642	7361	98	0	\N
285919	1678	15840600212000	14642	7361	99	0	\N
285920	1678	15840600213000	14642	7361	100	0	\N
285921	1678	15840600214000	14642	7361	101	0	\N
285922	1678	15840600215000	14642	7361	102	0	\N
285923	1678	15840600216000	14642	7361	103	0	\N
285924	1678	15840600217000	14642	7361	104	0	\N
285925	1678	15840600218000	14642	7361	105	0	\N
285926	1678	15840600219000	14642	7361	106	0	\N
285927	1678	15840600220000	14642	7361	107	0	\N
285928	1678	15840600221000	14642	7361	108	0	\N
285929	1678	15840600222000	14642	7361	109	0	\N
285930	1678	15840600223000	14642	7361	110	0	\N
285931	1678	15840600224000	14642	7361	111	0	\N
285932	1678	15840600225000	14642	7361	112	0	\N
285933	1678	15840600226000	14642	7361	113	0	\N
285934	1678	15840600227000	14642	7361	114	0	\N
285935	1678	15840600228000	14642	7361	115	0	\N
285936	1678	15840600229000	14642	7361	116	0	\N
285937	1678	15840600230000	14642	7361	117	0	\N
285938	1678	15840600231000	14642	7361	118	0	\N
285939	1678	15840600232000	14642	7361	119	0	\N
285940	1678	15840600233000	14642	7361	120	0	\N
285941	1678	15840600234000	14642	7361	121	0	\N
285942	1678	15840600235000	14642	7361	122	0	\N
285943	1678	15840600236000	14642	7361	123	0	\N
285944	1678	15840600237000	14642	7361	124	0	\N
285945	1678	15840600238000	14642	7361	125	0	\N
285963	1678	15840600260000	14646	7465	0	0	\N
285964	1874	4780000	14646	7465	1	0	\N
285965	1874	4783000	14646	7465	2	0	\N
285969	1678	15840600239000	14648	7362	0	0	\N
285970	1678	15840600240000	14648	7362	1	0	\N
285971	1678	15840600241000	14648	7362	2	0	\N
285972	1678	15840600242000	14648	7362	3	0	\N
285973	1678	15840600243000	14648	7362	4	0	\N
285974	1678	15840600244000	14648	7362	5	0	\N
285975	1678	15840600245000	14648	7362	6	0	\N
285976	1678	15840600246000	14648	7362	7	0	\N
285977	1678	15840600247000	14648	7362	8	0	\N
285978	1678	15840600248000	14648	7362	9	0	\N
285979	1678	15840600249000	14648	7362	10	0	\N
285980	1678	15840600250000	14648	7362	11	0	\N
285981	1678	15840600251000	14648	7362	12	0	\N
285982	1678	15840600252000	14648	7362	13	0	\N
285983	1678	15840600253000	14648	7362	14	0	\N
285984	1678	15840600254000	14648	7362	15	0	\N
285985	1678	15840600255000	14648	7362	16	0	\N
285986	1678	15840600256000	14648	7362	17	0	\N
285987	1678	15840600257000	14648	7362	18	0	\N
285988	1678	15840600258000	14648	7362	19	0	\N
285989	1678	15840600259000	14648	7362	20	0	\N
285990	1678	15840600260000	14648	7362	21	0	\N
285991	2113	333983938283	14648	7362	22	0	\N
285992	1874	4033000	14648	7362	23	0	\N
285993	1874	4035000	14648	7362	24	0	\N
285994	1874	4036000	14648	7362	25	0	\N
285995	1874	4039000	14648	7362	26	0	\N
285996	1874	4041000	14648	7362	27	0	\N
285997	1874	4042000	14648	7362	28	0	\N
285998	1874	4045000	14648	7362	29	0	\N
285999	1874	4047000	14648	7362	30	0	\N
286000	1874	4048000	14648	7362	31	0	\N
286001	1874	4051000	14648	7362	32	0	\N
286002	1874	4053000	14648	7362	33	0	\N
286003	1874	4054000	14648	7362	34	0	\N
286004	1874	4057000	14648	7362	35	0	\N
286005	1874	4059000	14648	7362	36	0	\N
286006	1874	4060000	14648	7362	37	0	\N
286007	1874	4063000	14648	7362	38	0	\N
286008	1874	4065000	14648	7362	39	0	\N
285948	1678	15840600257000	14644	7463	0	0	0
285949	1678	15840600258000	14644	7463	1	0	0
285950	1874	4750000	14644	7463	2	0	1
285951	1874	4753000	14644	7463	3	0	1
285952	1874	4755000	14644	7463	4	0	1
285954	1874	4760000	14644	7463	6	0	1
285955	1874	4763000	14644	7463	7	0	1
285956	1874	4765000	14644	7463	8	0	1
285957	1874	4768000	14644	7463	9	0	1
285958	1874	4770000	14644	7463	10	0	1
285960	1678	15840600259000	14645	7464	0	0	0
285961	1874	4775000	14645	7464	1	0	1
285962	1874	4778000	14645	7464	2	0	1
285966	1678	15840600260000	14647	7465	0	0	0
285968	1874	4783000	14647	7465	2	0	1
286009	1874	4066000	14648	7362	40	0	\N
286010	1874	4069000	14648	7362	41	0	\N
286011	1874	4071000	14648	7362	42	0	\N
286012	1874	4072000	14648	7362	43	0	\N
286013	1874	4075000	14648	7362	44	0	\N
286014	1874	4077000	14648	7362	45	0	\N
286015	1874	4078000	14648	7362	46	0	\N
286016	1874	4081000	14648	7362	47	0	\N
286017	1874	4082000	14648	7362	48	0	\N
286018	1874	4084000	14648	7362	49	0	\N
286019	1874	4085000	14648	7362	50	0	\N
286020	1874	4088000	14648	7362	51	0	\N
286021	1874	4089000	14648	7362	52	0	\N
286022	1874	4092000	14648	7362	53	0	\N
286023	1874	4094000	14648	7362	54	0	\N
286024	1874	4095000	14648	7362	55	0	\N
286025	1874	4097000	14648	7362	56	0	\N
286026	1874	4100000	14648	7362	57	0	\N
286027	1874	4101000	14648	7362	58	0	\N
286028	1874	4103000	14648	7362	59	0	\N
286029	1874	4106000	14648	7362	60	0	\N
286030	1874	4107000	14648	7362	61	0	\N
286031	1874	4109000	14648	7362	62	0	\N
286032	1874	4110000	14648	7362	64	0	\N
286033	1874	4112000	14648	7362	65	0	\N
286034	1874	4115000	14648	7362	66	0	\N
286035	1874	4116000	14648	7362	67	0	\N
286036	1874	4118000	14648	7362	68	0	\N
286037	1874	4121000	14648	7362	69	0	\N
286038	1874	4122000	14648	7362	70	0	\N
286039	1874	4124000	14648	7362	71	0	\N
286040	1874	4127000	14648	7362	72	0	\N
286041	1874	4128000	14648	7362	73	0	\N
286042	1874	4130000	14648	7362	74	0	\N
286043	1874	4133000	14648	7362	75	0	\N
286044	1874	4135000	14648	7362	76	0	\N
286045	1874	4138000	14648	7362	77	0	\N
286046	1874	4140000	14648	7362	78	0	\N
286047	1874	4143000	14648	7362	79	0	\N
286048	1874	4145000	14648	7362	80	0	\N
286049	1874	4146000	14648	7362	81	0	\N
286050	1874	4149000	14648	7362	82	0	\N
286051	1874	4151000	14648	7362	83	0	\N
286052	1874	4152000	14648	7362	84	0	\N
286053	1874	4155000	14648	7362	85	0	\N
286054	1874	4157000	14648	7362	86	0	\N
286055	1874	4158000	14648	7362	87	0	\N
286056	1874	4161000	14648	7362	88	0	\N
286057	1874	4163000	14648	7362	89	0	\N
286058	1874	4164000	14648	7362	90	0	\N
286059	1874	4167000	14648	7362	91	0	\N
286060	1874	4169000	14648	7362	92	0	\N
286061	1874	4170000	14648	7362	93	0	\N
286062	1874	4173000	14648	7362	94	0	\N
286063	1874	4175000	14648	7362	95	0	\N
286064	1874	4176000	14648	7362	96	0	\N
286065	1874	4179000	14648	7362	97	0	\N
286066	1874	4181000	14648	7362	98	0	\N
286067	1874	4182000	14648	7362	99	0	\N
286068	1874	4185000	14648	7362	100	0	\N
286069	1874	4187000	14648	7362	101	0	\N
286070	1874	4188000	14648	7362	102	0	\N
286071	1874	4191000	14648	7362	103	0	\N
286072	1874	4193000	14648	7362	104	0	\N
286073	1874	4194000	14648	7362	105	0	\N
286074	1874	4197000	14648	7362	106	0	\N
286075	1874	4199000	14648	7362	107	0	\N
286076	1874	4200000	14648	7362	108	0	\N
286077	1874	4203000	14648	7362	109	0	\N
286078	1874	4205000	14648	7362	110	0	\N
286079	1874	4206000	14648	7362	111	0	\N
286080	1874	4209000	14648	7362	112	0	\N
286081	1874	4211000	14648	7362	113	0	\N
286082	1874	4212000	14648	7362	114	0	\N
286083	1874	4215000	14648	7362	115	0	\N
286084	1874	4217000	14648	7362	116	0	\N
286085	1874	4218000	14648	7362	117	0	\N
286086	1874	4221000	14648	7362	118	0	\N
286087	1874	4223000	14648	7362	119	0	\N
286088	1874	4224000	14648	7362	120	0	\N
286089	1874	4227000	14648	7362	121	0	\N
286090	1874	4229000	14648	7362	122	0	\N
286091	1874	4230000	14648	7362	123	0	\N
286092	1874	4233000	14648	7362	124	0	\N
286093	1874	4235000	14648	7362	125	0	\N
286103	1678	15840600263000	14651	7467	0	0	\N
286104	1874	4795000	14651	7467	1	0	\N
286105	1874	4798000	14651	7467	2	0	\N
286106	1678	15840600263000	14652	7467	0	0	\N
286107	1874	4795000	14652	7467	1	0	\N
286108	1874	4798000	14652	7467	2	0	\N
286109	1678	15840600263000	14653	7467	0	0	\N
286110	1874	4795000	14653	7467	1	0	\N
286111	1874	4798000	14653	7467	2	0	\N
286112	1678	15840600263000	14654	7467	0	0	\N
286113	1874	4795000	14654	7467	1	0	\N
286114	1874	4798000	14654	7467	2	0	\N
286115	1678	15840600263000	14656	7467	0	0	\N
286116	1874	4795000	14656	7467	1	0	\N
286117	1874	4798000	14656	7467	2	0	\N
286118	1678	15840600264000	14657	7468	0	0	\N
286119	1874	4800000	14657	7468	1	0	\N
286120	1874	4803000	14657	7468	2	0	\N
286121	1678	15840600264000	14658	7468	0	0	\N
286122	1874	4800000	14658	7468	1	0	\N
286123	1874	4803000	14658	7468	2	0	\N
286127	1678	15840600265000	14660	7469	0	0	\N
286128	1678	15840600266000	14660	7469	1	0	\N
286129	1874	4805000	14660	7469	2	0	\N
286130	1874	4807000	14660	7469	3	0	\N
286131	1874	4810000	14660	7469	4	0	\N
286132	1678	15840600265000	14661	7469	0	0	\N
286133	1678	15840600266000	14661	7469	1	0	\N
286134	1874	4805000	14661	7469	2	0	\N
286135	1874	4807000	14661	7469	3	0	\N
286136	1874	4810000	14661	7469	4	0	\N
286142	1678	15840600267000	14663	7470	0	0	\N
286143	1874	4812000	14663	7470	1	0	\N
286144	1874	4815000	14663	7470	2	0	\N
286096	1874	4785000	14649	7466	2	0	1
286097	1874	4788000	14649	7466	3	0	1
286098	1874	4790000	14649	7466	4	0	1
286099	1874	4793000	14649	7466	6	0	1
286100	1678	15840600263000	14650	7467	0	0	0
286102	1874	4798000	14650	7467	2	0	1
286124	1678	15840600264000	14659	7468	0	0	0
286125	1874	4800000	14659	7468	1	0	1
286126	1874	4803000	14659	7468	2	0	1
286137	1678	15840600265000	14662	7469	0	0	0
286139	1874	4805000	14662	7469	2	0	1
286140	1874	4807000	14662	7469	3	0	1
286141	1874	4810000	14662	7469	4	0	1
286186	163	66530973005524	14668	7474	0	0	\N
286187	275	66530973005524	14668	7474	1	0	\N
286188	201	66530973005524	14668	7474	2	0	\N
286189	1678	15840600273000	14668	7474	3	0	\N
286190	1962	529885180751	14668	7474	4	0	\N
286191	309	66530973005524	14668	7474	5	0	\N
286192	82	66530973005524	14668	7474	6	0	\N
286193	1874	4832000	14668	7474	7	0	\N
286201	1678	15840600274000	14670	7475	0	0	\N
286202	361	66530973005524	14670	7475	1	0	\N
286203	452	66530973005524	14670	7475	2	0	\N
286204	594	66530973005524	14670	7475	3	0	\N
286205	534	66530973005524	14670	7475	4	0	\N
286206	245	66530973005524	14670	7475	5	0	\N
286207	191	66530973005524	14670	7475	6	0	\N
286208	1874	4832000	14670	7475	7	0	\N
286209	1874	4835000	14670	7475	8	0	\N
286219	1678	15840600275000	14672	7476	0	0	\N
286220	1678	15840600276000	14672	7476	1	0	\N
286221	1678	15840600277000	14672	7476	2	0	\N
286222	1678	15840600275000	14673	7476	0	0	\N
286223	1678	15840600276000	14673	7476	1	0	\N
286224	1678	15840600277000	14673	7476	2	0	\N
286225	266	66530973005524	14673	7476	3	0	\N
286226	352	66530973005524	14673	7476	4	0	\N
286227	421	66530973005524	14673	7476	5	0	\N
286228	420	66530973005524	14673	7476	6	0	\N
286229	600	66530973005524	14673	7476	7	0	\N
286230	353	66530963005524	14673	7476	8	0	\N
286231	620	66530973005524	14673	7476	9	0	\N
286232	180	66530973005524	14673	7476	10	0	\N
286233	112	66187942005524	14673	7476	11	0	\N
286234	652	66530973005524	14673	7476	12	0	\N
286235	680	66530973005524	14673	7476	13	0	\N
286236	690	66530973005524	14673	7476	14	0	\N
286237	89	66530973005524	14673	7476	15	0	\N
286238	186	66530973005524	14673	7476	16	0	\N
286239	383	66530973005524	14673	7476	17	0	\N
286240	392	66530973005524	14673	7476	18	0	\N
286241	308	66530973005524	14673	7476	19	0	\N
286242	678	66530973005524	14673	7476	20	0	\N
286243	1874	4838000	14673	7476	21	0	\N
286244	1874	4841000	14673	7476	22	0	\N
286245	1874	4844000	14673	7476	23	0	\N
286246	1678	15840600275000	14674	7476	0	0	\N
286247	1678	15840600276000	14674	7476	1	0	\N
286248	1678	15840600277000	14674	7476	2	0	\N
286249	266	66530973005524	14674	7476	3	0	\N
286250	352	66530973005524	14674	7476	4	0	\N
286251	421	66530973005524	14674	7476	5	0	\N
286252	420	66530973005524	14674	7476	6	0	\N
286253	600	66530973005524	14674	7476	7	0	\N
286254	353	66530963005524	14674	7476	8	0	\N
286255	620	66530973005524	14674	7476	9	0	\N
286256	180	66530973005524	14674	7476	10	0	\N
286257	112	66187942005524	14674	7476	11	0	\N
286258	652	66530973005524	14674	7476	12	0	\N
286259	680	66530973005524	14674	7476	13	0	\N
286260	690	66530973005524	14674	7476	14	0	\N
286261	89	66530973005524	14674	7476	15	0	\N
286262	186	66530973005524	14674	7476	16	0	\N
286263	383	66530973005524	14674	7476	17	0	\N
286264	392	66530973005524	14674	7476	18	0	\N
286265	308	66530973005524	14674	7476	19	0	\N
286266	678	66530973005524	14674	7476	20	0	\N
286267	1874	4838000	14674	7476	21	0	\N
286268	1874	4841000	14674	7476	22	0	\N
286269	1874	4844000	14674	7476	23	0	\N
286270	1678	15840600275000	14675	7476	0	0	\N
286271	1678	15840600276000	14675	7476	1	0	\N
286272	1678	15840600277000	14675	7476	2	0	\N
286273	266	66530973005524	14675	7476	3	0	\N
286274	352	66530973005524	14675	7476	4	0	\N
286275	421	66530973005524	14675	7476	5	0	\N
286276	420	66530973005524	14675	7476	6	0	\N
286277	600	66530973005524	14675	7476	7	0	\N
286278	353	66530963005524	14675	7476	8	0	\N
286279	620	66530973005524	14675	7476	9	0	\N
286280	180	66530973005524	14675	7476	10	0	\N
286147	1874	4815000	14664	7470	2	0	1
286148	251	66530973005524	14665	7471	0	0	0
286149	1678	15840600268000	14665	7471	1	0	0
286150	35	19354464874293	14665	7471	2	0	0
286151	49	66530973005524	14665	7471	3	0	0
286153	1874	4817000	14665	7471	5	0	1
286154	1772	3796456950108	14666	7472	0	0	1
286155	1678	15840600269000	14666	7472	1	0	0
286156	663	66530973005524	14666	7472	2	0	0
286157	320	66249773005524	14666	7472	3	0	2
286159	710	5040225227645	14666	7472	5	0	0
286160	499	66530973005524	14666	7472	6	0	0
286161	1874	4820000	14666	7472	7	0	1
286162	217	66530973005524	14667	7473	0	0	0
286164	1678	15840600271000	14667	7473	2	0	0
286165	1678	15840600272000	14667	7473	3	0	0
286166	103	66530973005524	14667	7473	4	0	0
286167	1811	1448945930186	14667	7473	5	0	1
286168	893	309291320931713	14667	7473	6	0	0
286170	377	66530973005524	14667	7473	8	0	0
286171	560	66530973005524	14667	7473	9	0	0
286172	252	66530973005524	14667	7473	10	0	0
286173	894	309291320931713	14667	7473	11	0	0
286174	569	66530973005524	14667	7473	12	0	0
286176	108	66530973005524	14667	7473	14	0	0
286177	99	66530973005524	14667	7473	15	0	0
286178	570	66530973005524	14667	7473	16	0	0
286179	2073	529147915594	14667	7473	17	0	1
286181	397	66530973005524	14667	7473	19	0	0
286182	402	66530973005524	14667	7473	20	0	0
286183	1874	4823000	14667	7473	21	0	1
286184	1874	4826000	14667	7473	22	0	1
286185	1874	4829000	14667	7473	23	0	1
286195	275	66530973005524	14669	7474	1	0	0
286196	201	66530973005524	14669	7474	2	0	0
286197	1678	15840600273000	14669	7474	3	0	0
286198	1962	529885180751	14669	7474	4	0	1
286199	309	66530973005524	14669	7474	5	0	0
286210	1678	15840600274000	14671	7475	0	0	0
286211	361	66530973005524	14671	7475	1	0	0
286212	452	66530973005524	14671	7475	2	0	0
286213	594	66530973005524	14671	7475	3	0	0
286215	245	66530973005524	14671	7475	5	0	0
286216	191	66530973005524	14671	7475	6	0	0
286217	1874	4832000	14671	7475	7	0	1
286218	1874	4835000	14671	7475	8	0	1
286281	112	66187942005524	14675	7476	11	0	\N
286282	652	66530973005524	14675	7476	12	0	\N
286283	680	66530973005524	14675	7476	13	0	\N
286284	690	66530973005524	14675	7476	14	0	\N
286285	89	66530973005524	14675	7476	15	0	\N
286286	186	66530973005524	14675	7476	16	0	\N
286287	383	66530973005524	14675	7476	17	0	\N
286288	392	66530973005524	14675	7476	18	0	\N
286289	308	66530973005524	14675	7476	19	0	\N
286290	678	66530973005524	14675	7476	20	0	\N
286291	1874	4838000	14675	7476	21	0	\N
286292	1874	4841000	14675	7476	22	0	\N
286293	1874	4844000	14675	7476	23	0	\N
286294	1678	15840600275000	14676	7476	0	0	\N
286295	1678	15840600276000	14676	7476	1	0	\N
286296	1678	15840600277000	14676	7476	2	0	\N
286297	266	66530973005524	14676	7476	3	0	\N
286298	352	66530973005524	14676	7476	4	0	\N
286299	421	66530973005524	14676	7476	5	0	\N
286300	420	66530973005524	14676	7476	6	0	\N
286301	600	66530973005524	14676	7476	7	0	\N
286302	353	66530963005524	14676	7476	8	0	\N
286303	620	66530973005524	14676	7476	9	0	\N
286304	180	66530973005524	14676	7476	10	0	\N
286305	112	66187942005524	14676	7476	11	0	\N
286306	652	66530973005524	14676	7476	12	0	\N
286307	680	66530973005524	14676	7476	13	0	\N
286308	690	66530973005524	14676	7476	14	0	\N
286309	89	66530973005524	14676	7476	15	0	\N
286310	186	66530973005524	14676	7476	16	0	\N
286311	383	66530973005524	14676	7476	17	0	\N
286312	392	66530973005524	14676	7476	18	0	\N
286313	308	66530973005524	14676	7476	19	0	\N
286314	678	66530973005524	14676	7476	20	0	\N
286315	1874	4838000	14676	7476	21	0	\N
286316	1874	4841000	14676	7476	22	0	\N
286317	1874	4844000	14676	7476	23	0	\N
286382	251	66530973005524	14680	7441	0	0	\N
286383	35	19354464874293	14680	7441	1	0	\N
286384	49	66530973005524	14680	7441	2	0	\N
286385	1030	908221538475200	14680	7441	3	0	\N
286386	1772	3796456950108	14680	7441	4	0	\N
286387	663	66530973005524	14680	7441	5	0	\N
286388	320	66249773005524	14680	7441	6	0	\N
286389	54	66530973005524	14680	7441	7	0	\N
286390	710	5040225227645	14680	7441	8	0	\N
286391	499	66530973005524	14680	7441	9	0	\N
286392	217	66530973005524	14680	7441	10	0	\N
286393	103	66530973005524	14680	7441	11	0	\N
286394	1811	1448945930186	14680	7441	12	0	\N
286395	893	309291320931713	14680	7441	13	0	\N
286396	225	66530973005524	14680	7441	14	0	\N
286397	377	66530973005524	14680	7441	15	0	\N
286398	560	66530973005524	14680	7441	16	0	\N
286399	252	66530973005524	14680	7441	17	0	\N
286400	894	309291320931713	14680	7441	18	0	\N
286401	569	66530973005524	14680	7441	19	0	\N
286402	390	66530973005524	14680	7441	20	0	\N
286403	108	66530973005524	14680	7441	21	0	\N
286404	99	66530973005524	14680	7441	22	0	\N
286405	570	66530973005524	14680	7441	23	0	\N
286406	2073	529147915594	14680	7441	24	0	\N
286407	391	66530973005524	14680	7441	25	0	\N
286408	397	66530973005524	14680	7441	26	0	\N
286409	402	66530973005524	14680	7441	27	0	\N
286410	163	66530973005524	14680	7441	28	0	\N
286411	275	66530973005524	14680	7441	29	0	\N
286412	201	66530973005524	14680	7441	30	0	\N
286413	1962	529885180751	14680	7441	31	0	\N
286414	309	66530973005524	14680	7441	32	0	\N
286415	1678	15840600280000	14681	7478	0	0	\N
286416	1678	15840600281000	14681	7478	1	0	\N
286320	1678	15840600277000	14677	7476	2	0	0
286321	266	66530973005524	14677	7476	3	0	0
286322	352	66530973005524	14677	7476	4	0	0
286323	421	66530973005524	14677	7476	5	0	0
286324	420	66530973005524	14677	7476	6	0	0
286326	353	66530963005524	14677	7476	8	0	1
286327	620	66530973005524	14677	7476	9	0	0
286328	180	66530973005524	14677	7476	10	0	0
286329	112	66187942005524	14677	7476	11	0	4
286330	652	66530973005524	14677	7476	12	0	0
286332	690	66530973005524	14677	7476	14	0	0
286333	89	66530973005524	14677	7476	15	0	0
286334	186	66530973005524	14677	7476	16	0	0
286335	383	66530973005524	14677	7476	17	0	0
286337	308	66530973005524	14677	7476	19	0	0
286338	678	66530973005524	14677	7476	20	0	0
286339	1874	4838000	14677	7476	21	0	1
286340	1874	4841000	14677	7476	22	0	1
286341	1874	4844000	14677	7476	23	0	1
286343	1678	15840600278000	14678	7477	1	0	0
286344	731	2016090091005	14678	7477	2	0	0
286345	1150	612795169601792	14678	7477	3	0	0
286346	84	66530973005524	14678	7477	4	0	0
286347	520	66530973005524	14678	7477	5	0	0
286349	2017	529572339923	14678	7477	7	0	2
286350	63	66530973005524	14678	7477	8	0	0
286351	1678	15840600279000	14678	7477	9	0	0
286352	150	66530973005524	14678	7477	10	0	0
286354	322	66530973005524	14678	7477	13	0	0
286355	373	66530973005524	14678	7477	14	0	0
286356	1874	4847000	14678	7477	15	0	1
286357	1874	4850000	14678	7477	16	0	1
286358	1678	15840600280000	14679	7478	0	0	0
286360	1678	15840600282000	14679	7478	2	0	0
286361	450	66530973005524	14679	7478	3	0	0
286362	453	66530973005524	14679	7478	4	0	0
286363	593	66529972005524	14679	7478	5	0	1
286364	91	66530973005524	14679	7478	6	0	0
286366	438	66530973005524	14679	7478	8	0	0
286367	601	66530973005524	14679	7478	9	0	0
286368	745	2016090091005	14679	7478	10	0	0
286369	339	66530973005524	14679	7478	11	0	0
286371	1961	529885180751	14679	7478	13	0	1
286372	658	66530973005524	14679	7478	14	0	0
286373	205	66530973005524	14679	7478	15	0	0
286374	660	66530973005524	14679	7478	16	0	0
286375	78	66530973005524	14679	7478	17	0	0
286377	29	7056315318724	14679	7478	19	0	0
286378	910	506822478197568	14679	7478	20	0	0
286379	1874	4853000	14679	7478	21	0	1
286380	1874	4856000	14679	7478	22	0	1
286381	1874	4859000	14679	7478	23	0	1
286417	1678	15840600282000	14681	7478	2	0	\N
286418	450	66530973005524	14681	7478	3	0	\N
286419	453	66530973005524	14681	7478	4	0	\N
286420	593	66529972005524	14681	7478	5	0	\N
286421	91	66530973005524	14681	7478	6	0	\N
286422	408	66530973005524	14681	7478	7	0	\N
286423	438	66530973005524	14681	7478	8	0	\N
286424	601	66530973005524	14681	7478	9	0	\N
286425	745	2016090091005	14681	7478	10	0	\N
286426	339	66530973005524	14681	7478	11	0	\N
286427	504	66530973005524	14681	7478	12	0	\N
286428	1961	529885180751	14681	7478	13	0	\N
286429	658	66530973005524	14681	7478	14	0	\N
286430	205	66530973005524	14681	7478	15	0	\N
286431	660	66530973005524	14681	7478	16	0	\N
286432	78	66530973005524	14681	7478	17	0	\N
286433	395	66527943005524	14681	7478	18	0	\N
286434	29	7056315318724	14681	7478	19	0	\N
286435	910	506822478197568	14681	7478	20	0	\N
286436	1874	4853000	14681	7478	21	0	\N
286437	1874	4856000	14681	7478	22	0	\N
286438	1874	4859000	14681	7478	23	0	\N
286439	1678	15840600280000	14682	7478	0	0	\N
286440	1678	15840600281000	14682	7478	1	0	\N
286441	1678	15840600282000	14682	7478	2	0	\N
286442	450	66530973005524	14682	7478	3	0	\N
286443	453	66530973005524	14682	7478	4	0	\N
286444	593	66529972005524	14682	7478	5	0	\N
286445	91	66530973005524	14682	7478	6	0	\N
286446	408	66530973005524	14682	7478	7	0	\N
286447	438	66530973005524	14682	7478	8	0	\N
286448	601	66530973005524	14682	7478	9	0	\N
286449	745	2016090091005	14682	7478	10	0	\N
286450	339	66530973005524	14682	7478	11	0	\N
286451	504	66530973005524	14682	7478	12	0	\N
286452	1961	529885180751	14682	7478	13	0	\N
286453	658	66530973005524	14682	7478	14	0	\N
286454	205	66530973005524	14682	7478	15	0	\N
286455	660	66530973005524	14682	7478	16	0	\N
286456	78	66530973005524	14682	7478	17	0	\N
286457	395	66527943005524	14682	7478	18	0	\N
286458	29	7056315318724	14682	7478	19	0	\N
286459	910	506822478197568	14682	7478	20	0	\N
286460	1874	4853000	14682	7478	21	0	\N
286461	1874	4856000	14682	7478	22	0	\N
286462	1874	4859000	14682	7478	23	0	\N
286463	251	66530973005524	14683	7419	0	0	\N
286464	35	19354464874293	14683	7419	1	0	\N
286465	49	66530973005524	14683	7419	2	0	\N
286466	1030	908221538475200	14683	7419	3	0	\N
286467	1772	3796456950108	14683	7419	4	0	\N
286468	663	66530973005524	14683	7419	5	0	\N
286469	320	66249773005524	14683	7419	6	0	\N
286470	54	66530973005524	14683	7419	7	0	\N
286471	710	5040225227645	14683	7419	8	0	\N
286472	499	66530973005524	14683	7419	9	0	\N
286473	217	66530973005524	14683	7419	10	0	\N
286474	103	66530973005524	14683	7419	11	0	\N
286475	1811	1448945930186	14683	7419	12	0	\N
286476	893	309291320931713	14683	7419	13	0	\N
286477	225	66530973005524	14683	7419	14	0	\N
286478	377	66530973005524	14683	7419	15	0	\N
286479	560	66530973005524	14683	7419	16	0	\N
286480	252	66530973005524	14683	7419	17	0	\N
286481	894	309291320931713	14683	7419	18	0	\N
286482	569	66530973005524	14683	7419	19	0	\N
286483	390	66530973005524	14683	7419	20	0	\N
286484	108	66530973005524	14683	7419	21	0	\N
286485	99	66530973005524	14683	7419	22	0	\N
286486	570	66530973005524	14683	7419	23	0	\N
286487	2073	529147915594	14683	7419	24	0	\N
286488	391	66530973005524	14683	7419	25	0	\N
286489	397	66530973005524	14683	7419	26	0	\N
286490	402	66530973005524	14683	7419	27	0	\N
286491	163	66530973005524	14683	7419	28	0	\N
286492	275	66530973005524	14683	7419	29	0	\N
286502	138	66530973005524	14685	7479	0	0	\N
286503	1678	15840600283000	14685	7479	1	0	\N
286504	146	66530973005524	14685	7479	2	0	\N
286505	122	66530973005524	14685	7479	3	0	\N
286506	105	66530973005524	14685	7479	4	0	\N
286507	500	66530973005524	14685	7479	5	0	\N
286508	587	66530973005524	14685	7479	6	0	\N
286509	1950	7169852000000	14685	7479	7	0	\N
286510	1874	4862000	14685	7479	8	0	\N
286511	1678	15840600283000	14686	7479	0	0	\N
286512	1950	7169852000000	14686	7479	1	0	\N
286513	1874	4862000	14686	7479	2	0	\N
286514	1678	15840600284000	14687	7480	0	0	\N
286515	304	66530973005524	14687	7480	1	0	\N
286516	399	66530973005524	14687	7480	2	0	\N
286517	611	66530973005524	14687	7480	3	0	\N
286518	206	66530973005524	14687	7480	4	0	\N
286519	622	66533953005524	14687	7480	5	0	\N
286520	1874	4865000	14687	7480	6	0	\N
286528	1678	15840600285000	14689	7481	0	0	\N
286529	653	66530973005524	14689	7481	1	0	\N
286530	194	66530973005524	14689	7481	2	0	\N
286531	1276	1707608226803810	14689	7481	3	0	\N
286532	721	2016090091005	14689	7481	4	0	\N
286533	1874	4868000	14689	7481	5	0	\N
286540	1678	15840600285000	14691	7481	0	0	\N
286541	653	66530973005524	14691	7481	1	0	\N
286542	194	66530973005524	14691	7481	2	0	\N
286543	1276	1707608226803810	14691	7481	3	0	\N
286544	721	2016090091005	14691	7481	4	0	\N
286545	1874	4868000	14691	7481	5	0	\N
286546	1678	15840600286000	14692	7482	0	0	\N
286547	1874	4871000	14692	7482	1	0	\N
286550	1678	15840600287000	14694	7483	0	0	\N
286551	1678	15840600288000	14694	7483	1	0	\N
286552	1874	4874000	14694	7483	2	0	\N
286495	146	66530973005524	14684	7479	2	0	0
286496	122	66530973005524	14684	7479	3	0	0
286497	105	66530973005524	14684	7479	4	0	0
286498	500	66530973005524	14684	7479	5	0	0
286499	587	66530973005524	14684	7479	6	0	0
286501	1874	4862000	14684	7479	8	0	1
286521	1678	15840600284000	14688	7480	0	0	0
286522	304	66530973005524	14688	7480	1	0	0
286523	399	66530973005524	14688	7480	2	0	0
286524	611	66530973005524	14688	7480	3	0	0
286526	622	66533953005524	14688	7480	5	0	1
286527	1874	4865000	14688	7480	6	0	1
286534	1678	15840600285000	14690	7481	0	0	0
286535	653	66530973005524	14690	7481	1	0	0
286537	1276	1707608226803810	14690	7481	3	0	0
286538	721	2016090091005	14690	7481	4	0	0
286539	1874	4868000	14690	7481	5	0	1
286548	1678	15840600286000	14693	7482	0	0	0
286549	1874	4871000	14693	7482	1	0	1
286553	1874	4877000	14694	7483	3	0	\N
286558	1678	15840600289000	14696	7484	0	0	\N
286559	1874	4880000	14696	7484	1	0	\N
286564	1678	15840600290000	14699	7485	0	0	\N
286565	1874	4883000	14699	7485	1	0	\N
286566	251	66530973005524	14700	7230	0	0	\N
286567	35	19354464874293	14700	7230	1	0	\N
286568	49	66530973005524	14700	7230	2	0	\N
286569	1030	908221538475200	14700	7230	3	0	\N
286570	1772	3796456950108	14700	7230	4	0	\N
286571	663	66530973005524	14700	7230	5	0	\N
286572	320	66249773005524	14700	7230	6	0	\N
286573	54	66530973005524	14700	7230	7	0	\N
286574	710	5040225227645	14700	7230	8	0	\N
286575	499	66530973005524	14700	7230	9	0	\N
286576	217	66530973005524	14700	7230	10	0	\N
286577	103	66530973005524	14700	7230	11	0	\N
286578	1811	1448945930186	14700	7230	12	0	\N
286579	893	309291320931713	14700	7230	13	0	\N
286580	225	66530973005524	14700	7230	14	0	\N
286581	377	66530973005524	14700	7230	15	0	\N
286582	560	66530973005524	14700	7230	16	0	\N
286583	252	66530973005524	14700	7230	17	0	\N
286584	894	309291320931713	14700	7230	18	0	\N
286585	569	66530973005524	14700	7230	19	0	\N
286586	390	66530973005524	14700	7230	20	0	\N
286587	108	66530973005524	14700	7230	21	0	\N
286588	99	66530973005524	14700	7230	22	0	\N
286589	570	66530973005524	14700	7230	23	0	\N
286590	2073	529147915594	14700	7230	24	0	\N
286591	391	66530973005524	14700	7230	25	0	\N
286592	397	66530973005524	14700	7230	26	0	\N
286593	402	66530973005524	14700	7230	27	0	\N
286594	163	66530973005524	14700	7230	28	0	\N
286595	275	66530973005524	14700	7230	29	0	\N
286596	201	66530973005524	14700	7230	30	0	\N
286597	1962	529885180751	14700	7230	31	0	\N
286598	309	66530973005524	14700	7230	32	0	\N
286599	82	66530973005524	14700	7230	33	0	\N
286600	361	66530973005524	14700	7230	34	0	\N
286601	452	66530973005524	14700	7230	35	0	\N
286602	594	66530973005524	14700	7230	36	0	\N
286603	534	66530973005524	14700	7230	37	0	\N
286604	245	66530973005524	14700	7230	38	0	\N
286605	191	66530973005524	14700	7230	39	0	\N
286606	266	66530973005524	14700	7230	40	0	\N
286607	352	66530973005524	14700	7230	41	0	\N
286608	421	66530973005524	14700	7230	42	0	\N
286609	420	66530973005524	14700	7230	43	0	\N
286610	600	66530973005524	14700	7230	44	0	\N
286611	353	66530963005524	14700	7230	45	0	\N
286612	620	66530973005524	14700	7230	46	0	\N
286613	180	66530973005524	14700	7230	47	0	\N
286614	112	66187942005524	14700	7230	48	0	\N
286615	652	66530973005524	14700	7230	49	0	\N
286616	680	66530973005524	14700	7230	50	0	\N
286617	690	66530973005524	14700	7230	51	0	\N
286618	89	66530973005524	14700	7230	52	0	\N
286619	186	66530973005524	14700	7230	53	0	\N
286620	383	66530973005524	14700	7230	54	0	\N
286621	392	66530973005524	14700	7230	55	0	\N
286622	308	66530973005524	14700	7230	56	0	\N
286623	678	66530973005524	14700	7230	57	0	\N
286624	691	66530973005524	14700	7230	58	0	\N
286625	731	2016090091005	14700	7230	59	0	\N
286626	1150	612795169601792	14700	7230	60	0	\N
286627	84	66530973005524	14700	7230	61	0	\N
286628	520	66530973005524	14700	7230	62	0	\N
286629	551	66530973005524	14700	7230	63	0	\N
286630	2017	529572339923	14700	7230	64	0	\N
286631	63	66530973005524	14700	7230	65	0	\N
286632	150	66530973005524	14700	7230	66	0	\N
286633	92	66530973005524	14700	7230	67	0	\N
286634	1678	15840600291000	14701	7486	0	0	\N
286635	1678	15840600292000	14701	7486	1	0	\N
286636	1874	4886000	14701	7486	2	0	\N
286637	1874	4889000	14701	7486	3	0	\N
286638	1678	15840600291000	14702	7486	0	0	\N
286639	1678	15840600292000	14702	7486	1	0	\N
286640	1874	4886000	14702	7486	2	0	\N
286641	1874	4889000	14702	7486	3	0	\N
286648	1678	15840600294000	14705	7488	0	0	\N
286649	1874	4895000	14705	7488	1	0	\N
286652	1678	15840600294000	14707	7488	0	0	\N
286653	1874	4895000	14707	7488	1	0	\N
286665	1678	15840600297000	14710	7490	0	0	\N
286666	1678	15840600298000	14710	7490	1	0	\N
286667	1678	15840600299000	14710	7490	2	0	\N
286668	1874	4904000	14710	7490	3	0	\N
286669	1874	4907000	14710	7490	4	0	\N
286670	1874	4910000	14710	7490	5	0	\N
286671	2113	99000000000	14711	7419	0	0	\N
286672	1678	15840600202000	14711	7419	1	0	\N
286673	251	66530973005524	14711	7419	2	0	\N
286674	1678	15840600203000	14711	7419	3	0	\N
286675	1678	15840600204000	14711	7419	4	0	\N
286676	1678	15840600205000	14711	7419	5	0	\N
286677	1678	15840600206000	14711	7419	6	0	\N
286678	1678	15840600207000	14711	7419	7	0	\N
286679	1678	15840600208000	14711	7419	8	0	\N
286680	1678	15840600209000	14711	7419	9	0	\N
286681	1678	15840600210000	14711	7419	10	0	\N
286682	1678	15840600211000	14711	7419	11	0	\N
286683	35	19354464874293	14711	7419	12	0	\N
286684	49	66530973005524	14711	7419	13	0	\N
286685	1030	908221538475200	14711	7419	14	0	\N
286686	1772	3796456950108	14711	7419	15	0	\N
286687	1678	15840600212000	14711	7419	16	0	\N
286688	1678	15840600213000	14711	7419	17	0	\N
286556	1874	4874000	14695	7483	2	0	1
286557	1874	4877000	14695	7483	3	0	1
286560	1678	15840600289000	14697	7484	0	0	0
286561	1874	4880000	14697	7484	1	0	1
286562	1678	15840600290000	14698	7485	0	0	0
286642	1678	15840600291000	14703	7486	0	0	0
286643	1678	15840600292000	14703	7486	1	0	0
286644	1874	4886000	14703	7486	2	0	1
286645	1874	4889000	14703	7486	3	0	1
286646	1678	15840600293000	14704	7487	0	0	0
286650	1678	15840600294000	14706	7488	0	0	0
286651	1874	4895000	14706	7488	1	0	1
286654	1678	15840600295000	14708	7489	0	0	0
286655	1678	15840600296000	14708	7489	1	0	0
286657	1874	4898000	14708	7489	3	0	1
286658	1874	4901000	14708	7489	4	0	1
286659	1678	15840600297000	14709	7490	0	0	0
286660	1678	15840600298000	14709	7490	1	0	0
286661	1678	15840600299000	14709	7490	2	0	0
286663	1874	4907000	14709	7490	4	0	1
286664	1874	4910000	14709	7490	5	0	1
286689	1678	15840600214000	14711	7419	18	0	\N
286690	1678	15840600215000	14711	7419	19	0	\N
286691	1678	15840600216000	14711	7419	20	0	\N
286692	1678	15840600217000	14711	7419	21	0	\N
286693	1678	15840600218000	14711	7419	22	0	\N
286694	1678	15840600219000	14711	7419	24	0	\N
286695	1678	15840600220000	14711	7419	25	0	\N
286696	663	66530973005524	14711	7419	26	0	\N
286697	320	66249773005524	14711	7419	27	0	\N
286698	54	66530973005524	14711	7419	28	0	\N
286699	710	5040225227645	14711	7419	29	0	\N
286700	499	66530973005524	14711	7419	30	0	\N
286701	217	66530973005524	14711	7419	31	0	\N
286702	103	66530973005524	14711	7419	32	0	\N
286703	1811	1448945930186	14711	7419	33	0	\N
286704	893	309291320931713	14711	7419	34	0	\N
286705	225	66530973005524	14711	7419	35	0	\N
286706	377	66530973005524	14711	7419	36	0	\N
286707	560	66530973005524	14711	7419	37	0	\N
286708	252	66530973005524	14711	7419	38	0	\N
286709	894	309291320931713	14711	7419	39	0	\N
286710	569	66530973005524	14711	7419	40	0	\N
286711	390	66530973005524	14711	7419	41	0	\N
286712	108	66530973005524	14711	7419	42	0	\N
286713	99	66530973005524	14711	7419	43	0	\N
286714	570	66530973005524	14711	7419	44	0	\N
286715	2073	529147915594	14711	7419	45	0	\N
286716	391	66530973005524	14711	7419	46	0	\N
286717	397	66530973005524	14711	7419	47	0	\N
286718	402	66530973005524	14711	7419	48	0	\N
286719	163	66530973005524	14711	7419	49	0	\N
286720	275	66530973005524	14711	7419	50	0	\N
286721	201	66530973005524	14711	7419	51	0	\N
286722	1962	529885180751	14711	7419	52	0	\N
286723	309	66530973005524	14711	7419	53	0	\N
286724	82	66530973005524	14711	7419	54	0	\N
286725	361	66530973005524	14711	7419	55	0	\N
286726	452	66530973005524	14711	7419	56	0	\N
286727	594	66530973005524	14711	7419	57	0	\N
286728	534	66530973005524	14711	7419	58	0	\N
286729	245	66530973005524	14711	7419	59	0	\N
286730	191	66530973005524	14711	7419	60	0	\N
286731	266	66530973005524	14711	7419	61	0	\N
286732	352	66530973005524	14711	7419	62	0	\N
286733	421	66530973005524	14711	7419	63	0	\N
286734	420	66530973005524	14711	7419	64	0	\N
286735	600	66530973005524	14711	7419	65	0	\N
286736	353	66530963005524	14711	7419	66	0	\N
286737	620	66530973005524	14711	7419	67	0	\N
286738	180	66530973005524	14711	7419	68	0	\N
286739	112	66187942005524	14711	7419	69	0	\N
286740	652	66530973005524	14711	7419	70	0	\N
286741	680	66530973005524	14711	7419	71	0	\N
286742	690	66530973005524	14711	7419	72	0	\N
286743	89	66530973005524	14711	7419	73	0	\N
286744	186	66530973005524	14711	7419	74	0	\N
286745	383	66530973005524	14711	7419	75	0	\N
286746	392	66530973005524	14711	7419	76	0	\N
286747	308	66530973005524	14711	7419	77	0	\N
286748	678	66530973005524	14711	7419	78	0	\N
286749	691	66530973005524	14711	7419	79	0	\N
286750	731	2016090091005	14711	7419	80	0	\N
286751	1150	612795169601792	14711	7419	81	0	\N
286752	84	66530973005524	14711	7419	82	0	\N
286753	520	66530973005524	14711	7419	83	0	\N
286754	551	66530973005524	14711	7419	84	0	\N
286755	2017	529572339923	14711	7419	85	0	\N
286756	63	66530973005524	14711	7419	86	0	\N
286757	150	66530973005524	14711	7419	87	0	\N
286758	92	66530973005524	14711	7419	88	0	\N
286759	322	66530973005524	14711	7419	89	0	\N
286760	373	66530973005524	14711	7419	90	0	\N
286761	450	66530973005524	14711	7419	91	0	\N
286762	453	66530973005524	14711	7419	92	0	\N
286763	593	66529972005524	14711	7419	93	0	\N
286764	91	66530973005524	14711	7419	94	0	\N
286765	408	66530973005524	14711	7419	95	0	\N
286766	438	66530973005524	14711	7419	96	0	\N
286767	601	66530973005524	14711	7419	97	0	\N
286768	745	2016090091005	14711	7419	98	0	\N
286769	339	66530973005524	14711	7419	99	0	\N
286770	504	66530973005524	14711	7419	100	0	\N
286771	1961	529885180751	14711	7419	101	0	\N
286772	658	66530973005524	14711	7419	102	0	\N
286773	205	66530973005524	14711	7419	103	0	\N
286774	660	66530973005524	14711	7419	104	0	\N
286775	78	66530973005524	14711	7419	105	0	\N
286776	395	66527943005524	14711	7419	106	0	\N
286777	29	7056315318724	14711	7419	107	0	\N
286778	910	506822478197568	14711	7419	108	0	\N
286779	138	66530973005524	14711	7419	109	0	\N
286780	146	66530973005524	14711	7419	110	0	\N
286781	122	66530973005524	14711	7419	111	0	\N
286782	105	66530973005524	14711	7419	112	0	\N
286783	500	66530973005524	14711	7419	113	0	\N
286784	587	66530973005524	14711	7419	114	0	\N
286785	304	66530973005524	14711	7419	115	0	\N
286786	399	66530973005524	14711	7419	116	0	\N
286787	611	66530973005524	14711	7419	117	0	\N
286788	206	66530973005524	14711	7419	118	0	\N
286789	622	66533953005524	14711	7419	119	0	\N
286790	653	66530973005524	14711	7419	120	0	\N
286791	194	66530973005524	14711	7419	121	0	\N
286792	1276	1707608226803810	14711	7419	122	0	\N
286793	721	2016090091005	14711	7419	123	0	\N
286794	1678	15840600221000	14711	7419	124	0	\N
286795	1678	15840600222000	14711	7419	125	0	\N
286796	2113	99000000000	14712	7290	0	0	\N
286797	251	66530973005524	14712	7290	1	0	\N
286798	35	19354464874293	14712	7290	2	0	\N
286799	49	66530973005524	14712	7290	3	0	\N
286800	1030	908221538475200	14712	7290	4	0	\N
286801	1772	3796456950108	14712	7290	5	0	\N
286802	663	66530973005524	14712	7290	6	0	\N
286803	320	66249773005524	14712	7290	7	0	\N
286804	54	66530973005524	14712	7290	8	0	\N
286805	710	5040225227645	14712	7290	9	0	\N
286806	499	66530973005524	14712	7290	10	0	\N
286807	217	66530973005524	14712	7290	11	0	\N
286808	103	66530973005524	14712	7290	12	0	\N
286809	1811	1448945930186	14712	7290	13	0	\N
286810	893	309291320931713	14712	7290	14	0	\N
286811	225	66530973005524	14712	7290	15	0	\N
286812	377	66530973005524	14712	7290	16	0	\N
286813	560	66530973005524	14712	7290	17	0	\N
286814	252	66530973005524	14712	7290	18	0	\N
286815	894	309291320931713	14712	7290	19	0	\N
286816	569	66530973005524	14712	7290	20	0	\N
286817	390	66530973005524	14712	7290	21	0	\N
286818	108	66530973005524	14712	7290	22	0	\N
286819	99	66530973005524	14712	7290	23	0	\N
286820	570	66530973005524	14712	7290	24	0	\N
286821	2073	529147915594	14712	7290	25	0	\N
286822	391	66530973005524	14712	7290	26	0	\N
286823	397	66530973005524	14712	7290	27	0	\N
286824	402	66530973005524	14712	7290	28	0	\N
286825	163	66530973005524	14712	7290	29	0	\N
286826	275	66530973005524	14712	7290	30	0	\N
286827	201	66530973005524	14712	7290	31	0	\N
286828	1962	529885180751	14712	7290	32	0	\N
286829	309	66530973005524	14712	7290	33	0	\N
286830	82	66530973005524	14712	7290	34	0	\N
286831	361	66530973005524	14712	7290	35	0	\N
286842	1678	15840600300000	14715	7491	0	0	\N
286843	1678	15840600301000	14715	7491	1	0	\N
286844	1678	15840600302000	14715	7491	2	0	\N
286845	1678	15840600303000	14715	7491	3	0	\N
286846	1678	15840600304000	14715	7491	4	0	\N
286847	1874	4913000	14715	7491	5	0	\N
286848	1874	4916000	14715	7491	6	0	\N
286849	1874	4919000	14715	7491	7	0	\N
286850	1874	4922000	14715	7491	8	0	\N
286851	1874	4925000	14715	7491	9	0	\N
286854	1678	15840600306000	14717	7493	0	0	\N
286855	1874	4931000	14717	7493	1	0	\N
286867	1678	15840600311000	14723	7497	0	0	\N
286868	1874	4943000	14723	7497	1	0	\N
286869	1678	15840600311000	14724	7497	0	0	\N
286870	1874	4943000	14724	7497	1	0	\N
286871	1678	15840600311000	14725	7497	0	0	\N
286872	1874	4943000	14725	7497	1	0	\N
286873	1678	15840600312000	14726	7498	0	0	\N
286874	1678	15840600313000	14726	7498	1	0	\N
286875	1874	4946000	14726	7498	2	0	\N
286876	1874	4949000	14726	7498	3	0	\N
286877	1678	15840600312000	14727	7498	0	0	\N
286878	1678	15840600313000	14727	7498	1	0	\N
286879	1874	4946000	14727	7498	2	0	\N
286880	1874	4949000	14727	7498	3	0	\N
286887	1678	15840600314000	14730	7499	0	0	\N
286888	1874	4952000	14730	7499	1	0	\N
286889	1678	15840600315000	14731	7500	0	0	\N
286890	1678	15840600316000	14731	7500	1	0	\N
286891	1678	15840600317000	14731	7500	2	0	\N
286892	1678	15840600318000	14731	7500	3	0	\N
286893	1874	4955000	14731	7500	4	0	\N
286894	1874	4958000	14731	7500	5	0	\N
286895	1874	4961000	14731	7500	6	0	\N
286896	1874	4964000	14731	7500	7	0	\N
286905	1678	15840600315000	14733	7500	0	0	\N
286906	1678	15840600316000	14733	7500	1	0	\N
286907	1678	15840600317000	14733	7500	2	0	\N
286908	1678	15840600318000	14733	7500	3	0	\N
286909	1874	4955000	14733	7500	4	0	\N
286910	1874	4958000	14733	7500	5	0	\N
286911	1874	4961000	14733	7500	6	0	\N
286912	1874	4964000	14733	7500	7	0	\N
286921	1678	15840600323000	14737	7502	0	0	\N
286922	1874	4979000	14737	7502	1	0	\N
286927	1678	15840600324000	14740	7503	0	0	\N
286928	1874	4982000	14740	7503	1	0	\N
286933	1678	15840600325000	14742	7504	0	0	\N
286934	1678	15840600326000	14742	7504	1	0	\N
286935	1874	4985000	14742	7504	2	0	\N
286936	1874	4988000	14742	7504	3	0	\N
286937	1678	15840600325000	14743	7504	0	0	\N
286938	1678	15840600326000	14743	7504	1	0	\N
286939	1874	4985000	14743	7504	2	0	\N
286940	1874	4988000	14743	7504	3	0	\N
286943	2113	99000000000	14745	7253	0	0	\N
286944	251	66530973005524	14745	7253	1	0	\N
286945	35	19354464874293	14745	7253	2	0	\N
286946	49	66530973005524	14745	7253	3	0	\N
286947	1030	908221538475200	14745	7253	4	0	\N
286948	1772	3796456950108	14745	7253	5	0	\N
286949	663	66530973005524	14745	7253	6	0	\N
286950	320	66249773005524	14745	7253	7	0	\N
286951	54	66530973005524	14745	7253	8	0	\N
286952	710	5040225227645	14745	7253	9	0	\N
286953	499	66530973005524	14745	7253	10	0	\N
286954	217	66530973005524	14745	7253	11	0	\N
286955	103	66530973005524	14745	7253	12	0	\N
286956	1811	1448945930186	14745	7253	13	0	\N
286957	893	309291320931713	14745	7253	14	0	\N
286958	225	66530973005524	14745	7253	15	0	\N
286959	377	66530973005524	14745	7253	16	0	\N
286960	560	66530973005524	14745	7253	17	0	\N
286834	1678	15840600302000	14714	7491	2	0	0
286835	1678	15840600303000	14714	7491	3	0	0
286836	1678	15840600304000	14714	7491	4	0	0
286837	1874	4913000	14714	7491	5	0	1
286838	1874	4916000	14714	7491	6	0	1
286840	1874	4922000	14714	7491	8	0	1
286841	1874	4925000	14714	7491	9	0	1
286852	1678	15840600305000	14716	7492	0	0	0
286853	1874	4928000	14716	7492	1	0	1
286856	1678	15840600306000	14718	7493	0	0	0
286858	1678	15840600307000	14719	7494	0	0	0
286859	1874	4934000	14719	7494	1	0	1
286860	1678	15840600308000	14720	7495	0	0	0
286861	1678	15840600309000	14720	7495	1	0	0
286863	1874	4940000	14720	7495	3	0	1
286864	1678	15840600310000	14721	7496	0	0	0
286865	1678	15840600311000	14722	7497	0	0	0
286866	1874	4943000	14722	7497	1	0	1
286881	1678	15840600312000	14728	7498	0	0	0
286883	1874	4946000	14728	7498	2	0	1
286884	1874	4949000	14728	7498	3	0	1
286885	1678	15840600314000	14729	7499	0	0	0
286886	1874	4952000	14729	7499	1	0	1
286897	1678	15840600315000	14732	7500	0	0	0
286899	1678	15840600317000	14732	7500	2	0	0
286900	1678	15840600318000	14732	7500	3	0	0
286901	1874	4955000	14732	7500	4	0	1
286902	1874	4958000	14732	7500	5	0	1
286904	1874	4964000	14732	7500	7	0	1
286913	1678	15840600319000	14736	7501	0	0	0
286914	1678	15840600320000	14736	7501	1	0	0
286915	1678	15840600321000	14736	7501	2	0	0
286916	1678	15840600322000	14736	7501	3	0	0
286918	1874	4970000	14736	7501	5	0	1
286919	1874	4973000	14736	7501	6	0	1
286920	1874	4976000	14736	7501	7	0	1
286923	1678	15840600323000	14738	7502	0	0	0
286924	1874	4979000	14738	7502	1	0	1
286926	1874	4982000	14739	7503	1	0	1
286929	1678	15840600325000	14741	7504	0	0	0
286930	1678	15840600326000	14741	7504	1	0	0
286931	1874	4985000	14741	7504	2	0	1
286941	1678	15840600327000	14744	7505	0	0	0
286942	1874	4991000	14744	7505	1	0	1
286961	252	66530973005524	14745	7253	18	0	\N
286962	894	309291320931713	14745	7253	19	0	\N
286963	569	66530973005524	14745	7253	20	0	\N
286964	390	66530973005524	14745	7253	21	0	\N
286965	108	66530973005524	14745	7253	22	0	\N
286966	99	66530973005524	14745	7253	23	0	\N
286967	570	66530973005524	14745	7253	24	0	\N
286968	2073	529147915594	14745	7253	25	0	\N
286969	391	66530973005524	14745	7253	26	0	\N
286970	397	66530973005524	14745	7253	27	0	\N
286971	402	66530973005524	14745	7253	28	0	\N
286972	163	66530973005524	14745	7253	29	0	\N
286973	275	66530973005524	14745	7253	30	0	\N
286974	201	66530973005524	14745	7253	31	0	\N
286975	1962	529885180751	14745	7253	32	0	\N
286976	309	66530973005524	14745	7253	33	0	\N
286977	82	66530973005524	14745	7253	34	0	\N
286978	361	66530973005524	14745	7253	35	0	\N
286979	452	66530973005524	14745	7253	36	0	\N
286980	594	66530973005524	14745	7253	37	0	\N
286981	534	66530973005524	14745	7253	38	0	\N
286982	245	66530973005524	14745	7253	39	0	\N
286983	191	66530973005524	14745	7253	40	0	\N
286984	266	66530973005524	14745	7253	41	0	\N
286985	352	66530973005524	14745	7253	42	0	\N
286986	421	66530973005524	14745	7253	43	0	\N
286987	420	66530973005524	14745	7253	44	0	\N
286988	600	66530973005524	14745	7253	46	0	\N
286989	353	66530963005524	14745	7253	47	0	\N
286990	620	66530973005524	14745	7253	48	0	\N
286991	180	66530973005524	14745	7253	49	0	\N
286992	112	66187942005524	14745	7253	50	0	\N
286993	652	66530973005524	14745	7253	51	0	\N
286994	680	66530973005524	14745	7253	52	0	\N
286995	690	66530973005524	14745	7253	53	0	\N
286996	89	66530973005524	14745	7253	54	0	\N
286997	186	66530973005524	14745	7253	55	0	\N
286998	383	66530973005524	14745	7253	56	0	\N
286999	392	66530973005524	14745	7253	57	0	\N
287000	308	66530973005524	14745	7253	58	0	\N
287001	678	66530973005524	14745	7253	59	0	\N
287002	691	66530973005524	14745	7253	60	0	\N
287003	731	2016090091005	14745	7253	61	0	\N
287004	1150	612795169601792	14745	7253	62	0	\N
287005	84	66530973005524	14745	7253	63	0	\N
287006	520	66530973005524	14745	7253	64	0	\N
287007	551	66530973005524	14745	7253	65	0	\N
287008	2017	529572339923	14745	7253	66	0	\N
287009	63	66530973005524	14745	7253	67	0	\N
287010	150	66530973005524	14745	7253	68	0	\N
287011	92	66530973005524	14745	7253	69	0	\N
287012	322	66530973005524	14745	7253	70	0	\N
287013	373	66530973005524	14745	7253	71	0	\N
287014	450	66530973005524	14745	7253	72	0	\N
287015	453	66530973005524	14745	7253	73	0	\N
287016	593	66529972005524	14745	7253	74	0	\N
287017	91	66530973005524	14745	7253	75	0	\N
287018	408	66530973005524	14745	7253	76	0	\N
287019	438	66530973005524	14745	7253	77	0	\N
287020	601	66530973005524	14745	7253	78	0	\N
287021	745	2016090091005	14745	7253	79	0	\N
287022	339	66530973005524	14745	7253	80	0	\N
287023	504	66530973005524	14745	7253	81	0	\N
287024	1961	529885180751	14745	7253	82	0	\N
287025	658	66530973005524	14745	7253	83	0	\N
287026	205	66530973005524	14745	7253	84	0	\N
287027	660	66530973005524	14745	7253	85	0	\N
287028	78	66530973005524	14745	7253	86	0	\N
287029	395	66527943005524	14745	7253	87	0	\N
287030	29	7056315318724	14745	7253	88	0	\N
287031	910	506822478197568	14745	7253	89	0	\N
287032	138	66530973005524	14745	7253	90	0	\N
287033	146	66530973005524	14745	7253	91	0	\N
287034	122	66530973005524	14745	7253	92	0	\N
287035	105	66530973005524	14745	7253	93	0	\N
287036	500	66530973005524	14745	7253	94	0	\N
287037	587	66530973005524	14745	7253	95	0	\N
287038	304	66530973005524	14745	7253	96	0	\N
287039	399	66530973005524	14745	7253	97	0	\N
287040	611	66530973005524	14745	7253	98	0	\N
287041	206	66530973005524	14745	7253	99	0	\N
287042	622	66533953005524	14745	7253	100	0	\N
287053	1678	15840600333000	14750	7510	0	0	\N
287054	1874	5009000	14750	7510	1	0	\N
287061	1678	15840600336000	14754	7513	0	0	\N
287062	1874	5018000	14754	7513	1	0	\N
287067	1874	5024000	14757	7515	0	0	\N
287073	1678	15840600340000	14761	7518	0	0	\N
287074	1874	5033000	14761	7518	1	0	\N
287083	1678	15840600341000	14764	7519	0	0	\N
287084	1678	15840600342000	14764	7519	1	0	\N
287085	1678	15840600343000	14764	7519	2	0	\N
287086	1874	5036000	14764	7519	3	0	\N
287087	1874	5039000	14764	7519	4	0	\N
287088	1874	5042000	14764	7519	5	0	\N
287089	1678	15840600344000	14765	7520	0	0	\N
287090	1678	15840600345000	14765	7520	2	0	\N
287091	1874	5045000	14765	7520	3	0	\N
287092	1874	5048000	14765	7520	4	0	\N
287045	1678	15840600329000	14747	7507	0	0	0
287046	1678	15840600330000	14747	7507	1	0	0
287047	1874	4997000	14747	7507	2	0	1
287048	1874	5000000	14747	7507	3	0	1
287049	1678	15840600331000	14748	7508	0	0	0
287051	1678	15840600332000	14749	7509	0	0	0
287052	1874	5006000	14749	7509	1	0	1
287055	1678	15840600333000	14751	7510	0	0	0
287056	1874	5009000	14751	7510	1	0	1
287057	1678	15840600334000	14752	7511	0	0	0
287059	1678	15840600335000	14753	7512	0	0	0
287060	1874	5015000	14753	7512	1	0	1
287063	1678	15840600336000	14755	7513	0	0	0
287064	1874	5018000	14755	7513	1	0	1
287066	1874	5021000	14756	7514	1	0	1
287068	1874	5024000	14758	7515	0	0	1
287069	1678	15840600338000	14759	7516	0	0	0
287070	1874	5027000	14759	7516	1	0	1
287071	1678	15840600339000	14760	7517	0	0	0
287075	1678	15840600340000	14762	7518	0	0	0
287076	1874	5033000	14762	7518	1	0	1
287077	1678	15840600341000	14763	7519	0	0	0
287078	1678	15840600342000	14763	7519	1	0	0
287079	1678	15840600343000	14763	7519	2	0	0
287081	1874	5039000	14763	7519	4	0	1
287082	1874	5042000	14763	7519	5	0	1
287093	1678	15840600344000	14766	7520	0	0	0
287094	1678	15840600345000	14766	7520	2	0	0
287096	1874	5048000	14766	7520	4	0	1
287097	1678	15840600346000	14767	7521	0	0	\N
287098	1874	5051000	14767	7521	1	0	\N
287101	1678	15840600346000	14769	7521	0	0	\N
287102	1874	5051000	14769	7521	1	0	\N
287111	1678	15840600351000	14777	7525	0	0	\N
287112	1678	15840600352000	14777	7525	1	0	\N
287113	1678	15840600353000	14777	7525	2	0	\N
287114	1874	5066000	14777	7525	3	0	\N
287115	1874	5069000	14777	7525	4	0	\N
287116	1874	5072000	14777	7525	5	0	\N
287123	1678	15840600354000	14779	7526	0	0	\N
287124	1874	5075000	14779	7526	1	0	\N
287135	1678	15840600357000	14785	7529	0	0	\N
287136	1678	15840600358000	14785	7529	1	0	\N
287137	1874	5084000	14785	7529	2	0	\N
287138	1874	5087000	14785	7529	3	0	\N
287141	1678	15840600359000	14787	7530	0	0	\N
287142	1874	5090000	14787	7530	1	0	\N
287163	1678	15840600370000	14796	7538	0	0	\N
287164	532	68880037000000	14796	7538	1	0	\N
287165	1874	5123000	14796	7538	2	0	\N
287171	1678	15840600372000	14799	7540	0	0	\N
287172	1874	5129000	14799	7540	1	0	\N
287184	1678	15840600377000	14803	7543	0	0	\N
287185	1874	5144000	14803	7543	1	0	\N
287188	1678	15840600378000	14805	7544	0	0	\N
287189	2085	1100980000000	14805	7544	1	0	\N
287190	1874	5147000	14805	7544	2	0	\N
287191	1678	15840600378000	14806	7544	0	0	\N
287192	2085	1100980000000	14806	7544	1	0	\N
287196	2085	1100980000000	14808	7544	0	0	\N
287200	1483	10000000	14811	7547	0	0	\N
287201	1678	15840600380000	14811	7547	1	0	\N
287211	1483	10000000	14813	7547	0	0	\N
287212	1678	15840600380000	14813	7547	1	0	\N
287213	1678	15840600381000	14813	7547	2	0	\N
287214	1678	15840600382000	14813	7547	3	0	\N
287215	1678	15840600383000	14813	7547	4	0	\N
287216	1874	5153000	14813	7547	5	0	\N
287217	1874	5156000	14813	7547	6	0	\N
287218	1874	5159000	14813	7547	7	0	\N
287219	1874	5162000	14813	7547	8	0	\N
287103	1678	15840600347000	14770	7522	0	0	0
287104	1678	15840600348000	14770	7522	1	0	0
287105	1874	5054000	14770	7522	2	0	1
287106	1874	5057000	14770	7522	3	0	1
287107	1678	15840600349000	14771	7523	0	0	0
287109	1678	15840600350000	14772	7524	0	0	0
287110	1874	5063000	14772	7524	1	0	1
287117	1678	15840600351000	14778	7525	0	0	0
287118	1678	15840600352000	14778	7525	1	0	0
287119	1678	15840600353000	14778	7525	2	0	0
287121	1874	5069000	14778	7525	4	0	1
287122	1874	5072000	14778	7525	5	0	1
287125	1678	15840600354000	14781	7526	0	0	0
287126	1874	5075000	14781	7526	1	0	1
287128	1874	5078000	14782	7527	1	0	1
287129	1678	15840600356000	14783	7528	0	0	0
287130	1874	5081000	14783	7528	1	0	1
287131	1678	15840600357000	14784	7529	0	0	0
287132	1678	15840600358000	14784	7529	1	0	0
287134	1874	5087000	14784	7529	3	0	1
287139	1678	15840600359000	14786	7530	0	0	0
287140	1874	5090000	14786	7530	1	0	1
287143	1678	15840600360000	14788	7531	0	0	0
287144	1874	5093000	14788	7531	1	0	1
287146	1678	15840600362000	14789	7532	1	0	0
287147	1874	5096000	14789	7532	2	0	1
287148	1874	5099000	14789	7532	3	0	1
287149	1678	15840600363000	14790	7533	0	0	0
287151	1678	15840600364000	14791	7534	0	0	0
287152	1874	5105000	14791	7534	1	0	1
287153	1678	15840600365000	14792	7535	0	0	0
287154	1874	5108000	14792	7535	1	0	1
287155	1678	15840600366000	14793	7536	0	0	0
287157	1678	15840600368000	14793	7536	2	0	0
287158	1874	5111000	14793	7536	3	0	1
287159	1874	5114000	14793	7536	4	0	1
287160	1874	5117000	14793	7536	5	0	1
287161	1678	15840600369000	14795	7537	0	0	0
287166	1678	15840600370000	14797	7538	0	0	0
287167	532	68880037000000	14797	7538	1	0	0
287168	1874	5123000	14797	7538	2	0	1
287169	1678	15840600371000	14798	7539	0	0	0
287173	1678	15840600372000	14800	7540	0	0	0
287174	1874	5129000	14800	7540	1	0	1
287175	1678	15840600373000	14801	7541	0	0	0
287176	1678	15840600374000	14801	7541	1	0	0
287177	1874	5132000	14801	7541	2	0	1
287179	1678	15840600375000	14802	7542	0	0	0
287180	1678	15840600376000	14802	7542	1	0	0
287181	606	72137736812962	14802	7542	2	0	11
287182	1874	5138000	14802	7542	3	0	1
287183	1874	5141000	14802	7542	4	0	1
287187	1874	5144000	14804	7543	1	0	1
287193	1678	15840600378000	14807	7544	0	0	0
287194	2085	1100980000000	14807	7544	1	0	1
287195	1874	5147000	14807	7544	2	0	1
287198	1745	1803000000	14809	7545	1	0	5
287199	1874	5150000	14809	7545	2	0	1
287202	1483	10000000	14812	7547	0	0	0
287203	1678	15840600380000	14812	7547	1	0	0
287204	1678	15840600381000	14812	7547	2	0	0
287206	1678	15840600383000	14812	7547	4	0	0
287207	1874	5153000	14812	7547	5	0	1
287208	1874	5156000	14812	7547	6	0	1
287209	1874	5159000	14812	7547	7	0	1
287210	1874	5162000	14812	7547	8	0	1
287221	1874	5165000	14814	7548	1	0	1
287222	1678	15840600385000	14815	7549	0	0	0
287223	1874	5168000	14815	7549	1	0	1
287224	1678	15840600386000	14816	7550	0	0	0
287226	1678	15840600387000	14817	7551	0	0	0
287227	1874	5174000	14817	7551	1	0	1
287228	1678	15840600388000	14818	7552	0	0	0
287229	1678	15840600389000	14818	7552	1	0	0
287230	1874	5177000	14818	7552	2	0	1
287232	1678	15840600390000	14819	7553	0	0	0
287234	1678	15840600391000	14820	7554	0	0	\N
287235	1874	5186000	14820	7554	1	0	\N
287240	1874	5189000	14823	7555	0	0	\N
287245	1678	15840600393000	14825	7556	0	0	\N
287246	1678	15840600394000	14825	7556	1	0	\N
287247	1874	5192000	14825	7556	2	0	\N
287248	1874	5195000	14825	7556	3	0	\N
287261	1678	15840600399000	14829	7559	0	0	\N
287262	1678	15840600400000	14829	7559	1	0	\N
287263	1874	5210000	14829	7559	2	0	\N
287264	1874	5213000	14829	7559	3	0	\N
287265	1678	15840600399000	14830	7559	0	0	\N
287266	1678	15840600400000	14830	7559	1	0	\N
287267	1874	5210000	14830	7559	2	0	\N
287268	1874	5213000	14830	7559	3	0	\N
287269	606	72137736812962	14831	7523	0	0	\N
287270	1483	10000000	14831	7523	1	0	\N
287271	2085	1100970000000	14831	7523	2	0	\N
287272	532	68880037000000	14831	7523	3	0	\N
287273	1874	5060000	14831	7523	4	0	\N
287274	1874	5063000	14831	7523	5	0	\N
287275	1874	5066000	14831	7523	6	0	\N
287276	1874	5069000	14831	7523	7	0	\N
287277	1745	1803000000	14831	7523	8	0	\N
287278	1874	5072000	14831	7523	9	0	\N
287279	1874	5075000	14831	7523	10	0	\N
287280	1874	5078000	14831	7523	11	0	\N
287281	1874	5081000	14831	7523	12	0	\N
287282	1874	5084000	14831	7523	13	0	\N
287283	1874	5087000	14831	7523	14	0	\N
287284	1874	5090000	14831	7523	15	0	\N
287285	1874	5093000	14831	7523	16	0	\N
287286	1874	5096000	14831	7523	17	0	\N
287287	1874	5099000	14831	7523	18	0	\N
287288	1874	5102000	14831	7523	19	0	\N
287289	1874	5105000	14831	7523	20	0	\N
287290	1874	5108000	14831	7523	21	0	\N
287291	1874	5111000	14831	7523	22	0	\N
287292	1874	5114000	14831	7523	23	0	\N
287293	1874	5117000	14831	7523	24	0	\N
287294	1874	5120000	14831	7523	25	0	\N
287295	1874	5123000	14831	7523	26	0	\N
287296	1874	5126000	14831	7523	27	0	\N
287297	1874	5129000	14831	7523	28	0	\N
287298	1874	5132000	14831	7523	29	0	\N
287299	1874	5135000	14831	7523	30	0	\N
287300	1874	5138000	14831	7523	31	0	\N
287301	1874	5141000	14831	7523	32	0	\N
287302	1874	5144000	14831	7523	33	0	\N
287303	1874	5147000	14831	7523	34	0	\N
287304	1874	5150000	14831	7523	35	0	\N
287305	1874	5153000	14831	7523	36	0	\N
287306	1874	5156000	14831	7523	37	0	\N
287307	1874	5159000	14831	7523	38	0	\N
287308	1874	5162000	14831	7523	39	0	\N
287309	1874	5165000	14831	7523	40	0	\N
287310	1874	5168000	14831	7523	41	0	\N
287311	1874	5171000	14831	7523	42	0	\N
287312	1874	5174000	14831	7523	43	0	\N
287313	1874	5177000	14831	7523	44	0	\N
287314	1874	5180000	14831	7523	45	0	\N
287315	1874	5183000	14831	7523	46	0	\N
287316	1874	5186000	14831	7523	47	0	\N
287317	1874	5189000	14831	7523	48	0	\N
287318	1874	5192000	14831	7523	49	0	\N
287319	1874	5195000	14831	7523	50	0	\N
287320	1874	5198000	14831	7523	51	0	\N
287321	1874	5201000	14831	7523	52	0	\N
287322	1874	5204000	14831	7523	53	0	\N
287323	1874	5207000	14831	7523	54	0	\N
287324	1874	5210000	14831	7523	55	0	\N
287325	1874	5213000	14831	7523	56	0	\N
287326	1874	5216000	14831	7523	57	0	\N
287327	1678	15840600401000	14832	7560	0	0	\N
287328	1874	5216000	14832	7560	1	0	\N
287331	1678	15840600401000	14835	7560	0	0	\N
287332	1874	5216000	14835	7560	1	0	\N
287345	1678	15840600404000	14839	7563	0	0	\N
287346	1678	15840600405000	14839	7563	1	0	\N
287347	1678	15840600406000	14839	7563	2	0	\N
287348	1678	15840600407000	14839	7563	3	0	\N
287349	1874	5225000	14839	7563	4	0	\N
287350	1874	5228000	14839	7563	5	0	\N
287351	1874	5231000	14839	7563	6	0	\N
287352	1874	5234000	14839	7563	7	0	\N
287353	1678	15840600404000	14840	7563	0	0	\N
287354	1678	15840600405000	14840	7563	1	0	\N
287355	1678	15840600406000	14840	7563	2	0	\N
287356	1678	15840600407000	14840	7563	3	0	\N
287357	1874	5225000	14840	7563	4	0	\N
287358	1874	5228000	14840	7563	5	0	\N
287359	1874	5231000	14840	7563	6	0	\N
287360	1874	5234000	14840	7563	7	0	\N
287363	1678	15840600409000	14842	7565	0	0	\N
287364	1874	5240000	14842	7565	1	0	\N
287367	1678	15840600409000	14844	7565	0	0	\N
287368	1874	5240000	14844	7565	1	0	\N
287237	1874	5186000	14821	7554	1	0	1
287238	1678	15840600392000	14822	7555	0	0	0
287239	1874	5189000	14822	7555	1	0	1
287241	1678	15840600393000	14824	7556	0	0	0
287242	1678	15840600394000	14824	7556	1	0	0
287244	1874	5195000	14824	7556	3	0	1
287249	1678	15840600395000	14826	7557	0	0	0
287250	1678	15840600396000	14826	7557	1	0	0
287251	1678	15840600397000	14826	7557	2	0	0
287252	1874	5198000	14826	7557	3	0	1
287254	1874	5204000	14826	7557	5	0	1
287255	1678	15840600398000	14827	7558	0	0	0
287256	1874	5207000	14827	7558	1	0	1
287257	1678	15840600399000	14828	7559	0	0	0
287259	1874	5210000	14828	7559	2	0	1
287260	1874	5213000	14828	7559	3	0	1
287329	1678	15840600401000	14833	7560	0	0	0
287330	1874	5216000	14833	7560	1	0	1
287333	1678	15840600402000	14836	7561	0	0	0
287335	1678	15840600403000	14837	7562	0	0	0
287336	1874	5222000	14837	7562	1	0	1
287337	1678	15840600404000	14838	7563	0	0	0
287338	1678	15840600405000	14838	7563	1	0	0
287339	1678	15840600406000	14838	7563	2	0	0
287341	1874	5225000	14838	7563	4	0	1
287342	1874	5228000	14838	7563	5	0	1
287343	1874	5231000	14838	7563	6	0	1
287344	1874	5234000	14838	7563	7	0	1
287362	1874	5237000	14841	7564	1	0	1
287365	1678	15840600409000	14843	7565	0	0	0
287366	1874	5240000	14843	7565	1	0	1
287371	251	66530973005524	14846	7430	0	0	\N
287372	606	72137736812962	14846	7430	1	0	\N
287373	1483	10000000	14846	7430	2	0	\N
287374	2085	1100970000000	14846	7430	3	0	\N
287375	532	68880037000000	14846	7430	4	0	\N
287376	35	19354464874293	14846	7430	5	0	\N
287377	49	66530973005524	14846	7430	6	0	\N
287378	1030	908221538475200	14846	7430	7	0	\N
287379	1772	3796456950108	14846	7430	8	0	\N
287380	663	66530973005524	14846	7430	9	0	\N
287381	320	66249773005524	14846	7430	10	0	\N
287382	54	66530973005524	14846	7430	11	0	\N
287383	710	5040225227645	14846	7430	12	0	\N
287384	499	66530973005524	14846	7430	13	0	\N
287385	217	66530973005524	14846	7430	14	0	\N
287386	103	66530973005524	14846	7430	15	0	\N
287387	1811	1448945930186	14846	7430	16	0	\N
287388	893	309291320931713	14846	7430	17	0	\N
287389	225	66530973005524	14846	7430	18	0	\N
287390	377	66530973005524	14846	7430	19	0	\N
287391	560	66530973005524	14846	7430	20	0	\N
287392	252	66530973005524	14846	7430	21	0	\N
287393	894	309291320931713	14846	7430	22	0	\N
287394	569	66530973005524	14846	7430	23	0	\N
287395	390	66530973005524	14846	7430	24	0	\N
287396	108	66530973005524	14846	7430	25	0	\N
287397	99	66530973005524	14846	7430	26	0	\N
287398	570	66530973005524	14846	7430	27	0	\N
287399	2073	529147915594	14846	7430	28	0	\N
287400	391	66530973005524	14846	7430	29	0	\N
287401	397	66530973005524	14846	7430	30	0	\N
287402	402	66530973005524	14846	7430	31	0	\N
287403	163	66530973005524	14846	7430	32	0	\N
287404	275	66530973005524	14846	7430	33	0	\N
287405	201	66530973005524	14846	7430	34	0	\N
287406	1962	529885180751	14846	7430	35	0	\N
287407	309	66530973005524	14846	7430	36	0	\N
287408	82	66530973005524	14846	7430	37	0	\N
287409	361	66530973005524	14846	7430	38	0	\N
287410	452	66530973005524	14846	7430	39	0	\N
287411	594	66530973005524	14846	7430	40	0	\N
287412	534	66530973005524	14846	7430	41	0	\N
287413	245	66530973005524	14846	7430	42	0	\N
287414	191	66530973005524	14846	7430	43	0	\N
287415	266	66530973005524	14846	7430	44	0	\N
287416	352	66530973005524	14846	7430	45	0	\N
287417	421	66530973005524	14846	7430	46	0	\N
287418	420	66530973005524	14846	7430	47	0	\N
287419	600	66530973005524	14846	7430	48	0	\N
287420	353	66530963005524	14846	7430	49	0	\N
287421	620	66530973005524	14846	7430	50	0	\N
287422	180	66530973005524	14846	7430	51	0	\N
287423	112	66187942005524	14846	7430	52	0	\N
287424	652	66530973005524	14846	7430	53	0	\N
287425	680	66530973005524	14846	7430	54	0	\N
287426	690	66530973005524	14846	7430	55	0	\N
287427	89	66530973005524	14846	7430	56	0	\N
287428	186	66530973005524	14846	7430	57	0	\N
287429	383	66530973005524	14846	7430	58	0	\N
287430	392	66530973005524	14846	7430	59	0	\N
287431	308	66530973005524	14846	7430	60	0	\N
287432	678	66530973005524	14846	7430	61	0	\N
287433	691	66530973005524	14846	7430	62	0	\N
287434	731	2016090091005	14846	7430	63	0	\N
287435	1150	612795169601792	14846	7430	64	0	\N
287436	84	66530973005524	14846	7430	65	0	\N
287437	520	66530973005524	14846	7430	66	0	\N
287438	551	66530973005524	14846	7430	67	0	\N
287439	2017	529572339923	14846	7430	68	0	\N
287440	63	66530973005524	14846	7430	69	0	\N
287441	150	66530973005524	14846	7430	70	0	\N
287442	92	66530973005524	14846	7430	71	0	\N
287443	322	66530973005524	14846	7430	72	0	\N
287444	373	66530973005524	14846	7430	73	0	\N
287445	450	66530973005524	14846	7430	74	0	\N
287446	453	66530973005524	14846	7430	75	0	\N
287447	1678	15840600410000	14847	7566	0	0	\N
287448	1874	5243000	14847	7566	1	0	\N
287449	1678	15840600411000	14848	7567	0	0	\N
287450	1678	15840600412000	14848	7567	1	0	\N
287451	1678	15840600413000	14848	7567	2	0	\N
287452	1874	5246000	14848	7567	3	0	\N
287453	1874	5249000	14848	7567	4	0	\N
287454	1874	5252000	14848	7567	5	0	\N
287465	1678	15840600415000	14852	7569	0	0	\N
287466	1874	5258000	14852	7569	1	0	\N
287469	1678	15840600417000	14854	7571	0	0	\N
287470	1678	15840600418000	14854	7571	1	0	\N
287471	1678	15840600419000	14854	7571	2	0	\N
287472	1678	15840600420000	14854	7571	4	0	\N
287473	1874	5264000	14854	7571	5	0	\N
287474	1874	5267000	14854	7571	6	0	\N
287475	1874	5270000	14854	7571	7	0	\N
287476	1874	5273000	14854	7571	8	0	\N
287477	1678	15840600417000	14855	7571	0	0	\N
287478	1678	15840600418000	14855	7571	1	0	\N
287479	1678	15840600419000	14855	7571	2	0	\N
287480	1678	15840600420000	14855	7571	4	0	\N
287481	1874	5264000	14855	7571	5	0	\N
287482	1874	5267000	14855	7571	6	0	\N
287483	1874	5270000	14855	7571	7	0	\N
287484	1874	5273000	14855	7571	8	0	\N
287485	1678	15840600417000	14856	7571	0	0	\N
287486	1678	15840600418000	14856	7571	1	0	\N
287487	1678	15840600419000	14856	7571	2	0	\N
287488	1678	15840600417000	14857	7571	0	0	\N
287489	1678	15840600418000	14857	7571	1	0	\N
287490	1678	15840600419000	14857	7571	2	0	\N
287491	1678	15840600420000	14857	7571	4	0	\N
287492	1874	5264000	14857	7571	5	0	\N
287493	1874	5267000	14857	7571	6	0	\N
287494	1874	5270000	14857	7571	7	0	\N
287495	1874	5273000	14857	7571	8	0	\N
287496	1678	15840600421000	14858	7572	0	0	\N
287497	1874	5276000	14858	7572	1	0	\N
287498	1678	15840600421000	14859	7572	0	0	\N
287499	1874	5276000	14859	7572	1	0	\N
287500	1678	15840600421000	14860	7572	0	0	\N
287501	1874	5276000	14860	7572	1	0	\N
287455	1678	15840600411000	14849	7567	0	0	0
287456	1678	15840600412000	14849	7567	1	0	0
287457	1678	15840600413000	14849	7567	2	0	0
287458	1874	5246000	14849	7567	3	0	1
287459	1874	5249000	14849	7567	4	0	1
287461	1678	15840600414000	14850	7568	0	0	0
287462	1874	5255000	14850	7568	1	0	1
287463	1678	15840600415000	14851	7569	0	0	0
287464	1874	5258000	14851	7569	1	0	1
287467	1678	15840600416000	14853	7570	0	0	0
287502	1678	15840600417000	14861	7571	0	0	0
287503	1678	15840600418000	14861	7571	1	0	0
287504	1678	15840600419000	14861	7571	2	0	0
287512	1678	15840600421000	14863	7572	0	0	\N
287513	1874	5267000	14863	7572	1	0	\N
287514	1874	5270000	14863	7572	2	0	\N
287515	1874	5273000	14863	7572	3	0	\N
287516	1874	5276000	14863	7572	4	0	\N
287523	1678	15840600424000	14867	7575	0	0	\N
287524	1874	5285000	14867	7575	1	0	\N
287525	1678	15840600424000	14868	7575	0	0	\N
287526	1874	5285000	14868	7575	1	0	\N
287527	1678	15840600424000	14869	7575	0	0	\N
287528	1874	5285000	14869	7575	1	0	\N
287536	2115	1000000000	14871	7576	0	0	\N
287537	1678	15840600425000	14871	7576	1	0	\N
287538	1678	15840600426000	14871	7576	2	0	\N
287539	1678	15840600427000	14871	7576	3	0	\N
287540	1874	5288000	14871	7576	4	0	\N
287541	1874	5291000	14871	7576	5	0	\N
287542	1874	5294000	14871	7576	6	0	\N
287543	2115	1000000000	14872	7576	0	0	\N
287544	1678	15840600425000	14872	7576	1	0	\N
287545	1678	15840600426000	14872	7576	2	0	\N
287546	1678	15840600427000	14872	7576	3	0	\N
287547	1874	5288000	14872	7576	4	0	\N
287548	1874	5291000	14872	7576	5	0	\N
287549	1874	5294000	14872	7576	6	0	\N
287552	1678	15840600428000	14874	7577	0	0	\N
287553	1874	5297000	14874	7577	1	0	\N
287554	1678	15840600428000	14875	7577	0	0	\N
287555	1874	5297000	14875	7577	1	0	\N
287556	1678	15840600428000	14876	7577	0	0	\N
287557	1874	5297000	14876	7577	1	0	\N
287572	2114	200000000	14880	7581	0	0	\N
287573	2116	200000000	14880	7581	1	0	\N
287574	1678	15840600433000	14880	7581	2	0	\N
287575	1678	15840600434000	14880	7581	3	0	\N
287576	1874	5321000	14880	7581	4	0	\N
287577	2114	1400000000	14880	7581	5	0	\N
287578	1874	5323000	14880	7581	6	0	\N
287579	1874	5326000	14880	7581	7	0	\N
287580	1874	5328000	14880	7581	8	0	\N
287590	2114	200000000	14882	7581	0	0	\N
287591	2116	200000000	14882	7581	1	0	\N
287592	1678	15840600433000	14882	7581	2	0	\N
287593	1678	15840600434000	14882	7581	3	0	\N
287594	1874	5321000	14882	7581	4	0	\N
287595	2114	1400000000	14882	7581	5	0	\N
287596	1874	5323000	14882	7581	6	0	\N
287597	1874	5326000	14882	7581	7	0	\N
287598	1874	5328000	14882	7581	8	0	\N
287607	1678	15840600436000	14885	7583	0	0	\N
287608	1874	5337000	14885	7583	1	0	\N
287609	1874	5339000	14885	7583	2	0	\N
287638	1678	15840600444000	14889	7587	0	0	\N
287639	1874	5382000	14889	7587	1	0	\N
287640	1874	5385000	14889	7587	2	0	\N
287507	1678	15840600421000	14862	7572	0	0	0
287508	1874	5267000	14862	7572	1	0	1
287509	1874	5270000	14862	7572	2	0	1
287510	1874	5273000	14862	7572	3	0	1
287511	1874	5276000	14862	7572	4	0	1
287518	1874	5279000	14864	7573	1	0	1
287519	1678	15840600423000	14865	7574	0	0	0
287520	1874	5282000	14865	7574	1	0	1
287521	1678	15840600424000	14866	7575	0	0	0
287522	1874	5285000	14866	7575	1	0	1
287530	1678	15840600425000	14870	7576	1	0	0
287531	1678	15840600426000	14870	7576	2	0	0
287532	1678	15840600427000	14870	7576	3	0	0
287533	1874	5288000	14870	7576	4	0	1
287535	1874	5294000	14870	7576	6	0	1
287550	1678	15840600428000	14873	7577	0	0	0
287551	1874	5297000	14873	7577	1	0	1
287558	1678	15840600429000	14877	7578	0	0	0
287559	1678	15840600430000	14877	7578	1	0	0
287561	1874	5303000	14877	7578	3	0	1
287562	1874	5304000	14877	7578	4	0	1
287563	1483	10000000	14877	7578	5	0	0
287564	1874	5306000	14877	7578	6	0	1
287565	1678	15840600431000	14878	7579	0	0	0
287567	1874	5310000	14878	7579	2	0	1
287568	1874	5312000	14878	7579	3	0	1
287569	1678	15840600432000	14879	7580	0	0	0
287570	1874	5315000	14879	7580	1	0	1
287581	2114	200000000	14881	7581	0	0	0
287582	2116	200000000	14881	7581	1	0	0
287583	1678	15840600433000	14881	7581	2	0	0
287584	1678	15840600434000	14881	7581	3	0	0
287585	1874	5321000	14881	7581	4	0	1
287587	1874	5323000	14881	7581	6	0	1
287588	1874	5326000	14881	7581	7	0	1
287589	1874	5328000	14881	7581	8	0	1
287599	1678	15840600435000	14883	7582	0	0	0
287600	1874	5329000	14883	7582	1	0	1
287602	1874	5332000	14883	7582	3	0	1
287603	1874	5334000	14883	7582	4	0	1
287604	1678	15840600436000	14884	7583	0	0	0
287605	1874	5337000	14884	7583	1	0	1
287610	1874	5340000	14886	7584	0	0	1
287611	1874	5343000	14886	7584	1	0	1
287612	1874	5345000	14886	7584	2	0	1
287613	1874	5346000	14886	7584	3	0	1
287614	1874	5349000	14886	7584	4	0	1
287616	1874	5352000	14886	7584	6	0	1
287617	1874	5355000	14886	7584	7	0	1
287618	1874	5357000	14886	7584	8	0	1
287619	1874	5358000	14886	7584	9	0	1
287620	1874	5361000	14886	7584	10	0	1
287622	1678	15840600437000	14887	7585	0	0	0
287623	1678	15840600438000	14887	7585	1	0	0
287624	1678	15840600439000	14887	7585	2	0	0
287625	1678	15840600440000	14887	7585	3	0	0
287627	1678	15840600442000	14887	7585	5	0	0
287628	1874	5364000	14887	7585	6	0	1
287629	1874	5367000	14887	7585	7	0	1
287630	1874	5369000	14887	7585	8	0	1
287631	1874	5370000	14887	7585	9	0	1
287633	1874	5375000	14887	7585	11	0	1
287634	1678	15840600443000	14888	7586	0	0	0
287635	1874	5376000	14888	7586	1	0	1
287636	1874	5379000	14888	7586	2	0	1
287637	1874	5381000	14888	7586	3	0	1
287641	1874	5387000	14889	7587	3	0	\N
287650	1678	15840600446000	14892	7589	0	0	\N
287651	1678	15840600447000	14892	7589	1	0	\N
287652	1874	5394000	14892	7589	3	0	\N
287653	1874	5397000	14892	7589	4	0	\N
287654	1874	5399000	14892	7589	5	0	\N
287655	1874	5400000	14892	7589	6	0	\N
287656	1874	5403000	14892	7589	7	0	\N
287657	1874	5405000	14892	7589	8	0	\N
287666	1678	15840600446000	14894	7589	0	0	\N
287667	1678	15840600447000	14894	7589	1	0	\N
287668	1874	5394000	14894	7589	3	0	\N
287669	1874	5397000	14894	7589	4	0	\N
287670	1874	5399000	14894	7589	5	0	\N
287671	1874	5400000	14894	7589	6	0	\N
287672	1874	5403000	14894	7589	7	0	\N
287673	1874	5405000	14894	7589	8	0	\N
287674	1678	15840600446000	14895	7589	0	0	\N
287675	1678	15840600447000	14895	7589	1	0	\N
287676	1874	5394000	14895	7589	3	0	\N
287677	1874	5397000	14895	7589	4	0	\N
287678	1874	5399000	14895	7589	5	0	\N
287679	1874	5400000	14895	7589	6	0	\N
287680	1874	5403000	14895	7589	7	0	\N
287681	1874	5405000	14895	7589	8	0	\N
287686	1678	15840600448000	14898	7590	0	0	\N
287687	1874	5406000	14898	7590	1	0	\N
287688	1874	5409000	14898	7590	2	0	\N
287689	1874	5411000	14898	7590	3	0	\N
287690	1678	15840600448000	14899	7590	0	0	\N
287691	1874	5406000	14899	7590	1	0	\N
287692	1874	5409000	14899	7590	2	0	\N
287693	1874	5411000	14899	7590	3	0	\N
287699	1678	15840600451000	14902	7593	0	0	\N
287700	1874	5417000	14902	7593	1	0	\N
287701	1874	5419000	14902	7593	2	0	\N
287702	1874	5422000	14902	7593	3	0	\N
287707	1678	15840600451000	14904	7593	0	0	\N
287708	1874	5417000	14904	7593	1	0	\N
287709	1874	5419000	14904	7593	2	0	\N
287710	1874	5422000	14904	7593	3	0	\N
287711	1678	15840600451000	14905	7593	0	0	\N
287712	1874	5417000	14905	7593	1	0	\N
287713	1874	5419000	14905	7593	2	0	\N
287714	1874	5422000	14905	7593	3	0	\N
287724	1678	15840600454000	14909	7596	0	0	\N
287725	1874	5428000	14909	7596	1	0	\N
287726	1874	5430000	14909	7596	2	0	\N
287727	1874	5433000	14909	7596	3	0	\N
287728	1678	15840600455000	14910	7597	0	0	\N
287729	1874	5434000	14910	7597	1	0	\N
287730	1874	5436000	14910	7597	2	0	\N
287731	1874	5439000	14910	7597	3	0	\N
287736	1678	15840600455000	14912	7597	0	0	\N
287737	1874	5434000	14912	7597	1	0	\N
287738	1874	5436000	14912	7597	2	0	\N
287739	1874	5439000	14912	7597	3	0	\N
287760	1678	15840600463000	14916	7600	0	0	\N
287761	1874	5463000	14916	7600	1	0	\N
287765	1678	15840600464000	14918	7601	0	0	\N
287766	1874	5466000	14918	7601	1	0	\N
287767	1874	5469000	14918	7601	2	0	\N
287768	1678	15840600464000	14919	7601	0	0	\N
287769	1874	5466000	14919	7601	1	0	\N
287770	1874	5469000	14919	7601	2	0	\N
287774	1678	15840600465000	14921	7602	0	0	\N
287775	1970	199000000	14921	7602	1	0	\N
287776	1874	5471000	14921	7602	2	0	\N
287644	1874	5385000	14890	7587	2	0	1
287645	1874	5387000	14890	7587	3	0	1
287646	1678	15840600445000	14891	7588	0	0	0
287647	1874	5388000	14891	7588	1	0	1
287648	1874	5391000	14891	7588	2	0	1
287658	1678	15840600446000	14893	7589	0	0	0
287659	1678	15840600447000	14893	7589	1	0	0
287660	1874	5394000	14893	7589	3	0	1
287661	1874	5397000	14893	7589	4	0	1
287662	1874	5399000	14893	7589	5	0	1
287664	1874	5403000	14893	7589	7	0	1
287665	1874	5405000	14893	7589	8	0	1
287682	1678	15840600448000	14897	7590	0	0	0
287683	1874	5406000	14897	7590	1	0	1
287685	1874	5411000	14897	7590	3	0	1
287694	1678	15840600449000	14900	7591	0	0	0
287695	1874	5412000	14900	7591	1	0	1
287696	1874	5414000	14900	7591	2	0	1
287697	1678	15840600450000	14901	7592	0	0	0
287703	1678	15840600451000	14903	7593	0	0	0
287704	1874	5417000	14903	7593	1	0	1
287705	1874	5419000	14903	7593	2	0	1
287706	1874	5422000	14903	7593	3	0	1
287715	1678	15840600452000	14906	7594	0	0	0
287717	1874	5425000	14906	7594	2	0	1
287718	1678	15840600453000	14907	7595	0	0	0
287719	1874	5427000	14907	7595	1	0	1
287720	1678	15840600454000	14908	7596	0	0	0
287722	1874	5430000	14908	7596	2	0	1
287723	1874	5433000	14908	7596	3	0	1
287732	1678	15840600455000	14911	7597	0	0	0
287733	1874	5434000	14911	7597	1	0	1
287734	1874	5436000	14911	7597	2	0	1
287740	1678	15840600456000	14913	7598	0	0	0
287741	1874	5440000	14913	7598	1	0	1
287742	2117	200000000	14913	7598	2	0	0
287743	1874	5442000	14913	7598	3	0	1
287744	1678	15840600457000	14914	7599	0	0	0
287746	1678	15840600459000	14914	7599	2	0	0
287747	1678	15840600460000	14914	7599	3	0	0
287748	1678	15840600461000	14914	7599	4	0	0
287749	1678	15840600462000	14914	7599	5	0	0
287751	1874	5445000	14914	7599	7	0	1
287752	1874	5446000	14914	7599	8	0	1
287753	1874	5448000	14914	7599	9	0	1
287754	1874	5451000	14914	7599	10	0	1
287755	1874	5454000	14914	7599	11	0	1
287757	1874	5460000	14914	7599	13	0	1
287758	1678	15840600463000	14915	7600	0	0	0
287759	1874	5463000	14915	7600	1	0	1
287762	1678	15840600464000	14917	7601	0	0	0
287763	1874	5466000	14917	7601	1	0	1
287771	1678	15840600465000	14920	7602	0	0	0
287772	1970	199000000	14920	7602	1	0	1
287773	1874	5471000	14920	7602	2	0	1
287778	1678	15840600466000	14923	7603	0	0	\N
287779	1678	15840600466000	14924	7603	0	0	\N
287790	1678	15840600471000	14929	7608	0	0	\N
287791	1678	15840600471000	14930	7608	0	0	\N
287798	1678	15840600472000	14933	7609	0	0	\N
287799	1678	15840600473000	14933	7609	1	0	\N
287800	1874	5488000	14933	7609	2	0	\N
287801	1874	5491000	14933	7609	3	0	\N
287802	1874	5493000	14933	7609	4	0	\N
287803	1678	15840600472000	14934	7609	0	0	\N
287804	1678	15840600473000	14934	7609	1	0	\N
287805	1874	5488000	14934	7609	2	0	\N
287806	1874	5491000	14934	7609	3	0	\N
287807	1874	5493000	14934	7609	4	0	\N
287808	1678	15840600472000	14935	7609	0	0	\N
287809	1678	15840600473000	14935	7609	1	0	\N
287810	1874	5488000	14935	7609	2	0	\N
287811	1874	5491000	14935	7609	3	0	\N
287812	1874	5493000	14935	7609	4	0	\N
287813	1678	15840600472000	14937	7609	0	0	\N
287814	1678	15840600473000	14937	7609	1	0	\N
287815	1874	5488000	14937	7609	2	0	\N
287816	1874	5491000	14937	7609	3	0	\N
287817	1874	5493000	14937	7609	4	0	\N
287818	1678	15840600472000	14938	7609	0	0	\N
287819	1678	15840600473000	14938	7609	1	0	\N
287820	1874	5488000	14938	7609	2	0	\N
287821	1874	5491000	14938	7609	3	0	\N
287822	1874	5493000	14938	7609	4	0	\N
287825	1678	16560623474000	14940	7610	0	0	\N
287826	1874	5496000	14940	7610	1	0	\N
287827	1678	16560623474000	14941	7610	0	0	\N
287828	1874	5496000	14941	7610	1	0	\N
287829	1678	16560623475000	14942	7611	0	0	\N
287830	1874	5498000	14942	7611	1	0	\N
287847	1678	16560623482000	14946	7614	0	0	\N
287848	1874	5513000	14946	7614	1	0	\N
287851	1678	16560623483000	14948	7615	0	0	\N
287852	1678	16560623484000	14948	7615	1	0	\N
287853	1874	5514000	14948	7615	2	0	\N
287854	1874	5516000	14948	7615	3	0	\N
287855	1874	5517000	14948	7615	4	0	\N
287856	1678	16560623483000	14949	7615	0	0	\N
287857	1678	16560623484000	14949	7615	1	0	\N
287858	1874	5514000	14949	7615	2	0	\N
287859	1874	5516000	14949	7615	3	0	\N
287860	1874	5517000	14949	7615	4	0	\N
287869	1678	16560623485000	14954	7616	0	0	\N
287870	1874	5519000	14954	7616	1	0	\N
287871	1874	5520000	14954	7616	2	0	\N
287873	1678	16560623487000	14956	7618	0	0	\N
287874	1874	5522000	14956	7618	1	0	\N
287875	1874	5523000	14956	7618	2	0	\N
287879	1678	16560623487000	14958	7618	0	0	\N
287880	1874	5522000	14958	7618	1	0	\N
287881	1874	5523000	14958	7618	2	0	\N
287882	1678	16560623487000	14959	7618	0	0	\N
287883	1874	5522000	14959	7618	1	0	\N
287884	1874	5523000	14959	7618	2	0	\N
287892	1678	16560623490000	14962	7620	0	0	\N
287893	1874	5529000	14962	7620	1	0	\N
287903	1678	16560623494000	14967	7624	0	0	\N
287904	1678	16560623494000	14968	7624	0	0	\N
287781	1874	5473000	14925	7604	1	0	1
287782	1874	5476000	14925	7604	2	0	1
287783	1678	15840600468000	14926	7605	0	0	0
287784	1874	5478000	14926	7605	1	0	1
287785	1678	15840600469000	14927	7606	0	0	0
287787	1678	15840600470000	14928	7607	0	0	0
287788	1874	5483000	14928	7607	1	0	1
287789	1874	5486000	14928	7607	2	0	1
287792	1678	15840600471000	14931	7608	0	0	0
287793	1678	15840600472000	14932	7609	0	0	0
287795	1874	5488000	14932	7609	2	0	1
287796	1874	5491000	14932	7609	3	0	1
287797	1874	5493000	14932	7609	4	0	1
287823	1678	16560623474000	14939	7610	0	0	0
287831	1678	16560623475000	14943	7611	0	0	0
287832	1874	5498000	14943	7611	1	0	1
287833	1678	16560623476000	14944	7612	0	0	0
287834	1678	16560623477000	14945	7613	0	0	0
287835	1678	16560623478000	14945	7613	1	0	0
287837	1678	16560623480000	14945	7613	3	0	0
287838	1678	16560623481000	14945	7613	4	0	0
287839	1874	5500000	14945	7613	5	0	1
287840	1874	5503000	14945	7613	6	0	1
287841	1874	5504000	14945	7613	7	0	1
287843	1874	5507000	14945	7613	9	0	1
287844	1874	5509000	14945	7613	10	0	1
287845	1874	5510000	14945	7613	11	0	1
287846	1874	5511000	14945	7613	12	0	1
287850	1874	5513000	14947	7614	1	0	1
287861	1678	16560623483000	14951	7615	0	0	0
287862	1678	16560623484000	14951	7615	1	0	0
287863	1874	5514000	14951	7615	2	0	1
287864	1874	5516000	14951	7615	3	0	1
287866	1678	16560623485000	14953	7616	0	0	0
287867	1874	5519000	14953	7616	1	0	1
287868	1874	5520000	14953	7616	2	0	1
287872	1678	16560623486000	14955	7617	0	0	0
287876	1678	16560623487000	14957	7618	0	0	0
287878	1874	5523000	14957	7618	2	0	1
287885	1678	16560623488000	14960	7619	0	0	0
287886	1678	16560623489000	14960	7619	1	0	0
287887	1874	5524000	14960	7619	2	0	1
287889	1874	5527000	14960	7619	4	0	1
287890	1678	16560623490000	14961	7620	0	0	0
287891	1874	5529000	14961	7620	1	0	1
287894	1678	16560623491000	14963	7621	0	0	0
287895	1874	5530000	14963	7621	1	0	1
287897	1874	5532000	14964	7622	1	0	1
287898	1874	5533000	14964	7622	2	0	1
287899	1678	16560623493000	14965	7623	0	0	0
287900	1874	5535000	14965	7623	1	0	1
287901	1874	5536000	14965	7623	2	0	1
287905	1678	16560623495000	14969	7625	0	0	0
287906	1874	5537000	14969	7625	1	0	1
287907	1874	5539000	14969	7625	2	0	1
287908	1678	16560623496000	14970	7626	0	0	0
287910	1874	5540000	14970	7626	2	0	1
287911	1874	5542000	14970	7626	3	0	1
287912	2118	200000000	14970	7626	4	0	0
287916	1678	16560623499000	14972	7628	0	0	\N
287917	1874	5546000	14972	7628	1	0	\N
287930	1678	16560623503000	14977	7631	0	0	\N
287931	1874	5553000	14977	7631	1	0	\N
287932	1874	5555000	14977	7631	2	0	\N
287933	1678	16560623504000	14978	7632	0	0	\N
287934	1874	5556000	14978	7632	1	0	\N
287935	1678	16560623504000	14979	7632	0	0	\N
287936	1874	5556000	14979	7632	1	0	\N
287939	1678	16560623504000	14981	7632	0	0	\N
287940	1874	5556000	14981	7632	1	0	\N
287944	1678	16560623506000	14983	7634	0	0	\N
287945	1678	16560623506000	14984	7634	0	0	\N
287946	1678	16560623506000	14985	7634	0	0	\N
287954	1678	16560623508000	14989	7636	0	0	\N
287955	1874	5563000	14989	7636	1	0	\N
287956	1874	5565000	14989	7636	2	0	\N
287957	1678	16560623508000	14990	7636	0	0	\N
287958	1874	5563000	14990	7636	1	0	\N
287959	1874	5565000	14990	7636	2	0	\N
287960	1678	16560623508000	14991	7636	0	0	\N
287961	1874	5563000	14991	7636	1	0	\N
287962	1874	5565000	14991	7636	2	0	\N
287970	1678	16560623510000	14994	7638	0	0	\N
287971	1678	16560623511000	14994	7638	1	0	\N
287972	1874	5568000	14994	7638	2	0	\N
287973	1874	5569000	14994	7638	3	0	\N
287974	2119	200000000	14994	7638	4	0	\N
287978	1678	16560623512000	14996	7639	0	0	\N
287979	1874	5571000	14996	7639	1	0	\N
287980	1874	5572000	14996	7639	2	0	\N
287984	1678	16560623514000	14998	7641	0	0	\N
287985	1678	16560623514000	15000	7642	0	0	\N
287986	1678	16560623515000	15000	7642	1	0	\N
287987	1874	5576000	15000	7642	2	0	\N
287988	1874	5578000	15000	7642	3	0	\N
287993	2115	1000000000	15002	7547	0	0	\N
287994	1483	10000000	15002	7547	1	0	\N
287995	1678	15840600380000	15002	7547	2	0	\N
287996	1678	15840600381000	15002	7547	3	0	\N
287997	1678	15840600382000	15002	7547	4	0	\N
287998	1678	15840600383000	15002	7547	5	0	\N
287999	1678	15840600384000	15002	7547	6	0	\N
288000	1678	15840600385000	15002	7547	7	0	\N
288001	1678	15840600386000	15002	7547	8	0	\N
288002	1678	15840600387000	15002	7547	9	0	\N
288003	1678	15840600388000	15002	7547	10	0	\N
288004	1678	15840600389000	15002	7547	11	0	\N
288005	1678	15840600390000	15002	7547	12	0	\N
288006	1678	15840600391000	15002	7547	13	0	\N
288007	1678	15840600392000	15002	7547	14	0	\N
288008	1678	15840600393000	15002	7547	15	0	\N
288009	1678	15840600394000	15002	7547	16	0	\N
288010	1678	15840600395000	15002	7547	17	0	\N
288011	1678	15840600396000	15002	7547	18	0	\N
288012	1678	15840600397000	15002	7547	19	0	\N
288013	1678	15840600398000	15002	7547	20	0	\N
288014	1678	15840600399000	15002	7547	21	0	\N
288015	1678	15840600400000	15002	7547	22	0	\N
288016	1678	15840600401000	15002	7547	23	0	\N
288017	1678	15840600402000	15002	7547	24	0	\N
288018	1678	15840600403000	15002	7547	25	0	\N
288019	1678	15840600404000	15002	7547	26	0	\N
288020	1678	15840600405000	15002	7547	27	0	\N
288021	1678	15840600406000	15002	7547	28	0	\N
288022	1678	15840600407000	15002	7547	29	0	\N
288023	1678	15840600408000	15002	7547	30	0	\N
288024	1678	15840600409000	15002	7547	31	0	\N
288025	1678	15840600410000	15002	7547	32	0	\N
288026	1678	15840600411000	15002	7547	33	0	\N
288027	1678	15840600412000	15002	7547	34	0	\N
288028	1678	15840600413000	15002	7547	35	0	\N
288029	1678	15840600414000	15002	7547	36	0	\N
288030	1678	15840600415000	15002	7547	37	0	\N
288031	1678	15840600416000	15002	7547	38	0	\N
288032	1678	15840600417000	15002	7547	39	0	\N
288033	1678	15840600418000	15002	7547	40	0	\N
288034	1678	15840600419000	15002	7547	41	0	\N
288035	1678	15840600420000	15002	7547	42	0	\N
288036	1678	15840600421000	15002	7547	43	0	\N
288037	1678	15840600422000	15002	7547	44	0	\N
288038	1678	15840600423000	15002	7547	45	0	\N
288039	1678	15840600424000	15002	7547	46	0	\N
288040	1678	15840600425000	15002	7547	47	0	\N
288041	1678	15840600426000	15002	7547	48	0	\N
288042	1678	15840600427000	15002	7547	49	0	\N
288043	1678	15840600428000	15002	7547	50	0	\N
288044	1678	15840600429000	15002	7547	51	0	\N
288045	1678	15840600430000	15002	7547	52	0	\N
288046	1678	15840600431000	15002	7547	53	0	\N
288047	1678	15840600432000	15002	7547	54	0	\N
288048	1678	15840600433000	15002	7547	55	0	\N
287915	1874	5545000	14971	7627	1	0	1
287918	1678	16560623499000	14973	7628	0	0	0
287919	1874	5546000	14973	7628	1	0	1
287920	1678	16560623500000	14974	7629	0	0	0
287921	1874	5548000	14974	7629	1	0	1
287923	1678	16560623501000	14975	7630	0	0	0
287924	1678	16560623502000	14975	7630	1	0	0
287925	1874	5550000	14975	7630	2	0	1
287926	1874	5552000	14975	7630	3	0	1
287927	1678	16560623503000	14976	7631	0	0	0
287929	1874	5555000	14976	7631	2	0	1
287937	1678	16560623504000	14980	7632	0	0	0
287938	1874	5556000	14980	7632	1	0	1
287941	1678	16560623505000	14982	7633	0	0	0
287943	1874	5559000	14982	7633	2	0	1
287947	1678	16560623506000	14986	7634	0	0	0
287948	1678	16560623507000	14987	7635	0	0	0
287949	1874	5561000	14987	7635	1	0	1
287950	1874	5562000	14987	7635	2	0	1
287952	1874	5563000	14988	7636	1	0	1
287953	1874	5565000	14988	7636	2	0	1
287963	1678	16560623509000	14992	7637	0	0	0
287964	1874	5566000	14992	7637	2	0	1
287965	1678	16560623510000	14993	7638	0	0	0
287967	1874	5568000	14993	7638	2	0	1
287968	1874	5569000	14993	7638	3	0	1
287969	2119	200000000	14993	7638	4	0	0
287975	1678	16560623512000	14995	7639	0	0	0
287977	1874	5572000	14995	7639	2	0	1
287981	1678	16560623513000	14997	7640	0	0	0
287982	1874	5573000	14997	7640	1	0	1
287983	1874	5575000	14997	7640	2	0	1
287989	1678	16560623514000	15001	7642	0	0	0
287991	1874	5576000	15001	7642	2	0	1
287992	1874	5578000	15001	7642	3	0	1
288049	1678	15840600434000	15002	7547	56	0	\N
288050	1678	15840600435000	15002	7547	57	0	\N
288051	1678	15840600436000	15002	7547	58	0	\N
288052	1678	15840600437000	15002	7547	59	0	\N
288053	1678	15840600438000	15002	7547	60	0	\N
288054	1678	15840600439000	15002	7547	61	0	\N
288055	1678	15840600440000	15002	7547	62	0	\N
288056	1678	15840600441000	15002	7547	63	0	\N
288057	1678	15840600442000	15002	7547	64	0	\N
288058	1678	15840600443000	15002	7547	65	0	\N
288059	1678	15840600444000	15002	7547	66	0	\N
288060	1678	15840600445000	15002	7547	67	0	\N
288061	1678	15840600446000	15002	7547	68	0	\N
288062	1678	15840600447000	15002	7547	69	0	\N
288063	1678	15840600448000	15002	7547	70	0	\N
288064	1678	15840600449000	15002	7547	71	0	\N
288065	1678	15840600450000	15002	7547	72	0	\N
288066	1678	15840600451000	15002	7547	73	0	\N
288067	1678	15840600452000	15002	7547	74	0	\N
288068	1678	15840600453000	15002	7547	75	0	\N
288069	1678	15840600454000	15002	7547	76	0	\N
288070	1678	15840600455000	15002	7547	77	0	\N
288071	1678	15840600456000	15002	7547	78	0	\N
288072	1678	15840600457000	15002	7547	79	0	\N
288073	1678	15840600458000	15002	7547	80	0	\N
288074	1678	15840600459000	15002	7547	81	0	\N
288075	1678	15840600460000	15002	7547	82	0	\N
288076	1678	15840600461000	15002	7547	83	0	\N
288077	1678	15840600462000	15002	7547	84	0	\N
288078	1678	15840600463000	15002	7547	85	0	\N
288079	1678	15840600464000	15002	7547	86	0	\N
288080	1678	15840600465000	15002	7547	87	0	\N
288081	1678	15840600466000	15002	7547	88	0	\N
288082	1678	15840600467000	15002	7547	89	0	\N
288083	1678	15840600468000	15002	7547	90	0	\N
288084	1678	15840600469000	15002	7547	91	0	\N
288085	1678	15840600470000	15002	7547	92	0	\N
288086	1678	15840600471000	15002	7547	93	0	\N
288087	1678	15840600472000	15002	7547	94	0	\N
288088	1678	15840600473000	15002	7547	95	0	\N
288089	1678	15840600474000	15002	7547	96	0	\N
288090	1678	15840600475000	15002	7547	97	0	\N
288091	1678	15840600476000	15002	7547	98	0	\N
288092	1678	15840600477000	15002	7547	99	0	\N
288093	1678	15840600478000	15002	7547	100	0	\N
288094	1678	15840600479000	15002	7547	101	0	\N
288095	1678	15840600480000	15002	7547	102	0	\N
288096	1678	15840600481000	15002	7547	103	0	\N
288097	1678	15840600482000	15002	7547	104	0	\N
288098	1678	15840600483000	15002	7547	105	0	\N
288099	1678	15840600484000	15002	7547	106	0	\N
288100	1678	15840600485000	15002	7547	107	0	\N
288101	1678	15840600486000	15002	7547	108	0	\N
288102	1678	15840600487000	15002	7547	109	0	\N
288103	1678	15840600488000	15002	7547	110	0	\N
288104	1678	15840600489000	15002	7547	111	0	\N
288105	1678	15840600490000	15002	7547	112	0	\N
288106	1678	15840600491000	15002	7547	113	0	\N
288107	1678	15840600492000	15002	7547	114	0	\N
288108	1678	15840600493000	15002	7547	115	0	\N
288109	1678	15840600494000	15002	7547	116	0	\N
288110	1678	15840600495000	15002	7547	117	0	\N
288111	1678	15840600496000	15002	7547	118	0	\N
288112	1678	15840600497000	15002	7547	119	0	\N
288113	1678	15840600498000	15002	7547	120	0	\N
288114	1678	15840600499000	15002	7547	121	0	\N
288115	1678	15840600500000	15002	7547	122	0	\N
288116	1678	15840600501000	15002	7547	123	0	\N
288117	1678	15840600502000	15002	7547	124	0	\N
288118	1678	15840600503000	15002	7547	125	0	\N
288121	1678	16560623516000	15004	7643	0	0	\N
288122	1874	5579000	15004	7643	1	0	\N
288123	1678	16560623517000	15005	7644	0	0	\N
288124	1678	16560623518000	15005	7644	1	0	\N
288125	1874	5581000	15005	7644	2	0	\N
288126	1874	5582000	15005	7644	3	0	\N
288127	1874	5584000	15005	7644	4	0	\N
288133	1678	16560623519000	15007	7645	0	0	\N
288134	1874	5585000	15007	7645	1	0	\N
288139	1678	16560623520000	15010	7646	0	0	\N
288140	1874	5587000	15010	7646	1	0	\N
288145	1678	16560623523000	15013	7649	0	0	\N
288146	1874	5591000	15013	7649	1	0	\N
288147	1874	5593000	15013	7649	2	0	\N
288160	1678	16560623528000	15018	7653	0	0	\N
288161	1874	5601000	15018	7653	1	0	\N
288162	1874	5603000	15018	7653	2	0	\N
288166	1678	16560623528000	15020	7653	0	0	\N
288167	1874	5601000	15020	7653	1	0	\N
288168	1874	5603000	15020	7653	2	0	\N
288169	1678	16560623529000	15021	7654	0	0	\N
288170	1874	5604000	15021	7654	1	0	\N
288183	1678	16560623530000	15024	7655	0	0	\N
288184	1678	16560623531000	15024	7655	1	0	\N
288128	1678	16560623517000	15006	7644	0	0	0
288129	1678	16560623518000	15006	7644	1	0	0
288130	1874	5581000	15006	7644	2	0	1
288131	1874	5582000	15006	7644	3	0	1
288132	1874	5584000	15006	7644	4	0	1
288136	1874	5585000	15008	7645	1	0	1
288137	1678	16560623520000	15009	7646	0	0	0
288138	1874	5587000	15009	7646	1	0	1
288141	1678	16560623521000	15011	7647	0	0	0
288142	1874	5588000	15011	7647	1	0	1
288144	1874	5590000	15012	7648	1	0	1
288148	1678	16560623523000	15014	7649	0	0	0
288149	1874	5591000	15014	7649	1	0	1
288150	1874	5593000	15014	7649	2	0	1
288152	1678	16560623525000	15015	7650	1	0	0
288153	1874	5594000	15015	7650	2	0	1
288154	1874	5596000	15015	7650	3	0	1
288155	1874	5597000	15015	7650	4	0	1
288156	1678	16560623526000	15016	7651	0	0	0
288158	1874	5599000	15017	7652	1	0	1
288159	1874	5600000	15017	7652	2	0	1
288163	1678	16560623528000	15019	7653	0	0	0
288164	1874	5601000	15019	7653	1	0	1
288165	1874	5603000	15019	7653	2	0	1
288172	1874	5604000	15022	7654	1	0	1
288173	1678	16560623530000	15023	7655	0	0	0
288174	1678	16560623531000	15023	7655	1	0	0
288175	1678	16560623532000	15023	7655	2	0	0
288177	1874	5606000	15023	7655	4	0	1
288178	1874	5607000	15023	7655	5	0	1
288179	1874	5609000	15023	7655	6	0	1
288180	1874	5610000	15023	7655	7	0	1
288181	1874	5612000	15023	7655	8	0	1
288185	1678	16560623532000	15024	7655	2	0	\N
288186	1678	16560623533000	15024	7655	3	0	\N
288187	1874	5606000	15024	7655	4	0	\N
288188	1874	5607000	15024	7655	5	0	\N
288189	1874	5609000	15024	7655	6	0	\N
288190	1874	5610000	15024	7655	7	0	\N
288191	1874	5612000	15024	7655	8	0	\N
288192	1874	5613000	15024	7655	9	0	\N
288194	1678	16560623535000	15026	7657	0	0	\N
288195	1874	5614000	15026	7657	1	0	\N
288196	1874	5616000	15026	7657	2	0	\N
288197	1678	16560623535000	15027	7657	0	0	\N
288198	1874	5614000	15027	7657	1	0	\N
288199	1874	5616000	15027	7657	2	0	\N
288208	2115	1000000000	15031	7556	0	0	\N
288209	1760	501000000000	15031	7556	1	0	\N
288210	1483	10000000	15031	7556	3	0	\N
288213	1678	16560623520000	15033	7646	0	0	\N
288214	1678	16560623521000	15033	7646	1	0	\N
288215	1678	16560623522000	15033	7646	2	0	\N
288216	1678	16560623523000	15033	7646	3	0	\N
288217	1678	16560623524000	15033	7646	4	0	\N
288218	1678	16560623525000	15033	7646	5	0	\N
288219	1678	16560623526000	15033	7646	6	0	\N
288220	1678	16560623527000	15033	7646	7	0	\N
288221	1678	16560623528000	15033	7646	8	0	\N
288222	1678	16560623529000	15033	7646	9	0	\N
288223	1678	16560623530000	15033	7646	10	0	\N
288224	1678	16560623531000	15033	7646	11	0	\N
288225	1678	16560623532000	15033	7646	12	0	\N
288226	1678	16560623533000	15033	7646	13	0	\N
288227	1678	16560623534000	15033	7646	14	0	\N
288228	1678	16560623535000	15033	7646	15	0	\N
288229	1678	16560623536000	15033	7646	16	0	\N
288230	1678	16560623537000	15033	7646	17	0	\N
288231	1678	16560623538000	15033	7646	18	0	\N
288232	1874	5587000	15033	7646	19	0	\N
288233	1874	5588000	15033	7646	20	0	\N
288234	1874	5590000	15033	7646	21	0	\N
288235	1874	5591000	15033	7646	22	0	\N
288236	1874	5593000	15033	7646	23	0	\N
288237	1874	5594000	15033	7646	24	0	\N
288238	1874	5596000	15033	7646	25	0	\N
288239	1874	5597000	15033	7646	26	0	\N
288240	1874	5599000	15033	7646	27	0	\N
288241	1874	5600000	15033	7646	28	0	\N
288242	1874	5601000	15033	7646	29	0	\N
288243	1874	5603000	15033	7646	30	0	\N
288244	1874	5604000	15033	7646	31	0	\N
288245	1874	5606000	15033	7646	32	0	\N
288246	1874	5607000	15033	7646	33	0	\N
288247	1874	5609000	15033	7646	34	0	\N
288248	1874	5610000	15033	7646	35	0	\N
288249	1874	5612000	15033	7646	36	0	\N
288250	1874	5613000	15033	7646	37	0	\N
288251	1874	5614000	15033	7646	38	0	\N
288252	1874	5616000	15033	7646	39	0	\N
288253	1874	5617000	15033	7646	40	0	\N
288254	1874	5619000	15033	7646	41	0	\N
288255	1874	5620000	15033	7646	42	0	\N
288256	1874	5622000	15033	7646	43	0	\N
288257	1678	16560623539000	15034	7661	0	0	\N
288258	1678	16560623540000	15034	7661	1	0	\N
288259	1874	5623000	15034	7661	2	0	\N
288260	1874	5625000	15034	7661	3	0	\N
288261	1874	5626000	15034	7661	4	0	\N
288267	1678	16560623541000	15036	7662	0	0	\N
288268	1678	16560623541000	15037	7662	0	0	\N
288269	1678	16560623541000	15038	7662	0	0	\N
288274	1678	16560623542000	15041	7663	0	0	\N
288275	1874	5627000	15041	7663	2	0	\N
288276	1874	5629000	15041	7663	3	0	\N
288277	1678	16560623542000	15042	7663	0	0	\N
288278	1874	5627000	15042	7663	2	0	\N
288279	1874	5629000	15042	7663	3	0	\N
288280	1678	16560623542000	15043	7663	0	0	\N
288281	1874	5627000	15043	7663	2	0	\N
288282	1874	5629000	15043	7663	3	0	\N
288283	1678	16560623543000	15044	7664	0	0	\N
288284	1874	5630000	15044	7664	1	0	\N
288289	1678	16560623545000	15047	7666	0	0	\N
288290	1874	5634000	15047	7666	1	0	\N
288291	1678	16560623545000	15048	7666	0	0	\N
288292	1874	5634000	15048	7666	1	0	\N
288296	1678	16560623546000	15051	7667	0	0	\N
288297	1678	16560623513000	15054	7640	0	0	\N
288298	1678	16560623514000	15054	7640	1	0	\N
288299	1678	16560623515000	15054	7640	2	0	\N
288300	1678	16560623516000	15054	7640	3	0	\N
288301	1678	16560623517000	15054	7640	4	0	\N
288302	1678	16560623518000	15054	7640	5	0	\N
288303	1678	16560623519000	15054	7640	6	0	\N
288304	1678	16560623520000	15054	7640	7	0	\N
288305	1678	16560623521000	15054	7640	8	0	\N
288306	1678	16560623522000	15054	7640	9	0	\N
288307	1678	16560623523000	15054	7640	10	0	\N
288308	1678	16560623524000	15054	7640	11	0	\N
288309	1678	16560623525000	15054	7640	12	0	\N
288310	1678	16560623526000	15054	7640	13	0	\N
288311	1678	16560623527000	15054	7640	14	0	\N
288312	1678	16560623528000	15054	7640	15	0	\N
288313	1678	16560623529000	15054	7640	16	0	\N
288314	1678	16560623530000	15054	7640	17	0	\N
288315	1678	16560623531000	15054	7640	18	0	\N
288316	1678	16560623532000	15054	7640	19	0	\N
288317	1678	16560623533000	15054	7640	20	0	\N
288318	1678	16560623534000	15054	7640	21	0	\N
288319	1678	16560623535000	15054	7640	22	0	\N
288320	1678	16560623536000	15054	7640	23	0	\N
288201	1874	5614000	15028	7657	1	0	1
288202	1874	5616000	15028	7657	2	0	1
288203	1678	16560623536000	15029	7658	0	0	0
288204	1874	5617000	15029	7658	1	0	1
288205	1678	16560623537000	15030	7659	0	0	0
288207	1874	5620000	15030	7659	2	0	1
288211	1678	16560623538000	15032	7660	0	0	0
288212	1874	5622000	15032	7660	1	0	1
288262	1678	16560623539000	15035	7661	0	0	0
288263	1678	16560623540000	15035	7661	1	0	0
288265	1874	5625000	15035	7661	3	0	1
288266	1874	5626000	15035	7661	4	0	1
288270	1678	16560623541000	15039	7662	0	0	0
288271	1678	16560623542000	15040	7663	0	0	0
288273	1874	5629000	15040	7663	3	0	1
288285	1678	16560623543000	15045	7664	0	0	0
288286	1874	5630000	15045	7664	1	0	1
288287	1678	16560623544000	15046	7665	0	0	0
288288	1874	5632000	15046	7665	1	0	1
288294	1874	5634000	15049	7666	1	0	1
288295	1678	16560623546000	15050	7667	0	0	0
288321	1678	16560623537000	15054	7640	24	0	\N
288322	1678	16560623538000	15054	7640	25	0	\N
288323	1678	16560623539000	15054	7640	26	0	\N
288324	1678	16560623540000	15054	7640	27	0	\N
288325	1678	16560623541000	15054	7640	28	0	\N
288326	1678	16560623542000	15054	7640	29	0	\N
288327	1678	16560623543000	15054	7640	30	0	\N
288328	1678	16560623544000	15054	7640	31	0	\N
288329	1678	16560623545000	15054	7640	32	0	\N
288330	1678	16560623546000	15054	7640	33	0	\N
288331	1874	5573000	15054	7640	34	0	\N
288332	1874	5575000	15054	7640	35	0	\N
288333	1874	5576000	15054	7640	36	0	\N
288334	1874	5578000	15054	7640	37	0	\N
288335	1874	5579000	15054	7640	38	0	\N
288336	1874	5581000	15054	7640	39	0	\N
288337	1874	5582000	15054	7640	40	0	\N
288338	1874	5584000	15054	7640	41	0	\N
288339	1874	5585000	15054	7640	42	0	\N
288340	1874	5587000	15054	7640	43	0	\N
288341	1874	5588000	15054	7640	44	0	\N
288342	1874	5590000	15054	7640	45	0	\N
288343	1874	5591000	15054	7640	46	0	\N
288344	1874	5593000	15054	7640	47	0	\N
288345	1874	5594000	15054	7640	48	0	\N
288346	1874	5596000	15054	7640	49	0	\N
288347	1874	5597000	15054	7640	50	0	\N
288348	1874	5599000	15054	7640	51	0	\N
288349	1874	5600000	15054	7640	52	0	\N
288350	1874	5601000	15054	7640	53	0	\N
288351	1874	5603000	15054	7640	54	0	\N
288352	1874	5604000	15054	7640	55	0	\N
288353	1874	5606000	15054	7640	56	0	\N
288354	1874	5607000	15054	7640	57	0	\N
288355	1874	5609000	15054	7640	58	0	\N
288356	1874	5610000	15054	7640	59	0	\N
288357	1874	5612000	15054	7640	60	0	\N
288358	1874	5613000	15054	7640	61	0	\N
288359	1874	5614000	15054	7640	62	0	\N
288360	1874	5616000	15054	7640	63	0	\N
288361	1874	5617000	15054	7640	64	0	\N
288362	1874	5619000	15054	7640	65	0	\N
288363	1874	5620000	15054	7640	66	0	\N
288364	1874	5622000	15054	7640	67	0	\N
288365	1874	5623000	15054	7640	68	0	\N
288366	1874	5625000	15054	7640	69	0	\N
288367	1874	5626000	15054	7640	70	0	\N
288368	1874	5627000	15054	7640	71	0	\N
288369	1874	5629000	15054	7640	72	0	\N
288370	1874	5630000	15054	7640	73	0	\N
288371	1874	5632000	15054	7640	74	0	\N
288372	1874	5634000	15054	7640	75	0	\N
288378	1678	16560623548000	15057	7669	0	0	\N
288379	1678	16560623549000	15057	7669	1	0	\N
288380	1874	5638000	15057	7669	2	0	\N
288381	1678	16560623550000	15058	7670	0	0	\N
288382	1874	5640000	15058	7670	1	0	\N
288385	1678	16560623551000	15060	7671	0	0	\N
288386	1678	16560623552000	15060	7671	1	0	\N
288387	1678	16560623553000	15060	7671	2	0	\N
288388	1874	5642000	15060	7671	3	0	\N
288393	1678	16560623551000	15062	7671	0	0	\N
288394	1678	16560623552000	15062	7671	1	0	\N
288395	1678	16560623553000	15062	7671	2	0	\N
288396	1874	5642000	15062	7671	3	0	\N
288397	1678	16560623551000	15063	7671	0	0	\N
288398	1678	16560623552000	15063	7671	1	0	\N
288399	1678	16560623553000	15063	7671	2	0	\N
288400	1874	5642000	15063	7671	3	0	\N
288401	1678	16560623551000	15064	7671	0	0	\N
288402	1678	16560623552000	15064	7671	1	0	\N
288403	1678	16560623553000	15064	7671	2	0	\N
288404	1874	5642000	15064	7671	3	0	\N
288405	1678	16560623554000	15065	7672	0	0	\N
288406	1874	5644000	15065	7672	1	0	\N
288411	1678	16560623555000	15068	7673	0	0	\N
288412	1874	5646000	15068	7673	1	0	\N
288413	1678	16560623556000	15069	7674	0	0	\N
288415	1678	16560623556000	15071	7674	0	0	\N
288423	1678	16560623561000	15077	7680	0	0	\N
288424	1678	16560623562000	15077	7680	1	0	\N
288425	1678	16560623563000	15077	7680	2	0	\N
288426	1874	5654000	15077	7680	3	0	\N
288427	1874	5656000	15077	7680	4	0	\N
288428	1678	16560623561000	15078	7680	0	0	\N
288429	1678	16560623562000	15078	7680	1	0	\N
288430	1678	16560623563000	15078	7680	2	0	\N
288431	1874	5654000	15078	7680	3	0	\N
288432	1874	5656000	15078	7680	4	0	\N
288441	1678	16560623566000	15081	7682	0	0	\N
288442	1678	16560623567000	15081	7682	1	0	\N
288443	1874	5660000	15081	7682	2	0	\N
288454	1678	16560623571000	15087	7686	0	0	\N
288455	1874	5666000	15087	7686	1	0	\N
288456	1678	16560623572000	15088	7687	0	0	\N
288375	1678	16560623548000	15056	7669	0	0	0
288376	1678	16560623549000	15056	7669	1	0	0
288377	1874	5638000	15056	7669	2	0	1
288383	1678	16560623550000	15059	7670	0	0	0
288384	1874	5640000	15059	7670	1	0	1
288390	1678	16560623552000	15061	7671	1	0	0
288391	1678	16560623553000	15061	7671	2	0	0
288392	1874	5642000	15061	7671	3	0	1
288407	1678	16560623554000	15066	7672	0	0	0
288408	1874	5644000	15066	7672	1	0	1
288410	1874	5646000	15067	7673	1	0	1
288414	1678	16560623556000	15070	7674	0	0	0
288416	1874	5648000	15072	7675	0	0	1
288417	1678	16560623557000	15073	7676	0	0	0
288419	1874	5650000	15074	7677	1	0	1
288420	1678	16560623559000	15075	7678	0	0	0
288421	1874	5652000	15075	7678	1	0	1
288422	1678	16560623560000	15076	7679	0	0	0
288433	1678	16560623561000	15079	7680	0	0	0
288435	1678	16560623563000	15079	7680	2	0	0
288436	1874	5654000	15079	7680	3	0	1
288437	1874	5656000	15079	7680	4	0	1
288438	1678	16560623564000	15080	7681	0	0	0
288439	1678	16560623565000	15080	7681	1	0	0
288444	1678	16560623566000	15082	7682	0	0	0
288445	1678	16560623567000	15082	7682	1	0	0
288446	1874	5660000	15082	7682	2	0	1
288447	1678	16560623568000	15083	7683	0	0	0
288449	1678	16560623569000	15084	7684	0	0	0
288450	1874	5664000	15084	7684	1	0	1
288451	1678	16560623570000	15085	7685	0	0	0
288452	1678	16560623571000	15086	7686	0	0	0
288453	1874	5666000	15086	7686	1	0	1
288463	1874	5672000	15095	7691	0	0	\N
288464	1874	5672000	15096	7691	0	0	\N
288466	1678	16560623575000	15099	7694	0	0	\N
288467	1874	5676000	15099	7694	1	0	\N
288476	1678	16560623579000	15106	7697	0	0	\N
288477	1678	16560623580000	15106	7697	1	0	\N
288478	1874	5680000	15106	7697	2	0	\N
288479	1874	5681000	15106	7697	3	0	\N
288480	2120	200000000	15106	7697	4	0	\N
288481	2121	200000000	15106	7697	5	0	\N
288482	2122	200000000	15106	7697	6	0	\N
288483	1874	5683000	15106	7697	7	0	\N
288484	1678	16560623580000	15107	7698	0	0	\N
288485	1874	5681000	15107	7698	1	0	\N
288486	2120	200000000	15107	7698	2	0	\N
288487	2121	200000000	15107	7698	3	0	\N
288488	2122	200000000	15107	7698	4	0	\N
288489	1874	5683000	15107	7698	5	0	\N
288496	1678	16560623580000	15109	7698	0	0	\N
288497	1874	5681000	15109	7698	1	0	\N
288498	2120	200000000	15109	7698	2	0	\N
288499	2121	200000000	15109	7698	3	0	\N
288500	2122	200000000	15109	7698	4	0	\N
288501	1874	5683000	15109	7698	5	0	\N
288521	1678	16560623589000	15119	7706	0	0	\N
288522	1874	5698000	15119	7706	1	0	\N
288523	1678	16560623589000	15120	7706	0	0	\N
288524	1874	5698000	15120	7706	1	0	\N
288527	1678	16560623591000	15122	7708	0	0	\N
288528	1678	16560623591000	15123	7708	0	0	\N
288529	1678	16560623591000	15124	7708	0	0	\N
288534	1678	16560623587000	15127	7704	0	0	\N
288535	1874	5694000	15127	7704	1	0	\N
288536	1874	5696000	15127	7704	2	0	\N
288544	1678	16560623595000	15130	7711	0	0	\N
288545	1678	16560623596000	15130	7711	1	0	\N
288546	1678	16560623597000	15130	7711	2	0	\N
288547	1874	5706000	15130	7711	3	0	\N
288548	1874	5708000	15130	7711	4	0	\N
288557	1678	16560623601000	15135	7715	0	0	\N
288558	1678	16560623602000	15135	7715	1	0	\N
288559	1874	5714000	15135	7715	2	0	\N
288563	1678	16560623604000	15139	7717	0	0	\N
288564	1874	5716000	15139	7717	1	0	\N
288568	1678	16560623606000	15142	7719	0	0	\N
288569	1678	16560623606000	15143	7719	0	0	\N
288572	1678	16560623607000	15145	7720	0	0	\N
288573	1874	5720000	15145	7720	1	0	\N
288574	1678	16560623592000	15146	7709	0	0	\N
288575	1678	16560623593000	15146	7709	1	0	\N
288576	1678	16560623594000	15146	7709	2	0	\N
288577	1678	16560623595000	15146	7709	3	0	\N
288578	1678	16560623596000	15146	7709	4	0	\N
288579	1678	16560623597000	15146	7709	5	0	\N
288580	1678	16560623598000	15146	7709	6	0	\N
288581	1678	16560623599000	15146	7709	7	0	\N
288582	1678	16560623600000	15146	7709	8	0	\N
288583	1678	16560623601000	15146	7709	9	0	\N
288584	1678	16560623602000	15146	7709	10	0	\N
288585	1678	16560623603000	15146	7709	11	0	\N
288586	1678	16560623604000	15146	7709	12	0	\N
288587	1678	16560623605000	15146	7709	13	0	\N
288588	1678	16560623606000	15146	7709	14	0	\N
288589	1678	16560623607000	15146	7709	15	0	\N
288590	1874	5702000	15146	7709	16	0	\N
288591	1874	5704000	15146	7709	17	0	\N
288592	1874	5706000	15146	7709	18	0	\N
288459	1874	5668000	15090	7688	1	0	1
288460	1678	16560623574000	15091	7689	0	0	0
288461	1874	5670000	15091	7689	1	0	1
288462	1874	5672000	15094	7691	0	0	1
288465	1874	5674000	15098	7693	0	0	1
288469	1874	5676000	15100	7694	1	0	1
288470	1678	16560623576000	15103	7695	0	0	0
288471	1678	16560623577000	15103	7695	1	0	0
288472	1874	5678000	15103	7695	2	0	1
288473	1678	16560623578000	15104	7696	0	0	0
288475	1874	5680000	15105	7697	1	0	1
288490	1678	16560623580000	15108	7698	0	0	0
288491	1874	5681000	15108	7698	1	0	1
288492	2120	200000000	15108	7698	2	0	0
288494	2122	200000000	15108	7698	4	0	0
288495	1874	5683000	15108	7698	5	0	1
288502	1678	16560623581000	15110	7699	0	0	0
288503	1874	5684000	15110	7699	1	0	1
288504	1678	16560623582000	15111	7700	0	0	0
288506	1874	5686000	15111	7700	2	0	1
288507	1874	5687000	15111	7700	3	0	1
288508	1678	16560623584000	15113	7701	0	0	0
288509	1874	5689000	15113	7701	1	0	1
288510	1874	5690000	15113	7701	2	0	1
288512	1874	5691000	15114	7702	1	0	1
288513	1874	5693000	15114	7702	2	0	1
288514	1678	16560623586000	15115	7703	0	0	0
288515	1678	16560623587000	15116	7704	0	0	0
288517	1874	5696000	15116	7704	2	0	1
288518	1678	16560623588000	15117	7705	0	0	0
288519	1678	16560623589000	15118	7706	0	0	0
288520	1874	5698000	15118	7706	1	0	1
288525	1678	16560623590000	15121	7707	0	0	0
288530	1678	16560623591000	15125	7708	0	0	0
288531	1678	16560623592000	15126	7709	0	0	0
288532	1678	16560623593000	15126	7709	1	0	0
288533	1874	5702000	15126	7709	2	0	1
288537	1678	16560623594000	15128	7710	0	0	0
288539	1678	16560623595000	15129	7711	0	0	0
288540	1678	16560623596000	15129	7711	1	0	0
288541	1678	16560623597000	15129	7711	2	0	0
288542	1874	5706000	15129	7711	3	0	1
288549	1678	16560623598000	15131	7712	0	0	0
288550	1678	16560623599000	15132	7713	0	0	0
288551	1874	5710000	15132	7713	1	0	1
288552	1678	16560623600000	15133	7714	0	0	0
288553	1874	5712000	15133	7714	1	0	1
288555	1678	16560623602000	15134	7715	1	0	0
288556	1874	5714000	15134	7715	2	0	1
288560	1678	16560623603000	15137	7716	0	0	0
288561	1678	16560623604000	15138	7717	0	0	0
288562	1874	5716000	15138	7717	1	0	1
288593	1874	5708000	15146	7709	19	0	\N
288594	1874	5710000	15146	7709	20	0	\N
288595	1874	5712000	15146	7709	21	0	\N
288596	1874	5714000	15146	7709	22	0	\N
288597	1874	5716000	15146	7709	23	0	\N
288598	1874	5718000	15146	7709	24	0	\N
288599	1874	5720000	15146	7709	25	0	\N
288613	1678	16560623614000	15149	7723	0	0	\N
288614	1678	16560623615000	15149	7723	1	0	\N
288615	1874	5730000	15149	7723	2	0	\N
288616	1874	5732000	15149	7723	3	0	\N
288617	1874	5733000	15149	7723	4	0	\N
288618	1874	5735000	15149	7723	6	0	\N
288619	1678	16560623614000	15150	7723	0	0	\N
288620	1678	16560623615000	15150	7723	1	0	\N
288621	1874	5730000	15150	7723	2	0	\N
288622	1874	5732000	15150	7723	3	0	\N
288623	1874	5733000	15150	7723	4	0	\N
288624	1874	5735000	15150	7723	6	0	\N
288633	1874	5736000	15154	7724	0	0	\N
288636	1678	16560623617000	15156	7725	0	0	\N
288637	1874	5738000	15156	7725	1	0	\N
288643	1678	16560623619000	15159	7727	0	0	\N
288644	1874	5741000	15159	7727	1	0	\N
288645	1874	5742000	15159	7727	2	0	\N
288650	2124	299000000000	15161	7693	0	0	\N
288651	1678	16560623621000	15162	7729	0	0	\N
288653	1678	16560623621000	15164	7729	0	0	\N
288654	1678	16560623622000	15165	7730	0	0	\N
288655	1874	5746000	15165	7730	1	0	\N
288656	1874	5748000	15165	7730	2	0	\N
288660	1678	16560623623000	15167	7731	0	0	\N
288661	1874	5749000	15167	7731	1	0	\N
288662	1874	5751000	15167	7731	2	0	\N
288663	1874	5752000	15167	7731	3	0	\N
288664	1678	16560623623000	15168	7731	0	0	\N
288665	1874	5749000	15168	7731	1	0	\N
288666	1874	5751000	15168	7731	2	0	\N
288667	1874	5752000	15168	7731	3	0	\N
288668	1678	16560623623000	15169	7731	0	0	\N
288669	1874	5749000	15169	7731	1	0	\N
288670	1874	5751000	15169	7731	2	0	\N
288671	1874	5752000	15169	7731	3	0	\N
288672	1678	16560623623000	15170	7731	0	0	\N
288673	1874	5749000	15170	7731	1	0	\N
288674	1874	5751000	15170	7731	2	0	\N
288675	1874	5752000	15170	7731	3	0	\N
288676	1678	16560623623000	15171	7731	0	0	\N
288677	1874	5749000	15171	7731	1	0	\N
288678	1874	5751000	15171	7731	2	0	\N
288679	1874	5752000	15171	7731	3	0	\N
288680	1678	16560623623000	15172	7731	0	0	\N
288681	1874	5749000	15172	7731	1	0	\N
288682	1874	5751000	15172	7731	2	0	\N
288683	1874	5752000	15172	7731	3	0	\N
288688	1678	16560623624000	15174	7732	0	0	\N
288693	1678	16560623625000	15177	7733	0	0	\N
288694	1874	5754000	15177	7733	1	0	\N
288695	1874	5755000	15177	7733	2	0	\N
288699	1678	16560623626000	15179	7734	0	0	\N
288700	1874	5756000	15179	7734	1	0	\N
288701	1874	5758000	15179	7734	2	0	\N
288702	2125	200000000	15180	7735	0	0	\N
288703	1678	16560623627000	15180	7735	1	0	\N
288704	1678	16560623628000	15180	7735	2	0	\N
288705	2126	200000000	15180	7735	3	0	\N
288706	2123	1400000000	15180	7735	4	0	\N
288707	1874	5760000	15180	7735	5	0	\N
288717	1678	16560623629000	15183	7736	0	0	\N
288718	1678	16560623630000	15183	7736	1	0	\N
288719	1874	5762000	15183	7736	2	0	\N
288720	1678	16560623629000	15184	7736	0	0	\N
288721	1678	16560623630000	15184	7736	1	0	\N
288722	1874	5762000	15184	7736	2	0	\N
288723	1678	16560623631000	15185	7737	0	0	\N
288724	1874	5764000	15185	7737	1	0	\N
288727	1678	16560623631000	15187	7737	0	0	\N
288728	1874	5764000	15187	7737	1	0	\N
288626	1678	16560623615000	15151	7723	1	0	0
288627	1874	5730000	15151	7723	2	0	1
288628	1874	5732000	15151	7723	3	0	1
288629	1874	5733000	15151	7723	4	0	1
288630	1874	5735000	15151	7723	6	0	1
288631	1678	16560623616000	15153	7724	0	0	0
288632	1874	5736000	15153	7724	1	0	1
288634	1678	16560623617000	15155	7725	0	0	0
288635	1874	5738000	15155	7725	1	0	1
288638	1678	16560623618000	15157	7726	0	0	0
288639	1874	5739000	15157	7726	1	0	1
288640	1678	16560623619000	15158	7727	0	0	0
288641	1874	5741000	15158	7727	1	0	1
288642	1874	5742000	15158	7727	2	0	1
288646	2124	299000000000	15160	7728	0	0	0
288647	1678	16560623620000	15160	7728	1	0	0
288648	1874	5743000	15160	7728	2	0	1
288649	1874	5745000	15160	7728	3	0	1
288652	1678	16560623621000	15163	7729	0	0	0
288657	1678	16560623622000	15166	7730	0	0	0
288658	1874	5746000	15166	7730	1	0	1
288659	1874	5748000	15166	7730	2	0	1
288684	1678	16560623623000	15173	7731	0	0	0
288685	1874	5749000	15173	7731	1	0	1
288686	1874	5751000	15173	7731	2	0	1
288687	1874	5752000	15173	7731	3	0	1
288689	1678	16560623624000	15175	7732	0	0	0
288690	1678	16560623625000	15176	7733	0	0	0
288691	1874	5754000	15176	7733	1	0	1
288692	1874	5755000	15176	7733	2	0	1
288696	1678	16560623626000	15178	7734	0	0	0
288697	1874	5756000	15178	7734	1	0	1
288698	1874	5758000	15178	7734	2	0	1
288708	2125	200000000	15181	7735	0	0	0
288709	1678	16560623627000	15181	7735	1	0	0
288710	1678	16560623628000	15181	7735	2	0	0
288711	2126	200000000	15181	7735	3	0	0
288712	2123	1400000000	15181	7735	4	0	0
288713	1874	5760000	15181	7735	5	0	1
288714	1678	16560623629000	15182	7736	0	0	0
288715	1678	16560623630000	15182	7736	1	0	0
288716	1874	5762000	15182	7736	2	0	1
288725	1678	16560623631000	15186	7737	0	0	0
288726	1874	5764000	15186	7737	1	0	1
288730	1678	16560623633000	15189	7739	0	0	\N
288731	1678	16560623634000	15189	7739	1	0	\N
288732	1678	16560623635000	15189	7739	2	0	\N
288733	1407	0	15189	7739	4	0	\N
288734	1403	0	15189	7739	5	0	\N
288735	1874	5765000	15189	7739	6	0	\N
288736	1874	5767000	15189	7739	7	0	\N
288737	1874	5768000	15189	7739	8	0	\N
288738	1874	5770000	15189	7739	9	0	\N
288739	1874	5771000	15189	7739	10	0	\N
288757	1678	16560623638000	15194	7742	0	0	\N
288758	1874	5775000	15194	7742	1	0	\N
288759	1874	5777000	15194	7742	2	0	\N
288762	2124	299000000000	15196	7710	0	0	\N
288763	1678	16560623608000	15196	7710	1	0	\N
288764	1678	16560623609000	15196	7710	2	0	\N
288765	1678	16560623610000	15196	7710	3	0	\N
288766	1678	16560623611000	15196	7710	4	0	\N
288767	1678	16560623612000	15196	7710	5	0	\N
288768	1678	16560623613000	15196	7710	6	0	\N
288769	1678	16560623614000	15196	7710	7	0	\N
288770	1678	16560623615000	15196	7710	8	0	\N
288771	1678	16560623616000	15196	7710	9	0	\N
288772	1678	16560623617000	15196	7710	10	0	\N
288773	1678	16560623618000	15196	7710	11	0	\N
288774	1678	16560623619000	15196	7710	12	0	\N
288775	1678	16560623620000	15196	7710	13	0	\N
288776	1678	16560623621000	15196	7710	14	0	\N
288777	1678	16560623622000	15196	7710	15	0	\N
288778	1678	16560623623000	15196	7710	16	0	\N
288779	1678	16560623624000	15196	7710	17	0	\N
288780	1678	16560623625000	15196	7710	18	0	\N
288781	1678	16560623626000	15196	7710	19	0	\N
288782	1678	16560623627000	15196	7710	20	0	\N
288783	1678	16560623628000	15196	7710	21	0	\N
288784	1678	16560623629000	15196	7710	22	0	\N
288785	1678	16560623630000	15196	7710	23	0	\N
288786	1678	16560623631000	15196	7710	24	0	\N
288787	1678	16560623632000	15196	7710	25	0	\N
288788	1678	16560623633000	15196	7710	26	0	\N
288789	1678	16560623634000	15196	7710	27	0	\N
288790	1678	16560623635000	15196	7710	28	0	\N
288791	1678	16560623636000	15196	7710	29	0	\N
288792	1678	16560623637000	15196	7710	30	0	\N
288793	1678	16560623638000	15196	7710	31	0	\N
288794	1678	16560623639000	15196	7710	32	0	\N
288795	1874	5722000	15196	7710	33	0	\N
288796	1874	5723000	15196	7710	34	0	\N
288797	2123	200000000	15196	7710	35	0	\N
288798	1874	5725000	15196	7710	36	0	\N
288799	1874	5726000	15196	7710	37	0	\N
288800	1874	5728000	15196	7710	38	0	\N
288801	1874	5729000	15196	7710	39	0	\N
288802	1874	5730000	15196	7710	40	0	\N
288803	1874	5732000	15196	7710	41	0	\N
288804	1874	5733000	15196	7710	42	0	\N
288805	1874	5735000	15196	7710	43	0	\N
288806	1874	5736000	15196	7710	45	0	\N
288807	1874	5738000	15196	7710	46	0	\N
288808	1874	5739000	15196	7710	47	0	\N
288809	1874	5741000	15196	7710	48	0	\N
288810	1874	5742000	15196	7710	49	0	\N
288811	1874	5743000	15196	7710	50	0	\N
288812	1874	5745000	15196	7710	51	0	\N
288813	1874	5746000	15196	7710	52	0	\N
288814	1874	5748000	15196	7710	53	0	\N
288815	1874	5749000	15196	7710	54	0	\N
288816	1874	5751000	15196	7710	55	0	\N
288817	1874	5752000	15196	7710	56	0	\N
288818	1874	5754000	15196	7710	57	0	\N
288819	1874	5755000	15196	7710	58	0	\N
288820	1874	5756000	15196	7710	59	0	\N
288821	1874	5758000	15196	7710	60	0	\N
288822	2125	200000000	15196	7710	61	0	\N
288823	2126	200000000	15196	7710	62	0	\N
288824	2123	1400000000	15196	7710	63	0	\N
288825	1874	5760000	15196	7710	64	0	\N
288826	1874	5762000	15196	7710	65	0	\N
288827	1874	5764000	15196	7710	66	0	\N
288828	1874	5765000	15196	7710	67	0	\N
288829	1874	5767000	15196	7710	68	0	\N
288830	1874	5768000	15196	7710	69	0	\N
288831	1874	5770000	15196	7710	70	0	\N
288832	1874	5771000	15196	7710	71	0	\N
288833	1874	5773000	15196	7710	72	0	\N
288834	1874	5774000	15196	7710	73	0	\N
288835	1874	5775000	15196	7710	74	0	\N
288836	1874	5777000	15196	7710	75	0	\N
288837	1874	5778000	15196	7710	76	0	\N
288838	1678	16560623640000	15197	7744	0	0	\N
288839	1874	5780000	15197	7744	1	0	\N
288842	1678	16560623641000	15199	7745	0	0	\N
288843	1874	5781000	15199	7745	1	0	\N
288844	1874	5783000	15199	7745	2	0	\N
288848	1678	16560623642000	15201	7746	0	0	\N
288849	1874	5784000	15201	7746	1	0	\N
288852	1678	16560623643000	15203	7747	0	0	\N
288853	1874	5786000	15203	7747	1	0	\N
288854	1874	5787000	15203	7747	2	0	\N
288855	1678	16560623643000	15204	7747	0	0	\N
288856	1874	5786000	15204	7747	1	0	\N
288857	1874	5787000	15204	7747	2	0	\N
288858	1874	5786000	15205	7747	0	0	\N
288859	1874	5787000	15205	7747	1	0	\N
288863	1678	16560623643000	15207	7747	0	0	\N
288864	1874	5786000	15207	7747	1	0	\N
288741	1678	16560623634000	15190	7739	1	0	0
288742	1678	16560623635000	15190	7739	2	0	0
288743	1407	0	15190	7739	4	0	0
288744	1403	0	15190	7739	5	0	0
288745	1874	5765000	15190	7739	6	0	1
288747	1874	5768000	15190	7739	8	0	1
288748	1874	5770000	15190	7739	9	0	1
288749	1874	5771000	15190	7739	10	0	1
288750	1678	16560623636000	15191	7740	0	0	0
288751	1874	5773000	15191	7740	1	0	1
288753	1874	5774000	15192	7741	1	0	1
288754	1678	16560623638000	15193	7742	0	0	0
288755	1874	5775000	15193	7742	1	0	1
288756	1874	5777000	15193	7742	2	0	1
288761	1874	5778000	15195	7743	1	0	1
288840	1678	16560623640000	15198	7744	0	0	0
288841	1874	5780000	15198	7744	1	0	1
288845	1678	16560623641000	15200	7745	0	0	0
288846	1874	5781000	15200	7745	1	0	1
288850	1678	16560623642000	15202	7746	0	0	0
288851	1874	5784000	15202	7746	1	0	1
288860	1678	16560623643000	15206	7747	0	0	0
288861	1874	5786000	15206	7747	1	0	1
288862	1874	5787000	15206	7747	2	0	1
288865	1874	5787000	15207	7747	2	0	\N
288866	1678	16560623644000	15208	7748	0	0	\N
288867	1678	16560623645000	15208	7748	1	0	\N
288868	1874	5788000	15208	7748	2	0	\N
288869	1874	5790000	15208	7748	3	0	\N
288879	1678	16560623648000	15212	7751	0	0	\N
288880	1874	5796000	15212	7751	1	0	\N
288883	1678	16560623648000	15214	7751	0	0	\N
288884	1874	5796000	15214	7751	1	0	\N
288887	1678	16560623649000	15216	7752	0	0	\N
288888	1874	5797000	15216	7752	1	0	\N
288894	1678	16560623652000	15218	7754	0	0	\N
288895	1678	16560623653000	15218	7754	1	0	\N
288896	1874	5803000	15218	7754	2	0	\N
288897	1874	5804000	15218	7754	3	0	\N
288898	1874	5806000	15218	7754	4	0	\N
288899	1678	16560623652000	15219	7754	0	0	\N
288900	1678	16560623653000	15219	7754	1	0	\N
288901	1874	5803000	15219	7754	2	0	\N
288902	1874	5804000	15219	7754	3	0	\N
288903	1874	5806000	15219	7754	4	0	\N
288909	1678	16560623652000	15221	7754	0	0	\N
288910	1678	16560623653000	15221	7754	1	0	\N
288911	1874	5803000	15221	7754	2	0	\N
288912	1874	5804000	15221	7754	3	0	\N
288913	1874	5806000	15221	7754	4	0	\N
288916	1678	16560623654000	15223	7755	0	0	\N
288917	1874	5807000	15223	7755	1	0	\N
288918	1678	16560623654000	15224	7755	0	0	\N
288919	1874	5807000	15224	7755	1	0	\N
288920	1678	16560623655000	15225	7756	0	0	\N
288921	1874	5809000	15225	7756	1	0	\N
288922	1874	5810000	15225	7756	2	0	\N
288923	1678	16560623655000	15226	7756	0	0	\N
288924	1874	5809000	15226	7756	1	0	\N
288925	1874	5810000	15226	7756	2	0	\N
288930	1678	16560623656000	15229	7757	0	0	\N
288931	1678	16560623656000	15230	7757	0	0	\N
288935	1678	16560623658000	15232	7759	0	0	\N
288936	1874	5814000	15232	7759	1	0	\N
288937	1874	5816000	15232	7759	2	0	\N
288938	1678	16560623658000	15233	7759	0	0	\N
288939	1874	5814000	15233	7759	1	0	\N
288940	1874	5816000	15233	7759	2	0	\N
288944	1678	16560623659000	15235	7760	0	0	\N
288945	1874	5817000	15235	7760	1	0	\N
288948	1678	16560623659000	15237	7760	0	0	\N
288949	1874	5817000	15237	7760	1	0	\N
288950	1678	16560623659000	15238	7760	0	0	\N
288951	1874	5817000	15238	7760	1	0	\N
288968	1678	16560623666000	15244	7765	0	0	\N
288969	1874	5830000	15244	7765	1	0	\N
288977	1678	16560623670000	15247	7768	0	0	\N
288978	1678	16560623671000	15247	7768	1	0	\N
288979	1678	16560623672000	15247	7768	2	0	\N
288980	1874	5837000	15247	7768	3	0	\N
288981	1874	5839000	15247	7768	4	0	\N
288982	1874	5840000	15247	7768	5	0	\N
288983	1874	5842000	15247	7768	6	0	\N
288991	1678	16560623673000	15249	7769	0	0	\N
288992	1874	5843000	15249	7769	1	0	\N
288993	1874	5845000	15249	7769	2	0	\N
288999	1678	16560623675000	15252	7771	0	0	\N
289000	1678	16560623676000	15252	7771	1	0	\N
288872	1874	5788000	15209	7748	2	0	1
288873	1874	5790000	15209	7748	3	0	1
288874	1678	16560623646000	15210	7749	0	0	0
288875	1874	5791000	15210	7749	1	0	1
288876	1874	5793000	15210	7749	2	0	1
288878	1874	5794000	15211	7750	1	0	1
288881	1678	16560623648000	15213	7751	0	0	0
288882	1874	5796000	15213	7751	1	0	1
288885	1678	16560623649000	15215	7752	0	0	0
288886	1874	5797000	15215	7752	1	0	1
288890	1678	16560623651000	15217	7753	1	0	0
288891	1874	5799000	15217	7753	2	0	1
288892	1874	5800000	15217	7753	3	0	1
288893	1874	5801000	15217	7753	4	0	1
288905	1678	16560623653000	15220	7754	1	0	0
288906	1874	5803000	15220	7754	2	0	1
288907	1874	5804000	15220	7754	3	0	1
288908	1874	5806000	15220	7754	4	0	1
288914	1678	16560623654000	15222	7755	0	0	0
288926	1678	16560623655000	15227	7756	0	0	0
288927	1874	5809000	15227	7756	1	0	1
288928	1874	5810000	15227	7756	2	0	1
288929	1678	16560623656000	15228	7757	0	0	0
288932	1678	16560623657000	15231	7758	0	0	0
288934	1874	5813000	15231	7758	2	0	1
288941	1678	16560623658000	15234	7759	0	0	0
288942	1874	5814000	15234	7759	1	0	1
288943	1874	5816000	15234	7759	2	0	1
288947	1874	5817000	15236	7760	1	0	1
288952	1678	16560623660000	15239	7761	0	0	0
288953	1874	5819000	15239	7761	1	0	1
288954	1678	16560623661000	15240	7762	0	0	0
288955	1874	5820000	15240	7762	1	0	1
288957	1678	16560623663000	15241	7763	1	0	0
288958	1678	16560623664000	15241	7763	2	0	0
288959	1874	5822000	15241	7763	3	0	1
288960	1874	5823000	15241	7763	4	0	1
288961	1874	5825000	15241	7763	5	0	1
288963	1678	16560623665000	15242	7764	0	0	0
288964	1874	5827000	15242	7764	1	0	1
288965	1874	5829000	15242	7764	2	0	1
288966	1678	16560623666000	15243	7765	0	0	0
288970	1678	16560623667000	15245	7766	0	0	0
288971	1678	16560623668000	15245	7766	1	0	0
288972	1874	5832000	15245	7766	2	0	1
288973	1874	5833000	15245	7766	3	0	1
288974	1874	5835000	15245	7766	4	0	1
288976	1874	5836000	15246	7767	1	0	1
288984	1678	16560623670000	15248	7768	0	0	0
288985	1678	16560623671000	15248	7768	1	0	0
288986	1678	16560623672000	15248	7768	2	0	0
288987	1874	5837000	15248	7768	3	0	1
288989	1874	5840000	15248	7768	5	0	1
288990	1874	5842000	15248	7768	6	0	1
288994	1678	16560623673000	15250	7769	0	0	0
288995	1874	5843000	15250	7769	1	0	1
288997	1678	16560623674000	15251	7770	0	0	0
288998	1874	5846000	15251	7770	1	0	1
289001	1874	5848000	15252	7771	2	0	\N
289002	1874	5849000	15252	7771	3	0	\N
289007	1678	16560623675000	15254	7771	0	0	\N
289008	1678	16560623676000	15254	7771	1	0	\N
289009	1874	5848000	15254	7771	2	0	\N
289010	1874	5849000	15254	7771	3	0	\N
289011	1678	16560623675000	15255	7771	0	0	\N
289012	1678	16560623676000	15255	7771	1	0	\N
289013	1874	5848000	15255	7771	2	0	\N
289014	1874	5849000	15255	7771	3	0	\N
289025	1678	16560623677000	15257	7772	0	0	\N
289026	1678	16560623678000	15257	7772	1	0	\N
289027	1678	16560623679000	15257	7772	2	0	\N
289028	1678	16560623680000	15257	7772	3	0	\N
289029	1874	5850000	15257	7772	4	0	\N
289030	1874	5852000	15257	7772	5	0	\N
289031	1874	5853000	15257	7772	6	0	\N
289032	1874	5855000	15257	7772	7	0	\N
289033	1874	5856000	15257	7772	8	0	\N
289034	1874	5858000	15257	7772	10	0	\N
289035	1678	16560623677000	15258	7772	0	0	\N
289036	1678	16560623678000	15258	7772	1	0	\N
289037	1678	16560623679000	15258	7772	2	0	\N
289038	1678	16560623680000	15258	7772	3	0	\N
289039	1874	5850000	15258	7772	4	0	\N
289040	1874	5852000	15258	7772	5	0	\N
289041	1874	5853000	15258	7772	6	0	\N
289042	1874	5855000	15258	7772	7	0	\N
289043	1874	5856000	15258	7772	8	0	\N
289044	1874	5858000	15258	7772	10	0	\N
289047	1678	16560623681000	15260	7773	0	0	\N
289048	1874	5859000	15260	7773	1	0	\N
289049	1678	16560623682000	15261	7774	0	0	\N
289050	1874	5861000	15261	7774	1	0	\N
289051	1874	5862000	15261	7774	2	0	\N
289058	1678	16560623684000	15264	7776	0	0	\N
289060	1678	16560623684000	15266	7776	0	0	\N
289061	1678	16560623685000	15267	7777	0	0	\N
289062	1678	16560623686000	15267	7777	1	0	\N
289063	1874	5866000	15267	7777	2	0	\N
289064	1874	5868000	15267	7777	3	0	\N
289065	1874	5869000	15267	7777	4	0	\N
289071	1678	16560623685000	15269	7777	0	0	\N
289072	1678	16560623686000	15269	7777	1	0	\N
289073	1874	5866000	15269	7777	2	0	\N
289074	1874	5868000	15269	7777	3	0	\N
289075	1874	5869000	15269	7777	4	0	\N
289076	1678	16560623687000	15270	7778	0	0	\N
289077	2128	200000000	15270	7778	1	0	\N
289078	1874	5871000	15270	7778	2	0	\N
289079	1874	5872000	15270	7778	3	0	\N
289094	1678	16560623689000	15274	7780	0	0	\N
289095	1678	16560623690000	15274	7780	1	0	\N
289096	1678	16560623691000	15274	7780	2	0	\N
289097	1874	5875000	15274	7780	3	0	\N
289098	1694	13692463127629	15274	7780	4	0	\N
289099	1874	5876000	15274	7780	5	0	\N
289100	1874	5878000	15274	7780	6	0	\N
289101	1874	5879000	15274	7780	7	0	\N
289106	1678	16560623692000	15276	7781	0	0	\N
289107	1678	16560623693000	15276	7781	1	0	\N
289108	1874	5881000	15276	7781	2	0	\N
289109	1874	5882000	15276	7781	3	0	\N
289110	1694	13692463127629	15277	7753	0	0	\N
289111	1678	16560623694000	15278	7782	0	0	\N
289112	1874	5884000	15278	7782	1	0	\N
289113	1874	5885000	15278	7782	2	0	\N
289117	1678	16560623694000	15280	7782	0	0	\N
289118	1874	5884000	15280	7782	1	0	\N
289119	1874	5885000	15280	7782	2	0	\N
289128	1678	16560623699000	15285	7787	0	0	\N
289129	1678	16560623700000	15285	7787	1	0	\N
289130	1678	16560623701000	15285	7787	2	0	\N
289131	1678	16560623702000	15285	7787	3	0	\N
289132	1874	5892000	15285	7787	4	0	\N
289133	1874	5893000	15285	7787	5	0	\N
289134	1874	5895000	15285	7787	6	0	\N
289135	1874	5896000	15285	7787	7	0	\N
289136	1874	5897000	15285	7787	8	0	\N
289005	1874	5848000	15253	7771	2	0	1
289006	1874	5849000	15253	7771	3	0	1
289015	1678	16560623677000	15256	7772	0	0	0
289016	1678	16560623678000	15256	7772	1	0	0
289017	1678	16560623679000	15256	7772	2	0	0
289019	1874	5850000	15256	7772	4	0	1
289020	1874	5852000	15256	7772	5	0	1
289021	1874	5853000	15256	7772	6	0	1
289022	1874	5855000	15256	7772	7	0	1
289023	1874	5856000	15256	7772	8	0	1
289045	1678	16560623681000	15259	7773	0	0	0
289046	1874	5859000	15259	7773	1	0	1
289052	1678	16560623682000	15262	7774	0	0	0
289053	1874	5861000	15262	7774	1	0	1
289055	1678	16560623683000	15263	7775	0	0	0
289056	1874	5863000	15263	7775	1	0	1
289057	1874	5865000	15263	7775	2	0	1
289059	1678	16560623684000	15265	7776	0	0	0
289066	1678	16560623685000	15268	7777	0	0	0
289068	1874	5866000	15268	7777	2	0	1
289069	1874	5868000	15268	7777	3	0	1
289070	1874	5869000	15268	7777	4	0	1
289080	1678	16560623687000	15271	7778	0	0	0
289081	2128	200000000	15271	7778	1	0	0
289083	1874	5872000	15271	7778	3	0	1
289084	1678	16560623688000	15272	7779	0	0	0
289085	1874	5874000	15272	7779	1	0	1
289086	1678	16560623689000	15273	7780	0	0	0
289088	1678	16560623691000	15273	7780	2	0	0
289089	1874	5875000	15273	7780	3	0	1
289090	1694	13692463127629	15273	7780	4	0	34
289091	1874	5876000	15273	7780	5	0	1
289092	1874	5878000	15273	7780	6	0	1
289102	1678	16560623692000	15275	7781	0	0	0
289103	1678	16560623693000	15275	7781	1	0	0
289104	1874	5881000	15275	7781	2	0	1
289105	1874	5882000	15275	7781	3	0	1
289114	1678	16560623694000	15279	7782	0	0	0
289116	1874	5885000	15279	7782	2	0	1
289120	1678	16560623695000	15281	7783	0	0	0
289121	1874	5886000	15281	7783	1	0	1
289122	1678	16560623696000	15282	7784	0	0	0
289124	1874	5887000	15283	7785	1	0	1
289125	1874	5889000	15283	7785	2	0	1
289126	1678	16560623698000	15284	7786	0	0	0
289127	1874	5890000	15284	7786	1	0	1
289137	1874	5899000	15285	7787	9	0	\N
289164	1678	16560623710000	15293	7794	0	0	\N
289165	1874	5913000	15293	7794	1	0	\N
289166	1874	5915000	15293	7794	2	0	\N
289172	2124	299000000000	15296	7530	0	0	\N
289173	2115	1000000000	15296	7530	1	0	\N
289174	606	72137736812962	15296	7530	2	0	\N
289175	1483	10000000	15296	7530	3	0	\N
289176	2085	1100970000000	15296	7530	4	0	\N
289177	532	68880037000000	15296	7530	5	0	\N
289178	1760	501000000000	15296	7530	6	0	\N
289179	1745	1803000000	15296	7530	8	0	\N
289180	1483	10000000	15296	7530	9	0	\N
289181	1678	16560623712000	15297	7796	0	0	\N
289182	1874	5918000	15297	7796	1	0	\N
289185	1678	16560623712000	15299	7796	0	0	\N
289186	1874	5918000	15299	7796	1	0	\N
289187	1678	16560623713000	15302	7798	0	0	\N
289188	1678	16560623714000	15302	7798	1	0	\N
289189	1678	16560623715000	15302	7798	2	0	\N
289190	1874	5919000	15302	7798	3	0	\N
289199	1678	16560623696000	15304	7784	0	0	\N
289200	1678	16560623697000	15304	7784	1	0	\N
289201	1678	16560623698000	15304	7784	2	0	\N
289202	1678	16560623699000	15304	7784	3	0	\N
289203	1678	16560623700000	15304	7784	4	0	\N
289204	1678	16560623701000	15304	7784	5	0	\N
289205	1678	16560623702000	15304	7784	6	0	\N
289206	1678	16560623703000	15304	7784	7	0	\N
289207	1678	16560623704000	15304	7784	8	0	\N
289208	1678	16560623705000	15304	7784	9	0	\N
289209	1678	16560623706000	15304	7784	10	0	\N
289210	1678	16560623707000	15304	7784	11	0	\N
289211	1678	16560623708000	15304	7784	12	0	\N
289212	1678	16560623709000	15304	7784	13	0	\N
289213	1678	16560623710000	15304	7784	14	0	\N
289214	1678	16560623711000	15304	7784	15	0	\N
289215	1678	16560623712000	15304	7784	16	0	\N
289216	1678	16560623713000	15304	7784	17	0	\N
289217	1678	16560623714000	15304	7784	18	0	\N
289218	1678	16560623715000	15304	7784	19	0	\N
289219	1874	5887000	15304	7784	20	0	\N
289220	1874	5889000	15304	7784	21	0	\N
289221	1874	5890000	15304	7784	22	0	\N
289222	1874	5892000	15304	7784	23	0	\N
289223	1874	5893000	15304	7784	24	0	\N
289224	1874	5895000	15304	7784	25	0	\N
289225	1874	5896000	15304	7784	26	0	\N
289226	1874	5897000	15304	7784	27	0	\N
289227	1874	5899000	15304	7784	28	0	\N
289228	1874	5900000	15304	7784	29	0	\N
289229	1874	5902000	15304	7784	30	0	\N
289230	1874	5903000	15304	7784	31	0	\N
289231	1874	5905000	15304	7784	32	0	\N
289232	1874	5906000	15304	7784	33	0	\N
289233	1874	5908000	15304	7784	34	0	\N
289234	1874	5909000	15304	7784	35	0	\N
289235	1874	5910000	15304	7784	36	0	\N
289236	1874	5912000	15304	7784	37	0	\N
289237	1874	5913000	15304	7784	38	0	\N
289238	1874	5915000	15304	7784	39	0	\N
289239	1874	5916000	15304	7784	40	0	\N
289240	1874	5918000	15304	7784	41	0	\N
289241	1874	5919000	15304	7784	42	0	\N
289242	1874	5921000	15304	7784	43	0	\N
289243	1874	5922000	15304	7784	44	0	\N
289244	1874	5923000	15304	7784	45	0	\N
289245	1874	5925000	15304	7784	46	0	\N
289246	1678	16560623713000	15305	7798	0	0	\N
289247	1678	16560623714000	15305	7798	1	0	\N
289248	1678	16560623715000	15305	7798	2	0	\N
289249	1874	5919000	15305	7798	3	0	\N
289250	1874	5921000	15305	7798	4	0	\N
289251	1874	5922000	15305	7798	5	0	\N
289252	1874	5923000	15305	7798	6	0	\N
289253	1874	5925000	15305	7798	7	0	\N
289254	1678	16560623713000	15306	7798	0	0	\N
289255	1678	16560623714000	15306	7798	1	0	\N
289256	1678	16560623715000	15306	7798	2	0	\N
289257	1874	5919000	15306	7798	3	0	\N
289258	1874	5921000	15306	7798	4	0	\N
289259	1874	5922000	15306	7798	5	0	\N
289260	1874	5923000	15306	7798	6	0	\N
289261	1874	5925000	15306	7798	7	0	\N
289262	1678	16560623716000	15307	7799	0	0	\N
289264	1678	16560623717000	15309	7800	0	0	\N
289265	1874	5926000	15309	7800	1	0	\N
289266	1874	5928000	15309	7800	2	0	\N
289272	1678	16560623718000	15312	7801	0	0	\N
289140	1678	16560623701000	15286	7787	2	0	0
289141	1678	16560623702000	15286	7787	3	0	0
289142	1874	5892000	15286	7787	4	0	1
289143	1874	5893000	15286	7787	5	0	1
289144	1874	5895000	15286	7787	6	0	1
289146	1874	5897000	15286	7787	8	0	1
289147	1874	5899000	15286	7787	9	0	1
289148	1678	16560623703000	15287	7788	0	0	0
289149	1874	5900000	15287	7788	1	0	1
289150	1678	16560623704000	15288	7789	0	0	0
289152	1874	5902000	15288	7789	2	0	1
289153	1874	5903000	15288	7789	3	0	1
289154	1874	5905000	15288	7789	4	0	1
289155	1678	16560623706000	15289	7790	0	0	0
289157	1678	16560623707000	15290	7791	0	0	0
289158	1874	5908000	15290	7791	1	0	1
289159	1874	5909000	15290	7791	2	0	1
289160	1678	16560623708000	15291	7792	0	0	0
289161	1678	16560623709000	15292	7793	0	0	0
289163	1874	5912000	15292	7793	2	0	1
289167	1678	16560623710000	15294	7794	0	0	0
289168	1874	5913000	15294	7794	1	0	1
289169	1874	5915000	15294	7794	2	0	1
289170	1678	16560623711000	15295	7795	0	0	0
289183	1678	16560623712000	15298	7796	0	0	0
289184	1874	5918000	15298	7796	1	0	1
289191	1678	16560623713000	15303	7798	0	0	0
289192	1678	16560623714000	15303	7798	1	0	0
289194	1874	5919000	15303	7798	3	0	1
289195	1874	5921000	15303	7798	4	0	1
289196	1874	5922000	15303	7798	5	0	1
289197	1874	5923000	15303	7798	6	0	1
289198	1874	5925000	15303	7798	7	0	1
289267	1678	16560623717000	15310	7800	0	0	0
289268	1874	5926000	15310	7800	1	0	1
289269	1874	5928000	15310	7800	2	0	1
289270	1678	16560623718000	15311	7801	0	0	0
289271	1874	5929000	15311	7801	1	0	1
289273	1874	5929000	15312	7801	1	0	\N
289274	1678	16560623719000	15313	7802	0	0	\N
289275	1874	5931000	15313	7802	1	0	\N
289276	1874	5932000	15313	7802	2	0	\N
289287	1678	16560623723000	15317	7805	0	0	\N
289288	1874	5939000	15317	7805	1	0	\N
289301	1678	16560623728000	15322	7809	0	0	\N
289303	1678	16560623729000	15324	7810	0	0	\N
289304	1874	5949000	15324	7810	1	0	\N
289305	1874	5951000	15324	7810	2	0	\N
289314	1678	16560623731000	15328	7812	0	0	\N
289315	1874	5955000	15328	7812	1	0	\N
289323	1678	16560623735000	15330	7814	0	0	\N
289324	1874	5962000	15330	7814	1	0	\N
289325	1874	5964000	15330	7814	2	0	\N
289329	1678	16560623735000	15332	7814	0	0	\N
289330	1874	5962000	15332	7814	1	0	\N
289331	1874	5964000	15332	7814	2	0	\N
289338	1678	16560623738000	15335	7816	0	0	\N
289339	1874	5968000	15335	7816	1	0	\N
289340	1678	16560623739000	15336	7817	0	0	\N
289341	1678	16560623740000	15336	7817	1	0	\N
289342	1678	16560623741000	15336	7817	2	0	\N
289343	1874	5970000	15336	7817	3	0	\N
289344	1874	5971000	15336	7817	4	0	\N
289345	1874	5973000	15336	7817	5	0	\N
289346	1874	5974000	15336	7817	6	0	\N
289347	1678	16560623739000	15337	7817	0	0	\N
289348	1678	16560623740000	15337	7817	1	0	\N
289349	1678	16560623741000	15337	7817	2	0	\N
289350	1874	5970000	15337	7817	3	0	\N
289351	1874	5971000	15337	7817	4	0	\N
289352	1874	5973000	15337	7817	5	0	\N
289353	1874	5974000	15337	7817	6	0	\N
289354	1678	16560623739000	15338	7817	0	0	\N
289355	1678	16560623740000	15338	7817	1	0	\N
289356	1678	16560623741000	15338	7817	2	0	\N
289357	1874	5970000	15338	7817	3	0	\N
289358	1874	5971000	15338	7817	4	0	\N
289359	1874	5973000	15338	7817	5	0	\N
289360	1874	5974000	15338	7817	6	0	\N
289378	1678	16560623745000	15342	7819	0	0	\N
289379	1874	5981000	15342	7819	1	0	\N
289380	1874	5983000	15342	7819	2	0	\N
289381	1678	16560623746000	15343	7820	0	0	\N
289382	1874	5984000	15343	7820	1	0	\N
289385	1678	16560623746000	15345	7820	0	0	\N
289386	1874	5984000	15345	7820	1	0	\N
289390	1678	16560623747000	15347	7821	0	0	\N
289391	1874	5986000	15347	7821	2	0	\N
289392	1874	5987000	15347	7821	3	0	\N
289393	1678	16560623748000	15348	7822	0	0	\N
289395	1678	16560623749000	15350	7823	0	0	\N
289396	1874	5988000	15350	7823	1	0	\N
289397	1874	5990000	15350	7823	2	0	\N
289401	1678	16560623750000	15352	7824	0	0	\N
289402	1874	5991000	15352	7824	1	0	\N
289408	1678	16560623751000	15357	7825	0	0	\N
289279	1874	5932000	15314	7802	2	0	1
289280	1678	16560623720000	15315	7803	0	0	0
289281	1678	16560623721000	15315	7803	1	0	0
289282	1874	5934000	15315	7803	2	0	1
289283	1874	5935000	15315	7803	3	0	1
289285	1874	5936000	15316	7804	1	0	1
289286	1874	5938000	15316	7804	2	0	1
289289	1678	16560623723000	15318	7805	0	0	0
289290	1874	5939000	15318	7805	1	0	1
289291	1678	16560623724000	15319	7806	0	0	0
289293	1678	16560623725000	15320	7807	0	0	0
289294	1678	16560623726000	15320	7807	1	0	0
289295	1874	5942000	15320	7807	2	0	1
289296	1874	5944000	15320	7807	3	0	1
289298	1678	16560623727000	15321	7808	0	0	0
289299	1874	5947000	15321	7808	1	0	1
289300	1874	5948000	15321	7808	2	0	1
289302	1678	16560623728000	15323	7809	0	0	0
289306	1678	16560623729000	15325	7810	0	0	0
289308	1874	5951000	15325	7810	2	0	1
289309	1678	16560623730000	15326	7811	0	0	0
289310	1874	5952000	15326	7811	1	0	1
289311	1874	5954000	15326	7811	2	0	1
289312	1678	16560623731000	15327	7812	0	0	0
289316	1678	16560623732000	15329	7813	0	0	0
289317	1678	16560623733000	15329	7813	1	0	0
289318	1678	16560623734000	15329	7813	2	0	0
289319	1874	5957000	15329	7813	3	0	1
289321	1874	5960000	15329	7813	5	0	1
289322	1874	5961000	15329	7813	6	0	1
289326	1678	16560623735000	15331	7814	0	0	0
289327	1874	5962000	15331	7814	1	0	1
289328	1874	5964000	15331	7814	2	0	1
289333	1678	16560623737000	15333	7815	1	0	0
289334	1874	5965000	15333	7815	2	0	1
289335	1874	5967000	15333	7815	3	0	1
289336	1678	16560623738000	15334	7816	0	0	0
289337	1874	5968000	15334	7816	1	0	1
289362	1678	16560623740000	15339	7817	1	0	0
289363	1678	16560623741000	15339	7817	2	0	0
289364	1874	5970000	15339	7817	3	0	1
289365	1874	5971000	15339	7817	4	0	1
289367	1874	5974000	15339	7817	6	0	1
289368	1678	16560623742000	15340	7818	0	0	0
289369	1678	16560623743000	15340	7818	1	0	0
289370	1678	16560623744000	15340	7818	2	0	0
289371	1874	5975000	15340	7818	3	0	1
289373	1874	5978000	15340	7818	5	0	1
289374	1874	5980000	15340	7818	6	0	1
289375	1678	16560623745000	15341	7819	0	0	0
289376	1874	5981000	15341	7819	1	0	1
289377	1874	5983000	15341	7819	2	0	1
289384	1874	5984000	15344	7820	1	0	1
289387	1678	16560623747000	15346	7821	0	0	0
289388	1874	5986000	15346	7821	2	0	1
289389	1874	5987000	15346	7821	3	0	1
289398	1678	16560623749000	15351	7823	0	0	0
289399	1874	5988000	15351	7823	1	0	1
289400	1874	5990000	15351	7823	2	0	1
289403	1678	16560623750000	15353	7824	0	0	0
289404	1874	5991000	15353	7824	1	0	1
289406	1874	5993000	15356	7825	1	0	1
289407	1874	5994000	15356	7825	2	0	1
289409	1874	5993000	15357	7825	1	0	\N
289410	1874	5994000	15357	7825	2	0	\N
289415	1678	16560623753000	15361	7827	0	0	\N
289416	1874	5997000	15361	7827	1	0	\N
289422	1678	16560623754000	15365	7828	0	0	\N
289423	1678	16560623755000	15365	7828	1	0	\N
289424	1874	5999000	15365	7828	2	0	\N
289425	1874	6000000	15365	7828	3	0	\N
289426	1874	6001000	15365	7828	4	0	\N
289427	1678	16560623754000	15366	7828	0	0	\N
289428	1678	16560623755000	15366	7828	1	0	\N
289429	1874	5999000	15366	7828	2	0	\N
289430	1874	6000000	15366	7828	3	0	\N
289431	1874	6001000	15366	7828	4	0	\N
289432	1678	16560623754000	15367	7828	0	0	\N
289433	1678	16560623755000	15367	7828	1	0	\N
289434	1874	5999000	15367	7828	2	0	\N
289435	1874	6000000	15367	7828	3	0	\N
289436	1874	6001000	15367	7828	4	0	\N
289437	1678	16560623756000	15368	7829	0	0	\N
289438	1678	16560623757000	15368	7829	1	0	\N
289439	1874	6003000	15368	7829	2	0	\N
289440	1874	6004000	15368	7829	3	0	\N
289441	1874	6006000	15368	7829	4	0	\N
289449	1678	16560623759000	15371	7831	0	0	\N
289450	1874	6009000	15371	7831	1	0	\N
289451	1874	6010000	15371	7831	2	0	\N
289456	1678	16560623760000	15374	7832	0	0	\N
289457	1678	16560623760000	15375	7832	0	0	\N
289458	1678	16560623750000	15377	7824	0	0	\N
289459	1678	16560623751000	15377	7824	1	0	\N
289460	1678	16560623752000	15377	7824	2	0	\N
289461	1678	16560623753000	15377	7824	3	0	\N
289462	1678	16560623754000	15377	7824	4	0	\N
289463	1678	16560623755000	15377	7824	5	0	\N
289464	1678	16560623756000	15377	7824	6	0	\N
289465	1678	16560623757000	15377	7824	7	0	\N
289466	1678	16560623758000	15377	7824	8	0	\N
289467	1678	16560623759000	15377	7824	9	0	\N
289468	1678	16560623760000	15377	7824	10	0	\N
289469	1678	16560623761000	15377	7824	11	0	\N
289470	1678	16560623762000	15377	7824	12	0	\N
289471	1874	5991000	15377	7824	13	0	\N
289472	1874	5993000	15377	7824	14	0	\N
289473	1874	5994000	15377	7824	15	0	\N
289474	1874	5996000	15377	7824	16	0	\N
289475	1874	5997000	15377	7824	17	0	\N
289476	1874	5999000	15377	7824	18	0	\N
289477	1874	6000000	15377	7824	19	0	\N
289478	1874	6001000	15377	7824	20	0	\N
289479	1874	6003000	15377	7824	21	0	\N
289480	1874	6004000	15377	7824	22	0	\N
289481	1874	6006000	15377	7824	23	0	\N
289482	1874	6007000	15377	7824	24	0	\N
289483	1874	6009000	15377	7824	25	0	\N
289484	1874	6010000	15377	7824	26	0	\N
289485	1874	6012000	15377	7824	27	0	\N
289486	1874	6013000	15377	7824	28	0	\N
289487	1874	6014000	15377	7824	29	0	\N
289488	1874	6016000	15377	7824	30	0	\N
289501	2124	299000000000	15380	7652	0	0	\N
289515	1678	16560623770000	15388	7838	0	0	\N
289516	1874	6030000	15388	7838	1	0	\N
289522	1678	16560623772000	15393	7840	0	0	\N
289523	1874	6035000	15393	7840	1	0	\N
289524	1678	16560623772000	15394	7840	0	0	\N
289525	1874	6035000	15394	7840	1	0	\N
289526	1403	0	15395	7653	0	0	\N
289529	1678	16560623773000	15397	7841	0	0	\N
289530	1874	6036000	15397	7841	1	0	\N
289543	1678	16560623779000	15402	7846	0	0	\N
289544	1874	6048000	15402	7846	2	0	\N
289413	1678	16560623753000	15360	7827	0	0	0
289414	1874	5997000	15360	7827	1	0	1
289417	1678	16560623754000	15364	7828	0	0	0
289418	1678	16560623755000	15364	7828	1	0	0
289419	1874	5999000	15364	7828	2	0	1
289421	1874	6001000	15364	7828	4	0	1
289442	1678	16560623756000	15369	7829	0	0	0
289443	1678	16560623757000	15369	7829	1	0	0
289444	1874	6003000	15369	7829	2	0	1
289445	1874	6004000	15369	7829	3	0	1
289447	1678	16560623758000	15370	7830	0	0	0
289448	1874	6007000	15370	7830	1	0	1
289452	1678	16560623759000	15372	7831	0	0	0
289453	1874	6009000	15372	7831	1	0	1
289455	1678	16560623760000	15373	7832	0	0	0
289489	1678	16560623761000	15378	7833	0	0	0
289490	1678	16560623762000	15378	7833	1	0	0
289491	1874	6012000	15378	7833	2	0	1
289492	1874	6013000	15378	7833	3	0	1
289494	1874	6016000	15378	7833	5	0	1
289495	1678	16560623763000	15379	7834	0	0	0
289496	1678	16560623764000	15379	7834	1	0	0
289497	1678	16560623765000	15379	7834	2	0	0
289498	1874	6017000	15379	7834	4	0	1
289500	1874	6020000	15379	7834	6	0	1
289502	1678	16560623766000	15381	7835	0	0	0
289503	1678	16560623767000	15381	7835	1	0	0
289504	1874	6022000	15381	7835	2	0	1
289506	1874	6025000	15381	7835	4	0	1
289507	1874	6026000	15381	7835	5	0	1
289508	1678	16560623768000	15383	7836	0	0	0
289509	1403	0	15383	7836	1	0	0
289510	1678	16560623769000	15385	7837	0	0	0
289512	1874	6029000	15385	7837	2	0	1
289513	1678	16560623770000	15387	7838	0	0	0
289514	1874	6030000	15387	7838	1	0	1
289517	1678	16560623771000	15391	7839	0	0	0
289518	1874	6032000	15391	7839	1	0	1
289520	1678	16560623772000	15392	7840	0	0	0
289521	1874	6035000	15392	7840	1	0	1
289527	1678	16560623773000	15396	7841	0	0	0
289528	1874	6036000	15396	7841	1	0	1
289532	1874	6038000	15398	7842	1	0	1
289533	1874	6039000	15398	7842	2	0	1
289534	1678	16560623775000	15399	7843	0	0	0
289535	1874	6040000	15399	7843	1	0	1
289536	1678	16560623776000	15400	7844	0	0	0
289538	1678	16560623777000	15401	7845	0	0	0
289539	1678	16560623778000	15401	7845	1	0	0
289540	1874	6043000	15401	7845	2	0	1
289541	1874	6045000	15401	7845	3	0	1
289542	1874	6046000	15401	7845	4	0	1
289545	1874	6049000	15402	7846	3	0	\N
289549	1678	16560623779000	15404	7846	0	0	\N
289550	1874	6048000	15404	7846	2	0	\N
289551	1874	6049000	15404	7846	3	0	\N
289559	1299	1702603897287650	15407	7849	0	0	\N
289560	1053	905559794837000	15407	7849	1	0	\N
289561	1678	16560623783000	15407	7849	2	0	\N
289562	1874	6056000	15407	7849	3	0	\N
289563	1299	1702603897287650	15408	7849	0	0	\N
289564	1053	905559794837000	15408	7849	1	0	\N
289565	1678	16560623783000	15408	7849	2	0	\N
289566	1874	6056000	15408	7849	3	0	\N
289567	1299	1702603897287650	15409	7849	0	0	\N
289568	1053	905559794837000	15409	7849	1	0	\N
289569	1678	16560623783000	15409	7849	2	0	\N
289570	1874	6056000	15409	7849	3	0	\N
289577	1678	16560623785000	15412	7851	0	0	\N
289578	1173	610999087832700	15412	7851	1	0	\N
289579	933	505337374679600	15412	7851	2	0	\N
289580	1874	6059000	15412	7851	3	0	\N
289585	1299	1702603897287650	15414	7654	0	0	\N
289586	1053	905559794837000	15414	7654	1	0	\N
289590	1678	16560623787000	15416	7853	0	0	\N
289591	1874	6063000	15416	7853	1	0	\N
289592	1874	6065000	15416	7853	2	0	\N
289593	1678	16560623787000	15417	7853	0	0	\N
289594	1874	6063000	15417	7853	1	0	\N
289595	1874	6065000	15417	7853	2	0	\N
289603	1678	16560623790000	15420	7855	0	0	\N
289604	1874	6069000	15420	7855	1	0	\N
289605	1678	16560623790000	15421	7855	0	0	\N
289606	1874	6069000	15421	7855	1	0	\N
289609	1678	16560623791000	15423	7856	0	0	\N
289610	1874	6071000	15423	7856	1	0	\N
289611	1874	6072000	15423	7856	2	0	\N
289617	1678	16560623793000	15426	7858	0	0	\N
289618	1874	6075000	15426	7858	1	0	\N
289619	1678	16560623793000	15427	7858	0	0	\N
289620	1874	6075000	15427	7858	1	0	\N
289623	1678	16560623793000	15429	7858	0	0	\N
289624	1874	6075000	15429	7858	1	0	\N
289628	1678	16560623794000	15431	7859	0	0	\N
289629	1874	6076000	15431	7859	1	0	\N
289630	1874	6078000	15431	7859	2	0	\N
289638	1678	16560623795000	15433	7860	0	0	\N
289639	1678	16560623796000	15433	7860	1	0	\N
289640	1678	16560623797000	15433	7860	2	0	\N
289641	1874	6079000	15433	7860	3	0	\N
289642	1874	6081000	15433	7860	4	0	\N
289643	1874	6082000	15433	7860	5	0	\N
289644	1874	6084000	15433	7860	6	0	\N
289654	1678	16560623800000	15436	7862	0	0	\N
289655	1678	16560623801000	15436	7862	1	0	\N
289656	1874	6089000	15436	7862	2	0	\N
289657	1874	6091000	15436	7862	3	0	\N
289658	1678	16560623802000	15437	7863	0	0	\N
289659	1678	16560623803000	15437	7863	1	0	\N
289660	1874	6092000	15437	7863	2	0	\N
289661	1874	6094000	15437	7863	3	0	\N
289662	1874	6095000	15437	7863	4	0	\N
289663	1678	16560623802000	15438	7863	0	0	\N
289664	1678	16560623803000	15438	7863	1	0	\N
289665	1874	6092000	15438	7863	2	0	\N
289666	1874	6094000	15438	7863	3	0	\N
289667	1874	6095000	15438	7863	4	0	\N
289673	1678	16560623792000	15440	7857	0	0	\N
289674	1678	16560623793000	15440	7857	1	0	\N
289675	1678	16560623794000	15440	7857	2	0	\N
289676	1678	16560623795000	15440	7857	3	0	\N
289677	1678	16560623796000	15440	7857	4	0	\N
289678	1678	16560623797000	15440	7857	5	0	\N
289679	1678	16560623798000	15440	7857	6	0	\N
289680	1678	16560623799000	15440	7857	7	0	\N
289548	1874	6049000	15403	7846	3	0	1
289552	1678	16560623780000	15405	7847	0	0	0
289553	1678	16560623781000	15406	7848	0	0	0
289554	1678	16560623782000	15406	7848	1	0	0
289555	1874	6051000	15406	7848	2	0	1
289557	1874	6053000	15406	7848	4	0	1
289558	1874	6055000	15406	7848	5	0	1
289571	1299	1702603897287650	15410	7849	0	0	0
289572	1053	905559794837000	15410	7849	1	0	0
289573	1678	16560623783000	15410	7849	2	0	0
289575	1678	16560623784000	15411	7850	0	0	0
289576	1874	6058000	15411	7850	1	0	1
289581	1678	16560623785000	15413	7851	0	0	0
289582	1173	610999087832700	15413	7851	1	0	0
289584	1874	6059000	15413	7851	3	0	1
289587	1678	16560623786000	15415	7852	0	0	0
289588	1874	6061000	15415	7852	1	0	1
289589	1874	6062000	15415	7852	2	0	1
289596	1678	16560623787000	15418	7853	0	0	0
289598	1874	6065000	15418	7853	2	0	1
289599	1678	16560623788000	15419	7854	0	0	0
289600	1678	16560623789000	15419	7854	1	0	0
289601	1874	6066000	15419	7854	2	0	1
289602	1874	6068000	15419	7854	3	0	1
289608	1874	6069000	15422	7855	1	0	1
289612	1678	16560623791000	15424	7856	0	0	0
289613	1874	6071000	15424	7856	1	0	1
289614	1874	6072000	15424	7856	2	0	1
289616	1874	6074000	15425	7857	1	0	1
289621	1678	16560623793000	15428	7858	0	0	0
289622	1874	6075000	15428	7858	1	0	1
289625	1678	16560623794000	15430	7859	0	0	0
289626	1874	6076000	15430	7859	1	0	1
289631	1678	16560623795000	15432	7860	0	0	0
289632	1678	16560623796000	15432	7860	1	0	0
289633	1678	16560623797000	15432	7860	2	0	0
289634	1874	6079000	15432	7860	3	0	1
289635	1874	6081000	15432	7860	4	0	1
289637	1874	6084000	15432	7860	6	0	1
289645	1678	16560623798000	15434	7861	0	0	0
289646	1678	16560623799000	15434	7861	1	0	0
289647	1874	6085000	15434	7861	2	0	1
289649	1874	6088000	15434	7861	4	0	1
289650	1678	16560623800000	15435	7862	0	0	0
289651	1678	16560623801000	15435	7862	1	0	0
289652	1874	6089000	15435	7862	2	0	1
289653	1874	6091000	15435	7862	3	0	1
289669	1678	16560623803000	15439	7863	1	0	0
289670	1874	6092000	15439	7863	2	0	1
289671	1874	6094000	15439	7863	3	0	1
289672	1874	6095000	15439	7863	4	0	1
289681	1678	16560623800000	15440	7857	8	0	\N
289682	1678	16560623801000	15440	7857	9	0	\N
289683	1678	16560623802000	15440	7857	10	0	\N
289684	1678	16560623803000	15440	7857	11	0	\N
289685	1874	6074000	15440	7857	12	0	\N
289686	1874	6075000	15440	7857	13	0	\N
289687	1874	6076000	15440	7857	14	0	\N
289688	1874	6078000	15440	7857	15	0	\N
289689	1874	6079000	15440	7857	16	0	\N
289690	1874	6081000	15440	7857	17	0	\N
289691	1874	6082000	15440	7857	18	0	\N
289692	1874	6084000	15440	7857	19	0	\N
289693	1874	6085000	15440	7857	20	0	\N
289694	1874	6087000	15440	7857	21	0	\N
289695	1874	6088000	15440	7857	22	0	\N
289696	1874	6089000	15440	7857	23	0	\N
289697	1874	6091000	15440	7857	24	0	\N
289698	1874	6092000	15440	7857	25	0	\N
289699	1874	6094000	15440	7857	26	0	\N
289700	1874	6095000	15440	7857	27	0	\N
289703	1678	16560623804000	15442	7864	0	0	\N
289704	1874	6097000	15442	7864	1	0	\N
289705	1678	16560623804000	15443	7864	0	0	\N
289706	1874	6097000	15443	7864	1	0	\N
289707	1678	16560623804000	15444	7864	0	0	\N
289708	1874	6097000	15444	7864	1	0	\N
289723	1678	16560623811000	15448	7868	0	0	\N
289724	1874	6110000	15448	7868	1	0	\N
289725	1874	6111000	15448	7868	2	0	\N
289729	1678	16560623812000	15452	7870	0	0	\N
289730	1678	16560623813000	15452	7870	1	0	\N
289731	1678	16560623814000	15452	7870	2	0	\N
289732	1874	6113000	15452	7870	3	0	\N
289733	1874	6114000	15452	7870	4	0	\N
289734	1874	6115000	15452	7870	5	0	\N
289735	1874	6117000	15452	7870	6	0	\N
289743	1678	16560623812000	15454	7870	0	0	\N
289744	1678	16560623813000	15454	7870	1	0	\N
289745	1678	16560623814000	15454	7870	2	0	\N
289746	1874	6113000	15454	7870	3	0	\N
289747	1874	6114000	15454	7870	4	0	\N
289748	1874	6115000	15454	7870	5	0	\N
289749	1874	6117000	15454	7870	6	0	\N
289750	1678	16560623812000	15455	7870	0	0	\N
289751	1678	16560623813000	15455	7870	1	0	\N
289752	1678	16560623814000	15455	7870	2	0	\N
289753	1874	6113000	15455	7870	3	0	\N
289754	1874	6114000	15455	7870	4	0	\N
289755	1874	6115000	15455	7870	5	0	\N
289756	1874	6117000	15455	7870	6	0	\N
289757	1678	16560623815000	15456	7871	0	0	\N
289758	1874	6118000	15456	7871	1	0	\N
289763	1678	16560623817000	15459	7873	0	0	\N
289764	1874	6121000	15459	7873	1	0	\N
289767	1678	16560623716000	15461	7785	0	0	\N
289768	1299	1702603897287650	15461	7785	1	0	\N
289769	1053	905559794837000	15461	7785	2	0	\N
289770	1173	610999087832700	15461	7785	3	0	\N
289771	933	505337374679600	15461	7785	4	0	\N
289772	1678	16560623717000	15461	7785	5	0	\N
289773	1678	16560623718000	15461	7785	6	0	\N
289774	1678	16560623719000	15461	7785	7	0	\N
289775	1678	16560623720000	15461	7785	8	0	\N
289776	1678	16560623721000	15461	7785	9	0	\N
289777	1678	16560623722000	15461	7785	10	0	\N
289778	1678	16560623723000	15461	7785	11	0	\N
289779	1678	16560623724000	15461	7785	12	0	\N
289780	1678	16560623725000	15461	7785	13	0	\N
289781	1678	16560623726000	15461	7785	14	0	\N
289782	1678	16560623727000	15461	7785	15	0	\N
289783	1678	16560623728000	15461	7785	17	0	\N
289784	1678	16560623729000	15461	7785	18	0	\N
289785	1678	16560623730000	15461	7785	19	0	\N
289786	1678	16560623731000	15461	7785	20	0	\N
289787	1678	16560623732000	15461	7785	21	0	\N
289788	1678	16560623733000	15461	7785	22	0	\N
289789	1678	16560623734000	15461	7785	23	0	\N
289790	1678	16560623735000	15461	7785	24	0	\N
289791	1678	16560623736000	15461	7785	25	0	\N
289792	1678	16560623737000	15461	7785	26	0	\N
289793	1678	16560623738000	15461	7785	27	0	\N
289794	1678	16560623739000	15461	7785	28	0	\N
289795	1678	16560623740000	15461	7785	29	0	\N
289796	1678	16560623741000	15461	7785	30	0	\N
289797	1678	16560623742000	15461	7785	31	0	\N
289798	1678	16560623743000	15461	7785	32	0	\N
289799	1678	16560623744000	15461	7785	33	0	\N
289800	1678	16560623745000	15461	7785	34	0	\N
289801	1678	16560623746000	15461	7785	35	0	\N
289802	1678	16560623747000	15461	7785	36	0	\N
289803	1678	16560623748000	15461	7785	37	0	\N
289804	1678	16560623749000	15461	7785	38	0	\N
289805	1678	16560623750000	15461	7785	39	0	\N
289806	1678	16560623751000	15461	7785	40	0	\N
289807	1678	16560623752000	15461	7785	41	0	\N
289808	1678	16560623753000	15461	7785	42	0	\N
289809	1678	16560623754000	15461	7785	43	0	\N
289810	1678	16560623755000	15461	7785	44	0	\N
289811	1678	16560623756000	15461	7785	45	0	\N
289812	1678	16560623757000	15461	7785	46	0	\N
289813	1678	16560623758000	15461	7785	47	0	\N
289814	1678	16560623759000	15461	7785	48	0	\N
289815	1678	16560623760000	15461	7785	49	0	\N
289816	1678	16560623761000	15461	7785	50	0	\N
289709	1678	16560623805000	15445	7865	0	0	0
289710	1678	16560623806000	15445	7865	1	0	0
289711	1874	6098000	15445	7865	2	0	1
289712	1874	6100000	15445	7865	3	0	1
289713	1874	6101000	15445	7865	4	0	1
289715	1874	6102000	15446	7866	1	0	1
289716	1678	16560623808000	15447	7867	0	0	0
289717	1678	16560623809000	15447	7867	1	0	0
289718	1678	16560623810000	15447	7867	2	0	0
289719	1874	6104000	15447	7867	3	0	1
289721	1874	6107000	15447	7867	5	0	1
289722	1874	6108000	15447	7867	6	0	1
289726	1678	16560623811000	15449	7868	0	0	0
289727	1874	6110000	15449	7868	1	0	1
289736	1678	16560623812000	15453	7870	0	0	0
289737	1678	16560623813000	15453	7870	1	0	0
289738	1678	16560623814000	15453	7870	2	0	0
289739	1874	6113000	15453	7870	3	0	1
289740	1874	6114000	15453	7870	4	0	1
289742	1874	6117000	15453	7870	6	0	1
289759	1678	16560623815000	15457	7871	0	0	0
289760	1874	6118000	15457	7871	1	0	1
289761	1678	16560623816000	15458	7872	0	0	0
289762	1874	6120000	15458	7872	1	0	1
289766	1874	6121000	15460	7873	1	0	1
289817	1678	16560623762000	15461	7785	51	0	\N
289818	1678	16560623763000	15461	7785	52	0	\N
289819	1678	16560623764000	15461	7785	53	0	\N
289820	1678	16560623765000	15461	7785	54	0	\N
289821	1678	16560623766000	15461	7785	55	0	\N
289822	1678	16560623767000	15461	7785	56	0	\N
289823	1678	16560623768000	15461	7785	57	0	\N
289824	1678	16560623769000	15461	7785	58	0	\N
289825	1678	16560623770000	15461	7785	59	0	\N
289826	1678	16560623771000	15461	7785	60	0	\N
289827	1678	16560623772000	15461	7785	61	0	\N
289828	1678	16560623773000	15461	7785	62	0	\N
289829	1678	16560623774000	15461	7785	63	0	\N
289830	1678	16560623775000	15461	7785	64	0	\N
289831	1678	16560623776000	15461	7785	65	0	\N
289832	1678	16560623777000	15461	7785	66	0	\N
289833	1678	16560623778000	15461	7785	67	0	\N
289834	1678	16560623779000	15461	7785	68	0	\N
289835	1678	16560623780000	15461	7785	69	0	\N
289836	1678	16560623781000	15461	7785	70	0	\N
289837	1678	16560623782000	15461	7785	71	0	\N
289838	1678	16560623783000	15461	7785	72	0	\N
289839	1678	16560623784000	15461	7785	73	0	\N
289840	1678	16560623785000	15461	7785	74	0	\N
289841	1678	16560623786000	15461	7785	75	0	\N
289842	1678	16560623787000	15461	7785	76	0	\N
289843	1678	16560623788000	15461	7785	77	0	\N
289844	1678	16560623789000	15461	7785	78	0	\N
289845	1678	16560623790000	15461	7785	79	0	\N
289846	1678	16560623791000	15461	7785	80	0	\N
289847	1678	16560623792000	15461	7785	81	0	\N
289848	1678	16560623793000	15461	7785	82	0	\N
289849	1678	16560623794000	15461	7785	83	0	\N
289850	1678	16560623795000	15461	7785	84	0	\N
289851	1678	16560623796000	15461	7785	85	0	\N
289852	1678	16560623797000	15461	7785	86	0	\N
289853	1678	16560623798000	15461	7785	87	0	\N
289854	1678	16560623799000	15461	7785	88	0	\N
289855	1678	16560623800000	15461	7785	89	0	\N
289856	1678	16560623801000	15461	7785	90	0	\N
289857	1678	16560623802000	15461	7785	91	0	\N
289858	1678	16560623803000	15461	7785	92	0	\N
289859	1678	16560623804000	15461	7785	93	0	\N
289860	1678	16560623805000	15461	7785	94	0	\N
289861	1678	16560623806000	15461	7785	95	0	\N
289862	1678	16560623807000	15461	7785	96	0	\N
289863	1678	16560623808000	15461	7785	97	0	\N
289864	1678	16560623809000	15461	7785	98	0	\N
289865	1678	16560623810000	15461	7785	99	0	\N
289866	1678	16560623811000	15461	7785	100	0	\N
289867	1678	16560623812000	15461	7785	101	0	\N
289868	1678	16560623813000	15461	7785	102	0	\N
289869	1678	16560623814000	15461	7785	103	0	\N
289870	1678	16560623815000	15461	7785	104	0	\N
289871	1678	16560623816000	15461	7785	105	0	\N
289872	1678	16560623817000	15461	7785	106	0	\N
289873	1874	5926000	15461	7785	108	0	\N
289874	1403	0	15461	7785	109	0	\N
289875	1874	5928000	15461	7785	110	0	\N
289876	1874	5929000	15461	7785	111	0	\N
289877	1874	5931000	15461	7785	112	0	\N
289878	1874	5932000	15461	7785	113	0	\N
289879	1874	5934000	15461	7785	114	0	\N
289880	1874	5935000	15461	7785	115	0	\N
289881	1874	5936000	15461	7785	116	0	\N
289882	1874	5938000	15461	7785	117	0	\N
289883	1874	5939000	15461	7785	118	0	\N
289884	1874	5941000	15461	7785	119	0	\N
289885	1874	5942000	15461	7785	120	0	\N
289886	1874	5944000	15461	7785	121	0	\N
289887	1874	5945000	15461	7785	122	0	\N
289888	1874	5947000	15461	7785	123	0	\N
289889	1874	5948000	15461	7785	124	0	\N
289890	1874	5949000	15461	7785	125	0	\N
289894	1678	16560623818000	15463	7874	0	0	\N
289895	1874	6123000	15463	7874	1	0	\N
289896	1874	6124000	15463	7874	2	0	\N
289901	1678	16560623821000	15468	7876	0	0	\N
289912	1678	16560623824000	15473	7879	0	0	\N
289913	1874	6136000	15473	7879	1	0	\N
289914	1678	16560623824000	15474	7879	0	0	\N
289915	1874	6136000	15474	7879	1	0	\N
289916	1678	16560623824000	15475	7879	0	0	\N
289917	1874	6136000	15475	7879	1	0	\N
289918	1678	16560623824000	15476	7879	0	0	\N
289919	1874	6136000	15476	7879	1	0	\N
289925	1678	16560623825000	15478	7880	0	0	\N
289926	1678	16560623826000	15478	7880	1	0	\N
289927	1874	6137000	15478	7880	2	0	\N
289928	1874	6139000	15478	7880	3	0	\N
289929	1874	6140000	15478	7880	4	0	\N
289930	1678	16560623827000	15479	7881	0	0	\N
289931	1678	16560623828000	15479	7881	1	0	\N
289932	1874	6141000	15479	7881	2	0	\N
289933	1874	6143000	15479	7881	3	0	\N
289934	1678	16560623827000	15480	7881	0	0	\N
289935	1678	16560623828000	15480	7881	1	0	\N
289936	1874	6141000	15480	7881	2	0	\N
289937	1874	6143000	15480	7881	3	0	\N
289950	1678	16560623831000	15485	7884	0	0	\N
289951	1874	6149000	15485	7884	1	0	\N
289952	1874	6150000	15485	7884	2	0	\N
289893	1874	6124000	15462	7874	2	0	1
289897	1678	16560623819000	15467	7875	0	0	0
289898	1678	16560623820000	15467	7875	1	0	0
289899	1874	6126000	15467	7875	2	0	1
289900	1874	6127000	15467	7875	3	0	1
289903	1874	6128000	15469	7876	1	0	1
289904	1874	6130000	15469	7876	2	0	1
289905	1678	16560623822000	15470	7877	0	0	0
289906	1874	6131000	15470	7877	1	0	1
289907	1678	16560623823000	15471	7878	0	0	0
289909	1874	6134000	15471	7878	2	0	1
289910	1678	16560623824000	15472	7879	0	0	0
289911	1874	6136000	15472	7879	1	0	1
289920	1678	16560623825000	15477	7880	0	0	0
289922	1874	6137000	15477	7880	2	0	1
289923	1874	6139000	15477	7880	3	0	1
289924	1874	6140000	15477	7880	4	0	1
289938	1678	16560623827000	15481	7881	0	0	0
289939	1678	16560623828000	15481	7881	1	0	0
289941	1874	6143000	15481	7881	3	0	1
289942	1678	16560623829000	15482	7882	0	0	0
289943	1874	6144000	15482	7882	1	0	1
289944	1874	6146000	15482	7882	2	0	1
289945	1678	16560623830000	15483	7883	0	0	0
289947	1678	16560623831000	15484	7884	0	0	0
289948	1874	6149000	15484	7884	1	0	1
289949	1874	6150000	15484	7884	2	0	1
289953	1678	16560623831000	15487	7884	0	0	\N
289954	1874	6149000	15487	7884	1	0	\N
289955	1874	6150000	15487	7884	2	0	\N
289957	1299	1702603897287650	15493	7839	0	0	\N
289958	1053	905559794837000	15493	7839	1	0	\N
289959	1173	610999087832700	15493	7839	2	0	\N
289960	933	505337374679600	15493	7839	3	0	\N
289973	1678	16560623835000	15496	7887	0	0	\N
289974	1678	16560623836000	15496	7887	1	0	\N
289975	1678	16560623837000	15496	7887	2	0	\N
289976	1874	6157000	15496	7887	3	0	\N
289977	1874	6159000	15496	7887	4	0	\N
289978	1874	6160000	15496	7887	5	0	\N
289979	1678	16560623835000	15497	7887	0	0	\N
289980	1678	16560623836000	15497	7887	1	0	\N
289981	1678	16560623837000	15497	7887	2	0	\N
289982	1874	6157000	15497	7887	3	0	\N
289983	1874	6159000	15497	7887	4	0	\N
289984	1874	6160000	15497	7887	5	0	\N
289985	1678	16560623838000	15499	7888	0	0	\N
289986	1874	6162000	15499	7888	1	0	\N
289987	1874	6163000	15499	7888	2	0	\N
289994	1678	16560623839000	15502	7889	0	0	\N
289995	1874	6165000	15502	7889	1	0	\N
289996	1874	6166000	15502	7889	2	0	\N
290006	1678	16560623844000	15507	7892	0	0	\N
290007	1874	6175000	15507	7892	1	0	\N
290008	1678	16560623844000	15508	7892	0	0	\N
290009	1874	6175000	15508	7892	1	0	\N
290012	1678	16560623845000	15510	7893	0	0	\N
290013	1874	6176000	15510	7893	1	0	\N
290015	2129	3800000000	15512	7894	0	0	\N
290016	1678	16560623845000	15512	7894	2	0	\N
290017	1678	16560623846000	15512	7894	3	0	\N
290018	1874	6177000	15512	7894	4	0	\N
290019	1874	6179000	15512	7894	5	0	\N
290020	2129	3800000000	15513	7894	0	0	\N
290021	1678	16560623845000	15513	7894	2	0	\N
290022	1678	16560623846000	15513	7894	3	0	\N
290023	1874	6177000	15513	7894	4	0	\N
290024	1874	6179000	15513	7894	5	0	\N
290025	2129	3800000000	15514	7894	0	0	\N
290026	1678	16560623845000	15514	7894	2	0	\N
290027	1678	16560623846000	15514	7894	3	0	\N
290028	1874	6177000	15514	7894	4	0	\N
290029	1874	6179000	15514	7894	5	0	\N
290050	1705	8555474500145	15522	7900	0	0	\N
290051	1678	16560623853000	15522	7900	1	0	\N
290052	1678	16560623854000	15522	7900	2	0	\N
290053	1874	6193000	15522	7900	3	0	\N
290054	1874	6195000	15522	7900	4	0	\N
290055	1874	6196000	15522	7900	5	0	\N
290056	1705	8555474500145	15523	7900	0	0	\N
290057	1678	16560623853000	15523	7900	1	0	\N
290058	1678	16560623854000	15523	7900	2	0	\N
290059	1874	6193000	15523	7900	3	0	\N
290060	1874	6195000	15523	7900	4	0	\N
290061	1874	6196000	15523	7900	5	0	\N
290070	1678	16560623855000	15526	7901	0	0	\N
290071	1874	6198000	15526	7901	1	0	\N
290072	1678	16560623855000	15527	7901	0	0	\N
290073	1874	6198000	15527	7901	1	0	\N
290083	1678	16560623857000	15530	7903	0	0	\N
290084	1678	16560623858000	15530	7903	1	0	\N
290085	1678	16560623859000	15530	7903	2	0	\N
290086	1874	6201000	15530	7903	3	0	\N
290087	1874	6202000	15530	7903	4	0	\N
290088	1874	6203000	15530	7903	5	0	\N
289962	1678	16560623834000	15494	7886	1	0	0
289963	1874	6152000	15494	7886	2	0	1
289964	1874	6153000	15494	7886	3	0	1
289965	1874	6154000	15494	7886	4	0	1
289966	1874	6156000	15494	7886	5	0	1
289968	1678	16560623836000	15495	7887	1	0	0
289969	1678	16560623837000	15495	7887	2	0	0
289970	1874	6157000	15495	7887	3	0	1
289971	1874	6159000	15495	7887	4	0	1
289972	1874	6160000	15495	7887	5	0	1
289989	1874	6162000	15500	7888	1	0	1
289990	1874	6163000	15500	7888	2	0	1
289991	1678	16560623839000	15501	7889	0	0	0
289992	1874	6165000	15501	7889	1	0	1
289997	1678	16560623840000	15503	7890	0	0	0
289998	1678	16560623841000	15504	7891	0	0	0
289999	1678	16560623842000	15504	7891	1	0	0
290000	1678	16560623843000	15504	7891	2	0	0
290001	1874	6167000	15504	7891	3	0	1
290003	1874	6170000	15504	7891	5	0	1
290004	1874	6172000	15504	7891	6	0	1
290005	1874	6173000	15504	7891	7	0	1
290010	1678	16560623844000	15509	7892	0	0	0
290011	1874	6175000	15509	7892	1	0	1
290030	2129	3800000000	15515	7894	0	0	0
290031	1678	16560623845000	15515	7894	2	0	0
290032	1874	6177000	15515	7894	3	0	1
290033	1874	6179000	15515	7894	4	0	1
290035	1678	16560623847000	15516	7895	1	0	0
290036	1874	6180000	15516	7895	2	0	1
290037	1678	16560623848000	15517	7896	0	0	0
290038	1874	6182000	15517	7896	1	0	1
290039	1874	6183000	15517	7896	2	0	1
290041	1678	16560623849000	15518	7897	0	0	0
290042	1874	6186000	15518	7897	1	0	1
290043	1678	16560623850000	15519	7898	0	0	0
290044	1874	6188000	15519	7898	1	0	1
290045	1874	6189000	15519	7898	2	0	1
290047	1678	16560623852000	15521	7899	1	0	0
290048	1874	6190000	15521	7899	2	0	1
290049	1874	6192000	15521	7899	3	0	1
290062	1705	8555474500145	15524	7900	0	0	20
290064	1678	16560623854000	15524	7900	2	0	0
290065	1874	6193000	15524	7900	3	0	1
290066	1874	6195000	15524	7900	4	0	1
290067	1874	6196000	15524	7900	5	0	1
290068	1678	16560623855000	15525	7901	0	0	0
290074	1678	16560623856000	15528	7902	0	0	0
290075	1874	6199000	15528	7902	1	0	1
290076	1678	16560623857000	15529	7903	0	0	0
290077	1678	16560623858000	15529	7903	1	0	0
290078	1678	16560623859000	15529	7903	2	0	0
290080	1874	6202000	15529	7903	4	0	1
290081	1874	6203000	15529	7903	5	0	1
290082	1874	6205000	15529	7903	6	0	1
290089	1874	6205000	15530	7903	6	0	\N
290093	1678	16560623860000	15532	7904	0	0	\N
290094	1874	6206000	15532	7904	1	0	\N
290095	1874	6208000	15532	7904	2	0	\N
290096	1678	16560623861000	15534	7905	0	0	\N
290097	1678	16560623862000	15534	7905	1	0	\N
290098	1874	6209000	15534	7905	2	0	\N
290099	1874	6211000	15534	7905	3	0	\N
290100	1874	6212000	15534	7905	4	0	\N
290122	1678	16560623870000	15541	7911	0	0	\N
290123	1678	16560623871000	15541	7911	1	0	\N
290124	1874	6226000	15541	7911	2	0	\N
290125	1874	6228000	15541	7911	3	0	\N
290126	1678	16560623870000	15542	7911	0	0	\N
290127	1678	16560623871000	15542	7911	1	0	\N
290128	1874	6226000	15542	7911	2	0	\N
290129	1874	6228000	15542	7911	3	0	\N
290134	1678	16560623870000	15544	7911	0	0	\N
290135	1678	16560623871000	15544	7911	1	0	\N
290136	1874	6226000	15544	7911	2	0	\N
290137	1874	6228000	15544	7911	3	0	\N
290155	1678	16560623877000	15548	7914	0	0	\N
290156	1678	16560623878000	15548	7914	1	0	\N
290157	1874	6239000	15548	7914	2	0	\N
290158	1874	6241000	15548	7914	3	0	\N
290159	1874	6242000	15548	7914	4	0	\N
290162	1678	16560623879000	15550	7915	0	0	\N
290163	1874	6244000	15550	7915	1	0	\N
290173	1678	16560623883000	15553	7917	0	0	\N
290179	1678	16560623884000	15555	7918	0	0	\N
290180	1678	16560623885000	15555	7918	1	0	\N
290181	1874	6252000	15555	7918	2	0	\N
290182	1874	6254000	15555	7918	3	0	\N
290183	1874	6255000	15555	7918	4	0	\N
290184	1678	16560623886000	15556	7919	0	0	\N
290185	1678	16560623887000	15556	7919	1	0	\N
290186	1874	6257000	15556	7919	2	0	\N
290187	2118	1400000000	15556	7919	3	0	\N
290188	2130	200000000	15556	7919	4	0	\N
290189	1874	6259000	15556	7919	5	0	\N
290190	1678	16560623886000	15557	7919	0	0	\N
290191	1678	16560623887000	15557	7919	1	0	\N
290192	1874	6257000	15557	7919	2	0	\N
290193	2118	1400000000	15557	7919	3	0	\N
290194	2130	200000000	15557	7919	4	0	\N
290195	1874	6259000	15557	7919	5	0	\N
290202	2129	3800000000	15559	7843	0	0	\N
290203	1678	16560623775000	15559	7843	1	0	\N
290204	1678	16560623776000	15559	7843	2	0	\N
290205	1678	16560623777000	15559	7843	3	0	\N
290206	1678	16560623778000	15559	7843	4	0	\N
290207	1678	16560623779000	15559	7843	5	0	\N
290208	1678	16560623780000	15559	7843	6	0	\N
290209	1678	16560623781000	15559	7843	7	0	\N
290210	1678	16560623782000	15559	7843	8	0	\N
290211	1299	1702603897287650	15559	7843	9	0	\N
290212	1053	905559794837000	15559	7843	10	0	\N
290213	1173	610999087832700	15559	7843	11	0	\N
290214	933	505337374679600	15559	7843	12	0	\N
290215	1678	16560623783000	15559	7843	13	0	\N
290216	1678	16560623784000	15559	7843	14	0	\N
290217	1678	16560623785000	15559	7843	15	0	\N
290218	1678	16560623786000	15559	7843	17	0	\N
290219	1678	16560623787000	15559	7843	18	0	\N
290220	1678	16560623788000	15559	7843	19	0	\N
290221	1678	16560623789000	15559	7843	20	0	\N
290222	1678	16560623790000	15559	7843	21	0	\N
290223	1678	16560623791000	15559	7843	22	0	\N
290224	1678	16560623792000	15559	7843	23	0	\N
290092	1874	6208000	15531	7904	2	0	1
290101	1678	16560623861000	15536	7906	0	0	0
290102	1678	16560623862000	15536	7906	1	0	0
290103	1678	16560623863000	15536	7906	2	0	0
290104	1874	6209000	15536	7906	3	0	1
290106	1874	6212000	15536	7906	5	0	1
290107	1678	16560623864000	15537	7907	0	0	0
290108	1678	16560623865000	15537	7907	1	0	0
290109	1874	6214000	15537	7907	2	0	1
290110	1874	6215000	15537	7907	3	0	1
290112	1874	6218000	15537	7907	5	0	1
290113	1678	16560623866000	15538	7908	0	0	0
290114	1874	6219000	15538	7908	1	0	1
290115	1678	16560623867000	15539	7909	0	0	0
290117	1874	6221000	15539	7909	2	0	1
290118	1874	6222000	15539	7909	3	0	1
290119	1678	16560623869000	15540	7910	0	0	0
290120	1874	6224000	15540	7910	1	0	1
290121	1874	6225000	15540	7910	2	0	1
290131	1678	16560623871000	15543	7911	1	0	0
290132	1874	6226000	15543	7911	2	0	1
290133	1874	6228000	15543	7911	3	0	1
290138	1678	16560623872000	15545	7912	0	0	0
290139	1874	6229000	15545	7912	1	0	1
290141	1678	16560623873000	15546	7913	0	0	0
290142	1678	16560623874000	15546	7913	1	0	0
290143	1678	16560623875000	15546	7913	2	0	0
290144	1678	16560623876000	15546	7913	3	0	0
290146	1874	6234000	15546	7913	5	0	1
290147	1874	6235000	15546	7913	6	0	1
290148	1874	6237000	15546	7913	7	0	1
290149	1874	6238000	15546	7913	8	0	1
290150	1678	16560623877000	15547	7914	0	0	0
290152	1874	6239000	15547	7914	2	0	1
290153	1874	6241000	15547	7914	3	0	1
290154	1874	6242000	15547	7914	4	0	1
290160	1678	16560623879000	15549	7915	0	0	0
290161	1874	6244000	15549	7915	1	0	1
290165	1678	16560623881000	15551	7916	2	0	0
290166	1678	16560623882000	15551	7916	3	0	0
290167	1874	6245000	15551	7916	4	0	1
290168	1874	6247000	15551	7916	5	0	1
290170	1874	6250000	15551	7916	7	0	1
290171	1874	6251000	15551	7916	8	0	1
290172	1678	16560623883000	15552	7917	0	0	0
290174	1678	16560623884000	15554	7918	0	0	0
290175	1678	16560623885000	15554	7918	1	0	0
290177	1874	6254000	15554	7918	3	0	1
290178	1874	6255000	15554	7918	4	0	1
290196	1678	16560623886000	15558	7919	0	0	0
290197	1678	16560623887000	15558	7919	1	0	0
290198	1874	6257000	15558	7919	2	0	1
290200	2130	200000000	15558	7919	4	0	0
290201	1874	6259000	15558	7919	5	0	1
290225	1678	16560623793000	15559	7843	24	0	\N
290226	1678	16560623794000	15559	7843	25	0	\N
290227	1678	16560623795000	15559	7843	26	0	\N
290228	1678	16560623796000	15559	7843	27	0	\N
290229	1678	16560623797000	15559	7843	28	0	\N
290230	1678	16560623798000	15559	7843	29	0	\N
290231	1678	16560623799000	15559	7843	30	0	\N
290232	1678	16560623800000	15559	7843	31	0	\N
290233	1678	16560623801000	15559	7843	32	0	\N
290234	1678	16560623802000	15559	7843	33	0	\N
290235	1678	16560623803000	15559	7843	34	0	\N
290236	1678	16560623804000	15559	7843	35	0	\N
290237	1678	16560623805000	15559	7843	36	0	\N
290238	1678	16560623806000	15559	7843	37	0	\N
290239	1678	16560623807000	15559	7843	38	0	\N
290240	1678	16560623808000	15559	7843	39	0	\N
290241	1678	16560623809000	15559	7843	40	0	\N
290242	1678	16560623810000	15559	7843	41	0	\N
290243	1678	16560623811000	15559	7843	42	0	\N
290244	1678	16560623812000	15559	7843	43	0	\N
290245	1678	16560623813000	15559	7843	44	0	\N
290246	1678	16560623814000	15559	7843	45	0	\N
290247	1678	16560623815000	15559	7843	46	0	\N
290248	1678	16560623816000	15559	7843	47	0	\N
290249	1678	16560623817000	15559	7843	48	0	\N
290250	1678	16560623818000	15559	7843	49	0	\N
290251	1678	16560623819000	15559	7843	50	0	\N
290252	1678	16560623820000	15559	7843	51	0	\N
290253	1678	16560623821000	15559	7843	52	0	\N
290254	1678	16560623822000	15559	7843	53	0	\N
290255	1678	16560623823000	15559	7843	54	0	\N
290256	1678	16560623824000	15559	7843	55	0	\N
290257	1678	16560623825000	15559	7843	56	0	\N
290258	1678	16560623826000	15559	7843	57	0	\N
290259	1678	16560623827000	15559	7843	58	0	\N
290260	1678	16560623828000	15559	7843	59	0	\N
290261	1678	16560623829000	15559	7843	60	0	\N
290262	1678	16560623830000	15559	7843	61	0	\N
290263	1678	16560623831000	15559	7843	62	0	\N
290264	1678	16560623832000	15559	7843	63	0	\N
290265	1678	16560623833000	15559	7843	64	0	\N
290266	1678	16560623834000	15559	7843	65	0	\N
290267	1678	16560623835000	15559	7843	66	0	\N
290268	1678	16560623836000	15559	7843	67	0	\N
290269	1678	16560623837000	15559	7843	68	0	\N
290270	1678	16560623838000	15559	7843	69	0	\N
290271	1678	16560623839000	15559	7843	70	0	\N
290272	1678	16560623840000	15559	7843	71	0	\N
290273	1678	16560623841000	15559	7843	72	0	\N
290274	1678	16560623842000	15559	7843	73	0	\N
290275	1678	16560623843000	15559	7843	74	0	\N
290276	1678	16560623844000	15559	7843	75	0	\N
290277	1678	16560623845000	15559	7843	76	0	\N
290278	1678	16560623846000	15559	7843	77	0	\N
290279	1678	16560623847000	15559	7843	78	0	\N
290280	1678	16560623848000	15559	7843	79	0	\N
290281	1678	16560623849000	15559	7843	80	0	\N
290282	1678	16560623850000	15559	7843	81	0	\N
290283	1678	16560623851000	15559	7843	82	0	\N
290284	1678	16560623852000	15559	7843	83	0	\N
290285	1678	16560623853000	15559	7843	84	0	\N
290286	1678	16560623854000	15559	7843	85	0	\N
290287	1678	16560623855000	15559	7843	86	0	\N
290288	1678	16560623856000	15559	7843	87	0	\N
290289	1678	16560623857000	15559	7843	88	0	\N
290290	1678	16560623858000	15559	7843	89	0	\N
290291	1678	16560623859000	15559	7843	90	0	\N
290292	1678	16560623860000	15559	7843	91	0	\N
290293	1678	16560623861000	15559	7843	92	0	\N
290294	1678	16560623862000	15559	7843	93	0	\N
290295	1678	16560623863000	15559	7843	94	0	\N
290296	1678	16560623864000	15559	7843	95	0	\N
290297	1678	16560623865000	15559	7843	96	0	\N
290298	1678	16560623866000	15559	7843	97	0	\N
290299	1678	16560623867000	15559	7843	98	0	\N
290300	1678	16560623868000	15559	7843	99	0	\N
290301	1678	16560623869000	15559	7843	100	0	\N
290302	1678	16560623870000	15559	7843	101	0	\N
290303	1678	16560623871000	15559	7843	102	0	\N
290304	1678	16560623872000	15559	7843	103	0	\N
290305	1678	16560623873000	15559	7843	104	0	\N
290306	1678	16560623874000	15559	7843	105	0	\N
290307	1678	16560623875000	15559	7843	106	0	\N
290308	1678	16560623876000	15559	7843	107	0	\N
290309	1678	16560623877000	15559	7843	108	0	\N
290310	1678	16560623878000	15559	7843	109	0	\N
290311	1678	16560623879000	15559	7843	110	0	\N
290312	1678	16560623880000	15559	7843	111	0	\N
290313	1678	16560623881000	15559	7843	112	0	\N
290314	1678	16560623882000	15559	7843	113	0	\N
290315	1678	16560623883000	15559	7843	114	0	\N
290316	1678	16560623884000	15559	7843	115	0	\N
290317	1678	16560623885000	15559	7843	116	0	\N
290318	1678	16560623886000	15559	7843	117	0	\N
290319	1678	16560623887000	15559	7843	118	0	\N
290320	1678	16560623888000	15559	7843	119	0	\N
290321	1678	16560623889000	15559	7843	120	0	\N
290322	1678	16560623890000	15559	7843	121	0	\N
290323	1874	6040000	15559	7843	122	0	\N
290324	1874	6042000	15559	7843	123	0	\N
290325	1874	6043000	15559	7843	124	0	\N
290326	1874	6045000	15559	7843	125	0	\N
290327	1678	16560623888000	15560	7920	0	0	\N
290328	1678	16560623889000	15560	7920	1	0	\N
290329	1678	16560623890000	15560	7920	2	0	\N
290330	1678	16560623891000	15560	7920	3	0	\N
290331	2131	200000000	15560	7920	4	0	\N
290332	2096	1400000000	15560	7920	5	0	\N
290339	1678	16560623892000	15563	7921	0	0	\N
290340	1678	16560623892000	15564	7921	0	0	\N
290346	1678	16560623897000	15568	7924	0	0	\N
290347	1678	16560623898000	15568	7924	1	0	\N
290348	1678	16560623899000	15568	7924	2	0	\N
290356	1678	16560623903000	15573	7928	0	0	\N
290357	1678	16560623903000	15574	7928	0	0	\N
290358	1678	16560623903000	15575	7928	0	0	\N
290335	1678	16560623890000	15561	7920	2	0	0
290336	1678	16560623891000	15561	7920	3	0	0
290337	2131	200000000	15561	7920	4	0	0
290338	2096	1400000000	15561	7920	5	0	0
290341	1678	16560623892000	15565	7921	0	0	0
290343	1678	16560623894000	15566	7922	1	0	0
290344	1678	16560623895000	15567	7923	0	0	0
290345	1678	16560623896000	15567	7923	1	0	0
290349	1678	16560623897000	15569	7924	0	0	0
290350	1678	16560623898000	15569	7924	1	0	0
290352	1678	16560623900000	15570	7925	0	0	0
290353	1678	16560623901000	15571	7926	0	0	0
290354	1726	641068109000	15571	7926	1	0	8165
290355	1678	16560623902000	15572	7927	1	0	0
290360	1678	16560623904000	15577	7929	0	0	0
290364	1678	16560623905000	15579	7930	0	0	\N
290365	1678	16560623906000	15579	7930	1	0	\N
290366	2132	149000000000	15579	7930	2	0	\N
290375	1678	16560623912000	15582	7932	0	0	\N
290376	1678	16560623912000	15583	7932	0	0	\N
290377	1678	16560623913000	15584	7933	0	0	\N
290378	1874	483000	15584	7933	1	0	\N
290385	1678	16560623914000	15587	7934	0	0	\N
290386	1678	16560623915000	15587	7934	1	0	\N
290387	1874	485000	15587	7934	2	0	\N
290388	1874	487000	15587	7934	3	0	\N
290391	1678	16560623917000	15589	7936	0	0	\N
290392	1678	16560623918000	15589	7936	1	0	\N
290393	1678	16560623919000	15589	7936	2	0	\N
290394	1874	491000	15589	7936	3	0	\N
290395	1874	493000	15589	7936	4	0	\N
290396	1874	495000	15589	7936	5	0	\N
290397	1678	16560623917000	15590	7936	0	0	\N
290398	1678	16560623918000	15590	7936	1	0	\N
290399	1678	16560623919000	15590	7936	2	0	\N
290400	1874	491000	15590	7936	3	0	\N
290401	1874	493000	15590	7936	4	0	\N
290402	1874	495000	15590	7936	5	0	\N
290413	1874	501000	15593	7938	0	0	\N
290414	1874	503000	15593	7938	1	0	\N
290415	1874	501000	15594	7938	0	0	\N
290416	1874	503000	15594	7938	1	0	\N
290417	1874	501000	15595	7938	0	0	\N
290418	1874	503000	15595	7938	1	0	\N
290427	1678	16560623923000	15600	7941	0	0	\N
290428	1874	511000	15600	7941	2	0	\N
290429	1678	16560623924000	15601	7942	0	0	\N
290430	1874	513000	15601	7942	1	0	\N
290433	1678	16560623925000	15603	7943	0	0	\N
290434	1874	515000	15603	7943	1	0	\N
290439	1678	16560623926000	15606	7944	0	0	\N
290440	1874	517000	15606	7944	1	0	\N
290441	1678	16560623926000	15607	7944	0	0	\N
290442	1874	517000	15607	7944	1	0	\N
290450	1678	16560623930000	15609	7946	0	0	\N
290451	1874	525000	15609	7946	1	0	\N
290452	1874	527000	15609	7946	2	0	\N
290456	1678	16560623930000	15611	7946	0	0	\N
290457	1874	525000	15611	7946	1	0	\N
290458	1874	527000	15611	7946	2	0	\N
290459	1678	16560623930000	15612	7946	0	0	\N
290460	1874	525000	15612	7946	1	0	\N
290461	1874	527000	15612	7946	2	0	\N
290464	1678	16560623932000	15614	7948	0	0	\N
290465	1874	531000	15614	7948	1	0	\N
290475	1678	16560623934000	15618	7950	0	0	\N
290476	1678	16560623935000	15618	7950	1	0	\N
290477	1874	535000	15618	7950	2	0	\N
290478	1874	537000	15618	7950	3	0	\N
290479	1874	538000	15618	7950	4	0	\N
290480	1678	16560623936000	15619	7951	0	0	\N
290481	1874	540000	15619	7951	1	0	\N
290484	1678	16560623937000	15621	7952	0	0	\N
290485	1874	543000	15621	7952	1	0	\N
290486	1874	544000	15621	7952	2	0	\N
290487	1874	546000	15621	7952	3	0	\N
290363	2132	149000000000	15578	7930	2	0	0
290367	1678	16560623907000	15580	7931	0	0	0
290368	1678	16560623908000	15580	7931	1	0	0
290369	1678	16560623909000	15580	7931	2	0	0
290370	1678	16560623910000	15580	7931	3	0	0
290372	2133	99000000000	15580	7931	5	0	0
290373	2134	99000000000	15580	7931	6	0	0
290374	1678	16560623912000	15581	7932	0	0	0
290379	1678	16560623913000	15585	7933	0	0	0
290380	1874	483000	15585	7933	1	0	2
290382	1678	16560623915000	15586	7934	1	0	0
290383	1874	485000	15586	7934	2	0	2
290384	1874	487000	15586	7934	3	0	2
290389	1678	16560623916000	15588	7935	0	0	0
290403	1678	16560623917000	15591	7936	0	0	0
290404	1678	16560623918000	15591	7936	1	0	0
290405	1678	16560623919000	15591	7936	2	0	0
290406	1874	491000	15591	7936	3	0	2
290407	1874	493000	15591	7936	4	0	2
290409	1678	16560623920000	15592	7937	0	0	0
290410	1678	16560623921000	15592	7937	1	0	0
290411	1874	497000	15592	7937	2	0	2
290412	1874	499000	15592	7937	3	0	2
290419	1874	501000	15596	7938	0	0	2
290421	1874	505000	15597	7939	0	0	2
290422	1874	507000	15597	7939	1	0	2
290423	1678	16560623922000	15598	7940	0	0	0
290424	1874	509000	15598	7940	1	0	2
290426	1874	511000	15599	7941	2	0	2
290431	1678	16560623924000	15602	7942	0	0	0
290432	1874	513000	15602	7942	1	0	2
290435	1678	16560623925000	15604	7943	0	0	0
290436	1874	515000	15604	7943	1	0	2
290438	1874	517000	15605	7944	1	0	2
290443	1678	16560623927000	15608	7945	0	0	0
290444	1678	16560623928000	15608	7945	1	0	0
290445	1678	16560623929000	15608	7945	2	0	0
290446	1874	518000	15608	7945	3	0	2
290448	1874	522000	15608	7945	5	0	2
290449	1874	524000	15608	7945	6	0	2
290453	1678	16560623930000	15610	7946	0	0	0
290454	1874	525000	15610	7946	1	0	2
290462	1678	16560623931000	15613	7947	0	0	0
290463	1874	529000	15613	7947	1	0	2
290466	1678	16560623932000	15615	7948	0	0	0
290467	1874	531000	15615	7948	1	0	2
290468	1678	16560623933000	15616	7949	0	0	0
290470	1678	16560623934000	15617	7950	0	0	0
290471	1678	16560623935000	15617	7950	1	0	0
290472	1874	535000	15617	7950	2	0	2
290473	1874	537000	15617	7950	3	0	2
290474	1874	538000	15617	7950	4	0	2
290483	1874	540000	15620	7951	1	0	2
290488	1678	16560623937000	15622	7952	0	0	0
290489	1874	543000	15622	7952	1	0	2
290490	1874	544000	15622	7952	2	0	2
290492	1678	16560623938000	15623	7953	0	0	0
290493	1678	16560623939000	15623	7953	1	0	0
290494	1874	548000	15623	7953	2	0	2
290495	1874	551000	15623	7953	3	0	2
290496	1874	554000	15623	7953	4	0	2
290498	1678	16560623940000	15624	7954	0	0	\N
290499	1874	557000	15624	7954	1	0	\N
290500	1874	560000	15624	7954	2	0	\N
290501	1874	562000	15624	7954	3	0	\N
290512	1678	16560623942000	15629	7956	0	0	\N
290513	1874	569000	15629	7956	1	0	\N
290514	1874	572000	15629	7956	2	0	\N
290515	1678	16560623943000	15630	7957	0	0	\N
290516	1874	574000	15630	7957	1	0	\N
290517	1874	577000	15630	7957	2	0	\N
290518	1678	16560623943000	15631	7957	0	0	\N
290519	1874	574000	15631	7957	1	0	\N
290520	1874	577000	15631	7957	2	0	\N
290521	1678	16560623943000	15632	7957	0	0	\N
290522	1874	574000	15632	7957	1	0	\N
290523	1874	577000	15632	7957	2	0	\N
290527	1678	16560623944000	15634	7958	0	0	\N
290528	1874	579000	15634	7958	1	0	\N
290529	1874	582000	15634	7958	2	0	\N
290530	1874	583000	15634	7958	3	0	\N
290535	1678	16560623944000	15636	7958	0	0	\N
290536	1874	579000	15636	7958	1	0	\N
290537	1874	582000	15636	7958	2	0	\N
290538	1874	583000	15636	7958	3	0	\N
290539	1678	16560623944000	15637	7958	0	0	\N
290540	1874	579000	15637	7958	1	0	\N
290541	1874	582000	15637	7958	2	0	\N
290542	1874	583000	15637	7958	3	0	\N
290543	1678	16560623944000	15638	7958	0	0	\N
290544	1874	579000	15638	7958	1	0	\N
290545	1874	582000	15638	7958	2	0	\N
290546	1874	583000	15638	7958	3	0	\N
290547	1678	16560623938000	15639	7953	0	0	\N
290548	1678	16560623939000	15639	7953	1	0	\N
290549	1678	16560623940000	15639	7953	2	0	\N
290550	1678	16560623941000	15639	7953	3	0	\N
290551	1678	16560623942000	15639	7953	4	0	\N
290552	1874	548000	15639	7953	5	0	\N
290553	1874	549000	15639	7953	6	0	\N
290554	1874	552000	15639	7953	7	0	\N
290555	1874	555000	15639	7953	8	0	\N
290556	1874	558000	15639	7953	9	0	\N
290557	1874	561000	15639	7953	10	0	\N
290558	1874	564000	15639	7953	11	0	\N
290559	1874	567000	15639	7953	12	0	\N
290560	1874	569000	15639	7953	13	0	\N
290561	1874	571000	15639	7953	14	0	\N
290562	1874	573000	15639	7953	15	0	\N
290563	1874	575000	15639	7953	16	0	\N
290564	1678	16560623945000	15640	7959	0	0	\N
290565	1874	585000	15640	7959	1	0	\N
290566	1874	588000	15640	7959	2	0	\N
290572	1678	16560623946000	15643	7960	0	0	\N
290573	1874	591000	15643	7960	1	0	\N
290574	1678	16560623947000	15644	7961	0	0	\N
290575	1874	594000	15644	7961	1	0	\N
290576	1874	595000	15644	7961	2	0	\N
290577	1874	597000	15644	7961	3	0	\N
290578	1678	16560623947000	15645	7961	0	0	\N
290579	1874	594000	15645	7961	1	0	\N
290580	1874	595000	15645	7961	2	0	\N
290581	1874	597000	15645	7961	3	0	\N
290592	1678	16560623950000	15648	7963	0	0	\N
290593	1874	610000	15648	7963	1	0	\N
290594	1874	611000	15648	7963	2	0	\N
290595	1874	613000	15648	7963	3	0	\N
290606	1678	16560623953000	15651	7965	0	0	\N
290607	1874	626000	15651	7965	1	0	\N
290608	1874	628000	15651	7965	2	0	\N
290612	1678	16560623953000	15653	7965	0	0	\N
290613	1874	626000	15653	7965	1	0	\N
290614	1874	628000	15653	7965	2	0	\N
290622	1678	16560623955000	15656	7967	0	0	\N
290623	1874	636000	15656	7967	1	0	\N
290624	1874	639000	15656	7967	2	0	\N
290632	1678	16560623956000	15658	7968	0	0	\N
290503	1874	557000	15625	7954	1	0	2
290504	1874	560000	15625	7954	2	0	2
290505	1874	562000	15625	7954	3	0	2
290506	1678	16560623941000	15626	7955	0	0	0
290507	1874	565000	15626	7955	1	0	2
290509	1678	16560623942000	15628	7956	0	0	0
290510	1874	569000	15628	7956	1	0	2
290511	1874	572000	15628	7956	2	0	2
290524	1678	16560623943000	15633	7957	0	0	0
290525	1874	574000	15633	7957	1	0	2
290531	1678	16560623944000	15635	7958	0	0	0
290532	1874	579000	15635	7958	1	0	2
290533	1874	582000	15635	7958	2	0	2
290534	1874	583000	15635	7958	3	0	2
290568	1874	585000	15641	7959	1	0	2
290569	1874	588000	15641	7959	2	0	2
290570	1678	16560623946000	15642	7960	0	0	0
290571	1874	591000	15642	7960	1	0	2
290582	1678	16560623947000	15646	7961	0	0	0
290584	1874	595000	15646	7961	2	0	2
290585	1874	597000	15646	7961	3	0	2
290586	1678	16560623948000	15647	7962	0	0	0
290587	1678	16560623949000	15647	7962	1	0	0
290588	1874	600000	15647	7962	2	0	2
290590	1874	605000	15647	7962	4	0	2
290591	1874	607000	15647	7962	5	0	2
290596	1678	16560623950000	15649	7963	0	0	0
290597	1874	610000	15649	7963	1	0	2
290599	1874	613000	15649	7963	3	0	2
290600	1678	16560623951000	15650	7964	0	0	0
290601	1678	16560623952000	15650	7964	1	0	0
290602	1874	615000	15650	7964	2	0	2
290603	1874	618000	15650	7964	3	0	2
290605	1874	623000	15650	7964	6	0	2
290609	1678	16560623953000	15652	7965	0	0	0
290610	1874	626000	15652	7965	1	0	2
290611	1874	628000	15652	7965	2	0	2
290615	1678	16560623954000	15654	7966	0	0	0
290617	1874	631000	15654	7966	2	0	2
290618	1874	634000	15654	7966	3	0	2
290619	1678	16560623955000	15655	7967	0	0	0
290620	1874	636000	15655	7967	1	0	2
290625	1678	16560623956000	15657	7968	0	0	0
290626	1678	16560623957000	15657	7968	1	0	0
290627	1874	642000	15657	7968	2	0	2
290628	1874	645000	15657	7968	3	0	2
290629	1874	647000	15657	7968	4	0	2
290631	1874	650000	15657	7968	6	0	2
290633	1678	16560623957000	15658	7968	1	0	\N
290634	1874	642000	15658	7968	2	0	\N
290635	1874	645000	15658	7968	3	0	\N
290636	1874	647000	15658	7968	4	0	\N
290637	1874	649000	15658	7968	5	0	\N
290638	1874	650000	15658	7968	6	0	\N
290662	1678	16560623965000	15665	7975	0	0	\N
290663	1678	16560623966000	15665	7975	1	0	\N
290664	1874	690000	15665	7975	2	0	\N
290665	1874	693000	15665	7975	3	0	\N
290666	1874	695000	15665	7975	4	0	\N
290667	1874	697000	15665	7975	5	0	\N
290668	1678	16560623965000	15666	7975	0	0	\N
290669	1678	16560623966000	15666	7975	1	0	\N
290670	1874	690000	15666	7975	2	0	\N
290671	1874	693000	15666	7975	3	0	\N
290672	1874	695000	15666	7975	4	0	\N
290673	1874	697000	15666	7975	5	0	\N
290674	1678	16560623965000	15667	7975	0	0	\N
290675	1678	16560623966000	15667	7975	1	0	\N
290676	1874	690000	15667	7975	2	0	\N
290677	1874	693000	15667	7975	3	0	\N
290678	1874	695000	15667	7975	4	0	\N
290679	1874	697000	15667	7975	5	0	\N
290686	1678	16560623964000	15669	7974	0	0	\N
290687	1874	682000	15669	7974	1	0	\N
290688	1874	684000	15669	7974	2	0	\N
290689	1874	687000	15669	7974	3	0	\N
290690	1678	16560623965000	15670	7975	0	0	\N
290691	1678	16560623966000	15670	7975	1	0	\N
290692	1874	690000	15670	7975	2	0	\N
290693	1874	693000	15670	7975	3	0	\N
290694	1874	695000	15670	7975	4	0	\N
290695	1874	697000	15670	7975	5	0	\N
290703	1678	16560623967000	15672	7976	0	0	\N
290704	1678	16560623968000	15672	7976	1	0	\N
290705	1874	699000	15672	7976	2	0	\N
290706	1874	702000	15672	7976	3	0	\N
290707	1874	705000	15672	7976	4	0	\N
290708	1874	707000	15672	7976	5	0	\N
290709	1874	708000	15672	7976	6	0	\N
290710	1678	16560623967000	15673	7976	0	0	\N
290711	1678	16560623968000	15673	7976	1	0	\N
290712	1874	699000	15673	7976	2	0	\N
290713	1874	702000	15673	7976	3	0	\N
290714	1874	705000	15673	7976	4	0	\N
290715	1874	707000	15673	7976	5	0	\N
290716	1874	708000	15673	7976	6	0	\N
290717	1678	16560623969000	15674	7977	0	0	\N
290718	1874	710000	15674	7977	1	0	\N
290719	1874	713000	15674	7977	2	0	\N
290723	1678	16560623970000	15676	7978	0	0	\N
290724	1874	714000	15676	7978	1	0	\N
290725	1874	716000	15676	7978	2	0	\N
290726	1874	719000	15676	7978	3	0	\N
290731	1678	16560623970000	15678	7978	0	0	\N
290732	1874	714000	15678	7978	1	0	\N
290733	1874	716000	15678	7978	2	0	\N
290734	1874	719000	15678	7978	3	0	\N
290735	1678	16560623970000	15679	7978	0	0	\N
290736	1874	714000	15679	7978	1	0	\N
290737	1874	716000	15679	7978	2	0	\N
290738	1874	719000	15679	7978	3	0	\N
290739	1678	16560623970000	15680	7978	0	0	\N
290740	1874	714000	15680	7978	1	0	\N
290741	1874	716000	15680	7978	2	0	\N
290742	1874	719000	15680	7978	3	0	\N
290743	1678	16560623971000	15681	7979	0	0	\N
290744	1874	721000	15681	7979	1	0	\N
290745	1874	724000	15681	7979	2	0	\N
290749	1678	16560623972000	15683	7980	0	0	\N
290750	1874	727000	15683	7980	1	0	\N
290751	1874	729000	15683	7980	2	0	\N
290752	1678	16560623972000	15684	7980	0	0	\N
290753	1874	727000	15684	7980	1	0	\N
290754	1678	16560623972000	15685	7980	0	0	\N
290755	1874	727000	15685	7980	1	0	\N
290756	1874	729000	15685	7980	2	0	\N
290757	1678	16560623972000	15686	7980	0	0	\N
290758	1874	727000	15686	7980	1	0	\N
290759	1874	729000	15686	7980	2	0	\N
290763	1678	16560623972000	15688	7980	0	0	\N
290764	1874	727000	15688	7980	1	0	\N
290765	1874	729000	15688	7980	2	0	\N
290766	1678	16560623973000	15689	7981	0	0	\N
290767	1678	16560623974000	15689	7981	1	0	\N
290768	1874	732000	15689	7981	2	0	\N
290641	1874	655000	15659	7969	2	0	2
290642	1678	16560623959000	15660	7970	0	0	0
290643	1874	657000	15660	7970	1	0	2
290644	1874	660000	15660	7970	2	0	2
290645	1678	16560623960000	15661	7971	0	0	0
290647	1874	664000	15661	7971	2	0	2
290648	1874	666000	15661	7971	3	0	2
290649	1678	16560623961000	15662	7972	0	0	0
290650	1678	16560623962000	15662	7972	1	0	0
290651	1874	668000	15662	7972	2	0	2
290653	1874	674000	15662	7972	4	0	2
290654	1874	676000	15662	7972	5	0	2
290655	1678	16560623963000	15663	7973	0	0	0
290656	1874	678000	15663	7973	1	0	2
290658	1678	16560623964000	15664	7974	0	0	0
290659	1874	682000	15664	7974	1	0	2
290660	1874	684000	15664	7974	2	0	2
290661	1874	687000	15664	7974	3	0	2
290680	1678	16560623965000	15668	7975	0	0	0
290682	1874	690000	15668	7975	2	0	2
290683	1874	693000	15668	7975	3	0	2
290684	1874	695000	15668	7975	4	0	2
290685	1874	697000	15668	7975	5	0	2
290696	1678	16560623967000	15671	7976	0	0	0
290698	1874	699000	15671	7976	2	0	2
290699	1874	702000	15671	7976	3	0	2
290700	1874	705000	15671	7976	4	0	2
290701	1874	707000	15671	7976	5	0	2
290720	1678	16560623969000	15675	7977	0	0	0
290721	1874	710000	15675	7977	1	0	2
290722	1874	713000	15675	7977	2	0	2
290727	1678	16560623970000	15677	7978	0	0	0
290728	1874	714000	15677	7978	1	0	2
290730	1874	719000	15677	7978	3	0	2
290746	1678	16560623971000	15682	7979	0	0	0
290747	1874	721000	15682	7979	1	0	2
290748	1874	724000	15682	7979	2	0	2
290760	1678	16560623972000	15687	7980	0	0	0
290762	1874	729000	15687	7980	2	0	2
290769	1874	735000	15689	7981	3	0	\N
290770	1874	736000	15689	7981	4	0	\N
290771	1678	16560623973000	15690	7981	0	0	\N
290772	1678	16560623974000	15690	7981	1	0	\N
290773	1874	732000	15690	7981	2	0	\N
290774	1874	735000	15690	7981	3	0	\N
290775	1874	736000	15690	7981	4	0	\N
290776	1874	738000	15690	7981	5	0	\N
290777	1874	740000	15690	7981	6	0	\N
290791	1678	16560623976000	15695	7983	0	0	\N
290792	1874	748000	15695	7983	1	0	\N
290793	1874	750000	15695	7983	2	0	\N
290794	1678	16560623977000	15696	7984	0	0	\N
290795	1874	753000	15696	7984	1	0	\N
290796	1874	754000	15696	7984	2	0	\N
290797	1874	756000	15696	7984	3	0	\N
290802	1678	16560623977000	15698	7984	0	0	\N
290803	1874	753000	15698	7984	1	0	\N
290804	1874	754000	15698	7984	2	0	\N
290805	1874	756000	15698	7984	3	0	\N
290806	1678	16560623977000	15699	7984	0	0	\N
290807	1874	753000	15699	7984	1	0	\N
290808	1874	754000	15699	7984	2	0	\N
290809	1874	756000	15699	7984	3	0	\N
290810	1678	16560623978000	15700	7985	0	0	\N
290811	1678	16560623979000	15700	7985	2	0	\N
290817	1678	16560623978000	15702	7985	0	0	\N
290818	1678	16560623979000	15702	7985	2	0	\N
290819	1874	758000	15702	7985	3	0	\N
290820	1874	760000	15702	7985	4	0	\N
290821	485	68158999000000	15702	7985	5	0	\N
290822	1874	763000	15702	7985	6	0	\N
290823	1874	766000	15702	7985	7	0	\N
290824	1678	16560623978000	15703	7985	0	0	\N
290825	1678	16560623979000	15703	7985	2	0	\N
290826	1874	758000	15703	7985	3	0	\N
290827	1874	760000	15703	7985	4	0	\N
290828	485	68158999000000	15703	7985	5	0	\N
290829	1874	763000	15703	7985	6	0	\N
290830	1874	766000	15703	7985	7	0	\N
290831	1678	16560623980000	15704	7986	0	0	\N
290832	1874	763000	15704	7986	1	0	\N
290833	1874	765000	15704	7986	2	0	\N
290834	1874	768000	15704	7986	3	0	\N
290835	1874	770000	15704	7986	4	0	\N
290836	1874	772000	15704	7986	5	0	\N
290843	1678	16560623980000	15706	7986	0	0	\N
290844	1874	757000	15706	7986	1	0	\N
290845	1874	759000	15706	7986	2	0	\N
290846	1874	761000	15706	7986	3	0	\N
290847	1874	763000	15706	7986	4	0	\N
290848	485	68158999000000	15706	7986	5	0	\N
290849	1874	766000	15706	7986	6	0	\N
290850	1874	769000	15706	7986	7	0	\N
290851	1874	772000	15706	7986	8	0	\N
290868	1726	645950170000	15711	7902	0	0	\N
290869	1678	16560623986000	15712	7990	0	0	\N
290870	1874	800000	15712	7990	1	0	\N
290871	1874	803000	15712	7990	2	0	\N
290872	1678	16560623986000	15713	7990	0	0	\N
290873	1874	800000	15713	7990	1	0	\N
290874	1874	803000	15713	7990	2	0	\N
290878	1678	16560623987000	15715	7991	0	0	\N
290879	1874	805000	15715	7991	1	0	\N
290880	1874	808000	15715	7991	2	0	\N
290881	1874	809000	15715	7991	3	0	\N
290886	1678	16560623891000	15717	7844	0	0	\N
290887	1678	16560623892000	15717	7844	1	0	\N
290888	1678	16560623893000	15717	7844	2	0	\N
290889	1678	16560623894000	15717	7844	3	0	\N
290890	1678	16560623895000	15717	7844	4	0	\N
290891	1678	16560623896000	15717	7844	5	0	\N
290892	1678	16560623897000	15717	7844	6	0	\N
290893	1678	16560623898000	15717	7844	7	0	\N
290894	1678	16560623899000	15717	7844	8	0	\N
290895	1678	16560623900000	15717	7844	9	0	\N
290896	1678	16560623901000	15717	7844	10	0	\N
290897	1678	16560623902000	15717	7844	11	0	\N
290898	1678	16560623903000	15717	7844	12	0	\N
290899	1678	16560623904000	15717	7844	13	0	\N
290900	1678	16560623905000	15717	7844	14	0	\N
290901	1678	16560623906000	15717	7844	15	0	\N
290902	1678	16560623907000	15717	7844	17	0	\N
290903	1678	16560623908000	15717	7844	18	0	\N
290904	1678	16560623909000	15717	7844	19	0	\N
290780	1874	732000	15691	7981	2	0	2
290781	1874	735000	15691	7981	3	0	2
290782	1874	736000	15691	7981	4	0	2
290783	1874	738000	15691	7981	5	0	2
290784	1874	740000	15691	7981	6	0	2
290786	1874	742000	15693	7982	1	0	2
290787	1874	745000	15693	7982	2	0	2
290788	1678	16560623976000	15694	7983	0	0	0
290789	1874	748000	15694	7983	1	0	2
290790	1874	750000	15694	7983	2	0	2
290799	1874	753000	15697	7984	1	0	2
290800	1874	754000	15697	7984	2	0	2
290801	1874	756000	15697	7984	3	0	2
290812	1678	16560623978000	15701	7985	0	0	0
290814	485	68158999000000	15701	7985	3	0	1
290815	1874	759000	15701	7985	4	0	2
290816	1874	762000	15701	7985	5	0	2
290837	1678	16560623980000	15705	7986	0	0	0
290838	1874	763000	15705	7986	1	0	2
290840	1874	768000	15705	7986	3	0	2
290841	1874	770000	15705	7986	4	0	2
290842	1874	772000	15705	7986	5	0	2
290852	1678	16560623981000	15707	7987	0	0	0
290853	1874	774000	15707	7987	1	0	2
290855	1678	16560623982000	15708	7988	0	0	0
290856	1874	779000	15708	7988	1	0	2
290857	1874	782000	15708	7988	2	0	2
290858	1678	16560623983000	15710	7989	0	0	0
290860	1678	16560623985000	15710	7989	2	0	0
290861	1874	783000	15710	7989	3	0	2
290862	1874	785000	15710	7989	4	0	2
290863	1874	787000	15710	7989	5	0	2
290864	1874	789000	15710	7989	6	0	2
290866	1874	795000	15710	7989	8	0	2
290867	1874	798000	15710	7989	9	0	2
290875	1678	16560623986000	15714	7990	0	0	0
290876	1874	800000	15714	7990	1	0	2
290877	1874	803000	15714	7990	2	0	2
290883	1874	805000	15716	7991	1	0	2
290884	1874	808000	15716	7991	2	0	2
290885	1874	809000	15716	7991	3	0	2
290905	1678	16560623910000	15717	7844	20	0	\N
290906	1678	16560623911000	15717	7844	21	0	\N
290907	1678	16560623912000	15717	7844	22	0	\N
290908	1678	16560623913000	15717	7844	23	0	\N
290909	1678	16560623914000	15717	7844	24	0	\N
290910	1678	16560623915000	15717	7844	25	0	\N
290911	1678	16560623916000	15717	7844	26	0	\N
290912	1678	16560623917000	15717	7844	27	0	\N
290913	1678	16560623918000	15717	7844	28	0	\N
290914	1678	16560623919000	15717	7844	29	0	\N
290915	1678	16560623920000	15717	7844	30	0	\N
290916	1678	16560623921000	15717	7844	31	0	\N
290917	1678	16560623922000	15717	7844	32	0	\N
290918	1678	16560623923000	15717	7844	33	0	\N
290919	1678	16560623924000	15717	7844	34	0	\N
290920	1678	16560623925000	15717	7844	35	0	\N
290921	1678	16560623926000	15717	7844	36	0	\N
290922	1678	16560623927000	15717	7844	37	0	\N
290923	1678	16560623928000	15717	7844	38	0	\N
290924	1678	16560623929000	15717	7844	39	0	\N
290925	1678	16560623930000	15717	7844	40	0	\N
290926	1678	16560623931000	15717	7844	41	0	\N
290927	1678	16560623932000	15717	7844	42	0	\N
290928	1678	16560623933000	15717	7844	43	0	\N
290929	1678	16560623934000	15717	7844	44	0	\N
290930	1678	16560623935000	15717	7844	45	0	\N
290931	1678	16560623936000	15717	7844	46	0	\N
290932	1678	16560623937000	15717	7844	47	0	\N
290933	1678	16560623938000	15717	7844	48	0	\N
290934	1678	16560623939000	15717	7844	49	0	\N
290935	1678	16560623940000	15717	7844	50	0	\N
290936	1678	16560623941000	15717	7844	51	0	\N
290937	1678	16560623942000	15717	7844	52	0	\N
290938	1678	16560623943000	15717	7844	53	0	\N
290939	1678	16560623944000	15717	7844	54	0	\N
290940	1678	16560623945000	15717	7844	55	0	\N
290941	1678	16560623946000	15717	7844	56	0	\N
290942	1678	16560623947000	15717	7844	57	0	\N
290943	1678	16560623948000	15717	7844	58	0	\N
290944	1678	16560623949000	15717	7844	59	0	\N
290945	1678	16560623950000	15717	7844	60	0	\N
290946	1678	16560623951000	15717	7844	61	0	\N
290947	1678	16560623952000	15717	7844	62	0	\N
290948	1678	16560623953000	15717	7844	63	0	\N
290949	1678	16560623954000	15717	7844	64	0	\N
290950	1678	16560623955000	15717	7844	65	0	\N
290951	1678	16560623956000	15717	7844	66	0	\N
290952	1678	16560623957000	15717	7844	67	0	\N
290953	1678	16560623958000	15717	7844	68	0	\N
290954	1678	16560623959000	15717	7844	69	0	\N
290955	1678	16560623960000	15717	7844	70	0	\N
290956	1678	16560623961000	15717	7844	71	0	\N
290957	1678	16560623962000	15717	7844	72	0	\N
290958	1678	16560623963000	15717	7844	73	0	\N
290959	1678	16560623964000	15717	7844	74	0	\N
290960	1678	16560623965000	15717	7844	75	0	\N
290961	1678	16560623966000	15717	7844	76	0	\N
290962	1678	16560623967000	15717	7844	77	0	\N
290963	1678	16560623968000	15717	7844	78	0	\N
290964	1678	16560623969000	15717	7844	79	0	\N
290965	1678	16560623970000	15717	7844	80	0	\N
290966	1678	16560623971000	15717	7844	81	0	\N
290967	1678	16560623972000	15717	7844	82	0	\N
290968	1678	16560623973000	15717	7844	83	0	\N
290969	1678	16560623974000	15717	7844	84	0	\N
290970	1678	16560623975000	15717	7844	85	0	\N
290971	1678	16560623976000	15717	7844	86	0	\N
290972	1678	16560623977000	15717	7844	87	0	\N
290973	1678	16560623978000	15717	7844	88	0	\N
290974	1678	16560623979000	15717	7844	89	0	\N
290975	1678	16560623980000	15717	7844	90	0	\N
290976	1678	16560623981000	15717	7844	91	0	\N
290977	1678	16560623982000	15717	7844	92	0	\N
290978	1678	16560623983000	15717	7844	93	0	\N
290979	1678	16560623984000	15717	7844	94	0	\N
290980	1678	16560623985000	15717	7844	95	0	\N
290981	1678	16560623986000	15717	7844	96	0	\N
290982	1678	16560623987000	15717	7844	97	0	\N
290983	1726	646056323000	15717	7844	98	0	\N
290984	1874	268000	15717	7844	99	0	\N
290985	1874	270000	15717	7844	100	0	\N
290986	1874	271000	15717	7844	101	0	\N
290987	1874	273000	15717	7844	102	0	\N
290988	1874	274000	15717	7844	103	0	\N
290989	1874	275000	15717	7844	104	0	\N
290990	1874	277000	15717	7844	105	0	\N
290991	1874	278000	15717	7844	106	0	\N
290992	1874	280000	15717	7844	107	0	\N
290993	1874	281000	15717	7844	108	0	\N
290994	1874	283000	15717	7844	109	0	\N
290995	1874	284000	15717	7844	110	0	\N
290996	1874	285000	15717	7844	111	0	\N
290997	1874	287000	15717	7844	112	0	\N
290998	1874	288000	15717	7844	113	0	\N
290999	1874	290000	15717	7844	114	0	\N
291000	1874	291000	15717	7844	115	0	\N
291001	1874	293000	15717	7844	116	0	\N
291002	1874	294000	15717	7844	117	0	\N
291003	1874	296000	15717	7844	118	0	\N
291004	1874	297000	15717	7844	119	0	\N
291005	1874	298000	15717	7844	120	0	\N
291006	1874	300000	15717	7844	121	0	\N
291007	1874	301000	15717	7844	122	0	\N
291008	1874	303000	15717	7844	123	0	\N
291009	1874	304000	15717	7844	124	0	\N
291010	1874	306000	15717	7844	125	0	\N
291011	1678	16560623988000	15718	7992	0	0	\N
291012	1678	16560623989000	15718	7992	1	0	\N
291013	1678	16560623990000	15718	7992	2	0	\N
291014	1874	810000	15718	7992	3	0	\N
291015	1874	812000	15718	7992	4	0	\N
291016	1874	814000	15718	7992	5	0	\N
291017	1874	816000	15718	7992	6	0	\N
291018	1874	819000	15718	7992	7	0	\N
291019	1874	822000	15718	7992	8	0	\N
291020	1874	825000	15718	7992	9	0	\N
291037	1678	16560623992000	15722	7994	0	0	\N
291038	1874	832000	15722	7994	1	0	\N
291039	1874	835000	15722	7994	2	0	\N
291040	1678	16560623993000	15723	7995	0	0	\N
291023	1678	16560623990000	15719	7992	2	0	0
291024	1874	810000	15719	7992	3	0	2
291025	1874	812000	15719	7992	4	0	2
291026	1874	814000	15719	7992	5	0	2
291027	1874	816000	15719	7992	6	0	2
291029	1874	822000	15719	7992	8	0	2
291030	1874	825000	15719	7992	9	0	2
291031	1678	16560623991000	15720	7993	0	0	0
291032	1874	828000	15720	7993	1	0	2
291033	1874	830000	15720	7993	2	0	2
291035	1874	832000	15721	7994	1	0	2
291036	1874	835000	15721	7994	2	0	2
291041	1874	838000	15723	7995	1	0	\N
291042	1874	840000	15723	7995	2	0	\N
291046	1678	16560623993000	15725	7995	0	0	\N
291047	1874	838000	15725	7995	1	0	\N
291048	1874	840000	15725	7995	2	0	\N
291053	1678	16560623994000	15727	7996	0	0	\N
291054	1874	843000	15727	7996	1	0	\N
291055	1874	845000	15727	7996	2	0	\N
291056	1874	846000	15727	7996	3	0	\N
291063	1678	16560623996000	15730	7998	0	0	\N
291064	1874	853000	15730	7998	1	0	\N
291065	1874	856000	15730	7998	2	0	\N
291084	1678	16560624002000	15734	8002	0	0	\N
291085	1874	885000	15734	8002	1	0	\N
291086	1874	888000	15734	8002	2	0	\N
291101	1678	16560624003000	15737	8003	0	0	\N
291102	1678	16560624004000	15737	8003	1	0	\N
291103	1678	16560624005000	15737	8003	2	0	\N
291104	1874	889000	15737	8003	3	0	\N
291105	2136	453000000000	15737	8003	4	0	\N
291106	1874	892000	15737	8003	5	0	\N
291107	1874	894000	15737	8003	6	0	\N
291108	1874	896000	15737	8003	7	0	\N
291109	1874	898000	15737	8003	9	0	\N
291110	1874	901000	15737	8003	10	0	\N
291111	1874	904000	15737	8003	11	0	\N
291115	2137	99000000000	15739	8004	0	0	\N
291116	1678	16560624006000	15739	8004	1	0	\N
291117	1678	16560624007000	15740	8005	0	0	\N
291118	1678	16560624008000	15740	8005	1	0	\N
291119	1874	910000	15740	8005	2	0	\N
291120	1874	912000	15740	8005	3	0	\N
291121	1874	915000	15740	8005	4	0	\N
291122	1874	917000	15740	8005	5	0	\N
291123	1874	918000	15740	8005	6	0	\N
291134	1678	16560624009000	15743	8006	0	0	\N
291135	1874	920000	15743	8006	1	0	\N
291136	1874	923000	15743	8006	2	0	\N
291141	2137	99000000000	15745	7903	0	0	\N
291142	688	66000100000000	15745	7903	1	0	\N
291143	2136	9000000000	15745	7903	2	0	\N
291144	2136	453000000000	15745	7903	3	0	\N
291152	688	66000100000000	15747	8008	0	0	\N
291153	1678	16560624011000	15747	8008	1	0	\N
291154	1678	16560624012000	15747	8008	2	0	\N
291155	1874	931000	15747	8008	3	0	\N
291156	1874	933000	15747	8008	4	0	\N
291157	1874	936000	15747	8008	5	0	\N
291158	1874	939000	15747	8008	6	0	\N
291159	1474	11074422000023	15748	8009	0	0	\N
291160	1678	16560624013000	15748	8009	1	0	\N
291161	1678	16560624014000	15748	8009	2	0	\N
291162	1678	16560624015000	15748	8009	3	0	\N
291163	1678	16560624016000	15748	8009	4	0	\N
291164	1874	940000	15748	8009	5	0	\N
291165	1874	943000	15748	8009	6	0	\N
291166	1874	945000	15748	8009	7	0	\N
291167	1874	947000	15748	8009	8	0	\N
291168	1874	949000	15748	8009	9	0	\N
291169	1874	951000	15748	8009	10	0	\N
291170	1874	954000	15748	8009	11	0	\N
291171	1874	957000	15748	8009	12	0	\N
291172	1874	960000	15748	8009	13	0	\N
291173	1474	11074422000023	15749	8009	0	0	\N
291174	1678	16560624013000	15749	8009	1	0	\N
291175	1678	16560624014000	15749	8009	2	0	\N
291176	1678	16560624015000	15749	8009	3	0	\N
291045	1874	840000	15724	7995	2	0	2
291049	1678	16560623994000	15726	7996	0	0	0
291050	1874	843000	15726	7996	1	0	2
291051	1874	845000	15726	7996	2	0	2
291052	1874	846000	15726	7996	3	0	2
291058	1874	848000	15728	7997	1	0	2
291059	1874	851000	15728	7997	2	0	2
291060	1678	16560623996000	15729	7998	0	0	0
291061	1874	853000	15729	7998	1	0	2
291062	1874	856000	15729	7998	2	0	2
291067	1678	16560623998000	15731	7999	1	0	0
291068	1874	857000	15731	7999	2	0	2
291069	1874	859000	15731	7999	3	0	2
291070	1874	862000	15731	7999	4	0	2
291072	1874	867000	15731	7999	6	0	2
291073	1678	16560623999000	15732	8000	0	0	0
291074	1678	16560624000000	15732	8000	1	0	0
291075	1874	869000	15732	8000	2	0	2
291076	1874	871000	15732	8000	3	0	2
291078	2136	9000000000	15732	8000	5	0	0
291079	1874	875000	15732	8000	6	0	2
291080	1874	878000	15732	8000	7	0	2
291081	1678	16560624001000	15733	8001	0	0	0
291082	1874	881000	15733	8001	1	0	2
291087	1678	16560624002000	15735	8002	0	0	0
291088	1874	885000	15735	8002	1	0	2
291089	1874	888000	15735	8002	2	0	2
291090	1678	16560624003000	15736	8003	0	0	0
291092	1678	16560624005000	15736	8003	2	0	0
291093	1874	889000	15736	8003	3	0	2
291094	2136	453000000000	15736	8003	4	0	0
291095	1874	892000	15736	8003	5	0	2
291096	1874	894000	15736	8003	6	0	2
291098	1874	898000	15736	8003	9	0	2
291099	1874	901000	15736	8003	10	0	2
291100	1874	904000	15736	8003	11	0	2
291112	2137	99000000000	15738	8004	0	0	0
291113	1678	16560624006000	15738	8004	1	0	0
291124	1678	16560624007000	15741	8005	0	0	0
291125	1678	16560624008000	15741	8005	1	0	0
291126	1874	910000	15741	8005	2	0	2
291127	1874	912000	15741	8005	3	0	2
291129	1874	917000	15741	8005	5	0	2
291130	1874	918000	15741	8005	6	0	2
291131	1678	16560624009000	15742	8006	0	0	0
291132	1874	920000	15742	8006	1	0	2
291133	1874	923000	15742	8006	2	0	2
291138	1874	926000	15744	8007	1	0	2
291139	1874	928000	15744	8007	2	0	2
291140	1874	929000	15744	8007	3	0	2
291145	688	66000100000000	15746	8008	0	0	0
291146	1678	16560624011000	15746	8008	1	0	0
291148	1874	931000	15746	8008	3	0	2
291149	1874	933000	15746	8008	4	0	2
291150	1874	936000	15746	8008	5	0	2
291151	1874	939000	15746	8008	6	0	2
291177	1678	16560624016000	15749	8009	4	0	\N
291178	1874	940000	15749	8009	5	0	\N
291179	1874	943000	15749	8009	6	0	\N
291180	1874	945000	15749	8009	7	0	\N
291181	1874	947000	15749	8009	8	0	\N
291182	1874	949000	15749	8009	9	0	\N
291183	1874	951000	15749	8009	10	0	\N
291184	1874	954000	15749	8009	11	0	\N
291185	1874	957000	15749	8009	12	0	\N
291186	1874	960000	15749	8009	13	0	\N
291208	1678	16560624019000	15752	8011	0	0	\N
291209	1678	16560624020000	15752	8011	1	0	\N
291210	1874	974000	15752	8011	2	0	\N
291211	1874	977000	15752	8011	3	0	\N
291212	1874	978000	15752	8011	4	0	\N
291213	1874	980000	15752	8011	5	0	\N
291214	1874	982000	15752	8011	6	0	\N
291215	1678	16560624019000	15753	8011	0	0	\N
291216	1678	16560624020000	15753	8011	1	0	\N
291217	1874	974000	15753	8011	2	0	\N
291218	1874	977000	15753	8011	3	0	\N
291219	1874	978000	15753	8011	4	0	\N
291220	1874	980000	15753	8011	5	0	\N
291221	1874	982000	15753	8011	6	0	\N
291229	1678	16560624019000	15755	8011	0	0	\N
291230	1678	16560624020000	15755	8011	1	0	\N
291231	1874	974000	15755	8011	2	0	\N
291232	1874	977000	15755	8011	3	0	\N
291233	1874	978000	15755	8011	4	0	\N
291234	1874	980000	15755	8011	5	0	\N
291235	1874	982000	15755	8011	6	0	\N
291236	1874	984000	15755	8011	7	0	\N
291243	1678	16560624023000	15757	8013	0	0	\N
291244	1874	995000	15757	8013	1	0	\N
291245	1874	997000	15757	8013	2	0	\N
291253	1678	16560624024000	15760	8014	0	0	\N
291254	1874	1000000	15760	8014	1	0	\N
291255	1874	1002000	15760	8014	2	0	\N
291256	1874	1003000	15760	8014	3	0	\N
291269	1678	16560624028000	15763	8016	0	0	\N
291270	1874	1018000	15763	8016	1	0	\N
291271	1874	1021000	15763	8016	2	0	\N
291279	1504	1037237000000	15766	8019	0	0	\N
291280	1678	16560624031000	15766	8019	1	0	\N
291281	1678	16560624032000	15766	8019	2	0	\N
291282	1874	1034000	15766	8019	3	0	\N
291283	1874	1036000	15766	8019	4	0	\N
291284	1874	1039000	15766	8019	5	0	\N
291285	1874	1042000	15766	8019	6	0	\N
291293	1504	1037237000000	15768	8019	0	0	\N
291294	1678	16560624031000	15768	8019	1	0	\N
291295	1678	16560624032000	15768	8019	2	0	\N
291296	1874	1034000	15768	8019	3	0	\N
291297	1874	1036000	15768	8019	4	0	\N
291298	1874	1039000	15768	8019	5	0	\N
291299	1874	1042000	15768	8019	6	0	\N
291311	1678	16560624036000	15772	8023	0	0	\N
291312	1678	16560624037000	15772	8023	1	0	\N
291189	1678	16560624014000	15750	8009	2	0	0
291190	1678	16560624015000	15750	8009	3	0	0
291191	1678	16560624016000	15750	8009	4	0	0
291192	1874	940000	15750	8009	5	0	2
291193	1874	943000	15750	8009	6	0	2
291195	1874	947000	15750	8009	8	0	2
291196	1874	949000	15750	8009	9	0	2
291197	1874	951000	15750	8009	10	0	2
291198	1874	954000	15750	8009	11	0	2
291199	1874	957000	15750	8009	12	0	2
291201	1678	16560624017000	15751	8010	0	0	0
291202	1678	16560624018000	15751	8010	1	0	0
291203	1874	961000	15751	8010	2	0	2
291204	1874	964000	15751	8010	3	0	2
291206	1874	969000	15751	8010	5	0	2
291207	1874	971000	15751	8010	6	0	2
291222	1678	16560624019000	15754	8011	0	0	0
291223	1678	16560624020000	15754	8011	1	0	0
291224	1874	974000	15754	8011	2	0	2
291226	1874	978000	15754	8011	4	0	2
291227	1874	980000	15754	8011	5	0	2
291228	1874	982000	15754	8011	6	0	2
291237	1678	16560624021000	15756	8012	0	0	0
291238	1678	16560624022000	15756	8012	1	0	0
291240	1874	988000	15756	8012	3	0	2
291241	1874	990000	15756	8012	4	0	2
291242	1874	992000	15756	8012	5	0	2
291246	1678	16560624023000	15758	8013	0	0	0
291248	1874	997000	15758	8013	2	0	2
291249	1678	16560624024000	15759	8014	0	0	0
291250	1874	1000000	15759	8014	1	0	2
291251	1874	1002000	15759	8014	2	0	2
291252	1874	1003000	15759	8014	3	0	2
291258	1678	16560624026000	15761	8015	1	0	0
291259	1678	16560624027000	15761	8015	2	0	0
291260	1874	1005000	15761	8015	3	0	2
291261	1874	1006000	15761	8015	4	0	2
291262	1874	1009000	15761	8015	5	0	2
291264	1874	1014000	15761	8015	7	0	2
291265	1874	1016000	15761	8015	8	0	2
291266	1678	16560624028000	15762	8016	0	0	0
291267	1874	1018000	15762	8016	1	0	2
291272	1678	16560624029000	15764	8017	0	0	0
291273	1874	1024000	15764	8017	1	0	2
291274	1874	1026000	15764	8017	2	0	2
291275	1678	16560624030000	15765	8018	0	0	0
291276	1874	1027000	15765	8018	1	0	2
291278	1874	1032000	15765	8018	3	0	2
291286	1504	1037237000000	15767	8019	0	0	7
291287	1678	16560624031000	15767	8019	1	0	0
291288	1678	16560624032000	15767	8019	2	0	0
291289	1874	1034000	15767	8019	3	0	2
291291	1874	1039000	15767	8019	5	0	2
291292	1874	1042000	15767	8019	6	0	2
291300	1678	16560624033000	15769	8020	0	0	0
291301	1874	1044000	15769	8020	1	0	2
291303	1678	16560624034000	15770	8021	0	0	0
291304	1697	501990000000	15770	8021	1	0	1
291305	1874	1049000	15770	8021	2	0	2
291306	1874	1050000	15770	8021	3	0	2
291307	1874	1053000	15770	8021	4	0	2
291309	1874	1056000	15771	8022	1	0	2
291310	1874	1058000	15771	8022	2	0	2
291313	1678	16560624038000	15772	8023	2	0	\N
291314	1678	16560624039000	15772	8023	3	0	\N
291315	1874	1059000	15772	8023	4	0	\N
291316	1697	1001990000000	15772	8023	5	0	\N
291317	1874	1062000	15772	8023	6	0	\N
291318	1874	1065000	15772	8023	7	0	\N
291319	1874	1068000	15772	8023	8	0	\N
291320	1874	1071000	15772	8023	9	0	\N
291334	1678	16560624040000	15775	8024	0	0	\N
291335	1874	1074000	15775	8024	1	0	\N
291336	1874	1075000	15775	8024	2	0	\N
291337	1874	1077000	15775	8024	3	0	\N
291338	1874	1079000	15775	8024	4	0	\N
291339	1874	1081000	15775	8024	5	0	\N
291340	1874	1083000	15775	8024	6	0	\N
291341	1874	1085000	15775	8024	7	0	\N
291342	1678	16560624041000	15776	8025	0	0	\N
291343	1874	1078000	15776	8025	1	0	\N
291344	1874	1080000	15776	8025	2	0	\N
291345	1874	1082000	15776	8025	3	0	\N
291346	1874	1084000	15776	8025	4	0	\N
291347	1874	1086000	15776	8025	5	0	\N
291348	1874	1088000	15776	8025	6	0	\N
291349	1874	1090000	15776	8025	7	0	\N
291358	1678	16560624042000	15778	8026	0	0	\N
291362	1678	16560624043000	15780	8027	0	0	\N
291363	1874	1098000	15780	8027	1	0	\N
291364	1874	1100000	15780	8027	2	0	\N
291372	1678	16560624044000	15783	8028	0	0	\N
291373	1874	1103000	15783	8028	1	0	\N
291374	1874	1104000	15783	8028	2	0	\N
291375	1874	1106000	15783	8028	3	0	\N
291376	1678	16560624044000	15784	8028	0	0	\N
291377	1874	1103000	15784	8028	1	0	\N
291378	1874	1104000	15784	8028	2	0	\N
291400	1678	16560624050000	15789	8032	0	0	\N
291401	1678	16560624051000	15789	8032	1	0	\N
291402	1874	1133000	15789	8032	2	0	\N
291411	1678	16560624054000	15792	8035	0	0	\N
291412	1874	1155000	15792	8035	1	0	\N
291413	1874	1156000	15792	8035	2	0	\N
291414	1874	1159000	15792	8035	3	0	\N
291448	1678	16560624063000	15798	8039	0	0	\N
291323	1678	16560624038000	15773	8023	2	0	0
291324	1678	16560624039000	15773	8023	3	0	0
291325	1874	1059000	15773	8023	4	0	2
291326	1697	1001990000000	15773	8023	5	0	1
291327	1874	1062000	15773	8023	6	0	2
291329	1874	1068000	15773	8023	8	0	2
291330	1874	1071000	15773	8023	9	0	2
291331	1678	16560624040000	15774	8024	0	0	0
291332	1874	1074000	15774	8024	1	0	2
291333	1874	1075000	15774	8024	2	0	2
291351	1874	1078000	15777	8025	1	0	2
291352	1874	1080000	15777	8025	2	0	2
291353	1874	1082000	15777	8025	3	0	2
291354	1874	1084000	15777	8025	4	0	2
291356	1874	1088000	15777	8025	6	0	2
291357	1874	1090000	15777	8025	7	0	2
291359	1678	16560624042000	15779	8026	0	0	0
291360	1874	1092000	15779	8026	1	0	2
291361	1874	1095000	15779	8026	2	0	2
291366	1874	1098000	15781	8027	1	0	2
291367	1874	1100000	15781	8027	2	0	2
291368	1678	16560624044000	15782	8028	0	0	0
291369	1874	1103000	15782	8028	1	0	2
291370	1874	1104000	15782	8028	2	0	2
291379	1678	16560624045000	15785	8029	0	0	0
291380	1678	16560624046000	15785	8029	1	0	0
291381	1874	1109000	15785	8029	2	0	2
291382	1874	1112000	15785	8029	3	0	2
291384	1874	1116000	15785	8029	5	0	2
291385	1678	16560624047000	15786	8030	0	0	0
291386	1874	1118000	15786	8030	1	0	2
291387	1874	1119000	15786	8030	2	0	2
291388	1874	1122000	15786	8030	3	0	2
291390	1678	16560624049000	15787	8031	1	0	0
291391	1874	1124000	15787	8031	2	0	2
291392	1874	1126000	15787	8031	3	0	2
291393	1874	1129000	15787	8031	4	0	2
291394	1874	1132000	15787	8031	5	0	2
291396	1678	16560624051000	15788	8032	1	0	0
291397	1874	1133000	15788	8032	2	0	2
291398	1874	1136000	15788	8032	3	0	2
291399	1874	1139000	15788	8032	4	0	2
291404	1874	1141000	15790	8033	1	0	2
291405	1874	1143000	15790	8033	2	0	2
291406	1874	1146000	15790	8033	3	0	2
291407	1874	1148000	15790	8033	4	0	2
291408	1678	16560624053000	15791	8034	0	0	0
291410	1874	1153000	15791	8034	2	0	2
291415	1678	16560624054000	15793	8035	0	0	0
291416	1874	1155000	15793	8035	1	0	2
291417	1874	1156000	15793	8035	2	0	2
291418	1874	1159000	15793	8035	3	0	2
291420	1678	16560624056000	15794	8036	1	0	0
291421	1874	1161000	15794	8036	2	0	2
291422	1874	1163000	15794	8036	3	0	2
291423	1874	1166000	15794	8036	4	0	2
291425	1678	16560624057000	15795	8037	0	0	0
291426	1874	1172000	15795	8037	1	0	2
291427	1874	1174000	15795	8037	2	0	2
291428	1874	1175000	15795	8037	3	0	2
291429	1678	16560624058000	15796	8038	0	0	0
291431	1678	16560624060000	15796	8038	2	0	0
291432	1678	16560624061000	15796	8038	3	0	0
291433	1678	16560624062000	15796	8038	4	0	0
291434	1874	1176000	15796	8038	5	0	2
291435	1874	1179000	15796	8038	7	0	2
291437	1874	1183000	15796	8038	9	0	2
291438	1874	1185000	15796	8038	10	0	2
291439	1874	1187000	15796	8038	11	0	2
291440	1874	1189000	15796	8038	12	0	2
291442	1874	1195000	15796	8038	14	0	2
291443	1874	1198000	15796	8038	15	0	2
291444	1874	1201000	15796	8038	16	0	2
291445	1678	16560624063000	15797	8039	0	0	0
291446	1874	1204000	15797	8039	1	0	2
291449	1874	1204000	15798	8039	1	0	\N
291450	1874	1206000	15798	8039	2	0	\N
291467	1678	16560624068000	15804	8044	0	0	\N
291468	1874	1229000	15804	8044	1	0	\N
291469	1874	1231000	15804	8044	2	0	\N
291478	1678	16560624070000	15807	8046	0	0	\N
291479	1874	1239000	15807	8046	1	0	\N
291480	1874	1240000	15807	8046	2	0	\N
291481	1874	1242000	15807	8046	3	0	\N
291482	2137	99000000000	15808	7957	0	0	\N
291483	1504	1037237000000	15808	7957	1	0	\N
291484	1393	76061442306600000	15808	7957	2	0	\N
291485	688	66000100000000	15808	7957	3	0	\N
291486	1395	58023263863007706	15808	7957	4	0	\N
291487	1697	501990000000	15808	7957	5	0	\N
291488	1697	1001990000000	15808	7957	6	0	\N
291489	2136	9000000000	15808	7957	7	0	\N
291490	2136	453000000000	15808	7957	8	0	\N
291495	31	1327209135594000	15811	8048	0	0	\N
291496	32	74107429462000	15811	8048	1	0	\N
291497	40	66430661911000	15811	8048	2	0	\N
291498	1678	16560624072000	15811	8048	3	0	\N
291499	1678	16560624073000	15811	8048	4	0	\N
291500	1678	16560624074000	15811	8048	5	0	\N
291501	779	27959474083792	15811	8048	6	0	\N
291502	1874	1249000	15811	8048	7	0	\N
291503	1874	1251000	15811	8048	8	0	\N
291504	1874	1253000	15811	8048	9	0	\N
291505	1874	1254000	15811	8048	10	0	\N
291506	31	1327209135594000	15812	8048	0	0	\N
291507	32	74107429462000	15812	8048	1	0	\N
291508	40	66430661911000	15812	8048	2	0	\N
291509	1678	16560624072000	15812	8048	3	0	\N
291510	1678	16560624073000	15812	8048	4	0	\N
291511	1678	16560624074000	15812	8048	5	0	\N
291512	779	27959474083792	15812	8048	6	0	\N
291513	1874	1250000	15812	8048	7	0	\N
291514	1874	1253000	15812	8048	8	0	\N
291515	1874	1255000	15812	8048	9	0	\N
291516	1874	1257000	15812	8048	10	0	\N
291517	1874	1259000	15812	8048	11	0	\N
291518	1874	1260000	15812	8048	12	0	\N
291519	1874	1263000	15812	8048	13	0	\N
291534	31	1327209135594000	15814	8048	0	0	\N
291535	32	74107429462000	15814	8048	1	0	\N
291536	40	66430661911000	15814	8048	2	0	\N
291537	1678	16560624072000	15814	8048	3	0	\N
291538	1678	16560624073000	15814	8048	4	0	\N
291539	1678	16560624074000	15814	8048	5	0	\N
291540	779	27959474083792	15814	8048	6	0	\N
291541	1874	1250000	15814	8048	7	0	\N
291542	1874	1253000	15814	8048	8	0	\N
291543	1874	1255000	15814	8048	9	0	\N
291544	1874	1257000	15814	8048	10	0	\N
291545	1874	1259000	15814	8048	11	0	\N
291546	1874	1260000	15814	8048	12	0	\N
291547	1874	1263000	15814	8048	13	0	\N
291548	31	1327209135594000	15815	8048	0	0	\N
291549	32	74107429462000	15815	8048	1	0	\N
291550	40	66430661911000	15815	8048	2	0	\N
291551	1678	16560624072000	15815	8048	3	0	\N
291552	1678	16560624073000	15815	8048	4	0	\N
291553	1678	16560624074000	15815	8048	5	0	\N
291554	779	27959474083792	15815	8048	6	0	\N
291555	1874	1250000	15815	8048	7	0	\N
291556	1874	1253000	15815	8048	8	0	\N
291557	1874	1255000	15815	8048	9	0	\N
291558	1874	1257000	15815	8048	10	0	\N
291559	1874	1259000	15815	8048	11	0	\N
291560	1874	1260000	15815	8048	12	0	\N
291561	1874	1263000	15815	8048	13	0	\N
291562	31	1327209135594000	15816	8048	0	0	\N
291563	32	74107429462000	15816	8048	1	0	\N
291564	40	66430661911000	15816	8048	2	0	\N
291565	1678	16560624072000	15816	8048	3	0	\N
291566	1678	16560624073000	15816	8048	4	0	\N
291567	1678	16560624074000	15816	8048	5	0	\N
291568	779	27959474083792	15816	8048	6	0	\N
291569	1874	1249000	15816	8048	7	0	\N
291570	1874	1251000	15816	8048	8	0	\N
291571	1874	1253000	15816	8048	9	0	\N
291572	1874	1254000	15816	8048	10	0	\N
291453	1874	1210000	15799	8040	2	0	2
291454	1678	16560624065000	15800	8041	0	0	0
291455	1874	1212000	15800	8041	1	0	2
291456	1874	1215000	15800	8041	2	0	2
291457	1393	76061442306600000	15801	8042	0	0	0
291459	1874	1217000	15801	8042	2	0	2
291460	1678	16560624067000	15802	8043	0	0	0
291461	1874	1218000	15802	8043	1	0	2
291462	1874	1220000	15802	8043	2	0	2
291463	1874	1223000	15802	8043	3	0	2
291465	1678	16560624068000	15803	8044	0	0	0
291466	1874	1228000	15803	8044	1	0	2
291470	1678	16560624069000	15805	8045	0	0	0
291471	1395	58029023989007706	15805	8045	1	0	0
291473	1874	1233000	15805	8045	3	0	2
291474	1874	1236000	15805	8045	4	0	2
291475	1678	16560624070000	15806	8046	0	0	0
291476	1874	1237000	15806	8046	1	0	2
291477	1874	1239000	15806	8046	2	0	2
291492	1874	1242000	15809	8047	1	0	2
291493	1874	1244000	15809	8047	2	0	2
291494	1874	1247000	15809	8047	3	0	2
291520	31	1327209135594000	15813	8048	0	0	0
291521	32	74107429462000	15813	8048	1	0	0
291523	1678	16560624072000	15813	8048	3	0	0
291524	1678	16560624073000	15813	8048	4	0	0
291525	1678	16560624074000	15813	8048	5	0	0
291526	779	27959474083792	15813	8048	6	0	0
291528	1874	1253000	15813	8048	8	0	2
291529	1874	1255000	15813	8048	9	0	2
291530	1874	1257000	15813	8048	10	0	2
291531	1874	1259000	15813	8048	11	0	2
291532	1874	1260000	15813	8048	12	0	2
291573	1678	16560624075000	15817	8049	0	0	0
291574	1678	16560624076000	15817	8049	1	0	0
291575	1678	16560624077000	15817	8049	2	0	0
291576	780	307553946521051	15817	8049	3	0	0
291577	782	2460381810083720	15817	8049	4	0	0
291579	786	2460381810083720	15817	8049	6	0	0
291580	791	55918948168584	15817	8049	7	0	0
291581	792	615107893042101	15817	8049	8	0	0
291582	799	13978484472181	15817	8049	9	0	0
291584	801	13981070685666	15817	8049	11	0	0
291597	802	153791643333275	15819	8050	0	0	\N
291598	811	108201544180286	15819	8050	1	0	\N
291599	1678	16560624078000	15819	8050	2	0	\N
291600	1874	1282000	15819	8050	3	0	\N
291601	1874	1284000	15819	8050	4	0	\N
291615	1	374891644742000	15821	8052	0	0	\N
291616	841	83913851142298	15821	8052	1	0	\N
291617	1678	16560624082000	15821	8052	2	0	\N
291618	843	156445677530667	15821	8052	3	0	\N
291619	849	1158293913161640	15821	8052	4	0	\N
291620	851	2243792044281750	15821	8052	5	0	\N
291621	1678	16560624083000	15821	8052	6	0	\N
291622	1678	16560624084000	15821	8052	8	0	\N
291623	853	247414175730225	15821	8052	9	0	\N
291624	855	130872826396125	15821	8052	10	0	\N
291625	857	329993876187608	15821	8052	11	0	\N
291626	861	455798464345125	15821	8052	12	0	\N
291627	1874	1302000	15821	8052	13	0	\N
291628	1874	1305000	15821	8052	14	0	\N
291629	1874	1308000	15821	8052	15	0	\N
291630	1874	1310000	15821	8052	16	0	\N
291631	1874	1312000	15821	8052	17	0	\N
291632	1874	1315000	15821	8052	18	0	\N
291633	1874	1316000	15821	8052	19	0	\N
291634	1	374891644742000	15822	8052	0	0	\N
291635	841	83913851142298	15822	8052	1	0	\N
291636	1678	16560624082000	15822	8052	2	0	\N
291637	843	156445677530667	15822	8052	3	0	\N
291638	849	1158293913161640	15822	8052	4	0	\N
291639	851	2243792044281750	15822	8052	5	0	\N
291640	1678	16560624083000	15822	8052	6	0	\N
291641	1678	16560624084000	15822	8052	8	0	\N
291642	853	247414175730225	15822	8052	9	0	\N
291643	855	130872826396125	15822	8052	10	0	\N
291644	857	329993876187608	15822	8052	11	0	\N
291645	861	455798464345125	15822	8052	12	0	\N
291646	1874	1302000	15822	8052	13	0	\N
291647	1874	1305000	15822	8052	14	0	\N
291648	1874	1308000	15822	8052	15	0	\N
291649	1874	1310000	15822	8052	16	0	\N
291650	1874	1312000	15822	8052	17	0	\N
291651	1874	1315000	15822	8052	18	0	\N
291652	1874	1316000	15822	8052	19	0	\N
291653	1	374891644742000	15823	8052	0	0	\N
291654	841	83913851142298	15823	8052	1	0	\N
291655	1678	16560624082000	15823	8052	2	0	\N
291656	843	156445677530667	15823	8052	3	0	\N
291657	849	1158293913161640	15823	8052	4	0	\N
291658	851	2243792044281750	15823	8052	5	0	\N
291659	1678	16560624083000	15823	8052	6	0	\N
291660	1678	16560624084000	15823	8052	8	0	\N
291661	853	247414175730225	15823	8052	9	0	\N
291662	855	130872826396125	15823	8052	10	0	\N
291663	857	329993876187608	15823	8052	11	0	\N
291664	861	455798464345125	15823	8052	12	0	\N
291665	1874	1302000	15823	8052	13	0	\N
291666	1874	1305000	15823	8052	14	0	\N
291667	1874	1308000	15823	8052	15	0	\N
291668	1874	1310000	15823	8052	16	0	\N
291669	1874	1312000	15823	8052	17	0	\N
291670	1874	1315000	15823	8052	18	0	\N
291671	1874	1316000	15823	8052	19	0	\N
291672	1	374891644742000	15824	8052	0	0	\N
291673	841	83913851142298	15824	8052	1	0	\N
291674	1678	16560624082000	15824	8052	2	0	\N
291675	843	156445677530667	15824	8052	3	0	\N
291676	849	1158293913161640	15824	8052	4	0	\N
291677	851	2243792044281750	15824	8052	5	0	\N
291678	1678	16560624083000	15824	8052	6	0	\N
291679	1678	16560624084000	15824	8052	8	0	\N
291680	853	247414175730225	15824	8052	9	0	\N
291681	855	130872826396125	15824	8052	10	0	\N
291682	857	329993876187608	15824	8052	11	0	\N
291683	861	455798464345125	15824	8052	12	0	\N
291684	1874	1302000	15824	8052	13	0	\N
291685	1874	1305000	15824	8052	14	0	\N
291686	1874	1308000	15824	8052	15	0	\N
291687	1874	1310000	15824	8052	16	0	\N
291688	1874	1312000	15824	8052	17	0	\N
291689	1874	1315000	15824	8052	18	0	\N
291690	1874	1316000	15824	8052	19	0	\N
291710	1	374891644742000	15826	8052	0	0	\N
291711	841	83913851142298	15826	8052	1	0	\N
291712	1678	16560624082000	15826	8052	2	0	\N
291713	843	156445677530667	15826	8052	3	0	\N
291714	849	1158293913161640	15826	8052	4	0	\N
291715	851	2243792044281750	15826	8052	5	0	\N
291716	1678	16560624083000	15826	8052	6	0	\N
291717	1678	16560624084000	15826	8052	8	0	\N
291718	853	247414175730225	15826	8052	9	0	\N
291719	855	130872826396125	15826	8052	10	0	\N
291720	857	329993876187608	15826	8052	11	0	\N
291587	1874	1270000	15817	8049	14	0	2
291588	1874	1273000	15817	8049	15	0	2
291589	1874	1276000	15817	8049	16	0	2
291590	1874	1278000	15817	8049	17	0	2
291591	1874	1279000	15817	8049	18	0	2
291593	811	108201544180286	15818	8050	1	0	0
291594	1678	16560624078000	15818	8050	2	0	0
291595	1874	1282000	15818	8050	3	0	2
291596	1874	1284000	15818	8050	4	0	2
291602	1678	16560624079000	15820	8051	0	0	0
291604	1678	16560624081000	15820	8051	2	0	0
291605	812	1190215947253140	15820	8051	3	0	0
291606	823	1736257813668760	15820	8051	4	0	0
291607	824	19098819282295700	15820	8051	5	0	0
291609	1874	1288000	15820	8051	7	0	2
291610	1874	1291000	15820	8051	8	0	2
291611	1874	1294000	15820	8051	9	0	2
291612	1874	1297000	15820	8051	10	0	2
291613	1874	1299000	15820	8051	11	0	2
291691	1	374891644742000	15825	8052	0	0	0
291692	841	83913851142298	15825	8052	1	0	0
291693	1678	16560624082000	15825	8052	2	0	0
291694	843	156445677530667	15825	8052	3	0	0
291695	849	1158293913161640	15825	8052	4	0	1
291697	1678	16560624083000	15825	8052	6	0	0
291698	1678	16560624084000	15825	8052	8	0	0
291699	853	247414175730225	15825	8052	9	0	0
291700	855	130872826396125	15825	8052	10	0	0
291702	861	455798464345125	15825	8052	12	0	0
291703	1874	1302000	15825	8052	13	0	2
291704	1874	1305000	15825	8052	14	0	2
291705	1874	1308000	15825	8052	15	0	2
291706	1874	1310000	15825	8052	16	0	2
291708	1874	1315000	15825	8052	18	0	2
291709	1874	1316000	15825	8052	19	0	2
291721	861	455798464345125	15826	8052	12	0	\N
291722	1874	1302000	15826	8052	13	0	\N
291723	1874	1305000	15826	8052	14	0	\N
291724	1874	1308000	15826	8052	15	0	\N
291725	1874	1310000	15826	8052	16	0	\N
291726	1874	1312000	15826	8052	17	0	\N
291727	1874	1315000	15826	8052	18	0	\N
291728	1874	1316000	15826	8052	19	0	\N
291729	1	374891644742000	15827	8052	0	0	\N
291730	841	83913851142298	15827	8052	1	0	\N
291731	1678	16560624082000	15827	8052	2	0	\N
291732	843	156445677530667	15827	8052	3	0	\N
291733	849	1158293913161640	15827	8052	4	0	\N
291734	851	2243792044281750	15827	8052	5	0	\N
291735	1678	16560624083000	15827	8052	6	0	\N
291736	1678	16560624084000	15827	8052	8	0	\N
291737	853	247414175730225	15827	8052	9	0	\N
291738	855	130872826396125	15827	8052	10	0	\N
291739	857	329993876187608	15827	8052	11	0	\N
291740	861	455798464345125	15827	8052	12	0	\N
291741	1874	1302000	15827	8052	13	0	\N
291742	1874	1305000	15827	8052	14	0	\N
291743	1874	1308000	15827	8052	15	0	\N
291744	1874	1310000	15827	8052	16	0	\N
291745	1874	1312000	15827	8052	17	0	\N
291746	1874	1315000	15827	8052	18	0	\N
291747	1874	1316000	15827	8052	19	0	\N
291748	1	374891644742000	15828	8052	0	0	\N
291749	841	83913851142298	15828	8052	1	0	\N
291750	1678	16560624082000	15828	8052	2	0	\N
291751	843	156445677530667	15828	8052	3	0	\N
291752	849	1158293913161640	15828	8052	4	0	\N
291753	851	2243792044281750	15828	8052	5	0	\N
291754	1678	16560624083000	15828	8052	6	0	\N
291755	1678	16560624084000	15828	8052	8	0	\N
291756	853	247414175730225	15828	8052	9	0	\N
291757	855	130872826396125	15828	8052	10	0	\N
291758	857	329993876187608	15828	8052	11	0	\N
291759	861	455798464345125	15828	8052	12	0	\N
291760	1874	1302000	15828	8052	13	0	\N
291761	1874	1305000	15828	8052	14	0	\N
291762	1874	1308000	15828	8052	15	0	\N
291763	1874	1310000	15828	8052	16	0	\N
291764	1874	1312000	15828	8052	17	0	\N
291765	1874	1315000	15828	8052	18	0	\N
291766	1874	1316000	15828	8052	19	0	\N
291767	865	400139905992417	15829	8053	0	0	\N
291768	867	2436942285185000	15829	8053	1	0	\N
291769	869	260612023343845	15829	8053	2	0	\N
291770	1874	1318000	15829	8053	3	0	\N
291771	1874	1321000	15829	8053	4	0	\N
291782	873	2436942285185000	15832	8054	0	0	\N
291783	1678	16560624085000	15832	8054	1	0	\N
291784	875	213608521244583	15832	8054	2	0	\N
291785	1874	1323000	15832	8054	3	0	\N
291786	1874	1326000	15832	8054	4	0	\N
291787	1678	16560624086000	15833	8055	0	0	\N
291788	879	135385682478750	15833	8055	1	0	\N
291789	881	586671290741250	15833	8055	2	0	\N
291790	883	90257121652500	15833	8055	3	0	\N
291791	1874	1327000	15833	8055	4	0	\N
291792	1874	1329000	15833	8055	5	0	\N
291793	1874	1332000	15833	8055	6	0	\N
291824	1678	16560624092000	15837	8058	0	0	\N
291825	1874	1360000	15837	8058	1	0	\N
291826	1874	1363000	15837	8058	2	0	\N
291827	1678	16560624092000	15838	8058	0	0	\N
291828	1874	1360000	15838	8058	1	0	\N
291832	1678	16560624092000	15840	8058	0	0	\N
291833	1874	1360000	15840	8058	1	0	\N
291834	1874	1363000	15840	8058	2	0	\N
291835	1678	16560624093000	15841	8059	0	0	\N
291836	1874	1364000	15841	8059	1	0	\N
291837	1874	1366000	15841	8059	2	0	\N
291838	1874	1369000	15841	8059	3	0	\N
291839	1678	16560624093000	15842	8059	0	0	\N
291840	1874	1364000	15842	8059	1	0	\N
291841	1874	1366000	15842	8059	2	0	\N
291842	1874	1369000	15842	8059	3	0	\N
291847	1678	16560624093000	15844	8059	0	0	\N
291848	1874	1364000	15844	8059	1	0	\N
291849	1874	1366000	15844	8059	2	0	\N
291850	1874	1369000	15844	8059	3	0	\N
291854	1678	16560624094000	15846	8060	0	0	\N
291855	1874	1371000	15846	8060	1	0	\N
291856	1874	1374000	15846	8060	2	0	\N
291774	869	260612023343845	15830	8053	2	0	0
291775	1874	1318000	15830	8053	3	0	2
291776	1874	1321000	15830	8053	4	0	2
291777	873	2436942285185000	15831	8054	0	0	0
291778	1678	16560624085000	15831	8054	1	0	0
291780	1874	1323000	15831	8054	3	0	2
291781	1874	1326000	15831	8054	4	0	2
291794	1678	16560624086000	15834	8055	0	0	0
291795	879	135385682478750	15834	8055	1	0	0
291796	881	586671290741250	15834	8055	2	0	0
291798	1874	1327000	15834	8055	4	0	2
291799	1874	1329000	15834	8055	5	0	2
291800	1874	1332000	15834	8055	6	0	2
291801	1678	16560624087000	15835	8056	0	0	0
291803	889	226130493445249	15835	8056	2	0	0
291804	891	496414169088750	15835	8056	3	0	0
291805	1874	1334000	15835	8056	4	0	2
291806	1874	1337000	15835	8056	5	0	2
291807	897	65483346900885	15836	8057	0	0	0
291809	1678	16560624089000	15836	8057	2	0	0
291810	1678	16560624090000	15836	8057	3	0	0
291811	1678	16560624091000	15836	8057	4	0	0
291812	899	39034399971990	15836	8057	5	0	0
291813	901	117334258148250	15836	8057	6	0	0
291815	1874	1338000	15836	8057	8	0	2
291816	1874	1341000	15836	8057	9	0	2
291817	1874	1344000	15836	8057	10	0	2
291818	1874	1347000	15836	8057	11	0	2
291820	1874	1352000	15836	8057	13	0	2
291821	1874	1354000	15836	8057	14	0	2
291822	1874	1356000	15836	8057	15	0	2
291823	1874	1358000	15836	8057	16	0	2
291829	1678	16560624092000	15839	8058	0	0	0
291831	1874	1363000	15839	8058	2	0	2
291843	1678	16560624093000	15843	8059	0	0	0
291844	1874	1364000	15843	8059	1	0	2
291845	1874	1366000	15843	8059	2	0	2
291846	1874	1369000	15843	8059	3	0	2
291852	1874	1371000	15845	8060	1	0	2
291853	1874	1374000	15845	8060	2	0	2
291857	1678	16560624095000	15847	8061	0	0	\N
291858	1678	16560624096000	15847	8061	1	0	\N
291859	1678	16560624097000	15847	8061	2	0	\N
291860	1874	1376000	15847	8061	3	0	\N
291861	1874	1379000	15847	8061	4	0	\N
291862	1874	1382000	15847	8061	5	0	\N
291863	1874	1385000	15847	8061	6	0	\N
291864	1874	1386000	15847	8061	7	0	\N
291865	1874	1388000	15847	8061	8	0	\N
291866	1874	1390000	15847	8061	9	0	\N
291877	1678	16560624095000	15849	8061	0	0	\N
291878	1678	16560624096000	15849	8061	1	0	\N
291879	1678	16560624097000	15849	8061	2	0	\N
291880	1874	1376000	15849	8061	3	0	\N
291881	1874	1379000	15849	8061	4	0	\N
291882	1874	1382000	15849	8061	5	0	\N
291883	1874	1385000	15849	8061	6	0	\N
291884	1874	1386000	15849	8061	7	0	\N
291885	1874	1388000	15849	8061	8	0	\N
291886	1874	1390000	15849	8061	9	0	\N
291887	1678	16560624095000	15850	8061	0	0	\N
291888	1678	16560624096000	15850	8061	1	0	\N
291889	1678	16560624097000	15850	8061	2	0	\N
291890	1874	1376000	15850	8061	3	0	\N
291891	1874	1379000	15850	8061	4	0	\N
291892	1874	1382000	15850	8061	5	0	\N
291893	1874	1385000	15850	8061	6	0	\N
291894	1874	1386000	15850	8061	7	0	\N
291895	1874	1388000	15850	8061	8	0	\N
291896	1874	1390000	15850	8061	9	0	\N
291897	2138	49000000000	15851	8062	0	0	\N
291898	1678	16560624098000	15851	8062	1	0	\N
291899	1874	1392000	15851	8062	2	0	\N
291900	1874	1395000	15851	8062	3	0	\N
291905	2138	49000000000	15853	8062	0	0	\N
291906	1678	16560624098000	15853	8062	1	0	\N
291907	1874	1392000	15853	8062	2	0	\N
291908	1874	1395000	15853	8062	3	0	\N
291915	1678	16560624099000	15855	8063	0	0	\N
291916	1678	16560624100000	15855	8063	1	0	\N
291917	1874	1396000	15855	8063	2	0	\N
291918	1874	1399000	15855	8063	3	0	\N
291919	1874	1402000	15855	8063	4	0	\N
291920	1874	1404000	15855	8063	5	0	\N
291924	1678	16560624102000	15857	8065	0	0	\N
291925	1874	1411000	15857	8065	1	0	\N
291926	1874	1414000	15857	8065	2	0	\N
291927	1678	16560624102000	15858	8065	0	0	\N
291928	1874	1411000	15858	8065	1	0	\N
291929	1874	1414000	15858	8065	2	0	\N
291940	1678	16560624103000	15861	8066	0	0	\N
291941	1678	16560624104000	15861	8066	1	0	\N
291942	1874	1417000	15861	8066	2	0	\N
291943	1874	1420000	15861	8066	3	0	\N
291944	1874	1422000	15861	8066	4	0	\N
291945	1874	1424000	15861	8066	5	0	\N
291946	1874	1425000	15861	8066	6	0	\N
291947	2137	99000000000	15862	7978	0	0	\N
291948	2138	49000000000	15862	7978	1	0	\N
291949	1504	1037237000000	15862	7978	2	0	\N
291950	1393	76061442306600000	15862	7978	3	0	\N
291951	688	66000100000000	15862	7978	4	0	\N
291952	1395	58024703899007706	15862	7978	5	0	\N
291953	31	1327209135594000	15862	7978	6	0	\N
291954	1	374891644742000	15862	7978	7	0	\N
291955	841	83913851142298	15862	7978	8	0	\N
291956	32	74107429462000	15862	7978	9	0	\N
291957	40	66430661911000	15862	7978	10	0	\N
291958	843	156445677530667	15862	7978	11	0	\N
291959	849	1158293913161640	15862	7978	12	0	\N
291960	851	2243792044281750	15862	7978	13	0	\N
291961	779	27959474083792	15862	7978	14	0	\N
291962	780	307553946521051	15862	7978	15	0	\N
291963	782	2460381810083720	15862	7978	16	0	\N
291964	785	223671268846807	15862	7978	17	0	\N
291965	786	2460381810083720	15862	7978	18	0	\N
291966	791	55918948168584	15862	7978	19	0	\N
291967	792	615107893042101	15862	7978	20	0	\N
291968	799	13978484472181	15862	7978	21	0	\N
291969	800	153763195008607	15862	7978	22	0	\N
291970	801	13981070685666	15862	7978	23	0	\N
291971	802	153791643333275	15862	7978	24	0	\N
291972	811	108201544180286	15862	7978	25	0	\N
291973	812	1190215947253140	15862	7978	26	0	\N
291974	823	1736257813668760	15862	7978	27	0	\N
291975	824	19098819282295700	15862	7978	28	0	\N
291976	853	247414175730225	15862	7978	29	0	\N
291977	855	130872826396125	15862	7978	30	0	\N
291978	857	329993876187608	15862	7978	31	0	\N
291979	861	455798464345125	15862	7978	32	0	\N
291980	865	400139905992417	15862	7978	33	0	\N
291981	867	2436942285185000	15862	7978	34	0	\N
291982	869	260612023343845	15862	7978	35	0	\N
291983	873	2436942285185000	15862	7978	36	0	\N
291984	875	213608521244583	15862	7978	37	0	\N
291985	879	135385682478750	15862	7978	38	0	\N
291986	881	586671290741250	15862	7978	39	0	\N
291987	883	90257121652500	15862	7978	40	0	\N
291988	887	269380502712154	15862	7978	41	0	\N
291992	1678	16560624106000	15864	8068	0	0	\N
291869	1678	16560624097000	15848	8061	2	0	0
291870	1874	1376000	15848	8061	3	0	2
291871	1874	1379000	15848	8061	4	0	2
291872	1874	1382000	15848	8061	5	0	2
291873	1874	1385000	15848	8061	6	0	2
291875	1874	1388000	15848	8061	8	0	2
291876	1874	1390000	15848	8061	9	0	2
291901	2138	49000000000	15852	8062	0	0	0
291902	1678	16560624098000	15852	8062	1	0	0
291903	1874	1392000	15852	8062	2	0	2
291909	1678	16560624099000	15854	8063	0	0	0
291910	1678	16560624100000	15854	8063	1	0	0
291911	1874	1396000	15854	8063	2	0	2
291912	1874	1399000	15854	8063	3	0	2
291914	1874	1404000	15854	8063	5	0	2
291921	1678	16560624101000	15856	8064	0	0	0
291922	1874	1406000	15856	8064	1	0	2
291923	1874	1409000	15856	8064	2	0	2
291930	1678	16560624102000	15859	8065	0	0	0
291932	1874	1414000	15859	8065	2	0	2
291933	1678	16560624103000	15860	8066	0	0	0
291934	1678	16560624104000	15860	8066	1	0	0
291935	1874	1417000	15860	8066	2	0	2
291936	1874	1420000	15860	8066	3	0	2
291938	1874	1424000	15860	8066	5	0	2
291939	1874	1425000	15860	8066	6	0	2
291989	1678	16560624105000	15863	8067	0	0	0
291990	1874	1428000	15863	8067	1	0	2
291993	1874	1432000	15864	8068	1	0	\N
291994	1874	1435000	15864	8068	2	0	\N
291995	1874	1436000	15864	8068	3	0	\N
291996	1678	16560624106000	15865	8068	0	0	\N
291997	1874	1432000	15865	8068	1	0	\N
291998	1874	1435000	15865	8068	2	0	\N
291999	1874	1436000	15865	8068	3	0	\N
292017	1678	16560624110000	15871	8072	0	0	\N
292018	1874	1453000	15871	8072	1	0	\N
292019	1874	1454000	15871	8072	2	0	\N
292020	1874	1457000	15871	8072	3	0	\N
292024	1678	16560624112000	15873	8074	0	0	\N
292025	1874	1465000	15873	8074	1	0	\N
292026	1519	2879065000000	15873	8074	2	0	\N
292027	1874	1467000	15873	8074	3	0	\N
292036	1678	16560624113000	15876	8075	0	0	\N
292037	1874	1468000	15876	8075	1	0	\N
292038	1874	1470000	15876	8075	2	0	\N
292039	1874	1473000	15876	8075	3	0	\N
292040	1519	2879065000000	15878	8002	0	0	\N
292041	1519	2879065000000	15879	8012	0	0	\N
292042	1678	16560624114000	15880	8076	0	0	\N
292046	1678	16560624114000	15883	8076	0	0	\N
292047	1874	1475000	15883	8076	1	0	\N
292048	1874	1478000	15883	8076	2	0	\N
292049	1678	16560624114000	15885	8076	0	0	\N
292050	1678	16560624115000	15885	8076	1	0	\N
292051	1874	1475000	15885	8076	2	0	\N
292052	1874	1478000	15885	8076	3	0	\N
292053	1519	2879065000000	15886	8029	0	0	\N
292054	1678	16560624115000	15887	8077	0	0	\N
292055	1678	16560624116000	15887	8077	1	0	\N
292056	1874	1479000	15887	8077	2	0	\N
292057	1874	1482000	15887	8077	3	0	\N
292058	1874	1485000	15887	8077	4	0	\N
292059	1874	1487000	15887	8077	5	0	\N
292075	1678	16560624120000	15890	8079	0	0	\N
292076	1874	1504000	15890	8079	1	0	\N
292077	1874	1505000	15890	8079	2	0	\N
292078	1874	1508000	15890	8079	3	0	\N
292079	1678	16560624120000	15891	8079	0	0	\N
292080	1874	1504000	15891	8079	1	0	\N
292081	1874	1505000	15891	8079	2	0	\N
292082	1874	1508000	15891	8079	3	0	\N
292105	1678	16560624126000	15897	8083	0	0	\N
292106	1874	1536000	15897	8083	1	0	\N
292107	1874	1538000	15897	8083	2	0	\N
292108	1678	16560624126000	15898	8083	0	0	\N
292109	1874	1536000	15898	8083	1	0	\N
292110	1874	1538000	15898	8083	2	0	\N
292117	1678	16560624129000	15901	8086	0	0	\N
292118	1678	16560624130000	15901	8086	1	0	\N
292119	1874	1550000	15901	8086	2	0	\N
292120	1874	1552000	15901	8086	3	0	\N
292121	1874	1555000	15901	8086	4	0	\N
292122	1874	1558000	15901	8086	5	0	\N
292123	1678	16560624129000	15902	8086	0	0	\N
292124	1678	16560624130000	15902	8086	1	0	\N
292125	1874	1550000	15902	8086	2	0	\N
292126	1874	1552000	15902	8086	3	0	\N
292127	1874	1555000	15902	8086	4	0	\N
292128	1874	1558000	15902	8086	5	0	\N
292002	1874	1435000	15866	8068	2	0	2
292003	1874	1436000	15866	8068	3	0	2
292004	1678	16560624107000	15867	8069	0	0	0
292005	1874	1438000	15867	8069	1	0	2
292006	1874	1441000	15867	8069	2	0	2
292008	1874	1443000	15868	8070	1	0	2
292009	1874	1446000	15868	8070	2	0	2
292010	1678	16560624109000	15869	8071	0	0	0
292011	1874	1448000	15869	8071	1	0	2
292012	1874	1451000	15869	8071	2	0	2
292014	1874	1453000	15870	8072	1	0	2
292015	1874	1454000	15870	8072	2	0	2
292016	1874	1457000	15870	8072	3	0	2
292021	1678	16560624111000	15872	8073	0	0	0
292023	1874	1462000	15872	8073	2	0	2
292028	1678	16560624112000	15874	8074	0	0	0
292029	1874	1465000	15874	8074	1	0	2
292030	1519	2879065000000	15874	8074	2	0	1
292031	1874	1467000	15874	8074	3	0	2
292033	1874	1468000	15875	8075	1	0	2
292034	1874	1470000	15875	8075	2	0	2
292035	1874	1473000	15875	8075	3	0	2
292043	1678	16560624114000	15881	8076	0	0	0
292044	1874	1475000	15881	8076	1	0	2
292060	1678	16560624115000	15888	8077	0	0	0
292061	1678	16560624116000	15888	8077	1	0	0
292062	1874	1479000	15888	8077	2	0	2
292063	1874	1482000	15888	8077	3	0	2
292065	1874	1487000	15888	8077	5	0	2
292066	1678	16560624117000	15889	8078	0	0	0
292067	1678	16560624118000	15889	8078	1	0	0
292068	1678	16560624119000	15889	8078	2	0	0
292069	1874	1489000	15889	8078	3	0	2
292071	1874	1493000	15889	8078	5	0	2
292072	1874	1496000	15889	8078	6	0	2
292073	1874	1499000	15889	8078	7	0	2
292074	1874	1502000	15889	8078	8	0	2
292083	1678	16560624120000	15892	8079	0	0	0
292085	1874	1505000	15892	8079	2	0	2
292086	1874	1508000	15892	8079	3	0	2
292087	1678	16560624121000	15893	8080	0	0	0
292088	1874	1510000	15893	8080	1	0	2
292090	1678	16560624122000	15894	8081	0	0	0
292091	1874	1516000	15894	8081	1	0	2
292092	1874	1518000	15894	8081	2	0	2
292093	1678	16560624123000	15895	8082	0	0	0
292094	1678	16560624124000	15895	8082	1	0	0
292096	1874	1521000	15895	8082	3	0	2
292097	1874	1524000	15895	8082	4	0	2
292098	1874	1527000	15895	8082	5	0	2
292099	1874	1529000	15895	8082	6	0	2
292100	1874	1531000	15895	8082	7	0	2
292102	1678	16560624126000	15896	8083	0	0	0
292103	1874	1536000	15896	8083	1	0	2
292104	1874	1538000	15896	8083	2	0	2
292111	1678	16560624127000	15899	8084	0	0	0
292113	1874	1543000	15899	8084	2	0	2
292114	1678	16560624128000	15900	8085	0	0	0
292115	1874	1545000	15900	8085	1	0	2
292116	1874	1548000	15900	8085	2	0	2
292135	1678	16560624131000	15904	8087	0	0	\N
292136	1678	16560624132000	15904	8087	1	0	\N
292137	1874	1560000	15904	8087	2	0	\N
292138	1874	1563000	15904	8087	3	0	\N
292139	1874	1565000	15904	8087	4	0	\N
292140	1874	1568000	15904	8087	5	0	\N
292141	1678	16560624131000	15905	8087	0	0	\N
292142	1678	16560624132000	15905	8087	1	0	\N
292143	1874	1560000	15905	8087	2	0	\N
292144	1874	1563000	15905	8087	3	0	\N
292145	1874	1565000	15905	8087	4	0	\N
292146	1874	1568000	15905	8087	5	0	\N
292153	1678	16560624131000	15907	8087	0	0	\N
292154	1678	16560624132000	15907	8087	1	0	\N
292155	1874	1560000	15907	8087	2	0	\N
292156	1874	1563000	15907	8087	3	0	\N
292157	1874	1565000	15907	8087	4	0	\N
292158	1874	1568000	15907	8087	5	0	\N
292159	1678	16560624133000	15908	8088	0	0	\N
292160	1874	1570000	15908	8088	1	0	\N
292163	1678	16560624134000	15910	8089	0	0	\N
292164	1874	1572000	15910	8089	1	0	\N
292165	1874	1575000	15910	8089	2	0	\N
292175	1678	16560624137000	15914	8092	0	0	\N
292176	1678	16560624138000	15914	8092	1	0	\N
292177	1874	1587000	15914	8092	2	0	\N
292178	1874	1590000	15914	8092	3	0	\N
292179	1874	1593000	15914	8092	4	0	\N
292180	1874	1595000	15914	8092	5	0	\N
292187	1678	16560624139000	15916	8093	0	0	\N
292188	1678	16560624140000	15916	8093	1	0	\N
292189	1874	1597000	15916	8093	2	0	\N
292190	1874	1600000	15916	8093	3	0	\N
292191	1874	1603000	15916	8093	4	0	\N
292192	1678	16560624139000	15917	8093	0	0	\N
292193	1678	16560624140000	15917	8093	1	0	\N
292194	1874	1597000	15917	8093	2	0	\N
292195	1874	1599000	15917	8093	3	0	\N
292196	1874	1602000	15917	8093	4	0	\N
292197	1874	1605000	15917	8093	5	0	\N
292198	1678	16560624139000	15918	8093	0	0	\N
292199	1678	16560624140000	15918	8093	1	0	\N
292200	1874	1597000	15918	8093	2	0	\N
292201	1874	1599000	15918	8093	3	0	\N
292202	1874	1602000	15918	8093	4	0	\N
292203	1874	1605000	15918	8093	5	0	\N
292213	1678	16560624142000	15921	8095	0	0	\N
292214	1874	1613000	15921	8095	1	0	\N
292215	1874	1615000	15921	8095	2	0	\N
292219	1678	16560624143000	15923	8096	0	0	\N
292220	1678	16560624144000	15923	8096	1	0	\N
292221	1874	1617000	15923	8096	2	0	\N
292222	1874	1619000	15923	8096	3	0	\N
292223	1874	1622000	15923	8096	4	0	\N
292224	1874	1625000	15923	8096	5	0	\N
292234	1678	16560624145000	15926	8097	0	0	\N
292235	1874	1628000	15926	8097	1	0	\N
292236	1874	1630000	15926	8097	2	0	\N
292237	1678	16560624145000	15927	8097	0	0	\N
292238	1874	1628000	15927	8097	1	0	\N
292239	1874	1630000	15927	8097	2	0	\N
292240	1678	16560624146000	15928	8098	0	0	\N
292241	1874	1633000	15928	8098	1	0	\N
292253	1678	16560624147000	15931	8099	0	0	\N
292254	1678	16560624148000	15931	8099	1	0	\N
292255	1678	16560624149000	15931	8099	2	0	\N
292256	1874	1636000	15931	8099	3	0	\N
292257	1874	1639000	15931	8099	4	0	\N
292258	1874	1641000	15931	8099	5	0	\N
292259	1874	1643000	15931	8099	6	0	\N
292260	1874	1645000	15931	8099	7	0	\N
292261	1874	1648000	15931	8099	8	0	\N
292262	1678	16560624150000	15932	8100	0	0	\N
292263	1874	1650000	15932	8100	1	0	\N
292264	1874	1653000	15932	8100	2	0	\N
292131	1874	1550000	15903	8086	2	0	2
292132	1874	1552000	15903	8086	3	0	2
292133	1874	1555000	15903	8086	4	0	2
292134	1874	1558000	15903	8086	5	0	2
292147	1678	16560624131000	15906	8087	0	0	0
292149	1874	1560000	15906	8087	2	0	2
292150	1874	1563000	15906	8087	3	0	2
292151	1874	1565000	15906	8087	4	0	2
292152	1874	1568000	15906	8087	5	0	2
292161	1678	16560624133000	15909	8088	0	0	0
292166	1678	16560624134000	15911	8089	0	0	0
292167	1874	1572000	15911	8089	1	0	2
292168	1874	1575000	15911	8089	2	0	2
292169	1678	16560624135000	15912	8090	0	0	0
292171	1874	1580000	15912	8090	2	0	2
292172	1678	16560624136000	15913	8091	0	0	0
292173	1874	1583000	15913	8091	1	0	2
292174	1874	1585000	15913	8091	2	0	2
292181	1678	16560624137000	15915	8092	0	0	0
292183	1874	1587000	15915	8092	2	0	2
292184	1874	1590000	15915	8092	3	0	2
292185	1874	1593000	15915	8092	4	0	2
292186	1874	1595000	15915	8092	5	0	2
292204	1678	16560624139000	15919	8093	0	0	0
292206	1874	1597000	15919	8093	2	0	2
292207	1874	1599000	15919	8093	3	0	2
292208	1874	1602000	15919	8093	4	0	2
292209	1874	1605000	15919	8093	5	0	2
292211	1874	1608000	15920	8094	1	0	2
292212	1874	1610000	15920	8094	2	0	2
292216	1678	16560624142000	15922	8095	0	0	0
292217	1874	1613000	15922	8095	1	0	2
292218	1874	1615000	15922	8095	2	0	2
292226	1678	16560624144000	15924	8096	1	0	0
292227	1874	1617000	15924	8096	2	0	2
292228	1874	1619000	15924	8096	3	0	2
292229	1874	1622000	15924	8096	4	0	2
292230	1874	1625000	15924	8096	5	0	2
292232	1874	1628000	15925	8097	1	0	2
292233	1874	1630000	15925	8097	2	0	2
292242	1678	16560624146000	15929	8098	0	0	0
292243	1874	1633000	15929	8098	1	0	2
292245	1678	16560624148000	15930	8099	1	0	0
292246	1678	16560624149000	15930	8099	2	0	0
292247	1874	1636000	15930	8099	3	0	2
292248	1874	1639000	15930	8099	4	0	2
292249	1874	1641000	15930	8099	5	0	2
292251	1874	1645000	15930	8099	7	0	2
292252	1874	1648000	15930	8099	8	0	2
292265	1678	16560624150000	15933	8100	0	0	\N
292266	1874	1650000	15933	8100	1	0	\N
292267	1874	1653000	15933	8100	2	0	\N
292271	1678	16560624151000	15935	8101	0	0	\N
292272	1874	1656000	15935	8101	1	0	\N
292273	1874	1658000	15935	8101	2	0	\N
292277	1678	16560624152000	15937	8102	0	0	\N
292278	1874	1661000	15937	8102	1	0	\N
292279	1874	1663000	15937	8102	2	0	\N
292283	1678	16560624153000	15939	8103	0	0	\N
292284	1874	1666000	15939	8103	1	0	\N
292285	1874	1668000	15939	8103	2	0	\N
292286	1678	16560624153000	15940	8103	0	0	\N
292287	1874	1666000	15940	8103	1	0	\N
292288	1874	1668000	15940	8103	2	0	\N
292304	1678	16560624158000	15944	8106	0	0	\N
292305	1874	1691000	15944	8106	1	0	\N
292306	1874	1693000	15944	8106	2	0	\N
292313	1678	16560624159000	15947	8107	0	0	\N
292314	1874	1696000	15947	8107	1	0	\N
292315	1874	1698000	15947	8107	2	0	\N
292322	1678	16560624160000	15950	8108	0	0	\N
292323	1678	16560624161000	15950	8108	1	0	\N
292324	1874	1700000	15950	8108	2	0	\N
292325	1874	1702000	15950	8108	3	0	\N
292326	1874	1705000	15950	8108	4	0	\N
292327	1874	1708000	15950	8108	5	0	\N
292337	1678	16560624165000	15954	8112	0	0	\N
292338	1874	1725000	15954	8112	1	0	\N
292339	1874	1728000	15954	8112	2	0	\N
292340	1678	16560624165000	15955	8112	0	0	\N
292341	1874	1725000	15955	8112	1	0	\N
292342	1874	1728000	15955	8112	2	0	\N
292346	1678	16560624166000	15957	8113	0	0	\N
292347	1874	1730000	15957	8113	1	0	\N
292348	1874	1733000	15957	8113	2	0	\N
292352	1678	16560624166000	15959	8113	0	0	\N
292353	1874	1730000	15959	8113	1	0	\N
292354	1874	1733000	15959	8113	2	0	\N
292355	1678	16560624166000	15960	8113	0	0	\N
292356	1874	1730000	15960	8113	1	0	\N
292357	1874	1733000	15960	8113	2	0	\N
292358	1678	16560624166000	15961	8113	0	0	\N
292359	1874	1730000	15961	8113	1	0	\N
292360	1874	1733000	15961	8113	2	0	\N
292361	1678	16560624167000	15962	8114	0	0	\N
292362	1678	16560624168000	15962	8114	1	0	\N
292363	1874	1735000	15962	8114	2	0	\N
292364	1874	1738000	15962	8114	3	0	\N
292365	1874	1740000	15962	8114	4	0	\N
292366	1874	1743000	15962	8114	5	0	\N
292367	1678	16560624167000	15963	8114	0	0	\N
292368	1678	16560624168000	15963	8114	1	0	\N
292369	1874	1735000	15963	8114	2	0	\N
292370	1874	1738000	15963	8114	3	0	\N
292371	1874	1740000	15963	8114	4	0	\N
292372	1874	1743000	15963	8114	5	0	\N
292382	1678	16560624170000	15967	8117	0	0	\N
292383	1678	16560624171000	15967	8117	1	0	\N
292384	1874	1750000	15967	8117	2	0	\N
292385	1874	1752000	15967	8117	3	0	\N
292386	1874	1755000	15967	8117	4	0	\N
292387	1874	1758000	15967	8117	5	0	\N
292388	1678	16560624170000	15968	8117	0	0	\N
292389	1678	16560624171000	15968	8117	1	0	\N
292390	1874	1750000	15968	8117	2	0	\N
292391	1874	1752000	15968	8117	3	0	\N
292392	1874	1755000	15968	8117	4	0	\N
292393	1874	1758000	15968	8117	5	0	\N
292400	1678	16560624170000	15970	8117	0	0	\N
292270	1874	1653000	15934	8100	2	0	2
292274	1678	16560624151000	15936	8101	0	0	0
292275	1874	1656000	15936	8101	1	0	2
292276	1874	1658000	15936	8101	2	0	2
292280	1678	16560624152000	15938	8102	0	0	0
292282	1874	1663000	15938	8102	2	0	2
292289	1678	16560624153000	15941	8103	0	0	0
292290	1874	1666000	15941	8103	1	0	2
292291	1874	1668000	15941	8103	2	0	2
292292	1678	16560624154000	15942	8104	0	0	0
292294	1874	1671000	15942	8104	2	0	2
292295	1874	1673000	15942	8104	3	0	2
292296	1874	1675000	15942	8104	4	0	2
292297	1874	1678000	15942	8104	5	0	2
292299	1678	16560624157000	15943	8105	1	0	0
292300	1874	1681000	15943	8105	2	0	2
292301	1874	1684000	15943	8105	3	0	2
292302	1874	1686000	15943	8105	4	0	2
292303	1874	1688000	15943	8105	5	0	2
292308	1874	1691000	15945	8106	1	0	2
292309	1874	1693000	15945	8106	2	0	2
292310	1678	16560624159000	15946	8107	0	0	0
292311	1874	1696000	15946	8107	1	0	2
292312	1874	1698000	15946	8107	2	0	2
292317	1678	16560624161000	15949	8108	1	0	0
292318	1874	1700000	15949	8108	2	0	2
292319	1874	1702000	15949	8108	3	0	2
292320	1874	1705000	15949	8108	4	0	2
292328	1678	16560624162000	15951	8109	0	0	0
292329	1874	1710000	15951	8109	1	0	2
292330	1874	1713000	15951	8109	2	0	2
292331	1678	16560624163000	15952	8110	0	0	0
292332	1874	1716000	15952	8110	1	0	2
292334	1678	16560624164000	15953	8111	0	0	0
292335	1874	1721000	15953	8111	1	0	2
292336	1874	1723000	15953	8111	2	0	2
292343	1678	16560624165000	15956	8112	0	0	0
292344	1874	1725000	15956	8112	1	0	2
292349	1678	16560624166000	15958	8113	0	0	0
292350	1874	1730000	15958	8113	1	0	2
292351	1874	1733000	15958	8113	2	0	2
292373	1678	16560624167000	15964	8114	0	0	0
292375	1874	1735000	15964	8114	2	0	2
292376	1874	1738000	15964	8114	3	0	2
292377	1874	1740000	15964	8114	4	0	2
292378	1874	1743000	15964	8114	5	0	2
292379	1678	16560624169000	15965	8115	0	0	0
292381	1874	1748000	15965	8115	2	0	2
292394	1678	16560624170000	15969	8117	0	0	0
292395	1678	16560624171000	15969	8117	1	0	0
292396	1874	1750000	15969	8117	2	0	2
292397	1874	1752000	15969	8117	3	0	2
292399	1874	1758000	15969	8117	5	0	2
292401	1678	16560624171000	15970	8117	1	0	\N
292402	1874	1750000	15970	8117	2	0	\N
292403	1874	1752000	15970	8117	3	0	\N
292404	1874	1755000	15970	8117	4	0	\N
292405	1874	1758000	15970	8117	5	0	\N
292406	1678	16560624170000	15971	8117	0	0	\N
292407	1678	16560624171000	15971	8117	1	0	\N
292408	1874	1750000	15971	8117	2	0	\N
292409	1874	1752000	15971	8117	3	0	\N
292410	1874	1755000	15971	8117	4	0	\N
292411	1874	1758000	15971	8117	5	0	\N
292421	1678	16560624174000	15975	8120	0	0	\N
292422	1874	1771000	15975	8120	1	0	\N
292423	1874	1773000	15975	8120	2	0	\N
292424	2138	49000000000	15976	8047	0	0	\N
292425	1519	2879065000000	15976	8047	1	0	\N
292445	1678	16560624180000	15979	8122	0	0	\N
292446	1874	1800000	15979	8122	1	0	\N
292447	1874	1803000	15979	8122	2	0	\N
292448	1678	16560624180000	15980	8122	0	0	\N
292449	1874	1800000	15980	8122	1	0	\N
292450	1874	1803000	15980	8122	2	0	\N
292463	1678	16560624185000	15984	8126	0	0	\N
292464	1874	1825000	15984	8126	1	0	\N
292465	1874	1828000	15984	8126	2	0	\N
292469	1678	16560624185000	15986	8126	0	0	\N
292470	1874	1825000	15986	8126	1	0	\N
292471	1874	1828000	15986	8126	2	0	\N
292478	1678	16560624188000	15988	8128	0	0	\N
292479	1874	1841000	15988	8128	1	0	\N
292480	1874	1843000	15988	8128	2	0	\N
292481	1678	16560624188000	15989	8128	0	0	\N
292482	1874	1841000	15989	8128	1	0	\N
292483	1874	1843000	15989	8128	2	0	\N
292496	1678	16560624191000	15994	8131	0	0	\N
292497	1874	1856000	15994	8131	1	0	\N
292498	1874	1858000	15994	8131	2	0	\N
292518	1678	16560624195000	15999	8135	0	0	\N
292519	1678	16560624196000	15999	8135	1	0	\N
292520	1678	16560624197000	15999	8135	2	0	\N
292521	2139	200000000	15999	8135	3	0	\N
292522	1874	1875000	15999	8135	4	0	\N
292523	1874	1877000	15999	8135	5	0	\N
292524	1874	1879000	15999	8135	6	0	\N
292525	1874	1882000	15999	8135	7	0	\N
292526	1874	1883000	15999	8135	8	0	\N
292527	1874	1886000	15999	8135	9	0	\N
292414	1874	1763000	15972	8118	2	0	2
292415	1678	16560624173000	15973	8119	0	0	0
292416	1874	1766000	15973	8119	1	0	2
292417	1874	1768000	15973	8119	2	0	2
292418	1678	16560624174000	15974	8120	0	0	0
292420	1874	1773000	15974	8120	2	0	2
292426	1678	16560624175000	15977	8121	0	0	0
292427	1678	16560624176000	15977	8121	1	0	0
292428	1678	16560624177000	15977	8121	2	0	0
292429	1678	16560624178000	15977	8121	3	0	0
292431	1874	1776000	15977	8121	5	0	2
292432	1821	527990000000	15977	8121	6	0	1
292433	1874	1779000	15977	8121	7	0	2
292434	1874	1782000	15977	8121	8	0	2
292436	1874	1788000	15977	8121	10	0	2
292437	1874	1790000	15977	8121	11	0	2
292438	1874	1792000	15977	8121	12	0	2
292439	1874	1794000	15977	8121	13	0	2
292440	1874	1796000	15977	8121	14	0	2
292442	1678	16560624180000	15978	8122	0	0	0
292443	1874	1800000	15978	8122	1	0	2
292444	1874	1803000	15978	8122	2	0	2
292451	1678	16560624181000	15981	8123	0	0	0
292452	1874	1806000	15981	8123	1	0	2
292454	1678	16560624182000	15982	8124	0	0	0
292455	1678	16560624183000	15982	8124	1	0	0
292456	1874	1811000	15982	8124	2	0	2
292457	1874	1813000	15982	8124	3	0	2
292459	1874	1818000	15982	8124	5	0	2
292460	1678	16560624184000	15983	8125	0	0	0
292461	1874	1820000	15983	8125	1	0	2
292462	1874	1823000	15983	8125	2	0	2
292466	1678	16560624185000	15985	8126	0	0	0
292468	1874	1828000	15985	8126	2	0	2
292472	1678	16560624186000	15987	8127	0	0	0
292473	1678	16560624187000	15987	8127	1	0	0
292474	1874	1831000	15987	8127	2	0	2
292475	1874	1834000	15987	8127	3	0	2
292477	1874	1838000	15987	8127	5	0	2
292484	1678	16560624188000	15990	8128	0	0	0
292485	1874	1841000	15990	8128	1	0	2
292486	1874	1843000	15990	8128	2	0	2
292488	1874	1846000	15991	8129	1	0	2
292489	1874	1848000	15991	8129	2	0	2
292490	1678	16560624190000	15992	8130	0	0	0
292491	1874	1851000	15992	8130	2	0	2
292492	1874	1853000	15992	8130	3	0	2
292494	1874	1856000	15993	8131	1	0	2
292495	1874	1858000	15993	8131	2	0	2
292499	1678	16560624192000	15995	8132	0	0	0
292500	1874	1861000	15995	8132	1	0	2
292501	1874	1863000	15995	8132	2	0	2
292503	1874	1866000	15996	8133	1	0	2
292504	1874	1868000	15996	8133	2	0	2
292505	1678	16560624194000	15997	8134	0	0	0
292506	1874	1871000	15997	8134	1	0	2
292508	1678	16560624195000	15998	8135	0	0	0
292509	1678	16560624196000	15998	8135	1	0	0
292510	1678	16560624197000	15998	8135	2	0	0
292511	2139	200000000	15998	8135	3	0	0
292512	1874	1875000	15998	8135	4	0	2
292514	1874	1879000	15998	8135	6	0	2
292515	1874	1882000	15998	8135	7	0	2
292516	1874	1883000	15998	8135	8	0	2
292517	1874	1886000	15998	8135	9	0	2
292528	1678	16560624198000	16000	8136	0	0	0
292530	1678	16560624200000	16000	8136	2	0	0
292531	1874	1887000	16000	8136	3	0	2
292532	1874	1890000	16000	8136	4	0	2
292533	1874	1893000	16000	8136	5	0	2
292535	1874	1898000	16000	8136	7	0	2
292536	1874	1900000	16000	8136	8	0	2
292540	1678	16560624201000	16002	8137	0	0	\N
292541	1874	1902000	16002	8137	1	0	\N
292542	1874	1905000	16002	8137	2	0	\N
292557	1678	16560624203000	16005	8139	0	0	\N
292558	1678	16560624204000	16005	8139	1	0	\N
292559	1678	16560624205000	16005	8139	2	0	\N
292560	1874	1912000	16005	8139	3	0	\N
292561	1874	1915000	16005	8139	4	0	\N
292562	1874	1918000	16005	8139	5	0	\N
292563	1874	1920000	16005	8139	6	0	\N
292564	1874	1922000	16005	8139	7	0	\N
292565	1874	1925000	16005	8139	8	0	\N
292566	1874	1927000	16005	8139	9	0	\N
292586	1678	16560624207000	16008	8141	0	0	\N
292587	1678	16560624208000	16008	8141	1	0	\N
292588	1678	16560624209000	16008	8141	2	0	\N
292589	1678	16560624210000	16008	8141	3	0	\N
292590	1678	16560624211000	16008	8141	4	0	\N
292591	1874	1935000	16008	8141	5	0	\N
292592	1874	1938000	16008	8141	6	0	\N
292593	1874	1941000	16008	8141	7	0	\N
292594	1874	1943000	16008	8141	8	0	\N
292595	1874	1945000	16008	8141	9	0	\N
292596	1874	1947000	16008	8141	10	0	\N
292597	1874	1949000	16008	8141	11	0	\N
292598	1874	1951000	16008	8141	12	0	\N
292599	1874	1952000	16008	8141	13	0	\N
292600	1874	1955000	16008	8141	14	0	\N
292601	1874	1958000	16008	8141	15	0	\N
292602	1678	16560624207000	16009	8141	0	0	\N
292603	1678	16560624208000	16009	8141	1	0	\N
292604	1678	16560624209000	16009	8141	2	0	\N
292605	1678	16560624210000	16009	8141	3	0	\N
292606	1678	16560624211000	16009	8141	4	0	\N
292607	1874	1935000	16009	8141	5	0	\N
292608	1874	1938000	16009	8141	6	0	\N
292609	1874	1941000	16009	8141	7	0	\N
292610	1874	1943000	16009	8141	8	0	\N
292611	1874	1945000	16009	8141	9	0	\N
292612	1874	1947000	16009	8141	10	0	\N
292613	1874	1949000	16009	8141	11	0	\N
292614	1874	1951000	16009	8141	12	0	\N
292615	1874	1952000	16009	8141	13	0	\N
292616	1874	1955000	16009	8141	14	0	\N
292617	1874	1958000	16009	8141	15	0	\N
292618	1678	16560624212000	16010	8142	0	0	\N
292619	1874	1961000	16010	8142	1	0	\N
292620	1874	1963000	16010	8142	2	0	\N
292621	1874	1964000	16010	8142	3	0	\N
292626	1678	16560624212000	16012	8142	0	0	\N
292627	1874	1961000	16012	8142	1	0	\N
292628	1874	1963000	16012	8142	2	0	\N
292629	1874	1964000	16012	8142	3	0	\N
292630	1678	16560624212000	16013	8142	0	0	\N
292631	1874	1961000	16013	8142	1	0	\N
292632	1874	1963000	16013	8142	2	0	\N
292633	1874	1964000	16013	8142	3	0	\N
292634	1678	16560624213000	16014	8143	0	0	\N
292635	1874	1967000	16014	8143	1	0	\N
292636	1874	1969000	16014	8143	2	0	\N
292637	1678	16560624213000	16015	8143	0	0	\N
292638	1874	1967000	16015	8143	1	0	\N
292639	1874	1969000	16015	8143	2	0	\N
292643	1678	16560624214000	16017	8144	0	0	\N
292644	1874	1972000	16017	8144	1	0	\N
292645	1874	1974000	16017	8144	2	0	\N
292649	1678	16560624214000	16019	8144	0	0	\N
292650	1874	1972000	16019	8144	1	0	\N
292651	1874	1974000	16019	8144	2	0	\N
292666	1678	16560624218000	16024	8148	0	0	\N
292667	1874	1992000	16024	8148	1	0	\N
292668	1874	1993000	16024	8148	3	0	\N
292669	1874	1996000	16024	8148	4	0	\N
292670	1678	16560624218000	16025	8148	0	0	\N
292671	1874	1992000	16025	8148	1	0	\N
292672	1874	1993000	16025	8148	3	0	\N
292539	1874	1905000	16001	8137	2	0	2
292543	1678	16560624202000	16003	8138	0	0	0
292544	1874	1908000	16003	8138	1	0	2
292545	1874	1909000	16003	8138	2	0	2
292546	1874	1911000	16003	8138	3	0	2
292548	1678	16560624204000	16004	8139	1	0	0
292549	1678	16560624205000	16004	8139	2	0	0
292550	1874	1912000	16004	8139	3	0	2
292551	1874	1915000	16004	8139	4	0	2
292552	1874	1918000	16004	8139	5	0	2
292554	1874	1922000	16004	8139	7	0	2
292555	1874	1925000	16004	8139	8	0	2
292556	1874	1927000	16004	8139	9	0	2
292567	1678	16560624206000	16006	8140	0	0	0
292569	1874	1932000	16006	8140	2	0	2
292570	1678	16560624207000	16007	8141	0	0	0
292571	1678	16560624208000	16007	8141	1	0	0
292572	1678	16560624209000	16007	8141	2	0	0
292573	1678	16560624210000	16007	8141	3	0	0
292575	1874	1935000	16007	8141	5	0	2
292576	1874	1938000	16007	8141	6	0	2
292577	1874	1941000	16007	8141	7	0	2
292578	1874	1943000	16007	8141	8	0	2
292579	1874	1945000	16007	8141	9	0	2
292581	1874	1949000	16007	8141	11	0	2
292582	1874	1951000	16007	8141	12	0	2
292583	1874	1952000	16007	8141	13	0	2
292584	1874	1955000	16007	8141	14	0	2
292622	1678	16560624212000	16011	8142	0	0	0
292623	1874	1961000	16011	8142	1	0	2
292624	1874	1963000	16011	8142	2	0	2
292625	1874	1964000	16011	8142	3	0	2
292640	1678	16560624213000	16016	8143	0	0	0
292642	1874	1969000	16016	8143	2	0	2
292646	1678	16560624214000	16018	8144	0	0	0
292647	1874	1972000	16018	8144	1	0	2
292648	1874	1974000	16018	8144	2	0	2
292652	1678	16560624215000	16020	8145	0	0	0
292654	1874	1978000	16020	8145	2	0	2
292655	1874	1980000	16020	8145	3	0	2
292656	1678	16560624216000	16021	8146	0	0	0
292657	1874	1982000	16021	8146	1	0	2
292659	1678	16560624217000	16022	8147	0	0	0
292660	1874	1987000	16022	8147	1	0	2
292661	1874	1990000	16022	8147	2	0	2
292662	1678	16560624218000	16023	8148	0	0	0
292663	1874	1992000	16023	8148	1	0	2
292665	1874	1996000	16023	8148	4	0	2
292673	1874	1996000	16025	8148	4	0	\N
292674	1678	16560624219000	16026	8149	0	0	\N
292675	1678	16560624220000	16026	8149	1	0	\N
292676	1678	16560624221000	16026	8149	2	0	\N
292677	1874	1998000	16026	8149	3	0	\N
292678	1874	2001000	16026	8149	4	0	\N
292679	1874	2003000	16026	8149	5	0	\N
292680	1874	2005000	16026	8149	6	0	\N
292681	1874	2008000	16026	8149	7	0	\N
292682	1874	2011000	16026	8149	8	0	\N
292696	1678	16560624223000	16029	8151	0	0	\N
292697	1874	2019000	16029	8151	1	0	\N
292698	1874	2022000	16029	8151	2	0	\N
292712	1678	16560624227000	16034	8154	0	0	\N
292713	1678	16560624228000	16034	8154	1	0	\N
292714	1874	2040000	16034	8154	2	0	\N
292715	1874	2043000	16034	8154	3	0	\N
292716	1874	2044000	16034	8154	4	0	\N
292717	1874	2046000	16034	8154	5	0	\N
292718	1874	2049000	16034	8154	6	0	\N
292726	1678	16560624229000	16036	8155	0	0	\N
292727	1678	16560624230000	16036	8155	1	0	\N
292728	1874	2052000	16036	8155	2	0	\N
292729	1874	2055000	16036	8155	3	0	\N
292739	1678	16560624232000	16039	8157	0	0	\N
292740	1874	2067000	16039	8157	1	0	\N
292741	1874	2068000	16039	8157	2	0	\N
292742	1874	2070000	16039	8157	3	0	\N
292747	1678	16560624232000	16041	8157	0	0	\N
292748	1874	2067000	16041	8157	1	0	\N
292749	1874	2068000	16041	8157	2	0	\N
292750	1874	2070000	16041	8157	3	0	\N
292751	1678	16560624232000	16042	8157	0	0	\N
292752	1874	2067000	16042	8157	1	0	\N
292753	1874	2068000	16042	8157	2	0	\N
292754	1874	2070000	16042	8157	3	0	\N
292765	1678	16560624235000	16046	8160	0	0	\N
292766	1874	2083000	16046	8160	1	0	\N
292767	1874	2085000	16046	8160	2	0	\N
292768	1874	2086000	16046	8160	3	0	\N
292775	1678	16560624237000	16049	8162	0	0	\N
292776	1874	2093000	16049	8162	1	0	\N
292777	1874	2096000	16049	8162	2	0	\N
292791	1678	16560624240000	16053	8165	0	0	\N
292792	1678	16560624241000	16053	8165	1	0	\N
292793	1874	2110000	16053	8165	2	0	\N
292794	1874	2113000	16053	8165	3	0	\N
292795	1874	2115000	16053	8165	4	0	\N
292796	1874	2117000	16053	8165	5	0	\N
292797	1678	16560624134000	16054	8089	0	0	\N
292798	1678	16560624135000	16054	8089	1	0	\N
292799	1678	16560624136000	16054	8089	2	0	\N
292800	1678	16560624137000	16054	8089	3	0	\N
292801	1678	16560624138000	16054	8089	4	0	\N
292802	1678	16560624139000	16054	8089	5	0	\N
292803	1678	16560624140000	16054	8089	6	0	\N
292804	1678	16560624141000	16054	8089	7	0	\N
292805	2139	200000000	16054	8089	8	0	\N
292806	1678	16560624142000	16054	8089	9	0	\N
292807	1678	16560624143000	16054	8089	10	0	\N
292808	1678	16560624144000	16054	8089	11	0	\N
292685	1678	16560624221000	16027	8149	2	0	0
292686	1874	1998000	16027	8149	3	0	2
292687	1874	2001000	16027	8149	4	0	2
292688	1874	2003000	16027	8149	5	0	2
292689	1874	2005000	16027	8149	6	0	2
292691	1874	2011000	16027	8149	8	0	2
292692	1678	16560624222000	16028	8150	0	0	0
292693	1874	2013000	16028	8150	1	0	2
292694	1874	2016000	16028	8150	2	0	2
292695	1874	2017000	16028	8150	3	0	2
292700	1874	2019000	16030	8151	1	0	2
292701	1874	2022000	16030	8151	2	0	2
292702	1678	16560624224000	16031	8152	0	0	0
292703	1678	16560624225000	16031	8152	1	0	0
292705	1874	2025000	16031	8152	3	0	2
292706	1874	2027000	16031	8152	4	0	2
292707	1874	2030000	16031	8152	5	0	2
292708	1874	2033000	16031	8152	6	0	2
292709	1678	16560624226000	16033	8153	0	0	0
292711	1874	2038000	16033	8153	2	0	2
292719	1678	16560624227000	16035	8154	0	0	0
292720	1678	16560624228000	16035	8154	1	0	0
292721	1874	2040000	16035	8154	2	0	2
292722	1874	2043000	16035	8154	3	0	2
292724	1874	2046000	16035	8154	5	0	2
292725	1874	2049000	16035	8154	6	0	2
292730	1678	16560624229000	16037	8155	0	0	0
292731	1678	16560624230000	16037	8155	1	0	0
292733	1874	2054000	16037	8155	3	0	2
292734	1874	2056000	16037	8155	4	0	2
292735	1874	2059000	16037	8155	5	0	2
292736	1678	16560624231000	16038	8156	0	0	0
292737	1874	2061000	16038	8156	1	0	2
292743	1678	16560624232000	16040	8157	0	0	0
292744	1874	2067000	16040	8157	1	0	2
292745	1874	2068000	16040	8157	2	0	2
292746	1874	2070000	16040	8157	3	0	2
292755	1678	16560624233000	16043	8158	0	0	0
292757	1874	2075000	16043	8158	2	0	2
292758	1678	16560624234000	16044	8159	0	0	0
292759	1874	2077000	16044	8159	1	0	2
292760	1874	2080000	16044	8159	2	0	2
292762	1874	2083000	16045	8160	1	0	2
292763	1874	2085000	16045	8160	2	0	2
292764	1874	2086000	16045	8160	3	0	2
292769	1678	16560624236000	16047	8161	0	0	0
292770	1874	2089000	16047	8161	1	0	2
292772	1678	16560624237000	16048	8162	0	0	0
292773	1874	2093000	16048	8162	1	0	2
292774	1874	2096000	16048	8162	2	0	2
292778	1678	16560624238000	16050	8163	0	0	0
292779	1874	2098000	16050	8163	1	0	2
292781	1874	2102000	16050	8163	3	0	2
292782	1678	16560624239000	16051	8164	0	0	0
292783	1874	2104000	16051	8164	1	0	2
292784	1874	2107000	16051	8164	2	0	2
292786	1678	16560624241000	16052	8165	1	0	0
292787	1874	2110000	16052	8165	2	0	2
292788	1874	2113000	16052	8165	3	0	2
292789	1874	2115000	16052	8165	4	0	2
292790	1874	2117000	16052	8165	5	0	2
292809	1678	16560624145000	16054	8089	12	0	\N
292810	1678	16560624146000	16054	8089	13	0	\N
292811	1678	16560624147000	16054	8089	14	0	\N
292812	1678	16560624148000	16054	8089	15	0	\N
292813	1678	16560624149000	16054	8089	16	0	\N
292814	1678	16560624150000	16054	8089	17	0	\N
292815	1678	16560624151000	16054	8089	18	0	\N
292816	1678	16560624152000	16054	8089	19	0	\N
292817	1678	16560624153000	16054	8089	20	0	\N
292818	1678	16560624154000	16054	8089	21	0	\N
292819	1678	16560624155000	16054	8089	22	0	\N
292820	1678	16560624156000	16054	8089	23	0	\N
292821	1678	16560624157000	16054	8089	24	0	\N
292822	1678	16560624158000	16054	8089	25	0	\N
292823	1678	16560624159000	16054	8089	26	0	\N
292824	1678	16560624160000	16054	8089	27	0	\N
292825	1678	16560624161000	16054	8089	28	0	\N
292826	1678	16560624162000	16054	8089	29	0	\N
292827	1678	16560624163000	16054	8089	30	0	\N
292828	1678	16560624164000	16054	8089	31	0	\N
292829	1678	16560624165000	16054	8089	32	0	\N
292830	1678	16560624166000	16054	8089	33	0	\N
292831	1678	16560624167000	16054	8089	34	0	\N
292832	1678	16560624168000	16054	8089	35	0	\N
292833	1678	16560624169000	16054	8089	36	0	\N
292834	1678	16560624170000	16054	8089	37	0	\N
292835	1678	16560624171000	16054	8089	38	0	\N
292836	1678	16560624172000	16054	8089	39	0	\N
292837	1678	16560624173000	16054	8089	40	0	\N
292838	1678	16560624174000	16054	8089	41	0	\N
292839	1678	16560624175000	16054	8089	42	0	\N
292840	1678	16560624176000	16054	8089	43	0	\N
292841	1678	16560624177000	16054	8089	44	0	\N
292842	1678	16560624178000	16054	8089	45	0	\N
292843	1678	16560624179000	16054	8089	46	0	\N
292844	1678	16560624180000	16054	8089	47	0	\N
292845	1678	16560624181000	16054	8089	48	0	\N
292846	1678	16560624182000	16054	8089	49	0	\N
292847	1678	16560624183000	16054	8089	50	0	\N
292848	1678	16560624184000	16054	8089	51	0	\N
292849	1678	16560624185000	16054	8089	52	0	\N
292850	1678	16560624186000	16054	8089	53	0	\N
292851	1678	16560624187000	16054	8089	54	0	\N
292852	1678	16560624188000	16054	8089	55	0	\N
292853	1678	16560624189000	16054	8089	56	0	\N
292854	1678	16560624190000	16054	8089	57	0	\N
292855	1678	16560624191000	16054	8089	58	0	\N
292856	1678	16560624192000	16054	8089	59	0	\N
292857	1678	16560624193000	16054	8089	60	0	\N
292858	1678	16560624194000	16054	8089	61	0	\N
292859	1678	16560624195000	16054	8089	62	0	\N
292860	1678	16560624196000	16054	8089	63	0	\N
292861	1678	16560624197000	16054	8089	64	0	\N
292862	1678	16560624198000	16054	8089	65	0	\N
292863	1678	16560624199000	16054	8089	66	0	\N
292864	1678	16560624200000	16054	8089	67	0	\N
292865	1678	16560624201000	16054	8089	68	0	\N
292866	1678	16560624202000	16054	8089	69	0	\N
292867	1678	16560624203000	16054	8089	70	0	\N
292868	1678	16560624204000	16054	8089	71	0	\N
292869	1678	16560624205000	16054	8089	72	0	\N
292870	1678	16560624206000	16054	8089	73	0	\N
292871	1678	16560624207000	16054	8089	74	0	\N
292872	1678	16560624208000	16054	8089	75	0	\N
292873	1678	16560624209000	16054	8089	76	0	\N
292874	1678	16560624210000	16054	8089	77	0	\N
292875	1678	16560624211000	16054	8089	78	0	\N
292876	1678	16560624212000	16054	8089	79	0	\N
292877	1678	16560624213000	16054	8089	80	0	\N
292878	1678	16560624214000	16054	8089	81	0	\N
292879	1678	16560624215000	16054	8089	82	0	\N
292880	1678	16560624216000	16054	8089	83	0	\N
292881	1678	16560624217000	16054	8089	84	0	\N
292882	1678	16560624218000	16054	8089	85	0	\N
292883	1678	16560624219000	16054	8089	86	0	\N
292884	1678	16560624220000	16054	8089	87	0	\N
292885	1678	16560624221000	16054	8089	88	0	\N
292886	1678	16560624222000	16054	8089	89	0	\N
292887	1678	16560624223000	16054	8089	90	0	\N
292888	1678	16560624224000	16054	8089	91	0	\N
292889	1678	16560624225000	16054	8089	92	0	\N
292890	1678	16560624226000	16054	8089	93	0	\N
292891	1678	16560624227000	16054	8089	94	0	\N
292892	1678	16560624228000	16054	8089	95	0	\N
292893	1678	16560624229000	16054	8089	96	0	\N
292894	1678	16560624230000	16054	8089	97	0	\N
292895	1678	16560624231000	16054	8089	98	0	\N
292896	1678	16560624232000	16054	8089	99	0	\N
292897	1678	16560624233000	16054	8089	100	0	\N
292898	1678	16560624234000	16054	8089	101	0	\N
292899	1678	16560624235000	16054	8089	102	0	\N
292900	1678	16560624236000	16054	8089	103	0	\N
292901	1678	16560624237000	16054	8089	104	0	\N
292902	1678	16560624238000	16054	8089	105	0	\N
292903	1678	16560624239000	16054	8089	106	0	\N
292904	1678	16560624240000	16054	8089	107	0	\N
292905	1678	16560624241000	16054	8089	108	0	\N
292906	1874	1572000	16054	8089	109	0	\N
292907	1874	1575000	16054	8089	110	0	\N
292908	1821	527990000000	16054	8089	111	0	\N
292909	1874	1577000	16054	8089	112	0	\N
292910	1874	1579000	16054	8089	113	0	\N
292911	1874	1580000	16054	8089	114	0	\N
292912	1874	1583000	16054	8089	115	0	\N
292913	1874	1586000	16054	8089	116	0	\N
292914	1678	16560624242000	16055	8166	0	0	\N
292915	1874	2119000	16055	8166	1	0	\N
292916	1874	2120000	16055	8166	2	0	\N
292917	1874	2123000	16055	8166	3	0	\N
292929	1678	16560624243000	16058	8167	0	0	\N
292930	1678	16560624244000	16058	8167	1	0	\N
292931	1950	8669851000000	16058	8167	2	0	\N
292932	1874	2125000	16058	8167	3	0	\N
292933	1874	2127000	16058	8167	4	0	\N
292934	1874	2130000	16058	8167	5	0	\N
292935	1874	2133000	16058	8167	6	0	\N
292936	1678	16560624245000	16059	8168	0	0	\N
292937	1874	2136000	16059	8168	1	0	\N
292938	1874	2138000	16059	8168	2	0	\N
292939	1874	2139000	16059	8168	3	0	\N
292940	1678	16560624245000	16060	8168	0	0	\N
292941	1874	2136000	16060	8168	1	0	\N
292942	1874	2138000	16060	8168	2	0	\N
292943	1874	2139000	16060	8168	3	0	\N
292920	1874	2120000	16056	8166	2	0	2
292921	1874	2123000	16056	8166	3	0	2
292922	1678	16560624243000	16057	8167	0	0	0
292923	1678	16560624244000	16057	8167	1	0	0
292924	1950	8669851000000	16057	8167	2	0	14
292926	1874	2127000	16057	8167	4	0	2
292927	1874	2130000	16057	8167	5	0	2
292928	1874	2133000	16057	8167	6	0	2
292944	1678	16560624245000	16061	8168	0	0	0
292948	1678	16560624245000	16062	8168	0	0	\N
292949	1874	2136000	16062	8168	1	0	\N
292950	1874	2138000	16062	8168	2	0	\N
292951	1874	2139000	16062	8168	3	0	\N
292952	1678	16560624245000	16063	8168	0	0	\N
292953	1874	2136000	16063	8168	1	0	\N
292954	1874	2138000	16063	8168	2	0	\N
292955	1874	2139000	16063	8168	3	0	\N
292956	1678	16560624246000	16064	8169	0	0	\N
292957	1678	16560624247000	16064	8169	1	0	\N
292958	1874	2142000	16064	8169	2	0	\N
292959	1874	2145000	16064	8169	3	0	\N
292966	1678	16560624248000	16066	8170	0	0	\N
292967	1874	2152000	16066	8170	1	0	\N
292968	1874	2154000	16066	8170	2	0	\N
292969	1874	2155000	16066	8170	3	0	\N
292974	1678	16560624248000	16068	8170	0	0	\N
292975	1874	2148000	16068	8170	1	0	\N
292976	1874	2150000	16068	8170	2	0	\N
292977	1874	2152000	16068	8170	3	0	\N
292978	1874	2154000	16068	8170	4	0	\N
292979	1874	2155000	16068	8170	5	0	\N
292987	1678	16560624251000	16070	8172	0	0	\N
292988	1678	16560624252000	16070	8172	1	0	\N
292989	1874	2167000	16070	8172	2	0	\N
292990	1874	2168000	16070	8172	3	0	\N
292991	1874	2171000	16070	8172	4	0	\N
292992	1874	2174000	16070	8172	5	0	\N
292993	1874	2176000	16070	8172	6	0	\N
292994	1678	16560624251000	16071	8172	0	0	\N
292995	1678	16560624252000	16071	8172	1	0	\N
292996	1874	2167000	16071	8172	2	0	\N
292997	1874	2168000	16071	8172	3	0	\N
292998	1874	2171000	16071	8172	4	0	\N
292999	1874	2174000	16071	8172	5	0	\N
293000	1874	2176000	16071	8172	6	0	\N
293001	1678	16560624251000	16072	8172	0	0	\N
293002	1678	16560624252000	16072	8172	1	0	\N
293003	1874	2167000	16072	8172	2	0	\N
293004	1874	2168000	16072	8172	3	0	\N
293005	1874	2171000	16072	8172	4	0	\N
293006	1874	2174000	16072	8172	5	0	\N
293007	1874	2176000	16072	8172	6	0	\N
293015	1678	16560624251000	16074	8172	0	0	\N
293016	1678	16560624252000	16074	8172	1	0	\N
293017	1874	2167000	16074	8172	2	0	\N
293018	1874	2168000	16074	8172	3	0	\N
293019	1874	2171000	16074	8172	4	0	\N
293020	1874	2174000	16074	8172	5	0	\N
293021	1874	2176000	16074	8172	6	0	\N
293022	1678	16560624251000	16075	8172	0	0	\N
293023	1678	16560624252000	16075	8172	1	0	\N
293024	1874	2167000	16075	8172	2	0	\N
293025	1874	2168000	16075	8172	3	0	\N
293026	1874	2171000	16075	8172	4	0	\N
293027	1874	2174000	16075	8172	5	0	\N
293028	1874	2176000	16075	8172	6	0	\N
293031	1678	16560624253000	16078	8173	0	0	\N
293032	1678	16560624254000	16079	8174	0	0	\N
293033	1874	2182000	16079	8174	1	0	\N
293034	1874	2184000	16079	8174	2	0	\N
293035	1678	16560624254000	16080	8174	0	0	\N
293036	1874	2182000	16080	8174	1	0	\N
293037	1874	2184000	16080	8174	2	0	\N
293044	1678	16560624255000	16083	8175	0	0	\N
293045	1874	2186000	16083	8175	1	0	\N
293046	1874	2187000	16083	8175	2	0	\N
293047	1874	2186000	16084	8175	0	0	\N
293048	1874	2187000	16084	8175	1	0	\N
293052	1678	16560624256000	16086	8176	0	0	\N
293053	1874	2190000	16086	8176	1	0	\N
293054	1874	2192000	16086	8176	2	0	\N
293055	1678	16560624256000	16087	8176	0	0	\N
293056	1874	2190000	16087	8176	1	0	\N
293057	1874	2192000	16087	8176	2	0	\N
293058	1678	16560624255000	16088	8175	0	0	\N
293059	1874	2187000	16088	8175	1	0	\N
293060	1874	2189000	16088	8175	2	0	\N
293061	1874	2190000	16088	8175	3	0	\N
293065	1678	16560624258000	16090	8178	0	0	\N
293066	1678	16560624259000	16090	8178	1	0	\N
293067	1678	16560624260000	16090	8178	2	0	\N
293068	1678	16560624261000	16090	8178	3	0	\N
293069	1678	16560624262000	16090	8178	4	0	\N
293070	1678	16560624263000	16090	8178	5	0	\N
293071	1874	2199000	16090	8178	6	0	\N
293072	1874	2201000	16090	8178	7	0	\N
293073	1874	2203000	16090	8178	8	0	\N
293074	1874	2205000	16090	8178	9	0	\N
293075	1874	2207000	16090	8178	10	0	\N
293076	1874	2210000	16090	8178	11	0	\N
293077	1874	2213000	16090	8178	12	0	\N
293078	1874	2216000	16090	8178	13	0	\N
293079	1874	2219000	16090	8178	14	0	\N
293080	1874	2222000	16090	8178	15	0	\N
292947	1874	2139000	16061	8168	3	0	2
292960	1678	16560624246000	16065	8169	0	0	0
292961	1678	16560624247000	16065	8169	1	0	0
292962	1874	2141000	16065	8169	2	0	2
292963	1874	2144000	16065	8169	3	0	2
292965	1874	2149000	16065	8169	5	0	2
292970	1678	16560624248000	16067	8170	0	0	0
292971	1874	2152000	16067	8170	1	0	2
292972	1874	2154000	16067	8170	2	0	2
292973	1874	2155000	16067	8170	3	0	2
292981	1678	16560624250000	16069	8171	1	0	0
292982	1950	10169851000000	16069	8171	2	0	14
292983	1874	2157000	16069	8171	3	0	2
292984	1874	2159000	16069	8171	4	0	2
292986	1874	2165000	16069	8171	6	0	2
293008	1678	16560624251000	16073	8172	0	0	0
293009	1678	16560624252000	16073	8172	1	0	0
293010	1874	2167000	16073	8172	2	0	2
293011	1874	2168000	16073	8172	3	0	2
293013	1874	2174000	16073	8172	5	0	2
293014	1874	2176000	16073	8172	6	0	2
293029	1678	16560624253000	16076	8173	0	0	0
293030	1874	2179000	16076	8173	1	0	2
293038	1678	16560624254000	16081	8174	0	0	0
293040	1874	2184000	16081	8174	2	0	2
293041	1678	16560624255000	16082	8175	0	0	0
293042	1874	2186000	16082	8175	1	0	2
293043	1874	2187000	16082	8175	2	0	2
293050	1874	2190000	16085	8176	1	0	2
293051	1874	2192000	16085	8176	2	0	2
293062	1678	16560624257000	16089	8177	0	0	0
293063	1874	2194000	16089	8177	1	0	2
293064	1874	2197000	16089	8177	2	0	2
293081	1874	2225000	16090	8178	16	0	\N
293082	1874	2228000	16090	8178	17	0	\N
293083	1874	2230000	16090	8178	18	0	\N
293084	1874	2232000	16090	8178	19	0	\N
293085	1874	2233000	16090	8178	20	0	\N
293086	1874	2234000	16090	8178	21	0	\N
293119	1678	16560624266000	16094	8180	0	0	\N
293120	1874	2247000	16094	8180	1	0	\N
293121	1874	2250000	16094	8180	2	0	\N
293122	1678	16560624266000	16095	8180	0	0	\N
293123	1874	2247000	16095	8180	1	0	\N
293124	1874	2250000	16095	8180	2	0	\N
293138	1678	16560624270000	16099	8183	0	0	\N
293139	1874	2268000	16099	8183	1	0	\N
293140	1874	2271000	16099	8183	2	0	\N
293141	1678	16560624206000	16100	8140	0	0	\N
293142	1678	16560624207000	16100	8140	1	0	\N
293143	1678	16560624208000	16100	8140	2	0	\N
293144	1678	16560624209000	16100	8140	3	0	\N
293145	1678	16560624210000	16100	8140	4	0	\N
293146	1678	16560624211000	16100	8140	5	0	\N
293147	1678	16560624212000	16100	8140	6	0	\N
293148	1678	16560624213000	16100	8140	7	0	\N
293149	1678	16560624214000	16100	8140	8	0	\N
293150	1678	16560624215000	16100	8140	9	0	\N
293151	1678	16560624216000	16100	8140	10	0	\N
293152	1678	16560624217000	16100	8140	11	0	\N
293153	1678	16560624218000	16100	8140	12	0	\N
293154	1678	16560624219000	16100	8140	13	0	\N
293155	1678	16560624220000	16100	8140	14	0	\N
293156	1678	16560624221000	16100	8140	15	0	\N
293157	1678	16560624222000	16100	8140	16	0	\N
293158	1678	16560624223000	16100	8140	17	0	\N
293159	1678	16560624224000	16100	8140	18	0	\N
293160	1678	16560624225000	16100	8140	19	0	\N
293161	1678	16560624226000	16100	8140	20	0	\N
293162	1678	16560624227000	16100	8140	21	0	\N
293163	1678	16560624228000	16100	8140	22	0	\N
293164	1678	16560624229000	16100	8140	23	0	\N
293165	1678	16560624230000	16100	8140	24	0	\N
293166	1678	16560624231000	16100	8140	25	0	\N
293167	1678	16560624232000	16100	8140	26	0	\N
293168	1678	16560624233000	16100	8140	27	0	\N
293169	1678	16560624234000	16100	8140	28	0	\N
293170	1678	16560624235000	16100	8140	29	0	\N
293171	1678	16560624236000	16100	8140	30	0	\N
293172	1678	16560624237000	16100	8140	31	0	\N
293173	1678	16560624238000	16100	8140	32	0	\N
293174	1678	16560624239000	16100	8140	33	0	\N
293175	1678	16560624240000	16100	8140	34	0	\N
293176	1678	16560624241000	16100	8140	35	0	\N
293177	1678	16560624242000	16100	8140	36	0	\N
293178	1678	16560624243000	16100	8140	37	0	\N
293179	1678	16560624244000	16100	8140	38	0	\N
293180	1678	16560624245000	16100	8140	39	0	\N
293181	1678	16560624246000	16100	8140	40	0	\N
293182	1678	16560624247000	16100	8140	41	0	\N
293183	1678	16560624248000	16100	8140	42	0	\N
293184	1678	16560624249000	16100	8140	43	0	\N
293185	1678	16560624250000	16100	8140	44	0	\N
293186	1678	16560624251000	16100	8140	45	0	\N
293187	1678	16560624252000	16100	8140	46	0	\N
293188	1678	16560624253000	16100	8140	47	0	\N
293189	1678	16560624254000	16100	8140	48	0	\N
293190	1678	16560624255000	16100	8140	49	0	\N
293191	1678	16560624256000	16100	8140	50	0	\N
293192	1678	16560624257000	16100	8140	51	0	\N
293193	1678	16560624258000	16100	8140	52	0	\N
293194	1678	16560624259000	16100	8140	53	0	\N
293195	1678	16560624260000	16100	8140	54	0	\N
293196	1678	16560624261000	16100	8140	55	0	\N
293197	1678	16560624262000	16100	8140	56	0	\N
293198	1678	16560624263000	16100	8140	58	0	\N
293199	1678	16560624264000	16100	8140	59	0	\N
293200	1678	16560624265000	16100	8140	60	0	\N
293201	1678	16560624266000	16100	8140	61	0	\N
293202	1678	16560624267000	16100	8140	62	0	\N
293203	1678	16560624268000	16100	8140	63	0	\N
293204	1678	16560624269000	16100	8140	64	0	\N
293205	1678	16560624270000	16100	8140	65	0	\N
293206	1874	1929000	16100	8140	66	0	\N
293207	1950	8669851000000	16100	8140	67	0	\N
293208	1950	10169851000000	16100	8140	68	0	\N
293209	1874	1931000	16100	8140	69	0	\N
293210	1874	1933000	16100	8140	70	0	\N
293211	1874	1935000	16100	8140	71	0	\N
293212	1874	1937000	16100	8140	72	0	\N
293213	1874	1939000	16100	8140	73	0	\N
293214	1874	1941000	16100	8140	74	0	\N
293215	1874	1943000	16100	8140	75	0	\N
293216	1874	1944000	16100	8140	76	0	\N
293089	1678	16560624260000	16091	8178	2	0	0
293090	1678	16560624261000	16091	8178	3	0	0
293091	1678	16560624262000	16091	8178	4	0	0
293092	1678	16560624263000	16091	8178	5	0	0
293093	1874	2199000	16091	8178	6	0	2
293095	1874	2203000	16091	8178	8	0	2
293096	1874	2205000	16091	8178	9	0	2
293097	1874	2207000	16091	8178	10	0	2
293098	1874	2210000	16091	8178	11	0	2
293099	1874	2213000	16091	8178	12	0	2
293101	1874	2219000	16091	8178	14	0	2
293102	1874	2222000	16091	8178	15	0	2
293103	1874	2225000	16091	8178	16	0	2
293104	1874	2228000	16091	8178	17	0	2
293106	1874	2232000	16091	8178	19	0	2
293107	1874	2233000	16091	8178	20	0	2
293108	1874	2234000	16091	8178	21	0	2
293109	1678	16560624264000	16092	8179	0	0	0
293110	1678	16560624265000	16092	8179	1	0	0
293112	1874	2237000	16092	8179	3	0	2
293113	1874	2239000	16092	8179	4	0	2
293114	1874	2242000	16092	8179	5	0	2
293115	1874	2245000	16092	8179	6	0	2
293116	1678	16560624266000	16093	8180	0	0	0
293118	1874	2250000	16093	8180	2	0	2
293125	1678	16560624267000	16096	8181	0	0	0
293126	1874	2251000	16096	8181	1	0	2
293127	1874	2253000	16096	8181	2	0	2
293129	1678	16560624268000	16097	8182	0	0	0
293130	1678	16560624269000	16097	8182	1	0	0
293131	1874	2259000	16097	8182	2	0	2
293132	1874	2262000	16097	8182	3	0	2
293133	1874	2264000	16097	8182	4	0	2
293135	1678	16560624270000	16098	8183	0	0	0
293136	1874	2268000	16098	8183	1	0	2
293137	1874	2271000	16098	8183	2	0	2
293217	1874	1945000	16100	8140	77	0	\N
293218	1874	1946000	16100	8140	78	0	\N
293219	1874	1947000	16100	8140	79	0	\N
293220	1874	1948000	16100	8140	80	0	\N
293221	1874	1949000	16100	8140	81	0	\N
293222	1874	1950000	16100	8140	82	0	\N
293223	1874	1951000	16100	8140	83	0	\N
293224	1874	1952000	16100	8140	84	0	\N
293225	1874	1954000	16100	8140	85	0	\N
293226	1874	1956000	16100	8140	86	0	\N
293227	1874	1958000	16100	8140	87	0	\N
293228	1874	1960000	16100	8140	88	0	\N
293229	1874	1962000	16100	8140	89	0	\N
293230	1874	1964000	16100	8140	90	0	\N
293231	1874	1966000	16100	8140	91	0	\N
293232	1874	1968000	16100	8140	92	0	\N
293233	1874	1970000	16100	8140	93	0	\N
293234	1874	1972000	16100	8140	94	0	\N
293235	1874	1974000	16100	8140	95	0	\N
293236	1874	1976000	16100	8140	96	0	\N
293237	1874	1978000	16100	8140	97	0	\N
293238	1874	1980000	16100	8140	98	0	\N
293239	1874	1982000	16100	8140	99	0	\N
293240	1874	1984000	16100	8140	100	0	\N
293241	1874	1986000	16100	8140	101	0	\N
293242	1874	1988000	16100	8140	102	0	\N
293243	1874	1990000	16100	8140	103	0	\N
293244	1874	1992000	16100	8140	104	0	\N
293245	1874	1994000	16100	8140	105	0	\N
293246	1874	1996000	16100	8140	106	0	\N
293247	1874	1998000	16100	8140	107	0	\N
293248	1874	2000000	16100	8140	108	0	\N
293249	1874	2002000	16100	8140	109	0	\N
293250	1874	2004000	16100	8140	110	0	\N
293251	1874	2007000	16100	8140	111	0	\N
293252	1874	2010000	16100	8140	112	0	\N
293253	1874	2013000	16100	8140	113	0	\N
293254	1874	2016000	16100	8140	114	0	\N
293255	1874	2019000	16100	8140	115	0	\N
293256	1874	2022000	16100	8140	116	0	\N
293257	1874	2025000	16100	8140	117	0	\N
293258	1874	2028000	16100	8140	118	0	\N
293259	1874	2031000	16100	8140	119	0	\N
293260	1874	2034000	16100	8140	120	0	\N
293261	1874	2037000	16100	8140	121	0	\N
293262	1874	2040000	16100	8140	122	0	\N
293263	1874	2043000	16100	8140	123	0	\N
293264	1874	2046000	16100	8140	124	0	\N
293265	1874	2047000	16100	8140	125	0	\N
293273	1678	16560624272000	16103	8185	0	0	\N
293274	1874	2280000	16103	8185	1	0	\N
293275	1874	2282000	16103	8185	3	0	\N
293276	1678	16560624272000	16104	8185	0	0	\N
293277	1874	2280000	16104	8185	1	0	\N
293278	1874	2282000	16104	8185	3	0	\N
293286	1678	16560624273000	16106	8186	0	0	\N
293287	1678	16560624274000	16106	8186	1	0	\N
293288	1874	2284000	16106	8186	2	0	\N
293289	1874	2286000	16106	8186	3	0	\N
293290	1874	2287000	16106	8186	4	0	\N
293291	1874	2290000	16106	8186	5	0	\N
293292	1874	2293000	16106	8186	6	0	\N
293293	1678	16560624275000	16107	8187	0	0	\N
293294	1874	2296000	16107	8187	1	0	\N
293295	1874	2298000	16107	8187	2	0	\N
293296	1678	16560624275000	16108	8187	0	0	\N
293297	1874	2296000	16108	8187	1	0	\N
293298	1874	2298000	16108	8187	2	0	\N
293325	1678	16560624282000	16114	8191	0	0	\N
293326	1874	2333000	16114	8191	1	0	\N
293327	1874	2335000	16114	8191	2	0	\N
293335	1678	16560624284000	16117	8193	0	0	\N
293336	1874	2341000	16117	8193	1	0	\N
293337	1874	2343000	16117	8193	2	0	\N
293338	1874	2346000	16117	8193	3	0	\N
293339	1678	16560624285000	16118	8194	0	0	\N
293340	1678	16560624286000	16118	8194	1	0	\N
293341	1874	2349000	16118	8194	2	0	\N
293342	1874	2351000	16118	8194	3	0	\N
293343	1874	2353000	16118	8194	4	0	\N
293344	1874	2356000	16118	8194	5	0	\N
293268	1874	2274000	16101	8184	2	0	2
293269	1874	2277000	16101	8184	3	0	2
293270	1678	16560624272000	16102	8185	0	0	0
293271	1874	2280000	16102	8185	1	0	2
293272	1874	2282000	16102	8185	3	0	2
293280	1678	16560624274000	16105	8186	1	0	0
293281	1874	2284000	16105	8186	2	0	2
293282	1874	2286000	16105	8186	3	0	2
293283	1874	2287000	16105	8186	4	0	2
293284	1874	2290000	16105	8186	5	0	2
293299	1678	16560624275000	16109	8187	0	0	0
293300	1874	2296000	16109	8187	1	0	2
293301	1874	2298000	16109	8187	2	0	2
293302	1678	16560624276000	16110	8188	0	0	0
293304	1874	2303000	16110	8188	2	0	2
293305	1678	16560624277000	16111	8189	0	0	0
293306	1874	2304000	16111	8189	1	0	2
293307	1874	2307000	16111	8189	2	0	2
293308	1874	2309000	16111	8189	3	0	2
293310	1678	16560624279000	16112	8190	1	0	0
293311	1678	16560624280000	16112	8190	2	0	0
293312	1678	16560624281000	16112	8190	3	0	0
293313	1874	2310000	16112	8190	4	0	2
293314	1874	2313000	16112	8190	5	0	2
293316	1874	2317000	16112	8190	7	0	2
293317	1874	2320000	16112	8190	8	0	2
293318	1874	2323000	16112	8190	9	0	2
293319	1874	2326000	16112	8190	10	0	2
293321	1874	2330000	16112	8190	12	0	2
293322	1678	16560624282000	16113	8191	0	0	0
293323	1874	2333000	16113	8191	1	0	2
293324	1874	2335000	16113	8191	2	0	2
293328	1678	16560624283000	16115	8192	0	0	0
293330	1874	2340000	16115	8192	2	0	2
293331	1678	16560624284000	16116	8193	0	0	0
293332	1874	2341000	16116	8193	1	0	2
293333	1874	2343000	16116	8193	2	0	2
293334	1874	2346000	16116	8193	3	0	2
293346	1678	16560624286000	16119	8194	1	0	0
293347	1874	2349000	16119	8194	2	0	2
293348	1874	2351000	16119	8194	3	0	2
293349	1874	2353000	16119	8194	4	0	2
293351	1678	16560624287000	16120	8195	0	0	0
293352	1874	2358000	16120	8195	1	0	2
293358	1678	16560624288000	16122	8196	0	0	\N
293359	1874	2364000	16122	8196	1	0	\N
293360	1874	2367000	16122	8196	2	0	\N
293364	1678	16560624290000	16124	8198	0	0	\N
293365	1678	16560624291000	16124	8198	1	0	\N
293366	1874	2373000	16124	8198	2	0	\N
293367	1874	2375000	16124	8198	3	0	\N
293368	1874	2377000	16124	8198	4	0	\N
293369	1874	2380000	16124	8198	5	0	\N
293370	1874	2383000	16124	8198	6	0	\N
293384	1678	16560624293000	16128	8200	0	0	\N
293385	1874	2390000	16128	8200	1	0	\N
293386	1874	2393000	16128	8200	2	0	\N
293387	2139	200000000	16129	8113	0	0	\N
293388	1821	527990000000	16129	8113	1	0	\N
293389	1950	8669851000000	16129	8113	2	0	\N
293390	1950	10169851000000	16129	8113	3	0	\N
293391	1874	1729000	16129	8113	4	0	\N
293392	1874	1730000	16129	8113	5	0	\N
293393	1874	1731000	16129	8113	6	0	\N
293394	1874	1732000	16129	8113	7	0	\N
293395	1874	1733000	16129	8113	8	0	\N
293396	1874	1734000	16129	8113	9	0	\N
293397	1874	1735000	16129	8113	10	0	\N
293398	1874	1736000	16129	8113	11	0	\N
293399	1874	1737000	16129	8113	12	0	\N
293400	1874	1738000	16129	8113	13	0	\N
293401	1874	1739000	16129	8113	14	0	\N
293402	1874	1740000	16129	8113	15	0	\N
293403	1874	1741000	16129	8113	16	0	\N
293404	1874	1742000	16129	8113	17	0	\N
293405	1874	1743000	16129	8113	18	0	\N
293406	1874	1744000	16129	8113	19	0	\N
293407	1874	1745000	16129	8113	20	0	\N
293408	1874	1746000	16129	8113	21	0	\N
293409	1874	1747000	16129	8113	22	0	\N
293410	1874	1748000	16129	8113	23	0	\N
293411	1874	1749000	16129	8113	24	0	\N
293412	1874	1750000	16129	8113	25	0	\N
293413	1874	1751000	16129	8113	26	0	\N
293414	1874	1752000	16129	8113	27	0	\N
293415	1874	1753000	16129	8113	28	0	\N
293416	1874	1754000	16129	8113	29	0	\N
293417	1874	1755000	16129	8113	30	0	\N
293418	1874	1756000	16129	8113	31	0	\N
293419	1874	1757000	16129	8113	32	0	\N
293420	1874	1758000	16129	8113	33	0	\N
293421	1874	1759000	16129	8113	34	0	\N
293426	1678	17280636294000	16131	8201	0	0	\N
293427	1874	2396000	16131	8201	1	0	\N
293428	1874	2398000	16131	8201	2	0	\N
293429	1874	2399000	16131	8201	3	0	\N
293430	1678	17280636295000	16132	8202	0	0	\N
293431	1874	2402000	16132	8202	1	0	\N
293434	1678	17280636296000	16134	8203	0	0	\N
293435	1678	17280636297000	16134	8203	1	0	\N
293436	1874	2405000	16134	8203	2	0	\N
293437	1874	2407000	16134	8203	3	0	\N
293438	1874	2409000	16134	8203	4	0	\N
293439	1874	2412000	16134	8203	5	0	\N
293440	1874	2413000	16134	8203	6	0	\N
293441	1678	17280636296000	16135	8203	0	0	\N
293442	1678	17280636297000	16135	8203	1	0	\N
293443	1874	2405000	16135	8203	2	0	\N
293444	1874	2407000	16135	8203	3	0	\N
293445	1874	2409000	16135	8203	4	0	\N
293446	1874	2412000	16135	8203	5	0	\N
293447	1874	2413000	16135	8203	6	0	\N
293455	1678	17280636298000	16138	8204	0	0	\N
293456	1678	17280636299000	16138	8204	1	0	\N
293457	1874	2415000	16138	8204	2	0	\N
293458	1874	2417000	16138	8204	3	0	\N
293459	1874	2420000	16138	8204	4	0	\N
293460	1874	2423000	16138	8204	5	0	\N
293461	1678	17280636298000	16139	8204	0	0	\N
293462	1678	17280636299000	16139	8204	1	0	\N
293463	1874	2415000	16139	8204	2	0	\N
293464	1874	2417000	16139	8204	3	0	\N
293465	1874	2420000	16139	8204	4	0	\N
293466	1874	2423000	16139	8204	5	0	\N
293482	1678	17280636302000	16143	8206	0	0	\N
293483	1874	2434000	16143	8206	1	0	\N
293484	1874	2436000	16143	8206	2	0	\N
293488	1678	17280636303000	16145	8207	0	0	\N
293355	1678	16560624288000	16121	8196	0	0	0
293356	1874	2364000	16121	8196	1	0	2
293357	1874	2367000	16121	8196	2	0	2
293361	1678	16560624289000	16123	8197	0	0	0
293362	1874	2370000	16123	8197	1	0	2
293371	1678	16560624290000	16125	8198	0	0	0
293372	1678	16560624291000	16125	8198	1	0	0
293373	1874	2373000	16125	8198	2	0	2
293374	1874	2375000	16125	8198	3	0	2
293375	1874	2377000	16125	8198	4	0	2
293377	1874	2383000	16125	8198	6	0	2
293378	1678	16560624292000	16126	8199	0	0	0
293379	1874	2385000	16126	8199	1	0	2
293380	1874	2388000	16126	8199	2	0	2
293382	1874	2390000	16127	8200	1	0	2
293383	1874	2393000	16127	8200	2	0	2
293422	1678	17280636294000	16130	8201	0	0	0
293423	1874	2396000	16130	8201	1	0	2
293424	1874	2398000	16130	8201	2	0	2
293432	1678	17280636295000	16133	8202	0	0	0
293433	1874	2402000	16133	8202	1	0	2
293448	1678	17280636296000	16136	8203	0	0	0
293449	1678	17280636297000	16136	8203	1	0	0
293450	1874	2405000	16136	8203	2	0	2
293452	1874	2409000	16136	8203	4	0	2
293453	1874	2412000	16136	8203	5	0	2
293454	1874	2413000	16136	8203	6	0	2
293467	1678	17280636298000	16140	8204	0	0	0
293469	1874	2415000	16140	8204	2	0	2
293470	1874	2417000	16140	8204	3	0	2
293471	1874	2420000	16140	8204	4	0	2
293472	1874	2423000	16140	8204	5	0	2
293473	1678	17280636300000	16141	8205	0	0	0
293475	1874	2425000	16141	8205	2	0	2
293476	1874	2427000	16141	8205	3	0	2
293477	1874	2428000	16141	8205	4	0	2
293478	1874	2431000	16141	8205	5	0	2
293479	1678	17280636302000	16142	8206	0	0	0
293481	1874	2436000	16142	8206	2	0	2
293485	1678	17280636303000	16144	8207	0	0	0
293486	1874	2438000	16144	8207	1	0	2
293487	1874	2441000	16144	8207	2	0	2
293489	1874	2438000	16145	8207	1	0	\N
293490	1874	2441000	16145	8207	2	0	\N
293491	1678	17280636304000	16146	8208	0	0	\N
293492	1678	17280636305000	16146	8208	1	0	\N
293493	1874	2443000	16146	8208	2	0	\N
293494	1874	2444000	16146	8208	3	0	\N
293495	1874	2447000	16146	8208	4	0	\N
293496	1874	2450000	16146	8208	5	0	\N
293503	1678	17280636306000	16148	8209	0	0	\N
293504	1874	2453000	16148	8209	1	0	\N
293505	1874	2455000	16148	8209	2	0	\N
293513	1678	17280636307000	16151	8210	0	0	\N
293514	1874	2456000	16151	8210	1	0	\N
293515	1874	2458000	16151	8210	2	0	\N
293516	1874	2461000	16151	8210	3	0	\N
293520	1678	17280636308000	16153	8211	0	0	\N
293521	1874	2464000	16153	8211	1	0	\N
293522	1874	2466000	16153	8211	2	0	\N
293523	1678	17280636300000	16154	8205	0	0	\N
293524	1678	17280636301000	16154	8205	1	0	\N
293525	1678	17280636302000	16154	8205	2	0	\N
293526	1678	17280636303000	16154	8205	3	0	\N
293527	1678	17280636304000	16154	8205	4	0	\N
293528	1678	17280636305000	16154	8205	5	0	\N
293529	1678	17280636306000	16154	8205	6	0	\N
293530	1678	17280636307000	16154	8205	7	0	\N
293531	1678	17280636308000	16154	8205	8	0	\N
293532	1874	2425000	16154	8205	9	0	\N
293533	1874	2427000	16154	8205	10	0	\N
293534	1874	2429000	16154	8205	11	0	\N
293535	1874	2431000	16154	8205	12	0	\N
293536	1874	2433000	16154	8205	13	0	\N
293537	1874	2435000	16154	8205	14	0	\N
293538	1874	2437000	16154	8205	15	0	\N
293539	1874	2439000	16154	8205	16	0	\N
293540	1874	2440000	16154	8205	17	0	\N
293541	1874	2441000	16154	8205	18	0	\N
293542	1874	2442000	16154	8205	19	0	\N
293543	1874	2445000	16154	8205	20	0	\N
293544	1874	2448000	16154	8205	21	0	\N
293545	1874	2451000	16154	8205	22	0	\N
293546	1874	2454000	16154	8205	23	0	\N
293547	1874	2457000	16154	8205	24	0	\N
293548	1874	2460000	16154	8205	25	0	\N
293549	1874	2463000	16154	8205	26	0	\N
293550	1874	2466000	16154	8205	27	0	\N
293554	1678	17280636309000	16156	8212	0	0	\N
293555	1874	2468000	16156	8212	1	0	\N
293556	1874	2471000	16156	8212	2	0	\N
293557	1678	17280636310000	16157	8213	0	0	\N
293558	1874	2474000	16157	8213	1	0	\N
293559	1874	2476000	16157	8213	2	0	\N
293560	1678	17280636310000	16158	8213	0	0	\N
293561	1874	2474000	16158	8213	1	0	\N
293562	1874	2476000	16158	8213	2	0	\N
293563	1678	17280636310000	16159	8213	0	0	\N
293564	1874	2474000	16159	8213	1	0	\N
293565	1874	2476000	16159	8213	2	0	\N
293566	1678	17280636310000	16160	8213	0	0	\N
293567	1874	2474000	16160	8213	1	0	\N
293568	1874	2476000	16160	8213	2	0	\N
293592	1678	17280636316000	16168	8219	0	0	\N
293593	1874	2505000	16168	8219	1	0	\N
293594	1874	2508000	16168	8219	2	0	\N
293595	1678	17280636316000	16169	8219	0	0	\N
293596	1874	2505000	16169	8219	1	0	\N
293597	1874	2508000	16169	8219	2	0	\N
293598	1678	17280636317000	16170	8220	0	0	\N
293599	1874	2511000	16170	8220	1	0	\N
293600	1874	2512000	16170	8220	2	0	\N
293601	1874	2514000	16170	8220	3	0	\N
293606	1678	17280636317000	16172	8220	0	0	\N
293607	1874	2511000	16172	8220	1	0	\N
293608	1874	2512000	16172	8220	2	0	\N
293609	1874	2514000	16172	8220	3	0	\N
293610	1678	17280636317000	16173	8220	0	0	\N
293611	1874	2511000	16173	8220	1	0	\N
293612	1874	2512000	16173	8220	2	0	\N
293613	1874	2514000	16173	8220	3	0	\N
293616	1678	16560624271000	16175	8141	0	0	\N
293617	1678	16560624272000	16175	8141	1	0	\N
293618	1678	16560624273000	16175	8141	2	0	\N
293619	1678	16560624274000	16175	8141	3	0	\N
293620	1678	16560624275000	16175	8141	4	0	\N
293621	1678	16560624276000	16175	8141	5	0	\N
293622	1678	16560624277000	16175	8141	6	0	\N
293623	1678	16560624278000	16175	8141	7	0	\N
293624	1678	16560624279000	16175	8141	8	0	\N
293499	1874	2443000	16147	8208	2	0	2
293500	1874	2444000	16147	8208	3	0	2
293501	1874	2447000	16147	8208	4	0	2
293502	1874	2450000	16147	8208	5	0	2
293506	1678	17280636306000	16149	8209	0	0	0
293508	1874	2455000	16149	8209	2	0	2
293509	1678	17280636307000	16150	8210	0	0	0
293510	1874	2456000	16150	8210	1	0	2
293511	1874	2458000	16150	8210	2	0	2
293512	1874	2461000	16150	8210	3	0	2
293518	1874	2464000	16152	8211	1	0	2
293519	1874	2466000	16152	8211	2	0	2
293551	1678	17280636309000	16155	8212	0	0	0
293552	1874	2468000	16155	8212	1	0	2
293569	1678	17280636310000	16161	8213	0	0	0
293570	1874	2474000	16161	8213	1	0	2
293571	1874	2476000	16161	8213	2	0	2
293572	1678	17280636311000	16162	8214	0	0	0
293573	1874	2477000	16162	8214	1	0	2
293575	1874	2482000	16162	8214	3	0	2
293576	1678	17280636312000	16163	8215	0	0	0
293577	1874	2484000	16163	8215	1	0	2
293578	1874	2487000	16163	8215	2	0	2
293579	1678	17280636313000	16164	8216	0	0	0
293581	1874	2492000	16164	8216	2	0	2
293582	1678	17280636314000	16165	8217	0	0	0
293583	1874	2493000	16165	8217	1	0	2
293584	1874	2495000	16165	8217	2	0	2
293586	1678	17280636315000	16166	8218	0	0	0
293587	1874	2500000	16166	8218	1	0	2
293588	1874	2503000	16166	8218	2	0	2
293589	1678	17280636316000	16167	8219	0	0	0
293590	1874	2505000	16167	8219	1	0	2
293602	1678	17280636317000	16171	8220	0	0	0
293603	1874	2511000	16171	8220	1	0	2
293604	1874	2512000	16171	8220	2	0	2
293605	1874	2514000	16171	8220	3	0	2
293614	1678	17280636318000	16174	8221	0	0	0
293625	1678	16560624280000	16175	8141	9	0	\N
293626	1678	16560624281000	16175	8141	10	0	\N
293627	1678	16560624282000	16175	8141	11	0	\N
293628	1678	16560624283000	16175	8141	12	0	\N
293629	1678	16560624284000	16175	8141	13	0	\N
293630	1678	16560624285000	16175	8141	14	0	\N
293631	1678	16560624286000	16175	8141	15	0	\N
293632	1678	16560624287000	16175	8141	16	0	\N
293633	1678	16560624288000	16175	8141	17	0	\N
293634	1678	16560624289000	16175	8141	18	0	\N
293635	1678	16560624290000	16175	8141	19	0	\N
293636	1678	16560624291000	16175	8141	20	0	\N
293637	1678	16560624292000	16175	8141	21	0	\N
293638	1678	16560624293000	16175	8141	22	0	\N
293639	1678	16560624294000	16175	8141	23	0	\N
293640	1678	16560624295000	16175	8141	24	0	\N
293641	1678	16560624296000	16175	8141	25	0	\N
293642	1678	16560624297000	16175	8141	26	0	\N
293643	1678	16560624298000	16175	8141	27	0	\N
293644	1678	16560624299000	16175	8141	28	0	\N
293645	1678	16560624300000	16175	8141	29	0	\N
293646	1678	16560624301000	16175	8141	30	0	\N
293647	1678	16560624302000	16175	8141	31	0	\N
293648	1678	16560624303000	16175	8141	32	0	\N
293649	1678	16560624304000	16175	8141	33	0	\N
293650	1678	16560624305000	16175	8141	34	0	\N
293651	1678	16560624306000	16175	8141	35	0	\N
293652	1678	16560624307000	16175	8141	36	0	\N
293653	1678	16560624308000	16175	8141	37	0	\N
293654	1678	16560624309000	16175	8141	38	0	\N
293655	1678	16560624310000	16175	8141	39	0	\N
293656	1678	16560624311000	16175	8141	40	0	\N
293657	1678	16560624312000	16175	8141	41	0	\N
293658	1678	16560624313000	16175	8141	42	0	\N
293659	1678	16560624314000	16175	8141	43	0	\N
293660	1678	16560624315000	16175	8141	44	0	\N
293661	1678	16560624316000	16175	8141	45	0	\N
293662	1678	16560624317000	16175	8141	46	0	\N
293663	1874	2048000	16175	8141	47	0	\N
293664	1874	2049000	16175	8141	48	0	\N
293665	1874	2050000	16175	8141	49	0	\N
293666	1874	2051000	16175	8141	50	0	\N
293667	1874	2052000	16175	8141	51	0	\N
293668	1874	2055000	16175	8141	52	0	\N
293669	1874	2058000	16175	8141	53	0	\N
293670	1874	2061000	16175	8141	54	0	\N
293671	1874	2064000	16175	8141	55	0	\N
293672	1874	2065000	16175	8141	56	0	\N
293673	1874	2067000	16175	8141	58	0	\N
293674	1874	2069000	16175	8141	59	0	\N
293675	1874	2071000	16175	8141	60	0	\N
293676	1874	2073000	16175	8141	61	0	\N
293677	1874	2075000	16175	8141	62	0	\N
293678	1874	2077000	16175	8141	63	0	\N
293679	1874	2079000	16175	8141	64	0	\N
293680	1874	2081000	16175	8141	65	0	\N
293681	1874	2083000	16175	8141	66	0	\N
293682	1874	2085000	16175	8141	67	0	\N
293683	1874	2087000	16175	8141	68	0	\N
293684	1874	2089000	16175	8141	69	0	\N
293685	1874	2091000	16175	8141	70	0	\N
293686	1874	2093000	16175	8141	71	0	\N
293687	1874	2095000	16175	8141	72	0	\N
293688	1874	2097000	16175	8141	73	0	\N
293689	1874	2099000	16175	8141	74	0	\N
293690	1874	2101000	16175	8141	75	0	\N
293691	1874	2103000	16175	8141	76	0	\N
293692	1874	2105000	16175	8141	77	0	\N
293693	1874	2107000	16175	8141	78	0	\N
293694	1874	2109000	16175	8141	79	0	\N
293695	1874	2111000	16175	8141	80	0	\N
293696	1874	2113000	16175	8141	81	0	\N
293697	1874	2115000	16175	8141	82	0	\N
293698	1874	2117000	16175	8141	83	0	\N
293699	1874	2119000	16175	8141	84	0	\N
293700	1874	2121000	16175	8141	85	0	\N
293701	1874	2123000	16175	8141	86	0	\N
293702	1874	2125000	16175	8141	87	0	\N
293703	1874	2127000	16175	8141	88	0	\N
293704	1874	2129000	16175	8141	89	0	\N
293705	1874	2131000	16175	8141	90	0	\N
293706	1874	2133000	16175	8141	91	0	\N
293707	1874	2135000	16175	8141	92	0	\N
293708	1874	2137000	16175	8141	93	0	\N
293709	1874	2139000	16175	8141	94	0	\N
293710	1874	2142000	16175	8141	95	0	\N
293711	1874	2145000	16175	8141	96	0	\N
293712	1874	2148000	16175	8141	97	0	\N
293713	1874	2151000	16175	8141	98	0	\N
293714	1874	2154000	16175	8141	99	0	\N
293715	1874	2157000	16175	8141	100	0	\N
293716	1874	2160000	16175	8141	101	0	\N
293717	1874	2163000	16175	8141	102	0	\N
293718	1874	2166000	16175	8141	103	0	\N
293719	1874	2169000	16175	8141	104	0	\N
293720	1874	2172000	16175	8141	105	0	\N
293721	1874	2175000	16175	8141	106	0	\N
293722	1874	2178000	16175	8141	107	0	\N
293723	1874	2181000	16175	8141	108	0	\N
293724	1874	2184000	16175	8141	109	0	\N
293725	1874	2187000	16175	8141	110	0	\N
293726	1874	2190000	16175	8141	111	0	\N
293727	1874	2193000	16175	8141	112	0	\N
293728	1874	2196000	16175	8141	113	0	\N
293729	1874	2199000	16175	8141	114	0	\N
293730	1874	2202000	16175	8141	115	0	\N
293731	1874	2205000	16175	8141	116	0	\N
293732	1874	2208000	16175	8141	117	0	\N
293733	1874	2211000	16175	8141	118	0	\N
293734	1874	2214000	16175	8141	119	0	\N
293735	1874	2217000	16175	8141	120	0	\N
293736	1874	2220000	16175	8141	121	0	\N
293737	1874	2223000	16175	8141	122	0	\N
293738	1874	2226000	16175	8141	123	0	\N
293739	1874	2229000	16175	8141	124	0	\N
293740	1874	2232000	16175	8141	125	0	\N
293747	1678	17280636320000	16178	8223	0	0	\N
293748	1874	2524000	16178	8223	1	0	\N
293749	1874	2527000	16178	8223	2	0	\N
293750	1678	17280636321000	16179	8224	0	0	\N
293751	1874	2529000	16179	8224	1	0	\N
293752	1874	2532000	16179	8224	2	0	\N
293753	1874	2533000	16179	8224	3	0	\N
293760	1678	17280636322000	16182	8226	0	0	\N
293743	1874	2522000	16176	8222	2	0	2
293744	1678	17280636320000	16177	8223	0	0	0
293745	1874	2524000	16177	8223	1	0	2
293746	1874	2527000	16177	8223	2	0	2
293754	1678	17280636321000	16180	8224	0	0	0
293756	1874	2532000	16180	8224	2	0	2
293757	1874	2533000	16180	8224	3	0	2
293758	1874	2536000	16181	8225	0	0	2
293759	1874	2538000	16181	8225	1	0	2
293761	1678	17280636323000	16182	8226	1	0	\N
293762	1678	17280636324000	16182	8226	2	0	\N
293763	1874	2539000	16182	8226	3	0	\N
293764	1874	2541000	16182	8226	5	0	\N
293765	1874	2543000	16182	8226	6	0	\N
293766	1874	2545000	16182	8226	7	0	\N
293767	1874	2548000	16182	8226	8	0	\N
293768	1874	2551000	16182	8226	9	0	\N
293769	1874	2554000	16182	8226	10	0	\N
293770	1678	17280636322000	16183	8226	0	0	\N
293771	1678	17280636323000	16183	8226	1	0	\N
293772	1678	17280636324000	16183	8226	2	0	\N
293773	1874	2539000	16183	8226	3	0	\N
293774	1874	2541000	16183	8226	5	0	\N
293775	1874	2543000	16183	8226	6	0	\N
293776	1874	2545000	16183	8226	7	0	\N
293777	1874	2548000	16183	8226	8	0	\N
293778	1874	2551000	16183	8226	9	0	\N
293779	1874	2554000	16183	8226	10	0	\N
293780	1678	17280636322000	16184	8226	0	0	\N
293781	1678	17280636323000	16184	8226	1	0	\N
293782	1678	17280636324000	16184	8226	2	0	\N
293783	1874	2539000	16184	8226	3	0	\N
293784	1874	2541000	16184	8226	5	0	\N
293785	1874	2543000	16184	8226	6	0	\N
293786	1874	2545000	16184	8226	7	0	\N
293787	1874	2548000	16184	8226	8	0	\N
293788	1874	2551000	16184	8226	9	0	\N
293789	1874	2554000	16184	8226	10	0	\N
293800	1678	17280636322000	16186	8226	0	0	\N
293801	1678	17280636323000	16186	8226	1	0	\N
293802	1678	17280636324000	16186	8226	2	0	\N
293803	1874	2539000	16186	8226	3	0	\N
293804	1874	2541000	16186	8226	5	0	\N
293805	1874	2543000	16186	8226	6	0	\N
293806	1874	2545000	16186	8226	7	0	\N
293807	1874	2548000	16186	8226	8	0	\N
293808	1874	2551000	16186	8226	9	0	\N
293809	1874	2554000	16186	8226	10	0	\N
293810	1678	17280636325000	16187	8227	0	0	\N
293811	2142	1000000	16187	8227	1	0	\N
293812	1874	2556000	16187	8227	2	0	\N
293813	1874	2559000	16187	8227	3	0	\N
293818	1678	17280636325000	16189	8227	0	0	\N
293819	2142	1000000	16189	8227	1	0	\N
293820	1874	2556000	16189	8227	2	0	\N
293821	1874	2559000	16189	8227	3	0	\N
293822	2142	1000000	16190	8224	1	0	\N
293847	1678	17280636333000	16195	8232	0	0	\N
293848	1874	2599000	16195	8232	1	0	\N
293849	1874	2600000	16195	8232	2	0	\N
293850	1874	2602000	16195	8232	3	0	\N
293855	1678	17280636334000	16197	8233	0	0	\N
293856	1684	16530435880623	16197	8233	1	0	\N
293857	1874	2605000	16197	8233	2	0	\N
293861	1678	17280636334000	16199	8233	0	0	\N
293862	1684	16530435880623	16199	8233	1	0	\N
293863	1874	2605000	16199	8233	2	0	\N
293864	1678	17280636334000	16200	8233	0	0	\N
293865	1684	16530435880623	16200	8233	1	0	\N
293866	1874	2605000	16200	8233	2	0	\N
293867	1678	17280636335000	16201	8234	0	0	\N
293868	1874	2608000	16201	8234	1	0	\N
293869	1874	2610000	16201	8234	2	0	\N
293872	1678	17280636335000	16203	8234	0	0	\N
293873	1874	2608000	16203	8234	1	0	\N
293874	1874	2610000	16203	8234	2	0	\N
293881	2142	2850002000000	16205	8235	0	0	\N
293882	1678	17280636335000	16205	8235	1	0	\N
293883	1678	17280636336000	16205	8235	2	0	\N
293884	1874	2611000	16205	8235	3	0	\N
293885	1874	2614000	16205	8235	4	0	\N
293886	1874	2616000	16205	8235	5	0	\N
293887	2142	2850002000000	16206	8235	0	0	\N
293888	1678	17280636335000	16206	8235	1	0	\N
293889	1678	17280636336000	16206	8235	2	0	\N
293890	1874	2611000	16206	8235	3	0	\N
293891	1874	2614000	16206	8235	4	0	\N
293892	1874	2616000	16206	8235	5	0	\N
293893	1678	17280636335000	16207	8235	0	0	\N
293894	1678	17280636336000	16207	8235	1	0	\N
293895	1874	2612000	16207	8235	2	0	\N
293792	1678	17280636324000	16185	8226	2	0	0
293793	1874	2539000	16185	8226	3	0	2
293794	1874	2541000	16185	8226	5	0	2
293795	1874	2543000	16185	8226	6	0	2
293796	1874	2545000	16185	8226	7	0	2
293798	1874	2551000	16185	8226	9	0	2
293799	1874	2554000	16185	8226	10	0	2
293814	1678	17280636325000	16188	8227	0	0	0
293815	2142	1000000	16188	8227	1	0	0
293816	1874	2556000	16188	8227	2	0	2
293823	1678	17280636326000	16191	8228	0	0	0
293824	1678	17280636327000	16191	8228	1	0	0
293825	1874	2560000	16191	8228	2	0	2
293826	1874	2562000	16191	8228	3	0	2
293828	1874	2567000	16191	8228	5	0	2
293829	1874	2570000	16191	8228	6	0	2
293830	1678	17280636328000	16192	8229	0	0	0
293831	1678	17280636329000	16192	8229	1	0	0
293832	2142	4000000	16192	8229	2	0	0
293834	1874	2575000	16192	8229	4	0	2
293835	1874	2577000	16192	8229	5	0	2
293836	1874	2580000	16192	8229	6	0	2
293837	1678	17280636330000	16193	8230	0	0	0
293838	1874	2582000	16193	8230	1	0	2
293840	1874	2586000	16193	8230	3	0	2
293841	1678	17280636331000	16194	8231	0	0	0
293842	1678	17280636332000	16194	8231	1	0	0
293843	1874	2589000	16194	8231	2	0	2
293845	1874	2594000	16194	8231	4	0	2
293846	1874	2596000	16194	8231	5	0	2
293851	1678	17280636333000	16196	8232	0	0	0
293852	1874	2599000	16196	8232	1	0	2
293853	1874	2600000	16196	8232	2	0	2
293858	1678	17280636334000	16198	8233	0	0	0
293859	1684	16530435880623	16198	8233	1	0	69
293860	1874	2605000	16198	8233	2	0	2
293870	1874	2608000	16202	8234	0	0	2
293871	1874	2610000	16202	8234	1	0	2
293876	1678	17280636335000	16204	8235	1	0	0
293877	1678	17280636336000	16204	8235	2	0	0
293878	1874	2611000	16204	8235	3	0	2
293879	1874	2614000	16204	8235	4	0	2
293896	1678	17280636337000	16208	8236	0	0	0
293910	2143	200000000	16210	8225	0	0	\N
293911	2144	200000000	16210	8225	1	0	\N
293912	2145	200000000	16210	8225	2	0	\N
293913	2146	200000000	16210	8225	3	0	\N
293914	2142	4000000	16210	8225	4	0	\N
293915	2142	2850004000000	16210	8225	5	0	\N
293916	967	504776675000000	16210	8225	6	0	\N
293917	1087	904515869720300	16210	8225	7	0	\N
293918	1207	610311145055850	16210	8225	8	0	\N
293919	1333	1700596942094750	16210	8225	9	0	\N
293927	1678	17280636341000	16212	8239	0	0	\N
293928	1678	17280636342000	16212	8239	1	0	\N
293929	1874	2640000	16212	8239	2	0	\N
293930	1874	2642000	16212	8239	3	0	\N
293931	1874	2644000	16212	8239	4	0	\N
293938	1678	17280636341000	16214	8239	0	0	\N
293939	1678	17280636342000	16214	8239	1	0	\N
293940	1678	17280636343000	16214	8239	2	0	\N
293941	1874	2640000	16214	8239	3	0	\N
293942	1874	2643000	16214	8239	4	0	\N
293943	1874	2645000	16214	8239	5	0	\N
293944	1874	2647000	16214	8239	6	0	\N
293954	1678	17280636345000	16217	8241	0	0	\N
293955	1874	2658000	16217	8241	1	0	\N
293956	1874	2660000	16217	8241	2	0	\N
293961	1678	17280636346000	16219	8242	0	0	\N
293962	1874	2661000	16219	8242	1	0	\N
293963	1874	2664000	16219	8242	2	0	\N
293964	1874	2666000	16219	8242	3	0	\N
293973	1678	17280636349000	16223	8245	0	0	\N
293974	1678	17280636350000	16223	8245	1	0	\N
293975	1874	2675000	16223	8245	2	0	\N
293976	1874	2677000	16223	8245	4	0	\N
293977	1874	2679000	16223	8245	5	0	\N
293978	1874	2682000	16223	8245	6	0	\N
293979	1874	2685000	16223	8245	7	0	\N
293998	1678	17280636353000	16227	8248	0	0	\N
293999	1678	17280636354000	16227	8248	1	0	\N
294000	1874	2698000	16227	8248	2	0	\N
294001	1874	2700000	16227	8248	3	0	\N
294002	1874	2702000	16227	8248	4	0	\N
294003	1874	2705000	16227	8248	5	0	\N
294004	1874	2706000	16227	8248	6	0	\N
294005	1678	17280636352000	16228	8247	0	0	\N
294006	1678	17280636353000	16228	8247	1	0	\N
294007	1678	17280636354000	16228	8247	2	0	\N
294008	1874	2692000	16228	8247	3	0	\N
294009	1874	2694000	16228	8247	4	0	\N
294010	1874	2696000	16228	8247	5	0	\N
294011	1874	2697000	16228	8247	6	0	\N
294012	1874	2700000	16228	8247	7	0	\N
294013	1874	2703000	16228	8247	8	0	\N
294014	1874	2706000	16228	8247	9	0	\N
294024	1678	17280636358000	16232	8252	0	0	\N
294025	1874	2722000	16232	8252	1	0	\N
294026	1874	2725000	16232	8252	2	0	\N
294030	1678	17280636358000	16234	8252	0	0	\N
294031	1874	2722000	16234	8252	1	0	\N
294032	1874	2725000	16234	8252	2	0	\N
293899	2145	200000000	16208	8236	3	0	0
293900	2146	200000000	16208	8236	4	0	0
293901	1874	2619000	16208	8236	5	0	2
293902	1874	2621000	16208	8236	6	0	2
293903	967	504776675000000	16208	8236	7	0	0
293905	1207	610311145055850	16208	8236	9	0	0
293906	1333	1700596942094750	16208	8236	10	0	0
293907	1678	17280636338000	16209	8237	0	0	0
293908	1874	2623000	16209	8237	1	0	2
293909	1874	2626000	16209	8237	2	0	2
293921	1678	17280636340000	16211	8238	1	0	0
293922	1874	2627000	16211	8238	2	0	2
293923	1874	2630000	16211	8238	3	0	2
293924	1874	2633000	16211	8238	4	0	2
293926	1874	2637000	16211	8238	6	0	2
293932	1678	17280636341000	16213	8239	0	0	0
293933	1678	17280636342000	16213	8239	1	0	0
293934	1874	2640000	16213	8239	2	0	2
293935	1874	2643000	16213	8239	3	0	2
293937	1874	2647000	16213	8239	5	0	2
293945	1678	17280636343000	16215	8240	0	0	0
293946	1678	17280636344000	16215	8240	1	0	0
293947	1874	2648000	16215	8240	2	0	2
293948	1874	2651000	16215	8240	3	0	2
293950	1874	2655000	16215	8240	5	0	2
293951	1678	17280636345000	16216	8241	0	0	0
293952	1874	2658000	16216	8241	1	0	2
293953	1874	2660000	16216	8241	2	0	2
293958	1874	2661000	16218	8242	1	0	2
293959	1874	2664000	16218	8242	2	0	2
293960	1874	2666000	16218	8242	3	0	2
293965	1678	17280636347000	16220	8243	0	0	0
293966	1874	2669000	16220	8243	1	0	2
293968	1678	17280636348000	16221	8244	0	0	0
293969	1874	2674000	16221	8244	1	0	2
293970	1678	17280636349000	16222	8245	0	0	0
293971	1874	2676000	16222	8245	1	0	2
293972	1874	2679000	16222	8245	2	0	2
293981	1678	17280636351000	16224	8246	1	0	0
293982	1874	2680000	16224	8246	2	0	2
293983	1874	2683000	16224	8246	3	0	2
293984	1874	2686000	16224	8246	4	0	2
293986	1874	2688000	16224	8246	6	0	2
293987	1874	2690000	16224	8246	7	0	2
293988	1678	17280636352000	16225	8247	0	0	0
293989	1874	2692000	16225	8247	1	0	2
293990	1874	2695000	16225	8247	2	0	2
293992	1678	17280636354000	16226	8248	1	0	0
293993	1874	2698000	16226	8248	2	0	2
293994	1874	2700000	16226	8248	3	0	2
293995	1874	2702000	16226	8248	4	0	2
293996	1874	2705000	16226	8248	5	0	2
294015	1678	17280636355000	16229	8249	0	0	0
294016	1874	2709000	16229	8249	1	0	2
294017	1874	2711000	16229	8249	2	0	2
294018	1678	17280636356000	16230	8250	0	0	0
294020	1874	2715000	16230	8250	2	0	2
294021	1874	2717000	16230	8250	3	0	2
294022	1678	17280636357000	16231	8251	0	0	0
294023	1874	2720000	16231	8251	1	0	2
294027	1678	17280636358000	16233	8252	0	0	0
294029	1874	2725000	16233	8252	2	0	2
294033	2143	200000000	16235	8210	0	0	\N
294034	2144	200000000	16235	8210	1	0	\N
294035	2145	200000000	16235	8210	2	0	\N
294036	2146	200000000	16235	8210	3	0	\N
294037	1303	1702889985351650	16235	8210	4	0	\N
294038	2142	1000000	16235	8210	6	0	\N
294039	2142	4000000	16235	8210	7	0	\N
294040	2142	2850004000000	16235	8210	8	0	\N
294041	967	504776675000000	16235	8210	9	0	\N
294042	1087	904515869720300	16235	8210	10	0	\N
294043	1207	610311145055850	16235	8210	11	0	\N
294044	1333	1700596942094750	16235	8210	12	0	\N
294045	2147	554000000000	16235	8210	13	0	\N
294050	1678	17280636360000	16237	8254	0	0	\N
294051	937	505422913800000	16237	8254	1	0	\N
294052	1874	2732000	16237	8254	2	0	\N
294053	1874	2735000	16237	8254	3	0	\N
294054	1874	2736000	16237	8254	4	0	\N
294060	1678	17280636326000	16239	8228	0	0	\N
294061	2143	200000000	16239	8228	1	0	\N
294062	2144	200000000	16239	8228	2	0	\N
294063	1678	17280636327000	16239	8228	3	0	\N
294064	1678	17280636328000	16239	8228	4	0	\N
294065	1678	17280636329000	16239	8228	5	0	\N
294066	1678	17280636330000	16239	8228	6	0	\N
294067	2145	200000000	16239	8228	7	0	\N
294068	2146	200000000	16239	8228	8	0	\N
294069	1678	17280636331000	16239	8228	9	0	\N
294070	1678	17280636332000	16239	8228	10	0	\N
294071	1678	17280636333000	16239	8228	11	0	\N
294072	1678	17280636334000	16239	8228	12	0	\N
294073	1678	17280636335000	16239	8228	13	0	\N
294074	1678	17280636336000	16239	8228	14	0	\N
294075	1678	17280636337000	16239	8228	15	0	\N
294076	1678	17280636338000	16239	8228	16	0	\N
294077	1678	17280636339000	16239	8228	17	0	\N
294078	1678	17280636340000	16239	8228	18	0	\N
294079	1678	17280636341000	16239	8228	19	0	\N
294080	1678	17280636342000	16239	8228	20	0	\N
294081	1678	17280636343000	16239	8228	21	0	\N
294082	1678	17280636344000	16239	8228	22	0	\N
294083	1678	17280636345000	16239	8228	23	0	\N
294084	1678	17280636346000	16239	8228	24	0	\N
294085	1678	17280636347000	16239	8228	25	0	\N
294086	1678	17280636348000	16239	8228	26	0	\N
294087	1678	17280636349000	16239	8228	27	0	\N
294088	1678	17280636350000	16239	8228	28	0	\N
294089	1678	17280636351000	16239	8228	29	0	\N
294090	1678	17280636352000	16239	8228	30	0	\N
294091	1678	17280636353000	16239	8228	31	0	\N
294092	1678	17280636354000	16239	8228	32	0	\N
294093	1678	17280636355000	16239	8228	33	0	\N
294094	1678	17280636356000	16239	8228	34	0	\N
294095	1678	17280636357000	16239	8228	35	0	\N
294096	1678	17280636358000	16239	8228	36	0	\N
294097	1678	17280636359000	16239	8228	37	0	\N
294098	1678	17280636360000	16239	8228	38	0	\N
294099	1303	1702889985351650	16239	8228	39	0	\N
294100	937	505422913800000	16239	8228	40	0	\N
294101	2142	4000000	16239	8228	41	0	\N
294102	2142	2850004000000	16239	8228	42	0	\N
294103	1874	2560000	16239	8228	43	0	\N
294104	1874	2561000	16239	8228	44	0	\N
294105	1874	2562000	16239	8228	45	0	\N
294106	1874	2563000	16239	8228	46	0	\N
294107	1874	2564000	16239	8228	47	0	\N
294108	1874	2565000	16239	8228	48	0	\N
294109	1874	2566000	16239	8228	49	0	\N
294110	1874	2567000	16239	8228	50	0	\N
294111	967	504776675000000	16239	8228	51	0	\N
294112	1087	904515869720300	16239	8228	52	0	\N
294113	1207	610311145055850	16239	8228	53	0	\N
294114	1333	1700596942094750	16239	8228	54	0	\N
294115	2147	554000000000	16239	8228	55	0	\N
294116	1874	2568000	16239	8228	56	0	\N
294117	1874	2569000	16239	8228	57	0	\N
294118	1874	2571000	16239	8228	58	0	\N
294119	1874	2574000	16239	8228	59	0	\N
294120	1874	2575000	16239	8228	60	0	\N
294121	1678	17280636348000	16240	8244	0	0	\N
294122	1678	17280636349000	16240	8244	1	0	\N
294123	1678	17280636350000	16240	8244	2	0	\N
294124	1678	17280636351000	16240	8244	3	0	\N
294125	1678	17280636352000	16240	8244	4	0	\N
294126	1678	17280636353000	16240	8244	5	0	\N
294127	1678	17280636354000	16240	8244	6	0	\N
294128	1678	17280636355000	16240	8244	8	0	\N
294129	1678	17280636356000	16240	8244	9	0	\N
294130	1678	17280636357000	16240	8244	10	0	\N
294131	1678	17280636358000	16240	8244	11	0	\N
294132	1678	17280636359000	16240	8244	12	0	\N
294133	1678	17280636360000	16240	8244	13	0	\N
294134	1303	1702889985351650	16240	8244	14	0	\N
294135	937	505422913800000	16240	8244	15	0	\N
294136	1874	2674000	16240	8244	16	0	\N
294137	1874	2675000	16240	8244	17	0	\N
294138	2147	554000000000	16240	8244	18	0	\N
294139	1874	2677000	16240	8244	19	0	\N
294140	1874	2679000	16240	8244	20	0	\N
294141	1874	2681000	16240	8244	21	0	\N
294142	1874	2683000	16240	8244	22	0	\N
294143	1874	2685000	16240	8244	23	0	\N
294144	1874	2687000	16240	8244	24	0	\N
294145	1874	2689000	16240	8244	25	0	\N
294146	1874	2690000	16240	8244	26	0	\N
294147	1874	2691000	16240	8244	27	0	\N
294148	1874	2694000	16240	8244	28	0	\N
294152	1678	17280636361000	16242	8255	0	0	\N
294153	1874	2739000	16242	8255	1	0	\N
294154	1874	2741000	16242	8255	2	0	\N
294158	1678	17280636363000	16244	8257	0	0	\N
294159	1874	2749000	16244	8257	1	0	\N
294160	1874	2750000	16244	8257	2	0	\N
294161	1874	2752000	16244	8257	3	0	\N
294166	1678	17280636364000	16246	8258	0	0	\N
294167	1874	2755000	16246	8258	1	0	\N
294048	1874	2727000	16236	8253	2	0	2
294049	1874	2730000	16236	8253	3	0	2
294055	1678	17280636360000	16238	8254	0	0	0
294056	937	505422913800000	16238	8254	1	0	0
294057	1874	2732000	16238	8254	2	0	2
294059	1874	2736000	16238	8254	4	0	2
294149	1678	17280636361000	16241	8255	0	0	0
294150	1874	2739000	16241	8255	1	0	2
294151	1874	2741000	16241	8255	2	0	2
294155	1678	17280636362000	16243	8256	0	0	0
294157	1874	2746000	16243	8256	2	0	2
294162	1678	17280636363000	16245	8257	0	0	0
294163	1874	2749000	16245	8257	1	0	2
294164	1874	2750000	16245	8257	2	0	2
294168	1678	17280636364000	16247	8258	0	0	0
294170	1678	17280636364000	16248	8258	0	0	\N
294171	1874	2755000	16248	8258	1	0	\N
294172	1678	17280636364000	16249	8258	0	0	\N
294173	1874	2755000	16249	8258	1	0	\N
294174	1678	17280636364000	16250	8258	0	0	\N
294175	1874	2755000	16250	8258	1	0	\N
294176	1678	17280636364000	16251	8258	0	0	\N
294177	1874	2755000	16251	8258	1	0	\N
294191	1678	17280636368000	16256	8262	0	0	\N
294192	1874	2774000	16256	8262	1	0	\N
294193	1874	2776000	16256	8262	2	0	\N
294194	1678	17280636368000	16257	8262	0	0	\N
294195	1874	2774000	16257	8262	1	0	\N
294196	1874	2776000	16257	8262	2	0	\N
294197	2143	200000000	16258	8159	0	0	\N
294198	1678	16560624234000	16258	8159	1	0	\N
294199	2144	200000000	16258	8159	2	0	\N
294200	1678	16560624235000	16258	8159	3	0	\N
294201	1678	16560624236000	16258	8159	4	0	\N
294202	1678	16560624237000	16258	8159	5	0	\N
294203	1678	16560624238000	16258	8159	6	0	\N
294204	2145	200000000	16258	8159	7	0	\N
294205	2146	200000000	16258	8159	8	0	\N
294206	1678	16560624239000	16258	8159	9	0	\N
294207	1678	16560624240000	16258	8159	10	0	\N
294208	1678	16560624241000	16258	8159	11	0	\N
294209	1678	16560624242000	16258	8159	12	0	\N
294210	1678	16560624243000	16258	8159	13	0	\N
294211	1678	16560624244000	16258	8159	14	0	\N
294212	1678	16560624245000	16258	8159	15	0	\N
294213	1678	16560624246000	16258	8159	16	0	\N
294214	1678	16560624247000	16258	8159	17	0	\N
294215	1678	16560624248000	16258	8159	18	0	\N
294216	1678	16560624249000	16258	8159	19	0	\N
294217	1678	16560624250000	16258	8159	20	0	\N
294218	1678	16560624251000	16258	8159	21	0	\N
294219	1678	16560624252000	16258	8159	22	0	\N
294220	1678	16560624253000	16258	8159	23	0	\N
294221	1678	16560624254000	16258	8159	24	0	\N
294222	1678	16560624255000	16258	8159	25	0	\N
294223	1678	16560624256000	16258	8159	26	0	\N
294224	1678	16560624257000	16258	8159	27	0	\N
294225	1678	16560624258000	16258	8159	28	0	\N
294226	1678	16560624259000	16258	8159	29	0	\N
294227	1678	16560624260000	16258	8159	30	0	\N
294228	1678	16560624261000	16258	8159	31	0	\N
294229	1678	16560624262000	16258	8159	32	0	\N
294230	1678	16560624263000	16258	8159	33	0	\N
294231	1678	16560624264000	16258	8159	34	0	\N
294232	1678	16560624265000	16258	8159	35	0	\N
294233	1678	16560624266000	16258	8159	36	0	\N
294234	1678	16560624267000	16258	8159	37	0	\N
294235	1678	16560624268000	16258	8159	38	0	\N
294236	1678	16560624269000	16258	8159	39	0	\N
294237	1678	16560624270000	16258	8159	40	0	\N
294238	1678	16560624271000	16258	8159	41	0	\N
294239	1678	16560624272000	16258	8159	42	0	\N
294240	1678	16560624273000	16258	8159	43	0	\N
294241	1678	16560624274000	16258	8159	44	0	\N
294242	1678	16560624275000	16258	8159	45	0	\N
294243	1678	16560624276000	16258	8159	46	0	\N
294244	1678	16560624277000	16258	8159	47	0	\N
294245	1678	16560624278000	16258	8159	48	0	\N
294246	1678	16560624279000	16258	8159	49	0	\N
294247	1678	16560624280000	16258	8159	50	0	\N
294248	1678	16560624281000	16258	8159	51	0	\N
294249	1678	16560624282000	16258	8159	52	0	\N
294250	1678	16560624283000	16258	8159	53	0	\N
294251	1678	16560624284000	16258	8159	55	0	\N
294252	1678	16560624285000	16258	8159	56	0	\N
294253	1678	16560624286000	16258	8159	57	0	\N
294254	1678	16560624287000	16258	8159	58	0	\N
294255	1678	16560624288000	16258	8159	59	0	\N
294256	1678	16560624289000	16258	8159	60	0	\N
294257	1678	16560624290000	16258	8159	61	0	\N
294258	1678	16560624291000	16258	8159	62	0	\N
294259	1678	16560624292000	16258	8159	63	0	\N
294260	1678	16560624293000	16258	8159	64	0	\N
294261	1678	16560624294000	16258	8159	65	0	\N
294262	1678	16560624295000	16258	8159	66	0	\N
294263	1678	16560624296000	16258	8159	67	0	\N
294264	1678	16560624297000	16258	8159	68	0	\N
294265	1678	16560624298000	16258	8159	69	0	\N
294266	1678	16560624299000	16258	8159	70	0	\N
294267	1678	16560624300000	16258	8159	71	0	\N
294268	1678	16560624301000	16258	8159	72	0	\N
294269	1678	16560624302000	16258	8159	73	0	\N
294270	1678	16560624303000	16258	8159	74	0	\N
294271	1678	16560624304000	16258	8159	75	0	\N
294272	1678	16560624305000	16258	8159	76	0	\N
294273	1678	16560624306000	16258	8159	77	0	\N
294274	1678	16560624307000	16258	8159	78	0	\N
294275	1678	16560624308000	16258	8159	79	0	\N
294276	1678	16560624309000	16258	8159	80	0	\N
294277	1678	16560624310000	16258	8159	81	0	\N
294278	1678	16560624311000	16258	8159	82	0	\N
294279	1678	16560624312000	16258	8159	83	0	\N
294280	1678	16560624313000	16258	8159	84	0	\N
294281	1678	16560624314000	16258	8159	85	0	\N
294282	1678	16560624315000	16258	8159	86	0	\N
294283	1678	16560624316000	16258	8159	87	0	\N
294284	1678	16560624317000	16258	8159	88	0	\N
294285	1678	16560624318000	16258	8159	89	0	\N
294286	1678	16560624319000	16258	8159	90	0	\N
294287	1678	16560624320000	16258	8159	91	0	\N
294288	1678	16560624321000	16258	8159	92	0	\N
294289	1678	16560624322000	16258	8159	93	0	\N
294290	1678	16560624323000	16258	8159	94	0	\N
294291	1678	16560624324000	16258	8159	95	0	\N
294292	1678	16560624325000	16258	8159	96	0	\N
294293	1678	16560624326000	16258	8159	97	0	\N
294294	1678	16560624327000	16258	8159	98	0	\N
294295	1678	16560624328000	16258	8159	99	0	\N
294296	1678	16560624329000	16258	8159	100	0	\N
294297	1678	16560624330000	16258	8159	101	0	\N
294298	1678	16560624331000	16258	8159	102	0	\N
294299	1678	16560624332000	16258	8159	103	0	\N
294300	1678	16560624333000	16258	8159	104	0	\N
294301	1678	16560624334000	16258	8159	105	0	\N
294302	1678	16560624335000	16258	8159	106	0	\N
294303	1678	16560624336000	16258	8159	107	0	\N
294304	1678	16560624337000	16258	8159	108	0	\N
294179	1874	2758000	16252	8259	1	0	2
294180	1874	2760000	16252	8259	2	0	2
294181	1678	17280636366000	16253	8260	0	0	0
294182	1874	2763000	16253	8260	1	0	2
294183	1874	2764000	16253	8260	2	0	2
294185	1678	17280636367000	16254	8261	0	0	0
294186	1874	2768000	16254	8261	1	0	2
294187	1874	2771000	16254	8261	2	0	2
294188	1678	17280636368000	16255	8262	0	0	0
294189	1874	2774000	16255	8262	1	0	2
294305	1678	16560624338000	16258	8159	109	0	\N
294306	1678	16560624339000	16258	8159	110	0	\N
294307	1678	16560624340000	16258	8159	111	0	\N
294308	1678	16560624341000	16258	8159	112	0	\N
294309	1678	16560624342000	16258	8159	113	0	\N
294310	1678	16560624343000	16258	8159	114	0	\N
294311	1678	16560624344000	16258	8159	115	0	\N
294312	1678	16560624345000	16258	8159	116	0	\N
294313	1678	16560624346000	16258	8159	117	0	\N
294314	1678	16560624347000	16258	8159	118	0	\N
294315	1678	16560624348000	16258	8159	119	0	\N
294316	1678	16560624349000	16258	8159	120	0	\N
294317	1678	16560624350000	16258	8159	121	0	\N
294318	1678	16560624351000	16258	8159	122	0	\N
294319	1678	16560624352000	16258	8159	123	0	\N
294320	1678	16560624353000	16258	8159	124	0	\N
294321	1678	16560624354000	16258	8159	125	0	\N
294322	1678	17280636369000	16259	8263	0	0	\N
294323	1874	2779000	16259	8263	1	0	\N
294324	1874	2781000	16259	8263	2	0	\N
294328	1678	17280636370000	16261	8264	0	0	\N
294329	1678	17280636371000	16261	8264	1	0	\N
294330	1874	2784000	16261	8264	2	0	\N
294331	1874	2787000	16261	8264	3	0	\N
294332	1874	2788000	16261	8264	4	0	\N
294347	1678	17280636374000	16264	8266	0	0	\N
294348	1874	2805000	16264	8266	1	0	\N
294349	1874	2808000	16264	8266	2	0	\N
294375	1678	17280636382000	16271	8271	0	0	\N
294376	1678	17280636383000	16271	8271	1	0	\N
294377	1874	2844000	16271	8271	2	0	\N
294378	1874	2847000	16271	8271	4	0	\N
294379	1874	2850000	16271	8271	5	0	\N
294380	1874	2852000	16271	8271	6	0	\N
294381	1874	2854000	16271	8271	7	0	\N
294389	1678	17280636382000	16273	8271	0	0	\N
294390	1678	17280636383000	16273	8271	1	0	\N
294391	1874	2844000	16273	8271	2	0	\N
294392	1874	2847000	16273	8271	4	0	\N
294393	1874	2850000	16273	8271	5	0	\N
294394	1874	2852000	16273	8271	6	0	\N
294395	1874	2854000	16273	8271	7	0	\N
294402	1678	17280636386000	16276	8274	0	0	\N
294403	1874	2865000	16276	8274	1	0	\N
294404	1874	2868000	16276	8274	2	0	\N
294405	1874	2870000	16276	8274	3	0	\N
294410	1678	17280636386000	16278	8274	0	0	\N
294411	1874	2865000	16278	8274	1	0	\N
294412	1874	2868000	16278	8274	2	0	\N
294413	1874	2870000	16278	8274	3	0	\N
294414	1678	17280636386000	16279	8274	0	0	\N
294415	1874	2865000	16279	8274	1	0	\N
294416	1874	2868000	16279	8274	2	0	\N
294417	1874	2870000	16279	8274	3	0	\N
294418	1678	17280636386000	16280	8274	0	0	\N
294419	1874	2865000	16280	8274	1	0	\N
294420	1874	2868000	16280	8274	2	0	\N
294421	1874	2870000	16280	8274	3	0	\N
294422	1678	17280636387000	16281	8275	0	0	\N
294423	1874	2873000	16281	8275	1	0	\N
294424	1678	17280636387000	16282	8275	0	0	\N
294425	1874	2873000	16282	8275	1	0	\N
294426	1874	2875000	16282	8275	2	0	\N
294427	1678	17280636387000	16283	8275	0	0	\N
294428	1874	2873000	16283	8275	1	0	\N
294429	1874	2875000	16283	8275	2	0	\N
294430	1678	17280636387000	16284	8275	0	0	\N
294431	1874	2873000	16284	8275	1	0	\N
294432	1874	2875000	16284	8275	2	0	\N
294436	1678	17280636388000	16287	8276	0	0	\N
294437	1874	2878000	16287	8276	1	0	\N
294438	1678	17280636388000	16288	8276	0	0	\N
294439	1874	2877000	16288	8276	1	0	\N
294440	1874	2880000	16288	8276	2	0	\N
294327	1874	2781000	16260	8263	2	0	2
294333	1678	17280636370000	16262	8264	0	0	0
294334	1678	17280636371000	16262	8264	1	0	0
294335	1874	2784000	16262	8264	2	0	2
294336	1874	2787000	16262	8264	3	0	2
294338	1874	2790000	16262	8264	5	0	2
294339	1874	2792000	16262	8264	6	0	2
294340	1678	17280636372000	16263	8265	0	0	0
294341	1678	17280636373000	16263	8265	1	0	0
294342	1874	2795000	16263	8265	2	0	2
294344	1874	2799000	16263	8265	4	0	2
294345	1874	2800000	16263	8265	5	0	2
294346	1874	2803000	16263	8265	6	0	2
294350	1678	17280636374000	16265	8266	0	0	0
294352	1874	2808000	16265	8266	2	0	2
294353	1678	17280636375000	16268	8268	0	0	0
294354	1678	17280636376000	16268	8268	1	0	0
294355	1874	2811000	16268	8268	2	0	2
294356	1874	2813000	16268	8268	3	0	2
294358	1874	2816000	16268	8268	5	0	2
294359	1874	2819000	16268	8268	6	0	2
294360	1678	17280636377000	16269	8269	0	0	0
294361	1874	2821000	16269	8269	1	0	2
294362	1874	2824000	16269	8269	2	0	2
294364	1678	17280636379000	16270	8270	1	0	0
294365	1678	17280636380000	16270	8270	2	0	0
294366	1678	17280636381000	16270	8270	3	0	0
294367	1874	2825000	16270	8270	4	0	2
294369	1874	2829000	16270	8270	6	0	2
294370	1874	2831000	16270	8270	7	0	2
294371	1874	2834000	16270	8270	9	0	2
294372	1874	2837000	16270	8270	10	0	2
294373	1874	2840000	16270	8270	11	0	2
294382	1678	17280636382000	16272	8271	0	0	0
294383	1678	17280636383000	16272	8271	1	0	0
294384	1874	2844000	16272	8271	2	0	2
294385	1874	2847000	16272	8271	4	0	2
294386	1874	2850000	16272	8271	5	0	2
294388	1874	2854000	16272	8271	7	0	2
294396	1678	17280636384000	16274	8272	0	0	0
294397	1874	2857000	16274	8272	1	0	2
294398	1874	2859000	16274	8272	2	0	2
294400	1874	2861000	16275	8273	1	0	2
294401	1874	2864000	16275	8273	2	0	2
294406	1678	17280636386000	16277	8274	0	0	0
294407	1874	2865000	16277	8274	1	0	2
294408	1874	2868000	16277	8274	2	0	2
294433	1678	17280636387000	16285	8275	0	0	0
294434	1874	2873000	16285	8275	1	0	2
294435	1874	2875000	16285	8275	2	0	2
294441	1678	17280636388000	16289	8276	0	0	\N
294442	1874	2877000	16289	8276	1	0	\N
294452	1678	16560624355000	16293	8160	0	0	\N
294453	1678	16560624356000	16293	8160	1	0	\N
294454	1678	16560624357000	16293	8160	2	0	\N
294455	1678	16560624358000	16293	8160	3	0	\N
294456	1678	16560624359000	16293	8160	4	0	\N
294457	1678	16560624360000	16293	8160	5	0	\N
294458	1678	16560624361000	16293	8160	6	0	\N
294459	1678	16560624362000	16293	8160	7	0	\N
294460	1678	16560624363000	16293	8160	8	0	\N
294461	1678	16560624364000	16293	8160	9	0	\N
294462	1678	16560624365000	16293	8160	10	0	\N
294463	1678	16560624366000	16293	8160	11	0	\N
294464	1678	16560624367000	16293	8160	12	0	\N
294465	1678	16560624368000	16293	8160	13	0	\N
294466	1678	16560624369000	16293	8160	14	0	\N
294467	1678	16560624370000	16293	8160	15	0	\N
294468	1678	16560624371000	16293	8160	16	0	\N
294469	1678	16560624372000	16293	8160	17	0	\N
294470	1678	16560624373000	16293	8160	18	0	\N
294471	1678	16560624374000	16293	8160	19	0	\N
294472	1678	16560624375000	16293	8160	20	0	\N
294473	1678	16560624376000	16293	8160	21	0	\N
294474	1678	16560624377000	16293	8160	22	0	\N
294475	1678	16560624378000	16293	8160	23	0	\N
294476	1678	16560624379000	16293	8160	24	0	\N
294477	1678	16560624380000	16293	8160	25	0	\N
294478	1678	16560624381000	16293	8160	26	0	\N
294479	1678	16560624382000	16293	8160	27	0	\N
294480	1678	16560624383000	16293	8160	28	0	\N
294481	1678	16560624384000	16293	8160	29	0	\N
294482	1678	16560624385000	16293	8160	30	0	\N
294483	1678	16560624386000	16293	8160	31	0	\N
294484	1678	16560624387000	16293	8160	32	0	\N
294485	1678	16560624388000	16293	8160	33	0	\N
294486	1678	16560624389000	16293	8160	34	0	\N
294487	1303	1702889985351650	16293	8160	35	0	\N
294488	937	505422913800000	16293	8160	36	0	\N
294489	2142	1000000	16293	8160	38	0	\N
294490	2142	4000000	16293	8160	39	0	\N
294491	2142	2850004000000	16293	8160	40	0	\N
294492	1874	2077000	16293	8160	41	0	\N
294493	1874	2080000	16293	8160	42	0	\N
294494	1874	2083000	16293	8160	43	0	\N
294495	1874	2086000	16293	8160	44	0	\N
294496	1874	2088000	16293	8160	45	0	\N
294497	1874	2090000	16293	8160	46	0	\N
294498	1874	2092000	16293	8160	47	0	\N
294499	1874	2094000	16293	8160	48	0	\N
294500	1874	2096000	16293	8160	49	0	\N
294501	1950	8669851000000	16293	8160	50	0	\N
294502	1950	10169851000000	16293	8160	51	0	\N
294503	1874	2097000	16293	8160	52	0	\N
294504	967	504776675000000	16293	8160	53	0	\N
294505	1087	904515869720300	16293	8160	55	0	\N
294506	1207	610311145055850	16293	8160	56	0	\N
294507	1333	1700596942094750	16293	8160	57	0	\N
294508	2147	554000000000	16293	8160	58	0	\N
294509	1874	2098000	16293	8160	59	0	\N
294510	1874	2099000	16293	8160	60	0	\N
294511	1874	2100000	16293	8160	61	0	\N
294512	1874	2101000	16293	8160	62	0	\N
294513	1874	2102000	16293	8160	63	0	\N
294514	1874	2103000	16293	8160	64	0	\N
294515	1874	2104000	16293	8160	65	0	\N
294516	1874	2106000	16293	8160	66	0	\N
294517	1874	2108000	16293	8160	67	0	\N
294518	1874	2110000	16293	8160	68	0	\N
294519	1874	2112000	16293	8160	69	0	\N
294520	1874	2114000	16293	8160	70	0	\N
294521	1874	2116000	16293	8160	71	0	\N
294522	1874	2118000	16293	8160	72	0	\N
294523	1874	2120000	16293	8160	73	0	\N
294524	1874	2122000	16293	8160	74	0	\N
294525	1874	2124000	16293	8160	75	0	\N
294526	1874	2126000	16293	8160	76	0	\N
294527	1874	2128000	16293	8160	77	0	\N
294528	1874	2130000	16293	8160	78	0	\N
294529	1874	2132000	16293	8160	79	0	\N
294530	1874	2134000	16293	8160	80	0	\N
294531	1874	2136000	16293	8160	81	0	\N
294532	1874	2138000	16293	8160	82	0	\N
294533	1874	2140000	16293	8160	83	0	\N
294534	1874	2142000	16293	8160	84	0	\N
294535	1874	2144000	16293	8160	85	0	\N
294536	1874	2146000	16293	8160	86	0	\N
294537	1874	2148000	16293	8160	87	0	\N
294538	1874	2150000	16293	8160	88	0	\N
294539	1874	2152000	16293	8160	89	0	\N
294540	1874	2154000	16293	8160	90	0	\N
294541	1874	2156000	16293	8160	91	0	\N
294542	1874	2158000	16293	8160	92	0	\N
294543	1874	2160000	16293	8160	93	0	\N
294544	1874	2162000	16293	8160	94	0	\N
294545	1874	2164000	16293	8160	95	0	\N
294546	1874	2166000	16293	8160	96	0	\N
294547	1874	2168000	16293	8160	97	0	\N
294548	1874	2170000	16293	8160	98	0	\N
294549	1874	2172000	16293	8160	99	0	\N
294550	1874	2174000	16293	8160	100	0	\N
294551	1874	2176000	16293	8160	101	0	\N
294552	1874	2178000	16293	8160	102	0	\N
294553	1874	2181000	16293	8160	105	0	\N
294554	1874	2184000	16293	8160	106	0	\N
294555	1874	2187000	16293	8160	107	0	\N
294556	1874	2190000	16293	8160	108	0	\N
294557	1874	2193000	16293	8160	109	0	\N
294558	1874	2196000	16293	8160	110	0	\N
294559	1874	2199000	16293	8160	111	0	\N
294560	1874	2202000	16293	8160	112	0	\N
294561	1874	2205000	16293	8160	113	0	\N
294562	1874	2208000	16293	8160	114	0	\N
294563	1874	2211000	16293	8160	115	0	\N
294564	1874	2214000	16293	8160	116	0	\N
294565	1874	2217000	16293	8160	117	0	\N
294566	1874	2220000	16293	8160	118	0	\N
294567	1874	2223000	16293	8160	119	0	\N
294568	1874	2226000	16293	8160	120	0	\N
294569	1874	2229000	16293	8160	121	0	\N
294570	1874	2232000	16293	8160	122	0	\N
294571	1874	2235000	16293	8160	123	0	\N
294572	1874	2238000	16293	8160	124	0	\N
294573	1874	2241000	16293	8160	125	0	\N
294445	1874	2880000	16290	8276	2	0	2
294446	1678	17280636389000	16291	8277	0	0	0
294447	1874	2882000	16291	8277	1	0	2
294448	1678	17280636390000	16292	8278	0	0	0
294449	1874	2883000	16292	8278	1	0	2
294451	1874	2888000	16292	8278	3	0	2
294574	1678	17280636391000	16294	8279	0	0	0
294575	1678	17280636392000	16294	8279	1	0	0
294576	1874	2891000	16294	8279	2	0	2
294580	1678	17280636393000	16295	8280	0	0	\N
294581	1874	2900000	16295	8280	1	0	\N
294582	1874	2901000	16295	8280	2	0	\N
294583	1874	2904000	16295	8280	3	0	\N
294591	1678	17280636395000	16298	8282	0	0	\N
294592	1874	2911000	16298	8282	1	0	\N
294593	1874	2914000	16298	8282	2	0	\N
294594	1678	17280636395000	16299	8282	0	0	\N
294595	1874	2911000	16299	8282	1	0	\N
294596	1874	2914000	16299	8282	2	0	\N
294606	1678	17280636397000	16303	8284	0	0	\N
294607	1874	2920000	16303	8284	1	0	\N
294608	1874	2923000	16303	8284	2	0	\N
294609	1678	17280636398000	16304	8285	0	0	\N
294610	1874	2926000	16304	8285	1	0	\N
294611	1874	2928000	16304	8285	2	0	\N
294615	1678	17280636370000	16306	8264	0	0	\N
294616	1678	17280636371000	16306	8264	1	0	\N
294617	1678	17280636372000	16306	8264	2	0	\N
294618	1678	17280636373000	16306	8264	3	0	\N
294619	1678	17280636374000	16306	8264	4	0	\N
294620	1678	17280636375000	16306	8264	5	0	\N
294621	1678	17280636376000	16306	8264	6	0	\N
294622	1678	17280636377000	16306	8264	7	0	\N
294623	1678	17280636378000	16306	8264	8	0	\N
294624	1678	17280636379000	16306	8264	9	0	\N
294625	1678	17280636380000	16306	8264	10	0	\N
294626	1678	17280636381000	16306	8264	11	0	\N
294627	1678	17280636382000	16306	8264	12	0	\N
294628	1678	17280636383000	16306	8264	13	0	\N
294629	1678	17280636384000	16306	8264	14	0	\N
294630	1678	17280636385000	16306	8264	15	0	\N
294631	1678	17280636386000	16306	8264	16	0	\N
294632	1678	17280636387000	16306	8264	17	0	\N
294633	1678	17280636388000	16306	8264	18	0	\N
294634	1678	17280636389000	16306	8264	19	0	\N
294635	1678	17280636390000	16306	8264	20	0	\N
294636	1678	17280636391000	16306	8264	21	0	\N
294637	1678	17280636392000	16306	8264	22	0	\N
294638	1678	17280636393000	16306	8264	24	0	\N
294639	1678	17280636394000	16306	8264	25	0	\N
294640	1678	17280636395000	16306	8264	26	0	\N
294641	1678	17280636396000	16306	8264	27	0	\N
294642	1678	17280636397000	16306	8264	28	0	\N
294643	1678	17280636398000	16306	8264	29	0	\N
294644	1874	2784000	16306	8264	30	0	\N
294645	1874	2787000	16306	8264	31	0	\N
294646	1874	2790000	16306	8264	32	0	\N
294647	1874	2792000	16306	8264	33	0	\N
294648	1874	2793000	16306	8264	34	0	\N
294649	1874	2795000	16306	8264	35	0	\N
294650	1874	2797000	16306	8264	36	0	\N
294651	1874	2799000	16306	8264	37	0	\N
294652	1874	2801000	16306	8264	38	0	\N
294653	1874	2803000	16306	8264	39	0	\N
294654	1874	2805000	16306	8264	40	0	\N
294655	1874	2807000	16306	8264	41	0	\N
294656	1874	2809000	16306	8264	42	0	\N
294657	1874	2811000	16306	8264	43	0	\N
294658	1874	2813000	16306	8264	44	0	\N
294659	1874	2814000	16306	8264	47	0	\N
294660	1874	2815000	16306	8264	48	0	\N
294661	1874	2816000	16306	8264	49	0	\N
294662	1874	2817000	16306	8264	50	0	\N
294663	1874	2818000	16306	8264	51	0	\N
294664	1874	2819000	16306	8264	52	0	\N
294665	1874	2820000	16306	8264	53	0	\N
294666	1874	2821000	16306	8264	54	0	\N
294667	1874	2824000	16306	8264	55	0	\N
294668	1874	2827000	16306	8264	56	0	\N
294669	1874	2830000	16306	8264	57	0	\N
294670	1874	2833000	16306	8264	58	0	\N
294671	1874	2836000	16306	8264	59	0	\N
294672	1874	2838000	16306	8264	60	0	\N
294673	1874	2840000	16306	8264	61	0	\N
294674	1874	2842000	16306	8264	62	0	\N
294675	1874	2844000	16306	8264	63	0	\N
294676	1874	2847000	16306	8264	64	0	\N
294677	1874	2850000	16306	8264	65	0	\N
294678	1874	2853000	16306	8264	66	0	\N
294679	1874	2856000	16306	8264	67	0	\N
294680	1874	2859000	16306	8264	68	0	\N
294681	1874	2862000	16306	8264	69	0	\N
294682	1874	2865000	16306	8264	70	0	\N
294683	1874	2868000	16306	8264	71	0	\N
294684	1874	2871000	16306	8264	72	0	\N
294685	1874	2874000	16306	8264	73	0	\N
294686	1874	2877000	16306	8264	74	0	\N
294687	1874	2880000	16306	8264	75	0	\N
294688	1874	2883000	16306	8264	76	0	\N
294689	1874	2886000	16306	8264	77	0	\N
294690	1874	2889000	16306	8264	78	0	\N
294691	1874	2892000	16306	8264	79	0	\N
294692	1874	2895000	16306	8264	80	0	\N
294693	1874	2898000	16306	8264	81	0	\N
294694	1874	2901000	16306	8264	82	0	\N
294695	1874	2904000	16306	8264	83	0	\N
294696	1874	2906000	16306	8264	84	0	\N
294697	1874	2908000	16306	8264	85	0	\N
294698	1874	2910000	16306	8264	86	0	\N
294699	1874	2912000	16306	8264	87	0	\N
294700	1874	2914000	16306	8264	88	0	\N
294701	1874	2916000	16306	8264	89	0	\N
294702	1874	2918000	16306	8264	90	0	\N
294703	1874	2920000	16306	8264	91	0	\N
294704	1874	2922000	16306	8264	92	0	\N
294705	1874	2924000	16306	8264	93	0	\N
294706	1874	2926000	16306	8264	94	0	\N
294707	1874	2928000	16306	8264	95	0	\N
294711	1678	17280636400000	16308	8287	0	0	\N
294712	1678	17280636401000	16308	8287	1	0	\N
294579	1874	2898000	16294	8279	5	0	2
294584	1678	17280636393000	16296	8280	0	0	0
294585	1874	2900000	16296	8280	1	0	2
294586	1874	2901000	16296	8280	2	0	2
294587	1874	2904000	16296	8280	3	0	2
294589	1874	2906000	16297	8281	1	0	2
294590	1874	2909000	16297	8281	2	0	2
294597	1678	17280636395000	16300	8282	0	0	0
294598	1874	2911000	16300	8282	1	0	2
294599	1874	2914000	16300	8282	2	0	2
294601	1874	2917000	16301	8283	1	0	2
294602	1874	2918000	16301	8283	2	0	2
294603	1678	17280636397000	16302	8284	0	0	0
294604	1874	2920000	16302	8284	1	0	2
294612	1678	17280636398000	16305	8285	0	0	0
294613	1874	2926000	16305	8285	1	0	2
294614	1874	2928000	16305	8285	2	0	2
294708	1678	17280636399000	16307	8286	0	0	0
294709	1874	2931000	16307	8286	1	0	2
294713	1874	2934000	16308	8287	2	0	\N
294714	1874	2937000	16308	8287	3	0	\N
294715	1874	2940000	16308	8287	4	0	\N
294716	1874	2942000	16308	8287	5	0	\N
294717	1874	2944000	16308	8287	6	0	\N
294718	1678	17280636400000	16309	8287	0	0	\N
294719	1678	17280636401000	16309	8287	1	0	\N
294720	1874	2934000	16309	8287	2	0	\N
294721	1874	2937000	16309	8287	3	0	\N
294722	1874	2940000	16309	8287	4	0	\N
294723	1874	2942000	16309	8287	5	0	\N
294724	1874	2944000	16309	8287	6	0	\N
294725	1678	17280636400000	16310	8287	0	0	\N
294726	1678	17280636401000	16310	8287	1	0	\N
294727	1874	2934000	16310	8287	2	0	\N
294728	1874	2937000	16310	8287	3	0	\N
294729	1874	2940000	16310	8287	4	0	\N
294730	1874	2942000	16310	8287	5	0	\N
294731	1874	2944000	16310	8287	6	0	\N
294732	1678	17280636400000	16311	8287	0	0	\N
294733	1678	17280636401000	16311	8287	1	0	\N
294734	1874	2934000	16311	8287	2	0	\N
294735	1874	2937000	16311	8287	3	0	\N
294736	1874	2940000	16311	8287	4	0	\N
294737	1874	2942000	16311	8287	5	0	\N
294738	1874	2944000	16311	8287	6	0	\N
294759	1678	17280636406000	16316	8291	1	0	\N
294760	1874	2968000	16316	8291	2	0	\N
294761	1874	2969000	16316	8291	3	0	\N
294762	1874	2971000	16316	8291	4	0	\N
294763	1678	17280636406000	16317	8291	1	0	\N
294764	1874	2968000	16317	8291	2	0	\N
294765	1874	2969000	16317	8291	3	0	\N
294766	1874	2971000	16317	8291	4	0	\N
294771	1678	17280636406000	16319	8291	1	0	\N
294772	1874	2968000	16319	8291	2	0	\N
294773	1874	2969000	16319	8291	3	0	\N
294774	1874	2971000	16319	8291	4	0	\N
294793	1678	17280636413000	16326	8298	0	0	\N
294794	1874	3001000	16326	8298	1	0	\N
294795	1874	3004000	16326	8298	2	0	\N
294796	1874	3006000	16326	8298	3	0	\N
294827	1678	17280636416000	16330	8300	1	0	\N
294828	1678	17280636417000	16330	8300	2	0	\N
294829	1678	17280636418000	16330	8300	3	0	\N
294830	1678	17280636419000	16330	8300	4	0	\N
294831	1678	17280636420000	16330	8300	5	0	\N
294832	1678	17280636421000	16330	8300	6	0	\N
294833	1874	3018000	16330	8300	7	0	\N
294834	1874	3021000	16330	8300	8	0	\N
294835	1874	3024000	16330	8300	9	0	\N
294836	1874	3027000	16330	8300	10	0	\N
294837	1874	3030000	16330	8300	11	0	\N
294838	1874	3033000	16330	8300	12	0	\N
294839	1874	3036000	16330	8300	13	0	\N
294840	1874	3038000	16330	8300	14	0	\N
294841	1874	3040000	16330	8300	15	0	\N
294842	1874	3042000	16330	8300	16	0	\N
294843	1874	3044000	16330	8300	17	0	\N
294844	1874	3046000	16330	8300	18	0	\N
294845	1874	3047000	16330	8300	19	0	\N
294846	1874	3048000	16330	8300	20	0	\N
294741	1874	2934000	16312	8287	2	0	2
294742	1874	2937000	16312	8287	3	0	2
294743	1874	2940000	16312	8287	4	0	2
294744	1874	2942000	16312	8287	5	0	2
294745	1874	2944000	16312	8287	6	0	2
294747	1874	2946000	16313	8288	1	0	2
294748	1874	2949000	16313	8288	2	0	2
294749	1678	17280636403000	16314	8289	0	0	0
294750	1874	2952000	16314	8289	1	0	2
294751	1874	2953000	16314	8289	2	0	2
294753	1678	17280636404000	16315	8290	0	0	0
294754	1678	17280636405000	16315	8290	1	0	0
294755	1874	2957000	16315	8290	2	0	2
294756	1874	2959000	16315	8290	3	0	2
294758	1874	2965000	16315	8290	5	0	2
294767	1678	17280636406000	16318	8291	1	0	0
294768	1874	2968000	16318	8291	2	0	2
294769	1874	2969000	16318	8291	3	0	2
294770	1874	2971000	16318	8291	4	0	2
294776	1874	2973000	16320	8292	1	0	2
294777	1874	2976000	16320	8292	2	0	2
294778	1678	17280636408000	16321	8293	0	0	0
294779	1874	2979000	16321	8293	1	0	2
294780	1678	17280636409000	16322	8294	0	0	0
294782	1874	2984000	16322	8294	2	0	2
294783	1678	17280636410000	16323	8295	0	0	0
294784	1874	2987000	16323	8295	1	0	2
294785	1874	2988000	16323	8295	2	0	2
294787	1678	17280636411000	16324	8296	0	0	0
294788	1874	2992000	16324	8296	1	0	2
294789	1874	2995000	16324	8296	2	0	2
294790	1678	17280636412000	16325	8297	0	0	0
294791	1874	2997000	16325	8297	1	0	2
294797	1678	17280636413000	16327	8298	0	0	0
294798	1874	3001000	16327	8298	1	0	2
294799	1874	3004000	16327	8298	2	0	2
294800	1874	3006000	16327	8298	3	0	2
294801	1678	17280636414000	16328	8299	0	0	0
294803	1874	3008000	16328	8299	2	0	2
294804	1874	3010000	16328	8299	3	0	2
294805	1874	3013000	16328	8299	4	0	2
294806	1874	3016000	16328	8299	5	0	2
294808	1678	17280636417000	16329	8300	2	0	0
294809	1678	17280636418000	16329	8300	3	0	0
294810	1678	17280636419000	16329	8300	4	0	0
294811	1678	17280636420000	16329	8300	5	0	0
294812	1678	17280636421000	16329	8300	6	0	0
294814	1874	3021000	16329	8300	8	0	2
294815	1874	3024000	16329	8300	9	0	2
294816	1874	3027000	16329	8300	10	0	2
294817	1874	3030000	16329	8300	11	0	2
294818	1874	3033000	16329	8300	12	0	2
294820	1874	3038000	16329	8300	14	0	2
294821	1874	3040000	16329	8300	15	0	2
294822	1874	3042000	16329	8300	16	0	2
294823	1874	3044000	16329	8300	17	0	2
294825	1874	3047000	16329	8300	19	0	2
294826	1874	3048000	16329	8300	20	0	2
294847	1678	17280636422000	16331	8301	0	0	0
294848	1874	3050000	16331	8301	1	0	2
294850	1678	17280636423000	16332	8302	0	0	\N
294851	1874	3056000	16332	8302	1	0	\N
294852	1874	3057000	16332	8302	2	0	\N
294853	1874	3059000	16332	8302	3	0	\N
294854	1678	17280636423000	16333	8302	0	0	\N
294855	1874	3056000	16333	8302	1	0	\N
294856	1874	3057000	16333	8302	2	0	\N
294857	1874	3059000	16333	8302	3	0	\N
294892	1678	17280636432000	16343	8310	0	0	\N
294893	1874	3100000	16343	8310	1	0	\N
294894	1874	3103000	16343	8310	2	0	\N
294902	1678	17280636434000	16346	8312	0	0	\N
294903	1874	3111000	16346	8312	1	0	\N
294904	1874	3114000	16346	8312	2	0	\N
294908	1678	17280636435000	16348	8313	0	0	\N
294909	1874	3117000	16348	8313	1	0	\N
294910	1874	3119000	16348	8313	2	0	\N
294911	1678	17280636435000	16349	8313	0	0	\N
294912	1874	3117000	16349	8313	1	0	\N
294913	1874	3119000	16349	8313	2	0	\N
294917	1678	17280636436000	16351	8314	0	0	\N
294918	1874	3121000	16351	8314	1	0	\N
294919	1874	3124000	16351	8314	2	0	\N
294953	1678	17280636447000	16356	8319	0	0	\N
294954	1874	3179000	16356	8319	1	0	\N
294955	1874	3182000	16356	8319	2	0	\N
294956	1874	3183000	16356	8319	3	0	\N
294957	1678	17280636447000	16357	8319	0	0	\N
294958	1874	3179000	16357	8319	1	0	\N
294959	1874	3182000	16357	8319	2	0	\N
294960	1874	3183000	16357	8319	3	0	\N
294971	1678	17280636450000	16360	8321	0	0	\N
294972	1874	3195000	16360	8321	1	0	\N
294973	1874	3198000	16360	8321	2	0	\N
294974	1874	3199000	16360	8321	3	0	\N
294982	1678	17280636451000	16363	8322	0	0	\N
294983	1874	3202000	16363	8322	1	0	\N
294859	1874	3056000	16334	8302	1	0	2
294860	1874	3057000	16334	8302	2	0	2
294861	1874	3059000	16334	8302	3	0	2
294862	2149	9000000000	16335	8303	0	0	0
294863	1678	17280636424000	16335	8303	1	0	0
294865	1874	3061000	16335	8303	3	0	2
294866	1874	3063000	16335	8303	4	0	2
294867	1874	3066000	16335	8303	5	0	2
294868	1678	17280636426000	16336	8304	0	0	0
294869	1874	3068000	16336	8304	1	0	2
294871	1874	3072000	16336	8304	3	0	2
294872	1678	17280636427000	16337	8305	0	0	0
294873	1874	3075000	16337	8305	1	0	2
294874	1874	3077000	16337	8305	2	0	2
294876	1874	3079000	16338	8306	1	0	2
294877	1874	3082000	16338	8306	2	0	2
294878	2149	9000000000	16339	8307	0	0	0
294879	1678	17280636429000	16339	8307	1	0	0
294880	1874	3084000	16339	8307	2	0	2
294882	1678	17280636430000	16340	8308	0	0	0
294883	1874	3090000	16340	8308	1	0	2
294884	1874	3091000	16340	8308	2	0	2
294885	1874	3093000	16340	8308	3	0	2
294886	1678	17280636431000	16341	8309	0	0	0
294888	1874	3098000	16341	8309	2	0	2
294889	1678	17280636432000	16342	8310	0	0	0
294890	1874	3100000	16342	8310	1	0	2
294891	1874	3103000	16342	8310	2	0	2
294896	1874	3106000	16344	8311	1	0	2
294897	1874	3107000	16344	8311	2	0	2
294898	1874	3109000	16344	8311	3	0	2
294899	1678	17280636434000	16345	8312	0	0	0
294900	1874	3111000	16345	8312	1	0	2
294905	1678	17280636435000	16347	8313	0	0	0
294906	1874	3117000	16347	8313	1	0	2
294907	1874	3119000	16347	8313	2	0	2
294914	1678	17280636436000	16350	8314	0	0	0
294915	1874	3121000	16350	8314	1	0	2
294920	1678	17280636437000	16352	8315	0	0	0
294921	1678	17280636438000	16352	8315	1	0	0
294922	1678	17280636439000	16352	8315	2	0	0
294923	1678	17280636440000	16352	8315	3	0	0
294925	1874	3126000	16352	8315	5	0	2
294926	1874	3129000	16352	8315	6	0	2
294927	1874	3132000	16352	8315	7	0	2
294928	1874	3135000	16352	8315	8	0	2
294929	1874	3138000	16352	8315	9	0	2
294931	1874	3142000	16352	8315	11	0	2
294932	1874	3144000	16352	8315	12	0	2
294933	1874	3146000	16352	8315	13	0	2
294934	1678	17280636441000	16353	8316	0	0	0
294935	1678	17280636442000	16353	8316	1	0	0
294937	1874	3148000	16353	8316	3	0	2
294938	1874	3150000	16353	8316	4	0	2
294939	1874	3152000	16353	8316	5	0	2
294940	1874	3153000	16353	8316	6	0	2
294942	1874	3159000	16353	8316	8	0	2
294943	1874	3162000	16353	8316	9	0	2
294944	1678	17280636444000	16354	8317	0	0	0
294945	1678	17280636445000	16354	8317	1	0	0
294946	1874	3164000	16354	8317	2	0	2
294948	1874	3169000	16354	8317	4	0	2
294949	1874	3172000	16354	8317	5	0	2
294950	1678	17280636446000	16355	8318	0	0	0
294951	1874	3174000	16355	8318	1	0	2
294952	1874	3177000	16355	8318	2	0	2
294962	1874	3179000	16358	8319	1	0	2
294963	1874	3182000	16358	8319	2	0	2
294964	1874	3183000	16358	8319	3	0	2
294965	1678	17280636448000	16359	8320	0	0	0
294967	1874	3186000	16359	8320	2	0	2
294968	1874	3189000	16359	8320	3	0	2
294969	1874	3191000	16359	8320	4	0	2
294970	1874	3193000	16359	8320	5	0	2
294975	1678	17280636450000	16361	8321	0	0	0
294977	1874	3198000	16361	8321	2	0	2
294978	1874	3199000	16361	8321	3	0	2
294979	1678	17280636451000	16362	8322	0	0	0
294980	1874	3202000	16362	8322	1	0	2
294981	1874	3204000	16362	8322	2	0	2
294988	946	505422075000000	16365	8323	0	0	\N
294989	1066	905711965000000	16365	8323	1	0	\N
294990	1186	611101950000000	16365	8323	2	0	\N
294991	1678	17280636452000	16365	8323	3	0	\N
294992	1678	17280636453000	16365	8323	4	0	\N
294993	1359	1701968237751650	16365	8323	5	0	\N
294994	1874	3206000	16365	8323	6	0	\N
294995	1874	3207000	16365	8323	7	0	\N
294996	1874	3209000	16365	8323	8	0	\N
294997	1874	3212000	16365	8323	9	0	\N
294998	1874	3215000	16365	8323	10	0	\N
295010	1874	3223000	16367	8325	0	0	\N
295011	1874	3225000	16367	8325	1	0	\N
295014	1874	3223000	16369	8325	0	0	\N
295015	1874	3225000	16369	8325	1	0	\N
295019	1678	17280636455000	16371	8326	0	0	\N
295020	1874	3228000	16371	8326	1	0	\N
295030	946	505422075000000	16374	8233	1	0	\N
295031	1066	905711965000000	16374	8233	2	0	\N
295032	1186	611101950000000	16374	8233	3	0	\N
295033	1312	1702889737751650	16374	8233	4	0	\N
295034	2149	9000000000	16374	8233	5	0	\N
295035	2149	9000000000	16374	8233	6	0	\N
295036	1303	1702889985351650	16374	8233	7	0	\N
295037	937	505422913800000	16374	8233	8	0	\N
295038	1359	1701968237751650	16374	8233	9	0	\N
295039	967	504776675000000	16374	8233	10	0	\N
295040	1087	904515869720300	16374	8233	11	0	\N
295041	1207	610311145055850	16374	8233	12	0	\N
295042	1333	1700596942094750	16374	8233	13	0	\N
295043	2147	554000000000	16374	8233	14	0	\N
295054	1678	17280636461000	16377	8330	0	0	\N
295055	1874	3258000	16377	8330	1	0	\N
295056	1874	3260000	16377	8330	2	0	\N
295057	1678	17280636461000	16378	8330	0	0	\N
295058	1874	3258000	16378	8330	1	0	\N
295059	1874	3260000	16378	8330	2	0	\N
295060	1678	17280636461000	16379	8330	0	0	\N
295061	1874	3258000	16379	8330	1	0	\N
295062	1874	3260000	16379	8330	2	0	\N
295072	1678	17280636465000	16382	8333	0	0	\N
295073	1874	3275000	16382	8333	1	0	\N
295074	1874	3278000	16382	8333	2	0	\N
295078	1678	17280636465000	16384	8333	0	0	\N
295079	1874	3275000	16384	8333	1	0	\N
295080	1874	3278000	16384	8333	2	0	\N
295088	1678	17280636467000	16387	8335	0	0	\N
295089	1874	3286000	16387	8335	1	0	\N
295090	1874	3289000	16387	8335	2	0	\N
295108	1678	17280636473000	16390	8338	0	0	\N
295109	1874	3318000	16390	8338	1	0	\N
295110	1874	3321000	16390	8338	2	0	\N
295114	1678	17280636473000	16392	8338	0	0	\N
295115	1678	17280636474000	16392	8338	1	0	\N
295116	1874	3318000	16392	8338	2	0	\N
295117	1874	3321000	16392	8338	3	0	\N
295118	1874	3323000	16392	8338	4	0	\N
295119	1874	3326000	16392	8338	6	0	\N
294987	1874	3209000	16364	8323	3	0	2
294999	1066	905711965000000	16366	8324	0	0	0
295000	1186	611101950000000	16366	8324	1	0	0
295001	1312	1702889737751650	16366	8324	2	0	0
295002	1678	17280636453000	16366	8324	3	0	0
295004	1359	1701968237751650	16366	8324	5	0	0
295005	1874	3210000	16366	8324	6	0	2
295006	1874	3213000	16366	8324	7	0	2
295007	1874	3216000	16366	8324	8	0	2
295008	1874	3218000	16366	8324	9	0	2
295012	1874	3223000	16368	8325	0	0	2
295013	1874	3225000	16368	8325	1	0	2
295016	1678	17280636455000	16370	8326	0	0	0
295017	1874	3227000	16370	8326	1	0	2
295021	1678	17280636456000	16372	8327	0	0	0
295022	1874	3231000	16372	8327	1	0	2
295023	1874	3234000	16372	8327	2	0	2
295024	1874	3236000	16372	8327	3	0	2
295025	1678	17280636457000	16373	8328	0	0	0
295027	1874	3238000	16373	8328	2	0	2
295028	1874	3241000	16373	8328	3	0	2
295029	1874	3244000	16373	8328	4	0	2
295044	1678	17280636459000	16375	8329	0	0	0
295045	1678	17280636460000	16375	8329	1	0	0
295047	1874	3249000	16375	8329	3	0	2
295048	1874	3252000	16375	8329	4	0	2
295049	1874	3254000	16375	8329	5	0	2
295050	1874	3255000	16375	8329	6	0	2
295052	1874	3258000	16376	8330	1	0	2
295053	1874	3260000	16376	8330	2	0	2
295063	1678	17280636462000	16380	8331	0	0	0
295064	1678	17280636463000	16380	8331	1	0	0
295065	1874	3263000	16380	8331	2	0	2
295067	1874	3267000	16380	8331	4	0	2
295068	1874	3268000	16380	8331	5	0	2
295069	1678	17280636464000	16381	8332	0	0	0
295070	1874	3271000	16381	8332	1	0	2
295071	1874	3273000	16381	8332	2	0	2
295076	1874	3275000	16383	8333	1	0	2
295077	1874	3278000	16383	8333	2	0	2
295081	1678	17280636466000	16385	8334	0	0	0
295082	1874	3280000	16385	8334	1	0	2
295084	1874	3284000	16385	8334	3	0	2
295085	1678	17280636467000	16386	8335	0	0	0
295086	1874	3286000	16386	8335	1	0	2
295087	1874	3289000	16386	8335	2	0	2
295091	1678	17280636468000	16388	8336	0	0	0
295093	1874	3292000	16388	8336	2	0	2
295094	1874	3295000	16388	8336	3	0	2
295095	1874	3296000	16388	8336	4	0	2
295096	1874	3298000	16388	8336	5	0	2
295097	1874	3300000	16388	8336	6	0	2
295099	1678	17280636471000	16389	8337	1	0	0
295100	1678	17280636472000	16389	8337	2	0	0
295101	1874	3301000	16389	8337	3	0	2
295102	1874	3304000	16389	8337	4	0	2
295104	1874	3309000	16389	8337	7	0	2
295105	1874	3312000	16389	8337	8	0	2
295106	1874	3314000	16389	8337	9	0	2
295107	1874	3316000	16389	8337	10	0	2
295111	1678	17280636473000	16391	8338	0	0	0
295113	1874	3321000	16391	8338	2	0	2
295120	1678	17280636474000	16394	8339	0	0	0
295130	1678	17280636474000	16395	8339	0	0	\N
295131	1678	17280636475000	16395	8339	1	0	\N
295132	1678	17280636476000	16395	8339	2	0	\N
295133	1874	3323000	16395	8339	3	0	\N
295134	1874	3325000	16395	8339	4	0	\N
295135	1874	3326000	16395	8339	5	0	\N
295136	1874	3328000	16395	8339	6	0	\N
295137	1874	3331000	16395	8339	7	0	\N
295138	1874	3334000	16395	8339	8	0	\N
295139	1874	3337000	16395	8339	9	0	\N
295140	1678	17280636477000	16396	8340	0	0	\N
295141	1874	3340000	16396	8340	1	0	\N
295142	1874	3342000	16396	8340	2	0	\N
295154	1678	17280636480000	16399	8342	0	0	\N
295155	1874	3356000	16399	8342	1	0	\N
295156	1874	3358000	16399	8342	2	0	\N
295160	1678	17280636481000	16401	8343	0	0	\N
295161	1678	17280636482000	16401	8343	1	0	\N
295162	1874	3361000	16401	8343	3	0	\N
295163	1874	3364000	16401	8343	4	0	\N
295164	1874	3366000	16401	8343	5	0	\N
295165	1874	3367000	16401	8343	6	0	\N
295166	1874	3369000	16401	8343	7	0	\N
295177	1678	17280636483000	16404	8344	0	0	\N
295178	1874	3371000	16404	8344	1	0	\N
295179	1874	3374000	16404	8344	2	0	\N
295186	1678	17280636486000	16407	8347	0	0	\N
295187	1874	3385000	16407	8347	1	0	\N
295188	1678	17280636486000	16408	8347	0	0	\N
295189	1874	3387000	16408	8347	1	0	\N
295190	1874	3388000	16408	8347	2	0	\N
295194	1678	17280636486000	16410	8347	0	0	\N
295195	1874	3387000	16410	8347	1	0	\N
295196	1874	3388000	16410	8347	2	0	\N
295203	1678	17280636489000	16412	8349	0	0	\N
295204	1874	3399000	16412	8349	1	0	\N
295205	1874	3401000	16412	8349	2	0	\N
295206	1874	3404000	16412	8349	3	0	\N
295207	1678	17280636489000	16413	8349	0	0	\N
295208	1874	3399000	16413	8349	1	0	\N
295209	1874	3401000	16413	8349	2	0	\N
295210	1874	3404000	16413	8349	3	0	\N
295211	1678	17280636489000	16414	8349	0	0	\N
295212	1874	3399000	16414	8349	1	0	\N
295213	1874	3401000	16414	8349	2	0	\N
295214	1874	3404000	16414	8349	3	0	\N
295219	1678	17280636490000	16416	8350	0	0	\N
295220	1874	3407000	16416	8350	1	0	\N
295221	1874	3409000	16416	8350	2	0	\N
295224	1678	17280636490000	16418	8350	0	0	\N
295225	1874	3407000	16418	8350	1	0	\N
295226	1874	3409000	16418	8350	2	0	\N
295231	1678	17280636492000	16420	8352	0	0	\N
295232	1874	3417000	16420	8352	1	0	\N
295233	1874	3418000	16420	8352	2	0	\N
295234	1874	3420000	16420	8352	3	0	\N
295239	1678	17280636492000	16422	8352	0	0	\N
295240	1874	3417000	16422	8352	1	0	\N
295241	1874	3418000	16422	8352	2	0	\N
295242	1874	3420000	16422	8352	3	0	\N
295243	1678	17280636493000	16423	8353	0	0	\N
295244	1678	17280636494000	16423	8353	1	0	\N
295245	1874	3422000	16423	8353	2	0	\N
295246	1874	3424000	16423	8353	3	0	\N
295247	1874	3427000	16423	8353	4	0	\N
295248	1874	3430000	16423	8353	5	0	\N
295255	1678	17280636493000	16425	8353	0	0	\N
295256	1678	17280636494000	16425	8353	1	0	\N
295123	1874	3323000	16394	8339	3	0	2
295124	1874	3325000	16394	8339	4	0	2
295125	1874	3326000	16394	8339	5	0	2
295126	1874	3328000	16394	8339	6	0	2
295127	1874	3331000	16394	8339	7	0	2
295129	1874	3337000	16394	8339	9	0	2
295143	1678	17280636477000	16397	8340	0	0	0
295144	1874	3340000	16397	8340	1	0	2
295145	1874	3342000	16397	8340	2	0	2
295146	1678	17280636478000	16398	8341	0	0	0
295148	1678	17280636479000	16398	8341	2	0	0
295149	1874	3344000	16398	8341	3	0	2
295150	1874	3347000	16398	8341	4	0	2
295151	1874	3350000	16398	8341	5	0	2
295153	1874	3353000	16398	8341	7	0	2
295157	1678	17280636480000	16400	8342	0	0	0
295158	1874	3356000	16400	8342	1	0	2
295159	1874	3358000	16400	8342	2	0	2
295167	1678	17280636481000	16402	8343	0	0	0
295169	1874	3361000	16402	8343	3	0	2
295170	1874	3364000	16402	8343	4	0	2
295171	1874	3366000	16402	8343	5	0	2
295172	1874	3367000	16402	8343	6	0	2
295173	1874	3369000	16402	8343	7	0	2
295175	1874	3371000	16403	8344	1	0	2
295176	1874	3374000	16403	8344	2	0	2
295180	1678	17280636484000	16405	8345	0	0	0
295181	1874	3376000	16405	8345	1	0	2
295183	1678	17280636485000	16406	8346	0	0	0
295184	1874	3381000	16406	8346	1	0	2
295185	1874	3384000	16406	8346	2	0	2
295191	1678	17280636486000	16409	8347	0	0	0
295192	1874	3387000	16409	8347	1	0	2
295197	1678	17280636487000	16411	8348	0	0	0
295198	1678	17280636488000	16411	8348	1	0	0
295199	1874	3390000	16411	8348	2	0	2
295200	1874	3393000	16411	8348	3	0	2
295201	1874	3396000	16411	8348	4	0	2
295215	1678	17280636489000	16415	8349	0	0	0
295216	1874	3399000	16415	8349	1	0	2
295217	1874	3401000	16415	8349	2	0	2
295218	1874	3404000	16415	8349	3	0	2
295223	1874	3409000	16417	8350	1	0	2
295227	1678	17280636490000	16419	8351	0	0	0
295228	1678	17280636491000	16419	8351	1	0	0
295229	1874	3412000	16419	8351	2	0	2
295230	1874	3414000	16419	8351	3	0	2
295236	1874	3417000	16421	8352	1	0	2
295237	1874	3418000	16421	8352	2	0	2
295238	1874	3420000	16421	8352	3	0	2
295249	1678	17280636493000	16424	8353	0	0	0
295250	1678	17280636494000	16424	8353	1	0	0
295252	1874	3424000	16424	8353	3	0	2
295253	1874	3427000	16424	8353	4	0	2
295254	1874	3430000	16424	8353	5	0	2
295257	1874	3422000	16425	8353	2	0	\N
295258	1874	3424000	16425	8353	3	0	\N
295259	1874	3427000	16425	8353	4	0	\N
295260	1874	3430000	16425	8353	5	0	\N
295264	1678	17280636495000	16427	8354	0	0	\N
295265	1874	3432000	16427	8354	2	0	\N
295266	1874	3435000	16427	8354	3	0	\N
295267	1678	17280636496000	16428	8355	0	0	\N
295268	1874	3436000	16428	8355	1	0	\N
295269	1874	3439000	16428	8355	2	0	\N
295270	1874	3441000	16428	8355	3	0	\N
295275	1678	17280636496000	16430	8355	0	0	\N
295276	1874	3436000	16430	8355	1	0	\N
295277	1874	3439000	16430	8355	2	0	\N
295278	1874	3441000	16430	8355	3	0	\N
295279	1678	17280636497000	16431	8356	0	0	\N
295280	1678	17280636498000	16431	8356	1	0	\N
295281	1874	3444000	16431	8356	2	0	\N
295282	1874	3446000	16431	8356	4	0	\N
295283	1874	3448000	16431	8356	6	0	\N
295284	1678	17280636497000	16432	8356	0	0	\N
295285	1678	17280636498000	16432	8356	1	0	\N
295286	1874	3444000	16432	8356	2	0	\N
295287	1874	3446000	16432	8356	4	0	\N
295288	1874	3448000	16432	8356	6	0	\N
295305	1678	17280636502000	16435	8358	0	0	\N
295306	1874	3465000	16435	8358	1	0	\N
295307	1874	3468000	16435	8358	3	0	\N
295311	1678	17280636503000	16437	8359	0	0	\N
295312	1874	3470000	16437	8359	1	0	\N
295313	1874	3473000	16437	8359	2	0	\N
295316	1678	17280636503000	16439	8360	0	0	\N
295317	1874	3476000	16439	8360	1	0	\N
295318	1874	3478000	16439	8360	2	0	\N
295322	1874	3476000	16441	8360	0	0	\N
295323	1874	3478000	16441	8360	1	0	\N
295344	1678	17280636507000	16446	8364	0	0	\N
295345	1678	17280636508000	16446	8364	1	0	\N
295346	1678	17280636509000	16446	8364	2	0	\N
295347	1874	3496000	16446	8364	3	0	\N
295348	1874	3499000	16446	8364	4	0	\N
295349	1874	3500000	16446	8364	5	0	\N
295350	1874	3502000	16446	8364	6	0	\N
295351	1874	3504000	16446	8364	7	0	\N
295352	1874	3507000	16446	8364	8	0	\N
295353	1874	3510000	16446	8364	9	0	\N
295363	1678	18000647511000	16449	8366	0	0	\N
295364	1678	18000647512000	16449	8366	1	0	\N
295365	1874	3516000	16449	8366	2	0	\N
295366	1874	3519000	16449	8366	3	0	\N
295367	1874	3521000	16449	8366	4	0	\N
295368	1874	3523000	16449	8366	5	0	\N
295369	1874	3524000	16449	8366	6	0	\N
295381	1678	18000647514000	16452	8368	0	0	\N
295382	1678	18000647515000	16452	8368	1	0	\N
295383	2151	200000000	16452	8368	2	0	\N
295384	1874	3531000	16452	8368	3	0	\N
295385	1874	3534000	16452	8368	4	0	\N
295386	1874	3537000	16452	8368	5	0	\N
295387	1874	3538000	16452	8368	6	0	\N
295388	1874	3540000	16452	8368	7	0	\N
295389	1678	18000647514000	16453	8368	0	0	\N
295390	1678	18000647515000	16453	8368	1	0	\N
295391	2151	200000000	16453	8368	2	0	\N
295392	1874	3531000	16453	8368	3	0	\N
295263	1874	3435000	16426	8354	3	0	2
295271	1678	17280636496000	16429	8355	0	0	0
295272	1874	3436000	16429	8355	1	0	2
295273	1874	3439000	16429	8355	2	0	2
295274	1874	3441000	16429	8355	3	0	2
295290	1678	17280636498000	16433	8356	1	0	0
295291	1874	3444000	16433	8356	2	0	2
295292	1874	3446000	16433	8356	4	0	2
295293	1874	3448000	16433	8356	6	0	2
295294	1678	17280636499000	16434	8357	0	0	0
295296	1860	107501010000000	16434	8357	2	0	2
295297	1678	17280636501000	16434	8357	3	0	0
295298	1874	3451000	16434	8357	4	0	2
295299	1874	3453000	16434	8357	5	0	2
295301	1874	3458000	16434	8357	8	0	2
295302	1874	3460000	16434	8357	9	0	2
295303	1874	3461000	16434	8357	10	0	2
295304	1874	3464000	16434	8357	11	0	2
295308	1678	17280636502000	16436	8358	0	0	0
295310	1874	3468000	16436	8358	3	0	2
295314	1874	3470000	16438	8359	0	0	2
295315	1874	3473000	16438	8359	1	0	2
295319	1678	17280636503000	16440	8360	0	0	0
295320	1874	3476000	16440	8360	1	0	2
295324	1678	17280636504000	16442	8361	0	0	0
295325	1874	3481000	16442	8361	1	0	2
295326	1874	3483000	16442	8361	2	0	2
295327	1678	17280636505000	16443	8362	0	0	0
295329	1874	3486000	16443	8362	2	0	2
295330	1874	3489000	16443	8362	3	0	2
295331	1678	17280636506000	16444	8363	0	0	0
295332	1874	3492000	16444	8363	2	0	2
295333	1874	3494000	16444	8363	3	0	2
295335	1678	17280636508000	16445	8364	1	0	0
295336	1678	17280636509000	16445	8364	2	0	0
295337	1874	3496000	16445	8364	3	0	2
295338	1874	3499000	16445	8364	4	0	2
295339	1874	3500000	16445	8364	5	0	2
295341	1874	3504000	16445	8364	7	0	2
295342	1874	3507000	16445	8364	8	0	2
295343	1874	3510000	16445	8364	9	0	2
295354	1678	17280636510000	16447	8365	0	0	0
295356	1678	18000647511000	16448	8366	0	0	0
295357	1678	18000647512000	16448	8366	1	0	0
295358	1874	3516000	16448	8366	2	0	2
295359	1874	3519000	16448	8366	3	0	2
295360	1874	3521000	16448	8366	4	0	2
295362	1874	3524000	16448	8366	6	0	2
295370	1678	18000647513000	16450	8367	0	0	0
295371	1874	3526000	16450	8367	1	0	2
295372	1874	3529000	16450	8367	2	0	2
295373	1678	18000647514000	16451	8368	0	0	0
295375	2151	200000000	16451	8368	2	0	0
295376	1874	3531000	16451	8368	3	0	2
295377	1874	3534000	16451	8368	4	0	2
295378	1874	3537000	16451	8368	5	0	2
295380	1874	3540000	16451	8368	7	0	2
295393	1874	3534000	16453	8368	4	0	\N
295394	1874	3537000	16453	8368	5	0	\N
295395	1874	3538000	16453	8368	6	0	\N
295396	1874	3540000	16453	8368	7	0	\N
295397	1678	17280636475000	16454	8339	0	0	\N
295398	1678	17280636476000	16454	8339	1	0	\N
295399	1678	17280636477000	16454	8339	2	0	\N
295400	1678	17280636478000	16454	8339	3	0	\N
295401	2150	200000000	16454	8339	4	0	\N
295402	2151	200000000	16454	8339	5	0	\N
295403	1860	107501010000000	16454	8339	6	0	\N
295404	1678	17280636479000	16454	8339	7	0	\N
295405	1678	17280636480000	16454	8339	8	0	\N
295406	1678	17280636481000	16454	8339	9	0	\N
295407	1678	17280636482000	16454	8339	10	0	\N
295408	1678	17280636483000	16454	8339	11	0	\N
295409	1678	17280636484000	16454	8339	12	0	\N
295410	1678	17280636485000	16454	8339	13	0	\N
295411	1678	17280636486000	16454	8339	14	0	\N
295412	1678	17280636487000	16454	8339	15	0	\N
295413	1678	17280636488000	16454	8339	16	0	\N
295414	1678	17280636489000	16454	8339	17	0	\N
295415	1678	17280636490000	16454	8339	18	0	\N
295416	1678	17280636491000	16454	8339	19	0	\N
295417	1678	17280636492000	16454	8339	20	0	\N
295418	1678	17280636493000	16454	8339	21	0	\N
295419	1678	17280636494000	16454	8339	22	0	\N
295420	1678	17280636495000	16454	8339	23	0	\N
295421	1678	17280636496000	16454	8339	24	0	\N
295422	1678	17280636497000	16454	8339	25	0	\N
295423	1678	17280636498000	16454	8339	26	0	\N
295424	1678	17280636499000	16454	8339	27	0	\N
295425	1678	17280636500000	16454	8339	28	0	\N
295426	1678	17280636501000	16454	8339	29	0	\N
295427	1678	17280636502000	16454	8339	30	0	\N
295428	1678	17280636503000	16454	8339	32	0	\N
295429	1678	17280636504000	16454	8339	33	0	\N
295430	1678	17280636505000	16454	8339	34	0	\N
295431	1678	17280636506000	16454	8339	35	0	\N
295432	1678	17280636507000	16454	8339	36	0	\N
295433	1678	17280636508000	16454	8339	37	0	\N
295434	1678	17280636509000	16454	8339	38	0	\N
295435	1678	17280636510000	16454	8339	39	0	\N
295436	1678	17280636511000	16454	8339	40	0	\N
295437	1678	17280636512000	16454	8339	41	0	\N
295438	1678	17280636513000	16454	8339	42	0	\N
295439	1678	17280636514000	16454	8339	43	0	\N
295440	1678	17280636515000	16454	8339	44	0	\N
295441	1874	3328000	16454	8339	45	0	\N
295442	1874	3331000	16454	8339	48	0	\N
295443	1874	3332000	16454	8339	49	0	\N
295444	1874	3333000	16454	8339	50	0	\N
295445	1874	3336000	16454	8339	51	0	\N
295446	1874	3339000	16454	8339	52	0	\N
295447	1874	3342000	16454	8339	53	0	\N
295448	1874	3345000	16454	8339	54	0	\N
295449	1874	3348000	16454	8339	55	0	\N
295450	1874	3351000	16454	8339	56	0	\N
295451	1874	3354000	16454	8339	57	0	\N
295452	1874	3356000	16454	8339	58	0	\N
295453	1874	3358000	16454	8339	59	0	\N
295454	1874	3360000	16454	8339	60	0	\N
295455	1874	3363000	16454	8339	64	0	\N
295456	1874	3366000	16454	8339	65	0	\N
295457	1874	3367000	16454	8339	66	0	\N
295458	1874	3368000	16454	8339	67	0	\N
295459	1874	3369000	16454	8339	68	0	\N
295460	1874	3370000	16454	8339	69	0	\N
295461	1874	3371000	16454	8339	70	0	\N
295462	1874	3372000	16454	8339	71	0	\N
295463	1874	3373000	16454	8339	72	0	\N
295464	1874	3374000	16454	8339	73	0	\N
295465	1874	3375000	16454	8339	74	0	\N
295466	1874	3376000	16454	8339	75	0	\N
295467	1874	3377000	16454	8339	76	0	\N
295468	1874	3380000	16454	8339	77	0	\N
295469	1874	3383000	16454	8339	78	0	\N
295470	1874	3386000	16454	8339	79	0	\N
295471	1874	3389000	16454	8339	80	0	\N
295472	1874	3392000	16454	8339	81	0	\N
295473	1874	3395000	16454	8339	82	0	\N
295474	1874	3398000	16454	8339	83	0	\N
295475	1874	3401000	16454	8339	84	0	\N
295476	1874	3404000	16454	8339	85	0	\N
295477	1874	3407000	16454	8339	86	0	\N
295478	1874	3410000	16454	8339	87	0	\N
295479	1874	3413000	16454	8339	88	0	\N
295480	1874	3416000	16454	8339	89	0	\N
295481	1874	3419000	16454	8339	90	0	\N
295482	1874	3422000	16454	8339	91	0	\N
295483	1874	3425000	16454	8339	92	0	\N
295484	1874	3428000	16454	8339	93	0	\N
295485	1874	3431000	16454	8339	94	0	\N
295486	1874	3434000	16454	8339	95	0	\N
295487	1874	3437000	16454	8339	96	0	\N
295488	1874	3440000	16454	8339	97	0	\N
295489	1874	3443000	16454	8339	98	0	\N
295490	1874	3446000	16454	8339	99	0	\N
295491	1874	3449000	16454	8339	100	0	\N
295492	1874	3452000	16454	8339	101	0	\N
295493	1874	3455000	16454	8339	102	0	\N
295494	1874	3458000	16454	8339	103	0	\N
295495	1874	3461000	16454	8339	104	0	\N
295496	1874	3464000	16454	8339	105	0	\N
295497	1874	3467000	16454	8339	106	0	\N
295498	1874	3470000	16454	8339	107	0	\N
295499	1874	3472000	16454	8339	108	0	\N
295500	1874	3474000	16454	8339	109	0	\N
295501	1874	3476000	16454	8339	110	0	\N
295502	1874	3478000	16454	8339	111	0	\N
295503	1874	3480000	16454	8339	112	0	\N
295504	1874	3482000	16454	8339	113	0	\N
295505	1874	3484000	16454	8339	114	0	\N
295506	1874	3486000	16454	8339	115	0	\N
295507	1874	3488000	16454	8339	116	0	\N
295508	1874	3490000	16454	8339	117	0	\N
295509	1874	3492000	16454	8339	118	0	\N
295510	1874	3494000	16454	8339	119	0	\N
295511	1874	3496000	16454	8339	120	0	\N
295512	1874	3498000	16454	8339	121	0	\N
295513	1874	3500000	16454	8339	122	0	\N
295514	1874	3502000	16454	8339	123	0	\N
295515	1874	3504000	16454	8339	124	0	\N
295516	1874	3506000	16454	8339	125	0	\N
295523	1678	18000647517000	16457	8370	0	0	\N
295524	1874	3547000	16457	8370	1	0	\N
295525	1874	3550000	16457	8370	2	0	\N
295519	1874	3545000	16455	8369	2	0	2
295520	1678	18000647517000	16456	8370	0	0	0
295521	1874	3547000	16456	8370	1	0	2
295522	1874	3550000	16456	8370	2	0	2
295526	1678	18000647518000	16458	8371	0	0	0
295528	1678	18000647520000	16458	8371	2	0	0
295540	1678	18000647521000	16460	8372	0	0	\N
295541	1874	3568000	16460	8372	1	0	\N
295542	1874	3571000	16460	8372	2	0	\N
295543	1874	3572000	16460	8372	3	0	\N
295544	1678	18000647522000	16461	8373	0	0	\N
295545	1874	3574000	16461	8373	1	0	\N
295546	1874	3577000	16461	8373	2	0	\N
295552	1678	18000647523000	16464	8374	0	0	\N
295553	1874	3579000	16464	8374	1	0	\N
295557	1678	18000647525000	16466	8376	0	0	\N
295558	1874	3585000	16466	8376	1	0	\N
295559	1874	3588000	16466	8376	2	0	\N
295560	1874	3590000	16466	8376	3	0	\N
295561	1678	18000647525000	16467	8376	0	0	\N
295562	1874	3585000	16467	8376	1	0	\N
295563	1874	3588000	16467	8376	2	0	\N
295564	1874	3590000	16467	8376	3	0	\N
295569	1678	18000647525000	16469	8376	0	0	\N
295570	1874	3585000	16469	8376	1	0	\N
295571	1874	3588000	16469	8376	2	0	\N
295572	1874	3590000	16469	8376	3	0	\N
295576	1678	18000647526000	16471	8377	0	0	\N
295577	1874	3593000	16471	8377	1	0	\N
295578	1874	3595000	16471	8377	2	0	\N
295579	2150	200000000	16472	8331	0	0	\N
295580	2151	200000000	16472	8331	1	0	\N
295581	1860	107501010000000	16472	8331	2	0	\N
295582	1678	18000647527000	16473	8378	0	0	\N
295583	1874	3598000	16473	8378	1	0	\N
295584	1874	3600000	16473	8378	2	0	\N
295588	1678	18000647527000	16475	8378	0	0	\N
295589	1874	3598000	16475	8378	1	0	\N
295590	1874	3600000	16475	8378	2	0	\N
295598	1678	18000647530000	16478	8381	0	0	\N
295599	1874	3613000	16478	8381	1	0	\N
295600	1874	3616000	16478	8381	2	0	\N
295604	1678	18000647530000	16480	8381	0	0	\N
295605	1874	3613000	16480	8381	1	0	\N
295606	1874	3616000	16480	8381	2	0	\N
295607	1678	18000647530000	16481	8381	0	0	\N
295608	1874	3613000	16481	8381	1	0	\N
295609	1874	3616000	16481	8381	2	0	\N
295628	1678	18000647536000	16484	8384	0	0	\N
295629	1874	3646000	16484	8384	1	0	\N
295630	1874	3648000	16484	8384	2	0	\N
295631	1678	18000647536000	16485	8384	0	0	\N
295632	1874	3646000	16485	8384	1	0	\N
295633	1874	3648000	16485	8384	2	0	\N
295634	1678	18000647536000	16486	8384	0	0	\N
295635	1874	3646000	16486	8384	1	0	\N
295636	1874	3648000	16486	8384	2	0	\N
295637	1678	18000647536000	16487	8384	0	0	\N
295638	1874	3646000	16487	8384	1	0	\N
295639	1874	3648000	16487	8384	2	0	\N
295654	1860	107499988700000	16492	8387	0	0	\N
295655	1678	18000647539000	16492	8387	1	0	\N
295656	1874	3662000	16492	8387	2	0	\N
295657	1874	3664000	16492	8387	3	0	\N
295664	1678	18000647542000	16494	8389	0	0	\N
295531	1874	3555000	16458	8371	5	0	2
295532	1874	3557000	16458	8371	6	0	2
295533	1874	3560000	16458	8371	7	0	2
295534	1874	3563000	16458	8371	8	0	2
295535	1874	3566000	16458	8371	9	0	2
295537	1874	3568000	16459	8372	1	0	2
295538	1874	3571000	16459	8372	2	0	2
295539	1874	3572000	16459	8372	3	0	2
295547	1678	18000647522000	16462	8373	0	0	0
295548	1874	3574000	16462	8373	1	0	2
295550	1678	18000647523000	16463	8374	0	0	0
295551	1874	3579000	16463	8374	1	0	2
295554	1678	18000647524000	16465	8375	0	0	0
295555	1874	3581000	16465	8375	1	0	2
295565	1678	18000647525000	16468	8376	0	0	0
295566	1874	3585000	16468	8376	1	0	2
295567	1874	3588000	16468	8376	2	0	2
295568	1874	3590000	16468	8376	3	0	2
295573	1678	18000647526000	16470	8377	0	0	0
295575	1874	3595000	16470	8377	2	0	2
295585	1678	18000647527000	16474	8378	0	0	0
295586	1874	3598000	16474	8378	1	0	2
295587	1874	3600000	16474	8378	2	0	2
295591	1678	18000647528000	16476	8379	0	0	0
295593	1874	3603000	16476	8379	2	0	2
295594	1874	3606000	16476	8379	3	0	2
295595	1678	18000647529000	16477	8380	0	0	0
295596	1874	3609000	16477	8380	1	0	2
295601	1678	18000647530000	16479	8381	0	0	0
295602	1874	3613000	16479	8381	1	0	2
295603	1874	3616000	16479	8381	2	0	2
295610	1678	18000647531000	16482	8382	0	0	0
295611	1874	3619000	16482	8382	1	0	2
295613	1874	3622000	16482	8382	3	0	2
295614	1678	18000647532000	16483	8383	0	0	0
295615	2152	12300000	16483	8383	1	0	0
295616	1678	18000647533000	16483	8383	2	0	0
295617	1678	18000647534000	16483	8383	4	0	0
295619	1874	3624000	16483	8383	6	0	2
295620	1874	3625000	16483	8383	7	0	2
295621	1874	3627000	16483	8383	8	0	2
295622	1874	3630000	16483	8383	9	0	2
295624	1874	3636000	16483	8383	11	0	2
295625	1874	3639000	16483	8383	12	0	2
295626	1874	3641000	16483	8383	13	0	2
295627	1874	3643000	16483	8383	14	0	2
295640	1678	18000647536000	16488	8384	0	0	0
295642	1874	3648000	16488	8384	2	0	2
295643	1678	18000647537000	16489	8385	0	0	0
295644	1874	3650000	16489	8385	1	0	2
295645	1874	3653000	16489	8385	2	0	2
295646	1678	18000647538000	16490	8386	0	0	0
295648	1874	3657000	16490	8386	2	0	2
295649	1874	3659000	16490	8386	3	0	2
295650	1860	107499988700000	16491	8387	0	0	3
295651	1678	18000647539000	16491	8387	1	0	0
295653	1874	3664000	16491	8387	3	0	2
295658	1678	18000647540000	16493	8388	0	0	0
295659	1678	18000647541000	16493	8388	1	0	0
295660	1874	3666000	16493	8388	2	0	2
295661	1874	3669000	16493	8388	3	0	2
295663	1874	3674000	16493	8388	5	0	2
295665	1874	3676000	16494	8389	1	0	\N
295666	1874	3679000	16494	8389	2	0	\N
295667	1874	3680000	16494	8389	3	0	\N
295696	1678	18000647549000	16500	8394	0	0	\N
295697	1874	3720000	16500	8394	1	0	\N
295698	1874	3722000	16500	8394	2	0	\N
295702	1678	18000647550000	16502	8395	0	0	\N
295703	1678	18000647551000	16502	8395	1	0	\N
295704	1678	18000647552000	16502	8395	2	0	\N
295705	1874	3724000	16502	8395	3	0	\N
295706	1874	3727000	16502	8395	4	0	\N
295707	1874	3729000	16502	8395	5	0	\N
295708	1874	3732000	16502	8395	6	0	\N
295709	1874	3733000	16502	8395	7	0	\N
295718	1678	18000647550000	16504	8395	0	0	\N
295719	1678	18000647551000	16504	8395	1	0	\N
295720	1678	18000647552000	16504	8395	2	0	\N
295721	1874	3724000	16504	8395	3	0	\N
295722	1874	3727000	16504	8395	4	0	\N
295723	1874	3729000	16504	8395	5	0	\N
295724	1874	3732000	16504	8395	6	0	\N
295725	1874	3733000	16504	8395	7	0	\N
295726	1678	18000647553000	16505	8396	0	0	\N
295727	1874	3736000	16505	8396	1	0	\N
295728	1874	3738000	16505	8396	2	0	\N
295750	1678	18000647557000	16509	8398	0	0	\N
295751	1678	18000647558000	16509	8398	1	0	\N
295752	1874	3755000	16509	8398	2	0	\N
295753	1874	3757000	16509	8398	3	0	\N
295754	1874	3759000	16509	8398	4	0	\N
295755	1874	3762000	16509	8398	5	0	\N
295756	1874	3765000	16509	8398	6	0	\N
295773	1678	18000647564000	16511	8400	0	0	\N
295774	1874	3792000	16511	8400	1	0	\N
295775	1874	3795000	16511	8400	2	0	\N
295776	1874	3797000	16511	8400	3	0	\N
295777	1678	18000647564000	16512	8400	0	0	\N
295778	1874	3792000	16512	8400	1	0	\N
295779	1874	3795000	16512	8400	2	0	\N
295780	1874	3797000	16512	8400	3	0	\N
295785	1678	18000647564000	16514	8400	0	0	\N
295786	1874	3792000	16514	8400	1	0	\N
295787	1874	3795000	16514	8400	2	0	\N
295788	1874	3797000	16514	8400	3	0	\N
295789	1678	18000647564000	16515	8400	0	0	\N
295790	1874	3792000	16515	8400	1	0	\N
295791	1874	3795000	16515	8400	2	0	\N
295792	1874	3797000	16515	8400	3	0	\N
295793	1678	18000647565000	16516	8401	0	0	\N
295794	1874	3799000	16516	8401	1	0	\N
295795	1874	3802000	16516	8401	2	0	\N
295796	1678	18000647565000	16517	8401	0	0	\N
295797	1874	3799000	16517	8401	1	0	\N
295798	1874	3802000	16517	8401	2	0	\N
295670	1874	3679000	16495	8389	2	0	2
295671	1874	3680000	16495	8389	3	0	2
295672	2152	107499001300000	16496	8390	0	0	1
295673	1678	18000647543000	16496	8390	1	0	0
295674	1678	18000647544000	16496	8390	2	0	0
295676	1874	3682000	16496	8390	4	0	2
295677	1874	3683000	16496	8390	5	0	2
295678	1874	3685000	16496	8390	6	0	2
295679	1874	3687000	16496	8390	7	0	2
295680	1874	3689000	16496	8390	8	0	2
295682	1874	3695000	16496	8390	10	0	2
295683	1874	3698000	16496	8390	11	0	2
295684	1874	3701000	16496	8390	12	0	2
295685	1678	18000647546000	16497	8391	0	0	0
295687	1874	3706000	16497	8391	2	0	2
295688	1678	18000647547000	16498	8392	0	0	0
295689	1874	3709000	16498	8392	1	0	2
295690	1874	3710000	16498	8392	2	0	2
295691	1874	3712000	16498	8392	3	0	2
295693	1678	18000647548000	16499	8393	1	0	0
295694	1874	3714000	16499	8393	2	0	2
295695	1874	3717000	16499	8393	3	0	2
295699	1678	18000647549000	16501	8394	0	0	0
295700	1874	3720000	16501	8394	1	0	2
295710	1678	18000647550000	16503	8395	0	0	0
295711	1678	18000647551000	16503	8395	1	0	0
295712	1678	18000647552000	16503	8395	2	0	0
295713	1874	3724000	16503	8395	3	0	2
295715	1874	3729000	16503	8395	5	0	2
295716	1874	3732000	16503	8395	6	0	2
295717	1874	3733000	16503	8395	7	0	2
295729	1678	18000647553000	16506	8396	0	0	0
295730	1874	3736000	16506	8396	1	0	2
295732	1678	18000647554000	16507	8397	0	0	0
295733	1678	18000647555000	16507	8397	1	0	0
295734	1678	18000647556000	16507	8397	2	0	0
295735	2154	200000000	16507	8397	3	0	0
295736	1874	3741000	16507	8397	4	0	2
295738	1874	3747000	16507	8397	6	0	2
295739	1874	3749000	16507	8397	7	0	2
295740	1874	3751000	16507	8397	8	0	2
295741	1874	3753000	16507	8397	9	0	2
295743	1678	18000647557000	16508	8398	0	0	0
295744	1678	18000647558000	16508	8398	1	0	0
295745	1874	3755000	16508	8398	2	0	2
295746	1874	3757000	16508	8398	3	0	2
295747	1874	3759000	16508	8398	4	0	2
295749	1874	3765000	16508	8398	6	0	2
295757	1678	18000647559000	16510	8399	0	0	0
295758	1678	18000647560000	16510	8399	1	0	0
295759	1678	18000647561000	16510	8399	2	0	0
295760	1678	18000647562000	16510	8399	3	0	0
295762	1874	3766000	16510	8399	6	0	2
295763	1874	3768000	16510	8399	7	0	2
295764	1874	3771000	16510	8399	8	0	2
295765	1874	3773000	16510	8399	9	0	2
295767	1874	3778000	16510	8399	11	0	2
295768	1874	3781000	16510	8399	12	0	2
295769	1874	3784000	16510	8399	13	0	2
295770	1874	3787000	16510	8399	14	0	2
295771	1874	3789000	16510	8399	15	0	2
295781	1678	18000647564000	16513	8400	0	0	0
295782	1874	3792000	16513	8400	1	0	2
295783	1874	3795000	16513	8400	2	0	2
295784	1874	3797000	16513	8400	3	0	2
295799	1678	18000647565000	16518	8401	0	0	0
295801	1678	18000647566000	16519	8402	0	0	\N
295802	1874	3803000	16519	8402	1	0	\N
295803	1874	3805000	16519	8402	2	0	\N
295804	1874	3807000	16519	8402	3	0	\N
295813	1678	18000647567000	16522	8403	0	0	\N
295814	1874	3809000	16522	8403	1	0	\N
295815	1874	3812000	16522	8403	2	0	\N
295816	1874	3813000	16522	8403	3	0	\N
295817	2152	12300000	16523	8234	0	0	\N
295818	1860	107499987700000	16523	8234	1	0	\N
295819	1678	18000647567000	16524	8403	0	0	\N
295820	1874	3809000	16524	8403	1	0	\N
295821	1874	3812000	16524	8403	2	0	\N
295822	1874	3813000	16524	8403	3	0	\N
295841	1678	18000647573000	16529	8407	0	0	\N
295842	1874	3836000	16529	8407	1	0	\N
295843	1874	3839000	16529	8407	2	0	\N
295844	1678	18000647573000	16530	8407	0	0	\N
295845	1874	3836000	16530	8407	1	0	\N
295846	1874	3839000	16530	8407	2	0	\N
295847	1678	18000647574000	16531	8408	0	0	\N
295848	1678	18000647575000	16531	8408	1	0	\N
295849	1874	3842000	16531	8408	2	0	\N
295850	1874	3845000	16531	8408	3	0	\N
295851	1874	3847000	16531	8408	4	0	\N
295852	1874	3848000	16531	8408	5	0	\N
295853	1874	3850000	16531	8408	6	0	\N
295861	1678	18000647576000	16533	8409	0	0	\N
295862	1874	3852000	16533	8409	1	0	\N
295863	1874	3855000	16533	8409	2	0	\N
295864	1678	18000647576000	16534	8409	0	0	\N
295865	1874	3852000	16534	8409	1	0	\N
295866	1874	3855000	16534	8409	2	0	\N
295867	1678	18000647576000	16535	8409	0	0	\N
295868	1874	3852000	16535	8409	1	0	\N
295869	1874	3855000	16535	8409	2	0	\N
295873	1678	18000647576000	16537	8409	0	0	\N
295874	1874	3852000	16537	8409	1	0	\N
295875	1874	3855000	16537	8409	2	0	\N
295876	1874	3852000	16538	8409	0	0	\N
295877	1874	3855000	16538	8409	1	0	\N
295892	1678	18000647577000	16544	8410	0	0	\N
295893	2088	77750012300000	16544	8410	1	0	\N
295894	1678	18000647578000	16544	8410	2	0	\N
295895	1678	18000647579000	16544	8410	3	0	\N
295896	1678	18000647580000	16544	8410	4	0	\N
295897	1874	3856000	16544	8410	5	0	\N
295898	1874	3858000	16544	8410	6	0	\N
295899	1874	3860000	16544	8410	7	0	\N
295900	1874	3862000	16544	8410	8	0	\N
295901	1874	3864000	16544	8410	9	0	\N
295902	1874	3867000	16544	8410	10	0	\N
295903	1874	3870000	16544	8410	11	0	\N
295904	1874	3873000	16544	8410	12	0	\N
295905	1874	3876000	16544	8410	13	0	\N
295906	1678	18000647577000	16545	8410	0	0	\N
295907	2088	77750012300000	16545	8410	1	0	\N
295908	1678	18000647578000	16545	8410	2	0	\N
295909	1678	18000647579000	16545	8410	3	0	\N
295910	1678	18000647580000	16545	8410	4	0	\N
295911	1874	3856000	16545	8410	5	0	\N
295912	1874	3858000	16545	8410	6	0	\N
295913	1874	3860000	16545	8410	7	0	\N
295914	1874	3862000	16545	8410	8	0	\N
295915	1874	3864000	16545	8410	9	0	\N
295916	1874	3867000	16545	8410	10	0	\N
295917	1874	3870000	16545	8410	11	0	\N
295918	1874	3873000	16545	8410	12	0	\N
295919	1874	3876000	16545	8410	13	0	\N
295920	1678	18000647577000	16546	8410	0	0	\N
295921	2088	77750012300000	16546	8410	1	0	\N
295922	1678	18000647578000	16546	8410	2	0	\N
295923	1678	18000647579000	16546	8410	3	0	\N
295924	1678	18000647580000	16546	8410	4	0	\N
295925	1874	3856000	16546	8410	5	0	\N
295926	1874	3858000	16546	8410	6	0	\N
295927	1874	3860000	16546	8410	7	0	\N
295928	1874	3862000	16546	8410	8	0	\N
295929	1874	3864000	16546	8410	9	0	\N
295930	1874	3867000	16546	8410	10	0	\N
295931	1874	3870000	16546	8410	11	0	\N
295932	1874	3873000	16546	8410	12	0	\N
295933	1874	3876000	16546	8410	13	0	\N
295934	1678	18000647577000	16547	8410	0	0	\N
295935	2088	77750012300000	16547	8410	1	0	\N
295936	1678	18000647578000	16547	8410	2	0	\N
295807	1874	3805000	16520	8402	2	0	2
295808	1874	3807000	16520	8402	3	0	2
295809	1678	18000647567000	16521	8403	0	0	0
295810	1874	3809000	16521	8403	1	0	2
295811	1874	3812000	16521	8403	2	0	2
295823	1678	18000647568000	16525	8404	0	0	0
295824	1874	3815000	16525	8404	1	0	2
295825	1874	3818000	16525	8404	2	0	2
295826	1678	18000647569000	16526	8405	0	0	0
295827	1678	18000647570000	16526	8405	1	0	0
295829	1874	3823000	16526	8405	3	0	2
295830	1874	3826000	16526	8405	4	0	2
295831	1678	18000647571000	16527	8406	0	0	0
295832	1678	18000647572000	16527	8406	1	0	0
295834	1874	3828000	16527	8406	3	0	2
295835	1874	3830000	16527	8406	4	0	2
295836	1874	3831000	16527	8406	5	0	2
295837	1874	3834000	16527	8406	6	0	2
295838	1678	18000647573000	16528	8407	0	0	0
295840	1874	3839000	16528	8407	2	0	2
295854	1678	18000647574000	16532	8408	0	0	0
295855	1678	18000647575000	16532	8408	1	0	0
295856	1874	3842000	16532	8408	2	0	2
295857	1874	3845000	16532	8408	3	0	2
295859	1874	3848000	16532	8408	5	0	2
295860	1874	3850000	16532	8408	6	0	2
295870	1678	18000647576000	16536	8409	0	0	0
295871	1874	3852000	16536	8409	1	0	2
295878	1678	18000647577000	16542	8410	0	0	0
295879	2088	77750012300000	16542	8410	1	0	0
295880	1678	18000647578000	16542	8410	2	0	0
295881	1678	18000647579000	16542	8410	3	0	0
295882	1678	18000647580000	16542	8410	4	0	0
295884	1874	3858000	16542	8410	6	0	2
295885	1874	3860000	16542	8410	7	0	2
295886	1874	3862000	16542	8410	8	0	2
295887	1874	3864000	16542	8410	9	0	2
295888	1874	3867000	16542	8410	10	0	2
295890	1874	3873000	16542	8410	12	0	2
295891	1874	3876000	16542	8410	13	0	2
295937	1678	18000647579000	16547	8410	3	0	\N
295938	1678	18000647580000	16547	8410	4	0	\N
295939	1874	3856000	16547	8410	5	0	\N
295940	1678	18000647581000	16550	8411	0	0	\N
295941	1874	3878000	16550	8411	1	0	\N
295942	1874	3879000	16550	8411	2	0	\N
295943	1874	3882000	16550	8411	3	0	\N
295944	1678	18000647581000	16551	8411	0	0	\N
295945	1874	3878000	16551	8411	1	0	\N
295946	1874	3879000	16551	8411	2	0	\N
295947	1874	3882000	16551	8411	3	0	\N
295974	1678	18000647588000	16557	8415	0	0	\N
295975	1874	3916000	16557	8415	1	0	\N
295976	1874	3917000	16557	8415	2	0	\N
295977	1678	18000647588000	16558	8415	0	0	\N
295978	1874	3916000	16558	8415	1	0	\N
295979	1874	3917000	16558	8415	2	0	\N
295983	1678	18000647589000	16560	8416	0	0	\N
295984	1874	3919000	16560	8416	1	0	\N
295985	1874	3922000	16560	8416	2	0	\N
295997	2088	77750012300000	16564	8408	0	0	\N
295998	1678	18000647574000	16564	8408	1	0	\N
295999	1678	18000647575000	16564	8408	3	0	\N
296000	1678	18000647576000	16564	8408	4	0	\N
296001	1678	18000647577000	16564	8408	5	0	\N
296002	1678	18000647578000	16564	8408	6	0	\N
296003	1678	18000647579000	16564	8408	7	0	\N
296004	1678	18000647580000	16564	8408	8	0	\N
296005	1678	18000647581000	16564	8408	9	0	\N
296006	1678	18000647582000	16564	8408	10	0	\N
296007	1678	18000647583000	16564	8408	11	0	\N
296008	1678	18000647584000	16564	8408	12	0	\N
296009	1678	18000647585000	16564	8408	13	0	\N
296010	1678	18000647586000	16564	8408	14	0	\N
296011	1678	18000647587000	16564	8408	15	0	\N
296012	1678	18000647588000	16564	8408	16	0	\N
296013	1678	18000647589000	16564	8408	17	0	\N
296014	1678	18000647590000	16564	8408	18	0	\N
296015	1678	18000647591000	16564	8408	19	0	\N
296016	1678	18000647592000	16564	8408	20	0	\N
296017	1678	18000647593000	16564	8408	21	0	\N
296018	1874	3842000	16564	8408	22	0	\N
296019	1874	3845000	16564	8408	23	0	\N
296020	1874	3847000	16564	8408	24	0	\N
296021	1874	3848000	16564	8408	25	0	\N
296022	1874	3849000	16564	8408	26	0	\N
296023	1874	3850000	16564	8408	27	0	\N
296024	1874	3851000	16564	8408	28	0	\N
296025	1874	3853000	16564	8408	29	0	\N
296026	1874	3855000	16564	8408	30	0	\N
296027	1874	3857000	16564	8408	31	0	\N
296028	1874	3859000	16564	8408	32	0	\N
296029	1874	3861000	16564	8408	33	0	\N
296030	1874	3863000	16564	8408	34	0	\N
296031	1874	3865000	16564	8408	35	0	\N
296032	1874	3867000	16564	8408	36	0	\N
296033	1874	3869000	16564	8408	37	0	\N
296034	1874	3871000	16564	8408	38	0	\N
296035	1874	3873000	16564	8408	39	0	\N
296036	1874	3876000	16564	8408	40	0	\N
296037	1874	3879000	16564	8408	41	0	\N
296038	1874	3882000	16564	8408	42	0	\N
296039	1874	3885000	16564	8408	43	0	\N
296040	1874	3888000	16564	8408	44	0	\N
296041	1874	3891000	16564	8408	45	0	\N
296042	1874	3894000	16564	8408	46	0	\N
296043	1874	3896000	16564	8408	47	0	\N
296044	1874	3898000	16564	8408	48	0	\N
296045	1874	3900000	16564	8408	49	0	\N
296046	1874	3902000	16564	8408	50	0	\N
296047	1874	3904000	16564	8408	51	0	\N
296048	1874	3906000	16564	8408	52	0	\N
296049	1874	3908000	16564	8408	53	0	\N
296050	1874	3910000	16564	8408	54	0	\N
296051	1874	3913000	16564	8408	55	0	\N
296052	1874	3916000	16564	8408	56	0	\N
296053	1874	3919000	16564	8408	57	0	\N
296054	1874	3922000	16564	8408	58	0	\N
296055	1874	3925000	16564	8408	59	0	\N
296056	1874	3928000	16564	8408	60	0	\N
296057	1874	3931000	16564	8408	61	0	\N
296058	1874	3934000	16564	8408	62	0	\N
296059	1874	3937000	16564	8408	63	0	\N
296060	1874	3940000	16564	8408	64	0	\N
296061	1874	3943000	16564	8408	66	0	\N
296062	1874	3944000	16564	8408	67	0	\N
296063	1874	3945000	16564	8408	68	0	\N
296064	1874	3946000	16564	8408	69	0	\N
295950	1874	3879000	16552	8411	2	0	2
295951	1874	3882000	16552	8411	3	0	2
295952	1874	3885000	16553	8412	0	0	2
295953	1678	18000647582000	16554	8413	0	0	0
295954	1678	18000647583000	16554	8413	1	0	0
295956	1874	3889000	16554	8413	3	0	2
295957	1874	3892000	16554	8413	4	0	2
295958	1678	18000647584000	16555	8414	0	0	0
295959	1678	18000647585000	16555	8414	1	0	0
295960	1678	18000647586000	16555	8414	2	0	0
295962	1874	3894000	16555	8414	4	0	2
295963	1874	3896000	16555	8414	5	0	2
295964	1874	3897000	16555	8414	6	0	2
295965	1874	3900000	16555	8414	7	0	2
295967	1874	3906000	16555	8414	9	0	2
295968	1874	3909000	16555	8414	10	0	2
295969	1874	3911000	16555	8414	11	0	2
295970	1874	3913000	16555	8414	12	0	2
295971	1678	18000647588000	16556	8415	0	0	0
295973	1874	3917000	16556	8415	2	0	2
295980	1678	18000647589000	16559	8416	0	0	0
295981	1874	3919000	16559	8416	1	0	2
295982	1874	3922000	16559	8416	2	0	2
295986	1678	18000647590000	16561	8417	0	0	0
295988	1874	3927000	16561	8417	2	0	2
295989	1678	18000647591000	16562	8418	0	0	0
295990	1874	3930000	16562	8418	2	0	2
295991	1874	3932000	16562	8418	3	0	2
295993	1874	3935000	16562	8418	5	0	2
295994	1678	18000647592000	16563	8419	0	0	0
295995	1874	3937000	16563	8419	1	0	2
295996	1874	3940000	16563	8419	2	0	2
296065	1678	18000647593000	16565	8420	0	0	0
296067	1874	3944000	16565	8420	2	0	2
296068	1874	3946000	16565	8420	3	0	2
296069	1678	18000647594000	16566	8421	0	0	0
296070	1678	18000647595000	16566	8421	1	0	0
296071	1874	3948000	16566	8421	2	0	2
296079	1678	18000647596000	16568	8422	0	0	\N
296080	2155	10000000	16568	8422	1	0	\N
296081	1874	3959000	16568	8422	2	0	\N
296082	1874	3961000	16568	8422	3	0	\N
296083	1678	18000647596000	16569	8422	0	0	\N
296084	2155	10000000	16569	8422	1	0	\N
296085	1874	3959000	16569	8422	2	0	\N
296086	1874	3961000	16569	8422	3	0	\N
296087	1678	18000647594000	16570	8421	0	0	\N
296088	1678	18000647595000	16570	8421	1	0	\N
296089	1678	18000647596000	16570	8421	2	0	\N
296090	1678	18000647597000	16570	8421	3	0	\N
296091	2155	10000000	16570	8421	4	0	\N
296092	1874	3948000	16570	8421	5	0	\N
296093	1874	3951000	16570	8421	6	0	\N
296094	1874	3954000	16570	8421	7	0	\N
296095	1874	3957000	16570	8421	8	0	\N
296096	1874	3960000	16570	8421	9	0	\N
296097	1874	3961000	16570	8421	10	0	\N
296098	1874	3963000	16570	8421	11	0	\N
296099	1874	3965000	16570	8421	12	0	\N
296100	1874	3967000	16570	8421	13	0	\N
296101	1678	18000647597000	16571	8423	0	0	\N
296102	1678	18000647598000	16571	8423	1	0	\N
296103	2155	10000000	16571	8423	2	0	\N
296104	1874	3964000	16571	8423	3	0	\N
296105	1874	3967000	16571	8423	4	0	\N
296106	1874	3968000	16571	8423	5	0	\N
296107	1874	3970000	16571	8423	6	0	\N
296108	1874	3972000	16571	8423	7	0	\N
296109	1678	18000647597000	16572	8423	0	0	\N
296110	1678	18000647598000	16572	8423	1	0	\N
296111	2155	10000000	16572	8423	2	0	\N
296112	1874	3964000	16572	8423	3	0	\N
296113	1874	3967000	16572	8423	4	0	\N
296114	1874	3968000	16572	8423	5	0	\N
296115	1874	3970000	16572	8423	6	0	\N
296116	1874	3972000	16572	8423	7	0	\N
296132	946	505422075000000	16576	8211	2	0	\N
296133	1066	905711965000000	16576	8211	3	0	\N
296134	1186	611101950000000	16576	8211	4	0	\N
296135	1312	1702889737751650	16576	8211	5	0	\N
296136	2149	9000000000	16576	8211	6	0	\N
296137	2149	9000000000	16576	8211	7	0	\N
296138	2150	200000000	16576	8211	8	0	\N
296139	2152	12300000	16576	8211	9	0	\N
296140	2151	200000000	16576	8211	10	0	\N
296141	2153	200000000	16576	8211	11	0	\N
296142	2154	200000000	16576	8211	12	0	\N
296143	1860	107499987700000	16576	8211	13	0	\N
296144	2155	10000000	16576	8211	15	0	\N
296145	2155	10000000	16576	8211	16	0	\N
296146	937	505422913800000	16576	8211	17	0	\N
296147	1359	1701968237751650	16576	8211	18	0	\N
296158	1678	18000647601000	16578	8426	0	0	\N
296159	1678	18000647602000	16578	8426	1	0	\N
296160	1678	18000647603000	16578	8426	2	0	\N
296161	1874	3984000	16578	8426	3	0	\N
296162	1874	3986000	16578	8426	4	0	\N
296163	1874	3989000	16578	8426	5	0	\N
296164	1874	3991000	16578	8426	6	0	\N
296165	1874	3993000	16578	8426	7	0	\N
296166	1874	3996000	16578	8426	8	0	\N
296167	1874	3999000	16578	8426	9	0	\N
296168	1678	18000647601000	16579	8426	0	0	\N
296169	1678	18000647602000	16579	8426	1	0	\N
296170	1678	18000647603000	16579	8426	2	0	\N
296171	1874	3984000	16579	8426	3	0	\N
296172	1874	3986000	16579	8426	4	0	\N
296173	1874	3989000	16579	8426	5	0	\N
296174	1874	3991000	16579	8426	6	0	\N
296175	1874	3993000	16579	8426	7	0	\N
296176	1874	3996000	16579	8426	8	0	\N
296177	1874	3999000	16579	8426	9	0	\N
296182	1678	18000647604000	16581	8427	0	0	\N
296183	1678	18000647605000	16581	8427	1	0	\N
296184	1874	4002000	16581	8427	2	0	\N
296185	1874	4004000	16581	8427	3	0	\N
296186	1874	4006000	16581	8427	4	0	\N
296187	1874	4009000	16581	8427	5	0	\N
296188	1678	18000647604000	16582	8427	0	0	\N
296189	1678	18000647605000	16582	8427	1	0	\N
296190	1874	4002000	16582	8427	2	0	\N
296191	1874	4004000	16582	8427	3	0	\N
296192	1874	4006000	16582	8427	4	0	\N
296193	1874	4009000	16582	8427	5	0	\N
296194	1678	18000647604000	16583	8427	0	0	\N
296195	1678	18000647605000	16583	8427	1	0	\N
296196	1874	4002000	16583	8427	2	0	\N
296197	1874	4004000	16583	8427	3	0	\N
296198	1874	4006000	16583	8427	4	0	\N
296199	1874	4009000	16583	8427	5	0	\N
296200	1678	18000647601000	16584	8426	0	0	\N
296201	1678	18000647602000	16584	8426	1	0	\N
296202	1678	18000647603000	16584	8426	2	0	\N
296203	1678	18000647604000	16584	8426	3	0	\N
296204	1678	18000647605000	16584	8426	4	0	\N
296205	1874	3984000	16584	8426	5	0	\N
296206	1874	3986000	16584	8426	6	0	\N
296207	1874	3989000	16584	8426	7	0	\N
296208	1874	3991000	16584	8426	8	0	\N
296075	1678	18000647596000	16567	8422	0	0	0
296076	2155	10000000	16567	8422	1	0	0
296077	1874	3959000	16567	8422	2	0	2
296078	1874	3961000	16567	8422	3	0	2
296117	1678	18000647597000	16573	8423	0	0	0
296119	1874	3964000	16573	8423	2	0	2
296120	1874	3967000	16573	8423	3	0	2
296121	1874	3968000	16573	8423	4	0	2
296122	1874	3970000	16573	8423	5	0	2
296123	1678	18000647599000	16574	8424	0	0	0
296125	1874	3973000	16574	8424	2	0	2
296126	1874	3975000	16574	8424	3	0	2
296127	1874	3977000	16574	8424	4	0	2
296128	1678	18000647600000	16575	8425	0	0	0
296130	1874	3982000	16575	8425	2	0	2
296131	1874	3983000	16575	8425	3	0	2
296148	1678	18000647601000	16577	8426	0	0	0
296149	1678	18000647602000	16577	8426	1	0	0
296150	1678	18000647603000	16577	8426	2	0	0
296152	1874	3986000	16577	8426	4	0	2
296153	1874	3989000	16577	8426	5	0	2
296154	1874	3991000	16577	8426	6	0	2
296155	1874	3993000	16577	8426	7	0	2
296156	1874	3996000	16577	8426	8	0	2
296178	1678	18000647604000	16580	8427	0	0	0
296179	1678	18000647605000	16580	8427	1	0	0
296180	1874	4001000	16580	8427	2	0	2
296181	1874	4003000	16580	8427	3	0	2
296209	1874	3993000	16584	8426	9	0	\N
296210	1874	3995000	16584	8426	10	0	\N
296211	1874	3997000	16584	8426	11	0	\N
296220	946	505422075000000	16586	8277	2	0	\N
296221	1066	905711965000000	16586	8277	3	0	\N
296222	1186	611101950000000	16586	8277	4	0	\N
296223	1312	1702889737751650	16586	8277	5	0	\N
296224	2149	9000000000	16586	8277	6	0	\N
296225	2149	9000000000	16586	8277	7	0	\N
296226	2150	200000000	16586	8277	8	0	\N
296227	2152	12300000	16586	8277	9	0	\N
296228	1678	17280636389000	16586	8277	10	0	\N
296229	1678	17280636390000	16586	8277	11	0	\N
296230	1678	17280636391000	16586	8277	12	0	\N
296231	1678	17280636392000	16586	8277	13	0	\N
296232	1678	17280636393000	16586	8277	14	0	\N
296233	1678	17280636394000	16586	8277	15	0	\N
296234	1678	17280636395000	16586	8277	16	0	\N
296235	1678	17280636396000	16586	8277	17	0	\N
296236	1678	17280636397000	16586	8277	18	0	\N
296237	1678	17280636398000	16586	8277	19	0	\N
296238	1678	17280636399000	16586	8277	20	0	\N
296239	1678	17280636400000	16586	8277	21	0	\N
296240	1678	17280636401000	16586	8277	22	0	\N
296241	2151	200000000	16586	8277	23	0	\N
296242	2153	200000000	16586	8277	24	0	\N
296243	2154	200000000	16586	8277	25	0	\N
296244	1860	107499987700000	16586	8277	26	0	\N
296245	1678	17280636402000	16586	8277	28	0	\N
296246	1678	17280636403000	16586	8277	29	0	\N
296247	1678	17280636404000	16586	8277	30	0	\N
296248	2155	10000000	16586	8277	31	0	\N
296249	2155	10000000	16586	8277	32	0	\N
296250	1678	17280636405000	16586	8277	33	0	\N
296251	1678	17280636406000	16586	8277	34	0	\N
296252	1678	17280636407000	16586	8277	35	0	\N
296253	1678	17280636408000	16586	8277	36	0	\N
296254	1678	17280636409000	16586	8277	37	0	\N
296255	1678	17280636410000	16586	8277	38	0	\N
296256	1678	17280636411000	16586	8277	39	0	\N
296257	1678	17280636412000	16586	8277	40	0	\N
296258	1678	17280636413000	16586	8277	41	0	\N
296259	1678	17280636414000	16586	8277	42	0	\N
296260	1678	17280636415000	16586	8277	43	0	\N
296261	1678	17280636416000	16586	8277	44	0	\N
296262	1678	17280636417000	16586	8277	45	0	\N
296263	1678	17280636418000	16586	8277	46	0	\N
296264	1678	17280636419000	16586	8277	47	0	\N
296265	1678	17280636420000	16586	8277	48	0	\N
296266	1678	17280636421000	16586	8277	49	0	\N
296267	1678	17280636422000	16586	8277	50	0	\N
296268	1678	17280636423000	16586	8277	51	0	\N
296269	1678	17280636424000	16586	8277	52	0	\N
296270	1678	17280636425000	16586	8277	53	0	\N
296271	1678	17280636426000	16586	8277	54	0	\N
296272	1678	17280636427000	16586	8277	55	0	\N
296273	1678	17280636428000	16586	8277	56	0	\N
296274	1678	17280636429000	16586	8277	57	0	\N
296275	1678	17280636430000	16586	8277	58	0	\N
296276	1678	17280636431000	16586	8277	59	0	\N
296277	1678	17280636432000	16586	8277	60	0	\N
296278	1678	17280636433000	16586	8277	61	0	\N
296279	1678	17280636434000	16586	8277	62	0	\N
296280	1678	17280636435000	16586	8277	64	0	\N
296281	1678	17280636436000	16586	8277	65	0	\N
296282	1678	17280636437000	16586	8277	66	0	\N
296283	1678	17280636438000	16586	8277	67	0	\N
296284	1678	17280636439000	16586	8277	68	0	\N
296285	1678	17280636440000	16586	8277	69	0	\N
296286	1678	17280636441000	16586	8277	70	0	\N
296287	1678	17280636442000	16586	8277	71	0	\N
296288	1678	17280636443000	16586	8277	72	0	\N
296289	1678	17280636444000	16586	8277	73	0	\N
296290	1678	17280636445000	16586	8277	74	0	\N
296291	1678	17280636446000	16586	8277	75	0	\N
296292	1678	17280636447000	16586	8277	76	0	\N
296293	1678	17280636448000	16586	8277	77	0	\N
296294	1678	17280636449000	16586	8277	78	0	\N
296295	1678	17280636450000	16586	8277	79	0	\N
296296	1678	17280636451000	16586	8277	80	0	\N
296297	1678	17280636452000	16586	8277	81	0	\N
296298	1678	17280636453000	16586	8277	82	0	\N
296299	1678	17280636454000	16586	8277	83	0	\N
296300	1678	17280636455000	16586	8277	84	0	\N
296301	1678	17280636456000	16586	8277	85	0	\N
296302	1678	17280636457000	16586	8277	86	0	\N
296303	1678	17280636458000	16586	8277	87	0	\N
296304	1678	17280636459000	16586	8277	88	0	\N
296305	1678	17280636460000	16586	8277	89	0	\N
296306	1678	17280636461000	16586	8277	90	0	\N
296307	1678	17280636462000	16586	8277	91	0	\N
296308	1678	17280636463000	16586	8277	92	0	\N
296309	1678	17280636464000	16586	8277	93	0	\N
296310	1678	17280636465000	16586	8277	94	0	\N
296311	1678	17280636466000	16586	8277	95	0	\N
296312	1678	17280636467000	16586	8277	96	0	\N
296313	1678	17280636468000	16586	8277	97	0	\N
296314	1678	17280636469000	16586	8277	98	0	\N
296315	1678	17280636470000	16586	8277	99	0	\N
296316	1678	17280636471000	16586	8277	100	0	\N
296317	1678	17280636472000	16586	8277	101	0	\N
296318	1678	17280636473000	16586	8277	102	0	\N
296319	1678	17280636474000	16586	8277	103	0	\N
296320	1678	17280636475000	16586	8277	104	0	\N
296321	1678	17280636476000	16586	8277	105	0	\N
296322	1678	17280636477000	16586	8277	106	0	\N
296323	1678	17280636478000	16586	8277	107	0	\N
296324	1678	17280636479000	16586	8277	108	0	\N
296325	1678	17280636480000	16586	8277	109	0	\N
296326	1678	17280636481000	16586	8277	110	0	\N
296327	1678	17280636482000	16586	8277	111	0	\N
296328	1678	17280636483000	16586	8277	112	0	\N
296329	1678	17280636484000	16586	8277	113	0	\N
296330	1678	17280636485000	16586	8277	114	0	\N
296331	1678	17280636486000	16586	8277	115	0	\N
296332	1678	17280636487000	16586	8277	116	0	\N
296333	1678	17280636488000	16586	8277	117	0	\N
296334	1678	17280636489000	16586	8277	118	0	\N
296335	1678	17280636490000	16586	8277	119	0	\N
296336	1678	17280636491000	16586	8277	120	0	\N
296337	1678	17280636492000	16586	8277	121	0	\N
296338	1678	17280636493000	16586	8277	122	0	\N
296339	1678	17280636494000	16586	8277	123	0	\N
296340	1678	17280636495000	16586	8277	124	0	\N
296341	1678	17280636496000	16586	8277	125	0	\N
296342	1678	18000647608000	16587	8429	0	0	\N
296343	1678	18000647609000	16587	8429	1	0	\N
296344	1874	4020000	16587	8429	2	0	\N
296214	1874	4006000	16585	8428	2	0	2
296215	1874	4007000	16585	8428	3	0	2
296216	1874	4009000	16585	8428	4	0	2
296217	1874	4012000	16585	8428	5	0	2
296218	1874	4015000	16585	8428	6	0	2
296345	1874	4023000	16587	8429	3	0	\N
296346	1874	4026000	16587	8429	4	0	\N
296347	1874	4028000	16587	8429	5	0	\N
296364	1136	908817465000000	16591	8431	0	0	\N
296365	1256	613196750000000	16591	8431	1	0	\N
296369	1678	18000647612000	16593	8432	0	0	\N
296370	1874	4042000	16593	8432	1	0	\N
296371	1874	4044000	16593	8432	2	0	\N
296372	1678	18000647612000	16594	8432	0	0	\N
296373	1874	4042000	16594	8432	1	0	\N
296374	1874	4044000	16594	8432	2	0	\N
296375	1382	1708727637751650	16595	8212	0	0	\N
296376	1136	908817465000000	16595	8212	1	0	\N
296377	1256	613196750000000	16595	8212	2	0	\N
296378	1016	507154775000000	16595	8212	3	0	\N
296383	1678	18000647613000	16597	8433	1	0	\N
296384	1874	4045000	16597	8433	2	0	\N
296385	1874	4047000	16597	8433	3	0	\N
296386	1874	4050000	16597	8433	4	0	\N
296387	1678	18000647614000	16598	8434	0	0	\N
296388	1874	4052000	16598	8434	2	0	\N
296389	1874	4055000	16598	8434	3	0	\N
296390	1678	18000647614000	16599	8434	0	0	\N
296391	1874	4052000	16599	8434	2	0	\N
296392	1874	4055000	16599	8434	3	0	\N
296400	1678	18000647616000	16603	8436	0	0	\N
296401	1874	4062000	16603	8436	1	0	\N
296402	1874	4065000	16603	8436	2	0	\N
296403	1678	18000647616000	16604	8436	0	0	\N
296404	1874	4062000	16604	8436	1	0	\N
296405	1874	4065000	16604	8436	2	0	\N
296406	1678	18000647616000	16605	8436	0	0	\N
296407	1874	4062000	16605	8436	1	0	\N
296408	1874	4065000	16605	8436	2	0	\N
296409	1678	18000647616000	16606	8436	0	0	\N
296410	1874	4062000	16606	8436	1	0	\N
296411	1874	4065000	16606	8436	2	0	\N
296412	1678	18000647616000	16607	8436	0	0	\N
296413	1874	4062000	16607	8436	1	0	\N
296414	1874	4065000	16607	8436	2	0	\N
296415	1678	18000647616000	16608	8436	0	0	\N
296416	1874	4062000	16608	8436	1	0	\N
296417	1874	4065000	16608	8436	2	0	\N
296418	1678	18000647616000	16609	8436	0	0	\N
296419	1874	4062000	16609	8436	1	0	\N
296420	1874	4065000	16609	8436	2	0	\N
296421	1382	1708727637751650	16610	8427	0	0	\N
296422	1136	908817465000000	16610	8427	1	0	\N
296423	1256	613196750000000	16610	8427	2	0	\N
296424	1016	507154775000000	16610	8427	3	0	\N
296425	1678	18000647606000	16610	8427	4	0	\N
296426	1678	18000647607000	16610	8427	5	0	\N
296427	1678	18000647608000	16610	8427	6	0	\N
296428	1678	18000647609000	16610	8427	7	0	\N
296429	1678	18000647610000	16610	8427	8	0	\N
296430	1678	18000647611000	16610	8427	9	0	\N
296431	1678	18000647612000	16610	8427	10	0	\N
296432	1678	18000647613000	16610	8427	11	0	\N
296433	1678	18000647614000	16610	8427	12	0	\N
296434	1678	18000647615000	16610	8427	13	0	\N
296435	1678	18000647616000	16610	8427	14	0	\N
296436	1874	3998000	16610	8427	15	0	\N
296437	1874	3999000	16610	8427	16	0	\N
296438	1874	4000000	16610	8427	17	0	\N
296439	1874	4002000	16610	8427	18	0	\N
296440	1874	4004000	16610	8427	19	0	\N
296441	1874	4006000	16610	8427	20	0	\N
296442	1874	4008000	16610	8427	21	0	\N
296443	1874	4010000	16610	8427	22	0	\N
296444	1874	4012000	16610	8427	23	0	\N
296445	1874	4014000	16610	8427	24	0	\N
296446	1874	4016000	16610	8427	25	0	\N
296447	1874	4018000	16610	8427	26	0	\N
296448	1874	4020000	16610	8427	27	0	\N
296472	1678	18000647623000	16620	8443	0	0	\N
296473	1874	4100000	16620	8443	1	0	\N
296474	1874	4102000	16620	8443	2	0	\N
296478	1678	18000647623000	16622	8443	0	0	\N
296479	1874	4100000	16622	8443	1	0	\N
296480	1874	4102000	16622	8443	2	0	\N
296350	1874	4020000	16588	8429	2	0	2
296351	1874	4023000	16588	8429	3	0	2
296352	1874	4026000	16588	8429	4	0	2
296353	1874	4028000	16588	8429	5	0	2
296354	1382	1708727637751650	16589	8430	0	0	0
296356	1874	4029000	16589	8430	2	0	2
296357	1874	4031000	16589	8430	3	0	2
296358	1874	4034000	16589	8430	4	0	2
296359	1136	908817465000000	16590	8431	0	0	0
296360	1256	613196750000000	16590	8431	1	0	0
296362	1874	4036000	16590	8431	3	0	2
296363	1874	4039000	16590	8431	4	0	2
296366	1678	18000647612000	16592	8432	0	0	0
296367	1874	4042000	16592	8432	1	0	2
296379	1678	18000647613000	16596	8433	1	0	0
296380	1874	4045000	16596	8433	2	0	2
296381	1874	4047000	16596	8433	3	0	2
296382	1874	4050000	16596	8433	4	0	2
296393	1678	18000647614000	16600	8434	0	0	0
296395	1874	4055000	16600	8434	3	0	2
296396	1678	18000647615000	16601	8435	0	0	0
296397	1874	4058000	16601	8435	1	0	2
296398	1874	4060000	16601	8435	2	0	2
296399	1874	4063000	16602	8436	0	0	2
296450	1678	18000647617000	16611	8437	1	0	0
296451	1874	4064000	16611	8437	2	0	2
296452	1874	4066000	16611	8437	3	0	2
296453	1874	4068000	16611	8437	4	0	2
296455	1678	18000647618000	16612	8438	0	0	0
296456	1874	4073000	16612	8438	1	0	2
296457	1874	4076000	16612	8438	2	0	2
296458	1678	18000647619000	16613	8439	0	0	0
296459	1874	4078000	16613	8439	1	0	2
296461	1678	18000647620000	16614	8440	0	0	0
296462	1874	4084000	16614	8440	1	0	2
296463	1874	4086000	16614	8440	2	0	2
296464	1874	4087000	16614	8440	3	0	2
296465	1678	18000647621000	16616	8441	0	0	0
296467	1874	4092000	16616	8441	2	0	2
296468	1016	507154775000000	16619	8442	0	0	0
296469	1678	18000647622000	16619	8442	1	0	0
296470	1874	4095000	16619	8442	2	0	2
296475	1678	18000647623000	16621	8443	0	0	0
296476	1874	4100000	16621	8443	1	0	2
296477	1874	4102000	16621	8443	2	0	2
296481	1382	1708727637751650	16623	8389	0	0	\N
296482	1136	908817465000000	16623	8389	1	0	\N
296483	1256	613196750000000	16623	8389	2	0	\N
296484	1016	507154775000000	16623	8389	3	0	\N
296485	2152	107499001300000	16623	8389	4	0	\N
296486	2153	200000000	16623	8389	5	0	\N
296487	2154	200000000	16623	8389	6	0	\N
296488	1678	18000647542000	16623	8389	7	0	\N
296489	1678	18000647543000	16623	8389	8	0	\N
296490	1678	18000647544000	16623	8389	9	0	\N
296491	1678	18000647545000	16623	8389	10	0	\N
296492	1678	18000647546000	16623	8389	11	0	\N
296493	1678	18000647547000	16623	8389	12	0	\N
296494	1678	18000647548000	16623	8389	13	0	\N
296495	1678	18000647549000	16623	8389	14	0	\N
296496	1678	18000647550000	16623	8389	15	0	\N
296497	1678	18000647551000	16623	8389	16	0	\N
296498	1678	18000647552000	16623	8389	17	0	\N
296499	1678	18000647553000	16623	8389	18	0	\N
296500	1678	18000647554000	16623	8389	19	0	\N
296501	1678	18000647555000	16623	8389	20	0	\N
296502	1678	18000647556000	16623	8389	21	0	\N
296503	1678	18000647557000	16623	8389	22	0	\N
296504	1678	18000647558000	16623	8389	23	0	\N
296505	1678	18000647559000	16623	8389	25	0	\N
296506	1678	18000647560000	16623	8389	26	0	\N
296507	1678	18000647561000	16623	8389	27	0	\N
296508	1678	18000647562000	16623	8389	28	0	\N
296509	1678	18000647563000	16623	8389	29	0	\N
296510	1678	18000647564000	16623	8389	30	0	\N
296511	1678	18000647565000	16623	8389	31	0	\N
296512	1678	18000647566000	16623	8389	32	0	\N
296513	1678	18000647567000	16623	8389	33	0	\N
296514	1678	18000647568000	16623	8389	34	0	\N
296515	1678	18000647569000	16623	8389	35	0	\N
296516	1678	18000647570000	16623	8389	36	0	\N
296517	1678	18000647571000	16623	8389	37	0	\N
296518	1678	18000647572000	16623	8389	38	0	\N
296519	1678	18000647573000	16623	8389	39	0	\N
296520	1678	18000647574000	16623	8389	40	0	\N
296521	1678	18000647575000	16623	8389	41	0	\N
296522	2155	10000000	16623	8389	42	0	\N
296523	2155	10000000	16623	8389	43	0	\N
296524	1678	18000647576000	16623	8389	44	0	\N
296525	1678	18000647577000	16623	8389	45	0	\N
296526	1678	18000647578000	16623	8389	46	0	\N
296527	1678	18000647579000	16623	8389	47	0	\N
296528	1678	18000647580000	16623	8389	48	0	\N
296529	1678	18000647581000	16623	8389	49	0	\N
296530	1678	18000647582000	16623	8389	50	0	\N
296531	1678	18000647583000	16623	8389	51	0	\N
296532	1678	18000647584000	16623	8389	52	0	\N
296533	1678	18000647585000	16623	8389	53	0	\N
296534	1678	18000647586000	16623	8389	54	0	\N
296535	1678	18000647587000	16623	8389	55	0	\N
296536	1678	18000647588000	16623	8389	56	0	\N
296537	1678	18000647589000	16623	8389	57	0	\N
296538	1678	18000647590000	16623	8389	58	0	\N
296539	1678	18000647591000	16623	8389	59	0	\N
296540	1678	18000647592000	16623	8389	60	0	\N
296541	1678	18000647593000	16623	8389	61	0	\N
296542	1678	18000647594000	16623	8389	62	0	\N
296543	1678	18000647595000	16623	8389	63	0	\N
296544	1678	18000647596000	16623	8389	64	0	\N
296545	1678	18000647597000	16623	8389	65	0	\N
296546	1678	18000647598000	16623	8389	66	0	\N
296547	1678	18000647599000	16623	8389	67	0	\N
296548	1678	18000647600000	16623	8389	68	0	\N
296549	1678	18000647601000	16623	8389	69	0	\N
296550	1678	18000647602000	16623	8389	70	0	\N
296551	1678	18000647603000	16623	8389	71	0	\N
296552	1678	18000647604000	16623	8389	72	0	\N
296553	1678	18000647605000	16623	8389	73	0	\N
296554	1678	18000647606000	16623	8389	74	0	\N
296555	1678	18000647607000	16623	8389	75	0	\N
296556	1678	18000647608000	16623	8389	76	0	\N
296557	1678	18000647609000	16623	8389	77	0	\N
296558	1678	18000647610000	16623	8389	78	0	\N
296559	1678	18000647611000	16623	8389	79	0	\N
296560	1678	18000647612000	16623	8389	80	0	\N
296561	1678	18000647613000	16623	8389	81	0	\N
296562	1678	18000647614000	16623	8389	82	0	\N
296563	1678	18000647615000	16623	8389	83	0	\N
296564	1678	18000647616000	16623	8389	85	0	\N
296565	1678	18000647617000	16623	8389	86	0	\N
296566	1678	18000647618000	16623	8389	87	0	\N
296567	1678	18000647619000	16623	8389	88	0	\N
296568	1678	18000647620000	16623	8389	89	0	\N
296569	1678	18000647621000	16623	8389	90	0	\N
296570	1678	18000647622000	16623	8389	91	0	\N
296571	1874	3676000	16623	8389	92	0	\N
296572	1874	3679000	16623	8389	93	0	\N
296573	1874	3681000	16623	8389	94	0	\N
296574	1874	3682000	16623	8389	95	0	\N
296575	1874	3683000	16623	8389	96	0	\N
296576	1874	3684000	16623	8389	97	0	\N
296577	1874	3685000	16623	8389	98	0	\N
296578	1874	3686000	16623	8389	99	0	\N
296579	1874	3687000	16623	8389	100	0	\N
296580	1874	3688000	16623	8389	101	0	\N
296583	1678	18000647625000	16625	8445	0	0	\N
296584	1874	4106000	16625	8445	1	0	\N
296585	1874	4108000	16625	8445	2	0	\N
296599	1382	1708727637751650	16629	8409	0	0	\N
296600	1136	908817465000000	16629	8409	1	0	\N
296601	1256	613196750000000	16629	8409	2	0	\N
296602	1016	507154775000000	16629	8409	3	0	\N
296603	1678	18000647594000	16629	8409	4	0	\N
296604	1678	18000647595000	16629	8409	5	0	\N
296605	1678	18000647596000	16629	8409	6	0	\N
296606	1678	18000647597000	16629	8409	7	0	\N
296607	1678	18000647598000	16629	8409	8	0	\N
296608	1678	18000647599000	16629	8409	9	0	\N
296609	1678	18000647600000	16629	8409	10	0	\N
296610	1678	18000647601000	16629	8409	11	0	\N
296611	2155	10000000	16629	8409	12	0	\N
296612	2155	10000000	16629	8409	13	0	\N
296613	1678	18000647602000	16629	8409	14	0	\N
296614	1678	18000647603000	16629	8409	15	0	\N
296615	1678	18000647604000	16629	8409	16	0	\N
296616	1678	18000647605000	16629	8409	17	0	\N
296586	1678	18000647625000	16626	8445	0	0	0
296587	1874	4106000	16626	8445	1	0	2
296588	1874	4108000	16626	8445	2	0	2
296589	1678	18000647626000	16627	8446	0	0	0
296590	1678	18000647627000	16627	8446	1	0	0
296592	1874	4111000	16627	8446	3	0	2
296593	1874	4114000	16627	8446	4	0	2
296594	1874	4117000	16627	8446	5	0	2
296595	1874	4119000	16627	8446	6	0	2
296596	1678	18000647628000	16628	8447	0	0	0
296598	1874	4124000	16628	8447	2	0	2
296617	1678	18000647606000	16629	8409	18	0	\N
296618	1678	18000647607000	16629	8409	19	0	\N
296619	1678	18000647608000	16629	8409	20	0	\N
296620	1678	18000647609000	16629	8409	21	0	\N
296621	1678	18000647610000	16629	8409	22	0	\N
296622	1678	18000647611000	16629	8409	23	0	\N
296623	1678	18000647612000	16629	8409	24	0	\N
296624	1678	18000647613000	16629	8409	25	0	\N
296625	1678	18000647614000	16629	8409	26	0	\N
296626	1678	18000647615000	16629	8409	27	0	\N
296627	1678	18000647616000	16629	8409	28	0	\N
296628	1678	18000647617000	16629	8409	29	0	\N
296629	1678	18000647618000	16629	8409	30	0	\N
296630	1678	18000647619000	16629	8409	31	0	\N
296631	1678	18000647620000	16629	8409	32	0	\N
296632	1678	18000647621000	16629	8409	33	0	\N
296633	1678	18000647622000	16629	8409	34	0	\N
296634	1678	18000647623000	16629	8409	35	0	\N
296635	1678	18000647624000	16629	8409	36	0	\N
296636	1678	18000647625000	16629	8409	37	0	\N
296637	1678	18000647626000	16629	8409	38	0	\N
296638	1678	18000647627000	16629	8409	39	0	\N
296639	1678	18000647628000	16629	8409	40	0	\N
296640	1678	18000647629000	16629	8409	41	0	\N
296641	1874	3948000	16629	8409	42	0	\N
296642	1874	3951000	16629	8409	43	0	\N
296643	1874	3954000	16629	8409	44	0	\N
296644	1874	3957000	16629	8409	45	0	\N
296645	1874	3960000	16629	8409	46	0	\N
296646	1874	3963000	16629	8409	47	0	\N
296647	1874	3964000	16629	8409	48	0	\N
296648	1874	3965000	16629	8409	49	0	\N
296649	1874	3966000	16629	8409	50	0	\N
296650	1874	3967000	16629	8409	51	0	\N
296651	1874	3968000	16629	8409	52	0	\N
296652	1874	3969000	16629	8409	53	0	\N
296653	1874	3970000	16629	8409	54	0	\N
296654	1874	3972000	16629	8409	55	0	\N
296655	1874	3974000	16629	8409	56	0	\N
296656	1874	3977000	16629	8409	57	0	\N
296657	1874	3980000	16629	8409	58	0	\N
296658	1874	3983000	16629	8409	59	0	\N
296659	1874	3984000	16629	8409	60	0	\N
296660	1874	3985000	16629	8409	61	0	\N
296661	1874	3986000	16629	8409	62	0	\N
296662	1874	3988000	16629	8409	63	0	\N
296663	1874	3990000	16629	8409	64	0	\N
296664	1874	3992000	16629	8409	65	0	\N
296665	1874	3994000	16629	8409	66	0	\N
296666	1874	3996000	16629	8409	67	0	\N
296667	1874	3998000	16629	8409	68	0	\N
296668	1874	4000000	16629	8409	69	0	\N
296669	1874	4002000	16629	8409	70	0	\N
296670	1874	4004000	16629	8409	71	0	\N
296671	1874	4006000	16629	8409	72	0	\N
296672	1874	4008000	16629	8409	73	0	\N
296673	1874	4010000	16629	8409	74	0	\N
296674	1874	4012000	16629	8409	75	0	\N
296675	1874	4014000	16629	8409	76	0	\N
296676	1874	4016000	16629	8409	77	0	\N
296677	1874	4018000	16629	8409	78	0	\N
296678	1874	4020000	16629	8409	79	0	\N
296679	1874	4022000	16629	8409	80	0	\N
296680	1874	4024000	16629	8409	81	0	\N
296681	1874	4026000	16629	8409	82	0	\N
296682	1874	4028000	16629	8409	83	0	\N
296683	1874	4030000	16629	8409	84	0	\N
296684	1874	4032000	16629	8409	85	0	\N
296685	1874	4034000	16629	8409	86	0	\N
296686	1874	4036000	16629	8409	87	0	\N
296687	1874	4038000	16629	8409	88	0	\N
296688	1874	4040000	16629	8409	89	0	\N
296689	1874	4042000	16629	8409	90	0	\N
296690	1874	4044000	16629	8409	91	0	\N
296691	1874	4047000	16629	8409	92	0	\N
296692	1874	4050000	16629	8409	93	0	\N
296693	1874	4053000	16629	8409	94	0	\N
296694	1874	4056000	16629	8409	95	0	\N
296695	1874	4059000	16629	8409	96	0	\N
296696	1874	4062000	16629	8409	97	0	\N
296697	1874	4065000	16629	8409	98	0	\N
296698	1874	4068000	16629	8409	99	0	\N
296699	1874	4071000	16629	8409	100	0	\N
296700	1874	4074000	16629	8409	101	0	\N
296701	1874	4077000	16629	8409	102	0	\N
296702	1874	4080000	16629	8409	103	0	\N
296703	1874	4083000	16629	8409	104	0	\N
296704	1874	4086000	16629	8409	105	0	\N
296705	1874	4089000	16629	8409	106	0	\N
296706	1874	4092000	16629	8409	107	0	\N
296707	1874	4095000	16629	8409	108	0	\N
296708	1874	4098000	16629	8409	109	0	\N
296709	1874	4101000	16629	8409	110	0	\N
296710	1874	4104000	16629	8409	111	0	\N
296711	1874	4107000	16629	8409	112	0	\N
296712	1874	4110000	16629	8409	113	0	\N
296713	1874	4113000	16629	8409	114	0	\N
296714	1874	4116000	16629	8409	115	0	\N
296715	1874	4119000	16629	8409	116	0	\N
296716	1874	4122000	16629	8409	117	0	\N
296717	1874	4125000	16629	8409	118	0	\N
296718	1874	4127000	16629	8409	119	0	\N
296719	1874	4129000	16629	8409	120	0	\N
296729	1319	1705962637751650	16632	8449	0	0	\N
296730	1678	18000647630000	16632	8449	1	0	\N
296731	1874	4130000	16632	8449	2	0	\N
296732	1874	4132000	16632	8449	3	0	\N
296733	1874	4135000	16632	8449	4	0	\N
296734	1678	18000647631000	16633	8450	0	0	\N
296735	1874	4137000	16633	8450	1	0	\N
296736	1874	4140000	16633	8450	2	0	\N
296737	1527	271999978	16633	8450	3	0	\N
296738	1678	18000647631000	16634	8450	0	0	\N
296739	1874	4137000	16634	8450	1	0	\N
296740	1874	4140000	16634	8450	2	0	\N
296741	1527	271999978	16634	8450	3	0	\N
296722	1874	4129000	16630	8448	2	0	2
296723	1319	1705962637751650	16631	8449	0	0	0
296724	1678	18000647630000	16631	8449	1	0	0
296725	1527	271999978	16631	8449	2	0	0
296726	1874	4130000	16631	8449	3	0	2
296728	1874	4135000	16631	8449	5	0	2
296742	1678	18000647631000	16635	8450	0	0	0
296743	1874	4137000	16635	8450	1	0	2
296744	1874	4140000	16635	8450	2	0	2
296745	1527	271999978	16635	8450	3	0	0
296747	1193	612204750000000	16636	8451	1	0	0
296748	953	506334775000000	16636	8451	2	0	0
296749	1678	18000647632000	16636	8451	3	0	0
296750	1874	4142000	16636	8451	4	0	2
296752	1678	18000647633000	16637	8452	0	0	0
296762	1678	18000647634000	16639	8453	0	0	\N
296763	1678	18000647635000	16639	8453	1	0	\N
296764	1874	4151000	16639	8453	2	0	\N
296765	1874	4154000	16639	8453	3	0	\N
296766	1874	4156000	16639	8453	4	0	\N
296767	1874	4158000	16639	8453	5	0	\N
296768	1874	4161000	16639	8453	6	0	\N
296788	1678	18000647638000	16645	8457	0	0	\N
296789	1678	18000647639000	16645	8457	1	0	\N
296790	1678	18000647640000	16645	8457	2	0	\N
296791	1678	18000647641000	16645	8457	3	0	\N
296792	1678	18000647642000	16645	8457	4	0	\N
296793	1874	4173000	16645	8457	5	0	\N
296794	1874	4175000	16645	8457	6	0	\N
296795	1874	4178000	16645	8457	7	0	\N
296796	1874	4181000	16645	8457	8	0	\N
296797	1874	4184000	16645	8457	9	0	\N
296798	1874	4187000	16645	8457	10	0	\N
296799	1874	4190000	16645	8457	11	0	\N
296800	1874	4192000	16645	8457	12	0	\N
296801	1874	4194000	16645	8457	13	0	\N
296802	1874	4196000	16645	8457	14	0	\N
296806	1678	18000647643000	16647	8458	0	0	\N
296807	1874	4198000	16647	8458	1	0	\N
296808	1874	4201000	16647	8458	2	0	\N
296812	1678	18000647643000	16649	8459	0	0	\N
296813	1874	4198000	16649	8459	1	0	\N
296814	1874	4201000	16649	8459	2	0	\N
296821	1678	18000647644000	16651	8460	0	0	\N
296822	1678	18000647645000	16651	8460	1	0	\N
296823	1874	4204000	16651	8460	2	0	\N
296824	1874	4205000	16651	8460	3	0	\N
296825	1874	4207000	16651	8460	4	0	\N
296826	1874	4209000	16651	8460	5	0	\N
296827	1678	18000647646000	16652	8461	0	0	\N
296828	1678	18000647647000	16652	8461	1	0	\N
296829	1874	4210000	16652	8461	2	0	\N
296830	1874	4212000	16652	8461	3	0	\N
296831	1874	4215000	16652	8461	4	0	\N
296832	1874	4217000	16652	8461	5	0	\N
296833	1874	4220000	16652	8461	6	0	\N
296834	1678	18000647646000	16653	8461	0	0	\N
296835	1678	18000647647000	16653	8461	1	0	\N
296836	1874	4210000	16653	8461	2	0	\N
296837	1874	4212000	16653	8461	3	0	\N
296838	1874	4215000	16653	8461	4	0	\N
296839	1874	4217000	16653	8461	5	0	\N
296840	1874	4220000	16653	8461	6	0	\N
296841	1678	18000647646000	16654	8461	0	0	\N
296842	1678	18000647647000	16654	8461	1	0	\N
296843	1874	4210000	16654	8461	2	0	\N
296844	1874	4212000	16654	8461	3	0	\N
296845	1874	4215000	16654	8461	4	0	\N
296846	1874	4217000	16654	8461	5	0	\N
296847	1874	4220000	16654	8461	6	0	\N
296848	1678	18000647646000	16655	8461	0	0	\N
296849	1678	18000647647000	16655	8461	1	0	\N
296850	1874	4210000	16655	8461	2	0	\N
296851	1874	4212000	16655	8461	3	0	\N
296852	1874	4215000	16655	8461	4	0	\N
296853	1874	4217000	16655	8461	5	0	\N
296854	1874	4220000	16655	8461	6	0	\N
296868	1678	18000647650000	16659	8464	0	0	\N
296869	1678	18000647651000	16659	8464	1	0	\N
296870	1678	18000647652000	16659	8464	2	0	\N
296871	1874	4231000	16659	8464	3	0	\N
296872	1874	4234000	16659	8464	4	0	\N
296873	1874	4236000	16659	8464	5	0	\N
296874	1874	4238000	16659	8464	6	0	\N
296875	1874	4241000	16659	8464	7	0	\N
296876	1874	4244000	16659	8464	8	0	\N
296877	1678	18000647650000	16660	8464	0	0	\N
296878	1678	18000647651000	16660	8464	1	0	\N
296879	1678	18000647652000	16660	8464	2	0	\N
296880	1874	4231000	16660	8464	3	0	\N
296881	1874	4234000	16660	8464	4	0	\N
296882	1874	4236000	16660	8464	5	0	\N
296883	1874	4238000	16660	8464	6	0	\N
296884	1874	4241000	16660	8464	7	0	\N
296885	1874	4244000	16660	8464	8	0	\N
296755	1678	18000647634000	16638	8453	0	0	0
296756	1678	18000647635000	16638	8453	1	0	0
296757	1874	4151000	16638	8453	2	0	2
296758	1874	4154000	16638	8453	3	0	2
296759	1874	4156000	16638	8453	4	0	2
296761	1874	4161000	16638	8453	6	0	2
296769	1678	18000647636000	16640	8454	0	0	0
296770	1874	4163000	16640	8454	1	0	2
296771	1874	4166000	16640	8454	2	0	2
296772	1678	18000647637000	16641	8455	0	0	0
296774	1874	4169000	16641	8455	2	0	2
296775	1874	4172000	16641	8455	3	0	2
296776	1678	18000647638000	16644	8457	0	0	0
296777	1678	18000647639000	16644	8457	1	0	0
296779	1678	18000647641000	16644	8457	3	0	0
296780	1874	4173000	16644	8457	4	0	2
296781	1874	4175000	16644	8457	5	0	2
296782	1874	4178000	16644	8457	6	0	2
296783	1874	4181000	16644	8457	7	0	2
296785	1874	4187000	16644	8457	9	0	2
296786	1874	4189000	16644	8457	10	0	2
296787	1874	4191000	16644	8457	11	0	2
296803	1678	18000647642000	16646	8458	0	0	0
296804	1874	4194000	16646	8458	1	0	2
296809	1678	18000647643000	16648	8459	0	0	0
296810	1874	4198000	16648	8459	1	0	2
296811	1874	4201000	16648	8459	2	0	2
296815	1678	18000647644000	16650	8460	0	0	0
296817	1874	4204000	16650	8460	2	0	2
296818	1874	4205000	16650	8460	3	0	2
296819	1874	4207000	16650	8460	4	0	2
296820	1874	4209000	16650	8460	5	0	2
296855	1678	18000647646000	16656	8461	0	0	0
296857	1874	4210000	16656	8461	2	0	2
296858	1874	4212000	16656	8461	3	0	2
296859	1874	4215000	16656	8461	4	0	2
296860	1874	4217000	16656	8461	5	0	2
296861	1874	4220000	16656	8461	6	0	2
296863	1874	4222000	16657	8462	1	0	2
296864	1874	4225000	16657	8462	2	0	2
296865	1678	18000647649000	16658	8463	0	0	0
296866	1874	4228000	16658	8463	1	0	2
296886	1678	18000647650000	16661	8464	0	0	0
296887	1678	18000647651000	16661	8464	1	0	0
296888	1678	18000647652000	16661	8464	2	0	0
296895	1382	1708727637751650	16662	8335	0	0	\N
296896	1319	1705962637751650	16662	8335	1	0	\N
296897	1073	907346465000000	16662	8335	2	0	\N
296898	1193	612204750000000	16662	8335	3	0	\N
296899	953	506334775000000	16662	8335	4	0	\N
296900	1136	908817465000000	16662	8335	5	0	\N
296901	1256	613196750000000	16662	8335	6	0	\N
296902	1016	507154775000000	16662	8335	7	0	\N
296903	2150	200000000	16662	8335	8	0	\N
296904	2152	12300000	16662	8335	9	0	\N
296905	2151	200000000	16662	8335	10	0	\N
296906	2153	200000000	16662	8335	11	0	\N
296907	2154	200000000	16662	8335	12	0	\N
296908	1860	107499987700000	16662	8335	13	0	\N
296909	2155	10000000	16662	8335	15	0	\N
296910	2155	10000000	16662	8335	16	0	\N
296911	1527	271999978	16662	8335	17	0	\N
296912	1527	271999978	16662	8335	23	0	\N
296913	1678	18000647653000	16663	8465	0	0	\N
296914	1874	4246000	16663	8465	1	0	\N
296915	1874	4249000	16663	8465	2	0	\N
296916	1678	18000647653000	16664	8465	0	0	\N
296917	1874	4246000	16664	8465	1	0	\N
296918	1874	4249000	16664	8465	2	0	\N
296929	1678	18000647654000	16668	8466	0	0	\N
296930	1678	18000647655000	16668	8466	1	0	\N
296931	1874	4252000	16668	8466	2	0	\N
296932	1874	4255000	16668	8466	3	0	\N
296933	1874	4256000	16668	8466	4	0	\N
296934	1874	4258000	16668	8466	5	0	\N
296935	1874	4260000	16668	8466	6	0	\N
296936	1678	18000647656000	16669	8468	0	0	\N
296937	1874	4262000	16669	8468	1	0	\N
296938	1874	4265000	16669	8468	2	0	\N
296942	1678	18000647656000	16671	8468	0	0	\N
296943	1874	4262000	16671	8468	1	0	\N
296944	1874	4265000	16671	8468	2	0	\N
296945	1678	18000647657000	16672	8469	0	0	\N
296946	1678	18000647658000	16672	8469	1	0	\N
296947	1874	4267000	16672	8469	2	0	\N
296948	1874	4270000	16672	8469	3	0	\N
296949	1874	4271000	16672	8469	4	0	\N
296950	1874	4273000	16672	8469	5	0	\N
296957	1678	18000647659000	16674	8470	0	0	\N
296958	1678	18000647660000	16674	8470	1	0	\N
296959	1874	4274000	16674	8470	2	0	\N
296960	1874	4277000	16674	8470	3	0	\N
296961	1874	4280000	16674	8470	4	0	\N
296962	1874	4282000	16674	8470	5	0	\N
296963	1874	4284000	16674	8470	6	0	\N
296964	1678	18000647659000	16675	8470	0	0	\N
296965	1678	18000647660000	16675	8470	1	0	\N
296966	1874	4274000	16675	8470	2	0	\N
296967	1874	4277000	16675	8470	3	0	\N
296968	1874	4280000	16675	8470	4	0	\N
296969	1874	4282000	16675	8470	5	0	\N
296970	1874	4284000	16675	8470	6	0	\N
296978	1678	18000647659000	16677	8470	0	0	\N
296979	1678	18000647660000	16677	8470	1	0	\N
296980	1874	4274000	16677	8470	2	0	\N
296981	1874	4277000	16677	8470	3	0	\N
296982	1874	4280000	16677	8470	4	0	\N
296983	1874	4282000	16677	8470	5	0	\N
296984	1874	4284000	16677	8470	6	0	\N
296985	1678	18000647661000	16678	8471	0	0	\N
296986	1874	4286000	16678	8471	1	0	\N
296987	1874	4289000	16678	8471	2	0	\N
297004	1678	18000647666000	16682	8474	0	0	\N
297005	1678	18000647667000	16682	8474	1	0	\N
297006	1874	4311000	16682	8474	2	0	\N
297007	1874	4313000	16682	8474	3	0	\N
297008	1874	4315000	16682	8474	4	0	\N
297009	1874	4318000	16682	8474	6	0	\N
297010	1874	4321000	16682	8474	7	0	\N
297018	1678	18000647668000	16684	8475	0	0	\N
297019	1874	4324000	16684	8475	1	0	\N
297022	1382	1708727637751650	16687	8383	0	0	\N
297023	1319	1705962637751650	16687	8383	1	0	\N
297024	1073	907346465000000	16687	8383	2	0	\N
296891	1874	4236000	16661	8464	5	0	2
296892	1874	4238000	16661	8464	6	0	2
296893	1874	4241000	16661	8464	7	0	2
296894	1874	4244000	16661	8464	8	0	2
296919	1678	18000647653000	16665	8465	0	0	0
296921	1874	4249000	16665	8465	2	0	2
296922	1678	18000647654000	16666	8466	0	0	0
296923	1874	4252000	16666	8466	1	0	2
296924	1874	4253000	16666	8466	2	0	2
296925	1874	4255000	16666	8466	3	0	2
296927	1874	4258000	16667	8467	1	0	2
296928	1874	4260000	16667	8467	2	0	2
296939	1678	18000647656000	16670	8468	0	0	0
296940	1874	4262000	16670	8468	1	0	2
296951	1678	18000647657000	16673	8469	0	0	0
296952	1678	18000647658000	16673	8469	1	0	0
296953	1874	4267000	16673	8469	2	0	2
296954	1874	4270000	16673	8469	3	0	2
296955	1874	4271000	16673	8469	4	0	2
296971	1678	18000647659000	16676	8470	0	0	0
296972	1678	18000647660000	16676	8470	1	0	0
296973	1874	4274000	16676	8470	2	0	2
296974	1874	4277000	16676	8470	3	0	2
296975	1874	4280000	16676	8470	4	0	2
296977	1874	4284000	16676	8470	6	0	2
296988	1678	18000647661000	16679	8471	0	0	0
296989	1874	4286000	16679	8471	1	0	2
296990	1874	4289000	16679	8471	2	0	2
296992	1874	4291000	16680	8472	1	0	2
296993	1874	4294000	16680	8472	2	0	2
296994	1678	18000647663000	16681	8473	0	0	0
296995	1678	18000647664000	16681	8473	1	0	0
296996	1678	18000647665000	16681	8473	2	0	0
296998	1874	4298000	16681	8473	4	0	2
296999	1874	4301000	16681	8473	5	0	2
297000	1874	4304000	16681	8473	6	0	2
297001	1874	4306000	16681	8473	7	0	2
297002	1874	4308000	16681	8473	8	0	2
297011	1678	18000647666000	16683	8474	0	0	0
297012	1678	18000647667000	16683	8474	1	0	0
297013	1874	4311000	16683	8474	2	0	2
297014	1874	4313000	16683	8474	3	0	2
297016	1874	4318000	16683	8474	6	0	2
297017	1874	4321000	16683	8474	7	0	2
297020	1678	18000647668000	16685	8475	0	0	0
297021	1874	4324000	16685	8475	1	0	2
297025	1193	612204750000000	16687	8383	4	0	\N
297026	953	506334775000000	16687	8383	5	0	\N
297027	1136	908817465000000	16687	8383	6	0	\N
297028	1256	613196750000000	16687	8383	7	0	\N
297029	1016	507154775000000	16687	8383	8	0	\N
297030	2153	200000000	16687	8383	9	0	\N
297031	2154	200000000	16687	8383	10	0	\N
297032	1678	18000647532000	16687	8383	11	0	\N
297033	2152	12300000	16687	8383	12	0	\N
297034	2152	107499012300000	16687	8383	13	0	\N
297035	1678	18000647533000	16687	8383	14	0	\N
297036	1678	18000647534000	16687	8383	15	0	\N
297037	1678	18000647535000	16687	8383	16	0	\N
297038	1678	18000647536000	16687	8383	17	0	\N
297039	1678	18000647537000	16687	8383	18	0	\N
297040	1678	18000647538000	16687	8383	19	0	\N
297041	1678	18000647539000	16687	8383	20	0	\N
297042	1678	18000647540000	16687	8383	21	0	\N
297043	1678	18000647541000	16687	8383	22	0	\N
297044	1678	18000647542000	16687	8383	23	0	\N
297045	1678	18000647543000	16687	8383	24	0	\N
297046	1678	18000647544000	16687	8383	25	0	\N
297047	1678	18000647545000	16687	8383	26	0	\N
297048	1678	18000647546000	16687	8383	27	0	\N
297049	1678	18000647547000	16687	8383	28	0	\N
297050	1678	18000647548000	16687	8383	29	0	\N
297051	1678	18000647549000	16687	8383	30	0	\N
297052	1678	18000647550000	16687	8383	31	0	\N
297053	1678	18000647551000	16687	8383	32	0	\N
297054	1678	18000647552000	16687	8383	33	0	\N
297055	1678	18000647553000	16687	8383	34	0	\N
297056	1678	18000647554000	16687	8383	35	0	\N
297057	1678	18000647555000	16687	8383	36	0	\N
297058	1678	18000647556000	16687	8383	37	0	\N
297059	1678	18000647557000	16687	8383	38	0	\N
297060	1678	18000647558000	16687	8383	39	0	\N
297061	1678	18000647559000	16687	8383	41	0	\N
297062	1678	18000647560000	16687	8383	42	0	\N
297063	1678	18000647561000	16687	8383	43	0	\N
297064	1678	18000647562000	16687	8383	44	0	\N
297065	1678	18000647563000	16687	8383	45	0	\N
297066	1678	18000647564000	16687	8383	46	0	\N
297067	1678	18000647565000	16687	8383	47	0	\N
297068	1678	18000647566000	16687	8383	48	0	\N
297069	1678	18000647567000	16687	8383	49	0	\N
297070	1678	18000647568000	16687	8383	50	0	\N
297071	1678	18000647569000	16687	8383	51	0	\N
297072	1678	18000647570000	16687	8383	52	0	\N
297073	1678	18000647571000	16687	8383	53	0	\N
297074	1678	18000647572000	16687	8383	54	0	\N
297075	1678	18000647573000	16687	8383	55	0	\N
297076	1678	18000647574000	16687	8383	56	0	\N
297077	1678	18000647575000	16687	8383	57	0	\N
297078	2155	10000000	16687	8383	58	0	\N
297079	2155	10000000	16687	8383	59	0	\N
297080	1678	18000647576000	16687	8383	60	0	\N
297081	1678	18000647577000	16687	8383	61	0	\N
297082	1678	18000647578000	16687	8383	62	0	\N
297083	1678	18000647579000	16687	8383	63	0	\N
297084	1678	18000647580000	16687	8383	64	0	\N
297085	1678	18000647581000	16687	8383	65	0	\N
297086	1678	18000647582000	16687	8383	66	0	\N
297087	1678	18000647583000	16687	8383	67	0	\N
297088	1678	18000647584000	16687	8383	68	0	\N
297089	1678	18000647585000	16687	8383	69	0	\N
297090	1678	18000647586000	16687	8383	70	0	\N
297091	1678	18000647587000	16687	8383	71	0	\N
297092	1678	18000647588000	16687	8383	72	0	\N
297093	1678	18000647589000	16687	8383	73	0	\N
297094	1678	18000647590000	16687	8383	74	0	\N
297095	1678	18000647591000	16687	8383	75	0	\N
297096	1678	18000647592000	16687	8383	76	0	\N
297097	1678	18000647593000	16687	8383	77	0	\N
297098	1678	18000647594000	16687	8383	78	0	\N
297099	1678	18000647595000	16687	8383	79	0	\N
297100	1678	18000647596000	16687	8383	80	0	\N
297101	1678	18000647597000	16687	8383	81	0	\N
297102	1678	18000647598000	16687	8383	82	0	\N
297103	1678	18000647599000	16687	8383	83	0	\N
297104	1678	18000647600000	16687	8383	84	0	\N
297105	1678	18000647601000	16687	8383	85	0	\N
297106	1678	18000647602000	16687	8383	86	0	\N
297107	1678	18000647603000	16687	8383	87	0	\N
297108	1678	18000647604000	16687	8383	88	0	\N
297109	1678	18000647605000	16687	8383	89	0	\N
297110	1678	18000647606000	16687	8383	90	0	\N
297111	1678	18000647607000	16687	8383	91	0	\N
297112	1678	18000647608000	16687	8383	92	0	\N
297113	1678	18000647609000	16687	8383	93	0	\N
297114	1678	18000647610000	16687	8383	94	0	\N
297115	1678	18000647611000	16687	8383	95	0	\N
297116	1678	18000647612000	16687	8383	96	0	\N
297117	1678	18000647613000	16687	8383	97	0	\N
297118	1678	18000647614000	16687	8383	98	0	\N
297119	1678	18000647615000	16687	8383	99	0	\N
297120	1678	18000647616000	16687	8383	100	0	\N
297121	1678	18000647617000	16687	8383	101	0	\N
297122	1678	18000647618000	16687	8383	102	0	\N
297123	1678	18000647619000	16687	8383	103	0	\N
297124	1678	18000647620000	16687	8383	104	0	\N
297125	1678	18000647621000	16687	8383	105	0	\N
297126	1678	18000647622000	16687	8383	106	0	\N
297127	1678	18000647623000	16687	8383	107	0	\N
297128	1678	18000647624000	16687	8383	108	0	\N
297129	1678	18000647625000	16687	8383	109	0	\N
297130	1678	18000647626000	16687	8383	110	0	\N
297131	1678	18000647627000	16687	8383	111	0	\N
297132	1678	18000647628000	16687	8383	112	0	\N
297133	1678	18000647629000	16687	8383	113	0	\N
297134	1678	18000647630000	16687	8383	114	0	\N
297135	1678	18000647631000	16687	8383	115	0	\N
297136	1678	18000647632000	16687	8383	116	0	\N
297137	1678	18000647633000	16687	8383	117	0	\N
297138	1678	18000647634000	16687	8383	118	0	\N
297139	1678	18000647635000	16687	8383	119	0	\N
297140	1678	18000647636000	16687	8383	120	0	\N
297141	1678	18000647637000	16687	8383	121	0	\N
297142	1678	18000647638000	16687	8383	122	0	\N
297143	1678	18000647639000	16687	8383	123	0	\N
297144	1678	18000647640000	16687	8383	124	0	\N
297145	1678	18000647641000	16687	8383	125	0	\N
297148	1678	18000647671000	16688	8476	2	0	0
297149	1678	18000647672000	16688	8476	3	0	0
297150	1678	18000647673000	16688	8476	4	0	0
297151	1874	4325000	16688	8476	5	0	2
297152	1874	4328000	16688	8476	6	0	2
297154	1874	4334000	16688	8476	8	0	2
297155	1874	4336000	16688	8476	9	0	2
297156	1874	4338000	16688	8476	10	0	2
297157	1874	4340000	16688	8476	11	0	2
297158	1874	4342000	16688	8476	12	0	2
297160	1874	4348000	16688	8476	14	0	2
297169	1678	18000647676000	16690	8478	0	0	\N
297170	1678	18000647677000	16690	8478	1	0	\N
297171	1874	4363000	16690	8478	2	0	\N
297172	1874	4365000	16690	8478	3	0	\N
297173	1874	4366000	16690	8478	4	0	\N
297174	1874	4369000	16690	8478	5	0	\N
297175	1874	4372000	16690	8478	6	0	\N
297176	1678	18000647676000	16691	8478	0	0	\N
297177	1678	18000647677000	16691	8478	1	0	\N
297178	1874	4363000	16691	8478	2	0	\N
297179	1874	4365000	16691	8478	3	0	\N
297180	1874	4366000	16691	8478	4	0	\N
297181	1874	4369000	16691	8478	5	0	\N
297182	1874	4372000	16691	8478	6	0	\N
297193	1678	18720659679000	16694	8480	0	0	\N
297194	1874	4380000	16694	8480	1	0	\N
297222	1678	18720659686000	16702	8486	0	0	\N
297223	1874	4417000	16702	8486	1	0	\N
297224	1874	4419000	16702	8486	2	0	\N
297225	1874	4420000	16702	8486	3	0	\N
297226	1678	18720659687000	16703	8487	0	0	\N
297227	1874	4422000	16703	8487	1	0	\N
297228	1874	4425000	16703	8487	2	0	\N
297239	1678	18720659688000	16706	8488	0	0	\N
297240	1678	18720659689000	16706	8488	1	0	\N
297241	1874	4428000	16706	8488	2	0	\N
297242	1874	4431000	16706	8488	3	0	\N
297243	1874	4433000	16706	8488	4	0	\N
297244	1874	4435000	16706	8488	5	0	\N
297245	1874	4436000	16706	8488	6	0	\N
297246	1319	1705962637751650	16707	8428	0	0	\N
297247	1073	907346465000000	16707	8428	1	0	\N
297248	1193	612204750000000	16707	8428	2	0	\N
297249	953	506334775000000	16707	8428	3	0	\N
297250	1678	18000647617000	16707	8428	4	0	\N
297251	1678	18000647618000	16707	8428	5	0	\N
297252	1678	18000647619000	16707	8428	6	0	\N
297253	1678	18000647620000	16707	8428	7	0	\N
297254	1678	18000647621000	16707	8428	8	0	\N
297255	1678	18000647622000	16707	8428	9	0	\N
297256	1678	18000647623000	16707	8428	10	0	\N
297257	1678	18000647624000	16707	8428	11	0	\N
297258	1678	18000647625000	16707	8428	12	0	\N
297259	1678	18000647626000	16707	8428	13	0	\N
297260	1678	18000647627000	16707	8428	14	0	\N
297261	1678	18000647628000	16707	8428	15	0	\N
297262	1678	18000647629000	16707	8428	16	0	\N
297263	1678	18000647630000	16707	8428	17	0	\N
297264	1678	18000647631000	16707	8428	18	0	\N
297265	1678	18000647632000	16707	8428	20	0	\N
297266	1678	18000647633000	16707	8428	21	0	\N
297267	1678	18000647634000	16707	8428	22	0	\N
297268	1678	18000647635000	16707	8428	23	0	\N
297269	1678	18000647636000	16707	8428	24	0	\N
297270	1678	18000647637000	16707	8428	25	0	\N
297271	1678	18000647638000	16707	8428	26	0	\N
297272	1678	18000647639000	16707	8428	27	0	\N
297273	1678	18000647640000	16707	8428	28	0	\N
297274	1678	18000647641000	16707	8428	29	0	\N
297275	1678	18000647642000	16707	8428	30	0	\N
297276	1678	18000647643000	16707	8428	31	0	\N
297277	1678	18000647644000	16707	8428	32	0	\N
297278	1678	18000647645000	16707	8428	33	0	\N
297279	1678	18000647646000	16707	8428	34	0	\N
297280	1678	18000647647000	16707	8428	35	0	\N
297281	1678	18000647648000	16707	8428	36	0	\N
297282	1678	18000647649000	16707	8428	37	0	\N
297283	1678	18000647650000	16707	8428	38	0	\N
297284	1678	18000647651000	16707	8428	39	0	\N
297285	1678	18000647652000	16707	8428	40	0	\N
297286	1678	18000647653000	16707	8428	41	0	\N
297287	1678	18000647654000	16707	8428	42	0	\N
297288	1678	18000647655000	16707	8428	43	0	\N
297289	1678	18000647656000	16707	8428	44	0	\N
297290	1678	18000647657000	16707	8428	45	0	\N
297291	1678	18000647658000	16707	8428	46	0	\N
297292	1678	18000647659000	16707	8428	47	0	\N
297293	1678	18000647660000	16707	8428	48	0	\N
297294	1678	18000647661000	16707	8428	49	0	\N
297295	1678	18000647662000	16707	8428	50	0	\N
297296	1678	18000647663000	16707	8428	51	0	\N
297163	1678	18000647675000	16689	8477	1	0	0
297164	1874	4352000	16689	8477	2	0	2
297165	1874	4354000	16689	8477	3	0	2
297166	1874	4355000	16689	8477	4	0	2
297167	1874	4358000	16689	8477	5	0	2
297183	1678	18000647676000	16692	8478	0	0	0
297184	1678	18000647677000	16692	8478	1	0	0
297185	1874	4363000	16692	8478	2	0	2
297186	1874	4365000	16692	8478	3	0	2
297187	1874	4366000	16692	8478	4	0	2
297189	1874	4372000	16692	8478	6	0	2
297190	1678	18000647678000	16693	8479	0	0	0
297191	1874	4375000	16693	8479	1	0	2
297192	1874	4377000	16693	8479	2	0	2
297196	1874	4380000	16695	8480	1	0	2
297197	1678	18720659680000	16696	8481	0	0	0
297198	1678	18720659681000	16696	8481	1	0	0
297199	1874	4383000	16696	8481	2	0	2
297200	1874	4386000	16696	8481	3	0	2
297202	1874	4389000	16696	8481	5	0	2
297203	1874	4391000	16696	8481	6	0	2
297204	1874	4393000	16696	8481	7	0	2
297205	1874	4396000	16696	8481	8	0	2
297206	1678	18720659682000	16697	8482	0	0	0
297208	1874	4401000	16697	8482	2	0	2
297209	1678	18720659683000	16698	8483	0	0	0
297210	1874	4403000	16698	8483	1	0	2
297211	1874	4406000	16698	8483	2	0	2
297213	1678	18720659684000	16699	8484	0	0	0
297214	1874	4409000	16699	8484	1	0	2
297215	1874	4412000	16699	8484	2	0	2
297216	1678	18720659685000	16700	8485	0	0	0
297217	1874	4414000	16700	8485	1	0	2
297219	1874	4417000	16701	8486	1	0	2
297220	1874	4419000	16701	8486	2	0	2
297221	1874	4420000	16701	8486	3	0	2
297229	1678	18720659687000	16704	8487	0	0	0
297230	1874	4422000	16704	8487	1	0	2
297232	1678	18720659688000	16705	8488	0	0	0
297233	1678	18720659689000	16705	8488	1	0	0
297234	1874	4428000	16705	8488	2	0	2
297235	1874	4431000	16705	8488	3	0	2
297237	1874	4435000	16705	8488	5	0	2
297238	1874	4436000	16705	8488	6	0	2
297297	1678	18000647664000	16707	8428	52	0	\N
297298	1678	18000647665000	16707	8428	53	0	\N
297299	1678	18000647666000	16707	8428	54	0	\N
297300	1678	18000647667000	16707	8428	55	0	\N
297301	1678	18000647668000	16707	8428	56	0	\N
297302	1678	18000647669000	16707	8428	57	0	\N
297303	1678	18000647670000	16707	8428	58	0	\N
297304	1678	18000647671000	16707	8428	59	0	\N
297305	1678	18000647672000	16707	8428	60	0	\N
297306	1678	18000647673000	16707	8428	61	0	\N
297307	1678	18000647674000	16707	8428	62	0	\N
297308	1678	18000647675000	16707	8428	63	0	\N
297309	1678	18000647676000	16707	8428	64	0	\N
297310	1678	18000647677000	16707	8428	65	0	\N
297311	1678	18000647678000	16707	8428	66	0	\N
297312	1678	18000647679000	16707	8428	67	0	\N
297313	1678	18000647680000	16707	8428	68	0	\N
297314	1678	18000647681000	16707	8428	69	0	\N
297315	1678	18000647682000	16707	8428	70	0	\N
297316	1678	18000647683000	16707	8428	71	0	\N
297317	1678	18000647684000	16707	8428	72	0	\N
297318	1678	18000647685000	16707	8428	73	0	\N
297319	1678	18000647686000	16707	8428	74	0	\N
297320	1678	18000647687000	16707	8428	75	0	\N
297321	1678	18000647688000	16707	8428	76	0	\N
297322	1678	18000647689000	16707	8428	77	0	\N
297323	1527	271999978	16707	8428	78	0	\N
297324	1874	4022000	16707	8428	79	0	\N
297325	1874	4023000	16707	8428	80	0	\N
297326	1874	4025000	16707	8428	81	0	\N
297327	1874	4027000	16707	8428	82	0	\N
297328	1874	4029000	16707	8428	83	0	\N
297329	1874	4031000	16707	8428	84	0	\N
297330	1874	4033000	16707	8428	85	0	\N
297331	1527	271999978	16707	8428	86	0	\N
297332	1874	4034000	16707	8428	87	0	\N
297333	1874	4035000	16707	8428	88	0	\N
297334	1874	4036000	16707	8428	89	0	\N
297335	1874	4037000	16707	8428	90	0	\N
297336	1874	4038000	16707	8428	91	0	\N
297337	1874	4039000	16707	8428	92	0	\N
297338	1874	4040000	16707	8428	93	0	\N
297339	1874	4041000	16707	8428	94	0	\N
297340	1874	4042000	16707	8428	95	0	\N
297341	1874	4043000	16707	8428	96	0	\N
297342	1874	4044000	16707	8428	97	0	\N
297343	1874	4045000	16707	8428	98	0	\N
297344	1874	4046000	16707	8428	99	0	\N
297345	1874	4047000	16707	8428	100	0	\N
297346	1874	4048000	16707	8428	101	0	\N
297347	1874	4049000	16707	8428	102	0	\N
297348	1874	4050000	16707	8428	103	0	\N
297349	1874	4051000	16707	8428	104	0	\N
297350	1874	4052000	16707	8428	105	0	\N
297351	1874	4053000	16707	8428	106	0	\N
297352	1874	4054000	16707	8428	107	0	\N
297353	1874	4055000	16707	8428	108	0	\N
297354	1874	4057000	16707	8428	109	0	\N
297355	1874	4059000	16707	8428	110	0	\N
297356	1874	4061000	16707	8428	111	0	\N
297357	1874	4063000	16707	8428	112	0	\N
297358	1874	4065000	16707	8428	113	0	\N
297359	1874	4067000	16707	8428	114	0	\N
297360	1874	4069000	16707	8428	115	0	\N
297361	1874	4071000	16707	8428	116	0	\N
297362	1874	4073000	16707	8428	117	0	\N
297363	1874	4075000	16707	8428	118	0	\N
297364	1874	4077000	16707	8428	119	0	\N
297365	1874	4079000	16707	8428	120	0	\N
297366	1874	4081000	16707	8428	121	0	\N
297367	1874	4083000	16707	8428	122	0	\N
297371	1382	1708727637751650	16709	8426	0	0	\N
297372	1319	1705962637751650	16709	8426	1	0	\N
297373	1073	907346465000000	16709	8426	2	0	\N
297374	1193	612204750000000	16709	8426	3	0	\N
297375	953	506334775000000	16709	8426	4	0	\N
297376	1136	908817465000000	16709	8426	5	0	\N
297377	1256	613196750000000	16709	8426	6	0	\N
297378	1016	507154775000000	16709	8426	7	0	\N
297379	1678	18000647601000	16709	8426	8	0	\N
297380	1678	18000647602000	16709	8426	9	0	\N
297381	1678	18000647603000	16709	8426	10	0	\N
297382	1678	18000647604000	16709	8426	11	0	\N
297383	1678	18000647605000	16709	8426	12	0	\N
297384	1678	18000647606000	16709	8426	13	0	\N
297385	1678	18000647607000	16709	8426	14	0	\N
297386	1678	18000647608000	16709	8426	15	0	\N
297387	1678	18000647609000	16709	8426	16	0	\N
297388	1678	18000647610000	16709	8426	17	0	\N
297389	1678	18000647611000	16709	8426	18	0	\N
297390	1678	18000647612000	16709	8426	19	0	\N
297391	1678	18000647613000	16709	8426	20	0	\N
297392	1678	18000647614000	16709	8426	21	0	\N
297393	1678	18000647615000	16709	8426	22	0	\N
297394	1678	18000647616000	16709	8426	23	0	\N
297395	1678	18000647617000	16709	8426	24	0	\N
297396	1678	18000647618000	16709	8426	25	0	\N
297397	1678	18000647619000	16709	8426	26	0	\N
297398	1678	18000647620000	16709	8426	27	0	\N
297399	1678	18000647621000	16709	8426	28	0	\N
297400	1678	18000647622000	16709	8426	29	0	\N
297401	1678	18000647623000	16709	8426	30	0	\N
297402	1678	18000647624000	16709	8426	31	0	\N
297403	1678	18000647625000	16709	8426	32	0	\N
297404	1678	18000647626000	16709	8426	33	0	\N
297405	1678	18000647627000	16709	8426	34	0	\N
297406	1678	18000647628000	16709	8426	35	0	\N
297407	1678	18000647629000	16709	8426	36	0	\N
297408	1678	18000647630000	16709	8426	37	0	\N
297409	1678	18000647631000	16709	8426	38	0	\N
297410	1678	18000647632000	16709	8426	39	0	\N
297411	1678	18000647633000	16709	8426	40	0	\N
297412	1678	18000647634000	16709	8426	41	0	\N
297413	1678	18000647635000	16709	8426	42	0	\N
297414	1678	18000647636000	16709	8426	43	0	\N
297415	1678	18000647637000	16709	8426	44	0	\N
297416	1678	18000647638000	16709	8426	45	0	\N
297417	1678	18000647639000	16709	8426	46	0	\N
297418	1678	18000647640000	16709	8426	47	0	\N
297419	1678	18000647641000	16709	8426	48	0	\N
297420	1678	18000647642000	16709	8426	49	0	\N
297421	1678	18000647643000	16709	8426	50	0	\N
297422	1678	18000647644000	16709	8426	51	0	\N
297423	1678	18000647645000	16709	8426	52	0	\N
297424	1678	18000647646000	16709	8426	53	0	\N
297425	1678	18000647647000	16709	8426	54	0	\N
297426	1678	18000647648000	16709	8426	55	0	\N
297427	1678	18000647649000	16709	8426	56	0	\N
297428	1678	18000647650000	16709	8426	57	0	\N
297429	1678	18000647651000	16709	8426	58	0	\N
297430	1678	18000647652000	16709	8426	59	0	\N
297431	1678	18000647653000	16709	8426	60	0	\N
297432	1678	18000647654000	16709	8426	61	0	\N
297370	1874	4441000	16708	8489	2	0	2
297433	1678	18000647655000	16709	8426	62	0	\N
297434	1678	18000647656000	16709	8426	64	0	\N
297435	1678	18000647657000	16709	8426	65	0	\N
297436	1678	18000647658000	16709	8426	66	0	\N
297437	1678	18000647659000	16709	8426	67	0	\N
297438	1678	18000647660000	16709	8426	68	0	\N
297439	1678	18000647661000	16709	8426	69	0	\N
297440	1678	18000647662000	16709	8426	70	0	\N
297441	1678	18000647663000	16709	8426	71	0	\N
297442	1678	18000647664000	16709	8426	72	0	\N
297443	1678	18000647665000	16709	8426	73	0	\N
297444	1678	18000647666000	16709	8426	74	0	\N
297445	1678	18000647667000	16709	8426	75	0	\N
297446	1678	18000647668000	16709	8426	76	0	\N
297447	1678	18000647669000	16709	8426	77	0	\N
297448	1678	18000647670000	16709	8426	78	0	\N
297449	1678	18000647671000	16709	8426	79	0	\N
297450	1678	18000647672000	16709	8426	80	0	\N
297451	1678	18000647673000	16709	8426	81	0	\N
297452	1678	18000647674000	16709	8426	82	0	\N
297453	1678	18000647675000	16709	8426	83	0	\N
297454	1678	18000647676000	16709	8426	84	0	\N
297455	1678	18000647677000	16709	8426	85	0	\N
297456	1678	18000647678000	16709	8426	86	0	\N
297457	1678	18000647679000	16709	8426	87	0	\N
297458	1678	18000647680000	16709	8426	88	0	\N
297459	1678	18000647681000	16709	8426	89	0	\N
297460	1678	18000647682000	16709	8426	90	0	\N
297461	1678	18000647683000	16709	8426	91	0	\N
297462	1678	18000647684000	16709	8426	92	0	\N
297463	1678	18000647685000	16709	8426	93	0	\N
297464	1678	18000647686000	16709	8426	94	0	\N
297465	1678	18000647687000	16709	8426	95	0	\N
297466	1678	18000647688000	16709	8426	96	0	\N
297467	1678	18000647689000	16709	8426	97	0	\N
297468	1678	18000647690000	16709	8426	98	0	\N
297469	1527	271999978	16709	8426	99	0	\N
297470	1874	3984000	16709	8426	100	0	\N
297471	1874	3985000	16709	8426	101	0	\N
297472	1874	3986000	16709	8426	102	0	\N
297473	1874	3987000	16709	8426	103	0	\N
297474	1874	3988000	16709	8426	104	0	\N
297475	1874	3990000	16709	8426	105	0	\N
297476	1874	3993000	16709	8426	106	0	\N
297477	1874	3995000	16709	8426	107	0	\N
297478	1874	3997000	16709	8426	108	0	\N
297479	1874	3999000	16709	8426	109	0	\N
297480	1874	4001000	16709	8426	110	0	\N
297481	1874	4003000	16709	8426	111	0	\N
297482	1874	4005000	16709	8426	112	0	\N
297483	1874	4007000	16709	8426	113	0	\N
297484	1874	4009000	16709	8426	114	0	\N
297485	1874	4011000	16709	8426	115	0	\N
297486	1874	4013000	16709	8426	116	0	\N
297487	1874	4015000	16709	8426	117	0	\N
297488	1874	4017000	16709	8426	118	0	\N
297489	1527	271999978	16709	8426	119	0	\N
297490	1874	4018000	16709	8426	120	0	\N
297491	1874	4019000	16709	8426	121	0	\N
297492	1874	4020000	16709	8426	122	0	\N
297493	1874	4021000	16709	8426	123	0	\N
297494	1874	4022000	16709	8426	124	0	\N
297495	1874	4023000	16709	8426	125	0	\N
297509	1678	18720659695000	16712	8492	0	0	\N
297510	1874	4464000	16712	8492	2	0	\N
297511	1874	4467000	16712	8492	3	0	\N
297512	1678	18720659695000	16713	8492	0	0	\N
297513	1678	18720659695000	16714	8492	0	0	\N
297514	1874	4464000	16714	8492	2	0	\N
297515	1874	4467000	16714	8492	3	0	\N
297516	1678	18720659695000	16715	8492	0	0	\N
297517	1874	4464000	16715	8492	2	0	\N
297518	1874	4467000	16715	8492	3	0	\N
297519	1678	18720659695000	16716	8492	0	0	\N
297520	1874	4464000	16716	8492	2	0	\N
297521	1874	4467000	16716	8492	3	0	\N
297522	1678	18720659695000	16717	8492	0	0	\N
297523	1874	4464000	16717	8492	2	0	\N
297524	1874	4467000	16717	8492	3	0	\N
297528	1678	18720659695000	16719	8492	0	0	\N
297529	1874	4464000	16719	8492	2	0	\N
297530	1874	4467000	16719	8492	3	0	\N
297538	1382	1708727637751650	16721	8355	0	0	\N
297539	1319	1705962637751650	16721	8355	1	0	\N
297540	1073	907346465000000	16721	8355	2	0	\N
297541	1193	612204750000000	16721	8355	3	0	\N
297542	953	506334775000000	16721	8355	4	0	\N
297543	1136	908817465000000	16721	8355	5	0	\N
297544	1256	613196750000000	16721	8355	6	0	\N
297545	1016	507154775000000	16721	8355	7	0	\N
297546	1678	17280636496000	16721	8355	8	0	\N
297547	1678	17280636497000	16721	8355	9	0	\N
297548	2152	12300000	16721	8355	10	0	\N
297549	2151	200000000	16721	8355	11	0	\N
297550	2153	200000000	16721	8355	12	0	\N
297551	2154	200000000	16721	8355	13	0	\N
297552	1860	107499987700000	16721	8355	14	0	\N
297553	1678	17280636498000	16721	8355	16	0	\N
297554	1678	17280636499000	16721	8355	17	0	\N
297555	1678	17280636500000	16721	8355	18	0	\N
297556	1678	17280636501000	16721	8355	19	0	\N
297557	1678	17280636502000	16721	8355	20	0	\N
297558	1678	17280636503000	16721	8355	21	0	\N
297559	1678	17280636504000	16721	8355	22	0	\N
297560	1678	17280636505000	16721	8355	23	0	\N
297561	1678	17280636506000	16721	8355	24	0	\N
297562	1678	17280636507000	16721	8355	25	0	\N
297563	1678	17280636508000	16721	8355	26	0	\N
297564	1678	17280636509000	16721	8355	27	0	\N
297565	1678	17280636510000	16721	8355	28	0	\N
297566	1678	17280636511000	16721	8355	29	0	\N
297567	1678	17280636512000	16721	8355	30	0	\N
297568	1678	17280636513000	16721	8355	31	0	\N
297498	1678	18720659693000	16710	8490	2	0	0
297499	1874	4443000	16710	8490	3	0	2
297500	1874	4445000	16710	8490	4	0	2
297501	1874	4446000	16710	8490	5	0	2
297502	1874	4448000	16710	8490	6	0	2
297504	1874	4454000	16710	8490	8	0	2
297505	1874	4457000	16710	8490	9	0	2
297506	1678	18720659694000	16711	8491	0	0	0
297507	1874	4460000	16711	8491	1	0	2
297508	1874	4462000	16711	8491	2	0	2
297526	1874	4464000	16718	8492	2	0	2
297527	1874	4467000	16718	8492	3	0	2
297531	1678	18720659696000	16720	8493	0	0	0
297532	1678	18720659697000	16720	8493	1	0	0
297534	1874	4473000	16720	8493	3	0	2
297535	1874	4475000	16720	8493	4	0	2
297536	1874	4477000	16720	8493	5	0	2
297537	1874	4478000	16720	8493	6	0	2
297569	1678	17280636514000	16721	8355	32	0	\N
297570	1678	17280636515000	16721	8355	33	0	\N
297571	1678	17280636516000	16721	8355	34	0	\N
297572	1678	17280636517000	16721	8355	35	0	\N
297573	1678	17280636518000	16721	8355	36	0	\N
297574	1678	17280636519000	16721	8355	37	0	\N
297575	1678	17280636520000	16721	8355	38	0	\N
297576	1678	17280636521000	16721	8355	39	0	\N
297577	1678	17280636522000	16721	8355	40	0	\N
297578	1678	17280636523000	16721	8355	41	0	\N
297579	1678	17280636524000	16721	8355	42	0	\N
297580	1678	17280636525000	16721	8355	43	0	\N
297581	1678	17280636526000	16721	8355	44	0	\N
297582	1678	17280636527000	16721	8355	45	0	\N
297583	1678	17280636528000	16721	8355	46	0	\N
297584	1678	17280636529000	16721	8355	47	0	\N
297585	1678	17280636530000	16721	8355	48	0	\N
297586	1678	17280636531000	16721	8355	49	0	\N
297587	1678	17280636532000	16721	8355	50	0	\N
297588	1678	17280636533000	16721	8355	51	0	\N
297589	1678	17280636534000	16721	8355	52	0	\N
297590	1678	17280636535000	16721	8355	53	0	\N
297591	1678	17280636536000	16721	8355	54	0	\N
297592	1678	17280636537000	16721	8355	55	0	\N
297593	1678	17280636538000	16721	8355	57	0	\N
297594	1678	17280636539000	16721	8355	58	0	\N
297595	1678	17280636540000	16721	8355	59	0	\N
297596	1678	17280636541000	16721	8355	60	0	\N
297597	1678	17280636542000	16721	8355	61	0	\N
297598	1678	17280636543000	16721	8355	62	0	\N
297599	1678	17280636544000	16721	8355	63	0	\N
297600	1678	17280636545000	16721	8355	64	0	\N
297601	1678	17280636546000	16721	8355	65	0	\N
297602	1678	17280636547000	16721	8355	66	0	\N
297603	1678	17280636548000	16721	8355	67	0	\N
297604	1678	17280636549000	16721	8355	68	0	\N
297605	1678	17280636550000	16721	8355	69	0	\N
297606	1678	17280636551000	16721	8355	70	0	\N
297607	1678	17280636552000	16721	8355	71	0	\N
297608	1678	17280636553000	16721	8355	72	0	\N
297609	1678	17280636554000	16721	8355	73	0	\N
297610	1678	17280636555000	16721	8355	74	0	\N
297611	1678	17280636556000	16721	8355	75	0	\N
297612	1678	17280636557000	16721	8355	76	0	\N
297613	1678	17280636558000	16721	8355	77	0	\N
297614	1678	17280636559000	16721	8355	78	0	\N
297615	1678	17280636560000	16721	8355	79	0	\N
297616	1678	17280636561000	16721	8355	80	0	\N
297617	1678	17280636562000	16721	8355	81	0	\N
297618	1678	17280636563000	16721	8355	82	0	\N
297619	1678	17280636564000	16721	8355	83	0	\N
297620	1678	17280636565000	16721	8355	84	0	\N
297621	1678	17280636566000	16721	8355	85	0	\N
297622	1678	17280636567000	16721	8355	86	0	\N
297623	1678	17280636568000	16721	8355	87	0	\N
297624	1678	17280636569000	16721	8355	88	0	\N
297625	1678	17280636570000	16721	8355	89	0	\N
297626	1678	17280636571000	16721	8355	90	0	\N
297627	1678	17280636572000	16721	8355	91	0	\N
297628	1678	17280636573000	16721	8355	92	0	\N
297629	1678	17280636574000	16721	8355	93	0	\N
297630	1678	17280636575000	16721	8355	94	0	\N
297631	2155	10000000	16721	8355	95	0	\N
297632	2155	10000000	16721	8355	96	0	\N
297633	1678	17280636576000	16721	8355	97	0	\N
297634	1678	17280636577000	16721	8355	98	0	\N
297635	1678	17280636578000	16721	8355	99	0	\N
297636	1678	17280636579000	16721	8355	100	0	\N
297637	1678	17280636580000	16721	8355	101	0	\N
297638	1678	17280636581000	16721	8355	102	0	\N
297639	1678	17280636582000	16721	8355	103	0	\N
297640	1678	17280636583000	16721	8355	104	0	\N
297641	1678	17280636584000	16721	8355	105	0	\N
297642	1678	17280636585000	16721	8355	106	0	\N
297643	1678	17280636586000	16721	8355	107	0	\N
297644	1678	17280636587000	16721	8355	108	0	\N
297645	1678	17280636588000	16721	8355	109	0	\N
297646	1678	17280636589000	16721	8355	110	0	\N
297647	1678	17280636590000	16721	8355	111	0	\N
297648	1678	17280636591000	16721	8355	112	0	\N
297649	1678	17280636592000	16721	8355	113	0	\N
297650	1678	17280636593000	16721	8355	114	0	\N
297651	1678	17280636594000	16721	8355	115	0	\N
297652	1678	17280636595000	16721	8355	116	0	\N
297653	1678	17280636596000	16721	8355	117	0	\N
297654	1678	17280636597000	16721	8355	118	0	\N
297655	1678	17280636598000	16721	8355	119	0	\N
297656	1678	17280636599000	16721	8355	120	0	\N
297657	1678	17280636600000	16721	8355	121	0	\N
297658	1678	17280636601000	16721	8355	122	0	\N
297659	1678	17280636602000	16721	8355	123	0	\N
297660	1678	17280636603000	16721	8355	124	0	\N
297661	1678	17280636604000	16721	8355	125	0	\N
297662	1678	18720659686000	16722	8486	0	0	\N
297663	1678	18720659687000	16722	8486	1	0	\N
297664	1678	18720659688000	16722	8486	2	0	\N
297665	1678	18720659689000	16722	8486	3	0	\N
297666	1678	18720659690000	16722	8486	4	0	\N
297667	1678	18720659691000	16722	8486	5	0	\N
297668	1678	18720659692000	16722	8486	6	0	\N
297669	1678	18720659693000	16722	8486	7	0	\N
297670	1678	18720659694000	16722	8486	8	0	\N
297671	1678	18720659695000	16722	8486	9	0	\N
297672	1678	18720659696000	16722	8486	10	0	\N
297673	1678	18720659697000	16722	8486	11	0	\N
297674	1678	18720659698000	16722	8486	12	0	\N
297675	1874	4417000	16722	8486	13	0	\N
297676	1874	4419000	16722	8486	14	0	\N
297677	1874	4421000	16722	8486	15	0	\N
297678	1874	4424000	16722	8486	16	0	\N
297679	1874	4427000	16722	8486	17	0	\N
297680	1874	4430000	16722	8486	18	0	\N
297681	1874	4432000	16722	8486	19	0	\N
297682	1874	4434000	16722	8486	20	0	\N
297683	1874	4437000	16722	8486	21	0	\N
297684	1874	4438000	16722	8486	22	0	\N
297685	1874	4439000	16722	8486	23	0	\N
297686	1874	4440000	16722	8486	24	0	\N
297687	1874	4441000	16722	8486	25	0	\N
297688	1874	4444000	16722	8486	26	0	\N
297689	1874	4447000	16722	8486	27	0	\N
297690	1874	4450000	16722	8486	28	0	\N
297691	1874	4453000	16722	8486	29	0	\N
297692	1874	4456000	16722	8486	30	0	\N
297693	1874	4459000	16722	8486	31	0	\N
297694	1874	4462000	16722	8486	32	0	\N
297695	1874	4465000	16722	8486	33	0	\N
297696	1874	4467000	16722	8486	34	0	\N
297697	1874	4469000	16722	8486	35	0	\N
297698	1874	4471000	16722	8486	36	0	\N
297699	1874	4473000	16722	8486	37	0	\N
297700	1874	4475000	16722	8486	38	0	\N
297701	1874	4477000	16722	8486	39	0	\N
297702	1874	4479000	16722	8486	40	0	\N
297703	1874	4481000	16722	8486	41	0	\N
297704	1874	4483000	16722	8486	42	0	\N
297705	1678	18720659698000	16723	8494	0	0	\N
297706	1678	18720659699000	16723	8494	1	0	\N
297707	1874	4480000	16723	8494	2	0	\N
297708	1874	4482000	16723	8494	3	0	\N
297709	1874	4483000	16723	8494	4	0	\N
297710	1874	4486000	16723	8494	5	0	\N
297711	1874	4489000	16723	8494	6	0	\N
297719	1678	18720659700000	16725	8495	0	0	\N
297720	1678	18720659701000	16725	8495	1	0	\N
297721	1874	4491000	16725	8495	2	0	\N
297722	1874	4494000	16725	8495	3	0	\N
297723	1874	4497000	16725	8495	4	0	\N
297729	1678	18720659700000	16727	8495	0	0	\N
297730	1678	18720659701000	16727	8495	1	0	\N
297731	1874	4491000	16727	8495	2	0	\N
297732	1874	4494000	16727	8495	3	0	\N
297733	1874	4497000	16727	8495	4	0	\N
297737	1678	18720659703000	16730	8497	0	0	\N
297738	1874	4503000	16730	8497	1	0	\N
297741	1678	18720659704000	16732	8498	0	0	\N
297742	1874	4505000	16732	8498	1	0	\N
297743	1874	4508000	16732	8498	2	0	\N
297747	1678	18720659705000	16734	8499	0	0	\N
297748	1874	4510000	16734	8499	1	0	\N
297749	1874	4513000	16734	8499	2	0	\N
297753	1678	18720659706000	16736	8500	0	0	\N
297754	1340	1700432510151650	16736	8500	1	0	\N
297755	1874	4515000	16736	8500	2	0	\N
297756	1874	4518000	16736	8500	3	0	\N
297757	1874	4519000	16736	8500	4	0	\N
297758	1678	18720659706000	16737	8500	0	0	\N
297759	1340	1700432510151650	16737	8500	1	0	\N
297760	1874	4515000	16737	8500	2	0	\N
297761	1874	4518000	16737	8500	3	0	\N
297762	1874	4519000	16737	8500	4	0	\N
297768	1678	18720659706000	16739	8500	0	0	\N
297769	1340	1700432510151650	16739	8500	1	0	\N
297770	1874	4515000	16739	8500	2	0	\N
297771	1874	4518000	16739	8500	3	0	\N
297772	1874	4519000	16739	8500	4	0	\N
297773	974	504693496200000	16740	8501	0	0	\N
297774	1678	18720659707000	16740	8501	1	0	\N
297775	1678	18720659708000	16740	8501	2	0	\N
297776	1874	4521000	16740	8501	4	0	\N
297777	1874	4523000	16740	8501	5	0	\N
297778	1874	4526000	16740	8501	6	0	\N
297779	1874	4529000	16740	8501	7	0	\N
297780	974	504693496200000	16741	8501	0	0	\N
297781	1678	18720659707000	16741	8501	1	0	\N
297782	1678	18720659708000	16741	8501	2	0	\N
297783	1874	4521000	16741	8501	4	0	\N
297784	1874	4523000	16741	8501	5	0	\N
297785	1874	4526000	16741	8501	6	0	\N
297786	1874	4529000	16741	8501	7	0	\N
297794	946	505422075000000	16743	8215	1	0	\N
297795	1066	905711965000000	16743	8215	2	0	\N
297796	1186	611101950000000	16743	8215	3	0	\N
297797	1312	1702889737751650	16743	8215	4	0	\N
297798	2149	9000000000	16743	8215	5	0	\N
297799	2149	9000000000	16743	8215	6	0	\N
297800	1382	1708727637751650	16743	8215	7	0	\N
297801	1319	1705962637751650	16743	8215	8	0	\N
297802	1073	907346465000000	16743	8215	9	0	\N
297803	1193	612204750000000	16743	8215	10	0	\N
297804	953	506334775000000	16743	8215	11	0	\N
297805	1136	908817465000000	16743	8215	12	0	\N
297806	1256	613196750000000	16743	8215	13	0	\N
297807	1016	507154775000000	16743	8215	14	0	\N
297808	2143	200000000	16743	8215	15	0	\N
297809	2144	200000000	16743	8215	16	0	\N
297810	1678	17280636312000	16743	8215	17	0	\N
297811	1678	17280636313000	16743	8215	18	0	\N
297812	1678	17280636314000	16743	8215	19	0	\N
297813	2152	12300000	16743	8215	20	0	\N
297814	1340	1700432510151650	16743	8215	21	0	\N
297815	974	504693496200000	16743	8215	22	0	\N
297816	1678	17280636315000	16743	8215	23	0	\N
297817	1678	17280636316000	16743	8215	24	0	\N
297818	1678	17280636317000	16743	8215	25	0	\N
297819	1678	17280636318000	16743	8215	26	0	\N
297820	1678	17280636319000	16743	8215	27	0	\N
297821	1678	17280636320000	16743	8215	28	0	\N
297822	1678	17280636321000	16743	8215	29	0	\N
297823	1860	107499987700000	16743	8215	30	0	\N
297824	2145	200000000	16743	8215	31	0	\N
297825	2146	200000000	16743	8215	32	0	\N
297826	2150	200000000	16743	8215	33	0	\N
297827	2151	200000000	16743	8215	34	0	\N
297828	2153	200000000	16743	8215	35	0	\N
297829	2154	200000000	16743	8215	36	0	\N
297830	1678	17280636322000	16743	8215	38	0	\N
297831	1678	17280636323000	16743	8215	39	0	\N
297832	1678	17280636324000	16743	8215	40	0	\N
297833	1678	17280636325000	16743	8215	41	0	\N
297834	1678	17280636326000	16743	8215	42	0	\N
297835	1678	17280636327000	16743	8215	43	0	\N
297836	1678	17280636328000	16743	8215	44	0	\N
297837	1678	17280636329000	16743	8215	45	0	\N
297838	1678	17280636330000	16743	8215	46	0	\N
297839	1678	17280636331000	16743	8215	47	0	\N
297840	1678	17280636332000	16743	8215	48	0	\N
297714	1874	4480000	16724	8494	2	0	2
297715	1874	4482000	16724	8494	3	0	2
297716	1874	4483000	16724	8494	4	0	2
297717	1874	4486000	16724	8494	5	0	2
297718	1874	4489000	16724	8494	6	0	2
297725	1678	18720659701000	16726	8495	1	0	0
297726	1874	4491000	16726	8495	2	0	2
297727	1874	4494000	16726	8495	3	0	2
297728	1874	4497000	16726	8495	4	0	2
297734	1678	18720659702000	16728	8496	0	0	0
297736	1874	4502000	16728	8496	2	0	2
297739	1678	18720659703000	16731	8497	0	0	0
297740	1874	4503000	16731	8497	1	0	2
297744	1678	18720659704000	16733	8498	0	0	0
297746	1874	4508000	16733	8498	2	0	2
297750	1678	18720659705000	16735	8499	0	0	0
297751	1874	4510000	16735	8499	1	0	2
297752	1874	4513000	16735	8499	2	0	2
297763	1678	18720659706000	16738	8500	0	0	0
297765	1874	4515000	16738	8500	2	0	2
297766	1874	4518000	16738	8500	3	0	2
297767	1874	4519000	16738	8500	4	0	2
297787	974	504693496200000	16742	8501	0	0	0
297788	1678	18720659707000	16742	8501	1	0	0
297790	1874	4521000	16742	8501	4	0	2
297791	1874	4523000	16742	8501	5	0	2
297792	1874	4526000	16742	8501	6	0	2
297793	1874	4529000	16742	8501	7	0	2
297841	1678	17280636333000	16743	8215	49	0	\N
297842	1678	17280636334000	16743	8215	50	0	\N
297843	1678	17280636335000	16743	8215	51	0	\N
297844	1678	17280636336000	16743	8215	52	0	\N
297845	1678	17280636337000	16743	8215	53	0	\N
297846	1678	17280636338000	16743	8215	54	0	\N
297847	1678	17280636339000	16743	8215	55	0	\N
297848	1678	17280636340000	16743	8215	56	0	\N
297849	1678	17280636341000	16743	8215	57	0	\N
297850	1678	17280636342000	16743	8215	58	0	\N
297851	1678	17280636343000	16743	8215	59	0	\N
297852	1678	17280636344000	16743	8215	60	0	\N
297853	1678	17280636345000	16743	8215	61	0	\N
297854	1678	17280636346000	16743	8215	62	0	\N
297855	1678	17280636347000	16743	8215	63	0	\N
297856	1678	17280636348000	16743	8215	64	0	\N
297857	1678	17280636349000	16743	8215	65	0	\N
297858	1678	17280636350000	16743	8215	66	0	\N
297859	1678	17280636351000	16743	8215	67	0	\N
297860	1678	17280636352000	16743	8215	69	0	\N
297861	1678	17280636353000	16743	8215	70	0	\N
297862	1678	17280636354000	16743	8215	71	0	\N
297863	1678	17280636355000	16743	8215	72	0	\N
297864	1678	17280636356000	16743	8215	73	0	\N
297865	1678	17280636357000	16743	8215	74	0	\N
297866	1678	17280636358000	16743	8215	75	0	\N
297867	1678	17280636359000	16743	8215	76	0	\N
297868	1678	17280636360000	16743	8215	77	0	\N
297869	1678	17280636361000	16743	8215	78	0	\N
297870	1678	17280636362000	16743	8215	79	0	\N
297871	1678	17280636363000	16743	8215	80	0	\N
297872	1678	17280636364000	16743	8215	81	0	\N
297873	1678	17280636365000	16743	8215	82	0	\N
297874	1678	17280636366000	16743	8215	83	0	\N
297875	1678	17280636367000	16743	8215	84	0	\N
297876	1678	17280636368000	16743	8215	85	0	\N
297877	1678	17280636369000	16743	8215	86	0	\N
297878	1678	17280636370000	16743	8215	87	0	\N
297879	1678	17280636371000	16743	8215	88	0	\N
297880	1678	17280636372000	16743	8215	89	0	\N
297881	1678	17280636373000	16743	8215	90	0	\N
297882	1678	17280636374000	16743	8215	91	0	\N
297883	1678	17280636375000	16743	8215	92	0	\N
297884	1678	17280636376000	16743	8215	93	0	\N
297885	1678	17280636377000	16743	8215	94	0	\N
297886	1678	17280636378000	16743	8215	95	0	\N
297887	1678	17280636379000	16743	8215	96	0	\N
297888	1678	17280636380000	16743	8215	97	0	\N
297889	1678	17280636381000	16743	8215	98	0	\N
297890	1678	17280636382000	16743	8215	99	0	\N
297891	1678	17280636383000	16743	8215	100	0	\N
297892	1678	17280636384000	16743	8215	101	0	\N
297893	1678	17280636385000	16743	8215	102	0	\N
297894	1678	17280636386000	16743	8215	103	0	\N
297895	1678	17280636387000	16743	8215	104	0	\N
297896	1678	17280636388000	16743	8215	105	0	\N
297897	1678	17280636389000	16743	8215	106	0	\N
297898	1678	17280636390000	16743	8215	107	0	\N
297899	1678	17280636391000	16743	8215	108	0	\N
297900	1678	17280636392000	16743	8215	109	0	\N
297901	1678	17280636393000	16743	8215	110	0	\N
297902	1678	17280636394000	16743	8215	111	0	\N
297903	1678	17280636395000	16743	8215	112	0	\N
297904	1678	17280636396000	16743	8215	113	0	\N
297905	1678	17280636397000	16743	8215	114	0	\N
297906	1678	17280636398000	16743	8215	115	0	\N
297907	1678	17280636399000	16743	8215	116	0	\N
297908	1678	17280636400000	16743	8215	117	0	\N
297909	1678	17280636401000	16743	8215	118	0	\N
297910	1678	17280636402000	16743	8215	119	0	\N
297911	1678	17280636403000	16743	8215	120	0	\N
297912	1678	17280636404000	16743	8215	121	0	\N
297913	2155	10000000	16743	8215	122	0	\N
297914	2155	10000000	16743	8215	123	0	\N
297915	1678	17280636405000	16743	8215	124	0	\N
297916	1678	17280636406000	16743	8215	125	0	\N
297917	1340	1700432510151650	16744	8404	0	0	\N
297918	1678	18720659709000	16745	8502	0	0	\N
297919	1678	18720659710000	16745	8502	1	0	\N
297920	1678	18720659711000	16745	8502	2	0	\N
297921	1874	4532000	16745	8502	3	0	\N
297922	1874	4535000	16745	8502	4	0	\N
297923	1874	4536000	16745	8502	5	0	\N
297924	1874	4539000	16745	8502	6	0	\N
297925	1874	4541000	16745	8502	7	0	\N
297926	1874	4543000	16745	8502	8	0	\N
297927	1874	4545000	16745	8502	9	0	\N
297928	1678	18720659709000	16746	8502	0	0	\N
297929	1678	18720659710000	16746	8502	1	0	\N
297930	1678	18720659711000	16746	8502	2	0	\N
297931	1874	4532000	16746	8502	3	0	\N
297932	1874	4535000	16746	8502	4	0	\N
297933	1874	4536000	16746	8502	5	0	\N
297934	1874	4539000	16746	8502	6	0	\N
297935	1874	4541000	16746	8502	7	0	\N
297936	1874	4543000	16746	8502	8	0	\N
297937	1874	4545000	16746	8502	9	0	\N
297938	1678	18720659709000	16747	8502	0	0	\N
297939	1678	18720659710000	16747	8502	1	0	\N
297940	1678	18720659711000	16747	8502	2	0	\N
297941	1874	4532000	16747	8502	3	0	\N
297942	1874	4535000	16747	8502	4	0	\N
297943	1874	4536000	16747	8502	5	0	\N
297944	1874	4539000	16747	8502	6	0	\N
297945	1874	4541000	16747	8502	7	0	\N
297946	1874	4543000	16747	8502	8	0	\N
297947	1874	4545000	16747	8502	9	0	\N
297958	1678	18720659712000	16749	8503	0	0	\N
297959	974	504694496200000	16749	8503	1	0	\N
297960	1874	4548000	16749	8503	2	0	\N
297961	1874	4550000	16749	8503	3	0	\N
297962	1678	18720659712000	16750	8503	0	0	\N
297963	974	504694496200000	16750	8503	1	0	\N
297964	1874	4548000	16750	8503	2	0	\N
297965	1874	4550000	16750	8503	3	0	\N
297976	1678	18720659714000	16754	8505	0	0	\N
297950	1678	18720659711000	16748	8502	2	0	0
297951	1874	4532000	16748	8502	3	0	2
297952	1874	4535000	16748	8502	4	0	2
297953	1874	4536000	16748	8502	5	0	2
297954	1874	4539000	16748	8502	6	0	2
297956	1874	4543000	16748	8502	8	0	2
297957	1874	4545000	16748	8502	9	0	2
297966	1678	18720659712000	16751	8503	0	0	0
297967	974	504694496200000	16751	8503	1	0	0
297968	1874	4548000	16751	8503	2	0	2
297970	1678	18720659713000	16752	8504	0	0	0
297971	1874	4553000	16752	8504	1	0	2
297972	1874	4554000	16752	8504	2	0	2
297973	1678	18720659714000	16753	8505	0	0	0
297975	1874	4559000	16753	8505	2	0	2
297977	1874	4557000	16754	8505	1	0	\N
297978	1874	4559000	16754	8505	2	0	\N
297982	1678	18000647642000	16756	8384	0	0	\N
297983	1678	18000647643000	16756	8384	1	0	\N
297984	1678	18000647644000	16756	8384	2	0	\N
297985	1678	18000647645000	16756	8384	4	0	\N
297986	1678	18000647646000	16756	8384	5	0	\N
297987	1678	18000647647000	16756	8384	6	0	\N
297988	1678	18000647648000	16756	8384	7	0	\N
297989	1678	18000647649000	16756	8384	8	0	\N
297990	1678	18000647650000	16756	8384	9	0	\N
297991	1678	18000647651000	16756	8384	10	0	\N
297992	1678	18000647652000	16756	8384	11	0	\N
297993	1678	18000647653000	16756	8384	12	0	\N
297994	1678	18000647654000	16756	8384	13	0	\N
297995	1678	18000647655000	16756	8384	14	0	\N
297996	1678	18000647656000	16756	8384	15	0	\N
297997	1678	18000647657000	16756	8384	16	0	\N
297998	1678	18000647658000	16756	8384	17	0	\N
297999	1678	18000647659000	16756	8384	18	0	\N
298000	1678	18000647660000	16756	8384	19	0	\N
298001	1678	18000647661000	16756	8384	20	0	\N
298002	1678	18000647662000	16756	8384	21	0	\N
298003	1678	18000647663000	16756	8384	22	0	\N
298004	1678	18000647664000	16756	8384	23	0	\N
298005	1340	1700432510151650	16756	8384	24	0	\N
298006	974	504693496200000	16756	8384	25	0	\N
298007	974	504694496200000	16756	8384	26	0	\N
298008	1678	18000647665000	16756	8384	27	0	\N
298009	1678	18000647666000	16756	8384	28	0	\N
298010	1678	18000647667000	16756	8384	29	0	\N
298011	1678	18000647668000	16756	8384	30	0	\N
298012	1678	18000647669000	16756	8384	31	0	\N
298013	1678	18000647670000	16756	8384	32	0	\N
298014	1678	18000647671000	16756	8384	33	0	\N
298015	1678	18000647672000	16756	8384	34	0	\N
298016	1678	18000647673000	16756	8384	35	0	\N
298017	1678	18000647674000	16756	8384	36	0	\N
298018	1678	18000647675000	16756	8384	37	0	\N
298019	1678	18000647676000	16756	8384	38	0	\N
298020	1678	18000647677000	16756	8384	39	0	\N
298021	1678	18000647678000	16756	8384	40	0	\N
298022	1678	18000647679000	16756	8384	41	0	\N
298023	1678	18000647680000	16756	8384	42	0	\N
298024	1678	18000647681000	16756	8384	43	0	\N
298025	1678	18000647682000	16756	8384	44	0	\N
298026	1678	18000647683000	16756	8384	45	0	\N
298027	1678	18000647684000	16756	8384	46	0	\N
298028	1678	18000647685000	16756	8384	47	0	\N
298029	1678	18000647686000	16756	8384	48	0	\N
298030	1678	18000647687000	16756	8384	49	0	\N
298031	1678	18000647688000	16756	8384	50	0	\N
298032	1678	18000647689000	16756	8384	51	0	\N
298033	1678	18000647690000	16756	8384	52	0	\N
298034	1678	18000647691000	16756	8384	53	0	\N
298035	1678	18000647692000	16756	8384	54	0	\N
298036	1678	18000647693000	16756	8384	55	0	\N
298037	1678	18000647694000	16756	8384	56	0	\N
298038	1678	18000647695000	16756	8384	57	0	\N
298039	1678	18000647696000	16756	8384	58	0	\N
298040	1678	18000647697000	16756	8384	59	0	\N
298041	1678	18000647698000	16756	8384	60	0	\N
298042	1678	18000647699000	16756	8384	61	0	\N
298043	1678	18000647700000	16756	8384	62	0	\N
298044	1678	18000647701000	16756	8384	63	0	\N
298045	1678	18000647702000	16756	8384	64	0	\N
298046	1678	18000647703000	16756	8384	65	0	\N
298047	1678	18000647704000	16756	8384	66	0	\N
298048	1678	18000647705000	16756	8384	67	0	\N
298049	1678	18000647706000	16756	8384	68	0	\N
298050	1678	18000647707000	16756	8384	69	0	\N
298051	1678	18000647708000	16756	8384	70	0	\N
298052	1678	18000647709000	16756	8384	71	0	\N
298053	1678	18000647710000	16756	8384	72	0	\N
298054	1678	18000647711000	16756	8384	73	0	\N
298055	1678	18000647712000	16756	8384	74	0	\N
298056	1678	18000647713000	16756	8384	75	0	\N
298057	1678	18000647714000	16756	8384	76	0	\N
298058	1527	271999978	16756	8384	77	0	\N
298059	1874	3624000	16756	8384	78	0	\N
298060	1874	3625000	16756	8384	79	0	\N
298061	1874	3627000	16756	8384	80	0	\N
298062	1874	3628000	16756	8384	81	0	\N
298063	1874	3629000	16756	8384	82	0	\N
298064	1874	3630000	16756	8384	83	0	\N
298065	1874	3631000	16756	8384	84	0	\N
298066	1874	3632000	16756	8384	85	0	\N
298067	1874	3635000	16756	8384	86	0	\N
298068	1874	3638000	16756	8384	87	0	\N
298069	1874	3641000	16756	8384	88	0	\N
298070	1527	271999978	16756	8384	89	0	\N
298071	1874	3642000	16756	8384	90	0	\N
298072	1874	3643000	16756	8384	91	0	\N
298073	1874	3644000	16756	8384	92	0	\N
298074	1874	3645000	16756	8384	93	0	\N
298075	1874	3648000	16756	8384	96	0	\N
298076	1874	3651000	16756	8384	97	0	\N
298077	1874	3654000	16756	8384	98	0	\N
298078	1874	3657000	16756	8384	99	0	\N
298079	1874	3660000	16756	8384	100	0	\N
298080	1874	3663000	16756	8384	101	0	\N
298081	1874	3665000	16756	8384	102	0	\N
298082	1874	3667000	16756	8384	103	0	\N
298083	1874	3669000	16756	8384	104	0	\N
298084	1874	3671000	16756	8384	105	0	\N
298085	1874	3673000	16756	8384	106	0	\N
298086	1874	3675000	16756	8384	107	0	\N
298087	1874	3677000	16756	8384	108	0	\N
298088	1874	3679000	16756	8384	109	0	\N
298089	1874	3681000	16756	8384	110	0	\N
298090	1874	3683000	16756	8384	111	0	\N
298091	1874	3685000	16756	8384	112	0	\N
298092	1874	3687000	16756	8384	113	0	\N
298093	1874	3689000	16756	8384	114	0	\N
298094	1874	3691000	16756	8384	115	0	\N
298095	1874	3693000	16756	8384	116	0	\N
298096	1874	3695000	16756	8384	117	0	\N
298097	1874	3697000	16756	8384	118	0	\N
298098	1874	3699000	16756	8384	119	0	\N
298099	1874	3701000	16756	8384	120	0	\N
298100	1874	3703000	16756	8384	121	0	\N
298101	1874	3705000	16756	8384	122	0	\N
298102	1874	3707000	16756	8384	123	0	\N
298103	1874	3709000	16756	8384	124	0	\N
298104	1874	3711000	16756	8384	125	0	\N
298105	1874	4565000	16757	8507	0	0	\N
298106	1874	4567000	16757	8507	1	0	\N
298107	1874	4570000	16757	8507	2	0	\N
298108	1874	4565000	16758	8507	0	0	\N
298109	1874	4567000	16758	8507	1	0	\N
298110	1874	4570000	16758	8507	2	0	\N
298111	1874	4565000	16759	8507	0	0	\N
298112	1874	4567000	16759	8507	1	0	\N
297981	1874	4564000	16755	8506	2	0	2
298113	1874	4570000	16759	8507	2	0	\N
298117	1678	18720659716000	16761	8508	0	0	\N
298118	1874	4572000	16761	8508	1	0	\N
298119	1874	4575000	16761	8508	2	0	\N
298123	1678	18720659716000	16763	8508	0	0	\N
298124	1874	4572000	16763	8508	1	0	\N
298125	1874	4575000	16763	8508	2	0	\N
298131	1678	18720659718000	16766	8510	0	0	\N
298132	1874	4582000	16766	8510	1	0	\N
298133	1678	18000647715000	16767	8385	0	0	\N
298134	1678	18000647716000	16767	8385	1	0	\N
298135	1678	18000647717000	16767	8385	2	0	\N
298136	1678	18000647718000	16767	8385	4	0	\N
298137	1874	3713000	16767	8385	5	0	\N
298138	1874	3715000	16767	8385	6	0	\N
298139	1874	3717000	16767	8385	7	0	\N
298140	1874	3719000	16767	8385	8	0	\N
298141	1874	3721000	16767	8385	9	0	\N
298142	1874	3722000	16767	8385	10	0	\N
298143	1874	3723000	16767	8385	11	0	\N
298144	1874	3724000	16767	8385	12	0	\N
298145	1874	3725000	16767	8385	13	0	\N
298146	1874	3726000	16767	8385	14	0	\N
298147	1874	3727000	16767	8385	15	0	\N
298148	1874	3729000	16767	8385	16	0	\N
298149	1874	3731000	16767	8385	17	0	\N
298150	1874	3733000	16767	8385	18	0	\N
298151	1874	3735000	16767	8385	19	0	\N
298152	1874	3737000	16767	8385	20	0	\N
298153	1874	3739000	16767	8385	21	0	\N
298154	1874	3741000	16767	8385	22	0	\N
298155	1874	3743000	16767	8385	23	0	\N
298156	1874	3745000	16767	8385	24	0	\N
298157	1874	3747000	16767	8385	25	0	\N
298158	1874	3749000	16767	8385	26	0	\N
298159	1874	3751000	16767	8385	27	0	\N
298160	1874	3753000	16767	8385	28	0	\N
298161	1874	3755000	16767	8385	29	0	\N
298162	1874	3757000	16767	8385	30	0	\N
298163	1874	3759000	16767	8385	31	0	\N
298164	1874	3761000	16767	8385	32	0	\N
298165	1874	3763000	16767	8385	33	0	\N
298166	1874	3765000	16767	8385	34	0	\N
298167	1874	3767000	16767	8385	35	0	\N
298168	1874	3769000	16767	8385	36	0	\N
298169	1874	3771000	16767	8385	37	0	\N
298170	1874	3773000	16767	8385	38	0	\N
298171	1874	3775000	16767	8385	39	0	\N
298172	1874	3777000	16767	8385	40	0	\N
298173	1874	3779000	16767	8385	41	0	\N
298174	1874	3781000	16767	8385	42	0	\N
298175	1874	3783000	16767	8385	43	0	\N
298176	1874	3785000	16767	8385	44	0	\N
298177	1874	3787000	16767	8385	45	0	\N
298178	1874	3789000	16767	8385	46	0	\N
298179	1874	3791000	16767	8385	47	0	\N
298180	1874	3793000	16767	8385	48	0	\N
298181	1874	3795000	16767	8385	49	0	\N
298182	1874	3797000	16767	8385	50	0	\N
298183	1874	3799000	16767	8385	51	0	\N
298184	1874	3801000	16767	8385	52	0	\N
298185	1874	3803000	16767	8385	53	0	\N
298186	1874	3805000	16767	8385	54	0	\N
298187	1874	3807000	16767	8385	55	0	\N
298188	1874	3809000	16767	8385	56	0	\N
298189	1874	3811000	16767	8385	57	0	\N
298190	1874	3813000	16767	8385	58	0	\N
298191	1874	3815000	16767	8385	59	0	\N
298192	1874	3817000	16767	8385	60	0	\N
298193	1874	3819000	16767	8385	61	0	\N
298194	1874	3821000	16767	8385	62	0	\N
298195	1874	3823000	16767	8385	63	0	\N
298210	1678	18720659721000	16771	8513	0	0	\N
298211	1678	18720659722000	16771	8513	1	0	\N
298212	1874	4596000	16771	8513	2	0	\N
298213	1874	4598000	16771	8513	3	0	\N
298214	1874	4600000	16771	8513	4	0	\N
298215	1874	4603000	16771	8513	5	0	\N
298216	1874	4604000	16771	8513	6	0	\N
298217	1319	1705962637751650	16772	8410	0	0	\N
298218	1073	907346465000000	16772	8410	1	0	\N
298219	1193	612204750000000	16772	8410	2	0	\N
298220	953	506334775000000	16772	8410	3	0	\N
298221	1678	18000647630000	16772	8410	4	0	\N
298222	1678	18000647631000	16772	8410	5	0	\N
298223	1678	18000647632000	16772	8410	6	0	\N
298224	1678	18000647633000	16772	8410	7	0	\N
298225	1678	18000647634000	16772	8410	8	0	\N
298226	1678	18000647635000	16772	8410	9	0	\N
298227	1678	18000647636000	16772	8410	10	0	\N
298228	1678	18000647637000	16772	8410	11	0	\N
298229	1340	1700432510151650	16772	8410	12	0	\N
298230	974	504693496200000	16772	8410	13	0	\N
298231	974	504694496200000	16772	8410	14	0	\N
298232	1678	18000647638000	16772	8410	15	0	\N
298233	1678	18000647639000	16772	8410	16	0	\N
298234	1678	18000647640000	16772	8410	17	0	\N
298235	1678	18000647641000	16772	8410	18	0	\N
298236	1678	18000647642000	16772	8410	19	0	\N
298237	1678	18000647643000	16772	8410	20	0	\N
298238	1678	18000647644000	16772	8410	21	0	\N
298239	1678	18000647645000	16772	8410	22	0	\N
298240	1678	18000647646000	16772	8410	23	0	\N
298241	1678	18000647647000	16772	8410	24	0	\N
298242	1678	18000647648000	16772	8410	25	0	\N
298243	1678	18000647649000	16772	8410	26	0	\N
298244	1678	18000647650000	16772	8410	27	0	\N
298245	1678	18000647651000	16772	8410	28	0	\N
298246	1678	18000647652000	16772	8410	29	0	\N
298247	1678	18000647653000	16772	8410	30	0	\N
298248	1678	18000647654000	16772	8410	31	0	\N
298116	1874	4570000	16760	8507	2	0	2
298120	1678	18720659716000	16762	8508	0	0	0
298121	1874	4572000	16762	8508	1	0	2
298122	1874	4575000	16762	8508	2	0	2
298126	1678	18720659717000	16764	8509	0	0	0
298128	1874	4580000	16764	8509	2	0	2
298129	1678	18720659718000	16765	8510	0	0	0
298130	1874	4582000	16765	8510	1	0	2
298196	1678	18720659719000	16768	8511	0	0	0
298197	1874	4584000	16768	8511	1	0	2
298199	1874	4588000	16768	8511	3	0	2
298200	1678	18720659720000	16769	8512	0	0	0
298201	1874	4590000	16769	8512	1	0	2
298202	1874	4593000	16769	8512	2	0	2
298204	1678	18720659722000	16770	8513	1	0	0
298205	1874	4596000	16770	8513	2	0	2
298206	1874	4598000	16770	8513	3	0	2
298207	1874	4600000	16770	8513	4	0	2
298208	1874	4603000	16770	8513	5	0	2
298249	1678	18000647655000	16772	8410	32	0	\N
298250	1678	18000647656000	16772	8410	33	0	\N
298251	1678	18000647657000	16772	8410	34	0	\N
298252	1678	18000647658000	16772	8410	35	0	\N
298253	1678	18000647659000	16772	8410	36	0	\N
298254	1678	18000647660000	16772	8410	37	0	\N
298255	1678	18000647661000	16772	8410	38	0	\N
298256	1678	18000647662000	16772	8410	39	0	\N
298257	1678	18000647663000	16772	8410	40	0	\N
298258	1678	18000647664000	16772	8410	41	0	\N
298259	1678	18000647665000	16772	8410	42	0	\N
298260	1678	18000647666000	16772	8410	43	0	\N
298261	1678	18000647667000	16772	8410	44	0	\N
298262	1678	18000647668000	16772	8410	45	0	\N
298263	1678	18000647669000	16772	8410	46	0	\N
298264	1678	18000647670000	16772	8410	47	0	\N
298265	1678	18000647671000	16772	8410	48	0	\N
298266	1678	18000647672000	16772	8410	49	0	\N
298267	1678	18000647673000	16772	8410	50	0	\N
298268	1678	18000647674000	16772	8410	51	0	\N
298269	1678	18000647675000	16772	8410	52	0	\N
298270	1678	18000647676000	16772	8410	53	0	\N
298271	1678	18000647677000	16772	8410	54	0	\N
298272	1678	18000647678000	16772	8410	55	0	\N
298273	1678	18000647679000	16772	8410	56	0	\N
298274	1678	18000647680000	16772	8410	57	0	\N
298275	1678	18000647681000	16772	8410	58	0	\N
298276	1678	18000647682000	16772	8410	59	0	\N
298277	1678	18000647683000	16772	8410	60	0	\N
298278	1678	18000647684000	16772	8410	61	0	\N
298279	1678	18000647685000	16772	8410	62	0	\N
298280	1678	18000647686000	16772	8410	63	0	\N
298281	1678	18000647687000	16772	8410	64	0	\N
298282	1678	18000647688000	16772	8410	65	0	\N
298283	1678	18000647689000	16772	8410	66	0	\N
298284	1678	18000647690000	16772	8410	67	0	\N
298285	1678	18000647691000	16772	8410	68	0	\N
298286	1678	18000647692000	16772	8410	69	0	\N
298287	1678	18000647693000	16772	8410	70	0	\N
298288	1678	18000647694000	16772	8410	71	0	\N
298289	1678	18000647695000	16772	8410	72	0	\N
298290	1678	18000647696000	16772	8410	73	0	\N
298291	1678	18000647697000	16772	8410	74	0	\N
298292	1678	18000647698000	16772	8410	75	0	\N
298293	1678	18000647699000	16772	8410	76	0	\N
298294	1678	18000647700000	16772	8410	77	0	\N
298295	1678	18000647701000	16772	8410	78	0	\N
298296	1678	18000647702000	16772	8410	79	0	\N
298297	1678	18000647703000	16772	8410	80	0	\N
298298	1678	18000647704000	16772	8410	81	0	\N
298299	1678	18000647705000	16772	8410	82	0	\N
298300	1678	18000647706000	16772	8410	83	0	\N
298301	1678	18000647707000	16772	8410	84	0	\N
298302	1678	18000647708000	16772	8410	85	0	\N
298303	1678	18000647709000	16772	8410	86	0	\N
298304	1678	18000647710000	16772	8410	87	0	\N
298305	1678	18000647711000	16772	8410	88	0	\N
298306	1678	18000647712000	16772	8410	89	0	\N
298307	1678	18000647713000	16772	8410	90	0	\N
298308	1678	18000647714000	16772	8410	91	0	\N
298309	1678	18000647715000	16772	8410	92	0	\N
298310	1678	18000647716000	16772	8410	93	0	\N
298311	1678	18000647717000	16772	8410	94	0	\N
298312	1678	18000647718000	16772	8410	95	0	\N
298313	1678	18000647719000	16772	8410	96	0	\N
298314	1678	18000647720000	16772	8410	97	0	\N
298315	1678	18000647721000	16772	8410	98	0	\N
298316	1678	18000647722000	16772	8410	99	0	\N
298317	1527	271999978	16772	8410	100	0	\N
298318	1874	4130000	16772	8410	101	0	\N
298319	1874	4131000	16772	8410	102	0	\N
298320	1874	4133000	16772	8410	103	0	\N
298321	1874	4135000	16772	8410	104	0	\N
298322	1874	4137000	16772	8410	105	0	\N
298323	1874	4140000	16772	8410	106	0	\N
298324	1874	4141000	16772	8410	107	0	\N
298325	1874	4142000	16772	8410	108	0	\N
298326	1874	4143000	16772	8410	109	0	\N
298327	1874	4144000	16772	8410	110	0	\N
298328	1874	4145000	16772	8410	111	0	\N
298329	1874	4146000	16772	8410	112	0	\N
298330	1874	4147000	16772	8410	113	0	\N
298331	1874	4148000	16772	8410	114	0	\N
298332	1874	4149000	16772	8410	115	0	\N
298333	1874	4150000	16772	8410	116	0	\N
298334	1874	4151000	16772	8410	117	0	\N
298335	1874	4153000	16772	8410	118	0	\N
298336	1874	4155000	16772	8410	119	0	\N
298337	1874	4157000	16772	8410	120	0	\N
298338	1874	4159000	16772	8410	121	0	\N
298339	1874	4161000	16772	8410	122	0	\N
298340	1874	4163000	16772	8410	123	0	\N
298341	1874	4166000	16772	8410	124	0	\N
298342	1874	4169000	16772	8410	125	0	\N
298343	1678	18720659723000	16773	8514	0	0	\N
298344	1678	18720659724000	16773	8514	1	0	\N
298345	1678	18720659725000	16773	8514	2	0	\N
298346	1678	18720659726000	16773	8514	3	0	\N
298347	1874	4607000	16773	8514	4	0	\N
298348	1874	4610000	16773	8514	5	0	\N
298349	1874	4612000	16773	8514	6	0	\N
298350	1874	4614000	16773	8514	7	0	\N
298351	1874	4616000	16773	8514	8	0	\N
298352	1874	4618000	16773	8514	9	0	\N
298353	1874	4619000	16773	8514	10	0	\N
298354	1874	4622000	16773	8514	11	0	\N
298355	1874	4625000	16773	8514	12	0	\N
298372	1678	18720659727000	16776	8515	0	0	\N
298373	1874	4627000	16776	8515	1	0	\N
298374	1874	4630000	16776	8515	2	0	\N
298358	1678	18720659725000	16774	8514	2	0	0
298359	1678	18720659726000	16774	8514	3	0	0
298360	1874	4607000	16774	8514	4	0	2
298361	1874	4610000	16774	8514	5	0	2
298362	1874	4612000	16774	8514	6	0	2
298364	1874	4616000	16774	8514	8	0	2
298365	1874	4618000	16774	8514	9	0	2
298366	1874	4619000	16774	8514	10	0	2
298367	1874	4622000	16774	8514	11	0	2
298368	1874	4625000	16774	8514	12	0	2
298370	1874	4627000	16775	8515	1	0	2
298371	1874	4630000	16775	8515	2	0	2
298375	1678	18720659728000	16777	8516	0	0	0
298376	1678	18720659729000	16777	8516	1	0	0
298378	1874	4634000	16777	8516	3	0	2
298379	1874	4637000	16777	8516	4	0	2
298380	1874	4639000	16777	8516	5	0	2
298381	1874	4641000	16777	8516	6	0	2
298382	1678	18720659730000	16778	8517	0	0	0
298384	1874	4646000	16778	8517	2	0	2
298385	1678	18720659730000	16779	8517	0	0	\N
298386	1874	4643000	16779	8517	1	0	\N
298387	1874	4646000	16779	8517	2	0	\N
298391	1678	18720659732000	16781	8519	0	0	\N
298392	1678	18720659733000	16781	8519	1	0	\N
298393	1874	4653000	16781	8519	2	0	\N
298394	1874	4654000	16781	8519	3	0	\N
298395	1874	4657000	16781	8519	4	0	\N
298396	1874	4660000	16781	8519	5	0	\N
298397	1874	4662000	16781	8519	6	0	\N
298398	1678	18720659732000	16782	8519	0	0	\N
298399	1678	18720659733000	16782	8519	1	0	\N
298400	1874	4653000	16782	8519	2	0	\N
298401	1874	4654000	16782	8519	3	0	\N
298402	1874	4657000	16782	8519	4	0	\N
298403	1874	4660000	16782	8519	5	0	\N
298404	1874	4662000	16782	8519	6	0	\N
298412	1678	18000647690000	16784	8429	0	0	\N
298413	1678	18000647691000	16784	8429	1	0	\N
298414	1678	18000647692000	16784	8429	2	0	\N
298415	1678	18000647693000	16784	8429	3	0	\N
298416	1678	18000647694000	16784	8429	4	0	\N
298417	1678	18000647695000	16784	8429	5	0	\N
298418	1340	1700432510151650	16784	8429	6	0	\N
298419	974	504693496200000	16784	8429	7	0	\N
298420	974	504694496200000	16784	8429	8	0	\N
298421	1678	18000647696000	16784	8429	9	0	\N
298422	1678	18000647697000	16784	8429	10	0	\N
298423	1678	18000647698000	16784	8429	11	0	\N
298424	1678	18000647699000	16784	8429	12	0	\N
298425	1678	18000647700000	16784	8429	13	0	\N
298426	1678	18000647701000	16784	8429	14	0	\N
298427	1678	18000647702000	16784	8429	15	0	\N
298428	1678	18000647703000	16784	8429	16	0	\N
298429	1678	18000647704000	16784	8429	17	0	\N
298430	1678	18000647705000	16784	8429	20	0	\N
298431	1678	18000647706000	16784	8429	21	0	\N
298432	1678	18000647707000	16784	8429	22	0	\N
298433	1678	18000647708000	16784	8429	23	0	\N
298434	1678	18000647709000	16784	8429	24	0	\N
298435	1678	18000647710000	16784	8429	25	0	\N
298436	1678	18000647711000	16784	8429	26	0	\N
298437	1678	18000647712000	16784	8429	27	0	\N
298438	1678	18000647713000	16784	8429	28	0	\N
298439	1678	18000647714000	16784	8429	29	0	\N
298440	1678	18000647715000	16784	8429	30	0	\N
298441	1678	18000647716000	16784	8429	31	0	\N
298442	1678	18000647717000	16784	8429	32	0	\N
298443	1678	18000647718000	16784	8429	33	0	\N
298444	1678	18000647719000	16784	8429	34	0	\N
298445	1678	18000647720000	16784	8429	35	0	\N
298446	1678	18000647721000	16784	8429	36	0	\N
298447	1678	18000647722000	16784	8429	37	0	\N
298448	1678	18000647723000	16784	8429	38	0	\N
298449	1678	18000647724000	16784	8429	39	0	\N
298450	1678	18000647725000	16784	8429	40	0	\N
298451	1678	18000647726000	16784	8429	41	0	\N
298452	1678	18000647727000	16784	8429	42	0	\N
298453	1678	18000647728000	16784	8429	43	0	\N
298454	1678	18000647729000	16784	8429	44	0	\N
298455	1678	18000647730000	16784	8429	45	0	\N
298456	1678	18000647731000	16784	8429	46	0	\N
298457	1678	18000647732000	16784	8429	47	0	\N
298458	1678	18000647733000	16784	8429	48	0	\N
298459	1874	4084000	16784	8429	49	0	\N
298460	1874	4086000	16784	8429	50	0	\N
298461	1874	4087000	16784	8429	51	0	\N
298462	1874	4088000	16784	8429	52	0	\N
298463	1874	4089000	16784	8429	53	0	\N
298464	1874	4091000	16784	8429	56	0	\N
298465	1874	4093000	16784	8429	57	0	\N
298466	1874	4094000	16784	8429	58	0	\N
298467	1874	4095000	16784	8429	59	0	\N
298468	1874	4096000	16784	8429	60	0	\N
298469	1874	4097000	16784	8429	61	0	\N
298470	1874	4098000	16784	8429	62	0	\N
298471	1874	4099000	16784	8429	63	0	\N
298472	1874	4100000	16784	8429	64	0	\N
298473	1874	4101000	16784	8429	65	0	\N
298474	1678	18720659734000	16785	8520	0	0	\N
298475	1874	4665000	16785	8520	1	0	\N
298476	1874	4667000	16785	8520	2	0	\N
298477	1382	1708727637751650	16786	8235	0	0	\N
298478	1319	1705962637751650	16786	8235	1	0	\N
298479	1073	907346465000000	16786	8235	2	0	\N
298480	1193	612204750000000	16786	8235	3	0	\N
298481	953	506334775000000	16786	8235	4	0	\N
298482	1136	908817465000000	16786	8235	5	0	\N
298483	1256	613196750000000	16786	8235	6	0	\N
298484	1016	507154775000000	16786	8235	7	0	\N
298485	1340	1700432510151650	16786	8235	8	0	\N
298486	974	504693496200000	16786	8235	9	0	\N
298487	974	504694496200000	16786	8235	10	0	\N
298488	2155	10000000	16786	8235	12	0	\N
298489	2155	10000000	16786	8235	13	0	\N
298490	1527	271999978	16786	8235	14	0	\N
298491	1527	271999978	16786	8235	15	0	\N
298495	1678	18720659734000	16788	8520	0	0	\N
298496	1874	4665000	16788	8520	1	0	\N
298497	1874	4667000	16788	8520	2	0	\N
298498	1678	18720659734000	16789	8520	0	0	\N
298499	1874	4665000	16789	8520	1	0	\N
298500	1874	4667000	16789	8520	2	0	\N
298507	1678	18720659736000	16792	8522	0	0	\N
298508	1874	4675000	16792	8522	1	0	\N
298509	1874	4676000	16792	8522	2	0	\N
298510	1678	18720659737000	16793	8523	0	0	\N
298511	1874	4678000	16793	8523	1	0	\N
298512	1874	4681000	16793	8523	2	0	\N
298520	414	66000011000000	16796	8525	0	0	\N
298390	1874	4651000	16780	8518	2	0	2
298405	1678	18720659732000	16783	8519	0	0	0
298406	1678	18720659733000	16783	8519	1	0	0
298407	1874	4653000	16783	8519	2	0	2
298408	1874	4654000	16783	8519	3	0	2
298410	1874	4660000	16783	8519	5	0	2
298411	1874	4662000	16783	8519	6	0	2
298492	1678	18720659734000	16787	8520	0	0	0
298493	1874	4665000	16787	8520	1	0	2
298494	1874	4667000	16787	8520	2	0	2
298502	1874	4669000	16790	8521	1	0	2
298503	1874	4672000	16790	8521	2	0	2
298504	1678	18720659736000	16791	8522	0	0	0
298505	1874	4675000	16791	8522	1	0	2
298513	1678	18720659737000	16794	8523	0	0	0
298514	1874	4678000	16794	8523	1	0	2
298515	1874	4681000	16794	8523	2	0	2
298516	2156	718900000000	16795	8524	0	0	0
298517	1678	18720659738000	16795	8524	1	0	0
298519	1874	4686000	16795	8524	3	0	2
298521	1678	18720659739000	16796	8525	1	0	\N
298522	1678	18720659740000	16796	8525	2	0	\N
298523	1299	1703411285540250	16796	8525	3	0	\N
298524	1053	905989686644800	16796	8525	4	0	\N
298525	1173	611289469681700	16796	8525	5	0	\N
298526	933	505577712770200	16796	8525	6	0	\N
298527	1874	4688000	16796	8525	7	0	\N
298528	1874	4689000	16796	8525	8	0	\N
298529	1874	4692000	16796	8525	9	0	\N
298530	1874	4695000	16796	8525	10	0	\N
298531	414	66000011000000	16797	8525	0	0	\N
298532	1678	18720659739000	16797	8525	1	0	\N
298533	1678	18720659740000	16797	8525	2	0	\N
298534	1299	1703411285540250	16797	8525	3	0	\N
298535	1053	905989686644800	16797	8525	4	0	\N
298536	1173	611289469681700	16797	8525	5	0	\N
298537	933	505577712770200	16797	8525	6	0	\N
298538	1874	4688000	16797	8525	7	0	\N
298539	1874	4689000	16797	8525	8	0	\N
298540	1874	4692000	16797	8525	9	0	\N
298541	1874	4695000	16797	8525	10	0	\N
298556	1678	18720659742000	16800	8527	0	0	\N
298557	1874	4702000	16800	8527	1	0	\N
298558	1874	4705000	16800	8527	2	0	\N
298559	1874	4706000	16800	8527	3	0	\N
298567	1678	18720659743000	16803	8528	0	0	\N
298568	1874	4709000	16803	8528	1	0	\N
298569	1874	4711000	16803	8528	2	0	\N
298570	1678	18720659744000	16804	8529	0	0	\N
298571	1874	4713000	16804	8529	1	0	\N
298572	1874	4716000	16804	8529	2	0	\N
298576	1678	18720659745000	16806	8530	0	0	\N
298577	1874	4719000	16806	8530	1	0	\N
298583	2156	718900000000	16810	8337	0	0	\N
298584	1340	1700432510151650	16810	8337	1	0	\N
298585	974	504693496200000	16810	8337	2	0	\N
298586	974	504694496200000	16810	8337	3	0	\N
298587	1299	1703411285540250	16810	8337	4	0	\N
298588	1053	905989686644800	16810	8337	5	0	\N
298589	1678	18720659747000	16812	8533	0	0	\N
298590	1678	18720659748000	16812	8533	1	0	\N
298591	1678	18720659749000	16812	8533	2	0	\N
298592	1874	4723000	16812	8533	3	0	\N
298593	1874	4725000	16812	8533	4	0	\N
298594	1874	4727000	16812	8533	5	0	\N
298595	1874	4729000	16812	8533	6	0	\N
298596	1874	4732000	16812	8533	7	0	\N
298597	1874	4735000	16812	8533	8	0	\N
298598	1874	4738000	16812	8533	9	0	\N
298599	1874	4741000	16812	8533	10	0	\N
298611	1678	18720659747000	16814	8533	0	0	\N
298612	1678	18720659748000	16814	8533	1	0	\N
298613	1678	18720659749000	16814	8533	2	0	\N
298614	1874	4723000	16814	8533	3	0	\N
298615	1874	4725000	16814	8533	4	0	\N
298616	1874	4727000	16814	8533	5	0	\N
298617	1874	4729000	16814	8533	6	0	\N
298618	1874	4732000	16814	8533	7	0	\N
298619	1874	4735000	16814	8533	8	0	\N
298620	1874	4738000	16814	8533	9	0	\N
298621	1874	4741000	16814	8533	10	0	\N
298622	1678	18720659750000	16815	8534	0	0	\N
298623	1874	4744000	16815	8534	1	0	\N
298635	1678	18720659753000	16820	8537	0	0	\N
298636	1874	4758000	16820	8537	1	0	\N
298637	1678	18720659754000	16821	8538	0	0	\N
298638	1874	4761000	16821	8538	1	0	\N
298639	1874	4763000	16821	8538	2	0	\N
298643	1678	18720659755000	16823	8539	0	0	\N
298644	1874	4765000	16823	8539	1	0	\N
298647	1678	18720659755000	16825	8539	0	0	\N
298648	1874	4765000	16825	8539	1	0	\N
298653	1678	18720659757000	16827	8541	0	0	\N
298654	1874	4775000	16827	8541	1	0	\N
298655	1874	4777000	16827	8541	2	0	\N
298544	1678	18720659740000	16798	8525	2	0	0
298545	1299	1703411285540250	16798	8525	3	0	0
298546	1053	905989686644800	16798	8525	4	0	0
298547	1173	611289469681700	16798	8525	5	0	0
298548	933	505577712770200	16798	8525	6	0	0
298550	1874	4689000	16798	8525	8	0	2
298551	1874	4692000	16798	8525	9	0	2
298552	1874	4695000	16798	8525	10	0	2
298553	1678	18720659741000	16799	8526	0	0	0
298554	1874	4697000	16799	8526	1	0	2
298560	1678	18720659742000	16801	8527	0	0	0
298561	1874	4702000	16801	8527	1	0	2
298562	1874	4705000	16801	8527	2	0	2
298563	1874	4706000	16801	8527	3	0	2
298565	1874	4709000	16802	8528	1	0	2
298566	1874	4711000	16802	8528	2	0	2
298573	1678	18720659744000	16805	8529	0	0	0
298574	1874	4713000	16805	8529	1	0	2
298575	1874	4716000	16805	8529	2	0	2
298579	1874	4719000	16807	8530	1	0	2
298580	1678	18720659746000	16808	8531	0	0	0
298581	1874	4721000	16808	8531	1	0	2
298582	1874	4722000	16808	8531	2	0	2
298600	1678	18720659747000	16813	8533	0	0	0
298602	1678	18720659749000	16813	8533	2	0	0
298603	1874	4723000	16813	8533	3	0	2
298604	1874	4725000	16813	8533	4	0	2
298605	1874	4727000	16813	8533	5	0	2
298607	1874	4732000	16813	8533	7	0	2
298608	1874	4735000	16813	8533	8	0	2
298609	1874	4738000	16813	8533	9	0	2
298610	1874	4741000	16813	8533	10	0	2
298624	1678	18720659750000	16816	8534	0	0	0
298626	1678	18720659751000	16817	8535	0	0	0
298627	1874	4746000	16817	8535	1	0	2
298628	1678	18720659752000	16818	8536	0	0	0
298629	1874	4747000	16818	8536	1	0	2
298630	1874	4749000	16818	8536	2	0	2
298632	1874	4755000	16818	8536	4	0	2
298633	1678	18720659753000	16819	8537	0	0	0
298634	1874	4758000	16819	8537	1	0	2
298640	1678	18720659754000	16822	8538	0	0	0
298642	1874	4763000	16822	8538	2	0	2
298645	1678	18720659755000	16824	8539	0	0	0
298646	1874	4765000	16824	8539	1	0	2
298649	1678	18720659756000	16826	8540	0	0	0
298650	1874	4768000	16826	8540	1	0	2
298652	1874	4772000	16826	8540	3	0	2
298656	1678	18720659757000	16828	8541	0	0	0
298659	1678	18720659757000	16829	8541	0	0	\N
298660	1874	4775000	16829	8541	1	0	\N
298661	1874	4777000	16829	8541	2	0	\N
298665	1678	18720659758000	16831	8542	0	0	\N
298666	1874	4779000	16831	8542	1	0	\N
298667	1874	4782000	16831	8542	2	0	\N
298668	1678	18720659758000	16832	8542	0	0	\N
298669	1874	4779000	16832	8542	1	0	\N
298670	1874	4782000	16832	8542	2	0	\N
298671	946	505422075000000	16833	8259	2	0	\N
298672	2156	718900000000	16833	8259	3	0	\N
298673	1066	905711965000000	16833	8259	4	0	\N
298674	1186	611101950000000	16833	8259	5	0	\N
298675	1312	1702889737751650	16833	8259	6	0	\N
298676	2149	9000000000	16833	8259	7	0	\N
298677	2149	9000000000	16833	8259	8	0	\N
298678	1382	1708727637751650	16833	8259	9	0	\N
298679	1319	1705962637751650	16833	8259	10	0	\N
298680	1073	907346465000000	16833	8259	11	0	\N
298681	1193	612204750000000	16833	8259	12	0	\N
298682	953	506334775000000	16833	8259	13	0	\N
298683	1136	908817465000000	16833	8259	14	0	\N
298684	1256	613196750000000	16833	8259	15	0	\N
298685	1016	507154775000000	16833	8259	16	0	\N
298686	2150	200000000	16833	8259	17	0	\N
298687	2152	12300000	16833	8259	18	0	\N
298688	1340	1700432510151650	16833	8259	19	0	\N
298689	974	504693496200000	16833	8259	20	0	\N
298690	974	504694496200000	16833	8259	21	0	\N
298691	2151	200000000	16833	8259	22	0	\N
298692	2153	200000000	16833	8259	23	0	\N
298693	2154	200000000	16833	8259	24	0	\N
298694	1860	107499987700000	16833	8259	25	0	\N
298695	2155	10000000	16833	8259	27	0	\N
298696	2155	10000000	16833	8259	28	0	\N
298697	1299	1703411285540250	16833	8259	29	0	\N
298698	1053	905989686644800	16833	8259	30	0	\N
298699	1527	271999978	16833	8259	31	0	\N
298700	1359	1701968237751650	16833	8259	32	0	\N
298701	1527	271999978	16833	8259	33	0	\N
298706	1678	18720659759000	16835	8543	0	0	\N
298707	1874	4784000	16835	8543	1	0	\N
298708	1874	4787000	16835	8543	2	0	\N
298709	1874	4788000	16835	8543	3	0	\N
298710	2156	718900000000	16836	8413	0	0	\N
298711	1382	1708727637751650	16836	8413	1	0	\N
298712	1319	1705962637751650	16836	8413	2	0	\N
298713	1073	907346465000000	16836	8413	3	0	\N
298714	1193	612204750000000	16836	8413	4	0	\N
298715	953	506334775000000	16836	8413	5	0	\N
298716	1136	908817465000000	16836	8413	6	0	\N
298717	1256	613196750000000	16836	8413	7	0	\N
298718	1016	507154775000000	16836	8413	8	0	\N
298719	1340	1700432510151650	16836	8413	9	0	\N
298720	974	504693496200000	16836	8413	10	0	\N
298721	974	504694496200000	16836	8413	11	0	\N
298722	1678	18000647582000	16836	8413	13	0	\N
298723	1678	18000647583000	16836	8413	14	0	\N
298724	1678	18000647584000	16836	8413	15	0	\N
298725	1678	18000647585000	16836	8413	16	0	\N
298726	1678	18000647586000	16836	8413	17	0	\N
298727	1678	18000647587000	16836	8413	18	0	\N
298728	1678	18000647588000	16836	8413	19	0	\N
298729	1678	18000647589000	16836	8413	20	0	\N
298730	1678	18000647590000	16836	8413	21	0	\N
298731	1678	18000647591000	16836	8413	22	0	\N
298732	1678	18000647592000	16836	8413	23	0	\N
298733	1678	18000647593000	16836	8413	24	0	\N
298734	1678	18000647594000	16836	8413	25	0	\N
298735	1678	18000647595000	16836	8413	27	0	\N
298736	1678	18000647596000	16836	8413	28	0	\N
298737	1678	18000647597000	16836	8413	29	0	\N
298738	1678	18000647598000	16836	8413	30	0	\N
298739	1678	18000647599000	16836	8413	31	0	\N
298740	1678	18000647600000	16836	8413	32	0	\N
298741	1678	18000647601000	16836	8413	33	0	\N
298742	2155	10000000	16836	8413	34	0	\N
298743	2155	10000000	16836	8413	35	0	\N
298744	1678	18000647602000	16836	8413	36	0	\N
298745	1678	18000647603000	16836	8413	37	0	\N
298746	1678	18000647604000	16836	8413	38	0	\N
298747	1678	18000647605000	16836	8413	39	0	\N
298748	1678	18000647606000	16836	8413	40	0	\N
298749	1678	18000647607000	16836	8413	41	0	\N
298750	1678	18000647608000	16836	8413	42	0	\N
298751	1678	18000647609000	16836	8413	43	0	\N
298752	1678	18000647610000	16836	8413	44	0	\N
298753	1678	18000647611000	16836	8413	45	0	\N
298754	1678	18000647612000	16836	8413	46	0	\N
298755	1678	18000647613000	16836	8413	47	0	\N
298756	1678	18000647614000	16836	8413	48	0	\N
298757	1678	18000647615000	16836	8413	49	0	\N
298758	1678	18000647616000	16836	8413	50	0	\N
298759	1678	18000647617000	16836	8413	51	0	\N
298760	1678	18000647618000	16836	8413	52	0	\N
298761	1678	18000647619000	16836	8413	53	0	\N
298762	1678	18000647620000	16836	8413	54	0	\N
298763	1678	18000647621000	16836	8413	55	0	\N
298764	1678	18000647622000	16836	8413	56	0	\N
298765	1678	18000647623000	16836	8413	57	0	\N
298766	1678	18000647624000	16836	8413	58	0	\N
298767	1678	18000647625000	16836	8413	59	0	\N
298768	1678	18000647626000	16836	8413	60	0	\N
298769	1678	18000647627000	16836	8413	61	0	\N
298770	1678	18000647628000	16836	8413	62	0	\N
298771	1678	18000647629000	16836	8413	63	0	\N
298772	1678	18000647630000	16836	8413	64	0	\N
298773	1678	18000647631000	16836	8413	65	0	\N
298774	1678	18000647632000	16836	8413	66	0	\N
298775	1678	18000647633000	16836	8413	67	0	\N
298776	1678	18000647634000	16836	8413	68	0	\N
298777	1678	18000647635000	16836	8413	69	0	\N
298780	1678	18720659760000	16838	8544	0	0	\N
298781	1874	4791000	16838	8544	1	0	\N
298782	1678	18720659760000	16839	8544	0	0	\N
298783	1874	4791000	16839	8544	1	0	\N
298784	1678	18720659761000	16840	8545	0	0	\N
298785	1874	4793000	16840	8545	1	0	\N
298786	1874	4796000	16840	8545	2	0	\N
298787	1678	18720659761000	16841	8545	0	0	\N
298788	1874	4793000	16841	8545	1	0	\N
298789	1874	4796000	16841	8545	2	0	\N
298662	1678	18720659758000	16830	8542	0	0	0
298663	1874	4779000	16830	8542	1	0	2
298664	1874	4782000	16830	8542	2	0	2
298702	1678	18720659759000	16834	8543	0	0	0
298703	1874	4784000	16834	8543	1	0	2
298705	1874	4788000	16834	8543	3	0	2
298778	1678	18720659760000	16837	8544	0	0	0
298779	1874	4791000	16837	8544	1	0	2
298790	1678	18720659761000	16842	8545	0	0	0
298791	1874	4793000	16842	8545	1	0	2
298800	1678	18720659764000	16844	8547	0	0	\N
298801	1874	4810000	16844	8547	1	0	\N
298802	1874	4812000	16844	8547	2	0	\N
298806	1678	18720659765000	16846	8548	0	0	\N
298807	1874	4814000	16846	8548	1	0	\N
298808	1874	4817000	16846	8548	2	0	\N
298819	1678	18720659768000	16850	8551	0	0	\N
298820	1874	4831000	16850	8551	1	0	\N
298821	1874	4833000	16850	8551	2	0	\N
298822	1678	18720659768000	16851	8551	0	0	\N
298823	1874	4831000	16851	8551	1	0	\N
298824	1874	4833000	16851	8551	2	0	\N
298825	1678	18720659768000	16852	8551	0	0	\N
298826	1874	4831000	16852	8551	1	0	\N
298827	1874	4833000	16852	8551	2	0	\N
298828	1678	18720659768000	16853	8551	0	0	\N
298829	1874	4831000	16853	8551	1	0	\N
298830	1874	4833000	16853	8551	2	0	\N
298834	1678	18720659743000	16855	8528	0	0	\N
298835	1678	18720659744000	16855	8528	1	0	\N
298836	1678	18720659745000	16855	8528	2	0	\N
298837	1678	18720659746000	16855	8528	3	0	\N
298838	1678	18720659747000	16855	8528	4	0	\N
298839	1678	18720659748000	16855	8528	5	0	\N
298840	1678	18720659749000	16855	8528	6	0	\N
298841	1678	18720659750000	16855	8528	7	0	\N
298842	1678	18720659751000	16855	8528	8	0	\N
298843	1678	18720659752000	16855	8528	9	0	\N
298844	1678	18720659753000	16855	8528	10	0	\N
298845	1678	18720659754000	16855	8528	11	0	\N
298846	1678	18720659755000	16855	8528	12	0	\N
298847	1678	18720659756000	16855	8528	13	0	\N
298848	1678	18720659757000	16855	8528	14	0	\N
298849	1678	18720659758000	16855	8528	15	0	\N
298850	1678	18720659759000	16855	8528	16	0	\N
298851	1678	18720659760000	16855	8528	17	0	\N
298852	1678	18720659761000	16855	8528	18	0	\N
298853	1678	18720659762000	16855	8528	20	0	\N
298854	1678	18720659763000	16855	8528	21	0	\N
298855	1678	18720659764000	16855	8528	22	0	\N
298856	1678	18720659765000	16855	8528	23	0	\N
298857	1678	18720659766000	16855	8528	24	0	\N
298858	1678	18720659767000	16855	8528	25	0	\N
298859	1678	18720659768000	16855	8528	26	0	\N
298860	1874	4707000	16855	8528	27	0	\N
298861	1874	4708000	16855	8528	28	0	\N
298862	1874	4709000	16855	8528	29	0	\N
298863	1874	4710000	16855	8528	30	0	\N
298864	1874	4713000	16855	8528	31	0	\N
298865	1874	4714000	16855	8528	32	0	\N
298866	1874	4715000	16855	8528	33	0	\N
298867	1874	4716000	16855	8528	34	0	\N
298868	1874	4719000	16855	8528	35	0	\N
298869	1874	4722000	16855	8528	36	0	\N
298870	1874	4725000	16855	8528	37	0	\N
298871	1874	4728000	16855	8528	38	0	\N
298872	1874	4731000	16855	8528	39	0	\N
298873	1874	4734000	16855	8528	40	0	\N
298874	1874	4737000	16855	8528	41	0	\N
298875	1874	4740000	16855	8528	42	0	\N
298876	1874	4743000	16855	8528	43	0	\N
298877	1874	4746000	16855	8528	44	0	\N
298878	1874	4749000	16855	8528	45	0	\N
298879	1874	4752000	16855	8528	46	0	\N
298880	1874	4755000	16855	8528	47	0	\N
298881	1874	4758000	16855	8528	48	0	\N
298882	1874	4761000	16855	8528	49	0	\N
298883	1874	4764000	16855	8528	50	0	\N
298884	1874	4767000	16855	8528	51	0	\N
298885	1874	4770000	16855	8528	52	0	\N
298886	1874	4773000	16855	8528	53	0	\N
298887	1874	4776000	16855	8528	54	0	\N
298888	1874	4779000	16855	8528	55	0	\N
298889	1874	4782000	16855	8528	56	0	\N
298890	1874	4785000	16855	8528	57	0	\N
298891	1874	4788000	16855	8528	58	0	\N
298892	1874	4791000	16855	8528	59	0	\N
298893	1874	4793000	16855	8528	60	0	\N
298894	1874	4795000	16855	8528	61	0	\N
298895	1874	4797000	16855	8528	62	0	\N
298896	1874	4799000	16855	8528	63	0	\N
298897	1874	4801000	16855	8528	64	0	\N
298898	1874	4803000	16855	8528	65	0	\N
298899	1874	4805000	16855	8528	66	0	\N
298900	1874	4807000	16855	8528	67	0	\N
298901	1874	4809000	16855	8528	68	0	\N
298902	1874	4811000	16855	8528	69	0	\N
298903	1874	4813000	16855	8528	70	0	\N
298904	1874	4815000	16855	8528	71	0	\N
298905	1874	4817000	16855	8528	72	0	\N
298906	1874	4819000	16855	8528	73	0	\N
298907	1874	4821000	16855	8528	74	0	\N
298908	1874	4823000	16855	8528	75	0	\N
298909	1874	4825000	16855	8528	76	0	\N
298910	1874	4827000	16855	8528	77	0	\N
298911	1874	4829000	16855	8528	78	0	\N
298912	1874	4831000	16855	8528	79	0	\N
298913	1874	4833000	16855	8528	80	0	\N
298921	1678	18720659771000	16863	8553	0	0	\N
298922	1874	4846000	16863	8553	1	0	\N
298923	1874	4849000	16863	8553	2	0	\N
298927	1678	18720659771000	16865	8553	0	0	\N
298928	1874	4846000	16865	8553	1	0	\N
298795	1874	4799000	16843	8546	2	0	2
298796	1874	4801000	16843	8546	3	0	2
298797	1874	4802000	16843	8546	4	0	2
298798	1874	4805000	16843	8546	5	0	2
298799	1874	4807000	16843	8546	6	0	2
298804	1874	4810000	16845	8547	1	0	2
298805	1874	4812000	16845	8547	2	0	2
298809	1678	18720659765000	16847	8548	0	0	0
298810	1874	4814000	16847	8548	1	0	2
298811	1874	4817000	16847	8548	2	0	2
298813	1874	4820000	16848	8549	1	0	2
298814	1874	4821000	16848	8549	2	0	2
298815	1874	4823000	16848	8549	3	0	2
298816	1678	18720659767000	16849	8550	0	0	0
298818	1874	4828000	16849	8550	2	0	2
298831	1678	18720659768000	16854	8551	0	0	0
298832	1874	4831000	16854	8551	1	0	2
298833	1874	4833000	16854	8551	2	0	2
298914	1678	18720659769000	16857	8552	0	0	0
298916	1874	4835000	16857	8552	2	0	2
298917	1874	4837000	16857	8552	3	0	2
298918	1874	4838000	16857	8552	4	0	2
298919	1874	4841000	16857	8552	5	0	2
298920	1874	4844000	16857	8552	6	0	2
298925	1874	4846000	16864	8553	1	0	2
298926	1874	4849000	16864	8553	2	0	2
298929	1874	4849000	16865	8553	2	0	\N
298934	2156	718900000000	16868	8427	0	0	\N
298935	1678	18000647691000	16868	8427	1	0	\N
298936	1678	18000647692000	16868	8427	2	0	\N
298937	1678	18000647693000	16868	8427	3	0	\N
298938	1678	18000647694000	16868	8427	4	0	\N
298939	1678	18000647695000	16868	8427	5	0	\N
298940	1340	1700432510151650	16868	8427	6	0	\N
298941	974	504693496200000	16868	8427	7	0	\N
298942	974	504694496200000	16868	8427	8	0	\N
298943	1678	18000647696000	16868	8427	9	0	\N
298944	1678	18000647697000	16868	8427	10	0	\N
298945	1678	18000647698000	16868	8427	11	0	\N
298946	1678	18000647699000	16868	8427	12	0	\N
298947	1678	18000647700000	16868	8427	13	0	\N
298948	1678	18000647701000	16868	8427	14	0	\N
298949	1678	18000647702000	16868	8427	15	0	\N
298950	1678	18000647703000	16868	8427	16	0	\N
298951	1678	18000647704000	16868	8427	17	0	\N
298952	1678	18000647705000	16868	8427	18	0	\N
298953	1678	18000647706000	16868	8427	19	0	\N
298954	1678	18000647707000	16868	8427	20	0	\N
298955	1678	18000647708000	16868	8427	21	0	\N
298956	1678	18000647709000	16868	8427	22	0	\N
298957	1678	18000647710000	16868	8427	23	0	\N
298958	1678	18000647711000	16868	8427	24	0	\N
298959	1678	18000647712000	16868	8427	25	0	\N
298960	1678	18000647713000	16868	8427	26	0	\N
298961	1678	18000647714000	16868	8427	27	0	\N
298962	1678	18000647715000	16868	8427	28	0	\N
298963	1678	18000647716000	16868	8427	29	0	\N
298964	1678	18000647717000	16868	8427	30	0	\N
298965	1678	18000647718000	16868	8427	31	0	\N
298966	1678	18000647719000	16868	8427	32	0	\N
298967	1678	18000647720000	16868	8427	33	0	\N
298968	1678	18000647721000	16868	8427	34	0	\N
298969	1678	18000647722000	16868	8427	35	0	\N
298970	1678	18000647723000	16868	8427	36	0	\N
298971	1678	18000647724000	16868	8427	37	0	\N
298972	1678	18000647725000	16868	8427	38	0	\N
298973	1678	18000647726000	16868	8427	39	0	\N
298974	1678	18000647727000	16868	8427	40	0	\N
298975	1678	18000647728000	16868	8427	41	0	\N
298976	1678	18000647729000	16868	8427	42	0	\N
298977	1678	18000647730000	16868	8427	43	0	\N
298978	1678	18000647731000	16868	8427	44	0	\N
298979	1678	18000647732000	16868	8427	45	0	\N
298980	1678	18000647733000	16868	8427	46	0	\N
298981	1678	18000647734000	16868	8427	47	0	\N
298982	1678	18000647735000	16868	8427	48	0	\N
298983	1678	18000647736000	16868	8427	49	0	\N
298984	1678	18000647737000	16868	8427	50	0	\N
298985	1678	18000647738000	16868	8427	51	0	\N
298986	1678	18000647739000	16868	8427	52	0	\N
298987	1678	18000647740000	16868	8427	53	0	\N
298988	1678	18000647741000	16868	8427	54	0	\N
298989	1678	18000647742000	16868	8427	55	0	\N
298990	1678	18000647743000	16868	8427	56	0	\N
298991	1678	18000647744000	16868	8427	57	0	\N
298992	1678	18000647745000	16868	8427	58	0	\N
298993	1678	18000647746000	16868	8427	59	0	\N
298994	1678	18000647747000	16868	8427	60	0	\N
298995	1678	18000647748000	16868	8427	61	0	\N
298996	1678	18000647749000	16868	8427	62	0	\N
298997	1678	18000647750000	16868	8427	64	0	\N
298998	1678	18000647751000	16868	8427	65	0	\N
298999	1678	18000647752000	16868	8427	66	0	\N
299000	1678	18000647753000	16868	8427	67	0	\N
299001	1678	18000647754000	16868	8427	68	0	\N
299002	1678	18000647755000	16868	8427	69	0	\N
299003	1678	18000647756000	16868	8427	70	0	\N
299004	1678	18000647757000	16868	8427	71	0	\N
299005	1678	18000647758000	16868	8427	72	0	\N
299006	1678	18000647759000	16868	8427	73	0	\N
299007	1678	18000647760000	16868	8427	74	0	\N
299008	1678	18000647761000	16868	8427	75	0	\N
299009	1678	18000647762000	16868	8427	76	0	\N
299010	1678	18000647763000	16868	8427	77	0	\N
299011	1678	18000647764000	16868	8427	78	0	\N
299012	1678	18000647765000	16868	8427	79	0	\N
299013	1678	18000647766000	16868	8427	80	0	\N
299014	1678	18000647767000	16868	8427	81	0	\N
299015	1678	18000647768000	16868	8427	82	0	\N
299016	1678	18000647769000	16868	8427	83	0	\N
299017	1678	18000647770000	16868	8427	84	0	\N
299018	1678	18000647771000	16868	8427	85	0	\N
299019	1678	18000647772000	16868	8427	86	0	\N
299020	1678	18000647773000	16868	8427	87	0	\N
299021	1678	18000647774000	16868	8427	88	0	\N
299022	1678	18000647775000	16868	8427	89	0	\N
299023	1678	18000647776000	16868	8427	90	0	\N
299024	1299	1703411285540250	16868	8427	91	0	\N
299025	1053	905989686644800	16868	8427	92	0	\N
299026	1173	611289469681700	16868	8427	93	0	\N
299027	933	505577712770200	16868	8427	94	0	\N
299028	1874	4024000	16868	8427	95	0	\N
299029	1874	4025000	16868	8427	96	0	\N
299030	1874	4026000	16868	8427	97	0	\N
299031	1874	4027000	16868	8427	98	0	\N
299032	1874	4028000	16868	8427	99	0	\N
299033	1874	4029000	16868	8427	100	0	\N
299034	1874	4030000	16868	8427	101	0	\N
299035	1874	4031000	16868	8427	102	0	\N
299036	1874	4032000	16868	8427	103	0	\N
299037	1874	4033000	16868	8427	104	0	\N
299038	1874	4034000	16868	8427	105	0	\N
299039	1874	4035000	16868	8427	106	0	\N
299040	1874	4036000	16868	8427	107	0	\N
299041	1874	4037000	16868	8427	108	0	\N
299042	1874	4038000	16868	8427	109	0	\N
299043	1874	4039000	16868	8427	110	0	\N
299044	1874	4040000	16868	8427	111	0	\N
299045	1874	4041000	16868	8427	112	0	\N
299046	1874	4042000	16868	8427	113	0	\N
299047	1874	4043000	16868	8427	114	0	\N
299048	1874	4044000	16868	8427	117	0	\N
299049	1874	4045000	16868	8427	118	0	\N
299050	1874	4046000	16868	8427	119	0	\N
299051	1874	4047000	16868	8427	120	0	\N
299052	1874	4048000	16868	8427	121	0	\N
299053	1874	4049000	16868	8427	122	0	\N
299054	1874	4050000	16868	8427	123	0	\N
299055	1874	4051000	16868	8427	124	0	\N
299056	1874	4052000	16868	8427	125	0	\N
298932	1874	4852000	16866	8554	2	0	2
298933	1874	4855000	16866	8554	3	0	2
299057	1678	18720659773000	16869	8556	0	0	0
299058	1678	18720659774000	16869	8556	1	0	0
299059	1678	18720659775000	16869	8556	2	0	0
299061	1874	4857000	16869	8556	4	0	2
299062	1874	4858000	16869	8556	5	0	2
299063	1874	4860000	16869	8556	6	0	2
299064	1874	4862000	16869	8556	7	0	2
299070	1678	18720659773000	16870	8556	0	0	\N
299071	1678	18720659774000	16870	8556	1	0	\N
299072	1678	18720659775000	16870	8556	2	0	\N
299073	1678	18720659776000	16870	8556	3	0	\N
299074	1874	4857000	16870	8556	4	0	\N
299075	1874	4858000	16870	8556	5	0	\N
299076	1874	4860000	16870	8556	6	0	\N
299077	1874	4862000	16870	8556	7	0	\N
299078	1874	4864000	16870	8556	8	0	\N
299079	1874	4867000	16870	8556	9	0	\N
299080	1874	4870000	16870	8556	10	0	\N
299081	1874	4873000	16870	8556	11	0	\N
299082	1874	4876000	16870	8556	12	0	\N
299083	1678	18720659773000	16871	8556	0	0	\N
299084	1678	18720659774000	16871	8556	1	0	\N
299085	1678	18720659775000	16871	8556	2	0	\N
299086	1678	18720659776000	16871	8556	3	0	\N
299087	1874	4857000	16871	8556	4	0	\N
299088	1874	4858000	16871	8556	5	0	\N
299089	1874	4860000	16871	8556	6	0	\N
299090	1874	4862000	16871	8556	7	0	\N
299091	1874	4864000	16871	8556	8	0	\N
299092	1874	4867000	16871	8556	9	0	\N
299093	1874	4870000	16871	8556	10	0	\N
299094	1874	4873000	16871	8556	11	0	\N
299095	1874	4876000	16871	8556	12	0	\N
299098	1678	18720659778000	16873	8558	0	0	\N
299099	1874	4881000	16873	8558	1	0	\N
299100	1874	4883000	16873	8558	2	0	\N
299101	1874	4886000	16873	8558	3	0	\N
299102	1678	18720659778000	16874	8558	0	0	\N
299103	1874	4881000	16874	8558	1	0	\N
299104	1874	4883000	16874	8558	2	0	\N
299105	1874	4886000	16874	8558	3	0	\N
299134	1678	18720659786000	16880	8562	0	0	\N
299135	1874	4927000	16880	8562	1	0	\N
299136	1874	4929000	16880	8562	2	0	\N
299140	1678	18720659786000	16882	8562	0	0	\N
299141	1874	4927000	16882	8562	1	0	\N
299142	1874	4929000	16882	8562	2	0	\N
299150	2156	718900000000	16885	8487	0	0	\N
299151	1678	18720659699000	16885	8487	1	0	\N
299152	1340	1700432510151650	16885	8487	2	0	\N
299153	974	504693496200000	16885	8487	3	0	\N
299154	974	504694496200000	16885	8487	4	0	\N
299155	1678	18720659700000	16885	8487	5	0	\N
299156	1678	18720659701000	16885	8487	6	0	\N
299157	1678	18720659702000	16885	8487	7	0	\N
299158	1678	18720659703000	16885	8487	8	0	\N
299159	1678	18720659704000	16885	8487	9	0	\N
299160	1678	18720659705000	16885	8487	10	0	\N
299161	1678	18720659706000	16885	8487	11	0	\N
299162	1678	18720659707000	16885	8487	12	0	\N
299163	1678	18720659708000	16885	8487	13	0	\N
299164	1678	18720659709000	16885	8487	14	0	\N
299165	1678	18720659710000	16885	8487	15	0	\N
299166	1678	18720659711000	16885	8487	16	0	\N
299167	1678	18720659712000	16885	8487	17	0	\N
299168	1678	18720659713000	16885	8487	18	0	\N
299169	1678	18720659714000	16885	8487	19	0	\N
299170	1678	18720659715000	16885	8487	20	0	\N
299171	1678	18720659716000	16885	8487	21	0	\N
299172	1678	18720659717000	16885	8487	22	0	\N
299173	1678	18720659718000	16885	8487	23	0	\N
299174	1678	18720659719000	16885	8487	24	0	\N
299175	1678	18720659720000	16885	8487	25	0	\N
299176	1678	18720659721000	16885	8487	26	0	\N
299177	1678	18720659722000	16885	8487	27	0	\N
299178	1678	18720659723000	16885	8487	28	0	\N
299179	1678	18720659724000	16885	8487	29	0	\N
299180	1678	18720659725000	16885	8487	30	0	\N
299181	1678	18720659726000	16885	8487	31	0	\N
299182	1678	18720659727000	16885	8487	32	0	\N
299183	1678	18720659728000	16885	8487	33	0	\N
299184	1678	18720659729000	16885	8487	34	0	\N
299185	1678	18720659730000	16885	8487	35	0	\N
299186	1678	18720659731000	16885	8487	36	0	\N
299187	1678	18720659732000	16885	8487	37	0	\N
299188	1678	18720659733000	16885	8487	38	0	\N
299189	1678	18720659734000	16885	8487	39	0	\N
299190	1678	18720659735000	16885	8487	40	0	\N
299191	1678	18720659736000	16885	8487	41	0	\N
299192	1678	18720659737000	16885	8487	42	0	\N
299193	1678	18720659738000	16885	8487	43	0	\N
299194	1678	18720659739000	16885	8487	44	0	\N
299195	1678	18720659740000	16885	8487	45	0	\N
299196	1678	18720659741000	16885	8487	46	0	\N
299197	1678	18720659742000	16885	8487	47	0	\N
299198	1678	18720659743000	16885	8487	48	0	\N
299199	1678	18720659744000	16885	8487	49	0	\N
299200	1678	18720659745000	16885	8487	50	0	\N
299067	1874	4870000	16869	8556	10	0	2
299068	1874	4873000	16869	8556	11	0	2
299069	1874	4876000	16869	8556	12	0	2
299096	1678	18720659777000	16872	8557	0	0	0
299097	1874	4878000	16872	8557	1	0	2
299107	1874	4881000	16875	8558	1	0	2
299108	1874	4883000	16875	8558	2	0	2
299109	1874	4886000	16875	8558	3	0	2
299110	1678	18720659779000	16876	8559	0	0	0
299111	1678	18720659780000	16876	8559	1	0	0
299113	1874	4889000	16876	8559	3	0	2
299114	1874	4891000	16876	8559	4	0	2
299115	1874	4893000	16876	8559	5	0	2
299116	1874	4894000	16876	8559	6	0	2
299118	1874	4899000	16876	8559	8	0	2
299119	1678	18720659782000	16877	8560	0	0	0
299120	1874	4900000	16877	8560	1	0	2
299121	1874	4903000	16877	8560	2	0	2
299122	1874	4905000	16877	8560	3	0	2
299124	1678	18720659784000	16879	8561	1	0	0
299125	1678	18720659785000	16879	8561	2	0	0
299126	1874	4907000	16879	8561	3	0	2
299127	1874	4909000	16879	8561	4	0	2
299128	1874	4912000	16879	8561	5	0	2
299130	1874	4916000	16879	8561	7	0	2
299131	1874	4919000	16879	8561	8	0	2
299132	1874	4921000	16879	8561	9	0	2
299133	1874	4924000	16879	8561	10	0	2
299138	1874	4927000	16881	8562	1	0	2
299139	1874	4929000	16881	8562	2	0	2
299143	1678	18720659787000	16883	8563	0	0	0
299144	1874	4931000	16883	8563	1	0	2
299145	1874	4934000	16883	8563	2	0	2
299147	1874	4935000	16884	8564	1	0	2
299148	1874	4937000	16884	8564	2	0	2
299149	1874	4940000	16884	8564	3	0	2
299201	1678	18720659746000	16885	8487	51	0	\N
299202	1678	18720659747000	16885	8487	52	0	\N
299203	1678	18720659748000	16885	8487	53	0	\N
299204	1678	18720659749000	16885	8487	54	0	\N
299205	1678	18720659750000	16885	8487	55	0	\N
299206	1678	18720659751000	16885	8487	56	0	\N
299207	1678	18720659752000	16885	8487	57	0	\N
299208	1678	18720659753000	16885	8487	58	0	\N
299209	1678	18720659754000	16885	8487	59	0	\N
299210	1678	18720659755000	16885	8487	60	0	\N
299211	1678	18720659756000	16885	8487	61	0	\N
299212	1678	18720659757000	16885	8487	62	0	\N
299213	1678	18720659758000	16885	8487	63	0	\N
299214	1678	18720659759000	16885	8487	64	0	\N
299215	1678	18720659760000	16885	8487	65	0	\N
299216	1678	18720659761000	16885	8487	66	0	\N
299217	1678	18720659762000	16885	8487	67	0	\N
299218	1678	18720659763000	16885	8487	68	0	\N
299219	1678	18720659764000	16885	8487	69	0	\N
299220	1678	18720659765000	16885	8487	70	0	\N
299221	1678	18720659766000	16885	8487	71	0	\N
299222	1678	18720659767000	16885	8487	72	0	\N
299223	1678	18720659768000	16885	8487	73	0	\N
299224	1678	18720659769000	16885	8487	74	0	\N
299225	1678	18720659770000	16885	8487	75	0	\N
299226	1678	18720659771000	16885	8487	76	0	\N
299227	1678	18720659772000	16885	8487	77	0	\N
299228	1678	18720659773000	16885	8487	78	0	\N
299229	1678	18720659774000	16885	8487	79	0	\N
299230	1678	18720659775000	16885	8487	80	0	\N
299231	1678	18720659776000	16885	8487	81	0	\N
299232	1678	18720659777000	16885	8487	82	0	\N
299233	1678	18720659778000	16885	8487	83	0	\N
299234	1678	18720659779000	16885	8487	84	0	\N
299235	1678	18720659780000	16885	8487	85	0	\N
299236	1678	18720659781000	16885	8487	86	0	\N
299237	1678	18720659782000	16885	8487	87	0	\N
299238	1678	18720659783000	16885	8487	88	0	\N
299239	1678	18720659784000	16885	8487	89	0	\N
299240	1678	18720659785000	16885	8487	90	0	\N
299241	1678	18720659786000	16885	8487	91	0	\N
299242	1678	18720659787000	16885	8487	92	0	\N
299243	1678	18720659788000	16885	8487	93	0	\N
299244	1299	1703411285540250	16885	8487	94	0	\N
299245	1053	905989686644800	16885	8487	95	0	\N
299246	1173	611289469681700	16885	8487	96	0	\N
299247	933	505577712770200	16885	8487	97	0	\N
299248	1874	4485000	16885	8487	98	0	\N
299249	1874	4487000	16885	8487	99	0	\N
299250	1874	4490000	16885	8487	100	0	\N
299251	1874	4493000	16885	8487	101	0	\N
299252	1874	4496000	16885	8487	102	0	\N
299253	1874	4499000	16885	8487	103	0	\N
299254	1874	4501000	16885	8487	104	0	\N
299255	1874	4503000	16885	8487	105	0	\N
299256	1874	4505000	16885	8487	106	0	\N
299257	1874	4507000	16885	8487	107	0	\N
299258	1874	4510000	16885	8487	108	0	\N
299259	1874	4513000	16885	8487	109	0	\N
299260	1874	4516000	16885	8487	110	0	\N
299261	1874	4517000	16885	8487	111	0	\N
299262	1874	4518000	16885	8487	112	0	\N
299263	1874	4519000	16885	8487	115	0	\N
299264	1874	4520000	16885	8487	116	0	\N
299265	1874	4521000	16885	8487	117	0	\N
299266	1874	4522000	16885	8487	118	0	\N
299267	1874	4523000	16885	8487	119	0	\N
299268	1874	4524000	16885	8487	120	0	\N
299269	1874	4525000	16885	8487	121	0	\N
299270	1874	4526000	16885	8487	122	0	\N
299271	1874	4527000	16885	8487	123	0	\N
299272	1874	4528000	16885	8487	124	0	\N
299273	1874	4529000	16885	8487	125	0	\N
299277	1678	18720659789000	16887	8565	0	0	\N
299278	1874	4942000	16887	8565	1	0	\N
299279	1874	4945000	16887	8565	2	0	\N
299280	1678	18720659790000	16888	8566	0	0	\N
299281	1874	4947000	16888	8566	1	0	\N
299282	1874	4950000	16888	8566	2	0	\N
299283	2156	718900000000	16889	8460	0	0	\N
299284	1678	18000647644000	16889	8460	1	0	\N
299285	1678	18000647645000	16889	8460	2	0	\N
299286	1678	18000647646000	16889	8460	3	0	\N
299287	1678	18000647647000	16889	8460	4	0	\N
299288	1678	18000647648000	16889	8460	5	0	\N
299289	1678	18000647649000	16889	8460	6	0	\N
299290	1678	18000647650000	16889	8460	7	0	\N
299291	1678	18000647651000	16889	8460	8	0	\N
299292	1678	18000647652000	16889	8460	9	0	\N
299293	1678	18000647653000	16889	8460	10	0	\N
299294	1678	18000647654000	16889	8460	11	0	\N
299295	1678	18000647655000	16889	8460	12	0	\N
299296	1678	18000647656000	16889	8460	13	0	\N
299297	1678	18000647657000	16889	8460	14	0	\N
299298	1678	18000647658000	16889	8460	15	0	\N
299299	1678	18000647659000	16889	8460	16	0	\N
299300	1678	18000647660000	16889	8460	17	0	\N
299301	1678	18000647661000	16889	8460	18	0	\N
299302	1678	18000647662000	16889	8460	19	0	\N
299303	1678	18000647663000	16889	8460	20	0	\N
299304	1678	18000647664000	16889	8460	21	0	\N
299305	1340	1700432510151650	16889	8460	22	0	\N
299306	974	504693496200000	16889	8460	23	0	\N
299307	974	504694496200000	16889	8460	24	0	\N
299308	1678	18000647665000	16889	8460	25	0	\N
299309	1678	18000647666000	16889	8460	26	0	\N
299310	1678	18000647667000	16889	8460	27	0	\N
299311	1678	18000647668000	16889	8460	28	0	\N
299312	1678	18000647669000	16889	8460	29	0	\N
299313	1678	18000647670000	16889	8460	30	0	\N
299314	1678	18000647671000	16889	8460	31	0	\N
299315	1678	18000647672000	16889	8460	32	0	\N
299316	1678	18000647673000	16889	8460	33	0	\N
299317	1678	18000647674000	16889	8460	34	0	\N
299318	1678	18000647675000	16889	8460	35	0	\N
299319	1678	18000647676000	16889	8460	36	0	\N
299320	1678	18000647677000	16889	8460	37	0	\N
299321	1678	18000647678000	16889	8460	38	0	\N
299322	1678	18000647679000	16889	8460	39	0	\N
299323	1678	18000647680000	16889	8460	40	0	\N
299324	1678	18000647681000	16889	8460	41	0	\N
299325	1678	18000647682000	16889	8460	42	0	\N
299326	1678	18000647683000	16889	8460	43	0	\N
299327	1678	18000647684000	16889	8460	44	0	\N
299328	1678	18000647685000	16889	8460	45	0	\N
299329	1678	18000647686000	16889	8460	46	0	\N
299330	1678	18000647687000	16889	8460	47	0	\N
299331	1678	18000647688000	16889	8460	48	0	\N
299332	1678	18000647689000	16889	8460	49	0	\N
299333	1678	18000647690000	16889	8460	50	0	\N
299334	1678	18000647691000	16889	8460	51	0	\N
299335	1678	18000647692000	16889	8460	52	0	\N
299336	1678	18000647693000	16889	8460	53	0	\N
299276	1874	4945000	16886	8565	2	0	2
299337	1678	18000647694000	16889	8460	54	0	\N
299338	1678	18000647695000	16889	8460	55	0	\N
299339	1678	18000647696000	16889	8460	56	0	\N
299340	1678	18000647697000	16889	8460	57	0	\N
299341	1678	18000647698000	16889	8460	58	0	\N
299342	1678	18000647699000	16889	8460	59	0	\N
299343	1678	18000647700000	16889	8460	60	0	\N
299344	1678	18000647701000	16889	8460	61	0	\N
299345	1678	18000647702000	16889	8460	62	0	\N
299346	1678	18000647703000	16889	8460	63	0	\N
299347	1678	18000647704000	16889	8460	64	0	\N
299348	1678	18000647705000	16889	8460	65	0	\N
299349	1678	18000647706000	16889	8460	66	0	\N
299350	1678	18000647707000	16889	8460	67	0	\N
299351	1678	18000647708000	16889	8460	68	0	\N
299352	1678	18000647709000	16889	8460	69	0	\N
299353	1678	18000647710000	16889	8460	70	0	\N
299354	1678	18000647711000	16889	8460	71	0	\N
299355	1678	18000647712000	16889	8460	72	0	\N
299356	1678	18000647713000	16889	8460	73	0	\N
299357	1678	18000647714000	16889	8460	74	0	\N
299358	1678	18000647715000	16889	8460	75	0	\N
299359	1678	18000647716000	16889	8460	76	0	\N
299360	1678	18000647717000	16889	8460	77	0	\N
299361	1678	18000647718000	16889	8460	78	0	\N
299362	1678	18000647719000	16889	8460	79	0	\N
299363	1678	18000647720000	16889	8460	80	0	\N
299364	1678	18000647721000	16889	8460	81	0	\N
299365	1678	18000647722000	16889	8460	82	0	\N
299366	1678	18000647723000	16889	8460	83	0	\N
299367	1678	18000647724000	16889	8460	84	0	\N
299368	1678	18000647725000	16889	8460	85	0	\N
299369	1678	18000647726000	16889	8460	86	0	\N
299370	1678	18000647727000	16889	8460	87	0	\N
299371	1678	18000647728000	16889	8460	88	0	\N
299372	1678	18000647729000	16889	8460	89	0	\N
299373	1678	18000647730000	16889	8460	90	0	\N
299374	1678	18000647731000	16889	8460	91	0	\N
299375	1678	18000647732000	16889	8460	92	0	\N
299376	1678	18000647733000	16889	8460	93	0	\N
299377	1678	18000647734000	16889	8460	94	0	\N
299378	1678	18000647735000	16889	8460	95	0	\N
299379	1678	18000647736000	16889	8460	96	0	\N
299380	1678	18000647737000	16889	8460	97	0	\N
299381	1678	18000647738000	16889	8460	98	0	\N
299382	1678	18000647739000	16889	8460	99	0	\N
299383	1678	18000647740000	16889	8460	100	0	\N
299384	1678	18000647741000	16889	8460	101	0	\N
299385	1678	18000647742000	16889	8460	102	0	\N
299386	1678	18000647743000	16889	8460	104	0	\N
299387	1678	18000647744000	16889	8460	105	0	\N
299388	1678	18000647745000	16889	8460	106	0	\N
299389	1678	18000647746000	16889	8460	107	0	\N
299390	1678	18000647747000	16889	8460	108	0	\N
299391	1678	18000647748000	16889	8460	109	0	\N
299392	1678	18000647749000	16889	8460	110	0	\N
299393	1678	18000647750000	16889	8460	111	0	\N
299394	1678	18000647751000	16889	8460	112	0	\N
299395	1678	18000647752000	16889	8460	113	0	\N
299396	1678	18000647753000	16889	8460	114	0	\N
299397	1678	18000647754000	16889	8460	115	0	\N
299398	1678	18000647755000	16889	8460	116	0	\N
299399	1678	18000647756000	16889	8460	117	0	\N
299400	1678	18000647757000	16889	8460	118	0	\N
299401	1678	18000647758000	16889	8460	119	0	\N
299402	1678	18000647759000	16889	8460	120	0	\N
299403	1678	18000647760000	16889	8460	121	0	\N
299404	1678	18000647761000	16889	8460	122	0	\N
299405	1678	18000647762000	16889	8460	123	0	\N
299406	1678	18000647763000	16889	8460	124	0	\N
299407	1678	18000647764000	16889	8460	125	0	\N
299408	1678	18720659790000	16890	8566	0	0	\N
299409	1874	4947000	16890	8566	1	0	\N
299410	1874	4950000	16890	8566	2	0	\N
299421	1678	18720659792000	16894	8568	0	0	\N
299422	1874	4956000	16894	8568	1	0	\N
299423	1874	4958000	16894	8568	2	0	\N
299424	1874	4961000	16894	8568	3	0	\N
299425	1678	18720659792000	16895	8568	0	0	\N
299426	1874	4956000	16895	8568	1	0	\N
299427	1874	4958000	16895	8568	2	0	\N
299428	1874	4961000	16895	8568	3	0	\N
299429	1678	18720659793000	16896	8569	0	0	\N
299430	1678	18720659794000	16896	8569	1	0	\N
299431	1474	11794422000023	16896	8569	2	0	\N
299432	1874	4964000	16896	8569	3	0	\N
299433	1874	4967000	16896	8569	4	0	\N
299434	1874	4969000	16896	8569	5	0	\N
299435	1874	4971000	16896	8569	6	0	\N
299439	1474	11794422000023	16898	8548	0	0	\N
299440	1474	11794422000023	16899	8557	0	0	\N
299441	1678	18720659793000	16900	8569	0	0	\N
299442	1678	18720659794000	16900	8569	1	0	\N
299443	1474	11794422000023	16900	8569	2	0	\N
299444	1874	4964000	16900	8569	3	0	\N
299445	1874	4967000	16900	8569	4	0	\N
299446	1874	4969000	16900	8569	5	0	\N
299447	1874	4971000	16900	8569	6	0	\N
299448	1474	11794422000023	16901	8566	0	0	\N
299459	1678	18720659796000	16904	8571	0	0	\N
299460	1874	4977000	16904	8571	1	0	\N
299461	1874	4980000	16904	8571	2	0	\N
299462	1678	18720659797000	16905	8572	0	0	\N
299463	1874	4982000	16905	8572	1	0	\N
299464	1874	4985000	16905	8572	2	0	\N
299413	1874	4950000	16891	8566	2	0	2
299414	1678	18720659791000	16892	8567	0	0	0
299415	1874	4953000	16892	8567	1	0	2
299416	1874	4955000	16892	8567	2	0	2
299417	1678	18720659792000	16893	8568	0	0	0
299419	1874	4958000	16893	8568	2	0	2
299420	1874	4961000	16893	8568	3	0	2
299436	1474	11794422000023	16897	8569	0	0	14
299437	1874	4963000	16897	8569	1	0	2
299438	1874	4965000	16897	8569	2	0	2
299450	1678	18720659794000	16902	8570	1	0	0
299451	1678	18720659795000	16902	8570	2	0	0
299452	1874	4966000	16902	8570	3	0	2
299453	1874	4969000	16902	8570	4	0	2
299455	1874	4975000	16902	8570	6	0	2
299456	1678	18720659796000	16903	8571	0	0	0
299457	1874	4977000	16903	8571	1	0	2
299458	1874	4980000	16903	8571	2	0	2
299465	1678	18720659797000	16906	8572	0	0	0
299467	1874	4985000	16906	8572	2	0	2
299468	1678	18720659798000	16907	8573	0	0	0
299469	1678	18720659799000	16907	8573	1	0	0
299470	1678	18720659800000	16907	8573	2	0	0
299471	1874	4988000	16907	8573	3	0	2
299485	1678	18720659801000	16909	8574	0	0	\N
299486	1678	18720659802000	16909	8574	1	0	\N
299487	1874	5002000	16909	8574	2	0	\N
299488	1874	5005000	16909	8574	3	0	\N
299489	1874	5007000	16909	8574	4	0	\N
299490	1874	5009000	16909	8574	5	0	\N
299491	1874	5012000	16909	8574	6	0	\N
299492	1678	18720659801000	16910	8574	0	0	\N
299493	1678	18720659802000	16910	8574	1	0	\N
299494	1874	5002000	16910	8574	2	0	\N
299495	1874	5005000	16910	8574	3	0	\N
299496	1874	5007000	16910	8574	4	0	\N
299497	1874	5009000	16910	8574	5	0	\N
299498	1874	5012000	16910	8574	6	0	\N
299499	1678	18720659801000	16911	8574	0	0	\N
299500	1678	18720659802000	16911	8574	1	0	\N
299501	1874	5002000	16911	8574	2	0	\N
299502	1874	5005000	16911	8574	3	0	\N
299503	1874	5007000	16911	8574	4	0	\N
299504	1874	5009000	16911	8574	5	0	\N
299505	1874	5012000	16911	8574	6	0	\N
299506	1678	18720659801000	16912	8574	0	0	\N
299507	1678	18720659802000	16912	8574	1	0	\N
299508	1874	5002000	16912	8574	2	0	\N
299509	1874	5005000	16912	8574	3	0	\N
299510	1874	5007000	16912	8574	4	0	\N
299511	1874	5009000	16912	8574	5	0	\N
299512	1874	5012000	16912	8574	6	0	\N
299513	1678	18720659803000	16913	8575	0	0	\N
299514	1874	5015000	16913	8575	1	0	\N
299515	1874	5017000	16913	8575	2	0	\N
299516	1678	18720659803000	16914	8575	0	0	\N
299517	1874	5015000	16914	8575	1	0	\N
299518	1874	5017000	16914	8575	2	0	\N
299519	1678	18720659803000	16915	8575	0	0	\N
299520	1874	5015000	16915	8575	1	0	\N
299521	1874	5017000	16915	8575	2	0	\N
299528	1678	18720659804000	16918	8576	0	0	\N
299529	1874	5019000	16918	8576	1	0	\N
299530	1874	5022000	16918	8576	2	0	\N
299531	1678	18720659805000	16919	8577	0	0	\N
299532	1874	5024000	16919	8577	1	0	\N
299533	1874	5027000	16919	8577	2	0	\N
299534	1874	5028000	16919	8577	3	0	\N
299535	1678	18720659805000	16920	8577	0	0	\N
299536	1874	5024000	16920	8577	1	0	\N
299537	1874	5027000	16920	8577	2	0	\N
299538	1874	5028000	16920	8577	3	0	\N
299543	1678	18720659805000	16922	8577	0	0	\N
299544	1874	5024000	16922	8577	1	0	\N
299545	1874	5027000	16922	8577	2	0	\N
299546	1874	5028000	16922	8577	3	0	\N
299547	1678	18720659805000	16923	8577	0	0	\N
299548	1874	5024000	16923	8577	1	0	\N
299549	1874	5027000	16923	8577	2	0	\N
299550	1874	5028000	16923	8577	3	0	\N
299551	1678	18720659806000	16924	8578	0	0	\N
299552	1678	18720659807000	16924	8578	1	0	\N
299553	1678	18720659808000	16924	8578	2	0	\N
299554	1678	18720659809000	16924	8578	3	0	\N
299555	1874	5031000	16924	8578	4	0	\N
299556	1874	5034000	16924	8578	5	0	\N
299557	1874	5036000	16924	8578	6	0	\N
299558	1874	5039000	16924	8578	7	0	\N
299559	1874	5040000	16924	8578	8	0	\N
299560	1874	5042000	16924	8578	9	0	\N
299561	1874	5044000	16924	8578	10	0	\N
299562	1874	5047000	16924	8578	11	0	\N
299579	1678	18720659811000	16927	8580	0	0	\N
299580	1874	5054000	16927	8580	1	0	\N
299581	1874	5057000	16927	8580	2	0	\N
299585	2157	200000000	16929	8578	0	0	\N
299586	1678	18720659806000	16929	8578	1	0	\N
299587	1678	18720659807000	16929	8578	2	0	\N
299588	1678	18720659808000	16929	8578	3	0	\N
299589	1678	18720659809000	16929	8578	4	0	\N
299590	1678	18720659810000	16929	8578	5	0	\N
299591	1678	18720659811000	16929	8578	6	0	\N
299592	1874	5031000	16929	8578	7	0	\N
299593	1874	5034000	16929	8578	8	0	\N
299594	1874	5036000	16929	8578	9	0	\N
299595	1874	5039000	16929	8578	10	0	\N
299596	1874	5040000	16929	8578	11	0	\N
299597	1874	5041000	16929	8578	12	0	\N
299598	1874	5043000	16929	8578	13	0	\N
299599	1874	5045000	16929	8578	14	0	\N
299600	1874	5047000	16929	8578	15	0	\N
299601	1874	5049000	16929	8578	16	0	\N
299602	1874	5052000	16929	8578	17	0	\N
299603	1874	5055000	16929	8578	18	0	\N
299604	1874	5058000	16929	8578	19	0	\N
299605	1874	5061000	16929	8578	20	0	\N
299475	1874	4995000	16907	8573	7	0	2
299476	1874	4998000	16907	8573	8	0	2
299477	1874	5001000	16907	8573	9	0	2
299478	1678	18720659801000	16908	8574	0	0	0
299479	1678	18720659802000	16908	8574	1	0	0
299481	1874	5005000	16908	8574	3	0	2
299482	1874	5007000	16908	8574	4	0	2
299483	1874	5009000	16908	8574	5	0	2
299484	1874	5012000	16908	8574	6	0	2
299522	1678	18720659803000	16916	8575	0	0	0
299524	1874	5017000	16916	8575	2	0	2
299525	1678	18720659804000	16917	8576	0	0	0
299526	1874	5019000	16917	8576	1	0	2
299527	1874	5022000	16917	8576	2	0	2
299540	1874	5024000	16921	8577	1	0	2
299541	1874	5027000	16921	8577	2	0	2
299542	1874	5028000	16921	8577	3	0	2
299563	1678	18720659806000	16925	8578	0	0	0
299564	1678	18720659807000	16925	8578	1	0	0
299566	1678	18720659809000	16925	8578	3	0	0
299567	1874	5031000	16925	8578	4	0	2
299568	1874	5034000	16925	8578	5	0	2
299569	1874	5036000	16925	8578	6	0	2
299570	1874	5039000	16925	8578	7	0	2
299572	1874	5042000	16925	8578	9	0	2
299573	1874	5044000	16925	8578	10	0	2
299574	1874	5047000	16925	8578	11	0	2
299575	1678	18720659810000	16926	8579	0	0	0
299577	1874	5049000	16926	8579	2	0	2
299578	1874	5052000	16926	8579	3	0	2
299582	1678	18720659811000	16928	8580	0	0	0
299583	1874	5054000	16928	8580	1	0	2
299584	1874	5057000	16928	8580	2	0	2
299607	1874	5060000	16930	8581	1	0	2
299608	1874	5063000	16930	8581	2	0	2
299609	1678	18720659812000	16931	8582	0	0	\N
299610	1874	5066000	16931	8582	1	0	\N
299611	1874	5068000	16931	8582	2	0	\N
299618	1678	18720659813000	16934	8583	0	0	\N
299619	1874	5071000	16934	8583	1	0	\N
299620	1874	5073000	16934	8583	2	0	\N
299630	1678	18720659815000	16937	8585	0	0	\N
299631	1678	18720659816000	16937	8585	1	0	\N
299632	1874	5076000	16937	8585	2	0	\N
299633	1874	5079000	16937	8585	3	0	\N
299634	1874	5082000	16937	8585	4	0	\N
299635	1874	5085000	16937	8585	5	0	\N
299636	1874	5087000	16937	8585	6	0	\N
299637	1678	18720659815000	16938	8585	0	0	\N
299638	1678	18720659816000	16938	8585	1	0	\N
299639	1874	5076000	16938	8585	2	0	\N
299640	1874	5079000	16938	8585	3	0	\N
299641	1874	5082000	16938	8585	4	0	\N
299642	1874	5085000	16938	8585	5	0	\N
299643	1874	5087000	16938	8585	6	0	\N
299650	1678	18720659818000	16941	8587	0	0	\N
299651	1874	5094000	16941	8587	1	0	\N
299652	1874	5095000	16941	8587	2	0	\N
299654	1678	18720659819000	16943	8588	0	0	\N
299657	1678	18720659820000	16945	8589	0	0	\N
299658	1874	5097000	16945	8589	1	0	\N
299659	1678	18720659820000	16946	8589	0	0	\N
299660	1874	5097000	16946	8589	1	0	\N
299661	1678	18000647765000	16947	8461	0	0	\N
299662	1678	18000647766000	16947	8461	1	0	\N
299663	1678	18000647767000	16947	8461	2	0	\N
299664	1678	18000647768000	16947	8461	3	0	\N
299665	1678	18000647769000	16947	8461	4	0	\N
299666	2157	200000000	16947	8461	5	0	\N
299667	1678	18000647770000	16947	8461	6	0	\N
299668	1678	18000647771000	16947	8461	7	0	\N
299669	1678	18000647772000	16947	8461	8	0	\N
299670	1678	18000647773000	16947	8461	9	0	\N
299671	1678	18000647774000	16947	8461	10	0	\N
299672	1678	18000647775000	16947	8461	11	0	\N
299673	1678	18000647776000	16947	8461	12	0	\N
299674	1678	18000647777000	16947	8461	13	0	\N
299675	1678	18000647778000	16947	8461	14	0	\N
299676	1678	18000647779000	16947	8461	15	0	\N
299677	1678	18000647780000	16947	8461	16	0	\N
299678	1678	18000647781000	16947	8461	17	0	\N
299679	1678	18000647782000	16947	8461	18	0	\N
299680	1678	18000647783000	16947	8461	19	0	\N
299681	1678	18000647784000	16947	8461	20	0	\N
299682	1678	18000647785000	16947	8461	21	0	\N
299683	1678	18000647786000	16947	8461	22	0	\N
299684	1678	18000647787000	16947	8461	23	0	\N
299685	1678	18000647788000	16947	8461	24	0	\N
299686	1678	18000647789000	16947	8461	25	0	\N
299687	1678	18000647790000	16947	8461	26	0	\N
299688	1678	18000647791000	16947	8461	27	0	\N
299689	1678	18000647792000	16947	8461	28	0	\N
299690	1678	18000647793000	16947	8461	29	0	\N
299691	1678	18000647794000	16947	8461	30	0	\N
299692	1678	18000647795000	16947	8461	31	0	\N
299693	1678	18000647796000	16947	8461	32	0	\N
299694	1678	18000647797000	16947	8461	33	0	\N
299695	1678	18000647798000	16947	8461	34	0	\N
299696	1474	11794422000023	16947	8461	35	0	\N
299697	1678	18000647799000	16947	8461	36	0	\N
299698	1678	18000647800000	16947	8461	37	0	\N
299699	1678	18000647801000	16947	8461	38	0	\N
299700	1678	18000647802000	16947	8461	39	0	\N
299701	1678	18000647803000	16947	8461	40	0	\N
299702	1678	18000647804000	16947	8461	41	0	\N
299703	1678	18000647805000	16947	8461	42	0	\N
299704	1678	18000647806000	16947	8461	43	0	\N
299705	1678	18000647807000	16947	8461	44	0	\N
299706	1678	18000647808000	16947	8461	45	0	\N
299707	1678	18000647809000	16947	8461	46	0	\N
299708	1678	18000647810000	16947	8461	47	0	\N
299709	1678	18000647811000	16947	8461	48	0	\N
299710	1678	18000647812000	16947	8461	49	0	\N
299711	1678	18000647813000	16947	8461	50	0	\N
299712	1678	18000647814000	16947	8461	51	0	\N
299713	1678	18000647815000	16947	8461	52	0	\N
299714	1678	18000647816000	16947	8461	53	0	\N
299715	1678	18000647817000	16947	8461	54	0	\N
299716	1678	18000647818000	16947	8461	55	0	\N
299717	1678	18000647819000	16947	8461	56	0	\N
299718	1678	18000647820000	16947	8461	57	0	\N
299719	1299	1703411285540250	16947	8461	58	0	\N
299720	1053	905989686644800	16947	8461	59	0	\N
299721	1173	611289469681700	16947	8461	60	0	\N
299722	933	505577712770200	16947	8461	61	0	\N
299723	1874	4204000	16947	8461	62	0	\N
299724	1874	4205000	16947	8461	63	0	\N
299725	1874	4206000	16947	8461	64	0	\N
299726	1874	4207000	16947	8461	65	0	\N
299727	1874	4208000	16947	8461	66	0	\N
299728	1874	4209000	16947	8461	67	0	\N
299729	1874	4210000	16947	8461	68	0	\N
299730	1874	4211000	16947	8461	69	0	\N
299731	1874	4212000	16947	8461	70	0	\N
299732	1874	4213000	16947	8461	71	0	\N
299733	1874	4216000	16947	8461	72	0	\N
299734	1874	4217000	16947	8461	73	0	\N
299735	1874	4219000	16947	8461	74	0	\N
299736	1874	4221000	16947	8461	75	0	\N
299737	1874	4223000	16947	8461	76	0	\N
299738	1874	4224000	16947	8461	77	0	\N
299739	1874	4225000	16947	8461	78	0	\N
299740	1874	4226000	16947	8461	79	0	\N
299741	1874	4227000	16947	8461	80	0	\N
299742	1874	4228000	16947	8461	81	0	\N
299743	1874	4229000	16947	8461	82	0	\N
299744	1874	4230000	16947	8461	83	0	\N
299614	1874	5068000	16932	8582	2	0	2
299615	1678	18720659813000	16933	8583	0	0	0
299616	1874	5071000	16933	8583	1	0	2
299617	1874	5073000	16933	8583	2	0	2
299621	1678	18720659814000	16935	8584	0	0	0
299623	1678	18720659815000	16936	8585	0	0	0
299624	1678	18720659816000	16936	8585	1	0	0
299625	1874	5076000	16936	8585	2	0	2
299626	1874	5079000	16936	8585	3	0	2
299627	1874	5082000	16936	8585	4	0	2
299629	1874	5087000	16936	8585	6	0	2
299644	1678	18720659817000	16939	8586	0	0	0
299645	1874	5089000	16939	8586	1	0	2
299646	1874	5092000	16939	8586	2	0	2
299648	1874	5094000	16940	8587	1	0	2
299649	1874	5095000	16940	8587	2	0	2
299653	1678	18720659819000	16942	8588	0	0	0
299655	1678	18720659820000	16944	8589	0	0	0
299656	1874	5097000	16944	8589	1	0	2
299745	1874	4231000	16947	8461	84	0	\N
299746	1874	4232000	16947	8461	85	0	\N
299747	1874	4233000	16947	8461	88	0	\N
299748	1874	4234000	16947	8461	89	0	\N
299749	1874	4235000	16947	8461	90	0	\N
299750	1874	4236000	16947	8461	91	0	\N
299751	1874	4237000	16947	8461	92	0	\N
299752	1874	4239000	16947	8461	93	0	\N
299753	1874	4241000	16947	8461	94	0	\N
299754	1874	4243000	16947	8461	95	0	\N
299755	1874	4245000	16947	8461	96	0	\N
299756	1874	4247000	16947	8461	97	0	\N
299757	1874	4249000	16947	8461	98	0	\N
299758	1874	4251000	16947	8461	99	0	\N
299759	1874	4253000	16947	8461	100	0	\N
299760	1874	4255000	16947	8461	101	0	\N
299761	1874	4257000	16947	8461	102	0	\N
299762	1874	4259000	16947	8461	104	0	\N
299763	1874	4261000	16947	8461	105	0	\N
299764	1874	4263000	16947	8461	106	0	\N
299765	1874	4265000	16947	8461	107	0	\N
299766	1874	4267000	16947	8461	108	0	\N
299767	1874	4269000	16947	8461	109	0	\N
299768	1874	4271000	16947	8461	110	0	\N
299769	1874	4273000	16947	8461	111	0	\N
299770	1874	4275000	16947	8461	112	0	\N
299771	1874	4277000	16947	8461	113	0	\N
299772	1874	4279000	16947	8461	114	0	\N
299773	1874	4281000	16947	8461	115	0	\N
299774	1874	4283000	16947	8461	116	0	\N
299775	1874	4285000	16947	8461	117	0	\N
299776	1874	4286000	16947	8461	118	0	\N
299777	1874	4287000	16947	8461	119	0	\N
299778	1874	4288000	16947	8461	120	0	\N
299779	1874	4289000	16947	8461	121	0	\N
299780	1874	4290000	16947	8461	122	0	\N
299781	1874	4291000	16947	8461	123	0	\N
299782	1874	4292000	16947	8461	124	0	\N
299783	1874	4293000	16947	8461	125	0	\N
299798	1678	18720659825000	16954	8593	0	0	\N
299799	1678	18720659826000	16954	8593	1	0	\N
299800	1874	5109000	16954	8593	2	0	\N
299801	1874	5111000	16954	8593	3	0	\N
299802	1678	18720659827000	16955	8594	0	0	\N
299803	1678	18720659828000	16955	8594	1	0	\N
299804	2158	200000000	16955	8594	2	0	\N
299805	1874	5113000	16955	8594	3	0	\N
299806	1874	5115000	16955	8594	4	0	\N
299807	1874	5116000	16955	8594	5	0	\N
299808	1678	18720659827000	16956	8594	0	0	\N
299809	1678	18720659828000	16956	8594	1	0	\N
299810	2158	200000000	16956	8594	2	0	\N
299811	1874	5113000	16956	8594	3	0	\N
299812	1874	5115000	16956	8594	4	0	\N
299813	1874	5116000	16956	8594	5	0	\N
299814	1678	18720659827000	16957	8594	0	0	\N
299815	1678	18720659828000	16957	8594	1	0	\N
299816	2158	200000000	16957	8594	2	0	\N
299817	1874	5113000	16957	8594	3	0	\N
299818	1874	5115000	16957	8594	4	0	\N
299819	1874	5116000	16957	8594	5	0	\N
299829	1678	18720659831000	16961	8597	0	0	\N
299830	1874	5119000	16961	8597	1	0	\N
299831	1874	5121000	16961	8597	2	0	\N
299835	1678	18720659832000	16963	8598	0	0	\N
299836	1678	18720659833000	16963	8598	1	0	\N
299837	1678	18720659834000	16963	8598	2	0	\N
299838	1874	5123000	16963	8598	3	0	\N
299839	1874	5125000	16963	8598	4	0	\N
299840	1874	5127000	16963	8598	5	0	\N
299841	2156	718900000000	16964	8523	0	0	\N
299842	2157	200000000	16964	8523	1	0	\N
299843	2158	200000000	16964	8523	2	0	\N
299844	1474	11794422000023	16964	8523	3	0	\N
299845	1299	1703411285540250	16964	8523	4	0	\N
299846	1053	905989686644800	16964	8523	5	0	\N
299847	1173	611289469681700	16964	8523	6	0	\N
299848	933	505577712770200	16964	8523	7	0	\N
299855	1678	18720659832000	16966	8598	0	0	\N
299856	1678	18720659833000	16966	8598	1	0	\N
299857	1678	18720659834000	16966	8598	2	0	\N
299858	1874	5123000	16966	8598	3	0	\N
299859	1874	5125000	16966	8598	4	0	\N
299860	1874	5127000	16966	8598	5	0	\N
299861	1678	18720659832000	16967	8598	0	0	\N
299862	1678	18720659833000	16967	8598	1	0	\N
299863	1678	18720659834000	16967	8598	2	0	\N
299864	1874	5123000	16967	8598	3	0	\N
299865	1874	5125000	16967	8598	4	0	\N
299866	1874	5127000	16967	8598	5	0	\N
299867	1678	18720659832000	16968	8598	0	0	\N
299868	1678	18720659833000	16968	8598	1	0	\N
299869	1678	18720659834000	16968	8598	2	0	\N
299870	1874	5123000	16968	8598	3	0	\N
299871	1874	5125000	16968	8598	4	0	\N
299872	1874	5127000	16968	8598	5	0	\N
299873	2157	200000000	16969	8538	0	0	\N
299874	2158	200000000	16969	8538	1	0	\N
299875	1474	11794422000023	16969	8538	2	0	\N
299879	1678	18720659835000	16971	8599	0	0	\N
299880	1874	5128000	16971	8599	1	0	\N
299786	1874	5100000	16948	8590	2	0	2
299787	1678	18720659822000	16949	8591	0	0	0
299788	1874	5102000	16949	8591	1	0	2
299789	1678	18720659823000	16951	8592	0	0	0
299790	1678	18720659824000	16951	8592	1	0	0
299792	1874	5106000	16951	8592	3	0	2
299793	1874	5107000	16951	8592	4	0	2
299794	1678	18720659825000	16953	8593	0	0	0
299795	1678	18720659826000	16953	8593	1	0	0
299796	1874	5109000	16953	8593	2	0	2
299820	1678	18720659827000	16958	8594	0	0	0
299821	1678	18720659828000	16958	8594	1	0	0
299822	2158	200000000	16958	8594	2	0	0
299823	1874	5113000	16958	8594	3	0	2
299825	1874	5116000	16958	8594	5	0	2
299826	1678	18720659829000	16959	8595	0	0	0
299827	1874	5118000	16959	8595	1	0	2
299828	1678	18720659830000	16960	8596	0	0	0
299832	1678	18720659831000	16962	8597	0	0	0
299834	1874	5121000	16962	8597	2	0	2
299849	1678	18720659832000	16965	8598	0	0	0
299850	1678	18720659833000	16965	8598	1	0	0
299851	1678	18720659834000	16965	8598	2	0	0
299852	1874	5123000	16965	8598	3	0	2
299854	1874	5127000	16965	8598	5	0	2
299876	1678	18720659835000	16970	8599	0	0	0
299877	1874	5128000	16970	8599	1	0	2
299878	1874	5130000	16970	8599	2	0	2
299881	1874	5130000	16971	8599	2	0	\N
299882	1678	18720659836000	16972	8600	0	0	\N
299883	1874	5132000	16972	8600	1	0	\N
299884	1678	18720659836000	16973	8600	0	0	\N
299885	1874	5132000	16973	8600	1	0	\N
299886	1678	18720659836000	16974	8600	0	0	\N
299887	1874	5132000	16974	8600	1	0	\N
299890	1678	18720659836000	16976	8600	0	0	\N
299891	1874	5132000	16976	8600	1	0	\N
299892	1678	18720659837000	16978	8601	0	0	\N
299897	1678	18720659839000	16981	8603	0	0	\N
299898	1874	5137000	16981	8603	1	0	\N
299899	1678	18720659839000	16982	8603	0	0	\N
299900	1874	5137000	16982	8603	1	0	\N
299903	1678	18720659840000	16984	8604	0	0	\N
299904	1678	18720659841000	16984	8604	1	0	\N
299905	1874	5138000	16984	8604	2	0	\N
299906	1874	5140000	16984	8604	3	0	\N
299907	1874	5142000	16984	8604	4	0	\N
299913	1678	18720659840000	16986	8604	0	0	\N
299914	1678	18720659841000	16986	8604	1	0	\N
299915	1874	5138000	16986	8604	2	0	\N
299916	1874	5140000	16986	8604	3	0	\N
299917	1874	5142000	16986	8604	4	0	\N
299920	1678	18720659842000	16988	8605	0	0	\N
299921	1874	5144000	16988	8605	1	0	\N
299922	1678	18720659842000	16989	8605	0	0	\N
299923	1874	5144000	16989	8605	1	0	\N
299938	1678	18720659848000	17000	8610	0	0	\N
299939	1874	5158000	17000	8610	1	0	\N
299940	1678	18720659848000	17001	8610	0	0	\N
299941	1874	5158000	17001	8610	1	0	\N
299951	1678	18720659851000	17005	8613	0	0	\N
299952	1678	18720659852000	17005	8613	1	0	\N
299953	1874	5165000	17005	8613	2	0	\N
299954	1874	5167000	17005	8613	3	0	\N
299955	1678	18720659851000	17006	8613	0	0	\N
299956	1678	18720659852000	17006	8613	1	0	\N
299957	1874	5165000	17006	8613	2	0	\N
299958	1874	5167000	17006	8613	3	0	\N
299971	1678	18720659856000	17010	8616	0	0	\N
299972	1678	18720659857000	17010	8616	1	0	\N
299973	1874	5175000	17010	8616	2	0	\N
299974	1874	5177000	17010	8616	3	0	\N
299975	1874	5179000	17010	8616	4	0	\N
299982	1678	18720659859000	17013	8618	0	0	\N
299983	1874	5187000	17013	8618	1	0	\N
299991	1678	18720659862000	17015	8620	0	0	\N
299992	1874	5201000	17015	8620	1	0	\N
299993	1874	5203000	17015	8620	3	0	\N
299997	1678	18720659863000	17017	8621	0	0	\N
299998	1874	5206000	17017	8621	1	0	\N
299999	1874	5208000	17017	8621	2	0	\N
300000	1678	18720659863000	17018	8621	0	0	\N
300001	1874	5206000	17018	8621	1	0	\N
300002	1874	5208000	17018	8621	2	0	\N
300006	1678	18720659864000	17020	8622	0	0	\N
300007	1678	18720659865000	17020	8622	1	0	\N
300008	1874	5211000	17020	8622	2	0	\N
300009	1874	5214000	17020	8622	3	0	\N
300010	1874	5215000	17020	8622	4	0	\N
300011	1874	5217000	17020	8622	5	0	\N
300012	1874	5219000	17020	8622	6	0	\N
300013	1678	18720659864000	17021	8622	0	0	\N
300014	1678	18720659865000	17021	8622	1	0	\N
300015	1874	5211000	17021	8622	2	0	\N
300016	1874	5214000	17021	8622	3	0	\N
299893	1678	18720659837000	16979	8601	0	0	0
299894	1678	18720659838000	16980	8602	0	0	0
299895	1874	5133000	16980	8602	1	0	2
299896	1874	5135000	16980	8602	2	0	2
299901	1678	18720659839000	16983	8603	0	0	0
299908	1678	18720659840000	16985	8604	0	0	0
299909	1678	18720659841000	16985	8604	1	0	0
299910	1874	5138000	16985	8604	2	0	2
299911	1874	5140000	16985	8604	3	0	2
299912	1874	5142000	16985	8604	4	0	2
299919	1874	5144000	16987	8605	1	0	2
299924	1678	18720659843000	16990	8606	0	0	0
299925	1874	5146000	16990	8606	1	0	2
299926	1678	18720659844000	16991	8607	0	0	0
299928	1874	5149000	16991	8607	2	0	2
299929	1678	18720659845000	16994	8608	0	0	0
299930	1874	5151000	16994	8608	1	0	2
299931	1678	18720659846000	16998	8609	0	0	0
299932	1678	18720659847000	16998	8609	1	0	0
299934	1874	5154000	16998	8609	3	0	2
299935	1874	5156000	16998	8609	4	0	2
299936	1678	18720659848000	16999	8610	0	0	0
299937	1874	5158000	16999	8610	1	0	2
299942	1678	18720659849000	17002	8611	0	0	0
299944	1678	18720659850000	17003	8612	0	0	0
299945	1874	5161000	17003	8612	1	0	2
299946	1874	5163000	17003	8612	2	0	2
299947	1678	18720659851000	17004	8613	0	0	0
299949	1874	5165000	17004	8613	2	0	2
299950	1874	5167000	17004	8613	3	0	2
299959	1678	18720659853000	17007	8614	0	0	0
299960	1678	18720659854000	17007	8614	1	0	0
299961	1874	5169000	17007	8614	2	0	2
299963	1874	5172000	17007	8614	4	0	2
299964	1678	18720659855000	17008	8615	0	0	0
299965	1874	5174000	17008	8615	1	0	2
299966	1678	18720659856000	17009	8616	0	0	0
299967	1678	18720659857000	17009	8616	1	0	0
299969	1874	5177000	17009	8616	3	0	2
299970	1874	5179000	17009	8616	4	0	2
299976	1678	18720659858000	17011	8617	0	0	0
299977	2159	200000000	17011	8617	1	0	0
299979	1874	5184000	17011	8617	3	0	2
299980	1678	18720659859000	17012	8618	0	0	0
299981	1874	5187000	17012	8618	1	0	2
299984	1678	18720659860000	17014	8619	0	0	0
299985	1678	18720659861000	17014	8619	1	0	0
299987	1874	5191000	17014	8619	3	0	2
299988	1874	5194000	17014	8619	4	0	2
299989	1874	5196000	17014	8619	5	0	2
299990	1874	5198000	17014	8619	6	0	2
299994	1678	18720659862000	17016	8620	0	0	0
299996	1874	5203000	17016	8620	3	0	2
300003	1678	18720659863000	17019	8621	0	0	0
300004	1874	5206000	17019	8621	1	0	2
300005	1874	5208000	17019	8621	2	0	2
300017	1874	5215000	17021	8622	4	0	\N
300018	1874	5217000	17021	8622	5	0	\N
300019	1874	5219000	17021	8622	6	0	\N
300027	1678	18720659864000	17023	8622	0	0	\N
300028	1678	18720659865000	17023	8622	1	0	\N
300029	1874	5211000	17023	8622	2	0	\N
300030	1874	5214000	17023	8622	3	0	\N
300031	1874	5215000	17023	8622	4	0	\N
300032	1874	5217000	17023	8622	5	0	\N
300033	1874	5219000	17023	8622	6	0	\N
300034	1678	18720659866000	17024	8623	0	0	\N
300035	1874	5221000	17024	8623	1	0	\N
300036	1874	5224000	17024	8623	2	0	\N
300037	1874	5221000	17025	8623	0	0	\N
300038	1874	5224000	17025	8623	1	0	\N
300042	1678	18720659823000	17027	8592	0	0	\N
300043	1678	18720659824000	17027	8592	1	0	\N
300044	1678	18720659825000	17027	8592	2	0	\N
300045	1678	18720659826000	17027	8592	3	0	\N
300046	1678	18720659827000	17027	8592	4	0	\N
300047	1678	18720659828000	17027	8592	5	0	\N
300048	2158	200000000	17027	8592	6	0	\N
300049	2159	200000000	17027	8592	7	0	\N
300050	1678	18720659829000	17027	8592	8	0	\N
300051	1678	18720659830000	17027	8592	9	0	\N
300052	1678	18720659831000	17027	8592	10	0	\N
300053	1678	18720659832000	17027	8592	11	0	\N
300054	1678	18720659833000	17027	8592	12	0	\N
300055	1678	18720659834000	17027	8592	13	0	\N
300056	1678	18720659835000	17027	8592	14	0	\N
300057	1678	18720659836000	17027	8592	15	0	\N
300058	1678	18720659837000	17027	8592	16	0	\N
300059	1678	18720659838000	17027	8592	17	0	\N
300060	1678	18720659839000	17027	8592	18	0	\N
300061	1678	18720659840000	17027	8592	19	0	\N
300062	1678	18720659841000	17027	8592	20	0	\N
300063	1678	18720659842000	17027	8592	21	0	\N
300064	1678	18720659843000	17027	8592	22	0	\N
300065	1678	18720659844000	17027	8592	24	0	\N
300066	1678	18720659845000	17027	8592	25	0	\N
300067	1678	18720659846000	17027	8592	26	0	\N
300068	1678	18720659847000	17027	8592	27	0	\N
300069	1678	18720659848000	17027	8592	28	0	\N
300070	1678	18720659849000	17027	8592	29	0	\N
300071	1678	18720659850000	17027	8592	30	0	\N
300072	1678	18720659851000	17027	8592	31	0	\N
300073	1678	18720659852000	17027	8592	32	0	\N
300074	1678	18720659853000	17027	8592	33	0	\N
300075	1678	18720659854000	17027	8592	34	0	\N
300076	1678	18720659855000	17027	8592	35	0	\N
300077	1678	18720659856000	17027	8592	36	0	\N
300078	1678	18720659857000	17027	8592	37	0	\N
300079	1678	18720659858000	17027	8592	38	0	\N
300080	1678	18720659859000	17027	8592	39	0	\N
300081	1678	18720659860000	17027	8592	40	0	\N
300082	1678	18720659861000	17027	8592	41	0	\N
300083	1678	18720659862000	17027	8592	42	0	\N
300084	1678	18720659863000	17027	8592	43	0	\N
300085	1678	18720659864000	17027	8592	44	0	\N
300086	1678	18720659865000	17027	8592	45	0	\N
300087	1678	18720659866000	17027	8592	46	0	\N
300088	1874	5104000	17027	8592	47	0	\N
300089	1874	5106000	17027	8592	48	0	\N
300090	1874	5108000	17027	8592	49	0	\N
300091	1874	5110000	17027	8592	50	0	\N
300092	1874	5112000	17027	8592	51	0	\N
300093	1874	5114000	17027	8592	52	0	\N
300094	1874	5116000	17027	8592	53	0	\N
300095	1874	5118000	17027	8592	54	0	\N
300096	1874	5120000	17027	8592	55	0	\N
300097	1874	5123000	17027	8592	56	0	\N
300098	1874	5126000	17027	8592	57	0	\N
300099	1874	5129000	17027	8592	58	0	\N
300100	1874	5132000	17027	8592	59	0	\N
300101	1874	5135000	17027	8592	60	0	\N
300102	1874	5138000	17027	8592	61	0	\N
300103	1874	5141000	17027	8592	62	0	\N
300104	1874	5144000	17027	8592	63	0	\N
300105	1874	5147000	17027	8592	64	0	\N
300106	1874	5149000	17027	8592	65	0	\N
300107	1874	5151000	17027	8592	66	0	\N
300108	1874	5153000	17027	8592	67	0	\N
300109	1874	5155000	17027	8592	68	0	\N
300110	1874	5157000	17027	8592	69	0	\N
300111	1874	5159000	17027	8592	70	0	\N
300112	1874	5161000	17027	8592	71	0	\N
300113	1874	5163000	17027	8592	72	0	\N
300114	1874	5164000	17027	8592	73	0	\N
300115	1874	5165000	17027	8592	74	0	\N
300116	1874	5166000	17027	8592	75	0	\N
300117	1874	5167000	17027	8592	76	0	\N
300118	1874	5168000	17027	8592	77	0	\N
300119	1874	5169000	17027	8592	78	0	\N
300120	1874	5170000	17027	8592	79	0	\N
300121	1874	5171000	17027	8592	80	0	\N
300122	1874	5172000	17027	8592	81	0	\N
300123	1874	5173000	17027	8592	82	0	\N
300124	1874	5174000	17027	8592	83	0	\N
300125	1874	5175000	17027	8592	84	0	\N
300126	1874	5176000	17027	8592	85	0	\N
300127	1874	5178000	17027	8592	86	0	\N
300128	1874	5180000	17027	8592	87	0	\N
300129	1874	5182000	17027	8592	88	0	\N
300130	1874	5184000	17027	8592	89	0	\N
300131	1874	5186000	17027	8592	90	0	\N
300132	1874	5188000	17027	8592	91	0	\N
300133	1874	5190000	17027	8592	92	0	\N
300134	1874	5192000	17027	8592	93	0	\N
300135	1874	5194000	17027	8592	94	0	\N
300136	1874	5196000	17027	8592	95	0	\N
300137	1874	5198000	17027	8592	96	0	\N
300138	1874	5200000	17027	8592	97	0	\N
300139	1874	5202000	17027	8592	98	0	\N
300140	1874	5204000	17027	8592	99	0	\N
300141	1874	5206000	17027	8592	100	0	\N
300142	1874	5208000	17027	8592	101	0	\N
300143	1874	5210000	17027	8592	102	0	\N
300144	1874	5212000	17027	8592	103	0	\N
300145	1874	5214000	17027	8592	104	0	\N
300146	1874	5216000	17027	8592	105	0	\N
300147	1874	5218000	17027	8592	106	0	\N
300148	1874	5220000	17027	8592	107	0	\N
300149	1874	5222000	17027	8592	108	0	\N
300150	1874	5224000	17027	8592	109	0	\N
300151	1874	5226000	17028	8624	0	0	\N
300152	1874	5227000	17028	8624	1	0	\N
300022	1874	5211000	17022	8622	2	0	2
300023	1874	5214000	17022	8622	3	0	2
300024	1874	5215000	17022	8622	4	0	2
300025	1874	5217000	17022	8622	5	0	2
300026	1874	5219000	17022	8622	6	0	2
300040	1874	5221000	17026	8623	1	0	2
300041	1874	5224000	17026	8623	2	0	2
300155	1678	18720659866000	17030	8623	0	0	\N
300156	1874	5221000	17030	8623	1	0	\N
300157	1874	5223000	17030	8623	2	0	\N
300158	1874	5226000	17030	8623	3	0	\N
300159	1874	5227000	17030	8623	4	0	\N
300160	1874	5226000	17031	8624	0	0	\N
300161	1874	5227000	17031	8624	1	0	\N
300162	1874	5225000	17032	8624	0	0	\N
300163	1678	18720659867000	17033	8625	0	0	\N
300164	1874	5227000	17033	8625	1	0	\N
300165	1874	5230000	17033	8625	2	0	\N
300166	1874	5232000	17033	8625	3	0	\N
300169	1678	18720659868000	17035	8626	0	0	\N
300170	1874	5233000	17035	8626	1	0	\N
300171	1874	5235000	17035	8626	2	0	\N
300178	1678	18720659869000	17038	8627	0	0	\N
300179	1874	5237000	17038	8627	1	0	\N
300180	1874	5240000	17038	8627	2	0	\N
300200	1678	18720659874000	17044	8632	0	0	\N
300201	1678	18720659875000	17044	8632	1	0	\N
300202	1874	5263000	17044	8632	2	0	\N
300203	1874	5266000	17044	8632	3	0	\N
300204	1874	5268000	17044	8632	4	0	\N
300205	1874	5270000	17044	8632	5	0	\N
300210	1678	18720659876000	17047	8633	0	0	\N
300211	1874	5273000	17047	8633	1	0	\N
300212	1874	5275000	17047	8633	2	0	\N
300213	1874	5276000	17047	8633	3	0	\N
300217	1874	5279000	17049	8634	0	0	\N
300218	1874	5281000	17049	8634	1	0	\N
300225	1678	18720659791000	17052	8567	0	0	\N
300226	1678	18720659792000	17052	8567	1	0	\N
300227	2157	200000000	17052	8567	2	0	\N
300228	2158	200000000	17052	8567	3	0	\N
300229	2159	200000000	17052	8567	4	0	\N
300230	1678	18720659793000	17052	8567	5	0	\N
300231	1678	18720659794000	17052	8567	6	0	\N
300232	1678	18720659795000	17052	8567	7	0	\N
300233	1678	18720659796000	17052	8567	8	0	\N
300234	1678	18720659797000	17052	8567	9	0	\N
300235	1678	18720659798000	17052	8567	10	0	\N
300236	1474	11794422000023	17052	8567	11	0	\N
300237	1678	18720659799000	17052	8567	12	0	\N
300238	1678	18720659800000	17052	8567	13	0	\N
300239	1678	18720659801000	17052	8567	14	0	\N
300240	1678	18720659802000	17052	8567	15	0	\N
300241	1678	18720659803000	17052	8567	16	0	\N
300242	1678	18720659804000	17052	8567	17	0	\N
300243	1678	18720659805000	17052	8567	18	0	\N
300244	1678	18720659806000	17052	8567	19	0	\N
300245	1678	18720659807000	17052	8567	20	0	\N
300246	1678	18720659808000	17052	8567	21	0	\N
300247	1678	18720659809000	17052	8567	22	0	\N
300248	1678	18720659810000	17052	8567	23	0	\N
300249	1678	18720659811000	17052	8567	24	0	\N
300250	1678	18720659812000	17052	8567	25	0	\N
300251	1678	18720659813000	17052	8567	26	0	\N
300252	1678	18720659814000	17052	8567	27	0	\N
300253	1678	18720659815000	17052	8567	28	0	\N
300254	1678	18720659816000	17052	8567	29	0	\N
300255	1678	18720659817000	17052	8567	30	0	\N
300256	1678	18720659818000	17052	8567	31	0	\N
300257	1678	18720659819000	17052	8567	32	0	\N
300258	1678	18720659820000	17052	8567	33	0	\N
300259	1678	18720659821000	17052	8567	34	0	\N
300260	1678	18720659822000	17052	8567	35	0	\N
300261	1678	18720659823000	17052	8567	36	0	\N
300262	1678	18720659824000	17052	8567	37	0	\N
300263	1678	18720659825000	17052	8567	38	0	\N
300264	1678	18720659826000	17052	8567	39	0	\N
300265	1678	18720659827000	17052	8567	40	0	\N
300266	1678	18720659828000	17052	8567	41	0	\N
300267	1678	18720659829000	17052	8567	42	0	\N
300268	1678	18720659830000	17052	8567	43	0	\N
300269	1678	18720659831000	17052	8567	44	0	\N
300270	1678	18720659832000	17052	8567	45	0	\N
300271	1678	18720659833000	17052	8567	47	0	\N
300272	1678	18720659834000	17052	8567	48	0	\N
300273	1678	18720659835000	17052	8567	49	0	\N
300274	1678	18720659836000	17052	8567	50	0	\N
300275	1678	18720659837000	17052	8567	51	0	\N
300276	1678	18720659838000	17052	8567	52	0	\N
300277	1678	18720659839000	17052	8567	53	0	\N
300278	1678	18720659840000	17052	8567	54	0	\N
300279	1678	18720659841000	17052	8567	55	0	\N
300280	1678	18720659842000	17052	8567	56	0	\N
300281	1678	18720659843000	17052	8567	57	0	\N
300282	1678	18720659844000	17052	8567	58	0	\N
300283	1678	18720659845000	17052	8567	59	0	\N
300284	1678	18720659846000	17052	8567	60	0	\N
300285	1678	18720659847000	17052	8567	61	0	\N
300286	1678	18720659848000	17052	8567	62	0	\N
300287	1678	18720659849000	17052	8567	63	0	\N
300288	1678	18720659850000	17052	8567	64	0	\N
300167	1678	18720659867000	17034	8625	0	0	0
300168	1874	5230000	17034	8625	1	0	2
300172	1678	18720659868000	17036	8626	0	0	0
300173	1874	5233000	17036	8626	1	0	2
300174	1874	5235000	17036	8626	2	0	2
300176	1874	5237000	17037	8627	1	0	2
300177	1874	5240000	17037	8627	2	0	2
300181	1678	18720659870000	17039	8628	0	0	0
300182	1874	5241000	17039	8628	1	0	2
300183	1874	5243000	17039	8628	2	0	2
300185	1678	18720659871000	17040	8629	0	0	0
300186	1874	5249000	17040	8629	1	0	2
300187	1874	5251000	17040	8629	2	0	2
300188	1678	18720659872000	17041	8630	0	0	0
300190	1874	5256000	17041	8630	2	0	2
300191	1678	18720659873000	17042	8631	0	0	0
300192	1874	5257000	17042	8631	1	0	2
300193	1874	5260000	17042	8631	2	0	2
300194	1678	18720659874000	17043	8632	0	0	0
300196	1874	5263000	17043	8632	2	0	2
300197	1874	5266000	17043	8632	3	0	2
300198	1874	5268000	17043	8632	4	0	2
300199	1874	5270000	17043	8632	5	0	2
300206	1678	18720659876000	17046	8633	0	0	0
300208	1874	5275000	17046	8633	2	0	2
300209	1874	5276000	17046	8633	3	0	2
300214	1678	18720659877000	17048	8634	0	0	0
300215	1874	5279000	17048	8634	1	0	2
300219	1678	18720659878000	17050	8635	0	0	0
300220	1874	5284000	17050	8635	1	0	2
300221	1874	5286000	17050	8635	2	0	2
300222	1678	18720659879000	17051	8636	0	0	0
300223	1874	5289000	17051	8636	1	0	2
300289	1678	18720659851000	17052	8567	65	0	\N
300290	1678	18720659852000	17052	8567	66	0	\N
300291	1678	18720659853000	17052	8567	67	0	\N
300292	1678	18720659854000	17052	8567	68	0	\N
300293	1678	18720659855000	17052	8567	69	0	\N
300294	1678	18720659856000	17052	8567	70	0	\N
300295	1678	18720659857000	17052	8567	71	0	\N
300296	1678	18720659858000	17052	8567	72	0	\N
300297	1678	18720659859000	17052	8567	73	0	\N
300298	1678	18720659860000	17052	8567	74	0	\N
300299	1678	18720659861000	17052	8567	75	0	\N
300300	1678	18720659862000	17052	8567	76	0	\N
300301	1678	18720659863000	17052	8567	77	0	\N
300302	1678	18720659864000	17052	8567	78	0	\N
300303	1678	18720659865000	17052	8567	79	0	\N
300304	1678	18720659866000	17052	8567	80	0	\N
300305	1678	18720659867000	17052	8567	81	0	\N
300306	1678	18720659868000	17052	8567	82	0	\N
300307	1678	18720659869000	17052	8567	83	0	\N
300308	1678	18720659870000	17052	8567	84	0	\N
300309	1678	18720659871000	17052	8567	85	0	\N
300310	1678	18720659872000	17052	8567	86	0	\N
300311	1678	18720659873000	17052	8567	87	0	\N
300312	1678	18720659874000	17052	8567	88	0	\N
300313	1678	18720659875000	17052	8567	89	0	\N
300314	1678	18720659876000	17052	8567	90	0	\N
300315	1678	18720659877000	17052	8567	91	0	\N
300316	1678	18720659878000	17052	8567	92	0	\N
300317	1678	18720659879000	17052	8567	93	0	\N
300318	1874	4951000	17052	8567	94	0	\N
300319	1874	4954000	17052	8567	95	0	\N
300320	1874	4956000	17052	8567	96	0	\N
300321	1874	4957000	17052	8567	97	0	\N
300322	1874	4958000	17052	8567	98	0	\N
300323	1874	4959000	17052	8567	99	0	\N
300324	1874	4961000	17052	8567	100	0	\N
300325	1874	4964000	17052	8567	101	0	\N
300326	1874	4967000	17052	8567	102	0	\N
300327	1874	4970000	17052	8567	103	0	\N
300328	1874	4973000	17052	8567	104	0	\N
300329	1874	4975000	17052	8567	105	0	\N
300330	1874	4977000	17052	8567	106	0	\N
300331	1874	4979000	17052	8567	107	0	\N
300332	1874	4981000	17052	8567	108	0	\N
300333	1874	4983000	17052	8567	109	0	\N
300334	1874	4985000	17052	8567	110	0	\N
300335	1874	4987000	17052	8567	111	0	\N
300336	1874	4989000	17052	8567	112	0	\N
300337	1874	4991000	17052	8567	113	0	\N
300338	1874	4994000	17052	8567	114	0	\N
300339	1874	4997000	17052	8567	115	0	\N
300340	1874	5000000	17052	8567	116	0	\N
300341	1874	5003000	17052	8567	117	0	\N
300342	1874	5006000	17052	8567	118	0	\N
300343	1874	5009000	17052	8567	119	0	\N
300344	1874	5012000	17052	8567	120	0	\N
300345	1874	5015000	17052	8567	121	0	\N
300346	1874	5018000	17052	8567	122	0	\N
300347	1874	5021000	17052	8567	123	0	\N
300348	1874	5024000	17052	8567	124	0	\N
300349	1874	5027000	17052	8567	125	0	\N
300350	2159	200000000	17053	8539	0	0	\N
300351	2160	200000000	17053	8539	1	0	\N
300352	1678	18720659880000	17054	8637	0	0	\N
300353	2160	200000000	17054	8637	1	0	\N
300354	1874	5293000	17054	8637	2	0	\N
300355	1874	5294000	17054	8637	3	0	\N
300356	1678	18720659880000	17055	8637	0	0	\N
300357	2160	200000000	17055	8637	1	0	\N
300358	1874	5294000	17055	8637	2	0	\N
300359	1874	5296000	17055	8637	3	0	\N
300360	1874	5297000	17055	8637	4	0	\N
300382	1678	18720659886000	17061	8642	0	0	\N
300383	1874	5325000	17061	8642	1	0	\N
300384	1874	5328000	17061	8642	2	0	\N
300385	1874	5329000	17061	8642	3	0	\N
300390	2156	718900000000	17063	8411	0	0	\N
300391	1678	18000647723000	17063	8411	1	0	\N
300392	2157	200000000	17063	8411	2	0	\N
300393	1678	18000647724000	17063	8411	3	0	\N
300394	2158	200000000	17063	8411	4	0	\N
300395	2159	200000000	17063	8411	5	0	\N
300396	2160	200000000	17063	8411	6	0	\N
300397	1678	18000647725000	17063	8411	7	0	\N
300398	1678	18000647726000	17063	8411	8	0	\N
300399	1678	18000647727000	17063	8411	9	0	\N
300400	1678	18000647728000	17063	8411	10	0	\N
300401	1678	18000647729000	17063	8411	11	0	\N
300402	1678	18000647730000	17063	8411	12	0	\N
300403	1678	18000647731000	17063	8411	13	0	\N
300404	1678	18000647732000	17063	8411	14	0	\N
300405	1678	18000647733000	17063	8411	15	0	\N
300406	1678	18000647734000	17063	8411	16	0	\N
300407	1678	18000647735000	17063	8411	17	0	\N
300408	1678	18000647736000	17063	8411	18	0	\N
300409	1678	18000647737000	17063	8411	19	0	\N
300410	1678	18000647738000	17063	8411	20	0	\N
300411	1678	18000647739000	17063	8411	21	0	\N
300412	1678	18000647740000	17063	8411	22	0	\N
300413	1678	18000647741000	17063	8411	23	0	\N
300414	1678	18000647742000	17063	8411	24	0	\N
300415	1874	5330000	17065	8644	0	0	\N
300363	1874	5294000	17056	8637	2	0	2
300364	1874	5296000	17056	8637	3	0	2
300365	1874	5297000	17056	8637	4	0	2
300366	1678	18720659881000	17057	8638	0	0	0
300367	1874	5299000	17057	8638	1	0	2
300369	1678	18720659882000	17058	8639	0	0	0
300370	1678	18720659883000	17058	8639	1	0	0
300371	1874	5303000	17058	8639	2	0	2
300372	1874	5305000	17058	8639	3	0	2
300373	1874	5307000	17058	8639	4	0	2
300375	1874	5313000	17058	8639	6	0	2
300376	1678	18720659884000	17059	8640	0	0	0
300377	1874	5315000	17059	8640	1	0	2
300378	1874	5318000	17059	8640	2	0	2
300380	1874	5321000	17060	8641	1	0	2
300381	1874	5323000	17060	8641	2	0	2
300386	1678	18720659886000	17062	8642	0	0	0
300387	1874	5325000	17062	8642	1	0	2
300388	1874	5328000	17062	8642	2	0	2
300416	1678	18720659887000	17066	8644	0	0	0
300417	1678	18720659888000	17066	8644	1	0	0
300418	1678	18720659889000	17066	8644	2	0	0
300419	1678	18720659890000	17066	8644	3	0	0
300420	1874	5330000	17066	8644	4	0	2
300422	1874	5334000	17066	8644	6	0	2
300423	1874	5336000	17066	8644	7	0	2
300424	1874	5338000	17066	8644	8	0	2
300429	2157	200000000	17067	8541	0	0	\N
300430	2158	200000000	17067	8541	1	0	\N
300431	2159	200000000	17067	8541	2	0	\N
300432	2160	200000000	17067	8541	3	0	\N
300433	1474	11794422000023	17067	8541	4	0	\N
300440	1678	18720659893000	17070	8647	0	0	\N
300441	1874	5362000	17070	8647	1	0	\N
300442	1874	5365000	17070	8647	2	0	\N
300443	1874	5366000	17070	8647	3	0	\N
300448	1678	18720659893000	17072	8647	0	0	\N
300449	1874	5362000	17072	8647	1	0	\N
300450	1874	5363000	17072	8647	2	0	\N
300451	1678	18720659894000	17073	8648	0	0	\N
300452	1874	5369000	17073	8648	1	0	\N
300453	1678	18720659894000	17074	8648	0	0	\N
300454	1874	5369000	17074	8648	1	0	\N
300460	1678	18720659895000	17077	8649	0	0	\N
300461	1874	5369000	17077	8649	1	0	\N
300462	1874	5372000	17077	8649	2	0	\N
300463	1874	5374000	17077	8649	3	0	\N
300490	1958	3485987000000	17082	8653	0	0	\N
300491	1678	18720659902000	17082	8653	1	0	\N
300492	1874	5408000	17082	8653	2	0	\N
300493	1874	5411000	17082	8653	3	0	\N
300507	1958	3485987000000	17086	8593	0	0	\N
300508	1678	18720659867000	17086	8593	1	0	\N
300509	1678	18720659868000	17086	8593	2	0	\N
300510	2160	200000000	17086	8593	3	0	\N
300511	1678	18720659869000	17086	8593	4	0	\N
300512	1678	18720659870000	17086	8593	5	0	\N
300513	1678	18720659871000	17086	8593	6	0	\N
300514	1678	18720659872000	17086	8593	7	0	\N
300515	1678	18720659873000	17086	8593	8	0	\N
300516	1678	18720659874000	17086	8593	9	0	\N
300517	1678	18720659875000	17086	8593	10	0	\N
300518	1678	18720659876000	17086	8593	11	0	\N
300519	1678	18720659877000	17086	8593	12	0	\N
300520	1678	18720659878000	17086	8593	13	0	\N
300521	2111	2200000000	17086	8593	14	0	\N
300522	1678	18720659879000	17086	8593	15	0	\N
300523	1678	18720659880000	17086	8593	16	0	\N
300524	1678	18720659881000	17086	8593	17	0	\N
300525	1678	18720659882000	17086	8593	18	0	\N
300526	1678	18720659883000	17086	8593	19	0	\N
300527	1678	18720659884000	17086	8593	20	0	\N
300528	1678	18720659885000	17086	8593	21	0	\N
300529	1678	18720659886000	17086	8593	22	0	\N
300530	1678	18720659887000	17086	8593	23	0	\N
300531	1678	18720659888000	17086	8593	24	0	\N
300532	1678	18720659889000	17086	8593	25	0	\N
300533	1678	18720659890000	17086	8593	26	0	\N
300534	1678	18720659891000	17086	8593	27	0	\N
300535	1678	18720659892000	17086	8593	28	0	\N
300536	1678	18720659893000	17086	8593	29	0	\N
300537	1678	18720659894000	17086	8593	30	0	\N
300538	1678	18720659895000	17086	8593	31	0	\N
300539	1678	18720659896000	17086	8593	32	0	\N
300540	1678	18720659897000	17086	8593	33	0	\N
300541	1678	18720659898000	17086	8593	34	0	\N
300542	1678	18720659899000	17086	8593	35	0	\N
300543	1678	18720659900000	17086	8593	36	0	\N
300544	1678	18720659901000	17086	8593	37	0	\N
300545	1678	18720659902000	17086	8593	38	0	\N
300546	1678	18720659903000	17086	8593	40	0	\N
300547	1678	18720659904000	17086	8593	41	0	\N
300548	1678	18720659905000	17086	8593	42	0	\N
300549	1678	18720659906000	17086	8593	43	0	\N
300550	1874	5226000	17086	8593	44	0	\N
300551	1474	12514422000023	17086	8593	45	0	\N
300552	1874	5229000	17086	8593	46	0	\N
300553	1874	5232000	17086	8593	47	0	\N
300554	1874	5234000	17086	8593	48	0	\N
300555	1874	5236000	17086	8593	49	0	\N
300556	1874	5238000	17086	8593	50	0	\N
300557	1874	5240000	17086	8593	51	0	\N
300558	1874	5241000	17086	8593	52	0	\N
300559	1874	5242000	17086	8593	53	0	\N
300560	1874	5243000	17086	8593	54	0	\N
300427	1874	5347000	17066	8644	11	0	2
300428	1874	5350000	17066	8644	12	0	2
300434	1678	18720659891000	17068	8645	0	0	0
300435	1874	5353000	17068	8645	1	0	2
300436	1874	5355000	17068	8645	2	0	2
300438	1874	5357000	17069	8646	1	0	2
300439	1874	5360000	17069	8646	2	0	2
300444	1678	18720659893000	17071	8647	0	0	0
300445	1874	5362000	17071	8647	1	0	2
300446	1874	5365000	17071	8647	2	0	2
300455	1678	18720659894000	17075	8648	0	0	0
300456	1678	18720659895000	17076	8649	0	0	0
300457	1874	5369000	17076	8649	1	0	2
300458	1874	5372000	17076	8649	2	0	2
300464	1678	18720659896000	17078	8650	0	0	0
300465	1874	5376000	17078	8650	1	0	2
300466	1874	5379000	17078	8650	2	0	2
300467	1678	18720659897000	17079	8651	0	0	0
300468	1678	18720659898000	17079	8651	1	0	0
300470	1874	5381000	17079	8651	3	0	2
300471	1874	5384000	17079	8651	4	0	2
300472	1874	5387000	17079	8651	5	0	2
300473	1874	5389000	17079	8651	6	0	2
300474	1874	5390000	17079	8651	7	0	2
300476	1678	18720659900000	17080	8652	1	0	0
300477	1678	18720659901000	17080	8652	2	0	0
300478	1474	12514422000023	17080	8652	3	0	14
300479	1874	5392000	17080	8652	4	0	2
300481	1874	5395000	17080	8652	6	0	2
300482	1874	5397000	17080	8652	7	0	2
300483	1874	5400000	17080	8652	8	0	2
300484	1874	5403000	17080	8652	9	0	2
300485	1874	5406000	17080	8652	10	0	2
300487	1678	18720659902000	17081	8653	1	0	0
300488	1874	5408000	17081	8653	2	0	2
300489	1874	5411000	17081	8653	3	0	2
300494	1678	18720659903000	17083	8654	0	0	0
300495	1874	5413000	17083	8654	1	0	2
300497	1874	5417000	17083	8654	3	0	2
300498	1678	18720659904000	17084	8655	0	0	0
300499	1874	5420000	17084	8655	1	0	2
300500	1874	5422000	17084	8655	2	0	2
300502	1678	18720659906000	17085	8656	1	0	0
300503	1874	5425000	17085	8656	2	0	2
300504	1874	5427000	17085	8656	3	0	2
300505	1874	5429000	17085	8656	4	0	2
300506	1874	5432000	17085	8656	5	0	2
300561	1874	5245000	17086	8593	55	0	\N
300562	1874	5247000	17086	8593	56	0	\N
300563	1874	5249000	17086	8593	57	0	\N
300564	1874	5251000	17086	8593	58	0	\N
300565	1874	5253000	17086	8593	59	0	\N
300566	1874	5255000	17086	8593	60	0	\N
300567	1874	5257000	17086	8593	61	0	\N
300568	1874	5259000	17086	8593	62	0	\N
300569	1874	5261000	17086	8593	63	0	\N
300570	1874	5263000	17086	8593	64	0	\N
300571	1874	5265000	17086	8593	65	0	\N
300572	1874	5267000	17086	8593	66	0	\N
300573	1874	5269000	17086	8593	67	0	\N
300574	1874	5271000	17086	8593	68	0	\N
300575	1874	5273000	17086	8593	69	0	\N
300576	1874	5275000	17086	8593	70	0	\N
300577	1874	5277000	17086	8593	71	0	\N
300578	1874	5279000	17086	8593	72	0	\N
300579	1874	5281000	17086	8593	73	0	\N
300580	1874	5283000	17086	8593	74	0	\N
300581	1874	5285000	17086	8593	75	0	\N
300582	1874	5287000	17086	8593	76	0	\N
300583	1874	5289000	17086	8593	77	0	\N
300584	1874	5291000	17086	8593	78	0	\N
300585	1874	5293000	17086	8593	79	0	\N
300586	1874	5295000	17086	8593	80	0	\N
300587	1874	5297000	17086	8593	81	0	\N
300588	1874	5299000	17086	8593	82	0	\N
300589	1874	5301000	17086	8593	83	0	\N
300590	1874	5303000	17086	8593	84	0	\N
300591	1874	5305000	17086	8593	85	0	\N
300592	1874	5307000	17086	8593	86	0	\N
300593	1874	5309000	17086	8593	87	0	\N
300594	1874	5312000	17086	8593	88	0	\N
300595	1874	5315000	17086	8593	89	0	\N
300596	1874	5318000	17086	8593	90	0	\N
300597	1874	5321000	17086	8593	91	0	\N
300598	1874	5324000	17086	8593	92	0	\N
300599	1874	5327000	17086	8593	93	0	\N
300600	1874	5330000	17086	8593	94	0	\N
300601	1874	5333000	17086	8593	95	0	\N
300602	1874	5336000	17086	8593	96	0	\N
300603	1874	5339000	17086	8593	97	0	\N
300604	1874	5342000	17086	8593	98	0	\N
300605	1874	5345000	17086	8593	99	0	\N
300606	1874	5348000	17086	8593	100	0	\N
300607	1874	5349000	17086	8593	101	0	\N
300608	1874	5350000	17086	8593	102	0	\N
300609	1874	5351000	17086	8593	103	0	\N
300610	1874	5352000	17086	8593	104	0	\N
300611	1874	5353000	17086	8593	105	0	\N
300612	1874	5354000	17086	8593	106	0	\N
300613	1874	5355000	17086	8593	107	0	\N
300614	1874	5356000	17086	8593	108	0	\N
300615	1874	5357000	17086	8593	109	0	\N
300616	1874	5360000	17086	8593	110	0	\N
300617	1874	5363000	17086	8593	111	0	\N
300618	1874	5366000	17086	8593	112	0	\N
300619	1874	5369000	17086	8593	113	0	\N
300620	1874	5372000	17086	8593	114	0	\N
300621	1874	5375000	17086	8593	115	0	\N
300622	1874	5378000	17086	8593	116	0	\N
300623	1874	5381000	17086	8593	117	0	\N
300624	1874	5384000	17086	8593	118	0	\N
300625	1874	5387000	17086	8593	119	0	\N
300626	1874	5390000	17086	8593	120	0	\N
300627	1874	5393000	17086	8593	121	0	\N
300628	1874	5396000	17086	8593	122	0	\N
300629	1874	5399000	17086	8593	123	0	\N
300630	1874	5402000	17086	8593	124	0	\N
300631	1874	5405000	17086	8593	125	0	\N
300641	1678	18720659909000	17090	8659	0	0	\N
300642	1874	5444000	17090	8659	1	0	\N
300643	1874	5446000	17090	8659	2	0	\N
300651	1678	18720659913000	17095	8663	0	0	\N
300652	1678	18720659914000	17095	8663	1	0	\N
300653	1874	5455000	17095	8663	2	0	\N
300654	1874	5457000	17095	8663	3	0	\N
300655	1874	5458000	17095	8663	4	0	\N
300656	1678	18720659913000	17096	8663	0	0	\N
300657	1678	18720659914000	17096	8663	1	0	\N
300658	1874	5455000	17096	8663	2	0	\N
300659	1874	5457000	17096	8663	3	0	\N
300660	1874	5458000	17096	8663	4	0	\N
300666	1678	18720659907000	17098	8594	0	0	\N
300667	1678	18720659908000	17098	8594	1	0	\N
300668	1678	18720659909000	17098	8594	2	0	\N
300669	1678	18720659910000	17098	8594	3	0	\N
300670	1678	18720659911000	17098	8594	4	0	\N
300671	1678	18720659912000	17098	8594	5	0	\N
300672	1678	18720659913000	17098	8594	6	0	\N
300673	1678	18720659914000	17098	8594	7	0	\N
300674	1874	5407000	17098	8594	8	0	\N
300675	1874	5410000	17098	8594	9	0	\N
300676	1874	5412000	17098	8594	10	0	\N
300677	1874	5415000	17098	8594	11	0	\N
300678	1874	5418000	17098	8594	12	0	\N
300679	1874	5421000	17098	8594	13	0	\N
300680	1874	5424000	17098	8594	14	0	\N
300681	1874	5426000	17098	8594	15	0	\N
300682	1874	5429000	17098	8594	16	0	\N
300683	1874	5432000	17098	8594	17	0	\N
300684	1874	5435000	17098	8594	18	0	\N
300685	1874	5436000	17098	8594	19	0	\N
300686	1874	5437000	17098	8594	20	0	\N
300687	1874	5439000	17098	8594	21	0	\N
300688	1874	5441000	17098	8594	22	0	\N
300689	1874	5443000	17098	8594	23	0	\N
300690	1874	5445000	17098	8594	24	0	\N
300691	1874	5446000	17098	8594	25	0	\N
300692	1874	5449000	17098	8594	26	0	\N
300693	1874	5452000	17098	8594	27	0	\N
300694	1874	5455000	17098	8594	28	0	\N
300695	1874	5458000	17098	8594	29	0	\N
300696	1678	18720659915000	17100	8664	0	0	\N
300634	1874	5436000	17087	8657	2	0	2
300635	1678	18720659908000	17088	8658	0	0	0
300636	1874	5438000	17088	8658	1	0	2
300637	1874	5441000	17088	8658	2	0	2
300638	1678	18720659909000	17089	8659	0	0	0
300640	1874	5446000	17089	8659	2	0	2
300644	1678	18720659910000	17091	8660	0	0	0
300645	1874	5447000	17091	8660	1	0	2
300646	1874	5449000	17091	8660	2	0	2
300647	1678	18720659911000	17093	8661	0	0	0
300649	1678	18720659912000	17094	8662	0	0	0
300650	1874	5453000	17094	8662	1	0	2
300661	1678	18720659913000	17097	8663	0	0	0
300662	1678	18720659914000	17097	8663	1	0	0
300664	1874	5457000	17097	8663	3	0	2
300665	1874	5458000	17097	8663	4	0	2
300697	1874	5460000	17100	8664	1	0	\N
300698	1958	3485987000000	17101	8618	0	0	\N
300699	2160	200000000	17101	8618	1	0	\N
300700	2111	2200000000	17101	8618	2	0	\N
300701	1474	12514422000023	17101	8618	3	0	\N
300706	1678	18720659915000	17103	8665	0	0	\N
300707	1678	18720659916000	17103	8665	1	0	\N
300708	1874	5460000	17103	8665	2	0	\N
300709	1874	5462000	17103	8665	3	0	\N
300710	1678	18720659917000	17104	8666	0	0	\N
300711	1874	5463000	17104	8666	1	0	\N
300712	1874	5465000	17104	8666	2	0	\N
300718	1678	18720659919000	17107	8668	0	0	\N
300719	1874	5469000	17107	8668	1	0	\N
300726	1874	5471000	17110	8669	0	0	\N
300727	1874	5472000	17110	8669	1	0	\N
300728	1950	11169851000000	17110	8669	2	0	\N
300731	1678	18720659922000	17112	8671	0	0	\N
300732	1874	5476000	17112	8671	1	0	\N
300733	1678	18720659922000	17113	8671	0	0	\N
300734	1874	5476000	17113	8671	1	0	\N
300737	1958	3485987000000	17115	8648	0	0	\N
300738	1678	18720659894000	17115	8648	1	0	\N
300739	1678	18720659895000	17115	8648	2	0	\N
300740	1678	18720659896000	17115	8648	3	0	\N
300741	1678	18720659897000	17115	8648	4	0	\N
300742	1678	18720659898000	17115	8648	5	0	\N
300743	1678	18720659899000	17115	8648	6	0	\N
300744	1678	18720659900000	17115	8648	7	0	\N
300745	1678	18720659901000	17115	8648	8	0	\N
300746	1678	18720659902000	17115	8648	9	0	\N
300747	2111	2200000000	17115	8648	10	0	\N
300748	1678	18720659903000	17115	8648	11	0	\N
300749	1678	18720659904000	17115	8648	12	0	\N
300750	1678	18720659905000	17115	8648	13	0	\N
300751	1678	18720659906000	17115	8648	14	0	\N
300752	1678	18720659907000	17115	8648	15	0	\N
300753	1678	18720659908000	17115	8648	16	0	\N
300754	1678	18720659909000	17115	8648	17	0	\N
300755	1678	18720659910000	17115	8648	18	0	\N
300756	1678	18720659911000	17115	8648	19	0	\N
300757	1678	18720659912000	17115	8648	20	0	\N
300758	1678	18720659913000	17115	8648	21	0	\N
300759	1678	18720659914000	17115	8648	22	0	\N
300760	1678	18720659915000	17115	8648	23	0	\N
300761	1678	18720659916000	17115	8648	24	0	\N
300762	1678	18720659917000	17115	8648	25	0	\N
300763	1678	18720659918000	17115	8648	26	0	\N
300764	1678	18720659919000	17115	8648	27	0	\N
300765	1678	18720659920000	17115	8648	28	0	\N
300766	1678	18720659921000	17115	8648	29	0	\N
300767	1678	18720659922000	17115	8648	30	0	\N
300768	1474	12514422000023	17115	8648	31	0	\N
300769	1874	5369000	17115	8648	32	0	\N
300770	1874	5372000	17115	8648	33	0	\N
300771	1874	5375000	17115	8648	34	0	\N
300772	1874	5378000	17115	8648	35	0	\N
300773	1874	5381000	17115	8648	36	0	\N
300774	1950	11169851000000	17115	8648	37	0	\N
300775	1874	5383000	17115	8648	38	0	\N
300776	1874	5385000	17115	8648	39	0	\N
300777	1874	5387000	17115	8648	40	0	\N
300778	1874	5389000	17115	8648	41	0	\N
300779	1874	5391000	17115	8648	42	0	\N
300780	1874	5393000	17115	8648	43	0	\N
300781	1874	5395000	17115	8648	44	0	\N
300782	1874	5397000	17115	8648	45	0	\N
300783	1874	5399000	17115	8648	46	0	\N
300784	1874	5401000	17115	8648	47	0	\N
300785	1874	5403000	17115	8648	48	0	\N
300786	1874	5405000	17115	8648	49	0	\N
300787	1874	5407000	17115	8648	50	0	\N
300788	1874	5409000	17115	8648	51	0	\N
300789	1874	5412000	17115	8648	52	0	\N
300790	1874	5415000	17115	8648	53	0	\N
300791	1874	5418000	17115	8648	54	0	\N
300792	1874	5421000	17115	8648	55	0	\N
300793	1874	5422000	17115	8648	56	0	\N
300794	1874	5423000	17115	8648	57	0	\N
300795	1874	5424000	17115	8648	58	0	\N
300796	1874	5426000	17115	8648	59	0	\N
300797	1874	5429000	17115	8648	60	0	\N
300798	1874	5432000	17115	8648	61	0	\N
300799	1874	5435000	17115	8648	62	0	\N
300800	1874	5436000	17115	8648	63	0	\N
300801	1874	5437000	17115	8648	64	0	\N
300802	1874	5439000	17115	8648	65	0	\N
300803	1874	5441000	17115	8648	66	0	\N
300804	1874	5443000	17115	8648	67	0	\N
300805	1874	5445000	17115	8648	68	0	\N
300806	1874	5447000	17115	8648	69	0	\N
300807	1874	5449000	17115	8648	70	0	\N
300808	1874	5450000	17115	8648	71	0	\N
300809	1874	5451000	17115	8648	72	0	\N
300810	1874	5452000	17115	8648	73	0	\N
300811	1874	5454000	17115	8648	74	0	\N
300812	1874	5456000	17115	8648	75	0	\N
300813	1874	5458000	17115	8648	76	0	\N
300814	1874	5460000	17115	8648	77	0	\N
300815	1874	5462000	17115	8648	78	0	\N
300816	1874	5464000	17115	8648	79	0	\N
300817	1874	5467000	17115	8648	80	0	\N
300818	1874	5470000	17115	8648	81	0	\N
300819	1874	5473000	17115	8648	82	0	\N
300820	1874	5476000	17115	8648	83	0	\N
300824	1678	18720659924000	17118	8673	0	0	\N
300825	1874	5481000	17118	8673	1	0	\N
300704	1874	5460000	17102	8665	2	0	2
300705	1874	5462000	17102	8665	3	0	2
300713	1678	18720659917000	17105	8666	0	0	0
300714	1874	5463000	17105	8666	1	0	2
300715	1874	5465000	17105	8666	2	0	2
300717	1874	5467000	17106	8667	1	0	2
300720	1678	18720659919000	17108	8668	0	0	0
300721	1874	5469000	17108	8668	1	0	2
300722	1678	18720659920000	17109	8669	0	0	0
300723	1874	5471000	17109	8669	1	0	2
300725	1950	11169851000000	17109	8669	3	0	14
300729	1678	18720659921000	17111	8670	0	0	0
300730	1874	5474000	17111	8670	1	0	2
300735	1678	18720659922000	17114	8671	0	0	0
300821	1678	18720659923000	17117	8672	0	0	0
300822	1874	5478000	17117	8672	1	0	2
300823	1874	5479000	17117	8672	2	0	2
300826	1678	18720659924000	17119	8673	0	0	0
300827	1874	5481000	17119	8673	1	0	2
300829	1874	5483000	17120	8674	1	0	2
300830	1678	18720659926000	17121	8675	0	0	0
300831	1874	5485000	17121	8675	1	0	2
300832	1874	5486000	17121	8675	2	0	2
300833	1678	18720659927000	17122	8676	0	0	\N
300834	1874	5488000	17122	8676	1	0	\N
300839	1678	18720659928000	17125	8677	0	0	\N
300840	1874	5490000	17125	8677	1	0	\N
300844	1678	18720659915000	17127	8595	0	0	\N
300845	1678	18720659916000	17127	8595	1	0	\N
300846	1678	18720659917000	17127	8595	2	0	\N
300847	1678	18720659918000	17127	8595	3	0	\N
300848	1678	18720659919000	17127	8595	4	0	\N
300849	1678	18720659920000	17127	8595	5	0	\N
300850	1678	18720659921000	17127	8595	6	0	\N
300851	1678	18720659922000	17127	8595	8	0	\N
300852	1678	18720659923000	17127	8595	9	0	\N
300853	1678	18720659924000	17127	8595	10	0	\N
300854	1678	18720659925000	17127	8595	11	0	\N
300855	1678	18720659926000	17127	8595	12	0	\N
300856	1678	18720659927000	17127	8595	13	0	\N
300857	1678	18720659928000	17127	8595	14	0	\N
300858	1678	18720659929000	17127	8595	15	0	\N
300859	1874	5460000	17127	8595	16	0	\N
300860	1874	5462000	17127	8595	17	0	\N
300861	1950	11169851000000	17127	8595	18	0	\N
300862	1874	5463000	17127	8595	19	0	\N
300863	1874	5464000	17127	8595	20	0	\N
300864	1874	5465000	17127	8595	21	0	\N
300865	1874	5466000	17127	8595	22	0	\N
300866	1874	5467000	17127	8595	23	0	\N
300867	1874	5469000	17127	8595	24	0	\N
300868	1874	5471000	17127	8595	25	0	\N
300869	1874	5473000	17127	8595	26	0	\N
300870	1874	5475000	17127	8595	27	0	\N
300871	1874	5477000	17127	8595	28	0	\N
300872	1874	5479000	17127	8595	29	0	\N
300873	1874	5481000	17127	8595	30	0	\N
300874	1874	5483000	17127	8595	31	0	\N
300875	1874	5485000	17127	8595	32	0	\N
300876	1874	5487000	17127	8595	33	0	\N
300877	1874	5489000	17127	8595	34	0	\N
300878	1874	5491000	17127	8595	35	0	\N
300883	1678	18720659932000	17130	8681	0	0	\N
300884	1874	5496000	17130	8681	1	0	\N
300885	1874	5498000	17130	8681	2	0	\N
300889	1678	18720659932000	17132	8681	0	0	\N
300890	1874	5496000	17132	8681	1	0	\N
300891	1874	5498000	17132	8681	2	0	\N
300892	1678	18720659933000	17133	8682	0	0	\N
300893	1678	18720659934000	17133	8682	1	0	\N
300894	1874	5500000	17133	8682	2	0	\N
300895	1874	5502000	17133	8682	3	0	\N
300902	1678	18720659935000	17136	8683	0	0	\N
300903	1874	5504000	17136	8683	1	0	\N
300908	1678	18720659937000	17139	8685	0	0	\N
300909	1874	5507000	17139	8685	1	0	\N
300926	1678	18720659943000	17143	8689	0	0	\N
300927	1874	5532000	17143	8689	1	0	\N
300928	1874	5535000	17143	8689	2	0	\N
300952	1678	18720659949000	17150	8694	0	0	\N
300953	1874	5562000	17150	8694	1	0	\N
300954	1874	5564000	17150	8694	2	0	\N
300955	1874	5565000	17150	8694	3	0	\N
300956	1958	3485987000000	17151	8601	0	0	\N
300957	2159	200000000	17151	8601	1	0	\N
300958	1678	18720659837000	17151	8601	2	0	\N
300959	1678	18720659838000	17151	8601	3	0	\N
300960	2160	200000000	17151	8601	4	0	\N
300961	2111	2200000000	17151	8601	5	0	\N
300962	693	66000010000000	17151	8601	6	0	\N
300963	2161	200000000	17151	8601	7	0	\N
300964	2162	200000000	17151	8601	8	0	\N
300965	1678	18720659839000	17151	8601	9	0	\N
300966	1678	18720659840000	17151	8601	10	0	\N
300967	1678	18720659841000	17151	8601	11	0	\N
300968	1678	18720659842000	17151	8601	12	0	\N
300837	1678	18720659928000	17124	8677	0	0	0
300838	1874	5490000	17124	8677	1	0	2
300841	1678	18720659929000	17126	8678	0	0	0
300842	1874	5492000	17126	8678	1	0	2
300843	1874	5493000	17126	8678	2	0	2
300880	693	66000010000000	17129	8680	0	0	0
300881	1678	18720659931000	17129	8680	1	0	0
300882	1874	5495000	17129	8680	2	0	2
300886	1678	18720659932000	17131	8681	0	0	0
300887	1874	5496000	17131	8681	1	0	2
300896	1678	18720659933000	17134	8682	0	0	0
300897	1678	18720659934000	17134	8682	1	0	0
300898	1874	5500000	17134	8682	2	0	2
300899	1874	5502000	17134	8682	3	0	2
300901	1874	5504000	17135	8683	1	0	2
300904	1678	18720659936000	17137	8684	0	0	0
300905	1874	5505000	17137	8684	1	0	2
300906	1678	18720659937000	17138	8685	0	0	0
300907	1874	5507000	17138	8685	1	0	2
300911	1678	18720659938000	17140	8686	1	0	0
300912	1874	5509000	17140	8686	2	0	2
300913	1678	18720659939000	17141	8687	0	0	0
300914	1874	5510000	17141	8687	1	0	2
300915	1874	5512000	17141	8687	2	0	2
300917	1678	18720659940000	17142	8688	0	0	0
300918	1678	18720659941000	17142	8688	1	0	0
300919	1678	18720659942000	17142	8688	2	0	0
300920	1874	5517000	17142	8688	3	0	2
300922	1874	5522000	17142	8688	5	0	2
300923	1874	5524000	17142	8688	6	0	2
300924	1874	5527000	17142	8688	7	0	2
300925	1874	5530000	17142	8688	8	0	2
300929	1678	18720659943000	17144	8689	0	0	0
300931	1874	5535000	17144	8689	2	0	2
300932	1678	18720659944000	17145	8690	0	0	0
300933	1874	5538000	17145	8690	1	0	2
300934	1874	5540000	17145	8690	2	0	2
300935	1678	18720659945000	17147	8692	0	0	0
300937	2162	200000000	17147	8692	2	0	0
300938	1874	5541000	17147	8692	3	0	2
300939	1874	5543000	17147	8692	4	0	2
300940	1874	5545000	17147	8692	5	0	2
300942	1874	5551000	17147	8692	7	0	2
300943	1678	18720659947000	17148	8693	0	0	0
300944	1678	18720659948000	17148	8693	1	0	0
300945	1874	5554000	17148	8693	2	0	2
300946	1874	5557000	17148	8693	3	0	2
300948	1678	18720659949000	17149	8694	0	0	0
300949	1874	5562000	17149	8694	1	0	2
300950	1874	5564000	17149	8694	2	0	2
300951	1874	5565000	17149	8694	3	0	2
300969	1678	18720659843000	17151	8601	13	0	\N
300970	1678	18720659844000	17151	8601	14	0	\N
300971	1678	18720659845000	17151	8601	15	0	\N
300972	1678	18720659846000	17151	8601	16	0	\N
300973	1678	18720659847000	17151	8601	17	0	\N
300974	1678	18720659848000	17151	8601	18	0	\N
300975	1678	18720659849000	17151	8601	19	0	\N
300976	1678	18720659850000	17151	8601	20	0	\N
300977	1678	18720659851000	17151	8601	21	0	\N
300978	1678	18720659852000	17151	8601	22	0	\N
300979	1678	18720659853000	17151	8601	23	0	\N
300980	1678	18720659854000	17151	8601	24	0	\N
300981	1678	18720659855000	17151	8601	25	0	\N
300982	1678	18720659856000	17151	8601	26	0	\N
300983	1678	18720659857000	17151	8601	27	0	\N
300984	1678	18720659858000	17151	8601	28	0	\N
300985	1678	18720659859000	17151	8601	29	0	\N
300986	1678	18720659860000	17151	8601	30	0	\N
300987	1678	18720659861000	17151	8601	31	0	\N
300988	1678	18720659862000	17151	8601	32	0	\N
300989	1678	18720659863000	17151	8601	33	0	\N
300990	1678	18720659864000	17151	8601	34	0	\N
300991	1678	18720659865000	17151	8601	35	0	\N
300992	1678	18720659866000	17151	8601	36	0	\N
300993	1678	18720659867000	17151	8601	37	0	\N
300994	1678	18720659868000	17151	8601	38	0	\N
300995	1678	18720659869000	17151	8601	39	0	\N
300996	1678	18720659870000	17151	8601	40	0	\N
300997	1678	18720659871000	17151	8601	41	0	\N
300998	1678	18720659872000	17151	8601	42	0	\N
300999	1678	18720659873000	17151	8601	43	0	\N
301000	1678	18720659874000	17151	8601	44	0	\N
301001	1678	18720659875000	17151	8601	45	0	\N
301002	1678	18720659876000	17151	8601	46	0	\N
301003	1678	18720659877000	17151	8601	47	0	\N
301004	1678	18720659878000	17151	8601	48	0	\N
301005	1678	18720659879000	17151	8601	49	0	\N
301006	1678	18720659880000	17151	8601	50	0	\N
301007	1678	18720659881000	17151	8601	51	0	\N
301008	1678	18720659882000	17151	8601	52	0	\N
301009	1678	18720659883000	17151	8601	53	0	\N
301010	1678	18720659884000	17151	8601	54	0	\N
301011	1678	18720659885000	17151	8601	55	0	\N
301012	1678	18720659886000	17151	8601	56	0	\N
301013	1678	18720659887000	17151	8601	57	0	\N
301014	1678	18720659888000	17151	8601	58	0	\N
301015	1678	18720659889000	17151	8601	59	0	\N
301016	1678	18720659890000	17151	8601	60	0	\N
301017	1678	18720659891000	17151	8601	61	0	\N
301018	1678	18720659892000	17151	8601	62	0	\N
301019	1678	18720659893000	17151	8601	63	0	\N
301020	1678	18720659894000	17151	8601	64	0	\N
301021	1678	18720659895000	17151	8601	65	0	\N
301022	1678	18720659896000	17151	8601	66	0	\N
301023	1678	18720659897000	17151	8601	67	0	\N
301024	1678	18720659898000	17151	8601	68	0	\N
301025	1678	18720659899000	17151	8601	69	0	\N
301026	1678	18720659900000	17151	8601	70	0	\N
301027	1678	18720659901000	17151	8601	71	0	\N
301028	1678	18720659902000	17151	8601	72	0	\N
301029	1678	18720659903000	17151	8601	73	0	\N
301030	1678	18720659904000	17151	8601	74	0	\N
301031	1678	18720659905000	17151	8601	75	0	\N
301032	1678	18720659906000	17151	8601	76	0	\N
301033	1678	18720659907000	17151	8601	77	0	\N
301034	1678	18720659908000	17151	8601	78	0	\N
301035	1678	18720659909000	17151	8601	79	0	\N
301036	1678	18720659910000	17151	8601	80	0	\N
301037	1678	18720659911000	17151	8601	81	0	\N
301038	1678	18720659912000	17151	8601	82	0	\N
301039	1678	18720659913000	17151	8601	83	0	\N
301040	1678	18720659914000	17151	8601	84	0	\N
301041	1678	18720659915000	17151	8601	85	0	\N
301042	1678	18720659916000	17151	8601	86	0	\N
301043	1678	18720659917000	17151	8601	87	0	\N
301044	1678	18720659918000	17151	8601	88	0	\N
301045	1678	18720659919000	17151	8601	89	0	\N
301046	1678	18720659920000	17151	8601	90	0	\N
301047	1678	18720659921000	17151	8601	91	0	\N
301048	1678	18720659922000	17151	8601	92	0	\N
301049	1678	18720659923000	17151	8601	93	0	\N
301050	1678	18720659924000	17151	8601	94	0	\N
301051	1678	18720659925000	17151	8601	95	0	\N
301052	1678	18720659926000	17151	8601	96	0	\N
301053	1678	18720659927000	17151	8601	97	0	\N
301054	1678	18720659928000	17151	8601	98	0	\N
301055	1678	18720659929000	17151	8601	99	0	\N
301056	1678	18720659930000	17151	8601	100	0	\N
301057	1678	18720659931000	17151	8601	102	0	\N
301058	1678	18720659932000	17151	8601	103	0	\N
301059	1678	18720659933000	17151	8601	104	0	\N
301060	1678	18720659934000	17151	8601	105	0	\N
301061	1678	18720659935000	17151	8601	106	0	\N
301062	1678	18720659936000	17151	8601	107	0	\N
301063	1678	18720659937000	17151	8601	108	0	\N
301064	1678	18720659938000	17151	8601	109	0	\N
301065	1678	18720659939000	17151	8601	110	0	\N
301066	1678	18720659940000	17151	8601	111	0	\N
301067	1678	18720659941000	17151	8601	112	0	\N
301068	1678	18720659942000	17151	8601	113	0	\N
301069	1678	18720659943000	17151	8601	114	0	\N
301070	1678	18720659944000	17151	8601	115	0	\N
301071	1678	18720659945000	17151	8601	116	0	\N
301072	1678	18720659946000	17151	8601	117	0	\N
301073	1678	18720659947000	17151	8601	118	0	\N
301074	1678	18720659948000	17151	8601	119	0	\N
301075	1678	18720659949000	17151	8601	120	0	\N
301076	1474	12514422000023	17151	8601	121	0	\N
301077	1950	11169851000000	17151	8601	122	0	\N
301078	1874	5133000	17151	8601	123	0	\N
301079	1874	5134000	17151	8601	124	0	\N
301080	1874	5135000	17151	8601	125	0	\N
301084	1678	18720659951000	17153	8696	0	0	\N
301085	1678	18720659952000	17153	8696	1	0	\N
301086	188	66001000000000	17153	8696	2	0	\N
301087	1874	5571000	17153	8696	3	0	\N
301088	1874	5574000	17153	8696	4	0	\N
301089	1874	5576000	17153	8696	5	0	\N
301090	1874	5578000	17153	8696	6	0	\N
301091	1874	5580000	17153	8696	7	0	\N
301092	1874	5583000	17153	8696	8	0	\N
301093	1874	5586000	17153	8696	9	0	\N
301104	1678	18720659951000	17155	8696	0	0	\N
301083	1874	5570000	17152	8695	2	0	2
301094	1678	18720659951000	17154	8696	0	0	0
301095	1678	18720659952000	17154	8696	1	0	0
301096	188	66001000000000	17154	8696	2	0	0
301097	1874	5571000	17154	8696	3	0	2
301099	1874	5576000	17154	8696	5	0	2
301100	1874	5578000	17154	8696	6	0	2
301101	1874	5580000	17154	8696	7	0	2
301102	1874	5583000	17154	8696	8	0	2
301103	1874	5586000	17154	8696	9	0	2
301105	1678	18720659952000	17155	8696	1	0	\N
301106	188	66001000000000	17155	8696	2	0	\N
301107	1874	5571000	17155	8696	3	0	\N
301108	1874	5574000	17155	8696	4	0	\N
301109	1874	5576000	17155	8696	5	0	\N
301110	1874	5578000	17155	8696	6	0	\N
301111	1874	5580000	17155	8696	7	0	\N
301112	1874	5583000	17155	8696	8	0	\N
301113	1874	5586000	17155	8696	9	0	\N
301114	1678	18720659951000	17156	8696	0	0	\N
301115	1678	18720659952000	17156	8696	1	0	\N
301116	188	66001000000000	17156	8696	2	0	\N
301117	1874	5571000	17156	8696	3	0	\N
301118	1874	5574000	17156	8696	4	0	\N
301119	1874	5576000	17156	8696	5	0	\N
301120	1874	5578000	17156	8696	6	0	\N
301121	1874	5580000	17156	8696	7	0	\N
301122	1874	5583000	17156	8696	8	0	\N
301123	1874	5586000	17156	8696	9	0	\N
301124	1958	3485987000000	17157	8627	0	0	\N
301125	2160	200000000	17157	8627	1	0	\N
301126	2111	2200000000	17157	8627	2	0	\N
301127	693	66000010000000	17157	8627	3	0	\N
301128	2161	200000000	17157	8627	4	0	\N
301129	2162	200000000	17157	8627	5	0	\N
301130	188	66001000000000	17157	8627	6	0	\N
301131	1474	12513412000023	17157	8627	7	0	\N
301132	1950	11169851000000	17157	8627	8	0	\N
301140	1474	12513412000023	17159	8697	0	0	\N
301141	1678	18720659953000	17159	8697	1	0	\N
301142	1678	18720659954000	17159	8697	2	0	\N
301143	1874	5588000	17159	8697	3	0	\N
301144	1874	5591000	17159	8697	4	0	\N
301145	1874	5594000	17159	8697	5	0	\N
301146	1874	5596000	17159	8697	6	0	\N
301147	1474	12513412000023	17160	8697	0	0	\N
301148	1678	18720659953000	17160	8697	1	0	\N
301149	1678	18720659954000	17160	8697	2	0	\N
301150	1874	5588000	17160	8697	3	0	\N
301151	1874	5591000	17160	8697	4	0	\N
301152	1874	5594000	17160	8697	5	0	\N
301153	1874	5596000	17160	8697	6	0	\N
301154	1474	12513412000023	17161	8697	0	0	\N
301155	1678	18720659953000	17161	8697	1	0	\N
301156	1678	18720659954000	17161	8697	2	0	\N
301157	1874	5588000	17161	8697	3	0	\N
301158	1874	5591000	17161	8697	4	0	\N
301159	1874	5594000	17161	8697	5	0	\N
301160	1874	5596000	17161	8697	6	0	\N
301181	1958	3485987000000	17166	8644	0	0	\N
301182	2111	2200000000	17166	8644	1	0	\N
301183	693	66000010000000	17166	8644	2	0	\N
301184	2161	200000000	17166	8644	3	0	\N
301185	2162	200000000	17166	8644	4	0	\N
301186	188	66001000000000	17166	8644	5	0	\N
301187	1678	18720659887000	17166	8644	6	0	\N
301188	1678	18720659888000	17166	8644	7	0	\N
301189	1678	18720659889000	17166	8644	8	0	\N
301190	1678	18720659890000	17166	8644	9	0	\N
301191	1678	18720659891000	17166	8644	10	0	\N
301192	1678	18720659892000	17166	8644	11	0	\N
301193	1678	18720659893000	17166	8644	12	0	\N
301194	1678	18720659894000	17166	8644	13	0	\N
301195	1678	18720659895000	17166	8644	14	0	\N
301196	1678	18720659896000	17166	8644	15	0	\N
301197	1678	18720659897000	17166	8644	16	0	\N
301198	1678	18720659898000	17166	8644	17	0	\N
301199	1678	18720659899000	17166	8644	18	0	\N
301200	1678	18720659900000	17166	8644	19	0	\N
301201	1678	18720659901000	17166	8644	20	0	\N
301202	1678	18720659902000	17166	8644	21	0	\N
301203	1678	18720659903000	17166	8644	22	0	\N
301204	1678	18720659904000	17166	8644	23	0	\N
301205	1678	18720659905000	17166	8644	24	0	\N
301206	1678	18720659906000	17166	8644	25	0	\N
301207	1678	18720659907000	17166	8644	26	0	\N
301208	1678	18720659908000	17166	8644	27	0	\N
301209	1678	18720659909000	17166	8644	28	0	\N
301210	1678	18720659910000	17166	8644	29	0	\N
301211	1678	18720659911000	17166	8644	30	0	\N
301212	1678	18720659912000	17166	8644	31	0	\N
301213	1678	18720659913000	17166	8644	32	0	\N
301214	1678	18720659914000	17166	8644	33	0	\N
301215	1678	18720659915000	17166	8644	34	0	\N
301216	1678	18720659916000	17166	8644	35	0	\N
301217	1678	18720659917000	17166	8644	36	0	\N
301218	1678	18720659918000	17166	8644	37	0	\N
301219	1678	18720659919000	17166	8644	38	0	\N
301220	1678	18720659920000	17166	8644	39	0	\N
301221	1678	18720659921000	17166	8644	40	0	\N
301222	1678	18720659922000	17166	8644	41	0	\N
301223	1678	18720659923000	17166	8644	42	0	\N
301224	1678	18720659924000	17166	8644	43	0	\N
301225	1678	18720659925000	17166	8644	44	0	\N
301226	1678	18720659926000	17166	8644	45	0	\N
301227	1678	18720659927000	17166	8644	46	0	\N
301228	1678	18720659928000	17166	8644	47	0	\N
301229	1678	18720659929000	17166	8644	48	0	\N
301230	1678	18720659930000	17166	8644	49	0	\N
301231	1678	18720659931000	17166	8644	50	0	\N
301232	1678	18720659932000	17166	8644	51	0	\N
301233	1678	18720659933000	17166	8644	52	0	\N
301234	1678	18720659934000	17166	8644	53	0	\N
301235	1678	18720659935000	17166	8644	54	0	\N
301236	1678	18720659936000	17166	8644	55	0	\N
301237	1678	18720659937000	17166	8644	56	0	\N
301238	1678	18720659938000	17166	8644	57	0	\N
301239	1678	18720659939000	17166	8644	58	0	\N
301240	1678	18720659940000	17166	8644	59	0	\N
301135	1678	18720659954000	17158	8697	2	0	0
301136	1874	5588000	17158	8697	3	0	2
301137	1874	5591000	17158	8697	4	0	2
301138	1874	5594000	17158	8697	5	0	2
301139	1874	5596000	17158	8697	6	0	2
301162	1874	5599000	17162	8698	1	0	2
301163	1874	5601000	17162	8698	2	0	2
301164	1874	5602000	17162	8698	3	0	2
301165	1678	18720659956000	17163	8699	0	0	0
301166	1678	18720659957000	17163	8699	1	0	0
301168	1874	5605000	17163	8699	3	0	2
301169	1874	5608000	17163	8699	4	0	2
301170	1874	5611000	17163	8699	5	0	2
301171	1874	5612000	17163	8699	6	0	2
301173	1874	5616000	17163	8699	8	0	2
301174	1874	5618000	17163	8699	9	0	2
301175	1678	18720659959000	17164	8700	0	0	0
301176	1874	5620000	17164	8700	1	0	2
301177	1874	5623000	17164	8700	2	0	2
301179	1874	5625000	17165	8701	1	0	2
301180	1874	5628000	17165	8701	2	0	2
301241	1678	18720659941000	17166	8644	60	0	\N
301242	1678	18720659942000	17166	8644	61	0	\N
301243	1678	18720659943000	17166	8644	62	0	\N
301244	1678	18720659944000	17166	8644	63	0	\N
301245	1678	18720659945000	17166	8644	64	0	\N
301246	1678	18720659946000	17166	8644	65	0	\N
301247	1678	18720659947000	17166	8644	66	0	\N
301248	1678	18720659948000	17166	8644	67	0	\N
301249	1678	18720659949000	17166	8644	68	0	\N
301250	1678	18720659950000	17166	8644	69	0	\N
301251	1678	18720659951000	17166	8644	70	0	\N
301252	1678	18720659952000	17166	8644	71	0	\N
301253	1678	18720659953000	17166	8644	72	0	\N
301254	1678	18720659954000	17166	8644	73	0	\N
301255	1678	18720659955000	17166	8644	74	0	\N
301256	1678	18720659956000	17166	8644	75	0	\N
301257	1678	18720659957000	17166	8644	76	0	\N
301258	1678	18720659958000	17166	8644	77	0	\N
301259	1678	18720659959000	17166	8644	78	0	\N
301260	1678	18720659960000	17166	8644	79	0	\N
301261	1678	18720659961000	17166	8644	80	0	\N
301262	1678	18720659962000	17166	8644	81	0	\N
301263	1474	12513412000023	17166	8644	82	0	\N
301264	1874	5330000	17166	8644	83	0	\N
301265	1874	5332000	17166	8644	84	0	\N
301266	1950	11169851000000	17166	8644	85	0	\N
301267	1874	5334000	17166	8644	86	0	\N
301268	1874	5336000	17166	8644	87	0	\N
301269	1874	5338000	17166	8644	88	0	\N
301270	1874	5340000	17166	8644	89	0	\N
301271	1874	5342000	17166	8644	90	0	\N
301272	1874	5344000	17166	8644	91	0	\N
301273	1874	5346000	17166	8644	92	0	\N
301274	1874	5348000	17166	8644	93	0	\N
301275	1874	5350000	17166	8644	94	0	\N
301276	1874	5352000	17166	8644	95	0	\N
301277	1874	5354000	17166	8644	96	0	\N
301278	1874	5356000	17166	8644	97	0	\N
301279	1874	5358000	17166	8644	98	0	\N
301280	1874	5360000	17166	8644	99	0	\N
301281	1874	5362000	17166	8644	100	0	\N
301282	1874	5364000	17166	8644	101	0	\N
301283	1874	5366000	17166	8644	102	0	\N
301284	1874	5368000	17166	8644	103	0	\N
301285	1874	5370000	17166	8644	104	0	\N
301286	1874	5372000	17166	8644	105	0	\N
301287	1874	5375000	17166	8644	106	0	\N
301288	1874	5378000	17166	8644	107	0	\N
301289	1874	5381000	17166	8644	108	0	\N
301290	1874	5384000	17166	8644	109	0	\N
301291	1874	5387000	17166	8644	110	0	\N
301292	1874	5390000	17166	8644	111	0	\N
301293	1874	5393000	17166	8644	112	0	\N
301294	1874	5396000	17166	8644	113	0	\N
301295	1874	5399000	17166	8644	114	0	\N
301296	1874	5402000	17166	8644	115	0	\N
301297	1874	5405000	17166	8644	116	0	\N
301298	1874	5408000	17166	8644	117	0	\N
301299	1874	5411000	17166	8644	118	0	\N
301300	1874	5414000	17166	8644	119	0	\N
301301	1874	5417000	17166	8644	120	0	\N
301302	1874	5420000	17166	8644	121	0	\N
301303	1874	5422000	17166	8644	122	0	\N
301304	1874	5425000	17166	8644	123	0	\N
301305	1874	5428000	17166	8644	124	0	\N
301306	1874	5431000	17166	8644	125	0	\N
301317	1678	18720659961000	17168	8702	0	0	\N
301318	1678	18720659962000	17168	8702	1	0	\N
301319	1678	18720659963000	17168	8702	2	0	\N
301320	1874	5631000	17168	8702	3	0	\N
301321	1874	5632000	17168	8702	4	0	\N
301322	1874	5635000	17168	8702	5	0	\N
301323	1874	5638000	17168	8702	6	0	\N
301324	1874	5640000	17168	8702	7	0	\N
301325	1874	5642000	17168	8702	8	0	\N
301326	1874	5644000	17168	8702	9	0	\N
301327	1958	3485987000000	17169	8586	0	0	\N
301328	2158	200000000	17169	8586	1	0	\N
301329	2159	200000000	17169	8586	2	0	\N
301330	2160	200000000	17169	8586	3	0	\N
301331	2111	2200000000	17169	8586	4	0	\N
301332	693	66000010000000	17169	8586	5	0	\N
301333	2161	200000000	17169	8586	6	0	\N
301334	2162	200000000	17169	8586	7	0	\N
301335	188	66001000000000	17169	8586	8	0	\N
301336	1474	12513412000023	17169	8586	9	0	\N
301337	1950	11169851000000	17169	8586	10	0	\N
301345	1678	18720659966000	17171	8704	0	0	\N
301346	1874	5657000	17171	8704	1	0	\N
301347	1874	5660000	17171	8704	2	0	\N
301354	1678	19440671968000	17174	8706	0	0	\N
301355	1874	5668000	17174	8706	1	0	\N
301356	1874	5669000	17174	8706	2	0	\N
301357	1874	5671000	17174	8706	3	0	\N
301362	1678	19440671968000	17176	8706	0	0	\N
301363	1874	5668000	17176	8706	1	0	\N
301364	1874	5669000	17176	8706	2	0	\N
301365	1874	5671000	17176	8706	3	0	\N
301366	1678	19440671968000	17177	8706	0	0	\N
301367	1874	5668000	17177	8706	1	0	\N
301368	1874	5669000	17177	8706	2	0	\N
301369	1874	5671000	17177	8706	3	0	\N
301370	1678	19440671969000	17178	8707	0	0	\N
301371	1874	5673000	17178	8707	1	0	\N
301372	1874	5676000	17178	8707	2	0	\N
301309	1678	18720659963000	17167	8702	2	0	0
301310	1874	5631000	17167	8702	3	0	2
301311	1874	5632000	17167	8702	4	0	2
301312	1874	5635000	17167	8702	5	0	2
301313	1874	5638000	17167	8702	6	0	2
301315	1874	5642000	17167	8702	8	0	2
301316	1874	5644000	17167	8702	9	0	2
301338	1678	18720659964000	17170	8703	0	0	0
301339	1678	18720659965000	17170	8703	1	0	0
301340	1874	5645000	17170	8703	2	0	2
301342	1874	5650000	17170	8703	4	0	2
301343	1874	5653000	17170	8703	5	0	2
301344	1874	5655000	17170	8703	6	0	2
301348	1678	18720659966000	17172	8704	0	0	0
301350	1874	5660000	17172	8704	2	0	2
301351	1678	19440671967000	17173	8705	0	0	0
301352	1874	5663000	17173	8705	1	0	2
301353	1874	5665000	17173	8705	2	0	2
301358	1678	19440671968000	17175	8706	0	0	0
301360	1874	5669000	17175	8706	2	0	2
301361	1874	5671000	17175	8706	3	0	2
301373	1678	19440671969000	17179	8707	0	0	0
301374	1874	5673000	17179	8707	1	0	2
301375	1874	5676000	17179	8707	2	0	2
301382	1678	19440671970000	17181	8708	0	0	\N
301383	1460	0	17181	8708	1	0	\N
301384	1874	5677000	17181	8708	2	0	\N
301385	1874	5679000	17181	8708	3	0	\N
301386	1874	5682000	17181	8708	4	0	\N
301387	1874	5685000	17181	8708	5	0	\N
301388	1678	19440671970000	17182	8708	0	0	\N
301389	1460	0	17182	8708	1	0	\N
301390	1874	5677000	17182	8708	2	0	\N
301391	1874	5679000	17182	8708	3	0	\N
301392	1874	5682000	17182	8708	4	0	\N
301393	1874	5685000	17182	8708	5	0	\N
301394	1460	0	17183	8685	0	0	\N
301395	1460	0	17184	8696	0	0	\N
301396	1460	0	17185	8706	0	0	\N
301406	1678	19440671971000	17189	8710	0	0	\N
301407	1678	19440671972000	17189	8710	1	0	\N
301408	1678	19440671973000	17189	8710	2	0	\N
301409	1874	5688000	17189	8710	3	0	\N
301410	1874	5691000	17189	8710	4	0	\N
301411	1874	5694000	17189	8710	5	0	\N
301412	1874	5696000	17189	8710	6	0	\N
301413	1874	5698000	17189	8710	7	0	\N
301414	1874	5700000	17189	8710	8	0	\N
301425	1460	0	17193	8628	0	0	\N
301426	1678	19440671977000	17194	8714	0	0	\N
301427	1874	5719000	17194	8714	1	0	\N
301428	1874	5720000	17194	8714	2	0	\N
301429	1874	5722000	17194	8714	3	0	\N
301434	1678	19440671977000	17196	8714	0	0	\N
301435	1874	5717000	17196	8714	1	0	\N
301436	1874	5719000	17196	8714	2	0	\N
301437	1678	19440671977000	17197	8714	0	0	\N
301438	1874	5719000	17197	8714	1	0	\N
301439	1874	5720000	17197	8714	2	0	\N
301440	1874	5722000	17197	8714	3	0	\N
301453	1678	19440671981000	17201	8717	0	0	\N
301454	1874	5739000	17201	8717	1	0	\N
301455	1874	5741000	17201	8717	2	0	\N
301456	1678	19440671981000	17202	8717	0	0	\N
301457	1874	5739000	17202	8717	1	0	\N
301458	1874	5741000	17202	8717	2	0	\N
301462	1678	19440671982000	17204	8718	0	0	\N
301463	1874	5744000	17204	8718	1	0	\N
301464	1874	5746000	17204	8718	2	0	\N
301465	1958	3485987000000	17205	8524	0	0	\N
301466	2159	200000000	17205	8524	1	0	\N
301467	2160	200000000	17205	8524	2	0	\N
301468	2111	2200000000	17205	8524	3	0	\N
301469	693	66000010000000	17205	8524	4	0	\N
301470	2161	200000000	17205	8524	5	0	\N
301471	2162	200000000	17205	8524	6	0	\N
301472	188	66001000000000	17205	8524	7	0	\N
301473	1474	12513412000023	17205	8524	8	0	\N
301474	1460	0	17205	8524	9	0	\N
301475	1950	11169851000000	17205	8524	10	0	\N
301476	1678	19440671982000	17206	8718	0	0	\N
301477	1874	5744000	17206	8718	1	0	\N
301478	1874	5746000	17206	8718	2	0	\N
301479	1678	19440671983000	17207	8719	0	0	\N
301480	1874	5749000	17207	8719	1	0	\N
301481	1678	19440671983000	17208	8719	0	0	\N
301482	1874	5749000	17208	8719	1	0	\N
301483	1874	5751000	17208	8719	2	0	\N
301487	1678	19440671983000	17210	8719	0	0	\N
301488	1874	5749000	17210	8719	1	0	\N
301489	1874	5751000	17210	8719	2	0	\N
301497	1678	19440671986000	17213	8722	0	0	\N
301498	1874	5764000	17213	8722	1	0	\N
301499	1874	5767000	17213	8722	2	0	\N
301500	1678	19440671986000	17214	8722	0	0	\N
301501	1874	5764000	17214	8722	1	0	\N
301502	1874	5767000	17214	8722	2	0	\N
301506	1874	5764000	17216	8722	0	0	\N
301507	1678	19440671987000	17217	8723	0	0	\N
301508	1678	19440671988000	17217	8723	1	0	\N
301509	1874	5768000	17217	8723	2	0	\N
301510	1874	5771000	17217	8723	3	0	\N
301511	1874	5773000	17217	8723	4	0	\N
301512	1874	5775000	17217	8723	5	0	\N
301379	1874	5679000	17180	8708	3	0	2
301380	1874	5682000	17180	8708	4	0	2
301381	1874	5685000	17180	8708	5	0	2
301397	1678	19440671971000	17188	8710	0	0	0
301398	1678	19440671972000	17188	8710	1	0	0
301400	1874	5688000	17188	8710	3	0	2
301401	1874	5691000	17188	8710	4	0	2
301402	1874	5694000	17188	8710	5	0	2
301403	1874	5696000	17188	8710	6	0	2
301404	1874	5698000	17188	8710	7	0	2
301415	1678	19440671974000	17190	8711	0	0	0
301416	1874	5702000	17190	8711	1	0	2
301417	1874	5703000	17190	8711	2	0	2
301418	1874	5706000	17190	8711	3	0	2
301420	1874	5709000	17191	8712	1	0	2
301421	1874	5711000	17191	8712	2	0	2
301422	1678	19440671976000	17192	8713	0	0	0
301423	1874	5714000	17192	8713	1	0	2
301424	1874	5716000	17192	8713	2	0	2
301431	1874	5719000	17195	8714	1	0	2
301432	1874	5720000	17195	8714	2	0	2
301433	1874	5722000	17195	8714	3	0	2
301441	1678	19440671978000	17198	8715	0	0	0
301442	1874	5725000	17198	8715	1	0	2
301444	1678	19440671979000	17199	8716	0	0	0
301445	1678	19440671980000	17199	8716	1	0	0
301446	1874	5729000	17199	8716	2	0	2
301447	1874	5732000	17199	8716	3	0	2
301449	1874	5736000	17199	8716	5	0	2
301450	1678	19440671981000	17200	8717	0	0	0
301451	1874	5739000	17200	8717	1	0	2
301452	1874	5741000	17200	8717	2	0	2
301459	1678	19440671982000	17203	8718	0	0	0
301461	1874	5746000	17203	8718	2	0	2
301484	1678	19440671983000	17209	8719	0	0	0
301485	1874	5749000	17209	8719	1	0	2
301486	1874	5751000	17209	8719	2	0	2
301490	1678	19440671984000	17211	8720	0	0	0
301492	1874	5754000	17211	8720	2	0	2
301493	1874	5757000	17211	8720	3	0	2
301494	1678	19440671985000	17212	8721	0	0	0
301495	1874	5760000	17212	8721	1	0	2
301503	1678	19440671986000	17215	8722	0	0	0
301504	1874	5764000	17215	8722	1	0	2
301505	1874	5767000	17215	8722	2	0	2
301513	1874	5778000	17217	8723	6	0	\N
301521	1678	19440671987000	17219	8723	0	0	\N
301522	1678	19440671988000	17219	8723	1	0	\N
301523	1874	5768000	17219	8723	2	0	\N
301524	1874	5771000	17219	8723	3	0	\N
301525	1874	5773000	17219	8723	4	0	\N
301526	1874	5775000	17219	8723	5	0	\N
301527	1874	5778000	17219	8723	6	0	\N
301537	1678	19440671991000	17223	8725	0	0	\N
301538	1874	5789000	17223	8725	1	0	\N
301539	1874	5792000	17223	8725	2	0	\N
301540	1678	19440671991000	17224	8725	0	0	\N
301541	1874	5789000	17224	8725	1	0	\N
301542	1874	5792000	17224	8725	2	0	\N
301553	1678	19440671995000	17228	8729	0	0	\N
301554	1678	19440671996000	17228	8729	1	0	\N
301555	1874	5810000	17228	8729	2	0	\N
301556	1874	5812000	17228	8729	3	0	\N
301557	1874	5815000	17228	8729	4	0	\N
301558	1874	5818000	17228	8729	5	0	\N
301565	1678	19440671997000	17230	8730	0	0	\N
301566	1678	19440671998000	17230	8730	1	0	\N
301567	1874	5820000	17230	8730	3	0	\N
301568	1874	5822000	17230	8730	4	0	\N
301569	1874	5825000	17230	8730	5	0	\N
301570	1874	5826000	17230	8730	6	0	\N
301571	1874	5829000	17230	8730	7	0	\N
301579	1678	19440671997000	17232	8730	0	0	\N
301580	1678	19440671998000	17232	8730	1	0	\N
301581	1874	5820000	17232	8730	3	0	\N
301582	1874	5822000	17232	8730	4	0	\N
301583	1874	5825000	17232	8730	5	0	\N
301584	1874	5826000	17232	8730	6	0	\N
301585	1874	5829000	17232	8730	7	0	\N
301586	1678	19440671997000	17233	8730	0	0	\N
301587	1678	19440671998000	17233	8730	1	0	\N
301588	1874	5820000	17233	8730	3	0	\N
301589	1874	5822000	17233	8730	4	0	\N
301590	1874	5825000	17233	8730	5	0	\N
301591	1874	5826000	17233	8730	6	0	\N
301592	1874	5829000	17233	8730	7	0	\N
301603	1678	19440672001000	17236	8732	0	0	\N
301604	1874	5843000	17236	8732	1	0	\N
301605	1874	5845000	17236	8732	2	0	\N
301606	1678	19440672002000	17237	8733	0	0	\N
301607	1874	5848000	17237	8733	1	0	\N
301617	1678	19440672003000	17241	8734	0	0	\N
301618	1678	19440672004000	17241	8734	1	0	\N
301619	1874	5851000	17241	8734	2	0	\N
301620	1874	5852000	17241	8734	3	0	\N
301621	1874	5854000	17241	8734	4	0	\N
301622	1874	5856000	17241	8734	5	0	\N
301623	1874	5859000	17241	8734	6	0	\N
301624	1678	19440672003000	17242	8734	0	0	\N
301625	1678	19440672004000	17242	8734	1	0	\N
301626	1874	5851000	17242	8734	2	0	\N
301627	1874	5852000	17242	8734	3	0	\N
301628	1874	5854000	17242	8734	4	0	\N
301629	1874	5856000	17242	8734	5	0	\N
301630	1874	5859000	17242	8734	6	0	\N
301634	1678	19440672005000	17244	8735	0	0	\N
301635	1874	5862000	17244	8735	1	0	\N
301636	1874	5864000	17244	8735	2	0	\N
301637	1678	19440672005000	17245	8735	0	0	\N
301638	1874	5862000	17245	8735	1	0	\N
301639	1874	5864000	17245	8735	2	0	\N
301642	1460	0	17247	8703	0	0	\N
301643	1958	3485987000000	17248	8624	0	0	\N
301644	1678	18720659866000	17248	8624	1	0	\N
301645	1678	18720659867000	17248	8624	2	0	\N
301646	1678	18720659868000	17248	8624	3	0	\N
301647	2160	200000000	17248	8624	4	0	\N
301648	1678	18720659869000	17248	8624	5	0	\N
301516	1874	5768000	17218	8723	2	0	2
301517	1874	5771000	17218	8723	3	0	2
301518	1874	5773000	17218	8723	4	0	2
301519	1874	5775000	17218	8723	5	0	2
301520	1874	5778000	17218	8723	6	0	2
301529	1678	19440671990000	17220	8724	1	0	0
301530	1874	5780000	17220	8724	2	0	2
301531	1874	5781000	17220	8724	3	0	2
301532	1874	5784000	17220	8724	4	0	2
301533	1874	5787000	17220	8724	5	0	2
301535	1874	5789000	17222	8725	1	0	2
301536	1874	5792000	17222	8725	2	0	2
301543	1678	19440671992000	17225	8726	0	0	0
301544	1874	5794000	17225	8726	1	0	2
301546	1678	19440671993000	17226	8727	0	0	0
301547	1874	5800000	17226	8727	1	0	2
301548	1874	5802000	17226	8727	2	0	2
301549	1678	19440671994000	17227	8728	0	0	0
301550	1874	5804000	17227	8728	1	0	2
301552	1874	5808000	17227	8728	3	0	2
301559	1678	19440671995000	17229	8729	0	0	0
301560	1678	19440671996000	17229	8729	1	0	0
301561	1874	5810000	17229	8729	2	0	2
301562	1874	5812000	17229	8729	3	0	2
301564	1874	5818000	17229	8729	5	0	2
301572	1678	19440671997000	17231	8730	0	0	0
301573	1678	19440671998000	17231	8730	1	0	0
301574	1874	5820000	17231	8730	3	0	2
301576	1874	5825000	17231	8730	5	0	2
301577	1874	5826000	17231	8730	6	0	2
301578	1874	5829000	17231	8730	7	0	2
301593	1678	19440671999000	17234	8731	0	0	0
301594	1678	19440672000000	17234	8731	1	0	0
301596	1874	5835000	17234	8731	3	0	2
301597	1874	5836000	17234	8731	4	0	2
301598	1874	5838000	17234	8731	5	0	2
301599	1874	5840000	17234	8731	6	0	2
301600	1678	19440672001000	17235	8732	0	0	0
301602	1874	5845000	17235	8732	2	0	2
301608	1678	19440672002000	17238	8733	0	0	0
301609	1874	5848000	17238	8733	1	0	2
301610	1678	19440672003000	17240	8734	0	0	0
301612	1874	5851000	17240	8734	2	0	2
301613	1874	5852000	17240	8734	3	0	2
301614	1874	5854000	17240	8734	4	0	2
301615	1874	5856000	17240	8734	5	0	2
301616	1874	5859000	17240	8734	6	0	2
301632	1874	5862000	17243	8735	1	0	2
301633	1874	5864000	17243	8735	2	0	2
301640	1874	5867000	17246	8736	0	0	2
301641	1874	5869000	17246	8736	1	0	2
301649	1678	18720659870000	17248	8624	6	0	\N
301650	1678	18720659871000	17248	8624	7	0	\N
301651	1678	18720659872000	17248	8624	8	0	\N
301652	1678	18720659873000	17248	8624	9	0	\N
301653	1678	18720659874000	17248	8624	10	0	\N
301654	1678	18720659875000	17248	8624	11	0	\N
301655	1678	18720659876000	17248	8624	12	0	\N
301656	1678	18720659877000	17248	8624	13	0	\N
301657	1678	18720659878000	17248	8624	14	0	\N
301658	2111	2200000000	17248	8624	15	0	\N
301659	693	66000010000000	17248	8624	16	0	\N
301660	2161	200000000	17248	8624	17	0	\N
301661	2162	200000000	17248	8624	18	0	\N
301662	188	66001000000000	17248	8624	19	0	\N
301663	1678	18720659879000	17248	8624	20	0	\N
301664	1678	18720659880000	17248	8624	21	0	\N
301665	1678	18720659881000	17248	8624	22	0	\N
301666	1678	18720659882000	17248	8624	23	0	\N
301667	1678	18720659883000	17248	8624	24	0	\N
301668	1678	18720659884000	17248	8624	25	0	\N
301669	1678	18720659885000	17248	8624	26	0	\N
301670	1678	18720659886000	17248	8624	27	0	\N
301671	1678	18720659887000	17248	8624	28	0	\N
301672	1678	18720659888000	17248	8624	29	0	\N
301673	1678	18720659889000	17248	8624	30	0	\N
301674	1678	18720659890000	17248	8624	31	0	\N
301675	1678	18720659891000	17248	8624	32	0	\N
301676	1678	18720659892000	17248	8624	33	0	\N
301677	1678	18720659893000	17248	8624	34	0	\N
301678	1678	18720659894000	17248	8624	35	0	\N
301679	1678	18720659895000	17248	8624	36	0	\N
301680	1678	18720659896000	17248	8624	37	0	\N
301681	1678	18720659897000	17248	8624	38	0	\N
301682	1678	18720659898000	17248	8624	39	0	\N
301683	1678	18720659899000	17248	8624	40	0	\N
301684	1678	18720659900000	17248	8624	41	0	\N
301685	1678	18720659901000	17248	8624	42	0	\N
301686	1678	18720659902000	17248	8624	43	0	\N
301687	1678	18720659903000	17248	8624	44	0	\N
301688	1678	18720659904000	17248	8624	45	0	\N
301689	1678	18720659905000	17248	8624	46	0	\N
301690	1678	18720659906000	17248	8624	47	0	\N
301691	1678	18720659907000	17248	8624	48	0	\N
301692	1678	18720659908000	17248	8624	49	0	\N
301693	1678	18720659909000	17248	8624	50	0	\N
301694	1678	18720659910000	17248	8624	51	0	\N
301695	1678	18720659911000	17248	8624	52	0	\N
301696	1678	18720659912000	17248	8624	53	0	\N
301697	1678	18720659913000	17248	8624	54	0	\N
301698	1678	18720659914000	17248	8624	55	0	\N
301699	1678	18720659915000	17248	8624	56	0	\N
301700	1678	18720659916000	17248	8624	57	0	\N
301701	1678	18720659917000	17248	8624	58	0	\N
301702	1678	18720659918000	17248	8624	59	0	\N
301703	1678	18720659919000	17248	8624	60	0	\N
301704	1678	18720659920000	17248	8624	61	0	\N
301705	1678	18720659921000	17248	8624	62	0	\N
301706	1678	18720659922000	17248	8624	63	0	\N
301707	1678	18720659923000	17248	8624	64	0	\N
301708	1678	18720659924000	17248	8624	65	0	\N
301709	1678	18720659925000	17248	8624	66	0	\N
301710	1678	18720659926000	17248	8624	67	0	\N
301711	1678	18720659927000	17248	8624	68	0	\N
301712	1678	18720659928000	17248	8624	69	0	\N
301713	1678	18720659929000	17248	8624	70	0	\N
301714	1678	18720659930000	17248	8624	71	0	\N
301715	1678	18720659931000	17248	8624	72	0	\N
301716	1678	18720659932000	17248	8624	73	0	\N
301717	1678	18720659933000	17248	8624	74	0	\N
301718	1678	18720659934000	17248	8624	75	0	\N
301719	1678	18720659935000	17248	8624	76	0	\N
301720	1678	18720659936000	17248	8624	77	0	\N
301721	1678	18720659937000	17248	8624	78	0	\N
301722	1678	18720659938000	17248	8624	79	0	\N
301723	1678	18720659939000	17248	8624	80	0	\N
301724	1678	18720659940000	17248	8624	81	0	\N
301725	1678	18720659941000	17248	8624	82	0	\N
301726	1678	18720659942000	17248	8624	83	0	\N
301727	1678	18720659943000	17248	8624	84	0	\N
301728	1678	18720659944000	17248	8624	85	0	\N
301729	1678	18720659945000	17248	8624	86	0	\N
301730	1678	18720659946000	17248	8624	87	0	\N
301731	1678	18720659947000	17248	8624	88	0	\N
301732	1678	18720659948000	17248	8624	89	0	\N
301733	1678	18720659949000	17248	8624	90	0	\N
301734	1678	18720659950000	17248	8624	91	0	\N
301735	1678	18720659951000	17248	8624	92	0	\N
301736	1678	18720659952000	17248	8624	93	0	\N
301737	1678	18720659953000	17248	8624	94	0	\N
301738	1678	18720659954000	17248	8624	95	0	\N
301739	1678	18720659955000	17248	8624	96	0	\N
301740	1678	18720659956000	17248	8624	97	0	\N
301741	1678	18720659957000	17248	8624	98	0	\N
301742	1678	18720659958000	17248	8624	99	0	\N
301743	1678	18720659959000	17248	8624	100	0	\N
301744	1678	18720659960000	17248	8624	101	0	\N
301745	1678	18720659961000	17248	8624	102	0	\N
301746	1678	18720659962000	17248	8624	103	0	\N
301747	1678	18720659963000	17248	8624	104	0	\N
301748	1678	18720659964000	17248	8624	105	0	\N
301749	1678	18720659965000	17248	8624	107	0	\N
301750	1678	18720659966000	17248	8624	108	0	\N
301751	1678	18720659967000	17248	8624	109	0	\N
301752	1678	18720659968000	17248	8624	110	0	\N
301753	1678	18720659969000	17248	8624	111	0	\N
301754	1678	18720659970000	17248	8624	112	0	\N
301755	1678	18720659971000	17248	8624	113	0	\N
301756	1678	18720659972000	17248	8624	114	0	\N
301757	1678	18720659973000	17248	8624	115	0	\N
301758	1678	18720659974000	17248	8624	116	0	\N
301759	1678	18720659975000	17248	8624	117	0	\N
301760	1678	18720659976000	17248	8624	118	0	\N
301761	1678	18720659977000	17248	8624	119	0	\N
301762	1678	18720659978000	17248	8624	120	0	\N
301763	1678	18720659979000	17248	8624	121	0	\N
301764	1678	18720659980000	17248	8624	122	0	\N
301765	1678	18720659981000	17248	8624	123	0	\N
301766	1678	18720659982000	17248	8624	124	0	\N
301767	1678	18720659983000	17248	8624	125	0	\N
301774	1678	19440672008000	17250	8738	0	0	\N
301775	1874	5881000	17250	8738	1	0	\N
301776	1874	5884000	17250	8738	2	0	\N
301780	1678	19440672009000	17252	8739	0	0	\N
301781	1678	19440672010000	17252	8739	1	0	\N
301782	1874	5886000	17252	8739	2	0	\N
301783	1874	5889000	17252	8739	3	0	\N
301784	1874	5892000	17252	8739	4	0	\N
301770	1874	5871000	17249	8737	2	0	2
301771	1874	5873000	17249	8737	3	0	2
301772	1874	5876000	17249	8737	4	0	2
301773	1874	5879000	17249	8737	5	0	2
301777	1678	19440672008000	17251	8738	0	0	0
301779	1874	5884000	17251	8738	2	0	2
301785	1874	5894000	17252	8739	5	0	\N
301792	1678	19440672009000	17254	8739	0	0	\N
301793	1678	19440672010000	17254	8739	1	0	\N
301794	1874	5886000	17254	8739	2	0	\N
301795	1874	5889000	17254	8739	3	0	\N
301796	1874	5892000	17254	8739	4	0	\N
301797	1874	5894000	17254	8739	5	0	\N
301798	1678	19440672011000	17255	8740	0	0	\N
301799	1874	5896000	17255	8740	1	0	\N
301800	1874	5899000	17255	8740	2	0	\N
301801	1678	19440672011000	17256	8740	0	0	\N
301802	1874	5896000	17256	8740	1	0	\N
301803	1874	5899000	17256	8740	2	0	\N
301805	1678	19440672011000	17258	8741	0	0	\N
301806	1678	19440672012000	17258	8741	1	0	\N
301807	1874	5900000	17258	8741	2	0	\N
301808	1874	5902000	17258	8741	3	0	\N
301809	1874	5904000	17258	8741	4	0	\N
301830	1678	19440672017000	17266	8745	0	0	\N
301831	1874	5926000	17266	8745	1	0	\N
301832	1874	5929000	17266	8745	2	0	\N
301846	1678	19440672022000	17275	8750	0	0	\N
301847	1874	5947000	17275	8750	1	0	\N
301848	1874	5949000	17275	8750	2	0	\N
301852	1678	19440672024000	17278	8752	0	0	\N
301853	1874	5956000	17278	8752	1	0	\N
301854	1874	5959000	17278	8752	3	0	\N
301855	1678	19440672024000	17279	8752	0	0	\N
301856	1874	5956000	17279	8752	1	0	\N
301857	1874	5959000	17279	8752	3	0	\N
301858	1678	19440672024000	17280	8752	0	0	\N
301859	1874	5956000	17280	8752	1	0	\N
301860	1874	5959000	17280	8752	3	0	\N
301864	1678	19440672024000	17282	8752	0	0	\N
301865	1874	5956000	17282	8752	1	0	\N
301866	1874	5959000	17282	8752	3	0	\N
301876	1678	19440672026000	17285	8754	0	0	\N
301877	1678	19440672027000	17285	8754	1	0	\N
301878	1874	5967000	17285	8754	2	0	\N
301879	1874	5970000	17285	8754	3	0	\N
301880	1874	5972000	17285	8754	4	0	\N
301881	1874	5974000	17285	8754	5	0	\N
301882	1678	19440672026000	17286	8754	0	0	\N
301883	1678	19440672027000	17286	8754	1	0	\N
301884	1874	5967000	17286	8754	2	0	\N
301885	1874	5970000	17286	8754	3	0	\N
301886	1874	5972000	17286	8754	4	0	\N
301887	1874	5974000	17286	8754	5	0	\N
301907	1678	19440672034000	17291	8758	0	0	\N
301908	1874	6007000	17291	8758	1	0	\N
301909	1678	19440672034000	17292	8758	0	0	\N
301910	1874	6007000	17292	8758	1	0	\N
301915	1678	19440672036000	17295	8760	0	0	\N
301916	1678	19440672037000	17295	8760	1	0	\N
301917	1678	19440672038000	17295	8760	2	0	\N
301918	1874	6014000	17295	8760	3	0	\N
301919	1874	6017000	17295	8760	4	0	\N
301920	1874	6020000	17295	8760	5	0	\N
301788	1874	5886000	17253	8739	2	0	2
301789	1874	5889000	17253	8739	3	0	2
301790	1874	5892000	17253	8739	4	0	2
301791	1874	5894000	17253	8739	5	0	2
301804	1874	5897000	17257	8740	0	0	2
301811	1678	19440672012000	17259	8741	1	0	0
301812	1874	5899000	17259	8741	2	0	2
301813	1874	5901000	17259	8741	3	0	2
301814	1678	19440672013000	17260	8742	0	0	0
301815	1678	19440672014000	17260	8742	1	0	0
301817	1874	5906000	17260	8742	3	0	2
301818	1874	5909000	17260	8742	4	0	2
301819	1874	5911000	17260	8742	5	0	2
301820	1874	5914000	17260	8742	6	0	2
301822	1874	5916000	17262	8743	1	0	2
301823	1874	5919000	17262	8743	2	0	2
301824	1678	19440672016000	17263	8744	0	0	0
301825	1874	5922000	17263	8744	1	0	2
301826	1874	5924000	17263	8744	2	0	2
301828	1874	5926000	17265	8745	1	0	2
301829	1874	5929000	17265	8745	2	0	2
301833	1874	5931000	17267	8746	0	0	2
301834	1678	19440672018000	17268	8747	0	0	0
301835	1678	19440672019000	17268	8747	1	0	0
301837	1874	5936000	17268	8747	3	0	2
301838	1678	19440672020000	17270	8748	0	0	0
301839	1874	5939000	17270	8748	1	0	2
301840	1678	19440672021000	17272	8749	0	0	0
301842	1874	5944000	17272	8749	2	0	2
301843	1678	19440672022000	17274	8750	0	0	0
301844	1874	5947000	17274	8750	1	0	2
301845	1874	5949000	17274	8750	2	0	2
301849	1678	19440672023000	17277	8751	0	0	0
301851	1874	5954000	17277	8751	2	0	2
301861	1678	19440672024000	17281	8752	0	0	0
301862	1874	5956000	17281	8752	1	0	2
301863	1874	5959000	17281	8752	3	0	2
301867	1678	19440672025000	17283	8753	0	0	0
301869	1874	5964000	17283	8753	2	0	2
301870	1678	19440672026000	17284	8754	0	0	0
301871	1678	19440672027000	17284	8754	1	0	0
301872	1874	5967000	17284	8754	2	0	2
301874	1874	5972000	17284	8754	4	0	2
301875	1874	5974000	17284	8754	5	0	2
301888	1678	19440672028000	17287	8755	0	0	0
301889	1678	19440672029000	17287	8755	1	0	0
301890	1678	19440672030000	17287	8755	2	0	0
301892	1874	5980000	17287	8755	4	0	2
301893	1874	5982000	17287	8755	5	0	2
301894	1874	5984000	17287	8755	6	0	2
301895	1874	5987000	17287	8755	7	0	2
301896	1874	5989000	17287	8755	8	0	2
301898	1678	19440672032000	17288	8756	1	0	0
301899	1874	5992000	17288	8756	2	0	2
301900	1874	5994000	17288	8756	3	0	2
301901	1874	5996000	17288	8756	4	0	2
301903	1678	19440672033000	17289	8757	0	0	0
301904	1874	6001000	17289	8757	1	0	2
301905	1874	6004000	17289	8757	2	0	2
301906	1678	19440672034000	17290	8758	0	0	0
301911	1678	19440672035000	17294	8759	0	0	0
301913	1874	6009000	17294	8759	2	0	2
301914	1874	6012000	17294	8759	3	0	2
301921	1874	6023000	17295	8760	6	0	\N
301922	1874	6025000	17295	8760	7	0	\N
301923	1874	6027000	17295	8760	8	0	\N
301951	1678	19440672045000	17300	8764	0	0	\N
301952	1678	19440672046000	17300	8764	1	0	\N
301953	1874	6060000	17300	8764	2	0	\N
301954	1874	6062000	17300	8764	3	0	\N
301955	1874	6064000	17300	8764	4	0	\N
301956	1874	6067000	17300	8764	5	0	\N
301957	1958	3485987000000	17301	8540	0	0	\N
301958	2111	2200000000	17301	8540	1	0	\N
301959	693	66000010000000	17301	8540	2	0	\N
301960	2161	200000000	17301	8540	3	0	\N
301961	2162	200000000	17301	8540	4	0	\N
301962	188	66001000000000	17301	8540	5	0	\N
301963	1474	12513412000023	17301	8540	6	0	\N
301964	1460	0	17301	8540	7	0	\N
301965	1950	11169851000000	17301	8540	8	0	\N
301972	1678	19440672045000	17303	8764	0	0	\N
301973	1678	19440672046000	17303	8764	1	0	\N
301974	1874	6060000	17303	8764	2	0	\N
301975	1874	6062000	17303	8764	3	0	\N
301976	1874	6064000	17303	8764	4	0	\N
301977	1874	6067000	17303	8764	5	0	\N
301991	1678	19440672050000	17307	8767	0	0	\N
301992	1874	6085000	17307	8767	1	0	\N
301993	1874	6087000	17307	8767	2	0	\N
301999	1678	19440672052000	17310	8769	0	0	\N
302000	1874	6092000	17310	8769	1	0	\N
302001	1874	6095000	17310	8769	2	0	\N
302003	1678	19440672053000	17312	8770	0	0	\N
302004	1874	6097000	17312	8770	1	0	\N
302005	1874	6100000	17312	8770	2	0	\N
302006	1678	19440672053000	17313	8771	0	0	\N
302007	1678	19440672054000	17313	8771	1	0	\N
302008	1874	6099000	17313	8771	2	0	\N
302009	1874	6102000	17313	8771	3	0	\N
302010	1874	6105000	17313	8771	5	0	\N
302016	1678	19440672055000	17315	8772	0	0	\N
302017	1874	6108000	17315	8772	1	0	\N
302028	1678	19440672059000	17320	8776	0	0	\N
302029	1874	6124000	17320	8776	1	0	\N
302030	1874	6126000	17320	8776	2	0	\N
302031	1678	19440672059000	17321	8776	0	0	\N
302032	1874	6124000	17321	8776	1	0	\N
302033	1874	6126000	17321	8776	2	0	\N
302037	1866	9452631301632	17323	8777	0	0	\N
302038	1678	19440672060000	17323	8777	1	0	\N
302039	1678	19440672061000	17323	8777	2	0	\N
302040	1874	6128000	17323	8777	3	0	\N
302041	1874	6130000	17323	8777	4	0	\N
302042	1874	6133000	17323	8777	5	0	\N
302043	1874	6136000	17323	8777	6	0	\N
302051	1866	9452631301632	17325	8777	0	0	\N
302052	1678	19440672060000	17325	8777	1	0	\N
302053	1678	19440672061000	17325	8777	2	0	\N
302054	1874	6128000	17325	8777	3	0	\N
302055	1874	6130000	17325	8777	4	0	\N
302056	1874	6133000	17325	8777	5	0	\N
301926	1678	19440672038000	17296	8760	2	0	0
301927	1874	6014000	17296	8760	3	0	2
301928	1874	6017000	17296	8760	4	0	2
301929	1874	6020000	17296	8760	5	0	2
301930	1874	6023000	17296	8760	6	0	2
301932	1874	6027000	17296	8760	8	0	2
301933	1678	19440672039000	17297	8761	0	0	0
301934	1874	6030000	17297	8761	1	0	2
301935	1874	6032000	17297	8761	2	0	2
301936	1678	19440672040000	17298	8762	0	0	0
301938	1678	19440672042000	17298	8762	2	0	0
301939	1678	19440672043000	17298	8762	3	0	0
301940	1874	6035000	17298	8762	4	0	2
301941	1874	6037000	17298	8762	5	0	2
301943	1874	6043000	17298	8762	7	0	2
301944	1874	6046000	17298	8762	8	0	2
301945	1874	6048000	17298	8762	9	0	2
301946	1874	6050000	17298	8762	10	0	2
301947	1874	6052000	17298	8762	11	0	2
301949	1874	6055000	17299	8763	1	0	2
301950	1874	6057000	17299	8763	2	0	2
301966	1678	19440672045000	17302	8764	0	0	0
301967	1678	19440672046000	17302	8764	1	0	0
301968	1874	6060000	17302	8764	2	0	2
301970	1874	6064000	17302	8764	4	0	2
301971	1874	6067000	17302	8764	5	0	2
301978	1678	19440672047000	17304	8765	0	0	0
301979	1505	0	17304	8765	1	0	0
301981	1874	6072000	17304	8765	3	0	2
301982	1678	19440672048000	17305	8766	0	0	0
301983	1678	19440672049000	17305	8766	1	0	0
301984	1874	6075000	17305	8766	2	0	2
301985	1874	6077000	17305	8766	3	0	2
301987	1874	6082000	17305	8766	5	0	2
301988	1678	19440672050000	17306	8767	0	0	0
301989	1874	6085000	17306	8767	1	0	2
301990	1874	6087000	17306	8767	2	0	2
301994	1678	19440672051000	17308	8768	0	0	0
301996	1678	19440672052000	17309	8769	0	0	0
301997	1874	6092000	17309	8769	1	0	2
301998	1874	6095000	17309	8769	2	0	2
302002	1874	6097000	17311	8770	0	0	2
302012	1678	19440672054000	17314	8771	1	0	0
302013	1874	6099000	17314	8771	2	0	2
302014	1874	6102000	17314	8771	3	0	2
302015	1874	6105000	17314	8771	5	0	2
302018	1678	19440672055000	17316	8772	0	0	0
302020	1678	19440672056000	17317	8773	0	0	0
302021	1874	6111000	17317	8773	1	0	2
302022	1874	6113000	17317	8773	2	0	2
302023	1678	19440672057000	17318	8774	0	0	0
302024	1874	6116000	17318	8774	1	0	2
302026	1678	19440672058000	17319	8775	0	0	0
302027	1874	6121000	17319	8775	1	0	2
302034	1678	19440672059000	17322	8776	0	0	0
302035	1874	6124000	17322	8776	1	0	2
302044	1866	9452631301632	17324	8777	0	0	16
302045	1678	19440672060000	17324	8777	1	0	0
302046	1678	19440672061000	17324	8777	2	0	0
302047	1874	6128000	17324	8777	3	0	2
302048	1874	6130000	17324	8777	4	0	2
302050	1874	6136000	17324	8777	6	0	2
302057	1874	6136000	17325	8777	6	0	\N
302058	1866	9452631301632	17326	8777	0	0	\N
302059	1678	19440672060000	17326	8777	1	0	\N
302060	1678	19440672061000	17326	8777	2	0	\N
302061	1874	6128000	17326	8777	3	0	\N
302062	1874	6130000	17326	8777	4	0	\N
302063	1874	6133000	17326	8777	5	0	\N
302064	1874	6136000	17326	8777	6	0	\N
302067	1866	9452631301632	17328	8762	0	0	\N
302068	1678	19440672040000	17328	8762	1	0	\N
302069	1505	0	17328	8762	2	0	\N
302070	1678	19440672041000	17328	8762	3	0	\N
302071	1678	19440672042000	17328	8762	4	0	\N
302072	1678	19440672043000	17328	8762	5	0	\N
302073	1678	19440672044000	17328	8762	6	0	\N
302074	1678	19440672045000	17328	8762	7	0	\N
302075	1678	19440672046000	17328	8762	8	0	\N
302076	1678	19440672047000	17328	8762	9	0	\N
302077	1678	19440672048000	17328	8762	10	0	\N
302078	1678	19440672049000	17328	8762	11	0	\N
302079	1678	19440672050000	17328	8762	12	0	\N
302080	1678	19440672051000	17328	8762	13	0	\N
302081	1678	19440672052000	17328	8762	14	0	\N
302082	1678	19440672053000	17328	8762	15	0	\N
302083	1678	19440672054000	17328	8762	16	0	\N
302084	1678	19440672055000	17328	8762	17	0	\N
302085	1678	19440672056000	17328	8762	18	0	\N
302086	1678	19440672057000	17328	8762	19	0	\N
302087	1678	19440672058000	17328	8762	20	0	\N
302088	1678	19440672059000	17328	8762	21	0	\N
302089	1678	19440672060000	17328	8762	22	0	\N
302090	1678	19440672061000	17328	8762	23	0	\N
302091	1678	19440672062000	17328	8762	24	0	\N
302092	1874	6035000	17328	8762	25	0	\N
302093	1874	6037000	17328	8762	26	0	\N
302094	1874	6040000	17328	8762	27	0	\N
302095	1874	6043000	17328	8762	28	0	\N
302096	1874	6046000	17328	8762	29	0	\N
302097	1874	6049000	17328	8762	30	0	\N
302098	1874	6052000	17328	8762	31	0	\N
302099	1874	6055000	17328	8762	32	0	\N
302100	1874	6058000	17328	8762	33	0	\N
302101	1874	6061000	17328	8762	34	0	\N
302102	1874	6064000	17328	8762	35	0	\N
302103	1874	6067000	17328	8762	36	0	\N
302104	1874	6070000	17328	8762	37	0	\N
302105	1874	6073000	17328	8762	38	0	\N
302106	1874	6076000	17328	8762	39	0	\N
302107	1874	6078000	17328	8762	40	0	\N
302108	1874	6080000	17328	8762	41	0	\N
302109	1874	6082000	17328	8762	42	0	\N
302110	1874	6084000	17328	8762	43	0	\N
302111	1874	6086000	17328	8762	44	0	\N
302112	1874	6088000	17328	8762	45	0	\N
302113	1874	6090000	17328	8762	46	0	\N
302114	1874	6092000	17328	8762	47	0	\N
302115	1874	6094000	17328	8762	48	0	\N
302116	1874	6096000	17328	8762	49	0	\N
302117	1874	6098000	17328	8762	50	0	\N
302118	1874	6100000	17328	8762	51	0	\N
302119	1874	6102000	17328	8762	52	0	\N
302120	1874	6104000	17328	8762	53	0	\N
302121	1874	6106000	17328	8762	54	0	\N
302122	1874	6108000	17328	8762	55	0	\N
302123	1874	6110000	17328	8762	56	0	\N
302124	1874	6112000	17328	8762	57	0	\N
302125	1874	6115000	17328	8762	58	0	\N
302126	1874	6118000	17328	8762	59	0	\N
302127	1874	6121000	17328	8762	60	0	\N
302128	1874	6124000	17328	8762	61	0	\N
302129	1874	6127000	17328	8762	63	0	\N
302130	1874	6130000	17328	8762	64	0	\N
302131	1874	6133000	17328	8762	65	0	\N
302132	1874	6136000	17328	8762	66	0	\N
302133	1874	6139000	17328	8762	67	0	\N
302134	481	66399889331481	17329	8779	0	0	\N
302135	734	2012117858457	17329	8779	1	0	\N
302136	845	576807119311139	17329	8779	2	0	\N
302137	846	576807119311139	17329	8779	3	0	\N
302138	936	505992901988482	17329	8779	4	0	\N
302139	1056	906734945016128	17329	8779	5	0	\N
302140	1176	611792135372498	17329	8779	6	0	\N
302141	1302	1704813182739154	17329	8779	7	0	\N
302142	1678	19440672063000	17329	8779	8	0	\N
302143	1874	6141000	17329	8779	9	0	\N
302144	1874	6144000	17329	8779	10	0	\N
302156	481	66399889331481	17331	8779	0	0	\N
302157	734	2012117858457	17331	8779	1	0	\N
302158	845	576807119311139	17331	8779	2	0	\N
302159	846	576807119311139	17331	8779	3	0	\N
302160	936	505992901988482	17331	8779	4	0	\N
302161	1056	906734945016128	17331	8779	5	0	\N
302162	1678	19440672063000	17331	8779	6	0	\N
302163	1874	6141000	17331	8779	7	0	\N
302164	1874	6144000	17331	8779	8	0	\N
302169	1678	19440672064000	17333	8780	0	0	\N
302170	1678	19440672065000	17333	8780	1	0	\N
302171	1874	6147000	17333	8780	2	0	\N
302172	1874	6150000	17333	8780	3	0	\N
302173	1874	6152000	17333	8780	4	0	\N
302174	1874	6154000	17333	8780	5	0	\N
302176	1866	9452631301632	17335	8777	0	0	\N
302145	481	66399889331481	17330	8779	0	0	0
302146	734	2012117858457	17330	8779	1	0	0
302147	845	576807119311139	17330	8779	2	0	0
302148	846	576807119311139	17330	8779	3	0	0
302149	936	505992901988482	17330	8779	4	0	0
302151	1176	611792135372498	17330	8779	6	0	0
302152	1302	1704813182739154	17330	8779	7	0	0
302153	1678	19440672063000	17330	8779	8	0	0
302154	1874	6141000	17330	8779	9	0	2
302155	1874	6144000	17330	8779	10	0	2
302166	1678	19440672065000	17332	8780	1	0	0
302167	1874	6146000	17332	8780	2	0	2
302168	1874	6148000	17332	8780	3	0	2
302175	1874	6150000	17334	8781	0	0	2
302178	1678	19440672067000	17336	8782	1	0	0
302179	1874	6152000	17336	8782	2	0	2
302180	1874	6155000	17336	8782	3	0	2
302181	1874	6157000	17336	8782	4	0	2
302182	1874	6160000	17336	8782	5	0	2
302184	1874	6166000	17336	8782	7	0	2
302185	1874	6169000	17336	8782	8	0	2
302186	1678	19440672068000	17337	8783	0	0	0
302187	1874	6172000	17337	8783	1	0	2
302188	1874	6174000	17337	8783	2	0	2
302190	1874	6177000	17338	8784	1	0	2
302191	1874	6179000	17338	8784	2	0	2
302192	1678	19440672070000	17339	8785	0	0	0
302195	1678	19440672070000	17340	8785	0	0	\N
302196	1874	6182000	17340	8785	1	0	\N
302197	1874	6184000	17340	8785	2	0	\N
302201	1678	19440672072000	17342	8787	0	0	\N
302202	1874	6192000	17342	8787	1	0	\N
302203	1874	6194000	17342	8787	2	0	\N
302207	1678	19440672073000	17344	8788	0	0	\N
302208	1874	6197000	17344	8788	1	0	\N
302209	1874	6199000	17344	8788	2	0	\N
302210	1678	19440672073000	17345	8788	0	0	\N
302211	1874	6197000	17345	8788	1	0	\N
302212	1874	6199000	17345	8788	2	0	\N
302216	1678	19440672074000	17348	8789	0	0	\N
302217	1874	6202000	17348	8789	1	0	\N
302218	1874	6204000	17348	8789	2	0	\N
302219	1678	19440672074000	17349	8789	0	0	\N
302220	1874	6201000	17349	8789	1	0	\N
302221	1678	19440672074000	17350	8789	0	0	\N
302222	1874	6202000	17350	8789	1	0	\N
302223	1874	6204000	17350	8789	2	0	\N
302234	1678	19440672078000	17354	8793	0	0	\N
302235	1678	19440672079000	17354	8793	1	0	\N
302236	1678	19440672080000	17354	8793	2	0	\N
302237	1874	6218000	17354	8793	3	0	\N
302238	1874	6221000	17354	8793	4	0	\N
302239	1874	6224000	17354	8793	5	0	\N
302240	1874	6226000	17354	8793	6	0	\N
302241	1874	6228000	17354	8793	7	0	\N
302242	1874	6230000	17354	8793	9	0	\N
302243	1678	19440672078000	17355	8793	0	0	\N
302244	1678	19440672079000	17355	8793	1	0	\N
302245	1678	19440672080000	17355	8793	2	0	\N
302246	1874	6218000	17355	8793	3	0	\N
302247	1874	6221000	17355	8793	4	0	\N
302248	1874	6224000	17355	8793	5	0	\N
302249	1874	6226000	17355	8793	6	0	\N
302250	1874	6228000	17355	8793	7	0	\N
302251	1874	6230000	17355	8793	9	0	\N
302261	1866	9452631301632	17357	8698	0	0	\N
302262	1505	0	17357	8698	1	0	\N
302263	1460	0	17357	8698	2	0	\N
302264	1678	19440672081000	17358	8794	0	0	\N
302265	1874	6233000	17358	8794	1	0	\N
302266	1874	6235000	17358	8794	2	0	\N
302267	1678	19440672081000	17359	8794	0	0	\N
302268	1874	6233000	17359	8794	1	0	\N
302269	1874	6235000	17359	8794	2	0	\N
302273	1678	19440672081000	17361	8794	0	0	\N
302274	1874	6233000	17361	8794	1	0	\N
302275	1874	6235000	17361	8794	2	0	\N
302276	1678	19440672081000	17362	8794	0	0	\N
302277	1874	6233000	17362	8794	1	0	\N
302278	1874	6235000	17362	8794	2	0	\N
302282	1678	19440672083000	17364	8796	0	0	\N
302283	1678	19440672084000	17364	8796	1	0	\N
302284	1874	6242000	17364	8796	2	0	\N
302285	1874	6245000	17364	8796	3	0	\N
302286	1874	6248000	17364	8796	4	0	\N
302287	1678	19440672083000	17365	8796	0	0	\N
302288	1678	19440672084000	17365	8796	1	0	\N
302289	1874	6242000	17365	8796	2	0	\N
302290	1874	6245000	17365	8796	3	0	\N
302291	1874	6248000	17365	8796	4	0	\N
302292	1678	19440672083000	17366	8796	0	0	\N
302293	1678	19440672084000	17366	8796	1	0	\N
302294	1874	6242000	17366	8796	2	0	\N
302295	1874	6245000	17366	8796	3	0	\N
302296	1874	6248000	17366	8796	4	0	\N
302308	1678	19440672087000	17369	8798	0	0	\N
302309	1874	6261000	17369	8798	1	0	\N
302312	1678	19440672088000	17371	8799	0	0	\N
302313	1874	6264000	17371	8799	1	0	\N
302314	1874	6266000	17371	8799	2	0	\N
302318	1678	19440672088000	17373	8799	0	0	\N
302319	1874	6264000	17373	8799	1	0	\N
302320	1874	6266000	17373	8799	2	0	\N
302321	1678	19440672088000	17374	8799	0	0	\N
302322	1874	6264000	17374	8799	1	0	\N
302323	1874	6266000	17374	8799	2	0	\N
302324	1874	6264000	17375	8799	0	0	\N
302325	1874	6266000	17375	8799	1	0	\N
302198	1678	19440672071000	17341	8786	0	0	0
302199	1874	6186000	17341	8786	1	0	2
302200	1874	6189000	17341	8786	2	0	2
302204	1678	19440672072000	17343	8787	0	0	0
302205	1874	6192000	17343	8787	1	0	2
302213	1678	19440672073000	17346	8788	0	0	0
302214	1874	6197000	17346	8788	1	0	2
302215	1874	6199000	17346	8788	2	0	2
302224	1678	19440672074000	17351	8790	0	0	0
302225	1678	19440672075000	17351	8790	1	0	0
302227	1874	6205000	17351	8790	3	0	2
302228	1874	6207000	17351	8790	4	0	2
302229	1678	19440672076000	17352	8791	0	0	0
302230	1874	6210000	17352	8791	1	0	2
302232	1678	19440672077000	17353	8792	0	0	0
302233	1874	6215000	17353	8792	1	0	2
302252	1678	19440672078000	17356	8793	0	0	0
302253	1678	19440672079000	17356	8793	1	0	0
302254	1678	19440672080000	17356	8793	2	0	0
302256	1874	6221000	17356	8793	4	0	2
302257	1874	6224000	17356	8793	5	0	2
302258	1874	6226000	17356	8793	6	0	2
302259	1874	6228000	17356	8793	7	0	2
302260	1874	6230000	17356	8793	9	0	2
302271	1874	6233000	17360	8794	1	0	2
302272	1874	6235000	17360	8794	2	0	2
302279	1678	19440672082000	17363	8795	0	0	0
302280	1874	6238000	17363	8795	1	0	2
302297	1678	19440672083000	17367	8796	0	0	0
302298	1874	6242000	17367	8796	1	0	2
302299	1874	6245000	17367	8796	2	0	2
302300	1874	6248000	17367	8796	3	0	2
302301	1678	19440672084000	17368	8797	0	0	0
302303	1678	19440672086000	17368	8797	2	0	0
302304	1874	6250000	17368	8797	3	0	2
302305	1874	6252000	17368	8797	4	0	2
302306	1874	6255000	17368	8797	5	0	2
302307	1874	6258000	17368	8797	6	0	2
302311	1874	6261000	17370	8798	1	0	2
302315	1678	19440672088000	17372	8799	0	0	0
302316	1874	6264000	17372	8799	1	0	2
302317	1874	6266000	17372	8799	2	0	2
302327	1874	6268000	17376	8800	1	0	2
302328	1874	6271000	17376	8800	2	0	2
302338	1678	19440672091000	17379	8802	0	0	\N
302339	1678	19440672092000	17379	8802	1	0	\N
302340	1874	6279000	17379	8802	2	0	\N
302341	1874	6282000	17379	8802	3	0	\N
302342	1874	6284000	17379	8802	4	0	\N
302343	1874	6286000	17379	8802	5	0	\N
302358	1678	19440672096000	17382	8804	0	0	\N
302359	1678	19440672097000	17382	8804	1	0	\N
302360	1874	6302000	17382	8804	2	0	\N
302361	1874	6305000	17382	8804	3	0	\N
302362	1874	6307000	17382	8804	4	0	\N
302363	1874	6309000	17382	8804	5	0	\N
302368	1678	19440672099000	17385	8806	0	0	\N
302369	1874	6317000	17385	8806	1	0	\N
302370	1874	6319000	17385	8806	2	0	\N
302371	1678	19440672099000	17386	8806	0	0	\N
302372	1874	6317000	17386	8806	1	0	\N
302373	1874	6319000	17386	8806	2	0	\N
302379	1866	9452631301632	17388	8772	0	0	\N
302380	1678	19440672055000	17388	8772	1	0	\N
302381	1678	19440672056000	17388	8772	2	0	\N
302382	1678	19440672057000	17388	8772	3	0	\N
302383	1678	19440672058000	17388	8772	4	0	\N
302384	1678	19440672059000	17388	8772	5	0	\N
302385	1678	19440672060000	17388	8772	6	0	\N
302386	1678	19440672061000	17388	8772	7	0	\N
302387	1678	19440672062000	17388	8772	8	0	\N
302388	1678	19440672063000	17388	8772	9	0	\N
302389	1678	19440672064000	17388	8772	10	0	\N
302390	1678	19440672065000	17388	8772	11	0	\N
302391	1678	19440672066000	17388	8772	12	0	\N
302392	1678	19440672067000	17388	8772	13	0	\N
302393	1678	19440672068000	17388	8772	14	0	\N
302394	1678	19440672069000	17388	8772	15	0	\N
302395	1678	19440672070000	17388	8772	16	0	\N
302396	1678	19440672071000	17388	8772	17	0	\N
302397	1678	19440672072000	17388	8772	18	0	\N
302398	1678	19440672073000	17388	8772	19	0	\N
302399	1678	19440672074000	17388	8772	20	0	\N
302400	1678	19440672075000	17388	8772	21	0	\N
302401	1678	19440672076000	17388	8772	22	0	\N
302402	1678	19440672077000	17388	8772	23	0	\N
302403	1678	19440672078000	17388	8772	24	0	\N
302404	1678	19440672079000	17388	8772	25	0	\N
302405	1678	19440672080000	17388	8772	26	0	\N
302406	1678	19440672081000	17388	8772	27	0	\N
302407	1678	19440672082000	17388	8772	28	0	\N
302408	1678	19440672083000	17388	8772	29	0	\N
302409	1678	19440672084000	17388	8772	30	0	\N
302410	1678	19440672085000	17388	8772	31	0	\N
302411	1678	19440672086000	17388	8772	32	0	\N
302412	1678	19440672087000	17388	8772	33	0	\N
302413	1678	19440672088000	17388	8772	34	0	\N
302414	1678	19440672089000	17388	8772	35	0	\N
302415	1678	19440672090000	17388	8772	36	0	\N
302416	1678	19440672091000	17388	8772	37	0	\N
302417	1678	19440672092000	17388	8772	38	0	\N
302418	1678	19440672093000	17388	8772	39	0	\N
302419	1678	19440672094000	17388	8772	40	0	\N
302420	1678	19440672095000	17388	8772	41	0	\N
302421	1678	19440672096000	17388	8772	42	0	\N
302422	1678	19440672097000	17388	8772	43	0	\N
302423	1678	19440672098000	17388	8772	44	0	\N
302424	1678	19440672099000	17388	8772	45	0	\N
302425	1678	19440672100000	17388	8772	46	0	\N
302426	1678	19440672101000	17388	8772	47	0	\N
302427	1678	19440672102000	17388	8772	48	0	\N
302428	1678	19440672103000	17388	8772	49	0	\N
302429	1678	19440672104000	17388	8772	50	0	\N
302430	2163	1199000000000	17388	8772	51	0	\N
302431	1874	6107000	17388	8772	52	0	\N
302432	1874	6109000	17388	8772	53	0	\N
302433	1874	6111000	17388	8772	54	0	\N
302434	1874	6113000	17388	8772	55	0	\N
302435	1874	6115000	17388	8772	56	0	\N
302436	1874	6117000	17388	8772	57	0	\N
302437	1874	6119000	17388	8772	58	0	\N
302438	1874	6121000	17388	8772	59	0	\N
302439	1874	6123000	17388	8772	60	0	\N
302440	1874	6125000	17388	8772	61	0	\N
302441	1874	6127000	17388	8772	62	0	\N
302442	1874	6129000	17388	8772	63	0	\N
302443	1874	6131000	17388	8772	64	0	\N
302444	1874	6133000	17388	8772	65	0	\N
302445	1874	6135000	17388	8772	66	0	\N
302446	1874	6137000	17388	8772	67	0	\N
302447	1874	6139000	17388	8772	68	0	\N
302448	1874	6141000	17388	8772	69	0	\N
302449	1874	6143000	17388	8772	70	0	\N
302450	1874	6145000	17388	8772	71	0	\N
302451	1874	6147000	17388	8772	72	0	\N
302452	1874	6149000	17388	8772	73	0	\N
302453	1874	6151000	17388	8772	74	0	\N
302454	1874	6153000	17388	8772	75	0	\N
302455	1874	6155000	17388	8772	76	0	\N
302456	1874	6157000	17388	8772	77	0	\N
302457	1874	6159000	17388	8772	78	0	\N
302458	1874	6161000	17388	8772	79	0	\N
302459	1874	6163000	17388	8772	80	0	\N
302460	1874	6165000	17388	8772	81	0	\N
302461	1874	6167000	17388	8772	82	0	\N
302462	1874	6169000	17388	8772	83	0	\N
302463	1874	6171000	17388	8772	84	0	\N
302464	1874	6173000	17388	8772	85	0	\N
302331	1874	6276000	17377	8801	2	0	2
302332	1678	19440672091000	17378	8802	0	0	0
302333	1678	19440672092000	17378	8802	1	0	0
302334	1874	6279000	17378	8802	2	0	2
302335	1874	6282000	17378	8802	3	0	2
302337	1874	6286000	17378	8802	5	0	2
302344	1678	19440672093000	17380	8803	0	0	0
302345	1678	19440672094000	17380	8803	1	0	0
302346	1678	19440672095000	17380	8803	2	0	0
302347	1874	6289000	17380	8803	3	0	2
302349	1874	6293000	17380	8803	5	0	2
302350	1874	6296000	17380	8803	6	0	2
302351	1874	6299000	17380	8803	7	0	2
302352	1678	19440672096000	17381	8804	0	0	0
302354	1874	6302000	17381	8804	2	0	2
302355	1874	6305000	17381	8804	3	0	2
302356	1874	6307000	17381	8804	4	0	2
302357	1874	6309000	17381	8804	5	0	2
302364	1678	19440672098000	17383	8805	0	0	0
302366	1874	6314000	17383	8805	2	0	2
302367	1874	6317000	17384	8806	0	0	2
302374	1678	19440672099000	17387	8807	0	0	0
302375	1678	19440672100000	17387	8807	1	0	0
302376	1874	6319000	17387	8807	2	0	2
302378	1874	6324000	17387	8807	4	0	2
302465	1874	6175000	17388	8772	86	0	\N
302466	1874	6177000	17388	8772	87	0	\N
302467	1874	6179000	17388	8772	88	0	\N
302468	1874	6181000	17388	8772	89	0	\N
302469	1874	6183000	17388	8772	90	0	\N
302470	1874	6185000	17388	8772	91	0	\N
302471	1874	6187000	17388	8772	92	0	\N
302472	1874	6189000	17388	8772	93	0	\N
302473	1874	6191000	17388	8772	94	0	\N
302474	1874	6194000	17388	8772	95	0	\N
302475	1874	6197000	17388	8772	96	0	\N
302476	1874	6200000	17388	8772	97	0	\N
302477	1874	6203000	17388	8772	98	0	\N
302478	1874	6206000	17388	8772	99	0	\N
302479	1874	6209000	17388	8772	100	0	\N
302480	1874	6212000	17388	8772	101	0	\N
302481	1874	6215000	17388	8772	102	0	\N
302482	1874	6218000	17388	8772	103	0	\N
302483	1874	6221000	17388	8772	104	0	\N
302484	1874	6224000	17388	8772	105	0	\N
302485	1874	6227000	17388	8772	106	0	\N
302486	1874	6230000	17388	8772	107	0	\N
302487	1874	6233000	17388	8772	108	0	\N
302488	1874	6236000	17388	8772	109	0	\N
302489	1874	6239000	17388	8772	110	0	\N
302490	1874	6242000	17388	8772	111	0	\N
302491	1874	6245000	17388	8772	112	0	\N
302492	1874	6248000	17388	8772	113	0	\N
302493	1874	6251000	17388	8772	114	0	\N
302494	1874	6254000	17388	8772	115	0	\N
302495	1874	6257000	17388	8772	116	0	\N
302496	1874	6260000	17388	8772	117	0	\N
302497	1874	6263000	17388	8772	118	0	\N
302498	1874	6266000	17388	8772	119	0	\N
302499	1874	6269000	17388	8772	120	0	\N
302500	1874	6272000	17388	8772	121	0	\N
302501	1874	6275000	17388	8772	122	0	\N
302502	1874	6278000	17388	8772	123	0	\N
302503	1874	6281000	17388	8772	125	0	\N
302504	1678	19440672101000	17389	8808	0	0	\N
302505	1678	19440672102000	17389	8808	1	0	\N
302506	1678	19440672103000	17389	8808	2	0	\N
302507	1678	19440672104000	17389	8808	3	0	\N
302508	2163	1199000000000	17389	8808	4	0	\N
302509	1874	6327000	17389	8808	5	0	\N
302510	1874	6330000	17389	8808	6	0	\N
302511	1874	6332000	17389	8808	7	0	\N
302512	1874	6335000	17389	8808	8	0	\N
302513	1874	6337000	17389	8808	9	0	\N
302514	1874	6339000	17389	8808	10	0	\N
302515	1874	6341000	17389	8808	11	0	\N
302528	1866	9452631301632	17391	8644	0	0	\N
302529	1958	3485987000000	17391	8644	1	0	\N
302530	2111	2200000000	17391	8644	2	0	\N
302531	693	66000010000000	17391	8644	3	0	\N
302532	2161	200000000	17391	8644	4	0	\N
302533	2162	200000000	17391	8644	5	0	\N
302534	188	66001000000000	17391	8644	6	0	\N
302535	1678	18720659887000	17391	8644	7	0	\N
302536	1678	18720659888000	17391	8644	8	0	\N
302537	1678	19440672105000	17392	8809	0	0	\N
302538	1678	19440672106000	17392	8809	1	0	\N
302539	849	1158298913161640	17392	8809	2	0	\N
302540	1874	6343000	17392	8809	3	0	\N
302541	1874	6345000	17392	8809	4	0	\N
302542	1874	6348000	17392	8809	5	0	\N
302543	1874	6351000	17392	8809	6	0	\N
302552	1678	19440672107000	17394	8810	0	0	\N
302553	1678	19440672108000	17394	8810	1	0	\N
302554	1874	6356000	17394	8810	2	0	\N
302555	1874	6358000	17394	8810	3	0	\N
302556	1874	6361000	17394	8810	4	0	\N
302582	1678	20160708113000	17399	8813	0	0	\N
302583	1678	20160708114000	17399	8813	1	0	\N
302584	1678	20160708115000	17399	8813	2	0	\N
302585	1874	6381000	17399	8813	3	0	\N
302586	1874	6383000	17399	8813	4	0	\N
302587	1874	6386000	17399	8813	5	0	\N
302588	1874	6389000	17399	8813	6	0	\N
302589	1874	6392000	17399	8813	7	0	\N
302590	1874	6394000	17399	8813	8	0	\N
302591	1678	20160708113000	17400	8813	0	0	\N
302592	1678	20160708114000	17400	8813	1	0	\N
302593	1678	20160708115000	17400	8813	2	0	\N
302594	1874	6381000	17400	8813	3	0	\N
302595	1874	6383000	17400	8813	4	0	\N
302596	1874	6386000	17400	8813	5	0	\N
302597	1874	6389000	17400	8813	6	0	\N
302598	1874	6392000	17400	8813	7	0	\N
302599	1874	6394000	17400	8813	8	0	\N
302600	1874	6396000	17401	8814	0	0	\N
302518	1678	19440672103000	17390	8808	2	0	0
302519	1678	19440672104000	17390	8808	3	0	0
302520	2163	1199000000000	17390	8808	4	0	0
302521	1874	6327000	17390	8808	5	0	2
302522	1874	6330000	17390	8808	6	0	2
302524	1874	6335000	17390	8808	8	0	2
302525	1874	6337000	17390	8808	9	0	2
302526	1874	6339000	17390	8808	10	0	2
302527	1874	6341000	17390	8808	11	0	2
302544	1678	19440672105000	17393	8809	0	0	0
302546	849	1158298913161640	17393	8809	2	0	1
302547	1874	6343000	17393	8809	3	0	2
302548	1874	6345000	17393	8809	4	0	2
302549	1874	6348000	17393	8809	5	0	2
302551	1874	6354000	17393	8809	7	0	2
302557	1678	19440672107000	17395	8810	0	0	0
302558	1678	19440672108000	17395	8810	1	0	0
302559	1874	6356000	17395	8810	2	0	2
302560	1874	6358000	17395	8810	3	0	2
302562	1678	19440672109000	17396	8811	0	0	0
302563	1874	6364000	17396	8811	1	0	2
302564	1678	19440672110000	17397	8812	0	0	0
302565	1678	19440672111000	17397	8812	1	0	0
302566	1678	19440672112000	17397	8812	2	0	0
302568	1874	6369000	17397	8812	5	0	2
302569	1874	6372000	17397	8812	6	0	2
302570	1874	6375000	17397	8812	7	0	2
302571	1874	6377000	17397	8812	8	0	2
302573	1678	20160708113000	17398	8813	0	0	0
302574	1678	20160708114000	17398	8813	1	0	0
302575	1678	20160708115000	17398	8813	2	0	0
302576	1874	6381000	17398	8813	3	0	2
302577	1874	6383000	17398	8813	4	0	2
302579	1874	6389000	17398	8813	6	0	2
302580	1874	6392000	17398	8813	7	0	2
302581	1874	6394000	17398	8813	8	0	2
302601	1874	6399000	17401	8814	1	0	\N
302610	1678	20160708118000	17405	8817	0	0	\N
302611	1874	6411000	17405	8817	1	0	\N
302612	1874	6414000	17405	8817	2	0	\N
302622	1678	20160708119000	17408	8818	0	0	\N
302623	1678	20160708120000	17408	8818	1	0	\N
302624	1874	6416000	17408	8818	2	0	\N
302625	1874	6418000	17408	8818	3	0	\N
302626	1874	6421000	17408	8818	4	0	\N
302627	1874	6424000	17408	8818	5	0	\N
302633	1678	20160708123000	17410	8820	0	0	\N
302634	1874	6434000	17410	8820	1	0	\N
302635	1874	6437000	17410	8820	2	0	\N
302636	1678	20160708123000	17411	8820	0	0	\N
302637	1874	6434000	17411	8820	1	0	\N
302638	1874	6437000	17411	8820	2	0	\N
302642	1678	20160708123000	17413	8820	0	0	\N
302643	1874	6434000	17413	8820	1	0	\N
302644	1874	6437000	17413	8820	2	0	\N
302645	1874	6440000	17414	8821	0	0	\N
302646	1874	6442000	17414	8821	1	0	\N
302647	1874	6440000	17415	8821	0	0	\N
302648	1874	6442000	17415	8821	1	0	\N
302658	1874	6454000	17420	8824	0	0	\N
302659	1874	6457000	17420	8824	1	0	\N
302660	1678	20160708124000	17421	8825	0	0	\N
302661	1678	20160708125000	17421	8825	1	0	\N
302662	1874	6459000	17421	8825	2	0	\N
302663	1874	6462000	17421	8825	3	0	\N
302664	1874	6465000	17421	8825	4	0	\N
302665	1874	6467000	17421	8825	5	0	\N
302672	1678	20160708124000	17423	8825	0	0	\N
302673	1678	20160708125000	17423	8825	1	0	\N
302674	1874	6459000	17423	8825	2	0	\N
302675	1874	6462000	17423	8825	3	0	\N
302676	1874	6465000	17423	8825	4	0	\N
302677	1874	6467000	17423	8825	5	0	\N
302682	928	505332697819092	17425	8826	0	0	\N
302683	928	505508850559092	17425	8826	1	0	\N
302684	1678	20160708126000	17425	8826	2	0	\N
302685	1874	6470000	17425	8826	3	0	\N
302694	1678	20160708129000	17427	8828	0	0	\N
302695	1874	6483000	17427	8828	1	0	\N
302705	1678	20160708131000	17431	8830	0	0	\N
302706	1516	593364520000	17431	8830	1	0	\N
302707	1874	6491000	17431	8830	2	0	\N
302708	1874	6493000	17431	8830	3	0	\N
302709	1866	9452631301632	17432	8766	0	0	\N
302710	1678	19440672048000	17432	8766	1	0	\N
302711	1516	1298566290000	17432	8766	2	0	\N
302712	1678	19440672049000	17432	8766	3	0	\N
302713	1678	19440672050000	17432	8766	4	0	\N
302714	1678	19440672051000	17432	8766	5	0	\N
302715	1678	19440672052000	17432	8766	6	0	\N
302716	1678	19440672053000	17432	8766	7	0	\N
302717	1678	19440672054000	17432	8766	8	0	\N
302718	1516	1474719030000	17432	8766	9	0	\N
302719	1678	19440672055000	17432	8766	10	0	\N
302720	1678	19440672056000	17432	8766	11	0	\N
302721	1678	19440672057000	17432	8766	12	0	\N
302722	1678	19440672058000	17432	8766	13	0	\N
302723	1678	19440672059000	17432	8766	14	0	\N
302724	1678	19440672060000	17432	8766	15	0	\N
302725	1678	19440672061000	17432	8766	16	0	\N
302726	1678	19440672062000	17432	8766	17	0	\N
302727	1678	19440672063000	17432	8766	18	0	\N
302728	1678	19440672064000	17432	8766	19	0	\N
302729	1678	19440672065000	17432	8766	20	0	\N
302730	1678	19440672066000	17432	8766	21	0	\N
302731	1678	19440672067000	17432	8766	22	0	\N
302732	1678	19440672068000	17432	8766	23	0	\N
302733	1678	19440672069000	17432	8766	24	0	\N
302734	1678	19440672070000	17432	8766	25	0	\N
302735	1678	19440672071000	17432	8766	26	0	\N
302736	1678	19440672072000	17432	8766	27	0	\N
302604	1678	20160708116000	17403	8815	0	0	0
302605	1874	6401000	17403	8815	1	0	2
302606	1874	6404000	17403	8815	2	0	2
302607	1678	20160708117000	17404	8816	0	0	0
302608	1874	6406000	17404	8816	1	0	2
302613	1678	20160708118000	17406	8817	0	0	0
302614	1874	6411000	17406	8817	1	0	2
302615	1874	6414000	17406	8817	2	0	2
302616	1678	20160708119000	17407	8818	0	0	0
302617	1678	20160708120000	17407	8818	1	0	0
302619	1874	6418000	17407	8818	3	0	2
302620	1874	6421000	17407	8818	4	0	2
302621	1874	6424000	17407	8818	5	0	2
302628	1678	20160708121000	17409	8819	0	0	0
302630	1874	6427000	17409	8819	2	0	2
302631	1874	6430000	17409	8819	3	0	2
302632	1874	6432000	17409	8819	4	0	2
302639	1678	20160708123000	17412	8820	0	0	0
302640	1874	6434000	17412	8820	1	0	2
302649	1874	6440000	17416	8821	0	0	2
302650	1874	6442000	17416	8821	1	0	2
302651	1874	6444000	17417	8822	0	0	2
302652	1874	6447000	17417	8822	1	0	2
302653	1516	1298566290000	17418	8823	0	0	7
302655	1874	6452000	17418	8823	2	0	2
302656	1874	6454000	17419	8824	0	0	2
302657	1874	6457000	17419	8824	1	0	2
302666	1678	20160708124000	17422	8825	0	0	0
302668	1874	6459000	17422	8825	2	0	2
302669	1874	6462000	17422	8825	3	0	2
302670	1874	6465000	17422	8825	4	0	2
302671	1874	6467000	17422	8825	5	0	2
302678	928	505332697819092	17424	8826	0	0	0
302680	1678	20160708126000	17424	8826	2	0	0
302681	1874	6470000	17424	8826	3	0	2
302686	1048	905551785610448	17426	8827	0	0	0
302687	1168	610993866670622	17426	8827	1	0	0
302688	1678	20160708127000	17426	8827	2	0	0
302690	1874	6473000	17426	8827	4	0	2
302691	1874	6476000	17426	8827	5	0	2
302692	1874	6478000	17426	8827	6	0	2
302693	1874	6480000	17426	8827	7	0	2
302697	1874	6483000	17428	8828	1	0	2
302698	1678	20160708130000	17429	8829	0	0	0
302699	1874	6485000	17429	8829	1	0	2
302700	1874	6488000	17429	8829	2	0	2
302701	1678	20160708131000	17430	8830	0	0	0
302703	1874	6491000	17430	8830	2	0	2
302704	1874	6493000	17430	8830	3	0	2
302737	1678	19440672073000	17432	8766	28	0	\N
302738	1678	19440672074000	17432	8766	30	0	\N
302739	1678	19440672075000	17432	8766	31	0	\N
302740	1678	19440672076000	17432	8766	32	0	\N
302741	1678	19440672077000	17432	8766	33	0	\N
302742	1678	19440672078000	17432	8766	34	0	\N
302743	1678	19440672079000	17432	8766	35	0	\N
302744	1678	19440672080000	17432	8766	36	0	\N
302745	1678	19440672081000	17432	8766	37	0	\N
302746	1678	19440672082000	17432	8766	38	0	\N
302747	1678	19440672083000	17432	8766	39	0	\N
302748	1678	19440672084000	17432	8766	40	0	\N
302749	1678	19440672085000	17432	8766	41	0	\N
302750	1678	19440672086000	17432	8766	42	0	\N
302751	1678	19440672087000	17432	8766	43	0	\N
302752	1678	19440672088000	17432	8766	44	0	\N
302753	1678	19440672089000	17432	8766	45	0	\N
302754	1678	19440672090000	17432	8766	46	0	\N
302755	1678	19440672091000	17432	8766	47	0	\N
302756	1678	19440672092000	17432	8766	48	0	\N
302757	1678	19440672093000	17432	8766	49	0	\N
302758	1678	19440672094000	17432	8766	50	0	\N
302759	1678	19440672095000	17432	8766	51	0	\N
302760	1678	19440672096000	17432	8766	52	0	\N
302761	1678	19440672097000	17432	8766	53	0	\N
302762	1678	19440672098000	17432	8766	54	0	\N
302763	1678	19440672099000	17432	8766	55	0	\N
302764	1678	19440672100000	17432	8766	56	0	\N
302765	1678	19440672101000	17432	8766	57	0	\N
302766	1678	19440672102000	17432	8766	58	0	\N
302767	1678	19440672103000	17432	8766	59	0	\N
302768	1678	19440672104000	17432	8766	60	0	\N
302769	1678	19440672105000	17432	8766	61	0	\N
302770	1678	19440672106000	17432	8766	62	0	\N
302771	1678	19440672107000	17432	8766	63	0	\N
302772	1678	19440672108000	17432	8766	64	0	\N
302773	1678	19440672109000	17432	8766	65	0	\N
302774	1678	19440672110000	17432	8766	66	0	\N
302775	1678	19440672111000	17432	8766	67	0	\N
302776	1678	19440672112000	17432	8766	68	0	\N
302777	1678	19440672113000	17432	8766	69	0	\N
302778	1678	19440672114000	17432	8766	70	0	\N
302779	1678	19440672115000	17432	8766	71	0	\N
302780	1678	19440672116000	17432	8766	72	0	\N
302781	1678	19440672117000	17432	8766	73	0	\N
302782	1678	19440672118000	17432	8766	74	0	\N
302783	1678	19440672119000	17432	8766	75	0	\N
302784	1678	19440672120000	17432	8766	76	0	\N
302785	1678	19440672121000	17432	8766	77	0	\N
302786	1678	19440672122000	17432	8766	78	0	\N
302787	1678	19440672123000	17432	8766	79	0	\N
302788	1678	19440672124000	17432	8766	80	0	\N
302789	1678	19440672125000	17432	8766	81	0	\N
302790	1678	19440672126000	17432	8766	82	0	\N
302791	1678	19440672127000	17432	8766	83	0	\N
302792	1678	19440672128000	17432	8766	84	0	\N
302793	1678	19440672129000	17432	8766	85	0	\N
302794	1678	19440672130000	17432	8766	86	0	\N
302795	1678	19440672131000	17432	8766	87	0	\N
302796	2163	1199000000000	17432	8766	88	0	\N
302797	1874	6075000	17432	8766	89	0	\N
302798	1874	6077000	17432	8766	90	0	\N
302799	1874	6079000	17432	8766	91	0	\N
302800	1874	6081000	17432	8766	92	0	\N
302801	1874	6083000	17432	8766	93	0	\N
302802	1874	6085000	17432	8766	94	0	\N
302803	1874	6087000	17432	8766	95	0	\N
302804	1874	6089000	17432	8766	96	0	\N
302805	1874	6091000	17432	8766	97	0	\N
302806	1874	6093000	17432	8766	98	0	\N
302807	1874	6095000	17432	8766	99	0	\N
302808	1874	6097000	17432	8766	100	0	\N
302809	1874	6099000	17432	8766	101	0	\N
302810	849	1158298913161640	17432	8766	102	0	\N
302811	1874	6102000	17432	8766	103	0	\N
302812	1874	6105000	17432	8766	104	0	\N
302813	1874	6108000	17432	8766	105	0	\N
302814	1874	6111000	17432	8766	106	0	\N
302815	1874	6114000	17432	8766	107	0	\N
302816	1874	6116000	17432	8766	108	0	\N
302817	1874	6118000	17432	8766	109	0	\N
302818	1874	6120000	17432	8766	110	0	\N
302819	1874	6122000	17432	8766	111	0	\N
302820	1874	6124000	17432	8766	112	0	\N
302821	1874	6126000	17432	8766	113	0	\N
302822	1874	6128000	17432	8766	114	0	\N
302823	1874	6130000	17432	8766	115	0	\N
302824	1874	6132000	17432	8766	116	0	\N
302825	1874	6134000	17432	8766	117	0	\N
302826	1874	6136000	17432	8766	118	0	\N
302827	1874	6138000	17432	8766	119	0	\N
302828	1874	6140000	17432	8766	120	0	\N
302829	1874	6142000	17432	8766	121	0	\N
302830	1874	6144000	17432	8766	122	0	\N
302831	1874	6146000	17432	8766	123	0	\N
302832	1874	6148000	17432	8766	124	0	\N
302833	1874	6150000	17432	8766	125	0	\N
302834	1678	20160708132000	17433	8831	0	0	\N
302835	1874	6496000	17433	8831	1	0	\N
302836	1874	6498000	17433	8831	2	0	\N
302840	1678	20160708132000	17435	8831	0	0	\N
302841	1874	6496000	17435	8831	1	0	\N
302842	1874	6498000	17435	8831	2	0	\N
302846	1294	1702588557365879	17437	8832	0	0	\N
302847	1678	20160708133000	17437	8832	1	0	\N
302848	1874	6501000	17437	8832	2	0	\N
302849	1678	20160708134000	17438	8833	0	0	\N
302850	1678	20160708135000	17438	8833	1	0	\N
302851	1874	6503000	17438	8833	2	0	\N
302852	1874	6505000	17438	8833	3	0	\N
302853	1874	6508000	17438	8833	5	0	\N
302854	1874	6511000	17438	8833	6	0	\N
302855	1678	20160708134000	17439	8833	0	0	\N
302856	1678	20160708135000	17439	8833	1	0	\N
302857	1874	6503000	17439	8833	2	0	\N
302858	1874	6505000	17439	8833	3	0	\N
302859	1874	6508000	17439	8833	5	0	\N
302860	1874	6511000	17439	8833	6	0	\N
302861	1678	20160708134000	17440	8833	0	0	\N
302862	1678	20160708135000	17440	8833	1	0	\N
302863	1874	6503000	17440	8833	2	0	\N
302864	1874	6505000	17440	8833	3	0	\N
302865	1874	6508000	17440	8833	5	0	\N
302866	1874	6511000	17440	8833	6	0	\N
302839	1874	6498000	17434	8831	2	0	2
302843	1294	1702588557365879	17436	8832	0	0	0
302844	1678	20160708133000	17436	8832	1	0	0
302845	1874	6501000	17436	8832	2	0	2
302867	1678	20160708134000	17441	8833	0	0	0
302869	1874	6503000	17441	8833	2	0	2
302870	1874	6505000	17441	8833	3	0	2
302871	1874	6508000	17441	8833	5	0	2
302872	1874	6511000	17441	8833	6	0	2
302873	1678	20160708134000	17442	8833	0	0	\N
302874	1678	20160708135000	17442	8833	1	0	\N
302875	1874	6503000	17442	8833	2	0	\N
302876	1874	6505000	17442	8833	3	0	\N
302877	1874	6508000	17442	8833	5	0	\N
302878	1874	6511000	17442	8833	6	0	\N
302879	1678	20160708134000	17443	8833	0	0	\N
302880	1678	20160708135000	17443	8833	1	0	\N
302881	1874	6503000	17443	8833	2	0	\N
302882	1874	6505000	17443	8833	3	0	\N
302883	1874	6508000	17443	8833	5	0	\N
302884	1874	6511000	17443	8833	6	0	\N
302887	1678	20160708137000	17445	8835	0	0	\N
302888	1678	20160708138000	17445	8835	1	0	\N
302889	1874	6517000	17445	8835	2	0	\N
302890	1874	6520000	17445	8835	3	0	\N
302891	1874	6522000	17445	8835	4	0	\N
302892	1874	6524000	17445	8835	5	0	\N
302899	1678	20160708137000	17447	8835	0	0	\N
302900	1678	20160708138000	17447	8835	1	0	\N
302901	1874	6517000	17447	8835	2	0	\N
302902	1874	6520000	17447	8835	3	0	\N
302903	1874	6522000	17447	8835	4	0	\N
302904	1874	6524000	17447	8835	5	0	\N
302907	1678	20160708139000	17449	8836	0	0	\N
302908	1874	6527000	17449	8836	1	0	\N
302927	1866	9452631301632	17451	8568	0	0	\N
302928	2164	500000000	17451	8568	1	0	\N
302929	1958	3485987000000	17451	8568	2	0	\N
302930	1678	18720659880000	17451	8568	3	0	\N
302931	1678	18720659881000	17451	8568	4	0	\N
302932	352	66613938193897	17451	8568	5	0	\N
302933	600	66613938193897	17451	8568	6	0	\N
302934	620	66613938193897	17451	8568	7	0	\N
302935	1150	613559297664572	17451	8568	8	0	\N
302936	1811	1675947484894	17451	8568	9	0	\N
302937	84	66613938193897	17451	8568	10	0	\N
302938	2017	612537528296	17451	8568	11	0	\N
302939	1516	1298566290000	17451	8568	12	0	\N
302940	2160	200000000	17451	8568	13	0	\N
302941	520	66613938193897	17451	8568	14	0	\N
302942	89	66613938193897	17451	8568	15	0	\N
302943	186	66613938193897	17451	8568	16	0	\N
302944	383	66613938193897	17451	8568	17	0	\N
302945	1678	18720659882000	17451	8568	18	0	\N
302946	2111	2200000000	17451	8568	19	0	\N
302947	693	66000010000000	17451	8568	20	0	\N
302948	2161	200000000	17451	8568	21	0	\N
302949	2162	200000000	17451	8568	22	0	\N
302950	1678	18720659883000	17451	8568	23	0	\N
302951	1678	18720659884000	17451	8568	24	0	\N
302952	1678	18720659885000	17451	8568	25	0	\N
302953	1678	18720659886000	17451	8568	26	0	\N
302954	188	66001000000000	17451	8568	27	0	\N
302955	1678	18720659887000	17451	8568	28	0	\N
302956	1678	18720659888000	17451	8568	29	0	\N
302957	1678	18720659889000	17451	8568	30	0	\N
302958	1678	18720659890000	17451	8568	31	0	\N
302959	1678	18720659891000	17451	8568	32	0	\N
302960	1678	18720659892000	17451	8568	33	0	\N
302961	1678	18720659893000	17451	8568	34	0	\N
302962	1678	18720659894000	17451	8568	35	0	\N
302963	1678	18720659895000	17451	8568	36	0	\N
302964	1678	18720659896000	17451	8568	37	0	\N
302965	1678	18720659897000	17451	8568	38	0	\N
302966	1678	18720659898000	17451	8568	39	0	\N
302967	1678	18720659899000	17451	8568	40	0	\N
302968	1678	18720659900000	17451	8568	41	0	\N
302969	1678	18720659901000	17451	8568	42	0	\N
302970	1678	18720659902000	17451	8568	43	0	\N
302971	1678	18720659903000	17451	8568	44	0	\N
302972	1516	1474719030000	17451	8568	45	0	\N
302973	1678	18720659904000	17451	8568	47	0	\N
302974	1678	18720659905000	17451	8568	48	0	\N
302975	1678	18720659906000	17451	8568	49	0	\N
302976	1678	18720659907000	17451	8568	50	0	\N
302977	1678	18720659908000	17451	8568	51	0	\N
302978	1678	18720659909000	17451	8568	52	0	\N
302979	1678	18720659910000	17451	8568	53	0	\N
302980	1678	18720659911000	17451	8568	54	0	\N
302981	1678	18720659912000	17451	8568	55	0	\N
302982	1678	18720659913000	17451	8568	56	0	\N
302983	1678	18720659914000	17451	8568	57	0	\N
302984	1678	18720659915000	17451	8568	58	0	\N
302985	1678	18720659916000	17451	8568	59	0	\N
302986	1678	18720659917000	17451	8568	60	0	\N
302987	1505	0	17451	8568	61	0	\N
302988	1678	18720659918000	17451	8568	62	0	\N
302989	1678	18720659919000	17451	8568	63	0	\N
302990	1678	18720659920000	17451	8568	64	0	\N
302991	1678	18720659921000	17451	8568	65	0	\N
302992	1678	18720659922000	17451	8568	66	0	\N
302993	1678	18720659923000	17451	8568	67	0	\N
302994	1678	18720659924000	17451	8568	68	0	\N
302995	1678	18720659925000	17451	8568	69	0	\N
302996	1678	18720659926000	17451	8568	70	0	\N
302997	1678	18720659927000	17451	8568	71	0	\N
302998	1678	18720659928000	17451	8568	72	0	\N
302999	1678	18720659929000	17451	8568	73	0	\N
303000	1678	18720659930000	17451	8568	74	0	\N
303001	1678	18720659931000	17451	8568	75	0	\N
303002	1678	18720659932000	17451	8568	76	0	\N
303003	1678	18720659933000	17451	8568	77	0	\N
303004	1678	18720659934000	17451	8568	78	0	\N
303005	1678	18720659935000	17451	8568	79	0	\N
303006	1678	18720659936000	17451	8568	80	0	\N
303007	1678	18720659937000	17451	8568	81	0	\N
303008	1678	18720659938000	17451	8568	82	0	\N
302893	1678	20160708137000	17446	8835	0	0	0
302894	1678	20160708138000	17446	8835	1	0	0
302895	1874	6517000	17446	8835	2	0	2
302896	1874	6520000	17446	8835	3	0	2
302897	1874	6522000	17446	8835	4	0	2
302905	1678	20160708139000	17448	8836	0	0	0
302906	1874	6527000	17448	8836	1	0	2
302909	2164	500000000	17450	8837	0	0	0
302910	352	66613938193897	17450	8837	1	0	0
302911	600	66613938193897	17450	8837	2	0	0
302913	1150	613559297664572	17450	8837	4	0	0
302914	1811	1675947484894	17450	8837	5	0	1
302915	84	66613938193897	17450	8837	6	0	0
302916	2017	612537528296	17450	8837	7	0	2
302918	89	66613938193897	17450	8837	9	0	0
302919	186	66613938193897	17450	8837	10	0	0
302920	383	66613938193897	17450	8837	11	0	0
302921	1678	20160708140000	17450	8837	12	0	0
302922	1678	20160708141000	17450	8837	13	0	0
302924	1874	6532000	17450	8837	15	0	2
302925	1874	6534000	17450	8837	16	0	2
302926	1874	6537000	17450	8837	17	0	2
303009	1678	18720659939000	17451	8568	83	0	\N
303010	1678	18720659940000	17451	8568	84	0	\N
303011	1678	18720659941000	17451	8568	85	0	\N
303012	1678	18720659942000	17451	8568	86	0	\N
303013	1678	18720659943000	17451	8568	87	0	\N
303014	1678	18720659944000	17451	8568	88	0	\N
303015	1678	18720659945000	17451	8568	89	0	\N
303016	1678	18720659946000	17451	8568	90	0	\N
303017	1678	18720659947000	17451	8568	91	0	\N
303018	1678	18720659948000	17451	8568	92	0	\N
303019	1678	18720659949000	17451	8568	93	0	\N
303020	1678	18720659950000	17451	8568	94	0	\N
303021	1678	18720659951000	17451	8568	95	0	\N
303022	1678	18720659952000	17451	8568	96	0	\N
303023	1678	18720659953000	17451	8568	97	0	\N
303024	1678	18720659954000	17451	8568	98	0	\N
303025	1678	18720659955000	17451	8568	99	0	\N
303026	1678	18720659956000	17451	8568	100	0	\N
303027	1678	18720659957000	17451	8568	101	0	\N
303028	1678	18720659958000	17451	8568	102	0	\N
303029	1678	18720659959000	17451	8568	103	0	\N
303030	1678	18720659960000	17451	8568	104	0	\N
303031	1678	18720659961000	17451	8568	105	0	\N
303032	1678	18720659962000	17451	8568	106	0	\N
303033	1678	18720659963000	17451	8568	107	0	\N
303034	1678	18720659964000	17451	8568	108	0	\N
303035	1678	18720659965000	17451	8568	109	0	\N
303036	1678	18720659966000	17451	8568	110	0	\N
303037	1678	18720659967000	17451	8568	111	0	\N
303038	1678	18720659968000	17451	8568	112	0	\N
303039	1678	18720659969000	17451	8568	113	0	\N
303040	1678	18720659970000	17451	8568	114	0	\N
303041	1678	18720659971000	17451	8568	115	0	\N
303042	1678	18720659972000	17451	8568	116	0	\N
303043	1678	18720659973000	17451	8568	117	0	\N
303044	1678	18720659974000	17451	8568	118	0	\N
303045	1678	18720659975000	17451	8568	119	0	\N
303046	1678	18720659976000	17451	8568	120	0	\N
303047	1678	18720659977000	17451	8568	121	0	\N
303048	1678	18720659978000	17451	8568	122	0	\N
303049	1678	18720659979000	17451	8568	123	0	\N
303050	1678	18720659980000	17451	8568	124	0	\N
303051	1678	18720659981000	17451	8568	125	0	\N
303065	1678	20160708143000	17454	8839	0	0	\N
303066	91	66613938193897	17454	8839	1	0	\N
303067	438	66613938193897	17454	8839	2	0	\N
303068	593	66612937193897	17454	8839	3	0	\N
303069	408	66613938193897	17454	8839	4	0	\N
303070	601	66613938193897	17454	8839	5	0	\N
303071	1874	6542000	17454	8839	6	0	\N
303099	92	66613938193897	17457	8841	0	0	\N
303100	150	66613938193897	17457	8841	1	0	\N
303101	1678	20160708145000	17457	8841	2	0	\N
303102	1678	20160708146000	17457	8841	3	0	\N
303103	373	66613938193897	17457	8841	4	0	\N
303104	1678	20160708147000	17457	8841	5	0	\N
303105	1678	20160708148000	17457	8841	6	0	\N
303106	2164	529600000000	17457	8841	7	0	\N
303107	322	66613938193897	17457	8841	8	0	\N
303108	453	66613938193897	17457	8841	9	0	\N
303109	450	66613938193897	17457	8841	10	0	\N
303110	395	66110897193897	17457	8841	11	0	\N
303111	29	7065114656873	17457	8841	12	0	\N
303112	138	66613938193897	17457	8841	13	0	\N
303113	910	507454463072188	17457	8841	14	0	\N
303114	500	66613938193897	17457	8841	15	0	\N
303115	146	66613938193897	17457	8841	16	0	\N
303116	504	66613938193897	17457	8841	17	0	\N
303117	587	66613938193897	17457	8841	18	0	\N
303118	1961	612850369124	17457	8841	19	0	\N
303119	611	66613938193897	17457	8841	20	0	\N
303120	205	66613938193897	17457	8841	21	0	\N
303121	658	66613938193897	17457	8841	22	0	\N
303122	78	66613938193897	17457	8841	23	0	\N
303123	660	66613938193897	17457	8841	24	0	\N
303124	1276	1709737537593210	17457	8841	25	0	\N
303125	194	66613938193897	17457	8841	26	0	\N
303126	105	66613938193897	17457	8841	27	0	\N
303127	1874	6549000	17457	8841	28	0	\N
303128	1874	6551000	17457	8841	29	0	\N
303129	1874	6553000	17457	8841	30	0	\N
303130	1874	6556000	17457	8841	31	0	\N
303131	1874	6559000	17457	8841	32	0	\N
303132	1874	6561000	17457	8841	33	0	\N
303133	1874	6564000	17457	8841	34	0	\N
303134	1874	6567000	17457	8841	35	0	\N
303135	92	66613938193897	17458	8841	0	0	\N
303136	150	66613938193897	17458	8841	1	0	\N
303137	1678	20160708145000	17458	8841	2	0	\N
303138	1678	20160708146000	17458	8841	3	0	\N
303139	373	66613938193897	17458	8841	4	0	\N
303140	1678	20160708147000	17458	8841	5	0	\N
303141	1678	20160708148000	17458	8841	6	0	\N
303142	2164	529600000000	17458	8841	7	0	\N
303143	322	66613938193897	17458	8841	8	0	\N
303144	453	66613938193897	17458	8841	9	0	\N
303054	308	66613938193897	17452	8838	2	0	0
303055	551	66613938193897	17452	8838	3	0	0
303056	678	66613938193897	17452	8838	4	0	0
303057	1874	6540000	17452	8838	5	0	2
303058	1678	20160708143000	17453	8839	0	0	0
303060	438	66613938193897	17453	8839	2	0	0
303061	593	66612937193897	17453	8839	3	0	1
303062	408	66613938193897	17453	8839	4	0	0
303063	601	66613938193897	17453	8839	5	0	0
303064	1874	6542000	17453	8839	6	0	2
303073	691	66613938193897	17455	8840	1	0	0
303074	339	66613938193897	17455	8840	2	0	0
303075	745	2018604187613	17455	8840	3	0	0
303076	63	66613938193897	17455	8840	4	0	0
303078	1874	6544000	17455	8840	6	0	2
303079	1874	6547000	17455	8840	7	0	2
303080	92	66613938193897	17456	8841	0	0	0
303081	150	66613938193897	17456	8841	1	0	0
303082	1678	20160708145000	17456	8841	2	0	0
303084	373	66613938193897	17456	8841	4	0	0
303085	2164	529600000000	17456	8841	5	0	0
303086	322	66613938193897	17456	8841	6	0	0
303087	453	66613938193897	17456	8841	7	0	0
303088	450	66613938193897	17456	8841	8	0	0
303090	29	7065114656873	17456	8841	10	0	0
303091	138	66613938193897	17456	8841	11	0	0
303092	910	507454463072188	17456	8841	12	0	0
303093	500	66613938193897	17456	8841	13	0	0
303095	1874	6549000	17456	8841	15	0	2
303096	1874	6551000	17456	8841	16	0	2
303097	1874	6554000	17456	8841	17	0	2
303098	1874	6557000	17456	8841	18	0	2
303145	450	66613938193897	17458	8841	10	0	\N
303146	395	66110897193897	17458	8841	11	0	\N
303147	29	7065114656873	17458	8841	12	0	\N
303148	138	66613938193897	17458	8841	13	0	\N
303149	910	507454463072188	17458	8841	14	0	\N
303150	500	66613938193897	17458	8841	15	0	\N
303151	146	66613938193897	17458	8841	16	0	\N
303152	504	66613938193897	17458	8841	17	0	\N
303153	587	66613938193897	17458	8841	18	0	\N
303154	1961	612850369124	17458	8841	19	0	\N
303155	611	66613938193897	17458	8841	20	0	\N
303156	205	66613938193897	17458	8841	21	0	\N
303157	658	66613938193897	17458	8841	22	0	\N
303158	78	66613938193897	17458	8841	23	0	\N
303159	660	66613938193897	17458	8841	24	0	\N
303160	1276	1709737537593210	17458	8841	25	0	\N
303161	194	66613938193897	17458	8841	26	0	\N
303162	105	66613938193897	17458	8841	27	0	\N
303163	1874	6549000	17458	8841	28	0	\N
303164	1874	6551000	17458	8841	29	0	\N
303165	1874	6553000	17458	8841	30	0	\N
303166	1874	6556000	17458	8841	31	0	\N
303167	1874	6559000	17458	8841	32	0	\N
303168	1874	6561000	17458	8841	33	0	\N
303169	1874	6564000	17458	8841	34	0	\N
303170	1874	6567000	17458	8841	35	0	\N
303197	122	66613938193897	17461	8843	0	0	\N
303198	622	66616918193897	17461	8843	1	0	\N
303199	653	66613938193897	17461	8843	2	0	\N
303200	304	66613938193897	17461	8843	3	0	\N
303201	206	66613938193897	17461	8843	4	0	\N
303202	399	66613938193897	17461	8843	5	0	\N
303203	1678	20160708149000	17461	8843	6	0	\N
303204	1874	6569000	17461	8843	7	0	\N
303205	1874	6572000	17461	8843	8	0	\N
303206	1678	20160708147000	17462	8842	0	0	\N
303207	1678	20160708148000	17462	8842	1	0	\N
303208	504	66613938193897	17462	8842	2	0	\N
303209	587	66613938193897	17462	8842	3	0	\N
303210	1961	612850369124	17462	8842	4	0	\N
303211	611	66613938193897	17462	8842	5	0	\N
303212	205	66613938193897	17462	8842	6	0	\N
303213	658	66613938193897	17462	8842	7	0	\N
303214	78	66613938193897	17462	8842	8	0	\N
303215	660	66613938193897	17462	8842	9	0	\N
303216	1276	1709737537593210	17462	8842	10	0	\N
303217	194	66613938193897	17462	8842	11	0	\N
303218	105	66613938193897	17462	8842	12	0	\N
303219	122	66613938193897	17462	8842	13	0	\N
303220	622	66616918193897	17462	8842	14	0	\N
303221	653	66613938193897	17462	8842	15	0	\N
303222	304	66613938193897	17462	8842	16	0	\N
303223	206	66613938193897	17462	8842	17	0	\N
303224	1874	6559000	17462	8842	18	0	\N
303225	1874	6561000	17462	8842	19	0	\N
303226	1874	6563000	17462	8842	20	0	\N
303227	1874	6566000	17462	8842	21	0	\N
303228	1874	6569000	17462	8842	22	0	\N
303229	1874	6572000	17462	8842	23	0	\N
303230	1678	20160708147000	17463	8842	0	0	\N
303231	1678	20160708148000	17463	8842	1	0	\N
303232	1678	20160708149000	17463	8842	2	0	\N
303233	504	66613938193897	17463	8842	3	0	\N
303234	587	66613938193897	17463	8842	4	0	\N
303235	1961	612850369124	17463	8842	5	0	\N
303236	611	66613938193897	17463	8842	6	0	\N
303237	205	66613938193897	17463	8842	7	0	\N
303238	658	66613938193897	17463	8842	8	0	\N
303239	78	66613938193897	17463	8842	9	0	\N
303240	660	66613938193897	17463	8842	10	0	\N
303241	1276	1709737537593210	17463	8842	11	0	\N
303242	194	66613938193897	17463	8842	12	0	\N
303243	105	66613938193897	17463	8842	13	0	\N
303244	122	66613938193897	17463	8842	14	0	\N
303245	622	66616918193897	17463	8842	15	0	\N
303246	653	66613938193897	17463	8842	16	0	\N
303247	304	66613938193897	17463	8842	17	0	\N
303248	206	66613938193897	17463	8842	18	0	\N
303249	1874	6559000	17463	8842	19	0	\N
303250	1874	6561000	17463	8842	20	0	\N
303251	1874	6563000	17463	8842	21	0	\N
303252	1874	6566000	17463	8842	22	0	\N
303253	1874	6569000	17463	8842	23	0	\N
303254	1874	6572000	17463	8842	24	0	\N
303255	54	66613938193897	17464	8844	0	0	\N
303256	710	5046510469181	17464	8844	1	0	\N
303257	499	66613938193897	17464	8844	2	0	\N
303258	721	2018604187613	17464	8844	3	0	\N
303259	103	66613938193897	17464	8844	4	0	\N
303260	217	66613938193897	17464	8844	5	0	\N
303261	1678	20160708150000	17464	8844	6	0	\N
303262	1678	20160708151000	17464	8844	7	0	\N
303263	893	309677012160129	17464	8844	8	0	\N
303264	251	66613938193897	17464	8844	10	0	\N
303265	1874	6574000	17464	8844	11	0	\N
303266	1874	6577000	17464	8844	12	0	\N
303267	1874	6580000	17464	8844	13	0	\N
303273	1866	9452631301632	17466	8745	0	0	\N
303274	2164	500000000	17466	8745	1	0	\N
303275	352	66613938193897	17466	8745	2	0	\N
303276	600	66613938193897	17466	8745	3	0	\N
303277	620	66613938193897	17466	8745	4	0	\N
303278	1150	613559297664572	17466	8745	5	0	\N
303279	1811	1675947484894	17466	8745	6	0	\N
303280	84	66613938193897	17466	8745	7	0	\N
303173	504	66613938193897	17459	8842	2	0	0
303174	587	66613938193897	17459	8842	3	0	0
303175	1961	612850369124	17459	8842	4	0	1
303176	611	66613938193897	17459	8842	5	0	0
303177	205	66613938193897	17459	8842	6	0	0
303179	78	66613938193897	17459	8842	8	0	0
303180	660	66613938193897	17459	8842	9	0	0
303181	1276	1709737537593210	17459	8842	10	0	0
303182	194	66613938193897	17459	8842	11	0	0
303183	105	66613938193897	17459	8842	12	0	0
303185	1874	6561000	17459	8842	14	0	2
303186	1874	6564000	17459	8842	15	0	2
303187	1874	6567000	17459	8842	16	0	2
303188	122	66613938193897	17460	8843	0	0	0
303190	653	66613938193897	17460	8843	2	0	0
303191	304	66613938193897	17460	8843	3	0	0
303192	206	66613938193897	17460	8843	4	0	0
303193	399	66613938193897	17460	8843	5	0	0
303194	1678	20160708149000	17460	8843	6	0	0
303196	1874	6572000	17460	8843	8	0	2
303268	1678	20160708150000	17465	8844	0	0	0
303269	1678	20160708151000	17465	8844	1	0	0
303270	1874	6574000	17465	8844	2	0	2
303271	1874	6577000	17465	8844	3	0	2
303281	2017	612537528296	17466	8745	8	0	\N
303282	1516	1298566290000	17466	8745	9	0	\N
303283	1678	19440672017000	17466	8745	10	0	\N
303284	1678	19440672018000	17466	8745	11	0	\N
303285	1678	19440672019000	17466	8745	12	0	\N
303286	1678	19440672020000	17466	8745	13	0	\N
303287	1678	19440672021000	17466	8745	14	0	\N
303288	1678	19440672022000	17466	8745	15	0	\N
303289	520	66613938193897	17466	8745	16	0	\N
303290	89	66613938193897	17466	8745	17	0	\N
303291	186	66613938193897	17466	8745	18	0	\N
303292	383	66613938193897	17466	8745	19	0	\N
303293	392	66613938193897	17466	8745	20	0	\N
303294	308	66613938193897	17466	8745	21	0	\N
303295	551	66613938193897	17466	8745	22	0	\N
303296	2164	529600000000	17466	8745	23	0	\N
303297	678	66613938193897	17466	8745	24	0	\N
303298	91	66613938193897	17466	8745	25	0	\N
303299	438	66613938193897	17466	8745	26	0	\N
303300	593	66612937193897	17466	8745	27	0	\N
303301	408	66613938193897	17466	8745	28	0	\N
303302	601	66613938193897	17466	8745	29	0	\N
303303	691	66613938193897	17466	8745	30	0	\N
303304	339	66613938193897	17466	8745	31	0	\N
303305	745	2018604187613	17466	8745	32	0	\N
303306	63	66613938193897	17466	8745	33	0	\N
303307	1772	4389917417867	17466	8745	34	0	\N
303308	92	66613938193897	17466	8745	36	0	\N
303309	150	66613938193897	17466	8745	37	0	\N
303310	373	66613938193897	17466	8745	38	0	\N
303311	1516	1474719030000	17466	8745	39	0	\N
303312	1678	19440672023000	17466	8745	40	0	\N
303313	1678	19440672024000	17466	8745	41	0	\N
303314	1678	19440672025000	17466	8745	42	0	\N
303315	1678	19440672026000	17466	8745	43	0	\N
303316	1678	19440672027000	17466	8745	44	0	\N
303317	1678	19440672028000	17466	8745	45	0	\N
303318	1678	19440672029000	17466	8745	46	0	\N
303319	1678	19440672030000	17466	8745	47	0	\N
303320	1678	19440672031000	17466	8745	48	0	\N
303321	1678	19440672032000	17466	8745	49	0	\N
303322	1678	19440672033000	17466	8745	50	0	\N
303323	1678	19440672034000	17466	8745	51	0	\N
303324	1678	19440672035000	17466	8745	52	0	\N
303325	1678	19440672036000	17466	8745	53	0	\N
303326	1678	19440672037000	17466	8745	54	0	\N
303327	1678	19440672038000	17466	8745	55	0	\N
303328	1678	19440672039000	17466	8745	56	0	\N
303329	1678	19440672040000	17466	8745	57	0	\N
303330	1505	0	17466	8745	58	0	\N
303331	322	66613938193897	17466	8745	59	0	\N
303332	453	66613938193897	17466	8745	60	0	\N
303333	450	66613938193897	17466	8745	61	0	\N
303334	395	66110897193897	17466	8745	62	0	\N
303335	29	7065114656873	17466	8745	63	0	\N
303336	138	66613938193897	17466	8745	64	0	\N
303337	910	507454463072188	17466	8745	65	0	\N
303338	500	66613938193897	17466	8745	66	0	\N
303339	146	66613938193897	17466	8745	67	0	\N
303340	504	66613938193897	17466	8745	68	0	\N
303341	587	66613938193897	17466	8745	69	0	\N
303342	1961	612850369124	17466	8745	70	0	\N
303343	611	66613938193897	17466	8745	71	0	\N
303344	205	66613938193897	17466	8745	72	0	\N
303345	658	66613938193897	17466	8745	73	0	\N
303346	78	66613938193897	17466	8745	74	0	\N
303347	660	66613938193897	17466	8745	75	0	\N
303348	1276	1709737537593210	17466	8745	76	0	\N
303349	194	66613938193897	17466	8745	77	0	\N
303350	105	66613938193897	17466	8745	78	0	\N
303351	122	66613938193897	17466	8745	79	0	\N
303352	622	66616918193897	17466	8745	80	0	\N
303353	653	66613938193897	17466	8745	81	0	\N
303354	304	66613938193897	17466	8745	82	0	\N
303355	206	66613938193897	17466	8745	83	0	\N
303356	399	66613938193897	17466	8745	84	0	\N
303357	54	66613938193897	17466	8745	85	0	\N
303358	710	5046510469181	17466	8745	86	0	\N
303359	499	66613938193897	17466	8745	87	0	\N
303360	721	2018604187613	17466	8745	88	0	\N
303361	103	66613938193897	17466	8745	89	0	\N
303362	217	66613938193897	17466	8745	90	0	\N
303363	893	309677012160129	17466	8745	91	0	\N
303364	251	66613938193897	17466	8745	92	0	\N
303365	1678	19440672041000	17466	8745	93	0	\N
303366	1678	19440672042000	17466	8745	94	0	\N
303367	1678	19440672043000	17466	8745	95	0	\N
303368	1678	19440672044000	17466	8745	96	0	\N
303369	1678	19440672045000	17466	8745	97	0	\N
303370	1678	19440672046000	17466	8745	98	0	\N
303371	1678	19440672047000	17466	8745	99	0	\N
303372	1678	19440672048000	17466	8745	100	0	\N
303373	1678	19440672049000	17466	8745	101	0	\N
303374	1678	19440672050000	17466	8745	102	0	\N
303375	1678	19440672051000	17466	8745	103	0	\N
303376	1678	19440672052000	17466	8745	104	0	\N
303377	1678	19440672053000	17466	8745	105	0	\N
303378	1678	19440672054000	17466	8745	106	0	\N
303379	1678	19440672055000	17466	8745	107	0	\N
303380	1678	19440672056000	17466	8745	108	0	\N
303381	1678	19440672057000	17466	8745	109	0	\N
303382	1678	19440672058000	17466	8745	110	0	\N
303383	1678	19440672059000	17466	8745	111	0	\N
303384	1678	19440672060000	17466	8745	112	0	\N
303385	1678	19440672061000	17466	8745	113	0	\N
303386	1678	19440672062000	17466	8745	114	0	\N
303387	1678	19440672063000	17466	8745	115	0	\N
303388	1678	19440672064000	17466	8745	116	0	\N
303389	1678	19440672065000	17466	8745	117	0	\N
303390	1678	19440672066000	17466	8745	118	0	\N
303391	1678	19440672067000	17466	8745	119	0	\N
303392	1678	19440672068000	17466	8745	120	0	\N
303393	1678	19440672069000	17466	8745	121	0	\N
303394	1678	19440672070000	17466	8745	122	0	\N
303395	1678	19440672071000	17466	8745	123	0	\N
303396	1678	19440672072000	17466	8745	124	0	\N
303397	1678	19440672073000	17466	8745	125	0	\N
303398	54	66613938193897	17467	8845	0	0	\N
303399	710	5046510469181	17467	8845	1	0	\N
303400	499	66613938193897	17467	8845	3	0	\N
303401	721	2018604187613	17467	8845	4	0	\N
303402	103	66613938193897	17467	8845	5	0	\N
303403	217	66613938193897	17467	8845	6	0	\N
303404	1678	20160708152000	17467	8845	7	0	\N
303405	1678	20160708153000	17467	8845	8	0	\N
303406	893	309677012160129	17467	8845	9	0	\N
303407	251	66613938193897	17467	8845	10	0	\N
303408	1483	10000000	17467	8845	11	0	\N
303409	1874	6582000	17467	8845	12	0	\N
303410	54	66613938193897	17468	8845	0	0	\N
303411	710	5046510469181	17468	8845	1	0	\N
303412	499	66613938193897	17468	8845	3	0	\N
303413	721	2018604187613	17468	8845	4	0	\N
303414	103	66613938193897	17468	8845	5	0	\N
303415	217	66613938193897	17468	8845	6	0	\N
303416	1678	20160708152000	17468	8845	7	0	\N
303417	1678	20160708153000	17468	8845	8	0	\N
303418	893	309677012160129	17468	8845	9	0	\N
303419	251	66613938193897	17468	8845	10	0	\N
303420	35	19378600201813	17468	8845	11	0	\N
303421	49	66613938193897	17468	8845	12	0	\N
303422	320	66332738193897	17468	8845	13	0	\N
303423	1030	909354049955700	17468	8845	14	0	\N
303424	569	66613938193897	17468	8845	15	0	\N
303425	663	66613938193897	17468	8845	16	0	\N
303426	108	66613938193897	17468	8845	17	0	\N
303427	390	66613938193897	17468	8845	18	0	\N
303428	894	309677012160129	17468	8845	19	0	\N
303429	570	66613938193897	17468	8845	20	0	\N
303430	99	66613938193897	17468	8845	21	0	\N
303431	377	66613938193897	17468	8845	22	0	\N
303432	1874	6583000	17468	8845	23	0	\N
303433	1483	10000000	17468	8845	24	0	\N
303434	1874	6586000	17468	8845	25	0	\N
303435	1874	6588000	17468	8845	26	0	\N
303469	103	66613938193897	17474	8846	0	0	\N
303470	217	66613938193897	17474	8846	1	0	\N
303471	1678	20160708152000	17474	8846	2	0	\N
303472	1678	20160708153000	17474	8846	3	0	\N
303473	1678	20160708154000	17474	8846	4	0	\N
303474	893	309677012160129	17474	8846	5	0	\N
303475	251	66613938193897	17474	8846	6	0	\N
303476	35	19378600201813	17474	8846	7	0	\N
303477	49	66613938193897	17474	8846	8	0	\N
303478	320	66332738193897	17474	8846	9	0	\N
303479	1030	909354049955700	17474	8846	10	0	\N
303480	569	66613938193897	17474	8846	11	0	\N
303481	663	66613938193897	17474	8846	12	0	\N
303482	108	66613938193897	17474	8846	13	0	\N
303483	390	66613938193897	17474	8846	14	0	\N
303484	894	309677012160129	17474	8846	15	0	\N
303485	570	66613938193897	17474	8846	16	0	\N
303486	99	66613938193897	17474	8846	17	0	\N
303487	377	66613938193897	17474	8846	18	0	\N
303488	225	66613938193897	17474	8846	19	0	\N
303489	560	66613938193897	17474	8846	20	0	\N
303490	252	66613938193897	17474	8846	21	0	\N
303491	163	66613938193897	17474	8846	22	0	\N
303492	1874	6583000	17474	8846	23	0	\N
303493	1483	10000000	17474	8846	24	0	\N
303494	1874	6586000	17474	8846	25	0	\N
303495	1874	6588000	17474	8846	26	0	\N
303496	1874	6590000	17474	8846	27	0	\N
303497	1874	6593000	17474	8846	28	0	\N
303513	1678	20160708159000	17478	8850	0	0	\N
303514	594	66613938193897	17478	8850	1	0	\N
303515	309	66613938193897	17478	8850	2	0	\N
303516	201	66613938193897	17478	8850	3	0	\N
303517	1962	612850369124	17478	8850	4	0	\N
303518	275	66613938193897	17478	8850	5	0	\N
303519	1874	6615000	17478	8850	6	0	\N
303520	1874	6618000	17478	8850	7	0	\N
303521	1678	20160708159000	17479	8850	0	0	\N
303522	594	66613938193897	17479	8850	1	0	\N
303523	309	66613938193897	17479	8850	2	0	\N
303524	201	66613938193897	17479	8850	3	0	\N
303525	1962	612850369124	17479	8850	4	0	\N
303526	275	66613938193897	17479	8850	5	0	\N
303527	1874	6615000	17479	8850	6	0	\N
303528	1874	6618000	17479	8850	7	0	\N
303537	397	66613938193897	17481	8851	0	0	\N
303538	1678	20160708160000	17481	8851	1	0	\N
303539	402	66613938193897	17481	8851	2	0	\N
303540	391	66613938193897	17481	8851	3	0	\N
303541	452	66613938193897	17481	8851	4	0	\N
303542	2073	612113103967	17481	8851	5	0	\N
303543	1874	6621000	17481	8851	6	0	\N
303544	1874	6623000	17481	8851	7	0	\N
303552	397	66613938193897	17483	8851	0	0	\N
303438	499	66613938193897	17469	8845	3	0	0
303439	721	2018604187613	17469	8845	4	0	0
303440	103	66613938193897	17472	8846	0	0	0
303441	217	66613938193897	17472	8846	1	0	0
303442	1678	20160708152000	17472	8846	2	0	0
303444	1678	20160708154000	17472	8846	4	0	0
303445	893	309677012160129	17472	8846	5	0	0
303446	251	66613938193897	17472	8846	6	0	0
303447	35	19378600201813	17472	8846	7	0	0
303448	49	66613938193897	17472	8846	8	0	0
303450	1030	909354049955700	17472	8846	10	0	0
303451	569	66613938193897	17472	8846	11	0	0
303452	663	66613938193897	17472	8846	12	0	0
303453	108	66613938193897	17472	8846	13	0	0
303455	894	309677012160129	17472	8846	15	0	0
303456	570	66613938193897	17472	8846	16	0	0
303457	99	66613938193897	17472	8846	17	0	0
303458	377	66613938193897	17472	8846	18	0	0
303459	225	66613938193897	17472	8846	19	0	0
303461	252	66613938193897	17472	8846	21	0	0
303462	163	66613938193897	17472	8846	22	0	0
303463	1874	6583000	17472	8846	23	0	2
303464	1483	10000000	17472	8846	24	0	0
303465	1874	6586000	17472	8846	25	0	2
303467	1874	6590000	17472	8846	27	0	2
303468	1874	6593000	17472	8846	28	0	2
303498	1678	20160708155000	17475	8847	0	0	0
303499	1874	6596000	17475	8847	1	0	2
303501	1678	20160708156000	17476	8848	0	0	0
303502	1874	6601000	17476	8848	1	0	2
303503	1874	6603000	17476	8848	2	0	2
303504	82	66613938193897	17477	8849	0	0	0
303505	1242	611019660000000	17477	8849	1	0	0
303507	1678	20160708158000	17477	8849	3	0	0
303508	361	66613938193897	17477	8849	4	0	0
303509	1874	6605000	17477	8849	5	0	2
303510	1874	6608000	17477	8849	6	0	2
303511	1874	6611000	17477	8849	7	0	2
303529	1678	20160708159000	17480	8850	0	0	0
303530	594	66613938193897	17480	8850	1	0	0
303531	309	66613938193897	17480	8850	2	0	0
303532	201	66613938193897	17480	8850	3	0	0
303534	275	66613938193897	17480	8850	5	0	0
303535	1874	6615000	17480	8850	6	0	2
303536	1874	6618000	17480	8850	7	0	2
303545	397	66613938193897	17482	8851	0	0	0
303546	1678	20160708160000	17482	8851	1	0	0
303548	391	66613938193897	17482	8851	3	0	0
303549	452	66613938193897	17482	8851	4	0	0
303550	2073	612113103967	17482	8851	5	0	1
303551	1874	6620000	17482	8851	6	0	2
303553	1678	20160708160000	17483	8851	1	0	\N
303554	402	66613938193897	17483	8851	2	0	\N
303555	391	66613938193897	17483	8851	3	0	\N
303556	452	66613938193897	17483	8851	4	0	\N
303557	2073	612113103967	17483	8851	5	0	\N
303558	1874	6621000	17483	8851	6	0	\N
303559	1874	6623000	17483	8851	7	0	\N
303560	680	66613938193897	17484	8852	0	0	\N
303561	690	66613938193897	17484	8852	1	0	\N
303562	1678	20160708161000	17484	8852	2	0	\N
303563	731	2018604187613	17484	8852	3	0	\N
303564	180	66613938193897	17484	8852	4	0	\N
303565	1874	6623000	17484	8852	5	0	\N
303566	1874	6626000	17484	8852	6	0	\N
303567	1874	6628000	17484	8852	7	0	\N
303568	680	66613938193897	17485	8852	0	0	\N
303569	690	66613938193897	17485	8852	1	0	\N
303570	1678	20160708161000	17485	8852	2	0	\N
303571	731	2018604187613	17485	8852	3	0	\N
303572	180	66613938193897	17485	8852	4	0	\N
303573	1874	6622000	17485	8852	5	0	\N
303574	680	66613938193897	17486	8852	0	0	\N
303575	690	66613938193897	17486	8852	1	0	\N
303576	1678	20160708161000	17486	8852	2	0	\N
303577	731	2018604187613	17486	8852	3	0	\N
303578	180	66613938193897	17486	8852	4	0	\N
303579	1874	6623000	17486	8852	5	0	\N
303580	1874	6626000	17486	8852	6	0	\N
303581	1874	6628000	17486	8852	7	0	\N
303582	680	66613938193897	17487	8852	0	0	\N
303583	690	66613938193897	17487	8852	1	0	\N
303584	1678	20160708161000	17487	8852	2	0	\N
303585	731	2018604187613	17487	8852	3	0	\N
303586	180	66613938193897	17487	8852	4	0	\N
303587	1874	6623000	17487	8852	5	0	\N
303588	1874	6626000	17487	8852	6	0	\N
303589	1874	6628000	17487	8852	7	0	\N
303607	1678	20160708163000	17490	8854	0	0	\N
303608	191	66613938193897	17490	8854	1	0	\N
303609	266	66613938193897	17490	8854	2	0	\N
303610	534	66613938193897	17490	8854	3	0	\N
303611	245	66613938193897	17490	8854	4	0	\N
303612	421	66613938193897	17490	8854	5	0	\N
303613	1874	6635000	17490	8854	6	0	\N
303614	1874	6638000	17490	8854	7	0	\N
303615	1678	20160708163000	17491	8854	0	0	\N
303616	191	66613938193897	17491	8854	1	0	\N
303617	266	66613938193897	17491	8854	2	0	\N
303618	534	66613938193897	17491	8854	3	0	\N
303619	245	66613938193897	17491	8854	4	0	\N
303620	421	66613938193897	17491	8854	5	0	\N
303621	1874	6635000	17491	8854	6	0	\N
303622	1874	6638000	17491	8854	7	0	\N
303633	1678	20160708165000	17494	8856	0	0	\N
303634	1874	6644000	17494	8856	1	0	\N
303643	1678	20160708168000	17499	8859	0	0	\N
303644	1874	6653000	17499	8859	1	0	\N
303645	1678	20160708168000	17500	8859	0	0	\N
303646	1874	6653000	17500	8859	1	0	\N
303659	1678	20160708172000	17504	8863	0	0	\N
303660	1678	20160708173000	17504	8863	1	0	\N
303661	1874	6676000	17504	8863	2	0	\N
303662	1874	6679000	17504	8863	3	0	\N
303663	1874	6682000	17504	8863	4	0	\N
303664	1874	6684000	17504	8863	5	0	\N
303671	1678	20160708172000	17506	8863	0	0	\N
303672	1678	20160708173000	17506	8863	1	0	\N
303673	1874	6676000	17506	8863	2	0	\N
303674	1874	6679000	17506	8863	3	0	\N
303675	1874	6682000	17506	8863	4	0	\N
303676	1874	6684000	17506	8863	5	0	\N
303677	1678	20160708174000	17507	8864	0	0	\N
303678	1874	6686000	17507	8864	1	0	\N
303679	1874	6689000	17507	8864	2	0	\N
303592	1678	20160708161000	17488	8852	2	0	0
303593	731	2018604187613	17488	8852	3	0	0
303594	180	66613938193897	17488	8852	4	0	0
303595	1874	6623000	17488	8852	5	0	2
303596	1874	6626000	17488	8852	6	0	2
303598	1122	905590055000000	17489	8853	0	0	0
303599	112	66084906193897	17489	8853	1	0	5
303600	1678	20160708162000	17489	8853	2	0	0
303601	353	66613928193897	17489	8853	3	0	1
303602	652	66613938193897	17489	8853	4	0	0
303604	1874	6630000	17489	8853	6	0	2
303605	1874	6633000	17489	8853	7	0	2
303606	1745	1803000000	17489	8853	8	0	5
303623	1678	20160708163000	17492	8854	0	0	0
303625	266	66613938193897	17492	8854	2	0	0
303626	534	66613938193897	17492	8854	3	0	0
303627	245	66613938193897	17492	8854	4	0	0
303628	421	66613938193897	17492	8854	5	0	0
303629	1874	6635000	17492	8854	6	0	2
303631	1678	20160708164000	17493	8855	0	0	0
303632	1874	6641000	17493	8855	1	0	2
303635	1678	20160708165000	17495	8856	0	0	0
303636	1874	6644000	17495	8856	1	0	2
303637	1678	20160708166000	17496	8857	0	0	0
303639	1678	20160708167000	17497	8858	0	0	0
303640	1874	6650000	17497	8858	1	0	2
303641	1678	20160708168000	17498	8859	0	0	0
303642	1874	6653000	17498	8859	1	0	2
303648	1874	6656000	17501	8860	2	0	2
303649	1874	6658000	17501	8860	3	0	2
303650	1874	6660000	17501	8860	4	0	2
303651	1874	6662000	17501	8860	5	0	2
303652	1874	6664000	17501	8860	6	0	2
303654	1874	6667000	17502	8861	1	0	2
303655	1874	6669000	17502	8861	2	0	2
303656	1678	20160708171000	17503	8862	0	0	0
303657	1874	6671000	17503	8862	1	0	2
303658	1874	6674000	17503	8862	2	0	2
303666	1678	20160708173000	17505	8863	1	0	0
303667	1874	6676000	17505	8863	2	0	2
303668	1874	6679000	17505	8863	3	0	2
303669	1874	6682000	17505	8863	4	0	2
303680	1874	6687000	17508	8864	0	0	2
303681	1678	20160708174000	17509	8865	0	0	0
303682	1678	20160708175000	17509	8865	1	0	0
303683	1874	6689000	17509	8865	2	0	2
303684	1874	6692000	17509	8865	3	0	2
303686	1678	20160708176000	17510	8866	0	0	0
303687	1678	20160708177000	17510	8866	1	0	0
303688	1678	20160708178000	17510	8866	2	0	0
303695	1678	20160708174000	17511	8865	0	0	\N
303696	1678	20160708175000	17511	8865	1	0	\N
303697	1678	20160708176000	17511	8865	2	0	\N
303698	1678	20160708177000	17511	8865	3	0	\N
303699	1678	20160708178000	17511	8865	4	0	\N
303700	1874	6689000	17511	8865	5	0	\N
303701	1874	6692000	17511	8865	6	0	\N
303702	1874	6695000	17511	8865	7	0	\N
303703	1874	6698000	17511	8865	8	0	\N
303704	1874	6700000	17511	8865	9	0	\N
303705	1874	6702000	17511	8865	10	0	\N
303706	1874	6704000	17511	8865	11	0	\N
303707	1874	6707000	17511	8865	12	0	\N
303708	1874	6709000	17511	8865	13	0	\N
303709	1678	20160708176000	17512	8866	0	0	\N
303710	1678	20160708177000	17512	8866	1	0	\N
303711	1678	20160708178000	17512	8866	2	0	\N
303712	1874	6696000	17512	8866	3	0	\N
303713	1874	6698000	17512	8866	4	0	\N
303714	1874	6701000	17512	8866	5	0	\N
303715	1874	6704000	17512	8866	6	0	\N
303716	1874	6707000	17512	8866	7	0	\N
303717	1874	6709000	17512	8866	8	0	\N
303723	1678	20160708180000	17515	8868	0	0	\N
303724	1874	6715000	17515	8868	1	0	\N
303725	1874	6717000	17515	8868	2	0	\N
303728	1678	20160708182000	17517	8870	0	0	\N
303729	1745	1803000000	17517	8870	1	0	\N
303730	1874	6723000	17517	8870	2	0	\N
303734	1678	20160708182000	17519	8870	0	0	\N
303735	1745	1803000000	17519	8870	1	0	\N
303736	1874	6723000	17519	8870	2	0	\N
303739	1678	20160708183000	17521	8871	0	0	\N
303740	1874	6726000	17521	8871	1	0	\N
303741	1678	20160708183000	17522	8871	0	0	\N
303742	1874	6726000	17522	8871	1	0	\N
303745	1678	20160708184000	17524	8872	0	0	\N
303746	1874	6729000	17524	8872	1	0	\N
303772	1678	20160708191000	17529	8876	0	0	\N
303773	1874	6765000	17529	8876	1	0	\N
303774	1874	6767000	17529	8876	2	0	\N
303775	1874	6770000	17529	8876	3	0	\N
303776	1874	6773000	17529	8876	4	0	\N
303777	1678	20160708191000	17530	8876	0	0	\N
303778	1874	6765000	17530	8876	1	0	\N
303779	1874	6767000	17530	8876	2	0	\N
303780	1874	6770000	17530	8876	3	0	\N
303781	1874	6773000	17530	8876	4	0	\N
303791	1678	20160708195000	17534	8880	0	0	\N
303792	1678	20160708196000	17534	8880	1	0	\N
303793	1678	20160708197000	17534	8880	2	0	\N
303794	1678	20160708198000	17534	8880	3	0	\N
303795	1874	6791000	17534	8880	4	0	\N
303796	1874	6794000	17534	8880	5	0	\N
303797	1874	6796000	17534	8880	6	0	\N
303798	1874	6798000	17534	8880	8	0	\N
303799	1874	6800000	17534	8880	9	0	\N
303800	1874	6802000	17534	8880	10	0	\N
303801	1874	6805000	17534	8880	11	0	\N
303802	1874	6808000	17534	8880	12	0	\N
303818	1678	20160708199000	17537	8881	0	0	\N
303819	1874	6811000	17537	8881	1	0	\N
303820	1874	6813000	17537	8881	2	0	\N
303821	1745	1803000000	17538	8852	0	0	\N
303822	1874	6623000	17538	8852	1	0	\N
303823	1745	1803000000	17538	8852	2	0	\N
303691	1874	6701000	17510	8866	5	0	2
303692	1874	6704000	17510	8866	6	0	2
303693	1874	6707000	17510	8866	7	0	2
303694	1874	6709000	17510	8866	8	0	2
303718	1678	20160708179000	17513	8867	0	0	0
303720	1678	20160708180000	17514	8868	0	0	0
303721	1874	6715000	17514	8868	1	0	2
303722	1874	6717000	17514	8868	2	0	2
303726	1678	20160708181000	17516	8869	0	0	0
303727	1874	6720000	17516	8869	1	0	2
303732	1745	1803000000	17518	8870	1	0	5
303733	1874	6723000	17518	8870	2	0	2
303737	1678	20160708183000	17520	8871	0	0	0
303738	1874	6726000	17520	8871	1	0	2
303744	1874	6729000	17523	8872	1	0	2
303747	1678	20160708185000	17525	8873	0	0	0
303748	1678	20160708186000	17525	8873	1	0	0
303749	1874	6731000	17525	8873	2	0	2
303750	1874	6733000	17525	8873	3	0	2
303752	1874	6739000	17525	8873	5	0	2
303753	1874	6741000	17525	8873	6	0	2
303754	1874	6743000	17525	8873	7	0	2
303755	1678	20160708187000	17526	8874	0	0	0
303756	1678	20160708188000	17526	8874	1	0	0
303758	1874	6746000	17526	8874	3	0	2
303759	1874	6749000	17526	8874	4	0	2
303760	1874	6751000	17526	8874	5	0	2
303761	1874	6753000	17526	8874	6	0	2
303763	1874	6758000	17526	8874	8	0	2
303764	1678	20160708190000	17527	8875	0	0	0
303765	1874	6760000	17527	8875	1	0	2
303766	1874	6763000	17527	8875	2	0	2
303767	1678	20160708191000	17528	8876	0	0	0
303769	1874	6767000	17528	8876	2	0	2
303770	1874	6770000	17528	8876	3	0	2
303771	1874	6773000	17528	8876	4	0	2
303782	1678	20160708192000	17531	8877	0	0	0
303783	1874	6776000	17531	8877	1	0	2
303785	1678	20160708193000	17532	8878	0	0	0
303786	1874	6781000	17532	8878	1	0	2
303787	1874	6783000	17532	8878	2	0	2
303788	1678	20160708194000	17533	8879	0	0	0
303790	1874	6788000	17533	8879	2	0	2
303803	1678	20160708195000	17535	8880	0	0	0
303804	1678	20160708196000	17535	8880	1	0	0
303805	1678	20160708197000	17535	8880	2	0	0
303806	1678	20160708198000	17535	8880	3	0	0
303808	1874	6794000	17535	8880	5	0	2
303809	1874	6796000	17535	8880	6	0	2
303810	1874	6798000	17535	8880	8	0	2
303811	1874	6800000	17535	8880	9	0	2
303812	1874	6802000	17535	8880	10	0	2
303814	1874	6808000	17535	8880	12	0	2
303815	1678	20160708199000	17536	8881	0	0	0
303816	1874	6811000	17536	8881	1	0	2
303817	1874	6813000	17536	8881	2	0	2
303827	1678	20160708200000	17540	8882	0	0	\N
303828	1874	6816000	17540	8882	1	0	\N
303829	1874	6818000	17540	8882	2	0	\N
303830	1678	20160708201000	17541	8883	0	0	\N
303831	1678	20160708202000	17541	8883	1	0	\N
303832	1874	6821000	17541	8883	2	0	\N
303833	1874	6824000	17541	8883	3	0	\N
303834	1874	6826000	17541	8883	4	0	\N
303841	1678	20160708201000	17543	8883	0	0	\N
303842	1678	20160708202000	17543	8883	1	0	\N
303843	1874	6821000	17543	8883	2	0	\N
303844	1874	6824000	17543	8883	3	0	\N
303845	1874	6826000	17543	8883	4	0	\N
303846	1678	20160708201000	17544	8883	0	0	\N
303847	1678	20160708202000	17544	8883	1	0	\N
303848	1874	6821000	17544	8883	2	0	\N
303849	1874	6824000	17544	8883	3	0	\N
303850	1874	6826000	17544	8883	4	0	\N
303853	1678	20160708204000	17546	8885	0	0	\N
303854	1874	6834000	17546	8885	1	0	\N
303855	1874	6836000	17546	8885	2	0	\N
303859	1678	20160708204000	17548	8885	0	0	\N
303860	1874	6834000	17548	8885	1	0	\N
303861	1874	6836000	17548	8885	2	0	\N
303865	1678	20160708205000	17550	8886	0	0	\N
303866	1874	6838000	17550	8886	1	0	\N
303867	1874	6841000	17550	8886	2	0	\N
303871	1678	20160708206000	17552	8887	0	0	\N
303872	1874	6844000	17552	8887	1	0	\N
303873	1874	6846000	17552	8887	2	0	\N
303874	1678	20160708206000	17553	8887	0	0	\N
303875	1874	6844000	17553	8887	1	0	\N
303876	1874	6846000	17553	8887	2	0	\N
303877	1678	20160708207000	17554	8888	0	0	\N
303878	1874	6848000	17554	8888	1	0	\N
303879	1874	6851000	17554	8888	2	0	\N
303880	1678	20160708207000	17555	8888	0	0	\N
303881	1874	6848000	17555	8888	1	0	\N
303882	1874	6851000	17555	8888	2	0	\N
303883	1678	20160708207000	17556	8888	0	0	\N
303884	1874	6848000	17556	8888	1	0	\N
303885	1874	6851000	17556	8888	2	0	\N
303886	1678	20160708207000	17557	8888	0	0	\N
303887	1874	6848000	17557	8888	1	0	\N
303888	1874	6851000	17557	8888	2	0	\N
303892	1678	20160708208000	17559	8889	0	0	\N
303893	1874	6853000	17559	8889	1	0	\N
303894	1874	6856000	17559	8889	2	0	\N
303895	1678	20160708208000	17560	8889	0	0	\N
303896	1874	6853000	17560	8889	1	0	\N
303897	1874	6856000	17560	8889	2	0	\N
303901	1678	20160708209000	17562	8890	0	0	\N
303902	1874	6858000	17562	8890	1	0	\N
303903	1874	6861000	17562	8890	2	0	\N
303907	1678	20160708210000	17564	8891	0	0	\N
303908	1678	20160708211000	17564	8891	1	0	\N
303909	1874	6864000	17564	8891	2	0	\N
303910	1874	6866000	17564	8891	3	0	\N
303911	1874	6868000	17564	8891	4	0	\N
303912	1874	6871000	17564	8891	5	0	\N
303922	1678	20160708212000	17567	8892	0	0	\N
303923	1874	6874000	17567	8892	1	0	\N
303924	1874	6876000	17567	8892	2	0	\N
303925	1678	20160708212000	17569	8892	0	0	\N
303926	1874	6874000	17569	8892	1	0	\N
303927	1874	6876000	17569	8892	2	0	\N
303928	1678	20160708212000	17570	8892	0	0	\N
303929	1874	6874000	17570	8892	1	0	\N
303930	1874	6876000	17570	8892	2	0	\N
303937	1678	20160708213000	17572	8893	0	0	\N
303938	1678	20160708214000	17572	8893	1	0	\N
303939	1874	6878000	17572	8893	2	0	\N
303940	1874	6880000	17572	8893	3	0	\N
303941	1874	6883000	17572	8893	4	0	\N
303942	1874	6886000	17572	8893	5	0	\N
303943	1678	20160708201000	17573	8883	0	0	\N
303944	1678	20160708202000	17573	8883	1	0	\N
303945	1678	20160708203000	17573	8883	2	0	\N
303946	1678	20160708204000	17573	8883	3	0	\N
303947	1678	20160708205000	17573	8883	4	0	\N
303948	1678	20160708206000	17573	8883	5	0	\N
303949	1678	20160708207000	17573	8883	6	0	\N
303950	1678	20160708208000	17573	8883	7	0	\N
303951	1678	20160708209000	17573	8883	8	0	\N
303952	1678	20160708210000	17573	8883	9	0	\N
303953	1678	20160708211000	17573	8883	10	0	\N
303954	1678	20160708212000	17573	8883	11	0	\N
303955	1678	20160708213000	17573	8883	12	0	\N
303956	1874	6821000	17573	8883	13	0	\N
303957	1874	6824000	17573	8883	14	0	\N
303958	1874	6826000	17573	8883	15	0	\N
303959	1874	6828000	17573	8883	16	0	\N
303960	1874	6830000	17573	8883	17	0	\N
303835	1678	20160708201000	17542	8883	0	0	0
303836	1678	20160708202000	17542	8883	1	0	0
303837	1874	6821000	17542	8883	2	0	2
303838	1874	6824000	17542	8883	3	0	2
303839	1874	6826000	17542	8883	4	0	2
303851	1678	20160708203000	17545	8884	0	0	0
303852	1874	6831000	17545	8884	1	0	2
303856	1678	20160708204000	17547	8885	0	0	0
303857	1874	6834000	17547	8885	1	0	2
303858	1874	6836000	17547	8885	2	0	2
303863	1874	6838000	17549	8886	1	0	2
303864	1874	6841000	17549	8886	2	0	2
303868	1678	20160708206000	17551	8887	0	0	0
303869	1874	6844000	17551	8887	1	0	2
303889	1678	20160708207000	17558	8888	0	0	0
303890	1874	6848000	17558	8888	1	0	2
303891	1874	6851000	17558	8888	2	0	2
303898	1678	20160708208000	17561	8889	0	0	0
303899	1874	6853000	17561	8889	1	0	2
303904	1678	20160708209000	17563	8890	0	0	0
303905	1874	6858000	17563	8890	1	0	2
303906	1874	6861000	17563	8890	2	0	2
303913	1678	20160708210000	17565	8891	0	0	0
303914	1678	20160708211000	17565	8891	1	0	0
303916	1874	6866000	17565	8891	3	0	2
303917	1874	6868000	17565	8891	4	0	2
303918	1874	6871000	17565	8891	5	0	2
303919	1678	20160708212000	17566	8892	0	0	0
303921	1874	6876000	17566	8892	2	0	2
303931	1678	20160708213000	17571	8893	0	0	0
303932	1678	20160708214000	17571	8893	1	0	0
303933	1874	6878000	17571	8893	2	0	2
303934	1874	6880000	17571	8893	3	0	2
303936	1874	6886000	17571	8893	5	0	2
303961	1874	6832000	17573	8883	18	0	\N
303962	1874	6834000	17573	8883	19	0	\N
303963	1874	6836000	17573	8883	20	0	\N
303964	1874	6838000	17573	8883	21	0	\N
303965	1874	6840000	17573	8883	22	0	\N
303966	1874	6842000	17573	8883	23	0	\N
303967	1874	6844000	17573	8883	24	0	\N
303968	1874	6847000	17573	8883	25	0	\N
303969	1874	6850000	17573	8883	26	0	\N
303970	1874	6853000	17573	8883	27	0	\N
303971	1874	6856000	17573	8883	28	0	\N
303972	1874	6859000	17573	8883	29	0	\N
303973	1874	6862000	17573	8883	30	0	\N
303974	1874	6865000	17573	8883	31	0	\N
303975	1874	6868000	17573	8883	32	0	\N
303976	1874	6870000	17573	8883	33	0	\N
303977	1874	6872000	17573	8883	34	0	\N
303978	1874	6875000	17573	8883	35	0	\N
303979	1874	6878000	17573	8883	36	0	\N
303980	1678	20160708215000	17574	8894	0	0	\N
303981	1874	6889000	17574	8894	1	0	\N
303982	1874	6891000	17574	8894	2	0	\N
303986	1678	20160708215000	17576	8894	0	0	\N
303987	1874	6889000	17576	8894	1	0	\N
303988	1874	6891000	17576	8894	2	0	\N
303992	1678	20160708215000	17580	8894	0	0	\N
303993	1678	20160708216000	17580	8894	1	0	\N
303994	1678	20160708217000	17580	8894	2	0	\N
303995	1874	6889000	17580	8894	3	0	\N
303996	1874	6892000	17580	8894	4	0	\N
303997	1874	6895000	17580	8894	5	0	\N
303998	1874	6897000	17580	8894	6	0	\N
303999	1874	6899000	17580	8894	7	0	\N
304000	1874	6901000	17580	8894	8	0	\N
304004	1678	20160708218000	17583	8897	0	0	\N
304005	1678	20160708219000	17583	8897	1	0	\N
304006	1678	20160708220000	17583	8897	2	0	\N
304007	1874	6903000	17583	8897	3	0	\N
304008	1874	6906000	17583	8897	4	0	\N
304009	1874	6909000	17583	8897	5	0	\N
304010	1874	6911000	17583	8897	6	0	\N
304011	1874	6914000	17583	8897	7	0	\N
304012	1874	6916000	17583	8897	8	0	\N
304013	1678	20160708218000	17584	8897	0	0	\N
304014	1678	20160708219000	17584	8897	1	0	\N
304015	1678	20160708220000	17584	8897	2	0	\N
304016	1874	6903000	17584	8897	3	0	\N
304017	1874	6906000	17584	8897	4	0	\N
304018	1874	6909000	17584	8897	5	0	\N
304019	1874	6911000	17584	8897	6	0	\N
304020	1874	6914000	17584	8897	7	0	\N
304021	1874	6916000	17584	8897	8	0	\N
304022	1678	20160708218000	17585	8897	0	0	\N
304023	1678	20160708219000	17585	8897	1	0	\N
304024	1678	20160708220000	17585	8897	2	0	\N
304025	1874	6903000	17585	8897	3	0	\N
304026	1874	6906000	17585	8897	4	0	\N
304027	1874	6909000	17585	8897	5	0	\N
304028	1874	6911000	17585	8897	6	0	\N
304029	1874	6914000	17585	8897	7	0	\N
304030	1874	6916000	17585	8897	8	0	\N
304046	1950	11889851000000	17588	8899	0	0	\N
304047	1678	20160708223000	17588	8899	1	0	\N
304048	1874	6928000	17588	8899	2	0	\N
304049	1874	6931000	17588	8899	3	0	\N
304050	1950	11889851000000	17589	8899	0	0	\N
304051	1678	20160708223000	17589	8899	1	0	\N
304052	1874	6928000	17589	8899	2	0	\N
304053	1874	6931000	17589	8899	3	0	\N
304056	1950	11889851000000	17591	8899	0	0	\N
304057	1678	20160708223000	17591	8899	1	0	\N
304058	1874	6928000	17591	8899	2	0	\N
304059	1874	6931000	17591	8899	3	0	\N
304060	1866	9452631301632	17592	8765	0	0	\N
304061	2164	500000000	17592	8765	1	0	\N
304062	352	66613938193897	17592	8765	2	0	\N
304063	600	66613938193897	17592	8765	3	0	\N
304064	620	66613938193897	17592	8765	4	0	\N
304065	1150	613559297664572	17592	8765	5	0	\N
304066	1811	1675947484894	17592	8765	6	0	\N
304067	84	66613938193897	17592	8765	7	0	\N
304068	2017	612537528296	17592	8765	8	0	\N
304069	1516	1298566290000	17592	8765	9	0	\N
304070	1242	611019660000000	17592	8765	10	0	\N
304071	1122	905590055000000	17592	8765	11	0	\N
304072	520	66613938193897	17592	8765	12	0	\N
304073	89	66613938193897	17592	8765	13	0	\N
304074	186	66613938193897	17592	8765	14	0	\N
304075	383	66613938193897	17592	8765	15	0	\N
304076	392	66613938193897	17592	8765	16	0	\N
304077	308	66613938193897	17592	8765	17	0	\N
304078	551	66613938193897	17592	8765	18	0	\N
304079	2164	529600000000	17592	8765	19	0	\N
304080	678	66613938193897	17592	8765	20	0	\N
304081	91	66613938193897	17592	8765	21	0	\N
304082	438	66613938193897	17592	8765	22	0	\N
304083	593	66612937193897	17592	8765	23	0	\N
304084	408	66613938193897	17592	8765	24	0	\N
304085	601	66613938193897	17592	8765	25	0	\N
304086	691	66613938193897	17592	8765	26	0	\N
304087	339	66613938193897	17592	8765	27	0	\N
304088	745	2018604187613	17592	8765	28	0	\N
304089	63	66613938193897	17592	8765	29	0	\N
304090	1772	4389917417867	17592	8765	30	0	\N
304091	92	66613938193897	17592	8765	31	0	\N
304092	150	66613938193897	17592	8765	32	0	\N
304093	373	66613938193897	17592	8765	33	0	\N
304094	1516	1474719030000	17592	8765	34	0	\N
304095	1678	20160708224000	17593	8900	0	0	\N
304096	1874	6933000	17593	8900	1	0	\N
303985	1874	6891000	17575	8894	2	0	2
303989	1678	20160708216000	17579	8895	0	0	0
303990	1874	6893000	17579	8895	1	0	2
303991	1874	6896000	17579	8895	2	0	2
304001	1678	20160708217000	17581	8896	0	0	0
304003	1874	6901000	17581	8896	2	0	2
304031	1678	20160708218000	17586	8897	0	0	0
304032	1678	20160708219000	17586	8897	1	0	0
304033	1678	20160708220000	17586	8897	2	0	0
304034	1874	6903000	17586	8897	3	0	2
304036	1874	6909000	17586	8897	5	0	2
304037	1874	6911000	17586	8897	6	0	2
304038	1874	6914000	17586	8897	7	0	2
304039	1874	6916000	17586	8897	8	0	2
304041	1678	20160708222000	17587	8898	1	0	0
304042	1874	6918000	17587	8898	2	0	2
304043	1874	6920000	17587	8898	3	0	2
304044	1874	6923000	17587	8898	4	0	2
304045	1874	6926000	17587	8898	5	0	2
304055	1874	6929000	17590	8899	1	0	2
304097	1874	6936000	17593	8900	2	0	\N
304106	2164	500000000	17596	8819	0	0	\N
304107	352	66613938193897	17596	8819	1	0	\N
304108	600	66613938193897	17596	8819	2	0	\N
304109	620	66613938193897	17596	8819	3	0	\N
304110	1150	613559297664572	17596	8819	4	0	\N
304111	1811	1675947484894	17596	8819	5	0	\N
304112	84	66613938193897	17596	8819	6	0	\N
304113	2017	612537528296	17596	8819	7	0	\N
304114	1516	1298566290000	17596	8819	8	0	\N
304115	1242	611019660000000	17596	8819	9	0	\N
304116	1122	905590055000000	17596	8819	10	0	\N
304117	520	66613938193897	17596	8819	11	0	\N
304118	89	66613938193897	17596	8819	12	0	\N
304119	186	66613938193897	17596	8819	13	0	\N
304120	383	66613938193897	17596	8819	14	0	\N
304121	392	66613938193897	17596	8819	15	0	\N
304122	308	66613938193897	17596	8819	16	0	\N
304123	551	66613938193897	17596	8819	17	0	\N
304124	1678	20160708121000	17596	8819	18	0	\N
304125	1678	20160708122000	17596	8819	19	0	\N
304126	1678	20160708123000	17596	8819	20	0	\N
304127	1678	20160708124000	17596	8819	21	0	\N
304128	2164	529600000000	17596	8819	22	0	\N
304129	678	66613938193897	17596	8819	23	0	\N
304130	91	66613938193897	17596	8819	24	0	\N
304131	438	66613938193897	17596	8819	25	0	\N
304132	593	66612937193897	17596	8819	26	0	\N
304133	408	66613938193897	17596	8819	27	0	\N
304134	601	66613938193897	17596	8819	28	0	\N
304135	691	66613938193897	17596	8819	29	0	\N
304136	339	66613938193897	17596	8819	30	0	\N
304137	745	2018604187613	17596	8819	31	0	\N
304138	63	66613938193897	17596	8819	32	0	\N
304139	1772	4389917417867	17596	8819	33	0	\N
304140	92	66613938193897	17596	8819	34	0	\N
304141	150	66613938193897	17596	8819	35	0	\N
304142	373	66613938193897	17596	8819	36	0	\N
304143	1516	1474719030000	17596	8819	37	0	\N
304144	1678	20160708125000	17596	8819	38	0	\N
304145	1678	20160708126000	17596	8819	39	0	\N
304146	1678	20160708127000	17596	8819	40	0	\N
304147	1678	20160708128000	17596	8819	41	0	\N
304148	1678	20160708129000	17596	8819	42	0	\N
304149	1678	20160708130000	17596	8819	43	0	\N
304150	1678	20160708131000	17596	8819	44	0	\N
304151	1678	20160708132000	17596	8819	45	0	\N
304152	1678	20160708133000	17596	8819	46	0	\N
304153	1678	20160708134000	17596	8819	47	0	\N
304154	1678	20160708135000	17596	8819	48	0	\N
304155	1678	20160708136000	17596	8819	49	0	\N
304156	1678	20160708137000	17596	8819	50	0	\N
304157	1678	20160708138000	17596	8819	51	0	\N
304158	1678	20160708139000	17596	8819	52	0	\N
304159	1678	20160708140000	17596	8819	53	0	\N
304160	1678	20160708141000	17596	8819	54	0	\N
304161	1678	20160708142000	17596	8819	55	0	\N
304162	1678	20160708143000	17596	8819	56	0	\N
304163	1678	20160708144000	17596	8819	57	0	\N
304164	1678	20160708145000	17596	8819	58	0	\N
304165	1678	20160708146000	17596	8819	59	0	\N
304166	1678	20160708147000	17596	8819	60	0	\N
304167	1678	20160708148000	17596	8819	61	0	\N
304168	1678	20160708149000	17596	8819	62	0	\N
304169	1678	20160708150000	17596	8819	63	0	\N
304170	1678	20160708151000	17596	8819	64	0	\N
304171	1678	20160708152000	17596	8819	65	0	\N
304172	1678	20160708153000	17596	8819	66	0	\N
304173	1678	20160708154000	17596	8819	67	0	\N
304174	1678	20160708155000	17596	8819	68	0	\N
304175	1678	20160708156000	17596	8819	69	0	\N
304176	1678	20160708157000	17596	8819	70	0	\N
304177	1678	20160708158000	17596	8819	71	0	\N
304178	1678	20160708159000	17596	8819	72	0	\N
304179	1678	20160708160000	17596	8819	73	0	\N
304180	1678	20160708161000	17596	8819	74	0	\N
304181	1678	20160708162000	17596	8819	75	0	\N
304182	1678	20160708163000	17596	8819	76	0	\N
304183	1678	20160708164000	17596	8819	77	0	\N
304184	1678	20160708165000	17596	8819	78	0	\N
304185	1678	20160708166000	17596	8819	79	0	\N
304186	1678	20160708167000	17596	8819	80	0	\N
304187	1678	20160708168000	17596	8819	81	0	\N
304188	1678	20160708169000	17596	8819	83	0	\N
304189	1678	20160708170000	17596	8819	84	0	\N
304190	1678	20160708171000	17596	8819	85	0	\N
304191	1678	20160708172000	17596	8819	86	0	\N
304192	1678	20160708173000	17596	8819	87	0	\N
304193	1678	20160708174000	17596	8819	88	0	\N
304194	1678	20160708175000	17596	8819	89	0	\N
304195	1678	20160708176000	17596	8819	90	0	\N
304196	1678	20160708177000	17596	8819	91	0	\N
304197	1678	20160708178000	17596	8819	92	0	\N
304198	1678	20160708179000	17596	8819	93	0	\N
304199	1678	20160708180000	17596	8819	94	0	\N
304200	1678	20160708181000	17596	8819	95	0	\N
304201	1678	20160708182000	17596	8819	96	0	\N
304202	1678	20160708183000	17596	8819	97	0	\N
304203	1678	20160708184000	17596	8819	98	0	\N
304204	1678	20160708185000	17596	8819	99	0	\N
304205	1678	20160708186000	17596	8819	100	0	\N
304206	1678	20160708187000	17596	8819	101	0	\N
304207	1678	20160708188000	17596	8819	102	0	\N
304208	1678	20160708189000	17596	8819	103	0	\N
304209	1678	20160708190000	17596	8819	104	0	\N
304210	1678	20160708191000	17596	8819	105	0	\N
304211	322	66613938193897	17596	8819	106	0	\N
304212	453	66613938193897	17596	8819	107	0	\N
304213	450	66613938193897	17596	8819	108	0	\N
304214	395	66110897193897	17596	8819	109	0	\N
304215	29	7065114656873	17596	8819	110	0	\N
304216	138	66613938193897	17596	8819	111	0	\N
304217	910	507454463072188	17596	8819	112	0	\N
304218	500	66613938193897	17596	8819	113	0	\N
304219	146	66613938193897	17596	8819	114	0	\N
304220	504	66613938193897	17596	8819	115	0	\N
304221	587	66613938193897	17596	8819	116	0	\N
304222	1961	612850369124	17596	8819	117	0	\N
304223	611	66613938193897	17596	8819	118	0	\N
304224	205	66613938193897	17596	8819	119	0	\N
304225	658	66613938193897	17596	8819	120	0	\N
304226	78	66613938193897	17596	8819	121	0	\N
304227	660	66613938193897	17596	8819	122	0	\N
304228	1276	1709737537593210	17596	8819	123	0	\N
304229	194	66613938193897	17596	8819	124	0	\N
304230	105	66613938193897	17596	8819	125	0	\N
304100	1874	6931000	17594	8900	2	0	2
304101	1874	6933000	17594	8900	3	0	2
304102	1874	6936000	17594	8900	4	0	2
304103	1678	20160708225000	17595	8901	0	0	0
304104	1874	6939000	17595	8901	1	0	2
304231	1678	20160708226000	17597	8902	0	0	0
304232	1874	6944000	17597	8902	1	0	2
304234	1950	11889851000000	17598	8890	0	0	\N
304235	1874	6858000	17598	8890	1	0	\N
304236	1874	6860000	17598	8890	2	0	\N
304237	1874	6862000	17598	8890	3	0	\N
304238	1874	6864000	17598	8890	4	0	\N
304239	1874	6866000	17598	8890	5	0	\N
304240	1874	6868000	17598	8890	6	0	\N
304241	1874	6870000	17598	8890	7	0	\N
304242	1874	6872000	17598	8890	8	0	\N
304243	1874	6874000	17598	8890	9	0	\N
304244	1874	6876000	17598	8890	10	0	\N
304245	1874	6878000	17598	8890	11	0	\N
304246	1874	6880000	17598	8890	12	0	\N
304247	1874	6882000	17598	8890	13	0	\N
304248	1874	6884000	17598	8890	14	0	\N
304249	1874	6886000	17598	8890	15	0	\N
304250	1874	6888000	17598	8890	16	0	\N
304251	1874	6890000	17598	8890	17	0	\N
304252	1874	6892000	17598	8890	18	0	\N
304253	1874	6894000	17598	8890	19	0	\N
304254	1866	9452631301632	17599	8619	0	0	\N
304255	2164	500000000	17599	8619	1	0	\N
304256	693	66000010000000	17599	8619	2	0	\N
304257	2161	200000000	17599	8619	3	0	\N
304258	352	66613938193897	17599	8619	4	0	\N
304259	600	66613938193897	17599	8619	5	0	\N
304260	620	66613938193897	17599	8619	6	0	\N
304261	1150	613559297664572	17599	8619	7	0	\N
304262	1811	1675947484894	17599	8619	8	0	\N
304263	84	66613938193897	17599	8619	10	0	\N
304264	2017	612537528296	17599	8619	11	0	\N
304265	1516	1298566290000	17599	8619	12	0	\N
304266	1950	11889851000000	17600	8897	0	0	\N
304267	1678	20160708218000	17600	8897	1	0	\N
304268	1678	20160708219000	17600	8897	2	0	\N
304269	1678	20160708220000	17600	8897	3	0	\N
304270	1678	20160708221000	17600	8897	4	0	\N
304271	1678	20160708222000	17600	8897	5	0	\N
304272	1678	20160708223000	17600	8897	6	0	\N
304273	1678	20160708224000	17600	8897	7	0	\N
304274	1678	20160708225000	17600	8897	8	0	\N
304275	1678	20160708226000	17600	8897	9	0	\N
304276	1678	20160708227000	17600	8897	10	0	\N
304277	1874	6904000	17600	8897	11	0	\N
304278	1874	6907000	17600	8897	12	0	\N
304279	1874	6910000	17600	8897	13	0	\N
304280	1874	6913000	17600	8897	14	0	\N
304281	1874	6916000	17600	8897	15	0	\N
304282	1874	6919000	17600	8897	16	0	\N
304283	1874	6922000	17600	8897	17	0	\N
304284	1874	6925000	17600	8897	18	0	\N
304285	1874	6928000	17600	8897	19	0	\N
304286	1874	6931000	17600	8897	20	0	\N
304287	1866	9452631301632	17601	8745	0	0	\N
304288	2164	500000000	17601	8745	1	0	\N
304289	352	66613938193897	17601	8745	2	0	\N
304290	600	66613938193897	17601	8745	3	0	\N
304291	620	66613938193897	17601	8745	4	0	\N
304292	1150	613559297664572	17601	8745	5	0	\N
304293	1811	1675947484894	17601	8745	6	0	\N
304294	84	66613938193897	17601	8745	7	0	\N
304295	2017	612537528296	17601	8745	8	0	\N
304296	1516	1298566290000	17601	8745	9	0	\N
304297	1242	611019660000000	17601	8745	10	0	\N
304298	1122	905590055000000	17601	8745	11	0	\N
304299	1678	19440672017000	17601	8745	12	0	\N
304300	1678	19440672018000	17601	8745	13	0	\N
304301	1678	19440672019000	17601	8745	14	0	\N
304302	1678	19440672020000	17601	8745	15	0	\N
304303	1678	19440672021000	17601	8745	16	0	\N
304304	1678	19440672022000	17601	8745	17	0	\N
304305	520	66613938193897	17601	8745	18	0	\N
304306	89	66613938193897	17601	8745	19	0	\N
304307	186	66613938193897	17601	8745	20	0	\N
304308	383	66613938193897	17601	8745	21	0	\N
304309	392	66613938193897	17601	8745	22	0	\N
304310	308	66613938193897	17601	8745	23	0	\N
304311	551	66613938193897	17601	8745	24	0	\N
304312	2164	529600000000	17601	8745	25	0	\N
304313	678	66613938193897	17601	8745	26	0	\N
304314	91	66613938193897	17601	8745	27	0	\N
304315	438	66613938193897	17601	8745	28	0	\N
304316	593	66612937193897	17601	8745	29	0	\N
304317	408	66613938193897	17601	8745	30	0	\N
304318	601	66613938193897	17601	8745	31	0	\N
304319	691	66613938193897	17601	8745	32	0	\N
304320	339	66613938193897	17601	8745	33	0	\N
304321	745	2018604187613	17601	8745	34	0	\N
304322	63	66613938193897	17601	8745	36	0	\N
304323	1772	4389917417867	17601	8745	37	0	\N
304324	92	66613938193897	17601	8745	38	0	\N
304325	150	66613938193897	17601	8745	39	0	\N
304326	373	66613938193897	17601	8745	40	0	\N
304327	1516	1474719030000	17601	8745	41	0	\N
304328	1678	19440672023000	17601	8745	42	0	\N
304329	1678	19440672024000	17601	8745	43	0	\N
304330	1678	19440672025000	17601	8745	44	0	\N
304331	1678	19440672026000	17601	8745	45	0	\N
304332	1678	19440672027000	17601	8745	46	0	\N
304333	1678	19440672028000	17601	8745	47	0	\N
304334	1678	19440672029000	17601	8745	48	0	\N
304335	1678	19440672030000	17601	8745	49	0	\N
304336	1678	19440672031000	17601	8745	50	0	\N
304337	1678	19440672032000	17601	8745	51	0	\N
304338	1678	19440672033000	17601	8745	52	0	\N
304339	1678	19440672034000	17601	8745	53	0	\N
304340	1678	19440672035000	17601	8745	54	0	\N
304341	1678	19440672036000	17601	8745	55	0	\N
304342	1678	19440672037000	17601	8745	56	0	\N
304343	1678	19440672038000	17601	8745	57	0	\N
304344	1678	19440672039000	17601	8745	58	0	\N
304345	1678	19440672040000	17601	8745	59	0	\N
304346	1505	0	17601	8745	60	0	\N
304347	322	66613938193897	17601	8745	61	0	\N
304348	453	66613938193897	17601	8745	62	0	\N
304349	450	66613938193897	17601	8745	63	0	\N
304350	395	66110897193897	17601	8745	64	0	\N
304351	29	7065114656873	17601	8745	65	0	\N
304352	138	66613938193897	17601	8745	66	0	\N
304353	910	507454463072188	17601	8745	67	0	\N
304354	500	66613938193897	17601	8745	68	0	\N
304355	146	66613938193897	17601	8745	69	0	\N
304356	504	66613938193897	17601	8745	70	0	\N
304357	587	66613938193897	17601	8745	71	0	\N
304358	1961	612850369124	17601	8745	72	0	\N
304359	611	66613938193897	17601	8745	73	0	\N
304360	205	66613938193897	17601	8745	74	0	\N
304361	658	66613938193897	17601	8745	75	0	\N
304362	78	66613938193897	17601	8745	76	0	\N
304363	660	66613938193897	17601	8745	77	0	\N
304364	1276	1709737537593210	17601	8745	78	0	\N
304365	194	66613938193897	17601	8745	79	0	\N
304366	105	66613938193897	17601	8745	80	0	\N
304367	122	66613938193897	17601	8745	81	0	\N
304368	622	66616918193897	17601	8745	82	0	\N
304369	653	66613938193897	17601	8745	83	0	\N
304370	304	66613938193897	17601	8745	84	0	\N
304371	206	66613938193897	17601	8745	85	0	\N
304372	399	66613938193897	17601	8745	86	0	\N
304373	54	66613938193897	17601	8745	87	0	\N
304374	710	5046510469181	17601	8745	88	0	\N
304375	499	66613938193897	17601	8745	89	0	\N
304376	721	2018604187613	17601	8745	90	0	\N
304377	103	66613938193897	17601	8745	91	0	\N
304378	217	66613938193897	17601	8745	92	0	\N
304379	893	309677012160129	17601	8745	93	0	\N
304380	251	66613938193897	17601	8745	94	0	\N
304381	35	19378600201813	17601	8745	95	0	\N
304382	49	66613938193897	17601	8745	96	0	\N
304383	320	66332738193897	17601	8745	97	0	\N
304384	1030	909354049955700	17601	8745	98	0	\N
304385	569	66613938193897	17601	8745	99	0	\N
304386	663	66613938193897	17601	8745	100	0	\N
304387	108	66613938193897	17601	8745	101	0	\N
304388	390	66613938193897	17601	8745	102	0	\N
304389	894	309677012160129	17601	8745	103	0	\N
304390	570	66613938193897	17601	8745	104	0	\N
304391	1678	19440672041000	17601	8745	105	0	\N
304392	1678	19440672042000	17601	8745	106	0	\N
304393	1678	19440672043000	17601	8745	107	0	\N
304394	1678	19440672044000	17601	8745	108	0	\N
304395	1678	19440672045000	17601	8745	109	0	\N
304396	1678	19440672046000	17601	8745	110	0	\N
304397	1678	19440672047000	17601	8745	111	0	\N
304398	1678	19440672048000	17601	8745	112	0	\N
304399	1678	19440672049000	17601	8745	113	0	\N
304400	1678	19440672050000	17601	8745	114	0	\N
304401	1678	19440672051000	17601	8745	115	0	\N
304402	1678	19440672052000	17601	8745	116	0	\N
304403	1678	19440672053000	17601	8745	117	0	\N
304404	1678	19440672054000	17601	8745	118	0	\N
304405	99	66613938193897	17601	8745	119	0	\N
304406	377	66613938193897	17601	8745	120	0	\N
304407	225	66613938193897	17601	8745	121	0	\N
304408	560	66613938193897	17601	8745	122	0	\N
304409	252	66613938193897	17601	8745	123	0	\N
304410	163	66613938193897	17601	8745	124	0	\N
304411	82	66613938193897	17601	8745	125	0	\N
304416	1678	20160708228000	17604	8904	0	0	\N
304417	1678	20160708229000	17604	8904	1	0	\N
304418	1678	20160708230000	17604	8904	2	0	\N
304419	1874	6952000	17604	8904	3	0	\N
304420	1874	6955000	17604	8904	4	0	\N
304421	1678	20160708228000	17605	8904	0	0	\N
304422	1678	20160708229000	17605	8904	1	0	\N
304423	1678	20160708230000	17605	8904	2	0	\N
304424	1874	6952000	17605	8904	3	0	\N
304425	1874	6955000	17605	8904	4	0	\N
304426	1874	6957000	17605	8904	5	0	\N
304427	1874	6959000	17605	8904	6	0	\N
304428	1874	6961000	17605	8904	7	0	\N
304429	1874	6963000	17605	8904	8	0	\N
304430	1678	20160708228000	17606	8905	0	0	\N
304431	1678	20160708229000	17606	8905	1	0	\N
304432	1678	20160708230000	17606	8905	2	0	\N
304433	1678	20160708231000	17606	8905	3	0	\N
304434	1874	6958000	17606	8905	4	0	\N
304447	1678	20160708233000	17609	8907	0	0	\N
304448	1874	6974000	17609	8907	1	0	\N
304449	1874	6976000	17609	8907	2	0	\N
304450	1874	6978000	17609	8907	3	0	\N
304451	1678	20160708233000	17610	8907	0	0	\N
304452	1874	6974000	17610	8907	1	0	\N
304453	1874	6976000	17610	8907	2	0	\N
304454	1874	6978000	17610	8907	3	0	\N
304455	1678	20160708233000	17611	8907	0	0	\N
304456	1874	6974000	17611	8907	1	0	\N
304457	1874	6976000	17611	8907	2	0	\N
304458	1874	6978000	17611	8907	3	0	\N
304466	1678	20160708234000	17614	8908	0	0	\N
304467	1874	6980000	17614	8908	1	0	\N
304468	1874	6983000	17614	8908	2	0	\N
304469	1678	20160708234000	17615	8908	0	0	\N
304470	1874	6980000	17615	8908	1	0	\N
304471	1874	6983000	17615	8908	2	0	\N
304475	1678	20160708235000	17617	8909	0	0	\N
304476	1874	6985000	17617	8909	1	0	\N
304477	1874	6988000	17617	8909	2	0	\N
304481	1678	20160708236000	17619	8910	0	0	\N
304482	1874	6991000	17619	8910	1	0	\N
304483	1874	6993000	17619	8910	2	0	\N
304484	1678	20160708236000	17620	8910	0	0	\N
304485	1874	6991000	17620	8910	1	0	\N
304486	1874	6993000	17620	8910	2	0	\N
304487	1874	6991000	17621	8910	0	0	\N
304494	1678	20160708238000	17624	8912	0	0	\N
304495	1874	7001000	17624	8912	1	0	\N
304496	1874	7003000	17624	8912	2	0	\N
304497	1678	20160708238000	17625	8912	0	0	\N
304498	1874	7001000	17625	8912	1	0	\N
304499	1874	7003000	17625	8912	2	0	\N
304414	1874	6952000	17603	8904	0	0	2
304415	1874	6955000	17603	8904	1	0	2
304435	1678	20160708228000	17607	8905	0	0	0
304436	1678	20160708229000	17607	8905	1	0	0
304437	1678	20160708230000	17607	8905	2	0	0
304439	1874	6958000	17607	8905	4	0	2
304440	1874	6960000	17607	8905	5	0	2
304441	1874	6962000	17607	8905	6	0	2
304442	1874	6964000	17607	8905	7	0	2
304443	1874	6966000	17607	8905	8	0	2
304445	1678	20160708232000	17608	8906	0	0	0
304446	1874	6971000	17608	8906	1	0	2
304459	1678	20160708233000	17612	8907	0	0	0
304460	1874	6974000	17612	8907	1	0	2
304462	1874	6978000	17612	8907	3	0	2
304463	1678	20160708234000	17613	8908	0	0	0
304464	1874	6980000	17613	8908	1	0	2
304465	1874	6983000	17613	8908	2	0	2
304472	1678	20160708235000	17616	8909	0	0	0
304474	1874	6988000	17616	8909	2	0	2
304478	1678	20160708236000	17618	8910	0	0	0
304479	1874	6991000	17618	8910	1	0	2
304480	1874	6993000	17618	8910	2	0	2
304488	1678	20160708237000	17622	8911	0	0	0
304490	1874	6998000	17622	8911	2	0	2
304491	1678	20160708238000	17623	8912	0	0	0
304492	1874	7001000	17623	8912	1	0	2
304493	1874	7003000	17623	8912	2	0	2
304501	1678	20160708240000	17626	8913	1	0	0
304502	1874	7006000	17626	8913	2	0	2
304503	1874	7008000	17626	8913	3	0	2
304504	1874	7010000	17626	8913	4	0	2
304506	1678	20160708239000	17627	8913	0	0	\N
304507	1678	20160708240000	17627	8913	1	0	\N
304508	1874	7006000	17627	8913	2	0	\N
304509	1874	7008000	17627	8913	3	0	\N
304510	1874	7010000	17627	8913	4	0	\N
304511	1874	7013000	17627	8913	5	0	\N
304512	1678	20160708239000	17628	8913	0	0	\N
304513	1678	20160708240000	17628	8913	1	0	\N
304514	1874	7006000	17628	8913	2	0	\N
304515	1874	7008000	17628	8913	3	0	\N
304516	1874	7010000	17628	8913	4	0	\N
304517	1874	7013000	17628	8913	5	0	\N
304518	1678	20160708241000	17629	8914	0	0	\N
304519	1874	7016000	17629	8914	1	0	\N
304520	1874	7018000	17629	8914	2	0	\N
304521	1678	20160708241000	17630	8914	0	0	\N
304522	1874	7016000	17630	8914	1	0	\N
304523	1874	7018000	17630	8914	2	0	\N
304527	1866	9452631301632	17632	8702	0	0	\N
304528	2164	500000000	17632	8702	1	0	\N
304529	1678	18720659961000	17632	8702	2	0	\N
304530	1678	18720659962000	17632	8702	3	0	\N
304531	1678	18720659963000	17632	8702	4	0	\N
304532	352	66613938193897	17632	8702	5	0	\N
304533	600	66613938193897	17632	8702	6	0	\N
304534	620	66613938193897	17632	8702	7	0	\N
304535	1150	613559297664572	17632	8702	8	0	\N
304536	1811	1675947484894	17632	8702	9	0	\N
304537	84	66613938193897	17632	8702	10	0	\N
304538	2017	612537528296	17632	8702	11	0	\N
304539	1678	18720659964000	17632	8702	12	0	\N
304540	1678	18720659965000	17632	8702	13	0	\N
304541	1678	18720659966000	17632	8702	14	0	\N
304542	1516	1298566290000	17632	8702	15	0	\N
304543	1242	611019660000000	17632	8702	16	0	\N
304544	1122	905590055000000	17632	8702	17	0	\N
304545	520	66613938193897	17632	8702	18	0	\N
304546	89	66613938193897	17632	8702	19	0	\N
304547	186	66613938193897	17632	8702	20	0	\N
304548	383	66613938193897	17632	8702	21	0	\N
304549	392	66613938193897	17632	8702	22	0	\N
304550	308	66613938193897	17632	8702	23	0	\N
304551	551	66613938193897	17632	8702	24	0	\N
304552	1678	18720659967000	17632	8702	25	0	\N
304553	1678	18720659968000	17632	8702	26	0	\N
304554	2164	529600000000	17632	8702	27	0	\N
304555	678	66613938193897	17632	8702	28	0	\N
304556	91	66613938193897	17632	8702	29	0	\N
304557	438	66613938193897	17632	8702	30	0	\N
304558	593	66612937193897	17632	8702	31	0	\N
304559	408	66613938193897	17632	8702	32	0	\N
304560	601	66613938193897	17632	8702	33	0	\N
304561	691	66613938193897	17632	8702	34	0	\N
304562	339	66613938193897	17632	8702	35	0	\N
304563	745	2018604187613	17632	8702	36	0	\N
304564	63	66613938193897	17632	8702	37	0	\N
304565	1772	4389917417867	17632	8702	38	0	\N
304566	92	66613938193897	17632	8702	39	0	\N
304567	150	66613938193897	17632	8702	40	0	\N
304568	373	66613938193897	17632	8702	41	0	\N
304569	1678	18720659969000	17632	8702	42	0	\N
304570	1678	18720659970000	17632	8702	43	0	\N
304571	1678	18720659971000	17632	8702	44	0	\N
304572	1678	18720659972000	17632	8702	45	0	\N
304573	1678	18720659973000	17632	8702	46	0	\N
304574	1678	18720659974000	17632	8702	47	0	\N
304575	1678	18720659975000	17632	8702	48	0	\N
304576	1678	18720659976000	17632	8702	49	0	\N
304577	1678	18720659977000	17632	8702	51	0	\N
304578	1678	18720659978000	17632	8702	52	0	\N
304579	1678	18720659979000	17632	8702	53	0	\N
304580	1678	18720659980000	17632	8702	54	0	\N
304581	1678	18720659981000	17632	8702	55	0	\N
304582	1678	18720659982000	17632	8702	56	0	\N
304583	1678	18720659983000	17632	8702	57	0	\N
304584	1678	18720659984000	17632	8702	58	0	\N
304585	1678	18720659985000	17632	8702	59	0	\N
304586	1678	18720659986000	17632	8702	60	0	\N
304587	1678	18720659987000	17632	8702	61	0	\N
304588	1516	1474719030000	17632	8702	62	0	\N
304589	1505	0	17632	8702	63	0	\N
304590	322	66613938193897	17632	8702	64	0	\N
304591	453	66613938193897	17632	8702	65	0	\N
304592	450	66613938193897	17632	8702	66	0	\N
304593	395	66110897193897	17632	8702	67	0	\N
304594	29	7065114656873	17632	8702	68	0	\N
304595	138	66613938193897	17632	8702	69	0	\N
304596	910	507454463072188	17632	8702	70	0	\N
304597	500	66613938193897	17632	8702	71	0	\N
304598	146	66613938193897	17632	8702	72	0	\N
304599	504	66613938193897	17632	8702	73	0	\N
304600	587	66613938193897	17632	8702	74	0	\N
304601	1961	612850369124	17632	8702	75	0	\N
304602	611	66613938193897	17632	8702	76	0	\N
304603	205	66613938193897	17632	8702	77	0	\N
304604	658	66613938193897	17632	8702	78	0	\N
304605	78	66613938193897	17632	8702	79	0	\N
304606	660	66613938193897	17632	8702	80	0	\N
304607	1276	1709737537593210	17632	8702	81	0	\N
304608	194	66613938193897	17632	8702	82	0	\N
304609	105	66613938193897	17632	8702	83	0	\N
304610	122	66613938193897	17632	8702	84	0	\N
304611	622	66616918193897	17632	8702	85	0	\N
304612	653	66613938193897	17632	8702	86	0	\N
304613	304	66613938193897	17632	8702	87	0	\N
304614	206	66613938193897	17632	8702	88	0	\N
304615	399	66613938193897	17632	8702	89	0	\N
304616	54	66613938193897	17632	8702	90	0	\N
304617	710	5046510469181	17632	8702	91	0	\N
304618	499	66613938193897	17632	8702	92	0	\N
304619	721	2018604187613	17632	8702	93	0	\N
304620	103	66613938193897	17632	8702	94	0	\N
304621	217	66613938193897	17632	8702	95	0	\N
304622	893	309677012160129	17632	8702	96	0	\N
304623	251	66613938193897	17632	8702	97	0	\N
304624	35	19378600201813	17632	8702	98	0	\N
304625	49	66613938193897	17632	8702	99	0	\N
304626	320	66332738193897	17632	8702	100	0	\N
304627	1030	909354049955700	17632	8702	101	0	\N
304628	569	66613938193897	17632	8702	102	0	\N
304629	663	66613938193897	17632	8702	103	0	\N
304630	108	66613938193897	17632	8702	104	0	\N
304631	390	66613938193897	17632	8702	105	0	\N
304632	894	309677012160129	17632	8702	106	0	\N
304633	570	66613938193897	17632	8702	107	0	\N
304634	1678	18720659988000	17632	8702	108	0	\N
304635	1678	18720659989000	17632	8702	109	0	\N
304636	1678	18720659990000	17632	8702	110	0	\N
304637	1678	18720659991000	17632	8702	111	0	\N
304638	1678	18720659992000	17632	8702	112	0	\N
304639	1678	18720659993000	17632	8702	113	0	\N
304640	1678	18720659994000	17632	8702	114	0	\N
304525	1874	7016000	17631	8914	1	0	2
304526	1874	7018000	17631	8914	2	0	2
304641	1678	18720659995000	17632	8702	115	0	\N
304642	1678	18720659996000	17632	8702	116	0	\N
304643	1678	18720659997000	17632	8702	117	0	\N
304644	1678	18720659998000	17632	8702	118	0	\N
304645	1678	18720659999000	17632	8702	119	0	\N
304646	1678	18720660000000	17632	8702	120	0	\N
304647	1678	18720660001000	17632	8702	121	0	\N
304648	1678	18720660002000	17632	8702	122	0	\N
304649	1678	18720660003000	17632	8702	123	0	\N
304650	1678	18720660004000	17632	8702	124	0	\N
304651	1678	18720660005000	17632	8702	125	0	\N
304655	1678	20160708243000	17634	8916	0	0	\N
304656	1874	7025000	17634	8916	1	0	\N
304657	1874	7028000	17634	8916	2	0	\N
304664	1678	20160708244000	17637	8917	0	0	\N
304665	1874	7030000	17637	8917	1	0	\N
304666	1874	7033000	17637	8917	2	0	\N
304667	1678	20160708244000	17638	8917	0	0	\N
304668	1874	7030000	17638	8917	1	0	\N
304669	1874	7033000	17638	8917	2	0	\N
304670	1950	11889851000000	17639	8843	0	0	\N
304671	122	66613938193897	17639	8843	1	0	\N
304672	622	66616918193897	17639	8843	2	0	\N
304673	653	66613938193897	17639	8843	3	0	\N
304674	1242	611019660000000	17639	8843	4	0	\N
304675	1122	905590055000000	17639	8843	5	0	\N
304676	304	66613938193897	17639	8843	6	0	\N
304677	206	66613938193897	17639	8843	7	0	\N
304678	399	66613938193897	17639	8843	8	0	\N
304679	54	66613938193897	17639	8843	9	0	\N
304680	710	5046510469181	17639	8843	10	0	\N
304681	499	66613938193897	17639	8843	11	0	\N
304682	721	2018604187613	17639	8843	12	0	\N
304683	103	66613938193897	17639	8843	13	0	\N
304684	217	66613938193897	17639	8843	14	0	\N
304685	1678	20160708149000	17639	8843	15	0	\N
304686	1678	20160708150000	17639	8843	16	0	\N
304687	1678	20160708151000	17639	8843	17	0	\N
304688	1678	20160708152000	17639	8843	18	0	\N
304689	1678	20160708153000	17639	8843	19	0	\N
304690	1678	20160708154000	17639	8843	21	0	\N
304691	1678	20160708155000	17639	8843	22	0	\N
304692	1678	20160708156000	17639	8843	23	0	\N
304693	1678	20160708157000	17639	8843	24	0	\N
304694	1678	20160708158000	17639	8843	25	0	\N
304695	1678	20160708159000	17639	8843	26	0	\N
304696	1678	20160708160000	17639	8843	27	0	\N
304697	1678	20160708161000	17639	8843	28	0	\N
304698	1678	20160708162000	17639	8843	29	0	\N
304699	1678	20160708163000	17639	8843	30	0	\N
304700	1678	20160708164000	17639	8843	31	0	\N
304701	1678	20160708165000	17639	8843	32	0	\N
304702	1678	20160708166000	17639	8843	33	0	\N
304703	1678	20160708167000	17639	8843	34	0	\N
304704	1678	20160708168000	17639	8843	35	0	\N
304705	1678	20160708169000	17639	8843	36	0	\N
304706	1678	20160708170000	17639	8843	37	0	\N
304707	1678	20160708171000	17639	8843	38	0	\N
304708	1678	20160708172000	17639	8843	39	0	\N
304709	1678	20160708173000	17639	8843	40	0	\N
304710	1678	20160708174000	17639	8843	41	0	\N
304711	1678	20160708175000	17639	8843	42	0	\N
304712	1678	20160708176000	17639	8843	43	0	\N
304713	1678	20160708177000	17639	8843	44	0	\N
304714	1678	20160708178000	17639	8843	45	0	\N
304715	1678	20160708179000	17639	8843	46	0	\N
304716	1678	20160708180000	17639	8843	47	0	\N
304717	1678	20160708181000	17639	8843	48	0	\N
304718	1678	20160708182000	17639	8843	49	0	\N
304719	1678	20160708183000	17639	8843	50	0	\N
304720	1678	20160708184000	17639	8843	51	0	\N
304721	1678	20160708185000	17639	8843	52	0	\N
304722	1678	20160708186000	17639	8843	53	0	\N
304723	1678	20160708187000	17639	8843	54	0	\N
304724	1678	20160708188000	17639	8843	55	0	\N
304725	1678	20160708189000	17639	8843	56	0	\N
304726	1678	20160708190000	17639	8843	57	0	\N
304727	1678	20160708191000	17639	8843	58	0	\N
304728	893	309677012160129	17639	8843	59	0	\N
304729	251	66613938193897	17639	8843	60	0	\N
304730	35	19378600201813	17639	8843	61	0	\N
304731	49	66613938193897	17639	8843	62	0	\N
304732	320	66332738193897	17639	8843	63	0	\N
304733	1030	909354049955700	17639	8843	64	0	\N
304734	569	66613938193897	17639	8843	65	0	\N
304735	663	66613938193897	17639	8843	66	0	\N
304736	108	66613938193897	17639	8843	67	0	\N
304737	390	66613938193897	17639	8843	68	0	\N
304738	894	309677012160129	17639	8843	69	0	\N
304739	570	66613938193897	17639	8843	70	0	\N
304740	1678	20160708192000	17639	8843	71	0	\N
304741	1678	20160708193000	17639	8843	72	0	\N
304742	1678	20160708194000	17639	8843	73	0	\N
304743	1678	20160708195000	17639	8843	74	0	\N
304744	1678	20160708196000	17639	8843	75	0	\N
304745	1678	20160708197000	17639	8843	76	0	\N
304746	1678	20160708198000	17639	8843	77	0	\N
304747	1678	20160708199000	17639	8843	78	0	\N
304748	1678	20160708200000	17639	8843	79	0	\N
304749	1678	20160708201000	17639	8843	80	0	\N
304750	1678	20160708202000	17639	8843	81	0	\N
304751	1678	20160708203000	17639	8843	82	0	\N
304752	1678	20160708204000	17639	8843	83	0	\N
304753	1678	20160708205000	17639	8843	84	0	\N
304754	1678	20160708206000	17639	8843	85	0	\N
304755	1678	20160708207000	17639	8843	86	0	\N
304756	1678	20160708208000	17639	8843	87	0	\N
304757	1678	20160708209000	17639	8843	88	0	\N
304758	1678	20160708210000	17639	8843	89	0	\N
304759	1678	20160708211000	17639	8843	90	0	\N
304760	1678	20160708212000	17639	8843	91	0	\N
304761	1678	20160708213000	17639	8843	92	0	\N
304762	1678	20160708214000	17639	8843	93	0	\N
304763	1678	20160708215000	17639	8843	94	0	\N
304764	1678	20160708216000	17639	8843	95	0	\N
304765	1678	20160708217000	17639	8843	96	0	\N
304766	99	66613938193897	17639	8843	97	0	\N
304767	377	66613938193897	17639	8843	98	0	\N
304768	225	66613938193897	17639	8843	99	0	\N
304769	560	66613938193897	17639	8843	100	0	\N
304770	252	66613938193897	17639	8843	101	0	\N
304771	163	66613938193897	17639	8843	102	0	\N
304772	82	66613938193897	17639	8843	103	0	\N
304773	361	66613938193897	17639	8843	104	0	\N
304774	594	66613938193897	17639	8843	105	0	\N
304775	309	66613938193897	17639	8843	106	0	\N
304776	201	66613938193897	17639	8843	107	0	\N
304654	1874	7023000	17633	8915	2	0	2
304658	1678	20160708243000	17635	8916	0	0	0
304659	1874	7025000	17635	8916	1	0	2
304660	1874	7028000	17635	8916	2	0	2
304661	1678	20160708244000	17636	8917	0	0	0
304663	1874	7033000	17636	8917	2	0	2
304777	1962	612850369124	17639	8843	108	0	\N
304778	275	66613938193897	17639	8843	109	0	\N
304779	397	66613938193897	17639	8843	110	0	\N
304780	402	66613938193897	17639	8843	111	0	\N
304781	391	66613938193897	17639	8843	112	0	\N
304782	452	66613938193897	17639	8843	113	0	\N
304783	2073	612113103967	17639	8843	114	0	\N
304784	680	66613938193897	17639	8843	115	0	\N
304785	690	66613938193897	17639	8843	116	0	\N
304786	731	2018604187613	17639	8843	117	0	\N
304787	180	66613938193897	17639	8843	118	0	\N
304788	112	66084906193897	17639	8843	119	0	\N
304789	353	66613928193897	17639	8843	120	0	\N
304790	652	66613938193897	17639	8843	121	0	\N
304791	420	66083228193897	17639	8843	122	0	\N
304792	191	66613938193897	17639	8843	123	0	\N
304793	266	66613938193897	17639	8843	124	0	\N
304794	534	66613938193897	17639	8843	125	0	\N
304798	1678	20160708245000	17641	8918	0	0	\N
304799	1874	7035000	17641	8918	1	0	\N
304800	1874	7038000	17641	8918	2	0	\N
304809	2166	200000000	17644	8921	0	0	\N
304810	1678	20160708248000	17644	8921	1	0	\N
304811	2167	200000000	17644	8921	2	0	\N
304812	2168	200000000	17644	8921	3	0	\N
304813	2169	200000000	17644	8921	4	0	\N
304814	1874	7051000	17644	8921	5	0	\N
304815	1874	7054000	17644	8921	6	0	\N
304816	2166	200000000	17645	8921	0	0	\N
304817	1678	20160708248000	17645	8921	1	0	\N
304818	2167	200000000	17645	8921	2	0	\N
304819	2168	200000000	17645	8921	3	0	\N
304820	2169	200000000	17645	8921	4	0	\N
304821	1874	7051000	17645	8921	5	0	\N
304822	1874	7054000	17645	8921	6	0	\N
304823	2166	200000000	17646	8921	0	0	\N
304824	1678	20160708248000	17646	8921	1	0	\N
304825	2167	200000000	17646	8921	2	0	\N
304826	2168	200000000	17646	8921	3	0	\N
304827	2169	200000000	17646	8921	4	0	\N
304828	1874	7051000	17646	8921	5	0	\N
304829	1874	7054000	17646	8921	6	0	\N
304844	1678	20160708252000	17649	8923	0	0	\N
304845	1874	7068000	17649	8923	2	0	\N
304848	1678	18720660006000	17651	8703	0	0	\N
304849	1678	18720660007000	17651	8703	1	0	\N
304850	1678	18720660008000	17651	8703	2	0	\N
304851	2165	200000000	17651	8703	3	0	\N
304852	2166	200000000	17651	8703	4	0	\N
304853	1678	18720660009000	17651	8703	5	0	\N
304854	1678	18720660010000	17651	8703	6	0	\N
304855	1678	18720660011000	17651	8703	7	0	\N
304856	1678	18720660012000	17651	8703	8	0	\N
304857	1678	18720660013000	17651	8703	9	0	\N
304858	1678	18720660014000	17651	8703	10	0	\N
304859	1678	18720660015000	17651	8703	11	0	\N
304860	1678	18720660016000	17651	8703	12	0	\N
304861	1678	18720660017000	17651	8703	13	0	\N
304862	1678	18720660018000	17651	8703	14	0	\N
304863	1678	18720660019000	17651	8703	15	0	\N
304864	1678	18720660020000	17651	8703	16	0	\N
304865	1678	18720660021000	17651	8703	17	0	\N
304866	1678	18720660022000	17651	8703	18	0	\N
304867	1678	18720660023000	17651	8703	19	0	\N
304868	1678	18720660024000	17651	8703	20	0	\N
304869	1678	18720660025000	17651	8703	21	0	\N
304870	1678	18720660026000	17651	8703	22	0	\N
304871	1678	18720660027000	17651	8703	23	0	\N
304872	1678	18720660028000	17651	8703	24	0	\N
304873	1678	18720660029000	17651	8703	25	0	\N
304874	1678	18720660030000	17651	8703	26	0	\N
304875	1678	18720660031000	17651	8703	27	0	\N
304876	1678	18720660032000	17651	8703	28	0	\N
304877	1678	18720660033000	17651	8703	29	0	\N
304878	1678	18720660034000	17651	8703	30	0	\N
304879	1678	18720660035000	17651	8703	31	0	\N
304880	1678	18720660036000	17651	8703	32	0	\N
304881	1678	18720660037000	17651	8703	33	0	\N
304882	1678	18720660038000	17651	8703	34	0	\N
304883	1678	18720660039000	17651	8703	35	0	\N
304884	1678	18720660040000	17651	8703	36	0	\N
304885	2167	200000000	17651	8703	37	0	\N
304886	2168	200000000	17651	8703	38	0	\N
304887	2169	200000000	17651	8703	39	0	\N
304888	1678	18720660041000	17651	8703	40	0	\N
304889	1678	18720660042000	17651	8703	41	0	\N
304890	1678	18720660043000	17651	8703	42	0	\N
304891	1678	18720660044000	17651	8703	43	0	\N
304892	1678	18720660045000	17651	8703	44	0	\N
304893	1678	18720660046000	17651	8703	45	0	\N
304894	1678	18720660047000	17651	8703	46	0	\N
304895	1678	18720660048000	17651	8703	47	0	\N
304896	1678	18720660049000	17651	8703	48	0	\N
304897	1678	18720660050000	17651	8703	49	0	\N
304898	1678	18720660051000	17651	8703	51	0	\N
304899	1678	18720660052000	17651	8703	52	0	\N
304900	1678	18720660053000	17651	8703	53	0	\N
304901	1678	18720660054000	17651	8703	54	0	\N
304902	1678	18720660055000	17651	8703	55	0	\N
304903	1678	18720660056000	17651	8703	56	0	\N
304904	1678	18720660057000	17651	8703	57	0	\N
304905	1678	18720660058000	17651	8703	58	0	\N
304906	1678	18720660059000	17651	8703	59	0	\N
304907	1678	18720660060000	17651	8703	60	0	\N
304908	1678	18720660061000	17651	8703	61	0	\N
304909	1678	18720660062000	17651	8703	62	0	\N
304910	1678	18720660063000	17651	8703	63	0	\N
304911	1678	18720660064000	17651	8703	64	0	\N
304912	1678	18720660065000	17651	8703	65	0	\N
304797	1874	7038000	17640	8918	2	0	2
304801	1678	20160708246000	17642	8919	0	0	0
304802	1874	7041000	17642	8919	1	0	2
304803	1874	7043000	17642	8919	2	0	2
304804	2165	200000000	17643	8920	0	0	0
304806	1874	7044000	17643	8920	2	0	2
304807	1874	7047000	17643	8920	3	0	2
304808	1874	7049000	17643	8920	4	0	2
304830	2166	200000000	17647	8921	0	0	0
304831	1678	20160708248000	17647	8921	1	0	0
304833	2168	200000000	17647	8921	3	0	0
304834	2169	200000000	17647	8921	4	0	0
304835	1874	7051000	17647	8921	5	0	2
304836	1874	7054000	17647	8921	6	0	2
304838	1678	20160708250000	17648	8922	1	0	0
304839	1678	20160708251000	17648	8922	2	0	0
304840	1874	7057000	17648	8922	3	0	2
304841	1874	7060000	17648	8922	4	0	2
304842	1874	7063000	17648	8922	5	0	2
304846	1678	20160708252000	17650	8923	0	0	0
304847	1874	7068000	17650	8923	2	0	2
304913	1678	18720660066000	17651	8703	66	0	\N
304914	1678	18720660067000	17651	8703	67	0	\N
304915	1678	18720660068000	17651	8703	68	0	\N
304916	1678	18720660069000	17651	8703	69	0	\N
304917	1678	18720660070000	17651	8703	70	0	\N
304918	1678	18720660071000	17651	8703	71	0	\N
304919	1678	18720660072000	17651	8703	72	0	\N
304920	1678	18720660073000	17651	8703	73	0	\N
304921	1678	18720660074000	17651	8703	74	0	\N
304922	1678	18720660075000	17651	8703	75	0	\N
304923	1678	18720660076000	17651	8703	76	0	\N
304924	1678	18720660077000	17651	8703	77	0	\N
304925	1678	18720660078000	17651	8703	78	0	\N
304926	1678	18720660079000	17651	8703	79	0	\N
304927	1678	18720660080000	17651	8703	80	0	\N
304928	1678	18720660081000	17651	8703	81	0	\N
304929	1678	18720660082000	17651	8703	82	0	\N
304930	1678	18720660083000	17651	8703	83	0	\N
304931	1678	18720660084000	17651	8703	84	0	\N
304932	1678	18720660085000	17651	8703	85	0	\N
304933	1678	18720660086000	17651	8703	86	0	\N
304934	1678	18720660087000	17651	8703	87	0	\N
304935	1678	18720660088000	17651	8703	88	0	\N
304936	1678	18720660089000	17651	8703	89	0	\N
304937	1678	18720660090000	17651	8703	90	0	\N
304938	1678	18720660091000	17651	8703	91	0	\N
304939	1678	18720660092000	17651	8703	92	0	\N
304940	1678	18720660093000	17651	8703	93	0	\N
304941	1678	18720660094000	17651	8703	94	0	\N
304942	1678	18720660095000	17651	8703	95	0	\N
304943	1678	18720660096000	17651	8703	96	0	\N
304944	1678	18720660097000	17651	8703	97	0	\N
304945	1678	18720660098000	17651	8703	98	0	\N
304946	1678	18720660099000	17651	8703	99	0	\N
304947	1678	18720660100000	17651	8703	100	0	\N
304948	1678	18720660101000	17651	8703	101	0	\N
304949	1678	18720660102000	17651	8703	102	0	\N
304950	1678	18720660103000	17651	8703	103	0	\N
304951	1678	18720660104000	17651	8703	104	0	\N
304952	1678	18720660105000	17651	8703	105	0	\N
304953	1678	18720660106000	17651	8703	106	0	\N
304954	1678	18720660107000	17651	8703	107	0	\N
304955	1678	18720660108000	17651	8703	108	0	\N
304956	1678	18720660109000	17651	8703	109	0	\N
304957	1678	18720660110000	17651	8703	110	0	\N
304958	1678	18720660111000	17651	8703	111	0	\N
304959	1678	18720660112000	17651	8703	112	0	\N
304960	1678	18720660113000	17651	8703	113	0	\N
304961	1678	18720660114000	17651	8703	114	0	\N
304962	1678	18720660115000	17651	8703	115	0	\N
304963	1678	18720660116000	17651	8703	116	0	\N
304964	1678	18720660117000	17651	8703	117	0	\N
304965	1678	18720660118000	17651	8703	118	0	\N
304966	1678	18720660119000	17651	8703	119	0	\N
304967	1678	18720660120000	17651	8703	120	0	\N
304968	1678	18720660121000	17651	8703	121	0	\N
304969	1678	18720660122000	17651	8703	122	0	\N
304970	1678	18720660123000	17651	8703	123	0	\N
304971	1678	18720660124000	17651	8703	124	0	\N
304972	1678	18720660125000	17651	8703	125	0	\N
304975	2165	200000000	17653	8911	0	0	\N
304976	2166	200000000	17653	8911	1	0	\N
304977	2167	200000000	17653	8911	2	0	\N
304978	2168	200000000	17653	8911	3	0	\N
304979	2169	200000000	17653	8911	4	0	\N
304980	1874	6994000	17653	8911	5	0	\N
304983	1678	20160708253000	17655	8924	0	0	\N
304984	1678	20160708254000	17655	8924	1	0	\N
304985	1874	7071000	17655	8924	2	0	\N
304986	1874	7074000	17655	8924	3	0	\N
304987	1678	20160708255000	17656	8926	0	0	\N
304988	1874	7077000	17656	8926	1	0	\N
304989	1678	20160708255000	17657	8926	0	0	\N
304990	1874	7077000	17657	8926	1	0	\N
304993	1678	20160708256000	17659	8927	0	0	\N
304994	1874	7080000	17659	8927	1	0	\N
305001	1678	20160708259000	17662	8929	0	0	\N
305002	1678	20160708260000	17662	8929	1	0	\N
305003	1874	7089000	17662	8929	2	0	\N
305004	1874	7092000	17662	8929	3	0	\N
305009	1678	20160708261000	17664	8930	0	0	\N
305010	1874	7095000	17664	8930	1	0	\N
305013	1678	20160708261000	17666	8930	0	0	\N
305014	1874	7095000	17666	8930	1	0	\N
305015	1678	20160708261000	17667	8930	0	0	\N
305016	1874	7095000	17667	8930	1	0	\N
305021	2165	200000000	17670	8746	0	0	\N
305022	2166	200000000	17670	8746	1	0	\N
305023	2167	200000000	17670	8746	2	0	\N
305024	2168	200000000	17670	8746	3	0	\N
305025	2169	200000000	17670	8746	4	0	\N
305026	1678	19440672055000	17670	8746	5	0	\N
305027	1678	19440672056000	17670	8746	6	0	\N
305028	1678	19440672057000	17670	8746	7	0	\N
305029	1678	19440672058000	17670	8746	8	0	\N
305030	1678	19440672059000	17670	8746	9	0	\N
305031	1678	19440672060000	17670	8746	10	0	\N
305032	1678	19440672061000	17670	8746	11	0	\N
305033	1678	19440672062000	17670	8746	12	0	\N
305034	1678	19440672063000	17670	8746	13	0	\N
305035	1678	19440672064000	17670	8746	14	0	\N
305036	1678	19440672065000	17670	8746	15	0	\N
305037	1678	19440672066000	17670	8746	16	0	\N
305038	1678	19440672067000	17670	8746	17	0	\N
305039	1678	19440672068000	17670	8746	18	0	\N
305040	1678	19440672069000	17670	8746	19	0	\N
305041	1678	19440672070000	17670	8746	20	0	\N
305042	1678	19440672071000	17670	8746	21	0	\N
305043	1678	19440672072000	17670	8746	22	0	\N
305044	1678	19440672073000	17670	8746	23	0	\N
305045	1678	19440672074000	17670	8746	24	0	\N
305046	1678	19440672075000	17670	8746	25	0	\N
305047	1678	19440672076000	17670	8746	26	0	\N
305048	1678	19440672077000	17670	8746	27	0	\N
304981	1678	20160708254000	17654	8925	0	0	0
304982	1874	7074000	17654	8925	1	0	2
304991	1678	20160708255000	17658	8926	0	0	0
304992	1874	7077000	17658	8926	1	0	2
304995	1678	20160708256000	17660	8927	0	0	0
304997	1678	20160708257000	17661	8928	0	0	0
304998	1678	20160708258000	17661	8928	1	0	0
304999	1874	7083000	17661	8928	2	0	2
305000	1874	7086000	17661	8928	3	0	2
305005	1678	20160708259000	17663	8929	0	0	0
305007	1874	7089000	17663	8929	2	0	2
305008	1874	7092000	17663	8929	3	0	2
305011	1678	20160708261000	17665	8930	0	0	0
305012	1874	7095000	17665	8930	1	0	2
305018	1874	7098000	17668	8931	1	0	2
305019	1678	20160708263000	17669	8932	0	0	0
305020	1874	7101000	17669	8932	1	0	2
305049	1678	19440672078000	17670	8746	28	0	\N
305050	1678	19440672079000	17670	8746	29	0	\N
305051	1678	19440672080000	17670	8746	30	0	\N
305052	1678	19440672081000	17670	8746	31	0	\N
305053	1678	19440672082000	17670	8746	32	0	\N
305054	1678	19440672083000	17670	8746	33	0	\N
305055	1678	19440672084000	17670	8746	34	0	\N
305056	1678	19440672085000	17670	8746	36	0	\N
305057	1678	19440672086000	17670	8746	37	0	\N
305058	1678	19440672087000	17670	8746	38	0	\N
305059	1678	19440672088000	17670	8746	39	0	\N
305060	1678	19440672089000	17670	8746	40	0	\N
305061	1678	19440672090000	17670	8746	41	0	\N
305062	1678	19440672091000	17670	8746	42	0	\N
305063	1678	19440672092000	17670	8746	43	0	\N
305064	1678	19440672093000	17670	8746	44	0	\N
305065	1678	19440672094000	17670	8746	45	0	\N
305066	1678	19440672095000	17670	8746	46	0	\N
305067	1678	19440672096000	17670	8746	47	0	\N
305068	1678	19440672097000	17670	8746	48	0	\N
305069	1678	19440672098000	17670	8746	49	0	\N
305070	1678	19440672099000	17670	8746	50	0	\N
305071	1678	19440672100000	17670	8746	51	0	\N
305072	1678	19440672101000	17670	8746	52	0	\N
305073	1678	19440672102000	17670	8746	53	0	\N
305074	1678	19440672103000	17670	8746	54	0	\N
305075	1678	19440672104000	17670	8746	55	0	\N
305076	1678	19440672105000	17670	8746	56	0	\N
305077	1678	19440672106000	17670	8746	57	0	\N
305078	1678	19440672107000	17670	8746	58	0	\N
305079	1678	19440672108000	17670	8746	59	0	\N
305080	1678	19440672109000	17670	8746	60	0	\N
305081	1678	19440672110000	17670	8746	61	0	\N
305082	1678	19440672111000	17670	8746	62	0	\N
305083	1678	19440672112000	17670	8746	63	0	\N
305084	1678	19440672113000	17670	8746	64	0	\N
305085	1678	19440672114000	17670	8746	65	0	\N
305086	1678	19440672115000	17670	8746	66	0	\N
305087	1678	19440672116000	17670	8746	67	0	\N
305088	1678	19440672117000	17670	8746	68	0	\N
305089	1678	19440672118000	17670	8746	69	0	\N
305090	1678	19440672119000	17670	8746	70	0	\N
305091	1678	19440672120000	17670	8746	71	0	\N
305092	1678	19440672121000	17670	8746	72	0	\N
305093	1678	19440672122000	17670	8746	73	0	\N
305094	1678	19440672123000	17670	8746	74	0	\N
305095	1678	19440672124000	17670	8746	75	0	\N
305096	1678	19440672125000	17670	8746	76	0	\N
305097	1678	19440672126000	17670	8746	77	0	\N
305098	1678	19440672127000	17670	8746	78	0	\N
305099	1678	19440672128000	17670	8746	79	0	\N
305100	1678	19440672129000	17670	8746	80	0	\N
305101	1678	19440672130000	17670	8746	81	0	\N
305102	1678	19440672131000	17670	8746	82	0	\N
305103	1678	19440672132000	17670	8746	83	0	\N
305104	1678	19440672133000	17670	8746	84	0	\N
305105	1678	19440672134000	17670	8746	85	0	\N
305106	1678	19440672135000	17670	8746	86	0	\N
305107	1678	19440672136000	17670	8746	87	0	\N
305108	1678	19440672137000	17670	8746	88	0	\N
305109	1678	19440672138000	17670	8746	89	0	\N
305110	1678	19440672139000	17670	8746	90	0	\N
305111	1678	19440672140000	17670	8746	91	0	\N
305112	1678	19440672141000	17670	8746	92	0	\N
305113	1678	19440672142000	17670	8746	93	0	\N
305114	1678	19440672143000	17670	8746	94	0	\N
305115	1678	19440672144000	17670	8746	95	0	\N
305116	1678	19440672145000	17670	8746	96	0	\N
305117	1678	19440672146000	17670	8746	97	0	\N
305118	1678	19440672147000	17670	8746	98	0	\N
305119	1678	19440672148000	17670	8746	99	0	\N
305120	1678	19440672149000	17670	8746	100	0	\N
305121	1678	19440672150000	17670	8746	101	0	\N
305122	1678	19440672151000	17670	8746	102	0	\N
305123	1678	19440672152000	17670	8746	103	0	\N
305124	1678	19440672153000	17670	8746	104	0	\N
305125	1678	19440672154000	17670	8746	105	0	\N
305126	1678	19440672155000	17670	8746	106	0	\N
305127	1678	19440672156000	17670	8746	107	0	\N
305128	1678	19440672157000	17670	8746	108	0	\N
305129	1678	19440672158000	17670	8746	109	0	\N
305130	1678	19440672159000	17670	8746	110	0	\N
305131	1678	19440672160000	17670	8746	111	0	\N
305132	1678	19440672161000	17670	8746	112	0	\N
305133	1678	19440672162000	17670	8746	113	0	\N
305134	1678	19440672163000	17670	8746	114	0	\N
305135	1678	19440672164000	17670	8746	115	0	\N
305136	1678	19440672165000	17670	8746	116	0	\N
305137	1678	19440672166000	17670	8746	117	0	\N
305138	1678	19440672167000	17670	8746	118	0	\N
305139	1678	19440672168000	17670	8746	119	0	\N
305140	1678	19440672169000	17670	8746	120	0	\N
305141	1678	19440672170000	17670	8746	121	0	\N
305142	1678	19440672171000	17670	8746	122	0	\N
305143	1678	19440672172000	17670	8746	123	0	\N
305144	1678	19440672173000	17670	8746	124	0	\N
305145	1678	19440672174000	17670	8746	125	0	\N
305146	1678	20160708264000	17671	8933	0	0	\N
305147	1874	7104000	17671	8933	1	0	\N
305150	1678	20160708265000	17673	8934	0	0	\N
305151	1678	20160708266000	17673	8934	1	0	\N
305152	1678	20160708267000	17673	8934	2	0	\N
305153	1678	20160708268000	17673	8934	3	0	\N
305154	1678	20160708269000	17673	8934	4	0	\N
305155	1874	7107000	17673	8934	5	0	\N
305156	1874	7110000	17673	8934	6	0	\N
305157	1874	7113000	17673	8934	7	0	\N
305158	1874	7116000	17673	8934	8	0	\N
305159	1874	7119000	17673	8934	9	0	\N
305170	1678	20160708270000	17675	8935	0	0	\N
305171	1874	7122000	17675	8935	1	0	\N
305172	1678	20160708270000	17676	8935	0	0	\N
305173	1874	7122000	17676	8935	1	0	\N
305176	2165	200000000	17678	8915	0	0	\N
305177	2166	200000000	17678	8915	1	0	\N
305178	2167	200000000	17678	8915	2	0	\N
305179	2168	200000000	17678	8915	3	0	\N
305180	2169	200000000	17678	8915	4	0	\N
305181	1874	7019000	17678	8915	5	0	\N
305160	1678	20160708265000	17674	8934	0	0	0
305161	1678	20160708266000	17674	8934	1	0	0
305162	1678	20160708267000	17674	8934	2	0	0
305163	1678	20160708268000	17674	8934	3	0	0
305164	1678	20160708269000	17674	8934	4	0	0
305166	1874	7110000	17674	8934	6	0	2
305167	1874	7113000	17674	8934	7	0	2
305168	1874	7116000	17674	8934	8	0	2
305169	1874	7119000	17674	8934	9	0	2
305174	1678	20160708270000	17677	8935	0	0	0
305182	1678	20160708271000	17679	8936	0	0	0
305183	1874	7125000	17679	8936	1	0	2
305184	1678	20160708272000	17680	8937	0	0	0
305188	1678	20160708273000	17682	8938	0	0	\N
305189	1874	7131000	17682	8938	1	0	\N
305190	2170	200000000	17683	8939	0	0	\N
305191	1678	20160708274000	17683	8939	1	0	\N
305192	1874	7134000	17683	8939	2	0	\N
305198	1950	11889851000000	17686	8863	0	0	\N
305199	2165	200000000	17686	8863	1	0	\N
305200	2166	200000000	17686	8863	2	0	\N
305201	2167	200000000	17686	8863	3	0	\N
305202	2168	200000000	17686	8863	4	0	\N
305203	2169	200000000	17686	8863	5	0	\N
305204	2170	200000000	17686	8863	6	0	\N
305205	1745	1803000000	17686	8863	7	0	\N
305206	1874	6675000	17686	8863	8	0	\N
305207	1678	20160708275000	17687	8940	0	0	\N
305208	1874	7137000	17687	8940	1	0	\N
305209	1950	11889851000000	17688	8854	0	0	\N
305210	2165	200000000	17688	8854	1	0	\N
305211	2166	200000000	17688	8854	2	0	\N
305212	2167	200000000	17688	8854	3	0	\N
305213	2168	200000000	17688	8854	4	0	\N
305214	2169	200000000	17688	8854	5	0	\N
305215	2170	200000000	17688	8854	6	0	\N
305216	1874	6624000	17688	8854	7	0	\N
305233	1678	20160708276000	17690	8941	0	0	\N
305234	1678	20160708277000	17690	8941	1	0	\N
305235	1678	20160708278000	17690	8941	2	0	\N
305236	1678	20160708279000	17690	8941	3	0	\N
305237	1678	20160708280000	17690	8941	4	0	\N
305238	1678	20160708281000	17690	8941	5	0	\N
305239	1678	20160708282000	17690	8941	6	0	\N
305240	1678	20160708283000	17690	8941	7	0	\N
305241	1874	7140000	17690	8941	8	0	\N
305242	1874	7143000	17690	8941	9	0	\N
305243	1874	7146000	17690	8941	10	0	\N
305244	1874	7149000	17690	8941	11	0	\N
305245	1874	7152000	17690	8941	12	0	\N
305246	1874	7155000	17690	8941	13	0	\N
305247	1874	7158000	17690	8941	14	0	\N
305248	1874	7161000	17690	8941	15	0	\N
305249	1678	20160708284000	17691	8942	0	0	\N
305250	1874	7164000	17691	8942	1	0	\N
305253	1678	20160708285000	17693	8943	0	0	\N
305254	1678	20160708286000	17693	8943	1	0	\N
305255	1874	7167000	17693	8943	2	0	\N
305256	1874	7170000	17693	8943	3	0	\N
305271	1678	20160708292000	17698	8947	0	0	\N
305272	1874	7188000	17698	8947	1	0	\N
305274	1678	20160708292000	17700	8947	0	0	\N
305275	1874	7188000	17700	8947	1	0	\N
305276	1678	20160708292000	17701	8947	0	0	\N
305277	1874	7188000	17701	8947	1	0	\N
305281	2170	200000000	17703	8916	0	0	\N
305282	1678	20160708292000	17704	8948	0	0	\N
305283	1678	20160708293000	17704	8948	1	0	\N
305284	1678	20160708292000	17705	8948	0	0	\N
305285	1678	20160708293000	17705	8948	1	0	\N
305286	1874	7191000	17705	8948	2	0	\N
305287	1678	20160708293000	17706	8948	0	0	\N
305288	1874	7191000	17706	8948	1	0	\N
305293	1678	20160708296000	17709	8951	0	0	\N
305294	1874	7200000	17709	8951	1	0	\N
305297	1678	20160708297000	17711	8952	0	0	\N
305298	1678	20160708298000	17711	8952	1	0	\N
305299	1874	7203000	17711	8952	2	0	\N
305300	1874	7206000	17711	8952	3	0	\N
305301	2170	200000000	17712	8912	0	0	\N
305310	1678	20160708299000	17715	8953	0	0	\N
305311	1678	20160708300000	17715	8953	1	0	\N
305312	1874	7209000	17715	8953	2	0	\N
305313	1874	7212000	17715	8953	3	0	\N
305314	1678	20160708299000	17716	8953	0	0	\N
305315	1678	20160708300000	17716	8953	1	0	\N
305316	1874	7209000	17716	8953	2	0	\N
305317	1874	7212000	17716	8953	3	0	\N
305187	1874	7131000	17681	8938	1	0	2
305193	2170	200000000	17684	8939	0	0	0
305194	1678	20160708274000	17684	8939	1	0	0
305195	1874	7134000	17684	8939	2	0	2
305196	1678	20160708275000	17685	8940	0	0	0
305217	1678	20160708276000	17689	8941	0	0	0
305218	1678	20160708277000	17689	8941	1	0	0
305219	1678	20160708278000	17689	8941	2	0	0
305220	1678	20160708279000	17689	8941	3	0	0
305221	1678	20160708280000	17689	8941	4	0	0
305223	1678	20160708282000	17689	8941	6	0	0
305224	1678	20160708283000	17689	8941	7	0	0
305225	1874	7140000	17689	8941	8	0	2
305226	1874	7143000	17689	8941	9	0	2
305228	1874	7149000	17689	8941	11	0	2
305229	1874	7152000	17689	8941	12	0	2
305230	1874	7155000	17689	8941	13	0	2
305231	1874	7158000	17689	8941	14	0	2
305232	1874	7161000	17689	8941	15	0	2
305252	1874	7164000	17692	8942	1	0	2
305257	1678	20160708285000	17694	8943	0	0	0
305258	1678	20160708286000	17694	8943	1	0	0
305259	1874	7167000	17694	8943	2	0	2
305260	1874	7170000	17694	8943	3	0	2
305262	1874	7173000	17695	8944	1	0	2
305263	1678	20160708288000	17696	8945	0	0	0
305264	1874	7176000	17696	8945	1	0	2
305265	1678	20160708289000	17697	8946	0	0	0
305267	1678	20160708291000	17697	8946	2	0	0
305268	1874	7179000	17697	8946	3	0	2
305269	1874	7182000	17697	8946	4	0	2
305270	1874	7185000	17697	8946	5	0	2
305273	1874	7188000	17699	8947	0	0	2
305279	1678	20160708293000	17702	8948	1	0	0
305280	1874	7191000	17702	8948	2	0	2
305289	1678	20160708294000	17707	8949	0	0	0
305290	1874	7194000	17707	8949	1	0	2
305291	1678	20160708295000	17708	8950	0	0	0
305295	1678	20160708296000	17710	8951	0	0	0
305296	1874	7200000	17710	8951	1	0	2
305302	1678	20160708297000	17713	8952	0	0	0
305303	1678	20160708298000	17713	8952	1	0	0
305305	1874	7206000	17713	8952	3	0	2
305306	1678	20160708299000	17714	8953	0	0	0
305307	1678	20160708300000	17714	8953	1	0	0
305308	1874	7209000	17714	8953	2	0	2
305309	1874	7212000	17714	8953	3	0	2
305319	1678	20160708302000	17717	8954	1	0	0
305320	1874	7215000	17717	8954	2	0	2
305322	2171	200000000	17718	8955	0	0	\N
305323	1678	20160708303000	17718	8955	1	0	\N
305324	1678	20160708304000	17718	8955	2	0	\N
305325	1874	7219000	17718	8955	3	0	\N
305326	1874	7222000	17718	8955	4	0	\N
305327	1874	7224000	17718	8955	5	0	\N
305328	1874	7227000	17718	8955	6	0	\N
305329	2171	200000000	17719	8955	0	0	\N
305330	1678	20160708303000	17719	8955	1	0	\N
305331	1678	20160708304000	17719	8955	2	0	\N
305332	1874	7219000	17719	8955	3	0	\N
305333	1874	7222000	17719	8955	4	0	\N
305334	1874	7224000	17719	8955	5	0	\N
305335	1874	7227000	17719	8955	6	0	\N
305343	2171	200000000	17721	8955	0	0	\N
305344	1678	20160708303000	17721	8955	1	0	\N
305345	1678	20160708304000	17721	8955	2	0	\N
305346	1874	7219000	17721	8955	3	0	\N
305347	1874	7222000	17721	8955	4	0	\N
305348	1874	7224000	17721	8955	5	0	\N
305349	1874	7227000	17721	8955	6	0	\N
305355	1678	20160708306000	17724	8957	0	0	\N
305356	1874	7231000	17724	8957	1	0	\N
305357	1874	7234000	17724	8957	2	0	\N
305358	1678	20160708307000	17725	8958	0	0	\N
305359	1874	7236000	17725	8958	1	0	\N
305360	1874	7239000	17725	8958	2	0	\N
305374	1874	7132000	17729	8939	0	0	\N
305375	1874	7134000	17729	8939	1	0	\N
305376	1874	7136000	17729	8939	2	0	\N
305377	1874	7138000	17729	8939	3	0	\N
305378	1874	7140000	17729	8939	4	0	\N
305379	1874	7142000	17729	8939	5	0	\N
305380	1874	7144000	17729	8939	6	0	\N
305381	1874	7145000	17729	8939	7	0	\N
305382	1874	7146000	17729	8939	8	0	\N
305383	1874	7148000	17729	8939	9	0	\N
305384	1874	7150000	17729	8939	10	0	\N
305389	1678	20160708311000	17731	8961	0	0	\N
305390	1874	7258000	17731	8961	1	0	\N
305391	1874	7260000	17731	8961	2	0	\N
305392	1874	7261000	17731	8961	3	0	\N
305412	1678	20160708316000	17735	8964	0	0	\N
305413	1678	20160708317000	17735	8964	2	0	\N
305414	1874	7285000	17735	8964	3	0	\N
305415	1874	7288000	17735	8964	4	0	\N
305416	1874	7290000	17735	8964	5	0	\N
305417	1874	7292000	17735	8964	6	0	\N
305436	1678	20160708321000	17738	8966	0	0	\N
305437	1678	20160708322000	17738	8966	1	0	\N
305438	1874	7310000	17738	8966	2	0	\N
305439	1874	7311000	17738	8966	3	0	\N
305440	1874	7313000	17738	8966	4	0	\N
305441	1874	7310000	17739	8966	0	0	\N
305442	1874	7312000	17739	8966	1	0	\N
305443	1678	20160708321000	17740	8966	0	0	\N
305444	1678	20160708322000	17740	8966	1	0	\N
305445	1874	7311000	17740	8966	2	0	\N
305446	1874	7314000	17740	8966	3	0	\N
305447	1874	7316000	17740	8966	4	0	\N
305448	1874	7317000	17740	8966	6	0	\N
305449	1874	7319000	17740	8966	7	0	\N
305450	1678	20160708321000	17741	8966	0	0	\N
305451	1678	20160708322000	17741	8966	1	0	\N
305452	1874	7311000	17741	8966	2	0	\N
305453	1874	7314000	17741	8966	3	0	\N
305454	1874	7316000	17741	8966	4	0	\N
305455	1874	7317000	17741	8966	6	0	\N
305456	1874	7319000	17741	8966	7	0	\N
305337	1678	20160708303000	17720	8955	1	0	0
305338	1678	20160708304000	17720	8955	2	0	0
305339	1874	7219000	17720	8955	3	0	2
305340	1874	7222000	17720	8955	4	0	2
305341	1874	7224000	17720	8955	5	0	2
305350	1678	20160708305000	17722	8956	0	0	0
305351	1874	7229000	17722	8956	1	0	2
305352	1678	20160708306000	17723	8957	0	0	0
305353	1874	7231000	17723	8957	1	0	2
305354	1874	7234000	17723	8957	2	0	2
305362	1874	7236000	17726	8958	1	0	2
305363	1874	7239000	17726	8958	2	0	2
305364	1678	20160708308000	17727	8959	0	0	0
305365	1678	20160708309000	17727	8959	1	0	0
305367	1874	7244000	17727	8959	3	0	2
305368	1874	7246000	17727	8959	4	0	2
305369	1874	7249000	17727	8959	5	0	2
305370	1874	7250000	17727	8959	6	0	2
305371	1678	20160708310000	17728	8960	0	0	0
305373	1874	7255000	17728	8960	2	0	2
305385	1678	20160708311000	17730	8961	0	0	0
305386	1874	7258000	17730	8961	1	0	2
305387	1874	7260000	17730	8961	2	0	2
305388	1874	7261000	17730	8961	3	0	2
305394	1678	20160708313000	17732	8962	1	0	0
305395	1874	7263000	17732	8962	2	0	2
305396	1874	7265000	17732	8962	3	0	2
305397	1874	7268000	17732	8962	4	0	2
305399	1678	20160708314000	17733	8963	1	0	0
305400	1678	20160708315000	17733	8963	2	0	0
305401	1874	7273000	17733	8963	3	0	2
305402	1874	7276000	17733	8963	4	0	2
305403	1874	7279000	17733	8963	5	0	2
305405	1874	7282000	17733	8963	7	0	2
305406	1678	20160708316000	17734	8964	0	0	0
305407	1678	20160708317000	17734	8964	2	0	0
305408	1874	7285000	17734	8964	3	0	2
305409	1874	7288000	17734	8964	4	0	2
305411	1874	7292000	17734	8964	6	0	2
305418	329	67444612000000	17736	8965	0	0	5
305419	1678	20160708318000	17736	8965	1	0	0
305420	1678	20160708319000	17736	8965	2	0	0
305422	1874	7295000	17736	8965	4	0	2
305423	1874	7298000	17736	8965	5	0	2
305424	1874	7299000	17736	8965	6	0	2
305425	1874	7301000	17736	8965	7	0	2
305426	1874	7303000	17736	8965	8	0	2
305428	1874	7308000	17736	8965	10	0	2
305429	1678	20160708321000	17737	8966	0	0	0
305430	1678	20160708322000	17737	8966	1	0	0
305431	1874	7311000	17737	8966	2	0	2
305432	1874	7314000	17737	8966	3	0	2
305434	1874	7317000	17737	8966	6	0	2
305435	1874	7319000	17737	8966	7	0	2
305457	1678	20160708321000	17742	8966	0	0	\N
305458	1678	20160708322000	17742	8966	1	0	\N
305459	1874	7311000	17742	8966	2	0	\N
305460	1874	7314000	17742	8966	3	0	\N
305461	1874	7316000	17742	8966	4	0	\N
305462	1874	7317000	17742	8966	6	0	\N
305463	1874	7319000	17742	8966	7	0	\N
305464	1678	20160708321000	17743	8966	0	0	\N
305465	1678	20160708322000	17743	8966	1	0	\N
305466	1874	7311000	17743	8966	2	0	\N
305467	1874	7314000	17743	8966	3	0	\N
305468	1874	7316000	17743	8966	4	0	\N
305469	1874	7317000	17743	8966	6	0	\N
305470	1874	7319000	17743	8966	7	0	\N
305471	1678	20160708321000	17744	8966	0	0	\N
305472	1678	20160708322000	17744	8966	1	0	\N
305473	1874	7311000	17744	8966	2	0	\N
305474	1874	7314000	17744	8966	3	0	\N
305475	1874	7316000	17744	8966	4	0	\N
305476	1874	7317000	17744	8966	6	0	\N
305477	1874	7319000	17744	8966	7	0	\N
305478	1678	20160708321000	17745	8966	0	0	\N
305479	1678	20160708322000	17745	8966	1	0	\N
305480	1874	7310000	17745	8966	2	0	\N
305481	1874	7311000	17745	8966	3	0	\N
305482	1874	7313000	17745	8966	4	0	\N
305483	1678	20160708323000	17746	8967	0	0	\N
305484	1678	20160708324000	17746	8967	1	0	\N
305485	1874	7321000	17746	8967	2	0	\N
305486	1874	7323000	17746	8967	3	0	\N
305487	1874	7326000	17746	8967	4	0	\N
305488	1874	7329000	17746	8967	5	0	\N
305495	1678	20160708323000	17748	8967	0	0	\N
305496	1678	20160708324000	17748	8967	1	0	\N
305497	1874	7321000	17748	8967	2	0	\N
305498	1874	7323000	17748	8967	3	0	\N
305499	1874	7326000	17748	8967	4	0	\N
305500	1874	7329000	17748	8967	5	0	\N
305505	1678	20160708325000	17750	8968	0	0	\N
305506	1874	7332000	17750	8968	1	0	\N
305507	1874	7333000	17750	8968	2	0	\N
305508	1874	7335000	17750	8968	3	0	\N
305509	1678	20160708228000	17751	8898	0	0	\N
305510	1678	20160708229000	17751	8898	1	0	\N
305511	329	67444622000000	17751	8898	2	0	\N
305512	2165	200000000	17751	8898	5	0	\N
305513	2166	200000000	17751	8898	6	0	\N
305514	1678	20160708230000	17751	8898	7	0	\N
305515	2167	200000000	17751	8898	8	0	\N
305516	2168	200000000	17751	8898	10	0	\N
305517	2169	200000000	17751	8898	11	0	\N
305518	2170	200000000	17751	8898	12	0	\N
305519	2171	200000000	17751	8898	13	0	\N
305520	1678	20160708231000	17751	8898	14	0	\N
305521	1678	20160708232000	17751	8898	15	0	\N
305522	1678	20160708233000	17751	8898	16	0	\N
305523	1678	20160708234000	17751	8898	17	0	\N
305524	1678	20160708235000	17751	8898	18	0	\N
305525	1678	20160708236000	17751	8898	19	0	\N
305526	1678	20160708237000	17751	8898	20	0	\N
305527	1678	20160708238000	17751	8898	21	0	\N
305528	1678	20160708239000	17751	8898	22	0	\N
305529	1678	20160708240000	17751	8898	23	0	\N
305530	1678	20160708241000	17751	8898	24	0	\N
305531	1678	20160708242000	17751	8898	25	0	\N
305532	1678	20160708243000	17751	8898	26	0	\N
305533	1678	20160708244000	17751	8898	27	0	\N
305534	1678	20160708245000	17751	8898	28	0	\N
305535	1678	20160708246000	17751	8898	29	0	\N
305536	1678	20160708247000	17751	8898	30	0	\N
305537	1678	20160708248000	17751	8898	31	0	\N
305538	1678	20160708249000	17751	8898	32	0	\N
305539	1678	20160708250000	17751	8898	33	0	\N
305540	1678	20160708251000	17751	8898	34	0	\N
305541	1678	20160708252000	17751	8898	35	0	\N
305542	1678	20160708253000	17751	8898	36	0	\N
305543	1678	20160708254000	17751	8898	37	0	\N
305544	1678	20160708255000	17751	8898	38	0	\N
305545	1678	20160708256000	17751	8898	39	0	\N
305546	1678	20160708257000	17751	8898	40	0	\N
305547	1678	20160708258000	17751	8898	41	0	\N
305548	1678	20160708259000	17751	8898	42	0	\N
305549	1678	20160708260000	17751	8898	43	0	\N
305550	1678	20160708261000	17751	8898	44	0	\N
305551	1678	20160708262000	17751	8898	45	0	\N
305552	1678	20160708263000	17751	8898	46	0	\N
305553	1678	20160708264000	17751	8898	47	0	\N
305554	1678	20160708265000	17751	8898	48	0	\N
305555	1678	20160708266000	17751	8898	49	0	\N
305556	1678	20160708267000	17751	8898	50	0	\N
305557	1678	20160708268000	17751	8898	51	0	\N
305558	1678	20160708269000	17751	8898	52	0	\N
305559	1678	20160708270000	17751	8898	53	0	\N
305560	1678	20160708271000	17751	8898	54	0	\N
305561	1678	20160708272000	17751	8898	55	0	\N
305562	1678	20160708273000	17751	8898	56	0	\N
305563	1678	20160708274000	17751	8898	57	0	\N
305564	1678	20160708275000	17751	8898	58	0	\N
305565	1678	20160708276000	17751	8898	59	0	\N
305566	1678	20160708277000	17751	8898	60	0	\N
305567	1678	20160708278000	17751	8898	61	0	\N
305568	1678	20160708279000	17751	8898	62	0	\N
305569	1678	20160708280000	17751	8898	63	0	\N
305570	1678	20160708281000	17751	8898	64	0	\N
305571	1678	20160708282000	17751	8898	65	0	\N
305572	1678	20160708283000	17751	8898	66	0	\N
305573	1678	20160708284000	17751	8898	67	0	\N
305574	1678	20160708285000	17751	8898	68	0	\N
305575	1678	20160708286000	17751	8898	69	0	\N
305579	1678	20160708326000	17753	8969	0	0	\N
305580	1874	7338000	17753	8969	1	0	\N
305581	1874	7340000	17753	8969	2	0	\N
305491	1874	7321000	17747	8967	2	0	2
305492	1874	7323000	17747	8967	3	0	2
305493	1874	7326000	17747	8967	4	0	2
305494	1874	7329000	17747	8967	5	0	2
305501	1678	20160708325000	17749	8968	0	0	0
305503	1874	7333000	17749	8968	2	0	2
305504	1874	7335000	17749	8968	3	0	2
305576	1678	20160708326000	17752	8969	0	0	0
305577	1874	7338000	17752	8969	1	0	2
305578	1874	7340000	17752	8969	2	0	2
305583	1874	7343000	17754	8970	1	0	2
305584	1874	7345000	17754	8970	2	0	2
305585	1678	20160708328000	17755	8971	0	0	0
305586	1874	7348000	17755	8971	1	0	2
305588	1874	7351000	17755	8971	3	0	2
305589	1678	20160708329000	17756	8972	0	0	0
305590	1678	20160708330000	17756	8972	1	0	0
305591	1678	20160708331000	17756	8972	2	0	0
305592	1678	20160708332000	17756	8972	3	0	0
305601	1678	20160708329000	17757	8972	0	0	\N
305602	1678	20160708330000	17757	8972	1	0	\N
305603	1678	20160708331000	17757	8972	2	0	\N
305604	1678	20160708332000	17757	8972	3	0	\N
305605	1874	7353000	17757	8972	4	0	\N
305606	1874	7355000	17757	8972	5	0	\N
305607	1874	7357000	17757	8972	6	0	\N
305608	1874	7360000	17757	8972	7	0	\N
305609	1874	7363000	17757	8972	8	0	\N
305610	1874	7366000	17757	8972	9	0	\N
305611	1874	7369000	17757	8972	10	0	\N
305612	1874	7370000	17757	8972	11	0	\N
305613	1678	20160708329000	17758	8972	0	0	\N
305614	1678	20160708330000	17758	8972	1	0	\N
305615	1678	20160708331000	17758	8972	2	0	\N
305616	1678	20160708332000	17758	8972	3	0	\N
305617	1874	7353000	17758	8972	4	0	\N
305618	1874	7355000	17758	8972	5	0	\N
305619	1874	7357000	17758	8972	6	0	\N
305620	1874	7360000	17758	8972	7	0	\N
305621	1874	7363000	17758	8972	8	0	\N
305622	1874	7366000	17758	8972	9	0	\N
305623	1874	7369000	17758	8972	10	0	\N
305624	1874	7370000	17758	8972	11	0	\N
305628	1678	20160708333000	17760	8973	0	0	\N
305629	1874	7373000	17760	8973	1	0	\N
305630	1874	7375000	17760	8973	2	0	\N
305631	1678	20160708334000	17761	8974	0	0	\N
305632	1874	7378000	17761	8974	1	0	\N
305633	1874	7380000	17761	8974	2	0	\N
305634	1678	20160708334000	17762	8974	0	0	\N
305635	1874	7378000	17762	8974	1	0	\N
305636	1874	7380000	17762	8974	2	0	\N
305637	1678	20160708334000	17763	8974	0	0	\N
305638	1874	7378000	17763	8974	1	0	\N
305639	1874	7380000	17763	8974	2	0	\N
305640	1678	20160708334000	17764	8974	0	0	\N
305641	1874	7378000	17764	8974	1	0	\N
305642	1874	7380000	17764	8974	2	0	\N
305660	1678	20160708337000	17768	8976	0	0	\N
305661	1678	20160708338000	17768	8976	1	0	\N
305662	1874	7394000	17768	8976	2	0	\N
305663	1874	7396000	17768	8976	3	0	\N
305664	1874	7398000	17768	8976	4	0	\N
305665	1874	7399000	17768	8976	5	0	\N
305666	1874	7402000	17768	8976	6	0	\N
305670	1678	20160708340000	17770	8978	0	0	\N
305671	1678	20160708341000	17770	8978	1	0	\N
305672	1678	20160708342000	17770	8978	2	0	\N
305673	1678	20160708343000	17770	8978	3	0	\N
305674	1874	7410000	17770	8978	6	0	\N
305675	1874	7412000	17770	8978	7	0	\N
305676	1874	7414000	17770	8978	8	0	\N
305677	1874	7417000	17770	8978	9	0	\N
305678	1874	7420000	17770	8978	10	0	\N
305679	1874	7423000	17770	8978	11	0	\N
305680	1874	7424000	17770	8978	12	0	\N
305681	1874	7426000	17770	8978	13	0	\N
305682	1874	7428000	17770	8978	14	0	\N
305700	1678	20160708344000	17773	8979	0	0	\N
305701	1874	7430000	17773	8979	1	0	\N
305702	1726	113215110000	17773	8979	2	0	\N
305703	1874	7433000	17773	8979	3	0	\N
305714	1678	20160708345000	17775	8980	0	0	\N
305715	1678	20160708346000	17775	8980	1	0	\N
305716	1678	20160708347000	17775	8980	2	0	\N
305717	1874	7435000	17775	8980	3	0	\N
305718	1874	7436000	17775	8980	4	0	\N
305719	1874	7438000	17775	8980	5	0	\N
305720	1874	7440000	17775	8980	6	0	\N
305721	1874	7443000	17775	8980	7	0	\N
305722	1874	7446000	17775	8980	8	0	\N
305723	1874	7449000	17775	8980	9	0	\N
305595	1874	7357000	17756	8972	6	0	2
305596	1874	7360000	17756	8972	7	0	2
305597	1874	7363000	17756	8972	8	0	2
305598	1874	7366000	17756	8972	9	0	2
305599	1874	7369000	17756	8972	10	0	2
305625	1678	20160708333000	17759	8973	0	0	0
305626	1874	7373000	17759	8973	1	0	2
305627	1874	7375000	17759	8973	2	0	2
305643	1678	20160708334000	17765	8974	0	0	0
305644	1874	7378000	17765	8974	1	0	2
305646	1678	20160708335000	17766	8975	0	0	0
305647	1678	20160708336000	17766	8975	1	0	0
305648	1874	7382000	17766	8975	2	0	2
305649	1874	7383000	17766	8975	3	0	2
305651	1874	7388000	17766	8975	5	0	2
305652	1874	7391000	17766	8975	6	0	2
305653	1678	20160708337000	17767	8976	0	0	0
305654	1678	20160708338000	17767	8976	1	0	0
305655	1874	7394000	17767	8976	2	0	2
305657	1874	7398000	17767	8976	4	0	2
305658	1874	7399000	17767	8976	5	0	2
305659	1874	7402000	17767	8976	6	0	2
305667	1678	20160708339000	17769	8977	0	0	0
305668	1874	7405000	17769	8977	1	0	2
305683	1678	20160708340000	17771	8978	0	0	0
305684	1678	20160708341000	17771	8978	1	0	0
305685	1678	20160708342000	17771	8978	2	0	0
305686	1678	20160708343000	17771	8978	3	0	0
305688	1874	7412000	17771	8978	7	0	2
305689	1874	7414000	17771	8978	8	0	2
305690	1874	7417000	17771	8978	9	0	2
305691	1874	7420000	17771	8978	10	0	2
305692	1874	7423000	17771	8978	11	0	2
305694	1874	7426000	17771	8978	13	0	2
305695	1874	7428000	17771	8978	14	0	2
305696	1678	20160708344000	17772	8979	0	0	0
305697	1874	7430000	17772	8979	1	0	2
305698	1726	113215110000	17772	8979	2	0	8193
305704	1678	20160708345000	17774	8980	0	0	0
305705	1678	20160708346000	17774	8980	1	0	0
305706	1678	20160708347000	17774	8980	2	0	0
305707	1874	7435000	17774	8980	3	0	2
305709	1874	7438000	17774	8980	5	0	2
305710	1874	7440000	17774	8980	6	0	2
305711	1874	7443000	17774	8980	7	0	2
305712	1874	7446000	17774	8980	8	0	2
305713	1874	7449000	17774	8980	9	0	2
305725	1874	7450000	17776	8981	1	0	2
305726	1874	7453000	17776	8981	2	0	2
305727	1874	7455000	17776	8981	3	0	2
305728	1678	20160708349000	17777	8982	0	0	0
305743	1678	20160708353000	17783	8986	0	0	\N
305744	1874	7476000	17783	8986	1	0	\N
305745	1874	7478000	17783	8986	2	0	\N
305746	1678	20160708354000	17785	8987	0	0	\N
305747	1874	7481000	17785	8987	1	0	\N
305748	1874	7483000	17785	8987	2	0	\N
305749	1678	20160708354000	17786	8987	0	0	\N
305750	1874	7481000	17786	8987	1	0	\N
305751	1874	7483000	17786	8987	2	0	\N
305752	1678	20160708354000	17788	8987	0	0	\N
305753	1874	7481000	17788	8987	1	0	\N
305754	1874	7483000	17788	8987	2	0	\N
305758	1678	20160708355000	17793	8988	0	0	\N
305759	1678	20160708356000	17793	8988	1	0	\N
305760	1874	7485000	17793	8988	2	0	\N
305761	1874	7487000	17793	8988	3	0	\N
305762	1874	7488000	17793	8988	4	0	\N
305763	1874	7491000	17793	8988	5	0	\N
305764	1874	7494000	17793	8988	6	0	\N
305765	1678	20160708355000	17794	8988	0	0	\N
305766	1678	20160708356000	17794	8988	1	0	\N
305767	1874	7485000	17794	8988	2	0	\N
305768	1874	7487000	17794	8988	3	0	\N
305769	1874	7488000	17794	8988	4	0	\N
305770	1874	7491000	17794	8988	5	0	\N
305771	1874	7494000	17794	8988	6	0	\N
305789	1678	20160708360000	17799	8992	0	0	\N
305790	1874	7513000	17799	8992	1	0	\N
305791	1874	7515000	17799	8992	2	0	\N
305792	1678	20160708360000	17800	8992	0	0	\N
305793	1874	7513000	17800	8992	1	0	\N
305794	1874	7515000	17800	8992	2	0	\N
305795	1678	20160708360000	17801	8992	0	0	\N
305796	1874	7513000	17801	8992	1	0	\N
305797	1874	7515000	17801	8992	2	0	\N
305801	1678	20160708360000	17803	8992	0	0	\N
305802	1678	20160708360000	17804	8992	0	0	\N
305803	1874	7513000	17804	8992	1	0	\N
305804	1874	7515000	17804	8992	2	0	\N
305805	1874	7517000	17804	8992	3	0	\N
305806	1874	7520000	17804	8992	4	0	\N
305807	1678	20160708361000	17805	8993	0	0	\N
305808	1874	7517000	17805	8993	2	0	\N
305809	1874	7518000	17805	8993	3	0	\N
305810	1874	7521000	17805	8993	4	0	\N
305811	1678	20160708361000	17806	8993	0	0	\N
305812	1874	7517000	17806	8993	2	0	\N
305813	1874	7518000	17806	8993	3	0	\N
305814	1874	7521000	17806	8993	4	0	\N
305821	1678	20160708362000	17808	8994	0	0	\N
305836	1874	7550000	17812	8996	0	0	\N
305837	1874	7552000	17812	8996	1	0	\N
305838	1874	7555000	17813	8997	0	0	\N
305839	1874	7556000	17813	8997	1	0	\N
305840	1874	7558000	17813	8997	2	0	\N
305841	1874	7555000	17814	8997	0	0	\N
305842	1874	7556000	17814	8997	1	0	\N
305843	1874	7558000	17814	8997	2	0	\N
305844	1874	7555000	17815	8997	0	0	\N
305845	1874	7556000	17815	8997	1	0	\N
305846	1874	7558000	17815	8997	2	0	\N
305853	1678	20160708364000	17819	8998	0	0	\N
305854	1874	7561000	17819	8998	1	0	\N
305855	1874	7563000	17819	8998	2	0	\N
305863	1678	20160708366000	17822	9000	0	0	\N
305864	1874	7569000	17822	9000	1	0	\N
305731	1678	20160708350000	17780	8984	0	0	0
305732	1678	20160708351000	17780	8984	1	0	0
305733	1874	7463000	17780	8984	2	0	2
305734	1874	7465000	17780	8984	3	0	2
305735	1874	7466000	17780	8984	4	0	2
305737	1678	20160708352000	17781	8985	0	0	0
305738	1874	7471000	17781	8985	1	0	2
305739	1874	7473000	17781	8985	2	0	2
305740	1678	20160708353000	17782	8986	0	0	0
305741	1874	7476000	17782	8986	1	0	2
305755	1678	20160708354000	17789	8987	0	0	0
305756	1874	7481000	17789	8987	1	0	2
305757	1874	7483000	17789	8987	2	0	2
305772	1678	20160708355000	17795	8988	0	0	0
305774	1874	7485000	17795	8988	2	0	2
305775	1874	7487000	17795	8988	3	0	2
305776	1874	7488000	17795	8988	4	0	2
305777	1874	7491000	17795	8988	5	0	2
305778	1874	7494000	17795	8988	6	0	2
305780	1874	7499000	17796	8989	1	0	2
305781	1678	20160708357000	17797	8990	0	0	0
305782	1678	20160708358000	17797	8990	1	0	0
305783	1874	7500000	17797	8990	2	0	2
305784	1874	7502000	17797	8990	3	0	2
305786	1678	20160708359000	17798	8991	0	0	0
305787	1874	7507000	17798	8991	1	0	2
305788	1874	7510000	17798	8991	2	0	2
305798	1678	20160708360000	17802	8992	0	0	0
305800	1874	7515000	17802	8992	2	0	2
305815	1678	20160708361000	17807	8993	0	0	0
305816	1874	7517000	17807	8993	2	0	2
305817	1874	7519000	17807	8993	3	0	2
305818	1874	7520000	17807	8993	4	0	2
305820	1874	7526000	17807	8993	6	0	2
305822	2174	200000000	17809	8994	0	0	0
305823	1678	20160708362000	17809	8994	1	0	0
305824	1678	20160708363000	17809	8994	2	0	0
305825	1874	7529000	17809	8994	3	0	2
305827	1874	7533000	17809	8994	5	0	2
305828	1874	7536000	17809	8994	6	0	2
305829	1874	7538000	17809	8994	7	0	2
305830	1874	7540000	17809	8994	8	0	2
305832	1874	7545000	17810	8995	0	0	2
305833	1874	7547000	17810	8995	1	0	2
305834	1874	7550000	17811	8996	0	0	2
305835	1874	7552000	17811	8996	1	0	2
305847	1874	7555000	17816	8997	0	0	2
305849	1874	7558000	17816	8997	2	0	2
305850	1678	20160708364000	17818	8998	0	0	0
305851	1874	7561000	17818	8998	1	0	2
305852	1874	7563000	17818	8998	2	0	2
305856	1678	20160708365000	17820	8999	0	0	0
305858	1874	7568000	17820	8999	2	0	2
305859	1678	20160708366000	17821	9000	0	0	0
305860	1874	7569000	17821	9000	1	0	2
305861	1874	7571000	17821	9000	2	0	2
305865	1874	7571000	17822	9000	2	0	\N
305866	1874	7574000	17822	9000	3	0	\N
305876	1678	20160708368000	17825	9002	0	0	\N
305877	1678	20160708369000	17825	9002	1	0	\N
305878	1874	7581000	17825	9002	2	0	\N
305879	1874	7583000	17825	9002	3	0	\N
305880	1874	7586000	17825	9002	4	0	\N
305881	1874	7589000	17825	9002	5	0	\N
305886	1678	20160708370000	17827	9003	0	0	\N
305887	1874	7591000	17827	9003	1	0	\N
305888	1874	7594000	17827	9003	2	0	\N
305889	1874	7595000	17827	9003	3	0	\N
305890	1678	20160708371000	17828	9004	0	0	\N
305891	1874	7597000	17828	9004	1	0	\N
305892	1874	7600000	17828	9004	2	0	\N
305893	1678	20160708371000	17829	9004	0	0	\N
305894	1874	7597000	17829	9004	1	0	\N
305895	1874	7600000	17829	9004	2	0	\N
305896	1678	20160708371000	17830	9004	0	0	\N
305897	1874	7597000	17830	9004	1	0	\N
305898	1874	7600000	17830	9004	2	0	\N
305902	1678	20160708372000	17833	9006	0	0	\N
305903	1678	20160708373000	17833	9006	1	0	\N
305904	1874	7601000	17833	9006	2	0	\N
305905	1874	7603000	17833	9006	3	0	\N
305906	1874	7605000	17833	9006	4	0	\N
305907	1874	7608000	17833	9006	5	0	\N
305908	1874	7611000	17833	9006	6	0	\N
305909	1678	20160708372000	17834	9006	0	0	\N
305910	1678	20160708373000	17834	9006	1	0	\N
305911	1874	7601000	17834	9006	2	0	\N
305912	1874	7603000	17834	9006	3	0	\N
305913	1874	7605000	17834	9006	4	0	\N
305914	1874	7608000	17834	9006	5	0	\N
305915	1874	7611000	17834	9006	6	0	\N
305923	1678	20160708374000	17836	9007	0	0	\N
305924	1678	20160708375000	17836	9007	1	0	\N
305925	1874	7613000	17836	9007	2	0	\N
305926	1874	7615000	17836	9007	3	0	\N
305927	1678	20160708374000	17837	9007	0	0	\N
305928	1678	20160708375000	17837	9007	1	0	\N
305929	1874	7614000	17837	9007	2	0	\N
305930	1874	7617000	17837	9007	3	0	\N
305931	1874	7619000	17837	9007	4	0	\N
305932	1874	7621000	17837	9007	5	0	\N
305933	1678	20160708374000	17838	9007	0	0	\N
305934	1678	20160708375000	17838	9007	1	0	\N
305935	1874	7614000	17838	9007	2	0	\N
305936	1874	7617000	17838	9007	3	0	\N
305937	1874	7619000	17838	9007	4	0	\N
305938	1874	7621000	17838	9007	5	0	\N
305939	1678	20160708374000	17839	9007	0	0	\N
305940	1678	20160708375000	17839	9007	1	0	\N
305941	1874	7614000	17839	9007	2	0	\N
305942	1874	7617000	17839	9007	3	0	\N
305943	1874	7619000	17839	9007	4	0	\N
305944	1874	7621000	17839	9007	5	0	\N
305945	1678	20160708374000	17841	9007	0	0	\N
305946	1678	20160708375000	17841	9007	1	0	\N
305947	1874	7614000	17841	9007	2	0	\N
305948	1874	7617000	17841	9007	3	0	\N
305949	1874	7619000	17841	9007	4	0	\N
305950	1874	7621000	17841	9007	5	0	\N
305951	1874	7623000	17841	9007	6	0	\N
305962	1678	20160708376000	17844	9008	0	0	\N
305963	1874	7623000	17844	9008	1	0	\N
305964	1874	7624000	17844	9008	2	0	\N
305965	1874	7627000	17844	9008	3	0	\N
305966	1678	20160708376000	17845	9008	0	0	\N
305967	1874	7623000	17845	9008	1	0	\N
305968	1874	7626000	17845	9008	2	0	\N
305969	1678	20160708374000	17846	9007	0	0	\N
305970	1678	20160708375000	17846	9007	1	0	\N
305971	1678	20160708376000	17846	9007	2	0	\N
305972	1874	7614000	17846	9007	3	0	\N
305973	1874	7617000	17846	9007	4	0	\N
305974	1874	7620000	17846	9007	5	0	\N
305975	1874	7622000	17846	9007	6	0	\N
305976	1874	7624000	17846	9007	7	0	\N
305977	1874	7626000	17846	9007	8	0	\N
305978	1678	20160708376000	17847	9008	0	0	\N
305979	1874	7623000	17847	9008	1	0	\N
305980	1874	7624000	17847	9008	2	0	\N
305981	1874	7627000	17847	9008	3	0	\N
305982	1678	20160708377000	17848	9009	0	0	\N
305983	1874	7629000	17848	9009	1	0	\N
305984	1874	7632000	17848	9009	2	0	\N
305988	1678	20160708377000	17850	9009	0	0	\N
305989	1874	7629000	17850	9009	1	0	\N
305993	1678	20160708379000	17852	9011	0	0	\N
305994	1874	7639000	17852	9011	2	0	\N
305995	1874	7642000	17852	9011	3	0	\N
305999	1678	20160708380000	17854	9012	0	0	\N
306000	1874	7644000	17854	9012	1	0	\N
305869	1874	7579000	17823	9001	2	0	2
305870	1678	20160708368000	17824	9002	0	0	0
305871	1678	20160708369000	17824	9002	1	0	0
305872	1874	7581000	17824	9002	2	0	2
305873	1874	7583000	17824	9002	3	0	2
305875	1874	7589000	17824	9002	5	0	2
305882	1678	20160708370000	17826	9003	0	0	0
305883	1874	7591000	17826	9003	1	0	2
305884	1874	7594000	17826	9003	2	0	2
305885	1874	7595000	17826	9003	3	0	2
305900	1874	7597000	17831	9004	1	0	2
305901	1874	7600000	17831	9004	2	0	2
305916	1678	20160708372000	17835	9006	0	0	0
305917	1678	20160708373000	17835	9006	1	0	0
305919	1874	7603000	17835	9006	3	0	2
305920	1874	7605000	17835	9006	4	0	2
305921	1874	7608000	17835	9006	5	0	2
305922	1874	7611000	17835	9006	6	0	2
305952	1678	20160708374000	17842	9007	0	0	0
305954	1874	7614000	17842	9007	2	0	2
305955	1874	7617000	17842	9007	3	0	2
305956	1874	7619000	17842	9007	4	0	2
305957	1874	7621000	17842	9007	5	0	2
305958	1678	20160708376000	17843	9008	0	0	0
305960	1874	7624000	17843	9008	2	0	2
305961	1874	7627000	17843	9008	3	0	2
305985	1678	20160708377000	17849	9009	0	0	0
305986	1874	7629000	17849	9009	1	0	2
305990	1678	20160708378000	17851	9010	0	0	0
305991	1874	7635000	17851	9010	1	0	2
305992	1874	7637000	17851	9010	2	0	2
305996	1678	20160708379000	17853	9011	0	0	0
305997	1874	7639000	17853	9011	2	0	2
306001	1874	7645000	17854	9012	2	0	\N
306002	329	67444622000000	17855	8921	0	0	\N
306003	2166	200000000	17855	8921	1	0	\N
306004	1678	20160708248000	17855	8921	2	0	\N
306005	1678	20160708249000	17855	8921	4	0	\N
306006	1678	20160708250000	17855	8921	5	0	\N
306007	1678	20160708251000	17855	8921	6	0	\N
306008	1678	20160708252000	17855	8921	7	0	\N
306009	1678	20160708253000	17855	8921	9	0	\N
306010	1678	20160708254000	17855	8921	10	0	\N
306011	1678	20160708255000	17855	8921	11	0	\N
306012	1678	20160708256000	17855	8921	12	0	\N
306013	1678	20160708257000	17855	8921	13	0	\N
306014	1678	20160708258000	17855	8921	14	0	\N
306015	1678	20160708259000	17855	8921	15	0	\N
306016	1678	20160708260000	17855	8921	16	0	\N
306017	1678	20160708261000	17855	8921	17	0	\N
306018	1678	20160708262000	17855	8921	18	0	\N
306019	1678	20160708263000	17855	8921	20	0	\N
306020	2167	200000000	17855	8921	21	0	\N
306021	2168	200000000	17855	8921	22	0	\N
306022	2169	200000000	17855	8921	23	0	\N
306023	2170	200000000	17855	8921	24	0	\N
306024	2171	200000000	17855	8921	25	0	\N
306025	2174	200000000	17855	8921	26	0	\N
306026	1678	20160708264000	17855	8921	27	0	\N
306027	1678	20160708265000	17855	8921	28	0	\N
306028	1678	20160708266000	17855	8921	29	0	\N
306029	1678	20160708267000	17855	8921	30	0	\N
306030	1678	20160708268000	17855	8921	31	0	\N
306031	1678	20160708269000	17855	8921	32	0	\N
306032	1678	20160708270000	17855	8921	33	0	\N
306033	1678	20160708271000	17855	8921	34	0	\N
306034	1678	20160708272000	17855	8921	35	0	\N
306035	1678	20160708273000	17855	8921	36	0	\N
306036	1678	20160708274000	17855	8921	37	0	\N
306037	1678	20160708275000	17855	8921	38	0	\N
306038	1678	20160708276000	17855	8921	39	0	\N
306039	1678	20160708277000	17855	8921	40	0	\N
306040	1678	20160708278000	17855	8921	41	0	\N
306041	1678	20160708279000	17855	8921	42	0	\N
306042	1678	20160708280000	17855	8921	43	0	\N
306043	1678	20160708281000	17855	8921	44	0	\N
306044	1678	20160708282000	17855	8921	45	0	\N
306045	1678	20160708283000	17855	8921	46	0	\N
306046	1678	20160708284000	17855	8921	47	0	\N
306047	1678	20160708285000	17855	8921	48	0	\N
306048	1678	20160708286000	17855	8921	49	0	\N
306049	1678	20160708287000	17855	8921	50	0	\N
306050	1678	20160708288000	17855	8921	51	0	\N
306051	1678	20160708289000	17855	8921	52	0	\N
306052	1678	20160708290000	17855	8921	53	0	\N
306053	1678	20160708291000	17855	8921	54	0	\N
306054	1678	20160708292000	17855	8921	55	0	\N
306055	1678	20160708293000	17855	8921	56	0	\N
306056	1678	20160708294000	17855	8921	57	0	\N
306057	1678	20160708295000	17855	8921	58	0	\N
306058	1678	20160708296000	17855	8921	59	0	\N
306059	1678	20160708297000	17855	8921	60	0	\N
306060	1678	20160708298000	17855	8921	61	0	\N
306061	1678	20160708299000	17855	8921	62	0	\N
306062	1678	20160708300000	17855	8921	63	0	\N
306063	1678	20160708301000	17855	8921	64	0	\N
306064	1678	20160708302000	17855	8921	65	0	\N
306065	1678	20160708303000	17855	8921	66	0	\N
306066	1678	20160708304000	17855	8921	67	0	\N
306067	1678	20160708305000	17855	8921	68	0	\N
306068	1678	20160708306000	17855	8921	69	0	\N
306069	1678	20160708307000	17855	8921	70	0	\N
306070	1678	20160708308000	17855	8921	71	0	\N
306071	1678	20160708309000	17855	8921	72	0	\N
306072	1678	20160708310000	17855	8921	73	0	\N
306073	1678	20160708311000	17855	8921	74	0	\N
306074	1678	20160708312000	17855	8921	75	0	\N
306075	1678	20160708313000	17855	8921	76	0	\N
306076	1678	20160708314000	17855	8921	77	0	\N
306077	1678	20160708315000	17855	8921	78	0	\N
306078	1678	20160708316000	17855	8921	79	0	\N
306079	1678	20160708317000	17855	8921	80	0	\N
306080	1678	20160708318000	17855	8921	81	0	\N
306081	1678	20160708319000	17855	8921	82	0	\N
306082	1678	20160708320000	17855	8921	83	0	\N
306083	1678	20160708321000	17855	8921	84	0	\N
306084	1678	20160708322000	17855	8921	85	0	\N
306085	1678	20160708323000	17855	8921	86	0	\N
306086	1678	20160708324000	17855	8921	87	0	\N
306087	1678	20160708325000	17855	8921	88	0	\N
306088	1678	20160708326000	17855	8921	89	0	\N
306089	1678	20160708327000	17855	8921	90	0	\N
306090	1678	20160708328000	17855	8921	91	0	\N
306091	1678	20160708329000	17855	8921	92	0	\N
306092	1678	20160708330000	17855	8921	93	0	\N
306093	1678	20160708331000	17855	8921	94	0	\N
306094	1678	20160708332000	17855	8921	95	0	\N
306095	1678	20160708333000	17855	8921	96	0	\N
306096	1678	20160708334000	17855	8921	97	0	\N
306097	1678	20160708335000	17855	8921	98	0	\N
306098	1678	20160708336000	17855	8921	99	0	\N
306099	1678	20160708337000	17855	8921	100	0	\N
306100	1678	20160708338000	17855	8921	101	0	\N
306101	1678	20160708339000	17855	8921	102	0	\N
306102	1678	20160708340000	17855	8921	103	0	\N
306103	1678	20160708341000	17855	8921	104	0	\N
306104	1678	20160708342000	17855	8921	105	0	\N
306105	1678	20160708343000	17855	8921	106	0	\N
306106	1678	20160708344000	17855	8921	107	0	\N
306107	1678	20160708345000	17855	8921	108	0	\N
306108	1678	20160708346000	17855	8921	109	0	\N
306109	1678	20160708347000	17855	8921	110	0	\N
306110	1678	20160708348000	17855	8921	111	0	\N
306111	1678	20160708349000	17855	8921	112	0	\N
306112	1678	20160708350000	17855	8921	113	0	\N
306113	1678	20160708351000	17855	8921	114	0	\N
306114	1678	20160708352000	17855	8921	115	0	\N
306115	1678	20160708353000	17855	8921	116	0	\N
306116	1678	20160708354000	17855	8921	117	0	\N
306117	1678	20160708355000	17855	8921	118	0	\N
306118	1678	20160708356000	17855	8921	119	0	\N
306119	1678	20160708357000	17855	8921	120	0	\N
306120	1678	20160708358000	17855	8921	121	0	\N
306121	1678	20160708359000	17855	8921	122	0	\N
306122	1678	20160708360000	17855	8921	123	0	\N
306123	1678	20160708361000	17855	8921	124	0	\N
306124	1678	20160708362000	17855	8921	125	0	\N
306128	1678	20160708380000	17857	9012	0	0	\N
306129	1874	7644000	17857	9012	1	0	\N
306130	1874	7645000	17857	9012	2	0	\N
306134	1678	20160708382000	17859	9014	0	0	\N
306135	1874	7653000	17859	9014	1	0	\N
306136	1874	7655000	17859	9014	2	0	\N
306127	1874	7645000	17856	9012	2	0	2
306131	1678	20160708381000	17858	9013	0	0	0
306132	1874	7648000	17858	9013	1	0	2
306133	1874	7650000	17858	9013	2	0	2
306137	1678	20160708382000	17860	9014	0	0	\N
306138	1874	7653000	17860	9014	1	0	\N
306139	1874	7655000	17860	9014	2	0	\N
306143	1678	20160708383000	17862	9015	0	0	\N
306144	1874	7656000	17862	9015	1	0	\N
306145	1874	7658000	17862	9015	2	0	\N
306146	1874	7661000	17862	9015	3	0	\N
306151	1678	20160708383000	17864	9015	0	0	\N
306152	1874	7656000	17864	9015	1	0	\N
306153	1874	7658000	17864	9015	2	0	\N
306154	1874	7661000	17864	9015	3	0	\N
306158	329	67444622000000	17866	8855	0	0	\N
306159	2171	200000000	17866	8855	2	0	\N
306160	2174	200000000	17866	8855	3	0	\N
306161	1726	112005110000	17866	8855	8	0	\N
306162	1874	6625000	17866	8855	9	0	\N
306163	1567	101	17866	8855	10	0	\N
306164	1874	6626000	17866	8855	11	0	\N
306165	1874	6627000	17866	8855	12	0	\N
306166	1874	6628000	17866	8855	13	0	\N
306167	1874	6629000	17866	8855	14	0	\N
306168	1874	6630000	17866	8855	15	0	\N
306169	1874	6631000	17866	8855	16	0	\N
306170	1874	6632000	17866	8855	17	0	\N
306171	1874	6633000	17866	8855	18	0	\N
306172	1874	6634000	17866	8855	19	0	\N
306173	1874	6635000	17866	8855	20	0	\N
306174	1874	6636000	17866	8855	21	0	\N
306175	1874	6637000	17866	8855	22	0	\N
306176	1874	6638000	17866	8855	23	0	\N
306177	1874	6639000	17866	8855	24	0	\N
306178	1874	6640000	17866	8855	25	0	\N
306179	1874	6641000	17866	8855	26	0	\N
306180	1874	6642000	17866	8855	27	0	\N
306181	1874	6643000	17866	8855	28	0	\N
306182	1874	6644000	17866	8855	29	0	\N
306183	1874	6645000	17866	8855	30	0	\N
306184	1874	6646000	17866	8855	31	0	\N
306185	1874	6647000	17866	8855	32	0	\N
306186	1874	6648000	17866	8855	33	0	\N
306187	1874	6649000	17866	8855	34	0	\N
306188	1874	6650000	17866	8855	35	0	\N
306206	1567	101	17869	9010	0	0	\N
306207	1678	20160708390000	17870	9019	0	0	\N
306208	1874	7693000	17870	9019	1	0	\N
306209	1874	7696000	17870	9019	2	0	\N
306210	1874	7698000	17870	9019	3	0	\N
306221	1678	20160708393000	17874	9022	0	0	\N
306222	1874	7711000	17874	9022	1	0	\N
306223	1874	7712000	17874	9022	2	0	\N
306224	1874	7714000	17874	9022	3	0	\N
306229	1678	20160708393000	17876	9022	0	0	\N
306230	1874	7711000	17876	9022	1	0	\N
306231	1874	7712000	17876	9022	2	0	\N
306232	1874	7714000	17876	9022	3	0	\N
306236	1678	20160708394000	17878	9023	0	0	\N
306237	1874	7716000	17878	9023	1	0	\N
306238	1874	7719000	17878	9023	2	0	\N
306249	1678	20160708398000	17880	9025	0	0	\N
306250	1874	7737000	17880	9025	1	0	\N
306251	1874	7740000	17880	9025	3	0	\N
306252	1678	20160708398000	17881	9025	0	0	\N
306253	1874	7737000	17881	9025	1	0	\N
306254	1874	7740000	17881	9025	3	0	\N
306258	1678	20160708398000	17883	9025	0	0	\N
306259	1874	7737000	17883	9025	1	0	\N
306260	1874	7740000	17883	9025	3	0	\N
306268	1678	20160708399000	17885	9026	0	0	\N
306269	1678	20160708400000	17885	9026	1	0	\N
306270	1874	7742000	17885	9026	2	0	\N
306271	1874	7744000	17885	9026	3	0	\N
306272	1874	7745000	17885	9026	4	0	\N
306142	1874	7655000	17861	9014	2	0	2
306147	1678	20160708383000	17863	9015	0	0	0
306148	1874	7656000	17863	9015	1	0	2
306149	1874	7658000	17863	9015	2	0	2
306150	1874	7661000	17863	9015	3	0	2
306156	1874	7663000	17865	9016	1	0	2
306157	1874	7666000	17865	9016	2	0	2
306189	1678	20160708385000	17867	9017	0	0	0
306190	1678	20160708386000	17867	9017	1	0	0
306191	1874	7668000	17867	9017	2	0	2
306193	1567	101	17867	9017	4	0	0
306194	1874	7671000	17867	9017	5	0	2
306195	1874	7674000	17867	9017	6	0	2
306196	1874	7677000	17867	9017	7	0	2
306198	1678	20160708388000	17868	9018	1	0	0
306199	1678	20160708389000	17868	9018	2	0	0
306200	1874	7680000	17868	9018	3	0	2
306201	1874	7682000	17868	9018	4	0	2
306202	1874	7684000	17868	9018	5	0	2
306204	1874	7689000	17868	9018	7	0	2
306205	1874	7692000	17868	9018	8	0	2
306211	1678	20160708390000	17871	9019	0	0	0
306212	1874	7693000	17871	9019	1	0	2
306213	1874	7696000	17871	9019	2	0	2
306215	1678	20160708391000	17872	9020	0	0	0
306216	1874	7701000	17872	9020	1	0	2
306217	1874	7703000	17872	9020	2	0	2
306218	1678	20160708392000	17873	9021	0	0	0
306220	1874	7708000	17873	9021	2	0	2
306225	1678	20160708393000	17875	9022	0	0	0
306226	1874	7711000	17875	9022	1	0	2
306227	1874	7712000	17875	9022	2	0	2
306228	1874	7714000	17875	9022	3	0	2
306234	1874	7716000	17877	9023	1	0	2
306235	1874	7719000	17877	9023	2	0	2
306239	1678	20160708395000	17879	9024	0	0	0
306240	1678	20160708396000	17879	9024	1	0	0
306241	1678	20160708397000	17879	9024	2	0	0
306243	1874	7722000	17879	9024	4	0	2
306244	1874	7725000	17879	9024	5	0	2
306245	1874	7728000	17879	9024	6	0	2
306246	1874	7731000	17879	9024	7	0	2
306248	1874	7735000	17879	9024	9	0	2
306255	1678	20160708398000	17882	9025	0	0	0
306256	1874	7737000	17882	9025	1	0	2
306257	1874	7740000	17882	9025	3	0	2
306261	1678	20160708399000	17884	9026	0	0	0
306263	1874	7742000	17884	9026	2	0	2
306264	1874	7744000	17884	9026	3	0	2
306265	1874	7745000	17884	9026	4	0	2
306266	1874	7748000	17884	9026	5	0	2
306267	1874	7751000	17884	9026	6	0	2
306273	1874	7748000	17885	9026	5	0	\N
306274	1874	7751000	17885	9026	6	0	\N
306275	1678	20160708401000	17887	9027	0	0	\N
306276	1678	20160708402000	17887	9027	1	0	\N
306277	1874	7753000	17887	9027	2	0	\N
306278	1874	7755000	17887	9027	3	0	\N
306279	1874	7758000	17887	9027	4	0	\N
306280	1874	7761000	17887	9027	5	0	\N
306285	1678	20160708403000	17889	9028	0	0	\N
306286	1874	7758000	17889	9028	1	0	\N
306287	1874	7761000	17889	9028	2	0	\N
306288	1874	7763000	17889	9028	3	0	\N
306289	1874	7765000	17889	9028	4	0	\N
306290	1874	7767000	17889	9028	5	0	\N
306291	1678	20160708403000	17890	9028	0	0	\N
306292	1874	7758000	17890	9028	1	0	\N
306293	1874	7761000	17890	9028	2	0	\N
306294	1874	7763000	17890	9028	3	0	\N
306295	1874	7765000	17890	9028	4	0	\N
306296	1874	7767000	17890	9028	5	0	\N
306303	1678	20160708403000	17892	9028	0	0	\N
306304	1874	7762000	17892	9028	1	0	\N
306305	1874	7765000	17892	9028	2	0	\N
306306	1874	7767000	17892	9028	3	0	\N
306307	1678	20160708404000	17893	9029	0	0	\N
306308	1874	7770000	17893	9029	1	0	\N
306309	1874	7772000	17893	9029	2	0	\N
306313	1678	20160708404000	17895	9029	0	0	\N
306314	1874	7770000	17895	9029	1	0	\N
306315	1874	7772000	17895	9029	2	0	\N
306316	2174	200000000	17896	8988	0	0	\N
306317	1678	20160708355000	17896	8988	1	0	\N
306318	1678	20160708356000	17896	8988	2	0	\N
306319	1678	20160708357000	17896	8988	3	0	\N
306320	1678	20160708358000	17896	8988	4	0	\N
306321	1678	20160708359000	17896	8988	5	0	\N
306322	1678	20160708360000	17896	8988	6	0	\N
306323	1678	20160708361000	17896	8988	7	0	\N
306324	1678	20160708362000	17896	8988	8	0	\N
306325	1678	20160708363000	17896	8988	9	0	\N
306326	1678	20160708364000	17896	8988	10	0	\N
306327	1678	20160708365000	17896	8988	11	0	\N
306328	1678	20160708366000	17896	8988	12	0	\N
306329	1678	20160708367000	17896	8988	13	0	\N
306330	1678	20160708368000	17896	8988	14	0	\N
306331	1678	20160708369000	17896	8988	15	0	\N
306332	1678	20160708370000	17896	8988	16	0	\N
306333	1678	20160708371000	17896	8988	17	0	\N
306334	1678	20160708372000	17896	8988	18	0	\N
306335	1678	20160708373000	17896	8988	19	0	\N
306336	1678	20160708374000	17896	8988	20	0	\N
306337	1678	20160708375000	17896	8988	21	0	\N
306338	1678	20160708376000	17896	8988	22	0	\N
306339	1678	20160708377000	17896	8988	23	0	\N
306340	1678	20160708378000	17896	8988	24	0	\N
306341	1678	20160708379000	17896	8988	25	0	\N
306342	1678	20160708380000	17896	8988	26	0	\N
306343	1678	20160708381000	17896	8988	27	0	\N
306344	1678	20160708382000	17896	8988	28	0	\N
306345	1678	20160708383000	17896	8988	29	0	\N
306346	1678	20160708384000	17896	8988	30	0	\N
306347	1678	20160708385000	17896	8988	31	0	\N
306348	1678	20160708386000	17896	8988	32	0	\N
306349	1678	20160708387000	17896	8988	33	0	\N
306350	1678	20160708388000	17896	8988	34	0	\N
306351	1678	20160708389000	17896	8988	35	0	\N
306352	1678	20160708390000	17896	8988	36	0	\N
306353	1678	20160708391000	17896	8988	37	0	\N
306354	1678	20160708392000	17896	8988	38	0	\N
306355	1678	20160708393000	17896	8988	39	0	\N
306356	1678	20160708394000	17896	8988	40	0	\N
306357	1678	20160708395000	17896	8988	41	0	\N
306358	1678	20160708396000	17896	8988	42	0	\N
306359	1678	20160708397000	17896	8988	43	0	\N
306360	1678	20160708398000	17896	8988	44	0	\N
306361	1678	20160708399000	17896	8988	45	0	\N
306362	1678	20160708400000	17896	8988	46	0	\N
306363	1678	20160708401000	17896	8988	47	0	\N
306364	1678	20160708402000	17896	8988	48	0	\N
306365	1678	20160708403000	17896	8988	49	0	\N
306366	1678	20160708404000	17896	8988	50	0	\N
306367	1567	101	17896	8988	53	0	\N
306368	1874	7485000	17896	8988	54	0	\N
306369	1874	7487000	17896	8988	55	0	\N
306370	1874	7489000	17896	8988	56	0	\N
306371	1874	7491000	17896	8988	57	0	\N
306372	1874	7493000	17896	8988	58	0	\N
306373	1874	7494000	17896	8988	59	0	\N
306374	1874	7495000	17896	8988	60	0	\N
306375	1874	7496000	17896	8988	61	0	\N
306376	1874	7497000	17896	8988	62	0	\N
306377	1874	7498000	17896	8988	63	0	\N
306378	1874	7499000	17896	8988	64	0	\N
306379	1874	7502000	17896	8988	65	0	\N
306380	1874	7505000	17896	8988	66	0	\N
306381	1874	7508000	17896	8988	67	0	\N
306382	1874	7511000	17896	8988	68	0	\N
306383	1874	7514000	17896	8988	69	0	\N
306384	1874	7517000	17896	8988	70	0	\N
306385	1874	7519000	17896	8988	71	0	\N
306386	1874	7521000	17896	8988	72	0	\N
306387	1874	7523000	17896	8988	73	0	\N
306388	1874	7525000	17896	8988	74	0	\N
306389	1874	7527000	17896	8988	75	0	\N
306390	1874	7530000	17896	8988	76	0	\N
306391	1874	7533000	17896	8988	77	0	\N
306392	1874	7536000	17896	8988	78	0	\N
306393	1874	7539000	17896	8988	79	0	\N
306394	1874	7542000	17896	8988	80	0	\N
306395	1874	7545000	17896	8988	81	0	\N
306396	1874	7548000	17896	8988	82	0	\N
306397	1874	7551000	17896	8988	83	0	\N
306398	1874	7554000	17896	8988	84	0	\N
306399	1874	7557000	17896	8988	85	0	\N
306400	1874	7560000	17896	8988	86	0	\N
306401	1874	7562000	17896	8988	87	0	\N
306402	1874	7564000	17896	8988	88	0	\N
306403	1874	7566000	17896	8988	89	0	\N
306404	1874	7568000	17896	8988	90	0	\N
306405	1874	7570000	17896	8988	91	0	\N
306406	1874	7572000	17896	8988	92	0	\N
306407	1874	7574000	17896	8988	93	0	\N
306408	1874	7576000	17896	8988	94	0	\N
306283	1874	7754000	17888	9027	2	0	2
306284	1874	7757000	17888	9027	3	0	2
306297	1678	20160708403000	17891	9028	0	0	0
306298	1874	7758000	17891	9028	1	0	2
306299	1874	7761000	17891	9028	2	0	2
306301	1874	7765000	17891	9028	4	0	2
306302	1874	7767000	17891	9028	5	0	2
306310	1678	20160708404000	17894	9029	0	0	0
306311	1874	7770000	17894	9029	1	0	2
306312	1874	7772000	17894	9029	2	0	2
306409	1874	7578000	17896	8988	95	0	\N
306410	1874	7580000	17896	8988	96	0	\N
306411	1874	7582000	17896	8988	97	0	\N
306412	1874	7584000	17896	8988	98	0	\N
306413	1874	7587000	17896	8988	99	0	\N
306414	1874	7588000	17896	8988	100	0	\N
306415	1874	7589000	17896	8988	101	0	\N
306416	1874	7590000	17896	8988	102	0	\N
306417	1874	7591000	17896	8988	103	0	\N
306418	1874	7592000	17896	8988	105	0	\N
306419	1874	7593000	17896	8988	106	0	\N
306420	1874	7594000	17896	8988	107	0	\N
306421	1874	7595000	17896	8988	108	0	\N
306422	1874	7596000	17896	8988	109	0	\N
306423	1874	7597000	17896	8988	110	0	\N
306424	1874	7598000	17896	8988	111	0	\N
306425	1874	7601000	17896	8988	112	0	\N
306426	1874	7604000	17896	8988	113	0	\N
306427	1874	7607000	17896	8988	114	0	\N
306428	1874	7610000	17896	8988	115	0	\N
306429	1874	7612000	17896	8988	116	0	\N
306430	1874	7614000	17896	8988	117	0	\N
306431	1874	7616000	17896	8988	118	0	\N
306432	1874	7618000	17896	8988	119	0	\N
306433	1874	7620000	17896	8988	120	0	\N
306434	1874	7622000	17896	8988	121	0	\N
306435	1874	7624000	17896	8988	122	0	\N
306436	1874	7626000	17896	8988	123	0	\N
306437	1874	7628000	17896	8988	124	0	\N
306438	1874	7630000	17896	8988	125	0	\N
306456	2175	200000000	17898	9030	0	0	\N
306457	1678	20160708405000	17898	9030	1	0	\N
306458	1678	20160708406000	17898	9030	2	0	\N
306459	1678	20160708407000	17898	9030	3	0	\N
306460	1678	20160708408000	17898	9030	4	0	\N
306461	1678	20160708409000	17898	9030	5	0	\N
306462	1874	7773000	17898	9030	6	0	\N
306463	1874	7776000	17898	9030	7	0	\N
306464	1874	7779000	17898	9030	8	0	\N
306465	1874	7781000	17898	9030	9	0	\N
306466	1874	7783000	17898	9030	10	0	\N
306467	1874	7785000	17898	9030	11	0	\N
306468	1874	7787000	17898	9030	12	0	\N
306469	1874	7789000	17898	9030	13	0	\N
306470	1874	7792000	17898	9030	14	0	\N
306471	1874	7795000	17898	9030	15	0	\N
306472	1874	7798000	17898	9030	16	0	\N
306480	1678	20160708410000	17900	9031	0	0	\N
306481	1678	20160708411000	17900	9031	1	0	\N
306482	1874	7801000	17900	9031	2	0	\N
306483	1874	7802000	17900	9031	3	0	\N
306484	1874	7805000	17900	9031	4	0	\N
306485	1874	7807000	17900	9031	5	0	\N
306486	1874	7809000	17900	9031	6	0	\N
306494	1678	20160708412000	17902	9032	0	0	\N
306495	1678	20160708413000	17902	9032	1	0	\N
306496	1874	7811000	17902	9032	2	0	\N
306497	1874	7813000	17902	9032	3	0	\N
306498	1874	7814000	17902	9032	4	0	\N
306499	1874	7817000	17902	9032	5	0	\N
306500	1874	7820000	17902	9032	6	0	\N
306501	1678	20160708412000	17903	9032	0	0	\N
306502	1678	20160708413000	17903	9032	1	0	\N
306503	1874	7811000	17903	9032	2	0	\N
306504	1874	7813000	17903	9032	3	0	\N
306505	1874	7814000	17903	9032	4	0	\N
306506	1874	7817000	17903	9032	5	0	\N
306507	1874	7820000	17903	9032	6	0	\N
306508	1678	20160708412000	17904	9032	0	0	\N
306509	1678	20160708413000	17904	9032	1	0	\N
306510	1874	7811000	17904	9032	2	0	\N
306511	1874	7813000	17904	9032	3	0	\N
306512	1874	7814000	17904	9032	4	0	\N
306513	1874	7817000	17904	9032	5	0	\N
306514	1874	7820000	17904	9032	6	0	\N
306515	1678	20160708410000	17905	9031	0	0	\N
306516	1678	20160708411000	17905	9031	1	0	\N
306517	1678	20160708412000	17905	9031	2	0	\N
306518	1678	20160708413000	17905	9031	3	0	\N
306519	1874	7801000	17905	9031	4	0	\N
306520	1874	7802000	17905	9031	5	0	\N
306521	1874	7803000	17905	9031	6	0	\N
306522	1874	7806000	17905	9031	7	0	\N
306523	1874	7809000	17905	9031	8	0	\N
306524	1874	7812000	17905	9031	9	0	\N
306527	1874	7822000	17907	9033	0	0	\N
306528	1874	7825000	17907	9033	1	0	\N
306529	1874	7822000	17908	9033	0	0	\N
306530	1874	7825000	17908	9033	1	0	\N
306531	1874	7828000	17909	9034	0	0	\N
306532	1874	7830000	17909	9034	1	0	\N
306535	1678	20160708414000	17911	9035	0	0	\N
306536	1874	7832000	17911	9035	1	0	\N
306537	1874	7833000	17911	9035	2	0	\N
306538	1874	7835000	17911	9035	3	0	\N
306539	1874	7838000	17911	9035	4	0	\N
306540	1874	7841000	17911	9035	5	0	\N
306541	1678	20160708414000	17912	9035	0	0	\N
306542	1874	7832000	17912	9035	1	0	\N
306543	1874	7833000	17912	9035	2	0	\N
306544	1874	7835000	17912	9035	3	0	\N
306441	1678	20160708406000	17897	9030	2	0	0
306442	1678	20160708407000	17897	9030	3	0	0
306443	1678	20160708408000	17897	9030	4	0	0
306444	1678	20160708409000	17897	9030	5	0	0
306445	1874	7773000	17897	9030	6	0	2
306447	1874	7779000	17897	9030	8	0	2
306448	1874	7781000	17897	9030	9	0	2
306449	1874	7783000	17897	9030	10	0	2
306450	1874	7785000	17897	9030	11	0	2
306451	1874	7787000	17897	9030	12	0	2
306453	1874	7792000	17897	9030	14	0	2
306454	1874	7795000	17897	9030	15	0	2
306455	1874	7798000	17897	9030	16	0	2
306473	1678	20160708410000	17899	9031	0	0	0
306475	1874	7801000	17899	9031	2	0	2
306476	1874	7802000	17899	9031	3	0	2
306477	1874	7805000	17899	9031	4	0	2
306478	1874	7807000	17899	9031	5	0	2
306479	1874	7809000	17899	9031	6	0	2
306488	1678	20160708413000	17901	9032	1	0	0
306489	1874	7811000	17901	9032	2	0	2
306490	1874	7813000	17901	9032	3	0	2
306491	1874	7814000	17901	9032	4	0	2
306492	1874	7817000	17901	9032	5	0	2
306525	1874	7822000	17906	9033	0	0	2
306526	1874	7825000	17906	9033	1	0	2
306533	1874	7828000	17910	9034	0	0	2
306534	1874	7830000	17910	9034	1	0	2
306545	1874	7838000	17912	9035	4	0	\N
306546	1874	7841000	17912	9035	5	0	\N
306553	1678	20160708414000	17914	9035	0	0	\N
306554	1874	7832000	17914	9035	1	0	\N
306555	1874	7833000	17914	9035	2	0	\N
306556	1874	7835000	17914	9035	3	0	\N
306557	1874	7838000	17914	9035	4	0	\N
306558	1874	7841000	17914	9035	5	0	\N
306569	1678	20160708418000	17917	9038	0	0	\N
306570	1874	7859000	17917	9038	1	0	\N
306571	1874	7862000	17917	9038	2	0	\N
306587	1678	20160708422000	17924	9042	0	0	\N
306588	1874	7877000	17924	9042	1	0	\N
306589	1874	7880000	17924	9042	2	0	\N
306590	1678	20160708422000	17925	9042	0	0	\N
306591	1874	7877000	17925	9042	1	0	\N
306592	1874	7880000	17925	9042	2	0	\N
306596	1678	20160708423000	17927	9043	0	0	\N
306597	1874	7882000	17927	9043	2	0	\N
306598	1874	7885000	17927	9043	3	0	\N
306603	1678	20160708424000	17929	9044	0	0	\N
306604	1874	7887000	17929	9044	1	0	\N
306605	1874	7890000	17929	9044	2	0	\N
306606	1874	7891000	17929	9044	3	0	\N
306607	1678	20160708424000	17930	9044	0	0	\N
306608	1874	7887000	17930	9044	1	0	\N
306609	1874	7890000	17930	9044	2	0	\N
306610	1874	7891000	17930	9044	3	0	\N
306611	1678	20160708424000	17931	9044	0	0	\N
306612	1874	7887000	17931	9044	1	0	\N
306613	1874	7890000	17931	9044	2	0	\N
306614	1874	7891000	17931	9044	3	0	\N
306625	1678	20160708428000	17934	9047	0	0	\N
306626	1874	7909000	17934	9047	1	0	\N
306627	1678	20160708428000	17935	9047	0	0	\N
306628	1874	7910000	17935	9047	1	0	\N
306629	1874	7912000	17935	9047	2	0	\N
306630	1678	20160708428000	17936	9047	0	0	\N
306631	1874	7910000	17936	9047	1	0	\N
306632	1874	7912000	17936	9047	2	0	\N
306636	1678	20160708429000	17938	9048	0	0	\N
306637	1874	7914000	17938	9048	1	0	\N
306638	1874	7917000	17938	9048	2	0	\N
306642	1678	20160708430000	17940	9049	0	0	\N
306643	1874	7918000	17940	9049	1	0	\N
306644	1874	7920000	17940	9049	2	0	\N
306652	1678	20160708431000	17943	9050	0	0	\N
306653	1874	7925000	17943	9050	1	0	\N
306654	1874	7928000	17943	9050	2	0	\N
306658	1678	20160708433000	17945	9052	0	0	\N
306659	1678	20160708434000	17945	9052	1	0	\N
306660	1874	7936000	17945	9052	2	0	\N
306661	1874	7938000	17945	9052	3	0	\N
306662	1874	7940000	17945	9052	4	0	\N
306663	1874	7941000	17945	9052	5	0	\N
306664	1874	7944000	17945	9052	6	0	\N
306665	1678	20160708433000	17946	9052	0	0	\N
306666	1678	20160708434000	17946	9052	1	0	\N
306667	1874	7936000	17946	9052	2	0	\N
306668	1874	7938000	17946	9052	3	0	\N
306669	1874	7940000	17946	9052	4	0	\N
306670	1874	7941000	17946	9052	5	0	\N
306671	1874	7944000	17946	9052	6	0	\N
306672	1678	20160708433000	17947	9052	0	0	\N
306673	1678	20160708434000	17947	9052	1	0	\N
306674	1874	7936000	17947	9052	2	0	\N
306675	1874	7938000	17947	9052	3	0	\N
306676	1874	7940000	17947	9052	4	0	\N
306677	1874	7941000	17947	9052	5	0	\N
306678	1874	7944000	17947	9052	6	0	\N
306549	1874	7833000	17913	9035	2	0	2
306550	1874	7835000	17913	9035	3	0	2
306551	1874	7838000	17913	9035	4	0	2
306552	1874	7841000	17913	9035	5	0	2
306559	1678	20160708415000	17915	9036	0	0	0
306561	1874	7846000	17915	9036	2	0	2
306562	1678	20160708416000	17916	9037	0	0	0
306563	1678	20160708417000	17916	9037	1	0	0
306564	1874	7848000	17916	9037	2	0	2
306565	1874	7849000	17916	9037	3	0	2
306567	1874	7855000	17916	9037	5	0	2
306568	1874	7857000	17916	9037	6	0	2
306572	1678	20160708418000	17918	9038	0	0	0
306573	1874	7859000	17918	9038	1	0	2
306575	1678	20160708419000	17920	9039	0	0	0
306576	1874	7864000	17920	9039	1	0	2
306577	1678	20160708420000	17921	9040	0	0	0
306578	1874	7865000	17921	9040	1	0	2
306579	1874	7868000	17921	9040	2	0	2
306581	1678	20160708421000	17922	9041	0	0	0
306582	1874	7872000	17922	9041	1	0	2
306583	1874	7875000	17922	9041	2	0	2
306584	1678	20160708422000	17923	9042	0	0	0
306585	1874	7877000	17923	9042	1	0	2
306593	1678	20160708423000	17926	9043	0	0	0
306594	1874	7882000	17926	9043	2	0	2
306595	1874	7885000	17926	9043	3	0	2
306599	1678	20160708424000	17928	9044	0	0	0
306601	1874	7890000	17928	9044	2	0	2
306602	1874	7891000	17928	9044	3	0	2
306615	1678	20160708425000	17932	9045	0	0	0
306616	1678	20160708426000	17932	9045	1	0	0
306617	1874	7893000	17932	9045	3	0	2
306619	1874	7898000	17932	9045	5	0	2
306620	1874	7901000	17932	9045	6	0	2
306621	1678	20160708427000	17933	9046	0	0	0
306622	1874	7902000	17933	9046	1	0	2
306623	1874	7904000	17933	9046	2	0	2
306633	1678	20160708428000	17937	9047	0	0	0
306634	1874	7910000	17937	9047	1	0	2
306635	1874	7912000	17937	9047	2	0	2
306639	1678	20160708429000	17939	9048	0	0	0
306641	1874	7917000	17939	9048	3	0	2
306645	1678	20160708430000	17941	9049	0	0	0
306646	1874	7918000	17941	9049	1	0	2
306647	1874	7921000	17941	9049	2	0	2
306648	1874	7923000	17941	9049	3	0	2
306650	1874	7925000	17942	9050	1	0	2
306651	1874	7928000	17942	9050	2	0	2
306655	1678	20160708432000	17944	9051	0	0	0
306656	1874	7931000	17944	9051	1	0	2
306657	1874	7933000	17944	9051	2	0	2
306680	1678	20160708434000	17948	9052	1	0	0
306699	1678	20160708363000	17953	8995	0	0	\N
306700	1678	20160708364000	17953	8995	1	0	\N
306701	1678	20160708365000	17953	8995	2	0	\N
306702	2174	200000000	17953	8995	3	0	\N
306703	2175	200000000	17953	8995	4	0	\N
306704	1678	20160708366000	17953	8995	5	0	\N
306705	1678	20160708367000	17953	8995	6	0	\N
306706	1678	20160708368000	17953	8995	7	0	\N
306707	1678	20160708369000	17953	8995	8	0	\N
306708	1678	20160708370000	17953	8995	9	0	\N
306709	1678	20160708371000	17953	8995	10	0	\N
306710	1678	20160708372000	17953	8995	11	0	\N
306711	1678	20160708373000	17953	8995	12	0	\N
306712	1678	20160708374000	17953	8995	13	0	\N
306713	1678	20160708375000	17953	8995	14	0	\N
306714	1678	20160708376000	17953	8995	15	0	\N
306715	1678	20160708377000	17953	8995	16	0	\N
306716	1678	20160708378000	17953	8995	17	0	\N
306717	1678	20160708379000	17953	8995	18	0	\N
306718	1678	20160708380000	17953	8995	19	0	\N
306719	1678	20160708381000	17953	8995	20	0	\N
306720	1678	20160708382000	17953	8995	21	0	\N
306721	1678	20160708383000	17953	8995	22	0	\N
306722	1678	20160708384000	17953	8995	23	0	\N
306723	1678	20160708385000	17953	8995	24	0	\N
306724	1678	20160708386000	17953	8995	25	0	\N
306725	1678	20160708387000	17953	8995	26	0	\N
306726	1678	20160708388000	17953	8995	27	0	\N
306727	1678	20160708389000	17953	8995	28	0	\N
306728	1678	20160708390000	17953	8995	29	0	\N
306729	1678	20160708391000	17953	8995	30	0	\N
306730	1678	20160708392000	17953	8995	31	0	\N
306731	1678	20160708393000	17953	8995	32	0	\N
306732	1678	20160708394000	17953	8995	33	0	\N
306733	1678	20160708395000	17953	8995	34	0	\N
306734	1678	20160708396000	17953	8995	35	0	\N
306735	1678	20160708397000	17953	8995	36	0	\N
306736	1678	20160708398000	17953	8995	37	0	\N
306737	1678	20160708399000	17953	8995	38	0	\N
306738	1678	20160708400000	17953	8995	39	0	\N
306739	1678	20160708401000	17953	8995	40	0	\N
306740	1678	20160708402000	17953	8995	41	0	\N
306741	1678	20160708403000	17953	8995	42	0	\N
306742	1678	20160708404000	17953	8995	43	0	\N
306743	1678	20160708405000	17953	8995	44	0	\N
306744	1678	20160708406000	17953	8995	45	0	\N
306745	1678	20160708407000	17953	8995	46	0	\N
306746	1678	20160708408000	17953	8995	47	0	\N
306747	1678	20160708409000	17953	8995	48	0	\N
306748	1678	20160708410000	17953	8995	49	0	\N
306749	1678	20160708411000	17953	8995	50	0	\N
306750	1678	20160708412000	17953	8995	51	0	\N
306751	1678	20160708413000	17953	8995	52	0	\N
306752	1678	20160708414000	17953	8995	53	0	\N
306753	1678	20160708415000	17953	8995	54	0	\N
306754	1678	20160708416000	17953	8995	55	0	\N
306755	1678	20160708417000	17953	8995	56	0	\N
306756	1678	20160708418000	17953	8995	57	0	\N
306757	1678	20160708419000	17953	8995	58	0	\N
306758	1678	20160708420000	17953	8995	59	0	\N
306759	1678	20160708421000	17953	8995	60	0	\N
306760	1678	20160708422000	17953	8995	61	0	\N
306761	1678	20160708423000	17953	8995	63	0	\N
306762	1678	20160708424000	17953	8995	64	0	\N
306763	1678	20160708425000	17953	8995	65	0	\N
306764	1678	20160708426000	17953	8995	66	0	\N
306765	1678	20160708427000	17953	8995	67	0	\N
306766	1678	20160708428000	17953	8995	68	0	\N
306767	1678	20160708429000	17953	8995	69	0	\N
306768	1678	20160708430000	17953	8995	70	0	\N
306769	1678	20160708431000	17953	8995	71	0	\N
306770	1678	20160708432000	17953	8995	72	0	\N
306771	1678	20160708433000	17953	8995	73	0	\N
306772	1678	20160708434000	17953	8995	74	0	\N
306773	1678	20160708435000	17953	8995	75	0	\N
306774	1678	20160708436000	17953	8995	76	0	\N
306775	1678	20160708437000	17953	8995	77	0	\N
306776	1678	20160708438000	17953	8995	78	0	\N
306777	1874	7529000	17953	8995	80	0	\N
306778	1874	7530000	17953	8995	84	0	\N
306779	1874	7531000	17953	8995	85	0	\N
306780	1874	7532000	17953	8995	86	0	\N
306781	1567	101	17953	8995	87	0	\N
306782	1874	7535000	17953	8995	88	0	\N
306783	1874	7538000	17953	8995	89	0	\N
306784	1874	7541000	17953	8995	90	0	\N
306785	1874	7544000	17953	8995	91	0	\N
306786	1874	7547000	17953	8995	92	0	\N
306787	1874	7550000	17953	8995	93	0	\N
306788	1874	7553000	17953	8995	94	0	\N
306789	1874	7556000	17953	8995	95	0	\N
306790	1874	7558000	17953	8995	96	0	\N
306791	1874	7560000	17953	8995	97	0	\N
306792	1874	7562000	17953	8995	98	0	\N
306793	1874	7564000	17953	8995	99	0	\N
306794	1874	7566000	17953	8995	100	0	\N
306795	1874	7568000	17953	8995	101	0	\N
306796	1874	7570000	17953	8995	102	0	\N
306797	1874	7572000	17953	8995	103	0	\N
306798	1874	7574000	17953	8995	104	0	\N
306799	1874	7576000	17953	8995	105	0	\N
306800	1874	7578000	17953	8995	106	0	\N
306801	1874	7580000	17953	8995	107	0	\N
306802	1874	7582000	17953	8995	108	0	\N
306803	1874	7584000	17953	8995	109	0	\N
306804	1874	7587000	17953	8995	110	0	\N
306805	1874	7588000	17953	8995	111	0	\N
306806	1874	7589000	17953	8995	112	0	\N
306807	1874	7590000	17953	8995	113	0	\N
306808	1874	7591000	17953	8995	114	0	\N
306809	1874	7592000	17953	8995	115	0	\N
306810	1874	7593000	17953	8995	116	0	\N
306811	1874	7594000	17953	8995	117	0	\N
306812	1874	7595000	17953	8995	118	0	\N
306813	1874	7596000	17953	8995	119	0	\N
306814	1874	7597000	17953	8995	120	0	\N
306815	1874	7598000	17953	8995	121	0	\N
306816	1874	7599000	17953	8995	122	0	\N
306683	1874	7940000	17948	9052	4	0	2
306684	1874	7941000	17948	9052	5	0	2
306685	1874	7944000	17948	9052	6	0	2
306686	1678	20160708435000	17949	9053	0	0	0
306687	1874	7946000	17949	9053	1	0	2
306689	1678	20160708436000	17950	9054	0	0	0
306690	1874	7952000	17950	9054	1	0	2
306691	1874	7954000	17950	9054	2	0	2
306692	1678	20160708437000	17951	9055	0	0	0
306693	1874	7957000	17951	9055	1	0	2
306695	1874	7960000	17951	9055	3	0	2
306696	1678	20160708438000	17952	9056	0	0	0
306697	1874	7962000	17952	9056	1	0	2
306698	1874	7965000	17952	9056	2	0	2
306817	1874	7600000	17953	8995	123	0	\N
306818	1874	7601000	17953	8995	124	0	\N
306819	1874	7602000	17953	8995	125	0	\N
306820	1678	20160708439000	17954	9057	0	0	\N
306821	1874	7968000	17954	9057	1	0	\N
306822	1874	7970000	17954	9057	2	0	\N
306826	1678	20160708439000	17956	9057	0	0	\N
306827	1874	7968000	17956	9057	1	0	\N
306828	1874	7970000	17956	9057	2	0	\N
306833	1678	20160708440000	17958	9058	0	0	\N
306834	1874	7973000	17958	9058	1	0	\N
306835	1874	7974000	17958	9058	2	0	\N
306836	1874	7976000	17958	9058	3	0	\N
306837	329	67444622000000	17959	8913	0	0	\N
306838	2171	200000000	17959	8913	3	0	\N
306839	2174	200000000	17959	8913	4	0	\N
306840	2175	200000000	17959	8913	5	0	\N
306841	1726	110795110000	17959	8913	11	0	\N
306842	1874	6995000	17959	8913	12	0	\N
306843	1567	101	17959	8913	15	0	\N
306844	1874	6996000	17959	8913	16	0	\N
306845	1874	6997000	17959	8913	17	0	\N
306846	1874	6998000	17959	8913	18	0	\N
306847	1874	6999000	17959	8913	19	0	\N
306848	1874	7000000	17959	8913	20	0	\N
306849	1874	7001000	17959	8913	21	0	\N
306850	1874	7002000	17959	8913	22	0	\N
306851	1874	7003000	17959	8913	23	0	\N
306852	1874	7004000	17959	8913	24	0	\N
306853	1874	7005000	17959	8913	25	0	\N
306854	1874	7006000	17959	8913	26	0	\N
306855	1874	7007000	17959	8913	27	0	\N
306856	1874	7008000	17959	8913	28	0	\N
306857	1874	7009000	17959	8913	29	0	\N
306858	1874	7010000	17959	8913	30	0	\N
306859	1874	7011000	17959	8913	31	0	\N
306860	1874	7012000	17959	8913	32	0	\N
306861	1874	7013000	17959	8913	33	0	\N
306862	1874	7014000	17959	8913	34	0	\N
306863	1874	7015000	17959	8913	35	0	\N
306864	1874	7016000	17959	8913	36	0	\N
306865	1874	7017000	17959	8913	37	0	\N
306866	1874	7018000	17959	8913	38	0	\N
306867	1874	7019000	17959	8913	39	0	\N
306868	1874	7020000	17959	8913	40	0	\N
306869	1874	7021000	17959	8913	41	0	\N
306870	1874	7022000	17959	8913	42	0	\N
306871	1874	7023000	17959	8913	43	0	\N
306872	1874	7024000	17959	8913	44	0	\N
306873	1874	7025000	17959	8913	45	0	\N
306874	1874	7026000	17959	8913	46	0	\N
306875	1874	7027000	17959	8913	47	0	\N
306876	1874	7028000	17959	8913	48	0	\N
306877	1874	7029000	17959	8913	49	0	\N
306878	1874	7030000	17959	8913	50	0	\N
306879	1874	7031000	17959	8913	51	0	\N
306880	1874	7032000	17959	8913	52	0	\N
306881	1874	7033000	17959	8913	53	0	\N
306882	1874	7034000	17959	8913	54	0	\N
306883	1874	7035000	17959	8913	55	0	\N
306884	1874	7036000	17959	8913	56	0	\N
306885	1874	7037000	17959	8913	57	0	\N
306886	1874	7038000	17959	8913	58	0	\N
306893	329	67444622000000	17961	8954	0	0	\N
306894	2171	200000000	17961	8954	3	0	\N
306895	2174	200000000	17961	8954	4	0	\N
306896	2175	200000000	17961	8954	5	0	\N
306897	1726	110795110000	17961	8954	11	0	\N
306898	1874	7213000	17961	8954	12	0	\N
306899	1567	101	17961	8954	15	0	\N
306900	1874	7215000	17961	8954	16	0	\N
306901	1874	7217000	17961	8954	17	0	\N
306902	1874	7219000	17961	8954	18	0	\N
306903	1874	7221000	17961	8954	19	0	\N
306904	1874	7223000	17961	8954	20	0	\N
306905	1874	7225000	17961	8954	21	0	\N
306906	1874	7226000	17961	8954	22	0	\N
306907	1874	7227000	17961	8954	23	0	\N
306908	1874	7228000	17961	8954	24	0	\N
306909	1874	7229000	17961	8954	25	0	\N
306910	1874	7230000	17961	8954	26	0	\N
306911	1874	7231000	17961	8954	27	0	\N
306912	1874	7232000	17961	8954	28	0	\N
306913	1874	7234000	17961	8954	29	0	\N
306914	1874	7236000	17961	8954	30	0	\N
306915	1874	7238000	17961	8954	31	0	\N
306916	1874	7240000	17961	8954	32	0	\N
306917	1874	7242000	17961	8954	33	0	\N
306918	1874	7244000	17961	8954	34	0	\N
306919	1874	7246000	17961	8954	35	0	\N
306920	1874	7248000	17961	8954	36	0	\N
306921	1874	7250000	17961	8954	37	0	\N
306922	1874	7252000	17961	8954	38	0	\N
306923	1874	7254000	17961	8954	39	0	\N
306924	1874	7256000	17961	8954	40	0	\N
306925	1874	7258000	17961	8954	41	0	\N
306926	1874	7260000	17961	8954	42	0	\N
306927	1874	7262000	17961	8954	43	0	\N
306928	1874	7264000	17961	8954	44	0	\N
306929	1874	7266000	17961	8954	45	0	\N
306930	1874	7268000	17961	8954	46	0	\N
306931	1874	7270000	17961	8954	47	0	\N
306932	1874	7272000	17961	8954	48	0	\N
306933	1874	7274000	17961	8954	49	0	\N
306934	1874	7276000	17961	8954	50	0	\N
306935	1874	7278000	17961	8954	51	0	\N
306936	1874	7280000	17961	8954	52	0	\N
306937	1874	7282000	17961	8954	53	0	\N
306938	1874	7284000	17961	8954	54	0	\N
306939	1874	7286000	17961	8954	55	0	\N
306940	1874	7288000	17961	8954	56	0	\N
306941	1874	7290000	17961	8954	57	0	\N
306942	1874	7292000	17961	8954	58	0	\N
306943	1874	7294000	17961	8954	59	0	\N
306944	1874	7296000	17961	8954	60	0	\N
306945	1874	7298000	17961	8954	61	0	\N
306946	1874	7300000	17961	8954	62	0	\N
306947	1874	7302000	17961	8954	63	0	\N
306948	1874	7304000	17961	8954	64	0	\N
306949	1874	7306000	17961	8954	65	0	\N
306950	1874	7308000	17961	8954	66	0	\N
306951	1874	7310000	17961	8954	67	0	\N
306952	1874	7312000	17961	8954	68	0	\N
306825	1874	7970000	17955	9057	2	0	2
306829	1678	20160708440000	17957	9058	0	0	0
306830	1874	7973000	17957	9058	1	0	2
306831	1874	7974000	17957	9058	2	0	2
306832	1874	7976000	17957	9058	3	0	2
306888	1678	20160708442000	17960	9059	1	0	0
306889	1874	7978000	17960	9059	2	0	2
306890	1874	7981000	17960	9059	3	0	2
306891	1874	7984000	17960	9059	4	0	2
306892	1874	7986000	17960	9059	5	0	2
306953	1874	7314000	17961	8954	69	0	\N
306954	1874	7316000	17961	8954	70	0	\N
306955	1874	7317000	17961	8954	71	0	\N
306956	1874	7318000	17961	8954	72	0	\N
306957	1874	7319000	17961	8954	73	0	\N
306958	1874	7320000	17961	8954	74	0	\N
306959	1874	7321000	17961	8954	75	0	\N
306960	1874	7322000	17961	8954	76	0	\N
306961	1874	7323000	17961	8954	77	0	\N
306962	1874	7324000	17961	8954	78	0	\N
306963	1874	7325000	17961	8954	79	0	\N
306964	1874	7326000	17961	8954	80	0	\N
306965	1874	7327000	17961	8954	81	0	\N
306966	1874	7328000	17961	8954	82	0	\N
306967	1874	7329000	17961	8954	83	0	\N
306968	1874	7330000	17961	8954	84	0	\N
306969	1874	7331000	17961	8954	85	0	\N
306970	1874	7332000	17961	8954	86	0	\N
306971	1874	7333000	17961	8954	87	0	\N
306972	1874	7334000	17961	8954	88	0	\N
306973	1874	7335000	17961	8954	89	0	\N
306974	1874	7336000	17961	8954	90	0	\N
306975	1874	7337000	17961	8954	91	0	\N
306976	1874	7338000	17961	8954	92	0	\N
306977	1874	7339000	17961	8954	93	0	\N
306988	1678	20160708446000	17964	9062	0	0	\N
306989	1678	20160708447000	17964	9062	1	0	\N
306990	1678	20160708448000	17964	9062	2	0	\N
306991	1874	8004000	17964	9062	3	0	\N
306992	1874	8007000	17964	9062	4	0	\N
306993	1874	8008000	17964	9062	5	0	\N
306994	1874	8010000	17964	9062	6	0	\N
306995	1874	8013000	17964	9062	7	0	\N
306996	1874	8016000	17964	9062	8	0	\N
306997	1874	8018000	17964	9062	9	0	\N
306998	1678	20160708446000	17965	9062	0	0	\N
306999	1678	20160708447000	17965	9062	1	0	\N
307000	1678	20160708448000	17965	9062	2	0	\N
307001	1874	8004000	17965	9062	3	0	\N
307002	1874	8007000	17965	9062	4	0	\N
307003	1874	8008000	17965	9062	5	0	\N
307004	1874	8010000	17965	9062	6	0	\N
307005	1874	8013000	17965	9062	7	0	\N
307006	1874	8016000	17965	9062	8	0	\N
307007	1874	8018000	17965	9062	9	0	\N
307018	1678	20160708449000	17967	9063	0	0	\N
307019	1874	8020000	17967	9063	1	0	\N
307022	1678	20160708449000	17969	9063	0	0	\N
307023	1874	8020000	17969	9063	1	0	\N
307024	1678	20160708449000	17970	9063	0	0	\N
307025	1874	8020000	17970	9063	1	0	\N
307028	1678	20160708450000	17972	9064	0	0	\N
307029	1678	20160708451000	17972	9064	1	0	\N
307030	1874	8022000	17972	9064	2	0	\N
307031	1874	8025000	17972	9064	3	0	\N
307032	1874	8026000	17972	9064	4	0	\N
307033	1874	8028000	17972	9064	5	0	\N
307034	1874	8031000	17972	9064	6	0	\N
307035	1678	20160708452000	17973	9065	0	0	\N
307036	1874	8022000	17973	9065	1	0	\N
307037	1874	8025000	17973	9065	2	0	\N
307038	1874	8026000	17973	9065	3	0	\N
307039	1874	8028000	17973	9065	4	0	\N
307040	1874	8030000	17973	9065	5	0	\N
307041	1874	8033000	17973	9065	6	0	\N
307042	1874	8036000	17973	9065	7	0	\N
307051	1678	20160708452000	17975	9065	0	0	\N
307052	1874	8022000	17975	9065	1	0	\N
307053	1874	8025000	17975	9065	2	0	\N
307054	1874	8026000	17975	9065	3	0	\N
307055	1874	8028000	17975	9065	4	0	\N
307056	1874	8030000	17975	9065	5	0	\N
307057	1874	8033000	17975	9065	6	0	\N
307058	1874	8036000	17975	9065	7	0	\N
307059	2177	8351322800000	17976	9066	0	0	\N
307060	1678	20160708453000	17976	9066	1	0	\N
307061	1874	8038000	17976	9066	2	0	\N
307062	1874	8041000	17976	9066	3	0	\N
307071	1678	20160708454000	17979	9067	0	0	\N
307072	1874	8044000	17979	9067	1	0	\N
307073	1874	8045000	17979	9067	2	0	\N
307074	1678	20160708455000	17980	9068	0	0	\N
307075	1678	20160708456000	17980	9068	1	0	\N
307076	1874	8049000	17980	9068	2	0	\N
307077	1874	8051000	17980	9068	3	0	\N
307078	1874	8054000	17980	9068	4	0	\N
307079	1874	8057000	17980	9068	5	0	\N
306980	1874	7988000	17962	9060	2	0	2
306981	1874	7990000	17962	9060	3	0	2
306982	1874	7993000	17962	9060	4	0	2
306983	1874	7996000	17962	9060	5	0	2
306984	1874	7997000	17962	9060	6	0	2
306986	1874	8000000	17963	9061	1	0	2
306987	1874	8002000	17963	9061	2	0	2
307008	1678	20160708446000	17966	9062	0	0	0
307009	1678	20160708447000	17966	9062	1	0	0
307010	1678	20160708448000	17966	9062	2	0	0
307012	1874	8007000	17966	9062	4	0	2
307013	1874	8008000	17966	9062	5	0	2
307014	1874	8010000	17966	9062	6	0	2
307015	1874	8013000	17966	9062	7	0	2
307017	1874	8018000	17966	9062	9	0	2
307020	1678	20160708449000	17968	9063	0	0	0
307021	1874	8020000	17968	9063	1	0	2
307026	1678	20160708450000	17971	9064	0	0	0
307027	1678	20160708451000	17971	9064	1	0	0
307044	1874	8022000	17974	9065	1	0	2
307045	1874	8025000	17974	9065	2	0	2
307046	1874	8026000	17974	9065	3	0	2
307047	1874	8028000	17974	9065	4	0	2
307048	1874	8030000	17974	9065	5	0	2
307050	1874	8036000	17974	9065	7	0	2
307063	2177	8351322800000	17977	9066	0	0	0
307064	1678	20160708453000	17977	9066	1	0	0
307065	1874	8038000	17977	9066	2	0	2
307067	1678	20160708454000	17978	9067	0	0	0
307068	1874	8044000	17978	9067	1	0	2
307069	1874	8045000	17978	9067	2	0	2
307070	1874	8047000	17978	9067	3	0	2
307080	1678	20160708455000	17981	9068	0	0	0
307082	1874	8049000	17981	9068	2	0	2
307083	1874	8051000	17981	9068	3	0	2
307084	1874	8054000	17981	9068	4	0	2
307085	1874	8057000	17981	9068	5	0	2
307086	1678	20160708457000	17982	9069	0	0	0
307088	1678	20160708458000	17982	9069	2	0	0
307120	1678	20160708466000	17988	9075	0	0	\N
307121	1874	8106000	17988	9075	1	0	\N
307122	1874	8108000	17988	9075	2	0	\N
307126	1678	20160708467000	17990	9076	0	0	\N
307127	2178	200000000	17990	9076	1	0	\N
307128	1874	8111000	17990	9076	2	0	\N
307129	1874	8112000	17990	9076	3	0	\N
307130	1874	8114000	17990	9076	4	0	\N
307151	1678	20160708445000	17994	9061	0	0	\N
307152	2177	9556246850100	17994	9061	1	0	\N
307153	2178	200000000	17994	9061	2	0	\N
307154	2179	200000000	17994	9061	3	0	\N
307155	2177	36771686249641	17994	9061	4	0	\N
307156	2180	200000000	17994	9061	5	0	\N
307157	2177	45124009049641	17994	9061	6	0	\N
307158	2177	58444409049641	17994	9061	7	0	\N
307159	1678	20160708446000	17994	9061	8	0	\N
307160	1678	20160708447000	17994	9061	9	0	\N
307161	1678	20160708448000	17994	9061	10	0	\N
307162	1678	20160708449000	17994	9061	11	0	\N
307163	1678	20160708450000	17994	9061	12	0	\N
307164	1678	20160708451000	17994	9061	13	0	\N
307165	1678	20160708452000	17994	9061	14	0	\N
307166	2177	59992466249641	17994	9061	15	0	\N
307167	2177	63700566249641	17994	9061	16	0	\N
307168	1678	20160708453000	17994	9061	17	0	\N
307169	1678	20160708454000	17994	9061	18	0	\N
307170	1678	20160708455000	17994	9061	19	0	\N
307171	1678	20160708456000	17994	9061	21	0	\N
307172	1678	20160708457000	17994	9061	22	0	\N
307173	1678	20160708458000	17994	9061	23	0	\N
307174	1678	20160708459000	17994	9061	24	0	\N
307175	1678	20160708460000	17994	9061	25	0	\N
307176	1678	20160708461000	17994	9061	26	0	\N
307177	1678	20160708462000	17994	9061	27	0	\N
307178	1678	20160708463000	17994	9061	28	0	\N
307179	1678	20160708464000	17994	9061	29	0	\N
307180	1678	20160708465000	17994	9061	30	0	\N
307181	1678	20160708466000	17994	9061	31	0	\N
307182	1678	20160708467000	17994	9061	32	0	\N
307183	1678	20160708468000	17994	9061	33	0	\N
307184	1678	20160708469000	17994	9061	34	0	\N
307185	1678	20160708470000	17994	9061	35	0	\N
307186	1678	20160708471000	17994	9061	36	0	\N
307187	1874	8000000	17994	9061	37	0	\N
307188	1874	8003000	17994	9061	38	0	\N
307189	1874	8004000	17994	9061	39	0	\N
307190	1874	8006000	17994	9061	41	0	\N
307191	1874	8008000	17994	9061	42	0	\N
307192	1874	8010000	17994	9061	43	0	\N
307193	1874	8013000	17994	9061	44	0	\N
307194	1874	8016000	17994	9061	45	0	\N
307195	1874	8019000	17994	9061	46	0	\N
307196	1874	8021000	17994	9061	47	0	\N
307197	1874	8023000	17994	9061	48	0	\N
307198	1874	8025000	17994	9061	49	0	\N
307199	1874	8026000	17994	9061	50	0	\N
307200	1874	8027000	17994	9061	51	0	\N
307201	1874	8028000	17994	9061	52	0	\N
307202	1874	8029000	17994	9061	53	0	\N
307203	1874	8031000	17994	9061	54	0	\N
307204	1874	8033000	17994	9061	55	0	\N
307205	1874	8035000	17994	9061	56	0	\N
307206	1874	8037000	17994	9061	57	0	\N
307207	1874	8039000	17994	9061	58	0	\N
307208	1874	8041000	17994	9061	59	0	\N
307209	1874	8043000	17994	9061	60	0	\N
307210	1874	8045000	17994	9061	61	0	\N
307211	1874	8047000	17994	9061	62	0	\N
307212	1874	8049000	17994	9061	63	0	\N
307213	1874	8051000	17994	9061	64	0	\N
307214	1874	8053000	17994	9061	65	0	\N
307215	1874	8055000	17994	9061	66	0	\N
307216	1874	8057000	17994	9061	67	0	\N
307217	1874	8058000	17994	9061	68	0	\N
307218	1874	8060000	17994	9061	69	0	\N
307219	1874	8061000	17994	9061	70	0	\N
307220	1874	8062000	17994	9061	71	0	\N
307221	1874	8065000	17994	9061	72	0	\N
307222	1874	8068000	17994	9061	73	0	\N
307223	1874	8071000	17994	9061	74	0	\N
307224	1874	8074000	17994	9061	75	0	\N
307091	1874	8063000	17982	9069	5	0	2
307092	1874	8066000	17982	9069	6	0	2
307093	1874	8068000	17982	9069	7	0	2
307094	1678	20160708459000	17983	9070	0	0	0
307095	1678	20160708460000	17983	9070	1	0	0
307097	1874	8070000	17983	9070	3	0	2
307098	1874	8073000	17983	9070	4	0	2
307099	1874	8074000	17983	9070	5	0	2
307100	1874	8077000	17983	9070	6	0	2
307101	1874	8079000	17983	9070	7	0	2
307103	1678	20160708461000	17984	9071	1	0	0
307104	1678	20160708462000	17984	9071	2	0	0
307105	1874	8082000	17984	9071	4	0	2
307106	1874	8085000	17984	9071	5	0	2
307108	1874	8089000	17984	9071	7	0	2
307109	1678	20160708463000	17985	9072	0	0	0
307110	1874	8091000	17985	9072	1	0	2
307111	1874	8094000	17985	9072	2	0	2
307112	1678	20160708464000	17986	9073	0	0	0
307114	1874	8096000	17986	9073	2	0	2
307115	1874	8097000	17986	9073	3	0	2
307116	1678	20160708465000	17987	9074	0	0	0
307117	2177	63700566249641	17987	9074	1	0	0
307118	1874	8100000	17987	9074	2	0	2
307123	1678	20160708466000	17989	9075	0	0	0
307124	1874	8106000	17989	9075	1	0	2
307125	1874	8108000	17989	9075	2	0	2
307131	1678	20160708467000	17991	9076	0	0	0
307133	1874	8111000	17991	9076	2	0	2
307134	1874	8112000	17991	9076	3	0	2
307135	1874	8114000	17991	9076	4	0	2
307136	2179	200000000	17992	9077	0	0	0
307137	1678	20160708468000	17992	9077	1	0	0
307139	1678	20160708470000	17992	9077	3	0	0
307140	2180	200000000	17992	9077	4	0	0
307141	1874	8115000	17992	9077	5	0	2
307142	1874	8118000	17992	9077	6	0	2
307143	1874	8121000	17992	9077	7	0	2
307145	1874	8126000	17992	9077	9	0	2
307146	1874	8128000	17992	9077	10	0	2
307147	1874	8130000	17992	9077	11	0	2
307148	1678	20160708471000	17993	9078	0	0	0
307150	1874	8135000	17993	9078	2	0	2
307225	1874	8077000	17994	9061	76	0	\N
307226	1874	8080000	17994	9061	77	0	\N
307227	1874	8083000	17994	9061	78	0	\N
307228	1874	8086000	17994	9061	79	0	\N
307229	1874	8089000	17994	9061	80	0	\N
307230	1874	8092000	17994	9061	81	0	\N
307231	1874	8095000	17994	9061	82	0	\N
307232	1874	8098000	17994	9061	83	0	\N
307233	1874	8101000	17994	9061	84	0	\N
307234	1874	8104000	17994	9061	85	0	\N
307235	1874	8107000	17994	9061	86	0	\N
307236	1874	8110000	17994	9061	87	0	\N
307237	1874	8113000	17994	9061	88	0	\N
307238	1874	8116000	17994	9061	89	0	\N
307239	1874	8119000	17994	9061	90	0	\N
307240	1874	8122000	17994	9061	91	0	\N
307241	1874	8125000	17994	9061	92	0	\N
307242	1874	8127000	17994	9061	93	0	\N
307243	1874	8129000	17994	9061	94	0	\N
307244	1874	8131000	17994	9061	95	0	\N
307245	1874	8133000	17994	9061	96	0	\N
307246	1874	8135000	17994	9061	97	0	\N
307247	1678	20160708472000	17995	9079	0	0	\N
307248	1874	8137000	17995	9079	1	0	\N
307249	1874	8140000	17995	9079	2	0	\N
307250	1678	20160708472000	17996	9079	0	0	\N
307251	1874	8137000	17996	9079	1	0	\N
307252	1874	8140000	17996	9079	2	0	\N
307258	1678	20160708474000	17999	9081	0	0	\N
307259	1483	10000000	17999	9081	1	0	\N
307260	1874	8144000	17999	9081	2	0	\N
307261	1874	8147000	17999	9081	3	0	\N
307262	1874	8148000	17999	9081	4	0	\N
307263	1678	20160708474000	18000	9081	0	0	\N
307264	1483	10000000	18000	9081	1	0	\N
307265	1874	8144000	18000	9081	2	0	\N
307266	1874	8147000	18000	9081	3	0	\N
307267	1874	8148000	18000	9081	4	0	\N
307273	1678	20160708475000	18002	9082	0	0	\N
307274	1874	8150000	18002	9082	1	0	\N
307275	1874	8153000	18002	9082	2	0	\N
307276	1678	20160708475000	18004	9082	0	0	\N
307277	1874	8150000	18004	9082	1	0	\N
307278	1874	8153000	18004	9082	2	0	\N
307285	1678	20160708475000	18006	9083	0	0	\N
307286	1678	20160708476000	18006	9083	1	0	\N
307287	1874	8150000	18006	9083	2	0	\N
307288	1874	8153000	18006	9083	3	0	\N
307289	1874	8155000	18006	9083	4	0	\N
307290	1874	8158000	18006	9083	5	0	\N
307291	1678	20160708475000	18007	9083	0	0	\N
307292	1678	20160708476000	18007	9083	1	0	\N
307293	1678	20160708477000	18007	9083	2	0	\N
307294	1874	8149000	18007	9083	3	0	\N
307295	1874	8151000	18007	9083	4	0	\N
307296	1874	8154000	18007	9083	5	0	\N
307297	1874	8156000	18007	9083	6	0	\N
307298	1874	8159000	18007	9083	7	0	\N
307299	1874	8161000	18007	9083	8	0	\N
307300	1874	8164000	18007	9083	9	0	\N
307305	1678	20160708477000	18009	9084	0	0	\N
307306	1874	8159000	18009	9084	1	0	\N
307307	1874	8161000	18009	9084	2	0	\N
307308	1874	8164000	18009	9084	3	0	\N
307309	1678	20160708478000	18010	9084	0	0	\N
307310	1874	8166000	18010	9084	1	0	\N
307311	1874	8169000	18010	9084	2	0	\N
307312	2164	612599000000	18010	9084	3	0	\N
307320	1678	20160708478000	18013	9085	0	0	\N
307321	1678	20160708479000	18013	9085	1	0	\N
307322	1874	8166000	18013	9085	2	0	\N
307323	1874	8168000	18013	9085	3	0	\N
307324	1874	8171000	18013	9085	4	0	\N
307325	1874	8174000	18013	9085	5	0	\N
307326	2164	612599000000	18013	9085	6	0	\N
307327	1678	20160708478000	18014	9085	0	0	\N
307328	1678	20160708479000	18014	9085	1	0	\N
307329	1874	8166000	18014	9085	2	0	\N
307330	1874	8168000	18014	9085	3	0	\N
307331	1874	8171000	18014	9085	4	0	\N
307332	1874	8174000	18014	9085	5	0	\N
307333	2164	612599000000	18014	9085	6	0	\N
307341	1678	20160708482000	18017	9089	0	0	\N
307342	1874	8187000	18017	9089	1	0	\N
307343	1874	8190000	18017	9089	2	0	\N
307347	1678	20160708482000	18019	9089	0	0	\N
307348	1874	8188000	18019	9089	1	0	\N
307349	1678	20160708483000	18020	9090	0	0	\N
307350	1874	8193000	18020	9090	1	0	\N
307351	1874	8195000	18020	9090	2	0	\N
307352	1483	10000000	18020	9090	3	0	\N
307255	1874	8140000	17997	9079	2	0	2
307256	1678	20160708473000	17998	9080	0	0	0
307257	1874	8142000	17998	9080	1	0	2
307268	1678	20160708474000	18001	9081	0	0	0
307269	1483	10000000	18001	9081	1	0	0
307271	1874	8147000	18001	9081	3	0	2
307272	1874	8148000	18001	9081	4	0	2
307279	1678	20160708475000	18005	9083	0	0	0
307280	1678	20160708476000	18005	9083	1	0	0
307281	1874	8150000	18005	9083	2	0	2
307283	1874	8155000	18005	9083	4	0	2
307284	1874	8158000	18005	9083	5	0	2
307301	1678	20160708477000	18008	9084	0	0	0
307302	1874	8159000	18008	9084	1	0	2
307304	1874	8164000	18008	9084	3	0	2
307313	1678	20160708478000	18011	9085	0	0	0
307314	1874	8166000	18011	9085	1	0	2
307315	1874	8168000	18011	9085	2	0	2
307316	1874	8171000	18011	9085	3	0	2
307318	1678	20160708479000	18012	9086	0	0	0
307319	1874	8174000	18012	9086	1	0	2
307334	1678	20160708480000	18015	9087	0	0	0
307335	1874	8176000	18015	9087	1	0	2
307336	1874	8177000	18015	9087	2	0	2
307338	1678	20160708481000	18016	9088	0	0	0
307339	1874	8182000	18016	9088	1	0	2
307340	1874	8185000	18016	9088	2	0	2
307344	1678	20160708482000	18018	9089	0	0	0
307346	1874	8190000	18018	9089	2	0	2
307353	1678	20160708483000	18021	9090	0	0	0
307354	1874	8193000	18021	9090	1	0	2
307355	1874	8195000	18021	9090	2	0	2
307356	1483	10000000	18021	9090	3	0	0
307358	1678	20160708485000	18022	9091	1	0	0
307359	1874	8197000	18022	9091	2	0	2
307360	1874	8198000	18022	9091	3	0	2
307370	1678	20160708488000	18025	9094	0	0	\N
307371	1874	8217000	18025	9094	1	0	\N
307379	1678	20160708490000	18029	9096	0	0	\N
307380	1874	8221000	18029	9096	1	0	\N
307381	1874	8224000	18029	9096	2	0	\N
307382	1678	20160708490000	18030	9096	0	0	\N
307383	1874	8221000	18030	9096	1	0	\N
307384	1874	8224000	18030	9096	2	0	\N
307385	1678	20160708490000	18031	9096	0	0	\N
307386	1874	8221000	18031	9096	1	0	\N
307387	1874	8224000	18031	9096	2	0	\N
307390	1678	20160708492000	18033	9098	0	0	\N
307391	1678	20160708493000	18033	9098	1	0	\N
307392	1874	8230000	18033	9098	2	0	\N
307393	1874	8233000	18033	9098	3	0	\N
307394	2177	9556246850100	18034	9044	0	0	\N
307395	2178	200000000	18034	9044	1	0	\N
307396	2179	200000000	18034	9044	2	0	\N
307397	1483	10000000	18034	9044	3	0	\N
307398	2177	36771686249641	18034	9044	4	0	\N
307399	2180	200000000	18034	9044	5	0	\N
307400	2177	45124009049641	18034	9044	6	0	\N
307401	2177	58444409049641	18034	9044	7	0	\N
307402	2177	59992466249641	18034	9044	8	0	\N
307403	2177	63700566249641	18034	9044	9	0	\N
307404	2164	612599000000	18034	9044	13	0	\N
307405	1483	10000000	18034	9044	14	0	\N
307410	1678	20160708494000	18036	9099	0	0	\N
307411	1874	8234000	18036	9099	1	0	\N
307412	1874	8237000	18036	9099	2	0	\N
307418	1678	20160708495000	18039	9100	0	0	\N
307419	1874	8240000	18039	9100	1	0	\N
307422	1678	20160708496000	18041	9101	0	0	\N
307423	1874	8243000	18041	9101	1	0	\N
307424	2175	200000000	18042	8999	0	0	\N
307425	2177	9556246850100	18042	8999	1	0	\N
307426	2178	200000000	18042	8999	2	0	\N
307427	2179	200000000	18042	8999	3	0	\N
307428	1483	10000000	18042	8999	4	0	\N
307429	2177	36771686249641	18042	8999	5	0	\N
307430	2180	200000000	18042	8999	6	0	\N
307431	2177	45124009049641	18042	8999	7	0	\N
307432	2177	58444409049641	18042	8999	8	0	\N
307433	2177	59992466249641	18042	8999	9	0	\N
307434	2177	63700566249641	18042	8999	10	0	\N
307435	1567	101	18042	8999	16	0	\N
307436	2164	612599000000	18042	8999	17	0	\N
307437	1483	10000000	18042	8999	18	0	\N
307441	1678	20160708497000	18044	9102	0	0	\N
307442	1874	8246000	18044	9102	1	0	\N
307443	1874	8247000	18044	9102	2	0	\N
307444	1678	20160708497000	18045	9102	0	0	\N
307445	1874	8246000	18045	9102	1	0	\N
307446	1874	8247000	18045	9102	2	0	\N
307452	1678	20160708499000	18048	9104	0	0	\N
307453	1874	8253000	18048	9104	1	0	\N
307454	1678	20160708499000	18049	9104	0	0	\N
307455	1874	8253000	18049	9104	1	0	\N
307456	1678	20160708500000	18050	9105	0	0	\N
307457	1874	8256000	18050	9105	1	0	\N
307458	1874	8257000	18050	9105	2	0	\N
307469	2181	612200000000	18055	9107	0	0	\N
307470	1678	20160708503000	18055	9107	1	0	\N
307471	1874	8266000	18055	9107	2	0	\N
307472	2181	612200000000	18056	9107	0	0	\N
307473	1678	20160708503000	18056	9107	1	0	\N
307474	1874	8266000	18056	9107	2	0	\N
307475	2181	200000000	18057	8914	0	0	\N
307476	2181	612200000000	18057	8914	1	0	\N
307477	2177	9556246850100	18057	8914	3	0	\N
307478	1678	20160708504000	18058	9108	0	0	\N
307479	1483	10000000	18058	9108	1	0	\N
307480	1678	20160708505000	18058	9108	2	0	\N
307481	1874	8267000	18058	9108	3	0	\N
307482	1874	8270000	18058	9108	4	0	\N
307483	1874	8273000	18058	9108	5	0	\N
307490	1678	20160708506000	18060	9109	0	0	\N
307491	1678	20160708507000	18060	9109	1	0	\N
307492	1483	10000000	18060	9109	2	0	\N
307493	1874	8276000	18060	9109	3	0	\N
307494	1874	8279000	18060	9109	4	0	\N
307495	1874	8280000	18060	9109	5	0	\N
307496	1678	20160708506000	18061	9109	0	0	\N
307363	1678	20160708486000	18023	9092	0	0	0
307364	1874	8205000	18023	9092	1	0	2
307365	1874	8208000	18023	9092	2	0	2
307366	1678	20160708487000	18024	9093	0	0	0
307367	1874	8209000	18024	9093	1	0	2
307369	1874	8214000	18024	9093	3	0	2
307372	1678	20160708488000	18026	9094	0	0	0
307373	1874	8217000	18026	9094	1	0	2
307374	1678	20160708489000	18027	9095	0	0	0
307375	1874	8220000	18027	9095	1	0	2
307377	1874	8221000	18028	9096	1	0	2
307378	1874	8224000	18028	9096	2	0	2
307388	1678	20160708491000	18032	9097	0	0	0
307389	1874	8227000	18032	9097	1	0	2
307407	1678	20160708493000	18035	9098	1	0	0
307408	1874	8230000	18035	9098	2	0	2
307409	1874	8233000	18035	9098	3	0	2
307413	1678	20160708494000	18037	9099	0	0	0
307414	1874	8234000	18037	9099	1	0	2
307416	1678	20160708495000	18038	9100	0	0	0
307417	1874	8240000	18038	9100	1	0	2
307420	1678	20160708496000	18040	9101	0	0	0
307421	1874	8243000	18040	9101	1	0	2
307438	1678	20160708497000	18043	9102	0	0	0
307440	1874	8247000	18043	9102	2	0	2
307447	2181	200000000	18046	9103	0	0	0
307448	1678	20160708498000	18046	9103	1	0	0
307449	1874	8250000	18046	9103	2	0	2
307451	1874	8253000	18047	9104	1	0	2
307459	1678	20160708500000	18051	9105	0	0	0
307460	1874	8256000	18051	9105	1	0	2
307461	1874	8257000	18051	9105	2	0	2
307462	1678	20160708501000	18052	9106	0	0	0
307464	1874	8260000	18052	9106	2	0	2
307465	1874	8263000	18052	9106	3	0	2
307466	2181	612200000000	18054	9107	0	0	0
307467	1678	20160708503000	18054	9107	1	0	0
307468	1874	8266000	18054	9107	2	0	2
307485	1483	10000000	18059	9108	1	0	0
307486	1678	20160708505000	18059	9108	2	0	0
307487	1874	8267000	18059	9108	3	0	2
307488	1874	8270000	18059	9108	4	0	2
307497	1678	20160708507000	18061	9109	1	0	\N
307498	1483	10000000	18061	9109	2	0	\N
307499	1874	8276000	18061	9109	3	0	\N
307500	1874	8279000	18061	9109	4	0	\N
307501	1874	8280000	18061	9109	5	0	\N
307508	1678	20160708508000	18063	9110	0	0	\N
307509	1678	20160708508000	18064	9110	0	0	\N
307517	1678	20160708511000	18068	9113	0	0	\N
307518	1874	8290000	18068	9113	1	0	\N
307519	1678	20160708511000	18069	9113	0	0	\N
307520	1874	8290000	18069	9113	1	0	\N
307523	1678	20160708511000	18071	9113	0	0	\N
307524	1874	8290000	18071	9113	1	0	\N
307525	1678	20160708511000	18072	9113	0	0	\N
307526	1874	8290000	18072	9113	1	0	\N
307527	1678	20160708512000	18073	9114	0	0	\N
307528	1678	20160708513000	18073	9114	1	0	\N
307529	1874	8293000	18073	9114	2	0	\N
307530	1874	8296000	18073	9114	3	0	\N
307549	1678	20160708519000	18078	9117	0	0	\N
307550	1874	8316000	18078	9117	1	0	\N
307551	1678	20160708520000	18079	9118	0	0	\N
307552	1874	8319000	18079	9118	1	0	\N
307553	1874	8320000	18079	9118	2	0	\N
307557	1678	20160708520000	18081	9118	0	0	\N
307558	1874	8319000	18081	9118	1	0	\N
307559	1874	8320000	18081	9118	2	0	\N
307569	2181	200000000	18085	9084	0	0	\N
307570	2181	612200000000	18085	9084	1	0	\N
307571	1560	15714357277001	18085	9084	2	0	\N
307572	1483	10000000	18085	9084	3	0	\N
307573	1874	8165000	18085	9084	4	0	\N
307574	1874	8166000	18085	9084	5	0	\N
307575	1874	8167000	18085	9084	6	0	\N
307576	1874	8168000	18085	9084	7	0	\N
307577	1874	8169000	18085	9084	8	0	\N
307578	1874	8170000	18085	9084	9	0	\N
307579	1874	8171000	18085	9084	10	0	\N
307580	1874	8172000	18085	9084	11	0	\N
307581	1874	8173000	18085	9084	12	0	\N
307582	1874	8174000	18085	9084	13	0	\N
307583	1874	8175000	18085	9084	14	0	\N
307584	1874	8176000	18085	9084	15	0	\N
307585	1874	8177000	18085	9084	16	0	\N
307586	1874	8178000	18085	9084	17	0	\N
307587	1483	10000000	18085	9084	18	0	\N
307588	1678	20160708522000	18086	9120	0	0	\N
307589	1678	20160708523000	18086	9120	1	0	\N
307590	1678	20160708524000	18086	9120	2	0	\N
307591	1874	8324000	18086	9120	3	0	\N
307592	1874	8327000	18086	9120	4	0	\N
307593	1874	8330000	18086	9120	5	0	\N
307594	1874	8333000	18086	9120	6	0	\N
307595	1678	20160708525000	18087	9121	0	0	\N
307596	1874	8336000	18087	9121	1	0	\N
307599	2181	200000000	18089	8996	0	0	\N
307600	2181	612200000000	18089	8996	1	0	\N
307601	1560	15714357277001	18089	8996	2	0	\N
307602	1483	10000000	18089	8996	3	0	\N
307603	2177	9556246850100	18089	8996	4	0	\N
307604	1678	20160708439000	18089	8996	5	0	\N
307605	1678	20160708440000	18089	8996	6	0	\N
307606	2178	200000000	18089	8996	7	0	\N
307607	2179	200000000	18089	8996	8	0	\N
307608	1678	20160708441000	18089	8996	9	0	\N
307609	1678	20160708442000	18089	8996	10	0	\N
307610	1678	20160708443000	18089	8996	11	0	\N
307611	1678	20160708444000	18089	8996	12	0	\N
307612	1678	20160708445000	18089	8996	13	0	\N
307613	1483	10000000	18089	8996	14	0	\N
307614	2177	36771686249641	18089	8996	15	0	\N
307615	2180	200000000	18089	8996	16	0	\N
307616	2177	45124009049641	18089	8996	17	0	\N
307617	2177	58444409049641	18089	8996	18	0	\N
307618	1678	20160708446000	18089	8996	19	0	\N
307619	1678	20160708447000	18089	8996	20	0	\N
307620	1678	20160708448000	18089	8996	21	0	\N
307621	1678	20160708449000	18089	8996	22	0	\N
307622	1678	20160708450000	18089	8996	23	0	\N
307623	1678	20160708451000	18089	8996	24	0	\N
307624	1678	20160708452000	18089	8996	25	0	\N
307625	2177	59992466249641	18089	8996	26	0	\N
307626	2177	63700566249641	18089	8996	27	0	\N
307627	1678	20160708453000	18089	8996	28	0	\N
307628	1678	20160708454000	18089	8996	29	0	\N
307629	1678	20160708455000	18089	8996	30	0	\N
307630	1678	20160708456000	18089	8996	31	0	\N
307631	1678	20160708457000	18089	8996	32	0	\N
307632	1678	20160708458000	18089	8996	33	0	\N
307504	1483	10000000	18062	9109	2	0	0
307505	1874	8276000	18062	9109	3	0	2
307506	1874	8279000	18062	9109	4	0	2
307507	1874	8280000	18062	9109	5	0	2
307510	1560	15714357277001	18065	9110	0	0	15
307512	1874	8283000	18065	9110	2	0	2
307513	1678	20160708509000	18066	9111	0	0	0
307514	1678	20160708510000	18067	9112	0	0	0
307515	1874	8286000	18067	9112	1	0	2
307516	1874	8287000	18067	9112	2	0	2
307522	1874	8290000	18070	9113	1	0	2
307531	1678	20160708512000	18074	9114	0	0	0
307532	1678	20160708513000	18074	9114	1	0	0
307533	1874	8293000	18074	9114	2	0	2
307535	1678	20160708514000	18075	9115	0	0	0
307536	1678	20160708515000	18075	9115	1	0	0
307537	1678	20160708516000	18075	9115	2	0	0
307538	1874	8299000	18075	9115	3	0	2
307539	1874	8302000	18075	9115	4	0	2
307541	1874	8306000	18075	9115	6	0	2
307542	1678	20160708517000	18076	9116	0	0	0
307543	1678	20160708518000	18076	9116	1	0	0
307544	1874	8307000	18076	9116	2	0	2
307545	1874	8310000	18076	9116	3	0	2
307547	1678	20160708519000	18077	9117	0	0	0
307548	1874	8316000	18077	9117	1	0	2
307554	1678	20160708520000	18080	9118	0	0	0
307555	1874	8319000	18080	9118	1	0	2
307560	1678	20160708521000	18082	9119	0	0	0
307561	1874	8323000	18082	9119	1	0	2
307562	1678	20160708522000	18084	9120	0	0	0
307563	1678	20160708523000	18084	9120	1	0	0
307564	1678	20160708524000	18084	9120	2	0	0
307566	1874	8327000	18084	9120	4	0	2
307567	1874	8330000	18084	9120	5	0	2
307568	1874	8333000	18084	9120	6	0	2
307597	1678	20160708525000	18088	9121	0	0	0
307598	1874	8336000	18088	9121	1	0	2
307633	1678	20160708459000	18089	8996	34	0	\N
307634	1678	20160708460000	18089	8996	35	0	\N
307635	1678	20160708461000	18089	8996	36	0	\N
307636	1678	20160708462000	18089	8996	37	0	\N
307637	1678	20160708463000	18089	8996	38	0	\N
307638	1678	20160708464000	18089	8996	39	0	\N
307639	1678	20160708465000	18089	8996	40	0	\N
307640	1678	20160708466000	18089	8996	41	0	\N
307641	1678	20160708467000	18089	8996	42	0	\N
307642	1678	20160708468000	18089	8996	43	0	\N
307643	1678	20160708469000	18089	8996	44	0	\N
307644	1678	20160708470000	18089	8996	45	0	\N
307645	1678	20160708471000	18089	8996	46	0	\N
307646	1678	20160708472000	18089	8996	47	0	\N
307647	1678	20160708473000	18089	8996	48	0	\N
307648	1678	20160708474000	18089	8996	49	0	\N
307649	1678	20160708475000	18089	8996	50	0	\N
307650	1678	20160708476000	18089	8996	51	0	\N
307651	1678	20160708477000	18089	8996	52	0	\N
307652	1678	20160708478000	18089	8996	53	0	\N
307653	1678	20160708479000	18089	8996	54	0	\N
307654	1678	20160708480000	18089	8996	55	0	\N
307655	1678	20160708481000	18089	8996	56	0	\N
307656	1678	20160708482000	18089	8996	57	0	\N
307657	1678	20160708483000	18089	8996	58	0	\N
307658	1678	20160708484000	18089	8996	59	0	\N
307659	1678	20160708485000	18089	8996	60	0	\N
307660	1678	20160708486000	18089	8996	61	0	\N
307661	1678	20160708487000	18089	8996	63	0	\N
307662	1678	20160708488000	18089	8996	64	0	\N
307663	1678	20160708489000	18089	8996	65	0	\N
307664	1678	20160708490000	18089	8996	66	0	\N
307665	1678	20160708491000	18089	8996	67	0	\N
307666	1678	20160708492000	18089	8996	68	0	\N
307667	1678	20160708493000	18089	8996	69	0	\N
307668	1678	20160708494000	18089	8996	70	0	\N
307669	1678	20160708495000	18089	8996	71	0	\N
307670	1678	20160708496000	18089	8996	72	0	\N
307671	1678	20160708497000	18089	8996	73	0	\N
307672	1678	20160708498000	18089	8996	74	0	\N
307673	1678	20160708499000	18089	8996	75	0	\N
307674	1678	20160708500000	18089	8996	76	0	\N
307675	1678	20160708501000	18089	8996	77	0	\N
307676	1678	20160708502000	18089	8996	78	0	\N
307677	1678	20160708503000	18089	8996	79	0	\N
307678	1678	20160708504000	18089	8996	80	0	\N
307679	1678	20160708505000	18089	8996	81	0	\N
307680	1678	20160708506000	18089	8996	82	0	\N
307681	1678	20160708507000	18089	8996	83	0	\N
307682	1678	20160708508000	18089	8996	84	0	\N
307683	1678	20160708509000	18089	8996	85	0	\N
307684	1678	20160708510000	18089	8996	86	0	\N
307685	1678	20160708511000	18089	8996	87	0	\N
307686	1678	20160708512000	18089	8996	88	0	\N
307687	1678	20160708513000	18089	8996	89	0	\N
307688	1678	20160708514000	18089	8996	90	0	\N
307689	1678	20160708515000	18089	8996	91	0	\N
307690	1678	20160708516000	18089	8996	92	0	\N
307691	1678	20160708517000	18089	8996	93	0	\N
307692	1678	20160708518000	18089	8996	94	0	\N
307693	1678	20160708519000	18089	8996	95	0	\N
307694	1678	20160708520000	18089	8996	96	0	\N
307695	1678	20160708521000	18089	8996	97	0	\N
307696	1678	20160708522000	18089	8996	98	0	\N
307697	1678	20160708523000	18089	8996	99	0	\N
307698	1678	20160708524000	18089	8996	100	0	\N
307699	1678	20160708525000	18089	8996	101	0	\N
307700	1874	7603000	18089	8996	102	0	\N
307701	1874	7604000	18089	8996	103	0	\N
307702	2164	612599000000	18089	8996	105	0	\N
307703	1483	10000000	18089	8996	106	0	\N
307704	1874	7605000	18089	8996	107	0	\N
307705	1874	7606000	18089	8996	108	0	\N
307706	1874	7607000	18089	8996	109	0	\N
307707	1874	7608000	18089	8996	110	0	\N
307708	1874	7609000	18089	8996	111	0	\N
307709	1874	7610000	18089	8996	112	0	\N
307710	1874	7611000	18089	8996	113	0	\N
307711	1874	7612000	18089	8996	114	0	\N
307712	1874	7613000	18089	8996	115	0	\N
307713	1874	7614000	18089	8996	116	0	\N
307714	1874	7615000	18089	8996	117	0	\N
307715	1874	7616000	18089	8996	118	0	\N
307716	1874	7617000	18089	8996	119	0	\N
307717	1874	7618000	18089	8996	120	0	\N
307718	1874	7619000	18089	8996	121	0	\N
307719	1874	7620000	18089	8996	122	0	\N
307720	1874	7621000	18089	8996	123	0	\N
307721	1874	7622000	18089	8996	124	0	\N
307722	1874	7623000	18089	8996	125	0	\N
307724	1678	20160708527000	18091	9123	0	0	\N
307725	1874	8339000	18091	9123	1	0	\N
307726	1874	8340000	18091	9123	2	0	\N
307727	1678	20160708527000	18092	9123	0	0	\N
307728	1874	8339000	18092	9123	1	0	\N
307729	1874	8340000	18092	9123	2	0	\N
307737	1678	20160708529000	18096	9125	0	0	\N
307738	1874	8346000	18096	9125	1	0	\N
307758	1678	20160708537000	18104	9132	0	0	\N
307759	1874	8367000	18104	9132	1	0	\N
307760	1874	8370000	18104	9132	2	0	\N
307761	1874	8373000	18104	9132	3	0	\N
307762	1678	20160708537000	18105	9132	0	0	\N
307763	1874	8367000	18105	9132	1	0	\N
307764	1874	8370000	18105	9132	2	0	\N
307765	1874	8373000	18105	9132	3	0	\N
307766	1678	20160708538000	18106	9133	0	0	\N
307767	1874	8376000	18106	9133	1	0	\N
307731	1874	8339000	18093	9123	1	0	2
307732	1874	8340000	18093	9123	2	0	2
307733	1678	20160708528000	18094	9124	0	0	0
307734	1874	8343000	18094	9124	1	0	2
307735	1678	20160708529000	18095	9125	0	0	0
307739	1678	20160708530000	18097	9126	0	0	0
307740	1874	8349000	18097	9126	1	0	2
307741	1874	8350000	18097	9126	2	0	2
307742	1678	20160708531000	18098	9127	0	0	0
307743	1874	8353000	18098	9127	1	0	2
307745	1874	8356000	18099	9128	1	0	2
307746	1678	20160708533000	18100	9129	0	0	0
307747	1874	8359000	18100	9129	1	0	2
307748	1678	20160708534000	18101	9130	0	0	0
307750	1874	8362000	18101	9130	2	0	2
307751	1874	8365000	18101	9130	3	0	2
307752	1678	20160708536000	18102	9131	0	0	0
307753	1874	8366000	18102	9131	1	0	2
307754	1678	20160708537000	18103	9132	0	0	0
307756	1874	8370000	18103	9132	2	0	2
307757	1874	8373000	18103	9132	3	0	2
307768	1678	20160708538000	18108	9134	0	0	0
307771	1678	20160708532000	18109	9128	0	0	\N
307772	1678	20160708533000	18109	9128	1	0	\N
307773	1678	20160708534000	18109	9128	2	0	\N
307774	1678	20160708535000	18109	9128	3	0	\N
307775	1678	20160708536000	18109	9128	4	0	\N
307776	1678	20160708537000	18109	9128	5	0	\N
307777	1678	20160708538000	18109	9128	6	0	\N
307778	1874	8356000	18109	9128	7	0	\N
307779	1874	8359000	18109	9128	8	0	\N
307780	1874	8360000	18109	9128	9	0	\N
307781	1874	8361000	18109	9128	10	0	\N
307782	1874	8364000	18109	9128	11	0	\N
307783	1874	8367000	18109	9128	12	0	\N
307784	1874	8370000	18109	9128	13	0	\N
307785	1874	8373000	18109	9128	14	0	\N
307786	1874	8376000	18109	9128	15	0	\N
307792	1678	20160708541000	18112	9136	0	0	\N
307793	1874	8383000	18112	9136	1	0	\N
307794	1678	20160708541000	18113	9136	0	0	\N
307795	1874	8383000	18113	9136	1	0	\N
307796	1678	20160708541000	18114	9136	0	0	\N
307797	1874	8383000	18114	9136	1	0	\N
307798	1678	20160708526000	18115	9122	0	0	\N
307799	1678	20160708527000	18115	9122	1	0	\N
307800	1678	20160708528000	18115	9122	2	0	\N
307801	1678	20160708529000	18115	9122	3	0	\N
307802	1678	20160708530000	18115	9122	4	0	\N
307803	1678	20160708531000	18115	9122	5	0	\N
307804	1678	20160708532000	18115	9122	6	0	\N
307805	1678	20160708533000	18115	9122	7	0	\N
307806	1678	20160708534000	18115	9122	8	0	\N
307807	1678	20160708535000	18115	9122	9	0	\N
307808	1678	20160708536000	18115	9122	10	0	\N
307809	1678	20160708537000	18115	9122	11	0	\N
307810	1678	20160708538000	18115	9122	12	0	\N
307811	1678	20160708539000	18115	9122	13	0	\N
307812	1678	20160708540000	18115	9122	14	0	\N
307813	1678	20160708541000	18115	9122	15	0	\N
307814	1874	8339000	18115	9122	16	0	\N
307815	1874	8342000	18115	9122	17	0	\N
307816	1874	8345000	18115	9122	18	0	\N
307817	1874	8346000	18115	9122	19	0	\N
307818	1874	8349000	18115	9122	20	0	\N
307819	1874	8352000	18115	9122	21	0	\N
307820	1874	8355000	18115	9122	22	0	\N
307821	1874	8358000	18115	9122	23	0	\N
307822	1874	8361000	18115	9122	24	0	\N
307823	1874	8362000	18115	9122	25	0	\N
307824	1874	8363000	18115	9122	26	0	\N
307825	1874	8364000	18115	9122	27	0	\N
307826	1874	8365000	18115	9122	28	0	\N
307827	1874	8368000	18115	9122	29	0	\N
307828	1874	8371000	18115	9122	30	0	\N
307829	1874	8374000	18115	9122	31	0	\N
307830	1874	8377000	18115	9122	32	0	\N
307831	1874	8380000	18115	9122	33	0	\N
307832	1874	8383000	18115	9122	34	0	\N
307844	1678	20160708542000	18118	9137	0	0	\N
307845	1678	20160708543000	18118	9137	1	0	\N
307846	1678	20160708544000	18118	9137	2	0	\N
307847	1678	20160708545000	18118	9137	3	0	\N
307848	1678	20160708546000	18118	9137	4	0	\N
307849	1874	8386000	18118	9137	5	0	\N
307850	1874	8389000	18118	9137	6	0	\N
307851	1874	8390000	18118	9137	7	0	\N
307852	1874	8393000	18118	9137	8	0	\N
307853	1874	8396000	18118	9137	9	0	\N
307854	1874	8399000	18118	9137	10	0	\N
307855	1678	20160708547000	18119	9138	0	0	\N
307856	1874	8400000	18119	9138	1	0	\N
307857	1874	8403000	18119	9138	2	0	\N
307858	1678	20160708547000	18120	9138	0	0	\N
307859	1874	8400000	18120	9138	1	0	\N
307860	1874	8403000	18120	9138	2	0	\N
307868	1678	20160708550000	18124	9140	0	0	\N
307869	1678	20160708551000	18124	9140	1	0	\N
307870	1874	8410000	18124	9140	2	0	\N
307871	1874	8413000	18124	9140	3	0	\N
307872	1874	8416000	18124	9140	4	0	\N
307878	1560	15714357277001	18126	9111	0	0	\N
307879	1678	20160708509000	18126	9111	1	0	\N
307880	1678	20160708510000	18126	9111	2	0	\N
307881	1678	20160708511000	18126	9111	3	0	\N
307882	1678	20160708512000	18126	9111	4	0	\N
307883	1678	20160708513000	18126	9111	5	0	\N
307884	1678	20160708514000	18126	9111	6	0	\N
307885	1678	20160708515000	18126	9111	7	0	\N
307886	1678	20160708516000	18126	9111	8	0	\N
307887	1678	20160708517000	18126	9111	9	0	\N
307888	1678	20160708518000	18126	9111	10	0	\N
307889	1678	20160708519000	18126	9111	11	0	\N
307890	1678	20160708520000	18126	9111	12	0	\N
307891	1678	20160708521000	18126	9111	13	0	\N
307892	1678	20160708522000	18126	9111	14	0	\N
307893	1678	20160708523000	18126	9111	15	0	\N
307894	1678	20160708524000	18126	9111	16	0	\N
307895	1678	20160708525000	18126	9111	17	0	\N
307896	1678	20160708526000	18126	9111	18	0	\N
307897	1678	20160708527000	18126	9111	19	0	\N
307898	1678	20160708528000	18126	9111	20	0	\N
307899	1678	20160708529000	18126	9111	21	0	\N
307900	1678	20160708530000	18126	9111	22	0	\N
307901	1678	20160708531000	18126	9111	23	0	\N
307902	1678	20160708532000	18126	9111	24	0	\N
307903	1678	20160708533000	18126	9111	25	0	\N
307904	1678	20160708534000	18126	9111	26	0	\N
307787	1678	20160708540000	18110	9135	0	0	0
307788	1874	8377000	18110	9135	1	0	2
307789	1874	8380000	18110	9135	2	0	2
307790	1678	20160708541000	18111	9136	0	0	0
307791	1874	8383000	18111	9136	1	0	2
307834	1678	20160708543000	18117	9137	1	0	0
307835	1678	20160708544000	18117	9137	2	0	0
307836	1678	20160708545000	18117	9137	3	0	0
307837	1678	20160708546000	18117	9137	4	0	0
307838	1874	8386000	18117	9137	5	0	2
307840	1874	8390000	18117	9137	7	0	2
307841	1874	8393000	18117	9137	8	0	2
307842	1874	8396000	18117	9137	9	0	2
307843	1874	8399000	18117	9137	10	0	2
307862	1874	8400000	18121	9138	1	0	2
307863	1874	8403000	18121	9138	2	0	2
307864	1678	20160708548000	18122	9139	0	0	0
307865	1678	20160708549000	18122	9139	1	0	0
307866	1874	8406000	18122	9139	2	0	2
307873	1678	20160708550000	18125	9140	0	0	0
307874	1678	20160708551000	18125	9140	1	0	0
307875	1874	8410000	18125	9140	2	0	2
307876	1874	8413000	18125	9140	3	0	2
307877	1874	8416000	18125	9140	4	0	2
307905	1678	20160708535000	18126	9111	27	0	\N
307906	1678	20160708536000	18126	9111	28	0	\N
307907	1678	20160708537000	18126	9111	29	0	\N
307908	1678	20160708538000	18126	9111	30	0	\N
307909	1678	20160708539000	18126	9111	31	0	\N
307910	1678	20160708540000	18126	9111	32	0	\N
307911	1678	20160708541000	18126	9111	33	0	\N
307912	1678	20160708542000	18126	9111	34	0	\N
307913	1678	20160708543000	18126	9111	35	0	\N
307914	1678	20160708544000	18126	9111	36	0	\N
307915	1678	20160708545000	18126	9111	37	0	\N
307916	1678	20160708546000	18126	9111	38	0	\N
307917	1678	20160708547000	18126	9111	39	0	\N
307918	1678	20160708548000	18126	9111	40	0	\N
307919	1678	20160708549000	18126	9111	41	0	\N
307920	1678	20160708550000	18126	9111	42	0	\N
307921	1678	20160708551000	18126	9111	43	0	\N
307922	1874	8283000	18126	9111	44	0	\N
307923	1874	8284000	18126	9111	45	0	\N
307924	1874	8285000	18126	9111	46	0	\N
307925	1874	8286000	18126	9111	47	0	\N
307926	1874	8287000	18126	9111	48	0	\N
307927	1874	8288000	18126	9111	49	0	\N
307928	1874	8289000	18126	9111	50	0	\N
307929	1874	8290000	18126	9111	51	0	\N
307930	1874	8291000	18126	9111	52	0	\N
307931	1874	8292000	18126	9111	53	0	\N
307932	1874	8293000	18126	9111	54	0	\N
307933	1874	8294000	18126	9111	55	0	\N
307934	1874	8295000	18126	9111	56	0	\N
307935	1874	8296000	18126	9111	57	0	\N
307943	1678	20160708552000	18128	9141	0	0	\N
307944	1678	20160708553000	18128	9141	1	0	\N
307945	1678	20160708554000	18128	9141	2	0	\N
307946	1874	8417000	18128	9141	3	0	\N
307947	1874	8420000	18128	9141	4	0	\N
307948	1874	8423000	18128	9141	5	0	\N
307949	1874	8426000	18128	9141	6	0	\N
307954	1678	20160708557000	18130	9143	0	0	\N
307955	1874	8435000	18130	9143	1	0	\N
307956	1874	8436000	18130	9143	2	0	\N
307960	1678	20160708557000	18132	9143	0	0	\N
307961	1874	8435000	18132	9143	1	0	\N
307962	1874	8436000	18132	9143	2	0	\N
307963	1678	20160708558000	18133	9144	0	0	\N
307964	1874	8439000	18133	9144	1	0	\N
307967	2181	200000000	18135	8917	0	0	\N
307968	329	67444622000000	18135	8917	1	0	\N
307969	2181	612200000000	18135	8917	2	0	\N
307970	1560	15714357277001	18135	8917	3	0	\N
307971	1483	10000000	18135	8917	5	0	\N
307972	2177	9556246850100	18135	8917	7	0	\N
307973	1483	10000000	18135	8917	8	0	\N
307974	2171	200000000	18135	8917	9	0	\N
307975	2174	200000000	18135	8917	10	0	\N
307976	2175	200000000	18135	8917	11	0	\N
307977	2178	200000000	18135	8917	12	0	\N
307978	2179	200000000	18135	8917	13	0	\N
307979	2177	36771686249641	18135	8917	14	0	\N
307980	2180	200000000	18135	8917	15	0	\N
307981	2177	45124009049641	18135	8917	16	0	\N
307982	2177	58444409049641	18135	8917	17	0	\N
307983	2177	59992466249641	18135	8917	18	0	\N
307984	2177	63700566249641	18135	8917	19	0	\N
307985	1726	107165110000	18135	8917	26	0	\N
307986	1874	7020000	18135	8917	27	0	\N
307987	1567	101	18135	8917	30	0	\N
307988	2164	612599000000	18135	8917	31	0	\N
307989	1483	10000000	18135	8917	32	0	\N
307990	1874	7021000	18135	8917	33	0	\N
307991	1874	7022000	18135	8917	34	0	\N
307992	1874	7023000	18135	8917	35	0	\N
307993	1874	7024000	18135	8917	36	0	\N
307994	1874	7025000	18135	8917	37	0	\N
307995	1874	7026000	18135	8917	38	0	\N
307996	1874	7027000	18135	8917	39	0	\N
307997	1874	7028000	18135	8917	41	0	\N
307998	1874	7029000	18135	8917	42	0	\N
307999	1874	7030000	18135	8917	43	0	\N
308000	1874	7031000	18135	8917	44	0	\N
308001	1874	7032000	18135	8917	45	0	\N
308002	1874	7033000	18135	8917	46	0	\N
308003	1874	7034000	18135	8917	47	0	\N
308004	1874	7035000	18135	8917	48	0	\N
308005	1874	7036000	18135	8917	49	0	\N
308006	1874	7037000	18135	8917	50	0	\N
308007	1874	7038000	18135	8917	51	0	\N
308008	1874	7039000	18135	8917	52	0	\N
308009	1874	7040000	18135	8917	53	0	\N
308010	1874	7041000	18135	8917	54	0	\N
308011	1874	7042000	18135	8917	55	0	\N
308012	1874	7043000	18135	8917	56	0	\N
308013	1874	7044000	18135	8917	57	0	\N
308014	1874	7045000	18135	8917	58	0	\N
308015	1874	7046000	18135	8917	59	0	\N
308016	1874	7047000	18135	8917	60	0	\N
308017	1874	7048000	18135	8917	61	0	\N
308018	1874	7049000	18135	8917	62	0	\N
308019	1874	7050000	18135	8917	63	0	\N
308020	1874	7051000	18135	8917	64	0	\N
308021	1874	7052000	18135	8917	65	0	\N
308022	1874	7053000	18135	8917	66	0	\N
308023	1874	7054000	18135	8917	67	0	\N
308024	1874	7055000	18135	8917	68	0	\N
308025	1874	7056000	18135	8917	69	0	\N
308026	1874	7057000	18135	8917	70	0	\N
308027	1874	7058000	18135	8917	71	0	\N
308028	1874	7059000	18135	8917	72	0	\N
308029	1874	7060000	18135	8917	73	0	\N
308030	1874	7061000	18135	8917	74	0	\N
308031	1874	7062000	18135	8917	75	0	\N
308032	1874	7063000	18135	8917	76	0	\N
308033	1874	7064000	18135	8917	77	0	\N
308034	1874	7065000	18135	8917	78	0	\N
308035	1874	7066000	18135	8917	79	0	\N
308036	1874	7067000	18135	8917	80	0	\N
308037	1874	7068000	18135	8917	81	0	\N
308038	1874	7069000	18135	8917	82	0	\N
308039	1874	7070000	18135	8917	83	0	\N
308040	1874	7071000	18135	8917	84	0	\N
307938	1678	20160708554000	18127	9141	2	0	0
307939	1874	8417000	18127	9141	3	0	2
307940	1874	8420000	18127	9141	4	0	2
307941	1874	8423000	18127	9141	5	0	2
307942	1874	8426000	18127	9141	6	0	2
307951	1678	20160708556000	18129	9142	1	0	0
307952	1874	8429000	18129	9142	2	0	2
307953	1874	8432000	18129	9142	3	0	2
307957	1678	20160708557000	18131	9143	0	0	0
307958	1874	8435000	18131	9143	1	0	2
307965	1678	20160708558000	18134	9144	0	0	0
307966	1874	8439000	18134	9144	1	0	2
308041	1874	7072000	18135	8917	85	0	\N
308042	1874	7073000	18135	8917	86	0	\N
308043	1874	7074000	18135	8917	87	0	\N
308044	1874	7075000	18135	8917	88	0	\N
308045	1874	7076000	18135	8917	89	0	\N
308046	1874	7077000	18135	8917	90	0	\N
308047	1874	7078000	18135	8917	91	0	\N
308048	1874	7079000	18135	8917	92	0	\N
308049	1874	7080000	18135	8917	93	0	\N
308050	1874	7081000	18135	8917	94	0	\N
308051	1874	7082000	18135	8917	95	0	\N
308052	1874	7083000	18135	8917	96	0	\N
308053	1874	7084000	18135	8917	97	0	\N
308054	1874	7085000	18135	8917	98	0	\N
308055	1874	7086000	18135	8917	99	0	\N
308056	1874	7087000	18135	8917	100	0	\N
308057	1874	7088000	18135	8917	101	0	\N
308058	1874	7089000	18135	8917	102	0	\N
308059	1874	7090000	18135	8917	103	0	\N
308060	1874	7091000	18135	8917	104	0	\N
308061	1874	7092000	18135	8917	105	0	\N
308062	1874	7093000	18135	8917	106	0	\N
308063	1874	7094000	18135	8917	107	0	\N
308064	1874	7095000	18135	8917	108	0	\N
308065	1874	7096000	18135	8917	109	0	\N
308066	1874	7097000	18135	8917	110	0	\N
308067	1874	7098000	18135	8917	111	0	\N
308068	1678	20160708559000	18136	9145	0	0	\N
308069	1678	20160708560000	18136	9145	1	0	\N
308070	1678	20160708561000	18136	9145	2	0	\N
308071	1874	8442000	18136	9145	3	0	\N
308072	1874	8443000	18136	9145	4	0	\N
308073	1874	8446000	18136	9145	5	0	\N
308074	1874	8449000	18136	9145	6	0	\N
308082	1678	20160708559000	18138	9145	0	0	\N
308083	1678	20160708560000	18138	9145	1	0	\N
308084	1678	20160708561000	18138	9145	2	0	\N
308085	1874	8442000	18138	9145	3	0	\N
308086	1874	8443000	18138	9145	4	0	\N
308087	1874	8446000	18138	9145	5	0	\N
308088	1874	8449000	18138	9145	6	0	\N
308091	1678	20160708562000	18140	9146	0	0	\N
308092	1874	8452000	18140	9146	1	0	\N
308095	1678	20160708564000	18142	9148	0	0	\N
308096	1678	20160708565000	18142	9148	1	0	\N
308097	1874	8458000	18142	9148	2	0	\N
308098	1874	8461000	18142	9148	3	0	\N
308099	1874	8462000	18142	9148	4	0	\N
308107	1678	20160708567000	18145	9150	0	0	\N
308108	1874	8466000	18145	9150	1	0	\N
308109	1678	20160708567000	18146	9150	0	0	\N
308110	1874	8466000	18146	9150	1	0	\N
308116	1678	20160708569000	18150	9152	1	0	\N
308117	1678	20160708570000	18150	9152	2	0	\N
308118	1678	20160708571000	18150	9152	3	0	\N
308119	1678	20160708572000	18150	9152	4	0	\N
308120	2182	200000000	18150	9152	5	0	\N
308121	1874	8474000	18150	9152	6	0	\N
308122	1874	8476000	18150	9152	7	0	\N
308123	1874	8478000	18150	9152	8	0	\N
308124	1874	8479000	18150	9152	9	0	\N
308125	1874	8482000	18150	9152	10	0	\N
308126	1874	8484000	18150	9152	11	0	\N
308127	1874	8486000	18150	9152	12	0	\N
308128	1874	8489000	18150	9152	14	0	\N
308129	1874	8492000	18150	9152	15	0	\N
308130	1678	20160708569000	18151	9152	1	0	\N
308131	1678	20160708570000	18151	9152	2	0	\N
308132	1678	20160708571000	18151	9152	3	0	\N
308133	1678	20160708572000	18151	9152	4	0	\N
308134	2182	200000000	18151	9152	5	0	\N
308135	1874	8474000	18151	9152	6	0	\N
308136	1874	8476000	18151	9152	7	0	\N
308137	1874	8478000	18151	9152	8	0	\N
308138	1874	8479000	18151	9152	9	0	\N
308139	1874	8482000	18151	9152	10	0	\N
308140	1874	8484000	18151	9152	11	0	\N
308141	1874	8486000	18151	9152	12	0	\N
308142	1874	8489000	18151	9152	14	0	\N
308143	1874	8492000	18151	9152	15	0	\N
308144	1678	20160708569000	18152	9152	1	0	\N
308145	1678	20160708570000	18152	9152	2	0	\N
308146	1678	20160708571000	18152	9152	3	0	\N
308147	1678	20160708572000	18152	9152	4	0	\N
308148	2182	200000000	18152	9152	5	0	\N
308149	1874	8474000	18152	9152	6	0	\N
308150	1874	8476000	18152	9152	7	0	\N
308151	1874	8478000	18152	9152	8	0	\N
308152	1874	8479000	18152	9152	9	0	\N
308153	1874	8482000	18152	9152	10	0	\N
308154	1874	8484000	18152	9152	11	0	\N
308155	1874	8486000	18152	9152	12	0	\N
308156	1874	8489000	18152	9152	14	0	\N
308157	1874	8492000	18152	9152	15	0	\N
308158	1678	20160708520000	18153	9118	0	0	\N
308159	2182	200000000	18153	9118	2	0	\N
308160	1678	20160708521000	18153	9118	3	0	\N
308161	1678	20160708522000	18153	9118	4	0	\N
308162	1678	20160708523000	18153	9118	5	0	\N
308163	1678	20160708524000	18153	9118	6	0	\N
308164	1678	20160708525000	18153	9118	7	0	\N
308165	1678	20160708526000	18153	9118	8	0	\N
308166	1678	20160708527000	18153	9118	9	0	\N
308167	1678	20160708528000	18153	9118	10	0	\N
308168	1678	20160708529000	18153	9118	11	0	\N
308169	1678	20160708530000	18153	9118	12	0	\N
308170	1678	20160708531000	18153	9118	13	0	\N
308171	1678	20160708532000	18153	9118	14	0	\N
308172	1678	20160708533000	18153	9118	15	0	\N
308173	1678	20160708534000	18153	9118	16	0	\N
308174	1678	20160708535000	18153	9118	17	0	\N
308175	1678	20160708536000	18153	9118	18	0	\N
308176	1678	20160708537000	18153	9118	19	0	\N
308077	1678	20160708561000	18137	9145	2	0	0
308078	1874	8442000	18137	9145	3	0	2
308079	1874	8443000	18137	9145	4	0	2
308080	1874	8446000	18137	9145	5	0	2
308081	1874	8449000	18137	9145	6	0	2
308090	1874	8452000	18139	9146	1	0	2
308093	1678	20160708563000	18141	9147	0	0	0
308094	1874	8455000	18141	9147	1	0	2
308100	1678	20160708564000	18143	9148	0	0	0
308101	1678	20160708565000	18143	9148	1	0	0
308103	1874	8461000	18143	9148	3	0	2
308104	1874	8462000	18143	9148	4	0	2
308105	1678	20160708566000	18144	9149	0	0	0
308106	1874	8465000	18144	9149	1	0	2
308112	1874	8466000	18147	9150	1	0	2
308113	1678	20160708568000	18148	9151	0	0	0
308114	1874	8469000	18148	9151	1	0	2
308115	1874	8471000	18148	9151	2	0	2
308177	1678	20160708538000	18153	9118	20	0	\N
308178	1678	20160708539000	18153	9118	21	0	\N
308179	1678	20160708540000	18153	9118	22	0	\N
308180	1678	20160708541000	18153	9118	23	0	\N
308181	1678	20160708542000	18153	9118	24	0	\N
308182	1678	20160708543000	18153	9118	25	0	\N
308183	1678	20160708544000	18153	9118	26	0	\N
308184	1678	20160708545000	18153	9118	27	0	\N
308185	1678	20160708546000	18153	9118	28	0	\N
308186	1678	20160708547000	18153	9118	29	0	\N
308187	1678	20160708548000	18153	9118	30	0	\N
308188	1678	20160708549000	18153	9118	31	0	\N
308189	1678	20160708550000	18153	9118	32	0	\N
308190	1678	20160708551000	18153	9118	33	0	\N
308191	1678	20160708552000	18153	9118	34	0	\N
308192	1678	20160708553000	18153	9118	35	0	\N
308193	1678	20160708554000	18153	9118	36	0	\N
308194	1678	20160708555000	18153	9118	37	0	\N
308195	1678	20160708556000	18153	9118	38	0	\N
308196	1678	20160708557000	18153	9118	39	0	\N
308197	1678	20160708558000	18153	9118	40	0	\N
308198	1678	20160708559000	18153	9118	41	0	\N
308199	1678	20160708560000	18153	9118	42	0	\N
308200	1678	20160708561000	18153	9118	43	0	\N
308201	1678	20160708562000	18153	9118	44	0	\N
308202	1678	20160708563000	18153	9118	45	0	\N
308203	1678	20160708564000	18153	9118	46	0	\N
308204	1678	20160708565000	18153	9118	47	0	\N
308205	1678	20160708566000	18153	9118	48	0	\N
308206	1678	20160708567000	18153	9118	49	0	\N
308207	1678	20160708568000	18153	9118	50	0	\N
308208	1678	20160708569000	18153	9118	51	0	\N
308209	1678	20160708570000	18153	9118	52	0	\N
308210	1678	20160708571000	18153	9118	53	0	\N
308211	1678	20160708572000	18153	9118	54	0	\N
308212	1874	8319000	18153	9118	55	0	\N
308213	1874	8321000	18153	9118	56	0	\N
308214	1874	8323000	18153	9118	57	0	\N
308215	1874	8325000	18153	9118	58	0	\N
308216	1874	8327000	18153	9118	59	0	\N
308217	1874	8329000	18153	9118	60	0	\N
308218	1874	8330000	18153	9118	61	0	\N
308219	1874	8331000	18153	9118	62	0	\N
308220	1874	8332000	18153	9118	64	0	\N
308221	1874	8335000	18153	9118	65	0	\N
308222	1874	8338000	18153	9118	66	0	\N
308223	1874	8341000	18153	9118	67	0	\N
308224	1874	8344000	18153	9118	68	0	\N
308225	1874	8347000	18153	9118	69	0	\N
308226	1874	8350000	18153	9118	70	0	\N
308227	1874	8353000	18153	9118	71	0	\N
308228	1874	8356000	18153	9118	72	0	\N
308229	1874	8359000	18153	9118	73	0	\N
308230	1874	8362000	18153	9118	74	0	\N
308231	1874	8365000	18153	9118	75	0	\N
308232	1874	8368000	18153	9118	76	0	\N
308233	1874	8371000	18153	9118	77	0	\N
308234	1874	8372000	18153	9118	78	0	\N
308235	1874	8373000	18153	9118	79	0	\N
308236	1874	8374000	18153	9118	80	0	\N
308237	1874	8375000	18153	9118	81	0	\N
308238	1874	8376000	18153	9118	82	0	\N
308239	1874	8377000	18153	9118	83	0	\N
308240	1874	8378000	18153	9118	84	0	\N
308241	1874	8379000	18153	9118	85	0	\N
308242	1874	8380000	18153	9118	86	0	\N
308243	1874	8381000	18153	9118	87	0	\N
308244	1874	8382000	18153	9118	88	0	\N
308245	1874	8383000	18153	9118	89	0	\N
308246	1874	8384000	18153	9118	90	0	\N
308247	1874	8387000	18153	9118	91	0	\N
308248	1874	8390000	18153	9118	92	0	\N
308249	1874	8393000	18153	9118	93	0	\N
308250	1874	8396000	18153	9118	94	0	\N
308251	1874	8399000	18153	9118	95	0	\N
308252	1874	8402000	18153	9118	96	0	\N
308253	1874	8405000	18153	9118	97	0	\N
308254	1874	8408000	18153	9118	98	0	\N
308255	1874	8411000	18153	9118	99	0	\N
308256	1874	8414000	18153	9118	100	0	\N
308257	1874	8417000	18153	9118	101	0	\N
308258	1874	8420000	18153	9118	102	0	\N
308259	1874	8423000	18153	9118	103	0	\N
308260	1874	8426000	18153	9118	104	0	\N
308261	1874	8429000	18153	9118	105	0	\N
308262	1874	8432000	18153	9118	106	0	\N
308263	1874	8435000	18153	9118	107	0	\N
308264	1874	8438000	18153	9118	108	0	\N
308265	1874	8441000	18153	9118	109	0	\N
308266	1874	8444000	18153	9118	110	0	\N
308267	1874	8447000	18153	9118	111	0	\N
308268	1874	8450000	18153	9118	112	0	\N
308269	1874	8453000	18153	9118	113	0	\N
308270	1874	8456000	18153	9118	114	0	\N
308271	1874	8459000	18153	9118	115	0	\N
308272	1874	8462000	18153	9118	116	0	\N
308273	1874	8465000	18153	9118	117	0	\N
308274	1874	8468000	18153	9118	118	0	\N
308275	1874	8471000	18153	9118	119	0	\N
308276	1874	8474000	18153	9118	120	0	\N
308277	1874	8477000	18153	9118	121	0	\N
308278	1874	8480000	18153	9118	122	0	\N
308279	1874	8483000	18153	9118	123	0	\N
308280	1874	8486000	18153	9118	124	0	\N
308281	1874	8489000	18153	9118	125	0	\N
308296	1678	20160708573000	18155	9153	1	0	\N
308297	1678	20160708574000	18155	9153	2	0	\N
308298	1678	20160708575000	18155	9153	3	0	\N
308299	1678	20160708576000	18155	9153	4	0	\N
308300	1874	8493000	18155	9153	5	0	\N
308301	1874	8496000	18155	9153	6	0	\N
308302	1874	8499000	18155	9153	7	0	\N
308303	1874	8502000	18155	9153	8	0	\N
308304	1874	8505000	18155	9153	9	0	\N
308305	1874	8507000	18155	9153	10	0	\N
308306	1874	8509000	18155	9153	11	0	\N
308307	1874	8511000	18155	9153	12	0	\N
308308	1874	8513000	18155	9153	13	0	\N
308284	1678	20160708571000	18154	9152	3	0	0
308285	1678	20160708572000	18154	9152	4	0	0
308286	2182	200000000	18154	9152	5	0	0
308287	1874	8474000	18154	9152	6	0	2
308288	1874	8476000	18154	9152	7	0	2
308290	1874	8479000	18154	9152	9	0	2
308291	1874	8482000	18154	9152	10	0	2
308292	1874	8484000	18154	9152	11	0	2
308293	1874	8486000	18154	9152	12	0	2
308294	1874	8489000	18154	9152	14	0	2
308309	1678	20160708573000	18156	9153	1	0	0
308310	1678	20160708574000	18156	9153	2	0	0
308311	1678	20160708575000	18156	9153	3	0	0
308312	1678	20160708576000	18156	9153	4	0	0
308322	1678	20160708577000	18157	9154	0	0	\N
308323	1678	20160708578000	18157	9154	1	0	\N
308324	1874	8516000	18157	9154	2	0	\N
308325	1874	8519000	18157	9154	3	0	\N
308326	1874	8521000	18157	9154	4	0	\N
308327	1874	8523000	18157	9154	5	0	\N
308328	1874	8524000	18157	9154	6	0	\N
308336	1678	20160708577000	18159	9154	0	0	\N
308337	1678	20160708578000	18159	9154	1	0	\N
308338	1874	8516000	18159	9154	2	0	\N
308339	1874	8519000	18159	9154	3	0	\N
308340	1874	8521000	18159	9154	4	0	\N
308341	1874	8523000	18159	9154	5	0	\N
308342	1874	8524000	18159	9154	6	0	\N
308349	1678	20160708581000	18161	9156	0	0	\N
308350	1874	8536000	18161	9156	1	0	\N
308351	1874	8539000	18161	9156	2	0	\N
308352	1874	8540000	18161	9156	3	0	\N
308357	1678	20160708581000	18163	9156	0	0	\N
308358	1874	8536000	18163	9156	1	0	\N
308359	1874	8539000	18163	9156	2	0	\N
308360	1874	8540000	18163	9156	3	0	\N
308383	1678	20160708589000	18169	9162	0	0	\N
308384	1874	8577000	18169	9162	1	0	\N
308385	1874	8579000	18169	9162	2	0	\N
308395	1678	20160708590000	18172	9163	0	0	\N
308396	1678	20160708591000	18172	9163	1	0	\N
308397	1874	8581000	18172	9163	2	0	\N
308398	1874	8582000	18172	9163	3	0	\N
308399	1874	8585000	18172	9163	4	0	\N
308400	1874	8588000	18172	9163	5	0	\N
308405	1678	20160708594000	18174	9165	0	0	\N
308406	1678	20160708595000	18174	9165	1	0	\N
308407	1874	8595000	18174	9165	2	0	\N
308408	1874	8598000	18174	9165	3	0	\N
308409	1874	8601000	18174	9165	4	0	\N
308424	1678	20160708600000	18178	9167	0	0	\N
308425	1874	8617000	18178	9167	1	0	\N
308431	1678	20160708601000	18181	9168	0	0	\N
308432	1874	8618000	18181	9168	1	0	\N
308433	1874	8621000	18181	9168	2	0	\N
308434	1678	20160708601000	18182	9168	0	0	\N
308435	1874	8618000	18182	9168	1	0	\N
308436	1874	8621000	18182	9168	2	0	\N
308437	1678	20160708602000	18185	9170	0	0	\N
308438	1678	20160708603000	18185	9170	1	0	\N
308439	1874	8624000	18185	9170	2	0	\N
308440	1874	8625000	18185	9170	3	0	\N
308441	1874	8628000	18185	9170	4	0	\N
308442	1678	20160708602000	18186	9170	0	0	\N
308443	1678	20160708603000	18186	9170	1	0	\N
308444	1874	8624000	18186	9170	2	0	\N
308445	1874	8625000	18186	9170	3	0	\N
308446	1874	8628000	18186	9170	4	0	\N
308447	1678	20160708602000	18187	9170	0	0	\N
308448	1678	20160708603000	18187	9170	1	0	\N
308315	1874	8499000	18156	9153	7	0	2
308316	1874	8502000	18156	9153	8	0	2
308317	1874	8505000	18156	9153	9	0	2
308318	1874	8507000	18156	9153	10	0	2
308319	1874	8509000	18156	9153	11	0	2
308321	1874	8513000	18156	9153	13	0	2
308329	1678	20160708577000	18158	9154	0	0	0
308330	1678	20160708578000	18158	9154	1	0	0
308331	1874	8516000	18158	9154	2	0	2
308332	1874	8519000	18158	9154	3	0	2
308334	1874	8523000	18158	9154	5	0	2
308335	1874	8524000	18158	9154	6	0	2
308343	1678	20160708579000	18160	9155	0	0	0
308344	1678	20160708580000	18160	9155	1	0	0
308346	1874	8528000	18160	9155	3	0	2
308347	1874	8531000	18160	9155	4	0	2
308348	1874	8534000	18160	9155	5	0	2
308353	1678	20160708581000	18162	9156	0	0	0
308354	1874	8536000	18162	9156	1	0	2
308356	1874	8540000	18162	9156	3	0	2
308361	1678	20160708582000	18164	9157	0	0	0
308362	1874	8542000	18164	9157	5	0	2
308363	1678	20160708583000	18165	9158	0	0	0
308364	1874	8545000	18165	9158	1	0	2
308366	1678	20160708584000	18166	9159	0	0	0
308367	1874	8548000	18166	9159	1	0	2
308368	1874	8551000	18166	9159	2	0	2
308369	1874	8553000	18166	9159	3	0	2
308371	1874	8555000	18167	9160	1	0	2
308372	1874	8558000	18167	9160	2	0	2
308373	1678	20160708586000	18168	9161	0	0	0
308374	1678	20160708587000	18168	9161	1	0	0
308375	1678	20160708588000	18168	9161	2	0	0
308377	1874	8562000	18168	9161	4	0	2
308378	1874	8564000	18168	9161	5	0	2
308379	1874	8566000	18168	9161	6	0	2
308380	1874	8568000	18168	9161	7	0	2
308381	1874	8571000	18168	9161	8	0	2
308386	1678	20160708589000	18170	9162	0	0	0
308387	1874	8577000	18170	9162	1	0	2
308388	1874	8579000	18170	9162	2	0	2
308389	1678	20160708590000	18171	9163	0	0	0
308391	1874	8581000	18171	9163	2	0	2
308392	1874	8582000	18171	9163	3	0	2
308393	1874	8585000	18171	9163	4	0	2
308394	1874	8588000	18171	9163	5	0	2
308401	1678	20160708592000	18173	9164	0	0	0
308403	1874	8591000	18173	9164	2	0	2
308404	1874	8594000	18173	9164	3	0	2
308410	1678	20160708594000	18175	9165	0	0	0
308411	1678	20160708595000	18175	9165	1	0	0
308412	1874	8595000	18175	9165	2	0	2
308414	1874	8601000	18175	9165	4	0	2
308415	1678	20160708596000	18176	9166	2	0	0
308416	1678	20160708597000	18176	9166	3	0	0
308417	1678	20160708598000	18176	9166	4	0	0
308419	1874	8602000	18176	9166	6	0	2
308420	1874	8605000	18176	9166	7	0	2
308421	1874	8608000	18176	9166	8	0	2
308422	1874	8611000	18176	9166	9	0	2
308423	1874	8614000	18176	9166	10	0	2
308427	1874	8617000	18179	9167	1	0	2
308428	1678	20160708601000	18180	9168	0	0	0
308429	1874	8618000	18180	9168	1	0	2
308430	1874	8621000	18180	9168	2	0	2
308449	1874	8624000	18187	9170	2	0	\N
308450	1874	8625000	18187	9170	3	0	\N
308451	1874	8628000	18187	9170	4	0	\N
308452	1678	20160708602000	18188	9170	0	0	\N
308453	1678	20160708603000	18188	9170	1	0	\N
308454	1874	8624000	18188	9170	2	0	\N
308455	1874	8625000	18188	9170	3	0	\N
308456	1874	8628000	18188	9170	4	0	\N
308462	1678	20160708602000	18190	9170	0	0	\N
308463	1678	20160708603000	18190	9170	1	0	\N
308464	1874	8624000	18190	9170	2	0	\N
308465	1874	8625000	18190	9170	3	0	\N
308466	1874	8628000	18190	9170	4	0	\N
308467	1678	20160708602000	18192	9170	0	0	\N
308468	1678	20160708603000	18192	9170	1	0	\N
308469	1874	8624000	18192	9170	2	0	\N
308470	1874	8625000	18192	9170	3	0	\N
308471	1874	8628000	18192	9170	4	0	\N
308472	1678	20160708602000	18193	9170	0	0	\N
308473	1678	20160708603000	18193	9170	1	0	\N
308474	1874	8624000	18193	9170	2	0	\N
308475	1874	8625000	18193	9170	3	0	\N
308476	1874	8628000	18193	9170	4	0	\N
308477	1678	20160708602000	18194	9170	0	0	\N
308478	1678	20160708603000	18194	9170	1	0	\N
308479	1874	8624000	18194	9170	2	0	\N
308480	1874	8625000	18194	9170	3	0	\N
308481	1874	8628000	18194	9170	4	0	\N
308482	1678	20160708602000	18195	9170	0	0	\N
308483	1678	20160708603000	18195	9170	1	0	\N
308484	1874	8624000	18195	9170	2	0	\N
308485	1874	8625000	18195	9170	3	0	\N
308486	1874	8628000	18195	9170	4	0	\N
308487	1678	20160708602000	18196	9170	0	0	\N
308488	1678	20160708603000	18196	9170	1	0	\N
308489	1874	8624000	18196	9170	2	0	\N
308490	1874	8625000	18196	9170	3	0	\N
308491	1874	8628000	18196	9170	4	0	\N
308492	1678	20160708604000	18197	9171	0	0	\N
308493	1874	8631000	18197	9171	1	0	\N
308494	1678	20160708604000	18198	9171	0	0	\N
308495	1874	8631000	18198	9171	1	0	\N
308496	1678	20160708604000	18199	9171	0	0	\N
308497	1678	20160708605000	18199	9171	1	0	\N
308498	1874	8631000	18199	9171	2	0	\N
308499	1874	8634000	18199	9171	3	0	\N
308506	1678	20160708604000	18202	9171	0	0	\N
308507	1678	20160708605000	18202	9171	1	0	\N
308508	1678	20160708606000	18202	9171	2	0	\N
308509	1874	8631000	18202	9171	3	0	\N
308510	1874	8634000	18202	9171	4	0	\N
308511	1874	8637000	18202	9171	5	0	\N
308512	1678	20160708607000	18203	9173	0	0	\N
308513	1899	1999000000	18203	9173	1	0	\N
308514	1899	1997000000	18203	9173	3	0	\N
308515	1874	8640000	18203	9173	4	0	\N
308516	1874	8641000	18203	9173	5	0	\N
308517	1678	20160708607000	18204	9173	0	0	\N
308518	1899	1999000000	18204	9173	1	0	\N
308519	1899	1997000000	18204	9173	3	0	\N
308520	1874	8640000	18204	9173	4	0	\N
308521	1874	8641000	18204	9173	5	0	\N
308527	1678	20160708607000	18206	9173	0	0	\N
308528	1899	1999000000	18206	9173	1	0	\N
308529	1899	1997000000	18206	9173	3	0	\N
308530	1874	8640000	18206	9173	4	0	\N
308531	1874	8641000	18206	9173	5	0	\N
308533	1678	20160708608000	18209	9174	0	0	\N
308534	1678	20160708609000	18209	9174	1	0	\N
308535	1874	8644000	18209	9174	2	0	\N
308536	1678	20160708608000	18210	9174	0	0	\N
308537	1678	20160708609000	18210	9174	1	0	\N
308538	1874	8644000	18210	9174	2	0	\N
308548	1678	20160708608000	18212	9175	0	0	\N
308549	1678	20160708609000	18212	9175	1	0	\N
308550	1678	20160708608000	18213	9175	0	0	\N
308551	1678	20160708609000	18213	9175	1	0	\N
308552	1678	20160708610000	18213	9175	2	0	\N
308553	1678	20160708611000	18213	9175	3	0	\N
308554	1678	20160708612000	18213	9175	4	0	\N
308555	1874	8645000	18213	9175	5	0	\N
308556	1874	8648000	18213	9175	6	0	\N
308557	1874	8651000	18213	9175	7	0	\N
308558	1874	8654000	18213	9175	8	0	\N
308559	1678	20160708613000	18214	9176	0	0	\N
308560	1874	8655000	18214	9176	1	0	\N
308561	1874	8658000	18214	9176	3	0	\N
308565	1678	20160708613000	18216	9176	0	0	\N
308566	1874	8655000	18216	9176	1	0	\N
308567	1874	8658000	18216	9176	3	0	\N
308568	1678	20160708614000	18218	9177	0	0	\N
308569	1874	8661000	18218	9177	1	0	\N
308572	1678	20160708615000	18220	9178	0	0	\N
308573	1874	8664000	18220	9178	1	0	\N
308576	2181	200000000	18222	9000	0	0	\N
308577	2181	612200000000	18222	9000	1	0	\N
308578	1560	15714357277001	18222	9000	2	0	\N
308579	1483	10000000	18222	9000	3	0	\N
308580	2182	200000000	18222	9000	5	0	\N
308581	1899	1999000000	18222	9000	6	0	\N
308582	1899	1997000000	18222	9000	8	0	\N
308583	1678	20160708539000	18223	9129	0	0	\N
308584	2182	200000000	18223	9129	2	0	\N
308459	1874	8624000	18189	9170	2	0	2
308460	1874	8625000	18189	9170	3	0	2
308461	1874	8628000	18189	9170	4	0	2
308500	1678	20160708604000	18200	9171	0	0	0
308501	1678	20160708605000	18200	9171	1	0	0
308503	1874	8634000	18200	9171	3	0	2
308504	1678	20160708606000	18201	9172	0	0	0
308505	1874	8637000	18201	9172	1	0	2
308522	1678	20160708607000	18205	9173	0	0	0
308523	1899	1999000000	18205	9173	1	0	1
308525	1874	8640000	18205	9173	4	0	2
308526	1874	8641000	18205	9173	5	0	2
308532	1874	8644000	18208	9174	0	0	2
308539	1678	20160708608000	18211	9175	0	0	0
308541	1678	20160708610000	18211	9175	2	0	0
308542	1678	20160708611000	18211	9175	3	0	0
308543	1678	20160708612000	18211	9175	4	0	0
308544	1874	8645000	18211	9175	5	0	2
308545	1874	8648000	18211	9175	6	0	2
308547	1874	8654000	18211	9175	8	0	2
308562	1678	20160708613000	18215	9176	0	0	0
308563	1874	8655000	18215	9176	1	0	2
308564	1874	8658000	18215	9176	3	0	2
308570	1678	20160708614000	18219	9177	0	0	0
308574	1678	20160708615000	18221	9178	0	0	0
308575	1874	8664000	18221	9178	1	0	2
308585	1678	20160708540000	18223	9129	3	0	\N
308586	1678	20160708541000	18223	9129	4	0	\N
308587	1678	20160708542000	18223	9129	5	0	\N
308588	1678	20160708543000	18223	9129	6	0	\N
308589	1678	20160708544000	18223	9129	7	0	\N
308590	1678	20160708545000	18223	9129	8	0	\N
308591	1678	20160708546000	18223	9129	9	0	\N
308592	1678	20160708547000	18223	9129	10	0	\N
308593	1678	20160708548000	18223	9129	11	0	\N
308594	1678	20160708549000	18223	9129	12	0	\N
308595	1678	20160708550000	18223	9129	13	0	\N
308596	1678	20160708551000	18223	9129	14	0	\N
308597	1678	20160708552000	18223	9129	15	0	\N
308598	1678	20160708553000	18223	9129	16	0	\N
308599	1678	20160708554000	18223	9129	17	0	\N
308600	1678	20160708555000	18223	9129	18	0	\N
308601	1678	20160708556000	18223	9129	19	0	\N
308602	1678	20160708557000	18223	9129	20	0	\N
308603	1678	20160708558000	18223	9129	21	0	\N
308604	1678	20160708559000	18223	9129	22	0	\N
308605	1678	20160708560000	18223	9129	23	0	\N
308606	1678	20160708561000	18223	9129	24	0	\N
308607	1678	20160708562000	18223	9129	25	0	\N
308608	1678	20160708563000	18223	9129	26	0	\N
308609	1678	20160708564000	18223	9129	27	0	\N
308610	1678	20160708565000	18223	9129	28	0	\N
308611	1678	20160708566000	18223	9129	29	0	\N
308612	1678	20160708567000	18223	9129	30	0	\N
308613	1678	20160708568000	18223	9129	31	0	\N
308614	1678	20160708569000	18223	9129	32	0	\N
308615	1678	20160708570000	18223	9129	33	0	\N
308616	1678	20160708571000	18223	9129	34	0	\N
308617	1678	20160708572000	18223	9129	35	0	\N
308618	1678	20160708573000	18223	9129	36	0	\N
308619	1678	20160708574000	18223	9129	37	0	\N
308620	1678	20160708575000	18223	9129	38	0	\N
308621	1678	20160708576000	18223	9129	39	0	\N
308622	1678	20160708577000	18223	9129	40	0	\N
308623	1678	20160708578000	18223	9129	41	0	\N
308624	1678	20160708579000	18223	9129	42	0	\N
308625	1678	20160708580000	18223	9129	43	0	\N
308626	1678	20160708581000	18223	9129	44	0	\N
308627	1678	20160708582000	18223	9129	45	0	\N
308628	1678	20160708583000	18223	9129	46	0	\N
308629	1678	20160708584000	18223	9129	47	0	\N
308630	1678	20160708585000	18223	9129	48	0	\N
308631	1678	20160708586000	18223	9129	49	0	\N
308632	1678	20160708587000	18223	9129	50	0	\N
308633	1678	20160708588000	18223	9129	51	0	\N
308634	1678	20160708589000	18223	9129	52	0	\N
308635	1678	20160708590000	18223	9129	53	0	\N
308636	1678	20160708591000	18223	9129	54	0	\N
308637	1678	20160708592000	18223	9129	55	0	\N
308638	1678	20160708593000	18223	9129	56	0	\N
308639	1678	20160708594000	18223	9129	57	0	\N
308640	1678	20160708595000	18223	9129	58	0	\N
308641	1678	20160708596000	18223	9129	59	0	\N
308650	1678	20160708618000	18226	9180	0	0	\N
308651	1874	8674000	18226	9180	1	0	\N
308652	1929	1302000000	18226	9180	2	0	\N
308653	1678	20160708569000	18227	9152	1	0	\N
308654	1678	20160708570000	18227	9152	2	0	\N
308655	1678	20160708571000	18227	9152	3	0	\N
308656	1678	20160708572000	18227	9152	4	0	\N
308657	2182	200000000	18227	9152	5	0	\N
308658	1678	20160708573000	18227	9152	6	0	\N
308659	1678	20160708574000	18227	9152	7	0	\N
308660	1678	20160708575000	18227	9152	8	0	\N
308661	1678	20160708576000	18227	9152	9	0	\N
308662	1678	20160708577000	18227	9152	10	0	\N
308663	1678	20160708578000	18227	9152	11	0	\N
308664	1678	20160708579000	18227	9152	12	0	\N
308665	1678	20160708580000	18227	9152	14	0	\N
308666	1678	20160708581000	18227	9152	15	0	\N
308667	1678	20160708582000	18227	9152	16	0	\N
308668	1678	20160708583000	18227	9152	17	0	\N
308669	1678	20160708584000	18227	9152	18	0	\N
308670	1678	20160708585000	18227	9152	19	0	\N
308671	1678	20160708586000	18227	9152	20	0	\N
308672	1678	20160708587000	18227	9152	21	0	\N
308673	1678	20160708588000	18227	9152	22	0	\N
308674	1678	20160708589000	18227	9152	23	0	\N
308675	1678	20160708590000	18227	9152	24	0	\N
308676	1678	20160708591000	18227	9152	25	0	\N
308677	1678	20160708592000	18227	9152	26	0	\N
308678	1678	20160708593000	18227	9152	27	0	\N
308679	1678	20160708594000	18227	9152	28	0	\N
308680	1678	20160708595000	18227	9152	29	0	\N
308681	1678	20160708596000	18227	9152	30	0	\N
308682	1678	20160708597000	18227	9152	31	0	\N
308683	1678	20160708598000	18227	9152	32	0	\N
308684	1678	20160708599000	18227	9152	33	0	\N
308685	1678	20160708600000	18227	9152	34	0	\N
308686	1678	20160708601000	18227	9152	35	0	\N
308687	1678	20160708602000	18227	9152	36	0	\N
308688	1678	20160708603000	18227	9152	37	0	\N
308689	1678	20160708604000	18227	9152	38	0	\N
308690	1678	20160708605000	18227	9152	39	0	\N
308691	1678	20160708606000	18227	9152	40	0	\N
308692	1678	20160708607000	18227	9152	41	0	\N
308693	1678	20160708608000	18227	9152	42	0	\N
308694	1678	20160708609000	18227	9152	43	0	\N
308695	1678	20160708610000	18227	9152	44	0	\N
308696	1678	20160708611000	18227	9152	45	0	\N
308697	1678	20160708612000	18227	9152	46	0	\N
308698	1678	20160708613000	18227	9152	47	0	\N
308699	1678	20160708614000	18227	9152	48	0	\N
308700	1678	20160708615000	18227	9152	49	0	\N
308701	1678	20160708616000	18227	9152	50	0	\N
308702	1678	20160708617000	18227	9152	51	0	\N
308703	1678	20160708618000	18227	9152	52	0	\N
308704	1899	1999000000	18227	9152	53	0	\N
308705	1899	1997000000	18227	9152	55	0	\N
308706	1874	8474000	18227	9152	56	0	\N
308707	1874	8476000	18227	9152	57	0	\N
308708	1874	8478000	18227	9152	58	0	\N
308709	1874	8479000	18227	9152	59	0	\N
308710	1874	8480000	18227	9152	60	0	\N
308711	1874	8483000	18227	9152	61	0	\N
308712	1874	8485000	18227	9152	62	0	\N
308713	1874	8487000	18227	9152	63	0	\N
308714	1874	8489000	18227	9152	64	0	\N
308715	1874	8491000	18227	9152	65	0	\N
308716	1874	8494000	18227	9152	66	0	\N
308717	1874	8497000	18227	9152	67	0	\N
308718	1874	8500000	18227	9152	68	0	\N
308719	1874	8503000	18227	9152	69	0	\N
308720	1874	8506000	18227	9152	70	0	\N
308644	1874	8665000	18224	9179	2	0	2
308645	1874	8668000	18224	9179	3	0	2
308646	1874	8671000	18224	9179	4	0	2
308647	1678	20160708618000	18225	9180	0	0	0
308648	1874	8674000	18225	9180	1	0	2
308721	1874	8509000	18227	9152	71	0	\N
308722	1874	8512000	18227	9152	72	0	\N
308723	1874	8515000	18227	9152	73	0	\N
308724	1874	8518000	18227	9152	74	0	\N
308725	1874	8521000	18227	9152	75	0	\N
308726	1874	8524000	18227	9152	76	0	\N
308727	1874	8527000	18227	9152	77	0	\N
308728	1874	8530000	18227	9152	78	0	\N
308729	1874	8532000	18227	9152	79	0	\N
308730	1874	8534000	18227	9152	80	0	\N
308731	1874	8536000	18227	9152	81	0	\N
308732	1874	8538000	18227	9152	82	0	\N
308733	1874	8540000	18227	9152	83	0	\N
308734	1874	8542000	18227	9152	84	0	\N
308735	1874	8544000	18227	9152	85	0	\N
308736	1874	8546000	18227	9152	86	0	\N
308737	1874	8548000	18227	9152	87	0	\N
308738	1874	8549000	18227	9152	88	0	\N
308739	1874	8550000	18227	9152	89	0	\N
308740	1874	8551000	18227	9152	90	0	\N
308741	1874	8552000	18227	9152	91	0	\N
308742	1874	8553000	18227	9152	92	0	\N
308743	1874	8554000	18227	9152	93	0	\N
308744	1874	8555000	18227	9152	94	0	\N
308745	1874	8556000	18227	9152	95	0	\N
308746	1874	8557000	18227	9152	96	0	\N
308747	1874	8558000	18227	9152	97	0	\N
308748	1874	8559000	18227	9152	98	0	\N
308749	1874	8560000	18227	9152	99	0	\N
308750	1874	8561000	18227	9152	100	0	\N
308751	1874	8563000	18227	9152	101	0	\N
308752	1874	8565000	18227	9152	102	0	\N
308753	1874	8567000	18227	9152	103	0	\N
308754	1874	8569000	18227	9152	104	0	\N
308755	1874	8571000	18227	9152	105	0	\N
308756	1874	8573000	18227	9152	106	0	\N
308757	1874	8575000	18227	9152	107	0	\N
308758	1874	8578000	18227	9152	108	0	\N
308759	1874	8581000	18227	9152	109	0	\N
308760	1874	8584000	18227	9152	110	0	\N
308761	1874	8587000	18227	9152	111	0	\N
308762	1874	8590000	18227	9152	112	0	\N
308763	1874	8593000	18227	9152	113	0	\N
308764	1874	8596000	18227	9152	114	0	\N
308765	1874	8599000	18227	9152	115	0	\N
308766	1874	8602000	18227	9152	116	0	\N
308767	1929	1302000000	18227	9152	122	0	\N
308768	1874	8605000	18227	9152	123	0	\N
308769	1874	8608000	18227	9152	124	0	\N
308770	1874	8611000	18227	9152	125	0	\N
308780	1678	20160708622000	18231	9184	0	0	\N
308781	1874	8687000	18231	9184	1	0	\N
308784	1678	20160708579000	18233	9155	0	0	\N
308785	1678	20160708580000	18233	9155	5	0	\N
308786	1678	20160708581000	18233	9155	6	0	\N
308787	1678	20160708582000	18233	9155	7	0	\N
308788	1678	20160708583000	18233	9155	8	0	\N
308789	1678	20160708584000	18233	9155	9	0	\N
308790	1678	20160708585000	18233	9155	10	0	\N
308791	1678	20160708586000	18233	9155	11	0	\N
308792	1678	20160708587000	18233	9155	12	0	\N
308793	1678	20160708588000	18233	9155	13	0	\N
308794	1678	20160708589000	18233	9155	14	0	\N
308795	1678	20160708590000	18233	9155	15	0	\N
308796	1678	20160708591000	18233	9155	16	0	\N
308797	1678	20160708592000	18233	9155	17	0	\N
308798	1678	20160708593000	18233	9155	18	0	\N
308799	1678	20160708594000	18233	9155	19	0	\N
308800	1678	20160708595000	18233	9155	20	0	\N
308801	1678	20160708596000	18233	9155	21	0	\N
308802	1678	20160708597000	18233	9155	22	0	\N
308803	1678	20160708598000	18233	9155	23	0	\N
308804	1678	20160708599000	18233	9155	24	0	\N
308805	1678	20160708600000	18233	9155	25	0	\N
308806	1678	20160708601000	18233	9155	26	0	\N
308807	1678	20160708602000	18233	9155	27	0	\N
308808	1678	20160708603000	18233	9155	28	0	\N
308809	1678	20160708604000	18233	9155	29	0	\N
308810	1678	20160708605000	18233	9155	30	0	\N
308811	1678	20160708606000	18233	9155	31	0	\N
308812	1678	20160708607000	18233	9155	32	0	\N
308813	1678	20160708608000	18233	9155	33	0	\N
308814	1678	20160708609000	18233	9155	34	0	\N
308815	1678	20160708610000	18233	9155	35	0	\N
308816	1678	20160708611000	18233	9155	36	0	\N
308817	1678	20160708612000	18233	9155	37	0	\N
308818	1678	20160708613000	18233	9155	38	0	\N
308819	1678	20160708614000	18233	9155	39	0	\N
308820	1678	20160708615000	18233	9155	40	0	\N
308821	1678	20160708616000	18233	9155	41	0	\N
308822	1678	20160708617000	18233	9155	42	0	\N
308823	1678	20160708618000	18233	9155	43	0	\N
308824	1678	20160708619000	18233	9155	44	0	\N
308825	1678	20160708620000	18233	9155	45	0	\N
308826	1678	20160708621000	18233	9155	46	0	\N
308827	1678	20160708622000	18233	9155	47	0	\N
308828	1899	1999000000	18233	9155	48	0	\N
308829	1899	1997000000	18233	9155	50	0	\N
308830	1874	8526000	18233	9155	51	0	\N
308831	1874	8528000	18233	9155	52	0	\N
308832	1874	8530000	18233	9155	53	0	\N
308833	1874	8532000	18233	9155	54	0	\N
308834	1874	8534000	18233	9155	55	0	\N
308835	1874	8535000	18233	9155	56	0	\N
308836	1874	8536000	18233	9155	57	0	\N
308837	1874	8537000	18233	9155	58	0	\N
308838	1874	8538000	18233	9155	59	0	\N
308839	1874	8539000	18233	9155	60	0	\N
308840	1874	8540000	18233	9155	61	0	\N
308841	1874	8541000	18233	9155	62	0	\N
308842	1874	8542000	18233	9155	63	0	\N
308843	1874	8543000	18233	9155	64	0	\N
308844	1874	8544000	18233	9155	65	0	\N
308845	1874	8545000	18233	9155	66	0	\N
308846	1874	8546000	18233	9155	67	0	\N
308847	1874	8548000	18233	9155	68	0	\N
308848	1874	8550000	18233	9155	69	0	\N
308849	1874	8552000	18233	9155	70	0	\N
308850	1874	8554000	18233	9155	71	0	\N
308851	1874	8556000	18233	9155	72	0	\N
308852	1874	8558000	18233	9155	73	0	\N
308853	1874	8560000	18233	9155	74	0	\N
308854	1874	8561000	18233	9155	75	0	\N
308855	1929	1302000000	18233	9155	81	0	\N
308856	1929	1302040000	18233	9155	82	0	\N
308773	1929	1302043000	18228	9181	2	0	1
308774	1874	8677000	18228	9181	3	0	2
308775	1678	20160708620000	18229	9182	0	0	0
308776	1874	8680000	18229	9182	1	0	2
308777	1874	8681000	18229	9182	2	0	2
308779	1874	8684000	18230	9183	1	0	2
308782	1678	20160708622000	18232	9184	0	0	0
308783	1874	8687000	18232	9184	1	0	2
308857	1929	1302043000	18233	9155	83	0	\N
308860	1874	8691000	18235	9186	0	0	\N
308861	1678	20160708624000	18236	9186	0	0	\N
308862	1874	8691000	18236	9186	1	0	\N
308865	1678	20160708625000	18238	9187	0	0	\N
308866	1874	8694000	18238	9187	1	0	\N
308869	1678	20160708625000	18240	9187	0	0	\N
308870	1874	8694000	18240	9187	1	0	\N
308871	1678	20160708626000	18241	9188	0	0	\N
308872	1678	20160708627000	18241	9188	1	0	\N
308873	1874	8695000	18241	9188	2	0	\N
308874	1874	8698000	18241	9188	3	0	\N
308875	1874	8701000	18241	9188	4	0	\N
308881	1678	20160708626000	18243	9188	0	0	\N
308882	1678	20160708627000	18243	9188	1	0	\N
308883	1874	8695000	18243	9188	2	0	\N
308884	1874	8698000	18243	9188	3	0	\N
308885	1874	8701000	18243	9188	4	0	\N
308886	1678	20160708628000	18244	9189	0	0	\N
308887	1874	8704000	18244	9189	1	0	\N
308902	1678	20160708634000	18249	9193	0	0	\N
308903	1874	8724000	18249	9193	1	0	\N
308904	1678	20160708623000	18250	9185	0	0	\N
308905	1678	20160708624000	18250	9185	1	0	\N
308906	1678	20160708625000	18250	9185	2	0	\N
308907	1678	20160708626000	18250	9185	3	0	\N
308908	1678	20160708627000	18250	9185	4	0	\N
308909	1678	20160708628000	18250	9185	5	0	\N
308910	1678	20160708629000	18250	9185	6	0	\N
308911	1678	20160708630000	18250	9185	7	0	\N
308912	1678	20160708631000	18250	9185	8	0	\N
308913	1678	20160708632000	18250	9185	9	0	\N
308914	1678	20160708633000	18250	9185	10	0	\N
308915	1678	20160708634000	18250	9185	11	0	\N
308916	1874	8690000	18250	9185	12	0	\N
308917	1874	8691000	18250	9185	13	0	\N
308918	1874	8692000	18250	9185	14	0	\N
308919	1874	8693000	18250	9185	15	0	\N
308920	1874	8694000	18250	9185	16	0	\N
308921	1874	8697000	18250	9185	17	0	\N
308922	1874	8700000	18250	9185	18	0	\N
308923	1874	8703000	18250	9185	19	0	\N
308924	1874	8706000	18250	9185	20	0	\N
308925	1874	8709000	18250	9185	21	0	\N
308926	1874	8712000	18250	9185	22	0	\N
308927	1874	8715000	18250	9185	23	0	\N
308928	1874	8718000	18250	9185	24	0	\N
308929	1874	8721000	18250	9185	25	0	\N
308930	1874	8724000	18250	9185	26	0	\N
308931	1678	20160708634000	18251	9193	0	0	\N
308932	1874	8724000	18251	9193	1	0	\N
308935	1678	20160708634000	18253	9193	0	0	\N
308936	1874	8724000	18253	9193	1	0	\N
308941	1678	20160708635000	18256	9194	0	0	\N
308942	1678	20160708636000	18256	9194	1	0	\N
308943	1874	8727000	18256	9194	2	0	\N
308944	1874	8730000	18256	9194	3	0	\N
308945	1874	8731000	18257	9196	0	0	\N
308949	1678	20160708637000	18259	9196	0	0	\N
308950	1874	8731000	18259	9196	1	0	\N
308951	1874	8734000	18259	9196	2	0	\N
308952	1678	20160708637000	18260	9196	0	0	\N
308953	1874	8731000	18260	9196	1	0	\N
308954	1874	8734000	18260	9196	2	0	\N
308966	1678	20160708642000	18265	9200	0	0	\N
308967	1874	8750000	18265	9200	1	0	\N
308971	1678	20160708644000	18267	9202	0	0	\N
308972	1874	8757000	18267	9202	1	0	\N
308983	1678	20160708649000	18272	9206	0	0	\N
308984	1678	20160708650000	18272	9206	1	0	\N
308985	1874	8770000	18272	9206	2	0	\N
308986	1874	8773000	18272	9206	3	0	\N
308987	1874	8774000	18272	9206	4	0	\N
308988	1678	20160708649000	18273	9206	0	0	\N
308989	1678	20160708650000	18273	9206	1	0	\N
308990	1874	8770000	18273	9206	2	0	\N
308991	1874	8773000	18273	9206	3	0	\N
308992	1874	8774000	18273	9206	4	0	\N
308863	1678	20160708624000	18237	9186	0	0	0
308864	1874	8691000	18237	9186	1	0	2
308867	1678	20160708625000	18239	9187	0	0	0
308868	1874	8694000	18239	9187	1	0	2
308876	1678	20160708626000	18242	9188	0	0	0
308878	1874	8695000	18242	9188	2	0	2
308879	1874	8698000	18242	9188	3	0	2
308880	1874	8701000	18242	9188	4	0	2
308888	1678	20160708628000	18245	9189	0	0	0
308889	1874	8704000	18245	9189	1	0	2
308891	1874	8707000	18246	9190	1	0	2
308892	1678	20160708630000	18247	9191	0	0	0
308893	1678	20160708631000	18247	9191	1	0	0
308894	1678	20160708632000	18247	9191	2	0	0
308896	1874	8711000	18247	9191	4	0	2
308897	1874	8714000	18247	9191	5	0	2
308898	1874	8717000	18247	9191	6	0	2
308899	1678	20160708633000	18248	9192	0	0	0
308900	1874	8718000	18248	9192	1	0	2
308933	1678	20160708634000	18252	9193	0	0	0
308934	1874	8724000	18252	9193	1	0	2
308937	1678	20160708635000	18254	9194	0	0	0
308938	1874	8727000	18254	9194	1	0	2
308939	1678	20160708636000	18255	9195	0	0	0
308946	1678	20160708637000	18258	9196	0	0	0
308947	1874	8731000	18258	9196	1	0	2
308948	1874	8734000	18258	9196	2	0	2
308955	1678	20160708638000	18261	9197	0	0	0
308957	1678	20160708639000	18262	9198	0	0	0
308958	1874	8740000	18262	9198	1	0	2
308959	1678	20160708640000	18263	9199	0	0	0
308960	1678	20160708641000	18263	9199	1	0	0
308961	1874	8741000	18263	9199	2	0	2
308963	1874	8747000	18263	9199	4	0	2
308964	1678	20160708642000	18264	9200	0	0	0
308965	1874	8750000	18264	9200	1	0	2
308968	1678	20160708643000	18266	9201	0	0	0
308969	1874	8753000	18266	9201	1	0	2
308973	1678	20160708644000	18268	9202	0	0	0
308974	1874	8757000	18268	9202	1	0	2
308975	1678	20160708645000	18269	9203	0	0	0
308976	1678	20160708646000	18270	9204	0	0	0
308978	1678	20160708647000	18271	9205	0	0	0
308979	1678	20160708648000	18271	9205	1	0	0
308980	1874	8761000	18271	9205	2	0	2
308981	1874	8764000	18271	9205	3	0	2
308982	1874	8767000	18271	9205	4	0	2
309005	1678	20160708654000	18277	9209	0	0	\N
309006	1874	8787000	18277	9209	1	0	\N
309007	1678	20160708654000	18278	9209	0	0	\N
309008	1874	8787000	18278	9209	1	0	\N
309022	1678	20160708625000	18284	9187	0	0	\N
309023	1678	20160708626000	18284	9187	1	0	\N
309024	1678	20160708627000	18284	9187	2	0	\N
309025	1678	20160708628000	18284	9187	3	0	\N
309026	1678	20160708629000	18284	9187	4	0	\N
309027	1678	20160708630000	18284	9187	5	0	\N
309028	1678	20160708631000	18284	9187	6	0	\N
309029	1678	20160708632000	18284	9187	7	0	\N
309030	1678	20160708633000	18284	9187	8	0	\N
309031	1678	20160708634000	18284	9187	9	0	\N
309032	1678	20160708635000	18284	9187	10	0	\N
309033	1678	20160708636000	18284	9187	11	0	\N
309034	1678	20160708637000	18284	9187	12	0	\N
309035	1678	20160708638000	18284	9187	13	0	\N
309036	1678	20160708639000	18284	9187	14	0	\N
309037	1678	20160708640000	18284	9187	15	0	\N
309038	1678	20160708641000	18284	9187	16	0	\N
309039	1678	20160708642000	18284	9187	17	0	\N
309040	1678	20160708643000	18284	9187	18	0	\N
309041	1678	20160708644000	18284	9187	19	0	\N
309042	1678	20160708645000	18284	9187	20	0	\N
309043	1678	20160708646000	18284	9187	21	0	\N
309044	1678	20160708647000	18284	9187	22	0	\N
309045	1678	20160708648000	18284	9187	23	0	\N
309046	1678	20160708649000	18284	9187	24	0	\N
309047	1678	20160708650000	18284	9187	25	0	\N
309048	1678	20160708651000	18284	9187	26	0	\N
309049	1678	20160708652000	18284	9187	27	0	\N
309050	1678	20160708653000	18284	9187	28	0	\N
309051	1678	20160708654000	18284	9187	29	0	\N
309052	1678	20160708655000	18284	9187	30	0	\N
309053	1678	20160708656000	18284	9187	32	0	\N
309054	1678	20160708657000	18284	9187	33	0	\N
309055	1678	20160708658000	18284	9187	34	0	\N
309056	1678	20160708659000	18284	9187	35	0	\N
309057	1874	8692000	18284	9187	36	0	\N
309058	1874	8693000	18284	9187	37	0	\N
309059	1874	8694000	18284	9187	38	0	\N
309060	1874	8695000	18284	9187	39	0	\N
309061	1874	8696000	18284	9187	40	0	\N
309062	1874	8697000	18284	9187	41	0	\N
309063	1874	8698000	18284	9187	42	0	\N
309064	1874	8699000	18284	9187	43	0	\N
309065	1874	8700000	18284	9187	44	0	\N
309066	1874	8701000	18284	9187	45	0	\N
309067	1874	8704000	18284	9187	46	0	\N
309068	1874	8707000	18284	9187	47	0	\N
309069	1874	8710000	18284	9187	48	0	\N
309070	1874	8713000	18284	9187	49	0	\N
309071	1874	8716000	18284	9187	50	0	\N
309072	1874	8719000	18284	9187	51	0	\N
309073	1874	8722000	18284	9187	52	0	\N
309074	1874	8725000	18284	9187	53	0	\N
309075	1874	8728000	18284	9187	54	0	\N
309076	1874	8731000	18284	9187	55	0	\N
309077	1874	8734000	18284	9187	56	0	\N
309078	1874	8737000	18284	9187	57	0	\N
309079	1874	8740000	18284	9187	58	0	\N
309080	1874	8743000	18284	9187	59	0	\N
309081	1874	8746000	18284	9187	60	0	\N
309082	1874	8749000	18284	9187	61	0	\N
309083	1874	8752000	18284	9187	62	0	\N
309084	1874	8755000	18284	9187	63	0	\N
309085	1874	8758000	18284	9187	64	0	\N
309086	1874	8761000	18284	9187	65	0	\N
309087	1874	8764000	18284	9187	66	0	\N
309088	1874	8767000	18284	9187	67	0	\N
309089	1874	8770000	18284	9187	68	0	\N
309090	1874	8773000	18284	9187	69	0	\N
309091	1874	8776000	18284	9187	70	0	\N
309092	1874	8779000	18284	9187	71	0	\N
309093	1874	8782000	18284	9187	72	0	\N
309094	1874	8785000	18284	9187	73	0	\N
309095	1874	8788000	18284	9187	74	0	\N
309096	1874	8791000	18284	9187	75	0	\N
309097	1874	8794000	18284	9187	76	0	\N
309098	1874	8797000	18284	9187	77	0	\N
309099	1874	8800000	18284	9187	78	0	\N
309100	1874	8803000	18284	9187	79	0	\N
309104	1678	20160708660000	18286	9214	0	0	\N
309105	1874	8804000	18286	9214	1	0	\N
309106	1874	8807000	18286	9214	2	0	\N
309107	1678	20160708660000	18287	9214	0	0	\N
309108	1678	20160708661000	18287	9214	1	0	\N
309109	1874	8804000	18287	9214	2	0	\N
309110	1874	8807000	18287	9214	3	0	\N
309127	1678	20160708664000	18291	9217	0	0	\N
309128	1874	8820000	18291	9217	1	0	\N
308995	1874	8770000	18274	9206	2	0	2
308996	1874	8773000	18274	9206	3	0	2
308997	1874	8774000	18274	9206	4	0	2
308998	1678	20160708651000	18275	9207	0	0	0
308999	1678	20160708652000	18275	9207	1	0	0
309001	1874	8780000	18275	9207	3	0	2
309002	1678	20160708653000	18276	9208	0	0	0
309003	1874	8783000	18276	9208	1	0	2
309004	1874	8784000	18276	9208	2	0	2
309009	1678	20160708654000	18279	9209	0	0	0
309011	1678	20160708655000	18280	9210	0	0	0
309012	1874	8790000	18280	9210	1	0	2
309013	1678	20160708656000	18281	9211	0	0	0
309014	1874	8793000	18281	9211	1	0	2
309016	1678	20160708658000	18282	9212	1	0	0
309017	1874	8794000	18282	9212	2	0	2
309018	1874	8797000	18282	9212	3	0	2
309019	1874	8800000	18282	9212	4	0	2
309020	1678	20160708659000	18283	9213	0	0	0
309101	1678	20160708660000	18285	9214	0	0	0
309102	1874	8804000	18285	9214	1	0	2
309103	1874	8807000	18285	9214	2	0	2
309111	1299	1704036598340250	18288	9215	0	0	0
309112	1053	906322247444800	18288	9215	1	0	0
309114	1678	20160708662000	18288	9215	3	0	0
309115	1401	0	18288	9215	4	0	0
309116	1874	8810000	18288	9215	5	0	2
309117	1874	8813000	18288	9215	6	0	2
309119	1173	611513821681700	18289	9216	1	0	0
309120	933	505763350370200	18289	9216	2	0	0
309121	1874	8814000	18289	9216	3	0	2
309122	1401	0	18289	9216	4	0	0
309123	1874	8817000	18289	9216	5	0	2
309125	1874	8820000	18290	9217	1	0	2
309126	1401	0	18290	9217	2	0	0
309129	1401	0	18291	9217	2	0	\N
309130	1678	20160708664000	18292	9217	0	0	\N
309131	1874	8820000	18292	9217	1	0	\N
309132	1401	0	18292	9217	2	0	\N
309136	1678	20160708665000	18294	9218	0	0	\N
309137	1874	8823000	18294	9218	1	0	\N
309138	1929	1307043000	18294	9218	2	0	\N
309139	1678	20160708665000	18295	9218	0	0	\N
309140	1874	8823000	18295	9218	1	0	\N
309141	1929	1307043000	18295	9218	2	0	\N
309144	1678	20160708666000	18297	9219	0	0	\N
309145	1874	8826000	18297	9219	1	0	\N
309146	1678	20160708666000	18298	9219	0	0	\N
309147	1874	8826000	18298	9219	1	0	\N
309148	1678	20160708666000	18299	9219	0	0	\N
309149	1874	8826000	18299	9219	1	0	\N
309150	1678	20160708666000	18300	9219	0	0	\N
309151	1678	20160708667000	18301	9220	0	0	\N
309152	1874	8827000	18301	9220	1	0	\N
309153	1929	1311243001	18301	9220	2	0	\N
309157	1678	20160708667000	18303	9220	0	0	\N
309158	1874	8827000	18303	9220	1	0	\N
309159	1929	1311243001	18303	9220	2	0	\N
309160	1678	20160708668000	18304	9221	0	0	\N
309161	1874	8830000	18304	9221	1	0	\N
309162	1678	20160708668000	18305	9221	0	0	\N
309163	1874	8830000	18305	9221	1	0	\N
309169	946	505554325000000	18308	9223	0	0	\N
309170	1066	905948965000000	18308	9223	1	0	\N
309171	1186	611261950000000	18308	9223	2	0	\N
309172	1312	1703335737751650	18308	9223	3	0	\N
309173	1678	20160708670000	18308	9223	4	0	\N
309174	1678	20160708671000	18308	9223	5	0	\N
309175	1678	20160708672000	18308	9223	6	0	\N
309176	1678	20160708673000	18308	9223	7	0	\N
309177	1678	20160708674000	18308	9223	8	0	\N
309178	1874	8836000	18308	9223	9	0	\N
309179	1874	8839000	18308	9223	10	0	\N
309180	1874	8842000	18308	9223	11	0	\N
309181	1874	8845000	18308	9223	12	0	\N
309182	1874	8848000	18308	9223	13	0	\N
309183	1401	0	18308	9223	14	0	\N
309184	1874	8849000	18308	9223	15	0	\N
309185	1874	8850000	18308	9223	16	0	\N
309186	1726	105955111000	18308	9223	17	0	\N
309187	1726	105955112000	18308	9223	18	0	\N
309188	946	505554325000000	18309	9223	0	0	\N
309189	1066	905948965000000	18309	9223	1	0	\N
309190	1186	611261950000000	18309	9223	2	0	\N
309191	1312	1703335737751650	18309	9223	3	0	\N
309192	1678	20160708670000	18309	9223	4	0	\N
309193	1678	20160708671000	18309	9223	5	0	\N
309194	1678	20160708672000	18309	9223	6	0	\N
309195	1678	20160708673000	18309	9223	7	0	\N
309196	1678	20160708674000	18309	9223	8	0	\N
309197	1874	8836000	18309	9223	9	0	\N
309198	1874	8839000	18309	9223	10	0	\N
309199	1874	8842000	18309	9223	11	0	\N
309200	1874	8845000	18309	9223	12	0	\N
309201	1874	8848000	18309	9223	13	0	\N
309202	1401	0	18309	9223	14	0	\N
309203	1874	8849000	18309	9223	15	0	\N
309204	1874	8850000	18309	9223	16	0	\N
309205	1726	105955111000	18309	9223	17	0	\N
309206	1726	105955112000	18309	9223	18	0	\N
309228	1678	20160708676000	18312	9225	0	0	\N
309229	1726	105956112000	18312	9225	1	0	\N
309230	1874	8856000	18312	9225	2	0	\N
309231	1678	20160708676000	18313	9225	0	0	\N
309232	1726	105956112000	18313	9225	1	0	\N
309233	1874	8856000	18313	9225	2	0	\N
309237	946	505554325000000	18315	9188	0	0	\N
309238	1066	905948965000000	18315	9188	1	0	\N
309239	1186	611261950000000	18315	9188	2	0	\N
309240	1312	1703335737751650	18315	9188	3	0	\N
309241	1678	20160708660000	18315	9188	4	0	\N
309242	1299	1704036598340250	18315	9188	5	0	\N
309243	1053	906322247444800	18315	9188	6	0	\N
309244	1678	20160708661000	18315	9188	7	0	\N
309245	1678	20160708662000	18315	9188	8	0	\N
309246	1678	20160708663000	18315	9188	9	0	\N
309247	1678	20160708664000	18315	9188	10	0	\N
309248	1678	20160708665000	18315	9188	11	0	\N
309249	1173	611513821681700	18315	9188	12	0	\N
309250	933	505763350370200	18315	9188	13	0	\N
309251	1678	20160708666000	18315	9188	14	0	\N
309252	1678	20160708667000	18315	9188	15	0	\N
309253	1678	20160708668000	18315	9188	16	0	\N
309254	1678	20160708669000	18315	9188	17	0	\N
309255	1678	20160708670000	18315	9188	18	0	\N
309256	1678	20160708671000	18315	9188	19	0	\N
309257	1678	20160708672000	18315	9188	20	0	\N
309258	1678	20160708673000	18315	9188	21	0	\N
309259	1678	20160708674000	18315	9188	22	0	\N
309260	1678	20160708675000	18315	9188	23	0	\N
309261	1678	20160708676000	18315	9188	24	0	\N
309262	1726	105956110000	18315	9188	25	0	\N
309263	1874	8804000	18315	9188	26	0	\N
309264	1874	8805000	18315	9188	27	0	\N
309135	1929	1307043000	18293	9218	2	0	1
309142	1678	20160708666000	18296	9219	0	0	0
309143	1874	8826000	18296	9219	1	0	2
309154	1678	20160708667000	18302	9220	0	0	0
309155	1874	8827000	18302	9220	1	0	2
309164	1678	20160708668000	18306	9221	0	0	0
309165	1874	8830000	18306	9221	1	0	2
309166	1678	20160708669000	18307	9222	0	0	0
309167	1874	8833000	18307	9222	1	0	2
309168	1929	1315743001	18307	9222	2	0	1
309208	1066	905948965000000	18310	9223	1	0	0
309209	1186	611261950000000	18310	9223	2	0	0
309210	1312	1703335737751650	18310	9223	3	0	0
309211	1678	20160708670000	18310	9223	4	0	0
309213	1678	20160708672000	18310	9223	6	0	0
309214	1678	20160708673000	18310	9223	7	0	0
309215	1678	20160708674000	18310	9223	8	0	0
309216	1874	8836000	18310	9223	9	0	2
309217	1874	8839000	18310	9223	10	0	2
309219	1874	8845000	18310	9223	12	0	2
309220	1874	8848000	18310	9223	13	0	2
309221	1401	0	18310	9223	14	0	0
309222	1874	8849000	18310	9223	15	0	2
309223	1874	8850000	18310	9223	16	0	2
309225	1726	105955112000	18310	9223	18	0	8199
309226	1678	20160708675000	18311	9224	0	0	0
309227	1874	8853000	18311	9224	1	0	2
309234	1678	20160708676000	18314	9225	0	0	0
309236	1874	8856000	18314	9225	2	0	2
309265	1874	8808000	18315	9188	28	0	\N
309266	1929	1307043000	18315	9188	29	0	\N
309267	1401	0	18315	9188	30	0	\N
309268	1401	0	18315	9188	31	0	\N
309269	1401	0	18315	9188	32	0	\N
309270	1874	8809000	18315	9188	33	0	\N
309271	1401	0	18315	9188	34	0	\N
309272	1874	8812000	18315	9188	35	0	\N
309273	1874	8815000	18315	9188	36	0	\N
309274	1874	8818000	18315	9188	37	0	\N
309275	1874	8821000	18315	9188	38	0	\N
309276	1874	8824000	18315	9188	39	0	\N
309277	1874	8827000	18315	9188	40	0	\N
309278	1874	8830000	18315	9188	41	0	\N
309279	1874	8833000	18315	9188	42	0	\N
309280	1874	8836000	18315	9188	43	0	\N
309281	1874	8839000	18315	9188	44	0	\N
309282	1874	8842000	18315	9188	45	0	\N
309283	1874	8845000	18315	9188	46	0	\N
309284	1874	8848000	18315	9188	47	0	\N
309285	1874	8851000	18315	9188	48	0	\N
309286	1874	8854000	18315	9188	49	0	\N
309287	1874	8855000	18315	9188	50	0	\N
309288	1874	8856000	18315	9188	51	0	\N
309289	1929	1311243001	18315	9188	52	0	\N
309290	1929	1315743001	18315	9188	53	0	\N
309291	1726	105956111000	18315	9188	54	0	\N
309292	1726	105956112000	18315	9188	55	0	\N
309293	1678	20160708676000	18316	9225	0	0	\N
309294	1726	105956112000	18316	9225	1	0	\N
309295	1874	8856000	18316	9225	2	0	\N
309305	1678	20160708679000	18318	9227	0	0	\N
309306	1874	8866000	18318	9227	1	0	\N
309309	1678	20160708679000	18320	9227	0	0	\N
309310	1874	8866000	18320	9227	1	0	\N
309311	1678	20160708680000	18321	9228	0	0	\N
309312	1874	8867000	18321	9228	1	0	\N
309321	1678	20160708683000	18326	9231	0	0	\N
309322	1874	8876000	18326	9231	1	0	\N
309323	1874	8877000	18326	9231	2	0	\N
309324	1678	20160708683000	18327	9231	0	0	\N
309325	1874	8876000	18327	9231	1	0	\N
309326	1874	8877000	18327	9231	2	0	\N
309327	1678	20160708683000	18328	9232	0	0	\N
309328	1678	20160708684000	18328	9232	1	0	\N
309329	1678	20160708685000	18328	9232	2	0	\N
309330	1874	8880000	18328	9232	3	0	\N
309331	1874	8883000	18328	9232	4	0	\N
309337	1678	20160708686000	18330	9233	0	0	\N
309338	1678	20160708687000	18330	9233	1	0	\N
309339	1874	8886000	18330	9233	2	0	\N
309340	1874	8889000	18330	9233	3	0	\N
309341	1874	8890000	18330	9233	4	0	\N
309362	1678	20160708693000	18337	9238	0	0	\N
309363	1678	20160708694000	18337	9238	1	0	\N
309364	1874	8904000	18337	9238	2	0	\N
309365	1874	8907000	18337	9238	3	0	\N
309366	1874	8910000	18337	9238	4	0	\N
309376	1678	20160708699000	18343	9242	0	0	\N
309377	1874	8926000	18343	9242	1	0	\N
309383	1678	20160708701000	18346	9244	0	0	\N
309384	1678	20160708702000	18346	9244	1	0	\N
309385	1678	20160708703000	18346	9244	2	0	\N
309386	1874	8933000	18346	9244	3	0	\N
309387	1874	8936000	18346	9244	5	0	\N
309388	1874	8939000	18346	9244	6	0	\N
309389	1678	20160708701000	18347	9244	0	0	\N
309390	1678	20160708702000	18347	9244	1	0	\N
309391	1678	20160708703000	18347	9244	2	0	\N
309398	1678	20160708701000	18349	9244	0	0	\N
309399	1678	20160708702000	18349	9244	1	0	\N
309400	1678	20160708703000	18349	9244	2	0	\N
309298	1186	611269950000000	18317	9226	2	0	0
309299	1312	1703358037751650	18317	9226	3	0	0
309300	1678	20160708677000	18317	9226	4	0	0
309301	1678	20160708678000	18317	9226	5	0	0
309302	1874	8857000	18317	9226	6	0	2
309304	1874	8863000	18317	9226	8	0	2
309307	1678	20160708679000	18319	9227	0	0	0
309308	1874	8866000	18319	9227	1	0	2
309313	1678	20160708680000	18322	9228	0	0	0
309314	1874	8867000	18322	9228	1	0	2
309316	1874	8870000	18323	9229	1	0	2
309317	1678	20160708682000	18324	9230	0	0	0
309318	1874	8873000	18324	9230	1	0	2
309319	1874	8876000	18325	9231	0	0	2
309332	1678	20160708683000	18329	9232	0	0	0
309333	1678	20160708684000	18329	9232	1	0	0
309334	1678	20160708685000	18329	9232	2	0	0
309335	1874	8880000	18329	9232	3	0	2
309336	1874	8883000	18329	9232	4	0	2
309343	1678	20160708687000	18331	9233	1	0	0
309344	1874	8886000	18331	9233	2	0	2
309345	1874	8889000	18331	9233	3	0	2
309346	1874	8890000	18331	9233	4	0	2
309347	1678	20160708688000	18332	9234	0	0	0
309349	1678	20160708689000	18333	9235	0	0	0
309350	1678	20160708690000	18333	9235	1	0	0
309351	1874	8896000	18333	9235	2	0	2
309352	1874	8899000	18333	9235	3	0	2
309354	1678	20160708691000	18334	9236	0	0	0
309355	1874	8903000	18334	9236	1	0	2
309356	1678	20160708692000	18335	9237	0	0	0
309357	1678	20160708693000	18336	9238	0	0	0
309358	1678	20160708694000	18336	9238	1	0	0
309360	1874	8907000	18336	9238	3	0	2
309361	1874	8910000	18336	9238	4	0	2
309367	1678	20160708695000	18338	9239	0	0	0
309368	1874	8913000	18338	9239	1	0	2
309369	1678	20160708696000	18342	9241	0	0	0
309371	1678	20160708698000	18342	9241	2	0	0
309372	1874	8914000	18342	9241	3	0	2
309373	1874	8917000	18342	9241	4	0	2
309374	1874	8920000	18342	9241	7	0	2
309378	1678	20160708699000	18344	9242	0	0	0
309379	1874	8926000	18344	9242	1	0	2
309380	1678	20160708700000	18345	9243	0	0	0
309381	1874	8929000	18345	9243	1	0	2
309382	1874	8930000	18345	9243	2	0	2
309393	1678	20160708702000	18348	9244	1	0	0
309394	1678	20160708703000	18348	9244	2	0	0
309395	1874	8933000	18348	9244	3	0	2
309396	1874	8936000	18348	9244	5	0	2
309397	1874	8939000	18348	9244	6	0	2
309401	1874	8933000	18349	9244	3	0	\N
309402	1874	8936000	18349	9244	5	0	\N
309403	1874	8939000	18349	9244	6	0	\N
309421	1678	20160708710000	18356	9250	0	0	\N
309422	1874	8960000	18356	9250	1	0	\N
309423	1874	8963000	18356	9250	2	0	\N
309432	1678	20160708714000	18360	9253	0	0	\N
309433	1874	8973000	18360	9253	1	0	\N
309434	1678	20160708714000	18361	9253	0	0	\N
309435	1874	8973000	18361	9253	1	0	\N
309436	1678	20160708714000	18362	9253	0	0	\N
309437	1874	8973000	18362	9253	1	0	\N
309440	1678	20160708715000	18364	9254	0	0	\N
309441	1874	8976000	18364	9254	1	0	\N
309449	946	505554325000000	18367	9112	0	0	\N
309450	1066	905948965000000	18367	9112	1	0	\N
309451	1186	611261950000000	18367	9112	2	0	\N
309452	1312	1703335737751650	18367	9112	3	0	\N
309453	946	505560945000000	18367	9112	4	0	\N
309454	1066	905960815000000	18367	9112	5	0	\N
309455	1186	611269950000000	18367	9112	6	0	\N
309456	1312	1703358037751650	18367	9112	7	0	\N
309457	2182	200000000	18367	9112	9	0	\N
309458	1678	20160708552000	18367	9112	10	0	\N
309459	1678	20160708553000	18367	9112	11	0	\N
309460	1678	20160708554000	18367	9112	12	0	\N
309461	1678	20160708555000	18367	9112	13	0	\N
309462	1678	20160708556000	18367	9112	14	0	\N
309463	1678	20160708557000	18367	9112	15	0	\N
309464	1678	20160708558000	18367	9112	16	0	\N
309465	1678	20160708559000	18367	9112	17	0	\N
309466	1299	1704036598340250	18367	9112	18	0	\N
309467	1053	906322247444800	18367	9112	19	0	\N
309468	1173	611513821681700	18367	9112	20	0	\N
309469	1678	20160708560000	18367	9112	21	0	\N
309470	933	505763350370200	18367	9112	22	0	\N
309471	1678	20160708561000	18367	9112	23	0	\N
309472	1678	20160708562000	18367	9112	24	0	\N
309473	1678	20160708563000	18367	9112	25	0	\N
309474	1678	20160708564000	18367	9112	26	0	\N
309475	1678	20160708565000	18367	9112	27	0	\N
309476	1678	20160708566000	18367	9112	28	0	\N
309477	1678	20160708567000	18367	9112	29	0	\N
309478	1678	20160708568000	18367	9112	30	0	\N
309479	1678	20160708569000	18367	9112	31	0	\N
309480	1678	20160708570000	18367	9112	32	0	\N
309481	1678	20160708571000	18367	9112	33	0	\N
309482	1678	20160708572000	18367	9112	34	0	\N
309483	1678	20160708573000	18367	9112	35	0	\N
309484	1678	20160708574000	18367	9112	36	0	\N
309485	1678	20160708575000	18367	9112	37	0	\N
309486	1678	20160708576000	18367	9112	38	0	\N
309487	1678	20160708577000	18367	9112	39	0	\N
309488	1678	20160708578000	18367	9112	40	0	\N
309489	1678	20160708579000	18367	9112	41	0	\N
309490	1678	20160708580000	18367	9112	42	0	\N
309491	1678	20160708581000	18367	9112	44	0	\N
309492	1678	20160708582000	18367	9112	45	0	\N
309493	1678	20160708583000	18367	9112	46	0	\N
309494	1678	20160708584000	18367	9112	47	0	\N
309495	1678	20160708585000	18367	9112	48	0	\N
309496	1678	20160708586000	18367	9112	49	0	\N
309497	1678	20160708587000	18367	9112	50	0	\N
309498	1678	20160708588000	18367	9112	51	0	\N
309499	1678	20160708589000	18367	9112	52	0	\N
309500	1678	20160708590000	18367	9112	53	0	\N
309501	1678	20160708591000	18367	9112	54	0	\N
309502	1678	20160708592000	18367	9112	55	0	\N
309503	1678	20160708593000	18367	9112	56	0	\N
309504	1678	20160708594000	18367	9112	57	0	\N
309505	1678	20160708595000	18367	9112	58	0	\N
309506	1678	20160708596000	18367	9112	59	0	\N
309507	1678	20160708597000	18367	9112	60	0	\N
309508	1678	20160708598000	18367	9112	61	0	\N
309509	1678	20160708599000	18367	9112	62	0	\N
309510	1678	20160708600000	18367	9112	63	0	\N
309511	1678	20160708601000	18367	9112	64	0	\N
309512	1678	20160708602000	18367	9112	65	0	\N
309513	1678	20160708603000	18367	9112	66	0	\N
309514	1678	20160708604000	18367	9112	67	0	\N
309515	1678	20160708605000	18367	9112	68	0	\N
309516	1678	20160708606000	18367	9112	69	0	\N
309517	1678	20160708607000	18367	9112	70	0	\N
309518	1678	20160708608000	18367	9112	71	0	\N
309519	1678	20160708609000	18367	9112	72	0	\N
309520	1678	20160708610000	18367	9112	73	0	\N
309521	1678	20160708611000	18367	9112	74	0	\N
309522	1678	20160708612000	18367	9112	75	0	\N
309523	1678	20160708613000	18367	9112	76	0	\N
309524	1678	20160708614000	18367	9112	77	0	\N
309525	1678	20160708615000	18367	9112	78	0	\N
309526	1678	20160708616000	18367	9112	79	0	\N
309527	1678	20160708617000	18367	9112	80	0	\N
309528	1678	20160708618000	18367	9112	81	0	\N
309529	1678	20160708619000	18367	9112	82	0	\N
309530	1678	20160708620000	18367	9112	83	0	\N
309531	1678	20160708621000	18367	9112	84	0	\N
309532	1678	20160708622000	18367	9112	85	0	\N
309533	1678	20160708623000	18367	9112	86	0	\N
309534	1678	20160708624000	18367	9112	87	0	\N
309535	1678	20160708625000	18367	9112	88	0	\N
309536	1678	20160708626000	18367	9112	89	0	\N
309406	1874	8943000	18350	9245	6	0	2
309407	1678	20160708705000	18351	9246	0	0	0
309408	1874	8946000	18351	9246	1	0	2
309409	1678	20160708706000	18352	9247	0	0	0
309410	1678	20160708707000	18352	9247	1	0	0
309412	1874	8950000	18352	9247	3	0	2
309413	1874	8953000	18352	9247	4	0	2
309414	1678	20160708708000	18353	9248	0	0	0
309415	1874	8956000	18353	9248	1	0	2
309416	1678	20160708709000	18354	9249	0	0	0
309418	1678	20160708710000	18355	9250	0	0	0
309419	1874	8960000	18355	9250	1	0	2
309420	1874	8963000	18355	9250	2	0	2
309424	1678	20160708711000	18357	9251	0	0	0
309426	1874	8966000	18357	9251	2	0	2
309427	1874	8969000	18357	9251	3	0	2
309428	1678	20160708713000	18358	9252	0	0	0
309429	1874	8972000	18358	9252	1	0	2
309430	1678	20160708714000	18359	9253	0	0	0
309438	1678	20160708715000	18363	9254	0	0	0
309439	1874	8976000	18363	9254	1	0	2
309442	1678	20160708716000	18365	9255	0	0	0
309443	1678	20160708717000	18365	9255	1	0	0
309444	1874	8977000	18365	9255	2	0	2
309446	1874	8983000	18365	9255	4	0	2
309447	1678	20160708718000	18366	9256	0	0	0
309448	1874	8986000	18366	9256	1	0	2
309537	1678	20160708627000	18367	9112	90	0	\N
309538	1678	20160708628000	18367	9112	91	0	\N
309539	1678	20160708629000	18367	9112	92	0	\N
309540	1678	20160708630000	18367	9112	93	0	\N
309541	1678	20160708631000	18367	9112	94	0	\N
309542	1678	20160708632000	18367	9112	95	0	\N
309543	1678	20160708633000	18367	9112	96	0	\N
309544	1678	20160708634000	18367	9112	97	0	\N
309545	1678	20160708635000	18367	9112	98	0	\N
309546	1678	20160708636000	18367	9112	99	0	\N
309547	1678	20160708637000	18367	9112	100	0	\N
309548	1678	20160708638000	18367	9112	101	0	\N
309549	1678	20160708639000	18367	9112	102	0	\N
309550	1678	20160708640000	18367	9112	103	0	\N
309551	1678	20160708641000	18367	9112	104	0	\N
309552	1678	20160708642000	18367	9112	105	0	\N
309553	1678	20160708643000	18367	9112	106	0	\N
309554	1678	20160708644000	18367	9112	107	0	\N
309555	1678	20160708645000	18367	9112	108	0	\N
309556	1678	20160708646000	18367	9112	109	0	\N
309557	1678	20160708647000	18367	9112	110	0	\N
309558	1678	20160708648000	18367	9112	111	0	\N
309559	1678	20160708649000	18367	9112	112	0	\N
309560	1678	20160708650000	18367	9112	113	0	\N
309561	1678	20160708651000	18367	9112	114	0	\N
309562	1678	20160708652000	18367	9112	115	0	\N
309563	1678	20160708653000	18367	9112	116	0	\N
309564	1678	20160708654000	18367	9112	117	0	\N
309565	1678	20160708655000	18367	9112	118	0	\N
309566	1678	20160708656000	18367	9112	119	0	\N
309567	1678	20160708657000	18367	9112	120	0	\N
309568	1678	20160708658000	18367	9112	121	0	\N
309569	1678	20160708659000	18367	9112	122	0	\N
309570	1678	20160708660000	18367	9112	123	0	\N
309571	1678	20160708661000	18367	9112	124	0	\N
309572	1678	20160708719000	18368	9257	0	0	\N
309573	1678	20160708720000	18368	9257	1	0	\N
309574	1874	8987000	18368	9257	2	0	\N
309575	1874	8990000	18368	9257	3	0	\N
309576	1874	8993000	18368	9257	4	0	\N
309582	946	505554325000000	18370	9186	0	0	\N
309583	1066	905948965000000	18370	9186	1	0	\N
309584	1186	611261950000000	18370	9186	2	0	\N
309585	1312	1703335737751650	18370	9186	3	0	\N
309586	946	505560945000000	18370	9186	4	0	\N
309587	1066	905960815000000	18370	9186	5	0	\N
309588	1186	611269950000000	18370	9186	6	0	\N
309589	1312	1703358037751650	18370	9186	7	0	\N
309590	1299	1704036598340250	18370	9186	8	0	\N
309591	1053	906322247444800	18370	9186	9	0	\N
309592	1173	611513821681700	18370	9186	11	0	\N
309593	933	505763350370200	18370	9186	12	0	\N
309594	1678	20160708635000	18370	9186	13	0	\N
309595	1678	20160708636000	18370	9186	14	0	\N
309596	1678	20160708637000	18370	9186	15	0	\N
309597	1678	20160708638000	18370	9186	16	0	\N
309598	1678	20160708639000	18370	9186	17	0	\N
309599	1678	20160708640000	18370	9186	18	0	\N
309600	1678	20160708641000	18370	9186	19	0	\N
309601	1678	20160708642000	18370	9186	20	0	\N
309602	1678	20160708643000	18370	9186	21	0	\N
309603	1678	20160708644000	18370	9186	22	0	\N
309604	1678	20160708645000	18370	9186	23	0	\N
309605	1678	20160708646000	18370	9186	24	0	\N
309606	1678	20160708647000	18370	9186	25	0	\N
309607	1678	20160708648000	18370	9186	26	0	\N
309608	1678	20160708649000	18370	9186	27	0	\N
309609	1678	20160708650000	18370	9186	28	0	\N
309610	1678	20160708651000	18370	9186	29	0	\N
309611	1678	20160708652000	18370	9186	30	0	\N
309612	1678	20160708653000	18370	9186	31	0	\N
309613	1678	20160708654000	18370	9186	32	0	\N
309614	1678	20160708655000	18370	9186	33	0	\N
309615	1678	20160708656000	18370	9186	34	0	\N
309616	1678	20160708657000	18370	9186	35	0	\N
309617	1678	20160708658000	18370	9186	36	0	\N
309618	1678	20160708659000	18370	9186	37	0	\N
309619	1678	20160708660000	18370	9186	38	0	\N
309620	1678	20160708661000	18370	9186	39	0	\N
309621	1678	20160708662000	18370	9186	40	0	\N
309622	1678	20160708663000	18370	9186	41	0	\N
309623	1678	20160708664000	18370	9186	42	0	\N
309624	1678	20160708665000	18370	9186	43	0	\N
309625	1678	20160708666000	18370	9186	44	0	\N
309626	1678	20160708667000	18370	9186	45	0	\N
309627	1678	20160708668000	18370	9186	46	0	\N
309628	1678	20160708669000	18370	9186	47	0	\N
309629	1678	20160708670000	18370	9186	48	0	\N
309630	1678	20160708671000	18370	9186	49	0	\N
309631	1678	20160708672000	18370	9186	50	0	\N
309632	1678	20160708673000	18370	9186	51	0	\N
309633	1678	20160708674000	18370	9186	52	0	\N
309634	1678	20160708675000	18370	9186	53	0	\N
309635	1678	20160708676000	18370	9186	54	0	\N
309636	1678	20160708677000	18370	9186	55	0	\N
309637	1678	20160708678000	18370	9186	56	0	\N
309638	1678	20160708679000	18370	9186	57	0	\N
309639	1678	20160708680000	18370	9186	58	0	\N
309640	1678	20160708681000	18370	9186	59	0	\N
309641	1678	20160708682000	18370	9186	60	0	\N
309642	1678	20160708683000	18370	9186	61	0	\N
309643	1678	20160708684000	18370	9186	62	0	\N
309644	1678	20160708685000	18370	9186	63	0	\N
309645	1678	20160708686000	18370	9186	64	0	\N
309646	1678	20160708687000	18370	9186	65	0	\N
309647	1678	20160708688000	18370	9186	66	0	\N
309648	1678	20160708689000	18370	9186	67	0	\N
309649	1678	20160708690000	18370	9186	68	0	\N
309650	1678	20160708691000	18370	9186	69	0	\N
309651	1678	20160708692000	18370	9186	70	0	\N
309652	1678	20160708693000	18370	9186	71	0	\N
309653	1678	20160708694000	18370	9186	72	0	\N
309654	1678	20160708695000	18370	9186	73	0	\N
309655	1678	20160708696000	18370	9186	74	0	\N
309656	1678	20160708697000	18370	9186	75	0	\N
309657	1678	20160708698000	18370	9186	76	0	\N
309658	1678	20160708699000	18370	9186	77	0	\N
309659	1678	20160708700000	18370	9186	78	0	\N
309660	1678	20160708701000	18370	9186	79	0	\N
309661	1678	20160708702000	18370	9186	80	0	\N
309662	1678	20160708703000	18370	9186	81	0	\N
309663	1678	20160708704000	18370	9186	82	0	\N
309664	1678	20160708705000	18370	9186	83	0	\N
309665	1678	20160708706000	18370	9186	84	0	\N
309666	1678	20160708707000	18370	9186	85	0	\N
309667	1678	20160708708000	18370	9186	86	0	\N
309668	1678	20160708709000	18370	9186	87	0	\N
309669	1678	20160708710000	18370	9186	88	0	\N
309670	1678	20160708711000	18370	9186	89	0	\N
309671	1678	20160708712000	18370	9186	90	0	\N
309672	1678	20160708713000	18370	9186	91	0	\N
309579	1874	8987000	18369	9257	2	0	2
309580	1874	8990000	18369	9257	3	0	2
309581	1874	8993000	18369	9257	4	0	2
309673	1678	20160708714000	18370	9186	92	0	\N
309674	1678	20160708715000	18370	9186	93	0	\N
309675	1678	20160708716000	18370	9186	94	0	\N
309676	1678	20160708717000	18370	9186	95	0	\N
309677	1678	20160708718000	18370	9186	96	0	\N
309678	1678	20160708719000	18370	9186	97	0	\N
309679	1678	20160708720000	18370	9186	98	0	\N
309680	1726	105956110000	18370	9186	99	0	\N
309681	1929	1307043000	18370	9186	100	0	\N
309682	1401	0	18370	9186	101	0	\N
309683	1401	0	18370	9186	102	0	\N
309684	1401	0	18370	9186	103	0	\N
309685	1874	8727000	18370	9186	104	0	\N
309686	1874	8728000	18370	9186	105	0	\N
309687	1874	8729000	18370	9186	106	0	\N
309688	1401	0	18370	9186	107	0	\N
309689	1929	1311243001	18370	9186	108	0	\N
309690	1929	1315743001	18370	9186	109	0	\N
309691	1874	8730000	18370	9186	115	0	\N
309692	1874	8731000	18370	9186	116	0	\N
309693	1874	8732000	18370	9186	117	0	\N
309694	1874	8733000	18370	9186	118	0	\N
309695	1874	8734000	18370	9186	119	0	\N
309696	1874	8735000	18370	9186	120	0	\N
309697	1874	8736000	18370	9186	121	0	\N
309698	1874	8737000	18370	9186	122	0	\N
309699	1874	8738000	18370	9186	123	0	\N
309700	1874	8739000	18370	9186	124	0	\N
309701	1874	8740000	18370	9186	125	0	\N
309704	1678	20160708721000	18372	9258	0	0	\N
309705	1874	8996000	18372	9258	1	0	\N
309710	1678	20160708724000	18375	9261	0	0	\N
309711	1874	9005000	18375	9261	1	0	\N
309712	1874	9006000	18375	9261	2	0	\N
309720	1678	20160708727000	18380	9264	0	0	\N
309721	1678	20160708728000	18380	9264	2	0	\N
309722	1874	9015000	18380	9264	3	0	\N
309723	1874	9018000	18380	9264	4	0	\N
309724	1874	9019000	18380	9264	5	0	\N
309725	1678	20160708721000	18381	9187	0	0	\N
309726	1678	20160708722000	18381	9187	1	0	\N
309727	1678	20160708723000	18381	9187	2	0	\N
309728	1678	20160708724000	18381	9187	3	0	\N
309729	1678	20160708725000	18381	9187	4	0	\N
309730	1678	20160708726000	18381	9187	5	0	\N
309731	1678	20160708727000	18381	9187	6	0	\N
309732	1678	20160708728000	18381	9187	7	0	\N
309733	1874	8741000	18381	9187	8	0	\N
309734	1874	8742000	18381	9187	9	0	\N
309735	1874	8743000	18381	9187	11	0	\N
309736	1874	8744000	18381	9187	12	0	\N
309737	1874	8745000	18381	9187	13	0	\N
309738	1874	8746000	18381	9187	14	0	\N
309739	1874	8747000	18381	9187	15	0	\N
309740	1874	8748000	18381	9187	16	0	\N
309741	1874	8749000	18381	9187	17	0	\N
309742	1874	8750000	18381	9187	18	0	\N
309743	1874	8751000	18381	9187	19	0	\N
309744	1874	8752000	18381	9187	20	0	\N
309745	1874	8753000	18381	9187	21	0	\N
309746	1874	8754000	18381	9187	22	0	\N
309747	1874	8755000	18381	9187	23	0	\N
309748	1726	105956111000	18381	9187	28	0	\N
309749	1726	105956112000	18381	9187	29	0	\N
309750	1874	8758000	18381	9187	30	0	\N
309751	1874	8761000	18381	9187	31	0	\N
309752	1874	8764000	18381	9187	32	0	\N
309753	1874	8767000	18381	9187	33	0	\N
309754	1874	8770000	18381	9187	34	0	\N
309755	1874	8773000	18381	9187	35	0	\N
309756	1874	8776000	18381	9187	36	0	\N
309757	1874	8779000	18381	9187	37	0	\N
309758	1874	8782000	18381	9187	38	0	\N
309759	1874	8785000	18381	9187	39	0	\N
309760	1874	8788000	18381	9187	40	0	\N
309761	1874	8791000	18381	9187	41	0	\N
309762	1874	8794000	18381	9187	42	0	\N
309763	1874	8797000	18381	9187	43	0	\N
309764	1874	8800000	18381	9187	44	0	\N
309765	1874	8803000	18381	9187	45	0	\N
309766	1874	8806000	18381	9187	46	0	\N
309767	1874	8809000	18381	9187	47	0	\N
309768	1874	8812000	18381	9187	48	0	\N
309769	1874	8815000	18381	9187	49	0	\N
309770	1874	8818000	18381	9187	50	0	\N
309771	1874	8821000	18381	9187	51	0	\N
309772	1874	8824000	18381	9187	52	0	\N
309773	1874	8827000	18381	9187	53	0	\N
309774	1874	8830000	18381	9187	54	0	\N
309775	1874	8833000	18381	9187	55	0	\N
309776	1874	8836000	18381	9187	56	0	\N
309777	1874	8839000	18381	9187	57	0	\N
309778	1874	8842000	18381	9187	58	0	\N
309779	1874	8845000	18381	9187	59	0	\N
309780	1874	8848000	18381	9187	60	0	\N
309781	1874	8851000	18381	9187	61	0	\N
309782	1874	8854000	18381	9187	62	0	\N
309783	1874	8857000	18381	9187	63	0	\N
309784	1874	8860000	18381	9187	64	0	\N
309785	1874	8863000	18381	9187	65	0	\N
309786	1874	8866000	18381	9187	66	0	\N
309787	1874	8869000	18381	9187	67	0	\N
309788	1874	8872000	18381	9187	68	0	\N
309789	1874	8875000	18381	9187	69	0	\N
309790	1874	8878000	18381	9187	70	0	\N
309791	1874	8881000	18381	9187	71	0	\N
309792	1874	8884000	18381	9187	72	0	\N
309793	1874	8887000	18381	9187	73	0	\N
309794	1874	8890000	18381	9187	74	0	\N
309795	1874	8893000	18381	9187	75	0	\N
309796	1874	8896000	18381	9187	76	0	\N
309797	1874	8899000	18381	9187	77	0	\N
309798	1874	8902000	18381	9187	78	0	\N
309799	1874	8905000	18381	9187	79	0	\N
309800	1874	8908000	18381	9187	80	0	\N
309801	1874	8911000	18381	9187	81	0	\N
309802	1874	8914000	18381	9187	82	0	\N
309803	1874	8917000	18381	9187	83	0	\N
309804	1874	8920000	18381	9187	84	0	\N
309805	1874	8923000	18381	9187	85	0	\N
309806	1874	8926000	18381	9187	86	0	\N
309807	1874	8929000	18381	9187	87	0	\N
309808	1874	8932000	18381	9187	88	0	\N
309706	1678	20160708722000	18373	9259	0	0	0
309707	1874	8999000	18373	9259	1	0	2
309708	1678	20160708723000	18374	9260	0	0	0
309709	1874	9002000	18374	9260	1	0	2
309713	1678	20160708724000	18376	9261	0	0	0
309715	1874	9006000	18376	9261	2	0	2
309716	1678	20160708725000	18377	9262	0	0	0
309717	1874	9009000	18377	9262	1	0	2
309718	1678	20160708726000	18378	9263	0	0	0
309719	1874	9012000	18378	9263	1	0	2
309809	1874	8935000	18381	9187	89	0	\N
309810	1874	8938000	18381	9187	90	0	\N
309811	1874	8941000	18381	9187	91	0	\N
309812	1874	8944000	18381	9187	92	0	\N
309813	1874	8947000	18381	9187	93	0	\N
309814	1874	8950000	18381	9187	94	0	\N
309815	1874	8953000	18381	9187	95	0	\N
309816	1874	8956000	18381	9187	96	0	\N
309817	1874	8959000	18381	9187	97	0	\N
309818	1874	8962000	18381	9187	98	0	\N
309819	1874	8965000	18381	9187	99	0	\N
309820	1874	8968000	18381	9187	100	0	\N
309821	1874	8971000	18381	9187	101	0	\N
309822	1874	8974000	18381	9187	102	0	\N
309823	1874	8977000	18381	9187	103	0	\N
309824	1874	8980000	18381	9187	104	0	\N
309825	1874	8983000	18381	9187	105	0	\N
309826	1874	8986000	18381	9187	106	0	\N
309827	1874	8989000	18381	9187	107	0	\N
309828	1874	8992000	18381	9187	108	0	\N
309829	1874	8995000	18381	9187	109	0	\N
309830	1874	8998000	18381	9187	110	0	\N
309831	1874	9001000	18381	9187	111	0	\N
309832	1874	9004000	18381	9187	112	0	\N
309833	1874	9007000	18381	9187	113	0	\N
309834	1874	9010000	18381	9187	114	0	\N
309835	1874	9013000	18381	9187	115	0	\N
309836	1874	9016000	18381	9187	116	0	\N
309837	1874	9019000	18381	9187	117	0	\N
309854	1678	20160708734000	18387	9268	0	0	\N
309855	1874	9038000	18387	9268	1	0	\N
309856	1874	9039000	18387	9268	2	0	\N
309860	1678	20160708734000	18389	9268	0	0	\N
309861	1874	9038000	18389	9268	1	0	\N
309862	1874	9039000	18389	9268	2	0	\N
309865	1678	20160708735000	18391	9269	0	0	\N
309866	1874	9042000	18391	9269	1	0	\N
309867	1678	20160708735000	18392	9269	0	0	\N
309868	1874	9042000	18392	9269	1	0	\N
309871	1678	20160708736000	18394	9270	0	0	\N
309872	1874	9045000	18394	9270	1	0	\N
309883	1678	20160708741000	18399	9275	0	0	\N
309884	1678	20160708742000	18399	9275	1	0	\N
309885	1874	9062000	18399	9275	2	0	\N
309886	1874	9065000	18399	9275	3	0	\N
309893	1678	20160708744000	18402	9277	0	0	\N
309894	1874	9071000	18402	9277	1	0	\N
309895	1874	9072000	18402	9277	2	0	\N
309896	1678	20160708744000	18403	9277	0	0	\N
309897	1874	9071000	18403	9277	1	0	\N
309898	1874	9072000	18403	9277	2	0	\N
309905	1678	20160708745000	18406	9278	0	0	\N
309906	1678	20160708746000	18406	9278	1	0	\N
309907	1874	9075000	18406	9278	2	0	\N
309919	1678	20160708751000	18411	9283	0	0	\N
309920	1874	9091000	18411	9283	1	0	\N
309921	1874	9094000	18411	9283	2	0	\N
309922	1678	20160708751000	18412	9283	0	0	\N
309923	1874	9091000	18412	9283	1	0	\N
309924	1874	9094000	18412	9283	2	0	\N
309928	1678	20160708752000	18414	9284	0	0	\N
309929	1678	20160708753000	18414	9284	1	0	\N
309930	1678	20160708754000	18414	9284	2	0	\N
309931	1874	9095000	18414	9284	3	0	\N
309932	1874	9098000	18414	9284	4	0	\N
309933	1874	9100000	18414	9284	5	0	\N
309934	1874	9102000	18414	9284	6	0	\N
309935	1874	9105000	18414	9284	7	0	\N
309936	1874	9107000	18414	9284	8	0	\N
309937	1874	9110000	18414	9284	9	0	\N
309840	1874	9015000	18382	9264	3	0	2
309841	1874	9018000	18382	9264	4	0	2
309842	1874	9019000	18382	9264	5	0	2
309843	1678	20160708729000	18383	9265	0	0	0
309844	1678	20160708730000	18383	9265	1	0	0
309846	1874	9023000	18383	9265	3	0	2
309847	1874	9026000	18383	9265	4	0	2
309848	1678	20160708731000	18385	9266	0	0	0
309849	1874	9029000	18385	9266	1	0	2
309850	1678	20160708732000	18386	9267	0	0	0
309852	1874	9032000	18386	9267	2	0	2
309853	1874	9035000	18386	9267	3	0	2
309857	1678	20160708734000	18388	9268	0	0	0
309858	1874	9038000	18388	9268	1	0	2
309863	1678	20160708735000	18390	9269	0	0	0
309864	1874	9042000	18390	9269	1	0	2
309869	1678	20160708736000	18393	9270	0	0	0
309870	1874	9045000	18393	9270	1	0	2
309873	1678	20160708737000	18395	9271	0	0	0
309875	1874	9049000	18395	9271	2	0	2
309876	1678	20160708738000	18396	9272	0	0	0
309877	1874	9052000	18396	9272	1	0	2
309878	1678	20160708739000	18397	9273	0	0	0
309879	1874	9055000	18397	9273	1	0	2
309881	1874	9058000	18398	9274	1	0	2
309882	1874	9059000	18398	9274	2	0	2
309887	1678	20160708741000	18400	9275	0	0	0
309888	1678	20160708742000	18400	9275	1	0	0
309890	1874	9065000	18400	9275	3	0	2
309891	1678	20160708743000	18401	9276	0	0	0
309892	1874	9068000	18401	9276	1	0	2
309899	1678	20160708744000	18404	9277	0	0	0
309900	1874	9071000	18404	9277	1	0	2
309902	1678	20160708745000	18405	9278	0	0	0
309903	1678	20160708746000	18405	9278	1	0	0
309904	1874	9075000	18405	9278	2	0	2
309908	1678	20160708747000	18407	9279	0	0	0
309909	1874	9078000	18407	9279	1	0	2
309911	1678	20160708748000	18408	9280	0	0	0
309912	1874	9082000	18408	9280	1	0	2
309913	1678	20160708749000	18409	9281	0	0	0
309914	1874	9085000	18409	9281	1	0	2
309916	1678	20160708750000	18410	9282	0	0	0
309917	1874	9086000	18410	9282	1	0	2
309918	1874	9089000	18410	9282	2	0	2
309925	1678	20160708751000	18413	9283	0	0	0
309926	1874	9091000	18413	9283	1	0	2
309938	1678	20160708752000	18415	9284	0	0	0
309939	1678	20160708753000	18415	9284	1	0	0
309940	1678	20160708754000	18415	9284	2	0	0
309941	1874	9095000	18415	9284	3	0	2
309942	1874	9098000	18415	9284	4	0	2
309944	1874	9102000	18415	9284	6	0	2
309948	1678	20160708752000	18416	9284	0	0	\N
309949	1678	20160708753000	18416	9284	1	0	\N
309950	1678	20160708754000	18416	9284	2	0	\N
309951	1874	9095000	18416	9284	3	0	\N
309952	1874	9097000	18416	9284	4	0	\N
309953	1874	9099000	18416	9284	5	0	\N
309954	1874	9101000	18416	9284	6	0	\N
309958	1874	9044000	18418	9270	0	0	\N
309959	1483	10000000	18418	9270	1	0	\N
309960	1874	9046000	18418	9270	2	0	\N
309961	1874	9048000	18418	9270	3	0	\N
309962	1874	9050000	18418	9270	4	0	\N
309963	1874	9052000	18418	9270	5	0	\N
309964	1874	9054000	18418	9270	6	0	\N
309965	1678	20160708756000	18419	9286	0	0	\N
309966	1874	9118000	18419	9286	1	0	\N
309967	1874	9120000	18419	9286	2	0	\N
309975	1678	20160708745000	18422	9278	0	0	\N
309976	1678	20160708746000	18422	9278	1	0	\N
309977	1678	20160708747000	18422	9278	2	0	\N
309978	1678	20160708748000	18422	9278	3	0	\N
309979	1678	20160708749000	18422	9278	4	0	\N
309980	1678	20160708750000	18422	9278	5	0	\N
309981	1678	20160708751000	18422	9278	6	0	\N
309982	1678	20160708752000	18422	9278	7	0	\N
309983	1678	20160708753000	18422	9278	8	0	\N
309984	1678	20160708754000	18422	9278	9	0	\N
309985	1678	20160708755000	18422	9278	10	0	\N
309986	1678	20160708756000	18422	9278	11	0	\N
309987	1874	9074000	18422	9278	12	0	\N
309988	1874	9077000	18422	9278	13	0	\N
309989	1874	9080000	18422	9278	14	0	\N
309990	1874	9083000	18422	9278	15	0	\N
309991	1874	9086000	18422	9278	16	0	\N
309992	1483	10000000	18422	9278	17	0	\N
309993	1874	9088000	18422	9278	18	0	\N
309994	1874	9090000	18422	9278	19	0	\N
309995	1874	9091000	18422	9278	20	0	\N
309996	1874	9092000	18422	9278	21	0	\N
309997	1874	9093000	18422	9278	22	0	\N
309998	1874	9095000	18422	9278	23	0	\N
309999	1874	9098000	18422	9278	24	0	\N
310000	1874	9101000	18422	9278	25	0	\N
310001	1874	9104000	18422	9278	26	0	\N
310002	1874	9107000	18422	9278	27	0	\N
310003	1874	9110000	18422	9278	28	0	\N
310004	1874	9113000	18422	9278	29	0	\N
310005	1874	9116000	18422	9278	30	0	\N
310006	1874	9118000	18422	9278	31	0	\N
310007	1874	9120000	18422	9278	32	0	\N
310008	1874	9122000	18422	9278	33	0	\N
310012	1678	20160708758000	18424	9288	0	0	\N
310013	1874	9128000	18424	9288	2	0	\N
310014	1874	9131000	18424	9288	3	0	\N
310020	1678	20160708743000	18427	9276	0	0	\N
310021	1678	20160708744000	18427	9276	1	0	\N
310022	1678	20160708745000	18427	9276	2	0	\N
310023	1678	20160708746000	18427	9276	3	0	\N
310024	1678	20160708747000	18427	9276	4	0	\N
310025	1678	20160708748000	18427	9276	5	0	\N
310026	1678	20160708749000	18427	9276	6	0	\N
310027	1678	20160708750000	18427	9276	7	0	\N
310028	1678	20160708751000	18427	9276	8	0	\N
310029	1678	20160708752000	18427	9276	9	0	\N
310030	1678	20160708753000	18427	9276	10	0	\N
310031	1678	20160708754000	18427	9276	11	0	\N
310032	1678	20160708755000	18427	9276	12	0	\N
310033	1678	20160708756000	18427	9276	13	0	\N
310034	1678	20160708757000	18427	9276	14	0	\N
310035	1678	20160708758000	18427	9276	15	0	\N
310036	1678	20160708759000	18427	9276	16	0	\N
310037	1678	20160708760000	18427	9276	17	0	\N
310038	1678	20160708761000	18427	9276	18	0	\N
310039	1874	9068000	18427	9276	19	0	\N
310040	1874	9070000	18427	9276	20	0	\N
310041	1483	10000000	18427	9276	21	0	\N
310042	1874	9072000	18427	9276	22	0	\N
310043	1874	9075000	18427	9276	23	0	\N
310044	1874	9078000	18427	9276	24	0	\N
310045	1874	9081000	18427	9276	25	0	\N
310046	1874	9084000	18427	9276	26	0	\N
310047	1874	9087000	18427	9276	27	0	\N
310048	1874	9089000	18427	9276	28	0	\N
310049	1874	9090000	18427	9276	29	0	\N
310050	1874	9091000	18427	9276	30	0	\N
310051	1874	9092000	18427	9276	31	0	\N
310052	1874	9093000	18427	9276	32	0	\N
310053	1874	9094000	18427	9276	33	0	\N
310054	1874	9095000	18427	9276	34	0	\N
310055	1874	9097000	18427	9276	35	0	\N
310056	1874	9100000	18427	9276	36	0	\N
310057	1874	9103000	18427	9276	37	0	\N
310058	1874	9106000	18427	9276	38	0	\N
310059	1874	9109000	18427	9276	39	0	\N
310060	1874	9112000	18427	9276	40	0	\N
310061	1874	9115000	18427	9276	41	0	\N
310062	1874	9118000	18427	9276	42	0	\N
310063	1874	9121000	18427	9276	43	0	\N
310064	1874	9124000	18427	9276	44	0	\N
310065	1874	9127000	18427	9276	45	0	\N
310066	1874	9129000	18427	9276	46	0	\N
310067	1874	9131000	18427	9276	47	0	\N
310068	1874	9133000	18427	9276	48	0	\N
310069	1874	9135000	18427	9276	49	0	\N
310070	1874	9137000	18427	9276	50	0	\N
310071	1874	9139000	18427	9276	51	0	\N
310072	1874	9141000	18427	9276	52	0	\N
310073	1874	9144000	18427	9276	53	0	\N
310078	1678	20160708762000	18429	9292	0	0	\N
310079	1874	9146000	18429	9292	1	0	\N
310080	1874	9149000	18429	9292	2	0	\N
309947	1874	9110000	18415	9284	9	0	2
309955	1678	20160708755000	18417	9285	0	0	0
309956	1874	9113000	18417	9285	1	0	2
309957	1874	9115000	18417	9285	2	0	2
309968	1678	20160708756000	18420	9286	0	0	0
309970	1874	9120000	18420	9286	2	0	2
309971	1678	20160708757000	18421	9287	0	0	0
309972	1874	9122000	18421	9287	1	0	2
309973	1874	9123000	18421	9287	2	0	2
309974	1874	9126000	18421	9287	3	0	2
310010	1874	9128000	18423	9288	2	0	2
310011	1874	9131000	18423	9288	3	0	2
310015	1678	20160708759000	18425	9289	0	0	0
310016	1874	9133000	18425	9289	1	0	2
310018	1874	9135000	18426	9290	1	0	2
310019	1874	9138000	18426	9290	2	0	2
310074	1678	20160708761000	18428	9291	0	0	0
310075	1874	9139000	18428	9291	1	0	2
310076	1874	9141000	18428	9291	2	0	2
310084	1678	20160708763000	18431	9293	0	0	\N
310085	1678	20160708764000	18431	9293	1	0	\N
310086	1874	9150000	18431	9293	2	0	\N
310087	1874	9153000	18431	9293	3	0	\N
310088	1874	9156000	18431	9293	4	0	\N
310089	1874	9158000	18431	9293	5	0	\N
310090	1874	9160000	18431	9293	6	0	\N
310091	1678	20160708763000	18432	9293	0	0	\N
310092	1678	20160708764000	18432	9293	1	0	\N
310093	1874	9150000	18432	9293	2	0	\N
310094	1874	9153000	18432	9293	3	0	\N
310095	1874	9156000	18432	9293	4	0	\N
310096	1874	9158000	18432	9293	5	0	\N
310097	1874	9160000	18432	9293	6	0	\N
310098	1678	20160708763000	18433	9293	0	0	\N
310099	1678	20160708764000	18433	9293	1	0	\N
310100	1874	9150000	18433	9293	2	0	\N
310101	1874	9153000	18433	9293	3	0	\N
310102	1874	9156000	18433	9293	4	0	\N
310103	1874	9158000	18433	9293	5	0	\N
310104	1874	9160000	18433	9293	6	0	\N
310112	946	505554325000000	18435	9119	0	0	\N
310113	1066	905948965000000	18435	9119	2	0	\N
310114	1186	611261950000000	18435	9119	3	0	\N
310115	1312	1703335737751650	18435	9119	4	0	\N
310116	946	505560945000000	18435	9119	5	0	\N
310117	1066	905960815000000	18435	9119	6	0	\N
310118	1186	611269950000000	18435	9119	7	0	\N
310119	1312	1703358037751650	18435	9119	8	0	\N
310120	1299	1704036598340250	18435	9119	9	0	\N
310121	1053	906322247444800	18435	9119	10	0	\N
310122	1173	611513821681700	18435	9119	11	0	\N
310123	933	505763350370200	18435	9119	12	0	\N
310124	1678	20160708573000	18435	9119	17	0	\N
310125	1678	20160708574000	18435	9119	18	0	\N
310126	1678	20160708575000	18435	9119	19	0	\N
310127	1678	20160708576000	18435	9119	20	0	\N
310128	1678	20160708577000	18435	9119	21	0	\N
310129	1678	20160708578000	18435	9119	22	0	\N
310130	1678	20160708579000	18435	9119	23	0	\N
310131	1678	20160708580000	18435	9119	24	0	\N
310132	1678	20160708581000	18435	9119	25	0	\N
310133	1678	20160708582000	18435	9119	26	0	\N
310134	1678	20160708583000	18435	9119	27	0	\N
310135	1678	20160708584000	18435	9119	28	0	\N
310136	1678	20160708585000	18435	9119	29	0	\N
310137	1678	20160708586000	18435	9119	30	0	\N
310138	1678	20160708587000	18435	9119	31	0	\N
310139	1678	20160708588000	18435	9119	32	0	\N
310140	1678	20160708589000	18435	9119	33	0	\N
310141	1678	20160708590000	18435	9119	34	0	\N
310142	1678	20160708591000	18435	9119	35	0	\N
310143	1678	20160708592000	18435	9119	36	0	\N
310144	1678	20160708593000	18435	9119	37	0	\N
310145	1678	20160708594000	18435	9119	38	0	\N
310146	1678	20160708595000	18435	9119	39	0	\N
310147	1678	20160708596000	18435	9119	40	0	\N
310148	1678	20160708597000	18435	9119	41	0	\N
310149	1678	20160708598000	18435	9119	42	0	\N
310150	1678	20160708599000	18435	9119	43	0	\N
310151	1678	20160708600000	18435	9119	44	0	\N
310152	1678	20160708601000	18435	9119	45	0	\N
310153	1678	20160708602000	18435	9119	46	0	\N
310154	1678	20160708603000	18435	9119	47	0	\N
310155	1678	20160708604000	18435	9119	48	0	\N
310156	1678	20160708605000	18435	9119	49	0	\N
310157	1678	20160708606000	18435	9119	50	0	\N
310158	1678	20160708607000	18435	9119	51	0	\N
310159	1678	20160708608000	18435	9119	52	0	\N
310160	1678	20160708609000	18435	9119	53	0	\N
310161	1678	20160708610000	18435	9119	54	0	\N
310162	1678	20160708611000	18435	9119	55	0	\N
310163	1678	20160708612000	18435	9119	56	0	\N
310164	1678	20160708613000	18435	9119	57	0	\N
310165	1678	20160708614000	18435	9119	58	0	\N
310166	1678	20160708615000	18435	9119	59	0	\N
310167	1678	20160708616000	18435	9119	60	0	\N
310168	1678	20160708617000	18435	9119	61	0	\N
310169	1678	20160708618000	18435	9119	62	0	\N
310170	1678	20160708619000	18435	9119	64	0	\N
310171	1678	20160708620000	18435	9119	65	0	\N
310172	1678	20160708621000	18435	9119	66	0	\N
310173	1678	20160708622000	18435	9119	67	0	\N
310174	1678	20160708623000	18435	9119	68	0	\N
310175	1678	20160708624000	18435	9119	69	0	\N
310176	1678	20160708625000	18435	9119	70	0	\N
310177	1678	20160708626000	18435	9119	71	0	\N
310178	1678	20160708627000	18435	9119	72	0	\N
310179	1678	20160708628000	18435	9119	73	0	\N
310180	1678	20160708629000	18435	9119	74	0	\N
310181	1678	20160708630000	18435	9119	75	0	\N
310182	1678	20160708631000	18435	9119	76	0	\N
310183	1678	20160708632000	18435	9119	77	0	\N
310184	1678	20160708633000	18435	9119	78	0	\N
310185	1678	20160708634000	18435	9119	79	0	\N
310186	1678	20160708635000	18435	9119	80	0	\N
310187	1678	20160708636000	18435	9119	81	0	\N
310188	1678	20160708637000	18435	9119	82	0	\N
310189	1678	20160708638000	18435	9119	83	0	\N
310190	1678	20160708639000	18435	9119	84	0	\N
310191	1678	20160708640000	18435	9119	85	0	\N
310192	1678	20160708641000	18435	9119	86	0	\N
310193	1678	20160708642000	18435	9119	87	0	\N
310194	1678	20160708643000	18435	9119	88	0	\N
310195	1678	20160708644000	18435	9119	89	0	\N
310196	1678	20160708645000	18435	9119	90	0	\N
310197	1678	20160708646000	18435	9119	91	0	\N
310198	1678	20160708647000	18435	9119	92	0	\N
310199	1678	20160708648000	18435	9119	93	0	\N
310200	1678	20160708649000	18435	9119	94	0	\N
310201	1678	20160708650000	18435	9119	95	0	\N
310202	1678	20160708651000	18435	9119	96	0	\N
310203	1678	20160708652000	18435	9119	97	0	\N
310204	1678	20160708653000	18435	9119	98	0	\N
310205	1678	20160708654000	18435	9119	99	0	\N
310206	1678	20160708655000	18435	9119	100	0	\N
310207	1678	20160708656000	18435	9119	101	0	\N
310208	1678	20160708657000	18435	9119	102	0	\N
310209	1678	20160708658000	18435	9119	103	0	\N
310210	1678	20160708659000	18435	9119	104	0	\N
310211	1678	20160708660000	18435	9119	105	0	\N
310212	1678	20160708661000	18435	9119	106	0	\N
310213	1678	20160708662000	18435	9119	107	0	\N
310214	1678	20160708663000	18435	9119	108	0	\N
310215	1678	20160708664000	18435	9119	109	0	\N
310216	1678	20160708665000	18435	9119	110	0	\N
310083	1874	9149000	18430	9292	2	0	2
310105	1678	20160708763000	18434	9293	0	0	0
310106	1678	20160708764000	18434	9293	1	0	0
310107	1874	9150000	18434	9293	2	0	2
310108	1874	9153000	18434	9293	3	0	2
310110	1874	9158000	18434	9293	5	0	2
310111	1874	9160000	18434	9293	6	0	2
310217	1678	20160708666000	18435	9119	111	0	\N
310218	1678	20160708667000	18435	9119	112	0	\N
310219	1678	20160708668000	18435	9119	113	0	\N
310220	1678	20160708669000	18435	9119	114	0	\N
310221	1678	20160708670000	18435	9119	115	0	\N
310222	1678	20160708671000	18435	9119	116	0	\N
310223	1678	20160708672000	18435	9119	117	0	\N
310224	1678	20160708673000	18435	9119	118	0	\N
310225	1678	20160708674000	18435	9119	119	0	\N
310226	1678	20160708675000	18435	9119	120	0	\N
310227	1678	20160708676000	18435	9119	121	0	\N
310228	1678	20160708677000	18435	9119	122	0	\N
310229	1678	20160708678000	18435	9119	123	0	\N
310230	1678	20160708679000	18435	9119	124	0	\N
310231	1678	20160708680000	18435	9119	125	0	\N
310235	1678	20160708765000	18437	9294	0	0	\N
310236	1874	9163000	18437	9294	1	0	\N
310237	1874	9165000	18437	9294	2	0	\N
310238	1874	9163000	18438	9294	0	0	\N
310239	1874	9165000	18438	9294	1	0	\N
310240	1874	9163000	18439	9294	0	0	\N
310241	1874	9165000	18439	9294	1	0	\N
310242	1678	20160708765000	18440	9294	0	0	\N
310243	1874	9163000	18440	9294	1	0	\N
310244	1874	9165000	18440	9294	2	0	\N
310251	1678	20160708768000	18442	9296	0	0	\N
310252	1874	9175000	18442	9296	1	0	\N
310253	1874	9178000	18442	9296	2	0	\N
310260	1678	20160708770000	18445	9298	0	0	\N
310261	1874	9185000	18445	9298	1	0	\N
310262	1874	9188000	18445	9298	2	0	\N
310270	1678	20160708771000	18448	9299	0	0	\N
310271	1874	9189000	18448	9299	1	0	\N
310272	1874	9192000	18448	9299	2	0	\N
310273	1874	9194000	18448	9299	3	0	\N
310274	1678	20160708771000	18449	9299	0	0	\N
310275	1874	9189000	18449	9299	1	0	\N
310276	1874	9192000	18449	9299	2	0	\N
310277	1874	9194000	18449	9299	3	0	\N
310278	1678	20160708772000	18450	9300	0	0	\N
310279	1874	9196000	18450	9300	1	0	\N
310280	1874	9199000	18450	9300	2	0	\N
310281	1678	20160708772000	18451	9300	0	0	\N
310282	1874	9196000	18451	9300	1	0	\N
310283	1874	9199000	18451	9300	2	0	\N
310287	1678	20160708729000	18453	9265	0	0	\N
310288	1678	20160708730000	18453	9265	1	0	\N
310289	1678	20160708731000	18453	9265	2	0	\N
310290	1678	20160708732000	18453	9265	3	0	\N
310291	1678	20160708733000	18453	9265	4	0	\N
310292	1678	20160708734000	18453	9265	5	0	\N
310293	1678	20160708735000	18453	9265	6	0	\N
310294	1678	20160708736000	18453	9265	7	0	\N
310295	1678	20160708737000	18453	9265	8	0	\N
310296	1678	20160708738000	18453	9265	9	0	\N
310297	1678	20160708739000	18453	9265	10	0	\N
310298	1678	20160708740000	18453	9265	11	0	\N
310299	1678	20160708741000	18453	9265	12	0	\N
310300	1678	20160708742000	18453	9265	13	0	\N
310301	1678	20160708743000	18453	9265	14	0	\N
310302	1678	20160708744000	18453	9265	15	0	\N
310303	1678	20160708745000	18453	9265	16	0	\N
310304	1678	20160708746000	18453	9265	17	0	\N
310305	1678	20160708747000	18453	9265	18	0	\N
310306	1678	20160708748000	18453	9265	19	0	\N
310307	1678	20160708749000	18453	9265	20	0	\N
310308	1678	20160708750000	18453	9265	21	0	\N
310309	1678	20160708751000	18453	9265	22	0	\N
310310	1678	20160708752000	18453	9265	23	0	\N
310311	1678	20160708753000	18453	9265	24	0	\N
310312	1678	20160708754000	18453	9265	25	0	\N
310313	1678	20160708755000	18453	9265	26	0	\N
310314	1678	20160708756000	18453	9265	27	0	\N
310315	1678	20160708757000	18453	9265	28	0	\N
310316	1678	20160708758000	18453	9265	29	0	\N
310317	1678	20160708759000	18453	9265	30	0	\N
310318	1678	20160708760000	18453	9265	31	0	\N
310319	1678	20160708761000	18453	9265	32	0	\N
310320	1678	20160708762000	18453	9265	33	0	\N
310321	1678	20160708763000	18453	9265	34	0	\N
310322	1678	20160708764000	18453	9265	35	0	\N
310323	1678	20160708765000	18453	9265	36	0	\N
310324	1678	20160708766000	18453	9265	37	0	\N
310325	1678	20160708767000	18453	9265	38	0	\N
310326	1678	20160708768000	18453	9265	39	0	\N
310327	1678	20160708769000	18453	9265	40	0	\N
310328	1678	20160708770000	18453	9265	41	0	\N
310329	1678	20160708771000	18453	9265	42	0	\N
310330	1678	20160708772000	18453	9265	43	0	\N
310331	1874	9020000	18453	9265	44	0	\N
310332	1874	9022000	18453	9265	45	0	\N
310333	1483	10000000	18453	9265	46	0	\N
310334	1874	9024000	18453	9265	47	0	\N
310335	1874	9026000	18453	9265	48	0	\N
310336	1874	9028000	18453	9265	49	0	\N
310337	1874	9031000	18453	9265	50	0	\N
310338	1874	9034000	18453	9265	51	0	\N
310339	1874	9037000	18453	9265	52	0	\N
310340	1874	9040000	18453	9265	53	0	\N
310341	1874	9041000	18453	9265	54	0	\N
310342	1874	9042000	18453	9265	55	0	\N
310343	1874	9044000	18453	9265	56	0	\N
310344	1874	9046000	18453	9265	57	0	\N
310345	1874	9048000	18453	9265	58	0	\N
310346	1874	9050000	18453	9265	59	0	\N
310347	1874	9052000	18453	9265	60	0	\N
310348	1874	9054000	18453	9265	61	0	\N
310349	1874	9056000	18453	9265	62	0	\N
310350	1874	9058000	18453	9265	63	0	\N
310351	1874	9060000	18453	9265	64	0	\N
310352	1874	9062000	18453	9265	65	0	\N
310234	1874	9165000	18436	9294	2	0	2
310245	1678	20160708766000	18441	9295	0	0	0
310246	1678	20160708767000	18441	9295	1	0	0
310247	1874	9167000	18441	9295	2	0	2
310248	1874	9170000	18441	9295	3	0	2
310250	1874	9173000	18441	9295	5	0	2
310254	1678	20160708768000	18443	9296	0	0	0
310255	1874	9175000	18443	9296	1	0	2
310256	1874	9178000	18443	9296	2	0	2
310257	1678	20160708769000	18444	9297	0	0	0
310259	1874	9183000	18444	9297	2	0	2
310263	1678	20160708770000	18446	9298	0	0	0
310264	1874	9185000	18446	9298	1	0	2
310265	1874	9188000	18446	9298	2	0	2
310267	1874	9189000	18447	9299	1	0	2
310268	1874	9192000	18447	9299	2	0	2
310269	1874	9194000	18447	9299	3	0	2
310284	1678	20160708772000	18452	9300	0	0	0
310285	1874	9196000	18452	9300	1	0	2
310353	1874	9064000	18453	9265	66	0	\N
310354	1874	9066000	18453	9265	67	0	\N
310355	1874	9068000	18453	9265	68	0	\N
310356	1874	9070000	18453	9265	69	0	\N
310357	1874	9072000	18453	9265	70	0	\N
310358	1874	9074000	18453	9265	71	0	\N
310359	1874	9075000	18453	9265	72	0	\N
310360	1874	9076000	18453	9265	73	0	\N
310361	1874	9077000	18453	9265	74	0	\N
310362	1874	9078000	18453	9265	75	0	\N
310363	1874	9079000	18453	9265	76	0	\N
310364	1874	9080000	18453	9265	77	0	\N
310365	1874	9081000	18453	9265	78	0	\N
310366	1874	9082000	18453	9265	79	0	\N
310367	1874	9083000	18453	9265	80	0	\N
310368	1874	9084000	18453	9265	81	0	\N
310369	1874	9087000	18453	9265	82	0	\N
310370	1874	9090000	18453	9265	83	0	\N
310371	1874	9093000	18453	9265	84	0	\N
310372	1874	9096000	18453	9265	85	0	\N
310373	1874	9099000	18453	9265	86	0	\N
310374	1874	9102000	18453	9265	87	0	\N
310375	1874	9105000	18453	9265	88	0	\N
310376	1874	9108000	18453	9265	89	0	\N
310377	1874	9111000	18453	9265	90	0	\N
310378	1874	9114000	18453	9265	91	0	\N
310379	1874	9117000	18453	9265	92	0	\N
310380	1874	9120000	18453	9265	93	0	\N
310381	1874	9123000	18453	9265	94	0	\N
310382	1874	9126000	18453	9265	95	0	\N
310383	1874	9129000	18453	9265	96	0	\N
310384	1874	9132000	18453	9265	97	0	\N
310385	1874	9135000	18453	9265	98	0	\N
310386	1874	9138000	18453	9265	99	0	\N
310387	1874	9141000	18453	9265	100	0	\N
310388	1874	9144000	18453	9265	101	0	\N
310389	1874	9147000	18453	9265	102	0	\N
310390	1874	9150000	18453	9265	103	0	\N
310391	1874	9153000	18453	9265	104	0	\N
310392	1874	9156000	18453	9265	105	0	\N
310393	1874	9159000	18453	9265	106	0	\N
310394	1874	9162000	18453	9265	107	0	\N
310395	1874	9165000	18453	9265	108	0	\N
310396	1874	9168000	18453	9265	109	0	\N
310397	1874	9171000	18453	9265	110	0	\N
310398	1874	9174000	18453	9265	111	0	\N
310399	1874	9177000	18453	9265	112	0	\N
310400	1874	9180000	18453	9265	113	0	\N
310401	1874	9183000	18453	9265	114	0	\N
310402	1874	9186000	18453	9265	115	0	\N
310403	1874	9189000	18453	9265	116	0	\N
310404	1874	9192000	18453	9265	117	0	\N
310408	1678	20160708773000	18455	9301	0	0	\N
310409	1874	9201000	18455	9301	1	0	\N
310410	1874	9204000	18455	9301	2	0	\N
310411	1678	20160708774000	18456	9302	0	0	\N
310412	1874	9207000	18456	9302	1	0	\N
310413	1874	9208000	18456	9302	2	0	\N
310418	1678	20160708774000	18458	9302	0	0	\N
310419	1874	9206000	18458	9302	1	0	\N
310420	1874	9209000	18458	9302	2	0	\N
310421	1874	9210000	18458	9302	3	0	\N
310422	1678	20160708774000	18459	9302	0	0	\N
310423	1874	9206000	18459	9302	1	0	\N
310424	1874	9209000	18459	9302	2	0	\N
310425	1874	9210000	18459	9302	3	0	\N
310426	1678	20160708774000	18460	9302	0	0	\N
310427	1874	9206000	18460	9302	1	0	\N
310428	1874	9209000	18460	9302	2	0	\N
310429	1874	9210000	18460	9302	3	0	\N
310433	1678	20160708776000	18463	9304	0	0	\N
310434	1874	9217000	18463	9304	1	0	\N
310437	1678	20160708776000	18465	9304	0	0	\N
310438	1874	9217000	18465	9304	1	0	\N
310439	1678	20160708776000	18466	9304	0	0	\N
310440	1874	9217000	18466	9304	1	0	\N
310448	1678	20160708777000	18468	9305	0	0	\N
310449	1678	20160708778000	18468	9305	1	0	\N
310450	1874	9218000	18468	9305	2	0	\N
310451	1874	9221000	18468	9305	3	0	\N
310452	1874	9224000	18468	9305	4	0	\N
310453	1874	9226000	18468	9305	5	0	\N
310454	1874	9228000	18468	9305	6	0	\N
310466	1678	20160708782000	18470	9307	0	0	\N
310467	1874	9247000	18470	9307	1	0	\N
310468	1678	20160708782000	18471	9307	0	0	\N
310469	1874	9246000	18471	9307	1	0	\N
310470	1874	9249000	18471	9307	2	0	\N
310474	1678	20160708782000	18473	9307	0	0	\N
310475	1874	9246000	18473	9307	1	0	\N
310476	1874	9249000	18473	9307	2	0	\N
310477	1678	20160708783000	18474	9308	0	0	\N
310478	1678	20160708784000	18474	9308	1	0	\N
310479	1874	9251000	18474	9308	2	0	\N
310480	1874	9252000	18474	9308	3	0	\N
310481	1874	9255000	18474	9308	4	0	\N
310482	1874	9258000	18474	9308	5	0	\N
310483	1874	9260000	18474	9308	6	0	\N
310484	2131	194998000	18474	9308	7	0	\N
310485	1678	20160708783000	18475	9308	0	0	\N
310486	1678	20160708784000	18475	9308	1	0	\N
310487	1874	9251000	18475	9308	2	0	\N
310488	1874	9252000	18475	9308	3	0	\N
310407	1874	9204000	18454	9301	2	0	2
310414	1678	20160708774000	18457	9302	0	0	0
310415	1874	9206000	18457	9302	1	0	2
310416	1874	9209000	18457	9302	2	0	2
310417	1874	9210000	18457	9302	3	0	2
310431	1874	9212000	18462	9303	1	0	2
310432	1874	9215000	18462	9303	2	0	2
310435	1678	20160708776000	18464	9304	0	0	0
310436	1874	9217000	18464	9304	1	0	2
310441	1678	20160708777000	18467	9305	0	0	0
310443	1874	9218000	18467	9305	2	0	2
310444	1874	9221000	18467	9305	3	0	2
310445	1874	9224000	18467	9305	4	0	2
310446	1874	9226000	18467	9305	5	0	2
310455	1678	20160708779000	18469	9306	0	0	0
310456	1678	20160708780000	18469	9306	1	0	0
310457	1678	20160708781000	18469	9306	2	0	0
310458	2172	200000000	18469	9306	3	0	0
310459	1874	9230000	18469	9306	4	0	2
310461	1874	9236000	18469	9306	6	0	2
310462	1874	9239000	18469	9306	7	0	2
310463	1874	9241000	18469	9306	8	0	2
310464	1874	9243000	18469	9306	9	0	2
310465	1874	9244000	18469	9306	10	0	2
310472	1874	9246000	18472	9307	1	0	2
310473	1874	9249000	18472	9307	2	0	2
310489	1874	9255000	18475	9308	4	0	\N
310490	1874	9258000	18475	9308	5	0	\N
310491	1874	9260000	18475	9308	6	0	\N
310492	2131	194998000	18475	9308	7	0	\N
310493	1678	20160708783000	18476	9308	0	0	\N
310494	1678	20160708784000	18476	9308	1	0	\N
310495	1874	9251000	18476	9308	2	0	\N
310496	1874	9252000	18476	9308	3	0	\N
310497	1874	9255000	18476	9308	4	0	\N
310498	1874	9258000	18476	9308	5	0	\N
310499	1874	9260000	18476	9308	6	0	\N
310500	2131	194998000	18476	9308	7	0	\N
310501	1678	20160708783000	18477	9308	0	0	\N
310502	1678	20160708784000	18477	9308	1	0	\N
310503	1874	9251000	18477	9308	2	0	\N
310504	1874	9252000	18477	9308	3	0	\N
310505	1874	9255000	18477	9308	4	0	\N
310506	1874	9258000	18477	9308	5	0	\N
310507	1874	9260000	18477	9308	6	0	\N
310508	2131	194998000	18477	9308	7	0	\N
310509	1678	20160708783000	18478	9308	0	0	\N
310510	1678	20160708784000	18478	9308	1	0	\N
310511	1874	9251000	18478	9308	2	0	\N
310512	1874	9252000	18478	9308	3	0	\N
310513	1874	9255000	18478	9308	4	0	\N
310514	1874	9258000	18478	9308	5	0	\N
310515	1874	9260000	18478	9308	6	0	\N
310516	2131	194998000	18478	9308	7	0	\N
310517	1678	20160708783000	18479	9308	0	0	\N
310518	1678	20160708784000	18479	9308	1	0	\N
310519	1874	9251000	18479	9308	2	0	\N
310520	1874	9252000	18479	9308	3	0	\N
310521	1874	9255000	18479	9308	4	0	\N
310522	1874	9258000	18479	9308	5	0	\N
310523	1874	9260000	18479	9308	6	0	\N
310524	2131	194998000	18479	9308	7	0	\N
310525	1678	20160708783000	18480	9308	0	0	\N
310526	1678	20160708784000	18480	9308	1	0	\N
310527	1874	9251000	18480	9308	2	0	\N
310528	1874	9252000	18480	9308	3	0	\N
310529	1874	9255000	18480	9308	4	0	\N
310530	1874	9258000	18480	9308	5	0	\N
310531	1874	9260000	18480	9308	6	0	\N
310532	2131	194998000	18480	9308	7	0	\N
310533	1678	20160708783000	18481	9308	0	0	\N
310534	1678	20160708784000	18481	9308	1	0	\N
310535	1874	9251000	18481	9308	2	0	\N
310536	1874	9252000	18481	9308	3	0	\N
310537	1874	9255000	18481	9308	4	0	\N
310538	1874	9258000	18481	9308	5	0	\N
310539	1874	9260000	18481	9308	6	0	\N
310540	2131	194998000	18481	9308	7	0	\N
310541	1678	20160708783000	18482	9308	0	0	\N
310542	1678	20160708784000	18482	9308	1	0	\N
310543	1874	9251000	18482	9308	2	0	\N
310544	1874	9252000	18482	9308	3	0	\N
310545	1874	9255000	18482	9308	4	0	\N
310546	1874	9258000	18482	9308	5	0	\N
310547	1874	9260000	18482	9308	6	0	\N
310548	2131	194998000	18482	9308	7	0	\N
310575	1678	20160708789000	18486	9310	0	0	\N
310576	1874	9278000	18486	9310	1	0	\N
310577	1874	9281000	18486	9310	2	0	\N
310578	1874	9283000	18486	9310	3	0	\N
310579	1874	9285000	18486	9310	4	0	\N
310580	1874	9287000	18486	9310	5	0	\N
310581	1874	9289000	18486	9310	6	0	\N
310582	1874	9291000	18486	9310	7	0	\N
310583	1678	20160708789000	18487	9310	0	0	\N
310584	1874	9278000	18487	9310	1	0	\N
310585	1874	9281000	18487	9310	2	0	\N
310586	1874	9283000	18487	9310	3	0	\N
310587	1874	9285000	18487	9310	4	0	\N
310588	1874	9287000	18487	9310	5	0	\N
310589	1874	9289000	18487	9310	6	0	\N
310590	1874	9291000	18487	9310	7	0	\N
310600	1678	20160708792000	18491	9313	0	0	\N
310601	1874	9302000	18491	9313	1	0	\N
310602	1874	9304000	18491	9313	2	0	\N
310603	1678	20160708793000	18492	9314	0	0	\N
310604	1874	9306000	18492	9314	1	0	\N
310605	1874	9307000	18492	9314	2	0	\N
310606	1874	9310000	18492	9314	3	0	\N
310615	1678	20160708794000	18495	9315	0	0	\N
310616	2184	200000000	18495	9315	1	0	\N
310617	1874	9313000	18495	9315	2	0	\N
310618	1874	9315000	18495	9315	3	0	\N
310619	1678	20160708794000	18496	9315	0	0	\N
310620	2184	200000000	18496	9315	1	0	\N
310621	1874	9313000	18496	9315	2	0	\N
310622	1874	9315000	18496	9315	3	0	\N
310551	1874	9251000	18483	9308	2	0	2
310552	1874	9252000	18483	9308	3	0	2
310553	1874	9255000	18483	9308	4	0	2
310554	1874	9258000	18483	9308	5	0	2
310555	1874	9260000	18483	9308	6	0	2
310557	1678	20160708785000	18484	9309	0	0	0
310558	1678	20160708786000	18484	9309	1	0	0
310559	1678	20160708787000	18484	9309	2	0	0
310560	1678	20160708788000	18484	9309	3	0	0
310561	1874	9261000	18484	9309	4	0	2
310563	1874	9267000	18484	9309	6	0	2
310564	1874	9270000	18484	9309	7	0	2
310565	1874	9273000	18484	9309	8	0	2
310566	1874	9276000	18484	9309	9	0	2
310568	1874	9278000	18485	9310	1	0	2
310569	1874	9281000	18485	9310	2	0	2
310570	1874	9283000	18485	9310	3	0	2
310571	1874	9285000	18485	9310	4	0	2
310572	1874	9287000	18485	9310	5	0	2
310574	1874	9291000	18485	9310	7	0	2
310591	1678	20160708790000	18488	9311	0	0	0
310592	1874	9292000	18488	9311	1	0	2
310593	1874	9294000	18488	9311	2	0	2
310594	1874	9297000	18488	9311	3	0	2
310596	1874	9299000	18489	9312	1	0	2
310597	1678	20160708792000	18490	9313	0	0	0
310598	1874	9302000	18490	9313	1	0	2
310599	1874	9304000	18490	9313	2	0	2
310608	1874	9306000	18493	9314	1	0	2
310609	1874	9307000	18493	9314	2	0	2
310610	1874	9310000	18493	9314	3	0	2
310611	1678	20160708794000	18494	9315	0	0	0
310612	2184	200000000	18494	9315	1	0	0
310614	1874	9315000	18494	9315	3	0	2
310623	1678	20160708795000	18497	9316	0	0	0
310624	2172	199000000	18497	9316	1	0	1
310638	946	505554325000000	18500	9153	0	0	\N
310639	1066	905948965000000	18500	9153	1	0	\N
310640	1186	611261950000000	18500	9153	2	0	\N
310641	1312	1703335737751650	18500	9153	3	0	\N
310642	946	505560945000000	18500	9153	4	0	\N
310643	1066	905960815000000	18500	9153	5	0	\N
310644	1186	611269950000000	18500	9153	6	0	\N
310645	1312	1703358037751650	18500	9153	7	0	\N
310646	1299	1704036598340250	18500	9153	8	0	\N
310647	1053	906322247444800	18500	9153	9	0	\N
310648	1173	611513821681700	18500	9153	10	0	\N
310649	933	505763350370200	18500	9153	11	0	\N
310650	1678	20160708619000	18500	9153	12	0	\N
310651	1678	20160708620000	18500	9153	14	0	\N
310652	1678	20160708621000	18500	9153	15	0	\N
310653	1678	20160708622000	18500	9153	16	0	\N
310654	1678	20160708623000	18500	9153	17	0	\N
310655	1678	20160708624000	18500	9153	18	0	\N
310656	1678	20160708625000	18500	9153	19	0	\N
310657	1678	20160708626000	18500	9153	20	0	\N
310658	1678	20160708627000	18500	9153	21	0	\N
310659	1678	20160708628000	18500	9153	22	0	\N
310660	1678	20160708629000	18500	9153	23	0	\N
310661	1678	20160708630000	18500	9153	24	0	\N
310662	1678	20160708631000	18500	9153	25	0	\N
310663	1678	20160708632000	18500	9153	26	0	\N
310664	1678	20160708633000	18500	9153	27	0	\N
310665	1678	20160708634000	18500	9153	28	0	\N
310666	2172	200000000	18500	9153	29	0	\N
310667	2184	200000000	18500	9153	30	0	\N
310668	1678	20160708635000	18500	9153	31	0	\N
310669	1678	20160708636000	18500	9153	32	0	\N
310670	1678	20160708637000	18500	9153	33	0	\N
310671	1678	20160708638000	18500	9153	34	0	\N
310672	1678	20160708639000	18500	9153	35	0	\N
310673	1678	20160708640000	18500	9153	36	0	\N
310674	1678	20160708641000	18500	9153	37	0	\N
310675	1678	20160708642000	18500	9153	38	0	\N
310676	1678	20160708643000	18500	9153	39	0	\N
310677	1678	20160708644000	18500	9153	40	0	\N
310678	1678	20160708645000	18500	9153	41	0	\N
310679	1678	20160708646000	18500	9153	42	0	\N
310680	1678	20160708647000	18500	9153	43	0	\N
310681	1678	20160708648000	18500	9153	44	0	\N
310682	1678	20160708649000	18500	9153	45	0	\N
310683	1678	20160708650000	18500	9153	46	0	\N
310684	1678	20160708651000	18500	9153	47	0	\N
310685	1678	20160708652000	18500	9153	48	0	\N
310686	1678	20160708653000	18500	9153	49	0	\N
310687	1678	20160708654000	18500	9153	50	0	\N
310688	1678	20160708655000	18500	9153	51	0	\N
310689	1678	20160708656000	18500	9153	52	0	\N
310690	1678	20160708657000	18500	9153	53	0	\N
310691	1678	20160708658000	18500	9153	54	0	\N
310692	1678	20160708659000	18500	9153	55	0	\N
310693	1678	20160708660000	18500	9153	56	0	\N
310694	1678	20160708661000	18500	9153	57	0	\N
310695	1678	20160708662000	18500	9153	58	0	\N
310696	1678	20160708663000	18500	9153	59	0	\N
310697	1678	20160708664000	18500	9153	60	0	\N
310698	1678	20160708665000	18500	9153	61	0	\N
310699	1678	20160708666000	18500	9153	62	0	\N
310700	1678	20160708667000	18500	9153	63	0	\N
310701	1678	20160708668000	18500	9153	64	0	\N
310702	1678	20160708669000	18500	9153	65	0	\N
310703	1678	20160708670000	18500	9153	66	0	\N
310704	1678	20160708671000	18500	9153	67	0	\N
310705	1678	20160708672000	18500	9153	68	0	\N
310706	1678	20160708673000	18500	9153	69	0	\N
310707	1678	20160708674000	18500	9153	70	0	\N
310708	1678	20160708675000	18500	9153	71	0	\N
310709	1678	20160708676000	18500	9153	72	0	\N
310710	1678	20160708677000	18500	9153	73	0	\N
310711	1678	20160708678000	18500	9153	74	0	\N
310712	1678	20160708679000	18500	9153	75	0	\N
310713	1678	20160708680000	18500	9153	76	0	\N
310714	1678	20160708681000	18500	9153	77	0	\N
310715	1678	20160708682000	18500	9153	78	0	\N
310716	1678	20160708683000	18500	9153	79	0	\N
310717	1678	20160708684000	18500	9153	80	0	\N
310718	1678	20160708685000	18500	9153	81	0	\N
310719	1678	20160708686000	18500	9153	82	0	\N
310720	1678	20160708687000	18500	9153	83	0	\N
310721	1678	20160708688000	18500	9153	84	0	\N
310722	1678	20160708689000	18500	9153	85	0	\N
310723	1678	20160708690000	18500	9153	86	0	\N
310724	1678	20160708691000	18500	9153	87	0	\N
310725	1678	20160708692000	18500	9153	88	0	\N
310726	1678	20160708693000	18500	9153	89	0	\N
310727	1678	20160708694000	18500	9153	90	0	\N
310728	1678	20160708695000	18500	9153	91	0	\N
310729	1678	20160708696000	18500	9153	92	0	\N
310730	1678	20160708697000	18500	9153	93	0	\N
310731	1678	20160708698000	18500	9153	94	0	\N
310732	1678	20160708699000	18500	9153	95	0	\N
310733	1678	20160708700000	18500	9153	96	0	\N
310734	1678	20160708701000	18500	9153	97	0	\N
310735	1678	20160708702000	18500	9153	98	0	\N
310736	1678	20160708703000	18500	9153	99	0	\N
310737	1678	20160708704000	18500	9153	100	0	\N
310738	1678	20160708705000	18500	9153	101	0	\N
310739	1678	20160708706000	18500	9153	102	0	\N
310740	1678	20160708707000	18500	9153	103	0	\N
310741	1678	20160708708000	18500	9153	104	0	\N
310742	1678	20160708709000	18500	9153	105	0	\N
310743	1678	20160708710000	18500	9153	106	0	\N
310744	1678	20160708711000	18500	9153	107	0	\N
310745	1678	20160708712000	18500	9153	108	0	\N
310746	1678	20160708713000	18500	9153	109	0	\N
310747	1678	20160708714000	18500	9153	110	0	\N
310748	1678	20160708715000	18500	9153	111	0	\N
310749	1678	20160708716000	18500	9153	112	0	\N
310750	1678	20160708717000	18500	9153	113	0	\N
310751	1678	20160708718000	18500	9153	114	0	\N
310752	1678	20160708719000	18500	9153	115	0	\N
310753	1678	20160708720000	18500	9153	116	0	\N
310754	1678	20160708721000	18500	9153	117	0	\N
310755	1678	20160708722000	18500	9153	118	0	\N
310756	1678	20160708723000	18500	9153	119	0	\N
310757	1678	20160708724000	18500	9153	120	0	\N
310758	1678	20160708725000	18500	9153	121	0	\N
310759	1678	20160708726000	18500	9153	122	0	\N
310760	1678	20160708727000	18500	9153	123	0	\N
310627	1678	20160708796000	18498	9317	0	0	0
310628	1874	9322000	18498	9317	1	0	2
310629	1874	9323000	18498	9317	2	0	2
310630	1874	9326000	18498	9317	3	0	2
310631	1678	20160708797000	18499	9318	0	0	0
310633	1402	59614738319298	18499	9318	2	0	33
310634	1874	9328000	18499	9318	3	0	2
310635	1874	9330000	18499	9318	4	0	2
310636	1874	9333000	18499	9318	5	0	2
310637	1874	9336000	18499	9318	6	0	2
310761	1678	20160708728000	18500	9153	124	0	\N
310762	1678	20160708729000	18500	9153	125	0	\N
310766	1678	20160708799000	18502	9319	0	0	\N
310767	1874	9339000	18502	9319	1	0	\N
310768	1874	9341000	18502	9319	2	0	\N
310776	1678	20160708801000	18505	9321	0	0	\N
310777	1874	9350000	18505	9321	1	0	\N
310778	1874	9352000	18505	9321	2	0	\N
310786	1678	20160708804000	18509	9323	0	0	\N
310787	1874	9365000	18509	9323	1	0	\N
310788	1874	9368000	18509	9323	2	0	\N
310789	1874	9365000	18510	9323	0	0	\N
310790	1874	9368000	18510	9323	1	0	\N
310796	1678	20160708805000	18513	9324	1	0	\N
310797	1874	9370000	18513	9324	2	0	\N
310798	2172	200000000	18514	9271	1	0	\N
310799	2184	200000000	18514	9271	2	0	\N
310800	2185	200000000	18514	9271	3	0	\N
310801	2172	200001000	18514	9271	4	0	\N
310802	1874	9056000	18514	9271	5	0	\N
310803	1874	9058000	18514	9271	6	0	\N
310804	1874	9060000	18514	9271	7	0	\N
310805	1874	9062000	18514	9271	8	0	\N
310806	1874	9064000	18514	9271	9	0	\N
310807	1874	9066000	18514	9271	10	0	\N
310808	1874	9068000	18514	9271	11	0	\N
310809	1874	9070000	18514	9271	12	0	\N
310810	1874	9072000	18514	9271	13	0	\N
310811	1874	9074000	18514	9271	14	0	\N
310812	1874	9076000	18514	9271	15	0	\N
310813	1874	9078000	18514	9271	16	0	\N
310814	1874	9080000	18514	9271	17	0	\N
310815	1874	9082000	18514	9271	18	0	\N
310816	1874	9084000	18514	9271	19	0	\N
310817	1874	9086000	18514	9271	20	0	\N
310818	1874	9088000	18514	9271	21	0	\N
310819	1874	9090000	18514	9271	22	0	\N
310820	1874	9092000	18514	9271	23	0	\N
310821	1874	9094000	18514	9271	24	0	\N
310822	1874	9096000	18514	9271	25	0	\N
310823	1874	9098000	18514	9271	26	0	\N
310824	1874	9100000	18514	9271	27	0	\N
310825	1874	9102000	18514	9271	28	0	\N
310826	1874	9104000	18514	9271	29	0	\N
310827	1874	9106000	18514	9271	30	0	\N
310828	1874	9108000	18514	9271	31	0	\N
310829	1874	9110000	18514	9271	32	0	\N
310830	1874	9112000	18514	9271	33	0	\N
310831	1874	9114000	18514	9271	34	0	\N
310832	1874	9116000	18514	9271	35	0	\N
310833	1874	9118000	18514	9271	36	0	\N
310834	1874	9120000	18514	9271	37	0	\N
310835	1874	9122000	18514	9271	38	0	\N
310836	1874	9124000	18514	9271	39	0	\N
310837	1874	9126000	18514	9271	40	0	\N
310838	1874	9128000	18514	9271	41	0	\N
310839	1874	9130000	18514	9271	42	0	\N
310840	1874	9132000	18514	9271	43	0	\N
310841	1874	9134000	18514	9271	44	0	\N
310842	1874	9136000	18514	9271	45	0	\N
310843	1874	9138000	18514	9271	46	0	\N
310844	1874	9140000	18514	9271	47	0	\N
310845	1874	9142000	18514	9271	48	0	\N
310846	1874	9144000	18514	9271	49	0	\N
310847	1874	9146000	18514	9271	50	0	\N
310848	1874	9148000	18514	9271	51	0	\N
310849	1874	9150000	18514	9271	52	0	\N
310850	1874	9152000	18514	9271	53	0	\N
310851	1874	9154000	18514	9271	54	0	\N
310852	1874	9156000	18514	9271	55	0	\N
310865	1403	0	18517	9272	0	0	\N
310866	1874	9158000	18517	9272	1	0	\N
310867	1874	9160000	18517	9272	2	0	\N
310868	1874	9162000	18517	9272	3	0	\N
310872	1678	20160708809000	18519	9327	0	0	\N
310873	1874	9389000	18519	9327	1	0	\N
310874	1874	9391000	18519	9327	2	0	\N
310885	1678	20160708813000	18524	9331	0	0	\N
310886	1874	9408000	18524	9331	1	0	\N
310887	1874	9410000	18524	9331	2	0	\N
310888	1874	9413000	18524	9331	3	0	\N
310889	1678	20160708813000	18525	9331	0	0	\N
310890	1874	9408000	18525	9331	1	0	\N
310891	1874	9410000	18525	9331	2	0	\N
310892	1874	9413000	18525	9331	3	0	\N
310765	1874	9341000	18501	9319	2	0	2
310769	1678	20160708800000	18503	9320	0	0	0
310770	1874	9343000	18503	9320	1	0	2
310771	1874	9346000	18503	9320	2	0	2
310772	1874	9347000	18503	9320	3	0	2
310774	1874	9350000	18504	9321	1	0	2
310775	1874	9352000	18504	9321	2	0	2
310779	1678	20160708802000	18506	9322	0	0	0
310780	1678	20160708803000	18506	9322	1	0	0
310781	1874	9353000	18506	9322	2	0	2
310783	1874	9358000	18506	9322	4	0	2
310784	1874	9361000	18506	9322	5	0	2
310785	1874	9363000	18506	9322	6	0	2
310791	1678	20160708804000	18511	9323	0	0	0
310793	1874	9368000	18511	9323	2	0	2
310794	1678	20160708805000	18512	9324	1	0	0
310795	1874	9370000	18512	9324	2	0	2
310853	1678	20160708806000	18515	9325	0	0	0
310854	2185	200000000	18515	9325	1	0	0
310856	1874	9375000	18515	9325	3	0	2
310857	1874	9376000	18515	9325	4	0	2
310858	1678	20160708807000	18516	9326	0	0	0
310859	1678	20160708808000	18516	9326	1	0	0
310860	1403	0	18516	9326	2	0	0
310862	1874	9382000	18516	9326	4	0	2
310863	1874	9384000	18516	9326	5	0	2
310864	1874	9386000	18516	9326	6	0	2
310869	1678	20160708809000	18518	9327	0	0	0
310871	1874	9391000	18518	9327	2	0	2
310875	1678	20160708810000	18522	9329	0	0	0
310876	1678	20160708811000	18522	9329	1	0	0
310877	1874	9394000	18522	9329	2	0	2
310878	1874	9395000	18522	9329	3	0	2
310880	1874	9399000	18522	9329	5	0	2
310881	1874	9402000	18522	9329	6	0	2
310882	1678	20160708812000	18523	9330	1	0	0
310883	1874	9405000	18523	9330	2	0	2
310884	1874	9407000	18523	9330	3	0	2
310894	1874	9408000	18526	9331	1	0	2
310895	1874	9410000	18526	9331	2	0	2
310896	1874	9413000	18526	9331	3	0	2
310926	1678	20160708822000	18534	9338	0	0	\N
310927	1874	9454000	18534	9338	1	0	\N
310928	1874	9457000	18534	9338	2	0	\N
310929	1678	20160708822000	18535	9338	0	0	\N
310930	1874	9454000	18535	9338	1	0	\N
310931	1874	9457000	18535	9338	2	0	\N
310932	2186	100000000	18536	9299	1	0	\N
310933	2172	200000000	18536	9299	3	0	\N
310934	2184	200000000	18536	9299	4	0	\N
310935	2185	200000000	18536	9299	5	0	\N
310936	2172	200001000	18536	9299	6	0	\N
310950	1678	20160708826000	18540	9341	0	0	\N
310951	1874	9475000	18540	9341	1	0	\N
310952	1874	9478000	18540	9341	2	0	\N
310953	1678	20160708826000	18541	9341	0	0	\N
310954	1874	9475000	18541	9341	1	0	\N
310955	1874	9478000	18541	9341	2	0	\N
310963	1678	20160708829000	18544	9344	0	0	\N
310964	1874	9491000	18544	9344	1	0	\N
310965	1874	9494000	18544	9344	2	0	\N
310966	1678	20160708829000	18545	9344	0	0	\N
310967	1874	9491000	18545	9344	1	0	\N
310968	1874	9494000	18545	9344	2	0	\N
310972	2186	524057693786	18547	9345	0	0	\N
310973	1678	20160708830000	18547	9345	1	0	\N
310974	1874	9497000	18547	9345	2	0	\N
310975	1874	9498000	18547	9345	3	0	\N
310980	2186	524057693786	18549	9345	0	0	\N
310981	1678	20160708830000	18549	9345	1	0	\N
310982	1874	9497000	18549	9345	2	0	\N
310983	1874	9498000	18549	9345	3	0	\N
311013	1678	20160708836000	18555	9350	0	0	\N
311014	1678	20160708837000	18555	9350	1	0	\N
311015	1678	20160708838000	18555	9350	2	0	\N
311016	1678	20160708839000	18555	9350	3	0	\N
311017	1874	9524000	18555	9350	4	0	\N
311018	1874	9527000	18555	9350	5	0	\N
311019	1874	9530000	18555	9350	6	0	\N
311020	1874	9533000	18555	9350	7	0	\N
311021	1874	9535000	18555	9350	8	0	\N
311022	1874	9537000	18555	9350	9	0	\N
311023	1874	9539000	18555	9350	10	0	\N
311024	1874	9541000	18555	9350	11	0	\N
311025	1874	9542000	18555	9350	12	0	\N
310899	1874	9418000	18527	9332	2	0	2
310900	1678	20160708815000	18528	9333	0	0	0
310901	1874	9420000	18528	9333	1	0	2
310902	1874	9423000	18528	9333	2	0	2
310903	1678	20160708816000	18529	9334	0	0	0
310905	1874	9428000	18529	9334	2	0	2
310906	1678	20160708817000	18530	9335	0	0	0
310907	1874	9429000	18530	9335	1	0	2
310908	1874	9431000	18530	9335	2	0	2
310909	2186	100000000	18531	9336	0	0	0
310911	1678	20160708819000	18531	9336	2	0	0
310912	1874	9433000	18531	9336	3	0	2
310913	1874	9436000	18531	9336	4	0	2
310914	1874	9439000	18531	9336	5	0	2
310916	1678	20160708820000	18532	9337	0	0	0
310917	1678	20160708821000	18532	9337	1	0	0
310918	1874	9443000	18532	9337	2	0	2
310919	1874	9445000	18532	9337	3	0	2
310920	1874	9448000	18532	9337	4	0	2
310922	1874	9452000	18532	9337	6	0	2
310923	1678	20160708822000	18533	9338	0	0	0
310924	1874	9454000	18533	9338	1	0	2
310925	1874	9457000	18533	9338	2	0	2
310937	1678	20160708823000	18537	9339	0	0	0
310939	1874	9459000	18537	9339	2	0	2
310940	1874	9462000	18537	9339	3	0	2
310941	1874	9465000	18537	9339	4	0	2
310942	1874	9467000	18537	9339	5	0	2
310944	1678	20160708825000	18538	9340	0	0	0
310945	1874	9470000	18538	9340	1	0	2
310946	1874	9473000	18538	9340	2	0	2
310947	1678	20160708826000	18539	9341	0	0	0
310948	1874	9475000	18539	9341	1	0	2
310956	1678	20160708827000	18542	9342	0	0	0
310957	1874	9479000	18542	9342	1	0	2
310958	1874	9481000	18542	9342	2	0	2
310959	1874	9484000	18542	9342	3	0	2
310960	1678	20160708828000	18543	9343	0	0	0
310962	1874	9489000	18543	9343	2	0	2
310969	1678	20160708829000	18546	9344	0	0	0
310970	1874	9491000	18546	9344	1	0	2
310971	1874	9494000	18546	9344	2	0	2
310977	1678	20160708830000	18548	9345	1	0	0
310978	1874	9497000	18548	9345	2	0	2
310979	1874	9498000	18548	9345	3	0	2
310984	1678	20160708831000	18550	9346	0	0	0
310985	1874	9500000	18550	9346	1	0	2
310987	1678	20160708833000	18551	9347	1	0	0
310988	1678	20160708834000	18551	9347	2	0	0
310989	1874	9502000	18551	9347	3	0	2
310990	1874	9504000	18551	9347	4	0	2
310991	1874	9505000	18551	9347	5	0	2
310993	1874	9510000	18551	9347	7	0	2
310994	1874	9513000	18551	9347	8	0	2
310995	1874	9516000	18551	9347	9	0	2
310996	50	66523957693786	18552	9348	0	0	0
310998	1874	9519000	18552	9348	2	0	2
310999	1874	9521000	18552	9348	3	0	2
311000	1678	20160708836000	18554	9350	0	0	0
311001	1678	20160708837000	18554	9350	1	0	0
311002	1678	20160708838000	18554	9350	2	0	0
311004	1874	9524000	18554	9350	4	0	2
311005	1874	9527000	18554	9350	5	0	2
311006	1874	9530000	18554	9350	6	0	2
311007	1874	9533000	18554	9350	7	0	2
311008	1874	9535000	18554	9350	8	0	2
311010	1874	9539000	18554	9350	10	0	2
311011	1874	9541000	18554	9350	11	0	2
311012	1874	9542000	18554	9350	12	0	2
311026	1678	20160708840000	18556	9351	0	0	0
311028	1874	9547000	18556	9351	2	0	2
311029	1874	9548000	18556	9351	3	0	2
311030	694	66523957693786	18557	9352	0	0	0
311031	1678	20160708841000	18557	9352	1	0	0
311032	1874	9550000	18557	9352	2	0	2
311034	694	66523957693786	18558	9352	0	0	\N
311035	1678	20160708841000	18558	9352	1	0	\N
311036	1874	9550000	18558	9352	2	0	\N
311037	1874	9553000	18558	9352	3	0	\N
311038	1678	20160708842000	18559	9353	0	0	\N
311039	1874	9556000	18559	9353	1	0	\N
311040	1874	9558000	18559	9353	2	0	\N
311053	1678	20160708845000	18563	9355	0	0	\N
311054	1678	20160708846000	18563	9355	1	0	\N
311055	1874	9569000	18563	9355	2	0	\N
311056	1874	9572000	18563	9355	3	0	\N
311057	1874	9574000	18563	9355	4	0	\N
311058	1126	907761861072558	18564	9356	0	0	\N
311059	1678	20160708847000	18564	9356	1	0	\N
311060	1874	9567000	18564	9356	2	0	\N
311068	1126	907761861072558	18566	9356	0	0	\N
311069	1678	20160708847000	18566	9356	1	0	\N
311070	1874	9567000	18566	9356	2	0	\N
311071	1874	9570000	18566	9356	3	0	\N
311072	1874	9573000	18566	9356	4	0	\N
311073	1874	9576000	18566	9356	5	0	\N
311074	1874	9578000	18566	9356	6	0	\N
311077	1678	20160708848000	18568	9357	0	0	\N
311078	1874	9581000	18568	9357	1	0	\N
311082	1372	1706743956489693	18571	9359	0	0	\N
311083	1678	20160708850000	18571	9359	1	0	\N
311084	1874	9587000	18571	9359	2	0	\N
311085	1874	9588000	18571	9359	3	0	\N
311091	1678	20160708851000	18577	9360	0	0	\N
311116	1678	20160708860000	18584	9366	0	0	\N
311117	1678	20160708861000	18584	9366	1	0	\N
311118	1874	9617000	18584	9366	2	0	\N
311119	1874	9618000	18584	9366	3	0	\N
311120	1678	20160708860000	18585	9366	0	0	\N
311121	1678	20160708861000	18585	9366	1	0	\N
311122	1874	9617000	18585	9366	2	0	\N
311123	1874	9618000	18585	9366	3	0	\N
311124	1678	20160708860000	18586	9366	0	0	\N
311125	1678	20160708861000	18586	9366	1	0	\N
311126	1874	9617000	18586	9366	2	0	\N
311127	1874	9618000	18586	9366	3	0	\N
311136	1678	20160708865000	18589	9369	0	0	\N
311137	1874	9631000	18589	9369	1	0	\N
311138	1678	20160708865000	18590	9369	0	0	\N
311139	1874	9631000	18590	9369	1	0	\N
311142	1678	20160708866000	18592	9370	0	0	\N
311143	1678	20160708867000	18592	9370	1	0	\N
311144	1874	9632000	18592	9370	2	0	\N
311145	1874	9635000	18592	9370	4	0	\N
311146	1874	9638000	18592	9370	5	0	\N
311147	1678	20160708866000	18593	9370	0	0	\N
311148	1678	20160708867000	18593	9370	1	0	\N
311149	1874	9632000	18593	9370	2	0	\N
311150	1874	9635000	18593	9370	4	0	\N
311151	1874	9638000	18593	9370	5	0	\N
311152	1678	20160708866000	18594	9370	0	0	\N
311153	1678	20160708867000	18594	9370	1	0	\N
311154	1874	9632000	18594	9370	2	0	\N
311155	1874	9635000	18594	9370	4	0	\N
311156	1874	9638000	18594	9370	5	0	\N
311157	1678	20160708866000	18595	9370	0	0	\N
311158	1678	20160708867000	18595	9370	1	0	\N
311159	1874	9632000	18595	9370	2	0	\N
311160	1874	9635000	18595	9370	4	0	\N
311161	1874	9638000	18595	9370	5	0	\N
311162	1678	20160708866000	18596	9370	0	0	\N
311163	1678	20160708867000	18596	9370	1	0	\N
311164	1874	9632000	18596	9370	2	0	\N
311165	1874	9635000	18596	9370	4	0	\N
311166	1874	9638000	18596	9370	5	0	\N
311167	1678	20160708866000	18597	9370	0	0	\N
311168	1678	20160708867000	18597	9370	1	0	\N
311042	1874	9556000	18560	9353	1	0	2
311043	1874	9558000	18560	9353	2	0	2
311044	1006	506565960563455	18561	9354	0	0	0
311045	1678	20160708843000	18561	9354	1	0	0
311046	1678	20160708844000	18561	9354	2	0	0
311048	1874	9562000	18561	9354	4	0	2
311049	1874	9564000	18561	9354	5	0	2
311050	1874	9566000	18561	9354	6	0	2
311051	1678	20160708845000	18562	9355	0	0	0
311052	1678	20160708846000	18562	9355	1	0	0
311062	1678	20160708847000	18565	9356	1	0	0
311063	1874	9567000	18565	9356	2	0	2
311064	1874	9570000	18565	9356	3	0	2
311065	1874	9573000	18565	9356	4	0	2
311067	1874	9578000	18565	9356	6	0	2
311075	1678	20160708848000	18567	9357	0	0	0
311076	1874	9581000	18567	9357	1	0	2
311079	1246	612485016098492	18569	9358	0	0	0
311080	1678	20160708849000	18569	9358	1	0	0
311086	1372	1706743956489693	18572	9359	0	0	0
311087	1678	20160708850000	18572	9359	1	0	0
311088	1874	9587000	18572	9359	2	0	2
311089	1874	9588000	18572	9359	3	0	2
311090	1678	20160708851000	18576	9360	0	0	0
311093	1874	9591000	18578	9361	1	0	2
311094	1678	20160708853000	18579	9362	0	0	0
311095	1678	20160708854000	18579	9362	1	0	0
311096	1874	9592000	18579	9362	2	0	2
311098	1874	9598000	18579	9362	4	0	2
311099	1678	20160708855000	18580	9363	0	0	0
311100	1874	9601000	18580	9363	1	0	2
311101	2187	200000000	18581	9364	0	0	0
311102	1678	20160708856000	18581	9364	1	0	0
311104	2152	29767163100000	18581	9364	3	0	3
311105	1678	20160708857000	18582	9365	0	0	0
311106	1678	20160708858000	18582	9365	1	0	0
311107	1678	20160708859000	18582	9365	2	0	0
311108	1874	9607000	18582	9365	3	0	2
311110	1874	9613000	18582	9365	5	0	2
311111	1874	9614000	18582	9365	6	0	2
311112	1678	20160708860000	18583	9366	0	0	0
311113	1678	20160708861000	18583	9366	1	0	0
311115	1874	9618000	18583	9366	3	0	2
311128	1678	20160708862000	18587	9367	0	0	0
311129	1874	9621000	18587	9367	1	0	2
311130	2188	200000000	18588	9368	0	0	0
311131	1678	20160708863000	18588	9368	1	0	0
311133	1874	9624000	18588	9368	3	0	2
311134	1874	9627000	18588	9368	4	0	2
311135	1874	9628000	18588	9368	5	0	2
311140	1678	20160708865000	18591	9369	0	0	0
311141	1874	9631000	18591	9369	1	0	2
311169	1874	9632000	18597	9370	2	0	\N
311170	1874	9635000	18597	9370	4	0	\N
311171	1874	9638000	18597	9370	5	0	\N
311177	1874	9632000	18599	9370	0	0	\N
311178	1678	20160708868000	18600	9371	0	0	\N
311179	1874	9641000	18600	9371	1	0	\N
311188	1678	20160708872000	18605	9375	0	0	\N
311189	1874	9651000	18605	9375	1	0	\N
311192	1678	20160708873000	18607	9376	0	0	\N
311193	1874	9654000	18607	9376	1	0	\N
311194	1678	20160708873000	18608	9376	0	0	\N
311195	1874	9654000	18608	9376	1	0	\N
311196	1678	20160708873000	18609	9376	0	0	\N
311197	1874	9654000	18609	9376	1	0	\N
311200	1678	20160708874000	18611	9377	0	0	\N
311201	1874	9657000	18611	9377	1	0	\N
311202	1874	9658000	18611	9377	2	0	\N
311206	2189	200000000	18613	9378	0	0	\N
311207	1678	20160708875000	18613	9378	1	0	\N
311208	1678	20160708876000	18613	9378	2	0	\N
311209	1678	20160708877000	18613	9378	3	0	\N
311210	1678	20160708878000	18613	9378	4	0	\N
311211	1678	20160708879000	18613	9378	5	0	\N
311212	1678	20160708880000	18613	9378	6	0	\N
311213	1678	20160708881000	18613	9378	7	0	\N
311214	1874	9659000	18613	9378	8	0	\N
311215	1874	9662000	18613	9378	9	0	\N
311216	1874	9665000	18613	9378	10	0	\N
311217	1874	9666000	18613	9378	11	0	\N
311218	1874	9669000	18613	9378	12	0	\N
311219	1874	9672000	18613	9378	13	0	\N
311220	1874	9675000	18613	9378	14	0	\N
311221	1874	9678000	18613	9378	15	0	\N
311222	1874	9681000	18613	9378	16	0	\N
311242	1678	20160708883000	18616	9380	0	0	\N
311246	1678	20160708884000	18619	9381	0	0	\N
311247	1874	9685000	18619	9381	1	0	\N
311251	1678	20160708885000	18621	9382	0	0	\N
311252	1874	9688000	18621	9382	1	0	\N
311253	1874	9691000	18621	9382	2	0	\N
311256	1678	20160708887000	18623	9384	0	0	\N
311257	1874	9697000	18623	9384	1	0	\N
311258	1874	9698000	18623	9384	2	0	\N
311269	1678	20160708891000	18627	9387	0	0	\N
311270	1678	20160708892000	18627	9387	1	0	\N
311271	1874	9710000	18627	9387	2	0	\N
311272	1874	9711000	18627	9387	3	0	\N
311273	1874	9714000	18627	9387	4	0	\N
311279	1678	20160708891000	18629	9387	0	0	\N
311280	1678	20160708892000	18629	9387	1	0	\N
311281	1874	9710000	18629	9387	2	0	\N
311282	1874	9711000	18629	9387	3	0	\N
311283	1874	9714000	18629	9387	4	0	\N
311289	1678	20160708893000	18631	9388	0	0	\N
311290	1678	20160708894000	18631	9388	1	0	\N
311291	1874	9717000	18631	9388	2	0	\N
311292	1874	9720000	18631	9388	3	0	\N
311293	1874	9721000	18631	9388	4	0	\N
311294	1678	20160708893000	18632	9388	0	0	\N
311295	1678	20160708894000	18632	9388	1	0	\N
311296	1874	9717000	18632	9388	2	0	\N
311297	1874	9720000	18632	9388	3	0	\N
311298	1874	9721000	18632	9388	4	0	\N
311303	1678	20160708897000	18634	9390	0	0	\N
311304	1678	20160708898000	18634	9390	1	0	\N
311174	1874	9632000	18598	9370	2	0	2
311175	1874	9635000	18598	9370	4	0	2
311176	1874	9638000	18598	9370	5	0	2
311180	1678	20160708868000	18601	9371	0	0	0
311181	1874	9641000	18601	9371	1	0	2
311183	1874	9644000	18602	9372	1	0	2
311184	1678	20160708870000	18603	9373	0	0	0
311185	1678	20160708871000	18604	9374	0	0	0
311186	1874	9647000	18604	9374	1	0	2
311187	1874	9648000	18604	9374	2	0	2
311191	1874	9651000	18606	9375	1	0	2
311198	1678	20160708873000	18610	9376	0	0	0
311199	1874	9654000	18610	9376	1	0	2
311203	1678	20160708874000	18612	9377	0	0	0
311205	1874	9658000	18612	9377	2	0	2
311223	2189	200000000	18614	9378	0	0	0
311224	1678	20160708875000	18614	9378	1	0	0
311225	1678	20160708876000	18614	9378	2	0	0
311226	1678	20160708877000	18614	9378	3	0	0
311228	1678	20160708879000	18614	9378	5	0	0
311229	1678	20160708880000	18614	9378	6	0	0
311230	1678	20160708881000	18614	9378	7	0	0
311231	1874	9659000	18614	9378	8	0	2
311232	1874	9662000	18614	9378	9	0	2
311234	1874	9666000	18614	9378	11	0	2
311235	1874	9669000	18614	9378	12	0	2
311236	1874	9672000	18614	9378	13	0	2
311237	1874	9675000	18614	9378	14	0	2
311239	1874	9681000	18614	9378	16	0	2
311240	1678	20160708882000	18615	9379	0	0	0
311241	1874	9684000	18615	9379	1	0	2
311243	1678	20160708883000	18617	9380	0	0	0
311244	1678	20160708884000	18618	9381	0	0	0
311248	1678	20160708885000	18620	9382	0	0	0
311249	1874	9688000	18620	9382	1	0	2
311250	1874	9691000	18620	9382	2	0	2
311254	1678	20160708886000	18622	9383	0	0	0
311255	1874	9694000	18622	9383	1	0	2
311260	1874	9697000	18624	9384	1	0	2
311261	1874	9698000	18624	9384	2	0	2
311262	1678	20160708888000	18625	9385	0	0	0
311263	1678	20160708889000	18625	9385	1	0	0
311265	1874	9701000	18625	9385	3	0	2
311266	1874	9704000	18625	9385	4	0	2
311267	1678	20160708890000	18626	9386	0	0	0
311268	1874	9707000	18626	9386	1	0	2
311274	1678	20160708891000	18628	9387	0	0	0
311276	1874	9710000	18628	9387	2	0	2
311277	1874	9711000	18628	9387	3	0	2
311278	1874	9714000	18628	9387	4	0	2
311284	1678	20160708893000	18630	9388	0	0	0
311285	1678	20160708894000	18630	9388	1	0	0
311287	1874	9720000	18630	9388	3	0	2
311288	1874	9721000	18630	9388	4	0	2
311299	1678	20160708895000	18633	9389	0	0	0
311300	1678	20160708896000	18633	9389	1	0	0
311302	1874	9727000	18633	9389	3	0	2
311305	1874	9728000	18634	9390	2	0	\N
311306	1874	9731000	18634	9390	3	0	\N
311307	1874	9734000	18634	9390	4	0	\N
311323	1361	1701353063351650	18638	9393	0	0	\N
311324	1115	904895247400000	18638	9393	1	0	\N
311325	1678	20160708903000	18638	9393	2	0	\N
311326	1874	9750000	18638	9393	3	0	\N
311338	1235	610551009200000	18641	9394	0	0	\N
311339	995	504966027800000	18641	9394	1	0	\N
311340	1678	20160708904000	18641	9394	2	0	\N
311341	1678	20160708905000	18641	9394	3	0	\N
311342	1874	9753000	18641	9394	4	0	\N
311343	1874	9756000	18641	9394	5	0	\N
311344	1874	9757000	18641	9394	6	0	\N
311345	1678	20160708906000	18642	9395	0	0	\N
311346	1874	9760000	18642	9395	1	0	\N
311347	1678	20160708906000	18643	9395	0	0	\N
311348	1874	9760000	18643	9395	1	0	\N
311349	1678	20160708906000	18644	9395	0	0	\N
311350	1874	9760000	18644	9395	1	0	\N
311353	1678	20160708906000	18646	9395	0	0	\N
311354	1874	9760000	18646	9395	1	0	\N
311355	1678	20160708907000	18647	9396	0	0	\N
311356	1678	20160708908000	18647	9396	1	0	\N
311357	1874	9763000	18647	9396	2	0	\N
311358	1874	9766000	18647	9396	3	0	\N
311359	1874	9767000	18647	9396	4	0	\N
311365	1678	20160708909000	18649	9397	0	0	\N
311366	1874	9770000	18649	9397	1	0	\N
311377	1678	20160708911000	18654	9400	0	0	\N
311378	1678	20160708912000	18654	9400	1	0	\N
311379	1874	9780000	18654	9400	2	0	\N
311380	1874	9783000	18654	9400	3	0	\N
311381	1678	20160708913000	18655	9401	0	0	\N
311382	1678	20160708914000	18655	9401	1	0	\N
311383	1874	9784000	18655	9401	2	0	\N
311384	1611	26029312550000	18655	9401	3	0	\N
311385	1874	9787000	18655	9401	4	0	\N
311386	1874	9790000	18655	9401	5	0	\N
311387	1678	20160708913000	18656	9401	0	0	\N
311388	1678	20160708914000	18656	9401	1	0	\N
311389	1874	9784000	18656	9401	2	0	\N
311390	1611	26029312550000	18656	9401	3	0	\N
311391	1874	9787000	18656	9401	4	0	\N
311392	1874	9790000	18656	9401	5	0	\N
311399	1678	20160708913000	18658	9401	0	0	\N
311400	1678	20160708914000	18658	9401	1	0	\N
311401	1874	9784000	18658	9401	2	0	\N
311402	1611	26029312550000	18658	9401	3	0	\N
311403	1874	9787000	18658	9401	4	0	\N
311404	1874	9790000	18658	9401	5	0	\N
311405	1678	20160708913000	18659	9401	0	0	\N
311406	1678	20160708914000	18659	9401	1	0	\N
311407	1874	9784000	18659	9401	2	0	\N
311408	1611	26029312550000	18659	9401	3	0	\N
311409	1874	9787000	18659	9401	4	0	\N
311410	1874	9790000	18659	9401	5	0	\N
311420	1361	1701353063351650	18663	9379	0	0	\N
311421	1115	904895247400000	18663	9379	1	0	\N
311422	1235	610551009200000	18663	9379	2	0	\N
311423	995	504966027800000	18663	9379	3	0	\N
311424	1929	1477998001	18663	9379	4	0	\N
311425	2190	1000000000	18663	9379	5	0	\N
311426	1874	9684000	18663	9379	6	0	\N
311427	1874	9687000	18663	9379	7	0	\N
311428	1874	9690000	18663	9379	8	0	\N
311429	1874	9693000	18663	9379	9	0	\N
311430	1874	9696000	18663	9379	10	0	\N
311431	1874	9699000	18663	9379	11	0	\N
311432	1874	9702000	18663	9379	12	0	\N
311433	1874	9705000	18663	9379	13	0	\N
311434	1874	9708000	18663	9379	14	0	\N
311435	1611	28071014000000	18663	9379	15	0	\N
311436	1874	9711000	18663	9379	16	0	\N
311437	1874	9714000	18663	9379	17	0	\N
311438	1874	9717000	18663	9379	18	0	\N
311439	1874	9720000	18663	9379	19	0	\N
311440	1874	9723000	18663	9379	20	0	\N
311310	1874	9728000	18635	9390	2	0	2
311311	1874	9731000	18635	9390	3	0	2
311312	1874	9734000	18635	9390	4	0	2
311313	1678	20160708899000	18636	9391	0	0	0
311314	1874	9737000	18636	9391	1	0	2
311316	1678	20160708901000	18637	9392	1	0	0
311317	1678	20160708902000	18637	9392	2	0	0
311318	1874	9740000	18637	9392	3	0	2
311319	1874	9743000	18637	9392	4	0	2
311320	1874	9744000	18637	9392	5	0	2
311322	1874	9747000	18637	9392	7	0	2
311327	1361	1701353063351650	18639	9393	0	0	0
311328	1115	904895247400000	18639	9393	1	0	0
311329	1678	20160708903000	18639	9393	2	0	0
311331	1235	610551009200000	18640	9394	0	0	0
311332	995	504966027800000	18640	9394	1	0	0
311333	1678	20160708904000	18640	9394	2	0	0
311334	1678	20160708905000	18640	9394	3	0	0
311335	1874	9753000	18640	9394	4	0	2
311337	1874	9757000	18640	9394	6	0	2
311351	1678	20160708906000	18645	9395	0	0	0
311352	1874	9760000	18645	9395	1	0	2
311360	1678	20160708907000	18648	9396	0	0	0
311361	1678	20160708908000	18648	9396	1	0	0
311363	1874	9766000	18648	9396	3	0	2
311364	1874	9767000	18648	9396	4	0	2
311367	1874	9770000	18650	9397	0	0	2
311368	1678	20160708909000	18651	9398	0	0	0
311370	1678	20160708910000	18652	9399	0	0	0
311371	1874	9776000	18652	9399	1	0	2
311372	1874	9777000	18652	9399	2	0	2
311373	1678	20160708911000	18653	9400	0	0	0
311374	1678	20160708912000	18653	9400	1	0	0
311376	1874	9783000	18653	9400	3	0	2
311393	1678	20160708913000	18657	9401	0	0	0
311394	1678	20160708914000	18657	9401	1	0	0
311395	1874	9784000	18657	9401	2	0	2
311396	1611	26029312550000	18657	9401	3	0	2
311398	1874	9790000	18657	9401	5	0	2
311411	1678	20160708915000	18660	9402	0	0	0
311412	1874	9793000	18660	9402	1	0	2
311413	1597	2157013000000	18660	9402	2	0	4
311415	1874	9796000	18661	9403	1	0	2
311416	1929	1477998001	18661	9403	2	0	1
311417	1678	20160708917000	18662	9404	0	0	0
311418	1874	9797000	18662	9404	1	0	2
311419	1874	9800000	18662	9404	2	0	2
311441	1874	9726000	18663	9379	21	0	\N
311442	1874	9729000	18663	9379	22	0	\N
311443	1874	9732000	18663	9379	23	0	\N
311444	1874	9735000	18663	9379	24	0	\N
311445	1874	9738000	18663	9379	25	0	\N
311446	1874	9741000	18663	9379	26	0	\N
311447	1874	9744000	18663	9379	27	0	\N
311448	1874	9747000	18663	9379	28	0	\N
311449	1874	9750000	18663	9379	29	0	\N
311450	1874	9753000	18663	9379	30	0	\N
311451	1874	9756000	18663	9379	31	0	\N
311452	1874	9759000	18663	9379	32	0	\N
311453	1874	9762000	18663	9379	33	0	\N
311454	1874	9765000	18663	9379	34	0	\N
311455	1874	9768000	18663	9379	35	0	\N
311456	1874	9771000	18663	9379	36	0	\N
311457	1874	9774000	18663	9379	37	0	\N
311458	1874	9777000	18663	9379	38	0	\N
311459	1874	9780000	18663	9379	39	0	\N
311460	1874	9783000	18663	9379	40	0	\N
311461	1874	9786000	18663	9379	41	0	\N
311462	1874	9789000	18663	9379	42	0	\N
311466	1678	20880720919000	18665	9406	0	0	\N
311467	1874	9806000	18665	9406	1	0	\N
311470	1678	20880720919000	18667	9406	0	0	\N
311471	1874	9806000	18667	9406	1	0	\N
311472	1678	20880720919000	18668	9406	0	0	\N
311473	1874	9806000	18668	9406	1	0	\N
311478	1678	20880720920000	18671	9407	0	0	\N
311479	2191	1000000000	18671	9407	1	0	\N
311480	1874	9809000	18671	9407	2	0	\N
311481	1874	9810000	18671	9407	3	0	\N
311482	1678	20880720920000	18672	9407	0	0	\N
311483	2191	1000000000	18672	9407	1	0	\N
311484	1874	9809000	18672	9407	2	0	\N
311485	1874	9810000	18672	9407	3	0	\N
311486	2186	100000000	18673	9276	1	0	\N
311487	2186	524057693786	18673	9276	2	0	\N
311488	50	66523957693786	18673	9276	3	0	\N
311489	694	66523957693786	18673	9276	4	0	\N
311490	1006	506565960563455	18673	9276	5	0	\N
311491	1126	907761861072558	18673	9276	6	0	\N
311492	1246	612485016098492	18673	9276	7	0	\N
311493	1372	1706743956489693	18673	9276	8	0	\N
311494	1361	1701353063351650	18673	9276	9	0	\N
311495	1115	904895247400000	18673	9276	10	0	\N
311496	1235	610551009200000	18673	9276	11	0	\N
311497	995	504966027800000	18673	9276	12	0	\N
311498	2172	200000000	18673	9276	14	0	\N
311499	2184	200000000	18673	9276	15	0	\N
311500	2185	200000000	18673	9276	16	0	\N
311501	2187	200000000	18673	9276	17	0	\N
311502	2188	200000000	18673	9276	18	0	\N
311503	2189	200000000	18673	9276	19	0	\N
311504	1678	20160708743000	18673	9276	20	0	\N
311505	1678	20160708744000	18673	9276	21	0	\N
311506	1678	20160708745000	18673	9276	22	0	\N
311507	1678	20160708746000	18673	9276	23	0	\N
311508	1678	20160708747000	18673	9276	24	0	\N
311509	1678	20160708748000	18673	9276	25	0	\N
311510	1678	20160708749000	18673	9276	26	0	\N
311511	1678	20160708750000	18673	9276	27	0	\N
311512	1678	20160708751000	18673	9276	28	0	\N
311513	1678	20160708752000	18673	9276	29	0	\N
311514	1678	20160708753000	18673	9276	30	0	\N
311515	1678	20160708754000	18673	9276	31	0	\N
311516	1678	20160708755000	18673	9276	32	0	\N
311517	1678	20160708756000	18673	9276	33	0	\N
311518	1678	20160708757000	18673	9276	34	0	\N
311519	1678	20160708758000	18673	9276	35	0	\N
311520	1678	20160708759000	18673	9276	36	0	\N
311521	1678	20160708760000	18673	9276	37	0	\N
311522	1678	20160708761000	18673	9276	38	0	\N
311523	1678	20160708762000	18673	9276	39	0	\N
311524	1678	20160708763000	18673	9276	40	0	\N
311525	1678	20160708764000	18673	9276	41	0	\N
311526	1678	20160708765000	18673	9276	42	0	\N
311527	1678	20160708766000	18673	9276	43	0	\N
311528	1678	20160708767000	18673	9276	44	0	\N
311529	1678	20160708768000	18673	9276	45	0	\N
311530	1678	20160708769000	18673	9276	46	0	\N
311531	1678	20160708770000	18673	9276	47	0	\N
311532	1678	20160708771000	18673	9276	48	0	\N
311533	1678	20160708772000	18673	9276	49	0	\N
311534	1678	20160708773000	18673	9276	50	0	\N
311535	1678	20160708774000	18673	9276	51	0	\N
311536	1678	20160708775000	18673	9276	52	0	\N
311537	1678	20160708776000	18673	9276	53	0	\N
311538	1678	20160708777000	18673	9276	54	0	\N
311539	1678	20160708778000	18673	9276	55	0	\N
311540	1678	20160708779000	18673	9276	56	0	\N
311541	1678	20160708780000	18673	9276	57	0	\N
311542	1678	20160708781000	18673	9276	58	0	\N
311543	1678	20160708782000	18673	9276	59	0	\N
311544	1678	20160708783000	18673	9276	60	0	\N
311545	1678	20160708784000	18673	9276	61	0	\N
311546	1678	20160708785000	18673	9276	62	0	\N
311547	1678	20160708786000	18673	9276	63	0	\N
311548	1678	20160708787000	18673	9276	64	0	\N
311549	1678	20160708788000	18673	9276	65	0	\N
311550	1678	20160708789000	18673	9276	66	0	\N
311551	1678	20160708790000	18673	9276	68	0	\N
311552	1678	20160708791000	18673	9276	69	0	\N
311553	1678	20160708792000	18673	9276	70	0	\N
311554	1678	20160708793000	18673	9276	71	0	\N
311555	1678	20160708794000	18673	9276	72	0	\N
311556	1678	20160708795000	18673	9276	73	0	\N
311557	1678	20160708796000	18673	9276	74	0	\N
311558	1678	20160708797000	18673	9276	75	0	\N
311559	1678	20160708798000	18673	9276	76	0	\N
311560	1678	20160708799000	18673	9276	77	0	\N
311561	1678	20160708800000	18673	9276	78	0	\N
311562	1678	20160708801000	18673	9276	79	0	\N
311563	1678	20160708802000	18673	9276	80	0	\N
311564	1678	20160708803000	18673	9276	81	0	\N
311565	1678	20160708804000	18673	9276	82	0	\N
311566	1678	20160708805000	18673	9276	83	0	\N
311567	1678	20160708806000	18673	9276	84	0	\N
311568	1678	20160708807000	18673	9276	85	0	\N
311569	1678	20160708808000	18673	9276	86	0	\N
311570	1678	20160708809000	18673	9276	87	0	\N
311571	1678	20160708810000	18673	9276	88	0	\N
311572	1678	20160708811000	18673	9276	89	0	\N
311573	1678	20160708812000	18673	9276	90	0	\N
311574	1678	20160708813000	18673	9276	91	0	\N
311575	1678	20160708814000	18673	9276	92	0	\N
311576	1678	20160708815000	18673	9276	93	0	\N
311465	2190	2150989000000	18664	9405	2	0	1
311468	1678	20880720919000	18666	9406	0	0	0
311469	1874	9806000	18666	9406	1	0	2
311474	1678	20880720920000	18670	9407	0	0	0
311475	2191	1000000000	18670	9407	1	0	0
311477	1874	9810000	18670	9407	3	0	2
311577	1678	20160708816000	18673	9276	94	0	\N
311578	1678	20160708817000	18673	9276	95	0	\N
311579	1678	20160708818000	18673	9276	96	0	\N
311580	1678	20160708819000	18673	9276	97	0	\N
311581	1678	20160708820000	18673	9276	98	0	\N
311582	1678	20160708821000	18673	9276	99	0	\N
311583	1678	20160708822000	18673	9276	100	0	\N
311584	1678	20160708823000	18673	9276	101	0	\N
311585	1678	20160708824000	18673	9276	102	0	\N
311586	1678	20160708825000	18673	9276	103	0	\N
311587	1678	20160708826000	18673	9276	104	0	\N
311588	1678	20160708827000	18673	9276	105	0	\N
311589	1678	20160708828000	18673	9276	106	0	\N
311590	1678	20160708829000	18673	9276	107	0	\N
311591	1678	20160708830000	18673	9276	108	0	\N
311592	1678	20160708831000	18673	9276	109	0	\N
311593	1678	20160708832000	18673	9276	110	0	\N
311594	1678	20160708833000	18673	9276	111	0	\N
311595	1678	20160708834000	18673	9276	112	0	\N
311596	1678	20160708835000	18673	9276	113	0	\N
311597	2192	1000000000	18674	9408	0	0	\N
311598	1678	20880720921000	18674	9408	1	0	\N
311599	1874	9813000	18674	9408	2	0	\N
311603	2192	1000000000	18676	9408	0	0	\N
311604	1678	20880720921000	18676	9408	1	0	\N
311605	1874	9813000	18676	9408	2	0	\N
311606	2192	1000000000	18677	9408	0	0	\N
311607	1874	9813000	18677	9408	1	0	\N
311627	1361	1701353063351650	18681	9372	0	0	\N
311628	1115	904895247400000	18681	9372	1	0	\N
311629	1235	610551009200000	18681	9372	2	0	\N
311630	995	504966027800000	18681	9372	3	0	\N
311631	2191	1000000000	18681	9372	4	0	\N
311632	2189	200000000	18681	9372	5	0	\N
311633	2192	1000000000	18681	9372	6	0	\N
311634	2193	1000000000	18681	9372	7	0	\N
311635	2194	1000000000	18681	9372	8	0	\N
311636	2195	1000000000	18681	9372	9	0	\N
311637	1929	1477998001	18681	9372	10	0	\N
311638	1874	9644000	18681	9372	11	0	\N
311639	1874	9647000	18681	9372	12	0	\N
311640	2190	1000000000	18681	9372	13	0	\N
311641	975	504819475450000	18681	9372	14	0	\N
311642	1874	9648000	18681	9372	15	0	\N
311643	1874	9649000	18681	9372	16	0	\N
311644	1874	9650000	18681	9372	17	0	\N
311645	2190	2151000000000	18681	9372	18	0	\N
311646	1874	9651000	18681	9372	19	0	\N
311647	1874	9654000	18681	9372	20	0	\N
311648	1874	9657000	18681	9372	21	0	\N
311649	1874	9660000	18681	9372	22	0	\N
311650	1874	9663000	18681	9372	23	0	\N
311651	1874	9666000	18681	9372	24	0	\N
311652	1874	9667000	18681	9372	25	0	\N
311653	1874	9668000	18681	9372	26	0	\N
311654	1611	26029312550000	18681	9372	27	0	\N
311655	1874	9669000	18681	9372	28	0	\N
311656	1874	9670000	18681	9372	29	0	\N
311657	1874	9671000	18681	9372	30	0	\N
311658	1874	9672000	18681	9372	31	0	\N
311659	1874	9673000	18681	9372	32	0	\N
311660	1874	9676000	18681	9372	33	0	\N
311661	1874	9679000	18681	9372	34	0	\N
311662	1874	9682000	18681	9372	35	0	\N
311663	1874	9685000	18681	9372	36	0	\N
311664	1874	9688000	18681	9372	37	0	\N
311665	1874	9691000	18681	9372	38	0	\N
311666	1874	9694000	18681	9372	39	0	\N
311667	1874	9697000	18681	9372	40	0	\N
311668	1874	9700000	18681	9372	41	0	\N
311669	1874	9703000	18681	9372	42	0	\N
311670	1874	9706000	18681	9372	43	0	\N
311671	1874	9709000	18681	9372	44	0	\N
311672	1874	9712000	18681	9372	45	0	\N
311673	1874	9715000	18681	9372	46	0	\N
311674	1874	9716000	18681	9372	47	0	\N
311675	1874	9717000	18681	9372	48	0	\N
311676	1874	9718000	18681	9372	49	0	\N
311677	1874	9719000	18681	9372	50	0	\N
311678	1874	9720000	18681	9372	51	0	\N
311679	1874	9721000	18681	9372	52	0	\N
311680	1874	9722000	18681	9372	53	0	\N
311681	1874	9725000	18681	9372	54	0	\N
311682	1874	9728000	18681	9372	55	0	\N
311683	1874	9731000	18681	9372	56	0	\N
311684	1874	9734000	18681	9372	57	0	\N
311685	1874	9737000	18681	9372	58	0	\N
311686	1874	9740000	18681	9372	59	0	\N
311687	1874	9743000	18681	9372	60	0	\N
311688	1874	9746000	18681	9372	61	0	\N
311689	1874	9749000	18681	9372	62	0	\N
311690	1874	9752000	18681	9372	63	0	\N
311691	1874	9755000	18681	9372	64	0	\N
311692	1874	9758000	18681	9372	65	0	\N
311693	1874	9761000	18681	9372	66	0	\N
311694	1874	9764000	18681	9372	67	0	\N
311695	1874	9767000	18681	9372	68	0	\N
311696	1874	9770000	18681	9372	69	0	\N
311697	1874	9773000	18681	9372	70	0	\N
311698	1874	9776000	18681	9372	71	0	\N
311699	1874	9779000	18681	9372	72	0	\N
311700	1874	9782000	18681	9372	73	0	\N
311701	1874	9785000	18681	9372	74	0	\N
311702	1874	9788000	18681	9372	75	0	\N
311703	1874	9791000	18681	9372	76	0	\N
311704	1874	9794000	18681	9372	77	0	\N
311705	1874	9797000	18681	9372	78	0	\N
311706	1874	9800000	18681	9372	79	0	\N
311707	1874	9803000	18681	9372	80	0	\N
311708	1874	9806000	18681	9372	81	0	\N
311709	1874	9809000	18681	9372	82	0	\N
311710	1874	9812000	18681	9372	83	0	\N
311711	1874	9815000	18681	9372	84	0	\N
311712	1874	9818000	18681	9372	85	0	\N
311602	1874	9813000	18675	9408	2	0	2
311608	1678	20880720922000	18678	9409	0	0	0
311609	2193	1000000000	18678	9409	1	0	0
311610	2194	1000000000	18678	9409	2	0	0
311611	2195	1000000000	18678	9409	3	0	0
311613	1678	20880720923000	18679	9410	0	0	0
311614	1874	9817000	18679	9410	1	0	2
311615	1874	9820000	18679	9410	2	0	2
311616	1678	20880720924000	18680	9411	0	0	0
311617	1678	20880720925000	18680	9411	1	0	0
311619	1678	20880720927000	18680	9411	3	0	0
311620	1678	20880720928000	18680	9411	4	0	0
311621	1874	9823000	18680	9411	5	0	2
311622	1874	9824000	18680	9411	6	0	2
311624	1874	9830000	18680	9411	8	0	2
311625	1874	9833000	18680	9411	9	0	2
311626	1874	9836000	18680	9411	10	0	2
311713	1874	9821000	18681	9372	86	0	\N
311714	1874	9824000	18681	9372	87	0	\N
311715	1874	9827000	18681	9372	88	0	\N
311716	1874	9830000	18681	9372	89	0	\N
311717	1874	9833000	18681	9372	90	0	\N
311718	1874	9836000	18681	9372	91	0	\N
311725	2196	599000000000	18683	9413	0	0	\N
311726	1874	9846000	18683	9413	1	0	\N
311727	1678	20880720931000	18684	9413	0	0	\N
311728	2196	599000000000	18684	9413	1	0	\N
311729	1874	9846000	18684	9413	2	0	\N
311733	1678	20880720932000	18686	9414	0	0	\N
311734	1874	9849000	18686	9414	2	0	\N
311735	1678	20880720932000	18687	9414	0	0	\N
311736	1874	9849000	18687	9414	2	0	\N
311737	1678	20880720932000	18688	9414	0	0	\N
311738	1874	9849000	18688	9414	2	0	\N
311746	1678	20880720932000	18692	9416	0	0	\N
311747	1678	20880720933000	18692	9416	1	0	\N
311748	1678	20880720934000	18692	9416	2	0	\N
311749	1874	9847000	18692	9416	3	0	\N
311750	1874	9850000	18692	9416	4	0	\N
311751	1874	9853000	18692	9416	5	0	\N
311752	1874	9856000	18692	9416	6	0	\N
311757	1678	20880720935000	18694	9417	0	0	\N
311758	1678	20880720936000	18694	9417	1	0	\N
311759	1874	9859000	18694	9417	2	0	\N
311760	1874	9862000	18694	9417	3	0	\N
311761	1678	20880720937000	18695	9418	0	0	\N
311762	1874	9865000	18695	9418	1	0	\N
311763	1874	9866000	18695	9418	2	0	\N
311764	1678	20880720937000	18696	9418	0	0	\N
311765	1874	9865000	18696	9418	1	0	\N
311766	1874	9866000	18696	9418	2	0	\N
311767	1678	20880720937000	18697	9418	0	0	\N
311768	1874	9865000	18697	9418	1	0	\N
311769	1874	9866000	18697	9418	2	0	\N
311773	2196	1000000000	18699	9410	0	0	\N
311774	1678	20880720923000	18699	9410	1	0	\N
311775	1678	20880720924000	18699	9410	2	0	\N
311776	1678	20880720925000	18699	9410	3	0	\N
311777	1678	20880720926000	18699	9410	4	0	\N
311778	1678	20880720927000	18699	9410	5	0	\N
311779	1678	20880720928000	18699	9410	6	0	\N
311780	1678	20880720929000	18699	9410	7	0	\N
311781	1678	20880720930000	18699	9410	8	0	\N
311782	1678	20880720931000	18699	9410	9	0	\N
311783	1678	20880720932000	18699	9410	10	0	\N
311784	1678	20880720933000	18699	9410	11	0	\N
311785	1678	20880720934000	18699	9410	12	0	\N
311786	1678	20880720935000	18699	9410	13	0	\N
311787	1678	20880720936000	18699	9410	14	0	\N
311788	1678	20880720937000	18699	9410	15	0	\N
311789	2196	599000000000	18699	9410	16	0	\N
311790	1874	9817000	18699	9410	17	0	\N
311791	1874	9818000	18699	9410	18	0	\N
311792	1874	9819000	18699	9410	19	0	\N
311793	1874	9820000	18699	9410	20	0	\N
311794	1874	9821000	18699	9410	21	0	\N
311795	1874	9824000	18699	9410	22	0	\N
311796	1874	9827000	18699	9410	23	0	\N
311797	1874	9830000	18699	9410	24	0	\N
311798	1874	9833000	18699	9410	25	0	\N
311799	1874	9836000	18699	9410	26	0	\N
311800	1874	9839000	18699	9410	27	0	\N
311801	1874	9842000	18699	9410	28	0	\N
311802	1874	9845000	18699	9410	29	0	\N
311803	1874	9848000	18699	9410	30	0	\N
311804	1874	9851000	18699	9410	31	0	\N
311805	1874	9854000	18699	9410	33	0	\N
311806	1874	9857000	18699	9410	34	0	\N
311807	1874	9860000	18699	9410	35	0	\N
311808	1874	9863000	18699	9410	36	0	\N
311809	1874	9866000	18699	9410	37	0	\N
311810	1678	20880720938000	18700	9419	0	0	\N
311811	1678	20880720939000	18700	9419	1	0	\N
311812	1874	9869000	18700	9419	2	0	\N
311813	1874	9872000	18700	9419	3	0	\N
311825	1678	20880720943000	18704	9422	0	0	\N
311826	1874	9885000	18704	9422	1	0	\N
311827	1678	20880720943000	18705	9422	0	0	\N
311828	1874	9885000	18705	9422	1	0	\N
311844	1678	20880720949000	18710	9425	0	0	\N
311845	2186	524057693786	18711	9300	0	0	\N
311846	50	66523957693786	18711	9300	1	0	\N
311847	694	66523957693786	18711	9300	2	0	\N
311848	1006	506565960563455	18711	9300	3	0	\N
311721	1678	20880720930000	18682	9412	2	0	0
311722	1874	9839000	18682	9412	3	0	2
311723	1874	9842000	18682	9412	4	0	2
311724	1874	9843000	18682	9412	5	0	2
311730	1678	20880720931000	18685	9413	0	0	0
311732	1874	9846000	18685	9413	2	0	2
311739	1678	20880720932000	18691	9416	0	0	0
311740	1678	20880720933000	18691	9416	1	0	0
311741	1678	20880720934000	18691	9416	2	0	0
311742	1874	9847000	18691	9416	3	0	2
311744	1874	9853000	18691	9416	5	0	2
311745	1874	9856000	18691	9416	6	0	2
311753	1678	20880720935000	18693	9417	0	0	0
311754	1678	20880720936000	18693	9417	1	0	0
311756	1874	9862000	18693	9417	3	0	2
311770	1678	20880720937000	18698	9418	0	0	0
311771	1874	9865000	18698	9418	1	0	2
311772	1874	9866000	18698	9418	2	0	2
311814	1678	20880720938000	18701	9419	0	0	0
311816	1874	9869000	18701	9419	2	0	2
311817	1874	9872000	18701	9419	3	0	2
311818	1678	20880720940000	18702	9420	0	0	0
311819	1678	20880720941000	18702	9420	1	0	0
311820	1874	9875000	18702	9420	2	0	2
311822	1874	9879000	18702	9420	4	0	2
311823	1678	20880720942000	18703	9421	0	0	0
311824	1874	9882000	18703	9421	1	0	2
311829	1678	20880720943000	18706	9422	0	0	0
311831	1678	20880720944000	18707	9423	0	0	0
311832	1678	20880720945000	18707	9423	1	0	0
311833	1678	20880720946000	18707	9423	2	0	0
311834	1874	9886000	18707	9423	3	0	2
311835	1874	9889000	18707	9423	4	0	2
311837	1874	9895000	18707	9423	6	0	2
311838	1678	20880720947000	18708	9424	0	0	0
311839	1678	20880720948000	18708	9424	1	0	0
311840	1874	9898000	18708	9424	2	0	2
311841	1874	9901000	18708	9424	3	0	2
311843	1678	20880720949000	18709	9425	0	0	0
311849	1126	907761861072558	18711	9300	4	0	\N
311850	1246	612485016098492	18711	9300	5	0	\N
311851	1372	1706743956489693	18711	9300	6	0	\N
311852	1361	1701353063351650	18711	9300	7	0	\N
311853	1115	904895247400000	18711	9300	8	0	\N
311854	1235	610551009200000	18711	9300	9	0	\N
311855	995	504966027800000	18711	9300	10	0	\N
311856	2196	1000000000	18711	9300	11	0	\N
311857	2187	200000000	18711	9300	12	0	\N
311858	2191	1000000000	18711	9300	13	0	\N
311859	2188	200000000	18711	9300	14	0	\N
311860	2189	200000000	18711	9300	15	0	\N
311861	2192	1000000000	18711	9300	16	0	\N
311862	2193	1000000000	18711	9300	17	0	\N
311863	2194	1000000000	18711	9300	18	0	\N
311864	2195	1000000000	18711	9300	19	0	\N
311865	2196	599000000000	18711	9300	20	0	\N
311866	1929	1477998001	18711	9300	21	0	\N
311867	2190	1000000000	18711	9300	22	0	\N
311868	975	504819475450000	18711	9300	23	0	\N
311869	2190	2151000000000	18711	9300	24	0	\N
311870	1611	26029312550000	18711	9300	25	0	\N
311871	2152	29767163100000	18711	9300	26	0	\N
311882	1678	20880720950000	18713	9426	0	0	\N
311883	1678	20880720951000	18713	9426	1	0	\N
311884	1678	20880720952000	18713	9426	2	0	\N
311885	1678	20880720953000	18713	9426	3	0	\N
311886	1874	9903000	18713	9426	4	0	\N
311887	1874	9906000	18713	9426	5	0	\N
311888	1597	7012000000	18713	9426	6	0	\N
311889	1874	9909000	18713	9426	7	0	\N
311890	1874	9912000	18713	9426	8	0	\N
311891	1874	9915000	18713	9426	9	0	\N
311899	1678	20880720956000	18717	9429	0	0	\N
311900	1874	9925000	18717	9429	1	0	\N
311910	1678	20880720961000	18721	9433	0	0	\N
311911	1874	9939000	18721	9433	1	0	\N
311912	1874	9942000	18721	9433	2	0	\N
311922	1678	20880720964000	18724	9435	0	0	\N
311923	1874	9951000	18724	9435	1	0	\N
311924	1874	9952000	18724	9435	2	0	\N
311925	1678	20880720964000	18725	9435	0	0	\N
311926	1874	9951000	18725	9435	1	0	\N
311927	1874	9952000	18725	9435	2	0	\N
311933	1678	20880720965000	18728	9436	0	0	\N
311934	1874	9955000	18728	9436	1	0	\N
311937	1678	20880720967000	18731	9439	0	0	\N
311938	1678	20880720968000	18731	9439	1	0	\N
311939	1874	9959000	18731	9439	2	0	\N
311940	1874	9962000	18731	9439	3	0	\N
311941	1874	9965000	18731	9439	4	0	\N
311951	1678	20880720971000	18734	9441	0	0	\N
311952	1678	20880720972000	18734	9441	1	0	\N
311953	1678	20880720973000	18734	9441	2	0	\N
311954	1874	9972000	18734	9441	3	0	\N
311955	1874	9975000	18734	9441	4	0	\N
311956	1874	9978000	18734	9441	5	0	\N
311957	1874	9981000	18734	9441	6	0	\N
311958	1678	20880720971000	18735	9441	0	0	\N
311959	1678	20880720972000	18735	9441	1	0	\N
311960	1678	20880720973000	18735	9441	2	0	\N
311968	1678	20880720971000	18737	9441	0	0	\N
311969	1678	20880720972000	18737	9441	1	0	\N
311970	1678	20880720973000	18737	9441	2	0	\N
311971	1874	9972000	18737	9441	3	0	\N
311972	1874	9975000	18737	9441	4	0	\N
311973	1874	9978000	18737	9441	5	0	\N
311974	1874	9981000	18737	9441	6	0	\N
311979	1678	20880720974000	18739	9442	0	0	\N
311980	1874	9982000	18739	9442	1	0	\N
311981	756	1006450000000	18739	9442	2	0	\N
311982	1874	9985000	18739	9442	3	0	\N
311983	1678	20880720974000	18740	9442	0	0	\N
311984	1874	9982000	18740	9442	1	0	\N
311874	1678	20880720952000	18712	9426	2	0	0
311875	1678	20880720953000	18712	9426	3	0	0
311876	1874	9903000	18712	9426	4	0	2
311877	1874	9906000	18712	9426	5	0	2
311878	1597	7012000000	18712	9426	6	0	5
311880	1874	9912000	18712	9426	8	0	2
311881	1874	9915000	18712	9426	9	0	2
311892	1678	20880720954000	18714	9427	0	0	0
311893	1874	9918000	18714	9427	1	0	2
311894	1874	9919000	18714	9427	2	0	2
311896	1874	9922000	18715	9428	1	0	2
311897	1678	20880720956000	18716	9429	0	0	0
311898	1874	9925000	18716	9429	1	0	2
311901	1678	20880720957000	18718	9430	0	0	0
311903	1874	9929000	18718	9430	2	0	2
311904	1678	20880720958000	18719	9431	0	0	0
311905	1678	20880720959000	18719	9431	1	0	0
311906	1874	9932000	18719	9431	2	0	2
311907	1874	9935000	18719	9431	3	0	2
311909	1874	9938000	18720	9432	1	0	2
311913	1678	20880720961000	18722	9433	0	0	0
311914	1874	9939000	18722	9433	1	0	2
311915	1874	9942000	18722	9433	2	0	2
311916	1678	20880720962000	18723	9434	0	0	0
311918	2157	1200001999	18723	9434	2	0	22
311919	2197	200000000	18723	9434	3	0	0
311920	1874	9945000	18723	9434	4	0	2
311921	1874	9948000	18723	9434	5	0	2
311929	1874	9951000	18726	9435	1	0	2
311930	1874	9952000	18726	9435	2	0	2
311931	1678	20880720965000	18727	9436	0	0	0
311932	1874	9955000	18727	9436	1	0	2
311935	1678	20880720966000	18729	9437	0	0	0
311942	1678	20880720967000	18732	9439	0	0	0
311943	1678	20880720968000	18732	9439	1	0	0
311944	1874	9959000	18732	9439	2	0	2
311945	1874	9962000	18732	9439	3	0	2
311946	1874	9965000	18732	9439	4	0	2
311948	1678	20880720970000	18733	9440	1	0	0
311949	1874	9968000	18733	9440	2	0	2
311950	1874	9971000	18733	9440	3	0	2
311961	1678	20880720971000	18736	9441	0	0	0
311963	1678	20880720973000	18736	9441	2	0	0
311964	1874	9972000	18736	9441	3	0	2
311965	1874	9975000	18736	9441	4	0	2
311966	1874	9978000	18736	9441	5	0	2
311967	1874	9981000	18736	9441	6	0	2
311976	1874	9982000	18738	9442	1	0	2
311977	756	1006450000000	18738	9442	2	0	0
311978	1874	9985000	18738	9442	3	0	2
311985	756	1006450000000	18740	9442	2	0	\N
311995	1678	20880720977000	18743	9444	0	0	\N
311996	1821	610489000000	18743	9444	1	0	\N
311997	1874	9994000	18743	9444	2	0	\N
311998	1821	612393000000	18743	9444	3	0	\N
312011	2196	1212000000000	18748	9437	0	0	\N
312012	1821	610990000000	18748	9437	1	0	\N
312013	1874	9956000	18748	9437	2	0	\N
312025	2198	200000000	18753	9453	0	0	\N
312026	1678	20880720988000	18753	9453	1	0	\N
312027	1874	10028000	18753	9453	2	0	\N
312028	1874	10031000	18753	9453	3	0	\N
312033	1678	20880720989000	18755	9454	0	0	\N
312034	1874	10034000	18755	9454	1	0	\N
312037	1678	20880720990000	18757	9455	0	0	\N
312038	1874	10037000	18757	9455	1	0	\N
312044	1678	20880720992000	18760	9457	0	0	\N
312045	2152	34767163100000	18760	9457	1	0	\N
312046	1874	10044000	18760	9457	2	0	\N
312047	1678	20880720992000	18761	9457	0	0	\N
312048	2152	34767163100000	18761	9457	1	0	\N
312049	1874	10044000	18761	9457	2	0	\N
312050	1678	20880720992000	18762	9457	0	0	\N
312051	2152	34767163100000	18762	9457	1	0	\N
312052	1874	10044000	18762	9457	2	0	\N
312053	1678	20880720992000	18763	9457	0	0	\N
312054	2152	34767163100000	18763	9457	1	0	\N
312055	1874	10044000	18763	9457	2	0	\N
312056	1678	20880720992000	18764	9457	0	0	\N
312057	2152	34767163100000	18764	9457	1	0	\N
312058	1874	10044000	18764	9457	2	0	\N
312064	1678	20880720993000	18767	9458	1	0	\N
312065	1874	10047000	18767	9458	2	0	\N
312066	1678	20880720994000	18768	9459	0	0	\N
312067	1874	10050000	18768	9459	1	0	\N
312068	1678	20880720994000	18769	9459	0	0	\N
312069	1874	10050000	18769	9459	1	0	\N
312072	1678	20880720994000	18771	9459	0	0	\N
312073	1874	10050000	18771	9459	1	0	\N
312077	1678	20880720996000	18773	9461	0	0	\N
312078	1874	10057000	18773	9461	1	0	\N
312081	1678	20880720996000	18775	9461	0	0	\N
312082	1874	10057000	18775	9461	1	0	\N
312096	1678	20880721001000	18778	9463	0	0	\N
312097	1874	10071000	18778	9463	1	0	\N
312098	1874	10074000	18778	9463	2	0	\N
312099	1678	20880721001000	18779	9463	0	0	\N
312100	1874	10071000	18779	9463	1	0	\N
312101	1874	10074000	18779	9463	2	0	\N
312102	1678	20880721002000	18780	9464	0	0	\N
312103	1874	10077000	18780	9464	1	0	\N
312104	1678	20880721002000	18781	9464	0	0	\N
312105	1874	10077000	18781	9464	1	0	\N
312111	1678	20880721003000	18784	9465	0	0	\N
312112	1874	10080000	18784	9465	1	0	\N
312113	1874	10083000	18784	9465	2	0	\N
312119	1678	20880721004000	18786	9466	0	0	\N
312120	1678	20880721005000	18786	9466	1	0	\N
311988	2196	1212000000000	18741	9443	2	0	0
311989	1874	9988000	18741	9443	3	0	2
311990	1874	9991000	18741	9443	4	0	2
311991	1678	20880720977000	18742	9444	0	0	0
311992	1821	610489000000	18742	9444	1	0	2
311994	1821	612393000000	18742	9444	3	0	2
311999	1678	20880720978000	18744	9445	0	0	0
312000	1874	9997000	18744	9445	1	0	2
312001	1874	9998000	18744	9445	2	0	2
312002	1678	20880720979000	18745	9446	0	0	0
312004	1678	20880720980000	18746	9447	0	0	0
312005	1874	10004000	18746	9447	1	0	2
312006	1678	20880720981000	18747	9448	0	0	0
312007	1678	20880720982000	18747	9448	1	0	0
312009	1874	10010000	18747	9448	3	0	2
312010	1874	10011000	18747	9448	4	0	2
312014	1678	20880720983000	18749	9449	0	0	0
312015	1874	10014000	18749	9449	1	0	2
312016	1678	20880720984000	18750	9450	0	0	0
312018	1874	10017000	18750	9450	2	0	2
312019	1874	10020000	18750	9450	3	0	2
312020	1874	10021000	18750	9450	4	0	2
312021	1678	20880720986000	18751	9451	0	0	0
312022	1874	10024000	18751	9451	1	0	2
312024	1874	10027000	18752	9452	1	0	2
312029	2198	200000000	18754	9453	0	0	0
312030	1678	20880720988000	18754	9453	1	0	0
312031	1874	10028000	18754	9453	2	0	2
312035	1678	20880720989000	18756	9454	0	0	0
312036	1874	10034000	18756	9454	1	0	2
312039	1678	20880720990000	18758	9455	0	0	0
312040	1874	10037000	18758	9455	1	0	2
312041	1678	20880720991000	18759	9456	0	0	0
312043	1874	10041000	18759	9456	2	0	2
312059	1678	20880720992000	18765	9457	0	0	0
312060	2152	34767163100000	18765	9457	1	0	3
312061	1874	10044000	18765	9457	2	0	2
312062	1678	20880720993000	18766	9458	1	0	0
312070	1678	20880720994000	18770	9459	0	0	0
312071	1874	10050000	18770	9459	1	0	2
312074	1678	20880720995000	18772	9460	0	0	0
312075	1874	10051000	18772	9460	1	0	2
312079	1678	20880720996000	18774	9461	0	0	0
312080	1874	10057000	18774	9461	1	0	2
312083	1678	20880720997000	18776	9462	0	0	0
312084	1678	20880720998000	18776	9462	1	0	0
312085	1678	20880720999000	18776	9462	2	0	0
312087	2152	40000000000000	18776	9462	4	0	3
312088	1874	10058000	18776	9462	6	0	2
312089	1874	10061000	18776	9462	7	0	2
312090	1874	10064000	18776	9462	8	0	2
312091	1874	10067000	18776	9462	9	0	2
312093	1678	20880721001000	18777	9463	0	0	0
312094	1874	10071000	18777	9463	1	0	2
312095	1874	10074000	18777	9463	2	0	2
312106	1678	20880721002000	18782	9464	0	0	0
312108	1678	20880721003000	18783	9465	0	0	0
312109	1874	10080000	18783	9465	1	0	2
312110	1874	10083000	18783	9465	2	0	2
312114	1678	20880721004000	18785	9466	0	0	0
312115	1678	20880721005000	18785	9466	1	0	0
312117	1874	10087000	18785	9466	3	0	2
312118	1874	10090000	18785	9466	4	0	2
312121	1874	10084000	18786	9466	2	0	\N
312122	1874	10087000	18786	9466	3	0	\N
312123	1874	10090000	18786	9466	4	0	\N
312131	1678	20880721007000	18789	9468	0	0	\N
312132	1678	20880721008000	18789	9468	1	0	\N
312133	1874	10096000	18789	9468	2	0	\N
312134	1874	10099000	18789	9468	3	0	\N
312135	1874	10100000	18789	9468	4	0	\N
312136	1874	10096000	18790	9468	0	0	\N
312137	1874	10099000	18790	9468	1	0	\N
312138	1874	10100000	18790	9468	2	0	\N
312139	1678	20880721009000	18791	9469	0	0	\N
312140	1874	10103000	18791	9469	1	0	\N
312143	266	66003928193897	18793	9470	0	0	\N
312144	1678	20880721010000	18793	9470	1	0	\N
312145	1678	20880721011000	18793	9470	2	0	\N
312146	1874	10106000	18793	9470	3	0	\N
312147	1874	10109000	18793	9470	4	0	\N
312148	1874	10110000	18793	9470	5	0	\N
312169	1678	20880721017000	18797	9472	0	0	\N
312170	1874	10129000	18797	9472	1	0	\N
312171	1874	10130000	18797	9472	2	0	\N
312172	1678	20880721017000	18798	9472	0	0	\N
312173	1874	10129000	18798	9472	1	0	\N
312174	1874	10130000	18798	9472	2	0	\N
312175	1678	20880721017000	18799	9472	0	0	\N
312176	1874	10129000	18799	9472	1	0	\N
312177	1874	10130000	18799	9472	2	0	\N
312187	1678	20880721020000	18803	9475	0	0	\N
312188	1678	20880721021000	18803	9475	1	0	\N
312189	1874	10139000	18803	9475	2	0	\N
312190	1874	10142000	18803	9475	3	0	\N
312191	1874	10143000	18803	9475	4	0	\N
312196	1678	20880721024000	18806	9478	0	0	\N
312197	1874	10150000	18806	9478	1	0	\N
312198	1874	10153000	18806	9478	2	0	\N
312202	1678	20880721024000	18808	9478	0	0	\N
312203	1874	10150000	18808	9478	1	0	\N
312204	1874	10153000	18808	9478	2	0	\N
312205	1678	20880721025000	18809	9479	0	0	\N
312206	1874	10156000	18809	9479	1	0	\N
312209	1678	20880721025000	18811	9479	0	0	\N
312210	1874	10156000	18811	9479	1	0	\N
312211	1678	20880721026000	18812	9480	0	0	\N
312212	1678	20880721027000	18812	9480	1	0	\N
312213	1678	20880721028000	18812	9480	2	0	\N
312214	1874	10159000	18812	9480	3	0	\N
312215	1874	10160000	18812	9480	4	0	\N
312216	1678	20880721026000	18813	9480	0	0	\N
312217	1678	20880721027000	18813	9480	1	0	\N
312218	1678	20880721028000	18813	9480	2	0	\N
312219	1874	10159000	18813	9480	3	0	\N
312220	1874	10160000	18813	9480	4	0	\N
312227	1678	20880721030000	18816	9482	0	0	\N
312231	1678	20880721032000	18820	9484	0	0	\N
312234	1678	20880721034000	18823	9486	0	0	\N
312235	1874	10162000	18823	9486	1	0	\N
312238	1678	20880721034000	18825	9486	0	0	\N
312239	1874	10162000	18825	9486	1	0	\N
312241	1678	20880721036000	18827	9488	0	0	\N
312242	1678	20880721036000	18828	9488	0	0	\N
312243	1678	20880721036000	18829	9488	0	0	\N
312253	1678	20880721043000	18836	9494	0	0	\N
312126	1678	20880721007000	18788	9468	0	0	0
312127	1678	20880721008000	18788	9468	1	0	0
312128	1874	10096000	18788	9468	2	0	2
312129	1874	10099000	18788	9468	3	0	2
312130	1874	10100000	18788	9468	4	0	2
312142	1874	10103000	18792	9469	1	0	2
312149	266	66003928193897	18794	9470	0	0	1
312150	1678	20880721010000	18794	9470	1	0	0
312151	1678	20880721011000	18794	9470	2	0	0
312152	1874	10106000	18794	9470	3	0	2
312154	1874	10110000	18794	9470	5	0	2
312155	1678	20880721012000	18795	9471	0	0	0
312156	1678	20880721013000	18795	9471	1	0	0
312157	1678	20880721014000	18795	9471	2	0	0
312159	1678	20880721016000	18795	9471	4	0	0
312160	1874	10111000	18795	9471	5	0	2
312161	1874	10114000	18795	9471	6	0	2
312162	1874	10117000	18795	9471	7	0	2
312163	1874	10120000	18795	9471	8	0	2
312165	1874	10126000	18795	9471	10	0	2
312166	1678	20880721017000	18796	9472	0	0	0
312167	1874	10129000	18796	9472	1	0	2
312168	1874	10130000	18796	9472	2	0	2
312178	1678	20880721018000	18800	9473	0	0	0
312180	1678	20880721019000	18801	9474	0	0	0
312181	1874	10136000	18801	9474	1	0	2
312182	1678	20880721020000	18802	9475	0	0	0
312183	1678	20880721021000	18802	9475	1	0	0
312185	1874	10142000	18802	9475	3	0	2
312186	1874	10143000	18802	9475	4	0	2
312192	1678	20880721022000	18804	9476	0	0	0
312193	1874	10146000	18804	9476	1	0	2
312194	1678	20880721023000	18805	9477	0	0	0
312199	1678	20880721024000	18807	9478	0	0	0
312200	1874	10150000	18807	9478	1	0	2
312201	1874	10153000	18807	9478	2	0	2
312207	1678	20880721025000	18810	9479	0	0	0
312208	1874	10156000	18810	9479	1	0	2
312222	1678	20880721027000	18814	9480	1	0	0
312223	1678	20880721028000	18814	9480	2	0	0
312224	1874	10159000	18814	9480	3	0	2
312225	1874	10160000	18814	9480	4	0	2
312228	1678	20880721030000	18817	9482	0	0	0
312229	1678	20880721031000	18818	9483	0	0	0
312230	1874	10161000	18818	9483	1	0	2
312232	1678	20880721032000	18821	9484	0	0	0
312233	1678	20880721033000	18822	9485	0	0	0
312237	1874	10162000	18824	9486	1	0	2
312240	1678	20880721035000	18826	9487	0	0	0
312244	1678	20880721036000	18830	9488	0	0	0
312245	1678	20880721037000	18831	9489	0	0	0
312246	1678	20880721038000	18831	9489	1	0	0
312248	1678	20880721039000	18832	9490	0	0	0
312249	1678	20880721040000	18833	9491	0	0	0
312250	1678	20880721041000	18834	9492	0	0	0
312251	1874	10164000	18834	9492	1	0	2
312254	1678	20880721043000	18837	9494	0	0	0
312255	1678	20880721044000	18838	9495	0	0	0
312256	1678	20880721045000	18838	9495	1	0	0
312258	1678	20880721046000	18839	9496	0	0	\N
312271	1678	20880721053000	18846	9501	0	0	\N
312272	1678	20880721054000	18846	9501	1	0	\N
312273	1874	10168000	18846	9501	2	0	\N
312278	1678	20880721058000	18850	9505	0	0	\N
312279	1678	20880721058000	18851	9505	0	0	\N
312280	1678	20880721058000	18852	9505	0	0	\N
312282	1678	20880721058000	18854	9505	0	0	\N
312288	1678	20880721063000	18858	9509	0	0	\N
312293	1678	20880721064000	18861	9510	0	0	\N
312294	1678	20880721065000	18861	9510	1	0	\N
312295	1874	10171000	18861	9510	2	0	\N
312296	1678	20880721066000	18862	9511	0	0	\N
312297	1874	10172000	18862	9511	1	0	\N
312302	1678	20880721067000	18865	9512	0	0	\N
312303	1678	20880721068000	18865	9512	1	0	\N
312308	1678	20880721072000	18869	9516	0	0	\N
312309	1678	20880721073000	18869	9516	1	0	\N
312310	1874	10174000	18869	9516	2	0	\N
312311	1678	20880721072000	18870	9516	0	0	\N
312312	1678	20880721073000	18870	9516	1	0	\N
312313	1874	10174000	18870	9516	2	0	\N
312318	1678	20880721075000	18873	9518	0	0	\N
312319	1678	20880721075000	18874	9518	0	0	\N
312320	1678	20880721075000	18875	9518	0	0	\N
312321	1678	20880721024000	18876	9478	0	0	\N
312322	1678	20880721025000	18876	9478	1	0	\N
312323	1678	20880721026000	18876	9478	2	0	\N
312324	1678	20880721027000	18876	9478	3	0	\N
312325	1678	20880721028000	18876	9478	4	0	\N
312326	1678	20880721029000	18876	9478	5	0	\N
312327	1678	20880721030000	18876	9478	6	0	\N
312328	1678	20880721031000	18876	9478	7	0	\N
312329	1678	20880721032000	18876	9478	8	0	\N
312330	1678	20880721033000	18876	9478	9	0	\N
312331	1678	20880721034000	18876	9478	10	0	\N
312332	1678	20880721035000	18876	9478	11	0	\N
312333	1678	20880721036000	18876	9478	12	0	\N
312334	1678	20880721037000	18876	9478	13	0	\N
312335	1678	20880721038000	18876	9478	14	0	\N
312336	1678	20880721039000	18876	9478	15	0	\N
312337	1678	20880721040000	18876	9478	16	0	\N
312338	1678	20880721041000	18876	9478	17	0	\N
312339	1678	20880721042000	18876	9478	18	0	\N
312340	1678	20880721043000	18876	9478	19	0	\N
312341	1678	20880721044000	18876	9478	20	0	\N
312342	1678	20880721045000	18876	9478	21	0	\N
312343	1678	20880721046000	18876	9478	22	0	\N
312344	1678	20880721047000	18876	9478	23	0	\N
312345	1678	20880721048000	18876	9478	24	0	\N
312346	1678	20880721049000	18876	9478	25	0	\N
312347	1678	20880721050000	18876	9478	26	0	\N
312348	1678	20880721051000	18876	9478	27	0	\N
312349	1678	20880721052000	18876	9478	28	0	\N
312350	1678	20880721053000	18876	9478	29	0	\N
312351	1678	20880721054000	18876	9478	30	0	\N
312352	1678	20880721055000	18876	9478	31	0	\N
312353	1678	20880721056000	18876	9478	32	0	\N
312354	1678	20880721057000	18876	9478	33	0	\N
312355	1678	20880721058000	18876	9478	34	0	\N
312356	1678	20880721059000	18876	9478	36	0	\N
312357	1678	20880721060000	18876	9478	37	0	\N
312358	1678	20880721061000	18876	9478	38	0	\N
312359	1678	20880721062000	18876	9478	39	0	\N
312360	1678	20880721063000	18876	9478	40	0	\N
312361	1678	20880721064000	18876	9478	41	0	\N
312362	1678	20880721065000	18876	9478	42	0	\N
312363	1678	20880721066000	18876	9478	43	0	\N
312364	1678	20880721067000	18876	9478	44	0	\N
312365	1678	20880721068000	18876	9478	45	0	\N
312366	1678	20880721069000	18876	9478	46	0	\N
312367	1678	20880721070000	18876	9478	47	0	\N
312368	1678	20880721071000	18876	9478	48	0	\N
312369	1678	20880721072000	18876	9478	49	0	\N
312370	1678	20880721073000	18876	9478	50	0	\N
312371	1678	20880721074000	18876	9478	51	0	\N
312372	1678	20880721075000	18876	9478	52	0	\N
312373	1874	10150000	18876	9478	53	0	\N
312374	1874	10153000	18876	9478	54	0	\N
312375	1874	10154000	18876	9478	55	0	\N
312376	1874	10155000	18876	9478	56	0	\N
312377	1874	10156000	18876	9478	57	0	\N
312378	1874	10157000	18876	9478	58	0	\N
312379	1874	10158000	18876	9478	59	0	\N
312380	1874	10159000	18876	9478	60	0	\N
312381	1874	10160000	18876	9478	61	0	\N
312382	1874	10161000	18876	9478	62	0	\N
312383	1874	10162000	18876	9478	63	0	\N
312384	1874	10163000	18876	9478	64	0	\N
312385	1874	10166000	18876	9478	65	0	\N
312386	1874	10169000	18876	9478	66	0	\N
312387	1874	10170000	18876	9478	67	0	\N
312388	1874	10171000	18876	9478	68	0	\N
312389	1874	10172000	18876	9478	69	0	\N
312390	1874	10173000	18876	9478	70	0	\N
312391	1874	10174000	18876	9478	71	0	\N
312260	1678	20880721047000	18841	9497	0	0	0
312261	1874	10166000	18841	9497	1	0	2
312262	1678	20880721048000	18842	9498	0	0	0
312263	1678	20880721049000	18842	9498	1	0	0
312264	1678	20880721050000	18843	9499	0	0	0
312266	1874	10167000	18843	9499	2	0	2
312267	1678	20880721052000	18844	9500	0	0	0
312268	1678	20880721053000	18845	9501	0	0	0
312269	1678	20880721054000	18845	9501	1	0	0
312270	1874	10168000	18845	9501	2	0	2
312275	1678	20880721056000	18848	9503	0	0	0
312276	1678	20880721057000	18849	9504	0	0	0
312277	1874	10169000	18849	9504	1	0	2
312281	1678	20880721058000	18853	9505	0	0	0
312284	1678	20880721060000	18855	9506	1	0	0
312285	1678	20880721061000	18856	9507	0	0	0
312286	1874	10170000	18856	9507	1	0	2
312287	1678	20880721062000	18857	9508	0	0	0
312289	1678	20880721063000	18859	9509	0	0	0
312291	1678	20880721065000	18860	9510	1	0	0
312292	1874	10171000	18860	9510	2	0	2
312298	1678	20880721066000	18863	9511	0	0	0
312299	1874	10172000	18863	9511	1	0	2
312300	1678	20880721067000	18864	9512	0	0	0
312304	1678	20880721069000	18866	9513	0	0	0
312305	1678	20880721070000	18867	9514	0	0	0
312306	1874	10173000	18867	9514	1	0	2
312307	1678	20880721071000	18868	9515	0	0	0
312315	1678	20880721073000	18871	9516	1	0	0
312316	1874	10174000	18871	9516	2	0	2
312317	1678	20880721074000	18872	9517	0	0	0
312392	1678	20880721075000	18877	9518	0	0	0
312401	1678	20880721082000	18883	9524	0	0	\N
312410	1678	20880721088000	18889	9529	0	0	\N
312411	1678	20880721089000	18889	9529	1	0	\N
312416	1678	20880721090000	18892	9530	0	0	\N
312417	1874	10179000	18892	9530	1	0	\N
312418	1678	20880721090000	18893	9530	0	0	\N
312419	1874	10179000	18893	9530	1	0	\N
312420	1678	20880721090000	18894	9530	0	0	\N
312421	1874	10179000	18894	9530	1	0	\N
312422	1678	20880721090000	18895	9530	0	0	\N
312423	1874	10179000	18895	9530	1	0	\N
312424	1678	20880721088000	18896	9529	0	0	\N
312425	1678	20880721089000	18896	9529	1	0	\N
312426	1678	20880721090000	18896	9529	2	0	\N
312427	1874	10179000	18896	9529	3	0	\N
312430	1678	20880721093000	18899	9533	0	0	\N
312431	1874	10180000	18899	9533	1	0	\N
312435	2186	100000000	18902	9287	1	0	\N
312436	2186	524057693786	18902	9287	2	0	\N
312437	50	66523957693786	18902	9287	3	0	\N
312438	694	66523957693786	18902	9287	4	0	\N
312439	1006	506565960563455	18902	9287	5	0	\N
312443	1678	20880721094000	18904	9534	0	0	\N
312444	1678	20880721095000	18904	9534	1	0	\N
312445	1678	20880721096000	18904	9534	2	0	\N
312446	1874	10181000	18904	9534	3	0	\N
312447	1678	20880721097000	18905	9536	0	0	\N
312459	1678	20880721104000	18913	9540	0	0	\N
312460	1678	20880721105000	18913	9540	1	0	\N
312461	1678	20880721106000	18914	9541	0	0	\N
312462	1874	10184000	18914	9541	1	0	\N
312465	1678	20880721106000	18916	9541	0	0	\N
312466	1874	10184000	18916	9541	1	0	\N
312472	1678	20880721076000	18920	9479	0	0	\N
312473	1678	20880721077000	18920	9479	1	0	\N
312474	1678	20880721078000	18920	9479	2	0	\N
312475	1678	20880721079000	18920	9479	3	0	\N
312476	1678	20880721080000	18920	9479	4	0	\N
312477	1678	20880721081000	18920	9479	5	0	\N
312478	1678	20880721082000	18920	9479	6	0	\N
312479	1678	20880721083000	18920	9479	7	0	\N
312480	1678	20880721084000	18920	9479	8	0	\N
312481	1678	20880721085000	18920	9479	9	0	\N
312482	1678	20880721086000	18920	9479	10	0	\N
312483	1678	20880721087000	18920	9479	11	0	\N
312484	1678	20880721088000	18920	9479	12	0	\N
312485	1678	20880721089000	18920	9479	13	0	\N
312486	1678	20880721090000	18920	9479	14	0	\N
312487	1678	20880721091000	18920	9479	15	0	\N
312488	1678	20880721092000	18920	9479	16	0	\N
312489	1678	20880721093000	18920	9479	17	0	\N
312490	1678	20880721094000	18920	9479	18	0	\N
312491	1678	20880721095000	18920	9479	19	0	\N
312492	1678	20880721096000	18920	9479	20	0	\N
312493	1678	20880721097000	18920	9479	21	0	\N
312494	1678	20880721098000	18920	9479	22	0	\N
312495	1678	20880721099000	18920	9479	23	0	\N
312496	1678	20880721100000	18920	9479	24	0	\N
312497	1678	20880721101000	18920	9479	25	0	\N
312498	1678	20880721102000	18920	9479	26	0	\N
312499	1678	20880721103000	18920	9479	27	0	\N
312500	1678	20880721104000	18920	9479	28	0	\N
312501	1678	20880721105000	18920	9479	29	0	\N
312502	1678	20880721106000	18920	9479	30	0	\N
312503	1678	20880721107000	18920	9479	31	0	\N
312504	1678	20880721108000	18920	9479	32	0	\N
312505	1678	20880721109000	18920	9479	33	0	\N
312506	1678	20880721110000	18920	9479	34	0	\N
312507	1874	10175000	18920	9479	35	0	\N
312508	1874	10176000	18920	9479	36	0	\N
312509	1874	10177000	18920	9479	37	0	\N
312510	1874	10178000	18920	9479	38	0	\N
312511	1874	10179000	18920	9479	39	0	\N
312512	1874	10180000	18920	9479	40	0	\N
312513	1874	10181000	18920	9479	41	0	\N
312514	1874	10182000	18920	9479	42	0	\N
312515	1874	10183000	18920	9479	43	0	\N
312516	1874	10184000	18920	9479	44	0	\N
312517	1874	10185000	18920	9479	45	0	\N
312519	1678	20880721111000	18922	9545	0	0	\N
312520	1678	20880721111000	18923	9545	0	0	\N
312524	1678	20880721114000	18926	9548	0	0	\N
312526	1678	20880721114000	18928	9548	0	0	\N
312527	1678	20880721114000	18929	9548	0	0	\N
312395	1874	10175000	18878	9519	2	0	2
312396	1678	20880721078000	18879	9520	0	0	0
312397	1678	20880721079000	18880	9521	0	0	0
312398	1678	20880721080000	18881	9522	0	0	0
312399	1874	10176000	18881	9522	1	0	2
312402	1678	20880721082000	18884	9524	0	0	0
312403	1678	20880721083000	18885	9525	0	0	0
312404	1874	10177000	18885	9525	1	0	2
312405	1678	20880721084000	18886	9526	0	0	0
312406	1678	20880721085000	18887	9527	0	0	0
312408	1874	10178000	18887	9527	2	0	2
312409	1678	20880721087000	18888	9528	0	0	0
312412	1678	20880721088000	18890	9529	0	0	0
312413	1678	20880721089000	18890	9529	1	0	0
312415	1874	10179000	18891	9530	1	0	2
312428	1678	20880721091000	18897	9531	0	0	0
312429	1678	20880721092000	18898	9532	0	0	0
312432	1678	20880721093000	18900	9533	0	0	0
312433	1874	10180000	18900	9533	1	0	2
312440	1678	20880721095000	18903	9535	0	0	0
312441	1678	20880721096000	18903	9535	1	0	0
312442	1874	10181000	18903	9535	2	0	2
312448	1678	20880721097000	18906	9536	0	0	0
312449	1678	20880721098000	18907	9537	0	0	0
312451	1678	20880721100000	18907	9537	2	0	0
312452	1678	20880721101000	18907	9537	3	0	0
312453	1874	10182000	18907	9537	4	0	2
312454	1678	20880721102000	18910	9538	0	0	0
312456	1874	10183000	18911	9539	1	0	2
312457	1678	20880721104000	18912	9540	0	0	0
312458	1678	20880721105000	18912	9540	1	0	0
312463	1678	20880721106000	18915	9541	0	0	0
312464	1874	10184000	18915	9541	1	0	2
312468	1678	20880721108000	18918	9543	0	0	0
312469	1678	20880721109000	18918	9543	1	0	0
312470	1678	20880721110000	18919	9544	0	0	0
312471	1874	10185000	18919	9544	1	0	2
312518	1678	20880721111000	18921	9545	0	0	0
312522	1678	20880721113000	18925	9547	0	0	0
312523	1874	10186000	18925	9547	1	0	2
312525	1678	20880721114000	18927	9548	0	0	0
312528	1678	20880721115000	18930	9549	0	0	0
312529	1678	20880721116000	18931	9550	0	0	\N
312530	1874	10187000	18931	9550	1	0	\N
312533	1678	20880721116000	18933	9550	0	0	\N
312534	1874	10187000	18933	9550	1	0	\N
312536	1678	20880721118000	18935	9552	0	0	\N
312541	1678	20880721120000	18939	9554	0	0	\N
312542	1874	10188000	18939	9554	1	0	\N
312544	1678	20880721122000	18941	9556	0	0	\N
312545	1678	20880721123000	18941	9556	1	0	\N
312546	1678	20880721124000	18941	9556	2	0	\N
312547	1874	10189000	18941	9556	3	0	\N
312552	2200	9000000000	18943	9557	0	0	\N
312553	1678	20880721125000	18943	9557	1	0	\N
312554	2200	9000000000	18944	9557	0	0	\N
312555	1678	20880721125000	18944	9557	1	0	\N
312558	2200	9000000000	18946	9557	0	0	\N
312559	1678	20880721126000	18947	9558	0	0	\N
312560	1678	20880721127000	18947	9558	1	0	\N
312561	1874	10190000	18947	9558	2	0	\N
312565	1678	20880721128000	18949	9559	0	0	\N
312569	1678	20880721129000	18953	9560	0	0	\N
312570	1474	13313364000023	18953	9560	1	0	\N
312575	1678	20880721131000	18956	9562	0	0	\N
312577	1678	20880721132000	18958	9563	0	0	\N
312578	1678	20880721133000	18960	9564	0	0	\N
312579	1726	95067112000	18960	9564	1	0	\N
312580	1874	10192000	18960	9564	2	0	\N
312584	1678	20880721133000	18962	9564	0	0	\N
312585	1726	95067112000	18962	9564	1	0	\N
312586	1874	10192000	18962	9564	2	0	\N
312587	1678	20880721134000	18963	9565	0	0	\N
312590	1678	20880721136000	18966	9567	0	0	\N
312591	1874	10193000	18966	9567	1	0	\N
312592	1678	20880721136000	18967	9567	0	0	\N
312593	1874	10193000	18967	9567	1	0	\N
312596	1678	20880721136000	18969	9567	0	0	\N
312597	1874	10193000	18969	9567	1	0	\N
312601	1678	20880721140000	18972	9570	0	0	\N
312602	1874	10194000	18972	9570	1	0	\N
312603	1678	20880721140000	18973	9570	0	0	\N
312604	1874	10194000	18973	9570	1	0	\N
312605	1678	20880721140000	18974	9570	0	0	\N
312606	1874	10194000	18974	9570	1	0	\N
312609	1678	20880721140000	18976	9570	0	0	\N
312610	1874	10194000	18976	9570	1	0	\N
312616	1678	20880721145000	18978	9572	0	0	\N
312618	1678	20880721145000	18980	9572	0	0	\N
312621	1678	20880721146000	18983	9573	0	0	\N
312622	1874	10196000	18983	9573	1	0	\N
312624	1678	20880721147000	18985	9574	0	0	\N
312625	1678	20880721148000	18986	9575	0	0	\N
312626	1095	904632174710000	18986	9575	1	0	\N
312627	1215	610373354340000	18986	9575	2	0	\N
312628	1341	1700859623251650	18986	9575	3	0	\N
312629	1678	20880721148000	18987	9575	0	0	\N
312630	1095	904632174710000	18987	9575	1	0	\N
312631	1215	610373354340000	18987	9575	2	0	\N
312632	1341	1700859623251650	18987	9575	3	0	\N
312637	1678	20880721149000	18989	9576	0	0	\N
312639	1678	20880721150000	18991	9577	0	0	\N
312640	1874	10197000	18991	9577	1	0	\N
312641	1678	20880721150000	18992	9577	0	0	\N
312642	1874	10197000	18992	9577	1	0	\N
312643	1678	20880721150000	18993	9577	0	0	\N
312644	1874	10197000	18993	9577	1	0	\N
312648	1678	20880721151000	18996	9578	0	0	\N
312652	1678	20880721153000	18999	9580	0	0	\N
312653	1874	10198000	18999	9580	1	0	\N
312654	1678	20880721154000	19000	9581	0	0	\N
312656	1678	20880721135000	19005	9566	0	0	\N
312657	1678	20880721136000	19005	9566	1	0	\N
312658	1678	20880721137000	19005	9566	2	0	\N
312659	1678	20880721138000	19005	9566	3	0	\N
312660	1678	20880721139000	19005	9566	4	0	\N
312661	1678	20880721140000	19005	9566	5	0	\N
312662	1678	20880721141000	19005	9566	6	0	\N
312663	1678	20880721142000	19005	9566	7	0	\N
312664	1678	20880721143000	19005	9566	8	0	\N
312535	1678	20880721117000	18934	9551	0	0	0
312537	1678	20880721118000	18936	9552	0	0	0
312538	1678	20880721119000	18937	9553	0	0	0
312539	1678	20880721120000	18938	9554	0	0	0
312540	1874	10188000	18938	9554	1	0	2
312548	1678	20880721122000	18942	9556	0	0	0
312549	1678	20880721123000	18942	9556	1	0	0
312550	1678	20880721124000	18942	9556	2	0	0
312551	1874	10189000	18942	9556	3	0	2
312556	2200	9000000000	18945	9557	0	0	0
312562	1678	20880721126000	18948	9558	0	0	0
312563	1678	20880721127000	18948	9558	1	0	0
312564	1874	10190000	18948	9558	2	0	2
312566	1678	20880721128000	18950	9559	0	0	0
312568	1474	13313364000023	18952	9560	1	0	21
312571	1678	20880721130000	18954	9561	0	0	0
312572	1474	16813364000023	18954	9561	1	0	21
312573	1874	10191000	18954	9561	2	0	2
312574	1678	20880721131000	18955	9562	0	0	0
312581	1678	20880721133000	18961	9564	0	0	0
312582	1726	95067112000	18961	9564	1	0	8208
312583	1874	10192000	18961	9564	2	0	2
312588	1678	20880721134000	18964	9565	0	0	0
312589	1678	20880721135000	18965	9566	0	0	0
312595	1874	10193000	18968	9567	1	0	2
312598	1678	20880721137000	18970	9568	0	0	0
312599	1678	20880721138000	18970	9568	1	0	0
312600	1678	20880721139000	18971	9569	0	0	0
312608	1874	10194000	18975	9570	1	0	2
312611	1678	20880721141000	18977	9571	0	0	0
312612	1678	20880721142000	18977	9571	1	0	0
312613	1678	20880721143000	18977	9571	2	0	0
312614	1678	20880721144000	18977	9571	3	0	0
312617	1678	20880721145000	18979	9572	0	0	0
312619	1678	20880721146000	18982	9573	0	0	0
312620	1874	10196000	18982	9573	1	0	2
312623	1678	20880721147000	18984	9574	0	0	0
312633	1678	20880721148000	18988	9575	0	0	0
312635	1215	610373354340000	18988	9575	2	0	0
312636	1341	1700859623251650	18988	9575	3	0	0
312638	1678	20880721149000	18990	9576	0	0	0
312645	1678	20880721150000	18994	9577	0	0	0
312647	1678	20880721151000	18995	9578	0	0	0
312649	1678	20880721152000	18997	9579	0	0	0
312650	1678	20880721153000	18998	9580	0	0	0
312651	1874	10198000	18998	9580	1	0	2
312655	1678	20880721154000	19001	9581	0	0	0
312665	1678	20880721144000	19005	9566	9	0	\N
312666	1678	20880721145000	19005	9566	10	0	\N
312667	1678	20880721146000	19005	9566	11	0	\N
312668	1678	20880721147000	19005	9566	12	0	\N
312669	1678	20880721148000	19005	9566	13	0	\N
312670	1678	20880721149000	19005	9566	14	0	\N
312671	1678	20880721150000	19005	9566	15	0	\N
312672	1678	20880721151000	19005	9566	16	0	\N
312673	1678	20880721152000	19005	9566	17	0	\N
312674	1678	20880721153000	19005	9566	18	0	\N
312675	1678	20880721154000	19005	9566	19	0	\N
312676	1678	20880721155000	19005	9566	20	0	\N
312677	1874	10193000	19005	9566	21	0	\N
312678	1874	10194000	19005	9566	22	0	\N
312679	1874	10195000	19005	9566	23	0	\N
312680	1874	10196000	19005	9566	24	0	\N
312681	1874	10197000	19005	9566	25	0	\N
312682	1095	904632174710000	19005	9566	26	0	\N
312683	1215	610373354340000	19005	9566	27	0	\N
312684	1341	1700859623251650	19005	9566	28	0	\N
312685	1874	10198000	19005	9566	29	0	\N
312689	1678	20880721157000	19008	9585	0	0	\N
312691	1678	20880721157000	19010	9585	0	0	\N
312692	1678	20880721158000	19011	9586	0	0	\N
312693	2131	193998000	19011	9586	1	0	\N
312696	1678	20880721158000	19013	9586	0	0	\N
312697	2131	193998000	19013	9586	1	0	\N
312698	1678	20880721159000	19014	9587	0	0	\N
312699	1874	10200000	19014	9587	1	0	\N
312700	1678	20880721159000	19015	9587	0	0	\N
312701	1874	10200000	19015	9587	1	0	\N
312702	1678	20880721159000	19016	9587	0	0	\N
312703	1874	10200000	19016	9587	1	0	\N
312708	1678	20880721161000	19020	9589	0	0	\N
312709	1678	20880721162000	19020	9589	1	0	\N
312710	2172	198999000	19020	9589	2	0	\N
312711	1874	10201000	19020	9589	3	0	\N
312717	1678	20880721163000	19023	9590	0	0	\N
312718	1678	20880721163000	19024	9590	0	0	\N
312733	1678	20880721174000	19032	9597	0	0	\N
312734	1678	20880721174000	19033	9597	0	0	\N
312740	1678	20880721179000	19038	9602	0	0	\N
312741	1874	10206000	19038	9602	1	0	\N
312751	1678	20880721181000	19043	9604	0	0	\N
312752	1678	20880721182000	19043	9604	1	0	\N
312753	1678	20880721183000	19043	9604	2	0	\N
312754	1678	20880721184000	19043	9604	3	0	\N
312755	1874	10207000	19043	9604	4	0	\N
312756	579	66000100000000	19043	9604	5	0	\N
312761	1678	20880721188000	19045	9606	0	0	\N
312762	1678	20880721188000	19046	9606	0	0	\N
312771	1678	20880721190000	19050	9608	0	0	\N
312772	1678	20880721191000	19050	9608	1	0	\N
312773	1678	20880721192000	19050	9608	2	0	\N
312774	1678	20880721193000	19050	9608	3	0	\N
312775	1874	10210000	19050	9608	4	0	\N
312777	1678	20880721195000	19052	9610	0	0	\N
312778	1678	20880721196000	19052	9610	1	0	\N
312779	1874	10211000	19052	9610	2	0	\N
312789	1678	20880721202000	19055	9612	0	0	\N
312790	1874	10213000	19055	9612	1	0	\N
312791	1678	20880721202000	19056	9612	0	0	\N
312792	1874	10213000	19056	9612	1	0	\N
312793	1678	20880721202000	19057	9612	0	0	\N
312794	1874	10213000	19057	9612	1	0	\N
312797	1678	20880721202000	19059	9612	0	0	\N
312798	1874	10213000	19059	9612	1	0	\N
312799	1678	20880721202000	19060	9612	0	0	\N
312800	1874	10213000	19060	9612	1	0	\N
312688	1678	20880721156000	19007	9584	0	0	0
312690	1678	20880721157000	19009	9585	0	0	0
312694	1678	20880721158000	19012	9586	0	0	0
312695	2131	193998000	19012	9586	1	0	6
312704	1678	20880721159000	19017	9587	0	0	0
312706	1678	20880721160000	19018	9588	0	0	0
312707	2200	1511000000000	19018	9588	1	0	0
312712	1678	20880721161000	19021	9589	0	0	0
312713	1678	20880721162000	19021	9589	1	0	0
312714	2172	198999000	19021	9589	2	0	2
312716	1678	20880721163000	19022	9590	0	0	0
312719	1678	20880721164000	19025	9591	0	0	0
312720	1678	20880721165000	19026	9592	0	0	0
312721	1678	20880721166000	19026	9592	1	0	0
312723	1678	20880721168000	19026	9592	3	0	0
312724	1874	10202000	19026	9592	4	0	2
312725	1678	20880721169000	19027	9593	0	0	0
312726	1874	10203000	19027	9593	1	0	2
312727	1678	20880721170000	19028	9594	0	0	0
312729	1678	20880721172000	19029	9595	1	0	0
312730	1874	10204000	19029	9595	2	0	2
312731	1678	20880721173000	19030	9596	0	0	0
312732	1678	20880721174000	19031	9597	0	0	0
312735	1678	20880721175000	19034	9598	0	0	0
312737	1678	20880721176000	19035	9599	0	0	0
312738	1678	20880721177000	19036	9600	0	0	0
312739	1678	20880721178000	19037	9601	0	0	0
312742	1678	20880721179000	19039	9602	0	0	0
312744	1678	20880721180000	19040	9603	0	0	0
312745	1678	20880721181000	19042	9604	0	0	0
312746	1678	20880721182000	19042	9604	1	0	0
312747	1678	20880721183000	19042	9604	2	0	0
312748	1678	20880721184000	19042	9604	3	0	0
312750	579	66000100000000	19042	9604	5	0	0
312757	1678	20880721185000	19044	9605	0	0	0
312758	1678	20880721186000	19044	9605	1	0	0
312759	1678	20880721187000	19044	9605	2	0	0
312760	1874	10208000	19044	9605	3	0	2
312764	1678	20880721189000	19048	9607	0	0	0
312765	1874	10209000	19048	9607	1	0	2
312766	1678	20880721190000	19049	9608	0	0	0
312767	1678	20880721191000	19049	9608	1	0	0
312769	1678	20880721193000	19049	9608	3	0	0
312770	1874	10210000	19049	9608	4	0	2
312776	1678	20880721194000	19051	9609	0	0	0
312780	1678	20880721195000	19053	9610	0	0	0
312781	1678	20880721196000	19053	9610	1	0	0
312783	1678	20880721197000	19054	9611	0	0	0
312784	1678	20880721198000	19054	9611	1	0	0
312785	1678	20880721199000	19054	9611	2	0	0
312786	1678	20880721200000	19054	9611	3	0	0
312787	1678	20880721201000	19054	9611	4	0	0
312795	1678	20880721202000	19058	9612	0	0	0
312796	1874	10213000	19058	9612	1	0	2
312801	1678	20880721202000	19061	9612	0	0	\N
312802	1874	10213000	19061	9612	1	0	\N
312803	2201	200000000	19062	9613	0	0	\N
312804	1678	20880721203000	19062	9613	1	0	\N
312805	2202	200000000	19062	9613	2	0	\N
312806	2203	200000000	19062	9613	3	0	\N
312807	2204	200000000	19062	9613	4	0	\N
312808	2205	200000000	19062	9613	5	0	\N
312809	2206	200000000	19062	9613	6	0	\N
312810	2207	200000000	19062	9613	7	0	\N
312811	2208	200000000	19062	9613	8	0	\N
312812	44	66000000000000	19062	9613	9	0	\N
312828	1678	20880721206000	19066	9616	1	0	\N
312830	1678	20880721207000	19068	9617	0	0	\N
312833	1678	20880721209000	19071	9619	0	0	\N
312834	1874	10215000	19071	9619	1	0	\N
312835	1678	20880721209000	19072	9619	0	0	\N
312836	1874	10215000	19072	9619	1	0	\N
312839	1678	20880721209000	19074	9619	0	0	\N
312840	1874	10215000	19074	9619	1	0	\N
312845	1678	20880721212000	19078	9622	0	0	\N
312846	1874	10216000	19078	9622	1	0	\N
312848	1678	20880721214000	19080	9624	0	0	\N
312854	1678	20880721218000	19084	9627	0	0	\N
312855	1678	20880721219000	19084	9627	1	0	\N
312856	1678	20880721220000	19084	9627	2	0	\N
312857	1874	10218000	19084	9627	6	0	\N
312858	2209	708000000000	19084	9627	7	0	\N
312864	1678	20880721218000	19086	9627	0	0	\N
312865	1678	20880721219000	19086	9627	1	0	\N
312866	1678	20880721220000	19086	9627	2	0	\N
312867	1874	10218000	19086	9627	6	0	\N
312868	2209	708000000000	19086	9627	7	0	\N
312869	1678	20880721221000	19087	9628	0	0	\N
312877	2210	200000000	19090	9623	1	0	\N
312878	2184	1399000000	19090	9623	2	0	\N
312879	1678	20880721213000	19090	9623	3	0	\N
312880	1678	20880721214000	19090	9623	4	0	\N
312881	1678	20880721215000	19090	9623	9	0	\N
312882	1678	20880721216000	19090	9623	10	0	\N
312883	1678	20880721217000	19090	9623	11	0	\N
312884	1678	20880721218000	19090	9623	12	0	\N
312885	1678	20880721219000	19090	9623	13	0	\N
312886	1678	20880721220000	19090	9623	14	0	\N
312887	1678	20880721221000	19090	9623	15	0	\N
312888	1678	20880721222000	19090	9623	16	0	\N
312889	1678	20880721223000	19090	9623	17	0	\N
312890	1678	20880721224000	19090	9623	18	0	\N
312891	1678	20880721225000	19090	9623	19	0	\N
312892	1678	20880721226000	19090	9623	20	0	\N
312893	2209	708000000000	19090	9623	21	0	\N
312894	1874	10218000	19090	9623	22	0	\N
312895	1874	10221000	19090	9623	23	0	\N
312896	1874	10222000	19090	9623	24	0	\N
312897	1874	10223000	19090	9623	25	0	\N
312898	1874	10224000	19090	9623	26	0	\N
312899	1874	10225000	19090	9623	27	0	\N
312900	1874	10228000	19090	9623	28	0	\N
312907	1678	20880721227000	19092	9631	0	0	\N
312908	1874	10231000	19092	9631	1	0	\N
312909	1874	10233000	19092	9631	2	0	\N
312913	1678	20880721228000	19094	9632	0	0	\N
312914	1874	10236000	19094	9632	1	0	\N
312915	1874	10238000	19094	9632	2	0	\N
312916	1678	20880721228000	19095	9632	0	0	\N
312917	1874	10236000	19095	9632	1	0	\N
312918	1874	10238000	19095	9632	2	0	\N
312919	2201	200000000	19096	9565	0	0	\N
312920	2200	1511000000000	19096	9565	1	0	\N
312921	2202	200000000	19096	9565	2	0	\N
312922	2203	200000000	19096	9565	3	0	\N
312923	2204	200000000	19096	9565	4	0	\N
312924	2205	200000000	19096	9565	5	0	\N
312925	2206	200000000	19096	9565	6	0	\N
312926	2207	200000000	19096	9565	7	0	\N
312927	2208	200000000	19096	9565	8	0	\N
312928	2210	200000000	19096	9565	9	0	\N
312929	2184	1399000000	19096	9565	10	0	\N
312930	2131	193998000	19096	9565	11	0	\N
312931	2172	198999000	19096	9565	12	0	\N
312932	1874	10194000	19096	9565	13	0	\N
312933	579	66000100000000	19096	9565	14	0	\N
312934	1874	10197000	19096	9565	15	0	\N
312935	1874	10199000	19096	9565	16	0	\N
312936	1874	10201000	19096	9565	17	0	\N
312815	2202	200000000	19063	9613	2	0	0
312816	2203	200000000	19063	9613	3	0	0
312817	2204	200000000	19063	9613	4	0	0
312818	2205	200000000	19063	9613	5	0	0
312819	2206	200000000	19063	9613	6	0	0
312821	2208	200000000	19063	9613	8	0	0
312822	44	66000000000000	19063	9613	9	0	3
312823	1678	20880721204000	19064	9614	0	0	0
312824	1678	20880721205000	19065	9615	0	0	0
312825	1460	0	19065	9615	1	0	0
312827	1540	720012000000	19065	9615	3	0	4
312829	1678	20880721206000	19067	9616	1	0	0
312831	1678	20880721207000	19069	9617	0	0	0
312832	1678	20880721208000	19070	9618	0	0	0
312838	1874	10215000	19073	9619	1	0	2
312841	1678	20880721210000	19075	9620	0	0	0
312842	1678	20880721211000	19076	9621	0	0	0
312843	1678	20880721212000	19077	9622	0	0	0
312844	1874	10216000	19077	9622	1	0	2
312849	1678	20880721214000	19081	9624	0	0	0
312850	1678	20880721215000	19082	9625	0	0	0
312851	1874	10217000	19082	9625	1	0	2
312852	1678	20880721216000	19083	9626	1	0	0
312853	1678	20880721217000	19083	9626	2	0	0
312860	1678	20880721219000	19085	9627	1	0	0
312861	1678	20880721220000	19085	9627	2	0	0
312862	1874	10218000	19085	9627	6	0	2
312863	2209	708000000000	19085	9627	7	0	0
312871	2210	200000000	19089	9629	0	0	0
312872	2184	1399000000	19089	9629	1	0	1
312873	1678	20880721222000	19089	9629	2	0	0
312874	1678	20880721223000	19089	9629	3	0	0
312875	1678	20880721224000	19089	9629	4	0	0
312901	1678	20880721225000	19091	9630	0	0	0
312902	1678	20880721226000	19091	9630	1	0	0
312903	1874	10221000	19091	9630	2	0	2
312904	1874	10222000	19091	9630	3	0	2
312905	1874	10225000	19091	9630	4	0	2
312910	1678	20880721227000	19093	9631	0	0	0
312911	1874	10231000	19093	9631	1	0	2
312912	1874	10233000	19093	9631	2	0	2
312937	1095	904632174710000	19096	9565	18	0	\N
312938	1215	610373354340000	19096	9565	19	0	\N
312939	1341	1700859623251650	19096	9565	20	0	\N
312940	1874	10204000	19096	9565	21	0	\N
312941	1874	10207000	19096	9565	22	0	\N
312942	1874	10210000	19096	9565	23	0	\N
312943	1678	20880721228000	19097	9632	0	0	\N
312944	1874	10236000	19097	9632	1	0	\N
312945	1874	10238000	19097	9632	2	0	\N
312952	1678	20880721230000	19100	9634	0	0	\N
312953	1678	20880721231000	19100	9634	1	0	\N
312954	1874	10246000	19100	9634	2	0	\N
312955	1874	10249000	19100	9634	3	0	\N
312956	1874	10251000	19100	9634	4	0	\N
312957	1874	10253000	19100	9634	5	0	\N
312958	1678	20880721230000	19101	9634	0	0	\N
312959	1678	20880721231000	19101	9634	1	0	\N
312960	1874	10246000	19101	9634	2	0	\N
312961	1874	10249000	19101	9634	3	0	\N
312962	1874	10251000	19101	9634	4	0	\N
312963	1874	10253000	19101	9634	5	0	\N
312970	1678	20880721230000	19103	9634	0	0	\N
312971	1678	20880721231000	19103	9634	1	0	\N
312972	1874	10246000	19103	9634	2	0	\N
312973	1874	10249000	19103	9634	3	0	\N
312974	1874	10251000	19103	9634	4	0	\N
312975	1874	10253000	19103	9634	5	0	\N
312988	1678	20880721236000	19107	9638	0	0	\N
312989	1678	20880721237000	19107	9638	1	0	\N
312990	1874	10276000	19107	9638	3	0	\N
312991	1874	10279000	19107	9638	4	0	\N
312992	1874	10281000	19107	9638	5	0	\N
313005	1874	10293000	19112	9642	0	0	\N
313013	1678	20880721244000	19117	9645	0	0	\N
313014	1874	10305000	19117	9645	1	0	\N
313015	1678	20880721244000	19118	9645	0	0	\N
313016	1874	10305000	19118	9645	1	0	\N
313017	1678	20880721244000	19119	9645	0	0	\N
313018	1874	10305000	19119	9645	1	0	\N
313021	2201	200000000	19121	9549	0	0	\N
313022	2200	9000000000	19121	9549	1	0	\N
313023	2200	1511000000000	19121	9549	2	0	\N
313024	2202	200000000	19121	9549	3	0	\N
313025	2203	200000000	19121	9549	4	0	\N
313026	2204	200000000	19121	9549	5	0	\N
313027	1474	11811354000023	19121	9549	6	0	\N
313028	2205	200000000	19121	9549	7	0	\N
313029	2206	200000000	19121	9549	8	0	\N
313030	2207	200000000	19121	9549	9	0	\N
313031	2208	200000000	19121	9549	10	0	\N
313032	2210	200000000	19121	9549	11	0	\N
313033	2184	1399000000	19121	9549	12	0	\N
313034	2131	193998000	19121	9549	13	0	\N
313035	2172	198999000	19121	9549	14	0	\N
313036	1874	10187000	19121	9549	15	0	\N
313037	1874	10189000	19121	9549	16	0	\N
313038	579	66000100000000	19121	9549	17	0	\N
313039	1874	10192000	19121	9549	18	0	\N
313040	1874	10194000	19121	9549	19	0	\N
313041	1874	10196000	19121	9549	20	0	\N
313042	1874	10198000	19121	9549	21	0	\N
313043	1874	10200000	19121	9549	22	0	\N
313044	1874	10202000	19121	9549	23	0	\N
313045	1874	10204000	19121	9549	24	0	\N
313046	1874	10206000	19121	9549	25	0	\N
313047	1874	10208000	19121	9549	26	0	\N
313048	1874	10210000	19121	9549	28	0	\N
313053	1678	20880721245000	19123	9646	0	0	\N
313054	1678	20880721246000	19123	9646	1	0	\N
313055	1874	10308000	19123	9646	2	0	\N
313056	1874	10311000	19123	9646	3	0	\N
313059	1678	20880721247000	19125	9647	0	0	\N
313060	1874	10314000	19125	9647	1	0	\N
313061	1678	20880721248000	19126	9648	0	0	\N
313062	1874	10317000	19126	9648	1	0	\N
313063	1678	20880721248000	19127	9648	0	0	\N
313064	1874	10317000	19127	9648	1	0	\N
313065	1678	20880721248000	19128	9648	0	0	\N
313066	1874	10317000	19128	9648	1	0	\N
313069	2201	200000000	19130	9591	0	0	\N
313070	2202	200000000	19130	9591	1	0	\N
313071	2203	200000000	19130	9591	2	0	\N
313072	2204	200000000	19130	9591	3	0	\N
312948	1874	10238000	19098	9632	2	0	2
312949	1678	20880721229000	19099	9633	0	0	0
312950	1874	10241000	19099	9633	1	0	2
312951	1874	10243000	19099	9633	2	0	2
312964	1678	20880721230000	19102	9634	0	0	0
312966	1874	10246000	19102	9634	2	0	2
312967	1874	10249000	19102	9634	3	0	2
312968	1874	10251000	19102	9634	4	0	2
312969	1874	10253000	19102	9634	5	0	2
312976	1874	10255000	19104	9635	0	0	2
312978	1678	20880721232000	19105	9636	0	0	0
312979	1678	20880721233000	19105	9636	1	0	0
312980	1874	10260000	19105	9636	2	0	2
312981	1874	10263000	19105	9636	3	0	2
312983	1678	20880721235000	19106	9637	3	0	0
312984	1874	10265000	19106	9637	4	0	2
312985	1874	10267000	19106	9637	5	0	2
312986	1874	10270000	19106	9637	6	0	2
312987	1874	10273000	19106	9637	7	0	2
312994	1678	20880721237000	19108	9638	1	0	0
312995	1874	10276000	19108	9638	3	0	2
312996	1874	10279000	19108	9638	4	0	2
312997	1874	10281000	19108	9638	5	0	2
312998	1678	20880721238000	19109	9639	0	0	0
313000	1540	720012000000	19109	9639	2	0	4
313001	1678	20880721239000	19110	9640	1	0	0
313002	1874	10287000	19110	9640	2	0	2
313003	1678	20880721240000	19111	9641	0	0	0
313006	1874	10293000	19113	9642	0	0	2
313007	1678	20880721241000	19116	9644	0	0	0
313008	1678	20880721242000	19116	9644	1	0	0
313009	1678	20880721243000	19116	9644	2	0	0
313010	1874	10296000	19116	9644	3	0	2
313012	1874	10302000	19116	9644	5	0	2
313019	1678	20880721244000	19120	9645	0	0	0
313020	1874	10305000	19120	9645	1	0	2
313049	1678	20880721245000	19122	9646	0	0	0
313050	1678	20880721246000	19122	9646	1	0	0
313052	1874	10311000	19122	9646	3	0	2
313057	1678	20880721247000	19124	9647	0	0	0
313058	1874	10314000	19124	9647	1	0	2
313067	1678	20880721248000	19129	9648	0	0	0
313073	2205	200000000	19130	9591	4	0	\N
313074	2206	200000000	19130	9591	5	0	\N
313075	2207	200000000	19130	9591	6	0	\N
313076	2208	200000000	19130	9591	7	0	\N
313077	2210	200000000	19130	9591	8	0	\N
313078	2184	1399000000	19130	9591	9	0	\N
313079	2209	708000000000	19130	9591	10	0	\N
313080	2212	200000000	19130	9591	11	0	\N
313081	1874	10203000	19130	9591	12	0	\N
313082	2206	1400000000	19130	9591	13	0	\N
313083	579	66000100000000	19130	9591	14	0	\N
313084	1874	10206000	19130	9591	15	0	\N
313085	1874	10208000	19130	9591	16	0	\N
313086	1874	10210000	19130	9591	17	0	\N
313087	1874	10212000	19130	9591	18	0	\N
313088	1874	10214000	19130	9591	19	0	\N
313089	1874	10216000	19130	9591	20	0	\N
313090	1874	10218000	19130	9591	21	0	\N
313091	1874	10220000	19130	9591	22	0	\N
313092	1874	10222000	19130	9591	23	0	\N
313093	1874	10224000	19130	9591	24	0	\N
313094	1874	10226000	19130	9591	25	0	\N
313095	1874	10229000	19130	9591	26	0	\N
313096	1874	10232000	19130	9591	27	0	\N
313097	1874	10235000	19130	9591	28	0	\N
313098	1874	10238000	19130	9591	29	0	\N
313099	1874	10241000	19130	9591	30	0	\N
313100	1874	10244000	19130	9591	31	0	\N
313101	1874	10247000	19130	9591	32	0	\N
313102	1874	10250000	19130	9591	33	0	\N
313103	1874	10253000	19130	9591	34	0	\N
313104	1874	10256000	19130	9591	35	0	\N
313105	1874	10259000	19130	9591	36	0	\N
313106	1874	10262000	19130	9591	37	0	\N
313107	1874	10265000	19130	9591	38	0	\N
313108	1874	10268000	19130	9591	39	0	\N
313109	1874	10271000	19130	9591	40	0	\N
313110	1874	10274000	19130	9591	41	0	\N
313111	1874	10277000	19130	9591	42	0	\N
313112	1874	10280000	19130	9591	43	0	\N
313113	1874	10283000	19130	9591	44	0	\N
313114	1874	10286000	19130	9591	45	0	\N
313115	1874	10289000	19130	9591	46	0	\N
313116	1874	10292000	19130	9591	47	0	\N
313117	1874	10295000	19130	9591	48	0	\N
313118	1874	10298000	19130	9591	49	0	\N
313119	1874	10301000	19130	9591	50	0	\N
313120	1874	10304000	19130	9591	51	0	\N
313121	1540	720012000000	19130	9591	52	0	\N
313128	1678	20880721249000	19132	9649	0	0	\N
313129	1678	20880721250000	19132	9649	1	0	\N
313130	2212	200000000	19132	9649	2	0	\N
313131	1874	10320000	19132	9649	3	0	\N
313132	2206	1399000000	19132	9649	4	0	\N
313133	1874	10323000	19132	9649	5	0	\N
313156	1678	20880721258000	19137	9654	0	0	\N
313157	1874	10361000	19137	9654	1	0	\N
313158	1874	10363000	19137	9654	2	0	\N
313159	1874	10364000	19137	9654	3	0	\N
313160	1678	20880721258000	19138	9654	0	0	\N
313161	1874	10360000	19138	9654	1	0	\N
313162	1874	10361000	19138	9654	2	0	\N
313170	1678	20880721259000	19141	9655	0	0	\N
313171	1874	10367000	19141	9655	1	0	\N
313172	1874	10369000	19141	9655	2	0	\N
313180	1678	20880721260000	19143	9656	0	0	\N
313181	1678	20880721261000	19143	9656	1	0	\N
313182	1874	10370000	19143	9656	2	0	\N
313183	1874	10372000	19143	9656	3	0	\N
313184	1874	10374000	19143	9656	4	0	\N
313185	1678	20880721262000	19144	9657	0	0	\N
313186	1874	10382000	19144	9657	1	0	\N
313187	1874	10385000	19144	9657	2	0	\N
313197	1678	20880721265000	19148	9660	0	0	\N
313198	1874	10397000	19148	9660	1	0	\N
313199	1874	10400000	19148	9660	2	0	\N
313200	1874	10401000	19148	9660	3	0	\N
313124	2212	200000000	19131	9649	2	0	0
313125	1874	10320000	19131	9649	3	0	2
313126	2206	1399000000	19131	9649	4	0	1
313127	1874	10323000	19131	9649	5	0	2
313134	1678	20880721251000	19133	9650	0	0	0
313136	1874	10326000	19133	9650	2	0	2
313137	1874	10329000	19133	9650	3	0	2
313138	1874	10330000	19133	9650	4	0	2
313139	1874	10332000	19133	9650	5	0	2
313140	1678	20880721253000	19134	9651	0	0	0
313142	1678	20880721255000	19134	9651	2	0	0
313143	1874	10333000	19134	9651	3	0	2
313144	1874	10335000	19134	9651	4	0	2
313145	1874	10338000	19134	9651	5	0	2
313147	1874	10344000	19134	9651	7	0	2
313148	1874	10346000	19134	9651	8	0	2
313149	1874	10348000	19134	9651	9	0	2
313150	1678	20880721256000	19135	9652	0	0	0
313151	1874	10351000	19135	9652	1	0	2
313153	1678	20880721257000	19136	9653	0	0	0
313154	1874	10355000	19136	9653	1	0	2
313155	1874	10358000	19136	9653	2	0	2
313163	1678	20880721258000	19139	9654	0	0	0
313164	1874	10361000	19139	9654	1	0	2
313166	1874	10364000	19139	9654	3	0	2
313167	1678	20880721259000	19140	9655	0	0	0
313168	1874	10367000	19140	9655	1	0	2
313169	1874	10369000	19140	9655	2	0	2
313174	1678	20880721261000	19142	9656	1	0	0
313175	1874	10370000	19142	9656	2	0	2
313176	1874	10372000	19142	9656	3	0	2
313177	1874	10374000	19142	9656	4	0	2
313178	1874	10377000	19142	9656	5	0	2
313188	1678	20880721262000	19145	9657	0	0	0
313189	1874	10382000	19145	9657	1	0	2
313190	1874	10385000	19145	9657	2	0	2
313191	1678	20880721263000	19146	9658	0	0	0
313192	1874	10388000	19146	9658	1	0	2
313194	1678	20880721264000	19147	9659	0	0	0
313195	1874	10392000	19147	9659	1	0	2
313196	1874	10395000	19147	9659	2	0	2
313201	1678	20880721265000	19149	9660	0	0	0
313203	1874	10400000	19149	9660	2	0	2
313204	1874	10401000	19149	9660	3	0	2
313205	1678	20880721266000	19150	9661	0	0	0
313206	1678	20880721267000	19150	9661	1	0	0
313207	1678	20880721268000	19150	9661	2	0	0
313224	1678	20880721271000	19151	9662	0	0	\N
313225	1874	10430000	19151	9662	2	0	\N
313226	1874	10432000	19151	9662	3	0	\N
313227	1874	10433000	19151	9662	4	0	\N
313232	1678	20880721271000	19153	9662	0	0	\N
313233	1874	10430000	19153	9662	2	0	\N
313234	1874	10432000	19153	9662	3	0	\N
313235	1874	10433000	19153	9662	4	0	\N
313236	1678	20880721271000	19154	9662	0	0	\N
313237	1874	10430000	19154	9662	2	0	\N
313238	1874	10432000	19154	9662	3	0	\N
313239	1874	10433000	19154	9662	4	0	\N
313240	1678	20880721271000	19155	9662	0	0	\N
313241	1874	10430000	19155	9662	2	0	\N
313242	1874	10432000	19155	9662	3	0	\N
313243	1874	10433000	19155	9662	4	0	\N
313251	1678	20880721273000	19158	9664	0	0	\N
313252	1874	10441000	19158	9664	1	0	\N
313253	1874	10443000	19158	9664	2	0	\N
313258	1678	20880721275000	19160	9666	0	0	\N
313259	1678	20880721276000	19160	9666	1	0	\N
313260	1874	10450000	19160	9666	2	0	\N
313261	1874	10451000	19160	9666	3	0	\N
313262	1874	10453000	19160	9666	4	0	\N
313263	2147	1525800000000	19160	9666	5	0	\N
313272	1678	20880721277000	19162	9667	0	0	\N
313273	1874	10462000	19162	9667	1	0	\N
313274	1874	10464000	19162	9667	2	0	\N
313275	1678	20880721277000	19163	9667	0	0	\N
313276	1874	10462000	19163	9667	1	0	\N
313277	1874	10464000	19163	9667	2	0	\N
313281	1678	20880721277000	19165	9667	0	0	\N
313282	1874	10462000	19165	9667	1	0	\N
313283	1874	10464000	19165	9667	2	0	\N
313284	1678	20880721278000	19166	9668	0	0	\N
313285	1678	20880721279000	19166	9668	1	0	\N
313286	1874	10466000	19166	9668	2	0	\N
313287	1874	10469000	19166	9668	3	0	\N
313288	1874	10470000	19166	9668	4	0	\N
313289	1874	10473000	19166	9668	5	0	\N
313290	1874	10475000	19166	9668	6	0	\N
313308	1678	20880721283000	19170	9671	0	0	\N
313309	1874	10494000	19170	9671	1	0	\N
313310	1874	10496000	19170	9671	2	0	\N
313335	1678	21600733289000	19175	9675	0	0	\N
313336	1874	10525000	19175	9675	1	0	\N
313337	1874	10528000	19175	9675	2	0	\N
313341	1678	21600733290000	19177	9676	0	0	\N
313342	1874	10531000	19177	9676	1	0	\N
313343	1874	10533000	19177	9676	2	0	\N
313211	967	507282475000000	19150	9661	6	0	0
313212	1087	909006169720300	19150	9661	7	0	0
313213	1333	1709039342094750	19150	9661	8	0	0
313214	1874	10405000	19150	9661	9	0	2
313215	1874	10408000	19150	9661	10	0	2
313217	1874	10414000	19150	9661	12	0	2
313218	1874	10417000	19150	9661	13	0	2
313219	1874	10419000	19150	9661	14	0	2
313220	1874	10421000	19150	9661	15	0	2
313221	1874	10423000	19150	9661	16	0	2
313223	1874	10427000	19150	9661	18	0	2
313228	1678	20880721271000	19152	9662	0	0	0
313229	1874	10430000	19152	9662	2	0	2
313230	1874	10432000	19152	9662	3	0	2
313244	1678	20880721272000	19156	9663	0	0	0
313245	2148	4001506880750	19156	9663	1	0	0
313246	1874	10436000	19156	9663	2	0	2
313247	1874	10438000	19156	9663	3	0	2
313248	1678	20880721273000	19157	9664	0	0	0
313250	1874	10443000	19157	9664	2	0	2
313254	1678	20880721274000	19159	9665	0	0	0
313255	1874	10446000	19159	9665	1	0	2
313256	1874	10448000	19159	9665	2	0	2
313257	1207	613340845055850	19159	9665	3	0	0
313265	1678	20880721276000	19161	9666	1	0	0
313266	1874	10451000	19161	9666	2	0	2
313267	1874	10453000	19161	9666	3	0	2
313268	1874	10456000	19161	9666	4	0	2
313270	1874	10459000	19161	9666	6	0	2
313271	2147	1525800000000	19161	9666	7	0	0
313278	1678	20880721277000	19164	9667	0	0	0
313279	1874	10462000	19164	9667	1	0	2
313280	1874	10464000	19164	9667	2	0	2
313292	1678	20880721279000	19167	9668	1	0	0
313293	1874	10466000	19167	9668	2	0	2
313294	1874	10469000	19167	9668	3	0	2
313295	1874	10470000	19167	9668	4	0	2
313296	1874	10473000	19167	9668	5	0	2
313298	1678	20880721280000	19168	9669	0	0	0
313299	1678	20880721281000	19168	9669	1	0	0
313300	1874	10477000	19168	9669	2	0	2
313301	1874	10480000	19168	9669	3	0	2
313303	1874	10484000	19168	9669	5	0	2
313304	1874	10486000	19168	9669	6	0	2
313305	1678	20880721282000	19169	9670	0	0	0
313306	1874	10489000	19169	9670	1	0	2
313307	1874	10491000	19169	9670	2	0	2
313312	1874	10494000	19171	9671	1	0	2
313313	1874	10496000	19171	9671	2	0	2
313314	1678	21600733284000	19172	9672	0	0	0
313315	1874	10499000	19172	9672	1	0	2
313316	1874	10501000	19172	9672	2	0	2
313318	1309	1708723637751650	19173	9673	1	0	0
313319	1063	908815465000000	19173	9673	2	0	0
313320	1183	613195750000000	19173	9673	3	0	0
313321	1678	21600733286000	19173	9673	4	0	0
313323	943	507154775000000	19173	9673	6	0	0
313324	1874	10504000	19173	9673	7	0	2
313325	1874	10506000	19173	9673	8	0	2
313326	1874	10507000	19173	9673	9	0	2
313327	1874	10510000	19173	9673	10	0	2
313329	1874	10514000	19173	9673	12	0	2
313330	1874	10517000	19173	9673	13	0	2
313331	1678	21600733288000	19174	9674	0	0	0
313332	1874	10519000	19174	9674	1	0	2
313333	1874	10522000	19174	9674	2	0	2
313338	1678	21600733289000	19176	9675	0	0	0
313339	1874	10525000	19176	9675	1	0	2
313340	1874	10528000	19176	9675	2	0	2
313344	1678	21600733290000	19178	9676	0	0	0
313352	2201	200000000	19180	9610	0	0	\N
313353	1678	20880721195000	19180	9610	1	0	\N
313354	1678	20880721196000	19180	9610	2	0	\N
313355	1678	20880721197000	19180	9610	3	0	\N
313356	1309	1708723637751650	19180	9610	4	0	\N
313357	1063	908815465000000	19180	9610	5	0	\N
313358	1183	613195750000000	19180	9610	6	0	\N
313359	943	507154775000000	19180	9610	7	0	\N
313360	764	3307760000000	19180	9610	8	0	\N
313361	2202	200000000	19180	9610	9	0	\N
313362	2203	200000000	19180	9610	10	0	\N
313363	2204	200000000	19180	9610	11	0	\N
313364	1678	20880721198000	19180	9610	12	0	\N
313365	1678	20880721199000	19180	9610	13	0	\N
313366	1678	20880721200000	19180	9610	14	0	\N
313367	1678	20880721201000	19180	9610	15	0	\N
313368	1678	20880721202000	19180	9610	16	0	\N
313369	1678	20880721203000	19180	9610	17	0	\N
313370	1678	20880721204000	19180	9610	18	0	\N
313371	1678	20880721205000	19180	9610	19	0	\N
313372	1678	20880721206000	19180	9610	20	0	\N
313373	1678	20880721207000	19180	9610	21	0	\N
313374	1678	20880721208000	19180	9610	22	0	\N
313375	1678	20880721209000	19180	9610	23	0	\N
313376	1678	20880721210000	19180	9610	24	0	\N
313377	1678	20880721211000	19180	9610	25	0	\N
313378	1678	20880721212000	19180	9610	26	0	\N
313379	1678	20880721213000	19180	9610	27	0	\N
313380	1678	20880721214000	19180	9610	28	0	\N
313381	1678	20880721215000	19180	9610	29	0	\N
313382	1678	20880721216000	19180	9610	30	0	\N
313383	1678	20880721217000	19180	9610	31	0	\N
313384	1678	20880721218000	19180	9610	32	0	\N
313385	1678	20880721219000	19180	9610	33	0	\N
313386	1678	20880721220000	19180	9610	34	0	\N
313387	1678	20880721221000	19180	9610	35	0	\N
313388	1678	20880721222000	19180	9610	36	0	\N
313389	1678	20880721223000	19180	9610	37	0	\N
313390	1678	20880721224000	19180	9610	38	0	\N
313391	1678	20880721225000	19180	9610	39	0	\N
313392	1678	20880721226000	19180	9610	40	0	\N
313393	1678	20880721227000	19180	9610	41	0	\N
313394	1678	20880721228000	19180	9610	42	0	\N
313395	1678	20880721229000	19180	9610	43	0	\N
313396	1678	20880721230000	19180	9610	44	0	\N
313397	1678	20880721231000	19180	9610	45	0	\N
313398	1678	20880721232000	19180	9610	46	0	\N
313399	1678	20880721233000	19180	9610	48	0	\N
313400	1678	20880721234000	19180	9610	49	0	\N
313401	1678	20880721235000	19180	9610	50	0	\N
313402	1678	20880721236000	19180	9610	51	0	\N
313403	1678	20880721237000	19180	9610	52	0	\N
313404	1678	20880721238000	19180	9610	53	0	\N
313405	1678	20880721239000	19180	9610	54	0	\N
313406	1678	20880721240000	19180	9610	55	0	\N
313407	1678	20880721241000	19180	9610	56	0	\N
313408	1678	20880721242000	19180	9610	57	0	\N
313409	1678	20880721243000	19180	9610	58	0	\N
313410	1678	20880721244000	19180	9610	59	0	\N
313411	1678	20880721245000	19180	9610	60	0	\N
313412	1678	20880721246000	19180	9610	61	0	\N
313413	1678	20880721247000	19180	9610	62	0	\N
313414	1678	20880721248000	19180	9610	63	0	\N
313415	1678	20880721249000	19180	9610	64	0	\N
313416	1678	20880721250000	19180	9610	65	0	\N
313417	1678	20880721251000	19180	9610	66	0	\N
313418	1678	20880721252000	19180	9610	67	0	\N
313419	1678	20880721253000	19180	9610	68	0	\N
313420	1678	20880721254000	19180	9610	69	0	\N
313421	1678	20880721255000	19180	9610	70	0	\N
313422	1678	20880721256000	19180	9610	71	0	\N
313423	1678	20880721257000	19180	9610	72	0	\N
313424	1678	20880721258000	19180	9610	73	0	\N
313425	1678	20880721259000	19180	9610	74	0	\N
313426	1678	20880721260000	19180	9610	75	0	\N
313427	1678	20880721261000	19180	9610	76	0	\N
313428	1678	20880721262000	19180	9610	77	0	\N
313429	1678	20880721263000	19180	9610	78	0	\N
313430	1678	20880721264000	19180	9610	79	0	\N
313431	1678	20880721265000	19180	9610	80	0	\N
313432	1678	20880721266000	19180	9610	81	0	\N
313433	1678	20880721267000	19180	9610	82	0	\N
313434	1678	20880721268000	19180	9610	83	0	\N
313435	1678	20880721269000	19180	9610	84	0	\N
313436	1678	20880721270000	19180	9610	85	0	\N
313437	2205	200000000	19180	9610	86	0	\N
313438	2206	200000000	19180	9610	87	0	\N
313439	2207	200000000	19180	9610	88	0	\N
313440	2208	200000000	19180	9610	89	0	\N
313441	2210	200000000	19180	9610	90	0	\N
313442	2184	1399000000	19180	9610	91	0	\N
313443	1678	20880721271000	19180	9610	92	0	\N
313444	1678	20880721272000	19180	9610	93	0	\N
313445	1678	20880721273000	19180	9610	94	0	\N
313446	1678	20880721274000	19180	9610	95	0	\N
313447	1678	20880721275000	19180	9610	96	0	\N
313448	1678	20880721276000	19180	9610	97	0	\N
313449	1678	20880721277000	19180	9610	98	0	\N
313450	1678	20880721278000	19180	9610	99	0	\N
313451	1678	20880721279000	19180	9610	100	0	\N
313452	1678	20880721280000	19180	9610	101	0	\N
313453	1678	20880721281000	19180	9610	102	0	\N
313454	1678	20880721282000	19180	9610	103	0	\N
313455	1678	20880721283000	19180	9610	104	0	\N
313456	1678	20880721284000	19180	9610	105	0	\N
313457	1678	20880721285000	19180	9610	106	0	\N
313458	1678	20880721286000	19180	9610	107	0	\N
313459	1678	20880721287000	19180	9610	108	0	\N
313460	1678	20880721288000	19180	9610	109	0	\N
313461	1678	20880721289000	19180	9610	110	0	\N
313462	1678	20880721290000	19180	9610	111	0	\N
313463	1678	20880721291000	19180	9610	112	0	\N
313464	44	66000000000000	19180	9610	113	0	\N
313465	2209	708000000000	19180	9610	114	0	\N
313466	2212	200000000	19180	9610	115	0	\N
313467	1874	10212000	19180	9610	116	0	\N
313468	967	507282475000000	19180	9610	117	0	\N
313469	2206	1400000000	19180	9610	118	0	\N
313470	1087	909006169720300	19180	9610	119	0	\N
313471	1333	1709039342094750	19180	9610	120	0	\N
313472	2148	4001506880750	19180	9610	121	0	\N
313473	1874	10215000	19180	9610	122	0	\N
313474	1874	10217000	19180	9610	123	0	\N
313475	1874	10218000	19180	9610	124	0	\N
313476	1874	10220000	19180	9610	125	0	\N
313477	1678	21600733291000	19181	9677	0	0	\N
313478	764	3307760000000	19181	9677	1	0	\N
313479	1874	10534000	19181	9677	2	0	\N
313480	1874	10537000	19181	9677	3	0	\N
313347	1678	21600733291000	19179	9677	0	0	0
313348	764	3307760000000	19179	9677	1	0	0
313349	1874	10534000	19179	9677	2	0	2
313350	1874	10537000	19179	9677	3	0	2
313351	1874	10539000	19179	9677	4	0	2
313481	1874	10539000	19181	9677	4	0	\N
313485	1678	21600733292000	19183	9678	1	0	\N
313486	1874	10542000	19183	9678	2	0	\N
313487	1874	10544000	19183	9678	3	0	\N
313488	1678	21600733293000	19184	9679	0	0	\N
313489	1874	10547000	19184	9679	1	0	\N
313490	1874	10549000	19184	9679	2	0	\N
313501	1678	21600733294000	19187	9680	1	0	\N
313502	1678	21600733295000	19187	9680	2	0	\N
313503	1874	10550000	19187	9680	3	0	\N
313504	1874	10553000	19187	9680	4	0	\N
313505	1874	10555000	19187	9680	5	0	\N
313506	1874	10556000	19187	9680	6	0	\N
313507	1874	10558000	19187	9680	7	0	\N
313508	1874	10560000	19187	9680	9	0	\N
313509	1678	21600733296000	19188	9681	0	0	\N
313510	1874	10562000	19188	9681	1	0	\N
313511	1874	10565000	19188	9681	2	0	\N
313525	1678	21600733298000	19192	9683	0	0	\N
313526	1678	21600733299000	19192	9683	1	0	\N
313527	1874	10572000	19192	9683	2	0	\N
313528	1874	10575000	19192	9683	3	0	\N
313529	1874	10576000	19192	9683	4	0	\N
313530	1874	10579000	19192	9683	5	0	\N
313531	1874	10581000	19192	9683	6	0	\N
313532	1678	21600733300000	19193	9684	0	0	\N
313533	1874	10584000	19193	9684	1	0	\N
313534	1874	10586000	19193	9684	2	0	\N
313535	1678	21600733300000	19194	9684	0	0	\N
313536	1874	10584000	19194	9684	1	0	\N
313537	1874	10586000	19194	9684	2	0	\N
313551	1678	21600733302000	19198	9686	0	0	\N
313552	1678	21600733303000	19198	9686	1	0	\N
313553	1874	10594000	19198	9686	2	0	\N
313554	1874	10595000	19198	9686	3	0	\N
313555	1874	10597000	19198	9686	4	0	\N
313556	1874	10599000	19198	9686	5	0	\N
313557	1874	10602000	19198	9686	6	0	\N
313558	1678	21600733302000	19199	9686	0	0	\N
313559	1678	21600733303000	19199	9686	1	0	\N
313560	1874	10594000	19199	9686	2	0	\N
313561	1874	10595000	19199	9686	3	0	\N
313562	1874	10597000	19199	9686	4	0	\N
313563	1874	10599000	19199	9686	5	0	\N
313564	1874	10602000	19199	9686	6	0	\N
313565	2201	200000000	19200	9473	2	0	\N
313566	2200	9000000000	19200	9473	3	0	\N
313567	1678	20880721018000	19200	9473	4	0	\N
313568	1678	20880721019000	19200	9473	5	0	\N
313569	2200	1511000000000	19200	9473	6	0	\N
313570	1309	1708723637751650	19200	9473	7	0	\N
313571	1063	908815465000000	19200	9473	8	0	\N
313572	1183	613195750000000	19200	9473	9	0	\N
313573	943	507154775000000	19200	9473	10	0	\N
313574	1678	20880721020000	19200	9473	11	0	\N
313575	1678	20880721021000	19200	9473	12	0	\N
313576	1678	20880721022000	19200	9473	13	0	\N
313577	2202	200000000	19200	9473	14	0	\N
313578	2203	200000000	19200	9473	15	0	\N
313579	2204	200000000	19200	9473	16	0	\N
313580	1678	20880721023000	19200	9473	17	0	\N
313581	1678	20880721024000	19200	9473	18	0	\N
313582	1678	20880721025000	19200	9473	19	0	\N
313583	1678	20880721026000	19200	9473	20	0	\N
313584	1678	20880721027000	19200	9473	21	0	\N
313585	1678	20880721028000	19200	9473	22	0	\N
313586	1678	20880721029000	19200	9473	23	0	\N
313587	1678	20880721030000	19200	9473	24	0	\N
313588	1678	20880721031000	19200	9473	25	0	\N
313589	1678	20880721032000	19200	9473	26	0	\N
313590	1678	20880721033000	19200	9473	27	0	\N
313591	1678	20880721034000	19200	9473	28	0	\N
313592	1678	20880721035000	19200	9473	29	0	\N
313593	1678	20880721036000	19200	9473	30	0	\N
313594	1678	20880721037000	19200	9473	31	0	\N
313595	1678	20880721038000	19200	9473	32	0	\N
313596	1678	20880721039000	19200	9473	33	0	\N
313597	1678	20880721040000	19200	9473	34	0	\N
313598	1678	20880721041000	19200	9473	35	0	\N
313599	1678	20880721042000	19200	9473	36	0	\N
313600	1678	20880721043000	19200	9473	37	0	\N
313601	1678	20880721044000	19200	9473	38	0	\N
313602	1678	20880721045000	19200	9473	39	0	\N
313603	1474	11811354000023	19200	9473	40	0	\N
313604	1678	20880721046000	19200	9473	41	0	\N
313605	1678	20880721047000	19200	9473	42	0	\N
313606	1678	20880721048000	19200	9473	43	0	\N
313607	1678	20880721049000	19200	9473	44	0	\N
313608	1678	20880721050000	19200	9473	45	0	\N
313609	1678	20880721051000	19200	9473	46	0	\N
313610	1678	20880721052000	19200	9473	47	0	\N
313611	1678	20880721053000	19200	9473	48	0	\N
313612	1678	20880721054000	19200	9473	49	0	\N
313613	1678	20880721055000	19200	9473	50	0	\N
313614	1678	20880721056000	19200	9473	51	0	\N
313615	1678	20880721057000	19200	9473	52	0	\N
313616	1678	20880721058000	19200	9473	53	0	\N
313484	1874	10544000	19182	9678	3	0	2
313491	1678	21600733293000	19185	9679	0	0	0
313492	1874	10547000	19185	9679	1	0	2
313493	1678	21600733294000	19186	9680	1	0	0
313494	1678	21600733295000	19186	9680	2	0	0
313496	1874	10553000	19186	9680	4	0	2
313497	1874	10555000	19186	9680	5	0	2
313498	1874	10556000	19186	9680	6	0	2
313499	1874	10558000	19186	9680	7	0	2
313500	1874	10560000	19186	9680	9	0	2
313513	1874	10562000	19189	9681	1	0	2
313514	1874	10565000	19189	9681	2	0	2
313515	1678	21600733297000	19190	9682	0	0	0
313516	1874	10567000	19190	9682	1	0	2
313518	1678	21600733298000	19191	9683	0	0	0
313519	1678	21600733299000	19191	9683	1	0	0
313520	1874	10572000	19191	9683	2	0	2
313521	1874	10575000	19191	9683	3	0	2
313522	1874	10576000	19191	9683	4	0	2
313524	1874	10581000	19191	9683	6	0	2
313538	1678	21600733300000	19195	9684	0	0	0
313539	1874	10584000	19195	9684	1	0	2
313540	1874	10586000	19195	9684	2	0	2
313541	1678	21600733301000	19196	9685	0	0	0
313543	1874	10591000	19196	9685	2	0	2
313544	1678	21600733302000	19197	9686	0	0	0
313545	1678	21600733303000	19197	9686	1	0	0
313546	1874	10594000	19197	9686	2	0	2
313548	1874	10597000	19197	9686	4	0	2
313549	1874	10599000	19197	9686	5	0	2
313550	1874	10602000	19197	9686	6	0	2
313617	1678	20880721059000	19200	9473	54	0	\N
313618	1678	20880721060000	19200	9473	55	0	\N
313619	1678	20880721061000	19200	9473	56	0	\N
313620	1678	20880721062000	19200	9473	57	0	\N
313621	1678	20880721063000	19200	9473	59	0	\N
313622	1678	20880721064000	19200	9473	60	0	\N
313623	1678	20880721065000	19200	9473	61	0	\N
313624	1678	20880721066000	19200	9473	62	0	\N
313625	1678	20880721067000	19200	9473	63	0	\N
313626	1678	20880721068000	19200	9473	64	0	\N
313627	1678	20880721069000	19200	9473	65	0	\N
313628	1678	20880721070000	19200	9473	66	0	\N
313629	1678	20880721071000	19200	9473	67	0	\N
313630	1678	20880721072000	19200	9473	68	0	\N
313631	1678	20880721073000	19200	9473	69	0	\N
313632	1678	20880721074000	19200	9473	70	0	\N
313633	1678	20880721075000	19200	9473	71	0	\N
313634	1678	20880721076000	19200	9473	72	0	\N
313635	1678	20880721077000	19200	9473	73	0	\N
313636	1678	20880721078000	19200	9473	74	0	\N
313637	1678	20880721079000	19200	9473	75	0	\N
313638	1678	20880721080000	19200	9473	76	0	\N
313639	1678	20880721081000	19200	9473	77	0	\N
313640	1678	20880721082000	19200	9473	78	0	\N
313641	1678	20880721083000	19200	9473	79	0	\N
313642	1678	20880721084000	19200	9473	80	0	\N
313643	1678	20880721085000	19200	9473	81	0	\N
313644	1678	20880721086000	19200	9473	82	0	\N
313645	1678	20880721087000	19200	9473	83	0	\N
313646	1678	20880721088000	19200	9473	84	0	\N
313647	1678	20880721089000	19200	9473	85	0	\N
313648	1678	20880721090000	19200	9473	86	0	\N
313649	2205	200000000	19200	9473	87	0	\N
313650	2206	200000000	19200	9473	88	0	\N
313651	2207	200000000	19200	9473	89	0	\N
313652	2208	200000000	19200	9473	90	0	\N
313653	2210	200000000	19200	9473	91	0	\N
313654	2184	1399000000	19200	9473	92	0	\N
313655	1678	20880721091000	19200	9473	93	0	\N
313656	1678	20880721092000	19200	9473	94	0	\N
313657	1678	20880721093000	19200	9473	95	0	\N
313658	1678	20880721094000	19200	9473	96	0	\N
313659	1678	20880721095000	19200	9473	97	0	\N
313660	1678	20880721096000	19200	9473	98	0	\N
313661	1678	20880721097000	19200	9473	99	0	\N
313662	1678	20880721098000	19200	9473	100	0	\N
313663	1678	20880721099000	19200	9473	101	0	\N
313664	1678	20880721100000	19200	9473	102	0	\N
313665	1678	20880721101000	19200	9473	103	0	\N
313666	1678	20880721102000	19200	9473	104	0	\N
313667	1678	20880721103000	19200	9473	105	0	\N
313668	1678	20880721104000	19200	9473	106	0	\N
313669	1678	20880721105000	19200	9473	107	0	\N
313670	1678	20880721106000	19200	9473	108	0	\N
313671	1678	20880721107000	19200	9473	109	0	\N
313672	1678	20880721108000	19200	9473	110	0	\N
313673	1678	20880721109000	19200	9473	111	0	\N
313674	1678	20880721110000	19200	9473	112	0	\N
313675	1678	20880721111000	19200	9473	113	0	\N
313676	1678	20880721112000	19200	9473	114	0	\N
313677	1678	20880721113000	19200	9473	115	0	\N
313678	1678	20880721114000	19200	9473	116	0	\N
313679	1678	20880721115000	19200	9473	117	0	\N
313680	1678	20880721116000	19200	9473	118	0	\N
313681	1678	20880721117000	19200	9473	119	0	\N
313682	1678	20880721118000	19200	9473	120	0	\N
313683	1678	20880721119000	19200	9473	121	0	\N
313684	1678	20880721120000	19200	9473	122	0	\N
313685	1678	20880721121000	19200	9473	123	0	\N
313686	1678	20880721122000	19200	9473	124	0	\N
313687	1678	20880721123000	19200	9473	125	0	\N
313695	1678	21600733304000	19202	9687	0	0	\N
313696	1678	21600733305000	19202	9687	1	0	\N
313697	1874	10605000	19202	9687	2	0	\N
313698	1874	10608000	19202	9687	3	0	\N
313699	1874	10609000	19202	9687	4	0	\N
313700	1678	21600733306000	19203	9688	0	0	\N
313701	1678	21600733307000	19203	9688	1	0	\N
313702	1874	10615000	19203	9688	2	0	\N
313703	1874	10617000	19203	9688	3	0	\N
313704	1874	10620000	19203	9688	4	0	\N
313705	1874	10623000	19203	9688	5	0	\N
313732	1678	21600733313000	19207	9690	0	0	\N
313733	1874	10650000	19207	9690	1	0	\N
313734	1678	21600733314000	19208	9691	0	0	\N
313735	1874	10655000	19208	9691	1	0	\N
313736	1874	10657000	19208	9691	2	0	\N
313744	1678	21600733315000	19211	9692	0	0	\N
313745	1874	10660000	19211	9692	1	0	\N
313746	1874	10662000	19211	9692	2	0	\N
313747	1874	10663000	19211	9692	3	0	\N
313748	1678	21600733315000	19212	9692	0	0	\N
313749	1874	10660000	19212	9692	1	0	\N
313750	1874	10661000	19212	9692	2	0	\N
313690	1874	10604000	19201	9687	2	0	2
313691	1874	10606000	19201	9687	3	0	2
313692	1874	10609000	19201	9687	4	0	2
313693	1874	10612000	19201	9687	5	0	2
313694	1874	10613000	19201	9687	6	0	2
313707	1678	21600733307000	19204	9688	1	0	0
313708	1874	10615000	19204	9688	2	0	2
313709	1874	10617000	19204	9688	3	0	2
313710	1874	10620000	19204	9688	4	0	2
313711	1874	10623000	19204	9688	5	0	2
313713	1678	21600733309000	19205	9689	1	0	0
313714	1678	21600733310000	19205	9689	2	0	0
313715	1678	21600733311000	19205	9689	3	0	0
313716	1678	21600733312000	19205	9689	4	0	0
313718	1874	10626000	19205	9689	6	0	2
313719	1874	10628000	19205	9689	7	0	2
313720	1874	10629000	19205	9689	8	0	2
313721	1483	10000000	19205	9689	9	0	0
313722	1874	10632000	19205	9689	10	0	2
313724	1874	10638000	19205	9689	12	0	2
313725	1874	10641000	19205	9689	13	0	2
313726	1874	10643000	19205	9689	14	0	2
313727	1874	10645000	19205	9689	15	0	2
313728	1874	10647000	19205	9689	16	0	2
313730	1874	10649000	19206	9690	1	0	2
313731	1874	10652000	19206	9690	2	0	2
313737	1678	21600733314000	19209	9691	0	0	0
313738	1874	10655000	19209	9691	1	0	2
313740	1678	21600733315000	19210	9692	0	0	0
313741	1874	10660000	19210	9692	1	0	2
313742	1874	10662000	19210	9692	2	0	2
313743	1874	10663000	19210	9692	3	0	2
313751	1678	21600733316000	19213	9693	0	0	0
313754	1678	21600733317000	19214	9694	0	0	\N
313755	1678	21600733318000	19214	9694	1	0	\N
313756	1678	21600733319000	19214	9694	2	0	\N
313757	1678	21600733320000	19214	9694	3	0	\N
313758	1678	21600733321000	19214	9694	4	0	\N
313759	1678	21600733322000	19214	9694	5	0	\N
313760	1874	10670000	19214	9694	6	0	\N
313761	1874	10671000	19214	9694	7	0	\N
313762	1874	10674000	19214	9694	8	0	\N
313763	1874	10677000	19214	9694	9	0	\N
313764	1874	10678000	19214	9694	10	0	\N
313765	1874	10680000	19214	9694	11	0	\N
313766	1874	10683000	19214	9694	12	0	\N
313767	1874	10686000	19214	9694	13	0	\N
313768	1874	10689000	19214	9694	14	0	\N
313769	1874	10692000	19214	9694	15	0	\N
313770	1874	10694000	19214	9694	16	0	\N
313771	1874	10696000	19214	9694	17	0	\N
313772	1874	10698000	19214	9694	18	0	\N
313773	1874	10700000	19214	9694	19	0	\N
313774	1678	21600733317000	19215	9694	0	0	\N
313775	1678	21600733318000	19215	9694	1	0	\N
313776	1678	21600733319000	19215	9694	2	0	\N
313777	1678	21600733320000	19215	9694	3	0	\N
313778	1678	21600733321000	19215	9694	4	0	\N
313779	1678	21600733322000	19215	9694	5	0	\N
313780	1874	10669000	19215	9694	6	0	\N
313781	1874	10672000	19215	9694	7	0	\N
313782	1874	10675000	19215	9694	8	0	\N
313783	1874	10676000	19215	9694	9	0	\N
313784	1874	10679000	19215	9694	10	0	\N
313785	1874	10682000	19215	9694	11	0	\N
313786	1874	10685000	19215	9694	12	0	\N
313787	1874	10688000	19215	9694	13	0	\N
313808	1678	21600733323000	19217	9695	0	0	\N
313809	1678	21600733324000	19217	9695	1	0	\N
313810	1678	21600733325000	19217	9695	2	0	\N
313811	1874	10701000	19217	9695	3	0	\N
313812	1874	10703000	19217	9695	4	0	\N
313813	1874	10705000	19217	9695	5	0	\N
313814	1874	10707000	19217	9695	6	0	\N
313815	1874	10710000	19217	9695	8	0	\N
313816	1874	10713000	19217	9695	9	0	\N
313817	1874	10716000	19217	9695	10	0	\N
313818	1678	21600733323000	19218	9695	0	0	\N
313819	1678	21600733324000	19218	9695	1	0	\N
313820	1678	21600733325000	19218	9695	2	0	\N
313821	1874	10701000	19218	9695	3	0	\N
313822	1874	10703000	19218	9695	4	0	\N
313823	1874	10705000	19218	9695	5	0	\N
313824	1874	10707000	19218	9695	6	0	\N
313825	1874	10710000	19218	9695	8	0	\N
313826	1874	10713000	19218	9695	9	0	\N
313827	1874	10716000	19218	9695	10	0	\N
313838	1678	21600733323000	19220	9695	0	0	\N
313839	1678	21600733324000	19220	9695	1	0	\N
313840	1678	21600733325000	19220	9695	2	0	\N
313841	1874	10701000	19220	9695	3	0	\N
313842	1874	10703000	19220	9695	4	0	\N
313843	1874	10705000	19220	9695	5	0	\N
313844	1874	10707000	19220	9695	6	0	\N
313845	1874	10710000	19220	9695	8	0	\N
313846	1874	10713000	19220	9695	9	0	\N
313847	1874	10716000	19220	9695	10	0	\N
313848	1678	21600733326000	19221	9696	0	0	\N
313849	1678	21600733327000	19221	9696	1	0	\N
313850	1874	10718000	19221	9696	2	0	\N
313851	1874	10720000	19221	9696	3	0	\N
313852	1678	21600733326000	19222	9696	0	0	\N
313853	1678	21600733327000	19222	9696	1	0	\N
313854	1874	10719000	19222	9696	2	0	\N
313855	1874	10721000	19222	9696	3	0	\N
313856	1874	10723000	19222	9696	4	0	\N
313857	1874	10726000	19222	9696	5	0	\N
313864	2213	200000000	19224	9675	2	0	\N
313865	1483	10000000	19224	9675	3	0	\N
313866	2213	200000000	19225	9697	0	0	\N
313867	1678	21600733328000	19225	9697	1	0	\N
313868	1874	10727000	19225	9697	2	0	\N
313869	1874	10730000	19225	9697	3	0	\N
313870	1874	10732000	19225	9697	4	0	\N
313871	2213	200000000	19226	9697	0	0	\N
313872	1678	21600733328000	19226	9697	1	0	\N
313873	1874	10727000	19226	9697	2	0	\N
313874	1874	10730000	19226	9697	3	0	\N
313875	1874	10732000	19226	9697	4	0	\N
313876	2213	200000000	19227	9697	0	0	\N
313877	1678	21600733328000	19227	9697	1	0	\N
313878	1874	10727000	19227	9697	2	0	\N
313879	1874	10730000	19227	9697	3	0	\N
313880	1874	10732000	19227	9697	4	0	\N
313881	2213	200000000	19228	9697	0	0	\N
313882	1678	21600733328000	19228	9697	1	0	\N
313883	1874	10727000	19228	9697	2	0	\N
313884	1874	10730000	19228	9697	3	0	\N
313885	1874	10732000	19228	9697	4	0	\N
313886	2213	200000000	19229	9697	0	0	\N
313887	1678	21600733328000	19229	9697	1	0	\N
313888	1874	10727000	19229	9697	2	0	\N
313789	1678	21600733318000	19216	9694	1	0	0
313790	1678	21600733319000	19216	9694	2	0	0
313791	1678	21600733320000	19216	9694	3	0	0
313792	1678	21600733321000	19216	9694	4	0	0
313793	1678	21600733322000	19216	9694	5	0	0
313795	1874	10671000	19216	9694	7	0	2
313796	1874	10674000	19216	9694	8	0	2
313797	1874	10677000	19216	9694	9	0	2
313798	1874	10678000	19216	9694	10	0	2
313799	1874	10680000	19216	9694	11	0	2
313801	1874	10686000	19216	9694	13	0	2
313802	1874	10689000	19216	9694	14	0	2
313803	1874	10692000	19216	9694	15	0	2
313804	1874	10694000	19216	9694	16	0	2
313806	1874	10698000	19216	9694	18	0	2
313807	1874	10700000	19216	9694	19	0	2
313828	1678	21600733323000	19219	9695	0	0	0
313829	1678	21600733324000	19219	9695	1	0	0
313830	1678	21600733325000	19219	9695	2	0	0
313832	1874	10703000	19219	9695	4	0	2
313833	1874	10705000	19219	9695	5	0	2
313834	1874	10707000	19219	9695	6	0	2
313835	1874	10710000	19219	9695	8	0	2
313836	1874	10713000	19219	9695	9	0	2
313858	1678	21600733326000	19223	9696	0	0	0
313859	1678	21600733327000	19223	9696	1	0	0
313860	1874	10719000	19223	9696	2	0	2
313861	1874	10721000	19223	9696	3	0	2
313863	1874	10726000	19223	9696	5	0	2
313889	1874	10730000	19229	9697	3	0	\N
313890	1874	10732000	19229	9697	4	0	\N
313891	2213	200000000	19230	9697	0	0	\N
313892	1678	21600733328000	19230	9697	1	0	\N
313893	1874	10727000	19230	9697	2	0	\N
313894	1874	10730000	19230	9697	3	0	\N
313895	1874	10732000	19230	9697	4	0	\N
313901	1874	10728000	19232	9697	0	0	\N
313905	1678	21600733329000	19234	9698	0	0	\N
313906	1874	10735000	19234	9698	1	0	\N
313907	1874	10737000	19234	9698	2	0	\N
313911	1678	21600733330000	19236	9699	0	0	\N
313912	1874	10740000	19236	9699	1	0	\N
313913	1874	10742000	19236	9699	2	0	\N
313914	1678	21600733330000	19237	9699	0	0	\N
313915	1874	10740000	19237	9699	1	0	\N
313916	1874	10742000	19237	9699	2	0	\N
313917	1874	10740000	19238	9699	0	0	\N
313918	1874	10742000	19238	9699	1	0	\N
313919	1678	21600733331000	19239	9700	0	0	\N
313920	1874	10744000	19239	9700	1	0	\N
313921	1874	10747000	19239	9700	2	0	\N
313922	1678	21600733331000	19240	9700	0	0	\N
313923	1874	10744000	19240	9700	1	0	\N
313924	1874	10747000	19240	9700	2	0	\N
313925	1678	21600733331000	19241	9700	0	0	\N
313926	1874	10744000	19241	9700	1	0	\N
313927	1874	10747000	19241	9700	2	0	\N
313947	2214	0	19246	9704	0	0	\N
313948	1874	10771000	19246	9704	1	0	\N
313949	1874	10774000	19246	9704	2	0	\N
313953	2214	0	19248	9704	0	0	\N
313954	1874	10771000	19248	9704	1	0	\N
313955	1874	10774000	19248	9704	2	0	\N
313966	1678	21600733338000	19251	9706	0	0	\N
313967	1874	10787000	19251	9706	1	0	\N
313968	1874	10790000	19251	9706	2	0	\N
313969	1678	21600733339000	19252	9707	0	0	\N
313970	1874	10792000	19252	9707	1	0	\N
313971	1874	10795000	19252	9707	2	0	\N
313983	1678	21600733340000	19255	9708	0	0	\N
313984	1678	21600733341000	19255	9708	1	0	\N
313985	1874	10796000	19255	9708	2	0	\N
313986	592	67440000000000	19255	9708	3	0	\N
313987	1874	10799000	19255	9708	4	0	\N
313988	1874	10802000	19255	9708	5	0	\N
313989	1874	10804000	19255	9708	6	0	\N
313990	1874	10806000	19255	9708	7	0	\N
313991	2213	200000000	19256	9604	2	0	\N
313992	2201	200000000	19256	9604	3	0	\N
313993	80	66000000000000	19256	9604	4	0	\N
313994	1309	1708723637751650	19256	9604	5	0	\N
313995	1063	908815465000000	19256	9604	6	0	\N
313996	1183	613195750000000	19256	9604	7	0	\N
313997	2214	0	19256	9604	8	0	\N
313998	943	507154775000000	19256	9604	9	0	\N
313999	764	3307760000000	19256	9604	10	0	\N
314000	2202	200000000	19256	9604	11	0	\N
314001	2203	200000000	19256	9604	12	0	\N
314002	2204	200000000	19256	9604	13	0	\N
314003	2205	200000000	19256	9604	14	0	\N
314004	2206	200000000	19256	9604	15	0	\N
314005	2207	200000000	19256	9604	16	0	\N
314006	2208	200000000	19256	9604	17	0	\N
314007	2210	200000000	19256	9604	18	0	\N
314008	2184	1399000000	19256	9604	19	0	\N
314009	2209	708000000000	19256	9604	20	0	\N
314010	2212	200000000	19256	9604	21	0	\N
314011	1874	10208000	19256	9604	22	0	\N
314012	967	507282475000000	19256	9604	23	0	\N
314013	2206	1400000000	19256	9604	24	0	\N
314014	1087	909006169720300	19256	9604	25	0	\N
314015	1333	1709039342094750	19256	9604	26	0	\N
314016	2148	4001506880750	19256	9604	27	0	\N
314017	1874	10211000	19256	9604	28	0	\N
314018	1874	10213000	19256	9604	29	0	\N
314019	1874	10215000	19256	9604	30	0	\N
314020	1874	10217000	19256	9604	31	0	\N
314021	1874	10219000	19256	9604	32	0	\N
314022	1874	10221000	19256	9604	33	0	\N
314023	1874	10223000	19256	9604	34	0	\N
314024	1874	10225000	19256	9604	35	0	\N
313898	1874	10727000	19231	9697	2	0	2
313899	1874	10730000	19231	9697	3	0	2
313900	1874	10732000	19231	9697	4	0	2
313902	1678	21600733329000	19233	9698	0	0	0
313903	1874	10735000	19233	9698	1	0	2
313908	1678	21600733330000	19235	9699	0	0	0
313909	1874	10740000	19235	9699	1	0	2
313910	1874	10742000	19235	9699	2	0	2
313928	1678	21600733331000	19242	9700	0	0	0
313929	1874	10744000	19242	9700	1	0	2
313931	1678	21600733332000	19243	9701	0	0	0
313932	80	66000000000000	19243	9701	1	0	0
313933	1874	10748000	19243	9701	2	0	2
313934	1874	10751000	19243	9701	3	0	2
313936	1498	0	19244	9702	0	0	0
313937	1678	21600733333000	19244	9702	1	0	0
313938	1678	21600733334000	19244	9702	2	0	0
313939	1874	10756000	19244	9702	3	0	2
313940	1874	10759000	19244	9702	4	0	2
313942	1874	10763000	19244	9702	6	0	2
313943	1678	21600733335000	19245	9703	0	0	0
313944	1874	10765000	19245	9703	1	0	2
313945	1874	10768000	19245	9703	2	0	2
313946	1874	10769000	19245	9703	3	0	2
313951	1874	10771000	19247	9704	1	0	2
313952	1874	10774000	19247	9704	2	0	2
313956	1678	21600733336000	19249	9705	0	0	0
313957	1678	21600733337000	19249	9705	1	0	0
313959	1874	10779000	19249	9705	3	0	2
313960	1874	10782000	19249	9705	4	0	2
313961	1874	10783000	19249	9705	5	0	2
313962	1874	10785000	19249	9705	6	0	2
313963	1678	21600733338000	19250	9706	0	0	0
313965	1874	10790000	19250	9706	2	0	2
313972	1678	21600733339000	19253	9707	0	0	0
313973	1874	10792000	19253	9707	1	0	2
313974	1874	10795000	19253	9707	2	0	2
313975	1678	21600733340000	19254	9708	0	0	0
313977	1874	10796000	19254	9708	2	0	2
313978	592	67440000000000	19254	9708	3	0	0
313979	1874	10799000	19254	9708	4	0	2
313980	1874	10802000	19254	9708	5	0	2
313982	1874	10806000	19254	9708	7	0	2
314025	1874	10227000	19256	9604	36	0	\N
314026	1874	10229000	19256	9604	37	0	\N
314027	1874	10231000	19256	9604	38	0	\N
314028	1874	10233000	19256	9604	39	0	\N
314029	1874	10235000	19256	9604	40	0	\N
314030	592	67440000000000	19256	9604	41	0	\N
314031	1483	10000000	19256	9604	42	0	\N
314032	1874	10237000	19256	9604	43	0	\N
314033	1874	10239000	19256	9604	44	0	\N
314034	1874	10242000	19256	9604	45	0	\N
314035	1874	10245000	19256	9604	46	0	\N
314036	1874	10248000	19256	9604	47	0	\N
314037	1874	10251000	19256	9604	48	0	\N
314038	1874	10254000	19256	9604	49	0	\N
314039	1874	10257000	19256	9604	50	0	\N
314040	1874	10260000	19256	9604	51	0	\N
314041	1874	10263000	19256	9604	52	0	\N
314042	1874	10266000	19256	9604	53	0	\N
314043	1874	10269000	19256	9604	54	0	\N
314044	1874	10272000	19256	9604	55	0	\N
314045	1874	10275000	19256	9604	56	0	\N
314046	1874	10278000	19256	9604	57	0	\N
314047	1874	10280000	19256	9604	58	0	\N
314048	1874	10282000	19256	9604	59	0	\N
314049	1874	10284000	19256	9604	60	0	\N
314050	1874	10286000	19256	9604	61	0	\N
314051	1874	10288000	19256	9604	62	0	\N
314052	1874	10290000	19256	9604	63	0	\N
314053	1874	10292000	19256	9604	64	0	\N
314054	1874	10294000	19256	9604	65	0	\N
314055	1874	10296000	19256	9604	66	0	\N
314056	1874	10298000	19256	9604	67	0	\N
314057	1874	10301000	19256	9604	68	0	\N
314058	1874	10304000	19256	9604	69	0	\N
314059	1874	10307000	19256	9604	70	0	\N
314060	1874	10310000	19256	9604	71	0	\N
314061	1874	10313000	19256	9604	72	0	\N
314062	1874	10316000	19256	9604	73	0	\N
314063	1874	10319000	19256	9604	74	0	\N
314064	1874	10322000	19256	9604	75	0	\N
314065	1874	10325000	19256	9604	76	0	\N
314066	1874	10328000	19256	9604	77	0	\N
314067	1874	10331000	19256	9604	79	0	\N
314068	1874	10334000	19256	9604	80	0	\N
314069	1874	10337000	19256	9604	81	0	\N
314070	1874	10340000	19256	9604	82	0	\N
314071	1874	10343000	19256	9604	83	0	\N
314072	1874	10346000	19256	9604	84	0	\N
314073	1678	21600733342000	19257	9709	0	0	\N
314074	1678	21600733343000	19257	9709	1	0	\N
314075	1678	21600733344000	19257	9709	2	0	\N
314076	1874	10808000	19257	9709	3	0	\N
314077	1874	10810000	19257	9709	4	0	\N
314078	1874	10812000	19257	9709	5	0	\N
314079	1874	10813000	19257	9709	6	0	\N
314080	1874	10816000	19257	9709	7	0	\N
314081	1874	10819000	19257	9709	8	0	\N
314082	1874	10822000	19257	9709	9	0	\N
314083	1678	21600733342000	19258	9709	0	0	\N
314084	1678	21600733343000	19258	9709	1	0	\N
314085	1678	21600733344000	19258	9709	2	0	\N
314086	1874	10808000	19258	9709	3	0	\N
314087	1874	10810000	19258	9709	4	0	\N
314088	1874	10812000	19258	9709	5	0	\N
314089	1874	10813000	19258	9709	6	0	\N
314090	1874	10816000	19258	9709	7	0	\N
314091	1874	10819000	19258	9709	8	0	\N
314092	1874	10822000	19258	9709	9	0	\N
314093	1678	21600733342000	19259	9709	0	0	\N
314094	1678	21600733343000	19259	9709	1	0	\N
314095	1678	21600733344000	19259	9709	2	0	\N
314096	1874	10808000	19259	9709	3	0	\N
314097	1874	10810000	19259	9709	4	0	\N
314098	1874	10812000	19259	9709	5	0	\N
314099	1874	10813000	19259	9709	6	0	\N
314100	1874	10816000	19259	9709	7	0	\N
314101	1874	10819000	19259	9709	8	0	\N
314102	1874	10822000	19259	9709	9	0	\N
314103	1678	21600733342000	19260	9709	0	0	\N
314104	1678	21600733343000	19260	9709	1	0	\N
314105	1678	21600733344000	19260	9709	2	0	\N
314106	1874	10808000	19260	9709	3	0	\N
314107	1874	10810000	19260	9709	4	0	\N
314108	1874	10812000	19260	9709	5	0	\N
314109	1874	10813000	19260	9709	6	0	\N
314110	1874	10816000	19260	9709	7	0	\N
314111	1874	10819000	19260	9709	8	0	\N
314112	1874	10822000	19260	9709	9	0	\N
314136	1678	21600733345000	19266	9710	0	0	\N
314137	1678	21600733346000	19266	9710	1	0	\N
314138	1678	21600733347000	19266	9710	2	0	\N
314139	1678	21600733348000	19266	9710	3	0	\N
314140	1678	21600733349000	19266	9710	4	0	\N
314141	1874	10824000	19266	9710	5	0	\N
314142	1874	10826000	19266	9710	6	0	\N
314143	1874	10827000	19266	9710	7	0	\N
314144	1874	10830000	19266	9710	8	0	\N
314145	1874	10833000	19266	9710	9	0	\N
314146	1874	10836000	19266	9710	10	0	\N
314147	1874	10839000	19266	9710	11	0	\N
314148	1874	10842000	19266	9710	12	0	\N
314149	1874	10844000	19266	9710	13	0	\N
314150	1874	10846000	19266	9710	14	0	\N
314151	1874	10848000	19266	9710	15	0	\N
314155	1678	21600733349000	19268	9714	0	0	\N
314156	1874	10846000	19268	9714	1	0	\N
314157	1874	10848000	19268	9714	2	0	\N
314158	1678	21600733349000	19269	9714	0	0	\N
314159	1874	10846000	19269	9714	1	0	\N
314160	1874	10848000	19269	9714	2	0	\N
314115	1678	21600733344000	19261	9709	2	0	0
314116	1874	10808000	19261	9709	3	0	2
314117	1874	10810000	19261	9709	4	0	2
314118	1874	10812000	19261	9709	5	0	2
314119	1874	10813000	19261	9709	6	0	2
314121	1874	10819000	19261	9709	8	0	2
314122	1874	10822000	19261	9709	9	0	2
314123	1678	21600733345000	19262	9710	0	0	0
314124	1874	10824000	19262	9710	1	0	2
314125	1874	10827000	19262	9710	2	0	2
314127	1874	10830000	19263	9711	1	0	2
314128	1874	10832000	19263	9711	2	0	2
314129	1678	21600733347000	19264	9712	0	0	0
314130	1874	10835000	19264	9712	1	0	2
314132	1874	10838000	19264	9712	3	0	2
314133	1678	21600733348000	19265	9713	0	0	0
314134	1874	10840000	19265	9713	1	0	2
314135	1874	10843000	19265	9713	2	0	2
314152	1678	21600733349000	19267	9714	0	0	0
314154	1874	10848000	19267	9714	2	0	2
314161	1678	21600733349000	19270	9714	0	0	\N
314162	1874	10846000	19270	9714	1	0	\N
314163	1874	10848000	19270	9714	2	0	\N
314174	1678	21600733352000	19274	9717	0	0	\N
314175	1874	10861000	19274	9717	1	0	\N
314176	1874	10864000	19274	9717	2	0	\N
314177	1678	21600733352000	19275	9717	0	0	\N
314178	1874	10861000	19275	9717	1	0	\N
314179	1874	10864000	19275	9717	2	0	\N
314180	1678	21600733352000	19276	9717	0	0	\N
314181	1874	10861000	19276	9717	1	0	\N
314182	1874	10864000	19276	9717	2	0	\N
314193	1678	21600733354000	19279	9719	0	0	\N
314194	1678	21600733355000	19279	9719	1	0	\N
314195	1874	10871000	19279	9719	2	0	\N
314196	1874	10874000	19279	9719	3	0	\N
314197	1874	10876000	19279	9719	4	0	\N
314198	1874	10877000	19279	9719	5	0	\N
314199	1678	21600733356000	19280	9720	0	0	\N
314200	1874	10880000	19280	9720	1	0	\N
314201	1874	10882000	19280	9720	2	0	\N
314216	266	66613928193897	19284	9722	0	0	\N
314217	1678	21600733358000	19284	9722	1	0	\N
314218	1678	21600733359000	19284	9722	2	0	\N
314219	1874	10891000	19284	9722	3	0	\N
314220	1874	10894000	19284	9722	4	0	\N
314221	1874	10896000	19284	9722	5	0	\N
314222	1874	10898000	19284	9722	6	0	\N
314223	1678	21600733360000	19285	9723	0	0	\N
314224	38	66083861377858	19285	9723	1	0	\N
314225	969	503416039028136	19285	9723	2	0	\N
314226	1089	902117228669776	19285	9723	3	0	\N
314227	1209	608676470139099	19285	9723	4	0	\N
314228	1335	1696131104536774	19285	9723	5	0	\N
314229	1874	10900000	19285	9723	6	0	\N
314230	1874	10903000	19285	9723	7	0	\N
314239	1678	21600733360000	19287	9723	0	0	\N
314240	38	66083861377858	19287	9723	1	0	\N
314241	969	503416039028136	19287	9723	2	0	\N
314242	1089	902117228669776	19287	9723	3	0	\N
314243	1209	608676470139099	19287	9723	4	0	\N
314244	1335	1696131104536774	19287	9723	5	0	\N
314245	1874	10900000	19287	9723	6	0	\N
314246	1874	10903000	19287	9723	7	0	\N
314272	1678	21600733364000	19291	9726	0	0	\N
314273	1678	21600733365000	19291	9726	1	0	\N
314274	1874	10922000	19291	9726	2	0	\N
314275	1874	10923000	19291	9726	3	0	\N
314276	1874	10925000	19291	9726	4	0	\N
314277	1874	10928000	19291	9726	5	0	\N
314278	1874	10930000	19291	9726	6	0	\N
314279	1678	21600733364000	19292	9726	0	0	\N
314280	1678	21600733365000	19292	9726	1	0	\N
314281	1874	10922000	19292	9726	2	0	\N
314282	1874	10923000	19292	9726	3	0	\N
314283	1874	10925000	19292	9726	4	0	\N
314284	1874	10928000	19292	9726	5	0	\N
314285	1874	10930000	19292	9726	6	0	\N
314289	1678	21600733366000	19294	9727	0	0	\N
314290	1874	10932000	19294	9727	1	0	\N
314291	1874	10935000	19294	9727	2	0	\N
314292	1678	21600733366000	19295	9727	0	0	\N
314293	1874	10932000	19295	9727	1	0	\N
314294	1874	10935000	19295	9727	2	0	\N
314166	1874	10853000	19271	9715	2	0	2
314167	1678	21600733351000	19272	9716	0	0	0
314168	1874	10854000	19272	9716	1	0	2
314169	1874	10856000	19272	9716	2	0	2
314170	1874	10859000	19272	9716	3	0	2
314172	1874	10861000	19273	9717	1	0	2
314173	1874	10864000	19273	9717	2	0	2
314183	266	66312928193897	19277	9718	0	0	1
314184	1678	21600733353000	19277	9718	1	0	0
314185	1874	10866000	19277	9718	2	0	2
314187	1678	21600733354000	19278	9719	0	0	0
314188	1678	21600733355000	19278	9719	1	0	0
314189	1874	10871000	19278	9719	2	0	2
314190	1874	10874000	19278	9719	3	0	2
314192	1874	10877000	19278	9719	5	0	2
314202	1678	21600733356000	19281	9720	0	0	0
314203	1874	10880000	19281	9720	1	0	2
314204	1874	10882000	19281	9720	2	0	2
314205	1678	21600733357000	19282	9721	0	0	0
314207	1874	10885000	19282	9721	2	0	2
314208	1874	10888000	19282	9721	3	0	2
314209	266	66613928193897	19283	9722	0	0	1
314210	1678	21600733358000	19283	9722	1	0	0
314211	1678	21600733359000	19283	9722	2	0	0
314213	1874	10894000	19283	9722	4	0	2
314214	1874	10896000	19283	9722	5	0	2
314215	1874	10898000	19283	9722	6	0	2
314231	1678	21600733360000	19286	9723	0	0	0
314233	969	503416039028136	19286	9723	2	0	0
314234	1089	902117228669776	19286	9723	3	0	0
314235	1209	608676470139099	19286	9723	4	0	0
314236	1335	1696131104536774	19286	9723	5	0	0
314237	1874	10900000	19286	9723	6	0	2
314247	1678	21600733361000	19288	9724	0	0	0
314248	1874	10905000	19288	9724	1	0	2
314249	1874	10908000	19288	9724	2	0	2
314250	1874	10909000	19288	9724	3	0	2
314251	1678	21600733362000	19289	9725	0	0	0
314253	1950	13889851000000	19289	9725	2	0	14
314254	1874	10912000	19289	9725	3	0	2
314255	1874	10915000	19289	9725	4	0	2
314256	2215	200000000	19289	9725	5	0	0
314258	2217	200000000	19289	9725	7	0	0
314259	1874	10917000	19289	9725	8	0	2
314260	1874	10919000	19289	9725	9	0	2
314261	2205	1399000000	19289	9725	10	0	1
314262	1930	2600000000	19289	9725	11	0	0
314264	2219	200000000	19289	9725	13	0	0
314265	1678	21600733364000	19290	9726	0	0	0
314266	1678	21600733365000	19290	9726	1	0	0
314267	1874	10922000	19290	9726	2	0	2
314268	1874	10923000	19290	9726	3	0	2
314270	1874	10928000	19290	9726	5	0	2
314271	1874	10930000	19290	9726	6	0	2
314286	1678	21600733366000	19293	9727	0	0	0
314287	1874	10932000	19293	9727	1	0	2
314295	1678	21600733367000	19296	9728	0	0	0
314296	1678	21600733368000	19296	9728	1	0	0
314302	1678	21600733369000	19297	9729	0	0	\N
314303	1874	10949000	19297	9729	1	0	\N
314304	1874	10951000	19297	9729	2	0	\N
314318	38	66119808346940	19303	9734	0	0	\N
314319	1678	21600733373000	19303	9734	1	0	\N
314320	1678	21600733374000	19303	9734	2	0	\N
314321	969	503689580754480	19303	9734	3	0	\N
314322	1089	902607413099680	19303	9734	4	0	\N
314323	1209	609007207341570	19303	9734	5	0	\N
314324	1335	1697052733158970	19303	9734	6	0	\N
314325	1678	21600733375000	19303	9734	7	0	\N
314326	1678	21600733376000	19303	9734	8	0	\N
314327	1724	16497457500000	19303	9734	9	0	\N
314328	1874	10969000	19303	9734	10	0	\N
314329	1874	10972000	19303	9734	11	0	\N
314330	1874	10974000	19303	9734	12	0	\N
314331	1874	10977000	19303	9734	13	0	\N
314332	1874	10980000	19303	9734	14	0	\N
314333	1874	10983000	19303	9734	15	0	\N
314334	1874	10985000	19303	9734	16	0	\N
314335	1874	10986000	19303	9734	17	0	\N
314336	1874	10988000	19303	9734	19	0	\N
314337	38	66119808346940	19304	9734	0	0	\N
314338	1678	21600733373000	19304	9734	1	0	\N
314339	1678	21600733374000	19304	9734	2	0	\N
314340	969	503689580754480	19304	9734	3	0	\N
314341	1089	902607413099680	19304	9734	4	0	\N
314342	1209	609007207341570	19304	9734	5	0	\N
314343	1335	1697052733158970	19304	9734	6	0	\N
314344	1678	21600733375000	19304	9734	7	0	\N
314345	1678	21600733376000	19304	9734	8	0	\N
314346	1724	16497457500000	19304	9734	9	0	\N
314347	1874	10969000	19304	9734	10	0	\N
314348	1874	10972000	19304	9734	11	0	\N
314349	1874	10974000	19304	9734	12	0	\N
314350	1874	10977000	19304	9734	13	0	\N
314351	1874	10980000	19304	9734	14	0	\N
314352	1874	10983000	19304	9734	15	0	\N
314353	1874	10985000	19304	9734	16	0	\N
314354	1874	10986000	19304	9734	17	0	\N
314355	1874	10988000	19304	9734	19	0	\N
314375	38	66119808346940	19306	9734	0	0	\N
314376	1678	21600733373000	19306	9734	1	0	\N
314377	1678	21600733374000	19306	9734	2	0	\N
314378	969	503689580754480	19306	9734	3	0	\N
314379	1089	902607413099680	19306	9734	4	0	\N
314380	1209	609007207341570	19306	9734	5	0	\N
314381	1335	1697052733158970	19306	9734	6	0	\N
314382	1678	21600733375000	19306	9734	7	0	\N
314383	1678	21600733376000	19306	9734	8	0	\N
314384	1724	16497457500000	19306	9734	9	0	\N
314385	1874	10969000	19306	9734	10	0	\N
314386	1874	10972000	19306	9734	11	0	\N
314387	1874	10974000	19306	9734	12	0	\N
314388	1874	10977000	19306	9734	13	0	\N
314389	1874	10980000	19306	9734	14	0	\N
314390	1874	10983000	19306	9734	15	0	\N
314391	1874	10985000	19306	9734	16	0	\N
314392	1874	10986000	19306	9734	17	0	\N
314393	1874	10988000	19306	9734	19	0	\N
314401	1678	21600733377000	19308	9735	0	0	\N
314402	1678	21600733378000	19308	9735	1	0	\N
314403	1874	10989000	19308	9735	2	0	\N
314404	1874	10992000	19308	9735	3	0	\N
314405	1874	10994000	19308	9735	4	0	\N
314406	1874	10996000	19308	9735	5	0	\N
314407	1874	10999000	19308	9735	6	0	\N
314427	1678	21600733381000	19313	9739	0	0	\N
314428	1874	11018000	19313	9739	1	0	\N
314429	1874	11020000	19313	9739	2	0	\N
314430	1678	21600733381000	19314	9739	0	0	\N
314431	1874	11018000	19314	9739	1	0	\N
314432	1874	11020000	19314	9739	2	0	\N
314299	1874	10940000	19296	9728	4	0	2
314300	1874	10943000	19296	9728	5	0	2
314301	1874	10946000	19296	9728	6	0	2
314305	1678	21600733369000	19298	9729	0	0	0
314306	1874	10949000	19298	9729	1	0	2
314308	1678	21600733370000	19299	9730	0	0	0
314309	1874	10953000	19299	9730	1	0	2
314310	1874	10956000	19299	9730	2	0	2
314311	1678	21600733371000	19300	9731	0	0	0
314312	1874	10957000	19300	9731	1	0	2
314314	1874	10962000	19300	9731	3	0	2
314315	1678	21600733372000	19301	9732	0	0	0
314316	1874	10965000	19301	9732	1	0	2
314317	1874	10967000	19301	9732	2	0	2
314357	1678	21600733373000	19305	9734	1	0	0
314358	1678	21600733374000	19305	9734	2	0	0
314359	969	503689580754480	19305	9734	3	0	0
314360	1089	902607413099680	19305	9734	4	0	0
314361	1209	609007207341570	19305	9734	5	0	0
314363	1678	21600733375000	19305	9734	7	0	0
314364	1678	21600733376000	19305	9734	8	0	0
314365	1724	16497457500000	19305	9734	9	0	9
314366	1874	10969000	19305	9734	10	0	2
314367	1874	10972000	19305	9734	11	0	2
314369	1874	10977000	19305	9734	13	0	2
314370	1874	10980000	19305	9734	14	0	2
314371	1874	10983000	19305	9734	15	0	2
314372	1874	10985000	19305	9734	16	0	2
314374	1874	10988000	19305	9734	19	0	2
314394	1678	21600733377000	19307	9735	0	0	0
314395	1678	21600733378000	19307	9735	1	0	0
314396	1874	10989000	19307	9735	2	0	2
314397	1874	10992000	19307	9735	3	0	2
314399	1874	10996000	19307	9735	5	0	2
314400	1874	10999000	19307	9735	6	0	2
314408	1874	11002000	19309	9736	0	0	2
314409	1874	11004000	19309	9736	1	0	2
314410	1678	21600733379000	19310	9737	0	0	0
314412	1874	11009000	19310	9737	2	0	2
314413	38	66191662385104	19311	9738	0	0	0
314414	969	504236664207168	19311	9738	1	0	0
314415	1089	903587781959488	19311	9738	2	0	0
314417	1209	609668681746512	19311	9738	4	0	0
314418	1335	1698895990403362	19311	9738	5	0	0
314419	1874	11010000	19311	9738	6	0	2
314420	2220	200000000	19311	9738	7	0	0
314421	2221	200000000	19311	9738	8	0	0
314423	1874	11015000	19311	9738	10	0	2
314424	1678	21600733381000	19312	9739	0	0	0
314425	1874	11018000	19312	9739	1	0	2
314426	1874	11020000	19312	9739	2	0	2
314433	1678	21600733381000	19315	9739	0	0	\N
314434	1874	11018000	19315	9739	1	0	\N
314435	1874	11020000	19315	9739	2	0	\N
314451	1678	21600733384000	19318	9741	0	0	\N
314452	38	66203641224798	19318	9741	1	0	\N
314453	969	504327844782616	19318	9741	2	0	\N
314454	1089	903751176769456	19318	9741	3	0	\N
314455	1209	609778927480669	19318	9741	4	0	\N
314456	1335	1699203199944094	19318	9741	5	0	\N
314457	1874	11034000	19318	9741	6	0	\N
314458	1874	11036000	19318	9741	7	0	\N
314466	266	66312928193897	19321	9655	2	0	\N
314467	2213	200000000	19321	9655	3	0	\N
314468	266	66613928193897	19321	9655	4	0	\N
314469	80	66000000000000	19321	9655	5	0	\N
314470	1309	1708723637751650	19321	9655	6	0	\N
314471	1063	908815465000000	19321	9655	7	0	\N
314472	1183	613195750000000	19321	9655	8	0	\N
314473	2214	0	19321	9655	9	0	\N
314474	38	66083861377858	19321	9655	10	0	\N
314475	969	503416039028136	19321	9655	11	0	\N
314476	943	507154775000000	19321	9655	12	0	\N
314477	764	3307760000000	19321	9655	13	0	\N
314478	1089	902117228669776	19321	9655	14	0	\N
314479	1209	608676470139099	19321	9655	15	0	\N
314480	1335	1696131104536774	19321	9655	16	0	\N
314481	38	66119808346940	19321	9655	17	0	\N
314482	969	503689580754480	19321	9655	18	0	\N
314483	1089	902607413099680	19321	9655	19	0	\N
314484	1209	609007207341570	19321	9655	20	0	\N
314485	1335	1697052733158970	19321	9655	21	0	\N
314486	38	66191662385104	19321	9655	22	0	\N
314487	969	504236664207168	19321	9655	23	0	\N
314488	1089	903587781959488	19321	9655	24	0	\N
314489	1209	609668681746512	19321	9655	25	0	\N
314490	1335	1698895990403362	19321	9655	26	0	\N
314491	38	66203641224798	19321	9655	27	0	\N
314492	969	504327844782616	19321	9655	28	0	\N
314493	1089	903751176769456	19321	9655	29	0	\N
314494	1209	609778927480669	19321	9655	30	0	\N
314495	1335	1699203199944094	19321	9655	31	0	\N
314496	1724	15777420500000	19321	9655	32	0	\N
314497	1950	13889851000000	19321	9655	33	0	\N
314498	2215	200000000	19321	9655	34	0	\N
314499	2216	200000000	19321	9655	35	0	\N
314500	2217	200000000	19321	9655	36	0	\N
314501	592	67440000000000	19321	9655	37	0	\N
314502	1483	10000000	19321	9655	38	0	\N
314503	2205	1399000000	19321	9655	39	0	\N
314504	1930	2600000000	19321	9655	40	0	\N
314505	2218	200000000	19321	9655	41	0	\N
314506	2219	200000000	19321	9655	42	0	\N
314507	2220	200000000	19321	9655	43	0	\N
314508	2221	200000000	19321	9655	44	0	\N
314509	266	66312928193897	19322	9684	0	0	\N
314510	2213	200000000	19322	9684	1	0	\N
314511	266	66613928193897	19322	9684	2	0	\N
314512	80	66000000000000	19322	9684	3	0	\N
314513	2214	0	19322	9684	4	0	\N
314514	38	66083861377858	19322	9684	5	0	\N
314515	969	503416039028136	19322	9684	6	0	\N
314516	1089	902117228669776	19322	9684	7	0	\N
314517	1678	21600733300000	19322	9684	8	0	\N
314518	1678	21600733301000	19322	9684	9	0	\N
314519	1678	21600733302000	19322	9684	10	0	\N
314520	1678	21600733303000	19322	9684	11	0	\N
314521	1678	21600733304000	19322	9684	12	0	\N
314522	1678	21600733305000	19322	9684	13	0	\N
314523	1678	21600733306000	19322	9684	14	0	\N
314524	1678	21600733307000	19322	9684	15	0	\N
314525	1678	21600733308000	19322	9684	16	0	\N
314526	1678	21600733309000	19322	9684	17	0	\N
314527	1678	21600733310000	19322	9684	18	0	\N
314528	1678	21600733311000	19322	9684	19	0	\N
314529	1678	21600733312000	19322	9684	20	0	\N
314530	1678	21600733313000	19322	9684	21	0	\N
314531	1678	21600733314000	19322	9684	22	0	\N
314532	1678	21600733315000	19322	9684	23	0	\N
314533	1678	21600733316000	19322	9684	24	0	\N
314534	1678	21600733317000	19322	9684	25	0	\N
314535	1678	21600733318000	19322	9684	26	0	\N
314536	1678	21600733319000	19322	9684	27	0	\N
314537	1678	21600733320000	19322	9684	28	0	\N
314538	1678	21600733321000	19322	9684	29	0	\N
314539	1678	21600733322000	19322	9684	30	0	\N
314540	1678	21600733323000	19322	9684	31	0	\N
314541	1678	21600733324000	19322	9684	32	0	\N
314542	1678	21600733325000	19322	9684	33	0	\N
314543	1678	21600733326000	19322	9684	34	0	\N
314544	1678	21600733327000	19322	9684	35	0	\N
314545	1678	21600733328000	19322	9684	36	0	\N
314546	1678	21600733329000	19322	9684	37	0	\N
314547	1678	21600733330000	19322	9684	38	0	\N
314548	1678	21600733331000	19322	9684	39	0	\N
314549	1678	21600733332000	19322	9684	40	0	\N
314550	1678	21600733333000	19322	9684	41	0	\N
314551	1678	21600733334000	19322	9684	42	0	\N
314552	1678	21600733335000	19322	9684	43	0	\N
314553	1678	21600733336000	19322	9684	44	0	\N
314554	1678	21600733337000	19322	9684	45	0	\N
314555	1678	21600733338000	19322	9684	46	0	\N
314556	1678	21600733339000	19322	9684	47	0	\N
314557	1678	21600733340000	19322	9684	48	0	\N
314558	1678	21600733341000	19322	9684	49	0	\N
314559	1678	21600733342000	19322	9684	50	0	\N
314560	1678	21600733343000	19322	9684	51	0	\N
314561	1678	21600733344000	19322	9684	52	0	\N
314562	1678	21600733345000	19322	9684	53	0	\N
314563	1678	21600733346000	19322	9684	54	0	\N
314564	1678	21600733347000	19322	9684	55	0	\N
314565	1678	21600733348000	19322	9684	56	0	\N
314566	1678	21600733349000	19322	9684	57	0	\N
314567	1678	21600733350000	19322	9684	58	0	\N
314568	1678	21600733351000	19322	9684	59	0	\N
314438	1874	11021000	19316	9740	2	0	2
314439	1874	11023000	19316	9740	3	0	2
314440	1874	11025000	19316	9740	4	0	2
314441	1874	11028000	19316	9740	5	0	2
314442	1874	11031000	19316	9740	6	0	2
314444	38	66203641224798	19317	9741	1	0	0
314445	969	504327844782616	19317	9741	2	0	0
314446	1089	903751176769456	19317	9741	3	0	0
314447	1209	609778927480669	19317	9741	4	0	0
314448	1335	1699203199944094	19317	9741	5	0	0
314450	1874	11036000	19317	9741	7	0	2
314459	1678	21600733385000	19319	9742	0	0	0
314460	1874	11039000	19319	9742	1	0	2
314461	1874	11041000	19319	9742	2	0	2
314463	1874	11044000	19320	9743	1	0	2
314464	1874	11046000	19320	9743	2	0	2
314465	1874	11047000	19320	9743	3	0	2
314569	1678	21600733352000	19322	9684	60	0	\N
314570	1678	21600733353000	19322	9684	61	0	\N
314571	1678	21600733354000	19322	9684	62	0	\N
314572	1678	21600733355000	19322	9684	63	0	\N
314573	1678	21600733356000	19322	9684	64	0	\N
314574	1678	21600733357000	19322	9684	65	0	\N
314575	1678	21600733358000	19322	9684	66	0	\N
314576	1678	21600733359000	19322	9684	67	0	\N
314577	1678	21600733360000	19322	9684	68	0	\N
314578	1678	21600733361000	19322	9684	69	0	\N
314579	1678	21600733362000	19322	9684	70	0	\N
314580	1678	21600733363000	19322	9684	71	0	\N
314581	1678	21600733364000	19322	9684	72	0	\N
314582	1678	21600733365000	19322	9684	73	0	\N
314583	1678	21600733366000	19322	9684	74	0	\N
314584	1678	21600733367000	19322	9684	75	0	\N
314585	1678	21600733368000	19322	9684	76	0	\N
314586	1678	21600733369000	19322	9684	77	0	\N
314587	1678	21600733370000	19322	9684	78	0	\N
314588	1678	21600733371000	19322	9684	79	0	\N
314589	1678	21600733372000	19322	9684	80	0	\N
314590	1678	21600733373000	19322	9684	81	0	\N
314591	1678	21600733374000	19322	9684	82	0	\N
314592	1678	21600733375000	19322	9684	83	0	\N
314593	1678	21600733376000	19322	9684	84	0	\N
314594	1678	21600733377000	19322	9684	85	0	\N
314595	1678	21600733378000	19322	9684	86	0	\N
314596	1678	21600733379000	19322	9684	87	0	\N
314597	1678	21600733380000	19322	9684	88	0	\N
314598	1678	21600733381000	19322	9684	89	0	\N
314599	1678	21600733382000	19322	9684	90	0	\N
314600	1678	21600733383000	19322	9684	91	0	\N
314601	1678	21600733384000	19322	9684	92	0	\N
314602	1678	21600733385000	19322	9684	93	0	\N
314603	1678	21600733386000	19322	9684	94	0	\N
314604	1678	21600733387000	19322	9684	95	0	\N
314605	1678	21600733388000	19322	9684	96	0	\N
314606	1678	21600733389000	19322	9684	97	0	\N
314607	1209	608676470139099	19322	9684	98	0	\N
314608	1335	1696131104536774	19322	9684	99	0	\N
314609	38	66119808346940	19322	9684	100	0	\N
314610	969	503689580754480	19322	9684	101	0	\N
314611	1089	902607413099680	19322	9684	102	0	\N
314612	1209	609007207341570	19322	9684	103	0	\N
314613	1335	1697052733158970	19322	9684	104	0	\N
314614	38	66191662385104	19322	9684	106	0	\N
314615	969	504236664207168	19322	9684	107	0	\N
314616	1089	903587781959488	19322	9684	108	0	\N
314617	1209	609668681746512	19322	9684	109	0	\N
314618	1335	1698895990403362	19322	9684	110	0	\N
314619	38	66203641224798	19322	9684	111	0	\N
314620	969	504327844782616	19322	9684	112	0	\N
314621	1089	903751176769456	19322	9684	113	0	\N
314622	1209	609778927480669	19322	9684	114	0	\N
314623	1335	1699203199944094	19322	9684	115	0	\N
314624	1724	15777420500000	19322	9684	116	0	\N
314625	1874	10584000	19322	9684	117	0	\N
314626	1950	13889851000000	19322	9684	118	0	\N
314627	1874	10585000	19322	9684	119	0	\N
314628	1874	10587000	19322	9684	120	0	\N
314629	1874	10590000	19322	9684	121	0	\N
314630	1874	10593000	19322	9684	122	0	\N
314631	2215	200000000	19322	9684	123	0	\N
314632	2216	200000000	19322	9684	124	0	\N
314633	2217	200000000	19322	9684	125	0	\N
314652	38	66263620923268	19325	9745	0	0	\N
314653	969	504783747659856	19325	9745	1	0	\N
314654	1678	21600733390000	19325	9745	2	0	\N
314655	1089	904568150819296	19325	9745	3	0	\N
314656	1209	610330156151454	19325	9745	4	0	\N
314657	1335	1700739247647754	19325	9745	5	0	\N
314658	1874	11064000	19325	9745	6	0	\N
314659	1874	11067000	19325	9745	7	0	\N
314660	1874	11068000	19325	9745	8	0	\N
314661	1483	10000000	19326	9746	0	0	\N
314662	1678	21600733391000	19326	9746	1	0	\N
314663	1678	21600733392000	19326	9746	2	0	\N
314664	1678	21600733393000	19326	9746	3	0	\N
314665	1874	11071000	19326	9746	4	0	\N
314666	1874	11073000	19326	9746	5	0	\N
314667	1874	11075000	19326	9746	6	0	\N
314668	1874	11077000	19326	9746	7	0	\N
314669	1874	11078000	19326	9746	8	0	\N
314670	1874	11081000	19326	9746	9	0	\N
314671	1874	11084000	19326	9746	10	0	\N
314672	1483	10000000	19327	9746	0	0	\N
314673	1678	21600733391000	19327	9746	1	0	\N
314674	1678	21600733392000	19327	9746	2	0	\N
314675	1678	21600733393000	19327	9746	3	0	\N
314676	1874	11071000	19327	9746	4	0	\N
314677	1874	11073000	19327	9746	5	0	\N
314678	1874	11075000	19327	9746	6	0	\N
314679	1874	11077000	19327	9746	7	0	\N
314680	1874	11078000	19327	9746	8	0	\N
314681	1874	11081000	19327	9746	9	0	\N
314682	1874	11084000	19327	9746	10	0	\N
314694	1483	10000000	19329	9746	0	0	\N
314695	1678	21600733391000	19329	9746	1	0	\N
314696	1678	21600733392000	19329	9746	2	0	\N
314697	1678	21600733393000	19329	9746	3	0	\N
314698	1874	11071000	19329	9746	4	0	\N
314699	1874	11073000	19329	9746	5	0	\N
314700	1874	11075000	19329	9746	6	0	\N
314701	1874	11077000	19329	9746	7	0	\N
314702	1874	11078000	19329	9746	8	0	\N
314703	1874	11081000	19329	9746	9	0	\N
314704	1874	11084000	19329	9746	10	0	\N
314636	1678	21600733389000	19323	9744	2	0	0
314637	1874	11049000	19323	9744	3	0	2
314638	1874	11051000	19323	9744	4	0	2
314639	1874	11053000	19323	9744	5	0	2
314640	1874	11056000	19323	9744	6	0	2
314642	1874	11062000	19323	9744	8	0	2
314643	38	66263620923268	19324	9745	0	0	0
314644	969	504783747659856	19324	9745	1	0	0
314645	1678	21600733390000	19324	9745	2	0	0
314646	1089	904568150819296	19324	9745	3	0	0
314648	1335	1700739247647754	19324	9745	5	0	0
314649	1874	11064000	19324	9745	6	0	2
314650	1874	11067000	19324	9745	7	0	2
314651	1874	11068000	19324	9745	8	0	2
314684	1678	21600733391000	19328	9746	1	0	0
314685	1678	21600733392000	19328	9746	2	0	0
314686	1678	21600733393000	19328	9746	3	0	0
314687	1874	11071000	19328	9746	4	0	2
314688	1874	11073000	19328	9746	5	0	2
314690	1874	11077000	19328	9746	7	0	2
314691	1874	11078000	19328	9746	8	0	2
314692	1874	11081000	19328	9746	9	0	2
314693	1874	11084000	19328	9746	10	0	2
314715	1678	21600733394000	19331	9747	0	0	\N
314716	1678	21600733395000	19331	9747	1	0	\N
314717	38	66311549582044	19331	9747	2	0	\N
314718	969	505148469961648	19331	9747	3	0	\N
314719	1089	905221730059168	19331	9747	5	0	\N
314720	1209	610771139088082	19331	9747	6	0	\N
314721	1335	1701968085810682	19331	9747	7	0	\N
314722	1874	11086000	19331	9747	8	0	\N
314723	1874	11088000	19331	9747	9	0	\N
314724	1874	11091000	19331	9747	10	0	\N
314729	1678	21600733396000	19333	9748	0	0	\N
314730	1874	11092000	19333	9748	1	0	\N
314731	1874	11095000	19333	9748	2	0	\N
314732	1874	11097000	19333	9748	3	0	\N
314733	1678	21600733396000	19334	9748	0	0	\N
314734	1874	11092000	19334	9748	1	0	\N
314735	1874	11095000	19334	9748	2	0	\N
314736	1874	11097000	19334	9748	3	0	\N
314756	1678	21600733400000	19337	9750	0	0	\N
314757	1874	11113000	19337	9750	1	0	\N
314758	1874	11116000	19337	9750	2	0	\N
314762	1678	21600733402000	19339	9752	0	0	\N
314763	1678	21600733403000	19339	9752	1	0	\N
314764	1874	11124000	19339	9752	3	0	\N
314765	1874	11126000	19339	9752	5	0	\N
314766	1874	11129000	19339	9752	7	0	\N
314767	1874	11132000	19339	9752	8	0	\N
314768	1874	11134000	19339	9752	9	0	\N
314769	1678	21600733402000	19340	9752	0	0	\N
314770	1678	21600733403000	19340	9752	1	0	\N
314771	1874	11124000	19340	9752	3	0	\N
314772	1874	11126000	19340	9752	5	0	\N
314773	1874	11129000	19340	9752	7	0	\N
314774	1874	11132000	19340	9752	8	0	\N
314775	1874	11134000	19340	9752	9	0	\N
314783	1678	21600733402000	19342	9752	0	0	\N
314784	1678	21600733403000	19342	9752	1	0	\N
314785	1874	11124000	19342	9752	3	0	\N
314786	1874	11126000	19342	9752	5	0	\N
314787	1874	11129000	19342	9752	7	0	\N
314788	1874	11132000	19342	9752	8	0	\N
314789	1874	11134000	19342	9752	9	0	\N
314790	1678	21600733402000	19343	9752	0	0	\N
314791	1678	21600733403000	19343	9752	1	0	\N
314792	1874	11124000	19343	9752	3	0	\N
314793	1874	11126000	19343	9752	5	0	\N
314794	1874	11129000	19343	9752	7	0	\N
314795	1874	11132000	19343	9752	8	0	\N
314796	1874	11134000	19343	9752	9	0	\N
314807	1678	21600733406000	19347	9755	0	0	\N
314808	1874	11145000	19347	9755	1	0	\N
314809	1874	11147000	19347	9755	2	0	\N
314810	1874	11150000	19347	9755	3	0	\N
314811	1483	10000000	19349	9656	0	0	\N
314812	38	66263620923268	19349	9656	1	0	\N
314813	969	504783747659856	19349	9656	2	0	\N
314814	1089	904568150819296	19349	9656	3	0	\N
314815	1209	610330156151454	19349	9656	4	0	\N
314816	1335	1700739247647754	19349	9656	5	0	\N
314817	38	66311549582044	19349	9656	6	0	\N
314818	969	505148469961648	19349	9656	7	0	\N
314819	1089	905221730059168	19349	9656	8	0	\N
314820	1209	610771139088082	19349	9656	10	0	\N
314821	1335	1701968085810682	19349	9656	11	0	\N
314822	38	66335589911432	19349	9656	12	0	\N
314823	969	505330831112544	19349	9656	13	0	\N
314824	1089	905548519679104	19349	9656	14	0	\N
314825	1209	610991630556396	19349	9656	15	0	\N
314826	1335	1702582504892146	19349	9656	16	0	\N
314827	1406	0	19349	9656	17	0	\N
314831	1678	21600733408000	19351	9757	0	0	\N
314832	1874	11157000	19351	9757	1	0	\N
314833	1874	11160000	19351	9757	2	0	\N
314834	1678	21600733408000	19352	9757	0	0	\N
314835	1874	11157000	19352	9757	1	0	\N
314836	1874	11160000	19352	9757	2	0	\N
314707	38	66311549582044	19330	9747	2	0	0
314708	969	505148469961648	19330	9747	3	0	0
314709	1089	905221730059168	19330	9747	5	0	0
314710	1209	610771139088082	19330	9747	6	0	0
314711	1335	1701968085810682	19330	9747	7	0	0
314713	1874	11088000	19330	9747	9	0	2
314714	1874	11091000	19330	9747	10	0	2
314725	1678	21600733396000	19332	9748	0	0	0
314726	1874	11092000	19332	9748	1	0	2
314727	1874	11095000	19332	9748	2	0	2
314737	38	66335589911432	19335	9749	0	0	0
314738	969	505330831112544	19335	9749	1	0	0
314739	1089	905548519679104	19335	9749	2	0	0
314740	1209	610991630556396	19335	9749	3	0	0
314742	1678	21600733397000	19335	9749	5	0	0
314743	1678	21600733398000	19335	9749	6	0	0
314744	1678	21600733399000	19335	9749	7	0	0
314745	1874	11100000	19335	9749	8	0	2
314746	1874	11103000	19335	9749	9	0	2
314748	1874	11107000	19335	9749	11	0	2
314749	1874	11109000	19335	9749	12	0	2
314750	1874	11112000	19335	9749	13	0	2
314751	1406	0	19335	9749	14	0	0
314752	1678	21600733400000	19336	9750	0	0	0
314754	1874	11115000	19336	9750	2	0	2
314755	1874	11118000	19336	9750	3	0	2
314759	1678	21600733401000	19338	9751	0	0	0
314760	1874	11121000	19338	9751	1	0	2
314776	1678	21600733402000	19341	9752	0	0	0
314777	1678	21600733403000	19341	9752	1	0	0
314778	1874	11124000	19341	9752	3	0	2
314779	1874	11126000	19341	9752	5	0	2
314780	1874	11129000	19341	9752	7	0	2
314782	1874	11134000	19341	9752	9	0	2
314797	1678	21600733404000	19344	9753	0	0	0
314798	1874	11137000	19344	9753	1	0	2
314799	1874	11139000	19344	9753	2	0	2
314800	1678	21600733405000	19345	9754	0	0	0
314802	1874	11144000	19345	9754	2	0	2
314803	1678	21600733406000	19346	9755	0	0	0
314804	1874	11145000	19346	9755	1	0	2
314805	1874	11147000	19346	9755	2	0	2
314828	1678	21600733407000	19350	9756	0	0	0
314829	1874	11153000	19350	9756	1	0	2
314830	1874	11155000	19350	9756	2	0	2
314837	1874	11157000	19353	9757	0	0	2
314838	1678	21600733408000	19354	9758	0	0	0
314840	1678	21600733410000	19354	9758	2	0	0
314865	1483	10000000	19356	9731	0	0	\N
314866	1388	1711802704351650	19356	9731	1	0	\N
314867	1142	910452755600000	19356	9731	2	0	\N
314868	1262	614299826200000	19356	9731	3	0	\N
314869	1022	508069064000000	19356	9731	4	0	\N
314870	1724	16497457500000	19356	9731	5	0	\N
314871	2220	200000000	19356	9731	6	0	\N
314872	2221	200000000	19356	9731	7	0	\N
314873	2222	200000000	19356	9731	8	0	\N
314874	1406	0	19356	9731	10	0	\N
314875	1678	21600733412000	19357	9759	0	0	\N
314876	1678	21600733413000	19357	9759	1	0	\N
314877	1678	21600733414000	19357	9759	2	0	\N
314878	1388	1711802704351650	19357	9759	3	0	\N
314879	1142	910452755600000	19357	9759	4	0	\N
314880	1262	614299826200000	19357	9759	5	0	\N
314881	1022	508069064000000	19357	9759	6	0	\N
314882	1874	11177000	19357	9759	7	0	\N
314883	2222	200000000	19357	9759	8	0	\N
314884	1874	11180000	19357	9759	9	0	\N
314885	1874	11183000	19357	9759	10	0	\N
314886	1874	11186000	19357	9759	11	0	\N
314887	1874	11188000	19357	9759	12	0	\N
314888	1874	11190000	19357	9759	13	0	\N
314889	1874	11192000	19357	9759	14	0	\N
314890	1678	21600733412000	19358	9759	0	0	\N
314891	1678	21600733413000	19358	9759	1	0	\N
314892	1678	21600733414000	19358	9759	2	0	\N
314893	1388	1711802704351650	19358	9759	3	0	\N
314894	1142	910452755600000	19358	9759	4	0	\N
314895	1262	614299826200000	19358	9759	5	0	\N
314896	1022	508069064000000	19358	9759	6	0	\N
314897	1874	11177000	19358	9759	7	0	\N
314898	2222	200000000	19358	9759	8	0	\N
314899	1874	11180000	19358	9759	9	0	\N
314900	1874	11183000	19358	9759	10	0	\N
314901	1874	11186000	19358	9759	11	0	\N
314902	1874	11188000	19358	9759	12	0	\N
314903	1874	11190000	19358	9759	13	0	\N
314904	1874	11192000	19358	9759	14	0	\N
314905	1678	21600733412000	19359	9759	0	0	\N
314906	1678	21600733413000	19359	9759	1	0	\N
314907	1678	21600733414000	19359	9759	2	0	\N
314908	1388	1711802704351650	19359	9759	3	0	\N
314909	1142	910452755600000	19359	9759	4	0	\N
314910	1262	614299826200000	19359	9759	5	0	\N
314911	1022	508069064000000	19359	9759	6	0	\N
314912	1874	11177000	19359	9759	7	0	\N
314913	2222	200000000	19359	9759	8	0	\N
314914	1874	11180000	19359	9759	9	0	\N
314915	1874	11183000	19359	9759	10	0	\N
314916	1874	11186000	19359	9759	11	0	\N
314917	1874	11188000	19359	9759	12	0	\N
314918	1874	11190000	19359	9759	13	0	\N
314919	1874	11192000	19359	9759	14	0	\N
314923	1678	21600733416000	19361	9761	0	0	\N
314924	1874	11198000	19361	9761	1	0	\N
314925	1874	11201000	19361	9761	2	0	\N
314926	1874	11203000	19361	9761	3	0	\N
314936	1678	21600733419000	19364	9763	0	0	\N
314937	1874	11213000	19364	9763	1	0	\N
314938	1874	11216000	19364	9763	2	0	\N
314939	1678	21600733419000	19365	9763	0	0	\N
314940	1874	11213000	19365	9763	1	0	\N
314941	1874	11216000	19365	9763	2	0	\N
314952	1678	21600733420000	19368	9764	0	0	\N
314953	1678	21600733421000	19368	9764	1	0	\N
314954	1874	11219000	19368	9764	2	0	\N
314955	1874	11222000	19368	9764	3	0	\N
314956	1874	11224000	19368	9764	4	0	\N
314957	1874	11226000	19368	9764	5	0	\N
314958	1874	11227000	19368	9764	6	0	\N
314966	1678	21600733423000	19371	9766	0	0	\N
314967	1874	11233000	19371	9766	1	0	\N
314968	1874	11236000	19371	9766	2	0	\N
314969	1874	11238000	19371	9766	4	0	\N
314973	1678	21600733424000	19373	9767	0	0	\N
314974	1874	11241000	19373	9767	1	0	\N
314975	1874	11243000	19373	9767	2	0	\N
314976	1678	21600733425000	19374	9768	0	0	\N
314843	1874	11161000	19354	9758	5	0	2
314844	1874	11163000	19354	9758	6	0	2
314845	1874	11166000	19354	9758	7	0	2
314846	1874	11169000	19354	9758	8	0	2
314847	1874	11172000	19354	9758	9	0	2
314849	1874	11176000	19354	9758	11	0	2
314850	1678	21600733412000	19355	9759	0	0	0
314851	1678	21600733413000	19355	9759	1	0	0
314852	1678	21600733414000	19355	9759	2	0	0
314853	1388	1711802704351650	19355	9759	3	0	0
314855	1262	614299826200000	19355	9759	5	0	0
314856	1022	508069064000000	19355	9759	6	0	0
314857	1874	11177000	19355	9759	7	0	2
314858	2222	200000000	19355	9759	8	0	0
314860	1874	11183000	19355	9759	10	0	2
314861	1874	11186000	19355	9759	11	0	2
314862	1874	11188000	19355	9759	12	0	2
314863	1874	11190000	19355	9759	13	0	2
314864	1874	11192000	19355	9759	14	0	2
314921	1874	11194000	19360	9760	1	0	2
314922	1874	11197000	19360	9760	2	0	2
314927	1678	21600733416000	19362	9761	0	0	0
314928	1874	11198000	19362	9761	1	0	2
314929	1874	11201000	19362	9761	2	0	2
314931	1678	21600733417000	19363	9762	0	0	0
314932	1678	21600733418000	19363	9762	1	0	0
314933	1874	11205000	19363	9762	2	0	2
314934	1874	11208000	19363	9762	3	0	2
314942	1678	21600733419000	19366	9763	0	0	0
314943	1874	11213000	19366	9763	1	0	2
314944	1874	11216000	19366	9763	2	0	2
314945	1678	21600733420000	19367	9764	0	0	0
314946	1678	21600733421000	19367	9764	1	0	0
314948	1874	11222000	19367	9764	3	0	2
314949	1874	11224000	19367	9764	4	0	2
314950	1874	11226000	19367	9764	5	0	2
314951	1874	11227000	19367	9764	6	0	2
314959	1678	21600733422000	19369	9765	0	0	0
314961	1874	11232000	19369	9765	2	0	2
314962	1678	21600733423000	19370	9766	0	0	0
314963	1874	11233000	19370	9766	1	0	2
314964	1874	11236000	19370	9766	2	0	2
314970	1678	21600733424000	19372	9767	0	0	0
314971	1874	11241000	19372	9767	1	0	2
314972	1874	11243000	19372	9767	2	0	2
314977	1874	11245000	19374	9768	1	0	\N
314978	1874	11248000	19374	9768	2	0	\N
314979	1678	21600733425000	19375	9768	0	0	\N
314980	1874	11245000	19375	9768	1	0	\N
314981	1874	11248000	19375	9768	2	0	\N
314982	1678	21600733425000	19376	9768	0	0	\N
314983	1874	11245000	19376	9768	1	0	\N
314984	1874	11248000	19376	9768	2	0	\N
314985	1678	21600733425000	19377	9768	0	0	\N
314986	1874	11245000	19377	9768	1	0	\N
314987	1874	11248000	19377	9768	2	0	\N
314991	1388	1711802704351650	19379	9657	0	0	\N
314992	1142	910452755600000	19379	9657	1	0	\N
314993	1262	614299826200000	19379	9657	2	0	\N
314994	1022	508069064000000	19379	9657	3	0	\N
314995	2222	200000000	19379	9657	4	0	\N
314996	1678	21600733425000	19380	9768	0	0	\N
314997	1874	11245000	19380	9768	1	0	\N
315000	1678	21600733426000	19382	9769	0	0	\N
315001	1874	11250000	19382	9769	1	0	\N
315002	1678	21600733427000	19383	9770	0	0	\N
315003	1874	11251000	19383	9770	1	0	\N
315004	1874	11254000	19383	9770	2	0	\N
315005	1874	11256000	19383	9770	3	0	\N
315010	1678	21600733427000	19385	9770	0	0	\N
315011	1874	11251000	19385	9770	1	0	\N
315012	1874	11254000	19385	9770	2	0	\N
315013	1874	11256000	19385	9770	3	0	\N
315031	1678	21600733433000	19388	9773	0	0	\N
315032	2224	719063000000	19388	9773	1	0	\N
315033	1874	11285000	19388	9773	2	0	\N
315034	1874	11287000	19388	9773	3	0	\N
315035	1874	11288000	19388	9773	4	0	\N
315036	1678	21600733433000	19389	9773	0	0	\N
315037	2224	719063000000	19389	9773	1	0	\N
315038	1874	11285000	19389	9773	2	0	\N
315039	1874	11287000	19389	9773	3	0	\N
315040	1874	11288000	19389	9773	4	0	\N
315041	1678	21600733433000	19390	9773	0	0	\N
315042	2224	719063000000	19390	9773	1	0	\N
315043	1874	11285000	19390	9773	2	0	\N
315044	1874	11287000	19390	9773	3	0	\N
315045	1874	11288000	19390	9773	4	0	\N
315053	1874	11290000	19393	9774	0	0	\N
315054	1874	11293000	19393	9774	1	0	\N
315063	1678	21600733435000	19397	9776	0	0	\N
315064	1874	11301000	19397	9776	1	0	\N
315065	1697	1501990000000	19397	9776	2	0	\N
315066	1874	11303000	19397	9776	3	0	\N
315067	1678	21600733435000	19398	9776	0	0	\N
315068	1874	11301000	19398	9776	1	0	\N
315069	1697	1501990000000	19398	9776	2	0	\N
315070	1874	11303000	19398	9776	3	0	\N
315071	1678	21600733435000	19399	9776	0	0	\N
315072	1874	11301000	19399	9776	1	0	\N
315073	1697	1501990000000	19399	9776	2	0	\N
315074	1874	11303000	19399	9776	3	0	\N
315079	2223	200000000	19401	9658	0	0	\N
315080	1678	21600733437000	19402	9778	0	0	\N
315081	1697	2001990000000	19402	9778	1	0	\N
315082	1874	11311000	19402	9778	2	0	\N
315083	1874	11314000	19402	9778	3	0	\N
315086	1678	21600733437000	19404	9778	0	0	\N
315087	1697	2001990000000	19404	9778	1	0	\N
315088	1874	11311000	19404	9778	2	0	\N
315089	1874	11314000	19404	9778	3	0	\N
315095	1678	21600733438000	19406	9779	0	0	\N
315096	1874	11317000	19406	9779	1	0	\N
315097	1874	11319000	19406	9779	2	0	\N
315102	266	66312928193897	19408	9627	2	0	\N
315103	2210	200000000	19408	9627	3	0	\N
315104	1678	20880721218000	19408	9627	4	0	\N
315105	2213	200000000	19408	9627	5	0	\N
315106	2184	1399000000	19408	9627	6	0	\N
315107	1678	20880721219000	19408	9627	7	0	\N
315108	266	66613928193897	19408	9627	8	0	\N
315109	80	66000000000000	19408	9627	9	0	\N
315110	1678	20880721220000	19408	9627	10	0	\N
315111	1678	20880721221000	19408	9627	11	0	\N
315112	1678	20880721222000	19408	9627	12	0	\N
314990	1874	11248000	19378	9768	2	0	2
314998	1678	21600733426000	19381	9769	0	0	0
314999	1874	11250000	19381	9769	1	0	2
315006	1678	21600733427000	19384	9770	0	0	0
315007	1874	11251000	19384	9770	1	0	2
315009	1874	11256000	19384	9770	3	0	2
315014	1678	21600733428000	19386	9771	0	0	0
315015	1874	11258000	19386	9771	1	0	2
315016	1874	11261000	19386	9771	2	0	2
315017	1678	21600733429000	19387	9772	0	0	0
315019	1678	21600733431000	19387	9772	2	0	0
315020	1678	21600733432000	19387	9772	3	0	0
315021	2223	200000000	19387	9772	4	0	0
315022	1874	11264000	19387	9772	5	0	2
315024	1874	11270000	19387	9772	7	0	2
315025	1874	11272000	19387	9772	8	0	2
315026	1874	11274000	19387	9772	9	0	2
315027	1874	11276000	19387	9772	10	0	2
315028	1874	11278000	19387	9772	11	0	2
315030	1874	11282000	19387	9772	13	0	2
315046	1678	21600733433000	19391	9773	0	0	0
315047	2224	719063000000	19391	9773	1	0	0
315048	1874	11285000	19391	9773	2	0	2
315049	1874	11287000	19391	9773	3	0	2
315051	1874	11290000	19392	9774	0	0	2
315052	1874	11293000	19392	9774	1	0	2
315055	1498	0	19395	9775	0	0	0
315056	1678	21600733434000	19395	9775	1	0	0
315058	1874	11298000	19395	9775	3	0	2
315059	1678	21600733435000	19396	9776	0	0	0
315060	1874	11301000	19396	9776	1	0	2
315061	1697	1501990000000	19396	9776	2	0	1
315062	1874	11303000	19396	9776	3	0	2
315076	1874	11305000	19400	9777	1	0	2
315077	1874	11308000	19400	9777	2	0	2
315078	1874	11309000	19400	9777	3	0	2
315084	1678	21600733437000	19403	9778	0	0	0
315085	1697	2001990000000	19403	9778	1	0	1
315091	1874	11311000	19405	9779	1	0	2
315092	1874	11313000	19405	9779	2	0	2
315093	1874	11316000	19405	9779	3	0	2
315094	1874	11319000	19405	9779	4	0	2
315099	1874	11321000	19407	9780	1	0	2
315100	1874	11322000	19407	9780	2	0	2
315101	1874	11325000	19407	9780	3	0	2
315113	1678	20880721223000	19408	9627	13	0	\N
315114	1678	20880721224000	19408	9627	14	0	\N
315115	1309	1708723637751650	19408	9627	15	0	\N
315116	1063	908815465000000	19408	9627	16	0	\N
315117	1183	613195750000000	19408	9627	17	0	\N
315118	2214	0	19408	9627	18	0	\N
315119	38	66083861377858	19408	9627	19	0	\N
315120	969	503416039028136	19408	9627	20	0	\N
315121	1678	20880721225000	19408	9627	21	0	\N
315122	1678	20880721226000	19408	9627	22	0	\N
315123	1678	20880721227000	19408	9627	23	0	\N
315124	1678	20880721228000	19408	9627	24	0	\N
315125	1678	20880721229000	19408	9627	25	0	\N
315126	1678	20880721230000	19408	9627	26	0	\N
315127	1678	20880721231000	19408	9627	27	0	\N
315128	1678	20880721232000	19408	9627	28	0	\N
315129	1678	20880721233000	19408	9627	29	0	\N
315130	1678	20880721234000	19408	9627	30	0	\N
315131	943	507154775000000	19408	9627	31	0	\N
315132	764	3307760000000	19408	9627	32	0	\N
315133	1089	902117228669776	19408	9627	33	0	\N
315134	1388	1711802704351650	19408	9627	35	0	\N
315135	1142	910452755600000	19408	9627	36	0	\N
315136	1262	614299826200000	19408	9627	37	0	\N
315137	1022	508069064000000	19408	9627	38	0	\N
315138	1678	20880721235000	19408	9627	39	0	\N
315139	1678	20880721236000	19408	9627	40	0	\N
315140	1678	20880721237000	19408	9627	41	0	\N
315141	1678	20880721238000	19408	9627	42	0	\N
315142	1678	20880721239000	19408	9627	43	0	\N
315143	1678	20880721240000	19408	9627	44	0	\N
315144	1678	20880721241000	19408	9627	45	0	\N
315145	1678	20880721242000	19408	9627	46	0	\N
315146	1678	20880721243000	19408	9627	47	0	\N
315147	1678	20880721244000	19408	9627	48	0	\N
315148	1678	20880721245000	19408	9627	49	0	\N
315149	1678	20880721246000	19408	9627	50	0	\N
315150	1678	20880721247000	19408	9627	51	0	\N
315151	1678	20880721248000	19408	9627	52	0	\N
315152	1678	20880721249000	19408	9627	53	0	\N
315153	1678	20880721250000	19408	9627	54	0	\N
315154	1678	20880721251000	19408	9627	55	0	\N
315155	1678	20880721252000	19408	9627	56	0	\N
315156	1678	20880721253000	19408	9627	57	0	\N
315157	1678	20880721254000	19408	9627	58	0	\N
315158	1678	20880721255000	19408	9627	59	0	\N
315159	1678	20880721256000	19408	9627	60	0	\N
315160	1678	20880721257000	19408	9627	61	0	\N
315161	1678	20880721258000	19408	9627	62	0	\N
315162	1678	20880721259000	19408	9627	68	0	\N
315163	1678	20880721260000	19408	9627	69	0	\N
315164	1678	20880721261000	19408	9627	70	0	\N
315165	1678	20880721262000	19408	9627	71	0	\N
315166	1678	20880721263000	19408	9627	72	0	\N
315167	1678	20880721264000	19408	9627	73	0	\N
315168	1678	20880721265000	19408	9627	74	0	\N
315169	1678	20880721266000	19408	9627	75	0	\N
315170	1678	20880721267000	19408	9627	76	0	\N
315171	1678	20880721268000	19408	9627	77	0	\N
315172	1678	20880721269000	19408	9627	78	0	\N
315173	1678	20880721270000	19408	9627	79	0	\N
315174	1678	20880721271000	19408	9627	82	0	\N
315175	1678	20880721272000	19408	9627	83	0	\N
315176	1678	20880721273000	19408	9627	84	0	\N
315177	1678	20880721274000	19408	9627	85	0	\N
315178	1678	20880721275000	19408	9627	86	0	\N
315179	1678	20880721276000	19408	9627	87	0	\N
315180	1678	20880721277000	19408	9627	88	0	\N
315181	1678	20880721278000	19408	9627	89	0	\N
315182	1678	20880721279000	19408	9627	90	0	\N
315183	1678	20880721280000	19408	9627	91	0	\N
315184	1678	20880721281000	19408	9627	92	0	\N
315185	1678	20880721282000	19408	9627	93	0	\N
315186	1678	20880721283000	19408	9627	94	0	\N
315187	1678	20880721284000	19408	9627	95	0	\N
315188	1678	20880721285000	19408	9627	96	0	\N
315189	1678	20880721286000	19408	9627	97	0	\N
315190	1678	20880721287000	19408	9627	99	0	\N
315191	1678	20880721288000	19408	9627	100	0	\N
315192	1678	20880721289000	19408	9627	101	0	\N
315193	1678	20880721290000	19408	9627	102	0	\N
315194	1678	20880721291000	19408	9627	103	0	\N
315195	1678	20880721292000	19408	9627	104	0	\N
315196	1678	20880721293000	19408	9627	105	0	\N
315197	1678	20880721294000	19408	9627	106	0	\N
315198	1678	20880721295000	19408	9627	107	0	\N
315199	1678	20880721296000	19408	9627	108	0	\N
315200	1678	20880721297000	19408	9627	109	0	\N
315201	1678	20880721298000	19408	9627	110	0	\N
315202	1678	20880721299000	19408	9627	111	0	\N
315203	1678	20880721300000	19408	9627	112	0	\N
315204	1678	20880721301000	19408	9627	113	0	\N
315205	1678	20880721302000	19408	9627	114	0	\N
315206	1678	20880721303000	19408	9627	115	0	\N
315207	1678	20880721304000	19408	9627	116	0	\N
315208	1678	20880721305000	19408	9627	117	0	\N
315209	1678	20880721306000	19408	9627	118	0	\N
315210	1678	20880721307000	19408	9627	119	0	\N
315211	1678	20880721308000	19408	9627	120	0	\N
315212	1678	20880721309000	19408	9627	121	0	\N
315213	1678	20880721310000	19408	9627	122	0	\N
315214	1678	20880721311000	19408	9627	123	0	\N
315215	1678	20880721312000	19408	9627	124	0	\N
315216	1678	20880721313000	19408	9627	125	0	\N
315220	1678	21600733440000	19410	9781	0	0	\N
315221	1874	11328000	19410	9781	1	0	\N
315222	1874	11330000	19410	9781	2	0	\N
315239	1678	21600733445000	19415	9785	0	0	\N
315240	1874	11353000	19415	9785	1	0	\N
315241	1874	11356000	19415	9785	2	0	\N
315246	1678	21600733446000	19417	9786	0	0	\N
315247	1874	11358000	19417	9786	1	0	\N
315248	1874	11361000	19417	9786	2	0	\N
315219	1874	11330000	19409	9781	2	0	2
315223	1678	21600733441000	19411	9782	0	0	0
315224	1678	21600733442000	19411	9782	1	0	0
315225	1874	11332000	19411	9782	2	0	2
315226	1874	11333000	19411	9782	3	0	2
315228	1874	11339000	19411	9782	5	0	2
315229	1874	11341000	19411	9782	6	0	2
315230	1678	21600733443000	19413	9784	0	0	0
315231	1678	21600733444000	19413	9784	1	0	0
315232	1874	11344000	19413	9784	2	0	2
315234	1874	11349000	19413	9784	4	0	2
315235	1874	11351000	19413	9784	5	0	2
315236	1678	21600733445000	19414	9785	0	0	0
315237	1874	11353000	19414	9785	1	0	2
315242	1678	21600733446000	19416	9786	0	0	0
315243	1874	11358000	19416	9786	1	0	2
315244	1874	11361000	19416	9786	2	0	2
315245	1874	11362000	19416	9786	3	0	2
315249	1874	11362000	19417	9786	3	0	\N
315253	266	66312928193897	19419	9550	2	0	\N
315254	1678	21600733448000	19420	9788	0	0	\N
315255	1678	21600733449000	19420	9788	1	0	\N
315256	1874	11370000	19420	9788	2	0	\N
315257	1874	11371000	19420	9788	3	0	\N
315258	1874	11373000	19420	9788	4	0	\N
315259	1874	11375000	19420	9788	5	0	\N
315260	1874	11378000	19420	9788	6	0	\N
315268	1874	11370000	19422	9788	0	0	\N
315269	1874	11371000	19422	9788	1	0	\N
315270	1874	11374000	19422	9788	2	0	\N
315271	1678	21600733448000	19423	9788	0	0	\N
315272	1678	21600733449000	19423	9788	1	0	\N
315273	1874	11370000	19423	9788	2	0	\N
315274	1874	11371000	19423	9788	3	0	\N
315275	1874	11373000	19423	9788	4	0	\N
315276	1874	11375000	19423	9788	5	0	\N
315277	1874	11378000	19423	9788	6	0	\N
315284	1678	21600733452000	19425	9790	0	0	\N
315285	1874	11391000	19425	9790	1	0	\N
315286	1874	11393000	19425	9790	2	0	\N
315287	1874	11394000	19425	9790	3	0	\N
315296	1678	21600733454000	19428	9792	0	0	\N
315297	1874	11402000	19428	9792	1	0	\N
315298	1874	11404000	19428	9792	2	0	\N
315315	1678	21600733457000	19432	9794	0	0	\N
315316	1874	11417000	19432	9794	1	0	\N
315317	1874	11420000	19432	9794	2	0	\N
315326	1678	21600733458000	19435	9795	0	0	\N
315327	1678	21600733459000	19435	9795	1	0	\N
315328	1874	11423000	19435	9795	2	0	\N
315329	1874	11424000	19435	9795	3	0	\N
315330	1874	11426000	19435	9795	4	0	\N
315331	1874	11428000	19435	9795	5	0	\N
315332	2225	717000000000	19435	9795	6	0	\N
315333	1874	11431000	19435	9795	7	0	\N
315337	1678	21600733460000	19437	9796	0	0	\N
315338	1874	11434000	19437	9796	1	0	\N
315339	1874	11436000	19437	9796	2	0	\N
315340	1678	21600733461000	19439	9797	0	0	\N
315341	1678	21600733462000	19439	9797	1	0	\N
315342	1678	21600733463000	19439	9797	2	0	\N
315343	1678	21600733464000	19439	9797	3	0	\N
315344	1678	21600733465000	19439	9797	4	0	\N
315345	1874	11437000	19439	9797	5	0	\N
315346	2225	717100000000	19439	9797	6	0	\N
315347	1874	11440000	19439	9797	7	0	\N
315348	2227	200000000	19439	9797	8	0	\N
315349	1874	11442000	19439	9797	9	0	\N
315350	1874	11445000	19439	9797	10	0	\N
315351	1874	11448000	19439	9797	11	0	\N
315352	1874	11451000	19439	9797	12	0	\N
315353	1874	11454000	19439	9797	13	0	\N
315354	1874	11456000	19439	9797	14	0	\N
315355	1874	11458000	19439	9797	15	0	\N
315356	1874	11460000	19439	9797	16	0	\N
315357	1874	11462000	19439	9797	17	0	\N
315252	1874	11367000	19418	9787	2	0	2
315261	1678	21600733448000	19421	9788	0	0	0
315262	1678	21600733449000	19421	9788	1	0	0
315263	1874	11370000	19421	9788	2	0	2
315264	1874	11371000	19421	9788	3	0	2
315266	1874	11375000	19421	9788	5	0	2
315267	1874	11378000	19421	9788	6	0	2
315278	1678	21600733450000	19424	9789	0	0	0
315279	1678	21600733451000	19424	9789	1	0	0
315280	1874	11380000	19424	9789	2	0	2
315282	1874	11385000	19424	9789	4	0	2
315283	1874	11388000	19424	9789	5	0	2
315288	1678	21600733452000	19426	9790	0	0	0
315289	1874	11391000	19426	9790	1	0	2
315291	1874	11394000	19426	9790	3	0	2
315292	1678	21600733453000	19427	9791	0	0	0
315293	2225	0	19427	9791	1	0	0
315294	1874	11397000	19427	9791	2	0	2
315295	1874	11399000	19427	9791	3	0	2
315300	1874	11402000	19429	9792	1	0	2
315301	1874	11404000	19429	9792	2	0	2
315302	2226	500000000	19430	9793	0	0	0
315303	1958	4098987000000	19430	9793	1	0	2
315304	1678	21600733455000	19430	9793	2	0	0
315306	1874	11405000	19430	9793	4	0	2
315307	2225	1000000000	19430	9793	5	0	0
315308	1874	11408000	19430	9793	6	0	2
315309	1874	11411000	19430	9793	7	0	2
315311	1874	11415000	19430	9793	9	0	2
315312	1678	21600733457000	19431	9794	0	0	0
315313	1874	11417000	19431	9794	1	0	2
315314	1874	11420000	19431	9794	2	0	2
315318	1678	21600733458000	19433	9795	0	0	0
315320	1874	11423000	19433	9795	2	0	2
315321	1874	11424000	19433	9795	3	0	2
315322	1874	11426000	19433	9795	4	0	2
315323	1874	11428000	19433	9795	5	0	2
315324	2225	717000000000	19433	9795	6	0	0
315334	1678	21600733460000	19436	9796	0	0	0
315335	1874	11434000	19436	9796	1	0	2
315336	1874	11436000	19436	9796	2	0	2
315358	1678	21600733461000	19440	9797	0	0	0
315360	1678	21600733463000	19440	9797	2	0	0
315361	1678	21600733464000	19440	9797	3	0	0
315362	1678	21600733465000	19440	9797	4	0	0
315363	1874	11437000	19440	9797	5	0	2
315364	2225	717100000000	19440	9797	6	0	0
315366	2227	200000000	19440	9797	8	0	0
315367	1874	11442000	19440	9797	9	0	2
315368	1874	11445000	19440	9797	10	0	2
315369	1874	11448000	19440	9797	11	0	2
315370	1874	11451000	19440	9797	12	0	2
315372	1874	11456000	19440	9797	14	0	2
315373	1874	11458000	19440	9797	15	0	2
315374	1874	11460000	19440	9797	16	0	2
315375	1874	11462000	19440	9797	17	0	2
315377	1874	11465000	19441	9798	1	0	2
315378	1874	11466000	19441	9798	2	0	2
315379	1874	11468000	19441	9798	3	0	2
315380	1678	21600733467000	19442	9799	0	0	0
315381	1645	0	19442	9799	1	0	0
315383	1874	11473000	19442	9799	3	0	2
315384	1678	21600733468000	19443	9800	0	0	0
315392	1678	21600733469000	19447	9802	0	0	\N
315393	1678	21600733470000	19447	9802	1	0	\N
315394	1874	11479000	19447	9802	2	0	\N
315395	1874	11481000	19447	9802	3	0	\N
315396	1874	11483000	19447	9802	4	0	\N
315397	1874	11486000	19447	9802	5	0	\N
315398	1874	11489000	19447	9802	6	0	\N
315399	1678	21600733469000	19448	9802	0	0	\N
315400	1678	21600733470000	19448	9802	1	0	\N
315401	1874	11479000	19448	9802	2	0	\N
315402	1874	11481000	19448	9802	3	0	\N
315403	1874	11483000	19448	9802	4	0	\N
315404	1874	11486000	19448	9802	5	0	\N
315405	1874	11489000	19448	9802	6	0	\N
315406	1678	21600733469000	19449	9802	0	0	\N
315407	1678	21600733470000	19449	9802	1	0	\N
315408	1874	11479000	19449	9802	2	0	\N
315409	1874	11481000	19449	9802	3	0	\N
315410	1874	11483000	19449	9802	4	0	\N
315411	1874	11486000	19449	9802	5	0	\N
315412	1874	11489000	19449	9802	6	0	\N
315413	1678	21600733471000	19450	9803	0	0	\N
315414	1874	11487000	19450	9803	1	0	\N
315415	1874	11489000	19450	9803	2	0	\N
315416	1874	11492000	19450	9803	3	0	\N
315417	1874	11494000	19450	9803	4	0	\N
315420	1678	21600733471000	19452	9803	0	0	\N
315421	1874	11487000	19452	9803	1	0	\N
315422	1874	11489000	19452	9803	2	0	\N
315423	1874	11492000	19452	9803	3	0	\N
315424	1874	11494000	19452	9803	4	0	\N
315438	1678	21600733475000	19455	9806	0	0	\N
315439	1874	11512000	19455	9806	1	0	\N
315440	1874	11515000	19455	9806	2	0	\N
315458	1678	21600733480000	19459	9809	0	0	\N
315459	1874	11539000	19459	9809	1	0	\N
315460	1874	11542000	19459	9809	2	0	\N
315461	1678	21600733480000	19460	9809	0	0	\N
315462	1874	11539000	19460	9809	1	0	\N
315468	1678	21600733481000	19463	9810	0	0	\N
315469	1874	11544000	19463	9810	1	0	\N
315474	1678	21600733482000	19465	9811	0	0	\N
315475	1874	11545000	19465	9811	1	0	\N
315476	1874	11548000	19465	9811	2	0	\N
315477	1874	11550000	19465	9811	3	0	\N
315495	1678	21600733488000	19469	9815	0	0	\N
315496	1678	21600733488000	19470	9815	0	0	\N
315497	1874	11578000	19470	9815	1	0	\N
315498	1874	11581000	19470	9815	2	0	\N
315516	1678	21600733492000	19475	9819	0	0	\N
315517	1874	11599000	19475	9819	1	0	\N
315518	1874	11602000	19475	9819	2	0	\N
315519	1874	11603000	19475	9819	3	0	\N
315520	1982	1400000000	19475	9819	4	0	\N
315387	1678	21600733469000	19446	9802	0	0	0
315388	1678	21600733470000	19446	9802	1	0	0
315389	1874	11479000	19446	9802	2	0	2
315390	1874	11482000	19446	9802	3	0	2
315391	1874	11485000	19446	9802	4	0	2
315419	1874	11488000	19451	9803	1	0	2
315425	1678	21600733472000	19453	9804	0	0	0
315426	1678	21600733473000	19453	9804	1	0	0
315427	1874	11490000	19453	9804	2	0	2
315428	1874	11492000	19453	9804	3	0	2
315430	1874	11496000	19453	9804	5	0	2
315431	1874	11499000	19453	9804	6	0	2
315432	1874	11502000	19453	9804	7	0	2
315433	1874	11503000	19453	9804	8	0	2
315435	1678	21600733474000	19454	9805	0	0	0
315436	1874	11508000	19454	9805	1	0	2
315437	1874	11510000	19454	9805	2	0	2
315441	1678	21600733475000	19456	9806	0	0	0
315442	1874	11512000	19456	9806	1	0	2
315444	1678	21600733476000	19457	9807	0	0	0
315445	1874	11517000	19457	9807	1	0	2
315446	1874	11518000	19457	9807	2	0	2
315447	1874	11521000	19457	9807	3	0	2
315448	1678	21600733477000	19458	9808	0	0	0
315450	1678	21600733479000	19458	9808	2	0	0
315451	1874	11524000	19458	9808	3	0	2
315452	1874	11527000	19458	9808	4	0	2
315453	1874	11530000	19458	9808	5	0	2
315455	1874	11533000	19458	9808	7	0	2
315456	1874	11535000	19458	9808	8	0	2
315457	1874	11537000	19458	9808	9	0	2
315463	1678	21600733480000	19461	9809	0	0	0
315464	1874	11539000	19461	9809	1	0	2
315466	1678	21600733481000	19462	9810	0	0	0
315467	1874	11544000	19462	9810	1	0	2
315470	1678	21600733482000	19464	9811	0	0	0
315471	1874	11545000	19464	9811	1	0	2
315472	1874	11548000	19464	9811	2	0	2
315478	1678	21600733483000	19466	9812	0	0	0
315479	1874	11553000	19466	9812	1	0	2
315480	1874	11555000	19466	9812	2	0	2
315481	1678	21600733484000	19467	9813	0	0	0
315483	1678	21600733486000	19467	9813	2	0	0
315484	1982	200000000	19467	9813	3	0	0
315485	1874	11556000	19467	9813	4	0	2
315486	1874	11559000	19467	9813	5	0	2
315487	1874	11562000	19467	9813	6	0	2
315489	1874	11567000	19467	9813	8	0	2
315490	1874	11569000	19467	9813	9	0	2
315491	1874	11571000	19467	9813	10	0	2
315492	1678	21600733487000	19468	9814	0	0	0
315493	1874	11573000	19468	9814	1	0	2
315499	1678	21600733488000	19471	9815	0	0	0
315500	1874	11578000	19471	9815	1	0	2
315501	1874	11581000	19471	9815	2	0	2
315502	1678	21600733489000	19472	9816	0	0	0
315504	1874	11584000	19472	9816	2	0	2
315505	1874	11587000	19472	9816	3	0	2
315506	1678	21600733490000	19473	9817	0	0	0
315507	1874	11589000	19473	9817	1	0	2
315508	1874	11592000	19473	9817	2	0	2
315510	2214	2000000000	19474	9818	1	0	0
315511	1874	11594000	19474	9818	2	0	2
315512	2228	200000000	19474	9818	3	0	0
315513	2229	200000000	19474	9818	4	0	0
315514	2229	1400000000	19474	9818	5	0	0
315525	1678	21600733492000	19477	9819	0	0	\N
315526	1874	11599000	19477	9819	1	0	\N
315527	1874	11602000	19477	9819	2	0	\N
315528	1874	11603000	19477	9819	3	0	\N
315529	1982	1400000000	19477	9819	4	0	\N
315530	1678	21600733493000	19478	9820	0	0	\N
315531	1678	21600733494000	19478	9820	1	0	\N
315532	1874	11603000	19478	9820	2	0	\N
315533	1874	11606000	19478	9820	3	0	\N
315534	1874	11609000	19478	9820	4	0	\N
315535	2214	2502000000000	19478	9820	5	0	\N
315536	1874	11611000	19478	9820	6	0	\N
315537	1874	11613000	19478	9820	8	0	\N
315546	1874	11615000	19480	9821	0	0	\N
315549	1678	21600733495000	19482	9821	0	0	\N
315550	1874	11615000	19482	9821	1	0	\N
315551	1874	11618000	19482	9821	2	0	\N
315552	1678	21600733495000	19483	9821	0	0	\N
315553	1874	11615000	19483	9821	1	0	\N
315554	1874	11618000	19483	9821	2	0	\N
315555	1874	11616000	19484	9822	0	0	\N
315556	1874	11618000	19484	9822	1	0	\N
315557	1874	11621000	19484	9822	2	0	\N
315564	1678	21600733496000	19487	9823	0	0	\N
315565	1444	18232370159999	19487	9823	1	0	\N
315566	1874	11623000	19487	9823	2	0	\N
315567	1874	11626000	19487	9823	3	0	\N
315572	1444	18232370159999	19489	9824	0	0	\N
315573	1678	21600733497000	19489	9824	1	0	\N
315574	1874	11629000	19489	9824	2	0	\N
315575	1874	11631000	19489	9824	3	0	\N
315576	2230	0	19490	9825	0	0	\N
315577	1678	21600733498000	19490	9825	1	0	\N
315578	1874	11632000	19490	9825	2	0	\N
315579	1874	11635000	19490	9825	3	0	\N
315580	2230	0	19491	9825	0	0	\N
315581	1678	21600733498000	19491	9825	1	0	\N
315582	1874	11633000	19491	9825	2	0	\N
315583	1874	11634000	19491	9825	3	0	\N
315584	1874	11637000	19491	9825	4	0	\N
315590	1678	21600733498000	19493	9825	0	0	\N
315591	1874	11633000	19493	9825	1	0	\N
315592	1874	11634000	19493	9825	2	0	\N
315593	1874	11637000	19493	9825	3	0	\N
315610	1678	21600733503000	19497	9828	0	0	\N
315611	1874	11661000	19497	9828	1	0	\N
315612	1874	11663000	19497	9828	2	0	\N
315616	1678	21600733505000	19499	9830	0	0	\N
315617	1874	11671000	19499	9830	1	0	\N
315618	1874	11672000	19499	9830	2	0	\N
315619	1874	11674000	19499	9830	3	0	\N
315620	1678	21600733505000	19500	9830	0	0	\N
315621	1874	11671000	19500	9830	1	0	\N
315622	1874	11672000	19500	9830	2	0	\N
315623	1874	11674000	19500	9830	3	0	\N
315624	1678	21600733505000	19501	9830	0	0	\N
315625	1874	11671000	19501	9830	1	0	\N
315626	1874	11672000	19501	9830	2	0	\N
315627	1874	11674000	19501	9830	3	0	\N
315632	1678	21600733505000	19503	9830	0	0	\N
315633	1874	11671000	19503	9830	1	0	\N
315634	1874	11672000	19503	9830	2	0	\N
315635	1874	11674000	19503	9830	3	0	\N
315636	1678	21600733506000	19504	9831	0	0	\N
315637	1678	21600733507000	19504	9831	1	0	\N
315638	1874	11676000	19504	9831	2	0	\N
315639	1874	11678000	19504	9831	3	0	\N
315640	1874	11681000	19504	9831	4	0	\N
315641	1874	11684000	19504	9831	5	0	\N
315642	1678	21600733506000	19505	9831	0	0	\N
315643	1678	21600733507000	19505	9831	1	0	\N
315644	1874	11676000	19505	9831	2	0	\N
315645	1874	11678000	19505	9831	3	0	\N
315646	1874	11681000	19505	9831	4	0	\N
315647	1874	11684000	19505	9831	5	0	\N
315648	1678	21600733506000	19506	9831	0	0	\N
315649	1678	21600733507000	19506	9831	1	0	\N
315650	1874	11676000	19506	9831	2	0	\N
315651	1874	11678000	19506	9831	3	0	\N
315652	1874	11681000	19506	9831	4	0	\N
315653	1874	11684000	19506	9831	5	0	\N
315523	1874	11601000	19476	9819	2	0	2
315524	1982	1400000000	19476	9819	3	0	0
315538	1678	21600733493000	19479	9820	0	0	0
315539	1678	21600733494000	19479	9820	1	0	0
315540	1874	11603000	19479	9820	2	0	2
315542	1874	11609000	19479	9820	4	0	2
315543	2214	2502000000000	19479	9820	5	0	0
315544	1874	11611000	19479	9820	6	0	2
315545	1874	11613000	19479	9820	8	0	2
315547	1678	21600733495000	19481	9821	0	0	0
315558	1874	11616000	19485	9822	0	0	2
315559	1874	11618000	19485	9822	1	0	2
315560	1874	11621000	19485	9822	2	0	2
315561	1678	21600733496000	19486	9823	0	0	0
315563	1874	11626000	19486	9823	2	0	2
315568	1444	18232370159999	19488	9824	0	0	8
315569	1678	21600733497000	19488	9824	1	0	0
315570	1874	11629000	19488	9824	2	0	2
315571	1874	11631000	19488	9824	3	0	2
315586	1678	21600733498000	19492	9825	1	0	0
315587	1874	11633000	19492	9825	2	0	2
315588	1874	11634000	19492	9825	3	0	2
315589	1874	11637000	19492	9825	4	0	2
315594	1678	21600733499000	19494	9826	0	0	0
315596	1874	11642000	19494	9826	2	0	2
315597	1678	21600733500000	19495	9827	0	0	0
315598	1678	21600733501000	19495	9827	1	0	0
315599	1678	21600733502000	19495	9827	2	0	0
315601	1874	11647000	19495	9827	4	0	2
315602	1874	11650000	19495	9827	5	0	2
315603	1874	11653000	19495	9827	6	0	2
315604	1874	11655000	19495	9827	7	0	2
315605	1874	11657000	19495	9827	8	0	2
315607	1678	21600733503000	19496	9828	0	0	0
315608	1874	11661000	19496	9828	1	0	2
315609	1874	11663000	19496	9828	2	0	2
315613	1678	21600733504000	19498	9829	0	0	0
315614	1874	11666000	19498	9829	1	0	2
315628	1678	21600733505000	19502	9830	0	0	0
315629	1874	11671000	19502	9830	1	0	2
315630	1874	11672000	19502	9830	2	0	2
315631	1874	11674000	19502	9830	3	0	2
315655	1678	21600733507000	19507	9831	1	0	0
315656	1874	11676000	19507	9831	2	0	2
315660	1678	21600733508000	19508	9832	0	0	\N
315661	1874	11687000	19508	9832	1	0	\N
315662	1874	11689000	19508	9832	2	0	\N
315663	1874	11690000	19508	9832	3	0	\N
315668	1678	21600733508000	19510	9832	0	0	\N
315669	1874	11687000	19510	9832	1	0	\N
315670	1874	11689000	19510	9832	2	0	\N
315671	1874	11690000	19510	9832	3	0	\N
315672	1678	21600733508000	19511	9832	0	0	\N
315673	1874	11687000	19511	9832	1	0	\N
315674	1874	11689000	19511	9832	2	0	\N
315675	1874	11690000	19511	9832	3	0	\N
315676	1678	21600733508000	19512	9832	0	0	\N
315677	1874	11687000	19512	9832	1	0	\N
315678	1874	11689000	19512	9832	2	0	\N
315679	1874	11690000	19512	9832	3	0	\N
315680	1678	21600733508000	19513	9832	0	0	\N
315681	1874	11687000	19513	9832	1	0	\N
315682	1874	11689000	19513	9832	2	0	\N
315683	1874	11690000	19513	9832	3	0	\N
315684	1678	21600733509000	19514	9833	0	0	\N
315685	1874	11693000	19514	9833	1	0	\N
315686	1874	11695000	19514	9833	2	0	\N
315693	1678	21600733511000	19516	9834	0	0	\N
315694	1874	11702000	19516	9834	1	0	\N
315695	1874	11705000	19516	9834	2	0	\N
315696	1874	11706000	19516	9834	3	0	\N
315701	2230	0	19518	9806	0	0	\N
315702	2214	2000000000	19518	9806	1	0	\N
315703	1982	200000000	19518	9806	2	0	\N
315704	2228	200000000	19518	9806	3	0	\N
315705	2229	200000000	19518	9806	4	0	\N
315706	2229	1400000000	19518	9806	5	0	\N
315707	2214	2502000000000	19518	9806	6	0	\N
315708	1982	1400000000	19518	9806	7	0	\N
315712	1678	21600733512000	19520	9835	0	0	\N
315713	1874	11708000	19520	9835	1	0	\N
315714	1874	11711000	19520	9835	2	0	\N
315715	1678	21600733512000	19521	9835	0	0	\N
315716	1874	11708000	19521	9835	1	0	\N
315717	1874	11711000	19521	9835	2	0	\N
315718	1678	21600733513000	19522	9836	0	0	\N
315719	1874	11714000	19522	9836	1	0	\N
315720	1874	11716000	19522	9836	2	0	\N
315724	1678	21600733514000	19524	9837	0	0	\N
315725	1874	11719000	19524	9837	1	0	\N
315729	1678	21600733514000	19526	9837	0	0	\N
315730	1874	11719000	19526	9837	1	0	\N
315731	1874	11721000	19526	9837	2	0	\N
315732	1678	21600733515000	19527	9838	0	0	\N
315733	1874	11723000	19527	9838	1	0	\N
315734	1874	11724000	19527	9838	2	0	\N
315735	1874	11727000	19527	9838	3	0	\N
315736	1678	21600733515000	19528	9838	0	0	\N
315737	1874	11723000	19528	9838	1	0	\N
315738	1874	11724000	19528	9838	2	0	\N
315739	1874	11727000	19528	9838	3	0	\N
315740	1678	21600733515000	19529	9838	0	0	\N
315741	1874	11723000	19529	9838	1	0	\N
315742	1874	11724000	19529	9838	2	0	\N
315743	1874	11727000	19529	9838	3	0	\N
315758	1678	21600733519000	19533	9841	0	0	\N
315759	1874	11745000	19533	9841	2	0	\N
315760	1874	11748000	19533	9841	3	0	\N
315764	1678	21600733520000	19536	9842	0	0	\N
315765	1874	11751000	19536	9842	1	0	\N
315766	1874	11753000	19536	9842	2	0	\N
315770	1678	21600733510000	19538	9834	0	0	\N
315771	1678	21600733511000	19538	9834	1	0	\N
315772	1678	21600733512000	19538	9834	2	0	\N
315773	1678	21600733513000	19538	9834	3	0	\N
315774	1678	21600733514000	19538	9834	4	0	\N
315775	1678	21600733515000	19538	9834	5	0	\N
315776	1678	21600733516000	19538	9834	6	0	\N
315777	1678	21600733517000	19538	9834	7	0	\N
315778	1678	21600733518000	19538	9834	8	0	\N
315779	1678	21600733519000	19538	9834	9	0	\N
315780	1678	21600733520000	19538	9834	10	0	\N
315781	1874	11697000	19538	9834	11	0	\N
315782	1874	11699000	19538	9834	12	0	\N
315783	1874	11701000	19538	9834	13	0	\N
315784	1874	11702000	19538	9834	14	0	\N
315785	1874	11703000	19538	9834	15	0	\N
315786	1874	11705000	19538	9834	16	0	\N
315787	1874	11708000	19538	9834	17	0	\N
315788	1874	11711000	19538	9834	18	0	\N
315789	1874	11714000	19538	9834	19	0	\N
315790	1874	11717000	19538	9834	20	0	\N
315791	1874	11720000	19538	9834	21	0	\N
315792	1874	11723000	19538	9834	22	0	\N
315659	1874	11684000	19507	9831	5	0	2
315664	1678	21600733508000	19509	9832	0	0	0
315665	1874	11687000	19509	9832	1	0	2
315666	1874	11689000	19509	9832	2	0	2
315667	1874	11690000	19509	9832	3	0	2
315688	1678	21600733510000	19515	9833	1	0	0
315689	1874	11693000	19515	9833	2	0	2
315690	1874	11695000	19515	9833	3	0	2
315691	1874	11697000	19515	9833	4	0	2
315692	1874	11700000	19515	9833	5	0	2
315698	1874	11702000	19517	9834	1	0	2
315699	1874	11705000	19517	9834	2	0	2
315700	1874	11706000	19517	9834	3	0	2
315709	1678	21600733512000	19519	9835	0	0	0
315711	1874	11711000	19519	9835	2	0	2
315721	1678	21600733513000	19523	9836	0	0	0
315722	1874	11714000	19523	9836	1	0	2
315723	1874	11716000	19523	9836	2	0	2
315726	1678	21600733514000	19525	9837	0	0	0
315728	1874	11721000	19525	9837	2	0	2
315744	1678	21600733515000	19530	9838	0	0	0
315745	1874	11723000	19530	9838	1	0	2
315746	1874	11724000	19530	9838	2	0	2
315747	1874	11727000	19530	9838	3	0	2
315749	1874	11729000	19531	9839	1	0	2
315750	1874	11732000	19531	9839	2	0	2
315751	1678	21600733517000	19532	9840	0	0	0
315752	1678	21600733518000	19532	9840	1	0	0
315754	1874	11738000	19532	9840	3	0	2
315755	1874	11740000	19532	9840	4	0	2
315756	1874	11742000	19532	9840	5	0	2
315757	1874	11743000	19532	9840	6	0	2
315761	1678	21600733519000	19534	9841	0	0	0
315763	1874	11748000	19534	9841	3	0	2
315767	1678	21600733520000	19537	9842	0	0	0
315768	1874	11751000	19537	9842	1	0	2
315769	1874	11753000	19537	9842	2	0	2
315793	1874	11726000	19538	9834	23	0	\N
315794	1874	11729000	19538	9834	24	0	\N
315795	1874	11732000	19538	9834	25	0	\N
315796	1874	11735000	19538	9834	26	0	\N
315797	1874	11738000	19538	9834	27	0	\N
315798	1874	11739000	19538	9834	28	0	\N
315799	1874	11741000	19538	9834	29	0	\N
315800	1874	11743000	19538	9834	30	0	\N
315801	1874	11745000	19538	9834	31	0	\N
315802	1874	11747000	19538	9834	32	0	\N
315803	1874	11749000	19538	9834	33	0	\N
315804	1874	11751000	19538	9834	34	0	\N
315805	1874	11753000	19538	9834	35	0	\N
315810	1678	21600733521000	19540	9843	0	0	\N
315811	1874	11754000	19540	9843	1	0	\N
315812	1874	11757000	19540	9843	2	0	\N
315813	1678	21600733521000	19541	9843	0	0	\N
315814	1874	11754000	19541	9843	1	0	\N
315815	1874	11757000	19541	9843	2	0	\N
315816	1874	11759000	19541	9843	3	0	\N
315820	1678	21600733523000	19543	9845	0	0	\N
315821	1678	21600733524000	19543	9845	1	0	\N
315822	1678	21600733525000	19543	9845	2	0	\N
315823	1874	11765000	19543	9845	3	0	\N
315824	1874	11768000	19543	9845	4	0	\N
315825	1874	11771000	19543	9845	5	0	\N
315826	1874	11774000	19543	9845	6	0	\N
315827	1678	21600733523000	19544	9845	0	0	\N
315828	1678	21600733524000	19544	9845	1	0	\N
315829	1678	21600733525000	19544	9845	2	0	\N
315830	1874	11766000	19544	9845	3	0	\N
315831	1874	11767000	19544	9845	4	0	\N
315832	1874	11769000	19544	9845	5	0	\N
315833	1874	11771000	19544	9845	6	0	\N
315834	1874	11774000	19544	9845	7	0	\N
315835	1874	11777000	19544	9845	8	0	\N
315836	1874	11780000	19544	9845	9	0	\N
315847	1678	21600733523000	19546	9845	0	0	\N
315848	1678	21600733524000	19546	9845	1	0	\N
315849	1678	21600733525000	19546	9845	2	0	\N
315850	1874	11766000	19546	9845	3	0	\N
315851	1874	11767000	19546	9845	4	0	\N
315852	1874	11769000	19546	9845	5	0	\N
315853	1874	11771000	19546	9845	6	0	\N
315854	1874	11774000	19546	9845	7	0	\N
315855	1874	11777000	19546	9845	8	0	\N
315856	1874	11780000	19546	9845	9	0	\N
315857	1678	21600733526000	19547	9846	0	0	\N
315858	1874	11782000	19547	9846	1	0	\N
315859	1874	11785000	19547	9846	2	0	\N
315863	1678	21600733527000	19549	9847	0	0	\N
315864	1678	21600733528000	19549	9847	1	0	\N
315865	1874	11787000	19549	9847	2	0	\N
315866	1874	11789000	19549	9847	3	0	\N
315867	1874	11790000	19549	9847	4	0	\N
315868	1874	11793000	19549	9847	5	0	\N
315869	1874	11796000	19549	9847	6	0	\N
315877	2226	500000000	19551	9681	0	0	\N
315878	266	66312928193897	19551	9681	1	0	\N
315879	2213	200000000	19551	9681	2	0	\N
315880	266	66613928193897	19551	9681	3	0	\N
315881	80	66000000000000	19551	9681	4	0	\N
315882	2230	0	19551	9681	5	0	\N
315883	2214	0	19551	9681	6	0	\N
315884	38	66083861377858	19551	9681	7	0	\N
315885	969	503416039028136	19551	9681	8	0	\N
315886	1089	902117228669776	19551	9681	9	0	\N
315887	1388	1711802704351650	19551	9681	10	0	\N
315888	1142	910452755600000	19551	9681	11	0	\N
315889	1262	614299826200000	19551	9681	12	0	\N
315890	1022	508069064000000	19551	9681	13	0	\N
315891	2225	0	19551	9681	14	0	\N
315892	1209	608676470139099	19551	9681	15	0	\N
315893	1335	1696131104536774	19551	9681	16	0	\N
315894	38	66119808346940	19551	9681	17	0	\N
315895	969	503689580754480	19551	9681	18	0	\N
315896	1089	902607413099680	19551	9681	19	0	\N
315897	1209	609007207341570	19551	9681	20	0	\N
315898	1335	1697052733158970	19551	9681	21	0	\N
315899	38	66191662385104	19551	9681	22	0	\N
315900	969	504236664207168	19551	9681	23	0	\N
315901	1089	903587781959488	19551	9681	24	0	\N
315902	1209	609668681746512	19551	9681	25	0	\N
315903	1335	1698895990403362	19551	9681	26	0	\N
315904	38	66203641224798	19551	9681	27	0	\N
315905	969	504327844782616	19551	9681	28	0	\N
315906	1089	903751176769456	19551	9681	29	0	\N
315907	1209	609778927480669	19551	9681	30	0	\N
315908	1335	1699203199944094	19551	9681	31	0	\N
315909	38	66263620923268	19551	9681	32	0	\N
315910	969	504783747659856	19551	9681	33	0	\N
315911	1089	904568150819296	19551	9681	34	0	\N
315912	1209	610330156151454	19551	9681	35	0	\N
315913	1335	1700739247647754	19551	9681	36	0	\N
315914	38	66311549582044	19551	9681	37	0	\N
315915	969	505148469961648	19551	9681	38	0	\N
315916	1089	905221730059168	19551	9681	39	0	\N
315917	1209	610771139088082	19551	9681	40	0	\N
315918	1335	1701968085810682	19551	9681	41	0	\N
315919	38	66335589911432	19551	9681	42	0	\N
315920	969	505330831112544	19551	9681	43	0	\N
315921	1089	905548519679104	19551	9681	44	0	\N
315922	1209	610991630556396	19551	9681	45	0	\N
315923	1335	1702582504892146	19551	9681	46	0	\N
315924	1724	15777420500000	19551	9681	47	0	\N
315925	2214	2000000000	19551	9681	48	0	\N
315926	1950	13889851000000	19551	9681	49	0	\N
315927	2225	1000000000	19551	9681	50	0	\N
315928	2225	717000000000	19551	9681	51	0	\N
315808	1874	11757000	19539	9843	2	0	2
315809	1874	11759000	19539	9843	3	0	2
315817	1678	21600733522000	19542	9844	0	0	0
315818	1874	11761000	19542	9844	1	0	2
315819	1874	11764000	19542	9844	2	0	2
315838	1678	21600733524000	19545	9845	1	0	0
315839	1678	21600733525000	19545	9845	2	0	0
315840	1874	11766000	19545	9845	3	0	2
315841	1874	11767000	19545	9845	4	0	2
315842	1874	11769000	19545	9845	5	0	2
315844	1874	11774000	19545	9845	7	0	2
315845	1874	11777000	19545	9845	8	0	2
315846	1874	11780000	19545	9845	9	0	2
315860	1678	21600733526000	19548	9846	0	0	0
315862	1874	11785000	19548	9846	2	0	2
315870	1678	21600733527000	19550	9847	0	0	0
315871	1678	21600733528000	19550	9847	1	0	0
315872	1874	11787000	19550	9847	2	0	2
315873	1874	11789000	19550	9847	3	0	2
315875	1874	11793000	19550	9847	5	0	2
315876	1874	11796000	19550	9847	6	0	2
315929	2225	717100000000	19551	9681	52	0	\N
315930	2214	2502000000000	19551	9681	53	0	\N
315931	2215	200000000	19551	9681	54	0	\N
315932	2216	200000000	19551	9681	55	0	\N
315933	2217	200000000	19551	9681	56	0	\N
315934	592	67440000000000	19551	9681	57	0	\N
315935	1483	10000000	19551	9681	58	0	\N
315936	2205	1399000000	19551	9681	59	0	\N
315937	1930	2600000000	19551	9681	60	0	\N
315938	2218	200000000	19551	9681	61	0	\N
315939	2219	200000000	19551	9681	62	0	\N
315940	2220	200000000	19551	9681	63	0	\N
315941	2221	200000000	19551	9681	64	0	\N
315942	2222	200000000	19551	9681	65	0	\N
315943	2223	200000000	19551	9681	66	0	\N
315944	2227	200000000	19551	9681	67	0	\N
315945	1982	200000000	19551	9681	68	0	\N
315946	2228	200000000	19551	9681	69	0	\N
315947	2229	200000000	19551	9681	70	0	\N
315948	2229	1400000000	19551	9681	71	0	\N
315949	1982	1400000000	19551	9681	72	0	\N
315950	1406	0	19551	9681	74	0	\N
315960	1678	21600733531000	19554	9849	0	0	\N
315961	1874	11807000	19554	9849	1	0	\N
315962	1874	11809000	19554	9849	2	0	\N
315963	1874	11812000	19554	9849	3	0	\N
315964	1678	21600733531000	19555	9849	0	0	\N
315965	1874	11807000	19555	9849	1	0	\N
315966	1874	11809000	19555	9849	2	0	\N
315967	1874	11812000	19555	9849	3	0	\N
315968	1678	21600733531000	19556	9849	0	0	\N
315969	1874	11807000	19556	9849	1	0	\N
315970	1874	11809000	19556	9849	2	0	\N
315971	1874	11812000	19556	9849	3	0	\N
315972	1678	21600733521000	19557	9835	0	0	\N
315973	1678	21600733522000	19557	9835	1	0	\N
315974	1678	21600733523000	19557	9835	2	0	\N
315975	1678	21600733524000	19557	9835	3	0	\N
315976	1678	21600733525000	19557	9835	4	0	\N
315977	1678	21600733526000	19557	9835	5	0	\N
315978	1678	21600733527000	19557	9835	6	0	\N
315979	1678	21600733528000	19557	9835	8	0	\N
315980	1678	21600733529000	19557	9835	9	0	\N
315981	1678	21600733530000	19557	9835	10	0	\N
315982	1678	21600733531000	19557	9835	11	0	\N
315983	1874	11754000	19557	9835	12	0	\N
315984	1874	11757000	19557	9835	13	0	\N
315985	1874	11760000	19557	9835	14	0	\N
315986	1874	11761000	19557	9835	15	0	\N
315987	1874	11763000	19557	9835	16	0	\N
315988	1874	11765000	19557	9835	17	0	\N
315989	1874	11767000	19557	9835	18	0	\N
315990	1874	11769000	19557	9835	19	0	\N
315991	1874	11771000	19557	9835	20	0	\N
315992	1874	11773000	19557	9835	21	0	\N
315993	1874	11775000	19557	9835	22	0	\N
315994	1874	11777000	19557	9835	23	0	\N
315995	1874	11779000	19557	9835	24	0	\N
315996	1874	11781000	19557	9835	25	0	\N
315997	1874	11783000	19557	9835	26	0	\N
315998	1874	11786000	19557	9835	27	0	\N
315999	1874	11789000	19557	9835	28	0	\N
316000	1874	11792000	19557	9835	29	0	\N
316001	1874	11795000	19557	9835	30	0	\N
316002	1874	11796000	19557	9835	31	0	\N
316003	1874	11797000	19557	9835	32	0	\N
316004	1874	11800000	19557	9835	33	0	\N
316005	1874	11803000	19557	9835	34	0	\N
316006	1874	11806000	19557	9835	35	0	\N
316007	1874	11809000	19557	9835	36	0	\N
316008	1874	11812000	19557	9835	37	0	\N
316013	1678	21600733532000	19559	9850	0	0	\N
316014	1874	11813000	19559	9850	1	0	\N
316031	1678	21600733538000	19565	9856	0	0	\N
316032	1874	11846000	19565	9856	1	0	\N
316033	1874	11847000	19565	9856	2	0	\N
316038	1678	21600733539000	19567	9857	0	0	\N
316039	1874	11852000	19567	9857	1	0	\N
316040	1874	11854000	19567	9857	2	0	\N
316041	2226	500000000	19568	9790	0	0	\N
316042	1678	21600733452000	19568	9790	1	0	\N
316043	2230	0	19568	9790	2	0	\N
316044	1678	21600733453000	19568	9790	3	0	\N
316045	1958	4098987000000	19568	9790	4	0	\N
316046	1678	21600733454000	19568	9790	5	0	\N
316047	2225	0	19568	9790	6	0	\N
316048	1678	21600733455000	19568	9790	7	0	\N
316049	1678	21600733456000	19568	9790	8	0	\N
316050	1678	21600733457000	19568	9790	9	0	\N
316051	1678	21600733458000	19568	9790	10	0	\N
316052	1678	21600733459000	19568	9790	11	0	\N
316053	1678	21600733460000	19568	9790	12	0	\N
316054	1678	21600733461000	19568	9790	13	0	\N
316055	1678	21600733462000	19568	9790	14	0	\N
316056	1678	21600733463000	19568	9790	15	0	\N
316057	1678	21600733464000	19568	9790	16	0	\N
316058	1678	21600733465000	19568	9790	17	0	\N
316059	1678	21600733466000	19568	9790	18	0	\N
316060	1678	21600733467000	19568	9790	19	0	\N
316061	1678	21600733468000	19568	9790	20	0	\N
316062	1678	21600733469000	19568	9790	21	0	\N
316063	1678	21600733470000	19568	9790	22	0	\N
316064	1678	21600733471000	19568	9790	23	0	\N
315953	1874	11799000	19552	9848	2	0	2
315954	1874	11801000	19552	9848	3	0	2
315955	1874	11803000	19552	9848	4	0	2
315956	1874	11806000	19552	9848	5	0	2
315957	1678	21600733531000	19553	9849	0	0	0
315959	1874	11810000	19553	9849	2	0	2
316009	1678	21600733532000	19558	9850	0	0	0
316010	1874	11813000	19558	9850	1	0	2
316011	1874	11815000	19558	9850	2	0	2
316012	1874	11817000	19558	9850	3	0	2
316016	1874	11820000	19560	9851	1	0	2
316017	1678	21600733534000	19561	9852	0	0	0
316018	1874	11823000	19561	9852	1	0	2
316019	1874	11825000	19561	9852	2	0	2
316021	1678	21600733535000	19562	9853	0	0	0
316022	1874	11830000	19562	9853	1	0	2
316023	1874	11832000	19562	9853	2	0	2
316024	1874	11833000	19562	9853	3	0	2
316025	1678	21600733536000	19563	9854	0	0	0
316027	1874	11838000	19563	9854	2	0	2
316028	1678	21600733537000	19564	9855	0	0	0
316029	1874	11841000	19564	9855	1	0	2
316030	1874	11843000	19564	9855	2	0	2
316034	1678	21600733538000	19566	9856	0	0	0
316036	1874	11848000	19566	9856	2	0	2
316037	1874	11849000	19566	9856	3	0	2
316065	1678	21600733472000	19568	9790	24	0	\N
316066	1678	21600733473000	19568	9790	25	0	\N
316067	1678	21600733474000	19568	9790	26	0	\N
316068	1678	21600733475000	19568	9790	27	0	\N
316069	1678	21600733476000	19568	9790	28	0	\N
316070	1678	21600733477000	19568	9790	29	0	\N
316071	1678	21600733478000	19568	9790	30	0	\N
316072	1678	21600733479000	19568	9790	31	0	\N
316073	1678	21600733480000	19568	9790	32	0	\N
316074	1678	21600733481000	19568	9790	33	0	\N
316075	1678	21600733482000	19568	9790	34	0	\N
316076	1678	21600733483000	19568	9790	35	0	\N
316077	1678	21600733484000	19568	9790	36	0	\N
316078	1678	21600733485000	19568	9790	37	0	\N
316079	1678	21600733486000	19568	9790	38	0	\N
316080	1678	21600733487000	19568	9790	39	0	\N
316081	1678	21600733488000	19568	9790	40	0	\N
316082	1678	21600733489000	19568	9790	41	0	\N
316083	1678	21600733490000	19568	9790	42	0	\N
316084	1678	21600733491000	19568	9790	43	0	\N
316085	1678	21600733492000	19568	9790	44	0	\N
316086	1678	21600733493000	19568	9790	45	0	\N
316087	1678	21600733494000	19568	9790	46	0	\N
316088	1678	21600733495000	19568	9790	47	0	\N
316089	1678	21600733496000	19568	9790	48	0	\N
316090	1678	21600733497000	19568	9790	49	0	\N
316091	1678	21600733498000	19568	9790	50	0	\N
316092	1678	21600733499000	19568	9790	51	0	\N
316093	1678	21600733500000	19568	9790	52	0	\N
316094	1678	21600733501000	19568	9790	53	0	\N
316095	1678	21600733502000	19568	9790	54	0	\N
316096	1678	21600733503000	19568	9790	55	0	\N
316097	1678	21600733504000	19568	9790	56	0	\N
316098	1678	21600733505000	19568	9790	57	0	\N
316099	1678	21600733506000	19568	9790	58	0	\N
316100	1678	21600733507000	19568	9790	59	0	\N
316101	1678	21600733508000	19568	9790	60	0	\N
316102	1678	21600733509000	19568	9790	61	0	\N
316103	1678	21600733510000	19568	9790	62	0	\N
316104	1678	21600733511000	19568	9790	63	0	\N
316105	1678	21600733512000	19568	9790	64	0	\N
316106	1678	21600733513000	19568	9790	65	0	\N
316107	1678	21600733514000	19568	9790	66	0	\N
316108	1678	21600733515000	19568	9790	67	0	\N
316109	1678	21600733516000	19568	9790	68	0	\N
316110	1678	21600733517000	19568	9790	69	0	\N
316111	1678	21600733518000	19568	9790	70	0	\N
316112	1678	21600733519000	19568	9790	71	0	\N
316113	1678	21600733520000	19568	9790	72	0	\N
316114	1678	21600733521000	19568	9790	73	0	\N
316115	1678	21600733522000	19568	9790	74	0	\N
316116	1678	21600733523000	19568	9790	75	0	\N
316117	1678	21600733524000	19568	9790	76	0	\N
316118	1678	21600733525000	19568	9790	77	0	\N
316119	1678	21600733526000	19568	9790	78	0	\N
316120	1678	21600733527000	19568	9790	79	0	\N
316121	1678	21600733528000	19568	9790	80	0	\N
316122	1678	21600733529000	19568	9790	81	0	\N
316123	1678	21600733530000	19568	9790	82	0	\N
316124	1678	21600733531000	19568	9790	83	0	\N
316125	1678	21600733532000	19568	9790	84	0	\N
316126	1678	21600733533000	19568	9790	85	0	\N
316127	1678	21600733534000	19568	9790	87	0	\N
316128	1678	21600733535000	19568	9790	88	0	\N
316129	1678	21600733536000	19568	9790	89	0	\N
316130	1678	21600733537000	19568	9790	90	0	\N
316131	1678	21600733538000	19568	9790	91	0	\N
316132	1678	21600733539000	19568	9790	92	0	\N
316133	2214	2000000000	19568	9790	93	0	\N
316134	1874	11391000	19568	9790	94	0	\N
316135	1874	11393000	19568	9790	95	0	\N
316136	2225	1000000000	19568	9790	96	0	\N
316137	2225	717000000000	19568	9790	97	0	\N
316138	2225	717100000000	19568	9790	98	0	\N
316139	1874	11394000	19568	9790	99	0	\N
316140	1874	11395000	19568	9790	100	0	\N
316141	1874	11396000	19568	9790	101	0	\N
316142	1874	11397000	19568	9790	102	0	\N
316143	1874	11398000	19568	9790	103	0	\N
316144	1874	11399000	19568	9790	104	0	\N
316145	2227	200000000	19568	9790	105	0	\N
316146	1982	200000000	19568	9790	106	0	\N
316147	2228	200000000	19568	9790	107	0	\N
316148	2229	200000000	19568	9790	108	0	\N
316149	2229	1400000000	19568	9790	109	0	\N
316150	2214	2502000000000	19568	9790	110	0	\N
316151	1874	11402000	19568	9790	111	0	\N
316152	1874	11405000	19568	9790	112	0	\N
316153	1874	11408000	19568	9790	113	0	\N
316154	1982	1400000000	19568	9790	114	0	\N
316155	1874	11410000	19568	9790	115	0	\N
316156	1874	11412000	19568	9790	116	0	\N
316157	1874	11415000	19568	9790	117	0	\N
316158	1874	11418000	19568	9790	118	0	\N
316159	1874	11421000	19568	9790	119	0	\N
316160	1874	11424000	19568	9790	120	0	\N
316161	1874	11427000	19568	9790	121	0	\N
316162	1874	11430000	19568	9790	122	0	\N
316163	1874	11432000	19568	9790	123	0	\N
316164	1874	11434000	19568	9790	124	0	\N
316165	1874	11436000	19568	9790	125	0	\N
316169	1874	11851000	19570	9857	0	0	\N
316170	1678	21600733539000	19571	9858	0	0	\N
316171	1678	21600733540000	19571	9858	1	0	\N
316172	1874	11854000	19571	9858	2	0	\N
316173	1874	11856000	19571	9858	3	0	\N
316174	1678	21600733539000	19572	9858	0	0	\N
316175	1678	21600733540000	19572	9858	1	0	\N
316176	1874	11854000	19572	9858	2	0	\N
316177	1874	11856000	19572	9858	3	0	\N
316178	1678	21600733540000	19573	9858	0	0	\N
316179	1874	11856000	19573	9858	1	0	\N
316199	1874	11886000	19579	9863	0	0	\N
316168	1874	11854000	19569	9857	2	0	2
316180	1874	11856000	19574	9858	0	0	2
316181	1678	21600733540000	19575	9859	0	0	0
316182	1678	21600733541000	19575	9859	1	0	0
316183	1874	11858000	19575	9859	2	0	2
316185	1678	21600733542000	19576	9860	0	0	0
316186	1874	11862000	19576	9860	1	0	2
316187	1874	11864000	19576	9860	2	0	2
316188	1874	11867000	19576	9860	3	0	2
316189	1678	21600733543000	19577	9861	0	0	0
316191	1874	11870000	19577	9861	2	0	2
316192	1874	11873000	19577	9861	3	0	2
316193	1678	21600733545000	19578	9862	0	0	0
316194	1874	11876000	19578	9862	1	0	2
316196	1874	11879000	19578	9862	3	0	2
316197	1874	11881000	19578	9862	5	0	2
316198	1874	11883000	19578	9862	6	0	2
316200	1874	11885000	19580	9863	0	0	2
316205	1678	21600733546000	19582	9864	0	0	\N
316206	1874	11890000	19582	9864	1	0	\N
316207	1874	11893000	19582	9864	2	0	\N
316208	1678	21600733547000	19583	9865	0	0	\N
316209	1874	11894000	19583	9865	1	0	\N
316210	1874	11896000	19583	9865	2	0	\N
316211	1874	11899000	19583	9865	3	0	\N
316216	1678	21600733547000	19585	9865	0	0	\N
316217	1874	11894000	19585	9865	1	0	\N
316218	1874	11896000	19585	9865	2	0	\N
316219	1874	11899000	19585	9865	3	0	\N
316223	1678	21600733548000	19587	9866	0	0	\N
316224	1874	11902000	19587	9866	1	0	\N
316225	1874	11904000	19587	9866	2	0	\N
316226	1678	21600733548000	19588	9866	0	0	\N
316227	1874	11902000	19588	9866	1	0	\N
316228	1874	11904000	19588	9866	2	0	\N
316229	1678	21600733548000	19590	9866	0	0	\N
316230	1874	11902000	19590	9866	1	0	\N
316231	1874	11904000	19590	9866	2	0	\N
316235	1678	21600733549000	19592	9867	0	0	\N
316236	1874	11906000	19592	9867	1	0	\N
316237	1874	11909000	19592	9867	2	0	\N
316238	1678	21600733549000	19594	9867	0	0	\N
316239	1874	11906000	19594	9867	1	0	\N
316240	1874	11909000	19594	9867	2	0	\N
316261	1678	21600733555000	19599	9871	0	0	\N
316262	1874	11938000	19599	9871	1	0	\N
316263	1874	11941000	19599	9871	2	0	\N
316264	1678	21600733556000	19600	9872	0	0	\N
316265	1678	21600733557000	19600	9872	1	0	\N
316266	1874	11942000	19600	9872	2	0	\N
316267	1874	11945000	19600	9872	3	0	\N
316268	1874	11948000	19600	9872	4	0	\N
316269	1874	11950000	19600	9872	5	0	\N
316270	1874	11952000	19600	9872	6	0	\N
316284	1678	21600733560000	19604	9875	0	0	\N
316285	1874	11965000	19604	9875	1	0	\N
316286	1874	11967000	19604	9875	2	0	\N
316290	1678	21600733560000	19606	9875	0	0	\N
316291	1874	11965000	19606	9875	1	0	\N
316292	1874	11967000	19606	9875	2	0	\N
316293	2226	500000000	19607	9772	0	0	\N
316294	2230	0	19607	9772	1	0	\N
316295	1958	4098987000000	19607	9772	2	0	\N
316296	2225	0	19607	9772	3	0	\N
316297	2214	2000000000	19607	9772	4	0	\N
316298	2225	1000000000	19607	9772	5	0	\N
316299	2225	717000000000	19607	9772	6	0	\N
316300	2225	717100000000	19607	9772	7	0	\N
316301	2214	2502000000000	19607	9772	8	0	\N
316302	1697	1501990000000	19607	9772	9	0	\N
316303	1697	2001990000000	19607	9772	10	0	\N
316311	2226	500000000	19609	9770	0	0	\N
316312	2230	0	19609	9770	1	0	\N
316313	2224	719063000000	19609	9770	2	0	\N
316314	1958	4098987000000	19609	9770	3	0	\N
316315	2225	0	19609	9770	4	0	\N
316316	2223	200000000	19609	9770	5	0	\N
316317	2214	2000000000	19609	9770	6	0	\N
316318	2225	1000000000	19609	9770	7	0	\N
316319	2225	717000000000	19609	9770	8	0	\N
316320	2225	717100000000	19609	9770	9	0	\N
316321	2227	200000000	19609	9770	10	0	\N
316322	1982	200000000	19609	9770	11	0	\N
316323	2228	200000000	19609	9770	12	0	\N
316324	2229	200000000	19609	9770	13	0	\N
316325	2229	1400000000	19609	9770	14	0	\N
316326	2214	2502000000000	19609	9770	15	0	\N
316327	1982	1400000000	19609	9770	16	0	\N
316328	1697	1501990000000	19609	9770	17	0	\N
316329	1697	2001990000000	19609	9770	18	0	\N
316203	1874	11890000	19581	9864	1	0	2
316204	1874	11893000	19581	9864	2	0	2
316212	1678	21600733547000	19584	9865	0	0	0
316213	1874	11894000	19584	9865	1	0	2
316214	1874	11896000	19584	9865	2	0	2
316220	1678	21600733548000	19586	9866	0	0	0
316221	1874	11902000	19586	9866	1	0	2
316222	1874	11904000	19586	9866	2	0	2
316232	1678	21600733549000	19591	9867	0	0	0
316233	1874	11906000	19591	9867	1	0	2
316241	1678	21600733550000	19595	9868	0	0	0
316242	1874	11912000	19595	9868	1	0	2
316243	1874	11914000	19595	9868	2	0	2
316244	1678	21600733551000	19596	9869	0	0	0
316246	1874	11918000	19596	9869	2	0	2
316247	1874	11920000	19596	9869	3	0	2
316248	1678	21600733552000	19597	9870	0	0	0
316249	1678	21600733553000	19597	9870	1	0	0
316250	1678	21600733554000	19597	9870	2	0	0
316252	1874	11923000	19597	9870	4	0	2
316253	1874	11926000	19597	9870	5	0	2
316254	1874	11929000	19597	9870	6	0	2
316255	1874	11932000	19597	9870	7	0	2
316256	1874	11934000	19597	9870	8	0	2
316258	1678	21600733555000	19598	9871	0	0	0
316259	1874	11938000	19598	9871	1	0	2
316260	1874	11941000	19598	9871	2	0	2
316271	1678	21600733556000	19601	9872	0	0	0
316273	1874	11942000	19601	9872	2	0	2
316274	1874	11945000	19601	9872	3	0	2
316275	1874	11948000	19601	9872	4	0	2
316276	1874	11950000	19601	9872	5	0	2
316277	1874	11952000	19601	9872	6	0	2
316279	1874	11955000	19602	9873	1	0	2
316280	1874	11957000	19602	9873	2	0	2
316281	1678	21600733559000	19603	9874	0	0	0
316282	1874	11959000	19603	9874	1	0	2
316283	1874	11962000	19603	9874	2	0	2
316288	1874	11965000	19605	9875	1	0	2
316289	1874	11967000	19605	9875	2	0	2
316304	1678	21600733561000	19608	9876	0	0	0
316305	1678	21600733562000	19608	9876	1	0	0
316307	1874	11971000	19608	9876	3	0	2
316308	1874	11974000	19608	9876	4	0	2
316309	1874	11976000	19608	9876	5	0	2
316310	1874	11978000	19608	9876	6	0	2
316330	1678	21600733563000	19610	9877	0	0	0
316332	1874	11983000	19610	9877	2	0	2
316333	1678	21600733564000	19611	9878	0	0	0
316334	1678	21600733565000	19611	9878	1	0	0
316335	1874	11986000	19611	9878	2	0	2
316336	1874	11988000	19611	9878	3	0	2
316340	1678	21600733566000	19612	9879	0	0	\N
316341	1678	21600733567000	19612	9879	1	0	\N
316342	1874	11997000	19612	9879	2	0	\N
316343	1874	11998000	19612	9879	3	0	\N
316344	1874	12001000	19612	9879	4	0	\N
316345	1874	12003000	19612	9879	5	0	\N
316346	1874	12005000	19612	9879	6	0	\N
316363	1678	21600733568000	19615	9880	0	0	\N
316364	1678	21600733569000	19615	9880	1	0	\N
316365	1678	21600733570000	19615	9880	2	0	\N
316366	1874	12007000	19615	9880	3	0	\N
316367	1874	12010000	19615	9880	4	0	\N
316368	1874	12013000	19615	9880	5	0	\N
316369	1874	12016000	19615	9880	6	0	\N
316370	1874	12018000	19615	9880	7	0	\N
316371	1874	12020000	19615	9880	8	0	\N
316372	1678	21600733568000	19616	9880	0	0	\N
316373	1678	21600733569000	19616	9880	1	0	\N
316374	1678	21600733570000	19616	9880	2	0	\N
316375	1874	12007000	19616	9880	3	0	\N
316376	1874	12010000	19616	9880	4	0	\N
316377	1874	12013000	19616	9880	5	0	\N
316378	1874	12016000	19616	9880	6	0	\N
316379	1874	12018000	19616	9880	7	0	\N
316380	1874	12020000	19616	9880	8	0	\N
316390	1678	21600733571000	19618	9881	0	0	\N
316391	1678	21600733572000	19618	9881	1	0	\N
316392	1678	21600733573000	19618	9881	2	0	\N
316393	1874	12022000	19618	9881	4	0	\N
316394	1874	12024000	19618	9881	5	0	\N
316395	1874	12027000	19618	9881	6	0	\N
316396	1874	12030000	19618	9881	7	0	\N
316397	1874	12031000	19618	9881	8	0	\N
316398	1874	12033000	19618	9881	9	0	\N
316399	1678	21600733571000	19619	9881	0	0	\N
316400	1678	21600733572000	19619	9881	1	0	\N
316401	1678	21600733573000	19619	9881	2	0	\N
316402	1874	12022000	19619	9881	4	0	\N
316403	1874	12024000	19619	9881	5	0	\N
316404	1874	12027000	19619	9881	6	0	\N
316405	1874	12030000	19619	9881	7	0	\N
316406	1874	12031000	19619	9881	8	0	\N
316407	1874	12033000	19619	9881	9	0	\N
316408	1678	21600733532000	19620	9836	0	0	\N
316409	1678	21600733533000	19620	9836	1	0	\N
316410	1678	21600733534000	19620	9836	2	0	\N
316411	1678	21600733535000	19620	9836	3	0	\N
316412	1678	21600733536000	19620	9836	4	0	\N
316413	1678	21600733537000	19620	9836	5	0	\N
316414	1678	21600733538000	19620	9836	6	0	\N
316415	1678	21600733539000	19620	9836	7	0	\N
316416	1678	21600733540000	19620	9836	8	0	\N
316417	1678	21600733541000	19620	9836	9	0	\N
316418	1678	21600733542000	19620	9836	10	0	\N
316419	1678	21600733543000	19620	9836	11	0	\N
316420	1678	21600733544000	19620	9836	12	0	\N
316421	1678	21600733545000	19620	9836	13	0	\N
316422	1678	21600733546000	19620	9836	14	0	\N
316423	1678	21600733547000	19620	9836	15	0	\N
316424	1678	21600733548000	19620	9836	16	0	\N
316425	1678	21600733549000	19620	9836	17	0	\N
316426	1678	21600733550000	19620	9836	18	0	\N
316427	1678	21600733551000	19620	9836	19	0	\N
316428	1678	21600733552000	19620	9836	20	0	\N
316429	1678	21600733553000	19620	9836	21	0	\N
316430	1678	21600733554000	19620	9836	22	0	\N
316431	1678	21600733555000	19620	9836	23	0	\N
316432	1678	21600733556000	19620	9836	24	0	\N
316433	1678	21600733557000	19620	9836	25	0	\N
316434	1678	21600733558000	19620	9836	26	0	\N
316435	1678	21600733559000	19620	9836	27	0	\N
316436	1678	21600733560000	19620	9836	28	0	\N
316437	1678	21600733561000	19620	9836	29	0	\N
316438	1678	21600733562000	19620	9836	30	0	\N
316439	1678	21600733563000	19620	9836	31	0	\N
316440	1678	21600733564000	19620	9836	32	0	\N
316441	1678	21600733565000	19620	9836	33	0	\N
316442	1678	21600733566000	19620	9836	34	0	\N
316443	1678	21600733567000	19620	9836	35	0	\N
316444	1678	21600733568000	19620	9836	36	0	\N
316445	1678	21600733569000	19620	9836	37	0	\N
316446	1678	21600733570000	19620	9836	38	0	\N
316447	1678	21600733571000	19620	9836	39	0	\N
316448	1678	21600733572000	19620	9836	40	0	\N
316449	1678	21600733573000	19620	9836	41	0	\N
316450	1874	11815000	19620	9836	42	0	\N
316451	1874	11818000	19620	9836	43	0	\N
316452	1874	11821000	19620	9836	44	0	\N
316453	1874	11824000	19620	9836	45	0	\N
316454	1874	11826000	19620	9836	46	0	\N
316455	1874	11829000	19620	9836	47	0	\N
316456	1874	11832000	19620	9836	48	0	\N
316457	1874	11835000	19620	9836	49	0	\N
316458	1874	11838000	19620	9836	50	0	\N
316459	1874	11841000	19620	9836	51	0	\N
316460	1874	11843000	19620	9836	52	0	\N
316461	1874	11845000	19620	9836	53	0	\N
316462	1874	11847000	19620	9836	54	0	\N
316463	1874	11849000	19620	9836	55	0	\N
316464	1874	11852000	19620	9836	56	0	\N
316465	1874	11855000	19620	9836	57	0	\N
316466	1874	11858000	19620	9836	58	0	\N
316467	1874	11861000	19620	9836	59	0	\N
316468	1874	11864000	19620	9836	60	0	\N
316469	1874	11865000	19620	9836	61	0	\N
316470	1874	11866000	19620	9836	62	0	\N
316471	1874	11867000	19620	9836	63	0	\N
316472	1874	11868000	19620	9836	64	0	\N
316339	1874	11994000	19611	9878	6	0	2
316347	1678	21600733566000	19613	9879	0	0	0
316348	1678	21600733567000	19613	9879	1	0	0
316349	1874	11997000	19613	9879	2	0	2
316350	1874	11998000	19613	9879	3	0	2
316352	1874	12003000	19613	9879	5	0	2
316353	1874	12005000	19613	9879	6	0	2
316354	1678	21600733568000	19614	9880	0	0	0
316355	1678	21600733569000	19614	9880	1	0	0
316356	1678	21600733570000	19614	9880	2	0	0
316358	1874	12010000	19614	9880	4	0	2
316359	1874	12013000	19614	9880	5	0	2
316360	1874	12016000	19614	9880	6	0	2
316361	1874	12018000	19614	9880	7	0	2
316381	1678	21600733571000	19617	9881	0	0	0
316382	1678	21600733572000	19617	9881	1	0	0
316383	1678	21600733573000	19617	9881	2	0	0
316384	1874	12022000	19617	9881	4	0	2
316385	1874	12024000	19617	9881	5	0	2
316387	1874	12030000	19617	9881	7	0	2
316388	1874	12031000	19617	9881	8	0	2
316389	1874	12033000	19617	9881	9	0	2
316473	1874	11869000	19620	9836	65	0	\N
316474	1874	11870000	19620	9836	66	0	\N
316475	1874	11871000	19620	9836	67	0	\N
316476	1874	11872000	19620	9836	68	0	\N
316477	1874	11873000	19620	9836	69	0	\N
316478	1874	11876000	19620	9836	70	0	\N
316479	1874	11879000	19620	9836	71	0	\N
316480	1874	11882000	19620	9836	72	0	\N
316481	1874	11885000	19620	9836	73	0	\N
316482	1874	11888000	19620	9836	74	0	\N
316483	1874	11891000	19620	9836	75	0	\N
316484	1874	11894000	19620	9836	76	0	\N
316485	1874	11897000	19620	9836	77	0	\N
316486	1874	11900000	19620	9836	78	0	\N
316487	1874	11903000	19620	9836	79	0	\N
316488	1874	11906000	19620	9836	80	0	\N
316489	1874	11909000	19620	9836	81	0	\N
316490	1874	11912000	19620	9836	82	0	\N
316491	1874	11915000	19620	9836	83	0	\N
316492	1874	11918000	19620	9836	84	0	\N
316493	1874	11921000	19620	9836	85	0	\N
316494	1874	11924000	19620	9836	86	0	\N
316495	1874	11927000	19620	9836	87	0	\N
316496	1874	11930000	19620	9836	88	0	\N
316497	1874	11933000	19620	9836	89	0	\N
316498	1874	11936000	19620	9836	90	0	\N
316499	1874	11939000	19620	9836	91	0	\N
316500	1874	11942000	19620	9836	92	0	\N
316501	1874	11945000	19620	9836	93	0	\N
316502	1874	11948000	19620	9836	94	0	\N
316503	1874	11951000	19620	9836	96	0	\N
316504	1874	11954000	19620	9836	97	0	\N
316505	1874	11955000	19620	9836	98	0	\N
316506	1874	11956000	19620	9836	99	0	\N
316507	1874	11957000	19620	9836	100	0	\N
316508	1874	11959000	19620	9836	101	0	\N
316509	1874	11961000	19620	9836	102	0	\N
316510	1874	11963000	19620	9836	103	0	\N
316511	1874	11965000	19620	9836	104	0	\N
316512	1874	11967000	19620	9836	105	0	\N
316513	1874	11969000	19620	9836	106	0	\N
316514	1874	11971000	19620	9836	107	0	\N
316515	1874	11973000	19620	9836	108	0	\N
316516	1874	11975000	19620	9836	109	0	\N
316517	1874	11977000	19620	9836	110	0	\N
316518	1874	11979000	19620	9836	111	0	\N
316519	1874	11981000	19620	9836	112	0	\N
316520	1874	11983000	19620	9836	113	0	\N
316521	1874	11985000	19620	9836	114	0	\N
316522	1874	11987000	19620	9836	115	0	\N
316523	1874	11989000	19620	9836	116	0	\N
316524	1874	11991000	19620	9836	117	0	\N
316525	1874	11993000	19620	9836	118	0	\N
316526	1874	11995000	19620	9836	119	0	\N
316527	1874	11997000	19620	9836	120	0	\N
316528	1874	11999000	19620	9836	121	0	\N
316529	1874	12001000	19620	9836	122	0	\N
316530	1874	12003000	19620	9836	123	0	\N
316531	1874	12005000	19620	9836	124	0	\N
316532	1874	12007000	19620	9836	125	0	\N
316540	1678	21600733574000	19622	9882	0	0	\N
316541	1678	21600733575000	19622	9882	1	0	\N
316542	1874	12036000	19622	9882	2	0	\N
316543	1874	12039000	19622	9882	3	0	\N
316544	1874	12041000	19622	9882	4	0	\N
316545	1874	12043000	19622	9882	5	0	\N
316546	1874	12044000	19622	9882	6	0	\N
316570	1678	21600733579000	19626	9885	0	0	\N
316571	1678	21600733580000	19626	9885	1	0	\N
316572	1678	21600733581000	19626	9885	2	0	\N
316573	1678	21600733582000	19626	9885	3	0	\N
316574	1874	12061000	19626	9885	4	0	\N
316575	1874	12063000	19626	9885	5	0	\N
316576	1874	12065000	19626	9885	6	0	\N
316577	1874	12067000	19626	9885	7	0	\N
316578	1874	12069000	19626	9885	8	0	\N
316579	1874	12072000	19626	9885	9	0	\N
316580	1874	12075000	19626	9885	10	0	\N
316581	1874	12078000	19626	9885	11	0	\N
316582	1874	12081000	19626	9885	12	0	\N
316583	1678	21600733579000	19627	9885	0	0	\N
316584	1678	21600733580000	19627	9885	1	0	\N
316585	1678	21600733581000	19627	9885	2	0	\N
316586	1678	21600733582000	19627	9885	3	0	\N
316587	1874	12061000	19627	9885	4	0	\N
316588	1874	12063000	19627	9885	5	0	\N
316589	1874	12065000	19627	9885	6	0	\N
316590	1874	12067000	19627	9885	7	0	\N
316591	1874	12069000	19627	9885	8	0	\N
316592	1874	12072000	19627	9885	9	0	\N
316593	1874	12075000	19627	9885	10	0	\N
316594	1874	12078000	19627	9885	11	0	\N
316595	1874	12081000	19627	9885	12	0	\N
316535	1874	12036000	19621	9882	2	0	2
316536	1874	12039000	19621	9882	3	0	2
316537	1874	12041000	19621	9882	4	0	2
316538	1874	12043000	19621	9882	5	0	2
316539	1874	12044000	19621	9882	6	0	2
316548	1874	12047000	19623	9883	1	0	2
316549	1874	12049000	19623	9883	2	0	2
316550	1678	21600733577000	19624	9884	0	0	0
316551	1678	21600733578000	19624	9884	1	0	0
316552	1874	12051000	19624	9884	2	0	2
316554	1874	12056000	19624	9884	4	0	2
316555	1874	12059000	19624	9884	5	0	2
316556	1874	12060000	19624	9884	6	0	2
316557	1678	21600733579000	19625	9885	0	0	0
316559	1678	21600733581000	19625	9885	2	0	0
316560	1678	21600733582000	19625	9885	3	0	0
316561	1874	12061000	19625	9885	4	0	2
316562	1874	12063000	19625	9885	5	0	2
316563	1874	12065000	19625	9885	6	0	2
316565	1874	12069000	19625	9885	8	0	2
316566	1874	12072000	19625	9885	9	0	2
316567	1874	12075000	19625	9885	10	0	2
316568	1874	12078000	19625	9885	11	0	2
316569	1874	12081000	19625	9885	12	0	2
316597	1678	21600733584000	19628	9886	1	0	0
316598	1874	12082000	19628	9886	2	0	2
316599	1874	12085000	19628	9886	3	0	2
316600	1874	12087000	19628	9886	4	0	2
316602	1874	12092000	19628	9886	6	0	2
316603	1678	21600733585000	19629	9887	0	0	0
316604	1874	12094000	19629	9887	1	0	2
316605	1874	12097000	19629	9887	2	0	2
316606	1678	21600733586000	19630	9888	0	0	0
316608	1874	12102000	19630	9888	2	0	2
316609	1678	21600733587000	19631	9889	0	0	\N
316610	1678	21600733588000	19631	9889	1	0	\N
316611	1874	12105000	19631	9889	2	0	\N
316612	1874	12108000	19631	9889	3	0	\N
316613	1874	12110000	19631	9889	4	0	\N
316614	1874	12112000	19631	9889	5	0	\N
316615	1874	12113000	19631	9889	6	0	\N
316623	1678	21600733568000	19633	9880	0	0	\N
316624	1678	21600733569000	19633	9880	1	0	\N
316625	1678	21600733570000	19633	9880	2	0	\N
316626	1678	21600733571000	19633	9880	3	0	\N
316627	1678	21600733572000	19633	9880	4	0	\N
316628	1678	21600733573000	19633	9880	5	0	\N
316629	1678	21600733574000	19633	9880	6	0	\N
316630	1678	21600733575000	19633	9880	7	0	\N
316631	1678	21600733576000	19633	9880	8	0	\N
316632	1678	21600733577000	19633	9880	9	0	\N
316633	1678	21600733578000	19633	9880	10	0	\N
316634	1678	21600733579000	19633	9880	11	0	\N
316635	1678	21600733580000	19633	9880	12	0	\N
316636	1678	21600733581000	19633	9880	13	0	\N
316637	1678	21600733582000	19633	9880	15	0	\N
316638	1678	21600733583000	19633	9880	16	0	\N
316639	1678	21600733584000	19633	9880	17	0	\N
316640	1678	21600733585000	19633	9880	18	0	\N
316641	1678	21600733586000	19633	9880	19	0	\N
316642	1678	21600733587000	19633	9880	20	0	\N
316643	1678	21600733588000	19633	9880	21	0	\N
316644	1874	12007000	19633	9880	22	0	\N
316645	1874	12010000	19633	9880	23	0	\N
316646	1874	12013000	19633	9880	24	0	\N
316647	1874	12016000	19633	9880	25	0	\N
316648	1874	12019000	19633	9880	26	0	\N
316649	1874	12022000	19633	9880	27	0	\N
316650	1874	12025000	19633	9880	28	0	\N
316651	1874	12028000	19633	9880	29	0	\N
316652	1874	12031000	19633	9880	30	0	\N
316653	1874	12034000	19633	9880	31	0	\N
316654	1874	12037000	19633	9880	32	0	\N
316655	1874	12038000	19633	9880	33	0	\N
316656	1874	12041000	19633	9880	34	0	\N
316657	1874	12044000	19633	9880	35	0	\N
316658	1874	12047000	19633	9880	36	0	\N
316659	1874	12050000	19633	9880	37	0	\N
316660	1874	12053000	19633	9880	38	0	\N
316661	1874	12056000	19633	9880	39	0	\N
316662	1874	12059000	19633	9880	40	0	\N
316663	1874	12062000	19633	9880	41	0	\N
316664	1874	12065000	19633	9880	42	0	\N
316665	1874	12068000	19633	9880	43	0	\N
316666	1874	12070000	19633	9880	44	0	\N
316667	1874	12072000	19633	9880	45	0	\N
316668	1874	12074000	19633	9880	46	0	\N
316669	1874	12076000	19633	9880	47	0	\N
316670	1874	12078000	19633	9880	48	0	\N
316671	1874	12080000	19633	9880	49	0	\N
316672	1874	12082000	19633	9880	50	0	\N
316673	1874	12084000	19633	9880	51	0	\N
316674	1874	12086000	19633	9880	52	0	\N
316675	1874	12088000	19633	9880	53	0	\N
316676	1874	12090000	19633	9880	54	0	\N
316677	1874	12092000	19633	9880	55	0	\N
316678	1874	12094000	19633	9880	56	0	\N
316679	1874	12096000	19633	9880	57	0	\N
316680	1874	12098000	19633	9880	58	0	\N
316681	1874	12100000	19633	9880	59	0	\N
316682	1874	12102000	19633	9880	60	0	\N
316683	1874	12104000	19633	9880	61	0	\N
316684	1874	12106000	19633	9880	62	0	\N
316685	1874	12108000	19633	9880	63	0	\N
316686	1874	12109000	19633	9880	64	0	\N
316687	1874	12110000	19633	9880	65	0	\N
316688	1874	12111000	19633	9880	66	0	\N
316689	1874	12112000	19633	9880	67	0	\N
316690	1874	12113000	19633	9880	68	0	\N
316701	1678	21600733592000	19636	9892	0	0	\N
316702	1874	12132000	19636	9892	1	0	\N
316703	1874	12134000	19636	9892	2	0	\N
316704	1678	21600733592000	19637	9892	0	0	\N
316705	1874	12132000	19637	9892	1	0	\N
316706	1874	12134000	19637	9892	2	0	\N
316707	1678	21600733592000	19638	9892	0	0	\N
316708	1874	12132000	19638	9892	1	0	\N
316709	1874	12134000	19638	9892	2	0	\N
316710	1678	21600733592000	19639	9892	0	0	\N
316711	1874	12132000	19639	9892	1	0	\N
316712	1874	12134000	19639	9892	2	0	\N
316713	1678	21600733592000	19640	9892	0	0	\N
316714	1874	12132000	19640	9892	1	0	\N
316715	1874	12134000	19640	9892	2	0	\N
316719	1678	21600733592000	19642	9892	0	0	\N
316720	1874	12132000	19642	9892	1	0	\N
316721	1874	12134000	19642	9892	2	0	\N
316722	1678	21600733593000	19643	9893	0	0	\N
316723	1678	21600733594000	19643	9893	1	0	\N
316724	1874	12135000	19643	9893	2	0	\N
316725	1874	12138000	19643	9893	3	0	\N
316726	1874	12141000	19643	9893	4	0	\N
316727	1874	12143000	19643	9893	5	0	\N
316728	1874	12145000	19643	9893	6	0	\N
316736	1678	21600733595000	19645	9894	0	0	\N
316737	1678	21600733596000	19645	9894	1	0	\N
316738	1874	12148000	19645	9894	2	0	\N
316739	1874	12151000	19645	9894	3	0	\N
316740	1874	12153000	19645	9894	4	0	\N
316741	1874	12155000	19645	9894	5	0	\N
316618	1874	12105000	19632	9889	2	0	2
316619	1874	12108000	19632	9889	3	0	2
316620	1874	12110000	19632	9889	4	0	2
316621	1874	12112000	19632	9889	5	0	2
316622	1874	12113000	19632	9889	6	0	2
316692	1874	12115000	19634	9890	1	0	2
316693	1874	12118000	19634	9890	2	0	2
316694	1678	21600733590000	19635	9891	0	0	0
316695	1678	21600733591000	19635	9891	1	0	0
316696	1874	12119000	19635	9891	2	0	2
316698	1874	12124000	19635	9891	4	0	2
316699	1874	12126000	19635	9891	5	0	2
316700	1874	12129000	19635	9891	6	0	2
316716	1678	21600733592000	19641	9892	0	0	0
316718	1874	12134000	19641	9892	2	0	2
316729	1678	21600733593000	19644	9893	0	0	0
316730	1678	21600733594000	19644	9893	1	0	0
316731	1874	12135000	19644	9893	2	0	2
316732	1874	12138000	19644	9893	3	0	2
316734	1874	12143000	19644	9893	5	0	2
316735	1874	12145000	19644	9893	6	0	2
316742	1678	21600733595000	19646	9894	0	0	0
316743	1678	21600733596000	19646	9894	1	0	0
316744	1874	12148000	19646	9894	2	0	2
316748	1678	21600733564000	19647	9878	0	0	\N
316749	1678	21600733565000	19647	9878	1	0	\N
316750	1678	21600733566000	19647	9878	2	0	\N
316751	1678	21600733567000	19647	9878	3	0	\N
316752	1678	21600733568000	19647	9878	4	0	\N
316753	1678	21600733569000	19647	9878	5	0	\N
316754	1678	21600733570000	19647	9878	6	0	\N
316755	1678	21600733571000	19647	9878	7	0	\N
316756	1678	21600733572000	19647	9878	8	0	\N
316757	1678	21600733573000	19647	9878	9	0	\N
316758	1678	21600733574000	19647	9878	10	0	\N
316759	1678	21600733575000	19647	9878	11	0	\N
316760	1678	21600733576000	19647	9878	12	0	\N
316761	1678	21600733577000	19647	9878	13	0	\N
316762	1678	21600733578000	19647	9878	14	0	\N
316763	1678	21600733579000	19647	9878	15	0	\N
316764	1678	21600733580000	19647	9878	16	0	\N
316765	1678	21600733581000	19647	9878	17	0	\N
316766	1678	21600733582000	19647	9878	18	0	\N
316767	1678	21600733583000	19647	9878	19	0	\N
316768	1678	21600733584000	19647	9878	20	0	\N
316769	1678	21600733585000	19647	9878	21	0	\N
316770	1678	21600733586000	19647	9878	22	0	\N
316771	1678	21600733587000	19647	9878	23	0	\N
316772	1678	21600733588000	19647	9878	24	0	\N
316773	1678	21600733589000	19647	9878	25	0	\N
316774	1678	21600733590000	19647	9878	26	0	\N
316775	1678	21600733591000	19647	9878	27	0	\N
316776	1678	21600733592000	19647	9878	28	0	\N
316777	1678	21600733593000	19647	9878	29	0	\N
316778	1678	21600733594000	19647	9878	30	0	\N
316779	1678	21600733595000	19647	9878	31	0	\N
316780	1678	21600733596000	19647	9878	33	0	\N
316781	1874	11986000	19647	9878	34	0	\N
316782	1874	11988000	19647	9878	35	0	\N
316783	1874	11991000	19647	9878	36	0	\N
316784	1874	11994000	19647	9878	37	0	\N
316785	1874	11997000	19647	9878	38	0	\N
316786	1874	12000000	19647	9878	39	0	\N
316787	1874	12002000	19647	9878	40	0	\N
316788	1874	12005000	19647	9878	41	0	\N
316789	1874	12008000	19647	9878	42	0	\N
316790	1874	12011000	19647	9878	43	0	\N
316791	1874	12014000	19647	9878	44	0	\N
316792	1874	12017000	19647	9878	45	0	\N
316793	1874	12020000	19647	9878	46	0	\N
316794	1874	12023000	19647	9878	47	0	\N
316795	1874	12026000	19647	9878	48	0	\N
316796	1874	12029000	19647	9878	49	0	\N
316797	1874	12031000	19647	9878	50	0	\N
316798	1874	12034000	19647	9878	51	0	\N
316799	1874	12037000	19647	9878	52	0	\N
316800	1874	12040000	19647	9878	53	0	\N
316801	1874	12043000	19647	9878	54	0	\N
316802	1874	12046000	19647	9878	55	0	\N
316803	1874	12049000	19647	9878	56	0	\N
316804	1874	12051000	19647	9878	57	0	\N
316805	1874	12053000	19647	9878	58	0	\N
316806	1874	12056000	19647	9878	59	0	\N
316807	1874	12059000	19647	9878	60	0	\N
316808	1874	12062000	19647	9878	61	0	\N
316809	1874	12065000	19647	9878	62	0	\N
316810	1874	12068000	19647	9878	63	0	\N
316811	1874	12071000	19647	9878	64	0	\N
316812	1874	12072000	19647	9878	65	0	\N
316813	1874	12073000	19647	9878	66	0	\N
316814	1874	12074000	19647	9878	67	0	\N
316815	1874	12077000	19647	9878	68	0	\N
316816	1874	12080000	19647	9878	69	0	\N
316817	1874	12083000	19647	9878	70	0	\N
316818	1874	12086000	19647	9878	71	0	\N
316819	1874	12089000	19647	9878	72	0	\N
316820	1874	12092000	19647	9878	73	0	\N
316821	1874	12094000	19647	9878	74	0	\N
316822	1874	12096000	19647	9878	75	0	\N
316823	1874	12098000	19647	9878	76	0	\N
316824	1874	12100000	19647	9878	77	0	\N
316825	1874	12102000	19647	9878	78	0	\N
316826	1874	12104000	19647	9878	79	0	\N
316827	1874	12106000	19647	9878	80	0	\N
316828	1874	12108000	19647	9878	81	0	\N
316829	1874	12110000	19647	9878	82	0	\N
316830	1874	12112000	19647	9878	83	0	\N
316831	1874	12114000	19647	9878	84	0	\N
316832	1874	12116000	19647	9878	85	0	\N
316833	1874	12118000	19647	9878	86	0	\N
316834	1874	12120000	19647	9878	87	0	\N
316835	1874	12122000	19647	9878	88	0	\N
316836	1874	12124000	19647	9878	89	0	\N
316837	1874	12126000	19647	9878	90	0	\N
316838	1874	12128000	19647	9878	91	0	\N
316839	1874	12130000	19647	9878	92	0	\N
316840	1874	12132000	19647	9878	93	0	\N
316841	1874	12134000	19647	9878	94	0	\N
316842	1874	12136000	19647	9878	95	0	\N
316843	1874	12138000	19647	9878	96	0	\N
316844	1874	12140000	19647	9878	97	0	\N
316845	1874	12142000	19647	9878	98	0	\N
316846	1874	12144000	19647	9878	99	0	\N
316847	1874	12146000	19647	9878	100	0	\N
316848	1874	12148000	19647	9878	101	0	\N
316849	1874	12149000	19647	9878	102	0	\N
316850	1874	12150000	19647	9878	103	0	\N
316851	1874	12151000	19647	9878	104	0	\N
316852	1874	12152000	19647	9878	105	0	\N
316853	1874	12153000	19647	9878	106	0	\N
316854	1874	12154000	19647	9878	107	0	\N
316855	1874	12155000	19647	9878	108	0	\N
316869	1678	21600733600000	19651	9897	0	0	\N
316870	1874	12173000	19651	9897	1	0	\N
316871	1874	12176000	19651	9897	2	0	\N
316872	1678	21600733601000	19652	9898	0	0	\N
316873	1678	21600733602000	19652	9898	1	0	\N
316874	1874	12178000	19652	9898	2	0	\N
316875	1874	12181000	19652	9898	3	0	\N
316876	1874	12183000	19652	9898	4	0	\N
316877	1874	12186000	19652	9898	5	0	\N
316747	1874	12155000	19646	9894	5	0	2
316856	1678	21600733597000	19648	9895	0	0	0
316857	1678	21600733598000	19648	9895	1	0	0
316858	1874	12156000	19648	9895	2	0	2
316859	1874	12159000	19648	9895	3	0	2
316861	1874	12163000	19648	9895	5	0	2
316862	1874	12166000	19648	9895	6	0	2
316863	1678	21600733599000	19649	9896	0	0	0
316864	1874	12168000	19649	9896	1	0	2
316865	1874	12171000	19649	9896	2	0	2
316867	1874	12173000	19650	9897	1	0	2
316868	1874	12176000	19650	9897	2	0	2
316878	1678	21600733601000	19653	9898	0	0	0
316879	1678	21600733602000	19653	9898	1	0	0
316887	1678	21600733604000	19655	9900	0	0	\N
316888	1874	12194000	19655	9900	1	0	\N
316889	1874	12196000	19655	9900	2	0	\N
316903	1678	21600733607000	19659	9902	0	0	\N
316904	1874	12209000	19659	9902	1	0	\N
316905	1874	12211000	19659	9902	2	0	\N
316912	399	66651272116779	19662	9905	0	0	\N
316913	499	66651272116779	19662	9905	1	0	\N
316914	1772	4656971682095	19662	9905	2	0	\N
316915	1678	21600733610000	19662	9905	3	0	\N
316916	1874	12223000	19662	9905	4	0	\N
316917	399	66651272116779	19663	9905	0	0	\N
316918	499	66651272116779	19663	9905	1	0	\N
316919	1678	21600733610000	19663	9905	2	0	\N
316932	35	19389460979377	19666	9907	0	0	\N
316933	1678	21600733611000	19666	9907	1	0	\N
316934	1678	21600733612000	19666	9907	2	0	\N
316935	49	66651272116779	19666	9907	3	0	\N
316936	251	66651272116779	19666	9907	4	0	\N
316937	893	309850571298133	19666	9907	5	0	\N
316938	320	66370072116779	19666	9907	6	0	\N
316939	1030	909863680121925	19666	9907	7	0	\N
316940	1874	12231000	19666	9907	8	0	\N
316941	1874	12233000	19666	9907	9	0	\N
316952	35	19389460979377	19668	9907	0	0	\N
316953	1678	21600733611000	19668	9907	1	0	\N
316954	1678	21600733612000	19668	9907	2	0	\N
316955	49	66651272116779	19668	9907	3	0	\N
316956	251	66651272116779	19668	9907	4	0	\N
316957	893	309850571298133	19668	9907	5	0	\N
316958	320	66370072116779	19668	9907	6	0	\N
316959	1030	909863680121925	19668	9907	7	0	\N
316960	1874	12231000	19668	9907	8	0	\N
316961	1874	12233000	19668	9907	9	0	\N
316962	663	66651272116779	19669	9908	0	0	\N
316963	390	66651272116779	19669	9908	1	0	\N
316964	108	66651272116779	19669	9908	2	0	\N
316965	894	309850571298133	19669	9908	3	0	\N
316966	569	66651272116779	19669	9908	4	0	\N
316967	99	66651272116779	19669	9908	5	0	\N
316968	1874	12236000	19669	9908	6	0	\N
316969	1874	12238000	19669	9908	7	0	\N
316978	663	66651272116779	19671	9908	0	0	\N
316979	390	66651272116779	19671	9908	1	0	\N
316980	108	66651272116779	19671	9908	2	0	\N
316981	894	309850571298133	19671	9908	3	0	\N
316982	569	66651272116779	19671	9908	4	0	\N
316983	99	66651272116779	19671	9908	5	0	\N
316984	1874	12236000	19671	9908	6	0	\N
316985	1874	12238000	19671	9908	7	0	\N
316986	663	66651272116779	19672	9908	0	0	\N
316987	390	66651272116779	19672	9908	1	0	\N
316988	108	66651272116779	19672	9908	2	0	\N
316989	894	309850571298133	19672	9908	3	0	\N
316990	1874	12236000	19672	9908	4	0	\N
317009	1678	21600733613000	19674	9909	0	0	\N
317010	1678	21600733614000	19674	9909	1	0	\N
317011	570	66651272116779	19674	9909	2	0	\N
317012	225	66651272116779	19674	9909	3	0	\N
317013	377	66651272116779	19674	9909	4	0	\N
317014	560	66651272116779	19674	9909	5	0	\N
317015	252	66651272116779	19674	9909	6	0	\N
317016	1962	650184292006	19674	9909	7	0	\N
316883	1874	12186000	19653	9898	5	0	2
316884	1678	21600733603000	19654	9899	0	0	0
316885	1874	12188000	19654	9899	1	0	2
316886	1874	12191000	19654	9899	2	0	2
316890	1678	21600733604000	19656	9900	0	0	0
316892	1874	12196000	19656	9900	2	0	2
316893	1678	21600733605000	19657	9901	0	0	0
316894	1678	21600733606000	19657	9901	1	0	0
316895	1874	12198000	19657	9901	2	0	2
316896	44	66000000000000	19657	9901	3	0	3
316898	1874	12203000	19657	9901	5	0	2
316899	1874	12206000	19657	9901	6	0	2
316900	1678	21600733607000	19658	9902	0	0	0
316901	1874	12209000	19658	9902	1	0	2
316906	1678	21600733608000	19660	9903	0	0	0
316907	1874	12214000	19660	9903	1	0	2
316908	1874	12216000	19660	9903	2	0	2
316909	1678	21600733609000	19661	9904	0	0	0
316910	1874	12218000	19661	9904	1	0	2
316920	399	66651272116779	19664	9905	0	0	0
316921	499	66651272116779	19664	9905	1	0	0
316922	1678	21600733610000	19664	9905	2	0	0
316923	1772	4656971682095	19665	9906	0	0	1
316924	54	66651272116779	19665	9906	1	0	0
316926	1811	1778097057551	19665	9906	3	0	1
316927	217	66651272116779	19665	9906	4	0	0
316928	103	66651272116779	19665	9906	5	0	0
316929	1874	12223000	19665	9906	6	0	2
316931	1874	12228000	19665	9906	8	0	2
316942	35	19389460979377	19667	9907	0	0	0
316943	1678	21600733611000	19667	9907	1	0	0
316944	1678	21600733612000	19667	9907	2	0	0
316945	49	66651272116779	19667	9907	3	0	0
316947	893	309850571298133	19667	9907	5	0	0
316948	320	66370072116779	19667	9907	6	0	2
316949	1030	909863680121925	19667	9907	7	0	0
316950	1874	12231000	19667	9907	8	0	2
316951	1874	12233000	19667	9907	9	0	2
316971	390	66651272116779	19670	9908	1	0	0
316972	108	66651272116779	19670	9908	2	0	0
316973	894	309850571298133	19670	9908	3	0	0
316974	569	66651272116779	19670	9908	4	0	0
316976	1874	12236000	19670	9908	6	0	2
316977	1874	12238000	19670	9908	7	0	2
316991	1678	21600733613000	19673	9909	0	0	0
316992	1678	21600733614000	19673	9909	1	0	0
316993	570	66651272116779	19673	9909	2	0	0
316995	377	66651272116779	19673	9909	4	0	0
316996	560	66651272116779	19673	9909	5	0	0
316997	252	66651272116779	19673	9909	6	0	0
316998	1962	650184292006	19673	9909	7	0	1
316999	201	66651272116779	19673	9909	8	0	0
317001	163	66651272116779	19673	9909	10	0	0
317002	82	66651272116779	19673	9909	11	0	0
317003	275	66651272116779	19673	9909	12	0	0
317004	361	66651272116779	19673	9909	13	0	0
317006	1874	12244000	19673	9909	15	0	2
317007	1874	12246000	19673	9909	16	0	2
317008	1874	12248000	19673	9909	17	0	2
317017	201	66651272116779	19674	9909	8	0	\N
317018	402	66651272116779	19674	9909	9	0	\N
317019	163	66651272116779	19674	9909	10	0	\N
317020	82	66651272116779	19674	9909	11	0	\N
317021	275	66651272116779	19674	9909	12	0	\N
317022	361	66651272116779	19674	9909	13	0	\N
317023	1874	12241000	19674	9909	14	0	\N
317024	1874	12244000	19674	9909	15	0	\N
317025	1874	12246000	19674	9909	16	0	\N
317026	1874	12248000	19674	9909	17	0	\N
317027	309	66651272116779	19675	9910	0	0	\N
317028	2073	649447026849	19675	9910	1	0	\N
317029	452	66651272116779	19675	9910	2	0	\N
317030	594	66651272116779	19675	9910	3	0	\N
317031	2181	649523922882	19675	9910	4	0	\N
317032	680	66651272116779	19675	9910	5	0	\N
317033	1678	21600733615000	19675	9910	6	0	\N
317034	1678	21600733616000	19675	9910	7	0	\N
317035	391	66649672116779	19675	9910	8	0	\N
317036	690	66651272116779	19675	9910	9	0	\N
317037	353	66650052116779	19675	9910	10	0	\N
317038	731	2019735518605	19675	9910	11	0	\N
317039	2164	649932922882	19675	9910	12	0	\N
317040	180	66651272116779	19675	9910	13	0	\N
317041	1874	12251000	19675	9910	14	0	\N
317042	1874	12254000	19675	9910	15	0	\N
317043	1874	12256000	19675	9910	16	0	\N
317044	1874	12258000	19675	9910	17	0	\N
317063	309	66651272116779	19677	9910	0	0	\N
317064	2073	649447026849	19677	9910	1	0	\N
317065	452	66651272116779	19677	9910	2	0	\N
317066	594	66651272116779	19677	9910	3	0	\N
317067	2181	649523922882	19677	9910	4	0	\N
317068	680	66651272116779	19677	9910	5	0	\N
317069	1678	21600733615000	19677	9910	6	0	\N
317070	1678	21600733616000	19677	9910	7	0	\N
317071	391	66649672116779	19677	9910	8	0	\N
317072	690	66651272116779	19677	9910	9	0	\N
317073	353	66650052116779	19677	9910	10	0	\N
317074	731	2019735518605	19677	9910	11	0	\N
317075	2164	649932922882	19677	9910	12	0	\N
317076	180	66651272116779	19677	9910	13	0	\N
317077	1874	12251000	19677	9910	14	0	\N
317078	1874	12254000	19677	9910	15	0	\N
317079	1874	12256000	19677	9910	16	0	\N
317080	1874	12258000	19677	9910	17	0	\N
317089	352	66651272116779	19679	9912	0	0	\N
317090	652	66651272116779	19679	9912	1	0	\N
317091	191	66651272116779	19679	9912	2	0	\N
317092	266	66038252116779	19679	9912	3	0	\N
317093	1150	613903155292823	19679	9912	4	0	\N
317094	84	66651272116779	19679	9912	5	0	\N
317095	1678	21600733618000	19679	9912	6	0	\N
317096	1874	12265000	19679	9912	7	0	\N
317097	1874	12268000	19679	9912	8	0	\N
317106	600	66651272116779	19681	9913	0	0	\N
317107	1678	21600733619000	19681	9913	1	0	\N
317108	691	66651272116779	19681	9913	2	0	\N
317109	2017	649871451178	19681	9913	3	0	\N
317110	551	66651272116779	19681	9913	4	0	\N
317111	520	66651272116779	19681	9913	5	0	\N
317112	392	66651272116779	19681	9913	6	0	\N
317113	1874	12268000	19681	9913	7	0	\N
317114	1874	12270000	19681	9913	8	0	\N
317115	1874	12273000	19681	9913	9	0	\N
317116	600	66651272116779	19682	9913	0	0	\N
317117	1678	21600733619000	19682	9913	1	0	\N
317118	691	66651272116779	19682	9913	2	0	\N
317119	2017	649871451178	19682	9913	3	0	\N
317120	551	66651272116779	19682	9913	4	0	\N
317121	520	66651272116779	19682	9913	5	0	\N
317122	392	66651272116779	19682	9913	6	0	\N
317123	1874	12268000	19682	9913	7	0	\N
317124	1874	12271000	19682	9913	8	0	\N
317125	600	66651272116779	19683	9913	0	0	\N
317126	1678	21600733619000	19683	9913	1	0	\N
317127	691	66651272116779	19683	9913	2	0	\N
317128	2017	649871451178	19683	9913	3	0	\N
317129	551	66651272116779	19683	9913	4	0	\N
317130	520	66651272116779	19683	9913	5	0	\N
317131	392	66651272116779	19683	9913	6	0	\N
317132	1874	12270000	19683	9913	7	0	\N
317133	1874	12273000	19683	9913	8	0	\N
317142	1678	21600733620000	19685	9914	0	0	\N
317143	392	66651272116779	19685	9914	1	0	\N
317144	89	66651272116779	19685	9914	2	0	\N
317145	186	66651272116779	19685	9914	3	0	\N
317146	383	66651272116779	19685	9914	4	0	\N
317147	308	66651272116779	19685	9914	5	0	\N
317148	408	66651272116779	19685	9914	6	0	\N
317149	678	66651272116779	19685	9914	7	0	\N
317150	1874	12274000	19685	9914	8	0	\N
317151	1874	12276000	19685	9914	9	0	\N
317152	1678	21600733620000	19686	9914	0	0	\N
317047	452	66651272116779	19676	9910	2	0	0
317048	594	66651272116779	19676	9910	3	0	0
317049	2181	649523922882	19676	9910	4	0	1
317050	680	66651272116779	19676	9910	5	0	0
317051	1678	21600733615000	19676	9910	6	0	0
317053	391	66649672116779	19676	9910	8	0	1
317054	690	66651272116779	19676	9910	9	0	0
317055	353	66650052116779	19676	9910	10	0	2
317056	731	2019735518605	19676	9910	11	0	0
317057	2164	649932922882	19676	9910	12	0	1
317059	1874	12251000	19676	9910	14	0	2
317060	1874	12254000	19676	9910	15	0	2
317061	1874	12256000	19676	9910	16	0	2
317062	1874	12258000	19676	9910	17	0	2
317082	112	66037334116779	19678	9911	1	0	7
317083	534	66651272116779	19678	9911	2	0	0
317084	245	66651272116779	19678	9911	3	0	0
317085	421	66651272116779	19678	9911	4	0	0
317086	620	66651272116779	19678	9911	5	0	0
317088	1874	12263000	19678	9911	8	0	2
317098	352	66651272116779	19680	9912	0	0	0
317099	652	66651272116779	19680	9912	1	0	0
317100	191	66651272116779	19680	9912	2	0	0
317101	266	66038252116779	19680	9912	3	0	2
317103	84	66651272116779	19680	9912	5	0	0
317104	1678	21600733618000	19680	9912	6	0	0
317105	1874	12266000	19680	9912	7	0	2
317134	600	66651272116779	19684	9913	0	0	0
317136	691	66651272116779	19684	9913	2	0	0
317137	2017	649871451178	19684	9913	3	0	2
317138	551	66651272116779	19684	9913	4	0	0
317139	520	66651272116779	19684	9913	5	0	0
317140	1874	12268000	19684	9913	6	0	2
317153	392	66651272116779	19686	9914	1	0	\N
317154	89	66651272116779	19686	9914	2	0	\N
317155	186	66651272116779	19686	9914	3	0	\N
317156	383	66651272116779	19686	9914	4	0	\N
317157	308	66651272116779	19686	9914	5	0	\N
317158	408	66651272116779	19686	9914	6	0	\N
317159	678	66651272116779	19686	9914	7	0	\N
317160	1874	12274000	19686	9914	8	0	\N
317161	1874	12276000	19686	9914	9	0	\N
317162	1678	21600733620000	19687	9914	0	0	\N
317163	392	66651272116779	19687	9914	1	0	\N
317164	89	66651272116779	19687	9914	2	0	\N
317165	186	66651272116779	19687	9914	3	0	\N
317166	383	66651272116779	19687	9914	4	0	\N
317167	308	66651272116779	19687	9914	5	0	\N
317168	408	66651272116779	19687	9914	6	0	\N
317169	1874	12274000	19687	9914	7	0	\N
317170	1874	12276000	19687	9914	8	0	\N
317171	1678	21600733620000	19688	9914	0	0	\N
317172	392	66651272116779	19688	9914	1	0	\N
317173	89	66651272116779	19688	9914	2	0	\N
317174	186	66651272116779	19688	9914	3	0	\N
317175	383	66651272116779	19688	9914	4	0	\N
317176	308	66651272116779	19688	9914	5	0	\N
317177	408	66651272116779	19688	9914	6	0	\N
317178	1874	12274000	19688	9914	7	0	\N
317179	1874	12276000	19688	9914	8	0	\N
317190	1678	21600733620000	19690	9914	0	0	\N
317191	89	66651272116779	19690	9914	1	0	\N
317192	186	66651272116779	19690	9914	2	0	\N
317193	383	66651272116779	19690	9914	3	0	\N
317194	308	66651272116779	19690	9914	4	0	\N
317195	408	66651272116779	19690	9914	5	0	\N
317196	1874	12276000	19690	9914	6	0	\N
317205	593	66650271116779	19692	9915	0	0	\N
317206	91	66651272116779	19692	9915	1	0	\N
317207	1678	21600733621000	19692	9915	2	0	\N
317208	438	66651272116779	19692	9915	3	0	\N
317209	339	66651272116779	19692	9915	4	0	\N
317210	601	66651272116779	19692	9915	5	0	\N
317211	1874	12279000	19692	9915	6	0	\N
317212	1874	12281000	19692	9915	7	0	\N
317213	593	66650271116779	19693	9915	0	0	\N
317214	91	66651272116779	19693	9915	1	0	\N
317215	1678	21600733621000	19693	9915	2	0	\N
317216	438	66651272116779	19693	9915	3	0	\N
317217	339	66651272116779	19693	9915	4	0	\N
317218	601	66651272116779	19693	9915	5	0	\N
317219	1874	12279000	19693	9915	6	0	\N
317220	1874	12281000	19693	9915	7	0	\N
317221	1678	21600733597000	19694	9879	0	0	\N
317222	399	66651272116779	19694	9879	1	0	\N
317223	499	66651272116779	19694	9879	2	0	\N
317224	1772	4656971682095	19694	9879	3	0	\N
317225	54	66651272116779	19694	9879	4	0	\N
317226	710	5049338796669	19694	9879	5	0	\N
317227	1811	1778097057551	19694	9879	6	0	\N
317228	217	66651272116779	19694	9879	7	0	\N
317229	103	66651272116779	19694	9879	8	0	\N
317230	35	19389460979377	19694	9879	9	0	\N
317231	49	66651272116779	19694	9879	10	0	\N
317232	251	66651272116779	19694	9879	11	0	\N
317233	893	309850571298133	19694	9879	12	0	\N
317234	320	66370072116779	19694	9879	13	0	\N
317235	1030	909863680121925	19694	9879	14	0	\N
317236	663	66651272116779	19694	9879	15	0	\N
317237	390	66651272116779	19694	9879	16	0	\N
317238	108	66651272116779	19694	9879	17	0	\N
317239	894	309850571298133	19694	9879	18	0	\N
317240	569	66651272116779	19694	9879	19	0	\N
317241	99	66651272116779	19694	9879	20	0	\N
317242	570	66651272116779	19694	9879	21	0	\N
317243	225	66651272116779	19694	9879	22	0	\N
317244	377	66651272116779	19694	9879	23	0	\N
317245	560	66651272116779	19694	9879	24	0	\N
317246	252	66651272116779	19694	9879	25	0	\N
317247	1962	650184292006	19694	9879	26	0	\N
317248	201	66651272116779	19694	9879	27	0	\N
317249	402	66651272116779	19694	9879	28	0	\N
317250	163	66651272116779	19694	9879	29	0	\N
317251	82	66651272116779	19694	9879	30	0	\N
317252	275	66651272116779	19694	9879	31	0	\N
317253	361	66651272116779	19694	9879	32	0	\N
317254	309	66651272116779	19694	9879	33	0	\N
317255	2073	649447026849	19694	9879	34	0	\N
317256	452	66651272116779	19694	9879	35	0	\N
317257	594	66651272116779	19694	9879	36	0	\N
317258	2181	649523922882	19694	9879	37	0	\N
317259	680	66651272116779	19694	9879	38	0	\N
317260	391	66649672116779	19694	9879	39	0	\N
317261	690	66651272116779	19694	9879	40	0	\N
317262	353	66650052116779	19694	9879	41	0	\N
317263	731	2019735518605	19694	9879	42	0	\N
317264	2164	649932922882	19694	9879	43	0	\N
317265	180	66651272116779	19694	9879	44	0	\N
317266	112	66037334116779	19694	9879	45	0	\N
317267	534	66651272116779	19694	9879	46	0	\N
317268	245	66651272116779	19694	9879	47	0	\N
317269	421	66651272116779	19694	9879	48	0	\N
317270	620	66651272116779	19694	9879	50	0	\N
317271	352	66651272116779	19694	9879	51	0	\N
317272	652	66651272116779	19694	9879	52	0	\N
317273	191	66651272116779	19694	9879	53	0	\N
317274	266	66038252116779	19694	9879	54	0	\N
317275	1150	613903155292823	19694	9879	55	0	\N
317276	84	66651272116779	19694	9879	56	0	\N
317277	600	66651272116779	19694	9879	57	0	\N
317278	691	66651272116779	19694	9879	58	0	\N
317279	2017	649871451178	19694	9879	59	0	\N
317280	551	66651272116779	19694	9879	60	0	\N
317281	520	66651272116779	19694	9879	61	0	\N
317282	392	66651272116779	19694	9879	62	0	\N
317283	89	66651272116779	19694	9879	63	0	\N
317284	186	66651272116779	19694	9879	64	0	\N
317285	383	66651272116779	19694	9879	65	0	\N
317286	308	66651272116779	19694	9879	66	0	\N
317287	408	66651272116779	19694	9879	67	0	\N
317288	678	66651272116779	19694	9879	68	0	\N
317182	89	66651272116779	19689	9914	2	0	0
317183	186	66651272116779	19689	9914	3	0	0
317184	383	66651272116779	19689	9914	4	0	0
317185	308	66651272116779	19689	9914	5	0	0
317186	408	66651272116779	19689	9914	6	0	0
317188	1874	12274000	19689	9914	8	0	2
317189	1874	12276000	19689	9914	9	0	2
317197	593	66650271116779	19691	9915	0	0	1
317198	91	66651272116779	19691	9915	1	0	0
317199	1678	21600733621000	19691	9915	2	0	0
317201	339	66651272116779	19691	9915	4	0	0
317202	601	66651272116779	19691	9915	5	0	0
317203	1874	12279000	19691	9915	6	0	2
317204	1874	12281000	19691	9915	7	0	2
317289	593	66650271116779	19694	9879	69	0	\N
317290	91	66651272116779	19694	9879	70	0	\N
317291	1678	21600733598000	19694	9879	71	0	\N
317292	1678	21600733599000	19694	9879	72	0	\N
317293	1678	21600733600000	19694	9879	73	0	\N
317294	1678	21600733601000	19694	9879	74	0	\N
317295	1678	21600733602000	19694	9879	75	0	\N
317296	1678	21600733603000	19694	9879	76	0	\N
317297	1678	21600733604000	19694	9879	77	0	\N
317298	1678	21600733605000	19694	9879	78	0	\N
317299	1678	21600733606000	19694	9879	79	0	\N
317300	1678	21600733607000	19694	9879	80	0	\N
317301	1678	21600733608000	19694	9879	81	0	\N
317302	1678	21600733609000	19694	9879	82	0	\N
317303	1678	21600733610000	19694	9879	83	0	\N
317304	1678	21600733611000	19694	9879	84	0	\N
317305	1678	21600733612000	19694	9879	85	0	\N
317306	1678	21600733613000	19694	9879	86	0	\N
317307	1678	21600733614000	19694	9879	87	0	\N
317308	1678	21600733615000	19694	9879	88	0	\N
317309	1678	21600733616000	19694	9879	89	0	\N
317310	1678	21600733617000	19694	9879	90	0	\N
317311	1678	21600733618000	19694	9879	91	0	\N
317312	1678	21600733619000	19694	9879	92	0	\N
317313	1678	21600733620000	19694	9879	93	0	\N
317314	1678	21600733621000	19694	9879	94	0	\N
317315	1874	12156000	19694	9879	95	0	\N
317316	1874	12159000	19694	9879	96	0	\N
317317	44	66000000000000	19694	9879	97	0	\N
317318	1874	12161000	19694	9879	98	0	\N
317319	1874	12163000	19694	9879	99	0	\N
317320	1874	12165000	19694	9879	100	0	\N
317321	1874	12167000	19694	9879	101	0	\N
317322	1874	12169000	19694	9879	102	0	\N
317323	1874	12171000	19694	9879	103	0	\N
317324	1874	12173000	19694	9879	104	0	\N
317325	1874	12175000	19694	9879	105	0	\N
317326	1874	12177000	19694	9879	106	0	\N
317327	1874	12179000	19694	9879	107	0	\N
317328	1874	12181000	19694	9879	108	0	\N
317329	1874	12183000	19694	9879	109	0	\N
317330	1874	12185000	19694	9879	110	0	\N
317331	1874	12187000	19694	9879	111	0	\N
317332	1874	12189000	19694	9879	112	0	\N
317333	1874	12191000	19694	9879	113	0	\N
317334	1874	12193000	19694	9879	114	0	\N
317335	1874	12195000	19694	9879	115	0	\N
317336	1874	12197000	19694	9879	116	0	\N
317337	1874	12199000	19694	9879	117	0	\N
317338	1874	12201000	19694	9879	118	0	\N
317339	1874	12203000	19694	9879	119	0	\N
317340	1874	12205000	19694	9879	120	0	\N
317341	1874	12207000	19694	9879	121	0	\N
317342	1874	12209000	19694	9879	122	0	\N
317343	1874	12212000	19694	9879	123	0	\N
317344	1874	12215000	19694	9879	124	0	\N
317345	1874	12218000	19694	9879	125	0	\N
317346	745	2019735518605	19695	9916	0	0	\N
317347	1678	21600733622000	19695	9916	1	0	\N
317348	150	66651272116779	19695	9916	2	0	\N
317349	92	66651272116779	19695	9916	3	0	\N
317350	63	66651272116779	19695	9916	4	0	\N
317351	450	66651272116779	19695	9916	5	0	\N
317352	322	66651272116779	19695	9916	6	0	\N
317353	1874	12284000	19695	9916	7	0	\N
317354	1874	12286000	19695	9916	8	0	\N
317402	1678	21600733628000	19700	9920	0	0	\N
317403	1874	12314000	19700	9920	1	0	\N
317404	1874	12316000	19700	9920	2	0	\N
317405	1678	21600733628000	19701	9920	0	0	\N
317406	1874	12314000	19701	9920	1	0	\N
317407	1874	12316000	19701	9920	2	0	\N
317408	399	66651272116779	19702	9886	0	0	\N
317409	499	66651272116779	19702	9886	1	0	\N
317410	1772	4656971682095	19702	9886	2	0	\N
317411	54	66651272116779	19702	9886	3	0	\N
317412	1678	21600733583000	19702	9886	4	0	\N
317413	1678	21600733584000	19702	9886	5	0	\N
317414	1678	21600733585000	19702	9886	6	0	\N
317415	1678	21600733586000	19702	9886	7	0	\N
317416	1678	21600733587000	19702	9886	8	0	\N
317417	1678	21600733588000	19702	9886	9	0	\N
317418	1678	21600733589000	19702	9886	10	0	\N
317419	1678	21600733590000	19702	9886	11	0	\N
317420	1678	21600733591000	19702	9886	12	0	\N
317421	710	5049338796669	19702	9886	13	0	\N
317422	1678	21600733592000	19702	9886	14	0	\N
317423	1678	21600733593000	19702	9886	15	0	\N
317424	1678	21600733594000	19702	9886	16	0	\N
317357	150	66651272116779	19696	9916	2	0	0
317358	92	66651272116779	19696	9916	3	0	0
317359	63	66651272116779	19696	9916	4	0	0
317360	450	66651272116779	19696	9916	5	0	0
317361	322	66651272116779	19696	9916	6	0	0
317363	1874	12286000	19696	9916	8	0	2
317364	373	66651272116779	19697	9917	0	0	0
317365	1678	21600733623000	19697	9917	1	0	0
317366	1678	21600733624000	19697	9917	2	0	0
317367	453	66651272116779	19697	9917	3	0	0
317369	138	66651272116779	19697	9917	5	0	0
317370	146	66651272116779	19697	9917	6	0	0
317371	395	66148231116779	19697	9917	7	0	2
317372	587	66651272116779	19697	9917	8	0	0
317374	1961	650184292006	19697	9917	10	0	1
317375	500	66651272116779	19697	9917	11	0	0
317376	504	66038202116779	19697	9917	12	0	3
317377	1874	12288000	19697	9917	13	0	2
317378	1874	12290000	19697	9917	14	0	2
317380	1874	12296000	19697	9917	16	0	2
317381	78	66651272116779	19698	9918	0	0	0
317382	611	66651272116779	19698	9918	1	0	0
317383	205	66651272116779	19698	9918	2	0	0
317384	658	66651272116779	19698	9918	3	0	0
317386	1678	21600733625000	19698	9918	5	0	0
317387	1678	21600733626000	19698	9918	6	0	0
317388	1276	1710695727448440	19698	9918	7	0	0
317389	660	66651272116779	19698	9918	8	0	0
317391	622	66654252116779	19698	9918	10	0	1
317392	105	66651272116779	19698	9918	11	0	0
317393	122	66651272116779	19698	9918	12	0	0
317394	721	2019735518605	19698	9918	13	0	0
317395	1874	12299000	19698	9918	14	0	2
317397	1874	12304000	19698	9918	16	0	2
317398	1874	12306000	19698	9918	17	0	2
317399	1678	21600733627000	19699	9919	0	0	0
317400	1874	12308000	19699	9919	1	0	2
317401	1874	12311000	19699	9919	2	0	2
317425	1678	21600733595000	19702	9886	17	0	\N
317426	1678	21600733596000	19702	9886	18	0	\N
317427	1678	21600733597000	19702	9886	19	0	\N
317428	1811	1778097057551	19702	9886	20	0	\N
317429	217	66651272116779	19702	9886	21	0	\N
317430	103	66651272116779	19702	9886	22	0	\N
317431	35	19389460979377	19702	9886	23	0	\N
317432	49	66651272116779	19702	9886	24	0	\N
317433	251	66651272116779	19702	9886	25	0	\N
317434	893	309850571298133	19702	9886	26	0	\N
317435	320	66370072116779	19702	9886	27	0	\N
317436	1030	909863680121925	19702	9886	28	0	\N
317437	663	66651272116779	19702	9886	29	0	\N
317438	390	66651272116779	19702	9886	30	0	\N
317439	108	66651272116779	19702	9886	31	0	\N
317440	894	309850571298133	19702	9886	32	0	\N
317441	569	66651272116779	19702	9886	33	0	\N
317442	99	66651272116779	19702	9886	34	0	\N
317443	570	66651272116779	19702	9886	35	0	\N
317444	225	66651272116779	19702	9886	36	0	\N
317445	377	66651272116779	19702	9886	37	0	\N
317446	560	66651272116779	19702	9886	38	0	\N
317447	252	66651272116779	19702	9886	39	0	\N
317448	1962	650184292006	19702	9886	40	0	\N
317449	201	66651272116779	19702	9886	41	0	\N
317450	402	66651272116779	19702	9886	42	0	\N
317451	163	66651272116779	19702	9886	43	0	\N
317452	82	66651272116779	19702	9886	44	0	\N
317453	275	66651272116779	19702	9886	45	0	\N
317454	361	66651272116779	19702	9886	46	0	\N
317455	309	66651272116779	19702	9886	47	0	\N
317456	2073	649447026849	19702	9886	48	0	\N
317457	452	66651272116779	19702	9886	49	0	\N
317458	594	66651272116779	19702	9886	50	0	\N
317459	2181	649523922882	19702	9886	51	0	\N
317460	680	66651272116779	19702	9886	52	0	\N
317461	391	66649672116779	19702	9886	53	0	\N
317462	690	66651272116779	19702	9886	54	0	\N
317463	353	66650052116779	19702	9886	55	0	\N
317464	731	2019735518605	19702	9886	56	0	\N
317465	2164	649932922882	19702	9886	57	0	\N
317466	180	66651272116779	19702	9886	58	0	\N
317467	112	66037334116779	19702	9886	59	0	\N
317468	534	66651272116779	19702	9886	60	0	\N
317469	245	66651272116779	19702	9886	61	0	\N
317470	421	66651272116779	19702	9886	62	0	\N
317471	620	66651272116779	19702	9886	63	0	\N
317472	352	66651272116779	19702	9886	64	0	\N
317473	652	66651272116779	19702	9886	65	0	\N
317474	191	66651272116779	19702	9886	66	0	\N
317475	266	66038252116779	19702	9886	67	0	\N
317476	1150	613903155292823	19702	9886	68	0	\N
317477	84	66651272116779	19702	9886	69	0	\N
317478	600	66651272116779	19702	9886	70	0	\N
317479	691	66651272116779	19702	9886	71	0	\N
317480	2017	649871451178	19702	9886	72	0	\N
317481	551	66651272116779	19702	9886	73	0	\N
317482	520	66651272116779	19702	9886	74	0	\N
317483	392	66651272116779	19702	9886	75	0	\N
317484	89	66651272116779	19702	9886	76	0	\N
317485	186	66651272116779	19702	9886	77	0	\N
317486	383	66651272116779	19702	9886	78	0	\N
317487	308	66651272116779	19702	9886	79	0	\N
317488	408	66651272116779	19702	9886	80	0	\N
317489	678	66651272116779	19702	9886	82	0	\N
317490	593	66650271116779	19702	9886	83	0	\N
317491	91	66651272116779	19702	9886	84	0	\N
317492	438	66651272116779	19702	9886	85	0	\N
317493	339	66651272116779	19702	9886	86	0	\N
317494	601	66651272116779	19702	9886	87	0	\N
317495	745	2019735518605	19702	9886	88	0	\N
317496	150	66651272116779	19702	9886	89	0	\N
317497	92	66651272116779	19702	9886	90	0	\N
317498	63	66651272116779	19702	9886	91	0	\N
317499	450	66651272116779	19702	9886	92	0	\N
317500	322	66651272116779	19702	9886	93	0	\N
317501	373	66651272116779	19702	9886	94	0	\N
317502	453	66651272116779	19702	9886	95	0	\N
317503	29	7069074315355	19702	9886	96	0	\N
317504	138	66651272116779	19702	9886	97	0	\N
317505	146	66651272116779	19702	9886	98	0	\N
317506	395	66148231116779	19702	9886	99	0	\N
317507	587	66651272116779	19702	9886	100	0	\N
317508	910	507738856265767	19702	9886	101	0	\N
317509	1961	650184292006	19702	9886	102	0	\N
317510	500	66651272116779	19702	9886	103	0	\N
317511	504	66038202116779	19702	9886	104	0	\N
317512	78	66651272116779	19702	9886	105	0	\N
317513	611	66651272116779	19702	9886	106	0	\N
317514	205	66651272116779	19702	9886	107	0	\N
317515	658	66651272116779	19702	9886	108	0	\N
317516	194	66651272116779	19702	9886	109	0	\N
317517	1276	1710695727448440	19702	9886	110	0	\N
317518	660	66651272116779	19702	9886	111	0	\N
317519	653	66651272116779	19702	9886	112	0	\N
317520	622	66654252116779	19702	9886	113	0	\N
317521	105	66651272116779	19702	9886	114	0	\N
317522	122	66651272116779	19702	9886	115	0	\N
317523	721	2019735518605	19702	9886	116	0	\N
317524	206	66651272116779	19702	9886	117	0	\N
317525	304	66651272116779	19702	9886	118	0	\N
317526	1678	21600733598000	19702	9886	119	0	\N
317527	1678	21600733599000	19702	9886	120	0	\N
317528	1678	21600733600000	19702	9886	121	0	\N
317529	1678	21600733601000	19702	9886	122	0	\N
317530	1678	21600733602000	19702	9886	123	0	\N
317531	1678	21600733603000	19702	9886	124	0	\N
317532	1678	21600733604000	19702	9886	125	0	\N
317548	1678	21600733633000	19706	9923	0	0	\N
317549	304	66651272116779	19706	9923	1	0	\N
317550	206	66651272116779	19706	9923	2	0	\N
317551	1874	12338000	19706	9923	3	0	\N
317552	1874	12341000	19706	9923	4	0	\N
317553	1678	21600733633000	19707	9923	0	0	\N
317554	304	66651272116779	19707	9923	1	0	\N
317555	206	66651272116779	19707	9923	2	0	\N
317556	1874	12338000	19707	9923	3	0	\N
317557	1874	12341000	19707	9923	4	0	\N
317558	1678	21600733633000	19708	9923	0	0	\N
317559	304	66651272116779	19708	9923	1	0	\N
317560	206	66651272116779	19708	9923	2	0	\N
317535	1874	12316000	19703	9920	2	0	2
317536	1678	21600733629000	19704	9921	0	0	0
317537	1678	21600733630000	19704	9921	1	0	0
317538	1874	12318000	19704	9921	2	0	2
317539	1874	12321000	19704	9921	3	0	2
317541	1874	12326000	19704	9921	5	0	2
317542	1678	21600733631000	19705	9922	0	0	0
317543	1678	21600733632000	19705	9922	1	0	0
317544	1874	12328000	19705	9922	2	0	2
317545	1874	12331000	19705	9922	3	0	2
317547	1874	12336000	19705	9922	5	0	2
317561	1874	12338000	19708	9923	3	0	\N
317562	1874	12341000	19708	9923	4	0	\N
317568	1678	21600733634000	19710	9924	0	0	\N
317569	1874	12343000	19710	9924	1	0	\N
317570	1874	12346000	19710	9924	2	0	\N
317571	1678	21600733634000	19711	9924	0	0	\N
317572	1874	12343000	19711	9924	1	0	\N
317573	1874	12346000	19711	9924	2	0	\N
317577	1678	21600733635000	19713	9925	0	0	\N
317578	1874	12348000	19713	9925	1	0	\N
317582	2230	0	19715	9824	0	0	\N
317583	399	66651272116779	19715	9824	1	0	\N
317584	499	66651272116779	19715	9824	2	0	\N
317585	1772	4656971682095	19715	9824	3	0	\N
317586	54	66651272116779	19715	9824	4	0	\N
317587	1678	21600733497000	19715	9824	5	0	\N
317588	710	5049338796669	19715	9824	6	0	\N
317589	1678	21600733498000	19715	9824	7	0	\N
317590	1678	21600733499000	19715	9824	8	0	\N
317591	1678	21600733500000	19715	9824	9	0	\N
317592	1678	21600733501000	19715	9824	10	0	\N
317593	1678	21600733502000	19715	9824	11	0	\N
317594	1678	21600733503000	19715	9824	12	0	\N
317595	1678	21600733504000	19715	9824	13	0	\N
317596	1678	21600733505000	19715	9824	14	0	\N
317597	1678	21600733506000	19715	9824	15	0	\N
317598	1678	21600733507000	19715	9824	16	0	\N
317599	1678	21600733508000	19715	9824	17	0	\N
317600	1678	21600733509000	19715	9824	18	0	\N
317601	1811	1778097057551	19715	9824	19	0	\N
317602	217	66651272116779	19715	9824	20	0	\N
317603	103	66651272116779	19715	9824	21	0	\N
317604	35	19389460979377	19715	9824	22	0	\N
317605	49	66651272116779	19715	9824	23	0	\N
317606	251	66651272116779	19715	9824	24	0	\N
317607	893	309850571298133	19715	9824	25	0	\N
317608	320	66370072116779	19715	9824	26	0	\N
317609	1030	909863680121925	19715	9824	27	0	\N
317610	663	66651272116779	19715	9824	28	0	\N
317611	390	66651272116779	19715	9824	29	0	\N
317612	108	66651272116779	19715	9824	30	0	\N
317613	894	309850571298133	19715	9824	31	0	\N
317614	569	66651272116779	19715	9824	32	0	\N
317615	99	66651272116779	19715	9824	33	0	\N
317616	570	66651272116779	19715	9824	34	0	\N
317617	225	66651272116779	19715	9824	35	0	\N
317618	377	66651272116779	19715	9824	36	0	\N
317619	560	66651272116779	19715	9824	37	0	\N
317620	252	66651272116779	19715	9824	38	0	\N
317621	1962	650184292006	19715	9824	39	0	\N
317622	201	66651272116779	19715	9824	40	0	\N
317623	402	66651272116779	19715	9824	41	0	\N
317624	163	66651272116779	19715	9824	42	0	\N
317625	82	66651272116779	19715	9824	43	0	\N
317626	275	66651272116779	19715	9824	44	0	\N
317627	361	66651272116779	19715	9824	45	0	\N
317628	309	66651272116779	19715	9824	46	0	\N
317629	2073	649447026849	19715	9824	47	0	\N
317630	452	66651272116779	19715	9824	48	0	\N
317631	594	66651272116779	19715	9824	49	0	\N
317632	2181	649523922882	19715	9824	50	0	\N
317633	680	66651272116779	19715	9824	51	0	\N
317634	1678	21600733510000	19715	9824	52	0	\N
317635	1678	21600733511000	19715	9824	53	0	\N
317636	1678	21600733512000	19715	9824	54	0	\N
317637	1678	21600733513000	19715	9824	55	0	\N
317638	1678	21600733514000	19715	9824	56	0	\N
317639	1678	21600733515000	19715	9824	57	0	\N
317640	1678	21600733516000	19715	9824	58	0	\N
317641	1678	21600733517000	19715	9824	59	0	\N
317642	1678	21600733518000	19715	9824	60	0	\N
317643	1678	21600733519000	19715	9824	61	0	\N
317644	1678	21600733520000	19715	9824	62	0	\N
317645	1678	21600733521000	19715	9824	63	0	\N
317646	1678	21600733522000	19715	9824	64	0	\N
317647	1678	21600733523000	19715	9824	65	0	\N
317648	1678	21600733524000	19715	9824	66	0	\N
317649	1678	21600733525000	19715	9824	67	0	\N
317650	1678	21600733526000	19715	9824	68	0	\N
317651	1678	21600733527000	19715	9824	69	0	\N
317652	1678	21600733528000	19715	9824	70	0	\N
317653	1678	21600733529000	19715	9824	71	0	\N
317654	1678	21600733530000	19715	9824	72	0	\N
317655	1678	21600733531000	19715	9824	73	0	\N
317656	1678	21600733532000	19715	9824	74	0	\N
317657	1678	21600733533000	19715	9824	75	0	\N
317658	1678	21600733534000	19715	9824	76	0	\N
317659	1678	21600733535000	19715	9824	77	0	\N
317660	1678	21600733536000	19715	9824	78	0	\N
317661	1678	21600733537000	19715	9824	79	0	\N
317662	1678	21600733538000	19715	9824	80	0	\N
317663	1678	21600733539000	19715	9824	81	0	\N
317664	1678	21600733540000	19715	9824	82	0	\N
317665	1678	21600733541000	19715	9824	83	0	\N
317666	1678	21600733542000	19715	9824	84	0	\N
317667	1678	21600733543000	19715	9824	85	0	\N
317668	1678	21600733544000	19715	9824	86	0	\N
317669	1678	21600733545000	19715	9824	87	0	\N
317670	1678	21600733546000	19715	9824	88	0	\N
317671	1678	21600733547000	19715	9824	89	0	\N
317672	1678	21600733548000	19715	9824	90	0	\N
317673	1678	21600733549000	19715	9824	91	0	\N
317674	1678	21600733550000	19715	9824	92	0	\N
317675	1678	21600733551000	19715	9824	93	0	\N
317676	1678	21600733552000	19715	9824	94	0	\N
317677	1678	21600733553000	19715	9824	95	0	\N
317678	1678	21600733554000	19715	9824	96	0	\N
317679	1678	21600733555000	19715	9824	97	0	\N
317680	1678	21600733556000	19715	9824	98	0	\N
317681	1678	21600733557000	19715	9824	99	0	\N
317682	1678	21600733558000	19715	9824	100	0	\N
317683	1678	21600733559000	19715	9824	101	0	\N
317684	1678	21600733560000	19715	9824	102	0	\N
317685	1678	21600733561000	19715	9824	103	0	\N
317686	1678	21600733562000	19715	9824	104	0	\N
317687	1678	21600733563000	19715	9824	105	0	\N
317688	1678	21600733564000	19715	9824	106	0	\N
317689	1678	21600733565000	19715	9824	107	0	\N
317690	1678	21600733566000	19715	9824	108	0	\N
317691	1678	21600733567000	19715	9824	110	0	\N
317692	1678	21600733568000	19715	9824	111	0	\N
317693	1678	21600733569000	19715	9824	112	0	\N
317694	1678	21600733570000	19715	9824	113	0	\N
317695	1678	21600733571000	19715	9824	114	0	\N
317696	1678	21600733572000	19715	9824	115	0	\N
317565	206	66651272116779	19709	9923	2	0	0
317566	1874	12338000	19709	9923	3	0	2
317567	1874	12341000	19709	9923	4	0	2
317574	1678	21600733634000	19712	9924	0	0	0
317575	1874	12343000	19712	9924	1	0	2
317579	1678	21600733635000	19714	9925	0	0	0
317580	1874	12349000	19714	9925	1	0	2
317581	1874	12351000	19714	9925	2	0	2
317697	1678	21600733573000	19715	9824	116	0	\N
317698	1678	21600733574000	19715	9824	117	0	\N
317699	1678	21600733575000	19715	9824	118	0	\N
317700	1678	21600733576000	19715	9824	119	0	\N
317701	1678	21600733577000	19715	9824	120	0	\N
317702	1678	21600733578000	19715	9824	121	0	\N
317703	1678	21600733579000	19715	9824	122	0	\N
317704	1678	21600733580000	19715	9824	123	0	\N
317705	1678	21600733581000	19715	9824	124	0	\N
317706	1678	21600733582000	19715	9824	125	0	\N
317722	1678	21600733641000	19719	9929	0	0	\N
317723	1678	21600733642000	19719	9929	1	0	\N
317724	1874	12376000	19719	9929	2	0	\N
317725	1874	12379000	19719	9929	3	0	\N
317732	1678	21600733643000	19721	9930	0	0	\N
317733	1874	12385000	19721	9930	1	0	\N
317734	1874	12388000	19721	9930	2	0	\N
317738	399	66651272116779	19723	9846	0	0	\N
317739	499	66651272116779	19723	9846	1	0	\N
317740	1772	4656971682095	19723	9846	2	0	\N
317741	54	66651272116779	19723	9846	3	0	\N
317742	710	5049338796669	19723	9846	4	0	\N
317743	1811	1778097057551	19723	9846	5	0	\N
317744	217	66651272116779	19723	9846	6	0	\N
317745	103	66651272116779	19723	9846	7	0	\N
317746	35	19389460979377	19723	9846	8	0	\N
317747	49	66651272116779	19723	9846	9	0	\N
317748	251	66651272116779	19723	9846	10	0	\N
317749	893	309850571298133	19723	9846	11	0	\N
317750	320	66370072116779	19723	9846	12	0	\N
317751	1030	909863680121925	19723	9846	13	0	\N
317752	663	66651272116779	19723	9846	14	0	\N
317753	390	66651272116779	19723	9846	15	0	\N
317754	108	66651272116779	19723	9846	16	0	\N
317755	894	309850571298133	19723	9846	17	0	\N
317756	569	66651272116779	19723	9846	18	0	\N
317757	99	66651272116779	19723	9846	19	0	\N
317758	570	66651272116779	19723	9846	20	0	\N
317759	225	66651272116779	19723	9846	21	0	\N
317760	377	66651272116779	19723	9846	22	0	\N
317761	560	66651272116779	19723	9846	23	0	\N
317762	252	66651272116779	19723	9846	24	0	\N
317763	1962	650184292006	19723	9846	25	0	\N
317764	201	66651272116779	19723	9846	26	0	\N
317765	402	66651272116779	19723	9846	27	0	\N
317766	163	66651272116779	19723	9846	28	0	\N
317767	82	66651272116779	19723	9846	29	0	\N
317768	275	66651272116779	19723	9846	30	0	\N
317769	361	66651272116779	19723	9846	31	0	\N
317770	309	66651272116779	19723	9846	32	0	\N
317771	2073	649447026849	19723	9846	33	0	\N
317772	452	66651272116779	19723	9846	34	0	\N
317773	594	66651272116779	19723	9846	35	0	\N
317774	2181	649523922882	19723	9846	36	0	\N
317775	680	66651272116779	19723	9846	37	0	\N
317776	391	66649672116779	19723	9846	38	0	\N
317777	690	66651272116779	19723	9846	39	0	\N
317778	353	66650052116779	19723	9846	40	0	\N
317779	731	2019735518605	19723	9846	41	0	\N
317780	2164	649932922882	19723	9846	42	0	\N
317781	180	66651272116779	19723	9846	43	0	\N
317782	112	66037334116779	19723	9846	44	0	\N
317783	534	66651272116779	19723	9846	45	0	\N
317784	245	66651272116779	19723	9846	46	0	\N
317785	421	66651272116779	19723	9846	47	0	\N
317786	620	66651272116779	19723	9846	48	0	\N
317787	352	66651272116779	19723	9846	49	0	\N
317788	652	66651272116779	19723	9846	50	0	\N
317789	191	66651272116779	19723	9846	51	0	\N
317790	266	66038252116779	19723	9846	52	0	\N
317791	1150	613903155292823	19723	9846	53	0	\N
317792	84	66651272116779	19723	9846	54	0	\N
317793	600	66651272116779	19723	9846	55	0	\N
317794	691	66651272116779	19723	9846	56	0	\N
317795	2017	649871451178	19723	9846	57	0	\N
317796	551	66651272116779	19723	9846	58	0	\N
317797	520	66651272116779	19723	9846	59	0	\N
317798	392	66651272116779	19723	9846	60	0	\N
317799	89	66651272116779	19723	9846	61	0	\N
317800	186	66651272116779	19723	9846	62	0	\N
317801	383	66651272116779	19723	9846	63	0	\N
317802	308	66651272116779	19723	9846	64	0	\N
317803	408	66651272116779	19723	9846	65	0	\N
317804	678	66651272116779	19723	9846	66	0	\N
317805	593	66650271116779	19723	9846	67	0	\N
317806	91	66651272116779	19723	9846	68	0	\N
317807	438	66651272116779	19723	9846	69	0	\N
317808	339	66651272116779	19723	9846	70	0	\N
317809	601	66651272116779	19723	9846	71	0	\N
317810	745	2019735518605	19723	9846	72	0	\N
317811	150	66651272116779	19723	9846	73	0	\N
317812	92	66651272116779	19723	9846	74	0	\N
317813	63	66651272116779	19723	9846	75	0	\N
317814	450	66651272116779	19723	9846	76	0	\N
317815	322	66651272116779	19723	9846	77	0	\N
317816	373	66651272116779	19723	9846	78	0	\N
317817	453	66651272116779	19723	9846	79	0	\N
317818	29	7069074315355	19723	9846	80	0	\N
317819	138	66651272116779	19723	9846	81	0	\N
317820	146	66651272116779	19723	9846	82	0	\N
317821	395	66148231116779	19723	9846	83	0	\N
317822	587	66651272116779	19723	9846	84	0	\N
317823	910	507738856265767	19723	9846	85	0	\N
317824	1961	650184292006	19723	9846	86	0	\N
317825	500	66651272116779	19723	9846	87	0	\N
317826	504	66038202116779	19723	9846	88	0	\N
317827	78	66651272116779	19723	9846	89	0	\N
317828	611	66651272116779	19723	9846	90	0	\N
317829	205	66651272116779	19723	9846	91	0	\N
317830	658	66651272116779	19723	9846	92	0	\N
317831	194	66651272116779	19723	9846	93	0	\N
317832	1276	1710695727448440	19723	9846	94	0	\N
317709	1678	21600733638000	19716	9926	2	0	0
317710	1778	5450090000000	19716	9926	3	0	1
317711	1874	12354000	19716	9926	4	0	2
317712	1874	12357000	19716	9926	5	0	2
317713	1874	12359000	19716	9926	6	0	2
317715	1874	12363000	19716	9926	8	0	2
317716	1678	21600733639000	19717	9927	0	0	0
317717	1874	12366000	19717	9927	1	0	2
317718	1874	12368000	19717	9927	2	0	2
317719	1678	21600733640000	19718	9928	0	0	0
317721	1874	12373000	19718	9928	2	0	2
317726	1678	21600733641000	19720	9929	0	0	0
317727	1678	21600733642000	19720	9929	1	0	0
317728	1874	12375000	19720	9929	2	0	2
317730	1874	12380000	19720	9929	4	0	2
317731	1874	12383000	19720	9929	5	0	2
317735	1678	21600733643000	19722	9930	0	0	0
317736	1874	12385000	19722	9930	1	0	2
317737	1874	12388000	19722	9930	2	0	2
317833	44	66000000000000	19723	9846	95	0	\N
317834	1678	21600733640000	19724	9928	0	0	\N
317835	1678	21600733641000	19724	9928	1	0	\N
317836	1678	21600733642000	19724	9928	2	0	\N
317837	1678	21600733643000	19724	9928	3	0	\N
317838	1874	12370000	19724	9928	4	0	\N
317839	1874	12372000	19724	9928	5	0	\N
317840	1874	12374000	19724	9928	6	0	\N
317841	1874	12376000	19724	9928	7	0	\N
317842	1874	12379000	19724	9928	8	0	\N
317843	1874	12382000	19724	9928	9	0	\N
317844	1874	12385000	19724	9928	10	0	\N
317845	1874	12388000	19724	9928	11	0	\N
317846	1678	21600733643000	19725	9930	0	0	\N
317847	1874	12386000	19725	9930	1	0	\N
317848	1678	21600733644000	19726	9931	0	0	\N
317849	1678	21600733645000	19726	9931	1	0	\N
317850	1874	12391000	19726	9931	2	0	\N
317851	1874	12394000	19726	9931	3	0	\N
317852	1874	12396000	19726	9931	4	0	\N
317853	1874	12398000	19726	9931	5	0	\N
317858	1678	21600733644000	19728	9931	0	0	\N
317859	1678	21600733645000	19728	9931	1	0	\N
317860	1874	12391000	19728	9931	2	0	\N
317861	1874	12394000	19728	9931	3	0	\N
317862	1874	12396000	19728	9931	4	0	\N
317863	1874	12398000	19728	9931	5	0	\N
317864	1678	21600733646000	19729	9932	0	0	\N
317865	1874	12397000	19729	9932	1	0	\N
317874	1678	21600733647000	19732	9933	0	0	\N
317875	1874	12406000	19732	9933	1	0	\N
317876	1874	12408000	19732	9933	2	0	\N
317886	1678	21600733650000	19735	9935	0	0	\N
317887	1874	12420000	19735	9935	1	0	\N
317888	1874	12423000	19735	9935	2	0	\N
317889	1874	12420000	19736	9935	0	0	\N
317890	1874	12423000	19736	9935	1	0	\N
317891	1874	12420000	19737	9935	0	0	\N
317892	1874	12423000	19737	9935	1	0	\N
317893	1678	21600733622000	19738	9880	0	0	\N
317894	1678	21600733623000	19738	9880	1	0	\N
317895	1678	21600733624000	19738	9880	2	0	\N
317896	1678	21600733625000	19738	9880	3	0	\N
317897	1678	21600733626000	19738	9880	4	0	\N
317898	1678	21600733627000	19738	9880	5	0	\N
317899	1678	21600733628000	19738	9880	6	0	\N
317900	1678	21600733629000	19738	9880	7	0	\N
317901	1678	21600733630000	19738	9880	8	0	\N
317902	1678	21600733631000	19738	9880	9	0	\N
317903	1678	21600733632000	19738	9880	10	0	\N
317904	1678	21600733633000	19738	9880	11	0	\N
317905	1678	21600733634000	19738	9880	12	0	\N
317906	1678	21600733635000	19738	9880	13	0	\N
317907	1678	21600733636000	19738	9880	14	0	\N
317908	1678	21600733637000	19738	9880	15	0	\N
317909	1678	21600733638000	19738	9880	16	0	\N
317910	1678	21600733639000	19738	9880	17	0	\N
317911	1678	21600733640000	19738	9880	18	0	\N
317912	1678	21600733641000	19738	9880	19	0	\N
317913	1678	21600733642000	19738	9880	20	0	\N
317914	1678	21600733643000	19738	9880	21	0	\N
317915	1678	21600733644000	19738	9880	22	0	\N
317916	1678	21600733645000	19738	9880	23	0	\N
317917	1678	21600733646000	19738	9880	24	0	\N
317918	1678	21600733647000	19738	9880	25	0	\N
317919	1678	21600733648000	19738	9880	26	0	\N
317920	1678	21600733649000	19738	9880	27	0	\N
317921	1678	21600733650000	19738	9880	28	0	\N
317922	1874	12221000	19738	9880	29	0	\N
317923	1874	12223000	19738	9880	30	0	\N
317924	1874	12225000	19738	9880	31	0	\N
317925	1874	12227000	19738	9880	32	0	\N
317926	1874	12229000	19738	9880	33	0	\N
317927	1874	12232000	19738	9880	34	0	\N
317928	1874	12235000	19738	9880	35	0	\N
317929	1874	12238000	19738	9880	36	0	\N
317930	1874	12240000	19738	9880	37	0	\N
317931	1874	12242000	19738	9880	38	0	\N
317932	1874	12244000	19738	9880	39	0	\N
317933	1874	12246000	19738	9880	40	0	\N
317934	1874	12248000	19738	9880	41	0	\N
317935	1874	12250000	19738	9880	42	0	\N
317936	1874	12252000	19738	9880	43	0	\N
317937	1874	12254000	19738	9880	44	0	\N
317938	1874	12256000	19738	9880	45	0	\N
317939	1874	12259000	19738	9880	46	0	\N
317940	1874	12262000	19738	9880	47	0	\N
317941	1874	12265000	19738	9880	48	0	\N
317942	1874	12268000	19738	9880	50	0	\N
317943	1874	12271000	19738	9880	51	0	\N
317944	1874	12274000	19738	9880	52	0	\N
317945	1874	12277000	19738	9880	53	0	\N
317946	1874	12280000	19738	9880	54	0	\N
317947	1874	12283000	19738	9880	55	0	\N
317948	1874	12286000	19738	9880	56	0	\N
317949	1874	12289000	19738	9880	57	0	\N
317950	1874	12292000	19738	9880	58	0	\N
317951	1874	12295000	19738	9880	59	0	\N
317952	1874	12298000	19738	9880	60	0	\N
317953	1874	12301000	19738	9880	61	0	\N
317954	1874	12304000	19738	9880	62	0	\N
317955	1874	12307000	19738	9880	63	0	\N
317956	1874	12310000	19738	9880	64	0	\N
317957	1874	12313000	19738	9880	65	0	\N
317958	1874	12316000	19738	9880	66	0	\N
317959	1874	12319000	19738	9880	67	0	\N
317960	1874	12322000	19738	9880	68	0	\N
317961	1874	12325000	19738	9880	69	0	\N
317962	1874	12328000	19738	9880	70	0	\N
317963	1874	12331000	19738	9880	71	0	\N
317964	1874	12334000	19738	9880	72	0	\N
317965	1874	12337000	19738	9880	73	0	\N
317966	1874	12340000	19738	9880	74	0	\N
317967	1874	12343000	19738	9880	75	0	\N
317968	1874	12346000	19738	9880	76	0	\N
317856	1874	12391000	19727	9931	2	0	2
317857	1874	12394000	19727	9931	3	0	2
317866	1678	21600733646000	19730	9932	0	0	0
317867	1874	12396000	19730	9932	1	0	2
317868	1874	12398000	19730	9932	2	0	2
317870	1874	12403000	19730	9932	4	0	2
317871	1678	21600733647000	19731	9933	0	0	0
317872	1874	12406000	19731	9933	1	0	2
317873	1874	12408000	19731	9933	2	0	2
317877	1678	21600733648000	19733	9934	0	0	0
317879	1874	12410000	19733	9934	2	0	2
317880	1874	12412000	19733	9934	3	0	2
317881	1874	12415000	19733	9934	4	0	2
317882	1874	12418000	19733	9934	5	0	2
317884	1874	12420000	19734	9935	1	0	2
317885	1874	12423000	19734	9935	2	0	2
317969	1874	12349000	19738	9880	77	0	\N
317970	1874	12352000	19738	9880	78	0	\N
317971	1874	12355000	19738	9880	79	0	\N
317972	1874	12358000	19738	9880	80	0	\N
317973	1874	12361000	19738	9880	81	0	\N
317974	1874	12364000	19738	9880	82	0	\N
317975	1874	12367000	19738	9880	83	0	\N
317976	1874	12369000	19738	9880	84	0	\N
317977	1874	12371000	19738	9880	85	0	\N
317978	1874	12373000	19738	9880	86	0	\N
317979	1874	12375000	19738	9880	87	0	\N
317980	1874	12377000	19738	9880	88	0	\N
317981	1874	12379000	19738	9880	89	0	\N
317982	1874	12381000	19738	9880	90	0	\N
317983	1874	12383000	19738	9880	91	0	\N
317984	1874	12385000	19738	9880	92	0	\N
317985	1874	12387000	19738	9880	93	0	\N
317986	1874	12389000	19738	9880	94	0	\N
317987	1678	21600733651000	19739	9936	0	0	\N
317988	1874	12425000	19739	9936	1	0	\N
317989	1874	12428000	19739	9936	2	0	\N
317993	1678	21600733652000	19741	9937	0	0	\N
317994	1874	12430000	19741	9937	1	0	\N
317995	1874	12433000	19741	9937	2	0	\N
318026	1678	21600733661000	19748	9942	0	0	\N
318027	1874	12475000	19748	9942	1	0	\N
318028	1874	12478000	19748	9942	2	0	\N
318029	1678	21600733635000	19749	9925	0	0	\N
318030	1678	21600733636000	19749	9925	1	0	\N
318031	1678	21600733637000	19749	9925	2	0	\N
318032	1678	21600733638000	19749	9925	3	0	\N
318033	1678	21600733639000	19749	9925	4	0	\N
318034	1778	5450090000000	19749	9925	5	0	\N
318035	1678	21600733640000	19749	9925	6	0	\N
318036	1678	21600733641000	19749	9925	7	0	\N
318037	1678	21600733642000	19749	9925	8	0	\N
318038	1678	21600733643000	19749	9925	9	0	\N
318039	1678	21600733644000	19749	9925	10	0	\N
318040	1678	21600733645000	19749	9925	11	0	\N
318041	1678	21600733646000	19749	9925	12	0	\N
318042	1678	21600733647000	19749	9925	13	0	\N
318043	1678	21600733648000	19749	9925	14	0	\N
318044	1678	21600733649000	19749	9925	15	0	\N
318045	1678	21600733650000	19749	9925	16	0	\N
318046	1678	21600733651000	19749	9925	17	0	\N
318047	1678	21600733652000	19749	9925	18	0	\N
318048	1678	21600733653000	19749	9925	19	0	\N
318049	1678	21600733654000	19749	9925	20	0	\N
318050	1678	21600733655000	19749	9925	21	0	\N
318051	1678	21600733656000	19749	9925	22	0	\N
318052	1678	21600733657000	19749	9925	23	0	\N
318053	1678	21600733658000	19749	9925	24	0	\N
318054	1678	21600733659000	19749	9925	25	0	\N
318055	1678	21600733660000	19749	9925	26	0	\N
318056	1678	21600733661000	19749	9925	27	0	\N
318057	1678	21600733662000	19749	9925	28	0	\N
318058	1874	12349000	19749	9925	29	0	\N
318059	1874	12352000	19749	9925	30	0	\N
318060	1874	12355000	19749	9925	31	0	\N
318061	1874	12358000	19749	9925	32	0	\N
318062	1874	12361000	19749	9925	33	0	\N
318063	1874	12364000	19749	9925	34	0	\N
318064	1874	12367000	19749	9925	35	0	\N
318065	1874	12369000	19749	9925	36	0	\N
318066	1874	12371000	19749	9925	37	0	\N
318067	1874	12373000	19749	9925	38	0	\N
318068	1874	12375000	19749	9925	39	0	\N
318069	1874	12377000	19749	9925	40	0	\N
318070	1874	12379000	19749	9925	41	0	\N
318071	1874	12381000	19749	9925	42	0	\N
318072	1874	12383000	19749	9925	43	0	\N
318073	1874	12385000	19749	9925	44	0	\N
318074	1874	12387000	19749	9925	45	0	\N
318075	1874	12389000	19749	9925	46	0	\N
318076	1874	12391000	19749	9925	47	0	\N
318077	1874	12393000	19749	9925	48	0	\N
318078	1874	12395000	19749	9925	49	0	\N
318079	1874	12397000	19749	9925	50	0	\N
318080	1874	12399000	19749	9925	51	0	\N
318081	1874	12401000	19749	9925	52	0	\N
318082	1874	12403000	19749	9925	53	0	\N
318083	1874	12405000	19749	9925	54	0	\N
318084	1874	12407000	19749	9925	55	0	\N
318085	1874	12409000	19749	9925	56	0	\N
318086	1874	12411000	19749	9925	57	0	\N
318087	1874	12413000	19749	9925	58	0	\N
318088	1874	12415000	19749	9925	59	0	\N
318089	1874	12417000	19749	9925	60	0	\N
318090	1874	12419000	19749	9925	61	0	\N
318091	1874	12421000	19749	9925	62	0	\N
318092	1874	12423000	19749	9925	63	0	\N
318093	1874	12426000	19749	9925	64	0	\N
318094	1874	12429000	19749	9925	65	0	\N
318095	1874	12432000	19749	9925	66	0	\N
318096	1874	12435000	19749	9925	67	0	\N
318097	1874	12438000	19749	9925	68	0	\N
318098	1874	12441000	19749	9925	69	0	\N
318099	1874	12444000	19749	9925	70	0	\N
318100	1874	12447000	19749	9925	71	0	\N
318101	1874	12450000	19749	9925	72	0	\N
318102	1874	12453000	19749	9925	73	0	\N
318103	1874	12456000	19749	9925	74	0	\N
318104	1874	12459000	19749	9925	75	0	\N
317992	1874	12428000	19740	9936	2	0	2
317996	1678	21600733652000	19742	9937	0	0	0
317997	1874	12430000	19742	9937	1	0	2
317998	1874	12433000	19742	9937	2	0	2
317999	1678	21600733653000	19743	9938	0	0	0
318001	1678	21600733654000	19744	9939	0	0	0
318002	1678	21600733655000	19744	9939	1	0	0
318003	1874	12438000	19744	9939	2	0	2
318004	1874	12441000	19744	9939	3	0	2
318005	1874	12444000	19744	9939	4	0	2
318007	1874	12448000	19744	9939	6	0	2
318008	1678	21600733656000	19745	9940	0	0	0
318009	1678	21600733657000	19745	9940	1	0	0
318010	1678	21600733658000	19745	9940	2	0	0
318012	1874	12450000	19745	9940	4	0	2
318013	1874	12453000	19745	9940	5	0	2
318014	1874	12456000	19745	9940	6	0	2
318015	1874	12459000	19745	9940	7	0	2
318016	1874	12462000	19745	9940	8	0	2
318018	1874	12466000	19745	9940	10	0	2
318019	1874	12468000	19745	9940	11	0	2
318020	1678	21600733660000	19746	9941	0	0	0
318021	1874	12470000	19746	9941	1	0	2
318022	1874	12473000	19746	9941	2	0	2
318024	1874	12475000	19747	9942	1	0	2
318025	1874	12478000	19747	9942	2	0	2
318105	1874	12462000	19749	9925	76	0	\N
318106	1874	12465000	19749	9925	77	0	\N
318107	1874	12468000	19749	9925	78	0	\N
318108	1874	12471000	19749	9925	79	0	\N
318109	1874	12474000	19749	9925	80	0	\N
318110	1874	12477000	19749	9925	81	0	\N
318111	1874	12480000	19749	9925	82	0	\N
318112	1874	12483000	19749	9925	83	0	\N
318119	1678	21600733663000	19753	9944	0	0	\N
318120	1874	12486000	19753	9944	1	0	\N
318121	1874	12488000	19753	9944	2	0	\N
318125	1874	12491000	19755	9945	0	0	\N
318126	1874	12493000	19755	9945	1	0	\N
318133	1678	21600733666000	19759	9947	0	0	\N
318134	1874	12500000	19759	9947	1	0	\N
318135	1874	12503000	19759	9947	2	0	\N
318150	1678	21600733672000	19765	9952	0	0	\N
318151	1874	12527000	19765	9952	1	0	\N
318152	2231	200000000	19765	9952	2	0	\N
318153	1874	12530000	19765	9952	3	0	\N
318154	1874	12531000	19765	9952	4	0	\N
318155	2232	200000000	19765	9952	5	0	\N
318156	2184	2599000000	19765	9952	6	0	\N
318157	2206	2599000000	19765	9952	7	0	\N
318158	2205	2599000000	19765	9952	8	0	\N
318159	2185	1399000000	19765	9952	9	0	\N
318160	2231	200000000	19766	9847	0	0	\N
318161	2232	200000000	19766	9847	1	0	\N
318162	2184	2599000000	19766	9847	2	0	\N
318163	2206	2599000000	19766	9847	3	0	\N
318164	2205	2599000000	19766	9847	4	0	\N
318165	2185	1399000000	19766	9847	5	0	\N
318176	1678	21600733644000	19768	9929	0	0	\N
318177	1678	21600733645000	19768	9929	1	0	\N
318178	1678	21600733646000	19768	9929	2	0	\N
318179	1678	21600733647000	19768	9929	3	0	\N
318180	1678	21600733648000	19768	9929	4	0	\N
318181	1678	21600733649000	19768	9929	5	0	\N
318182	1678	21600733650000	19768	9929	6	0	\N
318183	1678	21600733651000	19768	9929	7	0	\N
318184	1678	21600733652000	19768	9929	8	0	\N
318185	1678	21600733653000	19768	9929	9	0	\N
318186	1678	21600733654000	19768	9929	10	0	\N
318187	1678	21600733655000	19768	9929	11	0	\N
318188	1678	21600733656000	19768	9929	12	0	\N
318189	1678	21600733657000	19768	9929	13	0	\N
318190	1678	21600733658000	19768	9929	14	0	\N
318191	1678	21600733659000	19768	9929	15	0	\N
318192	1678	21600733660000	19768	9929	16	0	\N
318193	1678	21600733661000	19768	9929	17	0	\N
318194	1678	21600733662000	19768	9929	18	0	\N
318195	1678	21600733663000	19768	9929	19	0	\N
318196	1678	21600733664000	19768	9929	20	0	\N
318197	1678	21600733665000	19768	9929	21	0	\N
318198	1678	21600733666000	19768	9929	22	0	\N
318199	1678	21600733667000	19768	9929	23	0	\N
318200	1678	21600733668000	19768	9929	24	0	\N
318201	1678	21600733669000	19768	9929	25	0	\N
318202	1678	21600733670000	19768	9929	26	0	\N
318203	1678	21600733671000	19768	9929	27	0	\N
318204	1678	21600733672000	19768	9929	28	0	\N
318205	2231	200000000	19768	9929	29	0	\N
318206	1874	12391000	19768	9929	30	0	\N
318207	1874	12392000	19768	9929	31	0	\N
318208	1874	12395000	19768	9929	32	0	\N
318209	2232	200000000	19768	9929	33	0	\N
318210	2184	2599000000	19768	9929	34	0	\N
318211	2206	2599000000	19768	9929	35	0	\N
318212	2205	2599000000	19768	9929	36	0	\N
318213	1874	12397000	19768	9929	37	0	\N
318214	1874	12399000	19768	9929	38	0	\N
318215	1874	12401000	19768	9929	39	0	\N
318216	1874	12403000	19768	9929	40	0	\N
318217	1874	12405000	19768	9929	41	0	\N
318218	1874	12407000	19768	9929	42	0	\N
318219	1874	12409000	19768	9929	43	0	\N
318220	1874	12411000	19768	9929	44	0	\N
318221	1874	12413000	19768	9929	45	0	\N
318222	1874	12415000	19768	9929	46	0	\N
318223	1874	12418000	19768	9929	47	0	\N
318224	1874	12421000	19768	9929	48	0	\N
318225	1874	12424000	19768	9929	49	0	\N
318226	1874	12427000	19768	9929	50	0	\N
318227	2185	1399000000	19768	9929	51	0	\N
318228	1874	12429000	19768	9929	52	0	\N
318229	1874	12431000	19768	9929	53	0	\N
318230	1874	12433000	19768	9929	54	0	\N
318231	1874	12435000	19768	9929	55	0	\N
318232	1874	12437000	19768	9929	56	0	\N
318233	1874	12439000	19768	9929	57	0	\N
318234	1874	12441000	19768	9929	58	0	\N
318235	1874	12443000	19768	9929	59	0	\N
318236	1874	12445000	19768	9929	60	0	\N
318237	1874	12448000	19768	9929	61	0	\N
318238	1874	12450000	19768	9929	62	0	\N
318239	1874	12452000	19768	9929	63	0	\N
318240	1874	12454000	19768	9929	64	0	\N
318115	1874	12483000	19750	9943	2	0	2
318116	1678	21600733663000	19751	9944	0	0	0
318117	1874	12486000	19751	9944	1	0	2
318118	1874	12488000	19751	9944	2	0	2
318122	1678	21600733664000	19754	9945	0	0	0
318124	1874	12493000	19754	9945	2	0	2
318127	1678	21600733665000	19756	9946	0	0	0
318128	1874	12495000	19756	9946	1	0	2
318129	1874	12498000	19756	9946	2	0	2
318130	1678	21600733666000	19758	9947	0	0	0
318132	1874	12503000	19758	9947	2	0	2
318136	1678	21600733667000	19760	9948	0	0	0
318137	1874	12505000	19760	9948	1	0	2
318138	1678	21600733668000	19761	9949	0	0	0
318140	1874	12507000	19761	9949	2	0	2
318141	1874	12509000	19761	9949	3	0	2
318142	1874	12512000	19761	9949	4	0	2
318143	1874	12515000	19761	9949	5	0	2
318144	1678	21600733670000	19762	9950	0	0	0
318146	1874	12520000	19762	9950	2	0	2
318147	1678	21600733671000	19764	9951	0	0	0
318148	1874	12523000	19764	9951	1	0	2
318149	1874	12525000	19764	9951	2	0	2
318166	1678	21600733672000	19767	9952	0	0	0
318168	2231	200000000	19767	9952	2	0	0
318169	1874	12530000	19767	9952	3	0	2
318170	1874	12531000	19767	9952	4	0	2
318171	2232	200000000	19767	9952	5	0	0
318173	2206	2599000000	19767	9952	7	0	1
318174	2205	2599000000	19767	9952	8	0	1
318175	2185	1399000000	19767	9952	9	0	1
318241	1874	12456000	19768	9929	65	0	\N
318242	1874	12458000	19768	9929	66	0	\N
318243	1874	12460000	19768	9929	67	0	\N
318244	1874	12462000	19768	9929	68	0	\N
318245	1874	12464000	19768	9929	69	0	\N
318246	1874	12466000	19768	9929	70	0	\N
318247	1874	12468000	19768	9929	71	0	\N
318248	1874	12471000	19768	9929	72	0	\N
318249	1874	12474000	19768	9929	73	0	\N
318250	1874	12477000	19768	9929	74	0	\N
318251	1874	12480000	19768	9929	75	0	\N
318252	1874	12483000	19768	9929	76	0	\N
318253	1874	12486000	19768	9929	77	0	\N
318254	1874	12489000	19768	9929	78	0	\N
318255	1874	12492000	19768	9929	79	0	\N
318256	1874	12495000	19768	9929	80	0	\N
318257	1874	12498000	19768	9929	81	0	\N
318258	1874	12501000	19768	9929	82	0	\N
318259	1874	12504000	19768	9929	83	0	\N
318260	1874	12507000	19768	9929	84	0	\N
318261	1874	12510000	19768	9929	85	0	\N
318262	1874	12513000	19768	9929	87	0	\N
318263	1874	12516000	19768	9929	88	0	\N
318264	1874	12519000	19768	9929	89	0	\N
318265	1874	12522000	19768	9929	90	0	\N
318266	1874	12525000	19768	9929	91	0	\N
318267	1874	12528000	19768	9929	92	0	\N
318268	1874	12531000	19768	9929	93	0	\N
318269	1678	21600733673000	19769	9953	0	0	\N
318270	1874	12534000	19769	9953	1	0	\N
318271	1874	12536000	19769	9953	2	0	\N
318297	1678	21600733679000	19776	9958	0	0	\N
318298	1874	12571000	19776	9958	1	0	\N
318299	1874	12573000	19776	9958	2	0	\N
318303	1678	21600733681000	19778	9960	0	0	\N
318304	1678	21600733682000	19778	9960	1	0	\N
318305	1874	12579000	19778	9960	2	0	\N
318306	1874	12582000	19778	9960	3	0	\N
318307	1874	12585000	19778	9960	4	0	\N
318308	1874	12587000	19778	9960	5	0	\N
318309	1874	12589000	19778	9960	6	0	\N
318310	1678	21600733681000	19779	9960	0	0	\N
318311	1678	21600733682000	19779	9960	1	0	\N
318312	1874	12579000	19779	9960	2	0	\N
318313	1874	12582000	19779	9960	3	0	\N
318314	1874	12585000	19779	9960	4	0	\N
318315	1874	12587000	19779	9960	5	0	\N
318316	1874	12589000	19779	9960	6	0	\N
318333	1678	21600733686000	19783	9962	0	0	\N
318334	1874	12604000	19783	9962	1	0	\N
318335	1874	12607000	19783	9962	2	0	\N
318353	1678	21600733689000	19787	9964	0	0	\N
318354	1678	21600733690000	19787	9964	1	0	\N
318355	1874	12621000	19787	9964	2	0	\N
318356	2233	200000000	19787	9964	3	0	\N
318357	1874	12624000	19787	9964	4	0	\N
318358	1874	12626000	19787	9964	5	0	\N
318359	1874	12628000	19787	9964	6	0	\N
318367	1678	21600733693000	19790	9967	0	0	\N
318368	1874	12642000	19790	9967	1	0	\N
318369	1874	12644000	19790	9967	2	0	\N
318274	1874	12536000	19770	9953	2	0	2
318275	1678	21600733674000	19771	9954	0	0	0
318276	1874	12539000	19771	9954	1	0	2
318277	1874	12541000	19771	9954	2	0	2
318278	1678	21600733675000	19772	9955	0	0	0
318280	1874	12546000	19772	9955	2	0	2
318281	1874	12549000	19772	9955	3	0	2
318282	1874	12551000	19772	9955	4	0	2
318283	1874	12552000	19772	9955	5	0	2
318284	1678	21600733676000	19773	9956	0	0	0
318286	1874	12553000	19773	9956	2	0	2
318287	1874	12556000	19773	9956	3	0	2
318288	1874	12559000	19773	9956	4	0	2
318289	1874	12561000	19773	9956	5	0	2
318291	1678	21600733678000	19774	9957	0	0	0
318292	1874	12566000	19774	9957	1	0	2
318293	1874	12568000	19774	9957	2	0	2
318294	1678	21600733679000	19775	9958	0	0	0
318295	1874	12571000	19775	9958	1	0	2
318300	1678	21600733680000	19777	9959	0	0	0
318301	1874	12576000	19777	9959	1	0	2
318302	1874	12578000	19777	9959	2	0	2
318317	1678	21600733681000	19780	9960	0	0	0
318318	1678	21600733682000	19780	9960	1	0	0
318320	1874	12582000	19780	9960	3	0	2
318321	1874	12585000	19780	9960	4	0	2
318322	1874	12587000	19780	9960	5	0	2
318323	1874	12589000	19780	9960	6	0	2
318325	1678	21600733684000	19781	9961	1	0	0
318326	1678	21600733685000	19781	9961	2	0	0
318327	1874	12591000	19781	9961	3	0	2
318328	1874	12593000	19781	9961	4	0	2
318329	1874	12595000	19781	9961	5	0	2
318331	1874	12601000	19781	9961	7	0	2
318332	1874	12602000	19781	9961	8	0	2
318336	1678	21600733686000	19784	9962	0	0	0
318337	1874	12604000	19784	9962	1	0	2
318338	1874	12607000	19784	9962	2	0	2
318340	1678	21600733688000	19785	9963	1	0	0
318341	1874	12608000	19785	9963	2	0	2
318342	1874	12610000	19785	9963	3	0	2
318343	1874	12612000	19785	9963	4	0	2
318345	1874	12618000	19785	9963	7	0	2
318346	1678	21600733689000	19786	9964	0	0	0
318347	1678	21600733690000	19786	9964	1	0	0
318348	1874	12621000	19786	9964	2	0	2
318349	2233	200000000	19786	9964	3	0	0
318351	1874	12626000	19786	9964	5	0	2
318352	1874	12628000	19786	9964	6	0	2
318360	1678	21600733691000	19788	9965	0	0	0
318361	1874	12629000	19788	9965	1	0	2
318362	1874	12631000	19788	9965	2	0	2
318364	1678	21600733692000	19789	9966	0	0	0
318365	1874	12636000	19789	9966	1	0	2
318366	1874	12639000	19789	9966	2	0	2
318370	1678	21600733693000	19791	9967	0	0	0
318372	1874	12644000	19791	9967	2	0	2
318373	1678	21600733694000	19792	9968	0	0	0
318374	1874	12647000	19792	9968	1	0	2
318375	1874	12649000	19792	9968	2	0	2
318376	1874	12650000	19792	9968	3	0	2
318377	1678	21600733695000	19793	9969	0	0	\N
318378	1874	12652000	19793	9969	1	0	\N
318379	1678	21600733695000	19794	9969	0	0	\N
318380	1874	12652000	19794	9969	1	0	\N
318381	1874	12655000	19794	9969	2	0	\N
318382	1678	21600733695000	19795	9969	0	0	\N
318383	1874	12652000	19795	9969	1	0	\N
318384	1874	12655000	19795	9969	2	0	\N
318391	1330	1706840637751650	19798	9971	0	0	\N
318392	1204	612520750000000	19798	9971	1	0	\N
318393	1084	907813465000000	19798	9971	2	0	\N
318394	964	506595775000000	19798	9971	3	0	\N
318395	1678	21600733697000	19798	9971	4	0	\N
318396	1874	12663000	19798	9971	5	0	\N
318397	1874	12664000	19798	9971	6	0	\N
318398	1874	12666000	19798	9971	7	0	\N
318399	1330	1706840637751650	19799	9971	0	0	\N
318400	1204	612520750000000	19799	9971	1	0	\N
318401	1084	907813465000000	19799	9971	2	0	\N
318402	964	506595775000000	19799	9971	3	0	\N
318403	1678	21600733697000	19799	9971	4	0	\N
318404	1874	12663000	19799	9971	5	0	\N
318405	1874	12664000	19799	9971	6	0	\N
318406	1874	12666000	19799	9971	7	0	\N
318415	1330	1706840637751650	19801	9971	0	0	\N
318416	1204	612520750000000	19801	9971	1	0	\N
318417	1084	907813465000000	19801	9971	2	0	\N
318418	964	506595775000000	19801	9971	3	0	\N
318419	1678	21600733697000	19801	9971	4	0	\N
318420	1874	12663000	19801	9971	5	0	\N
318421	1874	12664000	19801	9971	6	0	\N
318422	1874	12666000	19801	9971	7	0	\N
318437	1678	21600733700000	19804	9973	0	0	\N
318438	1678	21600733701000	19804	9973	1	0	\N
318439	1678	21600733702000	19804	9973	2	0	\N
318440	1678	21600733703000	19804	9973	3	0	\N
318441	1931	5034486000000	19804	9973	4	0	\N
318442	1874	12673000	19804	9973	5	0	\N
318443	1874	12676000	19804	9973	6	0	\N
318444	1874	12679000	19804	9973	7	0	\N
318445	1874	12682000	19804	9973	8	0	\N
318446	1874	12685000	19804	9973	9	0	\N
318454	1678	21600733707000	19807	9976	0	0	\N
318455	1874	12696000	19807	9976	1	0	\N
318456	1874	12699000	19807	9976	2	0	\N
318460	1678	21600733707000	19809	9976	0	0	\N
318461	1874	12696000	19809	9976	1	0	\N
318462	1874	12699000	19809	9976	2	0	\N
318463	1678	21600733707000	19810	9976	0	0	\N
318464	1874	12696000	19810	9976	1	0	\N
318465	1874	12699000	19810	9976	2	0	\N
318469	1678	21600733710000	19813	9979	0	0	\N
318470	1874	12705000	19813	9979	1	0	\N
318485	1678	21600733716000	19817	9982	0	0	\N
318486	1874	12725000	19817	9982	1	0	\N
318497	1330	1706840637751650	19821	9955	0	0	\N
318498	1204	612520750000000	19821	9955	1	0	\N
318499	1084	907813465000000	19821	9955	2	0	\N
318500	964	506595775000000	19821	9955	3	0	\N
318501	2233	200000000	19821	9955	4	0	\N
318387	1874	12655000	19796	9969	2	0	2
318388	1678	21600733696000	19797	9970	0	0	0
318389	1874	12657000	19797	9970	1	0	2
318390	1874	12660000	19797	9970	2	0	2
318407	1330	1706840637751650	19800	9971	0	0	0
318409	1084	907813465000000	19800	9971	2	0	0
318410	964	506595775000000	19800	9971	3	0	0
318411	1678	21600733697000	19800	9971	4	0	0
318412	1874	12663000	19800	9971	5	0	2
318413	1874	12664000	19800	9971	6	0	2
318423	1678	21600733698000	19802	9972	0	0	0
318424	1678	21600733699000	19802	9972	1	0	0
318425	1874	12669000	19802	9972	2	0	2
318426	1874	12672000	19802	9972	3	0	2
318428	1678	21600733701000	19803	9973	1	0	0
318429	1678	21600733702000	19803	9973	2	0	0
318430	1678	21600733703000	19803	9973	3	0	0
318431	1931	5034486000000	19803	9973	4	0	1
318432	1874	12673000	19803	9973	5	0	2
318434	1874	12679000	19803	9973	7	0	2
318435	1874	12682000	19803	9973	8	0	2
318436	1874	12685000	19803	9973	9	0	2
318447	1678	21600733704000	19805	9974	0	0	0
318448	1874	12686000	19805	9974	1	0	2
318450	1678	21600733705000	19806	9975	0	0	0
318451	1678	21600733706000	19806	9975	1	0	0
318452	1874	12692000	19806	9975	2	0	2
318453	1874	12695000	19806	9975	3	0	2
318458	1874	12696000	19808	9976	1	0	2
318459	1874	12699000	19808	9976	2	0	2
318466	1678	21600733708000	19811	9977	0	0	0
318467	1678	21600733709000	19812	9978	0	0	0
318468	1874	12702000	19812	9978	1	0	2
318472	1874	12705000	19814	9979	1	0	2
318473	1678	21600733711000	19815	9980	0	0	0
318474	1678	21600733712000	19815	9980	1	0	0
318475	1678	21600733713000	19815	9980	2	0	0
318476	1874	12708000	19815	9980	3	0	2
318478	1874	12712000	19815	9980	5	0	2
318479	1874	12715000	19815	9980	6	0	2
318480	1678	21600733714000	19816	9981	0	0	0
318481	1678	21600733715000	19816	9981	1	0	0
318483	1874	12719000	19816	9981	3	0	2
318484	1874	12722000	19816	9981	4	0	2
318487	1678	21600733716000	19818	9982	0	0	0
318488	1874	12725000	19818	9982	1	0	2
318489	2203	120000000	19819	9983	0	0	8
318491	1874	12728000	19819	9983	2	0	2
318492	1874	12729000	19819	9983	3	0	2
318493	1678	21600733718000	19820	9984	3	0	0
318494	1678	21600733719000	19820	9984	4	0	0
318495	1874	12732000	19820	9984	5	0	2
318502	1678	21600733720000	19822	9985	0	0	0
318503	1874	12738000	19822	9985	1	0	2
318504	1678	21600733721000	19823	9986	0	0	0
318505	2203	120000001	19823	9986	1	0	8
318507	1874	12741000	19823	9986	3	0	2
318508	1874	12744000	19823	9986	4	0	2
318509	1678	21600733722000	19824	9987	0	0	0
318510	1874	12747000	19824	9987	1	0	2
318511	1874	12749000	19824	9987	2	0	2
318514	1678	21600733723000	19826	9988	0	0	\N
318515	1874	12751000	19826	9988	1	0	\N
318516	1874	12753000	19827	9989	0	0	\N
318517	1874	12754000	19827	9989	1	0	\N
318518	1874	12757000	19827	9989	2	0	\N
318522	1874	12753000	19829	9989	0	0	\N
318523	1874	12754000	19829	9989	1	0	\N
318524	1874	12757000	19829	9989	2	0	\N
318525	1874	12753000	19830	9989	0	0	\N
318526	1874	12754000	19830	9989	1	0	\N
318527	1874	12757000	19830	9989	2	0	\N
318528	1874	12753000	19831	9989	0	0	\N
318529	1874	12754000	19831	9989	1	0	\N
318530	1874	12757000	19831	9989	2	0	\N
318534	1678	22320744725000	19833	9991	0	0	\N
318535	1874	12764000	19833	9991	1	0	\N
318536	1874	12767000	19833	9991	2	0	\N
318550	1678	22320744728000	19838	9994	0	0	\N
318551	1874	12781000	19838	9994	1	0	\N
318552	1874	12783000	19838	9994	2	0	\N
318556	1678	22320744730000	19840	9996	0	0	\N
318557	1874	12789000	19840	9996	1	0	\N
318558	1874	12791000	19840	9996	2	0	\N
318559	1874	12794000	19840	9996	3	0	\N
318567	1678	22320744731000	19843	9997	0	0	\N
318568	1874	12796000	19843	9997	1	0	\N
318569	1874	12799000	19843	9997	2	0	\N
318570	1678	22320744731000	19844	9997	0	0	\N
318571	1874	12796000	19844	9997	1	0	\N
318572	1874	12799000	19844	9997	2	0	\N
318573	1678	22320744731000	19845	9997	0	0	\N
318574	1874	12796000	19845	9997	1	0	\N
318575	1874	12799000	19845	9997	2	0	\N
318583	1330	1706840637751650	19847	9838	0	0	\N
318584	1204	612520750000000	19847	9838	1	0	\N
318585	1084	907813465000000	19847	9838	2	0	\N
318586	964	506595775000000	19847	9838	3	0	\N
318587	399	66651272116779	19847	9838	4	0	\N
318588	499	66651272116779	19847	9838	5	0	\N
318589	1772	4656971682095	19847	9838	6	0	\N
318590	54	66651272116779	19847	9838	7	0	\N
318591	710	5049338796669	19847	9838	8	0	\N
318592	1811	1778097057551	19847	9838	9	0	\N
318593	217	66651272116779	19847	9838	10	0	\N
318594	103	66651272116779	19847	9838	11	0	\N
318595	35	19389460979377	19847	9838	12	0	\N
318596	49	66651272116779	19847	9838	13	0	\N
318597	251	66651272116779	19847	9838	14	0	\N
318598	893	309850571298133	19847	9838	15	0	\N
318599	320	66370072116779	19847	9838	16	0	\N
318600	1030	909863680121925	19847	9838	17	0	\N
318601	663	66651272116779	19847	9838	18	0	\N
318602	390	66651272116779	19847	9838	19	0	\N
318603	108	66651272116779	19847	9838	20	0	\N
318604	894	309850571298133	19847	9838	21	0	\N
318605	569	66651272116779	19847	9838	22	0	\N
318606	99	66651272116779	19847	9838	23	0	\N
318607	570	66651272116779	19847	9838	24	0	\N
318617	1678	22320744735000	19850	10000	0	0	\N
318618	1874	12815000	19850	10000	1	0	\N
318619	1874	12818000	19850	10000	2	0	\N
318620	2235	200000000	19850	10000	3	0	\N
318621	922	506425108194437	19850	10000	4	0	\N
318622	1874	12820000	19850	10000	5	0	\N
318623	1678	22320744736000	19851	10001	0	0	\N
318624	1594	17185313000000	19851	10001	1	0	\N
318625	1042	907509454834100	19851	10001	2	0	\N
318626	1874	12821000	19851	10001	3	0	\N
318627	1874	12823000	19851	10001	4	0	\N
318628	1678	22320744736000	19852	10001	0	0	\N
318629	1594	17185313000000	19852	10001	1	0	\N
318630	1874	12823000	19852	10001	2	0	\N
318631	1042	907509454834100	19852	10001	3	0	\N
318632	1874	12824000	19852	10001	4	0	\N
318633	1874	12826000	19852	10001	5	0	\N
318640	1678	22320744736000	19854	10001	0	0	\N
318641	1594	17185313000000	19854	10001	1	0	\N
318642	1874	12823000	19854	10001	2	0	\N
318643	1042	907509454834100	19854	10001	3	0	\N
318644	1874	12824000	19854	10001	4	0	\N
318645	1874	12826000	19854	10001	5	0	\N
318520	1874	12754000	19828	9989	1	0	2
318521	1874	12757000	19828	9989	2	0	2
318531	1678	22320744724000	19832	9990	0	0	0
318532	1874	12760000	19832	9990	1	0	2
318533	1874	12762000	19832	9990	2	0	2
318538	1874	12764000	19834	9991	1	0	2
318539	1874	12767000	19834	9991	2	0	2
318540	1678	22320744726000	19835	9992	0	0	0
318541	1874	12770000	19835	9992	1	0	2
318542	1874	12772000	19835	9992	2	0	2
318544	1678	22320744727000	19836	9993	0	0	0
318545	1874	12775000	19836	9993	1	0	2
318546	1874	12778000	19836	9993	2	0	2
318547	1678	22320744728000	19837	9994	0	0	0
318549	1874	12783000	19837	9994	2	0	2
318553	1678	22320744729000	19839	9995	0	0	0
318554	1874	12786000	19839	9995	1	0	2
318555	1874	12788000	19839	9995	2	0	2
318560	1678	22320744730000	19841	9996	0	0	0
318562	1874	12791000	19841	9996	2	0	2
318563	1874	12794000	19841	9996	3	0	2
318564	1678	22320744731000	19842	9997	0	0	0
318565	1874	12796000	19842	9997	1	0	2
318566	1874	12799000	19842	9997	2	0	2
318577	1678	22320744733000	19846	9998	1	0	0
318578	1874	12802000	19846	9998	2	0	2
318579	1874	12805000	19846	9998	3	0	2
318580	1874	12807000	19846	9998	4	0	2
318582	1874	12810000	19846	9998	6	0	2
318608	1678	22320744734000	19848	9999	0	0	0
318609	1874	12812000	19848	9999	1	0	2
318610	267	66478788050691	19848	9999	2	0	0
318611	1678	22320744735000	19849	10000	0	0	0
318613	1874	12818000	19849	10000	2	0	2
318614	2235	200000000	19849	10000	3	0	0
318615	922	506425108194437	19849	10000	4	0	0
318616	1874	12820000	19849	10000	5	0	2
318634	1678	22320744736000	19853	10001	0	0	0
318636	1874	12823000	19853	10001	2	0	2
318637	1042	907509454834100	19853	10001	3	0	0
318638	1874	12824000	19853	10001	4	0	2
318639	1874	12826000	19853	10001	5	0	2
318647	1874	12828000	19856	10002	1	0	2
318648	1874	12831000	19856	10002	2	0	2
318652	1678	22320744737000	19857	10002	0	0	\N
318653	1874	12828000	19857	10002	1	0	\N
318654	1874	12831000	19857	10002	2	0	\N
318655	2236	200000000	19857	10002	3	0	\N
318656	1162	612314712579855	19857	10002	4	0	\N
318657	1288	1706269390592464	19857	10002	5	0	\N
318667	1678	22320744740000	19860	10005	0	0	\N
318668	1148	612672289000000	19860	10005	1	0	\N
318669	1874	12843000	19860	10005	2	0	\N
318670	1874	12846000	19860	10005	4	0	\N
318671	1874	12847000	19860	10005	5	0	\N
318672	1678	22320744740000	19861	10005	0	0	\N
318673	1148	612672289000000	19861	10005	1	0	\N
318674	1874	12843000	19861	10005	2	0	\N
318675	1874	12846000	19861	10005	4	0	\N
318676	1874	12847000	19861	10005	5	0	\N
318677	1678	22320744740000	19862	10005	0	0	\N
318678	1148	612672289000000	19862	10005	1	0	\N
318679	1874	12843000	19862	10005	2	0	\N
318680	1874	12846000	19862	10005	4	0	\N
318681	1874	12847000	19862	10005	5	0	\N
318714	1274	1707265437751650	19867	10008	0	0	\N
318715	1986	516610000000	19867	10008	1	0	\N
318716	2203	160000001	19867	10008	2	0	\N
318717	1678	22320744743000	19867	10008	3	0	\N
318718	1678	22320744744000	19867	10008	4	0	\N
318719	1678	22320744745000	19867	10008	5	0	\N
318720	1678	22320744746000	19867	10008	6	0	\N
318721	1678	22320744747000	19867	10008	7	0	\N
318722	1874	12858000	19867	10008	8	0	\N
318723	1874	12861000	19867	10008	9	0	\N
318724	1874	12862000	19867	10008	10	0	\N
318725	1874	12864000	19867	10008	11	0	\N
318726	1874	12866000	19867	10008	12	0	\N
318727	1874	12868000	19867	10008	13	0	\N
318728	1874	12870000	19867	10008	14	0	\N
318729	1874	12872000	19867	10008	15	0	\N
318730	1874	12875000	19867	10008	16	0	\N
318731	1874	12878000	19867	10008	17	0	\N
318732	1874	12881000	19867	10008	18	0	\N
318733	1874	12884000	19867	10008	19	0	\N
318734	1274	1707265437751650	19868	10008	0	0	\N
318735	1986	516610000000	19868	10008	1	0	\N
318736	2203	160000001	19868	10008	2	0	\N
318737	1678	22320744743000	19868	10008	3	0	\N
318738	1678	22320744744000	19868	10008	4	0	\N
318739	1678	22320744745000	19868	10008	5	0	\N
318740	1678	22320744746000	19868	10008	6	0	\N
318741	1678	22320744747000	19868	10008	7	0	\N
318742	1874	12858000	19868	10008	8	0	\N
318743	1874	12861000	19868	10008	9	0	\N
318744	1874	12862000	19868	10008	10	0	\N
318745	1874	12864000	19868	10008	11	0	\N
318746	1874	12866000	19868	10008	12	0	\N
318747	1874	12868000	19868	10008	13	0	\N
318748	1874	12870000	19868	10008	14	0	\N
318749	1874	12872000	19868	10008	15	0	\N
318750	1874	12875000	19868	10008	16	0	\N
318751	1874	12878000	19868	10008	17	0	\N
318752	1874	12881000	19868	10008	18	0	\N
318753	1874	12884000	19868	10008	19	0	\N
318754	1678	22320744748000	19869	10009	0	0	\N
318755	1874	12886000	19869	10009	1	0	\N
318756	1874	12889000	19869	10009	2	0	\N
318760	1678	22320744748000	19871	10009	0	0	\N
318761	1874	12886000	19871	10009	1	0	\N
318762	1874	12889000	19871	10009	2	0	\N
318766	1678	22320744749000	19873	10010	0	0	\N
318767	1874	12892000	19873	10010	1	0	\N
318768	1678	22320744750000	19874	10011	0	0	\N
318769	1874	12896000	19874	10011	1	0	\N
318770	1874	12897000	19874	10011	2	0	\N
318771	1874	12900000	19874	10011	3	0	\N
318772	1460	0	19875	9992	0	0	\N
318773	2203	140000001	19875	9992	1	0	\N
318774	2203	160000001	19875	9992	2	0	\N
318775	1594	17185313000000	19875	9992	3	0	\N
318776	908	506720815000000	19875	9992	4	0	\N
318777	1028	908039275000000	19875	9992	5	0	\N
318778	1148	612672289000000	19875	9992	6	0	\N
318779	1274	1707265437751650	19875	9992	7	0	\N
318780	1986	516610000000	19875	9992	8	0	\N
318781	267	66478788050691	19875	9992	9	0	\N
318782	2235	200000000	19875	9992	10	0	\N
318783	2236	200000000	19875	9992	11	0	\N
318784	922	506425108194437	19875	9992	12	0	\N
318651	1288	1706269390592464	19856	10002	5	0	0
318658	1460	0	19858	10003	0	0	0
318659	1678	22320744738000	19858	10003	1	0	0
318660	1874	12833000	19858	10003	2	0	2
318661	1874	12836000	19858	10003	3	0	2
318663	1874	12839000	19859	10004	1	0	2
318664	908	506720815000000	19859	10004	2	0	0
318665	1028	908039275000000	19859	10004	3	0	0
318666	1874	12841000	19859	10004	4	0	2
318682	1678	22320744740000	19863	10005	0	0	0
318684	1874	12843000	19863	10005	2	0	2
318685	1874	12846000	19863	10005	4	0	2
318686	1874	12847000	19863	10005	5	0	2
318687	1678	22320744741000	19864	10006	0	0	0
318689	1874	12852000	19864	10006	2	0	2
318690	1678	22320744742000	19865	10007	0	0	0
318691	2203	140000001	19865	10007	1	0	8
318692	1874	12855000	19865	10007	2	0	2
318693	1874	12857000	19865	10007	3	0	2
318695	1986	516610000000	19866	10008	1	0	0
318696	2203	160000001	19866	10008	2	0	8
318697	1678	22320744743000	19866	10008	3	0	0
318698	1678	22320744744000	19866	10008	4	0	0
318699	1678	22320744745000	19866	10008	5	0	0
318701	1678	22320744747000	19866	10008	7	0	0
318702	1874	12858000	19866	10008	8	0	2
318703	1874	12861000	19866	10008	9	0	2
318704	1874	12862000	19866	10008	10	0	2
318706	1874	12866000	19866	10008	12	0	2
318707	1874	12868000	19866	10008	13	0	2
318708	1874	12870000	19866	10008	14	0	2
318709	1874	12872000	19866	10008	15	0	2
318710	1874	12875000	19866	10008	16	0	2
318712	1874	12881000	19866	10008	18	0	2
318713	1874	12884000	19866	10008	19	0	2
318757	1678	22320744748000	19870	10009	0	0	0
318758	1874	12886000	19870	10009	1	0	2
318759	1874	12889000	19870	10009	2	0	2
318764	1874	12891000	19872	10010	1	0	2
318765	1874	12894000	19872	10010	2	0	2
318785	1042	907509454834100	19875	9992	13	0	\N
318786	1162	612314712579855	19875	9992	14	0	\N
318787	1288	1706269390592464	19875	9992	15	0	\N
318804	1460	0	19880	9935	0	0	\N
318805	1330	1706840637751650	19880	9935	1	0	\N
318806	1204	612520750000000	19880	9935	2	0	\N
318807	1084	907813465000000	19880	9935	3	0	\N
318808	964	506595775000000	19880	9935	4	0	\N
318809	1594	17185313000000	19880	9935	5	0	\N
318810	908	506720815000000	19880	9935	6	0	\N
318811	2231	200000000	19880	9935	7	0	\N
318812	1874	12409000	19880	9935	8	0	\N
318813	1028	908039275000000	19880	9935	9	0	\N
318814	1148	612672289000000	19880	9935	10	0	\N
318815	1274	1707265437751650	19880	9935	11	0	\N
318816	1986	516610000000	19880	9935	12	0	\N
318817	267	66478788050691	19880	9935	13	0	\N
318818	2232	200000000	19880	9935	14	0	\N
318819	2184	2599000000	19880	9935	15	0	\N
318820	2206	2599000000	19880	9935	16	0	\N
318821	2205	2599000000	19880	9935	17	0	\N
318822	922	506425108194437	19880	9935	18	0	\N
318823	1042	907509454834100	19880	9935	19	0	\N
318824	1874	12410000	19880	9935	20	0	\N
318825	1874	12411000	19880	9935	21	0	\N
318826	1874	12412000	19880	9935	22	0	\N
318827	1162	612314712579855	19880	9935	23	0	\N
318828	1288	1706269390592464	19880	9935	24	0	\N
318829	2185	1399000000	19880	9935	25	0	\N
318830	2233	200000000	19880	9935	26	0	\N
318831	2235	200000000	19880	9935	27	0	\N
318832	2236	200000000	19880	9935	28	0	\N
318833	1874	12413000	19880	9935	29	0	\N
318834	1874	12414000	19880	9935	30	0	\N
318835	1874	12415000	19880	9935	31	0	\N
318836	1874	12416000	19880	9935	32	0	\N
318837	1874	12417000	19880	9935	33	0	\N
318838	1874	12418000	19880	9935	34	0	\N
318839	1874	12419000	19880	9935	35	0	\N
318840	1874	12420000	19880	9935	36	0	\N
318841	1874	12421000	19880	9935	37	0	\N
318842	1874	12422000	19880	9935	38	0	\N
318843	1874	12423000	19880	9935	39	0	\N
318844	1874	12424000	19880	9935	40	0	\N
318845	1874	12425000	19880	9935	41	0	\N
318846	1874	12426000	19880	9935	42	0	\N
318847	1874	12427000	19880	9935	43	0	\N
318848	1874	12428000	19880	9935	44	0	\N
318849	1874	12429000	19880	9935	45	0	\N
318850	1874	12430000	19880	9935	46	0	\N
318851	1874	12431000	19880	9935	47	0	\N
318852	1874	12432000	19880	9935	48	0	\N
318853	1874	12433000	19880	9935	49	0	\N
318854	1874	12434000	19880	9935	50	0	\N
318858	1678	22320744755000	19882	10015	0	0	\N
318859	1874	12920000	19882	10015	1	0	\N
318860	1874	12923000	19882	10015	2	0	\N
318861	1678	22320744755000	19883	10015	0	0	\N
318862	1874	12921000	19883	10015	1	0	\N
318870	1678	22320744758000	19885	10017	0	0	\N
318871	1874	12936000	19885	10017	1	0	\N
318872	1678	22320744758000	19886	10017	0	0	\N
318873	1874	12937000	19886	10017	1	0	\N
318874	1874	12939000	19886	10017	2	0	\N
318899	1678	22320744762000	19891	10020	0	0	\N
318900	1001	507702275000000	19891	10020	1	0	\N
318901	1241	613859250000000	19891	10020	2	0	\N
318902	1121	909797965000000	19891	10020	3	0	\N
318903	1678	22320744763000	19891	10020	4	0	\N
318904	1367	1710571137751650	19891	10020	5	0	\N
318905	1874	12957000	19891	10020	6	0	\N
318906	1874	12960000	19891	10020	7	0	\N
318907	1874	12963000	19891	10020	8	0	\N
318908	1874	12965000	19891	10020	9	0	\N
318909	1874	12966000	19891	10020	10	0	\N
318914	1678	22320744764000	19893	10021	0	0	\N
318915	2203	160030001	19893	10021	1	0	\N
318916	1874	12968000	19893	10021	2	0	\N
318917	1874	12971000	19893	10021	3	0	\N
318918	1678	22320744764000	19894	10021	0	0	\N
318919	2203	160030001	19894	10021	1	0	\N
318920	1874	12968000	19894	10021	2	0	\N
318790	1874	12897000	19876	10011	2	0	2
318791	1874	12900000	19876	10011	3	0	2
318792	1678	22320744751000	19877	10012	0	0	0
318793	1874	12902000	19877	10012	1	0	2
318794	1678	22320744752000	19878	10013	0	0	0
318796	1874	12907000	19878	10013	2	0	2
318797	1678	22320744753000	19879	10014	0	0	0
318798	1678	22320744754000	19879	10014	1	0	0
318799	1874	12908000	19879	10014	2	0	2
318800	1874	12910000	19879	10014	3	0	2
318802	1874	12915000	19879	10014	5	0	2
318803	1874	12918000	19879	10014	6	0	2
318855	1678	22320744755000	19881	10015	0	0	0
318856	1874	12920000	19881	10015	1	0	2
318863	1678	22320744756000	19884	10016	0	0	0
318864	1678	22320744757000	19884	10016	1	0	0
318865	1874	12926000	19884	10016	2	0	2
318866	1874	12929000	19884	10016	3	0	2
318867	1874	12930000	19884	10016	4	0	2
318869	1874	12934000	19884	10016	6	0	2
318875	1678	22320744758000	19887	10017	0	0	0
318876	1874	12937000	19887	10017	1	0	2
318877	1874	12939000	19887	10017	2	0	2
318878	1678	22320744759000	19888	10018	0	0	0
318880	1874	12944000	19888	10018	2	0	2
318881	1678	22320744760000	19889	10019	0	0	0
318882	1678	22320744761000	19889	10019	1	0	0
318883	1874	12945000	19889	10019	2	0	2
318885	1874	12949000	19889	10019	4	0	2
318886	1874	12952000	19889	10019	5	0	2
318887	1874	12955000	19889	10019	6	0	2
318888	1678	22320744762000	19890	10020	0	0	0
318889	1001	507702275000000	19890	10020	1	0	0
318891	1121	909797965000000	19890	10020	3	0	0
318892	1678	22320744763000	19890	10020	4	0	0
318893	1367	1710571137751650	19890	10020	5	0	0
318894	1874	12957000	19890	10020	6	0	2
318895	1874	12960000	19890	10020	7	0	2
318897	1874	12965000	19890	10020	9	0	2
318898	1874	12966000	19890	10020	10	0	2
318910	1678	22320744764000	19892	10021	0	0	0
318911	2203	160030001	19892	10021	1	0	8
318913	1874	12971000	19892	10021	3	0	2
318921	1874	12971000	19894	10021	3	0	\N
318922	1678	22320744764000	19895	10021	0	0	\N
318923	2203	160030001	19895	10021	1	0	\N
318924	1874	12968000	19895	10021	2	0	\N
318925	1874	12971000	19895	10021	3	0	\N
318926	1678	22320744764000	19896	10021	0	0	\N
318927	2203	160030001	19896	10021	1	0	\N
318928	1874	12968000	19896	10021	2	0	\N
318929	1874	12971000	19896	10021	3	0	\N
318930	1678	22320744765000	19897	10022	0	0	\N
318931	1874	12973000	19897	10022	1	0	\N
318932	2237	2100058999999	19897	10022	2	0	\N
318933	1874	12976000	19897	10022	3	0	\N
318934	1678	22320744765000	19898	10022	0	0	\N
318935	1874	12973000	19898	10022	1	0	\N
318936	2237	2100058999999	19898	10022	2	0	\N
318937	1874	12976000	19898	10022	3	0	\N
318938	1678	22320744765000	19899	10022	0	0	\N
318939	1874	12973000	19899	10022	1	0	\N
318940	2237	2100058999999	19899	10022	2	0	\N
318941	1874	12976000	19899	10022	3	0	\N
318953	1678	22320744766000	19902	10023	0	0	\N
318954	1678	22320744767000	19902	10023	1	0	\N
318955	1874	12979000	19902	10023	2	0	\N
318956	1874	12982000	19902	10023	3	0	\N
318957	1874	12984000	19902	10023	4	0	\N
318958	1874	12986000	19902	10023	5	0	\N
318959	1874	12987000	19902	10023	6	0	\N
318960	1678	22320744768000	19903	10024	0	0	\N
318961	1874	12989000	19903	10024	1	0	\N
318962	1874	12992000	19903	10024	2	0	\N
318966	1678	23040756769000	19905	10025	0	0	\N
318967	1678	23040756770000	19905	10025	1	0	\N
318968	1678	23040756771000	19905	10025	2	0	\N
318969	1874	12993000	19905	10025	3	0	\N
318970	1874	12996000	19905	10025	4	0	\N
318971	1874	12999000	19905	10025	5	0	\N
318972	1874	13002000	19905	10025	6	0	\N
318973	1874	13004000	19905	10025	7	0	\N
318974	1874	13006000	19905	10025	8	0	\N
318975	1874	13008000	19905	10025	9	0	\N
318986	1678	23040756769000	19907	10025	0	0	\N
318987	1678	23040756770000	19907	10025	1	0	\N
318988	1678	23040756771000	19907	10025	2	0	\N
318989	1874	12993000	19907	10025	3	0	\N
318990	1874	12996000	19907	10025	4	0	\N
318991	1874	12999000	19907	10025	5	0	\N
318992	1874	13002000	19907	10025	6	0	\N
318993	1874	13004000	19907	10025	7	0	\N
318994	1874	13006000	19907	10025	8	0	\N
318995	1874	13008000	19907	10025	9	0	\N
318996	2011	1475000000000	19908	10026	0	0	\N
318997	1678	23040756772000	19908	10026	1	0	\N
318998	1874	13010000	19908	10026	2	0	\N
318999	1874	13013000	19908	10026	3	0	\N
319004	2011	1475000000000	19910	10026	0	0	\N
319005	1678	23040756772000	19910	10026	1	0	\N
319006	1874	13010000	19910	10026	2	0	\N
319007	1874	13013000	19910	10026	3	0	\N
319008	966	506675775000000	19911	10027	0	0	\N
319009	1086	907959465000000	19911	10027	1	0	\N
319010	1678	23040756773000	19911	10027	2	0	\N
319011	1874	13016000	19911	10027	3	0	\N
319012	1874	13017000	19911	10027	4	0	\N
319013	1874	13019000	19911	10027	5	0	\N
319024	1206	612618750000000	19914	10028	0	0	\N
319025	1678	23040756774000	19914	10028	1	0	\N
319026	1874	13021000	19914	10028	2	0	\N
319027	1874	13024000	19914	10028	3	0	\N
319048	933	506041764067500	19919	10032	0	0	\N
319049	1678	23040756778000	19919	10032	1	0	\N
319050	1678	23040756779000	19919	10032	2	0	\N
319051	1874	13043000	19919	10032	3	0	\N
319052	1874	13046000	19919	10032	4	0	\N
319053	1874	13048000	19919	10032	5	0	\N
319054	1874	13050000	19919	10032	6	0	\N
319055	1678	23040756780000	19920	10033	0	0	\N
319056	1874	13052000	19920	10033	1	0	\N
318944	2237	2100058999999	19900	10022	2	0	0
318945	1874	12976000	19900	10022	3	0	2
318946	1678	22320744766000	19901	10023	0	0	0
318947	1678	22320744767000	19901	10023	1	0	0
318948	1874	12979000	19901	10023	2	0	2
318950	1874	12984000	19901	10023	4	0	2
318951	1874	12986000	19901	10023	5	0	2
318952	1874	12987000	19901	10023	6	0	2
318963	1678	22320744768000	19904	10024	0	0	0
318964	1874	12989000	19904	10024	1	0	2
318976	1678	23040756769000	19906	10025	0	0	0
318977	1678	23040756770000	19906	10025	1	0	0
318978	1678	23040756771000	19906	10025	2	0	0
318979	1874	12993000	19906	10025	3	0	2
318981	1874	12999000	19906	10025	5	0	2
318982	1874	13002000	19906	10025	6	0	2
318983	1874	13004000	19906	10025	7	0	2
318984	1874	13006000	19906	10025	8	0	2
318985	1874	13008000	19906	10025	9	0	2
319001	1678	23040756772000	19909	10026	1	0	0
319002	1874	13010000	19909	10026	2	0	2
319003	1874	13013000	19909	10026	3	0	2
319014	966	506675775000000	19912	10027	0	0	0
319015	1086	907959465000000	19912	10027	1	0	0
319017	1874	13016000	19912	10027	3	0	2
319018	1874	13017000	19912	10027	4	0	2
319019	1874	13019000	19912	10027	5	0	2
319020	1206	612618750000000	19913	10028	0	0	0
319022	1874	13021000	19913	10028	2	0	2
319023	1874	13024000	19913	10028	3	0	2
319028	1678	23040756775000	19915	10029	0	0	0
319029	1874	13027000	19915	10029	1	0	2
319030	1874	13029000	19915	10029	2	0	2
319032	1678	23040756776000	19916	10030	1	0	0
319033	1874	13032000	19916	10030	2	0	2
319034	1874	13034000	19916	10030	3	0	2
319035	1874	13035000	19916	10030	4	0	2
319036	1678	23040756777000	19917	10031	0	0	0
319038	1173	611850449546800	19917	10031	2	0	0
319039	1874	13037000	19917	10031	3	0	2
319040	1874	13040000	19917	10031	4	0	2
319041	933	506041764067500	19918	10032	0	0	0
319043	1678	23040756779000	19918	10032	2	0	0
319044	1874	13043000	19918	10032	3	0	2
319045	1874	13046000	19918	10032	4	0	2
319046	1874	13048000	19918	10032	5	0	2
319047	1874	13050000	19918	10032	6	0	2
319057	1874	13053000	19920	10033	2	0	\N
319058	1874	13056000	19920	10033	3	0	\N
319059	2011	1475000000000	19921	9993	0	0	\N
319060	966	506675775000000	19921	9993	1	0	\N
319061	1086	907959465000000	19921	9993	2	0	\N
319062	1206	612618750000000	19921	9993	3	0	\N
319063	1332	1707114637751650	19921	9993	4	0	\N
319064	1299	1704974641817750	19921	9993	5	0	\N
319065	1001	507702275000000	19921	9993	6	0	\N
319066	1241	613859250000000	19921	9993	7	0	\N
319067	1121	909797965000000	19921	9993	8	0	\N
319068	1053	906821162404900	19921	9993	9	0	\N
319069	1173	611850449546800	19921	9993	10	0	\N
319070	933	506041764067500	19921	9993	11	0	\N
319071	1367	1710571137751650	19921	9993	12	0	\N
319072	2203	160030001	19921	9993	13	0	\N
319073	2237	2100058999999	19921	9993	14	0	\N
319079	1874	13058000	19924	10034	0	0	\N
319080	1678	23040756781000	19925	10035	0	0	\N
319081	1874	13060000	19925	10035	1	0	\N
319082	1874	13063000	19925	10035	2	0	\N
319090	1678	23040756783000	19928	10037	0	0	\N
319091	1874	13072000	19928	10037	1	0	\N
319092	1874	13074000	19928	10037	2	0	\N
319099	1678	23040756783000	19931	10038	0	0	\N
319100	1678	23040756784000	19931	10038	1	0	\N
319101	1874	13073000	19931	10038	2	0	\N
319102	1874	13076000	19931	10038	3	0	\N
319103	1874	13079000	19931	10038	4	0	\N
319104	1678	23040756783000	19932	10038	0	0	\N
319105	1678	23040756784000	19932	10038	1	0	\N
319106	1874	13073000	19932	10038	2	0	\N
319107	1874	13076000	19932	10038	3	0	\N
319108	1874	13079000	19932	10038	4	0	\N
319113	1678	23040756785000	19934	10039	0	0	\N
319114	1874	13082000	19934	10039	1	0	\N
319115	1874	13083000	19934	10039	2	0	\N
319116	1874	13085000	19934	10039	3	0	\N
319119	1678	23040756786000	19936	10040	0	0	\N
319120	1874	13088000	19936	10040	1	0	\N
319121	1678	23040756786000	19937	10040	0	0	\N
319122	1874	13088000	19937	10040	1	0	\N
319123	1678	23040756787000	19938	10041	0	0	\N
319124	1874	13090000	19938	10041	1	0	\N
319125	1874	13093000	19938	10041	2	0	\N
319126	1678	23040756787000	19939	10041	0	0	\N
319127	1874	13090000	19939	10041	1	0	\N
319128	1874	13093000	19939	10041	2	0	\N
319132	1678	23040756787000	19941	10041	0	0	\N
319133	1874	13090000	19941	10041	1	0	\N
319134	1874	13093000	19941	10041	2	0	\N
319135	1678	23040756787000	19942	10041	0	0	\N
319136	1874	13090000	19942	10041	1	0	\N
319137	1874	13093000	19942	10041	2	0	\N
319138	1678	23040756787000	19943	10041	0	0	\N
319139	1874	13090000	19943	10041	1	0	\N
319140	1874	13093000	19943	10041	2	0	\N
319141	2011	1475000000000	19944	9926	0	0	\N
319142	1460	0	19944	9926	1	0	\N
319143	1330	1706840637751650	19944	9926	2	0	\N
319144	1204	612520750000000	19944	9926	3	0	\N
319145	1084	907813465000000	19944	9926	4	0	\N
319146	964	506595775000000	19944	9926	5	0	\N
319147	966	506675775000000	19944	9926	6	0	\N
319148	1086	907959465000000	19944	9926	7	0	\N
319149	1206	612618750000000	19944	9926	8	0	\N
319150	1332	1707114637751650	19944	9926	9	0	\N
319151	1299	1704974641817750	19944	9926	10	0	\N
319152	1001	507702275000000	19944	9926	11	0	\N
319153	1241	613859250000000	19944	9926	12	0	\N
319154	1678	21600733663000	19944	9926	13	0	\N
319155	1121	909797965000000	19944	9926	14	0	\N
319156	1678	21600733664000	19944	9926	15	0	\N
319157	1678	21600733665000	19944	9926	16	0	\N
319158	1678	21600733666000	19944	9926	17	0	\N
319159	1678	21600733667000	19944	9926	18	0	\N
319160	1053	906821162404900	19944	9926	19	0	\N
319161	1173	611850449546800	19944	9926	20	0	\N
319162	933	506041764067500	19944	9926	21	0	\N
319163	1678	21600733668000	19944	9926	22	0	\N
319164	1678	21600733669000	19944	9926	23	0	\N
319165	1678	21600733670000	19944	9926	24	0	\N
319166	1678	21600733671000	19944	9926	25	0	\N
319167	1678	21600733672000	19944	9926	26	0	\N
319168	1678	21600733673000	19944	9926	27	0	\N
319169	1678	21600733674000	19944	9926	28	0	\N
319170	1594	17185313000000	19944	9926	29	0	\N
319171	1678	21600733675000	19944	9926	30	0	\N
319172	1678	21600733676000	19944	9926	31	0	\N
319173	1678	21600733677000	19944	9926	32	0	\N
319174	1678	21600733678000	19944	9926	33	0	\N
319175	1678	21600733679000	19944	9926	34	0	\N
319176	1678	21600733680000	19944	9926	36	0	\N
319177	1678	21600733681000	19944	9926	37	0	\N
319178	1678	21600733682000	19944	9926	38	0	\N
319179	1678	21600733683000	19944	9926	39	0	\N
319180	1678	21600733684000	19944	9926	40	0	\N
319181	1678	21600733685000	19944	9926	41	0	\N
319182	1678	21600733686000	19944	9926	42	0	\N
319183	1678	21600733687000	19944	9926	43	0	\N
319184	1678	21600733688000	19944	9926	44	0	\N
319185	1678	21600733689000	19944	9926	45	0	\N
319186	1678	21600733690000	19944	9926	46	0	\N
319187	1678	21600733691000	19944	9926	47	0	\N
319188	1678	21600733692000	19944	9926	48	0	\N
319189	1678	21600733693000	19944	9926	49	0	\N
319190	1678	21600733694000	19944	9926	50	0	\N
319191	1678	21600733695000	19944	9926	51	0	\N
319192	1678	21600733696000	19944	9926	52	0	\N
319076	1874	13053000	19922	10033	2	0	2
319077	1874	13056000	19922	10033	3	0	2
319078	1874	13058000	19923	10034	0	0	2
319083	1678	23040756781000	19926	10035	0	0	0
319084	1874	13060000	19926	10035	1	0	2
319086	1678	23040756782000	19927	10036	0	0	0
319087	1874	13066000	19927	10036	1	0	2
319088	1874	13067000	19927	10036	2	0	2
319089	1874	13069000	19927	10036	3	0	2
319093	1874	13071000	19929	10037	0	0	2
319095	1678	23040756784000	19930	10038	1	0	0
319096	1874	13073000	19930	10038	2	0	2
319097	1874	13076000	19930	10038	3	0	2
319098	1874	13079000	19930	10038	4	0	2
319110	1874	13082000	19933	10039	1	0	2
319111	1874	13083000	19933	10039	2	0	2
319112	1874	13085000	19933	10039	3	0	2
319117	1678	23040756786000	19935	10040	0	0	0
319118	1874	13088000	19935	10040	1	0	2
319130	1874	13090000	19940	10041	1	0	2
319131	1874	13093000	19940	10041	2	0	2
319193	1678	21600733697000	19944	9926	53	0	\N
319194	1678	21600733698000	19944	9926	54	0	\N
319195	1678	21600733699000	19944	9926	55	0	\N
319196	1678	21600733700000	19944	9926	56	0	\N
319197	1678	21600733701000	19944	9926	57	0	\N
319198	1678	21600733702000	19944	9926	58	0	\N
319199	1678	21600733703000	19944	9926	59	0	\N
319200	1678	21600733704000	19944	9926	60	0	\N
319201	1678	21600733705000	19944	9926	61	0	\N
319202	1678	21600733706000	19944	9926	62	0	\N
319203	1678	21600733707000	19944	9926	63	0	\N
319204	1678	21600733708000	19944	9926	64	0	\N
319205	1678	21600733709000	19944	9926	65	0	\N
319206	1367	1710571137751650	19944	9926	66	0	\N
319207	1678	21600733710000	19944	9926	67	0	\N
319208	1678	21600733711000	19944	9926	68	0	\N
319209	1678	21600733712000	19944	9926	69	0	\N
319210	1678	21600733713000	19944	9926	70	0	\N
319211	1678	21600733714000	19944	9926	71	0	\N
319212	1678	21600733715000	19944	9926	72	0	\N
319213	1678	21600733716000	19944	9926	73	0	\N
319214	1678	21600733717000	19944	9926	74	0	\N
319215	1678	21600733718000	19944	9926	75	0	\N
319216	1678	21600733719000	19944	9926	76	0	\N
319217	1678	21600733720000	19944	9926	77	0	\N
319218	1678	21600733721000	19944	9926	78	0	\N
319219	1678	21600733722000	19944	9926	79	0	\N
319220	1678	21600733723000	19944	9926	80	0	\N
319221	1678	21600733724000	19944	9926	81	0	\N
319222	1678	21600733725000	19944	9926	82	0	\N
319223	1678	21600733726000	19944	9926	83	0	\N
319224	1678	21600733727000	19944	9926	84	0	\N
319225	1678	21600733728000	19944	9926	85	0	\N
319226	1678	21600733729000	19944	9926	86	0	\N
319227	1678	21600733730000	19944	9926	87	0	\N
319228	1678	21600733731000	19944	9926	88	0	\N
319229	1678	21600733732000	19944	9926	89	0	\N
319230	1678	21600733733000	19944	9926	90	0	\N
319231	1678	21600733734000	19944	9926	91	0	\N
319232	1678	21600733735000	19944	9926	92	0	\N
319233	1678	21600733736000	19944	9926	93	0	\N
319234	1678	21600733737000	19944	9926	94	0	\N
319235	1678	21600733738000	19944	9926	95	0	\N
319236	1678	21600733739000	19944	9926	96	0	\N
319237	1678	21600733740000	19944	9926	97	0	\N
319238	1678	21600733741000	19944	9926	98	0	\N
319239	1678	21600733742000	19944	9926	99	0	\N
319240	1678	21600733743000	19944	9926	100	0	\N
319241	1678	21600733744000	19944	9926	101	0	\N
319242	1678	21600733745000	19944	9926	102	0	\N
319243	1678	21600733746000	19944	9926	103	0	\N
319244	1678	21600733747000	19944	9926	104	0	\N
319245	1678	21600733748000	19944	9926	105	0	\N
319246	1678	21600733749000	19944	9926	106	0	\N
319247	1678	21600733750000	19944	9926	107	0	\N
319248	1678	21600733751000	19944	9926	108	0	\N
319249	1678	21600733752000	19944	9926	109	0	\N
319250	1678	21600733753000	19944	9926	110	0	\N
319251	1678	21600733754000	19944	9926	111	0	\N
319252	1678	21600733755000	19944	9926	112	0	\N
319253	1678	21600733756000	19944	9926	113	0	\N
319254	1678	21600733757000	19944	9926	114	0	\N
319255	1678	21600733758000	19944	9926	115	0	\N
319256	1678	21600733759000	19944	9926	116	0	\N
319257	1678	21600733760000	19944	9926	117	0	\N
319258	1678	21600733761000	19944	9926	118	0	\N
319259	1678	21600733762000	19944	9926	119	0	\N
319260	1678	21600733763000	19944	9926	120	0	\N
319261	1678	21600733764000	19944	9926	121	0	\N
319262	1678	21600733765000	19944	9926	122	0	\N
319263	1678	21600733766000	19944	9926	123	0	\N
319264	1678	21600733767000	19944	9926	124	0	\N
319265	1678	21600733768000	19944	9926	125	0	\N
319283	1678	23040756793000	19948	10045	0	0	\N
319284	1678	23040756794000	19948	10045	1	0	\N
319285	38	66383534720208	19948	10045	2	0	\N
319286	969	505695553414336	19948	10045	3	0	\N
319287	1678	23040756795000	19948	10045	4	0	\N
319288	1089	906202098918976	19948	10045	5	0	\N
319289	1209	611432613493024	19948	10045	6	0	\N
319290	1335	1703811343055074	19948	10045	7	0	\N
319291	1874	13122000	19948	10045	8	0	\N
319292	1874	13125000	19948	10045	9	0	\N
319293	1874	13128000	19948	10045	10	0	\N
319294	1874	13131000	19948	10045	11	0	\N
319295	1874	13132000	19948	10045	12	0	\N
319296	1874	13134000	19948	10045	13	0	\N
319297	1874	13136000	19948	10045	14	0	\N
319316	1678	23040756796000	19951	10046	0	0	\N
319317	1874	13138000	19951	10046	1	0	\N
319318	1874	13141000	19951	10046	2	0	\N
319319	1678	23040756796000	19952	10046	0	0	\N
319320	1874	13138000	19952	10046	1	0	\N
319321	1874	13141000	19952	10046	2	0	\N
319268	1874	13096000	19945	10042	2	0	2
319269	1874	13097000	19945	10042	3	0	2
319270	1874	13100000	19945	10042	4	0	2
319271	1874	13102000	19945	10042	5	0	2
319272	1874	13104000	19945	10042	6	0	2
319274	1874	13107000	19946	10043	1	0	2
319275	1874	13109000	19946	10043	2	0	2
319276	1678	23040756791000	19947	10044	0	0	0
319277	1678	23040756792000	19947	10044	1	0	0
319278	1874	13111000	19947	10044	2	0	2
319280	1874	13117000	19947	10044	4	0	2
319281	1874	13119000	19947	10044	5	0	2
319282	1874	13120000	19947	10044	6	0	2
319298	1678	23040756793000	19949	10045	0	0	0
319300	38	66383534720208	19949	10045	2	0	0
319301	969	505695553414336	19949	10045	3	0	0
319302	1678	23040756795000	19949	10045	4	0	0
319303	1089	906202098918976	19949	10045	5	0	0
319304	1209	611432613493024	19949	10045	6	0	0
319306	1874	13122000	19949	10045	8	0	2
319307	1874	13125000	19949	10045	9	0	2
319308	1874	13128000	19949	10045	10	0	2
319309	1874	13131000	19949	10045	11	0	2
319310	1874	13132000	19949	10045	12	0	2
319312	1874	13136000	19949	10045	14	0	2
319313	1678	23040756796000	19950	10046	0	0	0
319314	1874	13138000	19950	10046	1	0	2
319315	1874	13141000	19950	10046	2	0	2
319323	1678	23040756798000	19953	10047	1	0	0
319324	1678	23040756799000	19953	10047	2	0	0
319325	1874	13142000	19953	10047	3	0	2
319326	1874	13144000	19953	10047	4	0	2
319327	1874	13146000	19953	10047	5	0	2
319332	1678	23040756800000	19954	10048	0	0	\N
319333	1678	23040756801000	19954	10048	1	0	\N
319334	1678	23040756802000	19954	10048	2	0	\N
319335	1678	23040756803000	19954	10048	3	0	\N
319336	1874	13159000	19954	10048	4	0	\N
319337	1874	13162000	19954	10048	5	0	\N
319338	1874	13165000	19954	10048	6	0	\N
319339	1874	13168000	19954	10048	7	0	\N
319340	1874	13171000	19954	10048	8	0	\N
319341	1874	13173000	19954	10048	9	0	\N
319342	1874	13175000	19954	10048	10	0	\N
319343	1874	13177000	19954	10048	11	0	\N
319344	1874	13178000	19954	10048	12	0	\N
319365	2011	1475000000000	19958	9961	0	0	\N
319366	1460	0	19958	9961	1	0	\N
319367	1330	1706840637751650	19958	9961	2	0	\N
319368	1204	612520750000000	19958	9961	3	0	\N
319369	1084	907813465000000	19958	9961	4	0	\N
319370	964	506595775000000	19958	9961	5	0	\N
319371	966	506675775000000	19958	9961	6	0	\N
319372	1086	907959465000000	19958	9961	7	0	\N
319373	1206	612618750000000	19958	9961	8	0	\N
319374	1332	1707114637751650	19958	9961	9	0	\N
319375	1299	1704974641817750	19958	9961	10	0	\N
319376	1001	507702275000000	19958	9961	11	0	\N
319377	1241	613859250000000	19958	9961	12	0	\N
319378	1121	909797965000000	19958	9961	13	0	\N
319379	38	66383534720208	19958	9961	14	0	\N
319380	969	505695553414336	19958	9961	15	0	\N
319381	1053	906821162404900	19958	9961	16	0	\N
319382	1173	611850449546800	19958	9961	17	0	\N
319383	933	506041764067500	19958	9961	18	0	\N
319384	1089	906202098918976	19958	9961	19	0	\N
319385	1209	611432613493024	19958	9961	20	0	\N
319386	1594	17185313000000	19958	9961	21	0	\N
319387	1678	21600733683000	19958	9961	23	0	\N
319388	1678	21600733684000	19958	9961	24	0	\N
319389	1678	21600733685000	19958	9961	25	0	\N
319390	1678	21600733686000	19958	9961	26	0	\N
319391	1678	21600733687000	19958	9961	27	0	\N
319392	1678	21600733688000	19958	9961	28	0	\N
319393	1678	21600733689000	19958	9961	29	0	\N
319394	1678	21600733690000	19958	9961	30	0	\N
319395	1678	21600733691000	19958	9961	31	0	\N
319396	1678	21600733692000	19958	9961	32	0	\N
319397	1678	21600733693000	19958	9961	33	0	\N
319398	1678	21600733694000	19958	9961	34	0	\N
319399	1678	21600733695000	19958	9961	35	0	\N
319400	1678	21600733696000	19958	9961	36	0	\N
319401	1678	21600733697000	19958	9961	37	0	\N
319402	1678	21600733698000	19958	9961	38	0	\N
319403	1678	21600733699000	19958	9961	39	0	\N
319404	1678	21600733700000	19958	9961	40	0	\N
319405	1678	21600733701000	19958	9961	41	0	\N
319406	1678	21600733702000	19958	9961	42	0	\N
319407	1678	21600733703000	19958	9961	43	0	\N
319408	1678	21600733704000	19958	9961	44	0	\N
319409	1678	21600733705000	19958	9961	45	0	\N
319410	1678	21600733706000	19958	9961	46	0	\N
319411	1678	21600733707000	19958	9961	47	0	\N
319412	1678	21600733708000	19958	9961	48	0	\N
319413	1678	21600733709000	19958	9961	49	0	\N
319414	1335	1703811343055074	19958	9961	50	0	\N
319415	1367	1710571137751650	19958	9961	51	0	\N
319416	1678	21600733710000	19958	9961	52	0	\N
319417	1678	21600733711000	19958	9961	53	0	\N
319418	1678	21600733712000	19958	9961	54	0	\N
319419	1678	21600733713000	19958	9961	55	0	\N
319420	1678	21600733714000	19958	9961	56	0	\N
319421	1678	21600733715000	19958	9961	57	0	\N
319422	1678	21600733716000	19958	9961	58	0	\N
319423	1678	21600733717000	19958	9961	59	0	\N
319424	1678	21600733718000	19958	9961	60	0	\N
319425	1678	21600733719000	19958	9961	61	0	\N
319426	1678	21600733720000	19958	9961	62	0	\N
319427	1678	21600733721000	19958	9961	63	0	\N
319428	1678	21600733722000	19958	9961	64	0	\N
319429	1678	21600733723000	19958	9961	65	0	\N
319430	1678	21600733724000	19958	9961	66	0	\N
319431	1678	21600733725000	19958	9961	67	0	\N
319432	1678	21600733726000	19958	9961	68	0	\N
319433	1678	21600733727000	19958	9961	69	0	\N
319434	1678	21600733728000	19958	9961	70	0	\N
319435	1678	21600733729000	19958	9961	71	0	\N
319436	1678	21600733730000	19958	9961	72	0	\N
319437	1678	21600733731000	19958	9961	73	0	\N
319438	1678	21600733732000	19958	9961	74	0	\N
319439	1678	21600733733000	19958	9961	75	0	\N
319440	1678	21600733734000	19958	9961	76	0	\N
319441	1678	21600733735000	19958	9961	77	0	\N
319442	1678	21600733736000	19958	9961	78	0	\N
319443	1678	21600733737000	19958	9961	79	0	\N
319444	1678	21600733738000	19958	9961	80	0	\N
319445	1678	21600733739000	19958	9961	81	0	\N
319446	1678	21600733740000	19958	9961	82	0	\N
319447	1678	21600733741000	19958	9961	83	0	\N
319448	1678	21600733742000	19958	9961	84	0	\N
319449	1678	21600733743000	19958	9961	85	0	\N
319450	1678	21600733744000	19958	9961	86	0	\N
319451	1678	21600733745000	19958	9961	87	0	\N
319452	1678	21600733746000	19958	9961	88	0	\N
319453	1678	21600733747000	19958	9961	89	0	\N
319454	1678	21600733748000	19958	9961	90	0	\N
319455	1678	21600733749000	19958	9961	91	0	\N
319456	1678	21600733750000	19958	9961	92	0	\N
319457	1678	21600733751000	19958	9961	93	0	\N
319458	1678	21600733752000	19958	9961	94	0	\N
319459	1678	21600733753000	19958	9961	95	0	\N
319460	1678	21600733754000	19958	9961	96	0	\N
319461	1678	21600733755000	19958	9961	97	0	\N
319462	1678	21600733756000	19958	9961	98	0	\N
319463	1678	21600733757000	19958	9961	99	0	\N
319464	1678	21600733758000	19958	9961	100	0	\N
319331	1874	13157000	19953	10047	9	0	2
319345	1678	23040756800000	19955	10048	0	0	0
319346	1678	23040756801000	19955	10048	1	0	0
319347	1678	23040756802000	19955	10048	2	0	0
319348	1678	23040756803000	19955	10048	3	0	0
319350	1678	23040756804000	19956	10049	0	0	0
319351	1874	13160000	19956	10049	1	0	2
319352	1874	13163000	19956	10049	2	0	2
319353	1874	13166000	19956	10049	3	0	2
319354	1874	13169000	19956	10049	4	0	2
319356	1874	13175000	19956	10049	6	0	2
319357	1874	13177000	19956	10049	7	0	2
319358	1874	13179000	19956	10049	8	0	2
319359	1874	13181000	19956	10049	9	0	2
319361	1678	23040756805000	19957	10050	0	0	0
319362	1874	13186000	19957	10050	1	0	2
319363	1874	13187000	19957	10050	2	0	2
319364	1874	13189000	19957	10050	3	0	2
319465	1678	21600733759000	19958	9961	101	0	\N
319466	1678	21600733760000	19958	9961	102	0	\N
319467	1678	21600733761000	19958	9961	103	0	\N
319468	1678	21600733762000	19958	9961	104	0	\N
319469	1678	21600733763000	19958	9961	105	0	\N
319470	1678	21600733764000	19958	9961	106	0	\N
319471	1678	21600733765000	19958	9961	107	0	\N
319472	1678	21600733766000	19958	9961	108	0	\N
319473	1678	21600733767000	19958	9961	109	0	\N
319474	1678	21600733768000	19958	9961	110	0	\N
319475	1678	21600733769000	19958	9961	111	0	\N
319476	1678	21600733770000	19958	9961	112	0	\N
319477	1678	21600733771000	19958	9961	113	0	\N
319478	1678	21600733772000	19958	9961	114	0	\N
319479	1678	21600733773000	19958	9961	115	0	\N
319480	1678	21600733774000	19958	9961	116	0	\N
319481	1678	21600733775000	19958	9961	117	0	\N
319482	1678	21600733776000	19958	9961	118	0	\N
319483	1678	21600733777000	19958	9961	119	0	\N
319484	1678	21600733778000	19958	9961	120	0	\N
319485	1678	21600733779000	19958	9961	121	0	\N
319486	1678	21600733780000	19958	9961	122	0	\N
319487	1678	21600733781000	19958	9961	123	0	\N
319488	1678	21600733782000	19958	9961	124	0	\N
319489	1678	21600733783000	19958	9961	125	0	\N
319493	1678	23040756807000	19960	10052	0	0	\N
319494	1874	13196000	19960	10052	1	0	\N
319495	1874	13199000	19960	10052	2	0	\N
319502	1678	23040756808000	19963	10053	0	0	\N
319503	1874	13202000	19963	10053	1	0	\N
319504	1874	13204000	19963	10053	2	0	\N
319505	2011	1475000000000	19964	9936	0	0	\N
319506	966	506675775000000	19964	9936	1	0	\N
319507	1086	907959465000000	19964	9936	2	0	\N
319508	1206	612618750000000	19964	9936	3	0	\N
319509	1332	1707114637751650	19964	9936	4	0	\N
319510	1299	1704974641817750	19964	9936	5	0	\N
319511	1001	507702275000000	19964	9936	6	0	\N
319512	1241	613859250000000	19964	9936	7	0	\N
319513	1121	909797965000000	19964	9936	8	0	\N
319514	38	66383534720208	19964	9936	9	0	\N
319519	1678	23040756809000	19966	10054	0	0	\N
319520	1874	13207000	19966	10054	1	0	\N
319521	1874	13209000	19966	10054	2	0	\N
319522	1874	13210000	19966	10054	3	0	\N
319536	1678	23040756814000	19969	10057	0	0	\N
319537	1874	13234000	19969	10057	1	0	\N
319538	1874	13236000	19969	10057	2	0	\N
319542	1678	23040756815000	19971	10058	0	0	\N
319543	1678	23040756816000	19971	10058	1	0	\N
319544	1874	13238000	19971	10058	2	0	\N
319545	1874	13239000	19971	10058	3	0	\N
319546	1874	13242000	19971	10058	4	0	\N
319547	1874	13245000	19971	10058	5	0	\N
319548	1874	13247000	19971	10058	6	0	\N
319556	1678	23040756815000	19973	10058	0	0	\N
319557	1678	23040756816000	19973	10058	1	0	\N
319558	1874	13238000	19973	10058	2	0	\N
319559	1874	13239000	19973	10058	3	0	\N
319560	1874	13242000	19973	10058	4	0	\N
319561	1874	13245000	19973	10058	5	0	\N
319562	1874	13247000	19973	10058	6	0	\N
319563	1678	23040756815000	19974	10058	0	0	\N
319564	1678	23040756816000	19974	10058	1	0	\N
319565	1874	13238000	19974	10058	2	0	\N
319566	1874	13239000	19974	10058	3	0	\N
319567	1874	13242000	19974	10058	4	0	\N
319568	1874	13245000	19974	10058	5	0	\N
319569	1874	13247000	19974	10058	6	0	\N
319570	1678	23040756815000	19975	10058	0	0	\N
319571	1678	23040756816000	19975	10058	1	0	\N
319572	1874	13238000	19975	10058	2	0	\N
319573	1874	13239000	19975	10058	3	0	\N
319574	1874	13242000	19975	10058	4	0	\N
319575	1874	13245000	19975	10058	5	0	\N
319576	1874	13247000	19975	10058	6	0	\N
319577	1678	23040756815000	19976	10058	0	0	\N
319578	1678	23040756816000	19976	10058	1	0	\N
319579	1874	13238000	19976	10058	2	0	\N
319580	1874	13239000	19976	10058	3	0	\N
319581	1874	13242000	19976	10058	4	0	\N
319582	1874	13245000	19976	10058	5	0	\N
319583	1874	13247000	19976	10058	6	0	\N
319584	1678	23040756817000	19978	10060	0	0	\N
319585	1678	23040756818000	19978	10060	1	0	\N
319586	1678	23040756819000	19978	10060	2	0	\N
319587	1874	13248000	19978	10060	3	0	\N
319588	1874	13251000	19978	10060	4	0	\N
319589	1874	13254000	19978	10060	5	0	\N
319590	1874	13256000	19978	10060	6	0	\N
319591	1874	13258000	19978	10060	7	0	\N
319592	1874	13260000	19978	10060	8	0	\N
319492	1874	13194000	19959	10051	2	0	2
319496	1678	23040756807000	19961	10052	0	0	0
319497	1874	13196000	19961	10052	1	0	2
319498	1874	13199000	19961	10052	2	0	2
319499	1678	23040756808000	19962	10053	0	0	0
319501	1874	13204000	19962	10053	2	0	2
319515	1678	23040756809000	19965	10054	0	0	0
319516	1874	13207000	19965	10054	1	0	2
319517	1874	13209000	19965	10054	2	0	2
319518	1874	13210000	19965	10054	3	0	2
319524	1678	23040756811000	19967	10055	1	0	0
319525	1874	13212000	19967	10055	2	0	2
319526	1874	13214000	19967	10055	3	0	2
319527	1874	13217000	19967	10055	4	0	2
319529	1678	23040756812000	19968	10056	0	0	0
319530	1678	23040756813000	19968	10056	1	0	0
319531	1874	13221000	19968	10056	2	0	2
319532	1874	13224000	19968	10056	3	0	2
319533	1874	13226000	19968	10056	4	0	2
319535	1874	13231000	19968	10056	6	0	2
319539	1678	23040756814000	19970	10057	0	0	0
319540	1874	13234000	19970	10057	1	0	2
319541	1874	13236000	19970	10057	2	0	2
319549	1678	23040756815000	19972	10058	0	0	0
319551	1874	13238000	19972	10058	2	0	2
319552	1874	13239000	19972	10058	3	0	2
319553	1874	13242000	19972	10058	4	0	2
319554	1874	13245000	19972	10058	5	0	2
319593	1678	23040756817000	19979	10060	0	0	0
319594	1678	23040756818000	19979	10060	1	0	0
319595	1678	23040756819000	19979	10060	2	0	0
319596	1874	13248000	19979	10060	3	0	2
319597	1874	13251000	19979	10060	4	0	2
319599	1874	13256000	19979	10060	6	0	2
319600	1874	13258000	19979	10060	7	0	2
319614	1874	13279000	19982	10063	0	0	\N
319615	1406	0	19982	10063	1	0	\N
319616	1874	13281000	19982	10063	2	0	\N
319617	1874	13279000	19983	10063	0	0	\N
319618	1406	0	19983	10063	1	0	\N
319619	1874	13281000	19983	10063	2	0	\N
319624	1874	13283000	19985	10064	0	0	\N
319625	606	81835204812962	19985	10064	1	0	\N
319626	1874	13286000	19985	10064	2	0	\N
319630	1678	23040756824000	19987	10065	0	0	\N
319631	2238	1001998000000	19987	10065	1	0	\N
319632	1874	13288000	19987	10065	2	0	\N
319633	1874	13291000	19987	10065	3	0	\N
319634	1874	13292000	19987	10065	4	0	\N
319640	1678	23040756824000	19989	10065	0	0	\N
319641	2238	1001998000000	19989	10065	1	0	\N
319642	1874	13288000	19989	10065	2	0	\N
319643	1874	13291000	19989	10065	3	0	\N
319644	1874	13292000	19989	10065	4	0	\N
319660	1282	1713369637751650	19992	10067	0	0	\N
319661	1678	23040756826000	19992	10067	1	0	\N
319662	1678	23040756827000	19992	10067	2	0	\N
319663	1678	23040756828000	19992	10067	3	0	\N
319664	1874	13298000	19992	10067	4	0	\N
319665	606	80835194812962	19992	10067	5	0	\N
319666	1874	13301000	19992	10067	6	0	\N
319667	1874	13304000	19992	10067	7	0	\N
319668	1874	13307000	19992	10067	8	0	\N
319669	1678	23040756829000	19993	10068	0	0	\N
319670	1874	13316000	19993	10068	1	0	\N
319671	1874	13318000	19993	10068	2	0	\N
319672	1678	23040756829000	19994	10068	0	0	\N
319673	1874	13316000	19994	10068	1	0	\N
319674	1874	13318000	19994	10068	2	0	\N
319675	1678	23040756829000	19995	10068	0	0	\N
319676	1874	13316000	19995	10068	1	0	\N
319677	1874	13318000	19995	10068	2	0	\N
319686	1036	911287465000000	19998	10069	0	0	\N
319687	1985	2299990000000	19998	10069	1	0	\N
319688	1678	23040756830000	19998	10069	2	0	\N
319689	1874	13321000	19998	10069	3	0	\N
319690	1874	13323000	19998	10069	4	0	\N
319696	1282	1713369637751650	20000	10048	0	0	\N
319697	1036	911287465000000	20000	10048	1	0	\N
319698	1985	2299990000000	20000	10048	2	0	\N
319699	1678	23040756800000	20000	10048	3	0	\N
319700	2238	2000000000	20000	10048	4	0	\N
319701	2238	1002000000000	20000	10048	5	0	\N
319702	1678	23040756801000	20000	10048	6	0	\N
319703	1678	23040756802000	20000	10048	7	0	\N
319704	1678	23040756803000	20000	10048	8	0	\N
319705	1678	23040756804000	20000	10048	9	0	\N
319706	1678	23040756805000	20000	10048	10	0	\N
319707	1678	23040756806000	20000	10048	11	0	\N
319708	1678	23040756807000	20000	10048	12	0	\N
319709	1678	23040756808000	20000	10048	13	0	\N
319710	1678	23040756809000	20000	10048	14	0	\N
319711	1678	23040756810000	20000	10048	15	0	\N
319712	1678	23040756811000	20000	10048	16	0	\N
319713	1678	23040756812000	20000	10048	17	0	\N
319714	1678	23040756813000	20000	10048	18	0	\N
319715	1678	23040756814000	20000	10048	19	0	\N
319716	1678	23040756815000	20000	10048	20	0	\N
319717	1678	23040756816000	20000	10048	21	0	\N
319718	1678	23040756817000	20000	10048	22	0	\N
319719	1678	23040756818000	20000	10048	23	0	\N
319720	1678	23040756819000	20000	10048	24	0	\N
319721	1678	23040756820000	20000	10048	25	0	\N
319722	1678	23040756821000	20000	10048	26	0	\N
319723	1678	23040756822000	20000	10048	27	0	\N
319724	1678	23040756823000	20000	10048	28	0	\N
319725	1678	23040756824000	20000	10048	29	0	\N
319726	1678	23040756825000	20000	10048	30	0	\N
319727	1678	23040756826000	20000	10048	31	0	\N
319728	1678	23040756827000	20000	10048	32	0	\N
319729	1678	23040756828000	20000	10048	33	0	\N
319730	1678	23040756829000	20000	10048	34	0	\N
319731	1678	23040756830000	20000	10048	35	0	\N
319732	1678	23040756831000	20000	10048	36	0	\N
319733	1406	0	20000	10048	37	0	\N
319734	1874	13159000	20000	10048	38	0	\N
319735	1979	14400211999976	20000	10048	39	0	\N
319736	1874	13162000	20000	10048	40	0	\N
319603	1678	23040756821000	19980	10061	1	0	0
319604	1874	13262000	19980	10061	2	0	2
319605	1874	13265000	19980	10061	3	0	2
319606	1874	13268000	19980	10061	4	0	2
319607	1874	13270000	19980	10061	5	0	2
319609	2238	2000000000	19981	10062	1	0	0
319610	1874	13273000	19981	10062	2	0	2
319611	1979	14400211999976	19981	10062	3	0	9
319612	1874	13274000	19981	10062	4	0	2
319613	1874	13276000	19981	10062	5	0	2
319621	1874	13279000	19984	10063	1	0	2
319622	1406	0	19984	10063	2	0	0
319623	1874	13281000	19984	10063	3	0	2
319627	1874	13283000	19986	10064	0	0	2
319629	1874	13286000	19986	10064	2	0	2
319635	1678	23040756824000	19988	10065	0	0	0
319636	2238	1001998000000	19988	10065	1	0	1
319637	1874	13288000	19988	10065	2	0	2
319638	1874	13291000	19988	10065	3	0	2
319645	1678	23040756825000	19990	10066	0	0	0
319646	1874	13294000	19990	10066	1	0	2
319647	1874	13297000	19990	10066	2	0	2
319648	1282	1713369637751650	19991	10067	0	0	0
319649	1678	23040756826000	19991	10067	1	0	0
319651	1678	23040756828000	19991	10067	3	0	0
319652	1874	13298000	19991	10067	4	0	2
319653	606	80835194812962	19991	10067	5	0	14
319654	1874	13301000	19991	10067	6	0	2
319656	1874	13305000	19991	10067	8	0	2
319657	1874	13307000	19991	10067	9	0	2
319658	1874	13310000	19991	10067	10	0	2
319659	1874	13313000	19991	10067	11	0	2
319678	1678	23040756829000	19996	10068	0	0	0
319680	1874	13318000	19996	10068	2	0	2
319681	1036	911287465000000	19997	10069	0	0	0
319682	1985	2299990000000	19997	10069	1	0	1
319683	1678	23040756830000	19997	10069	2	0	0
319684	1874	13321000	19997	10069	3	0	2
319691	1156	614864750000000	19999	10070	0	0	0
319692	1678	23040756831000	19999	10070	1	0	0
319693	1874	13326000	19999	10070	2	0	2
319694	1874	13328000	19999	10070	3	0	2
319737	1874	13165000	20000	10048	41	0	\N
319738	1874	13168000	20000	10048	42	0	\N
319739	1874	13171000	20000	10048	43	0	\N
319740	1874	13174000	20000	10048	44	0	\N
319741	1874	13177000	20000	10048	45	0	\N
319742	1874	13180000	20000	10048	46	0	\N
319743	1874	13182000	20000	10048	47	0	\N
319744	1874	13184000	20000	10048	48	0	\N
319745	1874	13186000	20000	10048	49	0	\N
319746	1874	13187000	20000	10048	50	0	\N
319747	1874	13188000	20000	10048	51	0	\N
319748	1874	13189000	20000	10048	52	0	\N
319749	1874	13190000	20000	10048	53	0	\N
319750	1874	13191000	20000	10048	54	0	\N
319751	1874	13192000	20000	10048	55	0	\N
319752	1874	13193000	20000	10048	56	0	\N
319753	1874	13195000	20000	10048	57	0	\N
319754	1874	13197000	20000	10048	58	0	\N
319755	1874	13199000	20000	10048	59	0	\N
319756	1874	13201000	20000	10048	60	0	\N
319757	1874	13203000	20000	10048	61	0	\N
319758	1874	13205000	20000	10048	62	0	\N
319759	1874	13207000	20000	10048	63	0	\N
319760	1874	13209000	20000	10048	64	0	\N
319761	1874	13211000	20000	10048	65	0	\N
319762	1874	13213000	20000	10048	66	0	\N
319763	1874	13215000	20000	10048	67	0	\N
319764	1874	13217000	20000	10048	68	0	\N
319765	1874	13219000	20000	10048	69	0	\N
319766	1874	13221000	20000	10048	70	0	\N
319767	1874	13223000	20000	10048	71	0	\N
319768	1874	13225000	20000	10048	72	0	\N
319769	1874	13227000	20000	10048	73	0	\N
319770	1874	13229000	20000	10048	74	0	\N
319771	1874	13231000	20000	10048	75	0	\N
319772	1874	13233000	20000	10048	76	0	\N
319773	1874	13235000	20000	10048	77	0	\N
319774	1874	13237000	20000	10048	79	0	\N
319775	1874	13239000	20000	10048	80	0	\N
319776	1874	13241000	20000	10048	81	0	\N
319777	1874	13243000	20000	10048	82	0	\N
319778	1874	13245000	20000	10048	83	0	\N
319779	1874	13247000	20000	10048	84	0	\N
319780	1874	13249000	20000	10048	85	0	\N
319781	1874	13251000	20000	10048	86	0	\N
319782	1874	13252000	20000	10048	87	0	\N
319783	1874	13253000	20000	10048	88	0	\N
319784	1874	13256000	20000	10048	89	0	\N
319785	1874	13259000	20000	10048	90	0	\N
319786	1874	13262000	20000	10048	91	0	\N
319787	1874	13265000	20000	10048	92	0	\N
319788	1874	13268000	20000	10048	93	0	\N
319789	1874	13271000	20000	10048	94	0	\N
319790	1874	13274000	20000	10048	95	0	\N
319791	1874	13277000	20000	10048	96	0	\N
319792	1874	13280000	20000	10048	97	0	\N
319793	1874	13283000	20000	10048	98	0	\N
319794	1874	13286000	20000	10048	99	0	\N
319795	1874	13289000	20000	10048	100	0	\N
319796	1874	13292000	20000	10048	101	0	\N
319797	1874	13295000	20000	10048	102	0	\N
319798	1874	13298000	20000	10048	103	0	\N
319799	1874	13301000	20000	10048	104	0	\N
319800	1874	13304000	20000	10048	105	0	\N
319801	1874	13307000	20000	10048	106	0	\N
319802	1874	13310000	20000	10048	107	0	\N
319803	1874	13313000	20000	10048	108	0	\N
319804	1874	13316000	20000	10048	109	0	\N
319805	1874	13319000	20000	10048	110	0	\N
319806	1874	13322000	20000	10048	111	0	\N
319807	1874	13325000	20000	10048	112	0	\N
319808	1156	614864750000000	20001	10070	0	0	\N
319809	1678	23040756831000	20001	10070	1	0	\N
319810	1874	13326000	20001	10070	2	0	\N
319811	1874	13328000	20001	10070	3	0	\N
319812	1874	13329000	20001	10070	4	0	\N
319818	1678	23040756832000	20003	10071	0	0	\N
319819	1326	1709341117751650	20003	10071	1	0	\N
319820	1200	613417050000000	20003	10071	2	0	\N
319821	1874	13332000	20003	10071	3	0	\N
319822	1874	13334000	20003	10071	4	0	\N
319823	916	508533775000000	20004	10072	0	0	\N
319824	1080	909143225000000	20004	10072	1	0	\N
319825	1678	23040756833000	20004	10072	2	0	\N
319826	1874	13337000	20004	10072	3	0	\N
319827	1874	13339000	20004	10072	4	0	\N
319828	916	508533775000000	20005	10072	0	0	\N
319829	1080	909143225000000	20005	10072	1	0	\N
319830	1678	23040756833000	20005	10072	2	0	\N
319831	1874	13337000	20005	10072	3	0	\N
319832	1874	13339000	20005	10072	4	0	\N
319833	916	508533775000000	20006	10072	0	0	\N
319834	1080	909143225000000	20006	10072	1	0	\N
319835	1678	23040756833000	20006	10072	2	0	\N
319836	1874	13337000	20006	10072	3	0	\N
319837	1874	13339000	20006	10072	4	0	\N
319842	916	508533775000000	20008	10072	0	0	\N
319843	1080	909143225000000	20008	10072	1	0	\N
319844	1678	23040756833000	20008	10072	2	0	\N
319845	1874	13337000	20008	10072	3	0	\N
319846	1874	13339000	20008	10072	4	0	\N
319864	1678	23040756837000	20011	10075	0	0	\N
319865	1874	13355000	20011	10075	1	0	\N
319866	1874	13357000	20011	10075	2	0	\N
319870	1678	23040756837000	20013	10075	0	0	\N
319871	1874	13355000	20013	10075	1	0	\N
319872	1874	13357000	20013	10075	2	0	\N
319815	1200	613417050000000	20002	10071	2	0	0
319816	1874	13332000	20002	10071	3	0	2
319817	1874	13334000	20002	10071	4	0	2
319838	916	508533775000000	20007	10072	0	0	0
319839	1080	909143225000000	20007	10072	1	0	0
319841	1874	13339000	20007	10072	3	0	2
319847	1977	2219500000000	20009	10073	0	0	0
319848	1678	23040756833000	20009	10073	1	0	0
319849	1678	23040756834000	20009	10073	2	0	0
319850	1776	1379801392757	20009	10073	3	0	1
319852	1678	23040756835000	20009	10073	5	0	0
319853	950	508066275000000	20009	10073	6	0	0
319854	1874	13342000	20009	10073	7	0	2
319855	1874	13343000	20009	10073	8	0	2
319857	1874	13347000	20009	10073	10	0	2
319858	1678	23040756836000	20010	10074	0	0	0
319859	1874	13350000	20010	10074	1	0	2
319860	1070	910450405000000	20010	10074	2	0	0
319861	1190	614299070000000	20010	10074	3	0	0
319863	1874	13352000	20010	10074	5	0	2
319867	1678	23040756837000	20012	10075	0	0	0
319868	1874	13355000	20012	10075	1	0	2
319869	1874	13357000	20012	10075	2	0	2
319873	1678	23040756837000	20014	10075	0	0	\N
319874	1874	13355000	20014	10075	1	0	\N
319875	1874	13357000	20014	10075	2	0	\N
319876	1678	23040756837000	20015	10075	0	0	\N
319877	1874	13355000	20015	10075	1	0	\N
319878	1874	13357000	20015	10075	2	0	\N
319879	1678	23040756837000	20016	10075	0	0	\N
319880	1874	13355000	20016	10075	1	0	\N
319881	1874	13357000	20016	10075	2	0	\N
319882	1678	23040756838000	20017	10076	0	0	\N
319883	1874	13358000	20017	10076	1	0	\N
319884	1874	13361000	20017	10076	2	0	\N
319885	1874	13363000	20017	10076	3	0	\N
319890	1678	23040756839000	20019	10077	0	0	\N
319891	2239	2780956000000	20019	10077	1	0	\N
319892	1874	13365000	20019	10077	2	0	\N
319893	1874	13368000	20019	10077	3	0	\N
319930	1678	23040756845000	20027	10082	0	0	\N
319931	1874	13397000	20027	10082	1	0	\N
319932	1874	13399000	20027	10082	2	0	\N
319933	1874	13402000	20027	10082	3	0	\N
319934	1874	13405000	20027	10082	4	0	\N
319946	1678	23040756849000	20034	10086	0	0	\N
319947	1874	13423000	20034	10086	1	0	\N
319948	1874	13426000	20034	10086	2	0	\N
319952	1678	23040756849000	20036	10086	0	0	\N
319953	1874	13423000	20036	10086	1	0	\N
319954	1874	13426000	20036	10086	2	0	\N
319960	1332	1707114637751650	20038	10087	0	0	\N
319961	1678	23040756850000	20038	10087	1	0	\N
319962	2213	650232116779	20038	10087	2	0	\N
319963	1874	13428000	20038	10087	3	0	\N
319964	1874	13429000	20038	10087	4	0	\N
319968	1678	23040756851000	20041	10088	0	0	\N
319969	1874	13431000	20041	10088	1	0	\N
319970	1874	13434000	20041	10088	2	0	\N
319974	1678	23040756853000	20043	10090	0	0	\N
319975	1874	13442000	20043	10090	1	0	\N
319976	1483	10000000	20043	10090	2	0	\N
319977	1874	13444000	20043	10090	3	0	\N
319982	1678	23040756853000	20045	10090	0	0	\N
319983	1874	13442000	20045	10090	1	0	\N
319984	1483	10000000	20045	10090	2	0	\N
319985	1874	13444000	20045	10090	3	0	\N
319996	1678	23040756856000	20049	10092	0	0	\N
319997	1874	13458000	20049	10092	1	0	\N
319998	1874	13460000	20049	10092	2	0	\N
319999	1678	23040756856000	20050	10092	0	0	\N
320000	1874	13458000	20050	10092	1	0	\N
320001	1874	13460000	20050	10092	2	0	\N
319888	1874	13361000	20018	10076	2	0	2
319889	1874	13363000	20018	10076	3	0	2
319894	1678	23040756839000	20020	10077	0	0	0
319895	2239	2780956000000	20020	10077	1	0	0
319896	1874	13365000	20020	10077	2	0	2
319898	1678	23040756840000	20021	10078	0	0	0
319899	2240	200000000	20021	10078	1	0	0
319900	1874	13370000	20021	10078	2	0	2
319901	1874	13373000	20021	10078	3	0	2
319902	1678	23040756841000	20022	10079	0	0	0
319904	2241	200000000	20022	10079	2	0	0
319905	1874	13375000	20022	10079	3	0	2
319906	1874	13377000	20022	10079	4	0	2
319907	1874	13380000	20022	10079	5	0	2
319909	1874	13384000	20022	10079	7	0	2
319910	2242	200000000	20022	10079	8	0	0
319911	2243	200000000	20022	10079	9	0	0
319912	1776	1415976763769	20023	10080	0	0	1
319913	931	506688269472384	20023	10080	1	0	0
319915	1171	612632898860187	20023	10080	3	0	0
319916	1297	1707156044961604	20023	10080	4	0	0
319917	1776	2134917866625	20023	10080	5	0	1
319918	1678	23040756843000	20023	10080	6	0	0
319919	1874	13386000	20023	10080	7	0	2
319921	1678	23040756844000	20024	10081	0	0	0
319922	1874	13392000	20024	10081	1	0	2
319923	1874	13393000	20024	10081	2	0	2
319924	1874	13395000	20024	10081	3	0	2
319926	1874	13397000	20026	10082	1	0	2
319927	1874	13399000	20026	10082	2	0	2
319928	1874	13402000	20026	10082	3	0	2
319929	1874	13405000	20026	10082	4	0	2
319935	1678	23040756846000	20031	10083	0	0	0
319937	1874	13410000	20031	10083	2	0	2
319938	2244	200000000	20031	10083	3	0	0
319939	1678	23040756847000	20032	10084	0	0	0
319940	1874	13413000	20032	10084	1	0	2
319941	1874	13415000	20032	10084	2	0	2
319943	1678	23040756848000	20033	10085	0	0	0
319944	1874	13418000	20033	10085	1	0	2
319945	1874	13421000	20033	10085	2	0	2
319949	1678	23040756849000	20035	10086	0	0	0
319951	1874	13426000	20035	10086	2	0	2
319955	1332	1707114637751650	20037	10087	0	0	0
319956	1678	23040756850000	20037	10087	1	0	0
319957	2213	650232116779	20037	10087	2	0	1
319958	1874	13428000	20037	10087	3	0	2
319965	1678	23040756851000	20040	10088	0	0	0
319966	1874	13431000	20040	10088	1	0	2
319967	1874	13434000	20040	10088	2	0	2
319971	1678	23040756852000	20042	10089	0	0	0
319972	1874	13436000	20042	10089	1	0	2
319978	1678	23040756853000	20044	10090	0	0	0
319979	1874	13442000	20044	10090	1	0	2
319980	1483	10000000	20044	10090	2	0	0
319981	1874	13444000	20044	10090	3	0	2
319987	1678	23040756855000	20046	10091	1	0	0
319988	1874	13446000	20046	10091	2	0	2
319989	1874	13448000	20046	10091	3	0	2
319990	1874	13451000	20046	10091	4	0	2
319991	1874	13454000	20046	10091	5	0	2
319993	1678	23040756856000	20048	10092	0	0	0
319994	1874	13458000	20048	10092	1	0	2
319995	1874	13460000	20048	10092	2	0	2
320002	1678	23040756857000	20051	10093	0	0	0
320003	1874	13463000	20051	10093	1	0	2
320005	1874	13466000	20051	10093	3	0	2
320006	1678	23040756858000	20052	10094	0	0	0
320007	21	32910553770161	20052	10094	1	0	0
320008	52	66714679919853	20052	10094	2	0	0
320044	21	32910553770161	20055	10043	0	0	\N
320045	52	66714679919853	20055	10043	1	0	\N
320046	57	66714679919853	20055	10043	2	0	\N
320047	60	66714679919853	20055	10043	3	0	\N
320048	61	66714679919853	20055	10043	4	0	\N
320049	67	66714679919853	20055	10043	5	0	\N
320050	68	66714679919853	20055	10043	6	0	\N
320051	73	66714679919853	20055	10043	7	0	\N
320052	81	66714679919853	20055	10043	8	0	\N
320053	129	66260677919853	20055	10043	9	0	\N
320054	156	66714679919853	20055	10043	10	0	\N
320055	164	66714679919853	20055	10043	11	0	\N
320056	220	66714679919853	20055	10043	12	0	\N
320057	222	66714679919853	20055	10043	13	0	\N
320058	256	66714679919853	20055	10043	14	0	\N
320059	371	66714679919853	20055	10043	15	0	\N
320060	428	66714679919853	20055	10043	16	0	\N
320061	431	66714679919853	20055	10043	17	0	\N
320062	432	66714679919853	20055	10043	18	0	\N
320063	433	66714679919853	20055	10043	19	0	\N
320064	574	66714679919853	20055	10043	20	0	\N
320065	604	66714679919853	20055	10043	21	0	\N
320066	628	66714679919853	20055	10043	22	0	\N
320067	638	66714679919853	20055	10043	23	0	\N
320068	951	508339674986889	20055	10043	24	0	\N
320069	1071	910939949755115	20055	10043	25	0	\N
320070	1191	614629496764309	20055	10043	26	0	\N
320071	1317	1712718855121332	20055	10043	27	0	\N
320075	21	32910553770161	20057	10052	0	0	\N
320076	52	66714679919853	20057	10052	1	0	\N
320077	57	66714679919853	20057	10052	2	0	\N
320078	60	66714679919853	20057	10052	3	0	\N
320079	61	66714679919853	20057	10052	4	0	\N
320080	67	66714679919853	20057	10052	5	0	\N
320081	68	66714679919853	20057	10052	6	0	\N
320082	73	66714679919853	20057	10052	7	0	\N
320083	81	66714679919853	20057	10052	8	0	\N
320084	129	66260677919853	20057	10052	9	0	\N
320085	156	66714679919853	20057	10052	10	0	\N
320086	164	66714679919853	20057	10052	11	0	\N
320087	220	66714679919853	20057	10052	12	0	\N
320088	222	66714679919853	20057	10052	13	0	\N
320089	256	66714679919853	20057	10052	14	0	\N
320090	371	66714679919853	20057	10052	15	0	\N
320091	428	66714679919853	20057	10052	16	0	\N
320092	431	66714679919853	20057	10052	17	0	\N
320093	432	66714679919853	20057	10052	18	0	\N
320094	433	66714679919853	20057	10052	19	0	\N
320095	574	66714679919853	20057	10052	20	0	\N
320096	604	66714679919853	20057	10052	21	0	\N
320097	628	66714679919853	20057	10052	22	0	\N
320098	638	66714679919853	20057	10052	23	0	\N
320099	951	508339674986889	20057	10052	24	0	\N
320100	1071	910939949755115	20057	10052	25	0	\N
320101	1191	614629496764309	20057	10052	26	0	\N
320102	1317	1712718855121332	20057	10052	27	0	\N
320106	1678	23040756862000	20059	10098	0	0	\N
320107	1874	13486000	20059	10098	1	0	\N
320108	1874	13489000	20059	10098	2	0	\N
320138	1678	23040756870000	20062	10101	0	0	\N
320139	1874	13528000	20062	10101	1	0	\N
320140	1874	13530000	20062	10101	2	0	\N
320141	1678	23040756870000	20063	10101	0	0	\N
320142	1874	13528000	20063	10101	1	0	\N
320143	1874	13530000	20063	10101	2	0	\N
320011	61	66714679919853	20052	10094	5	0	0
320012	67	66714679919853	20052	10094	6	0	0
320013	68	66714679919853	20052	10094	7	0	0
320014	73	66714679919853	20052	10094	8	0	0
320015	81	66714679919853	20052	10094	9	0	0
320017	156	66714679919853	20052	10094	11	0	0
320018	164	66714679919853	20052	10094	12	0	0
320019	220	66714679919853	20052	10094	13	0	0
320020	222	66714679919853	20052	10094	15	0	0
320021	256	66714679919853	20052	10094	16	0	0
320023	428	66714679919853	20052	10094	18	0	0
320024	431	66714679919853	20052	10094	19	0	0
320025	432	66714679919853	20052	10094	20	0	0
320026	433	66714679919853	20052	10094	21	0	0
320028	604	66714679919853	20052	10094	23	0	0
320029	628	66714679919853	20052	10094	24	0	0
320030	638	66714679919853	20052	10094	25	0	0
320031	951	508339674986889	20052	10094	26	0	0
320032	1071	910939949755115	20052	10094	27	0	0
320034	1317	1712718855121332	20052	10094	29	0	0
320035	1874	13469000	20052	10094	30	0	2
320036	1874	13471000	20052	10094	31	0	2
320037	1678	23040756859000	20053	10095	0	0	0
320038	1874	13474000	20053	10095	1	0	2
320040	1678	23040756860000	20054	10096	0	0	0
320041	1874	13477000	20054	10096	1	0	2
320042	1874	13480000	20054	10096	2	0	2
320043	1874	13482000	20054	10096	3	0	2
320073	1672	26642252000000	20056	10097	1	0	5
320074	1874	13484000	20056	10097	2	0	2
320103	1678	23040756862000	20058	10098	0	0	0
320104	1874	13486000	20058	10098	1	0	2
320105	1874	13489000	20058	10098	2	0	2
320110	1678	23040756864000	20060	10099	1	0	0
320111	1678	23040756865000	20060	10099	2	0	0
320112	1678	23040756866000	20060	10099	3	0	0
320113	1874	13491000	20060	10099	4	0	2
320114	1874	13494000	20060	10099	5	0	2
320116	1874	13500000	20060	10099	7	0	2
320117	1874	13503000	20060	10099	8	0	2
320118	1874	13505000	20060	10099	9	0	2
320119	1874	13507000	20060	10099	10	0	2
320121	1874	13509000	20060	10099	12	0	2
320122	1874	13510000	20060	10099	13	0	2
320123	1678	23040756867000	20061	10100	0	0	0
320124	1678	23040756868000	20061	10100	1	0	0
320125	1678	23040756869000	20061	10100	2	0	0
320127	1874	13513000	20061	10100	4	0	2
320128	1874	13516000	20061	10100	5	0	2
320129	581	66618100000000	20061	10100	6	0	0
320130	698	66618100000000	20061	10100	7	0	0
320131	1874	13519000	20061	10100	8	0	2
320133	1874	13521000	20061	10100	10	0	2
320134	1874	13523000	20061	10100	11	0	2
320135	1874	13525000	20061	10100	12	0	2
320136	1672	26642252000000	20061	10100	13	0	5
320144	1678	23040756870000	20064	10101	0	0	0
320147	1678	23040756870000	20065	10101	0	0	\N
320148	1874	13528000	20065	10101	1	0	\N
320149	1678	23040756870000	20066	10101	0	0	\N
320150	1874	13528000	20066	10101	1	0	\N
320151	1874	13530000	20066	10101	2	0	\N
320152	1332	1707114637751650	20067	10083	0	0	\N
320153	2213	650232116779	20067	10083	1	0	\N
320154	1678	23040756846000	20067	10083	2	0	\N
320155	21	32910553770161	20067	10083	3	0	\N
320156	52	66714679919853	20067	10083	4	0	\N
320157	57	66714679919853	20067	10083	5	0	\N
320158	60	66714679919853	20067	10083	6	0	\N
320159	61	66714679919853	20067	10083	7	0	\N
320160	67	66714679919853	20067	10083	8	0	\N
320161	68	66714679919853	20067	10083	9	0	\N
320162	73	66714679919853	20067	10083	10	0	\N
320163	81	66714679919853	20067	10083	11	0	\N
320164	129	66260677919853	20067	10083	12	0	\N
320165	156	66714679919853	20067	10083	13	0	\N
320166	164	66714679919853	20067	10083	14	0	\N
320167	220	66714679919853	20067	10083	15	0	\N
320168	222	66714679919853	20067	10083	16	0	\N
320169	256	66714679919853	20067	10083	17	0	\N
320170	371	66714679919853	20067	10083	18	0	\N
320171	428	66714679919853	20067	10083	19	0	\N
320172	431	66714679919853	20067	10083	20	0	\N
320173	432	66714679919853	20067	10083	21	0	\N
320174	433	66714679919853	20067	10083	22	0	\N
320175	574	66714679919853	20067	10083	23	0	\N
320176	604	66714679919853	20067	10083	24	0	\N
320177	628	66714679919853	20067	10083	25	0	\N
320178	638	66714679919853	20067	10083	26	0	\N
320179	951	508339674986889	20067	10083	27	0	\N
320180	1071	910939949755115	20067	10083	28	0	\N
320181	1191	614629496764309	20067	10083	29	0	\N
320182	1317	1712718855121332	20067	10083	30	0	\N
320183	1874	13407000	20067	10083	31	0	\N
320184	909	507060990769063	20067	10083	32	0	\N
320185	581	66618100000000	20067	10083	33	0	\N
320186	698	66618100000000	20067	10083	34	0	\N
320187	1483	10000000	20067	10083	35	0	\N
320188	1672	25922239000000	20067	10083	36	0	\N
320189	1816	100000000	20067	10083	37	0	\N
320190	742	5048100000000	20067	10083	38	0	\N
320191	1874	13409000	20067	10083	39	0	\N
320192	1874	13411000	20067	10083	40	0	\N
320193	1874	13413000	20067	10083	41	0	\N
320194	1874	13415000	20067	10083	42	0	\N
320195	1874	13417000	20067	10083	43	0	\N
320196	1874	13419000	20067	10083	44	0	\N
320197	1874	13422000	20067	10083	45	0	\N
320198	1874	13425000	20067	10083	46	0	\N
320199	1874	13428000	20067	10083	47	0	\N
320200	2244	200000000	20067	10083	48	0	\N
320201	1672	25922239000000	20067	10083	49	0	\N
320202	1874	13429000	20067	10083	50	0	\N
320203	1874	13430000	20067	10083	51	0	\N
320204	1029	908648950959568	20067	10083	52	0	\N
320205	1874	13433000	20067	10083	53	0	\N
320206	1874	13436000	20067	10083	54	0	\N
320207	1874	13438000	20067	10083	55	0	\N
320208	1874	13440000	20067	10083	56	0	\N
320209	1874	13442000	20067	10083	57	0	\N
320210	1874	13444000	20067	10083	58	0	\N
320211	1874	13446000	20067	10083	59	0	\N
320212	1874	13448000	20067	10083	60	0	\N
320213	1874	13450000	20067	10083	61	0	\N
320214	1874	13452000	20067	10083	62	0	\N
320215	1874	13454000	20067	10083	63	0	\N
320216	1874	13456000	20067	10083	64	0	\N
320217	1874	13458000	20067	10083	65	0	\N
320218	1874	13460000	20067	10083	66	0	\N
320219	1874	13462000	20067	10083	67	0	\N
320220	1874	13464000	20067	10083	68	0	\N
320221	1874	13466000	20067	10083	69	0	\N
320222	1874	13468000	20067	10083	70	0	\N
320223	1874	13470000	20067	10083	71	0	\N
320224	1874	13472000	20067	10083	72	0	\N
320225	1874	13475000	20067	10083	73	0	\N
320226	1874	13478000	20067	10083	74	0	\N
320227	1874	13481000	20067	10083	75	0	\N
320228	1874	13484000	20067	10083	76	0	\N
320229	1874	13487000	20067	10083	77	0	\N
320230	1874	13490000	20067	10083	78	0	\N
320231	1874	13493000	20067	10083	80	0	\N
320232	1874	13496000	20067	10083	81	0	\N
320233	1874	13499000	20067	10083	82	0	\N
320234	1874	13502000	20067	10083	83	0	\N
320235	1874	13505000	20067	10083	84	0	\N
320236	1874	13508000	20067	10083	85	0	\N
320237	1874	13511000	20067	10083	86	0	\N
320238	1874	13514000	20067	10083	87	0	\N
320239	1874	13517000	20067	10083	88	0	\N
320240	1874	13520000	20067	10083	89	0	\N
320241	1874	13523000	20067	10083	90	0	\N
320242	1874	13526000	20067	10083	91	0	\N
320243	1874	13527000	20067	10083	92	0	\N
320244	1874	13528000	20067	10083	93	0	\N
320245	1874	13529000	20067	10083	94	0	\N
320246	1874	13530000	20067	10083	95	0	\N
320247	1678	23040756870000	20068	10101	0	0	\N
320248	1874	13527000	20068	10101	1	0	\N
320253	1678	23040756871000	20070	10102	0	0	\N
320254	1149	613083553321783	20070	10102	1	0	\N
320255	1874	13533000	20070	10102	2	0	\N
320256	1874	13535000	20070	10102	3	0	\N
320261	1678	23040756872000	20072	10103	0	0	\N
320262	1874	13538000	20072	10103	1	0	\N
320263	1874	13540000	20072	10103	2	0	\N
320264	1275	1708411833681314	20072	10103	3	0	\N
320265	1678	23040756872000	20073	10103	0	0	\N
320266	1874	13538000	20073	10103	1	0	\N
320267	1874	13540000	20073	10103	2	0	\N
320268	1275	1708411833681314	20073	10103	3	0	\N
320269	1678	23040756872000	20074	10103	0	0	\N
320270	1874	13538000	20074	10103	1	0	\N
320271	1874	13540000	20074	10103	2	0	\N
320272	1275	1708411833681314	20074	10103	3	0	\N
320276	1678	23040756874000	20076	10105	0	0	\N
320277	1874	13547000	20076	10105	1	0	\N
320278	1874	13550000	20076	10105	2	0	\N
320249	1678	23040756871000	20069	10102	0	0	0
320250	1149	613083553321783	20069	10102	1	0	0
320251	1874	13533000	20069	10102	2	0	2
320252	1874	13535000	20069	10102	3	0	2
320257	1678	23040756872000	20071	10103	0	0	0
320259	1874	13540000	20071	10103	2	0	2
320260	1275	1708411833681314	20071	10103	3	0	0
320273	1678	23040756873000	20075	10104	0	0	0
320274	1874	13543000	20075	10104	1	0	2
320275	1874	13545000	20075	10104	2	0	2
320280	1874	13547000	20077	10105	1	0	2
320290	242	66651405291044	20080	10108	0	0	\N
320291	1222	613662117612488	20080	10108	1	0	\N
320292	982	507539502027242	20080	10108	2	0	\N
320293	1678	23040756877000	20080	10108	3	0	\N
320294	372	66651405291044	20080	10108	4	0	\N
320295	1874	13560000	20080	10108	5	0	\N
320296	1874	13562000	20080	10108	6	0	\N
320318	2246	82779133619	20084	10110	1	0	\N
320319	1678	23040756879000	20084	10110	2	0	\N
320320	22	22510193128616	20084	10110	3	0	\N
320321	190	66544510726895	20084	10110	4	0	\N
320322	1874	13568000	20084	10110	5	0	\N
320323	1874	13571000	20084	10110	6	0	\N
320324	1874	13573000	20084	10110	7	0	\N
320325	2246	82779133619	20085	10110	1	0	\N
320326	1678	23040756879000	20085	10110	2	0	\N
320327	22	22510193128616	20085	10110	3	0	\N
320328	190	66544510726895	20085	10110	4	0	\N
320329	1874	13568000	20085	10110	5	0	\N
320330	1874	13571000	20085	10110	6	0	\N
320331	1874	13573000	20085	10110	7	0	\N
320332	258	66544510726895	20086	10111	0	0	\N
320333	273	66544510726895	20086	10111	1	0	\N
320334	2246	2686431101924	20086	10111	2	0	\N
320335	1678	23040756880000	20086	10111	3	0	\N
320336	292	66544510726895	20086	10111	4	0	\N
320337	293	66544510726895	20086	10111	5	0	\N
320338	333	66209510726895	20086	10111	6	0	\N
320339	376	66544510726895	20086	10111	7	0	\N
320340	426	66544510726895	20086	10111	8	0	\N
320341	429	66544510726895	20086	10111	9	0	\N
320342	1874	13576000	20086	10111	10	0	\N
320343	1874	13578000	20086	10111	11	0	\N
320408	1497	0	20090	10113	0	0	\N
320409	1678	23040756884000	20090	10113	1	0	\N
320410	1874	13597000	20090	10113	2	0	\N
320411	2247	649000000000	20090	10113	3	0	\N
320283	1348	1710024054520435	20078	10106	1	0	0
320284	1874	13552000	20078	10106	2	0	2
320285	1102	909506439034341	20079	10107	0	0	0
320286	1678	23040756876000	20079	10107	1	0	0
320287	1874	13555000	20079	10107	2	0	2
320289	1874	13557000	20079	10107	4	0	2
320297	242	66651405291044	20081	10108	0	0	0
320298	1222	613662117612488	20081	10108	1	0	0
320299	982	507539502027242	20081	10108	2	0	0
320300	1678	23040756877000	20081	10108	3	0	0
320302	1874	13560000	20081	10108	5	0	2
320303	1874	13562000	20081	10108	6	0	2
320304	271	66651405291044	20082	10109	0	0	0
320305	269	66651405291044	20082	10109	1	0	0
320307	1678	23040756878000	20082	10109	3	0	0
320308	1874	13564000	20082	10109	4	0	2
320309	2245	200000000	20082	10109	5	0	0
320310	1874	13567000	20082	10109	7	0	2
320311	2246	82779133619	20083	10110	1	0	0
320313	22	22510193128616	20083	10110	3	0	0
320314	190	66544510726895	20083	10110	4	0	0
320315	1874	13568000	20083	10110	5	0	2
320316	1874	13571000	20083	10110	6	0	2
320317	1874	13573000	20083	10110	7	0	2
320345	273	66544510726895	20087	10111	2	0	0
320346	2246	2686431101924	20087	10111	3	0	0
320347	1678	23040756880000	20087	10111	4	0	0
320348	1678	23040756881000	20087	10111	5	0	0
320350	292	66544510726895	20087	10111	7	0	0
320351	293	66544510726895	20087	10111	8	0	0
320352	333	66209510726895	20087	10111	9	0	2
320353	376	66544510726895	20087	10111	10	0	0
320354	426	66544510726895	20087	10111	11	0	0
320356	430	66544510726895	20087	10111	13	0	0
320357	440	66544510726895	20087	10111	14	0	0
320358	474	66544510726895	20087	10111	15	0	0
320359	475	66544510726895	20087	10111	16	0	0
320360	476	66544510726895	20087	10111	17	0	0
320362	486	66544510726895	20087	10111	19	0	0
320363	490	66544510726895	20087	10111	20	0	0
320364	496	66544510726895	20087	10111	21	0	0
320365	511	66544510726895	20087	10111	22	0	0
320367	522	66544510726895	20087	10111	24	0	0
320368	523	66544510726895	20087	10111	25	0	0
320369	533	66544510726895	20087	10111	26	0	0
320370	539	66544510726895	20087	10111	27	0	0
320371	541	66544510726895	20087	10111	28	0	0
320373	565	66544510726895	20087	10111	30	0	0
320374	1874	13576000	20087	10111	31	0	2
320375	1874	13579000	20087	10111	32	0	2
320376	1874	13582000	20087	10111	33	0	2
320377	2247	9000000000	20087	10111	34	0	0
320379	1874	13585000	20087	10111	36	0	2
320380	1874	13587000	20087	10111	37	0	2
320381	1874	13589000	20087	10111	38	0	2
320382	1607	0	20088	10112	0	0	14
320384	573	66544510726895	20088	10112	2	0	0
320385	576	83285346726895	20088	10112	3	0	4
320386	584	66544510726895	20088	10112	4	0	0
320387	585	66544510726895	20088	10112	5	0	0
320388	589	66544500726895	20088	10112	6	0	1
320390	597	66544510726895	20088	10112	8	0	0
320391	609	66544510726895	20088	10112	9	0	0
320392	1678	23040756883000	20088	10112	10	0	0
320393	1874	13591000	20088	10112	11	0	2
320394	1874	13594000	20088	10112	12	0	2
320396	612	66544510726895	20089	10113	1	0	0
320397	615	66544510726895	20089	10113	2	0	0
320398	616	66544510726895	20089	10113	3	0	0
320399	617	66544510726895	20089	10113	4	0	0
320401	624	66544510726895	20089	10113	6	0	0
320402	625	66544510726895	20089	10113	7	0	0
320403	626	66544510726895	20089	10113	8	0	0
320404	627	66544510726895	20089	10113	9	0	0
320405	629	66544510726895	20089	10113	10	0	0
320407	2247	649000000000	20089	10113	12	0	0
320412	1357	1712398137751650	20091	10114	0	0	0
320413	1678	23040756885000	20091	10114	1	0	0
320414	1111	910769145000000	20091	10114	2	0	0
320415	1231	614514090000000	20091	10114	3	0	0
320431	1357	1712398137751650	20092	10114	0	0	\N
320432	1678	23040756885000	20092	10114	1	0	\N
320433	1111	910769145000000	20092	10114	2	0	\N
320434	1231	614514090000000	20092	10114	3	0	\N
320435	991	508244145000000	20092	10114	4	0	\N
320436	272	67581824000000	20092	10114	5	0	\N
320437	319	66717580000000	20092	10114	6	0	\N
320438	637	66544510726895	20092	10114	7	0	\N
320439	647	66209425788612	20092	10114	8	0	\N
320440	656	66544510726895	20092	10114	9	0	\N
320441	664	66544510726895	20092	10114	10	0	\N
320442	666	66544510726895	20092	10114	11	0	\N
320443	670	66544510726895	20092	10114	12	0	\N
320444	673	66544510726895	20092	10114	13	0	\N
320445	674	66544510726895	20092	10114	14	0	\N
320446	681	66544510726895	20092	10114	15	0	\N
320447	1874	13598000	20092	10114	16	0	\N
320448	1874	13600000	20092	10114	17	0	\N
320449	1874	13603000	20092	10114	18	0	\N
320467	22	22510193128616	20094	10110	2	0	\N
320468	190	66544510726895	20094	10110	3	0	\N
320469	258	66544510726895	20094	10110	4	0	\N
320470	273	66544510726895	20094	10110	5	0	\N
320471	292	66544510726895	20094	10110	6	0	\N
320472	293	66544510726895	20094	10110	7	0	\N
320473	333	66209510726895	20094	10110	8	0	\N
320474	376	66544510726895	20094	10110	9	0	\N
320475	426	66544510726895	20094	10110	10	0	\N
320476	429	66544510726895	20094	10110	11	0	\N
320477	430	66544510726895	20094	10110	12	0	\N
320478	440	66544510726895	20094	10110	13	0	\N
320479	474	66544510726895	20094	10110	14	0	\N
320480	475	66544510726895	20094	10110	15	0	\N
320481	476	66544510726895	20094	10110	16	0	\N
320482	272	68914579000000	20095	10115	0	0	\N
320483	720	2016500325057	20095	10115	1	0	\N
320484	722	2016500325057	20095	10115	2	0	\N
320485	760	1008250162528	20095	10115	3	0	\N
320486	763	1008250162528	20095	10115	4	0	\N
320487	767	1008250162528	20095	10115	5	0	\N
320488	769	1008250162528	20095	10115	6	0	\N
320489	958	507015654801811	20095	10115	7	0	\N
320490	1078	908567040236094	20095	10115	8	0	\N
320491	1198	613028383950321	20095	10115	9	0	\N
320492	1678	23040756886000	20095	10115	10	0	\N
320493	1678	23040756887000	20095	10115	11	0	\N
320494	1324	1708257631862504	20095	10115	12	0	\N
320495	1874	13605000	20095	10115	13	0	\N
320496	1874	13607000	20095	10115	14	0	\N
320497	1874	13610000	20095	10115	15	0	\N
320498	1874	13613000	20095	10115	16	0	\N
320499	1678	23040756888000	20096	10116	0	0	\N
320500	1874	13615000	20096	10116	1	0	\N
320501	1874	13618000	20096	10116	3	0	\N
320509	1678	23040756888000	20098	10116	0	0	\N
320510	1678	23040756889000	20098	10116	1	0	\N
320511	1874	13614000	20098	10116	3	0	\N
320512	1874	13616000	20098	10116	4	0	\N
320513	1874	13618000	20098	10116	5	0	\N
320514	1874	13621000	20098	10116	6	0	\N
320515	1874	13624000	20098	10116	7	0	\N
320528	1484	0	20100	10117	0	0	\N
320529	2142	4630001000000	20100	10117	1	0	\N
320530	1678	23040756890000	20100	10117	2	0	\N
320531	1678	23040756891000	20100	10117	3	0	\N
320532	1678	23040756892000	20100	10117	4	0	\N
320533	1874	13626000	20100	10117	5	0	\N
320534	1874	13627000	20100	10117	6	0	\N
320535	1874	13629000	20100	10117	7	0	\N
320536	1874	13631000	20100	10117	8	0	\N
320537	1874	13634000	20100	10117	9	0	\N
320538	1874	13637000	20100	10117	10	0	\N
320539	1874	13640000	20100	10117	11	0	\N
320551	1460	0	20102	10118	0	0	\N
320552	976	507233775000000	20102	10118	1	0	\N
320419	637	66544510726895	20091	10114	7	0	0
320420	647	66209425788612	20091	10114	8	0	2
320421	656	66544510726895	20091	10114	9	0	0
320422	664	66544510726895	20091	10114	10	0	0
320423	666	66544510726895	20091	10114	11	0	0
320425	673	66544510726895	20091	10114	13	0	0
320426	674	66544510726895	20091	10114	14	0	0
320427	681	66544510726895	20091	10114	15	0	0
320428	1874	13598000	20091	10114	16	0	2
320429	1874	13600000	20091	10114	17	0	2
320450	272	68914579000000	20093	10115	0	0	0
320451	720	2016500325057	20093	10115	1	0	0
320452	722	2016500325057	20093	10115	2	0	0
320453	760	1008250162528	20093	10115	3	0	0
320455	767	1008250162528	20093	10115	5	0	0
320456	769	1008250162528	20093	10115	6	0	0
320457	958	507015654801811	20093	10115	7	0	0
320458	1078	908567040236094	20093	10115	8	0	0
320459	1198	613028383950321	20093	10115	9	0	0
320461	1678	23040756887000	20093	10115	11	0	0
320462	1324	1708257631862504	20093	10115	12	0	0
320463	1874	13605000	20093	10115	13	0	2
320464	1874	13607000	20093	10115	14	0	2
320465	1874	13610000	20093	10115	15	0	2
320502	1678	23040756888000	20097	10116	0	0	0
320503	1678	23040756889000	20097	10116	1	0	0
320504	1874	13614000	20097	10116	3	0	2
320505	1874	13616000	20097	10116	4	0	2
320507	1874	13621000	20097	10116	6	0	2
320508	1874	13624000	20097	10116	7	0	2
320516	1484	0	20099	10117	0	0	0
320517	2142	4630001000000	20099	10117	1	0	2
320518	1678	23040756890000	20099	10117	2	0	0
320520	1678	23040756892000	20099	10117	4	0	0
320521	1874	13626000	20099	10117	5	0	2
320522	1874	13627000	20099	10117	6	0	2
320523	1874	13629000	20099	10117	7	0	2
320524	1874	13631000	20099	10117	8	0	2
320526	1874	13637000	20099	10117	10	0	2
320527	1874	13640000	20099	10117	11	0	2
320540	1460	0	20101	10118	0	0	0
320541	976	507233775000000	20101	10118	1	0	0
320543	1216	613292750000000	20101	10118	3	0	0
320544	1342	1708990637751650	20101	10118	4	0	0
320545	1678	23040756893000	20101	10118	5	0	0
320546	1678	23040756894000	20101	10118	6	0	0
320547	1874	13642000	20101	10118	7	0	2
320549	1874	13648000	20101	10118	9	0	2
320550	1874	13650000	20101	10118	10	0	2
320553	1096	908957465000000	20102	10118	2	0	\N
320554	1216	613292750000000	20102	10118	3	0	\N
320555	1342	1708990637751650	20102	10118	4	0	\N
320556	1678	23040756893000	20102	10118	5	0	\N
320557	1678	23040756894000	20102	10118	6	0	\N
320558	1874	13642000	20102	10118	7	0	\N
320559	1874	13645000	20102	10118	8	0	\N
320560	1874	13648000	20102	10118	9	0	\N
320561	1874	13650000	20102	10118	10	0	\N
320562	1371	1710570537751650	20103	10119	0	0	\N
320563	1678	23040756895000	20103	10119	1	0	\N
320564	1125	909797565000000	20103	10119	2	0	\N
320565	1245	613858650000000	20103	10119	3	0	\N
320566	1005	507701875000000	20103	10119	4	0	\N
320567	538	67580540000000	20103	10119	5	0	\N
320568	1874	13652000	20103	10119	6	0	\N
320569	1874	13655000	20103	10119	7	0	\N
320570	1874	13656000	20103	10119	8	0	\N
320580	1371	1710570537751650	20105	10119	0	0	\N
320581	1678	23040756895000	20105	10119	1	0	\N
320582	1125	909797565000000	20105	10119	2	0	\N
320583	1245	613858650000000	20105	10119	3	0	\N
320584	1005	507701875000000	20105	10119	4	0	\N
320585	538	67580540000000	20105	10119	5	0	\N
320586	1874	13652000	20105	10119	6	0	\N
320587	1874	13655000	20105	10119	7	0	\N
320588	1874	13656000	20105	10119	8	0	\N
320589	1371	1710570537751650	20106	10119	0	0	\N
320590	1678	23040756895000	20106	10119	1	0	\N
320591	1125	909797565000000	20106	10119	2	0	\N
320592	1245	613858650000000	20106	10119	3	0	\N
320593	1005	507701875000000	20106	10119	4	0	\N
320594	538	67580540000000	20106	10119	5	0	\N
320595	1874	13652000	20106	10119	6	0	\N
320596	1874	13655000	20106	10119	7	0	\N
320597	1874	13656000	20106	10119	8	0	\N
320598	538	68588677000000	20107	10120	0	0	\N
320599	1678	23040756896000	20107	10120	1	0	\N
320600	1874	13659000	20107	10120	2	0	\N
320601	1874	13661000	20107	10120	3	0	\N
320623	1365	1710262743410483	20114	10126	0	0	\N
320624	1119	909633389928309	20114	10126	1	0	\N
320625	1239	613747773910318	20114	10126	2	0	\N
320626	1678	23040756901000	20114	10126	3	0	\N
320627	1874	13685000	20114	10126	4	0	\N
320628	1874	13688000	20114	10126	5	0	\N
320629	1874	13690000	20114	10126	6	0	\N
320630	1382	1712413637751650	20116	9969	0	0	\N
320631	1136	910778465000000	20116	9969	1	0	\N
320632	1256	614519750000000	20116	9969	2	0	\N
320633	1016	508248775000000	20116	9969	3	0	\N
320634	1365	1710262743410483	20116	9969	4	0	\N
320652	1016	508248775000000	20120	10129	0	0	\N
320653	1678	23040756904000	20120	10129	1	0	\N
320654	1678	23040756905000	20120	10129	2	0	\N
320655	1874	13703000	20120	10129	3	0	\N
320656	1874	13706000	20120	10129	4	0	\N
320657	1874	13708000	20120	10129	5	0	\N
320658	1874	13710000	20120	10129	6	0	\N
320674	365	66617801000000	20123	10130	0	0	\N
320675	1678	23040756906000	20123	10130	1	0	\N
320676	1678	23040756907000	20123	10130	2	0	\N
320677	1874	13712000	20123	10130	3	0	\N
320678	1874	13714000	20123	10130	4	0	\N
320679	1352	1710877257751650	20123	10130	5	0	\N
320680	1874	13717000	20123	10130	6	0	\N
320681	1874	13720000	20123	10130	7	0	\N
320573	1125	909797565000000	20104	10119	2	0	0
320574	1245	613858650000000	20104	10119	3	0	0
320575	1005	507701875000000	20104	10119	4	0	0
320576	538	67580540000000	20104	10119	5	0	0
320577	1874	13652000	20104	10119	6	0	2
320579	1874	13656000	20104	10119	8	0	2
320602	538	68588677000000	20108	10120	0	0	0
320603	1678	23040756896000	20108	10120	1	0	0
320604	1874	13659000	20108	10120	2	0	2
320605	1874	13661000	20108	10120	3	0	2
320607	1874	13663000	20109	10121	1	0	2
320608	1874	13665000	20110	10122	0	0	2
320609	1874	13668000	20110	10122	1	0	2
320610	1382	1712413637751650	20111	10123	0	0	0
320612	1256	614519750000000	20111	10123	2	0	0
320613	1678	23040756898000	20111	10123	3	0	0
320614	1874	13670000	20111	10123	4	0	2
320615	1874	13673000	20111	10123	5	0	2
320616	1874	13674000	20111	10123	6	0	2
320618	1874	13677000	20112	10124	1	0	2
320619	1678	23040756900000	20113	10125	0	0	0
320620	1874	13680000	20113	10125	1	0	2
320621	1874	13682000	20113	10125	2	0	2
320622	1874	13684000	20113	10125	3	0	2
320636	1119	909633389928309	20117	10126	1	0	0
320637	1239	613747773910318	20117	10126	2	0	0
320638	1678	23040756901000	20117	10126	3	0	0
320639	1874	13685000	20117	10126	4	0	2
320641	1874	13690000	20117	10126	6	0	2
320642	1678	23040756902000	20118	10127	0	0	0
320643	999	507610345498755	20118	10127	1	0	0
320644	986	507792735000000	20118	10127	2	0	0
320645	1106	909960255000000	20118	10127	3	0	0
320647	1874	13692000	20118	10127	5	0	2
320648	1874	13695000	20118	10127	6	0	2
320649	1678	23040756903000	20119	10128	0	0	0
320650	1874	13697000	20119	10128	1	0	2
320651	1874	13700000	20119	10128	2	0	2
320660	1678	23040756904000	20121	10129	1	0	0
320661	1678	23040756905000	20121	10129	2	0	0
320662	1874	13703000	20121	10129	3	0	2
320663	1874	13706000	20121	10129	4	0	2
320665	1874	13710000	20121	10129	6	0	2
320666	365	66617801000000	20122	10130	0	0	2
320667	1678	23040756906000	20122	10130	1	0	0
320668	1678	23040756907000	20122	10130	2	0	0
320669	1874	13712000	20122	10130	3	0	2
320671	1352	1710877257751650	20122	10130	5	0	0
320672	1874	13717000	20122	10130	6	0	2
320673	1874	13720000	20122	10130	7	0	2
320682	365	66715801000000	20124	10131	0	0	2
320683	365	66716501000000	20124	10131	1	0	2
320685	1067	909143245000000	20124	10131	3	0	0
320686	1187	613417050000000	20124	10131	4	0	0
320687	947	507336815000000	20124	10131	5	0	0
320688	365	66717301000000	20125	10132	0	0	2
320696	365	66717301000000	20126	10132	0	0	\N
320697	1678	23040756908000	20126	10132	1	0	\N
320698	1678	23040756909000	20126	10132	2	0	\N
320699	1678	23040756910000	20126	10132	3	0	\N
320700	1874	13723000	20126	10132	4	0	\N
320701	2007	1937313000000	20126	10132	5	0	\N
320702	1874	13725000	20126	10132	6	0	\N
320703	1874	13727000	20126	10132	7	0	\N
320704	1874	13729000	20126	10132	8	0	\N
320705	1874	13732000	20126	10132	9	0	\N
320706	1874	13735000	20126	10132	10	0	\N
320707	365	66717301000000	20127	10132	0	0	\N
320708	1678	23040756908000	20127	10132	1	0	\N
320709	1678	23040756909000	20127	10132	2	0	\N
320710	1678	23040756910000	20127	10132	3	0	\N
320711	1874	13723000	20127	10132	4	0	\N
320712	2007	1937313000000	20127	10132	5	0	\N
320713	1874	13725000	20127	10132	6	0	\N
320714	1874	13727000	20127	10132	7	0	\N
320715	1874	13729000	20127	10132	8	0	\N
320716	1874	13732000	20127	10132	9	0	\N
320717	1874	13735000	20127	10132	10	0	\N
320718	1678	23040756911000	20128	10133	0	0	\N
320719	956	506972775000000	20128	10133	1	0	\N
320720	1874	13732000	20128	10133	2	0	\N
320721	1874	13734000	20128	10133	3	0	\N
320722	1874	13736000	20128	10133	4	0	\N
320723	1874	13738000	20128	10133	5	0	\N
320724	1874	13740000	20128	10133	6	0	\N
320725	1678	23040756911000	20129	10133	0	0	\N
320726	956	506972775000000	20129	10133	1	0	\N
320727	1874	13732000	20129	10133	2	0	\N
320728	1874	13734000	20129	10133	3	0	\N
320729	1874	13736000	20129	10133	4	0	\N
320730	1874	13738000	20129	10133	5	0	\N
320731	1874	13740000	20129	10133	6	0	\N
320732	1678	23040756911000	20130	10133	0	0	\N
320733	956	506972775000000	20130	10133	1	0	\N
320734	1874	13732000	20130	10133	2	0	\N
320735	1874	13734000	20130	10133	3	0	\N
320736	1874	13736000	20130	10133	4	0	\N
320737	1874	13738000	20130	10133	5	0	\N
320738	1874	13740000	20130	10133	6	0	\N
320752	1678	23040756912000	20133	10134	0	0	\N
320753	1076	908490465000000	20133	10134	1	0	\N
320754	1196	612976750000000	20133	10134	2	0	\N
320755	1322	1708113637751650	20133	10134	3	0	\N
320756	1874	13742000	20133	10134	4	0	\N
320757	1874	13745000	20133	10134	5	0	\N
320758	1678	23040756913000	20134	10135	0	0	\N
320759	260	68399600999959	20134	10135	1	0	\N
320760	1678	23040756914000	20134	10135	2	0	\N
320761	1678	23040756915000	20134	10135	3	0	\N
320762	1874	13747000	20134	10135	4	0	\N
320763	1874	13749000	20134	10135	5	0	\N
320764	1874	13751000	20134	10135	6	0	\N
320765	1874	13754000	20134	10135	7	0	\N
320766	1874	13757000	20134	10135	8	0	\N
320767	1874	13760000	20134	10135	9	0	\N
320768	1678	23040756913000	20135	10135	0	0	\N
320769	260	68399600999959	20135	10135	1	0	\N
320770	1678	23040756914000	20135	10135	2	0	\N
320771	1678	23040756915000	20135	10135	3	0	\N
320772	1874	13747000	20135	10135	4	0	\N
320773	1874	13749000	20135	10135	5	0	\N
320774	1874	13751000	20135	10135	6	0	\N
320775	1874	13754000	20135	10135	7	0	\N
320776	1874	13757000	20135	10135	8	0	\N
320777	1874	13760000	20135	10135	9	0	\N
320793	1678	23040756917000	20139	10137	0	0	\N
320794	1874	13765000	20139	10137	1	0	\N
320795	1874	13767000	20139	10137	2	0	\N
320796	1678	23040756917000	20140	10137	0	0	\N
320797	1874	13765000	20140	10137	1	0	\N
320798	1874	13767000	20140	10137	2	0	\N
320799	1678	23040756917000	20141	10137	0	0	\N
320800	1874	13765000	20141	10137	1	0	\N
320801	1874	13767000	20141	10137	2	0	\N
320813	1249	611783750000000	20144	10139	0	0	\N
320814	1678	23040756919000	20144	10139	1	0	\N
320815	1276	1710695727448440	20144	10139	2	0	\N
320816	1874	13774000	20144	10139	3	0	\N
320817	1874	13777000	20144	10139	4	0	\N
320818	1249	611783750000000	20145	10139	0	0	\N
320819	1678	23040756919000	20145	10139	1	0	\N
320820	1276	1710695727448440	20145	10139	2	0	\N
320821	1874	13774000	20145	10139	3	0	\N
320822	1874	13777000	20145	10139	4	0	\N
320823	1249	611783750000000	20146	10139	0	0	\N
320824	1678	23040756919000	20146	10139	1	0	\N
320691	1678	23040756910000	20125	10132	3	0	0
320692	1874	13723000	20125	10132	4	0	2
320693	2007	1937313000000	20125	10132	5	0	0
320694	1874	13726000	20125	10132	6	0	2
320695	1874	13729000	20125	10132	7	0	2
320740	956	506972775000000	20131	10133	1	0	0
320741	1874	13732000	20131	10133	2	0	2
320742	1874	13734000	20131	10133	3	0	2
320743	1874	13736000	20131	10133	4	0	2
320744	1874	13738000	20131	10133	5	0	2
320746	1678	23040756912000	20132	10134	0	0	0
320747	1076	908490465000000	20132	10134	1	0	0
320748	1196	612976750000000	20132	10134	2	0	0
320749	1322	1708113637751650	20132	10134	3	0	0
320751	1874	13745000	20132	10134	5	0	2
320778	1678	23040756913000	20136	10135	0	0	0
320779	260	68399600999959	20136	10135	1	0	0
320780	1678	23040756914000	20136	10135	2	0	0
320781	1678	23040756915000	20136	10135	3	0	0
320783	1874	13749000	20136	10135	5	0	2
320784	1874	13751000	20136	10135	6	0	2
320785	1874	13754000	20136	10135	7	0	2
320786	1874	13757000	20136	10135	8	0	2
320787	1874	13760000	20136	10135	9	0	2
320789	1874	13762000	20137	10136	1	0	2
320790	1678	23040756917000	20138	10137	0	0	0
320791	1874	13765000	20138	10137	1	0	2
320792	1874	13767000	20138	10137	2	0	2
320803	1129	906722465000000	20142	10138	1	0	0
320804	1678	23040756918000	20142	10138	2	0	0
320805	1874	13770000	20142	10138	3	0	2
320806	1874	13772000	20142	10138	4	0	2
320807	1249	611783750000000	20143	10139	0	0	0
320809	1678	23040756919000	20143	10139	2	0	0
320810	1276	1710695727448440	20143	10139	3	0	0
320811	1874	13774000	20143	10139	4	0	2
320812	1874	13777000	20143	10139	5	0	2
320825	1276	1710695727448440	20146	10139	2	0	\N
320826	1874	13774000	20146	10139	3	0	\N
320827	1874	13777000	20146	10139	4	0	\N
320828	1009	505985775000000	20147	10123	0	0	\N
320829	1129	906722465000000	20147	10123	1	0	\N
320830	1249	611783750000000	20147	10123	2	0	\N
320831	1375	1704789637751650	20147	10123	3	0	\N
320832	365	66667801000000	20147	10123	4	0	\N
320833	365	66668501000000	20147	10123	5	0	\N
320834	365	66716501000000	20147	10123	6	0	\N
320835	365	66717301000000	20147	10123	7	0	\N
320836	1382	1712413637751650	20147	10123	8	0	\N
320837	1136	910778465000000	20147	10123	9	0	\N
320838	1256	614519750000000	20147	10123	10	0	\N
320839	1016	508248775000000	20147	10123	11	0	\N
320840	1365	1710262743410483	20147	10123	12	0	\N
320841	1313	1709341167751650	20147	10123	13	0	\N
320842	1067	909143245000000	20147	10123	14	0	\N
320843	1678	23040756898000	20147	10123	15	0	\N
320844	1678	23040756899000	20147	10123	16	0	\N
320845	1119	909633389928309	20147	10123	17	0	\N
320846	1239	613747773910318	20147	10123	18	0	\N
320847	1187	613417050000000	20147	10123	19	0	\N
320848	947	507336815000000	20147	10123	20	0	\N
320849	260	67534770000000	20147	10123	21	0	\N
320850	1276	1710695727448440	20147	10123	22	0	\N
320851	999	507610345498755	20147	10123	23	0	\N
320852	1678	23040756900000	20147	10123	24	0	\N
320853	1678	23040756901000	20147	10123	25	0	\N
320854	1678	23040756902000	20147	10123	26	0	\N
320855	1678	23040756903000	20147	10123	27	0	\N
320856	1678	23040756904000	20147	10123	28	0	\N
320857	1678	23040756905000	20147	10123	29	0	\N
320858	1678	23040756906000	20147	10123	30	0	\N
320859	1678	23040756907000	20147	10123	31	0	\N
320860	1678	23040756908000	20147	10123	32	0	\N
320861	1678	23040756909000	20147	10123	33	0	\N
320862	1678	23040756910000	20147	10123	34	0	\N
320863	1678	23040756911000	20147	10123	35	0	\N
320864	1678	23040756912000	20147	10123	36	0	\N
320865	1678	23040756913000	20147	10123	37	0	\N
320866	1678	23040756914000	20147	10123	38	0	\N
320867	1678	23040756915000	20147	10123	39	0	\N
320868	1678	23040756916000	20147	10123	40	0	\N
320869	1678	23040756917000	20147	10123	41	0	\N
320870	1678	23040756918000	20147	10123	42	0	\N
320871	1678	23040756919000	20147	10123	43	0	\N
320872	956	506972775000000	20147	10123	44	0	\N
320873	1076	908490465000000	20147	10123	45	0	\N
320874	1196	612976750000000	20147	10123	46	0	\N
320875	1322	1708113637751650	20147	10123	47	0	\N
320876	1874	13670000	20147	10123	48	0	\N
320877	986	507792735000000	20147	10123	49	0	\N
320878	1106	909960255000000	20147	10123	50	0	\N
320879	1226	613968310000000	20147	10123	51	0	\N
320880	1352	1710877257751650	20147	10123	52	0	\N
320881	2007	1937313000000	20147	10123	53	0	\N
320882	1874	13673000	20147	10123	54	0	\N
320883	1874	13676000	20147	10123	55	0	\N
320884	1874	13679000	20147	10123	56	0	\N
320885	1874	13682000	20147	10123	57	0	\N
320886	1874	13685000	20147	10123	58	0	\N
320887	1874	13686000	20147	10123	59	0	\N
320888	1874	13687000	20147	10123	60	0	\N
320889	1874	13689000	20147	10123	61	0	\N
320890	1874	13691000	20147	10123	62	0	\N
320891	1874	13693000	20147	10123	63	0	\N
320892	1874	13695000	20147	10123	64	0	\N
320893	1874	13697000	20147	10123	65	0	\N
320894	1874	13700000	20147	10123	66	0	\N
320895	1874	13703000	20147	10123	67	0	\N
320896	1874	13706000	20147	10123	69	0	\N
320897	1874	13709000	20147	10123	70	0	\N
320898	1874	13712000	20147	10123	71	0	\N
320899	1874	13715000	20147	10123	72	0	\N
320900	1874	13718000	20147	10123	73	0	\N
320901	1874	13721000	20147	10123	74	0	\N
320902	1874	13724000	20147	10123	75	0	\N
320903	1874	13727000	20147	10123	76	0	\N
320904	1874	13730000	20147	10123	77	0	\N
320905	1874	13733000	20147	10123	78	0	\N
320906	1874	13736000	20147	10123	79	0	\N
320907	1874	13739000	20147	10123	80	0	\N
320908	1874	13742000	20147	10123	81	0	\N
320909	1874	13745000	20147	10123	82	0	\N
320910	1874	13747000	20147	10123	83	0	\N
320911	1874	13749000	20147	10123	84	0	\N
320912	1874	13751000	20147	10123	85	0	\N
320913	1874	13753000	20147	10123	86	0	\N
320914	1874	13755000	20147	10123	87	0	\N
320915	1874	13757000	20147	10123	88	0	\N
320916	1874	13759000	20147	10123	89	0	\N
320917	1874	13761000	20147	10123	90	0	\N
320918	1874	13763000	20147	10123	91	0	\N
320919	1874	13765000	20147	10123	92	0	\N
320920	1874	13767000	20147	10123	93	0	\N
320921	1874	13769000	20147	10123	94	0	\N
320922	1874	13771000	20147	10123	95	0	\N
320923	1874	13773000	20147	10123	96	0	\N
320924	1874	13775000	20147	10123	97	0	\N
320925	1874	13777000	20147	10123	98	0	\N
320929	1678	23040756921000	20149	10141	0	0	\N
320930	1874	13785000	20149	10141	1	0	\N
320931	1874	13787000	20149	10141	2	0	\N
320954	1678	23040756927000	20156	10146	0	0	\N
320955	1874	13814000	20156	10146	1	0	\N
320956	1874	13817000	20156	10146	2	0	\N
320957	1678	23040756928000	20157	10147	0	0	\N
320958	1678	23040756929000	20157	10147	1	0	\N
320959	1874	13820000	20157	10147	2	0	\N
320960	1874	13823000	20157	10147	3	0	\N
320928	1874	13782000	20148	10140	2	0	2
320932	1678	23040756921000	20150	10141	0	0	0
320933	1874	13785000	20150	10141	1	0	2
320934	1874	13787000	20150	10141	2	0	2
320935	1678	23040756922000	20151	10142	0	0	0
320937	1874	13792000	20151	10142	2	0	2
320938	1678	23040756923000	20152	10143	0	0	0
320939	548	66720000000000	20152	10143	1	0	0
320940	1874	13795000	20152	10143	2	0	2
320941	1874	13797000	20152	10143	3	0	2
320943	1678	23040756925000	20153	10144	1	0	0
320944	1874	13799000	20153	10144	2	0	2
320945	1874	13802000	20153	10144	3	0	2
320946	1874	13805000	20153	10144	4	0	2
320948	1678	23040756926000	20154	10145	0	0	0
320949	1874	13810000	20154	10145	1	0	2
320950	1874	13812000	20154	10145	2	0	2
320951	1678	23040756927000	20155	10146	0	0	0
320952	1874	13814000	20155	10146	1	0	2
320961	1874	13825000	20157	10147	4	0	\N
320962	1874	13827000	20157	10147	5	0	\N
320993	948	507975167870000	20161	10149	0	0	\N
320994	1068	910287148470000	20161	10149	1	0	\N
320995	1188	614188877840000	20161	10149	2	0	\N
320996	1314	1711491918671650	20161	10149	3	0	\N
320997	1678	23040756934000	20161	10149	4	0	\N
320998	1153	611805340660000	20161	10149	5	0	\N
320999	1874	13850000	20161	10149	6	0	\N
321000	1874	13852000	20161	10149	7	0	\N
321001	1773	15732844699931	20161	10149	8	0	\N
321002	1484	0	20162	10084	0	0	\N
321003	1497	0	20162	10084	1	0	\N
321004	1009	505985775000000	20162	10084	2	0	\N
321005	1129	906722465000000	20162	10084	3	0	\N
321006	1249	611783750000000	20162	10084	4	0	\N
321007	1375	1704789637751650	20162	10084	5	0	\N
321008	365	66667801000000	20162	10084	6	0	\N
321009	365	66668501000000	20162	10084	7	0	\N
321010	365	66716501000000	20162	10084	8	0	\N
321011	365	66717301000000	20162	10084	9	0	\N
321012	1382	1712413637751650	20162	10084	11	0	\N
321013	1136	910778465000000	20162	10084	12	0	\N
321014	1256	614519750000000	20162	10084	13	0	\N
321015	1016	508248775000000	20162	10084	14	0	\N
321016	1357	1712398137751650	20162	10084	15	0	\N
321017	1365	1710262743410483	20162	10084	16	0	\N
321018	913	506003823451523	20162	10084	17	0	\N
321019	1460	0	20162	10084	18	0	\N
321020	976	507233775000000	20162	10084	19	0	\N
321021	1222	613662117612488	20162	10084	20	0	\N
321022	948	507975167870000	20162	10084	21	0	\N
321023	1068	910287148470000	20162	10084	22	0	\N
321024	1313	1709341167751650	20162	10084	23	0	\N
321025	1067	909143245000000	20162	10084	24	0	\N
321026	1119	909633389928309	20162	10084	25	0	\N
321027	1239	613747773910318	20162	10084	26	0	\N
321028	1111	910769145000000	20162	10084	27	0	\N
321029	1231	614514090000000	20162	10084	28	0	\N
321030	991	508244145000000	20162	10084	29	0	\N
321031	272	67581824000000	20162	10084	30	0	\N
321032	319	66717580000000	20162	10084	31	0	\N
321033	272	68914579000000	20162	10084	32	0	\N
321034	1096	908957465000000	20162	10084	33	0	\N
321035	1216	613292750000000	20162	10084	34	0	\N
321036	1342	1708990637751650	20162	10084	35	0	\N
321037	1371	1710570537751650	20162	10084	36	0	\N
321038	1188	614188877840000	20162	10084	37	0	\N
321039	1314	1711491918671650	20162	10084	38	0	\N
321040	1348	1710024054520435	20162	10084	40	0	\N
321041	982	507539502027242	20162	10084	41	0	\N
321042	271	66651395291044	20162	10084	42	0	\N
321043	269	66651405291044	20162	10084	43	0	\N
321044	577	66651405291044	20162	10084	44	0	\N
321045	2246	2602651968305	20162	10084	45	0	\N
321046	1102	909506439034341	20162	10084	46	0	\N
321047	242	66651405291044	20162	10084	47	0	\N
321048	1187	613417050000000	20162	10084	48	0	\N
321049	947	507336815000000	20162	10084	49	0	\N
321050	260	67534770000000	20162	10084	50	0	\N
321051	1276	1710695727448440	20162	10084	51	0	\N
321052	22	22510193128616	20162	10084	52	0	\N
321053	190	66544510726895	20162	10084	53	0	\N
321054	258	66544510726895	20162	10084	54	0	\N
321055	273	66544510726895	20162	10084	55	0	\N
321056	999	507610345498755	20162	10084	56	0	\N
321057	292	66544510726895	20162	10084	57	0	\N
321058	293	66544510726895	20162	10084	58	0	\N
321059	333	66209510726895	20162	10084	59	0	\N
321060	376	66544510726895	20162	10084	60	0	\N
321061	426	66544510726895	20162	10084	61	0	\N
321062	429	66544510726895	20162	10084	62	0	\N
321063	430	66544510726895	20162	10084	63	0	\N
321064	440	66544510726895	20162	10084	64	0	\N
321065	474	66544510726895	20162	10084	65	0	\N
321066	475	66544510726895	20162	10084	66	0	\N
321067	476	66544510726895	20162	10084	67	0	\N
321068	483	66544510726895	20162	10084	68	0	\N
321069	486	66544510726895	20162	10084	69	0	\N
321070	490	66544510726895	20162	10084	70	0	\N
321071	496	66544510726895	20162	10084	71	0	\N
321072	511	66544510726895	20162	10084	72	0	\N
321073	512	66544510726895	20162	10084	73	0	\N
321074	522	66544510726895	20162	10084	74	0	\N
321075	523	66544510726895	20162	10084	75	0	\N
321076	533	66544510726895	20162	10084	76	0	\N
321077	539	66544510726895	20162	10084	77	0	\N
321078	541	66544510726895	20162	10084	78	0	\N
321079	558	66243200726895	20162	10084	79	0	\N
321080	565	66544510726895	20162	10084	80	0	\N
321081	572	66544510726895	20162	10084	81	0	\N
321082	573	66544510726895	20162	10084	82	0	\N
321083	576	83285346726895	20162	10084	83	0	\N
321084	584	66544510726895	20162	10084	84	0	\N
321085	585	66544510726895	20162	10084	85	0	\N
321086	589	66544500726895	20162	10084	86	0	\N
321087	595	66544510726895	20162	10084	87	0	\N
321088	597	66544510726895	20162	10084	88	0	\N
321089	609	66544510726895	20162	10084	89	0	\N
321090	612	66544510726895	20162	10084	90	0	\N
321091	615	66544510726895	20162	10084	91	0	\N
321092	616	66544510726895	20162	10084	92	0	\N
321093	617	66544510726895	20162	10084	93	0	\N
321094	624	66544510726895	20162	10084	94	0	\N
321095	625	66544510726895	20162	10084	95	0	\N
321096	626	66544510726895	20162	10084	96	0	\N
320965	1874	13820000	20158	10147	2	0	2
320966	1874	13823000	20158	10147	3	0	2
320967	1874	13825000	20158	10147	4	0	2
320968	1874	13827000	20158	10147	5	0	2
320969	913	506003823451523	20159	10148	0	0	0
320971	1678	23040756931000	20159	10148	2	0	0
320972	1678	23040756932000	20159	10148	3	0	0
320973	1678	23040756933000	20159	10148	4	0	0
320974	1773	7990000000000	20159	10148	5	0	30
320975	1773	13749000000000	20159	10148	6	0	30
320977	1874	13833000	20159	10148	8	0	2
320978	1874	13836000	20159	10148	9	0	2
320979	1874	13838000	20159	10148	10	0	2
320980	1874	13840000	20159	10148	11	0	2
320982	1874	13844000	20159	10148	13	0	2
320983	1874	13847000	20159	10148	14	0	2
320984	948	507975167870000	20160	10149	0	0	0
320985	1068	910287148470000	20160	10149	1	0	0
320986	1188	614188877840000	20160	10149	2	0	0
320988	1678	23040756934000	20160	10149	4	0	0
320989	1153	611805340660000	20160	10149	5	0	0
320990	1874	13850000	20160	10149	6	0	2
320991	1874	13852000	20160	10149	7	0	2
320992	1773	15732844699931	20160	10149	8	0	30
321097	627	66544510726895	20162	10084	97	0	\N
321098	629	66544510726895	20162	10084	98	0	\N
321099	637	66544510726895	20162	10084	99	0	\N
321100	647	66209425788612	20162	10084	100	0	\N
321101	656	66544510726895	20162	10084	101	0	\N
321102	664	66544510726895	20162	10084	102	0	\N
321103	666	66544510726895	20162	10084	103	0	\N
321104	670	66544510726895	20162	10084	104	0	\N
321105	673	66544510726895	20162	10084	105	0	\N
321106	674	66544510726895	20162	10084	106	0	\N
321107	681	66544510726895	20162	10084	107	0	\N
321108	720	2016500325057	20162	10084	108	0	\N
321109	722	2016500325057	20162	10084	110	0	\N
321110	760	1008250162528	20162	10084	111	0	\N
321111	763	1008250162528	20162	10084	112	0	\N
321112	767	1008250162528	20162	10084	113	0	\N
321113	769	1008250162528	20162	10084	114	0	\N
321114	958	507015654801811	20162	10084	115	0	\N
321115	1078	908567040236094	20162	10084	116	0	\N
321116	1198	613028383950321	20162	10084	117	0	\N
321117	1324	1708257631862504	20162	10084	118	0	\N
321118	2142	4629991000000	20162	10084	119	0	\N
321119	372	66651405291044	20162	10084	120	0	\N
321120	2246	2686431101924	20162	10084	121	0	\N
321121	1125	909797565000000	20162	10084	122	0	\N
321122	1245	613858650000000	20162	10084	123	0	\N
321123	1005	507701875000000	20162	10084	124	0	\N
321124	182	66770027864240	20163	10150	0	0	\N
321125	1678	23040756935000	20163	10150	1	0	\N
321126	702	44513351909515	20163	10150	2	0	\N
321127	927	508636168253115	20163	10150	3	0	\N
321128	1047	911471655514890	20163	10150	4	0	\N
321129	1167	613988087331615	20163	10150	5	0	\N
321130	1293	1713718989828080	20163	10150	6	0	\N
321131	1874	13854000	20163	10150	7	0	\N
321132	1874	13857000	20163	10150	8	0	\N
321133	1874	13860000	20163	10150	9	0	\N
321134	1033	906754515920000	20163	10150	10	0	\N
321135	1279	1704849979141650	20163	10150	11	0	\N
321136	1874	13862000	20163	10150	12	0	\N
321176	1124	910301631000000	20166	10152	0	0	\N
321177	1678	23040756940000	20166	10152	1	0	\N
321178	1876	703463880000	20166	10152	2	0	\N
321179	1874	13884000	20166	10152	3	0	\N
321180	1874	13885000	20166	10152	4	0	\N
321181	1874	13888000	20166	10152	5	0	\N
321197	104	66915395942306	20169	10153	0	0	\N
321198	1244	614198650000000	20169	10153	1	0	\N
321199	1678	23040756941000	20169	10153	2	0	\N
321200	1678	23040756942000	20169	10153	3	0	\N
321201	1963	733509120000	20169	10153	4	0	\N
321202	1874	13891000	20169	10153	5	0	\N
321203	1874	13894000	20169	10153	6	0	\N
321204	1874	13896000	20169	10153	7	0	\N
321205	1874	13898000	20169	10153	8	0	\N
321231	1678	23040756945000	20176	10159	0	0	\N
321232	1874	13924000	20176	10159	1	0	\N
321139	702	44513351909515	20164	10150	2	0	0
321140	927	508636168253115	20164	10150	3	0	0
321141	1047	911471655514890	20164	10150	4	0	0
321142	1167	613988087331615	20164	10150	5	0	1
321143	1293	1713718989828080	20164	10150	6	0	0
321145	1874	13857000	20164	10150	8	0	2
321146	1874	13860000	20164	10150	9	0	2
321147	1033	906754515920000	20164	10150	10	0	0
321148	1279	1704849979141650	20164	10150	11	0	0
321149	1874	13862000	20164	10150	12	0	2
321151	199	66631395942306	20165	10151	1	0	0
321152	214	66631395942306	20165	10151	2	0	0
321153	234	66631395942306	20165	10151	3	0	0
321154	282	66631395942306	20165	10151	4	0	0
321156	323	66631395942306	20165	10151	6	0	0
321157	330	66631395942306	20165	10151	7	0	0
321158	332	66631395942306	20165	10151	8	0	0
321159	334	66631395942306	20165	10151	9	0	0
321160	343	66631395942306	20165	10151	10	0	0
321162	561	66631395942306	20165	10151	12	0	0
321163	1678	23040756936000	20165	10151	13	0	0
321164	1983	2734125920000	20165	10151	14	0	1
321165	1678	23040756937000	20165	10151	15	0	0
321166	1678	23040756938000	20165	10151	16	0	0
321168	1874	13864000	20165	10151	18	0	2
321169	1874	13867000	20165	10151	19	0	2
321170	1874	13870000	20165	10151	20	0	2
321171	1874	13873000	20165	10151	21	0	2
321173	1874	13877000	20165	10151	23	0	2
321174	1874	13879000	20165	10151	24	0	2
321175	1874	13882000	20165	10151	25	0	2
321182	1124	910301631000000	20167	10152	0	0	0
321183	1678	23040756940000	20167	10152	1	0	0
321185	1874	13884000	20167	10152	3	0	2
321186	1874	13885000	20167	10152	4	0	2
321187	1874	13888000	20167	10152	5	0	2
321188	104	66915395942306	20168	10153	0	0	0
321189	1244	614198650000000	20168	10153	1	0	0
321191	1678	23040756942000	20168	10153	3	0	0
321192	1963	733509120000	20168	10153	4	0	1
321193	1874	13891000	20168	10153	5	0	2
321194	1874	13894000	20168	10153	6	0	2
321196	1874	13898000	20168	10153	8	0	2
321206	1370	1711519148751650	20170	10154	0	0	0
321207	1678	23040756943000	20170	10154	1	0	0
321208	1874	13900000	20170	10154	2	0	2
321209	1874	13901000	20170	10154	3	0	2
321211	2249	200000000	20170	10154	5	0	0
321212	1678	23040756944000	20171	10155	0	0	0
321213	1874	13907000	20171	10155	1	0	2
321214	1874	13909000	20171	10155	2	0	2
321215	2250	200000000	20171	10155	3	0	0
321217	1874	13914000	20172	10156	1	0	2
321218	1004	507983250000000	20173	10157	0	0	0
321219	139	66576564642539	20173	10157	1	0	0
321220	1874	13916000	20173	10157	2	0	2
321222	813	504369561562206	20174	10158	1	0	0
321223	814	5548060335240798	20174	10158	2	0	0
321224	1874	13921000	20174	10158	3	0	2
321225	1874	13922000	20174	10158	4	0	2
321226	1678	23040756945000	20175	10159	0	0	0
321228	1874	13926000	20175	10159	2	0	2
321229	1874	13929000	20175	10159	3	0	2
321230	1874	13932000	20175	10159	4	0	2
321233	1874	13926000	20176	10159	2	0	\N
321234	1874	13929000	20176	10159	3	0	\N
321235	1874	13932000	20176	10159	4	0	\N
321246	1678	23040756949000	20178	10161	0	0	\N
321247	1874	13951000	20178	10161	1	0	\N
321248	1874	13953000	20178	10161	2	0	\N
321249	1874	13954000	20178	10161	3	0	\N
321257	1497	0	20181	9899	0	0	\N
321258	1009	505985775000000	20181	9899	1	0	\N
321259	1129	906722465000000	20181	9899	2	0	\N
321260	365	66667801000000	20181	9899	3	0	\N
321261	2011	1475000000000	20181	9899	4	0	\N
321262	1460	0	20181	9899	5	0	\N
321263	365	66715801000000	20181	9899	6	0	\N
321264	966	506675775000000	20181	9899	7	0	\N
321265	1382	1712413637751650	20181	9899	8	0	\N
321266	1136	910778465000000	20181	9899	9	0	\N
321267	1256	614519750000000	20181	9899	10	0	\N
321268	1016	508248775000000	20181	9899	11	0	\N
321269	1357	1712398137751650	20181	9899	12	0	\N
321270	1299	1704974641817750	20181	9899	13	0	\N
321271	1985	2300000000000	20181	9899	14	0	\N
321272	913	506003823451523	20181	9899	15	0	\N
321273	1460	0	20181	9899	16	0	\N
321274	976	507233775000000	20181	9899	17	0	\N
321275	1222	613662117612488	20181	9899	18	0	\N
321276	1313	1709341167751650	20181	9899	19	0	\N
321277	1067	909143245000000	20181	9899	20	0	\N
321278	1124	910301631000000	20181	9899	21	0	\N
321279	399	66651272116779	20181	9899	22	0	\N
321280	1111	910769145000000	20181	9899	23	0	\N
321281	1231	614514090000000	20181	9899	24	0	\N
321282	991	508244145000000	20181	9899	25	0	\N
321283	272	67581824000000	20181	9899	26	0	\N
321284	2238	2000000000	20181	9899	27	0	\N
321285	1096	908957465000000	20181	9899	28	0	\N
321286	1216	613292750000000	20181	9899	29	0	\N
321287	1342	1708990637751650	20181	9899	30	0	\N
321288	1371	1710570537751650	20181	9899	31	0	\N
321289	1348	1710024054520435	20181	9899	32	0	\N
321290	982	507539502027242	20181	9899	33	0	\N
321291	271	66651405291044	20181	9899	34	0	\N
321292	269	66651405291044	20181	9899	35	0	\N
321293	577	66651405291044	20181	9899	36	0	\N
321294	2246	2602651968305	20181	9899	37	0	\N
321295	38	66383534720208	20181	9899	38	0	\N
321296	969	505695553414336	20181	9899	39	0	\N
321297	1053	906821162404900	20181	9899	40	0	\N
321298	1173	611850449546800	20181	9899	41	0	\N
321299	1187	613417050000000	20181	9899	42	0	\N
321300	1678	21600733603000	20181	9899	43	0	\N
321301	1678	21600733604000	20181	9899	44	0	\N
321302	1089	906202098918976	20181	9899	45	0	\N
321303	1209	611432613493024	20181	9899	46	0	\N
321304	22	22510193128616	20181	9899	47	0	\N
321305	190	66544510726895	20181	9899	48	0	\N
321306	258	66544510726895	20181	9899	49	0	\N
321307	273	66544510726895	20181	9899	50	0	\N
321308	1594	16082303000000	20181	9899	51	0	\N
321309	292	66544510726895	20181	9899	52	0	\N
321310	293	66544510726895	20181	9899	53	0	\N
321311	1335	1703811343055074	20181	9899	54	0	\N
321312	21	32910553770161	20181	9899	55	0	\N
321313	52	66714679919853	20181	9899	56	0	\N
321314	1876	703463880000	20181	9899	57	0	\N
321315	1153	611805340660000	20181	9899	58	0	\N
321316	1874	12188000	20181	9899	59	0	\N
321317	908	506720815000000	20181	9899	60	0	\N
321318	581	66618100000000	20181	9899	61	0	\N
321319	698	66618100000000	20181	9899	62	0	\N
321320	139	66576564642539	20181	9899	63	0	\N
321321	813	504369561562206	20181	9899	64	0	\N
321322	814	5548060335240798	20181	9899	65	0	\N
321323	2231	200000000	20181	9899	66	0	\N
321324	1979	14400211999976	20181	9899	67	0	\N
321325	44	66000000000000	20181	9899	68	0	\N
321326	2247	9000000000	20181	9899	69	0	\N
321327	742	5048100000000	20181	9899	70	0	\N
321328	1874	12189000	20181	9899	71	0	\N
321329	986	507792735000000	20181	9899	72	0	\N
321330	1874	12191000	20181	9899	73	0	\N
321331	1874	12193000	20181	9899	74	0	\N
321332	1028	908039275000000	20181	9899	75	0	\N
321333	1148	612672289000000	20181	9899	76	0	\N
321334	1274	1707265437751650	20181	9899	77	0	\N
321335	1986	516610000000	20181	9899	78	0	\N
321336	267	66478788050691	20181	9899	79	0	\N
321337	2232	200000000	20181	9899	80	0	\N
321338	2184	2599000000	20181	9899	81	0	\N
321339	1106	909960255000000	20181	9899	82	0	\N
321340	1226	613968310000000	20181	9899	83	0	\N
321341	922	506425108194437	20181	9899	84	0	\N
321342	1042	907509454834100	20181	9899	85	0	\N
321343	1874	12194000	20181	9899	86	0	\N
321344	1874	12195000	20181	9899	87	0	\N
321345	1874	12196000	20181	9899	88	0	\N
321346	1874	12198000	20181	9899	89	0	\N
321347	1874	12200000	20181	9899	90	0	\N
321348	1162	612314712579855	20181	9899	91	0	\N
321349	1288	1706269390592464	20181	9899	92	0	\N
321350	1874	12202000	20181	9899	93	0	\N
321351	1874	12204000	20181	9899	94	0	\N
321352	1874	12206000	20181	9899	95	0	\N
321353	1773	1983844699931	20181	9899	96	0	\N
321354	1874	12207000	20181	9899	97	0	\N
321355	1874	12208000	20181	9899	98	0	\N
321356	104	66631395942306	20182	10085	0	0	\N
321357	199	66631395942306	20182	10085	1	0	\N
321358	214	66631395942306	20182	10085	2	0	\N
321359	234	66631395942306	20182	10085	3	0	\N
321360	282	66631395942306	20182	10085	4	0	\N
321361	314	66631395942306	20182	10085	5	0	\N
321362	323	66631395942306	20182	10085	6	0	\N
321363	330	66631395942306	20182	10085	7	0	\N
321364	332	66631395942306	20182	10085	8	0	\N
321365	334	66631395942306	20182	10085	9	0	\N
321366	343	66631395942306	20182	10085	10	0	\N
321367	559	66631395942306	20182	10085	11	0	\N
321368	561	66631395942306	20182	10085	12	0	\N
321238	1678	23040756948000	20177	10160	2	0	0
321239	1874	13933000	20177	10160	3	0	2
321240	1874	13936000	20177	10160	4	0	2
321241	1874	13938000	20177	10160	5	0	2
321242	1874	13940000	20177	10160	6	0	2
321244	1874	13945000	20177	10160	8	0	2
321245	1874	13948000	20177	10160	9	0	2
321250	1678	23040756949000	20179	10161	0	0	0
321251	1874	13951000	20179	10161	1	0	2
321252	1874	13953000	20179	10161	2	0	2
321254	1678	23040756950000	20180	10162	0	0	0
321255	1874	13956000	20180	10162	1	0	2
321256	1874	13959000	20180	10162	2	0	2
321369	1124	910301631000000	20182	10085	13	0	\N
321370	104	66915395942306	20182	10085	14	0	\N
321371	1244	614198650000000	20182	10085	15	0	\N
321372	1370	1711519148751650	20182	10085	16	0	\N
321373	1004	507983250000000	20182	10085	17	0	\N
321374	956	506972775000000	20182	10085	18	0	\N
321375	1076	908490465000000	20182	10085	19	0	\N
321376	1196	612976750000000	20182	10085	20	0	\N
321377	1322	1708113637751650	20182	10085	21	0	\N
321378	1876	703463880000	20182	10085	22	0	\N
321379	1963	733509120000	20182	10085	23	0	\N
321380	1153	611805340660000	20182	10085	24	0	\N
321381	1773	7990000000000	20182	10085	25	0	\N
321382	1874	13531000	20182	10085	26	0	\N
321383	1149	613083553321783	20182	10085	27	0	\N
321384	1874	13534000	20182	10085	28	0	\N
321385	1874	13537000	20182	10085	29	0	\N
321386	2245	200000000	20182	10085	30	0	\N
321387	1773	13749000000000	20182	10085	31	0	\N
321388	1874	13539000	20182	10085	32	0	\N
321389	1874	13541000	20182	10085	33	0	\N
321390	139	66576564642539	20182	10085	34	0	\N
321391	813	504369561562206	20182	10085	35	0	\N
321392	814	5548060335240798	20182	10085	36	0	\N
321393	2247	9000000000	20182	10085	37	0	\N
321394	2249	200000000	20182	10085	38	0	\N
321395	986	507792735000000	20182	10085	39	0	\N
321396	1033	906754515920000	20182	10085	40	0	\N
321397	1279	1704849979141650	20182	10085	41	0	\N
321398	1874	13542000	20182	10085	42	0	\N
321412	1484	0	20185	9927	0	0	\N
321413	1497	0	20185	9927	1	0	\N
321414	1009	505985775000000	20185	9927	2	0	\N
321415	1129	906722465000000	20185	9927	3	0	\N
321416	1249	611783750000000	20185	9927	4	0	\N
321417	1375	1704789637751650	20185	9927	5	0	\N
321418	365	66667801000000	20185	9927	6	0	\N
321419	365	66668501000000	20185	9927	7	0	\N
321420	365	66716501000000	20185	9927	8	0	\N
321421	365	66717301000000	20185	9927	9	0	\N
321422	1282	1713369637751650	20185	9927	10	0	\N
321423	1036	911287465000000	20185	9927	11	0	\N
321424	1156	614864750000000	20185	9927	12	0	\N
321425	916	508533775000000	20185	9927	13	0	\N
321426	104	66631395942306	20185	9927	14	0	\N
321427	199	66631395942306	20185	9927	15	0	\N
321428	214	66631395942306	20185	9927	16	0	\N
321429	234	66631395942306	20185	9927	17	0	\N
321430	282	66631395942306	20185	9927	18	0	\N
321431	314	66631395942306	20185	9927	19	0	\N
321432	323	66631395942306	20185	9927	20	0	\N
321433	330	66631395942306	20185	9927	21	0	\N
321434	332	66631395942306	20185	9927	22	0	\N
321435	334	66631395942306	20185	9927	23	0	\N
321436	343	66631395942306	20185	9927	24	0	\N
321437	1382	1712413637751650	20185	9927	26	0	\N
321438	1136	910778465000000	20185	9927	27	0	\N
321439	1256	614519750000000	20185	9927	28	0	\N
321440	1016	508248775000000	20185	9927	29	0	\N
321441	1357	1712398137751650	20185	9927	30	0	\N
321442	1985	2299990000000	20185	9927	31	0	\N
321443	1365	1710262743410483	20185	9927	32	0	\N
321444	913	506003823451523	20185	9927	33	0	\N
321445	1460	0	20185	9927	34	0	\N
321446	976	507233775000000	20185	9927	36	0	\N
321447	2213	650232116779	20185	9927	37	0	\N
321448	1222	613662117612488	20185	9927	38	0	\N
321449	948	507975167870000	20185	9927	39	0	\N
321450	1068	910287148470000	20185	9927	40	0	\N
321451	1313	1709341167751650	20185	9927	41	0	\N
321452	1067	909143245000000	20185	9927	42	0	\N
321453	1124	910301631000000	20185	9927	43	0	\N
321454	1119	909633389928309	20185	9927	44	0	\N
321455	1239	613747773910318	20185	9927	45	0	\N
321456	1111	910769145000000	20185	9927	46	0	\N
321457	1231	614514090000000	20185	9927	47	0	\N
321458	991	508244145000000	20185	9927	48	0	\N
321459	272	67581824000000	20185	9927	49	0	\N
321460	319	66717580000000	20185	9927	50	0	\N
321461	272	68914579000000	20185	9927	51	0	\N
321462	1326	1709341117751650	20185	9927	52	0	\N
321463	2238	2000000000	20185	9927	53	0	\N
321464	2238	1002000000000	20185	9927	54	0	\N
321465	1096	908957465000000	20185	9927	55	0	\N
321466	1216	613292750000000	20185	9927	56	0	\N
321467	1342	1708990637751650	20185	9927	57	0	\N
321468	1371	1710570537751650	20185	9927	58	0	\N
321469	1188	614188877840000	20185	9927	59	0	\N
321470	1314	1711491918671650	20185	9927	60	0	\N
321471	1348	1710024054520435	20185	9927	62	0	\N
321472	1244	614198650000000	20185	9927	63	0	\N
321473	1370	1711519148751650	20185	9927	64	0	\N
321474	1004	507983250000000	20185	9927	65	0	\N
321475	982	507539502027242	20185	9927	66	0	\N
321476	271	66651395291044	20185	9927	67	0	\N
321477	269	66651405291044	20185	9927	68	0	\N
321478	577	66651405291044	20185	9927	69	0	\N
321479	2246	2602651968305	20185	9927	70	0	\N
321480	1102	909506439034341	20185	9927	71	0	\N
321481	242	66651405291044	20185	9927	72	0	\N
321482	38	66383534720208	20185	9927	73	0	\N
321483	969	505695553414336	20185	9927	74	0	\N
321484	1187	613417050000000	20185	9927	75	0	\N
321485	1678	21600733769000	20185	9927	76	0	\N
321486	1678	21600733770000	20185	9927	77	0	\N
321487	1678	21600733771000	20185	9927	78	0	\N
321488	1678	21600733772000	20185	9927	79	0	\N
321489	1678	21600733773000	20185	9927	80	0	\N
321490	1678	21600733774000	20185	9927	81	0	\N
321491	1678	21600733775000	20185	9927	82	0	\N
321492	1678	21600733776000	20185	9927	83	0	\N
321493	1678	21600733777000	20185	9927	84	0	\N
321494	1089	906202098918976	20185	9927	85	0	\N
321495	1209	611432613493024	20185	9927	86	0	\N
321496	22	22510193128616	20185	9927	87	0	\N
321497	190	66544510726895	20185	9927	88	0	\N
321498	258	66544510726895	20185	9927	89	0	\N
321499	273	66544510726895	20185	9927	90	0	\N
321500	1200	613417050000000	20185	9927	91	0	\N
321501	1080	909143225000000	20185	9927	92	0	\N
321502	999	507610345498755	20185	9927	93	0	\N
321503	1678	21600733778000	20185	9927	94	0	\N
321504	1678	21600733779000	20185	9927	95	0	\N
321401	1678	23040756953000	20183	10163	2	0	0
321402	1874	13961000	20183	10163	3	0	2
321403	1874	13964000	20183	10163	4	0	2
321404	1874	13967000	20183	10163	5	0	2
321405	1874	13970000	20183	10163	6	0	2
321407	1874	13973000	20183	10163	8	0	2
321408	1874	13975000	20183	10163	9	0	2
321409	1678	23040756954000	20184	10164	0	0	0
321410	1874	13977000	20184	10164	1	0	2
321411	1874	13980000	20184	10164	2	0	2
321505	1678	21600733780000	20185	9927	96	0	\N
321506	1678	21600733781000	20185	9927	97	0	\N
321507	1678	21600733782000	20185	9927	98	0	\N
321508	292	66544510726895	20185	9927	99	0	\N
321509	293	66544510726895	20185	9927	100	0	\N
321510	333	66209510726895	20185	9927	101	0	\N
321511	376	66544510726895	20185	9927	102	0	\N
321512	426	66544510726895	20185	9927	103	0	\N
321513	429	66544510726895	20185	9927	104	0	\N
321514	430	66544510726895	20185	9927	105	0	\N
321515	440	66544510726895	20185	9927	106	0	\N
321516	474	66544510726895	20185	9927	107	0	\N
321517	475	66544510726895	20185	9927	108	0	\N
321518	476	66544510726895	20185	9927	109	0	\N
321519	483	66544510726895	20185	9927	110	0	\N
321520	486	66544510726895	20185	9927	111	0	\N
321521	490	66544510726895	20185	9927	112	0	\N
321522	496	66544510726895	20185	9927	113	0	\N
321523	511	66544510726895	20185	9927	114	0	\N
321524	512	66544510726895	20185	9927	115	0	\N
321525	522	66544510726895	20185	9927	116	0	\N
321526	523	66544510726895	20185	9927	117	0	\N
321527	533	66544510726895	20185	9927	118	0	\N
321528	539	66544510726895	20185	9927	119	0	\N
321529	541	66544510726895	20185	9927	120	0	\N
321530	558	66243200726895	20185	9927	121	0	\N
321531	565	66544510726895	20185	9927	122	0	\N
321532	572	66544510726895	20185	9927	123	0	\N
321533	573	66544510726895	20185	9927	124	0	\N
321544	1678	23040756958000	20187	10166	0	0	\N
321545	1874	13998000	20187	10166	1	0	\N
321546	1874	14001000	20187	10166	2	0	\N
321547	1678	23040756958000	20188	10166	0	0	\N
321548	1874	13998000	20188	10166	1	0	\N
321549	1874	14001000	20188	10166	2	0	\N
321575	1678	23040756966000	20194	10171	0	0	\N
321576	1305	1709013975785189	20194	10171	1	0	\N
321577	1179	613299639053204	20194	10171	2	0	\N
321578	1874	14036000	20194	10171	3	0	\N
321579	1874	14038000	20194	10171	4	0	\N
321580	1874	14041000	20194	10171	5	0	\N
321581	1678	23040756966000	20195	10171	0	0	\N
321582	1305	1709013975785189	20195	10171	1	0	\N
321583	1179	613299639053204	20195	10171	2	0	\N
321584	1874	14036000	20195	10171	3	0	\N
321585	1874	14038000	20195	10171	4	0	\N
321586	1874	14041000	20195	10171	5	0	\N
321597	1678	23040756967000	20198	10172	0	0	\N
321598	1059	908969210852514	20198	10172	1	0	\N
321599	1874	14043000	20198	10172	2	0	\N
321600	1874	14046000	20198	10172	3	0	\N
321609	1678	23040756970000	20200	10174	0	0	\N
321610	1874	14059000	20200	10174	1	0	\N
321611	1874	14062000	20200	10174	2	0	\N
321618	1678	23040756972000	20203	10176	0	0	\N
321619	1874	14070000	20203	10176	1	0	\N
321620	1874	14072000	20203	10176	2	0	\N
321624	1678	23040756972000	20205	10176	0	0	\N
321625	1874	14070000	20205	10176	1	0	\N
321626	1874	14072000	20205	10176	2	0	\N
321627	1678	23040756951000	20206	10163	0	0	\N
321628	1305	1709013975785189	20206	10163	1	0	\N
321629	1179	613299639053204	20206	10163	2	0	\N
321630	1059	908969210852514	20206	10163	3	0	\N
321631	939	507239718081690	20206	10163	4	0	\N
321632	1678	23040756952000	20206	10163	5	0	\N
321633	1678	23040756953000	20206	10163	6	0	\N
321634	1678	23040756954000	20206	10163	7	0	\N
321635	1678	23040756955000	20206	10163	8	0	\N
321636	1678	23040756956000	20206	10163	9	0	\N
321637	1678	23040756957000	20206	10163	10	0	\N
321638	1678	23040756958000	20206	10163	11	0	\N
321639	1678	23040756959000	20206	10163	12	0	\N
321640	1678	23040756960000	20206	10163	13	0	\N
321536	1678	23040756957000	20186	10165	2	0	0
321537	1874	13982000	20186	10165	3	0	2
321538	1874	13984000	20186	10165	4	0	2
321539	1874	13986000	20186	10165	5	0	2
321540	1874	13989000	20186	10165	6	0	2
321542	1874	13995000	20186	10165	8	0	2
321543	1874	13996000	20186	10165	9	0	2
321550	1678	23040756958000	20189	10166	0	0	0
321551	1874	13998000	20189	10166	1	0	2
321552	1874	14001000	20189	10166	2	0	2
321554	1874	14003000	20190	10167	1	0	2
321555	1874	14004000	20190	10167	2	0	2
321556	1874	14007000	20190	10167	3	0	2
321557	1678	23040756960000	20191	10168	0	0	0
321559	1678	23040756962000	20191	10168	2	0	0
321560	1874	14009000	20191	10168	3	0	2
321561	1874	14012000	20191	10168	4	0	2
321562	1874	14015000	20191	10168	5	0	2
321563	1874	14018000	20191	10168	6	0	2
321565	1874	14022000	20191	10168	8	0	2
321566	1678	23040756963000	20192	10169	0	0	0
321567	1874	14025000	20192	10169	1	0	2
321568	1874	14026000	20192	10169	2	0	2
321569	1874	14028000	20192	10169	3	0	2
321571	1678	23040756965000	20193	10170	1	0	0
321572	1874	14030000	20193	10170	2	0	2
321573	1874	14032000	20193	10170	3	0	2
321574	1874	14035000	20193	10170	4	0	2
321588	1305	1709013975785189	20196	10171	1	0	0
321589	1179	613299639053204	20196	10171	2	0	0
321590	1874	14036000	20196	10171	3	0	2
321591	1874	14038000	20196	10171	4	0	2
321592	1874	14041000	20196	10171	5	0	2
321594	1059	908969210852514	20197	10172	1	0	0
321595	1874	14043000	20197	10172	2	0	2
321596	1874	14046000	20197	10172	3	0	2
321601	939	507239718081690	20199	10173	0	0	0
321602	1678	23040756968000	20199	10173	1	0	0
321604	1874	14048000	20199	10173	3	0	2
321605	1874	14050000	20199	10173	4	0	2
321606	1874	14053000	20199	10173	5	0	2
321607	1874	14056000	20199	10173	6	0	2
321612	1678	23040756970000	20201	10174	0	0	0
321613	1874	14059000	20201	10174	1	0	2
321614	1874	14062000	20201	10174	2	0	2
321615	1678	23040756971000	20202	10175	0	0	0
321616	1874	14065000	20202	10175	1	0	2
321621	1678	23040756972000	20204	10176	0	0	0
321622	1874	14070000	20204	10176	1	0	2
321623	1874	14072000	20204	10176	2	0	2
321641	1678	23040756961000	20206	10163	14	0	\N
321642	1678	23040756962000	20206	10163	15	0	\N
321643	1678	23040756963000	20206	10163	16	0	\N
321644	1678	23040756964000	20206	10163	17	0	\N
321645	1678	23040756965000	20206	10163	18	0	\N
321646	1678	23040756966000	20206	10163	19	0	\N
321647	1678	23040756967000	20206	10163	20	0	\N
321648	1678	23040756968000	20206	10163	21	0	\N
321649	1678	23040756969000	20206	10163	22	0	\N
321650	1678	23040756970000	20206	10163	23	0	\N
321651	1678	23040756971000	20206	10163	24	0	\N
321652	1678	23040756972000	20206	10163	25	0	\N
321653	1874	13961000	20206	10163	26	0	\N
321654	1874	13964000	20206	10163	27	0	\N
321655	1874	13967000	20206	10163	28	0	\N
321656	1874	13970000	20206	10163	29	0	\N
321657	1874	13971000	20206	10163	30	0	\N
321658	1874	13972000	20206	10163	31	0	\N
321659	1874	13973000	20206	10163	32	0	\N
321660	1874	13974000	20206	10163	33	0	\N
321661	1874	13975000	20206	10163	34	0	\N
321662	1874	13977000	20206	10163	35	0	\N
321663	1874	13979000	20206	10163	36	0	\N
321664	1874	13981000	20206	10163	37	0	\N
321665	1874	13983000	20206	10163	38	0	\N
321666	1874	13985000	20206	10163	39	0	\N
321667	1874	13987000	20206	10163	40	0	\N
321668	1874	13989000	20206	10163	41	0	\N
321669	1874	13991000	20206	10163	42	0	\N
321670	1874	13993000	20206	10163	43	0	\N
321671	1874	13995000	20206	10163	44	0	\N
321672	1874	13997000	20206	10163	45	0	\N
321673	1874	13999000	20206	10163	46	0	\N
321674	1874	14001000	20206	10163	47	0	\N
321675	1874	14003000	20206	10163	48	0	\N
321676	1874	14005000	20206	10163	49	0	\N
321677	1874	14007000	20206	10163	50	0	\N
321678	1874	14009000	20206	10163	51	0	\N
321679	1874	14011000	20206	10163	52	0	\N
321680	1874	14013000	20206	10163	53	0	\N
321681	1874	14015000	20206	10163	54	0	\N
321682	1874	14018000	20206	10163	55	0	\N
321683	1874	14021000	20206	10163	56	0	\N
321684	1874	14024000	20206	10163	57	0	\N
321685	1874	14027000	20206	10163	58	0	\N
321686	1874	14030000	20206	10163	59	0	\N
321687	1874	14033000	20206	10163	60	0	\N
321688	1874	14036000	20206	10163	61	0	\N
321689	1874	14039000	20206	10163	62	0	\N
321690	1874	14042000	20206	10163	63	0	\N
321691	1874	14045000	20206	10163	64	0	\N
321692	1874	14048000	20206	10163	65	0	\N
321693	1874	14051000	20206	10163	66	0	\N
321694	1874	14054000	20206	10163	67	0	\N
321695	1874	14057000	20206	10163	68	0	\N
321696	1874	14060000	20206	10163	69	0	\N
321697	1874	14063000	20206	10163	70	0	\N
321698	1874	14066000	20206	10163	71	0	\N
321699	1874	14069000	20206	10163	72	0	\N
321700	1874	14070000	20206	10163	73	0	\N
321701	1874	14072000	20206	10163	74	0	\N
321705	1678	23040756974000	20208	10178	0	0	\N
321706	1874	14078000	20208	10178	1	0	\N
321707	1874	14080000	20208	10178	2	0	\N
321708	1678	23040756974000	20209	10178	0	0	\N
321709	1874	14078000	20209	10178	1	0	\N
321710	1874	14080000	20209	10178	2	0	\N
321711	1678	23040756974000	20210	10178	0	0	\N
321712	1874	14078000	20210	10178	1	0	\N
321713	1874	14080000	20210	10178	2	0	\N
321717	1678	23040756973000	20212	10164	0	0	\N
321718	1678	23040756974000	20212	10164	1	0	\N
321719	1874	14074000	20212	10164	2	0	\N
321720	1874	14077000	20212	10164	3	0	\N
321721	1874	14079000	20212	10164	4	0	\N
321722	1874	14080000	20212	10164	5	0	\N
321734	1678	23040756978000	20215	10181	0	0	\N
321735	1678	23040756979000	20215	10181	1	0	\N
321736	1874	14097000	20215	10181	2	0	\N
321737	1874	14100000	20215	10181	3	0	\N
321738	1874	14102000	20215	10181	4	0	\N
321739	1874	14104000	20215	10181	5	0	\N
321740	1874	14107000	20215	10181	6	0	\N
321741	1678	23040756978000	20216	10181	0	0	\N
321742	1678	23040756979000	20216	10181	1	0	\N
321743	1874	14097000	20216	10181	2	0	\N
321744	1874	14100000	20216	10181	3	0	\N
321745	1874	14102000	20216	10181	4	0	\N
321746	1874	14104000	20216	10181	5	0	\N
321747	1874	14107000	20216	10181	6	0	\N
321753	1678	23040756978000	20218	10181	0	0	\N
321754	1678	23040756979000	20218	10181	1	0	\N
321755	1874	14097000	20218	10181	2	0	\N
321756	1874	14100000	20218	10181	3	0	\N
321757	1874	14102000	20218	10181	4	0	\N
321758	1874	14104000	20218	10181	5	0	\N
321759	1874	14107000	20218	10181	6	0	\N
321760	1678	23040756978000	20219	10181	0	0	\N
321761	1678	23040756979000	20219	10181	1	0	\N
321762	1874	14097000	20219	10181	2	0	\N
321763	1874	14100000	20219	10181	3	0	\N
321764	1874	14102000	20219	10181	4	0	\N
321765	1874	14104000	20219	10181	5	0	\N
321766	1874	14107000	20219	10181	6	0	\N
321767	1678	23040756980000	20220	10182	0	0	\N
321768	1678	23040756981000	20220	10182	1	0	\N
321769	1678	23040756982000	20220	10182	2	0	\N
321770	1874	14103000	20220	10182	3	0	\N
321771	1874	14105000	20220	10182	4	0	\N
321772	1874	14107000	20220	10182	5	0	\N
321773	1874	14110000	20220	10182	6	0	\N
321774	1874	14113000	20220	10182	7	0	\N
321775	1874	14116000	20220	10182	8	0	\N
321776	1874	14119000	20220	10182	9	0	\N
321704	1874	14075000	20207	10177	2	0	2
321714	1678	23040756974000	20211	10178	0	0	0
321715	1874	14078000	20211	10178	1	0	2
321716	1874	14080000	20211	10178	2	0	2
321723	1678	23040756975000	20213	10179	0	0	0
321725	391	66650162116779	20213	10179	2	0	1
321726	1874	14082000	20213	10179	3	0	2
321727	1874	14085000	20213	10179	4	0	2
321728	1874	14088000	20213	10179	5	0	2
321729	1874	14089000	20213	10179	6	0	2
321731	1678	23040756977000	20214	10180	0	0	0
321732	1874	14093000	20214	10180	1	0	2
321733	1874	14096000	20214	10180	2	0	2
321748	1678	23040756978000	20217	10181	0	0	0
321750	1874	14097000	20217	10181	2	0	2
321751	1874	14099000	20217	10181	3	0	2
321752	1874	14101000	20217	10181	4	0	2
321777	1678	23040756980000	20221	10182	0	0	\N
321778	1678	23040756981000	20221	10182	1	0	\N
321779	1678	23040756982000	20221	10182	2	0	\N
321780	1874	14103000	20221	10182	3	0	\N
321781	1874	14105000	20221	10182	4	0	\N
321782	1874	14107000	20221	10182	5	0	\N
321783	1874	14110000	20221	10182	6	0	\N
321784	1874	14113000	20221	10182	7	0	\N
321785	1874	14116000	20221	10182	8	0	\N
321786	1874	14119000	20221	10182	9	0	\N
321787	1678	23040756980000	20222	10182	0	0	\N
321788	1678	23040756981000	20222	10182	1	0	\N
321789	1678	23040756982000	20222	10182	2	0	\N
321790	1874	14103000	20222	10182	3	0	\N
321791	1874	14105000	20222	10182	4	0	\N
321792	1874	14107000	20222	10182	5	0	\N
321793	1874	14110000	20222	10182	6	0	\N
321794	1874	14113000	20222	10182	7	0	\N
321795	1874	14116000	20222	10182	8	0	\N
321796	1874	14119000	20222	10182	9	0	\N
321807	1678	23040756983000	20224	10183	0	0	\N
321808	1874	14120000	20224	10183	1	0	\N
321809	1874	14123000	20224	10183	2	0	\N
321813	1678	23040756983000	20226	10183	0	0	\N
321814	1874	14120000	20226	10183	1	0	\N
321815	1874	14123000	20226	10183	2	0	\N
321816	1678	23040756984000	20227	10184	0	0	\N
321817	1678	23040756985000	20227	10184	1	0	\N
321818	1874	14125000	20227	10184	2	0	\N
321819	1874	14127000	20227	10184	3	0	\N
321820	1874	14130000	20227	10184	4	0	\N
321821	1874	14133000	20227	10184	5	0	\N
321835	1678	23040756987000	20231	10186	0	0	\N
321836	1874	14142000	20231	10186	1	0	\N
321837	1874	14144000	20231	10186	2	0	\N
321844	1678	23040756989000	20233	10188	0	0	\N
321845	1874	14152000	20233	10188	1	0	\N
321846	1874	14154000	20233	10188	2	0	\N
321847	1874	14155000	20233	10188	3	0	\N
321852	1678	23040756989000	20235	10188	0	0	\N
321853	1874	14152000	20235	10188	1	0	\N
321854	1874	14154000	20235	10188	2	0	\N
321855	1874	14155000	20235	10188	3	0	\N
321856	1678	23040756975000	20236	10165	0	0	\N
321857	914	507519164923296	20236	10165	1	0	\N
321858	1034	909469995118336	20236	10165	2	0	\N
321859	1154	613637528176164	20236	10165	3	0	\N
321860	1678	23040756976000	20236	10165	4	0	\N
321861	1678	23040756977000	20236	10165	5	0	\N
321862	1678	23040756978000	20236	10165	6	0	\N
321863	1280	1709955533869714	20236	10165	7	0	\N
321864	1678	23040756979000	20236	10165	8	0	\N
321865	1678	23040756980000	20236	10165	9	0	\N
321866	1678	23040756981000	20236	10165	10	0	\N
321867	1678	23040756982000	20236	10165	11	0	\N
321868	1678	23040756983000	20236	10165	12	0	\N
321869	1678	23040756984000	20236	10165	13	0	\N
321870	1678	23040756985000	20236	10165	14	0	\N
321871	1678	23040756986000	20236	10165	15	0	\N
321872	1678	23040756987000	20236	10165	16	0	\N
321873	1678	23040756988000	20236	10165	17	0	\N
321874	1678	23040756989000	20236	10165	18	0	\N
321875	391	66650162116779	20236	10165	19	0	\N
321876	1874	14082000	20236	10165	20	0	\N
321877	1874	14085000	20236	10165	21	0	\N
321878	1874	14088000	20236	10165	22	0	\N
321879	1874	14091000	20236	10165	23	0	\N
321880	1874	14094000	20236	10165	24	0	\N
321881	1874	14095000	20236	10165	25	0	\N
321882	1874	14096000	20236	10165	26	0	\N
321883	1874	14097000	20236	10165	27	0	\N
321884	1874	14098000	20236	10165	28	0	\N
321885	1874	14099000	20236	10165	29	0	\N
321886	1874	14102000	20236	10165	30	0	\N
321887	1874	14105000	20236	10165	31	0	\N
321888	1874	14108000	20236	10165	32	0	\N
321889	1874	14111000	20236	10165	33	0	\N
321890	1874	14114000	20236	10165	34	0	\N
321891	1874	14117000	20236	10165	35	0	\N
321892	1874	14120000	20236	10165	36	0	\N
321893	1874	14123000	20236	10165	38	0	\N
321894	1874	14126000	20236	10165	39	0	\N
321895	1874	14129000	20236	10165	40	0	\N
321896	1874	14131000	20236	10165	41	0	\N
321897	1874	14133000	20236	10165	42	0	\N
321898	1874	14135000	20236	10165	43	0	\N
321899	1874	14137000	20236	10165	44	0	\N
321900	1874	14139000	20236	10165	45	0	\N
321901	1874	14141000	20236	10165	46	0	\N
321902	1874	14143000	20236	10165	47	0	\N
321903	1874	14145000	20236	10165	48	0	\N
321904	1874	14147000	20236	10165	49	0	\N
321905	1874	14149000	20236	10165	50	0	\N
321906	1874	14151000	20236	10165	51	0	\N
321907	1874	14153000	20236	10165	52	0	\N
321908	1874	14155000	20236	10165	53	0	\N
321799	1678	23040756982000	20223	10182	2	0	0
321800	1874	14103000	20223	10182	3	0	2
321801	1874	14105000	20223	10182	4	0	2
321802	1874	14107000	20223	10182	5	0	2
321803	1874	14110000	20223	10182	6	0	2
321805	1874	14116000	20223	10182	8	0	2
321806	1874	14119000	20223	10182	9	0	2
321810	1678	23040756983000	20225	10183	0	0	0
321811	1874	14120000	20225	10183	1	0	2
321812	1874	14123000	20225	10183	2	0	2
321823	1678	23040756985000	20228	10184	1	0	0
321824	1874	14125000	20228	10184	2	0	2
321825	1874	14127000	20228	10184	3	0	2
321826	1874	14130000	20228	10184	4	0	2
321828	1678	23040756986000	20229	10185	0	0	0
321829	1874	14136000	20229	10185	1	0	2
321830	1874	14138000	20229	10185	2	0	2
321831	1874	14139000	20229	10185	3	0	2
321832	1678	23040756987000	20230	10186	0	0	0
321834	1874	14144000	20230	10186	2	0	2
321838	1678	23040756988000	20232	10187	0	0	0
321839	914	507519164923296	20232	10187	1	0	0
321840	1034	909469995118336	20232	10187	2	0	0
321841	1154	613637528176164	20232	10187	3	0	0
321843	1874	14149000	20232	10187	5	0	2
321848	1678	23040756989000	20234	10188	0	0	0
321849	1874	14152000	20234	10188	1	0	2
321850	1874	14154000	20234	10188	2	0	2
321909	1678	23040756990000	20237	10189	0	0	0
321910	1874	14157000	20237	10189	1	0	2
321911	1874	14160000	20237	10189	2	0	2
321912	1678	23040756991000	20238	10190	0	0	0
321919	1295	1707807077084620	20240	10191	0	0	\N
321920	1678	23040756992000	20240	10191	1	0	\N
321921	1874	14167000	20240	10191	2	0	\N
321922	1874	14170000	20240	10191	3	0	\N
321923	1295	1707807077084620	20241	10191	0	0	\N
321924	1678	23040756992000	20241	10191	1	0	\N
321925	1874	14167000	20241	10191	2	0	\N
321926	1874	14170000	20241	10191	3	0	\N
321967	1678	23040757001000	20248	10197	0	0	\N
321968	1678	23040757002000	20248	10197	1	0	\N
321969	1678	23040757003000	20248	10197	2	0	\N
321970	1874	14215000	20248	10197	3	0	\N
321971	1874	14218000	20248	10197	4	0	\N
321972	1874	14219000	20248	10197	5	0	\N
321973	1874	14221000	20248	10197	6	0	\N
321974	1874	14224000	20248	10197	7	0	\N
321975	1874	14226000	20248	10197	9	0	\N
321982	1678	23040757006000	20251	10200	0	0	\N
321983	1678	23040757007000	20251	10200	1	0	\N
321984	1874	14239000	20251	10200	2	0	\N
321985	1874	14242000	20251	10200	3	0	\N
321986	1874	14244000	20251	10200	4	0	\N
321987	1874	14246000	20251	10200	5	0	\N
321988	1874	14247000	20251	10200	6	0	\N
321996	1678	23040757008000	20253	10201	0	0	\N
321997	1678	23040757009000	20253	10201	1	0	\N
321998	1678	23040757010000	20253	10201	2	0	\N
321999	1678	23040757011000	20253	10201	3	0	\N
322000	1874	14249000	20253	10201	4	0	\N
322001	1874	14252000	20253	10201	5	0	\N
322002	1874	14254000	20253	10201	6	0	\N
322003	1874	14256000	20253	10201	7	0	\N
322004	1874	14258000	20253	10201	8	0	\N
322005	1874	14259000	20253	10201	9	0	\N
322006	1874	14262000	20253	10201	10	0	\N
322007	1874	14265000	20253	10201	11	0	\N
322008	1874	14268000	20253	10201	12	0	\N
322025	1678	23040757012000	20256	10202	0	0	\N
322026	1874	14271000	20256	10202	1	0	\N
322027	1678	23040757012000	20257	10202	0	0	\N
322028	1874	14270000	20257	10202	1	0	\N
322029	1874	14273000	20257	10202	2	0	\N
322043	1678	23040757016000	20261	10205	0	0	\N
322044	1874	14291000	20261	10205	1	0	\N
322045	1874	14294000	20261	10205	2	0	\N
322046	1874	14295000	20261	10205	3	0	\N
322047	1678	23040757016000	20262	10205	0	0	\N
322048	1874	14291000	20262	10205	1	0	\N
321915	1295	1707807077084620	20239	10191	0	0	0
321916	1678	23040756992000	20239	10191	1	0	0
321917	1874	14167000	20239	10191	2	0	2
321918	1874	14170000	20239	10191	3	0	2
321927	1678	23040756993000	20242	10192	0	0	0
321929	1169	612867818037067	20242	10192	2	0	0
321930	929	506882910895171	20242	10192	3	0	0
321931	1874	14173000	20242	10192	4	0	2
321932	1874	14174000	20242	10192	5	0	2
321933	1874	14176000	20242	10192	6	0	2
321935	1874	14178000	20243	10193	1	0	2
321936	1874	14181000	20243	10193	2	0	2
321937	1280	1709955533869714	20244	10194	0	0	0
321938	1678	23040756995000	20244	10194	1	0	0
321940	1874	14184000	20244	10194	3	0	2
321941	1874	14185000	20244	10194	4	0	2
321942	1874	14187000	20244	10194	5	0	2
321943	1874	14189000	20244	10194	6	0	2
321944	1874	14192000	20244	10194	7	0	2
321946	1678	23040756998000	20245	10195	1	0	0
321947	1874	14194000	20245	10195	2	0	2
321948	1874	14197000	20245	10195	3	0	2
321949	1874	14199000	20245	10195	4	0	2
321950	1874	14202000	20245	10195	5	0	2
321952	1678	23040757000000	20246	10196	1	0	0
321953	1874	14203000	20246	10196	2	0	2
321954	1874	14205000	20246	10196	3	0	2
321955	1874	14207000	20246	10196	4	0	2
321957	1874	14213000	20246	10196	6	0	2
321958	1678	23040757001000	20247	10197	0	0	0
321959	1678	23040757002000	20247	10197	1	0	0
321960	1678	23040757003000	20247	10197	2	0	0
321961	1874	14215000	20247	10197	3	0	2
321963	1874	14219000	20247	10197	5	0	2
321964	1874	14221000	20247	10197	6	0	2
321965	1874	14224000	20247	10197	7	0	2
321966	1874	14226000	20247	10197	9	0	2
321976	1678	23040757004000	20249	10198	0	0	0
321978	1874	14231000	20249	10198	2	0	2
321979	1678	23040757005000	20250	10199	0	0	0
321980	1874	14233000	20250	10199	1	0	2
321981	1874	14236000	20250	10199	2	0	2
321990	1678	23040757007000	20252	10200	1	0	0
321991	1874	14239000	20252	10200	2	0	2
321992	1874	14242000	20252	10200	3	0	2
321993	1874	14244000	20252	10200	4	0	2
321994	1874	14246000	20252	10200	5	0	2
322009	1678	23040757008000	20254	10201	0	0	0
322010	1678	23040757009000	20254	10201	1	0	0
322011	1678	23040757010000	20254	10201	2	0	0
322012	1678	23040757011000	20254	10201	3	0	0
322013	1874	14249000	20254	10201	4	0	2
322015	1874	14254000	20254	10201	6	0	2
322016	1874	14256000	20254	10201	7	0	2
322017	1874	14258000	20254	10201	8	0	2
322018	1874	14259000	20254	10201	9	0	2
322020	1874	14265000	20254	10201	11	0	2
322021	1874	14268000	20254	10201	12	0	2
322022	1678	23040757012000	20255	10202	0	0	0
322023	1874	14270000	20255	10202	1	0	2
322024	1874	14273000	20255	10202	2	0	2
322031	1678	23040757014000	20258	10203	1	0	0
322032	1874	14274000	20258	10203	2	0	2
322033	1874	14277000	20258	10203	3	0	2
322034	1874	14280000	20258	10203	4	0	2
322035	1874	14282000	20258	10203	5	0	2
322037	1678	23040757015000	20259	10204	0	0	0
322038	1874	14287000	20259	10204	1	0	2
322039	1874	14289000	20259	10204	2	0	2
322040	1678	23040757016000	20260	10205	0	0	0
322042	1874	14293000	20260	10205	2	0	2
322049	1874	14294000	20262	10205	2	0	\N
322050	1874	14295000	20262	10205	3	0	\N
322051	1678	23040757016000	20263	10205	0	0	\N
322052	1874	14291000	20263	10205	1	0	\N
322053	1874	14294000	20263	10205	2	0	\N
322054	1874	14295000	20263	10205	3	0	\N
322055	1678	23040757017000	20264	10206	0	0	\N
322056	1678	23040757018000	20264	10206	1	0	\N
322057	1874	14295000	20264	10206	2	0	\N
322058	1874	14297000	20264	10206	3	0	\N
322059	1874	14299000	20264	10206	4	0	\N
322060	1874	14302000	20264	10206	5	0	\N
322061	1874	14305000	20264	10206	6	0	\N
322072	1678	23040757019000	20267	10207	0	0	\N
322073	1874	14306000	20267	10207	1	0	\N
322074	1874	14308000	20267	10207	2	0	\N
322075	1678	23040757020000	20268	10208	0	0	\N
322076	1874	14311000	20268	10208	1	0	\N
322077	1874	14313000	20268	10208	2	0	\N
322086	1678	23040757021000	20271	10209	0	0	\N
322087	1874	14316000	20271	10209	1	0	\N
322088	1874	14319000	20271	10209	2	0	\N
322089	1678	23040757021000	20272	10209	0	0	\N
322090	1874	14315000	20272	10209	1	0	\N
322091	1874	14318000	20272	10209	2	0	\N
322092	1874	14320000	20272	10209	3	0	\N
322093	1874	14323000	20272	10209	4	0	\N
322094	1678	23040757022000	20273	10210	0	0	\N
322095	1678	23040757023000	20273	10210	1	0	\N
322096	1874	14324000	20273	10210	2	0	\N
322097	1874	14326000	20273	10210	3	0	\N
322098	1874	14328000	20273	10210	4	0	\N
322099	1874	14331000	20273	10210	5	0	\N
322100	1874	14334000	20273	10210	6	0	\N
322121	1678	23040757026000	20277	10212	0	0	\N
322122	1678	23040757027000	20277	10212	1	0	\N
322123	1874	14348000	20277	10212	2	0	\N
322124	1874	14351000	20277	10212	3	0	\N
322125	1874	14353000	20277	10212	4	0	\N
322126	1874	14355000	20277	10212	5	0	\N
322127	1484	0	20278	9953	0	0	\N
322128	1497	0	20278	9953	1	0	\N
322129	1009	505985775000000	20278	9953	2	0	\N
322130	1129	906722465000000	20278	9953	3	0	\N
322131	1249	611783750000000	20278	9953	4	0	\N
322132	1375	1704789637751650	20278	9953	5	0	\N
322133	365	66667801000000	20278	9953	6	0	\N
322134	2011	1475000000000	20278	9953	7	0	\N
322135	1460	0	20278	9953	8	0	\N
322136	365	66668501000000	20278	9953	9	0	\N
322137	365	66716501000000	20278	9953	10	0	\N
322138	365	66717301000000	20278	9953	11	0	\N
322139	1282	1713369637751650	20278	9953	12	0	\N
322140	1036	911287465000000	20278	9953	13	0	\N
322141	1156	614864750000000	20278	9953	14	0	\N
322142	916	508533775000000	20278	9953	15	0	\N
322143	1330	1706840637751650	20278	9953	16	0	\N
322144	1204	612520750000000	20278	9953	17	0	\N
322145	1084	907813465000000	20278	9953	18	0	\N
322146	964	506595775000000	20278	9953	19	0	\N
322147	966	506675775000000	20278	9953	20	0	\N
322148	1086	907959465000000	20278	9953	21	0	\N
322149	1206	612618750000000	20278	9953	22	0	\N
322150	1332	1707114637751650	20278	9953	23	0	\N
322151	104	66631395942306	20278	9953	24	0	\N
322152	199	66631395942306	20278	9953	25	0	\N
322153	214	66631395942306	20278	9953	26	0	\N
322154	234	66631395942306	20278	9953	27	0	\N
322155	282	66631395942306	20278	9953	28	0	\N
322156	314	66631395942306	20278	9953	29	0	\N
322157	323	66631395942306	20278	9953	30	0	\N
322158	330	66631395942306	20278	9953	31	0	\N
322159	332	66631395942306	20278	9953	32	0	\N
322160	334	66631395942306	20278	9953	33	0	\N
322161	343	66631395942306	20278	9953	34	0	\N
322162	1382	1712413637751650	20278	9953	36	0	\N
322163	1136	910778465000000	20278	9953	37	0	\N
322164	1256	614519750000000	20278	9953	38	0	\N
322165	1016	508248775000000	20278	9953	39	0	\N
322166	1357	1712398137751650	20278	9953	40	0	\N
322167	1299	1704974641817750	20278	9953	41	0	\N
322168	1985	2300000000000	20278	9953	42	0	\N
322169	1365	1710262743410483	20278	9953	43	0	\N
322170	1678	21600733673000	20278	9953	44	0	\N
322171	913	506003823451523	20278	9953	45	0	\N
322172	1460	0	20278	9953	46	0	\N
322173	976	507233775000000	20278	9953	47	0	\N
322174	2213	650232116779	20278	9953	48	0	\N
322175	1222	613662117612488	20278	9953	49	0	\N
322176	914	507519164923296	20278	9953	50	0	\N
322177	1034	909469995118336	20278	9953	51	0	\N
322178	1154	613637528176164	20278	9953	52	0	\N
322179	948	507975167870000	20278	9953	53	0	\N
322180	1068	910287148470000	20278	9953	54	0	\N
322181	1313	1709341167751650	20278	9953	55	0	\N
322182	1067	909143245000000	20278	9953	56	0	\N
322183	1124	910301631000000	20278	9953	57	0	\N
322184	1001	507702275000000	20278	9953	58	0	\N
322064	1874	14295000	20265	10206	2	0	2
322065	1874	14297000	20265	10206	3	0	2
322066	1874	14299000	20265	10206	4	0	2
322067	1874	14302000	20265	10206	5	0	2
322068	1874	14305000	20265	10206	6	0	2
322070	1874	14306000	20266	10207	1	0	2
322071	1874	14308000	20266	10207	2	0	2
322078	1678	23040757020000	20269	10208	0	0	0
322079	1874	14311000	20269	10208	1	0	2
322080	1874	14313000	20269	10208	2	0	2
322082	1874	14315000	20270	10209	1	0	2
322083	1874	14318000	20270	10209	2	0	2
322084	1874	14320000	20270	10209	3	0	2
322085	1874	14323000	20270	10209	4	0	2
322102	1678	23040757023000	20274	10210	1	0	0
322103	1874	14324000	20274	10210	2	0	2
322104	1874	14326000	20274	10210	3	0	2
322105	1874	14328000	20274	10210	4	0	2
322106	1874	14331000	20274	10210	5	0	2
322108	1678	23040757024000	20275	10211	0	0	0
322109	1678	23040757025000	20275	10211	1	0	0
322110	1874	14337000	20275	10211	2	0	2
322111	1874	14338000	20275	10211	3	0	2
322112	1874	14340000	20275	10211	4	0	2
322114	1874	14345000	20275	10211	6	0	2
322115	1678	23040757026000	20276	10212	0	0	0
322116	1678	23040757027000	20276	10212	1	0	0
322117	1874	14348000	20276	10212	2	0	2
322119	1874	14353000	20276	10212	4	0	2
322120	1874	14355000	20276	10212	5	0	2
322185	1241	613859250000000	20278	9953	59	0	\N
322186	1280	1709955533869714	20278	9953	60	0	\N
322187	1678	21600733674000	20278	9953	61	0	\N
322188	1305	1709013975785189	20278	9953	62	0	\N
322189	1179	613299639053204	20278	9953	63	0	\N
322190	1059	908969210852514	20278	9953	64	0	\N
322191	939	507239718081690	20278	9953	65	0	\N
322192	1119	909633389928309	20278	9953	66	0	\N
322193	1239	613747773910318	20278	9953	67	0	\N
322194	1111	910769145000000	20278	9953	68	0	\N
322195	1231	614514090000000	20278	9953	69	0	\N
322196	991	508244145000000	20278	9953	70	0	\N
322197	272	67581824000000	20278	9953	71	0	\N
322198	319	66717580000000	20278	9953	72	0	\N
322199	272	68914579000000	20278	9953	74	0	\N
322200	1121	909797965000000	20278	9953	75	0	\N
322201	1326	1709341117751650	20278	9953	76	0	\N
322202	2238	2000000000	20278	9953	77	0	\N
322203	2238	1002000000000	20278	9953	78	0	\N
322204	1295	1707807077084620	20278	9953	79	0	\N
322205	1096	908957465000000	20278	9953	80	0	\N
322206	1216	613292750000000	20278	9953	81	0	\N
322207	1342	1708990637751650	20278	9953	82	0	\N
322208	1371	1710570537751650	20278	9953	83	0	\N
322209	1188	614188877840000	20278	9953	84	0	\N
322210	1314	1711491918671650	20278	9953	85	0	\N
322211	1348	1710024054520435	20278	9953	87	0	\N
322212	1244	614198650000000	20278	9953	88	0	\N
322213	1370	1711519148751650	20278	9953	89	0	\N
322214	1004	507983250000000	20278	9953	90	0	\N
322215	982	507539502027242	20278	9953	91	0	\N
322216	271	66651395291044	20278	9953	92	0	\N
322217	269	66651405291044	20278	9953	93	0	\N
322218	577	66651405291044	20278	9953	94	0	\N
322219	2246	2602651968305	20278	9953	95	0	\N
322220	1102	909506439034341	20278	9953	96	0	\N
322221	242	66651405291044	20278	9953	97	0	\N
322222	38	66383534720208	20278	9953	98	0	\N
322223	969	505695553414336	20278	9953	99	0	\N
322224	1053	906821162404900	20278	9953	100	0	\N
322225	1173	611850449546800	20278	9953	101	0	\N
322226	933	506041764067500	20278	9953	102	0	\N
322227	1049	908328241448562	20278	9953	103	0	\N
322228	1187	613417050000000	20278	9953	104	0	\N
322229	1089	906202098918976	20278	9953	105	0	\N
322230	1209	611432613493024	20278	9953	106	0	\N
322231	22	22510193128616	20278	9953	107	0	\N
322232	190	66544510726895	20278	9953	108	0	\N
322233	258	66544510726895	20278	9953	109	0	\N
322234	273	66544510726895	20278	9953	110	0	\N
322235	1594	8402053000000	20278	9953	111	0	\N
322236	1200	613417050000000	20278	9953	112	0	\N
322237	1080	909143225000000	20278	9953	113	0	\N
322238	999	507610345498755	20278	9953	114	0	\N
322239	292	66544510726895	20278	9953	115	0	\N
322240	293	66544510726895	20278	9953	116	0	\N
322241	333	66209510726895	20278	9953	117	0	\N
322242	376	66544510726895	20278	9953	118	0	\N
322243	426	66544510726895	20278	9953	119	0	\N
322244	429	66544510726895	20278	9953	120	0	\N
322245	430	66544510726895	20278	9953	121	0	\N
322246	440	66544510726895	20278	9953	122	0	\N
322247	474	66544510726895	20278	9953	123	0	\N
322248	475	66544510726895	20278	9953	124	0	\N
322249	476	66544510726895	20278	9953	125	0	\N
322250	1678	23040757028000	20279	10213	0	0	\N
322251	1874	14358000	20279	10213	1	0	\N
322252	1874	14360000	20279	10213	2	0	\N
322253	1874	14361000	20279	10213	3	0	\N
322254	1678	23040757028000	20280	10213	0	0	\N
322255	1874	14358000	20280	10213	1	0	\N
322256	1874	14360000	20280	10213	2	0	\N
322257	1874	14361000	20280	10213	3	0	\N
322265	1678	23040757028000	20283	10214	0	0	\N
322266	1678	23040757029000	20283	10214	1	0	\N
322267	1874	14359000	20283	10214	2	0	\N
322268	1874	14362000	20283	10214	3	0	\N
322269	1874	14364000	20283	10214	4	0	\N
322270	1874	14366000	20283	10214	5	0	\N
322271	1678	23040757030000	20284	10215	0	0	\N
322272	1678	23040757031000	20284	10215	1	0	\N
322273	1874	14368000	20284	10215	2	0	\N
322274	1874	14370000	20284	10215	4	0	\N
322275	1874	14373000	20284	10215	5	0	\N
322276	1874	14376000	20284	10215	6	0	\N
322283	1678	23040757030000	20286	10215	0	0	\N
322284	1678	23040757031000	20286	10215	1	0	\N
322285	1874	14368000	20286	10215	2	0	\N
322286	1874	14370000	20286	10215	4	0	\N
322287	1874	14373000	20286	10215	5	0	\N
322288	1874	14376000	20286	10215	6	0	\N
322289	1678	23040757032000	20287	10216	0	0	\N
322290	1678	23040757033000	20287	10216	1	0	\N
322291	1874	14379000	20287	10216	2	0	\N
322292	1874	14382000	20287	10216	3	0	\N
322293	1874	14383000	20287	10216	4	0	\N
322294	1678	23040757032000	20288	10216	0	0	\N
322295	1678	23040757033000	20288	10216	1	0	\N
322296	1874	14378000	20288	10216	2	0	\N
322297	1874	14381000	20288	10216	3	0	\N
322298	1874	14384000	20288	10216	4	0	\N
322299	1874	14386000	20288	10216	5	0	\N
322300	1874	14387000	20288	10216	6	0	\N
322301	1678	23040757032000	20289	10216	0	0	\N
322302	1678	23040757033000	20289	10216	1	0	\N
322303	1874	14378000	20289	10216	2	0	\N
322304	1874	14381000	20289	10216	3	0	\N
322305	1874	14384000	20289	10216	4	0	\N
322306	1874	14386000	20289	10216	5	0	\N
322307	1874	14387000	20289	10216	6	0	\N
322315	1678	23040757032000	20291	10216	0	0	\N
322316	1678	23040757033000	20291	10216	1	0	\N
322317	1874	14378000	20291	10216	2	0	\N
322318	1874	14381000	20291	10216	3	0	\N
322319	1874	14384000	20291	10216	4	0	\N
322320	1874	14386000	20291	10216	5	0	\N
322260	1678	23040757029000	20282	10214	1	0	0
322261	1874	14359000	20282	10214	2	0	2
322262	1874	14362000	20282	10214	3	0	2
322263	1874	14364000	20282	10214	4	0	2
322264	1874	14366000	20282	10214	5	0	2
322278	1678	23040757031000	20285	10215	1	0	0
322279	1874	14368000	20285	10215	2	0	2
322280	1874	14370000	20285	10215	4	0	2
322281	1874	14373000	20285	10215	5	0	2
322282	1874	14376000	20285	10215	6	0	2
322309	1678	23040757033000	20290	10216	1	0	0
322310	1874	14378000	20290	10216	2	0	2
322311	1874	14381000	20290	10216	3	0	2
322312	1874	14384000	20290	10216	4	0	2
322314	1874	14387000	20290	10216	6	0	2
322321	1874	14387000	20291	10216	6	0	\N
322322	1678	23040757032000	20292	10216	0	0	\N
322323	1678	23040757033000	20292	10216	1	0	\N
322324	1874	14378000	20292	10216	2	0	\N
322325	1874	14381000	20292	10216	3	0	\N
322326	1874	14384000	20292	10216	4	0	\N
322327	1874	14386000	20292	10216	5	0	\N
322328	1874	14387000	20292	10216	6	0	\N
322329	1678	23040757032000	20293	10216	0	0	\N
322330	1678	23040757033000	20293	10216	1	0	\N
322331	1874	14378000	20293	10216	2	0	\N
322332	1874	14381000	20293	10216	3	0	\N
322333	1874	14384000	20293	10216	4	0	\N
322334	1874	14386000	20293	10216	5	0	\N
322335	1874	14387000	20293	10216	6	0	\N
322336	1678	23040757034000	20294	10217	0	0	\N
322337	1874	14389000	20294	10217	1	0	\N
322338	1874	14392000	20294	10217	2	0	\N
322358	1678	23040757040000	20298	10220	0	0	\N
322359	1874	14419000	20298	10220	1	0	\N
322360	1874	14421000	20298	10220	2	0	\N
322377	1678	23040757044000	20303	10223	0	0	\N
322378	1874	14440000	20303	10223	1	0	\N
322379	1874	14442000	20303	10223	2	0	\N
322394	1678	23040757049000	20307	10227	0	0	\N
322395	1874	14466000	20307	10227	1	0	\N
322396	1874	14469000	20307	10227	2	0	\N
322413	1678	23040757053000	20312	10230	0	0	\N
322414	1874	14487000	20312	10230	1	0	\N
322415	1874	14490000	20312	10230	2	0	\N
322416	1678	23040757053000	20313	10230	0	0	\N
322417	1874	14488000	20313	10230	1	0	\N
322421	1678	23040757055000	20315	10232	0	0	\N
322422	1874	14498000	20315	10232	1	0	\N
322423	1874	14499000	20315	10232	2	0	\N
322424	1874	14501000	20315	10232	3	0	\N
322427	1678	23040757055000	20317	10232	0	0	\N
322428	1874	14498000	20317	10232	1	0	\N
322429	1874	14499000	20317	10232	2	0	\N
322430	1874	14501000	20317	10232	3	0	\N
322439	1678	23040757055000	20319	10233	0	0	\N
322440	1678	23040757056000	20319	10233	1	0	\N
322441	1678	23040757057000	20319	10233	2	0	\N
322442	1678	23040757058000	20319	10233	3	0	\N
322443	1874	14501000	20319	10233	4	0	\N
322444	1874	14503000	20319	10233	5	0	\N
322445	1874	14505000	20319	10233	6	0	\N
322446	1874	14507000	20319	10233	7	0	\N
322447	1874	14508000	20319	10233	8	0	\N
322448	1874	14511000	20319	10233	9	0	\N
322449	1874	14514000	20319	10233	10	0	\N
322450	1874	14517000	20319	10233	12	0	\N
322341	1874	14392000	20295	10217	2	0	2
322342	1678	23040757035000	20296	10218	0	0	0
322343	1678	23040757036000	20296	10218	1	0	0
322344	1678	23040757037000	20296	10218	2	0	0
322345	1874	14395000	20296	10218	3	0	2
322347	1874	14399000	20296	10218	5	0	2
322348	1874	14401000	20296	10218	6	0	2
322349	1874	14404000	20296	10218	7	0	2
322350	1874	14405000	20296	10218	8	0	2
322351	1678	23040757038000	20297	10219	0	0	0
322353	1874	14408000	20297	10219	2	0	2
322354	1874	14410000	20297	10219	3	0	2
322355	1874	14412000	20297	10219	4	0	2
322356	1874	14415000	20297	10219	5	0	2
322361	1678	23040757040000	20299	10220	0	0	0
322362	1874	14419000	20299	10220	1	0	2
322363	1874	14421000	20299	10220	2	0	2
322364	1678	23040757041000	20300	10221	0	0	0
322365	1678	23040757042000	20300	10221	1	0	0
322367	1874	14426000	20300	10221	3	0	2
322368	1874	14428000	20300	10221	4	0	2
322369	1874	14431000	20300	10221	5	0	2
322370	1874	14432000	20300	10221	6	0	2
322371	1678	23040757043000	20301	10222	0	0	0
322373	1874	14437000	20301	10222	2	0	2
322374	1678	23040757044000	20302	10223	0	0	0
322375	1874	14440000	20302	10223	1	0	2
322376	1874	14442000	20302	10223	2	0	2
322381	1874	14445000	20304	10224	1	0	2
322382	1874	14446000	20304	10224	2	0	2
322383	1874	14448000	20304	10224	3	0	2
322384	1678	23040757046000	20305	10225	0	0	0
322385	1874	14450000	20305	10225	1	0	2
322387	1678	23040757047000	20306	10226	0	0	0
322388	1678	23040757048000	20306	10226	1	0	0
322389	1874	14456000	20306	10226	2	0	2
322390	1874	14457000	20306	10226	3	0	2
322391	1874	14459000	20306	10226	4	0	2
322393	1874	14464000	20306	10226	6	0	2
322397	1678	23040757049000	20308	10227	0	0	0
322398	1874	14466000	20308	10227	1	0	2
322399	1874	14469000	20308	10227	2	0	2
322401	1874	14472000	20309	10228	1	0	2
322402	1874	14474000	20309	10228	2	0	2
322403	1678	23040757051000	20310	10229	0	0	0
322404	1678	23040757052000	20310	10229	1	0	0
322405	1874	14475000	20310	10229	2	0	2
322407	1874	14481000	20310	10229	4	0	2
322408	1874	14483000	20310	10229	5	0	2
322409	1874	14485000	20310	10229	6	0	2
322410	1678	23040757053000	20311	10230	0	0	0
322411	1874	14487000	20311	10230	1	0	2
322418	1678	23040757054000	20314	10231	0	0	0
322419	1874	14493000	20314	10231	1	0	2
322420	1874	14495000	20314	10231	2	0	2
322425	1874	14498000	20316	10232	0	0	2
322431	1678	23040757055000	20318	10233	0	0	0
322432	1678	23040757056000	20318	10233	1	0	0
322433	1678	23040757057000	20318	10233	2	0	0
322434	1678	23040757058000	20318	10233	3	0	0
322435	1874	14500000	20318	10233	4	0	2
322437	1874	14506000	20318	10233	6	0	2
322438	1874	14509000	20318	10233	7	0	2
322451	1678	23040757059000	20320	10234	0	0	0
322452	531	66683261448682	20320	10234	2	0	0
322453	1874	14512000	20320	10234	3	0	2
322455	1874	14516000	20320	10234	5	0	2
322456	1874	14518000	20320	10234	6	0	2
322469	1678	23040757062000	20322	10236	0	0	\N
322470	1874	14535000	20322	10236	1	0	\N
322471	1874	14536000	20322	10236	2	0	\N
322472	1874	14538000	20322	10236	3	0	\N
322473	1678	23040757062000	20323	10236	0	0	\N
322474	1874	14535000	20323	10236	1	0	\N
322475	1874	14536000	20323	10236	2	0	\N
322476	1874	14538000	20323	10236	3	0	\N
322477	1678	23040757062000	20324	10236	0	0	\N
322478	1874	14535000	20324	10236	1	0	\N
322479	1874	14536000	20324	10236	2	0	\N
322480	1874	14538000	20324	10236	3	0	\N
322481	1678	23040757062000	20325	10236	0	0	\N
322482	1874	14535000	20325	10236	1	0	\N
322483	1874	14536000	20325	10236	2	0	\N
322484	1874	14538000	20325	10236	3	0	\N
322494	1678	23040757063000	20328	10237	0	0	\N
322495	1678	23040757064000	20328	10237	1	0	\N
322496	1874	14540000	20328	10237	2	0	\N
322497	1874	14543000	20328	10237	3	0	\N
322498	1874	14545000	20328	10237	4	0	\N
322499	1295	1707807077084620	20329	10185	0	0	\N
322500	914	507519164923296	20329	10185	1	0	\N
322501	1034	909469995118336	20329	10185	2	0	\N
322502	1154	613637528176164	20329	10185	3	0	\N
322503	1678	23040756986000	20329	10185	4	0	\N
322504	1280	1709955533869714	20329	10185	5	0	\N
322505	1678	23040756987000	20329	10185	6	0	\N
322506	1678	23040756988000	20329	10185	7	0	\N
322507	1049	908328241448562	20329	10185	8	0	\N
322508	1169	612867818037067	20329	10185	9	0	\N
322509	929	506882910895171	20329	10185	10	0	\N
322510	1678	23040756989000	20329	10185	11	0	\N
322511	1678	23040756990000	20329	10185	12	0	\N
322512	1678	23040756991000	20329	10185	13	0	\N
322513	1678	23040756992000	20329	10185	14	0	\N
322514	1678	23040756993000	20329	10185	15	0	\N
322515	1678	23040756994000	20329	10185	16	0	\N
322516	1678	23040756995000	20329	10185	17	0	\N
322517	1678	23040756996000	20329	10185	18	0	\N
322518	1678	23040756997000	20329	10185	19	0	\N
322519	1678	23040756998000	20329	10185	20	0	\N
322520	1678	23040756999000	20329	10185	21	0	\N
322521	1678	23040757000000	20329	10185	22	0	\N
322522	1678	23040757001000	20329	10185	23	0	\N
322523	1678	23040757002000	20329	10185	24	0	\N
322524	1678	23040757003000	20329	10185	25	0	\N
322525	1678	23040757004000	20329	10185	26	0	\N
322526	1678	23040757005000	20329	10185	27	0	\N
322527	1678	23040757006000	20329	10185	28	0	\N
322528	1678	23040757007000	20329	10185	29	0	\N
322529	1678	23040757008000	20329	10185	30	0	\N
322530	1678	23040757009000	20329	10185	31	0	\N
322531	1678	23040757010000	20329	10185	32	0	\N
322532	1678	23040757011000	20329	10185	33	0	\N
322533	1678	23040757012000	20329	10185	34	0	\N
322534	1678	23040757013000	20329	10185	35	0	\N
322535	1678	23040757014000	20329	10185	36	0	\N
322536	1678	23040757015000	20329	10185	37	0	\N
322537	1678	23040757016000	20329	10185	38	0	\N
322538	1678	23040757017000	20329	10185	39	0	\N
322539	1678	23040757018000	20329	10185	40	0	\N
322540	1678	23040757019000	20329	10185	41	0	\N
322541	1678	23040757020000	20329	10185	42	0	\N
322542	1678	23040757021000	20329	10185	43	0	\N
322543	1678	23040757022000	20329	10185	44	0	\N
322544	1678	23040757023000	20329	10185	45	0	\N
322545	1678	23040757024000	20329	10185	46	0	\N
322546	1678	23040757025000	20329	10185	47	0	\N
322547	1678	23040757026000	20329	10185	48	0	\N
322548	1678	23040757027000	20329	10185	49	0	\N
322549	1678	23040757028000	20329	10185	50	0	\N
322550	1678	23040757029000	20329	10185	51	0	\N
322551	1678	23040757030000	20329	10185	52	0	\N
322552	1678	23040757031000	20329	10185	53	0	\N
322553	1678	23040757032000	20329	10185	54	0	\N
322554	1678	23040757033000	20329	10185	55	0	\N
322555	1678	23040757034000	20329	10185	56	0	\N
322556	1678	23040757035000	20329	10185	57	0	\N
322557	1678	23040757036000	20329	10185	58	0	\N
322558	1678	23040757037000	20329	10185	59	0	\N
322559	1678	23040757038000	20329	10185	60	0	\N
322560	1678	23040757039000	20329	10185	61	0	\N
322561	1678	23040757040000	20329	10185	62	0	\N
322562	1678	23040757041000	20329	10185	63	0	\N
322563	1678	23040757042000	20329	10185	64	0	\N
322564	1678	23040757043000	20329	10185	65	0	\N
322565	1678	23040757044000	20329	10185	66	0	\N
322566	1678	23040757045000	20329	10185	67	0	\N
322567	1678	23040757046000	20329	10185	68	0	\N
322568	1678	23040757047000	20329	10185	69	0	\N
322569	1678	23040757048000	20329	10185	70	0	\N
322570	1678	23040757049000	20329	10185	71	0	\N
322571	1678	23040757050000	20329	10185	72	0	\N
322572	1678	23040757051000	20329	10185	73	0	\N
322573	1678	23040757052000	20329	10185	74	0	\N
322574	1678	23040757053000	20329	10185	75	0	\N
322575	1678	23040757054000	20329	10185	76	0	\N
322576	1678	23040757055000	20329	10185	77	0	\N
322577	1678	23040757056000	20329	10185	78	0	\N
322578	1678	23040757057000	20329	10185	79	0	\N
322579	1678	23040757058000	20329	10185	80	0	\N
322580	1678	23040757059000	20329	10185	81	0	\N
322581	1678	23040757060000	20329	10185	82	0	\N
322582	1678	23040757061000	20329	10185	83	0	\N
322583	1678	23040757062000	20329	10185	84	0	\N
322584	1678	23040757063000	20329	10185	85	0	\N
322585	1678	23040757064000	20329	10185	86	0	\N
322586	531	66683261448682	20329	10185	87	0	\N
322587	1874	14136000	20329	10185	88	0	\N
322588	1874	14139000	20329	10185	89	0	\N
322589	1874	14142000	20329	10185	91	0	\N
322590	1874	14145000	20329	10185	92	0	\N
322591	1874	14148000	20329	10185	93	0	\N
322592	1874	14151000	20329	10185	94	0	\N
322459	984	507975067800536	20320	10234	9	0	0
322460	1104	910286969168176	20320	10234	10	0	0
322461	1224	614188756846949	20320	10234	11	0	0
322462	1350	1711491581573374	20320	10234	12	0	0
322463	1678	23040757060000	20321	10235	0	0	0
322465	1874	14525000	20321	10235	2	0	2
322466	1874	14528000	20321	10235	3	0	2
322467	1874	14530000	20321	10235	4	0	2
322468	1874	14532000	20321	10235	5	0	2
322485	1678	23040757062000	20326	10236	0	0	0
322487	1874	14536000	20326	10236	2	0	2
322488	1874	14538000	20326	10236	3	0	2
322489	1678	23040757063000	20327	10237	0	0	0
322490	1678	23040757064000	20327	10237	1	0	0
322492	1874	14543000	20327	10237	3	0	2
322493	1874	14545000	20327	10237	4	0	2
322593	1874	14153000	20329	10185	95	0	\N
322594	1874	14155000	20329	10185	96	0	\N
322595	1874	14157000	20329	10185	97	0	\N
322596	1874	14159000	20329	10185	98	0	\N
322597	1874	14161000	20329	10185	99	0	\N
322598	1874	14163000	20329	10185	100	0	\N
322599	1874	14165000	20329	10185	101	0	\N
322600	1874	14166000	20329	10185	102	0	\N
322601	1874	14167000	20329	10185	103	0	\N
322602	1874	14168000	20329	10185	104	0	\N
322603	1874	14169000	20329	10185	105	0	\N
322604	1874	14170000	20329	10185	106	0	\N
322605	1874	14171000	20329	10185	107	0	\N
322606	984	507975067800536	20329	10185	108	0	\N
322607	1104	910286969168176	20329	10185	109	0	\N
322608	1224	614188756846949	20329	10185	110	0	\N
322609	1350	1711491581573374	20329	10185	111	0	\N
322610	1874	14173000	20329	10185	112	0	\N
322611	1874	14175000	20329	10185	113	0	\N
322612	1874	14177000	20329	10185	114	0	\N
322613	1874	14179000	20329	10185	115	0	\N
322614	1874	14181000	20329	10185	116	0	\N
322615	1874	14183000	20329	10185	117	0	\N
322616	1874	14185000	20329	10185	118	0	\N
322617	1874	14187000	20329	10185	119	0	\N
322618	1874	14189000	20329	10185	120	0	\N
322619	1874	14191000	20329	10185	121	0	\N
322620	1874	14193000	20329	10185	122	0	\N
322621	1874	14195000	20329	10185	123	0	\N
322622	1874	14197000	20329	10185	124	0	\N
322623	1874	14199000	20329	10185	125	0	\N
322624	1678	23040757065000	20330	10238	0	0	\N
322625	1874	14547000	20330	10238	1	0	\N
322626	1874	14550000	20330	10238	2	0	\N
322627	1874	14551000	20330	10238	3	0	\N
322651	1678	23040757070000	20336	10242	0	0	\N
322652	1678	23040757071000	20336	10242	1	0	\N
322653	1874	14574000	20336	10242	2	0	\N
322654	1874	14577000	20336	10242	3	0	\N
322655	1874	14579000	20336	10242	4	0	\N
322656	1874	14582000	20336	10242	5	0	\N
322661	1678	23040757073000	20338	10244	0	0	\N
322662	1874	14591000	20338	10244	1	0	\N
322663	1874	14593000	20338	10244	2	0	\N
322664	946	508296362263440	20338	10244	3	0	\N
322665	1066	910862659299040	20338	10244	4	0	\N
322666	1186	614577322024710	20338	10244	5	0	\N
322673	1678	23040757073000	20340	10244	0	0	\N
322674	1874	14591000	20340	10244	1	0	\N
322675	1874	14593000	20340	10244	2	0	\N
322676	946	508296362263440	20340	10244	3	0	\N
322677	1066	910862659299040	20340	10244	4	0	\N
322678	1186	614577322024710	20340	10244	5	0	\N
322679	1678	23040757063000	20341	10237	0	0	\N
322680	1678	23040757064000	20341	10237	1	0	\N
322681	1678	23040757065000	20341	10237	2	0	\N
322682	1678	23040757066000	20341	10237	3	0	\N
322683	1678	23040757067000	20341	10237	4	0	\N
322684	1678	23040757068000	20341	10237	5	0	\N
322685	1678	23040757069000	20341	10237	6	0	\N
322686	1678	23040757070000	20341	10237	7	0	\N
322687	1678	23040757071000	20341	10237	8	0	\N
322688	1678	23040757072000	20341	10237	9	0	\N
322689	1678	23040757073000	20341	10237	10	0	\N
322690	1874	14540000	20341	10237	11	0	\N
322691	1874	14543000	20341	10237	12	0	\N
322692	1874	14545000	20341	10237	13	0	\N
322693	1874	14547000	20341	10237	14	0	\N
322694	1874	14549000	20341	10237	15	0	\N
322695	1874	14551000	20341	10237	16	0	\N
322696	1874	14553000	20341	10237	17	0	\N
322697	1874	14555000	20341	10237	18	0	\N
322698	1874	14557000	20341	10237	19	0	\N
322699	1874	14559000	20341	10237	20	0	\N
322700	1874	14561000	20341	10237	21	0	\N
322701	1874	14563000	20341	10237	22	0	\N
322702	1874	14566000	20341	10237	23	0	\N
322703	1874	14567000	20341	10237	24	0	\N
322704	1874	14568000	20341	10237	25	0	\N
322705	1874	14569000	20341	10237	26	0	\N
322706	946	508296362263440	20341	10237	27	0	\N
322707	1066	910862659299040	20341	10237	28	0	\N
322708	1186	614577322024710	20341	10237	29	0	\N
322709	1874	14572000	20341	10237	30	0	\N
322710	1874	14575000	20341	10237	31	0	\N
322711	1874	14578000	20341	10237	32	0	\N
322712	1874	14581000	20341	10237	33	0	\N
322713	1874	14584000	20341	10237	34	0	\N
322714	1874	14587000	20341	10237	35	0	\N
322715	1874	14590000	20341	10237	36	0	\N
322716	1874	14593000	20341	10237	37	0	\N
322717	1678	23040757074000	20342	10245	0	0	\N
322718	1678	23040757075000	20342	10245	1	0	\N
322719	1874	14596000	20342	10245	2	0	\N
322720	1874	14598000	20342	10245	3	0	\N
322721	1874	14600000	20342	10245	4	0	\N
322630	1874	14550000	20331	10238	2	0	2
322631	1874	14551000	20331	10238	3	0	2
322632	1678	23040757066000	20332	10239	0	0	0
322633	1874	14553000	20332	10239	1	0	2
322634	1874	14556000	20332	10239	2	0	2
322636	1874	14559000	20333	10240	1	0	2
322637	1874	14561000	20333	10240	2	0	2
322638	1678	23040757068000	20334	10241	0	0	0
322639	1678	23040757069000	20334	10241	1	0	0
322640	1874	14562000	20334	10241	2	0	2
322642	1874	14566000	20334	10241	4	0	2
322643	1874	14569000	20334	10241	5	0	2
322644	1874	14572000	20334	10241	6	0	2
322645	1678	23040757070000	20335	10242	0	0	0
322647	1874	14574000	20335	10242	2	0	2
322648	1874	14577000	20335	10242	3	0	2
322649	1874	14579000	20335	10242	4	0	2
322650	1874	14582000	20335	10242	5	0	2
322657	1678	23040757072000	20337	10243	0	0	0
322659	1874	14587000	20337	10243	2	0	2
322660	1874	14588000	20337	10243	3	0	2
322667	1678	23040757073000	20339	10244	0	0	0
322668	1874	14591000	20339	10244	1	0	2
322669	1874	14593000	20339	10244	2	0	2
322671	1066	910862659299040	20339	10244	4	0	0
322672	1186	614577322024710	20339	10244	5	0	0
322722	1678	23040757074000	20343	10245	0	0	0
322723	1678	23040757075000	20343	10245	1	0	0
322725	1874	14598000	20343	10245	3	0	2
322726	1874	14600000	20343	10245	4	0	2
322727	1678	23040757076000	20344	10246	0	0	0
322728	1678	23040757077000	20344	10246	1	0	0
322733	1678	23040757078000	20345	10247	0	0	\N
322734	1874	14613000	20345	10247	1	0	\N
322735	1874	14615000	20345	10247	2	0	\N
322751	1678	23040757083000	20349	10250	0	0	\N
322752	1874	14637000	20349	10250	1	0	\N
322753	1874	14640000	20349	10250	2	0	\N
322757	1678	23040757083000	20351	10250	0	0	\N
322758	1874	14637000	20351	10250	1	0	\N
322759	1874	14640000	20351	10250	2	0	\N
322760	1678	23040757083000	20352	10250	0	0	\N
322761	1874	14637000	20352	10250	1	0	\N
322762	1874	14640000	20352	10250	2	0	\N
322763	1678	23040757083000	20353	10250	0	0	\N
322764	1874	14637000	20353	10250	1	0	\N
322765	1874	14640000	20353	10250	2	0	\N
322771	1678	23040757085000	20356	10252	0	0	\N
322772	1874	14644000	20356	10252	2	0	\N
322773	1874	14647000	20356	10252	3	0	\N
322783	1678	23040757074000	20359	10245	0	0	\N
322784	1678	23040757075000	20359	10245	1	0	\N
322785	1678	23040757076000	20359	10245	2	0	\N
322786	1678	23040757077000	20359	10245	3	0	\N
322787	1678	23040757078000	20359	10245	4	0	\N
322788	1678	23040757079000	20359	10245	5	0	\N
322789	1678	23040757080000	20359	10245	6	0	\N
322790	1678	23040757081000	20359	10245	7	0	\N
322791	1678	23040757082000	20359	10245	8	0	\N
322792	1678	23040757083000	20359	10245	9	0	\N
322793	1678	23040757084000	20359	10245	10	0	\N
322794	1678	23040757085000	20359	10245	11	0	\N
322795	1678	23040757086000	20359	10245	12	0	\N
322796	1678	23040757087000	20359	10245	13	0	\N
322797	1678	23040757088000	20359	10245	14	0	\N
322798	1678	23040757089000	20359	10245	15	0	\N
322799	1874	14596000	20359	10245	16	0	\N
322800	1874	14599000	20359	10245	17	0	\N
322801	1874	14602000	20359	10245	18	0	\N
322802	1874	14605000	20359	10245	19	0	\N
322803	1874	14608000	20359	10245	20	0	\N
322804	1874	14611000	20359	10245	21	0	\N
322805	1874	14614000	20359	10245	22	0	\N
322806	1874	14617000	20359	10245	23	0	\N
322807	1874	14620000	20359	10245	24	0	\N
322808	1874	14623000	20359	10245	25	0	\N
322809	1874	14626000	20359	10245	26	0	\N
322810	1874	14629000	20359	10245	27	0	\N
322811	1874	14632000	20359	10245	28	0	\N
322812	1874	14635000	20359	10245	29	0	\N
322813	1874	14637000	20359	10245	30	0	\N
322814	1874	14639000	20359	10245	31	0	\N
322815	1874	14641000	20359	10245	32	0	\N
322816	1874	14643000	20359	10245	33	0	\N
322817	1874	14645000	20359	10245	34	0	\N
322818	1874	14647000	20359	10245	35	0	\N
322819	1874	14649000	20359	10245	36	0	\N
322820	1874	14651000	20359	10245	37	0	\N
322821	1874	14653000	20359	10245	38	0	\N
322822	1874	14655000	20359	10245	39	0	\N
322823	1874	14657000	20359	10245	40	0	\N
322824	1874	14659000	20359	10245	41	0	\N
322825	1874	14661000	20359	10245	42	0	\N
322826	1874	14663000	20359	10245	43	0	\N
322827	1874	14665000	20359	10245	44	0	\N
322828	1874	14667000	20359	10245	45	0	\N
322842	1678	23040757091000	20363	10257	0	0	\N
322843	1117	909469995118338	20363	10257	1	0	\N
322844	1237	613637528176164	20363	10257	2	0	\N
322845	997	507519164923307	20363	10257	3	0	\N
322846	1874	14675000	20363	10257	4	0	\N
322847	1874	14677000	20363	10257	5	0	\N
322854	1678	23040757093000	20366	10259	0	0	\N
322855	1874	14684000	20366	10259	1	0	\N
322856	1874	14687000	20366	10259	2	0	\N
322731	1874	14607000	20344	10246	4	0	2
322732	1874	14610000	20344	10246	5	0	2
322736	1678	23040757078000	20346	10247	0	0	0
322737	1874	14613000	20346	10247	1	0	2
322738	1874	14615000	20346	10247	2	0	2
322740	1678	23040757080000	20347	10248	1	0	0
322741	1678	23040757081000	20347	10248	2	0	0
322742	1874	14617000	20347	10248	3	0	2
322743	1874	14620000	20347	10248	4	0	2
322744	1874	14623000	20347	10248	5	0	2
322746	1874	14628000	20347	10248	7	0	2
322747	1874	14630000	20347	10248	8	0	2
322748	1678	23040757082000	20348	10249	0	0	0
322749	1874	14633000	20348	10249	1	0	2
322754	1678	23040757083000	20350	10250	0	0	0
322755	1874	14637000	20350	10250	1	0	2
322756	1874	14640000	20350	10250	2	0	2
322766	1678	23040757084000	20354	10251	0	0	0
322767	1874	14642000	20354	10251	1	0	2
322769	1874	14644000	20355	10252	2	0	2
322770	1874	14647000	20355	10252	3	0	2
322774	1678	23040757086000	20357	10253	0	0	0
322775	1874	14650000	20357	10253	1	0	2
322776	1874	14652000	20357	10253	2	0	2
322778	1678	23040757088000	20358	10254	1	0	0
322779	1874	14654000	20358	10254	2	0	2
322780	1874	14657000	20358	10254	3	0	2
322781	1874	14660000	20358	10254	4	0	2
322829	1678	23040757089000	20360	10255	0	0	0
322830	1874	14664000	20360	10255	1	0	2
322831	1874	14667000	20360	10255	2	0	2
322832	1678	23040757090000	20361	10256	0	0	0
322833	1363	1709955533869748	20361	10256	1	0	0
322835	1874	14672000	20361	10256	3	0	2
322836	1678	23040757091000	20362	10257	0	0	0
322837	1117	909469995118338	20362	10257	1	0	0
322838	1237	613637528176164	20362	10257	2	0	0
322839	997	507519164923307	20362	10257	3	0	0
322841	1874	14677000	20362	10257	5	0	2
322848	1678	23040757092000	20364	10258	0	0	0
322849	1874	14679000	20364	10258	1	0	2
322850	1874	14682000	20364	10258	2	0	2
322852	1874	14684000	20365	10259	1	0	2
322853	1874	14687000	20365	10259	2	0	2
322857	1932	1382938664093	20367	10260	0	0	4
322858	1678	23040757094000	20367	10260	1	0	0
322859	1874	14690000	20367	10260	2	0	2
322861	1678	23040757096000	20368	10261	1	0	0
322862	1874	14692000	20368	10261	2	0	2
322863	1874	14694000	20368	10261	3	0	2
322864	1874	14697000	20368	10261	4	0	2
322866	1678	23040757097000	20369	10262	0	0	\N
322867	1874	14702000	20369	10262	1	0	\N
322868	135	66772980736837	20369	10262	2	0	\N
322869	170	66772980736837	20369	10262	3	0	\N
322870	202	66772980736837	20369	10262	4	0	\N
322871	264	66772980736837	20369	10262	5	0	\N
322872	279	66772980736837	20369	10262	6	0	\N
322873	331	66772980736837	20369	10262	7	0	\N
322874	382	66772980736837	20369	10262	8	0	\N
322875	388	66772980736837	20369	10262	9	0	\N
322876	400	66772980736837	20369	10262	10	0	\N
322877	505	66772980736837	20369	10262	11	0	\N
322878	925	508370750766612	20369	10262	12	0	\N
322879	1045	910996029653240	20369	10262	13	0	\N
322880	1165	614667174085221	20369	10262	14	0	\N
322881	1291	1712824733746403	20369	10262	15	0	\N
322899	1678	23040757097000	20371	10262	0	0	\N
322900	1874	14702000	20371	10262	1	0	\N
322901	1874	14705000	20371	10262	2	0	\N
322902	135	66772980736837	20371	10262	3	0	\N
322903	170	66772980736837	20371	10262	4	0	\N
322904	202	66772980736837	20371	10262	5	0	\N
322905	264	66772980736837	20371	10262	6	0	\N
322906	279	66772980736837	20371	10262	7	0	\N
322907	331	66772980736837	20371	10262	8	0	\N
322908	382	66772980736837	20371	10262	9	0	\N
322909	388	66772980736837	20371	10262	10	0	\N
322910	400	66772980736837	20371	10262	11	0	\N
322911	505	66772980736837	20371	10262	12	0	\N
322912	925	508370750766612	20371	10262	13	0	\N
322913	1045	910996029653240	20371	10262	14	0	\N
322914	1165	614667174085221	20371	10262	15	0	\N
322915	1291	1712824733746403	20371	10262	16	0	\N
322923	1678	23040757100000	20374	10265	0	0	\N
322924	1874	14717000	20374	10265	1	0	\N
322925	1874	14720000	20374	10265	2	0	\N
322926	1678	23040757100000	20375	10265	0	0	\N
322927	1874	14717000	20375	10265	1	0	\N
322928	1874	14720000	20375	10265	2	0	\N
322932	1678	23040757100000	20377	10265	0	0	\N
322933	1874	14717000	20377	10265	1	0	\N
322934	1874	14720000	20377	10265	2	0	\N
322935	1678	23040757090000	20378	10246	0	0	\N
322936	1596	20881018000000	20378	10246	1	0	\N
322937	1678	23040757091000	20378	10246	2	0	\N
322938	1678	23040757092000	20378	10246	3	0	\N
322939	1678	23040757093000	20378	10246	4	0	\N
322940	1678	23040757094000	20378	10246	5	0	\N
322941	1678	23040757095000	20378	10246	6	0	\N
322942	1678	23040757096000	20378	10246	7	0	\N
322943	1678	23040757097000	20378	10246	8	0	\N
322944	1678	23040757098000	20378	10246	9	0	\N
322945	1678	23040757099000	20378	10246	10	0	\N
322946	1678	23040757100000	20378	10246	11	0	\N
322947	1678	23040757101000	20378	10246	12	0	\N
322948	1678	23040757102000	20378	10246	13	0	\N
322949	1363	1709955533869748	20378	10246	14	0	\N
322950	1117	909469995118338	20378	10246	15	0	\N
322951	1237	613637528176164	20378	10246	16	0	\N
322952	997	507519164923307	20378	10246	17	0	\N
322953	1932	1382928664093	20378	10246	18	0	\N
322954	135	66772980736837	20378	10246	19	0	\N
322955	1874	14669000	20378	10246	20	0	\N
322956	170	66772980736837	20378	10246	21	0	\N
322957	202	66772980736837	20378	10246	22	0	\N
322958	1874	14672000	20378	10246	23	0	\N
322959	1874	14675000	20378	10246	24	0	\N
322960	1874	14678000	20378	10246	25	0	\N
322961	1874	14681000	20378	10246	26	0	\N
322962	1874	14684000	20378	10246	27	0	\N
322963	1874	14687000	20378	10246	28	0	\N
322964	1874	14690000	20378	10246	29	0	\N
322965	1874	14693000	20378	10246	30	0	\N
322966	1874	14695000	20378	10246	31	0	\N
322967	1874	14697000	20378	10246	32	0	\N
322968	1874	14699000	20378	10246	33	0	\N
322969	1874	14701000	20378	10246	34	0	\N
322970	1874	14703000	20378	10246	35	0	\N
322971	1874	14705000	20378	10246	36	0	\N
322972	1874	14707000	20378	10246	37	0	\N
322973	1874	14709000	20378	10246	38	0	\N
322974	1874	14711000	20378	10246	39	0	\N
322975	1874	14713000	20378	10246	40	0	\N
322976	1874	14716000	20378	10246	41	0	\N
322977	1874	14719000	20378	10246	42	0	\N
322978	264	66772980736837	20378	10246	43	0	\N
322979	279	66772980736837	20378	10246	44	0	\N
322980	331	66772980736837	20378	10246	45	0	\N
322981	382	66772980736837	20378	10246	46	0	\N
322982	388	66772980736837	20378	10246	47	0	\N
322983	400	66772980736837	20378	10246	48	0	\N
322984	1874	14722000	20378	10246	49	0	\N
322985	1874	14725000	20378	10246	50	0	\N
322986	1874	14728000	20378	10246	51	0	\N
322987	505	66772980736837	20378	10246	52	0	\N
322988	925	508370750766612	20378	10246	53	0	\N
322989	1045	910996029653240	20378	10246	54	0	\N
322990	1165	614667174085221	20378	10246	55	0	\N
322991	1291	1712824733746403	20378	10246	56	0	\N
322992	1874	14730000	20378	10246	57	0	\N
322883	1874	14702000	20370	10262	1	0	2
322884	1874	14705000	20370	10262	2	0	2
322885	135	66772980736837	20370	10262	3	0	0
322886	170	66772980736837	20370	10262	4	0	0
322887	202	66772980736837	20370	10262	5	0	0
322889	279	66772980736837	20370	10262	7	0	0
322890	331	66772980736837	20370	10262	8	0	0
322891	382	66772980736837	20370	10262	9	0	0
322892	388	66772980736837	20370	10262	10	0	0
322893	400	66772980736837	20370	10262	11	0	0
322895	925	508370750766612	20370	10262	13	0	0
322896	1045	910996029653240	20370	10262	14	0	0
322897	1165	614667174085221	20370	10262	15	0	0
322898	1291	1712824733746403	20370	10262	16	0	0
322917	1596	720000000000	20372	10263	1	0	16
322918	1874	14707000	20372	10263	2	0	2
322919	1874	14710000	20372	10263	3	0	2
322920	1678	23040757099000	20373	10264	0	0	0
322921	1874	14713000	20373	10264	1	0	2
322929	1678	23040757100000	20376	10265	0	0	0
322930	1874	14717000	20376	10265	1	0	2
322931	1874	14720000	20376	10265	2	0	2
322993	1678	23040757101000	20379	10266	0	0	0
322994	1678	23040757102000	20379	10266	1	0	0
322996	1874	14725000	20379	10266	3	0	2
322997	1874	14728000	20379	10266	4	0	2
322998	1874	14730000	20379	10266	5	0	2
322999	1678	23040757103000	20380	10267	0	0	0
323002	1678	23040757104000	20381	10268	0	0	\N
323003	1874	14737000	20381	10268	1	0	\N
323004	1874	14740000	20381	10268	2	0	\N
323013	1596	20161006000000	20385	10227	0	0	\N
323014	1363	1709955533869748	20385	10227	1	0	\N
323015	1117	909469995118338	20385	10227	2	0	\N
323016	1237	613637528176164	20385	10227	3	0	\N
323017	997	507519164923307	20385	10227	4	0	\N
323018	531	66683261448682	20385	10227	5	0	\N
323019	135	66772980736837	20385	10227	6	0	\N
323020	170	66772980736837	20385	10227	7	0	\N
323021	202	66772980736837	20385	10227	8	0	\N
323022	984	507975067800536	20385	10227	9	0	\N
323023	1104	910286969168176	20385	10227	10	0	\N
323024	1224	614188756846949	20385	10227	11	0	\N
323025	1350	1711491581573374	20385	10227	12	0	\N
323026	264	66772980736837	20385	10227	13	0	\N
323027	279	66772980736837	20385	10227	14	0	\N
323028	331	66772980736837	20385	10227	15	0	\N
323029	382	66772980736837	20385	10227	16	0	\N
323030	388	66772980736837	20385	10227	17	0	\N
323031	400	66772980736837	20385	10227	18	0	\N
323032	946	508296362263440	20385	10227	19	0	\N
323033	1066	910862659299040	20385	10227	20	0	\N
323034	1186	614577322024710	20385	10227	21	0	\N
323035	1312	1712574323973610	20385	10227	22	0	\N
323036	505	66772980736837	20385	10227	23	0	\N
323037	925	508370750766612	20385	10227	24	0	\N
323038	1045	910996029653240	20385	10227	25	0	\N
323039	1165	614667174085221	20385	10227	26	0	\N
323040	1291	1712824733746403	20385	10227	27	0	\N
323044	1678	23040757107000	20387	10271	0	0	\N
323045	1874	14749000	20387	10271	1	0	\N
323046	1874	14752000	20387	10271	2	0	\N
323068	1678	23040757112000	20392	10275	0	0	\N
323069	1678	23040757113000	20392	10275	1	0	\N
323070	1678	23040757114000	20392	10275	2	0	\N
323071	1874	14774000	20392	10275	3	0	\N
323072	1874	14777000	20392	10275	4	0	\N
323073	1874	14780000	20392	10275	5	0	\N
323074	1874	14783000	20392	10275	6	0	\N
323075	1874	14785000	20392	10275	7	0	\N
323076	1874	14787000	20392	10275	8	0	\N
323077	1678	23040757115000	20393	10276	0	0	\N
323078	1874	14790000	20393	10276	1	0	\N
323079	1874	14792000	20393	10276	2	0	\N
323080	1678	23040757115000	20394	10276	0	0	\N
323081	1678	23040757115000	20395	10276	0	0	\N
323082	1874	14790000	20395	10276	1	0	\N
323083	1874	14792000	20395	10276	2	0	\N
323087	1678	23040757115000	20397	10276	0	0	\N
323088	1874	14790000	20397	10276	1	0	\N
323089	1874	14792000	20397	10276	2	0	\N
323092	1596	20161006000000	20399	10186	0	0	\N
323093	1678	23040757065000	20399	10186	1	0	\N
323094	1678	23040757066000	20399	10186	2	0	\N
323095	1678	23040757067000	20399	10186	3	0	\N
323096	1678	23040757068000	20399	10186	4	0	\N
323097	1678	23040757069000	20399	10186	5	0	\N
323098	1678	23040757070000	20399	10186	6	0	\N
323099	1678	23040757071000	20399	10186	7	0	\N
323100	1678	23040757072000	20399	10186	8	0	\N
323101	1678	23040757073000	20399	10186	9	0	\N
323102	1678	23040757074000	20399	10186	10	0	\N
323103	1678	23040757075000	20399	10186	11	0	\N
323104	1678	23040757076000	20399	10186	12	0	\N
323105	1678	23040757077000	20399	10186	13	0	\N
323106	1678	23040757078000	20399	10186	14	0	\N
323107	1678	23040757079000	20399	10186	15	0	\N
323108	1678	23040757080000	20399	10186	16	0	\N
323109	1678	23040757081000	20399	10186	17	0	\N
323110	1678	23040757082000	20399	10186	18	0	\N
323111	1678	23040757083000	20399	10186	19	0	\N
323112	1678	23040757084000	20399	10186	20	0	\N
323113	1678	23040757085000	20399	10186	21	0	\N
323114	1678	23040757086000	20399	10186	22	0	\N
323115	1678	23040757087000	20399	10186	23	0	\N
323116	1678	23040757088000	20399	10186	24	0	\N
323117	1678	23040757089000	20399	10186	25	0	\N
323118	1678	23040757090000	20399	10186	26	0	\N
323119	1678	23040757091000	20399	10186	27	0	\N
323120	1678	23040757092000	20399	10186	28	0	\N
323121	1678	23040757093000	20399	10186	29	0	\N
323122	1678	23040757094000	20399	10186	30	0	\N
323123	1678	23040757095000	20399	10186	31	0	\N
323124	1678	23040757096000	20399	10186	32	0	\N
323125	1678	23040757097000	20399	10186	33	0	\N
323126	1678	23040757098000	20399	10186	34	0	\N
323127	1678	23040757099000	20399	10186	35	0	\N
323128	1678	23040757100000	20399	10186	36	0	\N
323129	1678	23040757101000	20399	10186	37	0	\N
323130	1678	23040757102000	20399	10186	38	0	\N
323131	1678	23040757103000	20399	10186	39	0	\N
323132	1678	23040757104000	20399	10186	40	0	\N
323133	1678	23040757105000	20399	10186	41	0	\N
323134	1678	23040757106000	20399	10186	42	0	\N
323135	1678	23040757107000	20399	10186	43	0	\N
323136	1678	23040757108000	20399	10186	44	0	\N
323006	1874	14737000	20382	10268	1	0	2
323007	1874	14740000	20382	10268	2	0	2
323008	1678	23040757105000	20383	10269	0	0	0
323009	1874	14742000	20383	10269	1	0	2
323010	1678	23040757106000	20384	10270	0	0	0
323012	1874	14747000	20384	10270	2	0	2
323041	1678	23040757107000	20386	10271	0	0	0
323042	1874	14749000	20386	10271	1	0	2
323043	1874	14752000	20386	10271	2	0	2
323047	1678	23040757108000	20389	10273	0	0	0
323049	1678	23040757110000	20389	10273	2	0	0
323050	1874	14754000	20389	10273	3	0	2
323051	1874	14757000	20389	10273	4	0	2
323052	1874	14760000	20389	10273	5	0	2
323054	1874	14765000	20389	10273	7	0	2
323055	1874	14767000	20389	10273	8	0	2
323056	1678	23040757111000	20390	10274	0	0	0
323057	1874	14770000	20390	10274	1	0	2
323058	1874	14772000	20390	10274	2	0	2
323060	1678	23040757113000	20391	10275	1	0	0
323061	1678	23040757114000	20391	10275	2	0	0
323062	1874	14774000	20391	10275	3	0	2
323063	1874	14777000	20391	10275	4	0	2
323064	1874	14780000	20391	10275	5	0	2
323066	1874	14785000	20391	10275	7	0	2
323067	1874	14787000	20391	10275	8	0	2
323084	1678	23040757115000	20396	10276	0	0	0
323085	1874	14790000	20396	10276	1	0	2
323090	1678	23040757116000	20398	10277	0	0	0
323091	1874	14794000	20398	10277	1	0	2
323137	1678	23040757109000	20399	10186	45	0	\N
323138	1678	23040757110000	20399	10186	46	0	\N
323139	1678	23040757111000	20399	10186	47	0	\N
323140	1678	23040757112000	20399	10186	48	0	\N
323141	1678	23040757113000	20399	10186	49	0	\N
323142	1678	23040757114000	20399	10186	50	0	\N
323143	1678	23040757115000	20399	10186	51	0	\N
323144	1363	1709955533869748	20399	10186	52	0	\N
323145	1117	909469995118338	20399	10186	53	0	\N
323146	1237	613637528176164	20399	10186	54	0	\N
323147	997	507519164923307	20399	10186	55	0	\N
323148	1874	14201000	20399	10186	56	0	\N
323149	1874	14203000	20399	10186	57	0	\N
323150	135	66772980736837	20399	10186	58	0	\N
323151	1874	14205000	20399	10186	59	0	\N
323152	1874	14207000	20399	10186	60	0	\N
323153	1874	14209000	20399	10186	61	0	\N
323154	1874	14211000	20399	10186	62	0	\N
323155	170	66772980736837	20399	10186	63	0	\N
323156	202	66772980736837	20399	10186	64	0	\N
323157	1874	14213000	20399	10186	65	0	\N
323158	1874	14215000	20399	10186	66	0	\N
323159	1874	14217000	20399	10186	67	0	\N
323160	1874	14219000	20399	10186	68	0	\N
323161	1874	14221000	20399	10186	69	0	\N
323162	1874	14223000	20399	10186	70	0	\N
323163	1874	14225000	20399	10186	71	0	\N
323164	1874	14227000	20399	10186	72	0	\N
323165	1874	14229000	20399	10186	73	0	\N
323166	1874	14231000	20399	10186	74	0	\N
323167	1874	14233000	20399	10186	75	0	\N
323168	1874	14235000	20399	10186	76	0	\N
323169	1874	14237000	20399	10186	77	0	\N
323170	1874	14239000	20399	10186	78	0	\N
323171	264	66772980736837	20399	10186	79	0	\N
323172	279	66772980736837	20399	10186	80	0	\N
323173	331	66772980736837	20399	10186	81	0	\N
323174	382	66772980736837	20399	10186	82	0	\N
323175	388	66772980736837	20399	10186	83	0	\N
323176	400	66772980736837	20399	10186	84	0	\N
323177	1874	14241000	20399	10186	85	0	\N
323178	1874	14243000	20399	10186	86	0	\N
323179	1874	14245000	20399	10186	87	0	\N
323180	1874	14247000	20399	10186	88	0	\N
323181	1874	14249000	20399	10186	91	0	\N
323182	1874	14251000	20399	10186	92	0	\N
323183	1874	14253000	20399	10186	93	0	\N
323184	1874	14255000	20399	10186	94	0	\N
323185	1874	14257000	20399	10186	95	0	\N
323186	1874	14259000	20399	10186	96	0	\N
323187	1874	14261000	20399	10186	97	0	\N
323188	1874	14263000	20399	10186	98	0	\N
323189	1874	14265000	20399	10186	99	0	\N
323190	1874	14267000	20399	10186	100	0	\N
323191	1874	14269000	20399	10186	101	0	\N
323192	1874	14271000	20399	10186	102	0	\N
323193	1874	14273000	20399	10186	103	0	\N
323194	1874	14275000	20399	10186	104	0	\N
323195	1874	14277000	20399	10186	105	0	\N
323196	1874	14279000	20399	10186	106	0	\N
323197	1874	14281000	20399	10186	107	0	\N
323198	1874	14283000	20399	10186	108	0	\N
323199	1874	14285000	20399	10186	109	0	\N
323200	1874	14287000	20399	10186	110	0	\N
323201	1874	14290000	20399	10186	111	0	\N
323202	1874	14293000	20399	10186	112	0	\N
323203	1874	14296000	20399	10186	113	0	\N
323204	1874	14299000	20399	10186	114	0	\N
323205	1874	14302000	20399	10186	115	0	\N
323206	1874	14305000	20399	10186	116	0	\N
323207	1874	14308000	20399	10186	117	0	\N
323208	1874	14311000	20399	10186	118	0	\N
323209	1874	14314000	20399	10186	119	0	\N
323210	1874	14317000	20399	10186	120	0	\N
323211	1874	14320000	20399	10186	121	0	\N
323212	1874	14323000	20399	10186	122	0	\N
323213	1874	14326000	20399	10186	123	0	\N
323214	1874	14329000	20399	10186	124	0	\N
323215	1874	14332000	20399	10186	125	0	\N
323219	1678	23040757117000	20401	10278	0	0	\N
323220	1874	14796000	20401	10278	1	0	\N
323221	1874	14799000	20401	10278	2	0	\N
323222	1678	23040757101000	20402	10266	0	0	\N
323223	1678	23040757102000	20402	10266	1	0	\N
323224	1678	23040757103000	20402	10266	2	0	\N
323225	1678	23040757104000	20402	10266	3	0	\N
323226	1678	23040757105000	20402	10266	4	0	\N
323227	1678	23040757106000	20402	10266	5	0	\N
323228	1678	23040757107000	20402	10266	6	0	\N
323229	1678	23040757108000	20402	10266	7	0	\N
323230	1678	23040757109000	20402	10266	8	0	\N
323231	1678	23040757110000	20402	10266	9	0	\N
323232	1678	23040757111000	20402	10266	10	0	\N
323233	1678	23040757112000	20402	10266	11	0	\N
323234	1678	23040757113000	20402	10266	12	0	\N
323235	1678	23040757114000	20402	10266	13	0	\N
323236	1678	23040757115000	20402	10266	14	0	\N
323237	1678	23040757116000	20402	10266	15	0	\N
323238	1678	23040757117000	20402	10266	16	0	\N
323239	1678	23040757118000	20402	10266	17	0	\N
323240	1874	14722000	20402	10266	18	0	\N
323241	1874	14724000	20402	10266	19	0	\N
323242	1874	14726000	20402	10266	20	0	\N
323243	1874	14728000	20402	10266	21	0	\N
323244	1874	14730000	20402	10266	22	0	\N
323245	1874	14732000	20402	10266	23	0	\N
323246	1874	14734000	20402	10266	24	0	\N
323247	1874	14736000	20402	10266	25	0	\N
323248	1874	14738000	20402	10266	26	0	\N
323249	1874	14740000	20402	10266	27	0	\N
323250	1874	14742000	20402	10266	28	0	\N
323251	1874	14744000	20402	10266	29	0	\N
323252	1874	14746000	20402	10266	30	0	\N
323256	1678	23040757119000	20404	10280	0	0	\N
323257	1678	23040757120000	20404	10280	1	0	\N
323258	1678	23040757121000	20404	10280	2	0	\N
323259	1678	23040757122000	20404	10280	3	0	\N
323260	1874	14806000	20404	10280	4	0	\N
323261	1874	14809000	20404	10280	5	0	\N
323262	1874	14811000	20404	10280	6	0	\N
323263	1874	14813000	20404	10280	7	0	\N
323264	1874	14815000	20404	10280	8	0	\N
323265	1874	14818000	20404	10280	9	0	\N
323266	1874	14821000	20404	10280	10	0	\N
323267	1874	14824000	20404	10280	11	0	\N
323218	1874	14799000	20400	10278	2	0	2
323253	1678	23040757118000	20403	10279	0	0	0
323254	1874	14801000	20403	10279	1	0	2
323255	1874	14804000	20403	10279	2	0	2
323268	1678	23040757119000	20405	10280	0	0	0
323270	1678	23040757121000	20405	10280	2	0	0
323271	1678	23040757122000	20405	10280	3	0	0
323272	1874	14806000	20405	10280	4	0	2
323294	1678	23040757126000	20409	10283	0	0	\N
323295	1874	14841000	20409	10283	1	0	\N
323296	1993	1956349532446	20409	10283	2	0	\N
323297	907	508157428951432	20409	10283	3	0	\N
323298	1027	910613758788112	20409	10283	4	0	\N
323299	1874	14844000	20409	10283	5	0	\N
323300	1678	23040757126000	20410	10283	0	0	\N
323301	1874	14841000	20410	10283	1	0	\N
323302	1993	1956349532446	20410	10283	2	0	\N
323303	907	508157428951432	20410	10283	3	0	\N
323304	1027	910613758788112	20410	10283	4	0	\N
323305	1874	14844000	20410	10283	5	0	\N
323306	1678	23040757126000	20411	10283	0	0	\N
323307	1874	14841000	20411	10283	1	0	\N
323308	1993	1956349532446	20411	10283	2	0	\N
323309	907	508157428951432	20411	10283	3	0	\N
323310	1027	910613758788112	20411	10283	4	0	\N
323311	1874	14844000	20411	10283	5	0	\N
323318	1678	23040757127000	20413	10284	0	0	\N
323319	1678	23040757128000	20413	10284	1	0	\N
323320	1678	23040757129000	20413	10284	2	0	\N
323321	1147	614409248315263	20413	10284	3	0	\N
323322	1874	14844000	20413	10284	4	0	\N
323323	1993	2816349532446	20413	10284	5	0	\N
323324	1874	14847000	20413	10284	6	0	\N
323325	1874	14848000	20413	10284	7	0	\N
323326	1874	14850000	20413	10284	8	0	\N
323327	1874	14852000	20413	10284	9	0	\N
323328	1874	14854000	20413	10284	10	0	\N
323329	2251	200000000	20413	10284	11	0	\N
323330	2252	200000000	20413	10284	12	0	\N
323331	2253	200000000	20413	10284	13	0	\N
323332	1874	14857000	20413	10284	14	0	\N
323333	1874	14860000	20413	10284	15	0	\N
323344	1678	23040757128000	20415	10285	0	0	\N
323345	1678	23040757129000	20415	10285	1	0	\N
323346	1874	14851000	20415	10285	2	0	\N
323347	1874	14853000	20415	10285	3	0	\N
323348	1874	14854000	20415	10285	4	0	\N
323349	2251	200000000	20415	10285	5	0	\N
323350	2252	200000000	20415	10285	6	0	\N
323351	2253	200000000	20415	10285	7	0	\N
323352	1874	14857000	20415	10285	8	0	\N
323353	1874	14860000	20415	10285	9	0	\N
323354	1678	23040757130000	20416	10286	0	0	\N
323355	1874	14862000	20416	10286	1	0	\N
323356	2254	200000000	20416	10286	2	0	\N
323357	1874	14865000	20416	10286	3	0	\N
323358	2255	200000000	20416	10286	4	0	\N
323364	1678	23040757130000	20418	10286	0	0	\N
323365	1874	14862000	20418	10286	1	0	\N
323366	2254	200000000	20418	10286	2	0	\N
323367	1874	14865000	20418	10286	3	0	\N
323368	2255	200000000	20418	10286	4	0	\N
323369	1678	23040757131000	20419	10287	0	0	\N
323370	1678	23040757132000	20419	10287	1	0	\N
323371	1874	14867000	20419	10287	2	0	\N
323372	1874	14870000	20419	10287	3	0	\N
323373	1874	14873000	20419	10287	4	0	\N
323374	1874	14875000	20419	10287	5	0	\N
323381	1678	23040757131000	20421	10287	0	0	\N
323382	1678	23040757132000	20421	10287	1	0	\N
323383	1874	14867000	20421	10287	2	0	\N
323384	1874	14870000	20421	10287	3	0	\N
323385	1874	14873000	20421	10287	4	0	\N
323386	1874	14875000	20421	10287	5	0	\N
323393	1678	23040757135000	20424	10290	0	0	\N
323394	1874	14886000	20424	10290	1	0	\N
323395	1874	14888000	20424	10290	3	0	\N
323396	1678	23040757135000	20425	10290	0	0	\N
323397	1874	14886000	20425	10290	1	0	\N
323398	1874	14888000	20425	10290	3	0	\N
323399	1678	23040757135000	20426	10290	0	0	\N
323400	1874	14886000	20426	10290	1	0	\N
323401	1874	14888000	20426	10290	3	0	\N
323402	1678	23040757135000	20427	10290	0	0	\N
323403	1874	14886000	20427	10290	1	0	\N
323404	1874	14888000	20427	10290	3	0	\N
323408	1273	1712106000654838	20429	10286	0	0	\N
323275	1874	14813000	20405	10280	7	0	2
323276	1874	14815000	20405	10280	8	0	2
323277	1874	14818000	20405	10280	9	0	2
323278	1874	14821000	20405	10280	10	0	2
323279	1874	14824000	20405	10280	11	0	2
323281	1874	14826000	20406	10281	1	0	2
323282	1874	14829000	20406	10281	2	0	2
323283	1678	23040757124000	20407	10282	0	0	0
323284	1678	23040757125000	20407	10282	1	0	0
323285	1874	14832000	20407	10282	2	0	2
323287	1874	14837000	20407	10282	4	0	2
323288	1874	14839000	20407	10282	5	0	2
323289	1678	23040757126000	20408	10283	0	0	0
323290	1993	1956349532446	20408	10283	1	0	1
323292	1027	910613758788112	20408	10283	3	0	0
323293	1874	14842000	20408	10283	4	0	2
323312	1678	23040757127000	20412	10284	0	0	0
323313	1147	614409248315263	20412	10284	1	0	0
323314	1874	14844000	20412	10284	2	0	2
323316	1874	14847000	20412	10284	4	0	2
323317	1874	14849000	20412	10284	5	0	2
323334	1678	23040757128000	20414	10285	0	0	0
323335	1678	23040757129000	20414	10285	1	0	0
323336	1874	14851000	20414	10285	2	0	2
323338	1874	14854000	20414	10285	4	0	2
323339	2251	200000000	20414	10285	5	0	0
323340	2252	200000000	20414	10285	6	0	0
323341	2253	200000000	20414	10285	7	0	0
323343	1874	14860000	20414	10285	9	0	2
323359	1678	23040757130000	20417	10286	0	0	0
323360	1874	14862000	20417	10286	1	0	2
323361	2254	200000000	20417	10286	2	0	0
323362	1874	14865000	20417	10286	3	0	2
323375	1678	23040757131000	20420	10287	0	0	0
323376	1678	23040757132000	20420	10287	1	0	0
323377	1874	14867000	20420	10287	2	0	2
323378	1874	14870000	20420	10287	3	0	2
323379	1874	14873000	20420	10287	4	0	2
323387	1678	23040757133000	20422	10288	0	0	0
323388	1874	14876000	20422	10288	1	0	2
323389	1874	14878000	20422	10288	2	0	2
323390	1678	23040757134000	20423	10289	0	0	0
323392	1874	14883000	20423	10289	2	0	2
323405	1678	23040757135000	20428	10290	0	0	0
323406	1874	14886000	20428	10290	1	0	2
323407	1874	14888000	20428	10290	3	0	2
323409	1678	23040757136000	20430	10291	0	0	\N
323410	1678	23040757137000	20430	10291	1	0	\N
323411	1273	1712106000654838	20430	10291	2	0	\N
323412	1874	14891000	20430	10291	3	0	\N
323413	1874	14892000	20430	10291	4	0	\N
323414	1874	14895000	20430	10291	5	0	\N
323415	1874	14897000	20430	10291	6	0	\N
323416	1874	14899000	20430	10291	7	0	\N
323425	1678	23040757138000	20432	10292	0	0	\N
323426	83	66578558947810	20432	10292	1	0	\N
323427	1874	14901000	20432	10292	2	0	\N
323428	348	66579458947810	20432	10292	3	0	\N
323429	380	66578558947810	20432	10292	4	0	\N
323430	1874	14904000	20432	10292	5	0	\N
323431	1678	23040757138000	20433	10292	0	0	\N
323432	83	66578558947810	20433	10292	1	0	\N
323433	1874	14901000	20433	10292	2	0	\N
323434	348	66579458947810	20433	10292	3	0	\N
323435	380	66578558947810	20433	10292	4	0	\N
323436	1874	14904000	20433	10292	5	0	\N
323442	1678	23040757139000	20435	10293	0	0	\N
323443	1874	14905000	20435	10293	1	0	\N
323444	380	66578558947810	20435	10293	2	0	\N
323445	530	66578657947810	20435	10293	3	0	\N
323446	675	66578558947810	20435	10293	4	0	\N
323447	959	507182874224259	20435	10293	5	0	\N
323448	1874	14908000	20435	10293	6	0	\N
323449	1079	908867365066994	20435	10293	7	0	\N
323450	1199	613230921672261	20435	10293	8	0	\N
323451	1325	1708822488693281	20435	10293	9	0	\N
323463	1678	23040757139000	20437	10293	0	0	\N
323464	1874	14905000	20437	10293	1	0	\N
323465	1874	14907000	20437	10293	2	0	\N
323466	380	66578558947810	20437	10293	3	0	\N
323467	530	66578657947810	20437	10293	4	0	\N
323468	675	66578558947810	20437	10293	5	0	\N
323469	959	507182874224259	20437	10293	6	0	\N
323470	1874	14910000	20437	10293	7	0	\N
323471	1079	908867365066994	20437	10293	8	0	\N
323472	1199	613230921672261	20437	10293	9	0	\N
323473	1325	1708822488693281	20437	10293	10	0	\N
323474	1678	23040757139000	20438	10293	0	0	\N
323475	1874	14905000	20438	10293	1	0	\N
323476	1874	14907000	20438	10293	2	0	\N
323477	530	66578657947810	20438	10293	3	0	\N
323478	675	66578558947810	20438	10293	4	0	\N
323479	959	507182874224259	20438	10293	5	0	\N
323480	1874	14910000	20438	10293	6	0	\N
323481	1079	908867365066994	20438	10293	7	0	\N
323482	1199	613230921672261	20438	10293	8	0	\N
323483	1325	1708822488693281	20438	10293	9	0	\N
323487	1678	23040757140000	20440	10294	0	0	\N
323488	1874	14913000	20440	10294	1	0	\N
323489	1874	14915000	20440	10294	2	0	\N
323490	1678	23040757140000	20441	10294	0	0	\N
323491	1874	14913000	20441	10294	1	0	\N
323495	1678	23040757142000	20443	10296	0	0	\N
323496	1874	14922000	20443	10296	1	0	\N
323499	1678	23040757142000	20445	10296	0	0	\N
323500	1874	14922000	20445	10296	1	0	\N
323505	1678	23040757144000	20447	10298	0	0	\N
323506	1874	14930000	20447	10298	1	0	\N
323507	1874	14933000	20447	10298	2	0	\N
323511	1678	23040757144000	20449	10298	0	0	\N
323512	1874	14930000	20449	10298	1	0	\N
323513	1874	14933000	20449	10298	2	0	\N
323514	1678	23040757144000	20450	10298	0	0	\N
323515	1874	14930000	20450	10298	1	0	\N
323516	1874	14933000	20450	10298	2	0	\N
323520	1678	23040757146000	20452	10300	0	0	\N
323521	2256	100000000	20452	10300	1	0	\N
323522	80	66000000000000	20452	10300	2	0	\N
323523	1874	14940000	20452	10300	3	0	\N
323524	1874	14943000	20452	10300	4	0	\N
323525	1874	14944000	20452	10300	5	0	\N
323532	1678	23040757146000	20454	10300	0	0	\N
323533	2256	100000000	20454	10300	1	0	\N
323534	80	66000000000000	20454	10300	2	0	\N
323535	1874	14940000	20454	10300	3	0	\N
323536	1874	14943000	20454	10300	4	0	\N
323537	1874	14944000	20454	10300	5	0	\N
323538	1678	23040757146000	20455	10300	0	0	\N
323539	2256	100000000	20455	10300	1	0	\N
323540	80	66000000000000	20455	10300	2	0	\N
323541	1874	14940000	20455	10300	3	0	\N
323542	1874	14943000	20455	10300	4	0	\N
323543	1874	14944000	20455	10300	5	0	\N
323419	1273	1712106000654838	20431	10291	2	0	0
323420	1874	14891000	20431	10291	3	0	2
323421	1874	14892000	20431	10291	4	0	2
323422	1874	14895000	20431	10291	5	0	2
323423	1874	14897000	20431	10291	6	0	2
323437	1678	23040757138000	20434	10292	0	0	0
323438	83	66578558947810	20434	10292	1	0	0
323439	1874	14901000	20434	10292	2	0	2
323440	348	66579458947810	20434	10292	3	0	1
323441	1874	14904000	20434	10292	4	0	2
323453	1874	14905000	20436	10293	1	0	2
323454	1874	14907000	20436	10293	2	0	2
323455	380	66578558947810	20436	10293	3	0	0
323456	530	66578657947810	20436	10293	4	0	1
323458	959	507182874224259	20436	10293	6	0	0
323459	1874	14910000	20436	10293	7	0	2
323460	1079	908867365066994	20436	10293	8	0	0
323461	1199	613230921672261	20436	10293	9	0	0
323462	1325	1708822488693281	20436	10293	10	0	0
323485	1874	14913000	20439	10294	1	0	2
323486	1874	14915000	20439	10294	2	0	2
323492	1678	23040757141000	20442	10295	0	0	0
323493	1874	14917000	20442	10295	1	0	2
323494	1874	14920000	20442	10295	2	0	2
323498	1874	14922000	20444	10296	1	0	2
323501	1678	23040757143000	20446	10297	0	0	0
323502	1874	14923000	20446	10297	1	0	2
323503	1874	14926000	20446	10297	2	0	2
323508	1678	23040757144000	20448	10298	0	0	0
323509	1874	14930000	20448	10298	1	0	2
323510	1874	14933000	20448	10298	2	0	2
323517	1678	23040757145000	20451	10299	0	0	0
323518	1874	14935000	20451	10299	1	0	2
323526	1678	23040757146000	20453	10300	0	0	0
323527	2256	100000000	20453	10300	1	0	0
323528	80	66000000000000	20453	10300	2	0	0
323529	1874	14940000	20453	10300	3	0	2
323530	1874	14943000	20453	10300	4	0	2
323544	1678	23040757147000	20456	10301	0	0	0
323547	1678	23040757148000	20457	10302	0	0	\N
323548	1874	14952000	20457	10302	1	0	\N
323549	1874	14954000	20457	10302	2	0	\N
323553	1678	23040757148000	20459	10302	0	0	\N
323554	1874	14952000	20459	10302	1	0	\N
323555	1874	14954000	20459	10302	2	0	\N
323556	1678	23040757148000	20460	10302	0	0	\N
323557	1874	14952000	20460	10302	1	0	\N
323561	1678	23040757150000	20462	10304	0	0	\N
323562	1874	14959000	20462	10304	1	0	\N
323563	1874	14962000	20462	10304	2	0	\N
323569	1678	23040757151000	20465	10305	0	0	\N
323570	1874	14965000	20465	10305	1	0	\N
323571	1874	14967000	20465	10305	2	0	\N
323577	2256	100000000	20467	10276	0	0	\N
323578	1678	23040757115000	20467	10276	1	0	\N
323579	1678	23040757116000	20467	10276	2	0	\N
323580	1678	23040757117000	20467	10276	3	0	\N
323581	1678	23040757118000	20467	10276	4	0	\N
323582	1678	23040757119000	20467	10276	5	0	\N
323583	1678	23040757120000	20467	10276	6	0	\N
323584	1678	23040757121000	20467	10276	7	0	\N
323585	1678	23040757122000	20467	10276	8	0	\N
323586	1678	23040757123000	20467	10276	9	0	\N
323587	1678	23040757124000	20467	10276	10	0	\N
323588	1678	23040757125000	20467	10276	11	0	\N
323589	1678	23040757126000	20467	10276	12	0	\N
323590	1678	23040757127000	20467	10276	13	0	\N
323591	1678	23040757128000	20467	10276	14	0	\N
323592	1678	23040757129000	20467	10276	15	0	\N
323593	1678	23040757130000	20467	10276	16	0	\N
323594	1678	23040757131000	20467	10276	17	0	\N
323595	1678	23040757132000	20467	10276	18	0	\N
323596	1678	23040757133000	20467	10276	19	0	\N
323597	1678	23040757134000	20467	10276	20	0	\N
323598	1678	23040757135000	20467	10276	21	0	\N
323599	1678	23040757136000	20467	10276	22	0	\N
323600	1678	23040757137000	20467	10276	23	0	\N
323601	1678	23040757138000	20467	10276	24	0	\N
323602	1678	23040757139000	20467	10276	25	0	\N
323603	1678	23040757140000	20467	10276	26	0	\N
323604	1678	23040757141000	20467	10276	27	0	\N
323605	1678	23040757142000	20467	10276	28	0	\N
323606	1678	23040757143000	20467	10276	29	0	\N
323607	1678	23040757144000	20467	10276	30	0	\N
323608	1678	23040757145000	20467	10276	31	0	\N
323609	1678	23040757146000	20467	10276	32	0	\N
323610	1678	23040757147000	20467	10276	33	0	\N
323611	1678	23040757148000	20467	10276	34	0	\N
323612	1678	23040757149000	20467	10276	35	0	\N
323613	1678	23040757150000	20467	10276	36	0	\N
323614	1678	23040757151000	20467	10276	37	0	\N
323615	83	66578558947810	20467	10276	38	0	\N
323616	80	66000000000000	20467	10276	39	0	\N
323617	1993	1956348532446	20467	10276	40	0	\N
323618	348	66579458947810	20467	10276	41	0	\N
323619	1874	14788000	20467	10276	42	0	\N
323620	1874	14789000	20467	10276	43	0	\N
323621	1874	14790000	20467	10276	44	0	\N
323622	1874	14791000	20467	10276	45	0	\N
323623	1874	14792000	20467	10276	46	0	\N
323624	1874	14795000	20467	10276	47	0	\N
323625	1874	14797000	20467	10276	48	0	\N
323626	1874	14799000	20467	10276	49	0	\N
323627	1874	14801000	20467	10276	50	0	\N
323628	1874	14803000	20467	10276	51	0	\N
323629	1874	14805000	20467	10276	52	0	\N
323630	2251	200000000	20467	10276	53	0	\N
323631	2252	200000000	20467	10276	54	0	\N
323632	2253	200000000	20467	10276	55	0	\N
323633	2254	200000000	20467	10276	56	0	\N
323634	2255	200000000	20467	10276	57	0	\N
323635	380	66578558947810	20467	10276	58	0	\N
323636	530	66578657947810	20467	10276	59	0	\N
323637	675	66578558947810	20467	10276	60	0	\N
323638	959	507182874224259	20467	10276	61	0	\N
323639	1079	908867365066994	20467	10276	62	0	\N
323640	1199	613230921672261	20467	10276	63	0	\N
323641	1874	14807000	20467	10276	64	0	\N
323642	1874	14808000	20467	10276	65	0	\N
323643	1874	14809000	20467	10276	66	0	\N
323644	1874	14812000	20467	10276	67	0	\N
323645	1874	14814000	20467	10276	68	0	\N
323646	1874	14816000	20467	10276	69	0	\N
323647	1874	14818000	20467	10276	70	0	\N
323648	907	508157428951432	20467	10276	71	0	\N
323649	1027	910613758788112	20467	10276	72	0	\N
323650	1147	614409248315263	20467	10276	73	0	\N
323651	1273	1712106000654838	20467	10276	74	0	\N
323652	1874	14820000	20467	10276	75	0	\N
323653	1874	14822000	20467	10276	76	0	\N
323654	1874	14824000	20467	10276	77	0	\N
323655	1874	14826000	20467	10276	78	0	\N
323656	1874	14828000	20467	10276	79	0	\N
323657	1874	14830000	20467	10276	80	0	\N
323658	1874	14832000	20467	10276	81	0	\N
323659	1874	14834000	20467	10276	82	0	\N
323660	1874	14836000	20467	10276	83	0	\N
323661	1874	14838000	20467	10276	84	0	\N
323662	1874	14840000	20467	10276	85	0	\N
323663	1874	14842000	20467	10276	86	0	\N
323664	1874	14844000	20467	10276	87	0	\N
323665	1874	14846000	20467	10276	88	0	\N
323666	1874	14848000	20467	10276	89	0	\N
323667	1874	14850000	20467	10276	90	0	\N
323668	1874	14852000	20467	10276	91	0	\N
323669	1874	14854000	20467	10276	92	0	\N
323670	1874	14856000	20467	10276	93	0	\N
323671	1874	14858000	20467	10276	94	0	\N
323672	1874	14860000	20467	10276	95	0	\N
323673	1874	14862000	20467	10276	96	0	\N
323674	1874	14864000	20467	10276	97	0	\N
323675	1874	14866000	20467	10276	98	0	\N
323676	1874	14868000	20467	10276	99	0	\N
323677	1874	14870000	20467	10276	101	0	\N
323678	1874	14872000	20467	10276	102	0	\N
323679	1874	14874000	20467	10276	103	0	\N
323680	1874	14876000	20467	10276	104	0	\N
323550	1678	23040757148000	20458	10302	0	0	0
323551	1874	14952000	20458	10302	1	0	2
323552	1874	14954000	20458	10302	2	0	2
323558	1678	23040757149000	20461	10303	0	0	0
323559	1874	14956000	20461	10303	1	0	2
323564	1678	23040757150000	20463	10304	0	0	0
323565	1874	14959000	20463	10304	1	0	2
323566	1874	14962000	20463	10304	2	0	2
323567	1678	23040757151000	20464	10305	0	0	0
323568	1874	14965000	20464	10305	1	0	2
323573	1678	23040757152000	20466	10306	1	0	0
323574	1874	14968000	20466	10306	2	0	2
323575	1874	14970000	20466	10306	3	0	2
323576	1874	14972000	20466	10306	4	0	2
323681	1325	1708822488693281	20467	10276	105	0	\N
323682	1874	14879000	20467	10276	106	0	\N
323683	1874	14882000	20467	10276	107	0	\N
323684	1874	14885000	20467	10276	108	0	\N
323685	1874	14888000	20467	10276	109	0	\N
323686	1874	14891000	20467	10276	110	0	\N
323687	1874	14894000	20467	10276	111	0	\N
323688	1874	14897000	20467	10276	112	0	\N
323689	1874	14900000	20467	10276	113	0	\N
323690	1874	14903000	20467	10276	114	0	\N
323691	1874	14906000	20467	10276	115	0	\N
323692	1874	14909000	20467	10276	116	0	\N
323693	1874	14912000	20467	10276	117	0	\N
323694	1874	14915000	20467	10276	118	0	\N
323695	1874	14918000	20467	10276	119	0	\N
323696	1874	14921000	20467	10276	120	0	\N
323697	1874	14924000	20467	10276	121	0	\N
323698	1874	14927000	20467	10276	122	0	\N
323699	1874	14930000	20467	10276	123	0	\N
323700	1874	14933000	20467	10276	124	0	\N
323701	1874	14936000	20467	10276	125	0	\N
323706	1678	23040757153000	20469	10307	0	0	\N
323707	1874	14973000	20469	10307	1	0	\N
323708	1874	14975000	20469	10307	2	0	\N
323709	1874	14978000	20469	10307	3	0	\N
323716	1678	23040757156000	20472	10310	0	0	\N
323717	1874	14990000	20472	10310	1	0	\N
323718	1874	14993000	20472	10310	2	0	\N
323719	1874	14994000	20472	10310	3	0	\N
323724	1874	14996000	20474	10311	0	0	\N
323727	1678	23040757158000	20476	10312	0	0	\N
323728	1651	3236050115	20476	10312	1	0	\N
323729	1874	14998000	20476	10312	2	0	\N
323730	1874	15001000	20476	10312	3	0	\N
323735	2256	100000000	20478	10247	0	0	\N
323736	1678	23040757103000	20478	10247	1	0	\N
323737	1678	23040757104000	20478	10247	2	0	\N
323738	1678	23040757105000	20478	10247	3	0	\N
323739	1678	23040757106000	20478	10247	4	0	\N
323740	1678	23040757107000	20478	10247	5	0	\N
323741	1678	23040757108000	20478	10247	6	0	\N
323742	1678	23040757109000	20478	10247	7	0	\N
323743	1678	23040757110000	20478	10247	8	0	\N
323744	1678	23040757111000	20478	10247	9	0	\N
323745	1678	23040757112000	20478	10247	10	0	\N
323746	1678	23040757113000	20478	10247	11	0	\N
323747	1678	23040757114000	20478	10247	12	0	\N
323748	1678	23040757115000	20478	10247	13	0	\N
323749	1678	23040757116000	20478	10247	14	0	\N
323750	1678	23040757117000	20478	10247	15	0	\N
323751	1678	23040757118000	20478	10247	16	0	\N
323752	1678	23040757119000	20478	10247	17	0	\N
323753	1678	23040757120000	20478	10247	18	0	\N
323754	1678	23040757121000	20478	10247	19	0	\N
323755	1678	23040757122000	20478	10247	20	0	\N
323756	1678	23040757123000	20478	10247	21	0	\N
323757	1651	3236050115	20478	10247	22	0	\N
323758	1678	23040757124000	20478	10247	23	0	\N
323759	1678	23040757125000	20478	10247	24	0	\N
323760	1678	23040757126000	20478	10247	25	0	\N
323761	1678	23040757127000	20478	10247	26	0	\N
323762	1678	23040757128000	20478	10247	27	0	\N
323763	1678	23040757129000	20478	10247	28	0	\N
323764	1678	23040757130000	20478	10247	29	0	\N
323765	1678	23040757131000	20478	10247	30	0	\N
323766	1678	23040757132000	20478	10247	31	0	\N
323767	1678	23040757133000	20478	10247	32	0	\N
323768	1678	23040757134000	20478	10247	33	0	\N
323769	1678	23040757135000	20478	10247	34	0	\N
323770	1678	23040757136000	20478	10247	35	0	\N
323771	1678	23040757137000	20478	10247	36	0	\N
323772	1678	23040757138000	20478	10247	37	0	\N
323773	1678	23040757139000	20478	10247	38	0	\N
323774	1678	23040757140000	20478	10247	39	0	\N
323775	1678	23040757141000	20478	10247	40	0	\N
323776	1678	23040757142000	20478	10247	41	0	\N
323777	1678	23040757143000	20478	10247	42	0	\N
323778	1678	23040757144000	20478	10247	43	0	\N
323779	1678	23040757145000	20478	10247	44	0	\N
323780	1678	23040757146000	20478	10247	45	0	\N
323781	1678	23040757147000	20478	10247	46	0	\N
323782	1678	23040757148000	20478	10247	47	0	\N
323783	1678	23040757149000	20478	10247	48	0	\N
323784	1678	23040757150000	20478	10247	49	0	\N
323785	1678	23040757151000	20478	10247	50	0	\N
323786	1678	23040757152000	20478	10247	51	0	\N
323787	1678	23040757153000	20478	10247	52	0	\N
323788	1678	23040757154000	20478	10247	53	0	\N
323789	1678	23040757155000	20478	10247	54	0	\N
323790	1678	23040757156000	20478	10247	55	0	\N
323791	1678	23040757157000	20478	10247	56	0	\N
323792	83	66578558947810	20478	10247	57	0	\N
323793	80	66000000000000	20478	10247	58	0	\N
323794	1993	1956348532446	20478	10247	59	0	\N
323795	348	66579458947810	20478	10247	60	0	\N
323796	1874	14731000	20478	10247	61	0	\N
323797	1874	14732000	20478	10247	62	0	\N
323798	1874	14733000	20478	10247	63	0	\N
323799	1874	14734000	20478	10247	64	0	\N
323800	1874	14735000	20478	10247	65	0	\N
323801	1874	14738000	20478	10247	67	0	\N
323802	1874	14741000	20478	10247	68	0	\N
323803	1874	14744000	20478	10247	69	0	\N
323804	1874	14746000	20478	10247	70	0	\N
323805	1874	14748000	20478	10247	71	0	\N
323806	2251	200000000	20478	10247	72	0	\N
323807	2252	200000000	20478	10247	73	0	\N
323808	2253	200000000	20478	10247	74	0	\N
323809	2254	200000000	20478	10247	75	0	\N
323810	2255	200000000	20478	10247	76	0	\N
323811	380	66578558947810	20478	10247	77	0	\N
323812	530	66578657947810	20478	10247	78	0	\N
323813	675	66578558947810	20478	10247	79	0	\N
323814	959	507182874224259	20478	10247	80	0	\N
323815	1079	908867365066994	20478	10247	81	0	\N
323816	1199	613230921672261	20478	10247	82	0	\N
323704	1874	14975000	20468	10307	2	0	2
323705	1874	14978000	20468	10307	3	0	2
323710	1678	23040757154000	20470	10308	0	0	0
323711	1874	14981000	20470	10308	1	0	2
323712	1874	14983000	20470	10308	2	0	2
323714	1874	14986000	20471	10309	1	0	2
323715	1874	14988000	20471	10309	2	0	2
323720	1678	23040757156000	20473	10310	0	0	0
323721	1874	14990000	20473	10310	1	0	2
323722	1874	14993000	20473	10310	2	0	2
323725	1678	23040757157000	20475	10311	0	0	0
323726	1874	14996000	20475	10311	1	0	2
323731	1678	23040757158000	20477	10312	0	0	0
323732	1651	3236050115	20477	10312	1	0	6
323734	1874	15001000	20477	10312	3	0	2
323817	1874	14751000	20478	10247	83	0	\N
323818	1874	14754000	20478	10247	84	0	\N
323819	1874	14757000	20478	10247	85	0	\N
323820	1874	14760000	20478	10247	86	0	\N
323821	1874	14763000	20478	10247	87	0	\N
323822	1874	14766000	20478	10247	88	0	\N
323823	1874	14769000	20478	10247	89	0	\N
323824	1874	14772000	20478	10247	90	0	\N
323825	1874	14775000	20478	10247	91	0	\N
323826	1874	14776000	20478	10247	92	0	\N
323827	1874	14777000	20478	10247	93	0	\N
323828	1874	14778000	20478	10247	94	0	\N
323829	1874	14779000	20478	10247	95	0	\N
323830	1874	14782000	20478	10247	96	0	\N
323831	1874	14784000	20478	10247	97	0	\N
323832	1874	14786000	20478	10247	98	0	\N
323833	1874	14788000	20478	10247	99	0	\N
323834	1874	14790000	20478	10247	100	0	\N
323835	1874	14792000	20478	10247	101	0	\N
323836	1874	14794000	20478	10247	102	0	\N
323837	1874	14796000	20478	10247	103	0	\N
323838	1874	14798000	20478	10247	104	0	\N
323839	1874	14800000	20478	10247	105	0	\N
323840	1874	14802000	20478	10247	106	0	\N
323841	1874	14804000	20478	10247	107	0	\N
323842	1874	14806000	20478	10247	108	0	\N
323843	1874	14808000	20478	10247	109	0	\N
323844	1874	14810000	20478	10247	110	0	\N
323845	1874	14812000	20478	10247	111	0	\N
323846	1874	14814000	20478	10247	112	0	\N
323847	1874	14816000	20478	10247	113	0	\N
323848	1874	14818000	20478	10247	114	0	\N
323849	1874	14820000	20478	10247	115	0	\N
323850	907	508157428951432	20478	10247	116	0	\N
323851	1027	910613758788112	20478	10247	117	0	\N
323852	1147	614409248315263	20478	10247	118	0	\N
323853	1273	1712106000654838	20478	10247	119	0	\N
323854	1874	14822000	20478	10247	120	0	\N
323855	1874	14824000	20478	10247	121	0	\N
323856	1874	14826000	20478	10247	122	0	\N
323857	1874	14828000	20478	10247	123	0	\N
323858	1874	14830000	20478	10247	124	0	\N
323859	1874	14832000	20478	10247	125	0	\N
323888	1678	23040757165000	20482	10314	0	0	\N
323889	1874	15035000	20482	10314	1	0	\N
323890	1651	19839236050115	20483	10315	0	0	\N
323891	1678	23040757166000	20483	10315	1	0	\N
323892	1874	15038000	20483	10315	2	0	\N
323893	1874	15039000	20483	10315	3	0	\N
323894	1874	15041000	20483	10315	4	0	\N
323895	1651	19839236050115	20484	10315	0	0	\N
323896	1678	23040757166000	20484	10315	1	0	\N
323897	1874	15038000	20484	10315	2	0	\N
323898	1874	15039000	20484	10315	3	0	\N
323899	1874	15041000	20484	10315	4	0	\N
323905	1384	1710568637751650	20486	10313	0	0	\N
323906	1138	909796465000000	20486	10313	1	0	\N
323907	1258	613860750000000	20486	10313	2	0	\N
323908	1018	507701775000000	20486	10313	3	0	\N
323909	1678	23040757159000	20486	10313	4	0	\N
323910	1678	23040757160000	20486	10313	5	0	\N
323911	1651	10083236050115	20486	10313	6	0	\N
323912	1678	23040757161000	20486	10313	7	0	\N
323913	1678	23040757162000	20486	10313	8	0	\N
323914	1678	23040757163000	20486	10313	9	0	\N
323915	1678	23040757164000	20486	10313	10	0	\N
323916	1678	23040757165000	20486	10313	11	0	\N
323917	1874	15002000	20486	10313	12	0	\N
323918	2257	200000000	20486	10313	13	0	\N
323919	1874	15005000	20486	10313	14	0	\N
323920	1874	15008000	20486	10313	15	0	\N
323921	1874	15011000	20486	10313	16	0	\N
323922	1874	15014000	20486	10313	17	0	\N
323923	1874	15016000	20486	10313	18	0	\N
323924	1874	15018000	20486	10313	19	0	\N
323925	1874	15019000	20486	10313	20	0	\N
323926	1874	15020000	20486	10313	21	0	\N
323927	1874	15023000	20486	10313	22	0	\N
323928	1874	15026000	20486	10313	23	0	\N
323929	1874	15029000	20486	10313	24	0	\N
323930	1874	15031000	20486	10313	25	0	\N
323931	1874	15033000	20486	10313	26	0	\N
323932	1874	15035000	20486	10313	27	0	\N
323933	1874	15037000	20486	10313	28	0	\N
323934	1874	15039000	20486	10313	29	0	\N
323935	1678	23040757167000	20487	10316	0	0	\N
323936	1678	23040757168000	20487	10316	1	0	\N
323937	1874	15043000	20487	10316	2	0	\N
323938	1874	15045000	20487	10316	3	0	\N
323939	1874	15048000	20487	10316	4	0	\N
323940	1874	15051000	20487	10316	5	0	\N
323947	1874	15043000	20489	10316	0	0	\N
323948	1874	15045000	20489	10316	1	0	\N
323949	1874	15048000	20489	10316	2	0	\N
323950	1874	15051000	20489	10316	3	0	\N
323951	1678	23040757169000	20490	10317	0	0	\N
323952	1874	15052000	20490	10317	1	0	\N
323862	1258	613860750000000	20479	10313	2	0	0
323863	1018	507701775000000	20479	10313	3	0	0
323864	1678	23040757159000	20479	10313	4	0	0
323865	1678	23040757160000	20479	10313	5	0	0
323866	1651	10083236050115	20479	10313	6	0	6
323868	1678	23040757162000	20479	10313	8	0	0
323869	1678	23040757163000	20479	10313	9	0	0
323870	1678	23040757164000	20479	10313	10	0	0
323871	1874	15002000	20479	10313	11	0	2
323872	2257	200000000	20479	10313	12	0	0
323874	1874	15008000	20479	10313	14	0	2
323875	1874	15011000	20479	10313	15	0	2
323876	1874	15014000	20479	10313	16	0	2
323877	1874	15016000	20479	10313	17	0	2
323879	1874	15019000	20479	10313	19	0	2
323880	1874	15022000	20479	10313	20	0	2
323881	1874	15025000	20479	10313	21	0	2
323882	1874	15027000	20479	10313	22	0	2
323883	1874	15029000	20479	10313	23	0	2
323885	1874	15033000	20479	10313	25	0	2
323886	1678	23040757165000	20481	10314	0	0	0
323887	1874	15035000	20481	10314	1	0	2
323900	1651	19839236050115	20485	10315	0	0	6
323901	1678	23040757166000	20485	10315	1	0	0
323903	1874	15039000	20485	10315	3	0	2
323904	1874	15041000	20485	10315	4	0	2
323941	1678	23040757167000	20488	10316	0	0	0
323942	1678	23040757168000	20488	10316	1	0	0
323944	1874	15045000	20488	10316	3	0	2
323945	1874	15048000	20488	10316	4	0	2
323946	1874	15051000	20488	10316	5	0	2
323953	1874	15055000	20490	10317	2	0	\N
323975	1678	23040757175000	20496	10321	0	0	\N
323976	1874	15083000	20496	10321	1	0	\N
323977	1874	15083000	20497	10321	0	0	\N
323978	1678	23040757175000	20498	10321	0	0	\N
323979	1874	15083000	20498	10321	1	0	\N
323984	1678	23040757176000	20500	10322	0	0	\N
323985	1874	15084000	20500	10322	1	0	\N
323986	1874	15086000	20500	10322	2	0	\N
323987	1874	15089000	20500	10322	3	0	\N
323988	1678	23040757176000	20501	10322	0	0	\N
323989	1874	15084000	20501	10322	1	0	\N
323990	1874	15086000	20501	10322	2	0	\N
323991	1874	15089000	20501	10322	3	0	\N
323998	1678	23040757178000	20505	10324	0	0	\N
323999	1874	15096000	20505	10324	1	0	\N
324000	1874	15099000	20505	10324	2	0	\N
324005	1384	1710568637751650	20508	10231	0	0	\N
324006	1138	909796465000000	20508	10231	1	0	\N
324007	1258	613860750000000	20508	10231	2	0	\N
324008	1018	507701775000000	20508	10231	3	0	\N
324009	2256	100000000	20508	10231	4	0	\N
324010	1596	20881018000000	20508	10231	5	0	\N
324011	1651	9759236050115	20508	10231	6	0	\N
324012	1678	23040757054000	20508	10231	7	0	\N
324013	1678	23040757055000	20508	10231	8	0	\N
324014	1678	23040757056000	20508	10231	9	0	\N
324015	1678	23040757057000	20508	10231	10	0	\N
324016	1678	23040757058000	20508	10231	11	0	\N
324017	1678	23040757059000	20508	10231	12	0	\N
324018	1678	23040757060000	20508	10231	13	0	\N
324019	1678	23040757061000	20508	10231	14	0	\N
324020	1678	23040757062000	20508	10231	15	0	\N
324021	1678	23040757063000	20508	10231	16	0	\N
324022	1678	23040757064000	20508	10231	17	0	\N
324023	1678	23040757065000	20508	10231	18	0	\N
324024	1651	9759236050115	20508	10231	19	0	\N
324025	1651	19839236050115	20508	10231	21	0	\N
324026	1678	23040757066000	20508	10231	22	0	\N
324027	1678	23040757067000	20508	10231	23	0	\N
324028	1678	23040757068000	20508	10231	24	0	\N
324029	1678	23040757069000	20508	10231	25	0	\N
324030	1678	23040757070000	20508	10231	26	0	\N
324031	1678	23040757071000	20508	10231	27	0	\N
324032	1678	23040757072000	20508	10231	28	0	\N
324033	1678	23040757073000	20508	10231	29	0	\N
324034	1678	23040757074000	20508	10231	30	0	\N
324035	1678	23040757075000	20508	10231	31	0	\N
324036	1678	23040757076000	20508	10231	32	0	\N
324037	1678	23040757077000	20508	10231	33	0	\N
324038	1678	23040757078000	20508	10231	34	0	\N
324039	1678	23040757079000	20508	10231	35	0	\N
324040	1678	23040757080000	20508	10231	36	0	\N
324041	1678	23040757081000	20508	10231	37	0	\N
324042	1678	23040757082000	20508	10231	38	0	\N
324043	1678	23040757083000	20508	10231	39	0	\N
324044	1678	23040757084000	20508	10231	40	0	\N
324045	1678	23040757085000	20508	10231	41	0	\N
324046	1678	23040757086000	20508	10231	42	0	\N
324047	1678	23040757087000	20508	10231	43	0	\N
324048	1678	23040757088000	20508	10231	44	0	\N
324049	1678	23040757089000	20508	10231	45	0	\N
324050	1678	23040757090000	20508	10231	46	0	\N
324051	1678	23040757091000	20508	10231	47	0	\N
324052	1678	23040757092000	20508	10231	48	0	\N
324053	1678	23040757093000	20508	10231	49	0	\N
324054	1678	23040757094000	20508	10231	50	0	\N
324055	1678	23040757095000	20508	10231	51	0	\N
324056	1678	23040757096000	20508	10231	52	0	\N
324057	1678	23040757097000	20508	10231	53	0	\N
324058	1678	23040757098000	20508	10231	54	0	\N
324059	1678	23040757099000	20508	10231	55	0	\N
324060	1678	23040757100000	20508	10231	56	0	\N
324061	1678	23040757101000	20508	10231	57	0	\N
324062	1678	23040757102000	20508	10231	58	0	\N
324063	1678	23040757103000	20508	10231	59	0	\N
324064	1678	23040757104000	20508	10231	60	0	\N
324065	1678	23040757105000	20508	10231	61	0	\N
324066	1678	23040757106000	20508	10231	62	0	\N
324067	1678	23040757107000	20508	10231	63	0	\N
324068	1678	23040757108000	20508	10231	64	0	\N
324069	1678	23040757109000	20508	10231	65	0	\N
324070	1678	23040757110000	20508	10231	66	0	\N
324071	1678	23040757111000	20508	10231	67	0	\N
324072	1678	23040757112000	20508	10231	68	0	\N
324073	1678	23040757113000	20508	10231	69	0	\N
324074	1678	23040757114000	20508	10231	70	0	\N
324075	1678	23040757115000	20508	10231	71	0	\N
324076	1678	23040757116000	20508	10231	72	0	\N
324077	1678	23040757117000	20508	10231	73	0	\N
324078	1678	23040757118000	20508	10231	74	0	\N
324079	1678	23040757119000	20508	10231	75	0	\N
324080	1678	23040757120000	20508	10231	76	0	\N
324081	1678	23040757121000	20508	10231	77	0	\N
324082	1678	23040757122000	20508	10231	78	0	\N
324083	1678	23040757123000	20508	10231	79	0	\N
324084	1678	23040757124000	20508	10231	80	0	\N
324085	1678	23040757125000	20508	10231	81	0	\N
324086	1678	23040757126000	20508	10231	82	0	\N
324087	1678	23040757127000	20508	10231	83	0	\N
324088	1678	23040757128000	20508	10231	84	0	\N
323956	1874	15055000	20491	10317	2	0	2
323957	1678	23040757170000	20492	10318	0	0	0
323958	1678	23040757171000	20492	10318	1	0	0
323959	1678	23040757172000	20492	10318	2	0	0
323960	1874	15058000	20492	10318	3	0	2
323962	1874	15064000	20492	10318	5	0	2
323963	1874	15066000	20492	10318	6	0	2
323964	1874	15068000	20492	10318	7	0	2
323965	1874	15070000	20492	10318	8	0	2
323966	1678	23040757173000	20493	10319	0	0	0
323968	1874	15075000	20493	10319	2	0	2
323969	1874	15076000	20493	10319	3	0	2
323970	1678	23040757174000	20494	10320	0	0	0
323971	1874	15079000	20494	10320	1	0	2
323973	1678	23040757175000	20495	10321	0	0	0
323974	1874	15083000	20495	10321	1	0	2
323980	1678	23040757176000	20499	10322	0	0	0
323981	1874	15084000	20499	10322	1	0	2
323982	1874	15086000	20499	10322	2	0	2
323992	1678	23040757177000	20502	10323	0	0	0
323993	1874	15092000	20502	10323	1	0	2
323994	1874	15094000	20502	10323	2	0	2
323995	1678	23040757178000	20503	10324	0	0	0
323996	1874	15096000	20503	10324	1	0	2
324001	1678	23040757179000	20507	10325	0	0	0
324002	1874	15100000	20507	10325	1	0	2
324003	1874	15102000	20507	10325	2	0	2
324004	1874	15105000	20507	10325	3	0	2
324089	1678	23040757129000	20508	10231	85	0	\N
324090	1678	23040757130000	20508	10231	86	0	\N
324091	1678	23040757131000	20508	10231	87	0	\N
324092	1678	23040757132000	20508	10231	88	0	\N
324093	1678	23040757133000	20508	10231	89	0	\N
324094	1678	23040757134000	20508	10231	90	0	\N
324095	1678	23040757135000	20508	10231	91	0	\N
324096	1678	23040757136000	20508	10231	92	0	\N
324097	1678	23040757137000	20508	10231	93	0	\N
324098	1678	23040757138000	20508	10231	94	0	\N
324099	1678	23040757139000	20508	10231	95	0	\N
324100	1678	23040757140000	20508	10231	96	0	\N
324101	1678	23040757141000	20508	10231	97	0	\N
324102	1678	23040757142000	20508	10231	98	0	\N
324103	1678	23040757143000	20508	10231	99	0	\N
324104	1678	23040757144000	20508	10231	100	0	\N
324105	1678	23040757145000	20508	10231	101	0	\N
324106	1678	23040757146000	20508	10231	102	0	\N
324107	1678	23040757147000	20508	10231	103	0	\N
324108	1678	23040757148000	20508	10231	104	0	\N
324109	1678	23040757149000	20508	10231	105	0	\N
324110	1678	23040757150000	20508	10231	106	0	\N
324111	1678	23040757151000	20508	10231	107	0	\N
324112	1678	23040757152000	20508	10231	108	0	\N
324113	1678	23040757153000	20508	10231	109	0	\N
324114	1678	23040757154000	20508	10231	110	0	\N
324115	1678	23040757155000	20508	10231	111	0	\N
324116	1678	23040757156000	20508	10231	112	0	\N
324117	1678	23040757157000	20508	10231	113	0	\N
324118	1678	23040757158000	20508	10231	114	0	\N
324119	1678	23040757159000	20508	10231	115	0	\N
324120	1678	23040757160000	20508	10231	116	0	\N
324121	1678	23040757161000	20508	10231	117	0	\N
324122	1678	23040757162000	20508	10231	118	0	\N
324123	1678	23040757163000	20508	10231	119	0	\N
324124	1678	23040757164000	20508	10231	120	0	\N
324125	1678	23040757165000	20508	10231	121	0	\N
324126	1678	23040757166000	20508	10231	122	0	\N
324127	1678	23040757167000	20508	10231	123	0	\N
324128	1678	23040757168000	20508	10231	124	0	\N
324129	1678	23040757169000	20508	10231	125	0	\N
324130	1874	15101000	20509	10325	0	0	\N
324131	1874	15104000	20509	10325	1	0	\N
324135	1874	15108000	20511	10326	0	0	\N
324136	1874	15110000	20511	10326	1	0	\N
324137	1678	23040757181000	20512	10327	0	0	\N
324138	1874	15113000	20512	10327	1	0	\N
324139	1678	23040757181000	20513	10327	0	0	\N
324140	1874	15112000	20513	10327	1	0	\N
324141	1874	15115000	20513	10327	2	0	\N
324145	1678	23040757182000	20515	10328	0	0	\N
324146	1678	23040757183000	20515	10328	1	0	\N
324147	1678	23040757184000	20515	10328	2	0	\N
324148	1678	23040757185000	20515	10328	3	0	\N
324149	1678	23040757186000	20515	10328	4	0	\N
324150	1874	15116000	20515	10328	5	0	\N
324151	1874	15117000	20515	10328	6	0	\N
324152	2206	3799000000	20515	10328	7	0	\N
324153	1874	15120000	20515	10328	8	0	\N
324154	1874	15123000	20515	10328	9	0	\N
324155	1874	15126000	20515	10328	10	0	\N
324156	1874	15129000	20515	10328	12	0	\N
324157	1874	15132000	20515	10328	13	0	\N
324158	1874	15134000	20515	10328	14	0	\N
324159	1874	15136000	20515	10328	15	0	\N
324160	1874	15138000	20515	10328	16	0	\N
324161	1874	15140000	20515	10328	17	0	\N
324162	1874	15142000	20515	10328	18	0	\N
324163	2205	3799000000	20515	10328	19	0	\N
324164	2184	3799000000	20515	10328	20	0	\N
324165	2185	2599000000	20515	10328	21	0	\N
324166	2258	200000000	20515	10328	22	0	\N
324167	1678	23040757182000	20516	10328	0	0	\N
324168	1678	23040757183000	20516	10328	1	0	\N
324169	1678	23040757184000	20516	10328	2	0	\N
324170	1678	23040757185000	20516	10328	3	0	\N
324171	1678	23040757186000	20516	10328	4	0	\N
324172	1874	15116000	20516	10328	5	0	\N
324173	1874	15117000	20516	10328	6	0	\N
324174	2206	3799000000	20516	10328	7	0	\N
324175	1874	15120000	20516	10328	8	0	\N
324176	1874	15123000	20516	10328	9	0	\N
324177	1874	15126000	20516	10328	10	0	\N
324178	1874	15129000	20516	10328	12	0	\N
324179	1874	15132000	20516	10328	13	0	\N
324180	1874	15134000	20516	10328	14	0	\N
324181	1874	15136000	20516	10328	15	0	\N
324182	1874	15138000	20516	10328	16	0	\N
324183	1874	15140000	20516	10328	17	0	\N
324184	1874	15142000	20516	10328	18	0	\N
324185	2205	3799000000	20516	10328	19	0	\N
324186	2184	3799000000	20516	10328	20	0	\N
324187	2185	2599000000	20516	10328	21	0	\N
324188	2258	200000000	20516	10328	22	0	\N
324211	1678	23040757187000	20518	10329	0	0	\N
324212	1678	23040757188000	20518	10329	1	0	\N
324213	1874	15145000	20518	10329	2	0	\N
324214	1874	15148000	20518	10329	3	0	\N
324215	1678	23040757187000	20519	10329	0	0	\N
324216	1678	23040757188000	20519	10329	1	0	\N
324217	1874	15144000	20519	10329	2	0	\N
324218	1874	15146000	20519	10329	3	0	\N
324219	1874	15149000	20519	10329	4	0	\N
324220	1874	15152000	20519	10329	5	0	\N
324134	1874	15110000	20510	10326	2	0	2
324142	1678	23040757181000	20514	10327	0	0	0
324143	1874	15112000	20514	10327	1	0	2
324144	1874	15115000	20514	10327	2	0	2
324189	1678	23040757182000	20517	10328	0	0	0
324191	1678	23040757184000	20517	10328	2	0	0
324192	1678	23040757185000	20517	10328	3	0	0
324193	1678	23040757186000	20517	10328	4	0	0
324194	1874	15116000	20517	10328	5	0	2
324195	1874	15117000	20517	10328	6	0	2
324197	1874	15120000	20517	10328	8	0	2
324198	1874	15123000	20517	10328	9	0	2
324199	1874	15126000	20517	10328	10	0	2
324200	1874	15129000	20517	10328	12	0	2
324202	1874	15134000	20517	10328	14	0	2
324203	1874	15136000	20517	10328	15	0	2
324204	1874	15138000	20517	10328	16	0	2
324205	1874	15140000	20517	10328	17	0	2
324206	1874	15142000	20517	10328	18	0	2
324208	2184	3799000000	20517	10328	20	0	1
324209	2185	2599000000	20517	10328	21	0	1
324210	2258	200000000	20517	10328	22	0	0
324221	1678	23040757187000	20520	10329	0	0	0
324222	1678	23040757188000	20520	10329	1	0	0
324224	1874	15146000	20520	10329	3	0	2
324227	1678	23040757187000	20521	10329	0	0	\N
324228	1678	23040757188000	20521	10329	1	0	\N
324229	1874	15144000	20521	10329	2	0	\N
324230	1874	15146000	20521	10329	3	0	\N
324231	1874	15149000	20521	10329	4	0	\N
324232	1874	15152000	20521	10329	5	0	\N
324237	1678	23040757189000	20523	10330	0	0	\N
324238	1874	15155000	20523	10330	1	0	\N
324239	1874	15157000	20523	10330	2	0	\N
324240	1874	15158000	20523	10330	3	0	\N
324241	1678	23040757189000	20524	10330	0	0	\N
324242	1874	15155000	20524	10330	1	0	\N
324243	1874	15157000	20524	10330	2	0	\N
324244	1874	15158000	20524	10330	3	0	\N
324270	1073	908653465000000	20528	10334	0	0	\N
324271	1874	15172000	20528	10334	1	0	\N
324272	1874	15173000	20528	10334	2	0	\N
324273	1874	15176000	20528	10334	3	0	\N
324281	1678	23040757193000	20531	10335	0	0	\N
324282	1874	15179000	20531	10335	1	0	\N
324283	1874	15181000	20531	10335	2	0	\N
324284	1193	613086750000000	20532	10336	0	0	\N
324285	953	507063775000000	20532	10336	1	0	\N
324286	1678	23040757194000	20532	10336	2	0	\N
324287	1874	15183000	20532	10336	3	0	\N
324288	1874	15186000	20532	10336	4	0	\N
324289	1193	613086750000000	20533	10336	0	0	\N
324290	953	507063775000000	20533	10336	1	0	\N
324291	1678	23040757194000	20533	10336	2	0	\N
324292	1874	15183000	20533	10336	3	0	\N
324293	1874	15186000	20533	10336	4	0	\N
324294	1193	613086750000000	20534	10336	0	0	\N
324295	953	507063775000000	20534	10336	1	0	\N
324296	1678	23040757194000	20534	10336	2	0	\N
324297	1874	15183000	20534	10336	3	0	\N
324298	1874	15186000	20534	10336	4	0	\N
324304	1384	1710568637751650	20536	10187	0	0	\N
324305	1138	909796465000000	20536	10187	1	0	\N
324306	1258	613860750000000	20536	10187	2	0	\N
324307	1018	507701775000000	20536	10187	3	0	\N
324308	1319	1708419637751650	20536	10187	4	0	\N
324309	1073	908653465000000	20536	10187	5	0	\N
324310	1193	613086750000000	20536	10187	6	0	\N
324311	953	507063775000000	20536	10187	7	0	\N
324312	2256	100000000	20536	10187	8	0	\N
324313	963	506768371327637	20536	10187	9	0	\N
324314	1678	23040757116000	20536	10187	10	0	\N
324315	1678	23040757117000	20536	10187	11	0	\N
324316	1678	23040757118000	20536	10187	12	0	\N
324317	1678	23040757119000	20536	10187	13	0	\N
324318	1651	9759236050115	20536	10187	14	0	\N
324319	1678	23040757120000	20536	10187	15	0	\N
324320	1678	23040757121000	20536	10187	16	0	\N
324321	1678	23040757122000	20536	10187	17	0	\N
324322	1678	23040757123000	20536	10187	18	0	\N
324323	1651	9759236050115	20536	10187	19	0	\N
324324	1651	19839236050115	20536	10187	20	0	\N
324325	1678	23040757195000	20537	10337	0	0	\N
324326	1678	23040757196000	20537	10337	1	0	\N
324327	1874	15187000	20537	10337	2	0	\N
324328	1874	15190000	20537	10337	3	0	\N
324329	1874	15192000	20537	10337	4	0	\N
324330	1874	15194000	20537	10337	5	0	\N
324233	1678	23040757189000	20522	10330	0	0	0
324234	1874	15155000	20522	10330	1	0	2
324235	1874	15157000	20522	10330	2	0	2
324236	1874	15158000	20522	10330	3	0	2
324245	1678	23040757190000	20525	10331	0	0	0
324247	462	66347494240603	20525	10331	2	0	0
324248	754	1005265064217	20525	10331	3	0	0
324249	935	508064846578276	20525	10331	4	0	0
324250	1055	910447851968622	20525	10331	5	0	0
324251	1083	908124579427713	20525	10331	6	0	0
324253	1090	910776965400000	20525	10331	8	0	0
324254	970	508247873800000	20525	10331	9	0	0
324255	1336	1712409905351650	20525	10331	10	0	0
324256	932	505786783998400	20525	10331	11	0	0
324258	1203	612729749400383	20526	10332	0	0	0
324259	1678	23040757191000	20526	10332	1	0	0
324260	1175	614297307678252	20526	10332	2	0	0
324261	1874	15162000	20526	10332	3	0	2
324262	1052	906365583343957	20526	10332	4	0	0
324264	1298	1704118721087018	20526	10332	6	0	0
324265	1874	15165000	20526	10332	7	0	2
324266	1319	1708419637751650	20527	10333	0	0	0
324267	1678	23040757192000	20527	10333	1	0	0
324268	1874	15168000	20527	10333	2	0	2
324274	1073	908653465000000	20529	10334	0	0	0
324275	1874	15172000	20529	10334	1	0	2
324276	1874	15173000	20529	10334	2	0	2
324277	1874	15176000	20529	10334	3	0	2
324279	1874	15179000	20530	10335	1	0	2
324280	1874	15181000	20530	10335	2	0	2
324299	1193	613086750000000	20535	10336	0	0	0
324300	953	507063775000000	20535	10336	1	0	0
324301	1678	23040757194000	20535	10336	2	0	0
324303	1874	15186000	20535	10336	4	0	2
324331	1678	23040757195000	20538	10337	0	0	0
324332	1678	23040757196000	20538	10337	1	0	0
324333	1874	15187000	20538	10337	2	0	2
324334	1874	15190000	20538	10337	3	0	2
324336	1874	15194000	20538	10337	5	0	2
324337	1678	23040757197000	20539	10338	0	0	0
324338	1874	15197000	20539	10338	1	0	2
324339	1874	15199000	20539	10338	2	0	2
324341	1329	1707426927595874	20540	10339	1	0	0
324342	1874	15201000	20540	10339	2	0	2
324343	1874	15204000	20540	10339	3	0	2
324344	1874	15205000	20540	10339	4	0	2
324345	1678	23040757199000	20541	10340	0	0	0
324347	1678	23040757200000	20542	10341	0	0	0
324348	1874	15210000	20542	10341	1	0	2
324349	2259	498800000000	20542	10341	2	0	0
324350	1874	15212000	20542	10341	3	0	2
324351	1301	1711794068116628	20543	10342	0	0	0
324353	1678	23040757202000	20543	10342	3	0	0
324354	1874	15215000	20543	10342	4	0	2
324355	1874	15216000	20543	10342	5	0	2
324356	1874	15218000	20543	10342	6	0	2
324358	1874	15223000	20543	10342	8	0	2
324359	1678	23040757203000	20544	10343	0	0	0
324360	1874	15225000	20544	10343	1	0	2
324362	1678	23040757204000	20545	10344	0	0	\N
324363	1874	15231000	20545	10344	1	0	\N
324364	1874	15233000	20545	10344	2	0	\N
324368	1678	23040757204000	20547	10344	0	0	\N
324369	1874	15231000	20547	10344	1	0	\N
324370	1874	15233000	20547	10344	2	0	\N
324378	1678	23040757207000	20552	10347	0	0	\N
324379	1874	15247000	20552	10347	1	0	\N
324380	1874	15249000	20552	10347	2	0	\N
324381	1678	23040757207000	20553	10347	0	0	\N
324382	1874	15247000	20553	10347	1	0	\N
324383	1874	15249000	20553	10347	2	0	\N
324391	1678	23040757208000	20556	10348	0	0	\N
324392	1874	15252000	20556	10348	1	0	\N
324393	1874	15254000	20556	10348	2	0	\N
324394	1874	15255000	20556	10348	3	0	\N
324395	1678	23040757208000	20557	10348	0	0	\N
324396	1874	15252000	20557	10348	1	0	\N
324397	1874	15253000	20557	10348	2	0	\N
324412	1384	1710568637751650	20559	10228	0	0	\N
324413	1138	909796465000000	20559	10228	1	0	\N
324414	1258	613860750000000	20559	10228	2	0	\N
324415	1018	507701775000000	20559	10228	3	0	\N
324416	1319	1708419637751650	20559	10228	4	0	\N
324417	1073	908653465000000	20559	10228	5	0	\N
324418	1193	613086750000000	20559	10228	6	0	\N
324419	953	507063775000000	20559	10228	7	0	\N
324420	2256	100000000	20559	10228	9	0	\N
324421	963	506768371327637	20559	10228	10	0	\N
324422	1651	9759236050115	20559	10228	11	0	\N
324423	13	4694444607287	20559	10228	12	0	\N
324424	19	2347726974088	20559	10228	13	0	\N
324425	203	66616500555940	20559	10228	15	0	\N
324426	241	66616500555940	20559	10228	16	0	\N
324427	313	66616500555940	20559	10228	17	0	\N
324428	1651	9759236050115	20559	10228	18	0	\N
324429	1651	19839236050115	20559	10228	19	0	\N
324430	1083	908124579427713	20559	10228	20	0	\N
324431	1203	612729749400383	20559	10228	21	0	\N
324432	1329	1707425927595874	20559	10228	22	0	\N
324433	965	507350663452652	20559	10228	23	0	\N
324434	1085	909168041926640	20559	10228	24	0	\N
324435	1205	613433794340872	20559	10228	25	0	\N
324436	1331	1709387811422786	20559	10228	26	0	\N
324437	2259	498800000000	20559	10228	27	0	\N
324438	83	66578558947810	20559	10228	28	0	\N
324439	80	66000000000000	20559	10228	29	0	\N
324440	1993	1956348532446	20559	10228	30	0	\N
324441	348	66579458947810	20559	10228	31	0	\N
324442	2251	200000000	20559	10228	32	0	\N
324443	2252	200000000	20559	10228	33	0	\N
324444	2253	200000000	20559	10228	34	0	\N
324445	2254	200000000	20559	10228	35	0	\N
324446	2255	200000000	20559	10228	36	0	\N
324447	2257	200000000	20559	10228	37	0	\N
324448	2206	3799000000	20559	10228	38	0	\N
324449	1090	910776965400000	20559	10228	39	0	\N
324450	970	508247873800000	20559	10228	40	0	\N
324451	1336	1712409905351650	20559	10228	41	0	\N
324452	380	66578558947810	20559	10228	42	0	\N
324453	530	66578657947810	20559	10228	43	0	\N
324454	675	66578558947810	20559	10228	44	0	\N
324455	959	507182874224259	20559	10228	45	0	\N
324456	1079	908867365066994	20559	10228	46	0	\N
324457	1199	613230921672261	20559	10228	47	0	\N
324458	932	505786783998400	20559	10228	48	0	\N
324459	1052	906365583343957	20559	10228	49	0	\N
324460	1172	611542919692213	20559	10228	50	0	\N
324461	1298	1704118721087018	20559	10228	51	0	\N
324462	907	508157428951432	20559	10228	52	0	\N
324463	1027	910613758788112	20559	10228	53	0	\N
324464	1147	614409248315263	20559	10228	54	0	\N
324465	1273	1712106000654838	20559	10228	55	0	\N
324466	2205	3799000000	20559	10228	56	0	\N
324467	2184	3799000000	20559	10228	57	0	\N
324468	2185	2599000000	20559	10228	58	0	\N
324469	2258	200000000	20559	10228	59	0	\N
324470	1210	614519753200000	20559	10228	60	0	\N
324471	1325	1708822488693281	20559	10228	61	0	\N
324472	1678	23040757209000	20560	10349	0	0	\N
324473	13	4694444607287	20560	10349	1	0	\N
324474	19	2347726974088	20560	10349	2	0	\N
324475	203	66616500555940	20560	10349	3	0	\N
324476	241	66616500555940	20560	10349	4	0	\N
324477	313	66616500555940	20560	10349	5	0	\N
324478	965	507350663452652	20560	10349	6	0	\N
324479	1085	909168041926640	20560	10349	7	0	\N
324480	1205	613433794340872	20560	10349	8	0	\N
324481	1331	1709387811422786	20560	10349	9	0	\N
324482	1678	23040757210000	20560	10349	10	0	\N
324483	1874	15258000	20560	10349	11	0	\N
324484	1874	15260000	20560	10349	12	0	\N
324485	1874	15262000	20560	10349	13	0	\N
324489	1874	15265000	20562	10350	0	0	\N
324490	1874	15267000	20562	10350	1	0	\N
324491	1678	23040757211000	20563	10350	0	0	\N
324492	1874	15265000	20563	10350	1	0	\N
324493	1874	15267000	20563	10350	2	0	\N
324366	1874	15231000	20546	10344	1	0	2
324367	1874	15233000	20546	10344	2	0	2
324371	1678	23040757205000	20551	10346	0	0	0
324372	1678	23040757206000	20551	10346	1	0	0
324373	1874	15234000	20551	10346	2	0	2
324375	1874	15240000	20551	10346	4	0	2
324376	1874	15242000	20551	10346	5	0	2
324377	1874	15244000	20551	10346	6	0	2
324384	1678	23040757207000	20554	10347	0	0	0
324385	1874	15247000	20554	10347	1	0	2
324387	1678	23040757208000	20555	10348	0	0	0
324388	1874	15252000	20555	10348	1	0	2
324389	1874	15254000	20555	10348	2	0	2
324390	1874	15255000	20555	10348	3	0	2
324399	13	4694444607287	20558	10349	1	0	0
324400	19	2347726974088	20558	10349	2	0	0
324401	203	66616500555940	20558	10349	3	0	0
324402	241	66616500555940	20558	10349	4	0	0
324403	313	66616500555940	20558	10349	5	0	0
324405	1085	909168041926640	20558	10349	7	0	0
324406	1205	613433794340872	20558	10349	8	0	0
324407	1331	1709387811422786	20558	10349	9	0	0
324408	1678	23040757210000	20558	10349	10	0	0
324409	1874	15258000	20558	10349	11	0	2
324411	1874	15262000	20558	10349	13	0	2
324486	1678	23040757211000	20561	10350	0	0	0
324487	1874	15265000	20561	10350	1	0	2
324488	1874	15267000	20561	10350	2	0	2
324495	1678	23040757212000	20565	10351	1	0	0
324496	1678	23040757213000	20565	10351	2	0	0
324502	2003	2428970654821	20566	10351	0	0	\N
324503	1678	23040757212000	20566	10351	1	0	\N
324504	1678	23040757213000	20566	10351	2	0	\N
324505	1874	15268000	20566	10351	3	0	\N
324506	1874	15270000	20566	10351	4	0	\N
324507	1874	15273000	20566	10351	5	0	\N
324508	1874	15276000	20566	10351	6	0	\N
324509	1874	15278000	20566	10351	7	0	\N
324510	2003	2428970654821	20567	10351	0	0	\N
324511	1678	23040757212000	20567	10351	1	0	\N
324512	1678	23040757213000	20567	10351	2	0	\N
324513	1874	15268000	20567	10351	3	0	\N
324514	1874	15270000	20567	10351	4	0	\N
324515	1874	15273000	20567	10351	5	0	\N
324516	1874	15276000	20567	10351	6	0	\N
324517	1874	15278000	20567	10351	7	0	\N
324518	2003	2428970654821	20568	10351	0	0	\N
324519	1678	23040757212000	20568	10351	1	0	\N
324520	1678	23040757213000	20568	10351	2	0	\N
324521	1874	15268000	20568	10351	3	0	\N
324522	1874	15270000	20568	10351	4	0	\N
324523	1874	15273000	20568	10351	5	0	\N
324524	1874	15276000	20568	10351	6	0	\N
324525	1874	15278000	20568	10351	7	0	\N
324526	2003	2428970654821	20569	10351	0	0	\N
324527	1678	23040757212000	20569	10351	1	0	\N
324528	1678	23040757213000	20569	10351	2	0	\N
324529	1874	15268000	20569	10351	3	0	\N
324530	1874	15270000	20569	10351	4	0	\N
324531	1874	15273000	20569	10351	5	0	\N
324532	1874	15276000	20569	10351	6	0	\N
324533	1874	15278000	20569	10351	7	0	\N
324534	2003	2428970654821	20570	10351	0	0	\N
324535	1678	23040757212000	20570	10351	1	0	\N
324536	1678	23040757213000	20570	10351	2	0	\N
324537	1874	15268000	20570	10351	3	0	\N
324538	1874	15270000	20570	10351	4	0	\N
324539	1874	15273000	20570	10351	5	0	\N
324540	1874	15276000	20570	10351	6	0	\N
324541	1874	15278000	20570	10351	7	0	\N
324542	2003	2428970654821	20571	10351	0	0	\N
324543	1874	15268000	20571	10351	1	0	\N
324544	1874	15270000	20571	10351	2	0	\N
324545	1874	15273000	20571	10351	3	0	\N
324546	1874	15276000	20571	10351	4	0	\N
324547	1874	15278000	20571	10351	5	0	\N
324548	2003	2428970654821	20572	10351	0	0	\N
324549	1678	23040757212000	20572	10351	1	0	\N
324550	1678	23040757213000	20572	10351	2	0	\N
324551	1874	15268000	20572	10351	3	0	\N
324552	1874	15270000	20572	10351	4	0	\N
324553	1874	15273000	20572	10351	5	0	\N
324554	1874	15276000	20572	10351	6	0	\N
324555	1874	15278000	20572	10351	7	0	\N
324556	1319	1708419637751650	20573	10314	0	0	\N
324557	1073	908653465000000	20573	10314	1	0	\N
324558	1193	613086750000000	20573	10314	2	0	\N
324559	953	507063775000000	20573	10314	3	0	\N
324560	963	506768371327637	20573	10314	5	0	\N
324561	1651	19839236050115	20573	10314	6	0	\N
324562	2003	2428970654821	20573	10314	7	0	\N
324563	13	4694444607287	20573	10314	8	0	\N
324564	19	2347726974088	20573	10314	9	0	\N
324565	203	66616500555940	20573	10314	10	0	\N
324566	241	66616500555940	20573	10314	11	0	\N
324567	313	66616500555940	20573	10314	12	0	\N
324568	462	66347494240603	20573	10314	13	0	\N
324569	754	1005265064217	20573	10314	14	0	\N
324570	935	508064846578276	20573	10314	15	0	\N
324571	1055	910447851968622	20573	10314	16	0	\N
324572	1083	908124579427713	20573	10314	17	0	\N
324573	1203	612729749400383	20573	10314	18	0	\N
324574	1329	1707425927595874	20573	10314	19	0	\N
324575	965	507350663452652	20573	10314	20	0	\N
324576	1085	909168041926640	20573	10314	21	0	\N
324577	1205	613433794340872	20573	10314	22	0	\N
324578	1331	1709387811422786	20573	10314	23	0	\N
324579	1678	23040757166000	20573	10314	24	0	\N
324580	1678	23040757167000	20573	10314	25	0	\N
324581	1678	23040757168000	20573	10314	26	0	\N
324582	1678	23040757169000	20573	10314	27	0	\N
324583	1678	23040757170000	20573	10314	28	0	\N
324584	1678	23040757171000	20573	10314	29	0	\N
324585	1678	23040757172000	20573	10314	30	0	\N
324586	1678	23040757173000	20573	10314	31	0	\N
324587	1678	23040757174000	20573	10314	32	0	\N
324588	1678	23040757175000	20573	10314	33	0	\N
324589	1678	23040757176000	20573	10314	34	0	\N
324590	1678	23040757177000	20573	10314	35	0	\N
324591	1678	23040757178000	20573	10314	36	0	\N
324592	1678	23040757179000	20573	10314	37	0	\N
324593	1678	23040757180000	20573	10314	38	0	\N
324594	1678	23040757181000	20573	10314	39	0	\N
324595	1678	23040757182000	20573	10314	40	0	\N
324596	1678	23040757183000	20573	10314	41	0	\N
324597	1678	23040757184000	20573	10314	42	0	\N
324598	1678	23040757185000	20573	10314	43	0	\N
324599	1678	23040757186000	20573	10314	44	0	\N
324600	1678	23040757187000	20573	10314	45	0	\N
324601	1678	23040757188000	20573	10314	46	0	\N
324602	1678	23040757189000	20573	10314	47	0	\N
324603	1678	23040757190000	20573	10314	48	0	\N
324604	1678	23040757191000	20573	10314	49	0	\N
324605	1678	23040757192000	20573	10314	50	0	\N
324606	1678	23040757193000	20573	10314	51	0	\N
324607	1678	23040757194000	20573	10314	52	0	\N
324608	1678	23040757195000	20573	10314	53	0	\N
324609	1678	23040757196000	20573	10314	54	0	\N
324610	1678	23040757197000	20573	10314	55	0	\N
324611	1678	23040757198000	20573	10314	56	0	\N
324612	1678	23040757199000	20573	10314	57	0	\N
324613	1678	23040757200000	20573	10314	58	0	\N
324614	1678	23040757201000	20573	10314	59	0	\N
324615	1678	23040757202000	20573	10314	60	0	\N
324616	1678	23040757203000	20573	10314	61	0	\N
324617	1678	23040757204000	20573	10314	62	0	\N
324618	1678	23040757205000	20573	10314	63	0	\N
324619	1678	23040757206000	20573	10314	64	0	\N
324620	1678	23040757207000	20573	10314	65	0	\N
324621	1678	23040757208000	20573	10314	66	0	\N
324622	1678	23040757209000	20573	10314	67	0	\N
324623	1678	23040757210000	20573	10314	68	0	\N
324624	1678	23040757211000	20573	10314	69	0	\N
324625	1678	23040757212000	20573	10314	70	0	\N
324626	1678	23040757213000	20573	10314	71	0	\N
324627	2259	498800000000	20573	10314	72	0	\N
324628	2206	3799000000	20573	10314	73	0	\N
324629	1874	15040000	20573	10314	74	0	\N
324630	1874	15041000	20573	10314	75	0	\N
324631	1874	15042000	20573	10314	76	0	\N
324632	1874	15043000	20573	10314	77	0	\N
324499	1874	15273000	20565	10351	5	0	2
324500	1874	15276000	20565	10351	6	0	2
324501	1874	15278000	20565	10351	7	0	2
324633	1874	15044000	20573	10314	78	0	\N
324634	1874	15045000	20573	10314	79	0	\N
324635	1090	910776965400000	20573	10314	80	0	\N
324636	970	508247873800000	20573	10314	81	0	\N
324637	1336	1712409905351650	20573	10314	82	0	\N
324638	932	505786783998400	20573	10314	83	0	\N
324639	1052	906365583343957	20573	10314	84	0	\N
324640	1172	611542919692213	20573	10314	85	0	\N
324641	1298	1704118721087018	20573	10314	86	0	\N
324642	1874	15047000	20573	10314	87	0	\N
324643	1874	15049000	20573	10314	88	0	\N
324644	1874	15051000	20573	10314	90	0	\N
324645	1874	15053000	20573	10314	91	0	\N
324646	1874	15056000	20573	10314	92	0	\N
324647	1874	15059000	20573	10314	93	0	\N
324648	1874	15062000	20573	10314	94	0	\N
324649	1874	15065000	20573	10314	95	0	\N
324650	1874	15068000	20573	10314	96	0	\N
324651	1874	15071000	20573	10314	97	0	\N
324652	1874	15074000	20573	10314	98	0	\N
324657	1678	23040757215000	20575	10353	1	0	\N
324658	1874	15284000	20575	10353	2	0	\N
324659	1874	15286000	20575	10353	3	0	\N
324663	1678	23040757216000	20577	10354	0	0	\N
324664	1874	15289000	20577	10354	1	0	\N
324665	1874	15291000	20577	10354	2	0	\N
324666	1678	23040757216000	20578	10354	0	0	\N
324667	1874	15289000	20578	10354	1	0	\N
324668	1874	15291000	20578	10354	2	0	\N
324669	1384	1710568637751650	20579	10248	0	0	\N
324670	1138	909796465000000	20579	10248	1	0	\N
324671	1258	613860750000000	20579	10248	2	0	\N
324672	1018	507701775000000	20579	10248	3	0	\N
324673	1319	1708419637751650	20579	10248	4	0	\N
324674	1073	908653465000000	20579	10248	5	0	\N
324675	1193	613086750000000	20579	10248	6	0	\N
324676	953	507063775000000	20579	10248	7	0	\N
324677	1678	23040757158000	20579	10248	8	0	\N
324678	1678	23040757159000	20579	10248	10	0	\N
324679	1678	23040757160000	20579	10248	11	0	\N
324680	963	506768371327637	20579	10248	12	0	\N
324681	1651	9759236050115	20579	10248	13	0	\N
324682	2003	2428970654821	20579	10248	14	0	\N
324683	13	4694444607287	20579	10248	15	0	\N
324684	19	2347726974088	20579	10248	16	0	\N
324685	203	66616500555940	20579	10248	17	0	\N
324686	241	66616500555940	20579	10248	18	0	\N
324687	313	66616500555940	20579	10248	19	0	\N
324688	1651	19839236050115	20579	10248	20	0	\N
324689	1678	23040757161000	20579	10248	21	0	\N
324690	1678	23040757162000	20579	10248	22	0	\N
324691	1678	23040757163000	20579	10248	23	0	\N
324692	1678	23040757164000	20579	10248	24	0	\N
324693	1678	23040757165000	20579	10248	25	0	\N
324694	1083	908124579427713	20579	10248	26	0	\N
324695	1203	612729749400383	20579	10248	27	0	\N
324696	1329	1707425927595874	20579	10248	28	0	\N
324697	965	507350663452652	20579	10248	29	0	\N
324698	1085	909168041926640	20579	10248	30	0	\N
324699	1205	613433794340872	20579	10248	31	0	\N
324700	1331	1709387811422786	20579	10248	32	0	\N
324701	1678	23040757166000	20579	10248	33	0	\N
324702	1678	23040757167000	20579	10248	34	0	\N
324703	1678	23040757168000	20579	10248	35	0	\N
324704	1678	23040757169000	20579	10248	36	0	\N
324705	1678	23040757170000	20579	10248	37	0	\N
324706	1678	23040757171000	20579	10248	38	0	\N
324707	1678	23040757172000	20579	10248	39	0	\N
324708	1678	23040757173000	20579	10248	40	0	\N
324709	1678	23040757174000	20579	10248	41	0	\N
324710	1678	23040757175000	20579	10248	42	0	\N
324711	1678	23040757176000	20579	10248	43	0	\N
324712	1678	23040757177000	20579	10248	44	0	\N
324713	1678	23040757178000	20579	10248	45	0	\N
324714	1678	23040757179000	20579	10248	46	0	\N
324715	1678	23040757180000	20579	10248	47	0	\N
324716	1678	23040757181000	20579	10248	48	0	\N
324717	1678	23040757182000	20579	10248	49	0	\N
324718	1678	23040757183000	20579	10248	50	0	\N
324719	1678	23040757184000	20579	10248	51	0	\N
324720	1678	23040757185000	20579	10248	52	0	\N
324721	1678	23040757186000	20579	10248	53	0	\N
324722	1678	23040757187000	20579	10248	54	0	\N
324723	1678	23040757188000	20579	10248	55	0	\N
324724	1678	23040757189000	20579	10248	56	0	\N
324725	1678	23040757190000	20579	10248	57	0	\N
324726	1678	23040757191000	20579	10248	58	0	\N
324727	1678	23040757192000	20579	10248	59	0	\N
324728	1678	23040757193000	20579	10248	60	0	\N
324729	1678	23040757194000	20579	10248	61	0	\N
324730	1678	23040757195000	20579	10248	62	0	\N
324731	1678	23040757196000	20579	10248	63	0	\N
324732	1678	23040757197000	20579	10248	64	0	\N
324733	1678	23040757198000	20579	10248	65	0	\N
324734	1678	23040757199000	20579	10248	67	0	\N
324735	1678	23040757200000	20579	10248	68	0	\N
324736	1678	23040757201000	20579	10248	69	0	\N
324737	1678	23040757202000	20579	10248	70	0	\N
324738	1678	23040757203000	20579	10248	71	0	\N
324739	1678	23040757204000	20579	10248	72	0	\N
324740	1678	23040757205000	20579	10248	73	0	\N
324741	1678	23040757206000	20579	10248	74	0	\N
324742	1678	23040757207000	20579	10248	75	0	\N
324743	1678	23040757208000	20579	10248	76	0	\N
324744	1678	23040757209000	20579	10248	77	0	\N
324745	1678	23040757210000	20579	10248	78	0	\N
324746	1678	23040757211000	20579	10248	79	0	\N
324747	1678	23040757212000	20579	10248	80	0	\N
324748	1678	23040757213000	20579	10248	81	0	\N
324749	1678	23040757214000	20579	10248	82	0	\N
324750	1678	23040757215000	20579	10248	83	0	\N
324751	1678	23040757216000	20579	10248	84	0	\N
324752	1874	14833000	20579	10248	85	0	\N
324753	2259	498800000000	20579	10248	86	0	\N
324754	1874	14835000	20579	10248	87	0	\N
324755	1874	14837000	20579	10248	88	0	\N
324756	2257	200000000	20579	10248	89	0	\N
324757	2206	3799000000	20579	10248	90	0	\N
324758	1090	910776965400000	20579	10248	91	0	\N
324759	970	508247873800000	20579	10248	92	0	\N
324760	1336	1712409905351650	20579	10248	93	0	\N
324761	1874	14838000	20579	10248	94	0	\N
324762	1874	14839000	20579	10248	95	0	\N
324763	1874	14840000	20579	10248	96	0	\N
324764	1874	14841000	20579	10248	97	0	\N
324765	1874	14842000	20579	10248	98	0	\N
324766	1874	14843000	20579	10248	99	0	\N
324767	1874	14844000	20579	10248	100	0	\N
324768	1678	23040757216000	20580	10354	0	0	\N
324655	1874	15283000	20574	10352	2	0	2
324656	1483	10000000	20574	10352	3	0	0
324660	1678	23040757215000	20576	10353	1	0	0
324661	1874	15284000	20576	10353	2	0	2
324662	1874	15286000	20576	10353	3	0	2
324769	1874	15289000	20580	10354	1	0	\N
324770	1874	15291000	20580	10354	2	0	\N
324774	1008	506594957082875	20582	10355	0	0	\N
324775	1678	23040757217000	20582	10355	1	0	\N
324776	1678	23040757218000	20582	10355	2	0	\N
324777	1874	15292000	20582	10355	3	0	\N
324778	1874	15295000	20582	10355	4	0	\N
324779	1874	15297000	20582	10355	5	0	\N
324780	1874	15299000	20582	10355	6	0	\N
324781	1874	15302000	20582	10355	7	0	\N
324799	1678	23040757219000	20585	10356	0	0	\N
324800	2037	1546000000000	20585	10356	1	0	\N
324801	1128	907813822586899	20585	10356	2	0	\N
324802	1248	612520075567628	20585	10356	3	0	\N
324803	1374	1706841652817754	20585	10356	4	0	\N
324804	1373	1707191380766396	20585	10356	5	0	\N
324805	1127	907999854007842	20585	10356	6	0	\N
324806	1247	612645625005290	20585	10356	7	0	\N
324807	1874	15303000	20585	10356	8	0	\N
324808	1874	15305000	20585	10356	9	0	\N
324809	1678	23040757219000	20586	10356	0	0	\N
324810	2037	1546000000000	20586	10356	1	0	\N
324811	1128	907813822586899	20586	10356	2	0	\N
324812	1248	612520075567628	20586	10356	3	0	\N
324813	1374	1706841652817754	20586	10356	4	0	\N
324814	1373	1707191380766396	20586	10356	5	0	\N
324815	1127	907999854007842	20586	10356	6	0	\N
324816	1247	612645625005290	20586	10356	7	0	\N
324817	1874	15303000	20586	10356	8	0	\N
324818	1874	15305000	20586	10356	9	0	\N
324819	1678	23040757220000	20587	10357	0	0	\N
324820	598	66514703000574	20587	10357	1	0	\N
324821	1874	15307000	20587	10357	2	0	\N
324822	1874	15310000	20587	10357	3	0	\N
324827	1678	23040757220000	20589	10357	0	0	\N
324828	598	66514703000574	20589	10357	1	0	\N
324829	1874	15307000	20589	10357	2	0	\N
324830	1874	15310000	20589	10357	3	0	\N
324831	1678	23040757220000	20590	10357	0	0	\N
324832	1874	15307000	20590	10357	1	0	\N
324833	1874	15310000	20590	10357	2	0	\N
324834	1678	23040757221000	20591	10358	0	0	\N
324835	1874	15313000	20591	10358	1	0	\N
324836	1874	15315000	20591	10358	2	0	\N
324846	2040	2016040000000	20594	10359	0	0	\N
324847	1678	23040757222000	20594	10359	1	0	\N
324848	1874	15316000	20594	10359	2	0	\N
324849	1874	15318000	20594	10359	3	0	\N
324850	2040	2016040000000	20595	10359	0	0	\N
324851	1377	1711490787751650	20595	10359	1	0	\N
324852	1678	23040757222000	20595	10359	2	0	\N
324853	1874	15318000	20595	10359	3	0	\N
324854	1874	15319000	20595	10359	4	0	\N
324855	1874	15321000	20595	10359	5	0	\N
324856	1319	1708419637751650	20596	10332	0	0	\N
324857	1073	908653465000000	20596	10332	1	0	\N
324858	1193	613086750000000	20596	10332	2	0	\N
324859	953	507063775000000	20596	10332	3	0	\N
324860	2040	2016040000000	20596	10332	4	0	\N
324861	1008	506594957082875	20596	10332	5	0	\N
324862	2003	2428970654821	20596	10332	7	0	\N
324863	1377	1711490787751650	20596	10332	8	0	\N
324864	2037	1546000000000	20596	10332	9	0	\N
324865	1128	907813822586899	20596	10332	10	0	\N
324866	1248	612520075567628	20596	10332	11	0	\N
324867	1374	1706841652817754	20596	10332	12	0	\N
324868	1203	612729749400383	20596	10332	13	0	\N
324869	13	4694444607287	20596	10332	14	0	\N
324870	19	2347726974088	20596	10332	15	0	\N
324871	203	66616500555940	20596	10332	16	0	\N
324872	241	66616500555940	20596	10332	17	0	\N
324873	313	66616500555940	20596	10332	18	0	\N
324874	1131	910286595000000	20596	10332	19	0	\N
324875	1251	614188560000000	20596	10332	20	0	\N
324876	1373	1707191380766396	20596	10332	21	0	\N
324877	1127	907999854007842	20596	10332	22	0	\N
324878	1247	612645625005290	20596	10332	23	0	\N
324879	1007	506698773004376	20596	10332	24	0	\N
324880	1011	507974845000000	20596	10332	25	0	\N
324881	1678	23040757191000	20596	10332	26	0	\N
324882	1678	23040757192000	20596	10332	27	0	\N
324883	1678	23040757193000	20596	10332	28	0	\N
324884	1678	23040757194000	20596	10332	29	0	\N
324885	1678	23040757195000	20596	10332	30	0	\N
324886	1678	23040757196000	20596	10332	31	0	\N
324887	1678	23040757197000	20596	10332	32	0	\N
324888	1678	23040757198000	20596	10332	33	0	\N
324889	1678	23040757199000	20596	10332	34	0	\N
324890	1678	23040757200000	20596	10332	35	0	\N
324891	1678	23040757201000	20596	10332	36	0	\N
324892	1678	23040757202000	20596	10332	37	0	\N
324893	1678	23040757203000	20596	10332	38	0	\N
324894	1678	23040757204000	20596	10332	39	0	\N
324895	1678	23040757205000	20596	10332	40	0	\N
324896	1678	23040757206000	20596	10332	41	0	\N
324897	1329	1707426927595874	20596	10332	42	0	\N
324898	965	507350663452652	20596	10332	43	0	\N
324899	1085	909168041926640	20596	10332	44	0	\N
324900	1205	613433794340872	20596	10332	45	0	\N
324901	1331	1709387811422786	20596	10332	46	0	\N
324902	1175	614297307678252	20596	10332	47	0	\N
324903	1301	1711794068116628	20596	10332	48	0	\N
324904	1678	23040757207000	20596	10332	49	0	\N
324773	1874	15291000	20581	10354	2	0	2
324782	1008	506594957082875	20583	10355	0	0	0
324783	1678	23040757217000	20583	10355	1	0	0
324784	1678	23040757218000	20583	10355	2	0	0
324785	1874	15292000	20583	10355	3	0	2
324787	1874	15297000	20583	10355	5	0	2
324788	1874	15300000	20583	10355	6	0	2
324789	1678	23040757219000	20584	10356	0	0	0
324790	2037	1546000000000	20584	10356	1	0	0
324791	1128	907813822586899	20584	10356	2	0	0
324793	1374	1706841652817754	20584	10356	4	0	0
324794	1373	1707191380766396	20584	10356	5	0	0
324795	1127	907999854007842	20584	10356	6	0	0
324796	1247	612645625005290	20584	10356	7	0	0
324798	1874	15305000	20584	10356	9	0	2
324823	1678	23040757220000	20588	10357	0	0	0
324824	598	66514703000574	20588	10357	1	0	0
324825	1874	15307000	20588	10357	2	0	2
324826	1874	15310000	20588	10357	3	0	2
324838	1874	15313000	20592	10358	1	0	2
324839	1874	15315000	20592	10358	2	0	2
324840	2040	2016040000000	20593	10359	0	0	0
324841	1377	1711490787751650	20593	10359	1	0	0
324842	1678	23040757222000	20593	10359	2	0	0
324844	1874	15319000	20593	10359	4	0	2
324845	1874	15321000	20593	10359	5	0	2
324905	1678	23040757208000	20596	10332	50	0	\N
324906	1678	23040757209000	20596	10332	51	0	\N
324907	1678	23040757210000	20596	10332	52	0	\N
324908	1678	23040757211000	20596	10332	53	0	\N
324909	1678	23040757212000	20596	10332	54	0	\N
324910	1678	23040757213000	20596	10332	55	0	\N
324911	1678	23040757214000	20596	10332	56	0	\N
324912	1678	23040757215000	20596	10332	57	0	\N
324913	1678	23040757216000	20596	10332	58	0	\N
324914	1678	23040757217000	20596	10332	59	0	\N
324915	1678	23040757218000	20596	10332	60	0	\N
324916	1678	23040757219000	20596	10332	61	0	\N
324917	1678	23040757220000	20596	10332	62	0	\N
324918	1678	23040757221000	20596	10332	63	0	\N
324919	1678	23040757222000	20596	10332	64	0	\N
324920	1678	23040757223000	20596	10332	65	0	\N
324921	1874	15162000	20596	10332	66	0	\N
324922	2259	498800000000	20596	10332	67	0	\N
324923	1052	906365583343957	20596	10332	68	0	\N
324924	1172	611542919692213	20596	10332	69	0	\N
324925	1298	1704118721087018	20596	10332	70	0	\N
324926	1874	15164000	20596	10332	71	0	\N
324927	1874	15166000	20596	10332	72	0	\N
324928	1874	15169000	20596	10332	73	0	\N
324929	1874	15172000	20596	10332	74	0	\N
324930	1874	15173000	20596	10332	75	0	\N
324931	1874	15174000	20596	10332	76	0	\N
324932	1874	15175000	20596	10332	77	0	\N
324933	1874	15176000	20596	10332	78	0	\N
324934	1874	15177000	20596	10332	79	0	\N
324935	1874	15178000	20596	10332	80	0	\N
324936	1874	15179000	20596	10332	81	0	\N
324937	1874	15180000	20596	10332	82	0	\N
324938	1874	15181000	20596	10332	83	0	\N
324939	1874	15182000	20596	10332	84	0	\N
324940	1483	10000000	20596	10332	86	0	\N
324941	1874	15184000	20596	10332	87	0	\N
324942	1874	15186000	20596	10332	88	0	\N
324943	1874	15188000	20596	10332	89	0	\N
324944	1874	15190000	20596	10332	90	0	\N
324945	1874	15192000	20596	10332	91	0	\N
324946	1874	15194000	20596	10332	92	0	\N
324947	1874	15196000	20596	10332	93	0	\N
324948	1874	15198000	20596	10332	94	0	\N
324949	1874	15200000	20596	10332	95	0	\N
324950	1874	15202000	20596	10332	96	0	\N
324951	1874	15204000	20596	10332	97	0	\N
324952	1874	15206000	20596	10332	98	0	\N
324953	1874	15208000	20596	10332	99	0	\N
324954	1874	15210000	20596	10332	100	0	\N
324955	1874	15212000	20596	10332	101	0	\N
324956	1874	15214000	20596	10332	102	0	\N
324957	1874	15216000	20596	10332	103	0	\N
324958	1874	15218000	20596	10332	104	0	\N
324959	1874	15220000	20596	10332	105	0	\N
324960	1874	15222000	20596	10332	106	0	\N
324961	1874	15225000	20596	10332	107	0	\N
324962	1874	15228000	20596	10332	108	0	\N
324963	1874	15231000	20596	10332	109	0	\N
324964	1874	15234000	20596	10332	110	0	\N
324965	1874	15237000	20596	10332	111	0	\N
324966	1874	15240000	20596	10332	112	0	\N
324967	1874	15243000	20596	10332	113	0	\N
324968	1874	15246000	20596	10332	114	0	\N
324969	1874	15249000	20596	10332	115	0	\N
324970	1874	15252000	20596	10332	116	0	\N
324971	1874	15255000	20596	10332	117	0	\N
324972	1874	15258000	20596	10332	118	0	\N
324973	1874	15261000	20596	10332	119	0	\N
324974	1874	15264000	20596	10332	120	0	\N
324975	1874	15267000	20596	10332	121	0	\N
324976	1874	15270000	20596	10332	122	0	\N
324977	1874	15273000	20596	10332	123	0	\N
324978	1874	15276000	20596	10332	124	0	\N
324979	1874	15279000	20596	10332	125	0	\N
324989	1678	23040757226000	20600	10363	0	0	\N
324990	1874	15336000	20600	10363	1	0	\N
324991	1874	15339000	20600	10363	2	0	\N
324995	1678	23040757227000	20602	10364	0	0	\N
324996	1874	15341000	20602	10364	1	0	\N
324997	1678	23040757227000	20603	10364	0	0	\N
324998	1874	15341000	20603	10364	1	0	\N
325001	1874	15341000	20605	10364	0	0	\N
325002	1678	23040757227000	20606	10364	0	0	\N
325003	1874	15341000	20606	10364	1	0	\N
325004	1678	23040757227000	20607	10364	0	0	\N
325005	1874	15341000	20607	10364	1	0	\N
325006	1384	1710568637751650	20608	10287	0	0	\N
325007	1138	909796465000000	20608	10287	1	0	\N
325008	1258	613860750000000	20608	10287	2	0	\N
325009	1018	507701775000000	20608	10287	3	0	\N
325010	1319	1708419637751650	20608	10287	4	0	\N
325011	1073	908653465000000	20608	10287	5	0	\N
325012	1193	613086750000000	20608	10287	6	0	\N
325013	953	507063775000000	20608	10287	7	0	\N
325014	2040	2016040000000	20608	10287	8	0	\N
325015	1008	506594957082875	20608	10287	9	0	\N
325016	2256	100000000	20608	10287	11	0	\N
325017	1377	1711490787751650	20608	10287	12	0	\N
325018	2037	1546000000000	20608	10287	13	0	\N
325019	1128	907813822586899	20608	10287	14	0	\N
325020	1248	612520075567628	20608	10287	15	0	\N
325021	1374	1706841652817754	20608	10287	16	0	\N
325022	963	506768371327637	20608	10287	17	0	\N
325023	1651	9759236050115	20608	10287	18	0	\N
325024	2003	2428970654821	20608	10287	19	0	\N
325025	13	4694444607287	20608	10287	20	0	\N
325026	19	2347726974088	20608	10287	21	0	\N
325027	203	66616500555940	20608	10287	22	0	\N
324982	1678	23040757224000	20598	10361	0	0	0
324983	1874	15326000	20598	10361	1	0	2
324984	1874	15328000	20598	10361	2	0	2
324985	1678	23040757225000	20599	10362	0	0	0
324986	1874	15330000	20599	10362	1	0	2
324988	1874	15334000	20599	10362	3	0	2
324992	1678	23040757226000	20601	10363	0	0	0
324993	1874	15336000	20601	10363	1	0	2
324994	1874	15339000	20601	10363	2	0	2
324999	1678	23040757227000	20604	10364	0	0	0
325028	1678	23040757228000	20609	10365	0	0	0
325029	1678	23040757229000	20609	10365	1	0	0
325030	1874	15344000	20609	10365	2	0	2
325031	1874	15345000	20609	10365	3	0	2
325033	1874	15349000	20609	10365	5	0	2
325034	1678	23040757230000	20610	10366	0	0	0
325035	1678	23040757231000	20610	10366	1	0	0
325036	1678	23040757232000	20610	10366	2	0	0
325037	1874	15350000	20610	10366	3	0	2
325039	1874	15356000	20610	10366	5	0	2
325040	1874	15358000	20610	10366	6	0	2
325044	1678	23040757230000	20611	10366	0	0	\N
325045	1678	23040757231000	20611	10366	1	0	\N
325046	1678	23040757232000	20611	10366	2	0	\N
325047	1874	15350000	20611	10366	3	0	\N
325048	1874	15353000	20611	10366	4	0	\N
325049	1874	15356000	20611	10366	5	0	\N
325050	1874	15358000	20611	10366	6	0	\N
325051	1874	15360000	20611	10366	7	0	\N
325052	1874	15362000	20611	10366	8	0	\N
325053	1874	15365000	20611	10366	9	0	\N
325057	1678	23040757233000	20613	10367	0	0	\N
325058	1874	15367000	20613	10367	1	0	\N
325059	1874	15370000	20613	10367	2	0	\N
325063	1678	23040757234000	20615	10368	0	0	\N
325064	1874	15372000	20615	10368	1	0	\N
325065	1874	15375000	20615	10368	2	0	\N
325085	2040	2016040000000	20620	10341	0	0	\N
325086	1008	506594957082875	20620	10341	1	0	\N
325087	1377	1711490787751650	20620	10341	3	0	\N
325088	2037	1546000000000	20620	10341	4	0	\N
325089	1128	907813822586899	20620	10341	5	0	\N
325090	1248	612520075567628	20620	10341	6	0	\N
325091	1374	1706841652817754	20620	10341	7	0	\N
325092	1131	910286595000000	20620	10341	8	0	\N
325093	1251	614188560000000	20620	10341	9	0	\N
325094	1373	1707191380766396	20620	10341	10	0	\N
325095	1127	907999854007842	20620	10341	11	0	\N
325096	1247	612645625005290	20620	10341	12	0	\N
325097	1007	506698773004376	20620	10341	13	0	\N
325098	1011	507974845000000	20620	10341	14	0	\N
325099	2259	498800000000	20620	10341	15	0	\N
325100	2260	200000000	20620	10341	16	0	\N
325101	2262	200000000	20620	10341	17	0	\N
325102	2184	4999000000	20620	10341	18	0	\N
325103	1483	10000000	20620	10341	22	0	\N
325108	2260	280000000	20622	10374	0	0	\N
325109	1874	15406000	20622	10374	1	0	\N
325110	1874	15408000	20622	10374	2	0	\N
325111	1874	15409000	20622	10374	3	0	\N
325112	1874	15412000	20622	10374	5	0	\N
325113	1874	15415000	20622	10374	6	0	\N
325114	2040	2016040000000	20623	10359	0	0	\N
325115	1377	1711490787751650	20623	10359	1	0	\N
325116	1131	910286595000000	20623	10359	3	0	\N
325117	1251	614188560000000	20623	10359	4	0	\N
325118	1011	507974845000000	20623	10359	5	0	\N
325119	1678	23040757222000	20623	10359	6	0	\N
325120	1678	23040757223000	20623	10359	7	0	\N
325121	1678	23040757224000	20623	10359	8	0	\N
325122	1678	23040757225000	20623	10359	9	0	\N
325123	1678	23040757226000	20623	10359	10	0	\N
325124	1678	23040757227000	20623	10359	11	0	\N
325125	1678	23040757228000	20623	10359	12	0	\N
325126	1678	23040757229000	20623	10359	13	0	\N
325127	1678	23040757230000	20623	10359	14	0	\N
325128	1678	23040757231000	20623	10359	15	0	\N
325129	1678	23040757232000	20623	10359	16	0	\N
325130	1678	23040757233000	20623	10359	17	0	\N
325131	1678	23040757234000	20623	10359	18	0	\N
325132	1678	23040757235000	20623	10359	19	0	\N
325133	1678	23040757236000	20623	10359	20	0	\N
325134	1678	23040757237000	20623	10359	21	0	\N
325135	1678	23040757238000	20623	10359	22	0	\N
325136	2260	200000000	20623	10359	23	0	\N
325137	2262	200000000	20623	10359	24	0	\N
325138	2184	4999000000	20623	10359	25	0	\N
325139	1874	15318000	20623	10359	26	0	\N
325140	1874	15321000	20623	10359	28	0	\N
325141	2263	200000000	20623	10359	34	0	\N
325142	2264	200000000	20623	10359	35	0	\N
325143	2265	200000000	20623	10359	36	0	\N
325144	1874	15322000	20623	10359	37	0	\N
325145	1874	15323000	20623	10359	38	0	\N
325146	1874	15324000	20623	10359	39	0	\N
325147	1874	15325000	20623	10359	40	0	\N
325148	1874	15326000	20623	10359	41	0	\N
325149	1874	15327000	20623	10359	42	0	\N
325150	1874	15328000	20623	10359	43	0	\N
325151	1874	15331000	20623	10359	44	0	\N
325152	1874	15334000	20623	10359	45	0	\N
325153	1874	15337000	20623	10359	46	0	\N
325154	1874	15340000	20623	10359	47	0	\N
325155	1874	15343000	20623	10359	48	0	\N
325156	1874	15346000	20623	10359	49	0	\N
325157	1874	15349000	20623	10359	50	0	\N
325158	1874	15352000	20623	10359	51	0	\N
325159	1874	15355000	20623	10359	52	0	\N
325160	1874	15358000	20623	10359	53	0	\N
325161	1874	15361000	20623	10359	54	0	\N
325162	1874	15364000	20623	10359	55	0	\N
325163	1874	15367000	20623	10359	56	0	\N
325164	1874	15370000	20623	10359	57	0	\N
325165	1874	15373000	20623	10359	58	0	\N
325166	1874	15375000	20623	10359	59	0	\N
325167	1874	15377000	20623	10359	60	0	\N
325168	1874	15379000	20623	10359	61	0	\N
325169	1874	15381000	20623	10359	62	0	\N
325170	1874	15383000	20623	10359	63	0	\N
325171	1874	15385000	20623	10359	64	0	\N
325172	1874	15387000	20623	10359	65	0	\N
325173	1874	15389000	20623	10359	66	0	\N
325174	1874	15391000	20623	10359	67	0	\N
325175	1874	15393000	20623	10359	68	0	\N
325176	1874	15395000	20623	10359	69	0	\N
325043	1874	15365000	20610	10366	9	0	2
325054	1678	23040757233000	20612	10367	0	0	0
325055	1874	15367000	20612	10367	1	0	2
325056	1874	15370000	20612	10367	2	0	2
325060	1678	23040757234000	20614	10368	0	0	0
325062	1874	15375000	20614	10368	2	0	2
325066	1678	23040757235000	20616	10369	0	0	0
325067	1874	15376000	20616	10369	1	0	2
325068	1874	15378000	20616	10369	2	0	2
325069	1874	15381000	20616	10369	4	0	2
325071	1678	23040757237000	20617	10370	1	0	0
325072	1874	15384000	20617	10370	3	0	2
325073	1874	15387000	20617	10370	4	0	2
325074	1678	23040757238000	20618	10371	0	0	0
325076	1874	15392000	20618	10371	2	0	2
325077	1874	15394000	20618	10371	4	0	2
325078	1874	15396000	20618	10371	5	0	2
325079	1874	15397000	20618	10371	6	0	2
325080	2260	200000000	20619	10372	0	0	0
325082	2184	4999000000	20619	10372	2	0	1
325083	1874	15399000	20619	10372	3	0	2
325084	1874	15402000	20619	10372	4	0	2
325104	1874	15404000	20621	10373	0	0	2
325105	2263	200000000	20621	10373	2	0	0
325107	2265	200000000	20621	10373	4	0	0
325177	1874	15397000	20623	10359	70	0	\N
325178	1874	15399000	20623	10359	71	0	\N
325179	1874	15401000	20623	10359	72	0	\N
325180	1874	15403000	20623	10359	73	0	\N
325181	1874	15405000	20623	10359	74	0	\N
325182	1874	15407000	20623	10359	75	0	\N
325183	1874	15409000	20623	10359	76	0	\N
325184	1874	15411000	20623	10359	77	0	\N
325185	1874	15413000	20623	10359	78	0	\N
325186	1874	15415000	20623	10359	79	0	\N
325246	1061	910619165000000	20632	10381	0	0	\N
325247	1181	614412890000000	20632	10381	1	0	\N
325248	941	508161275000000	20632	10381	2	0	\N
325249	1678	23040757250000	20632	10381	3	0	\N
325250	1283	1707425937751650	20632	10381	4	0	\N
325251	1037	908124585000000	20632	10381	5	0	\N
325252	1157	612729760000000	20632	10381	6	0	\N
325253	917	506768385000000	20632	10381	7	0	\N
325254	1874	15478000	20632	10381	8	0	\N
325255	1874	15479000	20632	10381	9	0	\N
325256	1874	15481000	20632	10381	10	0	\N
325271	1678	23040757251000	20635	10382	0	0	\N
325272	1874	15483000	20635	10382	1	0	\N
325273	1874	15486000	20635	10382	2	0	\N
325280	1678	23040757253000	20638	10384	0	0	\N
325281	1874	15490000	20638	10384	1	0	\N
325282	1874	15491000	20638	10384	2	0	\N
325283	1874	15494000	20638	10384	3	0	\N
325299	1678	23040757259000	20643	10389	0	0	\N
325300	1874	15520000	20643	10389	1	0	\N
325301	1874	15522000	20643	10389	2	0	\N
325302	1678	23040757259000	20644	10389	0	0	\N
325303	1874	15520000	20644	10389	1	0	\N
325304	1874	15522000	20644	10389	2	0	\N
325308	1307	1712116157751650	20646	10357	0	0	\N
325309	1308	1708575037751650	20646	10357	1	0	\N
325310	1062	908736865000000	20646	10357	2	0	\N
325311	1182	613142150000000	20646	10357	3	0	\N
325312	1061	910619165000000	20646	10357	4	0	\N
325189	1874	15408000	20625	10374	2	0	2
325190	1874	15409000	20625	10374	3	0	2
325191	1874	15412000	20625	10374	5	0	2
325192	1874	15415000	20625	10374	6	0	2
325193	1678	23040757239000	20626	10375	0	0	0
325195	1874	15420000	20626	10375	3	0	2
325196	1874	15423000	20626	10375	4	0	2
325197	1874	15425000	20626	10375	5	0	2
325198	1678	23040757240000	20627	10376	0	0	0
325199	1874	15426000	20627	10376	1	0	2
325201	1003	506881650540000	20627	10376	3	0	0
325202	1874	15431000	20627	10376	4	0	2
325203	1678	23040757241000	20628	10377	0	0	0
325204	1678	23040757242000	20628	10377	1	0	0
325206	1123	908327124870000	20628	10377	3	0	0
325207	1874	15433000	20628	10377	4	0	2
325208	1874	15435000	20628	10377	5	0	2
325209	1874	15437000	20628	10377	6	0	2
325210	1243	612866384820000	20628	10377	7	0	0
325212	1874	15440000	20628	10377	9	0	2
325213	1874	15443000	20628	10377	10	0	2
325214	1874	15444000	20628	10377	11	0	2
325215	1678	23040757244000	20629	10378	0	0	0
325216	1678	23040757245000	20629	10378	1	0	0
325218	1874	15448000	20629	10378	3	0	2
325219	2266	200000000	20629	10378	4	0	0
325220	1874	15451000	20629	10378	5	0	2
325221	1874	15454000	20629	10378	6	0	2
325223	1062	908736865000000	20630	10379	1	0	0
325224	1182	613142150000000	20630	10379	2	0	0
325225	942	507110975000000	20630	10379	3	0	0
325226	1678	23040757246000	20630	10379	4	0	0
325227	1678	23040757247000	20630	10379	5	0	0
325229	1874	15458000	20630	10379	7	0	2
325230	1874	15461000	20630	10379	8	0	2
325231	1874	15464000	20630	10379	10	0	2
325232	1874	15465000	20630	10379	11	0	2
325233	2262	1400000000	20630	10379	12	0	0
325235	149	86795298000341	20631	10380	1	0	5
325236	1281	1712096207751650	20631	10380	2	0	0
325237	1678	23040757248000	20631	10380	3	0	0
325238	1678	23040757249000	20631	10380	4	0	0
325240	1155	614405750000000	20631	10380	6	0	0
325241	915	508154535000000	20631	10380	7	0	0
325242	1874	15468000	20631	10380	8	0	2
325243	1874	15470000	20631	10380	9	0	2
325244	1874	15472000	20631	10380	10	0	2
325257	1061	910619165000000	20633	10381	0	0	0
325258	1181	614412890000000	20633	10381	1	0	0
325259	941	508161275000000	20633	10381	2	0	0
325260	1678	23040757250000	20633	10381	3	0	0
325261	1283	1707425937751650	20633	10381	4	0	0
325263	1157	612729760000000	20633	10381	6	0	0
325264	917	506768385000000	20633	10381	7	0	0
325265	1874	15478000	20633	10381	8	0	2
325266	1874	15479000	20633	10381	9	0	2
325268	1678	23040757251000	20634	10382	0	0	0
325269	1874	15483000	20634	10382	1	0	2
325270	1874	15486000	20634	10382	2	0	2
325274	1678	23040757252000	20636	10383	0	0	0
325275	1874	15488000	20636	10383	1	0	2
325277	1874	15490000	20637	10384	1	0	2
325278	1874	15491000	20637	10384	2	0	2
325279	1874	15494000	20637	10384	3	0	2
325284	1678	23040757254000	20639	10385	0	0	0
325285	1874	15497000	20639	10385	1	0	2
325287	1678	23040757255000	20640	10386	0	0	0
325288	1874	15502000	20640	10386	1	0	2
325289	1874	15504000	20640	10386	2	0	2
325290	1678	23040757256000	20641	10387	0	0	0
325292	1874	15507000	20641	10387	2	0	2
325293	1874	15509000	20641	10387	3	0	2
325294	1874	15511000	20641	10387	4	0	2
325295	1874	15512000	20641	10387	5	0	2
325296	1678	23040757258000	20642	10388	0	0	0
325298	1874	15517000	20642	10388	2	0	2
325305	1678	23040757259000	20645	10389	0	0	0
325306	1874	15520000	20645	10389	1	0	2
325307	1874	15522000	20645	10389	2	0	2
325313	1181	614412890000000	20646	10357	5	0	\N
325314	941	508161275000000	20646	10357	6	0	\N
325315	942	507110975000000	20646	10357	7	0	\N
325316	2040	2016040000000	20646	10357	8	0	\N
325317	1377	1711490787751650	20646	10357	9	0	\N
325318	149	86795298000341	20646	10357	10	0	\N
325319	1281	1712096207751650	20646	10357	12	0	\N
325320	1283	1707425937751650	20646	10357	13	0	\N
325321	1037	908124585000000	20646	10357	14	0	\N
325322	1157	612729760000000	20646	10357	15	0	\N
325323	917	506768385000000	20646	10357	16	0	\N
325324	1678	23040757220000	20646	10357	17	0	\N
325325	1678	23040757221000	20646	10357	18	0	\N
325326	1131	910286595000000	20646	10357	19	0	\N
325327	1251	614188560000000	20646	10357	20	0	\N
325328	1035	910608555000000	20646	10357	21	0	\N
325329	1155	614405750000000	20646	10357	22	0	\N
325330	915	508154535000000	20646	10357	23	0	\N
325331	1011	507974845000000	20646	10357	24	0	\N
325332	1678	23040757222000	20646	10357	25	0	\N
325333	1678	23040757223000	20646	10357	26	0	\N
325334	1678	23040757224000	20646	10357	27	0	\N
325335	1678	23040757225000	20646	10357	28	0	\N
325336	1678	23040757226000	20646	10357	29	0	\N
325337	1678	23040757227000	20646	10357	30	0	\N
325338	1678	23040757228000	20646	10357	31	0	\N
325339	1678	23040757229000	20646	10357	32	0	\N
325340	1678	23040757230000	20646	10357	33	0	\N
325341	1678	23040757231000	20646	10357	34	0	\N
325342	1678	23040757232000	20646	10357	35	0	\N
325343	1678	23040757233000	20646	10357	36	0	\N
325344	1678	23040757234000	20646	10357	37	0	\N
325345	1678	23040757235000	20646	10357	39	0	\N
325346	1678	23040757236000	20646	10357	40	0	\N
325347	1678	23040757237000	20646	10357	41	0	\N
325348	1678	23040757238000	20646	10357	42	0	\N
325349	1678	23040757239000	20646	10357	43	0	\N
325350	1678	23040757240000	20646	10357	44	0	\N
325351	1678	23040757241000	20646	10357	45	0	\N
325352	1678	23040757242000	20646	10357	46	0	\N
325353	1678	23040757243000	20646	10357	47	0	\N
325354	1678	23040757244000	20646	10357	48	0	\N
325355	1678	23040757245000	20646	10357	49	0	\N
325356	1678	23040757246000	20646	10357	50	0	\N
325357	1678	23040757247000	20646	10357	51	0	\N
325358	1678	23040757248000	20646	10357	52	0	\N
325359	1678	23040757249000	20646	10357	53	0	\N
325360	1678	23040757250000	20646	10357	54	0	\N
325361	1678	23040757251000	20646	10357	55	0	\N
325362	1678	23040757252000	20646	10357	56	0	\N
325363	1678	23040757253000	20646	10357	57	0	\N
325364	1678	23040757254000	20646	10357	58	0	\N
325365	1678	23040757255000	20646	10357	59	0	\N
325366	1678	23040757256000	20646	10357	60	0	\N
325367	1678	23040757257000	20646	10357	61	0	\N
325368	1678	23040757258000	20646	10357	62	0	\N
325369	1678	23040757259000	20646	10357	63	0	\N
325370	2260	200000000	20646	10357	64	0	\N
325371	2262	200000000	20646	10357	65	0	\N
325372	2184	4999000000	20646	10357	66	0	\N
325373	1874	15307000	20646	10357	69	0	\N
325374	1003	506881650540000	20646	10357	72	0	\N
325375	1123	908327124870000	20646	10357	73	0	\N
325376	1243	612866384820000	20646	10357	76	0	\N
325377	1369	1707805295351650	20646	10357	77	0	\N
325378	2263	200000000	20646	10357	78	0	\N
325379	2264	200000000	20646	10357	79	0	\N
325380	2265	200000000	20646	10357	80	0	\N
325381	1874	15310000	20646	10357	81	0	\N
325382	1874	15313000	20646	10357	82	0	\N
325383	1874	15316000	20646	10357	83	0	\N
325384	1874	15319000	20646	10357	84	0	\N
325385	1874	15320000	20646	10357	85	0	\N
325386	1874	15322000	20646	10357	86	0	\N
325387	1874	15323000	20646	10357	87	0	\N
325388	1874	15324000	20646	10357	88	0	\N
325389	1874	15325000	20646	10357	89	0	\N
325390	1874	15326000	20646	10357	90	0	\N
325391	1874	15327000	20646	10357	91	0	\N
325392	1874	15328000	20646	10357	92	0	\N
325393	1874	15329000	20646	10357	93	0	\N
325394	2266	200000000	20646	10357	94	0	\N
325395	2262	1400000000	20646	10357	95	0	\N
325396	1874	15330000	20646	10357	96	0	\N
325397	1874	15331000	20646	10357	97	0	\N
325398	1874	15332000	20646	10357	98	0	\N
325399	1874	15333000	20646	10357	99	0	\N
325400	1874	15334000	20646	10357	100	0	\N
325401	1874	15337000	20646	10357	101	0	\N
325402	1874	15340000	20646	10357	102	0	\N
325403	1874	15343000	20646	10357	103	0	\N
325404	1874	15346000	20646	10357	104	0	\N
325405	1874	15349000	20646	10357	105	0	\N
325406	1874	15352000	20646	10357	106	0	\N
325407	1874	15355000	20646	10357	107	0	\N
325408	1874	15358000	20646	10357	108	0	\N
325409	1874	15361000	20646	10357	109	0	\N
325410	1874	15364000	20646	10357	110	0	\N
325411	1874	15367000	20646	10357	111	0	\N
325412	1874	15370000	20646	10357	112	0	\N
325413	1874	15373000	20646	10357	113	0	\N
325414	1874	15376000	20646	10357	114	0	\N
325415	1874	15379000	20646	10357	115	0	\N
325416	1874	15382000	20646	10357	116	0	\N
325417	1874	15385000	20646	10357	117	0	\N
325418	1874	15388000	20646	10357	118	0	\N
325419	1874	15391000	20646	10357	119	0	\N
325420	1874	15394000	20646	10357	120	0	\N
325421	1874	15397000	20646	10357	121	0	\N
325422	1874	15400000	20646	10357	122	0	\N
325427	1678	23040757260000	20649	10390	0	0	\N
325428	1874	15523000	20649	10390	1	0	\N
325429	1874	15525000	20649	10390	2	0	\N
325430	1874	15528000	20649	10390	3	0	\N
325431	1307	1712116157751650	20651	10317	0	0	\N
325432	1308	1708575037751650	20651	10317	1	0	\N
325433	1062	908736865000000	20651	10317	2	0	\N
325434	1182	613142150000000	20651	10317	3	0	\N
325435	1061	910619165000000	20651	10317	4	0	\N
325436	1181	614412890000000	20651	10317	5	0	\N
325437	941	508161275000000	20651	10317	6	0	\N
325438	942	507110975000000	20651	10317	7	0	\N
325439	1319	1708419637751650	20651	10317	8	0	\N
325440	1073	908653465000000	20651	10317	9	0	\N
325441	1193	613086750000000	20651	10317	10	0	\N
325442	953	507063775000000	20651	10317	11	0	\N
325443	2040	2016040000000	20651	10317	12	0	\N
325444	1008	506594957082875	20651	10317	13	0	\N
325445	1678	23040757169000	20651	10317	15	0	\N
325446	2003	2428970654821	20651	10317	16	0	\N
325447	1377	1711490787751650	20651	10317	17	0	\N
325448	149	86075286000341	20651	10317	18	0	\N
325425	1874	15525000	20648	10390	2	0	2
325426	1874	15528000	20648	10390	3	0	2
325449	1281	1712096207751650	20651	10317	19	0	\N
325450	2037	1546000000000	20651	10317	20	0	\N
325451	1128	907813822586899	20651	10317	21	0	\N
325452	1248	612520075567628	20651	10317	22	0	\N
325453	1374	1706841652817754	20651	10317	23	0	\N
325454	1283	1707425937751650	20651	10317	24	0	\N
325455	1037	908124585000000	20651	10317	25	0	\N
325456	1157	612729760000000	20651	10317	26	0	\N
325457	917	506768385000000	20651	10317	27	0	\N
325458	1678	23040757170000	20651	10317	28	0	\N
325459	1678	23040757171000	20651	10317	29	0	\N
325460	1678	23040757172000	20651	10317	30	0	\N
325461	963	506768371327637	20651	10317	31	0	\N
325462	1678	23040757173000	20651	10317	32	0	\N
325463	1678	23040757174000	20651	10317	33	0	\N
325464	13	4694444607287	20651	10317	34	0	\N
325465	19	2347726974088	20651	10317	35	0	\N
325466	203	66616500555940	20651	10317	36	0	\N
325467	241	66616500555940	20651	10317	37	0	\N
325468	313	66616500555940	20651	10317	38	0	\N
325469	1678	23040757175000	20651	10317	39	0	\N
325470	1131	910286595000000	20651	10317	40	0	\N
325471	1251	614188560000000	20651	10317	41	0	\N
325472	462	66347494240603	20651	10317	42	0	\N
325473	754	1005265064217	20651	10317	43	0	\N
325474	935	508064846578276	20651	10317	44	0	\N
325475	1055	910447851968622	20651	10317	45	0	\N
325476	1373	1707191380766396	20651	10317	46	0	\N
325477	1127	907999854007842	20651	10317	47	0	\N
325478	1247	612645625005290	20651	10317	48	0	\N
325479	1007	506698773004376	20651	10317	49	0	\N
325480	1083	908124579427713	20651	10317	50	0	\N
325481	1203	612729749400383	20651	10317	51	0	\N
325482	1329	1707425927595874	20651	10317	52	0	\N
325483	1035	910608555000000	20651	10317	53	0	\N
325484	1155	614405750000000	20651	10317	54	0	\N
325485	915	508154535000000	20651	10317	55	0	\N
325486	1011	507974845000000	20651	10317	56	0	\N
325487	1678	23040757176000	20651	10317	57	0	\N
325488	1678	23040757177000	20651	10317	58	0	\N
325489	1678	23040757178000	20651	10317	59	0	\N
325490	1678	23040757179000	20651	10317	60	0	\N
325491	1678	23040757180000	20651	10317	61	0	\N
325492	1678	23040757181000	20651	10317	62	0	\N
325493	1678	23040757182000	20651	10317	63	0	\N
325494	1678	23040757183000	20651	10317	64	0	\N
325495	1678	23040757184000	20651	10317	65	0	\N
325496	1678	23040757185000	20651	10317	66	0	\N
325497	1678	23040757186000	20651	10317	67	0	\N
325498	1678	23040757187000	20651	10317	68	0	\N
325499	1678	23040757188000	20651	10317	69	0	\N
325500	1678	23040757189000	20651	10317	70	0	\N
325501	1678	23040757190000	20651	10317	71	0	\N
325502	1678	23040757191000	20651	10317	72	0	\N
325503	1678	23040757192000	20651	10317	73	0	\N
325504	1678	23040757193000	20651	10317	75	0	\N
325505	1678	23040757194000	20651	10317	76	0	\N
325506	1678	23040757195000	20651	10317	77	0	\N
325507	1678	23040757196000	20651	10317	78	0	\N
325508	1678	23040757197000	20651	10317	79	0	\N
325509	1678	23040757198000	20651	10317	80	0	\N
325510	1678	23040757199000	20651	10317	81	0	\N
325511	1678	23040757200000	20651	10317	82	0	\N
325512	1678	23040757201000	20651	10317	83	0	\N
325513	1678	23040757202000	20651	10317	84	0	\N
325514	1678	23040757203000	20651	10317	85	0	\N
325515	1678	23040757204000	20651	10317	86	0	\N
325516	1678	23040757205000	20651	10317	87	0	\N
325517	1678	23040757206000	20651	10317	88	0	\N
325518	965	507350663452652	20651	10317	89	0	\N
325519	1085	909168041926640	20651	10317	90	0	\N
325520	1205	613433794340872	20651	10317	91	0	\N
325521	1331	1709387811422786	20651	10317	92	0	\N
325522	1175	614297307678252	20651	10317	93	0	\N
325523	1301	1711794068116628	20651	10317	94	0	\N
325524	1678	23040757207000	20651	10317	95	0	\N
325525	1678	23040757208000	20651	10317	96	0	\N
325526	1678	23040757209000	20651	10317	97	0	\N
325527	1678	23040757210000	20651	10317	98	0	\N
325528	1678	23040757211000	20651	10317	99	0	\N
325529	1678	23040757212000	20651	10317	100	0	\N
325530	1678	23040757213000	20651	10317	101	0	\N
325531	1678	23040757214000	20651	10317	102	0	\N
325532	1678	23040757215000	20651	10317	103	0	\N
325533	1678	23040757216000	20651	10317	104	0	\N
325534	1678	23040757217000	20651	10317	105	0	\N
325535	1678	23040757218000	20651	10317	106	0	\N
325536	1678	23040757219000	20651	10317	107	0	\N
325537	1678	23040757220000	20651	10317	108	0	\N
325538	1678	23040757221000	20651	10317	109	0	\N
325539	1678	23040757222000	20651	10317	110	0	\N
325540	1678	23040757223000	20651	10317	111	0	\N
325541	1678	23040757224000	20651	10317	112	0	\N
325542	1678	23040757225000	20651	10317	113	0	\N
325543	1678	23040757226000	20651	10317	114	0	\N
325544	1678	23040757227000	20651	10317	115	0	\N
325545	1678	23040757228000	20651	10317	116	0	\N
325546	1678	23040757229000	20651	10317	117	0	\N
325547	1678	23040757230000	20651	10317	118	0	\N
325548	1678	23040757231000	20651	10317	119	0	\N
325549	1678	23040757232000	20651	10317	120	0	\N
325550	1678	23040757233000	20651	10317	121	0	\N
325551	1678	23040757234000	20651	10317	122	0	\N
325552	1678	23040757235000	20651	10317	123	0	\N
325553	1678	23040757236000	20651	10317	124	0	\N
325554	1678	23040757237000	20651	10317	125	0	\N
325561	1678	23040757262000	20655	10392	0	0	\N
325562	1874	15536000	20655	10392	1	0	\N
325563	1874	15538000	20655	10392	2	0	\N
325564	1678	23040757263000	20656	10393	0	0	\N
325565	1874	15541000	20656	10393	1	0	\N
325566	1874	15543000	20656	10393	2	0	\N
325567	1874	15544000	20656	10393	3	0	\N
325568	1678	23040757263000	20657	10393	0	0	\N
325569	1874	15541000	20657	10393	1	0	\N
325570	1874	15543000	20657	10393	2	0	\N
325571	1874	15544000	20657	10393	3	0	\N
325572	1678	23040757263000	20658	10393	0	0	\N
325573	1874	15541000	20658	10393	1	0	\N
325574	1874	15543000	20658	10393	2	0	\N
325575	1874	15544000	20658	10393	3	0	\N
325580	1678	23040757264000	20660	10394	0	0	\N
325581	1874	15547000	20660	10394	1	0	\N
325582	1874	15549000	20660	10394	2	0	\N
325557	1874	15533000	20653	10391	2	0	2
325558	1678	23040757262000	20654	10392	0	0	0
325559	1874	15536000	20654	10392	1	0	2
325560	1874	15538000	20654	10392	2	0	2
325576	1678	23040757263000	20659	10393	0	0	0
325578	1874	15543000	20659	10393	2	0	2
325579	1874	15544000	20659	10393	3	0	2
325583	1678	23040757264000	20661	10394	0	0	0
325584	1874	15547000	20661	10394	1	0	2
325586	1874	15546000	20662	10394	0	0	\N
325587	1678	23040757265000	20663	10395	0	0	\N
325588	1874	15551000	20663	10395	1	0	\N
325591	1678	23040757266000	20665	10396	0	0	\N
325592	1678	23040757267000	20665	10396	1	0	\N
325593	1678	23040757268000	20665	10396	2	0	\N
325594	1678	23040757269000	20665	10396	3	0	\N
325595	1874	15553000	20665	10396	4	0	\N
325596	1874	15555000	20665	10396	5	0	\N
325597	1874	15557000	20665	10396	6	0	\N
325598	1874	15558000	20665	10396	7	0	\N
325599	1874	15560000	20665	10396	8	0	\N
325600	1874	15563000	20665	10396	9	0	\N
325601	1874	15566000	20665	10396	10	0	\N
325602	1874	15569000	20665	10396	11	0	\N
325603	1874	15572000	20665	10396	12	0	\N
325617	1678	23040757266000	20667	10396	0	0	\N
325618	1678	23040757267000	20667	10396	1	0	\N
325619	1678	23040757268000	20667	10396	2	0	\N
325620	1678	23040757269000	20667	10396	3	0	\N
325621	1874	15553000	20667	10396	4	0	\N
325622	1874	15555000	20667	10396	5	0	\N
325623	1874	15557000	20667	10396	6	0	\N
325624	1874	15558000	20667	10396	7	0	\N
325625	1874	15560000	20667	10396	8	0	\N
325626	1874	15563000	20667	10396	9	0	\N
325627	1874	15566000	20667	10396	10	0	\N
325628	1874	15569000	20667	10396	11	0	\N
325629	1874	15572000	20667	10396	12	0	\N
325633	1678	23040757270000	20669	10397	0	0	\N
325634	1874	15574000	20669	10397	1	0	\N
325635	1874	15575000	20669	10397	2	0	\N
325639	1678	23040757271000	20671	10398	0	0	\N
325640	1874	15578000	20671	10398	2	0	\N
325641	1874	15580000	20671	10398	3	0	\N
325642	1678	23040757272000	20672	10399	0	0	\N
325643	1874	15582000	20672	10399	1	0	\N
325644	1874	15585000	20672	10399	2	0	\N
325648	1678	23040757273000	20674	10400	0	0	\N
325649	1678	23040757274000	20674	10400	1	0	\N
325650	1678	23040757275000	20674	10400	2	0	\N
325651	1874	15587000	20674	10400	3	0	\N
325652	1874	15589000	20674	10400	4	0	\N
325653	1874	15590000	20674	10400	5	0	\N
325654	1874	15593000	20674	10400	6	0	\N
325655	1874	15596000	20674	10400	7	0	\N
325656	1874	15599000	20674	10400	8	0	\N
325666	1678	23040757273000	20676	10400	0	0	\N
325667	1678	23040757274000	20676	10400	1	0	\N
325668	1678	23040757275000	20676	10400	2	0	\N
325669	1874	15587000	20676	10400	3	0	\N
325670	1874	15589000	20676	10400	4	0	\N
325671	1874	15590000	20676	10400	5	0	\N
325672	1874	15593000	20676	10400	6	0	\N
325673	1874	15596000	20676	10400	7	0	\N
325674	1874	15599000	20676	10400	8	0	\N
325675	1678	23040757273000	20677	10400	0	0	\N
325676	1678	23040757274000	20677	10400	1	0	\N
325677	1678	23040757275000	20677	10400	2	0	\N
325678	1874	15587000	20677	10400	3	0	\N
325679	1874	15589000	20677	10400	4	0	\N
325680	1874	15590000	20677	10400	5	0	\N
325681	1874	15593000	20677	10400	6	0	\N
325682	1874	15596000	20677	10400	7	0	\N
325683	1874	15599000	20677	10400	8	0	\N
325684	1678	23040757276000	20678	10401	0	0	\N
325685	1874	15602000	20678	10401	1	0	\N
325686	1874	15604000	20678	10401	2	0	\N
325690	1678	23040757266000	20680	10396	0	0	\N
325691	1678	23040757267000	20680	10396	1	0	\N
325692	1678	23040757268000	20680	10396	2	0	\N
325693	1678	23040757269000	20680	10396	3	0	\N
325694	1678	23040757270000	20680	10396	4	0	\N
325695	1678	23040757271000	20680	10396	5	0	\N
325696	1678	23040757272000	20680	10396	6	0	\N
325697	1678	23040757273000	20680	10396	7	0	\N
325698	1678	23040757274000	20680	10396	8	0	\N
325699	1678	23040757275000	20680	10396	9	0	\N
325700	1874	15553000	20680	10396	10	0	\N
325701	1874	15555000	20680	10396	11	0	\N
325702	1874	15557000	20680	10396	12	0	\N
325703	1874	15558000	20680	10396	13	0	\N
325704	1874	15559000	20680	10396	14	0	\N
325705	1874	15560000	20680	10396	15	0	\N
325706	1874	15562000	20680	10396	16	0	\N
325707	1874	15564000	20680	10396	17	0	\N
325708	1874	15566000	20680	10396	18	0	\N
325709	1874	15568000	20680	10396	19	0	\N
325710	1874	15570000	20680	10396	20	0	\N
325711	1874	15572000	20680	10396	22	0	\N
325712	1874	15574000	20680	10396	23	0	\N
325713	1874	15577000	20680	10396	24	0	\N
325714	1874	15580000	20680	10396	25	0	\N
325715	1874	15583000	20680	10396	26	0	\N
325716	1874	15586000	20680	10396	27	0	\N
325717	1874	15589000	20680	10396	28	0	\N
325718	1874	15592000	20680	10396	29	0	\N
325719	1874	15595000	20680	10396	30	0	\N
325720	1874	15598000	20680	10396	31	0	\N
325590	1874	15551000	20664	10395	1	0	2
325604	1678	23040757266000	20666	10396	0	0	0
325605	1678	23040757267000	20666	10396	1	0	0
325606	1678	23040757268000	20666	10396	2	0	0
325607	1678	23040757269000	20666	10396	3	0	0
325609	1874	15555000	20666	10396	5	0	2
325610	1874	15557000	20666	10396	6	0	2
325611	1874	15558000	20666	10396	7	0	2
325612	1874	15560000	20666	10396	8	0	2
325613	1874	15563000	20666	10396	9	0	2
325615	1874	15569000	20666	10396	11	0	2
325616	1874	15572000	20666	10396	12	0	2
325630	1678	23040757270000	20668	10397	0	0	0
325631	1874	15574000	20668	10397	1	0	2
325636	1678	23040757271000	20670	10398	0	0	0
325637	1874	15578000	20670	10398	2	0	2
325638	1874	15580000	20670	10398	3	0	2
325645	1678	23040757272000	20673	10399	0	0	0
325646	1874	15582000	20673	10399	1	0	2
325657	1678	23040757273000	20675	10400	0	0	0
325658	1678	23040757274000	20675	10400	1	0	0
325659	1678	23040757275000	20675	10400	2	0	0
325660	1874	15587000	20675	10400	3	0	2
325661	1874	15589000	20675	10400	4	0	2
325663	1874	15593000	20675	10400	6	0	2
325664	1874	15596000	20675	10400	7	0	2
325665	1874	15599000	20675	10400	8	0	2
325687	1678	23040757276000	20679	10401	0	0	0
325689	1874	15604000	20679	10401	2	0	2
325721	1874	15601000	20680	10396	32	0	\N
325725	1678	23040757277000	20682	10402	0	0	\N
325726	1874	15605000	20682	10402	1	0	\N
325727	1874	15607000	20682	10402	2	0	\N
325728	1307	1712116157751650	20683	10360	0	0	\N
325729	1308	1708575037751650	20683	10360	1	0	\N
325730	1062	908736865000000	20683	10360	2	0	\N
325731	1182	613142150000000	20683	10360	3	0	\N
325732	1061	910619165000000	20683	10360	4	0	\N
325733	1181	614412890000000	20683	10360	5	0	\N
325734	941	508161275000000	20683	10360	6	0	\N
325735	942	507110975000000	20683	10360	7	0	\N
325736	149	86795298000341	20683	10360	8	0	\N
325737	1281	1712096207751650	20683	10360	9	0	\N
325738	1283	1707425937751650	20683	10360	10	0	\N
325739	1037	908124585000000	20683	10360	11	0	\N
325740	1157	612729760000000	20683	10360	12	0	\N
325741	917	506768385000000	20683	10360	13	0	\N
325742	1678	23040757239000	20683	10360	14	0	\N
325743	1678	23040757240000	20683	10360	15	0	\N
325744	1678	23040757241000	20683	10360	16	0	\N
325745	1678	23040757242000	20683	10360	17	0	\N
325746	1035	910608555000000	20683	10360	18	0	\N
325747	1155	614405750000000	20683	10360	19	0	\N
325748	915	508154535000000	20683	10360	20	0	\N
325749	1678	23040757243000	20683	10360	21	0	\N
325750	1678	23040757244000	20683	10360	22	0	\N
325751	1678	23040757245000	20683	10360	23	0	\N
325752	1678	23040757246000	20683	10360	24	0	\N
325753	1678	23040757247000	20683	10360	25	0	\N
325754	1678	23040757248000	20683	10360	26	0	\N
325755	1678	23040757249000	20683	10360	27	0	\N
325756	1678	23040757250000	20683	10360	28	0	\N
325757	1678	23040757251000	20683	10360	29	0	\N
325758	1678	23040757252000	20683	10360	30	0	\N
325759	1678	23040757253000	20683	10360	31	0	\N
325760	1678	23040757254000	20683	10360	32	0	\N
325761	1678	23040757255000	20683	10360	33	0	\N
325762	1678	23040757256000	20683	10360	34	0	\N
325763	1678	23040757257000	20683	10360	35	0	\N
325764	1678	23040757258000	20683	10360	36	0	\N
325765	1678	23040757259000	20683	10360	37	0	\N
325766	1678	23040757260000	20683	10360	38	0	\N
325767	1678	23040757261000	20683	10360	39	0	\N
325768	1678	23040757262000	20683	10360	40	0	\N
325769	1678	23040757263000	20683	10360	41	0	\N
325770	1678	23040757264000	20683	10360	42	0	\N
325771	1678	23040757265000	20683	10360	43	0	\N
325772	1678	23040757266000	20683	10360	44	0	\N
325773	1678	23040757267000	20683	10360	45	0	\N
325774	1678	23040757268000	20683	10360	46	0	\N
325775	1678	23040757269000	20683	10360	47	0	\N
325776	1678	23040757270000	20683	10360	48	0	\N
325777	1678	23040757271000	20683	10360	49	0	\N
325778	1678	23040757272000	20683	10360	50	0	\N
325779	1678	23040757273000	20683	10360	51	0	\N
325780	1678	23040757274000	20683	10360	52	0	\N
325781	1678	23040757275000	20683	10360	53	0	\N
325782	1874	15416000	20683	10360	54	0	\N
325783	1003	506881650540000	20683	10360	56	0	\N
325784	1123	908327124870000	20683	10360	57	0	\N
325785	1874	15418000	20683	10360	58	0	\N
325786	1243	612866384820000	20683	10360	59	0	\N
325787	1369	1707805295351650	20683	10360	60	0	\N
325788	1874	15421000	20683	10360	61	0	\N
325789	1874	15424000	20683	10360	62	0	\N
325790	1874	15427000	20683	10360	63	0	\N
325791	1874	15429000	20683	10360	64	0	\N
325792	1874	15431000	20683	10360	65	0	\N
325793	1874	15433000	20683	10360	66	0	\N
325794	1874	15435000	20683	10360	67	0	\N
325795	1874	15437000	20683	10360	68	0	\N
325796	1874	15439000	20683	10360	69	0	\N
325797	1874	15441000	20683	10360	70	0	\N
325798	1874	15443000	20683	10360	71	0	\N
325799	1874	15445000	20683	10360	72	0	\N
325800	1874	15447000	20683	10360	74	0	\N
325801	1874	15449000	20683	10360	75	0	\N
325802	1874	15451000	20683	10360	76	0	\N
325803	1874	15453000	20683	10360	77	0	\N
325804	1874	15455000	20683	10360	78	0	\N
325805	1874	15457000	20683	10360	79	0	\N
325806	1874	15459000	20683	10360	80	0	\N
325807	1874	15461000	20683	10360	81	0	\N
325808	1874	15463000	20683	10360	82	0	\N
325809	1874	15465000	20683	10360	83	0	\N
325810	1874	15467000	20683	10360	84	0	\N
325811	1874	15469000	20683	10360	85	0	\N
325812	1874	15471000	20683	10360	86	0	\N
325813	1874	15473000	20683	10360	87	0	\N
325814	1874	15475000	20683	10360	88	0	\N
325815	1874	15477000	20683	10360	89	0	\N
325816	1874	15479000	20683	10360	90	0	\N
325817	1874	15481000	20683	10360	91	0	\N
325818	1874	15483000	20683	10360	92	0	\N
325819	1874	15485000	20683	10360	93	0	\N
325820	1874	15487000	20683	10360	94	0	\N
325821	1874	15490000	20683	10360	95	0	\N
325822	1874	15493000	20683	10360	96	0	\N
325823	1874	15495000	20683	10360	97	0	\N
325824	1874	15497000	20683	10360	98	0	\N
325825	1874	15499000	20683	10360	99	0	\N
325826	1874	15501000	20683	10360	100	0	\N
325827	1874	15503000	20683	10360	101	0	\N
325828	1874	15505000	20683	10360	102	0	\N
325829	1874	15507000	20683	10360	103	0	\N
325830	2266	200000000	20683	10360	104	0	\N
325831	2262	1400000000	20683	10360	105	0	\N
325832	1874	15510000	20683	10360	106	0	\N
325833	1874	15513000	20683	10360	107	0	\N
325834	1874	15516000	20683	10360	108	0	\N
325835	1874	15519000	20683	10360	109	0	\N
325836	1874	15522000	20683	10360	110	0	\N
325837	1874	15525000	20683	10360	111	0	\N
325838	1874	15528000	20683	10360	112	0	\N
325839	1874	15531000	20683	10360	113	0	\N
325840	1874	15534000	20683	10360	114	0	\N
325841	1874	15537000	20683	10360	115	0	\N
325842	1874	15540000	20683	10360	116	0	\N
325843	1874	15543000	20683	10360	117	0	\N
325844	1874	15546000	20683	10360	118	0	\N
325845	1874	15549000	20683	10360	119	0	\N
325846	1874	15552000	20683	10360	120	0	\N
325847	1874	15555000	20683	10360	121	0	\N
325848	1874	15558000	20683	10360	122	0	\N
325849	1874	15561000	20683	10360	123	0	\N
325850	1874	15564000	20683	10360	124	0	\N
325851	1874	15567000	20683	10360	125	0	\N
325852	1678	23040757278000	20684	10403	0	0	\N
325853	1874	15610000	20684	10403	1	0	\N
325854	1874	15612000	20684	10403	2	0	\N
325724	1874	15607000	20681	10402	2	0	2
325855	1678	23040757278000	20685	10403	0	0	0
325856	1874	15610000	20685	10403	1	0	2
325861	1678	23040757279000	20687	10404	0	0	\N
325862	1874	15614000	20687	10404	1	0	\N
325863	1874	15617000	20687	10404	2	0	\N
325871	1678	23040757282000	20690	10407	0	0	\N
325872	1874	15631000	20690	10407	1	0	\N
325873	1678	23040757282000	20691	10407	0	0	\N
325874	1874	15631000	20691	10407	1	0	\N
325875	1874	15633000	20691	10407	2	0	\N
325887	1343	1712413637751650	20694	10408	0	0	\N
325888	1678	23040757283000	20694	10408	1	0	\N
325889	1678	23040757284000	20694	10408	2	0	\N
325890	1874	15636000	20694	10408	3	0	\N
325891	1874	15639000	20694	10408	4	0	\N
325892	1874	15640000	20694	10408	5	0	\N
325893	1874	15642000	20694	10408	6	0	\N
325894	1874	15644000	20694	10408	7	0	\N
325895	1343	1712413637751650	20695	10325	0	0	\N
325896	1097	910778465000000	20695	10325	1	0	\N
325897	1217	614520750000000	20695	10325	2	0	\N
325898	977	508248775000000	20695	10325	3	0	\N
325899	1307	1712116157751650	20695	10325	4	0	\N
325900	1308	1708575037751650	20695	10325	5	0	\N
325901	1062	908736865000000	20695	10325	6	0	\N
325902	1182	613142150000000	20695	10325	7	0	\N
325903	1061	910619165000000	20695	10325	8	0	\N
325904	1181	614412890000000	20695	10325	9	0	\N
325905	941	508161275000000	20695	10325	10	0	\N
325906	942	507110975000000	20695	10325	11	0	\N
325907	1319	1708419637751650	20695	10325	12	0	\N
325908	1073	908653465000000	20695	10325	13	0	\N
325909	1193	613086750000000	20695	10325	14	0	\N
325910	953	507063775000000	20695	10325	15	0	\N
325911	2040	2016040000000	20695	10325	16	0	\N
325912	1008	506594957082875	20695	10325	17	0	\N
325913	2003	2428970654821	20695	10325	19	0	\N
325914	1377	1711490787751650	20695	10325	20	0	\N
325915	149	86075286000341	20695	10325	21	0	\N
325916	1281	1712096207751650	20695	10325	22	0	\N
325917	2037	1546000000000	20695	10325	23	0	\N
325918	1128	907813822586899	20695	10325	24	0	\N
325919	1248	612520075567628	20695	10325	25	0	\N
325920	1374	1706841652817754	20695	10325	26	0	\N
325921	1283	1707425937751650	20695	10325	28	0	\N
325928	1097	910778465000000	20697	10409	0	0	\N
325929	1217	614520750000000	20697	10409	1	0	\N
325930	977	508248775000000	20697	10409	2	0	\N
325931	1678	23040757285000	20697	10409	3	0	\N
325932	2267	200000000	20697	10409	4	0	\N
325933	1874	15646000	20697	10409	5	0	\N
325936	1678	23040757286000	20699	10411	0	0	\N
325937	1678	23040757287000	20699	10411	1	0	\N
325938	1678	23040757288000	20699	10411	2	0	\N
325939	1874	15652000	20699	10411	3	0	\N
325940	1874	15655000	20699	10411	4	0	\N
325941	1874	15658000	20699	10411	5	0	\N
325942	1874	15660000	20699	10411	6	0	\N
325943	1874	15662000	20699	10411	7	0	\N
325952	1678	23040757286000	20701	10411	0	0	\N
325953	1678	23040757287000	20701	10411	1	0	\N
325954	1678	23040757288000	20701	10411	2	0	\N
325955	1874	15652000	20701	10411	3	0	\N
325956	1874	15655000	20701	10411	4	0	\N
325957	1874	15658000	20701	10411	5	0	\N
325958	1874	15660000	20701	10411	6	0	\N
325959	1874	15662000	20701	10411	7	0	\N
325960	1678	23040757286000	20702	10411	0	0	\N
325961	1678	23040757287000	20702	10411	1	0	\N
325962	1678	23040757288000	20702	10411	2	0	\N
325963	1874	15652000	20702	10411	3	0	\N
325964	1874	15655000	20702	10411	4	0	\N
325965	1874	15658000	20702	10411	5	0	\N
325966	1874	15660000	20702	10411	6	0	\N
325967	1874	15662000	20702	10411	7	0	\N
325968	1678	23040757289000	20703	10412	0	0	\N
325969	1874	15664000	20703	10412	1	0	\N
325970	1874	15667000	20703	10412	2	0	\N
325984	1678	23040757292000	20707	10414	0	0	\N
325985	1874	15680000	20707	10414	1	0	\N
325986	1678	23040757293000	20710	10415	0	0	\N
325987	1874	15682000	20710	10415	1	0	\N
325988	1874	15683000	20710	10415	2	0	\N
325989	1874	15686000	20710	10415	3	0	\N
325859	1874	15614000	20686	10404	1	0	2
325860	1874	15617000	20686	10404	2	0	2
325864	1678	23040757280000	20688	10405	0	0	0
325865	1874	15620000	20688	10405	1	0	2
325866	1874	15621000	20688	10405	2	0	2
325868	1678	23040757281000	20689	10406	0	0	0
325869	1874	15625000	20689	10406	1	0	2
325870	1874	15628000	20689	10406	2	0	2
325876	1678	23040757282000	20692	10407	0	0	0
325877	1874	15631000	20692	10407	1	0	2
325879	1343	1712413637751650	20693	10408	0	0	0
325880	1678	23040757283000	20693	10408	1	0	0
325881	1678	23040757284000	20693	10408	2	0	0
325882	1874	15636000	20693	10408	3	0	2
325884	1874	15640000	20693	10408	5	0	2
325885	1874	15642000	20693	10408	6	0	2
325886	1874	15644000	20693	10408	7	0	2
325922	1097	910778465000000	20696	10409	0	0	0
325923	1217	614520750000000	20696	10409	1	0	0
325925	1678	23040757285000	20696	10409	3	0	0
325926	2267	200000000	20696	10409	4	0	0
325927	1874	15646000	20696	10409	5	0	2
325934	1874	15649000	20698	10410	0	0	2
325935	1874	15651000	20698	10410	1	0	2
325945	1678	23040757287000	20700	10411	1	0	0
325946	1678	23040757288000	20700	10411	2	0	0
325947	1874	15652000	20700	10411	3	0	2
325948	1874	15655000	20700	10411	4	0	2
325950	1874	15660000	20700	10411	6	0	2
325951	1874	15662000	20700	10411	7	0	2
325971	1678	23040757289000	20704	10412	0	0	0
325972	1874	15664000	20704	10412	1	0	2
325973	1874	15667000	20704	10412	2	0	2
325975	1678	23040757291000	20705	10413	1	0	0
325976	1469	90000000	20705	10413	2	0	0
325977	1874	15670000	20705	10413	3	0	2
325978	1874	15673000	20705	10413	4	0	2
325979	1874	15674000	20705	10413	5	0	2
325981	1874	15678000	20705	10413	7	0	2
325982	1678	23040757292000	20706	10414	0	0	0
325983	1874	15680000	20706	10414	1	0	2
325990	1678	23040757293000	20711	10415	0	0	0
325992	1874	15683000	20711	10415	2	0	2
325994	1678	23040757293000	20712	10415	0	0	\N
325995	1874	15682000	20712	10415	1	0	\N
325996	1874	15683000	20712	10415	2	0	\N
325997	1874	15686000	20712	10415	3	0	\N
325998	1678	23040757294000	20713	10416	0	0	\N
325999	1874	15689000	20713	10416	1	0	\N
326000	1874	15691000	20713	10416	2	0	\N
326001	1678	23040757294000	20714	10416	0	0	\N
326002	1874	15689000	20714	10416	1	0	\N
326003	1874	15691000	20714	10416	2	0	\N
326007	1343	1712413637751650	20716	10188	0	0	\N
326008	1097	910778465000000	20716	10188	1	0	\N
326009	1217	614520750000000	20716	10188	2	0	\N
326010	977	508248775000000	20716	10188	3	0	\N
326011	1307	1712116157751650	20716	10188	4	0	\N
326012	1308	1708575037751650	20716	10188	5	0	\N
326013	1062	908736865000000	20716	10188	6	0	\N
326014	1182	613142150000000	20716	10188	7	0	\N
326015	1061	910619165000000	20716	10188	8	0	\N
326016	1181	614412890000000	20716	10188	9	0	\N
326017	941	508161275000000	20716	10188	10	0	\N
326018	942	507110975000000	20716	10188	11	0	\N
326019	2040	2016040000000	20716	10188	12	0	\N
326020	1008	506594957082875	20716	10188	13	0	\N
326021	2003	2428970654821	20716	10188	15	0	\N
326022	1377	1711490787751650	20716	10188	16	0	\N
326023	149	85355271000341	20716	10188	17	0	\N
326024	1281	1712096207751650	20716	10188	18	0	\N
326025	2037	1546000000000	20716	10188	19	0	\N
326026	1128	907813822586899	20716	10188	20	0	\N
326027	1248	612520075567628	20716	10188	21	0	\N
326028	1374	1706841652817754	20716	10188	22	0	\N
326029	1283	1707425937751650	20716	10188	23	0	\N
326030	1037	908124585000000	20716	10188	24	0	\N
326031	1157	612729760000000	20716	10188	25	0	\N
326032	917	506768385000000	20716	10188	26	0	\N
326033	13	4694444607287	20716	10188	27	0	\N
326034	19	2347726974088	20716	10188	28	0	\N
326035	203	66616500555940	20716	10188	29	0	\N
326036	241	66616500555940	20716	10188	30	0	\N
326037	313	66616500555940	20716	10188	31	0	\N
326038	1131	910286595000000	20716	10188	32	0	\N
326039	1251	614188560000000	20716	10188	33	0	\N
326040	1373	1707191380766396	20716	10188	34	0	\N
326041	1127	907999854007842	20716	10188	35	0	\N
326042	1247	612645625005290	20716	10188	36	0	\N
326043	1007	506698773004376	20716	10188	37	0	\N
326044	1083	908124579427713	20716	10188	38	0	\N
326045	1203	612729749400383	20716	10188	39	0	\N
326046	1329	1707425927595874	20716	10188	40	0	\N
326047	1035	910608555000000	20716	10188	41	0	\N
326048	1155	614405750000000	20716	10188	42	0	\N
326049	915	508154535000000	20716	10188	43	0	\N
326050	1678	23040757124000	20716	10188	44	0	\N
326051	1678	23040757125000	20716	10188	45	0	\N
326052	1678	23040757126000	20716	10188	46	0	\N
326053	1678	23040757127000	20716	10188	47	0	\N
326054	1678	23040757128000	20716	10188	48	0	\N
326055	1678	23040757129000	20716	10188	49	0	\N
326056	1678	23040757130000	20716	10188	50	0	\N
326057	1678	23040757131000	20716	10188	51	0	\N
326058	965	507350663452652	20716	10188	52	0	\N
326059	1085	909168041926640	20716	10188	53	0	\N
326060	1205	613433794340872	20716	10188	54	0	\N
326061	1331	1709387811422786	20716	10188	55	0	\N
326062	1678	23040757132000	20716	10188	56	0	\N
326063	1678	23040757133000	20716	10188	57	0	\N
326064	1678	23040757134000	20716	10188	58	0	\N
326065	1678	23040757135000	20716	10188	59	0	\N
326066	1678	23040757136000	20716	10188	60	0	\N
326067	1678	23040757137000	20716	10188	61	0	\N
326068	1678	23040757138000	20716	10188	62	0	\N
326069	1678	23040757139000	20716	10188	63	0	\N
326070	1678	23040757140000	20716	10188	64	0	\N
326071	1678	23040757141000	20716	10188	65	0	\N
326072	1678	23040757142000	20716	10188	68	0	\N
326073	1678	23040757143000	20716	10188	69	0	\N
326074	1678	23040757144000	20716	10188	70	0	\N
326075	1678	23040757145000	20716	10188	71	0	\N
326076	1678	23040757146000	20716	10188	72	0	\N
326077	1678	23040757147000	20716	10188	73	0	\N
326078	1678	23040757148000	20716	10188	74	0	\N
326079	1678	23040757149000	20716	10188	75	0	\N
326080	1678	23040757150000	20716	10188	76	0	\N
326081	1678	23040757151000	20716	10188	77	0	\N
326082	1678	23040757152000	20716	10188	78	0	\N
326083	1678	23040757295000	20717	10417	0	0	\N
326084	1874	15694000	20717	10417	1	0	\N
326085	1874	15696000	20717	10417	2	0	\N
326091	1343	1712413637751650	20721	10382	0	0	\N
326092	1097	910778465000000	20721	10382	1	0	\N
326093	1217	614520750000000	20721	10382	2	0	\N
326094	977	508248775000000	20721	10382	3	0	\N
326095	1678	23040757251000	20721	10382	4	0	\N
326096	1678	23040757252000	20721	10382	5	0	\N
326097	1678	23040757253000	20721	10382	6	0	\N
326098	1678	23040757254000	20721	10382	7	0	\N
326099	1678	23040757255000	20721	10382	8	0	\N
326100	1678	23040757256000	20721	10382	9	0	\N
326101	1678	23040757257000	20721	10382	10	0	\N
326102	1678	23040757258000	20721	10382	11	0	\N
326103	1678	23040757259000	20721	10382	12	0	\N
326104	1678	23040757260000	20721	10382	13	0	\N
326105	1678	23040757261000	20721	10382	14	0	\N
326106	1678	23040757262000	20721	10382	15	0	\N
326107	1678	23040757263000	20721	10382	16	0	\N
326108	1678	23040757264000	20721	10382	17	0	\N
326109	1678	23040757265000	20721	10382	18	0	\N
326110	1678	23040757266000	20721	10382	19	0	\N
326111	1678	23040757267000	20721	10382	20	0	\N
326112	1678	23040757268000	20721	10382	21	0	\N
326113	1678	23040757269000	20721	10382	22	0	\N
326114	1678	23040757270000	20721	10382	23	0	\N
326115	1678	23040757271000	20721	10382	24	0	\N
326116	1678	23040757272000	20721	10382	25	0	\N
326117	1678	23040757273000	20721	10382	26	0	\N
326118	1678	23040757274000	20721	10382	27	0	\N
326119	1678	23040757275000	20721	10382	28	0	\N
326120	1678	23040757276000	20721	10382	29	0	\N
326121	1678	23040757277000	20721	10382	30	0	\N
326122	1678	23040757278000	20721	10382	31	0	\N
326123	1678	23040757279000	20721	10382	32	0	\N
326124	1678	23040757280000	20721	10382	33	0	\N
326125	1678	23040757281000	20721	10382	34	0	\N
326126	1678	23040757282000	20721	10382	35	0	\N
326127	1678	23040757283000	20721	10382	36	0	\N
326128	1678	23040757284000	20721	10382	37	0	\N
326005	1874	15689000	20715	10416	1	0	2
326006	1874	15691000	20715	10416	2	0	2
326086	1678	23040757295000	20718	10417	0	0	0
326087	1874	15694000	20718	10417	1	0	2
326088	1874	15696000	20718	10417	2	0	2
326090	1874	15698000	20720	10418	1	0	2
326129	1678	23040757285000	20721	10382	38	0	\N
326130	1678	23040757286000	20721	10382	39	0	\N
326131	1678	23040757287000	20721	10382	40	0	\N
326132	1678	23040757288000	20721	10382	41	0	\N
326133	1678	23040757289000	20721	10382	42	0	\N
326134	1678	23040757290000	20721	10382	43	0	\N
326135	1678	23040757291000	20721	10382	44	0	\N
326136	1678	23040757292000	20721	10382	45	0	\N
326137	1678	23040757293000	20721	10382	46	0	\N
326138	1678	23040757294000	20721	10382	47	0	\N
326139	1678	23040757295000	20721	10382	48	0	\N
326140	1874	15483000	20721	10382	49	0	\N
326141	2267	200000000	20721	10382	50	0	\N
326142	1469	90000000	20721	10382	51	0	\N
326143	1874	15485000	20721	10382	52	0	\N
326144	1874	15487000	20721	10382	53	0	\N
326145	1874	15488000	20721	10382	54	0	\N
326146	1874	15489000	20721	10382	55	0	\N
326147	1874	15490000	20721	10382	56	0	\N
326148	1874	15493000	20721	10382	57	0	\N
326149	1874	15495000	20721	10382	58	0	\N
326150	1874	15498000	20721	10382	59	0	\N
326151	1874	15501000	20721	10382	60	0	\N
326152	1874	15504000	20721	10382	61	0	\N
326153	1874	15507000	20721	10382	62	0	\N
326154	1874	15510000	20721	10382	63	0	\N
326155	1874	15513000	20721	10382	64	0	\N
326156	1874	15516000	20721	10382	65	0	\N
326157	1874	15519000	20721	10382	66	0	\N
326158	1874	15522000	20721	10382	67	0	\N
326159	1874	15525000	20721	10382	68	0	\N
326160	1874	15528000	20721	10382	69	0	\N
326161	1874	15530000	20721	10382	70	0	\N
326162	1874	15532000	20721	10382	71	0	\N
326163	1874	15534000	20721	10382	72	0	\N
326164	1874	15536000	20721	10382	73	0	\N
326165	1874	15538000	20721	10382	74	0	\N
326166	1874	15540000	20721	10382	75	0	\N
326167	1874	15542000	20721	10382	76	0	\N
326168	1874	15544000	20721	10382	77	0	\N
326169	1874	15546000	20721	10382	78	0	\N
326170	1874	15548000	20721	10382	79	0	\N
326171	1874	15550000	20721	10382	80	0	\N
326172	1874	15552000	20721	10382	81	0	\N
326173	1874	15554000	20721	10382	82	0	\N
326174	1874	15556000	20721	10382	83	0	\N
326175	1874	15557000	20721	10382	84	0	\N
326176	1874	15558000	20721	10382	85	0	\N
326177	1874	15559000	20721	10382	86	0	\N
326178	1874	15560000	20721	10382	87	0	\N
326179	1874	15561000	20721	10382	88	0	\N
326180	1874	15562000	20721	10382	89	0	\N
326181	1874	15564000	20721	10382	90	0	\N
326182	1874	15566000	20721	10382	91	0	\N
326183	1874	15568000	20721	10382	92	0	\N
326184	1874	15570000	20721	10382	93	0	\N
326185	1874	15572000	20721	10382	94	0	\N
326186	1874	15574000	20721	10382	96	0	\N
326187	1874	15576000	20721	10382	97	0	\N
326188	1874	15578000	20721	10382	98	0	\N
326189	1874	15580000	20721	10382	99	0	\N
326190	1874	15582000	20721	10382	100	0	\N
326191	1874	15584000	20721	10382	101	0	\N
326192	1874	15586000	20721	10382	102	0	\N
326193	1874	15588000	20721	10382	103	0	\N
326194	1874	15591000	20721	10382	104	0	\N
326195	1874	15594000	20721	10382	105	0	\N
326196	1874	15597000	20721	10382	106	0	\N
326197	1874	15600000	20721	10382	107	0	\N
326198	1874	15603000	20721	10382	108	0	\N
326199	1874	15606000	20721	10382	109	0	\N
326200	1874	15609000	20721	10382	110	0	\N
326201	1874	15612000	20721	10382	111	0	\N
326202	1874	15615000	20721	10382	112	0	\N
326203	1874	15618000	20721	10382	113	0	\N
326204	1874	15621000	20721	10382	114	0	\N
326205	1874	15624000	20721	10382	115	0	\N
326206	1874	15627000	20721	10382	116	0	\N
326207	1874	15630000	20721	10382	117	0	\N
326208	1874	15633000	20721	10382	118	0	\N
326209	1874	15636000	20721	10382	119	0	\N
326210	1874	15639000	20721	10382	120	0	\N
326211	1874	15642000	20721	10382	121	0	\N
326212	1874	15645000	20721	10382	122	0	\N
326213	1874	15646000	20721	10382	123	0	\N
326214	1874	15647000	20721	10382	124	0	\N
326215	1874	15648000	20721	10382	125	0	\N
326216	1678	23040757297000	20724	10420	0	0	\N
326217	1678	23040757298000	20724	10420	1	0	\N
326218	1678	23040757299000	20724	10420	2	0	\N
326219	1874	15701000	20724	10420	3	0	\N
326220	1874	15704000	20724	10420	4	0	\N
326221	1874	15705000	20724	10420	5	0	\N
326222	1874	15708000	20724	10420	6	0	\N
326223	1874	15710000	20724	10420	7	0	\N
326224	1874	15712000	20724	10420	8	0	\N
326225	1874	15714000	20724	10420	9	0	\N
326226	1678	23040757297000	20725	10420	0	0	\N
326227	1678	23040757298000	20725	10420	1	0	\N
326228	1678	23040757299000	20725	10420	2	0	\N
326229	1874	15701000	20725	10420	3	0	\N
326230	1874	15704000	20725	10420	4	0	\N
326231	1874	15705000	20725	10420	5	0	\N
326232	1874	15708000	20725	10420	6	0	\N
326233	1874	15710000	20725	10420	7	0	\N
326234	1874	15712000	20725	10420	8	0	\N
326235	1874	15714000	20725	10420	9	0	\N
326236	1678	23040757297000	20726	10420	0	0	\N
326237	1678	23040757298000	20726	10420	1	0	\N
326238	1678	23040757299000	20726	10420	2	0	\N
326239	1874	15701000	20726	10420	3	0	\N
326240	1874	15704000	20726	10420	4	0	\N
326241	1874	15705000	20726	10420	5	0	\N
326242	1874	15708000	20726	10420	6	0	\N
326243	1874	15710000	20726	10420	7	0	\N
326244	1874	15712000	20726	10420	8	0	\N
326245	1874	15714000	20726	10420	9	0	\N
326246	1678	23040757297000	20727	10420	0	0	\N
326247	1678	23040757298000	20727	10420	1	0	\N
326248	1678	23040757299000	20727	10420	2	0	\N
326249	1874	15701000	20727	10420	3	0	\N
326250	1874	15704000	20727	10420	4	0	\N
326251	1874	15705000	20727	10420	5	0	\N
326252	1874	15708000	20727	10420	6	0	\N
326253	1874	15710000	20727	10420	7	0	\N
326254	1874	15712000	20727	10420	8	0	\N
326255	1874	15714000	20727	10420	9	0	\N
326256	1678	23040757297000	20728	10420	0	0	\N
326257	1678	23040757298000	20728	10420	1	0	\N
326258	1678	23040757299000	20728	10420	2	0	\N
326259	1874	15701000	20728	10420	3	0	\N
326260	1874	15704000	20728	10420	4	0	\N
326261	1874	15705000	20728	10420	5	0	\N
326262	1874	15708000	20728	10420	6	0	\N
326263	1874	15710000	20728	10420	7	0	\N
326264	1874	15712000	20728	10420	8	0	\N
326265	1874	15714000	20728	10420	9	0	\N
326286	1678	23040757300000	20731	10421	0	0	\N
326287	1678	23040757301000	20731	10421	1	0	\N
326288	1678	23040757302000	20731	10421	2	0	\N
326289	1483	10000000	20731	10421	3	0	\N
326290	1874	15716000	20731	10421	4	0	\N
326291	1874	15718000	20731	10421	5	0	\N
326292	1874	15721000	20731	10421	6	0	\N
326293	1874	15723000	20731	10421	7	0	\N
326294	1874	15724000	20731	10421	8	0	\N
326295	1874	15727000	20731	10421	9	0	\N
326306	1678	23040757305000	20734	10423	0	0	\N
326307	1874	15741000	20734	10423	1	0	\N
326308	1874	15743000	20734	10423	2	0	\N
326309	1678	23040757303000	20735	10422	0	0	\N
326310	1678	23040757304000	20735	10422	1	0	\N
326311	1678	23040757305000	20735	10422	2	0	\N
326312	1874	15728000	20735	10422	3	0	\N
326316	1678	23040757306000	20737	10424	0	0	\N
326317	1874	15745000	20737	10424	1	0	\N
326318	1874	15748000	20737	10424	2	0	\N
326323	1678	23040757308000	20739	10426	0	0	\N
326324	1678	23040757309000	20739	10426	1	0	\N
326325	31	1329981875386000	20739	10426	2	0	\N
326326	32	74262251044000	20739	10426	3	0	\N
326327	40	66569445570000	20739	10426	4	0	\N
326328	779	28017885636792	20739	10426	5	0	\N
326329	1874	15757000	20739	10426	6	0	\N
326330	1874	15759000	20739	10426	7	0	\N
326331	1874	15761000	20739	10426	8	0	\N
326332	1874	15764000	20739	10426	9	0	\N
326350	780	308196473040051	20742	10427	0	0	\N
326351	782	2465521918273720	20742	10427	1	0	\N
326352	1678	23040757310000	20742	10427	2	0	\N
326353	785	224138551816807	20742	10427	3	0	\N
326354	1874	15767000	20742	10427	4	0	\N
326355	1874	15769000	20742	10427	5	0	\N
326356	1874	15770000	20742	10427	6	0	\N
326357	786	2465521918273720	20743	10428	0	0	\N
326358	791	56035771273584	20743	10428	1	0	\N
326359	792	616392946080101	20743	10428	2	0	\N
326360	1678	23040757311000	20743	10428	3	0	\N
326361	1874	15772000	20743	10428	4	0	\N
326362	1874	15775000	20743	10428	5	0	\N
326374	801	14010279247666	20746	10430	0	0	\N
326375	802	154112937240275	20746	10430	1	0	\N
326376	1678	23040757313000	20746	10430	2	0	\N
326377	811	108427593503286	20746	10430	3	0	\N
326378	1874	15782000	20746	10430	4	0	\N
326379	1874	15783000	20746	10430	5	0	\N
326380	1874	15786000	20746	10430	6	0	\N
326388	812	1192702487640140	20748	10431	0	0	\N
326389	1678	23040757314000	20748	10431	1	0	\N
326390	823	1739885117760760	20748	10431	2	0	\N
326391	824	19138719592487700	20748	10431	3	0	\N
326392	1874	15789000	20748	10431	4	0	\N
326393	1874	15791000	20748	10431	5	0	\N
326394	812	1192702487640140	20749	10431	0	0	\N
326395	1678	23040757314000	20749	10431	1	0	\N
326396	823	1739885117760760	20749	10431	2	0	\N
326397	824	19138719592487700	20749	10431	3	0	\N
326398	1874	15789000	20749	10431	4	0	\N
326399	1874	15791000	20749	10431	5	0	\N
326268	1678	23040757299000	20729	10420	2	0	0
326269	1874	15701000	20729	10420	3	0	2
326270	1874	15704000	20729	10420	4	0	2
326271	1874	15705000	20729	10420	5	0	2
326272	1874	15708000	20729	10420	6	0	2
326274	1874	15712000	20729	10420	8	0	2
326275	1874	15714000	20729	10420	9	0	2
326276	1678	23040757300000	20730	10421	0	0	0
326277	1678	23040757301000	20730	10421	1	0	0
326278	1678	23040757302000	20730	10421	2	0	0
326280	1874	15716000	20730	10421	4	0	2
326281	1874	15718000	20730	10421	5	0	2
326282	1874	15721000	20730	10421	6	0	2
326283	1874	15723000	20730	10421	7	0	2
326285	1874	15727000	20730	10421	9	0	2
326296	1678	23040757303000	20732	10422	0	0	0
326297	1678	23040757304000	20732	10422	1	0	0
326298	1874	15730000	20732	10422	2	0	2
326299	1874	15732000	20732	10422	3	0	2
326301	1874	15735000	20732	10422	5	0	2
326302	1874	15738000	20732	10422	6	0	2
326303	1678	23040757305000	20733	10423	0	0	0
326304	1874	15741000	20733	10423	1	0	2
326305	1874	15743000	20733	10423	2	0	2
326314	1874	15745000	20736	10424	1	0	2
326315	1874	15748000	20736	10424	2	0	2
326319	1678	23040757307000	20738	10425	0	0	0
326320	1874	15750000	20738	10425	1	0	2
326322	1874	15754000	20738	10425	3	0	2
326333	1678	23040757308000	20740	10426	0	0	0
326334	1678	23040757309000	20740	10426	1	0	0
326335	31	1329981875386000	20740	10426	2	0	0
326336	32	74262251044000	20740	10426	3	0	0
326338	779	28017885636792	20740	10426	5	0	0
326339	1874	15757000	20740	10426	6	0	2
326340	1874	15759000	20740	10426	7	0	2
326341	1874	15761000	20740	10426	8	0	2
326342	1874	15764000	20740	10426	9	0	2
326344	782	2465521918273720	20741	10427	1	0	0
326345	1678	23040757310000	20741	10427	2	0	0
326346	785	224138551816807	20741	10427	3	0	0
326347	1874	15767000	20741	10427	4	0	2
326349	1874	15770000	20741	10427	6	0	2
326363	786	2465521918273720	20744	10428	0	0	0
326364	791	56035771273584	20744	10428	1	0	0
326365	792	616392946080101	20744	10428	2	0	0
326366	1678	23040757311000	20744	10428	3	0	0
326368	1874	15775000	20744	10428	5	0	2
326369	799	14007687631181	20745	10429	0	0	0
326370	800	154084429483607	20745	10429	1	0	0
326371	1678	23040757312000	20745	10429	2	0	0
326372	1874	15778000	20745	10429	3	0	2
326381	801	14010279247666	20747	10430	0	0	0
326382	802	154112937240275	20747	10430	1	0	0
326383	1678	23040757313000	20747	10430	2	0	0
326384	811	108427593503286	20747	10430	3	0	0
326386	1874	15783000	20747	10430	5	0	2
326387	1874	15786000	20747	10430	6	0	2
326400	812	1192702487640140	20750	10431	0	0	0
326419	1678	23040757316000	20753	10433	0	0	\N
326420	1874	15798000	20753	10433	1	0	\N
326421	1874	15801000	20753	10433	2	0	\N
326422	2268	200000000	20753	10433	3	0	\N
326423	1874	15802000	20753	10433	4	0	\N
326424	1678	23040757316000	20754	10433	0	0	\N
326425	1874	15798000	20754	10433	1	0	\N
326426	1874	15801000	20754	10433	2	0	\N
326427	2268	200000000	20754	10433	3	0	\N
326428	1874	15802000	20754	10433	4	0	\N
326429	1678	23040757317000	20755	10434	0	0	\N
326430	1	375562550686000	20755	10434	1	0	\N
326431	841	84064023338298	20755	10434	2	0	\N
326432	843	156725652655667	20755	10434	3	0	\N
326433	1874	15804000	20755	10434	4	0	\N
326434	1874	15807000	20755	10434	5	0	\N
326441	1706	16053356600135	20760	10422	0	0	\N
326442	1706	16054356600135	20760	10422	1	0	\N
326443	1678	23040757303000	20760	10422	2	0	\N
326444	1678	23040757304000	20760	10422	3	0	\N
326445	1678	23040757305000	20760	10422	4	0	\N
326446	1	375562550686000	20760	10422	5	0	\N
326447	31	1329981875386000	20760	10422	6	0	\N
326448	32	74262251044000	20760	10422	7	0	\N
326449	556	66743135511028	20760	10422	8	0	\N
326450	841	84064023338298	20760	10422	9	0	\N
326451	843	156725652655667	20760	10422	10	0	\N
326452	849	1155353613497640	20760	10422	11	0	\N
326453	851	2247807533667750	20760	10422	12	0	\N
326454	930	508430970677776	20760	10422	13	0	\N
326455	1050	911103943218016	20760	10422	14	0	\N
326456	1170	614739985517734	20760	10422	15	0	\N
326457	40	66569445570000	20760	10422	16	0	\N
326458	779	28017885636792	20760	10422	17	0	\N
326459	780	308196473040051	20760	10422	18	0	\N
326460	782	2465521918273720	20760	10422	19	0	\N
326461	785	224138551816807	20760	10422	20	0	\N
326462	786	2465521918273720	20760	10422	21	0	\N
326463	791	56035771273584	20760	10422	22	0	\N
326464	792	616392946080101	20760	10422	23	0	\N
326465	799	14007687631181	20760	10422	24	0	\N
326466	800	154084429483607	20760	10422	25	0	\N
326467	801	14010279247666	20760	10422	26	0	\N
326468	802	154112937240275	20760	10422	27	0	\N
326469	1296	1713027629277034	20760	10422	28	0	\N
326470	1678	23040757306000	20760	10422	29	0	\N
326471	1678	23040757307000	20760	10422	30	0	\N
326472	1678	23040757308000	20760	10422	31	0	\N
326473	1678	23040757309000	20760	10422	32	0	\N
326474	1678	23040757310000	20760	10422	33	0	\N
326475	1678	23040757311000	20760	10422	34	0	\N
326476	1678	23040757312000	20760	10422	35	0	\N
326477	1678	23040757313000	20760	10422	36	0	\N
326478	1678	23040757314000	20760	10422	37	0	\N
326479	853	247856948044225	20760	10422	38	0	\N
326480	1678	23040757315000	20760	10422	39	0	\N
326481	1678	23040757316000	20760	10422	40	0	\N
326482	1678	23040757317000	20760	10422	41	0	\N
326483	1678	23040757318000	20760	10422	42	0	\N
326484	1678	23040757319000	20760	10422	43	0	\N
326485	1678	23040757320000	20760	10422	44	0	\N
326486	855	131107036356125	20760	10422	45	0	\N
326487	857	330584433102608	20760	10422	46	0	\N
326488	861	456614161103125	20760	10422	47	0	\N
326489	811	108427593503286	20760	10422	48	0	\N
326490	812	1192702487640140	20760	10422	49	0	\N
326491	823	1739885117760760	20760	10422	50	0	\N
326492	824	19138719592487700	20760	10422	51	0	\N
326493	2177	70684766549641	20760	10422	52	0	\N
326494	1874	15728000	20760	10422	53	0	\N
326495	1874	15729000	20760	10422	54	0	\N
326496	1874	15730000	20760	10422	55	0	\N
326497	1874	15731000	20760	10422	56	0	\N
326498	2268	200000000	20760	10422	57	0	\N
326499	1874	15732000	20760	10422	58	0	\N
326500	1874	15733000	20760	10422	59	0	\N
326515	1343	1712413637751650	20762	10361	0	0	\N
326516	1097	910778465000000	20762	10361	1	0	\N
326517	1217	614520750000000	20762	10361	2	0	\N
326518	977	508248775000000	20762	10361	3	0	\N
326519	1	375562550686000	20762	10361	4	0	\N
326520	31	1329981875386000	20762	10361	5	0	\N
326521	32	74262251044000	20762	10361	6	0	\N
326522	556	66743135511028	20762	10361	7	0	\N
326523	841	84064023338298	20762	10361	8	0	\N
326524	843	156725652655667	20762	10361	9	0	\N
326525	849	1155353613497640	20762	10361	10	0	\N
326526	851	2247807533667750	20762	10361	11	0	\N
326527	930	508430970677776	20762	10361	12	0	\N
326528	1050	911103943218016	20762	10361	13	0	\N
326529	1170	614739985517734	20762	10361	14	0	\N
326530	40	66569445570000	20762	10361	15	0	\N
326531	779	28017885636792	20762	10361	16	0	\N
326532	780	308196473040051	20762	10361	17	0	\N
326533	782	2465521918273720	20762	10361	18	0	\N
326534	785	224138551816807	20762	10361	19	0	\N
326535	786	2465521918273720	20762	10361	20	0	\N
326536	791	56035771273584	20762	10361	21	0	\N
326403	824	19138719592487700	20750	10431	3	0	0
326404	1874	15789000	20750	10431	4	0	2
326405	1874	15791000	20750	10431	5	0	2
326406	556	66743135511028	20751	10432	0	0	0
326407	930	508430970677776	20751	10432	1	0	0
326409	1170	614739985517734	20751	10432	3	0	0
326410	1296	1713027629277034	20751	10432	4	0	0
326411	1678	23040757315000	20751	10432	5	0	0
326412	1874	15793000	20751	10432	6	0	2
326413	1874	15796000	20751	10432	7	0	2
326415	1874	15798000	20752	10433	1	0	2
326416	1874	15801000	20752	10433	2	0	2
326417	2268	200000000	20752	10433	3	0	0
326418	1874	15802000	20752	10433	4	0	2
326436	1	375562550686000	20756	10434	1	0	0
326437	841	84064023338298	20756	10434	2	0	0
326438	843	156725652655667	20756	10434	3	0	0
326439	1874	15804000	20756	10434	4	0	2
326440	1874	15807000	20756	10434	5	0	2
326502	1706	16054356600135	20761	10436	1	0	20
326503	849	1155353613497640	20761	10436	2	0	3
326504	851	2247807533667750	20761	10436	3	0	0
326505	1678	23040757318000	20761	10436	4	0	0
326506	1678	23040757319000	20761	10436	5	0	0
326508	855	131107036356125	20761	10436	7	0	0
326509	857	330584433102608	20761	10436	8	0	0
326510	861	456614161103125	20761	10436	9	0	0
326511	1874	15808000	20761	10436	10	0	2
326513	1874	15813000	20761	10436	12	0	2
326514	1874	15815000	20761	10436	13	0	2
326537	792	616392946080101	20762	10361	22	0	\N
326538	799	14007687631181	20762	10361	23	0	\N
326539	800	154084429483607	20762	10361	24	0	\N
326540	801	14010279247666	20762	10361	25	0	\N
326541	802	154112937240275	20762	10361	26	0	\N
326542	1296	1713027629277034	20762	10361	27	0	\N
326543	1678	23040757276000	20762	10361	28	0	\N
326544	1678	23040757277000	20762	10361	29	0	\N
326545	1678	23040757278000	20762	10361	30	0	\N
326546	1678	23040757279000	20762	10361	31	0	\N
326547	1678	23040757280000	20762	10361	32	0	\N
326548	1678	23040757281000	20762	10361	33	0	\N
326549	1678	23040757282000	20762	10361	34	0	\N
326550	1678	23040757283000	20762	10361	35	0	\N
326551	1678	23040757284000	20762	10361	36	0	\N
326552	1678	23040757285000	20762	10361	37	0	\N
326553	853	247856948044225	20762	10361	38	0	\N
326554	855	131107036356125	20762	10361	39	0	\N
326555	811	108427593503286	20762	10361	40	0	\N
326556	812	1192702487640140	20762	10361	41	0	\N
326557	823	1739885117760760	20762	10361	42	0	\N
326558	824	19138719592487700	20762	10361	43	0	\N
326559	2177	70684766549641	20762	10361	44	0	\N
326560	1678	23040757286000	20762	10361	45	0	\N
326561	1678	23040757287000	20762	10361	46	0	\N
326562	1678	23040757288000	20762	10361	47	0	\N
326563	1678	23040757289000	20762	10361	48	0	\N
326564	1678	23040757290000	20762	10361	49	0	\N
326565	1678	23040757291000	20762	10361	50	0	\N
326566	1678	23040757292000	20762	10361	51	0	\N
326567	1678	23040757293000	20762	10361	52	0	\N
326568	1678	23040757294000	20762	10361	53	0	\N
326569	1678	23040757295000	20762	10361	54	0	\N
326570	1678	23040757296000	20762	10361	55	0	\N
326571	1678	23040757297000	20762	10361	56	0	\N
326572	1678	23040757298000	20762	10361	57	0	\N
326573	1678	23040757299000	20762	10361	58	0	\N
326574	1678	23040757300000	20762	10361	59	0	\N
326575	1678	23040757301000	20762	10361	60	0	\N
326576	1678	23040757302000	20762	10361	61	0	\N
326577	1678	23040757303000	20762	10361	62	0	\N
326578	1678	23040757304000	20762	10361	63	0	\N
326579	1678	23040757305000	20762	10361	64	0	\N
326580	1678	23040757306000	20762	10361	65	0	\N
326581	1678	23040757307000	20762	10361	66	0	\N
326582	1678	23040757308000	20762	10361	67	0	\N
326583	1678	23040757309000	20762	10361	68	0	\N
326584	1678	23040757310000	20762	10361	69	0	\N
326585	1678	23040757311000	20762	10361	70	0	\N
326586	1678	23040757312000	20762	10361	71	0	\N
326587	1678	23040757313000	20762	10361	72	0	\N
326588	1678	23040757314000	20762	10361	74	0	\N
326589	1678	23040757315000	20762	10361	75	0	\N
326590	1678	23040757316000	20762	10361	76	0	\N
326591	1678	23040757317000	20762	10361	77	0	\N
326592	1678	23040757318000	20762	10361	78	0	\N
326593	1678	23040757319000	20762	10361	79	0	\N
326594	1483	10000000	20762	10361	80	0	\N
326595	2267	200000000	20762	10361	81	0	\N
326596	1469	90000000	20762	10361	82	0	\N
326597	1874	15569000	20762	10361	83	0	\N
326598	1874	15571000	20762	10361	84	0	\N
326599	1874	15573000	20762	10361	85	0	\N
326600	2268	200000000	20762	10361	86	0	\N
326601	1874	15575000	20762	10361	87	0	\N
326602	1874	15577000	20762	10361	88	0	\N
326603	1874	15579000	20762	10361	89	0	\N
326604	1874	15582000	20762	10361	90	0	\N
326605	1874	15585000	20762	10361	91	0	\N
326606	1874	15588000	20762	10361	92	0	\N
326607	1874	15591000	20762	10361	93	0	\N
326608	1874	15594000	20762	10361	94	0	\N
326609	1874	15597000	20762	10361	95	0	\N
326610	1874	15600000	20762	10361	96	0	\N
326611	1874	15603000	20762	10361	97	0	\N
326612	1874	15606000	20762	10361	98	0	\N
326613	1874	15609000	20762	10361	99	0	\N
326614	1874	15612000	20762	10361	100	0	\N
326615	1874	15615000	20762	10361	101	0	\N
326616	1874	15618000	20762	10361	102	0	\N
326617	1874	15621000	20762	10361	103	0	\N
326618	1874	15624000	20762	10361	104	0	\N
326619	1874	15627000	20762	10361	105	0	\N
326620	1874	15630000	20762	10361	106	0	\N
326621	1874	15633000	20762	10361	107	0	\N
326622	1874	15635000	20762	10361	108	0	\N
326623	1874	15637000	20762	10361	109	0	\N
326624	1874	15639000	20762	10361	110	0	\N
326625	1874	15641000	20762	10361	111	0	\N
326626	1874	15644000	20762	10361	112	0	\N
326627	1874	15646000	20762	10361	113	0	\N
326628	1874	15648000	20762	10361	114	0	\N
326629	1874	15650000	20762	10361	115	0	\N
326630	1874	15651000	20762	10361	116	0	\N
326631	1874	15652000	20762	10361	117	0	\N
326632	1874	15653000	20762	10361	118	0	\N
326633	1706	16053356600135	20763	10416	0	0	\N
326634	1706	16054356600135	20763	10416	1	0	\N
326635	1	375562550686000	20763	10416	2	0	\N
326636	31	1329981875386000	20763	10416	3	0	\N
326637	32	74262251044000	20763	10416	4	0	\N
326638	556	66743135511028	20763	10416	5	0	\N
326639	841	84064023338298	20763	10416	6	0	\N
326640	843	156725652655667	20763	10416	7	0	\N
326641	849	1155353613497640	20763	10416	8	0	\N
326642	851	2247807533667750	20763	10416	9	0	\N
326643	930	508430970677776	20763	10416	10	0	\N
326644	1050	911103943218016	20763	10416	11	0	\N
326645	1170	614739985517734	20763	10416	12	0	\N
326646	40	66569445570000	20763	10416	13	0	\N
326647	779	28017885636792	20763	10416	15	0	\N
326648	780	308196473040051	20763	10416	16	0	\N
326649	782	2465521918273720	20763	10416	17	0	\N
326650	785	224138551816807	20763	10416	18	0	\N
326651	786	2465521918273720	20763	10416	19	0	\N
326652	791	56035771273584	20763	10416	20	0	\N
326653	792	616392946080101	20763	10416	21	0	\N
326654	799	14007687631181	20763	10416	22	0	\N
326655	800	154084429483607	20763	10416	23	0	\N
326656	801	14010279247666	20763	10416	24	0	\N
326657	802	154112937240275	20763	10416	25	0	\N
326658	1296	1713027629277034	20763	10416	26	0	\N
326659	853	247856948044225	20763	10416	27	0	\N
326660	855	131107036356125	20763	10416	28	0	\N
326661	857	330584433102608	20763	10416	29	0	\N
326662	861	456614161103125	20763	10416	30	0	\N
326663	811	108427593503286	20763	10416	31	0	\N
326664	812	1192702487640140	20763	10416	32	0	\N
326665	823	1739885117760760	20763	10416	33	0	\N
326666	824	19138719592487700	20763	10416	34	0	\N
326667	2177	70684766549641	20763	10416	35	0	\N
326668	1483	10000000	20763	10416	36	0	\N
326669	2268	200000000	20763	10416	37	0	\N
326670	1706	16053356600135	20764	10436	0	0	\N
326671	849	1155353613497640	20764	10436	1	0	\N
326672	851	2247807533667750	20764	10436	2	0	\N
326673	1678	23040757318000	20764	10436	3	0	\N
326674	1678	23040757319000	20764	10436	4	0	\N
326675	853	247856948044225	20764	10436	5	0	\N
326676	855	131107036356125	20764	10436	6	0	\N
326677	857	330584433102608	20764	10436	7	0	\N
326678	1874	15808000	20764	10436	8	0	\N
326679	1874	15810000	20764	10436	9	0	\N
326680	1874	15813000	20764	10436	10	0	\N
326681	1874	15815000	20764	10436	11	0	\N
326682	1706	16054356600135	20765	10437	0	0	\N
326683	861	456614161103125	20765	10437	1	0	\N
326684	865	400855996215417	20765	10437	2	0	\N
326685	867	2441303436168000	20765	10437	3	0	\N
326686	869	261078414520845	20765	10437	4	0	\N
326687	1678	23040757320000	20765	10437	5	0	\N
326688	1874	15817000	20765	10437	6	0	\N
326694	1706	16053356600135	20767	10436	0	0	\N
326695	1706	16054356600135	20767	10436	1	0	\N
326696	849	1155353613497640	20767	10436	2	0	\N
326697	851	2247807533667750	20767	10436	3	0	\N
326698	1678	23040757318000	20767	10436	4	0	\N
326699	1678	23040757319000	20767	10436	5	0	\N
326700	853	247856948044225	20767	10436	6	0	\N
326701	855	131107036356125	20767	10436	7	0	\N
326702	857	330584433102608	20767	10436	8	0	\N
326703	861	456614161103125	20767	10436	9	0	\N
326704	1874	15808000	20767	10436	10	0	\N
326705	1874	15810000	20767	10436	11	0	\N
326706	1874	15813000	20767	10436	12	0	\N
326707	1874	15815000	20767	10436	13	0	\N
326708	865	400855996215417	20768	10437	0	0	\N
326709	867	2441303436168000	20768	10437	1	0	\N
326710	869	261078414520845	20768	10437	2	0	\N
326711	1678	23040757320000	20768	10437	3	0	\N
326712	1874	15817000	20768	10437	4	0	\N
326716	1678	23040757321000	20770	10438	0	0	\N
326717	1874	15819000	20770	10438	1	0	\N
326718	1706	17490356600135	20771	10439	0	0	\N
326719	881	587721197459250	20771	10439	1	0	\N
326720	883	90418645762500	20771	10439	2	0	\N
326721	887	269862585957154	20771	10439	3	0	\N
326722	889	226535176490249	20771	10439	4	0	\N
326723	891	497302551695750	20771	10439	5	0	\N
326724	897	65600535873885	20771	10439	6	0	\N
326725	1678	23040757322000	20771	10439	7	0	\N
326726	1678	23040757323000	20771	10439	8	0	\N
326727	1874	15821000	20771	10439	9	0	\N
326728	1874	15823000	20771	10439	10	0	\N
326729	1874	15824000	20771	10439	11	0	\N
326730	1706	17490356600135	20772	10439	0	0	\N
326731	881	587721197459250	20772	10439	1	0	\N
326732	883	90418645762500	20772	10439	2	0	\N
326733	887	269862585957154	20772	10439	3	0	\N
326734	889	226535176490249	20772	10439	4	0	\N
326735	891	497302551695750	20772	10439	5	0	\N
326736	897	65600535873885	20772	10439	6	0	\N
326737	1678	23040757322000	20772	10439	7	0	\N
326738	1678	23040757323000	20772	10439	8	0	\N
326739	1874	15821000	20772	10439	9	0	\N
326740	1874	15823000	20772	10439	10	0	\N
326741	1874	15824000	20772	10439	11	0	\N
326754	1706	17490356600135	20774	10439	0	0	\N
326755	881	587721197459250	20774	10439	1	0	\N
326756	883	90418645762500	20774	10439	2	0	\N
326757	887	269862585957154	20774	10439	3	0	\N
326758	889	226535176490249	20774	10439	4	0	\N
326759	891	497302551695750	20774	10439	5	0	\N
326760	897	65600535873885	20774	10439	6	0	\N
326761	1678	23040757322000	20774	10439	7	0	\N
326762	1678	23040757323000	20774	10439	8	0	\N
326763	1874	15821000	20774	10439	9	0	\N
326764	1874	15823000	20774	10439	10	0	\N
326765	1874	15824000	20774	10439	11	0	\N
326766	1706	17490356600135	20775	10439	0	0	\N
326767	1678	23040757322000	20775	10439	1	0	\N
326768	1678	23040757323000	20775	10439	2	0	\N
326769	1874	15821000	20775	10439	3	0	\N
326770	1874	15823000	20775	10439	4	0	\N
326771	1874	15824000	20775	10439	5	0	\N
326783	1678	23040757325000	20778	10441	0	0	\N
326784	1678	23040757326000	20778	10441	1	0	\N
326785	1874	15827000	20778	10441	2	0	\N
326786	1874	15829000	20778	10441	3	0	\N
326787	1874	15831000	20778	10441	4	0	\N
326806	1251	614188360000000	20783	10445	0	0	\N
326807	1981	100980000000	20783	10445	1	0	\N
326808	1678	23040757332000	20783	10445	2	0	\N
326691	869	261078414520845	20766	10437	2	0	0
326692	1678	23040757320000	20766	10437	3	0	0
326693	1874	15817000	20766	10437	4	0	2
326713	879	135627968644750	20769	10438	0	0	0
326714	1678	23040757321000	20769	10438	1	0	0
326742	1706	17490356600135	20773	10439	0	0	20
326743	881	587721197459250	20773	10439	1	0	0
326744	883	90418645762500	20773	10439	2	0	0
326745	887	269862585957154	20773	10439	3	0	0
326746	889	226535176490249	20773	10439	4	0	0
326748	897	65600535873885	20773	10439	6	0	0
326749	1678	23040757322000	20773	10439	7	0	0
326750	1678	23040757323000	20773	10439	8	0	0
326751	1874	15821000	20773	10439	9	0	2
326753	1874	15824000	20773	10439	11	0	2
326772	899	39104255918990	20776	10440	0	0	0
326773	1678	23040757324000	20776	10440	1	0	0
326774	901	117544239492250	20776	10440	2	0	0
326775	905	422707168941938	20776	10440	3	0	0
326777	2177	64960605049641	20777	10441	0	0	0
326778	1678	23040757325000	20777	10441	1	0	0
326779	1678	23040757326000	20777	10441	2	0	0
326780	1874	15827000	20777	10441	3	0	2
326781	1874	15829000	20777	10441	4	0	2
326788	1678	23040757327000	20779	10442	0	0	0
326789	1874	15833000	20779	10442	1	0	2
326790	1131	910286565000000	20780	10443	0	0	0
326791	1678	23040757328000	20780	10443	1	0	0
326793	1678	23040757330000	20780	10443	3	0	0
326794	1874	15835000	20780	10443	4	0	2
326795	1874	15836000	20780	10443	5	0	2
326796	1874	15838000	20780	10443	6	0	2
326797	1874	15840000	20780	10443	7	0	2
326799	1874	15842000	20781	10444	1	0	2
326800	1251	614188360000000	20782	10445	0	0	0
326801	1981	100980000000	20782	10445	1	0	2
326802	1678	23040757332000	20782	10445	2	0	0
326803	2177	71944805349741	20782	10445	3	0	0
326805	1874	15845000	20782	10445	5	0	2
326809	2177	71944805349741	20783	10445	3	0	\N
326810	1874	15843000	20783	10445	4	0	\N
326811	1874	15845000	20783	10445	5	0	\N
326812	1251	614188360000000	20785	10445	0	0	\N
326813	1981	100980000000	20785	10445	1	0	\N
326814	1678	23040757332000	20785	10445	2	0	\N
326815	2177	71944805349741	20785	10445	3	0	\N
326816	1874	15843000	20785	10445	4	0	\N
326817	1874	15845000	20785	10445	5	0	\N
326818	1343	1712413637751650	20786	10358	0	0	\N
326819	1097	910778465000000	20786	10358	1	0	\N
326820	1217	614520750000000	20786	10358	2	0	\N
326821	977	508248775000000	20786	10358	3	0	\N
326822	1706	16053356600135	20786	10358	4	0	\N
326823	1706	16054356600135	20786	10358	5	0	\N
326824	1706	17490356600135	20786	10358	6	0	\N
326825	1981	100980000000	20786	10358	7	0	\N
326826	1	375562550686000	20786	10358	8	0	\N
326827	31	1329981875386000	20786	10358	9	0	\N
326828	32	74262251044000	20786	10358	10	0	\N
326829	556	66743135511028	20786	10358	11	0	\N
326830	841	84064023338298	20786	10358	12	0	\N
326831	843	156725652655667	20786	10358	13	0	\N
326832	849	1155353613497640	20786	10358	14	0	\N
326833	851	2247807533667750	20786	10358	15	0	\N
326834	930	508430970677776	20786	10358	16	0	\N
326835	1050	911103943218016	20786	10358	17	0	\N
326836	1170	614739985517734	20786	10358	18	0	\N
326837	40	66569445570000	20786	10358	19	0	\N
326838	779	28017885636792	20786	10358	20	0	\N
326839	780	308196473040051	20786	10358	21	0	\N
326840	782	2465521918273720	20786	10358	22	0	\N
326841	1678	23040757260000	20786	10358	23	0	\N
326842	1678	23040757261000	20786	10358	24	0	\N
326843	785	224138551816807	20786	10358	25	0	\N
326844	786	2465521918273720	20786	10358	26	0	\N
326845	791	56035771273584	20786	10358	27	0	\N
326846	792	616392946080101	20786	10358	28	0	\N
326847	799	14007687631181	20786	10358	29	0	\N
326848	800	154084429483607	20786	10358	30	0	\N
326849	801	14010279247666	20786	10358	31	0	\N
326850	802	154112937240275	20786	10358	32	0	\N
326851	1296	1713027629277034	20786	10358	33	0	\N
326852	853	247856948044225	20786	10358	34	0	\N
326853	1678	23040757262000	20786	10358	35	0	\N
326854	855	131107036356125	20786	10358	36	0	\N
326855	857	330584433102608	20786	10358	37	0	\N
326856	1678	23040757333000	20787	10446	0	0	\N
326857	1874	15847000	20787	10446	1	0	\N
326867	1981	101280000000	20791	10449	0	0	\N
326868	1678	23040757336000	20791	10449	1	0	\N
326869	1874	15850000	20791	10449	2	0	\N
326870	1874	15852000	20791	10449	3	0	\N
326890	1678	23040757339000	20796	10452	0	0	\N
326891	1108	908677517146240	20796	10452	1	0	\N
326892	1228	613102827497120	20796	10452	2	0	\N
326893	1354	1708465542884770	20796	10452	3	0	\N
326894	1874	15857000	20796	10452	4	0	\N
326895	1874	15859000	20796	10452	5	0	\N
326911	1678	23040757347000	20803	10458	0	0	\N
326912	1874	15877000	20803	10458	1	0	\N
326923	1678	23040757349000	20807	10460	0	0	\N
326924	1874	15881000	20807	10460	1	0	\N
326925	1874	15882000	20807	10460	2	0	\N
326931	1678	23040757351000	20810	10462	0	0	\N
326932	1874	15886000	20810	10462	1	0	\N
326933	1678	23040757351000	20811	10462	0	0	\N
326934	1874	15886000	20811	10462	1	0	\N
326935	1678	23040757351000	20812	10462	0	0	\N
326936	1874	15886000	20812	10462	1	0	\N
326942	1678	23040757353000	20815	10464	0	0	\N
326943	1874	15891000	20815	10464	1	0	\N
326944	1678	23040757353000	20816	10464	0	0	\N
326860	873	2441303436168000	20789	10447	1	0	0
326861	1678	23040757334000	20789	10447	2	0	0
326862	1981	101080000000	20789	10447	3	0	2
326863	1874	15847000	20789	10447	4	0	2
326864	1678	23040757335000	20790	10448	0	0	0
326866	1874	15849000	20790	10448	2	0	2
326871	1981	101280000000	20792	10449	0	0	2
326872	1678	23040757336000	20792	10449	1	0	0
326873	1874	15850000	20792	10449	2	0	2
326874	1874	15852000	20792	10449	3	0	2
326876	1874	15854000	20793	10450	1	0	2
326877	1678	23040757338000	20794	10451	0	0	0
326878	451	66564722585011	20794	10451	1	0	0
326879	487	66564722585011	20794	10451	2	0	0
326881	988	507076931797664	20794	10451	4	0	0
326882	1874	15856000	20794	10451	5	0	2
326883	1678	23040757339000	20795	10452	0	0	0
326884	1108	908677517146240	20795	10452	1	0	0
326885	1228	613102827497120	20795	10452	2	0	0
326887	1874	15857000	20795	10452	4	0	2
326888	1874	15859000	20795	10452	5	0	2
326889	1874	15861000	20795	10452	6	0	2
326896	1678	23040757340000	20797	10453	0	0	0
326897	1678	23040757341000	20798	10454	0	0	0
326899	1678	23040757342000	20800	10455	0	0	0
326900	1874	15865000	20800	10455	1	0	2
326901	1874	15866000	20800	10455	2	0	2
326902	1678	23040757343000	20801	10456	0	0	0
326904	1678	23040757344000	20802	10457	0	0	0
326905	1678	23040757345000	20802	10457	1	0	0
326906	1678	23040757346000	20802	10457	2	0	0
326907	1874	15870000	20802	10457	3	0	2
326908	1874	15872000	20802	10457	4	0	2
326910	1874	15875000	20802	10457	6	0	2
326913	1678	23040757347000	20804	10458	0	0	0
326914	1874	15877000	20804	10458	1	0	2
326915	1355	1708676653253353	20805	10459	0	0	0
326916	1109	908789804707202	20805	10459	1	0	0
326918	989	507139625446703	20805	10459	3	0	0
326919	1678	23040757348000	20805	10459	5	0	0
326920	1874	15879000	20805	10459	6	0	2
326921	1678	23040757349000	20806	10460	0	0	0
326926	1678	23040757350000	20808	10461	0	0	0
326927	1874	15882000	20808	10461	1	0	2
326928	1874	15884000	20808	10461	2	0	2
326929	1678	23040757351000	20809	10462	0	0	0
326930	1874	15886000	20809	10462	1	0	2
326938	1874	15887000	20813	10463	1	0	2
326939	1874	15889000	20813	10463	2	0	2
326940	1678	23040757353000	20814	10464	0	0	0
326941	1874	15891000	20814	10464	1	0	2
326945	1874	15891000	20816	10464	1	0	\N
326946	1678	23040757353000	20817	10464	0	0	\N
326947	1874	15891000	20817	10464	1	0	\N
326948	1706	16053356600135	20818	10423	0	0	\N
326949	1706	16054356600135	20818	10423	1	0	\N
326950	1706	17490356600135	20818	10423	2	0	\N
326951	1355	1708676653253353	20818	10423	3	0	\N
326952	1109	908789804707202	20818	10423	4	0	\N
326953	1229	613178594344390	20818	10423	5	0	\N
326954	989	507139625446703	20818	10423	6	0	\N
326955	1981	100980000000	20818	10423	8	0	\N
326956	1131	910286565000000	20818	10423	9	0	\N
326957	1251	614188360000000	20818	10423	10	0	\N
326958	1011	507974815000000	20818	10423	11	0	\N
326959	1	375562550686000	20818	10423	12	0	\N
326960	31	1329981875386000	20818	10423	13	0	\N
326961	32	74262251044000	20818	10423	14	0	\N
326962	556	66743135511028	20818	10423	15	0	\N
326963	841	84064023338298	20818	10423	16	0	\N
326964	843	156725652655667	20818	10423	17	0	\N
326965	849	1155353613497640	20818	10423	18	0	\N
326966	851	2247807533667750	20818	10423	19	0	\N
326967	930	508430970677776	20818	10423	20	0	\N
326968	1050	911103943218016	20818	10423	21	0	\N
326969	1170	614739985517734	20818	10423	22	0	\N
326970	40	66569445570000	20818	10423	23	0	\N
326971	779	28017885636792	20818	10423	24	0	\N
326972	780	308196473040051	20818	10423	25	0	\N
326973	782	2465521918273720	20818	10423	26	0	\N
326974	785	224138551816807	20818	10423	27	0	\N
326975	786	2465521918273720	20818	10423	28	0	\N
326976	791	56035771273584	20818	10423	29	0	\N
326977	792	616392946080101	20818	10423	30	0	\N
326978	799	14007687631181	20818	10423	31	0	\N
326979	800	154084429483607	20818	10423	32	0	\N
326980	801	14010279247666	20818	10423	33	0	\N
326981	802	154112937240275	20818	10423	34	0	\N
326982	1296	1713027629277034	20818	10423	35	0	\N
326983	1678	23040757306000	20818	10423	36	0	\N
326984	1678	23040757307000	20818	10423	37	0	\N
326985	1678	23040757308000	20818	10423	38	0	\N
326986	1678	23040757309000	20818	10423	39	0	\N
326987	1678	23040757310000	20818	10423	40	0	\N
326988	451	66564722585011	20818	10423	41	0	\N
326989	487	66564722585011	20818	10423	42	0	\N
326990	744	2017112805578	20818	10423	43	0	\N
326991	988	507076931797664	20818	10423	44	0	\N
326992	1108	908677517146240	20818	10423	45	0	\N
326993	1678	23040757311000	20818	10423	46	0	\N
326994	1678	23040757312000	20818	10423	47	0	\N
326995	1678	23040757313000	20818	10423	48	0	\N
326996	1678	23040757314000	20818	10423	49	0	\N
326997	853	247856948044225	20818	10423	50	0	\N
326998	1678	23040757315000	20818	10423	51	0	\N
326999	1678	23040757316000	20818	10423	52	0	\N
327000	1678	23040757317000	20818	10423	53	0	\N
327001	1678	23040757318000	20818	10423	54	0	\N
327002	1678	23040757319000	20818	10423	55	0	\N
327003	1678	23040757320000	20818	10423	56	0	\N
327004	855	131107036356125	20818	10423	57	0	\N
327005	857	330584433102608	20818	10423	58	0	\N
327006	861	456614161103125	20818	10423	59	0	\N
327007	865	400855996215417	20818	10423	60	0	\N
327008	867	2441303436168000	20818	10423	61	0	\N
327009	869	261078414520845	20818	10423	62	0	\N
327010	873	2441303436168000	20818	10423	63	0	\N
327011	875	213990794972583	20818	10423	64	0	\N
327012	883	90418645762500	20818	10423	65	0	\N
327013	887	269862585957154	20818	10423	66	0	\N
327014	889	226535176490249	20818	10423	67	0	\N
327015	891	497302551695750	20818	10423	68	0	\N
327016	897	65600535873885	20818	10423	69	0	\N
327017	899	39104255918990	20818	10423	70	0	\N
327018	901	117544239492250	20818	10423	71	0	\N
327019	905	422707168941938	20818	10423	72	0	\N
327020	2177	64960605049641	20818	10423	73	0	\N
327021	873	2445664587151000	20818	10423	74	0	\N
327022	875	214373068700583	20818	10423	75	0	\N
327023	1228	613102827497120	20818	10423	76	0	\N
327024	1354	1708465542884770	20818	10423	77	0	\N
327025	1678	23040757321000	20818	10423	78	0	\N
327026	1678	23040757322000	20818	10423	79	0	\N
327027	1678	23040757323000	20818	10423	80	0	\N
327028	1678	23040757324000	20818	10423	81	0	\N
327029	1678	23040757325000	20818	10423	82	0	\N
327030	1678	23040757326000	20818	10423	83	0	\N
327031	1678	23040757327000	20818	10423	84	0	\N
327032	1678	23040757328000	20818	10423	85	0	\N
327033	1678	23040757329000	20818	10423	86	0	\N
327034	1678	23040757330000	20818	10423	87	0	\N
327035	1678	23040757331000	20818	10423	88	0	\N
327036	1678	23040757332000	20818	10423	89	0	\N
327037	1678	23040757333000	20818	10423	90	0	\N
327038	1678	23040757334000	20818	10423	91	0	\N
327039	1678	23040757335000	20818	10423	92	0	\N
327040	1678	23040757336000	20818	10423	93	0	\N
327041	1678	23040757337000	20818	10423	94	0	\N
327042	1678	23040757338000	20818	10423	95	0	\N
327043	1678	23040757339000	20818	10423	96	0	\N
327044	1678	23040757340000	20818	10423	98	0	\N
327045	1678	23040757341000	20818	10423	99	0	\N
327046	1678	23040757342000	20818	10423	100	0	\N
327047	1678	23040757343000	20818	10423	101	0	\N
327048	1678	23040757344000	20818	10423	102	0	\N
327049	1678	23040757345000	20818	10423	103	0	\N
327050	1678	23040757346000	20818	10423	104	0	\N
327051	1678	23040757347000	20818	10423	105	0	\N
327052	1678	23040757348000	20818	10423	106	0	\N
327053	1678	23040757349000	20818	10423	107	0	\N
327054	1678	23040757350000	20818	10423	108	0	\N
327055	1678	23040757351000	20818	10423	109	0	\N
327056	1678	23040757352000	20818	10423	110	0	\N
327057	1678	23040757353000	20818	10423	111	0	\N
327058	811	108427593503286	20818	10423	112	0	\N
327059	812	1192702487640140	20818	10423	113	0	\N
327060	823	1739885117760760	20818	10423	114	0	\N
327061	824	19138719592487700	20818	10423	115	0	\N
327062	2177	71944805349641	20818	10423	116	0	\N
327063	1981	101080000000	20818	10423	117	0	\N
327064	1981	101280000000	20818	10423	118	0	\N
327065	1874	15729000	20818	10423	119	0	\N
327066	1874	15730000	20818	10423	120	0	\N
327067	1874	15731000	20818	10423	121	0	\N
327068	2268	200000000	20818	10423	122	0	\N
327069	1874	15732000	20818	10423	123	0	\N
327070	1874	15733000	20818	10423	124	0	\N
327071	1874	15734000	20818	10423	125	0	\N
327076	1678	23040757355000	20822	10466	0	0	\N
327077	1874	15895000	20822	10466	1	0	\N
327078	1874	15896000	20823	10467	0	0	\N
327074	1678	23040757355000	20821	10466	0	0	0
327075	1874	15895000	20821	10466	1	0	2
327079	1678	23040757356000	20824	10467	0	0	0
327080	1874	15897000	20824	10467	1	0	2
327082	1678	23040757356000	20825	10467	0	0	\N
327083	1874	15896000	20825	10467	1	0	\N
327084	1678	23040757356000	20826	10467	0	0	\N
327085	1874	15897000	20826	10467	1	0	\N
327086	1874	15898000	20826	10467	2	0	\N
327094	1678	23040757359000	20830	10470	0	0	\N
327095	1874	15904000	20830	10470	1	0	\N
327096	1874	15905000	20830	10470	2	0	\N
327097	1678	23040757359000	20831	10470	0	0	\N
327098	1874	15904000	20831	10470	1	0	\N
327099	1874	15905000	20831	10470	2	0	\N
327100	1678	23040757359000	20832	10470	0	0	\N
327101	1874	15904000	20832	10470	1	0	\N
327102	1874	15905000	20832	10470	2	0	\N
327103	940	507428775000000	20833	10471	0	0	\N
327104	1678	23040757360000	20833	10471	1	0	\N
327110	1706	17490356600135	20836	10417	0	0	\N
327111	1355	1708676653253353	20836	10417	1	0	\N
327112	1109	908789804707202	20836	10417	2	0	\N
327113	1229	613178594344390	20836	10417	3	0	\N
327114	989	507139625446703	20836	10417	4	0	\N
327115	1981	100980000000	20836	10417	6	0	\N
327116	940	507428775000000	20836	10417	7	0	\N
327117	1131	910286565000000	20836	10417	8	0	\N
327118	1251	614188360000000	20836	10417	9	0	\N
327119	1011	507974815000000	20836	10417	10	0	\N
327120	865	400855996215417	20836	10417	11	0	\N
327121	867	2441303436168000	20836	10417	12	0	\N
327122	869	261078414520845	20836	10417	13	0	\N
327123	873	2441303436168000	20836	10417	14	0	\N
327124	875	213990794972583	20836	10417	15	0	\N
327125	883	90418645762500	20836	10417	16	0	\N
327126	887	269862585957154	20836	10417	17	0	\N
327127	889	226535176490249	20836	10417	18	0	\N
327128	891	497302551695750	20836	10417	19	0	\N
327129	897	65600535873885	20836	10417	20	0	\N
327130	899	39104255918990	20836	10417	21	0	\N
327131	451	66564722585011	20836	10417	22	0	\N
327132	487	66564722585011	20836	10417	23	0	\N
327133	744	2017112805578	20836	10417	24	0	\N
327134	988	507076931797664	20836	10417	25	0	\N
327135	1108	908677517146240	20836	10417	26	0	\N
327136	901	117544239492250	20836	10417	27	0	\N
327137	905	422707168941938	20836	10417	28	0	\N
327138	2177	71944805349641	20836	10417	29	0	\N
327139	873	2445664587151000	20836	10417	30	0	\N
327140	875	214373068700583	20836	10417	31	0	\N
327141	1228	613102827497120	20836	10417	32	0	\N
327142	1354	1708465542884770	20836	10417	33	0	\N
327143	1981	101080000000	20836	10417	34	0	\N
327144	1981	101280000000	20836	10417	35	0	\N
327145	1678	23040757361000	20837	10472	0	0	\N
327146	1874	15909000	20837	10472	1	0	\N
327152	1678	23040757362000	20839	10473	0	0	\N
327153	1060	909307465000000	20839	10473	1	0	\N
327154	1180	613528750000000	20839	10473	2	0	\N
327155	1874	15911000	20839	10473	3	0	\N
327156	1874	15912000	20839	10473	4	0	\N
327157	1306	1709649637751650	20840	10474	0	0	\N
327158	1678	23040757363000	20840	10474	1	0	\N
327159	1874	15914000	20840	10474	2	0	\N
327160	1306	1709649637751650	20841	10474	0	0	\N
327161	1678	23040757363000	20841	10474	1	0	\N
327162	1874	15914000	20841	10474	2	0	\N
327169	1678	23040757365000	20845	10476	0	0	\N
327170	1874	15918000	20845	10476	1	0	\N
327171	1678	23040757365000	20846	10476	0	0	\N
327172	1874	15918000	20846	10476	1	0	\N
327177	1060	909307465000000	20848	10418	0	0	\N
327178	1180	613528750000000	20848	10418	1	0	\N
327179	1306	1709649637751650	20848	10418	2	0	\N
327180	596	68338432000000	20848	10418	3	0	\N
327189	1678	23040757369000	20851	10479	0	0	\N
327190	1874	15926000	20851	10479	2	0	\N
327191	1874	15928000	20851	10479	3	0	\N
327196	994	507243255271745	20853	10481	0	0	\N
327197	1678	23040757372000	20853	10481	1	0	\N
327198	1678	23040757373000	20853	10481	2	0	\N
327199	1678	23040757374000	20853	10481	3	0	\N
327200	1678	23040757375000	20853	10481	4	0	\N
327201	1874	15933000	20853	10481	5	0	\N
327202	1874	15935000	20853	10481	6	0	\N
327203	1874	15937000	20853	10481	7	0	\N
327204	1874	15939000	20853	10481	8	0	\N
327205	1874	15941000	20853	10481	9	0	\N
327216	1114	908975568495245	20855	10482	0	0	\N
327088	1874	15900000	20827	10468	1	0	2
327089	1678	23040757358000	20828	10469	0	0	0
327090	1874	15902000	20828	10469	1	0	2
327091	1678	23040757359000	20829	10470	0	0	0
327092	1874	15904000	20829	10470	1	0	2
327105	940	507428775000000	20834	10471	0	0	0
327106	1678	23040757360000	20834	10471	1	0	0
327107	1874	15907000	20834	10471	3	0	2
327108	1678	23040757361000	20835	10472	0	0	0
327109	1874	15909000	20835	10472	1	0	2
327148	1060	909307465000000	20838	10473	1	0	0
327149	1180	613528750000000	20838	10473	2	0	0
327150	1874	15911000	20838	10473	3	0	2
327151	1874	15912000	20838	10473	4	0	2
327164	1678	23040757363000	20842	10474	1	0	0
327165	1874	15914000	20842	10474	2	0	2
327166	1678	23040757364000	20843	10475	0	0	0
327167	1874	15916000	20843	10475	1	0	2
327168	1678	23040757365000	20844	10476	0	0	0
327174	1874	15917000	20847	10477	1	0	2
327175	1874	15919000	20847	10477	2	0	2
327176	1874	15921000	20847	10477	3	0	2
327181	596	68338432000000	20849	10478	0	0	8
327182	1678	23040757367000	20849	10478	1	0	0
327184	1874	15923000	20849	10478	3	0	2
327185	1874	15925000	20849	10478	4	0	2
327186	1678	23040757369000	20850	10479	0	0	0
327187	1874	15926000	20850	10479	2	0	2
327192	1678	23040757370000	20852	10480	0	0	0
327193	1678	23040757371000	20852	10480	1	0	0
327194	1874	15930000	20852	10480	2	0	2
327195	1874	15932000	20852	10480	3	0	2
327206	994	507243255271745	20854	10481	0	0	0
327208	1678	23040757373000	20854	10481	2	0	0
327209	1678	23040757374000	20854	10481	3	0	0
327210	1678	23040757375000	20854	10481	4	0	0
327211	1874	15933000	20854	10481	5	0	2
327212	1874	15935000	20854	10481	6	0	2
327214	1874	15939000	20854	10481	8	0	2
327215	1874	15941000	20854	10481	9	0	2
327217	1678	23040757376000	20855	10482	1	0	\N
327218	1874	15942000	20855	10482	2	0	\N
327219	1874	15944000	20855	10482	3	0	\N
327224	1114	908975568495245	20857	10482	0	0	\N
327225	1678	23040757376000	20857	10482	1	0	\N
327226	1874	15942000	20857	10482	2	0	\N
327227	1874	15944000	20857	10482	3	0	\N
327255	1360	1709025928146958	20863	10487	0	0	\N
327256	1678	23040757384000	20863	10487	1	0	\N
327257	1678	23040757385000	20863	10487	2	0	\N
327258	1874	15962000	20863	10487	3	0	\N
327259	1874	15964000	20863	10487	4	0	\N
327267	1678	23040757388000	20866	10489	0	0	\N
327268	1874	15971000	20866	10489	1	0	\N
327269	994	507243255271745	20867	10461	0	0	\N
327270	1114	908975568495245	20867	10461	1	0	\N
327271	1234	613303927936822	20867	10461	2	0	\N
327272	1360	1703067102686958	20867	10461	3	0	\N
327273	1360	1709025928146958	20867	10461	4	0	\N
327274	940	507428775000000	20867	10461	5	0	\N
327275	1060	909307465000000	20867	10461	6	0	\N
327276	1180	613528750000000	20867	10461	7	0	\N
327277	1306	1709649637751650	20867	10461	8	0	\N
327278	596	68338432000000	20867	10461	9	0	\N
327279	1678	23040757350000	20867	10461	10	0	\N
327280	1678	23040757351000	20867	10461	11	0	\N
327281	1678	23040757352000	20867	10461	12	0	\N
327282	1678	23040757353000	20867	10461	13	0	\N
327283	1678	23040757354000	20867	10461	14	0	\N
327284	1678	23040757355000	20867	10461	15	0	\N
327285	1678	23040757356000	20867	10461	16	0	\N
327286	1678	23040757357000	20867	10461	17	0	\N
327287	1678	23040757358000	20867	10461	18	0	\N
327288	1678	23040757359000	20867	10461	19	0	\N
327289	1678	23040757360000	20867	10461	20	0	\N
327290	1678	23040757361000	20867	10461	21	0	\N
327291	1678	23040757362000	20867	10461	22	0	\N
327292	1678	23040757363000	20867	10461	23	0	\N
327293	1678	23040757364000	20867	10461	24	0	\N
327294	1678	23040757365000	20867	10461	25	0	\N
327295	1678	23040757366000	20867	10461	26	0	\N
327296	1678	23040757367000	20867	10461	27	0	\N
327297	1678	23040757368000	20867	10461	28	0	\N
327298	1678	23040757369000	20867	10461	29	0	\N
327299	1678	23040757370000	20867	10461	30	0	\N
327300	1678	23040757371000	20867	10461	31	0	\N
327301	1678	23040757372000	20867	10461	33	0	\N
327302	1678	23040757373000	20867	10461	34	0	\N
327303	1678	23040757374000	20867	10461	35	0	\N
327304	1678	23040757375000	20867	10461	36	0	\N
327305	1678	23040757376000	20867	10461	37	0	\N
327306	1678	23040757377000	20867	10461	38	0	\N
327307	1678	23040757378000	20867	10461	39	0	\N
327308	1678	23040757379000	20867	10461	40	0	\N
327309	1678	23040757380000	20867	10461	41	0	\N
327310	1678	23040757381000	20867	10461	42	0	\N
327311	1678	23040757382000	20867	10461	43	0	\N
327312	1678	23040757383000	20867	10461	44	0	\N
327313	1678	23040757384000	20867	10461	45	0	\N
327314	1678	23040757385000	20867	10461	46	0	\N
327315	1678	23040757386000	20867	10461	47	0	\N
327316	1678	23040757387000	20867	10461	48	0	\N
327317	1678	23040757388000	20867	10461	49	0	\N
327318	1874	15881000	20867	10461	51	0	\N
327319	1874	15883000	20867	10461	52	0	\N
327320	1381	1710569952951650	20867	10461	53	0	\N
327321	1135	909796784740000	20867	10461	54	0	\N
327322	1874	15885000	20867	10461	55	0	\N
327323	1874	15887000	20867	10461	56	0	\N
327324	1255	613858019650000	20867	10461	57	0	\N
327325	1015	507701526080000	20867	10461	58	0	\N
327326	1874	15888000	20867	10461	59	0	\N
327327	1874	15889000	20867	10461	60	0	\N
327328	1874	15890000	20867	10461	61	0	\N
327329	1874	15891000	20867	10461	62	0	\N
327330	1874	15892000	20867	10461	63	0	\N
327331	1874	15893000	20867	10461	64	0	\N
327332	1874	15894000	20867	10461	65	0	\N
327333	1874	15895000	20867	10461	66	0	\N
327334	1874	15896000	20867	10461	67	0	\N
327335	1874	15898000	20867	10461	68	0	\N
327336	1874	15900000	20867	10461	69	0	\N
327337	1874	15902000	20867	10461	70	0	\N
327338	1874	15904000	20867	10461	71	0	\N
327339	1874	15906000	20867	10461	72	0	\N
327340	1874	15907000	20867	10461	73	0	\N
327341	1874	15909000	20867	10461	74	0	\N
327342	1874	15911000	20867	10461	75	0	\N
327343	1874	15913000	20867	10461	76	0	\N
327344	1874	15915000	20867	10461	77	0	\N
327345	1874	15917000	20867	10461	78	0	\N
327346	1874	15919000	20867	10461	79	0	\N
327347	1874	15921000	20867	10461	80	0	\N
327348	1874	15923000	20867	10461	81	0	\N
327349	1874	15925000	20867	10461	82	0	\N
327350	1874	15927000	20867	10461	83	0	\N
327351	1874	15929000	20867	10461	84	0	\N
327352	1874	15931000	20867	10461	85	0	\N
327222	1874	15942000	20856	10482	2	0	2
327223	1874	15944000	20856	10482	3	0	2
327228	1678	23040757377000	20858	10483	0	0	0
327229	1874	15946000	20858	10483	1	0	2
327230	1234	613303927936822	20859	10484	0	0	0
327232	1678	23040757378000	20859	10484	2	0	0
327233	1678	23040757379000	20859	10484	3	0	0
327234	1678	23040757380000	20859	10484	4	0	0
327235	1678	23040757381000	20859	10484	5	0	0
327236	1874	15947000	20859	10484	6	0	2
327238	1135	909796784740000	20859	10484	8	0	0
327239	1255	613858019650000	20859	10484	9	0	0
327240	1015	507701526080000	20859	10484	10	0	0
327241	1874	15949000	20859	10484	11	0	2
327243	1874	15953000	20859	10484	13	0	2
327244	1874	15955000	20859	10484	14	0	2
327245	1678	23040757382000	20860	10485	0	0	0
327246	1874	15957000	20860	10485	1	0	2
327247	1874	15958000	20860	10485	2	0	2
327249	1874	15960000	20861	10486	2	0	2
327250	1360	1709025928146958	20862	10487	0	0	0
327251	1678	23040757384000	20862	10487	1	0	0
327252	1678	23040757385000	20862	10487	2	0	0
327253	1874	15962000	20862	10487	3	0	2
327260	1678	23040757386000	20864	10488	0	0	0
327261	1678	23040757387000	20864	10488	1	0	0
327262	1874	15966000	20864	10488	2	0	2
327263	1874	15968000	20864	10488	3	0	2
327265	1678	23040757388000	20865	10489	0	0	0
327266	1874	15971000	20865	10489	1	0	2
327353	1874	15933000	20867	10461	86	0	\N
327354	1874	15935000	20867	10461	88	0	\N
327355	1874	15937000	20867	10461	89	0	\N
327356	1874	15939000	20867	10461	90	0	\N
327357	1874	15941000	20867	10461	91	0	\N
327358	1874	15943000	20867	10461	92	0	\N
327359	1874	15945000	20867	10461	93	0	\N
327360	1874	15947000	20867	10461	94	0	\N
327361	1874	15949000	20867	10461	95	0	\N
327362	1874	15951000	20867	10461	96	0	\N
327363	1874	15953000	20867	10461	97	0	\N
327364	1874	15955000	20867	10461	98	0	\N
327365	1874	15957000	20867	10461	99	0	\N
327366	1874	15959000	20867	10461	100	0	\N
327367	1874	15961000	20867	10461	101	0	\N
327368	1874	15963000	20867	10461	102	0	\N
327369	1874	15965000	20867	10461	103	0	\N
327370	1874	15967000	20867	10461	104	0	\N
327371	1874	15969000	20867	10461	105	0	\N
327372	1874	15971000	20867	10461	106	0	\N
327373	1678	23040757389000	20868	10490	0	0	\N
327374	1874	15972000	20868	10490	1	0	\N
327375	1874	15974000	20868	10490	2	0	\N
327376	1678	23040757389000	20869	10490	0	0	\N
327377	1874	15972000	20869	10490	1	0	\N
327378	1874	15974000	20869	10490	2	0	\N
327386	1678	23040757392000	20872	10492	0	0	\N
327387	1874	15980000	20872	10492	1	0	\N
327393	1678	23040757394000	20875	10494	0	0	\N
327394	1678	23040757395000	20875	10494	1	0	\N
327395	1874	15985000	20875	10494	2	0	\N
327396	1874	15987000	20875	10494	3	0	\N
327401	994	507243255271745	20877	10470	0	0	\N
327402	1114	908975568495245	20877	10470	1	0	\N
327403	1234	613303927936822	20877	10470	2	0	\N
327404	1360	1703067102686958	20877	10470	3	0	\N
327405	1360	1709025928146958	20877	10470	4	0	\N
327406	940	507428775000000	20877	10470	5	0	\N
327407	1060	909307465000000	20877	10470	6	0	\N
327408	1180	613528750000000	20877	10470	7	0	\N
327409	1306	1709649637751650	20877	10470	8	0	\N
327410	596	68338432000000	20877	10470	9	0	\N
327411	1678	23040757359000	20877	10470	10	0	\N
327412	1678	23040757360000	20877	10470	11	0	\N
327413	1678	23040757361000	20877	10470	12	0	\N
327414	1678	23040757362000	20877	10470	13	0	\N
327415	1678	23040757363000	20877	10470	14	0	\N
327416	1678	23040757364000	20877	10470	15	0	\N
327417	1678	23040757365000	20877	10470	16	0	\N
327418	1678	23040757366000	20877	10470	17	0	\N
327419	1678	23040757367000	20877	10470	18	0	\N
327420	1678	23040757368000	20877	10470	19	0	\N
327421	1678	23040757369000	20877	10470	20	0	\N
327422	1678	23040757370000	20877	10470	21	0	\N
327423	1678	23040757371000	20877	10470	22	0	\N
327424	1678	23040757372000	20877	10470	24	0	\N
327425	1678	23040757373000	20877	10470	25	0	\N
327426	1678	23040757374000	20877	10470	26	0	\N
327427	1678	23040757375000	20877	10470	27	0	\N
327428	1678	23040757376000	20877	10470	28	0	\N
327429	1678	23040757377000	20877	10470	29	0	\N
327430	1678	23040757378000	20877	10470	30	0	\N
327431	1678	23040757379000	20877	10470	31	0	\N
327432	1678	23040757380000	20877	10470	32	0	\N
327433	1678	23040757381000	20877	10470	33	0	\N
327434	1678	23040757382000	20877	10470	34	0	\N
327435	1678	23040757383000	20877	10470	35	0	\N
327436	1678	23040757384000	20877	10470	36	0	\N
327437	1678	23040757385000	20877	10470	37	0	\N
327438	1678	23040757386000	20877	10470	38	0	\N
327439	1678	23040757387000	20877	10470	39	0	\N
327440	1678	23040757388000	20877	10470	40	0	\N
327441	1678	23040757389000	20877	10470	41	0	\N
327442	1678	23040757390000	20877	10470	42	0	\N
327443	1678	23040757391000	20877	10470	43	0	\N
327444	1678	23040757392000	20877	10470	44	0	\N
327445	1678	23040757393000	20877	10470	45	0	\N
327446	1678	23040757394000	20877	10470	46	0	\N
327447	1678	23040757395000	20877	10470	47	0	\N
327448	1874	15904000	20877	10470	50	0	\N
327449	1874	15906000	20877	10470	51	0	\N
327450	1874	15907000	20877	10470	52	0	\N
327451	1874	15908000	20877	10470	53	0	\N
327452	1874	15909000	20877	10470	54	0	\N
327453	1874	15910000	20877	10470	55	0	\N
327454	1874	15911000	20877	10470	56	0	\N
327455	1874	15912000	20877	10470	57	0	\N
327456	1874	15913000	20877	10470	58	0	\N
327457	1381	1710569952951650	20877	10470	59	0	\N
327458	1135	909796784740000	20877	10470	60	0	\N
327459	1255	613858019650000	20877	10470	61	0	\N
327460	1015	507701526080000	20877	10470	62	0	\N
327461	1874	15914000	20877	10470	63	0	\N
327462	1874	15916000	20877	10470	64	0	\N
327463	1874	15918000	20877	10470	65	0	\N
327464	1874	15919000	20877	10470	66	0	\N
327465	1874	15920000	20877	10470	67	0	\N
327466	1874	15921000	20877	10470	68	0	\N
327467	1874	15923000	20877	10470	69	0	\N
327468	1874	15925000	20877	10470	70	0	\N
327469	1874	15927000	20877	10470	71	0	\N
327470	1874	15929000	20877	10470	72	0	\N
327471	1874	15931000	20877	10470	73	0	\N
327472	1874	15933000	20877	10470	74	0	\N
327473	1874	15935000	20877	10470	75	0	\N
327474	1874	15937000	20877	10470	76	0	\N
327475	1874	15939000	20877	10470	77	0	\N
327476	1874	15941000	20877	10470	78	0	\N
327477	1874	15943000	20877	10470	79	0	\N
327478	1874	15945000	20877	10470	80	0	\N
327479	1874	15947000	20877	10470	81	0	\N
327480	1874	15949000	20877	10470	82	0	\N
327481	1874	15951000	20877	10470	83	0	\N
327482	1874	15953000	20877	10470	84	0	\N
327483	1874	15955000	20877	10470	85	0	\N
327484	1874	15957000	20877	10470	86	0	\N
327485	1874	15959000	20877	10470	87	0	\N
327486	1874	15961000	20877	10470	88	0	\N
327487	1874	15963000	20877	10470	89	0	\N
327488	1874	15965000	20877	10470	90	0	\N
327381	1874	15974000	20870	10490	2	0	2
327382	1678	23040757390000	20871	10491	0	0	0
327383	1678	23040757391000	20871	10491	1	0	0
327384	1874	15976000	20871	10491	2	0	2
327385	1874	15978000	20871	10491	3	0	2
327389	1874	15980000	20873	10492	1	0	2
327390	1678	23040757393000	20874	10493	0	0	0
327391	1874	15981000	20874	10493	1	0	2
327392	1874	15983000	20874	10493	2	0	2
327397	1678	23040757394000	20876	10494	0	0	0
327399	1874	15985000	20876	10494	2	0	2
327400	1874	15987000	20876	10494	3	0	2
327489	1874	15967000	20877	10470	91	0	\N
327490	1874	15969000	20877	10470	92	0	\N
327491	1874	15971000	20877	10470	93	0	\N
327492	1874	15973000	20877	10470	94	0	\N
327493	1874	15975000	20877	10470	95	0	\N
327494	1874	15977000	20877	10470	96	0	\N
327495	1874	15979000	20877	10470	97	0	\N
327496	1874	15981000	20877	10470	98	0	\N
327497	1874	15983000	20877	10470	99	0	\N
327498	1874	15985000	20877	10470	100	0	\N
327499	1874	15987000	20877	10470	101	0	\N
327505	994	507243255271745	20880	10475	0	0	\N
327506	1114	908975568495245	20880	10475	1	0	\N
327507	1234	613303927936822	20880	10475	2	0	\N
327508	1360	1703067102686958	20880	10475	3	0	\N
327509	1360	1709025928146958	20880	10475	4	0	\N
327510	596	68338432000000	20880	10475	5	0	\N
327511	1678	23040757364000	20880	10475	6	0	\N
327512	1678	23040757365000	20880	10475	7	0	\N
327513	1678	23040757366000	20880	10475	8	0	\N
327514	1678	23040757367000	20880	10475	9	0	\N
327515	1678	23040757368000	20880	10475	10	0	\N
327516	1678	23040757369000	20880	10475	11	0	\N
327517	1678	23040757370000	20880	10475	12	0	\N
327518	1678	23040757371000	20880	10475	13	0	\N
327519	1678	23040757372000	20880	10475	15	0	\N
327520	1678	23040757373000	20880	10475	16	0	\N
327521	1678	23040757374000	20880	10475	17	0	\N
327522	1678	23040757375000	20880	10475	18	0	\N
327523	1678	23040757376000	20880	10475	19	0	\N
327524	1678	23040757377000	20880	10475	20	0	\N
327525	1678	23040757378000	20880	10475	22	0	\N
327526	1678	23040757379000	20880	10475	23	0	\N
327527	1678	23040757380000	20880	10475	24	0	\N
327528	1678	23040757381000	20880	10475	25	0	\N
327529	1678	23040757382000	20880	10475	26	0	\N
327530	1678	23040757383000	20880	10475	27	0	\N
327531	1678	23040757384000	20880	10475	28	0	\N
327532	1678	23040757385000	20880	10475	29	0	\N
327533	1678	23040757386000	20880	10475	30	0	\N
327534	1678	23040757387000	20880	10475	31	0	\N
327535	1678	23040757388000	20880	10475	32	0	\N
327536	1678	23040757389000	20880	10475	33	0	\N
327537	1678	23040757390000	20880	10475	34	0	\N
327538	1678	23040757391000	20880	10475	35	0	\N
327539	1678	23040757392000	20880	10475	36	0	\N
327540	1678	23040757393000	20880	10475	37	0	\N
327541	1678	23040757394000	20880	10475	38	0	\N
327542	1678	23040757395000	20880	10475	39	0	\N
327543	1678	23040757396000	20880	10475	40	0	\N
327544	1678	23040757397000	20880	10475	41	0	\N
327545	1874	15916000	20880	10475	42	0	\N
327546	1874	15917000	20880	10475	43	0	\N
327547	1874	15918000	20880	10475	44	0	\N
327548	1874	15919000	20880	10475	45	0	\N
327549	1874	15920000	20880	10475	46	0	\N
327550	1874	15921000	20880	10475	47	0	\N
327551	1381	1710569952951650	20880	10475	48	0	\N
327552	1135	909796784740000	20880	10475	49	0	\N
327553	1255	613858019650000	20880	10475	50	0	\N
327554	1015	507701526080000	20880	10475	51	0	\N
327555	1874	15922000	20880	10475	52	0	\N
327556	1874	15924000	20880	10475	53	0	\N
327557	1874	15926000	20880	10475	54	0	\N
327558	1874	15928000	20880	10475	55	0	\N
327559	1874	15930000	20880	10475	56	0	\N
327560	1874	15932000	20880	10475	57	0	\N
327561	1874	15933000	20880	10475	58	0	\N
327562	1874	15934000	20880	10475	59	0	\N
327563	1874	15935000	20880	10475	60	0	\N
327564	1874	15936000	20880	10475	61	0	\N
327565	1874	15938000	20880	10475	62	0	\N
327566	1874	15940000	20880	10475	63	0	\N
327567	1874	15942000	20880	10475	64	0	\N
327568	1874	15944000	20880	10475	65	0	\N
327569	1874	15946000	20880	10475	66	0	\N
327570	1874	15948000	20880	10475	67	0	\N
327571	1874	15950000	20880	10475	68	0	\N
327572	1874	15952000	20880	10475	69	0	\N
327573	1874	15954000	20880	10475	70	0	\N
327574	1874	15956000	20880	10475	71	0	\N
327575	1874	15958000	20880	10475	72	0	\N
327576	1874	15960000	20880	10475	73	0	\N
327577	1874	15962000	20880	10475	74	0	\N
327578	1874	15964000	20880	10475	75	0	\N
327579	1874	15966000	20880	10475	76	0	\N
327580	1874	15968000	20880	10475	77	0	\N
327581	1874	15970000	20880	10475	78	0	\N
327582	1874	15972000	20880	10475	79	0	\N
327583	1874	15974000	20880	10475	80	0	\N
327584	1874	15976000	20880	10475	81	0	\N
327585	1874	15978000	20880	10475	82	0	\N
327586	1874	15980000	20880	10475	83	0	\N
327587	1874	15982000	20880	10475	84	0	\N
327588	1874	15984000	20880	10475	85	0	\N
327589	1874	15986000	20880	10475	86	0	\N
327590	1874	15988000	20880	10475	87	0	\N
327591	1874	15990000	20880	10475	88	0	\N
327592	1874	15992000	20880	10475	89	0	\N
327594	1678	23040757399000	20882	10498	0	0	\N
327595	58	70307296999641	20882	10498	1	0	\N
327596	1874	15994000	20882	10498	2	0	\N
327597	1874	15995000	20882	10498	3	0	\N
327598	1678	23040757399000	20883	10498	0	0	\N
327599	58	70307296999641	20883	10498	1	0	\N
327600	1874	15994000	20883	10498	2	0	\N
327601	1874	15995000	20883	10498	3	0	\N
327608	1678	23040757400000	20887	10499	0	0	\N
327609	1874	15997000	20887	10499	1	0	\N
327612	1678	23040757401000	20889	10500	0	0	\N
327613	1874	15999000	20889	10500	1	0	\N
327614	1678	23040757401000	20891	10500	0	0	\N
327615	1874	15999000	20891	10500	1	0	\N
327618	1678	23040757403000	20893	10502	0	0	\N
327619	1874	16003000	20893	10502	1	0	\N
327620	1874	16004000	20893	10502	2	0	\N
327502	1874	15990000	20878	10495	2	0	2
327503	1678	23040757397000	20879	10496	0	0	0
327504	1874	15992000	20879	10496	1	0	2
327593	1678	23040757398000	20881	10497	0	0	0
327602	1678	23040757399000	20884	10498	0	0	0
327604	1874	15994000	20884	10498	2	0	2
327605	1874	15995000	20884	10498	3	0	2
327606	1678	23040757400000	20886	10499	0	0	0
327607	1874	15997000	20886	10499	1	0	2
327610	1678	23040757401000	20888	10500	0	0	0
327616	1678	23040757402000	20892	10501	0	0	0
327617	1874	16001000	20892	10501	1	0	2
327621	1678	23040757403000	20894	10502	0	0	0
327622	1874	16003000	20894	10502	1	0	2
327624	1678	23040757404000	20895	10503	0	0	0
327628	1678	23040757406000	20897	10505	0	0	\N
327629	1874	16010000	20897	10505	1	0	\N
327630	1874	16011000	20897	10505	2	0	\N
327634	1678	23040757407000	20899	10506	0	0	\N
327635	1874	16013000	20899	10506	1	0	\N
327638	1678	23040757407000	20901	10506	0	0	\N
327639	1874	16013000	20901	10506	1	0	\N
327640	1678	23040757407000	20902	10506	0	0	\N
327641	1874	16013000	20902	10506	1	0	\N
327642	1678	23040757407000	20903	10506	0	0	\N
327643	1874	16013000	20903	10506	1	0	\N
327646	1678	23040757409000	20905	10508	0	0	\N
327647	1678	23040757410000	20905	10508	1	0	\N
327648	1874	16017000	20905	10508	2	0	\N
327649	1874	16018000	20905	10508	3	0	\N
327650	1874	16020000	20905	10508	4	0	\N
327656	1678	23040757409000	20907	10508	0	0	\N
327657	1678	23040757410000	20907	10508	1	0	\N
327658	1874	16017000	20907	10508	2	0	\N
327659	1874	16018000	20907	10508	3	0	\N
327660	1874	16020000	20907	10508	4	0	\N
327679	994	507243255271745	20912	10467	0	0	\N
327680	1114	908975568495245	20912	10467	1	0	\N
327681	1234	613303927936822	20912	10467	2	0	\N
327682	1360	1703067102686958	20912	10467	3	0	\N
327683	1360	1709025928146958	20912	10467	4	0	\N
327684	1678	23040757356000	20912	10467	5	0	\N
327685	940	507428775000000	20912	10467	6	0	\N
327686	1060	909307465000000	20912	10467	7	0	\N
327687	1180	613528750000000	20912	10467	8	0	\N
327688	1306	1709649637751650	20912	10467	9	0	\N
327689	596	68338432000000	20912	10467	10	0	\N
327690	1678	23040757357000	20912	10467	11	0	\N
327691	1678	23040757358000	20912	10467	12	0	\N
327692	1678	23040757359000	20912	10467	13	0	\N
327693	1678	23040757360000	20912	10467	14	0	\N
327694	1678	23040757361000	20912	10467	15	0	\N
327695	1678	23040757362000	20912	10467	16	0	\N
327696	1678	23040757363000	20912	10467	17	0	\N
327697	1678	23040757364000	20912	10467	18	0	\N
327698	1678	23040757365000	20912	10467	19	0	\N
327699	1678	23040757366000	20912	10467	20	0	\N
327700	1678	23040757367000	20912	10467	21	0	\N
327701	1678	23040757368000	20912	10467	22	0	\N
327702	1678	23040757369000	20912	10467	23	0	\N
327703	1678	23040757370000	20912	10467	24	0	\N
327704	1678	23040757371000	20912	10467	25	0	\N
327705	58	70307296999641	20912	10467	26	0	\N
327706	1678	23040757372000	20912	10467	28	0	\N
327707	1678	23040757373000	20912	10467	29	0	\N
327708	1678	23040757374000	20912	10467	30	0	\N
327709	1678	23040757375000	20912	10467	31	0	\N
327710	1678	23040757376000	20912	10467	32	0	\N
327711	1678	23040757377000	20912	10467	33	0	\N
327712	1678	23040757378000	20912	10467	34	0	\N
327713	1678	23040757379000	20912	10467	35	0	\N
327714	1678	23040757380000	20912	10467	36	0	\N
327715	1678	23040757381000	20912	10467	37	0	\N
327716	1678	23040757382000	20912	10467	38	0	\N
327717	1678	23040757383000	20912	10467	39	0	\N
327718	1678	23040757384000	20912	10467	40	0	\N
327719	1678	23040757385000	20912	10467	41	0	\N
327720	1678	23040757386000	20912	10467	42	0	\N
327721	1678	23040757387000	20912	10467	43	0	\N
327722	1678	23040757388000	20912	10467	44	0	\N
327723	1678	23040757389000	20912	10467	45	0	\N
327724	1678	23040757390000	20912	10467	46	0	\N
327725	1678	23040757391000	20912	10467	47	0	\N
327726	1678	23040757392000	20912	10467	48	0	\N
327727	1678	23040757393000	20912	10467	49	0	\N
327728	1678	23040757394000	20912	10467	50	0	\N
327729	1678	23040757395000	20912	10467	51	0	\N
327730	1678	23040757396000	20912	10467	52	0	\N
327731	1678	23040757397000	20912	10467	53	0	\N
327732	1678	23040757398000	20912	10467	54	0	\N
327733	1678	23040757399000	20912	10467	55	0	\N
327734	1678	23040757400000	20912	10467	56	0	\N
327735	1678	23040757401000	20912	10467	57	0	\N
327736	1678	23040757402000	20912	10467	58	0	\N
327737	1678	23040757403000	20912	10467	59	0	\N
327738	1678	23040757404000	20912	10467	60	0	\N
327739	1678	23040757405000	20912	10467	62	0	\N
327740	1678	23040757406000	20912	10467	63	0	\N
327741	1678	23040757407000	20912	10467	64	0	\N
327742	1678	23040757408000	20912	10467	65	0	\N
327743	1678	23040757409000	20912	10467	66	0	\N
327744	1678	23040757410000	20912	10467	67	0	\N
327745	1678	23040757411000	20912	10467	68	0	\N
327746	1678	23040757412000	20912	10467	69	0	\N
327747	1678	23040757413000	20912	10467	70	0	\N
327748	1678	23040757414000	20912	10467	71	0	\N
327749	1678	23040757415000	20912	10467	72	0	\N
327750	1678	23040757416000	20912	10467	73	0	\N
327751	1678	23040757417000	20912	10467	74	0	\N
327752	1678	23040757418000	20912	10467	75	0	\N
327753	1381	1710569952951650	20912	10467	77	0	\N
327754	1135	909796784740000	20912	10467	78	0	\N
327755	1874	15897000	20912	10467	79	0	\N
327756	1255	613858019650000	20912	10467	80	0	\N
327757	1015	507701526080000	20912	10467	81	0	\N
327758	1874	15898000	20912	10467	82	0	\N
327759	1874	15899000	20912	10467	83	0	\N
327760	1874	15900000	20912	10467	84	0	\N
327627	1874	16008000	20896	10504	1	0	2
327631	1678	23040757406000	20898	10505	0	0	0
327632	1874	16010000	20898	10505	1	0	2
327633	1874	16011000	20898	10505	2	0	2
327636	1678	23040757407000	20900	10506	0	0	0
327644	1678	23040757408000	20904	10507	0	0	0
327645	1874	16015000	20904	10507	1	0	2
327651	1678	23040757409000	20906	10508	0	0	0
327652	1678	23040757410000	20906	10508	1	0	0
327653	1874	16017000	20906	10508	2	0	2
327655	1874	16020000	20906	10508	4	0	2
327661	1678	23040757411000	20908	10509	0	0	0
327662	1874	16022000	20908	10509	1	0	2
327663	1678	23040757412000	20909	10510	0	0	0
327665	1678	23040757414000	20909	10510	2	0	0
327666	1874	16024000	20909	10510	3	0	2
327667	1874	16025000	20909	10510	4	0	2
327668	1874	16027000	20909	10510	5	0	2
327669	1874	16029000	20909	10510	6	0	2
327671	1678	23040757416000	20910	10511	1	0	0
327672	1678	23040757417000	20910	10511	2	0	0
327673	1874	16031000	20910	10511	3	0	2
327674	1874	16032000	20910	10511	4	0	2
327675	1874	16034000	20910	10511	5	0	2
327677	1678	23040757418000	20911	10512	0	0	0
327678	1874	16038000	20911	10512	1	0	2
327761	1874	15901000	20912	10467	85	0	\N
327762	1874	15902000	20912	10467	86	0	\N
327763	1874	15903000	20912	10467	87	0	\N
327764	1874	15904000	20912	10467	88	0	\N
327765	1874	15905000	20912	10467	89	0	\N
327766	1874	15906000	20912	10467	90	0	\N
327767	1874	15907000	20912	10467	91	0	\N
327768	1874	15908000	20912	10467	92	0	\N
327769	1874	15909000	20912	10467	93	0	\N
327770	1874	15910000	20912	10467	94	0	\N
327771	1874	15911000	20912	10467	95	0	\N
327772	1874	15912000	20912	10467	96	0	\N
327773	1874	15913000	20912	10467	97	0	\N
327774	1874	15914000	20912	10467	98	0	\N
327775	1874	15915000	20912	10467	99	0	\N
327776	1874	15916000	20912	10467	100	0	\N
327777	1874	15918000	20912	10467	101	0	\N
327778	1874	15920000	20912	10467	102	0	\N
327779	1874	15922000	20912	10467	103	0	\N
327780	1874	15924000	20912	10467	104	0	\N
327781	1874	15926000	20912	10467	105	0	\N
327782	1874	15928000	20912	10467	106	0	\N
327783	1874	15930000	20912	10467	107	0	\N
327784	1874	15932000	20912	10467	108	0	\N
327785	1874	15934000	20912	10467	109	0	\N
327786	1874	15936000	20912	10467	110	0	\N
327787	1874	15938000	20912	10467	111	0	\N
327788	1874	15940000	20912	10467	112	0	\N
327789	1874	15942000	20912	10467	113	0	\N
327790	1874	15944000	20912	10467	114	0	\N
327791	1874	15946000	20912	10467	115	0	\N
327792	1874	15948000	20912	10467	116	0	\N
327793	1874	15950000	20912	10467	117	0	\N
327794	1874	15952000	20912	10467	118	0	\N
327795	1874	15954000	20912	10467	119	0	\N
327796	1874	15956000	20912	10467	120	0	\N
327797	1874	15958000	20912	10467	121	0	\N
327798	1874	15960000	20912	10467	122	0	\N
327799	1874	15962000	20912	10467	123	0	\N
327800	1874	15964000	20912	10467	124	0	\N
327801	1874	15966000	20912	10467	125	0	\N
327802	2269	2000000000	20913	10513	0	0	\N
327803	1678	23040757419000	20913	10513	1	0	\N
327804	1874	16039000	20913	10513	2	0	\N
327805	1874	16041000	20913	10513	3	0	\N
327810	2269	2000000000	20915	10513	0	0	\N
327811	1678	23040757419000	20915	10513	1	0	\N
327812	1874	16039000	20915	10513	2	0	\N
327813	1874	16041000	20915	10513	3	0	\N
327814	1678	23040757420000	20916	10514	0	0	\N
327815	1678	23040757421000	20916	10514	1	0	\N
327816	2269	649000000000	20916	10514	2	0	\N
327817	1874	16043000	20916	10514	3	0	\N
327818	1874	16045000	20916	10514	4	0	\N
327826	1678	23040757422000	20919	10515	0	0	\N
327827	1874	16047000	20919	10515	1	0	\N
327834	1678	23040757424000	20922	10517	0	0	\N
327835	1874	16052000	20922	10517	1	0	\N
327849	1678	23040757428000	20927	10521	0	0	\N
327850	1874	16061000	20927	10521	1	0	\N
327856	1678	23040757431000	20930	10524	0	0	\N
327857	1678	23040757432000	20930	10524	1	0	\N
327858	1678	23040757433000	20930	10524	2	0	\N
327859	1483	10000000	20930	10524	3	0	\N
327860	1874	16068000	20930	10524	4	0	\N
327861	1874	16070000	20930	10524	5	0	\N
327862	1874	16072000	20930	10524	7	0	\N
327863	1874	16073000	20930	10524	8	0	\N
327874	1678	23040757434000	20933	10525	0	0	\N
327875	1874	16075000	20933	10525	1	0	\N
327885	1338	1705962637751650	20935	10526	0	0	\N
327886	1092	907346465000000	20935	10526	1	0	\N
327887	1212	612204750000000	20935	10526	2	0	\N
327888	972	506334775000000	20935	10526	3	0	\N
327889	1678	23040757435000	20935	10526	4	0	\N
327890	1678	23040757436000	20935	10526	5	0	\N
327891	1874	16077000	20935	10526	6	0	\N
327892	1874	16079000	20935	10526	7	0	\N
327893	1874	16080000	20935	10526	8	0	\N
327894	1338	1705962637751650	20936	10526	0	0	\N
327895	1092	907346465000000	20936	10526	1	0	\N
327896	1212	612204750000000	20936	10526	2	0	\N
327808	1874	16039000	20914	10513	2	0	2
327809	1874	16041000	20914	10513	3	0	2
327819	1678	23040757420000	20917	10514	0	0	0
327820	1678	23040757421000	20917	10514	1	0	0
327821	2269	649000000000	20917	10514	2	0	0
327823	1874	16045000	20917	10514	4	0	2
327824	1678	23040757422000	20918	10515	0	0	0
327825	1874	16047000	20918	10515	1	0	2
327828	1678	23040757423000	20920	10516	0	0	0
327829	1445	1004169000000	20920	10516	1	0	8
327831	1874	16050000	20920	10516	3	0	2
327832	1678	23040757424000	20921	10517	0	0	0
327833	1874	16052000	20921	10517	1	0	2
327836	1678	23040757425000	20923	10518	0	0	0
327838	1874	16054000	20923	10518	2	0	2
327839	1164	613308350000000	20924	10519	0	0	0
327840	1044	908981365000000	20924	10519	1	0	0
327841	1678	23040757426000	20924	10519	2	0	0
327842	1874	16056000	20924	10519	3	0	2
327844	1678	23040757427000	20925	10520	0	0	0
327845	1290	1709035637751650	20925	10520	1	0	0
327846	1874	16059000	20925	10520	2	0	2
327847	1678	23040757428000	20926	10521	0	0	0
327848	1874	16061000	20926	10521	1	0	2
327852	1874	16062000	20928	10522	1	0	2
327853	1874	16064000	20928	10522	2	0	2
327854	1678	23040757430000	20929	10523	0	0	0
327855	1874	16066000	20929	10523	1	0	2
327865	1678	23040757432000	20931	10524	1	0	0
327866	1678	23040757433000	20931	10524	2	0	0
327867	1483	10000000	20931	10524	3	0	0
327868	1874	16068000	20931	10524	4	0	2
327869	1874	16070000	20931	10524	5	0	2
327871	1874	16073000	20931	10524	8	0	2
327872	1678	23040757434000	20932	10525	0	0	0
327873	1874	16075000	20932	10525	1	0	2
327876	1338	1705962637751650	20934	10526	0	0	0
327877	1092	907346465000000	20934	10526	1	0	0
327879	972	506334775000000	20934	10526	3	0	0
327880	1678	23040757435000	20934	10526	4	0	0
327881	1678	23040757436000	20934	10526	5	0	0
327882	1874	16077000	20934	10526	6	0	2
327884	1874	16080000	20934	10526	8	0	2
327897	972	506334775000000	20936	10526	3	0	\N
327898	1678	23040757435000	20936	10526	4	0	\N
327899	1678	23040757436000	20936	10526	5	0	\N
327900	1874	16077000	20936	10526	6	0	\N
327901	1874	16079000	20936	10526	7	0	\N
327902	1874	16080000	20936	10526	8	0	\N
327903	1338	1705962637751650	20937	10526	0	0	\N
327904	1092	907346465000000	20937	10526	1	0	\N
327905	1212	612204750000000	20937	10526	2	0	\N
327906	972	506334775000000	20937	10526	3	0	\N
327907	1678	23040757435000	20937	10526	4	0	\N
327908	1678	23040757436000	20937	10526	5	0	\N
327909	1874	16077000	20937	10526	6	0	\N
327910	1874	16079000	20937	10526	7	0	\N
327911	1874	16080000	20937	10526	8	0	\N
327941	1678	23040757446000	20945	10534	0	0	\N
327942	1678	23040757447000	20945	10534	1	0	\N
327943	1678	23040757448000	20945	10534	2	0	\N
327944	1874	16102000	20945	10534	3	0	\N
327945	1874	16103000	20945	10534	4	0	\N
327946	1874	16105000	20945	10534	5	0	\N
327947	1874	16107000	20945	10534	6	0	\N
327955	1678	23040757446000	20947	10534	0	0	\N
327956	1678	23040757447000	20947	10534	1	0	\N
327957	1678	23040757448000	20947	10534	2	0	\N
327958	1874	16102000	20947	10534	3	0	\N
327959	1874	16103000	20947	10534	4	0	\N
327960	1874	16105000	20947	10534	5	0	\N
327961	1874	16107000	20947	10534	6	0	\N
327967	1678	23040757450000	20950	10536	0	0	\N
327968	1874	16112000	20950	10536	1	0	\N
327971	1678	23040757452000	20952	10538	0	0	\N
327972	1874	16116000	20952	10538	1	0	\N
327978	1678	23040757454000	20955	10540	0	0	\N
327979	1874	16121000	20955	10540	1	0	\N
327989	1958	5031186000000	20958	10542	0	0	\N
327990	1678	23040757458000	20958	10542	1	0	\N
327991	1874	16130000	20958	10542	2	0	\N
327992	1958	5031186000000	20959	10542	0	0	\N
327993	1678	23040757458000	20959	10542	1	0	\N
327994	1874	16130000	20959	10542	2	0	\N
327998	1958	5031186000000	20961	10542	0	0	\N
327999	1678	23040757458000	20961	10542	1	0	\N
328000	1874	16130000	20961	10542	2	0	\N
328007	2270	699000000000	20964	10504	0	0	\N
328008	1338	1705962637751650	20964	10504	1	0	\N
328009	1092	907346465000000	20964	10504	2	0	\N
328010	2271	2000000000	20964	10504	3	0	\N
328011	1958	5031186000000	20964	10504	4	0	\N
328012	1212	612204750000000	20964	10504	5	0	\N
328013	972	506334775000000	20964	10504	6	0	\N
328014	588	66471000000000	20964	10504	7	0	\N
328015	2269	2000000000	20964	10504	8	0	\N
328016	1516	7792474350000	20964	10504	9	0	\N
328017	1445	1004169000000	20964	10504	10	0	\N
328018	924	507246525000000	20964	10504	11	0	\N
328019	1164	613308350000000	20964	10504	12	0	\N
328020	1044	908981365000000	20964	10504	13	0	\N
328021	1290	1709035637751650	20964	10504	14	0	\N
328022	2269	649000000000	20964	10504	15	0	\N
328028	1678	23040757464000	20966	10546	0	0	\N
328029	1874	16142000	20966	10546	1	0	\N
328032	1678	23040757464000	20968	10546	0	0	\N
327914	1874	16082000	20938	10527	2	0	2
327915	1678	23040757438000	20939	10528	0	0	0
327916	1516	7792474350000	20939	10528	1	0	12
327917	1678	23040757439000	20939	10528	2	0	0
327918	1874	16084000	20939	10528	3	0	2
327920	1874	16087000	20939	10528	5	0	2
327921	1483	10000000	20940	10529	0	0	0
327922	2271	2000000000	20940	10529	1	0	0
327923	1678	23040757440000	20940	10529	2	0	0
327924	1874	16089000	20940	10529	3	0	2
327926	1874	16091000	20941	10530	1	0	2
327927	928	506566118619092	20942	10531	0	0	0
327928	1048	907446321720448	20942	10531	1	0	0
327929	1678	23040757442000	20942	10531	2	0	0
327931	1874	16093000	20942	10531	4	0	2
327932	1168	612272180460622	20943	10532	0	0	0
327933	1294	1706150513755879	20943	10532	1	0	0
327934	1678	23040757443000	20943	10532	2	0	0
327935	1874	16094000	20943	10532	3	0	2
327937	1678	23040757444000	20944	10533	0	0	0
327938	1678	23040757445000	20944	10533	1	0	0
327939	1874	16098000	20944	10533	2	0	2
327940	1874	16100000	20944	10533	3	0	2
327948	1678	23040757446000	20946	10534	0	0	0
327950	1678	23040757448000	20946	10534	2	0	0
327951	1874	16102000	20946	10534	3	0	2
327952	1874	16103000	20946	10534	4	0	2
327953	1874	16105000	20946	10534	5	0	2
327962	1678	23040757449000	20948	10535	0	0	0
327963	1874	16108000	20948	10535	1	0	2
327964	1874	16110000	20948	10535	2	0	2
327965	1678	23040757450000	20949	10536	0	0	0
327966	1874	16112000	20949	10536	1	0	2
327970	1874	16114000	20951	10537	1	0	2
327973	1678	23040757452000	20953	10538	0	0	0
327974	1874	16116000	20953	10538	1	0	2
327975	1678	23040757453000	20954	10539	0	0	0
327976	1874	16117000	20954	10539	1	0	2
327980	1678	23040757454000	20956	10540	0	0	0
327981	1874	16121000	20956	10540	1	0	2
327982	1678	23040757455000	20957	10541	0	0	0
327983	1678	23040757456000	20957	10541	1	0	0
327985	1874	16122000	20957	10541	3	0	2
327986	1874	16124000	20957	10541	4	0	2
327987	1874	16126000	20957	10541	5	0	2
327988	1874	16128000	20957	10541	6	0	2
327995	1958	5031186000000	20960	10542	0	0	3
327997	1874	16130000	20960	10542	2	0	2
328001	1678	23040757459000	20962	10543	0	0	0
328002	1678	23040757460000	20962	10543	1	0	0
328003	1874	16131000	20962	10543	2	0	2
328004	1874	16133000	20962	10543	3	0	2
328006	1874	16135000	20963	10544	1	0	2
328023	1678	23040757462000	20965	10545	0	0	0
328024	1678	23040757463000	20965	10545	1	0	0
328025	1874	16137000	20965	10545	2	0	2
328027	1874	16140000	20965	10545	4	0	2
328030	1678	23040757464000	20967	10546	0	0	0
328031	1874	16142000	20967	10546	1	0	2
328033	1874	16142000	20968	10546	1	0	\N
328034	1678	23040757464000	20969	10546	0	0	\N
328035	1874	16142000	20969	10546	1	0	\N
328036	1678	23040757464000	20970	10546	0	0	\N
328037	1874	16142000	20970	10546	1	0	\N
328040	2270	699000000000	20972	10424	0	0	\N
328041	1338	1705962637751650	20972	10424	1	0	\N
328042	994	507243255271745	20972	10424	2	0	\N
328043	1092	907346465000000	20972	10424	3	0	\N
328052	2016	2332000000000	20975	10550	0	0	\N
328053	1678	23040757467000	20975	10550	1	0	\N
328054	1874	16151000	20975	10550	2	0	\N
328061	1678	23040757468000	20978	10551	0	0	\N
328062	1874	16152000	20978	10551	1	0	\N
328063	1874	16154000	20978	10551	2	0	\N
328066	1678	23040757470000	20980	10553	0	0	\N
328067	1874	16158000	20980	10553	1	0	\N
328070	1678	23040757470000	20982	10553	0	0	\N
328071	1874	16158000	20982	10553	1	0	\N
328072	1678	23040757471000	20983	10554	0	0	\N
328073	1874	16160000	20983	10554	1	0	\N
328079	1678	23040757473000	20986	10556	0	0	\N
328080	1874	16165000	20986	10556	1	0	\N
328081	1678	23040757473000	20987	10556	0	0	\N
328082	1874	16165000	20987	10556	1	0	\N
328087	1678	23040757474000	20990	10557	0	0	\N
328088	1874	16167000	20990	10557	1	0	\N
328089	1678	23040757474000	20991	10557	0	0	\N
328090	1874	16167000	20991	10557	1	0	\N
328094	1678	23040757476000	20993	10559	0	0	\N
328095	1678	23040757477000	20993	10559	1	0	\N
328096	1678	23040757476000	20994	10559	0	0	\N
328097	1678	23040757477000	20994	10559	1	0	\N
328098	1874	16172000	20994	10559	2	0	\N
328099	1874	16174000	20994	10559	3	0	\N
328100	1678	23040757476000	20995	10559	0	0	\N
328101	1678	23040757477000	20995	10559	1	0	\N
328102	1874	16172000	20995	10559	2	0	\N
328103	1874	16174000	20995	10559	3	0	\N
328108	1300	1710301631910020	20997	10560	0	0	\N
328109	1174	613761729502880	20997	10560	1	0	\N
328110	1054	909654073462350	20997	10560	2	0	\N
328111	934	507621887704640	20997	10560	3	0	\N
328112	1678	23040757478000	20997	10560	4	0	\N
328113	1678	23040757479000	20997	10560	5	0	\N
328114	1678	23040757480000	20997	10560	6	0	\N
328115	1678	23040757481000	20997	10560	7	0	\N
328116	1874	16176000	20997	10560	8	0	\N
328117	1874	16178000	20997	10560	9	0	\N
328118	1874	16180000	20997	10560	10	0	\N
328119	1874	16182000	20997	10560	11	0	\N
328120	1874	16183000	20997	10560	12	0	\N
328121	1300	1710301631910020	20998	10560	0	0	\N
328122	1174	613761729502880	20998	10560	1	0	\N
328123	1054	909654073462350	20998	10560	2	0	\N
328124	934	507621887704640	20998	10560	3	0	\N
328125	1678	23040757478000	20998	10560	4	0	\N
328126	1678	23040757479000	20998	10560	5	0	\N
328127	1678	23040757480000	20998	10560	6	0	\N
328128	1678	23040757481000	20998	10560	7	0	\N
328129	1874	16176000	20998	10560	8	0	\N
328130	1874	16178000	20998	10560	9	0	\N
328131	1874	16180000	20998	10560	10	0	\N
328132	1874	16182000	20998	10560	11	0	\N
328133	1874	16183000	20998	10560	12	0	\N
328147	2270	699000000000	21000	10518	0	0	\N
328148	1338	1705962637751650	21000	10518	1	0	\N
328149	1092	907346465000000	21000	10518	2	0	\N
328150	2271	2000000000	21000	10518	3	0	\N
328151	1958	5031186000000	21000	10518	4	0	\N
328152	1212	612204750000000	21000	10518	5	0	\N
328153	972	506334775000000	21000	10518	6	0	\N
328154	588	66471000000000	21000	10518	7	0	\N
328155	1678	23040757425000	21000	10518	8	0	\N
328156	924	507246525000000	21000	10518	9	0	\N
328157	1164	613308350000000	21000	10518	10	0	\N
328158	1044	908981365000000	21000	10518	11	0	\N
328159	1290	1709035637751650	21000	10518	12	0	\N
328160	1483	10000000	21000	10518	13	0	\N
328161	1516	7792474350000	21000	10518	14	0	\N
328162	1300	1710301631910020	21000	10518	15	0	\N
328163	1174	613761729502880	21000	10518	16	0	\N
328164	1054	909654073462350	21000	10518	17	0	\N
328165	934	507621887704640	21000	10518	18	0	\N
328166	1678	23040757426000	21000	10518	19	0	\N
328167	1678	23040757427000	21000	10518	20	0	\N
328168	1678	23040757428000	21000	10518	21	0	\N
328044	1285	1714307637751650	20973	10548	0	0	0
328045	1039	911784465000000	20973	10548	1	0	0
328046	1159	615200750000000	20973	10548	2	0	0
328047	919	508811775000000	20973	10548	3	0	0
328048	1874	16145000	20973	10548	4	0	2
328050	1678	23040757466000	20974	10549	0	0	0
328051	1874	16149000	20974	10549	1	0	2
328055	2016	2332000000000	20976	10550	0	0	0
328056	1678	23040757467000	20976	10550	1	0	0
328057	1874	16151000	20976	10550	2	0	2
328059	1874	16152000	20977	10551	1	0	2
328060	1874	16154000	20977	10551	2	0	2
328064	1678	23040757469000	20979	10552	0	0	0
328065	1874	16156000	20979	10552	1	0	2
328069	1874	16158000	20981	10553	1	0	2
328074	1678	23040757471000	20984	10554	0	0	0
328075	1874	16160000	20984	10554	1	0	2
328076	1678	23040757472000	20985	10555	0	0	0
328077	1874	16162000	20985	10555	1	0	2
328083	1678	23040757473000	20988	10556	0	0	0
328084	1874	16165000	20988	10556	1	0	2
328085	1678	23040757474000	20989	10557	0	0	0
328086	1874	16167000	20989	10557	1	0	2
328091	1678	23040757475000	20992	10558	0	0	0
328093	1874	16170000	20992	10558	2	0	2
328104	1678	23040757476000	20996	10559	0	0	0
328105	1678	23040757477000	20996	10559	1	0	0
328106	1874	16172000	20996	10559	2	0	2
328134	1300	1710301631910020	20999	10560	0	0	0
328135	1174	613761729502880	20999	10560	1	0	0
328136	1054	909654073462350	20999	10560	2	0	0
328137	934	507621887704640	20999	10560	3	0	0
328138	1678	23040757478000	20999	10560	4	0	0
328140	1678	23040757480000	20999	10560	6	0	0
328141	1678	23040757481000	20999	10560	7	0	0
328142	1874	16176000	20999	10560	8	0	2
328143	1874	16178000	20999	10560	9	0	2
328144	1874	16180000	20999	10560	10	0	2
328146	1874	16183000	20999	10560	12	0	2
328169	1678	23040757429000	21000	10518	22	0	\N
328170	1678	23040757430000	21000	10518	23	0	\N
328171	1678	23040757431000	21000	10518	24	0	\N
328172	1678	23040757432000	21000	10518	25	0	\N
328173	1678	23040757433000	21000	10518	26	0	\N
328174	1678	23040757434000	21000	10518	27	0	\N
328175	1678	23040757435000	21000	10518	28	0	\N
328176	1678	23040757436000	21000	10518	29	0	\N
328177	1678	23040757437000	21000	10518	30	0	\N
328178	1678	23040757438000	21000	10518	31	0	\N
328179	1678	23040757439000	21000	10518	32	0	\N
328180	1678	23040757440000	21000	10518	33	0	\N
328181	1678	23040757441000	21000	10518	34	0	\N
328182	1678	23040757442000	21000	10518	35	0	\N
328183	1678	23040757443000	21000	10518	37	0	\N
328184	1678	23040757444000	21000	10518	38	0	\N
328185	1678	23040757445000	21000	10518	39	0	\N
328186	1678	23040757446000	21000	10518	40	0	\N
328187	1678	23040757447000	21000	10518	41	0	\N
328188	1678	23040757448000	21000	10518	42	0	\N
328189	1678	23040757449000	21000	10518	43	0	\N
328190	1678	23040757450000	21000	10518	44	0	\N
328191	1678	23040757451000	21000	10518	45	0	\N
328192	1678	23040757452000	21000	10518	46	0	\N
328193	1678	23040757453000	21000	10518	47	0	\N
328194	1678	23040757454000	21000	10518	48	0	\N
328195	1678	23040757455000	21000	10518	49	0	\N
328196	1285	1714307637751650	21000	10518	50	0	\N
328197	1039	911784465000000	21000	10518	51	0	\N
328198	1159	615200750000000	21000	10518	52	0	\N
328199	919	508811775000000	21000	10518	53	0	\N
328200	2016	2332000000000	21000	10518	54	0	\N
328201	1678	23040757456000	21000	10518	55	0	\N
328202	1678	23040757457000	21000	10518	56	0	\N
328203	1678	23040757458000	21000	10518	57	0	\N
328204	1678	23040757459000	21000	10518	58	0	\N
328205	1678	23040757460000	21000	10518	59	0	\N
328206	1678	23040757461000	21000	10518	60	0	\N
328207	1678	23040757462000	21000	10518	61	0	\N
328208	1678	23040757463000	21000	10518	62	0	\N
328209	1678	23040757464000	21000	10518	63	0	\N
328210	1678	23040757465000	21000	10518	64	0	\N
328211	1678	23040757466000	21000	10518	65	0	\N
328212	1678	23040757467000	21000	10518	66	0	\N
328213	1678	23040757468000	21000	10518	67	0	\N
328214	1678	23040757469000	21000	10518	68	0	\N
328215	1678	23040757470000	21000	10518	69	0	\N
328216	1678	23040757471000	21000	10518	70	0	\N
328217	1678	23040757472000	21000	10518	71	0	\N
328218	1678	23040757473000	21000	10518	72	0	\N
328219	1678	23040757474000	21000	10518	73	0	\N
328220	1678	23040757475000	21000	10518	74	0	\N
328221	1678	23040757476000	21000	10518	75	0	\N
328222	1678	23040757477000	21000	10518	76	0	\N
328223	1678	23040757478000	21000	10518	77	0	\N
328224	1678	23040757479000	21000	10518	78	0	\N
328225	1678	23040757480000	21000	10518	79	0	\N
328226	1678	23040757481000	21000	10518	80	0	\N
328227	1874	16053000	21000	10518	81	0	\N
328228	1874	16054000	21000	10518	82	0	\N
328229	1874	16055000	21000	10518	83	0	\N
328230	1874	16056000	21000	10518	84	0	\N
328231	1874	16057000	21000	10518	85	0	\N
328232	1874	16058000	21000	10518	86	0	\N
328233	1874	16059000	21000	10518	87	0	\N
328234	1874	16060000	21000	10518	88	0	\N
328235	1874	16061000	21000	10518	89	0	\N
328236	1874	16062000	21000	10518	90	0	\N
328237	1874	16063000	21000	10518	91	0	\N
328238	1874	16065000	21000	10518	92	0	\N
328239	1874	16067000	21000	10518	93	0	\N
328240	1874	16069000	21000	10518	94	0	\N
328241	1874	16071000	21000	10518	95	0	\N
328242	1874	16073000	21000	10518	96	0	\N
328243	1874	16075000	21000	10518	97	0	\N
328244	1874	16077000	21000	10518	98	0	\N
328245	1874	16079000	21000	10518	99	0	\N
328246	1874	16081000	21000	10518	100	0	\N
328247	1874	16082000	21000	10518	101	0	\N
328248	1874	16083000	21000	10518	102	0	\N
328249	1874	16084000	21000	10518	103	0	\N
328250	1874	16085000	21000	10518	104	0	\N
328251	1874	16086000	21000	10518	105	0	\N
328252	1874	16087000	21000	10518	106	0	\N
328253	1874	16089000	21000	10518	107	0	\N
328254	1874	16091000	21000	10518	108	0	\N
328255	1874	16093000	21000	10518	109	0	\N
328256	1874	16095000	21000	10518	110	0	\N
328257	1874	16097000	21000	10518	111	0	\N
328258	1874	16099000	21000	10518	112	0	\N
328259	1874	16101000	21000	10518	113	0	\N
328260	1874	16103000	21000	10518	114	0	\N
328261	1874	16105000	21000	10518	115	0	\N
328262	1874	16107000	21000	10518	116	0	\N
328263	1874	16109000	21000	10518	117	0	\N
328264	1874	16111000	21000	10518	118	0	\N
328265	1874	16113000	21000	10518	119	0	\N
328266	1874	16115000	21000	10518	120	0	\N
328267	1874	16117000	21000	10518	121	0	\N
328268	1874	16119000	21000	10518	122	0	\N
328269	1874	16121000	21000	10518	123	0	\N
328270	1874	16123000	21000	10518	124	0	\N
328271	1874	16125000	21000	10518	125	0	\N
328277	1678	23040757482000	21002	10561	0	0	\N
328278	1678	23040757483000	21002	10561	1	0	\N
328279	1874	16185000	21002	10561	2	0	\N
328280	1874	16187000	21002	10561	3	0	\N
328281	1874	16188000	21002	10561	4	0	\N
328282	1678	23040757484000	21003	10562	0	0	\N
328283	1874	16190000	21003	10562	1	0	\N
328284	1678	23040757484000	21004	10562	0	0	\N
328285	1874	16190000	21004	10562	1	0	\N
328286	1678	23040757484000	21005	10562	0	0	\N
328287	1874	16190000	21005	10562	1	0	\N
328290	1678	23040757485000	21007	10563	0	0	\N
328291	1678	23040757486000	21007	10563	1	0	\N
328292	1874	16191000	21007	10563	2	0	\N
328293	1874	16193000	21007	10563	3	0	\N
328294	1874	16195000	21007	10563	4	0	\N
328300	1678	23040757485000	21009	10563	0	0	\N
328301	1678	23040757486000	21009	10563	1	0	\N
328302	1874	16191000	21009	10563	2	0	\N
328274	1874	16185000	21001	10561	2	0	2
328275	1874	16187000	21001	10561	3	0	2
328276	1874	16188000	21001	10561	4	0	2
328288	1678	23040757484000	21006	10562	0	0	0
328289	1874	16190000	21006	10562	1	0	2
328296	1678	23040757486000	21008	10563	1	0	0
328297	1874	16191000	21008	10563	2	0	2
328298	1874	16193000	21008	10563	3	0	2
328299	1874	16195000	21008	10563	4	0	2
328303	1678	23040757487000	21010	10564	0	0	0
328305	2270	699000000000	21011	10383	0	0	\N
328306	1706	16053356600135	21011	10383	1	0	\N
328307	1706	16054356600135	21011	10383	2	0	\N
328308	1706	17490356600135	21011	10383	3	0	\N
328309	1338	1705962637751650	21011	10383	4	0	\N
328310	1355	1708676653253353	21011	10383	5	0	\N
328311	994	507243255271745	21011	10383	6	0	\N
328312	1092	907346465000000	21011	10383	7	0	\N
328313	2271	2000000000	21011	10383	8	0	\N
328314	1958	5031186000000	21011	10383	9	0	\N
328315	1114	908975568495245	21011	10383	10	0	\N
328316	1109	908789804707202	21011	10383	11	0	\N
328317	1229	613178594344390	21011	10383	12	0	\N
328318	989	507139625446703	21011	10383	13	0	\N
328319	1212	612204750000000	21011	10383	15	0	\N
328320	972	506334775000000	21011	10383	16	0	\N
328321	588	66471000000000	21011	10383	17	0	\N
328322	1234	613303927936822	21011	10383	18	0	\N
328323	1360	1703067102686958	21011	10383	19	0	\N
328324	1360	1709025928146958	21011	10383	20	0	\N
328325	1981	100980000000	21011	10383	21	0	\N
328326	940	507428775000000	21011	10383	22	0	\N
328327	1060	909307465000000	21011	10383	23	0	\N
328328	1131	910286565000000	21011	10383	24	0	\N
328329	1251	614188360000000	21011	10383	25	0	\N
328330	1011	507974815000000	21011	10383	26	0	\N
328331	2269	2000000000	21011	10383	27	0	\N
328332	1	375562550686000	21011	10383	28	0	\N
328333	31	1329981875386000	21011	10383	29	0	\N
328334	32	74262251044000	21011	10383	30	0	\N
328335	556	66743135511028	21011	10383	31	0	\N
328336	841	84064023338298	21011	10383	32	0	\N
328337	843	156725652655667	21011	10383	33	0	\N
328338	849	1155353613497640	21011	10383	34	0	\N
328339	851	2247807533667750	21011	10383	35	0	\N
328340	1180	613528750000000	21011	10383	36	0	\N
328341	1306	1709649637751650	21011	10383	37	0	\N
328342	596	68338752000000	21011	10383	38	0	\N
328343	930	508430970677776	21011	10383	39	0	\N
328344	1050	911103943218016	21011	10383	40	0	\N
328345	1170	614739985517734	21011	10383	41	0	\N
328346	40	66569445570000	21011	10383	42	0	\N
328347	779	28017885636792	21011	10383	43	0	\N
328348	780	308196473040051	21011	10383	44	0	\N
328349	782	2465521918273720	21011	10383	45	0	\N
328350	1678	23040757296000	21011	10383	46	0	\N
328351	1678	23040757297000	21011	10383	47	0	\N
328352	1678	23040757298000	21011	10383	48	0	\N
328353	1678	23040757299000	21011	10383	49	0	\N
328354	1516	7792474350000	21011	10383	50	0	\N
328355	1445	1004169000000	21011	10383	51	0	\N
328356	924	507246525000000	21011	10383	52	0	\N
328357	1164	613308350000000	21011	10383	53	0	\N
328358	1044	908981365000000	21011	10383	54	0	\N
328359	1290	1709035637751650	21011	10383	55	0	\N
328360	1678	23040757300000	21011	10383	56	0	\N
328361	1300	1710301631910020	21011	10383	57	0	\N
328362	1174	613761729502880	21011	10383	58	0	\N
328363	1054	909654073462350	21011	10383	59	0	\N
328364	934	507621887704640	21011	10383	60	0	\N
328365	785	224138551816807	21011	10383	61	0	\N
328366	786	2465521918273720	21011	10383	62	0	\N
328367	791	56035771273584	21011	10383	63	0	\N
328368	792	616392946080101	21011	10383	64	0	\N
328369	799	14007687631181	21011	10383	65	0	\N
328370	800	154084429483607	21011	10383	66	0	\N
328371	801	14010279247666	21011	10383	67	0	\N
328372	802	154112937240275	21011	10383	68	0	\N
328373	1678	23040757301000	21011	10383	69	0	\N
328374	1678	23040757302000	21011	10383	70	0	\N
328375	1678	23040757303000	21011	10383	71	0	\N
328376	1678	23040757304000	21011	10383	72	0	\N
328377	1678	23040757305000	21011	10383	73	0	\N
328378	58	70307296999641	21011	10383	74	0	\N
328379	1296	1713027629277034	21011	10383	75	0	\N
328380	1678	23040757306000	21011	10383	76	0	\N
328381	1678	23040757307000	21011	10383	77	0	\N
328382	1678	23040757308000	21011	10383	78	0	\N
328383	1678	23040757309000	21011	10383	79	0	\N
328384	1678	23040757310000	21011	10383	80	0	\N
328385	451	66564722585011	21011	10383	81	0	\N
328386	487	66564722585011	21011	10383	82	0	\N
328387	744	2017112805578	21011	10383	83	0	\N
328388	988	507076931797664	21011	10383	84	0	\N
328389	1108	908677517146240	21011	10383	85	0	\N
328390	1678	23040757311000	21011	10383	86	0	\N
328391	1678	23040757312000	21011	10383	87	0	\N
328392	1678	23040757313000	21011	10383	88	0	\N
328393	1678	23040757314000	21011	10383	89	0	\N
328394	853	247856948044225	21011	10383	90	0	\N
328395	1678	23040757315000	21011	10383	91	0	\N
328396	1678	23040757316000	21011	10383	92	0	\N
328397	1678	23040757317000	21011	10383	93	0	\N
328398	1678	23040757318000	21011	10383	94	0	\N
328399	1678	23040757319000	21011	10383	96	0	\N
328400	1678	23040757320000	21011	10383	97	0	\N
328401	855	131107036356125	21011	10383	99	0	\N
328402	857	330584433102608	21011	10383	100	0	\N
328403	861	456614161103125	21011	10383	101	0	\N
328404	865	400855996215417	21011	10383	102	0	\N
328405	867	2441303436168000	21011	10383	103	0	\N
328406	869	261078414520845	21011	10383	104	0	\N
328407	873	2441303436168000	21011	10383	105	0	\N
328408	875	213990794972583	21011	10383	106	0	\N
328409	883	90418645762500	21011	10383	107	0	\N
328410	887	269862585957154	21011	10383	108	0	\N
328411	889	226535176490249	21011	10383	109	0	\N
328412	891	497302551695750	21011	10383	110	0	\N
328413	897	65600535873885	21011	10383	111	0	\N
328414	899	39104255918990	21011	10383	112	0	\N
328415	901	117544239492250	21011	10383	113	0	\N
328416	905	422707168941938	21011	10383	114	0	\N
328417	2177	64960605049641	21011	10383	115	0	\N
328418	873	2445664587151000	21011	10383	116	0	\N
328419	875	214373068700583	21011	10383	117	0	\N
328420	1228	613102827497120	21011	10383	118	0	\N
328421	1354	1708465542884770	21011	10383	119	0	\N
328422	1678	23040757321000	21011	10383	120	0	\N
328423	1678	23040757322000	21011	10383	121	0	\N
328424	1678	23040757323000	21011	10383	122	0	\N
328425	1678	23040757324000	21011	10383	123	0	\N
328426	1678	23040757325000	21011	10383	124	0	\N
328427	1678	23040757326000	21011	10383	125	0	\N
328431	1678	23040757488000	21013	10565	0	0	\N
328432	1874	16199000	21013	10565	1	0	\N
328433	1874	16200000	21013	10565	2	0	\N
328430	1874	16200000	21012	10565	2	0	2
328434	1678	23040757489000	21014	10566	0	0	0
328435	1678	23040757490000	21014	10566	1	0	0
328436	1289	1708728477751650	21014	10566	2	0	0
328437	1043	908817755000000	21014	10566	3	0	0
328439	1874	16202000	21014	10566	5	0	2
328440	1874	16204000	21014	10566	6	0	2
328446	1678	23040757491000	21016	10567	0	0	\N
328447	1678	23040757492000	21016	10567	1	0	\N
328448	1874	16206000	21016	10567	2	0	\N
328449	1874	16208000	21016	10567	3	0	\N
328450	1874	16209000	21016	10567	4	0	\N
328451	1678	23040757493000	21018	10568	0	0	\N
328452	1874	16211000	21018	10568	1	0	\N
328455	1678	23040757493000	21020	10568	0	0	\N
328456	1874	16211000	21020	10568	1	0	\N
328457	1678	23040757494000	21021	10569	0	0	\N
328458	1678	23040757495000	21021	10569	1	0	\N
328459	1678	23040757496000	21021	10569	2	0	\N
328460	1874	16213000	21021	10569	3	0	\N
328461	1874	16214000	21021	10569	4	0	\N
328462	1874	16216000	21021	10569	5	0	\N
328463	1678	23040757494000	21022	10569	0	0	\N
328464	1678	23040757495000	21022	10569	1	0	\N
328465	1678	23040757496000	21022	10569	2	0	\N
328466	1874	16213000	21022	10569	3	0	\N
328467	1874	16214000	21022	10569	4	0	\N
328468	1874	16216000	21022	10569	5	0	\N
328475	1678	23040757494000	21024	10569	0	0	\N
328476	1678	23040757495000	21024	10569	1	0	\N
328477	1678	23040757496000	21024	10569	2	0	\N
328478	1874	16213000	21024	10569	3	0	\N
328479	1874	16214000	21024	10569	4	0	\N
328480	1874	16216000	21024	10569	5	0	\N
328481	1678	23040757494000	21025	10569	0	0	\N
328482	1678	23040757495000	21025	10569	1	0	\N
328483	1678	23040757496000	21025	10569	2	0	\N
328484	1874	16213000	21025	10569	3	0	\N
328485	1874	16214000	21025	10569	4	0	\N
328486	1874	16216000	21025	10569	5	0	\N
328487	1678	23040757494000	21026	10569	0	0	\N
328488	1678	23040757495000	21026	10569	1	0	\N
328489	1678	23040757496000	21026	10569	2	0	\N
328490	1874	16213000	21026	10569	3	0	\N
328491	1874	16214000	21026	10569	4	0	\N
328492	1874	16216000	21026	10569	5	0	\N
328493	1678	23040757494000	21027	10569	0	0	\N
328494	1678	23040757495000	21027	10569	1	0	\N
328495	1678	23040757496000	21027	10569	2	0	\N
328496	1874	16213000	21027	10569	3	0	\N
328497	1874	16214000	21027	10569	4	0	\N
328498	1874	16216000	21027	10569	5	0	\N
328499	1678	23040757494000	21028	10569	0	0	\N
328500	1678	23040757495000	21028	10569	1	0	\N
328501	1678	23040757496000	21028	10569	2	0	\N
328502	1874	16213000	21028	10569	3	0	\N
328503	1874	16214000	21028	10569	4	0	\N
328504	1874	16216000	21028	10569	5	0	\N
328507	1678	23040757497000	21030	10570	0	0	\N
328508	1874	16218000	21030	10570	1	0	\N
328509	1678	23040757498000	21031	10571	0	0	\N
328510	1874	16219000	21031	10571	1	0	\N
328511	1874	16221000	21031	10571	2	0	\N
328515	1678	23040757497000	21033	10570	0	0	\N
328516	1678	23040757498000	21033	10570	1	0	\N
328517	1874	16218000	21033	10570	2	0	\N
328518	1874	16220000	21033	10570	3	0	\N
328519	1678	23040757499000	21034	10572	0	0	\N
328520	1874	16223000	21034	10572	1	0	\N
328523	1678	23040757499000	21038	10572	0	0	\N
328524	1874	16223000	21038	10572	1	0	\N
328529	1678	23040757501000	21041	10574	0	0	\N
328530	1874	16225000	21041	10574	1	0	\N
328531	1874	16227000	21041	10574	2	0	\N
328532	1678	23040757501000	21042	10574	0	0	\N
328533	1874	16225000	21042	10574	1	0	\N
328534	1874	16227000	21042	10574	2	0	\N
328542	1678	23040757504000	21045	10576	0	0	\N
328543	1874	16234000	21045	10576	1	0	\N
328544	1678	23040757504000	21046	10576	0	0	\N
328545	1874	16234000	21046	10576	1	0	\N
328546	1678	23040757505000	21047	10577	0	0	\N
328547	1874	16236000	21047	10577	1	0	\N
328548	1874	16237000	21047	10577	2	0	\N
328552	1678	23040757505000	21049	10577	0	0	\N
328553	1874	16236000	21049	10577	1	0	\N
328554	1874	16237000	21049	10577	2	0	\N
328555	1678	23040757506000	21050	10578	0	0	\N
328556	1874	16239000	21050	10578	1	0	\N
328559	1678	23040757506000	21052	10578	0	0	\N
328560	1874	16239000	21052	10578	1	0	\N
328561	1678	23040757506000	21053	10578	0	0	\N
328562	1874	16239000	21053	10578	1	0	\N
328563	1678	23040757507000	21054	10579	0	0	\N
328564	1678	23040757508000	21054	10579	1	0	\N
328565	1874	16241000	21054	10579	2	0	\N
328566	1874	16242000	21054	10579	3	0	\N
328571	1678	23040757509000	21056	10580	0	0	\N
328572	1874	16244000	21056	10580	1	0	\N
328443	1874	16206000	21015	10567	2	0	2
328444	1874	16208000	21015	10567	3	0	2
328445	1874	16209000	21015	10567	4	0	2
328453	1678	23040757493000	21019	10568	0	0	0
328454	1874	16211000	21019	10568	1	0	2
328470	1678	23040757495000	21023	10569	1	0	0
328471	1678	23040757496000	21023	10569	2	0	0
328472	1874	16213000	21023	10569	3	0	2
328473	1874	16214000	21023	10569	4	0	2
328474	1874	16216000	21023	10569	5	0	2
328506	1874	16218000	21029	10570	1	0	2
328512	1678	23040757498000	21032	10571	0	0	0
328513	1874	16219000	21032	10571	1	0	2
328514	1874	16221000	21032	10571	2	0	2
328522	1874	16223000	21035	10572	1	0	2
328525	1678	23040757500000	21039	10573	0	0	0
328526	1678	23040757501000	21040	10574	0	0	0
328527	1874	16225000	21040	10574	1	0	2
328528	1874	16227000	21040	10574	2	0	2
328536	1678	23040757503000	21043	10575	1	0	0
328537	1874	16229000	21043	10575	2	0	2
328538	1874	16231000	21043	10575	3	0	2
328539	1874	16232000	21043	10575	4	0	2
328540	1678	23040757504000	21044	10576	0	0	0
328549	1678	23040757505000	21048	10577	0	0	0
328550	1874	16236000	21048	10577	1	0	2
328551	1874	16237000	21048	10577	2	0	2
328557	1678	23040757506000	21051	10578	0	0	0
328567	1678	23040757507000	21055	10579	0	0	0
328568	1678	23040757508000	21055	10579	1	0	0
328569	1874	16241000	21055	10579	2	0	2
328570	1874	16242000	21055	10579	3	0	2
328573	1678	23040757509000	21057	10580	0	0	0
328575	1678	23040757510000	21058	10581	0	0	0
328576	1874	16246000	21058	10581	1	0	2
328586	1850	22240418949999	21061	10507	0	0	\N
328587	2270	699000000000	21061	10507	1	0	\N
328588	1338	1705962637751650	21061	10507	2	0	\N
328589	1092	907346465000000	21061	10507	3	0	\N
328590	2271	2000000000	21061	10507	4	0	\N
328591	1958	5031186000000	21061	10507	5	0	\N
328592	1212	612204750000000	21061	10507	6	0	\N
328593	972	506334775000000	21061	10507	7	0	\N
328594	588	66471000000000	21061	10507	8	0	\N
328595	1850	22241418949999	21061	10507	9	0	\N
328596	2269	2000000000	21061	10507	10	0	\N
328597	1289	1708728477751650	21061	10507	11	0	\N
328598	1043	908817755000000	21061	10507	12	0	\N
328599	1277	1709780037751650	21061	10507	13	0	\N
328600	1031	909376565000000	21061	10507	14	0	\N
328601	1151	613574650000000	21061	10507	15	0	\N
328602	911	507467575000000	21061	10507	16	0	\N
328603	1163	613197810000000	21061	10507	17	0	\N
328604	923	507155005000000	21061	10507	18	0	\N
328605	1516	7792474350000	21061	10507	19	0	\N
328606	1445	1004169000000	21061	10507	20	0	\N
328607	924	507246525000000	21061	10507	21	0	\N
328608	1164	613308350000000	21061	10507	22	0	\N
328609	1044	908981365000000	21061	10507	23	0	\N
328610	1290	1709035637751650	21061	10507	24	0	\N
328611	1300	1710301631910020	21061	10507	25	0	\N
328612	1174	613761729502880	21061	10507	26	0	\N
328613	1054	909654073462350	21061	10507	27	0	\N
328614	934	507621887704640	21061	10507	28	0	\N
328615	1285	1714307637751650	21061	10507	29	0	\N
328616	1039	911784465000000	21061	10507	30	0	\N
328617	1159	615200750000000	21061	10507	31	0	\N
328618	919	508811775000000	21061	10507	32	0	\N
328619	2016	2332000000000	21061	10507	33	0	\N
328620	2269	649000000000	21061	10507	34	0	\N
328621	1874	16014000	21061	10507	35	0	\N
328622	1874	16015000	21061	10507	36	0	\N
328623	1874	16016000	21061	10507	37	0	\N
328624	1874	16017000	21061	10507	38	0	\N
328625	1874	16018000	21061	10507	39	0	\N
328626	1874	16019000	21061	10507	40	0	\N
328627	1874	16020000	21061	10507	41	0	\N
328628	1874	16021000	21061	10507	42	0	\N
328629	1874	16022000	21061	10507	43	0	\N
328630	1874	16023000	21061	10507	44	0	\N
328631	1874	16024000	21061	10507	45	0	\N
328632	1874	16025000	21061	10507	46	0	\N
328633	1874	16026000	21061	10507	47	0	\N
328634	1874	16027000	21061	10507	48	0	\N
328635	1874	16028000	21061	10507	49	0	\N
328636	1874	16029000	21061	10507	50	0	\N
328637	1874	16030000	21061	10507	51	0	\N
328638	1874	16031000	21061	10507	52	0	\N
328639	1874	16032000	21061	10507	53	0	\N
328640	1874	16033000	21061	10507	54	0	\N
328641	1874	16034000	21061	10507	55	0	\N
328642	1874	16035000	21061	10507	56	0	\N
328643	1874	16036000	21061	10507	57	0	\N
328644	1874	16037000	21061	10507	58	0	\N
328645	1874	16038000	21061	10507	59	0	\N
328646	1874	16039000	21061	10507	60	0	\N
328647	1874	16040000	21061	10507	61	0	\N
328648	1874	16041000	21061	10507	62	0	\N
328649	1874	16042000	21061	10507	63	0	\N
328650	1874	16043000	21061	10507	64	0	\N
328651	1874	16044000	21061	10507	65	0	\N
328652	1874	16045000	21061	10507	66	0	\N
328653	1678	23040757514000	21062	10584	0	0	\N
328654	1277	1709780037751650	21062	10584	1	0	\N
328655	1031	909376565000000	21062	10584	2	0	\N
328656	1151	613574650000000	21062	10584	3	0	\N
328657	911	507467575000000	21062	10584	4	0	\N
328658	1874	16255000	21062	10584	5	0	\N
328659	1850	22240418949999	21063	10583	0	0	\N
328660	1850	22241418949999	21063	10583	1	0	\N
328661	1678	23040757513000	21063	10583	2	0	\N
328662	1678	23040757514000	21063	10583	3	0	\N
328663	1277	1709780037751650	21063	10583	4	0	\N
328664	1031	909376565000000	21063	10583	5	0	\N
328665	1151	613574650000000	21063	10583	6	0	\N
328666	911	507467575000000	21063	10583	7	0	\N
328667	1874	16253000	21063	10583	8	0	\N
328668	1874	16255000	21063	10583	9	0	\N
328675	1850	22240418949999	21065	10476	0	0	\N
328676	2270	699000000000	21065	10476	1	0	\N
328677	1338	1705962637751650	21065	10476	2	0	\N
328678	1092	907346465000000	21065	10476	3	0	\N
328679	2271	2000000000	21065	10476	4	0	\N
328680	1958	5031186000000	21065	10476	5	0	\N
328681	1212	612204750000000	21065	10476	6	0	\N
328682	972	506334775000000	21065	10476	7	0	\N
328683	588	66471000000000	21065	10476	8	0	\N
328684	1850	22241418949999	21065	10476	9	0	\N
328685	2269	2000000000	21065	10476	10	0	\N
328686	1289	1708728477751650	21065	10476	11	0	\N
328687	1043	908817755000000	21065	10476	12	0	\N
328688	1277	1709780037751650	21065	10476	13	0	\N
328689	1031	909376565000000	21065	10476	14	0	\N
328690	1151	613574650000000	21065	10476	15	0	\N
328691	911	507467575000000	21065	10476	16	0	\N
328692	1163	613197810000000	21065	10476	17	0	\N
328693	923	507155005000000	21065	10476	18	0	\N
328694	1516	7792474350000	21065	10476	19	0	\N
328695	1445	1004169000000	21065	10476	20	0	\N
328696	924	507246525000000	21065	10476	21	0	\N
328697	1164	613308350000000	21065	10476	22	0	\N
328698	1044	908981365000000	21065	10476	23	0	\N
328699	1290	1709035637751650	21065	10476	24	0	\N
328700	1300	1710301631910020	21065	10476	25	0	\N
328701	1174	613761729502880	21065	10476	26	0	\N
328702	1054	909654073462350	21065	10476	27	0	\N
328703	934	507621887704640	21065	10476	28	0	\N
328704	58	70307296999641	21065	10476	29	0	\N
328705	1678	23040757398000	21065	10476	30	0	\N
328706	1678	23040757399000	21065	10476	31	0	\N
328707	1678	23040757400000	21065	10476	32	0	\N
328708	1678	23040757401000	21065	10476	33	0	\N
328709	1678	23040757402000	21065	10476	34	0	\N
328710	1678	23040757403000	21065	10476	35	0	\N
328711	1678	23040757404000	21065	10476	36	0	\N
328712	1678	23040757405000	21065	10476	37	0	\N
328579	1874	16248000	21059	10582	2	0	2
328580	1874	16249000	21059	10582	3	0	2
328581	1874	16251000	21059	10582	4	0	2
328582	1850	22240418949999	21060	10583	0	0	5
328583	1850	22241418949999	21060	10583	1	0	5
328585	1874	16253000	21060	10583	3	0	2
328669	1678	23040757514000	21064	10584	0	0	0
328670	1277	1709780037751650	21064	10584	1	0	0
328671	1031	909376565000000	21064	10584	2	0	0
328672	1151	613574650000000	21064	10584	3	0	0
328674	1874	16255000	21064	10584	5	0	2
328713	1678	23040757406000	21065	10476	38	0	\N
328714	1678	23040757407000	21065	10476	39	0	\N
328715	1678	23040757408000	21065	10476	40	0	\N
328716	1678	23040757409000	21065	10476	41	0	\N
328717	1678	23040757410000	21065	10476	42	0	\N
328718	1678	23040757411000	21065	10476	43	0	\N
328719	1678	23040757412000	21065	10476	44	0	\N
328720	1678	23040757413000	21065	10476	45	0	\N
328721	1678	23040757414000	21065	10476	46	0	\N
328722	1678	23040757415000	21065	10476	47	0	\N
328723	1678	23040757416000	21065	10476	48	0	\N
328724	1678	23040757417000	21065	10476	49	0	\N
328725	1678	23040757418000	21065	10476	50	0	\N
328726	1678	23040757419000	21065	10476	51	0	\N
328727	1678	23040757420000	21065	10476	52	0	\N
328728	1678	23040757421000	21065	10476	53	0	\N
328729	1678	23040757422000	21065	10476	54	0	\N
328730	1678	23040757423000	21065	10476	55	0	\N
328731	1678	23040757424000	21065	10476	56	0	\N
328732	1678	23040757425000	21065	10476	58	0	\N
328733	1678	23040757426000	21065	10476	59	0	\N
328734	1678	23040757427000	21065	10476	60	0	\N
328735	1678	23040757428000	21065	10476	61	0	\N
328736	1678	23040757429000	21065	10476	62	0	\N
328737	1678	23040757430000	21065	10476	63	0	\N
328738	1678	23040757431000	21065	10476	64	0	\N
328739	1678	23040757432000	21065	10476	65	0	\N
328740	1678	23040757433000	21065	10476	66	0	\N
328741	1678	23040757434000	21065	10476	67	0	\N
328742	1678	23040757435000	21065	10476	68	0	\N
328743	1678	23040757436000	21065	10476	69	0	\N
328744	1678	23040757437000	21065	10476	70	0	\N
328745	1678	23040757438000	21065	10476	71	0	\N
328746	1678	23040757439000	21065	10476	72	0	\N
328747	1678	23040757440000	21065	10476	73	0	\N
328748	1678	23040757441000	21065	10476	74	0	\N
328749	1678	23040757442000	21065	10476	75	0	\N
328750	1678	23040757443000	21065	10476	76	0	\N
328751	1678	23040757444000	21065	10476	77	0	\N
328752	1678	23040757445000	21065	10476	78	0	\N
328753	1678	23040757446000	21065	10476	79	0	\N
328754	1678	23040757447000	21065	10476	80	0	\N
328755	1678	23040757448000	21065	10476	81	0	\N
328756	1678	23040757449000	21065	10476	82	0	\N
328757	1678	23040757450000	21065	10476	83	0	\N
328758	1678	23040757451000	21065	10476	84	0	\N
328759	1678	23040757452000	21065	10476	85	0	\N
328760	1678	23040757453000	21065	10476	86	0	\N
328761	1678	23040757454000	21065	10476	87	0	\N
328762	1678	23040757455000	21065	10476	88	0	\N
328763	1285	1714307637751650	21065	10476	89	0	\N
328764	1039	911784465000000	21065	10476	90	0	\N
328765	1159	615200750000000	21065	10476	91	0	\N
328766	919	508811775000000	21065	10476	92	0	\N
328767	2016	2332000000000	21065	10476	93	0	\N
328768	2269	649000000000	21065	10476	94	0	\N
328769	1678	23040757456000	21065	10476	95	0	\N
328770	1678	23040757457000	21065	10476	96	0	\N
328771	1678	23040757458000	21065	10476	97	0	\N
328772	1678	23040757459000	21065	10476	98	0	\N
328773	1678	23040757460000	21065	10476	99	0	\N
328774	1678	23040757461000	21065	10476	100	0	\N
328775	1678	23040757462000	21065	10476	101	0	\N
328776	1678	23040757463000	21065	10476	102	0	\N
328777	1678	23040757464000	21065	10476	103	0	\N
328778	1678	23040757465000	21065	10476	104	0	\N
328779	1678	23040757466000	21065	10476	105	0	\N
328780	1678	23040757467000	21065	10476	106	0	\N
328781	1678	23040757468000	21065	10476	107	0	\N
328782	1678	23040757469000	21065	10476	108	0	\N
328783	1678	23040757470000	21065	10476	109	0	\N
328784	1678	23040757471000	21065	10476	110	0	\N
328785	1678	23040757472000	21065	10476	111	0	\N
328786	1678	23040757473000	21065	10476	112	0	\N
328787	1678	23040757474000	21065	10476	113	0	\N
328788	1678	23040757475000	21065	10476	114	0	\N
328789	1678	23040757476000	21065	10476	115	0	\N
328790	1678	23040757477000	21065	10476	116	0	\N
328791	1678	23040757478000	21065	10476	117	0	\N
328792	1678	23040757479000	21065	10476	118	0	\N
328793	1678	23040757480000	21065	10476	119	0	\N
328794	1678	23040757481000	21065	10476	120	0	\N
328795	1678	23040757482000	21065	10476	121	0	\N
328796	1678	23040757483000	21065	10476	122	0	\N
328797	1678	23040757484000	21065	10476	123	0	\N
328798	1678	23040757485000	21065	10476	124	0	\N
328799	1678	23040757486000	21065	10476	125	0	\N
328800	1678	23040757515000	21066	10585	0	0	\N
328801	1874	16256000	21066	10585	1	0	\N
328805	1678	23040757515000	21068	10585	0	0	\N
328806	1874	16257000	21068	10585	1	0	\N
328807	1874	16258000	21068	10585	2	0	\N
328808	1678	23040757515000	21069	10585	0	0	\N
328809	1874	16257000	21069	10585	1	0	\N
328810	1874	16258000	21069	10585	2	0	\N
328817	1678	23040757519000	21071	10587	0	0	\N
328818	1874	16265000	21071	10587	1	0	\N
328819	1874	16267000	21071	10587	2	0	\N
328825	1678	23040757520000	21074	10588	0	0	\N
328826	1874	16269000	21074	10588	1	0	\N
328827	1678	23040757520000	21075	10588	0	0	\N
328828	1874	16269000	21075	10588	1	0	\N
328829	1678	23040757520000	21076	10588	0	0	\N
328830	1874	16269000	21076	10588	1	0	\N
328833	1678	23040757522000	21078	10590	0	0	\N
328834	1874	16272000	21078	10590	1	0	\N
328835	1874	16274000	21078	10590	2	0	\N
328839	1678	23040757523000	21080	10591	0	0	\N
328840	1874	16276000	21080	10591	1	0	\N
328804	1874	16258000	21067	10585	2	0	2
328811	1678	23040757516000	21070	10586	0	0	0
328812	1678	23040757517000	21070	10586	1	0	0
328813	1678	23040757518000	21070	10586	2	0	0
328814	1874	16260000	21070	10586	3	0	2
328816	1874	16264000	21070	10586	5	0	2
328820	1678	23040757519000	21072	10587	0	0	0
328821	1874	16265000	21072	10587	1	0	2
328822	1874	16267000	21072	10587	2	0	2
328823	1678	23040757520000	21073	10588	0	0	0
328831	1678	23040757521000	21077	10589	0	0	0
328832	1874	16271000	21077	10589	1	0	2
328836	1678	23040757522000	21079	10590	0	0	0
328837	1874	16272000	21079	10590	1	0	2
328841	1678	23040757523000	21081	10591	0	0	0
328842	1874	16276000	21081	10591	1	0	2
328843	1678	23040757524000	21082	10592	0	0	0
328844	1874	16278000	21082	10592	1	0	2
328845	1678	23040757525000	21083	10593	0	0	0
328847	1874	16279000	21083	10593	2	0	2
328848	1874	16281000	21083	10593	3	0	2
328850	1678	23040757525000	21084	10593	0	0	\N
328851	1678	23040757526000	21084	10593	1	0	\N
328852	1874	16279000	21084	10593	2	0	\N
328853	1874	16281000	21084	10593	3	0	\N
328854	1874	16283000	21084	10593	5	0	\N
328855	1678	23040757525000	21085	10593	0	0	\N
328856	1678	23040757526000	21085	10593	1	0	\N
328857	1874	16279000	21085	10593	2	0	\N
328858	1874	16281000	21085	10593	3	0	\N
328859	1874	16283000	21085	10593	5	0	\N
328860	1678	23040757527000	21086	10594	0	0	\N
328861	1874	16285000	21086	10594	1	0	\N
328862	1678	23040757527000	21087	10594	0	0	\N
328863	1874	16285000	21087	10594	1	0	\N
328864	1678	23040757527000	21088	10594	0	0	\N
328865	1874	16285000	21088	10594	1	0	\N
328868	1678	23040757527000	21090	10594	0	0	\N
328869	1874	16285000	21090	10594	1	0	\N
328875	1850	22240418949999	21092	10579	0	0	\N
328876	1850	22241418949999	21092	10579	1	0	\N
328877	1277	1709780037751650	21092	10579	2	0	\N
328878	1031	909376565000000	21092	10579	3	0	\N
328879	1151	613574650000000	21092	10579	4	0	\N
328880	911	507467575000000	21092	10579	5	0	\N
328881	1678	23040757530000	21093	10596	0	0	\N
328882	1678	23040757531000	21093	10596	1	0	\N
328883	1874	16292000	21093	10596	2	0	\N
328884	1874	16294000	21093	10596	3	0	\N
328885	1678	23040757530000	21094	10596	0	0	\N
328886	1678	23040757531000	21094	10596	1	0	\N
328887	1874	16292000	21094	10596	2	0	\N
328888	1874	16294000	21094	10596	3	0	\N
328889	1678	23040757530000	21095	10596	0	0	\N
328890	1678	23040757531000	21095	10596	1	0	\N
328891	1874	16292000	21095	10596	2	0	\N
328892	1874	16294000	21095	10596	3	0	\N
328893	1678	23040757530000	21096	10596	0	0	\N
328894	1678	23040757531000	21096	10596	1	0	\N
328895	1874	16292000	21096	10596	2	0	\N
328896	1874	16294000	21096	10596	3	0	\N
328901	1678	23040757532000	21098	10597	0	0	\N
328902	1874	16295000	21098	10597	1	0	\N
328903	1874	16297000	21098	10597	2	0	\N
328904	1678	23040757532000	21099	10597	0	0	\N
328905	1874	16295000	21099	10597	1	0	\N
328906	1874	16297000	21099	10597	2	0	\N
328911	1678	23040757533000	21102	10598	0	0	\N
328917	1678	23040757535000	21105	10600	0	0	\N
328918	1874	16300000	21105	10600	1	0	\N
328919	1874	16302000	21105	10600	2	0	\N
328920	1678	23040757534000	21106	10599	0	0	\N
328921	1678	23040757535000	21106	10599	1	0	\N
328922	1678	23040757536000	21106	10599	2	0	\N
328923	1874	16298000	21106	10599	3	0	\N
328924	1874	16300000	21106	10599	4	0	\N
328925	1874	16302000	21106	10599	5	0	\N
328926	1874	16304000	21106	10599	6	0	\N
328927	1678	23040757535000	21107	10600	0	0	\N
328928	1678	23040757536000	21107	10600	1	0	\N
328929	1874	16300000	21107	10600	2	0	\N
328930	1874	16302000	21107	10600	3	0	\N
328931	1874	16304000	21107	10600	4	0	\N
328932	1678	23040757536000	21108	10601	0	0	\N
328933	1678	23040757537000	21108	10601	1	0	\N
328934	1874	16304000	21108	10601	2	0	\N
328935	1874	16306000	21108	10601	3	0	\N
328941	1678	23040757538000	21111	10602	0	0	\N
328942	1678	23040757539000	21112	10603	0	0	\N
328943	1874	16307000	21112	10603	1	0	\N
328944	1874	16309000	21112	10603	2	0	\N
328945	1678	23040757539000	21113	10603	0	0	\N
328946	1874	16307000	21113	10603	1	0	\N
328947	1874	16309000	21113	10603	2	0	\N
328951	1678	23040757540000	21115	10604	0	0	\N
328952	1874	16311000	21115	10604	1	0	\N
328964	1678	23040757545000	21120	10608	0	0	\N
328965	1874	16321000	21120	10608	1	0	\N
328966	1874	16323000	21120	10608	2	0	\N
328976	1874	16330000	21123	10610	0	0	\N
328977	1874	16332000	21123	10610	1	0	\N
328978	1678	23040757549000	21124	10610	0	0	\N
328979	1874	16330000	21124	10610	1	0	\N
328980	1874	16332000	21124	10610	2	0	\N
328867	1874	16285000	21089	10594	1	0	2
328870	1678	23040757528000	21091	10595	0	0	0
328871	1678	23040757529000	21091	10595	1	0	0
328872	1874	16287000	21091	10595	2	0	2
328873	1874	16289000	21091	10595	3	0	2
328897	1678	23040757530000	21097	10596	0	0	0
328898	1678	23040757531000	21097	10596	1	0	0
328899	1874	16292000	21097	10596	2	0	2
328900	1874	16294000	21097	10596	3	0	2
328907	1678	23040757532000	21100	10597	0	0	0
328909	1874	16297000	21100	10597	2	0	2
328910	1678	23040757533000	21101	10598	0	0	0
328912	1678	23040757534000	21103	10599	0	0	0
328913	1874	16299000	21103	10599	1	0	2
328915	1874	16300000	21104	10600	1	0	2
328916	1874	16302000	21104	10600	2	0	2
328936	1678	23040757536000	21109	10601	0	0	0
328937	1678	23040757537000	21109	10601	1	0	0
328938	1874	16304000	21109	10601	2	0	2
328940	1678	23040757538000	21110	10602	0	0	0
328948	1678	23040757539000	21114	10603	0	0	0
328949	1874	16307000	21114	10603	1	0	2
328950	1874	16309000	21114	10603	2	0	2
328953	1678	23040757540000	21116	10604	0	0	0
328955	1678	23040757541000	21117	10605	0	0	0
328956	1874	16313000	21117	10605	1	0	2
328957	1678	23040757542000	21118	10606	0	0	0
328958	1874	16315000	21118	10606	1	0	2
328960	1678	23040757543000	21119	10607	0	0	0
328961	1678	23040757544000	21119	10607	1	0	0
328962	1874	16318000	21119	10607	2	0	2
328963	1874	16320000	21119	10607	3	0	2
328967	1678	23040757545000	21121	10608	0	0	0
328969	1874	16323000	21121	10608	2	0	2
328970	1678	23040757546000	21122	10609	0	0	0
328971	1678	23040757547000	21122	10609	1	0	0
328972	1678	23040757548000	21122	10609	2	0	0
328973	1874	16325000	21122	10609	3	0	2
328975	1874	16329000	21122	10609	5	0	2
328981	1874	16330000	21125	10610	0	0	2
328982	1874	16332000	21125	10610	1	0	2
328983	1678	23040757549000	21126	10611	0	0	0
328985	1678	23040757549000	21127	10611	0	0	\N
328986	1874	16334000	21127	10611	1	0	\N
328989	1678	23040757550000	21129	10612	0	0	\N
328990	1874	16336000	21129	10612	1	0	\N
328991	1678	23040757551000	21130	10613	0	0	\N
328992	1874	16337000	21130	10613	1	0	\N
328993	1874	16339000	21130	10613	2	0	\N
328997	1678	23040757551000	21132	10613	0	0	\N
328998	1874	16337000	21132	10613	1	0	\N
328999	1874	16339000	21132	10613	2	0	\N
329000	1678	23040757551000	21133	10613	0	0	\N
329001	1874	16337000	21133	10613	1	0	\N
329002	1874	16339000	21133	10613	2	0	\N
329003	1678	23040757552000	21134	10614	0	0	\N
329004	1678	23040757553000	21134	10614	1	0	\N
329005	1874	16341000	21134	10614	2	0	\N
329006	1874	16343000	21134	10614	3	0	\N
329007	1678	23040757552000	21135	10614	0	0	\N
329008	1678	23040757553000	21135	10614	1	0	\N
329009	1874	16341000	21135	10614	2	0	\N
329010	1874	16343000	21135	10614	3	0	\N
329011	1678	23040757552000	21137	10614	0	0	\N
329012	1678	23040757553000	21137	10614	1	0	\N
329013	1678	23040757552000	21138	10614	0	0	\N
329014	1678	23040757553000	21138	10614	1	0	\N
329015	1874	16341000	21138	10614	2	0	\N
329016	1874	16343000	21138	10614	3	0	\N
329017	1678	23040757552000	21139	10614	0	0	\N
329018	1678	23040757553000	21139	10614	1	0	\N
329019	1874	16341000	21139	10614	2	0	\N
329020	1874	16343000	21139	10614	3	0	\N
329030	1678	23040757555000	21142	10616	0	0	\N
329031	1874	16348000	21142	10616	1	0	\N
329032	1678	23040757555000	21143	10616	0	0	\N
329033	1874	16348000	21143	10616	1	0	\N
329051	1678	23040757563000	21148	10620	0	0	\N
329052	1874	16366000	21148	10620	1	0	\N
329053	1678	23040757563000	21149	10621	0	0	\N
329054	1678	23040757564000	21149	10621	1	0	\N
329055	1678	23040757565000	21149	10621	2	0	\N
329056	1874	16366000	21149	10621	3	0	\N
329057	1874	16368000	21149	10621	4	0	\N
329058	1874	16370000	21149	10621	5	0	\N
329070	1678	23040757568000	21152	10623	0	0	\N
329071	1874	16376000	21152	10623	1	0	\N
329076	1678	23040757569000	21155	10624	0	0	\N
329077	1874	16378000	21155	10624	1	0	\N
329080	1678	23040757570000	21157	10625	0	0	\N
329081	1874	16380000	21157	10625	1	0	\N
329090	1678	23040757575000	21160	10628	0	0	\N
329091	1874	16390000	21160	10628	1	0	\N
329094	1678	23040757575000	21162	10628	0	0	\N
329095	1874	16390000	21162	10628	1	0	\N
329100	1678	23040757577000	21165	10630	0	0	\N
329101	1874	16394000	21165	10630	1	0	\N
329106	1678	23040757579000	21168	10632	0	0	\N
329107	1874	16398000	21168	10632	1	0	\N
329108	1850	22240418949999	21169	10471	0	0	\N
329109	2270	699000000000	21169	10471	1	0	\N
329110	1338	1705962637751650	21169	10471	2	0	\N
329111	1092	907346465000000	21169	10471	3	0	\N
329112	2271	2000000000	21169	10471	4	0	\N
329113	1958	5031186000000	21169	10471	5	0	\N
329114	1212	612204750000000	21169	10471	6	0	\N
329115	972	506334775000000	21169	10471	7	0	\N
329116	588	66471000000000	21169	10471	8	0	\N
329117	1850	22241418949999	21169	10471	9	0	\N
329118	259	66010000000000	21169	10471	10	0	\N
329119	2269	2000000000	21169	10471	11	0	\N
329120	1289	1708728477751650	21169	10471	12	0	\N
328994	1678	23040757551000	21131	10613	0	0	0
328995	1874	16337000	21131	10613	1	0	2
328996	1874	16339000	21131	10613	2	0	2
329021	1678	23040757552000	21140	10615	0	0	0
329022	1678	23040757553000	21140	10615	1	0	0
329024	1874	16340000	21140	10615	3	0	2
329025	1874	16342000	21140	10615	4	0	2
329026	1874	16344000	21140	10615	5	0	2
329027	1874	16346000	21140	10615	6	0	2
329028	1678	23040757555000	21141	10616	0	0	0
329034	1678	23040757556000	21144	10617	0	0	0
329035	1678	23040757557000	21144	10617	1	0	0
329036	1874	16350000	21144	10617	2	0	2
329037	1874	16352000	21144	10617	3	0	2
329039	1874	16353000	21145	10618	1	0	2
329040	1874	16355000	21145	10618	2	0	2
329041	259	66010000000000	21146	10619	0	0	0
329042	1678	23040757559000	21146	10619	1	0	0
329043	1678	23040757560000	21146	10619	3	0	0
329045	1678	23040757562000	21146	10619	5	0	0
329046	1874	16356000	21146	10619	6	0	2
329047	1874	16358000	21146	10619	7	0	2
329048	1874	16360000	21146	10619	8	0	2
329049	1874	16362000	21146	10619	9	0	2
329059	1678	23040757563000	21150	10621	0	0	0
329060	1678	23040757564000	21150	10621	1	0	0
329061	1678	23040757565000	21150	10621	2	0	0
329062	1874	16366000	21150	10621	3	0	2
329064	1874	16370000	21150	10621	5	0	2
329065	1678	23040757566000	21151	10622	0	0	0
329066	1678	23040757567000	21151	10622	1	0	0
329067	1596	1440048000000	21151	10622	2	0	16
329068	1874	16372000	21151	10622	3	0	2
329072	1678	23040757568000	21153	10623	0	0	0
329073	1874	16376000	21153	10623	1	0	2
329074	1678	23040757569000	21154	10624	0	0	0
329075	1874	16378000	21154	10624	1	0	2
329078	1678	23040757570000	21156	10625	0	0	0
329082	1678	23040757571000	21158	10626	0	0	0
329083	1874	16382000	21158	10626	1	0	2
329084	1678	23040757572000	21159	10627	0	0	0
329085	1678	23040757573000	21159	10627	1	0	0
329087	1874	16384000	21159	10627	3	0	2
329088	1874	16386000	21159	10627	4	0	2
329089	1874	16388000	21159	10627	5	0	2
329092	1678	23040757575000	21161	10628	0	0	0
329093	1874	16390000	21161	10628	1	0	2
329097	1874	16392000	21163	10629	1	0	2
329098	1678	23040757577000	21164	10630	0	0	0
329099	1874	16394000	21164	10630	1	0	2
329102	1678	23040757578000	21166	10631	0	0	0
329103	1874	16396000	21166	10631	1	0	2
329105	1874	16398000	21167	10632	1	0	2
329121	1043	908817755000000	21169	10471	13	0	\N
329122	1678	23040757396000	21169	10471	14	0	\N
329123	1277	1709780037751650	21169	10471	15	0	\N
329124	1031	909376565000000	21169	10471	16	0	\N
329125	1151	613574650000000	21169	10471	17	0	\N
329126	911	507467575000000	21169	10471	18	0	\N
329127	1163	613197810000000	21169	10471	19	0	\N
329128	923	507155005000000	21169	10471	20	0	\N
329129	1678	23040757397000	21169	10471	21	0	\N
329130	1516	7792474350000	21169	10471	22	0	\N
329131	1445	1004169000000	21169	10471	23	0	\N
329132	924	507246525000000	21169	10471	24	0	\N
329133	1164	613308350000000	21169	10471	25	0	\N
329134	1044	908981365000000	21169	10471	26	0	\N
329135	1290	1709035637751650	21169	10471	27	0	\N
329136	1300	1710301631910020	21169	10471	28	0	\N
329137	1174	613761729502880	21169	10471	29	0	\N
329138	1054	909654073462350	21169	10471	30	0	\N
329139	934	507621887704640	21169	10471	31	0	\N
329140	58	70307296999641	21169	10471	32	0	\N
329141	1678	23040757398000	21169	10471	33	0	\N
329142	1678	23040757399000	21169	10471	34	0	\N
329143	1678	23040757400000	21169	10471	35	0	\N
329144	1678	23040757401000	21169	10471	36	0	\N
329145	1678	23040757402000	21169	10471	37	0	\N
329146	1678	23040757403000	21169	10471	38	0	\N
329147	1678	23040757404000	21169	10471	39	0	\N
329148	1678	23040757405000	21169	10471	40	0	\N
329149	1678	23040757406000	21169	10471	41	0	\N
329150	1678	23040757407000	21169	10471	42	0	\N
329151	1678	23040757408000	21169	10471	43	0	\N
329152	1678	23040757409000	21169	10471	44	0	\N
329153	1678	23040757410000	21169	10471	45	0	\N
329154	1678	23040757411000	21169	10471	46	0	\N
329155	1678	23040757412000	21169	10471	47	0	\N
329156	1678	23040757413000	21169	10471	48	0	\N
329157	1678	23040757414000	21169	10471	49	0	\N
329158	1678	23040757415000	21169	10471	50	0	\N
329159	1678	23040757416000	21169	10471	51	0	\N
329160	1678	23040757417000	21169	10471	52	0	\N
329161	1678	23040757418000	21169	10471	53	0	\N
329162	1678	23040757419000	21169	10471	54	0	\N
329163	1678	23040757420000	21169	10471	55	0	\N
329164	1678	23040757421000	21169	10471	56	0	\N
329165	1678	23040757422000	21169	10471	57	0	\N
329166	1678	23040757423000	21169	10471	58	0	\N
329167	1678	23040757424000	21169	10471	59	0	\N
329168	1678	23040757425000	21169	10471	60	0	\N
329169	1678	23040757426000	21169	10471	61	0	\N
329170	1678	23040757427000	21169	10471	62	0	\N
329171	1678	23040757428000	21169	10471	63	0	\N
329172	1678	23040757429000	21169	10471	64	0	\N
329173	1678	23040757430000	21169	10471	65	0	\N
329174	1678	23040757431000	21169	10471	66	0	\N
329175	1678	23040757432000	21169	10471	67	0	\N
329176	1678	23040757433000	21169	10471	68	0	\N
329177	1678	23040757434000	21169	10471	69	0	\N
329178	1678	23040757435000	21169	10471	70	0	\N
329179	1678	23040757436000	21169	10471	71	0	\N
329180	1678	23040757437000	21169	10471	73	0	\N
329181	1678	23040757438000	21169	10471	74	0	\N
329182	1678	23040757439000	21169	10471	75	0	\N
329183	1678	23040757440000	21169	10471	76	0	\N
329184	1678	23040757441000	21169	10471	77	0	\N
329185	1678	23040757442000	21169	10471	78	0	\N
329186	1678	23040757443000	21169	10471	79	0	\N
329187	1678	23040757444000	21169	10471	80	0	\N
329188	1678	23040757445000	21169	10471	81	0	\N
329189	1678	23040757446000	21169	10471	82	0	\N
329190	1678	23040757447000	21169	10471	83	0	\N
329191	1678	23040757448000	21169	10471	84	0	\N
329192	1678	23040757449000	21169	10471	85	0	\N
329193	1678	23040757450000	21169	10471	86	0	\N
329194	1678	23040757451000	21169	10471	87	0	\N
329195	1678	23040757452000	21169	10471	88	0	\N
329196	1678	23040757453000	21169	10471	89	0	\N
329197	1678	23040757454000	21169	10471	90	0	\N
329198	1678	23040757455000	21169	10471	91	0	\N
329199	1285	1714307637751650	21169	10471	92	0	\N
329200	1039	911784465000000	21169	10471	93	0	\N
329201	1159	615200750000000	21169	10471	94	0	\N
329202	919	508811775000000	21169	10471	95	0	\N
329203	2016	2332000000000	21169	10471	96	0	\N
329204	2269	649000000000	21169	10471	97	0	\N
329205	1678	23040757456000	21169	10471	98	0	\N
329206	1678	23040757457000	21169	10471	99	0	\N
329207	1678	23040757458000	21169	10471	100	0	\N
329208	1678	23040757459000	21169	10471	101	0	\N
329209	1678	23040757460000	21169	10471	102	0	\N
329210	1678	23040757461000	21169	10471	103	0	\N
329211	1678	23040757462000	21169	10471	104	0	\N
329212	1678	23040757463000	21169	10471	105	0	\N
329213	1678	23040757464000	21169	10471	106	0	\N
329214	1678	23040757465000	21169	10471	107	0	\N
329215	1678	23040757466000	21169	10471	108	0	\N
329216	1678	23040757467000	21169	10471	109	0	\N
329217	1678	23040757468000	21169	10471	110	0	\N
329218	1678	23040757469000	21169	10471	111	0	\N
329219	1678	23040757470000	21169	10471	112	0	\N
329220	1678	23040757471000	21169	10471	113	0	\N
329221	1678	23040757472000	21169	10471	114	0	\N
329222	1678	23040757473000	21169	10471	115	0	\N
329223	1678	23040757474000	21169	10471	116	0	\N
329224	1678	23040757475000	21169	10471	117	0	\N
329225	1678	23040757476000	21169	10471	118	0	\N
329226	1678	23040757477000	21169	10471	119	0	\N
329227	1678	23040757478000	21169	10471	120	0	\N
329228	1678	23040757479000	21169	10471	121	0	\N
329229	1678	23040757480000	21169	10471	122	0	\N
329230	1678	23040757481000	21169	10471	123	0	\N
329231	1678	23040757482000	21169	10471	124	0	\N
329232	1678	23040757483000	21169	10471	125	0	\N
329233	1678	23040757580000	21170	10633	0	0	\N
329234	1874	16400000	21170	10633	1	0	\N
329235	1850	22240418949999	21171	10575	0	0	\N
329236	1850	22241418949999	21171	10575	1	0	\N
329237	259	66010000000000	21171	10575	2	0	\N
329238	1277	1709780037751650	21171	10575	3	0	\N
329239	1031	909376565000000	21171	10575	4	0	\N
329240	1151	613574650000000	21171	10575	5	0	\N
329241	911	507467575000000	21171	10575	6	0	\N
329242	1596	1440048000000	21171	10575	7	0	\N
329243	1678	23040757580000	21172	10633	0	0	\N
329244	1874	16400000	21172	10633	1	0	\N
329245	1678	23040757580000	21173	10633	0	0	\N
329246	1874	16400000	21173	10633	1	0	\N
329249	1678	23040757580000	21175	10633	0	0	\N
329250	1874	16400000	21175	10633	1	0	\N
329251	1678	23040757581000	21176	10634	0	0	\N
329252	1678	23040757582000	21176	10634	1	0	\N
329253	1678	23040757583000	21176	10634	2	0	\N
329254	1874	16402000	21176	10634	3	0	\N
329255	1874	16404000	21176	10634	4	0	\N
329256	1678	23040757581000	21177	10634	0	0	\N
329257	1678	23040757582000	21177	10634	1	0	\N
329258	1678	23040757583000	21177	10634	2	0	\N
329259	1874	16402000	21177	10634	3	0	\N
329260	1874	16404000	21177	10634	4	0	\N
329268	1678	23040757584000	21180	10635	0	0	\N
329269	1874	16406000	21180	10635	1	0	\N
329274	1678	23040757587000	21182	10637	0	0	\N
329275	1874	16412000	21182	10637	1	0	\N
329284	1678	23040757588000	21185	10638	0	0	\N
329285	1678	23040757589000	21185	10638	1	0	\N
329286	1678	23040757590000	21185	10638	2	0	\N
329287	1874	16414000	21185	10638	3	0	\N
329288	1874	16416000	21185	10638	4	0	\N
329289	1874	16418000	21185	10638	5	0	\N
329290	1678	23040757591000	21186	10639	0	0	\N
329291	563	83475615000000	21186	10639	1	0	\N
329294	259	66010000000000	21188	10477	0	0	\N
329295	1678	23040757487000	21188	10477	1	0	\N
329296	1678	23040757488000	21188	10477	2	0	\N
329297	1678	23040757489000	21188	10477	3	0	\N
329298	1678	23040757490000	21188	10477	4	0	\N
329299	1678	23040757491000	21188	10477	5	0	\N
329300	1678	23040757492000	21188	10477	6	0	\N
329301	1678	23040757493000	21188	10477	7	0	\N
329302	1678	23040757494000	21188	10477	8	0	\N
329303	1678	23040757495000	21188	10477	9	0	\N
329304	1678	23040757496000	21188	10477	10	0	\N
329305	1678	23040757497000	21188	10477	11	0	\N
329306	1678	23040757498000	21188	10477	12	0	\N
329307	1678	23040757499000	21188	10477	13	0	\N
329308	1678	23040757500000	21188	10477	14	0	\N
329309	1678	23040757501000	21188	10477	15	0	\N
329310	1678	23040757502000	21188	10477	16	0	\N
329311	1678	23040757503000	21188	10477	17	0	\N
329312	1678	23040757504000	21188	10477	18	0	\N
329313	1678	23040757505000	21188	10477	19	0	\N
329314	1678	23040757506000	21188	10477	20	0	\N
329315	1678	23040757507000	21188	10477	21	0	\N
329316	1678	23040757508000	21188	10477	22	0	\N
329317	1678	23040757509000	21188	10477	23	0	\N
329318	1678	23040757510000	21188	10477	24	0	\N
329319	1678	23040757511000	21188	10477	25	0	\N
329320	1678	23040757512000	21188	10477	26	0	\N
329321	1678	23040757513000	21188	10477	27	0	\N
329322	1678	23040757514000	21188	10477	28	0	\N
329323	1678	23040757515000	21188	10477	29	0	\N
329324	1678	23040757516000	21188	10477	30	0	\N
329325	1678	23040757517000	21188	10477	31	0	\N
329326	1678	23040757518000	21188	10477	32	0	\N
329327	1678	23040757519000	21188	10477	33	0	\N
329328	1678	23040757520000	21188	10477	34	0	\N
329329	1678	23040757521000	21188	10477	35	0	\N
329330	1678	23040757522000	21188	10477	36	0	\N
329331	1678	23040757523000	21188	10477	37	0	\N
329332	1678	23040757524000	21188	10477	38	0	\N
329333	1678	23040757525000	21188	10477	39	0	\N
329334	1678	23040757526000	21188	10477	40	0	\N
329335	1678	23040757527000	21188	10477	41	0	\N
329336	1678	23040757528000	21188	10477	42	0	\N
329337	1678	23040757529000	21188	10477	43	0	\N
329338	1678	23040757530000	21188	10477	44	0	\N
329339	1678	23040757531000	21188	10477	45	0	\N
329340	1678	23040757532000	21188	10477	46	0	\N
329341	1678	23040757533000	21188	10477	47	0	\N
329342	1678	23040757534000	21188	10477	48	0	\N
329343	1678	23040757535000	21188	10477	49	0	\N
329344	1678	23040757536000	21188	10477	50	0	\N
329345	1678	23040757537000	21188	10477	51	0	\N
329346	1678	23040757538000	21188	10477	52	0	\N
329347	1678	23040757539000	21188	10477	53	0	\N
329348	1678	23040757540000	21188	10477	54	0	\N
329349	1678	23040757541000	21188	10477	55	0	\N
329350	1678	23040757542000	21188	10477	56	0	\N
329351	1678	23040757543000	21188	10477	58	0	\N
329352	1678	23040757544000	21188	10477	59	0	\N
329353	1678	23040757545000	21188	10477	60	0	\N
329354	1678	23040757546000	21188	10477	61	0	\N
329355	1678	23040757547000	21188	10477	62	0	\N
329356	1678	23040757548000	21188	10477	63	0	\N
329357	1678	23040757549000	21188	10477	64	0	\N
329358	1678	23040757550000	21188	10477	65	0	\N
329359	1678	23040757551000	21188	10477	66	0	\N
329360	1678	23040757552000	21188	10477	67	0	\N
329361	1678	23040757553000	21188	10477	68	0	\N
329362	1678	23040757554000	21188	10477	69	0	\N
329363	1678	23040757555000	21188	10477	70	0	\N
329364	1678	23040757556000	21188	10477	71	0	\N
329365	1678	23040757557000	21188	10477	72	0	\N
329366	1678	23040757558000	21188	10477	73	0	\N
329367	1678	23040757559000	21188	10477	74	0	\N
329368	1678	23040757560000	21188	10477	75	0	\N
329369	1678	23040757561000	21188	10477	76	0	\N
329370	1678	23040757562000	21188	10477	77	0	\N
329371	1678	23040757563000	21188	10477	78	0	\N
329372	1678	23040757564000	21188	10477	79	0	\N
329373	1678	23040757565000	21188	10477	80	0	\N
329374	1678	23040757566000	21188	10477	81	0	\N
329375	1678	23040757567000	21188	10477	82	0	\N
329376	1678	23040757568000	21188	10477	83	0	\N
329377	1678	23040757569000	21188	10477	84	0	\N
329378	1678	23040757570000	21188	10477	85	0	\N
329379	1678	23040757571000	21188	10477	86	0	\N
329380	1678	23040757572000	21188	10477	87	0	\N
329381	1678	23040757573000	21188	10477	88	0	\N
329382	1678	23040757574000	21188	10477	89	0	\N
329383	1678	23040757575000	21188	10477	90	0	\N
329384	1678	23040757576000	21188	10477	91	0	\N
329385	1678	23040757577000	21188	10477	92	0	\N
329386	1678	23040757578000	21188	10477	93	0	\N
329387	1678	23040757579000	21188	10477	94	0	\N
329388	1678	23040757580000	21188	10477	95	0	\N
329389	1678	23040757581000	21188	10477	96	0	\N
329390	1678	23040757582000	21188	10477	97	0	\N
329391	1678	23040757583000	21188	10477	98	0	\N
329392	1678	23040757584000	21188	10477	99	0	\N
329263	1678	23040757583000	21178	10634	2	0	0
329264	1874	16402000	21178	10634	3	0	2
329265	1874	16404000	21178	10634	4	0	2
329266	1678	23040757584000	21179	10635	0	0	0
329267	1874	16406000	21179	10635	1	0	2
329271	1678	23040757586000	21181	10636	1	0	0
329272	1874	16408000	21181	10636	2	0	2
329273	1874	16410000	21181	10636	3	0	2
329276	1678	23040757587000	21183	10637	0	0	0
329277	1874	16412000	21183	10637	1	0	2
329279	1678	23040757589000	21184	10638	1	0	0
329280	1678	23040757590000	21184	10638	2	0	0
329281	1874	16414000	21184	10638	3	0	2
329282	1874	16416000	21184	10638	4	0	2
329292	1678	23040757591000	21187	10639	0	0	0
329293	563	83475615000000	21187	10639	1	0	11
329393	1678	23040757585000	21188	10477	100	0	\N
329394	1678	23040757586000	21188	10477	101	0	\N
329395	1678	23040757587000	21188	10477	102	0	\N
329396	1678	23040757588000	21188	10477	103	0	\N
329397	1678	23040757589000	21188	10477	104	0	\N
329398	1678	23040757590000	21188	10477	105	0	\N
329399	1678	23040757591000	21188	10477	106	0	\N
329400	1678	23040757592000	21188	10477	107	0	\N
329401	1850	22240418949999	21189	10557	0	0	\N
329402	1850	22241418949999	21189	10557	1	0	\N
329403	259	66010000000000	21189	10557	2	0	\N
329404	1289	1708728477751650	21189	10557	3	0	\N
329405	1043	908817755000000	21189	10557	4	0	\N
329406	1277	1709780037751650	21189	10557	5	0	\N
329407	1031	909376565000000	21189	10557	6	0	\N
329408	1151	613574650000000	21189	10557	7	0	\N
329409	911	507467575000000	21189	10557	8	0	\N
329410	1163	613197810000000	21189	10557	9	0	\N
329411	923	507155005000000	21189	10557	10	0	\N
329412	1678	23040757474000	21189	10557	11	0	\N
329413	1300	1710301631910020	21189	10557	12	0	\N
329414	1174	613761729502880	21189	10557	13	0	\N
329415	1054	909654073462350	21189	10557	14	0	\N
329416	934	507621887704640	21189	10557	15	0	\N
329417	1678	23040757475000	21189	10557	16	0	\N
329418	1678	23040757476000	21189	10557	17	0	\N
329419	1678	23040757477000	21189	10557	18	0	\N
329420	1678	23040757478000	21189	10557	19	0	\N
329421	1678	23040757479000	21189	10557	20	0	\N
329422	1678	23040757480000	21189	10557	21	0	\N
329423	1678	23040757481000	21189	10557	22	0	\N
329424	1678	23040757482000	21189	10557	23	0	\N
329425	1678	23040757483000	21189	10557	24	0	\N
329426	1678	23040757484000	21189	10557	25	0	\N
329427	1678	23040757485000	21189	10557	26	0	\N
329428	1678	23040757486000	21189	10557	27	0	\N
329429	1678	23040757487000	21189	10557	28	0	\N
329430	1678	23040757488000	21189	10557	29	0	\N
329431	1678	23040757489000	21189	10557	30	0	\N
329432	1678	23040757490000	21189	10557	31	0	\N
329433	1678	23040757491000	21189	10557	32	0	\N
329434	1678	23040757492000	21189	10557	33	0	\N
329435	1678	23040757493000	21189	10557	34	0	\N
329436	1678	23040757494000	21189	10557	35	0	\N
329437	1678	23040757495000	21189	10557	36	0	\N
329438	1678	23040757496000	21189	10557	37	0	\N
329439	1678	23040757497000	21189	10557	38	0	\N
329440	1678	23040757498000	21189	10557	39	0	\N
329441	1678	23040757499000	21189	10557	40	0	\N
329442	1678	23040757500000	21189	10557	41	0	\N
329443	1678	23040757501000	21189	10557	42	0	\N
329444	1678	23040757502000	21189	10557	43	0	\N
329445	1678	23040757503000	21189	10557	44	0	\N
329446	1678	23040757504000	21189	10557	45	0	\N
329447	1678	23040757505000	21189	10557	46	0	\N
329448	1678	23040757506000	21189	10557	47	0	\N
329449	1678	23040757507000	21189	10557	48	0	\N
329450	1678	23040757508000	21189	10557	49	0	\N
329451	1678	23040757509000	21189	10557	50	0	\N
329452	1678	23040757510000	21189	10557	51	0	\N
329453	1678	23040757511000	21189	10557	52	0	\N
329454	1678	23040757512000	21189	10557	53	0	\N
329455	1678	23040757513000	21189	10557	54	0	\N
329456	1678	23040757514000	21189	10557	55	0	\N
329457	1678	23040757515000	21189	10557	56	0	\N
329458	1678	23040757516000	21189	10557	57	0	\N
329459	1678	23040757517000	21189	10557	58	0	\N
329460	1678	23040757518000	21189	10557	59	0	\N
329461	1678	23040757519000	21189	10557	60	0	\N
329462	1678	23040757520000	21189	10557	61	0	\N
329463	1678	23040757521000	21189	10557	62	0	\N
329464	1678	23040757522000	21189	10557	63	0	\N
329465	1678	23040757523000	21189	10557	64	0	\N
329466	1678	23040757524000	21189	10557	65	0	\N
329467	1678	23040757525000	21189	10557	66	0	\N
329468	1678	23040757526000	21189	10557	67	0	\N
329469	1678	23040757527000	21189	10557	68	0	\N
329470	1678	23040757528000	21189	10557	69	0	\N
329471	1678	23040757529000	21189	10557	70	0	\N
329472	1678	23040757530000	21189	10557	71	0	\N
329473	1678	23040757531000	21189	10557	72	0	\N
329474	1678	23040757532000	21189	10557	73	0	\N
329475	1678	23040757533000	21189	10557	74	0	\N
329476	1678	23040757534000	21189	10557	75	0	\N
329477	1678	23040757535000	21189	10557	77	0	\N
329478	1678	23040757536000	21189	10557	78	0	\N
329479	1678	23040757537000	21189	10557	79	0	\N
329480	1678	23040757538000	21189	10557	80	0	\N
329481	1678	23040757539000	21189	10557	81	0	\N
329482	1678	23040757540000	21189	10557	82	0	\N
329483	1678	23040757541000	21189	10557	83	0	\N
329484	1678	23040757542000	21189	10557	84	0	\N
329485	1678	23040757543000	21189	10557	85	0	\N
329486	1678	23040757544000	21189	10557	86	0	\N
329487	1678	23040757545000	21189	10557	87	0	\N
329488	1678	23040757546000	21189	10557	88	0	\N
329489	1678	23040757547000	21189	10557	89	0	\N
329490	1678	23040757548000	21189	10557	90	0	\N
329491	1678	23040757549000	21189	10557	91	0	\N
329492	1678	23040757550000	21189	10557	92	0	\N
329493	1678	23040757551000	21189	10557	93	0	\N
329494	1678	23040757552000	21189	10557	94	0	\N
329495	1678	23040757553000	21189	10557	95	0	\N
329496	1678	23040757554000	21189	10557	96	0	\N
329497	1678	23040757555000	21189	10557	97	0	\N
329498	1678	23040757556000	21189	10557	98	0	\N
329499	1678	23040757557000	21189	10557	99	0	\N
329500	1678	23040757558000	21189	10557	100	0	\N
329501	1678	23040757559000	21189	10557	101	0	\N
329502	1678	23040757560000	21189	10557	102	0	\N
329503	1678	23040757561000	21189	10557	103	0	\N
329504	1678	23040757562000	21189	10557	104	0	\N
329505	1678	23040757563000	21189	10557	105	0	\N
329506	1678	23040757564000	21189	10557	106	0	\N
329507	1678	23040757565000	21189	10557	107	0	\N
329508	1678	23040757566000	21189	10557	108	0	\N
329509	1678	23040757567000	21189	10557	109	0	\N
329510	1678	23040757568000	21189	10557	110	0	\N
329511	1678	23040757569000	21189	10557	111	0	\N
329512	1678	23040757570000	21189	10557	112	0	\N
329513	1678	23040757571000	21189	10557	113	0	\N
329514	1678	23040757572000	21189	10557	114	0	\N
329515	1678	23040757573000	21189	10557	115	0	\N
329516	1678	23040757574000	21189	10557	116	0	\N
329517	1678	23040757575000	21189	10557	117	0	\N
329518	1678	23040757576000	21189	10557	118	0	\N
329519	1678	23040757577000	21189	10557	119	0	\N
329520	1678	23040757578000	21189	10557	120	0	\N
329521	1678	23040757579000	21189	10557	121	0	\N
329522	1678	23040757580000	21189	10557	122	0	\N
329523	1678	23040757581000	21189	10557	123	0	\N
329524	1678	23040757582000	21189	10557	124	0	\N
329525	1678	23040757583000	21189	10557	125	0	\N
329526	1678	23040757592000	21190	10640	0	0	\N
329527	1678	23040757593000	21190	10640	1	0	\N
329528	1678	23040757594000	21190	10640	2	0	\N
329529	1678	23040757595000	21190	10640	3	0	\N
329530	1874	16420000	21190	10640	4	0	\N
329531	1874	16422000	21190	10640	5	0	\N
329532	1874	16424000	21190	10640	6	0	\N
329533	1874	16426000	21190	10640	7	0	\N
329545	1678	23040757596000	21193	10641	0	0	\N
329546	1359	1709956237751650	21193	10641	1	0	\N
329547	1874	16428000	21193	10641	2	0	\N
329550	1678	23040757598000	21195	10643	0	0	\N
329551	1874	16432000	21195	10643	2	0	\N
329554	1678	23040757598000	21197	10643	0	0	\N
329555	1874	16432000	21197	10643	2	0	\N
329568	1540	0	21200	10596	0	0	\N
329569	1540	0	21201	10587	0	0	\N
329570	1678	23040757603000	21202	10646	0	0	\N
329571	1678	23040757604000	21202	10646	1	0	\N
329572	1678	23040757605000	21202	10646	2	0	\N
329573	1874	16442000	21202	10646	3	0	\N
329574	1874	16444000	21202	10646	4	0	\N
329575	1874	16446000	21202	10646	5	0	\N
329584	1850	22240418949999	21205	10462	0	0	\N
329585	2270	699000000000	21205	10462	1	0	\N
329586	1338	1705962637751650	21205	10462	2	0	\N
329587	1092	907346465000000	21205	10462	3	0	\N
329588	2271	2000000000	21205	10462	4	0	\N
329589	1958	5031186000000	21205	10462	5	0	\N
329590	1212	612204750000000	21205	10462	6	0	\N
329591	972	506334775000000	21205	10462	7	0	\N
329592	588	66471000000000	21205	10462	8	0	\N
329593	1850	22241418949999	21205	10462	9	0	\N
329594	1678	23040757389000	21205	10462	10	0	\N
329595	259	66010000000000	21205	10462	11	0	\N
329596	2269	2000000000	21205	10462	12	0	\N
329597	1289	1708728477751650	21205	10462	13	0	\N
329598	1043	908817755000000	21205	10462	14	0	\N
329599	1277	1709780037751650	21205	10462	15	0	\N
329600	1031	909376565000000	21205	10462	16	0	\N
329601	1151	613574650000000	21205	10462	17	0	\N
329602	911	507467575000000	21205	10462	18	0	\N
329603	1163	613197810000000	21205	10462	19	0	\N
329604	923	507155005000000	21205	10462	20	0	\N
329605	1516	7792474350000	21205	10462	21	0	\N
329606	1445	1004169000000	21205	10462	22	0	\N
329607	924	507246525000000	21205	10462	23	0	\N
329608	1164	613308350000000	21205	10462	24	0	\N
329609	1044	908981365000000	21205	10462	25	0	\N
329610	1290	1709035637751650	21205	10462	26	0	\N
329611	1300	1710301631910020	21205	10462	27	0	\N
329612	1174	613761729502880	21205	10462	28	0	\N
329613	1054	909654073462350	21205	10462	29	0	\N
329614	934	507621887704640	21205	10462	30	0	\N
329615	58	70307296999641	21205	10462	31	0	\N
329616	1285	1714307637751650	21205	10462	32	0	\N
329617	1039	911784465000000	21205	10462	33	0	\N
329618	1159	615200750000000	21205	10462	34	0	\N
329619	919	508811775000000	21205	10462	35	0	\N
329620	2016	2332000000000	21205	10462	36	0	\N
329621	2269	649000000000	21205	10462	37	0	\N
329622	1678	23040757390000	21205	10462	38	0	\N
329623	1678	23040757391000	21205	10462	39	0	\N
329624	1678	23040757392000	21205	10462	40	0	\N
329625	1678	23040757393000	21205	10462	41	0	\N
329626	1678	23040757394000	21205	10462	42	0	\N
329627	1678	23040757395000	21205	10462	43	0	\N
329628	1678	23040757396000	21205	10462	44	0	\N
329629	1678	23040757397000	21205	10462	45	0	\N
329630	1678	23040757398000	21205	10462	46	0	\N
329631	1678	23040757399000	21205	10462	47	0	\N
329632	1678	23040757400000	21205	10462	48	0	\N
329633	1678	23040757401000	21205	10462	49	0	\N
329634	1678	23040757402000	21205	10462	50	0	\N
329635	1678	23040757403000	21205	10462	51	0	\N
329636	1678	23040757404000	21205	10462	52	0	\N
329637	1678	23040757405000	21205	10462	53	0	\N
329638	1678	23040757406000	21205	10462	54	0	\N
329639	1678	23040757407000	21205	10462	55	0	\N
329640	1678	23040757408000	21205	10462	56	0	\N
329641	1678	23040757409000	21205	10462	57	0	\N
329642	1678	23040757410000	21205	10462	58	0	\N
329643	1678	23040757411000	21205	10462	59	0	\N
329644	1678	23040757412000	21205	10462	60	0	\N
329645	1678	23040757413000	21205	10462	61	0	\N
329646	1678	23040757414000	21205	10462	62	0	\N
329647	1678	23040757415000	21205	10462	63	0	\N
329648	1678	23040757416000	21205	10462	64	0	\N
329649	1678	23040757417000	21205	10462	65	0	\N
329650	1678	23040757418000	21205	10462	66	0	\N
329651	1678	23040757419000	21205	10462	67	0	\N
329652	1678	23040757420000	21205	10462	68	0	\N
329653	1678	23040757421000	21205	10462	69	0	\N
329654	1678	23040757422000	21205	10462	70	0	\N
329655	1678	23040757423000	21205	10462	71	0	\N
329656	1678	23040757424000	21205	10462	72	0	\N
329657	1678	23040757425000	21205	10462	73	0	\N
329658	1678	23040757426000	21205	10462	74	0	\N
329659	1678	23040757427000	21205	10462	75	0	\N
329660	1678	23040757428000	21205	10462	76	0	\N
329661	1678	23040757429000	21205	10462	77	0	\N
329662	1678	23040757430000	21205	10462	78	0	\N
329663	1678	23040757431000	21205	10462	79	0	\N
329664	1678	23040757432000	21205	10462	80	0	\N
329536	1678	23040757594000	21191	10640	2	0	0
329537	1678	23040757595000	21191	10640	3	0	0
329538	1874	16420000	21191	10640	4	0	2
329539	1874	16422000	21191	10640	5	0	2
329540	1874	16424000	21191	10640	6	0	2
329542	1678	23040757596000	21192	10641	0	0	0
329543	1359	1709956237751650	21192	10641	1	0	0
329544	1874	16428000	21192	10641	2	0	2
329548	1678	23040757597000	21194	10642	0	0	0
329549	1874	16430000	21194	10642	1	0	2
329553	1874	16432000	21196	10643	2	0	2
329556	1678	23040757599000	21198	10644	0	0	0
329557	1874	16434000	21198	10644	1	0	2
329558	1678	23040757600000	21199	10645	0	0	0
329560	1678	23040757602000	21199	10645	2	0	0
329561	1113	909471065000000	21199	10645	3	0	0
329562	1233	613638650000000	21199	10645	4	0	0
329563	993	507519575000000	21199	10645	5	0	0
329564	1874	16436000	21199	10645	6	0	2
329566	1874	16438000	21199	10645	8	0	2
329567	1874	16440000	21199	10645	9	0	2
329576	1678	23040757603000	21203	10646	0	0	0
329577	1678	23040757604000	21203	10646	1	0	0
329578	1678	23040757605000	21203	10646	2	0	0
329580	1874	16444000	21203	10646	4	0	2
329581	1874	16446000	21203	10646	5	0	2
329582	1678	23040757606000	21204	10647	0	0	0
329583	1874	16448000	21204	10647	1	0	2
329665	1678	23040757433000	21205	10462	81	0	\N
329666	1678	23040757434000	21205	10462	82	0	\N
329667	1678	23040757435000	21205	10462	83	0	\N
329668	1678	23040757436000	21205	10462	84	0	\N
329669	1678	23040757437000	21205	10462	85	0	\N
329670	1678	23040757438000	21205	10462	86	0	\N
329671	1678	23040757439000	21205	10462	87	0	\N
329672	1678	23040757440000	21205	10462	88	0	\N
329673	1678	23040757441000	21205	10462	89	0	\N
329674	1678	23040757442000	21205	10462	90	0	\N
329675	1678	23040757443000	21205	10462	91	0	\N
329676	1678	23040757444000	21205	10462	92	0	\N
329677	1678	23040757445000	21205	10462	93	0	\N
329678	1678	23040757446000	21205	10462	94	0	\N
329679	1678	23040757447000	21205	10462	95	0	\N
329680	1678	23040757448000	21205	10462	96	0	\N
329681	1678	23040757449000	21205	10462	97	0	\N
329682	1678	23040757450000	21205	10462	98	0	\N
329683	1678	23040757451000	21205	10462	99	0	\N
329684	1678	23040757452000	21205	10462	100	0	\N
329685	1678	23040757453000	21205	10462	101	0	\N
329686	1678	23040757454000	21205	10462	102	0	\N
329687	1678	23040757455000	21205	10462	103	0	\N
329688	1678	23040757456000	21205	10462	104	0	\N
329689	1678	23040757457000	21205	10462	105	0	\N
329690	1678	23040757458000	21205	10462	107	0	\N
329691	1678	23040757459000	21205	10462	108	0	\N
329692	1678	23040757460000	21205	10462	109	0	\N
329693	1678	23040757461000	21205	10462	110	0	\N
329694	1678	23040757462000	21205	10462	111	0	\N
329695	1678	23040757463000	21205	10462	112	0	\N
329696	1678	23040757464000	21205	10462	113	0	\N
329697	1678	23040757465000	21205	10462	114	0	\N
329698	1678	23040757466000	21205	10462	115	0	\N
329699	1678	23040757467000	21205	10462	116	0	\N
329700	1678	23040757468000	21205	10462	117	0	\N
329701	1678	23040757469000	21205	10462	118	0	\N
329702	1678	23040757470000	21205	10462	119	0	\N
329703	1678	23040757471000	21205	10462	120	0	\N
329704	1678	23040757472000	21205	10462	121	0	\N
329705	1678	23040757473000	21205	10462	122	0	\N
329706	1678	23040757474000	21205	10462	123	0	\N
329707	1678	23040757475000	21205	10462	124	0	\N
329708	1678	23040757476000	21205	10462	125	0	\N
329709	563	83475615000000	21206	10629	0	0	\N
329710	1540	0	21206	10629	1	0	\N
329715	1678	23040757608000	21209	10649	0	0	\N
329716	1874	16452000	21209	10649	1	0	\N
329721	1678	23040757610000	21212	10651	0	0	\N
329722	1874	16456000	21212	10651	1	0	\N
329723	1678	23040757610000	21213	10651	0	0	\N
329724	1874	16456000	21213	10651	1	0	\N
329727	1678	23040757611000	21215	10652	0	0	\N
329728	1874	16458000	21215	10652	1	0	\N
329735	1678	23040757613000	21219	10654	0	0	\N
329736	1678	23040757614000	21219	10654	1	0	\N
329747	1678	23040757619000	21224	10657	0	0	\N
329748	1874	16474000	21224	10657	1	0	\N
329755	1678	23040757623000	21227	10660	0	0	\N
329756	1678	23040757624000	21227	10660	1	0	\N
329757	1874	16482000	21227	10660	2	0	\N
329758	1874	16484000	21227	10660	3	0	\N
329763	1678	23040757623000	21229	10660	0	0	\N
329764	1678	23040757624000	21229	10660	1	0	\N
329765	1874	16482000	21229	10660	2	0	\N
329766	1874	16484000	21229	10660	3	0	\N
329774	1678	23040757628000	21233	10663	0	0	\N
329775	1874	16490000	21233	10663	1	0	\N
329776	1678	23040757629000	21234	10664	0	0	\N
329777	1874	16492000	21234	10664	1	0	\N
329782	1386	1712107637751650	21237	10576	0	0	\N
329783	1140	910615465000000	21237	10576	1	0	\N
329784	1260	614410750000000	21237	10576	2	0	\N
329785	1020	508158775000000	21237	10576	3	0	\N
329786	563	83475615000000	21237	10576	4	0	\N
329787	1540	0	21237	10576	5	0	\N
329788	975	506861175900000	21237	10576	6	0	\N
329789	1095	908290884420000	21237	10576	7	0	\N
329790	1215	612841958680000	21237	10576	8	0	\N
329791	1341	1707738608751650	21237	10576	9	0	\N
329792	1386	1712107637751650	21238	10666	0	0	\N
329793	1140	910615465000000	21238	10666	1	0	\N
329794	1260	614410750000000	21238	10666	2	0	\N
329795	1678	23040757631000	21238	10666	3	0	\N
329796	1020	508158775000000	21238	10666	4	0	\N
329797	1874	16496000	21238	10666	5	0	\N
329798	975	506861175900000	21238	10666	6	0	\N
329799	1095	908290884420000	21238	10666	7	0	\N
329800	1215	612841958680000	21238	10666	8	0	\N
329713	1678	23040757608000	21208	10649	0	0	0
329714	1874	16452000	21208	10649	1	0	2
329717	1678	23040757609000	21210	10650	0	0	0
329718	1874	16454000	21210	10650	1	0	2
329719	1678	23040757610000	21211	10651	0	0	0
329725	1678	23040757611000	21214	10652	0	0	0
329726	1874	16458000	21214	10652	1	0	2
329729	1678	23040757612000	21216	10653	0	0	0
329730	1874	16460000	21216	10653	1	0	2
329731	1678	23040757613000	21218	10654	0	0	0
329733	1874	16462000	21218	10654	2	0	2
329734	1874	16464000	21218	10654	3	0	2
329737	1678	23040757615000	21221	10655	0	0	0
329738	1678	23040757616000	21221	10655	1	0	0
329740	1874	16466000	21221	10655	3	0	2
329741	1874	16468000	21221	10655	4	0	2
329742	1874	16470000	21221	10655	5	0	2
329743	1678	23040757618000	21222	10656	0	0	0
329744	1874	16472000	21222	10656	1	0	2
329746	1874	16474000	21223	10657	1	0	2
329749	1678	23040757620000	21225	10658	0	0	0
329750	1874	16476000	21225	10658	1	0	2
329751	1678	23040757621000	21226	10659	0	0	0
329752	1678	23040757622000	21226	10659	1	0	0
329754	1874	16480000	21226	10659	3	0	2
329759	1678	23040757623000	21228	10660	0	0	0
329760	1678	23040757624000	21228	10660	1	0	0
329761	1874	16482000	21228	10660	2	0	2
329767	1678	23040757625000	21230	10661	0	0	0
329768	1678	23040757626000	21231	10662	0	0	0
329769	1678	23040757627000	21231	10662	1	0	0
329770	1874	16486000	21231	10662	2	0	2
329771	1874	16488000	21231	10662	3	0	2
329773	1874	16490000	21232	10663	1	0	2
329778	1678	23040757629000	21235	10664	0	0	0
329779	1874	16492000	21235	10664	1	0	2
329780	1678	23040757630000	21236	10665	0	0	0
329781	1874	16494000	21236	10665	1	0	2
329801	1341	1707738608751650	21238	10666	9	0	\N
329814	1678	23040757632000	21241	10667	0	0	\N
329815	1874	16498000	21241	10667	2	0	\N
329816	1678	23040757632000	21242	10667	0	0	\N
329817	1874	16498000	21242	10667	2	0	\N
329818	1850	22240418949999	21243	10571	0	0	\N
329819	1850	22241418949999	21243	10571	1	0	\N
329820	1386	1712107637751650	21243	10571	2	0	\N
329821	259	66010000000000	21243	10571	3	0	\N
329822	1140	910615465000000	21243	10571	4	0	\N
329823	1260	614410750000000	21243	10571	5	0	\N
329824	1277	1709780037751650	21243	10571	6	0	\N
329825	1031	909376565000000	21243	10571	7	0	\N
329826	1151	613574650000000	21243	10571	8	0	\N
329827	911	507467575000000	21243	10571	9	0	\N
329828	1020	508158775000000	21243	10571	10	0	\N
329829	1596	1440048000000	21243	10571	11	0	\N
329830	563	83475615000000	21243	10571	12	0	\N
329831	1540	0	21243	10571	13	0	\N
329832	975	506861175900000	21243	10571	14	0	\N
329833	1095	908290884420000	21243	10571	15	0	\N
329834	1215	612841958680000	21243	10571	16	0	\N
329835	1341	1707738608751650	21243	10571	17	0	\N
329836	1678	23040757633000	21244	10668	0	0	\N
329837	1874	16500000	21244	10668	1	0	\N
329838	1678	23040757633000	21245	10668	0	0	\N
329839	1874	16500000	21245	10668	1	0	\N
329850	1383	1710879637751650	21249	10671	0	0	\N
329851	1137	909961465000000	21249	10671	1	0	\N
329852	1257	613969750000000	21249	10671	2	0	\N
329853	1017	507794775000000	21249	10671	3	0	\N
329854	1678	23040757636000	21249	10671	4	0	\N
329855	1678	23040757637000	21249	10671	5	0	\N
329856	1874	16506000	21249	10671	6	0	\N
329857	1874	16508000	21249	10671	7	0	\N
329858	1383	1710879637751650	21250	10671	0	0	\N
329859	1137	909961465000000	21250	10671	1	0	\N
329860	1257	613969750000000	21250	10671	2	0	\N
329861	1017	507794775000000	21250	10671	3	0	\N
329862	1678	23040757636000	21250	10671	4	0	\N
329863	1678	23040757637000	21250	10671	5	0	\N
329864	1874	16506000	21250	10671	6	0	\N
329865	1874	16508000	21250	10671	7	0	\N
329874	1383	1710879637751650	21252	10671	0	0	\N
329875	1137	909961465000000	21252	10671	1	0	\N
329876	1257	613969750000000	21252	10671	2	0	\N
329877	1017	507794775000000	21252	10671	3	0	\N
329878	1678	23040757636000	21252	10671	4	0	\N
329879	1678	23040757637000	21252	10671	5	0	\N
329880	1874	16506000	21252	10671	6	0	\N
329881	1874	16508000	21252	10671	7	0	\N
329883	1678	23040757638000	21254	10672	0	0	\N
329884	1678	23040757639000	21255	10673	0	0	\N
329885	1874	16510000	21255	10673	1	0	\N
329896	1678	23040757644000	21261	10678	0	0	\N
329897	1678	23040757645000	21261	10678	1	0	\N
329898	1678	23040757646000	21261	10678	2	0	\N
329899	1678	23040757647000	21261	10678	3	0	\N
329900	1874	16520000	21261	10678	4	0	\N
329901	1874	16522000	21261	10678	5	0	\N
329902	1874	16524000	21261	10678	6	0	\N
329903	1874	16526000	21261	10678	7	0	\N
329912	1678	23040757644000	21263	10678	0	0	\N
329913	1678	23040757645000	21263	10678	1	0	\N
329914	1678	23040757646000	21263	10678	2	0	\N
329915	1678	23040757647000	21263	10678	3	0	\N
329916	1874	16520000	21263	10678	4	0	\N
329917	1874	16522000	21263	10678	5	0	\N
329918	1874	16524000	21263	10678	6	0	\N
329919	1874	16526000	21263	10678	7	0	\N
329920	1678	23040757648000	21264	10679	0	0	\N
329921	1678	23040757649000	21264	10679	1	0	\N
329922	1874	16528000	21264	10679	2	0	\N
329923	1874	16530000	21264	10679	3	0	\N
329924	1678	23040757648000	21265	10679	0	0	\N
329925	1678	23040757649000	21265	10679	1	0	\N
329926	1874	16528000	21265	10679	2	0	\N
329927	1874	16530000	21265	10679	3	0	\N
329928	1678	23040757648000	21266	10679	0	0	\N
329929	1678	23040757649000	21266	10679	1	0	\N
329930	1874	16528000	21266	10679	2	0	\N
329931	1874	16530000	21266	10679	3	0	\N
329932	1678	23040757648000	21267	10679	0	0	\N
329933	1678	23040757649000	21267	10679	1	0	\N
329934	1874	16528000	21267	10679	2	0	\N
329935	1874	16530000	21267	10679	3	0	\N
329804	1260	614410750000000	21239	10666	2	0	0
329805	1678	23040757631000	21239	10666	3	0	0
329806	1020	508158775000000	21239	10666	4	0	0
329807	1874	16496000	21239	10666	5	0	2
329808	975	506861175900000	21239	10666	6	0	0
329810	1215	612841958680000	21239	10666	8	0	0
329811	1341	1707738608751650	21239	10666	9	0	0
329812	1678	23040757632000	21240	10667	0	0	0
329813	1874	16498000	21240	10667	2	0	2
329840	1678	23040757633000	21246	10668	0	0	0
329842	1678	23040757634000	21247	10669	0	0	0
329843	1874	16502000	21247	10669	1	0	2
329844	1364	1709956637751650	21248	10670	0	0	0
329845	1118	909471465000000	21248	10670	1	0	0
329847	1238	613638750000000	21248	10670	3	0	0
329848	998	507520775000000	21248	10670	4	0	0
329849	1874	16504000	21248	10670	5	0	2
329866	1383	1710879637751650	21251	10671	0	0	0
329867	1137	909961465000000	21251	10671	1	0	0
329869	1017	507794775000000	21251	10671	3	0	0
329870	1678	23040757636000	21251	10671	4	0	0
329871	1678	23040757637000	21251	10671	5	0	0
329872	1874	16506000	21251	10671	6	0	2
329873	1874	16508000	21251	10671	7	0	2
329886	1678	23040757639000	21256	10673	0	0	0
329887	1874	16510000	21256	10673	1	0	2
329888	1678	23040757640000	21257	10674	0	0	0
329889	1874	16512000	21257	10674	1	0	2
329891	1874	16514000	21258	10675	1	0	2
329892	1678	23040757642000	21259	10676	0	0	0
329893	1874	16516000	21259	10676	1	0	2
329894	1678	23040757643000	21260	10677	0	0	0
329895	1874	16518000	21260	10677	1	0	2
329905	1678	23040757645000	21262	10678	1	0	0
329906	1678	23040757646000	21262	10678	2	0	0
329907	1678	23040757647000	21262	10678	3	0	0
329908	1874	16520000	21262	10678	4	0	2
329909	1874	16522000	21262	10678	5	0	2
329911	1874	16526000	21262	10678	7	0	2
329936	1678	23040757648000	21268	10679	0	0	0
329942	1874	16532000	21270	10680	0	0	\N
329952	923	507155015000000	21272	10682	0	0	\N
329953	1678	23040757654000	21272	10682	1	0	\N
329954	2275	200000000	21272	10682	2	0	\N
329955	1874	16539000	21272	10682	3	0	\N
329956	2276	200000000	21272	10682	4	0	\N
329957	2277	200000000	21272	10682	5	0	\N
329958	2276	1400000000	21272	10682	6	0	\N
329959	2277	1400000000	21272	10682	7	0	\N
329960	2278	200000000	21272	10682	8	0	\N
329961	2279	200000000	21272	10682	9	0	\N
329995	1364	1709956637751650	21277	10577	0	0	\N
329996	923	507155015000000	21277	10577	1	0	\N
329997	1383	1710879637751650	21277	10577	2	0	\N
329998	1118	909471465000000	21277	10577	3	0	\N
329999	1137	909961465000000	21277	10577	4	0	\N
330000	1257	613969750000000	21277	10577	5	0	\N
330001	1017	507794775000000	21277	10577	6	0	\N
330002	1238	613638750000000	21277	10577	7	0	\N
330003	998	507520775000000	21277	10577	8	0	\N
330004	1874	16230000	21277	10577	9	0	\N
330005	2280	200000000	21277	10577	10	0	\N
330006	2281	200000000	21277	10577	11	0	\N
330007	2282	200000000	21277	10577	12	0	\N
330008	2282	1400000000	21277	10577	13	0	\N
330009	2283	200000000	21277	10577	14	0	\N
330010	2272	200000000	21277	10577	15	0	\N
330011	2273	200000000	21277	10577	16	0	\N
330012	2274	200000000	21277	10577	17	0	\N
330013	2275	200000000	21277	10577	18	0	\N
330014	2276	200000000	21277	10577	19	0	\N
330015	2277	200000000	21277	10577	20	0	\N
330016	2276	1400000000	21277	10577	21	0	\N
330017	2277	1400000000	21277	10577	22	0	\N
330018	2278	200000000	21277	10577	23	0	\N
330019	2279	200000000	21277	10577	24	0	\N
330020	2284	200000000	21277	10577	25	0	\N
330021	2285	200000000	21277	10577	26	0	\N
330022	1885	10000000	21277	10577	27	0	\N
330023	2286	200000000	21277	10577	28	0	\N
330024	1874	16233000	21277	10577	29	0	\N
330025	2276	2600000000	21277	10577	30	0	\N
330026	1874	16236000	21277	10577	31	0	\N
330027	1678	23040757658000	21278	10684	0	0	\N
330028	1874	16554000	21278	10684	1	0	\N
330029	1874	16557000	21278	10684	2	0	\N
330030	1874	16558000	21278	10684	3	0	\N
330031	923	507155015000000	21280	10678	0	0	\N
330032	1678	23040757644000	21280	10678	1	0	\N
330033	1678	23040757645000	21280	10678	2	0	\N
330034	1678	23040757646000	21280	10678	3	0	\N
330035	1678	23040757647000	21280	10678	4	0	\N
330036	1678	23040757648000	21280	10678	5	0	\N
330037	1678	23040757649000	21280	10678	6	0	\N
330038	1678	23040757650000	21280	10678	7	0	\N
330039	1678	23040757651000	21280	10678	8	0	\N
330040	1678	23040757652000	21280	10678	9	0	\N
330041	1678	23040757653000	21280	10678	10	0	\N
330042	1678	23040757654000	21280	10678	11	0	\N
330043	1678	23040757655000	21280	10678	12	0	\N
330044	1678	23040757656000	21280	10678	13	0	\N
330045	1678	23040757657000	21280	10678	14	0	\N
330046	1678	23040757658000	21280	10678	15	0	\N
330047	1874	16519000	21280	10678	16	0	\N
330048	1874	16522000	21280	10678	17	0	\N
330049	2280	200000000	21280	10678	18	0	\N
330050	1874	16524000	21280	10678	19	0	\N
330051	2281	200000000	21280	10678	20	0	\N
330052	2282	200000000	21280	10678	21	0	\N
330053	2282	1400000000	21280	10678	22	0	\N
330054	2283	200000000	21280	10678	23	0	\N
330055	1874	16526000	21280	10678	24	0	\N
330056	1874	16527000	21280	10678	25	0	\N
330057	1874	16528000	21280	10678	26	0	\N
330058	2272	200000000	21280	10678	27	0	\N
330059	2273	200000000	21280	10678	28	0	\N
330060	2274	200000000	21280	10678	29	0	\N
330061	2275	200000000	21280	10678	30	0	\N
330062	1874	16530000	21280	10678	31	0	\N
330063	1874	16532000	21280	10678	32	0	\N
330064	1874	16534000	21280	10678	33	0	\N
330065	1874	16536000	21280	10678	34	0	\N
330066	1874	16538000	21280	10678	35	0	\N
330067	1874	16540000	21280	10678	36	0	\N
330068	1874	16542000	21280	10678	37	0	\N
330069	1874	16544000	21280	10678	38	0	\N
330070	1874	16546000	21280	10678	39	0	\N
330071	2276	200000000	21280	10678	40	0	\N
330072	2277	200000000	21280	10678	41	0	\N
329939	1874	16530000	21268	10679	3	0	2
329940	1678	23040757650000	21269	10680	0	0	0
329941	1874	16532000	21269	10680	1	0	2
329943	1678	23040757651000	21271	10681	0	0	0
329944	1678	23040757652000	21271	10681	1	0	0
329946	1874	16533000	21271	10681	3	0	2
329947	1874	16535000	21271	10681	4	0	2
329948	1874	16537000	21271	10681	5	0	2
329949	2272	200000000	21271	10681	6	0	0
329950	2273	200000000	21271	10681	7	0	0
329962	923	507155015000000	21273	10682	0	0	0
329963	1678	23040757654000	21273	10682	1	0	0
329964	1678	23040757655000	21274	10683	0	0	0
329965	1678	23040757656000	21274	10683	1	0	0
329967	1874	16540000	21274	10683	3	0	2
329968	2280	200000000	21274	10683	4	0	0
329969	2275	200000000	21274	10683	5	0	0
329970	2281	200000000	21274	10683	6	0	0
329971	2282	200000000	21274	10683	7	0	0
329973	2283	200000000	21274	10683	9	0	0
329974	1874	16542000	21274	10683	10	0	2
329975	1874	16544000	21274	10683	11	0	2
329976	1874	16545000	21274	10683	12	0	2
329977	2276	200000000	21274	10683	13	0	0
329979	2276	1400000000	21274	10683	15	0	0
329980	2277	1400000000	21274	10683	16	0	0
329981	2278	200000000	21274	10683	17	0	0
329982	2279	200000000	21274	10683	18	0	0
329984	2285	200000000	21274	10683	20	0	0
329985	1885	10000000	21274	10683	21	0	2
329986	2286	200000000	21274	10683	22	0	0
329987	1874	16548000	21274	10683	23	0	2
329988	2276	2600000000	21274	10683	24	0	0
329990	1874	16552000	21274	10683	26	0	2
329991	1678	23040757658000	21275	10684	0	0	0
329992	1874	16554000	21275	10684	1	0	2
329993	1874	16557000	21275	10684	2	0	2
329994	1874	16558000	21275	10684	3	0	2
330073	2276	1400000000	21280	10678	42	0	\N
330074	2277	1400000000	21280	10678	43	0	\N
330075	2278	200000000	21280	10678	44	0	\N
330076	2279	200000000	21280	10678	45	0	\N
330077	2284	200000000	21280	10678	46	0	\N
330078	2285	200000000	21280	10678	47	0	\N
330079	1885	10000000	21280	10678	48	0	\N
330080	2286	200000000	21280	10678	49	0	\N
330081	1874	16549000	21280	10678	50	0	\N
330082	2276	2600000000	21280	10678	51	0	\N
330083	1874	16552000	21280	10678	52	0	\N
330084	1874	16554000	21280	10678	53	0	\N
330085	1874	16556000	21280	10678	54	0	\N
330086	1874	16558000	21280	10678	55	0	\N
330093	1678	23040757659000	21283	10685	0	0	\N
330094	1678	23040757660000	21283	10685	1	0	\N
330095	1874	16560000	21283	10685	2	0	\N
330096	1874	16562000	21283	10685	3	0	\N
330097	1874	16565000	21283	10685	4	0	\N
330098	1874	16568000	21283	10685	6	0	\N
330116	1678	23040757665000	21289	10690	0	0	\N
330117	1874	16590000	21289	10690	1	0	\N
330118	1874	16592000	21289	10690	2	0	\N
330119	1874	16595000	21289	10690	3	0	\N
330126	1678	23040757666000	21291	10691	0	0	\N
330127	1678	23040757667000	21291	10691	1	0	\N
330128	1874	16597000	21291	10691	2	0	\N
330129	1874	16600000	21291	10691	3	0	\N
330130	1874	16603000	21291	10691	4	0	\N
330131	1874	16605000	21291	10691	5	0	\N
330132	1678	23040757668000	21292	10692	0	0	\N
330133	1874	16606000	21292	10692	1	0	\N
330134	1874	16609000	21292	10692	2	0	\N
330135	1874	16611000	21292	10692	3	0	\N
330140	1678	23040757669000	21294	10693	0	0	\N
330141	1678	23040757670000	21294	10693	1	0	\N
330142	1874	16614000	21294	10693	2	0	\N
330143	1874	16617000	21294	10693	3	0	\N
330144	1874	16619000	21294	10693	4	0	\N
330145	1874	16621000	21294	10693	5	0	\N
330146	1678	23040757669000	21295	10693	0	0	\N
330147	1678	23040757670000	21295	10693	1	0	\N
330148	1874	16614000	21295	10693	2	0	\N
330149	1874	16617000	21295	10693	3	0	\N
330150	1874	16619000	21295	10693	4	0	\N
330151	1874	16621000	21295	10693	5	0	\N
330158	1678	23040757671000	21297	10694	0	0	\N
330159	1874	16623000	21297	10694	1	0	\N
330160	1874	16626000	21297	10694	2	0	\N
330161	1678	23040757671000	21298	10694	0	0	\N
330162	1874	16623000	21298	10694	1	0	\N
330163	1874	16626000	21298	10694	2	0	\N
330171	1678	23040757672000	21301	10695	0	0	\N
330172	1874	16627000	21301	10695	1	0	\N
330173	1874	16630000	21301	10695	2	0	\N
330174	1874	16632000	21301	10695	3	0	\N
330175	1850	22240418949999	21302	10573	0	0	\N
330176	1364	1709956637751650	21302	10573	1	0	\N
330177	923	507155015000000	21302	10573	2	0	\N
330178	1678	23040757500000	21302	10573	3	0	\N
330179	1850	22241418949999	21302	10573	4	0	\N
330180	1386	1712107637751650	21302	10573	5	0	\N
330181	259	66010000000000	21302	10573	6	0	\N
330182	1383	1710879637751650	21302	10573	7	0	\N
330183	1118	909471465000000	21302	10573	8	0	\N
330184	1140	910615465000000	21302	10573	9	0	\N
330185	1137	909961465000000	21302	10573	10	0	\N
330186	1257	613969750000000	21302	10573	11	0	\N
330187	1017	507794775000000	21302	10573	12	0	\N
330188	1260	614410750000000	21302	10573	13	0	\N
330189	1277	1709780037751650	21302	10573	14	0	\N
330190	1031	909376565000000	21302	10573	15	0	\N
330191	1151	613574650000000	21302	10573	16	0	\N
330192	911	507467575000000	21302	10573	17	0	\N
330193	1238	613638750000000	21302	10573	18	0	\N
330194	998	507520775000000	21302	10573	19	0	\N
330195	1678	23040757501000	21302	10573	20	0	\N
330196	1678	23040757502000	21302	10573	21	0	\N
330197	1678	23040757503000	21302	10573	22	0	\N
330198	1678	23040757504000	21302	10573	23	0	\N
330199	1678	23040757505000	21302	10573	24	0	\N
330200	1678	23040757506000	21302	10573	25	0	\N
330201	1678	23040757507000	21302	10573	26	0	\N
330202	1678	23040757508000	21302	10573	27	0	\N
330203	1678	23040757509000	21302	10573	28	0	\N
330204	1678	23040757510000	21302	10573	29	0	\N
330205	1678	23040757511000	21302	10573	30	0	\N
330206	1678	23040757512000	21302	10573	31	0	\N
330207	1678	23040757513000	21302	10573	32	0	\N
330208	1678	23040757514000	21302	10573	33	0	\N
330089	1874	16560000	21282	10685	2	0	2
330090	1874	16562000	21282	10685	3	0	2
330091	1874	16565000	21282	10685	4	0	2
330092	1874	16568000	21282	10685	6	0	2
330099	1678	23040757661000	21284	10686	0	0	0
330101	1874	16573000	21284	10686	2	0	2
330102	1678	23040757662000	21285	10687	0	0	0
330103	1874	16574000	21285	10687	1	0	2
330104	1874	16576000	21285	10687	2	0	2
330105	1874	16579000	21285	10687	3	0	2
330107	1874	16582000	21286	10688	1	0	2
330108	1874	16584000	21286	10688	2	0	2
330109	1678	23040757664000	21287	10689	0	0	0
330110	1874	16587000	21287	10689	1	0	2
330112	1678	23040757665000	21288	10690	0	0	0
330113	1874	16590000	21288	10690	1	0	2
330114	1874	16592000	21288	10690	2	0	2
330115	1874	16595000	21288	10690	3	0	2
330120	1678	23040757666000	21290	10691	0	0	0
330122	1874	16597000	21290	10691	2	0	2
330123	1874	16600000	21290	10691	3	0	2
330124	1874	16603000	21290	10691	4	0	2
330125	1874	16605000	21290	10691	5	0	2
330136	1678	23040757668000	21293	10692	0	0	0
330138	1874	16609000	21293	10692	2	0	2
330139	1874	16611000	21293	10692	3	0	2
330152	1678	23040757669000	21296	10693	0	0	0
330153	1678	23040757670000	21296	10693	1	0	0
330155	1874	16617000	21296	10693	3	0	2
330156	1874	16619000	21296	10693	4	0	2
330157	1874	16621000	21296	10693	5	0	2
330164	1678	23040757671000	21299	10694	0	0	0
330165	1874	16623000	21299	10694	1	0	2
330167	1678	23040757672000	21300	10695	0	0	0
330168	1874	16627000	21300	10695	1	0	2
330169	1874	16630000	21300	10695	2	0	2
330170	1874	16632000	21300	10695	3	0	2
330209	1678	23040757515000	21302	10573	34	0	\N
330210	1678	23040757516000	21302	10573	35	0	\N
330211	1678	23040757517000	21302	10573	36	0	\N
330212	1678	23040757518000	21302	10573	37	0	\N
330213	1678	23040757519000	21302	10573	38	0	\N
330214	1678	23040757520000	21302	10573	39	0	\N
330215	1678	23040757521000	21302	10573	40	0	\N
330216	1678	23040757522000	21302	10573	41	0	\N
330217	1678	23040757523000	21302	10573	42	0	\N
330218	1678	23040757524000	21302	10573	43	0	\N
330219	1678	23040757525000	21302	10573	44	0	\N
330220	1678	23040757526000	21302	10573	45	0	\N
330221	1678	23040757527000	21302	10573	46	0	\N
330222	1678	23040757528000	21302	10573	47	0	\N
330223	1678	23040757529000	21302	10573	48	0	\N
330224	1678	23040757530000	21302	10573	49	0	\N
330225	1678	23040757531000	21302	10573	50	0	\N
330226	1678	23040757532000	21302	10573	51	0	\N
330227	1678	23040757533000	21302	10573	52	0	\N
330228	1678	23040757534000	21302	10573	53	0	\N
330229	1678	23040757535000	21302	10573	54	0	\N
330230	1678	23040757536000	21302	10573	55	0	\N
330231	1678	23040757537000	21302	10573	56	0	\N
330232	1678	23040757538000	21302	10573	57	0	\N
330233	1678	23040757539000	21302	10573	58	0	\N
330234	1678	23040757540000	21302	10573	59	0	\N
330235	1678	23040757541000	21302	10573	60	0	\N
330236	1678	23040757542000	21302	10573	61	0	\N
330237	1678	23040757543000	21302	10573	62	0	\N
330238	1678	23040757544000	21302	10573	63	0	\N
330239	1678	23040757545000	21302	10573	64	0	\N
330240	1678	23040757546000	21302	10573	65	0	\N
330241	1678	23040757547000	21302	10573	66	0	\N
330242	1678	23040757548000	21302	10573	67	0	\N
330243	1678	23040757549000	21302	10573	68	0	\N
330244	1678	23040757550000	21302	10573	69	0	\N
330245	1678	23040757551000	21302	10573	70	0	\N
330246	1678	23040757552000	21302	10573	71	0	\N
330247	1678	23040757553000	21302	10573	72	0	\N
330248	1678	23040757554000	21302	10573	73	0	\N
330249	1678	23040757555000	21302	10573	74	0	\N
330250	1678	23040757556000	21302	10573	75	0	\N
330251	1678	23040757557000	21302	10573	76	0	\N
330252	1678	23040757558000	21302	10573	77	0	\N
330253	1678	23040757559000	21302	10573	78	0	\N
330254	1678	23040757560000	21302	10573	79	0	\N
330255	1678	23040757561000	21302	10573	80	0	\N
330256	1678	23040757562000	21302	10573	81	0	\N
330257	1678	23040757563000	21302	10573	82	0	\N
330258	1678	23040757564000	21302	10573	83	0	\N
330259	1678	23040757565000	21302	10573	84	0	\N
330260	1678	23040757566000	21302	10573	85	0	\N
330261	1678	23040757567000	21302	10573	86	0	\N
330262	1678	23040757568000	21302	10573	87	0	\N
330263	1678	23040757569000	21302	10573	88	0	\N
330264	1678	23040757570000	21302	10573	89	0	\N
330265	1678	23040757571000	21302	10573	90	0	\N
330266	1678	23040757572000	21302	10573	91	0	\N
330267	1678	23040757573000	21302	10573	92	0	\N
330268	1678	23040757574000	21302	10573	93	0	\N
330269	1678	23040757575000	21302	10573	94	0	\N
330270	1678	23040757576000	21302	10573	95	0	\N
330271	1678	23040757577000	21302	10573	96	0	\N
330272	1678	23040757578000	21302	10573	97	0	\N
330273	1678	23040757579000	21302	10573	98	0	\N
330274	1678	23040757580000	21302	10573	99	0	\N
330275	1678	23040757581000	21302	10573	100	0	\N
330276	1678	23040757582000	21302	10573	101	0	\N
330277	1678	23040757583000	21302	10573	102	0	\N
330278	1678	23040757584000	21302	10573	103	0	\N
330279	1678	23040757585000	21302	10573	104	0	\N
330280	1678	23040757586000	21302	10573	105	0	\N
330281	1678	23040757587000	21302	10573	107	0	\N
330282	1678	23040757588000	21302	10573	108	0	\N
330283	1678	23040757589000	21302	10573	109	0	\N
330284	1678	23040757590000	21302	10573	110	0	\N
330285	1678	23040757591000	21302	10573	111	0	\N
330286	1678	23040757592000	21302	10573	112	0	\N
330287	1678	23040757593000	21302	10573	113	0	\N
330288	1678	23040757594000	21302	10573	114	0	\N
330289	1678	23040757595000	21302	10573	115	0	\N
330290	1678	23040757596000	21302	10573	116	0	\N
330291	1678	23040757597000	21302	10573	117	0	\N
330292	1678	23040757598000	21302	10573	118	0	\N
330293	1678	23040757599000	21302	10573	119	0	\N
330294	1678	23040757600000	21302	10573	120	0	\N
330295	1678	23040757601000	21302	10573	121	0	\N
330296	1678	23040757602000	21302	10573	122	0	\N
330297	1678	23040757603000	21302	10573	123	0	\N
330298	1678	23040757604000	21302	10573	124	0	\N
330299	1678	23040757605000	21302	10573	125	0	\N
330300	1678	23040757673000	21303	10696	0	0	\N
330301	1874	16634000	21303	10696	1	0	\N
330302	1874	16637000	21303	10696	2	0	\N
330303	1678	23040757673000	21304	10696	0	0	\N
330304	1874	16634000	21304	10696	1	0	\N
330305	1874	16637000	21304	10696	2	0	\N
330309	1678	23040757674000	21306	10697	0	0	\N
330310	1874	16640000	21306	10697	1	0	\N
330311	1874	16642000	21306	10697	2	0	\N
330315	1874	16640000	21308	10697	0	0	\N
330316	1678	23040757674000	21309	10697	0	0	\N
330317	1874	16640000	21309	10697	1	0	\N
330318	1874	16642000	21309	10697	2	0	\N
330319	1850	22240418949999	21310	10516	0	0	\N
330320	2270	699000000000	21310	10516	1	0	\N
330321	1338	1705962637751650	21310	10516	2	0	\N
330322	1092	907346465000000	21310	10516	3	0	\N
330323	2271	2000000000	21310	10516	4	0	\N
330324	1958	5031186000000	21310	10516	5	0	\N
330325	1212	612204750000000	21310	10516	6	0	\N
330326	972	506334775000000	21310	10516	7	0	\N
330327	588	66471000000000	21310	10516	8	0	\N
330328	1364	1709956637751650	21310	10516	9	0	\N
330329	1850	22241418949999	21310	10516	10	0	\N
330330	1386	1712107637751650	21310	10516	11	0	\N
330331	259	66010000000000	21310	10516	12	0	\N
330332	1383	1710879637751650	21310	10516	13	0	\N
330333	1118	909471465000000	21310	10516	14	0	\N
330334	1140	910615465000000	21310	10516	15	0	\N
330335	1137	909961465000000	21310	10516	16	0	\N
330336	1257	613969750000000	21310	10516	17	0	\N
330337	1017	507794775000000	21310	10516	18	0	\N
330338	1289	1708728477751650	21310	10516	19	0	\N
330339	1043	908817755000000	21310	10516	20	0	\N
330340	1260	614410750000000	21310	10516	21	0	\N
330341	1678	23040757423000	21310	10516	22	0	\N
330342	1277	1709780037751650	21310	10516	23	0	\N
330343	1031	909376565000000	21310	10516	24	0	\N
330344	1151	613574650000000	21310	10516	25	0	\N
330308	1874	16637000	21305	10696	2	0	2
330312	1678	23040757674000	21307	10697	0	0	0
330313	1874	16640000	21307	10697	1	0	2
330314	1874	16642000	21307	10697	2	0	2
330345	911	507467575000000	21310	10516	26	0	\N
330346	1483	10000000	21310	10516	27	0	\N
330347	1163	613197810000000	21310	10516	28	0	\N
330348	923	507155005000000	21310	10516	29	0	\N
330349	1516	7792474350000	21310	10516	30	0	\N
330350	1445	1004169000000	21310	10516	31	0	\N
330351	924	507246525000000	21310	10516	32	0	\N
330352	1164	613308350000000	21310	10516	33	0	\N
330353	1044	908981365000000	21310	10516	34	0	\N
330354	1290	1709035637751650	21310	10516	35	0	\N
330355	1238	613638750000000	21310	10516	36	0	\N
330356	998	507520775000000	21310	10516	37	0	\N
330357	1678	23040757424000	21310	10516	38	0	\N
330358	1678	23040757425000	21310	10516	39	0	\N
330359	1300	1710301631910020	21310	10516	40	0	\N
330360	1174	613761729502880	21310	10516	41	0	\N
330361	1054	909654073462350	21310	10516	42	0	\N
330362	934	507621887704640	21310	10516	43	0	\N
330363	1678	23040757426000	21310	10516	44	0	\N
330364	1678	23040757427000	21310	10516	45	0	\N
330365	1678	23040757428000	21310	10516	47	0	\N
330366	1678	23040757429000	21310	10516	48	0	\N
330367	1678	23040757430000	21310	10516	49	0	\N
330368	1678	23040757431000	21310	10516	50	0	\N
330369	1678	23040757432000	21310	10516	51	0	\N
330370	1678	23040757433000	21310	10516	52	0	\N
330371	1678	23040757434000	21310	10516	53	0	\N
330372	1678	23040757435000	21310	10516	54	0	\N
330373	1678	23040757436000	21310	10516	55	0	\N
330374	1678	23040757437000	21310	10516	56	0	\N
330375	1678	23040757438000	21310	10516	57	0	\N
330376	1678	23040757439000	21310	10516	58	0	\N
330377	1678	23040757440000	21310	10516	59	0	\N
330378	1678	23040757441000	21310	10516	60	0	\N
330379	1678	23040757442000	21310	10516	61	0	\N
330380	1678	23040757443000	21310	10516	62	0	\N
330381	1678	23040757444000	21310	10516	63	0	\N
330382	1678	23040757445000	21310	10516	64	0	\N
330383	1678	23040757446000	21310	10516	65	0	\N
330384	1678	23040757447000	21310	10516	66	0	\N
330385	1678	23040757448000	21310	10516	67	0	\N
330386	1678	23040757449000	21310	10516	68	0	\N
330387	1678	23040757450000	21310	10516	69	0	\N
330388	1678	23040757451000	21310	10516	70	0	\N
330389	1678	23040757452000	21310	10516	71	0	\N
330390	1678	23040757453000	21310	10516	72	0	\N
330391	1678	23040757454000	21310	10516	73	0	\N
330392	1678	23040757455000	21310	10516	74	0	\N
330393	1285	1714307637751650	21310	10516	75	0	\N
330394	1039	911784465000000	21310	10516	76	0	\N
330395	1159	615200750000000	21310	10516	77	0	\N
330396	919	508811775000000	21310	10516	78	0	\N
330397	2016	2332000000000	21310	10516	79	0	\N
330398	1678	23040757456000	21310	10516	80	0	\N
330399	1678	23040757457000	21310	10516	81	0	\N
330400	1678	23040757458000	21310	10516	82	0	\N
330401	1678	23040757459000	21310	10516	83	0	\N
330402	1678	23040757460000	21310	10516	84	0	\N
330403	1678	23040757461000	21310	10516	85	0	\N
330404	1020	508158775000000	21310	10516	86	0	\N
330405	1678	23040757462000	21310	10516	87	0	\N
330406	1678	23040757463000	21310	10516	88	0	\N
330407	1678	23040757464000	21310	10516	89	0	\N
330408	1678	23040757465000	21310	10516	90	0	\N
330409	1678	23040757466000	21310	10516	91	0	\N
330410	1678	23040757467000	21310	10516	92	0	\N
330411	1678	23040757468000	21310	10516	93	0	\N
330412	1678	23040757469000	21310	10516	94	0	\N
330413	1678	23040757470000	21310	10516	95	0	\N
330414	1678	23040757471000	21310	10516	96	0	\N
330415	1678	23040757472000	21310	10516	97	0	\N
330416	1678	23040757473000	21310	10516	98	0	\N
330417	1678	23040757474000	21310	10516	99	0	\N
330418	1678	23040757475000	21310	10516	100	0	\N
330419	1678	23040757476000	21310	10516	101	0	\N
330420	1678	23040757477000	21310	10516	102	0	\N
330421	1678	23040757478000	21310	10516	103	0	\N
330422	1678	23040757479000	21310	10516	104	0	\N
330423	1678	23040757480000	21310	10516	105	0	\N
330424	1678	23040757481000	21310	10516	106	0	\N
330425	1678	23040757482000	21310	10516	107	0	\N
330426	1678	23040757483000	21310	10516	108	0	\N
330427	1678	23040757484000	21310	10516	109	0	\N
330428	1678	23040757485000	21310	10516	110	0	\N
330429	1678	23040757486000	21310	10516	111	0	\N
330430	1678	23040757487000	21310	10516	112	0	\N
330431	1678	23040757488000	21310	10516	113	0	\N
330432	1678	23040757489000	21310	10516	114	0	\N
330433	1678	23040757490000	21310	10516	115	0	\N
330434	1678	23040757491000	21310	10516	116	0	\N
330435	1678	23040757492000	21310	10516	117	0	\N
330436	1678	23040757493000	21310	10516	118	0	\N
330437	1678	23040757494000	21310	10516	119	0	\N
330438	1678	23040757495000	21310	10516	120	0	\N
330439	1678	23040757496000	21310	10516	121	0	\N
330440	1678	23040757497000	21310	10516	122	0	\N
330441	1678	23040757498000	21310	10516	123	0	\N
330442	1678	23040757499000	21310	10516	124	0	\N
330443	1678	23040757500000	21310	10516	125	0	\N
330444	1678	23040757674000	21311	10697	0	0	\N
330445	1874	16640000	21311	10697	1	0	\N
330446	1874	16642000	21311	10697	2	0	\N
330447	1678	23040757674000	21312	10697	0	0	\N
330448	1874	16640000	21312	10697	1	0	\N
330449	1874	16642000	21312	10697	2	0	\N
330452	1678	23040757675000	21314	10699	0	0	\N
330453	1678	23040757676000	21314	10699	1	0	\N
330454	1874	16648000	21314	10699	2	0	\N
330455	1874	16651000	21314	10699	3	0	\N
330463	1678	23040757678000	21317	10701	0	0	\N
330464	1678	23040757679000	21317	10701	1	0	\N
330465	1678	23040757680000	21317	10701	2	0	\N
330466	1678	23040757681000	21317	10701	3	0	\N
330467	1874	16657000	21317	10701	4	0	\N
330468	1874	16660000	21317	10701	5	0	\N
330469	1874	16662000	21317	10701	6	0	\N
330470	1874	16664000	21317	10701	7	0	\N
330471	1874	16667000	21317	10701	8	0	\N
330472	1874	16670000	21317	10701	9	0	\N
330473	1874	16673000	21317	10701	10	0	\N
330474	1874	16675000	21317	10701	11	0	\N
330475	1874	16677000	21317	10701	12	0	\N
330476	1678	23040757678000	21318	10701	0	0	\N
330477	1678	23040757679000	21318	10701	1	0	\N
330478	1678	23040757680000	21318	10701	2	0	\N
330479	1678	23040757681000	21318	10701	3	0	\N
330480	1874	16657000	21318	10701	4	0	\N
330456	1678	23040757675000	21315	10699	0	0	0
330457	1678	23040757676000	21315	10699	1	0	0
330458	1874	16648000	21315	10699	2	0	2
330459	1874	16651000	21315	10699	3	0	2
330460	1678	23040757677000	21316	10700	0	0	0
330462	1874	16656000	21316	10700	2	0	2
330481	1874	16660000	21318	10701	5	0	\N
330482	1874	16662000	21318	10701	6	0	\N
330483	1874	16664000	21318	10701	7	0	\N
330484	1874	16667000	21318	10701	8	0	\N
330485	1874	16670000	21318	10701	9	0	\N
330486	1874	16673000	21318	10701	10	0	\N
330487	1874	16675000	21318	10701	11	0	\N
330488	1874	16677000	21318	10701	12	0	\N
330510	1678	23040757684000	21322	10704	0	0	\N
330511	1874	16691000	21322	10704	1	0	\N
330512	1874	16693000	21322	10704	2	0	\N
330523	1678	23040757686000	21326	10706	0	0	\N
330524	1874	16701000	21326	10706	2	0	\N
330525	1874	16704000	21326	10706	3	0	\N
330526	1678	23040757687000	21327	10707	0	0	\N
330527	1874	16706000	21327	10707	1	0	\N
330528	1874	16709000	21327	10707	2	0	\N
330529	1678	23040757687000	21328	10707	0	0	\N
330530	1874	16706000	21328	10707	1	0	\N
330531	1874	16709000	21328	10707	2	0	\N
330535	1874	16706000	21330	10707	0	0	\N
330536	1874	16709000	21330	10707	1	0	\N
330537	957	508158775000000	21331	10708	0	0	\N
330538	1678	23040757688000	21331	10708	1	0	\N
330539	1874	16711000	21331	10708	2	0	\N
330540	1874	16714000	21331	10708	3	0	\N
330541	1874	16715000	21331	10708	4	0	\N
330547	1874	16711000	21333	10708	0	0	\N
330548	1874	16714000	21333	10708	1	0	\N
330549	1874	16715000	21333	10708	2	0	\N
330552	957	508158775000000	21335	10709	0	0	\N
330553	1678	23040757688000	21335	10709	1	0	\N
330554	1874	16718000	21335	10709	2	0	\N
330555	1874	16720000	21335	10709	3	0	\N
330556	1678	23040757689000	21336	10710	0	0	\N
330557	1874	16722000	21336	10710	1	0	\N
330558	1874	16725000	21336	10710	2	0	\N
330562	1678	23040757689000	21338	10710	0	0	\N
330563	1874	16722000	21338	10710	1	0	\N
330564	1874	16725000	21338	10710	2	0	\N
330565	1678	23040757689000	21339	10710	0	0	\N
330566	1874	16722000	21339	10710	1	0	\N
330567	1874	16725000	21339	10710	2	0	\N
330576	1678	23040757691000	21342	10712	0	0	\N
330577	1874	16731000	21342	10712	1	0	\N
330578	1874	16734000	21342	10712	2	0	\N
330579	1678	23040757692000	21343	10713	0	0	\N
330580	1678	23040757693000	21343	10713	1	0	\N
330581	1874	16737000	21343	10713	2	0	\N
330582	1874	16739000	21343	10713	3	0	\N
330583	1874	16742000	21343	10713	4	0	\N
330584	1874	16744000	21343	10713	5	0	\N
330585	1678	23040757692000	21344	10713	0	0	\N
330586	1678	23040757693000	21344	10713	1	0	\N
330587	1874	16737000	21344	10713	2	0	\N
330588	1874	16739000	21344	10713	3	0	\N
330589	1874	16742000	21344	10713	4	0	\N
330590	1874	16744000	21344	10713	5	0	\N
330591	1678	23040757692000	21345	10713	0	0	\N
330592	1678	23040757693000	21345	10713	1	0	\N
330593	1874	16737000	21345	10713	2	0	\N
330594	1874	16739000	21345	10713	3	0	\N
330595	1874	16742000	21345	10713	4	0	\N
330596	1874	16744000	21345	10713	5	0	\N
330615	1678	23040757697000	21349	10715	0	0	\N
330616	1874	16761000	21349	10715	1	0	\N
330491	1678	23040757680000	21319	10701	2	0	0
330492	1678	23040757681000	21319	10701	3	0	0
330493	1874	16657000	21319	10701	4	0	2
330494	1874	16660000	21319	10701	5	0	2
330495	1874	16662000	21319	10701	6	0	2
330497	1874	16667000	21319	10701	8	0	2
330498	1874	16670000	21319	10701	9	0	2
330499	1874	16673000	21319	10701	10	0	2
330500	1874	16675000	21319	10701	11	0	2
330501	1874	16677000	21319	10701	12	0	2
330503	1540	0	21320	10702	1	0	6
330504	1874	16682000	21320	10702	2	0	2
330505	1874	16683000	21320	10702	3	0	2
330506	1678	23040757682000	21321	10703	0	0	0
330508	1874	16685000	21321	10703	2	0	2
330509	1874	16688000	21321	10703	3	0	2
330513	1678	23040757684000	21323	10704	0	0	0
330514	1874	16691000	21323	10704	1	0	2
330515	1874	16693000	21323	10704	2	0	2
330517	1874	16694000	21324	10705	1	0	2
330518	1874	16696000	21324	10705	2	0	2
330519	1874	16699000	21324	10705	3	0	2
330520	1678	23040757686000	21325	10706	0	0	0
330521	1874	16701000	21325	10706	2	0	2
330532	1678	23040757687000	21329	10707	0	0	0
330533	1874	16706000	21329	10707	1	0	2
330534	1874	16709000	21329	10707	2	0	2
330542	957	508158775000000	21332	10708	0	0	0
330544	1874	16711000	21332	10708	2	0	2
330545	1874	16714000	21332	10708	3	0	2
330546	1874	16715000	21332	10708	4	0	2
330550	1874	16718000	21334	10709	0	0	2
330551	1874	16720000	21334	10709	1	0	2
330560	1874	16722000	21337	10710	1	0	2
330561	1874	16725000	21337	10710	2	0	2
330568	1197	614409750000000	21340	10711	0	0	0
330569	1077	910614465000000	21340	10711	1	0	0
330570	1678	23040757690000	21340	10711	2	0	0
330572	1874	16730000	21340	10711	4	0	2
330573	1678	23040757691000	21341	10712	0	0	0
330574	1874	16731000	21341	10712	1	0	2
330575	1874	16734000	21341	10712	2	0	2
330598	1678	23040757693000	21346	10713	1	0	0
330599	1874	16737000	21346	10713	2	0	2
330600	1874	16739000	21346	10713	3	0	2
330601	1874	16742000	21346	10713	4	0	2
330602	1874	16744000	21346	10713	5	0	2
330604	1678	23040757694000	21348	10714	1	0	0
330605	1678	23040757695000	21348	10714	2	0	0
330606	1678	23040757696000	21348	10714	3	0	0
330607	1874	16747000	21348	10714	4	0	2
330608	1874	16750000	21348	10714	5	0	2
330610	2287	19000000000	21348	10714	7	0	0
330611	1874	16755000	21348	10714	8	0	2
330612	1874	16757000	21348	10714	9	0	2
330613	1874	16759000	21348	10714	10	0	2
330617	1874	16763000	21349	10715	2	0	\N
330618	1874	16766000	21349	10715	3	0	\N
330623	1678	23040757698000	21351	10716	0	0	\N
330624	1678	23040757699000	21351	10716	1	0	\N
330625	1874	16768000	21351	10716	2	0	\N
330626	1874	16770000	21351	10716	3	0	\N
330627	1874	16773000	21351	10716	4	0	\N
330628	1874	16776000	21351	10716	5	0	\N
330643	1678	23040757701000	21355	10718	0	0	\N
330644	1874	16782000	21355	10718	1	0	\N
330645	1874	16784000	21355	10718	2	0	\N
330646	1874	16787000	21355	10718	3	0	\N
330660	957	508158775000000	21358	10700	0	0	\N
330661	1197	614409750000000	21358	10700	1	0	\N
330662	1077	910614465000000	21358	10700	2	0	\N
330663	1323	1712107637751650	21358	10700	3	0	\N
330664	1540	0	21358	10700	4	0	\N
330665	2287	19000000000	21358	10700	5	0	\N
330666	2287	719000000000	21358	10700	6	0	\N
330667	1678	23040757706000	21359	10721	0	0	\N
330668	1678	23040757707000	21359	10721	1	0	\N
330669	1678	23040757708000	21359	10721	2	0	\N
330670	1678	23040757709000	21359	10721	3	0	\N
330671	1678	23040757710000	21359	10721	4	0	\N
330672	1678	23040757711000	21359	10721	5	0	\N
330673	1874	16811000	21359	10721	6	0	\N
330674	1874	16812000	21359	10721	7	0	\N
330675	1874	16813000	21359	10721	8	0	\N
330676	1874	16816000	21359	10721	9	0	\N
330677	1874	16819000	21359	10721	10	0	\N
330678	1874	16822000	21359	10721	11	0	\N
330679	1874	16825000	21359	10721	12	0	\N
330680	1874	16828000	21359	10721	13	0	\N
330681	1874	16830000	21359	10721	14	0	\N
330682	1874	16832000	21359	10721	15	0	\N
330683	1874	16834000	21359	10721	16	0	\N
330684	1874	16836000	21359	10721	17	0	\N
330685	1874	16838000	21359	10721	18	0	\N
330705	1678	23040757712000	21361	10722	0	0	\N
330706	1678	23040757713000	21361	10722	1	0	\N
330707	1874	16840000	21361	10722	2	0	\N
330708	1874	16843000	21361	10722	3	0	\N
330709	1874	16846000	21361	10722	5	0	\N
330710	1874	16848000	21361	10722	6	0	\N
330717	1678	23040757712000	21363	10722	0	0	\N
330718	1678	23040757713000	21363	10722	1	0	\N
330719	1874	16840000	21363	10722	2	0	\N
330720	1874	16843000	21363	10722	3	0	\N
330721	1874	16846000	21363	10722	5	0	\N
330722	1874	16848000	21363	10722	6	0	\N
330723	1678	23040757712000	21364	10722	0	0	\N
330724	1678	23040757713000	21364	10722	1	0	\N
330725	1874	16840000	21364	10722	2	0	\N
330726	1874	16843000	21364	10722	3	0	\N
330727	1874	16846000	21364	10722	5	0	\N
330728	1874	16848000	21364	10722	6	0	\N
330729	1678	23040757712000	21365	10722	0	0	\N
330730	1678	23040757713000	21365	10722	1	0	\N
330731	1874	16840000	21365	10722	2	0	\N
330732	1874	16843000	21365	10722	3	0	\N
330733	1874	16846000	21365	10722	5	0	\N
330734	1874	16848000	21365	10722	6	0	\N
330735	1678	23040757712000	21366	10722	0	0	\N
330736	1678	23040757713000	21366	10722	1	0	\N
330737	1874	16840000	21366	10722	2	0	\N
330738	1874	16843000	21366	10722	3	0	\N
330739	1874	16846000	21366	10722	5	0	\N
330740	1874	16848000	21366	10722	6	0	\N
330745	1678	23040757714000	21368	10723	0	0	\N
330746	1874	16849000	21368	10723	1	0	\N
330747	1874	16851000	21368	10723	2	0	\N
330748	1874	16854000	21368	10723	3	0	\N
330749	1678	23040757714000	21369	10723	0	0	\N
330750	1874	16849000	21369	10723	1	0	\N
330751	1874	16851000	21369	10723	2	0	\N
330752	1874	16854000	21369	10723	3	0	\N
330621	1874	16763000	21350	10715	2	0	2
330622	1874	16766000	21350	10715	3	0	2
330629	1678	23040757698000	21352	10716	0	0	0
330630	1678	23040757699000	21352	10716	1	0	0
330631	1874	16768000	21352	10716	2	0	2
330633	1874	16773000	21352	10716	4	0	2
330634	1874	16776000	21352	10716	5	0	2
330635	1678	23040757700000	21353	10717	0	0	0
330636	1874	16779000	21353	10717	1	0	2
330637	2287	719000000000	21353	10717	2	0	0
330639	1678	23040757701000	21354	10718	0	0	0
330640	1874	16782000	21354	10718	1	0	2
330641	1874	16784000	21354	10718	2	0	2
330642	1874	16787000	21354	10718	3	0	2
330648	1874	16789000	21356	10719	1	0	2
330649	1874	16792000	21356	10719	2	0	2
330650	1678	23040757703000	21357	10720	0	0	0
330651	1678	23040757704000	21357	10720	1	0	0
330652	1678	23040757705000	21357	10720	2	0	0
330654	1874	16797000	21357	10720	4	0	2
330655	1874	16800000	21357	10720	5	0	2
330656	1874	16803000	21357	10720	6	0	2
330657	1874	16805000	21357	10720	7	0	2
330658	1874	16807000	21357	10720	8	0	2
330686	1678	23040757706000	21360	10721	0	0	0
330687	1678	23040757707000	21360	10721	1	0	0
330688	1678	23040757708000	21360	10721	2	0	0
330689	1678	23040757709000	21360	10721	3	0	0
330691	1678	23040757711000	21360	10721	5	0	0
330692	1874	16811000	21360	10721	6	0	2
330693	1874	16812000	21360	10721	7	0	2
330694	1874	16813000	21360	10721	8	0	2
330695	1874	16816000	21360	10721	9	0	2
330697	1874	16822000	21360	10721	11	0	2
330698	1874	16825000	21360	10721	12	0	2
330699	1874	16828000	21360	10721	13	0	2
330700	1874	16830000	21360	10721	14	0	2
330701	1874	16832000	21360	10721	15	0	2
330703	1874	16836000	21360	10721	17	0	2
330704	1874	16838000	21360	10721	18	0	2
330711	1678	23040757712000	21362	10722	0	0	0
330712	1678	23040757713000	21362	10722	1	0	0
330714	1874	16843000	21362	10722	3	0	2
330715	1874	16846000	21362	10722	5	0	2
330716	1874	16848000	21362	10722	6	0	2
330741	1678	23040757714000	21367	10723	0	0	0
330742	1874	16849000	21367	10723	1	0	2
330744	1874	16854000	21367	10723	3	0	2
330753	1678	23040757715000	21370	10724	0	0	\N
330754	1678	23040757716000	21370	10724	1	0	\N
330755	1874	16857000	21370	10724	2	0	\N
330756	1874	16860000	21370	10724	3	0	\N
330757	1874	16862000	21370	10724	4	0	\N
330758	1874	16864000	21370	10724	5	0	\N
330765	1678	23040757717000	21372	10725	0	0	\N
330766	1874	16867000	21372	10725	1	0	\N
330767	1874	16869000	21372	10725	2	0	\N
330768	1874	16870000	21372	10725	3	0	\N
330769	1678	23040757717000	21373	10725	0	0	\N
330770	1874	16867000	21373	10725	1	0	\N
330771	1874	16869000	21373	10725	2	0	\N
330772	1874	16870000	21373	10725	3	0	\N
330773	1678	23040757717000	21374	10725	0	0	\N
330774	1874	16867000	21374	10725	1	0	\N
330775	1874	16869000	21374	10725	2	0	\N
330776	1874	16870000	21374	10725	3	0	\N
330777	1678	23040757717000	21375	10725	0	0	\N
330778	1874	16867000	21375	10725	1	0	\N
330779	1874	16869000	21375	10725	2	0	\N
330780	1874	16870000	21375	10725	3	0	\N
330781	1678	23040757717000	21376	10725	0	0	\N
330782	1874	16867000	21376	10725	1	0	\N
330783	1874	16869000	21376	10725	2	0	\N
330784	1874	16870000	21376	10725	3	0	\N
330806	1678	23040757721000	21383	10728	0	0	\N
330807	1678	23040757722000	21383	10728	1	0	\N
330808	1874	16888000	21383	10728	2	0	\N
330809	1874	16891000	21383	10728	3	0	\N
330810	1874	16892000	21383	10728	4	0	\N
330811	1874	16894000	21383	10728	5	0	\N
330812	1874	16896000	21383	10728	6	0	\N
330813	1678	23040757723000	21384	10729	0	0	\N
330814	1874	16898000	21384	10729	1	0	\N
330815	1874	16901000	21384	10729	2	0	\N
330819	1678	23040757723000	21386	10729	0	0	\N
330820	1874	16898000	21386	10729	1	0	\N
330821	1874	16901000	21386	10729	2	0	\N
330822	1678	23040757723000	21387	10729	0	0	\N
330823	1874	16898000	21387	10729	1	0	\N
330824	1874	16901000	21387	10729	2	0	\N
330825	1678	23040757724000	21388	10730	0	0	\N
330826	2288	0	21388	10730	1	0	\N
330827	1874	16902000	21388	10730	2	0	\N
330828	1874	16905000	21388	10730	3	0	\N
330839	1197	614409750000000	21392	10709	0	0	\N
330840	1077	910614465000000	21392	10709	1	0	\N
330841	1323	1712107637751650	21392	10709	2	0	\N
330842	1678	23040757689000	21392	10709	3	0	\N
330843	2288	0	21392	10709	4	0	\N
330844	1678	23040757690000	21392	10709	5	0	\N
330845	1678	23040757691000	21392	10709	6	0	\N
330846	1678	23040757692000	21392	10709	7	0	\N
330847	1678	23040757693000	21392	10709	8	0	\N
330848	1678	23040757694000	21392	10709	9	0	\N
330849	1678	23040757695000	21392	10709	10	0	\N
330850	1678	23040757696000	21392	10709	11	0	\N
330851	1678	23040757697000	21392	10709	12	0	\N
330852	1678	23040757698000	21392	10709	13	0	\N
330853	1678	23040757699000	21392	10709	14	0	\N
330854	1678	23040757700000	21392	10709	15	0	\N
330855	1678	23040757701000	21392	10709	16	0	\N
330856	1678	23040757702000	21392	10709	17	0	\N
330857	1678	23040757703000	21392	10709	18	0	\N
330858	1678	23040757704000	21392	10709	19	0	\N
330859	1678	23040757705000	21392	10709	20	0	\N
330860	1678	23040757706000	21392	10709	21	0	\N
330861	1678	23040757707000	21392	10709	22	0	\N
330862	1678	23040757708000	21392	10709	23	0	\N
330863	1678	23040757709000	21392	10709	24	0	\N
330864	1678	23040757710000	21392	10709	25	0	\N
330865	1678	23040757711000	21392	10709	26	0	\N
330866	1678	23040757712000	21392	10709	27	0	\N
330867	1678	23040757713000	21392	10709	28	0	\N
330868	1678	23040757714000	21392	10709	29	0	\N
330869	1678	23040757715000	21392	10709	30	0	\N
330870	1678	23040757716000	21392	10709	31	0	\N
330871	1678	23040757717000	21392	10709	32	0	\N
330872	1678	23040757718000	21392	10709	33	0	\N
330873	1678	23040757719000	21392	10709	34	0	\N
330874	1678	23040757720000	21392	10709	35	0	\N
330875	1678	23040757721000	21392	10709	36	0	\N
330876	1678	23040757722000	21392	10709	37	0	\N
330877	1678	23040757723000	21392	10709	38	0	\N
330878	1678	23040757724000	21392	10709	39	0	\N
330879	1678	23040757725000	21392	10709	40	0	\N
330880	1678	23040757726000	21392	10709	41	0	\N
330881	1874	16716000	21392	10709	42	0	\N
330882	1874	16719000	21392	10709	43	0	\N
330883	2287	19000000000	21392	10709	44	0	\N
330884	2287	719000000000	21392	10709	45	0	\N
330885	1874	16721000	21392	10709	46	0	\N
330886	1874	16723000	21392	10709	47	0	\N
330887	1874	16726000	21392	10709	48	0	\N
330888	1874	16729000	21392	10709	49	0	\N
330761	1874	16857000	21371	10724	2	0	2
330762	1874	16860000	21371	10724	3	0	2
330763	1874	16862000	21371	10724	4	0	2
330764	1874	16864000	21371	10724	5	0	2
330785	1678	23040757717000	21377	10725	0	0	0
330787	1874	16869000	21377	10725	2	0	2
330788	1874	16870000	21377	10725	3	0	2
330789	1678	23040757718000	21380	10726	0	0	0
330790	1874	16873000	21380	10726	1	0	2
330791	1874	16875000	21380	10726	2	0	2
330793	1678	23040757719000	21381	10727	0	0	0
330794	1678	23040757720000	21381	10727	1	0	0
330795	1874	16877000	21381	10727	2	0	2
330796	1874	16879000	21381	10727	3	0	2
330798	1874	16885000	21381	10727	5	0	2
330799	1678	23040757721000	21382	10728	0	0	0
330800	1678	23040757722000	21382	10728	1	0	0
330801	1874	16888000	21382	10728	2	0	2
330802	1874	16891000	21382	10728	3	0	2
330804	1874	16894000	21382	10728	5	0	2
330805	1874	16896000	21382	10728	6	0	2
330816	1678	23040757723000	21385	10729	0	0	0
330817	1874	16898000	21385	10729	1	0	2
330818	1874	16901000	21385	10729	2	0	2
330830	2288	0	21389	10730	1	0	0
330831	1874	16902000	21389	10730	2	0	2
330832	1874	16905000	21389	10730	3	0	2
330833	1678	23040757725000	21390	10731	0	0	0
330835	1874	16910000	21390	10731	2	0	2
330836	1678	23040757726000	21391	10732	0	0	0
330837	1874	16912000	21391	10732	1	0	2
330838	1874	16915000	21391	10732	2	0	2
330889	1874	16732000	21392	10709	50	0	\N
330890	1874	16735000	21392	10709	51	0	\N
330891	1874	16738000	21392	10709	52	0	\N
330892	1874	16741000	21392	10709	53	0	\N
330893	1874	16744000	21392	10709	54	0	\N
330894	1874	16747000	21392	10709	55	0	\N
330895	1874	16750000	21392	10709	56	0	\N
330896	1874	16752000	21392	10709	57	0	\N
330897	1874	16754000	21392	10709	58	0	\N
330898	1874	16756000	21392	10709	59	0	\N
330899	1874	16758000	21392	10709	60	0	\N
330900	1874	16760000	21392	10709	61	0	\N
330901	1874	16762000	21392	10709	62	0	\N
330902	1874	16764000	21392	10709	63	0	\N
330903	1874	16766000	21392	10709	64	0	\N
330904	1874	16768000	21392	10709	65	0	\N
330905	1874	16770000	21392	10709	66	0	\N
330906	1874	16772000	21392	10709	67	0	\N
330907	1874	16774000	21392	10709	68	0	\N
330908	1874	16776000	21392	10709	69	0	\N
330909	1874	16778000	21392	10709	70	0	\N
330910	1874	16780000	21392	10709	71	0	\N
330911	1874	16783000	21392	10709	72	0	\N
330912	1874	16786000	21392	10709	73	0	\N
330913	1874	16789000	21392	10709	74	0	\N
330914	1874	16792000	21392	10709	75	0	\N
330915	1874	16795000	21392	10709	76	0	\N
330916	1874	16798000	21392	10709	77	0	\N
330917	1874	16801000	21392	10709	78	0	\N
330918	1874	16804000	21392	10709	79	0	\N
330919	1874	16807000	21392	10709	80	0	\N
330920	1874	16810000	21392	10709	81	0	\N
330921	1874	16813000	21392	10709	82	0	\N
330922	1874	16816000	21392	10709	83	0	\N
330923	1874	16819000	21392	10709	84	0	\N
330924	1874	16822000	21392	10709	85	0	\N
330925	1874	16825000	21392	10709	86	0	\N
330926	1874	16828000	21392	10709	87	0	\N
330927	1874	16831000	21392	10709	88	0	\N
330928	1874	16834000	21392	10709	89	0	\N
330929	1874	16837000	21392	10709	90	0	\N
330930	1874	16840000	21392	10709	91	0	\N
330931	1874	16843000	21392	10709	92	0	\N
330932	1874	16846000	21392	10709	93	0	\N
330933	1874	16849000	21392	10709	94	0	\N
330934	1874	16852000	21392	10709	95	0	\N
330935	1874	16855000	21392	10709	96	0	\N
330936	1874	16858000	21392	10709	97	0	\N
330937	1874	16861000	21392	10709	98	0	\N
330938	1874	16864000	21392	10709	99	0	\N
330939	1874	16867000	21392	10709	100	0	\N
330940	1874	16869000	21392	10709	101	0	\N
330941	1874	16871000	21392	10709	102	0	\N
330942	1874	16873000	21392	10709	103	0	\N
330943	1874	16875000	21392	10709	104	0	\N
330944	1874	16877000	21392	10709	105	0	\N
330945	1874	16879000	21392	10709	106	0	\N
330946	1874	16881000	21392	10709	107	0	\N
330947	1874	16883000	21392	10709	108	0	\N
330948	1874	16884000	21392	10709	109	0	\N
330949	1874	16885000	21392	10709	110	0	\N
330950	1874	16886000	21392	10709	112	0	\N
330951	1874	16887000	21392	10709	113	0	\N
330952	1874	16888000	21392	10709	114	0	\N
330953	1874	16889000	21392	10709	115	0	\N
330954	1874	16890000	21392	10709	116	0	\N
330955	1874	16891000	21392	10709	117	0	\N
330956	1874	16892000	21392	10709	118	0	\N
330957	1874	16893000	21392	10709	119	0	\N
330958	1874	16895000	21392	10709	120	0	\N
330959	1874	16897000	21392	10709	121	0	\N
330960	1874	16899000	21392	10709	122	0	\N
330961	1874	16901000	21392	10709	123	0	\N
330962	1874	16903000	21392	10709	124	0	\N
330963	1678	23040757727000	21393	10733	0	0	\N
330964	1874	16918000	21393	10733	1	0	\N
330965	1874	16920000	21393	10733	2	0	\N
330966	1874	16921000	21393	10733	3	0	\N
330971	1678	23040757727000	21395	10733	0	0	\N
330972	1874	16918000	21395	10733	1	0	\N
330973	1874	16920000	21395	10733	2	0	\N
330974	1874	16921000	21395	10733	3	0	\N
330978	2288	0	21397	10701	0	0	\N
330979	1514	9030400	21397	10701	1	0	\N
330980	1678	23040757728000	21398	10734	0	0	\N
330981	1874	16923000	21398	10734	1	0	\N
330982	683	66339585999999	21399	10735	0	0	\N
330983	1678	23040757729000	21399	10735	1	0	\N
330984	1678	23040757730000	21399	10735	2	0	\N
330985	1678	23040757731000	21399	10735	3	0	\N
330986	1874	16929000	21399	10735	4	0	\N
330987	1874	16932000	21399	10735	5	0	\N
330988	1874	16935000	21399	10735	6	0	\N
330989	1874	16937000	21399	10735	7	0	\N
330990	1874	16939000	21399	10735	8	0	\N
330991	1874	16940000	21399	10735	9	0	\N
330992	1874	16942000	21399	10735	10	0	\N
330993	683	66339585999999	21400	10735	0	0	\N
330994	1678	23040757729000	21400	10735	1	0	\N
330995	1678	23040757730000	21400	10735	2	0	\N
330996	1678	23040757731000	21400	10735	3	0	\N
330997	1874	16929000	21400	10735	4	0	\N
330998	1874	16932000	21400	10735	5	0	\N
330999	1874	16935000	21400	10735	6	0	\N
331000	1874	16937000	21400	10735	7	0	\N
331001	1874	16939000	21400	10735	8	0	\N
331002	1874	16940000	21400	10735	9	0	\N
331003	1874	16942000	21400	10735	10	0	\N
331004	683	66339585999999	21401	10735	0	0	\N
331005	1678	23040757729000	21401	10735	1	0	\N
331006	1678	23040757730000	21401	10735	2	0	\N
331007	1678	23040757731000	21401	10735	3	0	\N
331008	1874	16929000	21401	10735	4	0	\N
331009	1874	16932000	21401	10735	5	0	\N
331010	1874	16935000	21401	10735	6	0	\N
331011	1874	16937000	21401	10735	7	0	\N
331012	1874	16939000	21401	10735	8	0	\N
331013	1874	16940000	21401	10735	9	0	\N
331014	1874	16942000	21401	10735	10	0	\N
330969	1874	16920000	21394	10733	2	0	2
330970	1874	16921000	21394	10733	3	0	2
330975	1678	23040757728000	21396	10734	0	0	0
330976	1874	16924000	21396	10734	1	0	2
330977	1874	16926000	21396	10734	2	0	2
331016	1678	23040757729000	21402	10735	1	0	0
331017	1678	23040757730000	21402	10735	2	0	0
331018	1678	23040757731000	21402	10735	3	0	0
331019	1874	16929000	21402	10735	4	0	2
331020	1874	16932000	21402	10735	5	0	2
331022	1874	16937000	21402	10735	7	0	2
331023	1874	16939000	21402	10735	8	0	2
331024	1874	16940000	21402	10735	9	0	2
331026	683	66626585999999	21403	10736	0	0	\N
331027	1678	23040757732000	21403	10736	1	0	\N
331028	1678	23040757733000	21403	10736	2	0	\N
331029	1874	16944000	21403	10736	3	0	\N
331030	1874	16946000	21403	10736	4	0	\N
331031	1874	16949000	21403	10736	5	0	\N
331032	1874	16952000	21403	10736	6	0	\N
331040	1678	23040757734000	21405	10737	0	0	\N
331041	1874	16955000	21405	10737	1	0	\N
331042	1874	16957000	21405	10737	2	0	\N
331043	1874	16958000	21405	10737	3	0	\N
331044	1678	23040757734000	21406	10737	0	0	\N
331045	1874	16955000	21406	10737	1	0	\N
331046	1874	16957000	21406	10737	2	0	\N
331047	1874	16958000	21406	10737	3	0	\N
331057	1012	506425775000000	21409	10738	0	0	\N
331058	1252	612316750000000	21409	10738	1	0	\N
331059	1678	23040757735000	21409	10738	2	0	\N
331060	1874	16960000	21409	10738	3	0	\N
331061	1874	16963000	21409	10738	4	0	\N
331062	1012	506425775000000	21410	10738	0	0	\N
331063	1252	612316750000000	21410	10738	1	0	\N
331064	1874	16960000	21410	10738	2	0	\N
331065	957	508158775000000	21411	10463	0	0	\N
331066	1197	614409750000000	21411	10463	1	0	\N
331067	1077	910614465000000	21411	10463	2	0	\N
331068	1323	1712107637751650	21411	10463	3	0	\N
331069	683	66339585999999	21411	10463	4	0	\N
331070	683	66626585999999	21411	10463	5	0	\N
331071	1012	506425775000000	21411	10463	6	0	\N
331072	1252	612316750000000	21411	10463	7	0	\N
331073	1364	1709956637751650	21411	10463	8	0	\N
331074	1386	1712107637751650	21411	10463	9	0	\N
331075	1383	1710879637751650	21411	10463	10	0	\N
331076	1118	909471465000000	21411	10463	11	0	\N
331077	1140	910615465000000	21411	10463	12	0	\N
331078	2288	0	21411	10463	13	0	\N
331079	1137	909961465000000	21411	10463	14	0	\N
331080	1257	613969750000000	21411	10463	15	0	\N
331081	1017	507794775000000	21411	10463	16	0	\N
331082	1260	614410750000000	21411	10463	17	0	\N
331083	1678	23040757477000	21411	10463	18	0	\N
331084	1238	613638750000000	21411	10463	19	0	\N
331085	998	507520775000000	21411	10463	20	0	\N
331086	1678	23040757478000	21411	10463	21	0	\N
331087	1678	23040757479000	21411	10463	22	0	\N
331088	1678	23040757480000	21411	10463	23	0	\N
331089	1678	23040757481000	21411	10463	24	0	\N
331090	1678	23040757482000	21411	10463	25	0	\N
331091	1678	23040757483000	21411	10463	26	0	\N
331092	1678	23040757484000	21411	10463	27	0	\N
331093	1678	23040757485000	21411	10463	28	0	\N
331094	1678	23040757486000	21411	10463	29	0	\N
331095	1678	23040757487000	21411	10463	30	0	\N
331096	1678	23040757488000	21411	10463	31	0	\N
331097	1678	23040757489000	21411	10463	32	0	\N
331098	1678	23040757490000	21411	10463	33	0	\N
331099	1678	23040757491000	21411	10463	34	0	\N
331100	1678	23040757492000	21411	10463	35	0	\N
331101	1678	23040757493000	21411	10463	36	0	\N
331102	1678	23040757494000	21411	10463	37	0	\N
331103	1678	23040757495000	21411	10463	38	0	\N
331104	1678	23040757496000	21411	10463	39	0	\N
331105	1678	23040757497000	21411	10463	40	0	\N
331106	1678	23040757498000	21411	10463	41	0	\N
331107	1678	23040757499000	21411	10463	42	0	\N
331108	1678	23040757500000	21411	10463	43	0	\N
331109	1678	23040757501000	21411	10463	44	0	\N
331110	1678	23040757502000	21411	10463	45	0	\N
331111	1678	23040757503000	21411	10463	46	0	\N
331112	1678	23040757504000	21411	10463	47	0	\N
331113	1678	23040757505000	21411	10463	48	0	\N
331114	1678	23040757506000	21411	10463	49	0	\N
331115	1678	23040757507000	21411	10463	50	0	\N
331116	1678	23040757508000	21411	10463	51	0	\N
331117	1678	23040757509000	21411	10463	52	0	\N
331118	1678	23040757510000	21411	10463	53	0	\N
331119	1678	23040757511000	21411	10463	54	0	\N
331120	1678	23040757512000	21411	10463	55	0	\N
331121	1678	23040757513000	21411	10463	56	0	\N
331122	1678	23040757514000	21411	10463	57	0	\N
331123	1678	23040757515000	21411	10463	58	0	\N
331124	1678	23040757516000	21411	10463	59	0	\N
331125	1678	23040757517000	21411	10463	60	0	\N
331126	1678	23040757518000	21411	10463	61	0	\N
331127	1678	23040757519000	21411	10463	62	0	\N
331128	1678	23040757520000	21411	10463	63	0	\N
331129	1678	23040757521000	21411	10463	64	0	\N
331130	1678	23040757522000	21411	10463	65	0	\N
331131	1678	23040757523000	21411	10463	66	0	\N
331132	1678	23040757524000	21411	10463	67	0	\N
331133	1678	23040757525000	21411	10463	68	0	\N
331134	1678	23040757526000	21411	10463	69	0	\N
331135	1678	23040757527000	21411	10463	70	0	\N
331136	1678	23040757528000	21411	10463	71	0	\N
331137	1678	23040757529000	21411	10463	72	0	\N
331138	1678	23040757530000	21411	10463	73	0	\N
331139	1678	23040757531000	21411	10463	74	0	\N
331140	1678	23040757532000	21411	10463	75	0	\N
331141	1678	23040757533000	21411	10463	76	0	\N
331142	1678	23040757534000	21411	10463	77	0	\N
331143	1678	23040757535000	21411	10463	78	0	\N
331144	1678	23040757536000	21411	10463	79	0	\N
331145	1678	23040757537000	21411	10463	80	0	\N
331146	1678	23040757538000	21411	10463	81	0	\N
331147	1678	23040757539000	21411	10463	82	0	\N
331148	1678	23040757540000	21411	10463	83	0	\N
331149	1678	23040757541000	21411	10463	84	0	\N
331150	1678	23040757542000	21411	10463	85	0	\N
331151	1678	23040757543000	21411	10463	86	0	\N
331152	1678	23040757544000	21411	10463	87	0	\N
331153	1678	23040757545000	21411	10463	88	0	\N
331154	1678	23040757546000	21411	10463	89	0	\N
331155	1678	23040757547000	21411	10463	90	0	\N
331156	1678	23040757548000	21411	10463	91	0	\N
331157	1678	23040757549000	21411	10463	92	0	\N
331158	1678	23040757550000	21411	10463	93	0	\N
331159	1678	23040757551000	21411	10463	94	0	\N
331160	1678	23040757552000	21411	10463	95	0	\N
331034	1678	23040757732000	21404	10736	1	0	0
331035	1678	23040757733000	21404	10736	2	0	0
331036	1874	16944000	21404	10736	3	0	2
331037	1874	16946000	21404	10736	4	0	2
331038	1874	16949000	21404	10736	5	0	2
331048	1678	23040757734000	21407	10737	0	0	0
331049	1874	16955000	21407	10737	1	0	2
331050	1874	16957000	21407	10737	2	0	2
331051	1874	16958000	21407	10737	3	0	2
331052	1012	506425775000000	21408	10738	0	0	0
331054	1678	23040757735000	21408	10738	2	0	0
331055	1874	16960000	21408	10738	3	0	2
331056	1874	16963000	21408	10738	4	0	2
331161	1678	23040757553000	21411	10463	96	0	\N
331162	1678	23040757554000	21411	10463	97	0	\N
331163	1678	23040757555000	21411	10463	98	0	\N
331164	1678	23040757556000	21411	10463	99	0	\N
331165	1678	23040757557000	21411	10463	100	0	\N
331166	1678	23040757558000	21411	10463	101	0	\N
331167	1678	23040757559000	21411	10463	102	0	\N
331168	1678	23040757560000	21411	10463	103	0	\N
331169	1678	23040757561000	21411	10463	104	0	\N
331170	1678	23040757562000	21411	10463	105	0	\N
331171	1678	23040757563000	21411	10463	107	0	\N
331172	1678	23040757564000	21411	10463	108	0	\N
331173	1678	23040757565000	21411	10463	109	0	\N
331174	1678	23040757566000	21411	10463	110	0	\N
331175	1678	23040757567000	21411	10463	111	0	\N
331176	1678	23040757568000	21411	10463	112	0	\N
331177	1678	23040757569000	21411	10463	113	0	\N
331178	1678	23040757570000	21411	10463	114	0	\N
331179	1678	23040757571000	21411	10463	115	0	\N
331180	1678	23040757572000	21411	10463	116	0	\N
331181	1678	23040757573000	21411	10463	117	0	\N
331182	1678	23040757574000	21411	10463	118	0	\N
331183	1678	23040757575000	21411	10463	119	0	\N
331184	1678	23040757576000	21411	10463	120	0	\N
331185	1678	23040757577000	21411	10463	121	0	\N
331186	1678	23040757578000	21411	10463	122	0	\N
331190	1678	23040757736000	21413	10739	0	0	\N
331191	1874	16965000	21413	10739	1	0	\N
331192	1874	16968000	21413	10739	2	0	\N
331193	1678	23040757736000	21414	10739	0	0	\N
331194	1874	16965000	21414	10739	1	0	\N
331195	1874	16968000	21414	10739	2	0	\N
331207	1132	907510465000000	21416	10740	0	0	\N
331208	1378	1706269637751650	21416	10740	1	0	\N
331209	1678	23040757737000	21416	10740	2	0	\N
331210	1678	23040757738000	21416	10740	3	0	\N
331211	1874	16971000	21416	10740	4	0	\N
331212	1874	16973000	21416	10740	5	0	\N
331213	1874	16974000	21416	10740	6	0	\N
331214	1874	16977000	21416	10740	7	0	\N
331215	1874	16980000	21416	10740	9	0	\N
331216	1874	16982000	21416	10740	10	0	\N
331217	1874	16984000	21416	10740	11	0	\N
331218	1132	907510465000000	21417	10740	0	0	\N
331219	1378	1706269637751650	21417	10740	1	0	\N
331220	1678	23040757737000	21417	10740	2	0	\N
331221	1678	23040757738000	21417	10740	3	0	\N
331222	1678	23040757739000	21417	10740	4	0	\N
331223	1874	16971000	21417	10740	5	0	\N
331224	1874	16973000	21417	10740	6	0	\N
331225	1874	16974000	21417	10740	7	0	\N
331226	1874	16977000	21417	10740	9	0	\N
331227	1874	16980000	21417	10740	10	0	\N
331228	1874	16982000	21417	10740	11	0	\N
331229	1874	16984000	21417	10740	12	0	\N
331230	1132	907510465000000	21418	10740	0	0	\N
331231	1378	1706269637751650	21418	10740	1	0	\N
331232	1678	23040757737000	21418	10740	2	0	\N
331233	1678	23040757738000	21418	10740	3	0	\N
331234	1874	16971000	21418	10740	4	0	\N
331235	1874	16973000	21418	10740	5	0	\N
331236	1874	16974000	21418	10740	6	0	\N
331237	1874	16977000	21418	10740	7	0	\N
331238	1874	16980000	21418	10740	9	0	\N
331239	1874	16982000	21418	10740	10	0	\N
331240	1874	16984000	21418	10740	11	0	\N
331247	1678	23040757741000	21421	10743	0	0	\N
331248	1874	16995000	21421	10743	1	0	\N
331249	2288	1000000000	21421	10743	2	0	\N
331253	1678	23040757742000	21423	10744	0	0	\N
331254	1874	16998000	21423	10744	1	0	\N
331255	1874	17000000	21423	10744	2	0	\N
331259	1678	23040757743000	21425	10745	0	0	\N
331260	1874	17003000	21425	10745	1	0	\N
331261	1874	17004000	21425	10745	2	0	\N
331262	1874	17006000	21425	10745	3	0	\N
331273	1678	23040757746000	21428	10747	0	0	\N
331274	1678	23040757747000	21428	10747	1	0	\N
331275	1678	23040757748000	21428	10747	2	0	\N
331276	1874	17019000	21428	10747	3	0	\N
331277	1874	17021000	21428	10747	4	0	\N
331278	1874	17024000	21428	10747	5	0	\N
331279	1874	17027000	21428	10747	6	0	\N
331280	1874	17028000	21428	10747	7	0	\N
331281	1874	17030000	21428	10747	8	0	\N
331282	1874	17032000	21428	10747	9	0	\N
331293	1678	23040757749000	21430	10748	0	0	\N
331294	1874	17034000	21430	10748	1	0	\N
331295	1874	17037000	21430	10748	2	0	\N
331189	1874	16968000	21412	10739	2	0	2
331196	1132	907510465000000	21415	10740	0	0	0
331197	1378	1706269637751650	21415	10740	1	0	0
331198	1678	23040757737000	21415	10740	2	0	0
331199	1678	23040757738000	21415	10740	3	0	0
331201	1874	16973000	21415	10740	5	0	2
331202	1874	16974000	21415	10740	6	0	2
331203	1874	16977000	21415	10740	7	0	2
331204	1874	16980000	21415	10740	9	0	2
331205	1874	16982000	21415	10740	10	0	2
331241	1678	23040757739000	21419	10741	0	0	0
331242	1874	16986000	21419	10741	1	0	2
331243	1874	16989000	21419	10741	2	0	2
331244	1678	23040757740000	21420	10742	0	0	0
331246	1874	16993000	21420	10742	2	0	2
331250	1678	23040757741000	21422	10743	0	0	0
331251	1874	16995000	21422	10743	1	0	2
331252	2288	1000000000	21422	10743	2	0	0
331256	1678	23040757742000	21424	10744	0	0	0
331258	1874	17000000	21424	10744	2	0	2
331263	1678	23040757743000	21426	10745	0	0	0
331264	1874	17003000	21426	10745	1	0	2
331265	1874	17004000	21426	10745	2	0	2
331266	1874	17006000	21426	10745	3	0	2
331268	1678	23040757745000	21427	10746	1	0	0
331269	1874	17008000	21427	10746	2	0	2
331270	1874	17010000	21427	10746	3	0	2
331271	1874	17013000	21427	10746	4	0	2
331283	1678	23040757746000	21429	10747	0	0	0
331284	1678	23040757747000	21429	10747	1	0	0
331285	1678	23040757748000	21429	10747	2	0	0
331286	1874	17019000	21429	10747	3	0	2
331287	1874	17021000	21429	10747	4	0	2
331289	1874	17027000	21429	10747	6	0	2
331290	1874	17028000	21429	10747	7	0	2
331291	1874	17030000	21429	10747	8	0	2
331292	1874	17032000	21429	10747	9	0	2
331296	1678	23040757749000	21431	10748	0	0	0
331299	1678	23040757749000	21432	10748	0	0	\N
331300	1874	17034000	21432	10748	1	0	\N
331301	1874	17037000	21432	10748	2	0	\N
331311	1678	23040757751000	21435	10750	0	0	\N
331312	1678	23040757752000	21435	10750	1	0	\N
331313	1874	17043000	21435	10750	2	0	\N
331314	1874	17046000	21435	10750	3	0	\N
331315	1874	17049000	21435	10750	4	0	\N
331316	1874	17051000	21435	10750	5	0	\N
331324	2288	1000000000	21437	10741	0	0	\N
331340	1678	23040757756000	21441	10754	0	0	\N
331341	1678	23040757757000	21441	10754	1	0	\N
331342	291	66589992681547	21441	10754	2	0	\N
331343	1874	17073000	21441	10754	3	0	\N
331344	1874	17076000	21441	10754	4	0	\N
331345	1874	17078000	21441	10754	5	0	\N
331363	1678	23040757761000	21446	10757	0	0	\N
331364	1874	17097000	21446	10757	1	0	\N
331365	1874	17099000	21446	10757	2	0	\N
331381	1579	0	21450	10742	0	0	\N
331382	1771	598166214766	21450	10742	1	0	\N
331383	195	66589992681547	21450	10742	2	0	\N
331384	291	66589992681547	21450	10742	3	0	\N
331385	1023	507269669126828	21450	10742	4	0	\N
331386	1143	909022900788739	21450	10742	5	0	\N
331387	1263	613335864722998	21450	10742	6	0	\N
331388	1389	1709114921835103	21450	10742	7	0	\N
331389	1579	0	21450	10742	8	0	\N
331390	2288	11000000000	21450	10742	9	0	\N
331391	2288	521000000000	21450	10742	10	0	\N
331399	683	66339585999999	21453	10702	0	0	\N
331400	683	66626585999999	21453	10702	1	0	\N
331401	1012	506425775000000	21453	10702	2	0	\N
331402	1252	612316750000000	21453	10702	3	0	\N
331403	1132	907510465000000	21453	10702	4	0	\N
331404	1378	1706269637751650	21453	10702	5	0	\N
331405	1579	0	21453	10702	6	0	\N
331406	1771	598166214766	21453	10702	7	0	\N
331407	195	66589992681547	21453	10702	8	0	\N
331408	291	66589992681547	21453	10702	9	0	\N
331409	1023	507269669126828	21453	10702	10	0	\N
331410	1143	909022900788739	21453	10702	11	0	\N
331411	1263	613335864722998	21453	10702	12	0	\N
331412	1389	1709114921835103	21453	10702	13	0	\N
331413	1579	0	21453	10702	14	0	\N
331414	2288	1000000000	21453	10702	15	0	\N
331415	2288	11000000000	21453	10702	16	0	\N
331416	2288	521000000000	21453	10702	17	0	\N
331423	957	508158775000000	21456	10578	0	0	\N
331424	1197	614409750000000	21456	10578	1	0	\N
331425	1077	910614465000000	21456	10578	2	0	\N
331426	1323	1712107637751650	21456	10578	3	0	\N
331427	683	66339585999999	21456	10578	4	0	\N
331428	683	66626585999999	21456	10578	5	0	\N
331429	1012	506425775000000	21456	10578	6	0	\N
331430	1252	612316750000000	21456	10578	7	0	\N
331431	1132	907510465000000	21456	10578	8	0	\N
331432	1378	1706269637751650	21456	10578	9	0	\N
331302	1678	23040757750000	21433	10749	0	0	0
331303	1874	17038000	21433	10749	1	0	2
331304	1874	17041000	21433	10749	2	0	2
331305	1678	23040757751000	21434	10750	0	0	0
331306	1678	23040757752000	21434	10750	1	0	0
331308	1874	17046000	21434	10750	3	0	2
331309	1874	17049000	21434	10750	4	0	2
331310	1874	17051000	21434	10750	5	0	2
331317	1678	23040757753000	21436	10751	0	0	0
331318	1678	23040757754000	21436	10751	1	0	0
331320	1874	17057000	21436	10751	3	0	2
331321	1874	17059000	21436	10751	4	0	2
331322	1874	17060000	21436	10751	5	0	2
331323	1874	17062000	21436	10751	6	0	2
331326	1874	17065000	21438	10752	1	0	2
331327	1874	17067000	21438	10752	2	0	2
331328	2288	11000000000	21438	10752	3	0	0
331329	1771	598176214766	21439	10753	0	0	0
331330	195	66589992681547	21439	10753	1	0	0
331332	1874	17070000	21439	10753	3	0	2
331333	2288	521000000000	21439	10753	4	0	0
331334	1678	23040757756000	21440	10754	0	0	0
331335	1678	23040757757000	21440	10754	1	0	0
331336	291	66589992681547	21440	10754	2	0	0
331338	1874	17076000	21440	10754	4	0	2
331339	1874	17078000	21440	10754	5	0	2
331346	1023	507269669126828	21443	10755	0	0	0
331347	1143	909022900788739	21443	10755	1	0	0
331349	1678	23040757759000	21443	10755	3	0	0
331350	1874	17081000	21443	10755	4	0	2
331351	1874	17084000	21443	10755	5	0	2
331352	1874	17086000	21443	10755	6	0	2
331353	1874	17088000	21443	10755	7	0	2
331355	1263	613335864722998	21444	10756	1	0	0
331356	1389	1709114921835103	21444	10756	2	0	0
331357	1874	17091000	21444	10756	3	0	2
331358	1874	17093000	21444	10756	4	0	2
331359	1874	17094000	21444	10756	5	0	2
331361	1874	17097000	21445	10757	1	0	2
331362	1874	17099000	21445	10757	2	0	2
331366	1678	23040757762000	21447	10758	0	0	0
331367	1678	23040757763000	21447	10758	1	0	0
331369	1874	17104000	21447	10758	3	0	2
331370	1874	17105000	21447	10758	4	0	2
331371	1874	17108000	21447	10758	6	0	2
331372	1874	17110000	21447	10758	7	0	2
331373	1579	0	21448	10759	0	0	0
331375	1874	17113000	21448	10759	2	0	2
331376	1874	17115000	21448	10759	3	0	2
331377	1678	23040757765000	21449	10760	0	0	0
331378	1579	0	21449	10760	1	0	0
331379	1874	17118000	21449	10760	2	0	2
331392	1678	23040757766000	21451	10761	0	0	0
331393	1874	17123000	21451	10761	1	0	2
331394	1874	17124000	21451	10761	2	0	2
331395	1874	17126000	21451	10761	3	0	2
331397	1874	17129000	21452	10762	1	0	2
331398	1874	17131000	21452	10762	2	0	2
331417	1678	23040757768000	21454	10763	0	0	0
331418	1874	17133000	21454	10763	1	0	2
331419	1874	17136000	21454	10763	2	0	2
331421	1874	17138000	21455	10764	1	0	2
331422	1874	17141000	21455	10764	2	0	2
331433	2288	0	21456	10578	10	0	\N
331434	1579	0	21456	10578	11	0	\N
331435	1771	598166214766	21456	10578	12	0	\N
331436	195	66589992681547	21456	10578	13	0	\N
331437	291	66589992681547	21456	10578	14	0	\N
331438	1023	507269669126828	21456	10578	15	0	\N
331439	1143	909022900788739	21456	10578	16	0	\N
331440	1263	613335864722998	21456	10578	17	0	\N
331441	1389	1709114921835103	21456	10578	18	0	\N
331442	1579	0	21456	10578	19	0	\N
331443	1540	0	21456	10578	20	0	\N
331444	1874	16239000	21456	10578	21	0	\N
331445	2287	19000000000	21456	10578	22	0	\N
331446	2287	719000000000	21456	10578	23	0	\N
331447	1874	16242000	21456	10578	24	0	\N
331448	1874	16245000	21456	10578	25	0	\N
331449	1874	16248000	21456	10578	26	0	\N
331450	1874	16251000	21456	10578	27	0	\N
331451	1874	16254000	21456	10578	28	0	\N
331452	1874	16257000	21456	10578	29	0	\N
331453	1874	16260000	21456	10578	30	0	\N
331454	1874	16263000	21456	10578	31	0	\N
331455	1874	16266000	21456	10578	32	0	\N
331456	1874	16269000	21456	10578	33	0	\N
331457	1874	16272000	21456	10578	34	0	\N
331458	1874	16275000	21456	10578	35	0	\N
331459	1874	16278000	21456	10578	36	0	\N
331460	1874	16281000	21456	10578	37	0	\N
331461	1874	16284000	21456	10578	38	0	\N
331462	1874	16287000	21456	10578	39	0	\N
331463	2288	1000000000	21456	10578	40	0	\N
331464	1874	16290000	21456	10578	41	0	\N
331482	1678	23040757774000	21460	10767	0	0	\N
331483	1874	17165000	21460	10767	1	0	\N
331484	1874	17168000	21460	10767	2	0	\N
331485	1678	23040757775000	21461	10768	0	0	\N
331486	1874	17170000	21461	10768	1	0	\N
331487	1874	17173000	21461	10768	2	0	\N
331488	1678	23040757775000	21462	10768	0	0	\N
331489	1874	17170000	21462	10768	1	0	\N
331490	1874	17173000	21462	10768	2	0	\N
331491	1678	23040757775000	21463	10768	0	0	\N
331492	1874	17170000	21463	10768	1	0	\N
331493	1874	17173000	21463	10768	2	0	\N
331497	1678	23040757776000	21465	10769	0	0	\N
331498	1678	23040757777000	21465	10769	1	0	\N
331499	1678	23040757778000	21465	10769	2	0	\N
331500	1874	17175000	21465	10769	3	0	\N
331501	1874	17176000	21465	10769	4	0	\N
331502	1874	17178000	21465	10769	5	0	\N
331503	1874	17181000	21465	10769	6	0	\N
331504	1874	17184000	21465	10769	7	0	\N
331505	1874	17187000	21465	10769	8	0	\N
331506	1874	17189000	21465	10769	9	0	\N
331517	1678	23040757776000	21467	10769	0	0	\N
331518	1678	23040757777000	21467	10769	1	0	\N
331519	1678	23040757778000	21467	10769	2	0	\N
331520	1874	17175000	21467	10769	3	0	\N
331521	1874	17176000	21467	10769	4	0	\N
331522	1874	17178000	21467	10769	5	0	\N
331523	1874	17181000	21467	10769	6	0	\N
331524	1874	17184000	21467	10769	7	0	\N
331525	1874	17187000	21467	10769	8	0	\N
331526	1874	17189000	21467	10769	9	0	\N
331527	1678	23040757776000	21468	10769	0	0	\N
331528	1678	23040757777000	21468	10769	1	0	\N
331529	1678	23040757778000	21468	10769	2	0	\N
331530	1874	17175000	21468	10769	3	0	\N
331531	1874	17176000	21468	10769	4	0	\N
331532	1874	17178000	21468	10769	5	0	\N
331533	1874	17181000	21468	10769	6	0	\N
331534	1874	17184000	21468	10769	7	0	\N
331535	1874	17187000	21468	10769	8	0	\N
331536	1874	17189000	21468	10769	9	0	\N
331537	1678	23040757779000	21469	10770	0	0	\N
331538	1874	17192000	21469	10770	1	0	\N
331539	1874	17194000	21469	10770	2	0	\N
331540	1678	23040757779000	21470	10770	0	0	\N
331541	1874	17192000	21470	10770	1	0	\N
331542	1874	17194000	21470	10770	2	0	\N
331546	1678	23040757779000	21472	10770	0	0	\N
331547	1874	17192000	21472	10770	1	0	\N
331548	1874	17194000	21472	10770	2	0	\N
331559	1678	23040757783000	21477	10772	0	0	\N
331560	1874	17213000	21477	10772	1	0	\N
331561	1874	17214000	21477	10772	2	0	\N
331562	1874	17216000	21477	10772	3	0	\N
331563	1678	23040757783000	21478	10772	0	0	\N
331564	1874	17213000	21478	10772	1	0	\N
331565	1874	17214000	21478	10772	2	0	\N
331566	1874	17216000	21478	10772	3	0	\N
331567	1678	23040757783000	21479	10772	0	0	\N
331568	1874	17213000	21479	10772	1	0	\N
331467	1874	17143000	21457	10765	2	0	2
331468	1874	17146000	21457	10765	3	0	2
331469	1874	17148000	21457	10765	4	0	2
331470	1874	17149000	21457	10765	5	0	2
331471	1874	17152000	21457	10765	6	0	2
331473	1678	23040757773000	21458	10766	1	0	0
331474	1874	17154000	21458	10766	2	0	2
331475	1874	17156000	21458	10766	3	0	2
331476	1874	17157000	21458	10766	4	0	2
331477	1874	17160000	21458	10766	5	0	2
331479	1678	23040757774000	21459	10767	0	0	0
331480	1874	17165000	21459	10767	1	0	2
331481	1874	17168000	21459	10767	2	0	2
331494	1678	23040757775000	21464	10768	0	0	0
331496	1874	17173000	21464	10768	2	0	2
331507	1678	23040757776000	21466	10769	0	0	0
331508	1678	23040757777000	21466	10769	1	0	0
331509	1678	23040757778000	21466	10769	2	0	0
331510	1874	17175000	21466	10769	3	0	2
331512	1874	17178000	21466	10769	5	0	2
331513	1874	17181000	21466	10769	6	0	2
331514	1874	17184000	21466	10769	7	0	2
331515	1874	17187000	21466	10769	8	0	2
331516	1874	17189000	21466	10769	9	0	2
331544	1874	17192000	21471	10770	1	0	2
331545	1874	17194000	21471	10770	2	0	2
331549	1678	23040757780000	21476	10771	0	0	0
331550	1678	23040757781000	21476	10771	1	0	0
331552	1874	17196000	21476	10771	3	0	2
331553	1874	17198000	21476	10771	4	0	2
331554	1874	17201000	21476	10771	5	0	2
331555	1874	17204000	21476	10771	6	0	2
331556	1874	17207000	21476	10771	7	0	2
331558	1874	17210000	21476	10771	9	0	2
331569	1874	17214000	21479	10772	2	0	\N
331570	1874	17216000	21479	10772	3	0	\N
331571	1678	23040757783000	21480	10772	0	0	\N
331572	1874	17213000	21480	10772	1	0	\N
331573	1874	17214000	21480	10772	2	0	\N
331574	1874	17216000	21480	10772	3	0	\N
331579	1678	23040757783000	21482	10772	0	0	\N
331580	1874	17213000	21482	10772	1	0	\N
331581	1874	17214000	21482	10772	2	0	\N
331582	1874	17216000	21482	10772	3	0	\N
331583	1678	23040757783000	21483	10772	0	0	\N
331584	1874	17213000	21483	10772	1	0	\N
331585	1874	17214000	21483	10772	2	0	\N
331586	1874	17216000	21483	10772	3	0	\N
331599	1678	23040757788000	21487	10776	0	0	\N
331600	1874	17237000	21487	10776	1	0	\N
331601	1874	17240000	21487	10776	2	0	\N
331612	1678	23040757791000	21492	10779	0	0	\N
331613	1874	17251000	21492	10779	1	0	\N
331614	1483	10000000	21493	10703	0	0	\N
331615	1678	23040757791000	21494	10779	0	0	\N
331616	1874	17251000	21494	10779	1	0	\N
331620	1678	23040757793000	21496	10781	0	0	\N
331621	1483	10000000	21496	10781	1	0	\N
331622	1678	23040757794000	21496	10781	2	0	\N
331623	1874	17257000	21496	10781	3	0	\N
331624	1874	17260000	21496	10781	4	0	\N
331636	1678	23040757797000	21501	10784	0	0	\N
331637	1874	17269000	21501	10784	1	0	\N
331638	1678	23040757797000	21502	10784	0	0	\N
331639	1874	17269000	21502	10784	1	0	\N
331646	1678	23040757801000	21505	10787	0	0	\N
331647	1678	23040757802000	21505	10787	1	0	\N
331648	1678	23040757803000	21505	10787	2	0	\N
331649	1874	17281000	21505	10787	3	0	\N
331650	1874	17284000	21505	10787	4	0	\N
331651	1874	17287000	21505	10787	5	0	\N
331662	1678	23040757804000	21508	10788	0	0	\N
331663	1874	17289000	21508	10788	1	0	\N
331664	1874	17292000	21508	10788	2	0	\N
331665	1874	17293000	21508	10788	3	0	\N
331682	1678	23040757810000	21512	10792	0	0	\N
331683	1874	17321000	21512	10792	1	0	\N
331684	1874	17324000	21512	10792	2	0	\N
331685	1874	17325000	21512	10792	3	0	\N
331693	957	508158775000000	21515	10527	0	0	\N
331694	1197	614409750000000	21515	10527	1	0	\N
331695	1077	910614465000000	21515	10527	2	0	\N
331696	1323	1712107637751650	21515	10527	3	0	\N
331697	1850	22960521949999	21515	10527	4	0	\N
331698	2270	699000000000	21515	10527	5	0	\N
331699	2271	2000000000	21515	10527	6	0	\N
331700	1958	5031186000000	21515	10527	7	0	\N
331701	683	66339585999999	21515	10527	8	0	\N
331702	683	66626585999999	21515	10527	9	0	\N
331703	1012	506425775000000	21515	10527	10	0	\N
331704	1252	612316750000000	21515	10527	11	0	\N
331577	1874	17214000	21481	10772	2	0	2
331578	1874	17216000	21481	10772	3	0	2
331587	1678	23040757784000	21484	10773	0	0	0
331588	1874	17219000	21484	10773	1	0	2
331589	1678	23040757785000	21485	10774	0	0	0
331591	1874	17222000	21485	10774	2	0	2
331592	1874	17224000	21485	10774	3	0	2
331593	1874	17225000	21485	10774	4	0	2
331594	1874	17228000	21485	10774	5	0	2
331595	1874	17230000	21485	10774	6	0	2
331597	1874	17232000	21486	10775	1	0	2
331598	1874	17235000	21486	10775	2	0	2
331602	1678	23040757788000	21488	10776	0	0	0
331603	1874	17237000	21488	10776	1	0	2
331605	1678	23040757789000	21489	10777	0	0	0
331606	1483	10000000	21489	10777	1	0	0
331607	1874	17243000	21489	10777	2	0	2
331608	1874	17245000	21489	10777	3	0	2
331609	1678	23040757790000	21490	10778	0	0	0
331611	1678	23040757791000	21491	10779	0	0	0
331617	1678	23040757792000	21495	10780	0	0	0
331618	1874	17251000	21495	10780	1	0	2
331619	1874	17254000	21495	10780	2	0	2
331625	1678	23040757793000	21497	10781	0	0	0
331627	1678	23040757794000	21497	10781	2	0	0
331628	1874	17257000	21497	10781	3	0	2
331629	1874	17260000	21497	10781	4	0	2
331630	1678	23040757795000	21498	10782	0	0	0
331632	1678	23040757796000	21499	10783	0	0	0
331633	1874	17266000	21499	10783	1	0	2
331634	1678	23040757797000	21500	10784	0	0	0
331635	1874	17269000	21500	10784	1	0	2
331640	1678	23040757798000	21503	10785	0	0	0
331642	1874	17272000	21503	10785	2	0	2
331643	1874	17275000	21503	10785	3	0	2
331644	1678	23040757800000	21504	10786	0	0	0
331645	1874	17278000	21504	10786	1	0	2
331652	1678	23040757801000	21506	10787	0	0	0
331654	1678	23040757803000	21506	10787	2	0	0
331655	1874	17281000	21506	10787	3	0	2
331656	1874	17284000	21506	10787	4	0	2
331657	1874	17287000	21506	10787	5	0	2
331659	1874	17289000	21507	10788	1	0	2
331660	1874	17292000	21507	10788	2	0	2
331661	1874	17293000	21507	10788	3	0	2
331666	1678	23040757805000	21509	10789	0	0	0
331667	1874	17295000	21509	10789	1	0	2
331669	1678	23040757806000	21510	10790	0	0	0
331670	1678	23040757807000	21510	10790	1	0	0
331671	1874	17301000	21510	10790	2	0	2
331672	1874	17303000	21510	10790	3	0	2
331673	1874	17305000	21510	10790	4	0	2
331675	1874	17309000	21510	10790	6	0	2
331676	1678	23040757808000	21511	10791	0	0	0
331677	1678	23040757809000	21511	10791	1	0	0
331678	1874	17311000	21511	10791	2	0	2
331680	1874	17316000	21511	10791	4	0	2
331681	1874	17319000	21511	10791	5	0	2
331686	1678	23040757810000	21513	10792	0	0	0
331687	1874	17321000	21513	10792	1	0	2
331688	1874	17324000	21513	10792	2	0	2
331690	1678	23040757811000	21514	10793	0	0	0
331691	1874	17328000	21514	10793	1	0	2
331692	1874	17330000	21514	10793	2	0	2
331705	1132	907510465000000	21515	10527	12	0	\N
331706	1378	1706269637751650	21515	10527	13	0	\N
331707	1364	1709956637751650	21515	10527	14	0	\N
331708	1850	22961521949999	21515	10527	15	0	\N
331709	1386	1712107637751650	21515	10527	16	0	\N
331710	259	66010000000000	21515	10527	17	0	\N
331711	1483	10000000	21515	10527	18	0	\N
331712	1383	1710879637751650	21515	10527	19	0	\N
331713	1483	10000000	21515	10527	20	0	\N
331714	1118	909471465000000	21515	10527	21	0	\N
331715	1140	910615465000000	21515	10527	22	0	\N
331716	2288	0	21515	10527	23	0	\N
331717	1137	909961465000000	21515	10527	24	0	\N
331718	1257	613969750000000	21515	10527	25	0	\N
331719	1017	507794775000000	21515	10527	26	0	\N
331720	1289	1708728477751650	21515	10527	27	0	\N
331721	1043	908817755000000	21515	10527	28	0	\N
331722	1260	614410750000000	21515	10527	29	0	\N
331723	1277	1709780037751650	21515	10527	30	0	\N
331724	1031	909376565000000	21515	10527	31	0	\N
331725	1151	613574650000000	21515	10527	32	0	\N
331726	911	507467575000000	21515	10527	33	0	\N
331727	1163	613197810000000	21515	10527	34	0	\N
331728	923	507155005000000	21515	10527	35	0	\N
331729	1516	7792474350000	21515	10527	36	0	\N
331730	1238	613638750000000	21515	10527	37	0	\N
331731	998	507520775000000	21515	10527	38	0	\N
331732	1300	1710301631910020	21515	10527	39	0	\N
331733	1174	613761729502880	21515	10527	40	0	\N
331734	1054	909654073462350	21515	10527	41	0	\N
331735	934	507621887704640	21515	10527	42	0	\N
331736	1579	0	21515	10527	43	0	\N
331737	1285	1714307637751650	21515	10527	44	0	\N
331738	1039	911784465000000	21515	10527	45	0	\N
331739	1159	615200750000000	21515	10527	46	0	\N
331740	919	508811775000000	21515	10527	47	0	\N
331741	2016	2332000000000	21515	10527	48	0	\N
331742	1771	598166214766	21515	10527	49	0	\N
331743	195	66589992681547	21515	10527	50	0	\N
331744	291	66589992681547	21515	10527	51	0	\N
331745	1023	507269669126828	21515	10527	52	0	\N
331746	1143	909022900788739	21515	10527	53	0	\N
331747	1263	613335864722998	21515	10527	54	0	\N
331748	1389	1709114921835103	21515	10527	55	0	\N
331749	1579	0	21515	10527	56	0	\N
331750	1020	508158775000000	21515	10527	57	0	\N
331751	1596	1440048000000	21515	10527	58	0	\N
331752	563	83475615000000	21515	10527	59	0	\N
331753	1540	0	21515	10527	60	0	\N
331754	1874	16083000	21515	10527	61	0	\N
331755	2280	200000000	21515	10527	62	0	\N
331756	2281	200000000	21515	10527	63	0	\N
331757	2282	200000000	21515	10527	64	0	\N
331758	2282	1400000000	21515	10527	65	0	\N
331759	2283	200000000	21515	10527	66	0	\N
331760	2287	19000000000	21515	10527	67	0	\N
331761	2287	719000000000	21515	10527	68	0	\N
331762	2288	1000000000	21515	10527	69	0	\N
331763	2288	11000000000	21515	10527	70	0	\N
331764	975	506861175900000	21515	10527	71	0	\N
331765	1095	908290884420000	21515	10527	72	0	\N
331766	1215	612841958680000	21515	10527	73	0	\N
331767	1341	1707738608751650	21515	10527	74	0	\N
331768	2272	200000000	21515	10527	75	0	\N
331769	2273	200000000	21515	10527	76	0	\N
331770	2274	200000000	21515	10527	77	0	\N
331771	2275	200000000	21515	10527	78	0	\N
331772	2288	521000000000	21515	10527	79	0	\N
331773	2276	200000000	21515	10527	80	0	\N
331774	2277	200000000	21515	10527	81	0	\N
331775	2276	1400000000	21515	10527	82	0	\N
331776	2277	1400000000	21515	10527	83	0	\N
331777	2278	200000000	21515	10527	84	0	\N
331778	2279	200000000	21515	10527	85	0	\N
331779	2284	200000000	21515	10527	86	0	\N
331780	2285	200000000	21515	10527	87	0	\N
331781	1885	10000000	21515	10527	88	0	\N
331782	2286	200000000	21515	10527	89	0	\N
331783	1874	16086000	21515	10527	90	0	\N
331784	2276	2600000000	21515	10527	91	0	\N
331785	1874	16089000	21515	10527	92	0	\N
331786	1874	16092000	21515	10527	93	0	\N
331787	1874	16095000	21515	10527	94	0	\N
331788	1874	16098000	21515	10527	95	0	\N
331789	1874	16101000	21515	10527	96	0	\N
331790	1874	16104000	21515	10527	97	0	\N
331791	1874	16107000	21515	10527	98	0	\N
331792	1874	16110000	21515	10527	99	0	\N
331793	1874	16113000	21515	10527	100	0	\N
331794	1874	16116000	21515	10527	101	0	\N
331795	1874	16119000	21515	10527	102	0	\N
331796	1874	16122000	21515	10527	103	0	\N
331797	1874	16125000	21515	10527	104	0	\N
331798	1874	16128000	21515	10527	105	0	\N
331799	1874	16131000	21515	10527	106	0	\N
331800	1874	16134000	21515	10527	107	0	\N
331801	1874	16137000	21515	10527	109	0	\N
331802	1874	16140000	21515	10527	110	0	\N
331803	1874	16143000	21515	10527	111	0	\N
331804	1874	16146000	21515	10527	112	0	\N
331805	1874	16149000	21515	10527	113	0	\N
331806	1874	16152000	21515	10527	114	0	\N
331807	1874	16155000	21515	10527	115	0	\N
331808	1874	16158000	21515	10527	116	0	\N
331809	1874	16161000	21515	10527	117	0	\N
331810	1874	16164000	21515	10527	118	0	\N
331811	1874	16167000	21515	10527	119	0	\N
331812	1874	16170000	21515	10527	120	0	\N
331813	1874	16173000	21515	10527	121	0	\N
331814	1874	16176000	21515	10527	122	0	\N
331815	1874	16179000	21515	10527	123	0	\N
331816	1874	16182000	21515	10527	124	0	\N
331817	1874	16185000	21515	10527	125	0	\N
331821	1678	23040757813000	21517	10795	0	0	\N
331822	1874	17337000	21517	10795	1	0	\N
331823	1874	17340000	21517	10795	2	0	\N
331824	957	508158775000000	21518	10517	0	0	\N
331825	1197	614409750000000	21518	10517	1	0	\N
331826	1077	910614465000000	21518	10517	2	0	\N
331827	1323	1712107637751650	21518	10517	3	0	\N
331828	683	66339585999999	21518	10517	4	0	\N
331829	683	66626585999999	21518	10517	5	0	\N
331830	1012	506425775000000	21518	10517	6	0	\N
331831	1252	612316750000000	21518	10517	7	0	\N
331832	1132	907510465000000	21518	10517	8	0	\N
331833	1378	1706269637751650	21518	10517	9	0	\N
331834	1483	10000000	21518	10517	10	0	\N
331835	1483	10000000	21518	10517	11	0	\N
331836	2288	0	21518	10517	12	0	\N
331837	1579	0	21518	10517	13	0	\N
331838	1678	23040757501000	21518	10517	14	0	\N
331839	1678	23040757502000	21518	10517	15	0	\N
331840	1678	23040757503000	21518	10517	16	0	\N
331820	1874	17335000	21516	10794	2	0	2
331841	1678	23040757504000	21518	10517	17	0	\N
331842	1771	598166214766	21518	10517	18	0	\N
331843	195	66589992681547	21518	10517	19	0	\N
331844	291	66589992681547	21518	10517	20	0	\N
331845	1023	507269669126828	21518	10517	21	0	\N
331846	1143	909022900788739	21518	10517	22	0	\N
331847	1263	613335864722998	21518	10517	23	0	\N
331848	1389	1709114921835103	21518	10517	24	0	\N
331849	1579	0	21518	10517	25	0	\N
331850	1678	23040757505000	21518	10517	26	0	\N
331851	1678	23040757506000	21518	10517	27	0	\N
331852	1678	23040757507000	21518	10517	28	0	\N
331853	1678	23040757508000	21518	10517	29	0	\N
331854	1678	23040757509000	21518	10517	30	0	\N
331855	1678	23040757510000	21518	10517	31	0	\N
331856	1678	23040757511000	21518	10517	32	0	\N
331857	1678	23040757512000	21518	10517	33	0	\N
331858	1678	23040757513000	21518	10517	34	0	\N
331859	1678	23040757514000	21518	10517	35	0	\N
331860	1678	23040757515000	21518	10517	36	0	\N
331861	1678	23040757516000	21518	10517	37	0	\N
331862	1678	23040757517000	21518	10517	38	0	\N
331863	1678	23040757518000	21518	10517	39	0	\N
331864	1678	23040757519000	21518	10517	40	0	\N
331865	1678	23040757520000	21518	10517	41	0	\N
331866	1678	23040757521000	21518	10517	42	0	\N
331867	1678	23040757522000	21518	10517	43	0	\N
331868	1678	23040757523000	21518	10517	44	0	\N
331869	1678	23040757524000	21518	10517	45	0	\N
331870	1678	23040757525000	21518	10517	47	0	\N
331871	1678	23040757526000	21518	10517	48	0	\N
331872	1678	23040757527000	21518	10517	49	0	\N
331873	1678	23040757528000	21518	10517	50	0	\N
331874	1678	23040757529000	21518	10517	51	0	\N
331875	1678	23040757530000	21518	10517	52	0	\N
331876	1678	23040757531000	21518	10517	53	0	\N
331877	1678	23040757532000	21518	10517	54	0	\N
331878	1678	23040757533000	21518	10517	55	0	\N
331879	1678	23040757534000	21518	10517	56	0	\N
331880	1678	23040757535000	21518	10517	57	0	\N
331881	1678	23040757536000	21518	10517	58	0	\N
331882	1678	23040757537000	21518	10517	59	0	\N
331883	1678	23040757538000	21518	10517	60	0	\N
331884	1678	23040757539000	21518	10517	61	0	\N
331885	1678	23040757540000	21518	10517	62	0	\N
331886	1678	23040757541000	21518	10517	63	0	\N
331887	1678	23040757542000	21518	10517	64	0	\N
331888	1678	23040757543000	21518	10517	65	0	\N
331889	1678	23040757544000	21518	10517	66	0	\N
331890	1678	23040757545000	21518	10517	67	0	\N
331891	1678	23040757546000	21518	10517	68	0	\N
331892	1678	23040757547000	21518	10517	69	0	\N
331893	1678	23040757548000	21518	10517	70	0	\N
331894	1678	23040757549000	21518	10517	71	0	\N
331895	1678	23040757550000	21518	10517	72	0	\N
331896	1678	23040757551000	21518	10517	73	0	\N
331897	1678	23040757552000	21518	10517	74	0	\N
331898	1678	23040757553000	21518	10517	75	0	\N
331899	1678	23040757554000	21518	10517	76	0	\N
331900	1678	23040757555000	21518	10517	77	0	\N
331901	1678	23040757556000	21518	10517	78	0	\N
331902	1678	23040757557000	21518	10517	79	0	\N
331903	1678	23040757558000	21518	10517	80	0	\N
331904	1678	23040757559000	21518	10517	81	0	\N
331905	1678	23040757560000	21518	10517	82	0	\N
331906	1678	23040757561000	21518	10517	83	0	\N
331907	1678	23040757562000	21518	10517	84	0	\N
331908	1678	23040757563000	21518	10517	85	0	\N
331909	1678	23040757564000	21518	10517	86	0	\N
331910	1678	23040757565000	21518	10517	87	0	\N
331911	1678	23040757566000	21518	10517	88	0	\N
331912	1678	23040757567000	21518	10517	89	0	\N
331913	1678	23040757568000	21518	10517	90	0	\N
331914	1678	23040757569000	21518	10517	91	0	\N
331915	1678	23040757570000	21518	10517	92	0	\N
331916	1678	23040757571000	21518	10517	93	0	\N
331917	1678	23040757572000	21518	10517	94	0	\N
331918	1678	23040757573000	21518	10517	95	0	\N
331919	1678	23040757574000	21518	10517	96	0	\N
331920	1678	23040757575000	21518	10517	97	0	\N
331921	1678	23040757576000	21518	10517	98	0	\N
331922	1678	23040757577000	21518	10517	99	0	\N
331923	1678	23040757578000	21518	10517	100	0	\N
331924	1678	23040757579000	21518	10517	101	0	\N
331925	1678	23040757580000	21518	10517	102	0	\N
331926	1678	23040757581000	21518	10517	103	0	\N
331927	1678	23040757582000	21518	10517	104	0	\N
331928	1678	23040757583000	21518	10517	105	0	\N
331929	1678	23040757584000	21518	10517	106	0	\N
331930	1678	23040757585000	21518	10517	107	0	\N
331931	1678	23040757586000	21518	10517	108	0	\N
331932	1678	23040757587000	21518	10517	109	0	\N
331933	1678	23040757588000	21518	10517	110	0	\N
331934	1678	23040757589000	21518	10517	111	0	\N
331935	1678	23040757590000	21518	10517	112	0	\N
331936	1678	23040757591000	21518	10517	113	0	\N
331937	1678	23040757592000	21518	10517	114	0	\N
331938	1678	23040757593000	21518	10517	115	0	\N
331939	1678	23040757594000	21518	10517	116	0	\N
331940	1678	23040757595000	21518	10517	117	0	\N
331941	1678	23040757596000	21518	10517	118	0	\N
331942	1678	23040757597000	21518	10517	119	0	\N
331943	1678	23040757598000	21518	10517	120	0	\N
331944	1678	23040757599000	21518	10517	121	0	\N
331945	1678	23040757600000	21518	10517	122	0	\N
331946	1678	23040757601000	21518	10517	123	0	\N
331947	1678	23040757602000	21518	10517	124	0	\N
331948	1678	23040757603000	21518	10517	125	0	\N
331956	1678	23040757815000	21521	10797	0	0	\N
331957	1874	17348000	21521	10797	1	0	\N
331958	1874	17351000	21521	10797	2	0	\N
331962	1678	23040757815000	21523	10797	0	0	\N
331963	1874	17349000	21523	10797	1	0	\N
331964	1678	23040757815000	21524	10797	0	0	\N
331965	1874	17348000	21524	10797	1	0	\N
331966	1874	17351000	21524	10797	2	0	\N
331970	1483	10000000	21526	10704	0	0	\N
331951	1874	17340000	21519	10795	2	0	2
331952	1678	23040757814000	21520	10796	0	0	0
331953	1874	17342000	21520	10796	1	0	2
331954	1874	17345000	21520	10796	2	0	2
331955	1874	17346000	21520	10796	3	0	2
331960	1874	17348000	21522	10797	1	0	2
331961	1874	17351000	21522	10797	2	0	2
331967	1678	23040757816000	21525	10798	0	0	0
331968	1874	17354000	21525	10798	1	0	2
331969	1874	17356000	21525	10798	2	0	2
331972	1678	23040757818000	21527	10799	1	0	0
331973	1874	17359000	21527	10799	2	0	2
331974	1874	17362000	21527	10799	3	0	2
331975	1874	17364000	21527	10799	4	0	2
331977	1678	23040757819000	21528	10800	0	0	\N
331978	1874	17369000	21528	10800	1	0	\N
331979	1678	23040757819000	21529	10800	0	0	\N
331980	1874	17369000	21529	10800	1	0	\N
331981	1874	17371000	21529	10800	2	0	\N
331985	1678	23040757820000	21532	10801	0	0	\N
331986	1874	17374000	21532	10801	1	0	\N
331987	1874	17376000	21532	10801	2	0	\N
331988	1678	23040757820000	21533	10801	0	0	\N
331989	1874	17374000	21533	10801	1	0	\N
331990	1874	17376000	21533	10801	2	0	\N
331994	1678	23040757820000	21535	10801	0	0	\N
331995	1874	17374000	21535	10801	1	0	\N
331996	1874	17376000	21535	10801	2	0	\N
331997	1678	23040757820000	21536	10801	0	0	\N
331998	1874	17374000	21536	10801	1	0	\N
331999	1874	17376000	21536	10801	2	0	\N
332000	1678	23040757821000	21537	10802	0	0	\N
332001	1874	17379000	21537	10802	1	0	\N
332002	1874	17381000	21537	10802	2	0	\N
332003	1483	10000000	21538	10774	0	0	\N
332007	1678	23040757821000	21540	10802	0	0	\N
332008	1874	17378000	21540	10802	1	0	\N
332009	957	508158775000000	21541	10622	0	0	\N
332010	1197	614409750000000	21541	10622	1	0	\N
332011	1077	910614465000000	21541	10622	2	0	\N
332012	1323	1712107637751650	21541	10622	3	0	\N
332013	683	66339585999999	21541	10622	4	0	\N
332014	683	66626585999999	21541	10622	5	0	\N
332015	1012	506425775000000	21541	10622	6	0	\N
332016	1252	612316750000000	21541	10622	7	0	\N
332017	1132	907510465000000	21541	10622	8	0	\N
332018	1378	1706269637751650	21541	10622	9	0	\N
332019	1364	1709956637751650	21541	10622	10	0	\N
332020	923	507155015000000	21541	10622	11	0	\N
332021	1678	23040757566000	21541	10622	12	0	\N
332022	1386	1712107637751650	21541	10622	13	0	\N
332023	1483	10000000	21541	10622	14	0	\N
332024	1383	1710879637751650	21541	10622	15	0	\N
332025	1483	10000000	21541	10622	16	0	\N
332026	1118	909471465000000	21541	10622	17	0	\N
332027	1140	910615465000000	21541	10622	18	0	\N
332028	2288	0	21541	10622	19	0	\N
332029	1137	909961465000000	21541	10622	20	0	\N
332030	1257	613969750000000	21541	10622	21	0	\N
332031	1017	507794775000000	21541	10622	22	0	\N
332032	1260	614410750000000	21541	10622	23	0	\N
332033	1238	613638750000000	21541	10622	24	0	\N
332034	998	507520775000000	21541	10622	25	0	\N
332035	1579	0	21541	10622	26	0	\N
332036	1771	598166214766	21541	10622	27	0	\N
332037	195	66589992681547	21541	10622	28	0	\N
332038	291	66589992681547	21541	10622	29	0	\N
332039	1023	507269669126828	21541	10622	30	0	\N
332040	1143	909022900788739	21541	10622	31	0	\N
332041	1263	613335864722998	21541	10622	32	0	\N
332042	1389	1709114921835103	21541	10622	33	0	\N
332043	1579	0	21541	10622	34	0	\N
332044	1020	508158775000000	21541	10622	35	0	\N
332045	1596	1440048000000	21541	10622	36	0	\N
332046	563	83475615000000	21541	10622	37	0	\N
332047	1874	16372000	21541	10622	38	0	\N
332048	1540	0	21541	10622	39	0	\N
332049	1874	16373000	21541	10622	40	0	\N
332050	1540	0	21541	10622	41	0	\N
332051	1874	16376000	21541	10622	42	0	\N
332052	2280	200000000	21541	10622	43	0	\N
332053	2281	200000000	21541	10622	44	0	\N
332054	2282	200000000	21541	10622	45	0	\N
332055	2282	1400000000	21541	10622	46	0	\N
332056	2283	200000000	21541	10622	47	0	\N
332057	2287	19000000000	21541	10622	48	0	\N
332058	2287	719000000000	21541	10622	49	0	\N
332059	2288	1000000000	21541	10622	50	0	\N
332060	1874	16377000	21541	10622	51	0	\N
332061	1874	16378000	21541	10622	52	0	\N
332062	1874	16379000	21541	10622	53	0	\N
332063	1874	16380000	21541	10622	54	0	\N
332064	1874	16381000	21541	10622	55	0	\N
332065	1874	16382000	21541	10622	56	0	\N
332066	2288	11000000000	21541	10622	57	0	\N
332067	975	506861175900000	21541	10622	58	0	\N
332068	1095	908290884420000	21541	10622	59	0	\N
332069	1215	612841958680000	21541	10622	60	0	\N
332070	1341	1707738608751650	21541	10622	61	0	\N
332071	2272	200000000	21541	10622	62	0	\N
332072	2273	200000000	21541	10622	63	0	\N
332073	2274	200000000	21541	10622	64	0	\N
332074	2275	200000000	21541	10622	65	0	\N
332075	2288	521000000000	21541	10622	66	0	\N
332076	1874	16384000	21541	10622	67	0	\N
332077	2276	200000000	21541	10622	68	0	\N
332078	2277	200000000	21541	10622	69	0	\N
332079	2276	1400000000	21541	10622	70	0	\N
332080	2277	1400000000	21541	10622	71	0	\N
332081	2278	200000000	21541	10622	72	0	\N
332082	2279	200000000	21541	10622	73	0	\N
332083	2284	200000000	21541	10622	74	0	\N
332084	2285	200000000	21541	10622	75	0	\N
332085	1874	16385000	21541	10622	76	0	\N
332086	1874	16386000	21541	10622	77	0	\N
332087	1874	16387000	21541	10622	78	0	\N
332088	1874	16388000	21541	10622	79	0	\N
332089	1874	16389000	21541	10622	80	0	\N
332090	1874	16390000	21541	10622	81	0	\N
332091	1885	10000000	21541	10622	82	0	\N
332092	2286	200000000	21541	10622	83	0	\N
332093	1874	16393000	21541	10622	84	0	\N
332094	2276	2600000000	21541	10622	85	0	\N
332095	1874	16396000	21541	10622	86	0	\N
332096	1874	16399000	21541	10622	87	0	\N
332097	1874	16402000	21541	10622	88	0	\N
332098	1874	16405000	21541	10622	89	0	\N
332099	1874	16408000	21541	10622	90	0	\N
332100	1874	16411000	21541	10622	91	0	\N
332101	1874	16414000	21541	10622	92	0	\N
332102	1874	16417000	21541	10622	93	0	\N
332103	1874	16420000	21541	10622	94	0	\N
332104	1874	16423000	21541	10622	95	0	\N
332105	1874	16426000	21541	10622	96	0	\N
332106	1874	16429000	21541	10622	97	0	\N
332107	1874	16432000	21541	10622	98	0	\N
332108	1874	16435000	21541	10622	99	0	\N
332109	1874	16438000	21541	10622	100	0	\N
332110	1874	16441000	21541	10622	101	0	\N
332111	1874	16444000	21541	10622	102	0	\N
332112	1874	16447000	21541	10622	103	0	\N
331984	1874	17371000	21530	10800	2	0	2
331991	1678	23040757820000	21534	10801	0	0	0
331992	1874	17374000	21534	10801	1	0	2
331993	1874	17376000	21534	10801	2	0	2
332004	1678	23040757821000	21539	10802	0	0	0
332006	1874	17381000	21539	10802	2	0	2
332113	1874	16450000	21541	10622	104	0	\N
332114	1874	16453000	21541	10622	105	0	\N
332115	1874	16456000	21541	10622	106	0	\N
332116	1874	16459000	21541	10622	107	0	\N
332117	1874	16462000	21541	10622	109	0	\N
332118	1874	16465000	21541	10622	110	0	\N
332119	1874	16468000	21541	10622	111	0	\N
332120	1874	16471000	21541	10622	112	0	\N
332121	1874	16474000	21541	10622	113	0	\N
332122	1874	16477000	21541	10622	114	0	\N
332123	1874	16480000	21541	10622	115	0	\N
332124	1874	16483000	21541	10622	116	0	\N
332125	1874	16486000	21541	10622	117	0	\N
332126	1874	16489000	21541	10622	118	0	\N
332127	1874	16492000	21541	10622	119	0	\N
332128	1874	16495000	21541	10622	120	0	\N
332129	1874	16498000	21541	10622	121	0	\N
332130	1874	16501000	21541	10622	122	0	\N
332131	1874	16504000	21541	10622	123	0	\N
332132	1874	16507000	21541	10622	124	0	\N
332133	1874	16510000	21541	10622	125	0	\N
332134	1678	23040757822000	21542	10803	0	0	\N
332135	1678	23040757823000	21542	10803	1	0	\N
332136	1678	23040757824000	21542	10803	2	0	\N
332137	1874	17381000	21542	10803	3	0	\N
332138	1874	17383000	21542	10803	4	0	\N
332139	1874	17385000	21542	10803	5	0	\N
332140	1874	17387000	21542	10803	6	0	\N
332141	1874	17390000	21542	10803	7	0	\N
332142	1874	17393000	21542	10803	8	0	\N
332143	1874	17396000	21542	10803	9	0	\N
332144	1874	17381000	21543	10803	0	0	\N
332145	1874	17383000	21543	10803	1	0	\N
332146	1874	17385000	21543	10803	2	0	\N
332147	1874	17387000	21543	10803	3	0	\N
332148	1874	17390000	21543	10803	4	0	\N
332149	1874	17393000	21543	10803	5	0	\N
332150	1874	17396000	21543	10803	6	0	\N
332163	1678	23040757822000	21546	10804	0	0	\N
332164	1678	23040757823000	21546	10804	1	0	\N
332165	1678	23040757824000	21546	10804	2	0	\N
332166	1678	23040757825000	21548	10804	0	0	\N
332167	1874	17398000	21548	10804	1	0	\N
332175	1874	17415000	21552	10807	0	0	\N
332176	1874	17418000	21552	10807	1	0	\N
332177	1874	17415000	21553	10807	0	0	\N
332178	1874	17418000	21553	10807	1	0	\N
332179	683	66339585999999	21554	10725	0	0	\N
332180	683	66626585999999	21554	10725	1	0	\N
332181	1012	506425775000000	21554	10725	2	0	\N
332182	1252	612316750000000	21554	10725	3	0	\N
332183	1132	907510465000000	21554	10725	4	0	\N
332184	1378	1706269637751650	21554	10725	5	0	\N
332185	1678	23040757717000	21554	10725	6	0	\N
332186	1678	23040757718000	21554	10725	7	0	\N
332187	1483	10000000	21554	10725	8	0	\N
332188	1483	10000000	21554	10725	9	0	\N
332189	2288	0	21554	10725	10	0	\N
332190	1678	23040757719000	21554	10725	11	0	\N
332191	1678	23040757720000	21554	10725	12	0	\N
332192	1678	23040757721000	21554	10725	13	0	\N
332193	1678	23040757722000	21554	10725	14	0	\N
332194	1678	23040757723000	21554	10725	15	0	\N
332195	1678	23040757724000	21554	10725	16	0	\N
332196	1678	23040757725000	21554	10725	17	0	\N
332197	1678	23040757726000	21554	10725	18	0	\N
332198	1678	23040757727000	21554	10725	19	0	\N
332199	1678	23040757728000	21554	10725	20	0	\N
332200	1678	23040757729000	21554	10725	21	0	\N
332201	1579	0	21554	10725	22	0	\N
332202	1678	23040757730000	21554	10725	23	0	\N
332203	1678	23040757731000	21554	10725	24	0	\N
332204	1678	23040757732000	21554	10725	25	0	\N
332205	1678	23040757733000	21554	10725	26	0	\N
332206	1678	23040757734000	21554	10725	27	0	\N
332207	1771	598166214766	21554	10725	28	0	\N
332208	195	66589992681547	21554	10725	29	0	\N
332209	291	66589992681547	21554	10725	30	0	\N
332210	1023	507269669126828	21554	10725	31	0	\N
332211	1143	909022900788739	21554	10725	32	0	\N
332212	1263	613335864722998	21554	10725	33	0	\N
332213	1389	1709114921835103	21554	10725	34	0	\N
332214	1579	0	21554	10725	35	0	\N
332215	1678	23040757735000	21554	10725	36	0	\N
332216	1678	23040757736000	21554	10725	37	0	\N
332217	1678	23040757737000	21554	10725	38	0	\N
332218	1678	23040757738000	21554	10725	39	0	\N
332219	1678	23040757739000	21554	10725	40	0	\N
332220	1678	23040757740000	21554	10725	41	0	\N
332221	1678	23040757741000	21554	10725	42	0	\N
332222	1678	23040757742000	21554	10725	43	0	\N
332223	1678	23040757743000	21554	10725	44	0	\N
332224	1678	23040757744000	21554	10725	45	0	\N
332225	1678	23040757745000	21554	10725	46	0	\N
332226	1678	23040757746000	21554	10725	47	0	\N
332227	1678	23040757747000	21554	10725	48	0	\N
332228	1678	23040757748000	21554	10725	49	0	\N
332229	1678	23040757749000	21554	10725	50	0	\N
332230	1678	23040757750000	21554	10725	51	0	\N
332231	1678	23040757751000	21554	10725	52	0	\N
332232	1678	23040757752000	21554	10725	53	0	\N
332233	1678	23040757753000	21554	10725	54	0	\N
332234	1678	23040757754000	21554	10725	55	0	\N
332235	1678	23040757755000	21554	10725	56	0	\N
332236	1678	23040757756000	21554	10725	57	0	\N
332237	1678	23040757757000	21554	10725	58	0	\N
332238	1678	23040757758000	21554	10725	59	0	\N
332239	1678	23040757759000	21554	10725	60	0	\N
332240	1678	23040757760000	21554	10725	61	0	\N
332241	1678	23040757761000	21554	10725	62	0	\N
332242	1678	23040757762000	21554	10725	63	0	\N
332243	1678	23040757763000	21554	10725	64	0	\N
332244	1678	23040757764000	21554	10725	65	0	\N
332245	1678	23040757765000	21554	10725	66	0	\N
332246	1678	23040757766000	21554	10725	67	0	\N
332247	1678	23040757767000	21554	10725	68	0	\N
332248	1678	23040757768000	21554	10725	69	0	\N
332153	1678	23040757824000	21544	10803	2	0	0
332154	1874	17383000	21544	10803	3	0	2
332155	1874	17385000	21544	10803	4	0	2
332156	1874	17387000	21544	10803	5	0	2
332157	1874	17390000	21544	10803	6	0	2
332159	1874	17396000	21544	10803	8	0	2
332160	1678	23040757825000	21545	10804	0	0	0
332161	1874	17399000	21545	10804	1	0	2
332162	1874	17401000	21545	10804	2	0	2
332168	1874	17403000	21549	10805	0	0	2
332170	1874	17408000	21550	10806	0	0	2
332171	1874	17410000	21550	10806	1	0	2
332172	1874	17413000	21550	10806	2	0	2
332173	1874	17415000	21551	10807	0	0	2
332249	1678	23040757769000	21554	10725	70	0	\N
332250	1678	23040757770000	21554	10725	71	0	\N
332251	1678	23040757771000	21554	10725	72	0	\N
332252	1678	23040757772000	21554	10725	73	0	\N
332253	1678	23040757773000	21554	10725	74	0	\N
332254	1678	23040757774000	21554	10725	75	0	\N
332255	1678	23040757775000	21554	10725	76	0	\N
332256	1678	23040757776000	21554	10725	77	0	\N
332257	1678	23040757777000	21554	10725	78	0	\N
332258	1678	23040757778000	21554	10725	79	0	\N
332259	1678	23040757779000	21554	10725	80	0	\N
332260	1678	23040757780000	21554	10725	81	0	\N
332261	1678	23040757781000	21554	10725	82	0	\N
332262	1678	23040757782000	21554	10725	83	0	\N
332263	1678	23040757783000	21554	10725	84	0	\N
332264	1678	23040757784000	21554	10725	85	0	\N
332265	1678	23040757785000	21554	10725	86	0	\N
332266	1678	23040757786000	21554	10725	87	0	\N
332267	1678	23040757787000	21554	10725	88	0	\N
332268	1678	23040757788000	21554	10725	89	0	\N
332269	1678	23040757789000	21554	10725	90	0	\N
332270	1678	23040757790000	21554	10725	91	0	\N
332271	1678	23040757791000	21554	10725	92	0	\N
332272	1678	23040757792000	21554	10725	93	0	\N
332273	1678	23040757793000	21554	10725	94	0	\N
332274	1678	23040757794000	21554	10725	95	0	\N
332275	1678	23040757795000	21554	10725	96	0	\N
332276	1678	23040757796000	21554	10725	97	0	\N
332277	1678	23040757797000	21554	10725	98	0	\N
332278	1678	23040757798000	21554	10725	99	0	\N
332279	1678	23040757799000	21554	10725	100	0	\N
332280	1678	23040757800000	21554	10725	101	0	\N
332281	1678	23040757801000	21554	10725	102	0	\N
332282	1678	23040757802000	21554	10725	103	0	\N
332283	1678	23040757803000	21554	10725	104	0	\N
332284	1678	23040757804000	21554	10725	105	0	\N
332285	1678	23040757805000	21554	10725	106	0	\N
332286	1678	23040757806000	21554	10725	107	0	\N
332287	1678	23040757807000	21554	10725	108	0	\N
332288	1678	23040757808000	21554	10725	110	0	\N
332289	1678	23040757809000	21554	10725	111	0	\N
332290	1678	23040757810000	21554	10725	112	0	\N
332291	1678	23040757811000	21554	10725	113	0	\N
332292	1678	23040757812000	21554	10725	114	0	\N
332293	1678	23040757813000	21554	10725	115	0	\N
332294	1678	23040757814000	21554	10725	116	0	\N
332295	1678	23040757815000	21554	10725	117	0	\N
332296	1678	23040757816000	21554	10725	118	0	\N
332297	1678	23040757817000	21554	10725	119	0	\N
332298	1678	23040757818000	21554	10725	120	0	\N
332299	1678	23040757819000	21554	10725	121	0	\N
332300	1678	23040757820000	21554	10725	122	0	\N
332301	1678	23040757821000	21554	10725	123	0	\N
332302	1678	23040757822000	21554	10725	124	0	\N
332303	1678	23040757823000	21554	10725	125	0	\N
332307	1678	23040757827000	21556	10809	0	0	\N
332308	1874	17426000	21556	10809	1	0	\N
332309	1874	17428000	21556	10809	2	0	\N
332316	1678	23040757828000	21559	10810	0	0	\N
332317	1874	17430000	21559	10810	1	0	\N
332318	1874	17433000	21559	10810	2	0	\N
332322	1678	23040757830000	21561	10812	0	0	\N
332323	1874	17441000	21561	10812	1	0	\N
332324	1874	17443000	21561	10812	2	0	\N
332325	1678	23040757830000	21562	10812	0	0	\N
332326	1874	17441000	21562	10812	1	0	\N
332327	1874	17443000	21562	10812	2	0	\N
332334	1678	23040757831000	21565	10813	0	0	\N
332335	1874	17443000	21565	10813	1	0	\N
332336	1874	17445000	21565	10813	2	0	\N
332337	1874	17448000	21565	10813	3	0	\N
332338	1678	23040757831000	21566	10813	0	0	\N
332339	1874	17443000	21566	10813	1	0	\N
332340	1874	17445000	21566	10813	2	0	\N
332341	1874	17448000	21566	10813	3	0	\N
332344	1678	23040757832000	21568	10814	0	0	\N
332345	1874	17451000	21568	10814	1	0	\N
332346	1874	17453000	21568	10814	2	0	\N
332347	1678	23040757832000	21569	10814	0	0	\N
332348	1874	17451000	21569	10814	1	0	\N
332349	1874	17453000	21569	10814	2	0	\N
332350	1678	23040757832000	21570	10814	0	0	\N
332351	1874	17451000	21570	10814	1	0	\N
332352	1874	17453000	21570	10814	2	0	\N
332353	1874	17451000	21571	10814	0	0	\N
332354	1874	17453000	21571	10814	1	0	\N
332362	1678	23040757832000	21574	10814	0	0	\N
332363	1678	23040757833000	21574	10814	1	0	\N
332364	1874	17451000	21574	10814	2	0	\N
332365	1874	17454000	21574	10814	3	0	\N
332366	1874	17456000	21574	10814	4	0	\N
332367	1874	17458000	21574	10814	5	0	\N
332371	1678	23040757835000	21576	10817	0	0	\N
332372	1874	17466000	21576	10817	1	0	\N
332373	1874	17468000	21576	10817	2	0	\N
332374	1678	23040757835000	21577	10817	0	0	\N
332375	1874	17466000	21577	10817	1	0	\N
332376	1874	17468000	21577	10817	2	0	\N
332378	1678	23040757836000	21579	10818	0	0	\N
332379	1874	17471000	21579	10818	1	0	\N
332380	1874	17473000	21579	10818	2	0	\N
332381	1678	23040757834000	21580	10815	0	0	\N
332382	1678	23040757835000	21580	10815	1	0	\N
332383	1874	17460000	21580	10815	2	0	\N
332384	1874	17463000	21580	10815	3	0	\N
332306	1874	17423000	21555	10808	2	0	2
332310	1678	23040757827000	21557	10809	0	0	0
332311	1874	17426000	21557	10809	1	0	2
332312	1874	17428000	21557	10809	2	0	2
332313	1678	23040757828000	21558	10810	0	0	0
332315	1874	17433000	21558	10810	2	0	2
332319	1678	23040757829000	21560	10811	0	0	0
332320	1874	17435000	21560	10811	1	0	2
332321	1874	17438000	21560	10811	2	0	2
332328	1678	23040757830000	21563	10812	0	0	0
332330	1678	23040757831000	21564	10813	0	0	0
332331	1874	17443000	21564	10813	1	0	2
332332	1874	17445000	21564	10813	2	0	2
332333	1874	17448000	21564	10813	3	0	2
332343	1874	17451000	21567	10814	1	0	2
332355	1678	23040757833000	21572	10815	0	0	0
332356	1874	17454000	21572	10815	1	0	2
332357	1874	17456000	21572	10815	2	0	2
332358	1874	17458000	21572	10815	3	0	2
332360	1874	17460000	21573	10816	1	0	2
332361	1874	17463000	21573	10816	2	0	2
332368	1678	23040757835000	21575	10817	0	0	0
332369	1874	17466000	21575	10817	1	0	2
332370	1874	17468000	21575	10817	2	0	2
332385	1874	17466000	21580	10815	4	0	\N
332386	1874	17468000	21580	10815	5	0	\N
332387	1874	17471000	21580	10815	6	0	\N
332388	1874	17473000	21580	10815	7	0	\N
332390	1678	23760767838000	21582	10820	0	0	\N
332391	1678	23760767839000	21582	10820	1	0	\N
332392	1874	17471000	21582	10820	2	0	\N
332393	1406	0	21582	10820	3	0	\N
332394	1874	17474000	21582	10820	4	0	\N
332395	1874	17477000	21582	10820	5	0	\N
332396	1874	17480000	21582	10820	6	0	\N
332397	1874	17482000	21582	10820	7	0	\N
332398	1874	17484000	21582	10820	8	0	\N
332399	1874	17486000	21582	10820	9	0	\N
332400	1874	17488000	21582	10820	10	0	\N
332415	1678	23760767840000	21585	10821	0	0	\N
332416	1874	17490000	21585	10821	1	0	\N
332417	1874	17493000	21585	10821	2	0	\N
332421	1678	23760767842000	21587	10823	0	0	\N
332422	1874	17500000	21587	10823	1	0	\N
332423	1874	17503000	21587	10823	2	0	\N
332427	1678	23760767842000	21589	10823	0	0	\N
332428	1874	17500000	21589	10823	1	0	\N
332429	1874	17503000	21589	10823	2	0	\N
332437	957	508158775000000	21591	10574	0	0	\N
332438	1197	614409750000000	21591	10574	1	0	\N
332439	1077	910614465000000	21591	10574	2	0	\N
332440	1323	1712107637751650	21591	10574	3	0	\N
332441	683	66339585999999	21591	10574	4	0	\N
332442	683	66626585999999	21591	10574	5	0	\N
332443	1012	506425775000000	21591	10574	6	0	\N
332444	1252	612316750000000	21591	10574	7	0	\N
332445	1132	907510465000000	21591	10574	8	0	\N
332446	1378	1706269637751650	21591	10574	9	0	\N
332447	1483	10000000	21591	10574	10	0	\N
332448	1483	10000000	21591	10574	11	0	\N
332449	2288	0	21591	10574	12	0	\N
332450	1579	0	21591	10574	13	0	\N
332451	1771	598166214766	21591	10574	14	0	\N
332452	195	66589992681547	21591	10574	15	0	\N
332453	291	66589992681547	21591	10574	16	0	\N
332454	1023	507269669126828	21591	10574	17	0	\N
332455	1143	909022900788739	21591	10574	18	0	\N
332456	1263	613335864722998	21591	10574	19	0	\N
332457	1389	1709114921835103	21591	10574	20	0	\N
332458	1579	0	21591	10574	21	0	\N
332459	1678	23040757606000	21591	10574	22	0	\N
332460	1678	23040757607000	21591	10574	23	0	\N
332461	1678	23040757608000	21591	10574	24	0	\N
332462	1678	23040757609000	21591	10574	25	0	\N
332463	1678	23040757610000	21591	10574	26	0	\N
332464	1678	23040757611000	21591	10574	27	0	\N
332465	1678	23040757612000	21591	10574	28	0	\N
332466	1678	23040757613000	21591	10574	29	0	\N
332467	1678	23040757614000	21591	10574	30	0	\N
332468	1678	23040757615000	21591	10574	31	0	\N
332469	1678	23040757616000	21591	10574	32	0	\N
332470	1678	23040757617000	21591	10574	33	0	\N
332471	1678	23040757618000	21591	10574	34	0	\N
332472	1678	23040757619000	21591	10574	35	0	\N
332473	1678	23040757620000	21591	10574	36	0	\N
332474	1678	23040757621000	21591	10574	37	0	\N
332475	1678	23040757622000	21591	10574	38	0	\N
332476	1678	23040757623000	21591	10574	39	0	\N
332477	1678	23040757624000	21591	10574	40	0	\N
332478	1678	23040757625000	21591	10574	41	0	\N
332479	1678	23040757626000	21591	10574	42	0	\N
332480	1678	23040757627000	21591	10574	43	0	\N
332481	1678	23040757628000	21591	10574	44	0	\N
332482	1678	23040757629000	21591	10574	45	0	\N
332483	1678	23040757630000	21591	10574	46	0	\N
332484	1678	23040757631000	21591	10574	47	0	\N
332485	1678	23040757632000	21591	10574	48	0	\N
332486	1678	23040757633000	21591	10574	49	0	\N
332487	1678	23040757634000	21591	10574	50	0	\N
332488	1678	23040757635000	21591	10574	51	0	\N
332489	1678	23040757636000	21591	10574	52	0	\N
332490	1678	23040757637000	21591	10574	53	0	\N
332491	1678	23040757638000	21591	10574	54	0	\N
332492	1678	23040757639000	21591	10574	55	0	\N
332493	1678	23040757640000	21591	10574	56	0	\N
332494	1678	23040757641000	21591	10574	57	0	\N
332495	1678	23040757642000	21591	10574	58	0	\N
332496	1678	23040757643000	21591	10574	59	0	\N
332497	1678	23040757644000	21591	10574	60	0	\N
332498	1678	23040757645000	21591	10574	61	0	\N
332499	1678	23040757646000	21591	10574	62	0	\N
332500	1678	23040757647000	21591	10574	63	0	\N
332501	1678	23040757648000	21591	10574	64	0	\N
332502	1678	23040757649000	21591	10574	65	0	\N
332503	1678	23040757650000	21591	10574	66	0	\N
332504	1678	23040757651000	21591	10574	67	0	\N
332505	1678	23040757652000	21591	10574	68	0	\N
332506	1678	23040757653000	21591	10574	69	0	\N
332507	1678	23040757654000	21591	10574	70	0	\N
332508	1678	23040757655000	21591	10574	71	0	\N
332509	1678	23040757656000	21591	10574	72	0	\N
332510	1678	23040757657000	21591	10574	73	0	\N
332511	1678	23040757658000	21591	10574	74	0	\N
332512	1678	23040757659000	21591	10574	75	0	\N
332513	1678	23040757660000	21591	10574	76	0	\N
332514	1678	23040757661000	21591	10574	77	0	\N
332515	1678	23040757662000	21591	10574	78	0	\N
332516	1678	23040757663000	21591	10574	79	0	\N
332517	1678	23040757664000	21591	10574	80	0	\N
332518	1678	23040757665000	21591	10574	81	0	\N
332519	1678	23040757666000	21591	10574	82	0	\N
332520	1678	23040757667000	21591	10574	83	0	\N
332402	1678	23760767839000	21583	10820	1	0	0
332403	1874	17471000	21583	10820	2	0	2
332404	1406	0	21583	10820	3	0	0
332405	1874	17474000	21583	10820	4	0	2
332406	1874	17477000	21583	10820	5	0	2
332408	1874	17482000	21583	10820	7	0	2
332409	1874	17484000	21583	10820	8	0	2
332410	1874	17486000	21583	10820	9	0	2
332411	1874	17488000	21583	10820	10	0	2
332412	1678	23760767840000	21584	10821	0	0	0
332414	1874	17493000	21584	10821	2	0	2
332418	1678	23760767841000	21586	10822	0	0	0
332419	1874	17495000	21586	10822	1	0	2
332420	1874	17498000	21586	10822	2	0	2
332425	1874	17500000	21588	10823	1	0	2
332426	1874	17503000	21588	10823	2	0	2
332430	1678	23760767843000	21590	10824	0	0	0
332431	1678	23760767844000	21590	10824	1	0	0
332432	1874	17506000	21590	10824	2	0	2
332434	1874	17511000	21590	10824	5	0	2
332435	1874	17513000	21590	10824	6	0	2
332436	1483	10000000	21590	10824	7	0	0
332521	1678	23040757668000	21591	10574	84	0	\N
332522	1678	23040757669000	21591	10574	85	0	\N
332523	1678	23040757670000	21591	10574	86	0	\N
332524	1678	23040757671000	21591	10574	87	0	\N
332525	1678	23040757672000	21591	10574	88	0	\N
332526	1678	23040757673000	21591	10574	89	0	\N
332527	1678	23040757674000	21591	10574	90	0	\N
332528	1678	23040757675000	21591	10574	91	0	\N
332529	1678	23040757676000	21591	10574	92	0	\N
332530	1678	23040757677000	21591	10574	93	0	\N
332531	1678	23040757678000	21591	10574	94	0	\N
332532	1678	23040757679000	21591	10574	95	0	\N
332533	1678	23040757680000	21591	10574	96	0	\N
332534	1678	23040757681000	21591	10574	97	0	\N
332535	1678	23040757682000	21591	10574	98	0	\N
332536	1678	23040757683000	21591	10574	99	0	\N
332537	1678	23040757684000	21591	10574	100	0	\N
332538	1678	23040757685000	21591	10574	101	0	\N
332539	1678	23040757686000	21591	10574	102	0	\N
332540	1678	23040757687000	21591	10574	103	0	\N
332541	1678	23040757688000	21591	10574	104	0	\N
332542	1678	23040757689000	21591	10574	105	0	\N
332543	1678	23040757690000	21591	10574	107	0	\N
332544	1678	23040757691000	21591	10574	108	0	\N
332545	1678	23040757692000	21591	10574	109	0	\N
332546	1678	23040757693000	21591	10574	110	0	\N
332547	1678	23040757694000	21591	10574	111	0	\N
332548	1678	23040757695000	21591	10574	112	0	\N
332549	1678	23040757696000	21591	10574	113	0	\N
332550	1678	23040757697000	21591	10574	114	0	\N
332551	1678	23040757698000	21591	10574	115	0	\N
332552	1678	23040757699000	21591	10574	116	0	\N
332553	1678	23040757700000	21591	10574	117	0	\N
332554	1678	23040757701000	21591	10574	118	0	\N
332555	1678	23040757702000	21591	10574	119	0	\N
332556	1678	23040757703000	21591	10574	120	0	\N
332557	1678	23040757704000	21591	10574	121	0	\N
332558	1678	23040757705000	21591	10574	122	0	\N
332559	1678	23040757706000	21591	10574	123	0	\N
332560	1678	23040757707000	21591	10574	124	0	\N
332561	1678	23040757708000	21591	10574	125	0	\N
332562	1678	23760767843000	21592	10824	0	0	\N
332563	1678	23760767844000	21592	10824	1	0	\N
332564	1874	17506000	21592	10824	2	0	\N
332565	1874	17509000	21592	10824	3	0	\N
332566	1874	17511000	21592	10824	5	0	\N
332567	1874	17513000	21592	10824	6	0	\N
332568	1483	10000000	21592	10824	7	0	\N
332569	1678	23760767845000	21593	10825	0	0	\N
332570	1678	23760767846000	21593	10825	1	0	\N
332571	1874	17515000	21593	10825	2	0	\N
332572	1874	17517000	21593	10825	3	0	\N
332573	1874	17520000	21593	10825	4	0	\N
332574	1874	17523000	21593	10825	5	0	\N
332575	1406	0	21594	10705	0	0	\N
332576	1483	10000000	21594	10705	1	0	\N
332583	1678	23760767845000	21596	10825	0	0	\N
332584	1678	23760767846000	21596	10825	1	0	\N
332585	1874	17515000	21596	10825	2	0	\N
332586	1874	17517000	21596	10825	3	0	\N
332587	1874	17520000	21596	10825	4	0	\N
332588	1874	17523000	21596	10825	5	0	\N
332592	1678	23760767847000	21598	10826	0	0	\N
332593	1874	17525000	21598	10826	1	0	\N
332594	1874	17528000	21598	10826	2	0	\N
332595	1678	23760767848000	21599	10827	0	0	\N
332596	1874	17531000	21599	10827	1	0	\N
332597	1874	17533000	21599	10827	2	0	\N
332601	1678	23760767848000	21601	10827	0	0	\N
332602	1874	17531000	21601	10827	1	0	\N
332603	1874	17533000	21601	10827	2	0	\N
332604	1678	23760767848000	21602	10827	0	0	\N
332605	1874	17531000	21602	10827	1	0	\N
332606	1874	17533000	21602	10827	2	0	\N
332607	1678	23760767849000	21603	10828	0	0	\N
332608	1874	17535000	21603	10828	1	0	\N
332609	1678	23760767849000	21604	10828	0	0	\N
332610	1874	17536000	21604	10828	1	0	\N
332611	1874	17538000	21604	10828	2	0	\N
332612	1678	23760767849000	21605	10828	0	0	\N
332613	1874	17536000	21605	10828	1	0	\N
332614	1874	17538000	21605	10828	2	0	\N
332619	1678	23760767850000	21609	10829	0	0	\N
332620	1874	17540000	21609	10829	1	0	\N
332621	1874	17543000	21609	10829	2	0	\N
332627	1678	23760767852000	21611	10831	0	0	\N
332628	1874	17551000	21611	10831	1	0	\N
332629	1874	17553000	21611	10831	2	0	\N
332633	1678	23760767853000	21613	10832	0	0	\N
332634	1874	17555000	21613	10832	1	0	\N
332635	1874	17558000	21613	10832	2	0	\N
332639	1678	23760767854000	21615	10833	0	0	\N
332640	1874	17561000	21615	10833	1	0	\N
332641	1874	17563000	21615	10833	2	0	\N
332645	1678	23760767854000	21617	10833	0	0	\N
332646	1874	17561000	21617	10833	1	0	\N
332647	1874	17563000	21617	10833	2	0	\N
332648	683	66339585999999	21618	10716	0	0	\N
332649	683	66626585999999	21618	10716	1	0	\N
332650	1012	506425775000000	21618	10716	2	0	\N
332651	1252	612316750000000	21618	10716	3	0	\N
332652	1132	907510465000000	21618	10716	4	0	\N
332653	1378	1706269637751650	21618	10716	5	0	\N
332654	1483	10000000	21618	10716	6	0	\N
332655	1483	10000000	21618	10716	7	0	\N
332656	2288	0	21618	10716	8	0	\N
332579	1874	17515000	21595	10825	2	0	2
332580	1874	17517000	21595	10825	3	0	2
332581	1874	17520000	21595	10825	4	0	2
332582	1874	17523000	21595	10825	5	0	2
332589	1678	23760767847000	21597	10826	0	0	0
332591	1874	17528000	21597	10826	2	0	2
332598	1678	23760767848000	21600	10827	0	0	0
332599	1874	17531000	21600	10827	1	0	2
332600	1874	17533000	21600	10827	2	0	2
332615	1678	23760767849000	21607	10828	0	0	0
332617	1874	17538000	21607	10828	2	0	2
332618	1678	23760767850000	21608	10829	0	0	0
332622	1678	23760767851000	21610	10830	0	0	0
332623	1874	17540000	21610	10830	1	0	2
332625	1874	17545000	21610	10830	3	0	2
332626	1874	17548000	21610	10830	4	0	2
332630	1678	23760767852000	21612	10831	0	0	0
332631	1874	17551000	21612	10831	1	0	2
332632	1874	17553000	21612	10831	2	0	2
332637	1874	17555000	21614	10832	1	0	2
332638	1874	17558000	21614	10832	2	0	2
332642	1678	23760767854000	21616	10833	0	0	0
332643	1874	17561000	21616	10833	1	0	2
332644	1874	17563000	21616	10833	2	0	2
332657	1678	23040757698000	21618	10716	9	0	\N
332658	1579	0	21618	10716	10	0	\N
332659	1678	23040757699000	21618	10716	11	0	\N
332660	1678	23040757700000	21618	10716	12	0	\N
332661	1678	23040757701000	21618	10716	13	0	\N
332662	1678	23040757702000	21618	10716	14	0	\N
332663	1678	23040757703000	21618	10716	15	0	\N
332664	1678	23040757704000	21618	10716	16	0	\N
332665	1678	23040757705000	21618	10716	17	0	\N
332666	1678	23040757706000	21618	10716	18	0	\N
332667	1678	23040757707000	21618	10716	19	0	\N
332668	1678	23040757708000	21618	10716	20	0	\N
332669	1678	23040757709000	21618	10716	21	0	\N
332670	1678	23040757710000	21618	10716	22	0	\N
332671	1678	23040757711000	21618	10716	23	0	\N
332672	1678	23040757712000	21618	10716	24	0	\N
332673	1678	23040757713000	21618	10716	25	0	\N
332674	1678	23040757714000	21618	10716	26	0	\N
332675	1678	23040757715000	21618	10716	27	0	\N
332676	1678	23040757716000	21618	10716	28	0	\N
332677	1678	23040757717000	21618	10716	29	0	\N
332678	1678	23040757718000	21618	10716	30	0	\N
332679	1678	23040757719000	21618	10716	31	0	\N
332680	1678	23040757720000	21618	10716	32	0	\N
332681	1678	23040757721000	21618	10716	33	0	\N
332682	1678	23040757722000	21618	10716	34	0	\N
332683	1678	23040757723000	21618	10716	35	0	\N
332684	1678	23040757724000	21618	10716	36	0	\N
332685	1678	23040757725000	21618	10716	37	0	\N
332686	1678	23040757726000	21618	10716	38	0	\N
332687	1678	23040757727000	21618	10716	39	0	\N
332688	1678	23040757728000	21618	10716	40	0	\N
332689	1678	23040757729000	21618	10716	41	0	\N
332690	1678	23040757730000	21618	10716	42	0	\N
332691	1678	23040757731000	21618	10716	43	0	\N
332692	1678	23040757732000	21618	10716	44	0	\N
332693	1678	23040757733000	21618	10716	45	0	\N
332694	1678	23040757734000	21618	10716	46	0	\N
332695	1771	598166214766	21618	10716	47	0	\N
332696	195	66589992681547	21618	10716	48	0	\N
332697	291	66589992681547	21618	10716	49	0	\N
332698	1023	507269669126828	21618	10716	50	0	\N
332699	1143	909022900788739	21618	10716	51	0	\N
332700	1263	613335864722998	21618	10716	52	0	\N
332701	1389	1709114921835103	21618	10716	53	0	\N
332702	1579	0	21618	10716	54	0	\N
332703	1678	23040757735000	21618	10716	55	0	\N
332704	1678	23040757736000	21618	10716	56	0	\N
332705	1678	23040757737000	21618	10716	57	0	\N
332706	1678	23040757738000	21618	10716	58	0	\N
332707	1678	23040757739000	21618	10716	59	0	\N
332708	1678	23040757740000	21618	10716	60	0	\N
332709	1678	23040757741000	21618	10716	61	0	\N
332710	1678	23040757742000	21618	10716	63	0	\N
332711	1678	23040757743000	21618	10716	64	0	\N
332712	1678	23040757744000	21618	10716	65	0	\N
332713	1678	23040757745000	21618	10716	66	0	\N
332714	1678	23040757746000	21618	10716	67	0	\N
332715	1678	23040757747000	21618	10716	68	0	\N
332716	1678	23040757748000	21618	10716	69	0	\N
332717	1678	23040757749000	21618	10716	70	0	\N
332718	1678	23040757750000	21618	10716	71	0	\N
332719	1678	23040757751000	21618	10716	72	0	\N
332720	1678	23040757752000	21618	10716	73	0	\N
332721	1678	23040757753000	21618	10716	74	0	\N
332722	1678	23040757754000	21618	10716	75	0	\N
332723	1678	23040757755000	21618	10716	76	0	\N
332724	1678	23040757756000	21618	10716	77	0	\N
332725	1678	23040757757000	21618	10716	78	0	\N
332726	1678	23040757758000	21618	10716	79	0	\N
332727	1678	23040757759000	21618	10716	80	0	\N
332728	1678	23040757760000	21618	10716	81	0	\N
332729	1678	23040757761000	21618	10716	82	0	\N
332730	1678	23040757762000	21618	10716	83	0	\N
332731	1678	23040757763000	21618	10716	84	0	\N
332732	1678	23040757764000	21618	10716	85	0	\N
332733	1678	23040757765000	21618	10716	86	0	\N
332734	1678	23040757766000	21618	10716	87	0	\N
332735	1678	23040757767000	21618	10716	88	0	\N
332736	1678	23040757768000	21618	10716	89	0	\N
332737	1678	23040757769000	21618	10716	90	0	\N
332738	1678	23040757770000	21618	10716	91	0	\N
332739	1678	23040757771000	21618	10716	92	0	\N
332740	1678	23040757772000	21618	10716	93	0	\N
332741	1678	23040757773000	21618	10716	94	0	\N
332742	1678	23040757774000	21618	10716	95	0	\N
332743	1678	23040757775000	21618	10716	96	0	\N
332744	1678	23040757776000	21618	10716	97	0	\N
332745	1678	23040757777000	21618	10716	98	0	\N
332746	1678	23040757778000	21618	10716	99	0	\N
332747	1678	23040757779000	21618	10716	100	0	\N
332748	1678	23040757780000	21618	10716	101	0	\N
332749	1678	23040757781000	21618	10716	102	0	\N
332750	1678	23040757782000	21618	10716	103	0	\N
332751	1678	23040757783000	21618	10716	104	0	\N
332752	1678	23040757784000	21618	10716	105	0	\N
332753	1678	23040757785000	21618	10716	106	0	\N
332754	1678	23040757786000	21618	10716	107	0	\N
332755	1678	23040757787000	21618	10716	108	0	\N
332756	1678	23040757788000	21618	10716	109	0	\N
332757	1678	23040757789000	21618	10716	110	0	\N
332758	1678	23040757790000	21618	10716	111	0	\N
332759	1678	23040757791000	21618	10716	112	0	\N
332760	1678	23040757792000	21618	10716	113	0	\N
332761	1678	23040757793000	21618	10716	114	0	\N
332762	1678	23040757794000	21618	10716	115	0	\N
332763	1678	23040757795000	21618	10716	116	0	\N
332764	1678	23040757796000	21618	10716	117	0	\N
332765	1678	23040757797000	21618	10716	118	0	\N
332766	1678	23040757798000	21618	10716	119	0	\N
332767	1678	23040757799000	21618	10716	120	0	\N
332768	1678	23040757800000	21618	10716	121	0	\N
332769	1678	23040757801000	21618	10716	122	0	\N
332770	1678	23040757802000	21618	10716	123	0	\N
332771	1678	23040757803000	21618	10716	124	0	\N
332772	1678	23040757804000	21618	10716	125	0	\N
332773	1678	23760767855000	21621	10834	0	0	\N
332774	1678	23760767856000	21621	10834	1	0	\N
332775	1874	17565000	21621	10834	2	0	\N
332776	1874	17567000	21621	10834	3	0	\N
332777	1678	23760767855000	21622	10834	0	0	\N
332778	1678	23760767856000	21622	10834	1	0	\N
332779	1874	17565000	21622	10834	2	0	\N
332780	1874	17567000	21622	10834	3	0	\N
332781	1874	17570000	21622	10834	4	0	\N
332782	1874	17573000	21622	10834	5	0	\N
332783	1678	23760767855000	21623	10834	0	0	\N
332784	1678	23760767856000	21623	10834	1	0	\N
332785	1874	17565000	21623	10834	2	0	\N
332786	1874	17567000	21623	10834	3	0	\N
332789	1874	17565000	21624	10834	2	0	2
332790	1874	17567000	21624	10834	3	0	2
332791	1874	17570000	21624	10834	4	0	2
332792	1874	17573000	21624	10834	5	0	2
332793	1678	23760767855000	21625	10834	0	0	\N
332794	1678	23760767856000	21625	10834	1	0	\N
332795	1874	17565000	21625	10834	2	0	\N
332796	1874	17567000	21625	10834	3	0	\N
332797	1874	17570000	21625	10834	4	0	\N
332798	1874	17573000	21625	10834	5	0	\N
332799	1678	23040757795000	21626	10782	0	0	\N
332800	1678	23040757796000	21626	10782	1	0	\N
332801	1678	23040757797000	21626	10782	2	0	\N
332802	1678	23040757798000	21626	10782	3	0	\N
332803	1678	23040757799000	21626	10782	4	0	\N
332804	1678	23040757800000	21626	10782	5	0	\N
332805	1678	23040757801000	21626	10782	6	0	\N
332806	1678	23040757802000	21626	10782	7	0	\N
332807	1678	23040757803000	21626	10782	8	0	\N
332808	1678	23040757804000	21626	10782	9	0	\N
332809	1678	23040757805000	21626	10782	10	0	\N
332810	1678	23040757806000	21626	10782	11	0	\N
332811	1678	23040757807000	21626	10782	12	0	\N
332812	1678	23040757808000	21626	10782	13	0	\N
332813	1678	23040757809000	21626	10782	14	0	\N
332814	1678	23040757810000	21626	10782	15	0	\N
332815	1678	23040757811000	21626	10782	16	0	\N
332816	1678	23040757812000	21626	10782	17	0	\N
332817	1678	23040757813000	21626	10782	18	0	\N
332818	1678	23040757814000	21626	10782	19	0	\N
332819	1678	23040757815000	21626	10782	20	0	\N
332820	1678	23040757816000	21626	10782	21	0	\N
332821	1678	23040757817000	21626	10782	22	0	\N
332822	1678	23040757818000	21626	10782	23	0	\N
332823	1678	23040757819000	21626	10782	24	0	\N
332824	1678	23040757820000	21626	10782	25	0	\N
332825	1678	23040757821000	21626	10782	26	0	\N
332826	1678	23040757822000	21626	10782	27	0	\N
332827	1678	23040757823000	21626	10782	28	0	\N
332828	1678	23040757824000	21626	10782	29	0	\N
332829	1678	23040757825000	21626	10782	30	0	\N
332830	1678	23040757826000	21626	10782	31	0	\N
332831	1678	23040757827000	21626	10782	32	0	\N
332832	1678	23040757828000	21626	10782	33	0	\N
332833	1678	23040757829000	21626	10782	34	0	\N
332834	1678	23040757830000	21626	10782	35	0	\N
332835	1678	23040757831000	21626	10782	36	0	\N
332836	1678	23040757832000	21626	10782	37	0	\N
332837	1678	23040757833000	21626	10782	38	0	\N
332838	1678	23040757834000	21626	10782	39	0	\N
332839	1678	23040757835000	21626	10782	40	0	\N
332840	1678	23040757836000	21626	10782	41	0	\N
332841	1678	23040757837000	21626	10782	42	0	\N
332842	1678	23040757838000	21626	10782	43	0	\N
332843	1678	23040757839000	21626	10782	44	0	\N
332844	1678	23040757840000	21626	10782	45	0	\N
332845	1678	23040757841000	21626	10782	46	0	\N
332846	1678	23040757842000	21626	10782	47	0	\N
332847	1678	23040757843000	21626	10782	48	0	\N
332848	1678	23040757844000	21626	10782	49	0	\N
332849	1678	23040757845000	21626	10782	50	0	\N
332850	1678	23040757846000	21626	10782	51	0	\N
332851	1678	23040757847000	21626	10782	52	0	\N
332852	1678	23040757848000	21626	10782	53	0	\N
332853	1678	23040757849000	21626	10782	54	0	\N
332854	1678	23040757850000	21626	10782	55	0	\N
332855	1678	23040757851000	21626	10782	56	0	\N
332856	1678	23040757852000	21626	10782	57	0	\N
332857	1678	23040757853000	21626	10782	58	0	\N
332858	1678	23040757854000	21626	10782	59	0	\N
332859	1678	23040757855000	21626	10782	60	0	\N
332860	1874	17263000	21626	10782	61	0	\N
332861	1874	17266000	21626	10782	62	0	\N
332862	1874	17269000	21626	10782	63	0	\N
332863	1874	17272000	21626	10782	64	0	\N
332864	1874	17275000	21626	10782	65	0	\N
332865	1874	17277000	21626	10782	66	0	\N
332866	1874	17279000	21626	10782	67	0	\N
332867	1874	17281000	21626	10782	68	0	\N
332868	1874	17283000	21626	10782	69	0	\N
332869	1874	17285000	21626	10782	70	0	\N
332870	1874	17288000	21626	10782	71	0	\N
332871	1874	17290000	21626	10782	72	0	\N
332872	1874	17292000	21626	10782	73	0	\N
332873	1874	17294000	21626	10782	74	0	\N
332874	1874	17296000	21626	10782	75	0	\N
332875	1874	17298000	21626	10782	76	0	\N
332876	1874	17300000	21626	10782	77	0	\N
332877	1874	17302000	21626	10782	78	0	\N
332878	1874	17304000	21626	10782	79	0	\N
332879	1874	17306000	21626	10782	80	0	\N
332880	1874	17308000	21626	10782	81	0	\N
332881	1874	17310000	21626	10782	82	0	\N
332882	1874	17312000	21626	10782	83	0	\N
332883	1874	17314000	21626	10782	84	0	\N
332884	1874	17316000	21626	10782	85	0	\N
332885	1874	17318000	21626	10782	86	0	\N
332886	1874	17320000	21626	10782	87	0	\N
332887	1874	17322000	21626	10782	88	0	\N
332888	1874	17324000	21626	10782	89	0	\N
332889	1874	17326000	21626	10782	90	0	\N
332890	1874	17328000	21626	10782	91	0	\N
332891	1874	17330000	21626	10782	92	0	\N
332892	1874	17332000	21626	10782	93	0	\N
332893	1874	17334000	21626	10782	94	0	\N
332894	1874	17336000	21626	10782	95	0	\N
332895	1406	0	21626	10782	96	0	\N
332896	1483	10000000	21626	10782	97	0	\N
332897	1874	17338000	21626	10782	98	0	\N
332898	1874	17340000	21626	10782	99	0	\N
332899	1874	17342000	21626	10782	100	0	\N
332900	1874	17344000	21626	10782	101	0	\N
332901	1874	17346000	21626	10782	102	0	\N
332902	1874	17348000	21626	10782	103	0	\N
332903	1874	17350000	21626	10782	104	0	\N
332904	1874	17351000	21626	10782	105	0	\N
332905	1874	17352000	21626	10782	106	0	\N
332906	1874	17353000	21626	10782	108	0	\N
332907	1874	17354000	21626	10782	109	0	\N
332908	1874	17357000	21626	10782	110	0	\N
332909	1874	17360000	21626	10782	111	0	\N
332910	1874	17363000	21626	10782	112	0	\N
332911	1874	17366000	21626	10782	113	0	\N
332912	1874	17369000	21626	10782	114	0	\N
332913	1874	17372000	21626	10782	115	0	\N
332914	1874	17375000	21626	10782	116	0	\N
332915	1874	17378000	21626	10782	117	0	\N
332916	1874	17381000	21626	10782	118	0	\N
332917	1874	17384000	21626	10782	119	0	\N
332918	1874	17387000	21626	10782	120	0	\N
332919	1874	17390000	21626	10782	121	0	\N
332920	1874	17393000	21626	10782	122	0	\N
332921	1874	17396000	21626	10782	123	0	\N
332922	1874	17399000	21626	10782	124	0	\N
332923	1874	17402000	21626	10782	125	0	\N
332926	1678	23760767857000	21628	10835	0	0	\N
332927	1874	17576000	21628	10835	1	0	\N
332928	1874	17578000	21628	10835	2	0	\N
332940	1021	507244438919578	21631	10838	0	0	\N
332941	1678	23760767861000	21631	10838	1	0	\N
332942	1874	17595000	21631	10838	2	0	\N
332943	1021	507244438919578	21632	10838	0	0	\N
332944	1678	23760767861000	21632	10838	1	0	\N
332945	1874	17595000	21632	10838	2	0	\N
332950	1021	507244438919578	21634	10838	0	0	\N
332951	1678	23760767861000	21634	10838	1	0	\N
332952	1874	17596000	21634	10838	2	0	\N
332953	1874	17598000	21634	10838	3	0	\N
332954	1678	23760767862000	21635	10839	0	0	\N
332955	1141	908977688473491	21635	10839	1	0	\N
332956	1261	613305359073006	21635	10839	2	0	\N
332957	1387	1709029915128959	21635	10839	3	0	\N
332958	1874	17600000	21635	10839	4	0	\N
332959	1678	23760767862000	21636	10839	0	0	\N
332960	1141	908977688473491	21636	10839	1	0	\N
332961	1261	613305359073006	21636	10839	2	0	\N
332962	1387	1709029915128959	21636	10839	3	0	\N
332963	1874	17601000	21636	10839	4	0	\N
332964	1874	17603000	21636	10839	5	0	\N
332973	1678	23760767863000	21639	10840	0	0	\N
332974	1874	17601000	21639	10840	1	0	\N
332975	1874	17604000	21639	10840	2	0	\N
332976	1874	17606000	21639	10840	3	0	\N
332977	1874	17608000	21639	10840	4	0	\N
332985	1678	23760767865000	21642	10842	0	0	\N
332986	1874	17615000	21642	10842	1	0	\N
332987	1874	17618000	21642	10842	2	0	\N
332991	1678	23760767866000	21644	10843	0	0	\N
332992	1874	17621000	21644	10843	1	0	\N
332993	1874	17623000	21644	10843	2	0	\N
332994	1874	17626000	21644	10843	3	0	\N
332995	1874	17628000	21644	10843	4	0	\N
333009	1678	23760767868000	21647	10845	0	0	\N
333010	1678	23760767869000	21647	10845	1	0	\N
333011	1508	6428685544661	21647	10845	2	0	\N
333012	1508	6680255156616	21647	10845	3	0	\N
333013	1874	17635000	21647	10845	5	0	\N
333014	1874	17637000	21647	10845	6	0	\N
333015	1874	17640000	21647	10845	7	0	\N
333016	1874	17643000	21647	10845	8	0	\N
333017	1678	23760767870000	21648	10846	0	0	\N
333018	1874	17646000	21648	10846	1	0	\N
333019	1874	17648000	21648	10846	2	0	\N
333020	1678	23760767870000	21649	10846	0	0	\N
333021	1874	17646000	21649	10846	1	0	\N
333022	1874	17648000	21649	10846	2	0	\N
333023	1678	23760767870000	21650	10846	0	0	\N
333024	1874	17646000	21650	10846	1	0	\N
333025	1874	17648000	21650	10846	2	0	\N
333029	1678	23760767870000	21652	10846	0	0	\N
333030	1874	17646000	21652	10846	1	0	\N
333031	1874	17648000	21652	10846	2	0	\N
333032	957	508158775000000	21653	10674	0	0	\N
333033	1197	614409750000000	21653	10674	1	0	\N
333034	1077	910614465000000	21653	10674	2	0	\N
333035	1323	1712107637751650	21653	10674	3	0	\N
333036	683	66339585999999	21653	10674	4	0	\N
333037	683	66626585999999	21653	10674	5	0	\N
333038	1012	506425775000000	21653	10674	6	0	\N
333039	1252	612316750000000	21653	10674	7	0	\N
333040	1132	907510465000000	21653	10674	8	0	\N
333041	1378	1706269637751650	21653	10674	9	0	\N
333042	923	507155015000000	21653	10674	10	0	\N
333043	1483	10000000	21653	10674	11	0	\N
333044	1678	23040757640000	21653	10674	12	0	\N
333045	1483	10000000	21653	10674	13	0	\N
333046	1021	507244438919578	21653	10674	14	0	\N
333047	2288	0	21653	10674	15	0	\N
333048	1678	23040757641000	21653	10674	16	0	\N
333049	1508	19808157929693	21653	10674	17	0	\N
333050	1508	20059727541648	21653	10674	18	0	\N
333051	1579	0	21653	10674	19	0	\N
333052	1678	23040757642000	21653	10674	20	0	\N
333053	1678	23040757643000	21653	10674	21	0	\N
333054	1678	23040757644000	21653	10674	22	0	\N
333055	1678	23040757645000	21653	10674	23	0	\N
333056	1678	23040757646000	21653	10674	24	0	\N
333057	1678	23040757647000	21653	10674	25	0	\N
333058	1678	23040757648000	21653	10674	26	0	\N
333059	1678	23040757649000	21653	10674	27	0	\N
333060	1678	23040757650000	21653	10674	28	0	\N
333061	1678	23040757651000	21653	10674	29	0	\N
333062	1678	23040757652000	21653	10674	30	0	\N
333063	1678	23040757653000	21653	10674	31	0	\N
333064	1678	23040757654000	21653	10674	32	0	\N
332931	1874	17578000	21629	10836	2	0	2
332932	1874	17580000	21629	10836	3	0	2
332933	2289	200000000	21629	10836	4	0	0
332934	1874	17582000	21629	10836	5	0	2
332935	1874	17585000	21629	10836	6	0	2
332937	1678	23760767860000	21630	10837	0	0	0
332938	1874	17591000	21630	10837	1	0	2
332939	1874	17593000	21630	10837	2	0	2
332946	1021	507244438919578	21633	10838	0	0	0
332947	1678	23760767861000	21633	10838	1	0	0
332949	1874	17598000	21633	10838	3	0	2
332965	1678	23760767862000	21637	10839	0	0	0
332966	1141	908977688473491	21637	10839	1	0	0
332967	1261	613305359073006	21637	10839	2	0	0
332969	1678	23760767863000	21638	10840	0	0	0
332970	1874	17601000	21638	10840	1	0	2
332971	1874	17604000	21638	10840	2	0	2
332972	1874	17606000	21638	10840	3	0	2
332978	1678	23760767864000	21640	10841	0	0	0
332980	1874	17611000	21640	10841	2	0	2
332981	1874	17613000	21640	10841	3	0	2
332982	1678	23760767865000	21641	10842	0	0	0
332983	1874	17615000	21641	10842	1	0	2
332984	1874	17618000	21641	10842	2	0	2
332989	1874	17620000	21643	10843	1	0	2
332990	1874	17622000	21643	10843	2	0	2
332996	1678	23760767867000	21645	10844	0	0	0
332997	1874	17625000	21645	10844	1	0	2
332999	1874	17630000	21645	10844	3	0	2
333000	1874	17633000	21645	10844	4	0	2
333001	1678	23760767868000	21646	10845	0	0	0
333002	1678	23760767869000	21646	10845	1	0	0
333003	1508	6428685544661	21646	10845	2	0	10
333005	1874	17635000	21646	10845	5	0	2
333006	1874	17637000	21646	10845	6	0	2
333007	1874	17640000	21646	10845	7	0	2
333008	1874	17643000	21646	10845	8	0	2
333026	1678	23760767870000	21651	10846	0	0	0
333028	1874	17648000	21651	10846	2	0	2
333065	1678	23040757655000	21653	10674	33	0	\N
333066	1678	23040757656000	21653	10674	34	0	\N
333067	1678	23040757657000	21653	10674	35	0	\N
333068	1678	23040757658000	21653	10674	36	0	\N
333069	1678	23040757659000	21653	10674	37	0	\N
333070	1678	23040757660000	21653	10674	38	0	\N
333071	1678	23040757661000	21653	10674	39	0	\N
333072	1678	23040757662000	21653	10674	40	0	\N
333073	1678	23040757663000	21653	10674	41	0	\N
333074	1141	908977688473491	21653	10674	42	0	\N
333075	1261	613305359073006	21653	10674	43	0	\N
333076	1387	1709029915128959	21653	10674	44	0	\N
333077	1771	598166214766	21653	10674	45	0	\N
333078	195	66589992681547	21653	10674	46	0	\N
333079	291	66589992681547	21653	10674	47	0	\N
333080	1023	507269669126828	21653	10674	48	0	\N
333081	1143	909022900788739	21653	10674	49	0	\N
333082	1263	613335864722998	21653	10674	50	0	\N
333083	1389	1709114921835103	21653	10674	51	0	\N
333084	1579	0	21653	10674	52	0	\N
333085	1678	23040757664000	21653	10674	53	0	\N
333086	1678	23040757665000	21653	10674	54	0	\N
333087	1678	23040757666000	21653	10674	55	0	\N
333088	1678	23040757667000	21653	10674	56	0	\N
333089	1678	23040757668000	21653	10674	57	0	\N
333090	1678	23040757669000	21653	10674	58	0	\N
333091	1678	23040757670000	21653	10674	59	0	\N
333092	1678	23040757671000	21653	10674	60	0	\N
333093	1678	23040757672000	21653	10674	61	0	\N
333094	1678	23040757673000	21653	10674	62	0	\N
333095	1678	23040757674000	21653	10674	63	0	\N
333096	1678	23040757675000	21653	10674	64	0	\N
333097	1678	23040757676000	21653	10674	65	0	\N
333098	1678	23040757677000	21653	10674	66	0	\N
333099	1678	23040757678000	21653	10674	67	0	\N
333100	1678	23040757679000	21653	10674	68	0	\N
333101	1678	23040757680000	21653	10674	69	0	\N
333102	1678	23040757681000	21653	10674	70	0	\N
333103	1678	23040757682000	21653	10674	71	0	\N
333104	1678	23040757683000	21653	10674	72	0	\N
333105	1678	23040757684000	21653	10674	73	0	\N
333106	1678	23040757685000	21653	10674	74	0	\N
333107	1678	23040757686000	21653	10674	75	0	\N
333108	1678	23040757687000	21653	10674	76	0	\N
333109	1678	23040757688000	21653	10674	77	0	\N
333110	1678	23040757689000	21653	10674	78	0	\N
333111	1678	23040757690000	21653	10674	79	0	\N
333112	1678	23040757691000	21653	10674	80	0	\N
333113	1678	23040757692000	21653	10674	81	0	\N
333114	1678	23040757693000	21653	10674	82	0	\N
333115	1678	23040757694000	21653	10674	83	0	\N
333116	1678	23040757695000	21653	10674	84	0	\N
333117	1678	23040757696000	21653	10674	85	0	\N
333118	1678	23040757697000	21653	10674	86	0	\N
333119	1678	23040757698000	21653	10674	87	0	\N
333120	1678	23040757699000	21653	10674	88	0	\N
333121	1678	23040757700000	21653	10674	89	0	\N
333122	1678	23040757701000	21653	10674	90	0	\N
333123	1678	23040757702000	21653	10674	92	0	\N
333124	1678	23040757703000	21653	10674	93	0	\N
333125	1678	23040757704000	21653	10674	94	0	\N
333126	1678	23040757705000	21653	10674	95	0	\N
333127	1678	23040757706000	21653	10674	96	0	\N
333128	1678	23040757707000	21653	10674	97	0	\N
333129	1678	23040757708000	21653	10674	98	0	\N
333130	1678	23040757709000	21653	10674	99	0	\N
333131	1678	23040757710000	21653	10674	100	0	\N
333132	1678	23040757711000	21653	10674	101	0	\N
333133	1678	23040757712000	21653	10674	102	0	\N
333134	1678	23040757713000	21653	10674	103	0	\N
333135	1678	23040757714000	21653	10674	104	0	\N
333136	1678	23040757715000	21653	10674	105	0	\N
333137	1678	23040757716000	21653	10674	106	0	\N
333138	1678	23040757717000	21653	10674	107	0	\N
333139	1678	23040757718000	21653	10674	108	0	\N
333140	1678	23040757719000	21653	10674	109	0	\N
333141	1678	23040757720000	21653	10674	110	0	\N
333142	1678	23040757721000	21653	10674	111	0	\N
333143	1678	23040757722000	21653	10674	112	0	\N
333144	1678	23040757723000	21653	10674	113	0	\N
333145	1678	23040757724000	21653	10674	114	0	\N
333146	1678	23040757725000	21653	10674	115	0	\N
333147	1678	23040757726000	21653	10674	116	0	\N
333148	1678	23040757727000	21653	10674	117	0	\N
333149	1678	23040757728000	21653	10674	118	0	\N
333150	1678	23040757729000	21653	10674	119	0	\N
333151	1678	23040757730000	21653	10674	120	0	\N
333152	1678	23040757731000	21653	10674	121	0	\N
333153	1678	23040757732000	21653	10674	122	0	\N
333154	1678	23040757733000	21653	10674	123	0	\N
333155	1678	23040757734000	21653	10674	124	0	\N
333156	1678	23040757735000	21653	10674	125	0	\N
333166	1678	23760767871000	21655	10847	0	0	\N
333167	1678	23760767872000	21655	10847	1	0	\N
333168	1678	23760767873000	21655	10847	2	0	\N
333169	1874	17650000	21655	10847	3	0	\N
333170	1874	17652000	21655	10847	4	0	\N
333171	1874	17654000	21655	10847	5	0	\N
333172	1874	17657000	21655	10847	6	0	\N
333173	1874	17660000	21655	10847	7	0	\N
333174	1874	17663000	21655	10847	8	0	\N
333189	1678	23760767878000	21660	10852	0	0	\N
333190	1874	17685000	21660	10852	1	0	\N
333191	1678	23760767878000	21661	10852	0	0	\N
333192	1874	17686000	21661	10852	1	0	\N
333193	1874	17688000	21661	10852	2	0	\N
333159	1678	23760767873000	21654	10847	2	0	0
333160	1874	17650000	21654	10847	3	0	2
333161	1874	17652000	21654	10847	4	0	2
333162	1874	17654000	21654	10847	5	0	2
333163	1874	17657000	21654	10847	6	0	2
333165	1874	17663000	21654	10847	8	0	2
333175	1678	23760767874000	21656	10848	0	0	0
333176	1874	17665000	21656	10848	1	0	2
333177	1874	17668000	21656	10848	2	0	2
333178	1678	23760767875000	21657	10849	0	0	0
333180	1874	17670000	21657	10849	2	0	2
333181	1874	17673000	21657	10849	3	0	2
333182	1483	10000000	21658	10850	0	0	0
333183	1678	23760767876000	21658	10850	1	0	0
333185	1874	17678000	21658	10850	3	0	2
333186	1678	23760767877000	21659	10851	0	0	0
333187	1874	17681000	21659	10851	1	0	2
333188	1874	17683000	21659	10851	2	0	2
333194	1678	23760767878000	21662	10852	0	0	0
333196	1874	17688000	21662	10852	2	0	2
333197	1678	23760767879000	21663	10853	0	0	0
333198	2290	100000000	21663	10853	1	0	0
333199	1874	17690000	21663	10853	2	0	2
333200	1874	17693000	21663	10853	3	0	2
333202	1678	23760767880000	21665	10854	0	0	\N
333203	1874	17696000	21665	10854	1	0	\N
333204	1874	17698000	21665	10854	2	0	\N
333205	957	508158775000000	21666	10626	0	0	\N
333206	1197	614409750000000	21666	10626	1	0	\N
333207	1077	910614465000000	21666	10626	2	0	\N
333208	1323	1712107637751650	21666	10626	3	0	\N
333209	683	66339585999999	21666	10626	4	0	\N
333210	683	66626585999999	21666	10626	5	0	\N
333211	1012	506425775000000	21666	10626	6	0	\N
333212	1252	612316750000000	21666	10626	7	0	\N
333213	1132	907510465000000	21666	10626	8	0	\N
333214	1378	1706269637751650	21666	10626	9	0	\N
333215	1364	1709956637751650	21666	10626	10	0	\N
333216	923	507155015000000	21666	10626	11	0	\N
333217	1678	23040757571000	21666	10626	12	0	\N
333218	1386	1712107637751650	21666	10626	13	0	\N
333219	1483	10000000	21666	10626	14	0	\N
333220	1383	1710879637751650	21666	10626	15	0	\N
333221	1483	10000000	21666	10626	16	0	\N
333222	1118	909471465000000	21666	10626	17	0	\N
333223	1140	910615465000000	21666	10626	18	0	\N
333224	1021	507244438919578	21666	10626	19	0	\N
333225	2288	0	21666	10626	20	0	\N
333226	1678	23040757572000	21666	10626	21	0	\N
333227	1483	10000000	21666	10626	22	0	\N
333228	1137	909961465000000	21666	10626	23	0	\N
333229	1257	613969750000000	21666	10626	24	0	\N
333230	1017	507794775000000	21666	10626	25	0	\N
333231	1260	614410750000000	21666	10626	26	0	\N
333232	1483	10000000	21666	10626	27	0	\N
333233	1508	19808157929693	21666	10626	28	0	\N
333234	2290	100000000	21666	10626	29	0	\N
333235	1508	20059727541648	21666	10626	30	0	\N
333236	1238	613638750000000	21666	10626	31	0	\N
333237	998	507520775000000	21666	10626	32	0	\N
333238	1678	23040757573000	21666	10626	33	0	\N
333239	1678	23040757574000	21666	10626	34	0	\N
333240	1678	23040757575000	21666	10626	35	0	\N
333241	1678	23040757576000	21666	10626	36	0	\N
333242	1579	0	21666	10626	37	0	\N
333243	1678	23040757577000	21666	10626	38	0	\N
333244	1678	23040757578000	21666	10626	39	0	\N
333245	1141	908977688473491	21666	10626	40	0	\N
333246	1261	613305359073006	21666	10626	41	0	\N
333247	1387	1709029915128959	21666	10626	42	0	\N
333248	1678	23040757579000	21666	10626	43	0	\N
333249	1678	23040757580000	21666	10626	44	0	\N
333250	1678	23040757581000	21666	10626	45	0	\N
333251	1678	23040757582000	21666	10626	46	0	\N
333252	1678	23040757583000	21666	10626	47	0	\N
333253	1678	23040757584000	21666	10626	48	0	\N
333254	1678	23040757585000	21666	10626	49	0	\N
333255	1678	23040757586000	21666	10626	50	0	\N
333256	1678	23040757587000	21666	10626	51	0	\N
333257	1678	23040757588000	21666	10626	52	0	\N
333258	1678	23040757589000	21666	10626	53	0	\N
333259	1678	23040757590000	21666	10626	54	0	\N
333260	1678	23040757591000	21666	10626	55	0	\N
333261	1678	23040757592000	21666	10626	56	0	\N
333262	1678	23040757593000	21666	10626	57	0	\N
333263	1678	23040757594000	21666	10626	58	0	\N
333264	1678	23040757595000	21666	10626	59	0	\N
333265	1678	23040757596000	21666	10626	60	0	\N
333266	1678	23040757597000	21666	10626	61	0	\N
333267	1678	23040757598000	21666	10626	62	0	\N
333268	1771	598166214766	21666	10626	63	0	\N
333269	195	66589992681547	21666	10626	64	0	\N
333270	291	66589992681547	21666	10626	65	0	\N
333271	1023	507269669126828	21666	10626	66	0	\N
333272	1143	909022900788739	21666	10626	67	0	\N
333273	1263	613335864722998	21666	10626	68	0	\N
333274	1389	1709114921835103	21666	10626	69	0	\N
333275	1579	0	21666	10626	70	0	\N
333276	1678	23040757599000	21666	10626	71	0	\N
333277	1678	23040757600000	21666	10626	72	0	\N
333278	1678	23040757601000	21666	10626	73	0	\N
333279	1678	23040757602000	21666	10626	74	0	\N
333280	1678	23040757603000	21666	10626	75	0	\N
333281	1678	23040757604000	21666	10626	76	0	\N
333282	1678	23040757605000	21666	10626	77	0	\N
333283	1020	508158775000000	21666	10626	78	0	\N
333284	1678	23040757606000	21666	10626	79	0	\N
333285	1678	23040757607000	21666	10626	80	0	\N
333286	1678	23040757608000	21666	10626	81	0	\N
333287	1678	23040757609000	21666	10626	82	0	\N
333288	1678	23040757610000	21666	10626	83	0	\N
333289	1678	23040757611000	21666	10626	84	0	\N
333290	1678	23040757612000	21666	10626	85	0	\N
333291	1678	23040757613000	21666	10626	86	0	\N
333292	1678	23040757614000	21666	10626	87	0	\N
333293	1678	23040757615000	21666	10626	88	0	\N
333294	1678	23040757616000	21666	10626	90	0	\N
333295	1678	23040757617000	21666	10626	91	0	\N
333296	1678	23040757618000	21666	10626	92	0	\N
333297	1678	23040757619000	21666	10626	93	0	\N
333298	1678	23040757620000	21666	10626	94	0	\N
333299	1678	23040757621000	21666	10626	95	0	\N
333300	1678	23040757622000	21666	10626	96	0	\N
333301	1678	23040757623000	21666	10626	97	0	\N
333302	1678	23040757624000	21666	10626	98	0	\N
333303	1678	23040757625000	21666	10626	99	0	\N
333304	1678	23040757626000	21666	10626	100	0	\N
333305	1678	23040757627000	21666	10626	101	0	\N
333306	1678	23040757628000	21666	10626	102	0	\N
333307	1678	23040757629000	21666	10626	103	0	\N
333308	1678	23040757630000	21666	10626	104	0	\N
333309	1678	23040757631000	21666	10626	105	0	\N
333310	1678	23040757632000	21666	10626	106	0	\N
333311	1678	23040757633000	21666	10626	107	0	\N
333312	1678	23040757634000	21666	10626	108	0	\N
333313	1678	23040757635000	21666	10626	109	0	\N
333314	1678	23040757636000	21666	10626	110	0	\N
333315	1678	23040757637000	21666	10626	111	0	\N
333316	1678	23040757638000	21666	10626	112	0	\N
333317	1678	23040757639000	21666	10626	113	0	\N
333318	1678	23040757640000	21666	10626	114	0	\N
333319	1678	23040757641000	21666	10626	115	0	\N
333320	1678	23040757642000	21666	10626	116	0	\N
333321	1678	23040757643000	21666	10626	117	0	\N
333322	1678	23040757644000	21666	10626	118	0	\N
333323	1678	23040757645000	21666	10626	119	0	\N
333324	1678	23040757646000	21666	10626	120	0	\N
333325	1678	23040757647000	21666	10626	121	0	\N
333326	1678	23040757648000	21666	10626	122	0	\N
333327	1678	23040757649000	21666	10626	123	0	\N
333328	1678	23040757650000	21666	10626	124	0	\N
333329	1678	23040757651000	21666	10626	125	0	\N
333330	1483	10000000	21667	10855	0	0	\N
333331	1678	23760767881000	21667	10855	1	0	\N
333332	1874	17695000	21667	10855	2	0	\N
333333	1874	17697000	21667	10855	3	0	\N
333334	1483	10000000	21668	10855	0	0	\N
333335	1678	23760767881000	21668	10855	1	0	\N
333336	1874	17696000	21668	10855	2	0	\N
333337	1874	17699000	21668	10855	3	0	\N
333338	1874	17701000	21668	10855	4	0	\N
333339	1874	17703000	21668	10855	5	0	\N
333346	1483	10000000	21670	10855	0	0	\N
333347	1678	23760767881000	21670	10855	1	0	\N
333348	1874	17696000	21670	10855	2	0	\N
333349	1874	17699000	21670	10855	3	0	\N
333350	1874	17701000	21670	10855	4	0	\N
333351	1874	17703000	21670	10855	5	0	\N
333361	1678	23760767885000	21674	10858	0	0	\N
333362	1874	17720000	21674	10858	1	0	\N
333363	1874	17723000	21674	10858	2	0	\N
333377	1483	10000000	21680	10765	0	0	\N
333378	1483	10000000	21680	10765	1	0	\N
333379	1021	507244438919578	21680	10765	2	0	\N
333380	1958	5231186000000	21680	10765	3	0	\N
333381	1483	10000000	21680	10765	4	0	\N
333382	1483	10000000	21680	10765	5	0	\N
333383	1508	22688206929693	21680	10765	6	0	\N
333384	2290	100000000	21680	10765	7	0	\N
333385	1508	22939776541648	21680	10765	8	0	\N
333386	1141	908977688473491	21680	10765	9	0	\N
333387	1261	613305359073006	21680	10765	10	0	\N
333388	1387	1709029915128959	21680	10765	11	0	\N
333389	1406	0	21680	10765	12	0	\N
333390	1483	10000000	21680	10765	13	0	\N
333391	1678	23040757836000	21681	10816	0	0	\N
333392	1021	507244438919578	21681	10816	1	0	\N
333393	1958	5231186000000	21681	10816	2	0	\N
333394	1483	10000000	21681	10816	3	0	\N
333395	1678	23040757837000	21681	10816	4	0	\N
333396	1483	10000000	21681	10816	5	0	\N
333397	1508	22688206929693	21681	10816	6	0	\N
333398	2290	100000000	21681	10816	7	0	\N
333399	1508	22939776541648	21681	10816	8	0	\N
333400	1678	23040757838000	21681	10816	9	0	\N
333401	1678	23040757839000	21681	10816	10	0	\N
333402	1678	23040757840000	21681	10816	11	0	\N
333403	1678	23040757841000	21681	10816	12	0	\N
333404	1678	23040757842000	21681	10816	13	0	\N
333405	1678	23040757843000	21681	10816	14	0	\N
333406	1678	23040757844000	21681	10816	15	0	\N
333407	1678	23040757845000	21681	10816	16	0	\N
333408	1678	23040757846000	21681	10816	17	0	\N
333409	1678	23040757847000	21681	10816	18	0	\N
333410	1678	23040757848000	21681	10816	19	0	\N
333411	1678	23040757849000	21681	10816	20	0	\N
333412	1678	23040757850000	21681	10816	21	0	\N
333413	1678	23040757851000	21681	10816	22	0	\N
333414	1678	23040757852000	21681	10816	23	0	\N
333415	1678	23040757853000	21681	10816	24	0	\N
333416	1678	23040757854000	21681	10816	25	0	\N
333417	1678	23040757855000	21681	10816	26	0	\N
333418	1678	23040757856000	21681	10816	27	0	\N
333419	1678	23040757857000	21681	10816	28	0	\N
333420	1678	23040757858000	21681	10816	29	0	\N
333421	1678	23040757859000	21681	10816	30	0	\N
333422	1678	23040757860000	21681	10816	31	0	\N
333423	1678	23040757861000	21681	10816	32	0	\N
333424	1678	23040757862000	21681	10816	33	0	\N
333425	1678	23040757863000	21681	10816	34	0	\N
333426	1678	23040757864000	21681	10816	35	0	\N
333427	1678	23040757865000	21681	10816	36	0	\N
333428	1678	23040757866000	21681	10816	37	0	\N
333429	1678	23040757867000	21681	10816	38	0	\N
333430	1678	23040757868000	21681	10816	39	0	\N
333431	1678	23040757869000	21681	10816	41	0	\N
333432	1678	23040757870000	21681	10816	42	0	\N
333433	1678	23040757871000	21681	10816	43	0	\N
333434	1678	23040757872000	21681	10816	44	0	\N
333435	1678	23040757873000	21681	10816	45	0	\N
333436	1678	23040757874000	21681	10816	46	0	\N
333437	1678	23040757875000	21681	10816	47	0	\N
333438	1678	23040757876000	21681	10816	48	0	\N
333439	1678	23040757877000	21681	10816	49	0	\N
333440	1678	23040757878000	21681	10816	50	0	\N
333441	1678	23040757879000	21681	10816	51	0	\N
333442	1678	23040757880000	21681	10816	52	0	\N
333443	1678	23040757881000	21681	10816	53	0	\N
333444	1678	23040757882000	21681	10816	54	0	\N
333445	1678	23040757883000	21681	10816	55	0	\N
333446	1678	23040757884000	21681	10816	56	0	\N
333447	1678	23040757885000	21681	10816	57	0	\N
333448	1678	23040757886000	21681	10816	58	0	\N
333449	1678	23040757887000	21681	10816	59	0	\N
333450	1678	23040757888000	21681	10816	60	0	\N
333451	1678	23040757889000	21681	10816	61	0	\N
333452	1141	908977688473491	21681	10816	62	0	\N
333453	1261	613305359073006	21681	10816	63	0	\N
333454	1387	1709029915128959	21681	10816	64	0	\N
333455	1874	17475000	21681	10816	65	0	\N
333456	1874	17477000	21681	10816	66	0	\N
333457	1874	17479000	21681	10816	67	0	\N
333458	1874	17481000	21681	10816	68	0	\N
333459	1874	17483000	21681	10816	69	0	\N
333460	1874	17485000	21681	10816	70	0	\N
333461	1874	17487000	21681	10816	71	0	\N
333462	1874	17489000	21681	10816	72	0	\N
333463	1874	17491000	21681	10816	73	0	\N
333464	1874	17493000	21681	10816	74	0	\N
333465	1406	0	21681	10816	75	0	\N
333466	1483	10000000	21681	10816	76	0	\N
333467	1874	17496000	21681	10816	77	0	\N
333468	1874	17499000	21681	10816	78	0	\N
333469	1874	17502000	21681	10816	79	0	\N
333470	1874	17505000	21681	10816	80	0	\N
333471	1874	17508000	21681	10816	81	0	\N
333472	1874	17511000	21681	10816	82	0	\N
333342	1874	17696000	21669	10855	2	0	2
333343	1874	17699000	21669	10855	3	0	2
333344	1874	17701000	21669	10855	4	0	2
333345	1874	17703000	21669	10855	5	0	2
333352	1678	23760767882000	21671	10856	0	0	0
333354	1874	17705000	21671	10856	2	0	2
333355	1874	17707000	21671	10856	3	0	2
333356	1874	17710000	21671	10856	4	0	2
333357	1874	17713000	21671	10856	5	0	2
333358	1678	23760767884000	21673	10857	0	0	0
333360	1874	17718000	21673	10857	2	0	2
333364	1678	23760767885000	21675	10858	0	0	0
333365	1874	17720000	21675	10858	1	0	2
333366	1874	17723000	21675	10858	2	0	2
333368	1678	23760767886000	21677	10859	1	0	0
333369	1874	17725000	21677	10859	2	0	2
333370	1874	17728000	21677	10859	3	0	2
333371	1678	23760767887000	21678	10860	0	0	0
333372	1874	17730000	21678	10860	1	0	2
333374	1678	23760767888000	21679	10861	0	0	0
333375	1874	17736000	21679	10861	1	0	2
333376	1874	17738000	21679	10861	2	0	2
333473	1874	17514000	21681	10816	83	0	\N
333474	1874	17517000	21681	10816	84	0	\N
333475	1874	17520000	21681	10816	85	0	\N
333476	1874	17523000	21681	10816	86	0	\N
333477	1874	17525000	21681	10816	87	0	\N
333478	1874	17527000	21681	10816	88	0	\N
333479	1874	17529000	21681	10816	89	0	\N
333480	1874	17531000	21681	10816	90	0	\N
333481	1874	17533000	21681	10816	91	0	\N
333482	1874	17535000	21681	10816	92	0	\N
333483	1874	17537000	21681	10816	93	0	\N
333484	1874	17539000	21681	10816	94	0	\N
333485	1874	17541000	21681	10816	95	0	\N
333486	1874	17543000	21681	10816	96	0	\N
333487	1874	17545000	21681	10816	97	0	\N
333488	1874	17547000	21681	10816	98	0	\N
333489	2289	200000000	21681	10816	99	0	\N
333490	1874	17550000	21681	10816	100	0	\N
333491	1874	17553000	21681	10816	101	0	\N
333492	1874	17556000	21681	10816	102	0	\N
333493	1874	17559000	21681	10816	103	0	\N
333494	1874	17562000	21681	10816	104	0	\N
333495	1874	17565000	21681	10816	105	0	\N
333496	1874	17568000	21681	10816	106	0	\N
333497	1874	17571000	21681	10816	107	0	\N
333498	1874	17574000	21681	10816	108	0	\N
333499	1874	17577000	21681	10816	109	0	\N
333500	1874	17580000	21681	10816	110	0	\N
333501	1874	17582000	21681	10816	111	0	\N
333502	1874	17584000	21681	10816	112	0	\N
333503	1874	17586000	21681	10816	113	0	\N
333504	1874	17588000	21681	10816	114	0	\N
333505	1874	17590000	21681	10816	115	0	\N
333506	1874	17593000	21681	10816	116	0	\N
333507	1874	17596000	21681	10816	117	0	\N
333508	1874	17599000	21681	10816	118	0	\N
333509	1874	17602000	21681	10816	119	0	\N
333510	1874	17605000	21681	10816	120	0	\N
333511	1874	17608000	21681	10816	121	0	\N
333512	1874	17611000	21681	10816	122	0	\N
333513	1874	17614000	21681	10816	123	0	\N
333514	1874	17617000	21681	10816	124	0	\N
333515	1874	17620000	21681	10816	125	0	\N
333519	588	66783000000000	21683	10863	0	0	\N
333520	1678	23760767890000	21683	10863	1	0	\N
333521	1874	17745000	21683	10863	2	0	\N
333522	1874	17748000	21683	10863	3	0	\N
333523	588	66783000000000	21684	10863	0	0	\N
333524	1678	23760767890000	21684	10863	1	0	\N
333525	1874	17745000	21684	10863	2	0	\N
333526	1874	17748000	21684	10863	3	0	\N
333531	588	66783000000000	21686	10863	0	0	\N
333532	588	66783000000000	21687	10863	0	0	\N
333533	588	66783000000000	21688	10863	0	0	\N
333534	1678	23760767890000	21688	10863	1	0	\N
333535	1678	23760767891000	21688	10863	2	0	\N
333536	1874	17745000	21688	10863	3	0	\N
333537	1874	17747000	21688	10863	4	0	\N
333538	1874	17750000	21688	10863	5	0	\N
333539	1874	17753000	21688	10863	6	0	\N
333545	1093	909143945000000	21690	10865	0	0	\N
333546	1339	1709341667751650	21690	10865	1	0	\N
333547	1678	23760767892000	21690	10865	2	0	\N
333548	1678	23760767893000	21690	10865	3	0	\N
333549	1678	23760767894000	21690	10865	4	0	\N
333550	1874	17755000	21690	10865	5	0	\N
333551	1874	17757000	21690	10865	6	0	\N
333552	1874	17759000	21690	10865	7	0	\N
333553	1874	17762000	21690	10865	8	0	\N
333554	1874	17765000	21690	10865	10	0	\N
333555	1874	17768000	21690	10865	11	0	\N
333556	1093	909143945000000	21691	10865	0	0	\N
333557	1339	1709341667751650	21691	10865	1	0	\N
333558	1678	23760767892000	21691	10865	2	0	\N
333559	1678	23760767893000	21691	10865	3	0	\N
333560	1678	23760767894000	21691	10865	4	0	\N
333561	1874	17755000	21691	10865	5	0	\N
333562	1874	17757000	21691	10865	6	0	\N
333563	1874	17759000	21691	10865	7	0	\N
333564	1874	17762000	21691	10865	8	0	\N
333565	1874	17765000	21691	10865	10	0	\N
333566	1874	17768000	21691	10865	11	0	\N
333581	1678	23760767896000	21694	10867	0	0	\N
333582	1678	23760767897000	21694	10867	1	0	\N
333583	1874	17776000	21694	10867	2	0	\N
333584	1874	17779000	21694	10867	3	0	\N
333585	1874	17781000	21694	10867	4	0	\N
333586	1874	17783000	21694	10867	5	0	\N
333591	1678	23760767896000	21696	10867	0	0	\N
333592	1678	23760767897000	21696	10867	1	0	\N
333593	1874	17776000	21696	10867	2	0	\N
333594	1874	17779000	21696	10867	3	0	\N
333595	1874	17781000	21696	10867	4	0	\N
333596	1874	17783000	21696	10867	5	0	\N
333602	1678	23760767899000	21698	10869	0	0	\N
333603	1874	17791000	21698	10869	1	0	\N
333604	1874	17793000	21698	10869	2	0	\N
333608	1678	23760767899000	21700	10869	0	0	\N
333518	1874	17743000	21682	10862	2	0	2
333527	588	66783000000000	21685	10863	0	0	0
333528	1678	23760767890000	21685	10863	1	0	0
333529	1874	17745000	21685	10863	2	0	2
333530	1874	17748000	21685	10863	3	0	2
333541	973	507337115000000	21689	10864	1	0	0
333542	1213	613417650000000	21689	10864	2	0	0
333543	1874	17751000	21689	10864	3	0	2
333544	1874	17753000	21689	10864	4	0	2
333567	1093	909143945000000	21692	10865	0	0	0
333569	1678	23760767892000	21692	10865	2	0	0
333570	1678	23760767893000	21692	10865	3	0	0
333571	1678	23760767894000	21692	10865	4	0	0
333572	1874	17755000	21692	10865	5	0	2
333574	1874	17759000	21692	10865	7	0	2
333575	1874	17762000	21692	10865	8	0	2
333576	1874	17765000	21692	10865	10	0	2
333577	1874	17768000	21692	10865	11	0	2
333578	1678	23760767895000	21693	10866	0	0	0
333580	1874	17773000	21693	10866	2	0	2
333587	1678	23760767896000	21695	10867	0	0	0
333588	1678	23760767897000	21695	10867	1	0	0
333589	1874	17776000	21695	10867	2	0	2
333590	1874	17779000	21695	10867	3	0	2
333598	1874	17781000	21697	10868	1	0	2
333599	1874	17783000	21697	10868	2	0	2
333600	1874	17785000	21697	10868	3	0	2
333601	1874	17788000	21697	10868	4	0	2
333606	1874	17791000	21699	10869	1	0	2
333607	1874	17793000	21699	10869	2	0	2
333609	1874	17791000	21700	10869	1	0	\N
333610	1678	23760767899000	21701	10869	0	0	\N
333611	1874	17791000	21701	10869	1	0	\N
333612	1874	17793000	21701	10869	2	0	\N
333630	1678	23760767905000	21705	10872	0	0	\N
333631	1874	17820000	21705	10872	1	0	\N
333632	1874	17823000	21705	10872	2	0	\N
333633	2291	0	21706	10873	0	0	\N
333634	1678	23760767906000	21706	10873	1	0	\N
333635	1678	23760767907000	21706	10873	2	0	\N
333636	1874	17824000	21706	10873	3	0	\N
333637	1874	17827000	21706	10873	4	0	\N
333649	1678	23760767909000	21709	10875	0	0	\N
333650	1678	23760767910000	21709	10875	1	0	\N
333651	1874	17840000	21709	10875	2	0	\N
333652	1874	17842000	21709	10875	3	0	\N
333653	1874	17845000	21709	10875	4	0	\N
333659	1678	23760767909000	21711	10875	0	0	\N
333660	1678	23760767910000	21711	10875	1	0	\N
333661	1874	17841000	21711	10875	2	0	\N
333665	1678	23760767911000	21713	10876	0	0	\N
333666	1874	17848000	21713	10876	1	0	\N
333667	1678	23760767912000	21714	10877	0	0	\N
333668	1678	23760767913000	21714	10877	1	0	\N
333669	1874	17852000	21714	10877	2	0	\N
333670	1874	17855000	21714	10877	3	0	\N
333671	1874	17858000	21714	10877	4	0	\N
333672	1874	17860000	21714	10877	5	0	\N
333673	1678	23760767912000	21715	10877	0	0	\N
333674	1678	23760767913000	21715	10877	1	0	\N
333675	1874	17852000	21715	10877	2	0	\N
333676	1874	17855000	21715	10877	3	0	\N
333677	1874	17858000	21715	10877	4	0	\N
333678	1874	17860000	21715	10877	5	0	\N
333706	1678	23760767920000	21721	10881	0	0	\N
333707	1874	17893000	21721	10881	1	0	\N
333708	1874	17895000	21721	10881	2	0	\N
333712	1678	23760767921000	21723	10882	0	0	\N
333713	1874	17897000	21723	10882	1	0	\N
333714	1874	17900000	21723	10882	2	0	\N
333715	1678	23760767921000	21724	10882	0	0	\N
333716	1874	17897000	21724	10882	1	0	\N
333717	1874	17900000	21724	10882	2	0	\N
333718	1874	17903000	21725	10883	0	0	\N
333719	1874	17905000	21725	10883	1	0	\N
333722	1874	17903000	21727	10883	0	0	\N
333723	1874	17905000	21727	10883	1	0	\N
333726	2291	0	21733	10817	0	0	\N
333727	588	66783000000000	21733	10817	1	0	\N
333728	1678	23040757890000	21733	10817	2	0	\N
333729	1678	23040757891000	21733	10817	3	0	\N
333730	1678	23040757892000	21733	10817	4	0	\N
333731	973	507337115000000	21733	10817	5	0	\N
333732	1678	23040757893000	21733	10817	6	0	\N
333733	1678	23040757894000	21733	10817	7	0	\N
333734	1678	23040757895000	21733	10817	8	0	\N
333735	1678	23040757896000	21733	10817	9	0	\N
333736	1678	23040757897000	21733	10817	10	0	\N
333737	1678	23040757898000	21733	10817	11	0	\N
333738	1678	23040757899000	21733	10817	12	0	\N
333739	1678	23040757900000	21733	10817	13	0	\N
333740	1678	23040757901000	21733	10817	14	0	\N
333741	1678	23040757902000	21733	10817	15	0	\N
333742	1678	23040757903000	21733	10817	16	0	\N
333743	1678	23040757904000	21733	10817	17	0	\N
333744	1678	23040757905000	21733	10817	18	0	\N
333615	1874	17798000	21702	10870	2	0	2
333616	1678	23760767901000	21703	10871	0	0	0
333617	1678	23760767902000	21703	10871	1	0	0
333618	1678	23760767903000	21703	10871	2	0	0
333619	1678	23760767904000	21703	10871	3	0	0
333621	1874	17802000	21703	10871	5	0	2
333622	1874	17804000	21703	10871	6	0	2
333623	1874	17806000	21703	10871	7	0	2
333624	1874	17809000	21703	10871	8	0	2
333625	1874	17812000	21703	10871	9	0	2
333627	1874	17818000	21703	10871	11	0	2
333628	1678	23760767905000	21704	10872	0	0	0
333629	1874	17821000	21704	10872	1	0	2
333638	2291	0	21707	10873	0	0	0
333640	1678	23760767907000	21707	10873	2	0	0
333641	1874	17824000	21707	10873	3	0	2
333642	1874	17826000	21707	10873	4	0	2
333643	1874	17828000	21707	10873	5	0	2
333644	1874	17830000	21707	10873	6	0	2
333646	1678	23760767908000	21708	10874	0	0	0
333647	1874	17835000	21708	10874	1	0	2
333648	1874	17838000	21708	10874	2	0	2
333654	1678	23760767909000	21710	10875	0	0	0
333655	1678	23760767910000	21710	10875	1	0	0
333657	1874	17842000	21710	10875	3	0	2
333658	1874	17845000	21710	10875	4	0	2
333662	1678	23760767911000	21712	10876	0	0	0
333663	1874	17847000	21712	10876	1	0	2
333679	1678	23760767912000	21716	10877	0	0	0
333680	1678	23760767913000	21716	10877	1	0	0
333681	1874	17852000	21716	10877	2	0	2
333682	1874	17855000	21716	10877	3	0	2
333683	1874	17858000	21716	10877	4	0	2
333685	1678	23760767914000	21717	10878	0	0	0
333686	1678	23760767915000	21717	10878	1	0	0
333687	1678	23760767916000	21717	10878	2	0	0
333688	1678	23760767917000	21717	10878	3	0	0
333689	1874	17862000	21717	10878	4	0	2
333691	1874	17868000	21717	10878	6	0	2
333692	1874	17871000	21717	10878	7	0	2
333693	1874	17873000	21717	10878	8	0	2
333694	1874	17875000	21717	10878	9	0	2
333696	1874	17880000	21717	10878	11	0	2
333697	1678	23760767918000	21718	10879	0	0	0
333698	1874	17883000	21718	10879	1	0	2
333699	1874	17885000	21718	10879	2	0	2
333700	1678	23760767919000	21719	10880	0	0	0
333702	1874	17890000	21719	10880	2	0	2
333703	1678	23760767920000	21720	10881	0	0	0
333704	1874	17893000	21720	10881	1	0	2
333705	1874	17895000	21720	10881	2	0	2
333709	1678	23760767921000	21722	10882	0	0	0
333711	1874	17900000	21722	10882	2	0	2
333720	1874	17903000	21726	10883	0	0	2
333721	1874	17905000	21726	10883	1	0	2
333724	1874	17908000	21728	10884	0	0	2
333745	1678	23040757906000	21733	10817	19	0	\N
333746	1678	23040757907000	21733	10817	20	0	\N
333747	1678	23040757908000	21733	10817	21	0	\N
333748	1678	23040757909000	21733	10817	22	0	\N
333749	1678	23040757910000	21733	10817	23	0	\N
333750	1678	23040757911000	21733	10817	24	0	\N
333751	1678	23040757912000	21733	10817	25	0	\N
333752	1678	23040757913000	21733	10817	26	0	\N
333753	1678	23040757914000	21733	10817	27	0	\N
333754	1678	23040757915000	21733	10817	28	0	\N
333755	1678	23040757916000	21733	10817	29	0	\N
333756	1678	23040757917000	21733	10817	30	0	\N
333757	1678	23040757918000	21733	10817	31	0	\N
333758	1678	23040757919000	21733	10817	32	0	\N
333759	1678	23040757920000	21733	10817	33	0	\N
333760	1678	23040757921000	21733	10817	34	0	\N
333761	1213	613417650000000	21733	10817	35	0	\N
333762	1093	909143945000000	21733	10817	36	0	\N
333763	1339	1709341667751650	21733	10817	37	0	\N
333764	1874	17623000	21733	10817	38	0	\N
333765	1874	17626000	21733	10817	39	0	\N
333766	1874	17629000	21733	10817	41	0	\N
333767	1874	17632000	21733	10817	42	0	\N
333768	1874	17635000	21733	10817	43	0	\N
333769	1874	17638000	21733	10817	44	0	\N
333770	1874	17641000	21733	10817	45	0	\N
333771	1874	17644000	21733	10817	46	0	\N
333772	1874	17647000	21733	10817	47	0	\N
333773	1874	17650000	21733	10817	48	0	\N
333774	1874	17653000	21733	10817	49	0	\N
333775	1874	17656000	21733	10817	50	0	\N
333776	1874	17659000	21733	10817	51	0	\N
333777	1874	17662000	21733	10817	52	0	\N
333778	1874	17665000	21733	10817	53	0	\N
333779	1874	17668000	21733	10817	54	0	\N
333780	1874	17671000	21733	10817	55	0	\N
333781	1874	17674000	21733	10817	56	0	\N
333782	1874	17677000	21733	10817	57	0	\N
333783	1874	17680000	21733	10817	58	0	\N
333784	1874	17683000	21733	10817	59	0	\N
333785	1874	17686000	21733	10817	60	0	\N
333786	1874	17689000	21733	10817	61	0	\N
333787	1874	17692000	21733	10817	62	0	\N
333788	1874	17695000	21733	10817	63	0	\N
333789	1874	17698000	21733	10817	64	0	\N
333790	1874	17701000	21733	10817	65	0	\N
333791	1874	17704000	21733	10817	66	0	\N
333792	1874	17707000	21733	10817	67	0	\N
333793	1874	17710000	21733	10817	68	0	\N
333794	1874	17713000	21733	10817	69	0	\N
333795	1874	17716000	21733	10817	70	0	\N
333796	1874	17719000	21733	10817	71	0	\N
333797	1874	17722000	21733	10817	72	0	\N
333798	1874	17725000	21733	10817	73	0	\N
333799	1874	17728000	21733	10817	74	0	\N
333800	1874	17731000	21733	10817	75	0	\N
333801	1874	17734000	21733	10817	76	0	\N
333802	1874	17737000	21733	10817	77	0	\N
333803	1874	17740000	21733	10817	78	0	\N
333804	1874	17743000	21733	10817	79	0	\N
333805	1874	17746000	21733	10817	80	0	\N
333806	1874	17749000	21733	10817	81	0	\N
333807	1874	17752000	21733	10817	82	0	\N
333808	1874	17755000	21733	10817	83	0	\N
333809	1874	17758000	21733	10817	84	0	\N
333810	1874	17761000	21733	10817	85	0	\N
333811	1874	17764000	21733	10817	86	0	\N
333812	1874	17767000	21733	10817	87	0	\N
333813	1874	17770000	21733	10817	88	0	\N
333814	1874	17773000	21733	10817	89	0	\N
333815	1874	17776000	21733	10817	90	0	\N
333816	1874	17779000	21733	10817	91	0	\N
333817	1874	17782000	21733	10817	92	0	\N
333818	1874	17785000	21733	10817	93	0	\N
333819	1874	17788000	21733	10817	94	0	\N
333820	1874	17791000	21733	10817	95	0	\N
333821	1874	17793000	21733	10817	96	0	\N
333822	1874	17795000	21733	10817	97	0	\N
333823	1874	17797000	21733	10817	98	0	\N
333824	1874	17799000	21733	10817	99	0	\N
333825	1874	17801000	21733	10817	100	0	\N
333826	1874	17803000	21733	10817	101	0	\N
333827	1874	17805000	21733	10817	102	0	\N
333828	1874	17807000	21733	10817	103	0	\N
333829	1874	17809000	21733	10817	104	0	\N
333830	1874	17811000	21733	10817	105	0	\N
333831	1874	17813000	21733	10817	106	0	\N
333832	1874	17815000	21733	10817	107	0	\N
333833	1874	17817000	21733	10817	108	0	\N
333834	1874	17819000	21733	10817	109	0	\N
333835	1874	17821000	21733	10817	110	0	\N
333836	1874	17823000	21733	10817	111	0	\N
333837	1874	17825000	21733	10817	112	0	\N
333838	1874	17827000	21733	10817	113	0	\N
333839	1874	17829000	21733	10817	114	0	\N
333840	1874	17831000	21733	10817	115	0	\N
333841	1874	17833000	21733	10817	116	0	\N
333842	1874	17835000	21733	10817	117	0	\N
333843	1874	17837000	21733	10817	118	0	\N
333844	1874	17839000	21733	10817	119	0	\N
333845	1874	17841000	21733	10817	120	0	\N
333846	1874	17843000	21733	10817	121	0	\N
333847	1874	17845000	21733	10817	122	0	\N
333848	1874	17847000	21733	10817	123	0	\N
333849	1874	17849000	21733	10817	124	0	\N
333850	1874	17851000	21733	10817	125	0	\N
333860	1874	17913000	21735	10886	0	0	\N
333861	1442	0	21735	10886	1	0	\N
333862	1874	17916000	21735	10886	2	0	\N
333863	1874	17919000	21735	10886	3	0	\N
333864	1874	17922000	21735	10886	4	0	\N
333865	1874	17924000	21735	10886	5	0	\N
333866	1874	17926000	21735	10886	6	0	\N
333867	1874	17928000	21735	10886	7	0	\N
333868	1874	17930000	21735	10886	8	0	\N
333869	1874	17913000	21736	10886	0	0	\N
333870	1442	0	21736	10886	1	0	\N
333871	1874	17916000	21736	10886	2	0	\N
333872	1874	17919000	21736	10886	3	0	\N
333873	1874	17922000	21736	10886	4	0	\N
333874	1874	17924000	21736	10886	5	0	\N
333875	1874	17926000	21736	10886	6	0	\N
333876	1874	17928000	21736	10886	7	0	\N
333877	1874	17930000	21736	10886	8	0	\N
333878	2291	0	21737	10717	0	0	\N
333879	588	66783000000000	21737	10717	1	0	\N
333880	1678	23040757805000	21737	10717	2	0	\N
333853	1874	17916000	21734	10886	2	0	2
333854	1874	17919000	21734	10886	3	0	2
333855	1874	17922000	21734	10886	4	0	2
333856	1874	17924000	21734	10886	5	0	2
333857	1874	17926000	21734	10886	6	0	2
333859	1874	17930000	21734	10886	8	0	2
333881	1021	507244438919578	21737	10717	3	0	\N
333882	1958	5231186000000	21737	10717	4	0	\N
333883	1483	10000000	21737	10717	5	0	\N
333884	1483	10000000	21737	10717	6	0	\N
333885	1678	23040757806000	21737	10717	7	0	\N
333886	1678	23040757807000	21737	10717	8	0	\N
333887	1508	21968194929693	21737	10717	9	0	\N
333888	2290	100000000	21737	10717	10	0	\N
333889	1678	23040757808000	21737	10717	11	0	\N
333890	1678	23040757809000	21737	10717	12	0	\N
333891	1678	23040757810000	21737	10717	13	0	\N
333892	1678	23040757811000	21737	10717	14	0	\N
333893	1678	23040757812000	21737	10717	15	0	\N
333894	1508	22219764541648	21737	10717	16	0	\N
333895	1678	23040757813000	21737	10717	17	0	\N
333896	1141	908977688473491	21737	10717	18	0	\N
333897	1261	613305359073006	21737	10717	19	0	\N
333898	1387	1709029915128959	21737	10717	20	0	\N
333899	973	507337115000000	21737	10717	21	0	\N
333900	1678	23040757814000	21737	10717	22	0	\N
333901	1678	23040757815000	21737	10717	23	0	\N
333902	1678	23040757816000	21737	10717	24	0	\N
333903	1678	23040757817000	21737	10717	25	0	\N
333904	1678	23040757818000	21737	10717	26	0	\N
333905	1678	23040757819000	21737	10717	27	0	\N
333906	1678	23040757820000	21737	10717	28	0	\N
333907	1678	23040757821000	21737	10717	29	0	\N
333908	1678	23040757822000	21737	10717	30	0	\N
333909	1678	23040757823000	21737	10717	31	0	\N
333910	1678	23040757824000	21737	10717	32	0	\N
333911	1678	23040757825000	21737	10717	33	0	\N
333912	1678	23040757826000	21737	10717	34	0	\N
333913	1678	23040757827000	21737	10717	35	0	\N
333914	1678	23040757828000	21737	10717	36	0	\N
333915	1678	23040757829000	21737	10717	37	0	\N
333916	1678	23040757830000	21737	10717	38	0	\N
333917	1678	23040757831000	21737	10717	39	0	\N
333918	1678	23040757832000	21737	10717	40	0	\N
333919	1678	23040757833000	21737	10717	41	0	\N
333920	1678	23040757834000	21737	10717	42	0	\N
333921	1678	23040757835000	21737	10717	43	0	\N
333922	1678	23040757836000	21737	10717	44	0	\N
333923	1678	23040757837000	21737	10717	45	0	\N
333924	1678	23040757838000	21737	10717	46	0	\N
333925	1678	23040757839000	21737	10717	47	0	\N
333926	1678	23040757840000	21737	10717	48	0	\N
333927	1678	23040757841000	21737	10717	49	0	\N
333928	1678	23040757842000	21737	10717	50	0	\N
333929	1678	23040757843000	21737	10717	51	0	\N
333930	1678	23040757844000	21737	10717	52	0	\N
333931	1678	23040757845000	21737	10717	53	0	\N
333932	1678	23040757846000	21737	10717	54	0	\N
333933	1678	23040757847000	21737	10717	55	0	\N
333934	1678	23040757848000	21737	10717	56	0	\N
333935	1678	23040757849000	21737	10717	57	0	\N
333936	1678	23040757850000	21737	10717	58	0	\N
333937	1678	23040757851000	21737	10717	59	0	\N
333938	1678	23040757852000	21737	10717	60	0	\N
333939	1678	23040757853000	21737	10717	61	0	\N
333940	1678	23040757854000	21737	10717	63	0	\N
333941	1678	23040757855000	21737	10717	64	0	\N
333942	1678	23040757856000	21737	10717	65	0	\N
333943	1678	23040757857000	21737	10717	66	0	\N
333944	1678	23040757858000	21737	10717	67	0	\N
333945	1678	23040757859000	21737	10717	68	0	\N
333946	1678	23040757860000	21737	10717	69	0	\N
333947	1678	23040757861000	21737	10717	70	0	\N
333948	1678	23040757862000	21737	10717	71	0	\N
333949	1678	23040757863000	21737	10717	72	0	\N
333950	1678	23040757864000	21737	10717	73	0	\N
333951	1678	23040757865000	21737	10717	74	0	\N
333952	1678	23040757866000	21737	10717	75	0	\N
333953	1678	23040757867000	21737	10717	76	0	\N
333954	1678	23040757868000	21737	10717	77	0	\N
333955	1678	23040757869000	21737	10717	78	0	\N
333956	1678	23040757870000	21737	10717	79	0	\N
333957	1678	23040757871000	21737	10717	80	0	\N
333958	1678	23040757872000	21737	10717	81	0	\N
333959	1678	23040757873000	21737	10717	82	0	\N
333960	1678	23040757874000	21737	10717	83	0	\N
333961	1678	23040757875000	21737	10717	84	0	\N
333962	1678	23040757876000	21737	10717	85	0	\N
333963	1678	23040757877000	21737	10717	86	0	\N
333964	1678	23040757878000	21737	10717	87	0	\N
333965	1678	23040757879000	21737	10717	88	0	\N
333966	1678	23040757880000	21737	10717	89	0	\N
333967	1678	23040757881000	21737	10717	90	0	\N
333968	1678	23040757882000	21737	10717	91	0	\N
333969	1678	23040757883000	21737	10717	92	0	\N
333970	1678	23040757884000	21737	10717	93	0	\N
333971	1678	23040757885000	21737	10717	94	0	\N
333972	1678	23040757886000	21737	10717	95	0	\N
333973	1678	23040757887000	21737	10717	96	0	\N
333974	1678	23040757888000	21737	10717	97	0	\N
333975	1678	23040757889000	21737	10717	98	0	\N
333976	1678	23040757890000	21737	10717	99	0	\N
333977	1678	23040757891000	21737	10717	100	0	\N
333978	1678	23040757892000	21737	10717	101	0	\N
333979	1678	23040757893000	21737	10717	102	0	\N
333980	1678	23040757894000	21737	10717	103	0	\N
333981	1678	23040757895000	21737	10717	104	0	\N
333982	1678	23040757896000	21737	10717	105	0	\N
333983	1678	23040757897000	21737	10717	106	0	\N
333984	1678	23040757898000	21737	10717	107	0	\N
333985	1678	23040757899000	21737	10717	108	0	\N
333986	1678	23040757900000	21737	10717	109	0	\N
333987	1678	23040757901000	21737	10717	110	0	\N
333988	1678	23040757902000	21737	10717	111	0	\N
333989	1678	23040757903000	21737	10717	112	0	\N
333990	1678	23040757904000	21737	10717	113	0	\N
333991	1678	23040757905000	21737	10717	114	0	\N
333992	1678	23040757906000	21737	10717	115	0	\N
333993	1678	23040757907000	21737	10717	116	0	\N
333994	1678	23040757908000	21737	10717	117	0	\N
333995	1678	23040757909000	21737	10717	118	0	\N
333996	1678	23040757910000	21737	10717	119	0	\N
333997	1678	23040757911000	21737	10717	120	0	\N
333998	1678	23040757912000	21737	10717	121	0	\N
333999	1678	23040757913000	21737	10717	122	0	\N
334000	1678	23040757914000	21737	10717	123	0	\N
334001	1678	23040757915000	21737	10717	124	0	\N
334002	1678	23040757916000	21737	10717	125	0	\N
334009	1678	23760767922000	21739	10887	0	0	\N
334010	1678	23760767923000	21739	10887	1	0	\N
334011	1874	17933000	21739	10887	2	0	\N
334012	1874	17936000	21739	10887	3	0	\N
334013	1874	17938000	21739	10887	4	0	\N
334014	1874	17940000	21739	10887	5	0	\N
334015	1678	23760767922000	21740	10887	0	0	\N
334016	1678	23760767923000	21740	10887	1	0	\N
334005	1874	17933000	21738	10887	2	0	2
334006	1874	17936000	21738	10887	3	0	2
334007	1874	17938000	21738	10887	4	0	2
334008	1874	17940000	21738	10887	5	0	2
334017	1874	17933000	21740	10887	2	0	\N
334018	1874	17936000	21740	10887	3	0	\N
334019	1874	17938000	21740	10887	4	0	\N
334020	1874	17940000	21740	10887	5	0	\N
334021	1678	23760767922000	21741	10887	0	0	\N
334022	1678	23760767923000	21741	10887	1	0	\N
334023	1874	17933000	21741	10887	2	0	\N
334024	1874	17936000	21741	10887	3	0	\N
334025	1874	17938000	21741	10887	4	0	\N
334026	1874	17940000	21741	10887	5	0	\N
334027	1678	23760767924000	21742	10888	0	0	\N
334028	1874	17943000	21742	10888	1	0	\N
334029	1874	17945000	21742	10888	2	0	\N
334030	1678	23760767924000	21743	10888	0	0	\N
334031	1874	17943000	21743	10888	1	0	\N
334032	1874	17945000	21743	10888	2	0	\N
334033	1678	23760767924000	21744	10888	0	0	\N
334034	1874	17943000	21744	10888	1	0	\N
334035	1874	17945000	21744	10888	2	0	\N
334045	1678	23760767926000	21748	10890	0	0	\N
334046	1874	17953000	21748	10890	1	0	\N
334047	1874	17955000	21748	10890	2	0	\N
334051	1678	23760767927000	21750	10891	0	0	\N
334052	1874	17957000	21750	10891	1	0	\N
334053	1874	17960000	21750	10891	2	0	\N
334057	1678	23760767928000	21752	10892	0	0	\N
334058	1874	17963000	21752	10892	1	0	\N
334059	1874	17965000	21752	10892	2	0	\N
334060	2291	0	21753	10870	0	0	\N
334061	1678	23760767900000	21753	10870	1	0	\N
334062	1678	23760767901000	21753	10870	2	0	\N
334063	1678	23760767902000	21753	10870	3	0	\N
334064	1678	23760767903000	21753	10870	4	0	\N
334065	1678	23760767904000	21753	10870	5	0	\N
334066	1678	23760767905000	21753	10870	6	0	\N
334067	1678	23760767906000	21753	10870	7	0	\N
334068	1678	23760767907000	21753	10870	8	0	\N
334069	1678	23760767908000	21753	10870	9	0	\N
334070	1678	23760767909000	21753	10870	10	0	\N
334071	1678	23760767910000	21753	10870	11	0	\N
334072	1678	23760767911000	21753	10870	12	0	\N
334073	1678	23760767912000	21753	10870	13	0	\N
334074	1678	23760767913000	21753	10870	14	0	\N
334075	1678	23760767914000	21753	10870	15	0	\N
334076	1678	23760767915000	21753	10870	16	0	\N
334077	1678	23760767916000	21753	10870	17	0	\N
334078	1678	23760767917000	21753	10870	18	0	\N
334079	1678	23760767918000	21753	10870	19	0	\N
334080	1678	23760767919000	21753	10870	20	0	\N
334081	1678	23760767920000	21753	10870	21	0	\N
334082	1678	23760767921000	21753	10870	22	0	\N
334083	1678	23760767922000	21753	10870	23	0	\N
334084	1678	23760767923000	21753	10870	24	0	\N
334085	1678	23760767924000	21753	10870	25	0	\N
334086	1678	23760767925000	21753	10870	26	0	\N
334087	1678	23760767926000	21753	10870	27	0	\N
334088	1678	23760767927000	21753	10870	28	0	\N
334089	1678	23760767928000	21753	10870	29	0	\N
334090	1874	17796000	21753	10870	30	0	\N
334091	1442	0	21753	10870	31	0	\N
334092	1874	17799000	21753	10870	32	0	\N
334093	1874	17802000	21753	10870	33	0	\N
334094	1874	17805000	21753	10870	34	0	\N
334095	1874	17808000	21753	10870	35	0	\N
334096	1874	17811000	21753	10870	36	0	\N
334097	1874	17814000	21753	10870	37	0	\N
334098	1874	17817000	21753	10870	38	0	\N
334099	1874	17820000	21753	10870	39	0	\N
334100	1874	17823000	21753	10870	40	0	\N
334101	1874	17826000	21753	10870	41	0	\N
334102	1874	17829000	21753	10870	42	0	\N
334103	1874	17832000	21753	10870	43	0	\N
334104	1874	17835000	21753	10870	44	0	\N
334105	1874	17838000	21753	10870	45	0	\N
334106	1874	17841000	21753	10870	46	0	\N
334107	1874	17844000	21753	10870	47	0	\N
334108	1874	17847000	21753	10870	48	0	\N
334109	1874	17850000	21753	10870	49	0	\N
334110	1874	17853000	21753	10870	50	0	\N
334111	1874	17856000	21753	10870	51	0	\N
334112	1874	17859000	21753	10870	52	0	\N
334113	1874	17862000	21753	10870	53	0	\N
334114	1874	17865000	21753	10870	54	0	\N
334115	1874	17868000	21753	10870	55	0	\N
334116	1874	17871000	21753	10870	56	0	\N
334117	1874	17874000	21753	10870	57	0	\N
334118	1874	17877000	21753	10870	58	0	\N
334119	1874	17880000	21753	10870	59	0	\N
334120	1874	17883000	21753	10870	60	0	\N
334121	1874	17886000	21753	10870	61	0	\N
334122	1874	17889000	21753	10870	62	0	\N
334123	1874	17892000	21753	10870	63	0	\N
334124	1874	17895000	21753	10870	64	0	\N
334125	1874	17897000	21753	10870	65	0	\N
334126	1874	17899000	21753	10870	66	0	\N
334127	1874	17901000	21753	10870	67	0	\N
334128	1874	17903000	21753	10870	68	0	\N
334129	1874	17905000	21753	10870	69	0	\N
334130	1874	17907000	21753	10870	70	0	\N
334131	1874	17909000	21753	10870	71	0	\N
334132	1874	17911000	21753	10870	72	0	\N
334133	1874	17913000	21753	10870	73	0	\N
334134	1874	17915000	21753	10870	74	0	\N
334135	1874	17917000	21753	10870	75	0	\N
334136	1874	17919000	21753	10870	76	0	\N
334137	1874	17921000	21753	10870	77	0	\N
334138	1874	17923000	21753	10870	78	0	\N
334139	1874	17925000	21753	10870	79	0	\N
334140	1874	17927000	21753	10870	80	0	\N
334141	1874	17929000	21753	10870	81	0	\N
334142	1874	17931000	21753	10870	82	0	\N
334143	1874	17933000	21753	10870	83	0	\N
334144	1874	17935000	21753	10870	84	0	\N
334145	1874	17937000	21753	10870	85	0	\N
334146	1874	17939000	21753	10870	86	0	\N
334147	1874	17941000	21753	10870	87	0	\N
334148	1874	17943000	21753	10870	88	0	\N
334149	1874	17945000	21753	10870	89	0	\N
334150	1874	17947000	21753	10870	90	0	\N
334151	1874	17949000	21753	10870	91	0	\N
334152	1874	17951000	21753	10870	92	0	\N
334038	1874	17945000	21745	10888	2	0	2
334039	1678	23760767925000	21746	10889	0	0	0
334040	1874	17948000	21746	10889	1	0	2
334041	1874	17950000	21746	10889	2	0	2
334042	1678	23760767926000	21747	10890	0	0	0
334044	1874	17955000	21747	10890	2	0	2
334048	1678	23760767927000	21749	10891	0	0	0
334049	1874	17957000	21749	10891	1	0	2
334050	1874	17960000	21749	10891	2	0	2
334054	1678	23760767928000	21751	10892	0	0	0
334056	1874	17965000	21751	10892	2	0	2
334153	1874	17953000	21753	10870	93	0	\N
334154	1874	17955000	21753	10870	94	0	\N
334155	1874	17957000	21753	10870	95	0	\N
334156	1874	17959000	21753	10870	96	0	\N
334157	1874	17961000	21753	10870	97	0	\N
334158	1874	17963000	21753	10870	98	0	\N
334159	1874	17965000	21753	10870	99	0	\N
334160	2291	0	21754	10766	0	0	\N
334161	588	66783000000000	21754	10766	1	0	\N
334162	973	507337115000000	21754	10766	2	0	\N
334163	1213	613417650000000	21754	10766	3	0	\N
334164	1093	909143945000000	21754	10766	4	0	\N
334165	1339	1709341667751650	21754	10766	5	0	\N
334166	1442	0	21754	10766	6	0	\N
334170	1678	23760767929000	21756	10893	0	0	\N
334171	1874	17967000	21756	10893	1	0	\N
334172	1874	17970000	21756	10893	2	0	\N
334179	1678	23760767929000	21759	10871	0	0	\N
334180	1678	23760767930000	21759	10871	1	0	\N
334181	1678	23760767931000	21759	10871	2	0	\N
334182	1874	17967000	21759	10871	3	0	\N
334183	1874	17969000	21759	10871	4	0	\N
334184	1874	17971000	21759	10871	5	0	\N
334185	1874	17974000	21759	10871	6	0	\N
334186	1874	17977000	21759	10871	7	0	\N
334187	1874	17980000	21759	10871	8	0	\N
334190	1678	23760767932000	21761	10896	0	0	\N
334191	1874	17983000	21761	10896	1	0	\N
334192	1874	17985000	21761	10896	2	0	\N
334193	1678	23760767932000	21762	10896	0	0	\N
334194	1874	17983000	21762	10896	1	0	\N
334195	1874	17985000	21762	10896	2	0	\N
334203	1678	23760767934000	21766	10898	0	0	\N
334204	1874	17993000	21766	10898	1	0	\N
334205	1874	17995000	21766	10898	2	0	\N
334206	1678	23760767935000	21767	10899	0	0	\N
334207	1678	23760767936000	21767	10899	1	0	\N
334208	1874	17998000	21767	10899	2	0	\N
334209	1874	18000000	21767	10899	3	0	\N
334210	1874	18002000	21767	10899	4	0	\N
334211	1874	18005000	21767	10899	5	0	\N
334218	1678	23760767935000	21769	10899	0	0	\N
334219	1678	23760767936000	21769	10899	1	0	\N
334220	1874	17998000	21769	10899	2	0	\N
334221	1874	18000000	21769	10899	3	0	\N
334222	1874	18002000	21769	10899	4	0	\N
334223	1874	18005000	21769	10899	5	0	\N
334224	1678	23760767937000	21770	10900	0	0	\N
334225	1874	18008000	21770	10900	1	0	\N
334226	1874	18010000	21770	10900	2	0	\N
334233	1678	23760767938000	21773	10901	0	0	\N
334234	1874	18013000	21773	10901	1	0	\N
334235	1874	18015000	21773	10901	2	0	\N
334248	1678	23040757922000	21776	10818	0	0	\N
334249	1678	23040757923000	21776	10818	1	0	\N
334250	1678	23040757924000	21776	10818	2	0	\N
334251	1678	23040757925000	21776	10818	3	0	\N
334252	1678	23040757926000	21776	10818	4	0	\N
334253	1678	23040757927000	21776	10818	5	0	\N
334254	1678	23040757928000	21776	10818	6	0	\N
334255	1678	23040757929000	21776	10818	7	0	\N
334256	1678	23040757930000	21776	10818	8	0	\N
334257	1678	23040757931000	21776	10818	9	0	\N
334258	1678	23040757932000	21776	10818	10	0	\N
334259	1678	23040757933000	21776	10818	11	0	\N
334260	1678	23040757934000	21776	10818	12	0	\N
334261	1678	23040757935000	21776	10818	13	0	\N
334262	1678	23040757936000	21776	10818	14	0	\N
334263	1678	23040757937000	21776	10818	15	0	\N
334264	1678	23040757938000	21776	10818	16	0	\N
334265	1678	23040757939000	21776	10818	17	0	\N
334266	1678	23040757940000	21776	10818	18	0	\N
334267	1678	23040757941000	21776	10818	19	0	\N
334268	1678	23040757942000	21776	10818	20	0	\N
334269	1678	23040757943000	21776	10818	21	0	\N
334270	1874	17853000	21776	10818	22	0	\N
334271	1874	17855000	21776	10818	23	0	\N
334272	1442	0	21776	10818	24	0	\N
334273	1874	17858000	21776	10818	25	0	\N
334274	1874	17861000	21776	10818	26	0	\N
334275	1874	17864000	21776	10818	27	0	\N
334276	1874	17867000	21776	10818	28	0	\N
334277	1874	17869000	21776	10818	29	0	\N
334278	1874	17871000	21776	10818	30	0	\N
334279	1874	17873000	21776	10818	31	0	\N
334280	1874	17875000	21776	10818	32	0	\N
334281	1874	17877000	21776	10818	33	0	\N
334282	1874	17880000	21776	10818	34	0	\N
334283	1874	17883000	21776	10818	35	0	\N
334284	1874	17886000	21776	10818	36	0	\N
334285	1874	17889000	21776	10818	37	0	\N
334286	1874	17892000	21776	10818	38	0	\N
334287	1874	17895000	21776	10818	39	0	\N
334288	1874	17898000	21776	10818	41	0	\N
334169	1874	17970000	21755	10893	2	0	2
334173	1678	23760767930000	21757	10894	0	0	0
334174	1874	17972000	21757	10894	1	0	2
334175	1874	17975000	21757	10894	2	0	2
334176	1678	23760767931000	21758	10895	0	0	0
334178	1874	17980000	21758	10895	2	0	2
334188	1678	23760767932000	21760	10896	0	0	0
334189	1874	17983000	21760	10896	1	0	2
334196	1678	23760767933000	21763	10897	0	0	0
334197	1874	17985000	21763	10897	1	0	2
334199	1874	17990000	21763	10897	3	0	2
334200	1678	23760767934000	21765	10898	0	0	0
334201	1874	17993000	21765	10898	1	0	2
334202	1874	17995000	21765	10898	2	0	2
334213	1678	23760767936000	21768	10899	1	0	0
334214	1874	17998000	21768	10899	2	0	2
334215	1874	18000000	21768	10899	3	0	2
334216	1874	18002000	21768	10899	4	0	2
334217	1874	18005000	21768	10899	5	0	2
334228	1874	18008000	21771	10900	1	0	2
334229	1874	18010000	21771	10900	2	0	2
334230	1678	23760767938000	21772	10901	0	0	0
334231	1874	18013000	21772	10901	1	0	2
334232	1874	18015000	21772	10901	2	0	2
334237	1874	18018000	21774	10902	1	0	2
334238	1874	18020000	21774	10902	2	0	2
334239	1678	23760767940000	21775	10903	0	0	0
334240	1678	23760767941000	21775	10903	1	0	0
334242	1874	18022000	21775	10903	3	0	2
334243	1874	18024000	21775	10903	4	0	2
334244	1874	18026000	21775	10903	5	0	2
334245	1874	18029000	21775	10903	6	0	2
334246	1874	18032000	21775	10903	7	0	2
334289	1874	17901000	21776	10818	42	0	\N
334290	1874	17904000	21776	10818	43	0	\N
334291	1874	17907000	21776	10818	44	0	\N
334292	1874	17910000	21776	10818	45	0	\N
334293	1874	17913000	21776	10818	46	0	\N
334294	1874	17916000	21776	10818	47	0	\N
334295	1874	17919000	21776	10818	48	0	\N
334296	1874	17922000	21776	10818	49	0	\N
334297	1874	17925000	21776	10818	50	0	\N
334298	1874	17928000	21776	10818	51	0	\N
334299	1874	17930000	21776	10818	52	0	\N
334300	1874	17932000	21776	10818	53	0	\N
334301	1874	17934000	21776	10818	54	0	\N
334302	1874	17936000	21776	10818	55	0	\N
334303	1874	17938000	21776	10818	56	0	\N
334304	1874	17940000	21776	10818	57	0	\N
334305	1874	17942000	21776	10818	58	0	\N
334306	1874	17944000	21776	10818	59	0	\N
334307	1874	17946000	21776	10818	60	0	\N
334308	1874	17948000	21776	10818	61	0	\N
334309	1874	17950000	21776	10818	62	0	\N
334310	1874	17952000	21776	10818	63	0	\N
334311	1874	17954000	21776	10818	64	0	\N
334312	1874	17957000	21776	10818	65	0	\N
334313	1874	17960000	21776	10818	66	0	\N
334314	1874	17963000	21776	10818	67	0	\N
334315	1874	17966000	21776	10818	68	0	\N
334316	1874	17968000	21776	10818	69	0	\N
334326	1678	23760767946000	21780	10906	0	0	\N
334327	1874	18052000	21780	10906	1	0	\N
334328	1874	18055000	21780	10906	2	0	\N
334329	1678	23760767946000	21781	10906	0	0	\N
334330	1874	18052000	21781	10906	1	0	\N
334331	1874	18055000	21781	10906	2	0	\N
334332	1678	23760767946000	21783	10906	0	0	\N
334333	1874	18052000	21783	10906	1	0	\N
334334	1874	18055000	21783	10906	2	0	\N
334337	1678	23760767946000	21785	10906	0	0	\N
334338	1874	18052000	21785	10906	1	0	\N
334339	1874	18055000	21785	10906	2	0	\N
334346	1678	23760767948000	21788	10908	0	0	\N
334347	1874	18059000	21788	10908	1	0	\N
334348	1874	18062000	21788	10908	2	0	\N
334349	1678	23760767949000	21789	10909	0	0	\N
334350	1678	23760767950000	21789	10909	1	0	\N
334351	1874	18065000	21789	10909	2	0	\N
334352	1874	18067000	21789	10909	3	0	\N
334353	1874	18069000	21789	10909	4	0	\N
334354	1874	18071000	21789	10909	5	0	\N
334355	1874	18074000	21789	10909	6	0	\N
334356	1874	18077000	21789	10909	7	0	\N
334365	1678	23760767951000	21791	10910	0	0	\N
334366	1318	1710516637751650	21791	10910	1	0	\N
334367	1072	910057465000000	21791	10910	2	0	\N
334368	1192	614032750000000	21791	10910	3	0	\N
334369	1874	18079000	21791	10910	4	0	\N
334370	952	507686775000000	21791	10910	5	0	\N
334371	1874	18082000	21791	10910	6	0	\N
334372	1678	23760767931000	21792	10895	0	0	\N
334373	1678	23760767932000	21792	10895	1	0	\N
334374	1678	23760767933000	21792	10895	2	0	\N
334375	1678	23760767934000	21792	10895	3	0	\N
334376	1678	23760767935000	21792	10895	4	0	\N
334377	1678	23760767936000	21792	10895	5	0	\N
334378	1678	23760767937000	21792	10895	6	0	\N
334379	1678	23760767938000	21792	10895	7	0	\N
334380	1678	23760767939000	21792	10895	8	0	\N
334381	1678	23760767940000	21792	10895	9	0	\N
334382	1678	23760767941000	21792	10895	10	0	\N
334383	1678	23760767942000	21792	10895	11	0	\N
334384	1678	23760767943000	21792	10895	12	0	\N
334385	1678	23760767944000	21792	10895	13	0	\N
334386	1678	23760767945000	21792	10895	14	0	\N
334387	1678	23760767946000	21792	10895	15	0	\N
334388	1678	23760767947000	21792	10895	16	0	\N
334389	1678	23760767948000	21792	10895	17	0	\N
334390	1678	23760767949000	21792	10895	18	0	\N
334391	1678	23760767950000	21792	10895	19	0	\N
334392	1678	23760767951000	21792	10895	20	0	\N
334393	1874	17978000	21792	10895	21	0	\N
334394	1874	17981000	21792	10895	22	0	\N
334395	1874	17984000	21792	10895	23	0	\N
334396	1874	17987000	21792	10895	24	0	\N
334397	1874	17990000	21792	10895	25	0	\N
334398	1318	1710516637751650	21792	10895	26	0	\N
334399	1072	910057465000000	21792	10895	27	0	\N
334400	1192	614032750000000	21792	10895	28	0	\N
334401	952	507686775000000	21792	10895	29	0	\N
334402	1874	17992000	21792	10895	30	0	\N
334403	1874	17994000	21792	10895	31	0	\N
334404	1874	17997000	21792	10895	32	0	\N
334405	1874	18000000	21792	10895	33	0	\N
334406	1874	18003000	21792	10895	34	0	\N
334407	1874	18006000	21792	10895	35	0	\N
334408	1874	18008000	21792	10895	36	0	\N
334409	1874	18010000	21792	10895	37	0	\N
334410	1874	18012000	21792	10895	38	0	\N
334411	1874	18014000	21792	10895	39	0	\N
334412	1874	18016000	21792	10895	40	0	\N
334413	1874	18018000	21792	10895	41	0	\N
334414	1874	18021000	21792	10895	42	0	\N
334415	1874	18024000	21792	10895	43	0	\N
334416	1874	18027000	21792	10895	44	0	\N
334417	1874	18030000	21792	10895	45	0	\N
334418	1874	18033000	21792	10895	46	0	\N
334419	1874	18036000	21792	10895	47	0	\N
334420	1874	18039000	21792	10895	48	0	\N
334421	1874	18042000	21792	10895	49	0	\N
334422	1874	18045000	21792	10895	50	0	\N
334423	1874	18048000	21792	10895	51	0	\N
334424	1874	18051000	21792	10895	52	0	\N
334319	1874	18038000	21777	10904	2	0	2
334320	1874	18041000	21777	10904	3	0	2
334321	1874	18043000	21777	10904	4	0	2
334322	1874	18045000	21777	10904	5	0	2
334323	1678	23760767945000	21779	10905	0	0	0
334325	1874	18050000	21779	10905	2	0	2
334335	1678	23760767946000	21784	10906	0	0	0
334336	1874	18053000	21784	10906	1	0	2
334340	1678	23760767947000	21786	10907	0	0	0
334341	1874	18055000	21786	10907	1	0	2
334343	1678	23760767948000	21787	10908	0	0	0
334344	1874	18059000	21787	10908	1	0	2
334345	1874	18062000	21787	10908	2	0	2
334357	1678	23760767949000	21790	10909	0	0	0
334359	1874	18065000	21790	10909	2	0	2
334360	1874	18067000	21790	10909	3	0	2
334361	1874	18069000	21790	10909	4	0	2
334362	1874	18071000	21790	10909	5	0	2
334363	1874	18074000	21790	10909	6	0	2
334425	1874	18054000	21792	10895	53	0	\N
334426	1874	18056000	21792	10895	54	0	\N
334427	1874	18058000	21792	10895	55	0	\N
334428	1874	18060000	21792	10895	56	0	\N
334429	1874	18062000	21792	10895	57	0	\N
334430	1874	18064000	21792	10895	58	0	\N
334431	1874	18066000	21792	10895	59	0	\N
334432	1874	18068000	21792	10895	60	0	\N
334433	1874	18070000	21792	10895	61	0	\N
334434	1874	18072000	21792	10895	62	0	\N
334435	1874	18074000	21792	10895	63	0	\N
334436	1874	18076000	21792	10895	64	0	\N
334437	1874	18078000	21792	10895	65	0	\N
334438	1874	18080000	21792	10895	66	0	\N
334439	1874	18082000	21792	10895	67	0	\N
334453	2291	0	21795	10839	0	0	\N
334454	588	66783000000000	21795	10839	1	0	\N
334455	1958	5231186000000	21795	10839	2	0	\N
334456	1483	10000000	21795	10839	3	0	\N
334457	1483	10000000	21795	10839	4	0	\N
334458	1508	22688206929693	21795	10839	5	0	\N
334459	2290	100000000	21795	10839	6	0	\N
334460	1508	22939776541648	21795	10839	7	0	\N
334461	1678	23760767862000	21795	10839	8	0	\N
334462	1678	23760767863000	21795	10839	9	0	\N
334463	1678	23760767864000	21795	10839	10	0	\N
334464	1678	23760767865000	21795	10839	11	0	\N
334465	1678	23760767866000	21795	10839	12	0	\N
334466	1678	23760767867000	21795	10839	13	0	\N
334467	1678	23760767868000	21795	10839	14	0	\N
334468	1678	23760767869000	21795	10839	15	0	\N
334469	1678	23760767870000	21795	10839	16	0	\N
334470	1678	23760767871000	21795	10839	17	0	\N
334471	1678	23760767872000	21795	10839	18	0	\N
334472	1678	23760767873000	21795	10839	19	0	\N
334473	1678	23760767874000	21795	10839	20	0	\N
334474	1678	23760767875000	21795	10839	21	0	\N
334475	1678	23760767876000	21795	10839	22	0	\N
334476	1678	23760767877000	21795	10839	23	0	\N
334477	1678	23760767878000	21795	10839	24	0	\N
334478	1678	23760767879000	21795	10839	25	0	\N
334479	1678	23760767880000	21795	10839	26	0	\N
334480	1678	23760767881000	21795	10839	27	0	\N
334481	1678	23760767882000	21795	10839	28	0	\N
334482	1678	23760767883000	21795	10839	29	0	\N
334483	1678	23760767884000	21795	10839	30	0	\N
334484	1678	23760767885000	21795	10839	31	0	\N
334485	1678	23760767886000	21795	10839	32	0	\N
334486	1678	23760767887000	21795	10839	33	0	\N
334487	1678	23760767888000	21795	10839	34	0	\N
334488	1678	23760767889000	21795	10839	35	0	\N
334489	1678	23760767890000	21795	10839	36	0	\N
334490	1678	23760767891000	21795	10839	37	0	\N
334491	1141	908977688473491	21795	10839	38	0	\N
334492	1261	613305359073006	21795	10839	40	0	\N
334493	1387	1709029915128959	21795	10839	41	0	\N
334494	1678	23760767892000	21795	10839	42	0	\N
334495	973	507337115000000	21795	10839	43	0	\N
334496	1678	23760767893000	21795	10839	44	0	\N
334497	1678	23760767894000	21795	10839	45	0	\N
334498	1678	23760767895000	21795	10839	46	0	\N
334499	1678	23760767896000	21795	10839	47	0	\N
334500	1678	23760767897000	21795	10839	48	0	\N
334501	1678	23760767898000	21795	10839	49	0	\N
334502	1678	23760767899000	21795	10839	50	0	\N
334503	1678	23760767900000	21795	10839	51	0	\N
334504	1678	23760767901000	21795	10839	52	0	\N
334505	1678	23760767902000	21795	10839	53	0	\N
334506	1678	23760767903000	21795	10839	54	0	\N
334507	1678	23760767904000	21795	10839	55	0	\N
334508	1678	23760767905000	21795	10839	56	0	\N
334509	1678	23760767906000	21795	10839	57	0	\N
334510	1678	23760767907000	21795	10839	58	0	\N
334511	1678	23760767908000	21795	10839	59	0	\N
334512	1678	23760767909000	21795	10839	60	0	\N
334513	1678	23760767910000	21795	10839	61	0	\N
334514	1678	23760767911000	21795	10839	62	0	\N
334515	1678	23760767912000	21795	10839	63	0	\N
334516	1678	23760767913000	21795	10839	64	0	\N
334517	1678	23760767914000	21795	10839	65	0	\N
334518	1678	23760767915000	21795	10839	66	0	\N
334519	1678	23760767916000	21795	10839	67	0	\N
334520	1678	23760767917000	21795	10839	68	0	\N
334521	1678	23760767918000	21795	10839	69	0	\N
334522	1678	23760767919000	21795	10839	70	0	\N
334523	1678	23760767920000	21795	10839	71	0	\N
334524	1678	23760767921000	21795	10839	72	0	\N
334525	1678	23760767922000	21795	10839	73	0	\N
334526	1678	23760767923000	21795	10839	74	0	\N
334527	1678	23760767924000	21795	10839	75	0	\N
334528	1678	23760767925000	21795	10839	76	0	\N
334529	1678	23760767926000	21795	10839	77	0	\N
334530	1678	23760767927000	21795	10839	78	0	\N
334531	1678	23760767928000	21795	10839	79	0	\N
334532	1678	23760767929000	21795	10839	80	0	\N
334533	1678	23760767930000	21795	10839	81	0	\N
334534	1678	23760767931000	21795	10839	82	0	\N
334535	1678	23760767932000	21795	10839	83	0	\N
334536	1678	23760767933000	21795	10839	84	0	\N
334537	1678	23760767934000	21795	10839	85	0	\N
334538	1678	23760767935000	21795	10839	86	0	\N
334539	1678	23760767936000	21795	10839	87	0	\N
334540	1678	23760767937000	21795	10839	88	0	\N
334541	1678	23760767938000	21795	10839	89	0	\N
334542	1678	23760767939000	21795	10839	90	0	\N
334543	1678	23760767940000	21795	10839	91	0	\N
334544	1678	23760767941000	21795	10839	92	0	\N
334545	1678	23760767942000	21795	10839	93	0	\N
334546	1678	23760767943000	21795	10839	94	0	\N
334547	1678	23760767944000	21795	10839	95	0	\N
334548	1678	23760767945000	21795	10839	96	0	\N
334549	1678	23760767946000	21795	10839	97	0	\N
334550	1678	23760767947000	21795	10839	98	0	\N
334551	1678	23760767948000	21795	10839	99	0	\N
334552	1678	23760767949000	21795	10839	100	0	\N
334553	1678	23760767950000	21795	10839	101	0	\N
334554	1678	23760767951000	21795	10839	102	0	\N
334555	1678	23760767952000	21795	10839	103	0	\N
334556	1678	23760767953000	21795	10839	104	0	\N
334557	1678	23760767954000	21795	10839	105	0	\N
334558	1213	613417650000000	21795	10839	106	0	\N
334559	1093	909143945000000	21795	10839	107	0	\N
334560	1339	1709341667751650	21795	10839	108	0	\N
334442	1072	910057465000000	21793	10910	2	0	0
334443	1192	614032750000000	21793	10910	3	0	0
334444	1874	18079000	21793	10910	4	0	2
334445	952	507686775000000	21793	10910	5	0	0
334446	1874	18082000	21793	10910	6	0	2
334448	1678	23760767953000	21794	10911	1	0	0
334449	1874	18084000	21794	10911	2	0	2
334450	1874	18086000	21794	10911	3	0	2
334451	1874	18089000	21794	10911	4	0	2
334452	1874	18092000	21794	10911	5	0	2
334561	1874	17601000	21795	10839	109	0	\N
334562	1874	17604000	21795	10839	110	0	\N
334563	1442	0	21795	10839	111	0	\N
334564	1318	1710516637751650	21795	10839	112	0	\N
334565	1072	910057465000000	21795	10839	113	0	\N
334566	1192	614032750000000	21795	10839	114	0	\N
334567	1874	17606000	21795	10839	115	0	\N
334568	1874	17608000	21795	10839	116	0	\N
334569	952	507686775000000	21795	10839	117	0	\N
334570	1874	17611000	21795	10839	118	0	\N
334571	1874	17614000	21795	10839	119	0	\N
334572	1874	17617000	21795	10839	120	0	\N
334573	1874	17620000	21795	10839	121	0	\N
334574	1874	17623000	21795	10839	122	0	\N
334575	1874	17626000	21795	10839	123	0	\N
334576	1874	17629000	21795	10839	124	0	\N
334577	1874	17632000	21795	10839	125	0	\N
334578	1678	23760767921000	21796	10882	0	0	\N
334579	1678	23760767922000	21796	10882	1	0	\N
334580	1678	23760767923000	21796	10882	2	0	\N
334581	1678	23760767924000	21796	10882	3	0	\N
334582	1678	23760767925000	21796	10882	4	0	\N
334583	1678	23760767926000	21796	10882	5	0	\N
334584	1678	23760767927000	21796	10882	6	0	\N
334585	1678	23760767928000	21796	10882	7	0	\N
334586	1678	23760767929000	21796	10882	8	0	\N
334587	1678	23760767930000	21796	10882	9	0	\N
334588	1678	23760767931000	21796	10882	10	0	\N
334589	1678	23760767932000	21796	10882	11	0	\N
334590	1678	23760767933000	21796	10882	12	0	\N
334591	1678	23760767934000	21796	10882	14	0	\N
334592	1678	23760767935000	21796	10882	15	0	\N
334593	1678	23760767936000	21796	10882	16	0	\N
334594	1678	23760767937000	21796	10882	17	0	\N
334595	1678	23760767938000	21796	10882	18	0	\N
334596	1678	23760767939000	21796	10882	19	0	\N
334597	1678	23760767940000	21796	10882	20	0	\N
334598	1678	23760767941000	21796	10882	21	0	\N
334599	1678	23760767942000	21796	10882	22	0	\N
334600	1678	23760767943000	21796	10882	23	0	\N
334601	1678	23760767944000	21796	10882	24	0	\N
334602	1678	23760767945000	21796	10882	25	0	\N
334603	1678	23760767946000	21796	10882	26	0	\N
334604	1678	23760767947000	21796	10882	27	0	\N
334605	1678	23760767948000	21796	10882	28	0	\N
334606	1678	23760767949000	21796	10882	29	0	\N
334607	1678	23760767950000	21796	10882	30	0	\N
334608	1678	23760767951000	21796	10882	31	0	\N
334609	1678	23760767952000	21796	10882	32	0	\N
334610	1678	23760767953000	21796	10882	33	0	\N
334611	1678	23760767954000	21796	10882	34	0	\N
334612	1874	17897000	21796	10882	35	0	\N
334613	1442	0	21796	10882	36	0	\N
334614	1318	1710516637751650	21796	10882	37	0	\N
334615	1072	910057465000000	21796	10882	38	0	\N
334616	1192	614032750000000	21796	10882	39	0	\N
334617	952	507686775000000	21796	10882	40	0	\N
334618	1874	17900000	21796	10882	41	0	\N
334619	1874	17903000	21796	10882	42	0	\N
334620	1874	17906000	21796	10882	43	0	\N
334621	1874	17909000	21796	10882	44	0	\N
334622	1874	17912000	21796	10882	45	0	\N
334623	1874	17915000	21796	10882	46	0	\N
334624	1874	17918000	21796	10882	47	0	\N
334625	1874	17921000	21796	10882	48	0	\N
334626	1874	17924000	21796	10882	49	0	\N
334627	1874	17927000	21796	10882	50	0	\N
334628	1874	17930000	21796	10882	51	0	\N
334629	1874	17933000	21796	10882	52	0	\N
334630	1874	17936000	21796	10882	53	0	\N
334631	1874	17939000	21796	10882	54	0	\N
334632	1874	17942000	21796	10882	55	0	\N
334633	1874	17945000	21796	10882	56	0	\N
334634	1874	17948000	21796	10882	57	0	\N
334635	1874	17951000	21796	10882	58	0	\N
334636	1874	17954000	21796	10882	59	0	\N
334637	1874	17957000	21796	10882	60	0	\N
334638	1874	17960000	21796	10882	61	0	\N
334639	1874	17963000	21796	10882	62	0	\N
334640	1874	17966000	21796	10882	63	0	\N
334641	1874	17969000	21796	10882	64	0	\N
334642	1874	17972000	21796	10882	65	0	\N
334643	1874	17975000	21796	10882	66	0	\N
334644	1874	17978000	21796	10882	67	0	\N
334645	1874	17981000	21796	10882	68	0	\N
334646	1874	17984000	21796	10882	69	0	\N
334647	1874	17987000	21796	10882	70	0	\N
334648	1874	17990000	21796	10882	71	0	\N
334649	1874	17993000	21796	10882	72	0	\N
334650	1874	17996000	21796	10882	73	0	\N
334651	1874	17999000	21796	10882	74	0	\N
334652	1874	18002000	21796	10882	75	0	\N
334653	1874	18005000	21796	10882	76	0	\N
334654	1874	18008000	21796	10882	77	0	\N
334655	1874	18011000	21796	10882	78	0	\N
334656	1874	18014000	21796	10882	79	0	\N
334657	1874	18017000	21796	10882	80	0	\N
334658	1874	18019000	21796	10882	81	0	\N
334659	1874	18021000	21796	10882	82	0	\N
334660	1874	18023000	21796	10882	83	0	\N
334661	1874	18025000	21796	10882	84	0	\N
334662	1874	18027000	21796	10882	85	0	\N
334663	1874	18029000	21796	10882	86	0	\N
334664	1874	18031000	21796	10882	87	0	\N
334665	1874	18033000	21796	10882	88	0	\N
334666	1874	18035000	21796	10882	89	0	\N
334667	1874	18037000	21796	10882	90	0	\N
334668	1874	18039000	21796	10882	91	0	\N
334669	1874	18041000	21796	10882	92	0	\N
334670	1874	18043000	21796	10882	93	0	\N
334671	1874	18045000	21796	10882	94	0	\N
334672	1874	18047000	21796	10882	95	0	\N
334673	1874	18049000	21796	10882	96	0	\N
334674	1874	18051000	21796	10882	97	0	\N
334675	1874	18053000	21796	10882	98	0	\N
334676	1874	18055000	21796	10882	99	0	\N
334677	1874	18057000	21796	10882	100	0	\N
334678	1874	18059000	21796	10882	101	0	\N
334679	1874	18061000	21796	10882	102	0	\N
334680	1874	18063000	21796	10882	103	0	\N
334681	1874	18065000	21796	10882	104	0	\N
334682	1874	18067000	21796	10882	105	0	\N
334683	1874	18069000	21796	10882	106	0	\N
334684	1874	18071000	21796	10882	107	0	\N
334685	1874	18073000	21796	10882	108	0	\N
334686	1874	18075000	21796	10882	109	0	\N
334687	1874	18077000	21796	10882	110	0	\N
334688	1874	18079000	21796	10882	111	0	\N
334689	1874	18081000	21796	10882	112	0	\N
334690	1874	18083000	21796	10882	113	0	\N
334691	1874	18085000	21796	10882	114	0	\N
334692	1874	18087000	21796	10882	115	0	\N
334693	1874	18089000	21796	10882	116	0	\N
334694	1874	18091000	21796	10882	117	0	\N
334695	1874	18093000	21796	10882	118	0	\N
334696	1874	18095000	21796	10882	119	0	\N
334697	1874	18097000	21796	10882	120	0	\N
334698	1678	23760767954000	21797	10912	0	0	\N
334699	1678	23760767955000	21797	10912	1	0	\N
334700	1874	18094000	21797	10912	2	0	\N
334701	1874	18097000	21797	10912	3	0	\N
334702	1874	18100000	21797	10912	4	0	\N
334703	1874	18102000	21797	10912	5	0	\N
334710	1678	23760767954000	21799	10912	0	0	\N
334711	1678	23760767955000	21799	10912	1	0	\N
334712	1874	18094000	21799	10912	2	0	\N
334713	1874	18097000	21799	10912	3	0	\N
334714	1874	18100000	21799	10912	4	0	\N
334715	1874	18102000	21799	10912	5	0	\N
334719	1678	23760767957000	21802	10914	0	0	\N
334720	1678	23760767958000	21802	10914	1	0	\N
334721	1874	18109000	21802	10914	2	0	\N
334722	1874	18111000	21802	10914	3	0	\N
334723	1874	18114000	21802	10914	4	0	\N
334724	1874	18117000	21802	10914	5	0	\N
334725	1678	23760767957000	21803	10914	0	0	\N
334726	1678	23760767958000	21803	10914	1	0	\N
334727	1874	18109000	21803	10914	2	0	\N
334728	1874	18111000	21803	10914	3	0	\N
334729	1874	18114000	21803	10914	4	0	\N
334730	1874	18117000	21803	10914	5	0	\N
334731	1678	23760767957000	21804	10914	0	0	\N
334732	1678	23760767958000	21804	10914	1	0	\N
334733	1874	18109000	21804	10914	2	0	\N
334734	1874	18111000	21804	10914	3	0	\N
334735	1874	18114000	21804	10914	4	0	\N
334736	1874	18117000	21804	10914	5	0	\N
334743	2291	0	21806	10859	0	0	\N
334744	588	66783000000000	21806	10859	1	0	\N
334745	1958	5231186000000	21806	10859	2	0	\N
334746	973	507337115000000	21806	10859	3	0	\N
334747	1213	613417650000000	21806	10859	4	0	\N
334748	1093	909143945000000	21806	10859	5	0	\N
334749	1339	1709341667751650	21806	10859	6	0	\N
334750	1442	0	21806	10859	7	0	\N
334751	1318	1710516637751650	21806	10859	8	0	\N
334752	1072	910057465000000	21806	10859	9	0	\N
334753	1192	614032750000000	21806	10859	10	0	\N
334754	952	507686775000000	21806	10859	11	0	\N
334761	1678	23760767959000	21808	10915	0	0	\N
334762	1678	23760767960000	21808	10915	1	0	\N
334763	1874	18120000	21808	10915	2	0	\N
334764	1874	18122000	21808	10915	3	0	\N
334765	1874	18124000	21808	10915	4	0	\N
334766	1874	18127000	21808	10915	5	0	\N
334770	1678	23760767962000	21810	10917	0	0	\N
334771	1874	18135000	21810	10917	1	0	\N
334772	1874	18137000	21810	10917	2	0	\N
334773	1678	23760767962000	21811	10917	0	0	\N
334774	1874	18135000	21811	10917	1	0	\N
334775	1874	18137000	21811	10917	2	0	\N
334779	1678	23760767963000	21813	10918	0	0	\N
334780	1678	23760767964000	21813	10918	1	0	\N
334781	1874	18139000	21813	10918	2	0	\N
334782	1874	18141000	21813	10918	3	0	\N
334783	1874	18144000	21813	10918	4	0	\N
334784	1874	18147000	21813	10918	5	0	\N
334797	1678	23760767965000	21817	10919	0	0	\N
334798	1678	23760767966000	21817	10919	1	0	\N
334799	1874	18150000	21817	10919	2	0	\N
334800	1874	18153000	21817	10919	3	0	\N
334801	1874	18155000	21817	10919	4	0	\N
334802	1874	18157000	21817	10919	5	0	\N
334809	1678	23760767969000	21819	10921	0	0	\N
334810	1678	23760767970000	21819	10921	1	0	\N
334811	1874	18169000	21819	10921	2	0	\N
334812	1874	18171000	21819	10921	3	0	\N
334813	1874	18174000	21819	10921	4	0	\N
334814	1874	18177000	21819	10921	5	0	\N
334706	1874	18094000	21798	10912	2	0	2
334707	1874	18097000	21798	10912	3	0	2
334708	1874	18100000	21798	10912	4	0	2
334709	1874	18102000	21798	10912	5	0	2
334716	1678	23760767956000	21801	10913	0	0	0
334718	1874	18107000	21801	10913	2	0	2
334737	1678	23760767957000	21805	10914	0	0	0
334738	1678	23760767958000	21805	10914	1	0	0
334739	1874	18109000	21805	10914	2	0	2
334740	1874	18111000	21805	10914	3	0	2
334742	1874	18117000	21805	10914	5	0	2
334755	1678	23760767959000	21807	10915	0	0	0
334756	1678	23760767960000	21807	10915	1	0	0
334757	1874	18120000	21807	10915	2	0	2
334759	1874	18124000	21807	10915	4	0	2
334760	1874	18127000	21807	10915	5	0	2
334767	1678	23760767961000	21809	10916	0	0	0
334768	1874	18129000	21809	10916	1	0	2
334769	1874	18132000	21809	10916	2	0	2
334777	1874	18135000	21812	10917	1	0	2
334778	1874	18137000	21812	10917	2	0	2
334785	1678	23760767963000	21814	10918	0	0	0
334786	1678	23760767964000	21814	10918	1	0	0
334787	1874	18139000	21814	10918	2	0	2
334789	1874	18144000	21814	10918	4	0	2
334790	1874	18147000	21814	10918	5	0	2
334791	1678	23760767965000	21816	10919	0	0	0
334792	1678	23760767966000	21816	10919	1	0	0
334794	1874	18153000	21816	10919	3	0	2
334795	1874	18155000	21816	10919	4	0	2
334796	1874	18157000	21816	10919	5	0	2
334803	1678	23760767967000	21818	10920	0	0	0
334804	1678	23760767968000	21818	10920	1	0	0
334806	1874	18162000	21818	10920	3	0	2
334807	1874	18164000	21818	10920	4	0	2
334808	1874	18167000	21818	10920	5	0	2
334815	1678	23760767969000	21820	10921	0	0	0
334816	1678	23760767970000	21820	10921	1	0	0
334818	1874	18171000	21820	10921	3	0	2
334819	1874	18174000	21820	10921	4	0	2
334820	1874	18177000	21820	10921	5	0	2
334821	1678	23760767971000	21822	10922	0	0	0
334823	1678	23760767973000	21822	10922	2	0	0
334824	1678	23760767974000	21822	10922	3	0	0
334825	1874	18179000	21822	10922	4	0	2
334826	1874	18181000	21822	10922	5	0	2
334827	1874	18183000	21822	10922	6	0	2
334829	1874	18188000	21822	10922	8	0	2
334830	1874	18191000	21822	10922	9	0	2
334831	1874	18194000	21822	10922	10	0	2
334832	1874	18197000	21822	10922	11	0	2
334833	1678	23760767971000	21823	10922	0	0	\N
334834	1678	23760767972000	21823	10922	1	0	\N
334835	1678	23760767973000	21823	10922	2	0	\N
334836	1678	23760767974000	21823	10922	3	0	\N
334837	1874	18179000	21823	10922	4	0	\N
334838	1874	18181000	21823	10922	5	0	\N
334839	1874	18183000	21823	10922	6	0	\N
334840	1874	18185000	21823	10922	7	0	\N
334841	1874	18188000	21823	10922	8	0	\N
334842	1874	18191000	21823	10922	9	0	\N
334843	1874	18194000	21823	10922	10	0	\N
334844	1874	18197000	21823	10922	11	0	\N
334857	1678	23760767977000	21826	10924	0	0	\N
334858	1678	23760767978000	21826	10924	1	0	\N
334859	1874	18210000	21826	10924	2	0	\N
334860	1874	18213000	21826	10924	3	0	\N
334861	1874	18215000	21826	10924	4	0	\N
334862	1874	18217000	21826	10924	5	0	\N
334863	1678	23760767977000	21827	10924	0	0	\N
334864	1678	23760767978000	21827	10924	1	0	\N
334865	1874	18210000	21827	10924	2	0	\N
334866	1874	18213000	21827	10924	3	0	\N
334867	1874	18215000	21827	10924	4	0	\N
334868	1874	18217000	21827	10924	5	0	\N
334869	1874	18220000	21828	10925	0	0	\N
334870	1874	18223000	21828	10925	1	0	\N
334886	1678	23760767984000	21832	10927	0	0	\N
334887	1874	18244000	21832	10927	1	0	\N
334890	1678	23760767984000	21834	10927	0	0	\N
334891	1874	18244000	21834	10927	1	0	\N
334898	2291	0	21836	10868	0	0	\N
334899	1678	23760767898000	21836	10868	1	0	\N
334900	1678	23760767899000	21836	10868	2	0	\N
334901	1678	23760767900000	21836	10868	3	0	\N
334902	1678	23760767901000	21836	10868	4	0	\N
334903	1678	23760767902000	21836	10868	5	0	\N
334904	1678	23760767903000	21836	10868	6	0	\N
334905	1678	23760767904000	21836	10868	7	0	\N
334906	1678	23760767905000	21836	10868	8	0	\N
334907	1678	23760767906000	21836	10868	9	0	\N
334908	1678	23760767907000	21836	10868	10	0	\N
334909	1678	23760767908000	21836	10868	11	0	\N
334910	1678	23760767909000	21836	10868	12	0	\N
334911	1678	23760767910000	21836	10868	13	0	\N
334912	1678	23760767911000	21836	10868	14	0	\N
334913	1678	23760767912000	21836	10868	15	0	\N
334914	1678	23760767913000	21836	10868	16	0	\N
334915	1678	23760767914000	21836	10868	17	0	\N
334916	1678	23760767915000	21836	10868	18	0	\N
334917	1678	23760767916000	21836	10868	19	0	\N
334918	1678	23760767917000	21836	10868	20	0	\N
334919	1678	23760767918000	21836	10868	21	0	\N
334920	1678	23760767919000	21836	10868	22	0	\N
334921	1678	23760767920000	21836	10868	23	0	\N
334922	1678	23760767921000	21836	10868	24	0	\N
334923	1678	23760767922000	21836	10868	25	0	\N
334924	1678	23760767923000	21836	10868	26	0	\N
334925	1678	23760767924000	21836	10868	27	0	\N
334926	1678	23760767925000	21836	10868	28	0	\N
334927	1678	23760767926000	21836	10868	29	0	\N
334928	1678	23760767927000	21836	10868	30	0	\N
334929	1678	23760767928000	21836	10868	31	0	\N
334930	1678	23760767929000	21836	10868	32	0	\N
334931	1678	23760767930000	21836	10868	33	0	\N
334932	1678	23760767931000	21836	10868	34	0	\N
334933	1678	23760767932000	21836	10868	35	0	\N
334934	1678	23760767933000	21836	10868	36	0	\N
334935	1678	23760767934000	21836	10868	37	0	\N
334936	1678	23760767935000	21836	10868	38	0	\N
334937	1678	23760767936000	21836	10868	39	0	\N
334938	1678	23760767937000	21836	10868	40	0	\N
334939	1678	23760767938000	21836	10868	41	0	\N
334940	1678	23760767939000	21836	10868	42	0	\N
334941	1678	23760767940000	21836	10868	43	0	\N
334942	1678	23760767941000	21836	10868	44	0	\N
334943	1678	23760767942000	21836	10868	45	0	\N
334944	1678	23760767943000	21836	10868	46	0	\N
334945	1678	23760767944000	21836	10868	47	0	\N
334946	1678	23760767945000	21836	10868	48	0	\N
334947	1678	23760767946000	21836	10868	49	0	\N
334948	1678	23760767947000	21836	10868	50	0	\N
334949	1678	23760767948000	21836	10868	51	0	\N
334950	1678	23760767949000	21836	10868	52	0	\N
334951	1678	23760767950000	21836	10868	53	0	\N
334952	1678	23760767951000	21836	10868	54	0	\N
334953	1678	23760767952000	21836	10868	55	0	\N
334954	1678	23760767953000	21836	10868	56	0	\N
334955	1678	23760767954000	21836	10868	57	0	\N
334956	1678	23760767955000	21836	10868	58	0	\N
334957	1678	23760767956000	21836	10868	59	0	\N
334958	1678	23760767957000	21836	10868	60	0	\N
334959	1678	23760767958000	21836	10868	61	0	\N
334960	1678	23760767959000	21836	10868	62	0	\N
334961	1678	23760767960000	21836	10868	63	0	\N
334962	1678	23760767961000	21836	10868	64	0	\N
334963	1678	23760767962000	21836	10868	65	0	\N
334964	1678	23760767963000	21836	10868	66	0	\N
334965	1678	23760767964000	21836	10868	67	0	\N
334966	1678	23760767965000	21836	10868	68	0	\N
334967	1678	23760767966000	21836	10868	69	0	\N
334968	1678	23760767967000	21836	10868	70	0	\N
334847	1874	18199000	21824	10923	2	0	2
334848	1874	18201000	21824	10923	3	0	2
334849	1874	18204000	21824	10923	4	0	2
334850	1874	18207000	21824	10923	5	0	2
334851	1678	23760767977000	21825	10924	0	0	0
334853	1874	18210000	21825	10924	2	0	2
334854	1874	18213000	21825	10924	3	0	2
334855	1874	18215000	21825	10924	4	0	2
334856	1874	18217000	21825	10924	5	0	2
334871	1678	23760767979000	21829	10925	0	0	0
334873	1874	18219000	21829	10925	2	0	2
334874	1874	18221000	21829	10925	3	0	2
334875	1874	18224000	21829	10925	4	0	2
334876	1874	18227000	21829	10925	5	0	2
334878	1678	23760767982000	21831	10926	1	0	0
334879	1678	23760767983000	21831	10926	2	0	0
334880	1874	18229000	21831	10926	3	0	2
334881	1874	18231000	21831	10926	4	0	2
334882	1874	18233000	21831	10926	5	0	2
334884	1874	18239000	21831	10926	7	0	2
334885	1874	18242000	21831	10926	8	0	2
334888	1678	23760767984000	21833	10927	0	0	0
334889	1874	18244000	21833	10927	1	0	2
334892	1678	23760767985000	21835	10928	0	0	0
334894	1874	18246000	21835	10928	2	0	2
334895	1874	18248000	21835	10928	3	0	2
334896	1874	18251000	21835	10928	4	0	2
334897	1874	18254000	21835	10928	5	0	2
334969	1678	23760767968000	21836	10868	71	0	\N
334970	1678	23760767969000	21836	10868	72	0	\N
334971	1678	23760767970000	21836	10868	73	0	\N
334972	1678	23760767971000	21836	10868	74	0	\N
334973	1678	23760767972000	21836	10868	75	0	\N
334974	1678	23760767973000	21836	10868	76	0	\N
334975	1678	23760767974000	21836	10868	77	0	\N
334976	1678	23760767975000	21836	10868	78	0	\N
334977	1678	23760767976000	21836	10868	79	0	\N
334978	1678	23760767977000	21836	10868	80	0	\N
334979	1678	23760767978000	21836	10868	81	0	\N
334980	1678	23760767979000	21836	10868	82	0	\N
334981	1678	23760767980000	21836	10868	83	0	\N
334982	1678	23760767981000	21836	10868	84	0	\N
334983	1678	23760767982000	21836	10868	85	0	\N
334984	1678	23760767983000	21836	10868	86	0	\N
334985	1678	23760767984000	21836	10868	87	0	\N
334986	1678	23760767985000	21836	10868	88	0	\N
334987	1678	23760767986000	21836	10868	89	0	\N
334988	1678	23760767987000	21836	10868	90	0	\N
334989	1442	0	21836	10868	91	0	\N
334990	1318	1710516637751650	21836	10868	92	0	\N
334991	1072	910057465000000	21836	10868	93	0	\N
334992	1192	614032750000000	21836	10868	94	0	\N
334993	952	507686775000000	21836	10868	95	0	\N
334994	1874	17781000	21836	10868	96	0	\N
334995	1874	17783000	21836	10868	97	0	\N
334996	1874	17785000	21836	10868	98	0	\N
334997	1874	17787000	21836	10868	99	0	\N
334998	1874	17790000	21836	10868	100	0	\N
334999	1874	17793000	21836	10868	101	0	\N
335000	1874	17796000	21836	10868	102	0	\N
335001	1874	17799000	21836	10868	103	0	\N
335002	1874	17802000	21836	10868	104	0	\N
335003	1874	17805000	21836	10868	105	0	\N
335004	1874	17808000	21836	10868	106	0	\N
335005	1874	17811000	21836	10868	107	0	\N
335006	1874	17814000	21836	10868	108	0	\N
335007	1874	17817000	21836	10868	109	0	\N
335008	1874	17820000	21836	10868	110	0	\N
335009	1874	17823000	21836	10868	111	0	\N
335010	1874	17826000	21836	10868	113	0	\N
335011	1874	17829000	21836	10868	114	0	\N
335012	1874	17832000	21836	10868	115	0	\N
335013	1874	17835000	21836	10868	116	0	\N
335014	1874	17838000	21836	10868	117	0	\N
335015	1874	17841000	21836	10868	118	0	\N
335022	1678	23760767989000	21839	10931	0	0	\N
335023	1874	18267000	21839	10931	1	0	\N
335024	1874	18269000	21839	10931	2	0	\N
335028	1678	23760767989000	21841	10931	0	0	\N
335029	1874	18267000	21841	10931	1	0	\N
335030	1874	18269000	21841	10931	2	0	\N
335031	1678	23760767989000	21842	10931	0	0	\N
335032	1874	18267000	21842	10931	1	0	\N
335033	1874	18269000	21842	10931	2	0	\N
335043	1678	23760767991000	21845	10933	0	0	\N
335044	1678	23760767992000	21845	10933	1	0	\N
335045	1874	18277000	21845	10933	2	0	\N
335046	1874	18279000	21845	10933	3	0	\N
335047	1874	18282000	21845	10933	4	0	\N
335048	1874	18284000	21845	10933	5	0	\N
335049	2291	0	21846	10675	0	0	\N
335050	588	66783000000000	21846	10675	1	0	\N
335051	1958	5231186000000	21846	10675	2	0	\N
335052	1483	10000000	21846	10675	3	0	\N
335053	1483	10000000	21846	10675	4	0	\N
335054	2290	100000000	21846	10675	5	0	\N
335055	1678	23040757736000	21846	10675	6	0	\N
335056	1678	23040757737000	21846	10675	7	0	\N
335057	1678	23040757738000	21846	10675	8	0	\N
335058	1678	23040757739000	21846	10675	9	0	\N
335059	1678	23040757740000	21846	10675	10	0	\N
335060	1678	23040757741000	21846	10675	11	0	\N
335061	1678	23040757742000	21846	10675	12	0	\N
335062	1678	23040757743000	21846	10675	13	0	\N
335063	1678	23040757744000	21846	10675	14	0	\N
335064	1678	23040757745000	21846	10675	15	0	\N
335065	973	507337115000000	21846	10675	16	0	\N
335066	1678	23040757746000	21846	10675	17	0	\N
335067	1678	23040757747000	21846	10675	18	0	\N
335068	1678	23040757748000	21846	10675	19	0	\N
335069	1678	23040757749000	21846	10675	20	0	\N
335070	1678	23040757750000	21846	10675	21	0	\N
335071	1678	23040757751000	21846	10675	22	0	\N
335072	1678	23040757752000	21846	10675	23	0	\N
335073	1678	23040757753000	21846	10675	24	0	\N
335074	1678	23040757754000	21846	10675	25	0	\N
335075	1678	23040757755000	21846	10675	26	0	\N
335076	1678	23040757756000	21846	10675	27	0	\N
335077	1678	23040757757000	21846	10675	28	0	\N
335078	1678	23040757758000	21846	10675	29	0	\N
335079	1678	23040757759000	21846	10675	30	0	\N
335080	1678	23040757760000	21846	10675	31	0	\N
335081	1678	23040757761000	21846	10675	32	0	\N
335082	1678	23040757762000	21846	10675	33	0	\N
335083	1678	23040757763000	21846	10675	34	0	\N
335084	1678	23040757764000	21846	10675	35	0	\N
335085	1678	23040757765000	21846	10675	36	0	\N
335086	1678	23040757766000	21846	10675	37	0	\N
335087	1678	23040757767000	21846	10675	38	0	\N
335088	1678	23040757768000	21846	10675	39	0	\N
335089	1213	613417650000000	21846	10675	40	0	\N
335090	1093	909143945000000	21846	10675	41	0	\N
335091	1339	1709341667751650	21846	10675	42	0	\N
335092	1678	23040757769000	21846	10675	43	0	\N
335093	1678	23040757770000	21846	10675	44	0	\N
335094	1678	23040757771000	21846	10675	45	0	\N
335095	1678	23040757772000	21846	10675	46	0	\N
335096	1678	23040757773000	21846	10675	47	0	\N
335097	1678	23040757774000	21846	10675	48	0	\N
335098	1678	23040757775000	21846	10675	49	0	\N
335099	1678	23040757776000	21846	10675	50	0	\N
335100	1678	23040757777000	21846	10675	51	0	\N
335101	1678	23040757778000	21846	10675	52	0	\N
335102	1678	23040757779000	21846	10675	53	0	\N
335103	1678	23040757780000	21846	10675	54	0	\N
335104	1678	23040757781000	21846	10675	55	0	\N
335018	1874	18259000	21837	10929	2	0	2
335019	1678	23760767988000	21838	10930	0	0	0
335020	1874	18261000	21838	10930	1	0	2
335021	1874	18264000	21838	10930	2	0	2
335025	1678	23760767989000	21840	10931	0	0	0
335027	1874	18269000	21840	10931	2	0	2
335034	1678	23760767990000	21843	10932	0	0	0
335035	1874	18271000	21843	10932	1	0	2
335036	1874	18274000	21843	10932	2	0	2
335037	1678	23760767991000	21844	10933	0	0	0
335039	1874	18277000	21844	10933	2	0	2
335040	1874	18279000	21844	10933	3	0	2
335041	1874	18282000	21844	10933	4	0	2
335042	1874	18284000	21844	10933	5	0	2
335105	1678	23040757782000	21846	10675	56	0	\N
335106	1678	23040757783000	21846	10675	57	0	\N
335107	1678	23040757784000	21846	10675	58	0	\N
335108	1678	23040757785000	21846	10675	59	0	\N
335109	1678	23040757786000	21846	10675	60	0	\N
335110	1678	23040757787000	21846	10675	61	0	\N
335111	1678	23040757788000	21846	10675	62	0	\N
335112	1678	23040757789000	21846	10675	63	0	\N
335113	1678	23040757790000	21846	10675	64	0	\N
335114	1678	23040757791000	21846	10675	65	0	\N
335115	1678	23040757792000	21846	10675	66	0	\N
335116	1678	23040757793000	21846	10675	67	0	\N
335117	1678	23040757794000	21846	10675	68	0	\N
335118	1678	23040757795000	21846	10675	69	0	\N
335119	1678	23040757796000	21846	10675	70	0	\N
335120	1678	23040757797000	21846	10675	71	0	\N
335121	1678	23040757798000	21846	10675	72	0	\N
335122	1678	23040757799000	21846	10675	73	0	\N
335123	1678	23040757800000	21846	10675	74	0	\N
335124	1678	23040757801000	21846	10675	75	0	\N
335125	1678	23040757802000	21846	10675	76	0	\N
335126	1678	23040757803000	21846	10675	77	0	\N
335127	1678	23040757804000	21846	10675	78	0	\N
335128	1678	23040757805000	21846	10675	79	0	\N
335129	1678	23040757806000	21846	10675	80	0	\N
335130	1678	23040757807000	21846	10675	81	0	\N
335131	1678	23040757808000	21846	10675	82	0	\N
335132	1678	23040757809000	21846	10675	83	0	\N
335133	1678	23040757810000	21846	10675	84	0	\N
335134	1678	23040757811000	21846	10675	85	0	\N
335135	1678	23040757812000	21846	10675	86	0	\N
335136	1678	23040757813000	21846	10675	87	0	\N
335137	1678	23040757814000	21846	10675	88	0	\N
335138	1678	23040757815000	21846	10675	89	0	\N
335139	1678	23040757816000	21846	10675	90	0	\N
335140	1678	23040757817000	21846	10675	92	0	\N
335141	1678	23040757818000	21846	10675	93	0	\N
335142	1678	23040757819000	21846	10675	94	0	\N
335143	1678	23040757820000	21846	10675	95	0	\N
335144	1678	23040757821000	21846	10675	96	0	\N
335145	1678	23040757822000	21846	10675	97	0	\N
335146	1678	23040757823000	21846	10675	98	0	\N
335147	1678	23040757824000	21846	10675	99	0	\N
335148	1678	23040757825000	21846	10675	100	0	\N
335149	1678	23040757826000	21846	10675	101	0	\N
335150	1678	23040757827000	21846	10675	102	0	\N
335151	1678	23040757828000	21846	10675	103	0	\N
335152	1678	23040757829000	21846	10675	104	0	\N
335153	1678	23040757830000	21846	10675	105	0	\N
335154	1678	23040757831000	21846	10675	106	0	\N
335155	1678	23040757832000	21846	10675	107	0	\N
335156	1678	23040757833000	21846	10675	108	0	\N
335157	1678	23040757834000	21846	10675	109	0	\N
335158	1678	23040757835000	21846	10675	110	0	\N
335159	1678	23040757836000	21846	10675	111	0	\N
335160	1678	23040757837000	21846	10675	112	0	\N
335161	1678	23040757838000	21846	10675	113	0	\N
335162	1678	23040757839000	21846	10675	114	0	\N
335163	1678	23040757840000	21846	10675	115	0	\N
335164	1678	23040757841000	21846	10675	116	0	\N
335165	1678	23040757842000	21846	10675	117	0	\N
335166	1678	23040757843000	21846	10675	118	0	\N
335167	1678	23040757844000	21846	10675	119	0	\N
335168	1678	23040757845000	21846	10675	120	0	\N
335169	1678	23040757846000	21846	10675	121	0	\N
335170	1678	23040757847000	21846	10675	122	0	\N
335171	1678	23040757848000	21846	10675	123	0	\N
335172	1678	23040757849000	21846	10675	124	0	\N
335173	1678	23040757850000	21846	10675	125	0	\N
335174	1678	23760767993000	21847	10934	0	0	\N
335175	1678	23760767994000	21847	10934	1	0	\N
335176	1678	23760767995000	21847	10934	2	0	\N
335177	1874	18286000	21847	10934	3	0	\N
335178	1874	18288000	21847	10934	4	0	\N
335179	1874	18291000	21847	10934	5	0	\N
335180	1874	18294000	21847	10934	6	0	\N
335181	1874	18297000	21847	10934	7	0	\N
335182	1874	18299000	21847	10934	8	0	\N
335183	1678	23760767993000	21848	10934	0	0	\N
335184	1678	23760767994000	21848	10934	1	0	\N
335185	1678	23760767995000	21848	10934	2	0	\N
335186	1874	18286000	21848	10934	3	0	\N
335187	1874	18288000	21848	10934	4	0	\N
335188	1874	18291000	21848	10934	5	0	\N
335189	1874	18294000	21848	10934	6	0	\N
335190	1874	18297000	21848	10934	7	0	\N
335191	1874	18299000	21848	10934	8	0	\N
335201	1678	23760767996000	21850	10935	0	0	\N
335202	1874	18301000	21850	10935	1	0	\N
335203	1874	18304000	21850	10935	2	0	\N
335219	1678	23760767998000	21854	10937	0	0	\N
335220	1678	23760767999000	21854	10937	1	0	\N
335221	1678	23760768000000	21854	10937	2	0	\N
335222	1874	18311000	21854	10937	3	0	\N
335223	1874	18314000	21854	10937	4	0	\N
335224	1874	18316000	21854	10937	5	0	\N
335225	1874	18318000	21854	10937	6	0	\N
335226	1874	18321000	21854	10937	7	0	\N
335227	1874	18324000	21854	10937	8	0	\N
335228	1678	23760767998000	21855	10937	0	0	\N
335229	1678	23760767999000	21855	10937	1	0	\N
335230	1678	23760768000000	21855	10937	2	0	\N
335231	1874	18311000	21855	10937	3	0	\N
335232	1874	18314000	21855	10937	4	0	\N
335233	1874	18316000	21855	10937	5	0	\N
335234	1874	18318000	21855	10937	6	0	\N
335235	1874	18321000	21855	10937	7	0	\N
335236	1874	18324000	21855	10937	8	0	\N
335237	1678	23760767998000	21856	10937	0	0	\N
335238	1678	23760767999000	21856	10937	1	0	\N
335239	1678	23760768000000	21856	10937	2	0	\N
335240	1874	18311000	21856	10937	3	0	\N
335194	1678	23760767995000	21849	10934	2	0	0
335195	1874	18286000	21849	10934	3	0	2
335196	1874	18288000	21849	10934	4	0	2
335197	1874	18291000	21849	10934	5	0	2
335198	1874	18294000	21849	10934	6	0	2
335200	1874	18299000	21849	10934	8	0	2
335204	1678	23760767996000	21851	10935	0	0	0
335205	1874	18301000	21851	10935	1	0	2
335206	1874	18304000	21851	10935	2	0	2
335207	1678	23760767997000	21852	10936	0	0	0
335209	1874	18309000	21852	10936	2	0	2
335210	1678	23760767998000	21853	10937	0	0	0
335211	1678	23760767999000	21853	10937	1	0	0
335212	1678	23760768000000	21853	10937	2	0	0
335214	1874	18314000	21853	10937	4	0	2
335215	1874	18316000	21853	10937	5	0	2
335216	1874	18318000	21853	10937	6	0	2
335217	1874	18321000	21853	10937	7	0	2
335218	1874	18324000	21853	10937	8	0	2
335241	1874	18314000	21856	10937	4	0	\N
335242	1874	18316000	21856	10937	5	0	\N
335243	1874	18318000	21856	10937	6	0	\N
335244	1874	18321000	21856	10937	7	0	\N
335245	1874	18324000	21856	10937	8	0	\N
335246	1678	23760768001000	21857	10938	0	0	\N
335247	1874	18326000	21857	10938	1	0	\N
335248	1874	18329000	21857	10938	2	0	\N
335249	1678	23760768001000	21858	10938	0	0	\N
335250	1874	18326000	21858	10938	1	0	\N
335251	1874	18329000	21858	10938	2	0	\N
335267	1678	23760768006000	21864	10943	0	0	\N
335268	1874	18352000	21864	10943	1	0	\N
335269	1874	18354000	21864	10943	2	0	\N
335270	1678	23760768006000	21865	10943	0	0	\N
335271	1874	18352000	21865	10943	1	0	\N
335272	1874	18354000	21865	10943	2	0	\N
335274	1678	23760768006000	21867	10943	0	0	\N
335275	1874	18352000	21867	10943	1	0	\N
335276	1874	18354000	21867	10943	2	0	\N
335277	1678	23760768006000	21868	10943	0	0	\N
335278	1874	18352000	21868	10943	1	0	\N
335279	1874	18354000	21868	10943	2	0	\N
335280	588	66783000000000	21870	10799	0	0	\N
335281	1021	507244438919578	21870	10799	1	0	\N
335282	1958	5231186000000	21870	10799	2	0	\N
335283	1483	10000000	21870	10799	3	0	\N
335284	1678	23040757817000	21870	10799	4	0	\N
335285	1483	10000000	21870	10799	5	0	\N
335286	1508	22688206929693	21870	10799	6	0	\N
335287	2290	100000000	21870	10799	7	0	\N
335288	1678	23040757818000	21870	10799	8	0	\N
335289	1678	23040757819000	21870	10799	9	0	\N
335290	1508	22939776541648	21870	10799	10	0	\N
335291	1678	23040757820000	21870	10799	11	0	\N
335292	1678	23040757821000	21870	10799	13	0	\N
335293	1141	908977688473491	21870	10799	14	0	\N
335294	1261	613305359073006	21870	10799	15	0	\N
335295	1387	1709029915128959	21870	10799	16	0	\N
335296	973	507337115000000	21870	10799	17	0	\N
335297	1678	23040757822000	21870	10799	18	0	\N
335298	1678	23040757823000	21870	10799	19	0	\N
335299	1678	23040757824000	21870	10799	20	0	\N
335300	1678	23040757825000	21870	10799	21	0	\N
335301	1678	23040757826000	21870	10799	22	0	\N
335302	1678	23040757827000	21870	10799	23	0	\N
335303	1678	23040757828000	21870	10799	24	0	\N
335304	1678	23040757829000	21870	10799	25	0	\N
335305	1678	23040757830000	21870	10799	26	0	\N
335306	1678	23040757831000	21870	10799	27	0	\N
335307	1678	23040757832000	21870	10799	28	0	\N
335308	1678	23040757833000	21870	10799	29	0	\N
335309	1678	23040757834000	21870	10799	30	0	\N
335310	1678	23040757835000	21870	10799	31	0	\N
335311	1678	23040757836000	21870	10799	32	0	\N
335312	1678	23040757837000	21870	10799	33	0	\N
335313	1678	23040757838000	21870	10799	34	0	\N
335314	1678	23040757839000	21870	10799	35	0	\N
335315	1678	23040757840000	21870	10799	36	0	\N
335316	1678	23040757841000	21870	10799	37	0	\N
335317	1678	23040757842000	21870	10799	38	0	\N
335318	1678	23040757843000	21870	10799	39	0	\N
335319	1678	23040757844000	21870	10799	40	0	\N
335320	1678	23040757845000	21870	10799	41	0	\N
335321	1678	23040757846000	21870	10799	42	0	\N
335322	1678	23040757847000	21870	10799	43	0	\N
335323	1678	23040757848000	21870	10799	44	0	\N
335324	1678	23040757849000	21870	10799	45	0	\N
335325	1678	23040757850000	21870	10799	46	0	\N
335326	1678	23040757851000	21870	10799	47	0	\N
335327	1678	23040757852000	21870	10799	48	0	\N
335328	1678	23040757853000	21870	10799	49	0	\N
335329	1678	23040757854000	21870	10799	50	0	\N
335330	1678	23040757855000	21870	10799	51	0	\N
335331	1678	23040757856000	21870	10799	52	0	\N
335332	1678	23040757857000	21870	10799	53	0	\N
335333	1678	23040757858000	21870	10799	54	0	\N
335334	1678	23040757859000	21870	10799	55	0	\N
335335	1678	23040757860000	21870	10799	56	0	\N
335336	1678	23040757861000	21870	10799	57	0	\N
335337	1678	23040757862000	21870	10799	58	0	\N
335338	1678	23040757863000	21870	10799	59	0	\N
335339	1678	23040757864000	21870	10799	60	0	\N
335340	1678	23040757865000	21870	10799	61	0	\N
335341	1678	23040757866000	21870	10799	62	0	\N
335342	1678	23040757867000	21870	10799	63	0	\N
335343	1678	23040757868000	21870	10799	64	0	\N
335344	1678	23040757869000	21870	10799	65	0	\N
335345	1678	23040757870000	21870	10799	66	0	\N
335346	1678	23040757871000	21870	10799	67	0	\N
335347	1678	23040757872000	21870	10799	68	0	\N
335348	1678	23040757873000	21870	10799	69	0	\N
335349	1678	23040757874000	21870	10799	70	0	\N
335350	1678	23040757875000	21870	10799	71	0	\N
335351	1678	23040757876000	21870	10799	72	0	\N
335352	1678	23040757877000	21870	10799	73	0	\N
335353	1678	23040757878000	21870	10799	74	0	\N
335354	1678	23040757879000	21870	10799	75	0	\N
335355	1678	23040757880000	21870	10799	76	0	\N
335356	1678	23040757881000	21870	10799	77	0	\N
335357	1678	23040757882000	21870	10799	78	0	\N
335358	1678	23040757883000	21870	10799	79	0	\N
335359	1678	23040757884000	21870	10799	80	0	\N
335360	1678	23040757885000	21870	10799	81	0	\N
335361	1678	23040757886000	21870	10799	82	0	\N
335362	1678	23040757887000	21870	10799	83	0	\N
335363	1678	23040757888000	21870	10799	84	0	\N
335364	1678	23040757889000	21870	10799	85	0	\N
335365	1678	23040757890000	21870	10799	86	0	\N
335366	1678	23040757891000	21870	10799	87	0	\N
335367	1678	23040757892000	21870	10799	88	0	\N
335368	1678	23040757893000	21870	10799	89	0	\N
335369	1678	23040757894000	21870	10799	90	0	\N
335370	1213	613417650000000	21870	10799	91	0	\N
335371	1093	909143945000000	21870	10799	92	0	\N
335372	1339	1709341667751650	21870	10799	93	0	\N
335373	1874	17359000	21870	10799	94	0	\N
335374	1874	17362000	21870	10799	95	0	\N
335375	1874	17365000	21870	10799	96	0	\N
335376	1874	17368000	21870	10799	97	0	\N
335254	1874	18329000	21859	10938	2	0	2
335255	1678	23760768002000	21860	10939	0	0	0
335256	1874	18331000	21860	10939	1	0	2
335257	1874	18334000	21860	10939	2	0	2
335258	1678	23760768003000	21861	10940	0	0	0
335260	1874	18339000	21861	10940	2	0	2
335261	1678	23760768004000	21862	10941	0	0	0
335262	1874	18342000	21862	10941	1	0	2
335263	1874	18344000	21862	10941	2	0	2
335264	1678	23760768005000	21863	10942	0	0	0
335266	1874	18349000	21863	10942	2	0	2
335273	1874	18351000	21866	10943	0	0	2
335377	1874	17371000	21870	10799	98	0	\N
335378	1874	17373000	21870	10799	99	0	\N
335379	1874	17375000	21870	10799	100	0	\N
335380	1874	17377000	21870	10799	101	0	\N
335381	1874	17379000	21870	10799	102	0	\N
335382	1874	17382000	21870	10799	103	0	\N
335383	1874	17385000	21870	10799	104	0	\N
335384	1874	17388000	21870	10799	105	0	\N
335385	1874	17391000	21870	10799	106	0	\N
335386	1874	17394000	21870	10799	107	0	\N
335387	1874	17397000	21870	10799	108	0	\N
335388	1874	17400000	21870	10799	109	0	\N
335389	1874	17403000	21870	10799	110	0	\N
335390	1874	17406000	21870	10799	111	0	\N
335391	1874	17408000	21870	10799	112	0	\N
335392	1874	17410000	21870	10799	113	0	\N
335393	1874	17412000	21870	10799	114	0	\N
335394	1874	17414000	21870	10799	115	0	\N
335395	1874	17416000	21870	10799	116	0	\N
335396	1874	17418000	21870	10799	117	0	\N
335397	1874	17420000	21870	10799	118	0	\N
335398	1874	17422000	21870	10799	119	0	\N
335399	1874	17424000	21870	10799	120	0	\N
335400	1874	17426000	21870	10799	121	0	\N
335401	1874	17428000	21870	10799	122	0	\N
335402	2291	0	21871	10800	0	0	\N
335403	1678	23040757895000	21871	10800	1	0	\N
335404	1678	23040757896000	21871	10800	2	0	\N
335405	1678	23040757897000	21871	10800	3	0	\N
335406	1678	23040757898000	21871	10800	4	0	\N
335407	1678	23040757899000	21871	10800	5	0	\N
335408	1678	23040757900000	21871	10800	6	0	\N
335409	1678	23040757901000	21871	10800	7	0	\N
335410	1678	23040757902000	21871	10800	8	0	\N
335411	1678	23040757903000	21871	10800	9	0	\N
335412	1678	23040757904000	21871	10800	10	0	\N
335413	1678	23040757905000	21871	10800	13	0	\N
335414	1678	23040757906000	21871	10800	14	0	\N
335415	1678	23040757907000	21871	10800	15	0	\N
335416	1678	23040757908000	21871	10800	16	0	\N
335417	1678	23040757909000	21871	10800	17	0	\N
335418	1678	23040757910000	21871	10800	18	0	\N
335419	1678	23040757911000	21871	10800	19	0	\N
335420	1678	23040757912000	21871	10800	20	0	\N
335421	1678	23040757913000	21871	10800	21	0	\N
335422	1678	23040757914000	21871	10800	22	0	\N
335423	1678	23040757915000	21871	10800	23	0	\N
335424	1678	23040757916000	21871	10800	24	0	\N
335425	1678	23040757917000	21871	10800	25	0	\N
335426	1678	23040757918000	21871	10800	26	0	\N
335427	1678	23040757919000	21871	10800	27	0	\N
335428	1678	23040757920000	21871	10800	28	0	\N
335429	1678	23040757921000	21871	10800	29	0	\N
335430	1678	23040757922000	21871	10800	30	0	\N
335431	1678	23040757923000	21871	10800	31	0	\N
335432	1678	23040757924000	21871	10800	32	0	\N
335433	1678	23040757925000	21871	10800	33	0	\N
335442	1678	23760768006000	21874	10945	0	0	\N
335443	1678	23760768007000	21874	10945	1	0	\N
335444	1678	23760768008000	21874	10945	2	0	\N
335445	1874	18354000	21874	10945	3	0	\N
335446	1874	18357000	21874	10945	4	0	\N
335447	1874	18360000	21874	10945	5	0	\N
335448	1874	18362000	21874	10945	6	0	\N
335449	1874	18364000	21874	10945	7	0	\N
335450	1678	23760768003000	21875	10940	0	0	\N
335451	1678	23760768004000	21875	10940	1	0	\N
335452	1678	23760768005000	21875	10940	2	0	\N
335453	1678	23760768006000	21875	10940	3	0	\N
335454	1678	23760768007000	21875	10940	4	0	\N
335455	1678	23760768008000	21875	10940	5	0	\N
335456	1874	18337000	21875	10940	6	0	\N
335457	1874	18340000	21875	10940	7	0	\N
335458	1874	18342000	21875	10940	8	0	\N
335459	1874	18345000	21875	10940	9	0	\N
335460	1874	18348000	21875	10940	10	0	\N
335461	1874	18351000	21875	10940	11	0	\N
335462	1874	18354000	21875	10940	12	0	\N
335463	1874	18356000	21875	10940	13	0	\N
335464	1874	18358000	21875	10940	14	0	\N
335465	1874	18360000	21875	10940	15	0	\N
335466	1874	18362000	21875	10940	16	0	\N
335467	1874	18364000	21875	10940	17	0	\N
335471	1678	23760768009000	21877	10946	0	0	\N
335472	1874	18366000	21877	10946	1	0	\N
335473	1874	18369000	21877	10946	2	0	\N
335483	1678	23760768011000	21880	10948	0	0	\N
335484	1678	23760768012000	21880	10948	1	0	\N
335485	1874	18377000	21880	10948	2	0	\N
335486	1874	18380000	21880	10948	3	0	\N
335487	1874	18382000	21880	10948	4	0	\N
335488	1874	18384000	21880	10948	5	0	\N
335495	1678	23760768015000	21883	10950	0	0	\N
335496	1874	18396000	21883	10950	1	0	\N
335497	1874	18399000	21883	10950	2	0	\N
335436	1678	23760768008000	21873	10945	2	0	0
335437	1874	18354000	21873	10945	3	0	2
335438	1874	18357000	21873	10945	4	0	2
335439	1874	18360000	21873	10945	5	0	2
335440	1874	18362000	21873	10945	6	0	2
335468	1678	23760768009000	21876	10946	0	0	0
335469	1874	18366000	21876	10946	1	0	2
335470	1874	18369000	21876	10946	2	0	2
335474	1678	23760768010000	21878	10947	0	0	0
335475	1874	18372000	21878	10947	1	0	2
335477	1678	23760768011000	21879	10948	0	0	0
335478	1678	23760768012000	21879	10948	1	0	0
335479	1874	18377000	21879	10948	2	0	2
335480	1874	18380000	21879	10948	3	0	2
335482	1874	18384000	21879	10948	5	0	2
335489	1678	23760768013000	21882	10949	0	0	0
335490	1678	23760768014000	21882	10949	1	0	0
335491	1874	18386000	21882	10949	2	0	2
335492	1874	18388000	21882	10949	3	0	2
335494	1874	18394000	21882	10949	5	0	2
335498	1678	23760768015000	21884	10950	0	0	0
335499	1874	18396000	21884	10950	1	0	2
335500	1874	18399000	21884	10950	2	0	2
335501	1678	23760768016000	21885	10951	0	0	0
335503	1874	18404000	21885	10951	2	0	2
335504	1678	23760768017000	21886	10952	0	0	0
335505	1874	18406000	21886	10952	1	0	2
335506	1874	18409000	21886	10952	2	0	2
335508	1874	18412000	21887	10953	1	0	2
335509	1874	18414000	21887	10953	2	0	2
335510	1678	23760768019000	21888	10954	0	0	0
335511	1874	18417000	21888	10954	1	0	2
335512	1874	18419000	21888	10954	2	0	2
335513	1678	23760768019000	21889	10954	0	0	\N
335514	1874	18417000	21889	10954	1	0	\N
335515	1874	18419000	21889	10954	2	0	\N
335518	1678	23760768020000	21892	10955	0	0	\N
335519	1874	18421000	21892	10955	1	0	\N
335520	1874	18424000	21892	10955	2	0	\N
335521	1678	23760768020000	21893	10955	0	0	\N
335522	1874	18421000	21893	10955	1	0	\N
335523	1874	18424000	21893	10955	2	0	\N
335524	1678	23760768020000	21894	10955	0	0	\N
335525	1874	18421000	21894	10955	1	0	\N
335526	1874	18424000	21894	10955	2	0	\N
335531	1678	23760768022000	21896	10957	0	0	\N
335532	1874	18431000	21896	10957	1	0	\N
335533	1874	18434000	21896	10957	2	0	\N
335543	1678	23760768023000	21899	10958	0	0	\N
335544	1678	23760768024000	21899	10958	1	0	\N
335545	1874	18436000	21899	10958	2	0	\N
335546	1874	18439000	21899	10958	3	0	\N
335547	1874	18442000	21899	10958	4	0	\N
335548	1874	18444000	21899	10958	5	0	\N
335549	1678	23760768025000	21900	10959	0	0	\N
335550	1874	18447000	21900	10959	1	0	\N
335551	1874	18449000	21900	10959	2	0	\N
335552	1678	23760768025000	21901	10959	0	0	\N
335553	1874	18447000	21901	10959	1	0	\N
335554	1874	18449000	21901	10959	2	0	\N
335561	1678	23760768026000	21904	10960	0	0	\N
335562	1874	18451000	21904	10960	1	0	\N
335563	1874	18454000	21904	10960	2	0	\N
335564	1678	23760767952000	21905	10896	0	0	\N
335565	1678	23760767953000	21905	10896	1	0	\N
335566	1678	23760767954000	21905	10896	2	0	\N
335567	1678	23760767955000	21905	10896	4	0	\N
335568	1678	23760767956000	21905	10896	5	0	\N
335569	1678	23760767957000	21905	10896	6	0	\N
335570	1678	23760767958000	21905	10896	7	0	\N
335571	1678	23760767959000	21905	10896	8	0	\N
335572	1678	23760767960000	21905	10896	9	0	\N
335573	1678	23760767961000	21905	10896	10	0	\N
335574	1678	23760767962000	21905	10896	11	0	\N
335575	1678	23760767963000	21905	10896	12	0	\N
335576	1678	23760767964000	21905	10896	13	0	\N
335577	1678	23760767965000	21905	10896	14	0	\N
335578	1678	23760767966000	21905	10896	15	0	\N
335579	1678	23760767967000	21905	10896	16	0	\N
335580	1678	23760767968000	21905	10896	17	0	\N
335581	1678	23760767969000	21905	10896	18	0	\N
335582	1678	23760767970000	21905	10896	19	0	\N
335583	1678	23760767971000	21905	10896	20	0	\N
335584	1678	23760767972000	21905	10896	21	0	\N
335585	1678	23760767973000	21905	10896	22	0	\N
335586	1678	23760767974000	21905	10896	23	0	\N
335587	1678	23760767975000	21905	10896	24	0	\N
335588	1678	23760767976000	21905	10896	25	0	\N
335589	1678	23760767977000	21905	10896	26	0	\N
335590	1678	23760767978000	21905	10896	27	0	\N
335591	1678	23760767979000	21905	10896	28	0	\N
335592	1678	23760767980000	21905	10896	29	0	\N
335593	1678	23760767981000	21905	10896	30	0	\N
335594	1678	23760767982000	21905	10896	31	0	\N
335595	1678	23760767983000	21905	10896	32	0	\N
335596	1678	23760767984000	21905	10896	33	0	\N
335597	1678	23760767985000	21905	10896	34	0	\N
335598	1678	23760767986000	21905	10896	35	0	\N
335599	1678	23760767987000	21905	10896	36	0	\N
335600	1678	23760767988000	21905	10896	37	0	\N
335601	1678	23760767989000	21905	10896	38	0	\N
335602	1678	23760767990000	21905	10896	39	0	\N
335603	1678	23760767991000	21905	10896	40	0	\N
335604	1678	23760767992000	21905	10896	41	0	\N
335605	1678	23760767993000	21905	10896	42	0	\N
335606	1678	23760767994000	21905	10896	43	0	\N
335607	1678	23760767995000	21905	10896	44	0	\N
335608	1678	23760767996000	21905	10896	45	0	\N
335609	1678	23760767997000	21905	10896	46	0	\N
335610	1678	23760767998000	21905	10896	47	0	\N
335611	1678	23760767999000	21905	10896	48	0	\N
335612	1678	23760768000000	21905	10896	49	0	\N
335613	1678	23760768001000	21905	10896	50	0	\N
335614	1678	23760768002000	21905	10896	51	0	\N
335615	1678	23760768003000	21905	10896	52	0	\N
335616	1678	23760768004000	21905	10896	53	0	\N
335617	1678	23760768005000	21905	10896	54	0	\N
335618	1678	23760768006000	21905	10896	55	0	\N
335619	1678	23760768007000	21905	10896	56	0	\N
335620	1678	23760768008000	21905	10896	57	0	\N
335621	1678	23760768009000	21905	10896	58	0	\N
335622	1678	23760768010000	21905	10896	59	0	\N
335623	1678	23760768011000	21905	10896	60	0	\N
335624	1678	23760768012000	21905	10896	61	0	\N
335625	1678	23760768013000	21905	10896	62	0	\N
335626	1678	23760768014000	21905	10896	63	0	\N
335627	1678	23760768015000	21905	10896	64	0	\N
335628	1678	23760768016000	21905	10896	65	0	\N
335629	1678	23760768017000	21905	10896	66	0	\N
335630	1678	23760768018000	21905	10896	67	0	\N
335631	1678	23760768019000	21905	10896	68	0	\N
335632	1678	23760768020000	21905	10896	69	0	\N
335633	1678	23760768021000	21905	10896	70	0	\N
335634	1678	23760768022000	21905	10896	71	0	\N
335635	1678	23760768023000	21905	10896	72	0	\N
335636	1678	23760768024000	21905	10896	73	0	\N
335637	1678	23760768025000	21905	10896	74	0	\N
335638	1678	23760768026000	21905	10896	75	0	\N
335639	1874	18084000	21905	10896	76	0	\N
335640	1874	18086000	21905	10896	77	0	\N
335641	1874	18089000	21905	10896	78	0	\N
335642	1874	18092000	21905	10896	79	0	\N
335643	1874	18094000	21905	10896	80	0	\N
335644	1874	18097000	21905	10896	81	0	\N
335645	1874	18100000	21905	10896	82	0	\N
335646	1874	18103000	21905	10896	83	0	\N
335647	1874	18106000	21905	10896	84	0	\N
335648	1874	18109000	21905	10896	85	0	\N
335527	1678	23760768020000	21895	10956	0	0	0
335528	1678	23760768021000	21895	10956	1	0	0
335529	1874	18426000	21895	10956	2	0	2
335530	1874	18429000	21895	10956	3	0	2
335534	1678	23760768022000	21897	10957	0	0	0
335536	1874	18434000	21897	10957	2	0	2
335537	1678	23760768023000	21898	10958	0	0	0
335538	1678	23760768024000	21898	10958	1	0	0
335539	1874	18436000	21898	10958	2	0	2
335540	1874	18439000	21898	10958	3	0	2
335542	1874	18444000	21898	10958	5	0	2
335555	1678	23760768025000	21902	10959	0	0	0
335556	1874	18447000	21902	10959	1	0	2
335557	1874	18449000	21902	10959	2	0	2
335559	1874	18451000	21903	10960	1	0	2
335560	1874	18454000	21903	10960	2	0	2
335649	1874	18112000	21905	10896	86	0	\N
335650	1874	18115000	21905	10896	87	0	\N
335651	1874	18118000	21905	10896	88	0	\N
335652	1874	18121000	21905	10896	89	0	\N
335653	1874	18124000	21905	10896	90	0	\N
335654	1874	18127000	21905	10896	91	0	\N
335655	1874	18130000	21905	10896	92	0	\N
335656	1874	18133000	21905	10896	93	0	\N
335657	1874	18136000	21905	10896	94	0	\N
335658	1874	18139000	21905	10896	95	0	\N
335659	1874	18142000	21905	10896	96	0	\N
335660	1874	18145000	21905	10896	97	0	\N
335661	1874	18148000	21905	10896	98	0	\N
335662	1874	18151000	21905	10896	99	0	\N
335663	1874	18154000	21905	10896	100	0	\N
335664	1874	18157000	21905	10896	101	0	\N
335665	1874	18160000	21905	10896	102	0	\N
335666	1874	18163000	21905	10896	103	0	\N
335667	1874	18166000	21905	10896	104	0	\N
335668	1874	18169000	21905	10896	105	0	\N
335669	1874	18172000	21905	10896	106	0	\N
335670	1874	18175000	21905	10896	107	0	\N
335671	1874	18178000	21905	10896	108	0	\N
335672	1874	18181000	21905	10896	109	0	\N
335673	1874	18184000	21905	10896	110	0	\N
335674	1874	18187000	21905	10896	111	0	\N
335675	1874	18190000	21905	10896	112	0	\N
335676	1874	18193000	21905	10896	113	0	\N
335677	1874	18196000	21905	10896	114	0	\N
335678	1874	18199000	21905	10896	115	0	\N
335679	1874	18202000	21905	10896	116	0	\N
335680	1874	18205000	21905	10896	117	0	\N
335681	1874	18208000	21905	10896	118	0	\N
335682	1874	18211000	21905	10896	119	0	\N
335683	1874	18214000	21905	10896	120	0	\N
335684	1874	18217000	21905	10896	121	0	\N
335685	1874	18220000	21905	10896	122	0	\N
335686	1874	18223000	21905	10896	123	0	\N
335687	1874	18226000	21905	10896	124	0	\N
335688	1874	18228000	21905	10896	125	0	\N
335698	1678	23760768028000	21908	10962	0	0	\N
335699	1678	23760768029000	21908	10962	1	0	\N
335700	1874	18461000	21908	10962	2	0	\N
335701	1874	18463000	21908	10962	3	0	\N
335702	1874	18466000	21908	10962	4	0	\N
335703	1874	18469000	21908	10962	5	0	\N
335704	1678	23760768028000	21909	10962	0	0	\N
335705	1678	23760768029000	21909	10962	1	0	\N
335706	1874	18461000	21909	10962	2	0	\N
335707	1874	18463000	21909	10962	3	0	\N
335708	1874	18466000	21909	10962	4	0	\N
335709	1874	18469000	21909	10962	5	0	\N
335726	1678	23760768033000	21916	10967	0	0	\N
335727	1678	23760768034000	21916	10967	1	0	\N
335728	602	66010000000000	21916	10967	3	0	\N
335729	1874	18488000	21916	10967	4	0	\N
335730	1874	18491000	21916	10967	5	0	\N
335731	1874	18494000	21916	10967	6	0	\N
335732	602	66010000000000	21917	10967	0	0	\N
335733	1874	18488000	21917	10967	1	0	\N
335740	1678	23760768037000	21919	10969	0	0	\N
335741	1678	23760768038000	21919	10969	1	0	\N
335742	1874	18507000	21919	10969	2	0	\N
335743	1874	18510000	21919	10969	3	0	\N
335744	1874	18512000	21919	10969	4	0	\N
335745	1874	18514000	21919	10969	5	0	\N
335752	1874	18507000	21921	10969	0	0	\N
335753	1874	18510000	21921	10969	1	0	\N
335754	1874	18512000	21921	10969	2	0	\N
335755	1874	18514000	21921	10969	3	0	\N
335780	1678	23760768047000	21925	10972	0	0	\N
335781	1874	18557000	21925	10972	1	0	\N
335782	1874	18559000	21925	10972	2	0	\N
335783	1678	23760768047000	21926	10972	0	0	\N
335784	1874	18557000	21926	10972	1	0	\N
335691	1874	18459000	21906	10961	2	0	2
335692	1678	23760768028000	21907	10962	0	0	0
335693	1678	23760768029000	21907	10962	1	0	0
335694	1874	18461000	21907	10962	2	0	2
335695	1874	18463000	21907	10962	3	0	2
335697	1874	18469000	21907	10962	5	0	2
335710	1678	23760768030000	21910	10963	0	0	0
335711	1874	18472000	21910	10963	1	0	2
335712	1874	18474000	21910	10963	2	0	2
335713	1678	23760768031000	21911	10964	0	0	0
335715	1874	18479000	21911	10964	2	0	2
335716	1678	23760768032000	21913	10965	0	0	0
335717	1874	18482000	21913	10965	1	0	2
335718	1874	18484000	21913	10965	2	0	2
335720	1678	23760768033000	21915	10967	0	0	0
335721	1678	23760768034000	21915	10967	1	0	0
335722	602	66010000000000	21915	10967	3	0	0
335723	1874	18488000	21915	10967	4	0	2
335724	1874	18491000	21915	10967	5	0	2
335734	1678	23760768035000	21918	10968	0	0	0
335735	1678	23760768036000	21918	10968	1	0	0
335736	1874	18496000	21918	10968	2	0	2
335737	1874	18498000	21918	10968	3	0	2
335738	1874	18501000	21918	10968	4	0	2
335746	1678	23760768037000	21920	10969	0	0	0
335747	1678	23760768038000	21920	10969	1	0	0
335748	1874	18507000	21920	10969	2	0	2
335749	1874	18510000	21920	10969	3	0	2
335751	1874	18514000	21920	10969	5	0	2
335756	1678	23760768039000	21923	10970	0	0	0
335757	1678	23760768040000	21923	10970	1	0	0
335758	1678	23760768041000	21923	10970	2	0	0
335759	1678	23760768042000	21923	10970	3	0	0
335761	1678	23760768044000	21923	10970	5	0	0
335762	1678	23760768045000	21923	10970	6	0	0
335763	1874	18517000	21923	10970	7	0	2
335764	1874	18520000	21923	10970	8	0	2
335765	1874	18523000	21923	10970	9	0	2
335767	1874	18529000	21923	10970	11	0	2
335768	1874	18532000	21923	10970	12	0	2
335769	1874	18535000	21923	10970	13	0	2
335770	1874	18537000	21923	10970	14	0	2
335772	1874	18541000	21923	10970	16	0	2
335773	1874	18543000	21923	10970	17	0	2
335774	1874	18545000	21923	10970	18	0	2
335775	1874	18547000	21923	10970	19	0	2
335776	1874	18549000	21923	10970	20	0	2
335778	1874	18552000	21924	10971	1	0	2
335779	1874	18554000	21924	10971	2	0	2
335785	1874	18559000	21926	10972	2	0	\N
335789	1678	23760768047000	21928	10972	0	0	\N
335790	1874	18557000	21928	10972	1	0	\N
335791	1874	18559000	21928	10972	2	0	\N
335792	1678	23760768047000	21929	10972	0	0	\N
335793	1874	18557000	21929	10972	1	0	\N
335794	1678	23760768047000	21930	10972	0	0	\N
335795	1874	18557000	21930	10972	1	0	\N
335796	1874	18559000	21930	10972	2	0	\N
335802	1678	23760768050000	21932	10974	0	0	\N
335803	1874	18569000	21932	10974	1	0	\N
335806	1678	23760768050000	21934	10974	0	0	\N
335807	1874	18569000	21934	10974	1	0	\N
335808	1678	23760768051000	21936	10975	0	0	\N
335809	1874	18571000	21936	10975	1	0	\N
335810	1874	18574000	21936	10975	2	0	\N
335811	1678	23760768051000	21937	10975	0	0	\N
335812	1874	18571000	21937	10975	1	0	\N
335813	1874	18574000	21937	10975	2	0	\N
335814	1678	23760768051000	21938	10975	0	0	\N
335815	1874	18571000	21938	10975	1	0	\N
335816	1874	18574000	21938	10975	2	0	\N
335817	1678	23760768051000	21939	10975	0	0	\N
335818	1874	18571000	21939	10975	1	0	\N
335819	1874	18574000	21939	10975	2	0	\N
335826	1678	23760768052000	21942	10976	0	0	\N
335827	1874	18577000	21942	10976	1	0	\N
335828	1874	18579000	21942	10976	2	0	\N
335841	1678	23760768056000	21946	10979	0	0	\N
335842	1874	18597000	21946	10979	1	0	\N
335843	1874	18599000	21946	10979	2	0	\N
335844	1678	23760768056000	21947	10979	0	0	\N
335845	1874	18597000	21947	10979	1	0	\N
335846	1874	18599000	21947	10979	2	0	\N
335859	1678	23760768058000	21951	10981	0	0	\N
335860	1678	23760768059000	21951	10981	1	0	\N
335861	1678	23760768060000	21951	10981	2	0	\N
335862	1874	18606000	21951	10981	3	0	\N
335863	1874	18608000	21951	10981	4	0	\N
335864	1874	18610000	21951	10981	5	0	\N
335865	1874	18613000	21951	10981	6	0	\N
335866	1874	18616000	21951	10981	7	0	\N
335867	1874	18619000	21951	10981	8	0	\N
335880	1678	23760768065000	21955	10985	0	0	\N
335881	1678	23760768066000	21955	10985	1	0	\N
335882	1678	23760768067000	21955	10985	2	0	\N
335883	1874	18641000	21955	10985	3	0	\N
335884	1874	18643000	21955	10985	4	0	\N
335885	1874	18645000	21955	10985	5	0	\N
335886	1874	18648000	21955	10985	6	0	\N
335887	1874	18651000	21955	10985	7	0	\N
335888	1874	18654000	21955	10985	8	0	\N
335889	1678	23760768065000	21956	10985	0	0	\N
335890	1678	23760768066000	21956	10985	1	0	\N
335891	1678	23760768067000	21956	10985	2	0	\N
335892	1874	18641000	21956	10985	3	0	\N
335893	1874	18643000	21956	10985	4	0	\N
335894	1874	18645000	21956	10985	5	0	\N
335895	1874	18648000	21956	10985	6	0	\N
335896	1874	18651000	21956	10985	7	0	\N
335897	1874	18654000	21956	10985	8	0	\N
335898	1678	23760768065000	21957	10985	0	0	\N
335899	1678	23760768066000	21957	10985	1	0	\N
335900	1678	23760768067000	21957	10985	2	0	\N
335901	1874	18641000	21957	10985	3	0	\N
335902	1874	18643000	21957	10985	4	0	\N
335903	1874	18645000	21957	10985	5	0	\N
335904	1874	18648000	21957	10985	6	0	\N
335905	1874	18651000	21957	10985	7	0	\N
335906	1874	18654000	21957	10985	8	0	\N
335916	1678	23760768065000	21959	10985	0	0	\N
335917	1678	23760768066000	21959	10985	1	0	\N
335918	1678	23760768067000	21959	10985	2	0	\N
335919	1874	18641000	21959	10985	3	0	\N
335920	1874	18643000	21959	10985	4	0	\N
335788	1874	18559000	21927	10972	2	0	2
335797	1678	23760768048000	21931	10973	0	0	0
335798	1678	23760768049000	21931	10973	1	0	0
335799	1874	18561000	21931	10973	2	0	2
335800	1874	18564000	21931	10973	3	0	2
335804	1678	23760768050000	21933	10974	0	0	0
335805	1874	18569000	21933	10974	1	0	2
335820	1678	23760768051000	21940	10975	0	0	0
335821	1874	18571000	21940	10975	1	0	2
335822	1874	18574000	21940	10975	2	0	2
335824	1874	18577000	21941	10976	1	0	2
335825	1874	18579000	21941	10976	2	0	2
335829	1678	23760768053000	21943	10977	0	0	0
335830	1678	23760768054000	21943	10977	1	0	0
335832	1874	18583000	21943	10977	4	0	2
335833	1874	18586000	21943	10977	5	0	2
335834	1874	18589000	21943	10977	6	0	2
335835	1678	23760768055000	21944	10978	0	0	0
335836	1874	18592000	21944	10978	1	0	2
335838	1678	23760768056000	21945	10979	0	0	0
335839	1874	18597000	21945	10979	1	0	2
335840	1874	18599000	21945	10979	2	0	2
335847	1678	23760768057000	21949	10980	0	0	0
335848	1874	18602000	21949	10980	1	0	2
335850	1678	23760768058000	21950	10981	0	0	0
335851	1678	23760768059000	21950	10981	1	0	0
335852	1678	23760768060000	21950	10981	2	0	0
335853	1874	18606000	21950	10981	3	0	2
335855	1874	18610000	21950	10981	5	0	2
335856	1874	18613000	21950	10981	6	0	2
335857	1874	18616000	21950	10981	7	0	2
335858	1874	18619000	21950	10981	8	0	2
335868	1678	23760768061000	21952	10982	0	0	0
335870	1874	18622000	21952	10982	2	0	2
335871	1874	18625000	21952	10982	3	0	2
335872	1874	18627000	21952	10982	4	0	2
335873	1874	18629000	21952	10982	5	0	2
335874	1678	23760768063000	21953	10983	0	0	0
335876	1874	18631000	21953	10983	2	0	2
335877	1874	18634000	21953	10983	3	0	2
335878	1874	18636000	21953	10983	4	0	2
335879	1874	18639000	21953	10983	5	0	2
335908	1678	23760768066000	21958	10985	1	0	0
335909	1678	23760768067000	21958	10985	2	0	0
335910	1874	18641000	21958	10985	3	0	2
335911	1874	18643000	21958	10985	4	0	2
335912	1874	18645000	21958	10985	5	0	2
335914	1874	18651000	21958	10985	7	0	2
335915	1874	18654000	21958	10985	8	0	2
335921	1874	18645000	21959	10985	5	0	\N
335922	1874	18648000	21959	10985	6	0	\N
335923	1874	18651000	21959	10985	7	0	\N
335924	1874	18654000	21959	10985	8	0	\N
335928	1678	23760768068000	21961	10986	0	0	\N
335929	1874	18656000	21961	10986	1	0	\N
335930	1874	18659000	21961	10986	2	0	\N
335931	1678	23760768069000	21962	10987	0	0	\N
335932	1874	18662000	21962	10987	1	0	\N
335933	1874	18664000	21962	10987	2	0	\N
335934	1678	23760768069000	21963	10987	0	0	\N
335935	1874	18662000	21963	10987	1	0	\N
335936	1874	18664000	21963	10987	2	0	\N
335940	1678	23760768069000	21965	10987	0	0	\N
335941	1874	18662000	21965	10987	1	0	\N
335942	1874	18664000	21965	10987	2	0	\N
335943	1678	23760768069000	21966	10987	0	0	\N
335944	1874	18662000	21966	10987	1	0	\N
335945	1874	18664000	21966	10987	2	0	\N
335946	602	66010000000000	21967	10912	0	0	\N
335947	1678	23760768068000	21968	10986	0	0	\N
335948	1678	23760768069000	21968	10986	1	0	\N
335949	1874	18656000	21968	10986	2	0	\N
335950	1874	18658000	21968	10986	3	0	\N
335951	1874	18661000	21968	10986	4	0	\N
335952	1874	18664000	21968	10986	5	0	\N
335953	1678	23760768070000	21972	10988	0	0	\N
335954	1678	23760768071000	21972	10988	1	0	\N
335955	1874	18666000	21972	10988	2	0	\N
335956	1874	18668000	21972	10988	3	0	\N
335957	1874	18671000	21972	10988	4	0	\N
335958	1874	18674000	21972	10988	5	0	\N
335959	1678	23760768070000	21973	10988	0	0	\N
335960	1678	23760768071000	21973	10988	1	0	\N
335961	1874	18667000	21973	10988	2	0	\N
335962	1874	18670000	21973	10988	3	0	\N
335969	1678	23760768070000	21975	10988	0	0	\N
335970	1678	23760768071000	21975	10988	1	0	\N
335971	1874	18666000	21975	10988	2	0	\N
335972	1874	18668000	21975	10988	3	0	\N
335973	1874	18671000	21975	10988	4	0	\N
335974	1874	18674000	21975	10988	5	0	\N
335975	1678	23760768070000	21976	10988	0	0	\N
335976	1678	23760768071000	21976	10988	1	0	\N
335977	1874	18666000	21976	10988	2	0	\N
335978	1874	18668000	21976	10988	3	0	\N
335979	1874	18671000	21976	10988	4	0	\N
335980	1874	18674000	21976	10988	5	0	\N
335981	1678	23760768072000	21977	10989	0	0	\N
335982	1874	18677000	21977	10989	1	0	\N
335983	1874	18679000	21977	10989	2	0	\N
335984	1678	23760768072000	21978	10989	0	0	\N
335985	1874	18677000	21978	10989	1	0	\N
335986	1874	18679000	21978	10989	2	0	\N
335987	1678	23760768072000	21979	10989	0	0	\N
335988	1874	18677000	21979	10989	1	0	\N
335989	1874	18679000	21979	10989	2	0	\N
335993	2291	0	21981	10813	0	0	\N
335994	588	66783000000000	21981	10813	1	0	\N
335995	1678	23040757831000	21981	10813	2	0	\N
335996	1021	507244438919578	21981	10813	3	0	\N
335997	1958	5231186000000	21981	10813	4	0	\N
335998	1483	10000000	21981	10813	5	0	\N
335999	1483	10000000	21981	10813	6	0	\N
336000	1678	23040757832000	21981	10813	7	0	\N
336001	1508	22688206929693	21981	10813	8	0	\N
336002	2290	100000000	21981	10813	9	0	\N
336003	1678	23040757833000	21981	10813	10	0	\N
336004	1678	23040757834000	21981	10813	11	0	\N
336005	1678	23040757835000	21981	10813	12	0	\N
336006	1678	23040757836000	21981	10813	13	0	\N
336007	1678	23040757837000	21981	10813	14	0	\N
336008	1508	22939776541648	21981	10813	15	0	\N
336009	1678	23040757838000	21981	10813	16	0	\N
336010	1678	23040757839000	21981	10813	17	0	\N
336011	1678	23040757840000	21981	10813	18	0	\N
336012	1678	23040757841000	21981	10813	19	0	\N
336013	1678	23040757842000	21981	10813	20	0	\N
336014	1678	23040757843000	21981	10813	21	0	\N
336015	1678	23040757844000	21981	10813	22	0	\N
336016	1678	23040757845000	21981	10813	23	0	\N
336017	1678	23040757846000	21981	10813	24	0	\N
336018	1678	23040757847000	21981	10813	25	0	\N
336019	1678	23040757848000	21981	10813	26	0	\N
336020	1678	23040757849000	21981	10813	27	0	\N
336021	1678	23040757850000	21981	10813	28	0	\N
336022	1678	23040757851000	21981	10813	29	0	\N
336023	1678	23040757852000	21981	10813	30	0	\N
336024	1678	23040757853000	21981	10813	31	0	\N
336025	1678	23040757854000	21981	10813	32	0	\N
336026	1678	23040757855000	21981	10813	33	0	\N
336027	1678	23040757856000	21981	10813	34	0	\N
336028	1678	23040757857000	21981	10813	35	0	\N
336029	1678	23040757858000	21981	10813	36	0	\N
336030	1678	23040757859000	21981	10813	37	0	\N
336031	1678	23040757860000	21981	10813	38	0	\N
336032	1678	23040757861000	21981	10813	39	0	\N
336033	1678	23040757862000	21981	10813	40	0	\N
336034	1678	23040757863000	21981	10813	41	0	\N
336035	1678	23040757864000	21981	10813	42	0	\N
336036	1678	23040757865000	21981	10813	43	0	\N
336037	1678	23040757866000	21981	10813	44	0	\N
336038	1678	23040757867000	21981	10813	45	0	\N
336039	1678	23040757868000	21981	10813	46	0	\N
336040	1678	23040757869000	21981	10813	47	0	\N
336041	1678	23040757870000	21981	10813	48	0	\N
336042	1678	23040757871000	21981	10813	49	0	\N
336043	1678	23040757872000	21981	10813	50	0	\N
336044	1678	23040757873000	21981	10813	51	0	\N
336045	1678	23040757874000	21981	10813	52	0	\N
336046	1678	23040757875000	21981	10813	53	0	\N
336047	1678	23040757876000	21981	10813	54	0	\N
336048	1678	23040757877000	21981	10813	55	0	\N
336049	1678	23040757878000	21981	10813	56	0	\N
336050	1678	23040757879000	21981	10813	57	0	\N
336051	1678	23040757880000	21981	10813	58	0	\N
336052	1678	23040757881000	21981	10813	59	0	\N
336053	1678	23040757882000	21981	10813	60	0	\N
336054	1678	23040757883000	21981	10813	61	0	\N
336055	1678	23040757884000	21981	10813	62	0	\N
336056	1678	23040757885000	21981	10813	63	0	\N
335927	1874	18659000	21960	10986	2	0	2
335937	1678	23760768069000	21964	10987	0	0	0
335938	1874	18662000	21964	10987	1	0	2
335939	1874	18664000	21964	10987	2	0	2
335963	1678	23760768070000	21974	10988	0	0	0
335965	1874	18666000	21974	10988	2	0	2
335966	1874	18668000	21974	10988	3	0	2
335967	1874	18671000	21974	10988	4	0	2
335968	1874	18674000	21974	10988	5	0	2
335990	1678	23760768072000	21980	10989	0	0	0
335992	1874	18679000	21980	10989	2	0	2
336057	1678	23040757886000	21981	10813	65	0	\N
336058	1678	23040757887000	21981	10813	66	0	\N
336059	1678	23040757888000	21981	10813	67	0	\N
336060	1678	23040757889000	21981	10813	68	0	\N
336061	1678	23040757890000	21981	10813	69	0	\N
336062	1678	23040757891000	21981	10813	70	0	\N
336063	1141	908977688473491	21981	10813	71	0	\N
336064	1261	613305359073006	21981	10813	72	0	\N
336065	1387	1709029915128959	21981	10813	73	0	\N
336066	1678	23040757892000	21981	10813	74	0	\N
336067	973	507337115000000	21981	10813	75	0	\N
336068	1678	23040757893000	21981	10813	76	0	\N
336069	1678	23040757894000	21981	10813	77	0	\N
336070	1678	23040757895000	21981	10813	78	0	\N
336071	1678	23040757896000	21981	10813	79	0	\N
336072	1678	23040757897000	21981	10813	80	0	\N
336073	1678	23040757898000	21981	10813	81	0	\N
336074	1678	23040757899000	21981	10813	82	0	\N
336075	1678	23040757900000	21981	10813	83	0	\N
336076	1678	23040757901000	21981	10813	84	0	\N
336077	1678	23040757902000	21981	10813	85	0	\N
336078	1678	23040757903000	21981	10813	86	0	\N
336079	1678	23040757904000	21981	10813	87	0	\N
336080	1678	23040757905000	21981	10813	88	0	\N
336081	1678	23040757906000	21981	10813	89	0	\N
336082	1678	23040757907000	21981	10813	90	0	\N
336083	1678	23040757908000	21981	10813	91	0	\N
336084	1678	23040757909000	21981	10813	92	0	\N
336085	1678	23040757910000	21981	10813	93	0	\N
336086	1678	23040757911000	21981	10813	94	0	\N
336087	1678	23040757912000	21981	10813	95	0	\N
336088	1678	23040757913000	21981	10813	96	0	\N
336089	1678	23040757914000	21981	10813	97	0	\N
336090	1678	23040757915000	21981	10813	98	0	\N
336091	1678	23040757916000	21981	10813	99	0	\N
336092	1678	23040757917000	21981	10813	100	0	\N
336093	1678	23040757918000	21981	10813	101	0	\N
336094	1678	23040757919000	21981	10813	102	0	\N
336095	1678	23040757920000	21981	10813	103	0	\N
336096	1678	23040757921000	21981	10813	104	0	\N
336097	1678	23040757922000	21981	10813	105	0	\N
336098	1678	23040757923000	21981	10813	106	0	\N
336099	1678	23040757924000	21981	10813	107	0	\N
336100	1678	23040757925000	21981	10813	108	0	\N
336101	1678	23040757926000	21981	10813	109	0	\N
336102	1678	23040757927000	21981	10813	110	0	\N
336103	1678	23040757928000	21981	10813	111	0	\N
336104	1678	23040757929000	21981	10813	112	0	\N
336105	1678	23040757930000	21981	10813	113	0	\N
336106	1678	23040757931000	21981	10813	114	0	\N
336107	1678	23040757932000	21981	10813	115	0	\N
336108	1678	23040757933000	21981	10813	116	0	\N
336109	1678	23040757934000	21981	10813	117	0	\N
336110	1678	23040757935000	21981	10813	118	0	\N
336111	1678	23040757936000	21981	10813	119	0	\N
336112	1678	23040757937000	21981	10813	120	0	\N
336113	1678	23040757938000	21981	10813	121	0	\N
336114	1678	23040757939000	21981	10813	122	0	\N
336115	1678	23040757940000	21981	10813	123	0	\N
336116	1678	23040757941000	21981	10813	124	0	\N
336117	1678	23040757942000	21981	10813	125	0	\N
336118	1678	23760768072000	21982	10989	0	0	\N
336119	1874	18677000	21982	10989	1	0	\N
336120	1874	18679000	21982	10989	2	0	\N
336130	1678	23760768076000	21985	10992	0	0	\N
336131	1874	18697000	21985	10992	1	0	\N
336132	1874	18699000	21985	10992	2	0	\N
336150	1678	23760768081000	21991	10996	0	0	\N
336151	1874	18718000	21991	10996	1	0	\N
336152	1874	18721000	21991	10996	2	0	\N
336153	1678	23760768081000	21992	10996	0	0	\N
336154	1874	18718000	21992	10996	1	0	\N
336155	1874	18721000	21992	10996	2	0	\N
336156	1678	23760768081000	21993	10996	0	0	\N
336157	1874	18718000	21993	10996	1	0	\N
336158	1874	18721000	21993	10996	2	0	\N
336174	1678	23760768086000	21998	11000	0	0	\N
336175	1874	18744000	21998	11000	1	0	\N
336176	1874	18746000	21998	11000	2	0	\N
336177	1678	23760768027000	21999	10897	0	0	\N
336178	1678	23760768028000	21999	10897	1	0	\N
336179	1678	23760768029000	21999	10897	2	0	\N
336180	1678	23760768030000	21999	10897	4	0	\N
336181	1678	23760768031000	21999	10897	5	0	\N
336182	1678	23760768032000	21999	10897	6	0	\N
336183	1678	23760768033000	21999	10897	7	0	\N
336184	1678	23760768034000	21999	10897	8	0	\N
336185	1678	23760768035000	21999	10897	9	0	\N
336186	1678	23760768036000	21999	10897	10	0	\N
336187	1678	23760768037000	21999	10897	11	0	\N
336188	1678	23760768038000	21999	10897	12	0	\N
336189	1678	23760768039000	21999	10897	13	0	\N
336190	1678	23760768040000	21999	10897	14	0	\N
336191	1678	23760768041000	21999	10897	15	0	\N
336192	1678	23760768042000	21999	10897	16	0	\N
336123	1874	18681000	21983	10990	2	0	2
336124	1874	18683000	21983	10990	3	0	2
336125	1874	18686000	21983	10990	4	0	2
336126	1874	18689000	21983	10990	5	0	2
336127	1678	23760768075000	21984	10991	0	0	0
336129	1874	18694000	21984	10991	2	0	2
336133	1678	23760768076000	21986	10992	0	0	0
336134	1874	18697000	21986	10992	1	0	2
336135	1874	18699000	21986	10992	2	0	2
336136	1678	23760768077000	21987	10993	0	0	0
336138	1874	18704000	21987	10993	2	0	2
336139	1678	23760768078000	21988	10994	0	0	0
336140	1874	18706000	21988	10994	1	0	2
336141	1678	23760768079000	21989	10995	0	0	0
336143	1874	18708000	21989	10995	2	0	2
336144	1874	18711000	21989	10995	3	0	2
336145	1874	18713000	21989	10995	4	0	2
336146	1874	18716000	21989	10995	5	0	2
336147	1678	23760768081000	21990	10996	0	0	0
336149	1874	18721000	21990	10996	2	0	2
336159	1678	23760768082000	21994	10997	0	0	0
336160	1678	23760768083000	21994	10997	1	0	0
336161	1874	18724000	21994	10997	2	0	2
336162	1874	18727000	21994	10997	3	0	2
336164	1874	18731000	21994	10997	5	0	2
336165	1678	23760768084000	21995	10998	0	0	0
336166	1874	18734000	21995	10998	1	0	2
336167	1874	18736000	21995	10998	2	0	2
336169	1874	18738000	21996	10999	1	0	2
336170	1874	18741000	21996	10999	2	0	2
336171	1678	23760768086000	21997	11000	0	0	0
336172	1874	18744000	21997	11000	1	0	2
336173	1874	18746000	21997	11000	2	0	2
336193	1678	23760768043000	21999	10897	17	0	\N
336194	1678	23760768044000	21999	10897	18	0	\N
336195	1678	23760768045000	21999	10897	19	0	\N
336196	1678	23760768046000	21999	10897	20	0	\N
336197	1678	23760768047000	21999	10897	21	0	\N
336198	1678	23760768048000	21999	10897	22	0	\N
336199	1678	23760768049000	21999	10897	23	0	\N
336200	1678	23760768050000	21999	10897	24	0	\N
336201	1678	23760768051000	21999	10897	25	0	\N
336202	1678	23760768052000	21999	10897	26	0	\N
336203	1678	23760768053000	21999	10897	27	0	\N
336204	1678	23760768054000	21999	10897	28	0	\N
336205	1678	23760768055000	21999	10897	29	0	\N
336206	1678	23760768056000	21999	10897	30	0	\N
336207	1678	23760768057000	21999	10897	31	0	\N
336208	1678	23760768058000	21999	10897	32	0	\N
336209	1678	23760768059000	21999	10897	33	0	\N
336210	1678	23760768060000	21999	10897	34	0	\N
336211	1678	23760768061000	21999	10897	35	0	\N
336212	1678	23760768062000	21999	10897	36	0	\N
336213	1678	23760768063000	21999	10897	37	0	\N
336214	1678	23760768064000	21999	10897	38	0	\N
336215	1678	23760768065000	21999	10897	39	0	\N
336216	1678	23760768066000	21999	10897	40	0	\N
336217	1678	23760768067000	21999	10897	41	0	\N
336218	1678	23760768068000	21999	10897	42	0	\N
336219	1678	23760768069000	21999	10897	43	0	\N
336220	1678	23760768070000	21999	10897	44	0	\N
336221	1678	23760768071000	21999	10897	45	0	\N
336222	1678	23760768072000	21999	10897	46	0	\N
336223	1678	23760768073000	21999	10897	47	0	\N
336224	1678	23760768074000	21999	10897	48	0	\N
336225	1678	23760768075000	21999	10897	49	0	\N
336226	1678	23760768076000	21999	10897	50	0	\N
336227	1678	23760768077000	21999	10897	51	0	\N
336228	1678	23760768078000	21999	10897	52	0	\N
336229	1678	23760768079000	21999	10897	53	0	\N
336230	1678	23760768080000	21999	10897	54	0	\N
336231	1678	23760768081000	21999	10897	55	0	\N
336232	1678	23760768082000	21999	10897	56	0	\N
336233	1678	23760768083000	21999	10897	57	0	\N
336234	1678	23760768084000	21999	10897	58	0	\N
336235	1678	23760768085000	21999	10897	59	0	\N
336236	1678	23760768086000	21999	10897	60	0	\N
336237	602	66010000000000	21999	10897	61	0	\N
336238	1874	18230000	21999	10897	63	0	\N
336239	1874	18232000	21999	10897	64	0	\N
336240	1874	18234000	21999	10897	65	0	\N
336241	1874	18236000	21999	10897	66	0	\N
336242	1874	18238000	21999	10897	67	0	\N
336243	1874	18240000	21999	10897	68	0	\N
336244	1874	18242000	21999	10897	69	0	\N
336245	1874	18244000	21999	10897	70	0	\N
336246	1874	18246000	21999	10897	71	0	\N
336247	1874	18248000	21999	10897	72	0	\N
336248	1874	18250000	21999	10897	73	0	\N
336249	1874	18252000	21999	10897	74	0	\N
336250	1874	18254000	21999	10897	75	0	\N
336251	1874	18256000	21999	10897	76	0	\N
336252	1874	18258000	21999	10897	77	0	\N
336253	1874	18260000	21999	10897	78	0	\N
336254	1874	18262000	21999	10897	79	0	\N
336255	1874	18264000	21999	10897	80	0	\N
336256	1874	18266000	21999	10897	81	0	\N
336257	1874	18268000	21999	10897	82	0	\N
336258	1874	18270000	21999	10897	83	0	\N
336259	1874	18272000	21999	10897	84	0	\N
336260	1874	18274000	21999	10897	85	0	\N
336261	1874	18276000	21999	10897	86	0	\N
336262	1874	18278000	21999	10897	87	0	\N
336263	1874	18280000	21999	10897	88	0	\N
336264	1874	18282000	21999	10897	89	0	\N
336265	1874	18284000	21999	10897	90	0	\N
336266	1874	18286000	21999	10897	91	0	\N
336267	1874	18288000	21999	10897	92	0	\N
336268	1874	18290000	21999	10897	93	0	\N
336269	1874	18292000	21999	10897	94	0	\N
336270	1874	18294000	21999	10897	95	0	\N
336271	1874	18296000	21999	10897	96	0	\N
336272	1874	18298000	21999	10897	97	0	\N
336273	1874	18300000	21999	10897	98	0	\N
336274	1874	18302000	21999	10897	99	0	\N
336275	1874	18304000	21999	10897	100	0	\N
336276	1874	18306000	21999	10897	101	0	\N
336277	1874	18308000	21999	10897	102	0	\N
336278	1874	18310000	21999	10897	103	0	\N
336279	1874	18312000	21999	10897	104	0	\N
336280	1874	18314000	21999	10897	105	0	\N
336281	1874	18316000	21999	10897	106	0	\N
336282	1874	18318000	21999	10897	107	0	\N
336283	1874	18320000	21999	10897	108	0	\N
336284	1874	18322000	21999	10897	109	0	\N
336285	1874	18324000	21999	10897	110	0	\N
336286	1874	18326000	21999	10897	111	0	\N
336287	1874	18328000	21999	10897	112	0	\N
336288	1874	18330000	21999	10897	113	0	\N
336289	1874	18332000	21999	10897	114	0	\N
336290	1874	18334000	21999	10897	115	0	\N
336291	1874	18336000	21999	10897	116	0	\N
336292	1874	18338000	21999	10897	117	0	\N
336293	1874	18340000	21999	10897	118	0	\N
336294	1874	18342000	21999	10897	119	0	\N
336295	1874	18344000	21999	10897	120	0	\N
336296	1874	18346000	21999	10897	121	0	\N
336297	1874	18348000	21999	10897	122	0	\N
336298	1874	18350000	21999	10897	123	0	\N
336299	1874	18352000	21999	10897	124	0	\N
336300	1874	18354000	21999	10897	125	0	\N
336304	1678	23760768087000	22001	11001	0	0	\N
336305	1874	18749000	22001	11001	1	0	\N
336306	1874	18751000	22001	11001	2	0	\N
336307	1678	23760768087000	22002	11001	0	0	\N
336308	1874	18749000	22002	11001	1	0	\N
336309	1874	18751000	22002	11001	2	0	\N
336323	1678	23760768092000	22006	11005	0	0	\N
336324	1874	18774000	22006	11005	1	0	\N
336325	1874	18776000	22006	11005	2	0	\N
336326	1678	23760768092000	22007	11005	0	0	\N
336327	1874	18774000	22007	11005	1	0	\N
336328	1874	18776000	22007	11005	2	0	\N
336303	1874	18751000	22000	11001	2	0	2
336310	1678	23760768088000	22003	11002	0	0	0
336311	1874	18753000	22003	11002	1	0	2
336312	1874	18756000	22003	11002	2	0	2
336313	1678	23760768089000	22004	11003	0	0	0
336315	1874	18761000	22004	11003	2	0	2
336316	1678	23760768090000	22005	11004	0	0	0
336317	1678	23760768091000	22005	11004	1	0	0
336318	1874	18763000	22005	11004	2	0	2
336319	1874	18765000	22005	11004	3	0	2
336321	1874	18768000	22005	11004	5	0	2
336322	1874	18771000	22005	11004	6	0	2
336335	1678	23760768093000	22010	11006	0	0	\N
336336	1874	18779000	22010	11006	2	0	\N
336337	1678	23760768093000	22011	11006	0	0	\N
336338	1874	18778000	22011	11006	2	0	\N
336339	1874	18781000	22011	11006	3	0	\N
336340	1678	23760768094000	22012	11007	0	0	\N
336341	1874	18784000	22012	11007	1	0	\N
336342	1874	18786000	22012	11007	2	0	\N
336348	1678	23760768095000	22015	11008	0	0	\N
336349	1874	18788000	22015	11008	1	0	\N
336350	1874	18791000	22015	11008	2	0	\N
336355	1678	23760768096000	22017	11009	0	0	\N
336356	1874	18792000	22017	11009	1	0	\N
336357	1874	18794000	22017	11009	2	0	\N
336358	1874	18796000	22017	11009	3	0	\N
336359	1678	23760768096000	22018	11009	0	0	\N
336360	1874	18792000	22018	11009	1	0	\N
336361	1874	18794000	22018	11009	2	0	\N
336362	1874	18796000	22018	11009	3	0	\N
336363	1678	23760768096000	22019	11009	0	0	\N
336364	1874	18792000	22019	11009	1	0	\N
336365	1874	18794000	22019	11009	2	0	\N
336366	1874	18796000	22019	11009	3	0	\N
336367	1678	23760768096000	22020	11009	0	0	\N
336368	1874	18792000	22020	11009	1	0	\N
336369	1874	18794000	22020	11009	2	0	\N
336370	1874	18796000	22020	11009	3	0	\N
336371	1678	23760768096000	22021	11009	0	0	\N
336372	1874	18792000	22021	11009	1	0	\N
336373	1874	18794000	22021	11009	2	0	\N
336374	1874	18796000	22021	11009	3	0	\N
336375	1678	23760768097000	22022	11010	0	0	\N
336376	1874	18799000	22022	11010	1	0	\N
336377	1874	18801000	22022	11010	2	0	\N
336384	1678	23760768098000	22025	11011	0	0	\N
336391	1678	23760768100000	22028	11013	0	0	\N
336392	1874	18814000	22028	11013	1	0	\N
336393	1874	18816000	22028	11013	2	0	\N
336396	1303	1710570985351650	22030	11015	0	0	\N
336397	1057	909797285400000	22030	11015	1	0	\N
336398	1177	613859313200000	22030	11015	2	0	\N
336399	937	507702913800000	22030	11015	3	0	\N
336400	1874	18820000	22030	11015	4	0	\N
336401	1874	18823000	22030	11015	5	0	\N
336402	1874	18826000	22030	11015	6	0	\N
336417	1678	23760768105000	22032	11016	0	0	\N
336418	1874	18837000	22032	11016	1	0	\N
336419	1678	23760768105000	22033	11016	0	0	\N
336420	1874	18836000	22033	11016	1	0	\N
336421	1874	18839000	22033	11016	2	0	\N
336429	2291	0	22036	10783	0	0	\N
336430	588	66783000000000	22036	10783	1	0	\N
336431	1678	23040757856000	22036	10783	2	0	\N
336432	1678	23040757857000	22036	10783	3	0	\N
336433	1678	23040757858000	22036	10783	4	0	\N
336434	1678	23040757859000	22036	10783	5	0	\N
336435	1678	23040757860000	22036	10783	6	0	\N
336436	1021	507244438919578	22036	10783	7	0	\N
336437	1958	5231186000000	22036	10783	8	0	\N
336438	1483	10000000	22036	10783	9	0	\N
336439	1303	1710570985351650	22036	10783	10	0	\N
336440	1057	909797285400000	22036	10783	11	0	\N
336441	1177	613859313200000	22036	10783	12	0	\N
336442	1483	10000000	22036	10783	13	0	\N
336443	1508	22688206929693	22036	10783	14	0	\N
336444	2290	100000000	22036	10783	15	0	\N
336445	1678	23040757861000	22036	10783	16	0	\N
336446	1508	22939776541648	22036	10783	17	0	\N
336447	1678	23040757862000	22036	10783	18	0	\N
336448	1678	23040757863000	22036	10783	19	0	\N
336449	1678	23040757864000	22036	10783	20	0	\N
336450	1678	23040757865000	22036	10783	21	0	\N
336451	1678	23040757866000	22036	10783	22	0	\N
336452	1678	23040757867000	22036	10783	23	0	\N
336453	1678	23040757868000	22036	10783	24	0	\N
336454	1678	23040757869000	22036	10783	25	0	\N
336455	1678	23040757870000	22036	10783	26	0	\N
336456	1678	23040757871000	22036	10783	27	0	\N
336457	1678	23040757872000	22036	10783	28	0	\N
336458	1678	23040757873000	22036	10783	29	0	\N
336459	1678	23040757874000	22036	10783	30	0	\N
336460	1678	23040757875000	22036	10783	31	0	\N
336461	1678	23040757876000	22036	10783	32	0	\N
336462	1678	23040757877000	22036	10783	33	0	\N
336463	1678	23040757878000	22036	10783	34	0	\N
336464	1678	23040757879000	22036	10783	35	0	\N
336331	1874	18776000	22008	11005	2	0	2
336332	1678	23760768093000	22009	11006	0	0	0
336333	1874	18778000	22009	11006	2	0	2
336334	1874	18781000	22009	11006	3	0	2
336343	1678	23760768094000	22013	11007	0	0	0
336345	1874	18786000	22013	11007	2	0	2
336346	1678	23760768095000	22014	11008	0	0	0
336347	1874	18789000	22014	11008	1	0	2
336351	1678	23760768096000	22016	11009	0	0	0
336352	1874	18792000	22016	11009	1	0	2
336354	1874	18796000	22016	11009	3	0	2
336378	1678	23760768097000	22023	11010	0	0	0
336379	1874	18799000	22023	11010	1	0	2
336380	1874	18801000	22023	11010	2	0	2
336382	1874	18804000	22024	11011	1	0	2
336383	1874	18806000	22024	11011	2	0	2
336385	1678	23760768099000	22026	11012	0	0	0
336386	1874	18808000	22026	11012	1	0	2
336387	1874	18811000	22026	11012	2	0	2
336389	1874	18814000	22027	11013	1	0	2
336390	1874	18816000	22027	11013	2	0	2
336394	1678	23760768101000	22029	11014	0	0	0
336395	1874	18819000	22029	11014	1	0	2
336403	1303	1710570985351650	22031	11015	0	0	0
336405	1177	613859313200000	22031	11015	2	0	0
336406	1678	23760768102000	22031	11015	3	0	0
336407	937	507702913800000	22031	11015	4	0	0
336408	1678	23760768103000	22031	11015	5	0	0
336410	1874	18820000	22031	11015	7	0	2
336411	1874	18823000	22031	11015	8	0	2
336412	1874	18826000	22031	11015	9	0	2
336413	1874	18828000	22031	11015	10	0	2
336414	1874	18830000	22031	11015	11	0	2
336416	1874	18834000	22031	11015	13	0	2
336422	1678	23760768105000	22034	11016	0	0	0
336423	1874	18836000	22034	11016	1	0	2
336424	1874	18839000	22034	11016	2	0	2
336425	1678	23760768106000	22035	11017	0	0	0
336427	1874	18843000	22035	11017	2	0	2
336428	1874	18845000	22035	11017	3	0	2
336465	1678	23040757880000	22036	10783	36	0	\N
336466	1678	23040757881000	22036	10783	37	0	\N
336467	1678	23040757882000	22036	10783	38	0	\N
336468	1678	23040757883000	22036	10783	39	0	\N
336469	1678	23040757884000	22036	10783	40	0	\N
336470	1678	23040757885000	22036	10783	41	0	\N
336471	1678	23040757886000	22036	10783	42	0	\N
336472	1678	23040757887000	22036	10783	43	0	\N
336473	1678	23040757888000	22036	10783	44	0	\N
336474	1678	23040757889000	22036	10783	45	0	\N
336475	1678	23040757890000	22036	10783	46	0	\N
336476	1678	23040757891000	22036	10783	47	0	\N
336477	1141	908977688473491	22036	10783	48	0	\N
336478	1261	613305359073006	22036	10783	49	0	\N
336479	1387	1709029915128959	22036	10783	50	0	\N
336480	1678	23040757892000	22036	10783	51	0	\N
336481	973	507337115000000	22036	10783	52	0	\N
336482	1678	23040757893000	22036	10783	53	0	\N
336483	1678	23040757894000	22036	10783	54	0	\N
336484	937	507702913800000	22036	10783	55	0	\N
336485	1678	23040757895000	22036	10783	56	0	\N
336486	1678	23040757896000	22036	10783	57	0	\N
336487	1678	23040757897000	22036	10783	58	0	\N
336488	1678	23040757898000	22036	10783	59	0	\N
336489	1678	23040757899000	22036	10783	60	0	\N
336490	1678	23040757900000	22036	10783	61	0	\N
336491	1678	23040757901000	22036	10783	62	0	\N
336492	1678	23040757902000	22036	10783	63	0	\N
336493	1678	23040757903000	22036	10783	64	0	\N
336494	1678	23040757904000	22036	10783	65	0	\N
336495	1678	23040757905000	22036	10783	66	0	\N
336496	1678	23040757906000	22036	10783	67	0	\N
336497	1678	23040757907000	22036	10783	68	0	\N
336498	1678	23040757908000	22036	10783	69	0	\N
336499	1678	23040757909000	22036	10783	70	0	\N
336500	1678	23040757910000	22036	10783	71	0	\N
336501	1678	23040757911000	22036	10783	72	0	\N
336502	1678	23040757912000	22036	10783	73	0	\N
336503	1678	23040757913000	22036	10783	74	0	\N
336504	1678	23040757914000	22036	10783	75	0	\N
336505	1678	23040757915000	22036	10783	76	0	\N
336506	1678	23040757916000	22036	10783	77	0	\N
336507	1678	23040757917000	22036	10783	78	0	\N
336508	1678	23040757918000	22036	10783	79	0	\N
336509	1678	23040757919000	22036	10783	80	0	\N
336510	1678	23040757920000	22036	10783	81	0	\N
336511	1678	23040757921000	22036	10783	82	0	\N
336512	1678	23040757922000	22036	10783	83	0	\N
336513	1678	23040757923000	22036	10783	84	0	\N
336514	1678	23040757924000	22036	10783	85	0	\N
336515	1678	23040757925000	22036	10783	86	0	\N
336516	1678	23040757926000	22036	10783	87	0	\N
336517	1678	23040757927000	22036	10783	88	0	\N
336518	1678	23040757928000	22036	10783	89	0	\N
336519	1678	23040757929000	22036	10783	90	0	\N
336520	1678	23040757930000	22036	10783	91	0	\N
336521	1678	23040757931000	22036	10783	92	0	\N
336522	1678	23040757932000	22036	10783	93	0	\N
336523	1678	23040757933000	22036	10783	94	0	\N
336524	1678	23040757934000	22036	10783	95	0	\N
336525	1678	23040757935000	22036	10783	96	0	\N
336526	1678	23040757936000	22036	10783	97	0	\N
336527	1678	23040757937000	22036	10783	98	0	\N
336528	1678	23040757938000	22036	10783	99	0	\N
336529	1678	23040757939000	22036	10783	100	0	\N
336530	1678	23040757940000	22036	10783	101	0	\N
336531	1678	23040757941000	22036	10783	102	0	\N
336532	1678	23040757942000	22036	10783	103	0	\N
336533	1678	23040757943000	22036	10783	104	0	\N
336534	1678	23040757944000	22036	10783	105	0	\N
336535	1678	23040757945000	22036	10783	106	0	\N
336536	1678	23040757946000	22036	10783	108	0	\N
336537	1678	23040757947000	22036	10783	109	0	\N
336538	1678	23040757948000	22036	10783	110	0	\N
336539	1678	23040757949000	22036	10783	111	0	\N
336540	1678	23040757950000	22036	10783	112	0	\N
336541	1678	23040757951000	22036	10783	113	0	\N
336542	1678	23040757952000	22036	10783	114	0	\N
336543	1678	23040757953000	22036	10783	115	0	\N
336544	1678	23040757954000	22036	10783	116	0	\N
336545	1678	23040757955000	22036	10783	117	0	\N
336546	1678	23040757956000	22036	10783	118	0	\N
336547	1678	23040757957000	22036	10783	119	0	\N
336548	1678	23040757958000	22036	10783	120	0	\N
336549	1678	23040757959000	22036	10783	121	0	\N
336550	1678	23040757960000	22036	10783	122	0	\N
336551	1678	23040757961000	22036	10783	123	0	\N
336552	1678	23040757962000	22036	10783	124	0	\N
336553	1678	23040757963000	22036	10783	125	0	\N
336577	1678	23760768113000	22042	11022	0	0	\N
336578	1874	18877000	22042	11022	1	0	\N
336579	1874	18880000	22042	11022	2	0	\N
336580	1874	18882000	22042	11022	3	0	\N
336583	1678	23760768115000	22044	11024	0	0	\N
336584	1678	23760768116000	22044	11024	1	0	\N
336585	1678	23760768117000	22044	11024	2	0	\N
336586	1678	23760768118000	22044	11024	3	0	\N
336587	1874	18887000	22044	11024	4	0	\N
336588	1874	18888000	22044	11024	5	0	\N
336589	1874	18890000	22044	11024	6	0	\N
336590	1874	18893000	22044	11024	7	0	\N
336591	1874	18896000	22044	11024	8	0	\N
336592	1874	18899000	22044	11024	9	0	\N
336593	1874	18902000	22044	11024	10	0	\N
336594	1874	18904000	22044	11024	11	0	\N
336595	1874	18906000	22044	11024	12	0	\N
336596	1874	18908000	22044	11024	13	0	\N
336556	1678	23760768109000	22037	11018	2	0	0
336557	1874	18847000	22037	11018	3	0	2
336558	1874	18850000	22037	11018	4	0	2
336559	1874	18852000	22037	11018	5	0	2
336560	1874	18854000	22037	11018	6	0	2
336562	1874	18860000	22037	11018	8	0	2
336563	1678	23760768110000	22038	11019	0	0	0
336564	1874	18862000	22038	11019	1	0	2
336565	1874	18865000	22038	11019	2	0	2
336566	1874	18866000	22038	11019	3	0	2
336568	1874	18869000	22039	11020	1	0	2
336569	1678	23760768112000	22040	11021	0	0	0
336570	1874	18871000	22040	11021	1	0	2
336571	1874	18873000	22040	11021	2	0	2
336573	1678	23760768113000	22041	11022	0	0	0
336574	1874	18877000	22041	11022	1	0	2
336575	1874	18880000	22041	11022	2	0	2
336576	1874	18882000	22041	11022	3	0	2
336581	1678	23760768114000	22043	11023	0	0	0
336597	1678	23760768115000	22045	11024	0	0	0
336598	1678	23760768116000	22045	11024	1	0	0
336599	1678	23760768117000	22045	11024	2	0	0
336600	1678	23760768118000	22045	11024	3	0	0
336614	1678	23760768119000	22047	11025	0	0	\N
336615	1874	18910000	22047	11025	1	0	\N
336616	1874	18913000	22047	11025	2	0	\N
336617	1678	23760768119000	22048	11025	0	0	\N
336618	1874	18910000	22048	11025	1	0	\N
336619	1874	18913000	22048	11025	2	0	\N
336620	1678	23760768120000	22049	11026	0	0	\N
336621	1874	18914000	22049	11026	1	0	\N
336622	1874	18916000	22049	11026	2	0	\N
336623	1874	18919000	22049	11026	3	0	\N
336631	1678	23760768122000	22054	11028	0	0	\N
336632	1874	18926000	22054	11028	1	0	\N
336633	1874	18929000	22054	11028	2	0	\N
336641	1678	23760768124000	22058	11030	0	0	\N
336642	1874	18937000	22058	11030	1	0	\N
336643	1874	18940000	22058	11030	2	0	\N
336647	1678	23760768124000	22060	11030	0	0	\N
336648	1874	18937000	22060	11030	1	0	\N
336649	1874	18940000	22060	11030	2	0	\N
336660	1678	23760768128000	22062	11032	0	0	\N
336661	1874	18959000	22062	11032	1	0	\N
336662	1874	18961000	22062	11032	2	0	\N
336666	1678	23760768128000	22064	11032	0	0	\N
336667	1874	18959000	22064	11032	1	0	\N
336668	1874	18961000	22064	11032	2	0	\N
336676	1678	23760768130000	22067	11034	0	0	\N
336677	1874	18969000	22067	11034	1	0	\N
336678	1874	18970000	22067	11034	2	0	\N
336685	1678	23760768131000	22069	11035	0	0	\N
336686	1678	23760768132000	22069	11035	1	0	\N
336687	1874	18975000	22069	11035	2	0	\N
336688	1874	18978000	22069	11035	3	0	\N
336689	1874	18980000	22069	11035	4	0	\N
336690	1874	18982000	22069	11035	5	0	\N
336695	1303	1710570985351650	22071	10767	0	0	\N
336696	1057	909797285400000	22071	10767	1	0	\N
336697	1177	613859313200000	22071	10767	2	0	\N
336698	937	507702913800000	22071	10767	3	0	\N
336699	602	66010000000000	22071	10767	4	0	\N
336700	1318	1710516637751650	22071	10767	6	0	\N
336701	1072	910057465000000	22071	10767	7	0	\N
336702	1192	614032750000000	22071	10767	8	0	\N
336703	952	507686775000000	22071	10767	9	0	\N
336704	1312	1712574323973610	22071	10767	10	0	\N
336705	1340	1708727510151650	22072	11037	0	0	\N
336706	1678	23760768134000	22072	11037	1	0	\N
336707	1094	908818024600000	22072	11037	2	0	\N
336708	1214	613198226800000	22072	11037	3	0	\N
336709	1874	18991000	22072	11037	4	0	\N
336710	1874	18993000	22072	11037	5	0	\N
336711	1340	1708727510151650	22073	11037	0	0	\N
336712	1678	23760768134000	22073	11037	1	0	\N
336713	1094	908818024600000	22073	11037	2	0	\N
336714	1214	613198226800000	22073	11037	3	0	\N
336715	1874	18991000	22073	11037	4	0	\N
336716	1874	18993000	22073	11037	5	0	\N
336717	1340	1708727510151650	22074	11037	0	0	\N
336718	1678	23760768134000	22074	11037	1	0	\N
336719	1094	908818024600000	22074	11037	2	0	\N
336720	1214	613198226800000	22074	11037	3	0	\N
336721	1874	18991000	22074	11037	4	0	\N
336722	1874	18993000	22074	11037	5	0	\N
336723	1340	1708727510151650	22075	11037	0	0	\N
336724	1678	23760768134000	22075	11037	1	0	\N
336725	1094	908818024600000	22075	11037	2	0	\N
336726	1214	613198226800000	22075	11037	3	0	\N
336727	1874	18991000	22075	11037	4	0	\N
336728	1874	18993000	22075	11037	5	0	\N
336603	1874	18890000	22045	11024	6	0	2
336604	1874	18893000	22045	11024	7	0	2
336605	1874	18896000	22045	11024	8	0	2
336606	1874	18899000	22045	11024	9	0	2
336607	1874	18902000	22045	11024	10	0	2
336609	1874	18906000	22045	11024	12	0	2
336610	1874	18908000	22045	11024	13	0	2
336611	1678	23760768119000	22046	11025	0	0	0
336612	1874	18910000	22046	11025	1	0	2
336613	1874	18913000	22046	11025	2	0	2
336625	1874	18914000	22052	11026	1	0	2
336626	1874	18916000	22052	11026	2	0	2
336627	1874	18919000	22052	11026	3	0	2
336628	1678	23760768121000	22053	11027	0	0	0
336630	1874	18924000	22053	11027	2	0	2
336634	1678	23760768122000	22055	11028	0	0	0
336635	1874	18926000	22055	11028	1	0	2
336636	1874	18929000	22055	11028	2	0	2
336637	1678	23760768123000	22057	11029	0	0	0
336639	1874	18932000	22057	11029	2	0	2
336640	1874	18935000	22057	11029	3	0	2
336644	1678	23760768124000	22059	11030	0	0	0
336645	1874	18937000	22059	11030	1	0	2
336646	1874	18940000	22059	11030	2	0	2
336651	1678	23760768126000	22061	11031	1	0	0
336652	1678	23760768127000	22061	11031	2	0	0
336653	1874	18941000	22061	11031	3	0	2
336654	1874	18943000	22061	11031	4	0	2
336656	1874	18947000	22061	11031	6	0	2
336657	1874	18950000	22061	11031	7	0	2
336658	1874	18953000	22061	11031	8	0	2
336659	1874	18956000	22061	11031	9	0	2
336663	1678	23760768128000	22063	11032	0	0	0
336665	1874	18961000	22063	11032	2	0	2
336669	1678	23760768129000	22065	11033	0	0	0
336670	1874	18963000	22065	11033	1	0	2
336671	1874	18966000	22065	11033	2	0	2
336672	1678	23760768130000	22066	11034	0	0	0
336674	1874	18971000	22066	11034	2	0	2
336675	1874	18972000	22066	11034	3	0	2
336679	1678	23760768131000	22068	11035	0	0	0
336680	1678	23760768132000	22068	11035	1	0	0
336682	1874	18978000	22068	11035	3	0	2
336683	1874	18980000	22068	11035	4	0	2
336684	1874	18982000	22068	11035	5	0	2
336691	1678	23760768133000	22070	11036	0	0	0
336692	1874	18984000	22070	11036	1	0	2
336694	1874	18988000	22070	11036	3	0	2
336729	1340	1708727510151650	22076	11037	0	0	0
336730	1678	23760768134000	22076	11037	1	0	0
336731	1094	908818024600000	22076	11037	2	0	0
336732	1214	613198226800000	22076	11037	3	0	0
336734	1874	18993000	22076	11037	5	0	2
336735	1678	23760768135000	22077	11038	0	0	0
336736	1678	23760768136000	22077	11038	1	0	0
336741	1678	23760768137000	22078	11039	0	0	\N
336742	1874	19003000	22078	11039	1	0	\N
336743	1874	19006000	22078	11039	2	0	\N
336753	1340	1708727510151650	22082	11027	0	0	\N
336754	1678	23760768121000	22082	11027	1	0	\N
336755	1678	23760768122000	22082	11027	2	0	\N
336756	1678	23760768123000	22082	11027	3	0	\N
336757	1678	23760768124000	22082	11027	4	0	\N
336758	1678	23760768125000	22082	11027	5	0	\N
336759	1678	23760768126000	22082	11027	6	0	\N
336760	1094	908818024600000	22082	11027	7	0	\N
336761	1214	613198226800000	22082	11027	8	0	\N
336762	974	507156496200000	22082	11027	9	0	\N
336763	1678	23760768127000	22082	11027	10	0	\N
336764	1678	23760768128000	22082	11027	11	0	\N
336765	1678	23760768129000	22082	11027	12	0	\N
336766	1678	23760768130000	22082	11027	13	0	\N
336767	1678	23760768131000	22082	11027	14	0	\N
336768	1678	23760768132000	22082	11027	15	0	\N
336769	1678	23760768133000	22082	11027	16	0	\N
336770	1678	23760768134000	22082	11027	17	0	\N
336771	1678	23760768135000	22082	11027	18	0	\N
336772	1678	23760768136000	22082	11027	19	0	\N
336773	1678	23760768137000	22082	11027	20	0	\N
336774	1678	23760768138000	22082	11027	21	0	\N
336775	1678	23760768139000	22082	11027	22	0	\N
336776	1678	23760768140000	22082	11027	23	0	\N
336777	1874	18921000	22082	11027	24	0	\N
336778	1874	18923000	22082	11027	25	0	\N
336779	1874	18926000	22082	11027	26	0	\N
336780	1874	18929000	22082	11027	27	0	\N
336781	1874	18931000	22082	11027	28	0	\N
336782	1874	18932000	22082	11027	29	0	\N
336783	1874	18933000	22082	11027	30	0	\N
336784	1874	18934000	22082	11027	31	0	\N
336785	1874	18936000	22082	11027	32	0	\N
336786	1874	18938000	22082	11027	33	0	\N
336787	1874	18940000	22082	11027	34	0	\N
336788	1874	18942000	22082	11027	35	0	\N
336789	1874	18944000	22082	11027	36	0	\N
336790	1874	18946000	22082	11027	37	0	\N
336791	1874	18948000	22082	11027	38	0	\N
336792	1874	18949000	22082	11027	39	0	\N
336793	1874	18950000	22082	11027	40	0	\N
336794	1874	18951000	22082	11027	41	0	\N
336795	1874	18954000	22082	11027	42	0	\N
336796	1874	18956000	22082	11027	43	0	\N
336797	1874	18958000	22082	11027	44	0	\N
336798	1874	18960000	22082	11027	45	0	\N
336799	1874	18962000	22082	11027	46	0	\N
336800	1874	18964000	22082	11027	47	0	\N
336801	1874	18966000	22082	11027	48	0	\N
336802	1874	18968000	22082	11027	49	0	\N
336803	1874	18970000	22082	11027	50	0	\N
336804	1874	18972000	22082	11027	51	0	\N
336805	1874	18974000	22082	11027	52	0	\N
336806	1874	18977000	22082	11027	53	0	\N
336807	1874	18980000	22082	11027	54	0	\N
336808	1874	18983000	22082	11027	55	0	\N
336809	1874	18986000	22082	11027	56	0	\N
336810	1874	18989000	22082	11027	57	0	\N
336811	1874	18992000	22082	11027	58	0	\N
336812	1874	18995000	22082	11027	59	0	\N
336813	1874	18998000	22082	11027	60	0	\N
336814	1874	19001000	22082	11027	61	0	\N
336815	1874	19004000	22082	11027	62	0	\N
336816	1874	19007000	22082	11027	63	0	\N
336817	1874	19010000	22082	11027	64	0	\N
336818	1874	19013000	22082	11027	65	0	\N
336819	1874	19016000	22082	11027	66	0	\N
336820	1874	19019000	22082	11027	67	0	\N
336821	1874	19022000	22082	11027	68	0	\N
336822	1678	23760768140000	22083	11042	0	0	\N
336823	1678	23760768141000	22083	11042	1	0	\N
336824	1874	19019000	22083	11042	2	0	\N
336825	1874	19022000	22083	11042	3	0	\N
336826	1874	19023000	22083	11042	4	0	\N
336827	1678	23760768140000	22084	11042	0	0	\N
336828	1678	23760768141000	22084	11042	1	0	\N
336829	1874	19018000	22084	11042	2	0	\N
336830	1874	19021000	22084	11042	3	0	\N
336831	1874	19024000	22084	11042	4	0	\N
336832	1874	19026000	22084	11042	5	0	\N
336833	1874	19027000	22084	11042	6	0	\N
336834	1678	23760768140000	22085	11042	0	0	\N
336835	1678	23760768141000	22085	11042	1	0	\N
336836	1874	19018000	22085	11042	2	0	\N
336837	1874	19021000	22085	11042	3	0	\N
336838	1874	19024000	22085	11042	4	0	\N
336839	1874	19026000	22085	11042	5	0	\N
336840	1874	19027000	22085	11042	6	0	\N
336841	1678	23760768141000	22086	11028	0	0	\N
336842	1874	19025000	22086	11028	1	0	\N
336843	1874	19027000	22086	11028	2	0	\N
336854	1678	23760768142000	22089	11043	0	0	\N
336855	1874	19029000	22089	11043	1	0	\N
336856	1874	19032000	22089	11043	2	0	\N
336857	1678	23760768143000	22090	11044	0	0	\N
336858	1874	19033000	22090	11044	1	0	\N
336739	1874	18999000	22077	11038	4	0	2
336740	1874	19001000	22077	11038	5	0	2
336744	1874	19003000	22079	11039	0	0	2
336745	1874	19006000	22079	11039	1	0	2
336746	1678	23760768137000	22080	11040	0	0	0
336748	1874	19008000	22080	11040	2	0	2
336749	1874	19011000	22080	11040	3	0	2
336750	1678	23760768139000	22081	11041	0	0	0
336751	1874	19013000	22081	11041	1	0	2
336752	1874	19016000	22081	11041	2	0	2
336845	1678	23760768141000	22087	11042	1	0	0
336846	1874	19018000	22087	11042	2	0	2
336847	1874	19021000	22087	11042	3	0	2
336848	1874	19024000	22087	11042	4	0	2
336850	1874	19027000	22087	11042	6	0	2
336851	1678	23760768142000	22088	11043	0	0	0
336852	1874	19029000	22088	11043	1	0	2
336853	1874	19032000	22088	11043	2	0	2
336859	1874	19034000	22091	11044	0	0	2
336861	1678	23760768143000	22092	11045	0	0	0
336862	1678	23760768144000	22092	11045	1	0	0
336863	1678	23760768145000	22092	11045	2	0	0
336864	1678	23760768146000	22092	11045	3	0	0
336865	1874	19040000	22092	11045	4	0	2
336867	1874	19046000	22092	11045	6	0	2
336868	1874	19049000	22092	11045	7	0	2
336869	1874	19051000	22092	11045	8	0	2
336870	1874	19053000	22092	11045	10	0	2
336872	1874	19057000	22092	11045	12	0	2
336878	1678	23760768147000	22094	11046	0	0	\N
336879	1874	19061000	22094	11046	1	0	\N
336880	1874	19064000	22094	11046	2	0	\N
336891	1678	23760768151000	22098	11050	0	0	\N
336892	1678	23760768152000	22098	11050	1	0	\N
336893	1874	19083000	22098	11050	2	0	\N
336894	1874	19084000	22098	11050	3	0	\N
336895	1874	19087000	22098	11050	4	0	\N
336896	1874	19089000	22098	11050	5	0	\N
336897	1874	19091000	22098	11050	6	0	\N
336905	1678	23760768151000	22100	11050	0	0	\N
336906	1678	23760768152000	22100	11050	1	0	\N
336907	1874	19083000	22100	11050	2	0	\N
336908	1874	19084000	22100	11050	3	0	\N
336909	1874	19087000	22100	11050	4	0	\N
336910	1874	19089000	22100	11050	5	0	\N
336911	1874	19091000	22100	11050	6	0	\N
336935	1678	23760768160000	22105	11055	0	0	\N
336936	1366	1711789637751650	22105	11055	1	0	\N
336937	1874	19131000	22105	11055	2	0	\N
336938	1874	19133000	22105	11055	3	0	\N
336951	1678	23760768163000	22108	11057	0	0	\N
336952	1874	19146000	22108	11057	1	0	\N
336953	1874	19149000	22108	11057	2	0	\N
336954	1678	23760768163000	22109	11057	0	0	\N
336955	1874	19146000	22109	11057	1	0	\N
336956	1874	19149000	22109	11057	2	0	\N
336964	1678	23760768142000	22112	11029	1	0	\N
336965	1678	23760768143000	22112	11029	2	0	\N
336966	1678	23760768144000	22112	11029	3	0	\N
336967	1678	23760768145000	22112	11029	4	0	\N
336968	1678	23760768146000	22112	11029	5	0	\N
336969	1678	23760768147000	22112	11029	6	0	\N
336970	1678	23760768148000	22112	11029	7	0	\N
336971	1678	23760768149000	22112	11029	8	0	\N
336972	1678	23760768150000	22112	11029	9	0	\N
336973	1678	23760768151000	22112	11029	10	0	\N
336974	1678	23760768152000	22112	11029	11	0	\N
336975	1366	1711789637751650	22112	11029	12	0	\N
336976	1120	910446465000000	22112	11029	13	0	\N
336977	1240	614296750000000	22112	11029	14	0	\N
336978	1678	23760768153000	22112	11029	15	0	\N
336979	1678	23760768154000	22112	11029	16	0	\N
336980	1678	23760768155000	22112	11029	17	0	\N
336981	1678	23760768156000	22112	11029	18	0	\N
336982	1678	23760768157000	22112	11029	19	0	\N
336983	1678	23760768158000	22112	11029	20	0	\N
336984	1678	23760768159000	22112	11029	21	0	\N
336985	1678	23760768160000	22112	11029	22	0	\N
336986	1678	23760768161000	22112	11029	23	0	\N
336987	1678	23760768162000	22112	11029	24	0	\N
336988	1678	23760768163000	22112	11029	25	0	\N
336989	1678	23760768164000	22112	11029	26	0	\N
336990	1874	19029000	22112	11029	27	0	\N
336991	1874	19032000	22112	11029	28	0	\N
336992	1874	19034000	22112	11029	29	0	\N
336993	1874	19037000	22112	11029	30	0	\N
336994	1874	19040000	22112	11029	31	0	\N
336995	1874	19043000	22112	11029	32	0	\N
336996	1874	19046000	22112	11029	33	0	\N
336997	1874	19049000	22112	11029	34	0	\N
336998	1874	19051000	22112	11029	35	0	\N
336999	1874	19053000	22112	11029	36	0	\N
337000	1874	19055000	22112	11029	37	0	\N
337001	1874	19057000	22112	11029	38	0	\N
337002	1874	19059000	22112	11029	39	0	\N
337003	1874	19061000	22112	11029	40	0	\N
337004	1874	19063000	22112	11029	41	0	\N
337005	1874	19064000	22112	11029	42	0	\N
337006	1874	19065000	22112	11029	43	0	\N
337007	1874	19066000	22112	11029	44	0	\N
337008	1874	19067000	22112	11029	46	0	\N
336875	1678	23760768147000	22093	11046	0	0	0
336876	1874	19061000	22093	11046	1	0	2
336877	1874	19064000	22093	11046	2	0	2
336881	1678	23760768148000	22095	11047	0	0	0
336882	1874	19066000	22095	11047	1	0	2
336884	1678	23760768149000	22096	11048	0	0	0
336885	1874	19071000	22096	11048	1	0	2
336886	1874	19074000	22096	11048	2	0	2
336887	1874	19075000	22096	11048	3	0	2
336888	1678	23760768150000	22097	11049	0	0	0
336890	1874	19080000	22097	11049	2	0	2
336898	1678	23760768151000	22099	11050	0	0	0
336899	1678	23760768152000	22099	11050	1	0	0
336900	1874	19083000	22099	11050	2	0	2
336902	1874	19087000	22099	11050	4	0	2
336903	1874	19089000	22099	11050	5	0	2
336904	1874	19091000	22099	11050	6	0	2
336912	1678	23760768153000	22101	11051	0	0	0
336913	1874	19093000	22101	11051	1	0	2
336915	1678	23760768154000	22102	11052	0	0	0
336916	1874	19098000	22102	11052	1	0	2
336917	1874	19101000	22102	11052	2	0	2
336918	1678	23760768155000	22103	11053	0	0	0
336919	1678	23760768156000	22103	11053	1	0	0
336921	1874	19104000	22103	11053	3	0	2
336922	1874	19105000	22103	11053	4	0	2
336923	1874	19108000	22103	11053	5	0	2
336924	1874	19111000	22103	11053	6	0	2
336926	1874	19115000	22103	11053	8	0	2
336927	1874	19117000	22103	11053	9	0	2
336928	1678	23760768158000	22104	11054	0	0	0
336929	1678	23760768159000	22104	11054	1	0	0
336930	1874	19119000	22104	11054	2	0	2
336932	1874	19122000	22104	11054	4	0	2
336933	1874	19125000	22104	11054	5	0	2
336934	1874	19128000	22104	11054	6	0	2
336939	1678	23760768160000	22106	11055	0	0	0
336940	1366	1711789637751650	22106	11055	1	0	0
336942	1874	19133000	22106	11055	3	0	2
336943	1678	23760768161000	22107	11056	0	0	0
336944	1120	910446465000000	22107	11056	1	0	0
336945	1678	23760768162000	22107	11056	2	0	0
336947	1874	19137000	22107	11056	4	0	2
336948	1874	19140000	22107	11056	5	0	2
336949	1874	19143000	22107	11056	6	0	2
336950	1874	19144000	22107	11056	7	0	2
336957	1678	23760768163000	22110	11057	0	0	0
336959	1874	19149000	22110	11057	2	0	2
336960	1240	614296750000000	22111	11058	1	0	0
336961	1678	23760768164000	22111	11058	2	0	0
336962	1874	19152000	22111	11058	3	0	2
336963	1874	19154000	22111	11058	4	0	2
337009	1874	19068000	22112	11029	47	0	\N
337010	1874	19069000	22112	11029	48	0	\N
337011	1874	19070000	22112	11029	49	0	\N
337012	1874	19073000	22112	11029	50	0	\N
337013	1874	19076000	22112	11029	51	0	\N
337014	1874	19079000	22112	11029	52	0	\N
337015	1874	19082000	22112	11029	53	0	\N
337016	1874	19085000	22112	11029	54	0	\N
337017	1874	19088000	22112	11029	55	0	\N
337018	1874	19091000	22112	11029	56	0	\N
337019	1874	19094000	22112	11029	57	0	\N
337020	1874	19097000	22112	11029	58	0	\N
337021	1874	19100000	22112	11029	59	0	\N
337025	1678	23760768165000	22114	11059	0	0	\N
337026	1874	19156000	22114	11059	1	0	\N
337027	1874	19159000	22114	11059	2	0	\N
337028	1874	19160000	22114	11059	3	0	\N
337029	1678	23760768165000	22115	11059	0	0	\N
337030	1874	19156000	22115	11059	1	0	\N
337031	1874	19159000	22115	11059	2	0	\N
337032	1874	19160000	22115	11059	3	0	\N
337048	1678	23760768170000	22118	11062	0	0	\N
337049	723	3031599090000	22118	11062	1	0	\N
337050	1678	23760768171000	22118	11062	2	0	\N
337051	1874	19183000	22118	11062	3	0	\N
337052	1874	19186000	22118	11062	4	0	\N
337053	1874	19189000	22118	11062	5	0	\N
337054	1874	19191000	22118	11062	6	0	\N
337055	1678	23760768170000	22119	11062	0	0	\N
337056	723	3031599090000	22119	11062	1	0	\N
337057	1678	23760768171000	22119	11062	2	0	\N
337058	1874	19183000	22119	11062	3	0	\N
337059	1874	19186000	22119	11062	4	0	\N
337060	1874	19189000	22119	11062	5	0	\N
337061	1874	19191000	22119	11062	6	0	\N
337077	1678	23760768174000	22123	11065	0	0	\N
337078	1874	19205000	22123	11065	1	0	\N
337079	1874	19207000	22123	11065	2	0	\N
337083	1678	23760768174000	22125	11065	0	0	\N
337084	1874	19205000	22125	11065	1	0	\N
337085	1874	19207000	22125	11065	2	0	\N
337103	1678	23760768180000	22130	11070	0	0	\N
337104	1678	23760768181000	22130	11070	1	0	\N
337105	1874	19234000	22130	11070	2	0	\N
337106	1874	19237000	22130	11070	3	0	\N
337107	1874	19239000	22130	11070	4	0	\N
337108	1874	19241000	22130	11070	5	0	\N
337115	1678	23760768180000	22132	11070	0	0	\N
337116	1678	23760768181000	22132	11070	1	0	\N
337117	1874	19234000	22132	11070	2	0	\N
337118	1874	19237000	22132	11070	3	0	\N
337119	1874	19239000	22132	11070	4	0	\N
337120	1874	19241000	22132	11070	5	0	\N
337125	1678	23760768182000	22135	11071	0	0	\N
337126	1874	19243000	22135	11071	1	0	\N
337127	1874	19246000	22135	11071	2	0	\N
337128	1874	19247000	22135	11071	3	0	\N
337129	1678	23760768182000	22136	11071	0	0	\N
337130	1874	19243000	22136	11071	1	0	\N
337131	1874	19246000	22136	11071	2	0	\N
337132	1874	19247000	22136	11071	3	0	\N
337024	1874	19160000	22113	11059	2	0	2
337033	1000	508063659823781	22116	11060	0	0	0
337034	1678	23760768165000	22116	11060	1	0	0
337035	1678	23760768166000	22116	11060	2	0	0
337036	1874	19163000	22116	11060	3	0	2
337038	1678	23760768167000	22117	11061	0	0	0
337039	1678	23760768168000	22117	11061	1	0	0
337040	1678	23760768169000	22117	11061	2	0	0
337041	1874	19166000	22117	11061	3	0	2
337042	1874	19169000	22117	11061	4	0	2
337044	1874	19173000	22117	11061	6	0	2
337045	1874	19175000	22117	11061	7	0	2
337046	1874	19178000	22117	11061	8	0	2
337047	1874	19181000	22117	11061	9	0	2
337063	723	3031599090000	22120	11062	1	0	0
337064	1678	23760768171000	22120	11062	2	0	0
337065	1874	19183000	22120	11062	3	0	2
337066	1874	19186000	22120	11062	4	0	2
337067	1874	19189000	22120	11062	5	0	2
337069	1678	23760768172000	22121	11063	0	0	0
337070	2293	2047000000000	22121	11063	1	0	0
337071	1874	19194000	22121	11063	2	0	2
337072	1874	19196000	22121	11063	3	0	2
337073	1874	19197000	22121	11063	4	0	2
337075	1874	19199000	22122	11064	1	0	2
337076	1874	19202000	22122	11064	2	0	2
337080	1678	23760768174000	22124	11065	0	0	0
337081	1874	19205000	22124	11065	1	0	2
337086	1678	23760768175000	22126	11066	0	0	0
337087	1874	19209000	22126	11066	1	0	2
337088	1874	19210000	22126	11066	2	0	2
337089	1874	19213000	22126	11066	3	0	2
337090	1678	23760768176000	22127	11067	0	0	0
337092	1874	19218000	22127	11067	2	0	2
337093	1678	23760768177000	22128	11068	0	0	0
337094	1546	5277318000000	22128	11068	1	0	10
337095	1874	19220000	22128	11068	2	0	2
337096	1678	23760768178000	22129	11069	0	0	0
337098	1874	19221000	22129	11069	2	0	2
337099	1874	19224000	22129	11069	3	0	2
337100	1874	19227000	22129	11069	4	0	2
337101	1874	19229000	22129	11069	5	0	2
337109	1678	23760768180000	22131	11070	0	0	0
337110	1678	23760768181000	22131	11070	1	0	0
337111	1874	19234000	22131	11070	2	0	2
337112	1874	19237000	22131	11070	3	0	2
337113	1874	19239000	22131	11070	4	0	2
337121	1678	23760768182000	22134	11071	0	0	0
337122	1874	19243000	22134	11071	1	0	2
337123	1874	19246000	22134	11071	2	0	2
337124	1874	19247000	22134	11071	3	0	2
337133	1678	23760768183000	22137	11072	0	0	0
337135	1678	23760768185000	22137	11072	2	0	0
337136	1874	19248000	22137	11072	3	0	2
337137	1874	19251000	22137	11072	4	0	2
337138	1874	19254000	22137	11072	5	0	2
337140	1874	19259000	22137	11072	7	0	2
337141	1874	19261000	22137	11072	8	0	2
337142	1874	19263000	22137	11072	9	0	2
337143	1678	23760768186000	22138	11073	0	0	0
337144	1678	23760768187000	22138	11073	1	0	0
337152	1678	23760768189000	22140	11075	0	0	\N
337153	1678	23760768190000	22140	11075	1	0	\N
337154	1678	23760768191000	22140	11075	2	0	\N
337155	1874	19279000	22140	11075	3	0	\N
337156	1874	19281000	22140	11075	5	0	\N
337157	1874	19283000	22140	11075	6	0	\N
337158	1874	19285000	22140	11075	7	0	\N
337159	1874	19288000	22140	11075	8	0	\N
337160	1874	19291000	22140	11075	9	0	\N
337161	1874	19294000	22140	11075	10	0	\N
337162	1678	23760768189000	22141	11075	0	0	\N
337163	1678	23760768190000	22141	11075	1	0	\N
337164	1678	23760768191000	22141	11075	2	0	\N
337165	1874	19279000	22141	11075	3	0	\N
337166	1874	19281000	22141	11075	5	0	\N
337167	1874	19283000	22141	11075	6	0	\N
337168	1874	19285000	22141	11075	7	0	\N
337169	1874	19288000	22141	11075	8	0	\N
337170	1874	19291000	22141	11075	9	0	\N
337171	1874	19294000	22141	11075	10	0	\N
337176	1678	23760768190000	22143	11076	0	0	\N
337177	1678	23760768191000	22143	11076	1	0	\N
337178	1874	19287000	22143	11076	3	0	\N
337179	1874	19290000	22143	11076	4	0	\N
337180	1874	19292000	22143	11076	5	0	\N
337181	1874	19294000	22143	11076	6	0	\N
337188	1678	23760768190000	22145	11076	0	0	\N
337189	1678	23760768191000	22145	11076	1	0	\N
337190	1874	19287000	22145	11076	3	0	\N
337191	1874	19290000	22145	11076	4	0	\N
337192	1874	19292000	22145	11076	5	0	\N
337193	1874	19294000	22145	11076	6	0	\N
337214	1678	23760768198000	22152	11083	0	0	\N
337215	1678	23760768199000	22152	11083	1	0	\N
337216	1678	23760768200000	22152	11083	2	0	\N
337217	1874	19329000	22152	11083	3	0	\N
337218	1874	19330000	22152	11083	4	0	\N
337219	1874	19332000	22152	11083	5	0	\N
337220	1874	19334000	22152	11083	6	0	\N
337221	1874	19336000	22152	11083	7	0	\N
337222	1874	19339000	22152	11083	8	0	\N
337223	1874	19342000	22152	11083	9	0	\N
337234	1678	23760768198000	22154	11083	0	0	\N
337235	1678	23760768199000	22154	11083	1	0	\N
337236	1678	23760768200000	22154	11083	2	0	\N
337237	1874	19329000	22154	11083	3	0	\N
337238	1874	19330000	22154	11083	4	0	\N
337239	1874	19332000	22154	11083	5	0	\N
337240	1874	19334000	22154	11083	6	0	\N
337241	1874	19336000	22154	11083	7	0	\N
337242	1874	19339000	22154	11083	8	0	\N
337243	1874	19342000	22154	11083	9	0	\N
337244	1678	23760768198000	22155	11083	0	0	\N
337245	1678	23760768199000	22155	11083	1	0	\N
337246	1678	23760768200000	22155	11083	2	0	\N
337247	1874	19329000	22155	11083	3	0	\N
337248	1874	19330000	22155	11083	4	0	\N
337249	1874	19332000	22155	11083	5	0	\N
337250	1874	19334000	22155	11083	6	0	\N
337251	1874	19336000	22155	11083	7	0	\N
337252	1874	19339000	22155	11083	8	0	\N
337253	1874	19342000	22155	11083	9	0	\N
337254	1678	23760768198000	22157	11083	0	0	\N
337255	1678	23760768199000	22157	11083	1	0	\N
337256	1678	23760768200000	22157	11083	2	0	\N
337257	1874	19329000	22157	11083	3	0	\N
337258	1874	19330000	22157	11083	4	0	\N
337259	1874	19332000	22157	11083	5	0	\N
337260	1874	19334000	22157	11083	6	0	\N
337261	1874	19336000	22157	11083	7	0	\N
337262	1874	19339000	22157	11083	8	0	\N
337263	1874	19342000	22157	11083	9	0	\N
337271	1678	23760768202000	22160	11085	0	0	\N
337272	1874	19347000	22160	11085	1	0	\N
337273	1874	19348000	22160	11085	2	0	\N
337274	1874	19350000	22160	11085	3	0	\N
337275	2294	719000000000	22160	11085	4	0	\N
337279	1678	23760768203000	22162	11086	0	0	\N
337280	1874	19352000	22162	11086	1	0	\N
337147	1874	19270000	22138	11073	4	0	2
337148	1874	19273000	22138	11073	5	0	2
337149	1678	23760768188000	22139	11074	0	0	0
337150	1874	19275000	22139	11074	1	0	2
337151	1874	19278000	22139	11074	2	0	2
337173	1874	19279000	22142	11075	1	0	2
337174	1874	19281000	22142	11075	2	0	2
337175	1874	19284000	22142	11075	3	0	2
337182	1678	23760768190000	22144	11076	0	0	0
337183	1678	23760768191000	22144	11076	1	0	0
337185	1874	19290000	22144	11076	4	0	2
337186	1874	19292000	22144	11076	5	0	2
337187	1874	19294000	22144	11076	6	0	2
337194	1678	23760768192000	22146	11077	0	0	0
337196	1874	19297000	22146	11077	2	0	2
337197	1874	19300000	22146	11077	3	0	2
337198	1678	23760768193000	22147	11078	0	0	0
337199	1874	19303000	22147	11078	1	0	2
337200	1874	19305000	22147	11078	2	0	2
337202	1678	23760768195000	22148	11079	1	0	0
337203	1874	19306000	22148	11079	2	0	2
337204	1874	19309000	22148	11079	3	0	2
337205	1874	19312000	22148	11079	4	0	2
337206	1874	19314000	22148	11079	5	0	2
337208	1678	23760768196000	22149	11080	0	0	0
337209	1874	19319000	22149	11080	1	0	2
337210	1874	19321000	22149	11080	2	0	2
337211	1678	23760768197000	22150	11081	0	0	0
337213	1874	19326000	22150	11081	2	0	2
337224	1678	23760768198000	22153	11083	0	0	0
337225	1678	23760768199000	22153	11083	1	0	0
337226	1678	23760768200000	22153	11083	2	0	0
337227	1874	19329000	22153	11083	3	0	2
337229	1874	19332000	22153	11083	5	0	2
337230	1874	19334000	22153	11083	6	0	2
337231	1874	19336000	22153	11083	7	0	2
337232	1874	19339000	22153	11083	8	0	2
337233	1874	19342000	22153	11083	9	0	2
337265	1874	19344000	22158	11084	1	0	2
337266	1678	23760768202000	22159	11085	0	0	0
337267	1874	19347000	22159	11085	1	0	2
337268	1874	19348000	22159	11085	2	0	2
337270	2294	719000000000	22159	11085	4	0	0
337276	1678	23760768203000	22161	11086	0	0	0
337277	1874	19352000	22161	11086	1	0	2
337278	1874	19355000	22161	11086	2	0	2
337281	1874	19355000	22162	11086	2	0	\N
337282	1678	23760768201000	22163	11084	0	0	\N
337283	1678	23760768202000	22163	11084	1	0	\N
337284	1678	23760768203000	22163	11084	2	0	\N
337285	1678	23760768204000	22163	11084	3	0	\N
337286	1874	19345000	22163	11084	4	0	\N
337287	1874	19347000	22163	11084	5	0	\N
337288	1874	19348000	22163	11084	6	0	\N
337289	1874	19350000	22163	11084	7	0	\N
337290	1874	19352000	22163	11084	8	0	\N
337291	1874	19354000	22163	11084	9	0	\N
337292	2294	719000000000	22163	11084	10	0	\N
337293	1874	19357000	22163	11084	11	0	\N
337294	1874	19360000	22163	11084	12	0	\N
337295	1678	23760768204000	22164	11087	0	0	\N
337296	1874	19357000	22164	11087	1	0	\N
337297	1874	19360000	22164	11087	2	0	\N
337306	938	507800938770000	22167	11088	0	0	\N
337307	1678	23760768205000	22167	11088	1	0	\N
337308	1874	19363000	22167	11088	2	0	\N
337309	1874	19365000	22167	11088	3	0	\N
337310	1874	19366000	22167	11088	4	0	\N
337311	938	507800938770000	22168	11088	0	0	\N
337312	1678	23760768205000	22168	11088	1	0	\N
337313	1874	19363000	22168	11088	2	0	\N
337314	1874	19365000	22168	11088	3	0	\N
337315	1874	19366000	22168	11088	4	0	\N
337347	1678	23760768211000	22175	11094	0	0	\N
337348	1678	23760768212000	22175	11094	1	0	\N
337349	1874	19393000	22175	11094	2	0	\N
337350	1874	19396000	22175	11094	3	0	\N
337351	1874	19397000	22175	11094	4	0	\N
337352	1874	19399000	22175	11094	5	0	\N
337353	1874	19401000	22175	11094	6	0	\N
337364	1678	23760768216000	22178	11097	0	0	\N
337365	1678	23760768217000	22178	11097	1	0	\N
337366	1874	19419000	22178	11097	2	0	\N
337367	1874	19421000	22178	11097	3	0	\N
337368	1874	19424000	22178	11097	4	0	\N
337369	1874	19427000	22178	11097	5	0	\N
337389	1678	23760768220000	22183	11100	0	0	\N
337390	1678	23760768221000	22183	11100	1	0	\N
337391	1874	19441000	22183	11100	2	0	\N
337392	1874	19443000	22183	11100	3	0	\N
337393	1874	19446000	22183	11100	4	0	\N
337394	1874	19448000	22183	11100	5	0	\N
337395	938	507800938770000	22184	11005	0	0	\N
337396	1058	907781840850000	22184	11005	1	0	\N
337397	1178	615170912210000	22184	11005	2	0	\N
337398	1304	1706115953081650	22184	11005	3	0	\N
337399	954	507610345498744	22184	11005	5	0	\N
337400	1074	909633389928304	22184	11005	7	0	\N
337401	1194	613747773910321	22184	11005	8	0	\N
337402	1320	1710262743410446	22184	11005	9	0	\N
337403	1340	1708727510151650	22184	11005	10	0	\N
337404	1546	4557306000000	22184	11005	11	0	\N
337405	1303	1710570985351650	22184	11005	12	0	\N
337406	1057	909797285400000	22184	11005	13	0	\N
337407	1177	613859313200000	22184	11005	14	0	\N
337408	1678	23760768092000	22184	11005	15	0	\N
337409	1366	1711789637751650	22184	11005	16	0	\N
337410	1120	910446465000000	22184	11005	17	0	\N
337411	1240	614296750000000	22184	11005	18	0	\N
337412	1000	508063659823781	22184	11005	19	0	\N
337413	723	3031599090000	22184	11005	20	0	\N
337414	2293	2047000000000	22184	11005	21	0	\N
337415	1678	23760768093000	22184	11005	22	0	\N
337416	1678	23760768094000	22184	11005	23	0	\N
337300	1874	19360000	22165	11087	2	0	2
337301	938	507800938770000	22166	11088	0	0	0
337302	1678	23760768205000	22166	11088	1	0	0
337303	1874	19363000	22166	11088	2	0	2
337304	1874	19365000	22166	11088	3	0	2
337316	1058	907781840850000	22169	11089	0	0	0
337317	1178	615170912210000	22169	11089	1	0	0
337318	1678	23760768206000	22169	11089	2	0	0
337319	1635	11000000	22169	11089	3	0	1
337320	1874	19369000	22169	11089	4	0	2
337322	1304	1706115953081650	22170	11090	0	0	0
337323	954	507610345498744	22170	11090	1	0	0
337324	1074	909633389928304	22170	11090	2	0	0
337325	1194	613747773910321	22170	11090	3	0	0
337327	1678	23760768207000	22170	11090	5	0	0
337328	1635	11000000	22170	11090	6	0	1
337329	1874	19374000	22170	11090	7	0	2
337330	1678	23760768208000	22171	11091	0	0	0
337331	1874	19376000	22171	11091	1	0	2
337333	1678	23760768209000	22172	11092	0	0	0
337334	1874	19381000	22172	11092	1	0	2
337335	1874	19384000	22172	11092	2	0	2
337336	1874	19385000	22172	11092	3	0	2
337337	1678	23760768210000	22173	11093	0	0	0
337339	1874	19390000	22173	11093	2	0	2
337340	1678	23760768211000	22174	11094	0	0	0
337341	1678	23760768212000	22174	11094	1	0	0
337342	1874	19393000	22174	11094	2	0	2
337344	1874	19397000	22174	11094	4	0	2
337345	1874	19399000	22174	11094	5	0	2
337346	1874	19401000	22174	11094	6	0	2
337354	1678	23760768213000	22176	11095	0	0	0
337355	1874	19404000	22176	11095	1	0	2
337357	1678	23760768214000	22177	11096	0	0	0
337358	1678	23760768215000	22177	11096	1	0	0
337359	1874	19409000	22177	11096	2	0	2
337360	1874	19411000	22177	11096	3	0	2
337361	1874	19414000	22177	11096	4	0	2
337363	1874	19417000	22177	11096	6	0	2
337370	1678	23760768216000	22179	11097	0	0	0
337371	1678	23760768217000	22179	11097	1	0	0
337372	1874	19419000	22179	11097	2	0	2
337374	1874	19424000	22179	11097	4	0	2
337375	1874	19427000	22179	11097	5	0	2
337376	1678	23760768218000	22180	11098	0	0	0
337377	1874	19430000	22180	11098	1	0	2
337378	1874	19432000	22180	11098	2	0	2
337380	1874	19434000	22181	11099	1	0	2
337381	1874	19437000	22181	11099	2	0	2
337382	1874	19438000	22181	11099	3	0	2
337383	1678	23760768220000	22182	11100	0	0	0
337384	1678	23760768221000	22182	11100	1	0	0
337386	1874	19443000	22182	11100	3	0	2
337387	1874	19446000	22182	11100	4	0	2
337388	1874	19448000	22182	11100	5	0	2
337417	1678	23760768095000	22184	11005	24	0	\N
337418	1678	23760768096000	22184	11005	25	0	\N
337419	1678	23760768097000	22184	11005	26	0	\N
337420	1678	23760768098000	22184	11005	27	0	\N
337421	1678	23760768099000	22184	11005	28	0	\N
337422	1678	23760768100000	22184	11005	29	0	\N
337423	1678	23760768101000	22184	11005	30	0	\N
337424	1678	23760768102000	22184	11005	31	0	\N
337425	1094	908818024600000	22184	11005	32	0	\N
337426	1214	613198226800000	22184	11005	33	0	\N
337427	974	507156496200000	22184	11005	34	0	\N
337428	937	507702913800000	22184	11005	35	0	\N
337429	1678	23760768103000	22184	11005	36	0	\N
337430	1678	23760768104000	22184	11005	37	0	\N
337431	1678	23760768105000	22184	11005	38	0	\N
337432	1678	23760768106000	22184	11005	39	0	\N
337433	1678	23760768107000	22184	11005	40	0	\N
337434	1678	23760768108000	22184	11005	41	0	\N
337435	1678	23760768109000	22184	11005	42	0	\N
337436	1678	23760768110000	22184	11005	43	0	\N
337437	1678	23760768111000	22184	11005	44	0	\N
337438	1678	23760768112000	22184	11005	45	0	\N
337439	1678	23760768113000	22184	11005	46	0	\N
337440	1678	23760768114000	22184	11005	47	0	\N
337441	1678	23760768115000	22184	11005	48	0	\N
337442	1678	23760768116000	22184	11005	49	0	\N
337443	1678	23760768117000	22184	11005	50	0	\N
337444	1678	23760768118000	22184	11005	51	0	\N
337445	1678	23760768119000	22184	11005	52	0	\N
337446	1678	23760768120000	22184	11005	53	0	\N
337447	1678	23760768121000	22184	11005	54	0	\N
337448	1678	23760768122000	22184	11005	55	0	\N
337449	1678	23760768123000	22184	11005	56	0	\N
337450	1678	23760768124000	22184	11005	57	0	\N
337451	1678	23760768125000	22184	11005	58	0	\N
337452	1678	23760768126000	22184	11005	59	0	\N
337453	1678	23760768127000	22184	11005	60	0	\N
337454	1678	23760768128000	22184	11005	61	0	\N
337455	1678	23760768129000	22184	11005	62	0	\N
337456	1678	23760768130000	22184	11005	63	0	\N
337457	1678	23760768131000	22184	11005	64	0	\N
337458	1678	23760768132000	22184	11005	65	0	\N
337459	1678	23760768133000	22184	11005	66	0	\N
337460	1678	23760768134000	22184	11005	67	0	\N
337461	1678	23760768135000	22184	11005	68	0	\N
337462	1678	23760768136000	22184	11005	69	0	\N
337463	1678	23760768137000	22184	11005	70	0	\N
337464	1678	23760768138000	22184	11005	71	0	\N
337465	1678	23760768139000	22184	11005	72	0	\N
337466	1678	23760768140000	22184	11005	73	0	\N
337467	1678	23760768141000	22184	11005	74	0	\N
337468	1678	23760768142000	22184	11005	75	0	\N
337469	1678	23760768143000	22184	11005	76	0	\N
337470	1678	23760768144000	22184	11005	77	0	\N
337471	1678	23760768145000	22184	11005	78	0	\N
337472	1678	23760768146000	22184	11005	79	0	\N
337473	1678	23760768147000	22184	11005	80	0	\N
337474	1678	23760768148000	22184	11005	81	0	\N
337475	1678	23760768149000	22184	11005	82	0	\N
337476	1678	23760768150000	22184	11005	83	0	\N
337477	1678	23760768151000	22184	11005	84	0	\N
337478	1678	23760768152000	22184	11005	85	0	\N
337479	1678	23760768153000	22184	11005	86	0	\N
337480	1678	23760768154000	22184	11005	87	0	\N
337481	1678	23760768155000	22184	11005	88	0	\N
337482	1678	23760768156000	22184	11005	89	0	\N
337483	1678	23760768157000	22184	11005	90	0	\N
337484	1678	23760768158000	22184	11005	91	0	\N
337485	1678	23760768159000	22184	11005	92	0	\N
337486	1678	23760768160000	22184	11005	93	0	\N
337487	1678	23760768161000	22184	11005	94	0	\N
337488	1678	23760768162000	22184	11005	95	0	\N
337489	1678	23760768163000	22184	11005	96	0	\N
337490	1678	23760768164000	22184	11005	97	0	\N
337491	1678	23760768165000	22184	11005	98	0	\N
337492	1678	23760768166000	22184	11005	99	0	\N
337493	1678	23760768167000	22184	11005	100	0	\N
337494	1678	23760768168000	22184	11005	101	0	\N
337495	1678	23760768169000	22184	11005	102	0	\N
337496	1678	23760768170000	22184	11005	103	0	\N
337497	1678	23760768171000	22184	11005	104	0	\N
337498	1678	23760768172000	22184	11005	105	0	\N
337499	1678	23760768173000	22184	11005	106	0	\N
337500	1678	23760768174000	22184	11005	107	0	\N
337501	1678	23760768175000	22184	11005	108	0	\N
337502	1678	23760768176000	22184	11005	109	0	\N
337503	1678	23760768177000	22184	11005	110	0	\N
337504	1678	23760768178000	22184	11005	111	0	\N
337505	1678	23760768179000	22184	11005	112	0	\N
337506	1678	23760768180000	22184	11005	113	0	\N
337507	1678	23760768181000	22184	11005	114	0	\N
337508	1678	23760768182000	22184	11005	115	0	\N
337509	1678	23760768183000	22184	11005	116	0	\N
337510	1678	23760768184000	22184	11005	117	0	\N
337511	1678	23760768185000	22184	11005	118	0	\N
337512	1678	23760768186000	22184	11005	119	0	\N
337513	1678	23760768187000	22184	11005	120	0	\N
337514	1678	23760768188000	22184	11005	121	0	\N
337515	1678	23760768189000	22184	11005	122	0	\N
337516	1678	23760768190000	22184	11005	123	0	\N
337517	1678	23760768191000	22184	11005	124	0	\N
337518	1678	23760768192000	22184	11005	125	0	\N
337547	1678	23760768229000	22192	11107	0	0	\N
337548	1874	19488000	22192	11107	1	0	\N
337549	1874	19490000	22192	11107	2	0	\N
337550	1874	19491000	22192	11107	3	0	\N
337521	1874	19449000	22185	11101	3	0	2
337522	1874	19452000	22185	11101	4	0	2
337523	1874	19455000	22185	11101	5	0	2
337524	1874	19457000	22185	11101	6	0	2
337525	1874	19459000	22185	11101	7	0	2
337527	1874	19461000	22186	11102	1	0	2
337528	1874	19464000	22186	11102	2	0	2
337529	1678	23760768225000	22187	11103	0	0	0
337530	640	66001009000000	22187	11103	1	0	1
337531	1874	19465000	22187	11103	2	0	2
337533	1874	19470000	22187	11103	4	0	2
337534	1678	23760768226000	22188	11104	0	0	0
337535	1874	19473000	22188	11104	1	0	2
337536	1874	19475000	22188	11104	2	0	2
337538	1874	19478000	22189	11105	1	0	2
337539	1874	19480000	22189	11105	2	0	2
337540	1678	23760768228000	22190	11106	0	0	0
337541	1874	19483000	22190	11106	1	0	2
337542	1874	19485000	22190	11106	2	0	2
337544	1874	19488000	22191	11107	1	0	2
337545	1874	19490000	22191	11107	2	0	2
337546	1874	19491000	22191	11107	3	0	2
337551	1678	23760768230000	22193	11108	0	0	0
337552	1678	23760768231000	22193	11108	1	0	0
337562	1678	23760768232000	22195	11109	0	0	\N
337563	1874	19503000	22195	11109	1	0	\N
337564	1874	19506000	22195	11109	2	0	\N
337565	1874	19507000	22195	11109	3	0	\N
337577	1678	23760768193000	22199	11006	0	0	\N
337578	1678	23760768194000	22199	11006	1	0	\N
337579	1678	23760768195000	22199	11006	2	0	\N
337580	1678	23760768196000	22199	11006	3	0	\N
337581	1678	23760768197000	22199	11006	4	0	\N
337582	1678	23760768198000	22199	11006	5	0	\N
337583	1678	23760768199000	22199	11006	7	0	\N
337584	1678	23760768200000	22199	11006	8	0	\N
337585	1678	23760768201000	22199	11006	9	0	\N
337586	1678	23760768202000	22199	11006	10	0	\N
337587	1678	23760768203000	22199	11006	11	0	\N
337588	1678	23760768204000	22199	11006	12	0	\N
337589	1678	23760768205000	22199	11006	13	0	\N
337590	1678	23760768206000	22199	11006	14	0	\N
337591	1678	23760768207000	22199	11006	15	0	\N
337592	1678	23760768208000	22199	11006	16	0	\N
337593	1678	23760768209000	22199	11006	17	0	\N
337594	1678	23760768210000	22199	11006	18	0	\N
337595	1678	23760768211000	22199	11006	19	0	\N
337596	1678	23760768212000	22199	11006	20	0	\N
337597	1678	23760768213000	22199	11006	21	0	\N
337598	1678	23760768214000	22199	11006	22	0	\N
337599	1678	23760768215000	22199	11006	23	0	\N
337600	1678	23760768216000	22199	11006	24	0	\N
337601	1678	23760768217000	22199	11006	25	0	\N
337602	1678	23760768218000	22199	11006	26	0	\N
337603	1678	23760768219000	22199	11006	27	0	\N
337604	1678	23760768220000	22199	11006	28	0	\N
337605	1678	23760768221000	22199	11006	29	0	\N
337606	1678	23760768222000	22199	11006	30	0	\N
337607	1678	23760768223000	22199	11006	31	0	\N
337608	1678	23760768224000	22199	11006	32	0	\N
337609	1678	23760768225000	22199	11006	33	0	\N
337610	1678	23760768226000	22199	11006	34	0	\N
337611	1678	23760768227000	22199	11006	35	0	\N
337612	1678	23760768228000	22199	11006	36	0	\N
337613	1678	23760768229000	22199	11006	37	0	\N
337614	1678	23760768230000	22199	11006	38	0	\N
337615	1678	23760768231000	22199	11006	39	0	\N
337616	1678	23760768232000	22199	11006	40	0	\N
337617	1678	23760768233000	22199	11006	41	0	\N
337618	1678	23760768234000	22199	11006	42	0	\N
337619	1678	23760768235000	22199	11006	43	0	\N
337620	563	66000607000000	22199	11006	44	0	\N
337621	563	66000607000000	22199	11006	45	0	\N
337622	640	66001009000000	22199	11006	47	0	\N
337623	1874	18774000	22199	11006	49	0	\N
337624	1874	18776000	22199	11006	50	0	\N
337625	1874	18777000	22199	11006	51	0	\N
337626	1874	18779000	22199	11006	52	0	\N
337627	1874	18781000	22199	11006	53	0	\N
337628	1874	18782000	22199	11006	54	0	\N
337629	1874	18783000	22199	11006	55	0	\N
337630	1874	18784000	22199	11006	56	0	\N
337631	1874	18785000	22199	11006	57	0	\N
337632	1874	18786000	22199	11006	58	0	\N
337633	1874	18787000	22199	11006	59	0	\N
337634	1874	18788000	22199	11006	60	0	\N
337635	1874	18789000	22199	11006	61	0	\N
337636	640	66720007000000	22199	11006	62	0	\N
337637	1874	18791000	22199	11006	64	0	\N
337638	1874	18793000	22199	11006	65	0	\N
337639	1874	18794000	22199	11006	66	0	\N
337640	1874	18795000	22199	11006	67	0	\N
337641	2294	719000000000	22199	11006	68	0	\N
337642	1874	18796000	22199	11006	69	0	\N
337643	1874	18797000	22199	11006	70	0	\N
337644	1874	18798000	22199	11006	71	0	\N
337645	1874	18801000	22199	11006	72	0	\N
337646	1874	18804000	22199	11006	73	0	\N
337647	1874	18807000	22199	11006	74	0	\N
337648	1874	18810000	22199	11006	75	0	\N
337649	1874	18813000	22199	11006	76	0	\N
337650	1874	18816000	22199	11006	77	0	\N
337651	1874	18818000	22199	11006	78	0	\N
337652	1874	18820000	22199	11006	79	0	\N
337653	1874	18822000	22199	11006	80	0	\N
337654	1874	18823000	22199	11006	81	0	\N
337655	1874	18824000	22199	11006	82	0	\N
337656	1874	18825000	22199	11006	83	0	\N
337657	1874	18826000	22199	11006	84	0	\N
337658	1874	18827000	22199	11006	85	0	\N
337659	1874	18828000	22199	11006	86	0	\N
337660	1874	18829000	22199	11006	87	0	\N
337661	1874	18830000	22199	11006	88	0	\N
337662	1874	18831000	22199	11006	89	0	\N
337663	1874	18832000	22199	11006	90	0	\N
337664	1874	18833000	22199	11006	91	0	\N
337665	1874	18834000	22199	11006	92	0	\N
337666	1874	18835000	22199	11006	93	0	\N
337667	1874	18836000	22199	11006	94	0	\N
337668	1874	18837000	22199	11006	95	0	\N
337669	1874	18838000	22199	11006	96	0	\N
337670	1874	18839000	22199	11006	97	0	\N
337671	1874	18840000	22199	11006	98	0	\N
337672	1874	18841000	22199	11006	99	0	\N
337673	1874	18842000	22199	11006	100	0	\N
337674	1874	18843000	22199	11006	101	0	\N
337675	1874	18844000	22199	11006	102	0	\N
337676	1874	18845000	22199	11006	103	0	\N
337677	1874	18846000	22199	11006	104	0	\N
337678	1874	18847000	22199	11006	105	0	\N
337679	1874	18848000	22199	11006	106	0	\N
337680	1874	18849000	22199	11006	107	0	\N
337681	1874	18851000	22199	11006	108	0	\N
337682	1874	18853000	22199	11006	109	0	\N
337683	1874	18855000	22199	11006	110	0	\N
337684	1874	18857000	22199	11006	111	0	\N
337685	1874	18859000	22199	11006	112	0	\N
337686	1874	18861000	22199	11006	113	0	\N
337687	1874	18863000	22199	11006	114	0	\N
337688	1874	18865000	22199	11006	115	0	\N
337555	640	66720007000000	22193	11108	4	0	1
337556	1874	19498000	22193	11108	5	0	2
337557	1874	19501000	22193	11108	6	0	2
337558	1678	23760768232000	22194	11109	0	0	0
337559	1874	19503000	22194	11109	1	0	2
337561	1874	19507000	22194	11109	3	0	2
337566	1678	23760768233000	22196	11110	1	0	0
337567	1678	23760768234000	22196	11110	2	0	0
337568	563	66000607000000	22196	11110	3	0	15
337569	563	66000607000000	22196	11110	4	0	15
337571	1874	19512000	22196	11110	7	0	2
337572	1874	19514000	22196	11110	8	0	2
337573	1874	19517000	22196	11110	9	0	2
337574	1874	19520000	22198	11111	0	0	2
337576	1874	19523000	22198	11111	2	0	2
337689	1874	18867000	22199	11006	116	0	\N
337690	1874	18869000	22199	11006	117	0	\N
337691	1874	18871000	22199	11006	118	0	\N
337692	1874	18873000	22199	11006	119	0	\N
337693	1874	18875000	22199	11006	120	0	\N
337694	1874	18877000	22199	11006	121	0	\N
337695	1874	18879000	22199	11006	122	0	\N
337696	1874	18881000	22199	11006	123	0	\N
337697	1874	18883000	22199	11006	124	0	\N
337698	1874	18885000	22199	11006	125	0	\N
337705	1678	23760768235000	22201	11112	0	0	\N
337706	1678	23760768236000	22201	11112	1	0	\N
337707	1874	19526000	22201	11112	2	0	\N
337708	1874	19528000	22201	11112	3	0	\N
337709	1874	19531000	22201	11112	4	0	\N
337710	1874	19533000	22201	11112	5	0	\N
337718	1678	23760768238000	22204	11114	0	0	\N
337719	1874	19540000	22204	11114	1	0	\N
337720	1874	19543000	22204	11114	2	0	\N
337721	1874	19544000	22204	11114	3	0	\N
337733	1678	23760768236000	22208	11007	0	0	\N
337734	1678	23760768237000	22208	11007	1	0	\N
337735	1678	23760768238000	22208	11007	2	0	\N
337736	1678	23760768239000	22208	11007	3	0	\N
337737	1678	23760768240000	22208	11007	4	0	\N
337738	1678	23760768241000	22208	11007	5	0	\N
337739	1874	18887000	22208	11007	7	0	\N
337740	1874	18889000	22208	11007	8	0	\N
337741	1874	18891000	22208	11007	9	0	\N
337742	1874	18893000	22208	11007	10	0	\N
337743	1874	18895000	22208	11007	11	0	\N
337744	1874	18897000	22208	11007	12	0	\N
337745	1874	18898000	22208	11007	13	0	\N
337746	1874	18900000	22208	11007	14	0	\N
337747	1874	18902000	22208	11007	15	0	\N
337748	1874	18904000	22208	11007	16	0	\N
337749	1874	18906000	22208	11007	17	0	\N
337750	1874	18908000	22208	11007	18	0	\N
337751	1874	18910000	22208	11007	19	0	\N
337752	1874	18912000	22208	11007	20	0	\N
337753	1874	18913000	22208	11007	21	0	\N
337754	2295	999000000	22208	11007	22	0	\N
337755	1874	18915000	22208	11007	23	0	\N
337756	1874	18917000	22208	11007	24	0	\N
337757	1874	18919000	22208	11007	25	0	\N
337758	1874	18921000	22208	11007	26	0	\N
337759	1874	18923000	22208	11007	27	0	\N
337760	1874	18925000	22208	11007	28	0	\N
337761	1874	18927000	22208	11007	29	0	\N
337762	1874	18929000	22208	11007	30	0	\N
337763	1874	18931000	22208	11007	31	0	\N
337764	1874	18933000	22208	11007	32	0	\N
337765	1874	18935000	22208	11007	33	0	\N
337766	1874	18937000	22208	11007	34	0	\N
337767	1874	18939000	22208	11007	35	0	\N
337768	1874	18941000	22208	11007	36	0	\N
337769	1874	18943000	22208	11007	37	0	\N
337770	1874	18945000	22208	11007	38	0	\N
337771	1874	18947000	22208	11007	39	0	\N
337772	1874	18949000	22208	11007	40	0	\N
337773	1874	18951000	22208	11007	41	0	\N
337774	1874	18953000	22208	11007	42	0	\N
337775	1874	18955000	22208	11007	43	0	\N
337776	1874	18957000	22208	11007	44	0	\N
337777	1874	18959000	22208	11007	45	0	\N
337778	1874	18961000	22208	11007	46	0	\N
337779	1874	18963000	22208	11007	47	0	\N
337780	1874	18965000	22208	11007	48	0	\N
337781	1874	18967000	22208	11007	49	0	\N
337782	1874	18969000	22208	11007	50	0	\N
337783	1874	18971000	22208	11007	51	0	\N
337784	1874	18973000	22208	11007	52	0	\N
337785	1874	18975000	22208	11007	53	0	\N
337786	1874	18977000	22208	11007	54	0	\N
337787	1874	18979000	22208	11007	55	0	\N
337788	1874	18981000	22208	11007	56	0	\N
337789	1874	18983000	22208	11007	57	0	\N
337790	1874	18985000	22208	11007	58	0	\N
337791	1874	18987000	22208	11007	59	0	\N
337792	1874	18989000	22208	11007	60	0	\N
337803	1678	23760768242000	22210	11118	0	0	\N
337804	1678	23760768243000	22210	11118	1	0	\N
337805	1678	23760768244000	22210	11118	2	0	\N
337806	1874	19563000	22210	11118	3	0	\N
337807	1874	19565000	22210	11118	4	0	\N
337808	1874	19567000	22210	11118	5	0	\N
337809	1874	19568000	22210	11118	6	0	\N
337810	1874	19571000	22210	11118	7	0	\N
337811	1874	19574000	22210	11118	8	0	\N
337812	1874	19576000	22210	11118	9	0	\N
337819	1678	23760768247000	22212	11120	0	0	\N
337820	1678	23760768248000	22212	11120	1	0	\N
337821	1678	23760768249000	22212	11120	2	0	\N
337822	1874	19589000	22212	11120	3	0	\N
337823	1874	19592000	22212	11120	4	0	\N
337824	1874	19594000	22212	11120	5	0	\N
337701	1874	19526000	22200	11112	2	0	2
337702	1874	19528000	22200	11112	3	0	2
337703	1874	19531000	22200	11112	4	0	2
337704	1874	19533000	22200	11112	5	0	2
337711	1678	23760768237000	22202	11113	0	0	0
337713	1874	19538000	22202	11113	2	0	2
337714	1678	23760768238000	22203	11114	0	0	0
337715	1874	19540000	22203	11114	1	0	2
337716	1874	19543000	22203	11114	2	0	2
337717	1874	19544000	22203	11114	3	0	2
337723	1874	19547000	22205	11115	1	0	2
337724	1874	19549000	22205	11115	2	0	2
337725	2295	999000000	22205	11115	3	0	0
337726	1678	23760768240000	22206	11116	0	0	0
337728	1874	19554000	22206	11116	2	0	2
337729	1678	23760768241000	22207	11117	0	0	0
337730	1874	19556000	22207	11117	1	0	2
337731	1874	19559000	22207	11117	2	0	2
337732	1874	19560000	22207	11117	3	0	2
337794	1678	23760768243000	22209	11118	1	0	0
337795	1678	23760768244000	22209	11118	2	0	0
337796	1874	19563000	22209	11118	3	0	2
337797	1874	19565000	22209	11118	4	0	2
337798	1874	19567000	22209	11118	5	0	2
337800	1874	19571000	22209	11118	7	0	2
337801	1874	19574000	22209	11118	8	0	2
337802	1874	19576000	22209	11118	9	0	2
337813	1678	23760768245000	22211	11119	0	0	0
337815	1874	19579000	22211	11119	2	0	2
337816	1874	19582000	22211	11119	3	0	2
337817	1874	19584000	22211	11119	4	0	2
337818	1874	19586000	22211	11119	5	0	2
337825	1874	19596000	22212	11120	6	0	\N
337826	1874	19598000	22212	11120	7	0	\N
337827	1874	19599000	22212	11120	8	0	\N
337837	1678	23760768247000	22214	11120	0	0	\N
337838	1678	23760768248000	22214	11120	1	0	\N
337839	1678	23760768249000	22214	11120	2	0	\N
337840	1874	19589000	22214	11120	3	0	\N
337841	1874	19592000	22214	11120	4	0	\N
337842	1874	19594000	22214	11120	5	0	\N
337843	1874	19596000	22214	11120	6	0	\N
337844	1874	19598000	22214	11120	7	0	\N
337845	1874	19599000	22214	11120	8	0	\N
337868	1678	23760768253000	22224	11125	0	0	\N
337869	1874	19638000	22224	11125	1	0	\N
337870	1874	19641000	22224	11125	2	0	\N
337871	1678	23760768253000	22225	11125	0	0	\N
337872	1874	19638000	22225	11125	1	0	\N
337873	1874	19641000	22225	11125	2	0	\N
337874	1678	23760768253000	22226	11125	0	0	\N
337875	1874	19639000	22226	11125	1	0	\N
337876	1678	23760768253000	22227	11125	0	0	\N
337877	1874	19638000	22227	11125	1	0	\N
337878	1874	19641000	22227	11125	2	0	\N
337879	1678	23760768254000	22228	11126	0	0	\N
337880	1874	19641000	22228	11126	1	0	\N
337881	1874	19642000	22228	11126	2	0	\N
337882	1874	19644000	22228	11126	3	0	\N
337883	1874	19647000	22228	11126	4	0	\N
337884	1678	23760768254000	22229	11126	0	0	\N
337885	1874	19641000	22229	11126	1	0	\N
337886	1874	19642000	22229	11126	2	0	\N
337887	1874	19644000	22229	11126	3	0	\N
337888	1874	19647000	22229	11126	4	0	\N
337889	1678	23760768254000	22230	11126	0	0	\N
337890	1874	19641000	22230	11126	1	0	\N
337891	1874	19642000	22230	11126	2	0	\N
337892	1874	19645000	22230	11126	3	0	\N
337893	974	507156496200000	22231	11113	0	0	\N
337894	1678	23760768237000	22231	11113	1	0	\N
337895	1678	23760768238000	22231	11113	2	0	\N
337896	1678	23760768239000	22231	11113	3	0	\N
337897	1678	23760768240000	22231	11113	4	0	\N
337898	1678	23760768241000	22231	11113	5	0	\N
337899	1678	23760768242000	22231	11113	6	0	\N
337900	1678	23760768243000	22231	11113	7	0	\N
337901	1678	23760768244000	22231	11113	8	0	\N
337902	1678	23760768245000	22231	11113	9	0	\N
337903	1678	23760768246000	22231	11113	10	0	\N
337904	1678	23760768247000	22231	11113	11	0	\N
337905	1678	23760768248000	22231	11113	12	0	\N
337906	1678	23760768249000	22231	11113	13	0	\N
337907	1678	23760768250000	22231	11113	14	0	\N
337908	1678	23760768251000	22231	11113	15	0	\N
337909	1678	23760768252000	22231	11113	16	0	\N
337910	1678	23760768253000	22231	11113	17	0	\N
337911	1874	19535000	22231	11113	18	0	\N
337912	1874	19537000	22231	11113	19	0	\N
337913	1874	19539000	22231	11113	20	0	\N
337914	1874	19541000	22231	11113	21	0	\N
337915	1874	19543000	22231	11113	22	0	\N
337916	1874	19545000	22231	11113	23	0	\N
337917	1874	19547000	22231	11113	24	0	\N
337918	1874	19548000	22231	11113	25	0	\N
337919	1874	19549000	22231	11113	26	0	\N
337920	1874	19550000	22231	11113	27	0	\N
337921	1874	19552000	22231	11113	28	0	\N
337922	1874	19554000	22231	11113	29	0	\N
337923	1874	19556000	22231	11113	30	0	\N
337924	1874	19558000	22231	11113	31	0	\N
337925	1874	19560000	22231	11113	32	0	\N
337926	1874	19562000	22231	11113	33	0	\N
337927	1874	19564000	22231	11113	34	0	\N
337928	1874	19566000	22231	11113	35	0	\N
337929	1874	19567000	22231	11113	36	0	\N
337930	1874	19568000	22231	11113	37	0	\N
337931	1874	19569000	22231	11113	38	0	\N
337932	1874	19570000	22231	11113	39	0	\N
337933	1874	19572000	22231	11113	40	0	\N
337934	1874	19574000	22231	11113	41	0	\N
337935	1874	19576000	22231	11113	42	0	\N
337936	1874	19578000	22231	11113	43	0	\N
337937	1874	19580000	22231	11113	44	0	\N
337938	1874	19582000	22231	11113	45	0	\N
337939	1874	19584000	22231	11113	46	0	\N
337940	2295	999000000	22231	11113	48	0	\N
337941	1874	19587000	22231	11113	49	0	\N
337942	1874	19590000	22231	11113	50	0	\N
337943	1874	19593000	22231	11113	51	0	\N
337944	1874	19596000	22231	11113	52	0	\N
337945	1874	19599000	22231	11113	53	0	\N
337946	1874	19602000	22231	11113	54	0	\N
337947	1874	19605000	22231	11113	55	0	\N
337948	1874	19608000	22231	11113	56	0	\N
337949	1874	19611000	22231	11113	57	0	\N
337950	1874	19614000	22231	11113	58	0	\N
337951	1874	19617000	22231	11113	59	0	\N
337952	1874	19620000	22231	11113	60	0	\N
337953	1874	19623000	22231	11113	61	0	\N
337954	1874	19626000	22231	11113	62	0	\N
337955	1874	19629000	22231	11113	63	0	\N
337956	1874	19632000	22231	11113	64	0	\N
337957	1874	19635000	22231	11113	65	0	\N
337958	1874	19638000	22231	11113	66	0	\N
337959	1874	19641000	22231	11113	67	0	\N
337960	1874	19644000	22231	11113	68	0	\N
337830	1678	23760768249000	22213	11120	2	0	0
337831	1874	19589000	22213	11120	3	0	2
337832	1874	19592000	22213	11120	4	0	2
337833	1874	19594000	22213	11120	5	0	2
337834	1874	19596000	22213	11120	6	0	2
337836	1874	19599000	22213	11120	8	0	2
337846	1678	23760768250000	22215	11121	0	0	0
337847	1874	19602000	22215	11121	1	0	2
337848	1874	19604000	22215	11121	2	0	2
337849	1678	23760768251000	22217	11122	0	0	0
337851	1874	19608000	22217	11122	2	0	2
337852	1874	19611000	22217	11122	3	0	2
337853	1874	19613000	22217	11122	4	0	2
337854	1874	19616000	22217	11122	5	0	2
337856	1874	19620000	22217	11122	7	0	2
337857	1874	19623000	22221	11123	0	0	2
337858	1874	19624000	22221	11123	1	0	2
337859	1874	19626000	22221	11123	2	0	2
337860	1874	19628000	22221	11123	3	0	2
337862	974	507156496200000	22222	11124	0	0	0
337863	1678	23760768252000	22222	11124	1	0	0
337864	1874	19633000	22222	11124	2	0	2
337865	1874	19636000	22222	11124	3	0	2
337866	1678	23760768253000	22223	11125	0	0	0
337961	1874	19647000	22231	11113	69	0	\N
337979	1139	909288714334550	22235	11129	0	0	\N
337980	1678	23760768259000	22235	11129	1	0	\N
337981	1019	507418003287950	22235	11129	2	0	\N
337982	1259	613515214419050	22235	11129	3	0	\N
337983	1874	19666000	22235	11129	4	0	\N
337984	1874	19669000	22235	11129	5	0	\N
337985	1874	19671000	22235	11129	6	0	\N
337986	1874	19673000	22235	11129	7	0	\N
337987	1139	909288714334550	22236	11129	0	0	\N
337988	1678	23760768259000	22236	11129	1	0	\N
337989	1019	507418003287950	22236	11129	2	0	\N
337990	1259	613515214419050	22236	11129	3	0	\N
337991	1874	19666000	22236	11129	4	0	\N
337992	1874	19669000	22236	11129	5	0	\N
337993	1874	19671000	22236	11129	6	0	\N
337994	1874	19673000	22236	11129	7	0	\N
338006	920	507882026116745	22239	11131	0	0	\N
338007	1678	23760768261000	22239	11131	1	0	\N
338008	1040	910120239268005	22239	11131	2	0	\N
338009	1160	614076260860955	22239	11131	3	0	\N
338010	1286	1711178101505890	22239	11131	4	0	\N
338011	1874	19679000	22239	11131	5	0	\N
338012	1874	19681000	22239	11131	6	0	\N
338023	920	507882026116745	22242	10935	0	0	\N
338024	1040	910120239268005	22242	10935	1	0	\N
338025	1160	614076260860955	22242	10935	2	0	\N
338026	1286	1711178101505890	22242	10935	3	0	\N
338027	920	507882026116745	22243	10948	0	0	\N
338028	1040	910120239268005	22243	10948	1	0	\N
338029	1160	614076260860955	22243	10948	2	0	\N
338030	1286	1711178101505890	22243	10948	3	0	\N
338039	920	507882026116745	22245	10990	0	0	\N
338040	192	66623285364088	22245	10990	1	0	\N
338041	918	507519164923296	22245	10990	2	0	\N
338042	1038	909469995118336	22245	10990	3	0	\N
338043	1040	910120239268005	22245	10990	4	0	\N
338044	1284	1709955533869714	22245	10990	5	0	\N
338045	1158	613637528176164	22245	10990	6	0	\N
338046	1160	614076260860955	22245	10990	7	0	\N
338047	1286	1711178101505890	22245	10990	8	0	\N
338048	920	507882026116745	22246	11003	0	0	\N
338049	192	66623285364088	22246	11003	1	0	\N
338050	918	507519164923296	22246	11003	2	0	\N
338051	1038	909469995118336	22246	11003	3	0	\N
338052	1040	910120239268005	22246	11003	4	0	\N
338053	1284	1709955533869714	22246	11003	5	0	\N
338054	1158	613637528176164	22246	11003	6	0	\N
338055	1160	614076260860955	22246	11003	7	0	\N
338056	1286	1711178101505890	22246	11003	8	0	\N
338061	1678	23760768264000	22248	11134	0	0	\N
338062	1874	19694000	22248	11134	1	0	\N
338063	1874	19696000	22248	11134	2	0	\N
338064	1874	19697000	22248	11134	3	0	\N
338065	1678	23760768265000	22250	11135	0	0	\N
338066	1678	23760768266000	22250	11135	1	0	\N
338067	1874	19699000	22250	11135	2	0	\N
338068	1874	19702000	22250	11135	3	0	\N
338069	1874	19704000	22250	11135	4	0	\N
338070	1874	19707000	22250	11135	5	0	\N
338077	1678	23760768267000	22252	11136	0	0	\N
338078	1678	23760768268000	22252	11136	1	0	\N
338079	1874	19710000	22252	11136	2	0	\N
338080	1874	19711000	22252	11136	3	0	\N
338081	1874	19713000	22252	11136	4	0	\N
338082	1874	19715000	22252	11136	5	0	\N
338083	1874	19718000	22252	11136	6	0	\N
337964	1874	19642000	22232	11126	2	0	2
337965	1874	19644000	22232	11126	3	0	2
337966	1874	19647000	22232	11126	4	0	2
337967	1678	23760768255000	22233	11127	0	0	0
337968	1678	23760768256000	22233	11127	1	0	0
337970	1874	19652000	22233	11127	3	0	2
337971	1874	19654000	22233	11127	4	0	2
337972	1874	19657000	22233	11127	5	0	2
337973	1678	23760768257000	22234	11128	0	0	0
337974	1678	23760768258000	22234	11128	1	0	0
337976	1874	19661000	22234	11128	3	0	2
337977	1874	19664000	22234	11128	4	0	2
337978	1483	10000000	22234	11128	5	0	0
337995	1139	909288714334550	22237	11129	0	0	0
337997	1019	507418003287950	22237	11129	2	0	0
337998	1259	613515214419050	22237	11129	3	0	0
337999	1874	19666000	22237	11129	4	0	2
338000	1874	19669000	22237	11129	5	0	2
338001	1874	19671000	22237	11129	6	0	2
338003	1678	23760768260000	22238	11130	0	0	0
338004	1874	19675000	22238	11130	1	0	2
338005	1874	19676000	22238	11130	2	0	2
338013	920	507882026116745	22240	11131	0	0	0
338014	1678	23760768261000	22240	11131	1	0	0
338016	1160	614076260860955	22240	11131	3	0	0
338017	1286	1711178101505890	22240	11131	4	0	0
338018	1874	19679000	22240	11131	5	0	2
338019	1874	19681000	22240	11131	6	0	2
338021	1874	19683000	22241	11132	1	0	2
338022	1874	19686000	22241	11132	2	0	2
338031	192	66623285364088	22244	11133	0	0	0
338032	918	507519164923296	22244	11133	1	0	0
338033	1038	909469995118336	22244	11133	2	0	0
338035	1284	1709955533869714	22244	11133	4	0	0
338036	1158	613637528176164	22244	11133	5	0	0
338037	1874	19688000	22244	11133	6	0	2
338038	1874	19691000	22244	11133	7	0	2
338057	1678	23760768264000	22247	11134	0	0	0
338059	1874	19696000	22247	11134	2	0	2
338060	1874	19697000	22247	11134	3	0	2
338071	1678	23760768265000	22251	11135	0	0	0
338072	1678	23760768266000	22251	11135	1	0	0
338074	1874	19702000	22251	11135	3	0	2
338075	1874	19704000	22251	11135	4	0	2
338076	1874	19707000	22251	11135	5	0	2
338084	1678	23760768267000	22253	11136	0	0	0
338085	1678	23760768268000	22253	11136	1	0	0
338087	1874	19711000	22253	11136	3	0	2
338088	1874	19713000	22253	11136	4	0	2
338089	1874	19715000	22253	11136	5	0	2
338090	1874	19718000	22253	11136	6	0	2
338091	1678	23760768269000	22254	11137	0	0	0
338093	1874	19723000	22254	11137	2	0	2
338094	1678	23760768270000	22255	11138	0	0	0
338095	1874	19725000	22255	11138	1	0	2
338096	1874	19728000	22255	11138	2	0	2
338097	1678	23760768270000	22256	11138	0	0	\N
338098	1874	19725000	22256	11138	1	0	\N
338099	1874	19728000	22256	11138	2	0	\N
338100	1678	23760768271000	22257	11139	0	0	\N
338101	1874	19731000	22257	11139	1	0	\N
338102	1874	19733000	22257	11139	2	0	\N
338103	1874	19734000	22257	11139	3	0	\N
338104	1678	23760768271000	22258	11139	0	0	\N
338105	1874	19731000	22258	11139	1	0	\N
338106	1874	19733000	22258	11139	2	0	\N
338107	1874	19734000	22258	11139	3	0	\N
338115	1678	23760768272000	22261	11140	0	0	\N
338116	1874	19737000	22261	11140	1	0	\N
338120	1678	23760768273000	22263	11141	0	0	\N
338121	1874	19742000	22263	11141	1	0	\N
338122	1874	19744000	22263	11141	2	0	\N
338139	1678	23760768275000	22266	11143	0	0	\N
338140	1678	23760768276000	22266	11143	1	0	\N
338141	1678	23760768277000	22266	11143	2	0	\N
338142	1874	19752000	22266	11143	3	0	\N
338143	1874	19753000	22266	11143	4	0	\N
338144	1227	613524320000000	22266	11143	5	0	\N
338145	1874	19755000	22266	11143	6	0	\N
338146	1874	19757000	22266	11143	7	0	\N
338147	1874	19760000	22266	11143	8	0	\N
338148	1874	19763000	22266	11143	9	0	\N
338149	1874	19766000	22266	11143	10	0	\N
338153	1678	23760768279000	22268	11145	0	0	\N
338154	1874	19773000	22268	11145	1	0	\N
338155	1874	19776000	22268	11145	2	0	\N
338181	1678	23760768285000	22274	11149	0	0	\N
338182	1874	19806000	22274	11149	1	0	\N
338183	1874	19808000	22274	11149	2	0	\N
338193	1678	23760768288000	22277	11151	0	0	\N
338194	1874	19819000	22277	11151	1	0	\N
338195	1874	19821000	22277	11151	2	0	\N
338201	1874	19828000	22281	11153	0	0	\N
338202	1874	19831000	22281	11153	1	0	\N
338207	1678	23760768290000	22283	11154	0	0	\N
338208	1874	19832000	22283	11154	1	0	\N
338209	1874	19834000	22283	11154	2	0	\N
338210	1874	19837000	22283	11154	3	0	\N
338211	938	507800938770000	22284	10919	0	0	\N
338212	1058	907781840850000	22284	10919	1	0	\N
338213	1178	615170912210000	22284	10919	2	0	\N
338214	1304	1706115953081650	22284	10919	3	0	\N
338215	954	507610345498744	22284	10919	5	0	\N
338216	1074	909633389928304	22284	10919	6	0	\N
338217	1194	613747773910321	22284	10919	7	0	\N
338218	1320	1710262743410446	22284	10919	8	0	\N
338219	920	507882026116745	22284	10919	9	0	\N
338220	1139	909288714334550	22284	10919	10	0	\N
338221	1678	23760767965000	22284	10919	11	0	\N
338222	192	66623285364088	22284	10919	12	0	\N
338223	918	507519164923296	22284	10919	13	0	\N
338224	1340	1708727510151650	22284	10919	14	0	\N
338225	1038	909469995118336	22284	10919	15	0	\N
338226	1019	507418003287950	22284	10919	16	0	\N
338227	1546	4557306000000	22284	10919	17	0	\N
338228	1303	1710570985351650	22284	10919	18	0	\N
338229	1057	909797285400000	22284	10919	19	0	\N
338230	1177	613859313200000	22284	10919	20	0	\N
338231	1040	910120239268005	22284	10919	21	0	\N
338232	1259	613515214419050	22284	10919	22	0	\N
338110	1874	19733000	22259	11139	2	0	2
338111	1874	19734000	22259	11139	3	0	2
338112	1678	23760768272000	22260	11140	0	0	0
338113	1874	19737000	22260	11140	1	0	2
338114	1874	19739000	22260	11140	2	0	2
338118	1874	19742000	22262	11141	1	0	2
338119	1874	19744000	22262	11141	2	0	2
338123	1678	23760768274000	22264	11142	0	0	0
338124	1874	19745000	22264	11142	1	0	2
338125	1874	19748000	22264	11142	2	0	2
338127	987	507425545000000	22264	11142	4	0	0
338128	1678	23760768275000	22265	11143	0	0	0
338129	1678	23760768276000	22265	11143	1	0	0
338130	1678	23760768277000	22265	11143	2	0	0
338132	1874	19753000	22265	11143	4	0	2
338133	1227	613524320000000	22265	11143	5	0	0
338134	1874	19755000	22265	11143	6	0	2
338135	1874	19757000	22265	11143	7	0	2
338136	1874	19760000	22265	11143	8	0	2
338138	1874	19766000	22265	11143	10	0	2
338150	1678	23760768278000	22267	11144	0	0	0
338151	1874	19768000	22267	11144	1	0	2
338152	1874	19771000	22267	11144	2	0	2
338156	1678	23760768279000	22269	11145	0	0	0
338158	1874	19776000	22269	11145	2	0	2
338159	1678	23760768280000	22270	11146	0	0	0
338160	1678	23760768281000	22270	11146	1	0	0
338161	1874	19779000	22270	11146	2	0	2
338163	1874	19784000	22270	11146	4	0	2
338164	1874	19786000	22270	11146	5	0	2
338165	1107	909302195000000	22270	11146	6	0	0
338166	1874	19787000	22270	11146	7	0	2
338167	1678	23760768282000	22271	11147	0	0	0
338169	1874	19792000	22271	11147	2	0	2
338170	1678	23760768283000	22272	11148	0	0	0
338171	1678	23760768284000	22272	11148	1	0	0
338172	1874	19794000	22272	11148	2	0	2
338173	1874	19796000	22272	11148	3	0	2
338175	1874	19802000	22272	11148	5	0	2
338176	1353	1709640037751650	22272	11148	6	0	0
338177	1874	19803000	22272	11148	7	0	2
338178	1678	23760768285000	22273	11149	0	0	0
338180	1874	19808000	22273	11149	2	0	2
338184	1678	23760768286000	22275	11150	0	0	0
338185	1678	23760768287000	22275	11150	1	0	0
338186	1874	19811000	22275	11150	2	0	2
338187	1874	19812000	22275	11150	3	0	2
338189	1874	19816000	22275	11150	5	0	2
338190	1678	23760768288000	22276	11151	0	0	0
338191	1874	19819000	22276	11151	1	0	2
338192	1874	19821000	22276	11151	2	0	2
338196	1678	23760768289000	22278	11152	0	0	0
338198	1874	19826000	22278	11152	2	0	2
338199	1874	19828000	22280	11153	0	0	2
338200	1874	19831000	22280	11153	1	0	2
338203	1678	23760768290000	22282	11154	0	0	0
338205	1874	19834000	22282	11154	2	0	2
338206	1874	19837000	22282	11154	3	0	2
338233	1366	1711789637751650	22284	10919	23	0	\N
338234	1120	910446465000000	22284	10919	24	0	\N
338235	1240	614296750000000	22284	10919	25	0	\N
338236	1000	508063659823781	22284	10919	26	0	\N
338237	1284	1709955533869714	22284	10919	27	0	\N
338238	1158	613637528176164	22284	10919	28	0	\N
338239	1160	614076260860955	22284	10919	29	0	\N
338240	1286	1711178101505890	22284	10919	30	0	\N
338241	723	3031599090000	22284	10919	31	0	\N
338242	2293	2047000000000	22284	10919	32	0	\N
338243	1678	23760767966000	22284	10919	33	0	\N
338244	1678	23760767967000	22284	10919	34	0	\N
338245	1678	23760767968000	22284	10919	35	0	\N
338246	1678	23760767969000	22284	10919	36	0	\N
338247	1678	23760767970000	22284	10919	37	0	\N
338248	1678	23760767971000	22284	10919	38	0	\N
338249	1678	23760767972000	22284	10919	39	0	\N
338250	1678	23760767973000	22284	10919	40	0	\N
338251	1678	23760767974000	22284	10919	41	0	\N
338252	1094	908818024600000	22284	10919	42	0	\N
338253	1214	613198226800000	22284	10919	43	0	\N
338254	974	507156496200000	22284	10919	44	0	\N
338255	1678	23760767975000	22284	10919	46	0	\N
338256	1678	23760767976000	22284	10919	47	0	\N
338257	1678	23760767977000	22284	10919	48	0	\N
338258	1678	23760767978000	22284	10919	49	0	\N
338259	1678	23760767979000	22284	10919	50	0	\N
338260	1678	23760767980000	22284	10919	51	0	\N
338261	1678	23760767981000	22284	10919	52	0	\N
338262	1678	23760767982000	22284	10919	53	0	\N
338263	1678	23760767983000	22284	10919	54	0	\N
338264	1678	23760767984000	22284	10919	55	0	\N
338265	1678	23760767985000	22284	10919	56	0	\N
338266	1678	23760767986000	22284	10919	57	0	\N
338267	1678	23760767987000	22284	10919	58	0	\N
338268	937	507702913800000	22284	10919	59	0	\N
338269	1385	1709614695710050	22284	10919	60	0	\N
338270	1678	23760767988000	22284	10919	61	0	\N
338271	1678	23760767989000	22284	10919	62	0	\N
338272	1678	23760767990000	22284	10919	63	0	\N
338273	1678	23760767991000	22284	10919	64	0	\N
338274	1678	23760767992000	22284	10919	65	0	\N
338275	1678	23760767993000	22284	10919	66	0	\N
338276	1678	23760767994000	22284	10919	67	0	\N
338277	1678	23760767995000	22284	10919	68	0	\N
338278	1678	23760767996000	22284	10919	69	0	\N
338279	1678	23760767997000	22284	10919	70	0	\N
338280	1678	23760767998000	22284	10919	71	0	\N
338281	1678	23760767999000	22284	10919	72	0	\N
338282	1678	23760768000000	22284	10919	73	0	\N
338283	1678	23760768001000	22284	10919	74	0	\N
338284	1678	23760768002000	22284	10919	75	0	\N
338285	1678	23760768003000	22284	10919	76	0	\N
338286	1678	23760768004000	22284	10919	77	0	\N
338287	1678	23760768005000	22284	10919	78	0	\N
338288	1678	23760768006000	22284	10919	79	0	\N
338289	1678	23760768007000	22284	10919	80	0	\N
338290	1678	23760768008000	22284	10919	81	0	\N
338291	1678	23760768009000	22284	10919	82	0	\N
338292	1678	23760768010000	22284	10919	83	0	\N
338293	1678	23760768011000	22284	10919	84	0	\N
338294	1678	23760768012000	22284	10919	85	0	\N
338295	1678	23760768013000	22284	10919	86	0	\N
338296	1678	23760768014000	22284	10919	87	0	\N
338297	1678	23760768015000	22284	10919	88	0	\N
338298	1678	23760768016000	22284	10919	89	0	\N
338299	1678	23760768017000	22284	10919	90	0	\N
338300	1678	23760768018000	22284	10919	91	0	\N
338301	1678	23760768019000	22284	10919	92	0	\N
338302	1678	23760768020000	22284	10919	93	0	\N
338303	1678	23760768021000	22284	10919	94	0	\N
338304	1678	23760768022000	22284	10919	95	0	\N
338305	1678	23760768023000	22284	10919	96	0	\N
338306	1678	23760768024000	22284	10919	97	0	\N
338307	1678	23760768025000	22284	10919	98	0	\N
338308	1678	23760768026000	22284	10919	99	0	\N
338309	1678	23760768027000	22284	10919	100	0	\N
338310	1678	23760768028000	22284	10919	101	0	\N
338311	1678	23760768029000	22284	10919	102	0	\N
338312	1678	23760768030000	22284	10919	103	0	\N
338313	1678	23760768031000	22284	10919	104	0	\N
338314	1678	23760768032000	22284	10919	105	0	\N
338315	1678	23760768033000	22284	10919	106	0	\N
338316	1678	23760768034000	22284	10919	107	0	\N
338317	1678	23760768035000	22284	10919	108	0	\N
338318	1678	23760768036000	22284	10919	109	0	\N
338319	1678	23760768037000	22284	10919	110	0	\N
338320	1678	23760768038000	22284	10919	111	0	\N
338321	1678	23760768039000	22284	10919	112	0	\N
338322	1678	23760768040000	22284	10919	113	0	\N
338323	1678	23760768041000	22284	10919	114	0	\N
338324	1678	23760768042000	22284	10919	115	0	\N
338325	1678	23760768043000	22284	10919	116	0	\N
338326	1678	23760768044000	22284	10919	117	0	\N
338327	1678	23760768045000	22284	10919	118	0	\N
338328	1678	23760768046000	22284	10919	119	0	\N
338329	1678	23760768047000	22284	10919	120	0	\N
338330	1678	23760768048000	22284	10919	121	0	\N
338331	1678	23760768049000	22284	10919	122	0	\N
338332	1678	23760768050000	22284	10919	123	0	\N
338333	1678	23760768051000	22284	10919	124	0	\N
338334	1678	23760768052000	22284	10919	125	0	\N
338338	1678	23760768292000	22286	11156	0	0	\N
338339	1874	19845000	22286	11156	1	0	\N
338340	1874	19847000	22286	11156	2	0	\N
338344	1678	23760768292000	22288	11156	0	0	\N
338345	1874	19845000	22288	11156	1	0	\N
338346	1874	19847000	22288	11156	2	0	\N
338354	1678	23760768293000	22290	11157	0	0	\N
338355	1678	23760768294000	22290	11157	1	0	\N
338356	1874	19849000	22290	11157	2	0	\N
338357	1874	19851000	22290	11157	4	0	\N
338358	1874	19854000	22290	11157	5	0	\N
338359	1874	19855000	22290	11157	6	0	\N
338360	1874	19858000	22290	11157	7	0	\N
338361	1678	23760768293000	22291	11157	0	0	\N
338362	1678	23760768294000	22291	11157	1	0	\N
338363	1874	19849000	22291	11157	2	0	\N
338364	1874	19851000	22291	11157	4	0	\N
338365	1874	19854000	22291	11157	5	0	\N
338366	1874	19855000	22291	11157	6	0	\N
338367	1874	19858000	22291	11157	7	0	\N
338337	1874	19842000	22285	11155	2	0	2
338341	1678	23760768292000	22287	11156	0	0	0
338342	1874	19845000	22287	11156	1	0	2
338343	1874	19847000	22287	11156	2	0	2
338347	1678	23760768293000	22289	11157	0	0	0
338349	1874	19849000	22289	11157	2	0	2
338350	1874	19851000	22289	11157	4	0	2
338351	1874	19854000	22289	11157	5	0	2
338352	1874	19855000	22289	11157	6	0	2
338353	1874	19858000	22289	11157	7	0	2
338381	1678	23760768297000	22295	11160	0	0	\N
338382	1678	23760768298000	22295	11160	1	0	\N
338383	1874	19872000	22295	11160	2	0	\N
338384	1874	19875000	22295	11160	3	0	\N
338385	974	507156496200000	22296	11092	0	0	\N
338386	920	507882026116745	22296	11092	1	0	\N
338387	1139	909288714334550	22296	11092	2	0	\N
338388	1678	23760768209000	22296	11092	3	0	\N
338389	192	66623285364088	22296	11092	4	0	\N
338390	918	507519164923296	22296	11092	5	0	\N
338391	1038	909469995118336	22296	11092	6	0	\N
338392	1019	507418003287950	22296	11092	7	0	\N
338393	1678	23760768210000	22296	11092	8	0	\N
338394	1678	23760768211000	22296	11092	9	0	\N
338395	1678	23760768212000	22296	11092	10	0	\N
338396	1678	23760768213000	22296	11092	11	0	\N
338397	1040	910120239268005	22296	11092	12	0	\N
338398	1259	613515214419050	22296	11092	13	0	\N
338399	1678	23760768214000	22296	11092	14	0	\N
338400	1678	23760768215000	22296	11092	15	0	\N
338401	1678	23760768216000	22296	11092	16	0	\N
338402	1678	23760768217000	22296	11092	17	0	\N
338403	1678	23760768218000	22296	11092	18	0	\N
338404	1678	23760768219000	22296	11092	19	0	\N
338405	1678	23760768220000	22296	11092	20	0	\N
338406	1678	23760768221000	22296	11092	21	0	\N
338407	1678	23760768222000	22296	11092	22	0	\N
338408	1678	23760768223000	22296	11092	23	0	\N
338409	1678	23760768224000	22296	11092	24	0	\N
338410	1284	1709955533869714	22296	11092	25	0	\N
338411	1158	613637528176164	22296	11092	26	0	\N
338412	1160	614076260860955	22296	11092	27	0	\N
338413	1286	1711178101505890	22296	11092	28	0	\N
338414	1678	23760768225000	22296	11092	29	0	\N
338415	1678	23760768226000	22296	11092	30	0	\N
338416	1678	23760768227000	22296	11092	31	0	\N
338417	1678	23760768228000	22296	11092	32	0	\N
338418	1678	23760768229000	22296	11092	33	0	\N
338419	1678	23760768230000	22296	11092	34	0	\N
338420	1678	23760768231000	22296	11092	35	0	\N
338421	1678	23760768232000	22296	11092	36	0	\N
338422	1678	23760768233000	22296	11092	37	0	\N
338423	1678	23760768234000	22296	11092	38	0	\N
338424	1678	23760768235000	22296	11092	39	0	\N
338425	1678	23760768236000	22296	11092	40	0	\N
338426	1678	23760768237000	22296	11092	41	0	\N
338427	1678	23760768238000	22296	11092	42	0	\N
338428	1678	23760768239000	22296	11092	43	0	\N
338429	1678	23760768240000	22296	11092	44	0	\N
338430	1678	23760768241000	22296	11092	45	0	\N
338431	1678	23760768242000	22296	11092	46	0	\N
338432	1678	23760768243000	22296	11092	47	0	\N
338433	1678	23760768244000	22296	11092	48	0	\N
338434	1678	23760768245000	22296	11092	49	0	\N
338435	1678	23760768246000	22296	11092	50	0	\N
338436	1678	23760768247000	22296	11092	51	0	\N
338437	1678	23760768248000	22296	11092	52	0	\N
338438	1678	23760768249000	22296	11092	53	0	\N
338439	1678	23760768250000	22296	11092	54	0	\N
338440	1678	23760768251000	22296	11092	55	0	\N
338441	1678	23760768252000	22296	11092	56	0	\N
338442	1678	23760768253000	22296	11092	57	0	\N
338443	1678	23760768254000	22296	11092	58	0	\N
338444	1678	23760768255000	22296	11092	59	0	\N
338445	1678	23760768256000	22296	11092	60	0	\N
338446	1678	23760768257000	22296	11092	61	0	\N
338447	1678	23760768258000	22296	11092	62	0	\N
338448	1678	23760768259000	22296	11092	64	0	\N
338449	1678	23760768260000	22296	11092	65	0	\N
338450	1678	23760768261000	22296	11092	66	0	\N
338451	1678	23760768262000	22296	11092	67	0	\N
338452	1678	23760768263000	22296	11092	68	0	\N
338453	1678	23760768264000	22296	11092	69	0	\N
338454	1678	23760768265000	22296	11092	70	0	\N
338455	1678	23760768266000	22296	11092	71	0	\N
338456	1678	23760768267000	22296	11092	72	0	\N
338457	1678	23760768268000	22296	11092	73	0	\N
338458	1678	23760768269000	22296	11092	74	0	\N
338459	1678	23760768270000	22296	11092	75	0	\N
338460	1678	23760768271000	22296	11092	76	0	\N
338461	1678	23760768272000	22296	11092	77	0	\N
338462	1678	23760768273000	22296	11092	78	0	\N
338463	1678	23760768274000	22296	11092	79	0	\N
338464	1678	23760768275000	22296	11092	80	0	\N
338465	1678	23760768276000	22296	11092	81	0	\N
338466	1678	23760768277000	22296	11092	82	0	\N
338467	1678	23760768278000	22296	11092	83	0	\N
338468	1678	23760768279000	22296	11092	84	0	\N
338469	1678	23760768280000	22296	11092	85	0	\N
338470	1678	23760768281000	22296	11092	86	0	\N
338471	1678	23760768282000	22296	11092	87	0	\N
338472	1678	23760768283000	22296	11092	88	0	\N
338473	1678	23760768284000	22296	11092	89	0	\N
338474	1678	23760768285000	22296	11092	90	0	\N
338475	1385	1709614695710050	22296	11092	91	0	\N
338476	1678	23760768286000	22296	11092	92	0	\N
338477	1678	23760768287000	22296	11092	93	0	\N
338478	1678	23760768288000	22296	11092	94	0	\N
338479	1678	23760768289000	22296	11092	95	0	\N
338480	1678	23760768290000	22296	11092	96	0	\N
338481	1678	23760768291000	22296	11092	97	0	\N
338482	1678	23760768292000	22296	11092	98	0	\N
338483	1678	23760768293000	22296	11092	99	0	\N
338484	1678	23760768294000	22296	11092	100	0	\N
338485	1678	23760768295000	22296	11092	101	0	\N
338486	1678	23760768296000	22296	11092	102	0	\N
338487	1678	23760768297000	22296	11092	103	0	\N
338488	1678	23760768298000	22296	11092	104	0	\N
338489	563	66000607000000	22296	11092	105	0	\N
338490	563	66000607000000	22296	11092	106	0	\N
338491	1874	19381000	22296	11092	108	0	\N
338492	640	66001009000000	22296	11092	109	0	\N
338493	1874	19384000	22296	11092	110	0	\N
338494	1874	19386000	22296	11092	111	0	\N
338495	1874	19387000	22296	11092	112	0	\N
338496	1874	19388000	22296	11092	113	0	\N
338497	640	66720007000000	22296	11092	114	0	\N
338498	1874	19391000	22296	11092	116	0	\N
338499	1874	19394000	22296	11092	117	0	\N
338500	1874	19397000	22296	11092	118	0	\N
338501	1874	19400000	22296	11092	119	0	\N
338502	1874	19403000	22296	11092	120	0	\N
338503	1874	19406000	22296	11092	121	0	\N
338504	1874	19407000	22296	11092	122	0	\N
338371	1874	19864000	22293	11159	3	0	2
338372	1874	19866000	22293	11159	4	0	2
338373	1874	19868000	22293	11159	5	0	2
338374	1874	19869000	22293	11159	6	0	2
338375	1678	23760768297000	22294	11160	0	0	0
338377	1874	19871000	22294	11160	2	0	2
338378	1874	19873000	22294	11160	3	0	2
338379	1874	19876000	22294	11160	4	0	2
338380	1874	19879000	22294	11160	5	0	2
338505	1874	19408000	22296	11092	123	0	\N
338506	1874	19409000	22296	11092	124	0	\N
338507	1874	19410000	22296	11092	125	0	\N
338511	1678	23760768299000	22298	11161	0	0	\N
338512	1874	19881000	22298	11161	1	0	\N
338513	1874	19884000	22298	11161	2	0	\N
338528	1678	24480780304000	22300	11163	0	0	\N
338529	1874	19908000	22300	11163	1	0	\N
338530	1874	19911000	22300	11163	2	0	\N
338534	1678	24480780305000	22302	11164	0	0	\N
338535	1874	19913000	22302	11164	1	0	\N
338536	1874	19916000	22302	11164	2	0	\N
338551	1678	24480780309000	22305	11166	0	0	\N
338552	1874	19934000	22305	11166	1	0	\N
338553	1874	19937000	22305	11166	2	0	\N
338557	1678	24480780309000	22307	11166	0	0	\N
338558	1874	19934000	22307	11166	1	0	\N
338559	1874	19937000	22307	11166	2	0	\N
338560	1678	24480780309000	22308	11166	0	0	\N
338561	1874	19934000	22308	11166	1	0	\N
338562	1874	19937000	22308	11166	2	0	\N
338563	981	505968249228270	22309	11146	0	0	\N
338564	1678	23760768280000	22309	11146	1	0	\N
338565	1678	23760768281000	22309	11146	2	0	\N
338566	1678	23760768282000	22309	11146	3	0	\N
338567	1678	23760768283000	22309	11146	4	0	\N
338568	1678	23760768284000	22309	11146	5	0	\N
338569	1678	23760768285000	22309	11146	6	0	\N
338570	1678	23760768286000	22309	11146	7	0	\N
338571	1678	23760768287000	22309	11146	8	0	\N
338572	1678	23760768288000	22309	11146	9	0	\N
338573	1678	23760768289000	22309	11146	10	0	\N
338574	1678	23760768290000	22309	11146	11	0	\N
338575	1678	23760768291000	22309	11146	12	0	\N
338576	1678	23760768292000	22309	11146	13	0	\N
338577	1678	23760768293000	22309	11146	14	0	\N
338578	1678	23760768294000	22309	11146	15	0	\N
338579	1678	23760768295000	22309	11146	16	0	\N
338580	1678	23760768296000	22309	11146	17	0	\N
338581	1678	23760768297000	22309	11146	18	0	\N
338582	1678	23760768298000	22309	11146	19	0	\N
338583	1678	23760768299000	22309	11146	20	0	\N
338584	1678	23760768300000	22309	11146	21	0	\N
338585	1678	23760768301000	22309	11146	22	0	\N
338586	1678	23760768302000	22309	11146	23	0	\N
338587	1678	23760768303000	22309	11146	24	0	\N
338588	1678	23760768304000	22309	11146	25	0	\N
338589	1678	23760768305000	22309	11146	26	0	\N
338590	1678	23760768306000	22309	11146	27	0	\N
338591	1678	23760768307000	22309	11146	28	0	\N
338592	1678	23760768308000	22309	11146	29	0	\N
338593	1678	23760768309000	22309	11146	30	0	\N
338594	1874	19779000	22309	11146	31	0	\N
338595	1874	19782000	22309	11146	32	0	\N
338596	1874	19784000	22309	11146	33	0	\N
338597	1874	19786000	22309	11146	34	0	\N
338598	1874	19788000	22309	11146	35	0	\N
338599	1874	19790000	22309	11146	36	0	\N
338600	1874	19792000	22309	11146	37	0	\N
338601	1107	909302195000000	22309	11146	38	0	\N
338602	1353	1709640037751650	22309	11146	39	0	\N
338603	1874	19793000	22309	11146	40	0	\N
338604	1874	19794000	22309	11146	41	0	\N
338605	1874	19795000	22309	11146	42	0	\N
338606	1874	19796000	22309	11146	43	0	\N
338607	1874	19797000	22309	11146	44	0	\N
338608	1874	19798000	22309	11146	45	0	\N
338609	1874	19799000	22309	11146	46	0	\N
338610	1874	19800000	22309	11146	47	0	\N
338611	1874	19801000	22309	11146	48	0	\N
338612	1874	19803000	22309	11146	49	0	\N
338613	1874	19805000	22309	11146	50	0	\N
338614	1874	19807000	22309	11146	51	0	\N
338615	1874	19809000	22309	11146	52	0	\N
338616	1874	19811000	22309	11146	53	0	\N
338617	1874	19813000	22309	11146	54	0	\N
338618	1874	19815000	22309	11146	55	0	\N
338619	1874	19817000	22309	11146	56	0	\N
338620	1874	19819000	22309	11146	57	0	\N
338621	1874	19821000	22309	11146	58	0	\N
338622	1874	19823000	22309	11146	59	0	\N
338623	1874	19825000	22309	11146	60	0	\N
338624	1874	19827000	22309	11146	61	0	\N
338625	1874	19829000	22309	11146	62	0	\N
338626	1874	19831000	22309	11146	63	0	\N
338627	1874	19833000	22309	11146	64	0	\N
338628	1874	19835000	22309	11146	65	0	\N
338629	1874	19837000	22309	11146	66	0	\N
338630	1874	19839000	22309	11146	67	0	\N
338631	1874	19841000	22309	11146	68	0	\N
338632	1874	19843000	22309	11146	69	0	\N
338633	1874	19845000	22309	11146	70	0	\N
338634	1874	19847000	22309	11146	72	0	\N
338635	1874	19849000	22309	11146	73	0	\N
338636	1874	19851000	22309	11146	74	0	\N
338637	1874	19853000	22309	11146	75	0	\N
338638	1874	19856000	22309	11146	76	0	\N
338639	1874	19859000	22309	11146	77	0	\N
338640	1874	19862000	22309	11146	78	0	\N
338510	1874	19884000	22297	11161	2	0	2
338514	1678	24480780300000	22299	11162	0	0	0
338515	1678	24480780301000	22299	11162	1	0	0
338516	1678	24480780302000	22299	11162	2	0	0
338517	1678	24480780303000	22299	11162	3	0	0
338519	1874	19886000	22299	11162	5	0	2
338520	1874	19888000	22299	11162	6	0	2
338521	1874	19890000	22299	11162	7	0	2
338522	1874	19892000	22299	11162	8	0	2
338523	1874	19894000	22299	11162	9	0	2
338525	1874	19900000	22299	11162	11	0	2
338526	1874	19903000	22299	11162	12	0	2
338527	1874	19906000	22299	11162	13	0	2
338531	1678	24480780304000	22301	11163	0	0	0
338533	1874	19911000	22301	11163	2	0	2
338537	1678	24480780305000	22303	11164	0	0	0
338538	1874	19913000	22303	11164	1	0	2
338539	1874	19916000	22303	11164	2	0	2
338540	1678	24480780306000	22304	11165	0	0	0
338542	1678	24480780308000	22304	11165	2	0	0
338543	981	505968249228270	22304	11165	3	0	0
338544	1874	19919000	22304	11165	4	0	2
338545	1874	19921000	22304	11165	5	0	2
338546	1874	19924000	22304	11165	6	0	2
338548	1874	19928000	22304	11165	8	0	2
338549	1874	19930000	22304	11165	9	0	2
338550	1874	19932000	22304	11165	10	0	2
338554	1678	24480780309000	22306	11166	0	0	0
338556	1874	19937000	22306	11166	2	0	2
338641	1874	19865000	22309	11146	79	0	\N
338642	1874	19868000	22309	11146	80	0	\N
338643	1874	19871000	22309	11146	81	0	\N
338644	1874	19874000	22309	11146	82	0	\N
338645	1874	19877000	22309	11146	83	0	\N
338646	1874	19880000	22309	11146	84	0	\N
338647	1874	19883000	22309	11146	85	0	\N
338648	1874	19886000	22309	11146	86	0	\N
338649	1874	19889000	22309	11146	87	0	\N
338650	1874	19892000	22309	11146	88	0	\N
338651	1874	19895000	22309	11146	89	0	\N
338652	1874	19898000	22309	11146	90	0	\N
338653	1874	19901000	22309	11146	91	0	\N
338654	1874	19904000	22309	11146	92	0	\N
338655	1874	19907000	22309	11146	93	0	\N
338656	1874	19910000	22309	11146	94	0	\N
338657	1874	19913000	22309	11146	95	0	\N
338658	1874	19916000	22309	11146	96	0	\N
338659	1874	19919000	22309	11146	97	0	\N
338660	1874	19922000	22309	11146	98	0	\N
338661	1874	19925000	22309	11146	99	0	\N
338662	1874	19928000	22309	11146	100	0	\N
338663	1874	19931000	22309	11146	101	0	\N
338664	1874	19934000	22309	11146	102	0	\N
338665	1874	19937000	22309	11146	103	0	\N
338676	1678	24480780313000	22313	11170	0	0	\N
338677	1874	19955000	22313	11170	1	0	\N
338678	1874	19958000	22313	11170	2	0	\N
338679	1874	19959000	22313	11170	3	0	\N
338692	1678	24480780314000	22317	11171	0	0	\N
338693	1678	24480780315000	22317	11171	1	0	\N
338694	1101	906690767481065	22317	11171	2	0	\N
338695	978	506862505000000	22317	11171	3	0	\N
338696	1874	19962000	22317	11171	4	0	\N
338697	1874	19965000	22317	11171	5	0	\N
338698	1874	19967000	22317	11171	6	0	\N
338699	1874	19969000	22317	11171	7	0	\N
338712	1678	24480780318000	22319	11173	0	0	\N
338713	1678	24480780319000	22319	11173	1	0	\N
338714	1678	24480780320000	22319	11173	2	0	\N
338715	1874	19983000	22319	11173	3	0	\N
338716	1874	19986000	22319	11173	4	0	\N
338717	1344	1707743047751650	22319	11173	5	0	\N
338718	1874	19989000	22319	11173	6	0	\N
338719	1874	19990000	22319	11173	8	0	\N
338720	1874	19992000	22319	11173	9	0	\N
338721	1874	19994000	22319	11173	10	0	\N
338722	1874	19996000	22319	11173	11	0	\N
338734	1678	24480780318000	22321	11173	0	0	\N
338735	1678	24480780319000	22321	11173	1	0	\N
338736	1678	24480780320000	22321	11173	2	0	\N
338737	1874	19983000	22321	11173	3	0	\N
338738	1874	19986000	22321	11173	4	0	\N
338739	1344	1707743047751650	22321	11173	5	0	\N
338740	1874	19989000	22321	11173	6	0	\N
338741	1874	19990000	22321	11173	8	0	\N
338742	1874	19992000	22321	11173	9	0	\N
338743	1874	19994000	22321	11173	10	0	\N
338744	1874	19996000	22321	11173	11	0	\N
338745	1678	24480780321000	22322	11174	0	0	\N
338746	1678	24480780322000	22322	11174	1	0	\N
338747	1874	19998000	22322	11174	2	0	\N
338748	1874	20000000	22322	11174	3	0	\N
338749	1874	20003000	22322	11174	4	0	\N
338750	1874	20006000	22322	11174	5	0	\N
338751	2074	2293600000000	22322	11174	6	0	\N
338757	1678	24480780321000	22324	11174	0	0	\N
338758	1678	24480780322000	22324	11174	1	0	\N
338759	1874	19998000	22324	11174	2	0	\N
338760	1874	20000000	22324	11174	3	0	\N
338761	1874	20003000	22324	11174	4	0	\N
338762	1874	20006000	22324	11174	5	0	\N
338763	2074	2293600000000	22324	11174	6	0	\N
338764	1678	24480780321000	22325	11174	0	0	\N
338765	1678	24480780322000	22325	11174	1	0	\N
338766	1874	19998000	22325	11174	2	0	\N
338767	1874	20000000	22325	11174	3	0	\N
338768	1874	20003000	22325	11174	4	0	\N
338769	1874	20006000	22325	11174	5	0	\N
338770	2074	2293600000000	22325	11174	6	0	\N
338771	1678	24480780321000	22326	11174	0	0	\N
338772	1678	24480780322000	22326	11174	1	0	\N
338773	1874	19998000	22326	11174	2	0	\N
338774	1874	20000000	22326	11174	3	0	\N
338775	1874	20003000	22326	11174	4	0	\N
338776	1874	20006000	22326	11174	5	0	\N
338668	1874	19941000	22310	11167	2	0	2
338669	1874	19943000	22310	11167	3	0	2
338670	1678	24480780311000	22311	11168	0	0	0
338671	1874	19945000	22311	11168	1	0	2
338672	1874	19948000	22311	11168	2	0	2
338674	1874	19950000	22312	11169	1	0	2
338675	1874	19953000	22312	11169	2	0	2
338680	1678	24480780313000	22314	11170	0	0	0
338681	1874	19955000	22314	11170	1	0	2
338682	1874	19958000	22314	11170	2	0	2
338684	1678	24480780314000	22316	11171	0	0	0
338685	1678	24480780315000	22316	11171	1	0	0
338686	1101	906690767481065	22316	11171	2	0	0
338687	978	506862505000000	22316	11171	3	0	0
338689	1874	19965000	22316	11171	5	0	2
338690	1874	19967000	22316	11171	6	0	2
338691	1874	19969000	22316	11171	7	0	2
338700	1678	24480780316000	22318	11172	0	0	0
338701	1678	24480780317000	22318	11172	1	0	0
338703	1347	1704730121592585	22318	11172	3	0	0
338704	1874	19971000	22318	11172	4	0	2
338705	1874	19972000	22318	11172	5	0	2
338706	2295	718699000000	22318	11172	6	0	0
338707	1874	19975000	22318	11172	7	0	2
338709	1218	612843560000000	22318	11172	9	0	0
338710	1874	19978000	22318	11172	10	0	2
338711	1874	19980000	22318	11172	11	0	2
338723	1678	24480780318000	22320	11173	0	0	0
338725	1678	24480780320000	22320	11173	2	0	0
338726	1874	19983000	22320	11173	3	0	2
338727	1874	19986000	22320	11173	4	0	2
338728	1344	1707743047751650	22320	11173	5	0	0
338729	1874	19989000	22320	11173	6	0	2
338731	1874	19992000	22320	11173	9	0	2
338732	1874	19994000	22320	11173	10	0	2
338733	1874	19996000	22320	11173	11	0	2
338752	1678	24480780321000	22323	11174	0	0	0
338753	1678	24480780322000	22323	11174	1	0	0
338755	1874	20000000	22323	11174	3	0	2
338756	2074	2293600000000	22323	11174	4	0	0
338777	2074	2293600000000	22326	11174	6	0	\N
338778	1678	24480780321000	22327	11174	0	0	\N
338779	1678	24480780322000	22327	11174	1	0	\N
338780	1874	19998000	22327	11174	2	0	\N
338781	1874	20000000	22327	11174	3	0	\N
338782	1874	20003000	22327	11174	4	0	\N
338783	1874	20006000	22327	11174	5	0	\N
338784	2074	2293600000000	22327	11174	6	0	\N
338785	1678	24480780323000	22328	11175	0	0	\N
338786	1874	20002000	22328	11175	1	0	\N
338787	1874	20003000	22328	11175	2	0	\N
338791	1678	24480780323000	22330	11175	0	0	\N
338792	1874	20002000	22330	11175	1	0	\N
338793	1874	20005000	22330	11175	2	0	\N
338794	1874	20008000	22330	11175	3	0	\N
338795	1874	20011000	22330	11175	4	0	\N
338796	1874	20012000	22330	11175	5	0	\N
338806	1678	24480780324000	22333	11177	0	0	\N
338807	1678	24480780325000	22333	11177	1	0	\N
338808	1678	24480780326000	22333	11177	2	0	\N
338809	1874	20012000	22333	11177	3	0	\N
338810	1874	20014000	22333	11177	4	0	\N
338811	1874	20017000	22333	11177	5	0	\N
338812	1874	20020000	22333	11177	6	0	\N
338813	1874	20023000	22333	11177	7	0	\N
338814	1874	20024000	22333	11177	8	0	\N
338815	1874	20026000	22333	11177	9	0	\N
338816	1874	20028000	22333	11177	10	0	\N
338834	1678	24480780331000	22336	11180	0	0	\N
338835	1874	20051000	22336	11180	1	0	\N
338836	1874	20054000	22336	11180	2	0	\N
338847	1678	24480780334000	22340	11183	0	0	\N
338848	1678	24480780335000	22340	11183	1	0	\N
338849	1678	24480780336000	22340	11183	2	0	\N
338850	1874	20067000	22340	11183	3	0	\N
338851	1874	20068000	22340	11183	4	0	\N
338852	1874	20070000	22340	11183	5	0	\N
338853	1874	20072000	22340	11183	6	0	\N
338854	1874	20075000	22340	11183	7	0	\N
338855	1874	20078000	22340	11183	8	0	\N
338856	1874	20081000	22340	11183	9	0	\N
338857	1678	24480780334000	22341	11183	0	0	\N
338858	1678	24480780335000	22341	11183	1	0	\N
338859	1678	24480780336000	22341	11183	2	0	\N
338860	1874	20067000	22341	11183	3	0	\N
338861	1874	20068000	22341	11183	4	0	\N
338862	1874	20070000	22341	11183	5	0	\N
338863	1874	20072000	22341	11183	6	0	\N
338864	1874	20075000	22341	11183	7	0	\N
338865	1874	20078000	22341	11183	8	0	\N
338866	1874	20081000	22341	11183	9	0	\N
338881	1678	24480780337000	22344	11184	0	0	\N
338882	1678	24480780338000	22344	11184	1	0	\N
338883	1874	20074000	22344	11184	2	0	\N
338884	1874	20076000	22344	11184	3	0	\N
338885	1874	20079000	22344	11184	4	0	\N
338886	1874	20082000	22344	11184	5	0	\N
338887	1874	20085000	22344	11184	6	0	\N
338888	1874	20088000	22344	11184	7	0	\N
338889	1874	20091000	22344	11184	8	0	\N
338895	1678	24480780340000	22346	11186	0	0	\N
338896	1874	20098000	22346	11186	1	0	\N
338897	1874	20099000	22346	11186	2	0	\N
338898	1874	20102000	22346	11186	3	0	\N
338899	1678	24480780340000	22347	11186	0	0	\N
338900	1874	20098000	22347	11186	1	0	\N
338901	1874	20099000	22347	11186	2	0	\N
338902	1874	20102000	22347	11186	3	0	\N
338909	1678	24480780323000	22350	11175	0	0	\N
338910	1678	24480780324000	22350	11175	1	0	\N
338911	1678	24480780325000	22350	11175	2	0	\N
338912	1678	24480780326000	22350	11175	3	0	\N
338790	1874	20003000	22329	11175	2	0	2
338797	1874	20006000	22331	11176	0	0	2
338798	1874	20009000	22331	11176	1	0	2
338799	1678	24480780324000	22332	11177	0	0	0
338800	1678	24480780325000	22332	11177	1	0	0
338802	1874	20011000	22332	11177	3	0	2
338803	1874	20012000	22332	11177	4	0	2
338804	1874	20014000	22332	11177	5	0	2
338805	1874	20016000	22332	11177	6	0	2
338817	1678	24480780327000	22334	11178	0	0	0
338819	1874	20019000	22334	11178	2	0	2
338820	1874	20021000	22334	11178	3	0	2
338821	1874	20023000	22334	11178	4	0	2
338822	1874	20026000	22334	11178	5	0	2
338824	1874	20032000	22334	11178	7	0	2
338825	1874	20035000	22334	11178	8	0	2
338826	1874	20038000	22334	11178	9	0	2
338827	1678	24480780329000	22335	11179	0	0	0
338828	1678	24480780330000	22335	11179	1	0	0
338830	1874	20044000	22335	11179	3	0	2
338831	1874	20045000	22335	11179	4	0	2
338832	1874	20047000	22335	11179	5	0	2
338833	1874	20049000	22335	11179	6	0	2
338837	1678	24480780331000	22337	11180	0	0	0
338839	1874	20054000	22337	11180	2	0	2
338840	1678	24480780332000	22338	11181	0	0	0
338841	1874	20057000	22338	11181	1	0	2
338842	1874	20059000	22338	11181	2	0	2
338844	1874	20062000	22339	11182	1	0	2
338845	1874	20063000	22339	11182	2	0	2
338846	1874	20065000	22339	11182	3	0	2
338867	1678	24480780334000	22342	11183	0	0	0
338868	1678	24480780335000	22342	11183	1	0	0
338870	1874	20067000	22342	11183	3	0	2
338871	1874	20068000	22342	11183	4	0	2
338872	1874	20070000	22342	11183	5	0	2
338873	1874	20072000	22342	11183	6	0	2
338874	1678	24480780337000	22343	11184	0	0	0
338876	1874	20074000	22343	11184	2	0	2
338877	1874	20076000	22343	11184	3	0	2
338878	1874	20079000	22343	11184	4	0	2
338879	1874	20082000	22343	11184	5	0	2
338890	1678	24480780339000	22345	11185	0	0	0
338891	1874	20087000	22345	11185	1	0	2
338892	1874	20090000	22345	11185	2	0	2
338893	1874	20093000	22345	11185	3	0	2
338894	1874	20096000	22345	11185	4	0	2
338904	1874	20098000	22348	11186	1	0	2
338905	1874	20099000	22348	11186	2	0	2
338906	1874	20102000	22348	11186	3	0	2
338907	1678	24480780341000	22349	11187	0	0	0
338908	1874	20104000	22349	11187	1	0	2
338913	1678	24480780327000	22350	11175	4	0	\N
338914	1678	24480780328000	22350	11175	5	0	\N
338915	1678	24480780329000	22350	11175	6	0	\N
338916	1678	24480780330000	22350	11175	7	0	\N
338917	1678	24480780331000	22350	11175	8	0	\N
338918	1678	24480780332000	22350	11175	9	0	\N
338919	1678	24480780333000	22350	11175	10	0	\N
338920	1678	24480780334000	22350	11175	11	0	\N
338921	1678	24480780335000	22350	11175	12	0	\N
338922	1678	24480780336000	22350	11175	13	0	\N
338923	1678	24480780337000	22350	11175	14	0	\N
338924	1678	24480780338000	22350	11175	15	0	\N
338925	1678	24480780339000	22350	11175	16	0	\N
338926	1678	24480780340000	22350	11175	17	0	\N
338927	1678	24480780341000	22350	11175	18	0	\N
338928	1874	20002000	22350	11175	19	0	\N
338929	1874	20004000	22350	11175	20	0	\N
338930	1874	20007000	22350	11175	21	0	\N
338931	1874	20010000	22350	11175	22	0	\N
338932	1874	20013000	22350	11175	23	0	\N
338933	1874	20016000	22350	11175	24	0	\N
338934	1874	20019000	22350	11175	25	0	\N
338935	1874	20022000	22350	11175	26	0	\N
338936	1874	20025000	22350	11175	27	0	\N
338937	1874	20028000	22350	11175	28	0	\N
338938	1874	20031000	22350	11175	29	0	\N
338939	1874	20034000	22350	11175	30	0	\N
338940	1874	20037000	22350	11175	31	0	\N
338941	1874	20040000	22350	11175	32	0	\N
338942	1874	20043000	22350	11175	33	0	\N
338943	1874	20044000	22350	11175	34	0	\N
338944	1874	20045000	22350	11175	35	0	\N
338945	1874	20046000	22350	11175	36	0	\N
338946	1874	20047000	22350	11175	37	0	\N
338947	1874	20048000	22350	11175	38	0	\N
338948	1874	20049000	22350	11175	39	0	\N
338949	1874	20052000	22350	11175	40	0	\N
338950	1874	20055000	22350	11175	41	0	\N
338951	1874	20058000	22350	11175	42	0	\N
338952	1874	20061000	22350	11175	43	0	\N
338953	1874	20064000	22350	11175	44	0	\N
338954	1874	20067000	22350	11175	45	0	\N
338955	1874	20070000	22350	11175	46	0	\N
338956	1874	20072000	22350	11175	47	0	\N
338957	1874	20074000	22350	11175	48	0	\N
338958	1874	20076000	22350	11175	49	0	\N
338959	1874	20078000	22350	11175	50	0	\N
338960	1874	20080000	22350	11175	51	0	\N
338961	1874	20082000	22350	11175	52	0	\N
338962	1874	20084000	22350	11175	53	0	\N
338963	1874	20086000	22350	11175	54	0	\N
338964	1874	20088000	22350	11175	55	0	\N
338965	1874	20090000	22350	11175	56	0	\N
338966	1874	20092000	22350	11175	57	0	\N
338967	1874	20094000	22350	11175	58	0	\N
338968	1874	20096000	22350	11175	59	0	\N
338969	1874	20098000	22350	11175	60	0	\N
338970	1874	20100000	22350	11175	61	0	\N
338971	1874	20102000	22350	11175	62	0	\N
338972	1874	20104000	22350	11175	63	0	\N
338980	981	505968249228270	22354	11162	0	0	\N
338981	1101	906690767481065	22354	11162	1	0	\N
338982	1221	611762327909290	22354	11162	2	0	\N
338983	1347	1704730121592585	22354	11162	3	0	\N
338984	978	506862505000000	22354	11162	4	0	\N
338985	2295	718699000000	22354	11162	5	0	\N
338986	1098	908293245000000	22354	11162	6	0	\N
338987	1218	612843560000000	22354	11162	7	0	\N
338988	1344	1707743047751650	22354	11162	8	0	\N
338989	2074	2293600000000	22354	11162	9	0	\N
338990	1678	24480780344000	22355	11190	0	0	\N
338991	1874	20118000	22355	11190	1	0	\N
338992	1874	20120000	22355	11190	2	0	\N
338993	1678	24480780344000	22356	11190	0	0	\N
338994	1874	20118000	22356	11190	1	0	\N
338995	1874	20120000	22356	11190	2	0	\N
338999	1678	24480780344000	22358	11190	0	0	\N
339000	1874	20118000	22358	11190	1	0	\N
339001	1874	20120000	22358	11190	2	0	\N
339005	1678	24480780346000	22360	11192	0	0	\N
339006	1874	20128000	22360	11192	1	0	\N
339007	1874	20129000	22360	11192	3	0	\N
339008	1874	20131000	22360	11192	4	0	\N
339009	1678	24480780346000	22361	11192	0	0	\N
339010	1874	20128000	22361	11192	1	0	\N
339011	1874	20129000	22361	11192	3	0	\N
339012	1874	20131000	22361	11192	4	0	\N
339030	1678	24480780350000	22365	11194	0	0	\N
339031	1874	20148000	22365	11194	1	0	\N
339032	1874	20151000	22365	11194	2	0	\N
339033	1874	20152000	22365	11194	3	0	\N
339044	1678	24480780352000	22368	11196	0	0	\N
339045	1678	24480780353000	22368	11196	1	0	\N
339046	1874	20160000	22368	11196	2	0	\N
339047	1874	20161000	22368	11196	3	0	\N
339048	1874	20164000	22368	11196	4	0	\N
338975	1874	20109000	22351	11188	2	0	2
338976	1678	24480780343000	22353	11189	0	0	0
338977	1874	20112000	22353	11189	1	0	2
338978	1874	20113000	22353	11189	2	0	2
338979	1874	20115000	22353	11189	3	0	2
338997	1874	20118000	22357	11190	1	0	2
338998	1874	20120000	22357	11190	2	0	2
339002	1678	24480780345000	22359	11191	0	0	0
339003	1874	20123000	22359	11191	1	0	2
339004	1874	20125000	22359	11191	2	0	2
339014	1874	20128000	22362	11192	1	0	2
339015	1874	20129000	22362	11192	3	0	2
339016	1874	20131000	22362	11192	4	0	2
339017	1678	24480780347000	22363	11193	0	0	0
339019	1678	24480780349000	22363	11193	2	0	0
339020	1874	20134000	22363	11193	3	0	2
339021	1874	20137000	22363	11193	4	0	2
339022	1874	20140000	22363	11193	5	0	2
339023	1874	20142000	22363	11193	6	0	2
339025	1874	20146000	22363	11193	8	0	2
339026	1678	24480780350000	22364	11194	0	0	0
339027	1874	20148000	22364	11194	1	0	2
339028	1874	20151000	22364	11194	2	0	2
339029	1874	20152000	22364	11194	3	0	2
339035	1874	20154000	22366	11195	1	0	2
339036	1874	20157000	22366	11195	2	0	2
339037	1678	24480780352000	22367	11196	0	0	0
339038	1678	24480780353000	22367	11196	1	0	0
339040	1874	20161000	22367	11196	3	0	2
339041	1874	20164000	22367	11196	4	0	2
339042	1874	20166000	22367	11196	5	0	2
339043	1874	20168000	22367	11196	6	0	2
339049	1874	20166000	22368	11196	5	0	\N
339050	1874	20168000	22368	11196	6	0	\N
339051	1678	24480780352000	22369	11196	0	0	\N
339052	1678	24480780353000	22369	11196	1	0	\N
339053	1874	20160000	22369	11196	2	0	\N
339054	1874	20161000	22369	11196	3	0	\N
339055	1874	20164000	22369	11196	4	0	\N
339056	1874	20166000	22369	11196	5	0	\N
339057	1874	20168000	22369	11196	6	0	\N
339058	1678	24480780352000	22370	11196	0	0	\N
339059	1678	24480780353000	22370	11196	1	0	\N
339060	1874	20160000	22370	11196	2	0	\N
339061	1874	20161000	22370	11196	3	0	\N
339062	1874	20164000	22370	11196	4	0	\N
339063	1874	20166000	22370	11196	5	0	\N
339064	1874	20168000	22370	11196	6	0	\N
339086	1678	24480780359000	22376	11201	0	0	\N
339087	1678	24480780360000	22376	11201	1	0	\N
339088	1874	20192000	22376	11201	2	0	\N
339089	1874	20193000	22376	11201	3	0	\N
339090	1874	20196000	22376	11201	4	0	\N
339091	1874	20198000	22376	11201	5	0	\N
339092	1874	20200000	22376	11201	6	0	\N
339106	1678	24480780364000	22380	11204	0	0	\N
339107	1874	20218000	22380	11204	1	0	\N
339108	1874	20221000	22380	11204	2	0	\N
339113	2199	720338000000	22382	11163	0	0	\N
339121	1678	24480780368000	22385	11208	0	0	\N
339122	1874	20240000	22385	11208	1	0	\N
339123	1874	20242000	22385	11208	2	0	\N
339127	1678	24480780368000	22387	11208	0	0	\N
339128	1874	20240000	22387	11208	1	0	\N
339129	1874	20242000	22387	11208	2	0	\N
339130	1678	24480780344000	22388	11190	0	0	\N
339131	1678	24480780345000	22388	11190	1	0	\N
339132	1678	24480780346000	22388	11190	2	0	\N
339133	1678	24480780347000	22388	11190	3	0	\N
339134	1678	24480780348000	22388	11190	4	0	\N
339135	1678	24480780349000	22388	11190	5	0	\N
339136	1678	24480780350000	22388	11190	6	0	\N
339137	1678	24480780351000	22388	11190	7	0	\N
339138	1678	24480780352000	22388	11190	8	0	\N
339139	1678	24480780353000	22388	11190	9	0	\N
339140	1678	24480780354000	22388	11190	10	0	\N
339141	1678	24480780355000	22388	11190	11	0	\N
339142	1678	24480780356000	22388	11190	13	0	\N
339143	1678	24480780357000	22388	11190	14	0	\N
339144	1678	24480780358000	22388	11190	15	0	\N
339145	1678	24480780359000	22388	11190	16	0	\N
339146	1678	24480780360000	22388	11190	17	0	\N
339147	1678	24480780361000	22388	11190	18	0	\N
339148	1678	24480780362000	22388	11190	19	0	\N
339149	1678	24480780363000	22388	11190	20	0	\N
339150	1678	24480780364000	22388	11190	21	0	\N
339151	1678	24480780365000	22388	11190	22	0	\N
339152	1678	24480780366000	22388	11190	23	0	\N
339153	1678	24480780367000	22388	11190	24	0	\N
339154	1678	24480780368000	22388	11190	25	0	\N
339155	1874	20118000	22388	11190	26	0	\N
339156	2199	720338000000	22388	11190	27	0	\N
339157	1874	20121000	22388	11190	28	0	\N
339158	1874	20124000	22388	11190	29	0	\N
339159	1874	20127000	22388	11190	30	0	\N
339160	1874	20130000	22388	11190	31	0	\N
339161	1874	20131000	22388	11190	32	0	\N
339162	1874	20134000	22388	11190	33	0	\N
339163	1874	20137000	22388	11190	34	0	\N
339164	1874	20138000	22388	11190	35	0	\N
339165	1874	20141000	22388	11190	36	0	\N
339166	1874	20144000	22388	11190	37	0	\N
339167	1874	20145000	22388	11190	38	0	\N
339168	1874	20146000	22388	11190	39	0	\N
339169	1874	20149000	22388	11190	40	0	\N
339170	1874	20152000	22388	11190	41	0	\N
339171	1874	20155000	22388	11190	42	0	\N
339172	1874	20158000	22388	11190	43	0	\N
339173	1874	20160000	22388	11190	44	0	\N
339174	1874	20162000	22388	11190	45	0	\N
339175	1874	20164000	22388	11190	46	0	\N
339176	1874	20166000	22388	11190	47	0	\N
339177	1874	20168000	22388	11190	48	0	\N
339178	1874	20170000	22388	11190	49	0	\N
339179	1874	20172000	22388	11190	50	0	\N
339180	1874	20174000	22388	11190	51	0	\N
339181	1874	20177000	22388	11190	52	0	\N
339182	1874	20180000	22388	11190	53	0	\N
339183	1874	20181000	22388	11190	54	0	\N
339184	1874	20182000	22388	11190	55	0	\N
339067	1874	20170000	22372	11198	1	0	2
339068	1874	20173000	22372	11198	2	0	2
339069	1678	24480780356000	22373	11199	0	0	0
339070	1678	24480780357000	22373	11199	1	0	0
339071	1874	20175000	22373	11199	2	0	2
339073	1874	20179000	22373	11199	4	0	2
339074	1874	20182000	22373	11199	5	0	2
339075	1874	20184000	22373	11199	6	0	2
339076	1678	24480780358000	22374	11200	0	0	0
339077	1874	20186000	22374	11200	1	0	2
339079	1678	24480780359000	22375	11201	0	0	0
339080	1678	24480780360000	22375	11201	1	0	0
339081	1874	20192000	22375	11201	2	0	2
339082	1874	20193000	22375	11201	3	0	2
339084	1874	20198000	22375	11201	5	0	2
339085	1874	20200000	22375	11201	6	0	2
339093	1678	24480780361000	22377	11202	0	0	0
339094	1678	24480780362000	22377	11202	1	0	0
339095	1874	20203000	22377	11202	2	0	2
339097	1874	20207000	22377	11202	4	0	2
339098	1874	20210000	22377	11202	5	0	2
339099	1678	24480780363000	22378	11203	0	0	0
339100	1874	20211000	22378	11203	1	0	2
339101	1874	20214000	22378	11203	2	0	2
339103	1678	24480780364000	22379	11204	0	0	0
339104	1874	20218000	22379	11204	1	0	2
339105	1874	20221000	22379	11204	2	0	2
339109	1678	24480780365000	22381	11205	0	0	0
339111	1874	20223000	22381	11205	2	0	2
339112	1874	20226000	22381	11205	3	0	2
339114	1678	24480780366000	22383	11206	0	0	0
339115	1874	20227000	22383	11206	1	0	2
339116	1874	20229000	22383	11206	2	0	2
339118	1678	24480780367000	22384	11207	0	0	0
339119	1874	20234000	22384	11207	1	0	2
339120	1874	20237000	22384	11207	2	0	2
339124	1678	24480780368000	22386	11208	0	0	0
339125	1874	20240000	22386	11208	1	0	2
339185	1874	20183000	22388	11190	56	0	\N
339186	1874	20185000	22388	11190	57	0	\N
339187	1874	20187000	22388	11190	58	0	\N
339188	1874	20189000	22388	11190	59	0	\N
339189	1874	20191000	22388	11190	60	0	\N
339190	1874	20194000	22388	11190	61	0	\N
339191	1874	20197000	22388	11190	62	0	\N
339192	1874	20200000	22388	11190	63	0	\N
339193	1874	20203000	22388	11190	64	0	\N
339194	1874	20206000	22388	11190	65	0	\N
339195	1874	20209000	22388	11190	66	0	\N
339196	1874	20212000	22388	11190	67	0	\N
339197	1874	20215000	22388	11190	68	0	\N
339198	1874	20218000	22388	11190	69	0	\N
339199	1874	20220000	22388	11190	70	0	\N
339200	1874	20222000	22388	11190	71	0	\N
339201	1874	20224000	22388	11190	72	0	\N
339202	1874	20226000	22388	11190	73	0	\N
339203	1874	20228000	22388	11190	74	0	\N
339204	1874	20230000	22388	11190	75	0	\N
339205	1874	20232000	22388	11190	76	0	\N
339206	1874	20234000	22388	11190	77	0	\N
339207	1874	20236000	22388	11190	78	0	\N
339208	1874	20238000	22388	11190	79	0	\N
339209	1874	20240000	22388	11190	80	0	\N
339210	1874	20242000	22388	11190	81	0	\N
339211	1678	24480780369000	22389	11209	0	0	\N
339212	1874	20245000	22389	11209	1	0	\N
339213	1874	20247000	22389	11209	2	0	\N
339214	1678	24480780369000	22390	11209	0	0	\N
339215	1874	20245000	22390	11209	1	0	\N
339216	1874	20247000	22390	11209	2	0	\N
339224	1678	24480780370000	22393	11210	0	0	\N
339225	1874	20248000	22393	11210	1	0	\N
339226	1874	20251000	22393	11210	2	0	\N
339227	1874	20253000	22393	11210	3	0	\N
339238	1678	24480780374000	22397	11214	0	0	\N
339239	1678	24480780375000	22397	11214	1	0	\N
339240	1874	20271000	22397	11214	2	0	\N
339241	1874	20273000	22397	11214	3	0	\N
339242	1874	20276000	22397	11214	4	0	\N
339243	1874	20279000	22397	11214	5	0	\N
339244	1678	24480780374000	22398	11214	0	0	\N
339245	1678	24480780375000	22398	11214	1	0	\N
339246	1874	20271000	22398	11214	2	0	\N
339247	1874	20273000	22398	11214	3	0	\N
339248	1874	20276000	22398	11214	4	0	\N
339249	1874	20279000	22398	11214	5	0	\N
339250	1678	24480780374000	22400	11214	0	0	\N
339251	1678	24480780375000	22400	11214	1	0	\N
339252	1874	20271000	22400	11214	2	0	\N
339253	1874	20273000	22400	11214	3	0	\N
339254	1874	20276000	22400	11214	4	0	\N
339255	1874	20279000	22400	11214	5	0	\N
339262	1678	24480780376000	22402	11215	0	0	\N
339263	1678	24480780377000	22402	11215	1	0	\N
339264	1874	20281000	22402	11215	2	0	\N
339265	1874	20282000	22402	11215	3	0	\N
339266	1874	20285000	22402	11215	4	0	\N
339267	1874	20288000	22402	11215	5	0	\N
339268	1874	20290000	22402	11215	6	0	\N
339276	1678	24480780369000	22404	11191	0	0	\N
339277	1678	24480780370000	22404	11191	1	0	\N
339278	1678	24480780371000	22404	11191	2	0	\N
339279	1678	24480780372000	22404	11191	3	0	\N
339280	1678	24480780373000	22404	11191	4	0	\N
339281	1678	24480780374000	22404	11191	5	0	\N
339282	1678	24480780375000	22404	11191	6	0	\N
339283	1678	24480780376000	22404	11191	7	0	\N
339284	1874	20243000	22404	11191	8	0	\N
339285	1874	20246000	22404	11191	9	0	\N
339286	1874	20249000	22404	11191	10	0	\N
339287	1874	20251000	22404	11191	11	0	\N
339288	1874	20253000	22404	11191	12	0	\N
339289	1874	20255000	22404	11191	13	0	\N
339290	1874	20257000	22404	11191	14	0	\N
339291	1874	20259000	22404	11191	15	0	\N
339292	1874	20261000	22404	11191	16	0	\N
339293	1874	20263000	22404	11191	17	0	\N
339294	1874	20265000	22404	11191	18	0	\N
339295	1874	20268000	22404	11191	19	0	\N
339296	1874	20271000	22404	11191	20	0	\N
339297	1874	20274000	22404	11191	21	0	\N
339298	1874	20277000	22404	11191	22	0	\N
339299	1874	20278000	22404	11191	23	0	\N
339300	1874	20281000	22404	11191	24	0	\N
339301	1874	20284000	22404	11191	25	0	\N
339304	1678	24480780378000	22406	11216	0	0	\N
339305	1874	20292000	22406	11216	1	0	\N
339306	1678	24480780379000	22407	11217	0	0	\N
339307	1874	20295000	22407	11217	1	0	\N
339308	1678	24480780379000	22408	11217	0	0	\N
339309	1874	20294000	22408	11217	1	0	\N
339310	1874	20297000	22408	11217	2	0	\N
339311	1678	24480780379000	22409	11217	0	0	\N
339312	1874	20294000	22409	11217	1	0	\N
339313	1874	20297000	22409	11217	2	0	\N
339317	1678	24480780380000	22411	11218	0	0	\N
339318	1678	24480780381000	22411	11218	1	0	\N
339319	1678	24480780382000	22411	11218	2	0	\N
339320	1874	20298000	22411	11218	3	0	\N
339219	1874	20247000	22391	11209	2	0	2
339220	1678	24480780370000	22392	11210	0	0	0
339221	1874	20248000	22392	11210	1	0	2
339222	1874	20251000	22392	11210	2	0	2
339223	1874	20253000	22392	11210	3	0	2
339229	1874	20255000	22394	11211	1	0	2
339230	1874	20258000	22394	11211	2	0	2
339231	1678	24480780372000	22395	11212	0	0	0
339232	1874	20260000	22395	11212	1	0	2
339233	1874	20263000	22395	11212	2	0	2
339235	1874	20266000	22396	11213	1	0	2
339236	1874	20268000	22396	11213	2	0	2
339237	1874	20269000	22396	11213	3	0	2
339256	1678	24480780374000	22401	11214	0	0	0
339258	1874	20271000	22401	11214	2	0	2
339259	1874	20273000	22401	11214	3	0	2
339260	1874	20276000	22401	11214	4	0	2
339261	1874	20279000	22401	11214	5	0	2
339269	1678	24480780376000	22403	11215	0	0	0
339271	1874	20281000	22403	11215	2	0	2
339272	1874	20282000	22403	11215	3	0	2
339273	1874	20285000	22403	11215	4	0	2
339274	1874	20288000	22403	11215	5	0	2
339275	1874	20290000	22403	11215	6	0	2
339303	1874	20292000	22405	11216	1	0	2
339314	1678	24480780379000	22410	11217	0	0	0
339315	1874	20294000	22410	11217	1	0	2
339316	1874	20297000	22410	11217	2	0	2
339321	1874	20300000	22411	11218	4	0	\N
339322	1874	20302000	22411	11218	5	0	\N
339323	1874	20304000	22411	11218	6	0	\N
339324	1874	20307000	22411	11218	7	0	\N
339325	1874	20310000	22411	11218	8	0	\N
339326	1874	20313000	22411	11218	9	0	\N
339344	1678	24480780385000	22415	11221	0	0	\N
339345	1874	20327000	22415	11221	1	0	\N
339346	1678	24480780385000	22416	11221	0	0	\N
339347	1874	20326000	22416	11221	1	0	\N
339348	1874	20329000	22416	11221	2	0	\N
339352	1678	24480780380000	22418	11218	0	0	\N
339353	1678	24480780381000	22418	11218	1	0	\N
339354	1678	24480780382000	22418	11218	2	0	\N
339355	1678	24480780383000	22418	11218	3	0	\N
339356	1678	24480780384000	22418	11218	4	0	\N
339357	1678	24480780385000	22418	11218	5	0	\N
339358	1874	20296000	22418	11218	6	0	\N
339359	1874	20298000	22418	11218	7	0	\N
339360	1874	20299000	22418	11218	8	0	\N
339361	1874	20301000	22418	11218	9	0	\N
339362	1874	20304000	22418	11218	10	0	\N
339363	1874	20307000	22418	11218	11	0	\N
339364	1874	20310000	22418	11218	12	0	\N
339365	1874	20313000	22418	11218	13	0	\N
339366	1874	20316000	22418	11218	14	0	\N
339367	1874	20319000	22418	11218	15	0	\N
339368	1678	24480780386000	22419	11222	0	0	\N
339369	1874	20331000	22419	11222	1	0	\N
339372	1678	24480780387000	22421	11223	0	0	\N
339373	1678	24480780388000	22421	11223	1	0	\N
339374	1874	20334000	22421	11223	2	0	\N
339375	1874	20335000	22421	11223	3	0	\N
339376	1874	20338000	22421	11223	4	0	\N
339377	1874	20340000	22421	11223	5	0	\N
339378	1874	20342000	22421	11223	6	0	\N
339379	1678	24480780387000	22422	11223	0	0	\N
339380	1678	24480780388000	22422	11223	1	0	\N
339381	1874	20334000	22422	11223	2	0	\N
339382	1874	20335000	22422	11223	3	0	\N
339383	1874	20338000	22422	11223	4	0	\N
339384	1678	24480780387000	22423	11223	0	0	\N
339385	1678	24480780388000	22423	11223	1	0	\N
339386	1874	20334000	22423	11223	2	0	\N
339387	1874	20335000	22423	11223	3	0	\N
339388	1874	20338000	22423	11223	4	0	\N
339389	1874	20340000	22423	11223	5	0	\N
339390	1874	20342000	22423	11223	6	0	\N
339408	1678	24480780391000	22429	11225	0	0	\N
339409	1874	20356000	22429	11225	1	0	\N
339410	1874	20358000	22429	11225	2	0	\N
339422	1678	24480780394000	22433	11228	0	0	\N
339423	1874	20371000	22433	11228	1	0	\N
339424	144	66769780000000	22433	11228	2	0	\N
339425	1874	20374000	22433	11228	3	0	\N
339426	1678	24480780394000	22434	11228	0	0	\N
339427	1874	20371000	22434	11228	1	0	\N
339428	144	66769780000000	22434	11228	2	0	\N
339429	1874	20374000	22434	11228	3	0	\N
339430	1678	24480780342000	22435	11176	0	0	\N
339431	1678	24480780343000	22435	11176	1	0	\N
339432	1678	24480780344000	22435	11176	2	0	\N
339433	1678	24480780345000	22435	11176	3	0	\N
339434	1678	24480780346000	22435	11176	4	0	\N
339435	1678	24480780347000	22435	11176	5	0	\N
339436	1678	24480780348000	22435	11176	6	0	\N
339437	1678	24480780349000	22435	11176	7	0	\N
339438	1678	24480780350000	22435	11176	8	0	\N
339439	1678	24480780351000	22435	11176	9	0	\N
339440	1678	24480780352000	22435	11176	10	0	\N
339441	1678	24480780353000	22435	11176	11	0	\N
339445	1101	906690767481065	22437	11147	0	0	\N
339446	1221	611762327909290	22437	11147	1	0	\N
339447	1347	1704730121592585	22437	11147	2	0	\N
339448	1678	23760768310000	22437	11147	3	0	\N
339449	1678	23760768311000	22437	11147	4	0	\N
339450	1678	23760768312000	22437	11147	5	0	\N
339451	1678	23760768313000	22437	11147	6	0	\N
339452	1678	23760768314000	22437	11147	7	0	\N
339453	1678	23760768315000	22437	11147	8	0	\N
339454	1678	23760768316000	22437	11147	9	0	\N
339455	1678	23760768317000	22437	11147	10	0	\N
339456	1678	23760768318000	22437	11147	11	0	\N
339329	1678	24480780382000	22412	11218	2	0	0
339330	1874	20298000	22412	11218	3	0	2
339331	1874	20300000	22412	11218	4	0	2
339332	1874	20302000	22412	11218	5	0	2
339333	1874	20304000	22412	11218	6	0	2
339335	1874	20310000	22412	11218	8	0	2
339336	1874	20313000	22412	11218	9	0	2
339337	1678	24480780383000	22413	11219	0	0	0
339338	1874	20315000	22413	11219	1	0	2
339339	1874	20318000	22413	11219	2	0	2
339341	1678	24480780384000	22414	11220	0	0	0
339342	1874	20322000	22414	11220	1	0	2
339343	1874	20324000	22414	11220	2	0	2
339349	1678	24480780385000	22417	11221	0	0	0
339351	1874	20329000	22417	11221	2	0	2
339370	1678	24480780386000	22420	11222	0	0	0
339371	1874	20331000	22420	11222	1	0	2
339391	1678	24480780387000	22424	11223	0	0	0
339392	1678	24480780388000	22424	11223	1	0	0
339394	1874	20335000	22424	11223	3	0	2
339395	1874	20338000	22424	11223	4	0	2
339396	1874	20340000	22424	11223	5	0	2
339397	1874	20342000	22424	11223	6	0	2
339398	1678	24480780389000	22426	11224	0	0	0
339400	1874	20343000	22426	11224	2	0	2
339401	1874	20345000	22426	11224	3	0	2
339402	1874	20347000	22426	11224	4	0	2
339403	1874	20350000	22426	11224	5	0	2
339405	1678	24480780391000	22428	11225	0	0	0
339406	1874	20356000	22428	11225	1	0	2
339407	1874	20358000	22428	11225	2	0	2
339411	1678	24480780392000	22430	11226	0	0	0
339412	1874	20361000	22430	11226	1	0	2
339414	1678	24480780393000	22431	11227	0	0	0
339415	1874	20366000	22431	11227	1	0	2
339416	1874	20367000	22431	11227	2	0	2
339417	1874	20369000	22431	11227	3	0	2
339418	1678	24480780394000	22432	11228	0	0	0
339420	144	66769780000000	22432	11228	2	0	0
339421	1874	20374000	22432	11228	3	0	2
339442	1678	24480780395000	22436	11229	0	0	0
339443	1874	20377000	22436	11229	1	0	2
339457	1678	23760768319000	22437	11147	12	0	\N
339458	1678	23760768320000	22437	11147	13	0	\N
339459	1678	23760768321000	22437	11147	14	0	\N
339460	1678	23760768322000	22437	11147	15	0	\N
339461	1678	23760768323000	22437	11147	16	0	\N
339462	1678	23760768324000	22437	11147	17	0	\N
339463	1678	23760768325000	22437	11147	18	0	\N
339464	1678	23760768326000	22437	11147	19	0	\N
339465	1678	23760768327000	22437	11147	20	0	\N
339466	1678	23760768328000	22437	11147	21	0	\N
339467	1678	23760768329000	22437	11147	22	0	\N
339468	1678	23760768330000	22437	11147	23	0	\N
339469	1678	23760768331000	22437	11147	24	0	\N
339470	1678	23760768332000	22437	11147	25	0	\N
339471	1678	23760768333000	22437	11147	26	0	\N
339472	1678	23760768334000	22437	11147	27	0	\N
339473	1678	23760768335000	22437	11147	28	0	\N
339474	1678	23760768336000	22437	11147	29	0	\N
339475	1678	23760768337000	22437	11147	30	0	\N
339476	1678	23760768338000	22437	11147	31	0	\N
339477	1678	23760768339000	22437	11147	32	0	\N
339478	1678	23760768340000	22437	11147	33	0	\N
339479	1678	23760768341000	22437	11147	34	0	\N
339480	1678	23760768342000	22437	11147	35	0	\N
339481	1678	23760768343000	22437	11147	36	0	\N
339482	1678	23760768344000	22437	11147	37	0	\N
339483	1678	23760768345000	22437	11147	38	0	\N
339484	1678	23760768346000	22437	11147	39	0	\N
339485	1678	23760768347000	22437	11147	40	0	\N
339486	1678	23760768348000	22437	11147	41	0	\N
339487	1678	23760768349000	22437	11147	42	0	\N
339488	1678	23760768350000	22437	11147	43	0	\N
339489	1678	23760768351000	22437	11147	44	0	\N
339490	1678	23760768352000	22437	11147	45	0	\N
339491	1678	23760768353000	22437	11147	46	0	\N
339492	1678	23760768354000	22437	11147	47	0	\N
339493	1678	23760768355000	22437	11147	48	0	\N
339494	1678	23760768356000	22437	11147	49	0	\N
339495	1678	23760768357000	22437	11147	50	0	\N
339496	1678	23760768358000	22437	11147	51	0	\N
339497	1678	23760768359000	22437	11147	52	0	\N
339498	1678	23760768360000	22437	11147	53	0	\N
339499	1678	23760768361000	22437	11147	54	0	\N
339500	1678	23760768362000	22437	11147	55	0	\N
339501	1678	23760768363000	22437	11147	56	0	\N
339502	1678	23760768364000	22437	11147	57	0	\N
339503	1678	23760768365000	22437	11147	58	0	\N
339504	1678	23760768366000	22437	11147	59	0	\N
339505	1678	23760768367000	22437	11147	60	0	\N
339506	1678	23760768368000	22437	11147	61	0	\N
339507	1678	23760768369000	22437	11147	62	0	\N
339508	1678	23760768370000	22437	11147	63	0	\N
339509	1678	23760768371000	22437	11147	64	0	\N
339510	1678	23760768372000	22437	11147	65	0	\N
339511	1678	23760768373000	22437	11147	66	0	\N
339512	1678	23760768374000	22437	11147	67	0	\N
339513	1678	23760768375000	22437	11147	68	0	\N
339514	1678	23760768376000	22437	11147	69	0	\N
339515	1678	23760768377000	22437	11147	70	0	\N
339516	1678	23760768378000	22437	11147	71	0	\N
339517	1678	23760768379000	22437	11147	72	0	\N
339518	1678	23760768380000	22437	11147	73	0	\N
339519	1678	23760768381000	22437	11147	74	0	\N
339520	1678	23760768382000	22437	11147	75	0	\N
339521	1678	23760768383000	22437	11147	76	0	\N
339522	1678	23760768384000	22437	11147	77	0	\N
339523	1678	23760768385000	22437	11147	78	0	\N
339524	1678	23760768386000	22437	11147	79	0	\N
339525	1678	23760768387000	22437	11147	80	0	\N
339526	1678	23760768388000	22437	11147	81	0	\N
339527	1678	23760768389000	22437	11147	82	0	\N
339528	1678	23760768390000	22437	11147	83	0	\N
339529	1678	23760768391000	22437	11147	84	0	\N
339530	1678	23760768392000	22437	11147	85	0	\N
339531	1678	23760768393000	22437	11147	86	0	\N
339532	1678	23760768394000	22437	11147	87	0	\N
339533	1678	23760768395000	22437	11147	88	0	\N
339534	2199	720338000000	22437	11147	89	0	\N
339535	1874	19938000	22437	11147	90	0	\N
339536	978	506862505000000	22437	11147	91	0	\N
339537	1874	19941000	22437	11147	92	0	\N
339538	2295	718699000000	22437	11147	94	0	\N
339539	1874	19944000	22437	11147	95	0	\N
339540	1874	19947000	22437	11147	96	0	\N
339541	1874	19950000	22437	11147	97	0	\N
339542	1874	19953000	22437	11147	98	0	\N
339543	1874	19956000	22437	11147	99	0	\N
339544	1874	19957000	22437	11147	100	0	\N
339545	1874	19958000	22437	11147	101	0	\N
339546	1874	19959000	22437	11147	102	0	\N
339547	1874	19962000	22437	11147	103	0	\N
339548	1874	19964000	22437	11147	104	0	\N
339549	1874	19966000	22437	11147	105	0	\N
339550	1874	19968000	22437	11147	106	0	\N
339551	1874	19970000	22437	11147	107	0	\N
339552	1098	908293245000000	22437	11147	108	0	\N
339553	1218	612843560000000	22437	11147	109	0	\N
339554	1344	1707743047751650	22437	11147	110	0	\N
339555	1874	19973000	22437	11147	111	0	\N
339556	1874	19976000	22437	11147	112	0	\N
339557	1874	19979000	22437	11147	113	0	\N
339558	1874	19982000	22437	11147	114	0	\N
339559	1874	19985000	22437	11147	115	0	\N
339560	1874	19988000	22437	11147	116	0	\N
339561	1874	19991000	22437	11147	117	0	\N
339562	1874	19994000	22437	11147	118	0	\N
339563	1874	19997000	22437	11147	119	0	\N
339564	1874	20000000	22437	11147	120	0	\N
339565	1874	20003000	22437	11147	121	0	\N
339566	1874	20006000	22437	11147	122	0	\N
339567	1874	20009000	22437	11147	123	0	\N
339568	1874	20012000	22437	11147	124	0	\N
339569	1874	20015000	22437	11147	125	0	\N
339570	1678	24480780396000	22438	11230	0	0	\N
339571	1678	24480780397000	22438	11230	1	0	\N
339572	100	66769780000000	22438	11230	2	0	\N
339573	1874	20380000	22438	11230	3	0	\N
339574	1874	20382000	22438	11230	4	0	\N
339575	1874	20384000	22438	11230	5	0	\N
339576	1874	20387000	22438	11230	6	0	\N
339577	1874	20390000	22438	11230	7	0	\N
339586	1678	24480780369000	22440	11209	0	0	\N
339587	1678	24480780370000	22440	11209	1	0	\N
339588	1678	24480780371000	22440	11209	2	0	\N
339589	1678	24480780372000	22440	11209	3	0	\N
339590	1678	24480780373000	22440	11209	4	0	\N
339591	1678	24480780374000	22440	11209	5	0	\N
339592	1678	24480780375000	22440	11209	6	0	\N
339580	100	66769780000000	22439	11230	2	0	0
339581	1874	20380000	22439	11230	3	0	2
339582	1874	20382000	22439	11230	4	0	2
339583	1874	20384000	22439	11230	5	0	2
339584	1874	20387000	22439	11230	6	0	2
339593	1678	24480780376000	22440	11209	7	0	\N
339594	1678	24480780377000	22440	11209	8	0	\N
339595	1678	24480780378000	22440	11209	9	0	\N
339596	1678	24480780379000	22440	11209	10	0	\N
339597	1678	24480780380000	22440	11209	11	0	\N
339598	1678	24480780381000	22440	11209	12	0	\N
339599	1678	24480780382000	22440	11209	13	0	\N
339600	1678	24480780383000	22440	11209	14	0	\N
339601	1678	24480780384000	22440	11209	15	0	\N
339602	1678	24480780385000	22440	11209	16	0	\N
339603	1678	24480780386000	22440	11209	17	0	\N
339604	1678	24480780387000	22440	11209	18	0	\N
339605	1678	24480780388000	22440	11209	19	0	\N
339606	1678	24480780389000	22440	11209	21	0	\N
339607	1678	24480780390000	22440	11209	22	0	\N
339608	1678	24480780391000	22440	11209	23	0	\N
339609	1678	24480780392000	22440	11209	24	0	\N
339610	1678	24480780393000	22440	11209	25	0	\N
339611	1678	24480780394000	22440	11209	26	0	\N
339612	1678	24480780395000	22440	11209	27	0	\N
339613	1678	24480780396000	22440	11209	28	0	\N
339614	1678	24480780397000	22440	11209	29	0	\N
339615	1874	20243000	22440	11209	30	0	\N
339616	1874	20246000	22440	11209	31	0	\N
339617	1874	20249000	22440	11209	32	0	\N
339618	1874	20251000	22440	11209	33	0	\N
339619	1874	20253000	22440	11209	34	0	\N
339620	1874	20255000	22440	11209	35	0	\N
339621	1874	20257000	22440	11209	36	0	\N
339622	1874	20259000	22440	11209	37	0	\N
339623	1874	20261000	22440	11209	38	0	\N
339624	1874	20263000	22440	11209	39	0	\N
339625	1874	20265000	22440	11209	40	0	\N
339626	1874	20267000	22440	11209	41	0	\N
339627	1874	20269000	22440	11209	42	0	\N
339628	1874	20271000	22440	11209	43	0	\N
339629	1874	20274000	22440	11209	44	0	\N
339630	1874	20277000	22440	11209	45	0	\N
339631	1874	20280000	22440	11209	46	0	\N
339632	1874	20283000	22440	11209	47	0	\N
339633	1874	20285000	22440	11209	48	0	\N
339634	1874	20287000	22440	11209	49	0	\N
339635	1874	20289000	22440	11209	50	0	\N
339636	1874	20291000	22440	11209	51	0	\N
339637	1874	20293000	22440	11209	52	0	\N
339638	1874	20295000	22440	11209	53	0	\N
339639	1874	20297000	22440	11209	54	0	\N
339640	1874	20298000	22440	11209	55	0	\N
339641	1874	20299000	22440	11209	56	0	\N
339642	1874	20300000	22440	11209	57	0	\N
339643	1874	20301000	22440	11209	58	0	\N
339644	1874	20302000	22440	11209	59	0	\N
339645	1874	20303000	22440	11209	60	0	\N
339646	1874	20304000	22440	11209	61	0	\N
339647	1874	20305000	22440	11209	62	0	\N
339648	144	66769780000000	22440	11209	63	0	\N
339649	100	66769780000000	22440	11209	64	0	\N
339650	1874	20307000	22440	11209	65	0	\N
339651	1874	20309000	22440	11209	66	0	\N
339652	1874	20311000	22440	11209	67	0	\N
339653	1874	20313000	22440	11209	68	0	\N
339654	1874	20315000	22440	11209	69	0	\N
339655	1874	20317000	22440	11209	70	0	\N
339656	1874	20319000	22440	11209	71	0	\N
339657	1874	20321000	22440	11209	72	0	\N
339658	1874	20323000	22440	11209	73	0	\N
339659	1874	20325000	22440	11209	74	0	\N
339660	1874	20327000	22440	11209	75	0	\N
339661	1874	20330000	22440	11209	76	0	\N
339662	1874	20333000	22440	11209	77	0	\N
339663	1874	20336000	22440	11209	78	0	\N
339664	1874	20339000	22440	11209	79	0	\N
339665	1874	20342000	22440	11209	80	0	\N
339666	1874	20345000	22440	11209	81	0	\N
339667	1874	20348000	22440	11209	82	0	\N
339668	1874	20351000	22440	11209	83	0	\N
339669	1874	20354000	22440	11209	84	0	\N
339670	1874	20357000	22440	11209	85	0	\N
339671	1874	20360000	22440	11209	86	0	\N
339672	1874	20363000	22440	11209	87	0	\N
339673	1874	20366000	22440	11209	88	0	\N
339674	1874	20369000	22440	11209	89	0	\N
339675	1874	20372000	22440	11209	90	0	\N
339676	1874	20375000	22440	11209	91	0	\N
339677	1874	20378000	22440	11209	92	0	\N
339678	1874	20381000	22440	11209	93	0	\N
339679	1874	20384000	22440	11209	94	0	\N
339680	1874	20387000	22440	11209	95	0	\N
339681	1874	20390000	22440	11209	96	0	\N
339682	1678	24480780398000	22441	11231	0	0	\N
339683	1874	20393000	22441	11231	1	0	\N
339684	1678	24480780398000	22442	11231	0	0	\N
339685	1874	20393000	22442	11231	1	0	\N
339686	1874	20395000	22442	11231	2	0	\N
339690	1678	24480780399000	22444	11232	0	0	\N
339691	1874	20398000	22444	11232	1	0	\N
339692	1874	20400000	22444	11232	2	0	\N
339700	1678	24480780400000	22447	11233	0	0	\N
339701	1874	20403000	22447	11233	1	0	\N
339702	1874	20404000	22447	11233	2	0	\N
339703	1874	20406000	22447	11233	3	0	\N
339707	1678	24480780401000	22449	11234	0	0	\N
339708	1874	20409000	22449	11234	1	0	\N
339709	1874	20411000	22449	11234	2	0	\N
339710	1678	24480780401000	22450	11234	0	0	\N
339711	1874	20409000	22450	11234	1	0	\N
339712	1874	20411000	22450	11234	2	0	\N
339719	1678	24480780404000	22452	11236	0	0	\N
339720	1874	20421000	22452	11236	1	0	\N
339721	1874	20424000	22452	11236	2	0	\N
339722	1678	24480780404000	22453	11236	0	0	\N
339723	1874	20421000	22453	11236	1	0	\N
339724	1874	20424000	22453	11236	2	0	\N
339689	1874	20395000	22443	11231	2	0	2
339693	1678	24480780399000	22445	11232	0	0	0
339694	1874	20398000	22445	11232	1	0	2
339695	1874	20400000	22445	11232	2	0	2
339696	1678	24480780400000	22446	11233	0	0	0
339698	1874	20404000	22446	11233	2	0	2
339699	1874	20406000	22446	11233	3	0	2
339704	1678	24480780401000	22448	11234	0	0	0
339705	1874	20409000	22448	11234	1	0	2
339706	1874	20411000	22448	11234	2	0	2
339714	1678	24480780403000	22451	11235	1	0	0
339715	1874	20414000	22451	11235	2	0	2
339716	1874	20416000	22451	11235	3	0	2
339717	1874	20418000	22451	11235	4	0	2
339725	1678	24480780404000	22454	11236	0	0	0
339726	1874	20422000	22454	11236	1	0	2
339727	1678	24480780405000	22455	11237	0	0	0
339728	1874	20424000	22455	11237	1	0	2
339731	1678	24480780405000	22456	11237	0	0	\N
339732	1874	20424000	22456	11237	1	0	\N
339733	1874	20426000	22456	11237	2	0	\N
339734	1874	20429000	22456	11237	3	0	\N
339735	1678	24480780405000	22457	11237	0	0	\N
339736	1874	20424000	22457	11237	1	0	\N
339737	1874	20426000	22457	11237	2	0	\N
339738	1874	20429000	22457	11237	3	0	\N
339739	1678	24480780406000	22458	11238	0	0	\N
339740	1874	20431000	22458	11238	1	0	\N
339741	1874	20434000	22458	11238	2	0	\N
339745	1678	24480780407000	22460	11239	0	0	\N
339746	1874	20437000	22460	11239	1	0	\N
339747	1874	20438000	22460	11239	2	0	\N
339758	1678	24480780409000	22464	11241	0	0	\N
339759	1874	20448000	22464	11241	1	0	\N
339760	1874	20450000	22464	11241	2	0	\N
339765	1678	24480780410000	22466	11242	0	0	\N
339766	1874	20452000	22466	11242	1	0	\N
339767	1874	20453000	22466	11242	2	0	\N
339768	1874	20456000	22466	11242	3	0	\N
339769	981	505968249228270	22467	11093	0	0	\N
339770	1678	23760768299000	22467	11093	1	0	\N
339771	1678	23760768300000	22467	11093	2	0	\N
339772	1678	23760768301000	22467	11093	3	0	\N
339773	1678	23760768302000	22467	11093	4	0	\N
339774	1678	23760768303000	22467	11093	5	0	\N
339775	1678	23760768304000	22467	11093	6	0	\N
339776	1678	23760768305000	22467	11093	7	0	\N
339777	1678	23760768306000	22467	11093	8	0	\N
339778	1678	23760768307000	22467	11093	9	0	\N
339779	1678	23760768308000	22467	11093	10	0	\N
339780	1101	906690767481065	22467	11093	11	0	\N
339781	1678	23760768309000	22467	11093	12	0	\N
339782	1221	611762327909290	22467	11093	13	0	\N
339783	1347	1704730121592585	22467	11093	14	0	\N
339784	1678	23760768310000	22467	11093	15	0	\N
339785	1678	23760768311000	22467	11093	16	0	\N
339786	1678	23760768312000	22467	11093	17	0	\N
339787	1678	23760768313000	22467	11093	18	0	\N
339788	1678	23760768314000	22467	11093	19	0	\N
339789	1678	23760768315000	22467	11093	20	0	\N
339790	1678	23760768316000	22467	11093	21	0	\N
339791	1678	23760768317000	22467	11093	22	0	\N
339792	1678	23760768318000	22467	11093	23	0	\N
339793	1678	23760768319000	22467	11093	24	0	\N
339794	1678	23760768320000	22467	11093	25	0	\N
339795	1678	23760768321000	22467	11093	26	0	\N
339796	1678	23760768322000	22467	11093	27	0	\N
339797	1678	23760768323000	22467	11093	28	0	\N
339798	1678	23760768324000	22467	11093	29	0	\N
339799	1678	23760768325000	22467	11093	30	0	\N
339800	1678	23760768326000	22467	11093	31	0	\N
339801	1678	23760768327000	22467	11093	32	0	\N
339802	1678	23760768328000	22467	11093	33	0	\N
339803	1678	23760768329000	22467	11093	34	0	\N
339804	1678	23760768330000	22467	11093	35	0	\N
339805	1678	23760768331000	22467	11093	36	0	\N
339806	1678	23760768332000	22467	11093	37	0	\N
339807	1678	23760768333000	22467	11093	38	0	\N
339808	1678	23760768334000	22467	11093	39	0	\N
339809	1678	23760768335000	22467	11093	40	0	\N
339810	1678	23760768336000	22467	11093	41	0	\N
339811	1678	23760768337000	22467	11093	42	0	\N
339812	1678	23760768338000	22467	11093	43	0	\N
339813	1678	23760768339000	22467	11093	44	0	\N
339814	1678	23760768340000	22467	11093	45	0	\N
339815	1678	23760768341000	22467	11093	46	0	\N
339816	1678	23760768342000	22467	11093	47	0	\N
339817	1678	23760768343000	22467	11093	48	0	\N
339818	1678	23760768344000	22467	11093	49	0	\N
339819	1678	23760768345000	22467	11093	50	0	\N
339820	1678	23760768346000	22467	11093	51	0	\N
339821	1678	23760768347000	22467	11093	52	0	\N
339822	1678	23760768348000	22467	11093	53	0	\N
339823	1678	23760768349000	22467	11093	54	0	\N
339824	1678	23760768350000	22467	11093	55	0	\N
339825	1678	23760768351000	22467	11093	56	0	\N
339826	1678	23760768352000	22467	11093	57	0	\N
339827	1678	23760768353000	22467	11093	58	0	\N
339828	1678	23760768354000	22467	11093	59	0	\N
339829	1678	23760768355000	22467	11093	60	0	\N
339830	1678	23760768356000	22467	11093	61	0	\N
339831	1678	23760768357000	22467	11093	62	0	\N
339832	1678	23760768358000	22467	11093	64	0	\N
339833	1678	23760768359000	22467	11093	65	0	\N
339834	1678	23760768360000	22467	11093	66	0	\N
339835	1678	23760768361000	22467	11093	67	0	\N
339836	1678	23760768362000	22467	11093	68	0	\N
339837	1678	23760768363000	22467	11093	69	0	\N
339838	1678	23760768364000	22467	11093	70	0	\N
339839	1678	23760768365000	22467	11093	71	0	\N
339840	1678	23760768366000	22467	11093	72	0	\N
339841	1678	23760768367000	22467	11093	73	0	\N
339842	1678	23760768368000	22467	11093	74	0	\N
339843	1678	23760768369000	22467	11093	75	0	\N
339844	1678	23760768370000	22467	11093	76	0	\N
339845	1678	23760768371000	22467	11093	77	0	\N
339846	1678	23760768372000	22467	11093	78	0	\N
339847	1678	23760768373000	22467	11093	79	0	\N
339848	1678	23760768374000	22467	11093	80	0	\N
339849	1678	23760768375000	22467	11093	81	0	\N
339850	1678	23760768376000	22467	11093	82	0	\N
339851	1678	23760768377000	22467	11093	83	0	\N
339852	1678	23760768378000	22467	11093	84	0	\N
339853	1678	23760768379000	22467	11093	85	0	\N
339854	1678	23760768380000	22467	11093	86	0	\N
339855	1678	23760768381000	22467	11093	87	0	\N
339856	1678	23760768382000	22467	11093	88	0	\N
339857	1678	23760768383000	22467	11093	89	0	\N
339858	1678	23760768384000	22467	11093	90	0	\N
339859	1678	23760768385000	22467	11093	91	0	\N
339860	1678	23760768386000	22467	11093	92	0	\N
339861	1678	23760768387000	22467	11093	93	0	\N
339862	1678	23760768388000	22467	11093	94	0	\N
339863	1678	23760768389000	22467	11093	95	0	\N
339864	1678	23760768390000	22467	11093	96	0	\N
339742	1678	24480780406000	22459	11238	0	0	0
339743	1874	20431000	22459	11238	1	0	2
339744	1874	20434000	22459	11238	2	0	2
339748	1678	24480780407000	22461	11239	0	0	0
339749	1874	20436000	22461	11239	1	0	2
339751	1874	20440000	22461	11239	3	0	2
339752	1678	24480780408000	22462	11240	0	0	0
339753	1874	20442000	22462	11240	1	0	2
339754	1874	20445000	22462	11240	2	0	2
339755	1678	24480780409000	22463	11241	0	0	0
339757	1874	20450000	22463	11241	2	0	2
339761	1678	24480780410000	22465	11242	0	0	0
339762	1874	20452000	22465	11242	1	0	2
339763	1874	20453000	22465	11242	2	0	2
339865	1678	23760768391000	22467	11093	97	0	\N
339866	1678	23760768392000	22467	11093	98	0	\N
339867	1678	23760768393000	22467	11093	99	0	\N
339868	1678	23760768394000	22467	11093	100	0	\N
339869	1678	23760768395000	22467	11093	101	0	\N
339870	1678	23760768396000	22467	11093	102	0	\N
339871	1678	23760768397000	22467	11093	103	0	\N
339872	1678	23760768398000	22467	11093	104	0	\N
339873	1678	23760768399000	22467	11093	105	0	\N
339874	1678	23760768400000	22467	11093	106	0	\N
339875	1678	23760768401000	22467	11093	107	0	\N
339876	1678	23760768402000	22467	11093	108	0	\N
339877	1678	23760768403000	22467	11093	109	0	\N
339878	1678	23760768404000	22467	11093	110	0	\N
339879	1678	23760768405000	22467	11093	111	0	\N
339880	1678	23760768406000	22467	11093	112	0	\N
339881	1678	23760768407000	22467	11093	113	0	\N
339882	1678	23760768408000	22467	11093	114	0	\N
339883	1678	23760768409000	22467	11093	115	0	\N
339884	1678	23760768410000	22467	11093	116	0	\N
339885	2199	720338000000	22467	11093	117	0	\N
339886	978	506862505000000	22467	11093	118	0	\N
339887	1874	19411000	22467	11093	119	0	\N
339888	1874	19412000	22467	11093	120	0	\N
339889	1874	19413000	22467	11093	121	0	\N
339890	1874	19414000	22467	11093	122	0	\N
339891	1874	19415000	22467	11093	123	0	\N
339892	1874	19416000	22467	11093	124	0	\N
339893	1098	908293245000000	22467	11093	125	0	\N
339894	1678	24480780411000	22468	11243	0	0	\N
339895	1874	20459000	22468	11243	1	0	\N
339896	1678	24480780411000	22469	11243	0	0	\N
339897	1874	20459000	22469	11243	1	0	\N
339898	1874	20461000	22469	11243	2	0	\N
339909	1678	24480780412000	22472	11244	0	0	\N
339910	1678	24480780413000	22472	11244	1	0	\N
339911	1874	20462000	22472	11244	2	0	\N
339912	1874	20464000	22472	11244	3	0	\N
339913	1874	20466000	22472	11244	4	0	\N
339914	1874	20469000	22472	11244	5	0	\N
339915	1874	20472000	22472	11244	6	0	\N
339935	1678	24480780418000	22476	11246	0	0	\N
339936	2181	700610585574	22476	11246	1	0	\N
339937	438	66702358779471	22476	11246	2	0	\N
339938	262	66046804815506	22476	11246	3	0	\N
339939	1874	20496000	22476	11246	4	0	\N
339940	1874	20498000	22476	11246	5	0	\N
339941	1678	24480780419000	22477	11247	0	0	\N
339942	240	66047839524375	22477	11247	1	0	\N
339943	304	66702358779471	22477	11247	2	0	\N
339944	562	66046828809135	22477	11247	3	0	\N
339945	560	66702358779471	22477	11247	4	0	\N
339946	441	66046748752480	22477	11247	5	0	\N
339947	1772	5023827484556	22477	11247	6	0	\N
339948	1874	20501000	22477	11247	7	0	\N
339949	1678	24480780419000	22478	11247	0	0	\N
339950	240	66047839524375	22478	11247	1	0	\N
339951	304	66702358779471	22478	11247	2	0	\N
339952	562	66046828809135	22478	11247	3	0	\N
339953	560	66702358779471	22478	11247	4	0	\N
339954	441	66046748752480	22478	11247	5	0	\N
339955	1772	5023827484556	22478	11247	6	0	\N
339956	1874	20500000	22478	11247	7	0	\N
339957	1874	20503000	22478	11247	8	0	\N
339975	1678	24480780420000	22481	11248	0	0	\N
339976	653	66702358779471	22481	11248	1	0	\N
339977	373	66702358779471	22481	11248	2	0	\N
339978	92	66702358779471	22481	11248	3	0	\N
339979	710	5053208998381	22481	11248	4	0	\N
339980	1961	701270954698	22481	11248	5	0	\N
339981	1874	20505000	22481	11248	6	0	\N
339982	1874	20506000	22481	11248	7	0	\N
339901	1874	20461000	22470	11243	2	0	2
339902	1678	24480780412000	22471	11244	0	0	0
339903	1678	24480780413000	22471	11244	1	0	0
339904	1874	20462000	22471	11244	2	0	2
339905	1874	20464000	22471	11244	3	0	2
339907	1874	20469000	22471	11244	5	0	2
339908	1874	20472000	22471	11244	6	0	2
339916	1678	24480780414000	22474	11245	0	0	0
339917	1678	24480780415000	22474	11245	1	0	0
339918	1678	24480780416000	22474	11245	2	0	0
339920	1874	20475000	22474	11245	4	0	2
339921	1874	20476000	22474	11245	5	0	2
339922	1874	20478000	22474	11245	6	0	2
339923	1874	20481000	22474	11245	7	0	2
339925	1874	20487000	22474	11245	9	0	2
339926	1874	20489000	22474	11245	10	0	2
339927	1874	20491000	22474	11245	11	0	2
339928	1874	20493000	22474	11245	12	0	2
339929	1678	24480780418000	22475	11246	0	0	0
339931	438	66702358779471	22475	11246	2	0	0
339932	262	66046804815506	22475	11246	3	0	4
339933	1874	20496000	22475	11246	4	0	2
339934	1874	20498000	22475	11246	5	0	2
339958	1678	24480780419000	22479	11247	0	0	0
339960	304	66702358779471	22479	11247	2	0	0
339961	562	66046828809135	22479	11247	3	0	1
339962	560	66702358779471	22479	11247	4	0	0
339963	441	66046748752480	22479	11247	5	0	1
339965	1874	20500000	22479	11247	7	0	2
339966	1874	20503000	22479	11247	8	0	2
339967	1678	24480780420000	22480	11248	0	0	0
339968	653	66702358779471	22480	11248	1	0	0
339969	373	66702358779471	22480	11248	2	0	0
339971	710	5053208998381	22480	11248	4	0	0
339972	1961	701270954698	22480	11248	5	0	1
339973	1874	20505000	22480	11248	6	0	2
339974	1874	20506000	22480	11248	7	0	2
339983	660	66702358779471	22482	11249	0	0	0
339985	394	66046828809135	22482	11249	2	0	1
339986	1678	24480780421000	22482	11249	3	0	0
339987	29	7074492597754	22482	11249	4	0	0
339988	251	66702358779471	22482	11249	5	0	0
339990	89	66702358779471	22482	11249	7	0	0
339991	1811	1918419402059	22482	11249	8	0	1
339992	84	66702358779471	22482	11249	9	0	0
339993	390	66702358779471	22482	11249	10	0	0
339994	910	508128148220237	22482	11249	11	0	0
339996	1678	24480780422000	22482	11249	14	0	0
339997	1874	20508000	22482	11249	15	0	2
339998	1874	20510000	22482	11249	16	0	2
339999	1874	20513000	22482	11249	17	0	2
340000	1874	20516000	22482	11249	18	0	2
340001	1678	24480780423000	22484	11250	0	0	\N
340002	150	66702358779471	22484	11250	1	0	\N
340003	154	66046828809135	22484	11250	2	0	\N
340004	593	66701357779471	22484	11250	3	0	\N
340005	180	66702358779471	22484	11250	4	0	\N
340006	711	3004516180928	22484	11250	5	0	\N
340007	245	66702358779471	22484	11250	6	0	\N
340008	1874	20519000	22484	11250	7	0	\N
340009	1874	20520000	22484	11250	8	0	\N
340038	1678	24480780424000	22487	11251	0	0	\N
340039	1962	701270954698	22487	11251	1	0	\N
340040	63	66702358779471	22487	11251	2	0	\N
340041	1150	614373845207994	22487	11251	3	0	\N
340042	163	66702358779471	22487	11251	4	0	\N
340043	1678	24480780425000	22487	11251	5	0	\N
340044	78	66702358779471	22487	11251	6	0	\N
340045	678	66702358779471	22487	11251	7	0	\N
340046	108	66702358779471	22487	11251	8	0	\N
340047	745	2021283599286	22487	11251	9	0	\N
340048	600	66702358779471	22487	11251	10	0	\N
340049	112	66088313832720	22487	11251	11	0	\N
340050	103	66702358779471	22487	11251	12	0	\N
340051	383	66702358779471	22487	11251	13	0	\N
340052	1874	20525000	22487	11251	14	0	\N
340053	1874	20528000	22487	11251	15	0	\N
340054	1874	20530000	22487	11251	16	0	\N
340055	1874	20532000	22487	11251	17	0	\N
340065	1678	24480780427000	22489	11253	0	0	\N
340066	1678	24480780428000	22489	11253	1	0	\N
340067	2073	700533689541	22489	11253	2	0	\N
340068	1874	20539000	22489	11253	3	0	\N
340069	1874	20540000	22489	11253	4	0	\N
340070	1874	20542000	22489	11253	5	0	\N
340071	1874	20545000	22489	11253	6	0	\N
340072	1874	20548000	22489	11253	7	0	\N
340073	1678	24480780427000	22490	11253	0	0	\N
340074	1678	24480780428000	22490	11253	1	0	\N
340075	2073	700533689541	22490	11253	2	0	\N
340076	1874	20538000	22490	11253	3	0	\N
340077	1874	20541000	22490	11253	4	0	\N
340078	1874	20544000	22490	11253	5	0	\N
340079	1678	24480780427000	22491	11253	0	0	\N
340080	1678	24480780428000	22491	11253	1	0	\N
340081	2073	700533689541	22491	11253	2	0	\N
340082	1874	20539000	22491	11253	3	0	\N
340083	1874	20540000	22491	11253	4	0	\N
340084	1874	20542000	22491	11253	5	0	\N
340085	1874	20545000	22491	11253	6	0	\N
340086	1874	20548000	22491	11253	7	0	\N
340087	1678	24480780427000	22492	11253	0	0	\N
340088	1678	24480780428000	22492	11253	1	0	\N
340089	2073	700533689541	22492	11253	2	0	\N
340090	1874	20539000	22492	11253	3	0	\N
340091	1874	20540000	22492	11253	4	0	\N
340092	1874	20542000	22492	11253	5	0	\N
340093	1874	20545000	22492	11253	6	0	\N
340094	1874	20548000	22492	11253	7	0	\N
340095	1678	24480780427000	22493	11253	0	0	\N
340096	1678	24480780428000	22493	11253	1	0	\N
340097	2073	700533689541	22493	11253	2	0	\N
340098	1874	20539000	22493	11253	3	0	\N
340099	1874	20540000	22493	11253	4	0	\N
340100	1874	20542000	22493	11253	5	0	\N
340101	1874	20545000	22493	11253	6	0	\N
340102	1874	20548000	22493	11253	7	0	\N
340111	1678	24480780429000	22495	11254	0	0	\N
340112	237	66046828809135	22495	11254	1	0	\N
340113	1874	20550000	22495	11254	2	0	\N
340114	1874	20553000	22495	11254	3	0	\N
340118	1678	24480780429000	22497	11254	0	0	\N
340119	237	66046828809135	22497	11254	1	0	\N
340120	1874	20550000	22497	11254	2	0	\N
340121	1874	20553000	22497	11254	3	0	\N
340122	1874	20546000	22498	11254	0	0	\N
340123	1874	20548000	22498	11254	1	0	\N
340124	1874	20550000	22498	11254	2	0	\N
340012	154	66046828809135	22485	11250	2	0	1
340013	593	66701357779471	22485	11250	3	0	1
340014	180	66702358779471	22485	11250	4	0	0
340015	711	3004516180928	22485	11250	5	0	1
340016	245	66702358779471	22485	11250	6	0	0
340018	1874	20521000	22485	11250	8	0	2
340019	1874	20522000	22485	11250	9	0	2
340020	1678	24480780424000	22486	11251	0	0	0
340021	1962	701270954698	22486	11251	1	0	1
340022	63	66702358779471	22486	11251	2	0	0
340024	163	66702358779471	22486	11251	4	0	0
340025	1678	24480780425000	22486	11251	5	0	0
340026	78	66702358779471	22486	11251	6	0	0
340027	678	66702358779471	22486	11251	7	0	0
340029	745	2021283599286	22486	11251	9	0	0
340030	600	66702358779471	22486	11251	10	0	0
340031	112	66088313832720	22486	11251	11	0	7
340032	103	66702358779471	22486	11251	12	0	0
340033	383	66702358779471	22486	11251	13	0	0
340035	1874	20528000	22486	11251	15	0	2
340036	1874	20530000	22486	11251	16	0	2
340037	1874	20532000	22486	11251	17	0	2
340056	1678	24480780426000	22488	11252	0	0	0
340057	453	66702358779471	22488	11252	1	0	0
340059	308	66702358779471	22488	11252	3	0	0
340060	201	66702358779471	22488	11252	4	0	0
340061	748	2723708018119	22488	11252	5	0	1
340062	35	19404322553971	22488	11252	6	0	0
340064	1874	20537000	22488	11252	8	0	2
340103	1678	24480780427000	22494	11253	0	0	0
340104	1678	24480780428000	22494	11253	1	0	0
340105	2073	700533689541	22494	11253	2	0	1
340106	1874	20539000	22494	11253	3	0	2
340108	1874	20542000	22494	11253	5	0	2
340109	1874	20545000	22494	11253	6	0	2
340110	1874	20548000	22494	11253	7	0	2
340115	1678	24480780429000	22496	11254	0	0	0
340116	237	66046828809135	22496	11254	1	0	1
340125	225	66702358779471	22499	11255	0	0	0
340126	1678	24480780430000	22499	11255	1	0	0
340127	1678	24480780431000	22499	11255	2	0	0
340128	1678	24480780432000	22499	11255	3	0	0
340130	99	66702358779471	22499	11255	5	0	0
340131	206	66702358779471	22499	11255	6	0	0
340132	122	66702358779471	22499	11255	7	0	0
340133	443	66047127020166	22499	11255	8	0	3
340134	691	66702358779471	22499	11255	9	0	0
340136	49	66702358779471	22499	11255	11	0	0
340162	1678	24480780433000	22502	11256	0	0	\N
340163	322	66702358779471	22502	11256	1	0	\N
340164	252	66702358779471	22502	11256	2	0	\N
340165	636	66046738745395	22502	11256	3	0	\N
340166	1778	5451506401776	22502	11256	4	0	\N
340167	146	66702358779471	22502	11256	5	0	\N
340168	114	66049473685762	22502	11256	6	0	\N
340169	1874	20568000	22502	11256	7	0	\N
340170	1874	20571000	22502	11256	8	0	\N
340188	1678	24480780434000	22505	11257	0	0	\N
340189	1678	24480780435000	22505	11257	1	0	\N
340190	587	66702358779471	22505	11257	2	0	\N
340191	238	66046924858702	22505	11257	3	0	\N
340192	392	66702358779471	22505	11257	4	0	\N
340193	578	66046828809135	22505	11257	5	0	\N
340194	408	66702358779471	22505	11257	6	0	\N
340195	504	66089288779471	22505	11257	7	0	\N
340196	611	66702358779471	22505	11257	8	0	\N
340197	500	66702358779471	22505	11257	9	0	\N
340198	353	66004148160270	22505	11257	10	0	\N
340199	301	66057220092394	22505	11257	11	0	\N
340200	601	66702358779471	22505	11257	12	0	\N
340201	1276	1712007346748474	22505	11257	13	0	\N
340202	1874	20572000	22505	11257	14	0	\N
340203	1874	20574000	22505	11257	15	0	\N
340204	1874	20577000	22505	11257	16	0	\N
340205	1874	20579000	22505	11257	17	0	\N
340206	1874	20582000	22505	11257	18	0	\N
340208	450	66702358779471	22507	11258	0	0	\N
340209	1678	24480780436000	22507	11258	2	0	\N
340210	10	32582047065816	22507	11258	3	0	\N
340211	421	66702358779471	22507	11258	4	0	\N
340212	620	66702358779471	22507	11258	5	0	\N
340213	594	66702358779471	22507	11258	6	0	\N
340214	622	66658400277049	22507	11258	7	0	\N
340215	1874	20581000	22507	11258	8	0	\N
340216	1874	20583000	22507	11258	9	0	\N
340217	1874	20585000	22507	11258	10	0	\N
340218	1874	20587000	22507	11258	11	0	\N
340239	1678	24480780436000	22509	11259	0	0	\N
340240	1678	24480780437000	22509	11259	1	0	\N
340241	10	32582047065816	22509	11259	2	0	\N
340242	421	66702358779471	22509	11259	3	0	\N
340243	620	66702358779471	22509	11259	4	0	\N
340244	594	66702358779471	22509	11259	5	0	\N
340245	622	66658400277049	22509	11259	6	0	\N
340246	2017	700958113870	22509	11259	7	0	\N
340247	520	66702358779471	22509	11259	8	0	\N
340248	452	66702358779471	22509	11259	9	0	\N
340249	652	66702358779471	22509	11259	10	0	\N
340250	354	66049130437906	22509	11259	11	0	\N
340251	569	66702358779471	22509	11259	12	0	\N
340252	1874	20581000	22509	11259	13	0	\N
340253	1874	20583000	22509	11259	14	0	\N
340254	1874	20586000	22509	11259	15	0	\N
340255	1874	20587000	22509	11259	16	0	\N
340256	1874	20589000	22509	11259	17	0	\N
340257	1874	20591000	22509	11259	18	0	\N
340258	1874	20593000	22509	11259	19	0	\N
340263	1678	24480780438000	22511	11260	0	0	\N
340264	352	66702358779471	22511	11260	1	0	\N
340265	1874	20596000	22511	11260	2	0	\N
340266	1874	20598000	22511	11260	3	0	\N
340270	1678	24480780440000	22514	11262	0	0	\N
340271	1874	20604000	22514	11262	1	0	\N
340272	1874	20606000	22514	11262	2	0	\N
340139	54	66702358779471	22499	11255	14	0	0
340140	217	66702358779471	22499	11255	15	0	0
340141	603	66768259337864	22499	11255	16	0	1
340142	165	66046828809135	22499	11255	17	0	1
340143	194	66702358779471	22499	11255	18	0	0
340145	105	66702358779471	22499	11255	20	0	0
340146	1874	20554000	22499	11255	21	0	2
340147	1874	20557000	22499	11255	22	0	2
340148	1874	20559000	22499	11255	23	0	2
340149	1874	20561000	22499	11255	24	0	2
340151	1874	20565000	22499	11255	26	0	2
340152	1874	20566000	22499	11255	27	0	2
340153	1678	24480780433000	22501	11256	0	0	0
340154	322	66702358779471	22501	11256	1	0	0
340156	636	66046738745395	22501	11256	3	0	1
340157	1778	5451506401776	22501	11256	4	0	1
340158	146	66702358779471	22501	11256	5	0	0
340159	114	66049473685762	22501	11256	6	0	8
340160	1874	20568000	22501	11256	7	0	2
340171	1678	24480780434000	22504	11257	0	0	0
340172	1678	24480780435000	22504	11257	1	0	0
340173	587	66702358779471	22504	11257	2	0	0
340174	238	66046924858702	22504	11257	3	0	4
340175	392	66702358779471	22504	11257	4	0	0
340177	408	66702358779471	22504	11257	6	0	0
340178	504	66089288779471	22504	11257	7	0	3
340179	611	66702358779471	22504	11257	8	0	0
340180	500	66702358779471	22504	11257	9	0	0
340182	301	66057220092394	22504	11257	11	0	2
340183	601	66702358779471	22504	11257	12	0	0
340184	1276	1712007346748474	22504	11257	13	0	0
340185	1874	20572000	22504	11257	14	0	2
340186	1874	20575000	22504	11257	15	0	2
340207	450	66702358779471	22506	11258	0	0	0
340219	1678	24480780436000	22508	11259	0	0	0
340220	1678	24480780437000	22508	11259	1	0	0
340221	10	32582047065816	22508	11259	2	0	1
340222	421	66702358779471	22508	11259	3	0	0
340224	594	66702358779471	22508	11259	5	0	0
340225	622	66658400277049	22508	11259	6	0	1
340226	2017	700958113870	22508	11259	7	0	2
340227	520	66702358779471	22508	11259	8	0	0
340229	652	66702358779471	22508	11259	10	0	0
340230	354	66049130437906	22508	11259	11	0	1
340231	569	66702358779471	22508	11259	12	0	0
340232	1874	20581000	22508	11259	13	0	2
340233	1874	20583000	22508	11259	14	0	2
340235	1874	20587000	22508	11259	16	0	2
340236	1874	20589000	22508	11259	17	0	2
340237	1874	20591000	22508	11259	18	0	2
340238	1874	20593000	22508	11259	19	0	2
340259	1678	24480780438000	22510	11260	0	0	0
340261	1874	20596000	22510	11260	2	0	2
340262	1874	20598000	22510	11260	3	0	2
340267	1678	24480780439000	22512	11261	0	0	0
340268	1874	20601000	22512	11261	1	0	2
340273	1874	20609000	22514	11262	3	0	\N
340278	1678	24480780440000	22516	11262	0	0	\N
340279	1874	20604000	22516	11262	1	0	\N
340280	1874	20606000	22516	11262	2	0	\N
340281	1874	20609000	22516	11262	3	0	\N
340297	1678	24480780443000	22519	11265	0	0	\N
340298	499	66702358779471	22519	11265	1	0	\N
340299	391	66701248779471	22519	11265	2	0	\N
340300	186	66702358779471	22519	11265	3	0	\N
340301	458	66049130437906	22519	11265	4	0	\N
340302	327	66046738745395	22519	11265	5	0	\N
340303	894	310088064614009	22519	11265	6	0	\N
340304	1874	20618000	22519	11265	7	0	\N
340305	1874	20621000	22519	11265	8	0	\N
340328	1678	24480780444000	22522	11266	0	0	\N
340329	921	507426751732622	22522	11266	1	0	\N
340330	1041	909304391472409	22522	11266	2	0	\N
340331	1161	613525792096394	22522	11266	3	0	\N
340332	1287	1709644171348441	22522	11266	4	0	\N
340333	570	66702358779471	22522	11266	5	0	\N
340334	399	66702358779471	22522	11266	6	0	\N
340335	721	2021283599286	22522	11266	7	0	\N
340336	534	66702358779471	22522	11266	8	0	\N
340337	731	2021283599286	22522	11266	9	0	\N
340338	1874	20622000	22522	11266	10	0	\N
340339	1874	20625000	22522	11266	11	0	\N
340340	1874	20627000	22522	11266	12	0	\N
340357	1678	24480780448000	22527	11270	0	0	\N
340358	1678	24480780449000	22527	11270	1	0	\N
340359	1874	20645000	22527	11270	2	0	\N
340360	1874	20648000	22527	11270	3	0	\N
340361	1874	20650000	22527	11270	4	0	\N
340362	1874	20653000	22527	11270	5	0	\N
340376	1678	24480780450000	22530	11271	0	0	\N
340377	1678	24480780451000	22530	11271	1	0	\N
340378	1874	20650000	22530	11271	2	0	\N
340379	1874	20652000	22530	11271	3	0	\N
340380	1874	20655000	22530	11271	4	0	\N
340381	1874	20658000	22530	11271	5	0	\N
340382	1874	20660000	22530	11271	6	0	\N
340383	1678	24480780450000	22531	11271	0	0	\N
340384	1678	24480780451000	22531	11271	1	0	\N
340385	1874	20650000	22531	11271	2	0	\N
340386	1874	20652000	22531	11271	3	0	\N
340387	1874	20655000	22531	11271	4	0	\N
340388	1874	20658000	22531	11271	5	0	\N
340389	1874	20660000	22531	11271	6	0	\N
340390	1874	20662000	22531	11271	7	0	\N
340391	1874	20664000	22531	11271	8	0	\N
340276	1874	20606000	22515	11262	2	0	2
340277	1874	20609000	22515	11262	3	0	2
340282	1678	24480780441000	22517	11263	0	0	0
340283	663	66702358779471	22517	11263	1	0	0
340284	266	66089338779471	22517	11263	2	0	2
340286	379	66046828809135	22517	11263	4	0	1
340287	1874	20611000	22517	11263	5	0	2
340288	1678	24480780442000	22518	11264	0	0	0
340289	551	66702358779471	22518	11264	1	0	0
340290	366	66046738745395	22518	11264	2	0	1
340292	680	66702358779471	22518	11264	4	0	0
340293	342	66047839524375	22518	11264	5	0	1
340294	361	66052356779471	22518	11264	6	0	2
340295	1874	20614000	22518	11264	7	0	2
340306	1678	24480780443000	22520	11265	0	0	0
340307	499	66702358779471	22520	11265	1	0	0
340308	391	66701248779471	22520	11265	2	0	1
340309	186	66702358779471	22520	11265	3	0	0
340310	458	66049130437906	22520	11265	4	0	1
340312	894	310088064614009	22520	11265	6	0	0
340313	1874	20618000	22520	11265	7	0	2
340314	1874	20621000	22520	11265	8	0	2
340315	1678	24480780444000	22521	11266	0	0	0
340316	921	507426751732622	22521	11266	1	0	0
340318	1161	613525792096394	22521	11266	3	0	0
340319	1287	1709644171348441	22521	11266	4	0	0
340320	570	66702358779471	22521	11266	5	0	0
340321	399	66702358779471	22521	11266	6	0	0
340323	534	66702358779471	22521	11266	8	0	0
340324	731	2021283599286	22521	11266	9	0	0
340325	1874	20622000	22521	11266	10	0	2
340326	1874	20625000	22521	11266	11	0	2
340327	1874	20627000	22521	11266	12	0	2
340342	138	66702358779471	22523	11267	1	0	0
340343	402	66702358779471	22523	11267	2	0	0
340344	275	66702358779471	22523	11267	3	0	0
340345	1030	910561287968894	22523	11267	4	0	0
340346	309	66702358779471	22523	11267	5	0	0
340348	1874	20630000	22523	11267	7	0	2
340349	1874	20632000	22523	11267	8	0	2
340350	1678	24480780446000	22524	11268	0	0	0
340351	1874	20635000	22524	11268	1	0	2
340353	1678	24480780447000	22525	11269	0	0	0
340354	1874	20638000	22525	11269	1	0	2
340355	1874	20641000	22525	11269	2	0	2
340356	1874	20643000	22525	11269	3	0	2
340363	1678	24480780448000	22528	11270	0	0	0
340365	1874	20646000	22528	11270	2	0	2
340366	1874	20649000	22528	11270	3	0	2
340367	1678	24480780450000	22529	11271	0	0	0
340368	1678	24480780451000	22529	11271	1	0	0
340369	1874	20650000	22529	11271	2	0	2
340371	1874	20655000	22529	11271	4	0	2
340372	1874	20658000	22529	11271	5	0	2
340373	1874	20660000	22529	11271	6	0	2
340374	1874	20662000	22529	11271	7	0	2
340392	1678	24480780452000	22532	11272	0	0	0
340393	1678	24480780453000	22532	11272	1	0	0
340394	1874	20666000	22532	11272	2	0	2
340395	1874	20668000	22532	11272	4	0	2
340396	1874	20671000	22532	11272	5	0	2
340398	312	66046738745395	22533	11273	0	0	1
340399	1772	5026682804467	22533	11273	1	0	1
340400	1811	1919507019037	22533	11273	2	0	1
340401	649	66046828809135	22533	11273	3	0	1
340402	1678	24480780454000	22533	11273	4	0	0
340404	205	66702358779471	22533	11273	6	0	0
340405	120	66047639382744	22533	11273	7	0	1
340406	1874	20675000	22533	11273	8	0	2
340407	1874	20678000	22533	11273	9	0	2
340419	1678	24480780458000	22535	11275	0	0	\N
340420	1874	20698000	22535	11275	1	0	\N
340421	1874	20701000	22535	11275	2	0	\N
340425	1811	1920594636015	22537	11276	0	0	\N
340426	1678	24480780459000	22537	11276	1	0	\N
340427	1678	24480780460000	22537	11276	2	0	\N
340428	1678	24480780461000	22537	11276	3	0	\N
340429	1772	5029538124378	22537	11276	4	0	\N
340430	1874	20704000	22537	11276	5	0	\N
340431	1874	20707000	22537	11276	6	0	\N
340432	1874	20710000	22537	11276	7	0	\N
340433	1874	20711000	22537	11276	8	0	\N
340434	1874	20713000	22537	11276	9	0	\N
340435	1874	20715000	22537	11276	10	0	\N
340436	1874	20717000	22537	11276	11	0	\N
340449	1678	24480780462000	22539	11277	0	0	\N
340450	1874	20720000	22539	11277	1	0	\N
340451	1874	20722000	22539	11277	2	0	\N
340455	1678	24480780463000	22541	11278	0	0	\N
340456	1678	24480780463000	22542	11278	0	0	\N
340457	1874	20725000	22542	11278	1	0	\N
340458	1874	20727000	22542	11278	2	0	\N
340459	1678	24480780463000	22543	11278	0	0	\N
340460	1874	20725000	22543	11278	1	0	\N
340461	1874	20727000	22543	11278	2	0	\N
340482	1678	24480780465000	22548	11280	0	0	\N
340483	1678	24480780466000	22548	11280	1	0	\N
340484	1678	24480780467000	22548	11280	2	0	\N
340485	1678	24480780468000	22548	11280	3	0	\N
340486	1874	20736000	22548	11280	4	0	\N
340487	1874	20739000	22548	11280	5	0	\N
340488	1874	20741000	22548	11280	6	0	\N
340489	1874	20743000	22548	11280	7	0	\N
340490	1874	20745000	22548	11280	8	0	\N
340491	1874	20747000	22548	11280	9	0	\N
340492	1874	20748000	22548	11280	10	0	\N
340493	1874	20751000	22548	11280	11	0	\N
340494	1874	20754000	22548	11280	12	0	\N
340502	1678	24480780471000	22551	11283	0	0	\N
340503	1678	24480780472000	22551	11283	1	0	\N
340504	1874	20768000	22551	11283	2	0	\N
340505	1874	20771000	22551	11283	3	0	\N
340506	1874	20773000	22551	11283	4	0	\N
340507	1874	20775000	22551	11283	5	0	\N
340517	1678	24480780474000	22555	11285	0	0	\N
340518	1874	20782000	22555	11285	1	0	\N
340519	1874	20785000	22555	11285	2	0	\N
340520	1874	20786000	22555	11285	3	0	\N
340525	1678	24480780475000	22557	11286	0	0	\N
340526	1874	20788000	22557	11286	1	0	\N
340527	1874	20791000	22557	11286	2	0	\N
340528	1678	24480780475000	22558	11286	0	0	\N
340529	1874	20788000	22558	11286	1	0	\N
340530	1874	20791000	22558	11286	2	0	\N
340534	1678	24480780475000	22560	11286	0	0	\N
340535	1874	20788000	22560	11286	1	0	\N
340536	1874	20791000	22560	11286	2	0	\N
340411	320	66420959644087	22534	11274	0	0	2
340412	1678	24480780456000	22534	11274	1	0	0
340413	1678	24480780457000	22534	11274	2	0	0
340414	1874	20687000	22534	11274	3	0	2
340415	1874	20688000	22534	11274	4	0	2
340417	1874	20693000	22534	11274	6	0	2
340418	1874	20696000	22534	11274	7	0	2
340422	1678	24480780458000	22536	11275	0	0	0
340423	1874	20698000	22536	11275	1	0	2
340424	1874	20701000	22536	11275	2	0	2
340438	1678	24480780459000	22538	11276	1	0	0
340439	1678	24480780460000	22538	11276	2	0	0
340440	1678	24480780461000	22538	11276	3	0	0
340441	1772	5029538124378	22538	11276	4	0	1
340443	1874	20707000	22538	11276	6	0	2
340444	1874	20710000	22538	11276	7	0	2
340445	1874	20711000	22538	11276	8	0	2
340446	1874	20713000	22538	11276	9	0	2
340447	1874	20715000	22538	11276	10	0	2
340452	1678	24480780462000	22540	11277	0	0	0
340453	1874	20720000	22540	11277	1	0	2
340454	1874	20722000	22540	11277	2	0	2
340462	1678	24480780463000	22544	11278	0	0	0
340463	1874	20725000	22544	11278	1	0	2
340465	1874	20726000	22545	11279	1	0	2
340466	1874	20728000	22545	11279	2	0	2
340467	1874	20731000	22545	11279	3	0	2
340468	1874	20733000	22545	11279	4	0	2
340470	1678	24480780466000	22547	11280	1	0	0
340471	1678	24480780467000	22547	11280	2	0	0
340472	1678	24480780468000	22547	11280	3	0	0
340473	1874	20736000	22547	11280	4	0	2
340474	1874	20739000	22547	11280	5	0	2
340476	1874	20743000	22547	11280	7	0	2
340477	1874	20745000	22547	11280	8	0	2
340478	1874	20747000	22547	11280	9	0	2
340479	1874	20748000	22547	11280	10	0	2
340480	1874	20751000	22547	11280	11	0	2
340495	1678	24480780469000	22549	11281	0	0	0
340496	1874	20757000	22549	11281	1	0	2
340497	1874	20759000	22549	11281	2	0	2
340498	1678	24480780470000	22550	11282	0	0	0
340500	1874	20762000	22550	11282	2	0	2
340501	1874	20765000	22550	11282	3	0	2
340508	1678	24480780471000	22552	11283	0	0	0
340509	1678	24480780472000	22552	11283	1	0	0
340510	1874	20768000	22552	11283	2	0	2
340512	1874	20773000	22552	11283	4	0	2
340513	1874	20775000	22552	11283	5	0	2
340514	1678	24480780473000	22554	11284	0	0	0
340515	1874	20778000	22554	11284	1	0	2
340516	1874	20780000	22554	11284	2	0	2
340522	1874	20782000	22556	11285	1	0	2
340523	1874	20785000	22556	11285	2	0	2
340524	1874	20786000	22556	11285	3	0	2
340531	1678	24480780475000	22559	11286	0	0	0
340533	1874	20791000	22559	11286	2	0	2
340537	1678	24480780476000	22561	11287	0	0	0
340538	1678	24480780477000	22561	11287	1	0	0
340539	1874	20794000	22561	11287	2	0	2
340540	2297	1000000000	22561	11287	3	0	0
340542	1874	20798000	22561	11287	5	0	2
340543	1874	20800000	22561	11287	6	0	2
340544	1874	20802000	22561	11287	7	0	2
340545	1678	24480780478000	22562	11288	0	0	\N
340546	1874	20805000	22562	11288	1	0	\N
340547	1874	20807000	22562	11288	3	0	\N
340554	1678	24480780479000	22565	11289	0	0	\N
340555	1874	20810000	22565	11289	1	0	\N
340556	1874	20812000	22565	11289	2	0	\N
340557	1678	24480780479000	22566	11289	0	0	\N
340558	1874	20810000	22566	11289	1	0	\N
340559	1874	20812000	22566	11289	2	0	\N
340560	1678	24480780480000	22567	11290	0	0	\N
340561	1678	24480780481000	22567	11290	1	0	\N
340562	1678	24480780482000	22567	11290	2	0	\N
340563	1874	20815000	22567	11290	3	0	\N
340564	2297	3472784111139	22567	11290	4	0	\N
340565	1874	20816000	22567	11290	5	0	\N
340566	1874	20818000	22567	11290	6	0	\N
340567	1773	3775000000000	22567	11290	7	0	\N
340568	1773	4779872852234	22567	11290	8	0	\N
340569	1874	20820000	22567	11290	9	0	\N
340570	1874	20823000	22567	11290	10	0	\N
340571	1874	20826000	22567	11290	11	0	\N
340587	1678	24480780484000	22570	11292	0	0	\N
340588	1874	20833000	22570	11292	1	0	\N
340589	1874	20834000	22570	11292	2	0	\N
340593	1678	24480780484000	22572	11292	0	0	\N
340594	1874	20833000	22572	11292	1	0	\N
340595	1874	20834000	22572	11292	2	0	\N
340606	2298	81793760832	22574	11293	0	0	\N
340607	1678	24480780485000	22574	11293	1	0	\N
340608	2298	136989601386	22574	11293	2	0	\N
340609	927	509266136284689	22574	11293	3	0	\N
340610	1047	912600552829904	22574	11293	4	0	\N
340611	1167	614748529681380	22574	11293	5	0	\N
340612	1293	1715841505382575	22574	11293	6	0	\N
340613	1874	20836000	22574	11293	7	0	\N
340614	1874	20839000	22574	11293	8	0	\N
340615	2297	6946569222278	22574	11293	9	0	\N
340619	2298	81793760832	22576	11293	0	0	\N
340620	1678	24480780485000	22576	11293	1	0	\N
340621	2298	136989601386	22576	11293	2	0	\N
340622	927	509266136284689	22576	11293	3	0	\N
340623	1047	912600552829904	22576	11293	4	0	\N
340624	1678	24480780486000	22576	11293	5	0	\N
340625	1678	24480780487000	22576	11293	6	0	\N
340626	1678	24480780488000	22576	11293	7	0	\N
340627	1167	614748529681380	22576	11293	8	0	\N
340628	1293	1715841505382575	22576	11293	9	0	\N
340629	1874	20837000	22576	11293	10	0	\N
340630	1874	20840000	22576	11293	11	0	\N
340631	1874	20843000	22576	11293	12	0	\N
340632	1874	20846000	22576	11293	13	0	\N
340633	2297	6946569222278	22576	11293	14	0	\N
340634	1874	20847000	22576	11293	15	0	\N
340635	1647	20000000	22576	11293	16	0	\N
340636	1678	24480780487000	22577	11295	0	0	\N
340637	1678	24480780488000	22577	11295	1	0	\N
340638	1678	24480780489000	22577	11295	2	0	\N
340639	1874	20847000	22577	11295	3	0	\N
340640	1874	20850000	22577	11295	4	0	\N
340641	1874	20853000	22577	11295	5	0	\N
340642	1874	20854000	22577	11295	6	0	\N
340643	1874	20856000	22577	11295	7	0	\N
340644	1874	20858000	22577	11295	8	0	\N
340645	1874	20860000	22577	11295	9	0	\N
340646	1647	20000000	22577	11295	10	0	\N
340667	1866	14175294119770	22581	11210	0	0	\N
340668	1678	24480780398000	22581	11210	1	0	\N
340669	1678	24480780399000	22581	11210	2	0	\N
340670	1678	24480780400000	22581	11210	3	0	\N
340671	1678	24480780401000	22581	11210	4	0	\N
340672	1678	24480780402000	22581	11210	5	0	\N
340673	1678	24480780403000	22581	11210	6	0	\N
340674	1678	24480780404000	22581	11210	7	0	\N
340675	1678	24480780405000	22581	11210	8	0	\N
340676	1678	24480780406000	22581	11210	9	0	\N
340677	1678	24480780407000	22581	11210	10	0	\N
340678	1678	24480780408000	22581	11210	11	0	\N
340679	1678	24480780409000	22581	11210	12	0	\N
340680	1678	24480780410000	22581	11210	13	0	\N
340550	1874	20807000	22563	11288	3	0	2
340551	1678	24480780479000	22564	11289	0	0	0
340552	1874	20810000	22564	11289	1	0	2
340553	1874	20812000	22564	11289	2	0	2
340572	1678	24480780480000	22568	11290	0	0	0
340574	1678	24480780482000	22568	11290	2	0	0
340575	1874	20815000	22568	11290	3	0	2
340576	2297	3472784111139	22568	11290	4	0	0
340577	1874	20816000	22568	11290	5	0	2
340578	1874	20818000	22568	11290	6	0	2
340580	1773	4779872852234	22568	11290	8	0	36
340581	1874	20820000	22568	11290	9	0	2
340582	1874	20823000	22568	11290	10	0	2
340583	1874	20826000	22568	11290	11	0	2
340585	1874	20829000	22569	11291	1	0	2
340586	1874	20831000	22569	11291	2	0	2
340590	1678	24480780484000	22571	11292	0	0	0
340591	1874	20833000	22571	11292	1	0	2
340592	1874	20834000	22571	11292	2	0	2
340597	1678	24480780485000	22573	11293	1	0	0
340598	2298	136989601386	22573	11293	2	0	0
340599	927	509266136284689	22573	11293	3	0	0
340600	1047	912600552829904	22573	11293	4	0	0
340601	1167	614748529681380	22573	11293	5	0	1
340603	1874	20836000	22573	11293	7	0	2
340604	1874	20839000	22573	11293	8	0	2
340605	2297	6946569222278	22573	11293	9	0	0
340616	1678	24480780486000	22575	11294	0	0	0
340618	1874	20844000	22575	11294	2	0	2
340647	1678	24480780487000	22578	11295	0	0	0
340648	1678	24480780488000	22578	11295	1	0	0
340649	1678	24480780489000	22578	11295	2	0	0
340650	1874	20847000	22578	11295	3	0	2
340652	1874	20853000	22578	11295	5	0	2
340653	1874	20854000	22578	11295	6	0	2
340654	1874	20856000	22578	11295	7	0	2
340655	1874	20858000	22578	11295	8	0	2
340656	1874	20860000	22578	11295	9	0	2
340658	1678	24480780490000	22579	11296	0	0	0
340659	1874	20861000	22579	11296	1	0	2
340660	1874	20863000	22579	11296	2	0	2
340661	1527	286999963	22579	11296	3	0	0
340663	1866	14175294119770	22580	11297	0	0	24
340664	1678	24480780491000	22580	11297	1	0	0
340665	1874	20869000	22580	11297	2	0	2
340666	1874	20871000	22580	11297	3	0	2
340681	1678	24480780411000	22581	11210	14	0	\N
340682	921	507426751732622	22581	11210	15	0	\N
340683	1041	909304391472409	22581	11210	16	0	\N
340684	1161	613525792096394	22581	11210	17	0	\N
340685	1287	1709644171348441	22581	11210	18	0	\N
340686	1678	24480780412000	22581	11210	19	0	\N
340687	1678	24480780413000	22581	11210	20	0	\N
340688	2181	700610585574	22581	11210	21	0	\N
340689	438	66702358779471	22581	11210	22	0	\N
340690	262	66046804815506	22581	11210	23	0	\N
340691	240	66047839524375	22581	11210	24	0	\N
340692	304	66702358779471	22581	11210	25	0	\N
340693	562	66046828809135	22581	11210	26	0	\N
340694	560	66702358779471	22581	11210	27	0	\N
340695	441	66046748752480	22581	11210	28	0	\N
340696	1772	5023827484556	22581	11210	29	0	\N
340697	653	66702358779471	22581	11210	30	0	\N
340698	373	66702358779471	22581	11210	31	0	\N
340699	92	66702358779471	22581	11210	32	0	\N
340700	710	5053208998381	22581	11210	33	0	\N
340701	1961	701270954698	22581	11210	34	0	\N
340702	660	66702358779471	22581	11210	35	0	\N
340703	395	66199315633740	22581	11210	36	0	\N
340704	394	66046828809135	22581	11210	37	0	\N
340705	29	7074492597754	22581	11210	38	0	\N
340706	251	66702358779471	22581	11210	39	0	\N
340707	91	66702358779471	22581	11210	40	0	\N
340708	89	66702358779471	22581	11210	41	0	\N
340709	1811	1918419402059	22581	11210	42	0	\N
340710	84	66702358779471	22581	11210	43	0	\N
340711	390	66702358779471	22581	11210	44	0	\N
340712	910	508128148220237	22581	11210	45	0	\N
340713	658	66702358779471	22581	11210	46	0	\N
340714	150	66702358779471	22581	11210	47	0	\N
340715	154	66046828809135	22581	11210	48	0	\N
340716	593	66701357779471	22581	11210	50	0	\N
340717	180	66702358779471	22581	11210	51	0	\N
340718	711	3004516180928	22581	11210	52	0	\N
340719	245	66702358779471	22581	11210	53	0	\N
340720	1962	701270954698	22581	11210	54	0	\N
340721	63	66702358779471	22581	11210	55	0	\N
340722	1150	614373845207994	22581	11210	56	0	\N
340723	163	66702358779471	22581	11210	57	0	\N
340724	78	66702358779471	22581	11210	58	0	\N
340725	678	66702358779471	22581	11210	59	0	\N
340726	108	66702358779471	22581	11210	60	0	\N
340727	745	2021283599286	22581	11210	61	0	\N
340728	600	66702358779471	22581	11210	62	0	\N
340729	112	66088313832720	22581	11210	63	0	\N
340730	103	66702358779471	22581	11210	64	0	\N
340731	383	66702358779471	22581	11210	65	0	\N
340732	453	66702358779471	22581	11210	66	0	\N
340733	283	66047229092394	22581	11210	67	0	\N
340734	308	66702358779471	22581	11210	68	0	\N
340735	201	66702358779471	22581	11210	69	0	\N
340736	748	2723708018119	22581	11210	70	0	\N
340737	35	19404322553971	22581	11210	71	0	\N
340738	2073	700533689541	22581	11210	72	0	\N
340739	237	66046828809135	22581	11210	73	0	\N
340740	225	66702358779471	22581	11210	74	0	\N
340741	2164	701019585574	22581	11210	75	0	\N
340742	99	66702358779471	22581	11210	76	0	\N
340743	206	66702358779471	22581	11210	77	0	\N
340744	122	66702358779471	22581	11210	78	0	\N
340745	443	66047127020166	22581	11210	79	0	\N
340746	691	66702358779471	22581	11210	80	0	\N
340747	377	66702358779471	22581	11210	81	0	\N
340748	49	66702358779471	22581	11210	82	0	\N
340749	530	66625396763316	22581	11210	83	0	\N
340750	893	310088064614009	22581	11210	84	0	\N
340751	54	66702358779471	22581	11210	85	0	\N
340752	217	66702358779471	22581	11210	86	0	\N
340753	603	66768259337864	22581	11210	87	0	\N
340754	165	66046828809135	22581	11210	88	0	\N
340755	194	66702358779471	22581	11210	89	0	\N
340756	339	66702358779471	22581	11210	90	0	\N
340757	105	66702358779471	22581	11210	91	0	\N
340758	322	66702358779471	22581	11210	92	0	\N
340759	252	66702358779471	22581	11210	93	0	\N
340760	636	66046738745395	22581	11210	94	0	\N
340761	1778	5451506401776	22581	11210	95	0	\N
340762	146	66702358779471	22581	11210	96	0	\N
340763	114	66049473685762	22581	11210	97	0	\N
340764	587	66702358779471	22581	11210	98	0	\N
340765	1678	24480780414000	22581	11210	99	0	\N
340766	1678	24480780415000	22581	11210	100	0	\N
340767	1678	24480780416000	22581	11210	101	0	\N
340768	1678	24480780417000	22581	11210	102	0	\N
340769	1678	24480780418000	22581	11210	103	0	\N
340770	1678	24480780419000	22581	11210	104	0	\N
340771	1678	24480780420000	22581	11210	105	0	\N
340772	1678	24480780421000	22581	11210	106	0	\N
340773	1678	24480780422000	22581	11210	107	0	\N
340774	1678	24480780423000	22581	11210	108	0	\N
340775	1678	24480780424000	22581	11210	109	0	\N
340776	1678	24480780425000	22581	11210	110	0	\N
340777	1678	24480780426000	22581	11210	111	0	\N
340778	1678	24480780427000	22581	11210	112	0	\N
340779	1678	24480780428000	22581	11210	113	0	\N
340780	1678	24480780429000	22581	11210	114	0	\N
340781	1678	24480780430000	22581	11210	115	0	\N
340782	1678	24480780431000	22581	11210	116	0	\N
340783	1678	24480780432000	22581	11210	117	0	\N
340784	1678	24480780433000	22581	11210	118	0	\N
340785	1678	24480780434000	22581	11210	119	0	\N
340786	1678	24480780435000	22581	11210	120	0	\N
340787	1678	24480780436000	22581	11210	121	0	\N
340788	1678	24480780437000	22581	11210	122	0	\N
340789	1678	24480780438000	22581	11210	123	0	\N
340790	1678	24480780439000	22581	11210	124	0	\N
340791	1678	24480780440000	22581	11210	125	0	\N
340798	846	574541103991681	22583	11299	0	0	\N
340799	936	507110804697234	22583	11299	1	0	\N
340800	1056	908738217092021	22583	11299	2	0	\N
340801	1176	613143782960121	22583	11299	3	0	\N
340802	1302	1708579668923873	22583	11299	4	0	\N
340803	1687	848806848312	22583	11299	5	0	\N
340804	1678	24480780493000	22583	11299	6	0	\N
340805	1874	20879000	22583	11299	7	0	\N
340806	1874	20881000	22583	11299	8	0	\N
340807	846	574541103991681	22584	11299	0	0	\N
340808	936	507110804697234	22584	11299	1	0	\N
340809	1056	908738217092021	22584	11299	2	0	\N
340810	1176	613143782960121	22584	11299	3	0	\N
340811	1302	1708579668923873	22584	11299	4	0	\N
340812	1687	848806848312	22584	11299	5	0	\N
340813	1678	24480780493000	22584	11299	6	0	\N
340814	1874	20879000	22584	11299	7	0	\N
340815	1874	20881000	22584	11299	8	0	\N
340794	845	574541103991681	22582	11298	2	0	2
340795	1678	24480780492000	22582	11298	3	0	0
340796	1874	20873000	22582	11298	4	0	2
340797	1874	20876000	22582	11298	5	0	2
340816	846	574541103991681	22585	11299	0	0	1
340829	1678	24480780494000	22587	11300	0	0	\N
340830	1874	20884000	22587	11300	1	0	\N
340831	1874	20885000	22587	11300	2	0	\N
340832	1874	20887000	22587	11300	3	0	\N
340855	1866	14175294119770	22592	11271	0	0	\N
340856	312	66046738745395	22592	11271	1	0	\N
340857	1772	5026682804467	22592	11271	3	0	\N
340858	1811	1919507019037	22592	11271	4	0	\N
340859	649	66046828809135	22592	11271	5	0	\N
340860	205	66702358779471	22592	11271	6	0	\N
340861	120	66047639382744	22592	11271	7	0	\N
340862	320	66420959644087	22592	11271	8	0	\N
340863	1811	1920594636015	22592	11271	9	0	\N
340864	1772	5029538124378	22592	11271	10	0	\N
340865	2297	1000000000	22592	11271	11	0	\N
340866	2297	3472784111139	22592	11271	12	0	\N
340867	2297	6946569222278	22592	11271	13	0	\N
340868	1773	3775000000000	22592	11271	15	0	\N
340869	1773	4779872852234	22592	11271	16	0	\N
340873	1678	24480780501000	22594	11304	0	0	\N
340874	1874	20927000	22594	11304	2	0	\N
340875	1874	20929000	22594	11304	3	0	\N
340876	1678	24480780501000	22595	11304	0	0	\N
340877	1678	24480780502000	22595	11304	2	0	\N
340878	1874	20927000	22595	11304	3	0	\N
340879	1874	20929000	22595	11304	4	0	\N
340883	1678	24480780502000	22597	11305	0	0	\N
340884	1874	20932000	22597	11305	1	0	\N
340885	1874	20934000	22597	11305	2	0	\N
340901	1678	24480780503000	22599	11306	0	0	\N
340902	1678	24480780504000	22599	11306	1	0	\N
340903	1678	24480780505000	22599	11306	2	0	\N
340904	1678	24480780506000	22599	11306	3	0	\N
340905	2112	12766633101924	22599	11306	4	0	\N
340906	1874	20935000	22599	11306	5	0	\N
340907	1874	20936000	22599	11306	6	0	\N
340908	1874	20938000	22599	11306	7	0	\N
340909	1874	20941000	22599	11306	8	0	\N
340910	1874	20944000	22599	11306	9	0	\N
340911	1874	20947000	22599	11306	10	0	\N
340912	1874	20950000	22599	11306	11	0	\N
340913	1874	20952000	22599	11306	12	0	\N
340914	1874	20954000	22599	11306	13	0	\N
340915	1874	20956000	22599	11306	14	0	\N
340916	1678	24480780503000	22600	11306	0	0	\N
340917	1678	24480780504000	22600	11306	1	0	\N
340918	1678	24480780505000	22600	11306	2	0	\N
340919	1678	24480780506000	22600	11306	3	0	\N
340920	2112	12766633101924	22600	11306	4	0	\N
340921	1874	20935000	22600	11306	5	0	\N
340922	1874	20936000	22600	11306	6	0	\N
340923	1874	20939000	22600	11306	7	0	\N
340924	1874	20942000	22600	11306	8	0	\N
340925	1874	20945000	22600	11306	9	0	\N
340926	1874	20948000	22600	11306	10	0	\N
340931	1678	24480780509000	22602	11308	0	0	\N
340932	1874	20965000	22602	11308	1	0	\N
340933	1874	20966000	22602	11308	2	0	\N
340934	1874	20968000	22602	11308	3	0	\N
340935	1874	20970000	22602	11308	4	0	\N
340936	1874	20972000	22602	11308	5	0	\N
340943	1678	24480780510000	22604	11309	0	0	\N
340944	1874	20974000	22604	11309	1	0	\N
340947	1678	24480780510000	22606	11309	0	0	\N
340948	1874	20974000	22606	11309	1	0	\N
340819	1176	613143782960121	22585	11299	3	0	0
340820	1302	1708579668923873	22585	11299	4	0	0
340821	1687	848806848312	22585	11299	5	0	7
340822	1678	24480780493000	22585	11299	6	0	0
340823	1874	20879000	22585	11299	7	0	2
340825	1678	24480780494000	22586	11300	0	0	0
340826	1874	20884000	22586	11300	1	0	2
340827	1874	20885000	22586	11300	2	0	2
340828	1874	20887000	22586	11300	3	0	2
340833	1678	24480780495000	22588	11301	0	0	0
340835	1874	20892000	22588	11301	2	0	2
340836	1678	24480780496000	22589	11302	0	0	0
340837	1678	24480780497000	22589	11302	1	0	0
340838	1874	20893000	22589	11302	2	0	2
340840	1678	24480780499000	22591	11303	1	0	0
340841	1678	24480780500000	22591	11303	2	0	0
340842	1874	20895000	22591	11303	3	0	2
340843	1874	20896000	22591	11303	4	0	2
340844	1874	20898000	22591	11303	5	0	2
340846	1874	20902000	22591	11303	7	0	2
340847	1874	20904000	22591	11303	8	0	2
340848	1874	20906000	22591	11303	9	0	2
340849	1874	20909000	22591	11303	10	0	2
340850	1874	20912000	22591	11303	11	0	2
340852	1874	20918000	22591	11303	13	0	2
340853	1874	20921000	22591	11303	14	0	2
340854	1874	20924000	22591	11303	15	0	2
340870	1678	24480780501000	22593	11304	0	0	0
340872	1874	20929000	22593	11304	3	0	2
340880	1678	24480780502000	22596	11305	0	0	0
340881	1874	20932000	22596	11305	1	0	2
340882	1874	20934000	22596	11305	2	0	2
340886	1678	24480780503000	22598	11306	0	0	0
340888	1678	24480780505000	22598	11306	2	0	0
340889	1678	24480780506000	22598	11306	3	0	0
340890	2112	12766633101924	22598	11306	4	0	6
340891	1874	20935000	22598	11306	5	0	2
340892	1874	20936000	22598	11306	6	0	2
340894	1874	20941000	22598	11306	8	0	2
340895	1874	20944000	22598	11306	9	0	2
340896	1874	20947000	22598	11306	10	0	2
340897	1874	20950000	22598	11306	11	0	2
340899	1874	20954000	22598	11306	13	0	2
340900	1874	20956000	22598	11306	14	0	2
340927	1678	24480780507000	22601	11307	0	0	0
340928	1678	24480780508000	22601	11307	1	0	0
340929	1874	20959000	22601	11307	2	0	2
340937	1678	24480780509000	22603	11308	0	0	0
340938	1874	20965000	22603	11308	1	0	2
340939	1874	20966000	22603	11308	2	0	2
340940	1874	20968000	22603	11308	3	0	2
340941	1874	20970000	22603	11308	4	0	2
340945	1678	24480780510000	22605	11309	0	0	0
340946	1874	20974000	22605	11309	1	0	2
340949	1678	24480780511000	22607	11310	0	0	0
340950	1678	24480780512000	22607	11310	1	0	0
340952	1874	20975000	22607	11310	3	0	2
340956	1678	24480780511000	22608	11310	0	0	\N
340957	1678	24480780512000	22608	11310	1	0	\N
340958	1678	24480780513000	22608	11310	2	0	\N
340959	1874	20975000	22608	11310	3	0	\N
340960	1874	20978000	22608	11310	4	0	\N
340961	1874	20981000	22608	11310	5	0	\N
340962	1874	20984000	22608	11310	6	0	\N
340963	1874	20986000	22608	11310	7	0	\N
340964	1874	20988000	22608	11310	8	0	\N
340965	1874	20990000	22608	11310	9	0	\N
340966	1678	24480780514000	22609	11311	0	0	\N
340967	1874	20987000	22609	11311	1	0	\N
340968	1874	20989000	22609	11311	2	0	\N
340969	1874	20991000	22609	11311	3	0	\N
340970	1874	20993000	22609	11311	4	0	\N
340971	1874	20995000	22609	11311	5	0	\N
340974	1678	24480780514000	22611	11311	0	0	\N
340975	1874	20987000	22611	11311	1	0	\N
340976	1678	24480780514000	22612	11311	0	0	\N
340977	1874	20987000	22612	11311	1	0	\N
340978	1874	20989000	22612	11311	2	0	\N
340979	1874	20991000	22612	11311	3	0	\N
340980	1874	20993000	22612	11311	4	0	\N
340981	1874	20995000	22612	11311	5	0	\N
340989	1678	24480780515000	22614	11312	0	0	\N
340990	1874	20990000	22614	11312	1	0	\N
340991	1874	20992000	22614	11312	2	0	\N
340992	1874	20994000	22614	11312	3	0	\N
340993	1874	20996000	22614	11312	4	0	\N
340994	1874	20998000	22614	11312	5	0	\N
340995	1874	21000000	22614	11312	6	0	\N
340996	1678	24480780516000	22615	11313	0	0	\N
340997	1874	21001000	22615	11313	1	0	\N
340998	1874	21003000	22615	11313	2	0	\N
340999	1874	21006000	22615	11313	3	0	\N
341002	1678	24480780516000	22617	11313	0	0	\N
341003	1874	21001000	22617	11313	1	0	\N
341004	1874	21003000	22617	11313	2	0	\N
341005	1874	21006000	22617	11313	3	0	\N
341006	1678	24480780516000	22618	11313	0	0	\N
341007	1874	21001000	22618	11313	1	0	\N
341008	1874	21004000	22618	11313	2	0	\N
341009	1678	24480780516000	22619	11313	0	0	\N
341010	1874	21001000	22619	11313	1	0	\N
341011	1874	21003000	22619	11313	2	0	\N
341012	1874	21006000	22619	11313	3	0	\N
341013	1678	24480780517000	22620	11314	0	0	\N
341014	1874	21008000	22620	11314	1	0	\N
341015	1874	21011000	22620	11314	2	0	\N
341025	1678	24480780519000	22623	11316	0	0	\N
341026	1874	21017000	22623	11316	1	0	\N
341027	1874	21019000	22623	11316	2	0	\N
341028	1874	21022000	22623	11316	3	0	\N
341033	1678	24480780519000	22625	11316	0	0	\N
341034	1874	21017000	22625	11316	1	0	\N
341035	1874	21019000	22625	11316	2	0	\N
341036	1874	21022000	22625	11316	3	0	\N
341037	1678	24480780519000	22626	11316	0	0	\N
341038	1874	21018000	22626	11316	1	0	\N
341039	1874	21021000	22626	11316	2	0	\N
341046	1678	24480780520000	22628	11317	0	0	\N
341047	1678	24480780521000	22628	11317	1	0	\N
341048	1874	21024000	22628	11317	2	0	\N
341049	1874	21027000	22628	11317	3	0	\N
341050	1874	21029000	22628	11317	4	0	\N
341051	1874	21032000	22628	11317	5	0	\N
341059	1678	24480780523000	22631	11319	0	0	\N
341060	1874	21040000	22631	11319	1	0	\N
341061	1874	21042000	22631	11319	2	0	\N
341062	1874	21043000	22631	11319	3	0	\N
341063	1678	24480780523000	22632	11319	0	0	\N
341064	1874	21040000	22632	11319	1	0	\N
341065	1874	21042000	22632	11319	2	0	\N
341066	1874	21043000	22632	11319	3	0	\N
341067	1678	24480780523000	22633	11319	0	0	\N
341068	1874	21040000	22633	11319	1	0	\N
341069	1874	21042000	22633	11319	2	0	\N
341070	1874	21043000	22633	11319	3	0	\N
341071	1678	24480780524000	22634	11320	0	0	\N
341072	1678	24480780525000	22634	11320	1	0	\N
341073	1874	21046000	22634	11320	2	0	\N
341074	1874	21048000	22634	11320	3	0	\N
341075	1874	21050000	22634	11320	4	0	\N
341076	1874	21053000	22634	11320	5	0	\N
341077	1678	24480780524000	22635	11320	0	0	\N
341078	1678	24480780525000	22635	11320	1	0	\N
341079	1874	21046000	22635	11320	2	0	\N
341080	1874	21048000	22635	11320	3	0	\N
341081	1874	21050000	22635	11320	4	0	\N
341082	1874	21053000	22635	11320	5	0	\N
340955	1874	20984000	22607	11310	6	0	2
340972	1678	24480780514000	22610	11311	0	0	0
340973	1874	20987000	22610	11311	1	0	2
340982	1678	24480780515000	22613	11312	0	0	0
340983	1874	20990000	22613	11312	1	0	2
340985	1874	20994000	22613	11312	3	0	2
340986	1874	20996000	22613	11312	4	0	2
340987	1874	20998000	22613	11312	5	0	2
340988	1874	21000000	22613	11312	6	0	2
341000	1874	21001000	22616	11313	0	0	2
341016	1678	24480780516000	22621	11314	0	0	0
341017	1678	24480780517000	22621	11314	1	0	0
341018	1874	21006000	22621	11314	2	0	2
341019	1874	21008000	22621	11314	3	0	2
341021	1678	24480780518000	22622	11315	0	0	0
341022	1607	0	22622	11315	1	0	14
341023	1874	21013000	22622	11315	2	0	2
341024	1874	21016000	22622	11315	3	0	2
341029	1678	24480780519000	22624	11316	0	0	0
341031	1874	21019000	22624	11316	2	0	2
341032	1874	21022000	22624	11316	3	0	2
341040	1678	24480780520000	22627	11317	0	0	0
341041	1678	24480780521000	22627	11317	1	0	0
341042	1874	21024000	22627	11317	2	0	2
341044	1874	21029000	22627	11317	4	0	2
341045	1874	21032000	22627	11317	5	0	2
341052	1678	24480780522000	22629	11318	0	0	0
341053	1874	21034000	22629	11318	1	0	2
341055	1678	24480780523000	22630	11319	0	0	0
341056	1874	21040000	22630	11319	1	0	2
341057	1874	21042000	22630	11319	2	0	2
341058	1874	21043000	22630	11319	3	0	2
341083	1678	24480780524000	22636	11320	0	0	0
341085	1874	21046000	22636	11320	2	0	2
341086	1874	21048000	22636	11320	3	0	2
341087	1874	21050000	22636	11320	4	0	2
341088	1874	21053000	22636	11320	5	0	2
341089	1678	24480780526000	22637	11321	0	0	\N
341090	1874	21055000	22637	11321	1	0	\N
341091	1874	21058000	22637	11321	2	0	\N
341092	1874	21059000	22637	11321	3	0	\N
341097	1678	24480780526000	22639	11321	0	0	\N
341098	1874	21055000	22639	11321	1	0	\N
341099	1874	21058000	22639	11321	2	0	\N
341100	1874	21059000	22639	11321	3	0	\N
341104	1678	24480780527000	22641	11322	0	0	\N
341105	1874	21062000	22641	11322	1	0	\N
341106	1874	21064000	22641	11322	2	0	\N
341107	1678	24480780528000	22642	11323	0	0	\N
341108	1874	21067000	22642	11323	1	0	\N
341109	1874	21069000	22642	11323	2	0	\N
341113	1678	24480780528000	22644	11323	0	0	\N
341114	1874	21067000	22644	11323	1	0	\N
341115	1874	21069000	22644	11323	2	0	\N
341116	1678	24480780528000	22645	11323	0	0	\N
341117	1874	21066000	22645	11323	1	0	\N
341118	1678	24480780529000	22646	11324	0	0	\N
341119	1678	24480780530000	22646	11324	1	0	\N
341120	1874	21071000	22646	11324	2	0	\N
341121	1874	21073000	22646	11324	3	0	\N
341122	1874	21076000	22646	11324	4	0	\N
341123	1874	21079000	22646	11324	5	0	\N
341124	1874	21080000	22646	11324	6	0	\N
341132	1678	24480780529000	22648	11324	0	0	\N
341133	1678	24480780530000	22648	11324	1	0	\N
341134	1874	21071000	22648	11324	2	0	\N
341135	1874	21073000	22648	11324	3	0	\N
341136	1874	21076000	22648	11324	4	0	\N
341137	1874	21079000	22648	11324	5	0	\N
341138	1874	21080000	22648	11324	6	0	\N
341145	1678	24480780532000	22651	11326	0	0	\N
341146	1874	21088000	22651	11326	1	0	\N
341147	1874	21090000	22651	11326	2	0	\N
341148	1678	24480780532000	22652	11326	0	0	\N
341149	1874	21088000	22652	11326	1	0	\N
341150	1874	21090000	22652	11326	2	0	\N
341151	1678	24480780533000	22653	11327	0	0	\N
341152	1874	21092000	22653	11327	1	0	\N
341153	1816	100000000	22653	11327	2	0	\N
341154	1874	21093000	22653	11327	3	0	\N
341155	1678	24480780533000	22654	11327	0	0	\N
341156	1816	100000000	22654	11327	1	0	\N
341157	1874	21091000	22654	11327	2	0	\N
341165	1678	24480780534000	22657	11328	0	0	\N
341166	1874	21096000	22657	11328	1	0	\N
341167	1874	21098000	22657	11328	2	0	\N
341168	1678	24480780534000	22658	11328	0	0	\N
341169	1874	21096000	22658	11328	1	0	\N
341170	1874	21098000	22658	11328	2	0	\N
341171	1678	24480780534000	22659	11328	0	0	\N
341172	1874	21096000	22659	11328	1	0	\N
341180	1678	24480780537000	22661	11330	0	0	\N
341181	1678	24480780538000	22661	11330	1	0	\N
341182	1678	24480780539000	22661	11330	2	0	\N
341183	1874	21112000	22661	11330	3	0	\N
341184	1874	21115000	22661	11330	4	0	\N
341185	1874	21117000	22661	11330	5	0	\N
341186	1874	21120000	22661	11330	6	0	\N
341187	1874	21121000	22661	11330	7	0	\N
341188	1874	21123000	22661	11330	8	0	\N
341189	1874	21125000	22661	11330	9	0	\N
341209	1678	24480780543000	22667	11332	0	0	\N
341210	1874	21142000	22667	11332	1	0	\N
341211	1874	21143000	22667	11332	2	0	\N
341212	1874	21146000	22667	11332	3	0	\N
341220	1678	24480780544000	22670	11333	0	0	\N
341221	1874	21149000	22670	11333	1	0	\N
341222	1874	21151000	22670	11333	2	0	\N
341095	1874	21058000	22638	11321	2	0	2
341096	1874	21059000	22638	11321	3	0	2
341101	1678	24480780527000	22640	11322	0	0	0
341102	1874	21062000	22640	11322	1	0	2
341103	1874	21064000	22640	11322	2	0	2
341111	1874	21067000	22643	11323	1	0	2
341112	1874	21069000	22643	11323	2	0	2
341125	1678	24480780529000	22647	11324	0	0	0
341126	1678	24480780530000	22647	11324	1	0	0
341127	1874	21071000	22647	11324	2	0	2
341129	1874	21076000	22647	11324	4	0	2
341130	1874	21079000	22647	11324	5	0	2
341131	1874	21080000	22647	11324	6	0	2
341139	1678	24480780531000	22649	11325	0	0	0
341141	1874	21085000	22649	11325	2	0	2
341142	1678	24480780532000	22650	11326	0	0	0
341143	1874	21088000	22650	11326	1	0	2
341144	1874	21090000	22650	11326	2	0	2
341158	1678	24480780533000	22655	11327	0	0	0
341160	1816	100000000	22655	11327	2	0	1
341161	1874	21093000	22655	11327	3	0	2
341162	1678	24480780534000	22656	11328	0	0	0
341163	1874	21096000	22656	11328	1	0	2
341164	1874	21098000	22656	11328	2	0	2
341174	1678	24480780536000	22660	11329	1	0	0
341175	1874	21101000	22660	11329	2	0	2
341176	1874	21103000	22660	11329	3	0	2
341177	1874	21105000	22660	11329	4	0	2
341179	1874	21109000	22660	11329	6	0	2
341190	1678	24480780537000	22662	11330	0	0	0
341191	1678	24480780538000	22662	11330	1	0	0
341192	1678	24480780539000	22662	11330	2	0	0
341193	1874	21112000	22662	11330	3	0	2
341195	1874	21117000	22662	11330	5	0	2
341196	1874	21120000	22662	11330	6	0	2
341197	1874	21121000	22662	11330	7	0	2
341198	1874	21123000	22662	11330	8	0	2
341199	1874	21125000	22662	11330	9	0	2
341201	1678	24480780541000	22663	11331	1	0	0
341202	1678	24480780542000	22663	11331	2	0	0
341203	1874	21127000	22663	11331	3	0	2
341204	1874	21130000	22663	11331	4	0	2
341206	1874	21136000	22663	11331	6	0	2
341207	1874	21138000	22663	11331	7	0	2
341208	1874	21140000	22663	11331	8	0	2
341213	1678	24480780543000	22668	11332	0	0	0
341214	1874	21142000	22668	11332	1	0	2
341216	1874	21146000	22668	11332	3	0	2
341217	1678	24480780544000	22669	11333	0	0	0
341218	1874	21149000	22669	11333	1	0	2
341219	1874	21151000	22669	11333	2	0	2
341223	1678	24480780545000	22671	11334	0	0	0
341233	1678	24480780547000	22673	11335	0	0	\N
341234	1874	21164000	22673	11335	1	0	\N
341235	1874	21167000	22673	11335	2	0	\N
341243	1678	24480780550000	22676	11338	0	0	\N
341244	1874	21181000	22676	11338	1	0	\N
341245	1874	21183000	22676	11338	2	0	\N
341249	1678	24480780551000	22678	11339	0	0	\N
341250	1874	21185000	22678	11339	1	0	\N
341251	1874	21188000	22678	11339	2	0	\N
341265	1678	24480780553000	22682	11341	0	0	\N
341266	1678	24480780554000	22682	11341	1	0	\N
341267	1874	21196000	22682	11341	2	0	\N
341268	1874	21199000	22682	11341	3	0	\N
341269	1874	21201000	22682	11341	4	0	\N
341270	1874	21203000	22682	11341	5	0	\N
341271	1874	21204000	22682	11341	6	0	\N
341275	1678	24480780555000	22685	11342	0	0	\N
341276	1874	21206000	22685	11342	1	0	\N
341277	1874	21209000	22685	11342	2	0	\N
341278	1024	506483472011067	22686	11343	0	0	\N
341279	1678	24480780556000	22686	11343	1	0	\N
341280	1874	21210000	22686	11343	2	0	\N
341281	1874	21212000	22686	11343	3	0	\N
341286	1024	506483472011067	22688	11343	0	0	\N
341287	1678	24480780556000	22688	11343	1	0	\N
341288	1874	21210000	22688	11343	2	0	\N
341289	1874	21212000	22688	11343	3	0	\N
341300	1264	612385279822721	22691	11345	0	0	\N
341301	1144	907614042293421	22691	11345	1	0	\N
341302	1678	24480780558000	22691	11345	2	0	\N
341303	1678	24480780559000	22691	11345	3	0	\N
341304	1390	1706466032489164	22691	11345	4	0	\N
341305	1874	21216000	22691	11345	5	0	\N
341306	1874	21218000	22691	11345	6	0	\N
341307	2028	18495268170000	22691	11345	7	0	\N
341311	1678	24480780561000	22693	11347	0	0	\N
341312	1874	21223000	22693	11347	1	0	\N
341313	1310	1709614189931650	22693	11347	2	0	\N
341314	1184	613515032910000	22693	11347	3	0	\N
341315	1064	909288445330000	22693	11347	4	0	\N
341316	944	507417853180000	22693	11347	5	0	\N
341323	1678	24480780561000	22695	11347	0	0	\N
341324	1874	21223000	22695	11347	1	0	\N
341325	1310	1709614189931650	22695	11347	2	0	\N
341326	1184	613515032910000	22695	11347	3	0	\N
341327	1064	909288445330000	22695	11347	4	0	\N
341328	944	507417853180000	22695	11347	5	0	\N
341342	1678	24480780566000	22698	11349	0	0	\N
341343	2028	2521198400000	22698	11349	1	0	\N
341344	1874	21234000	22698	11349	2	0	\N
341345	1874	21235000	22698	11349	3	0	\N
341346	1678	24480780566000	22699	11349	0	0	\N
341347	2028	2521198400000	22699	11349	1	0	\N
341348	1874	21234000	22699	11349	2	0	\N
341349	1874	21235000	22699	11349	3	0	\N
341350	1678	24480780566000	22700	11349	0	0	\N
341351	2028	2521198400000	22700	11349	1	0	\N
341352	1874	21234000	22700	11349	2	0	\N
341353	1874	21235000	22700	11349	3	0	\N
341354	1678	24480780566000	22701	11349	0	0	\N
341355	2028	2521198400000	22701	11349	1	0	\N
341356	1874	21234000	22701	11349	2	0	\N
341357	1874	21235000	22701	11349	3	0	\N
341358	1678	24480780567000	22702	11350	0	0	\N
341359	1874	21237000	22702	11350	1	0	\N
341360	1310	1709648324321650	22702	11350	2	0	\N
341227	1874	21158000	22671	11334	4	0	2
341228	1874	21160000	22671	11334	5	0	2
341229	1874	21162000	22671	11334	6	0	2
341230	1678	24480780547000	22672	11335	0	0	0
341231	1874	21164000	22672	11335	1	0	2
341236	1678	24480780548000	22674	11336	0	0	0
341237	1874	21170000	22674	11336	1	0	2
341238	1874	21172000	22674	11336	2	0	2
341239	1678	24480780549000	22675	11337	0	0	0
341240	1874	21174000	22675	11337	1	0	2
341242	1874	21178000	22675	11337	3	0	2
341246	1678	24480780550000	22677	11338	0	0	0
341247	1874	21181000	22677	11338	1	0	2
341248	1874	21183000	22677	11338	2	0	2
341253	1874	21185000	22679	11339	1	0	2
341254	1874	21188000	22679	11339	2	0	2
341255	1678	24480780552000	22680	11340	0	0	0
341256	1874	21191000	22680	11340	1	0	2
341257	1874	21193000	22680	11340	2	0	2
341259	1678	24480780554000	22681	11341	1	0	0
341260	1874	21196000	22681	11341	2	0	2
341261	1874	21199000	22681	11341	3	0	2
341262	1874	21201000	22681	11341	4	0	2
341263	1874	21203000	22681	11341	5	0	2
341272	1678	24480780555000	22684	11342	0	0	0
341273	1874	21206000	22684	11342	1	0	2
341274	1874	21209000	22684	11342	2	0	2
341282	1024	506483472011067	22687	11343	0	0	0
341284	1874	21210000	22687	11343	2	0	2
341285	1874	21212000	22687	11343	3	0	2
341290	1678	24480780557000	22689	11344	0	0	0
341291	1874	21214000	22689	11344	1	0	2
341292	1264	612385279822721	22690	11345	0	0	0
341294	1678	24480780558000	22690	11345	2	0	0
341295	1678	24480780559000	22690	11345	3	0	0
341296	1390	1706466032489164	22690	11345	4	0	0
341297	1874	21216000	22690	11345	5	0	2
341298	1874	21218000	22690	11345	6	0	2
341308	1678	24480780560000	22692	11346	0	0	0
341309	1874	21219000	22692	11346	1	0	2
341310	1874	21221000	22692	11346	2	0	2
341317	1678	24480780561000	22694	11347	0	0	0
341319	1310	1709614189931650	22694	11347	2	0	0
341320	1184	613515032910000	22694	11347	3	0	0
341321	1064	909288445330000	22694	11347	4	0	0
341322	944	507417853180000	22694	11347	5	0	0
341329	1678	24480780562000	22696	11348	0	0	0
341331	1678	24480780564000	22696	11348	2	0	0
341332	1678	24480780565000	22696	11348	3	0	0
341333	1874	21224000	22696	11348	4	0	2
341334	1874	21226000	22696	11348	5	0	2
341335	1874	21228000	22696	11348	6	0	2
341337	1874	21232000	22696	11348	8	0	2
341338	1678	24480780566000	22697	11349	0	0	0
341339	2028	2521198400000	22697	11349	1	0	8
341340	1874	21234000	22697	11349	2	0	2
341361	1184	613527282440000	22702	11350	3	0	\N
341362	1064	909306600310000	22702	11350	4	0	\N
341363	944	507427984360000	22702	11350	5	0	\N
341377	1678	24480780568000	22705	11351	0	0	\N
341378	1678	24480780569000	22705	11351	1	0	\N
341379	1678	24480780570000	22705	11351	2	0	\N
341380	1874	21239000	22705	11351	3	0	\N
341381	1874	21241000	22705	11351	4	0	\N
341382	1874	21243000	22705	11351	5	0	\N
341383	1874	21244000	22705	11351	6	0	\N
341384	1678	24480780571000	22706	11352	0	0	\N
341385	1874	21246000	22706	11352	1	0	\N
341386	1678	24480780571000	22707	11352	0	0	\N
341387	1874	21246000	22707	11352	1	0	\N
341390	1678	24480780572000	22709	11353	0	0	\N
341391	1678	24480780573000	22709	11353	1	0	\N
341392	1874	21247000	22709	11353	2	0	\N
341393	1874	21249000	22709	11353	3	0	\N
341394	1874	21251000	22709	11353	4	0	\N
341400	1678	24480780574000	22711	11354	0	0	\N
341401	1678	24480780575000	22711	11354	1	0	\N
341402	1874	21253000	22711	11354	2	0	\N
341403	1874	21255000	22711	11354	3	0	\N
341404	1874	21257000	22711	11354	4	0	\N
341405	1874	21258000	22711	11354	5	0	\N
341406	1678	24480780574000	22712	11354	0	0	\N
341407	1678	24480780575000	22712	11354	1	0	\N
341408	1874	21253000	22712	11354	2	0	\N
341409	1874	21255000	22712	11354	3	0	\N
341410	1874	21257000	22712	11354	4	0	\N
341411	1874	21258000	22712	11354	5	0	\N
341427	1678	24480780579000	22717	11357	0	0	\N
341428	1874	21266000	22717	11357	1	0	\N
341429	1874	21267000	22717	11357	2	0	\N
341430	1678	24480780580000	22718	11358	0	0	\N
341431	1874	21269000	22718	11358	1	0	\N
341434	1678	24480780580000	22720	11358	0	0	\N
341435	1874	21269000	22720	11358	1	0	\N
341436	1678	24480780581000	22721	11359	0	0	\N
341437	1874	21271000	22721	11359	1	0	\N
341449	1678	24480780584000	22726	11362	0	0	\N
341450	1678	24480780585000	22726	11362	1	0	\N
341451	1874	21278000	22726	11362	2	0	\N
341452	1874	21279000	22726	11362	3	0	\N
341453	1678	24480780584000	22727	11362	0	0	\N
341454	1678	24480780585000	22727	11362	1	0	\N
341455	1874	21278000	22727	11362	2	0	\N
341456	1874	21279000	22727	11362	3	0	\N
341457	1678	24480780586000	22728	11363	0	0	\N
341458	1874	21281000	22728	11363	1	0	\N
341488	1678	24480780592000	22737	11368	0	0	\N
341489	1678	24480780593000	22737	11368	1	0	\N
341490	1678	24480780594000	22737	11368	2	0	\N
341491	1678	24480780595000	22737	11368	3	0	\N
341492	1874	21300000	22737	11368	4	0	\N
341493	1874	21302000	22737	11368	5	0	\N
341494	1874	21304000	22737	11368	6	0	\N
341495	1874	21306000	22737	11368	7	0	\N
341496	1874	21307000	22737	11368	8	0	\N
341366	1310	1709648324321650	22703	11350	2	0	0
341367	1184	613527282440000	22703	11350	3	0	0
341368	1064	909306600310000	22703	11350	4	0	0
341369	944	507427984360000	22703	11350	5	0	0
341370	1678	24480780568000	22704	11351	0	0	0
341372	1678	24480780570000	22704	11351	2	0	0
341373	1874	21239000	22704	11351	3	0	2
341374	1874	21241000	22704	11351	4	0	2
341375	1874	21243000	22704	11351	5	0	2
341376	1874	21244000	22704	11351	6	0	2
341389	1874	21246000	22708	11352	1	0	2
341395	1678	24480780572000	22710	11353	0	0	0
341396	1678	24480780573000	22710	11353	1	0	0
341397	1874	21247000	22710	11353	2	0	2
341399	1874	21251000	22710	11353	4	0	2
341412	1678	24480780574000	22713	11354	0	0	0
341413	1678	24480780575000	22713	11354	1	0	0
341414	1874	21253000	22713	11354	2	0	2
341415	1874	21255000	22713	11354	3	0	2
341417	1874	21258000	22713	11354	5	0	2
341418	1678	24480780576000	22714	11355	0	0	0
341419	1678	24480780577000	22714	11355	1	0	0
341420	1874	21260000	22714	11355	2	0	2
341421	1874	21262000	22714	11355	3	0	2
341423	1874	21264000	22715	11356	1	0	2
341424	1678	24480780579000	22716	11357	0	0	0
341425	1874	21266000	22716	11357	1	0	2
341426	1874	21267000	22716	11357	2	0	2
341433	1874	21269000	22719	11358	1	0	2
341438	1678	24480780581000	22722	11359	0	0	0
341439	1678	24480780582000	22723	11360	0	0	0
341440	1874	21271000	22723	11360	1	0	2
341441	1874	21272000	22723	11360	2	0	2
341443	1678	24480780583000	22724	11361	0	0	0
341444	1874	21276000	22724	11361	1	0	2
341445	1678	24480780584000	22725	11362	0	0	0
341446	1678	24480780585000	22725	11362	1	0	0
341447	1874	21278000	22725	11362	2	0	2
341459	1678	24480780586000	22729	11363	0	0	0
341460	1874	21281000	22729	11363	1	0	2
341461	1678	24480780587000	22730	11364	0	0	0
341462	1678	24480780588000	22730	11364	1	0	0
341464	1874	21285000	22730	11364	3	0	2
341465	1678	24480780589000	22731	11365	0	0	0
341466	1874	21287000	22731	11365	1	0	2
341467	1874	21288000	22731	11365	2	0	2
341468	1678	24480780590000	22732	11366	0	0	0
341470	1874	21293000	22732	11366	2	0	2
341471	1678	24480780591000	22733	11367	0	0	0
341472	1874	21296000	22733	11367	1	0	2
341473	1874	21298000	22733	11367	2	0	2
341474	1678	24480780592000	22736	11368	0	0	0
341476	1678	24480780594000	22736	11368	2	0	0
341477	1678	24480780595000	22736	11368	3	0	0
341478	1874	21300000	22736	11368	4	0	2
341479	1874	21302000	22736	11368	5	0	2
341481	1874	21306000	22736	11368	7	0	2
341482	1874	21307000	22736	11368	8	0	2
341483	1874	21308000	22736	11368	9	0	2
341484	1874	21311000	22736	11368	10	0	2
341485	1874	21314000	22736	11368	11	0	2
341487	1874	21320000	22736	11368	13	0	2
341497	1874	21308000	22737	11368	9	0	\N
341498	1874	21311000	22737	11368	10	0	\N
341499	1874	21314000	22737	11368	11	0	\N
341500	1874	21317000	22737	11368	12	0	\N
341501	1874	21320000	22737	11368	13	0	\N
341508	1678	24480780598000	22739	11370	0	0	\N
341509	1874	21333000	22739	11370	1	0	\N
341510	2172	199000000	22739	11370	2	0	\N
341511	1874	21335000	22739	11370	3	0	\N
341531	1678	24480780602000	22744	11373	0	0	\N
341532	1678	24480780603000	22744	11373	1	0	\N
341533	1874	21353000	22744	11373	2	0	\N
341534	1874	21355000	22744	11373	3	0	\N
341535	1874	21356000	22744	11373	4	0	\N
341536	1874	21359000	22744	11373	5	0	\N
341537	1874	21362000	22744	11373	6	0	\N
341547	1678	24480780606000	22747	11376	0	0	\N
341548	1874	21376000	22747	11376	1	0	\N
341549	1874	21378000	22747	11376	2	0	\N
341553	1678	24480780606000	22749	11376	0	0	\N
341554	1874	21376000	22749	11376	1	0	\N
341555	1874	21378000	22749	11376	2	0	\N
341556	1678	24480780606000	22750	11376	0	0	\N
341557	1874	21375000	22750	11376	1	0	\N
341558	1678	24480780606000	22751	11376	0	0	\N
341559	1874	21375000	22751	11376	1	0	\N
341560	1678	24480780606000	22752	11376	0	0	\N
341561	1874	21376000	22752	11376	1	0	\N
341562	1874	21378000	22752	11376	2	0	\N
341563	1678	24480780606000	22753	11376	0	0	\N
341564	1874	21375000	22753	11376	1	0	\N
341565	1024	506483472011067	22754	11165	1	0	\N
341566	1264	612385279822721	22754	11165	2	0	\N
341567	1144	907614042293421	22754	11165	3	0	\N
341568	921	507426751732622	22754	11165	4	0	\N
341569	1041	909304391472409	22754	11165	5	0	\N
341570	1161	613525792096394	22754	11165	6	0	\N
341571	1287	1709644171348441	22754	11165	7	0	\N
341572	1607	0	22754	11165	8	0	\N
341573	2181	700610585574	22754	11165	9	0	\N
341574	438	66702358779471	22754	11165	10	0	\N
341575	262	66046804815506	22754	11165	11	0	\N
341576	240	66047839524375	22754	11165	12	0	\N
341577	304	66702358779471	22754	11165	13	0	\N
341578	562	66046828809135	22754	11165	14	0	\N
341579	560	66702358779471	22754	11165	15	0	\N
341580	441	66046748752480	22754	11165	16	0	\N
341581	1772	5023827484556	22754	11165	17	0	\N
341582	653	66702358779471	22754	11165	18	0	\N
341583	373	66702358779471	22754	11165	19	0	\N
341584	92	66702358779471	22754	11165	20	0	\N
341585	710	5053208998381	22754	11165	21	0	\N
341586	1961	701270954698	22754	11165	22	0	\N
341587	660	66702358779471	22754	11165	23	0	\N
341588	395	66199315633740	22754	11165	24	0	\N
341589	394	66046828809135	22754	11165	25	0	\N
341590	29	7074492597754	22754	11165	26	0	\N
341591	251	66702358779471	22754	11165	27	0	\N
341592	91	66702358779471	22754	11165	28	0	\N
341593	89	66702358779471	22754	11165	29	0	\N
341594	1811	1918419402059	22754	11165	30	0	\N
341595	84	66702358779471	22754	11165	31	0	\N
341596	390	66702358779471	22754	11165	32	0	\N
341597	910	508128148220237	22754	11165	33	0	\N
341598	658	66702358779471	22754	11165	34	0	\N
341599	150	66702358779471	22754	11165	35	0	\N
341600	154	66046828809135	22754	11165	36	0	\N
341601	593	66701357779471	22754	11165	37	0	\N
341602	180	66702358779471	22754	11165	38	0	\N
341603	711	3004516180928	22754	11165	39	0	\N
341604	245	66702358779471	22754	11165	40	0	\N
341605	1962	701270954698	22754	11165	41	0	\N
341606	63	66702358779471	22754	11165	42	0	\N
341607	1150	614373845207994	22754	11165	43	0	\N
341608	163	66702358779471	22754	11165	44	0	\N
341609	78	66702358779471	22754	11165	45	0	\N
341610	678	66702358779471	22754	11165	46	0	\N
341611	108	66702358779471	22754	11165	47	0	\N
341612	745	2021283599286	22754	11165	48	0	\N
341613	600	66702358779471	22754	11165	49	0	\N
341614	112	66088313832720	22754	11165	50	0	\N
341615	103	66702358779471	22754	11165	51	0	\N
341616	383	66702358779471	22754	11165	52	0	\N
341617	453	66702358779471	22754	11165	53	0	\N
341618	2112	10606587101924	22754	11165	54	0	\N
341619	1390	1706466032489164	22754	11165	55	0	\N
341620	283	66047229092394	22754	11165	56	0	\N
341621	308	66702358779471	22754	11165	57	0	\N
341622	201	66702358779471	22754	11165	58	0	\N
341623	748	2723708018119	22754	11165	59	0	\N
341624	35	19404322553971	22754	11165	60	0	\N
341625	2073	700533689541	22754	11165	61	0	\N
341626	237	66046828809135	22754	11165	62	0	\N
341627	225	66702358779471	22754	11165	63	0	\N
341628	2164	701019585574	22754	11165	64	0	\N
341629	99	66702358779471	22754	11165	65	0	\N
341630	206	66702358779471	22754	11165	66	0	\N
341631	122	66702358779471	22754	11165	67	0	\N
341632	443	66047127020166	22754	11165	68	0	\N
341504	1874	21323000	22738	11369	2	0	2
341505	1874	21326000	22738	11369	3	0	2
341506	1874	21328000	22738	11369	4	0	2
341507	1874	21330000	22738	11369	5	0	2
341512	1678	24480780598000	22740	11370	0	0	0
341514	2172	199000000	22740	11370	2	0	2
341515	1874	21335000	22740	11370	3	0	2
341516	1678	24480780599000	22741	11371	0	0	0
341517	1874	21338000	22741	11371	1	0	2
341518	1874	21340000	22741	11371	2	0	2
341520	1678	24480780600000	22742	11372	0	0	0
341521	1678	24480780601000	22742	11372	1	0	0
341522	1874	21343000	22742	11372	2	0	2
341523	1874	21345000	22742	11372	3	0	2
341525	1874	21351000	22742	11372	5	0	2
341526	1678	24480780602000	22743	11373	0	0	0
341527	1678	24480780603000	22743	11373	1	0	0
341528	1874	21352000	22743	11373	2	0	2
341529	1874	21355000	22743	11373	3	0	2
341538	1678	24480780604000	22745	11374	0	0	0
341539	1874	21361000	22745	11374	1	0	2
341540	1874	21363000	22745	11374	2	0	2
341541	1874	21365000	22745	11374	3	0	2
341542	1874	21367000	22745	11374	4	0	2
341544	1874	21370000	22746	11375	1	0	2
341545	1874	21372000	22746	11375	2	0	2
341546	1874	21373000	22746	11375	3	0	2
341550	1678	24480780606000	22748	11376	0	0	0
341552	1874	21378000	22748	11376	2	0	2
341633	691	66702358779471	22754	11165	69	0	\N
341634	377	66702358779471	22754	11165	70	0	\N
341635	49	66702358779471	22754	11165	71	0	\N
341636	530	66625396763316	22754	11165	72	0	\N
341637	893	310088064614009	22754	11165	73	0	\N
341638	54	66702358779471	22754	11165	74	0	\N
341639	217	66702358779471	22754	11165	75	0	\N
341640	603	66768259337864	22754	11165	76	0	\N
341641	165	66046828809135	22754	11165	77	0	\N
341642	194	66702358779471	22754	11165	78	0	\N
341643	339	66702358779471	22754	11165	79	0	\N
341644	105	66702358779471	22754	11165	80	0	\N
341645	322	66702358779471	22754	11165	82	0	\N
341646	252	66702358779471	22754	11165	83	0	\N
341647	636	66046738745395	22754	11165	84	0	\N
341648	1778	5451506401776	22754	11165	85	0	\N
341649	146	66702358779471	22754	11165	86	0	\N
341650	114	66049473685762	22754	11165	87	0	\N
341651	587	66702358779471	22754	11165	88	0	\N
341652	238	66046924858702	22754	11165	89	0	\N
341653	392	66702358779471	22754	11165	90	0	\N
341654	578	66046828809135	22754	11165	91	0	\N
341655	408	66702358779471	22754	11165	92	0	\N
341656	504	66089288779471	22754	11165	93	0	\N
341657	611	66702358779471	22754	11165	94	0	\N
341658	500	66702358779471	22754	11165	95	0	\N
341659	353	66004148160270	22754	11165	96	0	\N
341660	301	66057220092394	22754	11165	97	0	\N
341661	601	66702358779471	22754	11165	98	0	\N
341662	1276	1712007346748474	22754	11165	99	0	\N
341663	450	66702358779471	22754	11165	100	0	\N
341664	10	32582047065816	22754	11165	101	0	\N
341665	421	66702358779471	22754	11165	102	0	\N
341666	620	66702358779471	22754	11165	103	0	\N
341667	594	66702358779471	22754	11165	104	0	\N
341668	622	66658400277049	22754	11165	105	0	\N
341669	2017	700958113870	22754	11165	106	0	\N
341670	520	66702358779471	22754	11165	107	0	\N
341671	452	66702358779471	22754	11165	108	0	\N
341672	652	66702358779471	22754	11165	109	0	\N
341673	354	66049130437906	22754	11165	110	0	\N
341674	569	66702358779471	22754	11165	111	0	\N
341675	352	66702358779471	22754	11165	112	0	\N
341676	663	66702358779471	22754	11165	113	0	\N
341677	266	66089338779471	22754	11165	114	0	\N
341678	191	66702358779471	22754	11165	115	0	\N
341679	379	66046828809135	22754	11165	116	0	\N
341680	551	66702358779471	22754	11165	117	0	\N
341681	366	66046738745395	22754	11165	118	0	\N
341682	82	66702358779471	22754	11165	119	0	\N
341683	680	66702358779471	22754	11165	120	0	\N
341694	1678	24480780607000	22756	11377	0	0	\N
341695	1678	24480780608000	22756	11377	1	0	\N
341696	1678	24480780609000	22756	11377	2	0	\N
341697	1874	21379000	22756	11377	3	0	\N
341698	1874	21381000	22756	11377	4	0	\N
341699	1874	21383000	22756	11377	5	0	\N
341700	1874	21386000	22756	11377	6	0	\N
341701	1874	21389000	22756	11377	7	0	\N
341702	1874	21392000	22756	11377	8	0	\N
341703	1874	21394000	22756	11377	9	0	\N
341714	1678	24480780613000	22760	11381	0	0	\N
341715	1678	24480780614000	22760	11381	1	0	\N
341716	1874	21412000	22760	11381	2	0	\N
341717	1874	21414000	22760	11381	3	0	\N
341718	1874	21417000	22760	11381	5	0	\N
341719	1874	21420000	22760	11381	6	0	\N
341729	1678	24480780615000	22764	11382	0	0	\N
341730	1874	21417000	22764	11382	1	0	\N
341731	1874	21419000	22764	11382	2	0	\N
341732	1874	21421000	22764	11382	3	0	\N
341733	1874	21423000	22764	11382	4	0	\N
341734	1678	24480780615000	22765	11382	0	0	\N
341735	1874	21417000	22765	11382	1	0	\N
341736	1874	21419000	22765	11382	2	0	\N
341737	1874	21421000	22765	11382	3	0	\N
341738	1874	21423000	22765	11382	4	0	\N
341744	1678	24480780618000	22768	11385	0	0	\N
341745	1874	21433000	22768	11385	1	0	\N
341746	1874	21436000	22768	11385	2	0	\N
341747	1874	21438000	22768	11385	3	0	\N
341762	1678	24480780622000	22772	11388	0	0	\N
341763	1678	24480780623000	22772	11388	1	0	\N
341764	1678	24480780624000	22772	11388	2	0	\N
341765	1678	24480780625000	22772	11388	3	0	\N
341766	1678	24480780626000	22772	11388	4	0	\N
341767	1678	24480780627000	22772	11388	5	0	\N
341768	1874	21455000	22772	11388	6	0	\N
341686	1678	24480780609000	22755	11377	2	0	0
341687	1874	21379000	22755	11377	3	0	2
341688	1874	21381000	22755	11377	4	0	2
341689	1874	21383000	22755	11377	5	0	2
341690	1874	21386000	22755	11377	6	0	2
341692	1874	21392000	22755	11377	8	0	2
341693	1874	21394000	22755	11377	9	0	2
341704	1678	24480780610000	22757	11378	0	0	0
341705	1874	21397000	22757	11378	1	0	2
341706	1874	21399000	22757	11378	2	0	2
341708	1874	21402000	22758	11379	1	0	2
341709	1874	21404000	22758	11379	2	0	2
341710	1678	24480780612000	22759	11380	0	0	0
341711	1874	21406000	22759	11380	1	0	2
341713	1874	21410000	22759	11380	3	0	2
341720	1678	24480780613000	22761	11381	0	0	0
341721	1678	24480780614000	22761	11381	1	0	0
341722	1874	21413000	22761	11381	2	0	2
341723	1874	21416000	22761	11381	3	0	2
341725	1874	21417000	22763	11382	1	0	2
341726	1874	21419000	22763	11382	2	0	2
341727	1874	21421000	22763	11382	3	0	2
341728	1874	21423000	22763	11382	4	0	2
341739	1678	24480780616000	22766	11383	0	0	0
341741	1874	21428000	22766	11383	2	0	2
341742	1678	24480780617000	22767	11384	0	0	0
341743	1874	21431000	22767	11384	1	0	2
341748	1678	24480780618000	22769	11385	0	0	0
341750	1874	21436000	22769	11385	2	0	2
341751	1874	21438000	22769	11385	3	0	2
341752	1678	24480780619000	22770	11386	0	0	0
341753	1874	21439000	22770	11386	1	0	2
341754	1874	21442000	22770	11386	2	0	2
341756	1678	24480780620000	22771	11387	0	0	0
341757	1678	24480780621000	22771	11387	1	0	0
341758	1874	21446000	22771	11387	2	0	2
341759	1874	21449000	22771	11387	3	0	2
341760	1874	21452000	22771	11387	4	0	2
341769	1874	21458000	22772	11388	7	0	\N
341770	1874	21461000	22772	11388	8	0	\N
341771	1874	21462000	22772	11388	9	0	\N
341772	1874	21465000	22772	11388	11	0	\N
341773	1874	21467000	22772	11388	12	0	\N
341774	1874	21469000	22772	11388	13	0	\N
341775	1874	21471000	22772	11388	14	0	\N
341776	1874	21473000	22772	11388	15	0	\N
341777	1874	21475000	22772	11388	16	0	\N
341778	1874	21477000	22772	11388	17	0	\N
341779	1874	21480000	22772	11388	18	0	\N
341780	1874	21483000	22772	11388	19	0	\N
341781	1874	21486000	22772	11388	20	0	\N
341782	1678	24480780622000	22773	11388	0	0	\N
341783	1678	24480780623000	22773	11388	1	0	\N
341784	1678	24480780624000	22773	11388	2	0	\N
341785	1678	24480780625000	22773	11388	3	0	\N
341786	1678	24480780626000	22773	11388	4	0	\N
341787	1678	24480780627000	22773	11388	5	0	\N
341788	1874	21455000	22773	11388	6	0	\N
341789	1874	21458000	22773	11388	7	0	\N
341790	1874	21461000	22773	11388	8	0	\N
341791	1874	21462000	22773	11388	9	0	\N
341792	1874	21465000	22773	11388	11	0	\N
341793	1874	21467000	22773	11388	12	0	\N
341794	1874	21469000	22773	11388	13	0	\N
341795	1874	21471000	22773	11388	14	0	\N
341796	1874	21473000	22773	11388	15	0	\N
341797	1874	21475000	22773	11388	16	0	\N
341798	1874	21477000	22773	11388	17	0	\N
341799	1874	21480000	22773	11388	18	0	\N
341800	1874	21483000	22773	11388	19	0	\N
341801	1874	21486000	22773	11388	20	0	\N
341825	1678	24480780628000	22776	11389	0	0	\N
341826	1874	21488000	22776	11389	1	0	\N
341827	1874	21491000	22776	11389	2	0	\N
341842	1678	24480780632000	22781	11393	0	0	\N
341843	1874	21509000	22781	11393	1	0	\N
341844	1874	21510000	22781	11393	2	0	\N
341845	1874	21513000	22781	11393	3	0	\N
341846	1651	355693450231	22782	11394	0	0	\N
341847	1678	24480780633000	22782	11394	1	0	\N
341848	1678	24480780634000	22782	11394	2	0	\N
341849	1874	21516000	22782	11394	3	0	\N
341850	1874	21519000	22782	11394	4	0	\N
341851	1874	21521000	22782	11394	5	0	\N
341852	1874	21523000	22782	11394	6	0	\N
341853	1651	355693450231	22783	11394	0	0	\N
341854	1678	24480780633000	22783	11394	1	0	\N
341855	1678	24480780634000	22783	11394	2	0	\N
341856	1874	21516000	22783	11394	3	0	\N
341857	1874	21519000	22783	11394	4	0	\N
341858	1874	21521000	22783	11394	5	0	\N
341859	1874	21523000	22783	11394	6	0	\N
341874	1678	24480780636000	22787	11396	0	0	\N
341875	1874	21529000	22787	11396	1	0	\N
341876	1874	21531000	22787	11396	2	0	\N
341877	1874	21534000	22787	11396	3	0	\N
341878	1874	21529000	22788	11396	0	0	\N
341879	1874	21531000	22788	11396	1	0	\N
341880	1874	21534000	22788	11396	2	0	\N
341804	1678	24480780624000	22774	11388	2	0	0
341805	1678	24480780625000	22774	11388	3	0	0
341806	1678	24480780626000	22774	11388	4	0	0
341807	1678	24480780627000	22774	11388	5	0	0
341808	1874	21455000	22774	11388	6	0	2
341810	1874	21461000	22774	11388	8	0	2
341811	1874	21462000	22774	11388	9	0	2
341812	1874	21465000	22774	11388	11	0	2
341813	1874	21467000	22774	11388	12	0	2
341814	1874	21469000	22774	11388	13	0	2
341816	1874	21473000	22774	11388	15	0	2
341817	1874	21475000	22774	11388	16	0	2
341818	1874	21477000	22774	11388	17	0	2
341819	1874	21480000	22774	11388	18	0	2
341821	1874	21486000	22774	11388	20	0	2
341822	1678	24480780628000	22775	11389	0	0	0
341823	1874	21488000	22775	11389	1	0	2
341824	1874	21491000	22775	11389	2	0	2
341828	1678	24480780629000	22777	11390	0	0	0
341830	1874	21496000	22777	11390	2	0	2
341831	1874	21497000	22777	11390	3	0	2
341832	1678	24480780630000	22778	11391	0	0	0
341833	1874	21500000	22778	11391	1	0	2
341834	1874	21502000	22778	11391	2	0	2
341836	1874	21505000	22779	11392	1	0	2
341837	1874	21507000	22779	11392	2	0	2
341838	1678	24480780632000	22780	11393	0	0	0
341839	1874	21509000	22780	11393	1	0	2
341841	1874	21513000	22780	11393	3	0	2
341860	1651	355693450231	22784	11394	0	0	12
341861	1678	24480780633000	22784	11394	1	0	0
341862	1678	24480780634000	22784	11394	2	0	0
341863	1874	21516000	22784	11394	3	0	2
341865	1874	21521000	22784	11394	5	0	2
341866	1874	21523000	22784	11394	6	0	2
341867	1678	24480780635000	22785	11395	0	0	0
341868	1874	21525000	22785	11395	1	0	2
341869	1874	21528000	22785	11395	2	0	2
341871	1874	21529000	22786	11396	1	0	2
341872	1874	21531000	22786	11396	2	0	2
341873	1874	21534000	22786	11396	3	0	2
341881	1678	24480780637000	22789	11397	0	0	0
341883	462	66694988481206	22789	11397	2	0	0
341884	1678	24480780638000	22789	11397	3	0	0
341885	1874	21537000	22789	11397	4	0	2
341886	1874	21540000	22789	11397	5	0	2
341887	1874	21542000	22789	11397	6	0	2
341889	1678	24480780639000	22790	11398	0	0	0
341890	1678	24480780640000	22790	11398	1	0	0
341891	1874	21546000	22790	11398	2	0	2
341892	1874	21547000	22790	11398	3	0	2
341893	1874	21549000	22790	11398	4	0	2
341895	1874	21555000	22790	11398	6	0	2
341896	1678	24480780641000	22791	11399	0	0	0
341897	1678	24480780642000	22791	11399	2	0	0
341898	1874	21558000	22791	11399	3	0	2
341900	1874	21562000	22791	11399	5	0	2
341901	1362	1715178097751650	22791	11399	6	0	0
341902	1874	21563000	22791	11399	7	0	2
341903	1874	21566000	22791	11399	8	0	2
341904	1116	912247707000000	22791	11399	9	0	0
341910	1678	24480780644000	22793	11401	0	0	\N
341911	1678	24480780645000	22793	11401	1	0	\N
341912	1874	21573000	22793	11401	2	0	\N
341913	1874	21576000	22793	11401	3	0	\N
341914	1874	21579000	22793	11401	4	0	\N
341915	1874	21581000	22793	11401	5	0	\N
341922	1678	24480780644000	22795	11401	0	0	\N
341923	1678	24480780645000	22795	11401	1	0	\N
341924	1874	21573000	22795	11401	2	0	\N
341925	1874	21576000	22795	11401	3	0	\N
341926	1874	21579000	22795	11401	4	0	\N
341927	1874	21581000	22795	11401	5	0	\N
341928	1678	24480780644000	22796	11401	0	0	\N
341929	1678	24480780645000	22796	11401	1	0	\N
341930	1678	24480780644000	22797	11401	0	0	\N
341931	1678	24480780645000	22797	11401	1	0	\N
341932	1874	21573000	22797	11401	2	0	\N
341933	1874	21576000	22797	11401	3	0	\N
341934	1874	21579000	22797	11401	4	0	\N
341935	1874	21581000	22797	11401	5	0	\N
341936	1678	24480780644000	22798	11401	0	0	\N
341937	1678	24480780645000	22798	11401	1	0	\N
341938	1874	21573000	22798	11401	2	0	\N
341939	1874	21576000	22798	11401	3	0	\N
341940	1874	21579000	22798	11401	4	0	\N
341941	1874	21581000	22798	11401	5	0	\N
341946	1678	24480780646000	22800	11402	0	0	\N
341947	1874	21584000	22800	11402	1	0	\N
341948	1874	21585000	22800	11402	2	0	\N
341949	1874	21587000	22800	11402	3	0	\N
341950	1678	24480780646000	22801	11402	0	0	\N
341951	1874	21584000	22801	11402	1	0	\N
341952	1874	21585000	22801	11402	2	0	\N
341953	1874	21587000	22801	11402	3	0	\N
341957	1678	24480780647000	22803	11403	0	0	\N
341958	1874	21590000	22803	11403	1	0	\N
341959	1874	21592000	22803	11403	2	0	\N
341960	1678	24480780647000	22804	11403	0	0	\N
341961	1874	21590000	22804	11403	1	0	\N
341962	1874	21592000	22804	11403	2	0	\N
341963	1678	24480780648000	22805	11404	0	0	\N
341964	1874	21594000	22805	11404	1	0	\N
341965	1874	21597000	22805	11404	2	0	\N
341979	1678	24480780652000	22810	11408	0	0	\N
341980	1874	21616000	22810	11408	1	0	\N
341981	1874	21617000	22810	11408	2	0	\N
341985	1678	24480780652000	22812	11408	0	0	\N
341986	1874	21616000	22812	11408	1	0	\N
341987	1874	21617000	22812	11408	2	0	\N
341991	1678	24480780653000	22814	11409	0	0	\N
341992	1874	21620000	22814	11409	1	0	\N
341993	1874	21622000	22814	11409	2	0	\N
341994	1678	24480780653000	22815	11409	0	0	\N
341995	1874	21620000	22815	11409	1	0	\N
341996	1874	21622000	22815	11409	2	0	\N
341997	1874	21620000	22816	11409	0	0	\N
341998	1874	21622000	22816	11409	1	0	\N
341999	1678	24480780654000	22817	11410	0	0	\N
342000	1874	21625000	22817	11410	1	0	\N
342001	1874	21628000	22817	11410	2	0	\N
342002	1874	21630000	22817	11410	3	0	\N
342003	1874	21632000	22817	11410	4	0	\N
342026	1678	24480780643000	22823	11400	0	0	\N
342037	1678	24480780660000	22826	11415	0	0	\N
342038	1678	24480780661000	22826	11415	1	0	\N
342039	1678	24480780662000	22826	11415	2	0	\N
342040	1874	21661000	22826	11415	3	0	\N
341907	1678	24480780643000	22792	11400	0	0	0
341908	1874	21569000	22792	11400	1	0	2
341909	1874	21571000	22792	11400	2	0	2
341916	1678	24480780644000	22794	11401	0	0	0
341917	1678	24480780645000	22794	11401	1	0	0
341919	1874	21576000	22794	11401	3	0	2
341920	1874	21579000	22794	11401	4	0	2
341921	1874	21581000	22794	11401	5	0	2
341942	1678	24480780646000	22799	11402	0	0	0
341943	1874	21584000	22799	11402	1	0	2
341945	1874	21587000	22799	11402	3	0	2
341954	1678	24480780647000	22802	11403	0	0	0
341955	1874	21590000	22802	11403	1	0	2
341956	1874	21592000	22802	11403	2	0	2
341967	1678	24480780648000	22807	11405	0	0	0
341968	1678	24480780649000	22807	11405	1	0	0
341969	1874	21598000	22807	11405	2	0	2
341970	1874	21600000	22807	11405	3	0	2
341971	1874	21602000	22807	11405	4	0	2
341973	1678	24480780650000	22808	11406	0	0	0
341974	1874	21606000	22808	11406	1	0	2
341975	1874	21608000	22808	11406	2	0	2
341976	1678	24480780651000	22809	11407	0	0	0
341977	1874	21611000	22809	11407	1	0	2
341982	1678	24480780652000	22811	11408	0	0	0
341983	1874	21616000	22811	11408	1	0	2
341984	1874	21617000	22811	11408	2	0	2
341988	1678	24480780653000	22813	11409	0	0	0
341990	1874	21622000	22813	11409	2	0	2
342004	1678	24480780654000	22818	11410	0	0	0
342005	1874	21625000	22818	11410	1	0	2
342006	1874	21628000	22818	11410	2	0	2
342007	1874	21630000	22818	11410	3	0	2
342009	1678	24480780655000	22819	11411	0	0	0
342010	1678	24480780656000	22819	11411	1	0	0
342011	1874	21635000	22819	11411	2	0	2
342012	1874	21638000	22819	11411	3	0	2
342013	1874	21640000	22819	11411	4	0	2
342015	1874	21643000	22819	11411	6	0	2
342016	1678	24480780657000	22820	11412	0	0	0
342017	1874	21645000	22820	11412	1	0	2
342018	1874	21648000	22820	11412	2	0	2
342020	1874	21649000	22821	11413	1	0	2
342021	1874	21651000	22821	11413	2	0	2
342022	1874	21654000	22821	11413	3	0	2
342023	1678	24480780659000	22822	11414	0	0	0
342024	1874	21656000	22822	11414	1	0	2
342027	1678	24480780660000	22825	11415	0	0	0
342028	1678	24480780661000	22825	11415	1	0	0
342029	1678	24480780662000	22825	11415	2	0	0
342030	1874	21662000	22825	11415	3	0	2
342031	1874	21664000	22825	11415	4	0	2
342033	1874	21668000	22825	11415	6	0	2
342034	1874	21671000	22825	11415	7	0	2
342035	1874	21674000	22825	11415	8	0	2
342036	1874	21675000	22825	11415	9	0	2
342041	1874	21663000	22826	11415	4	0	\N
342042	1874	21665000	22826	11415	5	0	\N
342043	1874	21666000	22826	11415	6	0	\N
342044	1678	24480780663000	22827	11416	0	0	\N
342045	1874	21678000	22827	11416	1	0	\N
342046	1874	21680000	22827	11416	2	0	\N
342050	1678	24480780664000	22829	11417	0	0	\N
342051	1672	3601284000000	22829	11417	1	0	\N
342052	1874	21683000	22829	11417	2	0	\N
342053	1874	21685000	22829	11417	3	0	\N
342062	1678	24480780665000	22832	11418	0	0	\N
342063	1874	21687000	22832	11418	1	0	\N
342064	1874	21688000	22832	11418	2	0	\N
342065	1874	21691000	22832	11418	3	0	\N
342069	1678	24480780666000	22834	11419	0	0	\N
342070	1874	21694000	22834	11419	1	0	\N
342071	1874	21696000	22834	11419	2	0	\N
342072	1678	24480780666000	22835	11419	0	0	\N
342073	1874	21694000	22835	11419	1	0	\N
342074	1874	21696000	22835	11419	2	0	\N
342075	1678	24480780667000	22836	11420	0	0	\N
342076	1874	21699000	22836	11420	1	0	\N
342090	1678	24480780670000	22840	11422	0	0	\N
342091	1874	21714000	22840	11422	1	0	\N
342092	1874	21717000	22840	11422	2	0	\N
342096	2300	59000000000	22845	11424	0	0	\N
342097	1678	24480780672000	22845	11424	1	0	\N
342098	1874	21723000	22845	11424	2	0	\N
342099	1874	21726000	22845	11424	3	0	\N
342108	1678	24480780674000	22848	11426	0	0	\N
342109	1874	21736000	22848	11426	1	0	\N
342110	1874	21738000	22848	11426	2	0	\N
342111	1678	24480780674000	22849	11426	0	0	\N
342112	1874	21736000	22849	11426	1	0	\N
342113	1874	21738000	22849	11426	2	0	\N
342117	1678	24480780674000	22851	11426	0	0	\N
342118	1874	21736000	22851	11426	1	0	\N
342119	1874	21738000	22851	11426	2	0	\N
342120	1874	21701000	22853	11422	0	0	\N
342121	1678	24480780675000	22854	11427	0	0	\N
342122	2300	2159000000000	22854	11427	1	0	\N
342123	1874	21739000	22854	11427	2	0	\N
342124	1874	21742000	22854	11427	3	0	\N
342125	1874	21744000	22854	11427	4	0	\N
342126	1678	24480780675000	22855	11427	0	0	\N
342127	2300	2159000000000	22855	11427	1	0	\N
342128	1874	21739000	22855	11427	2	0	\N
342129	1874	21742000	22855	11427	3	0	\N
342130	1874	21744000	22855	11427	4	0	\N
342140	2301	719000000000	22858	11428	0	0	\N
342141	1678	24480780676000	22858	11428	1	0	\N
342142	1874	21743000	22858	11428	2	0	\N
342143	1874	21746000	22858	11428	3	0	\N
342144	1874	21749000	22858	11428	4	0	\N
342145	2301	719000000000	22859	11428	0	0	\N
342146	1678	24480780676000	22859	11428	1	0	\N
342147	1874	21743000	22859	11428	2	0	\N
342148	1874	21746000	22859	11428	3	0	\N
342149	1874	21749000	22859	11428	4	0	\N
342150	2301	719000000000	22860	11428	0	0	\N
342151	1678	24480780676000	22860	11428	1	0	\N
342152	1874	21743000	22860	11428	2	0	\N
342153	1874	21746000	22860	11428	3	0	\N
342158	1678	24480780677000	22862	11429	0	0	\N
342159	1874	21751000	22862	11429	1	0	\N
342160	1672	3601284000000	22862	11429	2	0	\N
342161	1874	21754000	22862	11429	3	0	\N
342162	1678	24480780677000	22863	11429	0	0	\N
342163	1874	21751000	22863	11429	1	0	\N
342164	1672	3601284000000	22863	11429	2	0	\N
342165	1874	21754000	22863	11429	3	0	\N
342166	1678	24480780678000	22864	11430	0	0	\N
342167	1874	21755000	22864	11430	1	0	\N
342168	1874	21758000	22864	11430	2	0	\N
342169	2302	1439000000000	22864	11430	3	0	\N
342170	1874	21760000	22864	11430	4	0	\N
342176	1678	24480780679000	22866	11431	0	0	\N
342049	1874	21680000	22828	11416	2	0	2
342054	1678	24480780664000	22830	11417	0	0	0
342055	1672	3601284000000	22830	11417	1	0	10
342056	1874	21683000	22830	11417	2	0	2
342057	1874	21685000	22830	11417	3	0	2
342059	1874	21687000	22831	11418	1	0	2
342060	1874	21688000	22831	11418	2	0	2
342061	1874	21691000	22831	11418	3	0	2
342066	1678	24480780666000	22833	11419	0	0	0
342067	1874	21694000	22833	11419	1	0	2
342077	1678	24480780667000	22837	11420	0	0	0
342078	1874	21699000	22837	11420	1	0	2
342079	1874	21701000	22837	11420	2	0	2
342080	1678	24480780668000	22838	11421	0	0	0
342082	1874	21703000	22838	11421	2	0	2
342083	1874	21705000	22838	11421	3	0	2
342084	1874	21708000	22838	11421	4	0	2
342085	1874	21711000	22838	11421	5	0	2
342086	1874	21712000	22838	11421	6	0	2
342088	1874	21714000	22839	11422	1	0	2
342089	1874	21717000	22839	11422	2	0	2
342093	1678	24480780671000	22844	11423	0	0	0
342094	1874	21719000	22844	11423	1	0	2
342095	1874	21722000	22844	11423	2	0	2
342101	1678	24480780672000	22846	11424	1	0	0
342102	1874	21723000	22846	11424	2	0	2
342103	1874	21725000	22846	11424	3	0	2
342104	1874	21728000	22846	11424	4	0	2
342106	1874	21731000	22847	11425	1	0	2
342107	1874	21733000	22847	11425	2	0	2
342114	1678	24480780674000	22850	11426	0	0	0
342115	1874	21736000	22850	11426	1	0	2
342116	1874	21738000	22850	11426	2	0	2
342132	2300	2159000000000	22856	11427	1	0	0
342133	1874	21739000	22856	11427	2	0	2
342134	1874	21741000	22856	11427	3	0	2
342135	2301	719000000000	22857	11428	0	0	0
342136	1678	24480780676000	22857	11428	1	0	0
342138	1874	21746000	22857	11428	3	0	2
342139	1874	21749000	22857	11428	4	0	2
342154	1678	24480780677000	22861	11429	0	0	0
342155	1874	21751000	22861	11429	1	0	2
342157	1874	21754000	22861	11429	3	0	2
342171	1678	24480780678000	22865	11430	0	0	0
342172	1874	21755000	22865	11430	1	0	2
342173	1874	21758000	22865	11430	2	0	2
342174	2302	1439000000000	22865	11430	3	0	0
342177	1874	21763000	22866	11431	1	0	\N
342178	2303	719000000000	22866	11431	2	0	\N
342179	1874	21765000	22866	11431	3	0	\N
342180	1678	24480780679000	22867	11431	0	0	\N
342181	1874	21763000	22867	11431	1	0	\N
342182	2303	719000000000	22867	11431	2	0	\N
342183	1874	21765000	22867	11431	3	0	\N
342188	1678	24480780679000	22869	11431	0	0	\N
342189	1874	21763000	22869	11431	1	0	\N
342190	2303	719000000000	22869	11431	2	0	\N
342191	1874	21765000	22869	11431	3	0	\N
342192	1678	24480780679000	22870	11431	0	0	\N
342193	1678	24480780680000	22870	11431	1	0	\N
342194	1874	21763000	22870	11431	2	0	\N
342195	2303	719000000000	22870	11431	3	0	\N
342196	1874	21765000	22870	11431	4	0	\N
342214	1678	24480780683000	22875	11435	0	0	\N
342215	1678	24480780684000	22875	11435	1	0	\N
342216	1874	21784000	22875	11435	2	0	\N
342217	1874	21786000	22875	11435	3	0	\N
342218	1874	21789000	22875	11435	4	0	\N
342219	1874	21791000	22875	11435	5	0	\N
342220	1678	24480780685000	22876	11436	0	0	\N
342221	1874	21792000	22876	11436	1	0	\N
342222	1874	21795000	22876	11436	2	0	\N
342223	1874	21797000	22876	11436	3	0	\N
342224	1678	24480780685000	22877	11436	0	0	\N
342225	1874	21792000	22877	11436	1	0	\N
342226	1874	21795000	22877	11436	2	0	\N
342227	1874	21797000	22877	11436	3	0	\N
342228	1678	24480780685000	22878	11436	0	0	\N
342229	1874	21792000	22878	11436	1	0	\N
342230	1874	21795000	22878	11436	2	0	\N
342231	1874	21797000	22878	11436	3	0	\N
342236	1678	24480780685000	22880	11436	0	0	\N
342237	1874	21792000	22880	11436	1	0	\N
342238	1874	21795000	22880	11436	2	0	\N
342239	1874	21797000	22880	11436	3	0	\N
342255	1678	25200791689000	22885	11440	0	0	\N
342256	1678	25200791690000	22885	11440	1	0	\N
342257	1874	21813000	22885	11440	3	0	\N
342258	1874	21815000	22885	11440	4	0	\N
342259	1874	21818000	22885	11440	5	0	\N
342260	1874	21821000	22885	11440	6	0	\N
342264	1678	25200791692000	22887	11442	0	0	\N
342265	1874	21827000	22887	11442	1	0	\N
342266	1874	21830000	22887	11442	2	0	\N
342267	1874	21832000	22887	11442	3	0	\N
342268	1678	25200791692000	22888	11442	0	0	\N
342269	1874	21827000	22888	11442	1	0	\N
342270	1874	21830000	22888	11442	2	0	\N
342271	1874	21832000	22888	11442	3	0	\N
342276	1678	24480780679000	22890	11431	0	0	\N
342277	1678	24480780680000	22890	11431	1	0	\N
342278	1678	24480780681000	22890	11431	2	0	\N
342279	1678	24480780682000	22890	11431	3	0	\N
342280	1678	24480780683000	22890	11431	4	0	\N
342281	1678	24480780684000	22890	11431	5	0	\N
342282	1678	24480780685000	22890	11431	6	0	\N
342283	1678	24480780686000	22890	11431	7	0	\N
342284	1678	24480780687000	22890	11431	8	0	\N
342285	1678	24480780688000	22890	11431	9	0	\N
342286	1678	24480780689000	22890	11431	10	0	\N
342287	1678	24480780690000	22890	11431	11	0	\N
342288	1678	24480780691000	22890	11431	12	0	\N
342289	1678	24480780692000	22890	11431	13	0	\N
342290	1874	21763000	22890	11431	14	0	\N
342291	1874	21766000	22890	11431	15	0	\N
342292	2303	719000000000	22890	11431	16	0	\N
342293	2304	719000000000	22890	11431	17	0	\N
342294	1874	21768000	22890	11431	18	0	\N
342295	1874	21771000	22890	11431	19	0	\N
342296	1874	21774000	22890	11431	20	0	\N
342297	1874	21777000	22890	11431	21	0	\N
342298	1874	21780000	22890	11431	22	0	\N
342299	1874	21783000	22890	11431	23	0	\N
342300	1874	21786000	22890	11431	24	0	\N
342301	1874	21789000	22890	11431	25	0	\N
342302	1874	21792000	22890	11431	26	0	\N
342303	1874	21795000	22890	11431	27	0	\N
342304	1874	21796000	22890	11431	28	0	\N
342305	1874	21797000	22890	11431	29	0	\N
342306	1874	21798000	22890	11431	30	0	\N
342307	1874	21799000	22890	11431	31	0	\N
342308	1874	21801000	22890	11431	32	0	\N
342309	1874	21803000	22890	11431	33	0	\N
342310	1874	21805000	22890	11431	34	0	\N
342311	1874	21807000	22890	11431	35	0	\N
342312	1874	21810000	22890	11431	36	0	\N
342186	2303	719000000000	22868	11431	2	0	0
342187	1874	21765000	22868	11431	3	0	2
342197	1678	24480780680000	22871	11432	0	0	0
342198	1874	21768000	22871	11432	1	0	2
342199	1874	21770000	22871	11432	2	0	2
342201	1874	21772000	22872	11433	1	0	2
342202	1874	21775000	22872	11433	2	0	2
342203	1678	24480780682000	22873	11434	0	0	0
342204	2304	719000000000	22873	11434	1	0	0
342205	1874	21778000	22873	11434	2	0	2
342207	1874	21781000	22873	11434	4	0	2
342208	1678	24480780683000	22874	11435	0	0	0
342209	1678	24480780684000	22874	11435	1	0	0
342210	1874	21784000	22874	11435	2	0	2
342212	1874	21789000	22874	11435	4	0	2
342213	1874	21791000	22874	11435	5	0	2
342232	1678	24480780685000	22879	11436	0	0	0
342233	1874	21792000	22879	11436	1	0	2
342234	1874	21795000	22879	11436	2	0	2
342240	1678	24480780686000	22881	11437	0	0	0
342241	1874	21800000	22881	11437	1	0	2
342242	1678	25200791687000	22882	11438	0	0	0
342243	1874	21803000	22882	11438	1	0	2
342244	1874	21805000	22882	11438	2	0	2
342246	1874	21808000	22883	11439	1	0	2
342247	1874	21809000	22883	11439	2	0	2
342248	1874	21811000	22883	11439	3	0	2
342249	1678	25200791689000	22884	11440	0	0	0
342251	1874	21813000	22884	11440	3	0	2
342252	1874	21815000	22884	11440	4	0	2
342253	1874	21818000	22884	11440	5	0	2
342254	1874	21821000	22884	11440	6	0	2
342261	1678	25200791691000	22886	11441	0	0	0
342263	1874	21826000	22886	11441	2	0	2
342272	1678	25200791692000	22889	11442	0	0	0
342273	1874	21827000	22889	11442	1	0	2
342274	1874	21830000	22889	11442	2	0	2
342275	1874	21832000	22889	11442	3	0	2
342313	1874	21813000	22890	11431	37	0	\N
342314	1874	21816000	22890	11431	38	0	\N
342315	1874	21818000	22890	11431	39	0	\N
342316	1874	21820000	22890	11431	40	0	\N
342317	1874	21822000	22890	11431	41	0	\N
342318	1874	21824000	22890	11431	42	0	\N
342319	1874	21826000	22890	11431	43	0	\N
342320	1874	21828000	22890	11431	44	0	\N
342321	1874	21830000	22890	11431	45	0	\N
342322	1874	21832000	22890	11431	46	0	\N
342323	1678	25200791693000	22891	11443	0	0	\N
342324	1874	21835000	22891	11443	1	0	\N
342325	1874	21837000	22891	11443	2	0	\N
342329	1678	25200791693000	22893	11443	0	0	\N
342330	1874	21834000	22893	11443	1	0	\N
342331	1678	25200791694000	22894	11444	0	0	\N
342332	1874	21839000	22894	11444	1	0	\N
342333	1874	21842000	22894	11444	2	0	\N
342337	1678	25200791695000	22896	11445	0	0	\N
342338	1874	21845000	22896	11445	1	0	\N
342339	1874	21847000	22896	11445	2	0	\N
342340	1874	21848000	22896	11445	3	0	\N
342345	1678	25200791696000	22898	11446	0	0	\N
342346	1874	21851000	22898	11446	1	0	\N
342347	1874	21853000	22898	11446	2	0	\N
342351	1678	25200791697000	22900	11447	0	0	\N
342352	1874	21856000	22900	11447	1	0	\N
342353	1874	21858000	22900	11447	2	0	\N
342357	1678	25200791697000	22902	11447	0	0	\N
342358	1874	21856000	22902	11447	1	0	\N
342359	1874	21858000	22902	11447	2	0	\N
342360	1874	21835000	22903	11432	0	0	\N
342361	1874	21836000	22903	11432	1	0	\N
342362	1874	21837000	22903	11432	2	0	\N
342363	1874	21840000	22903	11432	3	0	\N
342364	1874	21843000	22903	11432	4	0	\N
342365	1874	21846000	22903	11432	6	0	\N
342366	1874	21849000	22903	11432	7	0	\N
342367	1874	21852000	22903	11432	8	0	\N
342372	1678	25200791699000	22905	11449	0	0	\N
342373	1874	21866000	22905	11449	1	0	\N
342374	1874	21869000	22905	11449	2	0	\N
342393	1678	25200791700000	22908	11450	0	0	\N
342394	1678	25200791701000	22908	11450	1	0	\N
342395	1678	25200791702000	22908	11450	2	0	\N
342396	715	2015703046640	22908	11450	3	0	\N
342397	1874	21870000	22908	11450	4	0	\N
342398	1874	21873000	22908	11450	5	0	\N
342399	1874	21876000	22908	11450	6	0	\N
342400	1874	21879000	22908	11450	7	0	\N
342401	1345	1709321034299650	22908	11450	8	0	\N
342402	1099	909132525338000	22908	11450	9	0	\N
342403	1219	613409830595000	22908	11450	10	0	\N
342404	979	507330843835000	22908	11450	11	0	\N
342408	1678	25200791703000	22910	11451	0	0	\N
342409	1874	21888000	22910	11451	1	0	\N
342410	1874	21890000	22910	11451	2	0	\N
342414	1678	25200791704000	22912	11452	0	0	\N
342415	1874	21893000	22912	11452	1	0	\N
342416	1874	21895000	22912	11452	2	0	\N
342431	1678	25200791709000	22915	11455	0	0	\N
342432	1874	21919000	22915	11455	1	0	\N
342433	2297	8154338013959	22915	11455	2	0	\N
342434	1874	21922000	22915	11455	3	0	\N
342435	2297	8154338013959	22916	11455	0	0	\N
342436	1874	21920000	22916	11455	1	0	\N
342445	1678	25200791704000	22919	11452	0	0	\N
342446	1678	25200791705000	22919	11452	1	0	\N
342447	1678	25200791706000	22919	11452	2	0	\N
342448	1678	25200791707000	22919	11452	3	0	\N
342328	1874	21837000	22892	11443	2	0	2
342334	1678	25200791694000	22895	11444	0	0	0
342335	1874	21839000	22895	11444	1	0	2
342336	1874	21842000	22895	11444	2	0	2
342341	1678	25200791695000	22897	11445	0	0	0
342343	1874	21847000	22897	11445	2	0	2
342344	1874	21848000	22897	11445	3	0	2
342348	1678	25200791696000	22899	11446	0	0	0
342349	1874	21851000	22899	11446	1	0	2
342350	1874	21853000	22899	11446	2	0	2
342355	1874	21856000	22901	11447	1	0	2
342356	1874	21858000	22901	11447	2	0	2
342368	1678	25200791698000	22904	11448	0	0	0
342369	1874	21861000	22904	11448	1	0	2
342371	1874	21864000	22904	11448	3	0	2
342375	1678	25200791699000	22906	11449	0	0	0
342376	1874	21866000	22906	11449	1	0	2
342377	1874	21869000	22906	11449	2	0	2
342378	1678	25200791700000	22907	11450	0	0	0
342380	1678	25200791702000	22907	11450	2	0	0
342381	715	2015703046640	22907	11450	3	0	0
342382	1874	21871000	22907	11450	4	0	2
342383	1874	21873000	22907	11450	5	0	2
342384	1874	21875000	22907	11450	6	0	2
342386	1874	21879000	22907	11450	8	0	2
342387	1874	21882000	22907	11450	9	0	2
342388	1874	21885000	22907	11450	10	0	2
342389	1345	1709321034299650	22907	11450	11	0	0
342391	1219	613409830595000	22907	11450	13	0	0
342392	979	507330843835000	22907	11450	14	0	0
342405	1678	25200791703000	22909	11451	0	0	0
342406	1874	21888000	22909	11451	1	0	2
342407	1874	21890000	22909	11451	2	0	2
342412	1874	21893000	22911	11452	1	0	2
342413	1874	21895000	22911	11452	2	0	2
342417	1678	25200791705000	22913	11453	0	0	0
342418	1678	25200791706000	22913	11453	1	0	0
342419	1678	25200791707000	22913	11453	2	0	0
342421	1874	21899000	22913	11453	4	0	2
342422	1874	21901000	22913	11453	5	0	2
342423	1874	21903000	22913	11453	6	0	2
342424	1874	21905000	22913	11453	7	0	2
342426	1874	21911000	22913	11453	9	0	2
342427	1678	25200791708000	22914	11454	0	0	0
342428	1874	21912000	22914	11454	1	0	2
342429	1874	21915000	22914	11454	2	0	2
342430	1874	21917000	22914	11454	3	0	2
342438	1874	21919000	22917	11455	1	0	2
342439	2297	8154338013959	22917	11455	2	0	1
342440	1874	21922000	22917	11455	3	0	2
342441	1678	25200791710000	22918	11456	0	0	0
342442	2297	9362107805640	22918	11456	1	0	1
342444	1874	21927000	22918	11456	3	0	2
342449	1678	25200791708000	22919	11452	4	0	\N
342450	1678	25200791709000	22919	11452	5	0	\N
342451	1678	25200791710000	22919	11452	6	0	\N
342452	1678	25200791711000	22919	11452	7	0	\N
342453	2297	8154338013959	22919	11452	8	0	\N
342454	1874	21893000	22919	11452	9	0	\N
342455	1647	20000000	22919	11452	10	0	\N
342456	1874	21894000	22919	11452	11	0	\N
342457	1874	21895000	22919	11452	12	0	\N
342458	1874	21898000	22919	11452	13	0	\N
342459	1874	21900000	22919	11452	14	0	\N
342460	1874	21902000	22919	11452	15	0	\N
342461	1874	21904000	22919	11452	16	0	\N
342462	1874	21906000	22919	11452	17	0	\N
342463	1874	21908000	22919	11452	18	0	\N
342464	1874	21910000	22919	11452	19	0	\N
342465	1874	21912000	22919	11452	20	0	\N
342466	1874	21914000	22919	11452	21	0	\N
342467	2297	9362106805640	22919	11452	22	0	\N
342468	1874	21917000	22919	11452	23	0	\N
342469	1874	21920000	22919	11452	24	0	\N
342470	1874	21923000	22919	11452	25	0	\N
342471	1874	21926000	22919	11452	26	0	\N
342472	1874	21929000	22919	11452	27	0	\N
342473	1874	21932000	22919	11452	28	0	\N
342474	1678	25200791711000	22920	11457	0	0	\N
342475	1874	21929000	22920	11457	1	0	\N
342476	1647	20000000	22920	11457	2	0	\N
342477	1874	21932000	22920	11457	3	0	\N
342482	1678	25200791712000	22922	11453	0	0	\N
342483	1874	21934000	22922	11453	1	0	\N
342484	1874	21937000	22922	11453	2	0	\N
342485	1874	21938000	22922	11453	3	0	\N
342486	1678	25200791712000	22923	11458	0	0	\N
342487	1874	21935000	22923	11458	1	0	\N
342488	1874	21936000	22923	11458	2	0	\N
342489	1678	25200791712000	22924	11458	0	0	\N
342490	1874	21934000	22924	11458	1	0	\N
342491	1874	21937000	22924	11458	2	0	\N
342492	1874	21938000	22924	11458	3	0	\N
342493	1678	25200791712000	22925	11458	0	0	\N
342494	1874	21934000	22925	11458	1	0	\N
342495	1874	21937000	22925	11458	2	0	\N
342496	1874	21938000	22925	11458	3	0	\N
342504	2301	719000000000	22928	11402	0	0	\N
342505	2300	59000000000	22928	11402	1	0	\N
342506	2300	2159000000000	22928	11402	2	0	\N
342507	2297	8154338013959	22928	11402	3	0	\N
342508	2303	719000000000	22928	11402	4	0	\N
342509	715	2015703046640	22928	11402	5	0	\N
342510	2304	719000000000	22928	11402	6	0	\N
342511	1647	20000000	22928	11402	7	0	\N
342512	1672	3601284000000	22928	11402	8	0	\N
342513	1874	21573000	22928	11402	9	0	\N
342514	1874	21576000	22928	11402	10	0	\N
342515	1672	3601284000000	22928	11402	11	0	\N
342516	1874	21579000	22928	11402	12	0	\N
342517	1874	21581000	22928	11402	13	0	\N
342518	2297	9362106805640	22928	11402	14	0	\N
342519	2302	1439000000000	22928	11402	15	0	\N
342520	1345	1709321034299650	22928	11402	16	0	\N
342521	1099	909132525338000	22928	11402	17	0	\N
342522	1219	613409830595000	22928	11402	18	0	\N
342523	979	507330843835000	22928	11402	19	0	\N
342524	1678	25200791697000	22929	11447	0	0	\N
342525	1678	25200791698000	22929	11447	1	0	\N
342526	1678	25200791699000	22929	11447	2	0	\N
342527	1678	25200791700000	22929	11447	3	0	\N
342528	1678	25200791701000	22929	11447	4	0	\N
342529	1678	25200791702000	22929	11447	5	0	\N
342530	1678	25200791703000	22929	11447	6	0	\N
342531	1678	25200791704000	22929	11447	7	0	\N
342532	1678	25200791705000	22929	11447	8	0	\N
342533	1678	25200791706000	22929	11447	9	0	\N
342534	1678	25200791707000	22929	11447	10	0	\N
342535	1678	25200791708000	22929	11447	11	0	\N
342536	1678	25200791709000	22929	11447	12	0	\N
342537	1678	25200791710000	22929	11447	13	0	\N
342538	1678	25200791711000	22929	11447	14	0	\N
342539	1678	25200791712000	22929	11447	15	0	\N
342540	1678	25200791713000	22929	11447	16	0	\N
342541	2297	8154338013959	22929	11447	17	0	\N
342542	715	2015703046640	22929	11447	18	0	\N
342543	1874	21856000	22929	11447	19	0	\N
342544	1874	21859000	22929	11447	20	0	\N
342545	1647	20000000	22929	11447	21	0	\N
342546	1874	21860000	22929	11447	22	0	\N
342547	1874	21861000	22929	11447	23	0	\N
342548	1874	21862000	22929	11447	24	0	\N
342549	1874	21863000	22929	11447	25	0	\N
342550	1874	21864000	22929	11447	26	0	\N
342551	1874	21867000	22929	11447	27	0	\N
342552	1874	21870000	22929	11447	28	0	\N
342553	1874	21873000	22929	11447	29	0	\N
342554	1874	21876000	22929	11447	30	0	\N
342555	1874	21879000	22929	11447	31	0	\N
342556	1874	21882000	22929	11447	32	0	\N
342557	1874	21885000	22929	11447	33	0	\N
342558	1874	21887000	22929	11447	34	0	\N
342559	2297	9362106805640	22929	11447	35	0	\N
342560	1345	1709321034299650	22929	11447	36	0	\N
342561	1099	909132525338000	22929	11447	37	0	\N
342562	1219	613409830595000	22929	11447	38	0	\N
342563	979	507330843835000	22929	11447	39	0	\N
342564	1874	21890000	22929	11447	40	0	\N
342565	1874	21893000	22929	11447	41	0	\N
342566	1874	21896000	22929	11447	42	0	\N
342567	1874	21899000	22929	11447	43	0	\N
342568	1874	21902000	22929	11447	44	0	\N
342569	1874	21905000	22929	11447	45	0	\N
342570	1874	21908000	22929	11447	46	0	\N
342571	1874	21910000	22929	11447	47	0	\N
342572	1874	21912000	22929	11447	48	0	\N
342573	1874	21914000	22929	11447	49	0	\N
342574	1874	21916000	22929	11447	50	0	\N
342575	1874	21918000	22929	11447	51	0	\N
342576	1874	21920000	22929	11447	52	0	\N
342577	1874	21922000	22929	11447	53	0	\N
342578	1874	21924000	22929	11447	54	0	\N
342579	1874	21926000	22929	11447	55	0	\N
342580	1874	21928000	22929	11447	56	0	\N
342581	1874	21930000	22929	11447	57	0	\N
342582	1874	21932000	22929	11447	58	0	\N
342583	1874	21934000	22929	11447	59	0	\N
342584	1874	21936000	22929	11447	60	0	\N
342480	1647	20000000	22921	11457	2	0	0
342481	1874	21932000	22921	11457	3	0	2
342497	1678	25200791712000	22926	11458	0	0	0
342498	1874	21934000	22926	11458	1	0	2
342499	1874	21937000	22926	11458	2	0	2
342501	1678	25200791713000	22927	11459	0	0	0
342502	1874	21941000	22927	11459	1	0	2
342503	1874	21943000	22927	11459	2	0	2
342585	1874	21938000	22929	11447	61	0	\N
342586	1874	21940000	22929	11447	62	0	\N
342590	1678	25200791714000	22931	11460	0	0	\N
342591	1678	25200791714000	22933	11460	0	0	\N
342592	1874	21946000	22933	11460	1	0	\N
342593	1874	21948000	22933	11460	2	0	\N
342598	1678	25200791715000	22935	11461	0	0	\N
342599	1874	21951000	22935	11461	1	0	\N
342600	1874	21952000	22935	11461	2	0	\N
342601	1874	21954000	22935	11461	3	0	\N
342602	1678	25200791715000	22936	11461	0	0	\N
342603	1874	21951000	22936	11461	1	0	\N
342604	1874	21952000	22936	11461	2	0	\N
342605	1874	21954000	22936	11461	3	0	\N
342606	1678	25200791715000	22937	11461	0	0	\N
342607	1874	21951000	22937	11461	1	0	\N
342608	1874	21952000	22937	11461	2	0	\N
342609	1874	21954000	22937	11461	3	0	\N
342613	1678	25200791716000	22939	11462	0	0	\N
342614	1874	21957000	22939	11462	1	0	\N
342615	1874	21959000	22939	11462	2	0	\N
342619	1678	25200791691000	22941	11441	0	0	\N
342620	1678	25200791692000	22941	11441	1	0	\N
342621	1678	25200791693000	22941	11441	2	0	\N
342622	1678	25200791694000	22941	11441	3	0	\N
342623	1678	25200791695000	22941	11441	4	0	\N
342624	1678	25200791696000	22941	11441	5	0	\N
342625	1678	25200791697000	22941	11441	6	0	\N
342626	1678	25200791698000	22941	11441	7	0	\N
342627	1678	25200791699000	22941	11441	8	0	\N
342628	1678	25200791700000	22941	11441	9	0	\N
342629	1678	25200791701000	22941	11441	10	0	\N
342630	1678	25200791702000	22941	11441	11	0	\N
342631	1678	25200791703000	22941	11441	12	0	\N
342632	1678	25200791704000	22941	11441	13	0	\N
342633	1678	25200791705000	22941	11441	14	0	\N
342634	1678	25200791706000	22941	11441	15	0	\N
342635	1678	25200791707000	22941	11441	16	0	\N
342636	1678	25200791708000	22941	11441	17	0	\N
342637	1678	25200791709000	22941	11441	18	0	\N
342638	1678	25200791710000	22941	11441	19	0	\N
342639	1678	25200791711000	22941	11441	20	0	\N
342640	1678	25200791712000	22941	11441	21	0	\N
342641	1678	25200791713000	22941	11441	22	0	\N
342642	1678	25200791714000	22941	11441	23	0	\N
342643	1678	25200791715000	22941	11441	24	0	\N
342644	1678	25200791716000	22941	11441	25	0	\N
342645	1678	25200791717000	22941	11441	26	0	\N
342646	2297	8154338013959	22941	11441	27	0	\N
342647	715	2015703046640	22941	11441	28	0	\N
342648	1647	20000000	22941	11441	29	0	\N
342649	1874	21822000	22941	11441	30	0	\N
342650	1874	21823000	22941	11441	31	0	\N
342651	1874	21824000	22941	11441	32	0	\N
342652	1874	21825000	22941	11441	33	0	\N
342653	1874	21826000	22941	11441	34	0	\N
342654	1874	21827000	22941	11441	35	0	\N
342655	1874	21828000	22941	11441	36	0	\N
342656	1874	21829000	22941	11441	37	0	\N
342657	2297	9362106805640	22941	11441	38	0	\N
342658	1874	21832000	22941	11441	39	0	\N
342659	1874	21835000	22941	11441	40	0	\N
342660	1874	21838000	22941	11441	41	0	\N
342661	1874	21841000	22941	11441	42	0	\N
342662	1874	21844000	22941	11441	43	0	\N
342663	1874	21847000	22941	11441	44	0	\N
342664	1874	21850000	22941	11441	45	0	\N
342665	1874	21853000	22941	11441	46	0	\N
342666	1874	21856000	22941	11441	47	0	\N
342667	1874	21859000	22941	11441	48	0	\N
342668	1874	21862000	22941	11441	49	0	\N
342669	1874	21865000	22941	11441	50	0	\N
342670	1874	21868000	22941	11441	51	0	\N
342671	1874	21871000	22941	11441	52	0	\N
342672	1874	21874000	22941	11441	53	0	\N
342673	1345	1709321034299650	22941	11441	54	0	\N
342674	1099	909132525338000	22941	11441	55	0	\N
342675	1219	613409830595000	22941	11441	56	0	\N
342676	979	507330843835000	22941	11441	57	0	\N
342677	1874	21877000	22941	11441	58	0	\N
342678	1874	21880000	22941	11441	59	0	\N
342679	1874	21883000	22941	11441	60	0	\N
342680	1874	21886000	22941	11441	61	0	\N
342681	1874	21889000	22941	11441	62	0	\N
342682	1874	21892000	22941	11441	63	0	\N
342683	1874	21895000	22941	11441	64	0	\N
342684	1874	21898000	22941	11441	65	0	\N
342685	1874	21901000	22941	11441	66	0	\N
342686	1874	21904000	22941	11441	67	0	\N
342687	1874	21907000	22941	11441	68	0	\N
342688	1874	21910000	22941	11441	69	0	\N
342689	1874	21912000	22941	11441	70	0	\N
342690	1874	21914000	22941	11441	71	0	\N
342691	1874	21916000	22941	11441	72	0	\N
342692	1874	21918000	22941	11441	73	0	\N
342693	1874	21920000	22941	11441	74	0	\N
342694	1874	21922000	22941	11441	75	0	\N
342695	1874	21924000	22941	11441	76	0	\N
342696	1874	21926000	22941	11441	77	0	\N
342697	1874	21928000	22941	11441	78	0	\N
342698	1874	21930000	22941	11441	79	0	\N
342699	1874	21932000	22941	11441	80	0	\N
342700	1874	21934000	22941	11441	81	0	\N
342701	1874	21936000	22941	11441	82	0	\N
342702	1874	21938000	22941	11441	83	0	\N
342703	1874	21940000	22941	11441	84	0	\N
342704	1874	21942000	22941	11441	85	0	\N
342705	1874	21944000	22941	11441	86	0	\N
342706	1874	21946000	22941	11441	87	0	\N
342707	1874	21948000	22941	11441	88	0	\N
342708	1874	21950000	22941	11441	89	0	\N
342709	1874	21952000	22941	11441	90	0	\N
342710	1874	21954000	22941	11441	91	0	\N
342711	1874	21956000	22941	11441	92	0	\N
342712	1874	21958000	22941	11441	93	0	\N
342713	1874	21960000	22941	11441	94	0	\N
342714	1874	21962000	22941	11441	95	0	\N
342715	1874	21964000	22941	11441	96	0	\N
342716	1678	25200791718000	22942	11464	0	0	\N
342717	1678	25200791719000	22942	11464	1	0	\N
342718	1874	21967000	22942	11464	2	0	\N
342719	1874	21969000	22942	11464	3	0	\N
342720	1874	21971000	22942	11464	4	0	\N
342589	1874	21948000	22930	11460	2	0	2
342594	1678	25200791715000	22934	11461	0	0	0
342595	1874	21951000	22934	11461	1	0	2
342596	1874	21952000	22934	11461	2	0	2
342597	1874	21954000	22934	11461	3	0	2
342611	1874	21957000	22938	11462	1	0	2
342612	1874	21959000	22938	11462	2	0	2
342616	1678	25200791717000	22940	11463	0	0	0
342617	1874	21962000	22940	11463	1	0	2
342618	1874	21964000	22940	11463	2	0	2
342721	971	506944567057213	22942	11464	5	0	\N
342722	1874	21974000	22942	11464	6	0	\N
342723	1874	21975000	22942	11464	7	0	\N
342730	1678	25200791718000	22944	11465	0	0	\N
342731	1678	25200791719000	22944	11465	1	0	\N
342732	1678	25200791720000	22944	11465	2	0	\N
342733	1678	25200791721000	22944	11465	3	0	\N
342734	1678	25200791722000	22944	11465	4	0	\N
342735	1874	21976000	22944	11465	5	0	\N
342736	1874	21978000	22944	11465	6	0	\N
342737	1874	21980000	22944	11465	7	0	\N
342738	1874	21982000	22944	11465	8	0	\N
342739	1391	1712412932951650	22944	11465	9	0	\N
342740	1145	910777100200000	22944	11465	10	0	\N
342741	1874	21985000	22944	11465	11	0	\N
342742	1874	21988000	22944	11465	12	0	\N
342743	1874	21991000	22944	11465	13	0	\N
342744	1265	614519166800000	22944	11465	14	0	\N
342745	1025	508248407000000	22944	11465	15	0	\N
342762	1678	25200791723000	22946	11466	0	0	\N
342763	1874	21994000	22946	11466	1	0	\N
342764	1874	21996000	22946	11466	2	0	\N
342765	1678	25200791723000	22947	11466	0	0	\N
342766	1874	21994000	22947	11466	1	0	\N
342767	1874	21996000	22947	11466	2	0	\N
342771	1678	25200791723000	22949	11466	0	0	\N
342772	1874	21994000	22949	11466	1	0	\N
342773	1874	21996000	22949	11466	2	0	\N
342774	1651	355693450231	22950	11334	0	0	\N
342775	2301	719000000000	22950	11334	1	0	\N
342776	1024	506483472011067	22950	11334	2	0	\N
342777	1264	612385279822721	22950	11334	3	0	\N
342778	1144	907614042293421	22950	11334	4	0	\N
342779	2300	59000000000	22950	11334	5	0	\N
342780	2300	2159000000000	22950	11334	6	0	\N
342781	1678	24480780545000	22950	11334	7	0	\N
342782	1678	24480780546000	22950	11334	8	0	\N
342783	1678	24480780547000	22950	11334	9	0	\N
342784	1678	24480780548000	22950	11334	10	0	\N
342785	1678	24480780549000	22950	11334	11	0	\N
342786	1390	1706466032489164	22950	11334	12	0	\N
342787	1678	24480780550000	22950	11334	13	0	\N
342788	1678	24480780551000	22950	11334	14	0	\N
342789	1678	24480780552000	22950	11334	15	0	\N
342790	1678	24480780553000	22950	11334	16	0	\N
342791	1678	24480780554000	22950	11334	17	0	\N
342792	1678	24480780555000	22950	11334	18	0	\N
342793	1678	24480780556000	22950	11334	19	0	\N
342794	1678	24480780557000	22950	11334	20	0	\N
342795	1678	24480780558000	22950	11334	21	0	\N
342796	1678	24480780559000	22950	11334	22	0	\N
342797	1678	24480780560000	22950	11334	23	0	\N
342798	1678	24480780561000	22950	11334	24	0	\N
342799	1678	24480780562000	22950	11334	25	0	\N
342800	1678	24480780563000	22950	11334	26	0	\N
342801	1678	24480780564000	22950	11334	27	0	\N
342802	1678	24480780565000	22950	11334	28	0	\N
342803	1678	24480780566000	22950	11334	29	0	\N
342804	1678	24480780567000	22950	11334	30	0	\N
342805	1678	24480780568000	22950	11334	31	0	\N
342806	1678	24480780569000	22950	11334	32	0	\N
342807	1678	24480780570000	22950	11334	33	0	\N
342808	1678	24480780571000	22950	11334	34	0	\N
342809	1678	24480780572000	22950	11334	35	0	\N
342810	1678	24480780573000	22950	11334	36	0	\N
342811	1678	24480780574000	22950	11334	37	0	\N
342812	1678	24480780575000	22950	11334	38	0	\N
342813	1678	24480780576000	22950	11334	39	0	\N
342814	1678	24480780577000	22950	11334	40	0	\N
342815	1678	24480780578000	22950	11334	41	0	\N
342816	1678	24480780579000	22950	11334	42	0	\N
342817	1678	24480780580000	22950	11334	43	0	\N
342818	1678	24480780581000	22950	11334	44	0	\N
342819	1678	24480780582000	22950	11334	45	0	\N
342820	1678	24480780583000	22950	11334	46	0	\N
342821	1678	24480780584000	22950	11334	47	0	\N
342822	1678	24480780585000	22950	11334	49	0	\N
342823	1678	24480780586000	22950	11334	50	0	\N
342824	1678	24480780587000	22950	11334	51	0	\N
342825	1678	24480780588000	22950	11334	52	0	\N
342826	1678	24480780589000	22950	11334	53	0	\N
342827	1678	24480780590000	22950	11334	54	0	\N
342828	1678	24480780591000	22950	11334	55	0	\N
342829	1678	24480780592000	22950	11334	56	0	\N
342830	1678	24480780593000	22950	11334	57	0	\N
342831	1678	24480780594000	22950	11334	58	0	\N
342832	1678	24480780595000	22950	11334	59	0	\N
342833	1678	24480780596000	22950	11334	60	0	\N
342834	1678	24480780597000	22950	11334	61	0	\N
342835	1678	24480780598000	22950	11334	62	0	\N
342836	1678	24480780599000	22950	11334	63	0	\N
342837	1678	24480780600000	22950	11334	64	0	\N
342838	1678	24480780601000	22950	11334	65	0	\N
342839	1678	24480780602000	22950	11334	66	0	\N
342840	1678	24480780603000	22950	11334	67	0	\N
342841	1678	24480780604000	22950	11334	68	0	\N
342842	1678	24480780605000	22950	11334	69	0	\N
342843	1678	24480780606000	22950	11334	70	0	\N
342844	1678	24480780607000	22950	11334	71	0	\N
342845	1678	24480780608000	22950	11334	72	0	\N
342846	1678	24480780609000	22950	11334	73	0	\N
342847	1678	24480780610000	22950	11334	74	0	\N
342848	1678	24480780611000	22950	11334	75	0	\N
342849	1678	24480780612000	22950	11334	76	0	\N
342850	1678	24480780613000	22950	11334	77	0	\N
342851	1678	24480780614000	22950	11334	78	0	\N
342852	1678	24480780615000	22950	11334	79	0	\N
342853	1678	24480780616000	22950	11334	80	0	\N
342854	1678	24480780617000	22950	11334	81	0	\N
342855	1678	24480780618000	22950	11334	82	0	\N
342856	1678	24480780619000	22950	11334	83	0	\N
342726	1874	21971000	22943	11464	2	0	2
342727	971	506944567057213	22943	11464	3	0	0
342728	1874	21974000	22943	11464	4	0	2
342729	1874	21975000	22943	11464	5	0	2
342746	1678	25200791718000	22945	11465	0	0	0
342748	1678	25200791720000	22945	11465	2	0	0
342749	1678	25200791721000	22945	11465	3	0	0
342750	1678	25200791722000	22945	11465	4	0	0
342751	1874	21976000	22945	11465	5	0	2
342752	1874	21978000	22945	11465	6	0	2
342754	1874	21982000	22945	11465	8	0	2
342755	1391	1712412932951650	22945	11465	9	0	0
342756	1145	910777100200000	22945	11465	10	0	0
342757	1874	21985000	22945	11465	11	0	2
342759	1874	21991000	22945	11465	13	0	2
342760	1265	614519166800000	22945	11465	14	0	0
342761	1025	508248407000000	22945	11465	15	0	0
342768	1678	25200791723000	22948	11466	0	0	0
342769	1874	21994000	22948	11466	1	0	2
342857	1678	24480780620000	22950	11334	84	0	\N
342858	1678	24480780621000	22950	11334	85	0	\N
342859	1678	24480780622000	22950	11334	86	0	\N
342860	1678	24480780623000	22950	11334	87	0	\N
342861	1678	24480780624000	22950	11334	88	0	\N
342862	1678	24480780625000	22950	11334	89	0	\N
342863	1678	24480780626000	22950	11334	90	0	\N
342864	1678	24480780627000	22950	11334	91	0	\N
342865	1678	24480780628000	22950	11334	92	0	\N
342866	1678	24480780629000	22950	11334	93	0	\N
342867	1678	24480780630000	22950	11334	94	0	\N
342868	1678	24480780631000	22950	11334	95	0	\N
342869	1678	24480780632000	22950	11334	96	0	\N
342870	1678	24480780633000	22950	11334	97	0	\N
342871	1678	24480780634000	22950	11334	98	0	\N
342872	1678	24480780635000	22950	11334	99	0	\N
342873	1678	24480780636000	22950	11334	100	0	\N
342874	1678	24480780637000	22950	11334	101	0	\N
342875	1678	24480780638000	22950	11334	102	0	\N
342876	1678	24480780639000	22950	11334	103	0	\N
342877	1678	24480780640000	22950	11334	104	0	\N
342878	1678	24480780641000	22950	11334	105	0	\N
342879	1678	24480780642000	22950	11334	106	0	\N
342880	1678	24480780643000	22950	11334	107	0	\N
342881	1678	24480780644000	22950	11334	108	0	\N
342882	1678	24480780645000	22950	11334	109	0	\N
342883	1678	24480780646000	22950	11334	110	0	\N
342884	1678	24480780647000	22950	11334	111	0	\N
342885	1678	24480780648000	22950	11334	112	0	\N
342886	1678	24480780649000	22950	11334	113	0	\N
342887	1678	24480780650000	22950	11334	114	0	\N
342888	1678	24480780651000	22950	11334	115	0	\N
342889	1678	24480780652000	22950	11334	116	0	\N
342890	1678	24480780653000	22950	11334	117	0	\N
342891	1678	24480780654000	22950	11334	118	0	\N
342892	1678	24480780655000	22950	11334	119	0	\N
342893	1678	24480780656000	22950	11334	120	0	\N
342894	1678	24480780657000	22950	11334	121	0	\N
342895	1678	24480780658000	22950	11334	122	0	\N
342896	1678	24480780659000	22950	11334	123	0	\N
342897	1678	24480780660000	22950	11334	124	0	\N
342898	1678	24480780661000	22950	11334	125	0	\N
342907	1678	25200791724000	22952	11467	0	0	\N
342908	1678	25200791725000	22952	11467	1	0	\N
342909	1874	21998000	22952	11467	2	0	\N
342910	1874	22000000	22952	11467	3	0	\N
342911	1874	22001000	22952	11467	4	0	\N
342912	1672	3601284000000	22952	11467	5	0	\N
342913	1874	22004000	22952	11467	6	0	\N
342914	1874	22007000	22952	11467	7	0	\N
342915	1678	25200791713000	22953	11454	0	0	\N
342916	1678	25200791714000	22953	11454	1	0	\N
342917	1678	25200791715000	22953	11454	2	0	\N
342918	1678	25200791716000	22953	11454	3	0	\N
342919	1678	25200791717000	22953	11454	4	0	\N
342920	1678	25200791718000	22953	11454	5	0	\N
342921	1678	25200791719000	22953	11454	6	0	\N
342922	1678	25200791720000	22953	11454	7	0	\N
342923	1678	25200791721000	22953	11454	8	0	\N
342924	1678	25200791722000	22953	11454	9	0	\N
342925	1678	25200791723000	22953	11454	10	0	\N
342926	1678	25200791724000	22953	11454	11	0	\N
342927	1678	25200791725000	22953	11454	12	0	\N
342928	1678	25200791726000	22953	11454	13	0	\N
342929	1874	21941000	22953	11454	15	0	\N
342930	1874	21944000	22953	11454	16	0	\N
342931	1874	21947000	22953	11454	17	0	\N
342932	1874	21948000	22953	11454	18	0	\N
342933	1672	3601284000000	22953	11454	19	0	\N
342934	1874	21950000	22953	11454	20	0	\N
342935	1874	21953000	22953	11454	21	0	\N
342936	1874	21956000	22953	11454	22	0	\N
342937	1874	21959000	22953	11454	23	0	\N
342938	971	506944567057213	22953	11454	24	0	\N
342939	1874	21962000	22953	11454	25	0	\N
342940	1874	21963000	22953	11454	26	0	\N
342941	1874	21964000	22953	11454	27	0	\N
342942	1874	21965000	22953	11454	28	0	\N
342943	1391	1712412932951650	22953	11454	29	0	\N
342944	1145	910777100200000	22953	11454	30	0	\N
342945	1874	21968000	22953	11454	31	0	\N
342946	1874	21971000	22953	11454	32	0	\N
342947	1874	21974000	22953	11454	33	0	\N
342948	1874	21977000	22953	11454	34	0	\N
342949	1265	614519166800000	22953	11454	35	0	\N
342950	1025	508248407000000	22953	11454	36	0	\N
342951	1874	21979000	22953	11454	37	0	\N
342952	1874	21981000	22953	11454	38	0	\N
342953	1874	21983000	22953	11454	39	0	\N
342954	1874	21985000	22953	11454	40	0	\N
342955	1874	21987000	22953	11454	41	0	\N
342956	1874	21989000	22953	11454	42	0	\N
342957	1874	21991000	22953	11454	43	0	\N
342958	1874	21993000	22953	11454	44	0	\N
342959	1874	21995000	22953	11454	45	0	\N
342960	1874	21997000	22953	11454	46	0	\N
342961	1874	21999000	22953	11454	47	0	\N
342962	1874	22001000	22953	11454	48	0	\N
342963	1874	22003000	22953	11454	49	0	\N
342964	1874	22006000	22953	11454	50	0	\N
342965	1874	22009000	22953	11454	51	0	\N
342966	1874	22012000	22953	11454	52	0	\N
342973	1678	25200791718000	22956	11442	0	0	\N
342974	1678	25200791719000	22956	11442	1	0	\N
342975	1678	25200791720000	22956	11442	2	0	\N
342976	1678	25200791721000	22956	11442	3	0	\N
342977	1678	25200791722000	22956	11442	4	0	\N
342978	1678	25200791723000	22956	11442	5	0	\N
342979	1678	25200791724000	22956	11442	6	0	\N
342980	1678	25200791725000	22956	11442	7	0	\N
342981	1678	25200791726000	22956	11442	8	0	\N
342982	1678	25200791727000	22956	11442	9	0	\N
342983	1672	3601284000000	22956	11442	10	0	\N
342984	1874	21967000	22956	11442	11	0	\N
342985	1874	21969000	22956	11442	12	0	\N
342986	1874	21971000	22956	11442	13	0	\N
342987	971	506944567057213	22956	11442	14	0	\N
342988	1874	21974000	22956	11442	15	0	\N
342989	1874	21975000	22956	11442	16	0	\N
342990	1874	21976000	22956	11442	17	0	\N
342991	1874	21977000	22956	11442	18	0	\N
342992	1874	21979000	22956	11442	19	0	\N
342901	1874	21998000	22951	11467	2	0	2
342902	1874	22000000	22951	11467	3	0	2
342903	1874	22001000	22951	11467	4	0	2
342904	1672	3601284000000	22951	11467	5	0	10
342905	1874	22004000	22951	11467	6	0	2
342967	1678	25200791726000	22954	11468	0	0	0
342968	1874	22009000	22954	11468	1	0	2
342969	1874	22012000	22954	11468	2	0	2
342970	1678	25200791727000	22955	11469	0	0	0
342971	1874	22014000	22955	11469	1	0	2
342993	1874	21981000	22956	11442	20	0	\N
342994	1874	21983000	22956	11442	21	0	\N
342995	1391	1712412932951650	22956	11442	23	0	\N
342996	1145	910777100200000	22956	11442	24	0	\N
342997	1874	21986000	22956	11442	25	0	\N
342998	1874	21989000	22956	11442	26	0	\N
342999	1874	21992000	22956	11442	27	0	\N
343000	1874	21995000	22956	11442	28	0	\N
343001	1265	614519166800000	22956	11442	29	0	\N
343002	1025	508248407000000	22956	11442	30	0	\N
343003	1874	21997000	22956	11442	31	0	\N
343004	1874	21999000	22956	11442	32	0	\N
343005	1874	22001000	22956	11442	33	0	\N
343006	1874	22003000	22956	11442	34	0	\N
343007	1874	22005000	22956	11442	35	0	\N
343008	1874	22008000	22956	11442	36	0	\N
343009	1874	22011000	22956	11442	37	0	\N
343010	1874	22014000	22956	11442	38	0	\N
343011	1874	22017000	22956	11442	39	0	\N
343031	1678	25200791733000	22958	11471	0	0	\N
343032	1874	22047000	22958	11471	1	0	\N
343033	485	68878999000000	22958	11471	2	0	\N
343034	1874	22049000	22958	11471	3	0	\N
343035	1678	25200791733000	22959	11471	0	0	\N
343036	1874	22047000	22959	11471	1	0	\N
343037	485	68878999000000	22959	11471	2	0	\N
343038	1874	22049000	22959	11471	3	0	\N
343043	1678	25200791734000	22961	11472	0	0	\N
343044	1874	22051000	22961	11472	1	0	\N
343045	1874	22054000	22961	11472	2	0	\N
343046	1678	25200791734000	22962	11472	0	0	\N
343047	1874	22051000	22962	11472	1	0	\N
343048	1874	22054000	22962	11472	2	0	\N
343052	1678	25200791734000	22964	11472	0	0	\N
343053	1874	22051000	22964	11472	1	0	\N
343054	1874	22054000	22964	11472	2	0	\N
343055	1874	22051000	22965	11472	0	0	\N
343056	1874	22054000	22965	11472	1	0	\N
343061	1678	25200791735000	22967	11473	0	0	\N
343062	1874	22056000	22967	11473	1	0	\N
343063	1874	22057000	22967	11473	2	0	\N
343070	1678	25200791738000	22969	11475	0	0	\N
343071	1874	22073000	22969	11475	1	0	\N
343072	1678	25200791738000	22970	11475	0	0	\N
343073	1874	22073000	22970	11475	1	0	\N
343074	1678	25200791738000	22971	11475	0	0	\N
343075	1874	22073000	22971	11475	1	0	\N
343082	1678	25200791739000	22974	11476	0	0	\N
343083	1874	22075000	22974	11476	1	0	\N
343084	1874	22076000	22974	11476	2	0	\N
343088	1678	25200791740000	22976	11477	0	0	\N
343089	1874	22081000	22976	11477	1	0	\N
343090	1678	25200791741000	22977	11478	0	0	\N
343091	1874	22086000	22977	11478	1	0	\N
343094	1678	25200791741000	22979	11478	0	0	\N
343095	1874	22086000	22979	11478	1	0	\N
343096	1678	24480780646000	22980	11402	0	0	\N
343097	2301	719000000000	22980	11402	1	0	\N
343098	2305	4000000000	22980	11402	2	0	\N
343099	1678	24480780647000	22980	11402	3	0	\N
343100	1678	24480780648000	22980	11402	4	0	\N
343101	1678	24480780649000	22980	11402	5	0	\N
343102	1678	24480780650000	22980	11402	6	0	\N
343103	2300	59000000000	22980	11402	7	0	\N
343104	2300	2159000000000	22980	11402	8	0	\N
343105	1678	24480780651000	22980	11402	9	0	\N
343106	1678	24480780652000	22980	11402	10	0	\N
343107	1678	24480780653000	22980	11402	11	0	\N
343108	1678	24480780654000	22980	11402	12	0	\N
343109	1678	24480780655000	22980	11402	13	0	\N
343110	1678	24480780656000	22980	11402	14	0	\N
343111	1678	24480780657000	22980	11402	15	0	\N
343112	1678	24480780658000	22980	11402	16	0	\N
343113	1678	24480780659000	22980	11402	17	0	\N
343114	1678	24480780660000	22980	11402	18	0	\N
343115	1678	24480780661000	22980	11402	19	0	\N
343116	1678	24480780662000	22980	11402	20	0	\N
343117	1678	24480780663000	22980	11402	21	0	\N
343118	1678	24480780664000	22980	11402	22	0	\N
343119	1678	24480780665000	22980	11402	23	0	\N
343120	1678	24480780666000	22980	11402	24	0	\N
343121	1678	24480780667000	22980	11402	25	0	\N
343122	1678	24480780668000	22980	11402	26	0	\N
343123	1678	24480780669000	22980	11402	27	0	\N
343124	1678	24480780670000	22980	11402	28	0	\N
343125	1678	24480780671000	22980	11402	29	0	\N
343126	1678	24480780672000	22980	11402	30	0	\N
343127	1678	24480780673000	22980	11402	31	0	\N
343128	1678	24480780674000	22980	11402	32	0	\N
343014	2305	4000000000	22957	11470	2	0	0
343015	1678	25200791730000	22957	11470	3	0	0
343016	1678	25200791731000	22957	11470	4	0	0
343017	1678	25200791732000	22957	11470	5	0	0
343018	1211	612942786305089	22957	11470	6	0	0
343020	1874	22019000	22957	11470	8	0	2
343021	1874	22021000	22957	11470	9	0	2
343022	1874	22023000	22957	11470	10	0	2
343023	1874	22025000	22957	11470	11	0	2
343024	1874	22027000	22957	11470	12	0	2
343026	1874	22032000	22957	11470	14	0	2
343027	1874	22035000	22957	11470	15	0	2
343028	1874	22038000	22957	11470	16	0	2
343029	1874	22041000	22957	11470	17	0	2
343039	1678	25200791733000	22960	11471	0	0	0
343040	1874	22047000	22960	11471	1	0	2
343041	485	68878999000000	22960	11471	2	0	1
343042	1874	22049000	22960	11471	3	0	2
343049	1678	25200791734000	22963	11472	0	0	0
343051	1874	22054000	22963	11472	2	0	2
343057	1678	25200791735000	22966	11473	0	0	0
343058	1874	22056000	22966	11473	1	0	2
343059	1874	22059000	22966	11473	2	0	2
343060	1874	22060000	22966	11473	3	0	2
343065	1678	25200791737000	22968	11474	1	0	0
343066	1874	22062000	22968	11474	2	0	2
343067	1874	22064000	22968	11474	3	0	2
343068	1874	22067000	22968	11474	4	0	2
343076	1678	25200791738000	22972	11475	0	0	0
343077	1874	22073000	22972	11475	1	0	2
343078	1678	25200791739000	22973	11476	0	0	0
343079	1874	22075000	22973	11476	1	0	2
343080	1874	22076000	22973	11476	2	0	2
343085	1678	25200791740000	22975	11477	0	0	0
343086	1874	22082000	22975	11477	1	0	2
343087	1874	22084000	22975	11477	2	0	2
343092	1678	25200791741000	22978	11478	0	0	0
343093	1874	22086000	22978	11478	1	0	2
343129	1678	24480780675000	22980	11402	33	0	\N
343130	1678	24480780676000	22980	11402	34	0	\N
343131	1678	24480780677000	22980	11402	35	0	\N
343132	1678	24480780678000	22980	11402	36	0	\N
343133	1678	24480780679000	22980	11402	37	0	\N
343134	1678	24480780680000	22980	11402	38	0	\N
343135	1678	24480780681000	22980	11402	39	0	\N
343136	1678	24480780682000	22980	11402	40	0	\N
343137	1678	24480780683000	22980	11402	41	0	\N
343138	1678	24480780684000	22980	11402	42	0	\N
343139	1678	24480780685000	22980	11402	43	0	\N
343140	1678	24480780686000	22980	11402	44	0	\N
343141	1678	24480780687000	22980	11402	45	0	\N
343142	1678	24480780688000	22980	11402	46	0	\N
343143	1678	24480780689000	22980	11402	47	0	\N
343144	1678	24480780690000	22980	11402	48	0	\N
343145	1678	24480780691000	22980	11402	49	0	\N
343146	1678	24480780692000	22980	11402	50	0	\N
343147	1678	24480780693000	22980	11402	51	0	\N
343148	1678	24480780694000	22980	11402	52	0	\N
343149	1678	24480780695000	22980	11402	53	0	\N
343150	1678	24480780696000	22980	11402	54	0	\N
343151	1678	24480780697000	22980	11402	55	0	\N
343152	1678	24480780698000	22980	11402	56	0	\N
343153	1678	24480780699000	22980	11402	57	0	\N
343154	1678	24480780700000	22980	11402	58	0	\N
343155	1678	24480780701000	22980	11402	59	0	\N
343156	1678	24480780702000	22980	11402	60	0	\N
343157	1678	24480780703000	22980	11402	61	0	\N
343158	1678	24480780704000	22980	11402	62	0	\N
343159	1678	24480780705000	22980	11402	63	0	\N
343160	1678	24480780706000	22980	11402	64	0	\N
343161	1678	24480780707000	22980	11402	65	0	\N
343162	1678	24480780708000	22980	11402	66	0	\N
343163	1678	24480780709000	22980	11402	67	0	\N
343164	1678	24480780710000	22980	11402	68	0	\N
343165	1678	24480780711000	22980	11402	69	0	\N
343166	1678	24480780712000	22980	11402	70	0	\N
343167	1678	24480780713000	22980	11402	71	0	\N
343168	1678	24480780714000	22980	11402	72	0	\N
343169	1678	24480780715000	22980	11402	73	0	\N
343170	1678	24480780716000	22980	11402	74	0	\N
343171	1678	24480780717000	22980	11402	75	0	\N
343172	1678	24480780718000	22980	11402	76	0	\N
343173	1678	24480780719000	22980	11402	77	0	\N
343174	1678	24480780720000	22980	11402	78	0	\N
343175	1678	24480780721000	22980	11402	79	0	\N
343176	1678	24480780722000	22980	11402	80	0	\N
343177	1678	24480780723000	22980	11402	81	0	\N
343178	1678	24480780724000	22980	11402	82	0	\N
343179	1678	24480780725000	22980	11402	83	0	\N
343180	1678	24480780726000	22980	11402	84	0	\N
343181	1678	24480780727000	22980	11402	85	0	\N
343182	1678	24480780728000	22980	11402	86	0	\N
343183	1678	24480780729000	22980	11402	87	0	\N
343184	1678	24480780730000	22980	11402	88	0	\N
343185	1678	24480780731000	22980	11402	89	0	\N
343186	1678	24480780732000	22980	11402	90	0	\N
343187	1678	24480780733000	22980	11402	91	0	\N
343188	1678	24480780734000	22980	11402	92	0	\N
343189	1678	24480780735000	22980	11402	93	0	\N
343190	1678	24480780736000	22980	11402	94	0	\N
343191	1678	24480780737000	22980	11402	95	0	\N
343192	1678	24480780738000	22980	11402	96	0	\N
343193	1678	24480780739000	22980	11402	97	0	\N
343194	1678	24480780740000	22980	11402	98	0	\N
343195	1678	24480780741000	22980	11402	99	0	\N
343196	2297	8154338013959	22980	11402	100	0	\N
343197	2303	719000000000	22980	11402	101	0	\N
343198	715	2015703046640	22980	11402	103	0	\N
343199	2304	719000000000	22980	11402	104	0	\N
343200	1647	20000000	22980	11402	105	0	\N
343201	1672	3601284000000	22980	11402	106	0	\N
343202	1672	3601284000000	22980	11402	107	0	\N
343203	1672	3601284000000	22980	11402	108	0	\N
343204	971	506944567057213	22980	11402	109	0	\N
343205	1211	612942786305089	22980	11402	110	0	\N
343206	1391	1712412932951650	22980	11402	111	0	\N
343207	1145	910777100200000	22980	11402	112	0	\N
343208	1265	614519166800000	22980	11402	113	0	\N
343209	1025	508248407000000	22980	11402	114	0	\N
343210	2297	9362106805640	22980	11402	115	0	\N
343211	2302	1439000000000	22980	11402	116	0	\N
343212	1345	1709321034299650	22980	11402	117	0	\N
343213	1099	909132525338000	22980	11402	118	0	\N
343214	1219	613409830595000	22980	11402	119	0	\N
343215	979	507330843835000	22980	11402	120	0	\N
343224	1678	25200791742000	22982	11479	0	0	\N
343225	1678	25200791743000	22982	11479	1	0	\N
343226	1678	25200791744000	22982	11479	2	0	\N
343227	1874	22088000	22982	11479	3	0	\N
343228	1874	22090000	22982	11479	4	0	\N
343229	1874	22091000	22982	11479	5	0	\N
343230	1874	22094000	22982	11479	6	0	\N
343231	1874	22096000	22982	11479	7	0	\N
343239	1678	25200791748000	22984	11481	0	0	\N
343240	1874	22103000	22984	11481	1	0	\N
343241	1874	22105000	22984	11481	2	0	\N
343242	1678	25200791745000	22985	11480	0	0	\N
343243	1678	25200791746000	22985	11480	1	0	\N
343244	1678	25200791747000	22985	11480	2	0	\N
343245	1678	25200791748000	22985	11480	3	0	\N
343246	1091	908440320665449	22985	11480	4	0	\N
343247	1874	22097000	22985	11480	5	0	\N
343248	1874	22099000	22985	11480	6	0	\N
343249	1874	22101000	22985	11480	7	0	\N
343250	1874	22103000	22985	11480	8	0	\N
343251	1874	22105000	22985	11480	9	0	\N
343254	1678	25200791748000	22987	11482	0	0	\N
343255	1678	25200791749000	22987	11482	1	0	\N
343256	1678	25200791750000	22987	11482	2	0	\N
343257	1874	22107000	22987	11482	3	0	\N
343258	1337	1708019573872989	22987	11482	4	0	\N
343259	1874	22109000	22987	11482	5	0	\N
343264	1678	25200791749000	22989	11483	0	0	\N
343218	1678	25200791744000	22981	11479	2	0	0
343219	1874	22088000	22981	11479	3	0	2
343220	1874	22090000	22981	11479	4	0	2
343221	1874	22091000	22981	11479	5	0	2
343222	1874	22094000	22981	11479	6	0	2
343232	1678	25200791745000	22983	11480	0	0	0
343233	1678	25200791746000	22983	11480	1	0	0
343234	1678	25200791747000	22983	11480	2	0	0
343235	1091	908440320665449	22983	11480	3	0	0
343236	1874	22098000	22983	11480	4	0	2
343238	1874	22102000	22983	11480	6	0	2
343252	1874	22103000	22986	11481	0	0	2
343253	1874	22105000	22986	11481	1	0	2
343260	1678	25200791748000	22988	11482	0	0	0
343262	1337	1708019573872989	22988	11482	2	0	0
343263	1874	22109000	22988	11482	3	0	2
343265	1678	25200791750000	22989	11483	1	0	\N
343266	1678	25200791751000	22989	11483	2	0	\N
343267	1874	22110000	22989	11483	3	0	\N
343268	1874	22112000	22989	11483	4	0	\N
343273	1678	25200791752000	22991	11484	0	0	\N
343274	1678	25200791753000	22991	11484	1	0	\N
343275	1874	22112000	22991	11484	2	0	\N
343276	1874	22114000	22991	11484	3	0	\N
343277	1874	22116000	22991	11484	4	0	\N
343310	1678	25200791762000	22997	11489	0	0	\N
343311	1874	22162000	22997	11489	1	0	\N
343312	1874	22164000	22997	11489	2	0	\N
343319	1678	25200791763000	23000	11490	0	0	\N
343320	1874	22167000	23000	11490	1	0	\N
343321	1874	22169000	23000	11490	2	0	\N
343322	1678	25200791763000	23001	11490	0	0	\N
343323	1874	22167000	23001	11490	1	0	\N
343324	1874	22169000	23001	11490	2	0	\N
343325	1678	25200791763000	23002	11490	0	0	\N
343326	1874	22167000	23002	11490	1	0	\N
343327	1874	22169000	23002	11490	2	0	\N
343335	1678	25200791766000	23005	11493	0	0	\N
343336	1874	22183000	23005	11493	1	0	\N
343337	1874	22185000	23005	11493	2	0	\N
343338	1678	25200791766000	23006	11493	0	0	\N
343339	1874	22183000	23006	11493	1	0	\N
343340	1874	22185000	23006	11493	2	0	\N
343344	1678	25200791766000	23008	11493	0	0	\N
343345	1874	22182000	23008	11493	1	0	\N
343346	1678	25200791767000	23009	11494	0	0	\N
343347	1678	25200791768000	23009	11494	1	0	\N
343348	1874	22183000	23009	11494	2	0	\N
343349	1874	22185000	23009	11494	3	0	\N
343350	1874	22187000	23009	11494	4	0	\N
343351	1874	22190000	23009	11494	5	0	\N
343352	1874	22193000	23009	11494	6	0	\N
343353	1874	22196000	23009	11494	7	0	\N
343354	1678	25200791767000	23010	11494	0	0	\N
343355	1678	25200791768000	23010	11494	1	0	\N
343356	1874	22183000	23010	11494	2	0	\N
343357	1874	22185000	23010	11494	3	0	\N
343358	1874	22187000	23010	11494	4	0	\N
343359	1874	22190000	23010	11494	5	0	\N
343360	1874	22193000	23010	11494	6	0	\N
343361	1874	22196000	23010	11494	7	0	\N
343362	1678	25200791767000	23011	11494	0	0	\N
343363	1678	25200791768000	23011	11494	1	0	\N
343364	1874	22183000	23011	11494	2	0	\N
343365	1874	22185000	23011	11494	3	0	\N
343366	1874	22187000	23011	11494	4	0	\N
343367	1874	22190000	23011	11494	5	0	\N
343368	1874	22193000	23011	11494	6	0	\N
343369	1874	22196000	23011	11494	7	0	\N
343380	1678	25200791769000	23014	11495	0	0	\N
343381	1874	22198000	23014	11495	1	0	\N
343382	1874	22201000	23014	11495	2	0	\N
343383	1678	25200791769000	23015	11495	0	0	\N
343384	1678	25200791770000	23017	11497	0	0	\N
343385	1678	25200791771000	23017	11497	1	0	\N
343386	1678	25200791772000	23017	11497	2	0	\N
343387	1678	25200791773000	23017	11497	3	0	\N
343388	1874	22204000	23017	11497	4	0	\N
343389	1874	22205000	23017	11497	5	0	\N
343390	1874	22208000	23017	11497	6	0	\N
343391	1874	22211000	23017	11497	7	0	\N
343392	1874	22214000	23017	11497	8	0	\N
343393	1874	22216000	23017	11497	9	0	\N
343394	1874	22218000	23017	11497	10	0	\N
343395	1874	22220000	23017	11497	11	0	\N
343396	1874	22222000	23017	11497	12	0	\N
343397	1678	25200791770000	23018	11497	0	0	\N
343398	1678	25200791771000	23018	11497	1	0	\N
343399	1678	25200791772000	23018	11497	2	0	\N
343400	1678	25200791773000	23018	11497	3	0	\N
343271	1678	25200791751000	22990	11483	2	0	0
343272	1874	22111000	22990	11483	3	0	2
343278	1678	25200791752000	22992	11484	0	0	0
343279	1678	25200791753000	22992	11484	1	0	0
343280	1874	22112000	22992	11484	2	0	2
343282	1874	22116000	22992	11484	4	0	2
343283	1678	25200791754000	22993	11485	0	0	0
343284	1874	22118000	22993	11485	1	0	2
343285	1874	22121000	22993	11485	2	0	2
343286	1678	25200791755000	22994	11486	0	0	0
343288	1874	22126000	22994	11486	2	0	2
343289	1874	22127000	22994	11486	3	0	2
343290	1678	25200791756000	22995	11487	0	0	0
343291	1678	25200791757000	22995	11487	1	0	0
343293	1874	22133000	22995	11487	3	0	2
343294	1874	22135000	22995	11487	4	0	2
343295	1874	22137000	22995	11487	5	0	2
343296	1678	25200791758000	22996	11488	0	0	0
343297	1678	25200791759000	22996	11488	1	0	0
343299	1678	25200791761000	22996	11488	3	0	0
343300	1874	22140000	22996	11488	4	0	2
343301	1874	22143000	22996	11488	5	0	2
343302	1874	22144000	22996	11488	6	0	2
343303	1874	22145000	22996	11488	7	0	2
343305	1874	22149000	22996	11488	9	0	2
343306	1874	22151000	22996	11488	10	0	2
343307	1874	22153000	22996	11488	11	0	2
343308	1874	22156000	22996	11488	12	0	2
343313	1678	25200791762000	22998	11489	0	0	0
343314	1874	22162000	22998	11489	1	0	2
343315	1874	22164000	22998	11489	2	0	2
343316	1678	25200791763000	22999	11490	0	0	0
343317	1874	22167000	22999	11490	1	0	2
343328	1678	25200791764000	23003	11491	0	0	0
343374	1874	22190000	23012	11494	4	0	2
343375	1874	22193000	23012	11494	5	0	2
343376	1874	22196000	23012	11494	6	0	2
343377	1678	25200791769000	23013	11495	0	0	0
343378	1874	22198000	23013	11495	1	0	2
343379	1874	22201000	23013	11495	2	0	2
343401	1874	22204000	23018	11497	4	0	\N
343402	1874	22205000	23018	11497	5	0	\N
343403	1874	22208000	23018	11497	6	0	\N
343404	1874	22211000	23018	11497	7	0	\N
343405	1874	22214000	23018	11497	8	0	\N
343406	1874	22216000	23018	11497	9	0	\N
343407	1874	22218000	23018	11497	10	0	\N
343408	1874	22220000	23018	11497	11	0	\N
343409	1874	22222000	23018	11497	12	0	\N
343423	2305	4000000000	23020	11455	0	0	\N
343424	1678	25200791727000	23020	11455	1	0	\N
343425	1678	25200791728000	23020	11455	2	0	\N
343426	1678	25200791729000	23020	11455	3	0	\N
343427	1678	25200791730000	23020	11455	4	0	\N
343428	1678	25200791731000	23020	11455	5	0	\N
343429	1678	25200791732000	23020	11455	6	0	\N
343430	1678	25200791733000	23020	11455	7	0	\N
343431	1678	25200791734000	23020	11455	8	0	\N
343432	1678	25200791735000	23020	11455	9	0	\N
343433	1678	25200791736000	23020	11455	10	0	\N
343434	1678	25200791737000	23020	11455	11	0	\N
343435	1678	25200791738000	23020	11455	12	0	\N
343436	1678	25200791739000	23020	11455	13	0	\N
343437	1678	25200791740000	23020	11455	14	0	\N
343438	1678	25200791741000	23020	11455	15	0	\N
343439	1678	25200791742000	23020	11455	16	0	\N
343440	1678	25200791743000	23020	11455	17	0	\N
343441	1678	25200791744000	23020	11455	18	0	\N
343442	1678	25200791745000	23020	11455	19	0	\N
343443	1678	25200791746000	23020	11455	20	0	\N
343444	1678	25200791747000	23020	11455	21	0	\N
343445	1678	25200791748000	23020	11455	22	0	\N
343446	1678	25200791749000	23020	11455	23	0	\N
343447	1678	25200791750000	23020	11455	24	0	\N
343448	1678	25200791751000	23020	11455	25	0	\N
343449	1678	25200791752000	23020	11455	26	0	\N
343450	1678	25200791753000	23020	11455	27	0	\N
343451	1678	25200791754000	23020	11455	28	0	\N
343452	1678	25200791755000	23020	11455	29	0	\N
343453	1678	25200791756000	23020	11455	30	0	\N
343454	1678	25200791757000	23020	11455	31	0	\N
343455	1678	25200791758000	23020	11455	32	0	\N
343456	1678	25200791759000	23020	11455	33	0	\N
343457	1678	25200791760000	23020	11455	34	0	\N
343458	1678	25200791761000	23020	11455	35	0	\N
343459	1678	25200791762000	23020	11455	36	0	\N
343460	1678	25200791763000	23020	11455	37	0	\N
343461	1678	25200791764000	23020	11455	38	0	\N
343462	1678	25200791765000	23020	11455	39	0	\N
343463	1678	25200791766000	23020	11455	40	0	\N
343464	1678	25200791767000	23020	11455	41	0	\N
343465	1678	25200791768000	23020	11455	42	0	\N
343466	1678	25200791769000	23020	11455	43	0	\N
343467	1678	25200791770000	23020	11455	44	0	\N
343468	1678	25200791771000	23020	11455	45	0	\N
343469	1678	25200791772000	23020	11455	46	0	\N
343470	1678	25200791773000	23020	11455	47	0	\N
343471	1678	25200791774000	23020	11455	48	0	\N
343472	1874	22014000	23020	11455	49	0	\N
343473	1211	612942786305089	23020	11455	50	0	\N
343474	1091	908440320665449	23020	11455	51	0	\N
343475	1874	22015000	23020	11455	52	0	\N
343476	1874	22016000	23020	11455	53	0	\N
343477	1874	22017000	23020	11455	54	0	\N
343478	1874	22018000	23020	11455	55	0	\N
343479	1874	22019000	23020	11455	56	0	\N
343480	1874	22020000	23020	11455	57	0	\N
343484	1678	25200791774000	23024	11498	0	0	\N
343485	1874	22225000	23024	11498	1	0	\N
343486	1874	22227000	23024	11498	2	0	\N
343487	1678	25200791774000	23025	11498	0	0	\N
343488	1874	22225000	23025	11498	1	0	\N
343489	1874	22227000	23025	11498	2	0	\N
343490	1678	25200791774000	23026	11498	0	0	\N
343491	1874	22225000	23026	11498	1	0	\N
343492	1874	22227000	23026	11498	2	0	\N
343493	1678	25200791774000	23027	11498	0	0	\N
343496	1678	25200791775000	23030	11499	0	0	\N
343497	1874	22230000	23030	11499	1	0	\N
343498	1874	22231000	23030	11499	2	0	\N
343499	1678	25200791775000	23031	11499	0	0	\N
343500	1874	22230000	23031	11499	1	0	\N
343501	1874	22231000	23031	11499	2	0	\N
343502	1678	25200791775000	23032	11499	0	0	\N
343503	1874	22230000	23032	11499	1	0	\N
343504	1874	22231000	23032	11499	2	0	\N
343522	1678	25200791778000	23035	11501	0	0	\N
343523	1678	25200791779000	23035	11501	1	0	\N
343524	1678	25200791780000	23035	11501	2	0	\N
343525	1874	22243000	23035	11501	3	0	\N
343526	1874	22245000	23035	11501	4	0	\N
343527	1874	22246000	23035	11501	5	0	\N
343528	1874	22248000	23035	11501	6	0	\N
343529	1874	22251000	23035	11501	7	0	\N
343530	1874	22254000	23035	11501	8	0	\N
343531	1874	22257000	23035	11501	9	0	\N
343412	1678	25200791772000	23019	11497	2	0	0
343413	1678	25200791773000	23019	11497	3	0	0
343414	1874	22204000	23019	11497	4	0	2
343415	1874	22205000	23019	11497	5	0	2
343416	1874	22208000	23019	11497	6	0	2
343418	1874	22214000	23019	11497	8	0	2
343419	1874	22216000	23019	11497	9	0	2
343420	1874	22218000	23019	11497	10	0	2
343421	1874	22220000	23019	11497	11	0	2
343422	1874	22222000	23019	11497	12	0	2
343482	1874	22225000	23022	11498	1	0	2
343483	1874	22227000	23022	11498	2	0	2
343494	1678	25200791775000	23029	11499	0	0	0
343495	1874	22230000	23029	11499	1	0	2
343506	1678	25200791777000	23033	11500	1	0	0
343507	1874	22233000	23033	11500	2	0	2
343508	1874	22234000	23033	11500	3	0	2
343509	1874	22237000	23033	11500	4	0	2
343510	1874	22239000	23033	11500	5	0	2
343512	1678	25200791778000	23034	11501	0	0	0
343513	1678	25200791779000	23034	11501	1	0	0
343514	1678	25200791780000	23034	11501	2	0	0
343515	1874	22243000	23034	11501	3	0	2
343516	1874	22245000	23034	11501	4	0	2
343518	1874	22248000	23034	11501	6	0	2
343519	1874	22251000	23034	11501	7	0	2
343520	1874	22254000	23034	11501	8	0	2
343521	1874	22257000	23034	11501	9	0	2
343533	1678	25200791782000	23036	11502	1	0	0
343534	1678	25200791783000	23036	11502	2	0	0
343535	1874	22260000	23036	11502	3	0	2
343536	1874	22263000	23036	11502	4	0	2
343542	1678	25200791781000	23037	11502	0	0	\N
343543	1678	25200791782000	23037	11502	1	0	\N
343544	1678	25200791783000	23037	11502	2	0	\N
343545	1874	22260000	23037	11502	3	0	\N
343546	1874	22263000	23037	11502	4	0	\N
343547	1874	22266000	23037	11502	5	0	\N
343548	1874	22268000	23037	11502	6	0	\N
343549	1874	22270000	23037	11502	7	0	\N
343550	1874	22272000	23037	11502	8	0	\N
343551	1874	22273000	23037	11502	9	0	\N
343559	1678	25200791784000	23039	11503	0	0	\N
343560	1678	25200791785000	23039	11503	1	0	\N
343561	1874	22276000	23039	11503	2	0	\N
343562	1874	22278000	23039	11503	3	0	\N
343563	1874	22280000	23039	11503	4	0	\N
343564	1874	22283000	23039	11503	5	0	\N
343565	1874	22284000	23039	11503	6	0	\N
343569	1678	25200791786000	23041	11504	0	0	\N
343570	1874	22286000	23041	11504	1	0	\N
343571	1874	22289000	23041	11504	2	0	\N
343572	1678	25200791787000	23042	11505	0	0	\N
343573	1874	22291000	23042	11505	1	0	\N
343574	1874	22294000	23042	11505	2	0	\N
343578	1678	25200791788000	23044	11506	0	0	\N
343579	1874	22296000	23044	11506	1	0	\N
343580	1874	22297000	23044	11506	2	0	\N
343581	1874	22300000	23044	11506	3	0	\N
343589	2301	719000000000	23047	11424	0	0	\N
343590	2305	4000000000	23047	11424	1	0	\N
343591	2297	8154338013959	23047	11424	2	0	\N
343592	2303	719000000000	23047	11424	3	0	\N
343593	715	2015703046640	23047	11424	4	0	\N
343594	2304	719000000000	23047	11424	5	0	\N
343595	1647	20000000	23047	11424	6	0	\N
343596	1672	3601284000000	23047	11424	7	0	\N
343597	1672	3601284000000	23047	11424	8	0	\N
343598	971	506944567057213	23047	11424	9	0	\N
343599	1211	612942786305089	23047	11424	10	0	\N
343600	1091	908440320665449	23047	11424	11	0	\N
343601	1391	1712412932951650	23047	11424	12	0	\N
343602	1145	910777100200000	23047	11424	13	0	\N
343603	1337	1708019573872989	23047	11424	14	0	\N
343604	1265	614519166800000	23047	11424	15	0	\N
343605	1025	508248407000000	23047	11424	16	0	\N
343606	2297	9362106805640	23047	11424	17	0	\N
343607	2302	1439000000000	23047	11424	18	0	\N
343608	1345	1709321034299650	23047	11424	19	0	\N
343609	1099	909132525338000	23047	11424	20	0	\N
343610	1219	613409830595000	23047	11424	21	0	\N
343611	979	507330843835000	23047	11424	22	0	\N
343612	1678	25200791790000	23048	11508	0	0	\N
343613	1678	25200791791000	23048	11508	1	0	\N
343614	1874	22308000	23048	11508	2	0	\N
343615	1874	22311000	23048	11508	3	0	\N
343616	1874	22313000	23048	11508	4	0	\N
343617	1874	22315000	23048	11508	5	0	\N
343618	1874	22316000	23048	11508	6	0	\N
343626	1678	25200791792000	23050	11509	0	0	\N
343627	1874	22318000	23050	11509	1	0	\N
343628	1874	22321000	23050	11509	2	0	\N
343641	1678	25200791793000	23054	11511	0	0	\N
343642	1678	25200791794000	23054	11511	1	0	\N
343643	1874	22328000	23054	11511	2	0	\N
343644	1874	22331000	23054	11511	3	0	\N
343645	1874	22332000	23054	11511	4	0	\N
343646	1874	22335000	23054	11511	5	0	\N
343647	1874	22337000	23054	11511	6	0	\N
343658	1678	25200791797000	23059	11514	0	0	\N
343659	1874	22350000	23059	11514	1	0	\N
343660	1874	22351000	23059	11514	2	0	\N
343661	1874	22353000	23059	11514	4	0	\N
343662	1678	25200791797000	23060	11514	0	0	\N
343663	1874	22350000	23060	11514	1	0	\N
343664	1874	22351000	23060	11514	2	0	\N
343665	1874	22353000	23060	11514	4	0	\N
343666	1678	25200791798000	23061	11515	0	0	\N
343667	1678	25200791799000	23061	11515	1	0	\N
343668	1874	22356000	23061	11515	2	0	\N
343669	1874	22359000	23061	11515	3	0	\N
343670	1874	22361000	23061	11515	4	0	\N
343671	1874	22363000	23061	11515	5	0	\N
343539	1874	22270000	23036	11502	7	0	2
343540	1874	22272000	23036	11502	8	0	2
343541	1874	22273000	23036	11502	9	0	2
343552	1678	25200791784000	23038	11503	0	0	0
343553	1678	25200791785000	23038	11503	1	0	0
343555	1874	22278000	23038	11503	3	0	2
343556	1874	22280000	23038	11503	4	0	2
343557	1874	22283000	23038	11503	5	0	2
343558	1874	22284000	23038	11503	6	0	2
343566	1678	25200791786000	23040	11504	0	0	0
343568	1874	22289000	23040	11504	2	0	2
343575	1678	25200791787000	23043	11505	0	0	0
343576	1874	22291000	23043	11505	1	0	2
343577	1874	22294000	23043	11505	2	0	2
343583	1874	22296000	23045	11506	1	0	2
343584	1874	22297000	23045	11506	2	0	2
343585	1874	22300000	23045	11506	3	0	2
343586	1678	25200791789000	23046	11507	0	0	0
343587	1874	22302000	23046	11507	1	0	2
343619	1678	25200791790000	23049	11508	0	0	0
343620	1678	25200791791000	23049	11508	1	0	0
343621	1874	22308000	23049	11508	2	0	2
343622	1874	22311000	23049	11508	3	0	2
343623	1874	22313000	23049	11508	4	0	2
343625	1874	22316000	23049	11508	6	0	2
343629	1678	25200791792000	23051	11509	0	0	0
343630	1874	22318000	23051	11509	1	0	2
343631	1874	22321000	23051	11509	2	0	2
343633	1874	22326000	23052	11510	1	0	2
343634	1678	25200791793000	23053	11511	0	0	0
343635	1678	25200791794000	23053	11511	1	0	0
343636	1874	22328000	23053	11511	2	0	2
343637	1874	22331000	23053	11511	3	0	2
343639	1874	22335000	23053	11511	5	0	2
343640	1874	22337000	23053	11511	6	0	2
343648	1678	25200791795000	23055	11512	0	0	0
343649	1874	22340000	23055	11512	1	0	2
343650	1874	22342000	23055	11512	2	0	2
343652	1874	22344000	23056	11513	1	0	2
343653	1874	22347000	23056	11513	2	0	2
343654	1678	25200791797000	23058	11514	0	0	0
343655	1874	22350000	23058	11514	1	0	2
343657	1874	22353000	23058	11514	4	0	2
343672	1678	25200791798000	23062	11515	0	0	0
343682	1678	25200791800000	23065	11516	0	0	\N
343683	1874	22366000	23065	11516	1	0	\N
343684	1874	22367000	23065	11516	2	0	\N
343685	1874	22369000	23065	11516	3	0	\N
343686	1678	25200791800000	23066	11516	0	0	\N
343687	1874	22366000	23066	11516	1	0	\N
343688	1874	22367000	23066	11516	2	0	\N
343689	1874	22369000	23066	11516	3	0	\N
343690	1678	25200791801000	23067	11517	0	0	\N
343691	1678	25200791802000	23067	11517	1	0	\N
343692	1874	22371000	23067	11517	2	0	\N
343693	1874	22373000	23067	11517	3	0	\N
343694	1874	22376000	23067	11517	4	0	\N
343695	1874	22379000	23067	11517	5	0	\N
343705	1678	25200791803000	23071	11518	0	0	\N
343706	1874	22381000	23071	11518	1	0	\N
343707	1874	22384000	23071	11518	2	0	\N
343712	1678	25200791804000	23073	11519	0	0	\N
343713	1874	22387000	23073	11519	1	0	\N
343714	1874	22388000	23073	11519	2	0	\N
343715	1874	22390000	23073	11519	3	0	\N
343716	1678	25200791805000	23074	11520	0	0	\N
343717	1874	22393000	23074	11520	1	0	\N
343718	1874	22395000	23074	11520	2	0	\N
343729	1678	25200791807000	23078	11522	0	0	\N
343730	1874	22398000	23078	11522	1	0	\N
343731	1874	22401000	23078	11522	2	0	\N
343732	1874	22404000	23078	11522	3	0	\N
343733	1678	25200791807000	23079	11522	0	0	\N
343734	1874	22399000	23079	11522	1	0	\N
343735	1874	22400000	23079	11522	2	0	\N
343736	1874	22403000	23079	11522	3	0	\N
343760	1678	25200791815000	23085	11528	0	0	\N
343761	1874	22446000	23085	11528	1	0	\N
343762	1678	25200791815000	23086	11528	0	0	\N
343763	1874	22446000	23086	11528	1	0	\N
343764	1874	22448000	23086	11528	2	0	\N
343768	1678	25200791815000	23088	11528	0	0	\N
343769	1874	22446000	23088	11528	1	0	\N
343770	1874	22448000	23088	11528	2	0	\N
343771	1678	25200791798000	23089	11515	0	0	\N
343772	1678	25200791799000	23089	11515	1	0	\N
343773	1678	25200791800000	23089	11515	2	0	\N
343774	1678	25200791801000	23089	11515	3	0	\N
343775	1678	25200791802000	23089	11515	4	0	\N
343776	1678	25200791803000	23089	11515	5	0	\N
343777	1678	25200791804000	23089	11515	6	0	\N
343778	1678	25200791805000	23089	11515	7	0	\N
343779	1678	25200791806000	23089	11515	8	0	\N
343780	1678	25200791807000	23089	11515	9	0	\N
343781	1678	25200791808000	23089	11515	10	0	\N
343782	1678	25200791809000	23089	11515	11	0	\N
343783	1678	25200791810000	23089	11515	12	0	\N
343784	1678	25200791811000	23089	11515	13	0	\N
343785	1678	25200791812000	23089	11515	14	0	\N
343786	1678	25200791813000	23089	11515	15	0	\N
343787	1678	25200791814000	23089	11515	16	0	\N
343788	1678	25200791815000	23089	11515	17	0	\N
343789	1678	25200791816000	23089	11515	18	0	\N
343790	1678	25200791817000	23089	11515	19	0	\N
343791	1678	25200791818000	23089	11515	20	0	\N
343792	1678	25200791819000	23089	11515	21	0	\N
343793	1874	22356000	23089	11515	22	0	\N
343794	1874	22359000	23089	11515	23	0	\N
343795	1874	22362000	23089	11515	24	0	\N
343796	1874	22364000	23089	11515	25	0	\N
343797	1874	22365000	23089	11515	26	0	\N
343798	1874	22367000	23089	11515	27	0	\N
343799	1874	22369000	23089	11515	28	0	\N
343800	1874	22371000	23089	11515	29	0	\N
343801	1874	22373000	23089	11515	30	0	\N
343802	1874	22375000	23089	11515	31	0	\N
343803	1874	22378000	23089	11515	32	0	\N
343804	1874	22381000	23089	11515	33	0	\N
343805	1874	22384000	23089	11515	34	0	\N
343806	1874	22387000	23089	11515	35	0	\N
343807	1874	22390000	23089	11515	36	0	\N
343808	1874	22393000	23089	11515	37	0	\N
343675	1874	22359000	23062	11515	3	0	2
343676	1874	22361000	23062	11515	4	0	2
343677	1874	22363000	23062	11515	5	0	2
343678	1678	25200791800000	23064	11516	0	0	0
343679	1874	22366000	23064	11516	1	0	2
343681	1874	22369000	23064	11516	3	0	2
343696	1678	25200791801000	23068	11517	0	0	0
343697	1678	25200791802000	23068	11517	1	0	0
343698	1874	22371000	23068	11517	2	0	2
343699	1874	22373000	23068	11517	3	0	2
343701	1874	22379000	23068	11517	5	0	2
343702	1678	25200791803000	23070	11518	0	0	0
343703	1874	22381000	23070	11518	1	0	2
343704	1874	22384000	23070	11518	2	0	2
343709	1874	22387000	23072	11519	1	0	2
343710	1874	22388000	23072	11519	2	0	2
343711	1874	22390000	23072	11519	3	0	2
343719	1678	25200791805000	23075	11520	0	0	0
343720	1874	22393000	23075	11520	1	0	2
343722	1678	25200791806000	23076	11521	0	0	0
343723	1874	22397000	23076	11521	1	0	2
343724	1678	25200791807000	23077	11522	0	0	0
343725	1874	22399000	23077	11522	1	0	2
343726	1874	22400000	23077	11522	2	0	2
343728	1874	22406000	23077	11522	4	0	2
343737	1678	25200791808000	23080	11523	0	0	0
343738	1874	22408000	23080	11523	1	0	2
343739	1874	22411000	23080	11523	2	0	2
343741	1874	22414000	23081	11524	1	0	2
343742	1874	22416000	23081	11524	2	0	2
343743	1678	25200791810000	23082	11525	0	0	0
343744	1874	22418000	23082	11525	1	0	2
343745	1874	22421000	23082	11525	2	0	2
343747	1678	25200791811000	23083	11526	0	0	0
343748	1874	22425000	23083	11526	1	0	2
343749	1874	22427000	23083	11526	2	0	2
343750	1678	25200791812000	23084	11527	0	0	0
343751	1678	25200791813000	23084	11527	1	0	0
343753	1874	22430000	23084	11527	3	0	2
343754	1874	22431000	23084	11527	4	0	2
343755	1874	22434000	23084	11527	5	0	2
343756	1874	22437000	23084	11527	6	0	2
343758	1874	22441000	23084	11527	8	0	2
343759	1874	22443000	23084	11527	9	0	2
343765	1678	25200791815000	23087	11528	0	0	0
343766	1874	22446000	23087	11528	1	0	2
343767	1874	22448000	23087	11528	2	0	2
343809	1874	22396000	23089	11515	38	0	\N
343810	1874	22399000	23089	11515	39	0	\N
343811	1874	22402000	23089	11515	40	0	\N
343812	1874	22405000	23089	11515	41	0	\N
343813	1874	22408000	23089	11515	42	0	\N
343814	1874	22411000	23089	11515	43	0	\N
343815	1874	22414000	23089	11515	44	0	\N
343816	1874	22417000	23089	11515	45	0	\N
343817	1874	22420000	23089	11515	46	0	\N
343818	1874	22423000	23089	11515	47	0	\N
343819	1874	22426000	23089	11515	48	0	\N
343820	1874	22429000	23089	11515	49	0	\N
343821	1874	22432000	23089	11515	50	0	\N
343822	1874	22433000	23089	11515	51	0	\N
343823	1874	22434000	23089	11515	52	0	\N
343824	1874	22435000	23089	11515	53	0	\N
343825	1874	22436000	23089	11515	54	0	\N
343826	1874	22437000	23089	11515	55	0	\N
343827	1874	22439000	23089	11515	56	0	\N
343828	1874	22441000	23089	11515	57	0	\N
343829	1874	22443000	23089	11515	58	0	\N
343830	1874	22445000	23089	11515	59	0	\N
343831	1874	22447000	23089	11515	60	0	\N
343832	1874	22449000	23089	11515	61	0	\N
343833	1874	22451000	23089	11515	62	0	\N
343834	1874	22453000	23089	11515	63	0	\N
343835	1874	22455000	23089	11515	64	0	\N
343836	1874	22457000	23089	11515	65	0	\N
343837	1874	22459000	23089	11515	66	0	\N
343838	1874	22461000	23089	11515	67	0	\N
343839	1874	22463000	23089	11515	68	0	\N
343840	1874	22465000	23089	11515	69	0	\N
343841	1874	22467000	23089	11515	70	0	\N
343842	1874	22469000	23089	11515	71	0	\N
343866	1678	25200791823000	23093	11532	0	0	\N
343867	1678	25200791824000	23093	11532	1	0	\N
343868	1874	22486000	23093	11532	2	0	\N
343869	1874	22488000	23093	11532	3	0	\N
343870	1874	22490000	23093	11532	4	0	\N
343871	1874	22493000	23093	11532	5	0	\N
343872	1874	22496000	23093	11532	6	0	\N
343873	1678	25200791823000	23094	11532	0	0	\N
343874	1678	25200791824000	23094	11532	1	0	\N
343875	1874	22486000	23094	11532	2	0	\N
343876	1874	22488000	23094	11532	3	0	\N
343877	1874	22490000	23094	11532	4	0	\N
343878	1874	22493000	23094	11532	5	0	\N
343879	1874	22496000	23094	11532	6	0	\N
343890	1678	25200791825000	23097	11533	0	0	\N
343891	1874	22498000	23097	11533	1	0	\N
343892	1874	22501000	23097	11533	2	0	\N
343902	1874	22517000	23100	11536	0	0	\N
343916	1678	25200791832000	23105	11539	0	0	\N
343917	1874	22532000	23105	11539	1	0	\N
343918	1874	22535000	23105	11539	2	0	\N
343922	1678	25200791834000	23107	11541	0	0	\N
343923	1874	22543000	23107	11541	1	0	\N
343924	1874	22544000	23107	11541	2	0	\N
343925	1874	22546000	23107	11541	3	0	\N
343930	1678	25200791834000	23109	11541	0	0	\N
343931	1874	22543000	23109	11541	1	0	\N
343932	1874	22544000	23109	11541	2	0	\N
343933	1874	22546000	23109	11541	3	0	\N
343934	1678	25200791835000	23110	11542	0	0	\N
343935	1874	22549000	23110	11542	1	0	\N
343936	1874	22551000	23110	11542	2	0	\N
343845	1678	25200791818000	23090	11529	2	0	0
343846	1678	25200791819000	23090	11529	3	0	0
343847	1678	25200791820000	23090	11529	4	0	0
343848	1874	22449000	23090	11529	5	0	2
343849	1874	22450000	23090	11529	6	0	2
343851	1874	22454000	23090	11529	8	0	2
343852	1874	22456000	23090	11529	9	0	2
343853	1874	22459000	23090	11529	10	0	2
343854	1874	22462000	23090	11529	11	0	2
343855	1874	22465000	23090	11529	12	0	2
343857	1874	22471000	23090	11529	14	0	2
343858	1874	22473000	23090	11529	15	0	2
343859	1874	22475000	23090	11529	16	0	2
343860	1678	25200791821000	23091	11530	0	0	0
343862	1874	22480000	23091	11530	2	0	2
343863	1678	25200791822000	23092	11531	0	0	0
343864	1874	22483000	23092	11531	1	0	2
343865	1874	22485000	23092	11531	2	0	2
343880	1678	25200791823000	23095	11532	0	0	0
343882	1874	22486000	23095	11532	2	0	2
343883	1874	22488000	23095	11532	3	0	2
343884	1874	22490000	23095	11532	4	0	2
343885	1874	22493000	23095	11532	5	0	2
343886	1874	22496000	23095	11532	6	0	2
343888	1874	22498000	23096	11533	1	0	2
343889	1874	22501000	23096	11533	2	0	2
343893	1678	25200791826000	23098	11534	0	0	0
343894	1678	25200791827000	23098	11534	1	0	0
343896	1874	22504000	23098	11534	3	0	2
343897	1874	22506000	23098	11534	4	0	2
343898	1874	22509000	23098	11534	5	0	2
343899	1678	25200791828000	23099	11535	0	0	0
343900	1874	22511000	23099	11535	1	0	2
343903	1678	25200791829000	23101	11536	0	0	0
343904	1874	22516000	23101	11536	1	0	2
343905	1874	22519000	23101	11536	2	0	2
343906	1678	25200791830000	23102	11537	0	0	0
343907	1874	22520000	23102	11537	1	0	2
343909	1874	22525000	23102	11537	3	0	2
343910	1678	25200791831000	23103	11538	0	0	0
343911	1874	22528000	23103	11538	1	0	2
343912	1874	22530000	23103	11538	2	0	2
343914	1874	22532000	23104	11539	1	0	2
343915	1874	22535000	23104	11539	2	0	2
343919	1678	25200791833000	23106	11540	0	0	0
343920	1874	22538000	23106	11540	1	0	2
343921	1874	22540000	23106	11540	2	0	2
343927	1874	22543000	23108	11541	1	0	2
343928	1874	22544000	23108	11541	2	0	2
343929	1874	22546000	23108	11541	3	0	2
343937	1678	25200791835000	23111	11542	0	0	0
343938	1874	22549000	23111	11542	1	0	2
343940	1678	25200791836000	23112	11543	0	0	0
343941	1874	22553000	23112	11543	1	0	2
343942	1874	22556000	23112	11543	2	0	2
343943	1678	25200791837000	23113	11544	0	0	0
343961	2113	543308726895	23117	11525	0	0	\N
343962	1678	25200791842000	23119	11547	0	0	\N
343963	1678	25200791843000	23119	11547	1	0	\N
343964	1874	22585000	23119	11547	2	0	\N
343965	1874	22588000	23119	11547	3	0	\N
343966	1874	22590000	23119	11547	4	0	\N
343967	1874	22593000	23119	11547	5	0	\N
343980	1678	25200791845000	23123	11549	0	0	\N
343981	1874	22599000	23123	11549	1	0	\N
343982	1874	22602000	23123	11549	2	0	\N
343990	1874	22615000	23125	11551	0	0	\N
343999	1678	25200791849000	23128	11552	0	0	\N
344000	1874	22620000	23128	11552	1	0	\N
344001	1874	22623000	23128	11552	2	0	\N
344002	1346	1711775637751650	23128	11552	3	0	\N
344003	1100	910438465000000	23128	11552	4	0	\N
344004	1678	25200791849000	23129	11552	0	0	\N
344005	1874	22620000	23129	11552	1	0	\N
344006	1874	22623000	23129	11552	2	0	\N
344007	1346	1711775637751650	23129	11552	3	0	\N
344008	1100	910438465000000	23129	11552	4	0	\N
344009	2305	4000000000	23130	11433	0	0	\N
344010	2297	8154338013959	23130	11433	1	0	\N
344011	715	2015703046640	23130	11433	2	0	\N
344012	1672	3601284000000	23130	11433	3	0	\N
344013	1647	20000000	23130	11433	4	0	\N
344014	1874	21853000	23130	11433	5	0	\N
344015	1346	1711775637751650	23130	11433	6	0	\N
344016	2113	543308726895	23130	11433	7	0	\N
344017	1874	21854000	23130	11433	8	0	\N
344018	1874	21855000	23130	11433	9	0	\N
344019	971	506944567057213	23130	11433	10	0	\N
344020	1211	612942786305089	23130	11433	11	0	\N
344021	1091	908440320665449	23130	11433	12	0	\N
344022	1874	21856000	23130	11433	13	0	\N
344023	1874	21857000	23130	11433	14	0	\N
344024	1874	21858000	23130	11433	15	0	\N
344025	1874	21859000	23130	11433	16	0	\N
344026	1874	21860000	23130	11433	17	0	\N
344027	1874	21861000	23130	11433	18	0	\N
344028	1874	21862000	23130	11433	19	0	\N
344029	1100	910438465000000	23130	11433	20	0	\N
344030	1874	21863000	23130	11433	21	0	\N
344031	1874	21864000	23130	11433	22	0	\N
344032	1874	21865000	23130	11433	23	0	\N
344033	1874	21866000	23130	11433	24	0	\N
344034	1874	21867000	23130	11433	25	0	\N
344035	1874	21868000	23130	11433	26	0	\N
344036	1874	21869000	23130	11433	27	0	\N
344037	1874	21870000	23130	11433	28	0	\N
344038	1874	21871000	23130	11433	29	0	\N
344039	1874	21872000	23130	11433	30	0	\N
344040	1874	21873000	23130	11433	31	0	\N
344041	1874	21874000	23130	11433	32	0	\N
344042	1874	21875000	23130	11433	33	0	\N
344043	1874	21878000	23130	11433	34	0	\N
344044	1874	21881000	23130	11433	35	0	\N
344045	1874	21884000	23130	11433	36	0	\N
344046	1874	21887000	23130	11433	37	0	\N
344047	1874	21890000	23130	11433	38	0	\N
344048	1874	21893000	23130	11433	39	0	\N
344049	1874	21896000	23130	11433	40	0	\N
344050	1391	1712412932951650	23130	11433	41	0	\N
344051	1145	910777100200000	23130	11433	42	0	\N
344052	1337	1708019573872989	23130	11433	43	0	\N
344053	1265	614519166800000	23130	11433	44	0	\N
344054	1025	508248407000000	23130	11433	45	0	\N
344055	2297	9362106805640	23130	11433	46	0	\N
344056	1345	1709321034299650	23130	11433	47	0	\N
344057	1099	909132525338000	23130	11433	48	0	\N
344058	1219	613409830595000	23130	11433	49	0	\N
344059	979	507330843835000	23130	11433	50	0	\N
344060	1874	21899000	23130	11433	51	0	\N
344061	1874	21902000	23130	11433	52	0	\N
344062	1874	21905000	23130	11433	53	0	\N
344063	1874	21908000	23130	11433	54	0	\N
344064	1874	21911000	23130	11433	55	0	\N
344065	1874	21914000	23130	11433	56	0	\N
344066	1874	21917000	23130	11433	57	0	\N
344067	1874	21920000	23130	11433	58	0	\N
344068	1874	21923000	23130	11433	59	0	\N
344069	1874	21926000	23130	11433	60	0	\N
344070	1874	21929000	23130	11433	61	0	\N
344071	1874	21932000	23130	11433	62	0	\N
344072	1874	21935000	23130	11433	63	0	\N
344073	1874	21938000	23130	11433	64	0	\N
344074	1874	21941000	23130	11433	65	0	\N
344075	1874	21944000	23130	11433	66	0	\N
344076	1874	21947000	23130	11433	67	0	\N
344077	1874	21950000	23130	11433	68	0	\N
344078	1874	21953000	23130	11433	69	0	\N
344079	1874	21956000	23130	11433	70	0	\N
344080	1874	21959000	23130	11433	71	0	\N
343947	1678	25200791838000	23115	11545	0	0	0
343948	1678	25200791839000	23115	11545	1	0	0
343949	1678	25200791840000	23115	11545	2	0	0
343950	1874	22565000	23115	11545	3	0	2
343951	1874	22567000	23115	11545	4	0	2
343953	1874	22570000	23115	11545	6	0	2
343954	1874	22572000	23115	11545	7	0	2
343955	1874	22575000	23115	11545	8	0	2
343956	1874	22578000	23115	11545	9	0	2
343957	1678	25200791841000	23116	11546	0	0	0
343959	1874	22580000	23116	11546	2	0	2
343960	1874	22583000	23116	11546	3	0	2
343968	1678	25200791842000	23120	11547	0	0	0
343969	1678	25200791843000	23120	11547	1	0	0
343971	1874	22588000	23120	11547	3	0	2
343972	1874	22590000	23120	11547	4	0	2
343973	1874	22593000	23120	11547	5	0	2
343974	1678	25200791844000	23121	11548	0	0	0
343975	1874	22596000	23121	11548	1	0	2
343977	1678	25200791845000	23122	11549	0	0	0
343978	1874	22599000	23122	11549	1	0	2
343979	1874	22602000	23122	11549	2	0	2
343983	1678	25200791846000	23124	11550	0	0	0
343984	1678	25200791847000	23124	11550	1	0	0
343986	1874	22606000	23124	11550	3	0	2
343987	1874	22608000	23124	11550	4	0	2
343988	1874	22610000	23124	11550	5	0	2
343989	1874	22613000	23124	11550	6	0	2
343992	1874	22615000	23126	11551	1	0	2
343993	1874	22618000	23126	11551	2	0	2
343994	1678	25200791849000	23127	11552	0	0	0
343995	1874	22620000	23127	11552	1	0	2
343996	1874	22623000	23127	11552	2	0	2
343998	1100	910438465000000	23127	11552	4	0	0
344081	1874	21962000	23130	11433	72	0	\N
344082	1874	21963000	23130	11433	73	0	\N
344083	1874	21964000	23130	11433	74	0	\N
344084	1874	21965000	23130	11433	75	0	\N
344085	1874	21966000	23130	11433	76	0	\N
344086	1874	21967000	23130	11433	77	0	\N
344087	1874	21968000	23130	11433	78	0	\N
344088	1874	21969000	23130	11433	79	0	\N
344089	1874	21970000	23130	11433	80	0	\N
344090	1874	21971000	23130	11433	81	0	\N
344091	1874	21972000	23130	11433	82	0	\N
344092	1874	21973000	23130	11433	83	0	\N
344093	1874	21974000	23130	11433	84	0	\N
344094	1874	21975000	23130	11433	85	0	\N
344095	1874	21976000	23130	11433	86	0	\N
344096	1874	21977000	23130	11433	87	0	\N
344097	1874	21978000	23130	11433	88	0	\N
344098	1874	21979000	23130	11433	89	0	\N
344099	1874	21980000	23130	11433	90	0	\N
344100	1874	21981000	23130	11433	91	0	\N
344101	1874	21982000	23130	11433	92	0	\N
344102	1874	21983000	23130	11433	93	0	\N
344103	1874	21986000	23130	11433	94	0	\N
344104	1874	21989000	23130	11433	95	0	\N
344105	1874	21992000	23130	11433	96	0	\N
344106	1874	21995000	23130	11433	97	0	\N
344107	1874	21998000	23130	11433	98	0	\N
344108	1874	22001000	23130	11433	99	0	\N
344109	1874	22004000	23130	11433	100	0	\N
344110	1874	22007000	23130	11433	101	0	\N
344111	1874	22010000	23130	11433	102	0	\N
344112	1874	22013000	23130	11433	103	0	\N
344113	1874	22016000	23130	11433	104	0	\N
344114	1874	22019000	23130	11433	105	0	\N
344115	1874	22022000	23130	11433	106	0	\N
344116	1874	22025000	23130	11433	107	0	\N
344117	1874	22028000	23130	11433	108	0	\N
344118	1874	22031000	23130	11433	109	0	\N
344119	1874	22034000	23130	11433	110	0	\N
344120	1874	22037000	23130	11433	111	0	\N
344121	1874	22040000	23130	11433	112	0	\N
344122	1874	22043000	23130	11433	113	0	\N
344123	1874	22046000	23130	11433	114	0	\N
344124	1874	22049000	23130	11433	115	0	\N
344125	1874	22052000	23130	11433	116	0	\N
344126	1874	22055000	23130	11433	117	0	\N
344127	1874	22058000	23130	11433	118	0	\N
344128	1874	22061000	23130	11433	119	0	\N
344129	1874	22064000	23130	11433	120	0	\N
344130	1874	22067000	23130	11433	123	0	\N
344131	1874	22070000	23130	11433	124	0	\N
344132	1678	25200791849000	23131	11552	0	0	\N
344133	1874	22620000	23131	11552	1	0	\N
344134	1874	22623000	23131	11552	2	0	\N
344135	1346	1711775637751650	23131	11552	3	0	\N
344136	1100	910438465000000	23131	11552	4	0	\N
344143	1678	25200791850000	23133	11553	0	0	\N
344144	1678	25200791851000	23133	11553	1	0	\N
344145	1874	22624000	23133	11553	2	0	\N
344146	1220	614291750000000	23133	11553	3	0	\N
344147	980	508059775000000	23133	11553	5	0	\N
344148	1874	22627000	23133	11553	6	0	\N
344149	1874	22629000	23133	11553	7	0	\N
344150	1874	22631000	23133	11553	8	0	\N
344151	1874	22634000	23133	11553	9	0	\N
344152	1678	25200791850000	23134	11553	0	0	\N
344153	1678	25200791851000	23134	11553	1	0	\N
344154	1874	22624000	23134	11553	2	0	\N
344155	1220	614291750000000	23134	11553	3	0	\N
344156	980	508059775000000	23134	11553	5	0	\N
344157	1874	22627000	23134	11553	6	0	\N
344158	1874	22629000	23134	11553	7	0	\N
344159	1874	22631000	23134	11553	8	0	\N
344160	1874	22634000	23134	11553	9	0	\N
344161	1678	25200791850000	23135	11553	0	0	\N
344162	1678	25200791851000	23135	11553	1	0	\N
344163	1874	22624000	23135	11553	2	0	\N
344164	1220	614291750000000	23135	11553	3	0	\N
344165	980	508059775000000	23135	11553	5	0	\N
344166	1874	22626000	23135	11553	6	0	\N
344167	1874	22628000	23135	11553	7	0	\N
344168	1678	25200791829000	23136	11536	0	0	\N
344169	1678	25200791830000	23136	11536	1	0	\N
344170	1678	25200791831000	23136	11536	2	0	\N
344171	1678	25200791832000	23136	11536	3	0	\N
344172	1678	25200791833000	23136	11536	4	0	\N
344173	1678	25200791834000	23136	11536	5	0	\N
344174	1678	25200791835000	23136	11536	6	0	\N
344175	1678	25200791836000	23136	11536	7	0	\N
344176	1678	25200791837000	23136	11536	8	0	\N
344177	1678	25200791838000	23136	11536	9	0	\N
344178	1678	25200791839000	23136	11536	10	0	\N
344179	1678	25200791840000	23136	11536	11	0	\N
344180	1678	25200791841000	23136	11536	12	0	\N
344181	1678	25200791842000	23136	11536	13	0	\N
344182	1678	25200791843000	23136	11536	14	0	\N
344183	1678	25200791844000	23136	11536	15	0	\N
344184	1678	25200791845000	23136	11536	16	0	\N
344185	1678	25200791846000	23136	11536	17	0	\N
344186	1678	25200791847000	23136	11536	18	0	\N
344187	1678	25200791848000	23136	11536	19	0	\N
344188	1678	25200791849000	23136	11536	20	0	\N
344189	1678	25200791850000	23136	11536	21	0	\N
344190	1874	22515000	23136	11536	22	0	\N
344191	1874	22517000	23136	11536	23	0	\N
344192	1874	22519000	23136	11536	24	0	\N
344193	1874	22521000	23136	11536	25	0	\N
344194	1874	22523000	23136	11536	26	0	\N
344195	1346	1711775637751650	23136	11536	27	0	\N
344196	2113	543308726895	23136	11536	28	0	\N
344197	1874	22524000	23136	11536	29	0	\N
344198	1874	22525000	23136	11536	30	0	\N
344199	1874	22528000	23136	11536	31	0	\N
344200	1874	22531000	23136	11536	32	0	\N
344201	1874	22534000	23136	11536	33	0	\N
344202	1874	22537000	23136	11536	34	0	\N
344203	1874	22540000	23136	11536	35	0	\N
344204	1874	22543000	23136	11536	36	0	\N
344205	1874	22546000	23136	11536	37	0	\N
344206	1874	22549000	23136	11536	38	0	\N
344207	1874	22552000	23136	11536	39	0	\N
344208	1874	22555000	23136	11536	40	0	\N
344209	1100	910438465000000	23136	11536	41	0	\N
344210	1220	614291750000000	23136	11536	42	0	\N
344211	980	508059775000000	23136	11536	43	0	\N
344212	1874	22557000	23136	11536	44	0	\N
344213	1874	22558000	23136	11536	45	0	\N
344214	1874	22559000	23136	11536	46	0	\N
344215	1874	22560000	23136	11536	47	0	\N
344216	1874	22563000	23136	11536	48	0	\N
344139	1874	22624000	23132	11553	2	0	2
344140	1220	614291750000000	23132	11553	3	0	0
344141	980	508059775000000	23132	11553	5	0	0
344142	1874	22626000	23132	11553	6	0	2
344217	1874	22566000	23136	11536	49	0	\N
344218	1874	22568000	23136	11536	50	0	\N
344219	1874	22570000	23136	11536	51	0	\N
344220	1874	22572000	23136	11536	52	0	\N
344221	1874	22574000	23136	11536	53	0	\N
344222	1874	22576000	23136	11536	54	0	\N
344223	1874	22578000	23136	11536	55	0	\N
344224	1874	22580000	23136	11536	56	0	\N
344225	1874	22582000	23136	11536	57	0	\N
344226	1874	22584000	23136	11536	58	0	\N
344227	1874	22586000	23136	11536	59	0	\N
344228	1874	22588000	23136	11536	60	0	\N
344229	1874	22590000	23136	11536	61	0	\N
344230	1874	22592000	23136	11536	62	0	\N
344231	1874	22594000	23136	11536	63	0	\N
344232	1874	22596000	23136	11536	64	0	\N
344233	1874	22598000	23136	11536	65	0	\N
344234	1874	22601000	23136	11536	66	0	\N
344235	1874	22604000	23136	11536	67	0	\N
344236	1874	22607000	23136	11536	68	0	\N
344237	1874	22610000	23136	11536	69	0	\N
344238	1874	22613000	23136	11536	70	0	\N
344239	1874	22616000	23136	11536	71	0	\N
344240	1874	22619000	23136	11536	72	0	\N
344241	1874	22622000	23136	11536	73	0	\N
344242	1874	22625000	23136	11536	74	0	\N
344243	1874	22628000	23136	11536	75	0	\N
344244	1678	25200791852000	23137	11554	0	0	\N
344245	1678	25200791853000	23137	11554	1	0	\N
344246	1874	22629000	23137	11554	2	0	\N
344247	1874	22631000	23137	11554	3	0	\N
344248	1874	22633000	23137	11554	4	0	\N
344249	1874	22635000	23137	11554	5	0	\N
344250	1874	22638000	23137	11554	6	0	\N
344251	1874	22641000	23137	11554	7	0	\N
344252	1874	22644000	23137	11554	8	0	\N
344269	1678	25200791854000	23140	11555	0	0	\N
344270	1678	25200791855000	23140	11555	1	0	\N
344271	1874	22645000	23140	11555	2	0	\N
344272	1874	22647000	23140	11555	3	0	\N
344273	1874	22649000	23140	11555	4	0	\N
344274	1874	22652000	23140	11555	5	0	\N
344275	1874	22655000	23140	11555	6	0	\N
344276	1678	25200791854000	23141	11555	0	0	\N
344277	1678	25200791855000	23141	11555	1	0	\N
344278	1874	22645000	23141	11555	2	0	\N
344279	1874	22647000	23141	11555	3	0	\N
344280	1874	22649000	23141	11555	4	0	\N
344281	1874	22652000	23141	11555	5	0	\N
344282	1874	22655000	23141	11555	6	0	\N
344283	1678	25200791854000	23142	11555	0	0	\N
344284	1678	25200791855000	23142	11555	1	0	\N
344285	1874	22645000	23142	11555	2	0	\N
344286	1874	22647000	23142	11555	3	0	\N
344287	1874	22649000	23142	11555	4	0	\N
344288	1874	22652000	23142	11555	5	0	\N
344289	1874	22655000	23142	11555	6	0	\N
344313	1678	25200791863000	23148	11561	0	0	\N
344314	1874	22695000	23148	11561	1	0	\N
344315	1874	22697000	23148	11561	2	0	\N
344319	1678	25200791863000	23150	11561	0	0	\N
344320	1874	22695000	23150	11561	1	0	\N
344321	1874	22697000	23150	11561	2	0	\N
344322	1678	25200791752000	23151	11484	0	0	\N
344323	1678	25200791753000	23151	11484	1	0	\N
344324	1678	25200791754000	23151	11484	2	0	\N
344325	1678	25200791755000	23151	11484	3	0	\N
344326	1678	25200791756000	23151	11484	4	0	\N
344327	1678	25200791757000	23151	11484	5	0	\N
344328	1678	25200791758000	23151	11484	6	0	\N
344329	1678	25200791759000	23151	11484	7	0	\N
344330	1678	25200791760000	23151	11484	8	0	\N
344331	1678	25200791761000	23151	11484	9	0	\N
344332	1678	25200791762000	23151	11484	10	0	\N
344333	1678	25200791763000	23151	11484	11	0	\N
344334	1678	25200791764000	23151	11484	12	0	\N
344335	1678	25200791765000	23151	11484	13	0	\N
344336	1678	25200791766000	23151	11484	14	0	\N
344337	1678	25200791767000	23151	11484	15	0	\N
344338	1678	25200791768000	23151	11484	16	0	\N
344339	1678	25200791769000	23151	11484	17	0	\N
344340	1678	25200791770000	23151	11484	18	0	\N
344341	1678	25200791771000	23151	11484	19	0	\N
344342	1678	25200791772000	23151	11484	20	0	\N
344343	1678	25200791773000	23151	11484	21	0	\N
344344	1678	25200791774000	23151	11484	22	0	\N
344345	1678	25200791775000	23151	11484	23	0	\N
344346	1678	25200791776000	23151	11484	24	0	\N
344347	1678	25200791777000	23151	11484	25	0	\N
344348	1678	25200791778000	23151	11484	26	0	\N
344349	1678	25200791779000	23151	11484	27	0	\N
344350	1678	25200791780000	23151	11484	28	0	\N
344351	1678	25200791781000	23151	11484	29	0	\N
344352	1678	25200791782000	23151	11484	30	0	\N
344255	1874	22629000	23138	11554	2	0	2
344256	1874	22631000	23138	11554	3	0	2
344257	1874	22633000	23138	11554	4	0	2
344258	1874	22635000	23138	11554	5	0	2
344259	1874	22638000	23138	11554	6	0	2
344261	1874	22644000	23138	11554	8	0	2
344262	1678	25200791854000	23139	11555	0	0	0
344263	1678	25200791855000	23139	11555	1	0	0
344264	1874	22645000	23139	11555	2	0	2
344265	1874	22647000	23139	11555	3	0	2
344267	1874	22652000	23139	11555	5	0	2
344268	1874	22655000	23139	11555	6	0	2
344290	1678	25200791856000	23143	11556	0	0	0
344291	1874	22658000	23143	11556	1	0	2
344293	1678	25200791857000	23144	11557	0	0	0
344294	1874	22663000	23144	11557	1	0	2
344295	1874	22665000	23144	11557	2	0	2
344296	1874	22666000	23144	11557	3	0	2
344297	1678	25200791858000	23145	11558	0	0	0
344299	1874	22671000	23145	11558	2	0	2
344300	1678	25200791859000	23146	11559	0	0	0
344301	1874	22674000	23146	11559	1	0	2
344302	1874	22676000	23146	11559	2	0	2
344303	1678	25200791860000	23147	11560	0	0	0
344305	1678	25200791862000	23147	11560	2	0	0
344306	1874	22677000	23147	11560	3	0	2
344307	1874	22679000	23147	11560	4	0	2
344308	1874	22681000	23147	11560	5	0	2
344310	1874	22686000	23147	11560	7	0	2
344311	1874	22689000	23147	11560	8	0	2
344312	1874	22692000	23147	11560	9	0	2
344316	1678	25200791863000	23149	11561	0	0	0
344317	1874	22695000	23149	11561	1	0	2
344353	1678	25200791783000	23151	11484	31	0	\N
344354	1678	25200791784000	23151	11484	32	0	\N
344355	1678	25200791785000	23151	11484	33	0	\N
344356	1678	25200791786000	23151	11484	34	0	\N
344357	1678	25200791787000	23151	11484	35	0	\N
344358	1678	25200791788000	23151	11484	36	0	\N
344359	1678	25200791789000	23151	11484	37	0	\N
344360	1678	25200791790000	23151	11484	38	0	\N
344361	1678	25200791791000	23151	11484	39	0	\N
344362	1678	25200791792000	23151	11484	40	0	\N
344363	1678	25200791793000	23151	11484	41	0	\N
344364	1678	25200791794000	23151	11484	42	0	\N
344365	1678	25200791795000	23151	11484	43	0	\N
344366	1678	25200791796000	23151	11484	44	0	\N
344367	1678	25200791797000	23151	11484	45	0	\N
344368	1678	25200791798000	23151	11484	46	0	\N
344369	1678	25200791799000	23151	11484	47	0	\N
344370	1678	25200791800000	23151	11484	48	0	\N
344371	1678	25200791801000	23151	11484	49	0	\N
344372	1678	25200791802000	23151	11484	50	0	\N
344373	1678	25200791803000	23151	11484	51	0	\N
344374	1678	25200791804000	23151	11484	52	0	\N
344375	1678	25200791805000	23151	11484	53	0	\N
344376	1678	25200791806000	23151	11484	54	0	\N
344377	1678	25200791807000	23151	11484	55	0	\N
344378	1678	25200791808000	23151	11484	56	0	\N
344379	1678	25200791809000	23151	11484	57	0	\N
344380	1678	25200791810000	23151	11484	58	0	\N
344381	1678	25200791811000	23151	11484	59	0	\N
344382	1678	25200791812000	23151	11484	60	0	\N
344383	1678	25200791813000	23151	11484	61	0	\N
344384	1678	25200791814000	23151	11484	62	0	\N
344385	1678	25200791815000	23151	11484	63	0	\N
344386	1678	25200791816000	23151	11484	64	0	\N
344387	1678	25200791817000	23151	11484	65	0	\N
344388	1678	25200791818000	23151	11484	66	0	\N
344389	1678	25200791819000	23151	11484	67	0	\N
344390	1678	25200791820000	23151	11484	68	0	\N
344391	1678	25200791821000	23151	11484	69	0	\N
344392	1678	25200791822000	23151	11484	70	0	\N
344393	1678	25200791823000	23151	11484	71	0	\N
344394	1678	25200791824000	23151	11484	72	0	\N
344395	1678	25200791825000	23151	11484	73	0	\N
344396	1678	25200791826000	23151	11484	74	0	\N
344397	1678	25200791827000	23151	11484	75	0	\N
344398	1678	25200791828000	23151	11484	76	0	\N
344399	1678	25200791829000	23151	11484	77	0	\N
344400	1678	25200791830000	23151	11484	78	0	\N
344401	1678	25200791831000	23151	11484	79	0	\N
344402	1678	25200791832000	23151	11484	80	0	\N
344403	1678	25200791833000	23151	11484	82	0	\N
344404	1678	25200791834000	23151	11484	83	0	\N
344405	1678	25200791835000	23151	11484	84	0	\N
344406	1678	25200791836000	23151	11484	85	0	\N
344407	1678	25200791837000	23151	11484	86	0	\N
344408	1678	25200791838000	23151	11484	87	0	\N
344409	1678	25200791839000	23151	11484	88	0	\N
344410	1678	25200791840000	23151	11484	89	0	\N
344411	1678	25200791841000	23151	11484	90	0	\N
344412	1678	25200791842000	23151	11484	91	0	\N
344413	1678	25200791843000	23151	11484	92	0	\N
344414	1678	25200791844000	23151	11484	93	0	\N
344415	1678	25200791845000	23151	11484	94	0	\N
344416	1678	25200791846000	23151	11484	95	0	\N
344417	1678	25200791847000	23151	11484	96	0	\N
344418	1678	25200791848000	23151	11484	97	0	\N
344419	1678	25200791849000	23151	11484	98	0	\N
344420	1678	25200791850000	23151	11484	99	0	\N
344421	1678	25200791851000	23151	11484	100	0	\N
344422	1678	25200791852000	23151	11484	101	0	\N
344423	1678	25200791853000	23151	11484	102	0	\N
344424	1678	25200791854000	23151	11484	103	0	\N
344425	1678	25200791855000	23151	11484	104	0	\N
344426	1678	25200791856000	23151	11484	105	0	\N
344427	1678	25200791857000	23151	11484	106	0	\N
344428	1678	25200791858000	23151	11484	107	0	\N
344429	1678	25200791859000	23151	11484	108	0	\N
344430	1678	25200791860000	23151	11484	109	0	\N
344431	1678	25200791861000	23151	11484	110	0	\N
344432	1678	25200791862000	23151	11484	111	0	\N
344433	1678	25200791863000	23151	11484	112	0	\N
344434	1874	22113000	23151	11484	113	0	\N
344435	1874	22114000	23151	11484	114	0	\N
344436	1346	1711775637751650	23151	11484	115	0	\N
344437	2113	543308726895	23151	11484	116	0	\N
344438	1874	22115000	23151	11484	117	0	\N
344439	1874	22116000	23151	11484	118	0	\N
344440	1874	22117000	23151	11484	119	0	\N
344441	1874	22118000	23151	11484	120	0	\N
344442	1874	22119000	23151	11484	121	0	\N
344443	1874	22120000	23151	11484	122	0	\N
344444	1100	910438465000000	23151	11484	123	0	\N
344445	1220	614291750000000	23151	11484	124	0	\N
344446	980	508059775000000	23151	11484	125	0	\N
344447	1678	25200791864000	23152	11562	0	0	\N
344448	1874	22699000	23152	11562	1	0	\N
344449	1874	22702000	23152	11562	2	0	\N
344450	1874	22703000	23152	11562	3	0	\N
344455	1678	25200791865000	23155	11563	0	0	\N
344456	1874	22706000	23155	11563	1	0	\N
344457	1678	25200791851000	23156	11537	0	0	\N
344458	1678	25200791852000	23156	11537	1	0	\N
344459	1678	25200791853000	23156	11537	2	0	\N
344460	1678	25200791854000	23156	11537	3	0	\N
344461	1678	25200791855000	23156	11537	4	0	\N
344462	1678	25200791856000	23156	11537	5	0	\N
344463	1678	25200791857000	23156	11537	6	0	\N
344464	1678	25200791858000	23156	11537	7	0	\N
344465	1678	25200791859000	23156	11537	8	0	\N
344466	1678	25200791860000	23156	11537	9	0	\N
344467	1678	25200791861000	23156	11537	10	0	\N
344468	1678	25200791862000	23156	11537	11	0	\N
344469	1678	25200791863000	23156	11537	12	0	\N
344470	1678	25200791864000	23156	11537	13	0	\N
344471	1874	22629000	23156	11537	14	0	\N
344472	1874	22630000	23156	11537	15	0	\N
344473	1874	22632000	23156	11537	16	0	\N
344474	1874	22634000	23156	11537	17	0	\N
344475	1874	22636000	23156	11537	18	0	\N
344476	1874	22638000	23156	11537	19	0	\N
344477	1874	22640000	23156	11537	20	0	\N
344478	1874	22642000	23156	11537	21	0	\N
344479	1874	22644000	23156	11537	22	0	\N
344480	1874	22646000	23156	11537	23	0	\N
344481	1874	22648000	23156	11537	24	0	\N
344482	1874	22650000	23156	11537	25	0	\N
344483	1874	22652000	23156	11537	26	0	\N
344484	1874	22654000	23156	11537	27	0	\N
344485	1874	22657000	23156	11537	28	0	\N
344486	1874	22660000	23156	11537	29	0	\N
344487	1874	22663000	23156	11537	30	0	\N
344488	1874	22666000	23156	11537	32	0	\N
344453	1874	22702000	23153	11562	2	0	2
344454	1874	22703000	23153	11562	3	0	2
344489	1874	22669000	23156	11537	33	0	\N
344490	1874	22672000	23156	11537	34	0	\N
344491	1874	22675000	23156	11537	35	0	\N
344492	1874	22678000	23156	11537	36	0	\N
344493	1874	22681000	23156	11537	37	0	\N
344494	1874	22684000	23156	11537	38	0	\N
344495	1874	22687000	23156	11537	39	0	\N
344496	1874	22690000	23156	11537	40	0	\N
344497	1874	22693000	23156	11537	41	0	\N
344498	1874	22696000	23156	11537	42	0	\N
344499	1874	22697000	23156	11537	43	0	\N
344500	1874	22698000	23156	11537	44	0	\N
344501	1874	22699000	23156	11537	45	0	\N
344502	1874	22701000	23156	11537	46	0	\N
344503	1874	22703000	23156	11537	47	0	\N
344504	1678	25200791865000	23157	11563	0	0	\N
344505	1678	25200791865000	23158	11564	0	0	\N
344506	1678	25200791866000	23158	11564	1	0	\N
344507	1678	25200791867000	23158	11564	2	0	\N
344508	1874	22706000	23158	11564	3	0	\N
344509	1874	22707000	23158	11564	4	0	\N
344510	1874	22710000	23158	11564	5	0	\N
344511	1874	22713000	23158	11564	6	0	\N
344519	1678	25200791868000	23160	11565	0	0	\N
344520	1874	22716000	23160	11565	1	0	\N
344528	1678	25200791869000	23163	11566	0	0	\N
344529	1678	25200791870000	23163	11566	1	0	\N
344530	1874	22717000	23163	11566	2	0	\N
344531	1874	22720000	23163	11566	3	0	\N
344532	1874	22723000	23163	11566	4	0	\N
344533	1678	25200791871000	23164	11567	0	0	\N
344534	1678	25200791872000	23164	11567	1	0	\N
344535	1874	22726000	23164	11567	2	0	\N
344536	1874	22729000	23164	11567	3	0	\N
344543	1678	25200791873000	23167	11568	0	0	\N
344544	1874	22732000	23167	11568	1	0	\N
344545	1678	25200791873000	23168	11568	0	0	\N
344546	1874	22732000	23168	11568	1	0	\N
344547	1678	25200791874000	23169	11569	0	0	\N
344548	1874	22735000	23169	11569	1	0	\N
344549	1874	22736000	23169	11569	2	0	\N
344550	1678	25200791874000	23170	11569	0	0	\N
344551	1874	22735000	23170	11569	1	0	\N
344552	1874	22736000	23170	11569	2	0	\N
344556	1678	25200791874000	23172	11569	0	0	\N
344557	1874	22735000	23172	11569	1	0	\N
344558	1874	22736000	23172	11569	2	0	\N
344561	1678	24480780677000	23174	11429	0	0	\N
344562	1678	24480780678000	23174	11429	1	0	\N
344563	1678	24480780679000	23174	11429	2	0	\N
344564	2305	4000000000	23174	11429	3	0	\N
344565	1678	24480780680000	23174	11429	4	0	\N
344566	1678	24480780681000	23174	11429	5	0	\N
344567	1678	24480780682000	23174	11429	6	0	\N
344568	1678	24480780683000	23174	11429	7	0	\N
344569	1678	24480780684000	23174	11429	8	0	\N
344570	1678	24480780685000	23174	11429	9	0	\N
344571	1678	24480780686000	23174	11429	10	0	\N
344572	1678	24480780687000	23174	11429	11	0	\N
344573	1678	24480780688000	23174	11429	12	0	\N
344574	1678	24480780689000	23174	11429	13	0	\N
344575	1678	24480780690000	23174	11429	14	0	\N
344576	1678	24480780691000	23174	11429	15	0	\N
344577	1678	24480780692000	23174	11429	16	0	\N
344578	1678	24480780693000	23174	11429	17	0	\N
344579	1678	24480780694000	23174	11429	18	0	\N
344580	1678	24480780695000	23174	11429	19	0	\N
344581	1678	24480780696000	23174	11429	20	0	\N
344582	1678	24480780697000	23174	11429	21	0	\N
344583	1678	24480780698000	23174	11429	22	0	\N
344584	1678	24480780699000	23174	11429	23	0	\N
344585	1678	24480780700000	23174	11429	24	0	\N
344586	1678	24480780701000	23174	11429	25	0	\N
344587	1678	24480780702000	23174	11429	26	0	\N
344588	1678	24480780703000	23174	11429	27	0	\N
344589	1678	24480780704000	23174	11429	28	0	\N
344590	1678	24480780705000	23174	11429	29	0	\N
344591	1678	24480780706000	23174	11429	30	0	\N
344592	1678	24480780707000	23174	11429	31	0	\N
344593	1678	24480780708000	23174	11429	32	0	\N
344594	1678	24480780709000	23174	11429	33	0	\N
344595	1678	24480780710000	23174	11429	34	0	\N
344596	1678	24480780711000	23174	11429	35	0	\N
344597	1678	24480780712000	23174	11429	36	0	\N
344598	1678	24480780713000	23174	11429	37	0	\N
344599	1678	24480780714000	23174	11429	38	0	\N
344600	1678	24480780715000	23174	11429	39	0	\N
344601	1678	24480780716000	23174	11429	40	0	\N
344602	1678	24480780717000	23174	11429	41	0	\N
344603	1678	24480780718000	23174	11429	42	0	\N
344604	1678	24480780719000	23174	11429	43	0	\N
344605	1678	24480780720000	23174	11429	44	0	\N
344606	1678	24480780721000	23174	11429	45	0	\N
344607	1678	24480780722000	23174	11429	46	0	\N
344608	1678	24480780723000	23174	11429	47	0	\N
344609	1678	24480780724000	23174	11429	48	0	\N
344610	1678	24480780725000	23174	11429	49	0	\N
344611	1678	24480780726000	23174	11429	50	0	\N
344612	1678	24480780727000	23174	11429	51	0	\N
344613	1678	24480780728000	23174	11429	52	0	\N
344614	1678	24480780729000	23174	11429	53	0	\N
344615	1678	24480780730000	23174	11429	54	0	\N
344616	1678	24480780731000	23174	11429	55	0	\N
344617	1678	24480780732000	23174	11429	56	0	\N
344618	1678	24480780733000	23174	11429	57	0	\N
344619	1678	24480780734000	23174	11429	58	0	\N
344620	1678	24480780735000	23174	11429	59	0	\N
344621	1678	24480780736000	23174	11429	60	0	\N
344622	1678	24480780737000	23174	11429	61	0	\N
344623	1678	24480780738000	23174	11429	62	0	\N
344624	1678	24480780739000	23174	11429	63	0	\N
344514	1678	25200791867000	23159	11564	2	0	0
344515	1874	22706000	23159	11564	3	0	2
344516	1874	22707000	23159	11564	4	0	2
344517	1874	22710000	23159	11564	5	0	2
344518	1874	22713000	23159	11564	6	0	2
344522	1874	22716000	23161	11565	1	0	2
344523	1678	25200791869000	23162	11566	0	0	0
344524	1678	25200791870000	23162	11566	1	0	0
344525	1874	22717000	23162	11566	2	0	2
344526	1874	22720000	23162	11566	3	0	2
344537	1678	25200791871000	23165	11567	0	0	0
344538	1678	25200791872000	23165	11567	1	0	0
344539	1874	22726000	23165	11567	2	0	2
344540	1874	22729000	23165	11567	3	0	2
344542	1874	22732000	23166	11568	1	0	2
344553	1678	25200791874000	23171	11569	0	0	0
344554	1874	22735000	23171	11569	1	0	2
344555	1874	22736000	23171	11569	2	0	2
344559	1678	25200791875000	23173	11570	0	0	0
344625	1678	24480780740000	23174	11429	64	0	\N
344626	1678	24480780741000	23174	11429	65	0	\N
344627	1678	24480780742000	23174	11429	66	0	\N
344628	1678	24480780743000	23174	11429	68	0	\N
344629	1678	24480780744000	23174	11429	69	0	\N
344630	1678	24480780745000	23174	11429	70	0	\N
344631	1678	24480780746000	23174	11429	71	0	\N
344632	1678	24480780747000	23174	11429	72	0	\N
344633	1678	24480780748000	23174	11429	73	0	\N
344634	1678	24480780749000	23174	11429	74	0	\N
344635	1678	24480780750000	23174	11429	75	0	\N
344636	1678	24480780751000	23174	11429	76	0	\N
344637	1678	24480780752000	23174	11429	77	0	\N
344638	1678	24480780753000	23174	11429	78	0	\N
344639	1678	24480780754000	23174	11429	79	0	\N
344640	1678	24480780755000	23174	11429	80	0	\N
344641	1678	24480780756000	23174	11429	81	0	\N
344642	1678	24480780757000	23174	11429	82	0	\N
344643	1678	24480780758000	23174	11429	83	0	\N
344644	1678	24480780759000	23174	11429	84	0	\N
344645	1678	24480780760000	23174	11429	85	0	\N
344646	1678	24480780761000	23174	11429	86	0	\N
344647	1678	24480780762000	23174	11429	87	0	\N
344648	1678	24480780763000	23174	11429	88	0	\N
344649	1678	24480780764000	23174	11429	89	0	\N
344650	1678	24480780765000	23174	11429	90	0	\N
344651	1678	24480780766000	23174	11429	91	0	\N
344652	1678	24480780767000	23174	11429	92	0	\N
344653	1678	24480780768000	23174	11429	93	0	\N
344654	1678	24480780769000	23174	11429	94	0	\N
344655	1678	24480780770000	23174	11429	95	0	\N
344656	1678	24480780771000	23174	11429	96	0	\N
344657	1678	24480780772000	23174	11429	97	0	\N
344658	1678	24480780773000	23174	11429	98	0	\N
344659	1678	24480780774000	23174	11429	99	0	\N
344660	1678	24480780775000	23174	11429	100	0	\N
344661	1678	24480780776000	23174	11429	101	0	\N
344662	1678	24480780777000	23174	11429	102	0	\N
344663	1678	24480780778000	23174	11429	103	0	\N
344664	1678	24480780779000	23174	11429	104	0	\N
344665	1678	24480780780000	23174	11429	105	0	\N
344666	1678	24480780781000	23174	11429	106	0	\N
344667	1678	24480780782000	23174	11429	107	0	\N
344668	1678	24480780783000	23174	11429	108	0	\N
344669	1678	24480780784000	23174	11429	109	0	\N
344670	1678	24480780785000	23174	11429	110	0	\N
344671	1678	24480780786000	23174	11429	111	0	\N
344672	1678	24480780787000	23174	11429	112	0	\N
344673	1678	24480780788000	23174	11429	113	0	\N
344674	1678	24480780789000	23174	11429	114	0	\N
344675	1678	24480780790000	23174	11429	115	0	\N
344676	1678	24480780791000	23174	11429	116	0	\N
344677	1678	24480780792000	23174	11429	117	0	\N
344678	1678	24480780793000	23174	11429	118	0	\N
344679	1678	24480780794000	23174	11429	119	0	\N
344680	1678	24480780795000	23174	11429	120	0	\N
344681	1678	24480780796000	23174	11429	121	0	\N
344682	1678	24480780797000	23174	11429	122	0	\N
344683	1678	24480780798000	23174	11429	123	0	\N
344684	1678	24480780799000	23174	11429	124	0	\N
344685	1678	24480780800000	23174	11429	125	0	\N
344689	1678	25200791876000	23176	11571	0	0	\N
344690	1678	25200791877000	23176	11571	1	0	\N
344691	1874	22742000	23176	11571	2	0	\N
344692	1874	22743000	23176	11571	3	0	\N
344693	1874	22746000	23176	11571	4	0	\N
344700	1678	25200791831000	23179	11538	0	0	\N
344701	1678	25200791832000	23179	11538	1	0	\N
344702	1678	25200791833000	23179	11538	2	0	\N
344703	1678	25200791834000	23179	11538	3	0	\N
344704	1678	25200791835000	23179	11538	4	0	\N
344705	1678	25200791836000	23179	11538	5	0	\N
344706	1678	25200791837000	23179	11538	6	0	\N
344707	1678	25200791838000	23179	11538	7	0	\N
344708	1678	25200791839000	23179	11538	8	0	\N
344709	1678	25200791840000	23179	11538	9	0	\N
344710	1678	25200791841000	23179	11538	10	0	\N
344711	1678	25200791842000	23179	11538	11	0	\N
344712	1678	25200791843000	23179	11538	12	0	\N
344713	1678	25200791844000	23179	11538	13	0	\N
344714	1678	25200791845000	23179	11538	14	0	\N
344715	1678	25200791846000	23179	11538	15	0	\N
344716	1678	25200791847000	23179	11538	16	0	\N
344717	1678	25200791848000	23179	11538	17	0	\N
344718	1678	25200791849000	23179	11538	18	0	\N
344719	1678	25200791850000	23179	11538	19	0	\N
344720	1678	25200791851000	23179	11538	20	0	\N
344721	1678	25200791852000	23179	11538	21	0	\N
344722	1678	25200791853000	23179	11538	22	0	\N
344723	1678	25200791854000	23179	11538	23	0	\N
344724	1678	25200791855000	23179	11538	24	0	\N
344725	1678	25200791856000	23179	11538	25	0	\N
344726	1678	25200791857000	23179	11538	26	0	\N
344727	1678	25200791858000	23179	11538	27	0	\N
344728	1678	25200791859000	23179	11538	28	0	\N
344729	1678	25200791860000	23179	11538	29	0	\N
344730	1678	25200791861000	23179	11538	30	0	\N
344731	1678	25200791862000	23179	11538	31	0	\N
344732	1678	25200791863000	23179	11538	32	0	\N
344733	1678	25200791864000	23179	11538	33	0	\N
344734	1678	25200791865000	23179	11538	34	0	\N
344735	1678	25200791866000	23179	11538	35	0	\N
344736	1678	25200791867000	23179	11538	36	0	\N
344737	1678	25200791868000	23179	11538	37	0	\N
344738	1678	25200791869000	23179	11538	38	0	\N
344739	1678	25200791870000	23179	11538	39	0	\N
344740	1678	25200791871000	23179	11538	40	0	\N
344741	1678	25200791872000	23179	11538	41	0	\N
344742	1678	25200791873000	23179	11538	42	0	\N
344743	1678	25200791874000	23179	11538	43	0	\N
344744	1678	25200791875000	23179	11538	44	0	\N
344745	1678	25200791876000	23179	11538	45	0	\N
344746	1678	25200791877000	23179	11538	46	0	\N
344747	1678	25200791878000	23179	11538	47	0	\N
344748	1678	25200791879000	23179	11538	48	0	\N
344749	1678	25200791880000	23179	11538	49	0	\N
344750	1678	25200791881000	23179	11538	50	0	\N
344751	1874	22528000	23179	11538	51	0	\N
344752	1874	22531000	23179	11538	52	0	\N
344753	1874	22533000	23179	11538	53	0	\N
344754	1874	22535000	23179	11538	54	0	\N
344755	1346	1711775637751650	23179	11538	55	0	\N
344756	2113	543308726895	23179	11538	56	0	\N
344757	1874	22538000	23179	11538	57	0	\N
344758	1874	22541000	23179	11538	58	0	\N
344759	1874	22544000	23179	11538	59	0	\N
344760	1874	22545000	23179	11538	60	0	\N
344688	1874	22740000	23175	11571	2	0	2
344694	1678	25200791878000	23177	11572	0	0	0
344695	1874	22743000	23177	11572	1	0	2
344696	1874	22746000	23177	11572	2	0	2
344697	1874	22749000	23177	11572	3	0	2
344699	1874	22752000	23178	11573	1	0	2
344761	1874	22546000	23179	11538	61	0	\N
344762	1874	22549000	23179	11538	62	0	\N
344763	1874	22552000	23179	11538	63	0	\N
344764	1874	22555000	23179	11538	64	0	\N
344765	1100	910438465000000	23179	11538	65	0	\N
344766	1220	614291750000000	23179	11538	66	0	\N
344767	980	508059775000000	23179	11538	67	0	\N
344768	1874	22557000	23179	11538	68	0	\N
344769	1874	22558000	23179	11538	69	0	\N
344770	1874	22559000	23179	11538	70	0	\N
344771	1874	22560000	23179	11538	71	0	\N
344772	1874	22561000	23179	11538	72	0	\N
344773	1874	22562000	23179	11538	73	0	\N
344774	1874	22565000	23179	11538	74	0	\N
344775	1874	22568000	23179	11538	75	0	\N
344776	1874	22569000	23179	11538	76	0	\N
344777	1874	22570000	23179	11538	77	0	\N
344778	1874	22571000	23179	11538	78	0	\N
344779	1874	22572000	23179	11538	79	0	\N
344780	1874	22573000	23179	11538	80	0	\N
344781	1874	22574000	23179	11538	81	0	\N
344782	1874	22575000	23179	11538	82	0	\N
344783	1874	22576000	23179	11538	83	0	\N
344784	1874	22578000	23179	11538	84	0	\N
344785	1874	22580000	23179	11538	85	0	\N
344786	1874	22582000	23179	11538	86	0	\N
344787	1874	22584000	23179	11538	87	0	\N
344788	1874	22586000	23179	11538	88	0	\N
344789	1874	22588000	23179	11538	89	0	\N
344790	1874	22590000	23179	11538	90	0	\N
344791	1874	22592000	23179	11538	91	0	\N
344792	1874	22594000	23179	11538	92	0	\N
344793	1874	22596000	23179	11538	93	0	\N
344794	1874	22598000	23179	11538	94	0	\N
344795	1874	22600000	23179	11538	95	0	\N
344796	1874	22602000	23179	11538	96	0	\N
344797	1874	22604000	23179	11538	97	0	\N
344798	1874	22606000	23179	11538	99	0	\N
344799	1874	22608000	23179	11538	100	0	\N
344800	1874	22610000	23179	11538	101	0	\N
344801	1874	22612000	23179	11538	102	0	\N
344802	1874	22614000	23179	11538	103	0	\N
344803	1874	22616000	23179	11538	104	0	\N
344804	1874	22618000	23179	11538	105	0	\N
344805	1874	22620000	23179	11538	106	0	\N
344806	1874	22622000	23179	11538	107	0	\N
344807	1874	22624000	23179	11538	108	0	\N
344808	1874	22626000	23179	11538	109	0	\N
344809	1874	22628000	23179	11538	110	0	\N
344810	1874	22630000	23179	11538	111	0	\N
344811	1874	22632000	23179	11538	112	0	\N
344812	1874	22634000	23179	11538	113	0	\N
344813	1874	22636000	23179	11538	114	0	\N
344814	1874	22639000	23179	11538	115	0	\N
344815	1874	22642000	23179	11538	116	0	\N
344816	1874	22645000	23179	11538	117	0	\N
344817	1874	22648000	23179	11538	118	0	\N
344818	1874	22651000	23179	11538	119	0	\N
344819	1874	22654000	23179	11538	120	0	\N
344820	1874	22657000	23179	11538	121	0	\N
344821	1874	22660000	23179	11538	122	0	\N
344822	1874	22663000	23179	11538	123	0	\N
344823	1874	22666000	23179	11538	124	0	\N
344824	1874	22669000	23179	11538	125	0	\N
344832	1678	25200791880000	23181	11574	0	0	\N
344833	1678	25200791881000	23181	11574	1	0	\N
344834	1678	25200791882000	23181	11574	2	0	\N
344835	1678	25200791883000	23181	11574	3	0	\N
344836	1678	25200791884000	23181	11574	5	0	\N
344837	1874	22755000	23181	11574	6	0	\N
344838	1874	22758000	23181	11574	7	0	\N
344839	1874	22761000	23181	11574	8	0	\N
344840	1874	22764000	23181	11574	9	0	\N
344841	1874	22767000	23181	11574	10	0	\N
344842	1874	22768000	23181	11574	11	0	\N
344843	1874	22769000	23181	11574	12	0	\N
344844	1678	25200791880000	23182	11574	0	0	\N
344845	1678	25200791881000	23182	11574	1	0	\N
344846	1678	25200791882000	23182	11574	2	0	\N
344847	1678	25200791883000	23182	11574	3	0	\N
344848	1678	25200791884000	23182	11574	5	0	\N
344849	1874	22755000	23182	11574	6	0	\N
344850	1874	22758000	23182	11574	7	0	\N
344851	1874	22761000	23182	11574	8	0	\N
344852	1874	22764000	23182	11574	9	0	\N
344853	1874	22767000	23182	11574	10	0	\N
344854	1874	22768000	23182	11574	11	0	\N
344855	1874	22769000	23182	11574	12	0	\N
344856	1678	25200791880000	23183	11574	0	0	\N
344857	1678	25200791881000	23183	11574	1	0	\N
344858	1678	25200791882000	23183	11574	2	0	\N
344859	1678	25200791883000	23183	11574	3	0	\N
344860	1678	25200791884000	23183	11574	5	0	\N
344861	1874	22755000	23183	11574	6	0	\N
344862	1874	22758000	23183	11574	7	0	\N
344863	1874	22761000	23183	11574	8	0	\N
344864	1874	22764000	23183	11574	9	0	\N
344865	1874	22767000	23183	11574	10	0	\N
344866	1874	22768000	23183	11574	11	0	\N
344867	1874	22769000	23183	11574	12	0	\N
344868	1678	24480780648000	23184	11405	0	0	\N
344869	2301	719000000000	23184	11405	1	0	\N
344870	2305	4000000000	23184	11405	2	0	\N
344871	1678	24480780649000	23184	11405	3	0	\N
344872	1678	24480780650000	23184	11405	4	0	\N
344873	2300	59000000000	23184	11405	5	0	\N
344874	2300	2159000000000	23184	11405	6	0	\N
344875	1678	24480780651000	23184	11405	7	0	\N
344876	1678	24480780652000	23184	11405	8	0	\N
344877	1678	24480780653000	23184	11405	9	0	\N
344878	1678	24480780654000	23184	11405	10	0	\N
344879	1678	24480780655000	23184	11405	11	0	\N
344880	1678	24480780656000	23184	11405	12	0	\N
344881	1678	24480780657000	23184	11405	13	0	\N
344882	1678	24480780658000	23184	11405	14	0	\N
344883	1678	24480780659000	23184	11405	15	0	\N
344884	1678	24480780660000	23184	11405	16	0	\N
344885	1678	24480780661000	23184	11405	17	0	\N
344886	1678	24480780662000	23184	11405	18	0	\N
344887	1678	24480780663000	23184	11405	19	0	\N
344888	1678	24480780664000	23184	11405	20	0	\N
344889	1678	24480780665000	23184	11405	21	0	\N
344890	1678	24480780666000	23184	11405	22	0	\N
344891	1678	24480780667000	23184	11405	23	0	\N
344892	1678	24480780668000	23184	11405	24	0	\N
344893	1678	24480780669000	23184	11405	25	0	\N
344894	1678	24480780670000	23184	11405	26	0	\N
344895	1678	24480780671000	23184	11405	27	0	\N
344896	1678	24480780672000	23184	11405	28	0	\N
344827	1678	25200791882000	23180	11574	2	0	0
344828	1678	25200791883000	23180	11574	3	0	0
344829	1678	25200791884000	23180	11574	5	0	0
344830	1874	22753000	23180	11574	6	0	2
344831	1874	22754000	23180	11574	7	0	2
344897	1678	24480780673000	23184	11405	29	0	\N
344898	1678	24480780674000	23184	11405	30	0	\N
344899	1678	24480780675000	23184	11405	31	0	\N
344900	1678	24480780676000	23184	11405	32	0	\N
344901	1678	24480780677000	23184	11405	33	0	\N
344902	1678	24480780678000	23184	11405	34	0	\N
344903	1678	24480780679000	23184	11405	35	0	\N
344904	1678	24480780680000	23184	11405	36	0	\N
344905	1678	24480780681000	23184	11405	37	0	\N
344906	1678	24480780682000	23184	11405	38	0	\N
344907	1678	24480780683000	23184	11405	39	0	\N
344908	1678	24480780684000	23184	11405	40	0	\N
344909	1678	24480780685000	23184	11405	41	0	\N
344910	1678	24480780686000	23184	11405	42	0	\N
344911	1678	24480780687000	23184	11405	43	0	\N
344912	1678	24480780688000	23184	11405	44	0	\N
344913	1678	24480780689000	23184	11405	45	0	\N
344914	1678	24480780690000	23184	11405	46	0	\N
344915	1678	24480780691000	23184	11405	47	0	\N
344916	1678	24480780692000	23184	11405	48	0	\N
344917	1678	24480780693000	23184	11405	49	0	\N
344918	1678	24480780694000	23184	11405	50	0	\N
344919	1678	24480780695000	23184	11405	51	0	\N
344920	1678	24480780696000	23184	11405	52	0	\N
344921	1678	24480780697000	23184	11405	53	0	\N
344922	1678	24480780698000	23184	11405	54	0	\N
344923	1678	24480780699000	23184	11405	55	0	\N
344924	1678	24480780700000	23184	11405	56	0	\N
344925	1678	24480780701000	23184	11405	57	0	\N
344926	1678	24480780702000	23184	11405	58	0	\N
344927	1678	24480780703000	23184	11405	59	0	\N
344928	1678	24480780704000	23184	11405	60	0	\N
344929	1678	24480780705000	23184	11405	61	0	\N
344930	1678	24480780706000	23184	11405	62	0	\N
344931	1678	24480780707000	23184	11405	63	0	\N
344932	1678	24480780708000	23184	11405	64	0	\N
344933	1678	24480780709000	23184	11405	65	0	\N
344934	1678	24480780710000	23184	11405	66	0	\N
344935	1678	24480780711000	23184	11405	67	0	\N
344936	1678	24480780712000	23184	11405	68	0	\N
344937	1678	24480780713000	23184	11405	69	0	\N
344938	1678	24480780714000	23184	11405	70	0	\N
344939	1678	24480780715000	23184	11405	71	0	\N
344940	1678	24480780716000	23184	11405	72	0	\N
344941	1678	24480780717000	23184	11405	73	0	\N
344942	1678	24480780718000	23184	11405	74	0	\N
344943	1678	24480780719000	23184	11405	75	0	\N
344944	1678	24480780720000	23184	11405	76	0	\N
344945	1678	24480780721000	23184	11405	77	0	\N
344946	1678	24480780722000	23184	11405	78	0	\N
344947	1678	24480780723000	23184	11405	79	0	\N
344948	1678	24480780724000	23184	11405	80	0	\N
344949	1678	24480780725000	23184	11405	81	0	\N
344950	1678	24480780726000	23184	11405	82	0	\N
344951	1678	24480780727000	23184	11405	83	0	\N
344952	1678	24480780728000	23184	11405	84	0	\N
344953	1678	24480780729000	23184	11405	85	0	\N
344954	1678	24480780730000	23184	11405	86	0	\N
344955	1678	24480780731000	23184	11405	87	0	\N
344956	1678	24480780732000	23184	11405	89	0	\N
344957	1678	24480780733000	23184	11405	90	0	\N
344958	1678	24480780734000	23184	11405	91	0	\N
344959	1678	24480780735000	23184	11405	92	0	\N
344960	1678	24480780736000	23184	11405	93	0	\N
344961	1678	24480780737000	23184	11405	94	0	\N
344962	1678	24480780738000	23184	11405	95	0	\N
344963	1678	24480780739000	23184	11405	96	0	\N
344964	1678	24480780740000	23184	11405	97	0	\N
344965	1678	24480780741000	23184	11405	98	0	\N
344966	1678	24480780742000	23184	11405	99	0	\N
344967	1678	24480780743000	23184	11405	100	0	\N
344968	1678	24480780744000	23184	11405	101	0	\N
344969	1678	24480780745000	23184	11405	102	0	\N
344970	1678	24480780746000	23184	11405	103	0	\N
344971	1678	24480780747000	23184	11405	104	0	\N
344972	1678	24480780748000	23184	11405	105	0	\N
344973	1678	24480780749000	23184	11405	106	0	\N
344974	1678	24480780750000	23184	11405	107	0	\N
344975	1678	24480780751000	23184	11405	108	0	\N
344976	1678	24480780752000	23184	11405	109	0	\N
344977	1678	24480780753000	23184	11405	110	0	\N
344978	1678	24480780754000	23184	11405	111	0	\N
344979	1678	24480780755000	23184	11405	112	0	\N
344980	1678	24480780756000	23184	11405	113	0	\N
344981	1678	24480780757000	23184	11405	114	0	\N
344982	1678	24480780758000	23184	11405	115	0	\N
344983	1678	24480780759000	23184	11405	116	0	\N
344984	1678	24480780760000	23184	11405	117	0	\N
344985	1678	24480780761000	23184	11405	118	0	\N
344986	1678	24480780762000	23184	11405	119	0	\N
344987	1678	24480780763000	23184	11405	120	0	\N
344988	1678	24480780764000	23184	11405	121	0	\N
344989	1678	24480780765000	23184	11405	122	0	\N
344990	1678	24480780766000	23184	11405	123	0	\N
344991	1678	24480780767000	23184	11405	124	0	\N
344992	1678	24480780768000	23184	11405	125	0	\N
345005	1678	25200791888000	23187	11577	0	0	\N
345006	1874	22782000	23187	11577	1	0	\N
345009	1678	25200791889000	23189	11578	0	0	\N
345010	1874	22785000	23189	11578	1	0	\N
345013	1678	25200791889000	23191	11578	0	0	\N
345014	1874	22785000	23191	11578	1	0	\N
345015	1678	25200791890000	23192	11579	0	0	\N
345016	1874	22786000	23192	11579	1	0	\N
345017	1874	22789000	23192	11579	2	0	\N
345018	1678	25200791890000	23193	11579	0	0	\N
345019	1874	22786000	23193	11579	1	0	\N
345020	1874	22789000	23193	11579	2	0	\N
345021	1678	25200791890000	23194	11579	0	0	\N
345022	1874	22786000	23194	11579	1	0	\N
345023	1874	22789000	23194	11579	2	0	\N
345027	1678	25200791890000	23196	11579	0	0	\N
345028	1874	22786000	23196	11579	1	0	\N
345029	1874	22789000	23196	11579	2	0	\N
345030	1874	22788000	23197	11579	0	0	\N
344995	1874	22760000	23185	11575	2	0	2
344996	1874	22763000	23185	11575	3	0	2
344997	1874	22766000	23185	11575	4	0	2
344998	1874	22769000	23185	11575	5	0	2
344999	1874	22772000	23185	11575	6	0	2
345001	1678	25200791887000	23186	11576	1	0	0
345002	1874	22773000	23186	11576	2	0	2
345003	1874	22776000	23186	11576	3	0	2
345004	1874	22779000	23186	11576	4	0	2
345007	1678	25200791888000	23188	11577	0	0	0
345011	1678	25200791889000	23190	11578	0	0	0
345012	1874	22785000	23190	11578	1	0	2
345024	1678	25200791890000	23195	11579	0	0	0
345025	1874	22786000	23195	11579	1	0	2
345031	1678	25200791891000	23198	11580	0	0	0
345032	1874	22792000	23198	11580	1	0	2
345040	1678	25200791895000	23202	11584	0	0	\N
345041	1678	25200791896000	23202	11584	1	0	\N
345042	1874	22805000	23202	11584	2	0	\N
345043	1874	22808000	23202	11584	3	0	\N
345048	1678	25200791895000	23204	11584	0	0	\N
345049	1678	25200791896000	23204	11584	1	0	\N
345050	1874	22805000	23204	11584	2	0	\N
345051	1874	22808000	23204	11584	3	0	\N
345052	1678	25200791895000	23205	11584	0	0	\N
345053	1678	25200791896000	23205	11584	1	0	\N
345054	1874	22805000	23205	11584	2	0	\N
345055	1874	22808000	23205	11584	3	0	\N
345056	1678	25200791897000	23206	11585	0	0	\N
345057	1874	22811000	23206	11585	1	0	\N
345058	1678	25200791897000	23207	11585	0	0	\N
345059	1874	22811000	23207	11585	1	0	\N
345062	1678	25200791897000	23209	11585	0	0	\N
345063	1874	22811000	23209	11585	1	0	\N
345064	1874	22811000	23210	11585	0	0	\N
345065	1874	22811000	23211	11585	0	0	\N
345068	1678	25200791898000	23213	11586	0	0	\N
345069	1874	22814000	23213	11586	1	0	\N
345070	1678	25200791820000	23214	11516	0	0	\N
345071	1678	25200791821000	23214	11516	1	0	\N
345072	1678	25200791822000	23214	11516	2	0	\N
345073	1678	25200791823000	23214	11516	3	0	\N
345074	1678	25200791824000	23214	11516	4	0	\N
345075	1678	25200791825000	23214	11516	5	0	\N
345076	1678	25200791826000	23214	11516	6	0	\N
345077	1678	25200791827000	23214	11516	7	0	\N
345078	1678	25200791828000	23214	11516	8	0	\N
345079	1678	25200791829000	23214	11516	9	0	\N
345080	1678	25200791830000	23214	11516	10	0	\N
345081	1678	25200791831000	23214	11516	11	0	\N
345082	1678	25200791832000	23214	11516	12	0	\N
345083	1678	25200791833000	23214	11516	13	0	\N
345084	1678	25200791834000	23214	11516	14	0	\N
345085	1678	25200791835000	23214	11516	15	0	\N
345086	1678	25200791836000	23214	11516	16	0	\N
345087	1678	25200791837000	23214	11516	17	0	\N
345088	1678	25200791838000	23214	11516	18	0	\N
345089	1678	25200791839000	23214	11516	19	0	\N
345090	1678	25200791840000	23214	11516	20	0	\N
345091	1678	25200791841000	23214	11516	21	0	\N
345092	1678	25200791842000	23214	11516	22	0	\N
345093	1678	25200791843000	23214	11516	23	0	\N
345094	1678	25200791844000	23214	11516	24	0	\N
345095	1678	25200791845000	23214	11516	25	0	\N
345096	1678	25200791846000	23214	11516	26	0	\N
345097	1678	25200791847000	23214	11516	27	0	\N
345098	1678	25200791848000	23214	11516	28	0	\N
345099	1678	25200791849000	23214	11516	29	0	\N
345100	1678	25200791850000	23214	11516	30	0	\N
345101	1678	25200791851000	23214	11516	31	0	\N
345102	1678	25200791852000	23214	11516	32	0	\N
345103	1678	25200791853000	23214	11516	33	0	\N
345104	1678	25200791854000	23214	11516	34	0	\N
345105	1678	25200791855000	23214	11516	35	0	\N
345106	1678	25200791856000	23214	11516	36	0	\N
345107	1678	25200791857000	23214	11516	37	0	\N
345108	1678	25200791858000	23214	11516	38	0	\N
345109	1678	25200791859000	23214	11516	39	0	\N
345110	1678	25200791860000	23214	11516	40	0	\N
345111	1678	25200791861000	23214	11516	41	0	\N
345112	1678	25200791862000	23214	11516	42	0	\N
345113	1678	25200791863000	23214	11516	43	0	\N
345114	1678	25200791864000	23214	11516	44	0	\N
345115	1678	25200791865000	23214	11516	45	0	\N
345116	1678	25200791866000	23214	11516	46	0	\N
345117	1678	25200791867000	23214	11516	47	0	\N
345118	1678	25200791868000	23214	11516	48	0	\N
345119	1678	25200791869000	23214	11516	49	0	\N
345120	1678	25200791870000	23214	11516	51	0	\N
345121	1678	25200791871000	23214	11516	52	0	\N
345122	1678	25200791872000	23214	11516	53	0	\N
345123	1678	25200791873000	23214	11516	54	0	\N
345124	1678	25200791874000	23214	11516	55	0	\N
345125	1678	25200791875000	23214	11516	56	0	\N
345126	1678	25200791876000	23214	11516	57	0	\N
345127	1678	25200791877000	23214	11516	58	0	\N
345128	1678	25200791878000	23214	11516	59	0	\N
345129	1678	25200791879000	23214	11516	60	0	\N
345130	1678	25200791880000	23214	11516	61	0	\N
345131	1678	25200791881000	23214	11516	62	0	\N
345132	1678	25200791882000	23214	11516	63	0	\N
345133	1678	25200791883000	23214	11516	64	0	\N
345134	1678	25200791884000	23214	11516	65	0	\N
345135	1678	25200791885000	23214	11516	66	0	\N
345136	1678	25200791886000	23214	11516	67	0	\N
345137	1678	25200791887000	23214	11516	68	0	\N
345138	1678	25200791888000	23214	11516	69	0	\N
345139	1678	25200791889000	23214	11516	70	0	\N
345140	1678	25200791890000	23214	11516	71	0	\N
345141	1678	25200791891000	23214	11516	72	0	\N
345142	1678	25200791892000	23214	11516	73	0	\N
345143	1678	25200791893000	23214	11516	74	0	\N
345144	1678	25200791894000	23214	11516	75	0	\N
345145	1678	25200791895000	23214	11516	76	0	\N
345146	1678	25200791896000	23214	11516	77	0	\N
345147	1678	25200791897000	23214	11516	78	0	\N
345148	1874	22471000	23214	11516	79	0	\N
345149	1874	22474000	23214	11516	80	0	\N
345150	1874	22475000	23214	11516	81	0	\N
345151	1874	22476000	23214	11516	82	0	\N
345152	1874	22477000	23214	11516	83	0	\N
345153	1874	22478000	23214	11516	84	0	\N
345154	1346	1711775637751650	23214	11516	85	0	\N
345155	2113	543308726895	23214	11516	86	0	\N
345156	1874	22481000	23214	11516	87	0	\N
345157	1874	22484000	23214	11516	88	0	\N
345158	1874	22487000	23214	11516	89	0	\N
345159	1874	22490000	23214	11516	90	0	\N
345160	1874	22491000	23214	11516	91	0	\N
345161	1874	22492000	23214	11516	92	0	\N
345162	1100	910438465000000	23214	11516	93	0	\N
345163	1220	614291750000000	23214	11516	94	0	\N
345164	980	508059775000000	23214	11516	95	0	\N
345165	1874	22494000	23214	11516	96	0	\N
345166	1874	22496000	23214	11516	97	0	\N
345167	1874	22498000	23214	11516	98	0	\N
345168	1874	22500000	23214	11516	99	0	\N
345035	1678	25200791893000	23200	11582	0	0	0
345036	1874	22798000	23200	11582	1	0	2
345037	1678	25200791894000	23201	11583	0	0	0
345038	1874	22799000	23201	11583	1	0	2
345039	1874	22802000	23201	11583	2	0	2
345045	1678	25200791896000	23203	11584	1	0	0
345046	1874	22805000	23203	11584	2	0	2
345047	1874	22808000	23203	11584	3	0	2
345060	1678	25200791897000	23208	11585	0	0	0
345061	1874	22811000	23208	11585	1	0	2
345067	1874	22814000	23212	11586	1	0	2
345169	1874	22502000	23214	11516	100	0	\N
345170	1874	22504000	23214	11516	101	0	\N
345171	1874	22506000	23214	11516	102	0	\N
345172	1874	22508000	23214	11516	103	0	\N
345173	1874	22510000	23214	11516	104	0	\N
345174	1874	22512000	23214	11516	105	0	\N
345175	1874	22514000	23214	11516	106	0	\N
345176	1874	22516000	23214	11516	107	0	\N
345177	1874	22518000	23214	11516	108	0	\N
345178	1874	22519000	23214	11516	109	0	\N
345179	1874	22522000	23214	11516	110	0	\N
345180	1874	22525000	23214	11516	111	0	\N
345181	1874	22528000	23214	11516	112	0	\N
345182	1874	22531000	23214	11516	113	0	\N
345183	1874	22534000	23214	11516	114	0	\N
345184	1874	22537000	23214	11516	115	0	\N
345185	1874	22540000	23214	11516	116	0	\N
345186	1874	22543000	23214	11516	117	0	\N
345187	1874	22546000	23214	11516	118	0	\N
345188	1874	22549000	23214	11516	119	0	\N
345189	1874	22552000	23214	11516	120	0	\N
345190	1874	22555000	23214	11516	121	0	\N
345191	1874	22558000	23214	11516	122	0	\N
345192	1874	22559000	23214	11516	123	0	\N
345193	1874	22560000	23214	11516	124	0	\N
345194	1874	22561000	23214	11516	125	0	\N
345195	1678	25200791899000	23215	11587	0	0	\N
345196	2308	44000000000	23215	11587	1	0	\N
345197	1874	22817000	23215	11587	2	0	\N
345201	1678	25200791900000	23217	11588	0	0	\N
345202	1874	22820000	23217	11588	1	0	\N
345205	2308	44000000000	23219	11526	0	0	\N
345206	1346	1711775637751650	23219	11526	1	0	\N
345207	1100	910438465000000	23219	11526	2	0	\N
345208	1220	614291750000000	23219	11526	3	0	\N
345209	980	508059775000000	23219	11526	4	0	\N
345215	1678	25200791873000	23222	11568	0	0	\N
345216	2308	44000000000	23222	11568	1	0	\N
345217	1678	25200791874000	23222	11568	2	0	\N
345218	1678	25200791875000	23222	11568	3	0	\N
345219	1678	25200791876000	23222	11568	4	0	\N
345220	1678	25200791877000	23222	11568	5	0	\N
345221	1678	25200791878000	23222	11568	6	0	\N
345222	1678	25200791879000	23222	11568	7	0	\N
345223	1678	25200791880000	23222	11568	8	0	\N
345224	1678	25200791881000	23222	11568	9	0	\N
345225	1678	25200791882000	23222	11568	10	0	\N
345226	1678	25200791883000	23222	11568	11	0	\N
345227	1678	25200791884000	23222	11568	12	0	\N
345228	1678	25200791885000	23222	11568	13	0	\N
345229	1678	25200791886000	23222	11568	14	0	\N
345230	1678	25200791887000	23222	11568	15	0	\N
345231	1678	25200791888000	23222	11568	16	0	\N
345232	1678	25200791889000	23222	11568	17	0	\N
345233	1678	25200791890000	23222	11568	18	0	\N
345234	1678	25200791891000	23222	11568	19	0	\N
345235	1678	25200791892000	23222	11568	20	0	\N
345236	1678	25200791893000	23222	11568	21	0	\N
345237	1678	25200791894000	23222	11568	22	0	\N
345238	1678	25200791895000	23222	11568	23	0	\N
345239	1678	25200791896000	23222	11568	24	0	\N
345240	1678	25200791897000	23222	11568	25	0	\N
345241	1678	25200791898000	23222	11568	26	0	\N
345242	1678	25200791899000	23222	11568	27	0	\N
345243	1678	25200791900000	23222	11568	28	0	\N
345244	1678	25200791901000	23222	11568	29	0	\N
345245	1874	22730000	23222	11568	30	0	\N
345246	1874	22731000	23222	11568	31	0	\N
345247	1874	22734000	23222	11568	33	0	\N
345248	1874	22737000	23222	11568	34	0	\N
345249	1874	22740000	23222	11568	35	0	\N
345250	1874	22743000	23222	11568	36	0	\N
345251	1874	22746000	23222	11568	37	0	\N
345252	1874	22749000	23222	11568	38	0	\N
345253	1874	22752000	23222	11568	39	0	\N
345254	1874	22755000	23222	11568	40	0	\N
345255	1874	22758000	23222	11568	41	0	\N
345256	1874	22761000	23222	11568	42	0	\N
345257	1874	22764000	23222	11568	43	0	\N
345258	1874	22767000	23222	11568	44	0	\N
345259	1874	22770000	23222	11568	45	0	\N
345260	1874	22773000	23222	11568	46	0	\N
345261	1874	22776000	23222	11568	47	0	\N
345262	1874	22779000	23222	11568	48	0	\N
345263	1874	22782000	23222	11568	49	0	\N
345264	1874	22785000	23222	11568	50	0	\N
345265	1874	22788000	23222	11568	51	0	\N
345266	1874	22791000	23222	11568	52	0	\N
345267	1874	22792000	23222	11568	53	0	\N
345268	1874	22795000	23222	11568	54	0	\N
345269	1874	22798000	23222	11568	55	0	\N
345270	1874	22801000	23222	11568	56	0	\N
345271	1874	22804000	23222	11568	57	0	\N
345272	1874	22807000	23222	11568	58	0	\N
345273	1874	22810000	23222	11568	59	0	\N
345274	1874	22813000	23222	11568	60	0	\N
345275	1874	22816000	23222	11568	61	0	\N
345276	1874	22819000	23222	11568	62	0	\N
345277	1874	22822000	23222	11568	63	0	\N
345278	1874	22823000	23222	11568	64	0	\N
345279	1874	22824000	23222	11568	65	0	\N
345280	1874	22825000	23222	11568	66	0	\N
345281	1874	22826000	23222	11568	67	0	\N
345287	1483	10000000	23226	11591	0	0	\N
345288	1678	25200791903000	23226	11591	1	0	\N
345289	1678	25200791904000	23226	11591	2	0	\N
345290	1874	22829000	23226	11591	3	0	\N
345291	1874	22832000	23226	11591	4	0	\N
345292	1483	10000000	23227	11591	0	0	\N
345293	1678	25200791903000	23227	11591	1	0	\N
345294	1678	25200791904000	23227	11591	2	0	\N
345295	1874	22829000	23227	11591	3	0	\N
345296	1874	22832000	23227	11591	4	0	\N
345297	1678	25200791798000	23228	11515	0	0	\N
345298	1678	25200791799000	23228	11515	1	0	\N
345299	2308	44000000000	23228	11515	2	0	\N
345300	1483	10000000	23228	11515	3	0	\N
345301	1678	25200791800000	23228	11515	4	0	\N
345302	1678	25200791801000	23228	11515	5	0	\N
345303	1678	25200791802000	23228	11515	6	0	\N
345304	1678	25200791803000	23228	11515	7	0	\N
345200	1874	22817000	23216	11587	2	0	2
345203	1678	25200791900000	23218	11588	0	0	0
345204	1874	22820000	23218	11588	1	0	2
345210	1678	25200791901000	23220	11589	0	0	0
345211	1874	22823000	23220	11589	1	0	2
345213	1678	25200791902000	23221	11590	1	0	0
345214	1874	22826000	23221	11590	2	0	2
345282	1483	10000000	23225	11591	0	0	0
345283	1678	25200791903000	23225	11591	1	0	0
345284	1678	25200791904000	23225	11591	2	0	0
345286	1874	22832000	23225	11591	4	0	2
345305	1678	25200791804000	23228	11515	8	0	\N
345306	1678	25200791805000	23228	11515	9	0	\N
345307	1678	25200791806000	23228	11515	10	0	\N
345308	1678	25200791807000	23228	11515	11	0	\N
345309	1678	25200791808000	23228	11515	12	0	\N
345310	1678	25200791809000	23228	11515	13	0	\N
345311	1678	25200791810000	23228	11515	14	0	\N
345312	1678	25200791811000	23228	11515	15	0	\N
345313	1678	25200791812000	23228	11515	16	0	\N
345314	1678	25200791813000	23228	11515	17	0	\N
345315	1678	25200791814000	23228	11515	18	0	\N
345316	1678	25200791815000	23228	11515	19	0	\N
345317	1678	25200791816000	23228	11515	20	0	\N
345318	1678	25200791817000	23228	11515	21	0	\N
345319	1678	25200791818000	23228	11515	22	0	\N
345320	1678	25200791819000	23228	11515	23	0	\N
345321	1678	25200791820000	23228	11515	24	0	\N
345322	1678	25200791821000	23228	11515	25	0	\N
345323	1678	25200791822000	23228	11515	26	0	\N
345324	1678	25200791823000	23228	11515	27	0	\N
345325	1678	25200791824000	23228	11515	28	0	\N
345326	1678	25200791825000	23228	11515	29	0	\N
345327	1678	25200791826000	23228	11515	30	0	\N
345328	1678	25200791827000	23228	11515	31	0	\N
345329	1678	25200791828000	23228	11515	32	0	\N
345330	1678	25200791829000	23228	11515	33	0	\N
345331	1678	25200791830000	23228	11515	34	0	\N
345332	1678	25200791831000	23228	11515	35	0	\N
345333	1678	25200791832000	23228	11515	36	0	\N
345334	1678	25200791833000	23228	11515	37	0	\N
345335	1678	25200791834000	23228	11515	38	0	\N
345336	1678	25200791835000	23228	11515	39	0	\N
345337	1678	25200791836000	23228	11515	40	0	\N
345338	1678	25200791837000	23228	11515	41	0	\N
345339	1678	25200791838000	23228	11515	42	0	\N
345340	1678	25200791839000	23228	11515	43	0	\N
345341	1678	25200791840000	23228	11515	44	0	\N
345342	1678	25200791841000	23228	11515	45	0	\N
345343	1678	25200791842000	23228	11515	46	0	\N
345344	1678	25200791843000	23228	11515	47	0	\N
345345	1678	25200791844000	23228	11515	48	0	\N
345346	1678	25200791845000	23228	11515	49	0	\N
345347	1678	25200791846000	23228	11515	50	0	\N
345348	1678	25200791847000	23228	11515	51	0	\N
345349	1678	25200791848000	23228	11515	52	0	\N
345350	1678	25200791849000	23228	11515	53	0	\N
345351	1678	25200791850000	23228	11515	54	0	\N
345352	1678	25200791851000	23228	11515	55	0	\N
345353	1678	25200791852000	23228	11515	56	0	\N
345354	1678	25200791853000	23228	11515	57	0	\N
345355	1678	25200791854000	23228	11515	58	0	\N
345356	1678	25200791855000	23228	11515	59	0	\N
345357	1678	25200791856000	23228	11515	60	0	\N
345358	1678	25200791857000	23228	11515	61	0	\N
345359	1678	25200791858000	23228	11515	62	0	\N
345360	1678	25200791859000	23228	11515	63	0	\N
345361	1678	25200791860000	23228	11515	64	0	\N
345362	1678	25200791861000	23228	11515	65	0	\N
345363	1678	25200791862000	23228	11515	66	0	\N
345364	1678	25200791863000	23228	11515	67	0	\N
345365	1678	25200791864000	23228	11515	68	0	\N
345366	1678	25200791865000	23228	11515	69	0	\N
345367	1678	25200791866000	23228	11515	70	0	\N
345368	1678	25200791867000	23228	11515	71	0	\N
345369	1678	25200791868000	23228	11515	72	0	\N
345370	1678	25200791869000	23228	11515	73	0	\N
345371	1678	25200791870000	23228	11515	74	0	\N
345372	1678	25200791871000	23228	11515	75	0	\N
345373	1678	25200791872000	23228	11515	76	0	\N
345374	1678	25200791873000	23228	11515	77	0	\N
345375	1678	25200791874000	23228	11515	78	0	\N
345376	1678	25200791875000	23228	11515	79	0	\N
345377	1678	25200791876000	23228	11515	80	0	\N
345378	1678	25200791877000	23228	11515	81	0	\N
345379	1678	25200791878000	23228	11515	82	0	\N
345380	1678	25200791879000	23228	11515	83	0	\N
345381	1678	25200791880000	23228	11515	84	0	\N
345382	1678	25200791881000	23228	11515	85	0	\N
345383	1678	25200791882000	23228	11515	86	0	\N
345384	1678	25200791883000	23228	11515	87	0	\N
345385	1678	25200791884000	23228	11515	88	0	\N
345386	1678	25200791885000	23228	11515	89	0	\N
345387	1678	25200791886000	23228	11515	90	0	\N
345388	1678	25200791887000	23228	11515	91	0	\N
345389	1678	25200791888000	23228	11515	92	0	\N
345390	1678	25200791889000	23228	11515	93	0	\N
345391	1678	25200791890000	23228	11515	94	0	\N
345392	1678	25200791891000	23228	11515	95	0	\N
345393	1678	25200791892000	23228	11515	96	0	\N
345394	1678	25200791893000	23228	11515	97	0	\N
345395	1678	25200791894000	23228	11515	98	0	\N
345396	1678	25200791895000	23228	11515	99	0	\N
345397	1678	25200791896000	23228	11515	100	0	\N
345398	1678	25200791897000	23228	11515	101	0	\N
345399	1678	25200791898000	23228	11515	102	0	\N
345400	1678	25200791899000	23228	11515	103	0	\N
345401	1678	25200791900000	23228	11515	104	0	\N
345402	1678	25200791901000	23228	11515	105	0	\N
345403	1678	25200791902000	23228	11515	106	0	\N
345404	1678	25200791903000	23228	11515	107	0	\N
345405	1678	25200791904000	23228	11515	108	0	\N
345406	1874	22356000	23228	11515	109	0	\N
345407	1874	22359000	23228	11515	110	0	\N
345408	1874	22362000	23228	11515	111	0	\N
345409	1874	22364000	23228	11515	112	0	\N
345410	1346	1711775637751650	23228	11515	113	0	\N
345411	2113	543308726895	23228	11515	114	0	\N
345412	1874	22365000	23228	11515	115	0	\N
345413	1874	22367000	23228	11515	116	0	\N
345414	1874	22369000	23228	11515	117	0	\N
345415	1874	22371000	23228	11515	118	0	\N
345416	1874	22373000	23228	11515	119	0	\N
345417	1874	22375000	23228	11515	120	0	\N
345418	1100	910438465000000	23228	11515	121	0	\N
345419	1220	614291750000000	23228	11515	122	0	\N
345420	980	508059775000000	23228	11515	123	0	\N
345421	1874	22378000	23228	11515	125	0	\N
345422	1678	25200791905000	23230	11592	0	0	\N
345423	1874	22835000	23230	11592	1	0	\N
345426	1678	25200791906000	23232	11593	0	0	\N
345427	1874	22838000	23232	11593	1	0	\N
345431	1678	25200791907000	23235	11595	0	0	\N
345432	1874	22844000	23235	11595	1	0	\N
345437	1678	25200791908000	23238	11596	0	0	\N
345438	1874	22847000	23238	11596	1	0	\N
345428	1678	25200791906000	23233	11593	0	0	0
345429	1874	22838000	23233	11593	1	0	2
345430	1874	22841000	23234	11594	0	0	2
345433	1678	25200791907000	23236	11595	0	0	0
345434	1874	22844000	23236	11595	1	0	2
345436	1874	22847000	23237	11596	1	0	2
345439	1678	25200791909000	23239	11597	0	0	0
345440	1874	22850000	23239	11597	1	0	2
345441	1678	25200791909000	23240	11597	0	0	\N
345442	1874	22850000	23240	11597	1	0	\N
345443	1678	25200791910000	23241	11598	0	0	\N
345444	1874	22853000	23241	11598	1	0	\N
345449	2308	44000000000	23244	11547	0	0	\N
345450	1483	10000000	23244	11547	1	0	\N
345451	1346	1711775637751650	23244	11547	2	0	\N
345452	1100	910438465000000	23244	11547	3	0	\N
345453	1220	614291750000000	23244	11547	4	0	\N
345454	980	508059775000000	23244	11547	5	0	\N
345455	1678	25200791912000	23245	11600	0	0	\N
345456	1678	25200791913000	23245	11600	1	0	\N
345457	1874	22859000	23245	11600	2	0	\N
345458	1874	22862000	23245	11600	3	0	\N
345463	1678	25200791912000	23247	11600	0	0	\N
345464	1678	25200791913000	23247	11600	1	0	\N
345465	1874	22859000	23247	11600	2	0	\N
345466	1874	22862000	23247	11600	3	0	\N
345467	1678	25200791914000	23248	11601	0	0	\N
345468	1874	22865000	23248	11601	1	0	\N
345471	2308	44000000000	23250	11480	0	0	\N
345472	1483	10000000	23250	11480	1	0	\N
345473	1346	1711775637751650	23250	11480	2	0	\N
345474	2113	543308726895	23250	11480	3	0	\N
345475	1100	910438465000000	23250	11480	4	0	\N
345476	1220	614291750000000	23250	11480	5	0	\N
345477	980	508059775000000	23250	11480	6	0	\N
345478	1678	25200791914000	23251	11601	0	0	\N
345479	1874	22865000	23251	11601	1	0	\N
345480	1678	25200791914000	23252	11601	0	0	\N
345481	1874	22865000	23252	11601	1	0	\N
345484	1678	25200791915000	23254	11602	0	0	\N
345485	1874	22868000	23254	11602	1	0	\N
345486	1678	25200791915000	23255	11602	0	0	\N
345487	1874	22868000	23255	11602	1	0	\N
345494	1678	25200791918000	23259	11605	0	0	\N
345495	1874	22877000	23259	11605	1	0	\N
345496	1678	25200791918000	23260	11605	0	0	\N
345497	1874	22877000	23260	11605	1	0	\N
345505	1678	25200791921000	23264	11608	0	0	\N
345506	1821	700693000000	23264	11608	1	0	\N
345507	1874	22886000	23264	11608	2	0	\N
345510	1678	25200791922000	23266	11609	0	0	\N
345511	1874	22889000	23266	11609	1	0	\N
345512	1678	25200791922000	23267	11609	0	0	\N
345513	1874	22889000	23267	11609	1	0	\N
345514	1678	25200791922000	23268	11609	0	0	\N
345515	1874	22889000	23268	11609	1	0	\N
345516	1678	25200791923000	23269	11610	0	0	\N
345517	1874	22892000	23269	11610	1	0	\N
345520	1821	700693000000	23271	11581	0	0	\N
345521	1678	25200791924000	23272	11611	0	0	\N
345522	1678	25200791925000	23272	11611	1	0	\N
345523	1678	25200791926000	23272	11611	2	0	\N
345524	1874	22895000	23272	11611	3	0	\N
345525	1874	22898000	23272	11611	4	0	\N
345526	1874	22901000	23272	11611	5	0	\N
345533	1678	25200791927000	23274	11612	0	0	\N
345534	1874	22904000	23274	11612	1	0	\N
345535	1678	25200791927000	23275	11612	0	0	\N
345536	1874	22904000	23275	11612	1	0	\N
345544	1678	25200791931000	23279	11615	0	0	\N
345545	1874	22913000	23279	11615	1	0	\N
345548	1678	25200791932000	23281	11616	0	0	\N
345549	1874	22916000	23281	11616	1	0	\N
345554	1678	25200791898000	23284	11517	0	0	\N
345555	1678	25200791899000	23284	11517	1	0	\N
345556	1678	25200791900000	23284	11517	2	0	\N
345557	1678	25200791901000	23284	11517	3	0	\N
345558	2308	44000000000	23284	11517	4	0	\N
345559	1483	10000000	23284	11517	5	0	\N
345560	1678	25200791902000	23284	11517	6	0	\N
345561	1678	25200791903000	23284	11517	7	0	\N
345562	1678	25200791904000	23284	11517	8	0	\N
345563	1678	25200791905000	23284	11517	9	0	\N
345564	1678	25200791906000	23284	11517	10	0	\N
345565	1678	25200791907000	23284	11517	11	0	\N
345566	1678	25200791908000	23284	11517	12	0	\N
345567	1678	25200791909000	23284	11517	13	0	\N
345568	1678	25200791910000	23284	11517	14	0	\N
345569	1678	25200791911000	23284	11517	15	0	\N
345570	1678	25200791912000	23284	11517	16	0	\N
345571	1678	25200791913000	23284	11517	17	0	\N
345572	1678	25200791914000	23284	11517	18	0	\N
345573	1678	25200791915000	23284	11517	19	0	\N
345574	1678	25200791916000	23284	11517	20	0	\N
345575	1678	25200791917000	23284	11517	21	0	\N
345576	1678	25200791918000	23284	11517	22	0	\N
345447	1678	25200791911000	23243	11599	0	0	0
345448	1874	22856000	23243	11599	1	0	2
345459	1678	25200791912000	23246	11600	0	0	0
345460	1678	25200791913000	23246	11600	1	0	0
345461	1874	22859000	23246	11600	2	0	2
345469	1678	25200791914000	23249	11601	0	0	0
345470	1874	22865000	23249	11601	1	0	2
345482	1678	25200791915000	23253	11602	0	0	0
345483	1874	22868000	23253	11602	1	0	2
345488	1678	25200791916000	23256	11603	0	0	0
345490	1678	25200791917000	23257	11604	0	0	0
345491	1874	22874000	23257	11604	1	0	2
345492	1678	25200791918000	23258	11605	0	0	0
345493	1874	22877000	23258	11605	1	0	2
345499	1874	22880000	23261	11606	1	0	2
345500	1678	25200791920000	23262	11607	0	0	0
345501	1874	22883000	23262	11607	1	0	2
345502	1678	25200791921000	23263	11608	0	0	0
345503	1821	700693000000	23263	11608	1	0	2
345508	1678	25200791922000	23265	11609	0	0	0
345509	1874	22889000	23265	11609	1	0	2
345518	1678	25200791923000	23270	11610	0	0	0
345519	1874	22892000	23270	11610	1	0	2
345527	1678	25200791924000	23273	11611	0	0	0
345529	1678	25200791926000	23273	11611	2	0	0
345530	1874	22895000	23273	11611	3	0	2
345531	1874	22898000	23273	11611	4	0	2
345532	1874	22901000	23273	11611	5	0	2
345538	1874	22904000	23276	11612	1	0	2
345539	1678	25200791928000	23277	11613	0	0	0
345540	1678	25200791929000	23277	11613	1	0	0
345541	1874	22907000	23277	11613	2	0	2
345542	1874	22910000	23277	11613	3	0	2
345546	1678	25200791931000	23280	11615	0	0	0
345547	1874	22913000	23280	11615	1	0	2
345550	1678	25200791932000	23282	11616	0	0	0
345551	1874	22916000	23282	11616	1	0	2
345552	1678	25200791933000	23283	11617	0	0	0
345577	1678	25200791919000	23284	11517	23	0	\N
345578	1678	25200791920000	23284	11517	24	0	\N
345579	1678	25200791921000	23284	11517	25	0	\N
345580	1678	25200791922000	23284	11517	26	0	\N
345581	1678	25200791923000	23284	11517	27	0	\N
345582	1678	25200791924000	23284	11517	28	0	\N
345583	1678	25200791925000	23284	11517	29	0	\N
345584	1678	25200791926000	23284	11517	30	0	\N
345585	1678	25200791927000	23284	11517	31	0	\N
345586	1678	25200791928000	23284	11517	32	0	\N
345587	1678	25200791929000	23284	11517	33	0	\N
345588	1678	25200791930000	23284	11517	34	0	\N
345589	1678	25200791931000	23284	11517	35	0	\N
345590	1678	25200791932000	23284	11517	36	0	\N
345591	1678	25200791933000	23284	11517	37	0	\N
345592	1821	700693000000	23284	11517	38	0	\N
345593	1874	22562000	23284	11517	39	0	\N
345594	1874	22565000	23284	11517	40	0	\N
345595	1874	22568000	23284	11517	41	0	\N
345596	1874	22569000	23284	11517	42	0	\N
345597	1874	22570000	23284	11517	43	0	\N
345598	1874	22571000	23284	11517	44	0	\N
345599	1874	22572000	23284	11517	45	0	\N
345600	1874	22573000	23284	11517	46	0	\N
345601	1874	22574000	23284	11517	47	0	\N
345602	1874	22575000	23284	11517	48	0	\N
345603	1874	22576000	23284	11517	49	0	\N
345604	1874	22577000	23284	11517	51	0	\N
345605	1874	22578000	23284	11517	52	0	\N
345606	1874	22579000	23284	11517	53	0	\N
345607	1874	22580000	23284	11517	54	0	\N
345608	1874	22582000	23284	11517	55	0	\N
345609	1874	22584000	23284	11517	56	0	\N
345610	1874	22586000	23284	11517	57	0	\N
345611	1874	22588000	23284	11517	58	0	\N
345612	1874	22590000	23284	11517	59	0	\N
345613	1874	22592000	23284	11517	60	0	\N
345614	1874	22594000	23284	11517	61	0	\N
345615	1874	22596000	23284	11517	62	0	\N
345616	1874	22598000	23284	11517	63	0	\N
345617	1874	22600000	23284	11517	64	0	\N
345618	1874	22602000	23284	11517	65	0	\N
345619	1874	22604000	23284	11517	66	0	\N
345620	1874	22606000	23284	11517	67	0	\N
345621	1874	22608000	23284	11517	68	0	\N
345622	1874	22610000	23284	11517	69	0	\N
345623	1874	22612000	23284	11517	70	0	\N
345624	1874	22614000	23284	11517	71	0	\N
345625	1874	22616000	23284	11517	72	0	\N
345626	1874	22618000	23284	11517	73	0	\N
345627	1874	22620000	23284	11517	74	0	\N
345628	1874	22622000	23284	11517	75	0	\N
345629	1874	22624000	23284	11517	76	0	\N
345630	1874	22626000	23284	11517	77	0	\N
345631	1874	22628000	23284	11517	78	0	\N
345632	1874	22630000	23284	11517	79	0	\N
345633	1874	22632000	23284	11517	80	0	\N
345634	1874	22634000	23284	11517	81	0	\N
345635	1874	22636000	23284	11517	82	0	\N
345636	1874	22638000	23284	11517	83	0	\N
345637	1874	22640000	23284	11517	84	0	\N
345638	1874	22643000	23284	11517	85	0	\N
345639	1874	22646000	23284	11517	86	0	\N
345640	1874	22649000	23284	11517	87	0	\N
345641	1874	22652000	23284	11517	88	0	\N
345642	1874	22655000	23284	11517	89	0	\N
345643	1874	22658000	23284	11517	90	0	\N
345644	1874	22661000	23284	11517	91	0	\N
345645	1874	22664000	23284	11517	92	0	\N
345646	1874	22667000	23284	11517	93	0	\N
345647	1874	22670000	23284	11517	94	0	\N
345648	1874	22673000	23284	11517	95	0	\N
345649	1874	22676000	23284	11517	96	0	\N
345650	1874	22679000	23284	11517	97	0	\N
345651	1874	22682000	23284	11517	98	0	\N
345652	1874	22685000	23284	11517	99	0	\N
345653	1874	22688000	23284	11517	100	0	\N
345654	1874	22691000	23284	11517	101	0	\N
345655	1874	22694000	23284	11517	102	0	\N
345656	1874	22697000	23284	11517	103	0	\N
345657	1874	22700000	23284	11517	104	0	\N
345658	1874	22703000	23284	11517	105	0	\N
345659	1874	22706000	23284	11517	106	0	\N
345660	1874	22709000	23284	11517	107	0	\N
345661	1874	22712000	23284	11517	108	0	\N
345662	1874	22715000	23284	11517	109	0	\N
345663	1874	22718000	23284	11517	110	0	\N
345670	1678	25200791934000	23286	11618	0	0	\N
345671	1678	25200791935000	23286	11618	1	0	\N
345672	1678	25200791936000	23286	11618	2	0	\N
345673	1874	22922000	23286	11618	3	0	\N
345674	1874	22925000	23286	11618	4	0	\N
345675	1874	22928000	23286	11618	5	0	\N
345678	1678	25200791938000	23288	11620	0	0	\N
345679	1874	22934000	23288	11620	1	0	\N
345682	1678	25200791864000	23290	11485	0	0	\N
345683	2308	44000000000	23290	11485	1	0	\N
345684	1483	10000000	23290	11485	2	0	\N
345685	1678	25200791865000	23290	11485	3	0	\N
345686	1678	25200791866000	23290	11485	4	0	\N
345687	1678	25200791867000	23290	11485	5	0	\N
345688	1678	25200791868000	23290	11485	6	0	\N
345689	1678	25200791869000	23290	11485	7	0	\N
345690	1678	25200791870000	23290	11485	8	0	\N
345691	1678	25200791871000	23290	11485	9	0	\N
345692	1678	25200791872000	23290	11485	10	0	\N
345693	1678	25200791873000	23290	11485	11	0	\N
345694	1678	25200791874000	23290	11485	12	0	\N
345695	1678	25200791875000	23290	11485	13	0	\N
345696	1678	25200791876000	23290	11485	14	0	\N
345697	1678	25200791877000	23290	11485	15	0	\N
345698	1678	25200791878000	23290	11485	16	0	\N
345699	1678	25200791879000	23290	11485	17	0	\N
345700	1678	25200791880000	23290	11485	18	0	\N
345701	1678	25200791881000	23290	11485	19	0	\N
345702	1678	25200791882000	23290	11485	20	0	\N
345703	1678	25200791883000	23290	11485	21	0	\N
345704	1678	25200791884000	23290	11485	22	0	\N
345705	1678	25200791885000	23290	11485	23	0	\N
345706	1678	25200791886000	23290	11485	24	0	\N
345707	1678	25200791887000	23290	11485	25	0	\N
345708	1678	25200791888000	23290	11485	26	0	\N
345709	1678	25200791889000	23290	11485	27	0	\N
345710	1678	25200791890000	23290	11485	28	0	\N
345711	1678	25200791891000	23290	11485	29	0	\N
345712	1678	25200791892000	23290	11485	30	0	\N
345666	1678	25200791936000	23285	11618	2	0	0
345667	1874	22922000	23285	11618	3	0	2
345668	1874	22925000	23285	11618	4	0	2
345669	1874	22928000	23285	11618	5	0	2
345676	1678	25200791937000	23287	11619	0	0	0
345680	1678	25200791938000	23289	11620	0	0	0
345681	1874	22934000	23289	11620	1	0	2
345713	1678	25200791893000	23290	11485	31	0	\N
345714	1678	25200791894000	23290	11485	32	0	\N
345715	1678	25200791895000	23290	11485	33	0	\N
345716	1678	25200791896000	23290	11485	34	0	\N
345717	1678	25200791897000	23290	11485	35	0	\N
345718	1678	25200791898000	23290	11485	36	0	\N
345719	1678	25200791899000	23290	11485	37	0	\N
345720	1678	25200791900000	23290	11485	38	0	\N
345721	1678	25200791901000	23290	11485	39	0	\N
345722	1678	25200791902000	23290	11485	40	0	\N
345723	1678	25200791903000	23290	11485	41	0	\N
345724	1678	25200791904000	23290	11485	42	0	\N
345725	1678	25200791905000	23290	11485	43	0	\N
345726	1678	25200791906000	23290	11485	44	0	\N
345727	1678	25200791907000	23290	11485	45	0	\N
345728	1678	25200791908000	23290	11485	46	0	\N
345729	1678	25200791909000	23290	11485	47	0	\N
345730	1678	25200791910000	23290	11485	48	0	\N
345731	1678	25200791911000	23290	11485	49	0	\N
345732	1678	25200791912000	23290	11485	50	0	\N
345733	1678	25200791913000	23290	11485	51	0	\N
345734	1678	25200791914000	23290	11485	52	0	\N
345735	1678	25200791915000	23290	11485	53	0	\N
345736	1678	25200791916000	23290	11485	54	0	\N
345737	1678	25200791917000	23290	11485	55	0	\N
345738	1678	25200791918000	23290	11485	56	0	\N
345739	1678	25200791919000	23290	11485	57	0	\N
345740	1678	25200791920000	23290	11485	58	0	\N
345741	1678	25200791921000	23290	11485	59	0	\N
345742	1678	25200791922000	23290	11485	60	0	\N
345743	1678	25200791923000	23290	11485	61	0	\N
345744	1678	25200791924000	23290	11485	62	0	\N
345745	1678	25200791925000	23290	11485	63	0	\N
345746	1678	25200791926000	23290	11485	64	0	\N
345747	1678	25200791927000	23290	11485	65	0	\N
345748	1678	25200791928000	23290	11485	66	0	\N
345749	1678	25200791929000	23290	11485	67	0	\N
345750	1678	25200791930000	23290	11485	68	0	\N
345751	1678	25200791931000	23290	11485	69	0	\N
345752	1678	25200791932000	23290	11485	70	0	\N
345753	1678	25200791933000	23290	11485	71	0	\N
345754	1678	25200791934000	23290	11485	72	0	\N
345755	1678	25200791935000	23290	11485	73	0	\N
345756	1678	25200791936000	23290	11485	74	0	\N
345757	1678	25200791937000	23290	11485	75	0	\N
345758	1678	25200791938000	23290	11485	76	0	\N
345759	1821	700693000000	23290	11485	77	0	\N
345760	1874	22123000	23290	11485	78	0	\N
345761	1874	22126000	23290	11485	79	0	\N
345762	1874	22129000	23290	11485	80	0	\N
345763	1874	22132000	23290	11485	82	0	\N
345764	1874	22135000	23290	11485	83	0	\N
345765	1874	22138000	23290	11485	84	0	\N
345766	1874	22141000	23290	11485	85	0	\N
345767	1874	22144000	23290	11485	86	0	\N
345768	1874	22147000	23290	11485	87	0	\N
345769	1874	22150000	23290	11485	88	0	\N
345770	1874	22153000	23290	11485	89	0	\N
345771	1874	22156000	23290	11485	90	0	\N
345772	1874	22159000	23290	11485	91	0	\N
345773	1874	22162000	23290	11485	92	0	\N
345774	1874	22165000	23290	11485	93	0	\N
345775	1874	22168000	23290	11485	94	0	\N
345776	1874	22171000	23290	11485	95	0	\N
345777	1874	22174000	23290	11485	96	0	\N
345778	1874	22177000	23290	11485	97	0	\N
345779	1874	22180000	23290	11485	98	0	\N
345780	1874	22183000	23290	11485	99	0	\N
345781	1874	22186000	23290	11485	100	0	\N
345782	1874	22189000	23290	11485	101	0	\N
345783	1874	22192000	23290	11485	102	0	\N
345784	1874	22195000	23290	11485	103	0	\N
345785	1874	22198000	23290	11485	104	0	\N
345786	1874	22201000	23290	11485	105	0	\N
345787	1874	22204000	23290	11485	106	0	\N
345788	1874	22207000	23290	11485	107	0	\N
345789	1874	22210000	23290	11485	108	0	\N
345790	1874	22213000	23290	11485	109	0	\N
345791	1874	22216000	23290	11485	110	0	\N
345792	1874	22219000	23290	11485	111	0	\N
345793	1874	22222000	23290	11485	112	0	\N
345794	1874	22225000	23290	11485	113	0	\N
345795	1874	22228000	23290	11485	114	0	\N
345796	1874	22231000	23290	11485	115	0	\N
345797	1874	22234000	23290	11485	116	0	\N
345798	1874	22237000	23290	11485	117	0	\N
345799	1874	22240000	23290	11485	118	0	\N
345800	1874	22243000	23290	11485	119	0	\N
345801	1874	22246000	23290	11485	120	0	\N
345802	1874	22249000	23290	11485	121	0	\N
345803	1874	22252000	23290	11485	122	0	\N
345804	1874	22255000	23290	11485	123	0	\N
345805	1874	22258000	23290	11485	124	0	\N
345806	1874	22261000	23290	11485	125	0	\N
345813	1678	25200791942000	23293	11623	0	0	\N
345814	1678	25200791943000	23293	11623	1	0	\N
345815	1874	22946000	23293	11623	2	0	\N
345816	1874	22949000	23293	11623	3	0	\N
345817	1678	25200791942000	23294	11623	0	0	\N
345818	1678	25200791943000	23294	11623	1	0	\N
345819	1874	22946000	23294	11623	2	0	\N
345820	1874	22949000	23294	11623	3	0	\N
345825	1678	25200791944000	23296	11624	0	0	\N
345826	1874	22952000	23296	11624	1	0	\N
345839	1678	24480780769000	23302	11406	0	0	\N
345840	2308	44000000000	23302	11406	1	0	\N
345841	1483	10000000	23302	11406	2	0	\N
345842	1678	24480780770000	23302	11406	3	0	\N
345843	1678	24480780771000	23302	11406	4	0	\N
345844	1678	24480780772000	23302	11406	5	0	\N
345845	1678	24480780773000	23302	11406	6	0	\N
345846	1678	24480780774000	23302	11406	7	0	\N
345847	1678	24480780775000	23302	11406	8	0	\N
345848	1678	24480780776000	23302	11406	9	0	\N
345809	1874	22937000	23291	11621	2	0	2
345810	1874	22940000	23291	11621	3	0	2
345811	1678	25200791941000	23292	11622	0	0	0
345812	1874	22943000	23292	11622	1	0	2
345821	1678	25200791942000	23295	11623	0	0	0
345823	1874	22946000	23295	11623	2	0	2
345824	1874	22949000	23295	11623	3	0	2
345827	1678	25200791944000	23297	11624	0	0	0
345828	1874	22952000	23297	11624	1	0	2
345829	1678	25200791945000	23298	11625	0	0	0
345831	1874	22955000	23298	11625	2	0	2
345832	1874	22958000	23298	11625	3	0	2
345833	1678	25200791947000	23299	11626	0	0	0
345834	1874	22961000	23299	11626	1	0	2
345836	1874	22964000	23300	11627	1	0	2
345837	1678	25200791949000	23301	11628	0	0	0
345838	1874	22967000	23301	11628	1	0	2
345849	1678	24480780777000	23302	11406	10	0	\N
345850	1678	24480780778000	23302	11406	11	0	\N
345851	1678	24480780779000	23302	11406	12	0	\N
345852	1678	24480780780000	23302	11406	13	0	\N
345853	1678	24480780781000	23302	11406	14	0	\N
345854	1678	24480780782000	23302	11406	15	0	\N
345855	1678	24480780783000	23302	11406	16	0	\N
345856	1678	24480780784000	23302	11406	17	0	\N
345857	1678	24480780785000	23302	11406	18	0	\N
345858	1678	24480780786000	23302	11406	19	0	\N
345859	1678	24480780787000	23302	11406	20	0	\N
345860	1678	24480780788000	23302	11406	21	0	\N
345861	1678	24480780789000	23302	11406	22	0	\N
345862	1678	24480780790000	23302	11406	23	0	\N
345863	1678	24480780791000	23302	11406	24	0	\N
345864	1678	24480780792000	23302	11406	25	0	\N
345865	1678	24480780793000	23302	11406	26	0	\N
345866	1678	24480780794000	23302	11406	27	0	\N
345867	1678	24480780795000	23302	11406	28	0	\N
345868	1678	24480780796000	23302	11406	29	0	\N
345869	1678	24480780797000	23302	11406	30	0	\N
345870	1678	24480780798000	23302	11406	31	0	\N
345871	1678	24480780799000	23302	11406	32	0	\N
345872	1678	24480780800000	23302	11406	33	0	\N
345873	1678	24480780801000	23302	11406	34	0	\N
345874	1678	24480780802000	23302	11406	35	0	\N
345875	1678	24480780803000	23302	11406	36	0	\N
345876	1678	24480780804000	23302	11406	37	0	\N
345877	1678	24480780805000	23302	11406	38	0	\N
345878	1678	24480780806000	23302	11406	39	0	\N
345879	1678	24480780807000	23302	11406	40	0	\N
345880	1678	24480780808000	23302	11406	41	0	\N
345881	1678	24480780809000	23302	11406	42	0	\N
345882	1678	24480780810000	23302	11406	43	0	\N
345883	1678	24480780811000	23302	11406	44	0	\N
345884	1678	24480780812000	23302	11406	45	0	\N
345885	1678	24480780813000	23302	11406	46	0	\N
345886	1678	24480780814000	23302	11406	47	0	\N
345887	1678	24480780815000	23302	11406	48	0	\N
345888	1678	24480780816000	23302	11406	49	0	\N
345889	1678	24480780817000	23302	11406	50	0	\N
345890	1678	24480780818000	23302	11406	51	0	\N
345891	1678	24480780819000	23302	11406	52	0	\N
345892	1678	24480780820000	23302	11406	53	0	\N
345893	1678	24480780821000	23302	11406	54	0	\N
345894	1678	24480780822000	23302	11406	55	0	\N
345895	1678	24480780823000	23302	11406	56	0	\N
345896	1678	24480780824000	23302	11406	57	0	\N
345897	1678	24480780825000	23302	11406	58	0	\N
345898	1678	24480780826000	23302	11406	59	0	\N
345899	1678	24480780827000	23302	11406	60	0	\N
345900	1678	24480780828000	23302	11406	61	0	\N
345901	1678	24480780829000	23302	11406	62	0	\N
345902	1678	24480780830000	23302	11406	63	0	\N
345903	1678	24480780831000	23302	11406	64	0	\N
345904	1678	24480780832000	23302	11406	65	0	\N
345905	1678	24480780833000	23302	11406	66	0	\N
345906	1678	24480780834000	23302	11406	67	0	\N
345907	1678	24480780835000	23302	11406	68	0	\N
345908	1678	24480780836000	23302	11406	69	0	\N
345909	1678	24480780837000	23302	11406	70	0	\N
345910	1678	24480780838000	23302	11406	71	0	\N
345911	1678	24480780839000	23302	11406	72	0	\N
345912	1678	24480780840000	23302	11406	73	0	\N
345913	1678	24480780841000	23302	11406	74	0	\N
345914	1678	24480780842000	23302	11406	75	0	\N
345915	1678	24480780843000	23302	11406	76	0	\N
345916	1678	24480780844000	23302	11406	77	0	\N
345917	1678	24480780845000	23302	11406	78	0	\N
345918	1678	24480780846000	23302	11406	79	0	\N
345919	1678	24480780847000	23302	11406	80	0	\N
345920	1678	24480780848000	23302	11406	81	0	\N
345921	1678	24480780849000	23302	11406	82	0	\N
345922	1678	24480780850000	23302	11406	83	0	\N
345923	1678	24480780851000	23302	11406	84	0	\N
345924	1678	24480780852000	23302	11406	85	0	\N
345925	1678	24480780853000	23302	11406	86	0	\N
345926	1678	24480780854000	23302	11406	87	0	\N
345927	1678	24480780855000	23302	11406	89	0	\N
345928	1678	24480780856000	23302	11406	90	0	\N
345929	1678	24480780857000	23302	11406	91	0	\N
345930	1678	24480780858000	23302	11406	92	0	\N
345931	1678	24480780859000	23302	11406	93	0	\N
345932	1678	24480780860000	23302	11406	94	0	\N
345933	1678	24480780861000	23302	11406	95	0	\N
345934	1678	24480780862000	23302	11406	96	0	\N
345935	1678	24480780863000	23302	11406	97	0	\N
345936	1678	24480780864000	23302	11406	98	0	\N
345937	1678	24480780865000	23302	11406	99	0	\N
345938	1678	24480780866000	23302	11406	100	0	\N
345939	1678	24480780867000	23302	11406	101	0	\N
345940	1678	24480780868000	23302	11406	102	0	\N
345941	1678	24480780869000	23302	11406	103	0	\N
345942	1678	24480780870000	23302	11406	104	0	\N
345943	1678	24480780871000	23302	11406	105	0	\N
345944	1678	24480780872000	23302	11406	106	0	\N
345945	1678	24480780873000	23302	11406	107	0	\N
345946	1678	24480780874000	23302	11406	108	0	\N
345947	1678	24480780875000	23302	11406	109	0	\N
345948	1678	24480780876000	23302	11406	110	0	\N
345949	1678	24480780877000	23302	11406	111	0	\N
345950	1678	24480780878000	23302	11406	112	0	\N
345951	1678	24480780879000	23302	11406	113	0	\N
345952	1678	24480780880000	23302	11406	114	0	\N
345953	1678	24480780881000	23302	11406	115	0	\N
345954	1678	24480780882000	23302	11406	116	0	\N
345955	1678	24480780883000	23302	11406	117	0	\N
345956	1678	24480780884000	23302	11406	118	0	\N
345957	1678	24480780885000	23302	11406	119	0	\N
345958	1678	24480780886000	23302	11406	120	0	\N
345959	1678	24480780887000	23302	11406	121	0	\N
345960	1678	24480780888000	23302	11406	122	0	\N
345961	1678	24480780889000	23302	11406	123	0	\N
345962	1678	24480780890000	23302	11406	124	0	\N
345963	1678	24480780891000	23302	11406	125	0	\N
345964	1678	25200791950000	23303	11629	0	0	\N
345965	1874	22970000	23303	11629	1	0	\N
345968	1678	25200791950000	23305	11629	0	0	\N
345969	1874	22970000	23305	11629	1	0	\N
345970	1678	25200791950000	23306	11629	0	0	\N
345971	1874	22970000	23306	11629	1	0	\N
345978	1678	25200791954000	23309	11632	0	0	\N
345979	1874	22982000	23309	11632	1	0	\N
345983	1483	10000000	23312	11569	0	0	\N
345984	1678	25200791902000	23312	11569	1	0	\N
345972	1678	25200791951000	23307	11630	0	0	0
345973	1874	22973000	23307	11630	1	0	2
345974	1678	25200791952000	23308	11631	0	0	0
345975	1678	25200791953000	23308	11631	1	0	0
345976	1874	22976000	23308	11631	2	0	2
345980	1678	25200791954000	23310	11632	0	0	0
345981	1874	22982000	23310	11632	1	0	2
345982	1678	25200791955000	23311	11633	0	0	0
345985	1678	25200791903000	23312	11569	2	0	\N
345986	1678	25200791904000	23312	11569	3	0	\N
345987	1678	25200791905000	23312	11569	4	0	\N
345988	1678	25200791906000	23312	11569	5	0	\N
345989	1678	25200791907000	23312	11569	6	0	\N
345990	1678	25200791908000	23312	11569	7	0	\N
345991	1678	25200791909000	23312	11569	8	0	\N
345992	1678	25200791910000	23312	11569	9	0	\N
345993	1678	25200791911000	23312	11569	10	0	\N
345994	1678	25200791912000	23312	11569	11	0	\N
345995	1678	25200791913000	23312	11569	12	0	\N
345996	1678	25200791914000	23312	11569	13	0	\N
345997	1678	25200791915000	23312	11569	14	0	\N
345998	1678	25200791916000	23312	11569	15	0	\N
345999	1678	25200791917000	23312	11569	16	0	\N
346000	1678	25200791918000	23312	11569	17	0	\N
346001	1678	25200791919000	23312	11569	18	0	\N
346002	1678	25200791920000	23312	11569	19	0	\N
346003	1678	25200791921000	23312	11569	20	0	\N
346004	1678	25200791922000	23312	11569	21	0	\N
346005	1678	25200791923000	23312	11569	22	0	\N
346006	1678	25200791924000	23312	11569	23	0	\N
346007	1678	25200791925000	23312	11569	24	0	\N
346008	1678	25200791926000	23312	11569	25	0	\N
346009	1678	25200791927000	23312	11569	26	0	\N
346010	1678	25200791928000	23312	11569	27	0	\N
346011	1678	25200791929000	23312	11569	28	0	\N
346012	1678	25200791930000	23312	11569	29	0	\N
346013	1678	25200791931000	23312	11569	30	0	\N
346014	1678	25200791932000	23312	11569	31	0	\N
346015	1678	25200791933000	23312	11569	32	0	\N
346016	1678	25200791934000	23312	11569	33	0	\N
346017	1678	25200791935000	23312	11569	34	0	\N
346018	1678	25200791936000	23312	11569	35	0	\N
346019	1678	25200791937000	23312	11569	36	0	\N
346020	1678	25200791938000	23312	11569	37	0	\N
346021	1678	25200791939000	23312	11569	38	0	\N
346022	1678	25200791940000	23312	11569	39	0	\N
346023	1678	25200791941000	23312	11569	40	0	\N
346024	1678	25200791942000	23312	11569	41	0	\N
346025	1678	25200791943000	23312	11569	42	0	\N
346026	1678	25200791944000	23312	11569	43	0	\N
346027	1678	25200791945000	23312	11569	44	0	\N
346028	1678	25200791946000	23312	11569	45	0	\N
346029	1678	25200791947000	23312	11569	46	0	\N
346030	1678	25200791948000	23312	11569	47	0	\N
346031	1678	25200791949000	23312	11569	48	0	\N
346032	1678	25200791950000	23312	11569	49	0	\N
346033	1678	25200791951000	23312	11569	50	0	\N
346034	1678	25200791952000	23312	11569	51	0	\N
346035	1678	25200791953000	23312	11569	52	0	\N
346036	1678	25200791954000	23312	11569	53	0	\N
346037	1678	25200791955000	23312	11569	54	0	\N
346038	1874	22829000	23312	11569	55	0	\N
346039	1874	22832000	23312	11569	56	0	\N
346040	1874	22835000	23312	11569	57	0	\N
346041	1821	700693000000	23312	11569	58	0	\N
346042	1874	22838000	23312	11569	59	0	\N
346043	1874	22841000	23312	11569	60	0	\N
346044	1874	22844000	23312	11569	61	0	\N
346045	1874	22847000	23312	11569	62	0	\N
346046	1874	22850000	23312	11569	63	0	\N
346047	1874	22853000	23312	11569	64	0	\N
346048	1874	22856000	23312	11569	65	0	\N
346049	1874	22859000	23312	11569	66	0	\N
346050	1874	22862000	23312	11569	67	0	\N
346051	1874	22865000	23312	11569	68	0	\N
346052	1874	22868000	23312	11569	69	0	\N
346053	1874	22871000	23312	11569	70	0	\N
346054	1874	22874000	23312	11569	71	0	\N
346055	1874	22877000	23312	11569	72	0	\N
346056	1874	22880000	23312	11569	73	0	\N
346057	1874	22883000	23312	11569	74	0	\N
346058	1874	22886000	23312	11569	75	0	\N
346059	1874	22889000	23312	11569	76	0	\N
346060	1874	22892000	23312	11569	77	0	\N
346061	1874	22895000	23312	11569	78	0	\N
346062	1874	22898000	23312	11569	79	0	\N
346063	1874	22901000	23312	11569	80	0	\N
346064	1874	22904000	23312	11569	81	0	\N
346065	1874	22907000	23312	11569	82	0	\N
346066	1874	22910000	23312	11569	83	0	\N
346067	1874	22913000	23312	11569	84	0	\N
346068	1874	22916000	23312	11569	85	0	\N
346069	1874	22919000	23312	11569	86	0	\N
346070	1874	22922000	23312	11569	87	0	\N
346071	1874	22925000	23312	11569	88	0	\N
346072	1874	22928000	23312	11569	89	0	\N
346073	1874	22931000	23312	11569	91	0	\N
346074	1874	22934000	23312	11569	92	0	\N
346075	1874	22937000	23312	11569	93	0	\N
346076	1874	22940000	23312	11569	94	0	\N
346077	1874	22943000	23312	11569	95	0	\N
346078	1874	22946000	23312	11569	96	0	\N
346079	1874	22949000	23312	11569	97	0	\N
346080	1874	22952000	23312	11569	98	0	\N
346081	1874	22955000	23312	11569	99	0	\N
346082	1874	22958000	23312	11569	100	0	\N
346083	1874	22961000	23312	11569	101	0	\N
346084	1874	22964000	23312	11569	102	0	\N
346085	1874	22967000	23312	11569	103	0	\N
346086	1874	22970000	23312	11569	104	0	\N
346087	1874	22973000	23312	11569	105	0	\N
346088	1874	22976000	23312	11569	106	0	\N
346089	1874	22979000	23312	11569	107	0	\N
346090	1874	22982000	23312	11569	108	0	\N
346091	1874	22985000	23312	11569	109	0	\N
346097	1678	25200791958000	23315	11635	0	0	\N
346098	1678	25200791959000	23315	11635	1	0	\N
346099	1874	22994000	23315	11635	2	0	\N
346100	1874	22997000	23315	11635	3	0	\N
346105	1678	25200791958000	23317	11635	0	0	\N
346106	1678	25200791959000	23317	11635	1	0	\N
346107	1874	22994000	23317	11635	2	0	\N
346108	1874	22997000	23317	11635	3	0	\N
346117	1678	25920813964000	23321	11639	0	0	\N
346118	1874	23012000	23321	11639	1	0	\N
346094	1874	22985000	23313	11634	2	0	2
346095	1874	22988000	23313	11634	3	0	2
346096	1874	22991000	23313	11634	4	0	2
346101	1678	25200791958000	23316	11635	0	0	0
346102	1678	25200791959000	23316	11635	1	0	0
346104	1874	22997000	23316	11635	3	0	2
346109	1678	25920813960000	23318	11636	0	0	0
346110	1678	25920813961000	23318	11636	1	0	0
346111	1874	23000000	23318	11636	2	0	2
346112	1874	23003000	23318	11636	3	0	2
346114	1874	23006000	23319	11637	1	0	2
346115	1678	25920813963000	23320	11638	0	0	0
346116	1874	23009000	23320	11638	1	0	2
346119	1678	25920813964000	23322	11639	0	0	0
346123	1821	700693000000	23324	11548	0	0	\N
346124	1678	25920813965000	23325	11640	0	0	\N
346125	1874	23015000	23325	11640	1	0	\N
346126	1678	25920813966000	23326	11641	0	0	\N
346127	1678	25920813967000	23326	11641	1	0	\N
346128	1874	23018000	23326	11641	2	0	\N
346129	1874	23021000	23326	11641	3	0	\N
346134	1678	25920813968000	23330	11642	0	0	\N
346135	1874	23024000	23330	11642	1	0	\N
346138	1678	25200791806000	23332	11521	0	0	\N
346139	1678	25200791807000	23332	11521	1	0	\N
346140	2308	44000000000	23332	11521	2	0	\N
346141	1483	10000000	23332	11521	3	0	\N
346142	1678	25200791808000	23332	11521	4	0	\N
346143	1678	25200791809000	23332	11521	5	0	\N
346144	1678	25200791810000	23332	11521	6	0	\N
346145	1678	25200791811000	23332	11521	7	0	\N
346146	1678	25200791812000	23332	11521	8	0	\N
346147	1678	25200791813000	23332	11521	9	0	\N
346148	1678	25200791814000	23332	11521	10	0	\N
346149	1678	25200791815000	23332	11521	11	0	\N
346150	1678	25200791816000	23332	11521	12	0	\N
346151	1678	25200791817000	23332	11521	13	0	\N
346152	1678	25200791818000	23332	11521	14	0	\N
346153	1678	25200791819000	23332	11521	15	0	\N
346154	1678	25200791820000	23332	11521	16	0	\N
346155	1678	25200791821000	23332	11521	17	0	\N
346156	1678	25200791822000	23332	11521	18	0	\N
346157	1678	25200791823000	23332	11521	19	0	\N
346158	1678	25200791824000	23332	11521	20	0	\N
346159	1678	25200791825000	23332	11521	21	0	\N
346160	1678	25200791826000	23332	11521	22	0	\N
346161	1678	25200791827000	23332	11521	23	0	\N
346162	1678	25200791828000	23332	11521	24	0	\N
346163	1678	25200791829000	23332	11521	25	0	\N
346164	1678	25200791830000	23332	11521	26	0	\N
346165	1678	25200791831000	23332	11521	27	0	\N
346166	1678	25200791832000	23332	11521	28	0	\N
346167	1678	25200791833000	23332	11521	29	0	\N
346168	1678	25200791834000	23332	11521	30	0	\N
346169	1678	25200791835000	23332	11521	31	0	\N
346170	1678	25200791836000	23332	11521	32	0	\N
346171	1678	25200791837000	23332	11521	33	0	\N
346172	1678	25200791838000	23332	11521	34	0	\N
346173	1678	25200791839000	23332	11521	35	0	\N
346174	1678	25200791840000	23332	11521	36	0	\N
346175	1678	25200791841000	23332	11521	37	0	\N
346176	1678	25200791842000	23332	11521	38	0	\N
346177	1678	25200791843000	23332	11521	39	0	\N
346178	1678	25200791844000	23332	11521	40	0	\N
346179	1678	25200791845000	23332	11521	41	0	\N
346180	1678	25200791846000	23332	11521	42	0	\N
346181	1678	25200791847000	23332	11521	43	0	\N
346182	1678	25200791848000	23332	11521	44	0	\N
346183	1678	25200791849000	23332	11521	45	0	\N
346184	1678	25200791850000	23332	11521	46	0	\N
346185	1678	25200791851000	23332	11521	47	0	\N
346186	1678	25200791852000	23332	11521	48	0	\N
346187	1678	25200791853000	23332	11521	49	0	\N
346188	1678	25200791854000	23332	11521	50	0	\N
346189	1678	25200791855000	23332	11521	51	0	\N
346190	1678	25200791856000	23332	11521	52	0	\N
346191	1678	25200791857000	23332	11521	53	0	\N
346192	1678	25200791858000	23332	11521	54	0	\N
346193	1678	25200791859000	23332	11521	55	0	\N
346194	1678	25200791860000	23332	11521	56	0	\N
346195	1678	25200791861000	23332	11521	57	0	\N
346196	1678	25200791862000	23332	11521	58	0	\N
346197	1678	25200791863000	23332	11521	59	0	\N
346198	1678	25200791864000	23332	11521	60	0	\N
346199	1678	25200791865000	23332	11521	61	0	\N
346200	1678	25200791866000	23332	11521	62	0	\N
346201	1678	25200791867000	23332	11521	63	0	\N
346202	1678	25200791868000	23332	11521	64	0	\N
346203	1678	25200791869000	23332	11521	65	0	\N
346204	1678	25200791870000	23332	11521	66	0	\N
346205	1678	25200791871000	23332	11521	67	0	\N
346206	1678	25200791872000	23332	11521	68	0	\N
346207	1678	25200791873000	23332	11521	69	0	\N
346208	1678	25200791874000	23332	11521	70	0	\N
346209	1678	25200791875000	23332	11521	71	0	\N
346210	1678	25200791876000	23332	11521	72	0	\N
346211	1678	25200791877000	23332	11521	73	0	\N
346212	1678	25200791878000	23332	11521	74	0	\N
346213	1678	25200791879000	23332	11521	75	0	\N
346214	1678	25200791880000	23332	11521	76	0	\N
346215	1678	25200791881000	23332	11521	77	0	\N
346216	1678	25200791882000	23332	11521	78	0	\N
346217	1678	25200791883000	23332	11521	79	0	\N
346218	1678	25200791884000	23332	11521	80	0	\N
346219	1678	25200791885000	23332	11521	81	0	\N
346220	1678	25200791886000	23332	11521	82	0	\N
346221	1678	25200791887000	23332	11521	83	0	\N
346222	1678	25200791888000	23332	11521	84	0	\N
346223	1678	25200791889000	23332	11521	85	0	\N
346224	1678	25200791890000	23332	11521	87	0	\N
346225	1678	25200791891000	23332	11521	88	0	\N
346226	1678	25200791892000	23332	11521	89	0	\N
346227	1678	25200791893000	23332	11521	90	0	\N
346228	1678	25200791894000	23332	11521	91	0	\N
346229	1678	25200791895000	23332	11521	92	0	\N
346230	1678	25200791896000	23332	11521	93	0	\N
346231	1678	25200791897000	23332	11521	94	0	\N
346232	1678	25200791898000	23332	11521	95	0	\N
346233	1678	25200791899000	23332	11521	96	0	\N
346234	1678	25200791900000	23332	11521	97	0	\N
346235	1678	25200791901000	23332	11521	98	0	\N
346240	1678	25920813970000	23336	11644	0	0	\N
346241	1874	23030000	23336	11644	1	0	\N
346246	1678	25920813973000	23340	11647	0	0	\N
346247	1678	25920813974000	23340	11647	1	0	\N
346248	1874	23039000	23340	11647	2	0	\N
346249	1874	23042000	23340	11647	3	0	\N
346254	1678	25920813973000	23342	11647	0	0	\N
346255	1678	25920813974000	23342	11647	1	0	\N
346256	1874	23039000	23342	11647	2	0	\N
346130	1678	25920813966000	23329	11641	0	0	0
346131	1678	25920813967000	23329	11641	1	0	0
346132	1874	23018000	23329	11641	2	0	2
346133	1874	23021000	23329	11641	3	0	2
346136	1678	25920813968000	23331	11642	0	0	0
346236	1678	25920813969000	23334	11643	0	0	0
346237	1874	23027000	23334	11643	1	0	2
346238	1678	25920813970000	23335	11644	0	0	0
346239	1874	23030000	23335	11644	1	0	2
346242	1678	25920813971000	23337	11645	0	0	0
346244	1678	25920813972000	23339	11646	0	0	0
346245	1874	23036000	23339	11646	1	0	2
346250	1678	25920813973000	23341	11647	0	0	0
346251	1678	25920813974000	23341	11647	1	0	0
346253	1874	23042000	23341	11647	3	0	2
346257	1874	23042000	23342	11647	3	0	\N
346263	1678	25920813977000	23344	11649	0	0	\N
346264	1874	23051000	23344	11649	1	0	\N
346267	1874	23054000	23346	11650	0	0	\N
346271	1678	25920813979000	23349	11652	0	0	\N
346272	1678	25920813980000	23349	11652	1	0	\N
346273	1874	23060000	23349	11652	2	0	\N
346274	1874	23063000	23349	11652	3	0	\N
346275	1678	25920813979000	23350	11652	0	0	\N
346276	1678	25920813980000	23350	11652	1	0	\N
346277	1874	23060000	23350	11652	2	0	\N
346278	1874	23063000	23350	11652	3	0	\N
346279	1678	25920813979000	23351	11652	0	0	\N
346280	1678	25920813980000	23351	11652	1	0	\N
346281	1874	23060000	23351	11652	2	0	\N
346282	1874	23063000	23351	11652	3	0	\N
346287	1678	24480780892000	23353	11407	0	0	\N
346288	2305	199000000000	23353	11407	1	0	\N
346289	1678	24480780893000	23353	11407	2	0	\N
346290	1678	24480780894000	23353	11407	3	0	\N
346291	1678	24480780895000	23353	11407	4	0	\N
346292	1678	24480780896000	23353	11407	5	0	\N
346293	1678	24480780897000	23353	11407	6	0	\N
346294	1678	24480780898000	23353	11407	7	0	\N
346295	1678	24480780899000	23353	11407	8	0	\N
346296	1678	24480780900000	23353	11407	9	0	\N
346297	1678	24480780901000	23353	11407	10	0	\N
346298	1678	24480780902000	23353	11407	11	0	\N
346299	1678	24480780903000	23353	11407	12	0	\N
346300	1678	24480780904000	23353	11407	13	0	\N
346301	1678	24480780905000	23353	11407	14	0	\N
346302	1678	24480780906000	23353	11407	15	0	\N
346303	1678	24480780907000	23353	11407	16	0	\N
346304	1678	24480780908000	23353	11407	17	0	\N
346305	1678	24480780909000	23353	11407	18	0	\N
346306	1678	24480780910000	23353	11407	19	0	\N
346307	1678	24480780911000	23353	11407	20	0	\N
346308	1678	24480780912000	23353	11407	21	0	\N
346309	1678	24480780913000	23353	11407	22	0	\N
346310	1678	24480780914000	23353	11407	23	0	\N
346311	1678	24480780915000	23353	11407	24	0	\N
346312	1678	24480780916000	23353	11407	25	0	\N
346313	1678	24480780917000	23353	11407	26	0	\N
346314	1678	24480780918000	23353	11407	27	0	\N
346315	1678	24480780919000	23353	11407	28	0	\N
346316	1678	24480780920000	23353	11407	29	0	\N
346317	1678	24480780921000	23353	11407	30	0	\N
346318	1678	24480780922000	23353	11407	31	0	\N
346319	1678	24480780923000	23353	11407	32	0	\N
346320	1678	24480780924000	23353	11407	33	0	\N
346321	1678	24480780925000	23353	11407	34	0	\N
346322	1678	24480780926000	23353	11407	35	0	\N
346323	1678	24480780927000	23353	11407	36	0	\N
346324	1678	24480780928000	23353	11407	37	0	\N
346325	1678	24480780929000	23353	11407	38	0	\N
346326	1678	24480780930000	23353	11407	39	0	\N
346327	1678	24480780931000	23353	11407	40	0	\N
346328	1678	24480780932000	23353	11407	41	0	\N
346329	1678	24480780933000	23353	11407	42	0	\N
346330	1678	24480780934000	23353	11407	43	0	\N
346331	1678	24480780935000	23353	11407	44	0	\N
346332	1678	24480780936000	23353	11407	45	0	\N
346333	1678	24480780937000	23353	11407	46	0	\N
346334	1678	24480780938000	23353	11407	47	0	\N
346335	1678	24480780939000	23353	11407	48	0	\N
346336	1678	24480780940000	23353	11407	49	0	\N
346337	1678	24480780941000	23353	11407	50	0	\N
346338	1678	24480780942000	23353	11407	51	0	\N
346339	1678	24480780943000	23353	11407	52	0	\N
346340	1678	24480780944000	23353	11407	53	0	\N
346341	1678	24480780945000	23353	11407	54	0	\N
346342	1678	24480780946000	23353	11407	55	0	\N
346343	1678	24480780947000	23353	11407	56	0	\N
346344	1678	24480780948000	23353	11407	57	0	\N
346345	1678	24480780949000	23353	11407	58	0	\N
346346	1678	24480780950000	23353	11407	59	0	\N
346347	1678	24480780951000	23353	11407	60	0	\N
346348	1678	24480780952000	23353	11407	61	0	\N
346349	1678	24480780953000	23353	11407	62	0	\N
346350	1678	24480780954000	23353	11407	63	0	\N
346351	1678	24480780955000	23353	11407	64	0	\N
346352	1678	24480780956000	23353	11407	65	0	\N
346353	1678	24480780957000	23353	11407	66	0	\N
346354	1678	24480780958000	23353	11407	67	0	\N
346355	1678	24480780959000	23353	11407	68	0	\N
346356	1678	24480780960000	23353	11407	69	0	\N
346357	1678	24480780961000	23353	11407	70	0	\N
346358	1678	24480780962000	23353	11407	71	0	\N
346359	1678	24480780963000	23353	11407	72	0	\N
346360	1678	24480780964000	23353	11407	73	0	\N
346361	1678	24480780965000	23353	11407	74	0	\N
346362	1678	24480780966000	23353	11407	75	0	\N
346363	1678	24480780967000	23353	11407	76	0	\N
346364	1678	24480780968000	23353	11407	77	0	\N
346365	1678	24480780969000	23353	11407	78	0	\N
346366	1678	24480780970000	23353	11407	79	0	\N
346367	1678	24480780971000	23353	11407	80	0	\N
346368	1678	24480780972000	23353	11407	81	0	\N
346369	1678	24480780973000	23353	11407	82	0	\N
346370	1678	24480780974000	23353	11407	83	0	\N
346371	1678	24480780975000	23353	11407	84	0	\N
346372	1678	24480780976000	23353	11407	85	0	\N
346373	1678	24480780977000	23353	11407	86	0	\N
346374	1678	24480780978000	23353	11407	87	0	\N
346375	1678	24480780979000	23353	11407	89	0	\N
346376	1678	24480780980000	23353	11407	90	0	\N
346377	2297	8154338013959	23353	11407	91	0	\N
346378	2303	719000000000	23353	11407	92	0	\N
346379	1874	21598000	23353	11407	93	0	\N
346380	1874	21601000	23353	11407	94	0	\N
346381	715	2015703046640	23353	11407	95	0	\N
346382	2304	719000000000	23353	11407	96	0	\N
346383	1874	21603000	23353	11407	97	0	\N
346384	1874	21605000	23353	11407	98	0	\N
346385	1874	21607000	23353	11407	99	0	\N
346386	1647	20000000	23353	11407	100	0	\N
346387	1672	3601284000000	23353	11407	101	0	\N
346388	1874	21608000	23353	11407	102	0	\N
346389	1678	25920813981000	23354	11653	0	0	\N
346390	1874	23066000	23354	11653	1	0	\N
346260	1678	25920813976000	23343	11648	2	0	0
346261	1874	23045000	23343	11648	3	0	2
346262	1874	23048000	23343	11648	4	0	2
346265	1678	25920813977000	23345	11649	0	0	0
346266	1874	23051000	23345	11649	1	0	2
346269	1678	25920813978000	23348	11651	0	0	0
346270	1874	23057000	23348	11651	1	0	2
346283	1678	25920813979000	23352	11652	0	0	0
346284	1678	25920813980000	23352	11652	1	0	0
346285	1874	23060000	23352	11652	2	0	2
346391	1678	25920813981000	23355	11653	0	0	0
346392	1874	23066000	23355	11653	1	0	2
346400	1678	25920813985000	23359	11656	0	0	\N
346401	1874	23078000	23359	11656	2	0	\N
346402	1678	25920813985000	23360	11656	0	0	\N
346403	1874	23078000	23360	11656	2	0	\N
346411	1678	25920813988000	23364	11659	0	0	\N
346412	1874	23087000	23364	11659	1	0	\N
346417	2305	199000000000	23366	11487	0	0	\N
346426	1678	25920813993000	23369	11662	0	0	\N
346427	1678	25920813994000	23369	11662	1	0	\N
346428	1874	23102000	23369	11662	2	0	\N
346429	1874	23105000	23369	11662	3	0	\N
346430	1678	25920813995000	23371	11663	0	0	\N
346431	1874	23108000	23371	11663	1	0	\N
346434	1678	25920813995000	23373	11663	0	0	\N
346435	1874	23108000	23373	11663	1	0	\N
346436	1678	25920813996000	23374	11664	0	0	\N
346437	1874	23111000	23374	11664	1	0	\N
346438	1678	25920813996000	23375	11664	0	0	\N
346439	1874	23111000	23375	11664	1	0	\N
346442	1678	25920813997000	23377	11665	0	0	\N
346443	1678	25920813998000	23377	11665	1	0	\N
346444	1678	25920813999000	23377	11665	2	0	\N
346445	1874	23114000	23377	11665	3	0	\N
346446	1874	23117000	23377	11665	4	0	\N
346451	1678	25920813999000	23379	11666	0	0	\N
346452	1874	23120000	23379	11666	1	0	\N
346457	1678	25920814000000	23382	11667	0	0	\N
346458	1874	23123000	23382	11667	1	0	\N
346459	1678	25920813995000	23383	11663	0	0	\N
346460	1678	25920813996000	23383	11663	1	0	\N
346461	1678	25920813997000	23383	11663	2	0	\N
346462	1678	25920813998000	23383	11663	3	0	\N
346463	1678	25920813999000	23383	11663	4	0	\N
346464	1678	25920814000000	23383	11663	5	0	\N
346465	1874	23108000	23383	11663	6	0	\N
346466	1874	23111000	23383	11663	7	0	\N
346467	1874	23114000	23383	11663	8	0	\N
346468	1874	23117000	23383	11663	9	0	\N
346469	1874	23120000	23383	11663	10	0	\N
346470	1874	23123000	23383	11663	11	0	\N
346477	1678	25920814003000	23386	11669	0	0	\N
346478	1874	23132000	23386	11669	1	0	\N
346479	2305	199000000000	23387	11570	0	0	\N
346480	2308	44000000000	23387	11570	1	0	\N
346481	1483	10000000	23387	11570	2	0	\N
346482	1821	700693000000	23387	11570	3	0	\N
346483	2305	199000000000	23388	11550	0	0	\N
346494	1678	25920814004000	23391	11670	0	0	\N
346495	1678	25920814005000	23391	11670	1	0	\N
346496	1678	25920814006000	23391	11670	2	0	\N
346497	1678	25920814007000	23391	11670	3	0	\N
346498	1678	25920814008000	23391	11670	4	0	\N
346499	1874	23135000	23391	11670	5	0	\N
346500	1874	23138000	23391	11670	6	0	\N
346501	1874	23141000	23391	11670	7	0	\N
346502	1874	23144000	23391	11670	8	0	\N
346503	1874	23147000	23391	11670	9	0	\N
346508	1678	25920814009000	23393	11671	0	0	\N
346509	1678	25920814010000	23393	11671	1	0	\N
346510	1874	23150000	23393	11671	2	0	\N
346511	1874	23153000	23393	11671	3	0	\N
346512	1678	25920814009000	23394	11671	0	0	\N
346513	1678	25920814010000	23394	11671	1	0	\N
346514	1874	23150000	23394	11671	2	0	\N
346515	1874	23153000	23394	11671	3	0	\N
346516	1874	23150000	23395	11671	0	0	\N
346517	1874	23153000	23395	11671	1	0	\N
346518	1678	25920814009000	23396	11671	0	0	\N
346519	1678	25920814010000	23396	11671	1	0	\N
346520	1874	23150000	23396	11671	2	0	\N
346521	1874	23153000	23396	11671	3	0	\N
346522	2305	199000000000	23397	11486	0	0	\N
346523	1678	25200791939000	23397	11486	1	0	\N
346524	1678	25200791940000	23397	11486	2	0	\N
346525	1678	25200791941000	23397	11486	3	0	\N
346526	1678	25200791942000	23397	11486	4	0	\N
346527	1678	25200791943000	23397	11486	5	0	\N
346528	1678	25200791944000	23397	11486	6	0	\N
346395	1874	23069000	23356	11654	2	0	2
346396	1874	23072000	23356	11654	3	0	2
346397	1678	25920813984000	23357	11655	0	0	0
346398	1874	23075000	23357	11655	1	0	2
346399	1678	25920813985000	23358	11656	0	0	0
346405	1874	23078000	23361	11657	1	0	2
346406	1874	23081000	23361	11657	2	0	2
346407	1678	25920813987000	23362	11658	0	0	0
346408	1874	23084000	23362	11658	1	0	2
346409	1678	25920813988000	23363	11659	0	0	0
346413	1678	25920813989000	23365	11660	0	0	0
346414	1678	25920813990000	23365	11660	1	0	0
346415	1874	23090000	23365	11660	2	0	2
346416	1874	23093000	23365	11660	3	0	2
346419	1678	25920813992000	23367	11661	1	0	0
346420	1874	23096000	23367	11661	2	0	2
346421	1874	23099000	23367	11661	3	0	2
346422	1678	25920813993000	23368	11662	0	0	0
346423	1678	25920813994000	23368	11662	1	0	0
346425	1874	23105000	23368	11662	3	0	2
346432	1678	25920813995000	23372	11663	0	0	0
346433	1874	23108000	23372	11663	1	0	2
346440	1678	25920813996000	23376	11664	0	0	0
346441	1874	23111000	23376	11664	1	0	2
346448	1678	25920813998000	23378	11665	1	0	0
346449	1874	23114000	23378	11665	2	0	2
346450	1874	23117000	23378	11665	3	0	2
346453	1678	25920813999000	23380	11666	0	0	0
346455	1678	25920814000000	23381	11667	0	0	0
346456	1874	23123000	23381	11667	1	0	2
346471	1678	25920814001000	23384	11668	0	0	0
346472	1678	25920814002000	23384	11668	1	0	0
346473	1874	23126000	23384	11668	2	0	2
346475	1678	25920814003000	23385	11669	0	0	0
346476	1874	23132000	23385	11669	1	0	2
346484	1678	25920814004000	23390	11670	0	0	0
346485	1678	25920814005000	23390	11670	1	0	0
346486	1678	25920814006000	23390	11670	2	0	0
346488	1678	25920814008000	23390	11670	4	0	0
346489	1874	23135000	23390	11670	5	0	2
346490	1874	23138000	23390	11670	6	0	2
346491	1874	23141000	23390	11670	7	0	2
346493	1874	23147000	23390	11670	9	0	2
346504	1678	25920814009000	23392	11671	0	0	0
346505	1678	25920814010000	23392	11671	1	0	0
346506	1874	23150000	23392	11671	2	0	2
346507	1874	23153000	23392	11671	3	0	2
346529	1678	25200791945000	23397	11486	7	0	\N
346530	1678	25200791946000	23397	11486	8	0	\N
346531	1678	25200791947000	23397	11486	9	0	\N
346532	1678	25200791948000	23397	11486	10	0	\N
346533	1678	25200791949000	23397	11486	11	0	\N
346534	1678	25200791950000	23397	11486	12	0	\N
346535	1678	25200791951000	23397	11486	13	0	\N
346536	1678	25200791952000	23397	11486	14	0	\N
346537	1678	25200791953000	23397	11486	15	0	\N
346538	1678	25200791954000	23397	11486	16	0	\N
346539	1678	25200791955000	23397	11486	17	0	\N
346540	1678	25200791956000	23397	11486	18	0	\N
346541	1678	25200791957000	23397	11486	19	0	\N
346542	1678	25200791958000	23397	11486	20	0	\N
346543	1678	25200791959000	23397	11486	21	0	\N
346544	1678	25200791960000	23397	11486	22	0	\N
346545	1678	25200791961000	23397	11486	23	0	\N
346546	1678	25200791962000	23397	11486	24	0	\N
346547	1678	25200791963000	23397	11486	25	0	\N
346548	1678	25200791964000	23397	11486	26	0	\N
346549	1678	25200791965000	23397	11486	27	0	\N
346550	1678	25200791966000	23397	11486	28	0	\N
346551	1678	25200791967000	23397	11486	29	0	\N
346552	1678	25200791968000	23397	11486	30	0	\N
346553	1678	25200791969000	23397	11486	31	0	\N
346554	1678	25200791970000	23397	11486	32	0	\N
346555	1678	25200791971000	23397	11486	33	0	\N
346556	1678	25200791972000	23397	11486	34	0	\N
346557	1678	25200791973000	23397	11486	35	0	\N
346558	1678	25200791974000	23397	11486	36	0	\N
346559	1678	25200791975000	23397	11486	37	0	\N
346560	1678	25200791976000	23397	11486	38	0	\N
346561	1678	25200791977000	23397	11486	39	0	\N
346562	1678	25200791978000	23397	11486	40	0	\N
346563	1678	25200791979000	23397	11486	41	0	\N
346564	1678	25200791980000	23397	11486	42	0	\N
346565	1678	25200791981000	23397	11486	43	0	\N
346566	1678	25200791982000	23397	11486	44	0	\N
346567	1678	25200791983000	23397	11486	45	0	\N
346568	1678	25200791984000	23397	11486	46	0	\N
346569	1678	25200791985000	23397	11486	47	0	\N
346570	1678	25200791986000	23397	11486	48	0	\N
346571	1678	25200791987000	23397	11486	49	0	\N
346572	1678	25200791988000	23397	11486	50	0	\N
346573	1678	25200791989000	23397	11486	51	0	\N
346574	1678	25200791990000	23397	11486	52	0	\N
346575	1678	25200791991000	23397	11486	53	0	\N
346576	1678	25200791992000	23397	11486	54	0	\N
346577	1678	25200791993000	23397	11486	55	0	\N
346578	1678	25200791994000	23397	11486	56	0	\N
346579	1678	25200791995000	23397	11486	57	0	\N
346580	1678	25200791996000	23397	11486	58	0	\N
346581	1678	25200791997000	23397	11486	59	0	\N
346582	1678	25200791998000	23397	11486	60	0	\N
346583	1678	25200791999000	23397	11486	61	0	\N
346584	1678	25200792000000	23397	11486	62	0	\N
346585	1678	25200792001000	23397	11486	63	0	\N
346586	1678	25200792002000	23397	11486	64	0	\N
346587	1678	25200792003000	23397	11486	65	0	\N
346588	1678	25200792004000	23397	11486	66	0	\N
346589	1678	25200792005000	23397	11486	67	0	\N
346590	1678	25200792006000	23397	11486	68	0	\N
346591	1678	25200792007000	23397	11486	69	0	\N
346592	1678	25200792008000	23397	11486	70	0	\N
346593	1678	25200792009000	23397	11486	71	0	\N
346594	1678	25200792010000	23397	11486	72	0	\N
346595	1874	22264000	23397	11486	73	0	\N
346596	1874	22267000	23397	11486	74	0	\N
346597	1874	22270000	23397	11486	75	0	\N
346598	1874	22273000	23397	11486	76	0	\N
346599	1874	22276000	23397	11486	77	0	\N
346600	1874	22279000	23397	11486	78	0	\N
346601	1874	22282000	23397	11486	79	0	\N
346602	1874	22285000	23397	11486	80	0	\N
346603	1874	22288000	23397	11486	82	0	\N
346604	1874	22291000	23397	11486	83	0	\N
346605	1874	22294000	23397	11486	84	0	\N
346606	1874	22297000	23397	11486	85	0	\N
346607	1874	22300000	23397	11486	86	0	\N
346608	1874	22303000	23397	11486	87	0	\N
346609	1874	22306000	23397	11486	88	0	\N
346610	1874	22309000	23397	11486	89	0	\N
346611	1874	22312000	23397	11486	90	0	\N
346612	1874	22315000	23397	11486	91	0	\N
346613	1874	22318000	23397	11486	92	0	\N
346614	1874	22321000	23397	11486	93	0	\N
346615	1874	22324000	23397	11486	94	0	\N
346616	1874	22327000	23397	11486	95	0	\N
346617	1874	22330000	23397	11486	96	0	\N
346618	1874	22333000	23397	11486	97	0	\N
346621	1678	25920814011000	23399	11672	0	0	\N
346622	1874	23156000	23399	11672	1	0	\N
346639	1678	25920814016000	23405	11677	0	0	\N
346640	1678	25920814017000	23405	11677	1	0	\N
346641	1678	25920814018000	23405	11677	2	0	\N
346642	1678	25920814019000	23405	11677	3	0	\N
346643	1874	23171000	23405	11677	4	0	\N
346644	1874	23174000	23405	11677	5	0	\N
346645	1874	23177000	23405	11677	6	0	\N
346646	1874	23180000	23405	11677	7	0	\N
346647	1678	25920814016000	23406	11677	0	0	\N
346648	1678	25920814017000	23406	11677	1	0	\N
346649	1678	25920814018000	23406	11677	2	0	\N
346650	1678	25920814019000	23406	11677	3	0	\N
346651	1874	23171000	23406	11677	4	0	\N
346652	1874	23174000	23406	11677	5	0	\N
346653	1874	23177000	23406	11677	6	0	\N
346654	1874	23180000	23406	11677	7	0	\N
346659	1678	25920814022000	23408	11679	0	0	\N
346660	1874	23189000	23408	11679	1	0	\N
346663	2305	199000000000	23410	11538	0	0	\N
346664	2308	44000000000	23410	11538	1	0	\N
346623	1678	25920814012000	23400	11673	0	0	0
346624	1874	23159000	23400	11673	1	0	2
346625	1678	25920814013000	23401	11674	0	0	0
346626	1874	23162000	23401	11674	1	0	2
346627	1678	25920814014000	23402	11675	0	0	0
346629	1678	25920814015000	23403	11676	0	0	0
346630	1874	23168000	23403	11676	1	0	2
346631	1678	25920814016000	23404	11677	0	0	0
346632	1678	25920814017000	23404	11677	1	0	0
346633	1678	25920814018000	23404	11677	2	0	0
346635	1874	23171000	23404	11677	4	0	2
346636	1874	23174000	23404	11677	5	0	2
346637	1874	23177000	23404	11677	6	0	2
346638	1874	23180000	23404	11677	7	0	2
346656	1678	25920814021000	23407	11678	1	0	0
346657	1874	23183000	23407	11678	2	0	2
346658	1874	23186000	23407	11678	3	0	2
346661	1678	25920814022000	23409	11679	0	0	0
346662	1874	23189000	23409	11679	1	0	2
346665	1483	10000000	23410	11538	2	0	\N
346666	1678	25200791865000	23410	11538	3	0	\N
346667	1678	25200791866000	23410	11538	4	0	\N
346668	1678	25200791867000	23410	11538	5	0	\N
346669	1678	25200791868000	23410	11538	6	0	\N
346670	1678	25200791869000	23410	11538	7	0	\N
346671	1678	25200791870000	23410	11538	8	0	\N
346672	1678	25200791871000	23410	11538	9	0	\N
346673	1678	25200791872000	23410	11538	10	0	\N
346674	1678	25200791873000	23410	11538	11	0	\N
346675	1678	25200791874000	23410	11538	12	0	\N
346676	1678	25200791875000	23410	11538	13	0	\N
346677	1678	25200791876000	23410	11538	14	0	\N
346678	1678	25200791877000	23410	11538	15	0	\N
346679	1678	25200791878000	23410	11538	16	0	\N
346680	1678	25200791879000	23410	11538	17	0	\N
346681	1678	25200791880000	23410	11538	18	0	\N
346682	1678	25200791881000	23410	11538	19	0	\N
346683	1678	25200791882000	23410	11538	20	0	\N
346684	1678	25200791883000	23410	11538	21	0	\N
346685	1678	25200791884000	23410	11538	22	0	\N
346686	1678	25200791885000	23410	11538	23	0	\N
346687	1678	25200791886000	23410	11538	24	0	\N
346688	1678	25200791887000	23410	11538	25	0	\N
346689	1678	25200791888000	23410	11538	26	0	\N
346690	1678	25200791889000	23410	11538	27	0	\N
346691	1678	25200791890000	23410	11538	28	0	\N
346692	1678	25200791891000	23410	11538	29	0	\N
346693	1678	25200791892000	23410	11538	30	0	\N
346694	1678	25200791893000	23410	11538	31	0	\N
346695	1678	25200791894000	23410	11538	32	0	\N
346696	1678	25200791895000	23410	11538	33	0	\N
346697	1678	25200791896000	23410	11538	34	0	\N
346698	1678	25200791897000	23410	11538	35	0	\N
346699	1678	25200791898000	23410	11538	36	0	\N
346700	1678	25200791899000	23410	11538	37	0	\N
346701	1678	25200791900000	23410	11538	38	0	\N
346702	1678	25200791901000	23410	11538	39	0	\N
346703	1678	25200791902000	23410	11538	40	0	\N
346704	1678	25200791903000	23410	11538	41	0	\N
346705	1678	25200791904000	23410	11538	42	0	\N
346706	1678	25200791905000	23410	11538	43	0	\N
346707	1678	25200791906000	23410	11538	44	0	\N
346708	1678	25200791907000	23410	11538	45	0	\N
346709	1678	25200791908000	23410	11538	46	0	\N
346710	1678	25200791909000	23410	11538	47	0	\N
346711	1678	25200791910000	23410	11538	48	0	\N
346712	1678	25200791911000	23410	11538	49	0	\N
346713	1678	25200791912000	23410	11538	50	0	\N
346714	1678	25200791913000	23410	11538	51	0	\N
346715	1678	25200791914000	23410	11538	52	0	\N
346716	1678	25200791915000	23410	11538	53	0	\N
346717	1678	25200791916000	23410	11538	54	0	\N
346718	1678	25200791917000	23410	11538	55	0	\N
346719	1678	25200791918000	23410	11538	56	0	\N
346720	1678	25200791919000	23410	11538	57	0	\N
346721	1678	25200791920000	23410	11538	58	0	\N
346722	1678	25200791921000	23410	11538	59	0	\N
346723	1678	25200791922000	23410	11538	60	0	\N
346724	1678	25200791923000	23410	11538	61	0	\N
346725	1678	25200791924000	23410	11538	62	0	\N
346726	1678	25200791925000	23410	11538	63	0	\N
346727	1678	25200791926000	23410	11538	64	0	\N
346728	1678	25200791927000	23410	11538	65	0	\N
346729	1678	25200791928000	23410	11538	66	0	\N
346730	1678	25200791929000	23410	11538	67	0	\N
346731	1678	25200791930000	23410	11538	68	0	\N
346732	1678	25200791931000	23410	11538	69	0	\N
346733	1678	25200791932000	23410	11538	70	0	\N
346734	1678	25200791933000	23410	11538	71	0	\N
346735	1678	25200791934000	23410	11538	72	0	\N
346736	1678	25200791935000	23410	11538	73	0	\N
346737	1678	25200791936000	23410	11538	74	0	\N
346738	1678	25200791937000	23410	11538	75	0	\N
346739	1678	25200791938000	23410	11538	76	0	\N
346740	1678	25200791939000	23410	11538	77	0	\N
346741	1678	25200791940000	23410	11538	78	0	\N
346742	1678	25200791941000	23410	11538	79	0	\N
346743	1678	25200791942000	23410	11538	80	0	\N
346744	1678	25200791943000	23410	11538	81	0	\N
346745	1678	25200791944000	23410	11538	82	0	\N
346746	1678	25200791945000	23410	11538	83	0	\N
346747	1678	25200791946000	23410	11538	84	0	\N
346748	1678	25200791947000	23410	11538	85	0	\N
346749	1678	25200791948000	23410	11538	86	0	\N
346750	1678	25200791949000	23410	11538	87	0	\N
346751	1678	25200791950000	23410	11538	88	0	\N
346752	1678	25200791951000	23410	11538	89	0	\N
346753	1678	25200791952000	23410	11538	90	0	\N
346754	1678	25200791953000	23410	11538	91	0	\N
346755	1678	25200791954000	23410	11538	92	0	\N
346756	1678	25200791955000	23410	11538	93	0	\N
346757	1678	25200791956000	23410	11538	94	0	\N
346758	1678	25200791957000	23410	11538	95	0	\N
346759	1678	25200791958000	23410	11538	96	0	\N
346760	1678	25200791959000	23410	11538	97	0	\N
346761	1678	25200791960000	23410	11538	98	0	\N
346762	1678	25200791961000	23410	11538	99	0	\N
346763	1678	25200791962000	23410	11538	100	0	\N
346764	1678	25200791963000	23410	11538	101	0	\N
346765	1678	25200791964000	23410	11538	102	0	\N
346766	1678	25200791965000	23410	11538	103	0	\N
346767	1678	25200791966000	23410	11538	104	0	\N
346768	1678	25200791967000	23410	11538	105	0	\N
346769	1678	25200791968000	23410	11538	106	0	\N
346770	1678	25200791969000	23410	11538	107	0	\N
346771	1678	25200791970000	23410	11538	108	0	\N
346772	1678	25200791971000	23410	11538	110	0	\N
346773	1678	25200791972000	23410	11538	111	0	\N
346774	1678	25200791973000	23410	11538	112	0	\N
346775	1678	25200791974000	23410	11538	113	0	\N
346776	1678	25200791975000	23410	11538	114	0	\N
346777	1678	25200791976000	23410	11538	115	0	\N
346778	1678	25200791977000	23410	11538	116	0	\N
346779	1678	25200791978000	23410	11538	117	0	\N
346780	1678	25200791979000	23410	11538	118	0	\N
346781	1678	25200791980000	23410	11538	119	0	\N
346782	1678	25200791981000	23410	11538	120	0	\N
346783	1678	25200791982000	23410	11538	121	0	\N
346784	1678	25200791983000	23410	11538	122	0	\N
346785	1678	25200791984000	23410	11538	123	0	\N
346786	1678	25200791985000	23410	11538	124	0	\N
346787	1678	25200791986000	23410	11538	125	0	\N
346792	1678	25920814025000	23413	11682	0	0	\N
346793	1678	25920814026000	23413	11682	1	0	\N
346794	1874	23198000	23413	11682	2	0	\N
346795	1874	23201000	23413	11682	3	0	\N
346800	1678	25920814025000	23415	11682	0	0	\N
346790	1678	25920814024000	23412	11681	0	0	0
346791	1874	23195000	23412	11681	2	0	2
346796	1678	25920814025000	23414	11682	0	0	0
346797	1678	25920814026000	23414	11682	1	0	0
346798	1874	23198000	23414	11682	2	0	2
346801	1678	25920814026000	23415	11682	1	0	\N
346802	1874	23198000	23415	11682	2	0	\N
346803	1874	23201000	23415	11682	3	0	\N
346804	1678	25920814011000	23416	11672	0	0	\N
346805	1678	25920814012000	23416	11672	1	0	\N
346806	1678	25920814013000	23416	11672	2	0	\N
346807	1678	25920814014000	23416	11672	3	0	\N
346808	1678	25920814015000	23416	11672	4	0	\N
346809	1678	25920814016000	23416	11672	5	0	\N
346810	1678	25920814017000	23416	11672	6	0	\N
346811	1678	25920814018000	23416	11672	7	0	\N
346812	1678	25920814019000	23416	11672	8	0	\N
346813	1678	25920814020000	23416	11672	9	0	\N
346814	1678	25920814021000	23416	11672	10	0	\N
346815	1678	25920814022000	23416	11672	11	0	\N
346816	1678	25920814023000	23416	11672	12	0	\N
346817	1678	25920814024000	23416	11672	13	0	\N
346818	1678	25920814025000	23416	11672	14	0	\N
346819	1678	25920814026000	23416	11672	15	0	\N
346820	1874	23156000	23416	11672	16	0	\N
346821	1874	23159000	23416	11672	17	0	\N
346822	1874	23162000	23416	11672	18	0	\N
346823	1874	23165000	23416	11672	19	0	\N
346824	1874	23168000	23416	11672	20	0	\N
346825	1874	23171000	23416	11672	21	0	\N
346826	1874	23174000	23416	11672	22	0	\N
346827	1874	23177000	23416	11672	23	0	\N
346828	1874	23180000	23416	11672	24	0	\N
346829	1874	23183000	23416	11672	25	0	\N
346830	1874	23186000	23416	11672	26	0	\N
346831	1874	23189000	23416	11672	27	0	\N
346832	1874	23192000	23416	11672	28	0	\N
346833	1874	23195000	23416	11672	29	0	\N
346834	1874	23198000	23416	11672	30	0	\N
346835	1874	23201000	23416	11672	31	0	\N
346836	1678	25920814027000	23417	11683	0	0	\N
346837	1874	23204000	23417	11683	1	0	\N
346845	1483	11000000	23421	11673	0	0	\N
346846	1678	25920814012000	23421	11673	1	0	\N
346847	1678	25920814013000	23421	11673	2	0	\N
346848	1678	25920814014000	23421	11673	3	0	\N
346849	1678	25920814015000	23421	11673	4	0	\N
346850	1678	25920814016000	23421	11673	5	0	\N
346851	1678	25920814017000	23421	11673	6	0	\N
346852	1678	25920814018000	23421	11673	7	0	\N
346853	1678	25920814019000	23421	11673	8	0	\N
346854	1678	25920814020000	23421	11673	9	0	\N
346855	1678	25920814021000	23421	11673	10	0	\N
346856	1678	25920814022000	23421	11673	11	0	\N
346857	1678	25920814023000	23421	11673	12	0	\N
346858	1678	25920814024000	23421	11673	13	0	\N
346859	1678	25920814025000	23421	11673	14	0	\N
346860	1678	25920814026000	23421	11673	15	0	\N
346861	1678	25920814027000	23421	11673	16	0	\N
346862	1678	25920814028000	23421	11673	17	0	\N
346863	1678	25920814029000	23421	11673	18	0	\N
346864	1874	23159000	23421	11673	19	0	\N
346865	1874	23162000	23421	11673	20	0	\N
346866	1874	23165000	23421	11673	21	0	\N
346867	1874	23168000	23421	11673	22	0	\N
346868	1874	23171000	23421	11673	23	0	\N
346869	1874	23174000	23421	11673	24	0	\N
346870	1874	23177000	23421	11673	25	0	\N
346871	1874	23180000	23421	11673	26	0	\N
346872	1874	23183000	23421	11673	27	0	\N
346873	1874	23186000	23421	11673	28	0	\N
346874	1874	23189000	23421	11673	29	0	\N
346875	1874	23192000	23421	11673	30	0	\N
346876	1874	23195000	23421	11673	31	0	\N
346877	1874	23198000	23421	11673	32	0	\N
346878	1874	23201000	23421	11673	33	0	\N
346879	1874	23204000	23421	11673	34	0	\N
346880	1874	23207000	23421	11673	35	0	\N
346881	1874	23210000	23421	11673	36	0	\N
346888	1678	25920814033000	23423	11687	0	0	\N
346889	1678	25920814030000	23424	11686	0	0	\N
346890	1678	25920814031000	23424	11686	1	0	\N
346891	1678	25920814032000	23424	11686	2	0	\N
346892	1678	25920814033000	23424	11686	3	0	\N
346893	1874	23213000	23424	11686	4	0	\N
346894	1874	23216000	23424	11686	5	0	\N
346895	1874	23219000	23424	11686	6	0	\N
346896	1874	23222000	23424	11686	7	0	\N
346897	1678	25920814033000	23425	11687	0	0	\N
346898	1874	23222000	23425	11687	1	0	\N
346903	1678	25920814035000	23428	11689	0	0	\N
346904	1874	23228000	23428	11689	1	0	\N
346907	1678	25920814035000	23430	11689	0	0	\N
346908	1874	23228000	23430	11689	1	0	\N
346909	1678	25920814035000	23431	11689	0	0	\N
346910	1874	23228000	23431	11689	1	0	\N
346911	1678	25920814036000	23432	11690	0	0	\N
346912	1874	23231000	23432	11690	1	0	\N
346915	1678	25920814036000	23434	11690	0	0	\N
346916	1874	23231000	23434	11690	1	0	\N
346917	1678	25920814036000	23435	11690	0	0	\N
346918	1874	23231000	23435	11690	1	0	\N
346919	1678	25920814036000	23436	11690	0	0	\N
346920	1874	23231000	23436	11690	1	0	\N
346921	1678	25920814037000	23437	11691	0	0	\N
346922	1874	23234000	23437	11691	1	0	\N
346925	1678	25920814037000	23440	11691	0	0	\N
346926	1874	23234000	23440	11691	1	0	\N
346927	1678	25920814037000	23441	11691	0	0	\N
346928	1874	23234000	23441	11691	1	0	\N
346929	1678	25920814037000	23442	11691	0	0	\N
346930	1874	23234000	23442	11691	1	0	\N
346931	1678	25920814037000	23444	11691	0	0	\N
346932	1874	23234000	23444	11691	1	0	\N
346935	1678	25920814038000	23448	11692	0	0	\N
346936	1874	23237000	23448	11692	1	0	\N
346840	1483	11000000	23419	11684	0	0	0
346841	1678	25920814028000	23419	11684	1	0	0
346842	1874	23207000	23419	11684	2	0	2
346843	1678	25920814029000	23420	11685	0	0	0
346844	1874	23210000	23420	11685	1	0	2
346883	1678	25920814031000	23422	11686	1	0	0
346884	1678	25920814032000	23422	11686	2	0	0
346885	1874	23213000	23422	11686	3	0	2
346886	1874	23216000	23422	11686	4	0	2
346887	1874	23219000	23422	11686	5	0	2
346900	1874	23222000	23426	11687	1	0	2
346901	1678	25920814034000	23427	11688	0	0	0
346902	1874	23225000	23427	11688	1	0	2
346905	1678	25920814035000	23429	11689	0	0	0
346913	1678	25920814036000	23433	11690	0	0	0
346914	1874	23231000	23433	11690	1	0	2
346923	1678	25920814037000	23439	11691	0	0	0
346924	1874	23234000	23439	11691	1	0	2
346933	1678	25920814038000	23447	11692	0	0	0
346939	1678	25920814030000	23450	11674	0	0	\N
346940	1678	25920814031000	23450	11674	1	0	\N
346941	1678	25920814032000	23450	11674	3	0	\N
346942	1678	25920814033000	23450	11674	4	0	\N
346943	1678	25920814034000	23450	11674	5	0	\N
346944	1678	25920814035000	23450	11674	6	0	\N
346945	1678	25920814036000	23450	11674	7	0	\N
346946	1678	25920814037000	23450	11674	8	0	\N
346947	1678	25920814038000	23450	11674	9	0	\N
346948	1678	25920814039000	23450	11674	10	0	\N
346951	1678	25920814041000	23452	11695	0	0	\N
346952	1874	23246000	23452	11695	1	0	\N
346955	1483	11000000	23454	11663	0	0	\N
346956	1678	25920813995000	23454	11663	1	0	\N
346957	1678	25920813996000	23454	11663	2	0	\N
346958	1678	25920813997000	23454	11663	3	0	\N
346959	1678	25920813998000	23454	11663	4	0	\N
346960	1678	25920813999000	23454	11663	5	0	\N
346961	1678	25920814000000	23454	11663	6	0	\N
346962	1678	25920814001000	23454	11663	7	0	\N
346963	1678	25920814002000	23454	11663	8	0	\N
346964	1678	25920814003000	23454	11663	9	0	\N
346965	1678	25920814004000	23454	11663	10	0	\N
346966	1678	25920814005000	23454	11663	11	0	\N
346967	1678	25920814006000	23454	11663	12	0	\N
346968	1678	25920814007000	23454	11663	13	0	\N
346969	1678	25920814008000	23454	11663	14	0	\N
346970	1678	25920814009000	23454	11663	15	0	\N
346971	1678	25920814010000	23454	11663	16	0	\N
346972	1678	25920814011000	23454	11663	17	0	\N
346973	1678	25920814012000	23454	11663	18	0	\N
346974	1678	25920814013000	23454	11663	19	0	\N
346975	1678	25920814014000	23454	11663	20	0	\N
346976	1678	25920814015000	23454	11663	21	0	\N
346977	1678	25920814016000	23454	11663	22	0	\N
346978	1678	25920814017000	23454	11663	23	0	\N
346979	1678	25920814018000	23454	11663	24	0	\N
346980	1678	25920814019000	23454	11663	25	0	\N
346981	1678	25920814020000	23454	11663	26	0	\N
346982	1678	25920814021000	23454	11663	27	0	\N
346983	1678	25920814022000	23454	11663	28	0	\N
346984	1678	25920814023000	23454	11663	29	0	\N
346985	1678	25920814024000	23454	11663	30	0	\N
346986	1678	25920814025000	23454	11663	31	0	\N
346987	1678	25920814026000	23454	11663	32	0	\N
346988	1678	25920814027000	23454	11663	33	0	\N
346989	1678	25920814028000	23454	11663	34	0	\N
346990	1678	25920814029000	23454	11663	35	0	\N
346991	1678	25920814030000	23454	11663	36	0	\N
346992	1678	25920814031000	23454	11663	37	0	\N
346993	1678	25920814032000	23454	11663	38	0	\N
346994	1678	25920814033000	23454	11663	39	0	\N
346995	1678	25920814034000	23454	11663	40	0	\N
346996	1678	25920814035000	23454	11663	41	0	\N
346997	1678	25920814036000	23454	11663	42	0	\N
346998	1678	25920814037000	23454	11663	43	0	\N
346999	1678	25920814038000	23454	11663	44	0	\N
347000	1678	25920814039000	23454	11663	45	0	\N
347001	1678	25920814040000	23454	11663	46	0	\N
347002	1678	25920814041000	23454	11663	47	0	\N
347003	1874	23108000	23454	11663	48	0	\N
347004	1874	23111000	23454	11663	49	0	\N
347005	1874	23114000	23454	11663	50	0	\N
347006	1874	23117000	23454	11663	51	0	\N
347007	1874	23120000	23454	11663	52	0	\N
347008	1874	23123000	23454	11663	53	0	\N
347009	1874	23126000	23454	11663	54	0	\N
347010	1874	23129000	23454	11663	55	0	\N
347011	1874	23132000	23454	11663	56	0	\N
347012	1874	23135000	23454	11663	57	0	\N
347013	1874	23138000	23454	11663	58	0	\N
347014	1874	23141000	23454	11663	59	0	\N
347015	1874	23144000	23454	11663	60	0	\N
347016	1874	23147000	23454	11663	61	0	\N
347017	1874	23150000	23454	11663	62	0	\N
347018	1874	23153000	23454	11663	63	0	\N
347019	1874	23156000	23454	11663	64	0	\N
347020	1874	23159000	23454	11663	65	0	\N
347021	1874	23162000	23454	11663	66	0	\N
347022	1874	23165000	23454	11663	67	0	\N
347023	1874	23168000	23454	11663	68	0	\N
347024	1874	23171000	23454	11663	69	0	\N
347025	1874	23174000	23454	11663	70	0	\N
347026	1874	23177000	23454	11663	71	0	\N
347027	1874	23180000	23454	11663	72	0	\N
347028	1874	23183000	23454	11663	73	0	\N
347029	1874	23186000	23454	11663	74	0	\N
347030	1874	23189000	23454	11663	75	0	\N
347031	1874	23192000	23454	11663	76	0	\N
347032	1874	23195000	23454	11663	77	0	\N
347033	1874	23198000	23454	11663	78	0	\N
347034	1874	23201000	23454	11663	79	0	\N
347035	1874	23204000	23454	11663	80	0	\N
347036	1874	23207000	23454	11663	81	0	\N
347037	1874	23210000	23454	11663	82	0	\N
347038	1874	23213000	23454	11663	83	0	\N
347039	1874	23216000	23454	11663	84	0	\N
347040	1874	23219000	23454	11663	85	0	\N
347041	1874	23222000	23454	11663	86	0	\N
347042	1874	23225000	23454	11663	87	0	\N
347043	1874	23228000	23454	11663	88	0	\N
347044	1874	23231000	23454	11663	89	0	\N
347045	1874	23234000	23454	11663	90	0	\N
347046	1874	23237000	23454	11663	91	0	\N
347047	1874	23240000	23454	11663	92	0	\N
347048	1874	23243000	23454	11663	93	0	\N
347049	1874	23246000	23454	11663	94	0	\N
347056	1678	25920814043000	23457	11697	0	0	\N
347057	1874	23253000	23457	11697	1	0	\N
347058	1874	23256000	23457	11697	2	0	\N
347059	1678	25920814043000	23458	11697	0	0	\N
347060	1874	23253000	23458	11697	1	0	\N
347061	1874	23256000	23458	11697	2	0	\N
347062	1678	25920814043000	23459	11697	0	0	\N
347063	1874	23253000	23459	11697	1	0	\N
347064	1874	23256000	23459	11697	2	0	\N
347065	1678	25920814043000	23461	11697	0	0	\N
347066	1874	23253000	23461	11697	1	0	\N
347067	1874	23256000	23461	11697	2	0	\N
347068	1678	25200791987000	23462	11539	0	0	\N
347069	1678	25200791988000	23462	11539	1	0	\N
347070	1678	25200791989000	23462	11539	2	0	\N
347071	1678	25200791990000	23462	11539	3	0	\N
347072	1678	25200791991000	23462	11539	4	0	\N
346949	1678	25920814040000	23451	11694	0	0	0
346950	1874	23243000	23451	11694	1	0	2
346953	1678	25920814041000	23453	11695	0	0	0
346954	1874	23246000	23453	11695	1	0	2
347050	1678	25920814042000	23455	11696	0	0	0
347052	1874	23251000	23455	11696	2	0	2
347053	1678	25920814043000	23456	11697	0	0	0
347054	1874	23253000	23456	11697	1	0	2
347055	1874	23256000	23456	11697	2	0	2
347073	1678	25200791992000	23462	11539	5	0	\N
347074	1678	25200791993000	23462	11539	6	0	\N
347075	1678	25200791994000	23462	11539	7	0	\N
347076	1678	25200791995000	23462	11539	8	0	\N
347077	1678	25200791996000	23462	11539	9	0	\N
347078	1678	25200791997000	23462	11539	10	0	\N
347079	1678	25200791998000	23462	11539	11	0	\N
347080	1678	25200791999000	23462	11539	12	0	\N
347081	1678	25200792000000	23462	11539	13	0	\N
347082	1678	25200792001000	23462	11539	14	0	\N
347083	1678	25200792002000	23462	11539	15	0	\N
347084	1678	25200792003000	23462	11539	16	0	\N
347085	1678	25200792004000	23462	11539	17	0	\N
347086	1678	25200792005000	23462	11539	18	0	\N
347087	1678	25200792006000	23462	11539	19	0	\N
347088	1678	25200792007000	23462	11539	20	0	\N
347089	1678	25200792008000	23462	11539	21	0	\N
347090	1678	25200792009000	23462	11539	22	0	\N
347091	1678	25200792010000	23462	11539	23	0	\N
347092	1678	25200792011000	23462	11539	24	0	\N
347093	1678	25200792012000	23462	11539	25	0	\N
347094	1678	25200792013000	23462	11539	26	0	\N
347095	1678	25200792014000	23462	11539	27	0	\N
347096	1678	25200792015000	23462	11539	28	0	\N
347097	1678	25200792016000	23462	11539	29	0	\N
347098	1678	25200792017000	23462	11539	30	0	\N
347099	1678	25200792018000	23462	11539	31	0	\N
347100	1678	25200792019000	23462	11539	32	0	\N
347101	1678	25200792020000	23462	11539	33	0	\N
347102	1678	25200792021000	23462	11539	34	0	\N
347103	1678	25200792022000	23462	11539	35	0	\N
347104	1678	25200792023000	23462	11539	36	0	\N
347105	1678	25200792024000	23462	11539	37	0	\N
347106	1678	25200792025000	23462	11539	38	0	\N
347107	1678	25200792026000	23462	11539	39	0	\N
347108	1678	25200792027000	23462	11539	40	0	\N
347109	1678	25200792028000	23462	11539	41	0	\N
347110	1678	25200792029000	23462	11539	42	0	\N
347111	1678	25200792030000	23462	11539	43	0	\N
347112	1678	25200792031000	23462	11539	44	0	\N
347113	1678	25200792032000	23462	11539	45	0	\N
347114	1678	25200792033000	23462	11539	46	0	\N
347115	1678	25200792034000	23462	11539	47	0	\N
347116	1678	25200792035000	23462	11539	48	0	\N
347117	1678	25200792036000	23462	11539	49	0	\N
347118	1678	25200792037000	23462	11539	50	0	\N
347119	1678	25200792038000	23462	11539	51	0	\N
347120	1678	25200792039000	23462	11539	52	0	\N
347121	1678	25200792040000	23462	11539	53	0	\N
347122	1678	25200792041000	23462	11539	54	0	\N
347123	1678	25200792042000	23462	11539	55	0	\N
347124	1678	25200792043000	23462	11539	56	0	\N
347125	1874	22705000	23462	11539	57	0	\N
347126	1874	22707000	23462	11539	58	0	\N
347127	1874	22710000	23462	11539	59	0	\N
347128	1874	22711000	23462	11539	60	0	\N
347129	1874	22712000	23462	11539	61	0	\N
347130	1874	22713000	23462	11539	62	0	\N
347131	1874	22716000	23462	11539	63	0	\N
347132	1874	22717000	23462	11539	64	0	\N
347133	1821	700693000000	23462	11539	65	0	\N
347134	1483	11000000	23462	11539	66	0	\N
347135	1874	22720000	23462	11539	67	0	\N
347136	1874	22723000	23462	11539	68	0	\N
347137	1874	22724000	23462	11539	69	0	\N
347138	1874	22727000	23462	11539	70	0	\N
347139	1874	22730000	23462	11539	71	0	\N
347140	1874	22733000	23462	11539	72	0	\N
347141	1874	22736000	23462	11539	73	0	\N
347142	1874	22739000	23462	11539	74	0	\N
347143	1874	22742000	23462	11539	75	0	\N
347144	1874	22745000	23462	11539	76	0	\N
347145	1874	22748000	23462	11539	77	0	\N
347146	1874	22751000	23462	11539	78	0	\N
347147	1874	22754000	23462	11539	79	0	\N
347148	1874	22757000	23462	11539	80	0	\N
347149	1874	22760000	23462	11539	81	0	\N
347150	1874	22763000	23462	11539	82	0	\N
347151	1874	22766000	23462	11539	83	0	\N
347152	1874	22769000	23462	11539	84	0	\N
347153	1874	22772000	23462	11539	85	0	\N
347154	1874	22775000	23462	11539	86	0	\N
347155	1874	22778000	23462	11539	87	0	\N
347156	1874	22781000	23462	11539	88	0	\N
347157	1874	22784000	23462	11539	89	0	\N
347158	1874	22787000	23462	11539	90	0	\N
347159	1874	22790000	23462	11539	91	0	\N
347160	1874	22793000	23462	11539	92	0	\N
347161	1874	22796000	23462	11539	93	0	\N
347162	1874	22799000	23462	11539	94	0	\N
347163	1874	22802000	23462	11539	95	0	\N
347164	1874	22805000	23462	11539	96	0	\N
347165	1874	22808000	23462	11539	97	0	\N
347166	1874	22811000	23462	11539	98	0	\N
347167	1874	22814000	23462	11539	99	0	\N
347168	1874	22817000	23462	11539	100	0	\N
347169	1874	22820000	23462	11539	101	0	\N
347170	1874	22823000	23462	11539	102	0	\N
347171	1874	22826000	23462	11539	103	0	\N
347172	1874	22829000	23462	11539	104	0	\N
347173	1874	22832000	23462	11539	105	0	\N
347174	1874	22835000	23462	11539	106	0	\N
347175	1874	22838000	23462	11539	107	0	\N
347176	1874	22841000	23462	11539	110	0	\N
347177	1874	22844000	23462	11539	111	0	\N
347178	1874	22847000	23462	11539	112	0	\N
347179	1874	22850000	23462	11539	113	0	\N
347199	1678	25920814049000	23466	11700	0	0	\N
347200	1874	23282000	23466	11700	1	0	\N
347201	1874	23284000	23466	11700	2	0	\N
347202	1874	23287000	23466	11700	3	0	\N
347203	1678	25920814050000	23467	11701	0	0	\N
347204	1874	23289000	23467	11701	1	0	\N
347205	1874	23292000	23467	11701	2	0	\N
347182	1678	25920814046000	23463	11698	2	0	0
347183	1874	23259000	23463	11698	3	0	2
347184	1874	23262000	23463	11698	4	0	2
347185	1874	23264000	23463	11698	5	0	2
347186	1874	23266000	23463	11698	6	0	2
347188	1874	23271000	23463	11698	8	0	2
347189	1678	25920814047000	23464	11699	0	0	0
347190	1678	25920814048000	23464	11699	1	0	0
347191	1874	23274000	23464	11699	2	0	2
347192	1874	23277000	23464	11699	3	0	2
347194	1874	23281000	23464	11699	5	0	2
347195	1678	25920814049000	23465	11700	0	0	0
347196	1874	23282000	23465	11700	1	0	2
347197	1874	23284000	23465	11700	2	0	2
347206	1678	25920814050000	23468	11701	0	0	0
347207	1874	23289000	23468	11701	1	0	2
347208	1874	23292000	23468	11701	2	0	2
347216	1678	25920814052000	23471	11703	0	0	\N
347217	1874	23300000	23471	11703	1	0	\N
347218	1874	23302000	23471	11703	2	0	\N
347219	1874	23303000	23471	11703	3	0	\N
347220	1678	25920814052000	23472	11703	0	0	\N
347221	1874	23300000	23472	11703	1	0	\N
347222	1874	23302000	23472	11703	2	0	\N
347223	1874	23303000	23472	11703	3	0	\N
347230	1678	25920814054000	23475	11705	0	0	\N
347231	1874	23310000	23475	11705	1	0	\N
347232	1874	23313000	23475	11705	2	0	\N
347233	1678	25920814054000	23476	11705	0	0	\N
347234	1874	23310000	23476	11705	1	0	\N
347235	1874	23313000	23476	11705	2	0	\N
347236	1678	25920814054000	23477	11705	0	0	\N
347237	1874	23310000	23477	11705	1	0	\N
347238	1874	23313000	23477	11705	2	0	\N
347239	1483	11000000	23479	11552	0	0	\N
347253	1678	25920814059000	23482	11709	0	0	\N
347254	1874	23335000	23482	11709	1	0	\N
347255	1874	23337000	23482	11709	2	0	\N
347265	1678	25920814060000	23485	11710	0	0	\N
347266	1678	25920814061000	23485	11710	1	0	\N
347267	1874	23339000	23485	11710	2	0	\N
347268	1874	23341000	23485	11710	3	0	\N
347269	1874	23344000	23485	11710	4	0	\N
347270	1874	23347000	23485	11710	5	0	\N
347275	1678	25920814063000	23490	11712	0	0	\N
347276	1874	23355000	23490	11712	1	0	\N
347277	1874	23358000	23490	11712	2	0	\N
347278	1678	25920814063000	23491	11712	0	0	\N
347279	1874	23355000	23491	11712	1	0	\N
347280	1874	23358000	23491	11712	2	0	\N
347290	1678	25920814064000	23494	11713	0	0	\N
347291	1678	25920814065000	23494	11713	1	0	\N
347292	1874	23360000	23494	11713	2	0	\N
347293	1874	23363000	23494	11713	3	0	\N
347294	1874	23366000	23494	11713	4	0	\N
347295	1874	23368000	23494	11713	5	0	\N
347296	1678	25920814066000	23495	11714	0	0	\N
347297	1874	23370000	23495	11714	1	0	\N
347298	1874	23373000	23495	11714	2	0	\N
347299	1874	23374000	23495	11714	3	0	\N
347300	1678	25920814066000	23496	11714	0	0	\N
347301	1874	23370000	23496	11714	1	0	\N
347302	1874	23373000	23496	11714	2	0	\N
347303	1874	23374000	23496	11714	3	0	\N
347304	1678	25920814066000	23497	11714	0	0	\N
347305	1874	23370000	23497	11714	1	0	\N
347306	1874	23373000	23497	11714	2	0	\N
347307	1874	23374000	23497	11714	3	0	\N
347312	1483	11000000	23499	11571	0	0	\N
347313	1874	22738000	23499	11571	1	0	\N
347314	1874	22740000	23499	11571	2	0	\N
347315	1874	22742000	23499	11571	3	0	\N
347316	1874	22744000	23499	11571	4	0	\N
347317	1874	22746000	23499	11571	5	0	\N
347318	1874	22748000	23499	11571	6	0	\N
347319	1874	22750000	23499	11571	7	0	\N
347320	1874	22752000	23499	11571	8	0	\N
347321	1874	22754000	23499	11571	9	0	\N
347322	1874	22756000	23499	11571	10	0	\N
347323	1874	22758000	23499	11571	11	0	\N
347324	1874	22760000	23499	11571	12	0	\N
347325	1874	22762000	23499	11571	13	0	\N
347326	1874	22764000	23499	11571	14	0	\N
347327	1874	22766000	23499	11571	15	0	\N
347328	1874	22768000	23499	11571	16	0	\N
347332	1678	25920814068000	23502	11716	0	0	\N
347333	1678	25920814069000	23502	11716	1	0	\N
347334	1874	23380000	23502	11716	2	0	\N
347335	1874	23383000	23502	11716	3	0	\N
347336	1874	23385000	23502	11716	4	0	\N
347337	1874	23387000	23502	11716	5	0	\N
347338	1874	23390000	23502	11716	6	0	\N
347211	1874	23297000	23469	11702	2	0	2
347212	1678	25920814052000	23470	11703	0	0	0
347213	1874	23300000	23470	11703	1	0	2
347214	1874	23302000	23470	11703	2	0	2
347215	1874	23303000	23470	11703	3	0	2
347225	1874	23305000	23473	11704	1	0	2
347226	1874	23308000	23473	11704	2	0	2
347227	1678	25920814054000	23474	11705	0	0	0
347228	1874	23310000	23474	11705	1	0	2
347229	1874	23313000	23474	11705	2	0	2
347241	1678	25920814056000	23480	11707	1	0	0
347242	1678	25920814057000	23480	11707	2	0	0
347243	1874	23316000	23480	11707	3	0	2
347244	1874	23319000	23480	11707	4	0	2
347246	1874	23322000	23480	11707	6	0	2
347247	1874	23324000	23480	11707	7	0	2
347248	1874	23327000	23480	11707	8	0	2
347249	1874	23329000	23480	11707	9	0	2
347250	1678	25920814058000	23481	11708	0	0	0
347252	1874	23334000	23481	11708	2	0	2
347256	1678	25920814059000	23483	11709	0	0	0
347257	1874	23335000	23483	11709	1	0	2
347258	1874	23337000	23483	11709	2	0	2
347259	1678	25920814060000	23484	11710	0	0	0
347261	1874	23339000	23484	11710	2	0	2
347262	1874	23341000	23484	11710	3	0	2
347263	1874	23344000	23484	11710	4	0	2
347264	1874	23347000	23484	11710	5	0	2
347272	1874	23349000	23487	11711	1	0	2
347273	1874	23352000	23487	11711	2	0	2
347274	1874	23353000	23487	11711	3	0	2
347281	1678	25920814063000	23492	11712	0	0	0
347282	1874	23355000	23492	11712	1	0	2
347284	1678	25920814064000	23493	11713	0	0	0
347285	1678	25920814065000	23493	11713	1	0	0
347286	1874	23360000	23493	11713	2	0	2
347287	1874	23363000	23493	11713	3	0	2
347288	1874	23366000	23493	11713	4	0	2
347308	1678	25920814066000	23498	11714	0	0	0
347309	1874	23370000	23498	11714	1	0	2
347310	1874	23373000	23498	11714	2	0	2
347311	1874	23374000	23498	11714	3	0	2
347330	1874	23376000	23501	11715	1	0	2
347331	1874	23379000	23501	11715	2	0	2
347339	1678	25920814068000	23503	11716	0	0	0
347340	1678	25920814069000	23503	11716	1	0	0
347341	1874	23380000	23503	11716	2	0	2
347343	1874	23385000	23503	11716	4	0	2
347344	1874	23387000	23503	11716	5	0	2
347349	1678	25920814070000	23505	11717	0	0	\N
347350	1874	23392000	23505	11717	1	0	\N
347351	1874	23395000	23505	11717	2	0	\N
347352	1678	25920814070000	23506	11717	0	0	\N
347353	1874	23392000	23506	11717	1	0	\N
347354	1874	23395000	23506	11717	2	0	\N
347355	1678	25920814070000	23507	11717	0	0	\N
347356	1874	23392000	23507	11717	1	0	\N
347357	1874	23395000	23507	11717	2	0	\N
347361	1678	25920814071000	23509	11718	0	0	\N
347362	1874	23397000	23509	11718	1	0	\N
347363	1874	23400000	23509	11718	2	0	\N
347364	1678	25920814072000	23510	11719	0	0	\N
347365	1874	23402000	23510	11719	1	0	\N
347366	1874	23403000	23510	11719	2	0	\N
347367	1874	23406000	23510	11719	3	0	\N
347372	1678	25920814072000	23512	11719	0	0	\N
347373	1874	23402000	23512	11719	1	0	\N
347374	1874	23403000	23512	11719	2	0	\N
347375	1874	23406000	23512	11719	3	0	\N
347377	1678	25920814073000	23514	11721	0	0	\N
347378	1874	23412000	23514	11721	1	0	\N
347379	1874	23414000	23514	11721	2	0	\N
347380	1874	23416000	23514	11721	3	0	\N
347381	1678	25920814073000	23515	11721	0	0	\N
347382	1874	23412000	23515	11721	1	0	\N
347383	1874	23414000	23515	11721	2	0	\N
347384	1874	23416000	23515	11721	3	0	\N
347387	1678	25920814074000	23517	11722	0	0	\N
347388	1874	23413000	23517	11722	1	0	\N
347389	1874	23416000	23517	11722	2	0	\N
347390	1874	23419000	23517	11722	3	0	\N
347391	1874	23421000	23517	11722	4	0	\N
347393	1678	25920814075000	23519	11723	0	0	\N
347394	1874	23413000	23519	11723	1	0	\N
347395	1874	23416000	23519	11723	2	0	\N
347396	1874	23419000	23519	11723	3	0	\N
347397	1874	23420000	23519	11723	4	0	\N
347398	1874	23422000	23519	11723	5	0	\N
347399	1874	23424000	23519	11723	6	0	\N
347400	1874	23427000	23519	11723	7	0	\N
347419	1678	25920814076000	23522	11724	0	0	\N
347420	1678	25920814077000	23522	11724	1	0	\N
347421	1678	25920814078000	23522	11724	2	0	\N
347422	1874	23430000	23522	11724	3	0	\N
347423	1874	23433000	23522	11724	4	0	\N
347424	1874	23436000	23522	11724	5	0	\N
347425	1874	23438000	23522	11724	6	0	\N
347426	1874	23440000	23522	11724	7	0	\N
347427	1874	23442000	23522	11724	8	0	\N
347428	1874	23443000	23522	11724	9	0	\N
347429	1483	11000000	23523	11653	0	0	\N
347430	1678	25920813981000	23523	11653	1	0	\N
347431	1678	25920813982000	23523	11653	2	0	\N
347432	1678	25920813983000	23523	11653	3	0	\N
347433	1678	25920813984000	23523	11653	4	0	\N
347434	1678	25920813985000	23523	11653	5	0	\N
347435	1678	25920813986000	23523	11653	6	0	\N
347436	1678	25920813987000	23523	11653	7	0	\N
347437	1678	25920813988000	23523	11653	8	0	\N
347438	1678	25920813989000	23523	11653	9	0	\N
347439	1678	25920813990000	23523	11653	10	0	\N
347440	1678	25920813991000	23523	11653	11	0	\N
347441	1678	25920813992000	23523	11653	12	0	\N
347442	1678	25920813993000	23523	11653	13	0	\N
347443	1678	25920813994000	23523	11653	14	0	\N
347444	1678	25920813995000	23523	11653	16	0	\N
347445	1678	25920813996000	23523	11653	17	0	\N
347446	1678	25920813997000	23523	11653	18	0	\N
347447	1678	25920813998000	23523	11653	19	0	\N
347448	1678	25920813999000	23523	11653	20	0	\N
347449	1678	25920814000000	23523	11653	21	0	\N
347450	1678	25920814001000	23523	11653	22	0	\N
347451	1678	25920814002000	23523	11653	23	0	\N
347452	1678	25920814003000	23523	11653	24	0	\N
347453	1678	25920814004000	23523	11653	25	0	\N
347454	1678	25920814005000	23523	11653	26	0	\N
347455	1678	25920814006000	23523	11653	27	0	\N
347456	1678	25920814007000	23523	11653	28	0	\N
347457	1678	25920814008000	23523	11653	29	0	\N
347458	1678	25920814009000	23523	11653	30	0	\N
347459	1678	25920814010000	23523	11653	31	0	\N
347460	1678	25920814011000	23523	11653	32	0	\N
347461	1678	25920814012000	23523	11653	33	0	\N
347462	1678	25920814013000	23523	11653	34	0	\N
347463	1678	25920814014000	23523	11653	35	0	\N
347464	1678	25920814015000	23523	11653	36	0	\N
347465	1678	25920814016000	23523	11653	37	0	\N
347466	1678	25920814017000	23523	11653	38	0	\N
347467	1678	25920814018000	23523	11653	39	0	\N
347468	1678	25920814019000	23523	11653	40	0	\N
347469	1678	25920814020000	23523	11653	41	0	\N
347470	1678	25920814021000	23523	11653	42	0	\N
347471	1678	25920814022000	23523	11653	43	0	\N
347472	1678	25920814023000	23523	11653	44	0	\N
347473	1678	25920814024000	23523	11653	45	0	\N
347474	1678	25920814025000	23523	11653	46	0	\N
347475	1678	25920814026000	23523	11653	47	0	\N
347476	1678	25920814027000	23523	11653	48	0	\N
347477	1678	25920814028000	23523	11653	49	0	\N
347478	1678	25920814029000	23523	11653	50	0	\N
347479	1678	25920814030000	23523	11653	51	0	\N
347480	1678	25920814031000	23523	11653	52	0	\N
347347	1874	23392000	23504	11717	1	0	2
347348	1874	23395000	23504	11717	2	0	2
347358	1678	25920814071000	23508	11718	0	0	0
347359	1874	23397000	23508	11718	1	0	2
347360	1874	23400000	23508	11718	2	0	2
347369	1874	23402000	23511	11719	1	0	2
347370	1874	23403000	23511	11719	2	0	2
347371	1874	23406000	23511	11719	3	0	2
347376	1874	23409000	23513	11720	0	0	2
347385	1678	25920814073000	23516	11721	0	0	0
347392	1678	25920814074000	23518	11722	0	0	0
347401	1678	25920814075000	23520	11723	0	0	0
347402	1874	23413000	23520	11723	1	0	2
347403	1874	23416000	23520	11723	2	0	2
347405	1874	23420000	23520	11723	4	0	2
347406	1874	23422000	23520	11723	5	0	2
347407	1874	23424000	23520	11723	6	0	2
347408	1874	23427000	23520	11723	7	0	2
347409	1678	25920814076000	23521	11724	0	0	0
347411	1678	25920814078000	23521	11724	2	0	0
347412	1874	23430000	23521	11724	3	0	2
347413	1874	23433000	23521	11724	4	0	2
347414	1874	23436000	23521	11724	5	0	2
347415	1874	23438000	23521	11724	6	0	2
347417	1874	23442000	23521	11724	8	0	2
347418	1874	23443000	23521	11724	9	0	2
347481	1678	25920814032000	23523	11653	53	0	\N
347482	1678	25920814033000	23523	11653	54	0	\N
347483	1678	25920814034000	23523	11653	55	0	\N
347484	1678	25920814035000	23523	11653	56	0	\N
347485	1678	25920814036000	23523	11653	57	0	\N
347486	1678	25920814037000	23523	11653	58	0	\N
347487	1678	25920814038000	23523	11653	59	0	\N
347488	1678	25920814039000	23523	11653	60	0	\N
347489	1678	25920814040000	23523	11653	61	0	\N
347511	1678	25920814081000	23529	11728	0	0	\N
347512	1678	25920814082000	23529	11728	1	0	\N
347513	1678	25920814083000	23529	11728	2	0	\N
347514	945	506263745391541	23529	11728	3	0	\N
347515	1065	907220979807644	23529	11728	4	0	\N
347516	1185	612120180476079	23529	11728	5	0	\N
347517	1311	1705725607568145	23529	11728	6	0	\N
347518	489	66458391250309	23529	11728	7	0	\N
347519	1874	23456000	23529	11728	8	0	\N
347520	1874	23458000	23529	11728	9	0	\N
347521	1874	23460000	23529	11728	10	0	\N
347522	1874	23462000	23529	11728	11	0	\N
347523	1874	23465000	23529	11728	12	0	\N
347524	1874	23468000	23529	11728	13	0	\N
347525	1874	23469000	23529	11728	14	0	\N
347533	1678	25920814085000	23532	11730	0	0	\N
347534	1874	23477000	23532	11730	1	0	\N
347535	1874	23479000	23532	11730	2	0	\N
347536	1874	23480000	23532	11730	3	0	\N
347540	1678	25920814086000	23534	11731	0	0	\N
347541	1874	23482000	23534	11731	1	0	\N
347542	1874	23485000	23534	11731	2	0	\N
347543	945	506263745391541	23535	11553	0	0	\N
347544	1065	907220979807644	23535	11553	1	0	\N
347545	1185	612120180476079	23535	11553	2	0	\N
347546	1311	1705725607568145	23535	11553	3	0	\N
347547	489	66458391250309	23535	11553	4	0	\N
347548	741	5034666003811	23535	11553	5	0	\N
347549	730	5034666003811	23535	11553	6	0	\N
347559	1678	25920814089000	23537	11733	0	0	\N
347560	1678	25920814090000	23537	11733	1	0	\N
347561	1678	25920814091000	23537	11733	2	0	\N
347562	1874	23497000	23537	11733	3	0	\N
347563	1874	23499000	23537	11733	4	0	\N
347564	1874	23501000	23537	11733	5	0	\N
347565	1874	23503000	23537	11733	6	0	\N
347566	1874	23506000	23537	11733	7	0	\N
347567	1874	23509000	23537	11733	8	0	\N
347568	1874	23512000	23537	11733	9	0	\N
347579	1678	25920814092000	23539	11734	0	0	\N
347580	1874	23515000	23539	11734	1	0	\N
347581	1874	23517000	23539	11734	2	0	\N
347582	1678	25920814092000	23540	11734	0	0	\N
347583	1874	23515000	23540	11734	1	0	\N
347584	1874	23517000	23540	11734	2	0	\N
347588	1678	25920814092000	23542	11734	0	0	\N
347589	1874	23515000	23542	11734	1	0	\N
347600	1678	25920814096000	23546	11738	0	0	\N
347601	1874	23535000	23546	11738	1	0	\N
347602	1874	23538000	23546	11738	2	0	\N
347606	1678	25920814096000	23548	11738	0	0	\N
347607	1874	23535000	23548	11738	1	0	\N
347608	1874	23538000	23548	11738	2	0	\N
347609	1678	25920814097000	23549	11739	0	0	\N
347610	1678	25920814098000	23549	11739	1	0	\N
347611	1874	23539000	23549	11739	2	0	\N
347612	1874	23541000	23549	11739	3	0	\N
347613	1874	23543000	23549	11739	4	0	\N
347614	1874	23546000	23549	11739	5	0	\N
347615	1874	23549000	23549	11739	6	0	\N
347616	1678	25920814097000	23551	11739	0	0	\N
347492	1874	23448000	23524	11725	2	0	2
347493	1678	25920814080000	23525	11726	0	0	0
347494	1874	23450000	23525	11726	1	0	2
347495	1874	23453000	23525	11726	2	0	2
347496	1678	25920814081000	23528	11728	0	0	0
347498	1678	25920814083000	23528	11728	2	0	0
347499	945	506263745391541	23528	11728	3	0	0
347500	1065	907220979807644	23528	11728	4	0	0
347501	1185	612120180476079	23528	11728	5	0	0
347502	1311	1705725607568145	23528	11728	6	0	0
347504	1874	23456000	23528	11728	8	0	2
347505	1874	23458000	23528	11728	9	0	2
347506	1874	23460000	23528	11728	10	0	2
347507	1874	23462000	23528	11728	11	0	2
347509	1874	23468000	23528	11728	13	0	2
347510	1874	23469000	23528	11728	14	0	2
347526	1678	25920814084000	23530	11729	0	0	0
347527	1874	23472000	23530	11729	1	0	2
347528	1874	23474000	23530	11729	2	0	2
347530	1874	23477000	23531	11730	1	0	2
347531	1874	23479000	23531	11730	2	0	2
347532	1874	23480000	23531	11730	3	0	2
347537	1678	25920814086000	23533	11731	0	0	0
347538	1874	23482000	23533	11731	1	0	2
347550	1678	25920814087000	23536	11732	0	0	0
347551	741	5034666003811	23536	11732	1	0	0
347552	730	5034666003811	23536	11732	2	0	0
347553	1678	25920814088000	23536	11732	3	0	0
347555	1874	23488000	23536	11732	5	0	2
347556	1874	23490000	23536	11732	6	0	2
347557	1874	23493000	23536	11732	7	0	2
347558	1874	23496000	23536	11732	8	0	2
347569	1678	25920814089000	23538	11733	0	0	0
347571	1678	25920814091000	23538	11733	2	0	0
347572	1874	23497000	23538	11733	3	0	2
347573	1874	23499000	23538	11733	4	0	2
347574	1874	23501000	23538	11733	5	0	2
347575	1874	23503000	23538	11733	6	0	2
347577	1874	23509000	23538	11733	8	0	2
347578	1874	23512000	23538	11733	9	0	2
347585	1678	25920814092000	23541	11734	0	0	0
347586	1874	23515000	23541	11734	1	0	2
347590	1678	25920814093000	23543	11735	0	0	0
347591	1874	23520000	23543	11735	1	0	2
347592	1874	23522000	23543	11735	2	0	2
347593	1678	25920814094000	23544	11736	0	0	0
347594	1874	23525000	23544	11736	1	0	2
347596	1678	25920814095000	23545	11737	0	0	0
347597	1874	23529000	23545	11737	1	0	2
347598	1874	23532000	23545	11737	2	0	2
347599	1874	23533000	23545	11737	3	0	2
347603	1678	25920814096000	23547	11738	0	0	0
347605	1874	23538000	23547	11738	2	0	2
347617	1678	25920814098000	23551	11739	1	0	\N
347618	1874	23539000	23551	11739	2	0	\N
347619	1874	23541000	23551	11739	3	0	\N
347620	1874	23543000	23551	11739	4	0	\N
347621	1874	23546000	23551	11739	5	0	\N
347622	1874	23549000	23551	11739	6	0	\N
347630	1678	25920814099000	23553	11740	0	0	\N
347631	1678	25920814100000	23553	11740	1	0	\N
347632	1874	23552000	23553	11740	2	0	\N
347633	1874	23554000	23553	11740	3	0	\N
347634	1874	23556000	23553	11740	4	0	\N
347635	1874	23559000	23553	11740	5	0	\N
347642	1678	25920814099000	23555	11740	0	0	\N
347643	1678	25920814100000	23555	11740	1	0	\N
347644	1874	23552000	23555	11740	2	0	\N
347645	1874	23554000	23555	11740	3	0	\N
347646	1874	23556000	23555	11740	4	0	\N
347647	1874	23559000	23555	11740	5	0	\N
347648	1678	25920814101000	23556	11741	0	0	\N
347649	1874	23562000	23556	11741	1	0	\N
347650	1874	23563000	23556	11741	2	0	\N
347651	1874	23566000	23556	11741	3	0	\N
347652	1874	23568000	23556	11741	4	0	\N
347653	1874	23570000	23556	11741	5	0	\N
347654	1678	25920814101000	23557	11741	0	0	\N
347655	1874	23562000	23557	11741	1	0	\N
347656	1874	23563000	23557	11741	2	0	\N
347657	1874	23566000	23557	11741	3	0	\N
347658	1874	23568000	23557	11741	4	0	\N
347659	1874	23570000	23557	11741	5	0	\N
347666	1678	25920814101000	23559	11741	0	0	\N
347667	1874	23562000	23559	11741	1	0	\N
347668	1874	23563000	23559	11741	2	0	\N
347669	1874	23566000	23559	11741	3	0	\N
347670	1874	23568000	23559	11741	4	0	\N
347671	1874	23570000	23559	11741	5	0	\N
347682	1678	25920814104000	23562	11743	0	0	\N
347683	1874	23581000	23562	11743	1	0	\N
347684	1874	23583000	23562	11743	2	0	\N
347685	1874	23586000	23562	11743	3	0	\N
347686	1448	172786000001	23563	11744	0	0	\N
347687	1678	25920814105000	23563	11744	1	0	\N
347688	1874	23588000	23563	11744	2	0	\N
347689	1874	23591000	23563	11744	3	0	\N
347690	1448	172786000001	23564	11744	0	0	\N
347691	1678	25920814105000	23564	11744	1	0	\N
347692	1874	23588000	23564	11744	2	0	\N
347693	1874	23591000	23564	11744	3	0	\N
347698	1678	25920814106000	23567	11745	0	0	\N
347699	1678	25920814107000	23567	11745	1	0	\N
347700	1874	23593000	23567	11745	2	0	\N
347701	1874	23594000	23567	11745	3	0	\N
347702	1874	23596000	23567	11745	4	0	\N
347703	1874	23599000	23567	11745	5	0	\N
347714	1678	25920814108000	23570	11746	0	0	\N
347715	1448	5931786000001	23570	11746	1	0	\N
347716	1874	23601000	23570	11746	2	0	\N
347717	1874	23604000	23570	11746	3	0	\N
347721	1678	25920814109000	23572	11747	0	0	\N
347722	1874	23606000	23572	11747	1	0	\N
347723	1874	23609000	23572	11747	2	0	\N
347724	1678	25920814109000	23573	11747	0	0	\N
347725	1874	23606000	23573	11747	1	0	\N
347726	1874	23609000	23573	11747	2	0	\N
347727	1678	25920814110000	23574	11748	0	0	\N
347728	1874	23612000	23574	11748	1	0	\N
347729	1874	23613000	23574	11748	2	0	\N
347730	1874	23615000	23574	11748	3	0	\N
347731	1678	25920814110000	23575	11748	0	0	\N
347732	1874	23612000	23575	11748	1	0	\N
347733	1874	23613000	23575	11748	2	0	\N
347734	1874	23615000	23575	11748	3	0	\N
347739	1678	25920814110000	23577	11748	0	0	\N
347740	1874	23610000	23577	11748	1	0	\N
347741	1874	23612000	23577	11748	2	0	\N
347749	449	66458391250309	23580	11750	0	0	\N
347750	1678	25920814112000	23580	11750	1	0	\N
347751	1874	23622000	23580	11750	2	0	\N
347752	1874	23625000	23580	11750	3	0	\N
347625	1874	23539000	23552	11739	2	0	2
347626	1874	23541000	23552	11739	3	0	2
347627	1874	23543000	23552	11739	4	0	2
347628	1874	23546000	23552	11739	5	0	2
347629	1874	23549000	23552	11739	6	0	2
347637	1678	25920814100000	23554	11740	1	0	0
347638	1874	23552000	23554	11740	2	0	2
347639	1874	23554000	23554	11740	3	0	2
347640	1874	23556000	23554	11740	4	0	2
347641	1874	23559000	23554	11740	5	0	2
347661	1874	23562000	23558	11741	1	0	2
347662	1874	23563000	23558	11741	2	0	2
347663	1874	23566000	23558	11741	3	0	2
347664	1874	23568000	23558	11741	4	0	2
347672	1678	25920814102000	23560	11742	0	0	0
347673	1678	25920814103000	23560	11742	1	0	0
347674	1874	23573000	23560	11742	2	0	2
347675	1874	23575000	23560	11742	3	0	2
347676	1874	23577000	23560	11742	4	0	2
347678	1678	25920814104000	23561	11743	0	0	0
347679	1874	23581000	23561	11743	1	0	2
347680	1874	23583000	23561	11743	2	0	2
347681	1874	23586000	23561	11743	3	0	2
347694	1448	172786000001	23565	11744	0	0	15
347696	1874	23588000	23565	11744	2	0	2
347697	1874	23591000	23565	11744	3	0	2
347704	1678	25920814106000	23568	11745	0	0	0
347705	1678	25920814107000	23568	11745	1	0	0
347707	1874	23594000	23568	11745	3	0	2
347708	1874	23596000	23568	11745	4	0	2
347709	1874	23599000	23568	11745	5	0	2
347710	1678	25920814108000	23569	11746	0	0	0
347711	1448	5931786000001	23569	11746	1	0	15
347713	1874	23604000	23569	11746	3	0	2
347718	1678	25920814109000	23571	11747	0	0	0
347719	1874	23606000	23571	11747	1	0	2
347720	1874	23609000	23571	11747	2	0	2
347735	1678	25920814110000	23576	11748	0	0	0
347737	1874	23613000	23576	11748	2	0	2
347738	1874	23615000	23576	11748	3	0	2
347742	1678	25920814111000	23578	11749	0	0	0
347743	1874	23617000	23578	11749	1	0	2
347745	449	66458391250309	23579	11750	0	0	0
347746	1678	25920814112000	23579	11750	1	0	0
347747	1874	23622000	23579	11750	2	0	2
347748	1874	23625000	23579	11750	3	0	2
347756	1678	25920814114000	23582	11752	0	0	\N
347757	1874	23631000	23582	11752	1	0	\N
347758	1874	23633000	23582	11752	2	0	\N
347759	1874	23636000	23582	11752	3	0	\N
347764	1678	25920814114000	23584	11752	0	0	\N
347765	1874	23631000	23584	11752	1	0	\N
347766	1874	23633000	23584	11752	2	0	\N
347767	1874	23636000	23584	11752	3	0	\N
347768	1678	25920814114000	23585	11752	0	0	\N
347769	1874	23631000	23585	11752	1	0	\N
347770	1874	23633000	23585	11752	2	0	\N
347771	1874	23636000	23585	11752	3	0	\N
347775	1678	25920814115000	23587	11753	0	0	\N
347776	1874	23638000	23587	11753	1	0	\N
347777	1874	23641000	23587	11753	2	0	\N
347781	1678	25920814117000	23589	11755	0	0	\N
347782	1874	23647000	23589	11755	1	0	\N
347783	1874	23649000	23589	11755	2	0	\N
347784	1874	23652000	23589	11755	3	0	\N
347789	1678	25920814118000	23591	11756	0	0	\N
347790	1678	25920814119000	23591	11756	1	0	\N
347791	1874	23655000	23591	11756	2	0	\N
347792	1874	23657000	23591	11756	3	0	\N
347793	1874	23659000	23591	11756	4	0	\N
347794	1874	23662000	23591	11756	5	0	\N
347801	1678	25920814118000	23593	11756	0	0	\N
347802	1678	25920814119000	23593	11756	1	0	\N
347803	1874	23655000	23593	11756	2	0	\N
347804	1874	23657000	23593	11756	3	0	\N
347805	1874	23659000	23593	11756	4	0	\N
347806	1874	23662000	23593	11756	5	0	\N
347807	1678	25920814118000	23594	11756	0	0	\N
347808	1678	25920814119000	23594	11756	1	0	\N
347809	1874	23655000	23594	11756	2	0	\N
347810	1874	23657000	23594	11756	3	0	\N
347811	1874	23659000	23594	11756	4	0	\N
347812	1874	23662000	23594	11756	5	0	\N
347813	1678	25920814116000	23595	11754	0	0	\N
347814	1678	25920814117000	23595	11754	1	0	\N
347815	1678	25920814118000	23595	11754	2	0	\N
347816	1678	25920814119000	23595	11754	3	0	\N
347817	1874	23643000	23595	11754	4	0	\N
347818	1874	23644000	23595	11754	5	0	\N
347819	1874	23647000	23595	11754	6	0	\N
347820	1874	23649000	23595	11754	7	0	\N
347821	1874	23651000	23595	11754	8	0	\N
347822	1874	23653000	23595	11754	9	0	\N
347823	1874	23656000	23595	11754	10	0	\N
347824	1874	23659000	23595	11754	11	0	\N
347825	1874	23662000	23595	11754	12	0	\N
347833	1678	25920814122000	23597	11758	0	0	\N
347834	1874	23676000	23597	11758	1	0	\N
347835	1678	25920814113000	23598	11751	0	0	\N
347836	1678	25920814114000	23598	11751	1	0	\N
347837	1678	25920814115000	23598	11751	2	0	\N
347838	1678	25920814116000	23598	11751	3	0	\N
347839	1678	25920814117000	23598	11751	4	0	\N
347840	1678	25920814118000	23598	11751	5	0	\N
347841	1678	25920814119000	23598	11751	6	0	\N
347842	1678	25920814120000	23598	11751	7	0	\N
347843	1678	25920814121000	23598	11751	8	0	\N
347844	1678	25920814122000	23598	11751	9	0	\N
347845	1874	23627000	23598	11751	10	0	\N
347846	1874	23628000	23598	11751	11	0	\N
347847	1874	23631000	23598	11751	12	0	\N
347848	1874	23633000	23598	11751	13	0	\N
347849	1874	23635000	23598	11751	14	0	\N
347850	1874	23637000	23598	11751	15	0	\N
347851	1874	23638000	23598	11751	16	0	\N
347852	1874	23639000	23598	11751	17	0	\N
347853	1874	23642000	23598	11751	18	0	\N
347854	1874	23645000	23598	11751	19	0	\N
347855	1874	23648000	23598	11751	20	0	\N
347856	1874	23650000	23598	11751	21	0	\N
347857	1874	23652000	23598	11751	22	0	\N
347858	1874	23654000	23598	11751	23	0	\N
347859	1874	23656000	23598	11751	24	0	\N
347860	1874	23658000	23598	11751	25	0	\N
347861	1874	23661000	23598	11751	26	0	\N
347862	1874	23664000	23598	11751	27	0	\N
347863	1874	23667000	23598	11751	28	0	\N
347864	1874	23670000	23598	11751	29	0	\N
347865	1874	23673000	23598	11751	30	0	\N
347866	1874	23676000	23598	11751	31	0	\N
347882	38	66443668039709	23601	11759	0	0	\N
347883	969	506150276480512	23601	11759	1	0	\N
347884	1089	907016958757500	23601	11759	2	0	\N
347885	1209	611982415663305	23601	11759	3	0	\N
347886	1335	1705343415688246	23601	11759	4	0	\N
347887	1678	25920814123000	23601	11759	6	0	\N
347888	1678	25920814124000	23601	11759	7	0	\N
347755	1874	23630000	23581	11751	2	0	2
347760	1678	25920814114000	23583	11752	0	0	0
347761	1874	23631000	23583	11752	1	0	2
347762	1874	23633000	23583	11752	2	0	2
347763	1874	23636000	23583	11752	3	0	2
347773	1874	23638000	23586	11753	1	0	2
347774	1874	23641000	23586	11753	2	0	2
347778	1678	25920814116000	23588	11754	0	0	0
347779	1874	23643000	23588	11754	1	0	2
347780	1874	23646000	23588	11754	2	0	2
347786	1874	23647000	23590	11755	1	0	2
347787	1874	23649000	23590	11755	2	0	2
347788	1874	23652000	23590	11755	3	0	2
347795	1678	25920814118000	23592	11756	0	0	0
347797	1874	23655000	23592	11756	2	0	2
347798	1874	23657000	23592	11756	3	0	2
347799	1874	23659000	23592	11756	4	0	2
347800	1874	23662000	23592	11756	5	0	2
347826	1678	25920814120000	23596	11757	0	0	0
347828	1874	23663000	23596	11757	2	0	2
347829	1874	23666000	23596	11757	3	0	2
347830	1874	23669000	23596	11757	4	0	2
347831	1874	23671000	23596	11757	5	0	2
347832	1874	23673000	23596	11757	6	0	2
347868	1874	23676000	23599	11758	1	0	2
347869	38	66443668039709	23600	11759	0	0	0
347870	969	506150276480512	23600	11759	1	0	0
347871	1089	907016958757500	23600	11759	2	0	0
347873	1335	1705343415688246	23600	11759	4	0	0
347874	1678	25920814123000	23600	11759	6	0	0
347875	1678	25920814124000	23600	11759	7	0	0
347876	1874	23678000	23600	11759	8	0	2
347877	1874	23681000	23600	11759	9	0	2
347879	1874	23684000	23600	11759	11	0	2
347880	1874	23686000	23600	11759	12	0	2
347881	1874	23689000	23600	11759	13	0	2
347889	1874	23678000	23601	11759	8	0	\N
347890	1874	23681000	23601	11759	9	0	\N
347891	1874	23682000	23601	11759	10	0	\N
347892	1874	23684000	23601	11759	11	0	\N
347893	1874	23686000	23601	11759	12	0	\N
347894	1874	23689000	23601	11759	13	0	\N
347898	1678	25920814125000	23603	11760	0	0	\N
347899	1874	23692000	23603	11760	1	0	\N
347900	1874	23694000	23603	11760	2	0	\N
347901	1678	25920814126000	23604	11761	0	0	\N
347902	1874	23696000	23604	11761	1	0	\N
347903	1678	25920814126000	23605	11761	0	0	\N
347904	1874	23697000	23605	11761	1	0	\N
347905	1874	23699000	23605	11761	2	0	\N
347909	1448	172786000001	23607	11554	0	0	\N
347910	38	66443668039709	23607	11554	1	0	\N
347911	969	506150276480512	23607	11554	2	0	\N
347912	1089	907016958757500	23607	11554	3	0	\N
347913	1209	611982415663305	23607	11554	4	0	\N
347914	1335	1705343415688246	23607	11554	5	0	\N
347915	1678	25920814126000	23608	11761	0	0	\N
347916	1874	23697000	23608	11761	1	0	\N
347917	1874	23699000	23608	11761	2	0	\N
347918	1678	25920814126000	23609	11761	0	0	\N
347919	1874	23697000	23609	11761	1	0	\N
347920	1874	23699000	23609	11761	2	0	\N
347921	1678	25920814126000	23610	11761	0	0	\N
347922	1874	23697000	23610	11761	1	0	\N
347923	1874	23699000	23610	11761	2	0	\N
347937	1678	25920814128000	23613	11763	0	0	\N
347938	1678	25920814129000	23613	11763	1	0	\N
347939	1678	25920814130000	23613	11763	2	0	\N
347940	1874	23705000	23613	11763	3	0	\N
347941	1874	23707000	23613	11763	4	0	\N
347942	1874	23709000	23613	11763	5	0	\N
347943	1874	23712000	23613	11763	6	0	\N
347944	1874	23715000	23613	11763	7	0	\N
347945	1874	23716000	23613	11763	8	0	\N
347946	1874	23719000	23613	11763	9	0	\N
347947	1678	25920814131000	23615	11765	0	0	\N
347948	1678	25920814132000	23615	11765	1	0	\N
347949	1874	23722000	23615	11765	2	0	\N
347950	1874	23724000	23615	11765	3	0	\N
347951	1874	23726000	23615	11765	4	0	\N
347952	1874	23729000	23615	11765	5	0	\N
347953	1678	25920814131000	23616	11765	0	0	\N
347954	1678	25920814132000	23616	11765	1	0	\N
347955	1874	23722000	23616	11765	2	0	\N
347956	1874	23724000	23616	11765	3	0	\N
347957	1874	23726000	23616	11765	4	0	\N
347958	1874	23729000	23616	11765	5	0	\N
347965	1678	25920814133000	23618	11766	0	0	\N
347966	1874	23732000	23618	11766	1	0	\N
347967	1874	23734000	23618	11766	2	0	\N
347975	1678	25920814134000	23621	11767	0	0	\N
347976	1874	23735000	23621	11767	1	0	\N
347977	1874	23738000	23621	11767	2	0	\N
347978	1874	23740000	23621	11767	3	0	\N
347986	1678	25920814135000	23623	11768	0	0	\N
347987	1678	25920814136000	23623	11768	1	0	\N
347988	1678	25920814137000	23623	11768	2	0	\N
347989	1874	23741000	23623	11768	4	0	\N
347990	1874	23744000	23623	11768	5	0	\N
347991	1874	23747000	23623	11768	6	0	\N
347992	1874	23750000	23623	11768	7	0	\N
347993	1874	23752000	23623	11768	8	0	\N
347994	1874	23754000	23623	11768	9	0	\N
347995	1874	23756000	23623	11768	10	0	\N
347996	1678	25920814135000	23624	11768	0	0	\N
347997	1678	25920814136000	23624	11768	1	0	\N
347998	1678	25920814137000	23624	11768	2	0	\N
347999	1874	23741000	23624	11768	4	0	\N
348000	1874	23744000	23624	11768	5	0	\N
348001	1874	23747000	23624	11768	6	0	\N
348002	1874	23750000	23624	11768	7	0	\N
348003	1874	23752000	23624	11768	8	0	\N
348004	1874	23754000	23624	11768	9	0	\N
348005	1874	23756000	23624	11768	10	0	\N
348015	1448	12276856000001	23626	11702	0	0	\N
348016	38	66443668039709	23626	11702	1	0	\N
348017	969	506150276480512	23626	11702	2	0	\N
348018	1089	907016958757500	23626	11702	3	0	\N
348019	1209	611982415663305	23626	11702	4	0	\N
348020	1335	1705343415688246	23626	11702	5	0	\N
348021	945	506263745391541	23626	11702	6	0	\N
348022	1065	907220979807644	23626	11702	7	0	\N
348023	1185	612120180476079	23626	11702	8	0	\N
348024	1678	25920814051000	23626	11702	10	0	\N
347897	1874	23694000	23602	11760	2	0	2
347906	1678	25920814126000	23606	11761	0	0	0
347907	1874	23697000	23606	11761	1	0	2
347908	1874	23699000	23606	11761	2	0	2
347924	1678	25920814127000	23611	11762	0	0	0
347926	1874	23703000	23611	11762	2	0	2
347927	1678	25920814128000	23612	11763	0	0	0
347928	1678	25920814129000	23612	11763	1	0	0
347929	1678	25920814130000	23612	11763	2	0	0
347930	1874	23705000	23612	11763	3	0	2
347932	1874	23709000	23612	11763	5	0	2
347933	1874	23712000	23612	11763	6	0	2
347934	1874	23715000	23612	11763	7	0	2
347935	1874	23716000	23612	11763	8	0	2
347959	1678	25920814131000	23617	11765	0	0	0
347960	1678	25920814132000	23617	11765	1	0	0
347961	1874	23722000	23617	11765	2	0	2
347962	1874	23724000	23617	11765	3	0	2
347963	1874	23726000	23617	11765	4	0	2
347968	1678	25920814133000	23619	11766	0	0	0
347969	1874	23732000	23619	11766	1	0	2
347970	1874	23734000	23619	11766	2	0	2
347971	1678	25920814134000	23620	11767	0	0	0
347972	1874	23735000	23620	11767	1	0	2
347974	1874	23740000	23620	11767	3	0	2
347979	1678	25920814135000	23622	11768	0	0	0
347980	1678	25920814136000	23622	11768	1	0	0
347981	1678	25920814137000	23622	11768	2	0	0
347983	1874	23743000	23622	11768	5	0	2
347984	1874	23745000	23622	11768	6	0	2
347985	1874	23747000	23622	11768	7	0	2
348006	1678	25920814138000	23625	11769	0	0	0
348007	1678	25920814139000	23625	11769	1	0	0
348009	1874	23753000	23625	11769	3	0	2
348010	1874	23756000	23625	11769	4	0	2
348011	1874	23759000	23625	11769	5	0	2
348012	1874	23762000	23625	11769	6	0	2
348013	1874	23764000	23625	11769	7	0	2
348025	1678	25920814052000	23626	11702	11	0	\N
348026	1678	25920814053000	23626	11702	12	0	\N
348027	1678	25920814054000	23626	11702	13	0	\N
348028	1678	25920814055000	23626	11702	14	0	\N
348029	1678	25920814056000	23626	11702	15	0	\N
348030	1678	25920814057000	23626	11702	16	0	\N
348031	1678	25920814058000	23626	11702	17	0	\N
348032	1678	25920814059000	23626	11702	18	0	\N
348033	1678	25920814060000	23626	11702	19	0	\N
348034	1678	25920814061000	23626	11702	20	0	\N
348035	1678	25920814062000	23626	11702	22	0	\N
348036	1678	25920814063000	23626	11702	23	0	\N
348037	1678	25920814064000	23626	11702	24	0	\N
348038	1678	25920814065000	23626	11702	25	0	\N
348039	1678	25920814066000	23626	11702	26	0	\N
348040	1678	25920814067000	23626	11702	27	0	\N
348041	1678	25920814068000	23626	11702	28	0	\N
348042	1678	25920814069000	23626	11702	29	0	\N
348043	1678	25920814070000	23626	11702	30	0	\N
348044	1678	25920814071000	23626	11702	31	0	\N
348045	1678	25920814072000	23626	11702	32	0	\N
348046	1678	25920814073000	23626	11702	33	0	\N
348047	1678	25920814074000	23626	11702	34	0	\N
348048	1678	25920814075000	23626	11702	35	0	\N
348049	1678	25920814076000	23626	11702	36	0	\N
348050	1678	25920814077000	23626	11702	37	0	\N
348051	1678	25920814078000	23626	11702	38	0	\N
348052	1678	25920814079000	23626	11702	39	0	\N
348053	1678	25920814080000	23626	11702	40	0	\N
348054	1678	25920814081000	23626	11702	41	0	\N
348055	1678	25920814082000	23626	11702	42	0	\N
348056	1678	25920814083000	23626	11702	43	0	\N
348057	1678	25920814084000	23626	11702	44	0	\N
348058	1678	25920814085000	23626	11702	45	0	\N
348059	1678	25920814086000	23626	11702	46	0	\N
348060	1678	25920814087000	23626	11702	47	0	\N
348061	1678	25920814088000	23626	11702	48	0	\N
348062	1678	25920814089000	23626	11702	49	0	\N
348063	1678	25920814090000	23626	11702	50	0	\N
348064	1311	1705725607568145	23626	11702	51	0	\N
348065	489	66458391250309	23626	11702	52	0	\N
348066	741	5034666003811	23626	11702	53	0	\N
348067	730	5034666003811	23626	11702	54	0	\N
348068	1678	25920814091000	23626	11702	55	0	\N
348069	1678	25920814092000	23626	11702	56	0	\N
348070	1678	25920814093000	23626	11702	57	0	\N
348071	1678	25920814094000	23626	11702	58	0	\N
348072	1678	25920814095000	23626	11702	59	0	\N
348073	1678	25920814096000	23626	11702	60	0	\N
348074	1678	25920814097000	23626	11702	61	0	\N
348075	1678	25920814098000	23626	11702	62	0	\N
348076	1678	25920814099000	23626	11702	63	0	\N
348077	1678	25920814100000	23626	11702	64	0	\N
348078	1678	25920814101000	23626	11702	65	0	\N
348079	1678	25920814102000	23626	11702	66	0	\N
348080	1678	25920814103000	23626	11702	67	0	\N
348081	1678	25920814104000	23626	11702	68	0	\N
348082	1678	25920814105000	23626	11702	69	0	\N
348083	1678	25920814106000	23626	11702	70	0	\N
348084	1678	25920814107000	23626	11702	71	0	\N
348085	1678	25920814108000	23626	11702	72	0	\N
348086	1678	25920814109000	23626	11702	73	0	\N
348087	1678	25920814110000	23626	11702	74	0	\N
348088	1678	25920814111000	23626	11702	75	0	\N
348089	1678	25920814112000	23626	11702	76	0	\N
348090	1678	25920814113000	23626	11702	77	0	\N
348091	1678	25920814114000	23626	11702	78	0	\N
348092	1678	25920814115000	23626	11702	79	0	\N
348093	1678	25920814116000	23626	11702	80	0	\N
348094	1678	25920814117000	23626	11702	81	0	\N
348095	1678	25920814118000	23626	11702	82	0	\N
348096	1678	25920814119000	23626	11702	83	0	\N
348097	1678	25920814120000	23626	11702	84	0	\N
348098	1678	25920814121000	23626	11702	85	0	\N
348099	1678	25920814122000	23626	11702	86	0	\N
348100	1678	25920814123000	23626	11702	87	0	\N
348101	1678	25920814124000	23626	11702	88	0	\N
348102	1678	25920814125000	23626	11702	89	0	\N
348103	1678	25920814126000	23626	11702	90	0	\N
348104	1678	25920814127000	23626	11702	91	0	\N
348105	1678	25920814128000	23626	11702	92	0	\N
348106	1678	25920814129000	23626	11702	93	0	\N
348107	1678	25920814130000	23626	11702	94	0	\N
348108	1678	25920814131000	23626	11702	95	0	\N
348109	1678	25920814132000	23626	11702	96	0	\N
348110	1678	25920814133000	23626	11702	97	0	\N
348111	1678	25920814134000	23626	11702	98	0	\N
348112	1678	25920814135000	23626	11702	99	0	\N
348113	1678	25920814136000	23626	11702	100	0	\N
348114	1678	25920814137000	23626	11702	101	0	\N
348115	1678	25920814138000	23626	11702	102	0	\N
348116	1678	25920814139000	23626	11702	103	0	\N
348117	1874	23295000	23626	11702	105	0	\N
348118	1874	23298000	23626	11702	106	0	\N
348119	1874	23300000	23626	11702	107	0	\N
348120	1874	23302000	23626	11702	108	0	\N
348121	1874	23304000	23626	11702	109	0	\N
348122	1874	23307000	23626	11702	110	0	\N
348123	1874	23309000	23626	11702	111	0	\N
348124	1874	23311000	23626	11702	112	0	\N
348125	1874	23313000	23626	11702	113	0	\N
348126	1874	23314000	23626	11702	114	0	\N
348127	1874	23315000	23626	11702	115	0	\N
348128	1874	23316000	23626	11702	116	0	\N
348129	1874	23317000	23626	11702	117	0	\N
348130	1874	23320000	23626	11702	118	0	\N
348131	1874	23323000	23626	11702	119	0	\N
348132	1874	23326000	23626	11702	120	0	\N
348133	1874	23329000	23626	11702	121	0	\N
348134	1874	23331000	23626	11702	122	0	\N
348135	1874	23333000	23626	11702	123	0	\N
348136	1874	23335000	23626	11702	124	0	\N
348137	1874	23337000	23626	11702	125	0	\N
348148	1678	25920814142000	23629	11771	0	0	\N
348149	1874	23780000	23629	11771	1	0	\N
348150	1874	23782000	23629	11771	2	0	\N
348158	1678	25920814145000	23631	11773	0	0	\N
348159	1874	23795000	23631	11773	1	0	\N
348160	1678	25920814145000	23632	11773	0	0	\N
348140	1874	23768000	23627	11770	2	0	2
348141	1874	23770000	23627	11770	3	0	2
348142	1874	23773000	23627	11770	4	0	2
348143	1874	23776000	23627	11770	5	0	2
348144	1874	23777000	23627	11770	6	0	2
348146	1874	23780000	23628	11771	1	0	2
348147	1874	23782000	23628	11771	2	0	2
348151	1678	25920814143000	23630	11772	0	0	0
348152	1678	25920814144000	23630	11772	1	0	0
348153	1874	23785000	23630	11772	2	0	2
348155	1874	23789000	23630	11772	4	0	2
348156	1874	23792000	23630	11772	5	0	2
348157	1874	23793000	23630	11772	6	0	2
348161	1874	23796000	23632	11773	1	0	\N
348162	1874	23798000	23632	11773	2	0	\N
348169	1678	25920814146000	23635	11774	0	0	\N
348170	1874	23800000	23635	11774	1	0	\N
348171	1874	23803000	23635	11774	2	0	\N
348179	1678	25920814147000	23637	11775	0	0	\N
348180	1678	25920814148000	23637	11775	1	0	\N
348181	1874	23804000	23637	11775	2	0	\N
348182	1874	23807000	23637	11775	3	0	\N
348183	1874	23809000	23637	11775	4	0	\N
348184	1874	23812000	23637	11775	5	0	\N
348185	1874	23814000	23637	11775	6	0	\N
348186	1678	25920814149000	23638	11776	0	0	\N
348187	1678	25920814150000	23638	11776	1	0	\N
348188	1874	23817000	23638	11776	2	0	\N
348189	1874	23820000	23638	11776	3	0	\N
348190	1874	23822000	23638	11776	4	0	\N
348191	1874	23824000	23638	11776	5	0	\N
348192	1874	23826000	23638	11776	6	0	\N
348193	1874	23829000	23638	11776	7	0	\N
348194	1874	23830000	23638	11776	8	0	\N
348195	1678	25920814149000	23639	11776	0	0	\N
348196	1678	25920814150000	23639	11776	1	0	\N
348197	1874	23817000	23639	11776	2	0	\N
348198	1874	23820000	23639	11776	3	0	\N
348199	1874	23822000	23639	11776	4	0	\N
348200	1874	23824000	23639	11776	5	0	\N
348201	1874	23826000	23639	11776	6	0	\N
348202	1874	23829000	23639	11776	7	0	\N
348203	1874	23830000	23639	11776	8	0	\N
348213	1678	25920814151000	23641	11777	0	0	\N
348214	1874	23832000	23641	11777	1	0	\N
348215	1874	23835000	23641	11777	2	0	\N
348226	1678	25920814152000	23644	11778	0	0	\N
348227	1678	25920814153000	23644	11778	1	0	\N
348228	1874	23836000	23644	11778	2	0	\N
348229	1874	23838000	23644	11778	3	0	\N
348230	1874	23840000	23644	11778	4	0	\N
348231	1874	23843000	23644	11778	5	0	\N
348232	1874	23846000	23644	11778	6	0	\N
348236	1678	25920814154000	23646	11779	0	0	\N
348237	1874	23848000	23646	11779	1	0	\N
348238	1874	23851000	23646	11779	2	0	\N
348246	1678	25920814156000	23649	11781	0	0	\N
348247	1874	23857000	23649	11781	1	0	\N
348248	1874	23859000	23649	11781	2	0	\N
348249	1874	23862000	23649	11781	3	0	\N
348257	1361	1705653644951650	23651	11782	0	0	\N
348258	1115	907182953800000	23651	11782	1	0	\N
348259	1235	612094660400000	23651	11782	2	0	\N
348260	995	506242508600000	23651	11782	3	0	\N
348261	1678	25920814157000	23651	11782	5	0	\N
348262	1874	23865000	23651	11782	6	0	\N
348263	1874	23867000	23651	11782	7	0	\N
348264	1361	1705653644951650	23652	11782	0	0	\N
348265	1115	907182953800000	23652	11782	1	0	\N
348266	1235	612094660400000	23652	11782	2	0	\N
348267	995	506242508600000	23652	11782	3	0	\N
348268	1678	25920814157000	23652	11782	5	0	\N
348269	1874	23865000	23652	11782	6	0	\N
348273	1678	25920814158000	23654	11783	0	0	\N
348274	1874	23869000	23654	11783	1	0	\N
348275	1874	23872000	23654	11783	2	0	\N
348276	1678	25920814158000	23655	11783	0	0	\N
348277	1874	23869000	23655	11783	1	0	\N
348278	1874	23872000	23655	11783	2	0	\N
348279	1678	25920814158000	23656	11783	0	0	\N
348280	1874	23869000	23656	11783	1	0	\N
348281	1874	23872000	23656	11783	2	0	\N
348282	1361	1705653644951650	23657	11555	0	0	\N
348283	1115	907182953800000	23657	11555	1	0	\N
348284	1235	612094660400000	23657	11555	2	0	\N
348285	995	506242508600000	23657	11555	3	0	\N
348296	1678	25920814159000	23659	11784	0	0	\N
348165	1874	23798000	23633	11773	2	0	2
348166	1678	25920814146000	23634	11774	0	0	0
348167	1874	23800000	23634	11774	1	0	2
348168	1874	23803000	23634	11774	2	0	2
348172	1678	25920814147000	23636	11775	0	0	0
348174	1874	23804000	23636	11775	2	0	2
348175	1874	23807000	23636	11775	3	0	2
348176	1874	23809000	23636	11775	4	0	2
348177	1874	23812000	23636	11775	5	0	2
348178	1874	23814000	23636	11775	6	0	2
348205	1678	25920814150000	23640	11776	1	0	0
348206	1874	23817000	23640	11776	2	0	2
348207	1874	23820000	23640	11776	3	0	2
348208	1874	23822000	23640	11776	4	0	2
348210	1874	23826000	23640	11776	6	0	2
348211	1874	23829000	23640	11776	7	0	2
348212	1874	23830000	23640	11776	8	0	2
348216	1678	25920814151000	23642	11777	0	0	0
348217	1874	23832000	23642	11777	1	0	2
348219	1678	25920814152000	23643	11778	0	0	0
348220	1678	25920814153000	23643	11778	1	0	0
348221	1874	23836000	23643	11778	2	0	2
348222	1874	23838000	23643	11778	3	0	2
348223	1874	23840000	23643	11778	4	0	2
348225	1874	23846000	23643	11778	6	0	2
348233	1678	25920814154000	23645	11779	0	0	0
348234	1874	23848000	23645	11779	1	0	2
348235	1874	23851000	23645	11779	2	0	2
348240	1874	23853000	23647	11780	1	0	2
348241	1874	23856000	23647	11780	2	0	2
348242	1678	25920814156000	23648	11781	0	0	0
348243	1874	23857000	23648	11781	1	0	2
348244	1874	23859000	23648	11781	2	0	2
348250	1361	1705653644951650	23650	11782	0	0	0
348251	1115	907182953800000	23650	11782	1	0	0
348252	1235	612094660400000	23650	11782	2	0	0
348253	995	506242508600000	23650	11782	3	0	0
348254	1678	25920814157000	23650	11782	5	0	0
348256	1874	23867000	23650	11782	7	0	2
348270	1678	25920814158000	23653	11783	0	0	0
348271	1874	23869000	23653	11783	1	0	2
348272	1874	23872000	23653	11783	2	0	2
348287	1678	25920814160000	23658	11784	1	0	0
348288	1678	25920814161000	23658	11784	2	0	0
348289	1874	23873000	23658	11784	3	0	2
348290	1874	23876000	23658	11784	4	0	2
348291	1874	23879000	23658	11784	5	0	2
348293	1874	23883000	23658	11784	7	0	2
348294	1874	23886000	23658	11784	8	0	2
348295	1874	23888000	23658	11784	9	0	2
348297	1678	25920814160000	23659	11784	1	0	\N
348298	1678	25920814161000	23659	11784	2	0	\N
348299	1874	23873000	23659	11784	3	0	\N
348300	1874	23876000	23659	11784	4	0	\N
348301	1874	23879000	23659	11784	5	0	\N
348302	1874	23881000	23659	11784	6	0	\N
348303	1874	23883000	23659	11784	7	0	\N
348304	1874	23886000	23659	11784	8	0	\N
348305	1874	23888000	23659	11784	9	0	\N
348306	1678	25920814162000	23660	11785	0	0	\N
348307	1874	23890000	23660	11785	1	0	\N
348308	1874	23893000	23660	11785	2	0	\N
348312	1678	25920814162000	23662	11785	0	0	\N
348313	1874	23890000	23662	11785	1	0	\N
348314	1874	23893000	23662	11785	2	0	\N
348315	1678	25920814162000	23663	11785	0	0	\N
348316	1874	23891000	23663	11785	1	0	\N
348317	1678	25920814163000	23664	11786	0	0	\N
348318	1874	23894000	23664	11786	1	0	\N
348319	1874	23896000	23664	11786	2	0	\N
348320	1874	23899000	23664	11786	3	0	\N
348324	1678	25920814163000	23666	11786	0	0	\N
348325	1874	23894000	23666	11786	1	0	\N
348326	1874	23896000	23666	11786	2	0	\N
348327	1874	23899000	23666	11786	3	0	\N
348330	1678	25920814164000	23668	11787	0	0	\N
348331	1874	23899000	23668	11787	1	0	\N
348332	1874	23901000	23668	11787	2	0	\N
348337	1678	25920814166000	23670	11789	0	0	\N
348338	1678	25920814167000	23670	11789	1	0	\N
348339	1874	23909000	23670	11789	2	0	\N
348340	1874	23912000	23670	11789	3	0	\N
348341	1874	23913000	23670	11789	4	0	\N
348342	1874	23915000	23670	11789	5	0	\N
348343	1874	23917000	23670	11789	6	0	\N
348351	1678	25920814166000	23672	11789	0	0	\N
348352	1678	25920814167000	23672	11789	1	0	\N
348353	1874	23909000	23672	11789	2	0	\N
348354	1874	23912000	23672	11789	3	0	\N
348355	1874	23913000	23672	11789	4	0	\N
348356	1874	23915000	23672	11789	5	0	\N
348357	1874	23917000	23672	11789	6	0	\N
348358	1678	25920814166000	23673	11789	0	0	\N
348359	1678	25920814167000	23673	11789	1	0	\N
348360	1874	23909000	23673	11789	2	0	\N
348361	1874	23912000	23673	11789	3	0	\N
348362	1874	23913000	23673	11789	4	0	\N
348363	1874	23915000	23673	11789	5	0	\N
348364	1874	23917000	23673	11789	6	0	\N
348365	1678	25920814166000	23674	11789	0	0	\N
348366	1678	25920814167000	23674	11789	1	0	\N
348367	1874	23909000	23674	11789	2	0	\N
348368	1874	23912000	23674	11789	3	0	\N
348369	1874	23913000	23674	11789	4	0	\N
348373	1678	25920814168000	23676	11790	0	0	\N
348374	1874	23920000	23676	11790	1	0	\N
348375	1678	25920814168000	23677	11790	0	0	\N
348376	1874	23920000	23677	11790	1	0	\N
348377	1874	23922000	23677	11790	2	0	\N
348382	1678	25920814170000	23681	11792	0	0	\N
348383	1678	25920814171000	23681	11792	1	0	\N
348384	1321	1710569637751650	23681	11792	2	0	\N
348385	955	507701775000000	23681	11792	3	0	\N
348386	1874	23931000	23681	11792	4	0	\N
348387	1874	23934000	23681	11792	5	0	\N
348388	1874	23936000	23681	11792	6	0	\N
348389	1874	23938000	23681	11792	7	0	\N
348311	1874	23893000	23661	11785	2	0	2
348321	1678	25920814163000	23665	11786	0	0	0
348322	1874	23894000	23665	11786	1	0	2
348323	1874	23897000	23665	11786	2	0	2
348328	1678	25920814164000	23667	11787	0	0	0
348333	1678	25920814165000	23669	11788	0	0	0
348334	1874	23901000	23669	11788	1	0	2
348335	1874	23903000	23669	11788	2	0	2
348336	1874	23906000	23669	11788	3	0	2
348344	1678	25920814166000	23671	11789	0	0	0
348346	1874	23909000	23671	11789	2	0	2
348347	1874	23912000	23671	11789	3	0	2
348348	1874	23913000	23671	11789	4	0	2
348349	1874	23915000	23671	11789	5	0	2
348370	1678	25920814168000	23675	11790	0	0	0
348371	1874	23920000	23675	11790	1	0	2
348372	1874	23922000	23675	11790	2	0	2
348378	1678	25920814169000	23678	11791	0	0	0
348379	1874	23925000	23678	11791	1	0	2
348381	1874	23928000	23678	11791	3	0	2
348390	1678	25920814170000	23682	11792	0	0	0
348391	1678	25920814171000	23682	11792	1	0	0
348392	1321	1710569637751650	23682	11792	2	0	0
348393	955	507701775000000	23682	11792	3	0	0
348395	1874	23934000	23682	11792	5	0	2
348396	1874	23936000	23682	11792	6	0	2
348397	1874	23938000	23682	11792	7	0	2
348398	1678	25920814172000	23684	11793	0	0	0
348400	1075	909796465000000	23684	11793	2	0	0
348401	1874	23940000	23684	11793	3	0	2
348402	1874	23942000	23684	11793	4	0	2
348403	1195	613858750000000	23684	11793	5	0	0
348404	1874	23945000	23684	11793	6	0	2
348406	1874	23949000	23684	11793	8	0	2
348407	1678	25920814174000	23685	11794	0	0	0
348408	1874	23951000	23685	11794	1	0	2
348409	1874	23954000	23685	11794	2	0	2
348410	1678	25920814175000	23686	11795	0	0	0
348412	1874	23959000	23686	11795	2	0	2
348413	1678	25920814176000	23687	11796	0	0	0
348414	1678	25920814177000	23687	11796	1	0	0
348415	1874	23962000	23687	11796	2	0	2
348417	1874	23967000	23687	11796	4	0	2
348418	1874	23969000	23687	11796	5	0	2
348419	1874	23970000	23687	11796	6	0	2
348420	1678	25920814178000	23688	11797	0	0	0
348421	1874	23972000	23688	11797	1	0	2
348423	1678	25920814179000	23689	11798	0	0	0
348424	1874	23978000	23689	11798	1	0	2
348425	1874	23979000	23689	11798	2	0	2
348426	1874	23981000	23689	11798	3	0	2
348427	1678	25920814180000	23690	11799	0	0	0
348429	1874	23986000	23690	11799	2	0	2
348430	1678	25920814181000	23691	11800	0	0	0
348431	1874	23988000	23691	11800	1	0	2
348432	1874	23991000	23691	11800	2	0	2
348433	1678	25920814181000	23692	11800	0	0	\N
348434	1874	23988000	23692	11800	1	0	\N
348435	1874	23991000	23692	11800	2	0	\N
348436	1678	25920814182000	23693	11801	0	0	\N
348437	1678	25920814183000	23693	11801	1	0	\N
348438	1874	23992000	23693	11801	2	0	\N
348439	1874	23994000	23693	11801	3	0	\N
348440	1874	23996000	23693	11801	5	0	\N
348441	1874	23999000	23693	11801	6	0	\N
348442	1874	24002000	23693	11801	7	0	\N
348450	1678	25920814182000	23695	11801	0	0	\N
348451	1678	25920814183000	23695	11801	1	0	\N
348452	1874	23992000	23695	11801	2	0	\N
348453	1874	23994000	23695	11801	3	0	\N
348454	1874	23996000	23695	11801	5	0	\N
348455	1874	23999000	23695	11801	6	0	\N
348456	1874	24002000	23695	11801	7	0	\N
348457	1678	25920814182000	23696	11801	0	0	\N
348458	1678	25920814183000	23696	11801	1	0	\N
348459	1874	23992000	23696	11801	2	0	\N
348460	1874	23994000	23696	11801	3	0	\N
348461	1874	23996000	23696	11801	5	0	\N
348462	1874	23999000	23696	11801	6	0	\N
348463	1874	24002000	23696	11801	7	0	\N
348464	1678	25920814182000	23697	11801	0	0	\N
348465	1678	25920814183000	23697	11801	1	0	\N
348466	1874	23992000	23697	11801	2	0	\N
348467	1874	23994000	23697	11801	3	0	\N
348468	1874	23996000	23697	11801	5	0	\N
348469	1874	23999000	23697	11801	6	0	\N
348470	1874	24002000	23697	11801	7	0	\N
348471	1678	26640839184000	23698	11802	0	0	\N
348472	1678	26640839185000	23698	11802	1	0	\N
348473	1678	26640839186000	23698	11802	2	0	\N
348474	1874	24004000	23698	11802	3	0	\N
348475	1874	24005000	23698	11802	4	0	\N
348476	1874	24008000	23698	11802	5	0	\N
348477	1874	24011000	23698	11802	6	0	\N
348478	1874	24014000	23698	11802	7	0	\N
348479	1874	24016000	23698	11802	8	0	\N
348480	1874	24018000	23698	11802	9	0	\N
348481	2309	1000000000	23698	11802	10	0	\N
348504	1678	26640839190000	23703	11805	0	0	\N
348505	1874	24037000	23703	11805	1	0	\N
348506	1678	26640839190000	23704	11805	0	0	\N
348507	1874	24037000	23704	11805	1	0	\N
348508	1874	24039000	23704	11805	2	0	\N
348522	1678	26640839193000	23709	11808	0	0	\N
348523	1874	24050000	23709	11808	1	0	\N
348524	1874	24053000	23709	11808	2	0	\N
348525	1874	24055000	23709	11808	3	0	\N
348526	1678	26640839193000	23710	11808	0	0	\N
348527	1874	24050000	23710	11808	1	0	\N
348528	1874	24053000	23710	11808	2	0	\N
348541	1678	26640839197000	23714	11811	0	0	\N
348542	1874	24074000	23714	11811	1	0	\N
348543	1678	26640839197000	23715	11811	0	0	\N
348544	1874	24074000	23715	11811	1	0	\N
348545	1874	24076000	23715	11811	2	0	\N
348546	1678	26640839197000	23716	11811	0	0	\N
348547	1874	24074000	23716	11811	1	0	\N
348548	1874	24076000	23716	11811	2	0	\N
348549	1678	26640839198000	23717	11812	0	0	\N
348550	1678	26640839199000	23717	11812	1	0	\N
348551	1874	24076000	23717	11812	2	0	\N
348552	1874	24078000	23717	11812	3	0	\N
348553	1874	24079000	23717	11812	4	0	\N
348554	1874	24081000	23717	11812	5	0	\N
348555	1874	24084000	23717	11812	6	0	\N
348556	1874	24087000	23717	11812	7	0	\N
348568	1678	26640839200000	23720	11813	0	0	\N
348445	1874	23992000	23694	11801	2	0	2
348446	1874	23994000	23694	11801	3	0	2
348447	1874	23996000	23694	11801	5	0	2
348448	1874	23999000	23694	11801	6	0	2
348449	1874	24002000	23694	11801	7	0	2
348483	1678	26640839185000	23699	11802	1	0	0
348484	1678	26640839186000	23699	11802	2	0	0
348485	1874	24003000	23699	11802	3	0	2
348486	1874	24006000	23699	11802	4	0	2
348487	1874	24009000	23699	11802	5	0	2
348489	2309	1000000000	23699	11802	7	0	0
348490	1678	26640839187000	23701	11803	0	0	0
348491	1678	26640839188000	23701	11803	1	0	0
348492	1874	24014000	23701	11803	2	0	2
348494	1874	24020000	23701	11803	4	0	2
348495	1874	24022000	23701	11803	5	0	2
348496	1874	24024000	23701	11803	6	0	2
348497	1874	24026000	23701	11803	7	0	2
348498	1874	24028000	23701	11803	8	0	2
348500	1678	26640839189000	23702	11804	0	0	0
348501	1874	24030000	23702	11804	1	0	2
348502	1874	24033000	23702	11804	2	0	2
348503	1874	24034000	23702	11804	3	0	2
348509	1678	26640839190000	23705	11805	0	0	0
348511	1874	24039000	23705	11805	2	0	2
348512	1678	26640839191000	23706	11806	0	0	0
348513	1874	24041000	23706	11806	1	0	2
348514	1874	24044000	23706	11806	2	0	2
348516	1874	24046000	23707	11807	1	0	2
348517	1874	24049000	23707	11807	2	0	2
348518	1678	26640839193000	23708	11808	0	0	0
348519	1874	24050000	23708	11808	1	0	2
348520	1874	24053000	23708	11808	2	0	2
348529	1678	26640839194000	23711	11809	0	0	0
348530	1678	26640839195000	23711	11809	1	0	0
348531	1874	24058000	23711	11809	2	0	2
348532	1874	24060000	23711	11809	3	0	2
348533	1874	24062000	23711	11809	4	0	2
348535	1678	26640839196000	23712	11810	0	0	0
348536	1874	24066000	23712	11810	1	0	2
348537	1874	24069000	23712	11810	2	0	2
348538	1874	24071000	23712	11810	3	0	2
348540	1874	24074000	23713	11811	1	0	2
348557	1678	26640839198000	23718	11812	0	0	0
348558	1678	26640839199000	23718	11812	1	0	0
348559	1874	24076000	23718	11812	2	0	2
348560	1874	24078000	23718	11812	3	0	2
348562	1874	24081000	23718	11812	5	0	2
348563	1874	24084000	23718	11812	6	0	2
348564	1874	24087000	23718	11812	7	0	2
348565	1678	26640839200000	23719	11813	0	0	0
348566	1874	24089000	23719	11813	1	0	2
348569	1874	24089000	23720	11813	1	0	\N
348570	1874	24092000	23720	11813	2	0	\N
348571	1678	26640839201000	23722	11814	0	0	\N
348572	1678	26640839202000	23722	11814	1	0	\N
348573	1874	24094000	23722	11814	2	0	\N
348574	1874	24096000	23722	11814	3	0	\N
348575	1874	24099000	23722	11814	4	0	\N
348576	1874	24102000	23722	11814	5	0	\N
348577	1678	26640839201000	23723	11814	0	0	\N
348578	1678	26640839202000	23723	11814	1	0	\N
348579	1874	24094000	23723	11814	2	0	\N
348580	1874	24096000	23723	11814	3	0	\N
348581	1874	24099000	23723	11814	4	0	\N
348582	1874	24102000	23723	11814	5	0	\N
348637	1361	1705653644951650	23733	11753	0	0	\N
348638	1115	907182953800000	23733	11753	1	0	\N
348639	1235	612094660400000	23733	11753	2	0	\N
348640	995	506242508600000	23733	11753	3	0	\N
348641	38	66443668039709	23733	11753	4	0	\N
348642	1678	25920814115000	23733	11753	5	0	\N
348643	969	506150276480512	23733	11753	6	0	\N
348644	1089	907016958757500	23733	11753	7	0	\N
348645	1209	611982415663305	23733	11753	8	0	\N
348646	1335	1705343415688246	23733	11753	9	0	\N
348647	1678	25920814116000	23733	11753	11	0	\N
348648	1678	25920814117000	23733	11753	12	0	\N
348649	1678	25920814118000	23733	11753	13	0	\N
348650	1678	25920814119000	23733	11753	14	0	\N
348651	1678	25920814120000	23733	11753	15	0	\N
348652	1678	25920814121000	23733	11753	16	0	\N
348653	1678	25920814122000	23733	11753	17	0	\N
348654	1678	25920814123000	23733	11753	18	0	\N
348655	1678	25920814124000	23733	11753	19	0	\N
348656	1678	25920814125000	23733	11753	20	0	\N
348657	1678	25920814126000	23733	11753	21	0	\N
348658	1678	25920814127000	23733	11753	22	0	\N
348659	1678	25920814128000	23733	11753	23	0	\N
348660	1678	25920814129000	23733	11753	24	0	\N
348661	1678	25920814130000	23733	11753	25	0	\N
348662	1678	25920814131000	23733	11753	26	0	\N
348663	1678	25920814132000	23733	11753	27	0	\N
348664	1678	25920814133000	23733	11753	28	0	\N
348665	1678	25920814134000	23733	11753	29	0	\N
348666	1678	25920814135000	23733	11753	30	0	\N
348667	1678	25920814136000	23733	11753	31	0	\N
348668	1678	25920814137000	23733	11753	32	0	\N
348669	1678	25920814138000	23733	11753	33	0	\N
348670	1678	25920814139000	23733	11753	34	0	\N
348671	1678	25920814140000	23733	11753	35	0	\N
348672	1678	25920814141000	23733	11753	36	0	\N
348673	1678	25920814142000	23733	11753	37	0	\N
348674	1678	25920814143000	23733	11753	38	0	\N
348675	1678	25920814144000	23733	11753	39	0	\N
348676	1678	25920814145000	23733	11753	40	0	\N
348677	1678	25920814146000	23733	11753	41	0	\N
348678	1678	25920814147000	23733	11753	42	0	\N
348679	1678	25920814148000	23733	11753	43	0	\N
348680	1678	25920814149000	23733	11753	44	0	\N
348681	1678	25920814150000	23733	11753	45	0	\N
348682	1678	25920814151000	23733	11753	46	0	\N
348683	1678	25920814152000	23733	11753	47	0	\N
348684	1678	25920814153000	23733	11753	48	0	\N
348685	1678	25920814154000	23733	11753	49	0	\N
348686	1678	25920814155000	23733	11753	50	0	\N
348687	1678	25920814156000	23733	11753	51	0	\N
348688	1678	25920814157000	23733	11753	52	0	\N
348689	1678	25920814158000	23733	11753	53	0	\N
348690	1678	25920814159000	23733	11753	54	0	\N
348691	1678	25920814160000	23733	11753	55	0	\N
348692	1678	25920814161000	23733	11753	56	0	\N
348693	1678	25920814162000	23733	11753	57	0	\N
348694	1678	25920814163000	23733	11753	58	0	\N
348695	1678	25920814164000	23733	11753	59	0	\N
348696	1678	25920814165000	23733	11753	60	0	\N
348697	1678	25920814166000	23733	11753	61	0	\N
348698	1678	25920814167000	23733	11753	62	0	\N
348699	1678	25920814168000	23733	11753	63	0	\N
348700	1678	25920814169000	23733	11753	64	0	\N
348701	1678	25920814170000	23733	11753	65	0	\N
348702	1678	25920814171000	23733	11753	66	0	\N
348703	1678	25920814172000	23733	11753	67	0	\N
348704	1678	25920814173000	23733	11753	68	0	\N
348585	1874	24094000	23724	11814	2	0	2
348586	1874	24096000	23724	11814	3	0	2
348587	1874	24099000	23724	11814	4	0	2
348588	1874	24102000	23724	11814	5	0	2
348589	1678	26640839203000	23725	11815	0	0	0
348591	1874	24103000	23725	11815	2	0	2
348592	1874	24105000	23725	11815	3	0	2
348593	1874	24108000	23725	11815	4	0	2
348594	1523	0	23725	11815	5	0	0
348595	1874	24111000	23725	11815	6	0	2
348597	1678	26640839205000	23726	11816	0	0	0
348598	1678	26640839206000	23726	11816	1	0	0
348599	1874	24116000	23726	11816	2	0	2
348600	1874	24119000	23726	11816	3	0	2
348602	1874	24122000	23726	11816	5	0	2
348603	1874	24124000	23726	11816	6	0	2
348604	1678	26640839207000	23727	11817	0	0	0
348605	1874	24127000	23727	11817	1	0	2
348606	1874	24129000	23727	11817	2	0	2
348608	1678	26640839209000	23728	11818	1	0	0
348609	1874	24132000	23728	11818	2	0	2
348610	1874	24134000	23728	11818	3	0	2
348611	1874	24136000	23728	11818	4	0	2
348612	1874	24137000	23728	11818	5	0	2
348614	1678	26640839210000	23729	11819	0	0	0
348615	1874	24142000	23729	11819	1	0	2
348616	1874	24145000	23729	11819	2	0	2
348617	1678	26640839211000	23730	11820	0	0	0
348619	1678	26640839213000	23730	11820	2	0	0
348620	1874	24147000	23730	11820	3	0	2
348621	1874	24150000	23730	11820	4	0	2
348622	1874	24153000	23730	11820	5	0	2
348623	1874	24156000	23730	11820	6	0	2
348625	1874	24159000	23730	11820	8	0	2
348626	1874	24161000	23730	11820	9	0	2
348627	1678	26640839214000	23731	11821	0	0	0
348628	1678	26640839215000	23731	11821	1	0	0
348629	1874	24164000	23731	11821	2	0	2
348631	1874	24168000	23731	11821	4	0	2
348632	1874	24171000	23731	11821	5	0	2
348633	1678	26640839216000	23732	11822	1	0	0
348634	1874	24172000	23732	11822	2	0	2
348636	1874	24177000	23732	11822	4	0	2
348705	1678	25920814174000	23733	11753	69	0	\N
348706	1678	25920814175000	23733	11753	70	0	\N
348707	1678	25920814176000	23733	11753	71	0	\N
348708	1678	25920814177000	23733	11753	72	0	\N
348709	1678	25920814178000	23733	11753	73	0	\N
348710	1678	25920814179000	23733	11753	74	0	\N
348711	1678	25920814180000	23733	11753	75	0	\N
348712	1678	25920814181000	23733	11753	76	0	\N
348713	1678	25920814182000	23733	11753	77	0	\N
348714	1678	25920814183000	23733	11753	78	0	\N
348715	1678	25920814184000	23733	11753	79	0	\N
348716	1678	25920814185000	23733	11753	81	0	\N
348717	1678	25920814186000	23733	11753	82	0	\N
348718	1678	25920814187000	23733	11753	83	0	\N
348719	1678	25920814188000	23733	11753	84	0	\N
348720	1678	25920814189000	23733	11753	85	0	\N
348721	1678	25920814190000	23733	11753	86	0	\N
348722	1678	25920814191000	23733	11753	87	0	\N
348723	1678	25920814192000	23733	11753	88	0	\N
348724	1678	25920814193000	23733	11753	89	0	\N
348725	1678	25920814194000	23733	11753	90	0	\N
348726	1678	25920814195000	23733	11753	91	0	\N
348727	1678	25920814196000	23733	11753	92	0	\N
348728	1678	25920814197000	23733	11753	93	0	\N
348729	1678	25920814198000	23733	11753	94	0	\N
348730	1678	25920814199000	23733	11753	95	0	\N
348731	1678	25920814200000	23733	11753	96	0	\N
348732	1678	25920814201000	23733	11753	97	0	\N
348733	1678	25920814202000	23733	11753	98	0	\N
348734	1678	25920814203000	23733	11753	99	0	\N
348735	1678	25920814204000	23733	11753	100	0	\N
348736	1678	25920814205000	23733	11753	101	0	\N
348737	1678	25920814206000	23733	11753	102	0	\N
348738	1678	25920814207000	23733	11753	103	0	\N
348739	1678	25920814208000	23733	11753	104	0	\N
348740	1678	25920814209000	23733	11753	105	0	\N
348741	1678	25920814210000	23733	11753	106	0	\N
348742	1678	25920814211000	23733	11753	107	0	\N
348743	1678	25920814212000	23733	11753	108	0	\N
348744	1678	25920814213000	23733	11753	109	0	\N
348745	1678	25920814214000	23733	11753	110	0	\N
348746	1678	25920814215000	23733	11753	111	0	\N
348747	1678	25920814216000	23733	11753	112	0	\N
348748	1321	1710569637751650	23733	11753	115	0	\N
348749	955	507701775000000	23733	11753	116	0	\N
348750	1075	909796465000000	23733	11753	117	0	\N
348751	1874	23638000	23733	11753	118	0	\N
348752	1874	23641000	23733	11753	119	0	\N
348753	1874	23643000	23733	11753	120	0	\N
348754	1874	23644000	23733	11753	121	0	\N
348755	1874	23645000	23733	11753	122	0	\N
348756	1874	23646000	23733	11753	123	0	\N
348757	1874	23647000	23733	11753	124	0	\N
348758	1195	613858750000000	23733	11753	125	0	\N
348759	1678	26640839217000	23734	11823	0	0	\N
348760	1874	24179000	23734	11823	1	0	\N
348761	1874	24182000	23734	11823	2	0	\N
348762	1874	24185000	23734	11823	3	0	\N
348763	1874	24187000	23734	11823	4	0	\N
348764	1678	26640839217000	23735	11823	0	0	\N
348765	1874	24179000	23735	11823	1	0	\N
348766	1874	24182000	23735	11823	2	0	\N
348767	1874	24185000	23735	11823	3	0	\N
348768	1874	24187000	23735	11823	4	0	\N
348778	1678	26640839218000	23738	11824	0	0	\N
348779	1874	24185000	23738	11824	1	0	\N
348780	1874	24188000	23738	11824	2	0	\N
348781	1874	24189000	23738	11824	3	0	\N
348782	1874	24191000	23738	11824	4	0	\N
348783	1874	24193000	23738	11824	5	0	\N
348784	1678	26640839218000	23739	11824	0	0	\N
348785	1874	24190000	23739	11824	1	0	\N
348786	1874	24192000	23739	11824	2	0	\N
348787	1874	24193000	23739	11824	3	0	\N
348788	1678	26640839218000	23740	11824	0	0	\N
348789	1874	24190000	23740	11824	1	0	\N
348790	1874	24192000	23740	11824	2	0	\N
348791	1874	24193000	23740	11824	3	0	\N
348792	1678	26640839218000	23741	11824	0	0	\N
348793	1874	24190000	23741	11824	1	0	\N
348794	1874	24192000	23741	11824	2	0	\N
348795	1874	24193000	23741	11824	3	0	\N
348796	1678	26640839218000	23742	11824	0	0	\N
348797	1874	24189000	23742	11824	1	0	\N
348833	1678	26640839214000	23748	11821	1	0	\N
348834	1678	26640839215000	23748	11821	2	0	\N
348835	1678	26640839216000	23748	11821	3	0	\N
348836	1678	26640839217000	23748	11821	4	0	\N
348837	1678	26640839218000	23748	11821	5	0	\N
348838	1678	26640839219000	23748	11821	6	0	\N
348839	1678	26640839220000	23748	11821	7	0	\N
348840	1678	26640839221000	23748	11821	8	0	\N
348771	1874	24182000	23736	11823	2	0	2
348772	1678	26640839218000	23737	11824	0	0	0
348773	1874	24185000	23737	11824	1	0	2
348774	1874	24188000	23737	11824	2	0	2
348775	1874	24189000	23737	11824	3	0	2
348777	1874	24193000	23737	11824	5	0	2
348798	1678	26640839219000	23743	11825	0	0	0
348799	1874	24195000	23743	11825	1	0	2
348800	1678	26640839220000	23744	11826	0	0	0
348801	1874	24198000	23744	11826	1	0	2
348803	1678	26640839221000	23746	11827	0	0	0
348804	1678	26640839222000	23746	11827	1	0	0
348805	1678	26640839223000	23746	11827	2	0	0
348806	1678	26640839224000	23746	11827	3	0	0
348808	1678	26640839226000	23746	11827	5	0	0
348809	1678	26640839227000	23746	11827	6	0	0
348810	1874	24202000	23746	11827	7	0	2
348811	1874	24204000	23746	11827	8	0	2
348812	1874	24205000	23746	11827	9	0	2
348814	1874	24211000	23746	11827	11	0	2
348815	1874	24214000	23746	11827	12	0	2
348816	1874	24217000	23746	11827	13	0	2
348817	1874	24220000	23746	11827	14	0	2
348818	1874	24221000	23746	11827	15	0	2
348820	1874	24225000	23746	11827	17	0	2
348821	1874	24227000	23746	11827	18	0	2
348822	1874	24229000	23746	11827	19	0	2
348823	1874	24231000	23746	11827	20	0	2
348825	1874	24237000	23746	11827	22	0	2
348826	1678	26640839228000	23747	11828	0	0	0
348827	1678	26640839229000	23747	11828	1	0	0
348828	1874	24239000	23747	11828	2	0	2
348829	1874	24242000	23747	11828	3	0	2
348831	1874	24245000	23747	11828	5	0	2
348832	1874	24248000	23747	11828	6	0	2
348841	1678	26640839222000	23748	11821	9	0	\N
348842	1678	26640839223000	23748	11821	10	0	\N
348843	1678	26640839224000	23748	11821	11	0	\N
348844	1678	26640839225000	23748	11821	12	0	\N
348845	1678	26640839226000	23748	11821	13	0	\N
348846	1678	26640839227000	23748	11821	14	0	\N
348847	1678	26640839228000	23748	11821	15	0	\N
348848	1678	26640839229000	23748	11821	16	0	\N
348849	1874	24162000	23748	11821	17	0	\N
348850	1874	24165000	23748	11821	18	0	\N
348851	1874	24167000	23748	11821	19	0	\N
348852	1874	24169000	23748	11821	20	0	\N
348853	1874	24171000	23748	11821	21	0	\N
348854	1874	24173000	23748	11821	22	0	\N
348855	1874	24176000	23748	11821	23	0	\N
348856	1874	24177000	23748	11821	24	0	\N
348857	1874	24178000	23748	11821	25	0	\N
348858	1874	24179000	23748	11821	26	0	\N
348859	1874	24180000	23748	11821	27	0	\N
348860	1874	24182000	23748	11821	28	0	\N
348861	1874	24184000	23748	11821	29	0	\N
348862	1874	24186000	23748	11821	30	0	\N
348863	1874	24189000	23748	11821	31	0	\N
348864	1874	24192000	23748	11821	32	0	\N
348865	1874	24195000	23748	11821	33	0	\N
348866	1874	24198000	23748	11821	34	0	\N
348867	1874	24201000	23748	11821	35	0	\N
348868	1874	24204000	23748	11821	36	0	\N
348869	1874	24207000	23748	11821	37	0	\N
348870	1874	24210000	23748	11821	38	0	\N
348871	1874	24213000	23748	11821	39	0	\N
348872	1874	24216000	23748	11821	40	0	\N
348873	1874	24219000	23748	11821	41	0	\N
348874	1874	24222000	23748	11821	42	0	\N
348875	1874	24225000	23748	11821	43	0	\N
348876	1874	24227000	23748	11821	44	0	\N
348877	1874	24229000	23748	11821	45	0	\N
348878	1874	24231000	23748	11821	46	0	\N
348879	1874	24233000	23748	11821	47	0	\N
348880	1874	24235000	23748	11821	48	0	\N
348881	1874	24237000	23748	11821	49	0	\N
348882	1874	24239000	23748	11821	50	0	\N
348883	1874	24241000	23748	11821	51	0	\N
348884	1874	24243000	23748	11821	52	0	\N
348885	1874	24245000	23748	11821	53	0	\N
348886	1874	24248000	23748	11821	54	0	\N
348887	1678	26640839230000	23749	11829	0	0	\N
348888	1874	24250000	23749	11829	1	0	\N
348889	1874	24253000	23749	11829	2	0	\N
348890	1874	24250000	23750	11829	0	0	\N
348894	1678	26640839230000	23752	11829	0	0	\N
348895	1874	24250000	23752	11829	1	0	\N
348896	1874	24253000	23752	11829	2	0	\N
348897	1678	26640839230000	23753	11822	0	0	\N
348898	1874	24250000	23753	11822	1	0	\N
348899	1874	24253000	23753	11822	2	0	\N
348900	1678	26640839231000	23754	11830	0	0	\N
348901	1874	24256000	23754	11830	1	0	\N
348902	1874	24258000	23754	11830	2	0	\N
348903	1678	26640839231000	23755	11830	0	0	\N
348904	1874	24256000	23755	11830	1	0	\N
348905	1874	24258000	23755	11830	2	0	\N
348909	1361	1705653644951650	23757	11774	0	0	\N
348910	1115	907182953800000	23757	11774	1	0	\N
348911	1235	612094660400000	23757	11774	2	0	\N
348912	995	506242508600000	23757	11774	3	0	\N
348913	1678	25920814146000	23757	11774	5	0	\N
348914	1678	25920814147000	23757	11774	6	0	\N
348915	1678	25920814148000	23757	11774	7	0	\N
348916	1678	25920814149000	23757	11774	8	0	\N
348917	1678	25920814150000	23757	11774	9	0	\N
348918	1678	25920814151000	23757	11774	10	0	\N
348919	1678	25920814152000	23757	11774	11	0	\N
348920	1678	25920814153000	23757	11774	12	0	\N
348921	1678	25920814154000	23757	11774	13	0	\N
348922	1678	25920814155000	23757	11774	14	0	\N
348923	1678	25920814156000	23757	11774	15	0	\N
348924	1678	25920814157000	23757	11774	16	0	\N
348925	1678	25920814158000	23757	11774	17	0	\N
348926	1678	25920814159000	23757	11774	18	0	\N
348927	1678	25920814160000	23757	11774	19	0	\N
348928	1678	25920814161000	23757	11774	20	0	\N
348929	1678	25920814162000	23757	11774	21	0	\N
348930	1678	25920814163000	23757	11774	22	0	\N
348931	1678	25920814164000	23757	11774	23	0	\N
348932	1678	25920814165000	23757	11774	24	0	\N
348933	1678	25920814166000	23757	11774	25	0	\N
348934	1678	25920814167000	23757	11774	26	0	\N
348935	1678	25920814168000	23757	11774	27	0	\N
348936	1678	25920814169000	23757	11774	28	0	\N
348937	1678	25920814170000	23757	11774	29	0	\N
348938	1678	25920814171000	23757	11774	30	0	\N
348939	1678	25920814172000	23757	11774	31	0	\N
348940	1678	25920814173000	23757	11774	32	0	\N
348941	1678	25920814174000	23757	11774	33	0	\N
348942	1678	25920814175000	23757	11774	34	0	\N
348943	1678	25920814176000	23757	11774	35	0	\N
348944	1678	25920814177000	23757	11774	36	0	\N
348945	1678	25920814178000	23757	11774	37	0	\N
348946	1678	25920814179000	23757	11774	38	0	\N
348947	1678	25920814180000	23757	11774	39	0	\N
348948	1678	25920814181000	23757	11774	40	0	\N
348949	1678	25920814182000	23757	11774	41	0	\N
348950	1678	25920814183000	23757	11774	42	0	\N
348951	1678	25920814184000	23757	11774	43	0	\N
348952	1678	25920814185000	23757	11774	44	0	\N
348953	1678	25920814186000	23757	11774	45	0	\N
348954	1678	25920814187000	23757	11774	46	0	\N
348955	1678	25920814188000	23757	11774	47	0	\N
348956	1678	25920814189000	23757	11774	48	0	\N
348957	1678	25920814190000	23757	11774	49	0	\N
348958	1678	25920814191000	23757	11774	50	0	\N
348959	1678	25920814192000	23757	11774	51	0	\N
348960	1678	25920814193000	23757	11774	52	0	\N
348961	1678	25920814194000	23757	11774	53	0	\N
348962	1678	25920814195000	23757	11774	54	0	\N
348963	1678	25920814196000	23757	11774	55	0	\N
348964	1678	25920814197000	23757	11774	56	0	\N
348965	1678	25920814198000	23757	11774	57	0	\N
348966	1678	25920814199000	23757	11774	58	0	\N
348967	1678	25920814200000	23757	11774	59	0	\N
348968	1678	25920814201000	23757	11774	61	0	\N
348969	1678	25920814202000	23757	11774	62	0	\N
348970	1678	25920814203000	23757	11774	63	0	\N
348971	1678	25920814204000	23757	11774	64	0	\N
348972	1678	25920814205000	23757	11774	65	0	\N
348973	1678	25920814206000	23757	11774	66	0	\N
348974	1678	25920814207000	23757	11774	67	0	\N
348975	1678	25920814208000	23757	11774	68	0	\N
348976	1678	25920814209000	23757	11774	69	0	\N
348893	1874	24253000	23751	11829	2	0	2
348906	1678	26640839231000	23756	11830	0	0	0
348907	1874	24256000	23756	11830	1	0	2
348908	1874	24258000	23756	11830	2	0	2
348977	1678	25920814210000	23757	11774	70	0	\N
348978	1678	25920814211000	23757	11774	71	0	\N
348979	1678	25920814212000	23757	11774	72	0	\N
348980	1678	25920814213000	23757	11774	73	0	\N
348981	1678	25920814214000	23757	11774	74	0	\N
348982	1678	25920814215000	23757	11774	75	0	\N
348983	1678	25920814216000	23757	11774	76	0	\N
348984	1678	25920814217000	23757	11774	77	0	\N
348985	1678	25920814218000	23757	11774	78	0	\N
348986	1678	25920814219000	23757	11774	79	0	\N
348987	1678	25920814220000	23757	11774	80	0	\N
348988	1678	25920814221000	23757	11774	81	0	\N
348989	1678	25920814222000	23757	11774	82	0	\N
348990	1678	25920814223000	23757	11774	83	0	\N
348991	1678	25920814224000	23757	11774	84	0	\N
348992	1678	25920814225000	23757	11774	85	0	\N
348993	1678	25920814226000	23757	11774	86	0	\N
348994	1678	25920814227000	23757	11774	87	0	\N
348995	1678	25920814228000	23757	11774	88	0	\N
348996	1678	25920814229000	23757	11774	89	0	\N
348997	1678	25920814230000	23757	11774	90	0	\N
348998	1678	25920814231000	23757	11774	91	0	\N
348999	1321	1710569637751650	23757	11774	92	0	\N
349000	1874	23796000	23757	11774	93	0	\N
349001	1874	23799000	23757	11774	94	0	\N
349002	955	507701775000000	23757	11774	95	0	\N
349003	1075	909796465000000	23757	11774	96	0	\N
349004	1195	613858750000000	23757	11774	97	0	\N
349005	1874	23802000	23757	11774	98	0	\N
349006	1874	23805000	23757	11774	99	0	\N
349007	2309	1000000000	23757	11774	100	0	\N
349008	1874	23808000	23757	11774	101	0	\N
349009	1874	23811000	23757	11774	102	0	\N
349010	1874	23814000	23757	11774	103	0	\N
349011	1874	23817000	23757	11774	104	0	\N
349012	1874	23820000	23757	11774	105	0	\N
349013	1874	23823000	23757	11774	106	0	\N
349014	1874	23826000	23757	11774	107	0	\N
349015	1874	23829000	23757	11774	108	0	\N
349016	2309	2742644000000	23757	11774	109	0	\N
349017	1874	23832000	23757	11774	110	0	\N
349018	1874	23835000	23757	11774	111	0	\N
349019	1874	23838000	23757	11774	112	0	\N
349020	1874	23841000	23757	11774	113	0	\N
349021	1874	23844000	23757	11774	114	0	\N
349022	1874	23847000	23757	11774	115	0	\N
349023	1874	23850000	23757	11774	116	0	\N
349024	1874	23853000	23757	11774	117	0	\N
349025	1874	23856000	23757	11774	118	0	\N
349026	1874	23859000	23757	11774	119	0	\N
349027	1874	23862000	23757	11774	120	0	\N
349028	1874	23865000	23757	11774	121	0	\N
349029	1874	23868000	23757	11774	122	0	\N
349030	1874	23871000	23757	11774	123	0	\N
349031	1874	23874000	23757	11774	124	0	\N
349036	1678	25920814217000	23759	11754	0	0	\N
349037	1678	25920814218000	23759	11754	1	0	\N
349038	1678	25920814219000	23759	11754	2	0	\N
349039	1678	25920814220000	23759	11754	3	0	\N
349040	1678	25920814221000	23759	11754	4	0	\N
349041	1678	25920814222000	23759	11754	5	0	\N
349042	1678	25920814223000	23759	11754	6	0	\N
349043	1678	25920814224000	23759	11754	7	0	\N
349044	1678	25920814225000	23759	11754	8	0	\N
349045	1678	25920814226000	23759	11754	9	0	\N
349046	1678	25920814227000	23759	11754	10	0	\N
349047	1678	25920814228000	23759	11754	11	0	\N
349048	1678	25920814229000	23759	11754	12	0	\N
349049	1678	25920814230000	23759	11754	13	0	\N
349050	1678	25920814231000	23759	11754	14	0	\N
349051	1874	23650000	23759	11754	15	0	\N
349052	1874	23651000	23759	11754	16	0	\N
349053	1874	23652000	23759	11754	17	0	\N
349054	1874	23653000	23759	11754	18	0	\N
349055	1874	23655000	23759	11754	19	0	\N
349056	1874	23657000	23759	11754	20	0	\N
349057	1874	23659000	23759	11754	21	0	\N
349058	1874	23661000	23759	11754	22	0	\N
349059	1874	23663000	23759	11754	23	0	\N
349060	1874	23665000	23759	11754	24	0	\N
349061	1874	23667000	23759	11754	25	0	\N
349062	1874	23669000	23759	11754	26	0	\N
349063	1874	23671000	23759	11754	27	0	\N
349064	1874	23673000	23759	11754	28	0	\N
349065	1874	23675000	23759	11754	29	0	\N
349066	1874	23677000	23759	11754	30	0	\N
349067	1874	23679000	23759	11754	31	0	\N
349068	1874	23681000	23759	11754	32	0	\N
349069	1874	23683000	23759	11754	33	0	\N
349070	1874	23685000	23759	11754	34	0	\N
349071	1874	23687000	23759	11754	35	0	\N
349072	1874	23689000	23759	11754	36	0	\N
349073	1874	23691000	23759	11754	37	0	\N
349074	1874	23693000	23759	11754	38	0	\N
349075	1874	23695000	23759	11754	39	0	\N
349076	1874	23697000	23759	11754	40	0	\N
349077	1874	23699000	23759	11754	41	0	\N
349078	1874	23701000	23759	11754	42	0	\N
349079	1874	23703000	23759	11754	43	0	\N
349080	1874	23705000	23759	11754	44	0	\N
349081	1874	23707000	23759	11754	45	0	\N
349082	1874	23709000	23759	11754	46	0	\N
349083	1874	23711000	23759	11754	47	0	\N
349084	1874	23713000	23759	11754	48	0	\N
349085	1874	23715000	23759	11754	49	0	\N
349086	1874	23717000	23759	11754	50	0	\N
349087	1874	23719000	23759	11754	51	0	\N
349088	1874	23721000	23759	11754	52	0	\N
349089	1874	23723000	23759	11754	53	0	\N
349090	1874	23725000	23759	11754	54	0	\N
349091	1874	23727000	23759	11754	55	0	\N
349092	1874	23729000	23759	11754	56	0	\N
349093	1874	23731000	23759	11754	57	0	\N
349094	1874	23733000	23759	11754	58	0	\N
349095	1874	23734000	23759	11754	59	0	\N
349096	1874	23735000	23759	11754	60	0	\N
349097	1874	23736000	23759	11754	61	0	\N
349098	1874	23739000	23759	11754	62	0	\N
349099	1874	23742000	23759	11754	63	0	\N
349100	1874	23745000	23759	11754	64	0	\N
349101	1874	23748000	23759	11754	65	0	\N
349102	1874	23751000	23759	11754	66	0	\N
349103	1874	23754000	23759	11754	67	0	\N
349104	1874	23757000	23759	11754	68	0	\N
349105	1874	23760000	23759	11754	69	0	\N
349106	1874	23763000	23759	11754	70	0	\N
349107	1874	23766000	23759	11754	71	0	\N
349108	1874	23769000	23759	11754	72	0	\N
349109	1874	23772000	23759	11754	73	0	\N
349110	1874	23775000	23759	11754	74	0	\N
349111	1874	23778000	23759	11754	75	0	\N
349112	1874	23781000	23759	11754	76	0	\N
349034	1874	24261000	23758	11831	2	0	2
349035	1874	24264000	23758	11831	3	0	2
349113	1874	23784000	23759	11754	77	0	\N
349114	1874	23787000	23759	11754	78	0	\N
349115	1874	23790000	23759	11754	79	0	\N
349116	1874	23793000	23759	11754	81	0	\N
349117	1874	23796000	23759	11754	82	0	\N
349118	1874	23799000	23759	11754	83	0	\N
349119	1874	23802000	23759	11754	84	0	\N
349120	1874	23805000	23759	11754	85	0	\N
349121	1874	23808000	23759	11754	86	0	\N
349122	1874	23811000	23759	11754	87	0	\N
349123	1874	23814000	23759	11754	88	0	\N
349124	1874	23817000	23759	11754	89	0	\N
349125	1874	23820000	23759	11754	90	0	\N
349126	1874	23823000	23759	11754	91	0	\N
349127	1874	23826000	23759	11754	92	0	\N
349128	1874	23829000	23759	11754	93	0	\N
349129	1874	23832000	23759	11754	94	0	\N
349130	1874	23835000	23759	11754	95	0	\N
349131	1874	23838000	23759	11754	96	0	\N
349132	1874	23841000	23759	11754	97	0	\N
349133	1874	23844000	23759	11754	98	0	\N
349134	1874	23847000	23759	11754	99	0	\N
349135	1874	23850000	23759	11754	100	0	\N
349136	1874	23853000	23759	11754	101	0	\N
349137	1874	23856000	23759	11754	102	0	\N
349138	1874	23859000	23759	11754	103	0	\N
349139	1874	23862000	23759	11754	104	0	\N
349140	1874	23865000	23759	11754	105	0	\N
349141	1874	23868000	23759	11754	106	0	\N
349142	1874	23871000	23759	11754	107	0	\N
349143	1874	23874000	23759	11754	108	0	\N
349144	1874	23877000	23759	11754	109	0	\N
349145	1874	23880000	23759	11754	110	0	\N
349146	1874	23883000	23759	11754	111	0	\N
349147	1874	23886000	23759	11754	112	0	\N
349148	1874	23889000	23759	11754	113	0	\N
349149	1874	23892000	23759	11754	114	0	\N
349150	1874	23895000	23759	11754	115	0	\N
349151	1874	23898000	23759	11754	116	0	\N
349152	1874	23901000	23759	11754	117	0	\N
349153	1874	23904000	23759	11754	118	0	\N
349154	1874	23907000	23759	11754	119	0	\N
349155	1874	23910000	23759	11754	120	0	\N
349156	1874	23913000	23759	11754	121	0	\N
349157	1874	23916000	23759	11754	122	0	\N
349158	1874	23919000	23759	11754	123	0	\N
349159	1874	23920000	23759	11754	124	0	\N
349160	1874	23921000	23759	11754	125	0	\N
349161	1678	26640839233000	23760	11832	0	0	\N
349162	1678	26640839234000	23760	11832	1	0	\N
349163	1874	24267000	23760	11832	2	0	\N
349164	1874	24270000	23760	11832	3	0	\N
349165	1874	24272000	23760	11832	4	0	\N
349166	1874	24274000	23760	11832	5	0	\N
349173	1678	25920814162000	23762	11785	1	0	\N
349174	1678	25920814163000	23762	11785	2	0	\N
349175	1678	25920814164000	23762	11785	3	0	\N
349176	1678	25920814165000	23762	11785	4	0	\N
349177	1678	25920814166000	23762	11785	5	0	\N
349178	1678	25920814167000	23762	11785	6	0	\N
349179	1678	25920814168000	23762	11785	7	0	\N
349180	1678	25920814169000	23762	11785	8	0	\N
349181	1678	25920814170000	23762	11785	9	0	\N
349182	1678	25920814171000	23762	11785	10	0	\N
349183	1678	25920814172000	23762	11785	11	0	\N
349184	1678	25920814173000	23762	11785	12	0	\N
349185	1678	25920814174000	23762	11785	13	0	\N
349186	1678	25920814175000	23762	11785	14	0	\N
349187	1678	25920814176000	23762	11785	15	0	\N
349188	1678	25920814177000	23762	11785	16	0	\N
349189	1678	25920814178000	23762	11785	17	0	\N
349190	1678	25920814179000	23762	11785	18	0	\N
349191	1678	25920814180000	23762	11785	19	0	\N
349192	1678	25920814181000	23762	11785	20	0	\N
349193	1678	25920814182000	23762	11785	21	0	\N
349194	1678	25920814183000	23762	11785	22	0	\N
349195	1678	25920814184000	23762	11785	23	0	\N
349196	1678	25920814185000	23762	11785	24	0	\N
349197	1678	25920814186000	23762	11785	25	0	\N
349198	1678	25920814187000	23762	11785	26	0	\N
349199	1678	25920814188000	23762	11785	27	0	\N
349200	1678	25920814189000	23762	11785	28	0	\N
349201	1678	25920814190000	23762	11785	29	0	\N
349202	1678	25920814191000	23762	11785	30	0	\N
349203	1678	25920814192000	23762	11785	31	0	\N
349204	1678	25920814193000	23762	11785	32	0	\N
349205	1678	25920814194000	23762	11785	33	0	\N
349206	1678	25920814195000	23762	11785	34	0	\N
349207	1678	25920814196000	23762	11785	35	0	\N
349208	1678	25920814197000	23762	11785	36	0	\N
349209	1678	25920814198000	23762	11785	37	0	\N
349210	1678	25920814199000	23762	11785	38	0	\N
349211	1678	25920814200000	23762	11785	39	0	\N
349212	1678	25920814201000	23762	11785	40	0	\N
349213	1678	25920814202000	23762	11785	41	0	\N
349214	1678	25920814203000	23762	11785	42	0	\N
349215	1678	25920814204000	23762	11785	43	0	\N
349216	1678	25920814205000	23762	11785	44	0	\N
349217	1678	25920814206000	23762	11785	45	0	\N
349218	1678	25920814207000	23762	11785	46	0	\N
349219	1678	25920814208000	23762	11785	47	0	\N
349220	1678	25920814209000	23762	11785	48	0	\N
349221	1678	25920814210000	23762	11785	49	0	\N
349222	1678	25920814211000	23762	11785	50	0	\N
349223	1678	25920814212000	23762	11785	51	0	\N
349224	1678	25920814213000	23762	11785	52	0	\N
349225	1678	25920814214000	23762	11785	53	0	\N
349226	1678	25920814215000	23762	11785	54	0	\N
349227	1678	25920814216000	23762	11785	55	0	\N
349228	1678	25920814217000	23762	11785	56	0	\N
349229	1678	25920814218000	23762	11785	57	0	\N
349230	1678	25920814219000	23762	11785	58	0	\N
349231	1678	25920814220000	23762	11785	59	0	\N
349232	1678	25920814221000	23762	11785	60	0	\N
349233	1678	25920814222000	23762	11785	61	0	\N
349234	1678	25920814223000	23762	11785	62	0	\N
349235	1678	25920814224000	23762	11785	63	0	\N
349236	1678	25920814225000	23762	11785	64	0	\N
349237	1678	25920814226000	23762	11785	65	0	\N
349238	1678	25920814227000	23762	11785	66	0	\N
349239	1678	25920814228000	23762	11785	67	0	\N
349240	1678	25920814229000	23762	11785	68	0	\N
349241	1678	25920814230000	23762	11785	69	0	\N
349242	1678	25920814231000	23762	11785	70	0	\N
349243	1678	25920814232000	23762	11785	71	0	\N
349244	1678	25920814233000	23762	11785	72	0	\N
349245	1678	25920814234000	23762	11785	73	0	\N
349246	1321	1710569637751650	23762	11785	74	0	\N
349247	955	507701775000000	23762	11785	75	0	\N
349248	1075	909796465000000	23762	11785	76	0	\N
349169	1874	24267000	23761	11832	2	0	2
349170	1874	24270000	23761	11832	3	0	2
349171	1874	24272000	23761	11832	4	0	2
349172	1874	24274000	23761	11832	5	0	2
349249	1874	23889000	23762	11785	77	0	\N
349250	1874	23890000	23762	11785	78	0	\N
349251	1195	613858750000000	23762	11785	79	0	\N
349252	1874	23892000	23762	11785	80	0	\N
349253	1874	23895000	23762	11785	81	0	\N
349254	1874	23896000	23762	11785	82	0	\N
349255	2309	1000000000	23762	11785	83	0	\N
349256	1874	23898000	23762	11785	84	0	\N
349257	1874	23900000	23762	11785	85	0	\N
349258	1874	23902000	23762	11785	86	0	\N
349259	1874	23904000	23762	11785	87	0	\N
349260	2309	2742644000000	23762	11785	88	0	\N
349261	1874	23906000	23762	11785	89	0	\N
349262	1874	23908000	23762	11785	90	0	\N
349263	1874	23910000	23762	11785	91	0	\N
349264	1874	23912000	23762	11785	92	0	\N
349265	1874	23914000	23762	11785	93	0	\N
349266	1874	23916000	23762	11785	94	0	\N
349267	1874	23918000	23762	11785	95	0	\N
349268	1874	23920000	23762	11785	96	0	\N
349269	1874	23922000	23762	11785	97	0	\N
349270	1874	23924000	23762	11785	98	0	\N
349271	1874	23926000	23762	11785	99	0	\N
349272	1874	23928000	23762	11785	100	0	\N
349273	1874	23930000	23762	11785	101	0	\N
349274	1874	23932000	23762	11785	102	0	\N
349275	1874	23934000	23762	11785	103	0	\N
349276	1874	23936000	23762	11785	104	0	\N
349277	1874	23938000	23762	11785	106	0	\N
349278	1874	23940000	23762	11785	107	0	\N
349279	1874	23942000	23762	11785	108	0	\N
349280	1874	23944000	23762	11785	109	0	\N
349281	1874	23946000	23762	11785	110	0	\N
349282	1874	23948000	23762	11785	111	0	\N
349283	1874	23950000	23762	11785	112	0	\N
349284	1874	23952000	23762	11785	113	0	\N
349285	1874	23954000	23762	11785	114	0	\N
349286	1874	23956000	23762	11785	115	0	\N
349287	1874	23959000	23762	11785	116	0	\N
349288	1874	23962000	23762	11785	117	0	\N
349289	1874	23965000	23762	11785	118	0	\N
349290	1874	23968000	23762	11785	119	0	\N
349291	1874	23971000	23762	11785	120	0	\N
349292	1874	23974000	23762	11785	121	0	\N
349293	1874	23977000	23762	11785	122	0	\N
349294	1874	23980000	23762	11785	123	0	\N
349295	1874	23983000	23762	11785	124	0	\N
349296	1874	23986000	23762	11785	125	0	\N
349297	1678	26640839235000	23763	11833	0	0	\N
349298	1678	26640839236000	23763	11833	1	0	\N
349299	1874	24276000	23763	11833	2	0	\N
349300	1874	24279000	23763	11833	3	0	\N
349301	1874	24281000	23763	11833	4	0	\N
349302	1874	24282000	23763	11833	5	0	\N
349303	1874	24285000	23763	11833	6	0	\N
349309	1678	26640839235000	23765	11833	0	0	\N
349310	1678	26640839236000	23765	11833	1	0	\N
349311	1874	24276000	23765	11833	2	0	\N
349312	1874	24279000	23765	11833	3	0	\N
349313	1874	24281000	23765	11833	4	0	\N
349314	1874	24282000	23765	11833	5	0	\N
349315	1874	24285000	23765	11833	6	0	\N
349325	1678	26640839239000	23769	11836	0	0	\N
349326	1874	24298000	23769	11836	1	0	\N
349327	1874	24301000	23769	11836	2	0	\N
349334	1678	26640839239000	23772	11837	0	0	\N
349335	1678	26640839240000	23772	11837	1	0	\N
349336	1874	24304000	23772	11837	2	0	\N
349337	1874	24306000	23772	11837	3	0	\N
349348	1678	26640839243000	23775	11839	0	0	\N
349349	1874	24320000	23775	11839	1	0	\N
349350	1874	24322000	23775	11839	2	0	\N
349351	1678	26640839243000	23776	11839	0	0	\N
349352	1874	24320000	23776	11839	1	0	\N
349353	1874	24322000	23776	11839	2	0	\N
349354	1678	26640839244000	23777	11840	0	0	\N
349355	1874	24325000	23777	11840	1	0	\N
349356	1874	24327000	23777	11840	2	0	\N
349364	1874	24335000	23781	11842	0	0	\N
349365	1874	24337000	23781	11842	1	0	\N
349366	1678	26640839246000	23782	11842	0	0	\N
349367	1678	26640839247000	23782	11842	1	0	\N
349368	1874	24335000	23782	11842	2	0	\N
349369	1874	24338000	23782	11842	3	0	\N
349370	1874	24340000	23782	11842	4	0	\N
349371	1874	24343000	23782	11842	5	0	\N
349380	1678	26640839248000	23785	11843	0	0	\N
349381	1874	24344000	23785	11843	1	0	\N
349382	1874	24346000	23785	11843	2	0	\N
349383	1874	24349000	23785	11843	3	0	\N
349384	1678	26640839248000	23786	11843	0	0	\N
349306	1874	24281000	23764	11833	2	0	2
349307	1874	24282000	23764	11833	3	0	2
349308	1874	24285000	23764	11833	4	0	2
349316	1678	26640839235000	23766	11834	0	0	0
349317	1678	26640839236000	23766	11834	1	0	0
349319	1874	24287000	23766	11834	3	0	2
349320	1874	24290000	23766	11834	4	0	2
349321	1678	26640839238000	23767	11835	0	0	0
349322	1874	24292000	23767	11835	2	0	2
349323	1874	24295000	23767	11835	3	0	2
349328	1874	24298000	23770	11836	0	0	2
349329	1874	24301000	23770	11836	1	0	2
349330	1678	26640839239000	23771	11837	0	0	0
349331	1678	26640839240000	23771	11837	1	0	0
349333	1874	24306000	23771	11837	3	0	2
349338	1678	26640839241000	23773	11838	0	0	0
349339	1678	26640839242000	23773	11838	1	0	0
349340	1874	24308000	23773	11838	2	0	2
349341	1874	24310000	23773	11838	3	0	2
349343	1874	24316000	23773	11838	5	0	2
349344	1874	24317000	23773	11838	6	0	2
349345	1678	26640839243000	23774	11839	0	0	0
349346	1874	24320000	23774	11839	1	0	2
349347	1874	24322000	23774	11839	2	0	2
349358	1874	24325000	23778	11840	1	0	2
349359	1874	24327000	23778	11840	2	0	2
349360	1678	26640839245000	23780	11841	0	0	0
349361	1874	24328000	23780	11841	1	0	2
349363	1874	24333000	23780	11841	3	0	2
349372	1678	26640839246000	23783	11842	0	0	0
349373	1678	26640839247000	23783	11842	1	0	0
349374	1874	24335000	23783	11842	2	0	2
349375	1874	24338000	23783	11842	3	0	2
349377	1874	24343000	23783	11842	5	0	2
349378	1874	24344000	23784	11843	0	0	2
349379	1874	24346000	23784	11843	1	0	2
349385	1874	24344000	23786	11843	1	0	\N
349386	1874	24346000	23786	11843	2	0	\N
349387	1874	24349000	23786	11843	3	0	\N
349388	1678	26640839248000	23787	11843	0	0	\N
349389	1874	24344000	23787	11843	1	0	\N
349390	1874	24346000	23787	11843	2	0	\N
349391	1874	24349000	23787	11843	3	0	\N
349392	1678	26640839248000	23788	11843	0	0	\N
349393	1874	24344000	23788	11843	1	0	\N
349394	1874	24346000	23788	11843	2	0	\N
349395	1874	24349000	23788	11843	3	0	\N
349401	1678	26640839248000	23790	11844	0	0	\N
349402	1678	26640839249000	23790	11844	1	0	\N
349403	1874	24348000	23790	11844	2	0	\N
349404	1874	24351000	23790	11844	3	0	\N
349405	1874	24354000	23790	11844	4	0	\N
349406	1678	26640839250000	23791	11845	0	0	\N
349407	1874	24357000	23791	11845	1	0	\N
349408	1874	24359000	23791	11845	2	0	\N
349411	1678	26640839250000	23793	11845	0	0	\N
349412	1874	24357000	23793	11845	1	0	\N
349413	1874	24359000	23793	11845	2	0	\N
349414	1678	26640839250000	23794	11845	0	0	\N
349415	1874	24357000	23794	11845	1	0	\N
349416	1874	24359000	23794	11845	2	0	\N
349417	1678	26640839250000	23795	11845	0	0	\N
349418	1874	24357000	23795	11845	1	0	\N
349419	1874	24359000	23795	11845	2	0	\N
349420	1678	26640839250000	23796	11846	0	0	\N
349421	1678	26640839251000	23796	11846	1	0	\N
349422	1874	24361000	23796	11846	2	0	\N
349423	1874	24364000	23796	11846	3	0	\N
349424	1678	26640839250000	23797	11846	0	0	\N
349425	1678	26640839251000	23797	11846	1	0	\N
349426	1874	24361000	23797	11846	2	0	\N
349427	1874	24364000	23797	11846	3	0	\N
349428	1678	26640839250000	23798	11846	0	0	\N
349429	1678	26640839251000	23798	11846	1	0	\N
349430	1874	24361000	23798	11846	2	0	\N
349431	1874	24364000	23798	11846	3	0	\N
349432	1678	26640839250000	23799	11846	0	0	\N
349433	1678	26640839251000	23799	11846	1	0	\N
349434	1874	24361000	23799	11846	2	0	\N
349435	1874	24364000	23799	11846	3	0	\N
349447	1678	26640839252000	23802	11847	0	0	\N
349448	1678	26640839253000	23802	11847	1	0	\N
349449	1874	24366000	23802	11847	2	0	\N
349450	1874	24368000	23802	11847	3	0	\N
349451	1874	24369000	23802	11847	4	0	\N
349452	1874	24372000	23802	11847	5	0	\N
349453	1874	24375000	23802	11847	6	0	\N
349457	1678	26640839254000	23804	11848	0	0	\N
349458	1874	24378000	23804	11848	1	0	\N
349459	1874	24380000	23804	11848	2	0	\N
349475	2310	0	23808	11851	0	0	\N
349476	1678	26640839258000	23808	11851	1	0	\N
349477	1874	24399000	23808	11851	2	0	\N
349478	1874	24401000	23808	11851	3	0	\N
349479	1874	24402000	23808	11851	4	0	\N
349480	1678	26640839259000	23809	11852	0	0	\N
349481	1874	24404000	23809	11852	1	0	\N
349482	1874	24407000	23809	11852	2	0	\N
349483	1678	26640839259000	23810	11852	0	0	\N
349484	1874	24404000	23810	11852	1	0	\N
349485	1874	24407000	23810	11852	2	0	\N
349489	1678	26640839260000	23812	11853	0	0	\N
349490	1874	24409000	23812	11853	1	0	\N
349491	1874	24412000	23812	11853	2	0	\N
349495	1678	26640839260000	23814	11853	0	0	\N
349496	1874	24409000	23814	11853	1	0	\N
349497	1874	24412000	23814	11853	2	0	\N
349511	1678	26640839263000	23818	11856	0	0	\N
349512	1678	26640839264000	23818	11856	1	0	\N
349513	1874	24425000	23818	11856	3	0	\N
349514	1874	24427000	23818	11856	4	0	\N
349515	1874	24430000	23818	11856	5	0	\N
349516	1874	24433000	23818	11856	6	0	\N
349517	1678	26640839265000	23819	11857	0	0	\N
349518	1678	26640839266000	23819	11857	1	0	\N
349519	1874	24434000	23819	11857	2	0	\N
349520	1874	24436000	23819	11857	3	0	\N
349398	1874	24348000	23789	11844	2	0	2
349399	1874	24351000	23789	11844	3	0	2
349400	1874	24354000	23789	11844	4	0	2
349409	1874	24357000	23792	11845	0	0	2
349410	1874	24359000	23792	11845	1	0	2
349437	1678	26640839251000	23800	11846	1	0	0
349438	1874	24361000	23800	11846	2	0	2
349439	1874	24364000	23800	11846	3	0	2
349440	1678	26640839252000	23801	11847	0	0	0
349441	1678	26640839253000	23801	11847	1	0	0
349443	1874	24368000	23801	11847	3	0	2
349444	1874	24369000	23801	11847	4	0	2
349445	1874	24372000	23801	11847	5	0	2
349446	1874	24375000	23801	11847	6	0	2
349455	1874	24378000	23803	11848	1	0	2
349456	1874	24380000	23803	11848	2	0	2
349460	1678	26640839255000	23805	11849	0	0	0
349461	1874	24383000	23805	11849	1	0	2
349462	1874	24384000	23805	11849	2	0	2
349464	1678	26640839256000	23806	11850	0	0	0
349465	1678	26640839257000	23806	11850	1	0	0
349466	1874	24389000	23806	11850	2	0	2
349467	1874	24392000	23806	11850	3	0	2
349468	1874	24394000	23806	11850	4	0	2
349470	2310	0	23807	11851	0	0	0
349471	1678	26640839258000	23807	11851	1	0	0
349472	1874	24399000	23807	11851	2	0	2
349473	1874	24401000	23807	11851	3	0	2
349486	1678	26640839259000	23811	11852	0	0	0
349487	1874	24404000	23811	11852	1	0	2
349488	1874	24407000	23811	11852	2	0	2
349492	1678	26640839260000	23813	11853	0	0	0
349493	1874	24409000	23813	11853	1	0	2
349498	1678	26640839261000	23815	11854	0	0	0
349499	1874	24414000	23815	11854	1	0	2
349500	1874	24417000	23815	11854	2	0	2
349501	1678	26640839262000	23816	11855	0	0	0
349502	1874	24419000	23816	11855	1	0	2
349504	1874	24423000	23816	11855	3	0	2
349505	1678	26640839263000	23817	11856	0	0	0
349506	1678	26640839264000	23817	11856	1	0	0
349507	1874	24425000	23817	11856	3	0	2
349509	1874	24430000	23817	11856	5	0	2
349510	1874	24433000	23817	11856	6	0	2
349521	1874	24438000	23819	11857	4	0	\N
349522	1874	24441000	23819	11857	5	0	\N
349523	1874	24444000	23819	11857	6	0	\N
349533	1678	26640839267000	23822	11858	0	0	\N
349534	1874	24446000	23822	11858	1	0	\N
349535	1874	24449000	23822	11858	2	0	\N
349536	1678	26640839268000	23823	11859	0	0	\N
349537	1678	26640839269000	23823	11859	1	0	\N
349538	1874	24448000	23823	11859	2	0	\N
349539	1874	24450000	23823	11859	3	0	\N
349540	1874	24451000	23823	11859	4	0	\N
349549	1678	26640839268000	23825	11859	0	0	\N
349550	1678	26640839269000	23825	11859	1	0	\N
349551	1874	24448000	23825	11859	2	0	\N
349552	1874	24450000	23825	11859	3	0	\N
349553	1874	24451000	23825	11859	4	0	\N
349554	1874	24454000	23825	11859	5	0	\N
349555	1874	24457000	23825	11859	6	0	\N
349556	1874	24460000	23825	11859	7	0	\N
349563	2310	0	23828	11847	0	0	\N
349564	1678	26640839272000	23829	11862	0	0	\N
349565	1678	26640839273000	23829	11862	1	0	\N
349566	1874	24472000	23829	11862	2	0	\N
349567	1874	24474000	23829	11862	3	0	\N
349568	1874	24475000	23829	11862	4	0	\N
349569	1874	24478000	23829	11862	5	0	\N
349570	1874	24481000	23829	11862	6	0	\N
349571	1678	26640839272000	23830	11862	0	0	\N
349572	1678	26640839273000	23830	11862	1	0	\N
349573	1874	24472000	23830	11862	2	0	\N
349574	1874	24474000	23830	11862	3	0	\N
349575	1874	24475000	23830	11862	4	0	\N
349576	1874	24478000	23830	11862	5	0	\N
349577	1874	24481000	23830	11862	6	0	\N
349578	1678	26640839272000	23831	11862	0	0	\N
349579	1678	26640839273000	23831	11862	1	0	\N
349580	1874	24472000	23831	11862	2	0	\N
349581	1874	24474000	23831	11862	3	0	\N
349582	1874	24475000	23831	11862	4	0	\N
349583	1874	24478000	23831	11862	5	0	\N
349584	1874	24481000	23831	11862	6	0	\N
349592	1678	26640839272000	23833	11862	0	0	\N
349593	1678	26640839273000	23833	11862	1	0	\N
349594	1874	24472000	23833	11862	2	0	\N
349595	1874	24474000	23833	11862	3	0	\N
349596	1874	24475000	23833	11862	4	0	\N
349597	1874	24478000	23833	11862	5	0	\N
349598	1874	24481000	23833	11862	6	0	\N
349599	1678	26640839274000	23834	11863	0	0	\N
349600	1874	24483000	23834	11863	1	0	\N
349601	1874	24485000	23834	11863	2	0	\N
349602	1874	24486000	23834	11863	3	0	\N
349603	1678	26640839274000	23835	11863	0	0	\N
349604	1874	24483000	23835	11863	1	0	\N
349605	1874	24485000	23835	11863	2	0	\N
349606	1874	24488000	23835	11863	3	0	\N
349607	1874	24489000	23835	11863	4	0	\N
349608	1874	24492000	23835	11863	5	0	\N
349615	1874	24484000	23837	11863	0	0	\N
349616	1874	24487000	23837	11863	1	0	\N
349620	1678	26640839275000	23839	11864	0	0	\N
349621	1874	24495000	23839	11864	1	0	\N
349622	1874	24497000	23839	11864	2	0	\N
349643	1678	26640839282000	23844	11869	0	0	\N
349644	1874	24532000	23844	11869	1	0	\N
349645	1874	24534000	23844	11869	2	0	\N
349646	1678	26640839282000	23845	11869	0	0	\N
349647	1874	24532000	23845	11869	1	0	\N
349648	1874	24534000	23845	11869	2	0	\N
349652	2310	0	23847	11673	0	0	\N
349653	1361	1705653644951650	23847	11673	1	0	\N
349654	1115	907182953800000	23847	11673	2	0	\N
349655	1235	612094660400000	23847	11673	3	0	\N
349656	995	506242508600000	23847	11673	4	0	\N
349526	1874	24434000	23820	11857	2	0	2
349527	1874	24436000	23820	11857	3	0	2
349528	1874	24438000	23820	11857	4	0	2
349529	1874	24441000	23820	11857	5	0	2
349530	1874	24444000	23820	11857	6	0	2
349532	1874	24446000	23821	11858	1	0	2
349541	1678	26640839268000	23824	11859	0	0	0
349542	1678	26640839269000	23824	11859	1	0	0
349543	1874	24448000	23824	11859	2	0	2
349544	1874	24450000	23824	11859	3	0	2
349546	1874	24454000	23824	11859	5	0	2
349547	1874	24457000	23824	11859	6	0	2
349548	1874	24460000	23824	11859	7	0	2
349557	1678	26640839270000	23826	11860	0	0	0
349559	1874	24465000	23826	11860	2	0	2
349560	1678	26640839271000	23827	11861	0	0	0
349561	1874	24468000	23827	11861	1	0	2
349562	1874	24470000	23827	11861	2	0	2
349585	1678	26640839272000	23832	11862	0	0	0
349587	1874	24472000	23832	11862	2	0	2
349588	1874	24474000	23832	11862	3	0	2
349589	1874	24475000	23832	11862	4	0	2
349590	1874	24478000	23832	11862	5	0	2
349591	1874	24481000	23832	11862	6	0	2
349610	1874	24483000	23836	11863	1	0	2
349611	1874	24485000	23836	11863	2	0	2
349612	1874	24488000	23836	11863	3	0	2
349613	1874	24489000	23836	11863	4	0	2
349617	1678	26640839275000	23838	11864	0	0	0
349618	1874	24495000	23838	11864	1	0	2
349619	1874	24497000	23838	11864	2	0	2
349623	1678	26640839276000	23840	11865	0	0	0
349624	1874	24499000	23840	11865	1	0	2
349626	1678	26640839277000	23841	11866	0	0	0
349627	1678	26640839278000	23841	11866	1	0	0
349628	1874	24505000	23841	11866	2	0	2
349629	1874	24507000	23841	11866	3	0	2
349630	1874	24509000	23841	11866	4	0	2
349632	1874	24513000	23841	11866	6	0	2
349633	1678	26640839279000	23842	11867	0	0	0
349634	1874	24515000	23842	11867	1	0	2
349635	1874	24518000	23842	11867	2	0	2
349637	1678	26640839281000	23843	11868	1	0	0
349638	1874	24521000	23843	11868	2	0	2
349639	1874	24524000	23843	11868	3	0	2
349640	1874	24526000	23843	11868	4	0	2
349641	1874	24528000	23843	11868	5	0	2
349649	1678	26640839282000	23846	11869	0	0	0
349650	1874	24532000	23846	11869	1	0	2
349651	1874	24534000	23846	11869	2	0	2
349657	1483	11000000	23847	11673	5	0	\N
349658	1448	12276856000001	23847	11673	6	0	\N
349659	1678	25920814027000	23847	11673	7	0	\N
349660	38	66443668039709	23847	11673	8	0	\N
349661	969	506150276480512	23847	11673	9	0	\N
349662	1678	25920814028000	23847	11673	10	0	\N
349663	1678	25920814029000	23847	11673	12	0	\N
349664	1678	25920814030000	23847	11673	13	0	\N
349665	1678	25920814031000	23847	11673	14	0	\N
349666	1678	25920814032000	23847	11673	15	0	\N
349667	1678	25920814033000	23847	11673	16	0	\N
349668	1678	25920814034000	23847	11673	17	0	\N
349669	1678	25920814035000	23847	11673	18	0	\N
349670	1678	25920814036000	23847	11673	19	0	\N
349671	1678	25920814037000	23847	11673	20	0	\N
349672	1678	25920814038000	23847	11673	21	0	\N
349673	1678	25920814039000	23847	11673	22	0	\N
349674	1678	25920814040000	23847	11673	23	0	\N
349675	1678	25920814041000	23847	11673	24	0	\N
349676	1678	25920814042000	23847	11673	25	0	\N
349677	1678	25920814043000	23847	11673	26	0	\N
349678	1678	25920814044000	23847	11673	27	0	\N
349679	1678	25920814045000	23847	11673	28	0	\N
349680	1678	25920814046000	23847	11673	29	0	\N
349681	1678	25920814047000	23847	11673	30	0	\N
349682	1678	25920814048000	23847	11673	31	0	\N
349683	1678	25920814049000	23847	11673	32	0	\N
349684	1089	907016958757500	23847	11673	33	0	\N
349685	1209	611982415663305	23847	11673	34	0	\N
349686	1335	1705343415688246	23847	11673	35	0	\N
349687	945	506263745391541	23847	11673	36	0	\N
349688	1065	907220979807644	23847	11673	37	0	\N
349689	1185	612120180476079	23847	11673	38	0	\N
349690	1678	25920814050000	23847	11673	40	0	\N
349691	1678	25920814051000	23847	11673	41	0	\N
349692	1678	25920814052000	23847	11673	42	0	\N
349693	1678	25920814053000	23847	11673	43	0	\N
349694	1678	25920814054000	23847	11673	44	0	\N
349695	1678	25920814055000	23847	11673	45	0	\N
349696	1678	25920814056000	23847	11673	46	0	\N
349697	1678	25920814057000	23847	11673	47	0	\N
349698	1678	25920814058000	23847	11673	48	0	\N
349699	1678	25920814059000	23847	11673	49	0	\N
349700	1678	25920814060000	23847	11673	50	0	\N
349701	1678	25920814061000	23847	11673	51	0	\N
349702	1678	25920814062000	23847	11673	52	0	\N
349703	1678	25920814063000	23847	11673	53	0	\N
349704	1678	25920814064000	23847	11673	54	0	\N
349705	1678	25920814065000	23847	11673	55	0	\N
349706	1678	25920814066000	23847	11673	56	0	\N
349707	1678	25920814067000	23847	11673	57	0	\N
349708	1678	25920814068000	23847	11673	58	0	\N
349709	1678	25920814069000	23847	11673	59	0	\N
349710	1678	25920814070000	23847	11673	60	0	\N
349711	1678	25920814071000	23847	11673	61	0	\N
349712	1678	25920814072000	23847	11673	62	0	\N
349713	1678	25920814073000	23847	11673	63	0	\N
349714	1678	25920814074000	23847	11673	64	0	\N
349715	1678	25920814075000	23847	11673	65	0	\N
349716	1678	25920814076000	23847	11673	66	0	\N
349717	1678	25920814077000	23847	11673	67	0	\N
349718	1678	25920814078000	23847	11673	68	0	\N
349719	1678	25920814079000	23847	11673	69	0	\N
349720	1678	25920814080000	23847	11673	70	0	\N
349721	1678	25920814081000	23847	11673	71	0	\N
349722	1678	25920814082000	23847	11673	72	0	\N
349723	1678	25920814083000	23847	11673	73	0	\N
349724	1678	25920814084000	23847	11673	74	0	\N
349725	1678	25920814085000	23847	11673	75	0	\N
349726	1678	25920814086000	23847	11673	76	0	\N
349727	1678	25920814087000	23847	11673	77	0	\N
349728	1678	25920814088000	23847	11673	78	0	\N
349729	1678	25920814089000	23847	11673	79	0	\N
349730	1678	25920814090000	23847	11673	80	0	\N
349731	1311	1705725607568145	23847	11673	81	0	\N
349732	489	66458391250309	23847	11673	82	0	\N
349733	741	5034666003811	23847	11673	83	0	\N
349734	730	5034666003811	23847	11673	84	0	\N
349735	1678	25920814091000	23847	11673	85	0	\N
349736	1678	25920814092000	23847	11673	86	0	\N
349737	1678	25920814093000	23847	11673	87	0	\N
349738	1678	25920814094000	23847	11673	88	0	\N
349739	1678	25920814095000	23847	11673	89	0	\N
349740	1678	25920814096000	23847	11673	90	0	\N
349741	1678	25920814097000	23847	11673	91	0	\N
349742	1678	25920814098000	23847	11673	92	0	\N
349743	1678	25920814099000	23847	11673	93	0	\N
349744	1678	25920814100000	23847	11673	94	0	\N
349745	1678	25920814101000	23847	11673	95	0	\N
349746	1678	25920814102000	23847	11673	96	0	\N
349747	1678	25920814103000	23847	11673	97	0	\N
349748	1678	25920814104000	23847	11673	98	0	\N
349749	1678	25920814105000	23847	11673	99	0	\N
349750	1678	25920814106000	23847	11673	100	0	\N
349751	1678	25920814107000	23847	11673	101	0	\N
349752	1678	25920814108000	23847	11673	102	0	\N
349753	1678	25920814109000	23847	11673	103	0	\N
349754	1678	25920814110000	23847	11673	104	0	\N
349755	1678	25920814111000	23847	11673	105	0	\N
349756	1678	25920814112000	23847	11673	106	0	\N
349757	1678	25920814113000	23847	11673	107	0	\N
349758	1678	25920814114000	23847	11673	108	0	\N
349759	1678	25920814115000	23847	11673	109	0	\N
349760	1678	25920814116000	23847	11673	110	0	\N
349761	1678	25920814117000	23847	11673	111	0	\N
349762	1678	25920814118000	23847	11673	112	0	\N
349763	1678	25920814119000	23847	11673	113	0	\N
349764	1678	25920814120000	23847	11673	114	0	\N
349765	1678	25920814121000	23847	11673	115	0	\N
349766	1678	25920814122000	23847	11673	116	0	\N
349767	1678	25920814123000	23847	11673	117	0	\N
349768	1678	25920814124000	23847	11673	118	0	\N
349769	1678	25920814125000	23847	11673	119	0	\N
349770	1678	25920814126000	23847	11673	120	0	\N
349771	1678	25920814127000	23847	11673	121	0	\N
349772	1678	25920814128000	23847	11673	122	0	\N
349773	1678	25920814129000	23847	11673	123	0	\N
349774	1678	25920814130000	23847	11673	124	0	\N
349775	1678	25920814131000	23847	11673	125	0	\N
349778	1678	26640839285000	23848	11870	2	0	0
349779	1874	24535000	23848	11870	3	0	2
349780	1874	24537000	23848	11870	4	0	2
349781	1874	24539000	23848	11870	5	0	2
349782	1874	24541000	23848	11870	6	0	2
349784	1874	24547000	23848	11870	8	0	2
349785	1874	24550000	23848	11870	9	0	2
349786	1678	26640839286000	23849	11871	0	0	0
349787	1874	24553000	23849	11871	1	0	2
349788	1874	24555000	23849	11871	2	0	2
349790	1874	24558000	23850	11872	1	0	2
349791	1874	24560000	23850	11872	2	0	2
349792	1874	24561000	23850	11872	3	0	2
349796	1678	26640839288000	23852	11873	0	0	\N
349797	1874	24563000	23852	11873	1	0	\N
349798	1874	24566000	23852	11873	2	0	\N
349799	2310	0	23853	11634	0	0	\N
349800	1361	1705653644951650	23853	11634	1	0	\N
349801	1115	907182953800000	23853	11634	2	0	\N
349802	1235	612094660400000	23853	11634	3	0	\N
349803	995	506242508600000	23853	11634	4	0	\N
349804	1483	11000000	23853	11634	5	0	\N
349805	1448	12276856000001	23853	11634	6	0	\N
349806	1678	25200791956000	23853	11634	7	0	\N
349807	1678	25200791957000	23853	11634	8	0	\N
349808	38	66443668039709	23853	11634	9	0	\N
349809	1678	25200791958000	23853	11634	10	0	\N
349810	2305	199000000000	23853	11634	11	0	\N
349811	969	506150276480512	23853	11634	12	0	\N
349812	1089	907016958757500	23853	11634	13	0	\N
349813	1209	611982415663305	23853	11634	14	0	\N
349814	1335	1705343415688246	23853	11634	15	0	\N
349815	945	506263745391541	23853	11634	16	0	\N
349816	1065	907220979807644	23853	11634	17	0	\N
349817	1185	612120180476079	23853	11634	18	0	\N
349818	1678	25200791959000	23853	11634	20	0	\N
349819	1678	25200791960000	23853	11634	21	0	\N
349820	1311	1705725607568145	23853	11634	22	0	\N
349821	489	66458391250309	23853	11634	23	0	\N
349822	741	5034666003811	23853	11634	24	0	\N
349823	730	5034666003811	23853	11634	25	0	\N
349824	1678	25200791961000	23853	11634	26	0	\N
349825	1678	25200791962000	23853	11634	27	0	\N
349826	1678	25200791963000	23853	11634	28	0	\N
349827	1678	25200791964000	23853	11634	29	0	\N
349828	1678	25200791965000	23853	11634	30	0	\N
349829	1678	25200791966000	23853	11634	31	0	\N
349830	1678	25200791967000	23853	11634	32	0	\N
349831	1678	25200791968000	23853	11634	33	0	\N
349832	1678	25200791969000	23853	11634	34	0	\N
349833	1678	25200791970000	23853	11634	35	0	\N
349834	1678	25200791971000	23853	11634	36	0	\N
349835	1678	25200791972000	23853	11634	37	0	\N
349836	1678	25200791973000	23853	11634	38	0	\N
349837	1678	25200791974000	23853	11634	39	0	\N
349838	1678	25200791975000	23853	11634	40	0	\N
349839	1678	25200791976000	23853	11634	41	0	\N
349840	1678	25200791977000	23853	11634	42	0	\N
349841	1678	25200791978000	23853	11634	43	0	\N
349842	1678	25200791979000	23853	11634	44	0	\N
349843	1678	25200791980000	23853	11634	45	0	\N
349844	1678	25200791981000	23853	11634	46	0	\N
349845	1678	25200791982000	23853	11634	47	0	\N
349846	1678	25200791983000	23853	11634	48	0	\N
349847	1678	25200791984000	23853	11634	49	0	\N
349848	1678	25200791985000	23853	11634	50	0	\N
349849	1678	25200791986000	23853	11634	51	0	\N
349850	1678	25200791987000	23853	11634	52	0	\N
349851	1678	25200791988000	23853	11634	53	0	\N
349852	1678	25200791989000	23853	11634	54	0	\N
349853	1678	25200791990000	23853	11634	55	0	\N
349854	1678	25200791991000	23853	11634	56	0	\N
349855	1678	25200791992000	23853	11634	57	0	\N
349856	1678	25200791993000	23853	11634	58	0	\N
349857	1678	25200791994000	23853	11634	59	0	\N
349858	1678	25200791995000	23853	11634	60	0	\N
349859	1678	25200791996000	23853	11634	61	0	\N
349860	1678	25200791997000	23853	11634	62	0	\N
349861	1678	25200791998000	23853	11634	63	0	\N
349862	1678	25200791999000	23853	11634	64	0	\N
349863	1678	25200792000000	23853	11634	65	0	\N
349864	1678	25200792001000	23853	11634	66	0	\N
349865	1678	25200792002000	23853	11634	67	0	\N
349866	1678	25200792003000	23853	11634	68	0	\N
349867	1678	25200792004000	23853	11634	69	0	\N
349868	1678	25200792005000	23853	11634	70	0	\N
349869	1678	25200792006000	23853	11634	71	0	\N
349870	1678	25200792007000	23853	11634	72	0	\N
349871	1678	25200792008000	23853	11634	73	0	\N
349872	1678	25200792009000	23853	11634	74	0	\N
349873	1678	25200792010000	23853	11634	75	0	\N
349874	1678	25200792011000	23853	11634	76	0	\N
349875	1678	25200792012000	23853	11634	77	0	\N
349876	1678	25200792013000	23853	11634	78	0	\N
349877	1678	25200792014000	23853	11634	79	0	\N
349878	1678	25200792015000	23853	11634	80	0	\N
349879	1678	25200792016000	23853	11634	81	0	\N
349880	1678	25200792017000	23853	11634	82	0	\N
349881	1678	25200792018000	23853	11634	83	0	\N
349882	1678	25200792019000	23853	11634	84	0	\N
349883	1678	25200792020000	23853	11634	85	0	\N
349884	1678	25200792021000	23853	11634	86	0	\N
349885	1678	25200792022000	23853	11634	87	0	\N
349886	1678	25200792023000	23853	11634	88	0	\N
349887	1678	25200792024000	23853	11634	89	0	\N
349888	1678	25200792025000	23853	11634	90	0	\N
349889	1678	25200792026000	23853	11634	91	0	\N
349890	1678	25200792027000	23853	11634	92	0	\N
349891	1678	25200792028000	23853	11634	93	0	\N
349892	1678	25200792029000	23853	11634	94	0	\N
349893	1678	25200792030000	23853	11634	95	0	\N
349894	1678	25200792031000	23853	11634	96	0	\N
349895	1678	25200792032000	23853	11634	97	0	\N
349896	1678	25200792033000	23853	11634	98	0	\N
349897	1678	25200792034000	23853	11634	99	0	\N
349898	1678	25200792035000	23853	11634	100	0	\N
349899	1678	25200792036000	23853	11634	101	0	\N
349900	1678	25200792037000	23853	11634	102	0	\N
349901	1678	25200792038000	23853	11634	103	0	\N
349902	1678	25200792039000	23853	11634	104	0	\N
349903	1678	25200792040000	23853	11634	105	0	\N
349904	1678	25200792041000	23853	11634	107	0	\N
349905	1678	25200792042000	23853	11634	108	0	\N
349906	1678	25200792043000	23853	11634	109	0	\N
349907	1678	25200792044000	23853	11634	110	0	\N
349908	1678	25200792045000	23853	11634	111	0	\N
349909	1678	25200792046000	23853	11634	112	0	\N
349910	1678	25200792047000	23853	11634	113	0	\N
349911	1678	25200792048000	23853	11634	114	0	\N
349912	1678	25200792049000	23853	11634	115	0	\N
349913	1678	25200792050000	23853	11634	116	0	\N
349914	1678	25200792051000	23853	11634	117	0	\N
349915	1678	25200792052000	23853	11634	118	0	\N
349916	1678	25200792053000	23853	11634	119	0	\N
349917	1678	25200792054000	23853	11634	120	0	\N
349918	1678	25200792055000	23853	11634	121	0	\N
349919	1678	25200792056000	23853	11634	122	0	\N
349920	1678	25200792057000	23853	11634	123	0	\N
349921	1678	25200792058000	23853	11634	124	0	\N
349922	1678	25200792059000	23853	11634	125	0	\N
349926	1678	26640839290000	23859	11876	0	0	\N
349927	1678	26640839291000	23859	11876	1	0	\N
349928	1874	24572000	23859	11876	2	0	\N
349795	1874	24566000	23851	11873	2	0	2
349923	1678	26640839289000	23854	11874	0	0	0
349924	1874	24568000	23854	11874	1	0	2
349925	1874	24571000	23854	11874	2	0	2
349929	1874	24575000	23859	11876	3	0	\N
349930	1874	24577000	23859	11876	4	0	\N
349931	1874	24579000	23859	11876	5	0	\N
349932	1874	24582000	23859	11876	6	0	\N
349933	1678	26640839290000	23860	11876	0	0	\N
349934	1678	26640839291000	23860	11876	1	0	\N
349935	1874	24572000	23860	11876	2	0	\N
349936	1874	24575000	23860	11876	3	0	\N
349937	1874	24577000	23860	11876	4	0	\N
349938	1874	24579000	23860	11876	5	0	\N
349939	1874	24582000	23860	11876	6	0	\N
349940	1678	26640839290000	23861	11876	0	0	\N
349941	1678	26640839291000	23861	11876	1	0	\N
349942	1874	24572000	23861	11876	2	0	\N
349943	1874	24575000	23861	11876	3	0	\N
349944	1874	24577000	23861	11876	4	0	\N
349945	1874	24579000	23861	11876	5	0	\N
349946	1874	24582000	23861	11876	6	0	\N
349957	1678	26640839290000	23863	11877	0	0	\N
349958	1678	26640839291000	23863	11877	1	0	\N
349959	1678	26640839292000	23863	11877	2	0	\N
349960	1874	24572000	23863	11877	3	0	\N
349961	1874	24575000	23863	11877	4	0	\N
349962	1874	24577000	23863	11877	5	0	\N
349963	1874	24579000	23863	11877	6	0	\N
349964	1874	24581000	23863	11877	7	0	\N
349965	1874	24584000	23863	11877	8	0	\N
349966	1874	24587000	23863	11877	9	0	\N
349977	1678	26640839295000	23866	11879	0	0	\N
349978	1874	24600000	23866	11879	1	0	\N
349979	1874	24603000	23866	11879	2	0	\N
349980	1678	26640839295000	23867	11879	0	0	\N
349981	1874	24600000	23867	11879	1	0	\N
349982	1874	24603000	23867	11879	2	0	\N
349992	1678	26640839298000	23870	11881	0	0	\N
349993	1874	24613000	23870	11881	1	0	\N
349994	1874	24616000	23870	11881	2	0	\N
349995	1678	26640839298000	23871	11881	0	0	\N
349996	1874	24613000	23871	11881	1	0	\N
349997	1874	24616000	23871	11881	2	0	\N
350004	1678	26640839299000	23873	11882	0	0	\N
350005	1678	26640839300000	23873	11882	1	0	\N
350006	1874	24618000	23873	11882	2	0	\N
350007	1874	24621000	23873	11882	3	0	\N
350008	1874	24624000	23873	11882	4	0	\N
350009	1874	24626000	23873	11882	5	0	\N
350020	1678	26640839299000	23876	11882	0	0	\N
350021	1678	26640839300000	23876	11882	1	0	\N
350022	1678	26640839301000	23876	11882	2	0	\N
350023	1678	26640839302000	23876	11882	3	0	\N
350024	1678	26640839303000	23876	11882	4	0	\N
350025	1678	26640839304000	23876	11882	5	0	\N
350026	1874	24618000	23876	11882	6	0	\N
350027	1874	24621000	23876	11882	7	0	\N
350028	1874	24624000	23876	11882	8	0	\N
350029	1874	24625000	23876	11882	9	0	\N
350030	1874	24626000	23876	11882	10	0	\N
350031	1874	24628000	23876	11882	11	0	\N
350032	1874	24630000	23876	11882	12	0	\N
350033	1874	24632000	23876	11882	13	0	\N
350034	1874	24634000	23876	11882	14	0	\N
350035	1874	24636000	23876	11882	15	0	\N
350036	1874	24639000	23876	11882	16	0	\N
350037	1874	24642000	23876	11882	17	0	\N
350038	1874	24645000	23876	11882	18	0	\N
350039	1874	24648000	23876	11882	19	0	\N
350040	2310	0	23877	11814	0	0	\N
350041	1678	26640839201000	23877	11814	2	0	\N
350042	1678	26640839202000	23877	11814	3	0	\N
350043	1678	26640839203000	23877	11814	4	0	\N
350044	1678	26640839204000	23877	11814	5	0	\N
350045	1678	26640839205000	23877	11814	6	0	\N
350046	1678	26640839206000	23877	11814	7	0	\N
350047	1678	26640839207000	23877	11814	8	0	\N
350048	1678	26640839208000	23877	11814	9	0	\N
350049	1678	26640839209000	23877	11814	10	0	\N
350050	1678	26640839210000	23877	11814	11	0	\N
350051	1678	26640839211000	23877	11814	12	0	\N
350052	1678	26640839212000	23877	11814	13	0	\N
350053	1678	26640839213000	23877	11814	14	0	\N
350054	1678	26640839214000	23877	11814	15	0	\N
350055	1678	26640839215000	23877	11814	16	0	\N
350056	1678	26640839216000	23877	11814	17	0	\N
350057	1678	26640839217000	23877	11814	18	0	\N
350058	1678	26640839218000	23877	11814	19	0	\N
350059	1678	26640839219000	23877	11814	20	0	\N
350060	1678	26640839220000	23877	11814	21	0	\N
350061	1678	26640839221000	23877	11814	22	0	\N
350062	1678	26640839222000	23877	11814	23	0	\N
350063	1678	26640839223000	23877	11814	24	0	\N
350064	1678	26640839224000	23877	11814	25	0	\N
349949	1678	26640839292000	23862	11877	2	0	0
349950	1874	24572000	23862	11877	3	0	2
349951	1874	24575000	23862	11877	4	0	2
349952	1874	24577000	23862	11877	5	0	2
349953	1874	24579000	23862	11877	6	0	2
349955	1874	24584000	23862	11877	8	0	2
349956	1874	24587000	23862	11877	9	0	2
349967	1678	26640839293000	23864	11878	0	0	0
349968	1678	26640839294000	23864	11878	1	0	0
349969	1874	24588000	23864	11878	2	0	2
349971	1874	24594000	23864	11878	4	0	2
349972	1874	24596000	23864	11878	5	0	2
349973	1874	24598000	23864	11878	6	0	2
349974	1678	26640839295000	23865	11879	0	0	0
349976	1874	24603000	23865	11879	2	0	2
349983	1678	26640839296000	23868	11880	0	0	0
349984	1678	26640839297000	23868	11880	1	0	0
349985	1874	24606000	23868	11880	2	0	2
349986	1874	24607000	23868	11880	3	0	2
349988	1874	24611000	23868	11880	5	0	2
349989	1678	26640839298000	23869	11881	0	0	0
349990	1874	24613000	23869	11881	1	0	2
349991	1874	24616000	23869	11881	2	0	2
349998	1678	26640839299000	23872	11882	0	0	0
350000	1874	24618000	23872	11882	2	0	2
350001	1874	24621000	23872	11882	3	0	2
350002	1874	24624000	23872	11882	4	0	2
350003	1874	24626000	23872	11882	5	0	2
350011	1678	26640839302000	23875	11883	1	0	0
350012	1678	26640839303000	23875	11883	2	0	0
350013	1874	24628000	23875	11883	3	0	2
350014	1874	24630000	23875	11883	4	0	2
350015	1874	24632000	23875	11883	5	0	2
350017	1874	24636000	23875	11883	7	0	2
350018	1874	24639000	23875	11883	8	0	2
350019	1874	24642000	23875	11883	9	0	2
350065	1678	26640839225000	23877	11814	26	0	\N
350066	1678	26640839226000	23877	11814	27	0	\N
350067	1678	26640839227000	23877	11814	28	0	\N
350068	1678	26640839228000	23877	11814	29	0	\N
350069	1678	26640839229000	23877	11814	30	0	\N
350070	1678	26640839230000	23877	11814	31	0	\N
350071	1678	26640839231000	23877	11814	32	0	\N
350072	1678	26640839232000	23877	11814	33	0	\N
350073	1678	26640839233000	23877	11814	34	0	\N
350074	1678	26640839234000	23877	11814	35	0	\N
350075	1678	26640839235000	23877	11814	36	0	\N
350076	1678	26640839236000	23877	11814	37	0	\N
350077	1678	26640839237000	23877	11814	38	0	\N
350078	1678	26640839238000	23877	11814	39	0	\N
350079	1678	26640839239000	23877	11814	41	0	\N
350080	1678	26640839240000	23877	11814	42	0	\N
350081	1678	26640839241000	23877	11814	43	0	\N
350082	1678	26640839242000	23877	11814	44	0	\N
350083	1678	26640839243000	23877	11814	45	0	\N
350084	1678	26640839244000	23877	11814	46	0	\N
350085	1678	26640839245000	23877	11814	47	0	\N
350086	1678	26640839246000	23877	11814	48	0	\N
350087	1678	26640839247000	23877	11814	49	0	\N
350088	1678	26640839248000	23877	11814	50	0	\N
350089	1678	26640839249000	23877	11814	51	0	\N
350090	1678	26640839250000	23877	11814	52	0	\N
350091	1678	26640839251000	23877	11814	53	0	\N
350092	1678	26640839252000	23877	11814	54	0	\N
350093	1678	26640839253000	23877	11814	55	0	\N
350094	1678	26640839254000	23877	11814	56	0	\N
350095	1678	26640839255000	23877	11814	57	0	\N
350096	1678	26640839256000	23877	11814	58	0	\N
350097	1678	26640839257000	23877	11814	59	0	\N
350098	1678	26640839258000	23877	11814	60	0	\N
350099	1678	26640839259000	23877	11814	61	0	\N
350100	1678	26640839260000	23877	11814	62	0	\N
350101	1678	26640839261000	23877	11814	63	0	\N
350102	1678	26640839262000	23877	11814	64	0	\N
350103	1678	26640839263000	23877	11814	65	0	\N
350104	1678	26640839264000	23877	11814	66	0	\N
350105	1678	26640839265000	23877	11814	67	0	\N
350106	1678	26640839266000	23877	11814	68	0	\N
350107	1678	26640839267000	23877	11814	69	0	\N
350108	1678	26640839268000	23877	11814	70	0	\N
350109	1678	26640839269000	23877	11814	71	0	\N
350110	1678	26640839270000	23877	11814	72	0	\N
350111	1678	26640839271000	23877	11814	73	0	\N
350112	1678	26640839272000	23877	11814	74	0	\N
350113	1678	26640839273000	23877	11814	75	0	\N
350114	1678	26640839274000	23877	11814	76	0	\N
350115	1678	26640839275000	23877	11814	77	0	\N
350116	1678	26640839276000	23877	11814	78	0	\N
350117	1678	26640839277000	23877	11814	79	0	\N
350118	1678	26640839278000	23877	11814	80	0	\N
350119	1678	26640839279000	23877	11814	81	0	\N
350120	1678	26640839280000	23877	11814	82	0	\N
350121	1678	26640839281000	23877	11814	83	0	\N
350122	1678	26640839282000	23877	11814	84	0	\N
350123	1678	26640839283000	23877	11814	85	0	\N
350124	1678	26640839284000	23877	11814	86	0	\N
350125	1678	26640839285000	23877	11814	87	0	\N
350126	1678	26640839286000	23877	11814	88	0	\N
350127	1678	26640839287000	23877	11814	89	0	\N
350128	1678	26640839288000	23877	11814	90	0	\N
350129	1678	26640839289000	23877	11814	91	0	\N
350130	1678	26640839290000	23877	11814	92	0	\N
350131	1678	26640839291000	23877	11814	93	0	\N
350132	1678	26640839292000	23877	11814	94	0	\N
350133	1678	26640839293000	23877	11814	95	0	\N
350134	1678	26640839294000	23877	11814	96	0	\N
350135	1678	26640839295000	23877	11814	97	0	\N
350136	1678	26640839296000	23877	11814	98	0	\N
350137	1678	26640839297000	23877	11814	99	0	\N
350138	1678	26640839298000	23877	11814	100	0	\N
350139	1678	26640839299000	23877	11814	101	0	\N
350140	1678	26640839300000	23877	11814	102	0	\N
350141	1678	26640839301000	23877	11814	103	0	\N
350142	1678	26640839302000	23877	11814	104	0	\N
350143	1678	26640839303000	23877	11814	105	0	\N
350144	1678	26640839304000	23877	11814	106	0	\N
350145	1874	24093000	23877	11814	107	0	\N
350146	1523	0	23877	11814	108	0	\N
350147	1874	24095000	23877	11814	109	0	\N
350148	1874	24096000	23877	11814	110	0	\N
350149	1874	24097000	23877	11814	111	0	\N
350150	1874	24098000	23877	11814	112	0	\N
350151	1874	24099000	23877	11814	113	0	\N
350152	1874	24100000	23877	11814	114	0	\N
350153	1874	24101000	23877	11814	115	0	\N
350154	1874	24102000	23877	11814	116	0	\N
350155	1874	24103000	23877	11814	117	0	\N
350156	1874	24104000	23877	11814	118	0	\N
350157	1874	24105000	23877	11814	119	0	\N
350158	1874	24106000	23877	11814	120	0	\N
350159	1874	24107000	23877	11814	121	0	\N
350160	1874	24108000	23877	11814	122	0	\N
350161	1874	24109000	23877	11814	123	0	\N
350162	1874	24110000	23877	11814	124	0	\N
350163	1678	26640839304000	23879	11884	0	0	\N
350164	1678	26640839305000	23879	11884	1	0	\N
350165	1874	24643000	23879	11884	2	0	\N
350166	1874	24645000	23879	11884	3	0	\N
350167	1874	24647000	23879	11884	4	0	\N
350168	1874	24650000	23879	11884	5	0	\N
350169	1874	24653000	23879	11884	6	0	\N
350200	1678	26640839313000	23883	11888	0	0	\N
350172	1678	26640839306000	23880	11885	2	0	0
350173	1678	26640839307000	23880	11885	3	0	0
350174	1874	24643000	23880	11885	4	0	2
350175	1874	24644000	23880	11885	5	0	2
350176	1874	24646000	23880	11885	6	0	2
350178	1874	24651000	23880	11885	8	0	2
350179	1874	24654000	23880	11885	9	0	2
350180	1874	24657000	23880	11885	10	0	2
350181	1874	24660000	23880	11885	11	0	2
350182	1874	24662000	23880	11885	12	0	2
350184	1678	26640839308000	23881	11886	0	0	0
350185	1678	26640839309000	23881	11886	1	0	0
350186	1678	26640839310000	23881	11886	2	0	0
350187	1874	24666000	23881	11886	3	0	2
350189	1874	24671000	23881	11886	5	0	2
350190	1874	24674000	23881	11886	6	0	2
350191	1874	24677000	23881	11886	7	0	2
350192	1874	24679000	23881	11886	8	0	2
350193	1678	26640839311000	23882	11887	0	0	0
350195	1874	24681000	23882	11887	2	0	2
350196	1874	24683000	23882	11887	3	0	2
350197	1874	24686000	23882	11887	4	0	2
350198	1874	24689000	23882	11887	5	0	2
350199	1874	24690000	23882	11887	6	0	2
350201	1874	24693000	23883	11888	1	0	\N
350202	1874	24695000	23883	11888	2	0	\N
350224	1678	26640839319000	23888	11892	0	0	\N
350225	1874	24725000	23888	11892	2	0	\N
350226	1874	24727000	23888	11892	3	0	\N
350227	1678	26640839319000	23889	11892	0	0	\N
350228	1874	24725000	23889	11892	2	0	\N
350229	1874	24727000	23889	11892	3	0	\N
350233	1678	26640839320000	23891	11893	0	0	\N
350234	1874	24729000	23891	11893	1	0	\N
350235	1874	24732000	23891	11893	2	0	\N
350236	1678	26640839320000	23892	11893	0	0	\N
350237	1874	24729000	23892	11893	1	0	\N
350238	1874	24732000	23892	11893	2	0	\N
350242	1874	24730000	23894	11893	0	0	\N
350243	1678	26640839320000	23895	11893	0	0	\N
350244	1874	24729000	23895	11893	1	0	\N
350245	1874	24732000	23895	11893	2	0	\N
350250	1874	24733000	23897	11894	0	0	\N
350254	1678	26640839323000	23899	11896	0	0	\N
350255	1874	24746000	23899	11896	1	0	\N
350256	1874	24748000	23899	11896	2	0	\N
350257	1678	26640839323000	23900	11896	0	0	\N
350258	1874	24746000	23900	11896	1	0	\N
350259	1874	24748000	23900	11896	2	0	\N
350263	1678	26640839323000	23902	11896	0	0	\N
350264	1874	24746000	23902	11896	1	0	\N
350265	1874	24748000	23902	11896	2	0	\N
350266	1678	26640839323000	23903	11896	0	0	\N
350267	1874	24746000	23903	11896	1	0	\N
350268	1874	24748000	23903	11896	2	0	\N
350269	1678	26640839324000	23904	11897	0	0	\N
350270	1874	24750000	23904	11897	1	0	\N
350271	1874	24753000	23904	11897	2	0	\N
350272	1874	24754000	23904	11897	3	0	\N
350273	1678	26640839324000	23905	11897	0	0	\N
350274	1874	24750000	23905	11897	1	0	\N
350275	1874	24753000	23905	11897	2	0	\N
350276	1874	24754000	23905	11897	3	0	\N
350277	1874	24749000	23906	11897	0	0	\N
350283	1678	26640839324000	23909	11898	0	0	\N
350284	1874	24751000	23909	11898	1	0	\N
350285	1874	24754000	23909	11898	2	0	\N
350286	1678	26640839324000	23910	11898	0	0	\N
350287	1874	24751000	23910	11898	1	0	\N
350288	1874	24754000	23910	11898	2	0	\N
350289	1678	26640839324000	23911	11898	0	0	\N
350290	1874	24751000	23911	11898	1	0	\N
350291	1874	24753000	23911	11898	2	0	\N
350292	1874	24756000	23911	11898	3	0	\N
350300	1678	26640839325000	23913	11899	0	0	\N
350301	1678	26640839326000	23913	11899	1	0	\N
350302	1874	24758000	23913	11899	2	0	\N
350303	1874	24760000	23913	11899	3	0	\N
350304	1874	24761000	23913	11899	4	0	\N
350305	1874	24764000	23913	11899	5	0	\N
350306	1874	24767000	23913	11899	6	0	\N
350322	2310	0	23916	11755	0	0	\N
350323	1678	25920814232000	23916	11755	1	0	\N
350324	1678	25920814233000	23916	11755	2	0	\N
350325	1678	25920814234000	23916	11755	3	0	\N
350326	1678	25920814235000	23916	11755	4	0	\N
350327	1678	25920814236000	23916	11755	5	0	\N
350328	1678	25920814237000	23916	11755	6	0	\N
350329	1678	25920814238000	23916	11755	7	0	\N
350330	1678	25920814239000	23916	11755	8	0	\N
350331	1678	25920814240000	23916	11755	9	0	\N
350332	1678	25920814241000	23916	11755	10	0	\N
350333	1678	25920814242000	23916	11755	11	0	\N
350334	1678	25920814243000	23916	11755	12	0	\N
350335	1678	25920814244000	23916	11755	13	0	\N
350336	1678	25920814245000	23916	11755	14	0	\N
350205	1874	24695000	23884	11888	2	0	2
350206	1678	26640839314000	23885	11889	0	0	0
350207	1678	26640839315000	23885	11889	1	0	0
350208	1874	24697000	23885	11889	2	0	2
350209	1874	24699000	23885	11889	3	0	2
350211	1874	24705000	23885	11889	5	0	2
350212	1874	24706000	23885	11889	6	0	2
350213	1678	26640839316000	23886	11890	0	0	0
350214	1874	24708000	23886	11890	1	0	2
350215	1874	24711000	23886	11890	2	0	2
350217	1678	26640839318000	23887	11891	1	0	0
350218	1874	24712000	23887	11891	2	0	2
350219	2311	100000000	23887	11891	3	0	0
350220	1874	24714000	23887	11891	4	0	2
350222	1874	24720000	23887	11891	6	0	2
350223	1874	24722000	23887	11891	7	0	2
350230	1678	26640839319000	23890	11892	0	0	0
350231	1874	24725000	23890	11892	2	0	2
350232	1874	24727000	23890	11892	3	0	2
350240	1874	24729000	23893	11893	1	0	2
350241	1874	24732000	23893	11893	2	0	2
350246	1678	26640839321000	23896	11894	0	0	0
350247	1874	24734000	23896	11894	1	0	2
350248	1874	24735000	23896	11894	2	0	2
350251	1678	26640839322000	23898	11895	0	0	0
350252	1874	24741000	23898	11895	1	0	2
350253	1874	24743000	23898	11895	2	0	2
350260	1678	26640839323000	23901	11896	0	0	0
350262	1874	24748000	23901	11896	2	0	2
350278	1874	24749000	23907	11897	0	0	2
350279	1678	26640839324000	23908	11898	0	0	0
350280	1874	24751000	23908	11898	1	0	2
350281	1874	24753000	23908	11898	2	0	2
350293	1678	26640839325000	23912	11899	0	0	0
350294	1678	26640839326000	23912	11899	1	0	0
350295	1874	24758000	23912	11899	2	0	2
350296	1874	24760000	23912	11899	3	0	2
350297	1874	24761000	23912	11899	4	0	2
350299	1874	24767000	23912	11899	6	0	2
350307	1678	26640839327000	23914	11900	0	0	0
350308	1874	24769000	23914	11900	1	0	2
350309	1874	24772000	23914	11900	2	0	2
350311	1678	26640839329000	23915	11901	1	0	0
350312	1678	26640839330000	23915	11901	2	0	0
350313	1678	26640839331000	23915	11901	3	0	0
350314	1874	24775000	23915	11901	4	0	2
350315	1874	24776000	23915	11901	5	0	2
350317	1874	24782000	23915	11901	7	0	2
350318	1874	24785000	23915	11901	8	0	2
350319	1874	24787000	23915	11901	9	0	2
350320	1874	24789000	23915	11901	10	0	2
350321	1874	24791000	23915	11901	11	0	2
350337	1678	25920814246000	23916	11755	15	0	\N
350338	1678	25920814247000	23916	11755	16	0	\N
350339	1678	25920814248000	23916	11755	17	0	\N
350340	1678	25920814249000	23916	11755	18	0	\N
350341	1678	25920814250000	23916	11755	19	0	\N
350342	1678	25920814251000	23916	11755	20	0	\N
350343	1678	25920814252000	23916	11755	21	0	\N
350344	1678	25920814253000	23916	11755	22	0	\N
350345	1678	25920814254000	23916	11755	23	0	\N
350346	1678	25920814255000	23916	11755	24	0	\N
350347	1678	25920814256000	23916	11755	25	0	\N
350348	1678	25920814257000	23916	11755	26	0	\N
350349	1678	25920814258000	23916	11755	27	0	\N
350350	1678	25920814259000	23916	11755	28	0	\N
350351	1678	25920814260000	23916	11755	29	0	\N
350352	1678	25920814261000	23916	11755	30	0	\N
350353	1678	25920814262000	23916	11755	31	0	\N
350354	1678	25920814263000	23916	11755	32	0	\N
350355	1678	25920814264000	23916	11755	33	0	\N
350356	1678	25920814265000	23916	11755	34	0	\N
350357	1678	25920814266000	23916	11755	35	0	\N
350358	1678	25920814267000	23916	11755	36	0	\N
350359	1678	25920814268000	23916	11755	37	0	\N
350360	1678	25920814269000	23916	11755	38	0	\N
350361	1678	25920814270000	23916	11755	39	0	\N
350362	1678	25920814271000	23916	11755	40	0	\N
350363	1678	25920814272000	23916	11755	41	0	\N
350364	1678	25920814273000	23916	11755	42	0	\N
350365	1678	25920814274000	23916	11755	43	0	\N
350366	1678	25920814275000	23916	11755	44	0	\N
350367	1678	25920814276000	23916	11755	45	0	\N
350368	1678	25920814277000	23916	11755	46	0	\N
350369	1678	25920814278000	23916	11755	47	0	\N
350370	1678	25920814279000	23916	11755	48	0	\N
350371	1678	25920814280000	23916	11755	49	0	\N
350372	1678	25920814281000	23916	11755	50	0	\N
350373	1678	25920814282000	23916	11755	51	0	\N
350374	1678	25920814283000	23916	11755	52	0	\N
350375	1678	25920814284000	23916	11755	53	0	\N
350376	1678	25920814285000	23916	11755	54	0	\N
350377	1678	25920814286000	23916	11755	55	0	\N
350378	1678	25920814287000	23916	11755	56	0	\N
350379	1678	25920814288000	23916	11755	57	0	\N
350380	1678	25920814289000	23916	11755	58	0	\N
350381	1678	25920814290000	23916	11755	59	0	\N
350382	1678	25920814291000	23916	11755	60	0	\N
350383	1678	25920814292000	23916	11755	61	0	\N
350384	1678	25920814293000	23916	11755	62	0	\N
350385	1678	25920814294000	23916	11755	63	0	\N
350386	1678	25920814295000	23916	11755	64	0	\N
350387	1678	25920814296000	23916	11755	65	0	\N
350388	1678	25920814297000	23916	11755	66	0	\N
350389	1678	25920814298000	23916	11755	67	0	\N
350390	1678	25920814299000	23916	11755	68	0	\N
350391	1678	25920814300000	23916	11755	69	0	\N
350392	1678	25920814301000	23916	11755	70	0	\N
350393	1678	25920814302000	23916	11755	71	0	\N
350394	1678	25920814303000	23916	11755	72	0	\N
350395	1678	25920814304000	23916	11755	73	0	\N
350396	1678	25920814305000	23916	11755	74	0	\N
350397	1678	25920814306000	23916	11755	75	0	\N
350398	1678	25920814307000	23916	11755	76	0	\N
350399	1678	25920814308000	23916	11755	77	0	\N
350400	1678	25920814309000	23916	11755	78	0	\N
350401	1678	25920814310000	23916	11755	79	0	\N
350402	1678	25920814311000	23916	11755	81	0	\N
350403	1678	25920814312000	23916	11755	82	0	\N
350404	1678	25920814313000	23916	11755	83	0	\N
350405	1678	25920814314000	23916	11755	84	0	\N
350406	1678	25920814315000	23916	11755	85	0	\N
350407	1678	25920814316000	23916	11755	86	0	\N
350408	1678	25920814317000	23916	11755	87	0	\N
350409	1678	25920814318000	23916	11755	88	0	\N
350410	1678	25920814319000	23916	11755	89	0	\N
350411	1678	25920814320000	23916	11755	90	0	\N
350412	1678	25920814321000	23916	11755	91	0	\N
350413	1678	25920814322000	23916	11755	92	0	\N
350414	1678	25920814323000	23916	11755	93	0	\N
350415	1678	25920814324000	23916	11755	94	0	\N
350416	1678	25920814325000	23916	11755	95	0	\N
350417	1678	25920814326000	23916	11755	96	0	\N
350418	1678	25920814327000	23916	11755	97	0	\N
350419	1678	26640839332000	23917	11902	0	0	\N
350420	1678	26640839333000	23917	11902	1	0	\N
350421	1678	26640839334000	23917	11902	2	0	\N
350422	1874	24793000	23917	11902	3	0	\N
350423	1874	24796000	23917	11902	4	0	\N
350424	1874	24798000	23917	11902	5	0	\N
350425	1874	24800000	23917	11902	6	0	\N
350426	1874	24803000	23917	11902	7	0	\N
350427	1874	24806000	23917	11902	8	0	\N
350428	1403	0	23917	11902	9	0	\N
350429	1874	24807000	23917	11902	10	0	\N
350448	1678	26640839337000	23921	11905	0	0	\N
350449	1874	24820000	23921	11905	1	0	\N
350450	1874	24823000	23921	11905	2	0	\N
350454	1678	26640839337000	23923	11905	0	0	\N
350455	1874	24820000	23923	11905	1	0	\N
350456	1874	24823000	23923	11905	2	0	\N
350457	1678	26640839338000	23924	11906	0	0	\N
350458	1874	24826000	23924	11906	1	0	\N
350459	1874	24828000	23924	11906	2	0	\N
350463	1678	26640839339000	23926	11907	0	0	\N
350464	1874	24831000	23926	11907	1	0	\N
350465	1874	24833000	23926	11907	2	0	\N
350432	1678	26640839334000	23918	11902	2	0	0
350433	1874	24793000	23918	11902	3	0	2
350434	1874	24796000	23918	11902	4	0	2
350435	1874	24798000	23918	11902	5	0	2
350436	1874	24800000	23918	11902	6	0	2
350438	1874	24806000	23918	11902	8	0	2
350439	1403	0	23918	11902	9	0	0
350440	1874	24807000	23918	11902	10	0	2
350441	1678	26640839335000	23919	11903	0	0	0
350442	1874	24809000	23919	11903	1	0	2
350444	1678	26640839336000	23920	11904	0	0	0
350445	1874	24813000	23920	11904	1	0	2
350446	1874	24816000	23920	11904	2	0	2
350447	1874	24818000	23920	11904	3	0	2
350452	1874	24820000	23922	11905	1	0	2
350453	1874	24823000	23922	11905	2	0	2
350460	1678	26640839338000	23925	11906	0	0	0
350461	1874	24826000	23925	11906	1	0	2
350462	1874	24828000	23925	11906	2	0	2
350467	1874	24831000	23927	11907	1	0	2
350468	1874	24833000	23927	11907	2	0	2
350469	1678	26640839340000	23928	11908	0	0	0
350470	1874	24836000	23928	11908	1	0	2
350471	1874	24837000	23928	11908	2	0	2
350473	1678	26640839341000	23929	11909	0	0	\N
350474	1678	26640839342000	23929	11909	1	0	\N
350475	1678	26640839343000	23929	11909	2	0	\N
350476	1874	24840000	23929	11909	3	0	\N
350490	1678	26640839344000	23932	11910	0	0	\N
350491	1874	24857000	23932	11910	1	0	\N
350492	1874	24860000	23932	11910	2	0	\N
350496	1678	26640839346000	23934	11912	0	0	\N
350497	1874	24867000	23934	11912	1	0	\N
350498	1874	24868000	23934	11912	2	0	\N
350499	1874	24871000	23934	11912	3	0	\N
350502	1678	26640839346000	23936	11912	0	0	\N
350503	1874	24867000	23936	11912	1	0	\N
350504	1874	24870000	23936	11912	2	0	\N
350505	1678	26640839347000	23937	11913	0	0	\N
350506	1874	24868000	23937	11913	1	0	\N
350507	1874	24870000	23937	11913	2	0	\N
350508	1874	24873000	23937	11913	3	0	\N
350509	1678	26640839347000	23938	11913	0	0	\N
350510	1874	24868000	23938	11913	1	0	\N
350511	1874	24870000	23938	11913	2	0	\N
350512	1874	24873000	23938	11913	3	0	\N
350513	1874	24876000	23938	11913	4	0	\N
350514	1678	26640839347000	23939	11913	0	0	\N
350515	1874	24868000	23939	11913	1	0	\N
350516	1874	24870000	23939	11913	2	0	\N
350517	1874	24873000	23939	11913	3	0	\N
350518	1874	24876000	23939	11913	4	0	\N
350524	1678	26640839348000	23941	11914	0	0	\N
350525	1678	26640839349000	23941	11914	1	0	\N
350526	1874	24879000	23941	11914	2	0	\N
350527	1874	24881000	23941	11914	3	0	\N
350528	1874	24884000	23941	11914	4	0	\N
350529	1874	24886000	23941	11914	5	0	\N
350536	1678	26640839350000	23943	11915	0	0	\N
350537	1874	24889000	23943	11915	1	0	\N
350538	1874	24891000	23943	11915	2	0	\N
350539	1678	26640839350000	23944	11915	0	0	\N
350540	1874	24889000	23944	11915	1	0	\N
350541	1874	24891000	23944	11915	2	0	\N
350542	1678	26640839350000	23945	11915	0	0	\N
350543	1874	24889000	23945	11915	1	0	\N
350544	1874	24891000	23945	11915	2	0	\N
350548	1678	26640839350000	23947	11915	0	0	\N
350549	1874	24889000	23947	11915	1	0	\N
350550	1874	24891000	23947	11915	2	0	\N
350551	1678	26640839351000	23949	11916	0	0	\N
350552	1678	26640839352000	23949	11916	1	0	\N
350553	1874	24894000	23949	11916	2	0	\N
350554	1874	24897000	23949	11916	3	0	\N
350555	1874	24899000	23949	11916	4	0	\N
350556	1874	24901000	23949	11916	5	0	\N
350557	1678	26640839351000	23950	11916	0	0	\N
350558	1678	26640839352000	23950	11916	1	0	\N
350559	1874	24894000	23950	11916	2	0	\N
350560	1874	24897000	23950	11916	3	0	\N
350561	1874	24899000	23950	11916	4	0	\N
350562	1874	24901000	23950	11916	5	0	\N
350563	1678	26640839351000	23951	11917	0	0	\N
350564	1678	26640839352000	23951	11917	1	0	\N
350565	1678	26640839353000	23951	11917	2	0	\N
350566	1874	24894000	23951	11917	3	0	\N
350567	1874	24897000	23951	11917	4	0	\N
350568	1874	24900000	23951	11917	5	0	\N
350569	1874	24902000	23951	11917	6	0	\N
350570	1874	24904000	23951	11917	7	0	\N
350571	1874	24906000	23951	11917	8	0	\N
350578	1678	26640839354000	23953	11918	0	0	\N
350579	1874	24900000	23953	11918	1	0	\N
350580	1874	24903000	23953	11918	2	0	\N
350581	1874	24905000	23953	11918	3	0	\N
350582	1874	24908000	23953	11918	4	0	\N
350583	1874	24911000	23953	11918	5	0	\N
350590	1678	26640839355000	23955	11919	0	0	\N
350591	1874	24913000	23955	11919	1	0	\N
350592	1874	24916000	23955	11919	2	0	\N
350596	1678	26640839356000	23957	11920	0	0	\N
350597	1874	24919000	23957	11920	1	0	\N
350598	1874	24921000	23957	11920	2	0	\N
350602	1874	24919000	23959	11920	0	0	\N
350603	1874	24921000	23959	11920	1	0	\N
350479	1678	26640839343000	23930	11909	2	0	0
350480	1874	24841000	23930	11909	3	0	2
350481	1874	24842000	23930	11909	4	0	2
350482	1874	24844000	23930	11909	5	0	2
350483	1874	24846000	23930	11909	6	0	2
350485	1874	24852000	23930	11909	8	0	2
350486	1874	24855000	23930	11909	9	0	2
350487	1678	26640839344000	23931	11910	0	0	0
350488	1874	24857000	23931	11910	1	0	2
350489	1874	24860000	23931	11910	2	0	2
350494	1874	24863000	23933	11911	1	0	2
350495	1874	24865000	23933	11911	2	0	2
350500	1678	26640839346000	23935	11912	0	0	0
350501	1874	24866000	23935	11912	1	0	2
350520	1874	24868000	23940	11913	1	0	2
350521	1874	24870000	23940	11913	2	0	2
350522	1874	24873000	23940	11913	3	0	2
350523	1874	24876000	23940	11913	4	0	2
350530	1678	26640839348000	23942	11914	0	0	0
350532	1874	24879000	23942	11914	2	0	2
350533	1874	24881000	23942	11914	3	0	2
350534	1874	24884000	23942	11914	4	0	2
350535	1874	24886000	23942	11914	5	0	2
350545	1678	26640839350000	23946	11915	0	0	0
350547	1874	24891000	23946	11915	2	0	2
350572	1678	26640839351000	23952	11917	0	0	0
350573	1678	26640839352000	23952	11917	1	0	0
350574	1678	26640839353000	23952	11917	2	0	0
350576	1874	24895000	23952	11917	4	0	2
350577	1874	24897000	23952	11917	5	0	2
350584	1678	26640839354000	23954	11918	0	0	0
350585	1874	24900000	23954	11918	1	0	2
350586	1874	24903000	23954	11918	2	0	2
350588	1874	24908000	23954	11918	4	0	2
350589	1874	24911000	23954	11918	5	0	2
350593	1678	26640839355000	23956	11919	0	0	0
350594	1874	24913000	23956	11919	1	0	2
350595	1874	24916000	23956	11919	2	0	2
350600	1874	24919000	23958	11920	1	0	2
350601	1874	24921000	23958	11920	2	0	2
350604	1678	26640839357000	23960	11921	0	0	0
350605	1874	24923000	23960	11921	1	0	2
350607	1678	26640839358000	23961	11922	0	0	0
350608	1678	26640839359000	23961	11922	1	0	0
350623	2310	0	23964	11786	0	0	\N
350624	1678	25920814235000	23964	11786	1	0	\N
350625	1678	25920814236000	23964	11786	2	0	\N
350626	34	67574074366663	23964	11786	3	0	\N
350627	1678	25920814237000	23964	11786	4	0	\N
350628	1678	25920814238000	23964	11786	5	0	\N
350629	1678	25920814239000	23964	11786	6	0	\N
350630	1678	25920814240000	23964	11786	7	0	\N
350631	1678	25920814241000	23964	11786	8	0	\N
350632	1678	25920814242000	23964	11786	9	0	\N
350633	1678	25920814243000	23964	11786	10	0	\N
350634	1678	25920814244000	23964	11786	11	0	\N
350635	1678	25920814245000	23964	11786	12	0	\N
350636	1678	25920814246000	23964	11786	13	0	\N
350637	1678	25920814247000	23964	11786	14	0	\N
350638	1678	25920814248000	23964	11786	15	0	\N
350639	1678	25920814249000	23964	11786	16	0	\N
350640	1678	25920814250000	23964	11786	17	0	\N
350641	1678	25920814251000	23964	11786	18	0	\N
350642	1678	25920814252000	23964	11786	19	0	\N
350643	1678	25920814253000	23964	11786	20	0	\N
350644	1678	25920814254000	23964	11786	21	0	\N
350645	1678	25920814255000	23964	11786	22	0	\N
350646	1678	25920814256000	23964	11786	23	0	\N
350647	1678	25920814257000	23964	11786	24	0	\N
350648	1678	25920814258000	23964	11786	25	0	\N
350649	1678	25920814259000	23964	11786	26	0	\N
350650	1678	25920814260000	23964	11786	27	0	\N
350651	1678	25920814261000	23964	11786	28	0	\N
350652	1678	25920814262000	23964	11786	29	0	\N
350653	1678	25920814263000	23964	11786	30	0	\N
350654	1678	25920814264000	23964	11786	31	0	\N
350655	1678	25920814265000	23964	11786	32	0	\N
350656	1678	25920814266000	23964	11786	33	0	\N
350657	1678	25920814267000	23964	11786	34	0	\N
350658	1678	25920814268000	23964	11786	35	0	\N
350659	1678	25920814269000	23964	11786	36	0	\N
350660	1678	25920814270000	23964	11786	37	0	\N
350661	1678	25920814271000	23964	11786	38	0	\N
350662	1678	25920814272000	23964	11786	39	0	\N
350663	1678	25920814273000	23964	11786	40	0	\N
350664	1678	25920814274000	23964	11786	41	0	\N
350665	1678	25920814275000	23964	11786	42	0	\N
350666	1678	25920814276000	23964	11786	43	0	\N
350667	1678	25920814277000	23964	11786	44	0	\N
350668	1678	25920814278000	23964	11786	45	0	\N
350669	1678	25920814279000	23964	11786	46	0	\N
350670	1678	25920814280000	23964	11786	47	0	\N
350671	1678	25920814281000	23964	11786	48	0	\N
350672	1678	25920814282000	23964	11786	49	0	\N
350673	1678	25920814283000	23964	11786	50	0	\N
350674	1678	25920814284000	23964	11786	51	0	\N
350675	1678	25920814285000	23964	11786	52	0	\N
350676	1678	25920814286000	23964	11786	53	0	\N
350677	1678	25920814287000	23964	11786	54	0	\N
350678	1678	25920814288000	23964	11786	55	0	\N
350679	1678	25920814289000	23964	11786	56	0	\N
350680	1678	25920814290000	23964	11786	57	0	\N
350681	1678	25920814291000	23964	11786	58	0	\N
350682	1678	25920814292000	23964	11786	59	0	\N
350683	1678	25920814293000	23964	11786	60	0	\N
350684	1678	25920814294000	23964	11786	61	0	\N
350685	1678	25920814295000	23964	11786	62	0	\N
350686	1678	25920814296000	23964	11786	63	0	\N
350687	1678	25920814297000	23964	11786	64	0	\N
350688	1678	25920814298000	23964	11786	65	0	\N
350689	1678	25920814299000	23964	11786	66	0	\N
350690	1678	25920814300000	23964	11786	67	0	\N
350691	1678	25920814301000	23964	11786	68	0	\N
350692	1678	25920814302000	23964	11786	69	0	\N
350693	1678	25920814303000	23964	11786	70	0	\N
350694	1678	25920814304000	23964	11786	71	0	\N
350695	1678	25920814305000	23964	11786	72	0	\N
350696	1678	25920814306000	23964	11786	73	0	\N
350697	1678	25920814307000	23964	11786	74	0	\N
350698	1678	25920814308000	23964	11786	75	0	\N
350699	1678	25920814309000	23964	11786	76	0	\N
350700	1678	25920814310000	23964	11786	77	0	\N
350701	1678	25920814311000	23964	11786	78	0	\N
350702	1678	25920814312000	23964	11786	79	0	\N
350703	1678	25920814313000	23964	11786	80	0	\N
350704	1678	25920814314000	23964	11786	81	0	\N
350705	1678	25920814315000	23964	11786	82	0	\N
350706	1678	25920814316000	23964	11786	83	0	\N
350707	1678	25920814317000	23964	11786	84	0	\N
350708	1678	25920814318000	23964	11786	85	0	\N
350709	1678	25920814319000	23964	11786	86	0	\N
350710	1678	25920814320000	23964	11786	87	0	\N
350711	1678	25920814321000	23964	11786	88	0	\N
350712	1678	25920814322000	23964	11786	89	0	\N
350713	1678	25920814323000	23964	11786	90	0	\N
350714	1678	25920814324000	23964	11786	91	0	\N
350715	1678	25920814325000	23964	11786	92	0	\N
350716	1678	25920814326000	23964	11786	93	0	\N
350717	1678	25920814327000	23964	11786	94	0	\N
350718	1678	25920814328000	23964	11786	95	0	\N
350719	1678	25920814329000	23964	11786	96	0	\N
350720	1678	25920814330000	23964	11786	97	0	\N
350721	1678	25920814331000	23964	11786	98	0	\N
350722	1678	25920814332000	23964	11786	99	0	\N
350723	1678	25920814333000	23964	11786	100	0	\N
350724	1678	25920814334000	23964	11786	101	0	\N
350725	1678	25920814335000	23964	11786	102	0	\N
350726	1678	25920814336000	23964	11786	103	0	\N
350727	1678	25920814337000	23964	11786	104	0	\N
350728	1678	25920814338000	23964	11786	106	0	\N
350729	1678	25920814339000	23964	11786	107	0	\N
350730	1678	25920814340000	23964	11786	108	0	\N
350731	1678	25920814341000	23964	11786	109	0	\N
350732	1678	25920814342000	23964	11786	110	0	\N
350733	1678	25920814343000	23964	11786	111	0	\N
350734	1678	25920814344000	23964	11786	112	0	\N
350735	1678	25920814345000	23964	11786	113	0	\N
350736	1678	25920814346000	23964	11786	114	0	\N
350737	1678	25920814347000	23964	11786	115	0	\N
350738	1678	25920814348000	23964	11786	116	0	\N
350739	1678	25920814349000	23964	11786	117	0	\N
350740	1678	25920814350000	23964	11786	118	0	\N
350741	1678	25920814351000	23964	11786	119	0	\N
350742	1678	25920814352000	23964	11786	120	0	\N
350743	1678	25920814353000	23964	11786	121	0	\N
350744	1678	25920814354000	23964	11786	122	0	\N
350611	1874	24934000	23961	11922	4	0	2
350612	1874	24936000	23961	11922	5	0	2
350613	1678	26640839360000	23962	11923	0	0	0
350614	1678	26640839361000	23962	11923	1	0	0
350615	34	67574074366663	23962	11923	2	0	0
350617	1874	24942000	23962	11923	4	0	2
350618	1874	24944000	23962	11923	5	0	2
350619	1874	24946000	23962	11923	6	0	2
350620	1678	26640839362000	23963	11924	0	0	0
350621	1874	24948000	23963	11924	1	0	2
350745	1678	25920814355000	23964	11786	123	0	\N
350746	1678	25920814356000	23964	11786	124	0	\N
350747	1678	25920814357000	23964	11786	125	0	\N
350748	1678	26640839363000	23965	11925	0	0	\N
350749	795	56052696220424	23965	11925	1	0	\N
350750	1874	24953000	23965	11925	2	0	\N
350770	796	616579120319670	23969	11927	0	0	\N
350771	1678	26640839364000	23969	11927	1	0	\N
350772	807	28013292775935	23969	11927	2	0	\N
350773	808	308145951608564	23969	11927	3	0	\N
350774	809	60255571266433	23969	11927	4	0	\N
350775	810	662810705478461	23969	11927	5	0	\N
350776	842	84031146773964	23969	11927	6	0	\N
350777	844	156664358883961	23969	11927	7	0	\N
350778	850	1154676151626426	23969	11927	8	0	\N
350779	852	2246928439532916	23969	11927	9	0	\N
350780	854	247760013772034	23969	11927	10	0	\N
350781	856	131055761758687	23969	11927	11	0	\N
350782	1874	24964000	23969	11927	12	0	\N
350783	1874	24966000	23969	11927	13	0	\N
350794	858	330455144970164	23971	11928	0	0	\N
350795	862	456435584056305	23971	11928	1	0	\N
350796	866	400699225607122	23971	11928	2	0	\N
350797	1678	26640839365000	23971	11928	3	0	\N
350798	868	2440348667799579	23971	11928	4	0	\N
350799	870	260976309470763	23971	11928	5	0	\N
350800	874	2440348667799579	23971	11928	6	0	\N
350801	1874	24965000	23971	11928	7	0	\N
350802	1874	24968000	23971	11928	8	0	\N
350803	1874	24971000	23971	11928	9	0	\N
350804	876	213907105399279	23972	11929	0	0	\N
350805	880	135574925957243	23972	11929	1	0	\N
350806	882	587491345815068	23972	11929	2	0	\N
350807	884	90383283971510	23972	11929	3	0	\N
350808	888	269757045508602	23972	11929	4	0	\N
350809	1678	26640839366000	23972	11929	5	0	\N
350810	1874	24974000	23972	11929	6	0	\N
350811	1874	24976000	23972	11929	7	0	\N
350826	1678	26640839368000	23976	11931	0	0	\N
350827	1874	24983000	23976	11931	1	0	\N
350828	1874	24986000	23976	11931	2	0	\N
350838	34	67574074366663	23980	11916	0	0	\N
350839	795	56052696220424	23980	11916	1	0	\N
350840	796	616579120319670	23980	11916	2	0	\N
350841	807	28013292775935	23980	11916	3	0	\N
350842	808	308145951608564	23980	11916	4	0	\N
350843	809	60255571266433	23980	11916	5	0	\N
350844	810	662810705478461	23980	11916	6	0	\N
350845	842	84031146773964	23980	11916	7	0	\N
350846	844	156664358883961	23980	11916	8	0	\N
350847	850	1154676151626426	23980	11916	9	0	\N
350848	852	2246928439532916	23980	11916	10	0	\N
350849	854	247760013772034	23980	11916	11	0	\N
350850	856	131055761758687	23980	11916	12	0	\N
350851	858	330455144970164	23980	11916	13	0	\N
350852	862	456435584056305	23980	11916	14	0	\N
350853	866	400699225607122	23980	11916	15	0	\N
350854	868	2440348667799579	23980	11916	16	0	\N
350855	870	260976309470763	23980	11916	17	0	\N
350856	874	2440348667799579	23980	11916	18	0	\N
350857	876	213907105399279	23980	11916	19	0	\N
350858	880	135574925957243	23980	11916	20	0	\N
350859	882	587491345815068	23980	11916	21	0	\N
350860	884	90383283971510	23980	11916	22	0	\N
350861	888	269757045508602	23980	11916	23	0	\N
350862	890	226446580939895	23980	11916	24	0	\N
350863	892	497108061843492	23980	11916	25	0	\N
350864	898	65574880186960	23980	11916	26	0	\N
350865	900	39088962651939	23980	11916	27	0	\N
350866	902	117498269162913	23980	11916	28	0	\N
350870	1678	26640839372000	23982	11935	0	0	\N
350871	1678	26640839373000	23983	11936	0	0	\N
350872	1874	25008000	23983	11936	1	0	\N
350873	1874	25011000	23983	11936	2	0	\N
350880	1678	26640839374000	23986	11937	0	0	\N
350753	1874	24953000	23966	11925	2	0	2
350754	1874	24956000	23966	11925	3	0	2
350755	1874	24959000	23967	11926	0	0	2
350756	1874	24961000	23967	11926	1	0	2
350757	796	616579120319670	23968	11927	0	0	0
350759	807	28013292775935	23968	11927	2	0	0
350760	808	308145951608564	23968	11927	3	0	0
350761	809	60255571266433	23968	11927	4	0	0
350762	810	662810705478461	23968	11927	5	0	0
350763	842	84031146773964	23968	11927	6	0	0
350765	850	1154676151626426	23968	11927	8	0	2
350766	852	2246928439532916	23968	11927	9	0	0
350767	854	247760013772034	23968	11927	10	0	0
350768	856	131055761758687	23968	11927	11	0	0
350784	858	330455144970164	23970	11928	0	0	0
350785	862	456435584056305	23970	11928	1	0	0
350786	866	400699225607122	23970	11928	2	0	0
350787	1678	26640839365000	23970	11928	3	0	0
350788	868	2440348667799579	23970	11928	4	0	0
350790	874	2440348667799579	23970	11928	6	0	0
350791	1874	24965000	23970	11928	7	0	2
350792	1874	24968000	23970	11928	8	0	2
350793	1874	24971000	23970	11928	9	0	2
350812	876	213907105399279	23973	11929	0	0	0
350814	882	587491345815068	23973	11929	2	0	0
350815	884	90383283971510	23973	11929	3	0	0
350816	888	269757045508602	23973	11929	4	0	0
350817	1678	26640839366000	23973	11929	5	0	0
350819	1874	24976000	23973	11929	7	0	2
350820	1678	26640839367000	23974	11930	0	0	0
350821	1874	24978000	23974	11930	2	0	2
350822	1874	24981000	23974	11930	3	0	2
350823	1678	26640839368000	23975	11931	0	0	0
350825	1874	24986000	23975	11931	2	0	2
350829	1678	26640839369000	23977	11932	0	0	0
350830	1874	24988000	23977	11932	1	0	2
350831	1874	24991000	23977	11932	2	0	2
350832	1678	26640839370000	23978	11933	0	0	0
350834	1874	24996000	23978	11933	2	0	2
350835	1678	26640839371000	23979	11934	0	0	0
350836	1874	24999000	23979	11934	1	0	2
350837	1874	25001000	23979	11934	2	0	2
350868	1874	25003000	23981	11935	1	0	2
350869	1874	25006000	23981	11935	2	0	2
350874	1678	26640839373000	23984	11936	0	0	0
350875	1874	25008000	23984	11936	1	0	2
350876	1874	25011000	23984	11936	2	0	2
350878	1874	25014000	23985	11937	1	0	2
350879	1874	25016000	23985	11937	2	0	2
350881	1874	25014000	23986	11937	1	0	\N
350882	1874	25016000	23986	11937	2	0	\N
350885	1678	26640839376000	23988	11939	0	0	\N
350886	1874	25021000	23988	11939	1	0	\N
350887	1874	25023000	23988	11939	2	0	\N
350891	1678	26640839377000	23990	11940	0	0	\N
350892	1874	25026000	23990	11940	1	0	\N
350893	1874	25028000	23990	11940	2	0	\N
350897	1678	26640839377000	23992	11940	0	0	\N
350898	1874	25026000	23992	11940	1	0	\N
350899	1874	25028000	23992	11940	2	0	\N
350900	34	67574074366663	23993	11894	0	0	\N
350901	795	56052696220424	23993	11894	1	0	\N
350902	796	616579120319670	23993	11894	2	0	\N
350903	1678	26640839321000	23993	11894	3	0	\N
350904	1678	26640839322000	23993	11894	4	0	\N
350905	807	28013292775935	23993	11894	5	0	\N
350906	808	308145951608564	23993	11894	6	0	\N
350907	809	60255571266433	23993	11894	7	0	\N
350908	1678	26640839323000	23993	11894	8	0	\N
350909	1678	26640839324000	23993	11894	9	0	\N
350910	1678	26640839325000	23993	11894	10	0	\N
350911	1678	26640839326000	23993	11894	11	0	\N
350912	1678	26640839327000	23993	11894	12	0	\N
350913	1678	26640839328000	23993	11894	13	0	\N
350914	1678	26640839329000	23993	11894	14	0	\N
350915	1678	26640839330000	23993	11894	15	0	\N
350916	1678	26640839331000	23993	11894	16	0	\N
350917	1678	26640839332000	23993	11894	17	0	\N
350918	1678	26640839333000	23993	11894	18	0	\N
350919	1678	26640839334000	23993	11894	19	0	\N
350920	1678	26640839335000	23993	11894	20	0	\N
350921	1678	26640839336000	23993	11894	21	0	\N
350922	1678	26640839337000	23993	11894	22	0	\N
350923	1678	26640839338000	23993	11894	23	0	\N
350924	1678	26640839339000	23993	11894	24	0	\N
350925	1678	26640839340000	23993	11894	25	0	\N
350926	1678	26640839341000	23993	11894	26	0	\N
350927	1678	26640839342000	23993	11894	27	0	\N
350928	1678	26640839343000	23993	11894	28	0	\N
350929	1678	26640839344000	23993	11894	29	0	\N
350930	1678	26640839345000	23993	11894	30	0	\N
350931	1678	26640839346000	23993	11894	31	0	\N
350932	1678	26640839347000	23993	11894	32	0	\N
350933	1678	26640839348000	23993	11894	33	0	\N
350934	1678	26640839349000	23993	11894	34	0	\N
350935	1678	26640839350000	23993	11894	35	0	\N
350936	1678	26640839351000	23993	11894	36	0	\N
350937	1678	26640839352000	23993	11894	37	0	\N
350938	1678	26640839353000	23993	11894	38	0	\N
350939	1678	26640839354000	23993	11894	39	0	\N
350940	1678	26640839355000	23993	11894	40	0	\N
350941	1678	26640839356000	23993	11894	41	0	\N
350942	1678	26640839357000	23993	11894	42	0	\N
350943	1678	26640839358000	23993	11894	43	0	\N
350944	1678	26640839359000	23993	11894	44	0	\N
350945	1678	26640839360000	23993	11894	45	0	\N
350946	1678	26640839361000	23993	11894	46	0	\N
350947	1678	26640839362000	23993	11894	47	0	\N
350948	1678	26640839363000	23993	11894	48	0	\N
350949	1678	26640839364000	23993	11894	49	0	\N
350950	1678	26640839365000	23993	11894	50	0	\N
350951	1678	26640839366000	23993	11894	51	0	\N
350952	1678	26640839367000	23993	11894	52	0	\N
350953	1678	26640839368000	23993	11894	53	0	\N
350954	1678	26640839369000	23993	11894	54	0	\N
350955	1678	26640839370000	23993	11894	55	0	\N
350956	1678	26640839371000	23993	11894	56	0	\N
350957	1678	26640839372000	23993	11894	57	0	\N
350958	1678	26640839373000	23993	11894	58	0	\N
350959	1678	26640839374000	23993	11894	59	0	\N
350960	1678	26640839375000	23993	11894	60	0	\N
350961	1678	26640839376000	23993	11894	61	0	\N
350962	1678	26640839377000	23993	11894	62	0	\N
350963	810	662810705478461	23993	11894	63	0	\N
350964	842	84031146773964	23993	11894	64	0	\N
350965	844	156664358883961	23993	11894	65	0	\N
350966	850	1154676151626426	23993	11894	66	0	\N
350967	852	2246928439532916	23993	11894	67	0	\N
350968	854	247760013772034	23993	11894	68	0	\N
350969	856	131055761758687	23993	11894	69	0	\N
350970	858	330455144970164	23993	11894	70	0	\N
350971	862	456435584056305	23993	11894	71	0	\N
350972	866	400699225607122	23993	11894	72	0	\N
350973	868	2440348667799579	23993	11894	73	0	\N
350974	870	260976309470763	23993	11894	74	0	\N
350975	874	2440348667799579	23993	11894	75	0	\N
350976	876	213907105399279	23993	11894	76	0	\N
350977	880	135574925957243	23993	11894	77	0	\N
350978	882	587491345815068	23993	11894	78	0	\N
350979	884	90383283971510	23993	11894	79	0	\N
350980	888	269757045508602	23993	11894	80	0	\N
350981	890	226446580939895	23993	11894	81	0	\N
350982	892	497108061843492	23993	11894	82	0	\N
350983	898	65574880186960	23993	11894	83	0	\N
350984	900	39088962651939	23993	11894	84	0	\N
350985	902	117498269162913	23993	11894	85	0	\N
350986	1874	24734000	23993	11894	86	0	\N
350987	1874	24735000	23993	11894	87	0	\N
350988	1874	24736000	23993	11894	88	0	\N
350989	1874	24737000	23993	11894	89	0	\N
350990	1874	24738000	23993	11894	90	0	\N
350991	1403	0	23993	11894	91	0	\N
350992	1874	24740000	23993	11894	92	0	\N
350993	1874	24742000	23993	11894	93	0	\N
350994	1874	24744000	23993	11894	94	0	\N
350995	1874	24746000	23993	11894	95	0	\N
350996	1874	24748000	23993	11894	96	0	\N
350997	1874	24750000	23993	11894	97	0	\N
350998	1874	24752000	23993	11894	98	0	\N
350999	1874	24754000	23993	11894	99	0	\N
351000	1874	24755000	23993	11894	100	0	\N
351001	1874	24756000	23993	11894	101	0	\N
351002	1874	24757000	23993	11894	102	0	\N
351003	1874	24758000	23993	11894	103	0	\N
351004	1874	24759000	23993	11894	104	0	\N
351005	1874	24761000	23993	11894	105	0	\N
351006	1874	24763000	23993	11894	106	0	\N
351007	1874	24765000	23993	11894	107	0	\N
351008	1874	24767000	23993	11894	108	0	\N
351009	1874	24769000	23993	11894	109	0	\N
351010	1874	24771000	23993	11894	110	0	\N
351011	1874	24773000	23993	11894	111	0	\N
351012	1874	24775000	23993	11894	112	0	\N
351013	1874	24777000	23993	11894	113	0	\N
351014	1874	24779000	23993	11894	114	0	\N
351015	1874	24781000	23993	11894	115	0	\N
351016	1874	24783000	23993	11894	116	0	\N
350888	1678	26640839376000	23989	11939	0	0	0
350889	1874	25021000	23989	11939	1	0	2
350890	1874	25023000	23989	11939	2	0	2
350894	1678	26640839377000	23991	11940	0	0	0
350895	1874	25026000	23991	11940	1	0	2
351017	1874	24785000	23993	11894	117	0	\N
351018	1874	24787000	23993	11894	119	0	\N
351019	1874	24789000	23993	11894	120	0	\N
351020	1874	24791000	23993	11894	121	0	\N
351021	1874	24793000	23993	11894	122	0	\N
351022	1874	24795000	23993	11894	123	0	\N
351023	1874	24797000	23993	11894	124	0	\N
351024	1874	24799000	23993	11894	125	0	\N
351028	890	226446580939895	23995	11940	0	0	\N
351032	1678	26640839379000	23997	11942	0	0	\N
351033	1874	25036000	23997	11942	1	0	\N
351034	1874	25038000	23997	11942	2	0	\N
351035	1678	26640839380000	23998	11943	0	0	\N
351036	1678	26640839381000	23998	11943	1	0	\N
351037	1678	26640839382000	23998	11943	2	0	\N
351038	1874	25041000	23998	11943	3	0	\N
351039	1874	25044000	23998	11943	4	0	\N
351040	1874	25047000	23998	11943	5	0	\N
351041	1874	25049000	23998	11943	6	0	\N
351042	1874	25051000	23998	11943	7	0	\N
351043	1874	25053000	23998	11943	8	0	\N
351053	1678	26640839383000	24000	11944	0	0	\N
351054	1874	25055000	24000	11944	1	0	\N
351055	1874	25058000	24000	11944	2	0	\N
351056	1874	25055000	24001	11944	0	0	\N
351060	1678	26640839383000	24003	11944	0	0	\N
351061	1874	25055000	24003	11944	1	0	\N
351062	1874	25058000	24003	11944	2	0	\N
351063	1678	26640839384000	24004	11945	0	0	\N
351064	1874	25060000	24004	11945	1	0	\N
351065	1874	25063000	24004	11945	2	0	\N
351066	1933	3003269000000	24004	11945	3	0	\N
351067	1933	3722269000000	24004	11945	4	0	\N
351076	1678	26640839386000	24007	11947	0	0	\N
351077	1874	25071000	24007	11947	1	0	\N
351080	1678	26640839386000	24009	11947	0	0	\N
351081	1874	25071000	24009	11947	1	0	\N
351088	1678	26640839387000	24011	11948	0	0	\N
351089	1678	26640839388000	24011	11948	1	0	\N
351090	1874	25073000	24011	11948	2	0	\N
351091	1874	25075000	24011	11948	3	0	\N
351092	1678	26640839389000	24012	11949	0	0	\N
351093	1874	25084000	24012	11949	1	0	\N
351094	1874	25086000	24012	11949	2	0	\N
351107	890	226446580939895	24019	11953	0	0	\N
351108	1678	26640839393000	24019	11953	1	0	\N
351109	1874	25103000	24019	11953	2	0	\N
351110	1874	25106000	24019	11953	3	0	\N
351111	890	226446580939895	24020	11953	0	0	\N
351112	1678	26640839393000	24020	11953	1	0	\N
351113	1874	25103000	24020	11953	2	0	\N
351114	1874	25106000	24020	11953	3	0	\N
351128	1678	26640839395000	24024	11955	0	0	\N
351129	892	497108061843492	24024	11955	1	0	\N
351130	898	65574880186960	24024	11955	2	0	\N
351131	900	39088962651939	24024	11955	3	0	\N
351132	1874	25113000	24024	11955	4	0	\N
351133	1874	25116000	24024	11955	5	0	\N
351140	902	117498269162913	24026	11956	0	0	\N
351141	906	422541852566961	24026	11956	1	0	\N
351142	1267	94435818214287	24026	11956	2	0	\N
351143	1678	26640839396000	24026	11956	3	0	\N
351144	1874	25119000	24026	11956	4	0	\N
351145	1874	25121000	24026	11956	5	0	\N
351027	1874	25033000	23994	11941	2	0	2
351029	1678	26640839379000	23996	11942	0	0	0
351030	1874	25036000	23996	11942	1	0	2
351031	1874	25038000	23996	11942	2	0	2
351044	1678	26640839380000	23999	11943	0	0	0
351046	1678	26640839382000	23999	11943	2	0	0
351047	1874	25041000	23999	11943	3	0	2
351048	1874	25044000	23999	11943	4	0	2
351049	1874	25047000	23999	11943	5	0	2
351050	1874	25049000	23999	11943	6	0	2
351052	1874	25053000	23999	11943	8	0	2
351057	1678	26640839383000	24002	11944	0	0	0
351058	1874	25055000	24002	11944	1	0	2
351059	1874	25058000	24002	11944	2	0	2
351069	1874	25060000	24005	11945	1	0	2
351070	1874	25063000	24005	11945	2	0	2
351071	1933	3003269000000	24005	11945	3	0	2
351072	1933	3722269000000	24005	11945	4	0	2
351073	1678	26640839385000	24006	11946	0	0	0
351075	1874	25068000	24006	11946	2	0	2
351078	1678	26640839386000	24008	11947	0	0	0
351079	1874	25071000	24008	11947	1	0	2
351082	1678	26640839387000	24010	11948	0	0	0
351083	1678	26640839388000	24010	11948	1	0	0
351085	1874	25077000	24010	11948	3	0	2
351086	1874	25079000	24010	11948	4	0	2
351087	1874	25081000	24010	11948	5	0	2
351095	1678	26640839389000	24013	11949	0	0	0
351097	1874	25086000	24013	11949	2	0	2
351098	1678	26640839390000	24014	11950	0	0	0
351099	1874	25089000	24014	11950	1	0	2
351100	1874	25091000	24014	11950	2	0	2
351101	1678	26640839391000	24017	11951	0	0	0
351103	1874	25096000	24017	11951	2	0	2
351104	1678	26640839392000	24018	11952	0	0	0
351105	1874	25098000	24018	11952	1	0	2
351106	1874	25101000	24018	11952	2	0	2
351115	890	226446580939895	24021	11953	0	0	0
351117	1874	25103000	24021	11953	2	0	2
351118	1874	25106000	24021	11953	3	0	2
351119	1678	26640839394000	24022	11954	0	0	0
351120	1874	25108000	24022	11954	1	0	2
351122	1678	26640839395000	24023	11955	0	0	0
351123	892	497108061843492	24023	11955	1	0	0
351124	898	65574880186960	24023	11955	2	0	0
351125	900	39088962651939	24023	11955	3	0	0
351126	1874	25113000	24023	11955	4	0	2
351134	902	117498269162913	24025	11956	0	0	0
351135	906	422541852566961	24025	11956	1	0	0
351136	1267	94435818214287	24025	11956	2	0	0
351137	1678	26640839396000	24025	11956	3	0	0
351138	1874	25119000	24025	11956	4	0	2
351146	1268	1003915681688	24027	11957	0	0	3
351147	2081	1880807942836	24027	11957	1	0	0
351148	1678	26640839397000	24027	11957	2	0	0
351149	1678	26640839398000	24027	11957	3	0	0
351151	1223	617341134400000	24027	11957	5	0	0
351152	1103	906728040000000	24027	11957	6	0	0
351158	1678	26640839399000	24028	11958	0	0	\N
351159	1874	25134000	24028	11958	1	0	\N
351160	1874	25136000	24028	11958	2	0	\N
351164	1678	26640839399000	24030	11958	0	0	\N
351165	1874	25134000	24030	11958	1	0	\N
351166	1874	25136000	24030	11958	2	0	\N
351167	1678	26640839400000	24031	11959	0	0	\N
351168	1874	25139000	24031	11959	1	0	\N
351169	1874	25141000	24031	11959	2	0	\N
351170	1678	26640839400000	24032	11959	0	0	\N
351171	1874	25139000	24032	11959	1	0	\N
351172	1874	25141000	24032	11959	2	0	\N
351185	1678	26640839403000	24036	11961	0	0	\N
351186	1874	25154000	24036	11961	1	0	\N
351187	1874	25156000	24036	11961	2	0	\N
351188	1678	26640839404000	24037	11962	0	0	\N
351189	1874	25158000	24037	11962	1	0	\N
351190	1678	26640839404000	24038	11962	0	0	\N
351191	1874	25158000	24038	11962	1	0	\N
351196	1678	26640839405000	24042	11963	0	0	\N
351197	1874	25161000	24042	11963	1	0	\N
351198	1874	25163000	24042	11963	2	0	\N
351205	1874	25171000	24045	11965	0	0	\N
351206	1874	25173000	24045	11965	1	0	\N
351216	1678	26640839410000	24048	11968	0	0	\N
351217	1678	26640839411000	24048	11968	1	0	\N
351218	1874	25190000	24048	11968	2	0	\N
351219	1874	25193000	24048	11968	3	0	\N
351220	1874	25196000	24048	11968	4	0	\N
351226	1678	26640839412000	24050	11969	0	0	\N
351227	1678	26640839413000	24050	11969	1	0	\N
351228	1874	25199000	24050	11969	2	0	\N
351229	1874	25202000	24050	11969	3	0	\N
351230	1678	26640839412000	24051	11969	0	0	\N
351231	1678	26640839413000	24051	11969	1	0	\N
351232	1874	25199000	24051	11969	2	0	\N
351233	1874	25202000	24051	11969	3	0	\N
351236	1678	26640839412000	24053	11969	0	0	\N
351237	1678	26640839413000	24053	11969	1	0	\N
351238	1874	25199000	24053	11969	2	0	\N
351239	1874	25202000	24053	11969	3	0	\N
351240	1678	26640839412000	24054	11969	0	0	\N
351241	1678	26640839413000	24054	11969	1	0	\N
351242	1874	25199000	24054	11969	2	0	\N
351243	1874	25202000	24054	11969	3	0	\N
351252	1678	26640839417000	24058	11973	0	0	\N
351253	1874	25214000	24058	11973	1	0	\N
351260	1678	26640839419000	24062	11975	0	0	\N
351261	1874	25220000	24062	11975	1	0	\N
351262	1349	1703417022151650	24063	11895	0	0	\N
351263	906	422541852566961	24063	11895	1	0	\N
351264	1678	26640839378000	24063	11895	2	0	\N
351265	1678	26640839379000	24063	11895	3	0	\N
351266	1267	94435818214287	24063	11895	4	0	\N
351267	1268	1003915681688	24063	11895	5	0	\N
351268	2081	1880807942836	24063	11895	6	0	\N
351269	1223	617341134400000	24063	11895	7	0	\N
351270	1103	906728040000000	24063	11895	8	0	\N
351271	983	508532350000000	24063	11895	9	0	\N
351272	1678	26640839380000	24063	11895	10	0	\N
351273	1678	26640839381000	24063	11895	11	0	\N
351274	1678	26640839382000	24063	11895	12	0	\N
351275	1678	26640839383000	24063	11895	13	0	\N
351276	1678	26640839384000	24063	11895	14	0	\N
351277	1678	26640839385000	24063	11895	15	0	\N
351278	1678	26640839386000	24063	11895	16	0	\N
351279	1678	26640839387000	24063	11895	17	0	\N
351280	1678	26640839388000	24063	11895	18	0	\N
351281	1678	26640839389000	24063	11895	19	0	\N
351282	1678	26640839390000	24063	11895	20	0	\N
351283	1678	26640839391000	24063	11895	21	0	\N
351284	1678	26640839392000	24063	11895	22	0	\N
351285	1678	26640839393000	24063	11895	23	0	\N
351286	1678	26640839394000	24063	11895	24	0	\N
351287	1678	26640839395000	24063	11895	25	0	\N
351288	1678	26640839396000	24063	11895	26	0	\N
351155	1874	25125000	24027	11957	9	0	2
351156	1874	25128000	24027	11957	10	0	2
351157	1874	25131000	24027	11957	11	0	2
351161	1678	26640839399000	24029	11958	0	0	0
351162	1874	25134000	24029	11958	1	0	2
351173	1678	26640839400000	24033	11959	0	0	0
351174	1874	25139000	24033	11959	1	0	2
351175	1874	25141000	24033	11959	2	0	2
351176	1678	26640839401000	24034	11960	0	0	0
351177	1678	26640839402000	24034	11960	1	0	0
351179	1874	25145000	24034	11960	3	0	2
351180	1874	25148000	24034	11960	4	0	2
351181	1874	25151000	24034	11960	5	0	2
351182	1678	26640839403000	24035	11961	0	0	0
351184	1874	25156000	24035	11961	2	0	2
351192	1678	26640839404000	24039	11962	0	0	0
351193	1874	25158000	24039	11962	1	0	2
351194	1678	26640839405000	24041	11963	0	0	0
351195	1874	25161000	24041	11963	1	0	2
351200	1874	25164000	24043	11964	1	0	2
351201	1874	25166000	24043	11964	2	0	2
351202	1874	25168000	24043	11964	3	0	2
351203	1874	25171000	24044	11965	0	0	2
351204	1874	25173000	24044	11965	1	0	2
351208	1874	25175000	24046	11966	1	0	2
351209	1874	25178000	24046	11966	2	0	2
351210	1678	26640839408000	24047	11967	0	0	0
351211	1678	26640839409000	24047	11967	1	0	0
351213	1874	25183000	24047	11967	3	0	2
351214	1874	25186000	24047	11967	4	0	2
351215	1874	25188000	24047	11967	5	0	2
351221	1678	26640839410000	24049	11968	0	0	0
351222	1678	26640839411000	24049	11968	1	0	0
351224	1874	25193000	24049	11968	3	0	2
351225	1874	25196000	24049	11968	4	0	2
351234	1678	26640839412000	24052	11969	0	0	0
351235	1678	26640839413000	24052	11969	1	0	0
351244	1678	26640839414000	24055	11970	0	0	0
351246	1874	25202000	24055	11970	2	0	2
351247	1874	25205000	24055	11970	3	0	2
351248	1678	26640839415000	24056	11971	0	0	0
351249	1874	25208000	24056	11971	1	0	2
351251	1874	25211000	24057	11972	1	0	2
351254	1678	26640839417000	24059	11973	0	0	0
351255	1874	25214000	24059	11973	1	0	2
351256	1678	26640839418000	24060	11974	0	0	0
351257	1874	25217000	24060	11974	1	0	2
351259	1874	25220000	24061	11975	1	0	2
351289	1678	26640839397000	24063	11895	27	0	\N
351290	1678	26640839398000	24063	11895	28	0	\N
351291	1678	26640839399000	24063	11895	29	0	\N
351292	1678	26640839400000	24063	11895	30	0	\N
351293	1678	26640839401000	24063	11895	31	0	\N
351294	1678	26640839402000	24063	11895	32	0	\N
351295	1678	26640839403000	24063	11895	33	0	\N
351296	1678	26640839404000	24063	11895	34	0	\N
351297	1678	26640839405000	24063	11895	35	0	\N
351298	1678	26640839406000	24063	11895	36	0	\N
351299	1678	26640839407000	24063	11895	37	0	\N
351300	1678	26640839408000	24063	11895	38	0	\N
351301	1678	26640839409000	24063	11895	39	0	\N
351302	1678	26640839410000	24063	11895	40	0	\N
351303	1678	26640839411000	24063	11895	41	0	\N
351304	1678	26640839412000	24063	11895	42	0	\N
351305	1678	26640839413000	24063	11895	43	0	\N
351306	1678	26640839414000	24063	11895	44	0	\N
351307	1678	26640839415000	24063	11895	45	0	\N
351308	1678	26640839416000	24063	11895	46	0	\N
351309	1678	26640839417000	24063	11895	47	0	\N
351310	1678	26640839418000	24063	11895	48	0	\N
351311	1678	26640839419000	24063	11895	49	0	\N
351312	1933	3003269000000	24063	11895	50	0	\N
351313	1933	3722269000000	24063	11895	51	0	\N
351314	1874	24801000	24063	11895	52	0	\N
351315	1874	24803000	24063	11895	53	0	\N
351316	1874	24805000	24063	11895	54	0	\N
351317	1874	24807000	24063	11895	55	0	\N
351318	1874	24809000	24063	11895	56	0	\N
351319	1874	24811000	24063	11895	57	0	\N
351320	1874	24813000	24063	11895	58	0	\N
351321	1874	24815000	24063	11895	59	0	\N
351322	1874	24817000	24063	11895	60	0	\N
351323	1874	24819000	24063	11895	61	0	\N
351324	1874	24821000	24063	11895	62	0	\N
351325	1874	24823000	24063	11895	63	0	\N
351326	1874	24825000	24063	11895	64	0	\N
351327	1874	24827000	24063	11895	65	0	\N
351328	1874	24829000	24063	11895	66	0	\N
351329	1874	24831000	24063	11895	67	0	\N
351330	1874	24833000	24063	11895	68	0	\N
351331	1874	24835000	24063	11895	69	0	\N
351332	1874	24837000	24063	11895	70	0	\N
351333	1874	24839000	24063	11895	71	0	\N
351334	1874	24841000	24063	11895	72	0	\N
351335	1874	24843000	24063	11895	73	0	\N
351336	1874	24845000	24063	11895	74	0	\N
351337	1874	24847000	24063	11895	75	0	\N
351338	1874	24849000	24063	11895	76	0	\N
351339	1874	24851000	24063	11895	77	0	\N
351340	1874	24853000	24063	11895	78	0	\N
351341	1874	24856000	24063	11895	79	0	\N
351342	1874	24859000	24063	11895	80	0	\N
351343	1874	24862000	24063	11895	81	0	\N
351344	1874	24865000	24063	11895	82	0	\N
351345	1874	24868000	24063	11895	83	0	\N
351346	1874	24871000	24063	11895	84	0	\N
351347	1874	24874000	24063	11895	85	0	\N
351348	1874	24877000	24063	11895	86	0	\N
351349	1874	24880000	24063	11895	87	0	\N
351350	1874	24883000	24063	11895	88	0	\N
351351	1874	24886000	24063	11895	89	0	\N
351352	1874	24889000	24063	11895	90	0	\N
351353	1874	24892000	24063	11895	91	0	\N
351354	1874	24895000	24063	11895	92	0	\N
351355	1874	24898000	24063	11895	93	0	\N
351356	1874	24901000	24063	11895	94	0	\N
351357	1874	24904000	24063	11895	95	0	\N
351358	1874	24907000	24063	11895	96	0	\N
351359	1874	24910000	24063	11895	97	0	\N
351360	1874	24913000	24063	11895	98	0	\N
351361	1874	24916000	24063	11895	99	0	\N
351362	1874	24919000	24063	11895	100	0	\N
351363	1874	24922000	24063	11895	101	0	\N
351364	1874	24925000	24063	11895	102	0	\N
351365	1874	24928000	24063	11895	103	0	\N
351366	1874	24931000	24063	11895	104	0	\N
351367	1874	24934000	24063	11895	105	0	\N
351368	1874	24937000	24063	11895	106	0	\N
351369	1874	24940000	24063	11895	107	0	\N
351370	1874	24943000	24063	11895	108	0	\N
351371	1874	24946000	24063	11895	109	0	\N
351372	1874	24949000	24063	11895	110	0	\N
351373	1874	24952000	24063	11895	111	0	\N
351374	1874	24955000	24063	11895	112	0	\N
351375	1874	24958000	24063	11895	113	0	\N
351376	1874	24961000	24063	11895	114	0	\N
351377	1874	24964000	24063	11895	115	0	\N
351378	1874	24967000	24063	11895	116	0	\N
351379	1874	24970000	24063	11895	117	0	\N
351380	1874	24973000	24063	11895	119	0	\N
351381	1874	24976000	24063	11895	120	0	\N
351382	1874	24979000	24063	11895	121	0	\N
351383	1874	24982000	24063	11895	122	0	\N
351384	1874	24985000	24063	11895	123	0	\N
351385	1874	24988000	24063	11895	124	0	\N
351386	1874	24991000	24063	11895	125	0	\N
351387	1678	26640839420000	24066	11977	0	0	\N
351388	1678	26640839421000	24066	11977	1	0	\N
351389	1678	26640839422000	24066	11977	2	0	\N
351390	1874	25223000	24066	11977	3	0	\N
351391	1874	25226000	24066	11977	4	0	\N
351392	1874	25229000	24066	11977	5	0	\N
351415	1678	26640839431000	24071	11981	0	0	\N
351416	1874	25256000	24071	11981	1	0	\N
351421	1678	26640839433000	24074	11983	0	0	\N
351422	1874	25262000	24074	11983	1	0	\N
351395	1678	26640839422000	24067	11977	2	0	0
351396	1874	25223000	24067	11977	3	0	2
351397	1874	25226000	24067	11977	4	0	2
351398	1874	25229000	24067	11977	5	0	2
351399	1678	26640839423000	24068	11978	0	0	0
351401	1678	26640839425000	24068	11978	2	0	0
351402	1678	26640839426000	24068	11978	3	0	0
351403	1678	26640839427000	24068	11978	4	0	0
351404	1874	25232000	24068	11978	5	0	2
351405	1874	25235000	24068	11978	6	0	2
351407	1874	25241000	24068	11978	8	0	2
351408	1874	25244000	24068	11978	9	0	2
351409	1678	26640839428000	24069	11979	0	0	0
351410	1874	25247000	24069	11979	1	0	2
351412	1678	26640839430000	24070	11980	1	0	0
351413	1874	25250000	24070	11980	2	0	2
351414	1874	25253000	24070	11980	3	0	2
351417	1678	26640839431000	24072	11981	0	0	0
351418	1874	25256000	24072	11981	1	0	2
351420	1874	25259000	24073	11982	1	0	2
351423	1678	26640839433000	24075	11983	0	0	0
351424	1874	25262000	24075	11983	1	0	2
351435	1678	26640839436000	24079	11986	0	0	\N
351436	1678	26640839437000	24079	11986	1	0	\N
351437	1678	26640839438000	24079	11986	2	0	\N
351438	1874	25271000	24079	11986	3	0	\N
351439	1874	25274000	24079	11986	4	0	\N
351440	1874	25277000	24079	11986	5	0	\N
351443	1678	26640839439000	24081	11987	0	0	\N
351444	1874	25280000	24081	11987	1	0	\N
351445	1678	26640839439000	24082	11987	0	0	\N
351446	1874	25280000	24082	11987	1	0	\N
351452	1678	26640839442000	24085	11989	0	0	\N
351453	1874	25289000	24085	11989	1	0	\N
351462	1678	26640839442000	24087	11990	0	0	\N
351463	1678	26640839443000	24087	11990	1	0	\N
351464	1678	26640839444000	24087	11990	2	0	\N
351465	1678	26640839445000	24087	11990	3	0	\N
351466	1874	25292000	24087	11990	4	0	\N
351467	1874	25295000	24087	11990	5	0	\N
351468	1874	25298000	24087	11990	6	0	\N
351469	1874	25301000	24087	11990	7	0	\N
351470	1678	26640839442000	24088	11990	0	0	\N
351471	1678	26640839443000	24088	11990	1	0	\N
351472	1678	26640839444000	24088	11990	2	0	\N
351473	1678	26640839445000	24088	11990	3	0	\N
351474	1874	25292000	24088	11990	4	0	\N
351475	1874	25295000	24088	11990	5	0	\N
351476	1874	25298000	24088	11990	6	0	\N
351477	1874	25301000	24088	11990	7	0	\N
351478	1678	26640839442000	24089	11990	0	0	\N
351479	1678	26640839443000	24089	11990	1	0	\N
351480	1678	26640839444000	24089	11990	2	0	\N
351481	1678	26640839445000	24089	11990	3	0	\N
351482	1874	25292000	24089	11990	4	0	\N
351483	1874	25295000	24089	11990	5	0	\N
351484	1874	25298000	24089	11990	6	0	\N
351485	1874	25301000	24089	11990	7	0	\N
351498	1678	26640839451000	24095	11995	0	0	\N
351499	1874	25319000	24095	11995	1	0	\N
351500	1678	26640839451000	24096	11995	0	0	\N
351501	1874	25319000	24096	11995	1	0	\N
351502	1678	26640839452000	24097	11996	0	0	\N
351503	1874	25322000	24097	11996	1	0	\N
351506	1678	26640839452000	24099	11996	0	0	\N
351507	1874	25322000	24099	11996	1	0	\N
351509	1678	26640839454000	24101	11998	0	0	\N
351510	1874	25325000	24101	11998	1	0	\N
351511	1678	26640839454000	24102	11998	0	0	\N
351512	1874	25325000	24102	11998	1	0	\N
351517	1678	26640839455000	24105	11999	0	0	\N
351518	1874	25328000	24105	11999	1	0	\N
351524	1874	25340000	24112	12002	0	0	\N
351525	1874	25340000	24113	12002	0	0	\N
351527	1874	25346000	24115	12004	0	0	\N
351539	1678	26640839457000	24119	12005	0	0	\N
351540	1678	26640839458000	24119	12005	1	0	\N
351541	1678	26640839459000	24119	12005	2	0	\N
351542	1678	26640839460000	24119	12005	3	0	\N
351543	1014	505330831110000	24119	12005	4	0	\N
351544	1874	25349000	24119	12005	5	0	\N
351545	1874	25352000	24119	12005	6	0	\N
351546	1380	1702582504891650	24119	12005	7	0	\N
351547	1874	25355000	24119	12005	8	0	\N
351548	1874	25358000	24119	12005	9	0	\N
351549	1678	26640839461000	24120	12006	0	0	\N
351550	1874	25361000	24120	12006	1	0	\N
351553	1678	26640839461000	24122	12006	0	0	\N
351554	1874	25361000	24122	12006	1	0	\N
351559	1678	26640839462000	24124	12007	0	0	\N
351560	1678	26640839463000	24124	12007	1	0	\N
351427	1678	26640839435000	24077	11985	0	0	0
351428	1874	25268000	24077	11985	1	0	2
351429	1678	26640839436000	24078	11986	0	0	0
351430	1678	26640839437000	24078	11986	1	0	0
351431	1678	26640839438000	24078	11986	2	0	0
351433	1874	25274000	24078	11986	4	0	2
351434	1874	25277000	24078	11986	5	0	2
351441	1678	26640839439000	24080	11987	0	0	0
351442	1874	25280000	24080	11987	1	0	2
351447	1678	26640839440000	24083	11988	0	0	0
351449	1874	25283000	24083	11988	2	0	2
351450	1874	25286000	24083	11988	3	0	2
351451	1874	25289000	24084	11989	0	0	2
351454	1678	26640839442000	24086	11990	0	0	0
351456	1678	26640839444000	24086	11990	2	0	0
351457	1678	26640839445000	24086	11990	3	0	0
351458	1874	25292000	24086	11990	4	0	2
351459	1874	25295000	24086	11990	5	0	2
351460	1874	25298000	24086	11990	6	0	2
351486	1678	26640839446000	24090	11991	0	0	0
351487	1874	25304000	24090	11991	1	0	2
351488	1678	26640839447000	24091	11992	0	0	0
351489	1874	25307000	24091	11992	1	0	2
351490	1678	26640839448000	24092	11993	0	0	0
351492	1678	26640839449000	24093	11994	0	0	0
351493	1678	26640839450000	24093	11994	1	0	0
351494	1874	25313000	24093	11994	2	0	2
351495	1874	25316000	24093	11994	3	0	2
351497	1874	25319000	24094	11995	1	0	2
351504	1678	26640839452000	24098	11996	0	0	0
351505	1874	25322000	24098	11996	1	0	2
351508	1678	26640839453000	24100	11997	0	0	0
351513	1678	26640839454000	24103	11998	0	0	0
351515	1678	26640839455000	24104	11999	0	0	0
351516	1874	25328000	24104	11999	1	0	2
351519	1678	26640839456000	24106	12000	0	0	0
351520	1874	25331000	24106	12000	1	0	2
351521	1874	25334000	24106	12000	2	0	2
351523	1874	25340000	24111	12002	0	0	2
351526	1874	25343000	24114	12003	0	0	2
351528	1874	25346000	24117	12004	0	0	2
351529	1678	26640839457000	24118	12005	0	0	0
351531	1678	26640839459000	24118	12005	2	0	0
351532	1678	26640839460000	24118	12005	3	0	0
351533	1014	505330831110000	24118	12005	4	0	0
351534	1874	25349000	24118	12005	5	0	2
351535	1874	25352000	24118	12005	6	0	2
351537	1874	25355000	24118	12005	8	0	2
351538	1874	25358000	24118	12005	9	0	2
351551	1678	26640839461000	24121	12006	0	0	0
351552	1874	25361000	24121	12006	1	0	2
351555	1678	26640839462000	24123	12007	0	0	0
351557	1874	25364000	24123	12007	2	0	2
351558	1874	25367000	24123	12007	3	0	2
351561	1874	25364000	24124	12007	2	0	\N
351562	1874	25367000	24124	12007	3	0	\N
351571	1678	26640839467000	24128	12010	0	0	\N
351572	1874	25379000	24128	12010	1	0	\N
351575	1678	26640839468000	24130	12011	0	0	\N
351576	1874	25382000	24130	12011	1	0	\N
351585	1678	26640839469000	24132	12012	0	0	\N
351586	1678	26640839470000	24132	12012	1	0	\N
351587	1678	26640839471000	24132	12012	2	0	\N
351588	1874	25385000	24132	12012	3	0	\N
351589	1874	25388000	24132	12012	4	0	\N
351590	1380	1710262743411650	24132	12012	5	0	\N
351591	1254	613748195750000	24132	12012	6	0	\N
351592	1874	25391000	24132	12012	7	0	\N
351601	1678	26640839474000	24135	12014	0	0	\N
351602	1874	25400000	24135	12014	1	0	\N
351603	1678	26640839474000	24136	12014	0	0	\N
351604	1874	25400000	24136	12014	1	0	\N
351605	1874	25403000	24137	12015	0	0	\N
351606	1874	25406000	24137	12015	1	0	\N
351619	1874	25421000	24141	12018	0	0	\N
351620	1874	25424000	24141	12018	1	0	\N
351625	1678	26640839481000	24143	12018	0	0	\N
351626	1678	26640839482000	24143	12018	1	0	\N
351627	1874	25421000	24143	12018	2	0	\N
351628	1874	25424000	24143	12018	3	0	\N
351629	1678	25920814358000	24144	11787	0	0	\N
351630	1678	25920814359000	24144	11787	1	0	\N
351631	795	56052696220424	24144	11787	2	0	\N
351632	796	616579120319670	24144	11787	3	0	\N
351633	1678	25920814360000	24144	11787	4	0	\N
351634	1678	25920814361000	24144	11787	5	0	\N
351635	1678	25920814362000	24144	11787	6	0	\N
351636	1678	25920814363000	24144	11787	7	0	\N
351637	1678	25920814364000	24144	11787	8	0	\N
351638	1678	25920814365000	24144	11787	9	0	\N
351639	1349	1703417022151650	24144	11787	10	0	\N
351640	1678	25920814366000	24144	11787	11	0	\N
351641	1678	25920814367000	24144	11787	12	0	\N
351642	1678	25920814368000	24144	11787	13	0	\N
351643	1678	25920814369000	24144	11787	14	0	\N
351644	1223	617341134400000	24144	11787	15	0	\N
351645	1103	906728040000000	24144	11787	16	0	\N
351646	983	508532350000000	24144	11787	17	0	\N
351647	1678	25920814370000	24144	11787	18	0	\N
351648	1678	25920814371000	24144	11787	19	0	\N
351649	1678	25920814372000	24144	11787	20	0	\N
351650	1678	25920814373000	24144	11787	21	0	\N
351651	1678	25920814374000	24144	11787	22	0	\N
351652	1678	25920814375000	24144	11787	23	0	\N
351653	1678	25920814376000	24144	11787	24	0	\N
351654	1678	25920814377000	24144	11787	25	0	\N
351655	1678	25920814378000	24144	11787	26	0	\N
351656	1678	25920814379000	24144	11787	27	0	\N
351657	1678	25920814380000	24144	11787	28	0	\N
351658	1678	25920814381000	24144	11787	29	0	\N
351659	1678	25920814382000	24144	11787	30	0	\N
351660	1678	25920814383000	24144	11787	31	0	\N
351661	1678	25920814384000	24144	11787	32	0	\N
351662	1678	25920814385000	24144	11787	33	0	\N
351663	1678	25920814386000	24144	11787	34	0	\N
351664	807	28013292775935	24144	11787	35	0	\N
351665	808	308145951608564	24144	11787	36	0	\N
351666	809	60255571266433	24144	11787	37	0	\N
351667	1678	25920814387000	24144	11787	38	0	\N
351668	1678	25920814388000	24144	11787	39	0	\N
351669	1678	25920814389000	24144	11787	40	0	\N
351670	1678	25920814390000	24144	11787	41	0	\N
351671	1678	25920814391000	24144	11787	42	0	\N
351672	1678	25920814392000	24144	11787	43	0	\N
351673	1678	25920814393000	24144	11787	44	0	\N
351674	1678	25920814394000	24144	11787	45	0	\N
351675	1678	25920814395000	24144	11787	46	0	\N
351676	1678	25920814396000	24144	11787	47	0	\N
351677	1678	25920814397000	24144	11787	48	0	\N
351678	1678	25920814398000	24144	11787	49	0	\N
351679	1678	25920814399000	24144	11787	50	0	\N
351680	810	662810705478461	24144	11787	51	0	\N
351681	842	84031146773964	24144	11787	52	0	\N
351682	844	156664358883961	24144	11787	53	0	\N
351683	850	1154676151626426	24144	11787	54	0	\N
351684	852	2246928439532916	24144	11787	55	0	\N
351685	854	247760013772034	24144	11787	56	0	\N
351686	856	131055761758687	24144	11787	57	0	\N
351687	858	330455144970164	24144	11787	58	0	\N
351688	862	456435584056305	24144	11787	59	0	\N
351689	866	400699225607122	24144	11787	60	0	\N
351690	868	2440348667799579	24144	11787	61	0	\N
351691	870	260976309470763	24144	11787	62	0	\N
351692	874	2440348667799579	24144	11787	63	0	\N
351693	876	213907105399279	24144	11787	64	0	\N
351694	880	135574925957243	24144	11787	65	0	\N
351695	882	587491345815068	24144	11787	66	0	\N
351696	884	90383283971510	24144	11787	67	0	\N
351565	1678	26640839465000	24126	12009	0	0	0
351566	1678	26640839466000	24126	12009	1	0	0
351567	1874	25373000	24126	12009	2	0	2
351568	1874	25376000	24126	12009	3	0	2
351569	1678	26640839467000	24127	12010	0	0	0
351573	1678	26640839468000	24129	12011	0	0	0
351574	1874	25382000	24129	12011	1	0	2
351577	1678	26640839469000	24131	12012	0	0	0
351578	1678	26640839470000	24131	12012	1	0	0
351579	1678	26640839471000	24131	12012	2	0	0
351581	1874	25388000	24131	12012	4	0	2
351582	1380	1710262743411650	24131	12012	5	0	0
351583	1254	613748195750000	24131	12012	6	0	0
351584	1874	25391000	24131	12012	7	0	2
351594	1678	26640839473000	24133	12013	1	0	0
351595	1134	909633748050000	24133	12013	2	0	0
351596	1014	507610345500000	24133	12013	3	0	0
351597	1874	25394000	24133	12013	4	0	2
351598	1874	25397000	24133	12013	5	0	2
351600	1874	25400000	24134	12014	1	0	2
351607	1678	26640839475000	24138	12015	0	0	0
351608	1678	26640839476000	24138	12015	1	0	0
351609	1874	25403000	24138	12015	2	0	2
351610	1874	25406000	24138	12015	3	0	2
351612	1874	25409000	24139	12016	1	0	2
351613	1678	26640839478000	24140	12017	0	0	0
351614	1678	26640839479000	24140	12017	1	0	0
351615	1678	26640839480000	24140	12017	2	0	0
351617	1874	25415000	24140	12017	4	0	2
351618	1874	25418000	24140	12017	5	0	2
351621	1678	26640839481000	24142	12018	0	0	0
351622	1678	26640839482000	24142	12018	1	0	0
351623	1874	25421000	24142	12018	2	0	2
351697	888	269757045508602	24144	11787	68	0	\N
351698	890	226446580939895	24144	11787	69	0	\N
351699	892	497108061843492	24144	11787	70	0	\N
351700	898	65574880186960	24144	11787	71	0	\N
351701	900	39088962651939	24144	11787	72	0	\N
351702	902	117498269162913	24144	11787	73	0	\N
351703	906	422541852566961	24144	11787	74	0	\N
351704	1267	94435818214287	24144	11787	75	0	\N
351705	1268	1003915681688	24144	11787	76	0	\N
351706	2081	1880807942836	24144	11787	77	0	\N
351707	1678	25920814400000	24144	11787	78	0	\N
351708	1678	25920814401000	24144	11787	79	0	\N
351709	1678	25920814402000	24144	11787	80	0	\N
351710	1678	25920814403000	24144	11787	81	0	\N
351711	1678	25920814404000	24144	11787	82	0	\N
351712	1678	25920814405000	24144	11787	83	0	\N
351713	1678	25920814406000	24144	11787	84	0	\N
351714	1678	25920814407000	24144	11787	85	0	\N
351715	1678	25920814408000	24144	11787	86	0	\N
351716	1678	25920814409000	24144	11787	87	0	\N
351717	1678	25920814410000	24144	11787	88	0	\N
351718	1678	25920814411000	24144	11787	89	0	\N
351719	1678	25920814412000	24144	11787	90	0	\N
351720	1678	25920814413000	24144	11787	91	0	\N
351721	1678	25920814414000	24144	11787	92	0	\N
351722	1678	25920814415000	24144	11787	93	0	\N
351723	1678	25920814416000	24144	11787	94	0	\N
351724	1678	25920814417000	24144	11787	95	0	\N
351725	1678	25920814418000	24144	11787	96	0	\N
351726	1678	25920814419000	24144	11787	97	0	\N
351727	1678	25920814420000	24144	11787	98	0	\N
351728	1678	25920814421000	24144	11787	99	0	\N
351729	1678	25920814422000	24144	11787	100	0	\N
351730	1678	25920814423000	24144	11787	101	0	\N
351731	1678	25920814424000	24144	11787	102	0	\N
351732	1678	25920814425000	24144	11787	103	0	\N
351733	1678	25920814426000	24144	11787	104	0	\N
351734	1678	25920814427000	24144	11787	106	0	\N
351735	1678	25920814428000	24144	11787	107	0	\N
351736	1678	25920814429000	24144	11787	108	0	\N
351737	1678	26640839483000	24145	12019	0	0	\N
351738	1874	25427000	24145	12019	1	0	\N
351741	1678	26640839420000	24148	11896	0	0	\N
351742	1678	26640839421000	24148	11896	1	0	\N
351743	1678	26640839422000	24148	11896	2	0	\N
351744	1678	26640839423000	24148	11896	3	0	\N
351745	1678	26640839424000	24148	11896	4	0	\N
351746	1678	26640839425000	24148	11896	5	0	\N
351747	1678	26640839426000	24148	11896	6	0	\N
351748	1678	26640839427000	24148	11896	7	0	\N
351749	1678	26640839428000	24148	11896	8	0	\N
351750	1678	26640839429000	24148	11896	9	0	\N
351751	1678	26640839430000	24148	11896	10	0	\N
351752	1678	26640839431000	24148	11896	11	0	\N
351753	1678	26640839432000	24148	11896	12	0	\N
351754	1678	26640839433000	24148	11896	13	0	\N
351755	1678	26640839434000	24148	11896	14	0	\N
351756	1678	26640839435000	24148	11896	15	0	\N
351757	1678	26640839436000	24148	11896	16	0	\N
351758	1678	26640839437000	24148	11896	17	0	\N
351759	1678	26640839438000	24148	11896	18	0	\N
351760	1678	26640839439000	24148	11896	19	0	\N
351761	1678	26640839440000	24148	11896	20	0	\N
351762	1678	26640839441000	24148	11896	21	0	\N
351763	1678	26640839442000	24148	11896	22	0	\N
351764	1678	26640839443000	24148	11896	23	0	\N
351765	1678	26640839444000	24148	11896	24	0	\N
351766	1678	26640839445000	24148	11896	25	0	\N
351767	1678	26640839446000	24148	11896	26	0	\N
351768	1678	26640839447000	24148	11896	27	0	\N
351769	1678	26640839448000	24148	11896	28	0	\N
351770	1678	26640839449000	24148	11896	29	0	\N
351771	1678	26640839450000	24148	11896	30	0	\N
351772	1678	26640839451000	24148	11896	31	0	\N
351773	1678	26640839452000	24148	11896	32	0	\N
351774	1678	26640839453000	24148	11896	33	0	\N
351775	1678	26640839454000	24148	11896	34	0	\N
351776	1678	26640839455000	24148	11896	35	0	\N
351777	1678	26640839456000	24148	11896	36	0	\N
351778	1678	26640839457000	24148	11896	37	0	\N
351779	1678	26640839458000	24148	11896	38	0	\N
351780	1678	26640839459000	24148	11896	39	0	\N
351781	1678	26640839460000	24148	11896	40	0	\N
351782	1678	26640839461000	24148	11896	41	0	\N
351783	1678	26640839462000	24148	11896	42	0	\N
351784	1678	26640839463000	24148	11896	43	0	\N
351785	1678	26640839464000	24148	11896	44	0	\N
351786	1678	26640839465000	24148	11896	45	0	\N
351787	1678	26640839466000	24148	11896	46	0	\N
351788	1678	26640839467000	24148	11896	47	0	\N
351789	1678	26640839468000	24148	11896	48	0	\N
351790	1678	26640839469000	24148	11896	49	0	\N
351791	1678	26640839470000	24148	11896	50	0	\N
351792	1678	26640839471000	24148	11896	51	0	\N
351793	1678	26640839484000	24150	12020	0	0	\N
351800	1678	26640839485000	24153	12021	0	0	\N
351801	1678	26640839486000	24153	12021	1	0	\N
351802	1874	25430000	24153	12021	2	0	\N
351803	1874	25433000	24153	12021	3	0	\N
351804	1874	25434000	24153	12021	4	0	\N
351815	1678	26640839490000	24157	12024	0	0	\N
351816	1874	25444000	24157	12024	1	0	\N
351817	1874	25447000	24157	12024	2	0	\N
351818	1678	26640839490000	24158	12024	0	0	\N
351819	1874	25444000	24158	12024	1	0	\N
351820	1874	25447000	24158	12024	2	0	\N
351821	1678	26640839491000	24159	12025	0	0	\N
351822	1874	25450000	24159	12025	1	0	\N
351823	1678	26640839491000	24160	12025	0	0	\N
351824	1874	25450000	24160	12025	1	0	\N
351827	1678	26640839492000	24163	12027	0	0	\N
351828	1678	26640839493000	24163	12027	1	0	\N
351829	1678	26640839494000	24163	12027	2	0	\N
351830	1385	1709614695710050	24163	12027	3	0	\N
351831	1874	25453000	24163	12027	4	0	\N
351832	1874	25456000	24163	12027	5	0	\N
351794	1678	26640839484000	24151	12020	0	0	0
351795	1678	26640839485000	24152	12021	0	0	0
351796	1678	26640839486000	24152	12021	1	0	0
351797	1874	25430000	24152	12021	2	0	2
351798	1874	25433000	24152	12021	3	0	2
351805	1678	26640839487000	24154	12022	0	0	0
351806	1874	25437000	24154	12022	1	0	2
351807	1495	10000000	24154	12022	2	0	0
351808	1678	26640839488000	24155	12023	0	0	0
351809	1678	26640839489000	24155	12023	1	0	0
351811	1874	25443000	24155	12023	3	0	2
351812	1678	26640839490000	24156	12024	0	0	0
351813	1874	25444000	24156	12024	1	0	2
351814	1874	25447000	24156	12024	2	0	2
351826	1874	25450000	24161	12025	1	0	2
351833	1874	25459000	24163	12027	6	0	\N
351834	1874	25460000	24163	12027	7	0	\N
351845	1678	26640839495000	24166	12028	0	0	\N
351846	1874	25463000	24166	12028	1	0	\N
351853	1678	26640839496000	24168	12029	0	0	\N
351854	1678	26640839497000	24168	12029	1	0	\N
351855	1874	25466000	24168	12029	2	0	\N
351856	1874	25467000	24168	12029	3	0	\N
351857	1401	0	24168	12029	4	0	\N
351858	1874	25470000	24168	12029	5	0	\N
351859	1678	26640839498000	24169	12030	0	0	\N
351860	1874	25473000	24169	12030	1	0	\N
351863	1678	26640839499000	24171	12031	0	0	\N
351864	1678	26640839500000	24171	12031	1	0	\N
351865	1874	25474000	24171	12031	2	0	\N
351866	1874	25477000	24171	12031	3	0	\N
351867	1874	25480000	24171	12031	4	0	\N
351881	1678	26640839504000	24174	12033	0	0	\N
351882	1874	25493000	24174	12033	1	0	\N
351883	1678	26640839504000	24175	12033	0	0	\N
351884	1874	25493000	24175	12033	1	0	\N
351896	1678	26640839509000	24179	12036	0	0	\N
351899	1678	26640839509000	24181	12036	0	0	\N
351900	1874	25509000	24181	12036	1	0	\N
351901	1678	26640839510000	24182	12037	0	0	\N
351902	1874	25512000	24182	12037	1	0	\N
351903	1874	25513000	24182	12037	2	0	\N
351914	890	226446580939895	24187	11936	0	0	\N
351915	892	497108061843492	24187	11936	1	0	\N
351916	1349	1703417022151650	24187	11936	2	0	\N
351917	898	65574880186960	24187	11936	3	0	\N
351918	900	39088962651939	24187	11936	4	0	\N
351919	902	117498269162913	24187	11936	5	0	\N
351920	906	422541852566961	24187	11936	6	0	\N
351921	1267	94435818214287	24187	11936	7	0	\N
351922	1268	1003915681688	24187	11936	8	0	\N
351923	2081	1880807942836	24187	11936	9	0	\N
351924	1223	617341134400000	24187	11936	10	0	\N
351925	1103	906728040000000	24187	11936	11	0	\N
351926	983	508532350000000	24187	11936	12	0	\N
351927	1385	1709614695710050	24187	11936	13	0	\N
351928	1933	3003269000000	24187	11936	14	0	\N
351929	1460	0	24187	11936	15	0	\N
351930	1874	25007000	24187	11936	16	0	\N
351931	1014	505330831110000	24187	11936	17	0	\N
351932	1495	10000000	24187	11936	18	0	\N
351933	1933	3722269000000	24187	11936	19	0	\N
351934	1874	25008000	24187	11936	20	0	\N
351935	1380	1702582504891650	24187	11936	21	0	\N
351936	1380	1710262743411650	24187	11936	22	0	\N
351937	1254	613748195750000	24187	11936	23	0	\N
351938	1134	909633748050000	24187	11936	24	0	\N
351939	1014	507610345500000	24187	11936	25	0	\N
351940	1401	0	24187	11936	26	0	\N
351941	1874	25009000	24187	11936	27	0	\N
351942	1874	25010000	24187	11936	28	0	\N
351943	1874	25011000	24187	11936	29	0	\N
351944	1874	25012000	24187	11936	30	0	\N
351945	1874	25013000	24187	11936	31	0	\N
351946	1874	25014000	24187	11936	32	0	\N
351947	1874	25015000	24187	11936	33	0	\N
351948	1678	26640839514000	24189	12041	0	0	\N
351949	1874	25526000	24189	12041	1	0	\N
351952	1678	26640839514000	24191	12041	0	0	\N
351953	1874	25526000	24191	12041	1	0	\N
351954	1678	26640839514000	24192	12041	0	0	\N
351955	1874	25526000	24192	12041	1	0	\N
351956	1678	26640839514000	24193	12041	0	0	\N
351957	1874	25526000	24193	12041	1	0	\N
351958	1678	26640839515000	24194	12042	0	0	\N
351959	1874	25529000	24194	12042	1	0	\N
351960	1874	25531000	24194	12042	2	0	\N
351837	1678	26640839494000	24164	12027	2	0	0
351838	1385	1709614695710050	24164	12027	3	0	0
351839	1874	25453000	24164	12027	4	0	2
351840	1874	25456000	24164	12027	5	0	2
351841	1874	25459000	24164	12027	6	0	2
351843	1678	26640839495000	24165	12028	0	0	0
351844	1874	25463000	24165	12028	1	0	2
351847	1678	26640839496000	24167	12029	0	0	0
351848	1678	26640839497000	24167	12029	1	0	0
351849	1874	25466000	24167	12029	2	0	2
351851	1401	0	24167	12029	4	0	0
351852	1874	25470000	24167	12029	5	0	2
351861	1678	26640839498000	24170	12030	0	0	0
351862	1874	25473000	24170	12030	1	0	2
351869	1678	26640839500000	24172	12031	1	0	0
351870	1874	25474000	24172	12031	2	0	2
351871	1874	25477000	24172	12031	3	0	2
351872	1874	25480000	24172	12031	4	0	2
351873	1678	26640839501000	24173	12032	0	0	0
351875	1678	26640839503000	24173	12032	2	0	0
351876	1460	0	24173	12032	3	0	0
351877	1874	25483000	24173	12032	4	0	2
351878	1874	25486000	24173	12032	5	0	2
351879	1874	25489000	24173	12032	6	0	2
351885	1678	26640839504000	24176	12033	0	0	0
351886	1874	25493000	24176	12033	1	0	2
351887	1678	26640839505000	24177	12034	0	0	0
351888	1874	25496000	24177	12034	1	0	2
351890	1678	26640839507000	24178	12035	1	0	0
351891	1678	26640839508000	24178	12035	2	0	0
351892	1874	25497000	24178	12035	3	0	2
351893	1874	25500000	24178	12035	4	0	2
351894	1874	25503000	24178	12035	5	0	2
351897	1678	26640839509000	24180	12036	0	0	0
351898	1874	25509000	24180	12036	1	0	2
351904	1678	26640839510000	24183	12037	0	0	0
351905	1874	25512000	24183	12037	1	0	2
351906	1874	25513000	24183	12037	2	0	2
351908	1874	25516000	24184	12038	1	0	2
351909	1678	26640839512000	24185	12039	0	0	0
351910	1874	25519000	24185	12039	1	0	2
351911	1678	26640839513000	24186	12040	0	0	0
351913	1874	25523000	24186	12040	2	0	2
351950	1678	26640839514000	24190	12041	0	0	0
351951	1874	25526000	24190	12041	1	0	2
351961	1678	26640839515000	24195	12042	0	0	0
351962	1874	25529000	24195	12042	1	0	2
351964	1678	26640839516000	24196	12043	0	0	0
351965	1874	25533000	24196	12043	1	0	2
351966	1874	25536000	24196	12043	2	0	2
351967	1874	25537000	24196	12043	3	0	2
351968	1678	26640839517000	24197	12044	0	0	0
351977	1678	26640839520000	24199	12046	0	0	\N
351978	1874	25553000	24199	12046	1	0	\N
351979	1874	25555000	24199	12046	2	0	\N
351980	1874	25558000	24199	12046	3	0	\N
351985	1349	1703417022151650	24201	11917	0	0	\N
351986	906	422541852566961	24201	11917	1	0	\N
351987	1267	94435818214287	24201	11917	2	0	\N
351988	1268	1003915681688	24201	11917	3	0	\N
351989	2081	1880807942836	24201	11917	4	0	\N
351990	1223	617341134400000	24201	11917	5	0	\N
351991	1103	906728040000000	24201	11917	6	0	\N
351992	983	508532350000000	24201	11917	7	0	\N
351993	1385	1709614695710050	24201	11917	8	0	\N
351994	1933	3003269000000	24201	11917	9	0	\N
351995	1460	0	24201	11917	10	0	\N
351996	1874	24892000	24201	11917	11	0	\N
351997	1014	505330831110000	24201	11917	12	0	\N
351998	1495	10000000	24201	11917	13	0	\N
351999	1933	3722269000000	24201	11917	14	0	\N
352000	1874	24893000	24201	11917	15	0	\N
352001	1380	1702582504891650	24201	11917	16	0	\N
352002	1380	1710262743411650	24201	11917	17	0	\N
352003	1254	613748195750000	24201	11917	18	0	\N
352004	1134	909633748050000	24201	11917	19	0	\N
352005	1014	507610345500000	24201	11917	20	0	\N
352006	1401	0	24201	11917	21	0	\N
352007	1874	24894000	24201	11917	22	0	\N
352008	1874	24895000	24201	11917	23	0	\N
352009	1874	24896000	24201	11917	24	0	\N
352010	1874	24897000	24201	11917	25	0	\N
352011	1874	24898000	24201	11917	26	0	\N
352012	1874	24899000	24201	11917	27	0	\N
352013	1874	24900000	24201	11917	28	0	\N
352014	1874	24901000	24201	11917	29	0	\N
352015	1874	24902000	24201	11917	30	0	\N
352016	1678	26640839521000	24202	12047	0	0	\N
352017	1874	25561000	24202	12047	1	0	\N
352018	1874	25563000	24202	12047	2	0	\N
352022	1678	26640839522000	24204	12048	0	0	\N
352023	1678	26640839523000	24204	12048	1	0	\N
352024	1874	25564000	24204	12048	2	0	\N
352025	1874	25566000	24204	12048	3	0	\N
352026	1874	25568000	24204	12048	4	0	\N
352027	1874	25571000	24204	12048	5	0	\N
352028	1678	26640839522000	24205	12048	0	0	\N
352029	1678	26640839523000	24205	12048	1	0	\N
352030	1874	25564000	24205	12048	2	0	\N
352031	1874	25566000	24205	12048	3	0	\N
352032	1874	25568000	24205	12048	4	0	\N
352033	1874	25571000	24205	12048	5	0	\N
352034	1678	26640839522000	24206	12048	0	0	\N
352035	1678	26640839523000	24206	12048	1	0	\N
352036	1874	25564000	24206	12048	2	0	\N
352037	1874	25566000	24206	12048	3	0	\N
352038	1874	25568000	24206	12048	4	0	\N
352039	1874	25571000	24206	12048	5	0	\N
352049	1678	26640839525000	24209	12050	0	0	\N
352050	1678	26640839526000	24209	12050	1	0	\N
352051	1874	25578000	24209	12050	2	0	\N
352052	1874	25579000	24209	12050	3	0	\N
352053	1874	25581000	24209	12050	4	0	\N
352054	1874	25584000	24209	12050	5	0	\N
352055	1874	25587000	24209	12050	6	0	\N
352063	1678	26640839525000	24212	12050	0	0	\N
352064	1678	26640839526000	24212	12050	1	0	\N
352065	1874	25578000	24212	12050	2	0	\N
352066	1874	25579000	24212	12050	3	0	\N
352067	1874	25581000	24212	12050	4	0	\N
352068	1874	25584000	24212	12050	5	0	\N
352069	1874	25587000	24212	12050	6	0	\N
352073	1678	26640839527000	24214	12051	0	0	\N
352074	1874	25589000	24214	12051	1	0	\N
352075	1874	25592000	24214	12051	2	0	\N
352079	1678	26640839528000	24216	12052	0	0	\N
352080	1874	25594000	24216	12052	1	0	\N
352081	1874	25597000	24216	12052	2	0	\N
352082	1678	26640839529000	24217	12053	0	0	\N
352083	1874	25600000	24217	12053	1	0	\N
352084	1874	25602000	24217	12053	2	0	\N
352088	1678	26640839530000	24219	12054	0	0	\N
352089	1874	25603000	24219	12054	1	0	\N
352090	1874	25606000	24219	12054	2	0	\N
352091	1874	25608000	24219	12054	3	0	\N
352095	1678	26640839530000	24221	12054	0	0	\N
352096	1874	25603000	24221	12054	1	0	\N
352097	1874	25606000	24221	12054	2	0	\N
352102	1678	26640839532000	24223	12056	0	0	\N
352103	1874	25616000	24223	12056	1	0	\N
352104	1874	25618000	24223	12056	2	0	\N
351971	1874	25541000	24197	12044	3	0	2
351972	1874	25544000	24197	12044	4	0	2
351973	1874	25547000	24197	12044	5	0	2
351974	1678	26640839519000	24198	12045	0	0	0
351975	1874	25549000	24198	12045	1	0	2
351981	1678	26640839520000	24200	12046	0	0	0
351982	1874	25553000	24200	12046	1	0	2
351983	1874	25555000	24200	12046	2	0	2
351984	1874	25558000	24200	12046	3	0	2
352019	1678	26640839521000	24203	12047	0	0	0
352021	1874	25563000	24203	12047	2	0	2
352040	1678	26640839522000	24207	12048	0	0	0
352041	1678	26640839523000	24207	12048	1	0	0
352042	1874	25564000	24207	12048	2	0	2
352044	1874	25568000	24207	12048	4	0	2
352045	1874	25571000	24207	12048	5	0	2
352046	1678	26640839524000	24208	12049	0	0	0
352047	1874	25573000	24208	12049	1	0	2
352048	1874	25576000	24208	12049	2	0	2
352057	1678	26640839526000	24211	12050	1	0	0
352058	1874	25578000	24211	12050	2	0	2
352059	1874	25579000	24211	12050	3	0	2
352060	1874	25581000	24211	12050	4	0	2
352061	1874	25584000	24211	12050	5	0	2
352070	1678	26640839527000	24213	12051	0	0	0
352071	1874	25589000	24213	12051	1	0	2
352072	1874	25592000	24213	12051	2	0	2
352076	1678	26640839528000	24215	12052	0	0	0
352078	1874	25597000	24215	12052	2	0	2
352085	1678	26640839529000	24218	12053	0	0	0
352086	1874	25600000	24218	12053	1	0	2
352087	1874	25602000	24218	12053	2	0	2
352092	1678	26640839530000	24220	12054	0	0	0
352094	1874	25606000	24220	12054	2	0	2
352098	1678	26640839531000	24222	12055	0	0	0
352099	1874	25609000	24222	12055	1	0	2
352100	1874	25611000	24222	12055	2	0	2
352101	1874	25613000	24222	12055	3	0	2
352108	1678	26640839533000	24225	12057	0	0	\N
352109	1874	25619000	24225	12057	1	0	\N
352110	1874	25622000	24225	12057	2	0	\N
352111	1874	25624000	24225	12057	3	0	\N
352112	1678	26640839533000	24226	12057	0	0	\N
352113	1874	25619000	24226	12057	1	0	\N
352114	1874	25622000	24226	12057	2	0	\N
352115	1874	25624000	24226	12057	3	0	\N
352116	1678	26640839533000	24227	12057	0	0	\N
352117	1874	25619000	24227	12057	1	0	\N
352118	1874	25622000	24227	12057	2	0	\N
352119	1874	25624000	24227	12057	3	0	\N
352124	1678	26640839533000	24229	12057	0	0	\N
352125	1874	25619000	24229	12057	1	0	\N
352126	1874	25622000	24229	12057	2	0	\N
352127	1874	25624000	24229	12057	3	0	\N
352128	1678	26640839533000	24230	12057	0	0	\N
352129	1874	25619000	24230	12057	1	0	\N
352130	1874	25622000	24230	12057	2	0	\N
352131	1874	25624000	24230	12057	3	0	\N
352132	1678	26640839534000	24231	12058	0	0	\N
352133	1874	25627000	24231	12058	1	0	\N
352134	1874	25629000	24231	12058	2	0	\N
352141	1678	26640839535000	24234	12059	0	0	\N
352142	1874	25632000	24234	12059	1	0	\N
352143	1874	25634000	24234	12059	2	0	\N
352144	1678	26640839536000	24235	12060	0	0	\N
352145	1874	25636000	24235	12060	1	0	\N
352146	1874	25637000	24235	12060	2	0	\N
352147	1874	25640000	24235	12060	3	0	\N
352157	1385	1709614695710050	24239	11999	0	0	\N
352158	1460	0	24239	11999	1	0	\N
352159	1874	25326000	24239	11999	2	0	\N
352160	1014	505330831110000	24239	11999	3	0	\N
352161	1495	10000000	24239	11999	4	0	\N
352162	1874	25327000	24239	11999	5	0	\N
352163	1380	1702582504891650	24239	11999	6	0	\N
352164	1380	1710262743411650	24239	11999	7	0	\N
352165	1254	613748195750000	24239	11999	8	0	\N
352166	1134	909633748050000	24239	11999	9	0	\N
352167	1014	507610345500000	24239	11999	10	0	\N
352168	1401	0	24239	11999	11	0	\N
352169	1874	25329000	24239	11999	12	0	\N
352170	1678	26640839539000	24240	12063	0	0	\N
352171	1874	25650000	24240	12063	1	0	\N
352172	1874	25652000	24240	12063	2	0	\N
352173	1678	26640839539000	24241	12063	0	0	\N
352174	1874	25650000	24241	12063	1	0	\N
352175	1874	25652000	24241	12063	2	0	\N
352179	1678	26640839539000	24243	12063	0	0	\N
352180	1874	25650000	24243	12063	1	0	\N
352181	1874	25652000	24243	12063	2	0	\N
352186	1874	24903000	24245	11918	0	0	\N
352187	1874	24904000	24245	11918	1	0	\N
352188	1874	24905000	24245	11918	2	0	\N
352189	1874	24906000	24245	11918	3	0	\N
352190	1874	24907000	24245	11918	4	0	\N
352191	1874	24908000	24245	11918	5	0	\N
352192	1678	26640839541000	24246	12065	0	0	\N
352193	1874	25661000	24246	12065	1	0	\N
352194	1874	25663000	24246	12065	2	0	\N
352211	1678	26640839542000	24249	12066	0	0	\N
352212	1678	26640839543000	24249	12066	1	0	\N
352213	1678	26640839544000	24249	12066	2	0	\N
352214	1678	26640839545000	24249	12066	3	0	\N
352215	1874	25666000	24249	12066	4	0	\N
352216	1874	25669000	24249	12066	5	0	\N
352217	1874	25671000	24249	12066	6	0	\N
352218	1874	25672000	24249	12066	7	0	\N
352219	1874	25675000	24249	12066	8	0	\N
352220	1874	25678000	24249	12066	9	0	\N
352221	1874	25680000	24249	12066	10	0	\N
352222	1874	25682000	24249	12066	11	0	\N
352223	1874	25684000	24249	12066	12	0	\N
352231	1678	26640839546000	24251	12067	0	0	\N
352232	1678	26640839547000	24251	12067	1	0	\N
352233	1874	25686000	24251	12067	2	0	\N
352234	1874	25688000	24251	12067	3	0	\N
352235	1874	25689000	24251	12067	4	0	\N
352236	1874	25692000	24251	12067	5	0	\N
352237	1874	25695000	24251	12067	6	0	\N
352107	1874	25618000	24224	12056	2	0	2
352120	1678	26640839533000	24228	12057	0	0	0
352121	1874	25619000	24228	12057	1	0	2
352122	1874	25622000	24228	12057	2	0	2
352123	1874	25624000	24228	12057	3	0	2
352136	1874	25627000	24232	12058	1	0	2
352137	1874	25629000	24232	12058	2	0	2
352138	1678	26640839535000	24233	12059	0	0	0
352139	1874	25632000	24233	12059	1	0	2
352140	1874	25634000	24233	12059	2	0	2
352149	1874	25636000	24236	12060	1	0	2
352150	1874	25637000	24236	12060	2	0	2
352151	1874	25640000	24236	12060	3	0	2
352152	1678	26640839537000	24237	12061	0	0	0
352154	1678	26640839538000	24238	12062	0	0	0
352155	1874	25645000	24238	12062	1	0	2
352156	1874	25647000	24238	12062	2	0	2
352176	1678	26640839539000	24242	12063	0	0	0
352177	1874	25650000	24242	12063	1	0	2
352182	1678	26640839540000	24244	12064	0	0	0
352183	1874	25653000	24244	12064	1	0	2
352184	1874	25656000	24244	12064	2	0	2
352185	1874	25658000	24244	12064	3	0	2
352195	1678	26640839541000	24247	12065	0	0	0
352197	1874	25663000	24247	12065	2	0	2
352198	1678	26640839542000	24248	12066	0	0	0
352199	1678	26640839543000	24248	12066	1	0	0
352200	1678	26640839544000	24248	12066	2	0	0
352202	1874	25666000	24248	12066	4	0	2
352203	1874	25669000	24248	12066	5	0	2
352204	1874	25671000	24248	12066	6	0	2
352205	1874	25672000	24248	12066	7	0	2
352206	1874	25675000	24248	12066	8	0	2
352208	1874	25680000	24248	12066	10	0	2
352209	1874	25682000	24248	12066	11	0	2
352210	1874	25684000	24248	12066	12	0	2
352224	1678	26640839546000	24250	12067	0	0	0
352225	1678	26640839547000	24250	12067	1	0	0
352227	1874	25688000	24250	12067	3	0	2
352228	1874	25689000	24250	12067	4	0	2
352229	1874	25692000	24250	12067	5	0	2
352230	1874	25695000	24250	12067	6	0	2
352239	169	66586284844974	24252	12068	1	0	0
352240	990	507245623196952	24252	12068	2	0	0
352246	1678	26640839548000	24253	12068	0	0	\N
352247	169	66586284844974	24253	12068	1	0	\N
352248	990	507245623196952	24253	12068	2	0	\N
352249	1110	908979810688432	24253	12068	3	0	\N
352250	1230	613306790973693	24253	12068	4	0	\N
352251	1356	1709033905247518	24253	12068	5	0	\N
352252	1874	25698000	24253	12068	6	0	\N
352253	1874	25700000	24253	12068	7	0	\N
352267	1678	26640839549000	24258	12070	0	0	\N
352268	1678	26640839550000	24258	12070	1	0	\N
352269	1678	26640839551000	24258	12070	2	0	\N
352270	1678	26640839552000	24258	12070	3	0	\N
352271	1874	25701000	24258	12070	4	0	\N
352272	1874	25704000	24258	12070	5	0	\N
352273	1874	25706000	24258	12070	6	0	\N
352274	1874	25708000	24258	12070	7	0	\N
352275	1874	25710000	24258	12070	8	0	\N
352276	1874	25713000	24258	12070	9	0	\N
352277	1874	25716000	24258	12070	10	0	\N
352278	1874	25719000	24258	12070	11	0	\N
352279	1874	25721000	24258	12070	12	0	\N
352284	1678	26640839553000	24260	12071	0	0	\N
352285	1874	25723000	24260	12071	1	0	\N
352286	1874	25726000	24260	12071	2	0	\N
352287	1874	25727000	24260	12071	3	0	\N
352291	1678	26640839554000	24262	12072	0	0	\N
352292	1874	25730000	24262	12072	1	0	\N
352293	1874	25732000	24262	12072	2	0	\N
352294	1678	26640839554000	24263	12072	0	0	\N
352295	1874	25730000	24263	12072	1	0	\N
352296	1874	25732000	24263	12072	2	0	\N
352297	2312	0	24264	12045	0	0	\N
352298	169	66586284844974	24264	12045	1	0	\N
352299	990	507245623196952	24264	12045	2	0	\N
352300	1110	908979810688432	24264	12045	3	0	\N
352301	1230	613306790973693	24264	12045	4	0	\N
352302	1356	1709033905247518	24264	12045	5	0	\N
352303	2310	1000000000	24264	12045	6	0	\N
352319	2312	0	24266	12073	0	0	\N
352320	1678	26640839555000	24266	12073	1	0	\N
352321	1678	26640839556000	24266	12073	2	0	\N
352322	1678	26640839557000	24266	12073	3	0	\N
352323	1678	26640839558000	24266	12073	4	0	\N
352324	2310	1000000000	24266	12073	5	0	\N
352325	1874	25734000	24266	12073	6	0	\N
352326	1874	25736000	24266	12073	7	0	\N
352327	1874	25739000	24266	12073	8	0	\N
352328	1874	25742000	24266	12073	9	0	\N
352329	1874	25745000	24266	12073	10	0	\N
352330	1874	25747000	24266	12073	11	0	\N
352331	1874	25749000	24266	12073	12	0	\N
352332	1874	25750000	24266	12073	13	0	\N
352333	1874	25753000	24266	12073	14	0	\N
352337	1678	26640839560000	24269	12075	0	0	\N
352338	1874	25760000	24269	12075	1	0	\N
352339	1874	25761000	24269	12075	2	0	\N
352340	1874	25764000	24269	12075	3	0	\N
352345	1678	26640839560000	24271	12075	0	0	\N
352346	1874	25760000	24271	12075	1	0	\N
352347	1874	25761000	24271	12075	2	0	\N
352348	1874	25764000	24271	12075	3	0	\N
352353	1678	26640839561000	24273	12076	0	0	\N
352354	1419	19006054560130	24273	12076	1	0	\N
352355	1874	25767000	24273	12076	2	0	\N
352356	1874	25769000	24273	12076	3	0	\N
352357	2312	1000000000	24274	12077	0	0	\N
352358	1678	26640839562000	24274	12077	1	0	\N
352359	1874	25771000	24274	12077	2	0	\N
352360	1874	25774000	24274	12077	3	0	\N
352365	1678	26640839563000	24276	12078	0	0	\N
352366	1874	25777000	24276	12078	1	0	\N
352367	1874	25779000	24276	12078	2	0	\N
352368	1874	25780000	24276	12078	3	0	\N
352369	1678	26640839563000	24277	12078	0	0	\N
352370	1874	25777000	24277	12078	1	0	\N
352371	1874	25779000	24277	12078	2	0	\N
352372	1874	25780000	24277	12078	3	0	\N
352373	1678	26640839563000	24278	12078	0	0	\N
352374	1874	25777000	24278	12078	1	0	\N
352375	1874	25779000	24278	12078	2	0	\N
352376	1874	25780000	24278	12078	3	0	\N
352243	1356	1709033905247518	24252	12068	5	0	0
352244	1874	25698000	24252	12068	6	0	2
352245	1874	25700000	24252	12068	7	0	2
352254	1678	26640839549000	24257	12070	0	0	0
352255	1678	26640839550000	24257	12070	1	0	0
352257	1678	26640839552000	24257	12070	3	0	0
352258	1874	25701000	24257	12070	4	0	2
352259	1874	25704000	24257	12070	5	0	2
352260	1874	25706000	24257	12070	6	0	2
352261	1874	25708000	24257	12070	7	0	2
352263	1874	25713000	24257	12070	9	0	2
352264	1874	25716000	24257	12070	10	0	2
352265	1874	25719000	24257	12070	11	0	2
352266	1874	25721000	24257	12070	12	0	2
352281	1874	25723000	24259	12071	1	0	2
352282	1874	25726000	24259	12071	2	0	2
352283	1874	25727000	24259	12071	3	0	2
352288	1678	26640839554000	24261	12072	0	0	0
352289	1874	25730000	24261	12072	1	0	2
352304	2312	0	24265	12073	0	0	0
352305	1678	26640839555000	24265	12073	1	0	0
352306	1678	26640839556000	24265	12073	2	0	0
352307	1678	26640839557000	24265	12073	3	0	0
352308	1678	26640839558000	24265	12073	4	0	0
352310	1874	25734000	24265	12073	6	0	2
352311	1874	25736000	24265	12073	7	0	2
352312	1874	25739000	24265	12073	8	0	2
352313	1874	25742000	24265	12073	9	0	2
352315	1874	25747000	24265	12073	11	0	2
352316	1874	25749000	24265	12073	12	0	2
352317	1874	25750000	24265	12073	13	0	2
352318	1874	25753000	24265	12073	14	0	2
352334	1678	26640839559000	24267	12074	0	0	0
352336	1874	25758000	24267	12074	2	0	2
352341	1678	26640839560000	24270	12075	0	0	0
352342	1874	25760000	24270	12075	1	0	2
352343	1874	25761000	24270	12075	2	0	2
352344	1874	25764000	24270	12075	3	0	2
352350	1419	19006054560130	24272	12076	1	0	8
352351	1874	25767000	24272	12076	2	0	2
352352	1874	25769000	24272	12076	3	0	2
352361	2312	1000000000	24275	12077	0	0	0
352363	1874	25771000	24275	12077	2	0	2
352364	1874	25774000	24275	12077	3	0	2
352377	1678	26640839563000	24279	12078	0	0	\N
352378	1874	25775000	24279	12078	1	0	\N
352386	1678	26640839564000	24284	12079	0	0	\N
352387	1874	25782000	24284	12079	1	0	\N
352388	1874	25785000	24284	12079	2	0	\N
352389	1678	26640839565000	24287	12080	0	0	\N
352390	1874	25788000	24287	12080	1	0	\N
352391	1874	25790000	24287	12080	2	0	\N
352395	1678	26640839566000	24289	12081	0	0	\N
352396	1874	25793000	24289	12081	1	0	\N
352397	1874	25794000	24289	12081	2	0	\N
352398	1874	25796000	24289	12081	3	0	\N
352399	1678	26640839566000	24290	12081	0	0	\N
352400	1874	25793000	24290	12081	1	0	\N
352401	1874	25794000	24290	12081	2	0	\N
352402	1874	25796000	24290	12081	3	0	\N
352407	1678	26640839567000	24292	12082	0	0	\N
352408	1874	25798000	24292	12082	1	0	\N
352409	1874	25801000	24292	12082	2	0	\N
352423	1874	25802000	24295	12083	0	0	\N
352424	1678	26640839568000	24296	12083	0	0	\N
352425	1678	26640839569000	24296	12083	1	0	\N
352426	1678	26640839570000	24296	12083	2	0	\N
352427	1874	25802000	24296	12083	3	0	\N
352428	1874	25805000	24296	12083	4	0	\N
352429	1874	25808000	24296	12083	5	0	\N
352430	1874	25810000	24296	12083	6	0	\N
352431	1874	25812000	24296	12083	7	0	\N
352432	1874	25814000	24296	12083	8	0	\N
352433	1874	25817000	24296	12083	9	0	\N
352434	2312	0	24297	12053	0	0	\N
352435	2312	1000000000	24297	12053	1	0	\N
352436	169	66586284844974	24297	12053	2	0	\N
352437	990	507245623196952	24297	12053	3	0	\N
352438	1110	908979810688432	24297	12053	4	0	\N
352439	1230	613306790973693	24297	12053	5	0	\N
352440	1356	1709033905247518	24297	12053	6	0	\N
352441	2310	1000000000	24297	12053	7	0	\N
352442	1678	26640839571000	24298	12084	0	0	\N
352443	1678	26640839572000	24298	12084	1	0	\N
352444	1874	25819000	24298	12084	2	0	\N
352445	1874	25822000	24298	12084	3	0	\N
352446	1874	25825000	24298	12084	4	0	\N
352447	1874	25827000	24298	12084	5	0	\N
352461	1678	26640839574000	24302	12086	0	0	\N
352462	1874	25835000	24302	12086	1	0	\N
352463	1874	25838000	24302	12086	2	0	\N
352464	1678	26640839574000	24303	12086	0	0	\N
352465	1874	25835000	24303	12086	1	0	\N
352466	1874	25838000	24303	12086	2	0	\N
352467	1678	26640839574000	24304	12086	0	0	\N
352468	1874	25835000	24304	12086	1	0	\N
352469	1874	25838000	24304	12086	2	0	\N
352470	1678	26640839575000	24305	12087	0	0	\N
352471	1678	26640839576000	24305	12087	1	0	\N
352472	1874	25841000	24305	12087	2	0	\N
352473	1874	25844000	24305	12087	4	0	\N
352474	1874	25846000	24305	12087	5	0	\N
352475	1874	25847000	24305	12087	6	0	\N
352476	1874	25849000	24305	12087	7	0	\N
352477	1678	26640839575000	24306	12087	0	0	\N
352478	1678	26640839576000	24306	12087	1	0	\N
352479	1874	25841000	24306	12087	2	0	\N
352480	1874	25844000	24306	12087	4	0	\N
352481	1874	25846000	24306	12087	5	0	\N
352482	1874	25847000	24306	12087	6	0	\N
352483	1874	25849000	24306	12087	7	0	\N
352491	1678	26640839575000	24308	12087	0	0	\N
352492	1678	26640839576000	24308	12087	1	0	\N
352493	1874	25841000	24308	12087	2	0	\N
352494	1874	25844000	24308	12087	4	0	\N
352495	1874	25846000	24308	12087	5	0	\N
352496	1874	25847000	24308	12087	6	0	\N
352497	1874	25849000	24308	12087	7	0	\N
352504	1678	26640839578000	24311	12089	0	0	\N
352505	1874	25856000	24311	12089	1	0	\N
352506	1874	25859000	24311	12089	2	0	\N
352507	1678	26640839579000	24312	12090	0	0	\N
352508	1678	26640839580000	24312	12090	1	0	\N
352509	1678	26640839581000	24312	12090	2	0	\N
352510	1874	25862000	24312	12090	3	0	\N
352511	1874	25865000	24312	12090	4	0	\N
352512	1874	25867000	24312	12090	5	0	\N
352381	1874	25779000	24280	12078	2	0	2
352382	1874	25780000	24280	12078	3	0	2
352383	1678	26640839564000	24282	12079	0	0	0
352384	1874	25782000	24282	12079	1	0	2
352385	1874	25785000	24282	12079	2	0	2
352393	1874	25788000	24288	12080	1	0	2
352394	1874	25790000	24288	12080	2	0	2
352403	1678	26640839566000	24291	12081	0	0	0
352404	1874	25793000	24291	12081	1	0	2
352405	1874	25794000	24291	12081	2	0	2
352410	1678	26640839567000	24293	12082	0	0	0
352411	1874	25798000	24293	12082	1	0	2
352412	1874	25801000	24293	12082	2	0	2
352413	1678	26640839568000	24294	12083	0	0	0
352415	1678	26640839570000	24294	12083	2	0	0
352416	1874	25802000	24294	12083	3	0	2
352417	1874	25805000	24294	12083	4	0	2
352418	1874	25808000	24294	12083	5	0	2
352419	1874	25810000	24294	12083	6	0	2
352421	1874	25814000	24294	12083	8	0	2
352422	1874	25817000	24294	12083	9	0	2
352448	1678	26640839571000	24299	12084	0	0	0
352449	1678	26640839572000	24299	12084	1	0	0
352450	1874	25819000	24299	12084	2	0	2
352452	1874	25825000	24299	12084	4	0	2
352453	1874	25827000	24299	12084	5	0	2
352454	1678	26640839573000	24300	12085	0	0	0
352455	1874	25829000	24300	12085	1	0	2
352457	1874	25833000	24300	12085	3	0	2
352458	1678	26640839574000	24301	12086	0	0	0
352459	1874	25835000	24301	12086	1	0	2
352460	1874	25838000	24301	12086	2	0	2
352484	1678	26640839575000	24307	12087	0	0	0
352486	1874	25841000	24307	12087	2	0	2
352487	1874	25844000	24307	12087	4	0	2
352488	1874	25846000	24307	12087	5	0	2
352489	1874	25847000	24307	12087	6	0	2
352490	1874	25849000	24307	12087	7	0	2
352499	1874	25852000	24309	12088	1	0	2
352500	1874	25854000	24309	12088	2	0	2
352501	1678	26640839578000	24310	12089	0	0	0
352502	1874	25856000	24310	12089	1	0	2
352513	1874	25869000	24312	12090	6	0	\N
352514	1874	25870000	24312	12090	7	0	\N
352515	1874	25872000	24312	12090	8	0	\N
352525	1678	26640839582000	24314	12091	0	0	\N
352526	1678	26640839583000	24314	12091	1	0	\N
352527	1874	25873000	24314	12091	2	0	\N
352528	1874	25876000	24314	12091	3	0	\N
352529	1874	25879000	24314	12091	4	0	\N
352530	1874	25881000	24314	12091	5	0	\N
352531	1874	25883000	24314	12091	6	0	\N
352555	1678	26640839589000	24319	12095	0	0	\N
352556	1678	26640839590000	24319	12095	1	0	\N
352557	1678	26640839591000	24319	12095	2	0	\N
352558	1678	26640839592000	24319	12095	3	0	\N
352559	1874	25912000	24319	12095	4	0	\N
352560	1874	25915000	24319	12095	5	0	\N
352561	1874	25917000	24319	12095	6	0	\N
352562	1874	25920000	24319	12095	7	0	\N
352563	1874	25923000	24319	12095	8	0	\N
352564	1874	25924000	24319	12095	9	0	\N
352565	1874	25926000	24319	12095	10	0	\N
352566	1874	25928000	24319	12095	11	0	\N
352567	1874	25930000	24319	12095	12	0	\N
352591	1678	26640839594000	24323	12097	0	0	\N
352592	1678	26640839595000	24323	12097	1	0	\N
352593	1874	25938000	24323	12097	3	0	\N
352594	1874	25940000	24323	12097	4	0	\N
352595	1874	25943000	24323	12097	5	0	\N
352596	1874	25946000	24323	12097	6	0	\N
352597	1678	26640839594000	24324	12097	0	0	\N
352598	1678	26640839595000	24324	12097	1	0	\N
352599	1874	25938000	24324	12097	3	0	\N
352600	1874	25940000	24324	12097	4	0	\N
352611	1678	26640839596000	24327	12099	0	0	\N
352612	1874	25965000	24327	12099	1	0	\N
352613	1874	25967000	24327	12099	2	0	\N
352614	1678	26640839596000	24328	12099	0	0	\N
352615	1874	25965000	24328	12099	1	0	\N
352616	1874	25967000	24328	12099	2	0	\N
352617	1678	26640839596000	24329	12099	0	0	\N
352618	1874	25965000	24329	12099	1	0	\N
352619	1874	25967000	24329	12099	2	0	\N
352624	1007	506698773004376	24331	12101	0	0	\N
352625	1678	26640839598000	24331	12101	1	0	\N
352626	1678	26640839599000	24331	12101	2	0	\N
352627	1678	26640839600000	24331	12101	3	0	\N
352628	1874	25976000	24331	12101	4	0	\N
352629	1874	25979000	24331	12101	5	0	\N
352630	1874	25980000	24331	12101	6	0	\N
352631	1874	25982000	24331	12101	7	0	\N
352632	1874	25984000	24331	12101	8	0	\N
352633	1874	25986000	24331	12101	9	0	\N
352634	1874	25989000	24331	12101	10	0	\N
352635	1007	506698773004376	24332	12101	0	0	\N
352636	1678	26640839598000	24332	12101	1	0	\N
352637	1678	26640839599000	24332	12101	2	0	\N
352638	1678	26640839600000	24332	12101	3	0	\N
352639	1874	25976000	24332	12101	4	0	\N
352640	1874	25979000	24332	12101	5	0	\N
352641	1874	25980000	24332	12101	6	0	\N
352642	1874	25982000	24332	12101	7	0	\N
352643	1874	25984000	24332	12101	8	0	\N
352644	1874	25986000	24332	12101	9	0	\N
352645	1874	25989000	24332	12101	10	0	\N
352646	1007	506698773004376	24333	12101	0	0	\N
352647	1678	26640839598000	24333	12101	1	0	\N
352648	1678	26640839599000	24333	12101	2	0	\N
352518	1678	26640839581000	24313	12090	2	0	0
352519	1874	25862000	24313	12090	3	0	2
352520	1874	25865000	24313	12090	4	0	2
352521	1874	25867000	24313	12090	5	0	2
352522	1874	25869000	24313	12090	6	0	2
352524	1874	25872000	24313	12090	8	0	2
352532	1678	26640839582000	24315	12091	0	0	0
352533	1678	26640839583000	24315	12091	1	0	0
352534	1874	25873000	24315	12091	2	0	2
352535	1874	25876000	24315	12091	3	0	2
352537	1874	25881000	24315	12091	5	0	2
352538	1874	25883000	24315	12091	6	0	2
352539	1678	26640839584000	24316	12092	0	0	0
352540	1874	25886000	24316	12092	1	0	2
352542	1678	26640839585000	24317	12093	0	0	0
352543	1678	26640839586000	24317	12093	1	0	0
352544	1874	25889000	24317	12093	2	0	2
352545	1874	25892000	24317	12093	3	0	2
352546	1874	25895000	24317	12093	4	0	2
352548	1874	25899000	24317	12093	6	0	2
352549	1678	26640839587000	24318	12094	0	0	0
352550	1678	26640839588000	24318	12094	1	0	0
352551	1874	25901000	24318	12094	2	0	2
352552	1874	25904000	24318	12094	3	0	2
352554	1874	25909000	24318	12094	5	0	2
352568	1678	26640839589000	24320	12095	0	0	0
352569	1678	26640839590000	24320	12095	1	0	0
352570	1678	26640839591000	24320	12095	2	0	0
352572	1874	25912000	24320	12095	4	0	2
352573	1874	25915000	24320	12095	5	0	2
352574	1874	25917000	24320	12095	6	0	2
352575	1874	25920000	24320	12095	7	0	2
352576	1874	25923000	24320	12095	8	0	2
352578	1874	25926000	24320	12095	10	0	2
352579	1874	25928000	24320	12095	11	0	2
352580	1874	25930000	24320	12095	12	0	2
352581	1678	26640839593000	24321	12096	0	0	0
352582	1874	25931000	24321	12096	1	0	2
352584	1874	25936000	24321	12096	3	0	2
352585	1678	26640839594000	24322	12097	0	0	0
352586	1678	26640839595000	24322	12097	1	0	0
352587	1874	25938000	24322	12097	3	0	2
352589	1874	25943000	24322	12097	5	0	2
352590	1874	25946000	24322	12097	6	0	2
352601	1874	25949000	24325	12098	0	0	2
352602	1874	25952000	24325	12098	1	0	2
352603	1874	25955000	24325	12098	2	0	2
352605	1874	25958000	24325	12098	4	0	2
352606	1874	25960000	24325	12098	5	0	2
352607	1874	25962000	24325	12098	6	0	2
352608	1678	26640839596000	24326	12099	0	0	0
352609	1874	25965000	24326	12099	1	0	2
352620	1678	26640839597000	24330	12100	0	0	0
352621	1874	25970000	24330	12100	1	0	2
352622	1874	25971000	24330	12100	2	0	2
352623	1874	25973000	24330	12100	3	0	2
352649	1678	26640839600000	24333	12101	3	0	\N
352650	1874	25976000	24333	12101	4	0	\N
352651	1874	25979000	24333	12101	5	0	\N
352652	1874	25980000	24333	12101	6	0	\N
352653	1874	25982000	24333	12101	7	0	\N
352654	1874	25984000	24333	12101	8	0	\N
352655	1874	25986000	24333	12101	9	0	\N
352656	1874	25989000	24333	12101	10	0	\N
352657	1007	506698773004376	24334	12101	0	0	\N
352658	1678	26640839598000	24334	12101	1	0	\N
352659	1678	26640839599000	24334	12101	2	0	\N
352660	1678	26640839600000	24334	12101	3	0	\N
352661	1874	25976000	24334	12101	4	0	\N
352662	1874	25979000	24334	12101	5	0	\N
352663	1874	25980000	24334	12101	6	0	\N
352664	1874	25982000	24334	12101	7	0	\N
352665	1874	25984000	24334	12101	8	0	\N
352666	1874	25986000	24334	12101	9	0	\N
352667	1874	25989000	24334	12101	10	0	\N
352679	1678	26640839601000	24336	12102	0	0	\N
352680	1874	25991000	24336	12102	1	0	\N
352681	1874	25994000	24336	12102	2	0	\N
352685	1678	26640839602000	24338	12103	0	0	\N
352686	1874	25996000	24338	12103	2	0	\N
352687	1874	25999000	24338	12103	3	0	\N
352693	1678	26640839604000	24341	12105	0	0	\N
352694	1874	26003000	24341	12105	1	0	\N
352695	1874	26005000	24341	12105	2	0	\N
352702	1678	26640839606000	24344	12107	0	0	\N
352703	1874	26013000	24344	12107	1	0	\N
352704	1874	26015000	24344	12107	2	0	\N
352718	1678	26640839609000	24348	12109	0	0	\N
352719	1874	26029000	24348	12109	1	0	\N
352720	1874	26031000	24348	12109	2	0	\N
352721	1678	26640839610000	24349	12110	0	0	\N
352722	1678	26640839611000	24349	12110	1	0	\N
352723	1874	26032000	24349	12110	2	0	\N
352724	1874	26035000	24349	12110	3	0	\N
352725	1874	26037000	24349	12110	4	0	\N
352726	1874	26040000	24349	12110	5	0	\N
352733	1678	26640839612000	24351	12111	0	0	\N
352734	1874	26043000	24351	12111	1	0	\N
352735	1678	26640839612000	24352	12111	0	0	\N
352736	1874	26043000	24352	12111	1	0	\N
352739	1678	26640839612000	24354	12111	0	0	\N
352740	1874	26043000	24354	12111	1	0	\N
352746	1678	26640839614000	24357	12113	0	0	\N
352747	1874	26047000	24357	12113	1	0	\N
352748	1874	26050000	24357	12113	2	0	\N
352749	1678	26640839615000	24358	12114	0	0	\N
352750	1874	26053000	24358	12114	1	0	\N
352751	1678	26640839615000	24359	12114	0	0	\N
352752	1874	26053000	24359	12114	1	0	\N
352755	1678	26640839616000	24361	12115	0	0	\N
352756	1874	26056000	24361	12115	1	0	\N
352762	1678	26640839617000	24364	12116	0	0	\N
352763	1874	26059000	24364	12116	1	0	\N
352764	1874	26060000	24364	12116	2	0	\N
352776	1678	26640839622000	24367	12119	0	0	\N
352777	1874	26076000	24367	12119	1	0	\N
352670	1678	26640839599000	24335	12101	2	0	0
352671	1678	26640839600000	24335	12101	3	0	0
352672	1874	25976000	24335	12101	4	0	2
352673	1874	25979000	24335	12101	5	0	2
352674	1874	25980000	24335	12101	6	0	2
352676	1874	25984000	24335	12101	8	0	2
352677	1874	25986000	24335	12101	9	0	2
352678	1874	25989000	24335	12101	10	0	2
352682	1678	26640839601000	24337	12102	0	0	0
352683	1874	25991000	24337	12102	1	0	2
352688	1678	26640839602000	24339	12103	0	0	0
352689	1874	25996000	24339	12103	2	0	2
352690	1874	25999000	24339	12103	3	0	2
352691	1678	26640839603000	24340	12104	0	0	0
352696	1678	26640839604000	24342	12105	0	0	0
352697	1874	26003000	24342	12105	1	0	2
352698	1874	26005000	24342	12105	2	0	2
352699	1678	26640839605000	24343	12106	0	0	0
352700	1874	26008000	24343	12106	1	0	2
352705	1678	26640839606000	24345	12107	0	0	0
352706	1874	26013000	24345	12107	1	0	2
352707	1874	26015000	24345	12107	2	0	2
352708	1678	26640839607000	24346	12108	0	0	0
352709	1678	26640839608000	24346	12108	1	0	0
352711	1874	26019000	24346	12108	3	0	2
352712	1874	26022000	24346	12108	4	0	2
352713	1874	26023000	24346	12108	5	0	2
352714	1874	26026000	24346	12108	6	0	2
352716	1874	26029000	24347	12109	1	0	2
352717	1874	26031000	24347	12109	2	0	2
352727	1678	26640839610000	24350	12110	0	0	0
352728	1678	26640839611000	24350	12110	1	0	0
352729	1874	26032000	24350	12110	2	0	2
352731	1874	26037000	24350	12110	4	0	2
352732	1874	26040000	24350	12110	5	0	2
352737	1678	26640839612000	24353	12111	0	0	0
352738	1874	26043000	24353	12111	1	0	2
352741	1678	26640839613000	24355	12112	0	0	0
352743	1678	26640839614000	24356	12113	0	0	0
352744	1874	26047000	24356	12113	1	0	2
352745	1874	26050000	24356	12113	2	0	2
352753	1678	26640839615000	24360	12114	0	0	0
352757	1678	26640839616000	24362	12115	0	0	0
352758	1874	26056000	24362	12115	1	0	2
352759	1678	26640839617000	24363	12116	0	0	0
352760	1874	26059000	24363	12116	1	0	2
352761	1874	26060000	24363	12116	2	0	2
352766	1678	26640839618000	24365	12117	1	0	0
352767	1678	26640839619000	24365	12117	2	0	0
352768	1874	26063000	24365	12117	3	0	2
352769	1874	26066000	24365	12117	4	0	2
352770	1046	909797465000000	24366	12118	0	0	0
352772	1678	26640839621000	24366	12118	2	0	0
352773	1874	26069000	24366	12118	3	0	2
352774	1874	26072000	24366	12118	4	0	2
352775	1874	26073000	24366	12118	5	0	2
352779	1874	26076000	24368	12119	1	0	2
352780	1166	613858750000000	24369	12120	0	0	0
352781	1678	26640839623000	24369	12120	1	0	0
352782	1678	26640839624000	24369	12120	2	0	0
352783	1678	26640839625000	24369	12120	3	0	0
352788	1166	613858750000000	24370	12120	0	0	\N
352789	1678	26640839623000	24370	12120	1	0	\N
352790	1678	26640839624000	24370	12120	2	0	\N
352791	1678	26640839625000	24370	12120	3	0	\N
352792	1874	26079000	24370	12120	4	0	\N
352793	1874	26082000	24370	12120	5	0	\N
352794	1874	26085000	24370	12120	6	0	\N
352795	1874	26086000	24370	12120	7	0	\N
352801	926	507702775000000	24375	12123	0	0	\N
352802	1678	26640839628000	24375	12123	1	0	\N
352803	1874	26096000	24375	12123	2	0	\N
352804	926	507702775000000	24376	12123	0	0	\N
352805	1678	26640839628000	24376	12123	1	0	\N
352806	1874	26096000	24376	12123	2	0	\N
352810	1292	1710568637751650	24378	12116	0	0	\N
352811	1046	909797465000000	24378	12116	1	0	\N
352812	1166	613858750000000	24378	12116	2	0	\N
352813	1678	26640839617000	24378	12116	3	0	\N
352814	1678	26640839618000	24378	12116	4	0	\N
352815	1678	26640839619000	24378	12116	5	0	\N
352816	1678	26640839620000	24378	12116	6	0	\N
352817	1678	26640839621000	24378	12116	7	0	\N
352818	1678	26640839622000	24378	12116	8	0	\N
352819	1678	26640839623000	24378	12116	9	0	\N
352820	1678	26640839624000	24378	12116	10	0	\N
352821	1678	26640839625000	24378	12116	11	0	\N
352822	1678	26640839626000	24378	12116	12	0	\N
352823	1678	26640839627000	24378	12116	13	0	\N
352824	1678	26640839628000	24378	12116	14	0	\N
352825	1874	26059000	24378	12116	15	0	\N
352826	1874	26060000	24378	12116	16	0	\N
352827	1874	26063000	24378	12116	17	0	\N
352828	1874	26066000	24378	12116	18	0	\N
352829	1874	26069000	24378	12116	19	0	\N
352830	1874	26072000	24378	12116	20	0	\N
352831	1874	26075000	24378	12116	21	0	\N
352832	1874	26078000	24378	12116	22	0	\N
352833	1874	26081000	24378	12116	23	0	\N
352834	1874	26082000	24378	12116	24	0	\N
352835	1874	26085000	24378	12116	25	0	\N
352836	1874	26088000	24378	12116	26	0	\N
352837	1874	26091000	24378	12116	27	0	\N
352838	1874	26092000	24378	12116	28	0	\N
352839	1874	26093000	24378	12116	29	0	\N
352841	1678	26640839629000	24380	12124	0	0	\N
352856	1678	26640839633000	24385	12127	0	0	\N
352857	1678	26640839634000	24385	12127	1	0	\N
352858	1678	26640839635000	24385	12127	2	0	\N
352859	1874	26107000	24385	12127	3	0	\N
352860	1874	26110000	24385	12127	4	0	\N
352861	1874	26113000	24385	12127	5	0	\N
352862	1874	26116000	24385	12127	6	0	\N
352863	1678	26640839633000	24386	12127	0	0	\N
352864	1678	26640839634000	24386	12127	1	0	\N
352865	1678	26640839635000	24386	12127	2	0	\N
352866	1874	26107000	24386	12127	3	0	\N
352867	1874	26110000	24386	12127	4	0	\N
352868	1874	26113000	24386	12127	5	0	\N
352869	1874	26116000	24386	12127	6	0	\N
352870	1678	26640839636000	24387	12128	0	0	\N
352871	1874	26119000	24387	12128	1	0	\N
352872	1678	26640839636000	24388	12128	0	0	\N
352873	1874	26119000	24388	12128	1	0	\N
352876	1678	26640839636000	24390	12128	0	0	\N
352877	1874	26119000	24390	12128	1	0	\N
352881	1678	26640839636000	24392	12128	0	0	\N
352882	1678	26640839637000	24392	12128	1	0	\N
352883	1874	26117000	24392	12128	2	0	\N
352884	1874	26120000	24392	12128	3	0	\N
352885	1874	26123000	24392	12128	4	0	\N
352886	1678	26640839637000	24393	12129	0	0	\N
352887	1874	26122000	24393	12129	1	0	\N
352888	1874	26123000	24393	12129	2	0	\N
352889	1678	26640839638000	24394	12130	0	0	\N
352890	1874	26126000	24394	12130	1	0	\N
352893	1292	1710568637751650	24396	12113	0	0	\N
352894	1046	909797465000000	24396	12113	1	0	\N
352895	1166	613858750000000	24396	12113	2	0	\N
352896	926	507702775000000	24396	12113	3	0	\N
352897	1678	26640839614000	24396	12113	4	0	\N
352898	1678	26640839615000	24396	12113	5	0	\N
352899	1678	26640839616000	24396	12113	6	0	\N
352900	1678	26640839617000	24396	12113	7	0	\N
352901	1678	26640839618000	24396	12113	8	0	\N
352902	1678	26640839619000	24396	12113	9	0	\N
352903	1678	26640839620000	24396	12113	10	0	\N
352904	1678	26640839621000	24396	12113	11	0	\N
352905	1678	26640839622000	24396	12113	12	0	\N
352906	1678	26640839623000	24396	12113	13	0	\N
352907	1678	26640839624000	24396	12113	14	0	\N
352908	1678	26640839625000	24396	12113	15	0	\N
352909	1678	26640839626000	24396	12113	16	0	\N
352910	1678	26640839627000	24396	12113	17	0	\N
352911	1678	26640839628000	24396	12113	18	0	\N
352912	1678	26640839629000	24396	12113	19	0	\N
352913	1678	26640839630000	24396	12113	20	0	\N
352914	1678	26640839631000	24396	12113	21	0	\N
352915	1678	26640839632000	24396	12113	22	0	\N
352916	1678	26640839633000	24396	12113	23	0	\N
352917	1678	26640839634000	24396	12113	24	0	\N
352918	1678	26640839635000	24396	12113	25	0	\N
352919	1678	26640839636000	24396	12113	26	0	\N
352920	1678	26640839637000	24396	12113	27	0	\N
352787	1874	26086000	24369	12120	7	0	2
352796	1678	26640839626000	24372	12121	0	0	0
352797	1874	26089000	24372	12121	1	0	2
352798	1678	26640839627000	24374	12122	0	0	0
352799	1874	26092000	24374	12122	1	0	2
352807	926	507702775000000	24377	12123	0	0	0
352808	1678	26640839628000	24377	12123	1	0	0
352809	1874	26096000	24377	12123	2	0	2
352840	1678	26640839629000	24379	12124	0	0	0
352842	1678	26640839630000	24381	12125	0	0	0
352844	1874	26100000	24381	12125	2	0	2
352845	1678	26640839631000	24382	12126	0	0	0
352846	1678	26640839632000	24382	12126	1	0	0
352847	1874	26103000	24382	12126	2	0	2
352849	1678	26640839633000	24384	12127	0	0	0
352850	1678	26640839634000	24384	12127	1	0	0
352851	1678	26640839635000	24384	12127	2	0	0
352852	1874	26107000	24384	12127	3	0	2
352853	1874	26110000	24384	12127	4	0	2
352855	1874	26116000	24384	12127	6	0	2
352874	1678	26640839636000	24389	12128	0	0	0
352875	1874	26119000	24389	12128	1	0	2
352878	1678	26640839637000	24391	12129	0	0	0
352879	1874	26122000	24391	12129	1	0	2
352891	1678	26640839638000	24395	12130	0	0	0
352892	1874	26126000	24395	12130	1	0	2
352921	1678	26640839638000	24396	12113	28	0	\N
352922	1874	26047000	24396	12113	29	0	\N
352923	1874	26050000	24396	12113	30	0	\N
352924	1874	26053000	24396	12113	31	0	\N
352925	1874	26056000	24396	12113	32	0	\N
352926	1874	26059000	24396	12113	33	0	\N
352927	1874	26060000	24396	12113	34	0	\N
352928	1874	26063000	24396	12113	35	0	\N
352929	1874	26066000	24396	12113	36	0	\N
352930	1874	26069000	24396	12113	37	0	\N
352931	1874	26072000	24396	12113	38	0	\N
352932	1874	26075000	24396	12113	39	0	\N
352933	1874	26078000	24396	12113	40	0	\N
352934	1874	26081000	24396	12113	41	0	\N
352935	1874	26082000	24396	12113	42	0	\N
352936	1874	26085000	24396	12113	43	0	\N
352937	1874	26088000	24396	12113	44	0	\N
352938	1874	26091000	24396	12113	45	0	\N
352939	1874	26094000	24396	12113	46	0	\N
352940	1874	26095000	24396	12113	47	0	\N
352941	1874	26096000	24396	12113	48	0	\N
352942	1874	26097000	24396	12113	49	0	\N
352943	1874	26098000	24396	12113	50	0	\N
352944	1874	26099000	24396	12113	51	0	\N
352945	1874	26102000	24396	12113	52	0	\N
352946	1874	26105000	24396	12113	53	0	\N
352947	1874	26108000	24396	12113	54	0	\N
352948	1874	26111000	24396	12113	55	0	\N
352949	1874	26114000	24396	12113	56	0	\N
352950	1874	26117000	24396	12113	57	0	\N
352951	1874	26120000	24396	12113	58	0	\N
352952	1874	26123000	24396	12113	59	0	\N
352953	1874	26126000	24396	12113	60	0	\N
352954	1678	26640839639000	24397	12131	0	0	\N
352955	1874	26129000	24397	12131	1	0	\N
352958	1678	26640839640000	24399	12132	0	0	\N
352959	1874	26132000	24399	12132	1	0	\N
352960	1874	26133000	24399	12132	2	0	\N
352972	1678	26640839644000	24404	12135	0	0	\N
352973	1874	26142000	24404	12135	1	0	\N
352974	1874	26143000	24404	12135	2	0	\N
352977	1678	26640839645000	24406	12136	0	0	\N
352978	1874	26146000	24406	12136	1	0	\N
352989	1678	26640839648000	24410	12139	0	0	\N
352990	1874	26156000	24410	12139	1	0	\N
353001	1678	26640839652000	24415	12143	0	0	\N
353002	1874	26169000	24415	12143	1	0	\N
353003	1678	26640839652000	24416	12143	0	0	\N
353004	1874	26169000	24416	12143	1	0	\N
353014	1678	26640839656000	24419	12145	0	0	\N
353015	1874	26182000	24419	12145	1	0	\N
353016	1678	26640839639000	24420	12114	0	0	\N
353017	1678	26640839640000	24420	12114	1	0	\N
353018	1678	26640839641000	24420	12114	2	0	\N
353019	1678	26640839642000	24420	12114	3	0	\N
353020	1678	26640839643000	24420	12114	4	0	\N
353021	1678	26640839644000	24420	12114	5	0	\N
353022	1678	26640839645000	24420	12114	6	0	\N
353023	1678	26640839646000	24420	12114	7	0	\N
353024	1678	26640839647000	24420	12114	8	0	\N
353025	1678	26640839648000	24420	12114	9	0	\N
353026	1678	26640839649000	24420	12114	10	0	\N
353027	1678	26640839650000	24420	12114	12	0	\N
353028	1678	26640839651000	24420	12114	13	0	\N
353029	1678	26640839652000	24420	12114	14	0	\N
353030	1678	26640839653000	24420	12114	15	0	\N
353031	1678	26640839654000	24420	12114	16	0	\N
353032	1678	26640839655000	24420	12114	17	0	\N
353033	1678	26640839656000	24420	12114	18	0	\N
353034	1678	26640839657000	24420	12114	19	0	\N
353035	975	507693347075084	24420	12114	20	0	\N
353036	1095	909782128041950	24420	12114	21	0	\N
353037	1215	613848130479398	24420	12114	22	0	\N
353038	1341	1710542395913461	24420	12114	23	0	\N
353039	1874	26129000	24420	12114	24	0	\N
353040	1874	26132000	24420	12114	25	0	\N
353041	1874	26135000	24420	12114	26	0	\N
353042	1874	26138000	24420	12114	27	0	\N
353043	1874	26141000	24420	12114	28	0	\N
353044	1874	26144000	24420	12114	29	0	\N
353045	1874	26147000	24420	12114	30	0	\N
353046	1874	26150000	24420	12114	31	0	\N
353047	1874	26153000	24420	12114	32	0	\N
353048	1874	26156000	24420	12114	33	0	\N
353049	1874	26159000	24420	12114	34	0	\N
353050	1874	26162000	24420	12114	35	0	\N
353051	1874	26165000	24420	12114	36	0	\N
353052	1874	26168000	24420	12114	37	0	\N
353053	1874	26171000	24420	12114	38	0	\N
353054	1874	26174000	24420	12114	39	0	\N
353055	1874	26177000	24420	12114	40	0	\N
353056	1874	26180000	24420	12114	41	0	\N
352961	1678	26640839640000	24400	12132	0	0	0
352962	1874	26132000	24400	12132	1	0	2
352963	1874	26133000	24400	12132	2	0	2
352964	1678	26640839641000	24401	12133	0	0	0
352965	1678	26640839642000	24401	12133	1	0	0
352967	1678	26640839643000	24402	12134	0	0	0
352968	1874	26139000	24402	12134	1	0	2
352969	1678	26640839644000	24403	12135	0	0	0
352970	1874	26142000	24403	12135	1	0	2
352971	1874	26143000	24403	12135	2	0	2
352976	1874	26146000	24405	12136	1	0	2
352979	1678	26640839646000	24407	12137	0	0	0
352980	1874	26149000	24407	12137	1	0	2
352981	975	507693347075084	24407	12137	2	0	0
352983	1215	613848130479398	24407	12137	4	0	0
352984	1341	1710542395913461	24407	12137	5	0	0
352985	1678	26640839647000	24408	12138	0	0	0
352986	1874	26152000	24408	12138	1	0	2
352987	1874	26153000	24408	12138	2	0	2
352991	1678	26640839648000	24411	12140	0	0	0
352992	1678	26640839649000	24411	12140	1	0	0
352993	1874	26159000	24411	12140	2	0	2
352994	1678	26640839650000	24412	12141	0	0	0
352995	1874	26160000	24412	12141	1	0	2
352997	1678	26640839651000	24413	12142	0	0	0
352998	1874	26166000	24413	12142	1	0	2
352999	1678	26640839652000	24414	12143	0	0	0
353000	1874	26169000	24414	12143	1	0	2
353006	1678	26640839654000	24417	12144	1	0	0
353007	1678	26640839655000	24417	12144	2	0	0
353008	1874	26170000	24417	12144	3	0	2
353009	1874	26173000	24417	12144	4	0	2
353010	1874	26176000	24417	12144	5	0	2
353012	1678	26640839656000	24418	12145	0	0	0
353013	1874	26182000	24418	12145	1	0	2
353057	1874	26181000	24420	12114	42	0	\N
353058	1874	26182000	24420	12114	43	0	\N
353059	1874	26183000	24420	12114	44	0	\N
353060	1874	26184000	24420	12114	45	0	\N
353061	1874	26185000	24420	12114	46	0	\N
353062	1874	26186000	24420	12114	47	0	\N
353063	1292	1710568637751650	24421	12075	0	0	\N
353064	1046	909797465000000	24421	12075	1	0	\N
353065	1166	613858750000000	24421	12075	2	0	\N
353066	926	507702775000000	24421	12075	3	0	\N
353067	2312	1000000000	24421	12075	4	0	\N
353068	1007	506698773004376	24421	12075	5	0	\N
353069	1678	26640839560000	24421	12075	6	0	\N
353070	1678	26640839561000	24421	12075	7	0	\N
353071	1419	19006054560130	24421	12075	8	0	\N
353072	1678	26640839562000	24421	12075	9	0	\N
353073	1678	26640839563000	24421	12075	10	0	\N
353074	1678	26640839564000	24421	12075	11	0	\N
353075	1678	26640839565000	24421	12075	12	0	\N
353076	1678	26640839566000	24421	12075	13	0	\N
353077	1678	26640839567000	24421	12075	14	0	\N
353078	1678	26640839568000	24421	12075	15	0	\N
353079	1678	26640839569000	24421	12075	16	0	\N
353080	1678	26640839570000	24421	12075	17	0	\N
353081	1678	26640839571000	24421	12075	18	0	\N
353082	1678	26640839572000	24421	12075	19	0	\N
353083	1678	26640839573000	24421	12075	20	0	\N
353084	1678	26640839574000	24421	12075	21	0	\N
353085	1678	26640839575000	24421	12075	22	0	\N
353086	1678	26640839576000	24421	12075	23	0	\N
353087	1678	26640839577000	24421	12075	24	0	\N
353088	1678	26640839578000	24421	12075	25	0	\N
353089	1678	26640839579000	24421	12075	26	0	\N
353090	1678	26640839580000	24421	12075	27	0	\N
353091	1678	26640839581000	24421	12075	28	0	\N
353092	1678	26640839582000	24421	12075	29	0	\N
353093	1678	26640839583000	24421	12075	30	0	\N
353094	1678	26640839584000	24421	12075	31	0	\N
353095	1678	26640839585000	24421	12075	32	0	\N
353096	1678	26640839586000	24421	12075	33	0	\N
353097	1678	26640839587000	24421	12075	34	0	\N
353098	1678	26640839588000	24421	12075	35	0	\N
353099	1678	26640839589000	24421	12075	36	0	\N
353100	1678	26640839590000	24421	12075	37	0	\N
353101	1678	26640839591000	24421	12075	38	0	\N
353102	1678	26640839592000	24421	12075	39	0	\N
353103	1678	26640839593000	24421	12075	40	0	\N
353104	1678	26640839594000	24421	12075	41	0	\N
353105	1678	26640839595000	24421	12075	42	0	\N
353106	1678	26640839596000	24421	12075	43	0	\N
353107	1678	26640839597000	24421	12075	44	0	\N
353108	1678	26640839598000	24421	12075	45	0	\N
353109	1678	26640839599000	24421	12075	46	0	\N
353110	1678	26640839600000	24421	12075	47	0	\N
353111	1678	26640839601000	24421	12075	48	0	\N
353112	1678	26640839602000	24421	12075	49	0	\N
353113	1678	26640839603000	24421	12075	50	0	\N
353114	1678	26640839604000	24421	12075	51	0	\N
353115	1678	26640839605000	24421	12075	52	0	\N
353116	1678	26640839606000	24421	12075	53	0	\N
353117	1678	26640839607000	24421	12075	54	0	\N
353118	1678	26640839608000	24421	12075	55	0	\N
353119	1678	26640839609000	24421	12075	56	0	\N
353120	1678	26640839610000	24421	12075	57	0	\N
353121	1678	26640839611000	24421	12075	58	0	\N
353122	1678	26640839612000	24421	12075	59	0	\N
353123	1678	26640839613000	24421	12075	60	0	\N
353124	1678	26640839614000	24421	12075	61	0	\N
353125	1678	26640839615000	24421	12075	62	0	\N
353126	1678	26640839616000	24421	12075	63	0	\N
353127	1678	26640839617000	24421	12075	64	0	\N
353128	1678	26640839618000	24421	12075	65	0	\N
353129	1678	26640839619000	24421	12075	66	0	\N
353130	1678	26640839620000	24421	12075	67	0	\N
353131	1678	26640839621000	24421	12075	68	0	\N
353132	1678	26640839622000	24421	12075	69	0	\N
353133	1678	26640839623000	24421	12075	70	0	\N
353134	1678	26640839624000	24421	12075	71	0	\N
353135	1678	26640839625000	24421	12075	72	0	\N
353136	1678	26640839626000	24421	12075	73	0	\N
353137	1678	26640839627000	24421	12075	74	0	\N
353138	1678	26640839628000	24421	12075	75	0	\N
353139	1678	26640839629000	24421	12075	76	0	\N
353140	1678	26640839630000	24421	12075	77	0	\N
353141	1678	26640839631000	24421	12075	78	0	\N
353142	1678	26640839632000	24421	12075	80	0	\N
353143	1678	26640839633000	24421	12075	81	0	\N
353144	1678	26640839634000	24421	12075	82	0	\N
353145	1678	26640839635000	24421	12075	83	0	\N
353146	1678	26640839636000	24421	12075	84	0	\N
353147	1678	26640839637000	24421	12075	85	0	\N
353148	1678	26640839638000	24421	12075	86	0	\N
353149	1678	26640839639000	24421	12075	87	0	\N
353150	1678	26640839640000	24421	12075	88	0	\N
353151	1678	26640839641000	24421	12075	89	0	\N
353152	1678	26640839642000	24421	12075	90	0	\N
353153	1678	26640839643000	24421	12075	91	0	\N
353154	1678	26640839644000	24421	12075	92	0	\N
353155	1678	26640839645000	24421	12075	93	0	\N
353156	1678	26640839646000	24421	12075	94	0	\N
353157	1678	26640839647000	24421	12075	95	0	\N
353158	1678	26640839648000	24421	12075	96	0	\N
353159	1678	26640839649000	24421	12075	97	0	\N
353160	1678	26640839650000	24421	12075	98	0	\N
353161	1678	26640839651000	24421	12075	99	0	\N
353162	1678	26640839652000	24421	12075	100	0	\N
353163	1678	26640839653000	24421	12075	101	0	\N
353164	1678	26640839654000	24421	12075	102	0	\N
353165	1678	26640839655000	24421	12075	103	0	\N
353166	1678	26640839656000	24421	12075	104	0	\N
353167	1678	26640839657000	24421	12075	105	0	\N
353168	975	507693347075084	24421	12075	107	0	\N
353169	1095	909782128041950	24421	12075	108	0	\N
353170	1215	613848130479398	24421	12075	109	0	\N
353171	1341	1710542395913461	24421	12075	110	0	\N
353172	1874	25760000	24421	12075	111	0	\N
353173	1874	25762000	24421	12075	112	0	\N
353174	1874	25764000	24421	12075	113	0	\N
353175	1874	25765000	24421	12075	114	0	\N
353176	1874	25767000	24421	12075	115	0	\N
353177	1874	25769000	24421	12075	116	0	\N
353178	1874	25771000	24421	12075	117	0	\N
353179	1874	25772000	24421	12075	118	0	\N
353180	1874	25773000	24421	12075	119	0	\N
353181	1874	25774000	24421	12075	120	0	\N
353182	1874	25775000	24421	12075	121	0	\N
353183	1874	25776000	24421	12075	122	0	\N
353184	1874	25778000	24421	12075	123	0	\N
353185	1874	25780000	24421	12075	124	0	\N
353186	1874	25782000	24421	12075	125	0	\N
353187	1678	26640839657000	24422	12146	0	0	\N
353188	1678	26640839658000	24422	12146	1	0	\N
353189	1678	26640839659000	24422	12146	2	0	\N
353190	1874	26183000	24422	12146	3	0	\N
353191	1874	26186000	24422	12146	4	0	\N
353192	1874	26189000	24422	12146	5	0	\N
353193	1874	26192000	24422	12146	6	0	\N
353208	1678	26640839663000	24425	12148	0	0	\N
353209	1874	26205000	24425	12148	1	0	\N
353212	1678	26640839663000	24427	12148	0	0	\N
353213	1874	26205000	24427	12148	1	0	\N
353214	1678	26640839664000	24428	12149	0	0	\N
353215	1874	26206000	24428	12149	1	0	\N
353216	1874	26209000	24428	12149	2	0	\N
353220	1678	26640839664000	24430	12149	0	0	\N
353221	1874	26206000	24430	12149	1	0	\N
353222	1874	26209000	24430	12149	2	0	\N
353223	1678	26640839664000	24431	12149	0	0	\N
353224	1874	26206000	24431	12149	1	0	\N
353225	1874	26209000	24431	12149	2	0	\N
353226	1678	26640839664000	24432	12149	0	0	\N
353227	1874	26206000	24432	12149	1	0	\N
353228	1874	26209000	24432	12149	2	0	\N
353238	1678	26640839666000	24437	12152	0	0	\N
353239	1678	26640839667000	24437	12152	1	0	\N
353240	1678	26640839668000	24437	12152	2	0	\N
353241	1874	26215000	24437	12152	3	0	\N
353242	1874	26216000	24437	12152	4	0	\N
353243	1874	26219000	24437	12152	5	0	\N
353244	1874	26222000	24437	12152	6	0	\N
353255	2003	2081960654821	24442	12154	0	0	\N
353256	1678	26640839670000	24442	12154	1	0	\N
353257	1678	26640839671000	24442	12154	2	0	\N
353258	1678	26640839672000	24442	12154	3	0	\N
353259	1874	26228000	24442	12154	4	0	\N
353260	1874	26231000	24442	12154	5	0	\N
353261	1874	26232000	24442	12154	6	0	\N
353262	1874	26235000	24442	12154	7	0	\N
353263	1678	26640839671000	24443	12155	0	0	\N
353264	1678	26640839672000	24443	12155	1	0	\N
353265	1874	26232000	24443	12155	2	0	\N
353266	1874	26235000	24443	12155	3	0	\N
353269	1678	26640839673000	24445	12157	0	0	\N
353270	1874	26238000	24445	12157	1	0	\N
353271	1292	1710568637751650	24446	12109	0	0	\N
353272	1046	909797465000000	24446	12109	1	0	\N
353273	1166	613858750000000	24446	12109	2	0	\N
353274	926	507702775000000	24446	12109	3	0	\N
353275	2003	2081960654821	24446	12109	4	0	\N
353276	975	507693347075084	24446	12109	5	0	\N
353277	1095	909782128041950	24446	12109	6	0	\N
353278	1215	613848130479398	24446	12109	7	0	\N
353279	1341	1710542395913461	24446	12109	8	0	\N
353287	1678	26640839675000	24449	12159	0	0	\N
353288	1678	26640839676000	24449	12159	1	0	\N
353289	1874	26245000	24449	12159	2	0	\N
353290	1874	26248000	24449	12159	3	0	\N
353291	1678	26640839675000	24450	12159	0	0	\N
353292	1678	26640839676000	24450	12159	1	0	\N
353293	1874	26245000	24450	12159	2	0	\N
353294	1874	26248000	24450	12159	3	0	\N
353295	1678	26640839675000	24451	12159	0	0	\N
353296	1678	26640839676000	24451	12159	1	0	\N
353297	1874	26245000	24451	12159	2	0	\N
353298	1874	26248000	24451	12159	3	0	\N
353299	1678	26640839677000	24452	12160	0	0	\N
353300	1874	26251000	24452	12160	1	0	\N
353301	1874	26252000	24452	12160	2	0	\N
353311	1678	26640839680000	24456	12162	0	0	\N
353312	1874	26256000	24456	12162	1	0	\N
353313	1874	26259000	24456	12162	2	0	\N
353318	1678	26640839681000	24458	12163	0	0	\N
353319	1678	26640839682000	24458	12163	1	0	\N
353320	1874	26262000	24458	12163	2	0	\N
353321	1874	26265000	24458	12163	3	0	\N
353322	1678	26640839681000	24459	12163	0	0	\N
353323	1678	26640839682000	24459	12163	1	0	\N
353324	1874	26262000	24459	12163	2	0	\N
353325	1874	26265000	24459	12163	3	0	\N
353328	1678	26640839683000	24461	12164	0	0	\N
353196	1678	26640839659000	24423	12146	2	0	0
353197	1874	26183000	24423	12146	3	0	2
353198	1874	26186000	24423	12146	4	0	2
353199	1874	26189000	24423	12146	5	0	2
353200	1874	26192000	24423	12146	6	0	2
353202	1678	26640839661000	24424	12147	1	0	0
353203	1678	26640839662000	24424	12147	2	0	0
353204	1874	26193000	24424	12147	3	0	2
353205	1874	26196000	24424	12147	4	0	2
353206	1874	26199000	24424	12147	5	0	2
353210	1678	26640839663000	24426	12148	0	0	0
353211	1874	26205000	24426	12148	1	0	2
353217	1678	26640839664000	24429	12149	0	0	0
353218	1874	26206000	24429	12149	1	0	2
353229	1678	26640839665000	24433	12150	0	0	0
353230	1874	26212000	24433	12150	1	0	2
353231	1678	26640839666000	24436	12152	0	0	0
353232	1678	26640839667000	24436	12152	1	0	0
353233	1678	26640839668000	24436	12152	2	0	0
353235	1874	26216000	24436	12152	4	0	2
353236	1874	26219000	24436	12152	5	0	2
353237	1874	26222000	24436	12152	6	0	2
353245	1678	26640839669000	24438	12153	0	0	0
353246	1874	26225000	24438	12153	1	0	2
353248	1678	26640839670000	24439	12154	1	0	0
353249	1874	26228000	24439	12154	2	0	2
353250	1874	26229000	24439	12154	3	0	2
353251	1678	26640839671000	24440	12155	0	0	0
353253	1678	26640839672000	24441	12156	0	0	0
353254	1874	26235000	24441	12156	1	0	2
353267	1678	26640839673000	24444	12157	0	0	0
353268	1874	26238000	24444	12157	1	0	2
353280	1678	26640839674000	24447	12158	0	0	0
353282	1874	26242000	24447	12158	2	0	2
353283	1678	26640839675000	24448	12159	0	0	0
353284	1678	26640839676000	24448	12159	1	0	0
353285	1874	26245000	24448	12159	2	0	2
353286	1874	26248000	24448	12159	3	0	2
353303	1874	26251000	24453	12160	1	0	2
353304	1874	26252000	24453	12160	2	0	2
353305	1678	26640839678000	24454	12161	0	0	0
353306	1678	26640839679000	24454	12161	1	0	0
353308	1678	26640839680000	24455	12162	0	0	0
353309	1874	26256000	24455	12162	1	0	2
353310	1874	26259000	24455	12162	2	0	2
353314	1678	26640839681000	24457	12163	0	0	0
353315	1678	26640839682000	24457	12163	1	0	0
353317	1874	26265000	24457	12163	3	0	2
353326	1678	26640839683000	24460	12164	0	0	0
353327	1874	26268000	24460	12164	1	0	2
353329	1874	26268000	24461	12164	1	0	\N
353348	1678	26640839690000	24466	12168	0	0	\N
353349	1874	26289000	24466	12168	1	0	\N
353350	1874	26292000	24466	12168	2	0	\N
353354	1678	26640839690000	24468	12168	0	0	\N
353355	1874	26289000	24468	12168	1	0	\N
353356	1874	26292000	24468	12168	2	0	\N
353357	1678	26640839690000	24469	12168	0	0	\N
353358	1874	26289000	24469	12168	1	0	\N
353359	1678	26640839691000	24470	12169	0	0	\N
353360	1874	26295000	24470	12169	1	0	\N
353367	1678	26640839692000	24473	12170	0	0	\N
353368	1678	26640839693000	24473	12170	1	0	\N
353369	1678	26640839692000	24475	12170	0	0	\N
353370	1678	26640839693000	24475	12170	1	0	\N
353371	1874	26298000	24475	12170	2	0	\N
353372	1874	26301000	24475	12170	3	0	\N
353373	1678	26640839692000	24476	12170	0	0	\N
353374	1678	26640839693000	24476	12170	1	0	\N
353375	1874	26298000	24476	12170	2	0	\N
353376	1874	26301000	24476	12170	3	0	\N
353380	1678	26640839695000	24478	12172	0	0	\N
353381	1874	26308000	24478	12172	1	0	\N
353409	1678	26640839705000	24490	12179	0	0	\N
353410	1678	26640839706000	24490	12179	1	0	\N
353411	1874	26341000	24490	12179	2	0	\N
353412	1874	26344000	24490	12179	3	0	\N
353415	1678	26640839707000	24492	12180	0	0	\N
353416	1874	26345000	24492	12180	1	0	\N
353417	1874	26348000	24492	12180	2	0	\N
353418	1678	26640839708000	24493	12181	0	0	\N
353419	1874	26348000	24493	12181	1	0	\N
353420	1874	26351000	24493	12181	2	0	\N
353425	1678	26640839709000	24496	12182	0	0	\N
353426	1874	26354000	24496	12182	1	0	\N
353427	1678	26640839710000	24497	12183	0	0	\N
353428	1678	26640839711000	24497	12183	1	0	\N
353429	1874	26354000	24497	12183	2	0	\N
353430	1874	26357000	24497	12183	3	0	\N
353431	1874	26360000	24497	12183	4	0	\N
353432	1874	26361000	24497	12183	5	0	\N
353446	1292	1710568637751650	24502	12028	0	0	\N
353447	1046	909797465000000	24502	12028	1	0	\N
353448	1166	613858750000000	24502	12028	2	0	\N
353449	926	507702775000000	24502	12028	3	0	\N
353450	1388	1715855704351650	24502	12028	4	0	\N
353451	2003	2081960654821	24502	12028	5	0	\N
353452	2312	0	24502	12028	6	0	\N
353453	2312	1000000000	24502	12028	7	0	\N
353454	1007	506698773004376	24502	12028	8	0	\N
353455	1142	912608755600000	24502	12028	9	0	\N
353456	1262	615754826200000	24502	12028	10	0	\N
353457	1022	509273064000000	24502	12028	11	0	\N
353458	1678	26640839495000	24502	12028	12	0	\N
353459	1678	26640839496000	24502	12028	13	0	\N
353460	1678	26640839497000	24502	12028	14	0	\N
353461	1678	26640839498000	24502	12028	15	0	\N
353462	1678	26640839499000	24502	12028	16	0	\N
353463	1678	26640839500000	24502	12028	17	0	\N
353464	169	66586284844974	24502	12028	18	0	\N
353332	1874	26272000	24463	12165	2	0	2
353333	1678	26640839685000	24464	12166	0	0	0
353334	1678	26640839686000	24464	12166	1	0	0
353335	1678	26640839687000	24464	12166	2	0	0
353336	1874	26275000	24464	12166	3	0	2
353338	1874	26281000	24464	12166	5	0	2
353339	1874	26282000	24464	12166	6	0	2
353340	1388	1715855704351650	24465	12167	0	0	0
353341	1142	912608755600000	24465	12167	1	0	0
353342	1262	615754826200000	24465	12167	2	0	0
353344	1678	26640839688000	24465	12167	4	0	0
353345	1678	26640839689000	24465	12167	5	0	0
353346	1874	26285000	24465	12167	6	0	2
353347	1874	26288000	24465	12167	7	0	2
353352	1874	26289000	24467	12168	1	0	2
353353	1874	26292000	24467	12168	2	0	2
353361	1678	26640839691000	24471	12169	0	0	0
353362	1874	26295000	24471	12169	1	0	2
353363	1678	26640839692000	24472	12170	0	0	0
353365	1874	26298000	24472	12170	2	0	2
353366	1874	26301000	24472	12170	3	0	2
353377	1678	26640839694000	24477	12171	0	0	0
353378	1874	26304000	24477	12171	1	0	2
353379	1874	26305000	24477	12171	2	0	2
353383	1874	26308000	24479	12172	1	0	2
353384	1678	26640839696000	24481	12173	0	0	0
353385	1678	26640839697000	24481	12173	1	0	0
353386	1874	26309000	24481	12173	2	0	2
353388	1874	26315000	24481	12173	4	0	2
353389	1678	26640839698000	24484	12174	0	0	0
353390	1874	26318000	24484	12174	1	0	2
353391	1678	26640839699000	24485	12175	0	0	0
353392	1874	26321000	24485	12175	2	0	2
353394	1678	26640839701000	24486	12176	1	0	0
353395	1874	26322000	24486	12176	2	0	2
353396	1874	26325000	24486	12176	3	0	2
353397	1874	26328000	24486	12176	4	0	2
353398	1678	26640839702000	24487	12177	0	0	0
353400	1874	26331000	24487	12177	2	0	2
353401	1874	26334000	24487	12177	3	0	2
353402	1678	26640839704000	24488	12178	0	0	0
353403	1874	26335000	24488	12178	1	0	2
353405	1678	26640839705000	24489	12179	0	0	0
353406	1678	26640839706000	24489	12179	1	0	0
353407	1874	26341000	24489	12179	2	0	2
353408	1874	26344000	24489	12179	3	0	2
353413	1678	26640839707000	24491	12180	0	0	0
353421	1678	26640839708000	24494	12181	0	0	0
353422	1874	26348000	24494	12181	1	0	2
353423	1874	26351000	24494	12181	2	0	2
353424	1678	26640839709000	24495	12182	0	0	0
353433	1678	26640839710000	24498	12183	0	0	0
353435	1874	26354000	24498	12183	2	0	2
353436	1874	26357000	24498	12183	3	0	2
353437	1874	26360000	24498	12183	4	0	2
353438	1874	26361000	24498	12183	5	0	2
353440	1874	26364000	24499	12184	1	0	2
353441	1678	26640839713000	24500	12185	0	0	0
353442	1874	26367000	24500	12185	1	0	2
353443	1678	26640839714000	24501	12186	0	0	0
353444	1874	26370000	24501	12186	1	0	2
353465	990	507245623196952	24502	12028	19	0	\N
353466	1110	908979810688432	24502	12028	20	0	\N
353467	1230	613306790973693	24502	12028	21	0	\N
353468	1356	1709033905247518	24502	12028	22	0	\N
353469	1678	26640839501000	24502	12028	23	0	\N
353470	1678	26640839502000	24502	12028	24	0	\N
353471	1678	26640839503000	24502	12028	25	0	\N
353472	1678	26640839504000	24502	12028	26	0	\N
353473	1678	26640839505000	24502	12028	27	0	\N
353474	1678	26640839506000	24502	12028	28	0	\N
353475	1678	26640839507000	24502	12028	29	0	\N
353476	1678	26640839508000	24502	12028	30	0	\N
353477	1678	26640839509000	24502	12028	31	0	\N
353478	1678	26640839510000	24502	12028	32	0	\N
353479	1678	26640839511000	24502	12028	33	0	\N
353480	1678	26640839512000	24502	12028	34	0	\N
353481	1678	26640839513000	24502	12028	35	0	\N
353482	1678	26640839514000	24502	12028	36	0	\N
353483	1678	26640839515000	24502	12028	37	0	\N
353484	1678	26640839516000	24502	12028	38	0	\N
353485	1678	26640839517000	24502	12028	39	0	\N
353486	1678	26640839518000	24502	12028	40	0	\N
353487	1678	26640839519000	24502	12028	41	0	\N
353488	1678	26640839520000	24502	12028	42	0	\N
353489	1678	26640839521000	24502	12028	43	0	\N
353490	1678	26640839522000	24502	12028	44	0	\N
353491	1678	26640839523000	24502	12028	45	0	\N
353492	1678	26640839524000	24502	12028	46	0	\N
353493	1678	26640839525000	24502	12028	47	0	\N
353494	1678	26640839526000	24502	12028	48	0	\N
353495	1678	26640839527000	24502	12028	49	0	\N
353496	1678	26640839528000	24502	12028	50	0	\N
353497	1678	26640839529000	24502	12028	51	0	\N
353498	1678	26640839530000	24502	12028	52	0	\N
353499	1678	26640839531000	24502	12028	53	0	\N
353500	1678	26640839532000	24502	12028	54	0	\N
353501	1678	26640839533000	24502	12028	55	0	\N
353502	1678	26640839534000	24502	12028	56	0	\N
353503	1678	26640839535000	24502	12028	57	0	\N
353504	1678	26640839536000	24502	12028	58	0	\N
353505	1678	26640839537000	24502	12028	59	0	\N
353506	1678	26640839538000	24502	12028	60	0	\N
353507	1678	26640839539000	24502	12028	61	0	\N
353508	1678	26640839540000	24502	12028	62	0	\N
353509	1678	26640839541000	24502	12028	63	0	\N
353510	1678	26640839542000	24502	12028	64	0	\N
353511	1678	26640839543000	24502	12028	65	0	\N
353512	1678	26640839544000	24502	12028	66	0	\N
353513	1678	26640839545000	24502	12028	67	0	\N
353514	1678	26640839546000	24502	12028	68	0	\N
353515	1678	26640839547000	24502	12028	69	0	\N
353516	1678	26640839548000	24502	12028	70	0	\N
353517	1678	26640839549000	24502	12028	71	0	\N
353518	1678	26640839550000	24502	12028	72	0	\N
353519	1678	26640839551000	24502	12028	73	0	\N
353520	1678	26640839552000	24502	12028	74	0	\N
353521	1678	26640839553000	24502	12028	75	0	\N
353522	1678	26640839554000	24502	12028	76	0	\N
353523	1678	26640839555000	24502	12028	77	0	\N
353524	1678	26640839556000	24502	12028	78	0	\N
353525	1678	26640839557000	24502	12028	79	0	\N
353526	1678	26640839558000	24502	12028	80	0	\N
353527	1678	26640839559000	24502	12028	81	0	\N
353528	1678	26640839560000	24502	12028	82	0	\N
353529	1678	26640839561000	24502	12028	83	0	\N
353530	1678	26640839562000	24502	12028	84	0	\N
353531	1678	26640839563000	24502	12028	85	0	\N
353532	1678	26640839564000	24502	12028	86	0	\N
353533	1678	26640839565000	24502	12028	87	0	\N
353534	1678	26640839566000	24502	12028	88	0	\N
353535	1678	26640839567000	24502	12028	89	0	\N
353536	1678	26640839568000	24502	12028	90	0	\N
353537	1678	26640839569000	24502	12028	91	0	\N
353538	1678	26640839570000	24502	12028	92	0	\N
353539	1678	26640839571000	24502	12028	93	0	\N
353540	1678	26640839572000	24502	12028	94	0	\N
353541	1678	26640839573000	24502	12028	95	0	\N
353542	1678	26640839574000	24502	12028	96	0	\N
353543	1678	26640839575000	24502	12028	97	0	\N
353544	1678	26640839576000	24502	12028	98	0	\N
353545	1678	26640839577000	24502	12028	99	0	\N
353546	1678	26640839578000	24502	12028	100	0	\N
353547	1678	26640839579000	24502	12028	101	0	\N
353548	1678	26640839580000	24502	12028	102	0	\N
353549	1678	26640839581000	24502	12028	103	0	\N
353550	1678	26640839582000	24502	12028	104	0	\N
353551	1678	26640839583000	24502	12028	105	0	\N
353552	1678	26640839584000	24502	12028	106	0	\N
353553	1678	26640839585000	24502	12028	107	0	\N
353554	1678	26640839586000	24502	12028	108	0	\N
353555	1678	26640839587000	24502	12028	109	0	\N
353556	1678	26640839588000	24502	12028	110	0	\N
353557	1678	26640839589000	24502	12028	111	0	\N
353558	1678	26640839590000	24502	12028	112	0	\N
353559	1678	26640839591000	24502	12028	113	0	\N
353560	1678	26640839592000	24502	12028	114	0	\N
353561	1678	26640839593000	24502	12028	115	0	\N
353562	1678	26640839594000	24502	12028	116	0	\N
353563	1678	26640839595000	24502	12028	118	0	\N
353564	1678	26640839596000	24502	12028	119	0	\N
353565	1678	26640839597000	24502	12028	120	0	\N
353566	1678	26640839598000	24502	12028	121	0	\N
353567	1678	26640839599000	24502	12028	122	0	\N
353568	1678	26640839600000	24502	12028	123	0	\N
353569	1678	26640839601000	24502	12028	124	0	\N
353570	1678	26640839602000	24502	12028	125	0	\N
353573	1678	26640839716000	24504	12188	0	0	\N
353574	1874	26377000	24504	12188	1	0	\N
353582	1678	26640839719000	24508	12190	0	0	\N
353583	1874	26387000	24508	12190	1	0	\N
353584	1678	26640839719000	24509	12190	0	0	\N
353585	1874	26387000	24509	12190	1	0	\N
353586	1678	26640839719000	24510	12190	0	0	\N
353587	1874	26387000	24510	12190	1	0	\N
353595	1678	26640839720000	24513	12191	0	0	\N
353596	1678	26640839721000	24513	12191	1	0	\N
353597	1874	26388000	24513	12191	2	0	\N
353598	1874	26391000	24513	12191	3	0	\N
353599	1874	26394000	24513	12191	4	0	\N
353600	1292	1710568637751650	24514	12096	0	0	\N
353575	1678	26640839716000	24506	12188	0	0	0
353576	1874	26377000	24506	12188	1	0	2
353577	1678	26640839717000	24507	12189	0	0	0
353578	1678	26640839718000	24507	12189	1	0	0
353579	1874	26380000	24507	12189	2	0	2
353581	1874	26384000	24507	12189	4	0	2
353588	1678	26640839719000	24511	12190	0	0	0
353589	1874	26387000	24511	12190	1	0	2
353590	1678	26640839720000	24512	12191	0	0	0
353591	1678	26640839721000	24512	12191	1	0	0
353593	1874	26391000	24512	12191	3	0	2
353594	1874	26394000	24512	12191	4	0	2
353601	1046	909797465000000	24514	12096	1	0	\N
353602	1166	613858750000000	24514	12096	2	0	\N
353603	926	507702775000000	24514	12096	3	0	\N
353604	1388	1715855704351650	24514	12096	4	0	\N
353605	2003	2081960654821	24514	12096	5	0	\N
353606	1678	26640839593000	24514	12096	6	0	\N
353607	1007	506698773004376	24514	12096	7	0	\N
353608	1142	912608755600000	24514	12096	8	0	\N
353609	1262	615754826200000	24514	12096	9	0	\N
353610	1022	509273064000000	24514	12096	10	0	\N
353611	1678	26640839594000	24514	12096	11	0	\N
353612	1678	26640839595000	24514	12096	12	0	\N
353613	1678	26640839596000	24514	12096	13	0	\N
353614	1678	26640839597000	24514	12096	14	0	\N
353615	1678	26640839598000	24514	12096	15	0	\N
353616	1678	26640839599000	24514	12096	16	0	\N
353617	1678	26640839600000	24514	12096	17	0	\N
353618	1678	26640839601000	24514	12096	18	0	\N
353619	1678	26640839602000	24514	12096	19	0	\N
353620	1678	26640839603000	24514	12096	20	0	\N
353621	1678	26640839604000	24514	12096	21	0	\N
353622	1678	26640839605000	24514	12096	22	0	\N
353623	1678	26640839606000	24514	12096	23	0	\N
353624	1678	26640839607000	24514	12096	24	0	\N
353625	1678	26640839608000	24514	12096	25	0	\N
353626	1678	26640839609000	24514	12096	26	0	\N
353627	1678	26640839610000	24514	12096	27	0	\N
353628	1678	26640839611000	24514	12096	28	0	\N
353629	1678	26640839612000	24514	12096	29	0	\N
353630	1678	26640839613000	24514	12096	30	0	\N
353631	1678	26640839614000	24514	12096	31	0	\N
353632	1678	26640839615000	24514	12096	32	0	\N
353633	1678	26640839616000	24514	12096	33	0	\N
353634	1678	26640839617000	24514	12096	34	0	\N
353635	1678	26640839618000	24514	12096	35	0	\N
353636	1678	26640839619000	24514	12096	36	0	\N
353637	1678	26640839620000	24514	12096	37	0	\N
353638	1678	26640839621000	24514	12096	38	0	\N
353639	1678	26640839622000	24514	12096	39	0	\N
353640	1678	26640839623000	24514	12096	40	0	\N
353641	1678	26640839624000	24514	12096	41	0	\N
353642	1678	26640839625000	24514	12096	42	0	\N
353643	1678	26640839626000	24514	12096	43	0	\N
353644	1678	26640839627000	24514	12096	44	0	\N
353645	1678	26640839628000	24514	12096	45	0	\N
353646	1678	26640839629000	24514	12096	46	0	\N
353647	1678	26640839630000	24514	12096	47	0	\N
353648	1678	26640839631000	24514	12096	48	0	\N
353649	1678	26640839632000	24514	12096	49	0	\N
353650	1678	26640839633000	24514	12096	50	0	\N
353651	1678	26640839634000	24514	12096	51	0	\N
353652	1678	26640839635000	24514	12096	52	0	\N
353653	1678	26640839636000	24514	12096	53	0	\N
353654	1678	26640839637000	24514	12096	55	0	\N
353655	1678	26640839638000	24514	12096	56	0	\N
353656	1678	26640839639000	24514	12096	57	0	\N
353657	1678	26640839640000	24514	12096	58	0	\N
353658	1678	26640839641000	24514	12096	59	0	\N
353659	1678	26640839642000	24514	12096	60	0	\N
353660	1678	26640839643000	24514	12096	61	0	\N
353661	1678	26640839644000	24514	12096	62	0	\N
353662	1678	26640839645000	24514	12096	63	0	\N
353663	1678	26640839646000	24514	12096	64	0	\N
353664	1678	26640839647000	24514	12096	65	0	\N
353665	1678	26640839648000	24514	12096	66	0	\N
353666	1678	26640839649000	24514	12096	67	0	\N
353667	1678	26640839650000	24514	12096	68	0	\N
353668	1678	26640839651000	24514	12096	69	0	\N
353669	1678	26640839652000	24514	12096	70	0	\N
353670	1678	26640839653000	24514	12096	71	0	\N
353671	1678	26640839654000	24514	12096	72	0	\N
353672	1678	26640839655000	24514	12096	73	0	\N
353673	1678	26640839656000	24514	12096	74	0	\N
353674	1678	26640839657000	24514	12096	75	0	\N
353675	1678	26640839658000	24514	12096	76	0	\N
353676	1678	26640839659000	24514	12096	77	0	\N
353677	1678	26640839660000	24514	12096	78	0	\N
353678	1678	26640839661000	24514	12096	79	0	\N
353679	1678	26640839662000	24514	12096	80	0	\N
353680	1678	26640839663000	24514	12096	81	0	\N
353681	1678	26640839664000	24514	12096	82	0	\N
353682	1678	26640839665000	24514	12096	83	0	\N
353683	1678	26640839666000	24514	12096	84	0	\N
353684	1678	26640839667000	24514	12096	85	0	\N
353685	1678	26640839668000	24514	12096	86	0	\N
353686	1678	26640839669000	24514	12096	87	0	\N
353687	1678	26640839670000	24514	12096	88	0	\N
353688	1678	26640839671000	24514	12096	89	0	\N
353689	1678	26640839672000	24514	12096	90	0	\N
353690	1678	26640839673000	24514	12096	91	0	\N
353691	1678	26640839674000	24514	12096	92	0	\N
353692	1678	26640839675000	24514	12096	93	0	\N
353693	1678	26640839676000	24514	12096	94	0	\N
353694	1678	26640839677000	24514	12096	95	0	\N
353695	1678	26640839678000	24514	12096	96	0	\N
353696	1678	26640839679000	24514	12096	97	0	\N
353697	1678	26640839680000	24514	12096	98	0	\N
353698	1678	26640839681000	24514	12096	99	0	\N
353699	1678	26640839682000	24514	12096	100	0	\N
353700	1678	26640839683000	24514	12096	101	0	\N
353701	1678	26640839684000	24514	12096	102	0	\N
353702	1678	26640839685000	24514	12096	103	0	\N
353703	1678	26640839686000	24514	12096	104	0	\N
353704	1678	26640839687000	24514	12096	105	0	\N
353705	1678	26640839688000	24514	12096	106	0	\N
353706	1678	26640839689000	24514	12096	107	0	\N
353707	1678	26640839690000	24514	12096	108	0	\N
353708	1678	26640839691000	24514	12096	109	0	\N
353709	1678	26640839692000	24514	12096	110	0	\N
353710	1678	26640839693000	24514	12096	111	0	\N
353711	1678	26640839694000	24514	12096	112	0	\N
353712	1678	26640839695000	24514	12096	113	0	\N
353713	1678	26640839696000	24514	12096	114	0	\N
353714	1678	26640839697000	24514	12096	115	0	\N
353715	1678	26640839698000	24514	12096	116	0	\N
353716	1678	26640839699000	24514	12096	117	0	\N
353717	1678	26640839700000	24514	12096	118	0	\N
353718	1678	26640839701000	24514	12096	119	0	\N
353719	1678	26640839702000	24514	12096	120	0	\N
353720	1678	26640839703000	24514	12096	121	0	\N
353721	1678	26640839704000	24514	12096	122	0	\N
353722	1678	26640839705000	24514	12096	123	0	\N
353723	1678	26640839706000	24514	12096	124	0	\N
353724	1678	26640839707000	24514	12096	125	0	\N
353725	1678	26640839722000	24515	12192	0	0	\N
353726	1678	26640839723000	24515	12192	1	0	\N
353727	1678	26640839724000	24515	12192	2	0	\N
353728	1874	26395000	24515	12192	3	0	\N
353729	1874	26398000	24515	12192	4	0	\N
353730	1874	26401000	24515	12192	5	0	\N
353731	1874	26404000	24515	12192	6	0	\N
353734	1678	26640839724000	24516	12192	2	0	0
353735	1874	26395000	24516	12192	3	0	2
353736	1874	26398000	24516	12192	4	0	2
353739	1292	1710568637751650	24517	11919	0	0	\N
353740	1046	909797465000000	24517	11919	1	0	\N
353741	1166	613858750000000	24517	11919	2	0	\N
353742	926	507702775000000	24517	11919	3	0	\N
353743	1388	1715855704351650	24517	11919	4	0	\N
353744	2003	2081960654821	24517	11919	5	0	\N
353745	2312	0	24517	11919	6	0	\N
353746	2312	1000000000	24517	11919	7	0	\N
353747	1007	506698773004376	24517	11919	8	0	\N
353748	1142	912608755600000	24517	11919	9	0	\N
353749	1262	615754826200000	24517	11919	10	0	\N
353750	1022	509273064000000	24517	11919	11	0	\N
353751	169	66586284844974	24517	11919	12	0	\N
353752	990	507245623196952	24517	11919	13	0	\N
353753	1110	908979810688432	24517	11919	14	0	\N
353754	1230	613306790973693	24517	11919	15	0	\N
353755	1356	1709033905247518	24517	11919	16	0	\N
353756	2310	1000000000	24517	11919	18	0	\N
353757	975	507693347075084	24517	11919	19	0	\N
353758	1095	909782128041950	24517	11919	20	0	\N
353759	1215	613848130479398	24517	11919	21	0	\N
353760	1341	1710542395913461	24517	11919	22	0	\N
353761	1874	24909000	24517	11919	23	0	\N
353762	1874	24910000	24517	11919	24	0	\N
353763	1874	24911000	24517	11919	25	0	\N
353764	1874	24912000	24517	11919	26	0	\N
353765	1874	24913000	24517	11919	27	0	\N
353766	1874	24914000	24517	11919	28	0	\N
353767	1874	24915000	24517	11919	29	0	\N
353768	1678	26640839725000	24518	12193	0	0	\N
353769	1874	26407000	24518	12193	1	0	\N
353770	1678	26640839725000	24519	12193	0	0	\N
353771	1874	26407000	24519	12193	1	0	\N
353772	1678	26640839725000	24520	12193	0	0	\N
353773	1874	26407000	24520	12193	1	0	\N
353774	1678	26640839725000	24521	12193	0	0	\N
353775	1874	26407000	24521	12193	1	0	\N
353776	1678	26640839725000	24522	12193	0	0	\N
353777	1874	26407000	24522	12193	1	0	\N
353778	1678	26640839725000	24523	12193	0	0	\N
353779	1874	26407000	24523	12193	1	0	\N
353782	1292	1710568637751650	24525	12082	0	0	\N
353783	1046	909797465000000	24525	12082	1	0	\N
353784	1166	613858750000000	24525	12082	2	0	\N
353785	926	507702775000000	24525	12082	3	0	\N
353786	1388	1715855704351650	24525	12082	4	0	\N
353787	2003	2081960654821	24525	12082	5	0	\N
353788	1007	506698773004376	24525	12082	6	0	\N
353789	1142	912608755600000	24525	12082	7	0	\N
353790	1262	615754826200000	24525	12082	8	0	\N
353791	1022	509273064000000	24525	12082	9	0	\N
353792	1678	26640839567000	24525	12082	10	0	\N
353793	1678	26640839568000	24525	12082	11	0	\N
353794	1678	26640839569000	24525	12082	12	0	\N
353795	1678	26640839570000	24525	12082	13	0	\N
353796	1678	26640839571000	24525	12082	14	0	\N
353797	1678	26640839572000	24525	12082	15	0	\N
353798	1678	26640839573000	24525	12082	16	0	\N
353799	1678	26640839574000	24525	12082	17	0	\N
353800	1678	26640839575000	24525	12082	18	0	\N
353801	1678	26640839576000	24525	12082	19	0	\N
353802	1678	26640839577000	24525	12082	20	0	\N
353803	1678	26640839578000	24525	12082	21	0	\N
353804	1678	26640839579000	24525	12082	22	0	\N
353805	1678	26640839580000	24525	12082	23	0	\N
353806	1678	26640839581000	24525	12082	24	0	\N
353807	1678	26640839582000	24525	12082	25	0	\N
353808	1678	26640839583000	24525	12082	26	0	\N
353809	1678	26640839584000	24525	12082	27	0	\N
353810	1678	26640839585000	24525	12082	28	0	\N
353811	1678	26640839586000	24525	12082	29	0	\N
353812	1678	26640839587000	24525	12082	30	0	\N
353813	1678	26640839588000	24525	12082	31	0	\N
353814	1678	26640839589000	24525	12082	32	0	\N
353815	1678	26640839590000	24525	12082	33	0	\N
353816	1678	26640839591000	24525	12082	34	0	\N
353817	1678	26640839592000	24525	12082	35	0	\N
353818	1678	26640839593000	24525	12082	36	0	\N
353819	1678	26640839594000	24525	12082	37	0	\N
353820	1678	26640839595000	24525	12082	38	0	\N
353821	1678	26640839596000	24525	12082	40	0	\N
353822	1678	26640839597000	24525	12082	41	0	\N
353823	1678	26640839598000	24525	12082	42	0	\N
353824	1678	26640839599000	24525	12082	43	0	\N
353825	1678	26640839600000	24525	12082	44	0	\N
353826	1678	26640839601000	24525	12082	45	0	\N
353827	1678	26640839602000	24525	12082	46	0	\N
353828	1678	26640839603000	24525	12082	47	0	\N
353829	1678	26640839604000	24525	12082	48	0	\N
353830	1678	26640839605000	24525	12082	49	0	\N
353831	1678	26640839606000	24525	12082	50	0	\N
353832	1678	26640839607000	24525	12082	51	0	\N
353833	1678	26640839608000	24525	12082	52	0	\N
353834	1678	26640839609000	24525	12082	53	0	\N
353835	1678	26640839610000	24525	12082	54	0	\N
353836	1678	26640839611000	24525	12082	55	0	\N
353837	1678	26640839612000	24525	12082	56	0	\N
353838	1678	26640839613000	24525	12082	57	0	\N
353839	1678	26640839614000	24525	12082	58	0	\N
353840	1678	26640839615000	24525	12082	59	0	\N
353841	1678	26640839616000	24525	12082	60	0	\N
353842	1678	26640839617000	24525	12082	61	0	\N
353843	1678	26640839618000	24525	12082	62	0	\N
353844	1678	26640839619000	24525	12082	63	0	\N
353845	1678	26640839620000	24525	12082	64	0	\N
353846	1678	26640839621000	24525	12082	65	0	\N
353847	1678	26640839622000	24525	12082	66	0	\N
353848	1678	26640839623000	24525	12082	67	0	\N
353849	1678	26640839624000	24525	12082	68	0	\N
353850	1678	26640839625000	24525	12082	69	0	\N
353851	1678	26640839626000	24525	12082	70	0	\N
353852	1678	26640839627000	24525	12082	71	0	\N
353853	1678	26640839628000	24525	12082	72	0	\N
353854	1678	26640839629000	24525	12082	73	0	\N
353855	1678	26640839630000	24525	12082	74	0	\N
353856	1678	26640839631000	24525	12082	75	0	\N
353857	1678	26640839632000	24525	12082	76	0	\N
353858	1678	26640839633000	24525	12082	77	0	\N
353859	1678	26640839634000	24525	12082	78	0	\N
353860	1678	26640839635000	24525	12082	79	0	\N
353861	1678	26640839636000	24525	12082	80	0	\N
353862	1678	26640839637000	24525	12082	81	0	\N
353863	1678	26640839638000	24525	12082	82	0	\N
353864	1678	26640839639000	24525	12082	83	0	\N
353865	1678	26640839640000	24525	12082	84	0	\N
353866	1678	26640839641000	24525	12082	85	0	\N
353867	1678	26640839642000	24525	12082	86	0	\N
353868	1678	26640839643000	24525	12082	87	0	\N
353869	1678	26640839644000	24525	12082	88	0	\N
353870	1678	26640839645000	24525	12082	89	0	\N
353871	1678	26640839646000	24525	12082	90	0	\N
353872	1678	26640839647000	24525	12082	91	0	\N
353780	1678	26640839725000	24524	12193	0	0	0
353781	1874	26407000	24524	12193	1	0	2
353873	1678	26640839648000	24525	12082	92	0	\N
353874	1678	26640839649000	24525	12082	93	0	\N
353875	1678	26640839650000	24525	12082	94	0	\N
353876	1678	26640839651000	24525	12082	95	0	\N
353877	1678	26640839652000	24525	12082	96	0	\N
353878	1678	26640839653000	24525	12082	97	0	\N
353879	1678	26640839654000	24525	12082	98	0	\N
353880	1678	26640839655000	24525	12082	99	0	\N
353881	1678	26640839656000	24525	12082	100	0	\N
353882	1678	26640839657000	24525	12082	101	0	\N
353883	1678	26640839658000	24525	12082	102	0	\N
353884	1678	26640839659000	24525	12082	103	0	\N
353885	1678	26640839660000	24525	12082	104	0	\N
353886	1678	26640839661000	24525	12082	105	0	\N
353887	1678	26640839662000	24525	12082	106	0	\N
353888	1678	26640839663000	24525	12082	107	0	\N
353889	1678	26640839664000	24525	12082	108	0	\N
353890	1678	26640839665000	24525	12082	109	0	\N
353891	1678	26640839666000	24525	12082	110	0	\N
353892	1678	26640839667000	24525	12082	111	0	\N
353893	1678	26640839668000	24525	12082	112	0	\N
353894	1678	26640839669000	24525	12082	113	0	\N
353895	1678	26640839670000	24525	12082	114	0	\N
353896	1678	26640839671000	24525	12082	115	0	\N
353897	1678	26640839672000	24525	12082	116	0	\N
353898	1678	26640839673000	24525	12082	117	0	\N
353899	1678	26640839674000	24525	12082	118	0	\N
353900	1678	26640839675000	24525	12082	119	0	\N
353901	1678	26640839676000	24525	12082	120	0	\N
353902	1678	26640839677000	24525	12082	121	0	\N
353903	1678	26640839678000	24525	12082	122	0	\N
353904	1678	26640839679000	24525	12082	123	0	\N
353905	1678	26640839680000	24525	12082	124	0	\N
353906	1678	26640839681000	24525	12082	125	0	\N
353907	1678	26640839725000	24526	12193	0	0	\N
353908	1874	26407000	24526	12193	1	0	\N
353909	1388	1715855704351650	24527	12156	0	0	\N
353910	1142	912608755600000	24527	12156	1	0	\N
353911	1262	615754826200000	24527	12156	2	0	\N
353912	1022	509273064000000	24527	12156	3	0	\N
353913	1678	26640839672000	24527	12156	4	0	\N
353914	1678	26640839673000	24527	12156	5	0	\N
353915	1678	26640839674000	24527	12156	6	0	\N
353916	1678	26640839675000	24527	12156	7	0	\N
353917	1678	26640839676000	24527	12156	8	0	\N
353918	1678	26640839677000	24527	12156	9	0	\N
353919	1874	26233000	24527	12156	10	0	\N
353920	1874	26234000	24527	12156	11	0	\N
353921	1874	26235000	24527	12156	12	0	\N
353922	1874	26236000	24527	12156	13	0	\N
353923	1874	26239000	24527	12156	14	0	\N
353924	1874	26242000	24527	12156	15	0	\N
353925	1874	26245000	24527	12156	16	0	\N
353926	1874	26248000	24527	12156	17	0	\N
353927	1874	26249000	24527	12156	18	0	\N
353928	1874	26250000	24527	12156	19	0	\N
353929	1874	26251000	24527	12156	20	0	\N
353930	1874	26252000	24527	12156	21	0	\N
353931	1874	26253000	24527	12156	22	0	\N
353932	1874	26254000	24527	12156	23	0	\N
353933	1874	26255000	24527	12156	24	0	\N
353934	1874	26256000	24527	12156	25	0	\N
353935	1874	26257000	24527	12156	26	0	\N
353936	1874	26258000	24527	12156	27	0	\N
353937	1874	26259000	24527	12156	28	0	\N
353938	1874	26260000	24527	12156	29	0	\N
353939	1874	26263000	24527	12156	30	0	\N
353940	1874	26266000	24527	12156	31	0	\N
353941	1874	26269000	24527	12156	32	0	\N
353942	1874	26272000	24527	12156	33	0	\N
353943	1874	26275000	24527	12156	34	0	\N
353944	1874	26278000	24527	12156	35	0	\N
353945	1874	26281000	24527	12156	36	0	\N
353946	1874	26284000	24527	12156	37	0	\N
353947	1874	26287000	24527	12156	38	0	\N
353948	1874	26290000	24527	12156	39	0	\N
353949	1874	26293000	24527	12156	40	0	\N
353950	1874	26296000	24527	12156	41	0	\N
353951	1874	26299000	24527	12156	42	0	\N
353952	1874	26302000	24527	12156	43	0	\N
353953	1874	26305000	24527	12156	44	0	\N
353954	1874	26308000	24527	12156	45	0	\N
353955	1874	26311000	24527	12156	46	0	\N
353956	1874	26314000	24527	12156	47	0	\N
353957	1874	26317000	24527	12156	48	0	\N
353958	1874	26320000	24527	12156	49	0	\N
353959	1874	26323000	24527	12156	50	0	\N
353960	1874	26326000	24527	12156	51	0	\N
353961	1874	26329000	24527	12156	52	0	\N
353962	1874	26332000	24527	12156	53	0	\N
353963	1874	26335000	24527	12156	54	0	\N
353964	1874	26338000	24527	12156	55	0	\N
353965	1874	26341000	24527	12156	56	0	\N
353966	1874	26344000	24527	12156	57	0	\N
353967	1874	26347000	24527	12156	58	0	\N
353968	1874	26350000	24527	12156	59	0	\N
353969	1874	26353000	24527	12156	60	0	\N
353970	1874	26356000	24527	12156	61	0	\N
353971	1874	26359000	24527	12156	62	0	\N
353972	1874	26362000	24527	12156	63	0	\N
353973	1874	26365000	24527	12156	64	0	\N
353974	1874	26368000	24527	12156	65	0	\N
353975	1874	26371000	24527	12156	66	0	\N
353976	1874	26374000	24527	12156	67	0	\N
353977	1874	26377000	24527	12156	68	0	\N
353978	1874	26380000	24527	12156	69	0	\N
353979	1874	26383000	24527	12156	70	0	\N
353980	1874	26386000	24527	12156	71	0	\N
353981	1874	26389000	24527	12156	72	0	\N
353982	1874	26392000	24527	12156	73	0	\N
353983	1874	26395000	24527	12156	74	0	\N
353984	1874	26398000	24527	12156	75	0	\N
353985	1874	26401000	24527	12156	76	0	\N
353986	1874	26404000	24527	12156	77	0	\N
353987	1874	26407000	24527	12156	78	0	\N
353988	1678	26640839725000	24528	12193	0	0	\N
353989	1874	26407000	24528	12193	1	0	\N
354008	1678	26640839725000	24535	12193	0	0	\N
353992	1874	26408000	24529	12194	2	0	2
353993	1874	26411000	24529	12194	3	0	2
353994	1874	26414000	24529	12194	4	0	2
353995	1678	26640839728000	24531	12195	0	0	0
353996	1874	26417000	24531	12195	1	0	2
353998	1874	26420000	24532	12196	1	0	2
353999	1678	26640839730000	24533	12197	0	0	0
354000	1678	26640839731000	24533	12197	1	0	0
354001	1874	26423000	24533	12197	2	0	2
354002	1874	26424000	24533	12197	3	0	2
354004	1678	26640839732000	24534	12198	0	0	0
354005	1678	26640839733000	24534	12198	1	0	0
354006	1874	26430000	24534	12198	2	0	2
354007	1874	26433000	24534	12198	3	0	2
354009	1678	26640839726000	24535	12193	1	0	\N
354010	1678	26640839727000	24535	12193	2	0	\N
354011	1678	26640839728000	24535	12193	3	0	\N
354012	1678	26640839729000	24535	12193	4	0	\N
354013	1678	26640839730000	24535	12193	5	0	\N
354014	1678	26640839731000	24535	12193	6	0	\N
354015	1678	26640839732000	24535	12193	7	0	\N
354016	1678	26640839733000	24535	12193	8	0	\N
354017	1874	26407000	24535	12193	9	0	\N
354018	1874	26408000	24535	12193	10	0	\N
354019	1874	26409000	24535	12193	11	0	\N
354020	1874	26412000	24535	12193	12	0	\N
354021	1874	26415000	24535	12193	13	0	\N
354022	1874	26418000	24535	12193	14	0	\N
354023	1874	26421000	24535	12193	15	0	\N
354024	1874	26424000	24535	12193	16	0	\N
354025	1874	26427000	24535	12193	17	0	\N
354026	1874	26430000	24535	12193	18	0	\N
354027	1874	26433000	24535	12193	19	0	\N
354028	1678	26640839734000	24538	12200	0	0	\N
354029	1678	26640839735000	24538	12200	1	0	\N
354030	1678	26640839736000	24538	12200	2	0	\N
354031	1874	26434000	24538	12200	3	0	\N
354032	1874	26437000	24538	12200	4	0	\N
354033	1874	26440000	24538	12200	5	0	\N
354034	1678	26640839734000	24539	12200	0	0	\N
354035	1678	26640839735000	24539	12200	1	0	\N
354036	1678	26640839736000	24539	12200	2	0	\N
354037	1874	26434000	24539	12200	3	0	\N
354038	1874	26437000	24539	12200	4	0	\N
354039	1874	26440000	24539	12200	5	0	\N
354053	1678	26640839738000	24542	12202	0	0	\N
354054	1678	26640839739000	24542	12202	1	0	\N
354055	1874	26447000	24542	12202	2	0	\N
354056	1874	26450000	24542	12202	3	0	\N
354064	1678	26640839742000	24549	12204	0	0	\N
354065	1874	26460000	24549	12204	1	0	\N
354066	1678	26640839742000	24550	12204	0	0	\N
354067	1874	26460000	24550	12204	1	0	\N
354068	1678	26640839742000	24551	12204	0	0	\N
354069	1874	26460000	24551	12204	1	0	\N
354072	1678	26640839743000	24554	12205	0	0	\N
354073	1874	26463000	24554	12205	1	0	\N
354079	1678	26640839744000	24556	12206	0	0	\N
354080	1678	26640839745000	24556	12206	1	0	\N
354081	1874	26466000	24556	12206	2	0	\N
354082	1874	26467000	24556	12206	3	0	\N
354083	1874	26470000	24556	12206	4	0	\N
354084	1678	26640839603000	24557	12029	0	0	\N
354085	1678	26640839604000	24557	12029	1	0	\N
354086	1678	26640839605000	24557	12029	2	0	\N
354087	1678	26640839606000	24557	12029	3	0	\N
354088	1678	26640839607000	24557	12029	4	0	\N
354089	1678	26640839608000	24557	12029	5	0	\N
354090	1678	26640839609000	24557	12029	6	0	\N
354091	1678	26640839610000	24557	12029	7	0	\N
354092	1678	26640839611000	24557	12029	8	0	\N
354093	1678	26640839612000	24557	12029	9	0	\N
354094	1678	26640839613000	24557	12029	10	0	\N
354095	1678	26640839614000	24557	12029	11	0	\N
354096	1678	26640839615000	24557	12029	12	0	\N
354097	1678	26640839616000	24557	12029	13	0	\N
354098	1678	26640839617000	24557	12029	14	0	\N
354099	1678	26640839618000	24557	12029	15	0	\N
354100	1678	26640839619000	24557	12029	16	0	\N
354101	1678	26640839620000	24557	12029	17	0	\N
354102	1678	26640839621000	24557	12029	18	0	\N
354103	1678	26640839622000	24557	12029	19	0	\N
354104	1678	26640839623000	24557	12029	20	0	\N
354105	1678	26640839624000	24557	12029	21	0	\N
354106	1678	26640839625000	24557	12029	22	0	\N
354107	1678	26640839626000	24557	12029	23	0	\N
354108	1678	26640839627000	24557	12029	24	0	\N
354109	1678	26640839628000	24557	12029	25	0	\N
354110	1678	26640839629000	24557	12029	26	0	\N
354111	1678	26640839630000	24557	12029	27	0	\N
354112	1678	26640839631000	24557	12029	28	0	\N
354113	1678	26640839632000	24557	12029	29	0	\N
354114	1678	26640839633000	24557	12029	30	0	\N
354115	1678	26640839634000	24557	12029	31	0	\N
354116	1678	26640839635000	24557	12029	32	0	\N
354117	1678	26640839636000	24557	12029	33	0	\N
354118	1678	26640839637000	24557	12029	34	0	\N
354119	1678	26640839638000	24557	12029	35	0	\N
354120	1678	26640839639000	24557	12029	36	0	\N
354121	1678	26640839640000	24557	12029	37	0	\N
354122	1678	26640839641000	24557	12029	38	0	\N
354123	1678	26640839642000	24557	12029	39	0	\N
354124	1678	26640839643000	24557	12029	40	0	\N
354125	1678	26640839644000	24557	12029	41	0	\N
354126	1678	26640839645000	24557	12029	42	0	\N
354127	1678	26640839646000	24557	12029	43	0	\N
354128	1678	26640839647000	24557	12029	44	0	\N
354129	1678	26640839648000	24557	12029	45	0	\N
354130	1678	26640839649000	24557	12029	46	0	\N
354131	1678	26640839650000	24557	12029	47	0	\N
354132	1678	26640839651000	24557	12029	48	0	\N
354133	1678	26640839652000	24557	12029	49	0	\N
354134	1678	26640839653000	24557	12029	50	0	\N
354135	1678	26640839654000	24557	12029	51	0	\N
354136	1678	26640839655000	24557	12029	52	0	\N
354137	1678	26640839656000	24557	12029	53	0	\N
354138	1678	26640839657000	24557	12029	54	0	\N
354139	1678	26640839658000	24557	12029	55	0	\N
354140	1678	26640839659000	24557	12029	56	0	\N
354141	1678	26640839660000	24557	12029	57	0	\N
354142	1678	26640839661000	24557	12029	58	0	\N
354143	1678	26640839662000	24557	12029	59	0	\N
354144	1678	26640839663000	24557	12029	60	0	\N
354042	1678	26640839736000	24540	12201	2	0	0
354043	1678	26640839737000	24540	12201	3	0	0
354044	1874	26434000	24540	12201	4	0	2
354045	1874	26435000	24540	12201	5	0	2
354046	1874	26438000	24540	12201	6	0	2
354048	1874	26444000	24540	12201	8	0	2
354049	1678	26640839738000	24541	12202	0	0	0
354050	1678	26640839739000	24541	12202	1	0	0
354051	1874	26447000	24541	12202	2	0	2
354052	1874	26450000	24541	12202	3	0	2
354058	1678	26640839741000	24547	12203	1	0	0
354059	1874	26453000	24547	12203	2	0	2
354060	1874	26456000	24547	12203	3	0	2
354061	1874	26457000	24547	12203	4	0	2
354063	1874	26460000	24548	12204	1	0	2
354070	1678	26640839743000	24553	12205	0	0	0
354071	1874	26463000	24553	12205	1	0	2
354074	1678	26640839744000	24555	12206	0	0	0
354075	1678	26640839745000	24555	12206	1	0	0
354077	1874	26467000	24555	12206	3	0	2
354078	1874	26470000	24555	12206	4	0	2
354145	1678	26640839664000	24557	12029	61	0	\N
354146	1678	26640839665000	24557	12029	62	0	\N
354147	1678	26640839666000	24557	12029	63	0	\N
354148	1678	26640839667000	24557	12029	64	0	\N
354149	1678	26640839668000	24557	12029	65	0	\N
354150	1678	26640839669000	24557	12029	66	0	\N
354151	1678	26640839670000	24557	12029	67	0	\N
354152	1678	26640839671000	24557	12029	68	0	\N
354153	1678	26640839672000	24557	12029	69	0	\N
354154	1678	26640839673000	24557	12029	70	0	\N
354155	1678	26640839674000	24557	12029	71	0	\N
354156	1678	26640839675000	24557	12029	72	0	\N
354157	1678	26640839676000	24557	12029	73	0	\N
354158	1678	26640839677000	24557	12029	74	0	\N
354159	1678	26640839678000	24557	12029	75	0	\N
354160	1678	26640839679000	24557	12029	76	0	\N
354161	1678	26640839680000	24557	12029	77	0	\N
354162	1678	26640839681000	24557	12029	78	0	\N
354163	1678	26640839682000	24557	12029	79	0	\N
354164	1678	26640839683000	24557	12029	80	0	\N
354165	1678	26640839684000	24557	12029	81	0	\N
354166	1678	26640839685000	24557	12029	82	0	\N
354167	1678	26640839686000	24557	12029	83	0	\N
354168	1678	26640839687000	24557	12029	84	0	\N
354169	1678	26640839688000	24557	12029	85	0	\N
354170	1678	26640839689000	24557	12029	86	0	\N
354171	1678	26640839690000	24557	12029	87	0	\N
354172	1678	26640839691000	24557	12029	88	0	\N
354173	1678	26640839692000	24557	12029	89	0	\N
354174	1678	26640839693000	24557	12029	90	0	\N
354175	1678	26640839694000	24557	12029	91	0	\N
354176	1678	26640839695000	24557	12029	92	0	\N
354177	1678	26640839696000	24557	12029	93	0	\N
354178	1678	26640839697000	24557	12029	94	0	\N
354179	1678	26640839698000	24557	12029	95	0	\N
354180	1678	26640839699000	24557	12029	96	0	\N
354181	1678	26640839700000	24557	12029	97	0	\N
354182	1678	26640839701000	24557	12029	98	0	\N
354183	1678	26640839702000	24557	12029	99	0	\N
354184	1678	26640839703000	24557	12029	100	0	\N
354185	1678	26640839704000	24557	12029	101	0	\N
354186	1678	26640839705000	24557	12029	102	0	\N
354187	1678	26640839706000	24557	12029	103	0	\N
354188	1678	26640839707000	24557	12029	104	0	\N
354189	1678	26640839708000	24557	12029	105	0	\N
354190	1678	26640839709000	24557	12029	106	0	\N
354191	1678	26640839710000	24557	12029	107	0	\N
354192	1678	26640839711000	24557	12029	108	0	\N
354193	1678	26640839712000	24557	12029	109	0	\N
354194	1678	26640839713000	24557	12029	110	0	\N
354195	1678	26640839714000	24557	12029	111	0	\N
354196	1678	26640839715000	24557	12029	112	0	\N
354197	1678	26640839716000	24557	12029	113	0	\N
354198	1678	26640839717000	24557	12029	114	0	\N
354199	1678	26640839718000	24557	12029	115	0	\N
354200	1678	26640839719000	24557	12029	116	0	\N
354201	1678	26640839720000	24557	12029	118	0	\N
354202	1678	26640839721000	24557	12029	119	0	\N
354203	1678	26640839722000	24557	12029	120	0	\N
354204	1678	26640839723000	24557	12029	121	0	\N
354205	1678	26640839724000	24557	12029	122	0	\N
354206	1678	26640839725000	24557	12029	123	0	\N
354207	1678	26640839726000	24557	12029	124	0	\N
354208	1678	26640839727000	24557	12029	125	0	\N
354214	1678	26640839748000	24560	12209	0	0	\N
354222	1678	26640839751000	24564	12212	0	0	\N
354223	1874	26490000	24564	12212	1	0	\N
354226	1678	26640839752000	24566	12213	0	0	\N
354227	1678	26640839753000	24566	12213	1	0	\N
354228	1874	26493000	24566	12213	2	0	\N
354229	1874	26496000	24566	12213	3	0	\N
354234	1678	26640839752000	24568	12213	0	0	\N
354235	1678	26640839753000	24568	12213	1	0	\N
354236	1874	26493000	24568	12213	2	0	\N
354237	1874	26496000	24568	12213	3	0	\N
354238	1678	26640839752000	24569	12213	0	0	\N
354239	1678	26640839753000	24569	12213	1	0	\N
354240	1874	26493000	24569	12213	2	0	\N
354241	1874	26496000	24569	12213	3	0	\N
354242	1678	26640839752000	24570	12213	0	0	\N
354243	1678	26640839753000	24570	12213	1	0	\N
354244	1874	26493000	24570	12213	2	0	\N
354245	1874	26496000	24570	12213	3	0	\N
354249	1678	26640839755000	24572	12215	0	0	\N
354250	1678	26640839756000	24572	12215	1	0	\N
354251	1678	26640839757000	24572	12215	2	0	\N
354252	1678	26640839758000	24572	12215	3	0	\N
354253	1874	26503000	24572	12215	4	0	\N
354254	1874	26506000	24572	12215	5	0	\N
354255	1874	26509000	24572	12215	6	0	\N
354256	1874	26512000	24572	12215	7	0	\N
354257	1874	26513000	24572	12215	8	0	\N
354267	1678	26640839759000	24574	12216	0	0	\N
354268	1874	26516000	24574	12216	1	0	\N
354274	1678	26640839760000	24577	12217	0	0	\N
354275	1874	26517000	24577	12217	1	0	\N
354276	1874	26520000	24577	12217	2	0	\N
354211	1678	26640839747000	24559	12208	0	0	0
354212	1874	26474000	24559	12208	1	0	2
354213	1874	26477000	24559	12208	2	0	2
354215	1678	26640839748000	24561	12209	0	0	0
354216	1874	26480000	24561	12209	1	0	2
354218	1874	26483000	24562	12210	1	0	2
354219	1678	26640839750000	24563	12211	0	0	0
354220	1874	26484000	24563	12211	1	0	2
354221	1874	26487000	24563	12211	2	0	2
354224	1678	26640839751000	24565	12212	0	0	0
354230	1678	26640839752000	24567	12213	0	0	0
354231	1678	26640839753000	24567	12213	1	0	0
354232	1874	26493000	24567	12213	2	0	2
354233	1874	26496000	24567	12213	3	0	2
354247	1874	26497000	24571	12214	1	0	2
354248	1874	26500000	24571	12214	2	0	2
354258	1678	26640839755000	24573	12215	0	0	0
354259	1678	26640839756000	24573	12215	1	0	0
354260	1678	26640839757000	24573	12215	2	0	0
354262	1874	26503000	24573	12215	4	0	2
354263	1874	26506000	24573	12215	5	0	2
354264	1874	26509000	24573	12215	6	0	2
354265	1874	26512000	24573	12215	7	0	2
354266	1874	26513000	24573	12215	8	0	2
354270	1874	26516000	24575	12216	1	0	2
354271	1678	26640839760000	24576	12217	0	0	0
354272	1874	26517000	24576	12217	1	0	2
354273	1874	26520000	24576	12217	2	0	2
354278	1874	26523000	24578	12218	1	0	2
354279	1678	26640839762000	24579	12219	0	0	0
354280	1874	26526000	24579	12219	1	0	2
354301	1678	26640839768000	24583	12222	0	0	\N
354302	1678	26640839769000	24583	12222	1	0	\N
354303	1678	26640839770000	24583	12222	2	0	\N
354304	1874	26546000	24583	12222	3	0	\N
354305	1874	26547000	24583	12222	4	0	\N
354306	1874	26550000	24583	12222	6	0	\N
354307	1874	26553000	24583	12222	7	0	\N
354308	1678	26640839768000	24584	12222	0	0	\N
354309	1678	26640839769000	24584	12222	1	0	\N
354310	1678	26640839770000	24584	12222	2	0	\N
354311	1874	26546000	24584	12222	3	0	\N
354312	1874	26547000	24584	12222	4	0	\N
354313	1874	26550000	24584	12222	6	0	\N
354314	1874	26553000	24584	12222	7	0	\N
354315	1678	26640839768000	24585	12222	0	0	\N
354316	1678	26640839769000	24585	12222	1	0	\N
354317	1678	26640839770000	24585	12222	2	0	\N
354318	1874	26546000	24585	12222	3	0	\N
354319	1874	26547000	24585	12222	4	0	\N
354320	1874	26550000	24585	12222	6	0	\N
354321	1874	26553000	24585	12222	7	0	\N
354322	1678	26640839768000	24586	12222	0	0	\N
354323	1678	26640839769000	24586	12222	1	0	\N
354324	1678	26640839770000	24586	12222	2	0	\N
354325	1874	26546000	24586	12222	3	0	\N
354326	1874	26547000	24586	12222	4	0	\N
354327	1874	26550000	24586	12222	6	0	\N
354328	1874	26553000	24586	12222	7	0	\N
354329	1678	26640839768000	24587	12222	0	0	\N
354330	1678	26640839769000	24587	12222	1	0	\N
354331	1678	26640839770000	24587	12222	2	0	\N
354332	1874	26546000	24587	12222	3	0	\N
354333	1874	26547000	24587	12222	4	0	\N
354334	1874	26550000	24587	12222	6	0	\N
354335	1874	26553000	24587	12222	7	0	\N
354338	1678	26640839771000	24589	12223	0	0	\N
354339	1874	26556000	24589	12223	1	0	\N
354346	1678	26640839775000	24592	12225	0	0	\N
354347	1678	26640839776000	24592	12225	1	0	\N
354348	1678	26640839777000	24592	12225	2	0	\N
354349	1874	26566000	24592	12225	3	0	\N
354350	1874	26567000	24592	12225	4	0	\N
354351	1874	26570000	24592	12225	5	0	\N
354352	1874	26573000	24592	12225	6	0	\N
354353	1678	26640839775000	24593	12225	0	0	\N
354354	1678	26640839776000	24593	12225	1	0	\N
354355	1678	26640839777000	24593	12225	2	0	\N
354356	1874	26566000	24593	12225	3	0	\N
354357	1874	26567000	24593	12225	4	0	\N
354358	1874	26570000	24593	12225	5	0	\N
354359	1874	26573000	24593	12225	6	0	\N
354367	1678	26640839778000	24595	12226	0	0	\N
354368	1874	26576000	24595	12226	1	0	\N
354371	1678	26640839779000	24597	12227	0	0	\N
354372	1874	26579000	24597	12227	1	0	\N
354375	1874	26579000	24599	12227	0	0	\N
354376	1678	26640839780000	24600	12228	0	0	\N
354377	1874	26582000	24600	12228	1	0	\N
354378	1874	26583000	24600	12228	2	0	\N
354385	1678	26640839781000	24603	12229	0	0	\N
354386	2068	935000000000	24603	12229	1	0	\N
354387	1874	26586000	24603	12229	2	0	\N
354388	1678	26640839782000	24604	12230	0	0	\N
354389	1874	26589000	24604	12230	1	0	\N
354399	1678	26640839785000	24607	12232	0	0	\N
354400	1874	26603000	24607	12232	1	0	\N
354401	1874	26605000	24607	12232	2	0	\N
354405	1678	26640839785000	24609	12232	0	0	\N
354406	1874	26603000	24609	12232	1	0	\N
354407	1874	26605000	24609	12232	2	0	\N
354408	1678	26640839785000	24610	12232	0	0	\N
354409	1874	26603000	24610	12232	1	0	\N
354410	1874	26605000	24610	12232	2	0	\N
354411	1678	26640839785000	24611	12232	0	0	\N
354412	1874	26603000	24611	12232	1	0	\N
354413	1874	26605000	24611	12232	2	0	\N
354414	1678	26640839785000	24612	12232	0	0	\N
354415	1874	26603000	24612	12232	1	0	\N
354416	1874	26605000	24612	12232	2	0	\N
354283	1678	26640839764000	24580	12220	2	0	0
354284	1678	26640839765000	24580	12220	3	0	0
354285	1874	26527000	24580	12220	4	0	2
354286	1874	26530000	24580	12220	5	0	2
354287	1874	26533000	24580	12220	6	0	2
354289	1678	26640839766000	24581	12221	0	0	0
354290	1678	26640839767000	24581	12221	1	0	0
354291	1874	26539000	24581	12221	2	0	2
354292	1874	26542000	24581	12221	3	0	2
354293	1874	26543000	24581	12221	4	0	2
354295	1678	26640839769000	24582	12222	1	0	0
354296	1678	26640839770000	24582	12222	2	0	0
354297	1874	26546000	24582	12222	3	0	2
354298	1874	26547000	24582	12222	4	0	2
354300	1874	26553000	24582	12222	7	0	2
354336	1678	26640839771000	24588	12223	0	0	0
354337	1874	26556000	24588	12223	1	0	2
354340	1678	26640839772000	24590	12224	0	0	0
354341	1678	26640839773000	24590	12224	1	0	0
354343	1874	26559000	24590	12224	3	0	2
354344	1874	26562000	24590	12224	4	0	2
354345	1874	26563000	24590	12224	5	0	2
354360	1678	26640839775000	24594	12225	0	0	0
354361	1678	26640839776000	24594	12225	1	0	0
354363	1874	26566000	24594	12225	3	0	2
354364	1874	26567000	24594	12225	4	0	2
354365	1874	26570000	24594	12225	5	0	2
354366	1874	26573000	24594	12225	6	0	2
354370	1874	26576000	24596	12226	1	0	2
354373	1678	26640839779000	24598	12227	0	0	0
354374	1874	26579000	24598	12227	1	0	2
354379	1678	26640839780000	24601	12228	0	0	0
354380	1874	26582000	24601	12228	1	0	2
354382	1678	26640839781000	24602	12229	0	0	0
354383	2068	935000000000	24602	12229	1	0	0
354384	1874	26586000	24602	12229	2	0	2
354390	1678	26640839782000	24605	12230	0	0	0
354391	1874	26589000	24605	12230	1	0	2
354393	1678	26640839784000	24606	12231	1	0	0
354394	1874	26591000	24606	12231	2	0	2
354395	1874	26592000	24606	12231	3	0	2
354396	1874	26595000	24606	12231	4	0	2
354398	1874	26600000	24606	12231	6	0	2
354402	1678	26640839785000	24608	12232	0	0	0
354403	1874	26603000	24608	12232	1	0	2
354404	1874	26605000	24608	12232	2	0	2
354417	1678	26640839786000	24613	12233	0	0	\N
354418	1874	26607000	24613	12233	1	0	\N
354419	1874	26610000	24613	12233	2	0	\N
354420	1678	26640839786000	24614	12233	0	0	\N
354421	1874	26607000	24614	12233	1	0	\N
354422	1874	26610000	24614	12233	2	0	\N
354426	1874	26607000	24616	12233	0	0	\N
354427	1874	26610000	24616	12233	1	0	\N
354445	1678	26640839787000	24618	12234	0	0	\N
354446	1678	26640839788000	24618	12234	1	0	\N
354447	1678	26640839789000	24618	12234	2	0	\N
354448	1678	26640839790000	24618	12234	3	0	\N
354449	1678	26640839791000	24618	12234	4	0	\N
354450	1874	26613000	24618	12234	5	0	\N
354451	1874	26614000	24618	12234	6	0	\N
354452	1874	26615000	24618	12234	7	0	\N
354453	1874	26618000	24618	12234	8	0	\N
354454	1874	26621000	24618	12234	9	0	\N
354455	1874	26624000	24618	12234	10	0	\N
354456	1874	26627000	24618	12234	11	0	\N
354457	1874	26629000	24618	12234	12	0	\N
354458	1874	26631000	24618	12234	13	0	\N
354459	1874	26633000	24618	12234	14	0	\N
354460	1874	26635000	24618	12234	15	0	\N
354461	1874	26637000	24618	12234	16	0	\N
354465	1678	26640839792000	24620	12235	0	0	\N
354466	1874	26640000	24620	12235	1	0	\N
354467	1874	26642000	24620	12235	2	0	\N
354468	1678	26640839793000	24621	12236	0	0	\N
354469	1874	26644000	24621	12236	1	0	\N
354470	1874	26647000	24621	12236	2	0	\N
354471	2291	255757211465	24622	12110	0	0	\N
354472	1388	1715855704351650	24622	12110	1	0	\N
354473	1142	912608755600000	24622	12110	2	0	\N
354474	1262	615754826200000	24622	12110	3	0	\N
354475	1022	509273064000000	24622	12110	4	0	\N
354476	2068	935000000000	24622	12110	5	0	\N
354477	1678	26640839793000	24623	12236	0	0	\N
354478	1874	26644000	24623	12236	1	0	\N
354479	1874	26647000	24623	12236	2	0	\N
354480	1678	26640839793000	24624	12236	0	0	\N
354481	1874	26644000	24624	12236	1	0	\N
354482	1678	26640839793000	24625	12236	0	0	\N
354483	1874	26644000	24625	12236	1	0	\N
354484	1874	26647000	24625	12236	2	0	\N
354502	1678	26640839797000	24629	12239	0	0	\N
354503	1874	26672000	24629	12239	1	0	\N
354504	1874	26674000	24629	12239	2	0	\N
354505	1678	26640839797000	24630	12239	0	0	\N
354506	1874	26672000	24630	12239	1	0	\N
354507	1874	26674000	24630	12239	2	0	\N
354508	1678	26640839797000	24631	12239	0	0	\N
354509	1874	26672000	24631	12239	1	0	\N
354510	1874	26674000	24631	12239	2	0	\N
354524	1678	26640839800000	24635	12241	0	0	\N
354525	1874	26683000	24635	12241	2	0	\N
354526	1874	26684000	24635	12241	3	0	\N
354527	1874	26687000	24635	12241	4	0	\N
354528	1678	26640839800000	24636	12241	0	0	\N
354529	1874	26683000	24636	12241	2	0	\N
354530	1874	26684000	24636	12241	3	0	\N
354531	1874	26687000	24636	12241	4	0	\N
354532	1678	26640839800000	24637	12241	0	0	\N
354533	1874	26683000	24637	12241	2	0	\N
354534	1874	26684000	24637	12241	3	0	\N
354535	1874	26687000	24637	12241	4	0	\N
354536	1678	26640839800000	24638	12241	0	0	\N
354537	1874	26683000	24638	12241	2	0	\N
354538	1874	26684000	24638	12241	3	0	\N
354539	1874	26687000	24638	12241	4	0	\N
354540	1010	508715470792656	24639	12242	0	0	\N
354541	1130	911613764986289	24639	12242	1	0	\N
354542	1678	26640839801000	24639	12242	2	0	\N
354543	1250	615083972423684	24639	12242	3	0	\N
354544	1376	1713986179376152	24639	12242	4	0	\N
354545	1874	26690000	24639	12242	6	0	\N
354546	1874	26692000	24639	12242	7	0	\N
354425	1874	26610000	24615	12233	2	0	2
354428	1678	26640839787000	24617	12234	0	0	0
354429	1678	26640839788000	24617	12234	1	0	0
354430	1678	26640839789000	24617	12234	2	0	0
354431	1678	26640839790000	24617	12234	3	0	0
354433	1874	26613000	24617	12234	5	0	2
354434	1874	26614000	24617	12234	6	0	2
354435	1874	26615000	24617	12234	7	0	2
354436	1874	26618000	24617	12234	8	0	2
354437	1874	26621000	24617	12234	9	0	2
354439	1874	26627000	24617	12234	11	0	2
354440	1874	26629000	24617	12234	12	0	2
354441	1874	26631000	24617	12234	13	0	2
354442	1874	26633000	24617	12234	14	0	2
354444	1874	26637000	24617	12234	16	0	2
354462	1678	26640839792000	24619	12235	0	0	0
354463	1874	26640000	24619	12235	1	0	2
354464	1874	26642000	24619	12235	2	0	2
354485	1678	26640839793000	24626	12236	0	0	0
354487	1874	26647000	24626	12236	2	0	2
354488	1678	26640839794000	24627	12237	0	0	0
354489	1874	26649000	24627	12237	1	0	2
354490	1874	26652000	24627	12237	2	0	2
354491	1874	26653000	24627	12237	3	0	2
354493	1678	26640839795000	24628	12238	1	0	0
354494	1678	26640839796000	24628	12238	2	0	0
354495	1874	26656000	24628	12238	3	0	2
354496	1874	26658000	24628	12238	4	0	2
354498	1874	26662000	24628	12238	6	0	2
354499	1874	26663000	24628	12238	7	0	2
354500	1874	26666000	24628	12238	8	0	2
354501	1874	26669000	24628	12238	9	0	2
354511	1678	26640839797000	24632	12239	0	0	0
354513	1874	26674000	24632	12239	2	0	2
354514	50	66779714905251	24633	12240	0	0	0
354515	1678	26640839798000	24633	12240	1	0	0
354516	1678	26640839799000	24633	12240	2	0	0
354517	1874	26677000	24633	12240	3	0	2
354519	1874	26681000	24633	12240	5	0	2
354520	1678	26640839800000	24634	12241	0	0	0
354521	1874	26683000	24634	12241	2	0	2
354522	1874	26684000	24634	12241	3	0	2
354547	1010	508715470792656	24640	12242	0	0	0
354548	1130	911613764986289	24640	12242	1	0	0
354549	1678	26640839801000	24640	12242	2	0	0
354550	1250	615083972423684	24640	12242	3	0	0
354551	1376	1713986179376152	24640	12242	4	0	0
354554	1010	508715470792656	24641	12242	0	0	\N
354555	1130	911613764986289	24641	12242	1	0	\N
354556	1678	26640839801000	24641	12242	2	0	\N
354557	1250	615083972423684	24641	12242	3	0	\N
354558	1376	1713986179376152	24641	12242	4	0	\N
354559	1874	26690000	24641	12242	6	0	\N
354560	1874	26692000	24641	12242	7	0	\N
354561	1010	508715470792656	24642	12242	0	0	\N
354562	1130	911613764986289	24642	12242	1	0	\N
354563	1678	26640839801000	24642	12242	2	0	\N
354564	1250	615083972423684	24642	12242	3	0	\N
354565	1376	1713986179376152	24642	12242	4	0	\N
354566	1874	26690000	24642	12242	6	0	\N
354567	1874	26692000	24642	12242	7	0	\N
354568	1292	1710568637751650	24643	12115	0	0	\N
354569	2291	255757211465	24643	12115	1	0	\N
354570	2288	776757211465	24643	12115	2	0	\N
354571	50	66779714905251	24643	12115	3	0	\N
354572	1046	909797465000000	24643	12115	4	0	\N
354573	1166	613858750000000	24643	12115	5	0	\N
354574	926	507702775000000	24643	12115	6	0	\N
354575	1388	1715855704351650	24643	12115	7	0	\N
354576	1010	508715470792656	24643	12115	8	0	\N
354577	1130	911613764986289	24643	12115	9	0	\N
354578	2003	2081960654821	24643	12115	10	0	\N
354579	1142	912608755600000	24643	12115	11	0	\N
354580	1262	615754826200000	24643	12115	12	0	\N
354581	1022	509273064000000	24643	12115	13	0	\N
354582	2068	935000000000	24643	12115	14	0	\N
354583	1678	26640839616000	24643	12115	15	0	\N
354584	1250	615083972423684	24643	12115	16	0	\N
354585	1376	1713986179376152	24643	12115	17	0	\N
354586	1678	26640839617000	24643	12115	18	0	\N
354587	1678	26640839618000	24643	12115	19	0	\N
354588	1678	26640839619000	24643	12115	20	0	\N
354589	1678	26640839620000	24643	12115	21	0	\N
354590	1678	26640839621000	24643	12115	22	0	\N
354591	1678	26640839622000	24643	12115	23	0	\N
354592	1678	26640839623000	24643	12115	24	0	\N
354593	1678	26640839624000	24643	12115	25	0	\N
354594	1678	26640839625000	24643	12115	26	0	\N
354595	1678	26640839626000	24643	12115	27	0	\N
354596	1678	26640839627000	24643	12115	28	0	\N
354597	1678	26640839628000	24643	12115	29	0	\N
354598	1678	26640839629000	24643	12115	30	0	\N
354599	1678	26640839630000	24643	12115	31	0	\N
354600	1678	26640839631000	24643	12115	32	0	\N
354601	1678	26640839632000	24643	12115	33	0	\N
354602	1678	26640839633000	24643	12115	34	0	\N
354603	1678	26640839634000	24643	12115	35	0	\N
354604	1678	26640839635000	24643	12115	36	0	\N
354605	1678	26640839636000	24643	12115	37	0	\N
354606	1678	26640839637000	24643	12115	38	0	\N
354607	1678	26640839638000	24643	12115	39	0	\N
354608	1678	26640839639000	24643	12115	40	0	\N
354609	1678	26640839640000	24643	12115	41	0	\N
354610	1678	26640839641000	24643	12115	42	0	\N
354611	1678	26640839642000	24643	12115	43	0	\N
354612	1678	26640839643000	24643	12115	44	0	\N
354613	1678	26640839644000	24643	12115	45	0	\N
354614	1678	26640839645000	24643	12115	46	0	\N
354615	1678	26640839646000	24643	12115	47	0	\N
354616	1678	26640839647000	24643	12115	48	0	\N
354617	1678	26640839648000	24643	12115	49	0	\N
354618	1678	26640839649000	24643	12115	50	0	\N
354619	1678	26640839650000	24643	12115	51	0	\N
354620	1678	26640839651000	24643	12115	52	0	\N
354621	1678	26640839652000	24643	12115	53	0	\N
354622	1678	26640839653000	24643	12115	54	0	\N
354623	1678	26640839654000	24643	12115	55	0	\N
354624	1678	26640839655000	24643	12115	56	0	\N
354625	1678	26640839656000	24643	12115	57	0	\N
354626	1678	26640839657000	24643	12115	58	0	\N
354627	1678	26640839658000	24643	12115	59	0	\N
354628	1678	26640839659000	24643	12115	60	0	\N
354629	1678	26640839660000	24643	12115	61	0	\N
354630	1678	26640839661000	24643	12115	62	0	\N
354631	1678	26640839662000	24643	12115	63	0	\N
354632	1678	26640839663000	24643	12115	64	0	\N
354633	1678	26640839664000	24643	12115	66	0	\N
354634	1678	26640839665000	24643	12115	67	0	\N
354635	1678	26640839666000	24643	12115	68	0	\N
354636	1678	26640839667000	24643	12115	69	0	\N
354637	1678	26640839668000	24643	12115	70	0	\N
354638	1678	26640839669000	24643	12115	71	0	\N
354639	1678	26640839670000	24643	12115	72	0	\N
354640	1678	26640839671000	24643	12115	73	0	\N
354641	1678	26640839672000	24643	12115	74	0	\N
354642	1678	26640839673000	24643	12115	75	0	\N
354643	1678	26640839674000	24643	12115	76	0	\N
354644	1678	26640839675000	24643	12115	77	0	\N
354645	1678	26640839676000	24643	12115	78	0	\N
354646	1678	26640839677000	24643	12115	79	0	\N
354647	1678	26640839678000	24643	12115	80	0	\N
354648	1678	26640839679000	24643	12115	81	0	\N
354649	1678	26640839680000	24643	12115	82	0	\N
354650	1678	26640839681000	24643	12115	83	0	\N
354651	1678	26640839682000	24643	12115	84	0	\N
354652	1678	26640839683000	24643	12115	85	0	\N
354653	1678	26640839684000	24643	12115	86	0	\N
354654	1678	26640839685000	24643	12115	87	0	\N
354655	1678	26640839686000	24643	12115	88	0	\N
354656	1678	26640839687000	24643	12115	89	0	\N
354657	1678	26640839688000	24643	12115	90	0	\N
354658	1678	26640839689000	24643	12115	91	0	\N
354659	1678	26640839690000	24643	12115	92	0	\N
354660	1678	26640839691000	24643	12115	93	0	\N
354661	1678	26640839692000	24643	12115	94	0	\N
354662	1678	26640839693000	24643	12115	95	0	\N
354663	1678	26640839694000	24643	12115	96	0	\N
354664	1678	26640839695000	24643	12115	97	0	\N
354665	1678	26640839696000	24643	12115	98	0	\N
354666	1678	26640839697000	24643	12115	99	0	\N
354667	1678	26640839698000	24643	12115	100	0	\N
354668	1678	26640839699000	24643	12115	101	0	\N
354669	1678	26640839700000	24643	12115	102	0	\N
354670	1678	26640839701000	24643	12115	103	0	\N
354671	1678	26640839702000	24643	12115	104	0	\N
354672	1678	26640839703000	24643	12115	105	0	\N
354673	1678	26640839704000	24643	12115	106	0	\N
354674	1678	26640839705000	24643	12115	107	0	\N
354675	1678	26640839706000	24643	12115	108	0	\N
354676	1678	26640839707000	24643	12115	109	0	\N
354677	1678	26640839708000	24643	12115	110	0	\N
354678	1678	26640839709000	24643	12115	111	0	\N
354679	1678	26640839710000	24643	12115	112	0	\N
354680	1678	26640839711000	24643	12115	113	0	\N
354681	1678	26640839712000	24643	12115	114	0	\N
354682	1678	26640839713000	24643	12115	115	0	\N
354683	1678	26640839714000	24643	12115	116	0	\N
354684	1678	26640839715000	24643	12115	117	0	\N
354685	1678	26640839716000	24643	12115	118	0	\N
354686	1678	26640839717000	24643	12115	119	0	\N
354687	1678	26640839718000	24643	12115	120	0	\N
354688	1678	26640839719000	24643	12115	121	0	\N
354689	1678	26640839720000	24643	12115	122	0	\N
354690	1678	26640839721000	24643	12115	123	0	\N
354691	1678	26640839722000	24643	12115	124	0	\N
354692	1678	26640839723000	24643	12115	125	0	\N
354693	1006	508416004675840	24644	12243	0	0	\N
354694	1678	26640839802000	24644	12243	1	0	\N
354695	1874	26694000	24644	12243	2	0	\N
354696	1874	26697000	24644	12243	3	0	\N
354701	1006	508416004675840	24646	12243	0	0	\N
354702	1678	26640839802000	24646	12243	1	0	\N
354703	1874	26694000	24646	12243	2	0	\N
354704	1874	26697000	24646	12243	3	0	\N
354705	1678	26640839803000	24647	12244	0	0	\N
354706	1874	26700000	24647	12244	1	0	\N
354707	1874	26701000	24647	12244	2	0	\N
354708	1874	26703000	24647	12244	3	0	\N
354709	1678	26640839803000	24648	12244	0	0	\N
354710	1874	26700000	24648	12244	1	0	\N
354711	1874	26701000	24648	12244	2	0	\N
354712	1874	26703000	24648	12244	3	0	\N
354713	1678	26640839803000	24649	12244	0	0	\N
354714	1874	26700000	24649	12244	1	0	\N
354715	1874	26701000	24649	12244	2	0	\N
354716	1874	26703000	24649	12244	3	0	\N
354721	1126	911077124270784	24651	12245	0	0	\N
354722	1678	26640839804000	24651	12245	1	0	\N
354723	1874	26705000	24651	12245	2	0	\N
354724	1874	26708000	24651	12245	3	0	\N
354729	1126	911077124270784	24653	12245	0	0	\N
354730	1678	26640839804000	24653	12245	1	0	\N
354731	1874	26705000	24653	12245	2	0	\N
354732	1874	26708000	24653	12245	3	0	\N
354733	1126	911077124270784	24654	12245	0	0	\N
354734	1678	26640839804000	24654	12245	1	0	\N
354735	1874	26705000	24654	12245	2	0	\N
354736	1874	26708000	24654	12245	3	0	\N
354746	1678	26640839807000	24656	12247	0	0	\N
354747	1874	26721000	24656	12247	1	0	\N
354748	1874	26724000	24656	12247	2	0	\N
354755	1678	26640839808000	24659	12248	0	0	\N
354756	1874	26727000	24659	12248	1	0	\N
354757	1874	26729000	24659	12248	2	0	\N
354761	1678	26640839810000	24661	12250	0	0	\N
354762	1874	26737000	24661	12250	1	0	\N
354763	1874	26738000	24661	12250	2	0	\N
354764	1874	26740000	24661	12250	3	0	\N
354765	1678	26640839810000	24662	12250	0	0	\N
354766	1874	26737000	24662	12250	1	0	\N
354767	1874	26738000	24662	12250	2	0	\N
354768	1874	26740000	24662	12250	3	0	\N
354773	1678	26640839810000	24664	12250	0	0	\N
354774	1874	26737000	24664	12250	1	0	\N
354775	1874	26738000	24664	12250	2	0	\N
354776	1874	26740000	24664	12250	3	0	\N
354777	1874	26742000	24665	12251	0	0	\N
354780	1678	26640839811000	24667	12251	0	0	\N
354781	1874	26742000	24667	12251	1	0	\N
354782	1678	26640839812000	24668	12252	0	0	\N
354783	1874	26745000	24668	12252	1	0	\N
354784	1874	26747000	24668	12252	2	0	\N
354792	1678	26640839813000	24671	12253	0	0	\N
354793	1874	26748000	24671	12253	1	0	\N
354794	1874	26751000	24671	12253	2	0	\N
354795	1874	26753000	24671	12253	3	0	\N
354796	1678	26640839813000	24672	12253	0	0	\N
354797	1874	26748000	24672	12253	1	0	\N
354798	1874	26751000	24672	12253	2	0	\N
354799	1874	26753000	24672	12253	3	0	\N
354815	1678	26640839818000	24676	12256	0	0	\N
354816	1874	26777000	24676	12256	1	0	\N
354817	1874	26779000	24676	12256	2	0	\N
354818	1242	614993850000000	24676	12256	3	0	\N
354699	1874	26694000	24645	12243	2	0	2
354700	1874	26697000	24645	12243	3	0	2
354717	1678	26640839803000	24650	12244	0	0	0
354718	1874	26700000	24650	12244	1	0	2
354719	1874	26701000	24650	12244	2	0	2
354725	1126	911077124270784	24652	12245	0	0	0
354726	1678	26640839804000	24652	12245	1	0	0
354727	1874	26705000	24652	12245	2	0	2
354728	1874	26708000	24652	12245	3	0	2
354737	1246	614721890239616	24655	12246	0	0	0
354739	1678	26640839805000	24655	12246	2	0	0
354740	1678	26640839806000	24655	12246	3	0	0
354741	1874	26710000	24655	12246	4	0	2
354742	1874	26712000	24655	12246	5	0	2
354744	1874	26718000	24655	12246	7	0	2
354745	1874	26719000	24655	12246	8	0	2
354749	1678	26640839807000	24657	12247	0	0	0
354750	1874	26721000	24657	12247	1	0	2
354751	1874	26724000	24657	12247	2	0	2
354753	1874	26727000	24658	12248	1	0	2
354754	1874	26729000	24658	12248	2	0	2
354758	1678	26640839809000	24660	12249	0	0	0
354759	1874	26731000	24660	12249	1	0	2
354760	1874	26734000	24660	12249	2	0	2
354770	1874	26737000	24663	12250	1	0	2
354771	1874	26738000	24663	12250	2	0	2
354772	1874	26740000	24663	12250	3	0	2
354778	1678	26640839811000	24666	12251	0	0	0
354785	1678	26640839812000	24669	12252	0	0	0
354786	1874	26745000	24669	12252	1	0	2
354787	1874	26747000	24669	12252	2	0	2
354788	1678	26640839813000	24670	12253	0	0	0
354789	1874	26748000	24670	12253	1	0	2
354791	1874	26753000	24670	12253	3	0	2
354800	1678	26640839814000	24673	12254	0	0	0
354801	1678	26640839815000	24673	12254	1	0	0
354802	1678	26640839816000	24673	12254	2	0	0
354803	1368	1713735727751650	24673	12254	3	0	0
354805	1122	911480185000000	24673	12254	5	0	0
354806	1874	26757000	24673	12254	6	0	2
354807	1874	26760000	24673	12254	7	0	2
354808	1874	26763000	24673	12254	8	0	2
354810	1874	26767000	24673	12254	10	0	2
354811	1874	26769000	24673	12254	11	0	2
354812	1678	26640839817000	24675	12255	0	0	0
354813	1874	26772000	24675	12255	1	0	2
354814	1874	26774000	24675	12255	2	0	2
354820	1874	26777000	24677	12256	1	0	2
354821	1874	26779000	24677	12256	2	0	2
354822	1242	614993850000000	24677	12256	3	0	0
354823	1678	26640839819000	24678	12257	0	0	0
354824	1874	26781000	24678	12257	1	0	2
354845	1678	26640839822000	24682	12260	0	0	\N
354846	1678	26640839823000	24682	12260	1	0	\N
354847	1678	26640839824000	24682	12260	2	0	\N
354848	1874	26796000	24682	12260	3	0	\N
354849	23	32937710000000	24682	12260	4	0	\N
354850	1874	26799000	24682	12260	6	0	\N
354851	1874	26802000	24682	12260	7	0	\N
354852	1874	26805000	24682	12260	8	0	\N
354853	1874	26807000	24682	12260	9	0	\N
354854	1874	26809000	24682	12260	10	0	\N
354855	1874	26811000	24682	12260	11	0	\N
354859	1678	26640839826000	24684	12262	0	0	\N
354860	1678	26640839827000	24684	12262	1	0	\N
354861	1678	26640839828000	24684	12262	2	0	\N
354862	1874	26817000	24684	12262	3	0	\N
354863	1874	26819000	24684	12262	4	0	\N
354864	1874	26821000	24684	12262	5	0	\N
354865	1874	26823000	24684	12262	6	0	\N
354866	1874	26826000	24684	12262	7	0	\N
354867	1874	26829000	24684	12262	8	0	\N
354868	1874	26832000	24684	12262	9	0	\N
354869	1678	26640839826000	24685	12262	0	0	\N
354870	1678	26640839827000	24685	12262	1	0	\N
354871	1678	26640839828000	24685	12262	2	0	\N
354872	1874	26817000	24685	12262	3	0	\N
354873	1874	26819000	24685	12262	4	0	\N
354874	1874	26821000	24685	12262	5	0	\N
354875	1874	26823000	24685	12262	6	0	\N
354876	1874	26826000	24685	12262	7	0	\N
354877	1874	26829000	24685	12262	8	0	\N
354878	1874	26832000	24685	12262	9	0	\N
354889	1678	26640839829000	24687	12263	0	0	\N
354890	1874	26835000	24687	12263	1	0	\N
354891	1874	26837000	24687	12263	2	0	\N
354892	756	1012990000000	24687	12263	3	0	\N
354893	1368	1713735727751650	24688	12254	0	0	\N
354894	1122	911480185000000	24688	12254	1	0	\N
354895	1242	614993850000000	24688	12254	2	0	\N
354900	1678	26640839829000	24690	12263	0	0	\N
354901	1874	26835000	24690	12263	1	0	\N
354902	1874	26837000	24690	12263	2	0	\N
354903	756	1012990000000	24690	12263	3	0	\N
354908	1678	26640839831000	24692	12265	0	0	\N
354909	1678	26640839832000	24692	12265	1	0	\N
354910	1874	26845000	24692	12265	2	0	\N
354911	1874	26847000	24692	12265	3	0	\N
354912	1874	26850000	24692	12265	4	0	\N
354913	1874	26853000	24692	12265	5	0	\N
354920	245	66778181541448	24694	12266	0	0	\N
354921	1678	26640839833000	24694	12266	1	0	\N
354922	2017	776780875847	24694	12266	2	0	\N
354923	1874	26854000	24694	12266	3	0	\N
354924	1874	26856000	24694	12266	4	0	\N
354925	245	66778181541448	24695	12266	0	0	\N
354926	1678	26640839833000	24695	12266	1	0	\N
354927	2017	776780875847	24695	12266	2	0	\N
354928	1874	26854000	24695	12266	3	0	\N
354929	1874	26856000	24695	12266	4	0	\N
354930	245	66778181541448	24696	12266	0	0	\N
354931	1678	26640839833000	24696	12266	1	0	\N
354932	2017	776780875847	24696	12266	2	0	\N
354933	1874	26854000	24696	12266	3	0	\N
354934	1874	26856000	24696	12266	4	0	\N
354940	245	66778181541448	24698	12266	0	0	\N
354941	1678	26640839833000	24698	12266	1	0	\N
354942	2017	776780875847	24698	12266	2	0	\N
354943	1874	26854000	24698	12266	3	0	\N
354944	1874	26856000	24698	12266	4	0	\N
354945	245	66778181541448	24699	12266	0	0	\N
354946	1678	26640839833000	24699	12266	1	0	\N
354947	2017	776780875847	24699	12266	2	0	\N
354948	1874	26854000	24699	12266	3	0	\N
354949	1874	26856000	24699	12266	4	0	\N
354827	1874	26785000	24679	12258	1	0	2
354828	1002	508641525000000	24679	12258	2	0	0
354829	1874	26788000	24679	12258	3	0	2
354830	1874	26790000	24679	12258	4	0	2
354831	1678	26640839821000	24680	12259	0	0	0
354833	1874	26795000	24680	12259	2	0	2
354834	1678	26640839822000	24681	12260	0	0	0
354835	1678	26640839823000	24681	12260	1	0	0
354836	1678	26640839824000	24681	12260	2	0	0
354837	1874	26796000	24681	12260	3	0	2
354839	1874	26799000	24681	12260	6	0	2
354840	1874	26802000	24681	12260	7	0	2
354841	1874	26805000	24681	12260	8	0	2
354842	1874	26807000	24681	12260	9	0	2
354844	1874	26811000	24681	12260	11	0	2
354856	1678	26640839825000	24683	12261	0	0	0
354857	1874	26813000	24683	12261	1	0	2
354858	1874	26816000	24683	12261	2	0	2
354879	1678	26640839826000	24686	12262	0	0	0
354881	1678	26640839828000	24686	12262	2	0	0
354882	1874	26817000	24686	12262	3	0	2
354883	1874	26819000	24686	12262	4	0	2
354884	1874	26821000	24686	12262	5	0	2
354885	1874	26823000	24686	12262	6	0	2
354887	1874	26829000	24686	12262	8	0	2
354888	1874	26832000	24686	12262	9	0	2
354896	1678	26640839829000	24689	12263	0	0	0
354897	1874	26835000	24689	12263	1	0	2
354899	756	1012990000000	24689	12263	3	0	0
354904	1678	26640839830000	24691	12264	0	0	0
354905	1874	26839000	24691	12264	1	0	2
354906	1874	26840000	24691	12264	2	0	2
354907	1874	26843000	24691	12264	3	0	2
354915	1678	26640839832000	24693	12265	1	0	0
354916	1874	26845000	24693	12265	2	0	2
354917	1874	26847000	24693	12265	3	0	2
354918	1874	26850000	24693	12265	4	0	2
354919	1874	26853000	24693	12265	5	0	2
354936	1678	26640839833000	24697	12266	1	0	0
354937	2017	776780875847	24697	12266	2	0	2
354938	1874	26854000	24697	12266	3	0	2
354939	1874	26856000	24697	12266	4	0	2
354951	1811	2128932225014	24700	12267	1	0	1
354952	283	66122729734615	24700	12267	2	0	1
354953	308	66778181541448	24700	12267	3	0	0
354954	186	66778181541448	24700	12267	4	0	0
354955	392	66778181541448	24700	12267	5	0	0
354957	1874	26861000	24700	12267	7	0	2
354958	1678	26640839835000	24701	12268	0	0	0
354959	301	66132720734615	24701	12268	1	0	2
354960	339	66778181541448	24701	12268	2	0	0
354965	408	66778181541448	24702	12269	0	0	\N
354966	1678	26640839836000	24702	12269	1	0	\N
354967	1678	26640839837000	24702	12269	2	0	\N
354968	1678	26640839838000	24702	12269	3	0	\N
354969	322	66778181541448	24702	12269	4	0	\N
354970	10	32619292617398	24702	12269	5	0	\N
354971	450	66778181541448	24702	12269	6	0	\N
354972	366	66122238827087	24702	12269	7	0	\N
354973	587	66778181541448	24702	12269	8	0	\N
354974	500	66778181541448	24702	12269	9	0	\N
354975	611	66778181541448	24702	12269	10	0	\N
354976	146	66778181541448	24702	12269	11	0	\N
354977	114	66118966901851	24702	12269	12	0	\N
354978	443	66122627545707	24702	12269	13	0	\N
354979	138	66778181541448	24702	12269	14	0	\N
354980	205	66778181541448	24702	12269	15	0	\N
354981	578	66122328993781	24702	12269	16	0	\N
354982	649	66122328993781	24702	12269	17	0	\N
354983	504	66165111541448	24702	12269	18	0	\N
354984	1276	1713954133592462	24702	12269	19	0	\N
354985	1874	26867000	24702	12269	20	0	\N
354986	1874	26869000	24702	12269	21	0	\N
354987	1874	26871000	24702	12269	22	0	\N
354988	1874	26873000	24702	12269	23	0	\N
354989	1874	26876000	24702	12269	24	0	\N
354990	1874	26879000	24702	12269	25	0	\N
354991	1874	26882000	24702	12269	26	0	\N
355019	408	66778181541448	24704	12269	0	0	\N
355020	1678	26640839836000	24704	12269	1	0	\N
355021	1678	26640839837000	24704	12269	2	0	\N
355022	1678	26640839838000	24704	12269	3	0	\N
355023	322	66778181541448	24704	12269	4	0	\N
355024	10	32619292617398	24704	12269	5	0	\N
355025	450	66778181541448	24704	12269	6	0	\N
355026	366	66122238827087	24704	12269	7	0	\N
355027	587	66778181541448	24704	12269	8	0	\N
355028	500	66778181541448	24704	12269	9	0	\N
355029	611	66778181541448	24704	12269	10	0	\N
355030	146	66778181541448	24704	12269	11	0	\N
355031	114	66118966901851	24704	12269	12	0	\N
355032	443	66122627545707	24704	12269	13	0	\N
355033	138	66778181541448	24704	12269	14	0	\N
355034	205	66778181541448	24704	12269	15	0	\N
355035	578	66122328993781	24704	12269	16	0	\N
355036	649	66122328993781	24704	12269	17	0	\N
355037	504	66165111541448	24704	12269	18	0	\N
355038	1276	1713954133592462	24704	12269	19	0	\N
355039	1874	26867000	24704	12269	20	0	\N
355040	1874	26869000	24704	12269	21	0	\N
355041	1874	26871000	24704	12269	22	0	\N
355042	1874	26873000	24704	12269	23	0	\N
355043	1874	26876000	24704	12269	24	0	\N
355044	1874	26879000	24704	12269	25	0	\N
355045	1874	26882000	24704	12269	26	0	\N
355046	408	66778181541448	24705	12269	0	0	\N
355047	1678	26640839836000	24705	12269	1	0	\N
355048	1678	26640839837000	24705	12269	2	0	\N
355049	1678	26640839838000	24705	12269	3	0	\N
355050	322	66778181541448	24705	12269	4	0	\N
355051	10	32619292617398	24705	12269	5	0	\N
355052	450	66778181541448	24705	12269	6	0	\N
355053	366	66122238827087	24705	12269	7	0	\N
355054	587	66778181541448	24705	12269	8	0	\N
355055	500	66778181541448	24705	12269	9	0	\N
355056	611	66778181541448	24705	12269	10	0	\N
355057	146	66778181541448	24705	12269	11	0	\N
355058	114	66118966901851	24705	12269	12	0	\N
355059	443	66122627545707	24705	12269	13	0	\N
355060	138	66778181541448	24705	12269	14	0	\N
355061	205	66778181541448	24705	12269	15	0	\N
355062	578	66122328993781	24705	12269	16	0	\N
355063	649	66122328993781	24705	12269	17	0	\N
355064	504	66165111541448	24705	12269	18	0	\N
355065	1276	1713954133592462	24705	12269	19	0	\N
355066	1874	26867000	24705	12269	20	0	\N
355067	1874	26869000	24705	12269	21	0	\N
355068	1874	26871000	24705	12269	22	0	\N
355069	1874	26873000	24705	12269	23	0	\N
355070	1874	26876000	24705	12269	24	0	\N
355071	1874	26879000	24705	12269	25	0	\N
355072	1874	26882000	24705	12269	26	0	\N
354963	1874	26864000	24701	12268	5	0	2
354964	1874	26866000	24701	12268	6	0	2
354992	408	66778181541448	24703	12269	0	0	0
354993	1678	26640839836000	24703	12269	1	0	0
354994	1678	26640839837000	24703	12269	2	0	0
354996	322	66778181541448	24703	12269	4	0	0
354997	10	32619292617398	24703	12269	5	0	1
354998	450	66778181541448	24703	12269	6	0	0
354999	366	66122238827087	24703	12269	7	0	1
355000	587	66778181541448	24703	12269	8	0	0
355002	611	66778181541448	24703	12269	10	0	0
355003	146	66778181541448	24703	12269	11	0	0
355004	114	66118966901851	24703	12269	12	0	9
355005	443	66122627545707	24703	12269	13	0	3
355007	205	66778181541448	24703	12269	15	0	0
355008	578	66122328993781	24703	12269	16	0	1
355009	649	66122328993781	24703	12269	17	0	1
355010	504	66165111541448	24703	12269	18	0	3
355011	1276	1713954133592462	24703	12269	19	0	0
355013	1874	26869000	24703	12269	21	0	2
355014	1874	26871000	24703	12269	22	0	2
355015	1874	26873000	24703	12269	23	0	2
355016	1874	26876000	24703	12269	24	0	2
355017	1874	26879000	24703	12269	25	0	2
355073	194	66778181541448	24706	12270	0	0	0
355074	399	66778181541448	24706	12270	1	0	0
355075	1678	26640839839000	24706	12270	2	0	0
355076	636	66122238827087	24706	12270	3	0	1
355078	1874	26884000	24706	12270	5	0	2
355079	1874	26887000	24706	12270	6	0	2
355080	1678	26640839840000	24707	12271	0	0	0
355081	105	66778181541448	24707	12271	1	0	0
355082	206	66778181541448	24707	12271	2	0	0
355084	499	66778181541448	24707	12271	4	0	0
355085	1030	911596720871342	24707	12271	5	0	0
355086	238	66122425123421	24707	12271	6	0	4
355087	1874	26889000	24707	12271	7	0	2
355088	1874	26892000	24707	12271	8	0	2
355090	120	66123140493981	24708	12272	0	0	1
355091	320	66496460729956	24708	12272	1	0	2
355092	251	66778181541448	24708	12272	2	0	0
355093	1678	26640839841000	24708	12272	3	0	0
355095	663	66778181541448	24708	12272	5	0	0
355096	1874	26896000	24708	12272	7	0	2
355098	1678	26640839841000	24709	12272	0	0	\N
355099	1874	26896000	24709	12272	1	0	\N
355100	1874	26898000	24709	12272	2	0	\N
355101	120	66123140493981	24710	12272	0	0	\N
355102	320	66496460729956	24710	12272	1	0	\N
355103	251	66778181541448	24710	12272	2	0	\N
355104	1678	26640839841000	24710	12272	3	0	\N
355105	312	66122238827087	24710	12272	4	0	\N
355106	663	66778181541448	24710	12272	5	0	\N
355107	1874	26896000	24710	12272	7	0	\N
355108	1874	26898000	24710	12272	8	0	\N
355116	1772	5574212177275	24712	12273	0	0	\N
355117	354	66124633253615	24712	12273	1	0	\N
355118	1678	26640839842000	24712	12273	2	0	\N
355119	570	66778181541448	24712	12273	3	0	\N
355120	894	310440551901528	24712	12273	4	0	\N
355121	1874	26901000	24712	12273	5	0	\N
355122	1874	26903000	24712	12273	6	0	\N
355123	1772	5574212177275	24713	12273	0	0	\N
355124	354	66124633253615	24713	12273	1	0	\N
355125	1678	26640839842000	24713	12273	2	0	\N
355126	570	66778181541448	24713	12273	3	0	\N
355127	894	310440551901528	24713	12273	4	0	\N
355128	1874	26901000	24713	12273	5	0	\N
355129	1874	26903000	24713	12273	6	0	\N
355130	569	66778181541448	24714	12274	0	0	\N
355131	1678	26640839843000	24714	12274	1	0	\N
355132	390	66778181541448	24714	12274	2	0	\N
355133	342	66123340864401	24714	12274	3	0	\N
355134	731	2023581258730	24714	12274	4	0	\N
355135	1874	26904000	24714	12274	5	0	\N
355136	1874	26906000	24714	12274	6	0	\N
355140	1678	26640839844000	24716	12275	0	0	\N
355141	569	66778181541448	24716	12275	1	0	\N
355142	390	66778181541448	24716	12275	2	0	\N
355143	342	66123340864401	24716	12275	3	0	\N
355144	731	2023581258730	24716	12275	4	0	\N
355145	1874	26909000	24716	12275	5	0	\N
355146	1874	26911000	24716	12275	6	0	\N
355161	1678	26640839847000	24719	12277	0	0	\N
355162	82	66778181541448	24719	12277	1	0	\N
355163	361	66128179541448	24719	12277	2	0	\N
355164	402	66778181541448	24719	12277	3	0	\N
355165	275	66778181541448	24719	12277	4	0	\N
355166	452	66778181541448	24719	12277	5	0	\N
355167	1874	26922000	24719	12277	6	0	\N
355168	1874	26925000	24719	12277	7	0	\N
355169	1678	26640839847000	24720	12277	0	0	\N
355170	82	66778181541448	24720	12277	1	0	\N
355171	361	66128179541448	24720	12277	2	0	\N
355172	402	66778181541448	24720	12277	3	0	\N
355173	275	66778181541448	24720	12277	4	0	\N
355174	452	66778181541448	24720	12277	5	0	\N
355175	1874	26922000	24720	12277	6	0	\N
355176	1874	26925000	24720	12277	7	0	\N
355177	1678	26640839847000	24721	12277	0	0	\N
355178	82	66778181541448	24721	12277	1	0	\N
355179	361	66128179541448	24721	12277	2	0	\N
355180	402	66778181541448	24721	12277	3	0	\N
355181	275	66778181541448	24721	12277	4	0	\N
355182	452	66778181541448	24721	12277	5	0	\N
355183	1874	26922000	24721	12277	6	0	\N
355184	1874	26925000	24721	12277	7	0	\N
355229	1678	26640839847000	24724	12278	0	0	\N
355230	1678	26640839848000	24724	12278	1	0	\N
355231	1678	26640839849000	24724	12278	2	0	\N
355232	1678	26640839850000	24724	12278	3	0	\N
355110	354	66124633253615	24711	12273	1	0	1
355111	1678	26640839842000	24711	12273	2	0	0
355112	570	66778181541448	24711	12273	3	0	0
355113	894	310440551901528	24711	12273	4	0	0
355114	1874	26901000	24711	12273	5	0	2
355137	1678	26640839843000	24715	12274	0	0	0
355138	1874	26904000	24715	12274	1	0	2
355139	1874	26906000	24715	12274	2	0	2
355147	1678	26640839844000	24717	12275	0	0	0
355148	569	66778181541448	24717	12275	1	0	0
355150	342	66123340864401	24717	12275	3	0	1
355151	731	2023581258730	24717	12275	4	0	0
355152	1874	26909000	24717	12275	5	0	2
355153	1678	26640839845000	24718	12276	0	0	0
355155	309	66778181541448	24718	12276	2	0	0
355156	1874	26911000	24718	12276	3	0	2
355157	1874	26912000	24718	12276	4	0	2
355158	1874	26914000	24718	12276	5	0	2
355159	1874	26917000	24718	12276	6	0	2
355185	1678	26640839847000	24723	12278	0	0	0
355186	1678	26640839848000	24723	12278	1	0	0
355187	1678	26640839849000	24723	12278	2	0	0
355188	1678	26640839850000	24723	12278	3	0	0
355189	1678	26640839851000	24723	12278	4	0	0
355191	361	66128179541448	24723	12278	6	0	2
355192	402	66778181541448	24723	12278	7	0	0
355193	275	66778181541448	24723	12278	8	0	0
355194	452	66778181541448	24723	12278	9	0	0
355196	391	66777071541448	24723	12278	11	0	1
355197	680	66778181541448	24723	12278	12	0	0
355198	690	66778181541448	24723	12278	13	0	0
355199	2181	776433347551	24723	12278	14	0	1
355200	327	66122238827087	24723	12278	15	0	1
355202	266	66165161541448	24723	12278	17	0	2
355203	352	66778181541448	24723	12278	18	0	0
355204	534	66778181541448	24723	12278	19	0	0
355205	520	66778181541448	24723	12278	20	0	0
355206	551	66778181541448	24723	12278	21	0	0
355208	421	66778181541448	24723	12278	23	0	0
355209	1150	615072472419738	24723	12278	24	0	0
355210	84	66778181541448	24723	12278	25	0	0
355211	379	66122328993781	24723	12278	26	0	1
355213	89	66778181541448	24723	12278	28	0	0
355214	383	66778181541448	24723	12278	29	0	0
355215	91	66778181541448	24723	12278	30	0	0
355216	438	66778181541448	24723	12278	31	0	0
355217	745	2023581258730	24723	12278	32	0	0
355219	1874	26925000	24723	12278	34	0	2
355220	1874	26926000	24723	12278	35	0	2
355221	1874	26928000	24723	12278	36	0	2
355222	1874	26930000	24723	12278	37	0	2
355223	1874	26933000	24723	12278	38	0	2
355225	1874	26937000	24723	12278	40	0	2
355226	1874	26940000	24723	12278	41	0	2
355227	1874	26943000	24723	12278	42	0	2
355228	1874	26946000	24723	12278	43	0	2
355233	1678	26640839851000	24724	12278	4	0	\N
355234	82	66778181541448	24724	12278	5	0	\N
355235	361	66128179541448	24724	12278	6	0	\N
355236	402	66778181541448	24724	12278	7	0	\N
355237	275	66778181541448	24724	12278	8	0	\N
355238	452	66778181541448	24724	12278	9	0	\N
355239	458	66124633253615	24724	12278	10	0	\N
355240	391	66777071541448	24724	12278	11	0	\N
355241	680	66778181541448	24724	12278	12	0	\N
355242	690	66778181541448	24724	12278	13	0	\N
355243	2181	776433347551	24724	12278	14	0	\N
355244	327	66122238827087	24724	12278	15	0	\N
355245	652	66778181541448	24724	12278	16	0	\N
355246	266	66165161541448	24724	12278	17	0	\N
355247	352	66778181541448	24724	12278	18	0	\N
355248	534	66778181541448	24724	12278	19	0	\N
355249	520	66778181541448	24724	12278	20	0	\N
355250	551	66778181541448	24724	12278	21	0	\N
355251	191	66778181541448	24724	12278	22	0	\N
355252	421	66778181541448	24724	12278	23	0	\N
355253	1150	615072472419738	24724	12278	24	0	\N
355254	84	66778181541448	24724	12278	25	0	\N
355255	379	66122328993781	24724	12278	26	0	\N
355256	678	66778181541448	24724	12278	27	0	\N
355257	89	66778181541448	24724	12278	28	0	\N
355258	383	66778181541448	24724	12278	29	0	\N
355259	91	66778181541448	24724	12278	30	0	\N
355260	438	66778181541448	24724	12278	31	0	\N
355261	745	2023581258730	24724	12278	32	0	\N
355262	1874	26922000	24724	12278	33	0	\N
355263	1874	26925000	24724	12278	34	0	\N
355264	1874	26926000	24724	12278	35	0	\N
355265	1874	26928000	24724	12278	36	0	\N
355266	1874	26930000	24724	12278	37	0	\N
355267	1874	26933000	24724	12278	38	0	\N
355268	1874	26935000	24724	12278	39	0	\N
355269	1874	26937000	24724	12278	40	0	\N
355270	1874	26940000	24724	12278	41	0	\N
355271	1874	26943000	24724	12278	42	0	\N
355272	1874	26946000	24724	12278	43	0	\N
355273	1678	26640839847000	24725	12278	0	0	\N
355274	1678	26640839848000	24725	12278	1	0	\N
355275	1678	26640839849000	24725	12278	2	0	\N
355276	1678	26640839850000	24725	12278	3	0	\N
355277	1678	26640839851000	24725	12278	4	0	\N
355278	82	66778181541448	24725	12278	5	0	\N
355279	361	66128179541448	24725	12278	6	0	\N
355280	402	66778181541448	24725	12278	7	0	\N
355281	275	66778181541448	24725	12278	8	0	\N
355282	452	66778181541448	24725	12278	9	0	\N
355283	458	66124633253615	24725	12278	10	0	\N
355284	391	66777071541448	24725	12278	11	0	\N
355285	680	66778181541448	24725	12278	12	0	\N
355286	690	66778181541448	24725	12278	13	0	\N
355287	2181	776433347551	24725	12278	14	0	\N
355288	327	66122238827087	24725	12278	15	0	\N
355289	652	66778181541448	24725	12278	16	0	\N
355290	266	66165161541448	24725	12278	17	0	\N
355291	352	66778181541448	24725	12278	18	0	\N
355292	534	66778181541448	24725	12278	19	0	\N
355293	520	66778181541448	24725	12278	20	0	\N
355294	551	66778181541448	24725	12278	21	0	\N
355295	191	66778181541448	24725	12278	22	0	\N
355296	421	66778181541448	24725	12278	23	0	\N
355297	1150	615072472419738	24725	12278	24	0	\N
355298	84	66778181541448	24725	12278	25	0	\N
355299	379	66122328993781	24725	12278	26	0	\N
355300	678	66778181541448	24725	12278	27	0	\N
355301	89	66778181541448	24725	12278	28	0	\N
355302	383	66778181541448	24725	12278	29	0	\N
355303	91	66778181541448	24725	12278	30	0	\N
355304	438	66778181541448	24725	12278	31	0	\N
355305	745	2023581258730	24725	12278	32	0	\N
355306	1874	26922000	24725	12278	33	0	\N
355307	1874	26925000	24725	12278	34	0	\N
355308	1874	26926000	24725	12278	35	0	\N
355309	1874	26928000	24725	12278	36	0	\N
355310	1874	26930000	24725	12278	37	0	\N
355311	1874	26933000	24725	12278	38	0	\N
355312	1874	26935000	24725	12278	39	0	\N
355313	1874	26937000	24725	12278	40	0	\N
355314	1874	26940000	24725	12278	41	0	\N
355315	1874	26943000	24725	12278	42	0	\N
355316	1874	26946000	24725	12278	43	0	\N
355340	1678	26640839855000	24728	12281	0	0	\N
355341	1874	26965000	24728	12281	1	0	\N
355342	1874	26967000	24728	12281	2	0	\N
355353	262	66122305010443	24734	12283	0	0	\N
355354	660	66778181541448	24734	12283	1	0	\N
355355	1678	26640839857000	24734	12283	2	0	\N
355356	304	66778181541448	24734	12283	4	0	\N
355357	441	66122248845612	24734	12283	5	0	\N
355358	122	66778181541448	24734	12283	6	0	\N
355359	1874	26975000	24734	12283	7	0	\N
355360	1874	26978000	24734	12283	8	0	\N
355361	262	66122305010443	24735	12283	0	0	\N
355362	660	66778181541448	24735	12283	1	0	\N
355363	304	66778181541448	24735	12283	2	0	\N
355364	441	66122248845612	24735	12283	4	0	\N
355365	122	66778181541448	24735	12283	5	0	\N
355366	1874	26975000	24735	12283	6	0	\N
355367	1874	26978000	24735	12283	7	0	\N
355319	63	66778181541448	24726	12279	2	0	0
355320	150	66778181541448	24726	12279	3	0	0
355321	92	66778181541448	24726	12279	4	0	0
355322	562	66122328993781	24726	12279	5	0	1
355323	910	508705959522200	24726	12279	6	0	0
355325	395	66275134929575	24726	12279	8	0	2
355326	78	66778181541448	24726	12279	9	0	0
355327	1678	26640839852000	24726	12279	10	0	0
355328	1678	26640839853000	24726	12279	11	0	0
355329	1874	26947000	24726	12279	12	0	2
355331	1874	26951000	24726	12279	14	0	2
355332	1874	26954000	24726	12279	15	0	2
355333	1874	26957000	24726	12279	16	0	2
355334	1678	26640839854000	24727	12280	0	0	0
355336	593	66777180541448	24727	12280	2	0	1
355337	154	66122328993781	24727	12280	3	0	1
355338	1874	26959000	24727	12280	4	0	2
355339	1874	26962000	24727	12280	5	0	2
355343	1678	26640839855000	24729	12281	0	0	0
355345	1874	26967000	24729	12281	2	0	2
355346	1961	777093716675	24732	12282	0	0	1
355347	1678	26640839856000	24732	12282	1	0	0
355348	658	66778181541448	24732	12282	2	0	0
355349	240	66123340864401	24732	12282	3	0	1
355351	1874	26972000	24732	12282	5	0	2
355352	1874	26973000	24732	12282	6	0	2
355368	262	66122305010443	24736	12283	0	0	4
355375	2308	119490184646	24737	12284	0	0	\N
355376	1678	26640839857000	24737	12284	1	0	\N
355377	1678	26640839858000	24737	12284	2	0	\N
355378	653	66778181541448	24737	12284	3	0	\N
355379	217	66778181541448	24737	12284	4	0	\N
355380	103	66778181541448	24737	12284	5	0	\N
355381	1874	26981000	24737	12284	6	0	\N
355382	1874	26983000	24737	12284	7	0	\N
355398	35	19426380084717	24740	12286	0	0	\N
355399	49	66778181541448	24740	12286	1	0	\N
355400	1678	26640839860000	24740	12286	2	0	\N
355401	1678	26640839861000	24740	12286	3	0	\N
355402	1778	5453794416372	24740	12286	4	0	\N
355403	99	66778181541448	24740	12286	5	0	\N
355404	108	66778181541448	24740	12286	6	0	\N
355405	252	66778181541448	24740	12286	7	0	\N
355406	225	66778181541448	24740	12286	8	0	\N
355407	377	66778181541448	24740	12286	9	0	\N
355408	560	66778181541448	24740	12286	10	0	\N
355409	594	66778181541448	24740	12286	11	0	\N
355410	201	66778181541448	24740	12286	12	0	\N
355411	1874	26991000	24740	12286	13	0	\N
355412	1874	26993000	24740	12286	14	0	\N
355413	1874	26995000	24740	12286	15	0	\N
355414	1874	26996000	24740	12286	16	0	\N
355415	1874	26999000	24740	12286	17	0	\N
355416	35	19426380084717	24741	12286	0	0	\N
355417	49	66778181541448	24741	12286	1	0	\N
355418	1678	26640839860000	24741	12286	2	0	\N
355419	1678	26640839861000	24741	12286	3	0	\N
355420	1778	5453794416372	24741	12286	4	0	\N
355421	99	66778181541448	24741	12286	5	0	\N
355422	108	66778181541448	24741	12286	6	0	\N
355423	252	66778181541448	24741	12286	7	0	\N
355424	225	66778181541448	24741	12286	8	0	\N
355425	377	66778181541448	24741	12286	9	0	\N
355426	560	66778181541448	24741	12286	10	0	\N
355427	594	66778181541448	24741	12286	11	0	\N
355428	201	66778181541448	24741	12286	12	0	\N
355429	1874	26991000	24741	12286	13	0	\N
355430	1874	26993000	24741	12286	14	0	\N
355431	1874	26995000	24741	12286	15	0	\N
355432	1874	26996000	24741	12286	16	0	\N
355433	1874	26999000	24741	12286	17	0	\N
355452	163	66778181541448	24743	12287	0	0	\N
355453	1962	777093716675	24743	12287	1	0	\N
355454	748	2725998633389	24743	12287	2	0	\N
355455	2073	776356451518	24743	12287	3	0	\N
355456	180	66778181541448	24743	12287	4	0	\N
355457	1678	26640839862000	24743	12287	5	0	\N
355458	1874	27002000	24743	12287	6	0	\N
355459	1874	27004000	24743	12287	7	0	\N
355468	163	66778181541448	24745	12287	0	0	\N
355469	1962	777093716675	24745	12287	1	0	\N
355470	748	2725998633389	24745	12287	2	0	\N
355471	2073	776356451518	24745	12287	3	0	\N
355472	180	66778181541448	24745	12287	4	0	\N
355473	1678	26640839862000	24745	12287	5	0	\N
355474	1874	27002000	24745	12287	6	0	\N
355475	1874	27004000	24745	12287	7	0	\N
355484	1678	26640839863000	24747	12288	0	0	\N
355485	237	66122328993781	24747	12288	1	0	\N
355486	2164	776842347551	24747	12288	2	0	\N
355487	165	66122328993781	24747	12288	3	0	\N
355488	600	66778181541448	24747	12288	4	0	\N
355489	1874	27007000	24747	12288	5	0	\N
355490	1874	27008000	24747	12288	6	0	\N
355491	1874	27010000	24747	12288	7	0	\N
355496	1678	26640839866000	24749	12290	0	0	\N
355497	691	66778181541448	24749	12290	1	0	\N
355498	620	66778181541448	24749	12290	2	0	\N
355499	1874	27018000	24749	12290	3	0	\N
355500	1874	27020000	24749	12290	4	0	\N
355501	1874	27022000	24749	12290	5	0	\N
355502	1874	27025000	24749	12290	6	0	\N
355503	1874	27026000	24749	12290	7	0	\N
355371	441	66122248845612	24736	12283	4	0	1
355372	122	66778181541448	24736	12283	5	0	0
355373	1874	26975000	24736	12283	6	0	2
355374	1874	26978000	24736	12283	7	0	2
355383	2308	119490184646	24738	12284	0	0	1
355385	1678	26640839858000	24738	12284	2	0	0
355386	653	66778181541448	24738	12284	3	0	0
355387	217	66778181541448	24738	12284	4	0	0
355388	103	66778181541448	24738	12284	5	0	0
355389	1874	26981000	24738	12284	6	0	2
355391	1678	26640839859000	24739	12285	0	0	0
355392	893	310440551901528	24739	12285	1	0	0
355393	54	66778181541448	24739	12285	2	0	0
355394	530	66700896958253	24739	12285	3	0	1
355396	1874	26985000	24739	12285	5	0	2
355397	1874	26988000	24739	12285	6	0	2
355434	35	19426380084717	24742	12286	0	0	0
355435	49	66778181541448	24742	12286	1	0	0
355436	1678	26640839860000	24742	12286	2	0	0
355438	1778	5453794416372	24742	12286	4	0	1
355439	99	66778181541448	24742	12286	5	0	0
355440	108	66778181541448	24742	12286	6	0	0
355441	252	66778181541448	24742	12286	7	0	0
355442	225	66778181541448	24742	12286	8	0	0
355444	560	66778181541448	24742	12286	10	0	0
355445	594	66778181541448	24742	12286	11	0	0
355446	201	66778181541448	24742	12286	12	0	0
355447	1874	26991000	24742	12286	13	0	2
355449	1874	26995000	24742	12286	15	0	2
355450	1874	26996000	24742	12286	16	0	2
355451	1874	26999000	24742	12286	17	0	2
355460	163	66778181541448	24744	12287	0	0	0
355461	1962	777093716675	24744	12287	1	0	1
355463	2073	776356451518	24744	12287	3	0	1
355464	180	66778181541448	24744	12287	4	0	0
355465	1678	26640839862000	24744	12287	5	0	0
355466	1874	27002000	24744	12287	6	0	2
355467	1874	27004000	24744	12287	7	0	2
355477	237	66122328993781	24746	12288	1	0	1
355478	2164	776842347551	24746	12288	2	0	1
355479	165	66122328993781	24746	12288	3	0	1
355480	600	66778181541448	24746	12288	4	0	0
355482	1874	27008000	24746	12288	6	0	2
355483	1874	27010000	24746	12288	7	0	2
355492	1678	26640839864000	24748	12289	0	0	0
355493	1678	26640839865000	24748	12289	1	0	0
355494	1874	27013000	24748	12289	2	0	2
355504	1678	26640839866000	24750	12290	0	0	0
355524	1678	26640839870000	24753	12292	0	0	\N
355525	1874	27040000	24753	12292	1	0	\N
355526	1874	27041000	24753	12292	2	0	\N
355527	1874	27044000	24753	12292	3	0	\N
355531	1678	26640839871000	24755	12293	0	0	\N
355532	1874	27047000	24755	12293	1	0	\N
355533	1874	27049000	24755	12293	2	0	\N
355534	1678	26640839871000	24756	12293	0	0	\N
355535	1874	27047000	24756	12293	1	0	\N
355536	1874	27049000	24756	12293	2	0	\N
355537	1678	26640839871000	24757	12293	0	0	\N
355538	1874	27047000	24757	12293	1	0	\N
355539	1678	26640839871000	24758	12293	0	0	\N
355540	1874	27047000	24758	12293	1	0	\N
355541	1874	27049000	24758	12293	2	0	\N
355542	1678	26640839872000	24759	12294	0	0	\N
355543	1678	26640839873000	24759	12294	1	0	\N
355544	1874	27050000	24759	12294	2	0	\N
355545	1874	27052000	24759	12294	3	0	\N
355546	1874	27054000	24759	12294	4	0	\N
355547	1874	27057000	24759	12294	5	0	\N
355548	1874	27060000	24759	12294	6	0	\N
355549	1678	26640839872000	24760	12294	0	0	\N
355550	1678	26640839873000	24760	12294	1	0	\N
355551	1874	27050000	24760	12294	2	0	\N
355552	1874	27053000	24760	12294	3	0	\N
355553	1874	27056000	24760	12294	4	0	\N
355554	1678	26640839872000	24761	12294	0	0	\N
355555	1678	26640839873000	24761	12294	1	0	\N
355556	1874	27050000	24761	12294	2	0	\N
355557	1874	27052000	24761	12294	3	0	\N
355558	1874	27054000	24761	12294	4	0	\N
355559	1874	27057000	24761	12294	5	0	\N
355560	1874	27060000	24761	12294	6	0	\N
355578	2068	1943000000000	24764	12296	0	0	\N
355579	1678	26640839876000	24764	12296	1	0	\N
355580	1874	27072000	24764	12296	2	0	\N
355581	1874	27074000	24764	12296	3	0	\N
355582	1874	27075000	24764	12296	5	0	\N
355583	1874	27078000	24764	12296	6	0	\N
355584	1874	27081000	24764	12296	7	0	\N
355595	1678	26640839877000	24767	12297	0	0	\N
355596	1874	27084000	24767	12297	1	0	\N
355597	1874	27086000	24767	12297	2	0	\N
355598	1678	26640839877000	24768	12297	0	0	\N
355599	1874	27084000	24768	12297	1	0	\N
355607	1678	26640839879000	24771	12299	0	0	\N
355608	1874	27094000	24771	12299	1	0	\N
355609	1874	27096000	24771	12299	2	0	\N
355610	1874	27097000	24771	12299	3	0	\N
355611	1678	26640839880000	24772	12300	0	0	\N
355612	1874	27100000	24772	12300	1	0	\N
355613	1874	27102000	24772	12300	2	0	\N
355617	1678	26640839881000	24774	12301	0	0	\N
355618	1874	27104000	24774	12301	1	0	\N
355621	1678	26640839882000	24776	12302	0	0	\N
355622	1874	27107000	24776	12302	1	0	\N
355623	1874	27108000	24776	12302	2	0	\N
355624	1874	27110000	24776	12302	3	0	\N
355629	1678	26640839883000	24778	12303	0	0	\N
355630	1678	26640839884000	24778	12303	1	0	\N
355631	1874	27113000	24778	12303	2	0	\N
355632	1874	27116000	24778	12303	3	0	\N
355633	1874	27118000	24778	12303	4	0	\N
355634	1874	27120000	24778	12303	5	0	\N
355507	1874	27018000	24750	12290	3	0	2
355508	1874	27020000	24750	12290	4	0	2
355509	1874	27022000	24750	12290	5	0	2
355510	1874	27025000	24750	12290	6	0	2
355511	1874	27026000	24750	12290	7	0	2
355513	1678	26640839868000	24751	12291	1	0	0
355514	1678	26640839869000	24751	12291	2	0	0
355515	1874	27029000	24751	12291	3	0	2
355516	1874	27032000	24751	12291	4	0	2
355517	1874	27034000	24751	12291	5	0	2
355519	1874	27038000	24751	12291	7	0	2
355520	1678	26640839870000	24752	12292	0	0	0
355521	1874	27040000	24752	12292	1	0	2
355522	1874	27041000	24752	12292	2	0	2
355528	1678	26640839871000	24754	12293	0	0	0
355529	1874	27047000	24754	12293	1	0	2
355530	1874	27049000	24754	12293	2	0	2
355561	1678	26640839872000	24762	12294	0	0	0
355562	1678	26640839873000	24762	12294	1	0	0
355564	1874	27052000	24762	12294	3	0	2
355565	1874	27054000	24762	12294	4	0	2
355566	1874	27057000	24762	12294	5	0	2
355567	1874	27060000	24762	12294	6	0	2
355568	1392	1710871984751650	24763	12295	0	0	0
355570	1678	26640839875000	24763	12295	2	0	0
355571	1146	909957426000000	24763	12295	3	0	0
355572	1266	612507047000000	24763	12295	4	0	1
355573	1026	507791170000000	24763	12295	5	0	0
355575	1874	27065000	24763	12295	7	0	2
355576	1874	27068000	24763	12295	8	0	2
355577	1874	27070000	24763	12295	9	0	2
355585	2068	1943000000000	24765	12296	0	0	0
355586	1678	26640839876000	24765	12296	1	0	0
355588	1874	27074000	24765	12296	3	0	2
355589	1874	27075000	24765	12296	5	0	2
355590	1874	27078000	24765	12296	6	0	2
355591	1874	27081000	24765	12296	7	0	2
355592	1678	26640839877000	24766	12297	0	0	0
355594	1874	27086000	24766	12297	2	0	2
355600	1678	26640839878000	24769	12298	0	0	0
355601	1874	27088000	24769	12298	1	0	2
355602	1874	27091000	24769	12298	2	0	2
355604	1874	27094000	24770	12299	1	0	2
355605	1874	27096000	24770	12299	2	0	2
355606	1874	27097000	24770	12299	3	0	2
355614	1678	26640839880000	24773	12300	0	0	0
355615	1874	27100000	24773	12300	1	0	2
355619	1678	26640839881000	24775	12301	0	0	0
355620	1874	27104000	24775	12301	1	0	2
355625	1678	26640839882000	24777	12302	0	0	0
355626	1874	27107000	24777	12302	1	0	2
355627	1874	27108000	24777	12302	2	0	2
355635	1678	26640839883000	24779	12303	0	0	0
355636	1678	26640839884000	24779	12303	1	0	0
355637	1874	27113000	24779	12303	2	0	2
355638	1874	27116000	24779	12303	3	0	2
355640	1874	27120000	24779	12303	5	0	2
355645	2291	255757211465	24781	12157	0	0	\N
355646	2288	776757211465	24781	12157	1	0	\N
355647	50	66779714905251	24781	12157	2	0	\N
355648	1006	508416004675840	24781	12157	3	0	\N
355649	1126	911077124270784	24781	12157	4	0	\N
355650	1246	614721890239616	24781	12157	5	0	\N
355651	1372	1712977205175714	24781	12157	6	0	\N
355652	245	66778181541448	24781	12157	7	0	\N
355653	1010	508715470792656	24781	12157	8	0	\N
355654	1130	911613764986289	24781	12157	9	0	\N
355655	2068	935000000000	24781	12157	10	0	\N
355656	1392	1710871984751650	24781	12157	11	0	\N
355657	1250	615083972423684	24781	12157	12	0	\N
355658	1376	1713986179376152	24781	12157	13	0	\N
355659	1146	909957426000000	24781	12157	15	0	\N
355660	1266	612507047000000	24781	12157	16	0	\N
355661	2017	776780875847	24781	12157	17	0	\N
355662	1811	2128932225014	24781	12157	18	0	\N
355663	283	66122729734615	24781	12157	19	0	\N
355664	308	66778181541448	24781	12157	20	0	\N
355665	186	66778181541448	24781	12157	21	0	\N
355666	392	66778181541448	24781	12157	22	0	\N
355667	301	66132720734615	24781	12157	24	0	\N
355668	339	66778181541448	24781	12157	25	0	\N
355669	601	66778181541448	24781	12157	26	0	\N
355670	1821	776898579462	24781	12157	27	0	\N
355671	408	66778181541448	24781	12157	28	0	\N
355672	322	66778181541448	24781	12157	29	0	\N
355673	10	32619292617398	24781	12157	30	0	\N
355674	450	66778181541448	24781	12157	31	0	\N
355675	366	66122238827087	24781	12157	32	0	\N
355676	587	66778181541448	24781	12157	33	0	\N
355677	500	66778181541448	24781	12157	34	0	\N
355678	611	66778181541448	24781	12157	35	0	\N
355679	146	66778181541448	24781	12157	36	0	\N
355680	114	66118966901851	24781	12157	37	0	\N
355681	443	66122627545707	24781	12157	38	0	\N
355682	138	66778181541448	24781	12157	39	0	\N
355683	205	66778181541448	24781	12157	40	0	\N
355684	578	66122328993781	24781	12157	41	0	\N
355685	649	66122328993781	24781	12157	42	0	\N
355686	504	66165111541448	24781	12157	43	0	\N
355687	1276	1713954133592462	24781	12157	44	0	\N
355688	194	66778181541448	24781	12157	45	0	\N
355689	399	66778181541448	24781	12157	46	0	\N
355690	636	66122238827087	24781	12157	47	0	\N
355691	721	2023581258730	24781	12157	48	0	\N
355692	105	66778181541448	24781	12157	49	0	\N
355693	206	66778181541448	24781	12157	50	0	\N
355694	710	5058953147009	24781	12157	51	0	\N
355695	499	66778181541448	24781	12157	52	0	\N
355696	1030	911596720871342	24781	12157	53	0	\N
355697	238	66122425123421	24781	12157	54	0	\N
355698	120	66123140493981	24781	12157	55	0	\N
355729	1678	26640839895000	24789	12309	0	0	\N
355730	1874	27174000	24789	12309	1	0	\N
355731	1874	27177000	24789	12309	2	0	\N
355732	1874	27179000	24789	12309	3	0	\N
355737	1678	26640839896000	24792	12310	0	0	\N
355738	1678	26640839897000	24792	12310	1	0	\N
355739	1678	26640839898000	24792	12310	2	0	\N
355740	1874	27182000	24792	12310	3	0	\N
355741	1874	27184000	24792	12310	4	0	\N
355742	1874	27186000	24792	12310	5	0	\N
355743	1874	27188000	24792	12310	6	0	\N
355744	1874	27191000	24792	12310	7	0	\N
355745	1874	27194000	24792	12310	8	0	\N
355746	1403	0	24792	12310	9	0	\N
355747	1874	27181000	24793	12310	0	0	\N
355748	1874	27183000	24793	12310	1	0	\N
355749	1874	27185000	24793	12310	2	0	\N
355750	1403	0	24793	12310	3	0	\N
355771	1678	26640839902000	24797	12313	0	0	\N
355772	1874	27212000	24797	12313	1	0	\N
355773	1874	27213000	24797	12313	2	0	\N
355774	1874	27216000	24797	12313	3	0	\N
355643	1874	27125000	24780	12304	2	0	2
355644	1874	27126000	24780	12304	3	0	2
355699	1678	26640839886000	24782	12305	0	0	0
355700	1874	27129000	24782	12305	1	0	2
355701	1874	27131000	24782	12305	2	0	2
355703	1678	26640839888000	24784	12306	1	0	0
355704	1678	26640839889000	24784	12306	2	0	0
355705	1678	26640839890000	24784	12306	3	0	0
355706	1678	26640839891000	24784	12306	4	0	0
355707	1874	27133000	24784	12306	5	0	2
355709	1406	0	24784	12306	7	0	0
355710	1874	27137000	24784	12306	8	0	2
355711	1874	27140000	24784	12306	9	0	2
355712	1874	27143000	24784	12306	10	0	2
355714	1874	27149000	24784	12306	12	0	2
355715	1874	27152000	24784	12306	13	0	2
355716	1874	27153000	24784	12306	14	0	2
355717	1874	27155000	24784	12306	15	0	2
355718	1874	27157000	24784	12306	16	0	2
355720	1874	27159000	24785	12307	1	0	2
355721	1874	27160000	24785	12307	2	0	2
355722	1874	27163000	24785	12307	3	0	2
355723	1678	26640839893000	24786	12308	0	0	0
355724	1678	26640839894000	24786	12308	1	0	0
355726	1874	27168000	24786	12308	3	0	2
355727	1874	27171000	24786	12308	4	0	2
355728	1874	27173000	24786	12308	5	0	2
355733	1678	26640839895000	24790	12309	0	0	0
355735	1874	27177000	24790	12309	2	0	2
355736	1874	27179000	24790	12309	3	0	2
355751	1678	26640839896000	24794	12310	0	0	0
355752	1678	26640839897000	24794	12310	1	0	0
355753	1678	26640839898000	24794	12310	2	0	0
355755	1874	27184000	24794	12310	4	0	2
355756	1874	27186000	24794	12310	5	0	2
355757	1874	27188000	24794	12310	6	0	2
355758	1874	27191000	24794	12310	7	0	2
355759	1874	27194000	24794	12310	8	0	2
355761	1678	26640839899000	24795	12311	0	0	0
355762	1678	26640839900000	24795	12311	1	0	0
355763	1874	27195000	24795	12311	2	0	2
355764	1874	27198000	24795	12311	3	0	2
355766	1874	27203000	24795	12311	5	0	2
355767	1874	27205000	24795	12311	6	0	2
355768	1678	26640839901000	24796	12312	0	0	0
355769	1874	27208000	24796	12312	1	0	2
355770	1874	27210000	24796	12312	2	0	2
355776	1874	27212000	24798	12313	1	0	2
355800	1678	26640839907000	24804	12318	0	0	\N
355801	2314	122000000000	24804	12318	1	0	\N
355802	2314	238000000000	24804	12318	2	0	\N
355803	2314	299000000000	24804	12318	3	0	\N
355804	1874	27240000	24804	12318	4	0	\N
355805	1874	27242000	24804	12318	5	0	\N
355806	1678	26640839908000	24805	12319	0	0	\N
355807	2314	429000000000	24805	12319	1	0	\N
355808	1874	27245000	24805	12319	2	0	\N
355809	1874	27247000	24805	12319	3	0	\N
355814	1678	26640839908000	24807	12319	0	0	\N
355815	2314	429000000000	24807	12319	1	0	\N
355816	1874	27245000	24807	12319	2	0	\N
355817	1678	26640839909000	24808	12320	0	0	\N
355818	1874	27250000	24808	12320	1	0	\N
355819	1874	27252000	24808	12320	2	0	\N
355820	1874	27253000	24808	12320	3	0	\N
355823	245	66778181541448	24810	12261	0	0	\N
355824	1392	1710871984751650	24810	12261	1	0	\N
355825	2314	0	24810	12261	2	0	\N
355826	2314	1000000000	24810	12261	3	0	\N
355827	1146	909957426000000	24810	12261	4	0	\N
355828	1266	612507047000000	24810	12261	5	0	\N
355829	2017	776780875847	24810	12261	6	0	\N
355830	1811	2128932225014	24810	12261	7	0	\N
355831	283	66122729734615	24810	12261	8	0	\N
355832	308	66778181541448	24810	12261	9	0	\N
355833	186	66778181541448	24810	12261	10	0	\N
355834	392	66778181541448	24810	12261	11	0	\N
355835	301	66132720734615	24810	12261	12	0	\N
355836	339	66778181541448	24810	12261	13	0	\N
355837	601	66778181541448	24810	12261	14	0	\N
355838	1821	776898579462	24810	12261	15	0	\N
355839	408	66778181541448	24810	12261	16	0	\N
355840	322	66778181541448	24810	12261	17	0	\N
355841	10	32619292617398	24810	12261	18	0	\N
355842	450	66778181541448	24810	12261	19	0	\N
355843	366	66122238827087	24810	12261	20	0	\N
355844	587	66778181541448	24810	12261	21	0	\N
355845	500	66778181541448	24810	12261	22	0	\N
355846	611	66778181541448	24810	12261	23	0	\N
355847	146	66778181541448	24810	12261	24	0	\N
355848	114	66116946901851	24810	12261	25	0	\N
355849	443	66122627545707	24810	12261	26	0	\N
355850	138	66778181541448	24810	12261	27	0	\N
355851	205	66778181541448	24810	12261	28	0	\N
355852	578	66122328993781	24810	12261	29	0	\N
355853	649	66122328993781	24810	12261	30	0	\N
355854	504	66165111541448	24810	12261	31	0	\N
355855	1276	1713954133592462	24810	12261	32	0	\N
355856	194	66778181541448	24810	12261	33	0	\N
355857	399	66778181541448	24810	12261	34	0	\N
355858	636	66122238827087	24810	12261	35	0	\N
355859	721	2023581258730	24810	12261	36	0	\N
355860	105	66778181541448	24810	12261	37	0	\N
355861	206	66778181541448	24810	12261	38	0	\N
355862	710	5058953147009	24810	12261	39	0	\N
355863	499	66778181541448	24810	12261	40	0	\N
355864	1030	911596720871342	24810	12261	41	0	\N
355865	238	66122425123421	24810	12261	42	0	\N
355866	120	66123140493981	24810	12261	43	0	\N
355867	320	66496460729956	24810	12261	44	0	\N
355868	251	66778181541448	24810	12261	45	0	\N
355869	312	66122238827087	24810	12261	46	0	\N
355870	663	66778181541448	24810	12261	47	0	\N
355871	1772	5574212177275	24810	12261	48	0	\N
355872	354	66124633253615	24810	12261	49	0	\N
355873	570	66778181541448	24810	12261	50	0	\N
355874	894	310440551901528	24810	12261	51	0	\N
355875	569	66778181541448	24810	12261	52	0	\N
355876	390	66778181541448	24810	12261	53	0	\N
355877	342	66123340864401	24810	12261	54	0	\N
355878	731	2023581258730	24810	12261	55	0	\N
355879	309	66778181541448	24810	12261	56	0	\N
355880	82	66778181541448	24810	12261	57	0	\N
355881	361	66128179541448	24810	12261	58	0	\N
355882	402	66778181541448	24810	12261	59	0	\N
355883	275	66778181541448	24810	12261	60	0	\N
355884	452	66778181541448	24810	12261	61	0	\N
355885	1026	507791170000000	24810	12261	62	0	\N
355886	2068	1943000000000	24810	12261	63	0	\N
355887	458	66124633253615	24810	12261	64	0	\N
355888	391	66777071541448	24810	12261	65	0	\N
355889	680	66778181541448	24810	12261	66	0	\N
355890	690	66778181541448	24810	12261	67	0	\N
355891	2181	776433347551	24810	12261	68	0	\N
355892	327	66122238827087	24810	12261	69	0	\N
355893	652	66778181541448	24810	12261	70	0	\N
355894	266	66165161541448	24810	12261	71	0	\N
355895	352	66778181541448	24810	12261	72	0	\N
355896	534	66778181541448	24810	12261	73	0	\N
355897	520	66778181541448	24810	12261	74	0	\N
355898	551	66778181541448	24810	12261	75	0	\N
355899	191	66778181541448	24810	12261	76	0	\N
355900	421	66778181541448	24810	12261	77	0	\N
355901	1150	615072472419738	24810	12261	78	0	\N
355902	84	66778181541448	24810	12261	79	0	\N
355903	379	66122328993781	24810	12261	80	0	\N
355904	678	66778181541448	24810	12261	81	0	\N
355905	89	66778181541448	24810	12261	82	0	\N
355906	383	66778181541448	24810	12261	83	0	\N
355907	91	66778181541448	24810	12261	84	0	\N
355908	438	66778181541448	24810	12261	85	0	\N
355909	745	2023581258730	24810	12261	86	0	\N
355910	453	66778181541448	24810	12261	87	0	\N
355911	373	66778181541448	24810	12261	88	0	\N
355912	63	66778181541448	24810	12261	89	0	\N
355779	1678	26640839903000	24799	12314	0	0	0
355780	1874	27218000	24799	12314	2	0	2
355781	1874	27221000	24799	12314	3	0	2
355782	2314	0	24800	12315	0	0	0
355783	1678	26640839904000	24800	12315	1	0	0
355785	1874	27226000	24800	12315	3	0	2
355786	2314	1000000000	24801	12316	0	0	0
355787	1678	26640839905000	24801	12316	1	0	0
355788	1874	27229000	24801	12316	2	0	2
355789	1874	27230000	24801	12316	3	0	2
355791	1678	26640839906000	24802	12317	0	0	0
355792	1874	27234000	24802	12317	1	0	2
355793	1874	27237000	24802	12317	2	0	2
355794	1678	26640839907000	24803	12318	0	0	0
355796	2314	238000000000	24803	12318	2	0	0
355797	2314	299000000000	24803	12318	3	0	0
355798	1874	27240000	24803	12318	4	0	2
355799	1874	27242000	24803	12318	5	0	2
355810	1678	26640839908000	24806	12319	0	0	0
355812	1874	27245000	24806	12319	2	0	2
355813	1874	27247000	24806	12319	3	0	2
355821	1874	27249000	24809	12320	0	0	2
355822	1874	27250000	24809	12320	1	0	2
355913	150	66778181541448	24810	12261	90	0	\N
355914	92	66778181541448	24810	12261	91	0	\N
355915	562	66122328993781	24810	12261	92	0	\N
355916	910	508705959522200	24810	12261	93	0	\N
355917	711	3007950736827	24810	12261	94	0	\N
355918	395	66275134929575	24810	12261	95	0	\N
355919	78	66778181541448	24810	12261	96	0	\N
355920	29	7082534405834	24810	12261	97	0	\N
355921	593	66777180541448	24810	12261	98	0	\N
355922	154	66122328993781	24810	12261	99	0	\N
355923	1961	777093716675	24810	12261	100	0	\N
355924	658	66778181541448	24810	12261	101	0	\N
355925	240	66123340864401	24810	12261	102	0	\N
355926	262	66122305010443	24810	12261	103	0	\N
355927	660	66778181541448	24810	12261	104	0	\N
355928	304	66778181541448	24810	12261	105	0	\N
355929	441	66122248845612	24810	12261	106	0	\N
355930	122	66778181541448	24810	12261	107	0	\N
355931	2308	119490184646	24810	12261	108	0	\N
355932	653	66778181541448	24810	12261	109	0	\N
355933	217	66778181541448	24810	12261	110	0	\N
355934	103	66778181541448	24810	12261	111	0	\N
355935	1678	26640839909000	24811	12320	0	0	\N
355936	1874	27250000	24811	12320	1	0	\N
355937	1874	27252000	24811	12320	2	0	\N
355938	1874	27253000	24811	12320	3	0	\N
355939	1678	26640839909000	24812	12321	0	0	\N
355940	1678	26640839910000	24812	12321	1	0	\N
355941	1874	27253000	24812	12321	2	0	\N
355942	1874	27256000	24812	12321	3	0	\N
355943	1874	27258000	24812	12321	4	0	\N
355949	1678	26640839909000	24814	12321	0	0	\N
355950	1678	26640839910000	24814	12321	1	0	\N
355951	1874	27253000	24814	12321	2	0	\N
355952	1874	27256000	24814	12321	3	0	\N
355953	1874	27258000	24814	12321	4	0	\N
355954	1392	1710871984751650	24815	12287	0	0	\N
355955	2314	0	24815	12287	1	0	\N
355956	2314	1000000000	24815	12287	2	0	\N
355957	2314	122000000000	24815	12287	3	0	\N
355958	2314	238000000000	24815	12287	4	0	\N
355959	2314	368000000000	24815	12287	5	0	\N
355960	2314	429000000000	24815	12287	6	0	\N
355961	163	66778181541448	24815	12287	7	0	\N
355962	1962	777093716675	24815	12287	8	0	\N
355963	748	2725998633389	24815	12287	9	0	\N
355964	2073	776356451518	24815	12287	10	0	\N
355965	180	66778181541448	24815	12287	11	0	\N
355966	237	66122328993781	24815	12287	12	0	\N
355967	2164	776842347551	24815	12287	13	0	\N
355968	165	66122328993781	24815	12287	14	0	\N
355969	600	66778181541448	24815	12287	15	0	\N
355970	691	66778181541448	24815	12287	16	0	\N
355971	620	66778181541448	24815	12287	17	0	\N
355972	1678	26640839862000	24815	12287	18	0	\N
355973	1678	26640839863000	24815	12287	19	0	\N
355974	1678	26640839864000	24815	12287	20	0	\N
355975	1678	26640839865000	24815	12287	21	0	\N
355976	1678	26640839866000	24815	12287	22	0	\N
355977	1678	26640839867000	24815	12287	23	0	\N
355978	1678	26640839868000	24815	12287	24	0	\N
355979	1678	26640839869000	24815	12287	25	0	\N
355980	1678	26640839870000	24815	12287	26	0	\N
355981	1678	26640839871000	24815	12287	27	0	\N
355982	1678	26640839872000	24815	12287	28	0	\N
355983	1678	26640839873000	24815	12287	29	0	\N
355984	1678	26640839874000	24815	12287	30	0	\N
355985	1678	26640839875000	24815	12287	31	0	\N
355986	1678	26640839876000	24815	12287	32	0	\N
355987	1678	26640839877000	24815	12287	33	0	\N
355988	1146	909957426000000	24815	12287	34	0	\N
355989	1266	612507047000000	24815	12287	35	0	\N
355990	1026	507791170000000	24815	12287	36	0	\N
355991	2068	1943000000000	24815	12287	37	0	\N
355992	1678	26640839878000	24815	12287	38	0	\N
355993	1678	26640839879000	24815	12287	39	0	\N
355994	1678	26640839880000	24815	12287	40	0	\N
355995	1678	26640839881000	24815	12287	41	0	\N
355996	1678	26640839882000	24815	12287	42	0	\N
355997	1678	26640839883000	24815	12287	43	0	\N
355998	1678	26640839884000	24815	12287	44	0	\N
355999	1678	26640839885000	24815	12287	45	0	\N
356000	1678	26640839886000	24815	12287	46	0	\N
356001	1678	26640839887000	24815	12287	47	0	\N
356002	1678	26640839888000	24815	12287	48	0	\N
356003	1678	26640839889000	24815	12287	49	0	\N
356004	1678	26640839890000	24815	12287	50	0	\N
356005	1678	26640839891000	24815	12287	51	0	\N
356006	1678	26640839892000	24815	12287	52	0	\N
356007	1678	26640839893000	24815	12287	53	0	\N
356008	1678	26640839894000	24815	12287	54	0	\N
356009	1678	26640839895000	24815	12287	55	0	\N
356010	1678	26640839896000	24815	12287	56	0	\N
356011	1678	26640839897000	24815	12287	57	0	\N
356012	1678	26640839898000	24815	12287	58	0	\N
356013	1678	26640839899000	24815	12287	59	0	\N
356014	1678	26640839900000	24815	12287	60	0	\N
356015	1678	26640839901000	24815	12287	61	0	\N
356016	1678	26640839902000	24815	12287	62	0	\N
356017	1678	26640839903000	24815	12287	63	0	\N
356018	1678	26640839904000	24815	12287	64	0	\N
356019	1678	26640839905000	24815	12287	65	0	\N
356020	1678	26640839906000	24815	12287	66	0	\N
356021	1678	26640839907000	24815	12287	67	0	\N
356022	1678	26640839908000	24815	12287	68	0	\N
356023	1678	26640839909000	24815	12287	69	0	\N
356024	1874	27002000	24815	12287	70	0	\N
356025	1874	27005000	24815	12287	71	0	\N
356026	1406	0	24815	12287	72	0	\N
356027	1874	27006000	24815	12287	73	0	\N
356028	1874	27009000	24815	12287	74	0	\N
356029	1874	27012000	24815	12287	75	0	\N
356030	1874	27015000	24815	12287	76	0	\N
356031	1874	27018000	24815	12287	77	0	\N
356032	1874	27021000	24815	12287	78	0	\N
356033	1874	27022000	24815	12287	79	0	\N
356034	1874	27023000	24815	12287	80	0	\N
356035	1874	27024000	24815	12287	81	0	\N
356036	1874	27025000	24815	12287	83	0	\N
356037	1874	27026000	24815	12287	84	0	\N
356038	1874	27027000	24815	12287	85	0	\N
356039	1874	27028000	24815	12287	86	0	\N
356040	1874	27029000	24815	12287	87	0	\N
356041	1874	27030000	24815	12287	88	0	\N
356042	1874	27031000	24815	12287	89	0	\N
356043	1874	27032000	24815	12287	90	0	\N
356044	1874	27033000	24815	12287	91	0	\N
356045	1874	27034000	24815	12287	92	0	\N
356046	1874	27036000	24815	12287	93	0	\N
356047	1874	27038000	24815	12287	94	0	\N
356048	1874	27040000	24815	12287	95	0	\N
355946	1874	27253000	24813	12321	2	0	2
355947	1874	27256000	24813	12321	3	0	2
355948	1874	27258000	24813	12321	4	0	2
356049	1874	27042000	24815	12287	96	0	\N
356050	1874	27044000	24815	12287	97	0	\N
356051	1874	27046000	24815	12287	98	0	\N
356052	1874	27048000	24815	12287	99	0	\N
356053	1874	27050000	24815	12287	100	0	\N
356054	1874	27052000	24815	12287	101	0	\N
356055	1874	27054000	24815	12287	102	0	\N
356056	1874	27056000	24815	12287	103	0	\N
356057	1874	27058000	24815	12287	104	0	\N
356058	1874	27060000	24815	12287	105	0	\N
356059	1874	27062000	24815	12287	106	0	\N
356060	1874	27064000	24815	12287	107	0	\N
356061	1874	27066000	24815	12287	108	0	\N
356062	1874	27068000	24815	12287	109	0	\N
356063	1874	27070000	24815	12287	110	0	\N
356064	1874	27072000	24815	12287	111	0	\N
356065	1874	27074000	24815	12287	112	0	\N
356066	1874	27076000	24815	12287	113	0	\N
356067	1874	27078000	24815	12287	114	0	\N
356068	1874	27081000	24815	12287	115	0	\N
356069	1874	27084000	24815	12287	116	0	\N
356070	1874	27087000	24815	12287	117	0	\N
356071	1874	27090000	24815	12287	118	0	\N
356072	1874	27093000	24815	12287	119	0	\N
356073	1874	27096000	24815	12287	120	0	\N
356074	1874	27099000	24815	12287	121	0	\N
356075	1874	27102000	24815	12287	122	0	\N
356076	1874	27105000	24815	12287	123	0	\N
356077	1874	27108000	24815	12287	124	0	\N
356078	1874	27111000	24815	12287	125	0	\N
356082	1860	67001978700000	24817	12323	0	0	\N
356083	1678	26640839912000	24817	12323	1	0	\N
356084	1874	27264000	24817	12323	2	0	\N
356085	1874	27267000	24817	12323	3	0	\N
356086	1874	27269000	24817	12323	4	0	\N
356107	1678	26640839914000	24821	12325	0	0	\N
356108	1678	26640839915000	24821	12325	1	0	\N
356109	1678	26640839916000	24821	12325	2	0	\N
356110	114	66002036901851	24821	12325	4	0	\N
356111	1950	13890351000000	24821	12325	5	0	\N
356112	1874	27277000	24821	12325	6	0	\N
356113	1874	27279000	24821	12325	7	0	\N
356114	1874	27281000	24821	12325	8	0	\N
356115	1874	27283000	24821	12325	9	0	\N
356116	1874	27286000	24821	12325	10	0	\N
356117	1874	27287000	24821	12325	11	0	\N
356118	1874	27290000	24821	12325	12	0	\N
356119	1678	26640839917000	24822	12326	0	0	\N
356120	1874	27293000	24822	12326	1	0	\N
356121	1874	27295000	24822	12326	2	0	\N
356125	1678	26640839917000	24824	12326	0	0	\N
356126	1874	27293000	24824	12326	1	0	\N
356127	1874	27295000	24824	12326	2	0	\N
356128	1678	26640839918000	24825	12327	0	0	\N
356129	1678	26640839919000	24825	12327	1	0	\N
356130	1950	14316851000000	24825	12327	2	0	\N
356131	1874	27298000	24825	12327	3	0	\N
356132	1874	27299000	24825	12327	4	0	\N
356133	1874	27302000	24825	12327	5	0	\N
356134	1874	27304000	24825	12327	6	0	\N
356135	1874	27306000	24825	12327	7	0	\N
356136	1678	26640839918000	24826	12327	0	0	\N
356137	1678	26640839919000	24826	12327	1	0	\N
356138	1950	14316851000000	24826	12327	2	0	\N
356139	1874	27298000	24826	12327	3	0	\N
356140	1874	27299000	24826	12327	4	0	\N
356141	1874	27302000	24826	12327	5	0	\N
356142	1874	27304000	24826	12327	6	0	\N
356143	1874	27306000	24826	12327	7	0	\N
356155	1678	26640839920000	24829	12328	0	0	\N
356156	1874	27308000	24829	12328	1	0	\N
356157	1874	27311000	24829	12328	2	0	\N
356158	1678	26640839920000	24830	12328	0	0	\N
356159	1874	27308000	24830	12328	1	0	\N
356160	1874	27311000	24830	12328	2	0	\N
356161	1678	26640839920000	24831	12328	0	0	\N
356162	1874	27309000	24831	12328	1	0	\N
356166	1678	26640839921000	24833	12329	0	0	\N
356167	1874	27314000	24833	12329	1	0	\N
356168	1874	27316000	24833	12329	2	0	\N
356179	1678	26640839925000	24836	12332	0	0	\N
356180	1678	26640839926000	24836	12332	1	0	\N
356181	1678	26640839927000	24836	12332	2	0	\N
356182	1874	27333000	24836	12332	3	0	\N
356183	1874	27335000	24836	12332	4	0	\N
356184	1874	27337000	24836	12332	5	0	\N
356081	1874	27263000	24816	12322	2	0	2
356087	1860	67001978700000	24818	12323	0	0	4
356088	1678	26640839912000	24818	12323	1	0	0
356089	1874	27264000	24818	12323	2	0	2
356090	1874	27267000	24818	12323	3	0	2
356092	1678	26640839913000	24819	12324	0	0	0
356093	1874	27271000	24819	12324	1	0	2
356094	1874	27274000	24819	12324	2	0	2
356095	1678	26640839914000	24820	12325	0	0	0
356096	1678	26640839915000	24820	12325	1	0	0
356098	114	66002036901851	24820	12325	4	0	12
356099	1950	13890351000000	24820	12325	5	0	14
356100	1874	27277000	24820	12325	6	0	2
356101	1874	27279000	24820	12325	7	0	2
356103	1874	27283000	24820	12325	9	0	2
356104	1874	27286000	24820	12325	10	0	2
356105	1874	27287000	24820	12325	11	0	2
356106	1874	27290000	24820	12325	12	0	2
356122	1678	26640839917000	24823	12326	0	0	0
356124	1874	27295000	24823	12326	2	0	2
356144	1678	26640839918000	24827	12327	0	0	0
356145	1678	26640839919000	24827	12327	1	0	0
356146	1950	14316851000000	24827	12327	2	0	14
356147	1874	27298000	24827	12327	3	0	2
356149	1874	27302000	24827	12327	5	0	2
356150	1874	27304000	24827	12327	6	0	2
356151	1874	27306000	24827	12327	7	0	2
356152	1678	26640839920000	24828	12328	0	0	0
356154	1874	27311000	24828	12328	2	0	2
356163	1678	26640839921000	24832	12329	0	0	0
356164	1874	27314000	24832	12329	1	0	2
356165	1874	27316000	24832	12329	2	0	2
356169	1678	26640839922000	24834	12330	0	0	0
356171	1874	27319000	24834	12330	2	0	2
356172	1874	27322000	24834	12330	3	0	2
356173	1874	27323000	24834	12330	4	0	2
356174	1874	27325000	24834	12330	5	0	2
356175	1874	27327000	24834	12330	6	0	2
356177	1874	27329000	24835	12331	1	0	2
356178	1874	27332000	24835	12331	2	0	2
356185	1874	27339000	24836	12332	6	0	\N
356186	1874	27342000	24836	12332	7	0	\N
356187	1874	27345000	24836	12332	8	0	\N
356188	1874	27348000	24836	12332	10	0	\N
356199	1678	26640839928000	24838	12333	0	0	\N
356200	1678	26640839929000	24838	12333	1	0	\N
356201	1874	27350000	24838	12333	2	0	\N
356202	1874	27351000	24838	12333	3	0	\N
356203	1874	27354000	24838	12333	4	0	\N
356204	1874	27357000	24838	12333	5	0	\N
356205	1874	27359000	24838	12333	6	0	\N
356213	1678	26640839928000	24840	12333	0	0	\N
356214	1678	26640839929000	24840	12333	1	0	\N
356215	1874	27350000	24840	12333	2	0	\N
356216	1874	27351000	24840	12333	3	0	\N
356217	1874	27354000	24840	12333	4	0	\N
356218	1874	27357000	24840	12333	5	0	\N
356219	1874	27359000	24840	12333	6	0	\N
356220	1678	26640839930000	24841	12334	0	0	\N
356221	1874	27361000	24841	12334	1	0	\N
356222	1874	27364000	24841	12334	2	0	\N
356223	1678	26640839930000	24842	12334	0	0	\N
356224	1874	27361000	24842	12334	1	0	\N
356225	1874	27364000	24842	12334	2	0	\N
356232	1678	26640839931000	24846	12335	0	0	\N
356233	1874	27367000	24846	12335	1	0	\N
356238	1678	26640839932000	24848	12336	0	0	\N
356239	1874	27372000	24848	12336	1	0	\N
356240	1874	27373000	24848	12336	2	0	\N
356241	1874	27375000	24848	12336	3	0	\N
356270	1678	26640839941000	24853	12341	0	0	\N
356271	1874	27420000	24853	12341	1	0	\N
356272	1874	27422000	24853	12341	2	0	\N
356283	1678	26640839942000	24856	12342	0	0	\N
356284	1678	26640839943000	24856	12342	1	0	\N
356285	1874	27425000	24856	12342	2	0	\N
356286	1874	27428000	24856	12342	3	0	\N
356287	1874	27429000	24856	12342	4	0	\N
356288	1874	27431000	24856	12342	5	0	\N
356289	1874	27433000	24856	12342	6	0	\N
356290	1678	26640839942000	24857	12342	0	0	\N
356291	1678	26640839943000	24857	12342	1	0	\N
356292	1874	27425000	24857	12342	2	0	\N
356293	1874	27428000	24857	12342	3	0	\N
356294	1874	27429000	24857	12342	4	0	\N
356295	1874	27431000	24857	12342	5	0	\N
356296	1874	27433000	24857	12342	6	0	\N
356300	1678	26640839945000	24859	12344	0	0	\N
356301	1678	26640839946000	24859	12344	1	0	\N
356302	1874	27441000	24859	12344	2	0	\N
356303	1874	27443000	24859	12344	3	0	\N
356304	1874	27445000	24859	12344	4	0	\N
356305	1874	27446000	24859	12344	5	0	\N
356306	1874	27449000	24859	12344	7	0	\N
356307	1678	26640839945000	24860	12344	0	0	\N
356308	1678	26640839946000	24860	12344	1	0	\N
356309	1874	27441000	24860	12344	2	0	\N
356310	1874	27443000	24860	12344	3	0	\N
356311	1874	27445000	24860	12344	4	0	\N
356312	1874	27446000	24860	12344	5	0	\N
356313	1874	27449000	24860	12344	7	0	\N
356191	1678	26640839927000	24837	12332	2	0	0
356192	1874	27333000	24837	12332	3	0	2
356193	1874	27335000	24837	12332	4	0	2
356194	1874	27337000	24837	12332	5	0	2
356195	1874	27339000	24837	12332	6	0	2
356197	1874	27345000	24837	12332	8	0	2
356198	1874	27348000	24837	12332	10	0	2
356206	1678	26640839928000	24839	12333	0	0	0
356207	1678	26640839929000	24839	12333	1	0	0
356208	1874	27350000	24839	12333	2	0	2
356210	1874	27354000	24839	12333	4	0	2
356211	1874	27357000	24839	12333	5	0	2
356212	1874	27359000	24839	12333	6	0	2
356226	1678	26640839930000	24843	12334	0	0	0
356228	1874	27364000	24843	12334	2	0	2
356229	1678	26640839931000	24845	12335	0	0	0
356230	1874	27366000	24845	12335	1	0	2
356231	1874	27369000	24845	12335	2	0	2
356234	1678	26640839932000	24847	12336	0	0	0
356236	1874	27373000	24847	12336	2	0	2
356237	1874	27375000	24847	12336	3	0	2
356242	1678	26640839933000	24849	12337	0	0	0
356243	1678	26640839934000	24849	12337	1	0	0
356244	1678	26640839935000	24849	12337	2	0	0
356246	1874	27377000	24849	12337	4	0	2
356247	1874	27379000	24849	12337	5	0	2
356248	1874	27381000	24849	12337	6	0	2
356249	1874	27384000	24849	12337	7	0	2
356251	1874	27390000	24849	12337	9	0	2
356252	1678	26640839936000	24850	12338	0	0	0
356253	1678	26640839937000	24850	12338	1	0	0
356254	1874	27391000	24850	12338	2	0	2
356255	1874	27394000	24850	12338	3	0	2
356257	1874	27398000	24850	12338	5	0	2
356258	1874	27401000	24850	12338	6	0	2
356259	1678	26640839938000	24851	12339	0	0	0
356260	1678	26640839939000	24851	12339	1	0	0
356261	1874	27402000	24851	12339	2	0	2
356263	1874	27407000	24851	12339	4	0	2
356264	1874	27410000	24851	12339	5	0	2
356265	1874	27412000	24851	12339	6	0	2
356266	2314	122879000000	24852	12340	0	0	3
356268	1874	27415000	24852	12340	2	0	2
356269	1874	27417000	24852	12340	3	0	2
356273	1678	26640839941000	24854	12341	0	0	0
356274	1874	27420000	24854	12341	1	0	2
356275	1874	27422000	24854	12341	2	0	2
356277	1678	26640839943000	24855	12342	1	0	0
356278	1874	27425000	24855	12342	2	0	2
356279	1874	27428000	24855	12342	3	0	2
356280	1874	27429000	24855	12342	4	0	2
356281	1874	27431000	24855	12342	5	0	2
356297	1678	26640839944000	24858	12343	0	0	0
356298	1874	27435000	24858	12343	1	0	2
356299	1874	27438000	24858	12343	2	0	2
356314	1678	26640839945000	24861	12344	0	0	0
356316	1874	27441000	24861	12344	2	0	2
356317	1874	27443000	24861	12344	3	0	2
356318	1874	27445000	24861	12344	4	0	2
356319	1874	27446000	24861	12344	5	0	2
356320	1874	27449000	24861	12344	7	0	2
356332	1678	26640839950000	24864	12347	0	0	\N
356333	1874	27468000	24864	12347	1	0	\N
356334	1874	27470000	24864	12347	2	0	\N
356335	1678	26640839950000	24865	12347	0	0	\N
356336	1874	27468000	24865	12347	1	0	\N
356337	1874	27470000	24865	12347	2	0	\N
356338	1678	26640839950000	24866	12347	0	0	\N
356339	1874	27467000	24866	12347	1	0	\N
356340	1678	26640839950000	24867	12347	0	0	\N
356341	1874	27468000	24867	12347	1	0	\N
356342	1874	27470000	24867	12347	2	0	\N
356344	1678	26640839950000	24869	12347	0	0	\N
356345	1874	27468000	24869	12347	1	0	\N
356346	1874	27470000	24869	12347	2	0	\N
356347	1874	27468000	24870	12347	0	0	\N
356371	1678	26640839955000	24874	12350	0	0	\N
356372	1874	27499000	24874	12350	1	0	\N
356373	1874	27501000	24874	12350	2	0	\N
356374	1874	27502000	24874	12350	3	0	\N
356378	1678	26640839956000	24876	12351	0	0	\N
356379	1874	27504000	24876	12351	1	0	\N
356380	1874	27507000	24876	12351	2	0	\N
356381	1678	26640839956000	24877	12351	0	0	\N
356382	1874	27504000	24877	12351	1	0	\N
356383	1874	27507000	24877	12351	2	0	\N
356384	1678	26640839956000	24878	12351	0	0	\N
356385	1874	27504000	24878	12351	1	0	\N
356386	1874	27507000	24878	12351	2	0	\N
356394	2315	10000000000	24881	12353	0	0	\N
356395	1678	26640839958000	24881	12353	1	0	\N
356396	1874	27513000	24881	12353	2	0	\N
356397	1874	27515000	24881	12353	3	0	\N
356398	1678	26640839959000	24882	12354	0	0	\N
356399	1874	27517000	24882	12354	1	0	\N
356400	1874	27520000	24882	12354	2	0	\N
356404	1678	26640839960000	24884	12355	0	0	\N
356405	1874	27522000	24884	12355	1	0	\N
356406	1874	27525000	24884	12355	2	0	\N
356413	1678	26640839962000	24887	12357	0	0	\N
356414	1874	27531000	24887	12357	1	0	\N
356415	1874	27534000	24887	12357	2	0	\N
356416	1678	26640839962000	24888	12357	0	0	\N
356417	1874	27531000	24888	12357	1	0	\N
356418	1874	27534000	24888	12357	2	0	\N
356422	1678	26640839963000	24890	12358	0	0	\N
356423	1874	27536000	24890	12358	1	0	\N
356424	1874	27539000	24890	12358	2	0	\N
356435	1678	26640839963000	24893	12359	0	0	\N
356436	1678	26640839964000	24893	12359	1	0	\N
356437	1678	26640839965000	24893	12359	2	0	\N
356438	1874	27541000	24893	12359	3	0	\N
356439	1874	27542000	24893	12359	4	0	\N
356440	1874	27544000	24893	12359	5	0	\N
356441	1874	27547000	24893	12359	7	0	\N
356442	1874	27550000	24893	12359	8	0	\N
356446	1678	26640839966000	24895	12360	0	0	\N
356447	1874	27553000	24895	12360	1	0	\N
356448	1874	27555000	24895	12360	2	0	\N
356323	1874	27451000	24862	12345	2	0	2
356324	1874	27453000	24862	12345	3	0	2
356325	44	66000001200000	24862	12345	4	0	3
356326	1874	27456000	24862	12345	5	0	2
356327	1874	27459000	24862	12345	6	0	2
356329	1874	27462000	24863	12346	1	0	2
356330	1874	27463000	24863	12346	3	0	2
356331	1874	27465000	24863	12346	4	0	2
356343	1874	27468000	24868	12347	0	0	2
356348	1678	26640839950000	24871	12348	0	0	0
356350	2315	9000000000	24871	12348	2	0	0
356351	1678	26640839952000	24871	12348	3	0	0
356352	1678	26640839953000	24871	12348	4	0	0
356353	1874	27471000	24871	12348	5	0	2
356355	1874	27472000	24871	12348	7	0	2
356356	1874	27474000	24871	12348	8	0	2
356357	1874	27476000	24871	12348	9	0	2
356358	1874	27478000	24871	12348	10	0	2
356359	1874	27480000	24871	12348	11	0	2
356361	1874	27485000	24871	12348	13	0	2
356362	1874	27488000	24871	12348	14	0	2
356363	1874	27491000	24871	12348	16	0	2
356364	1678	26640839954000	24872	12349	0	0	0
356365	1874	27494000	24872	12349	1	0	2
356367	1678	26640839955000	24873	12350	0	0	0
356368	1874	27499000	24873	12350	1	0	2
356369	1874	27501000	24873	12350	2	0	2
356370	1874	27502000	24873	12350	3	0	2
356376	1874	27504000	24875	12351	1	0	2
356377	1874	27507000	24875	12351	2	0	2
356387	1678	26640839957000	24879	12352	0	0	0
356388	1874	27509000	24879	12352	1	0	2
356389	1874	27512000	24879	12352	2	0	2
356391	1678	26640839958000	24880	12353	1	0	0
356392	1874	27513000	24880	12353	2	0	2
356393	1874	27515000	24880	12353	3	0	2
356401	1678	26640839959000	24883	12354	0	0	0
356402	1874	27517000	24883	12354	1	0	2
356407	1678	26640839960000	24885	12355	0	0	0
356408	1874	27522000	24885	12355	1	0	2
356409	1874	27525000	24885	12355	2	0	2
356410	1678	26640839961000	24886	12356	0	0	0
356412	1874	27529000	24886	12356	2	0	2
356419	1678	26640839962000	24889	12357	0	0	0
356420	1874	27531000	24889	12357	1	0	2
356421	1874	27534000	24889	12357	2	0	2
356425	1874	27536000	24891	12358	0	0	2
356427	1678	26640839963000	24892	12359	0	0	0
356428	1678	26640839964000	24892	12359	1	0	0
356429	1678	26640839965000	24892	12359	2	0	0
356430	1874	27541000	24892	12359	3	0	2
356431	1874	27542000	24892	12359	4	0	2
356433	1874	27547000	24892	12359	7	0	2
356434	1874	27550000	24892	12359	8	0	2
356443	1678	26640839966000	24894	12360	0	0	0
356444	1874	27553000	24894	12360	1	0	2
356449	1678	26640839967000	24896	12361	0	0	0
356450	1874	27558000	24896	12361	1	0	2
356451	1874	27560000	24896	12361	2	0	2
356452	1678	26640839968000	24897	12362	0	0	0
356453	1874	27563000	24897	12362	1	0	2
356455	1874	27566000	24897	12362	3	0	2
356456	1678	26640839969000	24898	12363	0	0	0
356462	1678	26640839971000	24899	12364	0	0	\N
356463	1874	27579000	24899	12364	1	0	\N
356464	1874	27580000	24899	12364	2	0	\N
356465	1874	27582000	24899	12364	3	0	\N
356466	1678	26640839971000	24900	12364	0	0	\N
356467	1874	27579000	24900	12364	1	0	\N
356468	1874	27580000	24900	12364	2	0	\N
356469	1874	27582000	24900	12364	3	0	\N
356480	1678	26640839972000	24903	12365	0	0	\N
356481	1678	26640839973000	24903	12365	1	0	\N
356482	1874	27585000	24903	12365	2	0	\N
356483	1874	27588000	24903	12365	3	0	\N
356484	1874	27590000	24903	12365	4	0	\N
356485	1874	27592000	24903	12365	5	0	\N
356486	1678	26640839974000	24904	12366	0	0	\N
356487	1874	27594000	24904	12366	1	0	\N
356488	1874	27597000	24904	12366	2	0	\N
356496	1678	26640839975000	24907	12367	0	0	\N
356497	1874	27600000	24907	12367	1	0	\N
356498	1874	27602000	24907	12367	2	0	\N
356499	1874	27603000	24907	12367	3	0	\N
356500	1678	26640839975000	24908	12367	0	0	\N
356501	1874	27600000	24908	12367	1	0	\N
356502	1874	27602000	24908	12367	2	0	\N
356503	1874	27603000	24908	12367	3	0	\N
356504	1678	26640839976000	24909	12368	0	0	\N
356505	1874	27605000	24909	12368	1	0	\N
356506	1874	27608000	24909	12368	2	0	\N
356510	1678	26640839976000	24911	12368	0	0	\N
356511	1874	27605000	24911	12368	1	0	\N
356512	1874	27608000	24911	12368	2	0	\N
356513	1678	26640839977000	24912	12369	0	0	\N
356514	1874	27611000	24912	12369	1	0	\N
356515	1874	27613000	24912	12369	2	0	\N
356516	1678	26640839977000	24913	12369	0	0	\N
356517	1874	27611000	24913	12369	1	0	\N
356518	1874	27613000	24913	12369	2	0	\N
356522	1678	26640839977000	24915	12369	0	0	\N
356523	1874	27611000	24915	12369	1	0	\N
356524	1874	27613000	24915	12369	2	0	\N
356525	1678	26640839977000	24916	12369	0	0	\N
356526	1874	27611000	24916	12369	1	0	\N
356527	1874	27613000	24916	12369	2	0	\N
356528	1678	26640839978000	24917	12370	0	0	\N
356529	1874	27615000	24917	12370	1	0	\N
356530	1874	27616000	24917	12370	2	0	\N
356531	1874	27619000	24917	12370	4	0	\N
356546	1678	26640839982000	24922	12374	0	0	\N
356547	1874	27638000	24922	12374	1	0	\N
356548	1874	27640000	24922	12374	2	0	\N
356549	1678	26640839981000	24923	12373	0	0	\N
356550	1678	26640839982000	24923	12373	1	0	\N
356551	1874	27631000	24923	12373	2	0	\N
356552	1874	27634000	24923	12373	3	0	\N
356553	1874	27637000	24923	12373	4	0	\N
356554	1874	27639000	24923	12373	5	0	\N
356555	1874	27640000	24923	12373	6	0	\N
356565	1678	26640839982000	24926	12375	0	0	\N
356566	1678	26640839983000	24926	12375	1	0	\N
356567	1678	26640839984000	24926	12375	2	0	\N
356568	1874	27643000	24926	12375	3	0	\N
356569	1874	27646000	24926	12375	4	0	\N
356570	1874	27648000	24926	12375	5	0	\N
356571	1874	27650000	24926	12375	6	0	\N
356572	1678	26640839982000	24927	12375	0	0	\N
356573	1678	26640839983000	24927	12375	1	0	\N
356574	1678	26640839984000	24927	12375	2	0	\N
356575	1874	27643000	24927	12375	3	0	\N
356576	1874	27646000	24927	12375	4	0	\N
356577	1874	27648000	24927	12375	5	0	\N
356578	1874	27650000	24927	12375	6	0	\N
356579	1678	26640839982000	24928	12375	0	0	\N
356580	1678	26640839983000	24928	12375	1	0	\N
356581	1678	26640839984000	24928	12375	2	0	\N
356582	1874	27643000	24928	12375	3	0	\N
356583	1874	27646000	24928	12375	4	0	\N
356584	1874	27648000	24928	12375	5	0	\N
356585	1874	27650000	24928	12375	6	0	\N
356586	1874	27643000	24929	12375	0	0	\N
356587	1874	27646000	24929	12375	1	0	\N
356588	1874	27648000	24929	12375	2	0	\N
356589	1874	27650000	24929	12375	3	0	\N
356590	2314	121000000000	24930	12298	0	0	\N
356591	2314	122000000000	24930	12298	1	0	\N
356592	1860	67001978700000	24930	12298	2	0	\N
356459	1874	27570000	24898	12363	3	0	2
356460	1874	27573000	24898	12363	4	0	2
356461	1874	27576000	24898	12363	5	0	2
356470	1678	26640839971000	24901	12364	0	0	0
356471	1874	27579000	24901	12364	1	0	2
356473	1874	27582000	24901	12364	3	0	2
356474	1678	26640839972000	24902	12365	0	0	0
356475	1678	26640839973000	24902	12365	1	0	0
356476	1874	27585000	24902	12365	2	0	2
356477	1874	27588000	24902	12365	3	0	2
356479	1874	27592000	24902	12365	5	0	2
356489	1678	26640839974000	24905	12366	0	0	0
356490	1874	27594000	24905	12366	1	0	2
356491	1874	27597000	24905	12366	2	0	2
356493	1874	27600000	24906	12367	1	0	2
356494	1874	27602000	24906	12367	2	0	2
356495	1874	27603000	24906	12367	3	0	2
356507	1678	26640839976000	24910	12368	0	0	0
356508	1874	27605000	24910	12368	1	0	2
356519	1678	26640839977000	24914	12369	0	0	0
356520	1874	27611000	24914	12369	1	0	2
356521	1874	27613000	24914	12369	2	0	2
356532	1678	26640839978000	24918	12370	0	0	0
356533	1874	27615000	24918	12370	1	0	2
356535	1874	27619000	24918	12370	4	0	2
356536	1678	26640839979000	24919	12371	0	0	0
356537	1874	27621000	24919	12371	1	0	2
356538	1874	27624000	24919	12371	2	0	2
356540	1874	27627000	24920	12372	1	0	2
356541	1874	27629000	24920	12372	2	0	2
356542	1678	26640839981000	24921	12373	0	0	0
356543	1874	27631000	24921	12373	1	0	2
356544	1874	27634000	24921	12373	2	0	2
356556	1874	27638000	24924	12374	0	0	2
356557	1874	27640000	24924	12374	1	0	2
356558	1678	26640839982000	24925	12375	0	0	0
356559	1678	26640839983000	24925	12375	1	0	0
356560	1678	26640839984000	24925	12375	2	0	0
356562	1874	27646000	24925	12375	4	0	2
356563	1874	27648000	24925	12375	5	0	2
356564	1874	27650000	24925	12375	6	0	2
356593	2314	123000000000	24930	12298	3	0	\N
356594	2315	9000000000	24930	12298	4	0	\N
356595	2315	10000000000	24930	12298	5	0	\N
356596	2314	244000000000	24930	12298	6	0	\N
356597	2314	360000000000	24930	12298	7	0	\N
356598	2314	490000000000	24930	12298	8	0	\N
356599	2314	551000000000	24930	12298	9	0	\N
356600	1678	26640839878000	24930	12298	10	0	\N
356601	1678	26640839879000	24930	12298	11	0	\N
356602	1678	26640839880000	24930	12298	12	0	\N
356603	1678	26640839881000	24930	12298	13	0	\N
356604	1678	26640839882000	24930	12298	14	0	\N
356605	1678	26640839883000	24930	12298	15	0	\N
356606	1678	26640839884000	24930	12298	16	0	\N
356607	1678	26640839885000	24930	12298	17	0	\N
356608	1678	26640839886000	24930	12298	18	0	\N
356609	1678	26640839887000	24930	12298	19	0	\N
356610	1678	26640839888000	24930	12298	20	0	\N
356611	1678	26640839889000	24930	12298	21	0	\N
356612	1678	26640839890000	24930	12298	22	0	\N
356613	1678	26640839891000	24930	12298	23	0	\N
356614	1678	26640839892000	24930	12298	24	0	\N
356615	1678	26640839893000	24930	12298	25	0	\N
356616	1678	26640839894000	24930	12298	26	0	\N
356617	1678	26640839895000	24930	12298	27	0	\N
356618	1678	26640839896000	24930	12298	28	0	\N
356619	1678	26640839897000	24930	12298	29	0	\N
356620	1678	26640839898000	24930	12298	30	0	\N
356621	1678	26640839899000	24930	12298	31	0	\N
356622	1678	26640839900000	24930	12298	32	0	\N
356623	1678	26640839901000	24930	12298	33	0	\N
356624	1678	26640839902000	24930	12298	34	0	\N
356625	1678	26640839903000	24930	12298	35	0	\N
356626	1678	26640839904000	24930	12298	36	0	\N
356627	1678	26640839905000	24930	12298	37	0	\N
356628	1678	26640839906000	24930	12298	38	0	\N
356629	1678	26640839907000	24930	12298	39	0	\N
356630	1678	26640839908000	24930	12298	40	0	\N
356631	1678	26640839909000	24930	12298	41	0	\N
356632	1678	26640839910000	24930	12298	42	0	\N
356633	1678	26640839911000	24930	12298	43	0	\N
356634	1678	26640839912000	24930	12298	44	0	\N
356635	1678	26640839913000	24930	12298	45	0	\N
356636	1678	26640839914000	24930	12298	46	0	\N
356637	1678	26640839915000	24930	12298	47	0	\N
356638	1678	26640839916000	24930	12298	48	0	\N
356639	1678	26640839917000	24930	12298	49	0	\N
356640	1678	26640839918000	24930	12298	50	0	\N
356641	1678	26640839919000	24930	12298	51	0	\N
356642	1678	26640839920000	24930	12298	52	0	\N
356643	1678	26640839921000	24930	12298	53	0	\N
356644	1678	26640839922000	24930	12298	54	0	\N
356645	1678	26640839923000	24930	12298	55	0	\N
356646	1678	26640839924000	24930	12298	56	0	\N
356647	1678	26640839925000	24930	12298	57	0	\N
356648	1678	26640839926000	24930	12298	58	0	\N
356649	1678	26640839927000	24930	12298	59	0	\N
356650	1678	26640839928000	24930	12298	60	0	\N
356651	1678	26640839929000	24930	12298	61	0	\N
356652	1678	26640839930000	24930	12298	62	0	\N
356653	1678	26640839931000	24930	12298	63	0	\N
356654	1678	26640839932000	24930	12298	64	0	\N
356655	1678	26640839933000	24930	12298	65	0	\N
356656	1678	26640839934000	24930	12298	66	0	\N
356657	1678	26640839935000	24930	12298	67	0	\N
356658	1678	26640839936000	24930	12298	68	0	\N
356659	1678	26640839937000	24930	12298	69	0	\N
356660	1678	26640839938000	24930	12298	70	0	\N
356661	1678	26640839939000	24930	12298	71	0	\N
356662	1678	26640839940000	24930	12298	72	0	\N
356663	1678	26640839941000	24930	12298	73	0	\N
356664	1678	26640839942000	24930	12298	74	0	\N
356665	1678	26640839943000	24930	12298	75	0	\N
356666	1678	26640839944000	24930	12298	76	0	\N
356667	1678	26640839945000	24930	12298	77	0	\N
356668	1678	26640839946000	24930	12298	78	0	\N
356669	1678	26640839947000	24930	12298	79	0	\N
356670	1678	26640839948000	24930	12298	80	0	\N
356671	1678	26640839949000	24930	12298	81	0	\N
356672	1678	26640839950000	24930	12298	82	0	\N
356673	1678	26640839951000	24930	12298	83	0	\N
356674	1678	26640839952000	24930	12298	84	0	\N
356675	1678	26640839953000	24930	12298	85	0	\N
356676	1678	26640839954000	24930	12298	86	0	\N
356677	1678	26640839955000	24930	12298	87	0	\N
356678	1678	26640839956000	24930	12298	88	0	\N
356679	1678	26640839957000	24930	12298	89	0	\N
356680	1678	26640839958000	24930	12298	90	0	\N
356681	1678	26640839959000	24930	12298	91	0	\N
356682	1678	26640839960000	24930	12298	92	0	\N
356683	1678	26640839961000	24930	12298	93	0	\N
356684	1678	26640839962000	24930	12298	94	0	\N
356685	1678	26640839963000	24930	12298	95	0	\N
356686	1678	26640839964000	24930	12298	96	0	\N
356687	1678	26640839965000	24930	12298	97	0	\N
356688	1678	26640839966000	24930	12298	98	0	\N
356689	1678	26640839967000	24930	12298	99	0	\N
356690	1678	26640839968000	24930	12298	100	0	\N
356691	1678	26640839969000	24930	12298	101	0	\N
356692	1678	26640839970000	24930	12298	102	0	\N
356693	1678	26640839971000	24930	12298	103	0	\N
356694	1678	26640839972000	24930	12298	104	0	\N
356695	1678	26640839973000	24930	12298	105	0	\N
356696	1678	26640839974000	24930	12298	106	0	\N
356697	1678	26640839975000	24930	12298	107	0	\N
356698	1678	26640839976000	24930	12298	108	0	\N
356699	1678	26640839977000	24930	12298	109	0	\N
356700	1678	26640839978000	24930	12298	110	0	\N
356701	1678	26640839979000	24930	12298	111	0	\N
356702	1678	26640839980000	24930	12298	112	0	\N
356703	1678	26640839981000	24930	12298	113	0	\N
356704	1678	26640839982000	24930	12298	114	0	\N
356705	1678	26640839983000	24930	12298	115	0	\N
356706	1678	26640839984000	24930	12298	116	0	\N
356707	1874	27088000	24930	12298	119	0	\N
356708	1406	0	24930	12298	120	0	\N
356709	1874	27091000	24930	12298	121	0	\N
356710	1874	27094000	24930	12298	122	0	\N
356711	1874	27097000	24930	12298	123	0	\N
356712	1874	27100000	24930	12298	124	0	\N
356713	1874	27103000	24930	12298	125	0	\N
356718	1678	26640839986000	24933	12377	0	0	\N
356719	1874	27658000	24933	12377	1	0	\N
356720	1874	27661000	24933	12377	2	0	\N
356721	1678	26640839986000	24934	12377	0	0	\N
356722	1874	27658000	24934	12377	1	0	\N
356723	1874	27661000	24934	12377	2	0	\N
356727	1678	26640839977000	24936	12369	0	0	\N
356728	1678	26640839978000	24936	12369	1	0	\N
356716	1874	27655000	24932	12376	2	0	2
356717	1874	27656000	24932	12376	3	0	2
356724	1678	26640839986000	24935	12377	0	0	0
356725	1874	27658000	24935	12377	1	0	2
356726	1874	27661000	24935	12377	2	0	2
356729	1678	26640839979000	24936	12369	2	0	\N
356730	1678	26640839980000	24936	12369	3	0	\N
356731	1678	26640839981000	24936	12369	4	0	\N
356732	1678	26640839982000	24936	12369	5	0	\N
356733	1678	26640839983000	24936	12369	6	0	\N
356734	1678	26640839984000	24936	12369	7	0	\N
356735	1678	26640839985000	24936	12369	9	0	\N
356736	1874	27611000	24936	12369	10	0	\N
356737	1874	27612000	24936	12369	11	0	\N
356738	1874	27614000	24936	12369	12	0	\N
356739	1874	27616000	24936	12369	13	0	\N
356740	1874	27618000	24936	12369	14	0	\N
356741	1874	27621000	24936	12369	15	0	\N
356742	1874	27622000	24936	12369	16	0	\N
356743	1874	27624000	24936	12369	17	0	\N
356744	1874	27626000	24936	12369	18	0	\N
356745	1874	27628000	24936	12369	19	0	\N
356746	1874	27630000	24936	12369	20	0	\N
356747	1874	27632000	24936	12369	21	0	\N
356748	1874	27635000	24936	12369	22	0	\N
356749	1874	27638000	24936	12369	23	0	\N
356750	1874	27641000	24936	12369	24	0	\N
356751	1874	27644000	24936	12369	25	0	\N
356752	1874	27647000	24936	12369	26	0	\N
356753	1874	27650000	24936	12369	27	0	\N
356754	1874	27653000	24936	12369	28	0	\N
356755	1874	27655000	24936	12369	29	0	\N
356756	1874	27656000	24936	12369	30	0	\N
356770	1678	26640839989000	24941	12380	0	0	\N
356771	1678	26640839990000	24941	12380	1	0	\N
356772	1874	27675000	24941	12380	2	0	\N
356773	1874	27678000	24941	12380	3	0	\N
356774	1874	27680000	24941	12380	4	0	\N
356775	1874	27682000	24941	12380	5	0	\N
356783	1874	27688000	24948	12382	0	0	\N
356784	1874	27691000	24948	12382	1	0	\N
356785	1874	27693000	24948	12382	2	0	\N
356789	1678	26640839986000	24953	12370	0	0	\N
356790	1678	26640839987000	24953	12370	1	0	\N
356791	1678	26640839988000	24953	12370	2	0	\N
356792	1678	26640839989000	24953	12370	3	0	\N
356793	1678	26640839990000	24953	12370	4	0	\N
356794	1678	26640839991000	24953	12370	5	0	\N
356795	1678	26640839992000	24953	12370	6	0	\N
356796	1678	26640839993000	24953	12370	7	0	\N
356797	1874	27657000	24953	12370	8	0	\N
356798	1874	27658000	24953	12370	9	0	\N
356799	1874	27660000	24953	12370	10	0	\N
356800	1874	27662000	24953	12370	11	0	\N
356801	1874	27664000	24953	12370	12	0	\N
356802	1874	27666000	24953	12370	13	0	\N
356803	1874	27668000	24953	12370	14	0	\N
356804	1874	27670000	24953	12370	15	0	\N
356805	1874	27672000	24953	12370	16	0	\N
356806	1874	27674000	24953	12370	17	0	\N
356807	1874	27677000	24953	12370	18	0	\N
356808	1874	27680000	24953	12370	19	0	\N
356809	1874	27683000	24953	12370	20	0	\N
356810	1874	27686000	24953	12370	21	0	\N
356811	1874	27689000	24953	12370	22	0	\N
356812	1874	27692000	24953	12370	23	0	\N
356813	1874	27695000	24953	12370	24	0	\N
356814	1874	27698000	24953	12370	25	0	\N
356815	1678	26640839994000	24954	12384	0	0	\N
356816	1874	27700000	24954	12384	1	0	\N
356817	1874	27703000	24954	12384	2	0	\N
356825	1678	26640839995000	24957	12385	0	0	\N
356826	1874	27706000	24957	12385	1	0	\N
356827	1874	27707000	24957	12385	2	0	\N
356828	1874	27709000	24957	12385	3	0	\N
356829	1678	26640839996000	24958	12386	0	0	\N
356830	1874	27711000	24958	12386	1	0	\N
356831	1874	27714000	24958	12386	2	0	\N
356832	1678	26640839996000	24959	12386	0	0	\N
356833	1874	27712000	24959	12386	1	0	\N
356834	1678	26640839996000	24960	12386	0	0	\N
356835	1874	27711000	24960	12386	1	0	\N
356836	1874	27714000	24960	12386	2	0	\N
356848	1678	26640839997000	24963	12387	0	0	\N
356849	1678	26640839998000	24963	12387	1	0	\N
356850	1950	14438851000000	24963	12387	2	0	\N
356851	1874	27717000	24963	12387	3	0	\N
356852	1874	27720000	24963	12387	4	0	\N
356853	1874	27721000	24963	12387	5	0	\N
356854	1874	27723000	24963	12387	6	0	\N
356855	1874	27725000	24963	12387	7	0	\N
356759	1874	27666000	24937	12378	2	0	2
356760	1678	26640839988000	24938	12379	0	0	0
356761	1874	27669000	24938	12379	1	0	2
356762	1874	27671000	24938	12379	2	0	2
356763	1874	27672000	24938	12379	3	0	2
356765	1678	26640839990000	24940	12380	1	0	0
356766	1874	27675000	24940	12380	2	0	2
356767	1874	27678000	24940	12380	3	0	2
356768	1874	27680000	24940	12380	4	0	2
356769	1874	27682000	24940	12380	5	0	2
356777	1874	27684000	24945	12381	1	0	2
356778	1874	27687000	24945	12381	2	0	2
356779	1678	26640839992000	24947	12382	0	0	0
356780	1874	27688000	24947	12382	1	0	2
356782	1874	27693000	24947	12382	3	0	2
356786	1678	26640839993000	24952	12383	0	0	0
356787	1874	27696000	24952	12383	1	0	2
356788	1874	27698000	24952	12383	2	0	2
356818	1678	26640839994000	24955	12384	0	0	0
356820	1874	27703000	24955	12384	2	0	2
356821	1678	26640839995000	24956	12385	0	0	0
356822	1874	27706000	24956	12385	1	0	2
356823	1874	27707000	24956	12385	2	0	2
356824	1874	27709000	24956	12385	3	0	2
356838	1874	27711000	24961	12386	1	0	2
356839	1874	27714000	24961	12386	2	0	2
356840	1678	26640839997000	24962	12387	0	0	0
356841	1678	26640839998000	24962	12387	1	0	0
356843	1874	27717000	24962	12387	3	0	2
356844	1874	27720000	24962	12387	4	0	2
356845	1874	27721000	24962	12387	5	0	2
356846	1874	27723000	24962	12387	6	0	2
356847	1874	27725000	24962	12387	7	0	2
356857	1874	27727000	24964	12388	1	0	2
356858	1874	27730000	24964	12388	2	0	2
356859	1678	26640840000000	24965	12389	0	0	0
356860	1874	27733000	24965	12389	1	0	2
356861	1874	27735000	24965	12389	2	0	2
356863	1678	26640840002000	24966	12390	1	0	0
356864	1678	26640840003000	24966	12390	2	0	0
356875	1678	26640840004000	24968	12391	0	0	\N
356876	1874	27753000	24968	12391	2	0	\N
356877	1874	27756000	24968	12391	3	0	\N
356884	1678	26640840006000	24971	12393	0	0	\N
356885	1874	27765000	24971	12393	1	0	\N
356886	1874	27767000	24971	12393	2	0	\N
356887	1678	26640840006000	24972	12393	0	0	\N
356896	1678	26640840007000	24974	12394	0	0	\N
356897	1678	26640840008000	24974	12394	1	0	\N
356898	1874	27767000	24974	12394	2	0	\N
356899	1874	27770000	24974	12394	3	0	\N
356900	1874	27773000	24974	12394	4	0	\N
356901	1874	27775000	24974	12394	5	0	\N
356902	1874	27777000	24974	12394	6	0	\N
356903	1874	27778000	24974	12394	7	0	\N
356904	1678	26640840007000	24975	12394	0	0	\N
356905	1678	26640840008000	24975	12394	1	0	\N
356906	1874	27767000	24975	12394	2	0	\N
356907	1874	27770000	24975	12394	3	0	\N
356908	1874	27773000	24975	12394	4	0	\N
356909	1874	27775000	24975	12394	5	0	\N
356910	1874	27777000	24975	12394	6	0	\N
356911	1874	27778000	24975	12394	7	0	\N
356915	1678	26640840009000	24977	12395	0	0	\N
356916	1874	27781000	24977	12395	1	0	\N
356917	1874	27783000	24977	12395	2	0	\N
356921	1678	26640840011000	24979	12397	0	0	\N
356922	1874	27790000	24979	12397	1	0	\N
356923	1874	27793000	24979	12397	2	0	\N
356924	1678	26640840011000	24980	12397	0	0	\N
356925	1874	27790000	24980	12397	1	0	\N
356926	1874	27793000	24980	12397	2	0	\N
356934	1678	26640840012000	24983	12398	0	0	\N
356935	1874	27792000	24983	12398	1	0	\N
356936	1874	27793000	24983	12398	2	0	\N
356937	1874	27796000	24983	12398	3	0	\N
356938	1874	27799000	24983	12398	4	0	\N
356939	1678	26640840012000	24984	12398	0	0	\N
356940	1874	27792000	24984	12398	1	0	\N
356941	1874	27793000	24984	12398	2	0	\N
356942	1874	27796000	24984	12398	3	0	\N
356943	1874	27799000	24984	12398	4	0	\N
356944	1678	26640840012000	24985	12398	0	0	\N
356945	1874	27792000	24985	12398	1	0	\N
356946	1874	27793000	24985	12398	2	0	\N
356958	1678	26640840013000	24987	12399	0	0	\N
356959	1678	26640840014000	24987	12399	1	0	\N
356960	2316	799000000000	24987	12399	2	0	\N
356961	1678	26640840015000	24987	12399	3	0	\N
356962	1874	27801000	24987	12399	4	0	\N
356963	1874	27803000	24987	12399	5	0	\N
356964	1874	27804000	24987	12399	6	0	\N
356965	1874	27806000	24987	12399	7	0	\N
356966	1874	27809000	24987	12399	8	0	\N
356967	1874	27812000	24987	12399	9	0	\N
356968	1874	27815000	24987	12399	10	0	\N
356969	2316	799000000000	24988	12360	0	0	\N
356970	1950	14438851000000	24988	12360	1	0	\N
356971	1678	26640839966000	24988	12360	2	0	\N
356972	1678	26640839967000	24988	12360	3	0	\N
356973	1678	26640839968000	24988	12360	4	0	\N
356974	1678	26640839969000	24988	12360	5	0	\N
356975	1678	26640839970000	24988	12360	6	0	\N
356976	1678	26640839971000	24988	12360	7	0	\N
356977	1678	26640839972000	24988	12360	8	0	\N
356978	1678	26640839973000	24988	12360	9	0	\N
356979	1678	26640839974000	24988	12360	10	0	\N
356980	1678	26640839975000	24988	12360	11	0	\N
356981	1678	26640839976000	24988	12360	12	0	\N
356982	1678	26640839977000	24988	12360	13	0	\N
356983	1678	26640839978000	24988	12360	14	0	\N
356984	1678	26640839979000	24988	12360	15	0	\N
356985	1678	26640839980000	24988	12360	16	0	\N
356986	1678	26640839981000	24988	12360	17	0	\N
356987	1678	26640839982000	24988	12360	18	0	\N
356988	1678	26640839983000	24988	12360	19	0	\N
356989	1678	26640839984000	24988	12360	20	0	\N
356990	1678	26640839985000	24988	12360	21	0	\N
356991	1678	26640839986000	24988	12360	22	0	\N
356992	1678	26640839987000	24988	12360	23	0	\N
356993	1678	26640839988000	24988	12360	24	0	\N
356994	1678	26640839989000	24988	12360	25	0	\N
356995	1678	26640839990000	24988	12360	26	0	\N
356996	1678	26640839991000	24988	12360	27	0	\N
356997	1678	26640839992000	24988	12360	28	0	\N
356998	1678	26640839993000	24988	12360	29	0	\N
356999	1678	26640839994000	24988	12360	30	0	\N
357000	1678	26640839995000	24988	12360	31	0	\N
356867	1874	27740000	24966	12390	5	0	2
356868	1874	27742000	24966	12390	6	0	2
356869	1874	27745000	24966	12390	7	0	2
356870	1874	27748000	24966	12390	8	0	2
356871	1874	27751000	24966	12390	9	0	2
356873	1874	27753000	24967	12391	2	0	2
356874	1874	27756000	24967	12391	3	0	2
356878	1678	26640840005000	24969	12392	0	0	0
356879	1874	27758000	24969	12392	1	0	2
356880	1874	27759000	24969	12392	2	0	2
356882	1678	26640840006000	24970	12393	0	0	0
356883	1874	27764000	24970	12393	1	0	2
356888	1678	26640840007000	24973	12394	0	0	0
356889	1678	26640840008000	24973	12394	1	0	0
356891	1874	27770000	24973	12394	3	0	2
356892	1874	27773000	24973	12394	4	0	2
356893	1874	27775000	24973	12394	5	0	2
356894	1874	27777000	24973	12394	6	0	2
356895	1874	27778000	24973	12394	7	0	2
356913	1874	27781000	24976	12395	1	0	2
356914	1874	27783000	24976	12395	2	0	2
356918	1678	26640840010000	24978	12396	0	0	0
356919	1874	27786000	24978	12396	1	0	2
356920	1874	27788000	24978	12396	2	0	2
356928	1874	27790000	24981	12397	1	0	2
356929	1678	26640840012000	24982	12398	0	0	0
356930	1874	27792000	24982	12398	1	0	2
356931	1874	27793000	24982	12398	2	0	2
356933	1874	27799000	24982	12398	4	0	2
356947	1678	26640840013000	24986	12399	0	0	0
356948	1678	26640840014000	24986	12399	1	0	0
356949	2316	799000000000	24986	12399	2	0	0
356950	1678	26640840015000	24986	12399	3	0	0
356952	1874	27803000	24986	12399	5	0	2
356953	1874	27804000	24986	12399	6	0	2
356954	1874	27806000	24986	12399	7	0	2
356955	1874	27809000	24986	12399	8	0	2
356956	1874	27812000	24986	12399	9	0	2
357001	1678	26640839996000	24988	12360	32	0	\N
357002	1678	26640839997000	24988	12360	33	0	\N
357003	1678	26640839998000	24988	12360	34	0	\N
357004	1678	26640839999000	24988	12360	35	0	\N
357005	1678	26640840000000	24988	12360	36	0	\N
357006	1678	26640840001000	24988	12360	37	0	\N
357007	1678	26640840002000	24988	12360	38	0	\N
357008	1678	26640840003000	24988	12360	39	0	\N
357009	1678	26640840004000	24988	12360	40	0	\N
357010	1678	26640840005000	24988	12360	41	0	\N
357011	1678	26640840006000	24988	12360	42	0	\N
357012	1678	26640840007000	24988	12360	43	0	\N
357013	1678	26640840008000	24988	12360	44	0	\N
357014	1678	26640840009000	24988	12360	45	0	\N
357015	1678	26640840010000	24988	12360	46	0	\N
357016	1678	26640840011000	24988	12360	47	0	\N
357017	1678	26640840012000	24988	12360	48	0	\N
357018	1678	26640840013000	24988	12360	49	0	\N
357019	1678	26640840014000	24988	12360	50	0	\N
357020	1678	26640840015000	24988	12360	51	0	\N
357021	1874	27553000	24988	12360	52	0	\N
357022	1874	27556000	24988	12360	53	0	\N
357023	1874	27559000	24988	12360	54	0	\N
357024	1874	27562000	24988	12360	55	0	\N
357025	1874	27565000	24988	12360	56	0	\N
357026	1874	27568000	24988	12360	57	0	\N
357027	1874	27571000	24988	12360	58	0	\N
357028	1874	27574000	24988	12360	59	0	\N
357029	1874	27576000	24988	12360	60	0	\N
357030	1874	27578000	24988	12360	61	0	\N
357031	1874	27580000	24988	12360	63	0	\N
357032	1874	27582000	24988	12360	64	0	\N
357033	1874	27584000	24988	12360	65	0	\N
357034	1874	27585000	24988	12360	66	0	\N
357035	1874	27586000	24988	12360	67	0	\N
357036	1874	27587000	24988	12360	68	0	\N
357037	1874	27588000	24988	12360	69	0	\N
357038	1874	27589000	24988	12360	70	0	\N
357039	1874	27590000	24988	12360	71	0	\N
357040	1874	27591000	24988	12360	72	0	\N
357041	1874	27592000	24988	12360	73	0	\N
357042	1874	27593000	24988	12360	74	0	\N
357043	1874	27594000	24988	12360	75	0	\N
357044	1874	27595000	24988	12360	76	0	\N
357045	1874	27596000	24988	12360	77	0	\N
357046	1874	27597000	24988	12360	78	0	\N
357047	1874	27598000	24988	12360	79	0	\N
357048	1874	27599000	24988	12360	80	0	\N
357049	1874	27601000	24988	12360	81	0	\N
357050	1874	27603000	24988	12360	82	0	\N
357051	1874	27605000	24988	12360	83	0	\N
357052	1874	27607000	24988	12360	84	0	\N
357053	1874	27609000	24988	12360	85	0	\N
357054	1874	27611000	24988	12360	86	0	\N
357055	1874	27613000	24988	12360	87	0	\N
357056	1874	27615000	24988	12360	88	0	\N
357057	1874	27617000	24988	12360	89	0	\N
357058	1874	27619000	24988	12360	90	0	\N
357059	1874	27621000	24988	12360	91	0	\N
357060	1874	27623000	24988	12360	92	0	\N
357061	1874	27625000	24988	12360	93	0	\N
357062	1874	27627000	24988	12360	94	0	\N
357063	1874	27629000	24988	12360	95	0	\N
357064	1874	27631000	24988	12360	96	0	\N
357065	1874	27633000	24988	12360	97	0	\N
357066	1874	27635000	24988	12360	98	0	\N
357067	1874	27637000	24988	12360	99	0	\N
357068	1874	27639000	24988	12360	100	0	\N
357069	1874	27641000	24988	12360	101	0	\N
357070	1874	27643000	24988	12360	102	0	\N
357071	1874	27645000	24988	12360	103	0	\N
357072	1874	27647000	24988	12360	104	0	\N
357073	1874	27649000	24988	12360	105	0	\N
357074	1874	27651000	24988	12360	106	0	\N
357075	1874	27653000	24988	12360	107	0	\N
357076	1874	27655000	24988	12360	108	0	\N
357077	1874	27657000	24988	12360	109	0	\N
357078	1874	27659000	24988	12360	110	0	\N
357079	1874	27661000	24988	12360	111	0	\N
357080	1874	27663000	24988	12360	112	0	\N
357081	1874	27665000	24988	12360	113	0	\N
357082	1874	27667000	24988	12360	114	0	\N
357083	1874	27669000	24988	12360	115	0	\N
357084	1874	27671000	24988	12360	116	0	\N
357085	1874	27673000	24988	12360	117	0	\N
357086	1874	27675000	24988	12360	118	0	\N
357087	1874	27677000	24988	12360	119	0	\N
357088	1874	27679000	24988	12360	120	0	\N
357089	1874	27681000	24988	12360	121	0	\N
357090	1874	27683000	24988	12360	122	0	\N
357091	1874	27685000	24988	12360	123	0	\N
357092	1874	27687000	24988	12360	124	0	\N
357093	1874	27689000	24988	12360	125	0	\N
357094	1678	26640840016000	24989	12400	0	0	\N
357095	1678	26640840017000	24989	12400	1	0	\N
357096	1678	26640840018000	24989	12400	2	0	\N
357097	1874	27816000	24989	12400	3	0	\N
357098	1874	27818000	24989	12400	4	0	\N
357099	1874	27820000	24989	12400	5	0	\N
357100	1874	27822000	24989	12400	6	0	\N
357101	1874	27825000	24989	12400	7	0	\N
357102	1874	27828000	24989	12400	8	0	\N
357103	1874	27831000	24989	12400	9	0	\N
357114	1678	26640840019000	24991	12401	0	0	\N
357115	1874	27833000	24991	12401	1	0	\N
357116	1874	27836000	24991	12401	2	0	\N
357117	1678	26640840019000	24992	12401	0	0	\N
357118	1874	27833000	24992	12401	1	0	\N
357122	2314	123000000000	24994	12262	0	0	\N
357123	1860	67001978700000	24994	12262	1	0	\N
357124	1678	26640840013000	24995	12399	0	0	\N
357125	1678	26640840014000	24995	12399	1	0	\N
357126	2316	799000000000	24995	12399	2	0	\N
357127	1678	26640840015000	24995	12399	3	0	\N
357128	1678	26640840016000	24995	12399	4	0	\N
357129	1678	26640840017000	24995	12399	5	0	\N
357130	1678	26640840018000	24995	12399	6	0	\N
357131	1678	26640840019000	24995	12399	7	0	\N
357132	1874	27801000	24995	12399	8	0	\N
357133	1874	27803000	24995	12399	9	0	\N
357134	1874	27804000	24995	12399	10	0	\N
357135	1874	27805000	24995	12399	11	0	\N
357136	1874	27807000	24995	12399	12	0	\N
357106	1678	26640840018000	24990	12400	2	0	0
357107	1874	27816000	24990	12400	3	0	2
357108	1874	27818000	24990	12400	4	0	2
357109	1874	27820000	24990	12400	5	0	2
357110	1874	27822000	24990	12400	6	0	2
357112	1874	27828000	24990	12400	8	0	2
357113	1874	27831000	24990	12400	9	0	2
357119	1678	26640840019000	24993	12401	0	0	0
357120	1874	27833000	24993	12401	1	0	2
357121	1874	27836000	24993	12401	2	0	2
357137	1874	27810000	24995	12399	13	0	\N
357138	1874	27813000	24995	12399	14	0	\N
357139	1874	27816000	24995	12399	15	0	\N
357140	1874	27818000	24995	12399	16	0	\N
357141	1874	27820000	24995	12399	17	0	\N
357142	1874	27822000	24995	12399	18	0	\N
357143	1874	27824000	24995	12399	19	0	\N
357144	1874	27827000	24995	12399	20	0	\N
357145	1874	27830000	24995	12399	21	0	\N
357146	1874	27833000	24995	12399	22	0	\N
357147	1874	27836000	24995	12399	23	0	\N
357148	1874	27839000	24995	12399	24	0	\N
357149	1678	26640840020000	24996	12402	0	0	\N
357150	1678	26640840021000	24996	12402	1	0	\N
357151	1874	27838000	24996	12402	3	0	\N
357152	1874	27840000	24996	12402	4	0	\N
357159	1678	26640840020000	24998	12402	0	0	\N
357160	1678	26640840021000	24998	12402	1	0	\N
357161	1874	27838000	24998	12402	3	0	\N
357162	1874	27840000	24998	12402	4	0	\N
357171	1678	26640840022000	25000	12403	0	0	\N
357172	1678	26640840023000	25000	12403	1	0	\N
357173	1678	26640840024000	25000	12403	2	0	\N
357174	1874	27848000	25000	12403	3	0	\N
357175	1874	27850000	25000	12403	4	0	\N
357176	1874	27852000	25000	12403	5	0	\N
357177	1874	27853000	25000	12403	6	0	\N
357178	1678	26640840022000	25001	12403	0	0	\N
357179	1678	26640840023000	25001	12403	1	0	\N
357180	1678	26640840024000	25001	12403	2	0	\N
357181	1874	27848000	25001	12403	3	0	\N
357182	1874	27850000	25001	12403	4	0	\N
357183	1874	27852000	25001	12403	5	0	\N
357184	1874	27853000	25001	12403	6	0	\N
357185	1874	27856000	25001	12403	7	0	\N
357189	1678	26640840025000	25003	12404	0	0	\N
357190	1874	27857000	25003	12404	1	0	\N
357191	1874	27859000	25003	12404	2	0	\N
357192	1678	26640840025000	25004	12404	0	0	\N
357193	1874	27857000	25004	12404	1	0	\N
357194	1874	27859000	25004	12404	2	0	\N
357195	1678	26640840026000	25005	12405	0	0	\N
357196	1678	26640840027000	25005	12405	1	0	\N
357197	2317	254755211465	25005	12405	3	0	\N
357198	1874	27861000	25005	12405	4	0	\N
357199	2318	0	25005	12405	5	0	\N
357200	1874	27863000	25005	12405	6	0	\N
357207	1678	26640840028000	25007	12406	0	0	\N
357208	1874	27864000	25007	12406	1	0	\N
357209	1874	27866000	25007	12406	2	0	\N
357222	1678	26640840033000	25013	12411	0	0	\N
357223	1874	27877000	25013	12411	1	0	\N
357226	1678	26640840034000	25015	12412	0	0	\N
357227	1874	27879000	25015	12412	1	0	\N
357228	1678	26640840034000	25016	12412	0	0	\N
357229	1874	27879000	25016	12412	1	0	\N
357239	1678	26640840034000	25020	12413	0	0	\N
357240	1678	26640840035000	25020	12413	1	0	\N
357241	1678	26640840036000	25020	12413	2	0	\N
357242	1678	26640840037000	25020	12413	3	0	\N
357243	1874	27878000	25020	12413	4	0	\N
357244	1874	27880000	25020	12413	5	0	\N
357245	1874	27882000	25020	12413	6	0	\N
357246	1874	27884000	25020	12413	7	0	\N
357247	1874	27886000	25020	12413	8	0	\N
357248	1678	26640840035000	25021	12413	0	0	\N
357249	1678	26640840036000	25021	12413	1	0	\N
357250	1678	26640840037000	25021	12413	2	0	\N
357251	1874	27880000	25021	12413	3	0	\N
357252	1874	27882000	25021	12413	4	0	\N
357253	1874	27884000	25021	12413	5	0	\N
357254	1874	27886000	25021	12413	6	0	\N
357259	1600	0	25023	12414	0	0	\N
357260	1678	26640840038000	25023	12414	1	0	\N
357261	1874	27888000	25023	12414	2	0	\N
357262	1874	27889000	25023	12414	3	0	\N
357263	1678	26640840039000	25024	12415	0	0	\N
357265	1678	26640840040000	25026	12416	0	0	\N
357266	1874	27891000	25026	12416	1	0	\N
357155	1874	27839000	24997	12402	3	0	2
357156	1874	27842000	24997	12402	4	0	2
357157	1874	27844000	24997	12402	5	0	2
357158	1874	27846000	24997	12402	6	0	2
357163	1678	26640840022000	24999	12403	0	0	0
357165	1678	26640840024000	24999	12403	2	0	0
357166	1874	27848000	24999	12403	3	0	2
357167	1874	27850000	24999	12403	4	0	2
357168	1874	27852000	24999	12403	5	0	2
357169	1874	27853000	24999	12403	6	0	2
357186	1678	26640840025000	25002	12404	0	0	0
357187	1874	27857000	25002	12404	1	0	2
357188	1874	27859000	25002	12404	2	0	2
357201	1678	26640840026000	25006	12405	0	0	0
357203	2317	254755211465	25006	12405	3	0	0
357204	1874	27861000	25006	12405	4	0	2
357205	2318	0	25006	12405	5	0	0
357206	1874	27863000	25006	12405	6	0	2
357210	1678	26640840028000	25008	12406	0	0	0
357212	1874	27866000	25008	12406	2	0	2
357213	1678	26640840029000	25009	12407	0	0	0
357214	1874	27868000	25009	12407	1	0	2
357215	1678	26640840030000	25010	12408	0	0	0
357216	1874	27870000	25010	12408	1	0	2
357218	1874	27872000	25011	12409	1	0	2
357219	1678	26640840032000	25012	12410	0	0	0
357220	1874	27874000	25012	12410	2	0	2
357221	1874	27875000	25012	12410	3	0	2
357225	1874	27877000	25014	12411	1	0	2
357230	1678	26640840034000	25019	12413	0	0	0
357231	1678	26640840035000	25019	12413	1	0	0
357232	1678	26640840036000	25019	12413	2	0	0
357233	1678	26640840037000	25019	12413	3	0	0
357235	1874	27880000	25019	12413	5	0	2
357236	1874	27882000	25019	12413	6	0	2
357237	1874	27884000	25019	12413	7	0	2
357238	1874	27886000	25019	12413	8	0	2
357255	1600	0	25022	12414	0	0	0
357257	1874	27888000	25022	12414	2	0	2
357258	1874	27889000	25022	12414	3	0	2
357264	1678	26640840039000	25025	12415	0	0	0
357267	1678	26640840040000	25027	12416	0	0	0
357269	1678	26640840041000	25028	12417	0	0	0
357270	1874	27893000	25028	12417	1	0	2
357271	1678	26640840042000	25029	12418	0	0	0
357272	1678	26640840043000	25029	12418	1	0	0
357276	1678	26640840042000	25030	12418	0	0	\N
357277	1678	26640840043000	25030	12418	1	0	\N
357278	1874	27895000	25030	12418	2	0	\N
357279	1874	27897000	25030	12418	3	0	\N
357280	1874	27898000	25030	12418	4	0	\N
357283	1678	26640840044000	25032	12419	0	0	\N
357284	1874	27900000	25032	12419	1	0	\N
357287	1678	26640840045000	25034	12421	0	0	\N
357288	1678	26640840046000	25034	12421	1	0	\N
357289	1874	27905000	25034	12421	2	0	\N
357293	1678	26640840047000	25036	12422	0	0	\N
357294	1874	27907000	25036	12422	1	0	\N
357297	2316	799000000000	25038	12366	0	0	\N
357298	1950	14438851000000	25038	12366	1	0	\N
357299	2317	254755211465	25038	12366	4	0	\N
357300	2318	0	25038	12366	5	0	\N
357301	1874	27595000	25038	12366	6	0	\N
357302	1874	27598000	25038	12366	7	0	\N
357303	1874	27601000	25038	12366	8	0	\N
357304	1874	27604000	25038	12366	9	0	\N
357305	1874	27607000	25038	12366	10	0	\N
357306	1874	27610000	25038	12366	11	0	\N
357307	1874	27613000	25038	12366	12	0	\N
357308	1874	27616000	25038	12366	13	0	\N
357309	1874	27619000	25038	12366	14	0	\N
357310	1874	27622000	25038	12366	15	0	\N
357311	1874	27625000	25038	12366	16	0	\N
357312	1874	27628000	25038	12366	17	0	\N
357313	1874	27631000	25038	12366	18	0	\N
357314	1874	27634000	25038	12366	19	0	\N
357315	1874	27637000	25038	12366	20	0	\N
357316	1874	27640000	25038	12366	21	0	\N
357317	1874	27643000	25038	12366	22	0	\N
357318	1874	27646000	25038	12366	23	0	\N
357319	1874	27649000	25038	12366	25	0	\N
357320	1874	27652000	25038	12366	26	0	\N
357321	1874	27655000	25038	12366	27	0	\N
357322	1874	27658000	25038	12366	28	0	\N
357323	1874	27661000	25038	12366	29	0	\N
357324	1874	27664000	25038	12366	30	0	\N
357325	1874	27667000	25038	12366	31	0	\N
357326	1678	26640840047000	25039	12422	0	0	\N
357327	1874	27907000	25039	12422	1	0	\N
357328	1678	26640840047000	25040	12422	0	0	\N
357329	1874	27907000	25040	12422	1	0	\N
357330	1874	27907000	25041	12422	0	0	\N
357347	1678	26640840054000	25046	12427	0	0	\N
357354	1678	26640840056000	25050	12429	0	0	\N
357355	1874	27928000	25050	12429	1	0	\N
357359	1678	26640840058000	25052	12431	0	0	\N
357360	1874	27932000	25052	12431	1	0	\N
357361	1678	26640840058000	25053	12431	0	0	\N
357362	1874	27932000	25053	12431	1	0	\N
357380	1678	26640840064000	25058	12435	0	0	\N
357381	1874	27955000	25058	12435	1	0	\N
357382	1874	27957000	25058	12435	2	0	\N
357383	1874	27958000	25058	12435	3	0	\N
357391	1678	26640840065000	25061	12436	0	0	\N
357392	1874	27960000	25061	12436	1	0	\N
357393	1874	27963000	25061	12436	2	0	\N
357394	1678	26640840066000	25062	12437	0	0	\N
357395	1874	27966000	25062	12437	1	0	\N
357396	1874	27968000	25062	12437	2	0	\N
357275	1874	27898000	25029	12418	4	0	2
357281	1678	26640840044000	25031	12419	0	0	0
357282	1874	27900000	25031	12419	1	0	2
357285	1874	27901000	25033	12420	0	0	2
357286	1874	27903000	25033	12420	1	0	2
357291	1678	26640840046000	25035	12421	1	0	0
357292	1874	27905000	25035	12421	2	0	2
357295	1678	26640840047000	25037	12422	0	0	0
357296	1874	27907000	25037	12422	1	0	2
357331	1678	26640840048000	25042	12423	0	0	0
357333	1874	27909000	25042	12423	2	0	2
357334	1874	27910000	25042	12423	3	0	2
357335	1874	27912000	25042	12423	4	0	2
357336	2318	10000000000	25042	12423	5	0	0
357338	1678	26640840051000	25043	12424	1	0	0
357339	2319	299000000000	25043	12424	2	0	0
357340	1874	27914000	25043	12424	3	0	2
357341	1874	27916000	25043	12424	4	0	2
357342	1678	26640840052000	25044	12425	0	0	0
357344	1874	27919000	25044	12425	2	0	2
357345	1678	26640840053000	25045	12426	0	0	0
357346	1874	27921000	25045	12426	1	0	2
357348	1678	26640840054000	25047	12427	0	0	0
357349	1874	27923000	25047	12427	1	0	2
357351	1874	27924000	25048	12428	1	0	2
357352	1874	27926000	25048	12428	2	0	2
357353	1678	26640840056000	25049	12429	0	0	0
357356	1678	26640840057000	25051	12430	0	0	0
357358	1874	27930000	25051	12430	2	0	2
357363	1678	26640840058000	25054	12431	0	0	0
357364	1874	27932000	25054	12431	1	0	2
357365	1678	26640840059000	25055	12432	0	0	0
357366	1874	27933000	25055	12432	1	0	2
357368	1874	27937000	25055	12432	3	0	2
357369	1678	26640840060000	25056	12433	0	0	0
357370	1678	26640840061000	25056	12433	1	0	0
357371	1678	26640840062000	25056	12433	2	0	0
357372	1874	27938000	25056	12433	3	0	2
357374	1874	27943000	25056	12433	5	0	2
357375	1874	27945000	25056	12433	6	0	2
357376	1874	27947000	25056	12433	7	0	2
357377	1678	26640840063000	25057	12434	0	0	0
357379	1874	27952000	25057	12434	2	0	2
357384	1678	26640840064000	25059	12435	0	0	0
357385	1874	27955000	25059	12435	1	0	2
357386	1874	27957000	25059	12435	2	0	2
357387	1874	27958000	25059	12435	3	0	2
357389	1874	27960000	25060	12436	1	0	2
357390	1874	27963000	25060	12436	2	0	2
357397	1678	26640840066000	25063	12437	0	0	0
357398	1874	27966000	25063	12437	1	0	2
357399	1874	27968000	25063	12437	2	0	2
357401	1874	27971000	25064	12438	1	0	2
357402	1874	27973000	25064	12438	2	0	2
357403	1678	26640840068000	25065	12439	0	0	0
357404	1874	27974000	25065	12439	1	0	2
357406	1874	27979000	25065	12439	3	0	2
357407	1678	26640840069000	25066	12440	0	0	0
357408	1874	27982000	25066	12440	1	0	2
357423	1678	26640840074000	25070	12444	0	0	\N
357424	1678	26640840075000	25070	12444	1	0	\N
357425	1874	28007000	25070	12444	2	0	\N
357426	1874	28009000	25070	12444	3	0	\N
357427	1874	28010000	25070	12444	4	0	\N
357428	1874	28013000	25070	12444	5	0	\N
357429	1874	28016000	25070	12444	6	0	\N
357433	1678	26640840074000	25072	12445	0	0	\N
357434	1678	26640840075000	25072	12445	1	0	\N
357435	1678	26640840076000	25072	12445	2	0	\N
357436	1874	28012000	25072	12445	3	0	\N
357437	1874	28015000	25072	12445	4	0	\N
357438	1874	28018000	25072	12445	5	0	\N
357439	1874	28021000	25072	12445	6	0	\N
357447	1678	26640840077000	25074	12446	0	0	\N
357448	1874	28024000	25074	12446	1	0	\N
357449	1874	28026000	25074	12446	2	0	\N
357457	1678	26640840078000	25077	12447	0	0	\N
357458	1874	28029000	25077	12447	1	0	\N
357459	1874	28031000	25077	12447	2	0	\N
357460	1874	28032000	25077	12447	3	0	\N
357463	1678	26640840079000	25079	12448	0	0	\N
357464	1874	28034000	25079	12448	1	0	\N
357465	1874	28037000	25079	12448	2	0	\N
357466	1678	26640840080000	25080	12449	0	0	\N
357467	1678	26640840081000	25080	12449	1	0	\N
357468	1874	28036000	25080	12449	2	0	\N
357469	1874	28038000	25080	12449	3	0	\N
357470	1874	28039000	25080	12449	4	0	\N
357471	1874	28042000	25080	12449	5	0	\N
357472	1874	28045000	25080	12449	6	0	\N
357473	1874	28048000	25080	12449	7	0	\N
357501	1678	26640840084000	25085	12452	0	0	\N
357502	1678	26640840085000	25085	12452	1	0	\N
357503	1678	26640840086000	25085	12452	2	0	\N
357504	1678	26640840087000	25085	12452	3	0	\N
357505	1874	28061000	25085	12452	4	0	\N
357506	1874	28064000	25085	12452	5	0	\N
357507	1874	28067000	25085	12452	6	0	\N
357508	1874	28070000	25085	12452	7	0	\N
357509	1874	28071000	25085	12452	8	0	\N
357510	1874	28073000	25085	12452	9	0	\N
357511	1874	28075000	25085	12452	10	0	\N
357512	1874	28077000	25085	12452	11	0	\N
357513	1874	28079000	25085	12452	12	0	\N
357518	1678	26640840089000	25087	12454	0	0	\N
357519	1678	26640840090000	25087	12454	1	0	\N
357520	1874	28087000	25087	12454	2	0	\N
357521	1874	28090000	25087	12454	3	0	\N
357522	1874	28093000	25087	12454	4	0	\N
357523	1874	28095000	25087	12454	5	0	\N
357524	1678	26640840089000	25088	12454	0	0	\N
357525	1678	26640840090000	25088	12454	1	0	\N
357526	1874	28087000	25088	12454	2	0	\N
357527	1874	28090000	25088	12454	3	0	\N
357528	1874	28093000	25088	12454	4	0	\N
357529	1874	28095000	25088	12454	5	0	\N
357536	1678	26640840091000	25090	12455	0	0	\N
357537	1874	28097000	25090	12455	1	0	\N
357538	1874	28098000	25090	12455	2	0	\N
357543	1678	26640840091000	25092	12455	0	0	\N
357544	1874	28098000	25092	12455	1	0	\N
357411	1874	27986000	25067	12441	1	0	2
357412	1874	27989000	25067	12441	2	0	2
357413	1678	26640840071000	25068	12442	0	0	0
357414	1678	26640840072000	25068	12442	1	0	0
357415	1874	27990000	25068	12442	2	0	2
357417	1874	27994000	25068	12442	4	0	2
357418	1874	27997000	25068	12442	5	0	2
357419	1874	28000000	25068	12442	6	0	2
357420	1678	26640840073000	25069	12443	0	0	0
357421	1874	28002000	25069	12443	1	0	2
357430	1874	28007000	25071	12444	0	0	2
357431	1874	28009000	25071	12444	1	0	2
357432	1874	28010000	25071	12444	2	0	2
357440	1678	26640840074000	25073	12445	0	0	0
357442	1678	26640840076000	25073	12445	2	0	0
357443	1874	28012000	25073	12445	3	0	2
357444	1874	28015000	25073	12445	4	0	2
357445	1874	28018000	25073	12445	5	0	2
357446	1874	28021000	25073	12445	6	0	2
357451	1874	28024000	25075	12446	1	0	2
357452	1874	28026000	25075	12446	2	0	2
357453	1678	26640840078000	25076	12447	0	0	0
357454	1874	28029000	25076	12447	1	0	2
357455	1874	28031000	25076	12447	2	0	2
357461	1678	26640840079000	25078	12448	0	0	0
357462	1874	28034000	25078	12448	1	0	2
357474	1678	26640840080000	25081	12449	0	0	0
357475	1678	26640840081000	25081	12449	1	0	0
357477	1874	28038000	25081	12449	3	0	2
357478	1874	28039000	25081	12449	4	0	2
357479	1874	28042000	25081	12449	5	0	2
357480	1874	28045000	25081	12449	6	0	2
357481	1874	28048000	25081	12449	7	0	2
357483	1874	28050000	25082	12450	1	0	2
357484	1874	28053000	25082	12450	2	0	2
357485	1678	26640840083000	25083	12451	0	0	0
357486	1874	28055000	25083	12451	1	0	2
357487	1874	28058000	25083	12451	2	0	2
357489	1678	26640840085000	25084	12452	1	0	0
357490	1678	26640840086000	25084	12452	2	0	0
357491	1678	26640840087000	25084	12452	3	0	0
357492	1874	28061000	25084	12452	4	0	2
357494	1874	28067000	25084	12452	6	0	2
357495	1874	28070000	25084	12452	7	0	2
357496	1874	28071000	25084	12452	8	0	2
357497	1874	28073000	25084	12452	9	0	2
357498	1874	28075000	25084	12452	10	0	2
357500	1874	28079000	25084	12452	12	0	2
357514	1678	26640840088000	25086	12453	0	0	0
357515	1874	28081000	25086	12453	1	0	2
357516	1874	28082000	25086	12453	2	0	2
357517	1874	28085000	25086	12453	3	0	2
357531	1678	26640840090000	25089	12454	1	0	0
357532	1874	28087000	25089	12454	2	0	2
357533	1874	28090000	25089	12454	3	0	2
357534	1874	28093000	25089	12454	4	0	2
357539	1678	26640840091000	25091	12455	0	0	0
357540	1874	28098000	25091	12455	1	0	2
357541	1874	28100000	25091	12455	2	0	2
357542	1874	28101000	25091	12455	3	0	2
357545	1874	28100000	25092	12455	2	0	\N
357546	1874	28101000	25092	12455	3	0	\N
357547	1678	26640840091000	25093	12455	0	0	\N
357548	1874	28098000	25093	12455	1	0	\N
357549	1874	28100000	25093	12455	2	0	\N
357550	1874	28101000	25093	12455	3	0	\N
357551	1678	26640840092000	25094	12456	0	0	\N
357552	1874	28103000	25094	12456	1	0	\N
357553	1874	28106000	25094	12456	2	0	\N
357554	1678	26640840092000	25095	12456	0	0	\N
357555	1874	28103000	25095	12456	1	0	\N
357556	1874	28106000	25095	12456	2	0	\N
357557	1678	26640840092000	25096	12456	0	0	\N
357558	1874	28103000	25096	12456	1	0	\N
357559	1874	28106000	25096	12456	2	0	\N
357563	1678	26640840093000	25098	12457	0	0	\N
357564	1874	28109000	25098	12457	1	0	\N
357565	1874	28111000	25098	12457	2	0	\N
357566	1678	26640840093000	25099	12457	0	0	\N
357567	1874	28109000	25099	12457	1	0	\N
357568	1874	28111000	25099	12457	2	0	\N
357569	1678	26640840093000	25100	12457	0	0	\N
357570	1874	28109000	25100	12457	1	0	\N
357571	1874	28111000	25100	12457	2	0	\N
357575	1874	28109000	25102	12457	0	0	\N
357576	1874	28111000	25102	12457	1	0	\N
357577	1678	26640840093000	25103	12457	0	0	\N
357578	1874	28109000	25103	12457	1	0	\N
357579	1874	28111000	25103	12457	2	0	\N
357580	1678	26640840079000	25104	12448	0	0	\N
357581	1678	26640840080000	25104	12448	1	0	\N
357582	1678	26640840081000	25104	12448	2	0	\N
357583	1678	26640840082000	25104	12448	3	0	\N
357584	1678	26640840083000	25104	12448	4	0	\N
357585	1678	26640840084000	25104	12448	5	0	\N
357586	1678	26640840085000	25104	12448	6	0	\N
357587	1678	26640840086000	25104	12448	7	0	\N
357588	1678	26640840087000	25104	12448	8	0	\N
357589	1678	26640840088000	25104	12448	9	0	\N
357590	1678	26640840089000	25104	12448	10	0	\N
357591	1678	26640840090000	25104	12448	11	0	\N
357592	1678	26640840091000	25104	12448	12	0	\N
357593	1678	26640840092000	25104	12448	13	0	\N
357594	1874	28034000	25104	12448	14	0	\N
357595	1874	28036000	25104	12448	15	0	\N
357596	1874	28038000	25104	12448	16	0	\N
357597	1874	28040000	25104	12448	17	0	\N
357598	1874	28042000	25104	12448	18	0	\N
357599	1874	28043000	25104	12448	19	0	\N
357600	1874	28044000	25104	12448	20	0	\N
357601	1874	28045000	25104	12448	21	0	\N
357602	1874	28046000	25104	12448	22	0	\N
357603	1874	28049000	25104	12448	23	0	\N
357604	1874	28052000	25104	12448	24	0	\N
357605	1874	28055000	25104	12448	25	0	\N
357606	1874	28058000	25104	12448	26	0	\N
357607	1874	28061000	25104	12448	27	0	\N
357608	1874	28064000	25104	12448	28	0	\N
357609	1874	28067000	25104	12448	29	0	\N
357610	1874	28070000	25104	12448	30	0	\N
357611	1874	28073000	25104	12448	31	0	\N
357612	1874	28076000	25104	12448	32	0	\N
357613	1874	28079000	25104	12448	33	0	\N
357614	1874	28082000	25104	12448	34	0	\N
357615	1874	28085000	25104	12448	35	0	\N
357616	1874	28088000	25104	12448	36	0	\N
357617	1874	28090000	25104	12448	37	0	\N
357618	1874	28092000	25104	12448	38	0	\N
357619	1874	28094000	25104	12448	39	0	\N
357620	1874	28096000	25104	12448	40	0	\N
357621	1874	28098000	25104	12448	41	0	\N
357622	1874	28100000	25104	12448	42	0	\N
357623	1874	28102000	25104	12448	43	0	\N
357624	1874	28104000	25104	12448	44	0	\N
357625	1874	28106000	25104	12448	45	0	\N
357626	1678	26640840093000	25105	12457	0	0	\N
357627	1874	28109000	25105	12457	1	0	\N
357628	1874	28111000	25105	12457	2	0	\N
357629	1678	26640840093000	25106	12457	0	0	\N
357630	1874	28109000	25106	12457	1	0	\N
357631	1874	28111000	25106	12457	2	0	\N
357632	1874	28113000	25106	12457	3	0	\N
357643	1678	26640840094000	25108	12458	0	0	\N
357644	1678	26640840095000	25108	12458	1	0	\N
357645	1678	26640840096000	25108	12458	2	0	\N
357646	1874	28114000	25108	12458	3	0	\N
357647	1874	28116000	25108	12458	4	0	\N
357648	1874	28118000	25108	12458	5	0	\N
357649	1678	26640840093000	25109	12449	0	0	\N
357650	1678	26640840094000	25109	12449	1	0	\N
357651	1678	26640840095000	25109	12449	2	0	\N
357652	1678	26640840096000	25109	12449	4	0	\N
357653	1874	28107000	25109	12449	5	0	\N
357654	1874	28110000	25109	12449	6	0	\N
357655	1874	28113000	25109	12449	7	0	\N
357656	1874	28116000	25109	12449	8	0	\N
357657	1874	28118000	25109	12449	9	0	\N
357658	1874	28120000	25109	12449	10	0	\N
357659	1874	28122000	25109	12449	11	0	\N
357660	1874	28124000	25109	12449	12	0	\N
357661	1874	28127000	25109	12449	13	0	\N
357672	1678	26640840100000	25113	12462	0	0	\N
357673	1874	28146000	25113	12462	1	0	\N
357674	1874	28148000	25113	12462	2	0	\N
357562	1874	28106000	25097	12456	2	0	2
357572	1678	26640840093000	25101	12457	0	0	0
357573	1874	28109000	25101	12457	1	0	2
357574	1874	28111000	25101	12457	2	0	2
357633	1678	26640840094000	25107	12458	0	0	0
357635	1678	26640840096000	25107	12458	2	0	0
357636	1874	28112000	25107	12458	3	0	2
357637	1874	28115000	25107	12458	4	0	2
357638	1874	28118000	25107	12458	5	0	2
357639	1874	28120000	25107	12458	6	0	2
357641	1874	28124000	25107	12458	8	0	2
357642	1874	28127000	25107	12458	9	0	2
357662	1678	26640840097000	25110	12459	0	0	0
357663	1874	28129000	25110	12459	1	0	2
357665	1678	26640840098000	25111	12460	0	0	0
357666	1874	28135000	25111	12460	1	0	2
357667	1874	28137000	25111	12460	2	0	2
357668	1874	28138000	25111	12460	3	0	2
357669	1678	26640840099000	25112	12461	0	0	0
357671	1874	28143000	25112	12461	2	0	2
357675	1678	26640840100000	25114	12462	0	0	0
357676	1874	28146000	25114	12462	1	0	2
357677	1874	28148000	25114	12462	2	0	2
357678	1874	28151000	25115	12463	0	0	2
357680	1874	28154000	25115	12463	2	0	2
357687	1678	26640840101000	25117	12464	0	0	\N
357688	1678	26640840102000	25117	12464	1	0	\N
357689	1874	28156000	25117	12464	2	0	\N
357690	1874	28159000	25117	12464	3	0	\N
357691	1874	28162000	25117	12464	4	0	\N
357692	1874	28164000	25117	12464	5	0	\N
357693	1678	26640840101000	25118	12464	0	0	\N
357694	1678	26640840102000	25118	12464	1	0	\N
357695	1874	28156000	25118	12464	2	0	\N
357696	1874	28159000	25118	12464	3	0	\N
357697	1874	28162000	25118	12464	4	0	\N
357698	1874	28164000	25118	12464	5	0	\N
357699	1678	26640840101000	25119	12464	0	0	\N
357700	1678	26640840102000	25119	12464	1	0	\N
357701	1874	28156000	25119	12464	2	0	\N
357702	1874	28159000	25119	12464	3	0	\N
357703	1874	28162000	25119	12464	4	0	\N
357704	1874	28164000	25119	12464	5	0	\N
357705	2314	551000000000	25120	12288	0	0	\N
357706	1860	67001978700000	25120	12288	1	0	\N
357707	1678	26640839910000	25120	12288	2	0	\N
357708	1678	26640839911000	25120	12288	3	0	\N
357709	2315	9000000000	25120	12288	4	0	\N
357710	2315	10000000000	25120	12288	5	0	\N
357711	2316	799000000000	25120	12288	6	0	\N
357712	1678	26640839912000	25120	12288	7	0	\N
357713	1678	26640839913000	25120	12288	8	0	\N
357714	1678	26640839914000	25120	12288	9	0	\N
357715	1678	26640839915000	25120	12288	10	0	\N
357716	1678	26640839916000	25120	12288	11	0	\N
357717	1678	26640839917000	25120	12288	12	0	\N
357718	1678	26640839918000	25120	12288	13	0	\N
357719	1678	26640839919000	25120	12288	14	0	\N
357720	1678	26640839920000	25120	12288	15	0	\N
357721	1678	26640839921000	25120	12288	16	0	\N
357722	1678	26640839922000	25120	12288	17	0	\N
357723	1678	26640839923000	25120	12288	18	0	\N
357724	1678	26640839924000	25120	12288	19	0	\N
357725	1678	26640839925000	25120	12288	20	0	\N
357726	1678	26640839926000	25120	12288	21	0	\N
357727	1678	26640839927000	25120	12288	22	0	\N
357728	1678	26640839928000	25120	12288	23	0	\N
357729	1678	26640839929000	25120	12288	24	0	\N
357730	1678	26640839930000	25120	12288	25	0	\N
357731	1678	26640839931000	25120	12288	26	0	\N
357732	1678	26640839932000	25120	12288	27	0	\N
357733	1678	26640839933000	25120	12288	28	0	\N
357734	1678	26640839934000	25120	12288	29	0	\N
357735	1678	26640839935000	25120	12288	30	0	\N
357736	1678	26640839936000	25120	12288	31	0	\N
357737	1678	26640839937000	25120	12288	32	0	\N
357738	1678	26640839938000	25120	12288	33	0	\N
357739	1678	26640839939000	25120	12288	34	0	\N
357740	1678	26640839940000	25120	12288	35	0	\N
357741	1678	26640839941000	25120	12288	36	0	\N
357742	1678	26640839942000	25120	12288	37	0	\N
357743	1678	26640839943000	25120	12288	38	0	\N
357744	1678	26640839944000	25120	12288	39	0	\N
357745	1678	26640839945000	25120	12288	40	0	\N
357746	1678	26640839946000	25120	12288	41	0	\N
357747	1678	26640839947000	25120	12288	42	0	\N
357748	1678	26640839948000	25120	12288	43	0	\N
357749	1678	26640839949000	25120	12288	44	0	\N
357750	1678	26640839950000	25120	12288	45	0	\N
357751	1678	26640839951000	25120	12288	46	0	\N
357752	1678	26640839952000	25120	12288	47	0	\N
357753	1678	26640839953000	25120	12288	48	0	\N
357754	1678	26640839954000	25120	12288	49	0	\N
357755	1678	26640839955000	25120	12288	50	0	\N
357756	1678	26640839956000	25120	12288	51	0	\N
357757	1678	26640839957000	25120	12288	52	0	\N
357758	1678	26640839958000	25120	12288	53	0	\N
357759	1678	26640839959000	25120	12288	54	0	\N
357760	1678	26640839960000	25120	12288	55	0	\N
357761	1678	26640839961000	25120	12288	56	0	\N
357762	1678	26640839962000	25120	12288	57	0	\N
357763	1678	26640839963000	25120	12288	58	0	\N
357764	1678	26640839964000	25120	12288	59	0	\N
357765	1678	26640839965000	25120	12288	60	0	\N
357766	1678	26640839966000	25120	12288	61	0	\N
357767	1678	26640839967000	25120	12288	62	0	\N
357768	1678	26640839968000	25120	12288	63	0	\N
357769	1678	26640839969000	25120	12288	64	0	\N
357770	1678	26640839970000	25120	12288	65	0	\N
357771	1678	26640839971000	25120	12288	66	0	\N
357772	1678	26640839972000	25120	12288	67	0	\N
357773	1678	26640839973000	25120	12288	68	0	\N
357774	1678	26640839974000	25120	12288	69	0	\N
357775	1678	26640839975000	25120	12288	70	0	\N
357776	1678	26640839976000	25120	12288	71	0	\N
357777	1678	26640839977000	25120	12288	72	0	\N
357778	1678	26640839978000	25120	12288	73	0	\N
357779	1678	26640839979000	25120	12288	74	0	\N
357780	1678	26640839980000	25120	12288	75	0	\N
357781	1678	26640839981000	25120	12288	76	0	\N
357782	1678	26640839982000	25120	12288	77	0	\N
357783	1678	26640839983000	25120	12288	78	0	\N
357784	1678	26640839984000	25120	12288	79	0	\N
357785	1678	26640839985000	25120	12288	80	0	\N
357786	1678	26640839986000	25120	12288	81	0	\N
357787	1678	26640839987000	25120	12288	83	0	\N
357788	1678	26640839988000	25120	12288	84	0	\N
357789	1678	26640839989000	25120	12288	85	0	\N
357790	1678	26640839990000	25120	12288	86	0	\N
357791	1678	26640839991000	25120	12288	87	0	\N
357792	1678	26640839992000	25120	12288	88	0	\N
357793	1678	26640839993000	25120	12288	89	0	\N
357794	1678	26640839994000	25120	12288	90	0	\N
357795	1678	26640839995000	25120	12288	91	0	\N
357796	1678	26640839996000	25120	12288	92	0	\N
357797	1678	26640839997000	25120	12288	93	0	\N
357798	1678	26640839998000	25120	12288	94	0	\N
357799	1678	26640839999000	25120	12288	95	0	\N
357800	1678	26640840000000	25120	12288	96	0	\N
357801	1678	26640840001000	25120	12288	97	0	\N
357802	1678	26640840002000	25120	12288	98	0	\N
357803	1678	26640840003000	25120	12288	99	0	\N
357804	1678	26640840004000	25120	12288	100	0	\N
357805	1678	26640840005000	25120	12288	101	0	\N
357806	1678	26640840006000	25120	12288	102	0	\N
357807	1678	26640840007000	25120	12288	103	0	\N
357808	1678	26640840008000	25120	12288	104	0	\N
357809	1678	26640840009000	25120	12288	105	0	\N
357810	1678	26640840010000	25120	12288	106	0	\N
357811	1678	26640840011000	25120	12288	107	0	\N
357812	1678	26640840012000	25120	12288	108	0	\N
357813	1678	26640840013000	25120	12288	109	0	\N
357814	1678	26640840014000	25120	12288	110	0	\N
357815	1678	26640840015000	25120	12288	111	0	\N
357816	1678	26640840016000	25120	12288	112	0	\N
357683	1874	28156000	25116	12464	2	0	2
357684	1874	28159000	25116	12464	3	0	2
357685	1874	28162000	25116	12464	4	0	2
357686	1874	28164000	25116	12464	5	0	2
357817	1678	26640840017000	25120	12288	113	0	\N
357818	1678	26640840018000	25120	12288	114	0	\N
357819	1678	26640840019000	25120	12288	115	0	\N
357820	1678	26640840020000	25120	12288	116	0	\N
357821	1678	26640840021000	25120	12288	117	0	\N
357822	1678	26640840022000	25120	12288	118	0	\N
357823	1678	26640840023000	25120	12288	119	0	\N
357824	1678	26640840024000	25120	12288	120	0	\N
357825	1678	26640840025000	25120	12288	121	0	\N
357826	1678	26640840026000	25120	12288	122	0	\N
357827	1678	26640840027000	25120	12288	123	0	\N
357828	1678	26640840028000	25120	12288	124	0	\N
357829	1678	26640840103000	25121	12465	0	0	\N
357830	1874	28167000	25121	12465	1	0	\N
357831	1874	28169000	25121	12465	2	0	\N
357832	1678	26640840103000	25122	12465	0	0	\N
357833	1874	28167000	25122	12465	1	0	\N
357834	1874	28169000	25122	12465	2	0	\N
357838	1678	26640840104000	25124	12466	0	0	\N
357839	1874	28170000	25124	12466	1	0	\N
357840	1874	28172000	25124	12466	2	0	\N
357841	1874	28175000	25124	12466	3	0	\N
357859	1678	26640840108000	25130	12470	0	0	\N
357860	1874	28194000	25130	12470	1	0	\N
357861	1874	28196000	25130	12470	2	0	\N
357862	1678	26640840109000	25131	12471	0	0	\N
357863	1678	26640840110000	25131	12471	1	0	\N
357864	1874	28199000	25131	12471	2	0	\N
357865	1874	28200000	25131	12471	3	0	\N
357866	1874	28203000	25131	12471	4	0	\N
357867	1874	28205000	25131	12471	5	0	\N
357868	1874	28207000	25131	12471	6	0	\N
357869	1678	26640840109000	25132	12471	0	0	\N
357870	1678	26640840110000	25132	12471	1	0	\N
357871	1874	28199000	25132	12471	2	0	\N
357872	1874	28200000	25132	12471	3	0	\N
357873	1874	28203000	25132	12471	4	0	\N
357874	1874	28205000	25132	12471	5	0	\N
357875	1874	28207000	25132	12471	6	0	\N
357883	1678	26640840109000	25134	12471	0	0	\N
357884	1678	26640840110000	25134	12471	1	0	\N
357885	1874	28199000	25134	12471	2	0	\N
357886	1874	28200000	25134	12471	3	0	\N
357887	1874	28203000	25134	12471	4	0	\N
357888	1874	28205000	25134	12471	5	0	\N
357889	1874	28207000	25134	12471	6	0	\N
357890	1678	26640840109000	25135	12471	0	0	\N
357891	1678	26640840110000	25135	12471	1	0	\N
357892	1874	28199000	25135	12471	2	0	\N
357893	1874	28200000	25135	12471	3	0	\N
357894	1874	28203000	25135	12471	4	0	\N
357895	1874	28205000	25135	12471	5	0	\N
357896	1874	28207000	25135	12471	6	0	\N
357897	1678	26640840111000	25136	12472	0	0	\N
357898	1874	28210000	25136	12472	1	0	\N
357899	1874	28212000	25136	12472	2	0	\N
357903	1678	26640840111000	25138	12472	0	0	\N
357904	1874	28210000	25138	12472	1	0	\N
357905	1874	28212000	25138	12472	2	0	\N
357906	1678	26640840112000	25139	12473	0	0	\N
357907	1874	28214000	25139	12473	1	0	\N
357908	1874	28217000	25139	12473	2	0	\N
357909	1678	26640840112000	25140	12473	0	0	\N
357910	1874	28214000	25140	12473	1	0	\N
357911	1874	28217000	25140	12473	2	0	\N
357918	1678	26640840113000	25143	12474	0	0	\N
357919	1874	28220000	25143	12474	1	0	\N
357920	1874	28222000	25143	12474	2	0	\N
357929	1678	26640840116000	25146	12477	0	0	\N
357930	1874	28235000	25146	12477	1	0	\N
357931	1874	28238000	25146	12477	2	0	\N
357935	1678	26640840116000	25148	12477	0	0	\N
357936	1874	28235000	25148	12477	1	0	\N
357937	1874	28238000	25148	12477	2	0	\N
357943	1678	26640840106000	25150	12468	0	0	\N
357944	1678	26640840107000	25150	12468	1	0	\N
357945	1678	26640840108000	25150	12468	2	0	\N
357946	1678	26640840109000	25150	12468	3	0	\N
357947	1678	26640840110000	25150	12468	4	0	\N
357948	1678	26640840111000	25150	12468	5	0	\N
357949	1678	26640840112000	25150	12468	6	0	\N
357950	1678	26640840113000	25150	12468	7	0	\N
357951	1678	26640840114000	25150	12468	8	0	\N
357952	1678	26640840115000	25150	12468	9	0	\N
357837	1874	28169000	25123	12465	2	0	2
357842	1678	26640840104000	25125	12466	0	0	0
357843	1874	28170000	25125	12466	1	0	2
357844	1874	28172000	25125	12466	2	0	2
357845	1874	28175000	25125	12466	3	0	2
357847	1874	28177000	25126	12467	1	0	2
357848	1874	28180000	25126	12467	2	0	2
357849	1678	26640840106000	25127	12468	0	0	0
357850	1874	28182000	25127	12468	1	0	2
357851	1874	28185000	25127	12468	2	0	2
357853	1874	28187000	25128	12469	1	0	2
357854	1874	28190000	25128	12469	2	0	2
357855	1874	28191000	25128	12469	3	0	2
357856	1678	26640840108000	25129	12470	0	0	0
357858	1874	28196000	25129	12470	2	0	2
357876	1678	26640840109000	25133	12471	0	0	0
357877	1678	26640840110000	25133	12471	1	0	0
357878	1874	28199000	25133	12471	2	0	2
357879	1874	28200000	25133	12471	3	0	2
357881	1874	28205000	25133	12471	5	0	2
357882	1874	28207000	25133	12471	6	0	2
357900	1678	26640840111000	25137	12472	0	0	0
357901	1874	28210000	25137	12472	1	0	2
357902	1874	28212000	25137	12472	2	0	2
357913	1874	28214000	25141	12473	1	0	2
357914	1874	28217000	25141	12473	2	0	2
357915	1678	26640840113000	25142	12474	0	0	0
357916	1874	28220000	25142	12474	1	0	2
357921	1678	26640840114000	25144	12475	0	0	0
357922	1874	28224000	25144	12475	1	0	2
357923	2320	0	25144	12475	2	0	0
357924	1874	28225000	25144	12475	3	0	2
357925	1874	28228000	25144	12475	4	0	2
357927	1874	28230000	25145	12476	2	0	2
357928	1874	28233000	25145	12476	3	0	2
357932	1678	26640840116000	25147	12477	0	0	0
357933	1874	28235000	25147	12477	1	0	2
357934	1874	28238000	25147	12477	2	0	2
357939	1874	28240000	25149	12478	1	0	2
357940	1874	28241000	25149	12478	2	0	2
357941	1403	0	25149	12478	3	0	0
357942	1874	28244000	25149	12478	4	0	2
357953	1678	26640840116000	25150	12468	10	0	\N
357954	1678	26640840117000	25150	12468	11	0	\N
357955	1874	28182000	25150	12468	12	0	\N
357956	1874	28184000	25150	12468	13	0	\N
357957	2320	0	25150	12468	14	0	\N
357958	1874	28187000	25150	12468	15	0	\N
357959	1874	28189000	25150	12468	16	0	\N
357960	1874	28191000	25150	12468	17	0	\N
357961	1874	28193000	25150	12468	18	0	\N
357962	1874	28195000	25150	12468	19	0	\N
357963	1874	28197000	25150	12468	20	0	\N
357964	1874	28199000	25150	12468	21	0	\N
357965	1874	28201000	25150	12468	22	0	\N
357966	1874	28203000	25150	12468	23	0	\N
357967	1874	28205000	25150	12468	24	0	\N
357968	1874	28207000	25150	12468	25	0	\N
357969	1403	0	25150	12468	26	0	\N
357970	1874	28210000	25150	12468	27	0	\N
357971	1874	28213000	25150	12468	28	0	\N
357972	1874	28216000	25150	12468	29	0	\N
357973	1874	28219000	25150	12468	30	0	\N
357974	1874	28222000	25150	12468	31	0	\N
357975	1874	28225000	25150	12468	32	0	\N
357976	1874	28228000	25150	12468	33	0	\N
357977	1874	28231000	25150	12468	34	0	\N
357978	1874	28234000	25150	12468	35	0	\N
357979	1874	28237000	25150	12468	36	0	\N
357980	1874	28238000	25150	12468	37	0	\N
357981	1874	28239000	25150	12468	38	0	\N
357982	1874	28240000	25150	12468	39	0	\N
357983	1874	28241000	25150	12468	40	0	\N
357984	1874	28244000	25150	12468	41	0	\N
357985	2320	1000000000	25151	12479	0	0	\N
357986	1874	28247000	25151	12479	1	0	\N
357987	1874	28249000	25151	12479	2	0	\N
357988	1678	26640840118000	25152	12479	0	0	\N
357989	2320	1000000000	25152	12479	1	0	\N
357990	1874	28247000	25152	12479	2	0	\N
357991	1874	28249000	25152	12479	3	0	\N
358006	2320	775742211465	25156	12481	0	0	\N
358007	1678	26640840120000	25156	12481	1	0	\N
358008	1874	28257000	25156	12481	2	0	\N
358009	1874	28258000	25156	12481	3	0	\N
358010	1874	28260000	25156	12481	4	0	\N
358011	1540	0	25156	12481	5	0	\N
358012	2320	775742211465	25157	12481	0	0	\N
358013	1678	26640840120000	25157	12481	1	0	\N
358014	1874	28257000	25157	12481	2	0	\N
358015	1874	28258000	25157	12481	3	0	\N
358016	1874	28260000	25157	12481	4	0	\N
358017	1540	0	25157	12481	5	0	\N
358018	2320	775742211465	25158	12481	0	0	\N
358019	1678	26640840120000	25158	12481	1	0	\N
358020	1874	28257000	25158	12481	2	0	\N
358021	1874	28258000	25158	12481	3	0	\N
358022	1874	28260000	25158	12481	4	0	\N
358023	1540	0	25158	12481	5	0	\N
358027	1678	26640840118000	25160	12469	0	0	\N
358028	1678	26640840119000	25160	12469	1	0	\N
358029	1678	26640840120000	25160	12469	2	0	\N
358030	1678	26640840121000	25160	12469	3	0	\N
358031	2320	1000000000	25160	12469	5	0	\N
358032	2320	775743211465	25160	12469	6	0	\N
358033	1874	28245000	25160	12469	7	0	\N
358034	1874	28248000	25160	12469	8	0	\N
358035	1874	28250000	25160	12469	9	0	\N
358036	1540	0	25160	12469	10	0	\N
358037	1874	28252000	25160	12469	11	0	\N
358038	1874	28254000	25160	12469	12	0	\N
358039	1874	28257000	25160	12469	13	0	\N
358040	1874	28260000	25160	12469	14	0	\N
358045	1678	26640840122000	25162	12483	0	0	\N
358046	1600	0	25162	12483	1	0	\N
358047	1874	28268000	25162	12483	2	0	\N
358048	1874	28270000	25162	12483	3	0	\N
358052	1678	26640840123000	25164	12484	0	0	\N
358053	1874	28272000	25164	12484	1	0	\N
358054	1874	28275000	25164	12484	2	0	\N
358055	1678	26640840123000	25165	12484	0	0	\N
358056	1874	28272000	25165	12484	1	0	\N
358057	1874	28275000	25165	12484	2	0	\N
358058	1678	26640840122000	25166	12470	0	0	\N
358059	1678	26640840123000	25166	12470	1	0	\N
358060	1874	28263000	25166	12470	2	0	\N
358061	1874	28265000	25166	12470	3	0	\N
358062	1874	28268000	25166	12470	4	0	\N
358063	1874	28271000	25166	12470	5	0	\N
358064	1874	28273000	25166	12470	6	0	\N
358065	1874	28275000	25166	12470	7	0	\N
358070	1678	26640840124000	25168	12485	0	0	\N
358071	1874	28278000	25168	12485	1	0	\N
358072	1874	28279000	25168	12485	2	0	\N
358073	1874	28281000	25168	12485	3	0	\N
358074	1678	26640840125000	25169	12486	0	0	\N
358075	1874	28283000	25169	12486	1	0	\N
358076	1874	28286000	25169	12486	2	0	\N
358077	1678	26640840125000	25170	12486	0	0	\N
358078	1874	28283000	25170	12486	1	0	\N
358079	1874	28286000	25170	12486	2	0	\N
357994	1874	28247000	25153	12479	2	0	2
357995	1874	28249000	25153	12479	3	0	2
357996	1678	26640840119000	25154	12480	0	0	0
357997	1600	0	25154	12480	1	0	0
357998	1874	28251000	25154	12480	2	0	2
358000	2320	775742211465	25155	12481	0	0	1
358001	1678	26640840120000	25155	12481	1	0	0
358002	1874	28257000	25155	12481	2	0	2
358003	1874	28258000	25155	12481	3	0	2
358004	1874	28260000	25155	12481	4	0	2
358024	1678	26640840121000	25159	12482	0	0	0
358025	1874	28263000	25159	12482	1	0	2
358026	1874	28265000	25159	12482	2	0	2
358041	1678	26640840122000	25161	12483	0	0	0
358043	1874	28268000	25161	12483	2	0	2
358044	1874	28270000	25161	12483	3	0	2
358049	1678	26640840123000	25163	12484	0	0	0
358050	1874	28272000	25163	12484	1	0	2
358051	1874	28275000	25163	12484	2	0	2
358067	1874	28278000	25167	12485	1	0	2
358068	1874	28279000	25167	12485	2	0	2
358069	1874	28281000	25167	12485	3	0	2
358080	1874	28283000	25171	12486	0	0	2
358081	1874	28286000	25171	12486	1	0	2
358083	1678	26640840126000	25172	12487	1	0	0
358084	1874	28289000	25172	12487	2	0	2
358085	1874	28291000	25172	12487	3	0	2
358086	1678	26640840127000	25173	12488	0	0	0
358088	1874	28296000	25173	12488	2	0	2
358109	1678	26640840128000	25183	12489	0	0	\N
358110	1678	26640840129000	25183	12489	1	0	\N
358111	1678	26640840130000	25183	12489	2	0	\N
358112	1678	26640840131000	25183	12489	3	0	\N
358113	1678	26640840132000	25183	12489	4	0	\N
358114	1678	26640840133000	25183	12489	5	0	\N
358115	1678	26640840134000	25183	12489	6	0	\N
358116	1678	26640840135000	25183	12489	7	0	\N
358117	1678	26640840136000	25183	12489	8	0	\N
358118	1874	28300000	25183	12489	9	0	\N
358119	1874	28302000	25183	12489	10	0	\N
358120	1874	28303000	25183	12489	11	0	\N
358121	949	508024693710000	25183	12489	12	0	\N
358122	1874	28306000	25183	12489	13	0	\N
358123	1874	28309000	25183	12489	14	0	\N
358124	1874	28312000	25183	12489	15	0	\N
358125	1874	28315000	25183	12489	16	0	\N
358126	1874	28318000	25183	12489	17	0	\N
358127	1874	28321000	25183	12489	18	0	\N
358128	1874	28324000	25183	12489	19	0	\N
358129	1874	28327000	25183	12489	20	0	\N
358130	1874	28328000	25183	12489	21	0	\N
358131	1874	28330000	25183	12489	22	0	\N
358132	1874	28332000	25183	12489	23	0	\N
358133	1874	28334000	25183	12489	24	0	\N
358134	1874	28336000	25183	12489	25	0	\N
358135	1874	28338000	25183	12489	26	0	\N
358136	1874	28340000	25183	12489	27	0	\N
358137	1874	28342000	25183	12489	28	0	\N
358138	1874	28344000	25183	12489	29	0	\N
358139	1678	26640840134000	25184	12495	0	0	\N
358140	1678	26640840135000	25184	12495	1	0	\N
358141	1678	26640840136000	25184	12495	2	0	\N
358142	1874	28330000	25184	12495	3	0	\N
358143	1874	28332000	25184	12495	4	0	\N
358144	1874	28334000	25184	12495	5	0	\N
358145	949	508024693710000	25184	12495	6	0	\N
358146	1874	28337000	25184	12495	7	0	\N
358147	1874	28340000	25184	12495	8	0	\N
358148	1874	28343000	25184	12495	9	0	\N
358149	1874	28344000	25184	12495	10	0	\N
358161	1678	26640840134000	25186	12495	0	0	\N
358162	1678	26640840135000	25186	12495	1	0	\N
358163	1678	26640840136000	25186	12495	2	0	\N
358164	1874	28330000	25186	12495	3	0	\N
358165	1874	28332000	25186	12495	4	0	\N
358166	1874	28334000	25186	12495	5	0	\N
358167	949	508024693710000	25186	12495	6	0	\N
358168	1874	28337000	25186	12495	7	0	\N
358169	1874	28340000	25186	12495	8	0	\N
358170	1874	28343000	25186	12495	9	0	\N
358171	1874	28344000	25186	12495	10	0	\N
358172	1678	26640840134000	25187	12495	0	0	\N
358173	1678	26640840135000	25187	12495	1	0	\N
358174	1678	26640840136000	25187	12495	2	0	\N
358175	1874	28330000	25187	12495	3	0	\N
358176	1874	28332000	25187	12495	4	0	\N
358177	1874	28334000	25187	12495	5	0	\N
358178	949	508024693710000	25187	12495	6	0	\N
358179	1874	28337000	25187	12495	7	0	\N
358180	1874	28340000	25187	12495	8	0	\N
358181	1874	28343000	25187	12495	9	0	\N
358182	1874	28344000	25187	12495	10	0	\N
358183	1874	28330000	25188	12495	0	0	\N
358184	1874	28332000	25188	12495	1	0	\N
358185	1874	28334000	25188	12495	2	0	\N
358186	949	508024693710000	25188	12495	3	0	\N
358187	1874	28337000	25188	12495	4	0	\N
358188	1874	28340000	25188	12495	5	0	\N
358189	1874	28343000	25188	12495	6	0	\N
358190	1874	28344000	25188	12495	7	0	\N
358191	1678	26640840137000	25189	12496	0	0	\N
358192	1874	28346000	25189	12496	1	0	\N
358193	1874	28347000	25189	12496	2	0	\N
358194	1189	614247191500000	25189	12496	3	0	\N
358195	1069	910373894650000	25189	12496	4	0	\N
358196	1874	28350000	25189	12496	5	0	\N
358203	1678	26640840138000	25191	12497	0	0	\N
358204	1315	1711655347751650	25191	12497	2	0	\N
358205	1874	28353000	25191	12497	3	0	\N
358206	1874	28355000	25191	12497	4	0	\N
358211	1678	26640840138000	25193	12497	0	0	\N
358212	1315	1711655347751650	25193	12497	2	0	\N
358213	1874	28353000	25193	12497	3	0	\N
358214	1874	28355000	25193	12497	4	0	\N
358215	2317	777595211465	25194	12498	0	0	\N
358216	1678	26640840139000	25194	12498	1	0	\N
358217	1874	28358000	25194	12498	2	0	\N
358218	1874	28360000	25194	12498	3	0	\N
358091	1874	28300000	25174	12489	1	0	2
358092	1874	28302000	25174	12489	2	0	2
358093	1678	26640840129000	25175	12490	0	0	0
358094	1874	28305000	25175	12490	1	0	2
358095	1874	28307000	25175	12490	2	0	2
358097	1874	28310000	25176	12491	1	0	2
358098	1874	28311000	25176	12491	2	0	2
358099	1874	28313000	25176	12491	3	0	2
358100	1678	26640840131000	25177	12492	0	0	0
358101	1874	28315000	25177	12492	1	0	2
358103	1678	26640840132000	25178	12493	0	0	0
358104	1874	28320000	25178	12493	1	0	2
358105	1874	28323000	25178	12493	2	0	2
358106	1678	26640840133000	25179	12494	0	0	0
358108	1874	28328000	25179	12494	2	0	2
358150	1678	26640840134000	25185	12495	0	0	0
358151	1678	26640840135000	25185	12495	1	0	0
358152	1678	26640840136000	25185	12495	2	0	0
358153	1874	28330000	25185	12495	3	0	2
358155	1874	28334000	25185	12495	5	0	2
358156	949	508024693710000	25185	12495	6	0	0
358157	1874	28337000	25185	12495	7	0	2
358158	1874	28340000	25185	12495	8	0	2
358159	1874	28343000	25185	12495	9	0	2
358197	1678	26640840137000	25190	12496	0	0	0
358198	1874	28346000	25190	12496	1	0	2
358199	1874	28347000	25190	12496	2	0	2
358200	1189	614247191500000	25190	12496	3	0	0
358202	1874	28350000	25190	12496	5	0	2
358207	1678	26640840138000	25192	12497	0	0	0
358208	1315	1711655347751650	25192	12497	2	0	0
358209	1874	28353000	25192	12497	3	0	2
358210	1874	28355000	25192	12497	4	0	2
358220	1678	26640840139000	25195	12498	1	0	0
358221	1874	28358000	25195	12498	2	0	2
358222	1874	28360000	25195	12498	3	0	2
358223	1678	26640840140000	25196	12499	0	0	0
358224	1678	26640840141000	25196	12499	1	0	0
358234	1678	26640840142000	25198	12500	0	0	\N
358235	1874	28374000	25198	12500	1	0	\N
358236	1874	28376000	25198	12500	2	0	\N
358237	1678	26640840142000	25199	12500	0	0	\N
358238	1874	28374000	25199	12500	1	0	\N
358239	1874	28376000	25199	12500	2	0	\N
358240	2317	777595211465	25200	12455	0	0	\N
358241	1678	26640840091000	25200	12455	1	0	\N
358242	1678	26640840092000	25200	12455	2	0	\N
358243	1678	26640840093000	25200	12455	3	0	\N
358244	1678	26640840094000	25200	12455	4	0	\N
358245	1678	26640840095000	25200	12455	5	0	\N
358246	1678	26640840096000	25200	12455	6	0	\N
358247	1678	26640840097000	25200	12455	7	0	\N
358248	1678	26640840098000	25200	12455	8	0	\N
358249	1678	26640840099000	25200	12455	9	0	\N
358250	1678	26640840100000	25200	12455	10	0	\N
358251	1678	26640840101000	25200	12455	11	0	\N
358252	1678	26640840102000	25200	12455	12	0	\N
358253	1678	26640840103000	25200	12455	13	0	\N
358254	1678	26640840104000	25200	12455	14	0	\N
358255	1678	26640840105000	25200	12455	15	0	\N
358256	1678	26640840106000	25200	12455	16	0	\N
358257	1678	26640840107000	25200	12455	17	0	\N
358258	1678	26640840108000	25200	12455	18	0	\N
358259	1678	26640840109000	25200	12455	19	0	\N
358260	1678	26640840110000	25200	12455	20	0	\N
358261	1678	26640840111000	25200	12455	21	0	\N
358262	1678	26640840112000	25200	12455	22	0	\N
358263	1678	26640840113000	25200	12455	23	0	\N
358264	1678	26640840114000	25200	12455	24	0	\N
358265	1678	26640840115000	25200	12455	25	0	\N
358266	1678	26640840116000	25200	12455	26	0	\N
358267	1678	26640840117000	25200	12455	27	0	\N
358268	1678	26640840118000	25200	12455	28	0	\N
358269	1678	26640840119000	25200	12455	29	0	\N
358270	1678	26640840120000	25200	12455	30	0	\N
358271	1678	26640840121000	25200	12455	31	0	\N
358272	1678	26640840122000	25200	12455	32	0	\N
358273	1678	26640840123000	25200	12455	33	0	\N
358274	1678	26640840124000	25200	12455	34	0	\N
358275	1678	26640840125000	25200	12455	35	0	\N
358276	1678	26640840126000	25200	12455	36	0	\N
358277	1678	26640840127000	25200	12455	37	0	\N
358278	1678	26640840128000	25200	12455	38	0	\N
358279	1678	26640840129000	25200	12455	39	0	\N
358280	1678	26640840130000	25200	12455	40	0	\N
358281	1678	26640840131000	25200	12455	41	0	\N
358282	1678	26640840132000	25200	12455	42	0	\N
358283	1678	26640840133000	25200	12455	43	0	\N
358284	1678	26640840134000	25200	12455	44	0	\N
358285	1678	26640840135000	25200	12455	45	0	\N
358286	1678	26640840136000	25200	12455	46	0	\N
358287	1678	26640840137000	25200	12455	47	0	\N
358288	1678	26640840138000	25200	12455	48	0	\N
358289	1678	26640840139000	25200	12455	49	0	\N
358290	1678	26640840140000	25200	12455	50	0	\N
358291	1678	26640840141000	25200	12455	51	0	\N
358292	1678	26640840142000	25200	12455	52	0	\N
358293	1874	28098000	25200	12455	53	0	\N
358294	1874	28100000	25200	12455	54	0	\N
358295	1874	28102000	25200	12455	55	0	\N
358296	2320	0	25200	12455	56	0	\N
358297	2320	1000000000	25200	12455	57	0	\N
358298	2320	775743211465	25200	12455	58	0	\N
358299	1874	28104000	25200	12455	59	0	\N
358300	1874	28106000	25200	12455	60	0	\N
358301	1874	28108000	25200	12455	61	0	\N
358302	1874	28110000	25200	12455	62	0	\N
358303	1874	28112000	25200	12455	63	0	\N
358304	1874	28114000	25200	12455	64	0	\N
358305	1874	28116000	25200	12455	65	0	\N
358306	1874	28118000	25200	12455	66	0	\N
358307	1874	28120000	25200	12455	67	0	\N
358308	1874	28122000	25200	12455	68	0	\N
358309	1874	28124000	25200	12455	69	0	\N
358310	949	508024693710000	25200	12455	70	0	\N
358311	1874	28127000	25200	12455	71	0	\N
358312	1874	28130000	25200	12455	72	0	\N
358313	1874	28133000	25200	12455	73	0	\N
358314	1874	28136000	25200	12455	74	0	\N
358315	1189	614247191500000	25200	12455	75	0	\N
358316	1069	910373894650000	25200	12455	76	0	\N
358317	1315	1711655347751650	25200	12455	77	0	\N
358318	1874	28139000	25200	12455	78	0	\N
358319	1540	0	25200	12455	79	0	\N
358320	968	507359775000000	25200	12455	80	0	\N
358321	1874	28140000	25200	12455	81	0	\N
358322	1874	28141000	25200	12455	82	0	\N
358323	1874	28142000	25200	12455	83	0	\N
358324	1874	28143000	25200	12455	84	0	\N
358325	1874	28144000	25200	12455	85	0	\N
358326	1403	0	25200	12455	86	0	\N
358327	1874	28145000	25200	12455	87	0	\N
358328	1874	28146000	25200	12455	88	0	\N
358329	1874	28147000	25200	12455	89	0	\N
358330	1874	28148000	25200	12455	90	0	\N
358331	1874	28149000	25200	12455	91	0	\N
358332	1874	28150000	25200	12455	92	0	\N
358333	1874	28151000	25200	12455	93	0	\N
358334	1874	28152000	25200	12455	94	0	\N
358335	1874	28153000	25200	12455	95	0	\N
358336	1874	28154000	25200	12455	96	0	\N
358337	1874	28155000	25200	12455	97	0	\N
358338	1874	28157000	25200	12455	98	0	\N
358339	1874	28159000	25200	12455	99	0	\N
358340	1874	28161000	25200	12455	100	0	\N
358341	1874	28163000	25200	12455	101	0	\N
358342	1874	28165000	25200	12455	102	0	\N
358343	1874	28167000	25200	12455	103	0	\N
358344	1874	28169000	25200	12455	104	0	\N
358345	1874	28171000	25200	12455	105	0	\N
358346	1874	28173000	25200	12455	106	0	\N
358347	1874	28175000	25200	12455	107	0	\N
358348	1874	28177000	25200	12455	108	0	\N
358349	1874	28179000	25200	12455	109	0	\N
358350	1874	28181000	25200	12455	110	0	\N
358351	1874	28183000	25200	12455	111	0	\N
358352	1874	28185000	25200	12455	112	0	\N
358353	1874	28187000	25200	12455	113	0	\N
358354	1874	28189000	25200	12455	114	0	\N
358355	1874	28191000	25200	12455	115	0	\N
358356	1874	28193000	25200	12455	116	0	\N
358357	1874	28195000	25200	12455	117	0	\N
358358	1874	28197000	25200	12455	118	0	\N
358359	1874	28199000	25200	12455	119	0	\N
358360	1874	28201000	25200	12455	120	0	\N
358227	1874	28368000	25196	12499	4	0	2
358228	1874	28370000	25196	12499	5	0	2
358229	968	507359775000000	25196	12499	6	0	0
358230	1874	28371000	25196	12499	7	0	2
358231	1678	26640840142000	25197	12500	0	0	0
358233	1874	28376000	25197	12500	2	0	2
358361	1874	28203000	25200	12455	121	0	\N
358362	1874	28205000	25200	12455	122	0	\N
358363	1874	28207000	25200	12455	123	0	\N
358364	1874	28209000	25200	12455	124	0	\N
358365	1874	28211000	25200	12455	125	0	\N
358366	1678	26640840143000	25201	12501	0	0	\N
358367	1678	26640840144000	25201	12501	1	0	\N
358368	1874	28378000	25201	12501	2	0	\N
358369	1874	28379000	25201	12501	3	0	\N
358370	1874	28382000	25201	12501	4	0	\N
358371	1874	28384000	25201	12501	5	0	\N
358372	1874	28387000	25201	12501	6	0	\N
358373	1678	26640840143000	25202	12501	0	0	\N
358374	1678	26640840144000	25202	12501	1	0	\N
358375	1874	28378000	25202	12501	2	0	\N
358376	1874	28379000	25202	12501	3	0	\N
358377	1874	28382000	25202	12501	4	0	\N
358378	1874	28384000	25202	12501	5	0	\N
358379	1874	28387000	25202	12501	6	0	\N
358403	1678	26640840150000	25208	12505	0	0	\N
358404	1874	28415000	25208	12505	1	0	\N
358405	1874	28418000	25208	12505	2	0	\N
358406	1678	26640840150000	25209	12505	0	0	\N
358407	1874	28415000	25209	12505	1	0	\N
358408	1874	28418000	25209	12505	2	0	\N
358409	1678	26640840150000	25210	12505	0	0	\N
358410	1874	28415000	25210	12505	1	0	\N
358411	1874	28418000	25210	12505	2	0	\N
358415	1678	26640840150000	25212	12505	0	0	\N
358416	1874	28415000	25212	12505	1	0	\N
358417	1874	28418000	25212	12505	2	0	\N
358434	1678	26640840155000	25217	12510	0	0	\N
358435	1874	28442000	25217	12510	1	0	\N
358436	1874	28445000	25217	12510	2	0	\N
358437	1208	613443250000000	25217	12510	3	0	\N
358442	1678	26640840156000	25219	12511	0	0	\N
358443	1874	28447000	25219	12511	1	0	\N
358444	1874	28450000	25219	12511	2	0	\N
358448	1678	26640840157000	25221	12512	0	0	\N
358449	1874	28451000	25221	12512	1	0	\N
358450	1874	28453000	25221	12512	2	0	\N
358451	1874	28456000	25221	12512	3	0	\N
358456	1678	26640840158000	25223	12513	0	0	\N
358457	1874	28459000	25223	12513	1	0	\N
358458	1874	28461000	25223	12513	2	0	\N
358459	1678	26640840158000	25224	12513	0	0	\N
358460	1874	28459000	25224	12513	1	0	\N
358461	1874	28461000	25224	12513	2	0	\N
358463	1678	26640840159000	25226	12514	0	0	\N
358464	1874	28459000	25226	12514	1	0	\N
358465	1874	28461000	25226	12514	2	0	\N
358466	1874	28463000	25226	12514	3	0	\N
358467	1874	28466000	25226	12514	4	0	\N
358468	1678	26640840159000	25227	12514	0	0	\N
358469	1874	28459000	25227	12514	1	0	\N
358470	1874	28461000	25227	12514	2	0	\N
358471	1874	28463000	25227	12514	3	0	\N
358472	1874	28466000	25227	12514	4	0	\N
358473	1678	26640840159000	25228	12514	0	0	\N
358474	1874	28459000	25228	12514	1	0	\N
358475	1874	28461000	25228	12514	2	0	\N
358476	1874	28463000	25228	12514	3	0	\N
358477	1874	28466000	25228	12514	4	0	\N
358483	1678	26640840159000	25230	12514	0	0	\N
358484	1874	28459000	25230	12514	1	0	\N
358485	1874	28461000	25230	12514	2	0	\N
358486	1874	28464000	25230	12514	3	0	\N
358487	1678	26640840159000	25231	12514	0	0	\N
358488	1874	28463000	25231	12514	1	0	\N
358489	1874	28466000	25231	12514	2	0	\N
358382	1874	28378000	25203	12501	2	0	2
358383	1874	28379000	25203	12501	3	0	2
358384	1874	28382000	25203	12501	4	0	2
358385	1874	28384000	25203	12501	5	0	2
358386	1874	28387000	25203	12501	6	0	2
358388	1874	28389000	25204	12502	1	0	2
358389	1874	28392000	25204	12502	2	0	2
358390	1678	26640840146000	25206	12503	0	0	0
358391	1678	26640840147000	25206	12503	1	0	0
358392	1874	28395000	25206	12503	2	0	2
358394	1874	28399000	25206	12503	4	0	2
358395	1874	28401000	25206	12503	5	0	2
358396	1874	28403000	25206	12503	6	0	2
358397	1678	26640840148000	25207	12504	0	0	0
358399	1874	28405000	25207	12504	2	0	2
358400	1874	28408000	25207	12504	4	0	2
358401	1874	28411000	25207	12504	5	0	2
358402	1874	28413000	25207	12504	6	0	2
358412	1678	26640840150000	25211	12505	0	0	0
358414	1874	28418000	25211	12505	2	0	2
358418	1678	26640840151000	25213	12506	0	0	0
358419	1874	28419000	25213	12506	1	0	2
358420	1874	28422000	25213	12506	2	0	2
358421	1874	28424000	25213	12506	3	0	2
358423	1874	28426000	25214	12507	1	0	2
358424	1874	28429000	25214	12507	2	0	2
358425	1678	26640840153000	25215	12508	0	0	0
358426	1874	28432000	25215	12508	1	0	2
358428	1678	26640840154000	25216	12509	0	0	0
358429	1874	28437000	25216	12509	1	0	2
358430	1874	28438000	25216	12509	2	0	2
358431	1874	28440000	25216	12509	3	0	2
358432	1088	909182965000000	25216	12509	4	0	0
358438	1678	26640840155000	25218	12510	0	0	0
358439	1874	28442000	25218	12510	1	0	2
358440	1874	28445000	25218	12510	2	0	2
358441	1208	613443250000000	25218	12510	3	0	0
358445	1678	26640840156000	25220	12511	0	0	0
358447	1874	28450000	25220	12511	2	0	2
358452	1678	26640840157000	25222	12512	0	0	0
358453	1874	28451000	25222	12512	1	0	2
358454	1874	28453000	25222	12512	2	0	2
358462	1678	26640840158000	25225	12513	0	0	0
358478	1678	26640840159000	25229	12514	0	0	0
358479	1874	28459000	25229	12514	1	0	2
358480	1874	28461000	25229	12514	2	0	2
358481	1874	28463000	25229	12514	3	0	2
358490	1678	26640840160000	25232	12515	0	0	0
358491	1749	18468588529980	25232	12515	1	0	19
358492	1874	28469000	25232	12515	2	0	2
358493	1874	28471000	25232	12515	3	0	2
358494	961	507418275000000	25232	12515	4	0	0
358496	1874	28473000	25233	12516	1	0	2
358500	1678	26640840161000	25234	12516	0	0	\N
358501	1874	28473000	25234	12516	1	0	\N
358502	1874	28474000	25234	12516	2	0	\N
358503	1874	28477000	25234	12516	3	0	\N
358504	1201	613649750000000	25234	12516	4	0	\N
358505	1678	26640840161000	25235	12516	0	0	\N
358506	1874	28473000	25235	12516	1	0	\N
358507	1874	28474000	25235	12516	2	0	\N
358508	1874	28477000	25235	12516	3	0	\N
358509	1201	613649750000000	25235	12516	4	0	\N
358510	1678	26640840161000	25236	12516	0	0	\N
358511	1874	28473000	25236	12516	1	0	\N
358512	1874	28474000	25236	12516	2	0	\N
358513	1874	28477000	25236	12516	3	0	\N
358514	1201	613649750000000	25236	12516	4	0	\N
358515	1678	26640840162000	25239	12518	0	0	\N
358516	1678	26640840163000	25239	12518	1	0	\N
358517	1874	28479000	25239	12518	2	0	\N
358518	1874	28481000	25239	12518	3	0	\N
358519	1874	28484000	25239	12518	4	0	\N
358520	1874	28487000	25239	12518	5	0	\N
358521	1081	909489465000000	25239	12518	6	0	\N
358522	1327	1709992637751650	25239	12518	7	0	\N
358538	2317	777595211465	25243	12471	0	0	\N
358539	1678	26640840124000	25243	12471	1	0	\N
358540	1678	26640840125000	25243	12471	2	0	\N
358541	1678	26640840126000	25243	12471	3	0	\N
358542	1678	26640840127000	25243	12471	4	0	\N
358543	1678	26640840128000	25243	12471	5	0	\N
358544	1678	26640840129000	25243	12471	6	0	\N
358545	1678	26640840130000	25243	12471	7	0	\N
358546	1678	26640840131000	25243	12471	8	0	\N
358547	1678	26640840132000	25243	12471	9	0	\N
358548	1678	26640840133000	25243	12471	10	0	\N
358549	1678	26640840134000	25243	12471	11	0	\N
358550	1678	26640840135000	25243	12471	12	0	\N
358551	1678	26640840136000	25243	12471	13	0	\N
358552	1678	26640840137000	25243	12471	14	0	\N
358553	1678	26640840138000	25243	12471	15	0	\N
358554	1678	26640840139000	25243	12471	16	0	\N
358555	1678	26640840140000	25243	12471	17	0	\N
358556	1678	26640840141000	25243	12471	18	0	\N
358557	1678	26640840142000	25243	12471	19	0	\N
358558	1678	26640840143000	25243	12471	20	0	\N
358559	1678	26640840144000	25243	12471	21	0	\N
358560	1678	26640840145000	25243	12471	22	0	\N
358561	1678	26640840146000	25243	12471	23	0	\N
358562	1678	26640840147000	25243	12471	24	0	\N
358563	1678	26640840148000	25243	12471	25	0	\N
358564	1678	26640840149000	25243	12471	26	0	\N
358565	1678	26640840150000	25243	12471	27	0	\N
358566	1678	26640840151000	25243	12471	28	0	\N
358567	1678	26640840152000	25243	12471	29	0	\N
358568	1678	26640840153000	25243	12471	30	0	\N
358569	1678	26640840154000	25243	12471	31	0	\N
358570	1678	26640840155000	25243	12471	32	0	\N
358571	1678	26640840156000	25243	12471	33	0	\N
358572	1678	26640840157000	25243	12471	34	0	\N
358573	1678	26640840158000	25243	12471	35	0	\N
358574	1678	26640840159000	25243	12471	36	0	\N
358575	1678	26640840160000	25243	12471	37	0	\N
358576	1678	26640840161000	25243	12471	38	0	\N
358577	1678	26640840162000	25243	12471	39	0	\N
358578	1678	26640840163000	25243	12471	40	0	\N
358579	1678	26640840164000	25243	12471	41	0	\N
358580	1678	26640840165000	25243	12471	42	0	\N
358581	1678	26640840166000	25243	12471	43	0	\N
358582	1874	28278000	25243	12471	44	0	\N
358583	1749	18468588529980	25243	12471	45	0	\N
358584	1874	28279000	25243	12471	47	0	\N
358585	1874	28281000	25243	12471	48	0	\N
358586	1874	28283000	25243	12471	49	0	\N
358587	1874	28285000	25243	12471	50	0	\N
358588	1874	28287000	25243	12471	51	0	\N
358589	1874	28289000	25243	12471	52	0	\N
358590	1874	28290000	25243	12471	53	0	\N
358591	1874	28291000	25243	12471	54	0	\N
358592	949	508024693710000	25243	12471	55	0	\N
358593	1189	614247191500000	25243	12471	56	0	\N
358594	1069	910373894650000	25243	12471	57	0	\N
358595	1315	1711655347751650	25243	12471	58	0	\N
358596	968	507359775000000	25243	12471	59	0	\N
358597	1088	909182965000000	25243	12471	60	0	\N
358598	961	507418275000000	25243	12471	61	0	\N
358599	1874	28292000	25243	12471	62	0	\N
358600	1874	28293000	25243	12471	63	0	\N
358601	1874	28295000	25243	12471	64	0	\N
358602	1874	28297000	25243	12471	65	0	\N
358603	1874	28299000	25243	12471	66	0	\N
358604	1874	28301000	25243	12471	67	0	\N
358605	1874	28303000	25243	12471	68	0	\N
358606	1874	28305000	25243	12471	69	0	\N
358607	1874	28307000	25243	12471	70	0	\N
358608	1874	28309000	25243	12471	71	0	\N
358609	1874	28311000	25243	12471	72	0	\N
358610	1874	28313000	25243	12471	73	0	\N
358611	1874	28314000	25243	12471	74	0	\N
358612	1874	28315000	25243	12471	75	0	\N
358613	1874	28316000	25243	12471	76	0	\N
358614	1874	28317000	25243	12471	77	0	\N
358615	1874	28318000	25243	12471	78	0	\N
358616	1874	28319000	25243	12471	79	0	\N
358617	1874	28320000	25243	12471	80	0	\N
358618	1874	28321000	25243	12471	81	0	\N
358619	1334	1709415637751650	25243	12471	82	0	\N
358620	1208	613443250000000	25243	12471	83	0	\N
358621	1874	28324000	25243	12471	84	0	\N
358622	1874	28327000	25243	12471	85	0	\N
358623	1874	28330000	25243	12471	86	0	\N
358624	1874	28333000	25243	12471	87	0	\N
358625	1874	28336000	25243	12471	88	0	\N
358626	1874	28339000	25243	12471	89	0	\N
358627	1874	28342000	25243	12471	90	0	\N
358628	1874	28345000	25243	12471	91	0	\N
358629	1874	28348000	25243	12471	92	0	\N
358630	1874	28351000	25243	12471	93	0	\N
358631	1874	28354000	25243	12471	94	0	\N
358632	1874	28357000	25243	12471	95	0	\N
358499	1201	613649750000000	25233	12516	4	0	0
358523	1678	26640840162000	25240	12518	0	0	0
358524	1678	26640840163000	25240	12518	1	0	0
358525	1874	28479000	25240	12518	2	0	2
358526	1874	28481000	25240	12518	3	0	2
358528	1874	28487000	25240	12518	5	0	2
358529	1081	909489465000000	25240	12518	6	0	0
358530	1327	1709992637751650	25240	12518	7	0	0
358531	1678	26640840164000	25241	12519	0	0	0
358532	1874	28490000	25241	12519	1	0	2
358534	1874	28493000	25241	12519	3	0	2
358535	1678	26640840165000	25242	12520	0	0	0
358536	1874	28496000	25242	12520	1	0	2
358537	1874	28498000	25242	12520	2	0	2
358633	1201	613649750000000	25243	12471	96	0	\N
358634	1081	909489465000000	25243	12471	97	0	\N
358635	1874	28360000	25243	12471	98	0	\N
358636	1874	28363000	25243	12471	99	0	\N
358637	1874	28366000	25243	12471	100	0	\N
358638	1874	28369000	25243	12471	101	0	\N
358639	1874	28372000	25243	12471	102	0	\N
358640	1874	28375000	25243	12471	103	0	\N
358641	1874	28378000	25243	12471	104	0	\N
358642	1874	28381000	25243	12471	106	0	\N
358643	1874	28384000	25243	12471	107	0	\N
358644	1874	28387000	25243	12471	108	0	\N
358645	1874	28390000	25243	12471	109	0	\N
358646	1874	28393000	25243	12471	110	0	\N
358647	1874	28396000	25243	12471	111	0	\N
358648	1874	28399000	25243	12471	112	0	\N
358649	1874	28402000	25243	12471	113	0	\N
358650	1874	28405000	25243	12471	114	0	\N
358651	1874	28408000	25243	12471	115	0	\N
358652	1874	28411000	25243	12471	116	0	\N
358653	1874	28414000	25243	12471	117	0	\N
358654	1874	28417000	25243	12471	118	0	\N
358655	1874	28420000	25243	12471	119	0	\N
358656	1874	28423000	25243	12471	120	0	\N
358657	1874	28426000	25243	12471	121	0	\N
358658	1874	28429000	25243	12471	122	0	\N
358659	1874	28432000	25243	12471	123	0	\N
358660	1874	28435000	25243	12471	124	0	\N
358661	1874	28438000	25243	12471	125	0	\N
358669	1678	26640840166000	25245	12521	0	0	\N
358670	1678	26640840167000	25245	12521	1	0	\N
358671	1874	28499000	25245	12521	2	0	\N
358672	1874	28502000	25245	12521	3	0	\N
358673	1874	28505000	25245	12521	4	0	\N
358674	1874	28507000	25245	12521	5	0	\N
358675	1874	28509000	25245	12521	6	0	\N
358676	1678	26640840166000	25246	12521	0	0	\N
358677	1678	26640840167000	25246	12521	1	0	\N
358678	1874	28499000	25246	12521	2	0	\N
358679	1874	28502000	25246	12521	3	0	\N
358680	1874	28505000	25246	12521	4	0	\N
358681	1874	28507000	25246	12521	5	0	\N
358682	1874	28509000	25246	12521	6	0	\N
358683	1678	26640840166000	25247	12521	0	0	\N
358684	1678	26640840167000	25247	12521	1	0	\N
358685	1874	28499000	25247	12521	2	0	\N
358686	1874	28502000	25247	12521	3	0	\N
358687	1874	28505000	25247	12521	4	0	\N
358688	1874	28507000	25247	12521	5	0	\N
358689	1874	28509000	25247	12521	6	0	\N
358709	1678	26640840174000	25252	12526	0	0	\N
358710	1678	26640840175000	25252	12526	1	0	\N
358711	1678	26640840176000	25252	12526	2	0	\N
358712	1874	28541000	25252	12526	3	0	\N
358713	1874	28544000	25252	12526	4	0	\N
358714	1874	28547000	25252	12526	5	0	\N
358715	1874	28550000	25252	12526	6	0	\N
358716	1874	28552000	25252	12526	7	0	\N
358717	1874	28554000	25252	12526	8	0	\N
358718	1874	28556000	25252	12526	9	0	\N
358733	1678	26640840177000	25255	12527	0	0	\N
358734	1874	28557000	25255	12527	1	0	\N
358735	1874	28559000	25255	12527	2	0	\N
358736	1874	28562000	25255	12527	3	0	\N
358746	1678	26640840181000	25259	12531	0	0	\N
358747	1874	28579000	25259	12531	1	0	\N
358748	1874	28582000	25259	12531	2	0	\N
358749	1874	28583000	25259	12531	3	0	\N
358750	1678	26640840181000	25260	12531	0	0	\N
358751	1874	28579000	25260	12531	1	0	\N
358752	1874	28582000	25260	12531	2	0	\N
358753	1874	28583000	25260	12531	3	0	\N
358754	1678	26640840181000	25261	12531	0	0	\N
358755	1874	28579000	25261	12531	1	0	\N
358756	1874	28582000	25261	12531	2	0	\N
358757	1874	28583000	25261	12531	3	0	\N
358758	1678	26640840181000	25262	12531	0	0	\N
358759	1874	28579000	25262	12531	1	0	\N
358760	1874	28582000	25262	12531	2	0	\N
358761	1874	28583000	25262	12531	3	0	\N
358768	1678	26640840183000	25265	12533	0	0	\N
358664	1874	28499000	25244	12521	2	0	2
358665	1874	28502000	25244	12521	3	0	2
358666	1874	28505000	25244	12521	4	0	2
358667	1874	28507000	25244	12521	5	0	2
358668	1874	28509000	25244	12521	6	0	2
358691	1874	28511000	25248	12522	1	0	2
358692	1874	28514000	25248	12522	2	0	2
358693	1678	26640840169000	25249	12523	0	0	0
358694	1678	26640840170000	25249	12523	1	0	0
358695	1874	28517000	25249	12523	2	0	2
358697	1874	28521000	25249	12523	4	0	2
358698	1874	28524000	25249	12523	5	0	2
358699	1678	26640840171000	25250	12524	0	0	0
358700	1678	26640840172000	25250	12524	1	0	0
358702	1874	28530000	25250	12524	3	0	2
358703	1874	28531000	25250	12524	4	0	2
358704	1874	28533000	25250	12524	5	0	2
358705	1874	28535000	25250	12524	6	0	2
358706	1678	26640840173000	25251	12525	0	0	0
358708	1874	28540000	25251	12525	2	0	2
358719	1678	26640840174000	25253	12526	0	0	0
358720	1678	26640840175000	25253	12526	1	0	0
358721	1678	26640840176000	25253	12526	2	0	0
358722	1874	28541000	25253	12526	3	0	2
358724	1874	28547000	25253	12526	5	0	2
358725	1874	28550000	25253	12526	6	0	2
358726	1874	28552000	25253	12526	7	0	2
358727	1874	28554000	25253	12526	8	0	2
358729	1678	26640840177000	25254	12527	0	0	0
358730	1874	28557000	25254	12527	1	0	2
358731	1874	28559000	25254	12527	2	0	2
358732	1874	28562000	25254	12527	3	0	2
358737	1678	26640840178000	25256	12528	0	0	0
358739	1874	28567000	25256	12528	2	0	2
358740	1678	26640840179000	25257	12529	0	0	0
358741	1874	28569000	25257	12529	1	0	2
358742	1874	28572000	25257	12529	2	0	2
358743	1678	26640840180000	25258	12530	0	0	0
358745	1874	28577000	25258	12530	2	0	2
358762	1678	26640840181000	25263	12531	0	0	0
358763	1874	28579000	25263	12531	1	0	2
358764	1874	28582000	25263	12531	2	0	2
358766	1678	26640840182000	25264	12532	0	0	0
358767	1874	28586000	25264	12532	1	0	2
358769	1678	26640840184000	25265	12533	1	0	\N
358770	1678	26640840185000	25265	12533	2	0	\N
358771	1678	26640840186000	25265	12533	3	0	\N
358772	1678	26640840187000	25265	12533	4	0	\N
358773	1874	28587000	25265	12533	5	0	\N
358774	1874	28589000	25265	12533	6	0	\N
358775	1874	28590000	25265	12533	7	0	\N
358776	1874	28592000	25265	12533	8	0	\N
358777	1874	28594000	25265	12533	9	0	\N
358778	1874	28596000	25265	12533	10	0	\N
358779	1874	28599000	25265	12533	11	0	\N
358780	1874	28602000	25265	12533	12	0	\N
358781	1874	28605000	25265	12533	13	0	\N
358782	1874	28608000	25265	12533	14	0	\N
358783	1874	28611000	25265	12533	15	0	\N
358784	1874	28613000	25265	12533	16	0	\N
358808	1678	26640840190000	25268	12535	0	0	\N
358809	1678	26640840191000	25268	12535	1	0	\N
358810	1874	28624000	25268	12535	2	0	\N
358811	1874	28627000	25268	12535	3	0	\N
358812	1874	28629000	25268	12535	4	0	\N
358813	1874	28632000	25268	12535	5	0	\N
358814	1874	28634000	25268	12535	6	0	\N
358822	1678	26640840190000	25270	12535	0	0	\N
358823	1678	26640840191000	25270	12535	1	0	\N
358824	1874	28624000	25270	12535	2	0	\N
358825	1874	28627000	25270	12535	3	0	\N
358826	1874	28629000	25270	12535	4	0	\N
358827	1874	28632000	25270	12535	5	0	\N
358828	1874	28634000	25270	12535	6	0	\N
358829	1678	26640840160000	25271	12515	0	0	\N
358830	1678	26640840161000	25271	12515	1	0	\N
358831	1678	26640840162000	25271	12515	2	0	\N
358832	1678	26640840163000	25271	12515	3	0	\N
358833	1678	26640840164000	25271	12515	4	0	\N
358834	1678	26640840165000	25271	12515	5	0	\N
358835	1678	26640840166000	25271	12515	6	0	\N
358836	1678	26640840167000	25271	12515	7	0	\N
358837	1678	26640840168000	25271	12515	8	0	\N
358838	1678	26640840169000	25271	12515	9	0	\N
358839	1678	26640840170000	25271	12515	10	0	\N
358840	1678	26640840171000	25271	12515	11	0	\N
358841	1678	26640840172000	25271	12515	12	0	\N
358842	1678	26640840173000	25271	12515	14	0	\N
358843	1678	26640840174000	25271	12515	15	0	\N
358844	1678	26640840175000	25271	12515	16	0	\N
358845	1678	26640840176000	25271	12515	17	0	\N
358846	1678	26640840177000	25271	12515	18	0	\N
358847	1678	26640840178000	25271	12515	19	0	\N
358848	1678	26640840179000	25271	12515	20	0	\N
358849	1678	26640840180000	25271	12515	21	0	\N
358850	1678	26640840181000	25271	12515	22	0	\N
358851	1678	26640840182000	25271	12515	23	0	\N
358852	1678	26640840183000	25271	12515	24	0	\N
358853	1678	26640840184000	25271	12515	25	0	\N
358854	1678	26640840185000	25271	12515	26	0	\N
358855	1678	26640840186000	25271	12515	27	0	\N
358856	1678	26640840187000	25271	12515	28	0	\N
358857	1678	26640840188000	25271	12515	29	0	\N
358858	1678	26640840189000	25271	12515	30	0	\N
358859	1678	26640840190000	25271	12515	31	0	\N
358860	1678	26640840191000	25271	12515	32	0	\N
358861	1749	18468588529980	25271	12515	33	0	\N
358862	1874	28469000	25271	12515	34	0	\N
358863	1874	28470000	25271	12515	35	0	\N
358864	1874	28471000	25271	12515	36	0	\N
358865	1874	28473000	25271	12515	37	0	\N
358866	1874	28475000	25271	12515	38	0	\N
358867	1874	28477000	25271	12515	39	0	\N
358868	1874	28479000	25271	12515	40	0	\N
358869	1874	28481000	25271	12515	41	0	\N
358870	1874	28483000	25271	12515	42	0	\N
358871	1874	28486000	25271	12515	43	0	\N
358872	1874	28489000	25271	12515	44	0	\N
358873	1874	28492000	25271	12515	45	0	\N
358874	1874	28495000	25271	12515	46	0	\N
358875	1874	28498000	25271	12515	47	0	\N
358876	1874	28499000	25271	12515	48	0	\N
358877	1874	28500000	25271	12515	49	0	\N
358878	1874	28501000	25271	12515	50	0	\N
358879	1874	28502000	25271	12515	51	0	\N
358880	1874	28503000	25271	12515	52	0	\N
358881	1874	28504000	25271	12515	53	0	\N
358882	1874	28505000	25271	12515	54	0	\N
358883	1874	28506000	25271	12515	55	0	\N
358884	1874	28509000	25271	12515	56	0	\N
358885	1874	28512000	25271	12515	57	0	\N
358886	1874	28515000	25271	12515	58	0	\N
358887	1874	28518000	25271	12515	59	0	\N
358888	1874	28521000	25271	12515	60	0	\N
358889	1874	28524000	25271	12515	61	0	\N
358890	1874	28527000	25271	12515	62	0	\N
358891	961	507418275000000	25271	12515	63	0	\N
358892	1874	28530000	25271	12515	64	0	\N
358893	1874	28533000	25271	12515	65	0	\N
358894	1874	28536000	25271	12515	66	0	\N
358895	1874	28539000	25271	12515	67	0	\N
358896	1201	613649750000000	25271	12515	68	0	\N
358897	1081	909489465000000	25271	12515	69	0	\N
358898	1874	28542000	25271	12515	70	0	\N
358899	1874	28545000	25271	12515	71	0	\N
358900	1874	28548000	25271	12515	72	0	\N
358901	1874	28551000	25271	12515	73	0	\N
358902	1874	28554000	25271	12515	74	0	\N
358903	1874	28557000	25271	12515	75	0	\N
358904	1874	28560000	25271	12515	76	0	\N
358787	1678	26640840185000	25266	12533	2	0	0
358788	1678	26640840186000	25266	12533	3	0	0
358789	1678	26640840187000	25266	12533	4	0	0
358790	1874	28587000	25266	12533	5	0	2
358791	1874	28589000	25266	12533	6	0	2
358793	1874	28592000	25266	12533	8	0	2
358794	1874	28594000	25266	12533	9	0	2
358795	1874	28596000	25266	12533	10	0	2
358796	1874	28599000	25266	12533	11	0	2
358797	1874	28602000	25266	12533	12	0	2
358799	1874	28608000	25266	12533	14	0	2
358800	1874	28611000	25266	12533	15	0	2
358801	1874	28613000	25266	12533	16	0	2
358802	1678	26640840188000	25267	12534	0	0	0
358804	1874	28616000	25267	12534	2	0	2
358805	1874	28618000	25267	12534	3	0	2
358806	1874	28621000	25267	12534	4	0	2
358807	1874	28623000	25267	12534	5	0	2
358815	1678	26640840190000	25269	12535	0	0	0
358817	1874	28624000	25269	12535	2	0	2
358818	1874	28627000	25269	12535	3	0	2
358819	1874	28629000	25269	12535	4	0	2
358820	1874	28632000	25269	12535	5	0	2
358821	1874	28634000	25269	12535	6	0	2
358905	1874	28563000	25271	12515	77	0	\N
358906	1874	28566000	25271	12515	78	0	\N
358907	1874	28569000	25271	12515	79	0	\N
358908	1874	28572000	25271	12515	80	0	\N
358909	1874	28575000	25271	12515	81	0	\N
358910	1874	28578000	25271	12515	82	0	\N
358911	1874	28581000	25271	12515	83	0	\N
358912	1874	28584000	25271	12515	84	0	\N
358913	1874	28586000	25271	12515	85	0	\N
358914	1874	28588000	25271	12515	86	0	\N
358915	1874	28590000	25271	12515	87	0	\N
358916	1874	28592000	25271	12515	88	0	\N
358917	1874	28594000	25271	12515	89	0	\N
358918	1874	28596000	25271	12515	90	0	\N
358919	1874	28598000	25271	12515	91	0	\N
358920	1874	28600000	25271	12515	92	0	\N
358921	1874	28602000	25271	12515	93	0	\N
358922	1874	28604000	25271	12515	94	0	\N
358923	1874	28606000	25271	12515	95	0	\N
358924	1874	28608000	25271	12515	96	0	\N
358925	1874	28610000	25271	12515	97	0	\N
358926	1874	28612000	25271	12515	98	0	\N
358927	1874	28614000	25271	12515	99	0	\N
358928	1874	28616000	25271	12515	100	0	\N
358929	1874	28618000	25271	12515	101	0	\N
358930	1874	28620000	25271	12515	102	0	\N
358931	1874	28622000	25271	12515	103	0	\N
358932	1874	28624000	25271	12515	104	0	\N
358933	1874	28626000	25271	12515	105	0	\N
358934	1874	28628000	25271	12515	106	0	\N
358935	1874	28630000	25271	12515	107	0	\N
358936	1874	28632000	25271	12515	108	0	\N
358937	1874	28634000	25271	12515	109	0	\N
358948	1678	26640840195000	25275	12539	0	0	\N
358949	1678	26640840196000	25275	12539	1	0	\N
358950	1874	28653000	25275	12539	2	0	\N
358951	1874	28656000	25275	12539	3	0	\N
358952	1678	26640840195000	25276	12539	0	0	\N
358953	1678	26640840196000	25276	12539	1	0	\N
358954	1874	28653000	25276	12539	2	0	\N
358955	1874	28656000	25276	12539	3	0	\N
358956	1874	28658000	25276	12539	4	0	\N
358957	1874	28660000	25276	12539	5	0	\N
358958	1678	26640840195000	25277	12539	0	0	\N
358959	1678	26640840196000	25277	12539	1	0	\N
358960	1874	28653000	25277	12539	2	0	\N
358961	1874	28656000	25277	12539	3	0	\N
358962	1874	28658000	25277	12539	4	0	\N
358963	1874	28660000	25277	12539	5	0	\N
358970	1678	26640840195000	25279	12539	0	0	\N
358971	1678	26640840196000	25279	12539	1	0	\N
358972	1874	28653000	25279	12539	2	0	\N
358973	1874	28656000	25279	12539	3	0	\N
358974	1874	28658000	25279	12539	4	0	\N
358975	1874	28660000	25279	12539	5	0	\N
358980	1678	26640840197000	25281	12540	0	0	\N
358981	1874	28662000	25281	12540	1	0	\N
358982	1874	28665000	25281	12540	2	0	\N
358983	1874	28666000	25281	12540	3	0	\N
358987	1678	26640840199000	25283	12542	0	0	\N
358988	1678	26640840200000	25283	12542	1	0	\N
358989	1874	28674000	25283	12542	2	0	\N
358990	1874	28676000	25283	12542	3	0	\N
358991	1874	28678000	25283	12542	4	0	\N
358992	1874	28681000	25283	12542	5	0	\N
358993	1678	26640840199000	25284	12542	0	0	\N
358994	1678	26640840200000	25284	12542	1	0	\N
358995	1874	28674000	25284	12542	2	0	\N
358996	1874	28676000	25284	12542	3	0	\N
358997	1874	28678000	25284	12542	4	0	\N
358998	1874	28681000	25284	12542	5	0	\N
359012	1678	26640840202000	25288	12544	0	0	\N
359013	1874	28689000	25288	12544	1	0	\N
359014	1874	28692000	25288	12544	2	0	\N
359017	1874	28694000	25290	12545	0	0	\N
359018	1874	28697000	25290	12545	1	0	\N
359019	1678	26640840167000	25291	12472	0	0	\N
359020	1678	26640840168000	25291	12472	1	0	\N
359021	1678	26640840169000	25291	12472	2	0	\N
359022	1678	26640840170000	25291	12472	3	0	\N
359023	1678	26640840171000	25291	12472	4	0	\N
359024	1678	26640840172000	25291	12472	5	0	\N
359025	1678	26640840173000	25291	12472	6	0	\N
359026	1678	26640840174000	25291	12472	7	0	\N
359027	1678	26640840175000	25291	12472	8	0	\N
359028	1678	26640840176000	25291	12472	9	0	\N
359029	1678	26640840177000	25291	12472	10	0	\N
359030	1678	26640840178000	25291	12472	11	0	\N
359031	1678	26640840179000	25291	12472	12	0	\N
359032	1678	26640840180000	25291	12472	13	0	\N
359033	1678	26640840181000	25291	12472	14	0	\N
359034	1678	26640840182000	25291	12472	15	0	\N
359035	1678	26640840183000	25291	12472	16	0	\N
359036	1678	26640840184000	25291	12472	17	0	\N
359037	1678	26640840185000	25291	12472	18	0	\N
359038	1678	26640840186000	25291	12472	19	0	\N
359039	1678	26640840187000	25291	12472	20	0	\N
359040	1678	26640840188000	25291	12472	21	0	\N
358940	1874	28639000	25272	12536	2	0	2
358941	1678	26640840193000	25273	12537	0	0	0
358942	1874	28642000	25273	12537	1	0	2
358943	1874	28644000	25273	12537	2	0	2
358944	1678	26640840194000	25274	12538	0	0	0
358946	1874	28649000	25274	12538	2	0	2
358947	1874	28650000	25274	12538	3	0	2
358964	1678	26640840195000	25278	12539	0	0	0
358965	1678	26640840196000	25278	12539	1	0	0
358966	1874	28653000	25278	12539	2	0	2
358968	1874	28658000	25278	12539	4	0	2
358969	1874	28660000	25278	12539	5	0	2
358976	1678	26640840197000	25280	12540	0	0	0
358977	1874	28662000	25280	12540	1	0	2
358979	1874	28666000	25280	12540	3	0	2
358984	1678	26640840198000	25282	12541	0	0	0
358985	1874	28668000	25282	12541	1	0	2
358986	1874	28671000	25282	12541	2	0	2
358999	1678	26640840199000	25285	12542	0	0	0
359001	1874	28674000	25285	12542	2	0	2
359002	1874	28676000	25285	12542	3	0	2
359003	1874	28678000	25285	12542	4	0	2
359004	1874	28681000	25285	12542	5	0	2
359005	1678	26640840201000	25286	12543	0	0	0
359007	1874	28684000	25286	12543	2	0	2
359008	1874	28687000	25286	12543	3	0	2
359009	1678	26640840202000	25287	12544	0	0	0
359010	1874	28689000	25287	12544	1	0	2
359015	1874	28694000	25289	12545	0	0	2
359016	1874	28697000	25289	12545	1	0	2
359041	1678	26640840189000	25291	12472	22	0	\N
359042	1678	26640840190000	25291	12472	23	0	\N
359043	1678	26640840191000	25291	12472	24	0	\N
359044	1678	26640840192000	25291	12472	25	0	\N
359045	1678	26640840193000	25291	12472	26	0	\N
359046	1678	26640840194000	25291	12472	27	0	\N
359047	1678	26640840195000	25291	12472	28	0	\N
359048	1678	26640840196000	25291	12472	29	0	\N
359049	1678	26640840197000	25291	12472	30	0	\N
359050	1678	26640840198000	25291	12472	31	0	\N
359051	1678	26640840199000	25291	12472	32	0	\N
359052	1678	26640840200000	25291	12472	33	0	\N
359053	1678	26640840201000	25291	12472	34	0	\N
359054	1678	26640840202000	25291	12472	35	0	\N
359055	1874	28441000	25291	12472	36	0	\N
359056	1874	28444000	25291	12472	37	0	\N
359057	1874	28445000	25291	12472	38	0	\N
359058	1874	28446000	25291	12472	39	0	\N
359059	1874	28447000	25291	12472	40	0	\N
359060	1874	28448000	25291	12472	41	0	\N
359061	1874	28449000	25291	12472	42	0	\N
359062	1874	28450000	25291	12472	43	0	\N
359063	1874	28451000	25291	12472	44	0	\N
359064	1874	28452000	25291	12472	45	0	\N
359065	1874	28453000	25291	12472	46	0	\N
359066	1874	28456000	25291	12472	47	0	\N
359067	1874	28459000	25291	12472	48	0	\N
359068	1874	28460000	25291	12472	49	0	\N
359069	1874	28461000	25291	12472	50	0	\N
359070	1874	28464000	25291	12472	51	0	\N
359071	1874	28467000	25291	12472	52	0	\N
359072	1874	28470000	25291	12472	53	0	\N
359073	1874	28473000	25291	12472	54	0	\N
359074	1874	28476000	25291	12472	55	0	\N
359075	1874	28479000	25291	12472	56	0	\N
359076	1874	28482000	25291	12472	57	0	\N
359077	1874	28485000	25291	12472	58	0	\N
359078	1874	28488000	25291	12472	59	0	\N
359079	1874	28491000	25291	12472	60	0	\N
359080	1874	28494000	25291	12472	61	0	\N
359081	1874	28497000	25291	12472	62	0	\N
359082	1874	28500000	25291	12472	63	0	\N
359083	1874	28503000	25291	12472	64	0	\N
359084	1874	28506000	25291	12472	65	0	\N
359085	1874	28509000	25291	12472	66	0	\N
359086	1874	28512000	25291	12472	67	0	\N
359087	1874	28515000	25291	12472	68	0	\N
359088	1874	28518000	25291	12472	69	0	\N
359089	1874	28521000	25291	12472	70	0	\N
359090	1874	28524000	25291	12472	71	0	\N
359091	1874	28527000	25291	12472	72	0	\N
359092	1874	28530000	25291	12472	73	0	\N
359093	1874	28533000	25291	12472	74	0	\N
359094	1874	28536000	25291	12472	75	0	\N
359095	1874	28539000	25291	12472	76	0	\N
359096	1874	28542000	25291	12472	77	0	\N
359097	1874	28545000	25291	12472	78	0	\N
359098	1874	28548000	25291	12472	79	0	\N
359099	1874	28551000	25291	12472	80	0	\N
359100	1874	28554000	25291	12472	81	0	\N
359101	1874	28557000	25291	12472	82	0	\N
359102	1874	28560000	25291	12472	83	0	\N
359103	1874	28563000	25291	12472	84	0	\N
359104	1874	28566000	25291	12472	85	0	\N
359105	1874	28569000	25291	12472	86	0	\N
359106	1874	28571000	25291	12472	87	0	\N
359107	1874	28573000	25291	12472	88	0	\N
359108	1874	28575000	25291	12472	89	0	\N
359109	1874	28577000	25291	12472	90	0	\N
359110	1874	28579000	25291	12472	91	0	\N
359111	1874	28581000	25291	12472	92	0	\N
359112	1874	28583000	25291	12472	93	0	\N
359113	1874	28585000	25291	12472	94	0	\N
359114	1874	28587000	25291	12472	95	0	\N
359115	1874	28589000	25291	12472	96	0	\N
359116	1874	28591000	25291	12472	97	0	\N
359117	1874	28593000	25291	12472	98	0	\N
359118	1874	28595000	25291	12472	99	0	\N
359119	1874	28597000	25291	12472	100	0	\N
359120	1874	28599000	25291	12472	101	0	\N
359121	1874	28601000	25291	12472	102	0	\N
359122	1874	28603000	25291	12472	103	0	\N
359123	1874	28605000	25291	12472	104	0	\N
359124	1874	28607000	25291	12472	106	0	\N
359125	1874	28609000	25291	12472	107	0	\N
359126	1874	28611000	25291	12472	108	0	\N
359127	1874	28613000	25291	12472	109	0	\N
359128	1874	28615000	25291	12472	110	0	\N
359129	1874	28617000	25291	12472	111	0	\N
359130	1874	28619000	25291	12472	112	0	\N
359131	1874	28621000	25291	12472	113	0	\N
359132	1874	28623000	25291	12472	114	0	\N
359133	1874	28625000	25291	12472	115	0	\N
359134	1874	28627000	25291	12472	116	0	\N
359135	1874	28629000	25291	12472	117	0	\N
359136	1874	28631000	25291	12472	118	0	\N
359137	1874	28633000	25291	12472	119	0	\N
359138	1874	28635000	25291	12472	120	0	\N
359139	1874	28637000	25291	12472	121	0	\N
359140	1874	28639000	25291	12472	122	0	\N
359141	1874	28641000	25291	12472	123	0	\N
359142	1874	28643000	25291	12472	124	0	\N
359143	1874	28645000	25291	12472	125	0	\N
359158	2317	777595211465	25296	12473	0	0	\N
359159	1749	18468588529980	25296	12473	1	0	\N
359160	2320	0	25296	12473	2	0	\N
359161	2320	1000000000	25296	12473	3	0	\N
359162	2320	775743211465	25296	12473	4	0	\N
359163	949	508024693710000	25296	12473	6	0	\N
359164	1189	614247191500000	25296	12473	7	0	\N
359165	1069	910373894650000	25296	12473	8	0	\N
359166	1315	1711655347751650	25296	12473	9	0	\N
359167	1540	0	25296	12473	10	0	\N
359168	968	507359775000000	25296	12473	11	0	\N
359169	1088	909182965000000	25296	12473	12	0	\N
359170	961	507418275000000	25296	12473	13	0	\N
359171	1334	1709415637751650	25296	12473	14	0	\N
359172	1208	613443250000000	25296	12473	15	0	\N
359173	1403	0	25296	12473	16	0	\N
359174	1201	613649750000000	25296	12473	17	0	\N
359175	1678	26640840207000	25297	12550	0	0	\N
359176	1874	28722000	25297	12550	1	0	\N
359146	1874	28702000	25292	12546	2	0	2
359147	1874	28703000	25292	12546	3	0	2
359148	1678	26640840204000	25293	12547	0	0	0
359149	1874	28706000	25293	12547	1	0	2
359150	1874	28708000	25293	12547	2	0	2
359152	1874	28710000	25294	12548	1	0	2
359153	1874	28713000	25294	12548	2	0	2
359154	1678	26640840206000	25295	12549	0	0	0
359155	1874	28715000	25295	12549	1	0	2
359156	1874	28716000	25295	12549	2	0	2
359180	1678	26640840207000	25299	12550	0	0	\N
359181	1874	28722000	25299	12550	1	0	\N
359182	1874	28724000	25299	12550	2	0	\N
359186	1678	26640840209000	25301	12552	0	0	\N
359187	1874	28732000	25301	12552	1	0	\N
359188	1874	28734000	25301	12552	2	0	\N
359207	1678	26640840213000	25310	12557	0	0	\N
359208	1678	26640840214000	25310	12557	1	0	\N
359209	1874	28757000	25310	12557	2	0	\N
359210	1874	28759000	25310	12557	4	0	\N
359211	1874	28761000	25310	12557	5	0	\N
359212	1678	26640840215000	25313	12558	0	0	\N
359213	1874	28760000	25313	12558	1	0	\N
359214	1874	28762000	25313	12558	2	0	\N
359215	1874	28764000	25313	12558	3	0	\N
359216	1874	28766000	25313	12558	4	0	\N
359217	1678	26640840215000	25314	12558	0	0	\N
359218	1874	28760000	25314	12558	1	0	\N
359219	1874	28762000	25314	12558	2	0	\N
359220	1874	28764000	25314	12558	3	0	\N
359221	1874	28766000	25314	12558	4	0	\N
359227	1678	26640840215000	25316	12558	0	0	\N
359228	1874	28760000	25316	12558	1	0	\N
359229	1874	28762000	25316	12558	2	0	\N
359230	1874	28764000	25316	12558	3	0	\N
359231	1874	28766000	25316	12558	4	0	\N
359232	1678	26640840215000	25317	12558	0	0	\N
359233	1874	28760000	25317	12558	1	0	\N
359234	1874	28762000	25317	12558	2	0	\N
359235	1874	28764000	25317	12558	3	0	\N
359236	1874	28766000	25317	12558	4	0	\N
359237	1678	26640840215000	25318	12558	0	0	\N
359238	1874	28760000	25318	12558	1	0	\N
359239	1874	28762000	25318	12558	2	0	\N
359240	1874	28764000	25318	12558	3	0	\N
359241	1874	28766000	25318	12558	4	0	\N
359246	1678	26640840216000	25320	12559	0	0	\N
359247	1874	28769000	25320	12559	1	0	\N
359248	1874	28771000	25320	12559	2	0	\N
359249	1874	28772000	25320	12559	3	0	\N
359250	1678	26640840216000	25321	12559	0	0	\N
359251	1874	28768000	25321	12559	1	0	\N
359252	1678	26640840216000	25322	12559	0	0	\N
359253	1874	28768000	25322	12559	1	0	\N
359273	1678	26640840220000	25325	12561	0	0	\N
359274	1678	26640840221000	25325	12561	1	0	\N
359275	1678	26640840222000	25325	12561	2	0	\N
359276	1874	28790000	25325	12561	3	0	\N
359277	1874	28793000	25325	12561	4	0	\N
359278	1874	28796000	25325	12561	5	0	\N
359279	1874	28798000	25325	12561	6	0	\N
359280	1874	28800000	25325	12561	7	0	\N
359281	1874	28802000	25325	12561	8	0	\N
359282	1874	28803000	25325	12561	9	0	\N
359286	2321	500000000	25327	12563	0	0	\N
359287	1678	26640840224000	25327	12563	1	0	\N
359288	1874	28809000	25327	12563	2	0	\N
359289	1874	28811000	25327	12563	3	0	\N
359290	2321	500000000	25328	12563	0	0	\N
359291	1678	26640840224000	25328	12563	1	0	\N
359292	1874	28809000	25328	12563	2	0	\N
359293	1874	28811000	25328	12563	3	0	\N
359298	1678	26640840225000	25330	12564	0	0	\N
359299	1874	28814000	25330	12564	1	0	\N
359300	1874	28816000	25330	12564	2	0	\N
359304	1678	26640840225000	25332	12564	0	0	\N
359305	1874	28814000	25332	12564	1	0	\N
359306	1874	28816000	25332	12564	2	0	\N
359307	2321	11000000000	25333	12565	0	0	\N
359308	1874	28819000	25333	12565	1	0	\N
359309	1874	28820000	25333	12565	2	0	\N
359310	1874	28823000	25333	12565	3	0	\N
359311	2321	11000000000	25334	12565	0	0	\N
359312	1678	26640840226000	25334	12565	1	0	\N
359179	1874	28724000	25298	12550	2	0	2
359183	1678	26640840208000	25300	12551	0	0	0
359184	1874	28727000	25300	12551	1	0	2
359185	1874	28729000	25300	12551	2	0	2
359189	1678	26640840209000	25302	12552	0	0	0
359191	1874	28734000	25302	12552	2	0	2
359192	1678	26640840210000	25303	12553	0	0	0
359193	1874	28736000	25303	12553	1	0	2
359194	1874	28737000	25303	12553	2	0	2
359195	1874	28740000	25303	12553	3	0	2
359197	1874	28743000	25304	12554	1	0	2
359198	1874	28745000	25304	12554	2	0	2
359199	1678	26640840212000	25305	12555	0	0	0
359200	1874	28747000	25305	12555	1	0	2
359202	1874	28751000	25306	12556	0	0	2
359203	1874	28754000	25306	12556	1	0	2
359204	1678	26640840213000	25308	12557	0	0	0
359205	1678	26640840214000	25308	12557	1	0	0
359206	1874	28757000	25308	12557	2	0	2
359223	1874	28760000	25315	12558	1	0	2
359224	1874	28762000	25315	12558	2	0	2
359225	1874	28764000	25315	12558	3	0	2
359226	1874	28766000	25315	12558	4	0	2
359242	1678	26640840216000	25319	12559	0	0	0
359244	1874	28771000	25319	12559	2	0	2
359245	1874	28772000	25319	12559	3	0	2
359254	1678	26640840217000	25323	12560	0	0	0
359255	1678	26640840218000	25323	12560	1	0	0
359257	1874	28774000	25323	12560	3	0	2
359258	1874	28776000	25323	12560	4	0	2
359259	1874	28778000	25323	12560	5	0	2
359260	1874	28781000	25323	12560	6	0	2
359261	1874	28784000	25323	12560	7	0	2
359263	1678	26640840220000	25324	12561	0	0	0
359264	1678	26640840221000	25324	12561	1	0	0
359265	1678	26640840222000	25324	12561	2	0	0
359266	1874	28790000	25324	12561	3	0	2
359267	1874	28793000	25324	12561	4	0	2
359269	1874	28798000	25324	12561	6	0	2
359270	1874	28800000	25324	12561	7	0	2
359271	1874	28802000	25324	12561	8	0	2
359272	1874	28803000	25324	12561	9	0	2
359284	1874	28805000	25326	12562	1	0	2
359285	1874	28806000	25326	12562	2	0	2
359294	2321	500000000	25329	12563	0	0	0
359295	1678	26640840224000	25329	12563	1	0	0
359296	1874	28809000	25329	12563	2	0	2
359301	1678	26640840225000	25331	12564	0	0	0
359302	1874	28814000	25331	12564	1	0	2
359303	1874	28816000	25331	12564	2	0	2
359313	1678	26640840227000	25334	12565	2	0	\N
359314	1874	28819000	25334	12565	3	0	\N
359315	1874	28820000	25334	12565	4	0	\N
359316	1874	28823000	25334	12565	5	0	\N
359317	2321	11000000000	25335	12565	0	0	\N
359318	1678	26640840226000	25335	12565	1	0	\N
359319	1678	26640840227000	25335	12565	2	0	\N
359320	1874	28819000	25335	12565	3	0	\N
359321	1874	28820000	25335	12565	4	0	\N
359322	1874	28822000	25335	12565	5	0	\N
359323	1874	28824000	25335	12565	6	0	\N
359324	1874	28827000	25335	12565	7	0	\N
359333	1678	26640840228000	25337	12566	0	0	\N
359334	1874	28830000	25337	12566	1	0	\N
359335	1874	28832000	25337	12566	2	0	\N
359336	1678	26640840228000	25338	12566	0	0	\N
359337	1874	28830000	25338	12566	1	0	\N
359338	1874	28832000	25338	12566	2	0	\N
359342	1678	26640840228000	25340	12566	0	0	\N
359343	1874	28830000	25340	12566	1	0	\N
359344	1874	28832000	25340	12566	2	0	\N
359345	1678	26640840228000	25341	12566	0	0	\N
359346	1874	28830000	25341	12566	1	0	\N
359347	1678	26640840228000	25342	12566	0	0	\N
359348	1874	28830000	25342	12566	1	0	\N
359349	1874	28832000	25342	12566	2	0	\N
359350	1678	26640840228000	25343	12566	0	0	\N
359351	1874	28826000	25343	12566	1	0	\N
359352	1874	28828000	25343	12566	2	0	\N
359353	1874	28830000	25343	12566	3	0	\N
359354	1874	28832000	25343	12566	4	0	\N
359364	1678	26640840231000	25346	12568	0	0	\N
359365	1874	28846000	25346	12568	1	0	\N
359366	1874	28848000	25346	12568	2	0	\N
359367	2321	52000000000	25347	12569	0	0	\N
359368	1678	26640840231000	25347	12569	1	0	\N
359369	1678	26640840232000	25347	12569	2	0	\N
359370	1874	28848000	25347	12569	3	0	\N
359371	1874	28850000	25347	12569	4	0	\N
359372	1874	28853000	25347	12569	5	0	\N
359379	1678	26640840233000	25349	12570	0	0	\N
359380	1874	28855000	25349	12570	1	0	\N
359381	1874	28856000	25349	12570	2	0	\N
359382	1874	28859000	25349	12570	3	0	\N
359383	1678	26640840233000	25350	12570	0	0	\N
359384	1874	28855000	25350	12570	1	0	\N
359385	1874	28856000	25350	12570	2	0	\N
359386	1874	28859000	25350	12570	3	0	\N
359387	2321	11000000000	25351	12565	0	0	\N
359389	1678	26640840233000	25353	12570	0	0	\N
359390	1874	28855000	25353	12570	1	0	\N
359391	1874	28856000	25353	12570	2	0	\N
359392	1874	28859000	25353	12570	3	0	\N
359400	1678	26640840235000	25355	12572	0	0	\N
359401	1874	28866000	25355	12572	1	0	\N
359402	1874	28869000	25355	12572	2	0	\N
359403	1678	26640840235000	25356	12572	0	0	\N
359404	1874	28867000	25356	12572	1	0	\N
359405	1678	26640840235000	25357	12572	0	0	\N
359406	1874	28866000	25357	12572	1	0	\N
359407	1874	28869000	25357	12572	2	0	\N
359425	1678	26640840240000	25361	12575	0	0	\N
359426	1874	28891000	25361	12575	1	0	\N
359427	1874	28894000	25361	12575	2	0	\N
359428	1874	28896000	25361	12575	4	0	\N
359439	1678	26640840241000	25364	12576	0	0	\N
359440	1678	26640840242000	25364	12576	1	0	\N
359441	1874	28898000	25364	12576	2	0	\N
359442	1874	28900000	25364	12576	3	0	\N
359443	1874	28903000	25364	12576	4	0	\N
359444	1874	28906000	25364	12576	5	0	\N
359445	1874	28907000	25365	12577	0	0	\N
359446	1874	28910000	25365	12577	1	0	\N
359447	1678	26640840243000	25366	12577	0	0	\N
359448	1874	28907000	25366	12577	1	0	\N
359327	1678	26640840227000	25336	12565	2	0	0
359328	1874	28819000	25336	12565	3	0	2
359329	1874	28820000	25336	12565	4	0	2
359330	1874	28822000	25336	12565	5	0	2
359331	1874	28824000	25336	12565	6	0	2
359339	1678	26640840228000	25339	12566	0	0	0
359340	1874	28830000	25339	12566	1	0	2
359341	1874	28832000	25339	12566	2	0	2
359355	2321	31500000000	25344	12567	0	0	0
359356	1678	26640840229000	25344	12567	1	0	0
359358	1874	28833000	25344	12567	3	0	2
359359	1874	28836000	25344	12567	4	0	2
359360	1874	28839000	25344	12567	5	0	2
359361	1874	28841000	25344	12567	6	0	2
359363	1874	28846000	25345	12568	0	0	2
359373	2321	52000000000	25348	12569	0	0	0
359374	1678	26640840231000	25348	12569	1	0	0
359375	1678	26640840232000	25348	12569	2	0	0
359376	1874	28848000	25348	12569	3	0	2
359378	1874	28853000	25348	12569	5	0	2
359388	1874	28854000	25352	12570	0	0	2
359393	2321	172500000000	25354	12571	0	0	0
359394	1678	26640840233000	25354	12571	1	0	0
359395	1678	26640840234000	25354	12571	2	0	0
359397	1874	28858000	25354	12571	4	0	2
359398	1874	28861000	25354	12571	5	0	2
359399	1874	28864000	25354	12571	6	0	2
359408	1678	26640840235000	25358	12572	0	0	0
359410	1874	28869000	25358	12572	2	0	2
359411	2321	293000000000	25359	12573	0	0	0
359412	1678	26640840236000	25359	12573	1	0	0
359413	1874	28872000	25359	12573	2	0	2
359414	1874	28874000	25359	12573	3	0	2
359416	1678	26640840238000	25360	12574	1	0	0
359417	1678	26640840239000	25360	12574	2	0	0
359418	1874	28876000	25360	12574	3	0	2
359419	1874	28877000	25360	12574	4	0	2
359420	1874	28880000	25360	12574	5	0	2
359422	1874	28886000	25360	12574	7	0	2
359423	1874	28888000	25360	12574	8	0	2
359424	1874	28890000	25360	12574	9	0	2
359429	1678	26640840240000	25362	12575	0	0	0
359431	1874	28894000	25362	12575	2	0	2
359432	1874	28896000	25362	12575	4	0	2
359433	1678	26640840241000	25363	12576	0	0	0
359434	1678	26640840242000	25363	12576	1	0	0
359435	1874	28898000	25363	12576	2	0	2
359437	1874	28903000	25363	12576	4	0	2
359438	1874	28906000	25363	12576	5	0	2
359449	1874	28909000	25366	12577	2	0	\N
359450	1874	28912000	25366	12577	3	0	\N
359451	1678	26640840243000	25367	12577	0	0	\N
359452	1874	28907000	25367	12577	1	0	\N
359453	1874	28909000	25367	12577	2	0	\N
359454	1874	28912000	25367	12577	3	0	\N
359463	1678	26640840245000	25370	12579	0	0	\N
359464	1874	28919000	25370	12579	1	0	\N
359465	1874	28922000	25370	12579	2	0	\N
359472	1678	26640840246000	25373	12580	0	0	\N
359473	1874	28924000	25373	12580	1	0	\N
359474	1874	28927000	25373	12580	2	0	\N
359480	2321	500000000	25375	12473	0	0	\N
359481	2321	11000000000	25375	12473	1	0	\N
359482	2321	31500000000	25375	12473	2	0	\N
359483	2321	52000000000	25375	12473	3	0	\N
359484	2321	172500000000	25375	12473	4	0	\N
359485	2321	293000000000	25375	12473	5	0	\N
359486	2321	413500000000	25375	12473	6	0	\N
359487	2321	534000000000	25375	12473	7	0	\N
359488	1678	26640840203000	25375	12473	8	0	\N
359489	1678	26640840204000	25375	12473	9	0	\N
359490	1678	26640840205000	25375	12473	10	0	\N
359491	1678	26640840206000	25375	12473	11	0	\N
359492	1678	26640840207000	25375	12473	12	0	\N
359496	1678	26640840248000	25377	12582	0	0	\N
359497	1874	28936000	25377	12582	1	0	\N
359498	1678	26640840248000	25378	12582	0	0	\N
359499	1874	28935000	25378	12582	1	0	\N
359500	1874	28938000	25378	12582	2	0	\N
359501	1678	26640840248000	25379	12582	0	0	\N
359502	1874	28935000	25379	12582	1	0	\N
359503	1874	28938000	25379	12582	2	0	\N
359504	1678	26640840248000	25380	12582	0	0	\N
359505	1874	28935000	25380	12582	1	0	\N
359506	1874	28938000	25380	12582	2	0	\N
359507	1678	26640840249000	25381	12583	0	0	\N
359508	1874	28940000	25381	12583	1	0	\N
359509	1874	28943000	25381	12583	2	0	\N
359513	1678	26640840249000	25383	12583	0	0	\N
359514	1874	28940000	25383	12583	1	0	\N
359515	1874	28943000	25383	12583	2	0	\N
359520	1678	26640840251000	25386	12585	0	0	\N
359521	1874	28952000	25386	12585	1	0	\N
359522	1874	28954000	25386	12585	2	0	\N
359523	1678	26640840251000	25387	12585	0	0	\N
359524	1874	28952000	25387	12585	1	0	\N
359525	1874	28954000	25387	12585	2	0	\N
359526	1678	26640840251000	25388	12585	0	0	\N
359527	1874	28952000	25388	12585	1	0	\N
359528	1874	28954000	25388	12585	2	0	\N
359529	1678	26640840251000	25389	12585	0	0	\N
359530	1874	28952000	25389	12585	1	0	\N
359531	1874	28954000	25389	12585	2	0	\N
359535	1678	26640840251000	25391	12585	0	0	\N
359536	1874	28952000	25391	12585	1	0	\N
359537	1874	28954000	25391	12585	2	0	\N
359538	1678	26640840251000	25392	12585	0	0	\N
359539	1874	28952000	25392	12585	1	0	\N
359540	1874	28954000	25392	12585	2	0	\N
359544	1678	26640840252000	25394	12586	0	0	\N
359545	1678	26640840253000	25394	12586	1	0	\N
359546	1874	28955000	25394	12586	2	0	\N
359547	1874	28957000	25394	12586	3	0	\N
359548	1874	28959000	25394	12586	4	0	\N
359549	1874	28962000	25394	12586	5	0	\N
359550	1874	28965000	25394	12586	6	0	\N
359558	1678	26640840252000	25396	12587	0	0	\N
359559	1678	26640840253000	25396	12587	1	0	\N
359560	1678	26640840254000	25396	12587	2	0	\N
359561	1874	28963000	25396	12587	3	0	\N
359562	1874	28965000	25396	12587	4	0	\N
359563	1874	28967000	25396	12587	5	0	\N
359564	1874	28970000	25396	12587	6	0	\N
359565	1678	26640840254000	25398	12587	0	0	\N
359566	1874	28967000	25398	12587	1	0	\N
359567	1874	28970000	25398	12587	2	0	\N
359574	1678	26640840255000	25400	12588	0	0	\N
359575	1678	26640840256000	25400	12588	1	0	\N
359576	1874	28972000	25400	12588	2	0	\N
359577	1874	28975000	25400	12588	3	0	\N
359578	2322	0	25400	12588	4	0	\N
359579	2323	0	25400	12588	5	0	\N
359580	1874	28978000	25400	12588	6	0	\N
359581	1874	28980000	25400	12588	7	0	\N
359582	1678	26640840255000	25401	12588	0	0	\N
359583	1678	26640840256000	25401	12588	1	0	\N
359584	1874	28972000	25401	12588	2	0	\N
359457	1874	28909000	25368	12577	2	0	2
359458	1874	28912000	25368	12577	3	0	2
359459	2321	413500000000	25369	12578	0	0	0
359460	1678	26640840244000	25369	12578	1	0	0
359461	1874	28915000	25369	12578	2	0	2
359466	1678	26640840245000	25371	12579	0	0	0
359467	1874	28919000	25371	12579	1	0	2
359468	1874	28922000	25371	12579	2	0	2
359469	1678	26640840246000	25372	12580	0	0	0
359470	1874	28924000	25372	12580	1	0	2
359475	2321	534000000000	25374	12581	0	0	0
359476	1678	26640840247000	25374	12581	1	0	0
359477	1874	28929000	25374	12581	2	0	2
359478	1874	28932000	25374	12581	3	0	2
359493	1678	26640840248000	25376	12582	0	0	0
359494	1874	28935000	25376	12582	1	0	2
359495	1874	28938000	25376	12582	2	0	2
359510	1678	26640840249000	25382	12583	0	0	0
359511	1874	28940000	25382	12583	1	0	2
359516	1678	26640840250000	25384	12584	0	0	0
359517	1874	28944000	25384	12584	1	0	2
359518	1874	28946000	25384	12584	2	0	2
359519	1874	28949000	25384	12584	3	0	2
359532	1678	26640840251000	25390	12585	0	0	0
359534	1874	28954000	25390	12585	2	0	2
359541	1874	28955000	25393	12586	0	0	2
359542	1874	28958000	25393	12586	1	0	2
359543	1874	28961000	25393	12586	2	0	2
359552	1678	26640840253000	25395	12587	1	0	0
359553	1678	26640840254000	25395	12587	2	0	0
359554	1874	28963000	25395	12587	3	0	2
359555	1874	28965000	25395	12587	4	0	2
359556	1874	28967000	25395	12587	5	0	2
359568	1678	26640840255000	25399	12588	0	0	0
359569	1678	26640840256000	25399	12588	1	0	0
359570	1874	28973000	25399	12588	2	0	2
359571	2322	0	25399	12588	3	0	0
359572	2323	0	25399	12588	4	0	0
359585	1874	28975000	25401	12588	3	0	\N
359586	2322	0	25401	12588	4	0	\N
359587	2323	0	25401	12588	5	0	\N
359588	1874	28978000	25401	12588	6	0	\N
359589	1874	28980000	25401	12588	7	0	\N
359590	2321	654500000000	25402	12589	0	0	\N
359591	1678	26640840257000	25402	12589	1	0	\N
359592	1874	28978000	25402	12589	2	0	\N
359593	1874	28981000	25402	12589	3	0	\N
359594	1874	28982000	25402	12589	4	0	\N
359595	1874	28984000	25402	12589	5	0	\N
359596	1874	28986000	25402	12589	6	0	\N
359604	2321	654500000000	25404	12589	0	0	\N
359605	1678	26640840257000	25404	12589	1	0	\N
359606	1874	28978000	25404	12589	2	0	\N
359607	1874	28981000	25404	12589	3	0	\N
359608	1874	28982000	25404	12589	4	0	\N
359609	1874	28984000	25404	12589	5	0	\N
359610	1874	28986000	25404	12589	6	0	\N
359611	2321	500000000	25405	12547	0	0	\N
359612	2321	11000000000	25405	12547	1	0	\N
359613	2321	31500000000	25405	12547	2	0	\N
359614	2321	52000000000	25405	12547	3	0	\N
359615	2321	172500000000	25405	12547	4	0	\N
359616	2321	293000000000	25405	12547	5	0	\N
359617	2321	413500000000	25405	12547	6	0	\N
359618	2321	534000000000	25405	12547	7	0	\N
359619	2321	654500000000	25405	12547	8	0	\N
359620	2322	0	25405	12547	9	0	\N
359621	2323	0	25405	12547	10	0	\N
359643	1678	26640840263000	25410	12593	0	0	\N
359644	1874	29014000	25410	12593	1	0	\N
359645	1874	29017000	25410	12593	2	0	\N
359646	1874	29018000	25410	12593	3	0	\N
359647	1678	26640840263000	25411	12593	0	0	\N
359648	1874	29014000	25411	12593	1	0	\N
359649	1874	29017000	25411	12593	2	0	\N
359650	1874	29018000	25411	12593	3	0	\N
359651	1678	26640840263000	25412	12593	0	0	\N
359652	1874	29014000	25412	12593	1	0	\N
359653	1874	29017000	25412	12593	2	0	\N
359654	1874	29018000	25412	12593	3	0	\N
359656	1678	26640840264000	25414	12594	0	0	\N
359657	1874	29021000	25414	12594	1	0	\N
359658	1874	29023000	25414	12594	2	0	\N
359659	1874	29021000	25415	12594	0	0	\N
359663	1678	26640840264000	25417	12595	0	0	\N
359664	1678	26640840265000	25417	12595	1	0	\N
359665	1874	29024000	25417	12595	2	0	\N
359666	1874	29026000	25417	12595	4	0	\N
359667	1874	29028000	25417	12595	5	0	\N
359668	1678	26640840266000	25418	12596	0	0	\N
359669	1874	29027000	25418	12596	1	0	\N
359670	1874	29029000	25418	12596	2	0	\N
359671	1874	29031000	25418	12596	3	0	\N
359672	1874	29033000	25418	12596	4	0	\N
359673	1678	26640840266000	25419	12596	0	0	\N
359674	1874	29027000	25419	12596	1	0	\N
359675	1874	29029000	25419	12596	2	0	\N
359676	1874	29031000	25419	12596	3	0	\N
359677	1874	29033000	25419	12596	4	0	\N
359683	1678	26640840266000	25421	12596	0	0	\N
359684	1874	29027000	25421	12596	1	0	\N
359685	1874	29029000	25421	12596	2	0	\N
359690	1678	26640840268000	25423	12598	0	0	\N
359691	1874	29042000	25423	12598	1	0	\N
359698	1678	26640840269000	25426	12599	0	0	\N
359699	1678	26640840270000	25426	12599	1	0	\N
359700	1678	26640840271000	25426	12599	2	0	\N
359701	1874	29046000	25426	12599	3	0	\N
359702	1874	29049000	25426	12599	4	0	\N
359703	1874	29051000	25426	12599	5	0	\N
359704	1874	29053000	25426	12599	6	0	\N
359705	1874	29056000	25426	12599	7	0	\N
359706	1874	29059000	25426	12599	8	0	\N
359707	1874	29060000	25426	12599	9	0	\N
359708	1874	29050000	25427	12600	0	0	\N
359709	2321	654500000000	25428	12585	0	0	\N
359710	2321	710000000000	25428	12585	1	0	\N
359711	2322	0	25428	12585	2	0	\N
359712	2323	0	25428	12585	3	0	\N
359720	1678	26640840270000	25430	12600	0	0	\N
359599	1874	28978000	25403	12589	2	0	2
359600	1874	28981000	25403	12589	3	0	2
359601	1874	28982000	25403	12589	4	0	2
359602	1874	28984000	25403	12589	5	0	2
359603	1874	28986000	25403	12589	6	0	2
359623	1678	26640840258000	25406	12590	1	0	0
359624	1678	26640840259000	25406	12590	2	0	0
359625	1678	26640840260000	25406	12590	3	0	0
359626	1874	28989000	25406	12590	4	0	2
359627	1874	28990000	25406	12590	5	0	2
359629	1874	28994000	25406	12590	7	0	2
359630	1874	28996000	25406	12590	8	0	2
359631	1874	28999000	25406	12590	9	0	2
359632	1874	29002000	25406	12590	10	0	2
359634	1874	29004000	25407	12591	1	0	2
359635	1874	29007000	25407	12591	2	0	2
359636	1678	26640840262000	25408	12592	0	0	0
359637	1874	29010000	25408	12592	1	0	2
359638	1874	29012000	25408	12592	2	0	2
359640	1874	29014000	25409	12593	1	0	2
359641	1874	29017000	25409	12593	2	0	2
359642	1874	29018000	25409	12593	3	0	2
359655	1874	29021000	25413	12594	0	0	2
359660	1678	26640840264000	25416	12595	0	0	0
359662	1874	29024000	25416	12595	2	0	2
359678	1678	26640840266000	25420	12596	0	0	0
359679	1874	29027000	25420	12596	1	0	2
359680	1874	29029000	25420	12596	2	0	2
359682	1874	29033000	25420	12596	4	0	2
359686	1678	26640840267000	25422	12597	0	0	0
359687	1874	29036000	25422	12597	1	0	2
359688	1874	29038000	25422	12597	2	0	2
359689	1874	29039000	25422	12597	3	0	2
359693	1874	29041000	25424	12598	1	0	2
359694	1874	29044000	25424	12598	2	0	2
359695	1678	26640840269000	25425	12599	0	0	0
359696	1874	29046000	25425	12599	1	0	2
359697	1874	29049000	25425	12599	2	0	2
359714	1678	26640840271000	25429	12600	1	0	0
359715	1874	29051000	25429	12600	2	0	2
359716	1874	29053000	25429	12600	3	0	2
359717	1874	29056000	25429	12600	4	0	2
359719	1874	29060000	25429	12600	6	0	2
359721	1678	26640840271000	25430	12600	1	0	\N
359722	1874	29051000	25430	12600	2	0	\N
359723	1874	29053000	25430	12600	3	0	\N
359724	1874	29056000	25430	12600	4	0	\N
359725	1874	29059000	25430	12600	5	0	\N
359726	1874	29060000	25430	12600	6	0	\N
359727	1678	26640840269000	25431	12599	0	0	\N
359728	1678	26640840270000	25431	12599	1	0	\N
359729	1678	26640840271000	25431	12599	2	0	\N
359730	1874	29047000	25431	12599	3	0	\N
359731	1874	29050000	25431	12599	4	0	\N
359732	1874	29053000	25431	12599	5	0	\N
359733	1874	29054000	25431	12599	6	0	\N
359744	1678	26640840274000	25435	12603	0	0	\N
359745	1874	29074000	25435	12603	1	0	\N
359746	1874	29076000	25435	12603	2	0	\N
359747	1678	26640840274000	25436	12603	0	0	\N
359748	1874	29074000	25436	12603	1	0	\N
359749	1874	29076000	25436	12603	2	0	\N
359750	1678	26640840275000	25438	12604	0	0	\N
359751	1874	29078000	25438	12604	1	0	\N
359752	1874	29081000	25438	12604	2	0	\N
359753	1678	26640840275000	25439	12604	0	0	\N
359754	1874	29078000	25439	12604	1	0	\N
359755	1874	29081000	25439	12604	2	0	\N
359756	1678	26640840275000	25440	12604	0	0	\N
359757	1874	29078000	25440	12604	1	0	\N
359758	1874	29081000	25440	12604	2	0	\N
359762	1678	26640840275000	25442	12604	0	0	\N
359763	1874	29078000	25442	12604	1	0	\N
359764	1874	29081000	25442	12604	2	0	\N
359765	1678	26640840276000	25443	12605	0	0	\N
359766	1874	29084000	25443	12605	1	0	\N
359767	1874	29086000	25443	12605	2	0	\N
359770	1678	26640840276000	25445	12605	0	0	\N
359771	1874	29084000	25445	12605	1	0	\N
359772	1874	29086000	25445	12605	2	0	\N
359773	1678	26640840277000	25446	12606	0	0	\N
359774	1874	29085000	25446	12606	1	0	\N
359775	1874	29088000	25446	12606	2	0	\N
359776	1874	29090000	25446	12606	3	0	\N
359777	1874	29092000	25446	12606	4	0	\N
359783	1678	26640840277000	25448	12606	0	0	\N
359784	1874	29085000	25448	12606	1	0	\N
359785	1874	29088000	25448	12606	2	0	\N
359786	1874	29090000	25448	12606	3	0	\N
359787	1874	29092000	25448	12606	4	0	\N
359795	1678	26640840280000	25450	12608	0	0	\N
359796	1874	29103000	25450	12608	1	0	\N
359797	1874	29106000	25450	12608	2	0	\N
359802	1678	26640840281000	25452	12609	0	0	\N
359803	1874	29110000	25452	12609	1	0	\N
359804	1874	29113000	25452	12609	2	0	\N
359805	1678	26640840281000	25453	12609	0	0	\N
359806	1874	29110000	25453	12609	1	0	\N
359807	1874	29113000	25453	12609	2	0	\N
359811	1678	26640840281000	25455	12609	0	0	\N
359812	1874	29111000	25455	12609	1	0	\N
359813	1678	26640840281000	25456	12609	0	0	\N
359814	1874	29110000	25456	12609	1	0	\N
359815	1874	29113000	25456	12609	2	0	\N
359820	2322	0	25458	12581	0	0	\N
359821	2323	0	25458	12581	1	0	\N
359822	1483	11000000	25458	12581	2	0	\N
359823	1483	11000000	25458	12581	3	0	\N
359828	1678	26640840283000	25462	12611	0	0	\N
359829	1874	29119000	25462	12611	1	0	\N
359830	1874	29122000	25462	12611	2	0	\N
359831	1874	29124000	25462	12611	3	0	\N
359838	1678	26640840286000	25464	12613	0	0	\N
359839	1874	29137000	25464	12613	1	0	\N
359840	1874	29139000	25464	12613	2	0	\N
359848	1678	26640840288000	25467	12615	0	0	\N
359849	1874	29148000	25467	12615	1	0	\N
359850	1874	29150000	25467	12615	2	0	\N
359854	1678	26640840288000	25469	12615	0	0	\N
359855	1874	29148000	25469	12615	1	0	\N
359856	1874	29150000	25469	12615	2	0	\N
359736	1874	29065000	25432	12601	2	0	2
359737	1678	26640840273000	25433	12602	0	0	0
359738	1874	29067000	25433	12602	1	0	2
359739	1874	29070000	25433	12602	2	0	2
359740	1874	29071000	25433	12602	3	0	2
359742	1874	29074000	25434	12603	1	0	2
359743	1874	29076000	25434	12603	2	0	2
359759	1678	26640840275000	25441	12604	0	0	0
359760	1874	29078000	25441	12604	1	0	2
359761	1874	29081000	25441	12604	2	0	2
359769	1874	29084000	25444	12605	1	0	2
359778	1678	26640840277000	25447	12606	0	0	0
359779	1874	29085000	25447	12606	1	0	2
359780	1874	29088000	25447	12606	2	0	2
359782	1874	29092000	25447	12606	4	0	2
359788	1678	26640840278000	25449	12607	0	0	0
359789	1678	26640840279000	25449	12607	1	0	0
359790	1874	29094000	25449	12607	2	0	2
359791	1874	29097000	25449	12607	3	0	2
359793	1874	29100000	25449	12607	5	0	2
359794	1874	29102000	25449	12607	6	0	2
359798	1678	26640840280000	25451	12608	0	0	0
359799	1874	29103000	25451	12608	1	0	2
359800	1874	29105000	25451	12608	2	0	2
359808	1678	26640840281000	25454	12609	0	0	0
359809	1874	29110000	25454	12609	1	0	2
359810	1874	29113000	25454	12609	2	0	2
359816	1483	11000000	25457	12610	0	0	0
359818	1874	29115000	25457	12610	2	0	2
359819	1874	29118000	25457	12610	3	0	2
359824	1678	26640840283000	25461	12611	0	0	0
359825	1874	29119000	25461	12611	1	0	2
359826	1874	29122000	25461	12611	2	0	2
359832	1678	26640840284000	25463	12612	0	0	0
359833	1678	26640840285000	25463	12612	1	0	0
359834	1874	29126000	25463	12612	2	0	2
359835	1874	29128000	25463	12612	3	0	2
359836	1874	29131000	25463	12612	4	0	2
359841	1678	26640840286000	25465	12613	0	0	0
359842	1874	29137000	25465	12613	1	0	2
359843	1874	29139000	25465	12613	2	0	2
359844	1678	26640840287000	25466	12614	0	0	0
359846	1874	29144000	25466	12614	2	0	2
359847	1874	29145000	25466	12614	3	0	2
359851	1678	26640840288000	25468	12615	0	0	0
359852	1874	29148000	25468	12615	1	0	2
359853	1874	29150000	25468	12615	2	0	2
359857	1678	26640840288000	25470	12615	0	0	\N
359858	1874	29148000	25470	12615	1	0	\N
359859	1874	29150000	25470	12615	2	0	\N
359860	1874	29148000	25471	12615	0	0	\N
359861	1874	29150000	25471	12615	1	0	\N
359865	1678	26640840290000	25473	12617	0	0	\N
359866	1874	29157000	25473	12617	2	0	\N
359867	2152	107988998000000	25473	12617	3	0	\N
359868	1874	29160000	25473	12617	4	0	\N
359869	1678	26640840290000	25474	12617	0	0	\N
359870	1874	29157000	25474	12617	2	0	\N
359871	2152	107988998000000	25474	12617	3	0	\N
359872	1874	29160000	25474	12617	4	0	\N
359873	1678	26640840290000	25475	12617	0	0	\N
359874	1874	29157000	25475	12617	2	0	\N
359875	2152	107988998000000	25475	12617	3	0	\N
359876	1874	29160000	25475	12617	4	0	\N
359881	1678	26640840290000	25477	12617	0	0	\N
359882	1874	29157000	25477	12617	2	0	\N
359883	2152	107988998000000	25477	12617	3	0	\N
359884	1874	29160000	25477	12617	4	0	\N
359891	1678	26640840292000	25480	12619	0	0	\N
359892	1874	29168000	25480	12619	1	0	\N
359893	1874	29170000	25480	12619	2	0	\N
359897	2321	654500000000	25482	12475	0	0	\N
359898	1678	26640840293000	25483	12620	0	0	\N
359899	1874	29172000	25483	12620	1	0	\N
359900	1874	29175000	25483	12620	2	0	\N
359904	1678	26640840295000	25485	12622	0	0	\N
359905	1874	29183000	25485	12622	1	0	\N
359906	1874	29185000	25485	12622	2	0	\N
359913	1678	26640840296000	25488	12623	0	0	\N
359914	1874	29188000	25488	12623	1	0	\N
359915	1874	29190000	25488	12623	2	0	\N
359916	1874	29187000	25489	12623	0	0	\N
359920	1678	26640840298000	25492	12625	0	0	\N
359921	1678	26640840299000	25492	12625	1	0	\N
359922	1874	29197000	25492	12625	2	0	\N
359923	1874	29200000	25492	12625	3	0	\N
359924	1874	29203000	25492	12625	4	0	\N
359925	1874	29205000	25492	12625	5	0	\N
359932	1678	26640840298000	25494	12625	0	0	\N
359933	1678	26640840299000	25494	12625	1	0	\N
359934	1874	29197000	25494	12625	2	0	\N
359935	1874	29200000	25494	12625	3	0	\N
359936	1874	29203000	25494	12625	4	0	\N
359937	1874	29205000	25494	12625	5	0	\N
359938	1678	26640840300000	25495	12626	0	0	\N
359939	1874	29208000	25495	12626	1	0	\N
359940	1874	29210000	25495	12626	2	0	\N
359941	1678	26640840300000	25496	12626	0	0	\N
359942	1874	29208000	25496	12626	1	0	\N
359943	1874	29210000	25496	12626	2	0	\N
359944	1678	26640840300000	25497	12626	0	0	\N
359945	1874	29208000	25497	12626	1	0	\N
359946	1874	29210000	25497	12626	2	0	\N
359950	1678	26640840300000	25499	12626	0	0	\N
359951	1874	29208000	25499	12626	1	0	\N
359952	1874	29210000	25499	12626	2	0	\N
359965	1678	26640840304000	25504	12630	0	0	\N
359966	1874	29227000	25504	12630	1	0	\N
359967	1874	29230000	25504	12630	2	0	\N
359968	1678	26640840305000	25505	12631	0	0	\N
359969	1874	29232000	25505	12631	1	0	\N
359970	1874	29235000	25505	12631	2	0	\N
359971	1678	26640840305000	25506	12631	0	0	\N
359972	1874	29232000	25506	12631	1	0	\N
359973	1874	29235000	25506	12631	2	0	\N
359977	1678	26640840306000	25508	12632	0	0	\N
359978	1874	29238000	25508	12632	1	0	\N
359979	1874	29240000	25508	12632	2	0	\N
359983	1678	26640840307000	25510	12633	0	0	\N
359984	1874	29242000	25510	12633	1	0	\N
359985	1874	29245000	25510	12633	2	0	\N
359989	1678	26640840307000	25512	12633	0	0	\N
359990	1874	29242000	25512	12633	1	0	\N
359991	1874	29245000	25512	12633	2	0	\N
359992	1678	26640840307000	25513	12633	0	0	\N
359864	1874	29155000	25472	12616	2	0	2
359877	1678	26640840290000	25476	12617	0	0	0
359878	1874	29157000	25476	12617	2	0	2
359879	2152	107988998000000	25476	12617	3	0	5
359880	1874	29160000	25476	12617	4	0	2
359886	1874	29163000	25478	12618	1	0	2
359887	1874	29165000	25478	12618	2	0	2
359888	1678	26640840292000	25479	12619	0	0	0
359889	1874	29168000	25479	12619	1	0	2
359890	1874	29170000	25479	12619	2	0	2
359895	1874	29172000	25481	12620	1	0	2
359896	1874	29175000	25481	12620	2	0	2
359901	1678	26640840294000	25484	12621	0	0	0
359902	1874	29178000	25484	12621	1	0	2
359907	1678	26640840295000	25486	12622	0	0	0
359908	1874	29183000	25486	12622	1	0	2
359909	1874	29185000	25486	12622	2	0	2
359910	1678	26640840296000	25487	12623	0	0	0
359911	1874	29188000	25487	12623	1	0	2
359917	1678	26640840297000	25490	12624	0	0	0
359918	1874	29193000	25490	12624	1	0	2
359919	1874	29195000	25490	12624	2	0	2
359926	1678	26640840298000	25493	12625	0	0	0
359927	1678	26640840299000	25493	12625	1	0	0
359929	1874	29200000	25493	12625	3	0	2
359930	1874	29203000	25493	12625	4	0	2
359931	1874	29205000	25493	12625	5	0	2
359947	1678	26640840300000	25498	12626	0	0	0
359949	1874	29210000	25498	12626	2	0	2
359953	1678	26640840301000	25500	12627	0	0	0
359954	1874	29213000	25500	12627	1	0	2
359955	1874	29215000	25500	12627	2	0	2
359956	1678	26640840302000	25501	12628	0	0	0
359958	1874	29220000	25501	12628	2	0	2
359959	1678	26640840303000	25502	12629	0	0	0
359960	1874	29223000	25502	12629	1	0	2
359961	1874	29225000	25502	12629	2	0	2
359962	1678	26640840304000	25503	12630	0	0	0
359964	1874	29230000	25503	12630	2	0	2
359974	1678	26640840305000	25507	12631	0	0	0
359975	1874	29232000	25507	12631	1	0	2
359976	1874	29235000	25507	12631	2	0	2
359981	1874	29238000	25509	12632	1	0	2
359982	1874	29240000	25509	12632	2	0	2
359986	1678	26640840307000	25511	12633	0	0	0
359987	1874	29242000	25511	12633	1	0	2
359988	1874	29245000	25511	12633	2	0	2
359993	1874	29242000	25513	12633	1	0	\N
359994	1874	29245000	25513	12633	2	0	\N
359995	1678	26640840307000	25514	12633	0	0	\N
359996	1874	29242000	25514	12633	1	0	\N
359997	1874	29245000	25514	12633	2	0	\N
359998	1678	26640840308000	25515	12634	0	0	\N
359999	1874	29248000	25515	12634	1	0	\N
360000	1874	29250000	25515	12634	2	0	\N
360001	1678	26640840308000	25516	12634	0	0	\N
360002	1874	29248000	25516	12634	1	0	\N
360003	1874	29250000	25516	12634	2	0	\N
360004	1678	26640840308000	25517	12634	0	0	\N
360005	1874	29248000	25517	12634	1	0	\N
360006	1874	29250000	25517	12634	2	0	\N
360010	1678	26640840309000	25519	12635	0	0	\N
360011	1874	29253000	25519	12635	1	0	\N
360012	1874	29255000	25519	12635	2	0	\N
360013	1678	26640840309000	25520	12635	0	0	\N
360014	1874	29253000	25520	12635	1	0	\N
360015	1874	29255000	25520	12635	2	0	\N
360016	1678	26640840309000	25521	12635	0	0	\N
360017	1874	29253000	25521	12635	1	0	\N
360018	1874	29255000	25521	12635	2	0	\N
360027	1678	26640840312000	25524	12637	0	0	\N
360028	1874	29265000	25524	12637	1	0	\N
360029	1874	29267000	25524	12637	2	0	\N
360033	1678	26640840312000	25526	12637	0	0	\N
360034	1874	29265000	25526	12637	1	0	\N
360035	1874	29267000	25526	12637	2	0	\N
360036	1678	26640840312000	25527	12637	0	0	\N
360037	1874	29265000	25527	12637	1	0	\N
360038	1874	29267000	25527	12637	2	0	\N
360039	1678	26640840313000	25529	12638	0	0	\N
360040	1678	26640840314000	25529	12638	1	0	\N
360041	1678	26640840315000	25529	12638	2	0	\N
360042	1874	29270000	25529	12638	3	0	\N
360043	1874	29273000	25529	12638	4	0	\N
360044	1874	29276000	25529	12638	5	0	\N
360045	1874	29278000	25529	12638	6	0	\N
360046	1874	29280000	25529	12638	7	0	\N
360047	1874	29282000	25529	12638	8	0	\N
360063	1678	26640840317000	25533	12640	0	0	\N
360064	1874	29289000	25533	12640	2	0	\N
360065	1874	29292000	25533	12640	3	0	\N
360069	1678	26640840319000	25535	12642	0	0	\N
360070	1874	29299000	25535	12642	1	0	\N
360071	1874	29302000	25535	12642	2	0	\N
360081	1678	26640840322000	25538	12644	0	0	\N
360082	1874	29315000	25538	12644	1	0	\N
360083	1678	26640840322000	25539	12644	0	0	\N
360084	1874	29315000	25539	12644	1	0	\N
360092	2152	107988998000000	25542	12582	0	0	\N
360093	2152	107988998000000	25543	12608	0	0	\N
360118	1678	26640840306000	25551	12632	0	0	\N
360119	1678	26640840307000	25551	12632	1	0	\N
360120	1678	26640840308000	25551	12632	2	0	\N
360121	1678	26640840309000	25551	12632	3	0	\N
360122	1678	26640840310000	25551	12632	4	0	\N
360123	1678	26640840311000	25551	12632	5	0	\N
360124	1678	26640840312000	25551	12632	6	0	\N
360125	1678	26640840313000	25551	12632	7	0	\N
360126	1678	26640840314000	25551	12632	8	0	\N
360127	1678	26640840315000	25551	12632	9	0	\N
360128	1678	26640840316000	25551	12632	10	0	\N
360009	1874	29250000	25518	12634	2	0	2
360019	1874	29252000	25522	12635	0	0	2
360020	1678	26640840309000	25523	12636	0	0	0
360021	1678	26640840310000	25523	12636	1	0	0
360022	1678	26640840311000	25523	12636	2	0	0
360024	1874	29257000	25523	12636	4	0	2
360025	1874	29260000	25523	12636	5	0	2
360026	1874	29262000	25523	12636	6	0	2
360030	1678	26640840312000	25525	12637	0	0	0
360031	1874	29265000	25525	12637	1	0	2
360048	1678	26640840313000	25530	12638	0	0	0
360049	1678	26640840314000	25530	12638	1	0	0
360050	1678	26640840315000	25530	12638	2	0	0
360051	1874	29270000	25530	12638	3	0	2
360053	1874	29276000	25530	12638	5	0	2
360054	1874	29278000	25530	12638	6	0	2
360055	1874	29280000	25530	12638	7	0	2
360056	1874	29282000	25530	12638	8	0	2
360057	1678	26640840316000	25531	12639	0	0	0
360059	1874	29287000	25531	12639	2	0	2
360060	1678	26640840317000	25532	12640	0	0	0
360061	1874	29289000	25532	12640	2	0	2
360062	1874	29292000	25532	12640	3	0	2
360066	1678	26640840318000	25534	12641	0	0	0
360068	1874	29297000	25534	12641	2	0	2
360072	1678	26640840319000	25536	12642	0	0	0
360073	1874	29299000	25536	12642	1	0	2
360074	1874	29302000	25536	12642	2	0	2
360076	1678	26640840321000	25537	12643	1	0	0
360077	1874	29304000	25537	12643	2	0	2
360078	1874	29307000	25537	12643	3	0	2
360079	1874	29310000	25537	12643	4	0	2
360080	1874	29312000	25537	12643	5	0	2
360086	1874	29315000	25540	12644	1	0	2
360087	1678	26640840323000	25541	12645	0	0	0
360088	1874	29317000	25541	12645	1	0	2
360089	1874	29319000	25541	12645	2	0	2
360090	1874	29322000	25541	12645	3	0	2
360094	1678	26640840324000	25544	12646	0	0	0
360095	1678	26640840325000	25544	12646	1	0	0
360096	1874	29327000	25544	12646	2	0	2
360097	1874	29329000	25544	12646	3	0	2
360099	1874	29335000	25544	12646	5	0	2
360100	1678	26640840326000	25545	12647	0	0	0
360101	1874	29338000	25545	12647	1	0	2
360102	1874	29340000	25545	12647	2	0	2
360103	1678	26640840327000	25546	12648	0	0	0
360105	1874	29345000	25546	12648	2	0	2
360106	1678	26640840328000	25548	12649	0	0	0
360107	1678	26640840329000	25548	12649	1	0	0
360108	1678	26640840330000	25548	12649	2	0	0
360109	1874	29348000	25548	12649	3	0	2
360111	1874	29353000	25548	12649	5	0	2
360112	1874	29355000	25548	12649	6	0	2
360113	1874	29357000	25548	12649	7	0	2
360114	1874	29360000	25549	12650	0	0	2
360116	1874	29362000	25550	12651	1	0	2
360117	1874	29365000	25550	12651	2	0	2
360129	1678	26640840317000	25551	12632	11	0	\N
360130	1678	26640840318000	25551	12632	12	0	\N
360131	1678	26640840319000	25551	12632	13	0	\N
360132	1678	26640840320000	25551	12632	14	0	\N
360133	1678	26640840321000	25551	12632	15	0	\N
360134	1678	26640840322000	25551	12632	16	0	\N
360135	1678	26640840323000	25551	12632	17	0	\N
360136	1678	26640840324000	25551	12632	18	0	\N
360137	1678	26640840325000	25551	12632	19	0	\N
360138	1678	26640840326000	25551	12632	20	0	\N
360139	1678	26640840327000	25551	12632	21	0	\N
360140	1678	26640840328000	25551	12632	22	0	\N
360141	1678	26640840329000	25551	12632	23	0	\N
360142	1678	26640840330000	25551	12632	24	0	\N
360143	1678	26640840331000	25551	12632	25	0	\N
360144	1874	29238000	25551	12632	26	0	\N
360145	1874	29241000	25551	12632	27	0	\N
360146	1874	29244000	25551	12632	28	0	\N
360147	1874	29247000	25551	12632	29	0	\N
360148	1874	29250000	25551	12632	30	0	\N
360149	1874	29253000	25551	12632	31	0	\N
360150	1874	29256000	25551	12632	32	0	\N
360151	1874	29259000	25551	12632	33	0	\N
360152	1874	29262000	25551	12632	34	0	\N
360153	1874	29265000	25551	12632	35	0	\N
360154	1874	29268000	25551	12632	36	0	\N
360155	1874	29271000	25551	12632	37	0	\N
360156	1874	29274000	25551	12632	38	0	\N
360157	1874	29277000	25551	12632	39	0	\N
360158	1874	29280000	25551	12632	40	0	\N
360159	1874	29283000	25551	12632	41	0	\N
360160	1874	29286000	25551	12632	42	0	\N
360161	1874	29289000	25551	12632	43	0	\N
360162	1874	29292000	25551	12632	44	0	\N
360163	1874	29294000	25551	12632	45	0	\N
360164	1874	29296000	25551	12632	46	0	\N
360165	1874	29298000	25551	12632	47	0	\N
360166	1874	29300000	25551	12632	48	0	\N
360167	1874	29302000	25551	12632	50	0	\N
360168	1874	29305000	25551	12632	51	0	\N
360169	1874	29308000	25551	12632	52	0	\N
360170	1874	29311000	25551	12632	53	0	\N
360171	1874	29314000	25551	12632	54	0	\N
360172	1874	29317000	25551	12632	55	0	\N
360173	1874	29320000	25551	12632	56	0	\N
360174	1874	29323000	25551	12632	57	0	\N
360175	1874	29325000	25551	12632	58	0	\N
360176	1874	29327000	25551	12632	59	0	\N
360177	1874	29329000	25551	12632	60	0	\N
360178	1874	29331000	25551	12632	61	0	\N
360179	1874	29333000	25551	12632	62	0	\N
360180	1874	29335000	25551	12632	63	0	\N
360181	1874	29337000	25551	12632	64	0	\N
360182	1874	29339000	25551	12632	65	0	\N
360183	1874	29341000	25551	12632	66	0	\N
360184	1874	29343000	25551	12632	67	0	\N
360185	1874	29345000	25551	12632	68	0	\N
360186	1874	29347000	25551	12632	69	0	\N
360187	1874	29349000	25551	12632	70	0	\N
360188	1874	29351000	25551	12632	71	0	\N
360189	1874	29353000	25551	12632	72	0	\N
360190	1874	29355000	25551	12632	73	0	\N
360191	1874	29357000	25551	12632	74	0	\N
360192	1874	29359000	25551	12632	75	0	\N
360193	1874	29361000	25551	12632	76	0	\N
360194	1874	29363000	25551	12632	77	0	\N
360195	1874	29365000	25551	12632	78	0	\N
360199	1678	26640840333000	25554	12653	0	0	\N
360200	1678	26640840334000	25554	12653	1	0	\N
360201	1874	29372000	25554	12653	2	0	\N
360202	1874	29375000	25554	12653	3	0	\N
360203	1874	29378000	25554	12653	4	0	\N
360204	1874	29380000	25554	12653	5	0	\N
360211	1678	26640840272000	25556	12601	0	0	\N
360212	1678	26640840273000	25556	12601	1	0	\N
360213	1678	26640840274000	25556	12601	2	0	\N
360214	1678	26640840275000	25556	12601	3	0	\N
360215	1678	26640840276000	25556	12601	4	0	\N
360216	1678	26640840277000	25556	12601	5	0	\N
360217	1678	26640840278000	25556	12601	6	0	\N
360218	1678	26640840279000	25556	12601	7	0	\N
360219	1678	26640840280000	25556	12601	8	0	\N
360220	1678	26640840281000	25556	12601	9	0	\N
360221	1678	26640840282000	25556	12601	10	0	\N
360222	1678	26640840283000	25556	12601	11	0	\N
360223	1678	26640840284000	25556	12601	12	0	\N
360224	1678	26640840285000	25556	12601	13	0	\N
360225	1678	26640840286000	25556	12601	14	0	\N
360226	1678	26640840287000	25556	12601	15	0	\N
360227	1678	26640840288000	25556	12601	16	0	\N
360228	1678	26640840289000	25556	12601	17	0	\N
360229	1678	26640840290000	25556	12601	18	0	\N
360230	1678	26640840291000	25556	12601	19	0	\N
360231	1678	26640840292000	25556	12601	20	0	\N
360232	1678	26640840293000	25556	12601	21	0	\N
360233	1678	26640840294000	25556	12601	22	0	\N
360234	1678	26640840295000	25556	12601	23	0	\N
360235	1678	26640840296000	25556	12601	24	0	\N
360236	1678	26640840297000	25556	12601	25	0	\N
360237	1678	26640840298000	25556	12601	26	0	\N
360238	1678	26640840299000	25556	12601	27	0	\N
360239	1678	26640840300000	25556	12601	28	0	\N
360240	1678	26640840301000	25556	12601	29	0	\N
360241	1678	26640840302000	25556	12601	30	0	\N
360242	1678	26640840303000	25556	12601	31	0	\N
360243	1678	26640840304000	25556	12601	32	0	\N
360244	1678	26640840305000	25556	12601	33	0	\N
360245	1678	26640840306000	25556	12601	34	0	\N
360246	1678	26640840307000	25556	12601	35	0	\N
360247	1678	26640840308000	25556	12601	36	0	\N
360248	1678	26640840309000	25556	12601	37	0	\N
360249	1678	26640840310000	25556	12601	38	0	\N
360250	1678	26640840311000	25556	12601	39	0	\N
360251	1678	26640840312000	25556	12601	40	0	\N
360252	1678	26640840313000	25556	12601	41	0	\N
360253	1678	26640840314000	25556	12601	42	0	\N
360254	1678	26640840315000	25556	12601	43	0	\N
360255	1678	26640840316000	25556	12601	44	0	\N
360256	1678	26640840317000	25556	12601	45	0	\N
360257	1678	26640840318000	25556	12601	46	0	\N
360258	1678	26640840319000	25556	12601	47	0	\N
360259	1678	26640840320000	25556	12601	48	0	\N
360260	1678	26640840321000	25556	12601	49	0	\N
360261	1678	26640840322000	25556	12601	50	0	\N
360262	1678	26640840323000	25556	12601	51	0	\N
360263	1678	26640840324000	25556	12601	52	0	\N
360264	1678	26640840325000	25556	12601	53	0	\N
360198	1874	29370000	25552	12652	2	0	2
360205	1678	26640840333000	25555	12653	0	0	0
360206	1678	26640840334000	25555	12653	1	0	0
360207	1874	29372000	25555	12653	2	0	2
360208	1874	29375000	25555	12653	3	0	2
360210	1874	29380000	25555	12653	5	0	2
360265	1678	26640840326000	25556	12601	54	0	\N
360266	1678	26640840327000	25556	12601	55	0	\N
360267	1678	26640840328000	25556	12601	56	0	\N
360268	1678	26640840329000	25556	12601	57	0	\N
360269	1678	26640840330000	25556	12601	58	0	\N
360270	1678	26640840331000	25556	12601	59	0	\N
360271	1678	26640840332000	25556	12601	60	0	\N
360272	1678	26640840333000	25556	12601	61	0	\N
360273	1678	26640840334000	25556	12601	62	0	\N
360274	2152	107988998000000	25556	12601	63	0	\N
360275	1874	29063000	25556	12601	64	0	\N
360276	1874	29065000	25556	12601	65	0	\N
360277	1483	11000000	25556	12601	66	0	\N
360278	1483	11000000	25556	12601	67	0	\N
360279	1874	29067000	25556	12601	68	0	\N
360280	1874	29070000	25556	12601	69	0	\N
360281	1874	29073000	25556	12601	70	0	\N
360282	1874	29074000	25556	12601	71	0	\N
360283	1874	29075000	25556	12601	72	0	\N
360284	1874	29076000	25556	12601	73	0	\N
360285	1874	29077000	25556	12601	74	0	\N
360286	1874	29079000	25556	12601	75	0	\N
360287	1874	29081000	25556	12601	76	0	\N
360288	1874	29083000	25556	12601	77	0	\N
360289	1874	29085000	25556	12601	78	0	\N
360290	1874	29087000	25556	12601	79	0	\N
360291	1874	29089000	25556	12601	80	0	\N
360292	1874	29091000	25556	12601	81	0	\N
360293	1874	29093000	25556	12601	82	0	\N
360294	1874	29095000	25556	12601	83	0	\N
360295	1874	29097000	25556	12601	84	0	\N
360296	1874	29099000	25556	12601	85	0	\N
360297	1874	29101000	25556	12601	86	0	\N
360298	1874	29103000	25556	12601	87	0	\N
360299	1874	29105000	25556	12601	88	0	\N
360300	1874	29108000	25556	12601	89	0	\N
360301	1874	29111000	25556	12601	90	0	\N
360302	1874	29114000	25556	12601	91	0	\N
360303	1874	29117000	25556	12601	92	0	\N
360304	1874	29120000	25556	12601	93	0	\N
360305	1874	29123000	25556	12601	95	0	\N
360306	1874	29126000	25556	12601	96	0	\N
360307	1874	29129000	25556	12601	97	0	\N
360308	1874	29132000	25556	12601	98	0	\N
360309	1874	29135000	25556	12601	99	0	\N
360310	1874	29138000	25556	12601	100	0	\N
360311	1874	29141000	25556	12601	101	0	\N
360312	1874	29144000	25556	12601	102	0	\N
360313	1874	29147000	25556	12601	103	0	\N
360314	1874	29150000	25556	12601	104	0	\N
360315	1874	29153000	25556	12601	105	0	\N
360316	1874	29156000	25556	12601	106	0	\N
360317	1874	29159000	25556	12601	107	0	\N
360318	1874	29162000	25556	12601	108	0	\N
360319	1874	29165000	25556	12601	109	0	\N
360320	1874	29168000	25556	12601	110	0	\N
360321	1874	29171000	25556	12601	111	0	\N
360322	1874	29174000	25556	12601	112	0	\N
360323	1874	29177000	25556	12601	113	0	\N
360324	1874	29180000	25556	12601	114	0	\N
360325	1874	29183000	25556	12601	115	0	\N
360326	1874	29186000	25556	12601	116	0	\N
360327	1874	29189000	25556	12601	117	0	\N
360328	1874	29192000	25556	12601	118	0	\N
360329	1874	29195000	25556	12601	119	0	\N
360330	1874	29198000	25556	12601	120	0	\N
360331	1874	29201000	25556	12601	121	0	\N
360332	1874	29204000	25556	12601	122	0	\N
360333	1874	29207000	25556	12601	123	0	\N
360334	1874	29210000	25556	12601	124	0	\N
360335	1874	29213000	25556	12601	125	0	\N
360345	1678	26640840338000	25560	12656	0	0	\N
360346	1874	29397000	25560	12656	1	0	\N
360347	1874	29400000	25560	12656	2	0	\N
360348	1678	26640840338000	25561	12656	0	0	\N
360349	1874	29397000	25561	12656	1	0	\N
360350	1874	29400000	25561	12656	2	0	\N
360354	1678	26640840338000	25563	12656	0	0	\N
360355	1874	29397000	25563	12656	1	0	\N
360356	1874	29400000	25563	12656	2	0	\N
360357	1678	26640840338000	25564	12656	0	0	\N
360358	1874	29397000	25564	12656	1	0	\N
360359	1874	29400000	25564	12656	2	0	\N
360369	1678	26640840339000	25566	12657	0	0	\N
360370	1678	26640840340000	25566	12657	1	0	\N
360371	1678	26640840341000	25566	12657	2	0	\N
360372	1874	29402000	25566	12657	3	0	\N
360373	1874	29404000	25566	12657	4	0	\N
360374	1874	29406000	25566	12657	5	0	\N
360375	1874	29409000	25566	12657	6	0	\N
360376	1874	29412000	25566	12657	7	0	\N
360377	1874	29415000	25566	12657	8	0	\N
360378	1678	26640840339000	25567	12657	0	0	\N
360379	1678	26640840340000	25567	12657	1	0	\N
360380	1678	26640840341000	25567	12657	2	0	\N
360381	1874	29402000	25567	12657	3	0	\N
360382	1874	29404000	25567	12657	4	0	\N
360383	1874	29406000	25567	12657	5	0	\N
360384	1874	29409000	25567	12657	6	0	\N
360385	1874	29412000	25567	12657	7	0	\N
360386	1874	29415000	25567	12657	8	0	\N
360399	1678	26640840345000	25571	12660	0	0	\N
360400	1678	26640840346000	25571	12660	1	0	\N
360338	1874	29385000	25557	12654	2	0	2
360339	1678	26640840336000	25558	12655	0	0	0
360340	1678	26640840337000	25558	12655	1	0	0
360341	1874	29388000	25558	12655	2	0	2
360342	1874	29391000	25558	12655	3	0	2
360344	1874	29395000	25558	12655	5	0	2
360351	1678	26640840338000	25562	12656	0	0	0
360352	1874	29397000	25562	12656	1	0	2
360353	1874	29400000	25562	12656	2	0	2
360360	1678	26640840339000	25565	12657	0	0	0
360362	1678	26640840341000	25565	12657	2	0	0
360363	1874	29402000	25565	12657	3	0	2
360364	1874	29404000	25565	12657	4	0	2
360365	1874	29406000	25565	12657	5	0	2
360367	1874	29412000	25565	12657	7	0	2
360368	1874	29415000	25565	12657	8	0	2
360387	1678	26640840342000	25568	12658	0	0	0
360388	1678	26640840343000	25568	12658	1	0	0
360389	1874	29418000	25568	12658	2	0	2
360391	1874	29423000	25568	12658	4	0	2
360392	1874	29425000	25568	12658	5	0	2
360393	1678	26640840344000	25569	12659	0	0	0
360394	1874	29428000	25569	12659	1	0	2
360395	1874	29430000	25569	12659	2	0	2
360397	1678	26640840346000	25570	12660	1	0	0
360398	1678	26640840347000	25570	12660	2	0	0
360401	1678	26640840347000	25571	12660	2	0	\N
360402	1678	26640840345000	25572	12660	0	0	\N
360403	1678	26640840346000	25572	12660	1	0	\N
360404	1678	26640840347000	25572	12660	2	0	\N
360405	1874	29433000	25572	12660	4	0	\N
360406	1874	29436000	25572	12660	5	0	\N
360407	1874	29438000	25572	12660	6	0	\N
360408	1874	29440000	25572	12660	7	0	\N
360409	1874	29443000	25572	12660	8	0	\N
360410	1874	29445000	25572	12660	9	0	\N
360411	1678	26640840345000	25573	12660	0	0	\N
360412	1678	26640840346000	25573	12660	1	0	\N
360413	1678	26640840347000	25573	12660	2	0	\N
360414	1874	29433000	25573	12660	4	0	\N
360415	1874	29436000	25573	12660	5	0	\N
360416	1874	29438000	25573	12660	6	0	\N
360417	1874	29440000	25573	12660	7	0	\N
360418	1874	29443000	25573	12660	8	0	\N
360419	1874	29445000	25573	12660	9	0	\N
360420	1678	26640840345000	25574	12660	0	0	\N
360421	1678	26640840346000	25574	12660	1	0	\N
360422	1678	26640840347000	25574	12660	2	0	\N
360423	1874	29433000	25574	12660	4	0	\N
360424	1874	29436000	25574	12660	5	0	\N
360425	1874	29438000	25574	12660	6	0	\N
360426	1874	29440000	25574	12660	7	0	\N
360427	1874	29443000	25574	12660	8	0	\N
360428	1874	29445000	25574	12660	9	0	\N
360429	1678	26640840345000	25575	12660	0	0	\N
360430	1678	26640840346000	25575	12660	1	0	\N
360431	1678	26640840347000	25575	12660	2	0	\N
360432	1874	29433000	25575	12660	4	0	\N
360433	1874	29436000	25575	12660	5	0	\N
360434	1874	29438000	25575	12660	6	0	\N
360435	1874	29440000	25575	12660	7	0	\N
360436	1874	29443000	25575	12660	8	0	\N
360437	1874	29445000	25575	12660	9	0	\N
360456	1678	26640840351000	25578	12662	0	0	\N
360457	1874	29462000	25578	12662	1	0	\N
360458	1874	29465000	25578	12662	2	0	\N
360459	1678	26640840351000	25579	12662	0	0	\N
360460	1874	29462000	25579	12662	1	0	\N
360461	1874	29465000	25579	12662	2	0	\N
360462	1678	26640840352000	25581	12663	0	0	\N
360463	1874	29468000	25581	12663	1	0	\N
360464	1874	29470000	25581	12663	2	0	\N
360468	2152	107988998000000	25586	12591	0	0	\N
360469	1483	11000000	25586	12591	1	0	\N
360470	1483	11000000	25586	12591	2	0	\N
360471	1678	26640840353000	25587	12664	0	0	\N
360472	1678	26640840354000	25587	12664	1	0	\N
360473	1678	26640840355000	25587	12664	2	0	\N
360474	1678	26640840356000	25587	12664	3	0	\N
360475	1874	29473000	25587	12664	4	0	\N
360476	1874	29476000	25587	12664	5	0	\N
360477	1874	29478000	25587	12664	6	0	\N
360478	1874	29481000	25587	12664	7	0	\N
360479	1874	29484000	25587	12664	8	0	\N
360480	1874	29486000	25587	12664	9	0	\N
360481	1874	29488000	25587	12664	10	0	\N
360482	1874	29490000	25587	12664	11	0	\N
360495	1678	26640840357000	25589	12665	0	0	\N
360496	1874	29492000	25589	12665	1	0	\N
360497	1874	29495000	25589	12665	2	0	\N
360507	1678	26640840360000	25593	12668	0	0	\N
360508	1874	29508000	25593	12668	1	0	\N
360512	1678	26640840361000	25596	12669	0	0	\N
360513	1874	29513000	25596	12669	1	0	\N
360523	1678	26640840362000	25601	12670	0	0	\N
360524	1678	26640840363000	25601	12670	1	0	\N
360525	1874	29518000	25601	12670	2	0	\N
360526	1874	29520000	25601	12670	3	0	\N
360527	1874	29522000	25601	12670	4	0	\N
360528	1874	29525000	25601	12670	5	0	\N
360535	1678	26640840366000	25603	12672	0	0	\N
360536	1678	26640840367000	25603	12672	1	0	\N
360440	1678	26640840350000	25576	12661	2	0	0
360441	1874	29433000	25576	12661	3	0	2
360442	1874	29436000	25576	12661	4	0	2
360443	1874	29438000	25576	12661	5	0	2
360444	1874	29440000	25576	12661	6	0	2
360446	1874	29445000	25576	12661	8	0	2
360447	1874	29447000	25576	12661	9	0	2
360448	1874	29449000	25576	12661	10	0	2
360449	1874	29451000	25576	12661	11	0	2
360450	1874	29454000	25576	12661	12	0	2
360452	1874	29460000	25576	12661	14	0	2
360453	1678	26640840351000	25577	12662	0	0	0
360454	1874	29462000	25577	12662	1	0	2
360455	1874	29465000	25577	12662	2	0	2
360466	1874	29468000	25583	12663	1	0	2
360467	1874	29470000	25583	12663	2	0	2
360483	1678	26640840353000	25588	12664	0	0	0
360484	1678	26640840354000	25588	12664	1	0	0
360485	1678	26640840355000	25588	12664	2	0	0
360487	1874	29473000	25588	12664	4	0	2
360488	1874	29476000	25588	12664	5	0	2
360489	1874	29478000	25588	12664	6	0	2
360490	1874	29481000	25588	12664	7	0	2
360491	1874	29484000	25588	12664	8	0	2
360493	1874	29488000	25588	12664	10	0	2
360494	1874	29490000	25588	12664	11	0	2
360498	1678	26640840357000	25590	12665	0	0	0
360499	1874	29492000	25590	12665	1	0	2
360501	1678	26640840358000	25591	12666	0	0	0
360502	1874	29498000	25591	12666	1	0	2
360503	1678	26640840359000	25592	12667	0	0	0
360504	1874	29500000	25592	12667	1	0	2
360505	1874	29503000	25592	12667	2	0	2
360509	1678	26640840360000	25594	12668	0	0	0
360510	1874	29507000	25594	12668	1	0	2
360511	1874	29510000	25594	12668	2	0	2
360514	1678	26640840361000	25599	12669	0	0	0
360515	1874	29513000	25599	12669	1	0	2
360517	1678	26640840362000	25600	12670	0	0	0
360518	1678	26640840363000	25600	12670	1	0	0
360519	1874	29518000	25600	12670	2	0	2
360520	1874	29520000	25600	12670	3	0	2
360522	1874	29525000	25600	12670	5	0	2
360529	1678	26640840364000	25602	12671	0	0	0
360530	1678	26640840365000	25602	12671	1	0	0
360531	1874	29527000	25602	12671	2	0	2
360532	1874	29530000	25602	12671	3	0	2
360534	1874	29535000	25602	12671	5	0	2
360537	1874	29538000	25603	12672	2	0	\N
360538	1874	29541000	25603	12672	3	0	\N
360539	1874	29543000	25603	12672	4	0	\N
360540	1874	29545000	25603	12672	5	0	\N
360541	1678	26640840366000	25604	12672	0	0	\N
360542	1678	26640840367000	25604	12672	1	0	\N
360543	1874	29538000	25604	12672	2	0	\N
360544	1874	29541000	25604	12672	3	0	\N
360545	1874	29543000	25604	12672	4	0	\N
360546	1874	29545000	25604	12672	5	0	\N
360560	1678	26640840369000	25609	12674	0	0	\N
360561	1678	26640840370000	25609	12674	1	0	\N
360562	1874	29553000	25609	12674	2	0	\N
360563	1874	29556000	25609	12674	3	0	\N
360564	1874	29558000	25609	12674	4	0	\N
360565	1874	29560000	25609	12674	5	0	\N
360566	1678	26640840371000	25610	12675	0	0	\N
360567	1874	29559000	25610	12675	1	0	\N
360568	1874	29561000	25610	12675	2	0	\N
360569	1874	29563000	25610	12675	3	0	\N
360570	1874	29565000	25610	12675	4	0	\N
360576	1678	26640840372000	25612	12676	0	0	\N
360577	1874	29567000	25612	12676	1	0	\N
360578	1874	29570000	25612	12676	2	0	\N
360582	1678	26640840372000	25614	12676	0	0	\N
360583	1874	29567000	25614	12676	1	0	\N
360584	1874	29570000	25614	12676	2	0	\N
360588	1678	26640840373000	25616	12677	0	0	\N
360589	1874	29573000	25616	12677	1	0	\N
360590	1874	29575000	25616	12677	2	0	\N
360591	1678	26640840373000	25617	12677	0	0	\N
360592	1874	29573000	25617	12677	1	0	\N
360593	1874	29575000	25617	12677	2	0	\N
360594	1678	26640840373000	25618	12677	0	0	\N
360595	1874	29573000	25618	12677	1	0	\N
360596	1874	29575000	25618	12677	2	0	\N
360612	1678	26640840378000	25623	12680	0	0	\N
360613	1678	26640840379000	25623	12680	1	0	\N
360614	1874	29598000	25623	12680	2	0	\N
360615	1874	29600000	25623	12680	3	0	\N
360616	1874	29602000	25623	12680	4	0	\N
360617	1874	29605000	25623	12680	5	0	\N
360618	1678	26640840378000	25624	12681	0	0	\N
360619	1678	26640840379000	25624	12681	1	0	\N
360620	1678	26640840380000	25624	12681	2	0	\N
360621	1678	26640840381000	25624	12681	3	0	\N
360622	1874	29604000	25624	12681	4	0	\N
360623	1874	29607000	25624	12681	5	0	\N
360624	1874	29609000	25624	12681	6	0	\N
360625	1874	29611000	25624	12681	7	0	\N
360626	1874	29613000	25624	12681	8	0	\N
360627	1874	29615000	25624	12681	9	0	\N
360638	1678	26640840378000	25626	12681	0	0	\N
360639	1678	26640840379000	25626	12681	1	0	\N
360640	1678	26640840380000	25626	12681	2	0	\N
360641	1678	26640840381000	25626	12681	3	0	\N
360642	1874	29604000	25626	12681	4	0	\N
360643	1874	29607000	25626	12681	5	0	\N
360644	1874	29609000	25626	12681	6	0	\N
360645	1874	29611000	25626	12681	7	0	\N
360646	1874	29613000	25626	12681	8	0	\N
360647	1874	29615000	25626	12681	9	0	\N
360648	1678	26640840378000	25627	12681	0	0	\N
360649	1678	26640840379000	25627	12681	1	0	\N
360650	1678	26640840380000	25627	12681	2	0	\N
360651	1678	26640840381000	25627	12681	3	0	\N
360652	1874	29604000	25627	12681	4	0	\N
360653	1874	29607000	25627	12681	5	0	\N
360654	1874	29609000	25627	12681	6	0	\N
360655	1874	29611000	25627	12681	7	0	\N
360656	1874	29613000	25627	12681	8	0	\N
360657	1874	29615000	25627	12681	9	0	\N
360672	1678	26640840387000	25631	12685	0	0	\N
360549	1874	29538000	25605	12672	2	0	2
360550	1874	29541000	25605	12672	3	0	2
360551	1874	29543000	25605	12672	4	0	2
360552	1874	29545000	25605	12672	5	0	2
360553	1678	26640840368000	25606	12673	0	0	0
360555	1874	29550000	25606	12673	2	0	2
360556	1678	26640840369000	25608	12674	0	0	0
360557	1678	26640840370000	25608	12674	1	0	0
360558	1874	29553000	25608	12674	2	0	2
360559	1874	29556000	25608	12674	3	0	2
360572	1874	29559000	25611	12675	1	0	2
360573	1874	29561000	25611	12675	2	0	2
360574	1874	29563000	25611	12675	3	0	2
360575	1874	29565000	25611	12675	4	0	2
360580	1874	29567000	25613	12676	1	0	2
360581	1874	29570000	25613	12676	2	0	2
360585	1678	26640840373000	25615	12677	0	0	0
360586	1874	29573000	25615	12677	1	0	2
360587	1874	29575000	25615	12677	2	0	2
360598	1678	26640840375000	25619	12678	1	0	0
360599	2232	10200000000	25619	12678	2	0	0
360600	1874	29578000	25619	12678	3	0	2
360601	1874	29581000	25619	12678	4	0	2
360602	1874	29583000	25619	12678	5	0	2
360604	1678	26640840376000	25621	12679	0	0	0
360605	1678	26640840377000	25621	12679	1	0	0
360606	1874	29587000	25621	12679	2	0	2
360607	1874	29589000	25621	12679	3	0	2
360609	1874	29595000	25621	12679	5	0	2
360610	1874	29598000	25622	12680	0	0	2
360611	1874	29601000	25622	12680	1	0	2
360628	1678	26640840378000	25625	12681	0	0	0
360629	1678	26640840379000	25625	12681	1	0	0
360631	1678	26640840381000	25625	12681	3	0	0
360632	1874	29604000	25625	12681	4	0	2
360633	1874	29607000	25625	12681	5	0	2
360634	1874	29609000	25625	12681	6	0	2
360635	1874	29611000	25625	12681	7	0	2
360637	1874	29615000	25625	12681	9	0	2
360658	1678	26640840382000	25628	12682	0	0	0
360659	1678	26640840383000	25628	12682	1	0	0
360660	1874	29618000	25628	12682	2	0	2
360662	1874	29623000	25628	12682	4	0	2
360663	1874	29625000	25628	12682	5	0	2
360664	1678	26640840384000	25629	12683	0	0	0
360665	1678	26640840385000	25629	12683	1	0	0
360666	1874	29627000	25629	12683	2	0	2
360668	1874	29632000	25629	12683	4	0	2
360669	1678	26640840386000	25630	12684	0	0	0
360670	1874	29634000	25630	12684	1	0	2
360671	1874	29637000	25630	12684	2	0	2
360673	1678	26640840388000	25631	12685	1	0	\N
360674	1874	29640000	25631	12685	2	0	\N
360675	1874	29642000	25631	12685	3	0	\N
360676	1874	29644000	25631	12685	4	0	\N
360677	1874	29647000	25631	12685	5	0	\N
360690	1678	26640840391000	25634	12687	0	0	\N
360691	1678	26640840392000	25634	12687	1	0	\N
360692	1678	26640840393000	25634	12687	2	0	\N
360693	1678	26640840394000	25634	12687	3	0	\N
360694	1874	29659000	25634	12687	4	0	\N
360695	1874	29662000	25634	12687	5	0	\N
360696	1874	29664000	25634	12687	6	0	\N
360697	1874	29667000	25634	12687	7	0	\N
360698	1874	29670000	25634	12687	8	0	\N
360699	1874	29672000	25634	12687	9	0	\N
360700	1874	29674000	25634	12687	10	0	\N
360701	1874	29677000	25634	12687	11	0	\N
360714	1678	26640840395000	25636	12688	0	0	\N
360715	1874	29680000	25636	12688	1	0	\N
360716	1874	29682000	25636	12688	2	0	\N
360717	1678	26640840395000	25637	12688	0	0	\N
360718	1874	29680000	25637	12688	1	0	\N
360719	1874	29682000	25637	12688	2	0	\N
360726	1678	26640840397000	25640	12690	0	0	\N
360727	1874	29690000	25640	12690	1	0	\N
360728	1874	29692000	25640	12690	2	0	\N
360732	1678	26640840397000	25642	12690	0	0	\N
360733	1874	29690000	25642	12690	1	0	\N
360734	1874	29692000	25642	12690	2	0	\N
360735	1678	26640840332000	25643	12633	0	0	\N
360736	1678	26640840333000	25643	12633	1	0	\N
360737	1678	26640840334000	25643	12633	2	0	\N
360738	1678	26640840335000	25643	12633	3	0	\N
360739	1678	26640840336000	25643	12633	4	0	\N
360740	1678	26640840337000	25643	12633	5	0	\N
360741	1678	26640840338000	25643	12633	6	0	\N
360742	1678	26640840339000	25643	12633	7	0	\N
360743	1678	26640840340000	25643	12633	8	0	\N
360744	1678	26640840341000	25643	12633	9	0	\N
360745	1678	26640840342000	25643	12633	10	0	\N
360746	1678	26640840343000	25643	12633	11	0	\N
360747	1678	26640840344000	25643	12633	12	0	\N
360748	1678	26640840345000	25643	12633	13	0	\N
360749	1678	26640840346000	25643	12633	14	0	\N
360750	1678	26640840347000	25643	12633	15	0	\N
360751	1678	26640840348000	25643	12633	16	0	\N
360752	1678	26640840349000	25643	12633	17	0	\N
360753	1678	26640840350000	25643	12633	18	0	\N
360754	1678	26640840351000	25643	12633	19	0	\N
360755	1678	26640840352000	25643	12633	20	0	\N
360756	1678	26640840353000	25643	12633	21	0	\N
360757	1678	26640840354000	25643	12633	22	0	\N
360758	1678	26640840355000	25643	12633	23	0	\N
360759	1678	26640840356000	25643	12633	24	0	\N
360760	1678	26640840357000	25643	12633	25	0	\N
360761	1678	26640840358000	25643	12633	26	0	\N
360762	1678	26640840359000	25643	12633	27	0	\N
360763	1678	26640840360000	25643	12633	28	0	\N
360764	1678	26640840361000	25643	12633	29	0	\N
360765	1678	26640840362000	25643	12633	30	0	\N
360766	1678	26640840363000	25643	12633	31	0	\N
360767	1678	26640840364000	25643	12633	32	0	\N
360768	1678	26640840365000	25643	12633	33	0	\N
360769	1678	26640840366000	25643	12633	34	0	\N
360770	1678	26640840367000	25643	12633	35	0	\N
360771	1678	26640840368000	25643	12633	36	0	\N
360772	1678	26640840369000	25643	12633	37	0	\N
360773	1678	26640840370000	25643	12633	38	0	\N
360774	1678	26640840371000	25643	12633	39	0	\N
360775	1678	26640840372000	25643	12633	40	0	\N
360776	1678	26640840373000	25643	12633	41	0	\N
360777	1678	26640840374000	25643	12633	42	0	\N
360778	1678	26640840375000	25643	12633	43	0	\N
360779	1678	26640840376000	25643	12633	44	0	\N
360780	1678	26640840377000	25643	12633	45	0	\N
360781	1678	26640840378000	25643	12633	46	0	\N
360782	1678	26640840379000	25643	12633	47	0	\N
360783	1678	26640840380000	25643	12633	48	0	\N
360784	1678	26640840381000	25643	12633	49	0	\N
360785	1678	26640840382000	25643	12633	50	0	\N
360786	1678	26640840383000	25643	12633	51	0	\N
360787	1678	26640840384000	25643	12633	52	0	\N
360788	1678	26640840385000	25643	12633	53	0	\N
360789	1678	26640840386000	25643	12633	54	0	\N
360790	1678	26640840387000	25643	12633	55	0	\N
360791	1678	26640840388000	25643	12633	56	0	\N
360792	1678	26640840389000	25643	12633	57	0	\N
360793	1678	26640840390000	25643	12633	58	0	\N
360794	1678	26640840391000	25643	12633	59	0	\N
360795	1678	26640840392000	25643	12633	60	0	\N
360796	1678	26640840393000	25643	12633	61	0	\N
360797	1678	26640840394000	25643	12633	62	0	\N
360798	1678	26640840395000	25643	12633	63	0	\N
360799	1678	26640840396000	25643	12633	64	0	\N
360800	1678	26640840397000	25643	12633	65	0	\N
360801	2232	10200000000	25643	12633	66	0	\N
360802	1874	29368000	25643	12633	67	0	\N
360803	1874	29371000	25643	12633	68	0	\N
360804	1874	29374000	25643	12633	69	0	\N
360805	1874	29377000	25643	12633	70	0	\N
360806	1874	29380000	25643	12633	71	0	\N
360807	1874	29383000	25643	12633	72	0	\N
360808	1874	29385000	25643	12633	73	0	\N
360680	1874	29640000	25632	12685	2	0	2
360681	1874	29642000	25632	12685	3	0	2
360682	1874	29644000	25632	12685	4	0	2
360683	1874	29647000	25632	12685	5	0	2
360684	1678	26640840389000	25633	12686	0	0	0
360686	1874	29650000	25633	12686	2	0	2
360687	1874	29653000	25633	12686	3	0	2
360688	1874	29655000	25633	12686	4	0	2
360689	1874	29657000	25633	12686	5	0	2
360702	1678	26640840391000	25635	12687	0	0	0
360704	1678	26640840393000	25635	12687	2	0	0
360705	1678	26640840394000	25635	12687	3	0	0
360706	1874	29659000	25635	12687	4	0	2
360707	1874	29662000	25635	12687	5	0	2
360709	1874	29667000	25635	12687	7	0	2
360710	1874	29670000	25635	12687	8	0	2
360711	1874	29672000	25635	12687	9	0	2
360712	1874	29674000	25635	12687	10	0	2
360713	1874	29677000	25635	12687	11	0	2
360721	1874	29680000	25638	12688	1	0	2
360722	1874	29682000	25638	12688	2	0	2
360723	1678	26640840396000	25639	12689	0	0	0
360724	1874	29685000	25639	12689	1	0	2
360725	1874	29687000	25639	12689	2	0	2
360730	1874	29690000	25641	12690	1	0	2
360731	1874	29692000	25641	12690	2	0	2
360809	1874	29387000	25643	12633	74	0	\N
360810	1874	29390000	25643	12633	75	0	\N
360811	1874	29393000	25643	12633	76	0	\N
360812	1874	29396000	25643	12633	77	0	\N
360813	1874	29398000	25643	12633	78	0	\N
360814	1874	29400000	25643	12633	79	0	\N
360815	1874	29402000	25643	12633	80	0	\N
360816	1874	29404000	25643	12633	81	0	\N
360817	1874	29406000	25643	12633	82	0	\N
360818	1874	29408000	25643	12633	83	0	\N
360819	1874	29410000	25643	12633	84	0	\N
360820	1874	29412000	25643	12633	85	0	\N
360821	1874	29414000	25643	12633	86	0	\N
360822	1874	29417000	25643	12633	87	0	\N
360823	1874	29420000	25643	12633	88	0	\N
360824	1874	29423000	25643	12633	89	0	\N
360825	1874	29426000	25643	12633	90	0	\N
360826	1874	29429000	25643	12633	91	0	\N
360827	1874	29432000	25643	12633	92	0	\N
360828	1874	29435000	25643	12633	93	0	\N
360829	1874	29437000	25643	12633	94	0	\N
360830	1874	29439000	25643	12633	95	0	\N
360831	1874	29441000	25643	12633	97	0	\N
360832	1874	29443000	25643	12633	98	0	\N
360833	1874	29445000	25643	12633	99	0	\N
360834	1874	29447000	25643	12633	100	0	\N
360835	1874	29449000	25643	12633	101	0	\N
360836	1874	29451000	25643	12633	102	0	\N
360837	1874	29453000	25643	12633	103	0	\N
360838	1874	29455000	25643	12633	104	0	\N
360839	1874	29457000	25643	12633	105	0	\N
360840	1874	29459000	25643	12633	106	0	\N
360841	1874	29461000	25643	12633	107	0	\N
360842	1874	29463000	25643	12633	108	0	\N
360843	1874	29465000	25643	12633	109	0	\N
360844	1874	29467000	25643	12633	110	0	\N
360845	1874	29469000	25643	12633	111	0	\N
360846	1874	29471000	25643	12633	112	0	\N
360847	1874	29473000	25643	12633	113	0	\N
360848	1874	29475000	25643	12633	114	0	\N
360849	1874	29477000	25643	12633	115	0	\N
360850	1874	29479000	25643	12633	116	0	\N
360851	1874	29481000	25643	12633	117	0	\N
360852	1874	29483000	25643	12633	118	0	\N
360853	1874	29485000	25643	12633	119	0	\N
360854	1874	29487000	25643	12633	120	0	\N
360855	1874	29489000	25643	12633	121	0	\N
360856	1874	29491000	25643	12633	122	0	\N
360857	1678	26640840398000	25644	12691	0	0	\N
360858	1678	26640840399000	25644	12691	1	0	\N
360859	1874	29694000	25644	12691	2	0	\N
360860	1874	29697000	25644	12691	3	0	\N
360861	1874	29700000	25644	12691	4	0	\N
360862	1874	29702000	25644	12691	5	0	\N
360878	1678	26640840402000	25648	12693	0	0	\N
360879	1874	29715000	25648	12693	1	0	\N
360880	1874	29717000	25648	12693	2	0	\N
360881	1678	26640840402000	25649	12693	0	0	\N
360882	1874	29715000	25649	12693	1	0	\N
360883	1874	29717000	25649	12693	2	0	\N
360884	1678	26640840403000	25650	12694	0	0	\N
360885	1874	29719000	25650	12694	1	0	\N
360886	2324	8000000000	25650	12694	2	0	\N
360887	1874	29722000	25650	12694	3	0	\N
360888	1678	26640840403000	25651	12694	0	0	\N
360889	2324	8000000000	25651	12694	1	0	\N
360890	1874	29720000	25651	12694	2	0	\N
360895	1874	29725000	25653	12695	0	0	\N
360901	1678	26640840405000	25656	12697	0	0	\N
360902	1678	26640840406000	25656	12697	1	0	\N
360903	1874	29735000	25656	12697	3	0	\N
360904	1874	29737000	25656	12697	4	0	\N
360905	1874	29739000	25656	12697	5	0	\N
360906	1874	29742000	25656	12697	6	0	\N
360907	1678	26640840405000	25657	12697	0	0	\N
360908	1678	26640840406000	25657	12697	1	0	\N
360909	1874	29735000	25657	12697	3	0	\N
360910	1874	29737000	25657	12697	4	0	\N
360911	1874	29739000	25657	12697	5	0	\N
360912	1874	29742000	25657	12697	6	0	\N
360944	1678	26640840415000	25662	12701	0	0	\N
360865	1874	29694000	25645	12691	2	0	2
360866	1874	29697000	25645	12691	3	0	2
360867	1874	29700000	25645	12691	4	0	2
360868	1874	29702000	25645	12691	5	0	2
360869	1678	26640840400000	25646	12692	0	0	0
360871	1874	29705000	25646	12692	2	0	2
360872	1874	29708000	25646	12692	3	0	2
360873	1874	29710000	25646	12692	4	0	2
360874	1874	29712000	25646	12692	5	0	2
360875	1678	26640840402000	25647	12693	0	0	0
360877	1874	29717000	25647	12693	2	0	2
360891	1678	26640840403000	25652	12694	0	0	0
360892	1874	29719000	25652	12694	1	0	2
360893	2324	8000000000	25652	12694	2	0	0
360896	1874	29725000	25654	12695	0	0	2
360897	1874	29727000	25654	12695	1	0	2
360898	1678	26640840404000	25655	12696	0	0	0
360899	1874	29730000	25655	12696	1	0	2
360900	1874	29732000	25655	12696	2	0	2
360914	1678	26640840406000	25658	12697	1	0	0
360915	1874	29735000	25658	12697	3	0	2
360916	1874	29737000	25658	12697	4	0	2
360917	1874	29739000	25658	12697	5	0	2
360918	1874	29742000	25658	12697	6	0	2
360920	1678	26640840408000	25659	12698	1	0	0
360921	1874	29744000	25659	12698	2	0	2
360922	2232	9179000000	25659	12698	3	0	1
360923	1874	29747000	25659	12698	4	0	2
360925	1874	29752000	25659	12698	6	0	2
360926	1678	26640840409000	25660	12699	0	0	0
360927	1678	26640840410000	25660	12699	1	0	0
360928	1678	26640840411000	25660	12699	2	0	0
360929	1678	26640840412000	25660	12699	3	0	0
360931	1874	29758000	25660	12699	5	0	2
360932	1874	29761000	25660	12699	6	0	2
360933	1874	29763000	25660	12699	7	0	2
360934	1874	29765000	25660	12699	8	0	2
360935	1874	29768000	25660	12699	9	0	2
360937	1874	29772000	25660	12699	11	0	2
360938	1678	26640840413000	25661	12700	0	0	0
360939	1678	26640840414000	25661	12700	1	0	0
360940	1874	29774000	25661	12700	2	0	2
360942	1874	29780000	25661	12700	4	0	2
360943	1874	29782000	25661	12700	5	0	2
360945	1874	29785000	25662	12701	1	0	\N
360946	1874	29787000	25662	12701	2	0	\N
360947	1678	26640840415000	25663	12701	0	0	\N
360948	1874	29785000	25663	12701	1	0	\N
360952	1678	26640840416000	25665	12702	0	0	\N
360953	1874	29790000	25665	12702	1	0	\N
360957	1678	26640840417000	25667	12703	0	0	\N
360958	1874	29795000	25667	12703	1	0	\N
360959	1874	29797000	25667	12703	2	0	\N
360960	1678	26640840417000	25668	12703	0	0	\N
360961	1874	29795000	25668	12703	1	0	\N
360962	1874	29797000	25668	12703	2	0	\N
360969	1678	26640840419000	25671	12705	0	0	\N
360970	1874	29805000	25671	12705	1	0	\N
360971	1874	29807000	25671	12705	2	0	\N
360972	1678	26640840419000	25672	12705	0	0	\N
360973	1874	29805000	25672	12705	1	0	\N
360977	1678	26640840420000	25674	12706	0	0	\N
360978	1874	29810000	25674	12706	1	0	\N
360979	1874	29812000	25674	12706	2	0	\N
360980	1678	26640840420000	25675	12706	0	0	\N
360981	1874	29810000	25675	12706	1	0	\N
360982	1874	29812000	25675	12706	2	0	\N
360985	1678	26640840420000	25677	12706	0	0	\N
360986	1874	29810000	25677	12706	1	0	\N
360987	1874	29812000	25677	12706	2	0	\N
360988	1678	26640840420000	25678	12706	0	0	\N
360989	1874	29808000	25678	12706	1	0	\N
360990	1874	29810000	25678	12706	2	0	\N
360991	1874	29812000	25678	12706	3	0	\N
360992	1678	26640840421000	25679	12707	0	0	\N
360993	1678	26640840422000	25679	12707	1	0	\N
360994	1678	26640840423000	25679	12707	2	0	\N
360995	1874	29813000	25679	12707	3	0	\N
360996	1874	29816000	25679	12707	4	0	\N
360997	1874	29819000	25679	12707	5	0	\N
360998	1678	26640840421000	25680	12707	0	0	\N
360999	1678	26640840422000	25680	12707	1	0	\N
361000	1678	26640840423000	25680	12707	2	0	\N
361001	1874	29813000	25680	12707	3	0	\N
361002	1874	29816000	25680	12707	4	0	\N
361003	1874	29819000	25680	12707	5	0	\N
361004	1678	26640840421000	25681	12707	0	0	\N
361005	1678	26640840422000	25681	12707	1	0	\N
361006	1678	26640840423000	25681	12707	2	0	\N
361007	1874	29812000	25681	12707	3	0	\N
361008	1874	29814000	25681	12707	4	0	\N
361009	1874	29816000	25681	12707	5	0	\N
361010	1874	29818000	25681	12707	6	0	\N
361011	1874	29821000	25681	12707	7	0	\N
361012	1874	29824000	25681	12707	8	0	\N
361013	1874	29827000	25681	12707	9	0	\N
361014	1678	26640840421000	25682	12707	0	0	\N
361015	1678	26640840422000	25682	12707	1	0	\N
361016	1678	26640840423000	25682	12707	2	0	\N
361017	1874	29812000	25682	12707	3	0	\N
361018	1874	29814000	25682	12707	4	0	\N
361019	1874	29816000	25682	12707	5	0	\N
361020	1874	29818000	25682	12707	6	0	\N
361021	1874	29821000	25682	12707	7	0	\N
361022	1874	29824000	25682	12707	8	0	\N
361023	1874	29827000	25682	12707	9	0	\N
361037	1678	26640840425000	25685	12709	0	0	\N
361038	1678	26640840426000	25685	12709	1	0	\N
361039	1874	29835000	25685	12709	2	0	\N
361040	1874	29837000	25685	12709	3	0	\N
361041	1874	29840000	25685	12709	4	0	\N
361042	1874	29842000	25685	12709	5	0	\N
361049	1678	26640840425000	25687	12709	0	0	\N
361050	1678	26640840426000	25687	12709	1	0	\N
361051	1874	29835000	25687	12709	2	0	\N
361052	1874	29837000	25687	12709	3	0	\N
361053	1874	29840000	25687	12709	4	0	\N
361054	1874	29842000	25687	12709	5	0	\N
361060	1678	26640840428000	25690	12711	0	0	\N
361061	1874	29847000	25690	12711	1	0	\N
361062	1874	29849000	25690	12711	2	0	\N
361079	1678	26640840434000	25693	12714	0	0	\N
361080	1874	29877000	25693	12714	1	0	\N
360951	1874	29787000	25664	12701	2	0	2
360954	1678	26640840416000	25666	12702	0	0	0
360955	1874	29789000	25666	12702	1	0	2
360956	1874	29792000	25666	12702	2	0	2
360963	1678	26640840417000	25669	12703	0	0	0
360965	1874	29797000	25669	12703	2	0	2
360966	1678	26640840418000	25670	12704	0	0	0
360967	1874	29800000	25670	12704	1	0	2
360968	1874	29802000	25670	12704	2	0	2
360974	1678	26640840419000	25673	12705	0	0	0
360976	1874	29807000	25673	12705	2	0	2
360983	1678	26640840420000	25676	12706	0	0	0
360984	1874	29810000	25676	12706	1	0	2
361024	1678	26640840421000	25683	12707	0	0	0
361026	1678	26640840423000	25683	12707	2	0	0
361027	1874	29812000	25683	12707	3	0	2
361028	1874	29814000	25683	12707	4	0	2
361029	1874	29816000	25683	12707	5	0	2
361030	1874	29818000	25683	12707	6	0	2
361032	1874	29824000	25683	12707	8	0	2
361033	1874	29827000	25683	12707	9	0	2
361034	1678	26640840424000	25684	12708	0	0	0
361035	1874	29829000	25684	12708	1	0	2
361036	1874	29832000	25684	12708	2	0	2
361044	1678	26640840426000	25686	12709	1	0	0
361045	1874	29835000	25686	12709	2	0	2
361046	1874	29837000	25686	12709	3	0	2
361047	1874	29840000	25686	12709	4	0	2
361055	1678	26640840427000	25688	12710	0	0	0
361056	1874	29844000	25688	12710	1	0	2
361057	1678	26640840428000	25689	12711	0	0	0
361058	1874	29847000	25689	12711	1	0	2
361059	1874	29849000	25689	12711	2	0	2
361064	1678	26640840430000	25691	12712	1	0	0
361065	1874	29852000	25691	12712	2	0	2
361066	1874	29854000	25691	12712	3	0	2
361067	1874	29856000	25691	12712	4	0	2
361068	1874	29859000	25691	12712	5	0	2
361070	1678	26640840432000	25692	12713	1	0	0
361071	1678	26640840433000	25692	12713	2	0	0
361072	1874	29862000	25692	12713	3	0	2
361073	1874	29864000	25692	12713	4	0	2
361075	1874	29868000	25692	12713	6	0	2
361076	1764	13043504100000	25692	12713	7	0	12
361077	1874	29871000	25692	12713	8	0	2
361078	1874	29874000	25692	12713	9	0	2
361081	1874	29879000	25693	12714	2	0	\N
361082	1678	26640840434000	25694	12714	0	0	\N
361083	1874	29877000	25694	12714	1	0	\N
361084	1874	29879000	25694	12714	2	0	\N
361088	2321	654500000000	25696	12480	0	0	\N
361089	1678	26640840435000	25697	12715	0	0	\N
361090	1874	29881000	25697	12715	2	0	\N
361091	1874	29884000	25697	12715	3	0	\N
361095	1678	26640840436000	25699	12716	0	0	\N
361096	1874	29886000	25699	12716	1	0	\N
361097	1874	29889000	25699	12716	2	0	\N
361098	1678	26640840436000	25700	12716	0	0	\N
361099	1874	29886000	25700	12716	1	0	\N
361100	1874	29889000	25700	12716	2	0	\N
361103	1678	26640840437000	25702	12717	0	0	\N
361104	1874	29889000	25702	12717	1	0	\N
361105	1874	29891000	25702	12717	2	0	\N
361106	1874	29894000	25702	12717	3	0	\N
361107	2232	10200000000	25703	12668	0	0	\N
361108	1764	12323456100000	25703	12668	1	0	\N
361113	1678	26640840438000	25705	12718	0	0	\N
361114	1874	29897000	25705	12718	1	0	\N
361115	1874	29899000	25705	12718	2	0	\N
361116	1678	26640840438000	25706	12718	0	0	\N
361117	1874	29897000	25706	12718	1	0	\N
361118	1874	29899000	25706	12718	2	0	\N
361122	1678	26640840438000	25708	12718	0	0	\N
361123	1874	29897000	25708	12718	1	0	\N
361124	1874	29899000	25708	12718	2	0	\N
361132	1678	26640840439000	25710	12719	0	0	\N
361133	1678	26640840440000	25710	12719	1	0	\N
361134	1874	29902000	25710	12719	2	0	\N
361135	1874	29904000	25710	12719	3	0	\N
361136	1874	29906000	25710	12719	4	0	\N
361137	1874	29909000	25710	12719	5	0	\N
361138	1874	29912000	25710	12719	6	0	\N
361139	1678	26640840439000	25711	12719	0	0	\N
361140	1678	26640840440000	25711	12719	1	0	\N
361141	1874	29902000	25711	12719	2	0	\N
361142	1874	29904000	25711	12719	3	0	\N
361143	1874	29906000	25711	12719	4	0	\N
361144	1874	29909000	25711	12719	5	0	\N
361145	1874	29912000	25711	12719	6	0	\N
361146	1678	26640840441000	25712	12720	0	0	\N
361147	1678	26640840442000	25712	12720	1	0	\N
361148	1678	26640840443000	25712	12720	2	0	\N
361149	1874	29914000	25712	12720	3	0	\N
361150	1874	29916000	25712	12720	4	0	\N
361151	1874	29918000	25712	12720	5	0	\N
361152	1678	26640840441000	25713	12720	0	0	\N
361153	1678	26640840442000	25713	12720	1	0	\N
361154	1678	26640840443000	25713	12720	2	0	\N
361155	1874	29914000	25713	12720	3	0	\N
361156	1874	29917000	25713	12720	4	0	\N
361157	1874	29920000	25713	12720	5	0	\N
361158	1874	29923000	25713	12720	6	0	\N
361159	1874	29925000	25713	12720	7	0	\N
361160	1874	29927000	25713	12720	8	0	\N
361170	1678	26640840441000	25715	12720	0	0	\N
361171	1678	26640840442000	25715	12720	1	0	\N
361172	1678	26640840443000	25715	12720	2	0	\N
361173	1874	29914000	25715	12720	3	0	\N
361174	1874	29917000	25715	12720	4	0	\N
361175	1874	29920000	25715	12720	5	0	\N
361176	1874	29923000	25715	12720	6	0	\N
361177	1874	29925000	25715	12720	7	0	\N
361178	1874	29927000	25715	12720	8	0	\N
361182	1678	26640840444000	25717	12721	0	0	\N
361183	1874	29930000	25717	12721	1	0	\N
361184	1874	29932000	25717	12721	2	0	\N
361188	1678	26640840445000	25719	12722	0	0	\N
361189	1874	29935000	25719	12722	1	0	\N
361190	1874	29937000	25719	12722	2	0	\N
361197	1678	26640840448000	25722	12725	0	0	\N
361198	1678	26640840449000	25722	12725	1	0	\N
361199	1874	29950000	25722	12725	2	0	\N
361200	1874	29953000	25722	12725	3	0	\N
361201	1874	29955000	25722	12725	4	0	\N
361202	1874	29957000	25722	12725	5	0	\N
361087	1874	29879000	25695	12714	2	0	2
361092	1678	26640840435000	25698	12715	0	0	0
361093	1874	29881000	25698	12715	2	0	2
361094	1874	29884000	25698	12715	3	0	2
361101	1678	26640840436000	25701	12716	0	0	0
361109	1678	26640840437000	25704	12717	0	0	0
361110	1874	29889000	25704	12717	1	0	2
361111	1874	29891000	25704	12717	2	0	2
361112	1874	29894000	25704	12717	3	0	2
361119	1678	26640840438000	25707	12718	0	0	0
361121	1874	29899000	25707	12718	2	0	2
361125	1678	26640840439000	25709	12719	0	0	0
361126	1678	26640840440000	25709	12719	1	0	0
361127	1874	29902000	25709	12719	2	0	2
361129	1874	29906000	25709	12719	4	0	2
361130	1874	29909000	25709	12719	5	0	2
361131	1874	29912000	25709	12719	6	0	2
361161	1678	26640840441000	25714	12720	0	0	0
361162	1678	26640840442000	25714	12720	1	0	0
361164	1874	29914000	25714	12720	3	0	2
361165	1874	29917000	25714	12720	4	0	2
361166	1874	29920000	25714	12720	5	0	2
361167	1874	29923000	25714	12720	6	0	2
361168	1874	29925000	25714	12720	7	0	2
361179	1678	26640840444000	25716	12721	0	0	0
361180	1874	29930000	25716	12721	1	0	2
361181	1874	29932000	25716	12721	2	0	2
361185	1678	26640840445000	25718	12722	0	0	0
361187	1874	29937000	25718	12722	2	0	2
361191	1678	26640840446000	25720	12723	0	0	0
361192	1874	29939000	25720	12723	1	0	2
361193	1874	29942000	25720	12723	2	0	2
361194	1678	26640840447000	25721	12724	0	0	0
361196	1874	29947000	25721	12724	2	0	2
361203	1678	26640840448000	25723	12725	0	0	0
361204	1678	26640840449000	25723	12725	1	0	0
361205	1874	29950000	25723	12725	2	0	2
361206	1874	29953000	25723	12725	3	0	2
361208	1874	29957000	25723	12725	5	0	2
361209	1678	26640840450000	25724	12726	0	0	0
361210	1874	29959000	25724	12726	1	0	2
361211	1874	29962000	25724	12726	2	0	2
361213	1874	29965000	25725	12727	1	0	2
361214	1874	29967000	25725	12727	2	0	2
361215	1678	26640840452000	25726	12728	0	0	0
361216	1678	26640840453000	25726	12728	1	0	0
361221	1678	26640840454000	25727	12729	0	0	\N
361222	1874	29979000	25727	12729	1	0	\N
361223	1874	29982000	25727	12729	2	0	\N
361236	1678	26640840458000	25730	12731	0	0	\N
361237	1874	30000000	25730	12731	1	0	\N
361238	1874	30002000	25730	12731	2	0	\N
361239	1678	26640840458000	25731	12731	0	0	\N
361240	1874	30000000	25731	12731	1	0	\N
361241	1874	30002000	25731	12731	2	0	\N
361254	1678	26640840460000	25735	12733	0	0	\N
361255	1678	26640840461000	25735	12733	1	0	\N
361256	1874	30009000	25735	12733	2	0	\N
361257	1874	30011000	25735	12733	3	0	\N
361258	1874	30014000	25735	12733	4	0	\N
361259	1874	30017000	25735	12733	5	0	\N
361260	1678	26640840460000	25736	12733	0	0	\N
361261	1678	26640840461000	25736	12733	1	0	\N
361262	1874	30009000	25736	12733	2	0	\N
361263	1874	30011000	25736	12733	3	0	\N
361264	1874	30014000	25736	12733	4	0	\N
361265	1874	30017000	25736	12733	5	0	\N
361266	1678	26640840462000	25737	12734	0	0	\N
361267	1874	30020000	25737	12734	1	0	\N
361268	1874	30022000	25737	12734	2	0	\N
361269	1407	0	25737	12734	3	0	\N
361270	1678	26640840462000	25738	12734	0	0	\N
361271	1874	30020000	25738	12734	1	0	\N
361272	1874	30022000	25738	12734	2	0	\N
361273	1407	0	25738	12734	3	0	\N
361274	1874	30020000	25739	12734	0	0	\N
361275	1407	0	25739	12734	1	0	\N
361280	1678	26640840462000	25741	12734	0	0	\N
361281	1874	30020000	25741	12734	1	0	\N
361282	1874	30022000	25741	12734	2	0	\N
361283	1407	0	25741	12734	3	0	\N
361284	2232	10200000000	25742	12584	0	0	\N
361285	1407	0	25742	12584	1	0	\N
361286	1764	12323456100000	25742	12584	3	0	\N
361288	1678	26640840463000	25744	12735	0	0	\N
361289	1874	30024000	25744	12735	2	0	\N
361290	1874	30027000	25744	12735	3	0	\N
361291	1678	26640840463000	25745	12735	0	0	\N
361292	1874	30024000	25745	12735	2	0	\N
361293	1874	30027000	25745	12735	3	0	\N
361294	2232	10200000000	25746	12610	0	0	\N
361295	1407	0	25746	12610	1	0	\N
361296	1764	12323456100000	25746	12610	3	0	\N
361297	1678	26640840463000	25747	12736	0	0	\N
361298	1678	26640840464000	25747	12736	1	0	\N
361299	1874	30027000	25747	12736	2	0	\N
361300	1874	30029000	25747	12736	3	0	\N
361301	1874	30032000	25747	12736	4	0	\N
361309	1678	26640840466000	25750	12738	0	0	\N
361310	1874	30037000	25750	12738	1	0	\N
361311	44	66000001200000	25750	12738	2	0	\N
361312	1874	30039000	25750	12738	3	0	\N
361320	1678	26640840467000	25753	12739	0	0	\N
361321	1874	30041000	25753	12739	1	0	\N
361322	1874	30044000	25753	12739	2	0	\N
361323	1678	26640840467000	25754	12739	0	0	\N
361324	1874	30041000	25754	12739	1	0	\N
361325	1874	30044000	25754	12739	2	0	\N
361329	1678	26640840469000	25756	12741	0	0	\N
361330	1874	30051000	25756	12741	1	0	\N
361331	1874	30054000	25756	12741	2	0	\N
361332	1678	26640840468000	25757	12740	0	0	\N
361333	1678	26640840469000	25757	12740	1	0	\N
361334	1874	30047000	25757	12740	2	0	\N
361335	1874	30050000	25757	12740	3	0	\N
361336	1874	30052000	25757	12740	4	0	\N
361337	1874	30054000	25757	12740	5	0	\N
361338	1678	26640840469000	25758	12741	0	0	\N
361339	1874	30051000	25758	12741	1	0	\N
361340	1874	30054000	25758	12741	2	0	\N
361344	1678	26640840469000	25760	12741	0	0	\N
361345	1874	30051000	25760	12741	1	0	\N
361346	1874	30054000	25760	12741	2	0	\N
361347	1678	26640840470000	25761	12742	0	0	\N
361348	1874	30057000	25761	12742	1	0	\N
361349	1874	30059000	25761	12742	2	0	\N
361219	1874	29974000	25726	12728	4	0	2
361220	1874	29977000	25726	12728	5	0	2
361224	1678	26640840454000	25728	12729	0	0	0
361225	1874	29979000	25728	12729	1	0	2
361226	1874	29982000	25728	12729	2	0	2
361228	1678	26640840456000	25729	12730	1	0	0
361229	1678	26640840457000	25729	12730	2	0	0
361230	1874	29984000	25729	12730	3	0	2
361231	1874	29986000	25729	12730	4	0	2
361232	1874	29989000	25729	12730	5	0	2
361234	1874	29995000	25729	12730	7	0	2
361235	1874	29997000	25729	12730	8	0	2
361242	1678	26640840458000	25732	12731	0	0	0
361243	1874	30000000	25732	12731	1	0	2
361245	1678	26640840459000	25733	12732	0	0	0
361246	1874	30005000	25733	12732	1	0	2
361247	1874	30007000	25733	12732	2	0	2
361248	1678	26640840460000	25734	12733	0	0	0
361249	1678	26640840461000	25734	12733	1	0	0
361251	1874	30011000	25734	12733	3	0	2
361252	1874	30014000	25734	12733	4	0	2
361253	1874	30017000	25734	12733	5	0	2
361276	1678	26640840462000	25740	12734	0	0	0
361277	1874	30020000	25740	12734	1	0	2
361279	1407	0	25740	12734	3	0	0
361287	1874	30025000	25743	12735	0	0	2
361302	1678	26640840463000	25748	12736	0	0	0
361303	1678	26640840464000	25748	12736	1	0	0
361305	1874	30029000	25748	12736	3	0	2
361306	1874	30032000	25748	12736	4	0	2
361307	1678	26640840465000	25749	12737	0	0	0
361308	1874	30034000	25749	12737	1	0	2
361313	1678	26640840466000	25751	12738	0	0	0
361315	44	66000001200000	25751	12738	2	0	3
361316	1874	30039000	25751	12738	3	0	2
361317	1678	26640840467000	25752	12739	0	0	0
361318	1874	30041000	25752	12739	1	0	2
361319	1874	30044000	25752	12739	2	0	2
361327	1874	30047000	25755	12740	1	0	2
361328	1874	30049000	25755	12740	2	0	2
361341	1678	26640840469000	25759	12741	0	0	0
361342	1874	30052000	25759	12741	1	0	2
361350	1678	26640840470000	25762	12742	0	0	0
361351	1874	30057000	25762	12742	1	0	2
361352	1874	30059000	25762	12742	2	0	2
361353	1678	26640840470000	25763	12742	0	0	\N
361354	1874	30057000	25763	12742	1	0	\N
361355	1874	30059000	25763	12742	2	0	\N
361359	44	66000001200000	25765	12585	0	0	\N
361360	1678	26640840472000	25766	12744	0	0	\N
361361	1874	30067000	25766	12744	1	0	\N
361362	1874	30069000	25766	12744	2	0	\N
361363	1678	26640840472000	25767	12744	0	0	\N
361364	1874	30067000	25767	12744	1	0	\N
361365	1874	30069000	25767	12744	2	0	\N
361366	44	66000001200000	25768	12611	0	0	\N
361373	1678	26640840471000	25771	12743	0	0	\N
361374	1678	26640840472000	25771	12743	1	0	\N
361375	1678	26640840473000	25771	12743	2	0	\N
361376	1874	30061000	25771	12743	3	0	\N
361377	1874	30064000	25771	12743	4	0	\N
361378	1874	30067000	25771	12743	5	0	\N
361379	1874	30070000	25771	12743	6	0	\N
361380	1874	30072000	25771	12743	7	0	\N
361381	1874	30074000	25771	12743	8	0	\N
361382	1678	26640840474000	25772	12746	0	0	\N
361383	1874	30076000	25772	12746	1	0	\N
361384	1874	30079000	25772	12746	2	0	\N
361397	1678	26640840476000	25776	12748	0	0	\N
361398	1678	26640840477000	25776	12748	1	0	\N
361399	1874	30087000	25776	12748	2	0	\N
361400	1874	30090000	25776	12748	3	0	\N
361401	1874	30092000	25776	12748	4	0	\N
361402	1874	30094000	25776	12748	5	0	\N
361403	2232	10200000000	25777	12625	0	0	\N
361404	1407	0	25777	12625	1	0	\N
361405	44	66000001200000	25777	12625	3	0	\N
361406	1764	12323456100000	25777	12625	4	0	\N
361410	1678	26640840478000	25779	12749	0	0	\N
361411	1874	30097000	25779	12749	1	0	\N
361412	1874	30099000	25779	12749	2	0	\N
361428	1678	26640840482000	25783	12752	0	0	\N
361429	1678	26640840483000	25783	12752	1	0	\N
361430	1874	30117000	25783	12752	2	0	\N
361431	1874	30120000	25783	12752	3	0	\N
361432	1874	30122000	25783	12752	4	0	\N
361433	1874	30124000	25783	12752	5	0	\N
361434	1678	26640840482000	25784	12752	0	0	\N
361435	1678	26640840483000	25784	12752	1	0	\N
361436	1874	30117000	25784	12752	2	0	\N
361437	1874	30120000	25784	12752	3	0	\N
361438	1874	30122000	25784	12752	4	0	\N
361439	1874	30124000	25784	12752	5	0	\N
361440	1678	26640840482000	25785	12752	0	0	\N
361441	1678	26640840483000	25785	12752	1	0	\N
361442	1874	30117000	25785	12752	2	0	\N
361443	1874	30120000	25785	12752	3	0	\N
361444	1874	30122000	25785	12752	4	0	\N
361445	1874	30124000	25785	12752	5	0	\N
361446	1678	26640840484000	25786	12753	0	0	\N
361447	1874	30127000	25786	12753	1	0	\N
361448	1874	30129000	25786	12753	2	0	\N
361455	1678	26640840485000	25789	12754	0	0	\N
361456	1874	30132000	25789	12754	1	0	\N
361457	2325	1000000000	25789	12754	2	0	\N
361458	1874	30134000	25789	12754	3	0	\N
361459	1678	26640840485000	25790	12754	0	0	\N
361460	1874	30132000	25790	12754	1	0	\N
361461	2325	1000000000	25790	12754	2	0	\N
361462	1874	30134000	25790	12754	3	0	\N
361463	1874	30132000	25791	12754	0	0	\N
361464	2325	1000000000	25791	12754	1	0	\N
361465	1678	26640840485000	25792	12754	0	0	\N
361466	1874	30132000	25792	12754	1	0	\N
361467	2325	1000000000	25792	12754	2	0	\N
361468	1874	30134000	25792	12754	3	0	\N
361473	1678	26640840487000	25794	12756	0	0	\N
361474	1678	26640840488000	25794	12756	1	0	\N
361475	1678	26640840489000	25794	12756	2	0	\N
361476	1678	26640840490000	25794	12756	3	0	\N
361477	1678	26640840491000	25794	12756	4	0	\N
361478	1874	30142000	25794	12756	5	0	\N
361479	1718	8896596519070	25794	12756	6	0	\N
361480	1874	30145000	25794	12756	7	0	\N
361481	1874	30148000	25794	12756	8	0	\N
361482	1874	30151000	25794	12756	9	0	\N
361483	1874	30154000	25794	12756	10	0	\N
361484	1874	30156000	25794	12756	11	0	\N
361485	1874	30158000	25794	12756	12	0	\N
361486	1874	30160000	25794	12756	13	0	\N
361487	2325	1000000000	25794	12756	15	0	\N
361488	1874	30162000	25794	12756	16	0	\N
361358	1874	30064000	25764	12743	2	0	2
361367	1678	26640840472000	25769	12744	0	0	0
361368	1874	30067000	25769	12744	1	0	2
361369	1874	30069000	25769	12744	2	0	2
361370	1678	26640840473000	25770	12745	0	0	0
361372	1874	30074000	25770	12745	2	0	2
361385	1678	26640840474000	25773	12746	0	0	0
361386	1874	30076000	25773	12746	1	0	2
361387	1874	30079000	25773	12746	2	0	2
361388	1678	26640840475000	25774	12747	0	0	0
361390	1874	30084000	25774	12747	2	0	2
361391	1678	26640840476000	25775	12748	0	0	0
361392	1678	26640840477000	25775	12748	1	0	0
361393	1874	30087000	25775	12748	2	0	2
361395	1874	30092000	25775	12748	4	0	2
361396	1874	30094000	25775	12748	5	0	2
361407	1678	26640840478000	25778	12749	0	0	0
361408	1874	30097000	25778	12749	1	0	2
361409	1874	30099000	25778	12749	2	0	2
361414	1874	30102000	25780	12750	1	0	2
361415	1874	30104000	25780	12750	2	0	2
361416	1678	26640840480000	25781	12751	0	0	0
361417	1678	26640840481000	25781	12751	1	0	0
361418	1874	30107000	25781	12751	2	0	2
361420	1874	30111000	25781	12751	4	0	2
361421	1874	30114000	25781	12751	5	0	2
361422	1678	26640840482000	25782	12752	0	0	0
361423	1678	26640840483000	25782	12752	1	0	0
361425	1874	30120000	25782	12752	3	0	2
361426	1874	30122000	25782	12752	4	0	2
361427	1874	30124000	25782	12752	5	0	2
361449	1678	26640840484000	25787	12753	0	0	0
361450	1874	30127000	25787	12753	1	0	2
361452	1678	26640840485000	25788	12754	0	0	0
361453	1874	30132000	25788	12754	1	0	2
361454	2325	1000000000	25788	12754	2	0	0
361469	1678	26640840486000	25793	12755	0	0	0
361470	1874	30135000	25793	12755	1	0	2
361472	1874	30139000	25793	12755	3	0	2
361489	1874	30164000	25794	12756	17	0	\N
361507	1678	26640840492000	25796	12757	0	0	\N
361508	1874	30166000	25796	12757	1	0	\N
361509	1678	26640840492000	25797	12757	0	0	\N
361510	1874	30166000	25797	12757	1	0	\N
361511	1678	26640840492000	25798	12757	0	0	\N
361512	1874	30166000	25798	12757	1	0	\N
361515	1678	26640840492000	25800	12757	0	0	\N
361516	1874	30166000	25800	12757	1	0	\N
361520	1678	26640840494000	25802	12759	0	0	\N
361521	1874	30173000	25802	12759	1	0	\N
361522	1874	30176000	25802	12759	2	0	\N
361523	1678	26640840494000	25803	12759	0	0	\N
361524	1874	30173000	25803	12759	1	0	\N
361525	1874	30176000	25803	12759	2	0	\N
361529	1678	26640840494000	25805	12759	0	0	\N
361530	1874	30173000	25805	12759	1	0	\N
361531	1874	30176000	25805	12759	2	0	\N
361538	1678	26640840495000	25807	12760	0	0	\N
361539	1678	26640840496000	25807	12760	1	0	\N
361540	1874	30178000	25807	12760	2	0	\N
361541	1874	30181000	25807	12760	3	0	\N
361542	1874	30184000	25807	12760	4	0	\N
361543	1874	30186000	25807	12760	5	0	\N
361548	1678	26640840497000	25809	12761	0	0	\N
361549	1933	2539268000000	25809	12761	1	0	\N
361550	1874	30189000	25809	12761	2	0	\N
361551	1874	30191000	25809	12761	3	0	\N
361555	1678	26640840498000	25811	12762	0	0	\N
361556	1874	30194000	25811	12762	1	0	\N
361557	1874	30196000	25811	12762	2	0	\N
361558	1678	26640840499000	25812	12763	0	0	\N
361559	1874	30199000	25812	12763	1	0	\N
361560	1874	30201000	25812	12763	2	0	\N
361567	1678	26640840501000	25815	12765	0	0	\N
361568	1678	26640840502000	25815	12765	1	0	\N
361569	1874	30209000	25815	12765	2	0	\N
361570	1874	30212000	25815	12765	3	0	\N
361571	1874	30214000	25815	12765	4	0	\N
361572	1874	30216000	25815	12765	5	0	\N
361573	1678	26640840501000	25816	12765	0	0	\N
361574	1678	26640840502000	25816	12765	1	0	\N
361575	1874	30209000	25816	12765	2	0	\N
361576	1874	30212000	25816	12765	3	0	\N
361577	1874	30214000	25816	12765	4	0	\N
361578	1874	30216000	25816	12765	5	0	\N
361579	1678	26640840501000	25818	12766	0	0	\N
361580	1678	26640840502000	25818	12766	1	0	\N
361581	1678	26640840503000	25818	12766	2	0	\N
361582	1678	26640840504000	25818	12766	3	0	\N
361583	1874	30209000	25818	12766	4	0	\N
361584	1874	30212000	25818	12766	5	0	\N
361585	1874	30215000	25818	12766	6	0	\N
361586	1874	30218000	25818	12766	7	0	\N
361587	1874	30220000	25818	12766	8	0	\N
361588	1874	30222000	25818	12766	9	0	\N
361589	1874	30224000	25818	12766	10	0	\N
361590	1874	30226000	25818	12766	11	0	\N
361612	1678	26640840506000	25822	12768	0	0	\N
361613	1678	26640840507000	25822	12768	1	0	\N
361614	1874	30230000	25822	12768	2	0	\N
361615	1874	30232000	25822	12768	3	0	\N
361616	1874	30235000	25822	12768	4	0	\N
361617	1874	30238000	25822	12768	5	0	\N
361618	1874	30241000	25822	12768	6	0	\N
361619	1678	26640840508000	25823	12769	0	0	\N
361620	1678	26640840509000	25823	12769	1	0	\N
361621	1678	26640840510000	25823	12769	2	0	\N
361622	1874	30244000	25823	12769	3	0	\N
361623	1874	30247000	25823	12769	4	0	\N
361624	1874	30249000	25823	12769	5	0	\N
361492	1678	26640840489000	25795	12756	2	0	0
361493	1678	26640840490000	25795	12756	3	0	0
361494	1678	26640840491000	25795	12756	4	0	0
361495	1874	30142000	25795	12756	5	0	2
361496	1718	8896596519070	25795	12756	6	0	13
361498	1874	30148000	25795	12756	8	0	2
361499	1874	30151000	25795	12756	9	0	2
361500	1874	30154000	25795	12756	10	0	2
361501	1874	30156000	25795	12756	11	0	2
361502	1874	30158000	25795	12756	12	0	2
361504	2325	1000000000	25795	12756	15	0	0
361505	1874	30162000	25795	12756	16	0	2
361506	1874	30164000	25795	12756	17	0	2
361513	1678	26640840492000	25799	12757	0	0	0
361517	1678	26640840493000	25801	12758	0	0	0
361518	1874	30169000	25801	12758	1	0	2
361519	1874	30171000	25801	12758	2	0	2
361526	1678	26640840494000	25804	12759	0	0	0
361527	1874	30173000	25804	12759	1	0	2
361532	1678	26640840495000	25806	12760	0	0	0
361533	1678	26640840496000	25806	12760	1	0	0
361534	1874	30178000	25806	12760	2	0	2
361535	1874	30181000	25806	12760	3	0	2
361536	1874	30184000	25806	12760	4	0	2
361544	1678	26640840497000	25808	12761	0	0	0
361545	1933	2539268000000	25808	12761	1	0	3
361546	1874	30189000	25808	12761	2	0	2
361547	1874	30191000	25808	12761	3	0	2
361553	1874	30194000	25810	12762	1	0	2
361554	1874	30196000	25810	12762	2	0	2
361561	1678	26640840499000	25813	12763	0	0	0
361562	1874	30199000	25813	12763	1	0	2
361563	1874	30201000	25813	12763	2	0	2
361565	1874	30203000	25814	12764	1	0	2
361566	1874	30206000	25814	12764	2	0	2
361591	1678	26640840501000	25819	12766	0	0	0
361592	1678	26640840502000	25819	12766	1	0	0
361593	1678	26640840503000	25819	12766	2	0	0
361595	1874	30209000	25819	12766	4	0	2
361596	1874	30212000	25819	12766	5	0	2
361597	1874	30215000	25819	12766	6	0	2
361598	1874	30218000	25819	12766	7	0	2
361600	1874	30222000	25819	12766	9	0	2
361601	1874	30224000	25819	12766	10	0	2
361602	1874	30226000	25819	12766	11	0	2
361603	1678	26640840505000	25820	12767	0	0	0
361604	1874	30228000	25820	12767	1	0	2
361606	1678	26640840507000	25821	12768	1	0	0
361607	1874	30230000	25821	12768	2	0	2
361608	1874	30232000	25821	12768	3	0	2
361609	1874	30235000	25821	12768	4	0	2
361610	1874	30238000	25821	12768	5	0	2
361625	1874	30251000	25823	12769	6	0	\N
361626	1874	30253000	25823	12769	7	0	\N
361627	1874	30256000	25823	12769	8	0	\N
361637	1678	26640840511000	25825	12770	0	0	\N
361638	1874	30258000	25825	12770	1	0	\N
361639	1874	30261000	25825	12770	2	0	\N
361646	1678	26640840513000	25828	12772	0	0	\N
361647	1678	26640840514000	25828	12772	1	0	\N
361648	2326	0	25828	12772	2	0	\N
361649	1874	30268000	25828	12772	3	0	\N
361650	1874	30270000	25828	12772	4	0	\N
361651	1874	30273000	25828	12772	5	0	\N
361652	1874	30276000	25828	12772	6	0	\N
361663	1678	26640840515000	25831	12773	0	0	\N
361664	1874	30278000	25831	12773	1	0	\N
361665	1874	30281000	25831	12773	2	0	\N
361670	1678	26640840516000	25833	12774	0	0	\N
361671	1874	30284000	25833	12774	1	0	\N
361672	1874	30286000	25833	12774	2	0	\N
361673	2326	719000000000	25833	12774	3	0	\N
361674	1678	26640840516000	25834	12774	0	0	\N
361675	1874	30284000	25834	12774	1	0	\N
361676	1874	30286000	25834	12774	2	0	\N
361677	2326	719000000000	25834	12774	3	0	\N
361678	2326	0	25835	12669	0	0	\N
361679	2325	1000000000	25835	12669	1	0	\N
361680	2326	719000000000	25835	12669	2	0	\N
361681	1718	8896596519070	25835	12669	3	0	\N
361682	1407	0	25835	12669	4	0	\N
361683	44	66000001200000	25835	12669	6	0	\N
361684	2325	1000000000	25835	12669	7	0	\N
361688	1678	26640840517000	25837	12775	0	0	\N
361689	1874	30288000	25837	12775	1	0	\N
361690	1874	30291000	25837	12775	2	0	\N
361691	1678	26640840517000	25838	12775	0	0	\N
361692	1874	30288000	25838	12775	1	0	\N
361693	1874	30291000	25838	12775	2	0	\N
361694	1678	26640840517000	25839	12775	0	0	\N
361695	1874	30288000	25839	12775	1	0	\N
361696	1874	30291000	25839	12775	2	0	\N
361701	1678	26640840518000	25841	12776	0	0	\N
361702	2326	719004000000	25841	12776	1	0	\N
361703	1874	30293000	25841	12776	2	0	\N
361704	1874	30296000	25841	12776	3	0	\N
361705	1678	26640840518000	25842	12776	0	0	\N
361706	2326	719004000000	25842	12776	1	0	\N
361707	1874	30293000	25842	12776	2	0	\N
361708	1874	30296000	25842	12776	3	0	\N
361709	1678	26640840519000	25843	12777	0	0	\N
361710	547	66000004000000	25843	12777	1	0	\N
361711	1874	30299000	25843	12777	2	0	\N
361712	1874	30301000	25843	12777	3	0	\N
361719	1678	26640840520000	25846	12778	0	0	\N
361720	1874	30303000	25846	12778	1	0	\N
361721	1678	26640840520000	25847	12778	0	0	\N
361722	1874	30303000	25847	12778	1	0	\N
361723	1678	26640840520000	25848	12778	0	0	\N
361724	1874	30303000	25848	12778	1	0	\N
361749	1678	26640840528000	25853	12782	0	0	\N
361750	1874	30340000	25853	12782	1	0	\N
361751	1874	30343000	25853	12782	2	0	\N
361752	1678	26640840529000	25854	12783	0	0	\N
361753	1874	30345000	25854	12783	1	0	\N
361754	1874	30348000	25854	12783	2	0	\N
361755	1678	26640840529000	25855	12783	0	0	\N
361756	1874	30345000	25855	12783	1	0	\N
361757	1874	30348000	25855	12783	2	0	\N
361630	1678	26640840510000	25824	12769	2	0	0
361631	1874	30244000	25824	12769	3	0	2
361632	1874	30247000	25824	12769	4	0	2
361633	1874	30249000	25824	12769	5	0	2
361634	1874	30251000	25824	12769	6	0	2
361636	1874	30256000	25824	12769	8	0	2
361640	1678	26640840511000	25826	12770	0	0	0
361641	1874	30258000	25826	12770	1	0	2
361642	1874	30261000	25826	12770	2	0	2
361643	1678	26640840512000	25827	12771	0	0	0
361645	1874	30266000	25827	12771	2	0	2
361653	1678	26640840513000	25829	12772	0	0	0
361654	1678	26640840514000	25829	12772	1	0	0
361655	2326	0	25829	12772	2	0	0
361657	1874	30270000	25829	12772	4	0	2
361658	1874	30273000	25829	12772	5	0	2
361659	1874	30276000	25829	12772	6	0	2
361660	1678	26640840515000	25830	12773	0	0	0
361661	1874	30278000	25830	12773	1	0	2
361666	1678	26640840516000	25832	12774	0	0	0
361667	1874	30284000	25832	12774	1	0	2
361668	1874	30286000	25832	12774	2	0	2
361669	2326	719000000000	25832	12774	3	0	0
361685	1678	26640840517000	25836	12775	0	0	0
361687	1874	30291000	25836	12775	2	0	2
361697	1678	26640840518000	25840	12776	0	0	0
361698	2326	719004000000	25840	12776	1	0	0
361699	1874	30293000	25840	12776	2	0	2
361713	1678	26640840519000	25844	12777	0	0	0
361714	547	66000004000000	25844	12777	1	0	3
361715	1874	30299000	25844	12777	2	0	2
361716	1874	30301000	25844	12777	3	0	2
361717	1678	26640840520000	25845	12778	0	0	0
361725	1678	26640840521000	25849	12779	0	0	0
361726	1678	26640840522000	25849	12779	1	0	0
361727	1874	30306000	25849	12779	2	0	2
361728	1874	30309000	25849	12779	3	0	2
361729	1874	30311000	25849	12779	4	0	2
361731	1678	26640840523000	25850	12780	0	0	0
361732	1678	26640840524000	25850	12780	1	0	0
361733	1678	26640840525000	25850	12780	2	0	0
361734	1874	30316000	25850	12780	3	0	2
361736	1874	30321000	25850	12780	6	0	2
361737	1874	30323000	25850	12780	7	0	2
361738	1874	30325000	25850	12780	8	0	2
361739	1874	30328000	25850	12780	9	0	2
361740	1678	26640840526000	25851	12781	0	0	0
361742	1874	30330000	25851	12781	2	0	2
361743	1874	30332000	25851	12781	3	0	2
361744	1874	30335000	25851	12781	4	0	2
361745	1874	30338000	25851	12781	5	0	2
361746	1678	26640840528000	25852	12782	0	0	0
361748	1874	30343000	25852	12782	2	0	2
361758	1678	26640840529000	25856	12783	0	0	0
361759	1874	30345000	25856	12783	1	0	2
361760	1874	30348000	25856	12783	2	0	2
361761	1678	26640840529000	25857	12783	0	0	\N
361762	1874	30345000	25857	12783	1	0	\N
361763	1874	30348000	25857	12783	2	0	\N
361764	1678	26640840530000	25858	12784	0	0	\N
361765	1874	30350000	25858	12784	1	0	\N
361766	1874	30353000	25858	12784	2	0	\N
361768	1678	26640840530000	25860	12785	0	0	\N
361769	1678	26640840531000	25860	12785	1	0	\N
361770	1678	26640840532000	25860	12785	2	0	\N
361771	1874	30353000	25860	12785	3	0	\N
361772	1874	30355000	25860	12785	4	0	\N
361773	1874	30357000	25860	12785	5	0	\N
361774	1874	30360000	25860	12785	6	0	\N
361775	1874	30363000	25860	12785	7	0	\N
361784	1678	26640840530000	25862	12785	0	0	\N
361785	1678	26640840531000	25862	12785	1	0	\N
361786	1678	26640840532000	25862	12785	2	0	\N
361787	1874	30353000	25862	12785	3	0	\N
361788	1874	30355000	25862	12785	4	0	\N
361789	1874	30357000	25862	12785	5	0	\N
361790	1874	30360000	25862	12785	6	0	\N
361791	1874	30363000	25862	12785	7	0	\N
361792	1678	26640840530000	25863	12785	0	0	\N
361793	1678	26640840531000	25863	12785	1	0	\N
361794	1678	26640840532000	25863	12785	2	0	\N
361795	1874	30353000	25863	12785	3	0	\N
361796	1874	30355000	25863	12785	4	0	\N
361797	1874	30357000	25863	12785	5	0	\N
361798	1874	30360000	25863	12785	6	0	\N
361799	1874	30363000	25863	12785	7	0	\N
361803	1678	26640840473000	25865	12745	0	0	\N
361804	1678	26640840474000	25865	12745	1	0	\N
361805	1678	26640840475000	25865	12745	2	0	\N
361806	1678	26640840476000	25865	12745	3	0	\N
361807	1678	26640840477000	25865	12745	4	0	\N
361808	1678	26640840478000	25865	12745	5	0	\N
361809	1678	26640840479000	25865	12745	6	0	\N
361810	1678	26640840480000	25865	12745	7	0	\N
361811	1678	26640840481000	25865	12745	8	0	\N
361812	1678	26640840482000	25865	12745	9	0	\N
361813	1678	26640840483000	25865	12745	10	0	\N
361814	1678	26640840484000	25865	12745	11	0	\N
361815	1678	26640840485000	25865	12745	12	0	\N
361816	1678	26640840486000	25865	12745	13	0	\N
361817	1678	26640840487000	25865	12745	14	0	\N
361818	1678	26640840488000	25865	12745	15	0	\N
361819	1678	26640840489000	25865	12745	16	0	\N
361820	1678	26640840490000	25865	12745	17	0	\N
361821	1678	26640840491000	25865	12745	18	0	\N
361822	1678	26640840492000	25865	12745	19	0	\N
361823	1678	26640840493000	25865	12745	20	0	\N
361824	1678	26640840494000	25865	12745	21	0	\N
361825	1678	26640840495000	25865	12745	22	0	\N
361826	1678	26640840496000	25865	12745	23	0	\N
361827	1678	26640840497000	25865	12745	24	0	\N
361828	1678	26640840498000	25865	12745	25	0	\N
361829	1678	26640840499000	25865	12745	26	0	\N
361830	1678	26640840500000	25865	12745	27	0	\N
361831	1678	26640840501000	25865	12745	28	0	\N
361832	1678	26640840502000	25865	12745	29	0	\N
361833	1678	26640840503000	25865	12745	30	0	\N
361834	1678	26640840504000	25865	12745	31	0	\N
361835	1678	26640840505000	25865	12745	32	0	\N
361836	1678	26640840506000	25865	12745	33	0	\N
361837	1678	26640840507000	25865	12745	34	0	\N
361838	1678	26640840508000	25865	12745	35	0	\N
361839	1678	26640840509000	25865	12745	36	0	\N
361840	1678	26640840510000	25865	12745	37	0	\N
361841	1678	26640840511000	25865	12745	38	0	\N
361842	1678	26640840512000	25865	12745	39	0	\N
361843	1678	26640840513000	25865	12745	40	0	\N
361844	1678	26640840514000	25865	12745	41	0	\N
361845	1678	26640840515000	25865	12745	42	0	\N
361846	1678	26640840516000	25865	12745	43	0	\N
361847	1678	26640840517000	25865	12745	44	0	\N
361848	1678	26640840518000	25865	12745	45	0	\N
361849	1678	26640840519000	25865	12745	46	0	\N
361850	1678	26640840520000	25865	12745	47	0	\N
361851	1678	26640840521000	25865	12745	48	0	\N
361852	1678	26640840522000	25865	12745	49	0	\N
361853	1678	26640840523000	25865	12745	50	0	\N
361854	1678	26640840524000	25865	12745	51	0	\N
361855	1678	26640840525000	25865	12745	52	0	\N
361856	1678	26640840526000	25865	12745	53	0	\N
361857	1678	26640840527000	25865	12745	54	0	\N
361858	1678	26640840528000	25865	12745	55	0	\N
361859	1678	26640840529000	25865	12745	56	0	\N
361860	1678	26640840530000	25865	12745	57	0	\N
361861	1678	26640840531000	25865	12745	58	0	\N
361862	1678	26640840532000	25865	12745	59	0	\N
361863	1678	26640840533000	25865	12745	60	0	\N
361864	1678	26640840534000	25865	12745	61	0	\N
361865	1678	26640840535000	25865	12745	62	0	\N
361866	1874	30071000	25865	12745	64	0	\N
361867	1874	30073000	25865	12745	65	0	\N
361868	1874	30075000	25865	12745	66	0	\N
361869	2326	0	25865	12745	67	0	\N
361870	2325	1000000000	25865	12745	68	0	\N
361871	2326	719000000000	25865	12745	69	0	\N
361872	1718	8896596519070	25865	12745	70	0	\N
361873	1874	30078000	25865	12745	71	0	\N
361874	1874	30081000	25865	12745	72	0	\N
361875	1874	30084000	25865	12745	73	0	\N
361876	1874	30087000	25865	12745	74	0	\N
361877	1874	30090000	25865	12745	75	0	\N
361878	1874	30093000	25865	12745	76	0	\N
361879	1874	30096000	25865	12745	77	0	\N
361880	1874	30099000	25865	12745	78	0	\N
361881	2326	719004000000	25865	12745	80	0	\N
361882	1874	30101000	25865	12745	81	0	\N
361883	1874	30103000	25865	12745	82	0	\N
361884	1874	30105000	25865	12745	83	0	\N
361885	1874	30107000	25865	12745	84	0	\N
361886	1874	30109000	25865	12745	85	0	\N
361887	1874	30111000	25865	12745	86	0	\N
361888	1874	30113000	25865	12745	87	0	\N
361889	1874	30115000	25865	12745	88	0	\N
361890	1874	30117000	25865	12745	89	0	\N
361891	2325	1000000000	25865	12745	90	0	\N
361892	1874	30119000	25865	12745	91	0	\N
361893	1874	30121000	25865	12745	92	0	\N
361894	1874	30123000	25865	12745	93	0	\N
361895	1874	30125000	25865	12745	94	0	\N
361896	1874	30127000	25865	12745	95	0	\N
361777	1678	26640840531000	25861	12785	1	0	0
361778	1678	26640840532000	25861	12785	2	0	0
361779	1874	30353000	25861	12785	3	0	2
361780	1874	30355000	25861	12785	4	0	2
361781	1874	30357000	25861	12785	5	0	2
361783	1874	30363000	25861	12785	7	0	2
361800	1678	26640840533000	25864	12786	0	0	0
361801	1874	30366000	25864	12786	1	0	2
361802	1874	30368000	25864	12786	2	0	2
361897	1874	30129000	25865	12745	96	0	\N
361898	1874	30131000	25865	12745	97	0	\N
361899	1874	30133000	25865	12745	98	0	\N
361900	1874	30135000	25865	12745	99	0	\N
361901	1874	30137000	25865	12745	100	0	\N
361902	1874	30139000	25865	12745	101	0	\N
361903	1874	30141000	25865	12745	102	0	\N
361904	1874	30143000	25865	12745	103	0	\N
361905	1874	30145000	25865	12745	104	0	\N
361906	1874	30147000	25865	12745	105	0	\N
361907	1874	30149000	25865	12745	106	0	\N
361908	1874	30151000	25865	12745	107	0	\N
361909	1874	30153000	25865	12745	108	0	\N
361910	1874	30155000	25865	12745	109	0	\N
361911	1874	30157000	25865	12745	110	0	\N
361912	1874	30159000	25865	12745	111	0	\N
361913	1874	30161000	25865	12745	112	0	\N
361914	1874	30163000	25865	12745	113	0	\N
361915	1874	30165000	25865	12745	114	0	\N
361916	1874	30167000	25865	12745	115	0	\N
361917	1874	30169000	25865	12745	116	0	\N
361918	1874	30171000	25865	12745	117	0	\N
361919	1874	30173000	25865	12745	118	0	\N
361920	1874	30175000	25865	12745	119	0	\N
361921	1874	30177000	25865	12745	120	0	\N
361922	1874	30179000	25865	12745	121	0	\N
361923	1874	30181000	25865	12745	122	0	\N
361924	1874	30183000	25865	12745	123	0	\N
361925	1874	30185000	25865	12745	124	0	\N
361926	1874	30187000	25865	12745	125	0	\N
361936	1678	26640840536000	25868	12788	0	0	\N
361937	1874	30381000	25868	12788	1	0	\N
361938	1874	30383000	25868	12788	2	0	\N
361939	1678	26640840536000	25869	12788	0	0	\N
361940	1874	30381000	25869	12788	1	0	\N
361941	1874	30383000	25869	12788	2	0	\N
361942	1678	26640840536000	25870	12788	0	0	\N
361943	1874	30381000	25870	12788	1	0	\N
361944	1874	30383000	25870	12788	2	0	\N
361945	1678	26640840536000	25871	12788	0	0	\N
361946	1874	30381000	25871	12788	1	0	\N
361947	1874	30383000	25871	12788	2	0	\N
361948	1874	30381000	25872	12788	0	0	\N
361949	1678	26640840537000	25873	12789	0	0	\N
361950	1678	26640840538000	25873	12789	1	0	\N
361951	1874	30386000	25873	12789	2	0	\N
361952	1874	30389000	25873	12789	3	0	\N
361953	1874	30391000	25873	12789	4	0	\N
361954	1874	30393000	25873	12789	5	0	\N
361955	1678	26640840537000	25874	12789	0	0	\N
361956	1678	26640840538000	25874	12789	1	0	\N
361957	1874	30386000	25874	12789	2	0	\N
361958	1874	30389000	25874	12789	3	0	\N
361959	1874	30391000	25874	12789	4	0	\N
361960	1874	30393000	25874	12789	5	0	\N
361961	1678	26640840537000	25875	12789	0	0	\N
361962	1678	26640840538000	25875	12789	1	0	\N
361963	1874	30386000	25875	12789	2	0	\N
361964	1874	30389000	25875	12789	3	0	\N
361965	1874	30391000	25875	12789	4	0	\N
361966	1874	30393000	25875	12789	5	0	\N
361967	1678	26640840537000	25876	12789	0	0	\N
361968	1678	26640840538000	25876	12789	1	0	\N
361969	1874	30386000	25876	12789	2	0	\N
361970	1874	30389000	25876	12789	3	0	\N
361971	1874	30391000	25876	12789	4	0	\N
361972	1874	30393000	25876	12789	5	0	\N
361979	1678	26640840539000	25878	12790	0	0	\N
361980	1678	26640840540000	25878	12790	1	0	\N
361981	1678	26640840541000	25878	12790	2	0	\N
361982	1874	30395000	25878	12790	3	0	\N
361983	1874	30397000	25878	12790	4	0	\N
361984	1874	30399000	25878	12790	5	0	\N
361993	1678	26640840542000	25881	12791	0	0	\N
361994	1874	30401000	25881	12791	1	0	\N
361995	1678	26640840543000	25882	12792	0	0	\N
361996	1874	30403000	25882	12792	1	0	\N
362001	1678	26640840544000	25885	12793	0	0	\N
362002	1874	30405000	25885	12793	1	0	\N
362005	1678	26640840546000	25887	12795	0	0	\N
362006	1678	26640840547000	25887	12795	1	0	\N
362007	1874	30409000	25887	12795	2	0	\N
362008	1874	30411000	25887	12795	3	0	\N
362009	1678	26640840546000	25888	12795	0	0	\N
362010	1678	26640840547000	25888	12795	1	0	\N
362011	1874	30409000	25888	12795	2	0	\N
362012	1874	30411000	25888	12795	3	0	\N
362017	1678	26640840548000	25890	12796	0	0	\N
362018	1874	30413000	25890	12796	1	0	\N
362023	1678	26640840549000	25893	12797	0	0	\N
362024	1874	30415000	25893	12797	1	0	\N
362027	1678	26640840551000	25895	12799	0	0	\N
362028	1678	26640840552000	25895	12799	1	0	\N
362029	1678	26640840553000	25895	12799	2	0	\N
362030	1678	26640840554000	25895	12799	3	0	\N
362031	1678	26640840555000	25895	12799	4	0	\N
362032	1874	30419000	25895	12799	5	0	\N
361929	1874	30371000	25866	12787	2	0	2
361930	1874	30374000	25866	12787	3	0	2
361931	1874	30376000	25866	12787	4	0	2
361932	1874	30378000	25866	12787	5	0	2
361933	1678	26640840536000	25867	12788	0	0	0
361935	1874	30383000	25867	12788	2	0	2
361973	1678	26640840537000	25877	12789	0	0	0
361974	1678	26640840538000	25877	12789	1	0	0
361975	1874	30386000	25877	12789	2	0	2
361976	1874	30389000	25877	12789	3	0	2
361978	1874	30393000	25877	12789	5	0	2
361985	1678	26640840539000	25879	12790	0	0	0
361986	1678	26640840540000	25879	12790	1	0	0
361987	1678	26640840541000	25879	12790	2	0	0
361989	1874	30397000	25879	12790	4	0	2
361990	1874	30399000	25879	12790	5	0	2
361991	1678	26640840542000	25880	12791	0	0	0
361992	1874	30401000	25880	12791	1	0	2
361997	1678	26640840543000	25883	12792	0	0	0
361999	1678	26640840544000	25884	12793	0	0	0
362000	1874	30405000	25884	12793	1	0	2
362003	1678	26640840545000	25886	12794	0	0	0
362004	1874	30407000	25886	12794	1	0	2
362013	1678	26640840546000	25889	12795	0	0	0
362015	1874	30409000	25889	12795	2	0	2
362016	1874	30411000	25889	12795	3	0	2
362019	1678	26640840548000	25891	12796	0	0	0
362020	1874	30413000	25891	12796	1	0	2
362022	1874	30415000	25892	12797	1	0	2
362025	1678	26640840550000	25894	12798	0	0	0
362026	1874	30417000	25894	12798	1	0	2
362033	1874	30421000	25895	12799	6	0	\N
362034	1874	30423000	25895	12799	7	0	\N
362035	1874	30425000	25895	12799	8	0	\N
362036	1874	30427000	25895	12799	9	0	\N
362037	1874	30429000	25895	12799	10	0	\N
362054	2327	10000000	25899	12801	0	0	\N
362055	1678	26640840557000	25899	12801	1	0	\N
362056	1874	30433000	25899	12801	2	0	\N
362057	2327	10000000	25900	12801	0	0	\N
362058	1678	26640840557000	25900	12801	1	0	\N
362059	1874	30433000	25900	12801	2	0	\N
362060	1678	26640840558000	25901	12802	0	0	\N
362061	1874	30435000	25901	12802	1	0	\N
362066	1678	26640840559000	25905	12803	0	0	\N
362067	1874	30437000	25905	12803	1	0	\N
362068	1678	26640840560000	25906	12804	0	0	\N
362069	1678	26640840561000	25906	12804	1	0	\N
362070	1678	26640840562000	25906	12804	2	0	\N
362071	1874	30439000	25906	12804	3	0	\N
362072	1874	30441000	25906	12804	4	0	\N
362073	1874	30443000	25906	12804	5	0	\N
362074	106	66001000000000	25906	12804	6	0	\N
362082	1678	26640840560000	25908	12804	0	0	\N
362083	1678	26640840561000	25908	12804	1	0	\N
362084	1678	26640840562000	25908	12804	2	0	\N
362085	1874	30439000	25908	12804	3	0	\N
362086	1874	30441000	25908	12804	4	0	\N
362087	1874	30443000	25908	12804	5	0	\N
362088	106	66001000000000	25908	12804	6	0	\N
362089	1678	26640840563000	25909	12805	0	0	\N
362090	1874	30445000	25909	12805	1	0	\N
362091	1678	26640840563000	25910	12805	0	0	\N
362092	1874	30445000	25910	12805	1	0	\N
362095	1678	26640840564000	25912	12806	0	0	\N
362096	1874	30447000	25912	12806	1	0	\N
362099	1678	26640840564000	25914	12806	0	0	\N
362100	1678	26640840565000	25915	12807	0	0	\N
362101	1678	26640840566000	25915	12807	1	0	\N
362102	1874	30449000	25915	12807	2	0	\N
362103	1874	30451000	25915	12807	3	0	\N
362108	1678	26640840567000	25917	12808	0	0	\N
362109	1874	30453000	25917	12808	1	0	\N
362112	1678	26640840567000	25919	12808	0	0	\N
362113	1874	30453000	25919	12808	1	0	\N
362114	1678	26640840568000	25920	12809	0	0	\N
362115	1874	30455000	25920	12809	1	0	\N
362116	1678	26640840568000	25921	12809	0	0	\N
362117	1874	30455000	25921	12809	1	0	\N
362118	1678	26640840568000	25922	12809	0	0	\N
362119	1874	30455000	25922	12809	1	0	\N
362130	1678	26640840573000	25926	12812	0	0	\N
362131	1874	30465000	25926	12812	1	0	\N
362138	1678	26640840576000	25929	12814	0	0	\N
362139	1874	30471000	25929	12814	1	0	\N
362151	1678	26640830579000	25933	12816	0	0	\N
362152	1678	26640830580000	25933	12816	1	0	\N
362153	1874	30477000	25933	12816	2	0	\N
362154	1874	30479000	25933	12816	3	0	\N
362166	1678	26640830587000	25938	12821	0	0	\N
362167	1678	26640830588000	25938	12821	1	0	\N
362168	1678	26640830589000	25938	12821	2	0	\N
362040	1678	26640840553000	25896	12799	2	0	0
362041	1678	26640840554000	25896	12799	3	0	0
362042	1678	26640840555000	25896	12799	4	0	0
362043	1874	30419000	25896	12799	5	0	2
362044	1874	30421000	25896	12799	6	0	2
362046	1874	30425000	25896	12799	8	0	2
362047	1874	30427000	25896	12799	9	0	2
362048	1874	30429000	25896	12799	10	0	2
362049	1678	26640840556000	25897	12800	0	0	0
362050	1874	30431000	25897	12800	1	0	2
362052	1678	26640840557000	25898	12801	1	0	0
362053	1874	30433000	25898	12801	2	0	2
362062	1678	26640840558000	25902	12802	0	0	0
362063	1874	30435000	25902	12802	1	0	2
362065	1874	30437000	25904	12803	1	0	2
362075	1678	26640840560000	25907	12804	0	0	0
362076	1678	26640840561000	25907	12804	1	0	0
362077	1678	26640840562000	25907	12804	2	0	0
362078	1874	30439000	25907	12804	3	0	2
362080	1874	30443000	25907	12804	5	0	2
362081	106	66001000000000	25907	12804	6	0	3
362093	1678	26640840563000	25911	12805	0	0	0
362094	1874	30445000	25911	12805	1	0	2
362097	1678	26640840564000	25913	12806	0	0	0
362104	1678	26640840565000	25916	12807	0	0	0
362105	1678	26640840566000	25916	12807	1	0	0
362106	1874	30449000	25916	12807	2	0	2
362107	1874	30451000	25916	12807	3	0	2
362111	1874	30453000	25918	12808	1	0	2
362120	1678	26640840568000	25923	12809	0	0	0
362121	1874	30455000	25923	12809	1	0	2
362122	1678	26640840569000	25924	12810	0	0	0
362123	1874	30457000	25924	12810	1	0	2
362125	1678	26640840571000	25925	12811	1	0	0
362126	1678	26640840572000	25925	12811	2	0	0
362127	1874	30459000	25925	12811	3	0	2
362128	1874	30461000	25925	12811	4	0	2
362129	1874	30463000	25925	12811	5	0	2
362133	1874	30465000	25927	12812	1	0	2
362134	1678	26640840574000	25928	12813	0	0	0
362135	1678	26640840575000	25928	12813	1	0	0
362136	1874	30467000	25928	12813	2	0	2
362140	1678	26640840576000	25930	12814	0	0	0
362141	1874	30471000	25930	12814	1	0	2
362142	1678	26640840577000	25931	12815	0	0	0
362143	1678	26640840578000	25931	12815	1	0	0
362144	1397	1283874522000	25931	12815	2	0	15495
362146	1874	30475000	25931	12815	4	0	2
362147	1678	26640830579000	25932	12816	0	0	1
362148	1678	26640830580000	25932	12816	1	0	1
362149	1874	30477000	25932	12816	2	0	2
362150	1874	30479000	25932	12816	3	0	2
362156	1874	30481000	25934	12817	1	0	2
362157	1678	26640830582000	25935	12818	0	0	1
362158	1874	30483000	25935	12818	1	0	2
362159	1678	26640830583000	25936	12819	0	0	1
362161	1678	26640830585000	25936	12819	2	0	1
362162	1874	30485000	25936	12819	3	0	2
362163	1874	30487000	25936	12819	4	0	2
362164	1874	30489000	25936	12819	5	0	2
362165	1678	26640830586000	25937	12820	0	0	1
362169	1678	26640830590000	25938	12821	3	0	\N
362170	1874	30491000	25938	12821	4	0	\N
362171	1874	30493000	25938	12821	5	0	\N
362172	1874	30495000	25938	12821	6	0	\N
362173	1678	26640830587000	25939	12821	0	0	\N
362174	1678	26640830588000	25939	12821	1	0	\N
362175	1678	26640830589000	25939	12821	2	0	\N
362176	1678	26640830590000	25939	12821	3	0	\N
362177	1874	30491000	25939	12821	4	0	\N
362178	1874	30493000	25939	12821	5	0	\N
362179	1874	30495000	25939	12821	6	0	\N
362180	1874	30497000	25939	12821	8	0	\N
362181	1874	30499000	25939	12821	9	0	\N
362191	1678	26640830587000	25941	12821	0	0	\N
362192	1678	26640830588000	25941	12821	1	0	\N
362193	1678	26640830589000	25941	12821	2	0	\N
362194	1678	26640830590000	25941	12821	3	0	\N
362195	1874	30491000	25941	12821	4	0	\N
362196	1874	30493000	25941	12821	5	0	\N
362197	1874	30495000	25941	12821	6	0	\N
362198	1874	30497000	25941	12821	8	0	\N
362199	1874	30499000	25941	12821	9	0	\N
362200	1678	26640830587000	25942	12821	0	0	\N
362201	1678	26640830588000	25942	12821	1	0	\N
362202	1678	26640830589000	25942	12821	2	0	\N
362203	1678	26640830590000	25942	12821	3	0	\N
362204	1874	30491000	25942	12821	4	0	\N
362205	1874	30493000	25942	12821	5	0	\N
362206	1874	30495000	25942	12821	6	0	\N
362207	1874	30497000	25942	12821	8	0	\N
362208	1874	30499000	25942	12821	9	0	\N
362210	1678	26640830591000	25945	12822	0	0	\N
362211	1678	26640830592000	25945	12822	1	0	\N
362212	1678	26640830593000	25945	12822	2	0	\N
362213	1874	30501000	25945	12822	3	0	\N
362214	1874	30503000	25945	12822	4	0	\N
362215	1678	26640830591000	25946	12822	0	0	\N
362216	1678	26640830592000	25946	12822	1	0	\N
362217	1678	26640830593000	25946	12822	2	0	\N
362218	1874	30501000	25946	12822	3	0	\N
362219	1874	30503000	25946	12822	4	0	\N
362224	1678	26640830594000	25951	12824	0	0	\N
362225	1678	26640830595000	25951	12824	1	0	\N
362226	1874	30505000	25951	12824	2	0	\N
362227	1874	30507000	25951	12824	3	0	\N
362234	1397	1284064541000	25954	12804	0	0	\N
362235	2327	124010000000	25954	12804	1	0	\N
362236	106	66001000000000	25954	12804	2	0	\N
362237	2327	124010000000	25955	12826	0	0	\N
362238	1678	26640830597000	25955	12826	1	0	\N
362239	1874	30511000	25955	12826	2	0	\N
362243	1678	26640830598000	25957	12827	0	0	\N
362244	1678	26640830599000	25957	12827	1	0	\N
362245	1874	30513000	25957	12827	2	0	\N
362246	1874	30515000	25957	12827	3	0	\N
362251	1678	26640830598000	25959	12827	0	0	\N
362252	1678	26640830599000	25959	12827	1	0	\N
362253	1874	30513000	25959	12827	2	0	\N
362254	1874	30515000	25959	12827	3	0	\N
362257	1678	26640830600000	25961	12828	0	0	\N
362258	1874	30517000	25961	12828	1	0	\N
362259	1678	26640830601000	25962	12829	0	0	\N
362260	1678	26640830602000	25962	12829	1	0	\N
362261	1874	30519000	25962	12829	2	0	\N
362262	2328	719004000000	25962	12829	3	0	\N
362263	1874	30521000	25962	12829	4	0	\N
362264	1678	26640830601000	25963	12829	0	0	\N
362265	1678	26640830602000	25963	12829	1	0	\N
362266	1874	30519000	25963	12829	2	0	\N
362267	2328	719004000000	25963	12829	3	0	\N
362268	1874	30521000	25963	12829	4	0	\N
362269	1678	26640830601000	25964	12829	0	0	\N
362270	1678	26640830602000	25964	12829	1	0	\N
362271	1874	30519000	25964	12829	2	0	\N
362272	2328	719004000000	25964	12829	3	0	\N
362273	1874	30521000	25964	12829	4	0	\N
362274	1678	26640830601000	25965	12829	0	0	\N
362275	1678	26640830602000	25965	12829	1	0	\N
362276	1874	30519000	25965	12829	2	0	\N
362277	2328	719004000000	25965	12829	3	0	\N
362278	1874	30521000	25965	12829	4	0	\N
362288	1678	26640830603000	25968	12830	0	0	\N
362289	1874	30523000	25968	12830	1	0	\N
362290	1874	30525000	25968	12830	2	0	\N
362291	568	66000007000000	25968	12830	3	0	\N
362292	1678	26640830603000	25969	12830	0	0	\N
362293	1874	30523000	25969	12830	1	0	\N
362294	1874	30525000	25969	12830	2	0	\N
362295	568	66000007000000	25969	12830	3	0	\N
362296	1678	26640830604000	25970	12831	0	0	\N
362297	1874	30527000	25970	12831	1	0	\N
362184	1678	26640830589000	25940	12821	2	0	1
362185	1678	26640830590000	25940	12821	3	0	1
362186	1874	30491000	25940	12821	4	0	2
362187	1874	30493000	25940	12821	5	0	2
362188	1874	30495000	25940	12821	6	0	2
362190	1874	30499000	25940	12821	9	0	2
362209	1678	26640830591000	25943	12822	0	0	1
362220	1678	26640830592000	25948	12823	0	0	1
362221	1678	26640830593000	25948	12823	1	0	1
362222	1874	30501000	25948	12823	2	0	2
362228	1678	26640830594000	25952	12824	0	0	1
362229	1678	26640830595000	25952	12824	1	0	1
362230	1874	30505000	25952	12824	2	0	2
362231	1874	30507000	25952	12824	3	0	2
362233	1874	30509000	25953	12825	1	0	2
362240	2327	124010000000	25956	12826	0	0	0
362241	1678	26640830597000	25956	12826	1	0	1
362242	1874	30511000	25956	12826	2	0	2
362247	1678	26640830598000	25958	12827	0	0	1
362249	1874	30513000	25958	12827	2	0	2
362250	1874	30515000	25958	12827	3	0	2
362255	1678	26640830600000	25960	12828	0	0	1
362256	1874	30517000	25960	12828	1	0	2
362279	1678	26640830601000	25966	12829	0	0	1
362281	1874	30519000	25966	12829	2	0	2
362282	2328	719004000000	25966	12829	3	0	0
362283	1874	30521000	25966	12829	4	0	2
362284	1678	26640830603000	25967	12830	0	0	1
362286	1874	30525000	25967	12830	2	0	2
362287	568	66000007000000	25967	12830	3	0	1
362298	1678	26640830604000	25971	12831	0	0	1
362299	1874	30527000	25971	12831	1	0	2
362300	1678	26640830605000	25972	12832	0	0	1
362302	1678	26640830606000	25973	12833	0	0	1
362303	1874	30531000	25973	12833	1	0	2
362304	1678	26640830607000	25974	12834	0	0	1
362306	2328	719004000000	25975	12805	0	0	\N
362309	1678	26640830608000	25977	12835	0	0	\N
362310	1874	30535000	25977	12835	1	0	\N
362323	1678	26640830614000	25983	12840	0	0	\N
362324	1874	30547000	25983	12840	1	0	\N
362325	1678	26640830614000	25984	12840	0	0	\N
362326	1874	30547000	25984	12840	1	0	\N
362337	1678	26640830619000	25988	12843	0	0	\N
362338	1874	30557000	25988	12843	1	0	\N
362341	1678	26640830620000	25990	12844	0	0	\N
362342	1874	30559000	25990	12844	1	0	\N
362345	1678	26640830622000	25992	12846	0	0	\N
362346	1874	30563000	25992	12846	1	0	\N
362353	1678	26640830623000	25995	12847	0	0	\N
362354	1678	26640830624000	25995	12847	1	0	\N
362355	1874	30565000	25995	12847	2	0	\N
362356	1874	30567000	25995	12847	3	0	\N
362357	1678	26640830625000	25999	12849	0	0	\N
362358	1678	26640830626000	25999	12849	1	0	\N
362359	1874	30569000	25999	12849	2	0	\N
362360	1874	30571000	25999	12849	3	0	\N
362361	1403	0	25999	12849	4	0	\N
362362	1678	26640830625000	26000	12850	0	0	\N
362363	1678	26640830626000	26000	12850	1	0	\N
362364	1678	26640830627000	26000	12850	2	0	\N
362365	1874	30569000	26000	12850	3	0	\N
362366	1874	30571000	26000	12850	4	0	\N
362367	1874	30573000	26000	12850	5	0	\N
362368	1403	0	26000	12850	6	0	\N
362376	2327	10000000	26002	12731	0	0	\N
362377	2326	0	26002	12731	2	0	\N
362378	2325	1000000000	26002	12731	3	0	\N
362379	2326	719000000000	26002	12731	4	0	\N
362380	1718	8896596519070	26002	12731	5	0	\N
362381	106	66001000000000	26002	12731	6	0	\N
362382	2326	719004000000	26002	12731	7	0	\N
362383	2325	1000000000	26002	12731	8	0	\N
362384	1397	1285084643000	26003	12732	0	0	\N
362385	2327	124010000000	26003	12732	1	0	\N
362386	2328	719004000000	26003	12732	2	0	\N
362387	1403	0	26003	12732	3	0	\N
362389	1678	26640830628000	26005	12851	0	0	\N
362390	1874	30575000	26005	12851	1	0	\N
362413	1678	26640830635000	26011	12856	0	0	\N
362414	1874	30607000	26011	12856	1	0	\N
362415	1874	30610000	26011	12856	2	0	\N
362416	1678	26640830636000	26012	12857	0	0	\N
362417	1726	1000098112000	26012	12857	1	0	\N
362418	1874	30613000	26012	12857	2	0	\N
362419	1874	30615000	26012	12857	3	0	\N
362424	1678	26640840357000	26014	12665	0	0	\N
362425	1678	26640840358000	26014	12665	1	0	\N
362426	1678	26640840359000	26014	12665	2	0	\N
362427	2327	10000000	26014	12665	3	0	\N
362428	1678	26640840360000	26014	12665	4	0	\N
362429	1397	1286054740000	26014	12665	5	0	\N
362430	2327	124010000000	26014	12665	6	0	\N
362431	1678	26640830361000	26014	12665	7	0	\N
362432	1678	26640830362000	26014	12665	8	0	\N
362433	1678	26640830363000	26014	12665	9	0	\N
362434	1678	26640830364000	26014	12665	10	0	\N
362435	1678	26640830365000	26014	12665	11	0	\N
362436	1678	26640830366000	26014	12665	12	0	\N
362437	1678	26640830367000	26014	12665	13	0	\N
362438	1678	26640830368000	26014	12665	14	0	\N
362439	1678	26640830369000	26014	12665	15	0	\N
362440	1678	26640830370000	26014	12665	16	0	\N
362308	1874	30535000	25976	12835	1	0	2
362311	1678	26640830609000	25978	12836	0	0	1
362312	1678	26640830610000	25978	12836	1	0	1
362313	1874	30537000	25978	12836	2	0	2
362314	1874	30539000	25978	12836	3	0	2
362316	1874	30541000	25979	12837	1	0	2
362317	1678	26640830612000	25980	12838	0	0	1
362318	1874	30543000	25980	12838	1	0	2
362319	1678	26640830613000	25981	12839	0	0	1
362320	1874	30545000	25981	12839	1	0	2
362322	1874	30547000	25982	12840	1	0	2
362327	1678	26640830615000	25985	12841	0	0	1
362328	1678	26640830616000	25985	12841	1	0	1
362329	1678	26640830617000	25985	12841	2	0	1
362331	1874	30551000	25985	12841	4	0	2
362332	1874	30553000	25985	12841	5	0	2
362333	1678	26640830618000	25986	12842	0	0	1
362334	1874	30555000	25986	12842	1	0	2
362335	1678	26640830619000	25987	12843	0	0	1
362339	1678	26640830620000	25989	12844	0	0	1
362340	1874	30559000	25989	12844	1	0	2
362343	1678	26640830621000	25991	12845	0	0	1
362344	1874	30561000	25991	12845	1	0	2
362347	1678	26640830622000	25993	12846	0	0	1
362349	1678	26640830623000	25994	12847	0	0	1
362350	1678	26640830624000	25994	12847	1	0	1
362351	1874	30565000	25994	12847	2	0	2
362352	1874	30567000	25994	12847	3	0	2
362370	1678	26640830626000	26001	12850	1	0	1
362371	1678	26640830627000	26001	12850	2	0	1
362372	1874	30569000	26001	12850	3	0	2
362373	1874	30571000	26001	12850	4	0	2
362374	1874	30573000	26001	12850	5	0	2
362388	1678	26640830628000	26004	12851	0	0	1
362391	1678	26640830629000	26006	12852	0	0	1
362392	1678	26640830630000	26006	12852	1	0	1
362393	1874	30576000	26006	12852	2	0	2
362394	1874	30579000	26006	12852	3	0	2
362396	1874	30583000	26006	12852	5	0	2
362397	1874	30585000	26006	12852	6	0	2
362398	1678	26640830631000	26007	12853	0	0	1
362399	1874	30587000	26007	12853	1	0	2
362401	1678	26640830632000	26008	12854	0	0	1
362402	1678	26640830633000	26008	12854	1	0	1
362403	1874	30593000	26008	12854	2	0	2
362404	1874	30595000	26008	12854	3	0	2
362405	1874	30597000	26008	12854	4	0	2
362407	1678	26640830634000	26009	12855	0	0	1
362408	1874	30602000	26009	12855	1	0	2
362409	1874	30605000	26009	12855	2	0	2
362410	1678	26640830635000	26010	12856	0	0	1
362411	1874	30607000	26010	12856	1	0	2
362420	1678	26640830636000	26013	12857	0	0	1
362421	1726	1000098112000	26013	12857	1	0	8287
362422	1874	30613000	26013	12857	2	0	2
362423	1874	30615000	26013	12857	3	0	2
362441	1678	26640830371000	26014	12665	17	0	\N
362442	1678	26640830372000	26014	12665	18	0	\N
362443	1678	26640830373000	26014	12665	19	0	\N
362444	1678	26640830374000	26014	12665	20	0	\N
362445	1678	26640830375000	26014	12665	21	0	\N
362446	1678	26640830376000	26014	12665	22	0	\N
362447	1678	26640830377000	26014	12665	23	0	\N
362448	1678	26640830378000	26014	12665	24	0	\N
362449	1678	26640830379000	26014	12665	25	0	\N
362450	1678	26640830380000	26014	12665	26	0	\N
362451	1678	26640830381000	26014	12665	27	0	\N
362452	1678	26640830382000	26014	12665	28	0	\N
362453	1678	26640830383000	26014	12665	29	0	\N
362454	1678	26640830384000	26014	12665	30	0	\N
362455	1678	26640830385000	26014	12665	31	0	\N
362456	1678	26640830386000	26014	12665	32	0	\N
362457	1678	26640830387000	26014	12665	33	0	\N
362458	1678	26640830388000	26014	12665	34	0	\N
362459	1678	26640830389000	26014	12665	35	0	\N
362460	1678	26640830390000	26014	12665	36	0	\N
362461	1678	26640830391000	26014	12665	37	0	\N
362462	1678	26640830392000	26014	12665	38	0	\N
362463	1678	26640830393000	26014	12665	39	0	\N
362464	1678	26640830394000	26014	12665	40	0	\N
362465	1678	26640830395000	26014	12665	41	0	\N
362466	1678	26640830396000	26014	12665	42	0	\N
362467	1678	26640830397000	26014	12665	43	0	\N
362468	1678	26640830398000	26014	12665	44	0	\N
362469	1678	26640830399000	26014	12665	45	0	\N
362470	1678	26640830400000	26014	12665	46	0	\N
362471	1678	26640830401000	26014	12665	47	0	\N
362472	1678	26640830402000	26014	12665	48	0	\N
362473	1678	26640830403000	26014	12665	49	0	\N
362474	1678	26640830404000	26014	12665	50	0	\N
362475	1678	26640830405000	26014	12665	51	0	\N
362476	1678	26640830406000	26014	12665	52	0	\N
362477	1678	26640830407000	26014	12665	53	0	\N
362478	1678	26640830408000	26014	12665	54	0	\N
362479	1678	26640830409000	26014	12665	55	0	\N
362480	1678	26640830410000	26014	12665	56	0	\N
362481	1678	26640830411000	26014	12665	57	0	\N
362482	1678	26640830412000	26014	12665	58	0	\N
362483	1678	26640830413000	26014	12665	59	0	\N
362484	1678	26640830414000	26014	12665	60	0	\N
362485	1678	26640830415000	26014	12665	61	0	\N
362486	1678	26640830416000	26014	12665	62	0	\N
362487	1678	26640830417000	26014	12665	63	0	\N
362488	1678	26640830418000	26014	12665	64	0	\N
362489	1678	26640830419000	26014	12665	65	0	\N
362490	1678	26640830420000	26014	12665	66	0	\N
362491	1678	26640830421000	26014	12665	67	0	\N
362492	1678	26640830422000	26014	12665	68	0	\N
362493	1678	26640830423000	26014	12665	69	0	\N
362494	1678	26640830424000	26014	12665	70	0	\N
362495	1678	26640830425000	26014	12665	71	0	\N
362496	1678	26640830426000	26014	12665	72	0	\N
362497	1678	26640830427000	26014	12665	73	0	\N
362498	1678	26640830428000	26014	12665	74	0	\N
362499	1678	26640830429000	26014	12665	75	0	\N
362500	1678	26640830430000	26014	12665	76	0	\N
362501	1678	26640830431000	26014	12665	77	0	\N
362502	1678	26640830432000	26014	12665	78	0	\N
362503	1678	26640830433000	26014	12665	79	0	\N
362504	1678	26640830434000	26014	12665	80	0	\N
362505	1678	26640830435000	26014	12665	81	0	\N
362506	1678	26640830436000	26014	12665	82	0	\N
362507	1678	26640830437000	26014	12665	83	0	\N
362508	1678	26640830438000	26014	12665	84	0	\N
362509	1678	26640830439000	26014	12665	86	0	\N
362510	1678	26640830440000	26014	12665	87	0	\N
362511	1678	26640830441000	26014	12665	88	0	\N
362512	1678	26640830442000	26014	12665	89	0	\N
362513	1678	26640830443000	26014	12665	90	0	\N
362514	1678	26640830444000	26014	12665	91	0	\N
362515	1678	26640830445000	26014	12665	92	0	\N
362516	1678	26640830446000	26014	12665	93	0	\N
362517	1678	26640830447000	26014	12665	94	0	\N
362518	1678	26640830448000	26014	12665	95	0	\N
362519	1678	26640830449000	26014	12665	96	0	\N
362520	1678	26640830450000	26014	12665	97	0	\N
362521	1678	26640830451000	26014	12665	98	0	\N
362522	1678	26640830452000	26014	12665	99	0	\N
362523	1678	26640830453000	26014	12665	100	0	\N
362524	1678	26640830454000	26014	12665	101	0	\N
362525	1678	26640830455000	26014	12665	102	0	\N
362526	1678	26640830456000	26014	12665	103	0	\N
362527	1678	26640830457000	26014	12665	104	0	\N
362528	1678	26640830458000	26014	12665	105	0	\N
362529	1678	26640830459000	26014	12665	106	0	\N
362530	1678	26640830460000	26014	12665	107	0	\N
362531	1678	26640830461000	26014	12665	108	0	\N
362532	1678	26640830462000	26014	12665	109	0	\N
362533	1678	26640830463000	26014	12665	110	0	\N
362534	1678	26640830464000	26014	12665	111	0	\N
362535	1678	26640830465000	26014	12665	112	0	\N
362536	1678	26640830466000	26014	12665	113	0	\N
362537	1678	26640830467000	26014	12665	114	0	\N
362538	1678	26640830468000	26014	12665	115	0	\N
362539	1678	26640830469000	26014	12665	116	0	\N
362540	1678	26640830470000	26014	12665	117	0	\N
362541	1678	26640830471000	26014	12665	118	0	\N
362542	1678	26640830472000	26014	12665	119	0	\N
362543	1678	26640830473000	26014	12665	120	0	\N
362544	1678	26640830474000	26014	12665	121	0	\N
362545	1678	26640830475000	26014	12665	122	0	\N
362546	1678	26640830476000	26014	12665	123	0	\N
362547	1678	26640830477000	26014	12665	124	0	\N
362548	1678	26640830478000	26014	12665	125	0	\N
362552	1678	26640830637000	26016	12858	0	0	\N
362553	1874	30617000	26016	12858	1	0	\N
362554	1874	30620000	26016	12858	2	0	\N
362555	1678	26640830638000	26018	12859	0	0	\N
362556	1874	30623000	26018	12859	1	0	\N
362557	1874	30625000	26018	12859	2	0	\N
362558	1874	30622000	26019	12859	0	0	\N
362564	1678	26640830640000	26022	12861	0	0	\N
362565	1874	30631000	26022	12861	1	0	\N
362570	1678	26640830641000	26025	12862	0	0	\N
362571	1874	30634000	26025	12862	1	0	\N
362574	1678	26640830643000	26028	12864	0	0	\N
362575	1874	30640000	26028	12864	1	0	\N
362576	1678	26640830643000	26029	12864	0	0	\N
362551	1874	30620000	26015	12858	2	0	2
362559	1678	26640830638000	26020	12859	0	0	1
362560	1874	30623000	26020	12859	1	0	2
362561	1874	30625000	26020	12859	2	0	2
362562	1678	26640830639000	26021	12860	0	0	1
362566	1678	26640830640000	26023	12861	0	0	1
362567	1874	30631000	26023	12861	1	0	2
362568	1678	26640830641000	26024	12862	0	0	1
362569	1874	30634000	26024	12862	1	0	2
362572	1678	26640830642000	26026	12863	0	0	1
362577	1874	30640000	26029	12864	1	0	\N
362580	1678	26640830643000	26031	12864	0	0	\N
362581	1874	30640000	26031	12864	1	0	\N
362582	2327	10000000	26033	12748	0	0	\N
362583	1678	26640840476000	26033	12748	1	0	\N
362584	1397	1284894624000	26033	12748	2	0	\N
362585	2327	124010000000	26033	12748	3	0	\N
362586	1678	26640830477000	26033	12748	4	0	\N
362587	1678	26640830478000	26033	12748	5	0	\N
362588	1678	26640830479000	26033	12748	6	0	\N
362589	1678	26640830480000	26033	12748	7	0	\N
362590	1678	26640830481000	26033	12748	8	0	\N
362591	1678	26640830482000	26033	12748	9	0	\N
362592	1678	26640830483000	26033	12748	10	0	\N
362593	1678	26640830484000	26033	12748	11	0	\N
362594	1678	26640830485000	26033	12748	12	0	\N
362595	1678	26640830486000	26033	12748	13	0	\N
362596	1678	26640830487000	26033	12748	14	0	\N
362597	1678	26640830488000	26033	12748	15	0	\N
362598	1678	26640830489000	26033	12748	16	0	\N
362599	1678	26640830490000	26033	12748	17	0	\N
362600	1678	26640830491000	26033	12748	18	0	\N
362601	1678	26640830492000	26033	12748	19	0	\N
362602	1678	26640830493000	26033	12748	20	0	\N
362603	1678	26640830494000	26033	12748	21	0	\N
362604	1678	26640830495000	26033	12748	22	0	\N
362605	1678	26640830496000	26033	12748	23	0	\N
362606	1678	26640830497000	26033	12748	24	0	\N
362607	1678	26640830498000	26033	12748	25	0	\N
362608	1678	26640830499000	26033	12748	26	0	\N
362609	1678	26640830500000	26033	12748	27	0	\N
362610	1678	26640830501000	26033	12748	28	0	\N
362611	1678	26640830502000	26033	12748	29	0	\N
362612	1678	26640830503000	26033	12748	30	0	\N
362613	1678	26640830504000	26033	12748	31	0	\N
362614	1678	26640830505000	26033	12748	32	0	\N
362615	1678	26640830506000	26033	12748	33	0	\N
362616	1678	26640830507000	26033	12748	34	0	\N
362617	1678	26640830508000	26033	12748	35	0	\N
362618	1678	26640830509000	26033	12748	36	0	\N
362619	1678	26640830510000	26033	12748	37	0	\N
362620	1678	26640830511000	26033	12748	38	0	\N
362621	1678	26640830512000	26033	12748	39	0	\N
362622	1678	26640830513000	26033	12748	40	0	\N
362623	1678	26640830514000	26033	12748	41	0	\N
362624	1678	26640830515000	26033	12748	42	0	\N
362625	1678	26640830516000	26033	12748	43	0	\N
362626	1678	26640830517000	26033	12748	44	0	\N
362627	1678	26640830518000	26033	12748	45	0	\N
362628	1678	26640830519000	26033	12748	46	0	\N
362629	1678	26640830520000	26033	12748	47	0	\N
362630	1678	26640830521000	26033	12748	48	0	\N
362631	1678	26640830522000	26033	12748	49	0	\N
362632	1678	26640830523000	26033	12748	50	0	\N
362633	1678	26640830524000	26033	12748	51	0	\N
362634	1678	26640830525000	26033	12748	52	0	\N
362635	1678	26640830526000	26033	12748	53	0	\N
362636	1678	26640830527000	26033	12748	54	0	\N
362637	1678	26640830528000	26033	12748	55	0	\N
362638	1678	26640830529000	26033	12748	56	0	\N
362639	1678	26640830530000	26033	12748	57	0	\N
362640	1678	26640830531000	26033	12748	58	0	\N
362641	1678	26640830532000	26033	12748	59	0	\N
362642	1678	26640830533000	26033	12748	60	0	\N
362643	1678	26640830534000	26033	12748	61	0	\N
362644	1678	26640830535000	26033	12748	62	0	\N
362645	1678	26640830536000	26033	12748	63	0	\N
362646	1678	26640830537000	26033	12748	65	0	\N
362647	1678	26640830538000	26033	12748	66	0	\N
362648	1678	26640830539000	26033	12748	67	0	\N
362649	1678	26640830540000	26033	12748	68	0	\N
362650	1678	26640830541000	26033	12748	69	0	\N
362651	1678	26640830542000	26033	12748	70	0	\N
362652	1678	26640830543000	26033	12748	71	0	\N
362653	1678	26640830544000	26033	12748	72	0	\N
362654	1678	26640830545000	26033	12748	73	0	\N
362655	1678	26640830546000	26033	12748	74	0	\N
362656	1678	26640830547000	26033	12748	75	0	\N
362657	1678	26640830548000	26033	12748	76	0	\N
362658	1678	26640830549000	26033	12748	77	0	\N
362659	1678	26640830550000	26033	12748	78	0	\N
362660	1678	26640830551000	26033	12748	79	0	\N
362661	1678	26640830552000	26033	12748	80	0	\N
362662	1678	26640830553000	26033	12748	81	0	\N
362663	1678	26640830554000	26033	12748	82	0	\N
362664	1678	26640830555000	26033	12748	83	0	\N
362665	1678	26640830556000	26033	12748	84	0	\N
362666	1678	26640830557000	26033	12748	85	0	\N
362667	1678	26640830558000	26033	12748	86	0	\N
362668	1678	26640830559000	26033	12748	87	0	\N
362669	1678	26640830560000	26033	12748	88	0	\N
362670	1678	26640830561000	26033	12748	89	0	\N
362671	1678	26640830562000	26033	12748	90	0	\N
362672	1678	26640830563000	26033	12748	91	0	\N
362673	1678	26640830564000	26033	12748	92	0	\N
362674	1678	26640830565000	26033	12748	93	0	\N
362675	1678	26640830566000	26033	12748	94	0	\N
362676	1678	26640830567000	26033	12748	95	0	\N
362677	1678	26640830568000	26033	12748	96	0	\N
362678	1678	26640830569000	26033	12748	97	0	\N
362679	1678	26640830570000	26033	12748	98	0	\N
362680	1678	26640830571000	26033	12748	99	0	\N
362681	1678	26640830572000	26033	12748	100	0	\N
362682	1678	26640830573000	26033	12748	101	0	\N
362683	1678	26640830574000	26033	12748	102	0	\N
362684	1678	26640830575000	26033	12748	103	0	\N
362685	1678	26640830576000	26033	12748	104	0	\N
362686	1678	26640830577000	26033	12748	105	0	\N
362687	1678	26640830578000	26033	12748	106	0	\N
362688	1678	26640830579000	26033	12748	107	0	\N
362689	1678	26640830580000	26033	12748	108	0	\N
362690	1678	26640830581000	26033	12748	109	0	\N
362691	1678	26640830582000	26033	12748	110	0	\N
362692	1678	26640830583000	26033	12748	111	0	\N
362693	1678	26640830584000	26033	12748	112	0	\N
362694	1678	26640830585000	26033	12748	113	0	\N
362695	1678	26640830586000	26033	12748	114	0	\N
362696	1678	26640830587000	26033	12748	115	0	\N
362697	1678	26640830588000	26033	12748	116	0	\N
362698	1678	26640830589000	26033	12748	117	0	\N
362699	1678	26640830590000	26033	12748	118	0	\N
362700	1678	26640830591000	26033	12748	119	0	\N
362701	1678	26640830592000	26033	12748	120	0	\N
362702	1678	26640830593000	26033	12748	121	0	\N
362703	1678	26640830594000	26033	12748	122	0	\N
362704	1678	26640830595000	26033	12748	123	0	\N
362705	1678	26640830596000	26033	12748	124	0	\N
362706	1678	26640830597000	26033	12748	125	0	\N
362707	1678	26640830644000	26036	12865	0	0	1
362708	1874	30643000	26036	12865	1	0	2
362709	1678	26640830645000	26037	12866	0	0	1
362710	1678	26640830646000	26037	12866	1	0	1
362711	1874	30646000	26037	12866	2	0	2
362713	1678	26640830645000	26038	12866	0	0	\N
362714	1678	26640830646000	26038	12866	1	0	\N
362715	1874	30646000	26038	12866	2	0	\N
362716	1874	30649000	26038	12866	3	0	\N
362717	1678	26640830645000	26039	12866	0	0	\N
362718	1678	26640830646000	26039	12866	1	0	\N
362719	1874	30646000	26039	12866	2	0	\N
362720	1874	30649000	26039	12866	3	0	\N
362723	1678	26640830648000	26041	12868	0	0	\N
362724	1874	30655000	26041	12868	1	0	\N
362725	1678	26640830648000	26042	12868	0	0	\N
362726	1874	30655000	26042	12868	1	0	\N
362727	1678	26640830648000	26043	12868	0	0	\N
362728	1874	30655000	26043	12868	1	0	\N
362737	1678	26640830652000	26047	12871	0	0	\N
362738	1678	26640830653000	26047	12871	1	0	\N
362762	801	14036777239666	26051	12874	0	0	\N
362763	802	154404414900275	26051	12874	1	0	\N
362764	811	108632665328286	26051	12874	2	0	\N
362765	812	1194958275746140	26051	12874	3	0	\N
362766	823	1743175806087760	26051	12874	4	0	\N
362767	824	19174917132499700	26051	12874	5	0	\N
362768	1900	65126000	26051	12874	6	0	\N
362769	2177	78208862930741	26051	12874	7	0	\N
362770	1678	26640830657000	26051	12874	8	0	\N
362771	1874	30685000	26051	12874	9	0	\N
362784	801	14036777239666	26054	12875	0	0	\N
362785	802	154404414900275	26054	12875	1	0	\N
362786	811	108632665328286	26054	12875	2	0	\N
362787	812	1194958275746140	26054	12875	3	0	\N
362788	823	1743175806087760	26054	12875	4	0	\N
362789	824	19174917132499700	26054	12875	5	0	\N
362790	1900	65126000	26054	12875	6	0	\N
362791	2177	78208862930741	26054	12875	7	0	\N
362792	1678	26640830658000	26054	12875	8	0	\N
362793	1874	30688000	26054	12875	9	0	\N
362796	1678	26640830659000	26057	12876	0	0	\N
362797	1874	30691000	26057	12876	1	0	\N
362806	31	1332497303438000	26060	12862	0	0	\N
362807	32	74402705100000	26060	12862	1	0	\N
362808	40	66695350031000	26060	12862	2	0	\N
362809	779	28070876565792	26060	12862	3	0	\N
362810	780	308779372753051	26060	12862	4	0	\N
362811	782	2470185021667720	26060	12862	5	0	\N
362812	785	224562470676807	26060	12862	6	0	\N
362813	786	2470185021667720	26060	12862	7	0	\N
362814	791	56141753131584	26060	12862	8	0	\N
362815	792	617558745507101	26060	12862	9	0	\N
362816	799	14034180722181	26060	12862	10	0	\N
362817	800	154375853226607	26060	12862	11	0	\N
362818	801	14036777239666	26060	12862	12	0	\N
362819	802	154404414900275	26060	12862	13	0	\N
362820	811	108632665328286	26060	12862	14	0	\N
362821	812	1194958275746140	26060	12862	15	0	\N
362822	823	1743175806087760	26060	12862	16	0	\N
362823	824	19174917132499700	26060	12862	17	0	\N
362824	1900	65126000	26060	12862	18	0	\N
362825	2177	78208862930741	26060	12862	19	0	\N
362826	1678	26640830641000	26060	12862	20	0	\N
362827	1678	26640830642000	26060	12862	21	0	\N
362828	1678	26640830643000	26060	12862	22	0	\N
362829	1678	26640830644000	26060	12862	23	0	\N
362830	1678	26640830645000	26060	12862	24	0	\N
362831	1678	26640830646000	26060	12862	25	0	\N
362832	1678	26640830647000	26060	12862	26	0	\N
362833	1678	26640830648000	26060	12862	27	0	\N
362834	1678	26640830649000	26060	12862	28	0	\N
362835	1678	26640830650000	26060	12862	29	0	\N
362836	1678	26640830651000	26060	12862	30	0	\N
362837	1678	26640830652000	26060	12862	31	0	\N
362838	1678	26640830653000	26060	12862	32	0	\N
362839	1678	26640830654000	26060	12862	33	0	\N
362840	1678	26640830655000	26060	12862	34	0	\N
362841	1678	26640830656000	26060	12862	35	0	\N
362842	1678	26640830657000	26060	12862	36	0	\N
362843	1678	26640830658000	26060	12862	37	0	\N
362844	1678	26640830659000	26060	12862	38	0	\N
362845	1678	26640830660000	26060	12862	39	0	\N
362846	1678	26640830661000	26060	12862	40	0	\N
362847	1874	30634000	26060	12862	41	0	\N
362848	1874	30637000	26060	12862	42	0	\N
362729	1678	26640830648000	26044	12868	0	0	1
362730	1874	30655000	26044	12868	1	0	2
362731	1678	26640830649000	26045	12869	0	0	1
362732	1874	30658000	26045	12869	1	0	2
362733	1678	26640830650000	26046	12870	0	0	1
362735	1874	30661000	26046	12870	2	0	2
362736	1874	30664000	26046	12870	3	0	2
362739	1678	26640830652000	26048	12871	0	0	1
362740	1678	26640830653000	26048	12871	1	0	1
362741	31	1332497303438000	26049	12872	0	0	0
362743	1678	26640830655000	26049	12872	2	0	1
362744	32	74402705100000	26049	12872	3	0	0
362745	40	66695350031000	26049	12872	4	0	0
362746	779	28070876565792	26049	12872	5	0	0
362748	1874	30670000	26049	12872	7	0	2
362749	1874	30673000	26049	12872	8	0	2
362750	1874	30676000	26049	12872	9	0	2
362751	1874	30679000	26049	12872	10	0	2
362752	780	308779372753051	26050	12873	0	0	0
362754	782	2470185021667720	26050	12873	3	0	0
362755	785	224562470676807	26050	12873	4	0	0
362756	786	2470185021667720	26050	12873	5	0	0
362757	791	56141753131584	26050	12873	6	0	0
362758	792	617558745507101	26050	12873	7	0	0
362760	800	154375853226607	26050	12873	9	0	0
362761	1874	30682000	26050	12873	10	0	2
362772	1678	26640830657000	26052	12874	0	0	1
362773	1874	30685000	26052	12874	1	0	2
362775	802	154404414900275	26053	12875	1	0	0
362776	811	108632665328286	26053	12875	2	0	0
362777	812	1194958275746140	26053	12875	3	0	0
362778	823	1743175806087760	26053	12875	4	0	0
362779	824	19174917132499700	26053	12875	5	0	0
362781	2177	78208862930741	26053	12875	7	0	0
362782	1678	26640830658000	26053	12875	8	0	1
362783	1874	30688000	26053	12875	9	0	2
362794	1678	26640830659000	26056	12876	0	0	1
362795	1874	30691000	26056	12876	1	0	2
362799	1874	30694000	26058	12877	1	0	2
362800	1	376405981756000	26059	12878	0	0	0
362801	841	84252812686298	26059	12878	1	0	0
362802	843	157077624077667	26059	12878	2	0	0
362804	1678	26640830661000	26059	12878	4	0	1
362805	1874	30697000	26059	12878	5	0	2
362849	1874	30640000	26060	12862	43	0	\N
362850	1874	30643000	26060	12862	44	0	\N
362851	1874	30646000	26060	12862	45	0	\N
362852	1874	30649000	26060	12862	46	0	\N
362853	1874	30652000	26060	12862	47	0	\N
362854	1874	30655000	26060	12862	48	0	\N
362855	1874	30658000	26060	12862	49	0	\N
362856	1874	30661000	26060	12862	50	0	\N
362857	1874	30664000	26060	12862	51	0	\N
362858	1874	30667000	26060	12862	52	0	\N
362859	1874	30670000	26060	12862	53	0	\N
362860	1874	30673000	26060	12862	54	0	\N
362861	1874	30676000	26060	12862	55	0	\N
362862	1874	30679000	26060	12862	56	0	\N
362863	1874	30682000	26060	12862	57	0	\N
362864	1874	30685000	26060	12862	59	0	\N
362865	1874	30688000	26060	12862	60	0	\N
362866	1874	30691000	26060	12862	61	0	\N
362867	1874	30694000	26060	12862	62	0	\N
362868	1874	30697000	26060	12862	63	0	\N
362884	1678	26640830663000	26063	12880	0	0	\N
362885	1678	26640830664000	26063	12880	1	0	\N
362886	1874	30703000	26063	12880	2	0	\N
362887	1874	30706000	26063	12880	3	0	\N
362912	1678	26640830668000	26066	12882	0	0	\N
362913	1678	26640830669000	26066	12882	1	0	\N
362914	875	214471371336583	26066	12882	2	0	\N
362915	1678	26640830670000	26066	12882	3	0	\N
362916	1678	26640830671000	26066	12882	4	0	\N
362917	1874	30718000	26066	12882	5	0	\N
362918	1874	30721000	26066	12882	6	0	\N
362919	1874	30724000	26066	12882	7	0	\N
362920	1874	30727000	26066	12882	8	0	\N
362921	1678	26640830672000	26067	12883	0	0	\N
362922	879	135932559298750	26067	12883	1	0	\N
362923	1678	26640830673000	26067	12883	2	0	\N
362924	881	589041090291250	26067	12883	3	0	\N
362925	1874	30730000	26067	12883	4	0	\N
362926	1874	30733000	26067	12883	5	0	\N
362941	1678	26640830674000	26070	12884	0	0	\N
362942	1678	26640830675000	26070	12884	1	0	\N
362943	1678	26640830676000	26070	12884	2	0	\N
362944	1874	30736000	26070	12884	3	0	\N
362945	1874	30739000	26070	12884	4	0	\N
362946	1874	30742000	26070	12884	5	0	\N
362951	1678	26640830678000	26072	12885	0	0	\N
362952	1678	26640830679000	26072	12885	1	0	\N
362953	1874	30748000	26072	12885	2	0	\N
362954	1874	30751000	26072	12885	3	0	\N
362957	1678	26640830680000	26074	12886	0	0	\N
362958	1874	30754000	26074	12886	1	0	\N
362961	1678	26640830681000	26076	12887	0	0	\N
362962	1874	30757000	26076	12887	1	0	\N
362963	1678	26640830681000	26077	12887	0	0	\N
362964	1874	30757000	26077	12887	1	0	\N
362965	1678	26640830682000	26078	12888	0	0	\N
362966	1874	30760000	26078	12888	1	0	\N
362969	1678	26640830683000	26080	12889	0	0	\N
362970	1874	30763000	26080	12889	2	0	\N
362971	1678	26640830683000	26081	12889	0	0	\N
362972	1874	30763000	26081	12889	2	0	\N
362975	1678	26640830683000	26083	12889	0	0	\N
362976	1874	30763000	26083	12889	2	0	\N
362871	853	248413580356225	26061	12879	2	0	0
362872	855	131401473988125	26061	12879	3	0	0
362873	857	331326853191608	26061	12879	4	0	0
362874	861	457639616303125	26061	12879	5	0	0
362875	865	401756230813417	26061	12879	6	0	0
362877	869	261664739344845	26061	12879	8	0	0
362878	873	2446786067934000	26061	12879	9	0	0
362879	1874	30700000	26061	12879	10	0	2
362880	1678	26640830663000	26062	12880	0	0	1
362881	1678	26640830664000	26062	12880	1	0	1
362883	1874	30706000	26062	12880	3	0	2
362888	883	90621706198500	26064	12881	0	0	0
362889	887	270468638103154	26064	12881	1	0	0
362890	889	227043924783249	26064	12881	2	0	0
362892	897	65747860280885	26064	12881	4	0	0
362893	899	39192075495990	26064	12881	5	0	0
362894	901	117808218058250	26064	12881	6	0	0
362895	905	423656476478938	26064	12881	7	0	0
362896	2177	79792923830741	26064	12881	8	0	0
362898	1678	26640830666000	26064	12881	10	0	1
362899	1678	26640830667000	26064	12881	11	0	1
362900	1874	30709000	26064	12881	12	0	2
362901	1874	30712000	26064	12881	13	0	2
362902	1874	30715000	26064	12881	14	0	2
362904	1678	26640830669000	26065	12882	1	0	1
362905	875	214471371336583	26065	12882	2	0	0
362906	1678	26640830670000	26065	12882	3	0	1
362907	1678	26640830671000	26065	12882	4	0	1
362909	1874	30721000	26065	12882	6	0	2
362910	1874	30724000	26065	12882	7	0	2
362911	1874	30727000	26065	12882	8	0	2
362927	1678	26640830672000	26068	12883	0	0	1
362928	879	135932559298750	26068	12883	1	0	0
362930	881	589041090291250	26068	12883	3	0	0
362931	1874	30730000	26068	12883	4	0	2
362932	1874	30733000	26068	12883	5	0	2
362933	1678	26640830674000	26069	12884	0	0	1
362934	1678	26640830675000	26069	12884	1	0	1
362936	1678	26640830677000	26069	12884	3	0	1
362937	1874	30736000	26069	12884	4	0	2
362938	1874	30739000	26069	12884	5	0	2
362939	1874	30742000	26069	12884	6	0	2
362947	1678	26640830678000	26071	12885	0	0	1
362948	1678	26640830679000	26071	12885	1	0	1
362949	1874	30748000	26071	12885	2	0	2
362950	1874	30751000	26071	12885	3	0	2
362955	1678	26640830680000	26073	12886	0	0	1
362959	1678	26640830681000	26075	12887	0	0	1
362960	1874	30757000	26075	12887	1	0	2
362967	1678	26640830682000	26079	12888	0	0	1
362968	1874	30760000	26079	12888	1	0	2
362973	1678	26640830683000	26082	12889	0	0	1
362977	1678	26640830684000	26084	12890	0	0	1
362978	1678	26640830685000	26084	12890	1	0	1
362979	1678	26640830686000	26084	12890	2	0	1
362980	1678	26640830687000	26084	12890	3	0	1
362982	1874	30769000	26084	12890	5	0	2
362983	1874	30772000	26084	12890	6	0	2
362984	1874	30775000	26084	12890	7	0	2
362989	1678	26640830689000	26087	12892	0	0	\N
362990	1874	30781000	26087	12892	1	0	\N
362993	1678	26640830690000	26089	12893	0	0	\N
362994	1874	30784000	26089	12893	1	0	\N
362995	1678	26640830691000	26090	12894	0	0	\N
362996	1874	30787000	26090	12894	1	0	\N
362997	1678	26640830691000	26091	12894	0	0	\N
362998	1874	30787000	26091	12894	1	0	\N
363007	1	376405981756000	26096	12855	0	0	\N
363008	31	1332497303438000	26096	12855	1	0	\N
363009	1678	26640830634000	26096	12855	2	0	\N
363010	1678	26640830635000	26096	12855	3	0	\N
363011	1678	26640830636000	26096	12855	4	0	\N
363012	32	74402705100000	26096	12855	5	0	\N
363013	40	66695350031000	26096	12855	6	0	\N
363014	779	28070876565792	26096	12855	7	0	\N
363015	780	308779372753051	26096	12855	8	0	\N
363016	782	2470185021667720	26096	12855	9	0	\N
363017	1678	26640830637000	26096	12855	10	0	\N
363018	1678	26640830638000	26096	12855	11	0	\N
363019	1678	26640830639000	26096	12855	12	0	\N
363020	1678	26640830640000	26096	12855	13	0	\N
363021	841	84252812686298	26096	12855	14	0	\N
363022	843	157077624077667	26096	12855	15	0	\N
363023	849	1157959544926640	26096	12855	16	0	\N
363024	851	2252855616099750	26096	12855	17	0	\N
363025	853	248413580356225	26096	12855	18	0	\N
363026	855	131401473988125	26096	12855	19	0	\N
363027	857	331326853191608	26096	12855	20	0	\N
363028	861	457639616303125	26096	12855	21	0	\N
363029	865	401756230813417	26096	12855	22	0	\N
363030	867	2446786067934000	26096	12855	23	0	\N
363031	869	261664739344845	26096	12855	24	0	\N
363032	873	2446786067934000	26096	12855	25	0	\N
363033	875	214471371336583	26096	12855	26	0	\N
363034	879	135932559298750	26096	12855	27	0	\N
363035	881	589041090291250	26096	12855	28	0	\N
363036	891	498419384091750	26096	12855	29	0	\N
363037	897	65747860280885	26096	12855	30	0	\N
363038	899	39192075495990	26096	12855	31	0	\N
363039	901	117808218058250	26096	12855	32	0	\N
363040	905	423656476478938	26096	12855	33	0	\N
363041	785	224562470676807	26096	12855	34	0	\N
363042	786	2470185021667720	26096	12855	35	0	\N
363043	791	56141753131584	26096	12855	36	0	\N
363044	792	617558745507101	26096	12855	37	0	\N
363045	799	14034180722181	26096	12855	38	0	\N
363046	800	154375853226607	26096	12855	39	0	\N
363047	801	14036777239666	26096	12855	40	0	\N
363048	802	154404414900275	26096	12855	41	0	\N
363049	811	108632665328286	26096	12855	42	0	\N
363050	812	1194958275746140	26096	12855	43	0	\N
363051	823	1743175806087760	26096	12855	44	0	\N
363052	824	19174917132499700	26096	12855	45	0	\N
363053	1900	65126000	26096	12855	46	0	\N
363054	2177	78208862930741	26096	12855	47	0	\N
363055	2177	79792923830741	26096	12855	48	0	\N
363056	875	214951947700583	26096	12855	49	0	\N
363057	879	136237149952750	26096	12855	50	0	\N
363058	881	590360983123250	26096	12855	51	0	\N
363059	1678	26640830641000	26096	12855	52	0	\N
363060	1678	26640830642000	26096	12855	53	0	\N
363061	1678	26640830643000	26096	12855	54	0	\N
363062	1678	26640830644000	26096	12855	55	0	\N
363063	1678	26640830645000	26096	12855	56	0	\N
363064	1678	26640830646000	26096	12855	57	0	\N
363065	1678	26640830647000	26096	12855	58	0	\N
363066	1678	26640830648000	26096	12855	59	0	\N
363067	1678	26640830649000	26096	12855	60	0	\N
363068	1678	26640830650000	26096	12855	61	0	\N
363069	1678	26640830651000	26096	12855	62	0	\N
363070	1678	26640830652000	26096	12855	63	0	\N
363071	1678	26640830653000	26096	12855	64	0	\N
363072	1678	26640830654000	26096	12855	65	0	\N
363073	1678	26640830655000	26096	12855	66	0	\N
363074	1678	26640830656000	26096	12855	67	0	\N
363075	1678	26640830657000	26096	12855	68	0	\N
363076	1678	26640830658000	26096	12855	69	0	\N
363077	1678	26640830659000	26096	12855	70	0	\N
363078	1678	26640830660000	26096	12855	71	0	\N
363079	1678	26640830661000	26096	12855	72	0	\N
363080	1678	26640830662000	26096	12855	73	0	\N
363081	1678	26640830663000	26096	12855	74	0	\N
363082	1678	26640830664000	26096	12855	75	0	\N
363083	1678	26640830665000	26096	12855	76	0	\N
363084	1678	26640830666000	26096	12855	77	0	\N
363085	1678	26640830667000	26096	12855	78	0	\N
363086	1678	26640830668000	26096	12855	79	0	\N
363087	1678	26640830669000	26096	12855	80	0	\N
363088	1678	26640830670000	26096	12855	81	0	\N
363089	1678	26640830671000	26096	12855	82	0	\N
363090	1678	26640830672000	26096	12855	83	0	\N
363091	1678	26640830673000	26096	12855	84	0	\N
363092	1678	26640830674000	26096	12855	85	0	\N
363093	1678	26640830675000	26096	12855	86	0	\N
363094	1678	26640830676000	26096	12855	87	0	\N
363095	1678	26640830677000	26096	12855	88	0	\N
363096	1678	26640830678000	26096	12855	89	0	\N
363097	1678	26640830679000	26096	12855	90	0	\N
363098	1678	26640830680000	26096	12855	91	0	\N
363099	1678	26640830681000	26096	12855	93	0	\N
363100	1678	26640830682000	26096	12855	94	0	\N
363101	1678	26640830683000	26096	12855	95	0	\N
363102	1678	26640830684000	26096	12855	96	0	\N
363103	1678	26640830685000	26096	12855	97	0	\N
363104	1678	26640830686000	26096	12855	98	0	\N
363105	1678	26640830687000	26096	12855	99	0	\N
363106	1678	26640830688000	26096	12855	100	0	\N
363107	1678	26640830689000	26096	12855	101	0	\N
363108	1678	26640830690000	26096	12855	102	0	\N
363109	1678	26640830691000	26096	12855	103	0	\N
363110	1678	26640830692000	26096	12855	104	0	\N
363111	1678	26640830693000	26096	12855	105	0	\N
363112	1678	26640830694000	26096	12855	106	0	\N
363113	1726	1000098112000	26096	12855	107	0	\N
363114	1874	30602000	26096	12855	108	0	\N
363115	1874	30605000	26096	12855	109	0	\N
363116	1874	30607000	26096	12855	110	0	\N
363117	1874	30609000	26096	12855	111	0	\N
363118	1874	30611000	26096	12855	112	0	\N
363119	1874	30613000	26096	12855	113	0	\N
363120	1874	30616000	26096	12855	114	0	\N
362987	1678	26640830689000	26086	12892	0	0	1
362988	1874	30781000	26086	12892	1	0	2
362991	1678	26640830690000	26088	12893	0	0	1
362992	1874	30784000	26088	12893	1	0	2
362999	1678	26640830691000	26092	12894	0	0	1
363001	1678	26640830692000	26093	12895	0	0	1
363002	1874	30790000	26093	12895	1	0	2
363003	1678	26640830693000	26094	12896	0	0	1
363004	1874	30793000	26094	12896	1	0	2
363005	1678	26640830694000	26095	12897	0	0	1
363121	1874	30619000	26096	12855	115	0	\N
363122	1874	30622000	26096	12855	116	0	\N
363123	1874	30625000	26096	12855	117	0	\N
363124	1874	30628000	26096	12855	118	0	\N
363125	1874	30631000	26096	12855	119	0	\N
363126	1874	30634000	26096	12855	120	0	\N
363127	1874	30637000	26096	12855	121	0	\N
363128	1874	30640000	26096	12855	122	0	\N
363129	1874	30643000	26096	12855	123	0	\N
363130	1874	30646000	26096	12855	124	0	\N
363131	1874	30649000	26096	12855	125	0	\N
363132	1678	26640830695000	26097	12898	0	0	\N
363133	1874	30799000	26097	12898	1	0	\N
363141	1678	26640830698000	26101	12901	0	0	\N
363142	1678	26640830699000	26101	12901	1	0	\N
363143	1874	30808000	26101	12901	2	0	\N
363144	1874	30811000	26101	12901	3	0	\N
363149	1678	26640830698000	26103	12901	0	0	\N
363150	1678	26640830699000	26103	12901	1	0	\N
363151	1874	30808000	26103	12901	2	0	\N
363152	1874	30811000	26103	12901	3	0	\N
363155	1678	26640830700000	26105	12902	0	0	\N
363156	1874	30814000	26105	12902	1	0	\N
363161	2327	10000000	26107	12626	0	0	\N
363162	1	376405981756000	26107	12626	1	0	\N
363163	31	1332497303438000	26107	12626	2	0	\N
363164	32	74402705100000	26107	12626	3	0	\N
363165	40	66695350031000	26107	12626	4	0	\N
363166	779	28070876565792	26107	12626	5	0	\N
363167	780	308779372753051	26107	12626	6	0	\N
363168	782	2470185021667720	26107	12626	7	0	\N
363169	841	84252812686298	26107	12626	8	0	\N
363170	843	157077624077667	26107	12626	9	0	\N
363171	849	1157959544926640	26107	12626	10	0	\N
363172	851	2252855616099750	26107	12626	11	0	\N
363173	853	248413580356225	26107	12626	12	0	\N
363174	1397	1286684803000	26107	12626	13	0	\N
363175	855	131401473988125	26107	12626	14	0	\N
363176	857	331326853191608	26107	12626	15	0	\N
363177	861	457639616303125	26107	12626	16	0	\N
363178	865	401756230813417	26107	12626	17	0	\N
363179	867	2446786067934000	26107	12626	18	0	\N
363180	869	261664739344845	26107	12626	19	0	\N
363181	873	2446786067934000	26107	12626	20	0	\N
363182	875	214471371336583	26107	12626	21	0	\N
363183	879	135932559298750	26107	12626	22	0	\N
363184	881	589041090291250	26107	12626	23	0	\N
363185	891	498419384091750	26107	12626	24	0	\N
363186	897	65747860280885	26107	12626	25	0	\N
363187	899	39192075495990	26107	12626	26	0	\N
363188	901	117808218058250	26107	12626	27	0	\N
363189	905	423656476478938	26107	12626	28	0	\N
363190	2327	124010000000	26107	12626	29	0	\N
363191	785	224562470676807	26107	12626	30	0	\N
363192	786	2470185021667720	26107	12626	31	0	\N
363193	791	56141753131584	26107	12626	32	0	\N
363194	792	617558745507101	26107	12626	33	0	\N
363195	799	14034180722181	26107	12626	34	0	\N
363196	800	154375853226607	26107	12626	35	0	\N
363197	801	14036777239666	26107	12626	36	0	\N
363198	802	154404414900275	26107	12626	37	0	\N
363199	811	108632665328286	26107	12626	38	0	\N
363200	812	1194958275746140	26107	12626	39	0	\N
363201	823	1743175806087760	26107	12626	40	0	\N
363202	824	19174917132499700	26107	12626	41	0	\N
363203	1900	65126000	26107	12626	42	0	\N
363204	2177	78208862930741	26107	12626	43	0	\N
363205	2177	79792923830741	26107	12626	44	0	\N
363206	875	214951947700583	26107	12626	45	0	\N
363207	879	136237149952750	26107	12626	46	0	\N
363208	1726	1000098112000	26107	12626	47	0	\N
363209	1600	0	26107	12626	48	0	\N
363210	2326	0	26107	12626	50	0	\N
363211	2325	1000000000	26107	12626	51	0	\N
363212	2326	719000000000	26107	12626	52	0	\N
363213	2328	719004000000	26107	12626	53	0	\N
363214	1718	8896596519070	26107	12626	54	0	\N
363215	106	66001000000000	26107	12626	55	0	\N
363216	2326	719004000000	26107	12626	56	0	\N
363217	2325	1000000000	26107	12626	57	0	\N
363218	1678	26640830703000	26108	12904	0	0	\N
363219	1874	30823000	26108	12904	1	0	\N
363220	1678	26640830703000	26109	12904	0	0	\N
363221	1874	30823000	26109	12904	1	0	\N
363222	1678	26640830703000	26110	12904	0	0	\N
363223	1874	30823000	26110	12904	1	0	\N
363226	1678	26640830703000	26112	12904	0	0	\N
363227	1874	30823000	26112	12904	1	0	\N
363248	1678	26640830714000	26120	12912	0	0	\N
363249	1874	30856000	26120	12912	1	0	\N
363136	1678	26640830696000	26099	12899	0	0	1
363137	1600	0	26099	12899	1	0	0
363138	1874	30802000	26099	12899	2	0	2
363139	1678	26640830697000	26100	12900	0	0	1
363140	1874	30805000	26100	12900	1	0	2
363146	1678	26640830699000	26102	12901	1	0	1
363147	1874	30808000	26102	12901	2	0	2
363148	1874	30811000	26102	12901	3	0	2
363153	1678	26640830700000	26104	12902	0	0	1
363154	1874	30814000	26104	12902	1	0	2
363158	1678	26640830702000	26106	12903	1	0	1
363159	1874	30817000	26106	12903	2	0	2
363160	1874	30820000	26106	12903	3	0	2
363224	1678	26640830703000	26111	12904	0	0	1
363228	1678	26640830704000	26113	12905	0	0	1
363229	1874	30826000	26113	12905	1	0	2
363230	1678	26640830705000	26114	12906	0	0	1
363231	1874	30829000	26114	12906	1	0	2
363232	1678	26640830706000	26115	12907	0	0	1
363234	1678	26640830707000	26116	12908	0	0	1
363235	1874	30835000	26116	12908	1	0	2
363236	1678	26640830708000	26117	12909	0	0	1
363237	1678	26640830709000	26117	12909	1	0	1
363238	1874	30838000	26117	12909	2	0	2
363240	1678	26640830710000	26118	12910	0	0	1
363241	1678	26640830711000	26118	12910	1	0	1
363242	1874	30844000	26118	12910	2	0	2
363243	1874	30847000	26118	12910	3	0	2
363245	1678	26640830713000	26119	12911	1	0	1
363246	1874	30850000	26119	12911	2	0	2
363247	1874	30853000	26119	12911	3	0	2
363250	1678	26640830714000	26121	12912	0	0	1
363251	1874	30856000	26121	12912	1	0	2
363253	1678	26640830716000	26122	12913	1	0	1
363254	1874	30859000	26122	12913	2	0	2
363255	1874	30862000	26122	12913	3	0	2
363256	1678	26640830717000	26123	12914	0	0	1
363258	1678	26640830717000	26124	12914	0	0	\N
363259	1874	30865000	26124	12914	1	0	\N
363264	1678	26640830720000	26127	12917	0	0	\N
363265	1874	30874000	26127	12917	1	0	\N
363266	1678	26640830720000	26128	12917	0	0	\N
363267	1874	30874000	26128	12917	1	0	\N
363268	1678	26640830720000	26129	12917	0	0	\N
363269	1874	30874000	26129	12917	1	0	\N
363272	1678	26640830720000	26131	12917	0	0	\N
363273	1874	30874000	26131	12917	1	0	\N
363274	1678	26640830721000	26132	12918	0	0	\N
363275	1874	30877000	26132	12918	1	0	\N
363278	1678	26640830721000	26134	12918	0	0	\N
363279	1874	30877000	26134	12918	1	0	\N
363282	1678	26640830722000	26136	12919	0	0	\N
363283	1874	30880000	26136	12919	1	0	\N
363288	1678	26640830725000	26138	12921	0	0	\N
363289	1874	30889000	26138	12921	1	0	\N
363292	1678	26640830725000	26140	12921	0	0	\N
363293	1874	30889000	26140	12921	1	0	\N
363298	1678	26640830727000	26143	12923	0	0	\N
363299	1874	30895000	26143	12923	1	0	\N
363300	1678	26640830727000	26144	12923	0	0	\N
363301	1874	30895000	26144	12923	1	0	\N
363316	1678	26640830720000	26149	12917	0	0	\N
363317	1678	26640830721000	26149	12917	1	0	\N
363318	1678	26640830722000	26149	12917	2	0	\N
363319	1678	26640830723000	26149	12917	3	0	\N
363320	1678	26640830724000	26149	12917	4	0	\N
363321	1678	26640830725000	26149	12917	5	0	\N
363322	1678	26640830726000	26149	12917	6	0	\N
363323	1678	26640830727000	26149	12917	7	0	\N
363324	1678	26640830728000	26149	12917	8	0	\N
363325	1678	26640830729000	26149	12917	9	0	\N
363326	1678	26640830730000	26149	12917	10	0	\N
363327	1678	26640830731000	26149	12917	11	0	\N
363328	1678	26640830732000	26149	12917	12	0	\N
363329	1874	30873000	26149	12917	13	0	\N
363330	1874	30875000	26149	12917	14	0	\N
363331	1874	30878000	26149	12917	15	0	\N
363332	1874	30881000	26149	12917	16	0	\N
363333	1874	30883000	26149	12917	17	0	\N
363334	1874	30885000	26149	12917	18	0	\N
363335	1874	30888000	26149	12917	19	0	\N
363336	1874	30891000	26149	12917	20	0	\N
363337	1874	30894000	26149	12917	21	0	\N
363338	1874	30897000	26149	12917	22	0	\N
363339	1874	30900000	26149	12917	23	0	\N
363340	1874	30903000	26149	12917	24	0	\N
363341	1874	30906000	26149	12917	25	0	\N
363342	1874	30909000	26149	12917	26	0	\N
363343	1874	30912000	26149	12917	27	0	\N
363344	1874	30915000	26149	12917	28	0	\N
363345	1874	30918000	26149	12917	29	0	\N
363346	1678	26640830733000	26150	12928	0	0	\N
363347	1678	26640830734000	26150	12928	1	0	\N
363348	1874	30921000	26150	12928	2	0	\N
363349	1874	30924000	26150	12928	3	0	\N
363350	1874	30926000	26150	12928	4	0	\N
363351	1874	30928000	26150	12928	5	0	\N
363358	1678	26640830733000	26152	12928	0	0	\N
363359	1678	26640830734000	26152	12928	1	0	\N
363360	1874	30921000	26152	12928	2	0	\N
363361	1874	30924000	26152	12928	3	0	\N
363362	1874	30926000	26152	12928	4	0	\N
363363	1874	30928000	26152	12928	5	0	\N
363364	1678	26640830733000	26153	12928	0	0	\N
363365	1678	26640830734000	26153	12928	1	0	\N
363366	1874	30921000	26153	12928	2	0	\N
363367	1874	30924000	26153	12928	3	0	\N
363368	1874	30926000	26153	12928	4	0	\N
363369	1874	30928000	26153	12928	5	0	\N
363370	1678	26640830733000	26154	12928	0	0	\N
363371	1678	26640830734000	26154	12928	1	0	\N
363372	1874	30921000	26154	12928	2	0	\N
363373	1874	30924000	26154	12928	3	0	\N
363374	1874	30926000	26154	12928	4	0	\N
363375	1874	30928000	26154	12928	5	0	\N
363376	1678	26640830735000	26155	12929	0	0	\N
363377	1874	30930000	26155	12929	1	0	\N
363378	2330	100000000	26155	12929	2	0	\N
363379	1874	30933000	26155	12929	3	0	\N
363380	2331	100000000	26155	12929	4	0	\N
363386	1678	26640830735000	26157	12929	0	0	\N
363387	1874	30930000	26157	12929	1	0	\N
363388	2330	100000000	26157	12929	2	0	\N
363389	1874	30933000	26157	12929	3	0	\N
363390	2331	100000000	26157	12929	4	0	\N
363391	1678	26640830735000	26158	12929	0	0	\N
363392	1874	30930000	26158	12929	1	0	\N
363261	1874	30868000	26125	12915	1	0	2
363262	1678	26640830719000	26126	12916	0	0	1
363263	1874	30871000	26126	12916	2	0	2
363270	1678	26640830720000	26130	12917	0	0	1
363271	1874	30874000	26130	12917	1	0	2
363277	1874	30877000	26133	12918	1	0	2
363280	1678	26640830722000	26135	12919	0	0	1
363281	1874	30880000	26135	12919	1	0	2
363284	1678	26640830723000	26137	12920	0	0	1
363285	1678	26640830724000	26137	12920	1	0	1
363287	1874	30886000	26137	12920	3	0	2
363290	1678	26640830725000	26139	12921	0	0	1
363291	1874	30889000	26139	12921	1	0	2
363294	1678	26640830726000	26141	12922	0	0	1
363296	1678	26640830727000	26142	12923	0	0	1
363297	1874	30895000	26142	12923	1	0	2
363302	1678	26640830728000	26145	12924	0	0	1
363303	1874	30898000	26145	12924	1	0	2
363304	1678	26640830729000	26146	12925	0	0	1
363306	1874	30903000	26146	12925	2	0	2
363307	1678	26640830730000	26147	12926	0	0	1
363308	1678	26640830731000	26147	12926	1	0	1
363309	1874	30905000	26147	12926	2	0	2
363310	1874	30907000	26147	12926	3	0	2
363312	1874	30913000	26147	12926	5	0	2
363313	1678	26640830732000	26148	12927	0	0	1
363314	1874	30915000	26148	12927	1	0	2
363315	1874	30918000	26148	12927	2	0	2
363353	1678	26640830734000	26151	12928	1	0	1
363354	1874	30921000	26151	12928	2	0	2
363355	1874	30924000	26151	12928	3	0	2
363356	1874	30926000	26151	12928	4	0	2
363357	1874	30928000	26151	12928	5	0	2
363382	1874	30930000	26156	12929	1	0	2
363383	2330	100000000	26156	12929	2	0	0
363384	1874	30933000	26156	12929	3	0	2
363385	2331	100000000	26156	12929	4	0	0
363393	2330	100000000	26158	12929	2	0	\N
363394	1874	30933000	26158	12929	3	0	\N
363395	2331	100000000	26158	12929	4	0	\N
363396	1678	26640830736000	26159	12930	0	0	\N
363397	1678	26640830737000	26159	12930	1	0	\N
363398	1874	30935000	26159	12930	2	0	\N
363399	1874	30938000	26159	12930	3	0	\N
363400	2332	100000000	26159	12930	4	0	\N
363401	2333	100000000	26159	12930	5	0	\N
363402	1874	30940000	26159	12930	6	0	\N
363403	1874	30943000	26159	12930	7	0	\N
363421	1678	26640830739000	26163	12932	0	0	\N
363422	1874	30950000	26163	12932	1	0	\N
363423	1874	30953000	26163	12932	2	0	\N
363433	1678	26640830742000	26166	12934	0	0	\N
363434	1874	30966000	26166	12934	1	0	\N
363435	1874	30968000	26166	12934	2	0	\N
363450	1678	26640830746000	26174	12940	0	0	\N
363451	1678	26640830747000	26174	12940	1	0	\N
363452	1678	26640830748000	26174	12940	2	0	\N
363453	1678	26640830749000	26174	12940	3	0	\N
363454	1874	30991000	26174	12940	4	0	\N
363455	1874	30993000	26174	12940	5	0	\N
363456	1874	30994000	26174	12940	6	0	\N
363457	1874	30995000	26174	12940	7	0	\N
363458	1874	30997000	26174	12940	8	0	\N
363459	1874	30999000	26174	12940	9	0	\N
363460	1874	31001000	26174	12940	10	0	\N
363461	1874	31004000	26174	12940	11	0	\N
363462	1874	31007000	26174	12940	12	0	\N
363463	1874	31010000	26174	12940	13	0	\N
363485	1678	26640830750000	26177	12941	0	0	\N
363486	1678	26640830751000	26177	12941	1	0	\N
363487	1874	31011000	26177	12941	2	0	\N
363488	1874	31013000	26177	12941	3	0	\N
363489	1874	31016000	26177	12941	4	0	\N
363490	1874	31019000	26177	12941	5	0	\N
363491	1874	31021000	26177	12941	6	0	\N
363492	1678	26640830750000	26178	12941	0	0	\N
363493	1678	26640830751000	26178	12941	1	0	\N
363494	1874	31011000	26178	12941	2	0	\N
363495	1874	31013000	26178	12941	3	0	\N
363496	1874	31016000	26178	12941	4	0	\N
363497	1874	31019000	26178	12941	5	0	\N
363498	1874	31021000	26178	12941	6	0	\N
363506	1678	26640830754000	26181	12944	0	0	\N
363507	1874	31035000	26181	12944	1	0	\N
363508	1874	31037000	26181	12944	2	0	\N
363509	1678	26640830754000	26182	12944	0	0	\N
363510	1874	31035000	26182	12944	1	0	\N
363511	1874	31037000	26182	12944	2	0	\N
363515	1678	26640830754000	26184	12944	0	0	\N
363516	1874	31035000	26184	12944	1	0	\N
363517	1874	31037000	26184	12944	2	0	\N
363518	1678	26640830733000	26185	12918	0	0	\N
363519	1678	26640830734000	26185	12918	1	0	\N
363520	1678	26640830735000	26185	12918	2	0	\N
363521	1678	26640830736000	26185	12918	3	0	\N
363522	1678	26640830737000	26185	12918	4	0	\N
363523	1678	26640830738000	26185	12918	5	0	\N
363524	1678	26640830739000	26185	12918	6	0	\N
363525	1678	26640830740000	26185	12918	7	0	\N
363526	1678	26640830741000	26185	12918	8	0	\N
363527	1678	26640830742000	26185	12918	9	0	\N
363528	1678	26640830743000	26185	12918	10	0	\N
363406	1874	30935000	26160	12930	2	0	2
363407	1874	30938000	26160	12930	3	0	2
363408	2332	100000000	26160	12930	4	0	0
363409	2333	100000000	26160	12930	5	0	0
363410	1874	30940000	26160	12930	6	0	2
363412	1678	26640830738000	26161	12931	0	0	1
363413	1874	30945000	26161	12931	1	0	2
363414	2296	100000000	26161	12931	2	0	0
363415	2334	100000000	26161	12931	3	0	0
363416	2335	100000000	26161	12931	4	0	0
363418	1678	26640830739000	26162	12932	0	0	1
363419	1874	30950000	26162	12932	1	0	2
363420	1874	30953000	26162	12932	2	0	2
363424	1678	26640830740000	26164	12933	0	0	1
363426	1874	30956000	26164	12933	2	0	2
363427	1874	30959000	26164	12933	3	0	2
363428	1874	30961000	26164	12933	4	0	2
363429	1874	30963000	26164	12933	5	0	2
363430	1678	26640830742000	26165	12934	0	0	1
363432	1874	30968000	26165	12934	2	0	2
363436	1678	26640830743000	26167	12935	0	0	1
363437	1678	26640830744000	26167	12935	1	0	1
363438	1874	30970000	26167	12935	2	0	2
363439	1874	30972000	26167	12935	3	0	2
363441	1874	30978000	26167	12935	5	0	2
363442	2336	100000000	26167	12935	6	0	0
363443	2337	100000000	26167	12935	7	0	0
363444	1678	26640830745000	26168	12936	0	0	1
363446	1874	30983000	26168	12936	2	0	2
363447	2338	100000000	26169	12937	0	0	0
363448	1874	30985000	26169	12937	1	0	2
363449	1874	30988000	26169	12937	2	0	2
363464	1678	26640830746000	26175	12940	0	0	1
363466	1678	26640830748000	26175	12940	2	0	1
363467	1678	26640830749000	26175	12940	3	0	1
363468	1874	30991000	26175	12940	4	0	2
363469	1874	30993000	26175	12940	5	0	2
363470	1874	30994000	26175	12940	6	0	2
363472	1874	30997000	26175	12940	8	0	2
363473	1874	30999000	26175	12940	9	0	2
363474	1874	31001000	26175	12940	10	0	2
363475	1874	31004000	26175	12940	11	0	2
363477	1874	31010000	26175	12940	13	0	2
363478	1678	26640830750000	26176	12941	0	0	1
363479	1678	26640830751000	26176	12941	1	0	1
363480	1874	31011000	26176	12941	2	0	2
363481	1874	31013000	26176	12941	3	0	2
363483	1874	31019000	26176	12941	5	0	2
363484	1874	31021000	26176	12941	6	0	2
363499	1678	26640830752000	26179	12942	0	0	1
363500	1874	31023000	26179	12942	1	0	2
363501	1678	26640830753000	26180	12943	0	0	1
363503	1874	31028000	26180	12943	2	0	2
363504	1874	31031000	26180	12943	3	0	2
363505	1874	31032000	26180	12943	4	0	2
363512	1678	26640830754000	26183	12944	0	0	1
363514	1874	31037000	26183	12944	2	0	2
363529	1678	26640830744000	26185	12918	11	0	\N
363530	1678	26640830745000	26185	12918	12	0	\N
363531	1678	26640830746000	26185	12918	13	0	\N
363532	1678	26640830747000	26185	12918	14	0	\N
363533	1678	26640830748000	26185	12918	15	0	\N
363534	1678	26640830749000	26185	12918	16	0	\N
363535	1678	26640830750000	26185	12918	17	0	\N
363536	1678	26640830751000	26185	12918	18	0	\N
363537	1678	26640830752000	26185	12918	19	0	\N
363538	1678	26640830753000	26185	12918	20	0	\N
363539	1678	26640830754000	26185	12918	21	0	\N
363540	2330	100000000	26185	12918	22	0	\N
363541	1874	30921000	26185	12918	23	0	\N
363542	1874	30924000	26185	12918	24	0	\N
363543	1874	30926000	26185	12918	25	0	\N
363544	1874	30928000	26185	12918	26	0	\N
363545	1874	30930000	26185	12918	27	0	\N
363546	1874	30932000	26185	12918	28	0	\N
363547	1874	30935000	26185	12918	29	0	\N
363548	1874	30938000	26185	12918	30	0	\N
363549	1874	30939000	26185	12918	31	0	\N
363550	1874	30940000	26185	12918	32	0	\N
363551	1874	30941000	26185	12918	33	0	\N
363552	1874	30943000	26185	12918	34	0	\N
363553	1874	30945000	26185	12918	35	0	\N
363554	1874	30947000	26185	12918	36	0	\N
363555	1874	30948000	26185	12918	37	0	\N
363556	1874	30950000	26185	12918	38	0	\N
363557	1874	30952000	26185	12918	39	0	\N
363558	1874	30954000	26185	12918	40	0	\N
363559	1874	30956000	26185	12918	41	0	\N
363560	1874	30958000	26185	12918	42	0	\N
363561	1874	30960000	26185	12918	43	0	\N
363562	1874	30962000	26185	12918	44	0	\N
363563	1874	30964000	26185	12918	45	0	\N
363564	1874	30967000	26185	12918	46	0	\N
363565	2331	100000000	26185	12918	47	0	\N
363566	2332	100000000	26185	12918	48	0	\N
363567	2333	100000000	26185	12918	49	0	\N
363568	2296	100000000	26185	12918	50	0	\N
363569	2334	100000000	26185	12918	51	0	\N
363570	2335	100000000	26185	12918	52	0	\N
363571	1874	30969000	26185	12918	53	0	\N
363572	1874	30971000	26185	12918	54	0	\N
363573	1874	30973000	26185	12918	55	0	\N
363574	1874	30975000	26185	12918	56	0	\N
363575	1874	30977000	26185	12918	57	0	\N
363576	1874	30979000	26185	12918	58	0	\N
363577	1874	30981000	26185	12918	59	0	\N
363578	1874	30983000	26185	12918	60	0	\N
363579	1874	30986000	26185	12918	61	0	\N
363580	1874	30989000	26185	12918	62	0	\N
363581	1874	30992000	26185	12918	63	0	\N
363582	1874	30995000	26185	12918	64	0	\N
363583	1874	30998000	26185	12918	65	0	\N
363584	1874	31001000	26185	12918	66	0	\N
363585	1874	31004000	26185	12918	67	0	\N
363586	1874	31007000	26185	12918	68	0	\N
363587	1874	31010000	26185	12918	69	0	\N
363588	1874	31013000	26185	12918	70	0	\N
363589	1874	31016000	26185	12918	71	0	\N
363590	1874	31019000	26185	12918	72	0	\N
363591	1874	31022000	26185	12918	73	0	\N
363592	1874	31025000	26185	12918	74	0	\N
363593	1874	31028000	26185	12918	75	0	\N
363594	1874	31031000	26185	12918	76	0	\N
363595	1874	31034000	26185	12918	77	0	\N
363596	1874	31037000	26185	12918	78	0	\N
363597	2336	100000000	26185	12918	79	0	\N
363598	2337	100000000	26185	12918	80	0	\N
363599	2338	100000000	26185	12918	81	0	\N
363604	1678	26640830755000	26187	12945	0	0	\N
363605	1874	31039000	26187	12945	1	0	\N
363606	1874	31042000	26187	12945	2	0	\N
363607	2339	100000000	26187	12945	3	0	\N
363612	1678	26640830756000	26189	12946	0	0	\N
363613	2329	1440022000000	26189	12946	1	0	\N
363614	1874	31044000	26189	12946	2	0	\N
363615	1874	31047000	26189	12946	3	0	\N
363616	1678	26640830628000	26190	12851	0	0	\N
363617	1	376405981756000	26190	12851	1	0	\N
363618	31	1332497303438000	26190	12851	2	0	\N
363619	32	74402705100000	26190	12851	3	0	\N
363620	40	66695350031000	26190	12851	4	0	\N
363621	779	28070876565792	26190	12851	5	0	\N
363622	780	308779372753051	26190	12851	6	0	\N
363623	782	2470185021667720	26190	12851	7	0	\N
363624	841	84252812686298	26190	12851	8	0	\N
363625	843	157077624077667	26190	12851	9	0	\N
363626	849	1157959544926640	26190	12851	10	0	\N
363627	851	2252855616099750	26190	12851	11	0	\N
363628	853	248413580356225	26190	12851	12	0	\N
363629	855	131401473988125	26190	12851	13	0	\N
363630	857	331326853191608	26190	12851	14	0	\N
363631	861	457639616303125	26190	12851	15	0	\N
363632	865	401756230813417	26190	12851	16	0	\N
363633	867	2446786067934000	26190	12851	17	0	\N
363634	869	261664739344845	26190	12851	18	0	\N
363635	873	2446786067934000	26190	12851	19	0	\N
363636	875	214471371336583	26190	12851	20	0	\N
363637	879	135932559298750	26190	12851	21	0	\N
363638	881	589041090291250	26190	12851	22	0	\N
363639	891	498419384091750	26190	12851	23	0	\N
363640	897	65747860280885	26190	12851	24	0	\N
363641	899	39192075495990	26190	12851	25	0	\N
363642	901	117808218058250	26190	12851	26	0	\N
363643	905	423656476478938	26190	12851	27	0	\N
363644	785	224562470676807	26190	12851	28	0	\N
363645	786	2470185021667720	26190	12851	29	0	\N
363646	791	56141753131584	26190	12851	30	0	\N
363647	792	617558745507101	26190	12851	31	0	\N
363648	799	14034180722181	26190	12851	32	0	\N
363649	800	154375853226607	26190	12851	33	0	\N
363650	801	14036777239666	26190	12851	34	0	\N
363651	802	154404414900275	26190	12851	35	0	\N
363652	811	108632665328286	26190	12851	36	0	\N
363653	812	1194958275746140	26190	12851	37	0	\N
363654	823	1743175806087760	26190	12851	38	0	\N
363655	824	19174917132499700	26190	12851	39	0	\N
363656	1900	65126000	26190	12851	40	0	\N
363657	2177	78208862930741	26190	12851	41	0	\N
363658	2177	79792923830741	26190	12851	42	0	\N
363659	875	214951947700583	26190	12851	43	0	\N
363660	879	136237149952750	26190	12851	44	0	\N
363661	881	590360983123250	26190	12851	45	0	\N
363662	1678	26640830629000	26190	12851	46	0	\N
363663	1678	26640830630000	26190	12851	47	0	\N
363664	1678	26640830631000	26190	12851	48	0	\N
363602	1874	31042000	26186	12945	2	0	2
363603	2339	100000000	26186	12945	3	0	0
363608	1678	26640830756000	26188	12946	0	0	1
363609	2329	1440022000000	26188	12946	1	0	0
363610	1874	31044000	26188	12946	2	0	2
363665	1678	26640830632000	26190	12851	49	0	\N
363666	1678	26640830633000	26190	12851	50	0	\N
363667	1678	26640830634000	26190	12851	51	0	\N
363668	1678	26640830635000	26190	12851	52	0	\N
363669	1678	26640830636000	26190	12851	53	0	\N
363670	1678	26640830637000	26190	12851	54	0	\N
363671	1678	26640830638000	26190	12851	55	0	\N
363672	1678	26640830639000	26190	12851	56	0	\N
363673	1678	26640830640000	26190	12851	57	0	\N
363674	1678	26640830641000	26190	12851	58	0	\N
363675	1678	26640830642000	26190	12851	59	0	\N
363676	1678	26640830643000	26190	12851	60	0	\N
363677	1678	26640830644000	26190	12851	61	0	\N
363678	1678	26640830645000	26190	12851	62	0	\N
363679	1678	26640830646000	26190	12851	63	0	\N
363680	1678	26640830647000	26190	12851	64	0	\N
363681	1678	26640830648000	26190	12851	65	0	\N
363682	1678	26640830649000	26190	12851	66	0	\N
363683	1678	26640830650000	26190	12851	67	0	\N
363684	1678	26640830651000	26190	12851	68	0	\N
363685	1678	26640830652000	26190	12851	69	0	\N
363686	1678	26640830653000	26190	12851	70	0	\N
363687	1678	26640830654000	26190	12851	71	0	\N
363688	1678	26640830655000	26190	12851	72	0	\N
363689	1678	26640830656000	26190	12851	73	0	\N
363690	1678	26640830657000	26190	12851	74	0	\N
363691	1678	26640830658000	26190	12851	75	0	\N
363692	1678	26640830659000	26190	12851	76	0	\N
363693	1678	26640830660000	26190	12851	77	0	\N
363694	1678	26640830661000	26190	12851	78	0	\N
363695	1678	26640830662000	26190	12851	79	0	\N
363696	1678	26640830663000	26190	12851	80	0	\N
363697	1678	26640830664000	26190	12851	81	0	\N
363698	1678	26640830665000	26190	12851	82	0	\N
363699	1678	26640830666000	26190	12851	83	0	\N
363700	1678	26640830667000	26190	12851	84	0	\N
363701	1678	26640830668000	26190	12851	85	0	\N
363702	1678	26640830669000	26190	12851	86	0	\N
363703	1678	26640830670000	26190	12851	87	0	\N
363704	1678	26640830671000	26190	12851	88	0	\N
363705	1678	26640830672000	26190	12851	89	0	\N
363706	1678	26640830673000	26190	12851	90	0	\N
363707	1678	26640830674000	26190	12851	91	0	\N
363708	1678	26640830675000	26190	12851	92	0	\N
363709	1678	26640830676000	26190	12851	93	0	\N
363710	1678	26640830677000	26190	12851	94	0	\N
363711	1678	26640830678000	26190	12851	95	0	\N
363712	1678	26640830679000	26190	12851	96	0	\N
363713	1678	26640830680000	26190	12851	97	0	\N
363714	1678	26640830681000	26190	12851	98	0	\N
363715	1678	26640830682000	26190	12851	99	0	\N
363716	1678	26640830683000	26190	12851	100	0	\N
363717	1678	26640830684000	26190	12851	101	0	\N
363718	1678	26640830685000	26190	12851	102	0	\N
363719	1678	26640830686000	26190	12851	103	0	\N
363720	1678	26640830687000	26190	12851	104	0	\N
363721	1678	26640830688000	26190	12851	105	0	\N
363722	1678	26640830689000	26190	12851	106	0	\N
363723	1678	26640830690000	26190	12851	107	0	\N
363724	1678	26640830691000	26190	12851	108	0	\N
363725	1678	26640830692000	26190	12851	109	0	\N
363726	1678	26640830693000	26190	12851	110	0	\N
363727	1678	26640830694000	26190	12851	111	0	\N
363728	1678	26640830695000	26190	12851	112	0	\N
363729	1678	26640830696000	26190	12851	113	0	\N
363730	1678	26640830697000	26190	12851	114	0	\N
363731	1678	26640830698000	26190	12851	115	0	\N
363732	1678	26640830699000	26190	12851	116	0	\N
363733	1678	26640830700000	26190	12851	118	0	\N
363734	1678	26640830701000	26190	12851	119	0	\N
363735	1678	26640830702000	26190	12851	120	0	\N
363736	1678	26640830703000	26190	12851	121	0	\N
363737	1678	26640830704000	26190	12851	122	0	\N
363738	1678	26640830705000	26190	12851	123	0	\N
363739	1678	26640830706000	26190	12851	124	0	\N
363740	1678	26640830707000	26190	12851	125	0	\N
363757	1	376405981756000	26193	12863	0	0	\N
363758	1678	26640830662000	26193	12863	1	0	\N
363759	841	84252812686298	26193	12863	2	0	\N
363760	843	157077624077667	26193	12863	3	0	\N
363761	849	1157959544926640	26193	12863	4	0	\N
363762	851	2252855616099750	26193	12863	5	0	\N
363763	853	248413580356225	26193	12863	6	0	\N
363764	1678	26640830663000	26193	12863	7	0	\N
363765	855	131401473988125	26193	12863	8	0	\N
363766	857	331326853191608	26193	12863	9	0	\N
363767	861	457639616303125	26193	12863	10	0	\N
363768	865	401756230813417	26193	12863	11	0	\N
363769	867	2446786067934000	26193	12863	12	0	\N
363770	869	261664739344845	26193	12863	13	0	\N
363771	873	2446786067934000	26193	12863	14	0	\N
363772	875	214471371336583	26193	12863	15	0	\N
363773	879	135932559298750	26193	12863	16	0	\N
363774	881	589041090291250	26193	12863	17	0	\N
363775	891	498419384091750	26193	12863	18	0	\N
363776	897	65747860280885	26193	12863	19	0	\N
363777	899	39192075495990	26193	12863	20	0	\N
363778	901	117808218058250	26193	12863	21	0	\N
363779	905	423656476478938	26193	12863	22	0	\N
363780	2177	79792923830741	26193	12863	23	0	\N
363781	875	214951947700583	26193	12863	24	0	\N
363782	879	136237149952750	26193	12863	25	0	\N
363783	881	590360983123250	26193	12863	26	0	\N
363784	1678	26640830664000	26193	12863	27	0	\N
363785	1678	26640830665000	26193	12863	28	0	\N
363786	1678	26640830666000	26193	12863	29	0	\N
363787	1678	26640830667000	26193	12863	30	0	\N
363788	1678	26640830668000	26193	12863	31	0	\N
363789	1678	26640830669000	26193	12863	32	0	\N
363790	1678	26640830670000	26193	12863	33	0	\N
363791	1678	26640830671000	26193	12863	34	0	\N
363792	1678	26640830672000	26193	12863	35	0	\N
363793	1678	26640830673000	26193	12863	36	0	\N
363794	1678	26640830674000	26193	12863	37	0	\N
363795	1678	26640830675000	26193	12863	38	0	\N
363796	1678	26640830676000	26193	12863	39	0	\N
363797	1678	26640830677000	26193	12863	40	0	\N
363798	1678	26640830678000	26193	12863	41	0	\N
363799	1678	26640830679000	26193	12863	42	0	\N
363800	1678	26640830680000	26193	12863	43	0	\N
363743	1678	26640830759000	26191	12947	2	0	1
363744	1874	31050000	26191	12947	3	0	2
363745	1874	31053000	26191	12947	4	0	2
363746	1874	31055000	26191	12947	5	0	2
363747	1874	31057000	26191	12947	6	0	2
363749	1874	31062000	26191	12947	8	0	2
363750	2329	303126199819988	26191	12947	9	0	0
363751	1874	31063000	26191	12947	10	0	2
363752	1678	26640830760000	26192	12948	0	0	1
363753	1874	31064000	26192	12948	1	0	2
363755	1874	31069000	26192	12948	3	0	2
363756	2340	100000000	26192	12948	4	0	0
363801	1678	26640830681000	26193	12863	44	0	\N
363802	1678	26640830682000	26193	12863	45	0	\N
363803	1678	26640830683000	26193	12863	46	0	\N
363804	1678	26640830684000	26193	12863	47	0	\N
363805	1678	26640830685000	26193	12863	48	0	\N
363806	1678	26640830686000	26193	12863	49	0	\N
363807	1678	26640830687000	26193	12863	50	0	\N
363808	1678	26640830688000	26193	12863	51	0	\N
363809	1678	26640830689000	26193	12863	52	0	\N
363810	1678	26640830690000	26193	12863	53	0	\N
363811	1678	26640830691000	26193	12863	54	0	\N
363812	1678	26640830692000	26193	12863	55	0	\N
363813	1678	26640830693000	26193	12863	56	0	\N
363814	1678	26640830694000	26193	12863	57	0	\N
363815	1678	26640830695000	26193	12863	58	0	\N
363816	1678	26640830696000	26193	12863	59	0	\N
363817	1678	26640830697000	26193	12863	60	0	\N
363818	1678	26640830698000	26193	12863	61	0	\N
363819	1678	26640830699000	26193	12863	62	0	\N
363820	1678	26640830700000	26193	12863	63	0	\N
363821	1678	26640830701000	26193	12863	64	0	\N
363822	1678	26640830702000	26193	12863	65	0	\N
363823	1678	26640830703000	26193	12863	66	0	\N
363824	1678	26640830704000	26193	12863	67	0	\N
363825	1678	26640830705000	26193	12863	68	0	\N
363826	1678	26640830706000	26193	12863	69	0	\N
363827	1678	26640830707000	26193	12863	70	0	\N
363828	1678	26640830708000	26193	12863	71	0	\N
363829	1678	26640830709000	26193	12863	72	0	\N
363830	1678	26640830710000	26193	12863	73	0	\N
363831	1678	26640830711000	26193	12863	74	0	\N
363832	1678	26640830712000	26193	12863	75	0	\N
363833	1678	26640830713000	26193	12863	76	0	\N
363834	1678	26640830714000	26193	12863	77	0	\N
363835	1678	26640830715000	26193	12863	78	0	\N
363836	1678	26640830716000	26193	12863	79	0	\N
363837	1678	26640830717000	26193	12863	80	0	\N
363838	1678	26640830718000	26193	12863	81	0	\N
363839	1678	26640830719000	26193	12863	82	0	\N
363840	1678	26640830720000	26193	12863	83	0	\N
363841	1678	26640830721000	26193	12863	84	0	\N
363842	1678	26640830722000	26193	12863	85	0	\N
363843	1678	26640830723000	26193	12863	86	0	\N
363844	1678	26640830724000	26193	12863	87	0	\N
363845	1678	26640830725000	26193	12863	88	0	\N
363846	1678	26640830726000	26193	12863	89	0	\N
363847	1678	26640830727000	26193	12863	90	0	\N
363848	1678	26640830728000	26193	12863	91	0	\N
363849	1678	26640830729000	26193	12863	92	0	\N
363850	1678	26640830730000	26193	12863	93	0	\N
363851	1678	26640830731000	26193	12863	94	0	\N
363852	1678	26640830732000	26193	12863	95	0	\N
363853	1678	26640830733000	26193	12863	96	0	\N
363854	1678	26640830734000	26193	12863	97	0	\N
363855	1678	26640830735000	26193	12863	98	0	\N
363856	1678	26640830736000	26193	12863	99	0	\N
363857	1678	26640830737000	26193	12863	100	0	\N
363858	1678	26640830738000	26193	12863	101	0	\N
363859	1678	26640830739000	26193	12863	102	0	\N
363860	1678	26640830740000	26193	12863	103	0	\N
363861	1678	26640830741000	26193	12863	104	0	\N
363862	1678	26640830742000	26193	12863	105	0	\N
363863	1678	26640830743000	26193	12863	106	0	\N
363864	1678	26640830744000	26193	12863	107	0	\N
363865	1678	26640830745000	26193	12863	108	0	\N
363866	1678	26640830746000	26193	12863	109	0	\N
363867	1678	26640830747000	26193	12863	110	0	\N
363868	1678	26640830748000	26193	12863	111	0	\N
363869	1678	26640830749000	26193	12863	112	0	\N
363870	1678	26640830750000	26193	12863	113	0	\N
363871	1678	26640830751000	26193	12863	114	0	\N
363872	1678	26640830752000	26193	12863	115	0	\N
363873	1678	26640830753000	26193	12863	116	0	\N
363874	1678	26640830754000	26193	12863	117	0	\N
363875	1678	26640830755000	26193	12863	118	0	\N
363876	1678	26640830756000	26193	12863	119	0	\N
363877	1678	26640830757000	26193	12863	121	0	\N
363878	1678	26640830758000	26193	12863	122	0	\N
363879	1678	26640830759000	26193	12863	123	0	\N
363880	1678	26640830760000	26193	12863	124	0	\N
363881	1874	30699000	26193	12863	125	0	\N
363882	1678	26640830761000	26194	12949	0	0	\N
363883	1678	26640830762000	26194	12949	1	0	\N
363884	1874	31072000	26194	12949	2	0	\N
363885	1874	31075000	26194	12949	3	0	\N
363886	1874	31077000	26194	12949	4	0	\N
363887	1874	31079000	26194	12949	5	0	\N
363894	1678	26640830763000	26196	12950	0	0	\N
363895	2341	100000000	26196	12950	1	0	\N
363896	1874	31080000	26196	12950	2	0	\N
363897	1874	31083000	26196	12950	3	0	\N
363898	1874	31085000	26196	12950	4	0	\N
363904	1678	26640830763000	26198	12950	0	0	\N
363905	2341	100000000	26198	12950	1	0	\N
363906	1874	31080000	26198	12950	2	0	\N
363907	1874	31083000	26198	12950	3	0	\N
363908	1874	31085000	26198	12950	4	0	\N
363917	1874	31098000	26202	12953	0	0	\N
363918	1874	31100000	26202	12953	1	0	\N
363923	1678	26640830766000	26204	12954	0	0	\N
363924	1874	31103000	26204	12954	1	0	\N
363925	1874	31104000	26204	12954	2	0	\N
363926	1874	31106000	26204	12954	3	0	\N
363890	1874	31072000	26195	12949	2	0	2
363891	1874	31075000	26195	12949	3	0	2
363892	1874	31077000	26195	12949	4	0	2
363893	1874	31079000	26195	12949	5	0	2
363899	1678	26640830763000	26197	12950	0	0	1
363901	1874	31080000	26197	12950	2	0	2
363902	1874	31083000	26197	12950	3	0	2
363903	1874	31085000	26197	12950	4	0	2
363909	1678	26640830764000	26199	12951	0	0	1
363910	1874	31088000	26199	12951	1	0	2
363912	1678	26640830765000	26200	12952	0	0	1
363913	1874	31093000	26200	12952	1	0	2
363914	1874	31095000	26200	12952	2	0	2
363915	1874	31098000	26201	12953	0	0	2
363919	1678	26640830766000	26203	12954	0	0	1
363920	1874	31103000	26203	12954	1	0	2
363921	1874	31104000	26203	12954	2	0	2
363922	1874	31106000	26203	12954	3	0	2
363927	1678	26640830767000	26205	12955	0	0	1
363929	1678	26640830769000	26205	12955	2	0	1
363930	1678	26640830770000	26205	12955	3	0	1
363931	1874	31108000	26205	12955	4	0	2
363932	1874	31111000	26205	12955	5	0	2
363933	1874	31114000	26205	12955	6	0	2
363935	1874	31120000	26205	12955	8	0	2
363936	1874	31121000	26205	12955	9	0	2
363943	1678	26640830772000	26207	12957	0	0	\N
363944	1874	31134000	26207	12957	1	0	\N
363945	1874	31135000	26207	12957	2	0	\N
363946	1874	31138000	26207	12957	3	0	\N
363947	1678	26640830772000	26208	12957	0	0	\N
363948	1874	31134000	26208	12957	1	0	\N
363949	1874	31135000	26208	12957	2	0	\N
363950	1874	31138000	26208	12957	3	0	\N
363951	1678	26640830772000	26209	12957	0	0	\N
363952	1874	31134000	26209	12957	1	0	\N
363953	1874	31135000	26209	12957	2	0	\N
363954	1874	31138000	26209	12957	3	0	\N
363968	1678	26640830776000	26214	12961	0	0	\N
363969	1874	31154000	26214	12961	1	0	\N
363970	1874	31156000	26214	12961	2	0	\N
363971	1874	31159000	26214	12961	3	0	\N
363976	1678	26640830776000	26216	12961	0	0	\N
363977	1874	31154000	26216	12961	1	0	\N
363978	1874	31156000	26216	12961	2	0	\N
363979	1874	31159000	26216	12961	3	0	\N
363980	1678	26640830776000	26217	12961	0	0	\N
363981	1874	31154000	26217	12961	1	0	\N
363982	1874	31156000	26217	12961	2	0	\N
363983	1874	31159000	26217	12961	3	0	\N
363994	1678	26640830779000	26220	12963	0	0	\N
363995	1874	31171000	26220	12963	1	0	\N
363996	1874	31174000	26220	12963	2	0	\N
363997	1874	31175000	26220	12963	3	0	\N
363998	1678	26640830780000	26221	12964	0	0	\N
363999	1874	31178000	26221	12964	1	0	\N
364000	1874	31180000	26221	12964	2	0	\N
364004	1678	26640830781000	26223	12965	0	0	\N
364005	1678	26640830782000	26223	12965	1	0	\N
364006	1874	31181000	26223	12965	2	0	\N
364007	1874	31183000	26223	12965	3	0	\N
364008	1874	31185000	26223	12965	4	0	\N
364009	1874	31188000	26223	12965	5	0	\N
364010	1874	31191000	26223	12965	6	0	\N
364018	1678	26640830708000	26225	12852	0	0	\N
364019	1678	26640830709000	26225	12852	1	0	\N
364020	1678	26640830710000	26225	12852	2	0	\N
364021	1678	26640830711000	26225	12852	3	0	\N
364022	1678	26640830712000	26225	12852	4	0	\N
364023	1678	26640830713000	26225	12852	5	0	\N
364024	1678	26640830714000	26225	12852	6	0	\N
364025	1678	26640830715000	26225	12852	7	0	\N
364026	1678	26640830716000	26225	12852	8	0	\N
364027	1678	26640830717000	26225	12852	9	0	\N
364028	1678	26640830718000	26225	12852	10	0	\N
364029	1678	26640830719000	26225	12852	11	0	\N
364030	1678	26640830720000	26225	12852	12	0	\N
364031	1678	26640830721000	26225	12852	13	0	\N
364032	1678	26640830722000	26225	12852	14	0	\N
364033	1678	26640830723000	26225	12852	15	0	\N
364034	1678	26640830724000	26225	12852	16	0	\N
364035	1678	26640830725000	26225	12852	17	0	\N
364036	1678	26640830726000	26225	12852	18	0	\N
364037	1678	26640830727000	26225	12852	19	0	\N
364038	1678	26640830728000	26225	12852	20	0	\N
364039	1678	26640830729000	26225	12852	21	0	\N
364040	1678	26640830730000	26225	12852	22	0	\N
364041	1678	26640830731000	26225	12852	23	0	\N
364042	1678	26640830732000	26225	12852	24	0	\N
364043	1678	26640830733000	26225	12852	25	0	\N
364044	1678	26640830734000	26225	12852	26	0	\N
364045	1678	26640830735000	26225	12852	27	0	\N
364046	1678	26640830736000	26225	12852	28	0	\N
364047	1678	26640830737000	26225	12852	29	0	\N
364048	1678	26640830738000	26225	12852	30	0	\N
364049	1678	26640830739000	26225	12852	31	0	\N
364050	1678	26640830740000	26225	12852	32	0	\N
364051	1678	26640830741000	26225	12852	33	0	\N
364052	1678	26640830742000	26225	12852	34	0	\N
364053	1678	26640830743000	26225	12852	35	0	\N
364054	1678	26640830744000	26225	12852	36	0	\N
364055	1678	26640830745000	26225	12852	37	0	\N
364056	1678	26640830746000	26225	12852	38	0	\N
364057	1678	26640830747000	26225	12852	39	0	\N
364058	1678	26640830748000	26225	12852	40	0	\N
364059	1678	26640830749000	26225	12852	41	0	\N
364060	1678	26640830750000	26225	12852	42	0	\N
364061	1678	26640830751000	26225	12852	43	0	\N
364062	1678	26640830752000	26225	12852	44	0	\N
364063	1678	26640830753000	26225	12852	45	0	\N
364064	1678	26640830754000	26225	12852	46	0	\N
364065	1678	26640830755000	26225	12852	47	0	\N
364066	1678	26640830756000	26225	12852	48	0	\N
364067	1678	26640830757000	26225	12852	49	0	\N
364068	1678	26640830758000	26225	12852	50	0	\N
364069	1678	26640830759000	26225	12852	51	0	\N
364070	1678	26640830760000	26225	12852	52	0	\N
364071	1678	26640830761000	26225	12852	53	0	\N
364072	1678	26640830762000	26225	12852	54	0	\N
363939	1874	31127000	26205	12955	12	0	2
363940	1678	26640830771000	26206	12956	0	0	1
363941	1874	31129000	26206	12956	1	0	2
363942	1874	31132000	26206	12956	2	0	2
363955	1678	26640830772000	26210	12957	0	0	1
363957	1874	31135000	26210	12957	2	0	2
363958	1874	31138000	26210	12957	3	0	2
363959	1678	26640830773000	26211	12958	0	0	1
363960	1874	31140000	26211	12958	1	0	2
363961	1874	31143000	26211	12958	2	0	2
363963	1874	31145000	26212	12959	1	0	2
363964	1874	31148000	26212	12959	2	0	2
363965	1678	26640830775000	26213	12960	0	0	1
363966	1874	31150000	26213	12960	1	0	2
363972	1678	26640830776000	26215	12961	0	0	1
363973	1874	31154000	26215	12961	1	0	2
363974	1874	31156000	26215	12961	2	0	2
363975	1874	31159000	26215	12961	3	0	2
363984	1678	26640830777000	26218	12962	0	0	1
363986	1874	31162000	26218	12962	2	0	2
363987	1874	31164000	26218	12962	3	0	2
363988	1874	31167000	26218	12962	4	0	2
363989	1874	31169000	26218	12962	5	0	2
363990	1678	26640830779000	26219	12963	0	0	1
363992	1874	31174000	26219	12963	2	0	2
363993	1874	31175000	26219	12963	3	0	2
364001	1678	26640830780000	26222	12964	0	0	1
364002	1874	31178000	26222	12964	1	0	2
364011	1678	26640830781000	26224	12965	0	0	1
364012	1678	26640830782000	26224	12965	1	0	1
364013	1874	31181000	26224	12965	2	0	2
364014	1874	31183000	26224	12965	3	0	2
364015	1874	31185000	26224	12965	4	0	2
364017	1874	31191000	26224	12965	6	0	2
364073	1678	26640830763000	26225	12852	55	0	\N
364074	1678	26640830764000	26225	12852	56	0	\N
364075	1678	26640830765000	26225	12852	57	0	\N
364076	1678	26640830766000	26225	12852	58	0	\N
364077	1678	26640830767000	26225	12852	59	0	\N
364078	1678	26640830768000	26225	12852	60	0	\N
364079	1678	26640830769000	26225	12852	61	0	\N
364080	1678	26640830770000	26225	12852	62	0	\N
364081	1678	26640830771000	26225	12852	63	0	\N
364082	1678	26640830772000	26225	12852	64	0	\N
364083	1678	26640830773000	26225	12852	65	0	\N
364084	1678	26640830774000	26225	12852	66	0	\N
364085	1678	26640830775000	26225	12852	67	0	\N
364086	1678	26640830776000	26225	12852	68	0	\N
364087	1678	26640830777000	26225	12852	69	0	\N
364088	1678	26640830778000	26225	12852	70	0	\N
364089	1678	26640830779000	26225	12852	71	0	\N
364090	1678	26640830780000	26225	12852	72	0	\N
364091	1678	26640830781000	26225	12852	73	0	\N
364092	1678	26640830782000	26225	12852	74	0	\N
364093	1678	26640830783000	26225	12852	75	0	\N
364094	1678	26640830784000	26225	12852	76	0	\N
364095	1678	26640830785000	26225	12852	77	0	\N
364096	1726	1000098112000	26225	12852	78	0	\N
364097	2329	0	26225	12852	79	0	\N
364098	1874	30576000	26225	12852	80	0	\N
364099	1600	0	26225	12852	81	0	\N
364100	1874	30579000	26225	12852	82	0	\N
364101	1874	30581000	26225	12852	83	0	\N
364102	2329	301686177819988	26225	12852	84	0	\N
364103	1874	30583000	26225	12852	85	0	\N
364104	1874	30585000	26225	12852	86	0	\N
364105	1874	30586000	26225	12852	87	0	\N
364106	1874	30587000	26225	12852	88	0	\N
364107	1874	30588000	26225	12852	89	0	\N
364108	1874	30590000	26225	12852	90	0	\N
364109	1874	30592000	26225	12852	91	0	\N
364110	1874	30593000	26225	12852	92	0	\N
364111	1874	30595000	26225	12852	93	0	\N
364112	1874	30597000	26225	12852	94	0	\N
364113	1874	30599000	26225	12852	95	0	\N
364114	1874	30601000	26225	12852	96	0	\N
364115	1874	30603000	26225	12852	97	0	\N
364116	1874	30605000	26225	12852	98	0	\N
364117	1874	30607000	26225	12852	99	0	\N
364118	1874	30609000	26225	12852	100	0	\N
364119	1874	30611000	26225	12852	101	0	\N
364120	1874	30613000	26225	12852	102	0	\N
364121	1874	30615000	26225	12852	103	0	\N
364122	1874	30617000	26225	12852	104	0	\N
364123	1874	30619000	26225	12852	105	0	\N
364124	1874	30621000	26225	12852	106	0	\N
364125	1874	30623000	26225	12852	107	0	\N
364126	1874	30625000	26225	12852	108	0	\N
364127	1874	30627000	26225	12852	109	0	\N
364128	1874	30629000	26225	12852	110	0	\N
364129	1874	30631000	26225	12852	111	0	\N
364130	1874	30633000	26225	12852	112	0	\N
364131	1874	30635000	26225	12852	113	0	\N
364132	1874	30637000	26225	12852	114	0	\N
364133	1874	30639000	26225	12852	115	0	\N
364134	1874	30641000	26225	12852	116	0	\N
364135	1874	30643000	26225	12852	118	0	\N
364136	1874	30645000	26225	12852	119	0	\N
364137	1874	30647000	26225	12852	120	0	\N
364138	1874	30649000	26225	12852	121	0	\N
364139	1874	30651000	26225	12852	122	0	\N
364140	1874	30653000	26225	12852	123	0	\N
364141	1874	30655000	26225	12852	124	0	\N
364142	1874	30657000	26225	12852	125	0	\N
364167	1678	26640830783000	26227	12966	0	0	\N
364168	1678	26640830784000	26227	12966	1	0	\N
364169	1678	26640830785000	26227	12966	2	0	\N
364170	1678	26640830786000	26227	12966	3	0	\N
364171	1678	26640830787000	26227	12966	4	0	\N
364172	1678	26640830788000	26227	12966	5	0	\N
364173	1678	26640830789000	26227	12966	6	0	\N
364174	2342	100000000	26227	12966	7	0	\N
364175	1874	31194000	26227	12966	8	0	\N
364176	1874	31196000	26227	12966	9	0	\N
364177	1874	31198000	26227	12966	10	0	\N
364178	1874	31200000	26227	12966	11	0	\N
364179	1874	31202000	26227	12966	12	0	\N
364180	1874	31204000	26227	12966	13	0	\N
364181	1874	31206000	26227	12966	14	0	\N
364182	1874	31208000	26227	12966	15	0	\N
364183	1874	31209000	26227	12966	16	0	\N
364184	1874	31210000	26227	12966	17	0	\N
364185	1874	31213000	26227	12966	18	0	\N
364186	1874	31216000	26227	12966	19	0	\N
364187	1874	31219000	26227	12966	20	0	\N
364188	1874	31222000	26227	12966	21	0	\N
364189	1874	31225000	26227	12966	22	0	\N
364190	1874	31228000	26227	12966	23	0	\N
364204	1678	26640830792000	26231	12969	0	0	\N
364205	1678	26640830793000	26231	12969	1	0	\N
364206	1874	31241000	26231	12969	2	0	\N
364207	1874	31243000	26231	12969	3	0	\N
364208	1874	31245000	26231	12969	4	0	\N
364145	1678	26640830785000	26226	12966	2	0	1
364146	1678	26640830786000	26226	12966	3	0	1
364147	1678	26640830787000	26226	12966	4	0	1
364148	1678	26640830788000	26226	12966	5	0	1
364149	1678	26640830789000	26226	12966	6	0	1
364151	1874	31194000	26226	12966	8	0	2
364152	1874	31196000	26226	12966	9	0	2
364153	1874	31198000	26226	12966	10	0	2
364154	1874	31200000	26226	12966	11	0	2
364155	1874	31202000	26226	12966	12	0	2
364157	1874	31206000	26226	12966	14	0	2
364158	1874	31208000	26226	12966	15	0	2
364159	1874	31209000	26226	12966	16	0	2
364160	1874	31210000	26226	12966	17	0	2
364162	1874	31216000	26226	12966	19	0	2
364163	1874	31219000	26226	12966	20	0	2
364164	1874	31222000	26226	12966	21	0	2
364165	1874	31225000	26226	12966	22	0	2
364166	1874	31228000	26226	12966	23	0	2
364192	1874	31231000	26228	12967	1	0	2
364193	1874	31233000	26228	12967	2	0	2
364194	1678	26640830791000	26229	12968	0	0	1
364195	1874	31236000	26229	12968	1	0	2
364196	1874	31238000	26229	12968	2	0	2
364198	1678	26640830793000	26230	12969	1	0	1
364199	1874	31241000	26230	12969	2	0	2
364200	1874	31243000	26230	12969	3	0	2
364201	1874	31245000	26230	12969	4	0	2
364203	1874	31249000	26230	12969	6	0	2
364209	1874	31248000	26231	12969	5	0	\N
364210	1874	31249000	26231	12969	6	0	\N
364221	1678	26640830795000	26234	12971	0	0	\N
364222	1678	26640830796000	26234	12971	1	0	\N
364223	1874	31256000	26234	12971	2	0	\N
364224	1874	31258000	26234	12971	3	0	\N
364225	1874	31261000	26234	12971	4	0	\N
364226	1874	31264000	26234	12971	5	0	\N
364227	1874	31265000	26234	12971	6	0	\N
364231	1678	26640830797000	26237	12972	0	0	\N
364232	1874	31268000	26237	12972	1	0	\N
364233	1874	31270000	26237	12972	2	0	\N
364234	1678	26640830797000	26238	12972	0	0	\N
364235	1874	31268000	26238	12972	1	0	\N
364236	1874	31270000	26238	12972	2	0	\N
364260	1678	26640830803000	26245	12975	0	0	\N
364261	1874	31300000	26245	12975	1	0	\N
364262	1874	31302000	26245	12975	2	0	\N
364263	1678	26640830803000	26246	12975	0	0	\N
364264	1874	31300000	26246	12975	1	0	\N
364265	1874	31302000	26246	12975	2	0	\N
364266	1678	26640830803000	26247	12975	0	0	\N
364267	1874	31300000	26247	12975	1	0	\N
364268	1874	31302000	26247	12975	2	0	\N
364302	1678	26640830814000	26255	12983	0	0	\N
364303	1874	31357000	26255	12983	1	0	\N
364304	1874	31360000	26255	12983	2	0	\N
364308	1678	26640830814000	26257	12983	0	0	\N
364309	1874	31357000	26257	12983	1	0	\N
364310	1874	31360000	26257	12983	2	0	\N
364311	1678	26640830814000	26258	12983	0	0	\N
364312	1874	31357000	26258	12983	1	0	\N
364313	1874	31360000	26258	12983	2	0	\N
364314	1678	26640830815000	26259	12984	0	0	\N
364315	1874	31363000	26259	12984	1	0	\N
364316	1874	31365000	26259	12984	2	0	\N
364333	1678	26640830817000	26263	12986	0	0	\N
364334	1678	26640830818000	26263	12986	1	0	\N
364335	1874	31378000	26263	12986	2	0	\N
364336	1874	31380000	26263	12986	3	0	\N
364337	1874	31381000	26263	12986	4	0	\N
364338	1874	31384000	26263	12986	5	0	\N
364339	1874	31387000	26263	12986	6	0	\N
364213	1874	31254000	26232	12970	2	0	2
364214	1678	26640830795000	26233	12971	0	0	1
364215	1678	26640830796000	26233	12971	1	0	1
364216	1874	31256000	26233	12971	2	0	2
364217	1874	31258000	26233	12971	3	0	2
364219	1874	31264000	26233	12971	5	0	2
364220	1874	31265000	26233	12971	6	0	2
364228	1678	26640830797000	26236	12972	0	0	1
364229	1874	31268000	26236	12972	1	0	2
364230	1874	31270000	26236	12972	2	0	2
364238	1874	31273000	26242	12973	1	0	2
364239	1874	31275000	26242	12973	2	0	2
364240	1678	26640830799000	26243	12974	0	0	1
364241	1678	26640830800000	26243	12974	1	0	1
364243	1678	26640830802000	26243	12974	4	0	1
364244	1874	31276000	26243	12974	5	0	2
364245	2343	100000000	26243	12974	6	0	0
364246	1874	31278000	26243	12974	7	0	2
364247	1874	31281000	26243	12974	8	0	2
364249	1874	31287000	26243	12974	10	0	2
364250	1874	31290000	26243	12974	11	0	2
364251	2344	100000000	26243	12974	12	0	0
364252	1874	31292000	26243	12974	13	0	2
364253	2345	100000000	26243	12974	14	0	0
364255	1874	31295000	26243	12974	16	0	2
364256	1874	31297000	26243	12974	17	0	2
364257	1678	26640830803000	26244	12975	0	0	1
364258	1874	31300000	26244	12975	1	0	2
364269	1678	26640830804000	26248	12976	0	0	1
364270	1874	31305000	26248	12976	1	0	2
364271	1874	31307000	26248	12976	2	0	2
364272	1678	26640830805000	26249	12977	0	0	1
364273	1874	31310000	26249	12977	1	0	2
364275	1678	26640830806000	26250	12978	0	0	1
364276	1874	31315000	26250	12978	1	0	2
364277	1874	31317000	26250	12978	2	0	2
364278	1874	31318000	26250	12978	3	0	2
364279	1678	26640830807000	26251	12979	0	0	1
364281	1678	26640830809000	26251	12979	2	0	1
364282	1678	26640830810000	26251	12979	3	0	1
364283	1874	31320000	26251	12979	4	0	2
364284	1874	31322000	26251	12979	5	0	2
364286	1874	31326000	26251	12979	7	0	2
364287	1874	31329000	26251	12979	8	0	2
364288	1874	31332000	26251	12979	9	0	2
364289	1874	31335000	26251	12979	10	0	2
364290	1874	31337000	26251	12979	11	0	2
364292	1678	26640830811000	26252	12980	0	0	1
364293	1874	31342000	26252	12980	1	0	2
364294	1874	31344000	26252	12980	2	0	2
364295	1678	26640830812000	26253	12981	0	0	1
364296	1874	31347000	26253	12981	1	0	2
364298	1874	31350000	26253	12981	3	0	2
364299	1678	26640830813000	26254	12982	0	0	1
364300	1874	31353000	26254	12982	1	0	2
364301	1874	31355000	26254	12982	2	0	2
364306	1874	31357000	26256	12983	1	0	2
364307	1874	31360000	26256	12983	2	0	2
364317	1678	26640830815000	26260	12984	0	0	1
364318	1874	31363000	26260	12984	1	0	2
364319	1874	31365000	26260	12984	2	0	2
364321	1874	31367000	26261	12985	1	0	2
364322	1874	31369000	26261	12985	2	0	2
364323	1874	31372000	26261	12985	3	0	2
364324	1874	31375000	26261	12985	4	0	2
364325	1874	31376000	26261	12985	5	0	2
364327	1678	26640830818000	26262	12986	1	0	1
364328	1874	31378000	26262	12986	2	0	2
364329	1874	31380000	26262	12986	3	0	2
364330	1874	31381000	26262	12986	4	0	2
364332	1874	31387000	26262	12986	6	0	2
364340	1678	26640830819000	26264	12987	0	0	1
364341	1874	31389000	26264	12987	1	0	2
364342	1874	31392000	26264	12987	2	0	2
364343	1678	26640830820000	26265	12988	0	0	1
364353	1678	26640830823000	26267	12990	0	0	\N
364354	1874	31411000	26267	12990	1	0	\N
364355	1874	31413000	26267	12990	2	0	\N
364362	1678	26640830824000	26270	12991	0	0	\N
364363	1874	31416000	26270	12991	1	0	\N
364364	1874	31418000	26270	12991	2	0	\N
364378	1678	26640830828000	26275	12995	0	0	\N
364379	1874	31432000	26275	12995	1	0	\N
364380	1874	31434000	26275	12995	2	0	\N
364381	1874	31437000	26275	12995	3	0	\N
364382	1678	26640830828000	26276	12995	0	0	\N
364383	1874	31432000	26276	12995	1	0	\N
364384	1874	31434000	26276	12995	2	0	\N
364385	1874	31437000	26276	12995	3	0	\N
364399	1	376405981756000	26280	12831	0	0	\N
364400	31	1332497303438000	26280	12831	1	0	\N
364401	32	74402705100000	26280	12831	2	0	\N
364402	40	66695350031000	26280	12831	3	0	\N
364403	779	28070876565792	26280	12831	4	0	\N
364404	780	308779372753051	26280	12831	5	0	\N
364405	782	2470185021667720	26280	12831	6	0	\N
364406	841	84252812686298	26280	12831	7	0	\N
364407	843	157077624077667	26280	12831	8	0	\N
364408	849	1157959544926640	26280	12831	9	0	\N
364409	851	2252855616099750	26280	12831	10	0	\N
364410	853	248413580356225	26280	12831	11	0	\N
364411	855	131401473988125	26280	12831	12	0	\N
364412	857	331326853191608	26280	12831	13	0	\N
364413	861	457639616303125	26280	12831	14	0	\N
364414	865	401756230813417	26280	12831	15	0	\N
364415	867	2446786067934000	26280	12831	16	0	\N
364416	869	261664739344845	26280	12831	17	0	\N
364417	873	2446786067934000	26280	12831	18	0	\N
364418	875	214471371336583	26280	12831	19	0	\N
364419	879	135932559298750	26280	12831	20	0	\N
364420	881	589041090291250	26280	12831	21	0	\N
364421	891	498419384091750	26280	12831	22	0	\N
364422	897	65747860280885	26280	12831	23	0	\N
364423	899	39192075495990	26280	12831	24	0	\N
364424	901	117808218058250	26280	12831	25	0	\N
364425	905	423656476478938	26280	12831	26	0	\N
364426	785	224562470676807	26280	12831	27	0	\N
364427	786	2470185021667720	26280	12831	28	0	\N
364428	791	56141753131584	26280	12831	29	0	\N
364429	792	617558745507101	26280	12831	30	0	\N
364430	799	14034180722181	26280	12831	31	0	\N
364431	800	154375853226607	26280	12831	32	0	\N
364432	801	14036777239666	26280	12831	33	0	\N
364433	802	154404414900275	26280	12831	34	0	\N
364434	811	108632665328286	26280	12831	35	0	\N
364435	812	1194958275746140	26280	12831	36	0	\N
364436	823	1743175806087760	26280	12831	37	0	\N
364437	824	19174917132499700	26280	12831	38	0	\N
364438	1900	65126000	26280	12831	39	0	\N
364439	2177	78208862930741	26280	12831	40	0	\N
364440	2177	79792923830741	26280	12831	41	0	\N
364441	875	214951947700583	26280	12831	42	0	\N
364442	879	136237149952750	26280	12831	43	0	\N
364443	1678	26640830604000	26280	12831	44	0	\N
364444	1678	26640830605000	26280	12831	45	0	\N
364445	1678	26640830606000	26280	12831	46	0	\N
364446	1678	26640830607000	26280	12831	47	0	\N
364447	1678	26640830608000	26280	12831	48	0	\N
364448	1678	26640830609000	26280	12831	49	0	\N
364449	1678	26640830610000	26280	12831	50	0	\N
364450	1678	26640830611000	26280	12831	51	0	\N
364451	1678	26640830612000	26280	12831	52	0	\N
364452	881	590360983123250	26280	12831	53	0	\N
364453	1678	26640830613000	26280	12831	54	0	\N
364454	1678	26640830614000	26280	12831	55	0	\N
364455	1678	26640830615000	26280	12831	56	0	\N
364456	1678	26640830616000	26280	12831	57	0	\N
364457	1678	26640830617000	26280	12831	58	0	\N
364458	1678	26640830618000	26280	12831	59	0	\N
364459	1678	26640830619000	26280	12831	60	0	\N
364460	1678	26640830620000	26280	12831	61	0	\N
364461	1678	26640830621000	26280	12831	62	0	\N
364462	1678	26640830622000	26280	12831	63	0	\N
364463	1678	26640830623000	26280	12831	64	0	\N
364464	1678	26640830624000	26280	12831	65	0	\N
364465	1678	26640830625000	26280	12831	66	0	\N
364466	1678	26640830626000	26280	12831	67	0	\N
364467	1678	26640830627000	26280	12831	68	0	\N
364468	1678	26640830628000	26280	12831	69	0	\N
364469	1678	26640830629000	26280	12831	70	0	\N
364470	1678	26640830630000	26280	12831	71	0	\N
364471	1678	26640830631000	26280	12831	72	0	\N
364472	1678	26640830632000	26280	12831	73	0	\N
364473	1678	26640830633000	26280	12831	74	0	\N
364474	1678	26640830634000	26280	12831	75	0	\N
364475	1678	26640830635000	26280	12831	77	0	\N
364476	1678	26640830636000	26280	12831	78	0	\N
364477	1678	26640830637000	26280	12831	79	0	\N
364478	1678	26640830638000	26280	12831	80	0	\N
364479	1678	26640830639000	26280	12831	81	0	\N
364480	1678	26640830640000	26280	12831	82	0	\N
364347	1874	31398000	26265	12988	4	0	2
364348	1874	31401000	26265	12988	5	0	2
364349	1874	31403000	26265	12988	6	0	2
364350	1678	26640830822000	26266	12989	0	0	1
364351	1874	31405000	26266	12989	1	0	2
364356	1678	26640830823000	26268	12990	0	0	1
364357	1874	31411000	26268	12990	1	0	2
364358	1874	31413000	26268	12990	2	0	2
364359	1678	26640830824000	26269	12991	0	0	1
364360	1874	31416000	26269	12991	1	0	2
364365	1678	26640830825000	26271	12992	0	0	1
364366	1874	31419000	26271	12992	1	0	2
364367	1874	31422000	26271	12992	3	0	2
364368	1874	31424000	26271	12992	4	0	2
364370	1874	31426000	26272	12993	1	0	2
364371	1678	26640830827000	26273	12994	0	0	1
364372	1874	31428000	26273	12994	1	0	2
364373	1874	31431000	26273	12994	2	0	2
364374	1678	26640830828000	26274	12995	0	0	1
364376	1874	31434000	26274	12995	2	0	2
364377	1874	31437000	26274	12995	3	0	2
364386	1678	26640830829000	26277	12996	0	0	1
364387	1678	26640830830000	26277	12996	1	0	1
364388	1874	31440000	26277	12996	2	0	2
364390	1874	31445000	26277	12996	4	0	2
364391	1874	31447000	26277	12996	5	0	2
364392	1678	26640830831000	26278	12997	0	0	1
364393	1874	31449000	26278	12997	1	0	2
364395	1874	31453000	26278	12997	3	0	2
364396	1678	26640830832000	26279	12998	0	0	1
364397	1874	31455000	26279	12998	1	0	2
364398	1874	31458000	26279	12998	2	0	2
364481	1678	26640830641000	26280	12831	83	0	\N
364482	1678	26640830642000	26280	12831	84	0	\N
364483	1678	26640830643000	26280	12831	85	0	\N
364484	1678	26640830644000	26280	12831	86	0	\N
364485	1678	26640830645000	26280	12831	87	0	\N
364486	1678	26640830646000	26280	12831	88	0	\N
364487	1678	26640830647000	26280	12831	89	0	\N
364488	1678	26640830648000	26280	12831	90	0	\N
364489	1678	26640830649000	26280	12831	91	0	\N
364490	1678	26640830650000	26280	12831	92	0	\N
364491	1678	26640830651000	26280	12831	93	0	\N
364492	1678	26640830652000	26280	12831	94	0	\N
364493	1678	26640830653000	26280	12831	95	0	\N
364494	1678	26640830654000	26280	12831	96	0	\N
364495	1678	26640830655000	26280	12831	97	0	\N
364496	1678	26640830656000	26280	12831	98	0	\N
364497	1678	26640830657000	26280	12831	99	0	\N
364498	1678	26640830658000	26280	12831	100	0	\N
364499	1678	26640830659000	26280	12831	101	0	\N
364500	1678	26640830660000	26280	12831	102	0	\N
364501	1678	26640830661000	26280	12831	103	0	\N
364502	1678	26640830662000	26280	12831	104	0	\N
364503	1678	26640830663000	26280	12831	105	0	\N
364504	1678	26640830664000	26280	12831	106	0	\N
364505	1678	26640830665000	26280	12831	107	0	\N
364506	1678	26640830666000	26280	12831	108	0	\N
364507	1678	26640830667000	26280	12831	109	0	\N
364508	1678	26640830668000	26280	12831	110	0	\N
364509	1678	26640830669000	26280	12831	111	0	\N
364510	1678	26640830670000	26280	12831	112	0	\N
364511	1678	26640830671000	26280	12831	113	0	\N
364512	1678	26640830672000	26280	12831	114	0	\N
364513	1678	26640830673000	26280	12831	115	0	\N
364514	1678	26640830674000	26280	12831	116	0	\N
364515	1678	26640830675000	26280	12831	117	0	\N
364516	1678	26640830676000	26280	12831	118	0	\N
364517	1678	26640830677000	26280	12831	119	0	\N
364518	1678	26640830678000	26280	12831	120	0	\N
364519	1678	26640830679000	26280	12831	121	0	\N
364520	1678	26640830680000	26280	12831	122	0	\N
364521	1678	26640830681000	26280	12831	123	0	\N
364522	1678	26640830682000	26280	12831	124	0	\N
364523	1678	26640830683000	26280	12831	125	0	\N
364524	1678	26640830833000	26281	12999	0	0	\N
364525	1678	26640830834000	26281	12999	1	0	\N
364526	1678	26640830835000	26281	12999	2	0	\N
364527	1874	31461000	26281	12999	3	0	\N
364528	1874	31464000	26281	12999	4	0	\N
364529	1874	31467000	26281	12999	5	0	\N
364530	1874	31468000	26281	12999	6	0	\N
364531	1678	26640830833000	26282	12999	0	0	\N
364532	1678	26640830834000	26282	12999	1	0	\N
364533	1678	26640830835000	26282	12999	2	0	\N
364534	1874	31461000	26282	12999	3	0	\N
364535	1874	31464000	26282	12999	4	0	\N
364536	1874	31467000	26282	12999	5	0	\N
364537	1874	31468000	26282	12999	6	0	\N
364545	1678	26640830833000	26284	12999	0	0	\N
364546	1678	26640830834000	26284	12999	1	0	\N
364547	1678	26640830835000	26284	12999	2	0	\N
364548	1874	31461000	26284	12999	3	0	\N
364549	1874	31464000	26284	12999	4	0	\N
364550	1874	31467000	26284	12999	5	0	\N
364551	1874	31468000	26284	12999	6	0	\N
364552	1678	26640830836000	26285	13000	0	0	\N
364553	1874	31471000	26285	13000	1	0	\N
364570	1678	26640830843000	26291	13005	0	0	\N
364571	1874	31494000	26291	13005	1	0	\N
364576	1678	26640830845000	26294	13007	0	0	\N
364577	1678	26640830846000	26294	13007	1	0	\N
364578	1678	26640830847000	26294	13007	2	0	\N
364579	1678	26640830848000	26294	13007	3	0	\N
364580	1874	31498000	26294	13007	4	0	\N
364581	1874	31499000	26294	13007	5	0	\N
364582	1874	31502000	26294	13007	6	0	\N
364583	1874	31505000	26294	13007	7	0	\N
364584	1874	31508000	26294	13007	8	0	\N
364585	1874	31511000	26294	13007	9	0	\N
364586	1681	14974751358535	26294	13007	10	0	\N
364598	1678	26640830845000	26296	13007	0	0	\N
364599	1678	26640830846000	26296	13007	1	0	\N
364600	1678	26640830847000	26296	13007	2	0	\N
364601	1678	26640830848000	26296	13007	3	0	\N
364602	1874	31498000	26296	13007	4	0	\N
364603	1874	31499000	26296	13007	5	0	\N
364604	1874	31502000	26296	13007	6	0	\N
364605	1874	31505000	26296	13007	7	0	\N
364606	1874	31508000	26296	13007	8	0	\N
364607	1874	31511000	26296	13007	9	0	\N
364608	1681	14974751358535	26296	13007	10	0	\N
364611	1678	26640830849000	26298	13008	0	0	\N
364612	1874	31514000	26298	13008	1	0	\N
364613	1678	26640830850000	26299	13009	0	0	\N
364614	1678	26640830851000	26299	13009	1	0	\N
364615	1874	31517000	26299	13009	2	0	\N
364616	1874	31520000	26299	13009	3	0	\N
364540	1678	26640830835000	26283	12999	2	0	1
364541	1874	31461000	26283	12999	3	0	2
364542	1874	31464000	26283	12999	4	0	2
364543	1874	31467000	26283	12999	5	0	2
364544	1874	31468000	26283	12999	6	0	2
364555	1874	31471000	26286	13000	1	0	2
364556	1678	26640830837000	26287	13001	0	0	1
364557	1874	31474000	26287	13001	1	0	2
364558	1678	26640830838000	26288	13002	0	0	1
364559	1678	26640830839000	26288	13002	1	0	1
364561	1874	31475000	26288	13002	3	0	2
364562	1874	31478000	26288	13002	4	0	2
364563	1874	31481000	26288	13002	5	0	2
364564	1874	31484000	26288	13002	6	0	2
364566	1874	31487000	26289	13003	1	0	2
364567	1874	31488000	26289	13003	2	0	2
364568	1678	26640830842000	26290	13004	0	0	1
364569	1874	31491000	26290	13004	1	0	2
364572	1678	26640830843000	26292	13005	0	0	1
364574	1678	26640830844000	26293	13006	0	0	1
364575	1874	31497000	26293	13006	1	0	2
364587	1678	26640830845000	26295	13007	0	0	1
364588	1678	26640830846000	26295	13007	1	0	1
364589	1678	26640830847000	26295	13007	2	0	1
364591	1874	31498000	26295	13007	4	0	2
364592	1874	31499000	26295	13007	5	0	2
364593	1874	31502000	26295	13007	6	0	2
364594	1874	31505000	26295	13007	7	0	2
364596	1874	31511000	26295	13007	9	0	2
364597	1681	14974751358535	26295	13007	10	0	11
364609	1678	26640830849000	26297	13008	0	0	1
364610	1874	31514000	26297	13008	1	0	2
364617	1874	31521000	26299	13009	4	0	\N
364623	1678	26640830850000	26301	13009	0	0	\N
364624	1678	26640830851000	26301	13009	1	0	\N
364625	1874	31517000	26301	13009	2	0	\N
364626	1874	31520000	26301	13009	3	0	\N
364627	1874	31521000	26301	13009	4	0	\N
364641	1678	26640830858000	26305	13013	0	0	\N
364642	1874	31541000	26305	13013	1	0	\N
364643	1874	31544000	26305	13013	2	0	\N
364645	2329	720022000000	26309	12929	0	0	\N
364646	2329	302406199819988	26309	12929	1	0	\N
364647	1874	30929000	26309	12929	2	0	\N
364648	1874	30930000	26309	12929	3	0	\N
364649	1874	30931000	26309	12929	4	0	\N
364650	1874	30932000	26309	12929	5	0	\N
364651	1681	14974751358535	26309	12929	6	0	\N
364652	1874	30933000	26309	12929	7	0	\N
364653	1874	30934000	26309	12929	8	0	\N
364654	1874	30935000	26309	12929	9	0	\N
364655	1874	30936000	26309	12929	10	0	\N
364656	1874	30937000	26309	12929	11	0	\N
364657	1874	30938000	26309	12929	12	0	\N
364658	1874	30939000	26309	12929	13	0	\N
364659	1874	30940000	26309	12929	14	0	\N
364660	1874	30941000	26309	12929	15	0	\N
364661	1874	30942000	26309	12929	16	0	\N
364662	1874	30943000	26309	12929	17	0	\N
364663	1874	30944000	26309	12929	18	0	\N
364664	1874	30945000	26309	12929	19	0	\N
364665	1874	30946000	26309	12929	20	0	\N
364666	1874	30947000	26309	12929	21	0	\N
364667	1874	30948000	26309	12929	22	0	\N
364668	1874	30949000	26309	12929	23	0	\N
364669	1874	30950000	26309	12929	24	0	\N
364670	1874	30951000	26309	12929	25	0	\N
364671	1874	30952000	26309	12929	26	0	\N
364672	1874	30953000	26309	12929	27	0	\N
364673	1874	30954000	26309	12929	28	0	\N
364674	1874	30955000	26309	12929	29	0	\N
364675	1874	30956000	26309	12929	30	0	\N
364676	1874	30957000	26309	12929	31	0	\N
364677	1874	30958000	26309	12929	32	0	\N
364678	1874	30959000	26309	12929	33	0	\N
364679	1874	30960000	26309	12929	34	0	\N
364680	1874	30961000	26309	12929	35	0	\N
364681	1874	30962000	26309	12929	36	0	\N
364682	1874	30963000	26309	12929	37	0	\N
364683	1874	30964000	26309	12929	38	0	\N
364684	1678	26640830858000	26311	13015	0	0	\N
364685	1678	26640830859000	26311	13015	1	0	\N
364686	1678	26640830860000	26311	13015	2	0	\N
364687	1874	31544000	26311	13015	3	0	\N
364688	1874	31547000	26311	13015	4	0	\N
364689	1874	31550000	26311	13015	5	0	\N
364690	1678	26640830858000	26312	13015	0	0	\N
364691	1678	26640830859000	26312	13015	1	0	\N
364692	1678	26640830860000	26312	13015	2	0	\N
364693	1874	31544000	26312	13015	3	0	\N
364694	1874	31547000	26312	13015	4	0	\N
364695	1874	31550000	26312	13015	5	0	\N
364702	1678	26640830861000	26314	13016	0	0	\N
364703	1874	31553000	26314	13016	1	0	\N
364704	1874	31554000	26314	13016	2	0	\N
364705	1678	26640830861000	26315	13016	0	0	\N
364706	1874	31553000	26315	13016	1	0	\N
364707	1874	31554000	26315	13016	2	0	\N
364710	1678	26640830862000	26317	13017	0	0	\N
364711	1678	26640830863000	26317	13017	1	0	\N
364712	1874	31554000	26317	13017	2	0	\N
364713	1874	31557000	26317	13017	3	0	\N
364714	1874	31560000	26317	13017	4	0	\N
364715	1678	26640830862000	26318	13017	0	0	\N
364716	1678	26640830863000	26318	13017	1	0	\N
364717	1874	31554000	26318	13017	2	0	\N
364718	1874	31557000	26318	13017	3	0	\N
364719	1874	31560000	26318	13017	4	0	\N
364720	1678	26640830862000	26319	13017	0	0	\N
364721	1678	26640830863000	26319	13017	1	0	\N
364722	1874	31554000	26319	13017	2	0	\N
364723	1874	31557000	26319	13017	3	0	\N
364724	1874	31560000	26319	13017	4	0	\N
364730	1678	26640830862000	26321	13017	0	0	\N
364731	1678	26640830863000	26321	13017	1	0	\N
364732	1874	31554000	26321	13017	2	0	\N
364733	1874	31557000	26321	13017	3	0	\N
364734	1874	31560000	26321	13017	4	0	\N
364735	1678	26640830864000	26322	13018	0	0	\N
364736	1678	26640830865000	26322	13018	1	0	\N
364737	1874	31563000	26322	13018	2	0	\N
364738	1874	31566000	26322	13018	3	0	\N
364739	1874	31567000	26322	13018	4	0	\N
364745	1678	26640830864000	26324	13018	0	0	\N
364746	1678	26640830865000	26324	13018	1	0	\N
364747	1874	31563000	26324	13018	2	0	\N
364748	1874	31566000	26324	13018	3	0	\N
364749	1874	31567000	26324	13018	4	0	\N
364752	1678	26640830867000	26326	13020	0	0	\N
364620	1874	31517000	26300	13009	2	0	2
364621	1874	31520000	26300	13009	3	0	2
364622	1874	31521000	26300	13009	4	0	2
364628	1678	26640830852000	26302	13010	0	0	1
364629	1678	26640830853000	26302	13010	1	0	1
364631	1874	31524000	26302	13010	3	0	2
364632	1874	31527000	26302	13010	4	0	2
364633	1874	31530000	26302	13010	5	0	2
364634	1678	26640830855000	26303	13011	0	0	1
364635	1678	26640830856000	26303	13011	1	0	1
364637	1874	31534000	26303	13011	3	0	2
364638	1874	31537000	26303	13011	4	0	2
364639	1678	26640830857000	26304	13012	0	0	1
364640	1874	31540000	26304	13012	1	0	2
364696	1678	26640830858000	26313	13015	0	0	1
364697	1678	26640830859000	26313	13015	1	0	1
364698	1678	26640830860000	26313	13015	2	0	1
364699	1874	31544000	26313	13015	3	0	2
364700	1874	31547000	26313	13015	4	0	2
364708	1678	26640830861000	26316	13016	0	0	1
364709	1874	31551000	26316	13016	1	0	2
364725	1678	26640830862000	26320	13017	0	0	1
364726	1678	26640830863000	26320	13017	1	0	1
364727	1874	31554000	26320	13017	2	0	2
364729	1874	31560000	26320	13017	4	0	2
364740	1678	26640830864000	26323	13018	0	0	1
364741	1678	26640830865000	26323	13018	1	0	1
364742	1874	31563000	26323	13018	2	0	2
364744	1874	31567000	26323	13018	4	0	2
364750	1678	26640830866000	26325	13019	0	0	1
364751	1874	31570000	26325	13019	1	0	2
364753	1874	31573000	26326	13020	1	0	\N
364754	1678	26640830867000	26327	13020	0	0	\N
364757	1678	26640830868000	26329	13021	0	0	\N
364758	1678	26640830869000	26329	13021	1	0	\N
364759	1874	31574000	26329	13021	2	0	\N
364763	1678	26640830868000	26331	13021	0	0	\N
364764	1678	26640830869000	26331	13021	1	0	\N
364765	1874	31574000	26331	13021	2	0	\N
364766	1874	31577000	26331	13021	3	0	\N
364767	1874	31580000	26331	13021	4	0	\N
364768	1678	26640830868000	26332	13021	0	0	\N
364769	1678	26640830869000	26332	13021	1	0	\N
364770	1874	31574000	26332	13021	2	0	\N
364771	1874	31577000	26332	13021	3	0	\N
364772	1874	31580000	26332	13021	4	0	\N
364773	1678	26640830868000	26333	13021	0	0	\N
364774	1678	26640830869000	26333	13021	1	0	\N
364775	1874	31574000	26333	13021	2	0	\N
364776	1874	31577000	26333	13021	3	0	\N
364777	1874	31580000	26333	13021	4	0	\N
364791	1678	26640830874000	26338	13025	0	0	\N
364797	1678	26640830875000	26340	13026	0	0	\N
364798	1678	26640830876000	26340	13026	1	0	\N
364799	1874	31599000	26340	13026	2	0	\N
364800	1874	31600000	26340	13026	3	0	\N
364801	1874	31603000	26340	13026	4	0	\N
364802	1678	26640830875000	26341	13026	0	0	\N
364803	1678	26640830876000	26341	13026	1	0	\N
364804	1874	31599000	26341	13026	2	0	\N
364805	1874	31600000	26341	13026	3	0	\N
364806	1874	31603000	26341	13026	4	0	\N
364809	1678	26640830877000	26343	13027	0	0	\N
364810	1874	31606000	26343	13027	1	0	\N
364811	1678	26640830878000	26344	13028	0	0	\N
364812	1874	31607000	26344	13028	1	0	\N
364813	1874	31610000	26344	13028	2	0	\N
364814	1678	26640830878000	26345	13028	0	0	\N
364815	1874	31607000	26345	13028	1	0	\N
364816	1874	31610000	26345	13028	2	0	\N
364820	1874	31607000	26347	13028	0	0	\N
364821	1874	31610000	26347	13028	1	0	\N
364822	1678	26640830878000	26348	13028	0	0	\N
364823	1874	31607000	26348	13028	1	0	\N
364825	1874	31613000	26350	13029	0	0	\N
364833	1678	26640830879000	26352	13030	0	0	\N
364834	1678	26640830880000	26352	13030	1	0	\N
364835	1678	26640830881000	26352	13030	2	0	\N
364836	1874	31616000	26352	13030	3	0	\N
364837	1874	31617000	26352	13030	4	0	\N
364838	1874	31620000	26352	13030	5	0	\N
364839	1874	31623000	26352	13030	6	0	\N
364842	1678	26640830882000	26354	13031	0	0	\N
364843	1874	31626000	26354	13031	1	0	\N
364853	1678	26640830884000	26357	13033	0	0	\N
364854	1678	26640830885000	26357	13033	1	0	\N
364855	1678	26640830886000	26357	13033	2	0	\N
364856	1874	31632000	26357	13033	3	0	\N
364857	1874	31633000	26357	13033	4	0	\N
364858	1874	31636000	26357	13033	5	0	\N
364859	1874	31639000	26357	13033	6	0	\N
364860	1678	26640830732000	26358	12927	0	0	\N
364861	1678	26640830733000	26358	12927	1	0	\N
364862	1678	26640830734000	26358	12927	2	0	\N
364863	1678	26640830735000	26358	12927	3	0	\N
364864	1678	26640830736000	26358	12927	4	0	\N
364865	1678	26640830737000	26358	12927	5	0	\N
364866	1678	26640830738000	26358	12927	6	0	\N
364867	1678	26640830739000	26358	12927	7	0	\N
364868	1678	26640830740000	26358	12927	8	0	\N
364869	1678	26640830741000	26358	12927	9	0	\N
364870	1678	26640830742000	26358	12927	10	0	\N
364871	1678	26640830743000	26358	12927	11	0	\N
364872	1678	26640830744000	26358	12927	12	0	\N
364873	1678	26640830745000	26358	12927	13	0	\N
364874	1678	26640830746000	26358	12927	14	0	\N
364875	1678	26640830747000	26358	12927	15	0	\N
364876	1678	26640830748000	26358	12927	16	0	\N
364877	1678	26640830749000	26358	12927	17	0	\N
364878	1678	26640830750000	26358	12927	18	0	\N
364879	1678	26640830751000	26358	12927	19	0	\N
364880	1678	26640830752000	26358	12927	20	0	\N
364881	1678	26640830753000	26358	12927	21	0	\N
364882	1678	26640830754000	26358	12927	22	0	\N
364883	1678	26640830755000	26358	12927	23	0	\N
364884	1678	26640830756000	26358	12927	24	0	\N
364885	1678	26640830757000	26358	12927	25	0	\N
364886	1678	26640830758000	26358	12927	26	0	\N
364887	1678	26640830759000	26358	12927	27	0	\N
364888	1678	26640830760000	26358	12927	28	0	\N
364760	1678	26640830868000	26330	13021	0	0	1
364761	1678	26640830869000	26330	13021	1	0	1
364762	1874	31574000	26330	13021	2	0	2
364778	1678	26640830870000	26334	13022	0	0	1
364779	1874	31577000	26334	13022	1	0	2
364781	1874	31583000	26334	13022	3	0	2
364782	1678	26640830871000	26335	13023	0	0	1
364783	1874	31586000	26335	13023	1	0	2
364784	1874	31587000	26335	13023	2	0	2
364785	1678	26640830872000	26336	13024	0	0	1
364787	1874	31590000	26336	13024	2	0	2
364788	1874	31593000	26336	13024	3	0	2
364789	1678	26640830874000	26337	13025	0	0	1
364790	1874	31596000	26337	13025	1	0	2
364793	1678	26640830876000	26339	13026	1	0	1
364794	1874	31599000	26339	13026	2	0	2
364795	1874	31600000	26339	13026	3	0	2
364796	1874	31603000	26339	13026	4	0	2
364807	1678	26640830877000	26342	13027	0	0	1
364817	1678	26640830878000	26346	13028	0	0	1
364818	1874	31607000	26346	13028	1	0	2
364819	1874	31610000	26346	13028	2	0	2
364824	1874	31613000	26349	13029	0	0	2
364826	1678	26640830879000	26351	13030	0	0	1
364828	1678	26640830881000	26351	13030	2	0	1
364829	1874	31616000	26351	13030	3	0	2
364830	1874	31617000	26351	13030	4	0	2
364831	1874	31620000	26351	13030	5	0	2
364840	1678	26640830882000	26353	13031	0	0	1
364841	1874	31626000	26353	13031	1	0	2
364844	1678	26640830883000	26355	13032	0	0	1
364845	1874	31629000	26355	13032	1	0	2
364846	1678	26640830884000	26356	13033	0	0	1
364848	1678	26640830886000	26356	13033	2	0	1
364849	1874	31632000	26356	13033	3	0	2
364850	1874	31633000	26356	13033	4	0	2
364851	1874	31636000	26356	13033	5	0	2
364852	1874	31639000	26356	13033	6	0	2
364889	1678	26640830761000	26358	12927	29	0	\N
364890	1678	26640830762000	26358	12927	30	0	\N
364891	1678	26640830763000	26358	12927	31	0	\N
364892	1678	26640830764000	26358	12927	32	0	\N
364893	1678	26640830765000	26358	12927	33	0	\N
364894	1678	26640830766000	26358	12927	34	0	\N
364895	1678	26640830767000	26358	12927	35	0	\N
364896	1678	26640830768000	26358	12927	36	0	\N
364897	1678	26640830769000	26358	12927	37	0	\N
364898	1678	26640830770000	26358	12927	38	0	\N
364899	1678	26640830771000	26358	12927	39	0	\N
364900	1678	26640830772000	26358	12927	40	0	\N
364901	1678	26640830773000	26358	12927	41	0	\N
364902	1678	26640830774000	26358	12927	42	0	\N
364903	1678	26640830775000	26358	12927	43	0	\N
364904	1678	26640830776000	26358	12927	44	0	\N
364905	1678	26640830777000	26358	12927	45	0	\N
364906	1678	26640830778000	26358	12927	46	0	\N
364907	1678	26640830779000	26358	12927	47	0	\N
364908	1678	26640830780000	26358	12927	48	0	\N
364909	1678	26640830781000	26358	12927	49	0	\N
364910	1678	26640830782000	26358	12927	50	0	\N
364911	1678	26640830783000	26358	12927	51	0	\N
364912	1678	26640830784000	26358	12927	52	0	\N
364913	1678	26640830785000	26358	12927	53	0	\N
364914	1678	26640830786000	26358	12927	54	0	\N
364915	1678	26640830787000	26358	12927	55	0	\N
364916	1678	26640830788000	26358	12927	56	0	\N
364917	1678	26640830789000	26358	12927	57	0	\N
364918	1678	26640830790000	26358	12927	58	0	\N
364919	1678	26640830791000	26358	12927	59	0	\N
364920	1678	26640830792000	26358	12927	60	0	\N
364921	1678	26640830793000	26358	12927	61	0	\N
364922	1678	26640830794000	26358	12927	62	0	\N
364923	1678	26640830795000	26358	12927	63	0	\N
364924	1678	26640830796000	26358	12927	64	0	\N
364925	1678	26640830797000	26358	12927	65	0	\N
364926	1678	26640830798000	26358	12927	66	0	\N
364927	1678	26640830799000	26358	12927	67	0	\N
364928	1678	26640830800000	26358	12927	68	0	\N
364929	1678	26640830801000	26358	12927	69	0	\N
364930	1678	26640830802000	26358	12927	70	0	\N
364931	1678	26640830803000	26358	12927	71	0	\N
364932	1678	26640830804000	26358	12927	72	0	\N
364933	1678	26640830805000	26358	12927	73	0	\N
364934	1678	26640830806000	26358	12927	74	0	\N
364935	1678	26640830807000	26358	12927	75	0	\N
364936	1678	26640830808000	26358	12927	76	0	\N
364937	1678	26640830809000	26358	12927	78	0	\N
364938	1678	26640830810000	26358	12927	79	0	\N
364939	1678	26640830811000	26358	12927	80	0	\N
364940	1678	26640830812000	26358	12927	81	0	\N
364941	1678	26640830813000	26358	12927	82	0	\N
364942	1678	26640830814000	26358	12927	83	0	\N
364943	1678	26640830815000	26358	12927	84	0	\N
364944	1678	26640830816000	26358	12927	85	0	\N
364945	1678	26640830817000	26358	12927	86	0	\N
364946	1678	26640830818000	26358	12927	87	0	\N
364947	1678	26640830819000	26358	12927	88	0	\N
364948	1678	26640830820000	26358	12927	89	0	\N
364949	1678	26640830821000	26358	12927	90	0	\N
364950	1678	26640830822000	26358	12927	91	0	\N
364951	1678	26640830823000	26358	12927	92	0	\N
364952	1678	26640830824000	26358	12927	93	0	\N
364953	1678	26640830825000	26358	12927	94	0	\N
364954	1678	26640830826000	26358	12927	95	0	\N
364955	1678	26640830827000	26358	12927	96	0	\N
364956	1678	26640830828000	26358	12927	97	0	\N
364957	1678	26640830829000	26358	12927	98	0	\N
364958	1678	26640830830000	26358	12927	99	0	\N
364959	1678	26640830831000	26358	12927	100	0	\N
364960	1678	26640830832000	26358	12927	101	0	\N
364961	1678	26640830833000	26358	12927	102	0	\N
364962	1678	26640830834000	26358	12927	103	0	\N
364963	1678	26640830835000	26358	12927	104	0	\N
364964	1678	26640830836000	26358	12927	105	0	\N
364965	1678	26640830837000	26358	12927	106	0	\N
364966	1678	26640830838000	26358	12927	107	0	\N
364967	1678	26640830839000	26358	12927	108	0	\N
364968	1678	26640830840000	26358	12927	109	0	\N
364969	1678	26640830841000	26358	12927	110	0	\N
364970	1678	26640830842000	26358	12927	111	0	\N
364971	1678	26640830843000	26358	12927	112	0	\N
364972	1678	26640830844000	26358	12927	113	0	\N
364973	1678	26640830845000	26358	12927	114	0	\N
364974	1678	26640830846000	26358	12927	115	0	\N
364975	1678	26640830847000	26358	12927	116	0	\N
364976	1678	26640830848000	26358	12927	117	0	\N
364977	1678	26640830849000	26358	12927	118	0	\N
364978	1678	26640830850000	26358	12927	119	0	\N
364979	1678	26640830851000	26358	12927	120	0	\N
364980	1678	26640830852000	26358	12927	121	0	\N
364981	1678	26640830853000	26358	12927	122	0	\N
364982	1678	26640830854000	26358	12927	123	0	\N
364983	1678	26640830855000	26358	12927	124	0	\N
364984	1678	26640830856000	26358	12927	125	0	\N
364992	1678	26640830890000	26362	13037	0	0	\N
364993	1874	31650000	26362	13037	1	0	\N
364994	1874	31653000	26362	13037	2	0	\N
365014	1678	26640830897000	26369	13042	0	0	\N
365015	1678	26640830898000	26369	13042	1	0	\N
365016	1874	31673000	26369	13042	2	0	\N
365017	1874	31676000	26369	13042	3	0	\N
365018	1874	31679000	26369	13042	4	0	\N
364987	1874	31643000	26359	13034	2	0	2
364988	1678	26640830888000	26360	13035	0	0	1
364989	1874	31646000	26360	13035	1	0	2
364990	1678	26640830889000	26361	13036	0	0	1
364991	1874	31649000	26361	13036	1	0	2
364996	1874	31650000	26363	13037	1	0	2
364997	1874	31653000	26363	13037	2	0	2
364998	1678	26640830891000	26364	13038	0	0	1
364999	1874	31656000	26364	13038	1	0	2
365000	1678	26640830892000	26366	13040	0	0	1
365002	1678	26640830894000	26366	13040	2	0	1
365003	1874	31659000	26366	13040	3	0	2
365004	1874	31662000	26366	13040	4	0	2
365005	1874	31665000	26366	13040	5	0	2
365007	1678	26640830895000	26367	13041	0	0	1
365008	1678	26640830896000	26367	13041	1	0	1
365009	1874	31669000	26367	13041	2	0	2
365010	1874	31672000	26367	13041	3	0	2
365011	1678	26640830897000	26368	13042	0	0	1
365013	1874	31673000	26368	13042	2	0	2
365019	1678	26640830899000	26370	13043	0	0	1
365020	1874	31675000	26370	13043	1	0	2
365021	1874	31678000	26370	13043	2	0	2
365022	1874	31681000	26370	13043	3	0	2
365024	2346	100000000	26370	13043	5	0	0
365031	1678	26640830900000	26372	13044	0	0	\N
365032	1874	31687000	26372	13044	1	0	\N
365033	2347	100000000	26372	13044	2	0	\N
365034	2346	190000000	26372	13044	3	0	\N
365035	1874	31688000	26372	13044	4	0	\N
365036	1874	31690000	26372	13044	5	0	\N
365037	1678	26640830900000	26373	13044	0	0	\N
365038	1874	31687000	26373	13044	1	0	\N
365039	2347	100000000	26373	13044	2	0	\N
365040	2346	190000000	26373	13044	3	0	\N
365041	1874	31688000	26373	13044	4	0	\N
365042	1874	31690000	26373	13044	5	0	\N
365057	1678	26640830903000	26376	13046	0	0	\N
365058	1678	26640830904000	26376	13046	1	0	\N
365059	2348	100000000	26376	13046	2	0	\N
365060	1874	31701000	26376	13046	3	0	\N
365061	1874	31704000	26376	13046	4	0	\N
365062	1874	31706000	26376	13046	5	0	\N
365063	1874	31708000	26376	13046	6	0	\N
365064	1874	31711000	26376	13046	7	0	\N
365068	1678	26640830905000	26378	13047	0	0	\N
365069	1874	31714000	26378	13047	1	0	\N
365070	1874	31716000	26378	13047	2	0	\N
365074	1678	26640830906000	26380	13048	0	0	\N
365075	1874	31718000	26380	13048	1	0	\N
365076	1874	31721000	26380	13048	2	0	\N
365081	1678	26640830907000	26382	13049	0	0	\N
365082	1874	31722000	26382	13049	1	0	\N
365083	1874	31724000	26382	13049	2	0	\N
365084	1874	31727000	26382	13049	3	0	\N
365085	1678	26640830907000	26383	13049	0	0	\N
365086	1874	31722000	26383	13049	1	0	\N
365087	1874	31724000	26383	13049	2	0	\N
365088	1874	31727000	26383	13049	3	0	\N
365089	1678	26640830907000	26384	13049	0	0	\N
365090	1874	31722000	26384	13049	1	0	\N
365091	1874	31724000	26384	13049	2	0	\N
365092	1874	31727000	26384	13049	3	0	\N
365093	1678	26640830907000	26385	13049	0	0	\N
365094	1874	31722000	26385	13049	1	0	\N
365095	1874	31724000	26385	13049	2	0	\N
365096	1874	31727000	26385	13049	3	0	\N
365123	1678	26640830914000	26391	13054	0	0	\N
365124	1678	26640830915000	26391	13054	1	0	\N
365125	1874	31760000	26391	13054	2	0	\N
365126	1874	31762000	26391	13054	3	0	\N
365127	1874	31763000	26391	13054	4	0	\N
365128	1874	31766000	26391	13054	5	0	\N
365129	1874	31769000	26391	13054	6	0	\N
365130	1874	30804000	26392	12900	0	0	\N
365131	2329	720022000000	26392	12900	1	0	\N
365132	1874	30806000	26392	12900	2	0	\N
365133	2330	100000000	26392	12900	3	0	\N
365134	2329	302406199819988	26392	12900	4	0	\N
365135	1874	30807000	26392	12900	5	0	\N
365136	1874	30808000	26392	12900	6	0	\N
365137	1874	30809000	26392	12900	7	0	\N
365138	1874	30810000	26392	12900	8	0	\N
365139	2331	100000000	26392	12900	9	0	\N
365140	2332	100000000	26392	12900	10	0	\N
365141	2333	100000000	26392	12900	11	0	\N
365142	2296	100000000	26392	12900	12	0	\N
365143	2334	100000000	26392	12900	13	0	\N
365144	2335	100000000	26392	12900	14	0	\N
365145	1874	30812000	26392	12900	15	0	\N
365146	1874	30814000	26392	12900	16	0	\N
365147	1874	30816000	26392	12900	17	0	\N
365148	1874	30818000	26392	12900	18	0	\N
365149	1874	30820000	26392	12900	19	0	\N
365150	1874	30822000	26392	12900	20	0	\N
365151	1874	30824000	26392	12900	21	0	\N
365152	1874	30826000	26392	12900	22	0	\N
365153	1874	30828000	26392	12900	23	0	\N
365154	1874	30830000	26392	12900	24	0	\N
365155	1874	30832000	26392	12900	25	0	\N
365156	1874	30834000	26392	12900	26	0	\N
365157	1874	30836000	26392	12900	27	0	\N
365158	1874	30838000	26392	12900	28	0	\N
365159	1874	30840000	26392	12900	29	0	\N
365160	1874	30842000	26392	12900	30	0	\N
365027	2347	100000000	26371	13044	2	0	0
365028	2346	190000000	26371	13044	3	0	0
365029	1874	31688000	26371	13044	4	0	2
365030	1874	31690000	26371	13044	5	0	2
365043	1678	26640830901000	26374	13045	0	0	1
365045	1874	31693000	26374	13045	2	0	2
365046	1874	31695000	26374	13045	3	0	2
365047	1874	31698000	26374	13045	4	0	2
365048	1874	31700000	26374	13045	5	0	2
365049	1678	26640830903000	26375	13046	0	0	1
365051	2348	100000000	26375	13046	2	0	0
365052	1874	31701000	26375	13046	3	0	2
365053	1874	31704000	26375	13046	4	0	2
365054	1874	31706000	26375	13046	5	0	2
365056	1874	31711000	26375	13046	7	0	2
365065	1678	26640830905000	26377	13047	0	0	1
365066	1874	31714000	26377	13047	1	0	2
365067	1874	31716000	26377	13047	2	0	2
365071	1678	26640830906000	26379	13048	0	0	1
365073	1874	31721000	26379	13048	2	0	2
365077	1678	26640830907000	26381	13049	0	0	1
365078	1874	31722000	26381	13049	1	0	2
365079	1874	31724000	26381	13049	2	0	2
365080	1874	31727000	26381	13049	3	0	2
365098	1874	31730000	26386	13050	1	0	2
365099	1874	31732000	26386	13050	2	0	2
365100	1678	26640830909000	26387	13051	0	0	1
365101	1874	31734000	26387	13051	1	0	2
365103	1678	26640830910000	26388	13052	0	0	1
365104	1678	26640830911000	26388	13052	1	0	1
365105	1874	31739000	26388	13052	2	0	2
365106	1874	31741000	26388	13052	3	0	2
365107	1874	31742000	26388	13052	4	0	2
365109	1874	31748000	26388	13052	6	0	2
365110	1678	26640830912000	26389	13053	0	0	1
365111	1678	26640830913000	26389	13053	1	0	1
365112	1874	31751000	26389	13053	2	0	2
365113	1874	31753000	26389	13053	3	0	2
365115	1874	31758000	26389	13053	5	0	2
365116	1678	26640830914000	26390	13054	0	0	1
365117	1678	26640830915000	26390	13054	1	0	1
365118	1874	31760000	26390	13054	2	0	2
365120	1874	31763000	26390	13054	4	0	2
365121	1874	31766000	26390	13054	5	0	2
365122	1874	31769000	26390	13054	6	0	2
365161	1874	30844000	26392	12900	31	0	\N
365162	1874	30846000	26392	12900	32	0	\N
365163	1874	30848000	26392	12900	33	0	\N
365164	1874	30850000	26392	12900	34	0	\N
365165	1874	30852000	26392	12900	35	0	\N
365166	1874	30854000	26392	12900	36	0	\N
365167	1874	30856000	26392	12900	37	0	\N
365168	1874	30858000	26392	12900	38	0	\N
365169	1874	30860000	26392	12900	39	0	\N
365170	1874	30862000	26392	12900	40	0	\N
365171	1874	30864000	26392	12900	41	0	\N
365172	1874	30866000	26392	12900	42	0	\N
365173	1874	30868000	26392	12900	43	0	\N
365174	1874	30870000	26392	12900	44	0	\N
365175	1874	30872000	26392	12900	45	0	\N
365176	1874	30874000	26392	12900	46	0	\N
365177	1874	30876000	26392	12900	47	0	\N
365178	1874	30878000	26392	12900	48	0	\N
365179	1874	30880000	26392	12900	49	0	\N
365180	1874	30882000	26392	12900	50	0	\N
365181	1874	30884000	26392	12900	51	0	\N
365182	1874	30886000	26392	12900	52	0	\N
365183	1874	30888000	26392	12900	53	0	\N
365184	1874	30890000	26392	12900	54	0	\N
365185	1874	30892000	26392	12900	55	0	\N
365186	1874	30894000	26392	12900	56	0	\N
365187	1874	30896000	26392	12900	57	0	\N
365188	1874	30898000	26392	12900	58	0	\N
365189	1874	30900000	26392	12900	59	0	\N
365190	1874	30902000	26392	12900	60	0	\N
365191	1874	30904000	26392	12900	61	0	\N
365192	1874	30906000	26392	12900	62	0	\N
365193	1874	30908000	26392	12900	63	0	\N
365194	1874	30910000	26392	12900	64	0	\N
365195	1874	30912000	26392	12900	65	0	\N
365196	1874	30914000	26392	12900	66	0	\N
365197	1874	30916000	26392	12900	67	0	\N
365198	1874	30918000	26392	12900	68	0	\N
365199	1874	30920000	26392	12900	69	0	\N
365200	1874	30922000	26392	12900	70	0	\N
365201	1874	30924000	26392	12900	71	0	\N
365202	1874	30926000	26392	12900	72	0	\N
365203	1874	30928000	26392	12900	73	0	\N
365204	1874	30930000	26392	12900	74	0	\N
365205	1874	30932000	26392	12900	75	0	\N
365206	1874	30934000	26392	12900	76	0	\N
365207	1874	30936000	26392	12900	78	0	\N
365208	1874	30938000	26392	12900	79	0	\N
365209	1874	30940000	26392	12900	80	0	\N
365210	1874	30942000	26392	12900	81	0	\N
365211	1874	30944000	26392	12900	82	0	\N
365212	1874	30946000	26392	12900	83	0	\N
365213	1874	30948000	26392	12900	84	0	\N
365214	1874	30950000	26392	12900	85	0	\N
365215	1874	30952000	26392	12900	86	0	\N
365216	1874	30954000	26392	12900	87	0	\N
365217	1681	14254739358535	26392	12900	88	0	\N
365218	1874	30955000	26392	12900	89	0	\N
365219	1874	30956000	26392	12900	90	0	\N
365220	1874	30957000	26392	12900	91	0	\N
365221	1874	30958000	26392	12900	92	0	\N
365222	1874	30959000	26392	12900	93	0	\N
365223	1874	30960000	26392	12900	94	0	\N
365224	1874	30961000	26392	12900	95	0	\N
365225	1874	30962000	26392	12900	96	0	\N
365226	1874	30963000	26392	12900	97	0	\N
365227	1874	30964000	26392	12900	98	0	\N
365228	1874	30965000	26392	12900	99	0	\N
365229	1874	30966000	26392	12900	100	0	\N
365230	1874	30967000	26392	12900	101	0	\N
365231	1874	30968000	26392	12900	102	0	\N
365232	1874	30969000	26392	12900	103	0	\N
365233	1874	30970000	26392	12900	104	0	\N
365234	1874	30971000	26392	12900	105	0	\N
365235	1874	30972000	26392	12900	106	0	\N
365236	1874	30973000	26392	12900	107	0	\N
365237	1874	30974000	26392	12900	108	0	\N
365238	1874	30975000	26392	12900	109	0	\N
365239	1874	30976000	26392	12900	110	0	\N
365240	1874	30977000	26392	12900	111	0	\N
365241	1874	30978000	26392	12900	112	0	\N
365242	1874	30979000	26392	12900	113	0	\N
365243	1874	30980000	26392	12900	114	0	\N
365244	1874	30981000	26392	12900	115	0	\N
365259	1678	26640830920000	26396	13058	0	0	\N
365260	1678	26640830921000	26396	13058	2	0	\N
365261	1874	31792000	26396	13058	3	0	\N
365262	1874	31794000	26396	13058	4	0	\N
365263	1874	31797000	26396	13058	5	0	\N
365264	1874	31800000	26396	13058	6	0	\N
365265	1874	31801000	26396	13058	7	0	\N
365289	1678	26640830926000	26403	13063	0	0	\N
365290	1874	31824000	26403	13063	1	0	\N
365291	1874	31827000	26403	13063	2	0	\N
365296	1678	26640830927000	26405	13064	0	0	\N
365247	1874	31770000	26393	13055	2	0	2
365248	1874	31772000	26393	13055	3	0	2
365249	1874	31774000	26393	13055	4	0	2
365250	1874	31777000	26393	13055	5	0	2
365251	1874	31780000	26393	13055	6	0	2
365253	1874	31783000	26394	13056	1	0	2
365254	1874	31785000	26394	13056	2	0	2
365255	1678	26640830919000	26395	13057	0	0	1
365256	1874	31788000	26395	13057	1	0	2
365257	1561	0	26395	13057	2	0	0
365266	1678	26640830920000	26397	13058	0	0	1
365267	1678	26640830921000	26397	13058	2	0	1
365268	1874	31792000	26397	13058	3	0	2
365269	1874	31794000	26397	13058	4	0	2
365271	1874	31800000	26397	13058	6	0	2
365272	1874	31801000	26397	13058	7	0	2
365273	1678	26640830922000	26398	13059	0	0	1
365274	1874	31804000	26398	13059	1	0	2
365275	1678	26640830923000	26399	13060	0	0	1
365277	1874	31809000	26399	13060	2	0	2
365278	1874	31811000	26399	13060	3	0	2
365279	1678	26640830924000	26400	13061	0	0	1
365280	1874	31813000	26400	13061	1	0	2
365281	1874	31816000	26400	13061	2	0	2
365283	1678	26640830925000	26401	13062	0	0	1
365284	1874	31820000	26401	13062	1	0	2
365285	1874	31822000	26401	13062	2	0	2
365286	1678	26640830926000	26402	13063	0	0	1
365288	1874	31827000	26402	13063	2	0	2
365292	1678	26640830927000	26404	13064	0	0	1
365293	1874	31830000	26404	13064	1	0	2
365294	1874	31831000	26404	13064	2	0	2
365295	1874	31833000	26404	13064	3	0	2
365297	1874	31830000	26405	13064	1	0	\N
365298	1874	31831000	26405	13064	2	0	\N
365299	1874	31833000	26405	13064	3	0	\N
365300	1678	26640830922000	26406	13059	0	0	\N
365301	1678	26640830923000	26406	13059	1	0	\N
365302	1678	26640830924000	26406	13059	2	0	\N
365303	1678	26640830925000	26406	13059	3	0	\N
365304	1678	26640830926000	26406	13059	4	0	\N
365305	1678	26640830927000	26406	13059	5	0	\N
365306	1678	26640830928000	26406	13059	6	0	\N
365307	1874	31804000	26406	13059	7	0	\N
365308	1874	31807000	26406	13059	8	0	\N
365309	1874	31809000	26406	13059	9	0	\N
365310	1874	31812000	26406	13059	10	0	\N
365311	1874	31815000	26406	13059	11	0	\N
365312	1874	31818000	26406	13059	12	0	\N
365313	1874	31821000	26406	13059	13	0	\N
365314	1874	31822000	26406	13059	14	0	\N
365315	1874	31823000	26406	13059	15	0	\N
365316	1874	31825000	26406	13059	16	0	\N
365317	1874	31827000	26406	13059	17	0	\N
365318	1874	31829000	26406	13059	18	0	\N
365319	1874	31831000	26406	13059	19	0	\N
365320	1874	31833000	26406	13059	20	0	\N
365321	1678	26640830928000	26407	13065	0	0	\N
365322	1678	26640830929000	26407	13065	1	0	\N
365323	1874	31836000	26407	13065	2	0	\N
365324	1874	31839000	26407	13065	3	0	\N
365325	1874	31841000	26407	13065	4	0	\N
365326	1874	31843000	26407	13065	5	0	\N
365333	1678	26640830786000	26409	12853	0	0	\N
365334	1678	26640830787000	26409	12853	1	0	\N
365335	1678	26640830788000	26409	12853	2	0	\N
365336	1678	26640830789000	26409	12853	3	0	\N
365337	1678	26640830790000	26409	12853	4	0	\N
365338	1678	26640830791000	26409	12853	5	0	\N
365339	1678	26640830792000	26409	12853	6	0	\N
365340	1678	26640830793000	26409	12853	7	0	\N
365341	1678	26640830794000	26409	12853	8	0	\N
365342	1678	26640830795000	26409	12853	9	0	\N
365343	1678	26640830796000	26409	12853	10	0	\N
365344	1678	26640830797000	26409	12853	11	0	\N
365345	1678	26640830798000	26409	12853	12	0	\N
365346	1678	26640830799000	26409	12853	13	0	\N
365347	1678	26640830800000	26409	12853	14	0	\N
365348	1678	26640830801000	26409	12853	15	0	\N
365349	1678	26640830802000	26409	12853	16	0	\N
365350	1678	26640830803000	26409	12853	17	0	\N
365351	1678	26640830804000	26409	12853	18	0	\N
365352	1678	26640830805000	26409	12853	19	0	\N
365353	1678	26640830806000	26409	12853	20	0	\N
365354	1678	26640830807000	26409	12853	21	0	\N
365355	1678	26640830808000	26409	12853	22	0	\N
365356	1678	26640830809000	26409	12853	23	0	\N
365357	1678	26640830810000	26409	12853	24	0	\N
365358	1678	26640830811000	26409	12853	25	0	\N
365359	1678	26640830812000	26409	12853	26	0	\N
365360	1678	26640830813000	26409	12853	27	0	\N
365361	1678	26640830814000	26409	12853	28	0	\N
365362	1678	26640830815000	26409	12853	29	0	\N
365363	1678	26640830816000	26409	12853	30	0	\N
365364	1678	26640830817000	26409	12853	31	0	\N
365365	1678	26640830818000	26409	12853	32	0	\N
365366	1678	26640830819000	26409	12853	33	0	\N
365367	1678	26640830820000	26409	12853	34	0	\N
365368	1678	26640830821000	26409	12853	35	0	\N
365369	1678	26640830822000	26409	12853	36	0	\N
365370	1678	26640830823000	26409	12853	37	0	\N
365371	1678	26640830824000	26409	12853	38	0	\N
365372	1678	26640830825000	26409	12853	39	0	\N
365373	1678	26640830826000	26409	12853	40	0	\N
365374	1678	26640830827000	26409	12853	41	0	\N
365375	1678	26640830828000	26409	12853	42	0	\N
365376	1678	26640830829000	26409	12853	43	0	\N
365377	1678	26640830830000	26409	12853	44	0	\N
365378	1678	26640830831000	26409	12853	45	0	\N
365379	1678	26640830832000	26409	12853	46	0	\N
365380	1678	26640830833000	26409	12853	47	0	\N
365381	1678	26640830834000	26409	12853	48	0	\N
365382	1678	26640830835000	26409	12853	49	0	\N
365383	1678	26640830836000	26409	12853	50	0	\N
365384	1678	26640830837000	26409	12853	51	0	\N
365385	1678	26640830838000	26409	12853	52	0	\N
365386	1678	26640830839000	26409	12853	53	0	\N
365387	1678	26640830840000	26409	12853	54	0	\N
365388	1678	26640830841000	26409	12853	55	0	\N
365389	1678	26640830842000	26409	12853	56	0	\N
365390	1678	26640830843000	26409	12853	57	0	\N
365391	1678	26640830844000	26409	12853	58	0	\N
365392	1678	26640830845000	26409	12853	59	0	\N
365393	1678	26640830846000	26409	12853	60	0	\N
365394	1678	26640830847000	26409	12853	61	0	\N
365395	1678	26640830848000	26409	12853	62	0	\N
365396	1678	26640830849000	26409	12853	63	0	\N
365397	1678	26640830850000	26409	12853	64	0	\N
365398	1678	26640830851000	26409	12853	65	0	\N
365399	1678	26640830852000	26409	12853	66	0	\N
365400	1678	26640830853000	26409	12853	67	0	\N
365401	1678	26640830854000	26409	12853	68	0	\N
365402	1678	26640830855000	26409	12853	69	0	\N
365403	1678	26640830856000	26409	12853	70	0	\N
365404	1678	26640830857000	26409	12853	71	0	\N
365405	1678	26640830858000	26409	12853	72	0	\N
365406	1678	26640830859000	26409	12853	73	0	\N
365407	1678	26640830860000	26409	12853	74	0	\N
365408	1678	26640830861000	26409	12853	75	0	\N
365409	1678	26640830862000	26409	12853	76	0	\N
365410	1678	26640830863000	26409	12853	77	0	\N
365411	1678	26640830864000	26409	12853	78	0	\N
365412	1678	26640830865000	26409	12853	79	0	\N
365413	1678	26640830866000	26409	12853	80	0	\N
365414	1678	26640830867000	26409	12853	81	0	\N
365415	1678	26640830868000	26409	12853	82	0	\N
365416	1678	26640830869000	26409	12853	83	0	\N
365417	1678	26640830870000	26409	12853	84	0	\N
365418	1678	26640830871000	26409	12853	85	0	\N
365419	1678	26640830872000	26409	12853	86	0	\N
365420	1678	26640830873000	26409	12853	87	0	\N
365421	1678	26640830874000	26409	12853	88	0	\N
365422	1678	26640830875000	26409	12853	89	0	\N
365423	1678	26640830876000	26409	12853	90	0	\N
365424	1678	26640830877000	26409	12853	91	0	\N
365425	1678	26640830878000	26409	12853	92	0	\N
365426	1678	26640830879000	26409	12853	93	0	\N
365427	1678	26640830880000	26409	12853	94	0	\N
365428	1678	26640830881000	26409	12853	95	0	\N
365429	1678	26640830882000	26409	12853	96	0	\N
365430	1678	26640830883000	26409	12853	97	0	\N
365431	1678	26640830884000	26409	12853	98	0	\N
365432	1678	26640830885000	26409	12853	99	0	\N
365329	1874	31836000	26408	13065	2	0	2
365330	1874	31839000	26408	13065	3	0	2
365331	1874	31841000	26408	13065	4	0	2
365332	1874	31843000	26408	13065	5	0	2
365433	1678	26640830886000	26409	12853	100	0	\N
365434	1678	26640830887000	26409	12853	101	0	\N
365435	1678	26640830888000	26409	12853	102	0	\N
365436	1678	26640830889000	26409	12853	103	0	\N
365437	1678	26640830890000	26409	12853	104	0	\N
365438	1678	26640830891000	26409	12853	105	0	\N
365439	1678	26640830892000	26409	12853	106	0	\N
365440	1678	26640830893000	26409	12853	107	0	\N
365441	1678	26640830894000	26409	12853	108	0	\N
365442	1678	26640830895000	26409	12853	109	0	\N
365443	1678	26640830896000	26409	12853	110	0	\N
365444	1678	26640830897000	26409	12853	111	0	\N
365445	1678	26640830898000	26409	12853	112	0	\N
365446	1678	26640830899000	26409	12853	113	0	\N
365447	1678	26640830900000	26409	12853	114	0	\N
365448	1678	26640830901000	26409	12853	115	0	\N
365449	1678	26640830902000	26409	12853	116	0	\N
365450	1678	26640830930000	26410	13066	0	0	\N
365451	1874	31844000	26410	13066	1	0	\N
365452	1874	31846000	26410	13066	2	0	\N
365453	1874	31849000	26410	13066	3	0	\N
365458	1678	26640830931000	26412	13067	0	0	\N
365459	1874	31851000	26412	13067	1	0	\N
365460	1874	31854000	26412	13067	2	0	\N
365482	1678	26640830932000	26415	13068	0	0	\N
365483	1678	26640830933000	26415	13068	1	0	\N
365484	1678	26640830934000	26415	13068	2	0	\N
365485	1678	26640830935000	26415	13068	3	0	\N
365486	1678	26640830936000	26415	13068	4	0	\N
365487	1874	31855000	26415	13068	5	0	\N
365488	1874	31858000	26415	13068	6	0	\N
365489	2349	100000000	26415	13068	7	0	\N
365490	2350	100000000	26415	13068	8	0	\N
365491	1874	31861000	26415	13068	9	0	\N
365492	1874	31864000	26415	13068	10	0	\N
365493	1874	31867000	26415	13068	11	0	\N
365494	1874	31870000	26415	13068	12	0	\N
365495	1874	31872000	26415	13068	13	0	\N
365496	1874	31874000	26415	13068	14	0	\N
365497	1874	31876000	26415	13068	15	0	\N
365498	1874	31878000	26415	13068	16	0	\N
365499	1874	31880000	26415	13068	17	0	\N
365504	1678	26640830937000	26417	13069	0	0	\N
365505	1874	31882000	26417	13069	1	0	\N
365506	1874	31885000	26417	13069	2	0	\N
365507	1874	31886000	26417	13069	3	0	\N
365521	1678	26640830941000	26421	13072	0	0	\N
365522	1874	31901000	26421	13072	1	0	\N
365523	1874	31904000	26421	13072	2	0	\N
365524	1678	26640830941000	26422	13072	0	0	\N
365525	1874	31901000	26422	13072	1	0	\N
365526	1874	31904000	26422	13072	2	0	\N
365527	1678	26640830941000	26423	13072	0	0	\N
365528	1874	31901000	26423	13072	1	0	\N
365529	1874	31904000	26423	13072	2	0	\N
365530	1678	26640830857000	26424	12928	0	0	\N
365531	1678	26640830858000	26424	12928	1	0	\N
365532	1678	26640830859000	26424	12928	2	0	\N
365533	1678	26640830860000	26424	12928	3	0	\N
365534	1678	26640830861000	26424	12928	4	0	\N
365535	1678	26640830862000	26424	12928	5	0	\N
365536	1678	26640830863000	26424	12928	6	0	\N
365537	1678	26640830864000	26424	12928	7	0	\N
365538	1678	26640830865000	26424	12928	8	0	\N
365539	1678	26640830866000	26424	12928	9	0	\N
365540	1678	26640830867000	26424	12928	10	0	\N
365541	1678	26640830868000	26424	12928	11	0	\N
365542	1678	26640830869000	26424	12928	12	0	\N
365543	1678	26640830870000	26424	12928	13	0	\N
365544	1678	26640830871000	26424	12928	14	0	\N
365545	1678	26640830872000	26424	12928	15	0	\N
365546	1678	26640830873000	26424	12928	16	0	\N
365547	1678	26640830874000	26424	12928	17	0	\N
365548	1678	26640830875000	26424	12928	18	0	\N
365549	1678	26640830876000	26424	12928	19	0	\N
365550	1678	26640830877000	26424	12928	20	0	\N
365551	1678	26640830878000	26424	12928	21	0	\N
365552	1678	26640830879000	26424	12928	22	0	\N
365553	1678	26640830880000	26424	12928	23	0	\N
365554	1678	26640830881000	26424	12928	24	0	\N
365555	1678	26640830882000	26424	12928	25	0	\N
365556	1678	26640830883000	26424	12928	26	0	\N
365557	1678	26640830884000	26424	12928	27	0	\N
365558	1678	26640830885000	26424	12928	28	0	\N
365559	1678	26640830886000	26424	12928	29	0	\N
365560	1678	26640830887000	26424	12928	30	0	\N
365561	1678	26640830888000	26424	12928	31	0	\N
365562	1678	26640830889000	26424	12928	32	0	\N
365563	1678	26640830890000	26424	12928	33	0	\N
365564	1678	26640830891000	26424	12928	34	0	\N
365565	1678	26640830892000	26424	12928	35	0	\N
365566	1678	26640830893000	26424	12928	36	0	\N
365567	1678	26640830894000	26424	12928	37	0	\N
365568	1678	26640830895000	26424	12928	38	0	\N
365456	1874	31846000	26411	13066	2	0	2
365457	1874	31849000	26411	13066	3	0	2
365461	1678	26640830931000	26413	13067	0	0	1
365462	1874	31851000	26413	13067	1	0	2
365463	1874	31854000	26413	13067	2	0	2
365465	1678	26640830933000	26414	13068	1	0	1
365466	1678	26640830934000	26414	13068	2	0	1
365467	1678	26640830935000	26414	13068	3	0	1
365468	1678	26640830936000	26414	13068	4	0	1
365469	1874	31855000	26414	13068	5	0	2
365471	2349	100000000	26414	13068	7	0	0
365472	2350	100000000	26414	13068	8	0	0
365473	1874	31861000	26414	13068	9	0	2
365474	1874	31864000	26414	13068	10	0	2
365476	1874	31870000	26414	13068	12	0	2
365477	1874	31872000	26414	13068	13	0	2
365478	1874	31874000	26414	13068	14	0	2
365479	1874	31876000	26414	13068	15	0	2
365480	1874	31878000	26414	13068	16	0	2
365500	1678	26640830937000	26416	13069	0	0	1
365501	1874	31882000	26416	13069	1	0	2
365502	1874	31885000	26416	13069	2	0	2
365503	1874	31886000	26416	13069	3	0	2
365508	1678	26640830938000	26418	13070	0	0	1
365510	1874	31888000	26418	13070	2	0	2
365511	1678	26640830939000	26419	13071	0	0	1
365512	1678	26640830940000	26419	13071	1	0	1
365513	1874	31890000	26419	13071	2	0	2
365515	1874	31893000	26419	13071	4	0	2
365516	1874	31896000	26419	13071	5	0	2
365517	1874	31899000	26419	13071	6	0	2
365518	1678	26640830941000	26420	13072	0	0	1
365519	1874	31901000	26420	13072	1	0	2
365569	1678	26640830896000	26424	12928	39	0	\N
365570	1678	26640830897000	26424	12928	40	0	\N
365571	1678	26640830898000	26424	12928	41	0	\N
365572	1678	26640830899000	26424	12928	42	0	\N
365573	1678	26640830900000	26424	12928	43	0	\N
365574	1678	26640830901000	26424	12928	44	0	\N
365575	1678	26640830902000	26424	12928	45	0	\N
365576	1678	26640830903000	26424	12928	46	0	\N
365577	1678	26640830904000	26424	12928	47	0	\N
365578	1678	26640830905000	26424	12928	48	0	\N
365579	1678	26640830906000	26424	12928	49	0	\N
365580	1678	26640830907000	26424	12928	50	0	\N
365581	1678	26640830908000	26424	12928	51	0	\N
365582	1678	26640830909000	26424	12928	52	0	\N
365583	1678	26640830910000	26424	12928	53	0	\N
365584	1678	26640830911000	26424	12928	54	0	\N
365585	1678	26640830912000	26424	12928	55	0	\N
365586	1678	26640830913000	26424	12928	56	0	\N
365587	1678	26640830914000	26424	12928	57	0	\N
365588	1678	26640830915000	26424	12928	58	0	\N
365589	1678	26640830916000	26424	12928	59	0	\N
365590	1678	26640830917000	26424	12928	60	0	\N
365591	1678	26640830918000	26424	12928	61	0	\N
365592	1678	26640830919000	26424	12928	62	0	\N
365593	1678	26640830920000	26424	12928	63	0	\N
365594	1678	26640830921000	26424	12928	64	0	\N
365595	1678	26640830922000	26424	12928	65	0	\N
365596	1678	26640830923000	26424	12928	66	0	\N
365597	1678	26640830924000	26424	12928	67	0	\N
365598	1678	26640830925000	26424	12928	68	0	\N
365599	1678	26640830926000	26424	12928	69	0	\N
365600	1678	26640830927000	26424	12928	70	0	\N
365601	1678	26640830928000	26424	12928	71	0	\N
365602	1678	26640830929000	26424	12928	72	0	\N
365603	1678	26640830930000	26424	12928	73	0	\N
365604	1678	26640830931000	26424	12928	74	0	\N
365605	1678	26640830932000	26424	12928	75	0	\N
365606	1678	26640830933000	26424	12928	76	0	\N
365607	1678	26640830934000	26424	12928	78	0	\N
365608	1678	26640830935000	26424	12928	79	0	\N
365609	1678	26640830936000	26424	12928	80	0	\N
365610	1678	26640830937000	26424	12928	81	0	\N
365611	1678	26640830938000	26424	12928	82	0	\N
365612	1678	26640830939000	26424	12928	83	0	\N
365613	1678	26640830940000	26424	12928	84	0	\N
365614	1678	26640830941000	26424	12928	85	0	\N
365615	2329	720022000000	26424	12928	86	0	\N
365616	2330	100000000	26424	12928	87	0	\N
365617	1561	0	26424	12928	88	0	\N
365624	1678	26640830943000	26427	13074	0	0	\N
365625	1874	31911000	26427	13074	1	0	\N
365626	1874	31914000	26427	13074	2	0	\N
365627	1678	26640830943000	26428	13074	0	0	\N
365628	1874	31911000	26428	13074	1	0	\N
365629	1874	31914000	26428	13074	2	0	\N
365630	1678	26640830944000	26429	13075	0	0	\N
365631	1874	31916000	26429	13075	1	0	\N
365632	1874	31917000	26429	13075	2	0	\N
365633	1874	31920000	26429	13075	3	0	\N
365648	1678	26640830946000	26433	13077	0	0	\N
365649	1678	26640830947000	26433	13077	1	0	\N
365650	1874	31928000	26433	13077	3	0	\N
365651	1874	31931000	26433	13077	4	0	\N
365652	1874	31933000	26433	13077	5	0	\N
365653	1874	31934000	26433	13077	6	0	\N
365654	1874	31936000	26433	13077	7	0	\N
365655	1678	26640830946000	26434	13077	0	0	\N
365656	1678	26640830947000	26434	13077	1	0	\N
365657	1874	31928000	26434	13077	3	0	\N
365658	1874	31931000	26434	13077	4	0	\N
365659	1874	31933000	26434	13077	5	0	\N
365660	1874	31934000	26434	13077	6	0	\N
365661	1874	31936000	26434	13077	7	0	\N
365662	1678	26640830946000	26435	13077	0	0	\N
365663	1678	26640830947000	26435	13077	1	0	\N
365664	1874	31928000	26435	13077	3	0	\N
365665	1874	31931000	26435	13077	4	0	\N
365666	1874	31933000	26435	13077	5	0	\N
365667	1874	31934000	26435	13077	6	0	\N
365668	1874	31936000	26435	13077	7	0	\N
365669	1678	26640830948000	26436	13078	0	0	\N
365670	1678	26640830949000	26436	13078	1	0	\N
365671	1874	31938000	26436	13078	2	0	\N
365672	1874	31940000	26436	13078	3	0	\N
365673	1874	31943000	26436	13078	4	0	\N
365674	1874	31946000	26436	13078	5	0	\N
365681	1678	26640830950000	26438	13079	0	0	\N
365682	1874	31949000	26438	13079	1	0	\N
365683	1874	31950000	26438	13079	2	0	\N
365684	1874	31952000	26438	13079	3	0	\N
365689	1678	26640830951000	26440	13080	0	0	\N
365690	1874	31954000	26440	13080	1	0	\N
365691	1874	31957000	26440	13080	2	0	\N
365695	1678	26640830952000	26442	13081	0	0	\N
365696	1678	26640830953000	26442	13081	1	0	\N
365697	1874	31959000	26442	13081	2	0	\N
365698	1874	31961000	26442	13081	3	0	\N
365699	1874	31964000	26442	13081	4	0	\N
365700	1874	31967000	26442	13081	5	0	\N
365620	1874	31909000	26425	13073	2	0	2
365621	1678	26640830943000	26426	13074	0	0	1
365622	1874	31911000	26426	13074	1	0	2
365623	1874	31914000	26426	13074	2	0	2
365634	1678	26640830944000	26430	13075	0	0	1
365636	1874	31917000	26430	13075	2	0	2
365637	1874	31920000	26430	13075	3	0	2
365638	1678	26640830945000	26431	13076	0	0	1
365639	1874	31922000	26431	13076	1	0	2
365640	1874	31925000	26431	13076	2	0	2
365642	1678	26640830947000	26432	13077	1	0	1
365643	1874	31928000	26432	13077	3	0	2
365644	1874	31931000	26432	13077	4	0	2
365645	1874	31933000	26432	13077	5	0	2
365647	1874	31936000	26432	13077	7	0	2
365675	1678	26640830948000	26437	13078	0	0	1
365676	1678	26640830949000	26437	13078	1	0	1
365677	1874	31938000	26437	13078	2	0	2
365678	1874	31940000	26437	13078	3	0	2
365680	1874	31946000	26437	13078	5	0	2
365685	1678	26640830950000	26439	13079	0	0	1
365686	1874	31949000	26439	13079	1	0	2
365687	1874	31950000	26439	13079	2	0	2
365688	1874	31952000	26439	13079	3	0	2
365693	1874	31954000	26441	13080	1	0	2
365694	1874	31957000	26441	13080	2	0	2
365701	1678	26640830952000	26443	13081	0	0	1
365702	1678	26640830953000	26443	13081	1	0	1
365704	1874	31961000	26443	13081	3	0	2
365707	1678	26640830952000	26444	13081	0	0	\N
365708	1678	26640830953000	26444	13081	1	0	\N
365709	1874	31959000	26444	13081	2	0	\N
365710	1874	31961000	26444	13081	3	0	\N
365711	1874	31964000	26444	13081	4	0	\N
365712	1874	31967000	26444	13081	5	0	\N
365717	1678	26640830954000	26447	13082	0	0	\N
365718	1874	31969000	26447	13082	1	0	\N
365719	1874	31970000	26447	13082	2	0	\N
365720	1874	31973000	26447	13082	3	0	\N
365721	1678	26640830954000	26448	13082	0	0	\N
365722	1874	31969000	26448	13082	1	0	\N
365723	1874	31970000	26448	13082	2	0	\N
365724	1874	31973000	26448	13082	3	0	\N
365725	1874	31968000	26449	13082	0	0	\N
365726	1874	31971000	26449	13082	1	0	\N
365727	1678	26640830955000	26450	13083	0	0	\N
365728	1874	31975000	26450	13083	1	0	\N
365729	1874	31978000	26450	13083	2	0	\N
365733	1678	26640830955000	26452	13083	0	0	\N
365734	1874	31975000	26452	13083	1	0	\N
365735	1874	31978000	26452	13083	2	0	\N
365738	1678	26640830957000	26454	13085	0	0	\N
365739	1874	31984000	26454	13085	1	0	\N
365740	1874	31985000	26454	13085	2	0	\N
365741	1874	31987000	26454	13085	3	0	\N
365742	1678	26640830932000	26455	13068	0	0	\N
365743	1678	26640830933000	26455	13068	1	0	\N
365744	1678	26640830934000	26455	13068	2	0	\N
365745	1678	26640830935000	26455	13068	3	0	\N
365746	1678	26640830936000	26455	13068	4	0	\N
365747	1678	26640830937000	26455	13068	5	0	\N
365748	1678	26640830938000	26455	13068	6	0	\N
365749	1678	26640830939000	26455	13068	7	0	\N
365750	1678	26640830940000	26455	13068	8	0	\N
365751	1678	26640830941000	26455	13068	9	0	\N
365752	1678	26640830942000	26455	13068	10	0	\N
365753	1678	26640830943000	26455	13068	11	0	\N
365754	1678	26640830944000	26455	13068	12	0	\N
365755	1678	26640830945000	26455	13068	13	0	\N
365756	1678	26640830946000	26455	13068	14	0	\N
365757	1678	26640830947000	26455	13068	15	0	\N
365758	1678	26640830948000	26455	13068	16	0	\N
365759	1678	26640830949000	26455	13068	17	0	\N
365760	1678	26640830950000	26455	13068	18	0	\N
365761	1678	26640830951000	26455	13068	19	0	\N
365762	1678	26640830952000	26455	13068	20	0	\N
365763	1678	26640830953000	26455	13068	21	0	\N
365764	1678	26640830954000	26455	13068	22	0	\N
365765	1678	26640830955000	26455	13068	23	0	\N
365766	1678	26640830956000	26455	13068	24	0	\N
365767	1678	26640830957000	26455	13068	25	0	\N
365768	1874	31855000	26455	13068	26	0	\N
365769	1874	31858000	26455	13068	27	0	\N
365770	2349	100000000	26455	13068	28	0	\N
365771	2350	100000000	26455	13068	29	0	\N
365772	3	145418010000000	26455	13068	30	0	\N
365773	1874	31859000	26455	13068	31	0	\N
365774	1874	31860000	26455	13068	32	0	\N
365775	1874	31861000	26455	13068	33	0	\N
365776	1874	31862000	26455	13068	34	0	\N
365777	1874	31863000	26455	13068	35	0	\N
365778	1874	31864000	26455	13068	36	0	\N
365779	1874	31865000	26455	13068	37	0	\N
365780	1874	31868000	26455	13068	38	0	\N
365781	1874	31871000	26455	13068	39	0	\N
365782	1874	31874000	26455	13068	40	0	\N
365783	1874	31877000	26455	13068	41	0	\N
365784	1874	31880000	26455	13068	42	0	\N
365785	1874	31883000	26455	13068	43	0	\N
365786	1874	31886000	26455	13068	44	0	\N
365787	1874	31889000	26455	13068	45	0	\N
365788	1874	31892000	26455	13068	46	0	\N
365789	1874	31895000	26455	13068	47	0	\N
365790	1874	31898000	26455	13068	48	0	\N
365791	1874	31901000	26455	13068	49	0	\N
365792	1874	31904000	26455	13068	50	0	\N
365793	1874	31907000	26455	13068	51	0	\N
365794	1874	31910000	26455	13068	52	0	\N
365795	1874	31913000	26455	13068	53	0	\N
365796	1874	31916000	26455	13068	54	0	\N
365797	1874	31919000	26455	13068	55	0	\N
365798	1874	31922000	26455	13068	56	0	\N
365799	1874	31925000	26455	13068	57	0	\N
365800	1874	31928000	26455	13068	58	0	\N
365801	1874	31931000	26455	13068	59	0	\N
365802	1874	31934000	26455	13068	60	0	\N
365803	1874	31937000	26455	13068	61	0	\N
365804	1874	31939000	26455	13068	62	0	\N
365805	1874	31941000	26455	13068	63	0	\N
365806	1874	31943000	26455	13068	64	0	\N
365807	1874	31945000	26455	13068	65	0	\N
365808	1874	31947000	26455	13068	66	0	\N
365809	1874	31949000	26455	13068	67	0	\N
365810	1874	31951000	26455	13068	69	0	\N
365811	1874	31953000	26455	13068	70	0	\N
365812	1874	31955000	26455	13068	71	0	\N
365813	1874	31957000	26455	13068	72	0	\N
365814	1874	31959000	26455	13068	73	0	\N
365815	1874	31961000	26455	13068	74	0	\N
365816	1874	31963000	26455	13068	75	0	\N
365817	1874	31965000	26455	13068	76	0	\N
365818	1874	31967000	26455	13068	77	0	\N
365819	1874	31969000	26455	13068	78	0	\N
365820	1874	31971000	26455	13068	79	0	\N
365821	1874	31973000	26455	13068	80	0	\N
365822	1874	31975000	26455	13068	81	0	\N
365823	1874	31977000	26455	13068	82	0	\N
365824	1874	31979000	26455	13068	83	0	\N
365825	1874	31981000	26455	13068	84	0	\N
365826	1874	31983000	26455	13068	85	0	\N
365827	1874	31985000	26455	13068	86	0	\N
365828	1874	31987000	26455	13068	87	0	\N
365713	1678	26640830954000	26446	13082	0	0	1
365714	1874	31969000	26446	13082	1	0	2
365715	1874	31970000	26446	13082	2	0	2
365716	1874	31973000	26446	13082	3	0	2
365730	1678	26640830955000	26451	13083	0	0	1
365732	1874	31978000	26451	13083	2	0	2
365736	1678	26640830956000	26453	13084	0	0	1
365737	1874	31981000	26453	13084	1	0	2
365829	1678	26640830957000	26456	13085	0	0	1
365830	1874	31984000	26456	13085	1	0	2
365832	1874	31987000	26456	13085	3	0	2
365833	1678	26640830958000	26457	13086	0	0	1
365834	1874	31989000	26457	13086	1	0	2
365835	1874	31992000	26457	13086	2	0	2
365837	1678	26640830960000	26458	13087	1	0	1
365838	1874	31994000	26458	13087	2	0	2
365839	1874	31996000	26458	13087	3	0	2
365840	1874	31999000	26458	13087	4	0	2
365843	1678	26640830923000	26459	13060	0	0	\N
365844	1678	26640830924000	26459	13060	1	0	\N
365845	1678	26640830925000	26459	13060	2	0	\N
365846	1678	26640830926000	26459	13060	3	0	\N
365847	1678	26640830927000	26459	13060	4	0	\N
365848	1678	26640830928000	26459	13060	5	0	\N
365849	1678	26640830929000	26459	13060	6	0	\N
365850	1678	26640830930000	26459	13060	7	0	\N
365851	1678	26640830931000	26459	13060	8	0	\N
365852	1678	26640830932000	26459	13060	9	0	\N
365853	1678	26640830933000	26459	13060	10	0	\N
365854	1678	26640830934000	26459	13060	11	0	\N
365855	1678	26640830935000	26459	13060	12	0	\N
365856	1678	26640830936000	26459	13060	13	0	\N
365857	1678	26640830937000	26459	13060	14	0	\N
365858	1678	26640830938000	26459	13060	15	0	\N
365859	1678	26640830939000	26459	13060	16	0	\N
365860	1678	26640830940000	26459	13060	17	0	\N
365861	1678	26640830941000	26459	13060	18	0	\N
365862	1678	26640830942000	26459	13060	19	0	\N
365863	1678	26640830943000	26459	13060	20	0	\N
365864	1678	26640830944000	26459	13060	21	0	\N
365865	1678	26640830945000	26459	13060	22	0	\N
365866	1678	26640830946000	26459	13060	23	0	\N
365867	1678	26640830947000	26459	13060	24	0	\N
365868	1678	26640830948000	26459	13060	25	0	\N
365869	1678	26640830949000	26459	13060	26	0	\N
365870	1678	26640830950000	26459	13060	27	0	\N
365871	1678	26640830951000	26459	13060	28	0	\N
365872	1678	26640830952000	26459	13060	29	0	\N
365873	1678	26640830953000	26459	13060	30	0	\N
365874	1678	26640830954000	26459	13060	31	0	\N
365875	1678	26640830955000	26459	13060	32	0	\N
365876	1678	26640830956000	26459	13060	33	0	\N
365877	1678	26640830957000	26459	13060	34	0	\N
365878	1678	26640830958000	26459	13060	35	0	\N
365879	1678	26640830959000	26459	13060	36	0	\N
365880	1678	26640830960000	26459	13060	37	0	\N
365881	1874	31807000	26459	13060	38	0	\N
365882	1874	31809000	26459	13060	39	0	\N
365883	2349	100000000	26459	13060	40	0	\N
365884	2350	100000000	26459	13060	41	0	\N
365885	1874	31812000	26459	13060	42	0	\N
365886	1874	31815000	26459	13060	43	0	\N
365887	1874	31818000	26459	13060	44	0	\N
365888	1874	31821000	26459	13060	45	0	\N
365889	1874	31824000	26459	13060	46	0	\N
365890	1874	31827000	26459	13060	47	0	\N
365891	3	145418010000000	26459	13060	48	0	\N
365892	1874	31830000	26459	13060	49	0	\N
365893	1874	31833000	26459	13060	50	0	\N
365894	1874	31836000	26459	13060	51	0	\N
365895	1874	31839000	26459	13060	52	0	\N
365896	1874	31842000	26459	13060	53	0	\N
365897	1874	31845000	26459	13060	54	0	\N
365898	1874	31848000	26459	13060	55	0	\N
365899	1874	31851000	26459	13060	56	0	\N
365900	1874	31854000	26459	13060	57	0	\N
365901	1874	31857000	26459	13060	58	0	\N
365902	1874	31860000	26459	13060	59	0	\N
365903	1874	31863000	26459	13060	60	0	\N
365904	1874	31866000	26459	13060	61	0	\N
365905	1874	31869000	26459	13060	62	0	\N
365906	1874	31872000	26459	13060	63	0	\N
365907	1874	31875000	26459	13060	64	0	\N
365908	1874	31878000	26459	13060	65	0	\N
365909	1874	31881000	26459	13060	66	0	\N
365910	1874	31884000	26459	13060	67	0	\N
365911	1874	31887000	26459	13060	68	0	\N
365912	1874	31890000	26459	13060	69	0	\N
365913	1874	31893000	26459	13060	70	0	\N
365914	1874	31896000	26459	13060	71	0	\N
365915	1874	31899000	26459	13060	72	0	\N
365916	1874	31902000	26459	13060	73	0	\N
365917	1874	31905000	26459	13060	74	0	\N
365918	1874	31908000	26459	13060	75	0	\N
365919	1874	31911000	26459	13060	76	0	\N
365920	1874	31914000	26459	13060	77	0	\N
365921	1874	31917000	26459	13060	78	0	\N
365922	1874	31918000	26459	13060	79	0	\N
365923	1874	31919000	26459	13060	80	0	\N
365924	1874	31920000	26459	13060	81	0	\N
365925	1874	31921000	26459	13060	82	0	\N
365926	1874	31922000	26459	13060	83	0	\N
365927	1874	31923000	26459	13060	84	0	\N
365928	1874	31924000	26459	13060	85	0	\N
365929	1874	31925000	26459	13060	86	0	\N
365930	1874	31926000	26459	13060	87	0	\N
365931	1874	31927000	26459	13060	88	0	\N
365932	1874	31928000	26459	13060	89	0	\N
365933	1874	31929000	26459	13060	90	0	\N
365934	1874	31931000	26459	13060	91	0	\N
365935	1874	31933000	26459	13060	92	0	\N
365936	1874	31935000	26459	13060	93	0	\N
365937	1874	31937000	26459	13060	94	0	\N
365938	1874	31939000	26459	13060	95	0	\N
365939	1874	31941000	26459	13060	96	0	\N
365940	1874	31943000	26459	13060	97	0	\N
365941	1874	31945000	26459	13060	98	0	\N
365942	1874	31947000	26459	13060	99	0	\N
365943	1874	31949000	26459	13060	100	0	\N
365944	1874	31951000	26459	13060	101	0	\N
365945	1874	31953000	26459	13060	102	0	\N
365946	1874	31955000	26459	13060	103	0	\N
365947	1874	31957000	26459	13060	104	0	\N
365948	1874	31959000	26459	13060	105	0	\N
365949	1874	31961000	26459	13060	106	0	\N
365950	1874	31963000	26459	13060	107	0	\N
365951	1874	31965000	26459	13060	108	0	\N
365952	1874	31967000	26459	13060	109	0	\N
365953	1874	31969000	26459	13060	110	0	\N
365954	1874	31971000	26459	13060	111	0	\N
365955	1874	31973000	26459	13060	112	0	\N
365956	1874	31975000	26459	13060	113	0	\N
365957	1874	31977000	26459	13060	114	0	\N
365958	1874	31979000	26459	13060	116	0	\N
365959	1874	31981000	26459	13060	117	0	\N
365969	1678	26640830962000	26463	13089	0	0	\N
365970	1678	26640830963000	26463	13089	1	0	\N
365971	1874	32011000	26463	13089	2	0	\N
365972	1874	32014000	26463	13089	3	0	\N
365973	1874	32016000	26463	13089	4	0	\N
365974	1874	32018000	26463	13089	5	0	\N
365960	1678	26640830961000	26460	13088	0	0	1
365961	1874	32005000	26460	13088	1	0	2
365962	1874	32008000	26460	13088	2	0	2
365963	1678	26640830962000	26462	13089	0	0	1
365964	1678	26640830963000	26462	13089	1	0	1
365966	1874	32014000	26462	13089	3	0	2
365967	1874	32016000	26462	13089	4	0	2
365968	1874	32018000	26462	13089	5	0	2
365975	1874	32021000	26464	13090	0	0	2
365976	1874	32022000	26464	13090	1	0	2
365981	1678	26640830964000	26466	13091	0	0	\N
365982	1874	32027000	26466	13091	1	0	\N
365983	1874	32029000	26466	13091	2	0	\N
365984	1678	26640830930000	26467	13066	0	0	\N
365985	1678	26640830931000	26467	13066	1	0	\N
365986	1678	26640830932000	26467	13066	2	0	\N
365987	1678	26640830933000	26467	13066	3	0	\N
365988	1678	26640830934000	26467	13066	4	0	\N
365989	1678	26640830935000	26467	13066	5	0	\N
365990	1678	26640830936000	26467	13066	6	0	\N
365991	1678	26640830937000	26467	13066	7	0	\N
365992	1678	26640830938000	26467	13066	8	0	\N
365993	1678	26640830939000	26467	13066	9	0	\N
365994	1678	26640830940000	26467	13066	10	0	\N
365995	1678	26640830941000	26467	13066	11	0	\N
365996	1678	26640830942000	26467	13066	12	0	\N
365997	1678	26640830943000	26467	13066	13	0	\N
365998	1678	26640830944000	26467	13066	14	0	\N
365999	1678	26640830945000	26467	13066	15	0	\N
366000	1678	26640830946000	26467	13066	16	0	\N
366001	1678	26640830947000	26467	13066	17	0	\N
366002	1678	26640830948000	26467	13066	18	0	\N
366003	1678	26640830949000	26467	13066	19	0	\N
366004	1678	26640830950000	26467	13066	20	0	\N
366005	1678	26640830951000	26467	13066	21	0	\N
366006	1678	26640830952000	26467	13066	22	0	\N
366007	1678	26640830953000	26467	13066	23	0	\N
366008	1678	26640830954000	26467	13066	24	0	\N
366009	1678	26640830955000	26467	13066	25	0	\N
366010	1678	26640830956000	26467	13066	26	0	\N
366011	1678	26640830957000	26467	13066	27	0	\N
366012	1678	26640830958000	26467	13066	28	0	\N
366013	1678	26640830959000	26467	13066	29	0	\N
366014	1678	26640830960000	26467	13066	30	0	\N
366015	1678	26640830961000	26467	13066	31	0	\N
366016	1678	26640830962000	26467	13066	32	0	\N
366017	1678	26640830963000	26467	13066	33	0	\N
366018	1678	26640830964000	26467	13066	34	0	\N
366019	1874	31844000	26467	13066	35	0	\N
366020	1874	31845000	26467	13066	36	0	\N
366021	2349	100000000	26467	13066	37	0	\N
366022	2350	100000000	26467	13066	38	0	\N
366023	1874	31847000	26467	13066	39	0	\N
366024	1874	31849000	26467	13066	40	0	\N
366025	3	145418010000000	26467	13066	41	0	\N
366026	1874	31852000	26467	13066	42	0	\N
366027	1874	31853000	26467	13066	43	0	\N
366028	1874	31854000	26467	13066	44	0	\N
366029	1874	31855000	26467	13066	45	0	\N
366030	1874	31856000	26467	13066	46	0	\N
366031	1874	31857000	26467	13066	47	0	\N
366032	1874	31858000	26467	13066	48	0	\N
366033	1874	31859000	26467	13066	49	0	\N
366034	1874	31860000	26467	13066	50	0	\N
366035	1874	31861000	26467	13066	51	0	\N
366036	1874	31864000	26467	13066	52	0	\N
366037	1874	31867000	26467	13066	53	0	\N
366038	1874	31870000	26467	13066	54	0	\N
366039	1874	31873000	26467	13066	55	0	\N
366040	1874	31876000	26467	13066	56	0	\N
366041	1874	31879000	26467	13066	57	0	\N
366042	1874	31882000	26467	13066	58	0	\N
366043	1874	31885000	26467	13066	59	0	\N
366044	1874	31888000	26467	13066	60	0	\N
366045	1874	31891000	26467	13066	61	0	\N
366046	1874	31894000	26467	13066	62	0	\N
366047	1874	31897000	26467	13066	63	0	\N
366048	1874	31900000	26467	13066	64	0	\N
366049	1874	31903000	26467	13066	65	0	\N
366050	1874	31906000	26467	13066	66	0	\N
366051	1874	31909000	26467	13066	67	0	\N
366052	1874	31912000	26467	13066	68	0	\N
366053	1874	31915000	26467	13066	69	0	\N
366054	1874	31918000	26467	13066	70	0	\N
366055	1874	31921000	26467	13066	71	0	\N
366056	1874	31924000	26467	13066	72	0	\N
366057	1874	31927000	26467	13066	73	0	\N
366058	1874	31930000	26467	13066	74	0	\N
366059	1874	31933000	26467	13066	75	0	\N
366060	1874	31936000	26467	13066	76	0	\N
366061	1874	31939000	26467	13066	77	0	\N
366062	1874	31942000	26467	13066	78	0	\N
366063	1874	31945000	26467	13066	80	0	\N
366064	1874	31948000	26467	13066	81	0	\N
366065	1874	31951000	26467	13066	82	0	\N
366066	1874	31954000	26467	13066	83	0	\N
366067	1874	31957000	26467	13066	84	0	\N
366068	1874	31960000	26467	13066	85	0	\N
366069	1874	31963000	26467	13066	86	0	\N
366070	1874	31965000	26467	13066	87	0	\N
366071	1874	31967000	26467	13066	88	0	\N
366072	1874	31969000	26467	13066	89	0	\N
366073	1874	31971000	26467	13066	90	0	\N
366074	1874	31973000	26467	13066	91	0	\N
366075	1874	31975000	26467	13066	92	0	\N
366076	1874	31977000	26467	13066	93	0	\N
366077	1874	31979000	26467	13066	94	0	\N
366078	1874	31981000	26467	13066	95	0	\N
366079	1874	31983000	26467	13066	96	0	\N
366080	1874	31985000	26467	13066	97	0	\N
366081	1874	31987000	26467	13066	98	0	\N
366082	1874	31989000	26467	13066	99	0	\N
366083	1874	31991000	26467	13066	100	0	\N
366084	1874	31993000	26467	13066	101	0	\N
366085	1874	31995000	26467	13066	102	0	\N
366086	1874	31997000	26467	13066	103	0	\N
366087	1874	31999000	26467	13066	104	0	\N
366088	1874	32001000	26467	13066	105	0	\N
366089	1874	32003000	26467	13066	106	0	\N
366090	1874	32005000	26467	13066	107	0	\N
366091	1874	32007000	26467	13066	108	0	\N
366092	1874	32009000	26467	13066	109	0	\N
366093	1874	32011000	26467	13066	110	0	\N
366094	1874	32013000	26467	13066	111	0	\N
366095	1874	32015000	26467	13066	112	0	\N
366096	1874	32017000	26467	13066	113	0	\N
366097	1874	32019000	26467	13066	114	0	\N
366098	1874	32021000	26467	13066	115	0	\N
366099	1874	32023000	26467	13066	116	0	\N
366100	1874	32025000	26467	13066	117	0	\N
366101	1874	32027000	26467	13066	118	0	\N
366102	1874	32029000	26467	13066	119	0	\N
366103	1678	26640830878000	26468	13028	0	0	\N
366104	1678	26640830879000	26468	13028	1	0	\N
366105	1678	26640830880000	26468	13028	2	0	\N
366106	1678	26640830881000	26468	13028	3	0	\N
366107	1678	26640830882000	26468	13028	4	0	\N
366108	1678	26640830883000	26468	13028	5	0	\N
366109	1678	26640830884000	26468	13028	6	0	\N
366110	1678	26640830885000	26468	13028	7	0	\N
366111	1678	26640830886000	26468	13028	8	0	\N
366112	1678	26640830887000	26468	13028	9	0	\N
365979	1874	32027000	26465	13091	1	0	2
365980	1874	32029000	26465	13091	2	0	2
366113	1678	26640830888000	26468	13028	10	0	\N
366114	1678	26640830889000	26468	13028	11	0	\N
366115	1678	26640830890000	26468	13028	12	0	\N
366116	1678	26640830891000	26468	13028	13	0	\N
366117	1678	26640830892000	26468	13028	14	0	\N
366118	1678	26640830893000	26468	13028	15	0	\N
366119	1678	26640830894000	26468	13028	16	0	\N
366120	1678	26640830895000	26468	13028	17	0	\N
366121	1678	26640830896000	26468	13028	18	0	\N
366122	1678	26640830897000	26468	13028	19	0	\N
366123	1678	26640830898000	26468	13028	20	0	\N
366124	1678	26640830899000	26468	13028	21	0	\N
366125	1678	26640830900000	26468	13028	22	0	\N
366126	1678	26640830901000	26468	13028	23	0	\N
366127	1678	26640830902000	26468	13028	24	0	\N
366128	1678	26640830903000	26468	13028	25	0	\N
366129	1678	26640830904000	26468	13028	26	0	\N
366130	1678	26640830905000	26468	13028	27	0	\N
366131	1678	26640830906000	26468	13028	28	0	\N
366132	1678	26640830907000	26468	13028	29	0	\N
366133	1678	26640830908000	26468	13028	30	0	\N
366134	1678	26640830909000	26468	13028	31	0	\N
366135	1678	26640830910000	26468	13028	32	0	\N
366136	1678	26640830911000	26468	13028	33	0	\N
366137	1678	26640830912000	26468	13028	34	0	\N
366138	1678	26640830913000	26468	13028	35	0	\N
366139	1678	26640830914000	26468	13028	36	0	\N
366140	1678	26640830915000	26468	13028	37	0	\N
366141	1678	26640830916000	26468	13028	38	0	\N
366142	1678	26640830917000	26468	13028	39	0	\N
366143	1678	26640830918000	26468	13028	40	0	\N
366144	1678	26640830919000	26468	13028	41	0	\N
366145	1678	26640830920000	26468	13028	42	0	\N
366146	1678	26640830921000	26468	13028	43	0	\N
366147	1678	26640830922000	26468	13028	44	0	\N
366148	1678	26640830923000	26468	13028	45	0	\N
366149	1678	26640830924000	26468	13028	46	0	\N
366150	1678	26640830925000	26468	13028	47	0	\N
366151	1678	26640830926000	26468	13028	48	0	\N
366152	1678	26640830927000	26468	13028	49	0	\N
366153	1678	26640830928000	26468	13028	50	0	\N
366154	1678	26640830929000	26468	13028	51	0	\N
366155	1678	26640830930000	26468	13028	52	0	\N
366156	1678	26640830931000	26468	13028	53	0	\N
366157	1678	26640830932000	26468	13028	54	0	\N
366158	1678	26640830933000	26468	13028	55	0	\N
366159	1678	26640830934000	26468	13028	57	0	\N
366160	1678	26640830935000	26468	13028	58	0	\N
366161	1678	26640830936000	26468	13028	59	0	\N
366162	1678	26640830937000	26468	13028	60	0	\N
366163	1678	26640830938000	26468	13028	61	0	\N
366164	1678	26640830939000	26468	13028	62	0	\N
366165	1678	26640830940000	26468	13028	63	0	\N
366166	1678	26640830941000	26468	13028	64	0	\N
366167	1678	26640830942000	26468	13028	65	0	\N
366168	1678	26640830943000	26468	13028	66	0	\N
366169	1678	26640830944000	26468	13028	67	0	\N
366170	1678	26640830945000	26468	13028	68	0	\N
366171	1678	26640830946000	26468	13028	69	0	\N
366172	1678	26640830947000	26468	13028	70	0	\N
366173	1678	26640830948000	26468	13028	71	0	\N
366174	1678	26640830949000	26468	13028	72	0	\N
366175	1678	26640830950000	26468	13028	73	0	\N
366176	1678	26640830951000	26468	13028	74	0	\N
366177	1678	26640830952000	26468	13028	75	0	\N
366178	1678	26640830953000	26468	13028	76	0	\N
366179	1678	26640830954000	26468	13028	77	0	\N
366180	1678	26640830955000	26468	13028	78	0	\N
366181	1678	26640830956000	26468	13028	79	0	\N
366182	1678	26640830957000	26468	13028	80	0	\N
366183	1678	26640830958000	26468	13028	81	0	\N
366184	1678	26640830959000	26468	13028	82	0	\N
366185	1678	26640830960000	26468	13028	83	0	\N
366186	1678	26640830961000	26468	13028	84	0	\N
366187	1678	26640830962000	26468	13028	85	0	\N
366188	1678	26640830963000	26468	13028	86	0	\N
366189	1678	26640830964000	26468	13028	87	0	\N
366190	1874	31608000	26468	13028	88	0	\N
366191	1874	31609000	26468	13028	89	0	\N
366192	1874	31610000	26468	13028	90	0	\N
366193	1874	31613000	26468	13028	91	0	\N
366194	1874	31616000	26468	13028	92	0	\N
366195	1874	31619000	26468	13028	93	0	\N
366196	1874	31622000	26468	13028	94	0	\N
366197	1874	31625000	26468	13028	95	0	\N
366198	1874	31628000	26468	13028	96	0	\N
366199	1561	0	26468	13028	97	0	\N
366200	1874	31629000	26468	13028	98	0	\N
366201	1874	31632000	26468	13028	100	0	\N
366202	1874	31635000	26468	13028	101	0	\N
366203	3	145418010000000	26468	13028	102	0	\N
366204	1874	31636000	26468	13028	103	0	\N
366205	1874	31637000	26468	13028	104	0	\N
366206	1874	31638000	26468	13028	105	0	\N
366207	1874	31639000	26468	13028	106	0	\N
366208	1874	31640000	26468	13028	107	0	\N
366209	1874	31641000	26468	13028	108	0	\N
366210	1874	31642000	26468	13028	109	0	\N
366211	2346	100000000	26468	13028	110	0	\N
366212	2347	100000000	26468	13028	111	0	\N
366213	2348	100000000	26468	13028	112	0	\N
366214	2349	100000000	26468	13028	113	0	\N
366215	2350	100000000	26468	13028	114	0	\N
366216	1874	31643000	26468	13028	115	0	\N
366217	1874	31644000	26468	13028	116	0	\N
366218	1874	31645000	26468	13028	117	0	\N
366219	1874	31646000	26468	13028	118	0	\N
366220	1874	31649000	26468	13028	119	0	\N
366221	1874	31652000	26468	13028	120	0	\N
366222	1874	31655000	26468	13028	121	0	\N
366223	1874	31658000	26468	13028	122	0	\N
366224	1874	31661000	26468	13028	123	0	\N
366225	1874	31664000	26468	13028	124	0	\N
366226	1874	31667000	26468	13028	125	0	\N
366235	1678	26640830965000	26470	13092	0	0	\N
366236	1678	26640830966000	26470	13092	1	0	\N
366237	1874	32031000	26470	13092	2	0	\N
366238	1950	14538851000000	26470	13092	3	0	\N
366239	1874	32032000	26470	13092	4	0	\N
366240	1874	32034000	26470	13092	5	0	\N
366241	1874	32037000	26470	13092	6	0	\N
366242	1874	32040000	26470	13092	7	0	\N
366246	1678	26640830967000	26472	13093	0	0	\N
366247	1874	32043000	26472	13093	1	0	\N
366248	1874	32045000	26472	13093	2	0	\N
366229	1874	32031000	26469	13092	2	0	2
366230	1950	14538851000000	26469	13092	3	0	14
366231	1874	32032000	26469	13092	4	0	2
366232	1874	32034000	26469	13092	5	0	2
366233	1874	32037000	26469	13092	6	0	2
366243	1678	26640830967000	26471	13093	0	0	1
366244	1874	32043000	26471	13093	1	0	2
366245	1874	32045000	26471	13093	2	0	2
366262	1678	26640830970000	26475	13095	0	0	\N
366263	2351	100000000	26475	13095	1	0	\N
366264	1950	14848851000000	26475	13095	2	0	\N
366265	1874	32059000	26475	13095	3	0	\N
366266	2352	100000000	26475	13095	4	0	\N
366267	1874	32061000	26475	13095	5	0	\N
366268	1678	26640830970000	26476	13095	0	0	\N
366269	2351	100000000	26476	13095	1	0	\N
366270	1950	14848851000000	26476	13095	2	0	\N
366271	1874	32059000	26476	13095	3	0	\N
366272	2352	100000000	26476	13095	4	0	\N
366273	1874	32061000	26476	13095	5	0	\N
366282	1678	26640830972000	26479	13097	0	0	\N
366283	1874	32069000	26479	13097	1	0	\N
366284	1483	11000000	26479	13097	2	0	\N
366285	1874	32071000	26479	13097	3	0	\N
366291	1678	26640830973000	26481	13098	0	0	\N
366292	1874	32072000	26481	13098	1	0	\N
366293	1950	15158851000000	26481	13098	2	0	\N
366294	1874	32075000	26481	13098	3	0	\N
366295	1874	32077000	26481	13098	4	0	\N
366296	1678	26640830974000	26482	13099	0	0	\N
366297	1874	32079000	26482	13099	1	0	\N
366298	1874	32082000	26482	13099	2	0	\N
366299	1678	26640830974000	26483	13099	0	0	\N
366300	1874	32079000	26483	13099	1	0	\N
366301	1874	32082000	26483	13099	2	0	\N
366302	1678	26640830974000	26484	13099	0	0	\N
366303	1874	32079000	26484	13099	1	0	\N
366304	1874	32082000	26484	13099	2	0	\N
366318	1678	26640830978000	26489	13103	0	0	\N
366319	1678	26640830979000	26489	13103	1	0	\N
366320	1874	32099000	26489	13103	2	0	\N
366321	1874	32102000	26489	13103	3	0	\N
366322	1874	32105000	26489	13103	4	0	\N
366323	1874	32107000	26489	13103	5	0	\N
366324	1874	32109000	26489	13103	6	0	\N
366338	1678	27360855981000	26493	13105	0	0	\N
366339	1874	32117000	26493	13105	1	0	\N
366340	1874	32119000	26493	13105	2	0	\N
366341	1678	26640830929000	26494	13060	0	0	\N
366342	1678	26640830930000	26494	13060	1	0	\N
366343	1678	26640830931000	26494	13060	2	0	\N
366344	1678	26640830932000	26494	13060	3	0	\N
366345	1678	26640830933000	26494	13060	4	0	\N
366346	1678	26640830934000	26494	13060	5	0	\N
366347	1678	26640830935000	26494	13060	6	0	\N
366348	1678	26640830936000	26494	13060	7	0	\N
366349	1678	26640830937000	26494	13060	8	0	\N
366350	1678	26640830938000	26494	13060	9	0	\N
366351	1678	26640830939000	26494	13060	10	0	\N
366352	1678	26640830940000	26494	13060	11	0	\N
366353	1678	26640830941000	26494	13060	12	0	\N
366354	1678	26640830942000	26494	13060	13	0	\N
366355	1678	26640830943000	26494	13060	14	0	\N
366356	1678	26640830944000	26494	13060	15	0	\N
366357	1678	26640830945000	26494	13060	16	0	\N
366358	1678	26640830946000	26494	13060	17	0	\N
366359	1678	26640830947000	26494	13060	18	0	\N
366360	1678	26640830948000	26494	13060	19	0	\N
366361	1678	26640830949000	26494	13060	20	0	\N
366362	1678	26640830950000	26494	13060	21	0	\N
366363	1678	26640830951000	26494	13060	22	0	\N
366364	1678	26640830952000	26494	13060	23	0	\N
366365	1678	26640830953000	26494	13060	24	0	\N
366366	1678	26640830954000	26494	13060	25	0	\N
366367	1678	26640830955000	26494	13060	26	0	\N
366368	1678	26640830956000	26494	13060	27	0	\N
366369	1678	26640830957000	26494	13060	28	0	\N
366370	1678	26640830958000	26494	13060	29	0	\N
366371	1678	26640830959000	26494	13060	30	0	\N
366372	1678	26640830960000	26494	13060	31	0	\N
366373	1678	26640830961000	26494	13060	32	0	\N
366374	1678	26640830962000	26494	13060	33	0	\N
366375	1678	26640830963000	26494	13060	34	0	\N
366376	1678	26640830964000	26494	13060	35	0	\N
366377	1678	26640830965000	26494	13060	36	0	\N
366378	1678	26640830966000	26494	13060	37	0	\N
366379	1678	26640830967000	26494	13060	38	0	\N
366380	1678	26640830968000	26494	13060	39	0	\N
366381	1678	26640830969000	26494	13060	40	0	\N
366382	1678	26640830970000	26494	13060	41	0	\N
366383	1678	26640830971000	26494	13060	42	0	\N
366384	1678	26640830972000	26494	13060	43	0	\N
366251	1874	32047000	26473	13094	2	0	2
366252	1874	32050000	26473	13094	3	0	2
366253	1874	32052000	26473	13094	4	0	2
366254	1874	32055000	26473	13094	5	0	2
366255	1874	32056000	26473	13094	6	0	2
366257	2351	100000000	26474	13095	1	0	0
366258	1950	14848851000000	26474	13095	2	0	14
366259	1874	32059000	26474	13095	3	0	2
366260	2352	100000000	26474	13095	4	0	0
366261	1874	32061000	26474	13095	5	0	2
366275	1874	32064000	26477	13096	1	0	2
366276	2353	100000000	26477	13096	2	0	0
366277	1874	32066000	26477	13096	4	0	2
366278	1678	26640830972000	26478	13097	0	0	1
366280	1483	11000000	26478	13097	2	0	0
366281	1874	32071000	26478	13097	3	0	2
366286	1678	26640830973000	26480	13098	0	0	1
366287	1874	32072000	26480	13098	1	0	2
366288	1950	15158851000000	26480	13098	2	0	14
366290	1874	32077000	26480	13098	4	0	2
366305	1678	26640830974000	26485	13099	0	0	1
366306	1874	32079000	26485	13099	1	0	2
366307	1874	32082000	26485	13099	2	0	2
366308	1678	26640830975000	26486	13100	0	0	1
366310	1874	32087000	26486	13100	2	0	2
366311	1678	26640830976000	26487	13101	0	0	1
366312	1874	32089000	26487	13101	1	0	2
366313	1874	32090000	26487	13101	2	0	2
366315	1678	26640830977000	26488	13102	0	0	1
366316	1874	32095000	26488	13102	1	0	2
366317	1874	32098000	26488	13102	2	0	2
366325	1678	26640830978000	26490	13103	0	0	1
366326	1678	26640830979000	26490	13103	1	0	1
366328	1874	32102000	26490	13103	3	0	2
366329	1874	32105000	26490	13103	4	0	2
366330	1874	32107000	26490	13103	5	0	2
366331	1874	32109000	26490	13103	6	0	2
366332	1678	27360855980000	26491	13104	0	0	1
366334	1874	32114000	26491	13104	2	0	2
366335	1678	27360855981000	26492	13105	0	0	1
366336	1874	32117000	26492	13105	1	0	2
366337	1874	32119000	26492	13105	2	0	2
366385	1678	26640830973000	26494	13060	44	0	\N
366386	1678	26640830974000	26494	13060	45	0	\N
366387	1678	26640830975000	26494	13060	46	0	\N
366388	1678	26640830976000	26494	13060	47	0	\N
366389	1678	26640830977000	26494	13060	48	0	\N
366390	1678	26640830978000	26494	13060	49	0	\N
366391	1678	26640830979000	26494	13060	50	0	\N
366392	1678	26640830980000	26494	13060	51	0	\N
366393	1678	26640830981000	26494	13060	52	0	\N
366394	1678	26640830982000	26494	13060	53	0	\N
366395	1678	26640830983000	26494	13060	54	0	\N
366396	1874	31836000	26494	13060	55	0	\N
366397	1874	31839000	26494	13060	56	0	\N
366398	1874	31840000	26494	13060	57	0	\N
366399	1874	31841000	26494	13060	58	0	\N
366400	2349	100000000	26494	13060	59	0	\N
366401	2350	100000000	26494	13060	60	0	\N
366402	2351	100000000	26494	13060	61	0	\N
366403	2352	100000000	26494	13060	62	0	\N
366404	2353	100000000	26494	13060	63	0	\N
366405	1874	31843000	26494	13060	64	0	\N
366406	1874	31845000	26494	13060	65	0	\N
366407	1874	31847000	26494	13060	66	0	\N
366408	1874	31849000	26494	13060	67	0	\N
366409	3	145418010000000	26494	13060	68	0	\N
366410	1874	31852000	26494	13060	69	0	\N
366411	1874	31853000	26494	13060	70	0	\N
366412	1874	31854000	26494	13060	71	0	\N
366413	1874	31855000	26494	13060	72	0	\N
366414	1874	31856000	26494	13060	73	0	\N
366415	1874	31857000	26494	13060	74	0	\N
366416	1874	31858000	26494	13060	75	0	\N
366417	1874	31859000	26494	13060	76	0	\N
366418	1874	31860000	26494	13060	77	0	\N
366419	1874	31861000	26494	13060	78	0	\N
366420	1874	31862000	26494	13060	79	0	\N
366421	1874	31863000	26494	13060	80	0	\N
366422	1874	31864000	26494	13060	81	0	\N
366423	1874	31865000	26494	13060	82	0	\N
366424	1874	31866000	26494	13060	83	0	\N
366425	1874	31867000	26494	13060	84	0	\N
366426	1874	31870000	26494	13060	85	0	\N
366427	1874	31873000	26494	13060	86	0	\N
366428	1874	31876000	26494	13060	87	0	\N
366429	1874	31879000	26494	13060	88	0	\N
366430	1874	31882000	26494	13060	89	0	\N
366431	1874	31885000	26494	13060	90	0	\N
366432	1874	31888000	26494	13060	91	0	\N
366433	1874	31891000	26494	13060	92	0	\N
366434	1874	31894000	26494	13060	93	0	\N
366435	1874	31897000	26494	13060	94	0	\N
366436	1874	31900000	26494	13060	95	0	\N
366437	1874	31903000	26494	13060	97	0	\N
366438	1874	31906000	26494	13060	98	0	\N
366439	1874	31909000	26494	13060	99	0	\N
366440	1874	31912000	26494	13060	100	0	\N
366441	1874	31915000	26494	13060	101	0	\N
366442	1874	31918000	26494	13060	102	0	\N
366443	1874	31921000	26494	13060	103	0	\N
366444	1874	31924000	26494	13060	104	0	\N
366445	1874	31927000	26494	13060	105	0	\N
366446	1874	31930000	26494	13060	106	0	\N
366447	1874	31933000	26494	13060	107	0	\N
366448	1874	31936000	26494	13060	108	0	\N
366449	1874	31939000	26494	13060	109	0	\N
366450	1874	31942000	26494	13060	110	0	\N
366451	1874	31945000	26494	13060	111	0	\N
366452	1874	31948000	26494	13060	112	0	\N
366453	1874	31951000	26494	13060	113	0	\N
366454	1874	31954000	26494	13060	114	0	\N
366455	1874	31957000	26494	13060	115	0	\N
366456	1874	31960000	26494	13060	116	0	\N
366457	1874	31963000	26494	13060	117	0	\N
366458	1874	31966000	26494	13060	118	0	\N
366459	1874	31969000	26494	13060	119	0	\N
366460	1874	31972000	26494	13060	120	0	\N
366461	1874	31975000	26494	13060	121	0	\N
366462	1874	31978000	26494	13060	122	0	\N
366463	1874	31981000	26494	13060	123	0	\N
366464	1874	31984000	26494	13060	124	0	\N
366465	1874	31987000	26494	13060	125	0	\N
366476	1678	27360855985000	26496	13107	0	0	\N
366477	1874	32137000	26496	13107	1	0	\N
366478	1874	32140000	26496	13107	2	0	\N
366482	1874	32138000	26498	13107	0	0	\N
366500	1678	27360855989000	26502	13110	0	0	\N
366501	1678	27360855990000	26502	13110	1	0	\N
366502	1874	32157000	26502	13110	2	0	\N
366503	1874	32160000	26502	13110	3	0	\N
366504	1874	32163000	26502	13110	4	0	\N
366505	1874	32165000	26502	13110	5	0	\N
366506	1874	32167000	26502	13110	6	0	\N
366510	1678	27360855992000	26504	13112	0	0	\N
366511	1874	32174000	26504	13112	1	0	\N
366512	1874	32177000	26504	13112	2	0	\N
366468	1678	27360855984000	26495	13106	2	0	1
366469	1874	32120000	26495	13106	3	0	2
366470	1874	32123000	26495	13106	4	0	2
366471	1874	32126000	26495	13106	5	0	2
366472	1874	32129000	26495	13106	6	0	2
366474	1874	32133000	26495	13106	8	0	2
366475	1874	32135000	26495	13106	9	0	2
366479	1678	27360855985000	26497	13107	0	0	1
366480	1874	32137000	26497	13107	1	0	2
366481	1874	32140000	26497	13107	2	0	2
366484	1678	27360855987000	26499	13108	1	0	1
366485	1874	32143000	26499	13108	2	0	2
366486	1874	32146000	26499	13108	3	0	2
366487	1874	32148000	26499	13108	4	0	2
366489	1874	32151000	26499	13108	6	0	2
366490	1678	27360855988000	26500	13109	0	0	1
366491	1874	32154000	26500	13109	1	0	2
366492	1874	32156000	26500	13109	2	0	2
366493	1678	27360855989000	26501	13110	0	0	1
366495	1874	32157000	26501	13110	2	0	2
366496	1874	32160000	26501	13110	3	0	2
366497	1874	32163000	26501	13110	4	0	2
366498	1874	32165000	26501	13110	5	0	2
366499	1874	32167000	26501	13110	6	0	2
366508	1874	32170000	26503	13111	1	0	2
366509	1874	32172000	26503	13111	2	0	2
366513	1678	27360855992000	26505	13112	0	0	1
366514	1874	32174000	26505	13112	1	0	2
366516	1678	27360855993000	26506	13113	0	0	1
366517	1874	32178000	26506	13113	1	0	2
366518	1874	32180000	26506	13113	2	0	2
366519	1874	32183000	26506	13113	3	0	2
366520	1678	27360855994000	26507	13114	0	0	1
366526	1678	26640830984000	26509	13061	0	0	\N
366527	1678	26640830985000	26509	13061	1	0	\N
366528	1678	26640830986000	26509	13061	2	0	\N
366529	1678	26640830987000	26509	13061	3	0	\N
366530	1678	26640830988000	26509	13061	4	0	\N
366531	1678	26640830989000	26509	13061	5	0	\N
366532	1678	26640830990000	26509	13061	6	0	\N
366533	1678	26640830991000	26509	13061	7	0	\N
366534	1678	26640830992000	26509	13061	8	0	\N
366535	1678	26640830993000	26509	13061	9	0	\N
366536	1678	26640830994000	26509	13061	10	0	\N
366537	1678	26640830995000	26509	13061	11	0	\N
366538	1874	31990000	26509	13061	12	0	\N
366539	1874	31993000	26509	13061	13	0	\N
366540	1874	31996000	26509	13061	14	0	\N
366541	1874	31999000	26509	13061	15	0	\N
366542	1874	32002000	26509	13061	16	0	\N
366543	1874	32003000	26509	13061	17	0	\N
366544	1874	32004000	26509	13061	18	0	\N
366545	1874	32005000	26509	13061	19	0	\N
366546	1874	32008000	26509	13061	20	0	\N
366547	1874	32011000	26509	13061	21	0	\N
366548	1874	32014000	26509	13061	22	0	\N
366549	1874	32017000	26509	13061	23	0	\N
366550	1874	32020000	26509	13061	24	0	\N
366551	1874	32023000	26509	13061	25	0	\N
366552	1874	32026000	26509	13061	26	0	\N
366553	1874	32029000	26509	13061	27	0	\N
366554	1874	32032000	26509	13061	28	0	\N
366555	1874	32035000	26509	13061	29	0	\N
366556	1874	32038000	26509	13061	30	0	\N
366557	1874	32041000	26509	13061	31	0	\N
366558	1874	32044000	26509	13061	32	0	\N
366559	1874	32047000	26509	13061	33	0	\N
366560	1874	32050000	26509	13061	34	0	\N
366561	1874	32053000	26509	13061	35	0	\N
366562	1874	32056000	26509	13061	36	0	\N
366563	1874	32059000	26509	13061	37	0	\N
366564	1874	32062000	26509	13061	38	0	\N
366565	1874	32065000	26509	13061	39	0	\N
366566	1874	32067000	26509	13061	40	0	\N
366567	1874	32069000	26509	13061	41	0	\N
366568	1874	32071000	26509	13061	42	0	\N
366569	1874	32073000	26509	13061	43	0	\N
366570	1874	32075000	26509	13061	44	0	\N
366571	1874	32077000	26509	13061	45	0	\N
366572	1874	32079000	26509	13061	46	0	\N
366573	1874	32081000	26509	13061	47	0	\N
366574	1874	32083000	26509	13061	48	0	\N
366575	1874	32085000	26509	13061	49	0	\N
366576	1874	32087000	26509	13061	50	0	\N
366577	1874	32089000	26509	13061	51	0	\N
366578	1874	32091000	26509	13061	52	0	\N
366579	1874	32093000	26509	13061	53	0	\N
366580	1874	32095000	26509	13061	54	0	\N
366581	1874	32097000	26509	13061	55	0	\N
366582	1874	32099000	26509	13061	56	0	\N
366583	1874	32101000	26509	13061	57	0	\N
366584	1874	32103000	26509	13061	58	0	\N
366585	1874	32105000	26509	13061	59	0	\N
366586	1874	32107000	26509	13061	60	0	\N
366587	1874	32109000	26509	13061	61	0	\N
366588	1874	32111000	26509	13061	62	0	\N
366589	1874	32113000	26509	13061	63	0	\N
366590	1874	32115000	26509	13061	64	0	\N
366591	1874	32117000	26509	13061	65	0	\N
366592	1874	32119000	26509	13061	66	0	\N
366593	1874	32121000	26509	13061	67	0	\N
366594	1874	32123000	26509	13061	68	0	\N
366595	1874	32125000	26509	13061	69	0	\N
366596	1874	32127000	26509	13061	70	0	\N
366597	1874	32129000	26509	13061	71	0	\N
366598	1874	32131000	26509	13061	72	0	\N
366599	1874	32133000	26509	13061	73	0	\N
366600	1874	32135000	26509	13061	74	0	\N
366601	1874	32137000	26509	13061	75	0	\N
366602	1874	32139000	26509	13061	76	0	\N
366603	1874	32141000	26509	13061	77	0	\N
366604	1874	32143000	26509	13061	78	0	\N
366605	1874	32145000	26509	13061	79	0	\N
366606	1874	32147000	26509	13061	80	0	\N
366607	1874	32149000	26509	13061	81	0	\N
366608	1874	32151000	26509	13061	82	0	\N
366609	1874	32153000	26509	13061	83	0	\N
366610	1874	32155000	26509	13061	84	0	\N
366611	1874	32157000	26509	13061	85	0	\N
366612	1874	32159000	26509	13061	86	0	\N
366613	1874	32161000	26509	13061	87	0	\N
366614	1874	32163000	26509	13061	88	0	\N
366615	1874	32165000	26509	13061	89	0	\N
366616	1874	32167000	26509	13061	90	0	\N
366617	1874	32169000	26509	13061	91	0	\N
366618	1874	32171000	26509	13061	92	0	\N
366619	1874	32173000	26509	13061	93	0	\N
366620	1874	32175000	26509	13061	94	0	\N
366621	1874	32177000	26509	13061	95	0	\N
366622	1874	32179000	26509	13061	97	0	\N
366623	1874	32181000	26509	13061	98	0	\N
366624	1874	32183000	26509	13061	99	0	\N
366625	1874	32185000	26509	13061	100	0	\N
366626	1874	32187000	26509	13061	101	0	\N
366627	1874	32189000	26509	13061	102	0	\N
366628	1874	32191000	26509	13061	103	0	\N
366629	1874	32193000	26509	13061	104	0	\N
366630	1678	27360855996000	26510	13116	0	0	\N
366631	1678	27360855997000	26510	13116	1	0	\N
366632	1678	27360855998000	26510	13116	2	0	\N
366633	1874	32196000	26510	13116	3	0	\N
366634	1874	32198000	26510	13116	4	0	\N
366635	1874	32200000	26510	13116	6	0	\N
366636	1874	32201000	26510	13116	7	0	\N
366637	1874	32204000	26510	13116	8	0	\N
366638	1874	32207000	26510	13116	9	0	\N
366639	1874	32209000	26510	13116	10	0	\N
366650	1678	27360855999000	26512	13117	0	0	\N
366651	1874	32211000	26512	13117	1	0	\N
366652	1874	32212000	26512	13117	2	0	\N
366653	1874	32215000	26512	13117	3	0	\N
366523	1678	27360855995000	26508	13115	0	0	1
366524	1874	32190000	26508	13115	1	0	2
366525	1874	32193000	26508	13115	2	0	2
366640	1678	27360855996000	26511	13116	0	0	1
366641	1678	27360855997000	26511	13116	1	0	1
366643	1874	32196000	26511	13116	3	0	2
366644	1874	32198000	26511	13116	4	0	2
366645	1874	32200000	26511	13116	6	0	2
366646	1874	32201000	26511	13116	7	0	2
366647	1874	32204000	26511	13116	8	0	2
366649	1874	32209000	26511	13116	10	0	2
366654	1678	27360855999000	26513	13117	0	0	1
366655	1678	27360856000000	26513	13117	1	0	1
366656	1874	32211000	26513	13117	2	0	2
366664	1678	27360856001000	26515	13118	0	0	\N
366665	1874	32223000	26515	13118	1	0	\N
366666	1874	32225000	26515	13118	2	0	\N
366667	1678	27360856002000	26516	13119	0	0	\N
366668	1874	32228000	26516	13119	1	0	\N
366669	1874	32230000	26516	13119	2	0	\N
366670	1678	27360856002000	26517	13119	0	0	\N
366671	1874	32228000	26517	13119	1	0	\N
366672	1874	32230000	26517	13119	2	0	\N
366683	1678	27360856004000	26521	13121	0	0	\N
366684	1874	32238000	26521	13121	1	0	\N
366685	1678	27360856004000	26522	13121	0	0	\N
366686	1874	32239000	26522	13121	1	0	\N
366687	1874	32241000	26522	13121	2	0	\N
366688	1678	27360856004000	26523	13121	0	0	\N
366689	1874	32239000	26523	13121	1	0	\N
366690	1874	32241000	26523	13121	2	0	\N
366691	1678	27360856004000	26524	13121	0	0	\N
366692	1874	32239000	26524	13121	1	0	\N
366693	1874	32241000	26524	13121	2	0	\N
366694	1678	27360856004000	26525	13121	0	0	\N
366695	1874	32239000	26525	13121	1	0	\N
366696	1874	32241000	26525	13121	2	0	\N
366707	1678	27360856007000	26529	13124	0	0	\N
366708	1874	32255000	26529	13124	1	0	\N
366709	1874	32257000	26529	13124	2	0	\N
366726	1678	27360856010000	26534	13127	0	0	\N
366727	1678	27360856011000	26534	13127	1	0	\N
366728	1678	27360856012000	26534	13127	2	0	\N
366729	1874	32271000	26534	13127	3	0	\N
366730	1874	32274000	26534	13127	4	0	\N
366731	1874	32277000	26534	13127	5	0	\N
366732	1874	32279000	26534	13127	6	0	\N
366733	1874	32281000	26534	13127	7	0	\N
366734	1874	32283000	26534	13127	8	0	\N
366735	1678	27360856010000	26535	13127	0	0	\N
366736	1678	27360856011000	26535	13127	1	0	\N
366737	1678	27360856012000	26535	13127	2	0	\N
366738	1874	32271000	26535	13127	3	0	\N
366739	1874	32274000	26535	13127	4	0	\N
366740	1874	32277000	26535	13127	5	0	\N
366741	1874	32279000	26535	13127	6	0	\N
366742	1874	32281000	26535	13127	7	0	\N
366743	1874	32283000	26535	13127	8	0	\N
366744	1678	27360856010000	26536	13127	0	0	\N
366745	1678	27360856011000	26536	13127	1	0	\N
366746	1678	27360856012000	26536	13127	2	0	\N
366747	1874	32271000	26536	13127	3	0	\N
366748	1874	32274000	26536	13127	4	0	\N
366749	1874	32277000	26536	13127	5	0	\N
366750	1874	32279000	26536	13127	6	0	\N
366751	1874	32281000	26536	13127	7	0	\N
366752	1874	32283000	26536	13127	8	0	\N
366753	1678	27360856013000	26537	13128	0	0	\N
366754	1678	27360856014000	26537	13128	1	0	\N
366755	1874	32284000	26537	13128	2	0	\N
366756	1874	32287000	26537	13128	3	0	\N
366757	1874	32290000	26537	13128	4	0	\N
366775	1678	27360856018000	26541	13131	0	0	\N
366776	1678	27360856019000	26541	13131	1	0	\N
366777	1874	32312000	26541	13131	2	0	\N
366778	1874	32315000	26541	13131	3	0	\N
366779	1874	32317000	26541	13131	4	0	\N
366780	1874	32320000	26541	13131	5	0	\N
366781	1874	32321000	26541	13131	6	0	\N
366789	1874	32324000	26543	13132	0	0	\N
366790	1874	32326000	26543	13132	1	0	\N
366659	1874	32217000	26513	13117	5	0	2
366660	1874	32220000	26513	13117	6	0	2
366661	1678	27360856001000	26514	13118	0	0	1
366662	1874	32223000	26514	13118	1	0	2
366663	1874	32225000	26514	13118	2	0	2
366674	1874	32228000	26518	13119	1	0	2
366675	1874	32230000	26518	13119	2	0	2
366676	1678	27360856003000	26519	13120	0	0	1
366677	1874	32232000	26519	13120	1	0	2
366678	1874	32233000	26519	13120	2	0	2
366680	1678	27360856004000	26520	13121	0	0	1
366681	1874	32239000	26520	13121	1	0	2
366682	1874	32241000	26520	13121	2	0	2
366697	1678	27360856005000	26526	13122	0	0	1
366699	1874	32246000	26526	13122	2	0	2
366700	1678	27360856006000	26527	13123	0	0	1
366701	1874	32247000	26527	13123	1	0	2
366702	1874	32249000	26527	13123	2	0	2
366703	1874	32252000	26527	13123	3	0	2
366705	1874	32255000	26528	13124	1	0	2
366706	1874	32257000	26528	13124	2	0	2
366710	1678	27360856008000	26530	13125	0	0	1
366711	1874	32259000	26530	13125	1	0	2
366712	1874	32262000	26530	13125	2	0	2
366714	1874	32264000	26531	13126	1	0	2
366715	1874	32267000	26531	13126	2	0	2
366716	1874	32268000	26531	13126	3	0	2
366717	1678	27360856010000	26533	13127	0	0	1
366719	1678	27360856012000	26533	13127	2	0	1
366720	1874	32271000	26533	13127	3	0	2
366721	1874	32274000	26533	13127	4	0	2
366722	1874	32277000	26533	13127	5	0	2
366723	1874	32279000	26533	13127	6	0	2
366725	1874	32283000	26533	13127	8	0	2
366758	1678	27360856013000	26538	13128	0	0	1
366759	1678	27360856014000	26538	13128	1	0	1
366760	1874	32284000	26538	13128	2	0	2
366761	1874	32286000	26538	13128	3	0	2
366763	1874	32291000	26538	13128	5	0	2
366764	1874	32294000	26538	13128	6	0	2
366765	1678	27360856015000	26539	13129	0	0	1
366766	1874	32296000	26539	13129	1	0	2
366768	1678	27360856016000	26540	13130	0	0	1
366769	1678	27360856017000	26540	13130	1	0	1
366770	1874	32302000	26540	13130	2	0	2
366771	1874	32305000	26540	13130	3	0	2
366772	1874	32307000	26540	13130	5	0	2
366774	1874	32310000	26540	13130	8	0	2
366782	1678	27360856018000	26542	13131	0	0	1
366783	1678	27360856019000	26542	13131	1	0	1
366784	1874	32312000	26542	13131	2	0	2
366785	1874	32315000	26542	13131	3	0	2
366787	1874	32320000	26542	13131	5	0	2
366788	1874	32321000	26542	13131	6	0	2
366791	1874	32324000	26544	13132	0	0	2
366792	1874	32326000	26544	13132	1	0	2
366793	1874	32324000	26545	13132	0	0	\N
366794	1874	32326000	26545	13132	1	0	\N
366808	1678	27360856023000	26548	13134	0	0	\N
366809	1874	32345000	26548	13134	2	0	\N
366810	1874	32347000	26548	13134	3	0	\N
366817	1678	27360856026000	26551	13137	0	0	\N
366818	1874	32358000	26551	13137	1	0	\N
366819	1874	32360000	26551	13137	2	0	\N
366836	1678	27360856031000	26555	13140	0	0	\N
366837	1874	32383000	26555	13140	1	0	\N
366838	1874	32386000	26555	13140	2	0	\N
366842	1678	27360856031000	26557	13140	0	0	\N
366843	1874	32383000	26557	13140	1	0	\N
366844	1874	32386000	26557	13140	2	0	\N
366849	1678	27360856032000	26559	13141	0	0	\N
366850	1874	32387000	26559	13141	1	0	\N
366851	1874	32390000	26559	13141	2	0	\N
366852	1874	32392000	26559	13141	3	0	\N
366853	1678	27360856032000	26560	13141	0	0	\N
366854	1874	32387000	26560	13141	1	0	\N
366855	1874	32390000	26560	13141	2	0	\N
366856	1874	32392000	26560	13141	3	0	\N
366863	1678	27360856034000	26563	13143	0	0	\N
366864	1874	32400000	26563	13143	1	0	\N
366865	1874	32402000	26563	13143	2	0	\N
366866	1678	26640830958000	26564	13069	0	0	\N
366867	1678	26640830959000	26564	13069	1	0	\N
366868	1678	26640830960000	26564	13069	2	0	\N
366869	1678	26640830961000	26564	13069	3	0	\N
366870	1678	26640830962000	26564	13069	4	0	\N
366871	1678	26640830963000	26564	13069	5	0	\N
366872	1678	26640830964000	26564	13069	6	0	\N
366873	1678	26640830965000	26564	13069	7	0	\N
366874	1678	26640830966000	26564	13069	8	0	\N
366875	1678	26640830967000	26564	13069	9	0	\N
366876	1678	26640830968000	26564	13069	10	0	\N
366877	1678	26640830969000	26564	13069	11	0	\N
366878	1678	26640830970000	26564	13069	12	0	\N
366879	1678	26640830971000	26564	13069	13	0	\N
366880	1678	26640830972000	26564	13069	14	0	\N
366881	1678	26640830973000	26564	13069	15	0	\N
366882	1678	26640830974000	26564	13069	16	0	\N
366883	1678	26640830975000	26564	13069	17	0	\N
366884	1678	26640830976000	26564	13069	18	0	\N
366885	1678	26640830977000	26564	13069	19	0	\N
366886	1678	26640830978000	26564	13069	20	0	\N
366887	1678	26640830979000	26564	13069	21	0	\N
366888	1678	26640830980000	26564	13069	22	0	\N
366889	1678	26640830981000	26564	13069	23	0	\N
366890	1678	26640830982000	26564	13069	24	0	\N
366891	1678	26640830983000	26564	13069	25	0	\N
366892	1678	26640830984000	26564	13069	26	0	\N
366893	1678	26640830985000	26564	13069	27	0	\N
366894	1678	26640830986000	26564	13069	28	0	\N
366895	1678	26640830987000	26564	13069	29	0	\N
366896	1678	26640830988000	26564	13069	30	0	\N
366897	1678	26640830989000	26564	13069	31	0	\N
366898	1678	26640830990000	26564	13069	32	0	\N
366899	1678	26640830991000	26564	13069	33	0	\N
366900	1678	26640830992000	26564	13069	34	0	\N
366901	1678	26640830993000	26564	13069	35	0	\N
366902	1678	26640830994000	26564	13069	36	0	\N
366903	1678	26640830995000	26564	13069	37	0	\N
366904	1678	26640830996000	26564	13069	38	0	\N
366905	1678	26640830997000	26564	13069	39	0	\N
366906	1678	26640830998000	26564	13069	40	0	\N
366907	1678	26640830999000	26564	13069	41	0	\N
366908	1678	26640831000000	26564	13069	42	0	\N
366909	1678	26640831001000	26564	13069	43	0	\N
366910	1678	26640831002000	26564	13069	44	0	\N
366911	1678	26640831003000	26564	13069	45	0	\N
366912	1678	26640831004000	26564	13069	46	0	\N
366913	1678	26640831005000	26564	13069	47	0	\N
366914	1678	26640831006000	26564	13069	48	0	\N
366915	1678	26640831007000	26564	13069	49	0	\N
366916	1678	26640831008000	26564	13069	50	0	\N
366917	1678	26640831009000	26564	13069	51	0	\N
366918	1678	26640831010000	26564	13069	52	0	\N
366919	1678	26640831011000	26564	13069	53	0	\N
366920	1678	26640831012000	26564	13069	54	0	\N
366921	1678	26640831013000	26564	13069	55	0	\N
366922	1678	26640831014000	26564	13069	56	0	\N
366923	1678	26640831015000	26564	13069	57	0	\N
366924	1678	26640831016000	26564	13069	58	0	\N
366925	1678	26640831017000	26564	13069	59	0	\N
366926	1678	26640831018000	26564	13069	60	0	\N
366927	1678	26640831019000	26564	13069	61	0	\N
366928	1678	26640831020000	26564	13069	62	0	\N
366797	1678	27360856022000	26546	13133	2	0	1
366798	1874	32328000	26546	13133	3	0	2
366799	1874	32329000	26546	13133	4	0	2
366800	1874	32332000	26546	13133	5	0	2
366801	1874	32335000	26546	13133	6	0	2
366803	1874	32340000	26546	13133	8	0	2
366804	1874	32342000	26546	13133	9	0	2
366805	1678	27360856023000	26547	13134	0	0	1
366806	1874	32345000	26547	13134	2	0	2
366807	1874	32347000	26547	13134	3	0	2
366812	1874	32349000	26549	13135	1	0	2
366813	1678	27360856025000	26550	13136	0	0	1
366814	1874	32350000	26550	13136	1	0	2
366815	1874	32353000	26550	13136	2	0	2
366820	1678	27360856026000	26552	13137	0	0	1
366821	1874	32358000	26552	13137	1	0	2
366822	1874	32360000	26552	13137	2	0	2
366823	1678	27360856027000	26553	13138	0	0	1
366824	1678	27360856028000	26553	13138	1	0	1
366826	1874	32365000	26553	13138	3	0	2
366827	1874	32368000	26553	13138	4	0	2
366828	1874	32370000	26553	13138	5	0	2
366829	1874	32371000	26553	13138	6	0	2
366830	1678	27360856029000	26554	13139	0	0	1
366832	1874	32374000	26554	13139	2	0	2
366833	1874	32377000	26554	13139	3	0	2
366834	1874	32379000	26554	13139	4	0	2
366835	1874	32381000	26554	13139	5	0	2
366840	1874	32383000	26556	13140	1	0	2
366841	1874	32386000	26556	13140	2	0	2
366845	1678	27360856032000	26558	13141	0	0	1
366846	1874	32387000	26558	13141	1	0	2
366847	1874	32390000	26558	13141	2	0	2
366857	1678	27360856033000	26561	13142	0	0	1
366858	1874	32395000	26561	13142	1	0	2
366859	1874	32397000	26561	13142	2	0	2
366860	1678	27360856034000	26562	13143	0	0	1
366861	1874	32400000	26562	13143	1	0	2
366929	1678	26640831021000	26564	13069	63	0	\N
366930	1678	26640831022000	26564	13069	64	0	\N
366931	1678	26640831023000	26564	13069	65	0	\N
366932	1678	26640831024000	26564	13069	66	0	\N
366933	1678	26640831025000	26564	13069	67	0	\N
366934	1678	26640831026000	26564	13069	68	0	\N
366935	1678	26640831027000	26564	13069	69	0	\N
366936	1678	26640831028000	26564	13069	70	0	\N
366937	1678	26640831029000	26564	13069	71	0	\N
366938	1678	26640831030000	26564	13069	72	0	\N
366939	1678	26640831031000	26564	13069	73	0	\N
366940	1678	26640831032000	26564	13069	74	0	\N
366941	1678	26640831033000	26564	13069	75	0	\N
366942	2351	100000000	26564	13069	76	0	\N
366943	2352	100000000	26564	13069	77	0	\N
366944	2353	100000000	26564	13069	78	0	\N
366945	1874	31989000	26564	13069	79	0	\N
366946	1874	31991000	26564	13069	80	0	\N
366947	1874	31993000	26564	13069	81	0	\N
366948	1874	31995000	26564	13069	82	0	\N
366949	1874	31996000	26564	13069	83	0	\N
366950	1874	31997000	26564	13069	84	0	\N
366951	1874	31998000	26564	13069	85	0	\N
366952	1874	31999000	26564	13069	86	0	\N
366953	1874	32000000	26564	13069	87	0	\N
366954	1874	32001000	26564	13069	88	0	\N
366955	1874	32002000	26564	13069	89	0	\N
366956	1874	32003000	26564	13069	90	0	\N
366957	1874	32004000	26564	13069	91	0	\N
366958	1874	32005000	26564	13069	92	0	\N
366959	1874	32006000	26564	13069	93	0	\N
366960	1874	32007000	26564	13069	94	0	\N
366961	1874	32008000	26564	13069	95	0	\N
366962	1874	32009000	26564	13069	96	0	\N
366963	1874	32010000	26564	13069	97	0	\N
366964	1874	32011000	26564	13069	98	0	\N
366965	1874	32012000	26564	13069	99	0	\N
366966	1874	32013000	26564	13069	100	0	\N
366967	1874	32015000	26564	13069	101	0	\N
366968	1874	32017000	26564	13069	102	0	\N
366969	1874	32019000	26564	13069	103	0	\N
366970	1874	32021000	26564	13069	104	0	\N
366971	1874	32023000	26564	13069	105	0	\N
366972	1874	32025000	26564	13069	107	0	\N
366973	1874	32027000	26564	13069	108	0	\N
366974	1874	32029000	26564	13069	109	0	\N
366975	1874	32031000	26564	13069	110	0	\N
366976	1874	32033000	26564	13069	111	0	\N
366977	1874	32035000	26564	13069	112	0	\N
366978	1874	32037000	26564	13069	113	0	\N
366979	1874	32039000	26564	13069	114	0	\N
366980	1874	32041000	26564	13069	115	0	\N
366981	1874	32043000	26564	13069	116	0	\N
366982	1874	32045000	26564	13069	117	0	\N
366983	1874	32047000	26564	13069	118	0	\N
366984	1874	32049000	26564	13069	119	0	\N
366985	1874	32051000	26564	13069	120	0	\N
366986	1874	32053000	26564	13069	121	0	\N
366987	1874	32055000	26564	13069	122	0	\N
366988	1874	32057000	26564	13069	123	0	\N
366989	1874	32059000	26564	13069	124	0	\N
366990	1874	32061000	26564	13069	125	0	\N
367001	1678	27360856037000	26568	13146	0	0	\N
367002	1874	32416000	26568	13146	1	0	\N
367003	1874	32418000	26568	13146	2	0	\N
367004	1678	27360856037000	26569	13146	0	0	\N
367005	1874	32416000	26569	13146	1	0	\N
367006	1874	32418000	26569	13146	2	0	\N
367007	1678	27360856038000	26570	13147	0	0	\N
367008	1678	27360856039000	26570	13147	1	0	\N
367009	1874	32419000	26570	13147	2	0	\N
367010	1874	32422000	26570	13147	3	0	\N
367011	1874	32424000	26570	13147	4	0	\N
367012	1874	32426000	26570	13147	5	0	\N
367013	1874	32429000	26570	13147	6	0	\N
367021	1678	27360856040000	26572	13148	0	0	\N
367022	2346	190000000	26572	13148	1	0	\N
367023	1874	32431000	26572	13148	2	0	\N
367024	1874	32434000	26572	13148	3	0	\N
367044	1678	27360856042000	26577	13150	0	0	\N
367045	1678	27360856043000	26577	13150	1	0	\N
367046	1678	27360856044000	26577	13150	2	0	\N
367047	2346	289000000	26577	13150	3	0	\N
367048	2346	388000000	26577	13150	4	0	\N
367049	1874	32442000	26577	13150	5	0	\N
367050	1874	32445000	26577	13150	6	0	\N
367051	1874	32448000	26577	13150	7	0	\N
367052	1874	32449000	26577	13150	8	0	\N
367053	1874	32451000	26577	13150	9	0	\N
367054	1874	32453000	26577	13150	10	0	\N
367055	1874	32455000	26577	13150	11	0	\N
366993	1874	32405000	26565	13144	2	0	2
366994	1678	27360856036000	26566	13145	0	0	1
366995	1874	32408000	26566	13145	1	0	2
366996	1874	32410000	26566	13145	2	0	2
366997	1874	32413000	26566	13145	3	0	2
366999	1874	32416000	26567	13146	1	0	2
367000	1874	32418000	26567	13146	2	0	2
367014	1678	27360856038000	26571	13147	0	0	1
367015	1678	27360856039000	26571	13147	1	0	1
367016	1874	32419000	26571	13147	2	0	2
367018	1874	32424000	26571	13147	4	0	2
367019	1874	32426000	26571	13147	5	0	2
367020	1874	32429000	26571	13147	6	0	2
367025	1678	27360856040000	26573	13148	0	0	1
367027	1874	32431000	26573	13148	2	0	2
367028	1874	32434000	26573	13148	3	0	2
367029	1678	27360856041000	26575	13149	0	0	1
367030	1874	32437000	26575	13149	1	0	2
367031	1874	32439000	26575	13149	2	0	2
367033	1678	27360856043000	26576	13150	1	0	1
367034	1678	27360856044000	26576	13150	2	0	1
367035	2346	289000000	26576	13150	3	0	0
367036	2346	388000000	26576	13150	4	0	0
367037	1874	32442000	26576	13150	5	0	2
367039	1874	32448000	26576	13150	7	0	2
367040	1874	32449000	26576	13150	8	0	2
367041	1874	32451000	26576	13150	9	0	2
367042	1874	32453000	26576	13150	10	0	2
367056	1678	27360856045000	26578	13151	0	0	1
367057	1874	32456000	26578	13151	1	0	2
367058	1874	32458000	26578	13151	2	0	2
367059	1874	32461000	26578	13151	3	0	2
367060	1678	27360856046000	26579	13152	0	0	1
367062	1874	32464000	26579	13152	2	0	2
367063	1874	32467000	26579	13152	3	0	2
367064	1874	32469000	26579	13152	4	0	2
367066	2346	190000000	26580	13078	0	0	\N
367067	2351	100000000	26580	13078	1	0	\N
367068	2346	289000000	26580	13078	2	0	\N
367069	2352	100000000	26580	13078	3	0	\N
367070	2353	100000000	26580	13078	4	0	\N
367071	2346	388000000	26580	13078	5	0	\N
367072	1678	27360856048000	26581	13153	0	0	\N
367073	1678	27360856049000	26581	13153	1	0	\N
367074	1874	32474000	26581	13153	2	0	\N
367075	1874	32475000	26581	13153	3	0	\N
367076	1874	32478000	26581	13153	4	0	\N
367077	1874	32480000	26581	13153	5	0	\N
367078	1874	32482000	26581	13153	7	0	\N
367079	1678	27360856048000	26582	13153	0	0	\N
367080	1678	27360856049000	26582	13153	1	0	\N
367081	1874	32474000	26582	13153	2	0	\N
367082	1874	32475000	26582	13153	3	0	\N
367083	1874	32478000	26582	13153	4	0	\N
367084	1874	32480000	26582	13153	5	0	\N
367085	1874	32482000	26582	13153	7	0	\N
367086	1678	27360856048000	26583	13153	0	0	\N
367087	1678	27360856049000	26583	13153	1	0	\N
367088	1874	32474000	26583	13153	2	0	\N
367089	1874	32475000	26583	13153	3	0	\N
367090	1874	32478000	26583	13153	4	0	\N
367091	1874	32480000	26583	13153	5	0	\N
367092	1874	32482000	26583	13153	7	0	\N
367100	1678	27360856048000	26585	13153	0	0	\N
367101	1678	27360856049000	26585	13153	1	0	\N
367102	1874	32474000	26585	13153	2	0	\N
367103	1874	32475000	26585	13153	3	0	\N
367104	1874	32478000	26585	13153	4	0	\N
367105	1874	32480000	26585	13153	5	0	\N
367106	1874	32482000	26585	13153	7	0	\N
367107	1678	27360856048000	26586	13153	0	0	\N
367108	1678	27360856049000	26586	13153	1	0	\N
367109	1874	32474000	26586	13153	2	0	\N
367110	1874	32475000	26586	13153	3	0	\N
367111	1874	32478000	26586	13153	4	0	\N
367112	1874	32480000	26586	13153	5	0	\N
367113	1874	32482000	26586	13153	7	0	\N
367114	1678	27360856050000	26587	13154	0	0	\N
367115	1678	27360856051000	26587	13154	1	0	\N
367116	1874	32484000	26587	13154	2	0	\N
367117	1874	32486000	26587	13154	3	0	\N
367118	1874	32489000	26587	13154	4	0	\N
367119	1874	32492000	26587	13154	5	0	\N
367126	1678	27360856050000	26589	13154	0	0	\N
367127	1678	27360856051000	26589	13154	1	0	\N
367128	1874	32484000	26589	13154	2	0	\N
367129	1874	32486000	26589	13154	3	0	\N
367130	1874	32489000	26589	13154	4	0	\N
367131	1874	32492000	26589	13154	5	0	\N
367146	1678	27360856056000	26593	13158	0	0	\N
367147	1678	27360856057000	26593	13158	1	0	\N
367148	1874	32517000	26593	13158	2	0	\N
367149	1874	32520000	26593	13158	3	0	\N
367150	1678	27360856056000	26594	13158	0	0	\N
367151	1678	27360856057000	26594	13158	1	0	\N
367152	1874	32516000	26594	13158	2	0	\N
367153	1874	32519000	26594	13158	3	0	\N
367154	1874	32522000	26594	13158	4	0	\N
367155	1874	32524000	26594	13158	5	0	\N
367162	1678	27360856056000	26596	13158	0	0	\N
367163	1678	27360856057000	26596	13158	1	0	\N
367164	1874	32516000	26596	13158	2	0	\N
367165	1874	32519000	26596	13158	3	0	\N
367166	1874	32522000	26596	13158	4	0	\N
367167	1874	32524000	26596	13158	5	0	\N
367168	1678	27360856056000	26597	13158	0	0	\N
367169	1678	27360856057000	26597	13158	1	0	\N
367170	1874	32516000	26597	13158	2	0	\N
367171	1874	32519000	26597	13158	3	0	\N
367172	1874	32522000	26597	13158	4	0	\N
367173	1874	32524000	26597	13158	5	0	\N
367174	1678	27360856056000	26598	13158	0	0	\N
367175	1678	27360856057000	26598	13158	1	0	\N
367176	1874	32516000	26598	13158	2	0	\N
367177	1874	32519000	26598	13158	3	0	\N
367178	1874	32522000	26598	13158	4	0	\N
367179	1874	32524000	26598	13158	5	0	\N
367184	1678	27360856058000	26600	13159	0	0	\N
367185	1874	32527000	26600	13159	1	0	\N
367186	1874	32528000	26600	13159	2	0	\N
367187	1874	32530000	26600	13159	3	0	\N
367193	1678	27360856059000	26602	13160	0	0	\N
367194	1874	32532000	26602	13160	1	0	\N
367195	1874	32534000	26602	13160	2	0	\N
367196	1874	32537000	26602	13160	3	0	\N
367197	1874	32540000	26602	13160	4	0	\N
367094	1678	27360856049000	26584	13153	1	0	1
367095	1874	32474000	26584	13153	2	0	2
367096	1874	32475000	26584	13153	3	0	2
367097	1874	32478000	26584	13153	4	0	2
367098	1874	32480000	26584	13153	5	0	2
367120	1678	27360856050000	26588	13154	0	0	1
367121	1678	27360856051000	26588	13154	1	0	1
367122	1874	32484000	26588	13154	2	0	2
367123	1874	32486000	26588	13154	3	0	2
367124	1874	32489000	26588	13154	4	0	2
367132	1678	27360856052000	26590	13155	0	0	1
367133	1874	32494000	26590	13155	1	0	2
367134	1874	32495000	26590	13155	2	0	2
367135	1874	32498000	26590	13155	3	0	2
367137	1678	27360856054000	26591	13156	1	0	1
367138	1874	32500000	26591	13156	2	0	2
367139	1874	32502000	26591	13156	3	0	2
367140	1874	32505000	26591	13156	4	0	2
367141	1874	32508000	26591	13156	5	0	2
367143	1874	32511000	26592	13157	1	0	2
367144	1874	32512000	26592	13157	2	0	2
367145	1874	32514000	26592	13157	3	0	2
367156	1678	27360856056000	26595	13158	0	0	1
367157	1678	27360856057000	26595	13158	1	0	1
367159	1874	32519000	26595	13158	3	0	2
367160	1874	32522000	26595	13158	4	0	2
367161	1874	32524000	26595	13158	5	0	2
367180	1678	27360856058000	26599	13159	0	0	1
367182	1874	32528000	26599	13159	2	0	2
367183	1874	32530000	26599	13159	3	0	2
367188	1678	27360856059000	26601	13160	0	0	1
367189	1874	32532000	26601	13160	1	0	2
367190	1874	32534000	26601	13160	2	0	2
367192	1874	32540000	26601	13160	4	0	2
367198	1678	27360856060000	26603	13161	0	0	1
367199	1874	32543000	26603	13161	1	0	2
367200	1874	32545000	26603	13161	2	0	2
367211	1678	27360856064000	26605	13163	0	0	\N
367212	1874	32563000	26605	13163	1	0	\N
367213	1874	32564000	26605	13163	2	0	\N
367214	1874	32567000	26605	13163	3	0	\N
367221	1678	27360856066000	26608	13165	0	0	\N
367222	1874	32572000	26608	13165	1	0	\N
367223	1874	32574000	26608	13165	2	0	\N
367224	1678	27360856066000	26609	13165	0	0	\N
367225	1874	32572000	26609	13165	1	0	\N
367226	1874	32574000	26609	13165	2	0	\N
367227	1678	27360856066000	26610	13165	0	0	\N
367228	1874	32572000	26610	13165	1	0	\N
367229	1874	32574000	26610	13165	2	0	\N
367241	1678	27360856068000	26614	13168	0	0	\N
367242	1874	32591000	26614	13168	1	0	\N
367243	1874	32593000	26614	13168	2	0	\N
367244	1874	32595000	26614	13168	3	0	\N
367245	1874	32597000	26614	13168	4	0	\N
367246	1874	32600000	26614	13168	5	0	\N
367247	1874	32603000	26614	13168	6	0	\N
367248	1874	32606000	26614	13168	7	0	\N
367249	1678	27360856068000	26615	13168	0	0	\N
367250	1874	32591000	26615	13168	1	0	\N
367251	1874	32593000	26615	13168	2	0	\N
367252	1874	32595000	26615	13168	3	0	\N
367253	1874	32597000	26615	13168	4	0	\N
367254	1874	32600000	26615	13168	5	0	\N
367255	1874	32603000	26615	13168	6	0	\N
367256	1874	32606000	26615	13168	7	0	\N
367257	1678	27360856068000	26616	13168	0	0	\N
367258	1874	32591000	26616	13168	1	0	\N
367259	1874	32593000	26616	13168	2	0	\N
367260	1874	32595000	26616	13168	3	0	\N
367261	1874	32597000	26616	13168	4	0	\N
367262	1874	32600000	26616	13168	5	0	\N
367263	1874	32603000	26616	13168	6	0	\N
367264	1874	32606000	26616	13168	7	0	\N
367273	1678	27360856068000	26618	13168	0	0	\N
367274	1874	32591000	26618	13168	1	0	\N
367275	1874	32593000	26618	13168	2	0	\N
367276	1874	32595000	26618	13168	3	0	\N
367277	1874	32597000	26618	13168	4	0	\N
367278	1874	32600000	26618	13168	5	0	\N
367279	1874	32603000	26618	13168	6	0	\N
367280	1874	32606000	26618	13168	7	0	\N
367281	1678	27360856068000	26619	13168	0	0	\N
367282	1874	32591000	26619	13168	1	0	\N
367283	1874	32593000	26619	13168	2	0	\N
367284	1874	32595000	26619	13168	3	0	\N
367285	1874	32597000	26619	13168	4	0	\N
367286	1874	32600000	26619	13168	5	0	\N
367287	1874	32603000	26619	13168	6	0	\N
367288	1874	32606000	26619	13168	7	0	\N
367289	1678	27360856069000	26620	13169	0	0	\N
367290	1678	27360856070000	26620	13169	1	0	\N
367291	1678	27360856071000	26620	13169	2	0	\N
367292	1678	27360856072000	26620	13169	3	0	\N
367293	1678	27360856073000	26620	13169	4	0	\N
367294	1874	32607000	26620	13169	5	0	\N
367295	2357	100000000	26620	13169	6	0	\N
367296	1874	32608000	26620	13169	7	0	\N
367297	1874	32611000	26620	13169	8	0	\N
367298	1874	32614000	26620	13169	9	0	\N
367299	1874	32617000	26620	13169	10	0	\N
367300	1874	32620000	26620	13169	11	0	\N
367301	2358	100000000	26620	13169	12	0	\N
367302	2359	100000000	26620	13169	13	0	\N
367303	2360	100000000	26620	13169	14	0	\N
367304	2361	100000000	26620	13169	15	0	\N
367305	1874	32623000	26620	13169	16	0	\N
367306	1874	32625000	26620	13169	17	0	\N
367307	1874	32627000	26620	13169	18	0	\N
367308	1874	32629000	26620	13169	19	0	\N
367309	1874	32631000	26620	13169	20	0	\N
367310	1874	32633000	26620	13169	22	0	\N
367311	1678	27360856069000	26621	13169	0	0	\N
367312	1678	27360856070000	26621	13169	1	0	\N
367313	1678	27360856071000	26621	13169	2	0	\N
367314	1678	27360856072000	26621	13169	3	0	\N
367315	1678	27360856073000	26621	13169	4	0	\N
367316	1874	32607000	26621	13169	5	0	\N
367317	2357	100000000	26621	13169	6	0	\N
367318	1874	32608000	26621	13169	7	0	\N
367319	1874	32611000	26621	13169	8	0	\N
367320	1874	32614000	26621	13169	9	0	\N
367321	1874	32617000	26621	13169	10	0	\N
367322	1874	32620000	26621	13169	11	0	\N
367323	2358	100000000	26621	13169	12	0	\N
367324	2359	100000000	26621	13169	13	0	\N
367325	2360	100000000	26621	13169	14	0	\N
367326	2361	100000000	26621	13169	15	0	\N
367327	1874	32623000	26621	13169	16	0	\N
367328	1874	32625000	26621	13169	17	0	\N
367329	1874	32627000	26621	13169	18	0	\N
367330	1874	32629000	26621	13169	19	0	\N
367331	1874	32631000	26621	13169	20	0	\N
367332	1874	32633000	26621	13169	22	0	\N
367203	1678	27360856063000	26604	13162	2	0	1
367204	1874	32548000	26604	13162	3	0	2
367205	1874	32551000	26604	13162	4	0	2
367206	1874	32552000	26604	13162	5	0	2
367207	1874	32555000	26604	13162	6	0	2
367209	1874	32559000	26604	13162	8	0	2
367210	1874	32561000	26604	13162	9	0	2
367215	1678	27360856064000	26606	13163	0	0	1
367216	1874	32562000	26606	13163	1	0	2
367217	1874	32565000	26606	13163	2	0	2
367219	1874	32567000	26607	13164	1	0	2
367220	1874	32569000	26607	13164	2	0	2
367230	1678	27360856066000	26611	13165	0	0	1
367231	1874	32572000	26611	13165	1	0	2
367233	1678	27360856067000	26612	13166	0	0	1
367234	1874	32575000	26612	13166	1	0	2
367235	1874	32578000	26612	13166	2	0	2
367236	1874	32581000	26612	13166	3	0	2
367237	1874	32583000	26612	13166	4	0	2
367239	1874	32587000	26613	13167	0	0	2
367240	1874	32590000	26613	13167	1	0	2
367265	1678	27360856068000	26617	13168	0	0	1
367266	1874	32591000	26617	13168	1	0	2
367267	1874	32593000	26617	13168	2	0	2
367269	1874	32597000	26617	13168	4	0	2
367270	1874	32600000	26617	13168	5	0	2
367271	1874	32603000	26617	13168	6	0	2
367272	1874	32606000	26617	13168	7	0	2
367334	1678	27360856070000	26622	13169	1	0	1
367335	1678	27360856071000	26622	13169	2	0	1
367336	1678	27360856072000	26622	13169	3	0	1
367355	1678	27360856074000	26623	13170	0	0	\N
367356	1874	32635000	26623	13170	1	0	\N
367357	1874	32638000	26623	13170	2	0	\N
367374	1678	27360856077000	26628	13173	0	0	\N
367375	1678	27360856078000	26628	13173	1	0	\N
367376	1874	32651000	26628	13173	2	0	\N
367377	1874	32654000	26628	13173	3	0	\N
367378	1874	32656000	26628	13173	4	0	\N
367379	1874	32658000	26628	13173	5	0	\N
367380	1874	32659000	26628	13173	6	0	\N
367381	1678	27360856077000	26629	13173	0	0	\N
367382	1678	27360856078000	26629	13173	1	0	\N
367383	1874	32651000	26629	13173	2	0	\N
367384	1874	32654000	26629	13173	3	0	\N
367385	1874	32656000	26629	13173	4	0	\N
367386	1874	32658000	26629	13173	5	0	\N
367387	1874	32659000	26629	13173	6	0	\N
367392	1678	27360856080000	26631	13175	0	0	\N
367393	1874	32667000	26631	13175	1	0	\N
367394	1874	32668000	26631	13175	2	0	\N
367395	1874	32670000	26631	13175	3	0	\N
367405	1678	27360856082000	26635	13178	0	0	\N
367406	1874	32683000	26635	13178	1	0	\N
367407	1874	32685000	26635	13178	2	0	\N
367408	1874	32686000	26635	13178	3	0	\N
367409	1678	27360856082000	26636	13178	0	0	\N
367410	1874	32683000	26636	13178	1	0	\N
367411	1874	32685000	26636	13178	2	0	\N
367412	1874	32686000	26636	13178	3	0	\N
367417	1678	27360856082000	26638	13178	0	0	\N
367418	1874	32683000	26638	13178	1	0	\N
367419	1874	32685000	26638	13178	2	0	\N
367420	1874	32686000	26638	13178	3	0	\N
367421	1678	27360856083000	26639	13179	0	0	\N
367422	1678	27360856084000	26639	13179	1	0	\N
367423	1678	27360856085000	26639	13179	2	0	\N
367424	1874	32688000	26639	13179	3	0	\N
367425	1874	32690000	26639	13179	4	0	\N
367426	1874	32692000	26639	13179	5	0	\N
367427	1874	32695000	26639	13179	6	0	\N
367428	1874	32698000	26639	13179	7	0	\N
367429	1874	32701000	26639	13179	8	0	\N
367439	1678	27360856083000	26641	13179	0	0	\N
367440	1678	27360856084000	26641	13179	1	0	\N
367441	1678	27360856085000	26641	13179	2	0	\N
367442	1874	32688000	26641	13179	3	0	\N
367443	1874	32690000	26641	13179	4	0	\N
367444	1874	32692000	26641	13179	5	0	\N
367445	1874	32695000	26641	13179	6	0	\N
367446	1874	32698000	26641	13179	7	0	\N
367447	1874	32701000	26641	13179	8	0	\N
367448	1678	27360856083000	26642	13179	0	0	\N
367449	1678	27360856084000	26642	13179	1	0	\N
367450	1678	27360856085000	26642	13179	2	0	\N
367451	1874	32688000	26642	13179	3	0	\N
367452	1874	32690000	26642	13179	4	0	\N
367453	1874	32692000	26642	13179	5	0	\N
367454	1874	32695000	26642	13179	6	0	\N
367455	1874	32698000	26642	13179	7	0	\N
367456	1874	32701000	26642	13179	8	0	\N
367467	1678	27360856087000	26645	13181	0	0	\N
367468	1678	27360856088000	26645	13181	1	0	\N
367469	1874	32706000	26645	13181	2	0	\N
367470	1874	32708000	26645	13181	3	0	\N
367471	1874	32711000	26645	13181	4	0	\N
367472	1874	32714000	26645	13181	5	0	\N
367339	2357	100000000	26622	13169	6	0	0
367340	1874	32608000	26622	13169	7	0	2
367341	1874	32611000	26622	13169	8	0	2
367342	1874	32614000	26622	13169	9	0	2
367343	1874	32617000	26622	13169	10	0	2
367345	2358	100000000	26622	13169	12	0	0
367346	2359	100000000	26622	13169	13	0	0
367347	2360	100000000	26622	13169	14	0	0
367348	2361	100000000	26622	13169	15	0	0
367349	1874	32623000	26622	13169	16	0	2
367351	1874	32627000	26622	13169	18	0	2
367352	1874	32629000	26622	13169	19	0	2
367353	1874	32631000	26622	13169	20	0	2
367354	1874	32633000	26622	13169	22	0	2
367359	1874	32635000	26624	13170	1	0	2
367360	1874	32638000	26624	13170	2	0	2
367361	1678	27360856075000	26625	13171	0	0	1
367362	1874	32641000	26625	13171	1	0	2
367363	1874	32643000	26625	13171	2	0	2
367365	1874	32646000	26626	13172	1	0	2
367366	1874	32648000	26626	13172	2	0	2
367367	1678	27360856077000	26627	13173	0	0	1
367368	1678	27360856078000	26627	13173	1	0	1
367369	1874	32651000	26627	13173	2	0	2
367371	1874	32656000	26627	13173	4	0	2
367372	1874	32658000	26627	13173	5	0	2
367373	1874	32659000	26627	13173	6	0	2
367388	1678	27360856079000	26630	13174	0	0	1
367390	1874	32662000	26630	13174	2	0	2
367391	1874	32664000	26630	13174	3	0	2
367396	1678	27360856080000	26632	13175	0	0	1
367397	1874	32667000	26632	13175	1	0	2
367398	1874	32668000	26632	13175	2	0	2
367400	1678	27360856081000	26633	13176	0	0	1
367401	1874	32673000	26633	13176	1	0	2
367402	1874	32675000	26633	13176	2	0	2
367403	1874	32678000	26634	13177	0	0	2
367404	1874	32680000	26634	13177	1	0	2
367414	1874	32683000	26637	13178	1	0	2
367415	1874	32685000	26637	13178	2	0	2
367416	1874	32686000	26637	13178	3	0	2
367430	1678	27360856083000	26640	13179	0	0	1
367432	1678	27360856085000	26640	13179	2	0	1
367433	1874	32688000	26640	13179	3	0	2
367434	1874	32690000	26640	13179	4	0	2
367435	1874	32692000	26640	13179	5	0	2
367436	1874	32695000	26640	13179	6	0	2
367438	1874	32701000	26640	13179	8	0	2
367457	1678	27360856086000	26643	13180	0	0	1
367458	2362	1000000000	26643	13180	1	0	0
367459	1874	32702000	26643	13180	2	0	2
367460	1874	32704000	26643	13180	3	0	2
367462	1678	27360856088000	26644	13181	1	0	1
367463	1874	32706000	26644	13181	2	0	2
367464	1874	32708000	26644	13181	3	0	2
367465	1874	32711000	26644	13181	4	0	2
367473	1874	32706000	26646	13181	0	0	\N
367474	1874	32708000	26646	13181	1	0	\N
367475	1874	32711000	26646	13181	2	0	\N
367476	1874	32714000	26646	13181	3	0	\N
367477	1678	27360856089000	26647	13182	0	0	\N
367478	1874	32715000	26647	13182	1	0	\N
367479	1874	32718000	26647	13182	2	0	\N
367480	1874	32720000	26647	13182	3	0	\N
367481	1678	27360856089000	26648	13182	0	0	\N
367482	1874	32715000	26648	13182	1	0	\N
367483	1874	32718000	26648	13182	2	0	\N
367484	1874	32720000	26648	13182	3	0	\N
367492	1678	26640831034000	26651	13070	0	0	\N
367493	1678	26640831035000	26651	13070	1	0	\N
367494	1678	26640831036000	26651	13070	2	0	\N
367495	1678	26640831037000	26651	13070	3	0	\N
367496	1678	26640831038000	26651	13070	4	0	\N
367497	1678	26640831039000	26651	13070	5	0	\N
367498	1678	26640831040000	26651	13070	6	0	\N
367499	1678	26640831041000	26651	13070	7	0	\N
367500	1678	26640831042000	26651	13070	8	0	\N
367501	1678	26640831043000	26651	13070	9	0	\N
367502	1678	26640831044000	26651	13070	10	0	\N
367503	1678	26640831045000	26651	13070	11	0	\N
367504	1678	26640831046000	26651	13070	12	0	\N
367505	1678	26640831047000	26651	13070	13	0	\N
367506	1678	26640831048000	26651	13070	14	0	\N
367507	1678	26640831049000	26651	13070	15	0	\N
367508	1678	26640831050000	26651	13070	16	0	\N
367509	1678	26640831051000	26651	13070	17	0	\N
367510	1678	26640831052000	26651	13070	18	0	\N
367511	1678	26640831053000	26651	13070	19	0	\N
367512	1678	26640831054000	26651	13070	20	0	\N
367513	1678	26640831055000	26651	13070	21	0	\N
367514	1678	26640831056000	26651	13070	22	0	\N
367515	1678	26640831057000	26651	13070	23	0	\N
367516	1678	26640831058000	26651	13070	24	0	\N
367517	1678	26640831059000	26651	13070	25	0	\N
367518	1678	26640831060000	26651	13070	26	0	\N
367519	1678	26640831061000	26651	13070	27	0	\N
367520	1678	26640831062000	26651	13070	28	0	\N
367521	1678	26640831063000	26651	13070	29	0	\N
367522	1678	26640831064000	26651	13070	30	0	\N
367523	1678	26640831065000	26651	13070	31	0	\N
367524	1678	26640831066000	26651	13070	32	0	\N
367525	1678	26640831067000	26651	13070	33	0	\N
367526	1678	26640831068000	26651	13070	34	0	\N
367527	1678	26640831069000	26651	13070	35	0	\N
367528	1678	26640831070000	26651	13070	36	0	\N
367529	1678	26640831071000	26651	13070	37	0	\N
367530	1678	26640831072000	26651	13070	38	0	\N
367531	1678	26640831073000	26651	13070	39	0	\N
367532	1678	26640831074000	26651	13070	40	0	\N
367533	1678	26640831075000	26651	13070	41	0	\N
367534	1678	26640831076000	26651	13070	42	0	\N
367535	1678	26640831077000	26651	13070	43	0	\N
367536	1678	26640831078000	26651	13070	44	0	\N
367537	1678	26640831079000	26651	13070	45	0	\N
367538	1678	26640831080000	26651	13070	46	0	\N
367539	1678	26640831081000	26651	13070	47	0	\N
367540	1678	26640831082000	26651	13070	48	0	\N
367541	1678	26640831083000	26651	13070	49	0	\N
367542	1678	26640831084000	26651	13070	50	0	\N
367543	1678	26640831085000	26651	13070	51	0	\N
367544	1678	26640831086000	26651	13070	52	0	\N
367545	1678	26640831087000	26651	13070	53	0	\N
367546	1678	26640831088000	26651	13070	54	0	\N
367547	1678	26640831089000	26651	13070	55	0	\N
367548	1678	26640831090000	26651	13070	56	0	\N
367549	2362	0	26651	13070	57	0	\N
367550	2362	1000000000	26651	13070	58	0	\N
367551	2346	190000000	26651	13070	59	0	\N
367552	1874	32063000	26651	13070	60	0	\N
367553	2357	100000000	26651	13070	61	0	\N
367554	2346	289000000	26651	13070	62	0	\N
367555	2358	100000000	26651	13070	63	0	\N
367556	2359	100000000	26651	13070	64	0	\N
367557	2360	100000000	26651	13070	65	0	\N
367558	2346	388000000	26651	13070	66	0	\N
367559	2361	100000000	26651	13070	67	0	\N
367560	1874	32065000	26651	13070	68	0	\N
367561	1874	32067000	26651	13070	69	0	\N
367562	1874	32069000	26651	13070	70	0	\N
367563	1874	32071000	26651	13070	71	0	\N
367564	1874	32073000	26651	13070	72	0	\N
367565	1874	32075000	26651	13070	73	0	\N
367566	1874	32077000	26651	13070	74	0	\N
367567	1874	32079000	26651	13070	75	0	\N
367568	1874	32081000	26651	13070	76	0	\N
367569	1874	32083000	26651	13070	77	0	\N
367570	1874	32085000	26651	13070	78	0	\N
367571	1874	32087000	26651	13070	79	0	\N
367572	1874	32090000	26651	13070	80	0	\N
367573	1874	32093000	26651	13070	81	0	\N
367574	1874	32096000	26651	13070	82	0	\N
367575	1874	32099000	26651	13070	83	0	\N
367576	1874	32102000	26651	13070	84	0	\N
367577	1874	32105000	26651	13070	85	0	\N
367578	1874	32108000	26651	13070	86	0	\N
367579	1874	32111000	26651	13070	87	0	\N
367580	1874	32114000	26651	13070	88	0	\N
367581	1874	32117000	26651	13070	89	0	\N
367582	1874	32120000	26651	13070	90	0	\N
367583	1874	32123000	26651	13070	91	0	\N
367584	1874	32126000	26651	13070	92	0	\N
367585	1874	32129000	26651	13070	93	0	\N
367586	1874	32132000	26651	13070	94	0	\N
367587	1874	32135000	26651	13070	95	0	\N
367588	1874	32138000	26651	13070	96	0	\N
367589	1874	32141000	26651	13070	97	0	\N
367590	1874	32144000	26651	13070	98	0	\N
367591	1874	32147000	26651	13070	99	0	\N
367592	1874	32150000	26651	13070	100	0	\N
367593	1874	32153000	26651	13070	101	0	\N
367594	1874	32156000	26651	13070	102	0	\N
367595	1874	32159000	26651	13070	103	0	\N
367596	1874	32162000	26651	13070	104	0	\N
367597	1874	32165000	26651	13070	105	0	\N
367598	1874	32168000	26651	13070	107	0	\N
367599	1874	32171000	26651	13070	108	0	\N
367600	1874	32174000	26651	13070	109	0	\N
367601	1874	32177000	26651	13070	110	0	\N
367602	1874	32180000	26651	13070	111	0	\N
367603	1874	32183000	26651	13070	112	0	\N
367604	1874	32186000	26651	13070	113	0	\N
367605	1874	32189000	26651	13070	114	0	\N
367606	1874	32192000	26651	13070	115	0	\N
367607	1874	32195000	26651	13070	116	0	\N
367608	1874	32198000	26651	13070	117	0	\N
367487	1874	32718000	26649	13182	2	0	2
367488	1874	32720000	26649	13182	3	0	2
367489	1678	27360856090000	26650	13183	0	0	1
367490	1874	32722000	26650	13183	1	0	2
367491	1874	32725000	26650	13183	2	0	2
367609	1874	32201000	26651	13070	118	0	\N
367610	1874	32204000	26651	13070	119	0	\N
367611	1874	32207000	26651	13070	120	0	\N
367612	1874	32210000	26651	13070	121	0	\N
367613	1874	32213000	26651	13070	122	0	\N
367614	1874	32216000	26651	13070	123	0	\N
367615	1874	32219000	26651	13070	124	0	\N
367616	1874	32222000	26651	13070	125	0	\N
367617	1678	27360856091000	26652	13184	0	0	\N
367618	1874	32728000	26652	13184	1	0	\N
367619	1874	32730000	26652	13184	2	0	\N
367620	1678	27360856091000	26653	13184	0	0	\N
367621	1874	32728000	26653	13184	1	0	\N
367622	1874	32730000	26653	13184	2	0	\N
367630	1678	27360856092000	26656	13185	0	0	\N
367631	1874	32732000	26656	13185	1	0	\N
367632	1874	32733000	26656	13185	2	0	\N
367633	1874	32736000	26656	13185	3	0	\N
367637	1678	27360856094000	26658	13187	0	0	\N
367638	1874	32744000	26658	13187	1	0	\N
367639	1874	32746000	26658	13187	2	0	\N
367650	1678	27360856095000	26661	13188	0	0	\N
367651	1678	27360856096000	26661	13188	1	0	\N
367652	1874	32747000	26661	13188	2	0	\N
367653	1874	32749000	26661	13188	3	0	\N
367654	1874	32752000	26661	13188	4	0	\N
367655	1874	32754000	26661	13188	5	0	\N
367656	1874	32756000	26661	13188	6	0	\N
367657	1874	32757000	26661	13188	7	0	\N
367658	1678	27360856095000	26662	13188	0	0	\N
367659	1678	27360856096000	26662	13188	1	0	\N
367660	1874	32747000	26662	13188	2	0	\N
367661	1874	32749000	26662	13188	3	0	\N
367662	1874	32752000	26662	13188	4	0	\N
367663	1874	32754000	26662	13188	5	0	\N
367664	1874	32756000	26662	13188	6	0	\N
367665	1874	32757000	26662	13188	7	0	\N
367669	1678	27360856097000	26664	13189	0	0	\N
367670	1874	32759000	26664	13189	1	0	\N
367671	1874	32762000	26664	13189	2	0	\N
367672	1678	27360856098000	26665	13190	0	0	\N
367673	1678	27360856099000	26665	13190	1	0	\N
367674	1874	32764000	26665	13190	3	0	\N
367675	1874	32766000	26665	13190	4	0	\N
367676	1874	32769000	26665	13190	5	0	\N
367677	1874	32772000	26665	13190	6	0	\N
367678	1874	32773000	26665	13190	7	0	\N
367679	1678	27360856098000	26666	13190	0	0	\N
367680	1678	27360856099000	26666	13190	1	0	\N
367681	1874	32764000	26666	13190	3	0	\N
367682	1874	32766000	26666	13190	4	0	\N
367683	1874	32769000	26666	13190	5	0	\N
367684	1874	32772000	26666	13190	6	0	\N
367685	1874	32773000	26666	13190	7	0	\N
367686	1678	27360856098000	26667	13190	0	0	\N
367687	1678	27360856099000	26667	13190	1	0	\N
367688	1874	32764000	26667	13190	3	0	\N
367689	1874	32766000	26667	13190	4	0	\N
367690	1874	32769000	26667	13190	5	0	\N
367691	1874	32772000	26667	13190	6	0	\N
367692	1874	32773000	26667	13190	7	0	\N
367693	1678	27360856098000	26668	13190	0	0	\N
367694	1678	27360856099000	26668	13190	1	0	\N
367695	1874	32764000	26668	13190	3	0	\N
367696	1874	32766000	26668	13190	4	0	\N
367697	1874	32769000	26668	13190	5	0	\N
367698	1874	32772000	26668	13190	6	0	\N
367699	1874	32773000	26668	13190	7	0	\N
367707	1678	27360856098000	26670	13190	0	0	\N
367708	1678	27360856099000	26670	13190	1	0	\N
367709	1874	32764000	26670	13190	3	0	\N
367710	1874	32766000	26670	13190	4	0	\N
367711	1874	32769000	26670	13190	5	0	\N
367712	1874	32772000	26670	13190	6	0	\N
367713	1874	32773000	26670	13190	7	0	\N
367724	1678	27360856102000	26674	13193	0	0	\N
367725	1874	32786000	26674	13193	1	0	\N
367726	1874	32787000	26674	13193	2	0	\N
367727	1874	32789000	26674	13193	3	0	\N
367728	1678	27360856102000	26675	13193	0	0	\N
367729	1874	32786000	26675	13193	1	0	\N
367730	1874	32787000	26675	13193	2	0	\N
367731	1874	32789000	26675	13193	3	0	\N
367741	1678	27360856105000	26679	13196	0	0	\N
367742	1874	32802000	26679	13196	1	0	\N
367743	1874	32804000	26679	13196	2	0	\N
367625	1874	32730000	26654	13184	2	0	2
367626	1678	27360856092000	26655	13185	0	0	1
367627	1874	32732000	26655	13185	1	0	2
367628	1874	32733000	26655	13185	2	0	2
367629	1874	32736000	26655	13185	3	0	2
367635	1874	32738000	26657	13186	1	0	2
367636	1874	32741000	26657	13186	2	0	2
367640	1678	27360856094000	26659	13187	0	0	1
367641	1874	32744000	26659	13187	1	0	2
367642	1678	27360856095000	26660	13188	0	0	1
367644	1874	32747000	26660	13188	2	0	2
367645	1874	32749000	26660	13188	3	0	2
367646	1874	32752000	26660	13188	4	0	2
367647	1874	32754000	26660	13188	5	0	2
367649	1874	32757000	26660	13188	7	0	2
367666	1678	27360856097000	26663	13189	0	0	1
367667	1874	32759000	26663	13189	1	0	2
367668	1874	32762000	26663	13189	2	0	2
367700	1678	27360856098000	26669	13190	0	0	1
367702	1874	32764000	26669	13190	3	0	2
367703	1874	32766000	26669	13190	4	0	2
367704	1874	32769000	26669	13190	5	0	2
367705	1874	32772000	26669	13190	6	0	2
367706	1874	32773000	26669	13190	7	0	2
367715	1874	32775000	26671	13191	1	0	2
367716	1874	32778000	26671	13191	2	0	2
367717	1678	27360856101000	26672	13192	0	0	1
367718	1874	32781000	26672	13192	1	0	2
367720	1678	27360856102000	26673	13193	0	0	1
367721	1874	32786000	26673	13193	1	0	2
367722	1874	32787000	26673	13193	2	0	2
367723	1874	32789000	26673	13193	3	0	2
367732	1678	27360856103000	26676	13194	0	0	1
367734	1874	32794000	26676	13194	2	0	2
367735	1678	27360856104000	26677	13195	0	0	1
367736	1874	32797000	26677	13195	1	0	2
367737	1874	32799000	26677	13195	2	0	2
367738	1678	27360856105000	26678	13196	0	0	1
367740	1874	32804000	26678	13196	2	0	2
367744	1678	27360856106000	26680	13197	0	0	1
367751	1678	26640831091000	26681	13071	0	0	\N
367752	1678	26640831092000	26681	13071	1	0	\N
367753	1678	26640831093000	26681	13071	2	0	\N
367754	1678	26640831094000	26681	13071	3	0	\N
367755	1678	26640831095000	26681	13071	4	0	\N
367756	1678	26640831096000	26681	13071	5	0	\N
367766	1678	27360856108000	26683	13198	0	0	\N
367767	1678	27360856109000	26683	13198	1	0	\N
367768	1678	27360856110000	26683	13198	2	0	\N
367769	1874	32817000	26683	13198	3	0	\N
367770	1874	32818000	26683	13198	4	0	\N
367771	1874	32820000	26683	13198	5	0	\N
367772	1874	32823000	26683	13198	6	0	\N
367773	1874	32826000	26683	13198	7	0	\N
367774	1874	32829000	26683	13198	8	0	\N
367775	1678	27360856111000	26685	13199	0	0	\N
367776	1678	27360856112000	26685	13199	1	0	\N
367777	1874	32831000	26685	13199	2	0	\N
367778	1874	32833000	26685	13199	3	0	\N
367779	1874	32834000	26685	13199	4	0	\N
367780	2363	100000000	26685	13199	5	0	\N
367781	1874	32837000	26685	13199	6	0	\N
367782	1874	32840000	26685	13199	7	0	\N
367783	1678	27360856111000	26686	13199	0	0	\N
367784	1678	27360856112000	26686	13199	1	0	\N
367785	1874	32831000	26686	13199	2	0	\N
367786	1874	32833000	26686	13199	3	0	\N
367787	1874	32834000	26686	13199	4	0	\N
367788	2363	100000000	26686	13199	5	0	\N
367789	1874	32837000	26686	13199	6	0	\N
367790	1874	32840000	26686	13199	7	0	\N
367802	1678	27360856114000	26690	13201	0	0	\N
367803	1678	27360856115000	26690	13201	1	0	\N
367804	1678	27360856116000	26690	13201	2	0	\N
367805	1874	32847000	26690	13201	3	0	\N
367806	1874	32850000	26690	13201	4	0	\N
367807	1874	32853000	26690	13201	5	0	\N
367808	1874	32856000	26690	13201	6	0	\N
367809	1874	32858000	26690	13201	7	0	\N
367810	1874	32860000	26690	13201	8	0	\N
367811	1874	32861000	26690	13201	9	0	\N
367812	1678	27360856114000	26691	13201	0	0	\N
367813	1678	27360856115000	26691	13201	1	0	\N
367814	1678	27360856116000	26691	13201	2	0	\N
367815	1874	32847000	26691	13201	3	0	\N
367816	1874	32850000	26691	13201	4	0	\N
367817	1874	32853000	26691	13201	5	0	\N
367818	1874	32856000	26691	13201	6	0	\N
367819	1874	32858000	26691	13201	7	0	\N
367820	1874	32860000	26691	13201	8	0	\N
367821	1874	32861000	26691	13201	9	0	\N
367843	1678	27360856119000	26697	13204	0	0	\N
367844	1874	32873000	26697	13204	1	0	\N
367845	1874	32874000	26697	13204	2	0	\N
367846	1874	32877000	26697	13204	3	0	\N
367850	1678	27360856120000	26699	13205	0	0	\N
367851	1874	32880000	26699	13205	1	0	\N
367852	1874	32882000	26699	13205	2	0	\N
367853	1678	27360856121000	26700	13206	0	0	\N
367854	1874	32884000	26700	13206	1	0	\N
367855	1874	32887000	26700	13206	2	0	\N
367859	1678	27360856121000	26702	13206	0	0	\N
367860	1874	32884000	26702	13206	1	0	\N
367861	1874	32887000	26702	13206	2	0	\N
367875	1678	27360856126000	26705	13209	0	0	\N
367876	1678	27360856127000	26705	13209	1	0	\N
367877	1678	27360856128000	26705	13209	2	0	\N
367878	1540	0	26705	13209	3	0	\N
367879	1874	32910000	26705	13209	4	0	\N
367880	1874	32912000	26705	13209	5	0	\N
367747	1874	32808000	26680	13197	3	0	2
367748	1874	32810000	26680	13197	4	0	2
367749	1874	32813000	26680	13197	5	0	2
367750	1874	32815000	26680	13197	6	0	2
367757	1678	27360856108000	26682	13198	0	0	1
367759	1678	27360856110000	26682	13198	2	0	1
367760	1874	32817000	26682	13198	3	0	2
367761	1874	32818000	26682	13198	4	0	2
367762	1874	32820000	26682	13198	5	0	2
367763	1874	32823000	26682	13198	6	0	2
367765	1874	32829000	26682	13198	8	0	2
367791	1678	27360856111000	26687	13199	0	0	1
367792	1678	27360856112000	26687	13199	1	0	1
367793	1874	32831000	26687	13199	2	0	2
367795	1874	32834000	26687	13199	4	0	2
367796	2363	100000000	26687	13199	5	0	0
367797	1874	32837000	26687	13199	6	0	2
367798	1874	32840000	26687	13199	7	0	2
367799	1678	27360856113000	26688	13200	0	0	1
367801	1874	32845000	26688	13200	2	0	2
367822	1678	27360856114000	26692	13201	0	0	1
367823	1678	27360856115000	26692	13201	1	0	1
367824	1678	27360856116000	26692	13201	2	0	1
367825	1874	32847000	26692	13201	3	0	2
367827	1874	32853000	26692	13201	5	0	2
367828	1874	32856000	26692	13201	6	0	2
367829	1874	32858000	26692	13201	7	0	2
367830	1874	32860000	26692	13201	8	0	2
367832	1678	27360856117000	26694	13202	0	0	1
367833	1874	32864000	26694	13202	1	0	2
367834	1874	32866000	26694	13202	2	0	2
367835	2364	100000000	26694	13202	3	0	0
367836	1678	27360856118000	26695	13203	0	0	1
367838	1874	32871000	26695	13203	2	0	2
367839	1678	27360856119000	26696	13204	0	0	1
367840	1874	32873000	26696	13204	1	0	2
367841	1874	32874000	26696	13204	2	0	2
367842	1874	32877000	26696	13204	3	0	2
367848	1874	32880000	26698	13205	1	0	2
367849	1874	32882000	26698	13205	2	0	2
367856	1678	27360856121000	26701	13206	0	0	1
367857	1874	32884000	26701	13206	1	0	2
367862	1678	27360856122000	26703	13207	0	0	1
367863	1678	27360856123000	26703	13207	1	0	1
367864	1874	32889000	26703	13207	2	0	2
367865	1874	32892000	26703	13207	3	0	2
367866	1874	32895000	26703	13207	4	0	2
367868	1874	32898000	26703	13207	6	0	2
367869	1678	27360856124000	26704	13208	0	0	1
367870	1678	27360856125000	26704	13208	1	0	1
367871	1874	32901000	26704	13208	2	0	2
367872	1874	32904000	26704	13208	3	0	2
367874	1874	32908000	26704	13208	5	0	2
367881	1874	32915000	26705	13209	6	0	\N
367882	1874	32918000	26705	13209	7	0	\N
367883	1874	32921000	26705	13209	8	0	\N
367884	1874	32923000	26705	13209	9	0	\N
367885	1874	32924000	26705	13209	10	0	\N
367886	1678	26640830912000	26706	13053	0	0	\N
367887	1678	26640830913000	26706	13053	1	0	\N
367888	1678	26640830914000	26706	13053	2	0	\N
367889	1678	26640830915000	26706	13053	3	0	\N
367890	1678	26640830916000	26706	13053	4	0	\N
367891	1678	26640830917000	26706	13053	5	0	\N
367892	1678	26640830918000	26706	13053	6	0	\N
367893	1678	26640830919000	26706	13053	7	0	\N
367894	1678	26640830920000	26706	13053	8	0	\N
367895	1678	26640830921000	26706	13053	9	0	\N
367896	1678	26640830922000	26706	13053	10	0	\N
367897	1678	26640830923000	26706	13053	11	0	\N
367898	1678	26640830924000	26706	13053	12	0	\N
367899	1678	26640830925000	26706	13053	13	0	\N
367900	1678	26640830926000	26706	13053	14	0	\N
367901	1678	26640830927000	26706	13053	15	0	\N
367902	1678	26640830928000	26706	13053	16	0	\N
367903	1678	26640830929000	26706	13053	17	0	\N
367904	1678	26640830930000	26706	13053	18	0	\N
367905	1678	26640830931000	26706	13053	19	0	\N
367906	1678	26640830932000	26706	13053	20	0	\N
367907	1678	26640830933000	26706	13053	21	0	\N
367908	1678	26640830934000	26706	13053	22	0	\N
367909	1678	26640830935000	26706	13053	23	0	\N
367910	1678	26640830936000	26706	13053	24	0	\N
367911	1678	26640830937000	26706	13053	25	0	\N
367912	1678	26640830938000	26706	13053	26	0	\N
367913	1678	26640830939000	26706	13053	27	0	\N
367914	1678	26640830940000	26706	13053	28	0	\N
367915	1678	26640830941000	26706	13053	29	0	\N
367916	1678	26640830942000	26706	13053	30	0	\N
367917	1678	26640830943000	26706	13053	31	0	\N
367918	1678	26640830944000	26706	13053	32	0	\N
367919	1678	26640830945000	26706	13053	33	0	\N
367920	1678	26640830946000	26706	13053	34	0	\N
367921	1678	26640830947000	26706	13053	35	0	\N
367922	1678	26640830948000	26706	13053	36	0	\N
367923	1678	26640830949000	26706	13053	37	0	\N
367924	1678	26640830950000	26706	13053	39	0	\N
367925	1678	26640830951000	26706	13053	40	0	\N
367926	1678	26640830952000	26706	13053	41	0	\N
367927	1678	26640830953000	26706	13053	42	0	\N
367928	1678	26640830954000	26706	13053	43	0	\N
367929	1678	26640830955000	26706	13053	44	0	\N
367930	1678	26640830956000	26706	13053	45	0	\N
367931	1678	26640830957000	26706	13053	46	0	\N
367932	1678	26640830958000	26706	13053	47	0	\N
367933	1678	26640830959000	26706	13053	48	0	\N
367934	1678	26640830960000	26706	13053	49	0	\N
367935	1678	26640830961000	26706	13053	50	0	\N
367936	1678	26640830962000	26706	13053	51	0	\N
367937	1678	26640830963000	26706	13053	52	0	\N
367938	1678	26640830964000	26706	13053	53	0	\N
367939	1678	26640830965000	26706	13053	54	0	\N
367940	1678	26640830966000	26706	13053	55	0	\N
367941	1678	26640830967000	26706	13053	56	0	\N
367942	1678	26640830968000	26706	13053	57	0	\N
367943	1678	26640830969000	26706	13053	58	0	\N
367944	1678	26640830970000	26706	13053	59	0	\N
367945	1678	26640830971000	26706	13053	60	0	\N
367946	1678	26640830972000	26706	13053	61	0	\N
367947	1678	26640830973000	26706	13053	62	0	\N
367948	1678	26640830974000	26706	13053	63	0	\N
367949	1678	26640830975000	26706	13053	64	0	\N
367950	1678	26640830976000	26706	13053	65	0	\N
367951	1678	26640830977000	26706	13053	66	0	\N
367952	1678	26640830978000	26706	13053	67	0	\N
367953	1678	26640830979000	26706	13053	68	0	\N
367954	1678	26640830980000	26706	13053	69	0	\N
367955	1678	26640830981000	26706	13053	70	0	\N
367956	1678	26640830982000	26706	13053	71	0	\N
367957	1678	26640830983000	26706	13053	72	0	\N
367958	1678	26640830984000	26706	13053	73	0	\N
367959	1678	26640830985000	26706	13053	74	0	\N
367960	1678	26640830986000	26706	13053	75	0	\N
367961	1678	26640830987000	26706	13053	76	0	\N
367962	1678	26640830988000	26706	13053	77	0	\N
367963	1678	26640830989000	26706	13053	78	0	\N
367964	1678	26640830990000	26706	13053	79	0	\N
367965	1678	26640830991000	26706	13053	80	0	\N
367966	1678	26640830992000	26706	13053	81	0	\N
367967	1678	26640830993000	26706	13053	82	0	\N
367968	1678	26640830994000	26706	13053	83	0	\N
367969	1678	26640830995000	26706	13053	84	0	\N
367970	1678	26640830996000	26706	13053	85	0	\N
367971	1678	26640830997000	26706	13053	86	0	\N
367972	1678	26640830998000	26706	13053	87	0	\N
367973	1678	26640830999000	26706	13053	88	0	\N
367974	1678	26640831000000	26706	13053	89	0	\N
367975	1678	26640831001000	26706	13053	90	0	\N
367976	1678	26640831002000	26706	13053	91	0	\N
367977	1678	26640831003000	26706	13053	92	0	\N
367978	1678	26640831004000	26706	13053	93	0	\N
367979	1678	26640831005000	26706	13053	94	0	\N
367980	1678	26640831006000	26706	13053	95	0	\N
367981	1678	26640831007000	26706	13053	96	0	\N
367982	1678	26640831008000	26706	13053	97	0	\N
367983	1678	26640831009000	26706	13053	98	0	\N
367984	1678	26640831010000	26706	13053	99	0	\N
367985	1678	26640831011000	26706	13053	100	0	\N
367986	1678	26640831012000	26706	13053	101	0	\N
367987	1678	26640831013000	26706	13053	102	0	\N
367988	1678	26640831014000	26706	13053	103	0	\N
367989	1678	26640831015000	26706	13053	104	0	\N
367990	1678	26640831016000	26706	13053	105	0	\N
367991	1678	26640831017000	26706	13053	106	0	\N
367992	1678	26640831018000	26706	13053	107	0	\N
367993	1678	26640831019000	26706	13053	108	0	\N
367994	1678	26640831020000	26706	13053	109	0	\N
367995	1678	26640831021000	26706	13053	110	0	\N
367996	1678	26640831022000	26706	13053	111	0	\N
367997	1678	26640831023000	26706	13053	112	0	\N
367998	1678	26640831024000	26706	13053	113	0	\N
367999	1678	26640831025000	26706	13053	114	0	\N
368000	1678	26640831026000	26706	13053	115	0	\N
368001	1678	26640831027000	26706	13053	116	0	\N
368002	1678	26640831028000	26706	13053	117	0	\N
368003	1678	26640831029000	26706	13053	118	0	\N
368004	1678	26640831030000	26706	13053	119	0	\N
368005	1678	26640831031000	26706	13053	120	0	\N
368006	1678	26640831032000	26706	13053	121	0	\N
368007	1678	26640831033000	26706	13053	122	0	\N
368008	1678	26640831034000	26706	13053	123	0	\N
368009	1678	26640831035000	26706	13053	124	0	\N
368010	1678	26640831036000	26706	13053	125	0	\N
368013	1678	27360856128000	26707	13209	2	0	1
368014	1540	0	26707	13209	3	0	6
368015	1874	32910000	26707	13209	4	0	2
368016	1874	32912000	26707	13209	5	0	2
368029	1678	27360856064000	26709	13163	0	0	\N
368030	1678	27360856065000	26709	13163	1	0	\N
368031	1678	27360856066000	26709	13163	2	0	\N
368032	1678	27360856067000	26709	13163	3	0	\N
368033	1678	27360856068000	26709	13163	4	0	\N
368034	1678	27360856069000	26709	13163	5	0	\N
368035	1678	27360856070000	26709	13163	6	0	\N
368036	1678	27360856071000	26709	13163	7	0	\N
368037	1678	27360856072000	26709	13163	8	0	\N
368038	1678	27360856073000	26709	13163	9	0	\N
368039	1678	27360856074000	26709	13163	10	0	\N
368040	1678	27360856075000	26709	13163	11	0	\N
368041	1678	27360856076000	26709	13163	12	0	\N
368042	1678	27360856077000	26709	13163	13	0	\N
368043	1678	27360856078000	26709	13163	14	0	\N
368044	1678	27360856079000	26709	13163	15	0	\N
368045	1678	27360856080000	26709	13163	16	0	\N
368046	1678	27360856081000	26709	13163	17	0	\N
368047	1678	27360856082000	26709	13163	18	0	\N
368048	1678	27360856083000	26709	13163	19	0	\N
368049	1678	27360856084000	26709	13163	20	0	\N
368050	1678	27360856085000	26709	13163	21	0	\N
368051	1678	27360856086000	26709	13163	22	0	\N
368052	1678	27360856087000	26709	13163	23	0	\N
368053	1678	27360856088000	26709	13163	24	0	\N
368054	1678	27360856089000	26709	13163	25	0	\N
368055	1678	27360856090000	26709	13163	26	0	\N
368056	1678	27360856091000	26709	13163	27	0	\N
368057	1678	27360856092000	26709	13163	28	0	\N
368058	1678	27360856093000	26709	13163	29	0	\N
368059	1678	27360856094000	26709	13163	30	0	\N
368060	1678	27360856095000	26709	13163	31	0	\N
368061	1678	27360856096000	26709	13163	32	0	\N
368062	1678	27360856097000	26709	13163	33	0	\N
368063	1678	27360856098000	26709	13163	34	0	\N
368064	1678	27360856099000	26709	13163	35	0	\N
368065	1678	27360856100000	26709	13163	36	0	\N
368066	1678	27360856101000	26709	13163	37	0	\N
368067	1678	27360856102000	26709	13163	38	0	\N
368068	1678	27360856103000	26709	13163	39	0	\N
368069	1678	27360856104000	26709	13163	40	0	\N
368070	1678	27360856105000	26709	13163	41	0	\N
368071	1678	27360856106000	26709	13163	42	0	\N
368072	1678	27360856107000	26709	13163	43	0	\N
368073	1678	27360856108000	26709	13163	44	0	\N
368074	1678	27360856109000	26709	13163	45	0	\N
368075	1678	27360856110000	26709	13163	46	0	\N
368076	1678	27360856111000	26709	13163	47	0	\N
368077	1678	27360856112000	26709	13163	48	0	\N
368078	1678	27360856113000	26709	13163	49	0	\N
368079	1678	27360856114000	26709	13163	50	0	\N
368080	1678	27360856115000	26709	13163	51	0	\N
368081	1678	27360856116000	26709	13163	52	0	\N
368082	1678	27360856117000	26709	13163	53	0	\N
368083	1678	27360856118000	26709	13163	54	0	\N
368084	1678	27360856119000	26709	13163	55	0	\N
368085	1678	27360856120000	26709	13163	56	0	\N
368086	1678	27360856121000	26709	13163	57	0	\N
368087	1678	27360856122000	26709	13163	59	0	\N
368088	1678	27360856123000	26709	13163	60	0	\N
368089	1678	27360856124000	26709	13163	61	0	\N
368090	1678	27360856125000	26709	13163	62	0	\N
368091	1678	27360856126000	26709	13163	63	0	\N
368092	1678	27360856127000	26709	13163	64	0	\N
368093	1678	27360856128000	26709	13163	65	0	\N
368094	1678	27360856129000	26709	13163	66	0	\N
368095	1678	27360856130000	26709	13163	67	0	\N
368096	2362	0	26709	13163	68	0	\N
368097	2362	1000000000	26709	13163	69	0	\N
368098	1874	32563000	26709	13163	70	0	\N
368099	1540	0	26709	13163	71	0	\N
368100	2357	100000000	26709	13163	72	0	\N
368101	1874	32565000	26709	13163	73	0	\N
368102	2358	100000000	26709	13163	74	0	\N
368103	2359	100000000	26709	13163	75	0	\N
368104	2360	100000000	26709	13163	76	0	\N
368105	1874	32566000	26709	13163	77	0	\N
368106	1874	32567000	26709	13163	78	0	\N
368107	1874	32568000	26709	13163	79	0	\N
368108	1874	32569000	26709	13163	80	0	\N
368109	1874	32570000	26709	13163	81	0	\N
368110	2361	100000000	26709	13163	82	0	\N
368111	2363	100000000	26709	13163	83	0	\N
368112	1874	32573000	26709	13163	84	0	\N
368113	1874	32576000	26709	13163	85	0	\N
368114	1874	32579000	26709	13163	86	0	\N
368115	1874	32582000	26709	13163	87	0	\N
368116	1874	32585000	26709	13163	88	0	\N
368117	1874	32587000	26709	13163	89	0	\N
368118	1874	32589000	26709	13163	90	0	\N
368119	1874	32591000	26709	13163	91	0	\N
368120	1874	32593000	26709	13163	92	0	\N
368121	1874	32595000	26709	13163	93	0	\N
368122	1874	32597000	26709	13163	94	0	\N
368123	1874	32599000	26709	13163	95	0	\N
368124	2364	100000000	26709	13163	96	0	\N
368125	1874	32601000	26709	13163	97	0	\N
368126	1874	32603000	26709	13163	98	0	\N
368127	1874	32605000	26709	13163	99	0	\N
368128	1874	32607000	26709	13163	100	0	\N
368129	1874	32610000	26709	13163	101	0	\N
368130	1874	32612000	26709	13163	102	0	\N
368131	1874	32614000	26709	13163	103	0	\N
368132	1874	32616000	26709	13163	104	0	\N
368133	1874	32617000	26709	13163	105	0	\N
368134	1874	32618000	26709	13163	106	0	\N
368135	1874	32619000	26709	13163	107	0	\N
368136	1874	32620000	26709	13163	108	0	\N
368137	1874	32621000	26709	13163	109	0	\N
368138	1874	32622000	26709	13163	110	0	\N
368139	1874	32623000	26709	13163	111	0	\N
368140	1874	32624000	26709	13163	112	0	\N
368141	1874	32625000	26709	13163	113	0	\N
368142	1874	32626000	26709	13163	114	0	\N
368143	1874	32627000	26709	13163	115	0	\N
368144	1874	32628000	26709	13163	116	0	\N
368145	1874	32629000	26709	13163	117	0	\N
368146	1874	32630000	26709	13163	118	0	\N
368147	1874	32631000	26709	13163	119	0	\N
368148	1874	32634000	26709	13163	120	0	\N
368149	1874	32637000	26709	13163	121	0	\N
368150	1874	32640000	26709	13163	122	0	\N
368151	1874	32643000	26709	13163	123	0	\N
368152	1874	32646000	26709	13163	124	0	\N
368019	1874	32921000	26707	13209	8	0	2
368020	1874	32923000	26707	13209	9	0	2
368021	1874	32924000	26707	13209	10	0	2
368022	1678	27360856129000	26708	13210	0	0	1
368023	1678	27360856130000	26708	13210	1	0	1
368025	1874	32927000	26708	13210	3	0	2
368026	1874	32930000	26708	13210	4	0	2
368027	1874	32933000	26708	13210	5	0	2
368028	1874	32935000	26708	13210	6	0	2
368153	1874	32649000	26709	13163	125	0	\N
368154	1678	27360856131000	26710	13211	0	0	\N
368155	1874	32938000	26710	13211	1	0	\N
368156	1874	32940000	26710	13211	2	0	\N
368167	1678	27360856134000	26713	13213	0	0	\N
368168	1678	27360856135000	26713	13213	1	0	\N
368169	1874	32954000	26713	13213	2	0	\N
368170	1874	32956000	26713	13213	3	0	\N
368171	1874	32959000	26713	13213	4	0	\N
368172	1874	32961000	26713	13213	5	0	\N
368179	1678	27360856136000	26715	13214	0	0	\N
368180	1874	32963000	26715	13214	1	0	\N
368181	1874	32964000	26715	13214	2	0	\N
368182	1874	32967000	26715	13214	3	0	\N
368187	1678	27360856137000	26717	13215	0	0	\N
368188	1874	32969000	26717	13215	1	0	\N
368189	1874	32972000	26717	13215	2	0	\N
368196	1678	27360856138000	26720	13216	0	0	\N
368197	1874	32975000	26720	13216	1	0	\N
368198	1874	32977000	26720	13216	2	0	\N
368199	1678	27360856138000	26721	13216	0	0	\N
368200	1874	32975000	26721	13216	1	0	\N
368220	1678	27360856145000	26727	13221	0	0	\N
368221	1678	27360856146000	26727	13221	1	0	\N
368222	1874	33009000	26727	13221	2	0	\N
368223	1874	33010000	26727	13221	3	0	\N
368224	1874	33012000	26727	13221	4	0	\N
368225	1874	33014000	26727	13221	5	0	\N
368226	1874	33017000	26727	13221	6	0	\N
368227	1678	27360856145000	26728	13221	0	0	\N
368228	1678	27360856146000	26728	13221	1	0	\N
368229	1874	33009000	26728	13221	2	0	\N
368230	1874	33010000	26728	13221	3	0	\N
368231	1874	33012000	26728	13221	4	0	\N
368232	1874	33014000	26728	13221	5	0	\N
368233	1874	33017000	26728	13221	6	0	\N
368244	1678	27360856147000	26731	13222	0	0	\N
368245	1874	33020000	26731	13222	1	0	\N
368246	1874	33022000	26731	13222	2	0	\N
368247	1678	27360856147000	26732	13222	0	0	\N
368248	1874	33020000	26732	13222	1	0	\N
368249	1874	33022000	26732	13222	2	0	\N
368250	1678	27360856148000	26733	13223	0	0	\N
368251	2365	100000000	26733	13223	1	0	\N
368252	1874	33024000	26733	13223	2	0	\N
368253	2366	100000000	26733	13223	3	0	\N
368254	1874	33027000	26733	13223	4	0	\N
368273	1678	27360856153000	26739	13227	0	0	\N
368274	1874	33050000	26739	13227	1	0	\N
368275	1874	33053000	26739	13227	2	0	\N
368276	1874	33054000	26739	13227	3	0	\N
368277	1678	27360856153000	26740	13227	0	0	\N
368278	1874	33051000	26740	13227	1	0	\N
368279	1874	33052000	26740	13227	2	0	\N
368280	1678	27360856153000	26741	13227	0	0	\N
368281	1874	33050000	26741	13227	1	0	\N
368282	1874	33053000	26741	13227	2	0	\N
368283	1874	33054000	26741	13227	3	0	\N
368284	1678	27360856153000	26742	13227	0	0	\N
368285	1874	33050000	26742	13227	1	0	\N
368286	1874	33053000	26742	13227	2	0	\N
368287	1874	33054000	26742	13227	3	0	\N
368288	1678	27360856153000	26743	13227	0	0	\N
368159	1874	32940000	26711	13211	2	0	2
368160	1678	27360856132000	26712	13212	0	0	1
368161	1678	27360856133000	26712	13212	1	0	1
368162	1874	32943000	26712	13212	2	0	2
368163	1874	32946000	26712	13212	3	0	2
368165	1874	32950000	26712	13212	5	0	2
368166	1874	32951000	26712	13212	6	0	2
368173	1678	27360856134000	26714	13213	0	0	1
368174	1678	27360856135000	26714	13213	1	0	1
368175	1874	32954000	26714	13213	2	0	2
368177	1874	32959000	26714	13213	4	0	2
368178	1874	32961000	26714	13213	5	0	2
368183	1678	27360856136000	26716	13214	0	0	1
368184	1874	32963000	26716	13214	1	0	2
368186	1874	32967000	26716	13214	3	0	2
368190	1678	27360856137000	26718	13215	0	0	1
368191	1874	32969000	26718	13215	1	0	2
368192	1874	32972000	26718	13215	2	0	2
368193	1678	27360856138000	26719	13216	0	0	1
368195	1874	32977000	26719	13216	2	0	2
368201	1678	27360856139000	26722	13217	0	0	1
368202	1874	32978000	26722	13217	1	0	2
368203	1874	32980000	26722	13217	2	0	2
368204	1874	32983000	26722	13217	3	0	2
368206	1678	27360856141000	26724	13218	1	0	1
368207	1678	27360856142000	26724	13218	2	0	1
368208	1874	32985000	26724	13218	3	0	2
368209	1874	32987000	26724	13218	4	0	2
368211	1874	32992000	26724	13218	6	0	2
368212	1874	32995000	26724	13218	7	0	2
368213	1678	27360856143000	26725	13219	0	0	1
368214	1874	32998000	26725	13219	1	0	2
368215	1874	33000000	26725	13219	2	0	2
368217	1678	27360856144000	26726	13220	0	0	1
368218	1874	33004000	26726	13220	1	0	2
368219	1874	33006000	26726	13220	2	0	2
368234	1678	27360856145000	26729	13221	0	0	1
368235	1678	27360856146000	26729	13221	1	0	1
368237	1874	33010000	26729	13221	3	0	2
368238	1874	33012000	26729	13221	4	0	2
368239	1874	33014000	26729	13221	5	0	2
368240	1874	33017000	26729	13221	6	0	2
368242	1874	33020000	26730	13222	1	0	2
368243	1874	33022000	26730	13222	2	0	2
368255	1678	27360856148000	26734	13223	0	0	1
368256	2365	100000000	26734	13223	1	0	0
368257	1874	33024000	26734	13223	2	0	2
368259	1874	33027000	26734	13223	4	0	2
368260	1678	27360856149000	26735	13224	0	0	1
368261	1874	33029000	26735	13224	1	0	2
368262	1874	33030000	26735	13224	2	0	2
368263	1874	33033000	26735	13224	3	0	2
368265	1678	27360856151000	26736	13225	1	0	1
368266	1874	33036000	26736	13225	2	0	2
368267	1874	33038000	26736	13225	3	0	2
368268	1874	33040000	26736	13225	4	0	2
368270	1678	27360856152000	26737	13226	0	0	1
368271	1874	33046000	26737	13226	1	0	2
368272	1874	33048000	26737	13226	2	0	2
368289	1874	33050000	26743	13227	1	0	\N
368290	1874	33053000	26743	13227	2	0	\N
368291	1874	33054000	26743	13227	3	0	\N
368292	1678	27360856153000	26744	13228	0	0	\N
368293	1678	27360856154000	26744	13228	1	0	\N
368294	1874	33050000	26744	13228	2	0	\N
368295	1874	33053000	26744	13228	3	0	\N
368296	1874	33056000	26744	13228	4	0	\N
368297	1874	33058000	26744	13228	5	0	\N
368298	1874	33059000	26744	13228	6	0	\N
368313	2362	0	26747	13125	0	0	\N
368314	2362	1000000000	26747	13125	1	0	\N
368315	2346	190000000	26747	13125	2	0	\N
368316	1540	0	26747	13125	3	0	\N
368317	2357	100000000	26747	13125	4	0	\N
368318	2346	289000000	26747	13125	5	0	\N
368319	2358	100000000	26747	13125	6	0	\N
368320	2359	100000000	26747	13125	7	0	\N
368321	2360	100000000	26747	13125	8	0	\N
368322	2346	388000000	26747	13125	9	0	\N
368323	2361	100000000	26747	13125	10	0	\N
368324	2363	100000000	26747	13125	11	0	\N
368325	2364	100000000	26747	13125	12	0	\N
368326	2365	100000000	26747	13125	13	0	\N
368327	2366	100000000	26747	13125	14	0	\N
368328	1678	27360856157000	26748	13230	0	0	\N
368329	1874	33072000	26748	13230	1	0	\N
368330	1874	33075000	26748	13230	2	0	\N
368334	1678	27360856158000	26750	13231	0	0	\N
368335	1874	33077000	26750	13231	1	0	\N
368336	1874	33080000	26750	13231	2	0	\N
368340	1874	33077000	26752	13231	0	0	\N
368341	1874	33080000	26752	13231	1	0	\N
368342	2362	0	26753	13138	0	0	\N
368343	2362	1000000000	26753	13138	1	0	\N
368344	2346	190000000	26753	13138	2	0	\N
368345	1540	0	26753	13138	3	0	\N
368346	2357	100000000	26753	13138	4	0	\N
368347	2346	289000000	26753	13138	5	0	\N
368348	2358	100000000	26753	13138	6	0	\N
368349	2359	100000000	26753	13138	7	0	\N
368350	2360	100000000	26753	13138	8	0	\N
368351	2346	388000000	26753	13138	9	0	\N
368352	2361	100000000	26753	13138	10	0	\N
368353	2363	100000000	26753	13138	11	0	\N
368354	2364	100000000	26753	13138	12	0	\N
368355	2365	100000000	26753	13138	13	0	\N
368356	2366	100000000	26753	13138	14	0	\N
368357	2362	0	26754	13148	0	0	\N
368358	2362	1000000000	26754	13148	1	0	\N
368359	2346	190000000	26754	13148	2	0	\N
368360	1540	0	26754	13148	3	0	\N
368361	2357	100000000	26754	13148	4	0	\N
368362	2346	289000000	26754	13148	5	0	\N
368363	2358	100000000	26754	13148	6	0	\N
368364	2359	100000000	26754	13148	7	0	\N
368365	2360	100000000	26754	13148	8	0	\N
368366	2346	388000000	26754	13148	9	0	\N
368367	2361	100000000	26754	13148	10	0	\N
368368	2363	100000000	26754	13148	11	0	\N
368369	2364	100000000	26754	13148	12	0	\N
368370	2365	100000000	26754	13148	13	0	\N
368371	2366	100000000	26754	13148	14	0	\N
368376	2362	0	26756	13157	0	0	\N
368377	2362	1000000000	26756	13157	1	0	\N
368378	1540	0	26756	13157	2	0	\N
368379	2357	100000000	26756	13157	3	0	\N
368380	2358	100000000	26756	13157	4	0	\N
368381	2359	100000000	26756	13157	5	0	\N
368382	2360	100000000	26756	13157	6	0	\N
368383	2361	100000000	26756	13157	7	0	\N
368384	2363	100000000	26756	13157	8	0	\N
368385	2364	100000000	26756	13157	9	0	\N
368386	2365	100000000	26756	13157	10	0	\N
368387	2366	100000000	26756	13157	11	0	\N
368388	1540	0	26757	13185	0	0	\N
368389	2363	100000000	26757	13185	1	0	\N
368390	2364	100000000	26757	13185	2	0	\N
368391	2365	100000000	26757	13185	3	0	\N
368392	2366	100000000	26757	13185	4	0	\N
368393	1678	27360856160000	26758	13233	0	0	\N
368394	1678	27360856161000	26758	13233	1	0	\N
368395	1874	33089000	26758	13233	2	0	\N
368396	1874	33091000	26758	13233	3	0	\N
368397	1874	33093000	26758	13233	4	0	\N
368398	1874	33096000	26758	13233	5	0	\N
368412	1678	27360856164000	26764	13236	0	0	\N
368413	1678	27360856165000	26764	13236	1	0	\N
368414	1678	27360856166000	26764	13236	2	0	\N
368415	1874	33110000	26764	13236	3	0	\N
368416	1874	33112000	26764	13236	4	0	\N
368417	1874	33114000	26764	13236	5	0	\N
368418	1874	33116000	26764	13236	6	0	\N
368419	1874	33119000	26764	13236	7	0	\N
368420	1874	33122000	26764	13236	8	0	\N
368421	1874	33123000	26764	13236	9	0	\N
368422	1678	27360856164000	26765	13236	0	0	\N
368423	1678	27360856165000	26765	13236	1	0	\N
368424	1678	27360856166000	26765	13236	2	0	\N
368301	1874	33050000	26745	13228	2	0	2
368302	1874	33053000	26745	13228	3	0	2
368303	1874	33056000	26745	13228	4	0	2
368304	1874	33058000	26745	13228	5	0	2
368305	1874	33059000	26745	13228	6	0	2
368307	1678	27360856156000	26746	13229	1	0	1
368308	1874	33061000	26746	13229	2	0	2
368309	1874	33062000	26746	13229	3	0	2
368310	1874	33065000	26746	13229	4	0	2
368311	1874	33068000	26746	13229	5	0	2
368331	1678	27360856157000	26749	13230	0	0	1
368332	1874	33072000	26749	13230	1	0	2
368333	1874	33075000	26749	13230	2	0	2
368337	1678	27360856158000	26751	13231	0	0	1
368339	1874	33080000	26751	13231	2	0	2
368372	1678	27360856159000	26755	13232	0	0	1
368373	1874	33081000	26755	13232	1	0	2
368374	1874	33083000	26755	13232	2	0	2
368375	1874	33086000	26755	13232	3	0	2
368400	1678	27360856161000	26760	13233	1	0	1
368401	1874	33089000	26760	13233	2	0	2
368402	1874	33091000	26760	13233	3	0	2
368403	1874	33093000	26760	13233	4	0	2
368404	1874	33096000	26760	13233	5	0	2
368406	1874	33099000	26762	13234	1	0	2
368407	1874	33101000	26762	13234	2	0	2
368408	1678	27360856163000	26763	13235	0	0	1
368409	1874	33103000	26763	13235	1	0	2
368411	1874	33107000	26763	13235	3	0	2
368425	1874	33110000	26765	13236	3	0	\N
368426	1874	33113000	26765	13236	4	0	\N
368427	1874	33116000	26765	13236	5	0	\N
368428	1874	33117000	26765	13236	6	0	\N
368439	1678	27360856164000	26767	13236	0	0	\N
368440	1678	27360856165000	26767	13236	1	0	\N
368441	1678	27360856166000	26767	13236	2	0	\N
368442	1874	33110000	26767	13236	3	0	\N
368443	1874	33112000	26767	13236	4	0	\N
368444	1874	33114000	26767	13236	5	0	\N
368445	1874	33116000	26767	13236	6	0	\N
368446	1874	33119000	26767	13236	7	0	\N
368447	1874	33122000	26767	13236	8	0	\N
368448	1874	33123000	26767	13236	9	0	\N
368481	1678	27360856171000	26771	13239	0	0	\N
368482	1678	27360856172000	26771	13239	1	0	\N
368483	1678	27360856173000	26771	13239	2	0	\N
368484	1678	27360856174000	26771	13239	3	0	\N
368485	1678	27360856175000	26771	13239	4	0	\N
368486	1678	27360856176000	26771	13239	5	0	\N
368487	1874	33143000	26771	13239	6	0	\N
368488	1874	33144000	26771	13239	7	0	\N
368489	1874	33145000	26771	13239	8	0	\N
368490	1874	33147000	26771	13239	9	0	\N
368491	1874	33149000	26771	13239	10	0	\N
368492	1874	33151000	26771	13239	11	0	\N
368493	1874	33153000	26771	13239	12	0	\N
368494	1874	33155000	26771	13239	13	0	\N
368495	1874	33158000	26771	13239	14	0	\N
368496	1874	33161000	26771	13239	15	0	\N
368497	1874	33164000	26771	13239	16	0	\N
368498	1874	33167000	26771	13239	17	0	\N
368499	1874	33170000	26771	13239	18	0	\N
368500	1874	33173000	26771	13239	19	0	\N
368501	1678	27360856177000	26772	13240	0	0	\N
368502	1678	27360856178000	26772	13240	1	0	\N
368503	1874	33175000	26772	13240	2	0	\N
368504	1874	33177000	26772	13240	3	0	\N
368505	1874	33180000	26772	13240	4	0	\N
368506	1874	33183000	26772	13240	5	0	\N
368507	1678	27360856177000	26773	13240	0	0	\N
368508	1678	27360856178000	26773	13240	1	0	\N
368509	1874	33175000	26773	13240	2	0	\N
368510	1874	33177000	26773	13240	3	0	\N
368511	1874	33180000	26773	13240	4	0	\N
368512	1874	33183000	26773	13240	5	0	\N
368519	1678	26640830965000	26775	13067	0	0	\N
368520	1678	26640830966000	26775	13067	1	0	\N
368521	1678	26640830967000	26775	13067	2	0	\N
368522	1678	26640830968000	26775	13067	3	0	\N
368523	1678	26640830969000	26775	13067	4	0	\N
368524	1678	26640830970000	26775	13067	5	0	\N
368525	1678	26640830971000	26775	13067	6	0	\N
368526	1678	26640830972000	26775	13067	7	0	\N
368527	1678	26640830973000	26775	13067	8	0	\N
368528	1678	26640830974000	26775	13067	9	0	\N
368529	1678	26640830975000	26775	13067	10	0	\N
368530	1678	26640830976000	26775	13067	11	0	\N
368531	1678	26640830977000	26775	13067	12	0	\N
368532	1678	26640830978000	26775	13067	13	0	\N
368533	1678	26640830979000	26775	13067	14	0	\N
368534	1678	26640830980000	26775	13067	15	0	\N
368535	1678	26640830981000	26775	13067	16	0	\N
368536	1678	26640830982000	26775	13067	17	0	\N
368537	1678	26640830983000	26775	13067	18	0	\N
368538	1678	26640830984000	26775	13067	19	0	\N
368539	1678	26640830985000	26775	13067	20	0	\N
368540	1678	26640830986000	26775	13067	21	0	\N
368541	1678	26640830987000	26775	13067	22	0	\N
368542	1678	26640830988000	26775	13067	23	0	\N
368543	1678	26640830989000	26775	13067	24	0	\N
368544	1678	26640830990000	26775	13067	25	0	\N
368545	1678	26640830991000	26775	13067	26	0	\N
368546	1678	26640830992000	26775	13067	27	0	\N
368547	1678	26640830993000	26775	13067	28	0	\N
368548	1678	26640830994000	26775	13067	29	0	\N
368549	1678	26640830995000	26775	13067	30	0	\N
368550	1678	26640830996000	26775	13067	31	0	\N
368551	1678	26640830997000	26775	13067	32	0	\N
368552	1678	26640830998000	26775	13067	33	0	\N
368553	1678	26640830999000	26775	13067	34	0	\N
368554	1678	26640831000000	26775	13067	35	0	\N
368555	1678	26640831001000	26775	13067	36	0	\N
368556	1678	26640831002000	26775	13067	37	0	\N
368557	1678	26640831003000	26775	13067	38	0	\N
368558	1678	26640831004000	26775	13067	39	0	\N
368559	1678	26640831005000	26775	13067	40	0	\N
368560	1678	26640831006000	26775	13067	41	0	\N
368431	1678	27360856166000	26766	13236	2	0	1
368432	1874	33110000	26766	13236	3	0	2
368433	1874	33112000	26766	13236	4	0	2
368434	1874	33114000	26766	13236	5	0	2
368435	1874	33116000	26766	13236	6	0	2
368437	1874	33122000	26766	13236	8	0	2
368438	1874	33123000	26766	13236	9	0	2
368449	1678	27360856167000	26768	13237	0	0	1
368450	1678	27360856168000	26768	13237	1	0	1
368451	1874	33126000	26768	13237	2	0	2
368453	1874	33130000	26768	13237	4	0	2
368454	1874	33133000	26768	13237	5	0	2
368455	1678	27360856169000	26769	13238	0	0	1
368456	1678	27360856170000	26769	13238	1	0	1
368458	1874	33136000	26769	13238	3	0	2
368459	1874	33138000	26769	13238	4	0	2
368460	1874	33141000	26769	13238	5	0	2
368461	1678	27360856171000	26770	13239	0	0	1
368462	1678	27360856172000	26770	13239	1	0	1
368464	1678	27360856174000	26770	13239	3	0	1
368465	1678	27360856175000	26770	13239	4	0	1
368466	1678	27360856176000	26770	13239	5	0	1
368467	1874	33143000	26770	13239	6	0	2
368468	1874	33144000	26770	13239	7	0	2
368470	1874	33147000	26770	13239	9	0	2
368471	1874	33149000	26770	13239	10	0	2
368472	1874	33151000	26770	13239	11	0	2
368473	1874	33153000	26770	13239	12	0	2
368475	1874	33158000	26770	13239	14	0	2
368476	1874	33161000	26770	13239	15	0	2
368477	1874	33164000	26770	13239	16	0	2
368478	1874	33167000	26770	13239	17	0	2
368479	1874	33170000	26770	13239	18	0	2
368513	1678	27360856177000	26774	13240	0	0	1
368514	1678	27360856178000	26774	13240	1	0	1
368515	1874	33175000	26774	13240	2	0	2
368516	1874	33177000	26774	13240	3	0	2
368517	1874	33180000	26774	13240	4	0	2
368561	1678	26640831007000	26775	13067	42	0	\N
368562	1678	26640831008000	26775	13067	43	0	\N
368563	1678	26640831009000	26775	13067	44	0	\N
368564	1678	26640831010000	26775	13067	45	0	\N
368565	1678	26640831011000	26775	13067	46	0	\N
368566	1678	26640831012000	26775	13067	47	0	\N
368567	1678	26640831013000	26775	13067	48	0	\N
368568	1678	26640831014000	26775	13067	49	0	\N
368569	1678	26640831015000	26775	13067	50	0	\N
368570	1678	26640831016000	26775	13067	51	0	\N
368571	1678	26640831017000	26775	13067	52	0	\N
368572	1678	26640831018000	26775	13067	53	0	\N
368573	1678	26640831019000	26775	13067	54	0	\N
368574	1678	26640831020000	26775	13067	55	0	\N
368575	1678	26640831021000	26775	13067	56	0	\N
368576	1678	26640831022000	26775	13067	57	0	\N
368577	1678	26640831023000	26775	13067	58	0	\N
368578	1678	26640831024000	26775	13067	59	0	\N
368579	1678	26640831025000	26775	13067	60	0	\N
368580	1678	26640831026000	26775	13067	61	0	\N
368581	1678	26640831027000	26775	13067	62	0	\N
368582	1678	26640831028000	26775	13067	63	0	\N
368583	1678	26640831029000	26775	13067	64	0	\N
368584	1678	26640831030000	26775	13067	65	0	\N
368585	1678	26640831031000	26775	13067	66	0	\N
368586	1678	26640831032000	26775	13067	67	0	\N
368587	1678	26640831033000	26775	13067	68	0	\N
368588	1678	26640831034000	26775	13067	69	0	\N
368589	1678	26640831035000	26775	13067	70	0	\N
368590	1678	26640831036000	26775	13067	71	0	\N
368591	1678	26640831037000	26775	13067	72	0	\N
368592	1678	26640831038000	26775	13067	73	0	\N
368593	1678	26640831039000	26775	13067	74	0	\N
368594	1678	26640831040000	26775	13067	75	0	\N
368595	1678	26640831041000	26775	13067	76	0	\N
368596	1678	26640831042000	26775	13067	77	0	\N
368597	1678	26640831043000	26775	13067	78	0	\N
368598	1678	26640831044000	26775	13067	79	0	\N
368599	1678	26640831045000	26775	13067	80	0	\N
368600	1678	26640831046000	26775	13067	81	0	\N
368601	1678	26640831047000	26775	13067	82	0	\N
368602	1678	26640831048000	26775	13067	83	0	\N
368603	1678	26640831049000	26775	13067	84	0	\N
368604	1678	26640831050000	26775	13067	86	0	\N
368605	1678	26640831051000	26775	13067	87	0	\N
368606	1678	26640831052000	26775	13067	88	0	\N
368607	1678	26640831053000	26775	13067	89	0	\N
368608	1678	26640831054000	26775	13067	90	0	\N
368609	1678	26640831055000	26775	13067	91	0	\N
368610	1678	26640831056000	26775	13067	92	0	\N
368611	1678	26640831057000	26775	13067	93	0	\N
368612	1678	26640831058000	26775	13067	94	0	\N
368613	1678	26640831059000	26775	13067	95	0	\N
368614	1678	26640831060000	26775	13067	96	0	\N
368615	1678	26640831061000	26775	13067	97	0	\N
368616	1678	26640831062000	26775	13067	98	0	\N
368617	1678	26640831063000	26775	13067	99	0	\N
368618	1678	26640831064000	26775	13067	100	0	\N
368619	1678	26640831065000	26775	13067	101	0	\N
368620	1678	26640831066000	26775	13067	102	0	\N
368621	1678	26640831067000	26775	13067	103	0	\N
368622	1678	26640831068000	26775	13067	104	0	\N
368623	1678	26640831069000	26775	13067	105	0	\N
368624	1678	26640831070000	26775	13067	106	0	\N
368625	1678	26640831071000	26775	13067	107	0	\N
368626	1678	26640831072000	26775	13067	108	0	\N
368627	1678	26640831073000	26775	13067	109	0	\N
368628	1678	26640831074000	26775	13067	110	0	\N
368629	1678	26640831075000	26775	13067	111	0	\N
368630	1678	26640831076000	26775	13067	112	0	\N
368631	1678	26640831077000	26775	13067	113	0	\N
368632	1678	26640831078000	26775	13067	114	0	\N
368633	1678	26640831079000	26775	13067	115	0	\N
368634	1678	26640831080000	26775	13067	116	0	\N
368635	1678	26640831081000	26775	13067	117	0	\N
368636	1678	26640831082000	26775	13067	118	0	\N
368637	1678	26640831083000	26775	13067	119	0	\N
368638	1678	26640831084000	26775	13067	120	0	\N
368639	1678	26640831085000	26775	13067	121	0	\N
368640	1678	26640831086000	26775	13067	122	0	\N
368641	1678	26640831087000	26775	13067	123	0	\N
368642	1678	26640831088000	26775	13067	124	0	\N
368643	1678	26640831089000	26775	13067	125	0	\N
368644	1678	26640830965000	26776	13029	0	0	\N
368645	1678	26640830966000	26776	13029	1	0	\N
368646	1678	26640830967000	26776	13029	2	0	\N
368647	1678	26640830968000	26776	13029	3	0	\N
368648	1678	26640830969000	26776	13029	4	0	\N
368649	1678	26640830970000	26776	13029	5	0	\N
368650	1678	26640830971000	26776	13029	6	0	\N
368651	1678	26640830972000	26776	13029	7	0	\N
368652	1678	26640830973000	26776	13029	8	0	\N
368653	1678	26640830974000	26776	13029	9	0	\N
368654	1678	26640830975000	26776	13029	10	0	\N
368655	1678	26640830976000	26776	13029	11	0	\N
368656	1678	26640830977000	26776	13029	12	0	\N
368657	1678	26640830978000	26776	13029	13	0	\N
368658	1678	26640830979000	26776	13029	14	0	\N
368659	1678	26640830980000	26776	13029	15	0	\N
368660	1678	26640830981000	26776	13029	16	0	\N
368661	1678	26640830982000	26776	13029	17	0	\N
368662	1678	26640830983000	26776	13029	18	0	\N
368663	1678	26640830984000	26776	13029	19	0	\N
368664	1678	26640830985000	26776	13029	20	0	\N
368665	1678	26640830986000	26776	13029	21	0	\N
368666	1678	26640830987000	26776	13029	22	0	\N
368667	1678	26640830988000	26776	13029	23	0	\N
368668	1678	26640830989000	26776	13029	24	0	\N
368669	1678	26640830990000	26776	13029	25	0	\N
368670	1678	26640830991000	26776	13029	26	0	\N
368671	1678	26640830992000	26776	13029	27	0	\N
368672	1678	26640830993000	26776	13029	28	0	\N
368673	1678	26640830994000	26776	13029	29	0	\N
368674	1678	26640830995000	26776	13029	30	0	\N
368675	1678	26640830996000	26776	13029	31	0	\N
368676	1678	26640830997000	26776	13029	32	0	\N
368677	1678	26640830998000	26776	13029	33	0	\N
368678	1678	26640830999000	26776	13029	34	0	\N
368679	1678	26640831000000	26776	13029	35	0	\N
368680	1678	26640831001000	26776	13029	36	0	\N
368681	1678	26640831002000	26776	13029	37	0	\N
368682	1678	26640831003000	26776	13029	38	0	\N
368683	1678	26640831004000	26776	13029	39	0	\N
368684	1678	26640831005000	26776	13029	40	0	\N
368685	1678	26640831006000	26776	13029	41	0	\N
368686	1678	26640831007000	26776	13029	42	0	\N
368687	1678	26640831008000	26776	13029	43	0	\N
368688	1678	26640831009000	26776	13029	44	0	\N
368689	1678	26640831010000	26776	13029	45	0	\N
368690	1678	26640831011000	26776	13029	46	0	\N
368691	1678	26640831012000	26776	13029	47	0	\N
368692	1678	26640831013000	26776	13029	48	0	\N
368693	1678	26640831014000	26776	13029	49	0	\N
368694	1678	26640831015000	26776	13029	50	0	\N
368695	1678	26640831016000	26776	13029	51	0	\N
368696	1678	26640831017000	26776	13029	52	0	\N
368697	1678	26640831018000	26776	13029	53	0	\N
368698	1678	26640831019000	26776	13029	54	0	\N
368699	1678	26640831020000	26776	13029	55	0	\N
368700	1678	26640831021000	26776	13029	57	0	\N
368701	1678	26640831022000	26776	13029	58	0	\N
368702	1678	26640831023000	26776	13029	59	0	\N
368703	1678	26640831024000	26776	13029	60	0	\N
368704	1678	26640831025000	26776	13029	61	0	\N
368705	1678	26640831026000	26776	13029	62	0	\N
368706	1678	26640831027000	26776	13029	63	0	\N
368707	1678	26640831028000	26776	13029	64	0	\N
368708	1678	26640831029000	26776	13029	65	0	\N
368709	1678	26640831030000	26776	13029	66	0	\N
368710	1678	26640831031000	26776	13029	67	0	\N
368711	1678	26640831032000	26776	13029	68	0	\N
368712	1678	26640831033000	26776	13029	69	0	\N
368713	1678	26640831034000	26776	13029	70	0	\N
368714	1678	26640831035000	26776	13029	71	0	\N
368715	1678	26640831036000	26776	13029	72	0	\N
368716	1678	26640831037000	26776	13029	73	0	\N
368717	1678	26640831038000	26776	13029	74	0	\N
368718	1678	26640831039000	26776	13029	75	0	\N
368719	1678	26640831040000	26776	13029	76	0	\N
368720	1678	26640831041000	26776	13029	77	0	\N
368721	1678	26640831042000	26776	13029	78	0	\N
368722	1678	26640831043000	26776	13029	79	0	\N
368723	1678	26640831044000	26776	13029	80	0	\N
368724	1678	26640831045000	26776	13029	81	0	\N
368725	1678	26640831046000	26776	13029	82	0	\N
368726	1678	26640831047000	26776	13029	83	0	\N
368727	1678	26640831048000	26776	13029	84	0	\N
368728	1678	26640831049000	26776	13029	85	0	\N
368729	1678	26640831050000	26776	13029	86	0	\N
368730	1678	26640831051000	26776	13029	87	0	\N
368731	1678	26640831052000	26776	13029	88	0	\N
368732	1678	26640831053000	26776	13029	89	0	\N
368733	1678	26640831054000	26776	13029	90	0	\N
368734	1678	26640831055000	26776	13029	91	0	\N
368735	1678	26640831056000	26776	13029	92	0	\N
368736	1678	26640831057000	26776	13029	93	0	\N
368737	1678	26640831058000	26776	13029	94	0	\N
368738	1678	26640831059000	26776	13029	95	0	\N
368739	1678	26640831060000	26776	13029	96	0	\N
368740	1678	26640831061000	26776	13029	97	0	\N
368741	1678	26640831062000	26776	13029	98	0	\N
368742	1678	26640831063000	26776	13029	99	0	\N
368743	1678	26640831064000	26776	13029	100	0	\N
368744	1678	26640831065000	26776	13029	101	0	\N
368745	1678	26640831066000	26776	13029	102	0	\N
368746	1678	26640831067000	26776	13029	103	0	\N
368747	1678	26640831068000	26776	13029	104	0	\N
368748	1678	26640831069000	26776	13029	105	0	\N
368749	1678	26640831070000	26776	13029	106	0	\N
368750	1678	26640831071000	26776	13029	107	0	\N
368751	1678	26640831072000	26776	13029	108	0	\N
368752	1678	26640831073000	26776	13029	109	0	\N
368753	1678	26640831074000	26776	13029	110	0	\N
368754	1678	26640831075000	26776	13029	111	0	\N
368755	1678	26640831076000	26776	13029	112	0	\N
368756	1678	26640831077000	26776	13029	113	0	\N
368757	1678	26640831078000	26776	13029	114	0	\N
368758	1678	26640831079000	26776	13029	115	0	\N
368759	1678	26640831080000	26776	13029	116	0	\N
368760	1678	26640831081000	26776	13029	117	0	\N
368761	1678	26640831082000	26776	13029	118	0	\N
368762	1678	26640831083000	26776	13029	119	0	\N
368763	1678	26640831084000	26776	13029	120	0	\N
368764	1678	26640831085000	26776	13029	121	0	\N
368765	1678	26640831086000	26776	13029	122	0	\N
368766	1678	26640831087000	26776	13029	123	0	\N
368767	1678	26640831088000	26776	13029	124	0	\N
368768	1678	26640831089000	26776	13029	125	0	\N
368788	2367	100000000	26780	13243	0	0	\N
368789	2368	100000000	26780	13243	1	0	\N
368790	1874	33195000	26780	13243	2	0	\N
368791	1678	27360856184000	26781	13244	0	0	\N
368792	1874	33212000	26781	13244	1	0	\N
368793	1874	33215000	26781	13244	2	0	\N
368797	1678	27360856185000	26783	13245	0	0	\N
368798	1874	33217000	26783	13245	1	0	\N
368799	1874	33220000	26783	13245	2	0	\N
368800	2362	0	26784	13094	0	0	\N
368801	2362	1000000000	26784	13094	1	0	\N
368802	1540	0	26784	13094	2	0	\N
368803	2346	289000000	26784	13094	3	0	\N
368804	2346	388000000	26784	13094	4	0	\N
368805	1874	32046000	26784	13094	5	0	\N
368806	1874	32047000	26784	13094	6	0	\N
368807	1874	32048000	26784	13094	7	0	\N
368808	1874	32049000	26784	13094	8	0	\N
368809	1874	32050000	26784	13094	9	0	\N
368810	1874	32051000	26784	13094	10	0	\N
368811	1874	32052000	26784	13094	11	0	\N
368812	1874	32053000	26784	13094	12	0	\N
368813	1874	32054000	26784	13094	13	0	\N
368814	1874	32055000	26784	13094	14	0	\N
368815	1874	32056000	26784	13094	15	0	\N
368816	1874	32057000	26784	13094	16	0	\N
368817	1874	32058000	26784	13094	17	0	\N
368818	1874	32059000	26784	13094	18	0	\N
368822	1678	27360856186000	26786	13246	0	0	\N
368823	1874	33222000	26786	13246	1	0	\N
368824	1874	33223000	26786	13246	2	0	\N
368825	1874	33226000	26786	13246	3	0	\N
368826	1678	27360856186000	26787	13246	0	0	\N
368827	1874	33222000	26787	13246	1	0	\N
368828	1874	33223000	26787	13246	2	0	\N
368829	1874	33226000	26787	13246	3	0	\N
368771	1874	33187000	26777	13241	2	0	2
368772	1874	33189000	26777	13241	3	0	2
368773	1678	27360856180000	26778	13242	0	0	1
368774	1874	33192000	26778	13242	1	0	2
368775	1874	33194000	26778	13242	2	0	2
368777	1678	27360856182000	26779	13243	1	0	1
368778	1678	27360856183000	26779	13243	2	0	1
368779	1874	33196000	26779	13243	3	0	2
368780	1874	33199000	26779	13243	5	0	2
368781	2367	100000000	26779	13243	6	0	0
368783	1874	33201000	26779	13243	8	0	2
368784	1874	33203000	26779	13243	9	0	2
368785	1874	33206000	26779	13243	10	0	2
368786	1874	33209000	26779	13243	11	0	2
368794	1678	27360856184000	26782	13244	0	0	1
368795	1874	33212000	26782	13244	1	0	2
368796	1874	33215000	26782	13244	2	0	2
368819	1678	27360856185000	26785	13245	0	0	1
368820	1874	33217000	26785	13245	1	0	2
368830	1678	27360856186000	26788	13246	0	0	1
368831	1874	33222000	26788	13246	1	0	2
368832	1874	33223000	26788	13246	2	0	2
368834	1678	27360856187000	26789	13247	0	0	\N
368835	1874	33228000	26789	13247	1	0	\N
368836	1874	33231000	26789	13247	2	0	\N
368840	1678	27360856187000	26791	13247	0	0	\N
368841	1874	33228000	26791	13247	1	0	\N
368842	1874	33231000	26791	13247	2	0	\N
368853	1678	27360856191000	26793	13249	0	0	\N
368854	1874	33250000	26793	13249	1	0	\N
368855	1874	33252000	26793	13249	2	0	\N
368856	1678	27360856191000	26794	13249	0	0	\N
368857	1874	33250000	26794	13249	1	0	\N
368858	1874	33252000	26794	13249	2	0	\N
368859	1678	27360856191000	26795	13249	0	0	\N
368860	1874	33250000	26795	13249	1	0	\N
368861	1874	33252000	26795	13249	2	0	\N
368865	1678	27360856192000	26797	13250	0	0	\N
368866	1874	33254000	26797	13250	1	0	\N
368873	1678	27360856194000	26800	13252	0	0	\N
368874	1874	33262000	26800	13252	1	0	\N
368875	1874	33265000	26800	13252	2	0	\N
368882	1678	27360856195000	26803	13253	0	0	\N
368883	1874	33267000	26803	13253	1	0	\N
368884	1874	33270000	26803	13253	2	0	\N
368906	1678	27360856202000	26808	13258	0	0	\N
368907	1874	33304000	26808	13258	1	0	\N
368908	1874	33307000	26808	13258	2	0	\N
368909	1678	27360856202000	26809	13258	0	0	\N
368910	1874	33304000	26809	13258	1	0	\N
368911	1874	33307000	26809	13258	2	0	\N
368912	1678	27360856202000	26810	13258	0	0	\N
368913	1874	33304000	26810	13258	1	0	\N
368914	1874	33307000	26810	13258	2	0	\N
368925	1678	27360856203000	26813	13259	0	0	\N
368926	1678	27360856204000	26813	13259	1	0	\N
368927	1874	33308000	26813	13259	2	0	\N
368928	1874	33310000	26813	13259	3	0	\N
368929	1874	33312000	26813	13259	4	0	\N
368930	1874	33315000	26813	13259	5	0	\N
368931	1874	33318000	26813	13259	6	0	\N
368945	1678	27360856209000	26815	13261	0	0	\N
368946	1874	33342000	26815	13261	2	0	\N
368947	1874	33343000	26815	13261	3	0	\N
368948	1874	33345000	26815	13261	4	0	\N
368956	1483	11000000	26818	13262	0	0	\N
368957	1678	27360856210000	26818	13262	1	0	\N
368958	1874	33348000	26818	13262	2	0	\N
368959	1874	33350000	26818	13262	3	0	\N
368960	1678	27360856210000	26819	13263	0	0	\N
368961	1678	27360856211000	26819	13263	1	0	\N
368962	1874	33353000	26819	13263	2	0	\N
368963	1874	33355000	26819	13263	3	0	\N
368968	1678	27360856035000	26821	13144	0	0	\N
368838	1874	33228000	26790	13247	1	0	2
368839	1874	33231000	26790	13247	2	0	2
368843	1678	27360856188000	26792	13248	0	0	1
368844	1678	27360856189000	26792	13248	1	0	1
368845	1678	27360856190000	26792	13248	2	0	1
368847	1874	33234000	26792	13248	4	0	2
368848	1874	33236000	26792	13248	5	0	2
368849	1874	33238000	26792	13248	6	0	2
368850	1874	33241000	26792	13248	7	0	2
368851	1874	33244000	26792	13248	8	0	2
368862	1678	27360856191000	26796	13249	0	0	1
368863	1874	33250000	26796	13249	1	0	2
368864	1874	33252000	26796	13249	2	0	2
368867	1678	27360856192000	26798	13250	0	0	1
368869	1678	27360856193000	26799	13251	0	0	1
368870	1874	33255000	26799	13251	1	0	2
368871	1874	33258000	26799	13251	2	0	2
368872	1874	33260000	26799	13251	3	0	2
368876	1678	27360856194000	26801	13252	0	0	1
368878	1874	33265000	26801	13252	2	0	2
368879	1678	27360856195000	26802	13253	0	0	1
368880	1874	33267000	26802	13253	1	0	2
368881	1874	33270000	26802	13253	2	0	2
368885	1678	27360856196000	26804	13254	0	0	1
368887	1874	33275000	26804	13254	2	0	2
368888	1874	33276000	26804	13254	3	0	2
368889	134	66000100000000	26805	13255	0	0	0
368890	1678	27360856197000	26805	13255	1	0	1
368892	1874	33281000	26805	13255	3	0	2
368893	1678	27360856198000	26806	13256	0	0	1
368894	1678	27360856199000	26806	13256	1	0	1
368895	1678	27360856200000	26806	13256	2	0	1
368896	1874	33282000	26806	13256	3	0	2
368898	1874	33286000	26806	13256	5	0	2
368899	1874	33289000	26806	13256	6	0	2
368900	1874	33292000	26806	13256	7	0	2
368901	1874	33295000	26806	13256	8	0	2
368902	1874	33297000	26806	13256	9	0	2
368904	1874	33300000	26807	13257	1	0	2
368905	1874	33302000	26807	13257	2	0	2
368915	1678	27360856202000	26811	13258	0	0	1
368916	1874	33304000	26811	13258	1	0	2
368918	1678	27360856203000	26812	13259	0	0	1
368919	1678	27360856204000	26812	13259	1	0	1
368920	1874	33308000	26812	13259	2	0	2
368921	1874	33310000	26812	13259	3	0	2
368922	1874	33312000	26812	13259	4	0	2
368924	1874	33318000	26812	13259	6	0	2
368932	1678	27360856205000	26814	13260	0	0	1
368933	1678	27360856206000	26814	13260	1	0	1
368934	1678	27360856207000	26814	13260	2	0	1
368935	1678	27360856208000	26814	13260	3	0	1
368937	1874	33322000	26814	13260	5	0	2
368938	1874	33325000	26814	13260	6	0	2
368939	1874	33328000	26814	13260	7	0	2
368940	1874	33331000	26814	13260	8	0	2
368942	1874	33335000	26814	13260	10	0	2
368943	1874	33337000	26814	13260	11	0	2
368944	1874	33339000	26814	13260	12	0	2
368949	1678	27360856209000	26816	13261	0	0	1
368950	1874	33342000	26816	13261	2	0	2
368952	1874	33345000	26816	13261	4	0	2
368953	1483	11000000	26817	13262	0	0	0
368954	1874	33348000	26817	13262	1	0	2
368955	1874	33350000	26817	13262	2	0	2
368964	1678	27360856210000	26820	13263	0	0	1
368966	1874	33353000	26820	13263	2	0	2
368967	1874	33355000	26820	13263	3	0	2
368969	1678	27360856036000	26821	13144	1	0	\N
368970	1678	27360856037000	26821	13144	2	0	\N
368971	1678	27360856038000	26821	13144	3	0	\N
368972	1678	27360856039000	26821	13144	4	0	\N
368973	1678	27360856040000	26821	13144	5	0	\N
368974	1678	27360856041000	26821	13144	6	0	\N
368975	1678	27360856042000	26821	13144	7	0	\N
368976	1678	27360856043000	26821	13144	8	0	\N
368977	1678	27360856044000	26821	13144	9	0	\N
368978	1678	27360856045000	26821	13144	10	0	\N
368979	1678	27360856046000	26821	13144	11	0	\N
368980	1678	27360856047000	26821	13144	12	0	\N
368981	1678	27360856048000	26821	13144	13	0	\N
368982	1678	27360856049000	26821	13144	14	0	\N
368983	1678	27360856050000	26821	13144	15	0	\N
368984	1678	27360856051000	26821	13144	16	0	\N
368985	1678	27360856052000	26821	13144	17	0	\N
368986	1678	27360856053000	26821	13144	18	0	\N
368987	1678	27360856054000	26821	13144	19	0	\N
368988	1678	27360856055000	26821	13144	20	0	\N
368989	1678	27360856056000	26821	13144	21	0	\N
368990	1678	27360856057000	26821	13144	22	0	\N
368991	1678	27360856058000	26821	13144	23	0	\N
368992	1678	27360856059000	26821	13144	24	0	\N
368993	1678	27360856060000	26821	13144	25	0	\N
368994	1678	27360856061000	26821	13144	26	0	\N
368995	1678	27360856062000	26821	13144	27	0	\N
368996	1678	27360856063000	26821	13144	28	0	\N
368997	1678	27360856064000	26821	13144	29	0	\N
368998	1678	27360856065000	26821	13144	30	0	\N
368999	1678	27360856066000	26821	13144	31	0	\N
369000	1678	27360856067000	26821	13144	32	0	\N
369001	1678	27360856068000	26821	13144	33	0	\N
369002	1678	27360856069000	26821	13144	34	0	\N
369003	1678	27360856070000	26821	13144	35	0	\N
369004	1678	27360856071000	26821	13144	36	0	\N
369005	1678	27360856072000	26821	13144	37	0	\N
369006	1678	27360856073000	26821	13144	38	0	\N
369007	1678	27360856074000	26821	13144	39	0	\N
369008	1678	27360856075000	26821	13144	40	0	\N
369009	1678	27360856076000	26821	13144	41	0	\N
369010	1678	27360856077000	26821	13144	42	0	\N
369011	1678	27360856078000	26821	13144	43	0	\N
369012	1678	27360856079000	26821	13144	44	0	\N
369013	1678	27360856080000	26821	13144	45	0	\N
369014	1678	27360856081000	26821	13144	46	0	\N
369015	1678	27360856082000	26821	13144	47	0	\N
369016	1678	27360856083000	26821	13144	48	0	\N
369017	1678	27360856084000	26821	13144	49	0	\N
369018	1678	27360856085000	26821	13144	50	0	\N
369019	1678	27360856086000	26821	13144	51	0	\N
369020	1678	27360856087000	26821	13144	52	0	\N
369021	1678	27360856088000	26821	13144	53	0	\N
369022	1678	27360856089000	26821	13144	54	0	\N
369023	1678	27360856090000	26821	13144	55	0	\N
369024	1678	27360856091000	26821	13144	56	0	\N
369025	1678	27360856092000	26821	13144	57	0	\N
369026	1678	27360856093000	26821	13144	58	0	\N
369027	1678	27360856094000	26821	13144	59	0	\N
369028	1678	27360856095000	26821	13144	60	0	\N
369029	1678	27360856096000	26821	13144	61	0	\N
369030	1678	27360856097000	26821	13144	62	0	\N
369031	1678	27360856098000	26821	13144	63	0	\N
369032	1678	27360856099000	26821	13144	64	0	\N
369033	1678	27360856100000	26821	13144	65	0	\N
369034	1678	27360856101000	26821	13144	66	0	\N
369035	1678	27360856102000	26821	13144	67	0	\N
369036	1678	27360856103000	26821	13144	68	0	\N
369040	134	66000100000000	26823	13126	0	0	\N
369041	2367	100000000	26823	13126	1	0	\N
369042	2368	100000000	26823	13126	2	0	\N
369043	1678	27360856213000	26824	13265	0	0	\N
369044	1874	33361000	26824	13265	1	0	\N
369045	1874	33364000	26824	13265	2	0	\N
369046	1874	33366000	26824	13265	3	0	\N
369047	1678	27360856213000	26825	13265	0	0	\N
369048	1874	33361000	26825	13265	1	0	\N
369049	1874	33364000	26825	13265	2	0	\N
369050	1874	33366000	26825	13265	3	0	\N
369051	1678	27360856213000	26826	13265	0	0	\N
369052	1874	33361000	26826	13265	1	0	\N
369053	1874	33364000	26826	13265	2	0	\N
369054	1874	33366000	26826	13265	3	0	\N
369064	1678	27360856216000	26830	13268	0	0	\N
369065	1874	33374000	26830	13268	1	0	\N
369066	1874	33376000	26830	13268	2	0	\N
369067	1874	33379000	26830	13268	3	0	\N
369072	1678	27360856217000	26832	13269	0	0	\N
369073	1874	33382000	26832	13269	1	0	\N
369074	1874	33384000	26832	13269	2	0	\N
369078	1678	27360856217000	26834	13269	0	0	\N
369079	1874	33382000	26834	13269	1	0	\N
369093	1678	27360856222000	26837	13272	0	0	\N
369094	1874	33407000	26837	13272	1	0	\N
369095	1874	33410000	26837	13272	2	0	\N
369099	1678	27360856223000	26839	13273	0	0	\N
369100	1874	33413000	26839	13273	1	0	\N
369101	1874	33414000	26839	13273	2	0	\N
369102	1874	33416000	26839	13273	3	0	\N
369039	1874	33360000	26822	13264	2	0	2
369055	1678	27360856213000	26827	13265	0	0	1
369056	1874	33361000	26827	13265	1	0	2
369057	1874	33364000	26827	13265	2	0	2
369058	1874	33366000	26827	13265	3	0	2
369060	1874	33368000	26828	13266	1	0	2
369061	1678	27360856215000	26829	13267	0	0	1
369062	1874	33370000	26829	13267	1	0	2
369063	1874	33373000	26829	13267	2	0	2
369068	1678	27360856216000	26831	13268	0	0	1
369070	1874	33376000	26831	13268	2	0	2
369071	1874	33379000	26831	13268	3	0	2
369075	1678	27360856217000	26833	13269	0	0	1
369076	1874	33382000	26833	13269	1	0	2
369080	1678	27360856218000	26835	13270	0	0	1
369081	1678	27360856219000	26835	13270	1	0	1
369082	1678	27360856220000	26835	13270	2	0	1
369083	1874	33386000	26835	13270	3	0	2
369084	1874	33389000	26835	13270	4	0	2
369086	1874	33395000	26835	13270	6	0	2
369087	1874	33396000	26835	13270	7	0	2
369088	1874	33398000	26835	13270	8	0	2
369089	1874	33400000	26835	13270	9	0	2
369090	1678	27360856221000	26836	13271	0	0	1
369092	1874	33405000	26836	13271	2	0	2
369096	1678	27360856222000	26838	13272	0	0	1
369097	1874	33407000	26838	13272	1	0	2
369098	1874	33410000	26838	13272	2	0	2
369104	1874	33413000	26840	13273	1	0	2
369110	1678	27360856225000	26842	13275	0	0	\N
369111	1874	33424000	26842	13275	1	0	\N
369112	1874	33426000	26842	13275	2	0	\N
369145	1678	27360856234000	26849	13280	0	0	\N
369146	1874	33468000	26849	13280	1	0	\N
369147	1874	33471000	26849	13280	2	0	\N
369158	1678	27360856238000	26852	13283	0	0	\N
369159	1874	33490000	26852	13283	1	0	\N
369160	1874	33492000	26852	13283	2	0	\N
369164	1678	27360856238000	26854	13283	0	0	\N
369165	1874	33490000	26854	13283	1	0	\N
369166	1874	33492000	26854	13283	2	0	\N
369167	1678	27360856238000	26855	13283	0	0	\N
369168	1874	33490000	26855	13283	1	0	\N
369169	1874	33492000	26855	13283	2	0	\N
369170	134	66000100000000	26856	13245	0	0	\N
369171	1678	27360856185000	26856	13245	1	0	\N
369172	1678	27360856186000	26856	13245	2	0	\N
369173	1678	27360856187000	26856	13245	3	0	\N
369174	1678	27360856188000	26856	13245	4	0	\N
369175	1678	27360856189000	26856	13245	5	0	\N
369176	1678	27360856190000	26856	13245	6	0	\N
369177	1678	27360856191000	26856	13245	7	0	\N
369178	1678	27360856192000	26856	13245	8	0	\N
369179	1678	27360856193000	26856	13245	9	0	\N
369180	1678	27360856194000	26856	13245	10	0	\N
369181	1678	27360856195000	26856	13245	11	0	\N
369182	1678	27360856196000	26856	13245	12	0	\N
369183	1678	27360856197000	26856	13245	13	0	\N
369184	1678	27360856198000	26856	13245	14	0	\N
369185	1678	27360856199000	26856	13245	15	0	\N
369186	1678	27360856200000	26856	13245	16	0	\N
369187	1678	27360856201000	26856	13245	17	0	\N
369188	1678	27360856202000	26856	13245	18	0	\N
369189	1678	27360856203000	26856	13245	19	0	\N
369190	1678	27360856204000	26856	13245	20	0	\N
369191	1678	27360856205000	26856	13245	21	0	\N
369192	1678	27360856206000	26856	13245	22	0	\N
369193	1678	27360856207000	26856	13245	23	0	\N
369194	1678	27360856208000	26856	13245	24	0	\N
369195	1678	27360856209000	26856	13245	25	0	\N
369196	1678	27360856210000	26856	13245	26	0	\N
369197	1678	27360856211000	26856	13245	27	0	\N
369198	1678	27360856212000	26856	13245	28	0	\N
369199	1678	27360856213000	26856	13245	29	0	\N
369200	1678	27360856214000	26856	13245	30	0	\N
369201	1678	27360856215000	26856	13245	31	0	\N
369202	1678	27360856216000	26856	13245	32	0	\N
369203	1678	27360856217000	26856	13245	33	0	\N
369204	1678	27360856218000	26856	13245	34	0	\N
369205	1678	27360856219000	26856	13245	35	0	\N
369206	1678	27360856220000	26856	13245	36	0	\N
369207	1678	27360856221000	26856	13245	37	0	\N
369208	1678	27360856222000	26856	13245	38	0	\N
369209	1678	27360856223000	26856	13245	39	0	\N
369210	1678	27360856224000	26856	13245	40	0	\N
369211	1678	27360856225000	26856	13245	41	0	\N
369212	1678	27360856226000	26856	13245	42	0	\N
369213	1678	27360856227000	26856	13245	43	0	\N
369214	1678	27360856228000	26856	13245	44	0	\N
369215	1678	27360856229000	26856	13245	45	0	\N
369216	1678	27360856230000	26856	13245	46	0	\N
369217	1678	27360856231000	26856	13245	47	0	\N
369218	1678	27360856232000	26856	13245	48	0	\N
369219	1678	27360856233000	26856	13245	49	0	\N
369220	1678	27360856234000	26856	13245	50	0	\N
369221	1678	27360856235000	26856	13245	51	0	\N
369222	1678	27360856236000	26856	13245	52	0	\N
369223	1678	27360856237000	26856	13245	53	0	\N
369224	1678	27360856238000	26856	13245	54	0	\N
369225	1874	33217000	26856	13245	55	0	\N
369226	1874	33219000	26856	13245	56	0	\N
369227	1874	33221000	26856	13245	57	0	\N
369228	1874	33223000	26856	13245	58	0	\N
369229	1874	33225000	26856	13245	59	0	\N
369230	1874	33227000	26856	13245	60	0	\N
369231	1874	33230000	26856	13245	61	0	\N
369232	1874	33232000	26856	13245	62	0	\N
369233	1874	33234000	26856	13245	63	0	\N
369234	1874	33236000	26856	13245	64	0	\N
369235	1874	33238000	26856	13245	65	0	\N
369236	1874	33240000	26856	13245	66	0	\N
369237	1874	33242000	26856	13245	67	0	\N
369238	1874	33244000	26856	13245	68	0	\N
369239	1874	33246000	26856	13245	69	0	\N
369240	1874	33248000	26856	13245	70	0	\N
369107	1678	27360856224000	26841	13274	0	0	1
369108	1874	33418000	26841	13274	1	0	2
369109	1874	33421000	26841	13274	2	0	2
369113	1678	27360856225000	26843	13275	0	0	1
369114	1874	33424000	26843	13275	1	0	2
369116	1678	27360856226000	26844	13276	0	0	1
369117	1874	33428000	26844	13276	1	0	2
369118	1874	33431000	26844	13276	2	0	2
369119	1874	33432000	26844	13276	3	0	2
369120	1678	27360856227000	26845	13277	0	0	1
369122	1678	27360856229000	26845	13277	2	0	1
369123	1678	27360856230000	26845	13277	3	0	1
369124	1874	33434000	26845	13277	4	0	2
369125	1874	33437000	26845	13277	5	0	2
369127	1874	33441000	26845	13277	7	0	2
369128	1874	33443000	26845	13277	8	0	2
369129	1874	33444000	26845	13277	9	0	2
369130	1874	33447000	26845	13277	10	0	2
369131	1874	33450000	26845	13277	11	0	2
369133	1678	27360856231000	26846	13278	0	0	1
369134	1874	33455000	26846	13278	1	0	2
369135	1678	27360856232000	26847	13279	0	0	1
369136	1678	27360856233000	26847	13279	1	0	1
369137	1874	33458000	26847	13279	2	0	2
369139	1874	33463000	26847	13279	4	0	2
369140	1874	33465000	26847	13279	5	0	2
369141	1874	33466000	26847	13279	6	0	2
369142	1678	27360856234000	26848	13280	0	0	1
369144	1874	33471000	26848	13280	2	0	2
369148	1678	27360856235000	26850	13281	0	0	1
369149	1874	33474000	26850	13281	1	0	2
369150	1874	33476000	26850	13281	2	0	2
369151	1678	27360856236000	26851	13282	0	0	1
369153	1874	33478000	26851	13282	2	0	2
369154	1874	33481000	26851	13282	3	0	2
369155	1874	33483000	26851	13282	4	0	2
369156	1874	33484000	26851	13282	5	0	2
369157	1874	33487000	26851	13282	6	0	2
369162	1874	33490000	26853	13283	1	0	2
369163	1874	33492000	26853	13283	2	0	2
369241	1874	33249000	26856	13245	71	0	\N
369242	1874	33250000	26856	13245	72	0	\N
369243	1874	33251000	26856	13245	73	0	\N
369244	1874	33252000	26856	13245	74	0	\N
369245	1874	33253000	26856	13245	75	0	\N
369246	1874	33254000	26856	13245	76	0	\N
369247	1874	33255000	26856	13245	77	0	\N
369248	1874	33256000	26856	13245	78	0	\N
369249	1874	33257000	26856	13245	79	0	\N
369250	1874	33258000	26856	13245	80	0	\N
369251	1874	33259000	26856	13245	81	0	\N
369252	1874	33260000	26856	13245	82	0	\N
369253	1874	33261000	26856	13245	83	0	\N
369254	1874	33262000	26856	13245	84	0	\N
369255	1874	33264000	26856	13245	85	0	\N
369256	1874	33266000	26856	13245	86	0	\N
369257	1874	33268000	26856	13245	87	0	\N
369258	1874	33270000	26856	13245	88	0	\N
369259	1874	33272000	26856	13245	89	0	\N
369260	1874	33274000	26856	13245	90	0	\N
369261	1874	33276000	26856	13245	91	0	\N
369262	1874	33278000	26856	13245	92	0	\N
369263	1874	33280000	26856	13245	93	0	\N
369264	1874	33282000	26856	13245	94	0	\N
369265	1874	33284000	26856	13245	95	0	\N
369266	1874	33286000	26856	13245	96	0	\N
369267	1874	33288000	26856	13245	97	0	\N
369268	1874	33290000	26856	13245	98	0	\N
369269	1874	33291000	26856	13245	99	0	\N
369270	1874	33292000	26856	13245	100	0	\N
369271	1874	33295000	26856	13245	101	0	\N
369272	1874	33298000	26856	13245	102	0	\N
369273	1874	33301000	26856	13245	103	0	\N
369274	1874	33304000	26856	13245	104	0	\N
369275	1874	33307000	26856	13245	105	0	\N
369276	1874	33310000	26856	13245	106	0	\N
369277	1874	33313000	26856	13245	107	0	\N
369278	1874	33316000	26856	13245	108	0	\N
369279	1874	33318000	26856	13245	109	0	\N
369280	1874	33320000	26856	13245	110	0	\N
369281	1874	33322000	26856	13245	111	0	\N
369282	1874	33324000	26856	13245	113	0	\N
369283	1874	33326000	26856	13245	114	0	\N
369284	1874	33328000	26856	13245	115	0	\N
369285	1874	33330000	26856	13245	116	0	\N
369286	1874	33332000	26856	13245	117	0	\N
369287	1874	33334000	26856	13245	118	0	\N
369288	1874	33336000	26856	13245	119	0	\N
369289	1874	33338000	26856	13245	120	0	\N
369290	1874	33340000	26856	13245	121	0	\N
369291	1874	33342000	26856	13245	122	0	\N
369292	1874	33344000	26856	13245	123	0	\N
369293	1874	33346000	26856	13245	124	0	\N
369294	1874	33348000	26856	13245	125	0	\N
369305	1678	27360856242000	26858	13285	0	0	\N
369306	1874	33510000	26858	13285	1	0	\N
369307	1874	33513000	26858	13285	2	0	\N
369311	1678	27360856242000	26860	13285	0	0	\N
369312	1874	33510000	26860	13285	1	0	\N
369313	1874	33513000	26860	13285	2	0	\N
369314	1678	27360856192000	26861	13250	0	0	\N
369315	134	66000100000000	26861	13250	1	0	\N
369316	1678	27360856193000	26861	13250	2	0	\N
369317	1678	27360856194000	26861	13250	3	0	\N
369318	1678	27360856195000	26861	13250	4	0	\N
369319	1678	27360856196000	26861	13250	5	0	\N
369320	1678	27360856197000	26861	13250	6	0	\N
369321	1678	27360856198000	26861	13250	7	0	\N
369322	1678	27360856199000	26861	13250	8	0	\N
369323	1678	27360856200000	26861	13250	9	0	\N
369324	1678	27360856201000	26861	13250	10	0	\N
369325	1678	27360856202000	26861	13250	11	0	\N
369326	1678	27360856203000	26861	13250	12	0	\N
369327	1678	27360856204000	26861	13250	13	0	\N
369328	1678	27360856205000	26861	13250	14	0	\N
369329	1678	27360856206000	26861	13250	15	0	\N
369330	1678	27360856207000	26861	13250	16	0	\N
369331	1678	27360856208000	26861	13250	17	0	\N
369332	1678	27360856209000	26861	13250	18	0	\N
369333	1678	27360856210000	26861	13250	19	0	\N
369334	1678	27360856211000	26861	13250	20	0	\N
369335	1678	27360856212000	26861	13250	21	0	\N
369336	1678	27360856213000	26861	13250	22	0	\N
369337	1678	27360856214000	26861	13250	23	0	\N
369338	1678	27360856215000	26861	13250	24	0	\N
369339	1678	27360856216000	26861	13250	25	0	\N
369340	1678	27360856217000	26861	13250	26	0	\N
369341	1678	27360856218000	26861	13250	27	0	\N
369342	1678	27360856219000	26861	13250	28	0	\N
369343	1678	27360856220000	26861	13250	29	0	\N
369344	1678	27360856221000	26861	13250	30	0	\N
369345	1678	27360856222000	26861	13250	31	0	\N
369346	1678	27360856223000	26861	13250	32	0	\N
369347	1678	27360856224000	26861	13250	33	0	\N
369348	1678	27360856225000	26861	13250	34	0	\N
369349	1678	27360856226000	26861	13250	35	0	\N
369350	1678	27360856227000	26861	13250	36	0	\N
369351	1678	27360856228000	26861	13250	37	0	\N
369352	1678	27360856229000	26861	13250	38	0	\N
369353	1678	27360856230000	26861	13250	39	0	\N
369354	1678	27360856231000	26861	13250	40	0	\N
369355	1678	27360856232000	26861	13250	41	0	\N
369356	1678	27360856233000	26861	13250	42	0	\N
369357	1678	27360856234000	26861	13250	43	0	\N
369358	1678	27360856235000	26861	13250	44	0	\N
369359	1678	27360856236000	26861	13250	45	0	\N
369360	1678	27360856237000	26861	13250	46	0	\N
369361	1678	27360856238000	26861	13250	47	0	\N
369362	1678	27360856239000	26861	13250	48	0	\N
369363	1678	27360856240000	26861	13250	49	0	\N
369364	1678	27360856241000	26861	13250	50	0	\N
369365	1678	27360856242000	26861	13250	51	0	\N
369366	1874	33253000	26861	13250	52	0	\N
369367	1874	33255000	26861	13250	53	0	\N
369368	1874	33258000	26861	13250	54	0	\N
369369	1874	33259000	26861	13250	55	0	\N
369370	1874	33260000	26861	13250	56	0	\N
369371	1874	33261000	26861	13250	57	0	\N
369372	1874	33262000	26861	13250	58	0	\N
369373	1874	33263000	26861	13250	59	0	\N
369374	1874	33264000	26861	13250	60	0	\N
369375	1874	33265000	26861	13250	61	0	\N
369376	1874	33266000	26861	13250	62	0	\N
369297	1678	27360856241000	26857	13284	2	0	1
369298	1874	33493000	26857	13284	3	0	2
369299	1874	33496000	26857	13284	4	0	2
369300	1874	33499000	26857	13284	5	0	2
369301	1874	33502000	26857	13284	6	0	2
369303	1874	33506000	26857	13284	8	0	2
369304	1874	33508000	26857	13284	9	0	2
369308	1678	27360856242000	26859	13285	0	0	1
369309	1874	33510000	26859	13285	1	0	2
369310	1874	33513000	26859	13285	2	0	2
369377	1874	33267000	26861	13250	63	0	\N
369378	1874	33268000	26861	13250	64	0	\N
369379	1874	33270000	26861	13250	65	0	\N
369380	1874	33272000	26861	13250	66	0	\N
369381	1874	33274000	26861	13250	67	0	\N
369382	1874	33276000	26861	13250	68	0	\N
369383	1874	33278000	26861	13250	69	0	\N
369384	1874	33280000	26861	13250	70	0	\N
369385	1874	33282000	26861	13250	71	0	\N
369386	1874	33285000	26861	13250	72	0	\N
369387	1874	33286000	26861	13250	73	0	\N
369388	1874	33288000	26861	13250	74	0	\N
369389	1874	33290000	26861	13250	75	0	\N
369390	1874	33292000	26861	13250	76	0	\N
369391	1874	33294000	26861	13250	77	0	\N
369392	1874	33296000	26861	13250	78	0	\N
369393	1874	33298000	26861	13250	80	0	\N
369394	1874	33300000	26861	13250	81	0	\N
369395	1874	33302000	26861	13250	82	0	\N
369396	1874	33304000	26861	13250	83	0	\N
369397	1874	33306000	26861	13250	84	0	\N
369398	1874	33308000	26861	13250	85	0	\N
369399	1874	33310000	26861	13250	86	0	\N
369400	1874	33312000	26861	13250	87	0	\N
369401	1874	33314000	26861	13250	88	0	\N
369402	1874	33315000	26861	13250	89	0	\N
369403	1874	33316000	26861	13250	90	0	\N
369404	1874	33317000	26861	13250	91	0	\N
369405	1874	33319000	26861	13250	92	0	\N
369406	1874	33321000	26861	13250	93	0	\N
369407	1874	33323000	26861	13250	94	0	\N
369408	1874	33325000	26861	13250	95	0	\N
369409	1874	33327000	26861	13250	96	0	\N
369410	1874	33329000	26861	13250	97	0	\N
369411	1874	33331000	26861	13250	98	0	\N
369412	1874	33333000	26861	13250	99	0	\N
369413	1874	33335000	26861	13250	100	0	\N
369414	1874	33337000	26861	13250	101	0	\N
369415	1874	33339000	26861	13250	102	0	\N
369416	1874	33341000	26861	13250	103	0	\N
369417	1874	33343000	26861	13250	104	0	\N
369418	1874	33345000	26861	13250	105	0	\N
369419	1874	33347000	26861	13250	106	0	\N
369420	1874	33349000	26861	13250	107	0	\N
369421	1874	33351000	26861	13250	108	0	\N
369422	1874	33353000	26861	13250	109	0	\N
369423	1874	33355000	26861	13250	110	0	\N
369424	1874	33357000	26861	13250	111	0	\N
369425	1874	33359000	26861	13250	112	0	\N
369426	1874	33361000	26861	13250	113	0	\N
369427	1874	33363000	26861	13250	114	0	\N
369428	1874	33365000	26861	13250	115	0	\N
369429	1874	33367000	26861	13250	116	0	\N
369430	1874	33369000	26861	13250	117	0	\N
369431	1874	33371000	26861	13250	118	0	\N
369432	1874	33373000	26861	13250	119	0	\N
369433	1874	33375000	26861	13250	120	0	\N
369434	1874	33378000	26861	13250	121	0	\N
369435	1874	33381000	26861	13250	122	0	\N
369436	1874	33384000	26861	13250	123	0	\N
369437	1874	33387000	26861	13250	124	0	\N
369438	1874	33390000	26861	13250	125	0	\N
369439	1678	27360856242000	26862	13285	0	0	\N
369440	1874	33510000	26862	13285	1	0	\N
369441	1874	33513000	26862	13285	2	0	\N
369442	1678	27360856243000	26863	13286	0	0	\N
369443	1678	27360856244000	26863	13286	1	0	\N
369444	1874	33516000	26863	13286	2	0	\N
369445	1874	33518000	26863	13286	3	0	\N
369446	1874	33520000	26863	13286	4	0	\N
369447	1874	33523000	26863	13286	5	0	\N
369448	1874	33524000	26863	13286	6	0	\N
369456	1678	27360856243000	26865	13286	0	0	\N
369457	1678	27360856244000	26865	13286	1	0	\N
369458	1874	33516000	26865	13286	2	0	\N
369459	1874	33518000	26865	13286	3	0	\N
369460	1874	33520000	26865	13286	4	0	\N
369461	1874	33523000	26865	13286	5	0	\N
369462	1874	33524000	26865	13286	6	0	\N
369473	1678	27360856247000	26869	13289	0	0	\N
369474	1874	33538000	26869	13289	1	0	\N
369475	1874	33540000	26869	13289	2	0	\N
369476	1678	27360856248000	26870	13290	0	0	\N
369477	1874	33542000	26870	13290	1	0	\N
369478	1874	33545000	26870	13290	2	0	\N
369479	1678	27360856248000	26871	13290	0	0	\N
369480	1874	33542000	26871	13290	1	0	\N
369481	1874	33545000	26871	13290	2	0	\N
369482	1678	27360856248000	26872	13290	0	0	\N
369483	1874	33542000	26872	13290	1	0	\N
369484	1874	33545000	26872	13290	2	0	\N
369493	1678	27360856250000	26875	13292	0	0	\N
369494	1874	33554000	26875	13292	1	0	\N
369495	1874	33556000	26875	13292	2	0	\N
369499	1678	27360856251000	26877	13293	0	0	\N
369500	1874	33559000	26877	13293	1	0	\N
369501	1874	33561000	26877	13293	2	0	\N
369502	1678	27360856251000	26878	13293	0	0	\N
369503	1874	33559000	26878	13293	1	0	\N
369504	1874	33561000	26878	13293	2	0	\N
369508	1678	27360856251000	26880	13293	0	0	\N
369509	1874	33559000	26880	13293	1	0	\N
369510	1874	33561000	26880	13293	2	0	\N
369511	1678	27360856251000	26881	13293	0	0	\N
369512	1874	33559000	26881	13293	1	0	\N
369451	1874	33516000	26864	13286	2	0	2
369452	1874	33518000	26864	13286	3	0	2
369453	1874	33520000	26864	13286	4	0	2
369454	1874	33523000	26864	13286	5	0	2
369455	1874	33524000	26864	13286	6	0	2
369464	1874	33527000	26866	13287	1	0	2
369465	1874	33529000	26866	13287	2	0	2
369466	1678	27360856246000	26867	13288	0	0	1
369467	1874	33531000	26867	13288	1	0	2
369468	1874	33534000	26867	13288	2	0	2
369470	1678	27360856247000	26868	13289	0	0	1
369471	1874	33538000	26868	13289	1	0	2
369472	1874	33540000	26868	13289	2	0	2
369485	1678	27360856248000	26873	13290	0	0	1
369487	1874	33545000	26873	13290	2	0	2
369488	1678	27360856249000	26874	13291	0	0	1
369489	1874	33547000	26874	13291	1	0	2
369490	1874	33550000	26874	13291	2	0	2
369491	1841	1438025000000	26874	13291	3	0	1
369496	1678	27360856250000	26876	13292	0	0	1
369497	1874	33554000	26876	13292	1	0	2
369498	1874	33556000	26876	13292	2	0	2
369505	1678	27360856251000	26879	13293	0	0	1
369506	1874	33559000	26879	13293	1	0	2
369513	1874	33561000	26881	13293	2	0	\N
369514	1678	27360856239000	26882	13246	0	0	\N
369515	1678	27360856240000	26882	13246	1	0	\N
369516	1678	27360856241000	26882	13246	2	0	\N
369517	1678	27360856242000	26882	13246	3	0	\N
369518	1678	27360856243000	26882	13246	4	0	\N
369519	1678	27360856244000	26882	13246	5	0	\N
369520	1678	27360856245000	26882	13246	6	0	\N
369521	1678	27360856246000	26882	13246	7	0	\N
369522	1678	27360856247000	26882	13246	8	0	\N
369523	1678	27360856248000	26882	13246	9	0	\N
369524	1678	27360856249000	26882	13246	10	0	\N
369525	1678	27360856250000	26882	13246	11	0	\N
369526	1678	27360856251000	26882	13246	12	0	\N
369527	1874	33349000	26882	13246	13	0	\N
369528	1874	33351000	26882	13246	14	0	\N
369529	1874	33353000	26882	13246	15	0	\N
369530	1874	33355000	26882	13246	16	0	\N
369531	1874	33357000	26882	13246	17	0	\N
369532	1874	33359000	26882	13246	18	0	\N
369533	1874	33361000	26882	13246	19	0	\N
369534	1874	33363000	26882	13246	20	0	\N
369535	1874	33365000	26882	13246	21	0	\N
369536	1874	33367000	26882	13246	22	0	\N
369537	1874	33369000	26882	13246	23	0	\N
369538	1874	33371000	26882	13246	24	0	\N
369539	1874	33373000	26882	13246	25	0	\N
369540	1874	33375000	26882	13246	26	0	\N
369541	1874	33377000	26882	13246	27	0	\N
369542	1874	33379000	26882	13246	28	0	\N
369543	1874	33381000	26882	13246	29	0	\N
369544	1874	33383000	26882	13246	30	0	\N
369545	1874	33385000	26882	13246	31	0	\N
369546	1874	33387000	26882	13246	32	0	\N
369547	1874	33389000	26882	13246	33	0	\N
369548	1874	33391000	26882	13246	34	0	\N
369549	1874	33393000	26882	13246	35	0	\N
369550	1874	33394000	26882	13246	36	0	\N
369551	1874	33395000	26882	13246	37	0	\N
369552	1874	33396000	26882	13246	38	0	\N
369553	1874	33399000	26882	13246	39	0	\N
369554	1874	33402000	26882	13246	40	0	\N
369555	1874	33405000	26882	13246	41	0	\N
369556	1874	33408000	26882	13246	42	0	\N
369557	1874	33411000	26882	13246	43	0	\N
369558	1874	33414000	26882	13246	44	0	\N
369559	1874	33417000	26882	13246	45	0	\N
369560	1874	33420000	26882	13246	46	0	\N
369561	1874	33423000	26882	13246	47	0	\N
369562	1874	33426000	26882	13246	48	0	\N
369563	1874	33429000	26882	13246	49	0	\N
369564	1874	33432000	26882	13246	50	0	\N
369565	1874	33435000	26882	13246	51	0	\N
369566	1874	33438000	26882	13246	52	0	\N
369567	1874	33441000	26882	13246	53	0	\N
369568	1874	33444000	26882	13246	54	0	\N
369569	1874	33447000	26882	13246	55	0	\N
369570	1874	33450000	26882	13246	56	0	\N
369571	1874	33453000	26882	13246	57	0	\N
369572	1874	33456000	26882	13246	58	0	\N
369573	1874	33459000	26882	13246	59	0	\N
369574	1874	33462000	26882	13246	60	0	\N
369575	1874	33465000	26882	13246	61	0	\N
369576	1874	33468000	26882	13246	62	0	\N
369577	1874	33471000	26882	13246	63	0	\N
369578	1874	33474000	26882	13246	64	0	\N
369579	1874	33477000	26882	13246	65	0	\N
369580	1874	33480000	26882	13246	66	0	\N
369581	1874	33483000	26882	13246	67	0	\N
369582	1874	33486000	26882	13246	68	0	\N
369583	1874	33489000	26882	13246	69	0	\N
369584	1874	33492000	26882	13246	70	0	\N
369585	1874	33495000	26882	13246	71	0	\N
369586	1874	33498000	26882	13246	72	0	\N
369587	1874	33501000	26882	13246	73	0	\N
369588	1874	33504000	26882	13246	74	0	\N
369589	1874	33507000	26882	13246	75	0	\N
369590	1874	33510000	26882	13246	76	0	\N
369591	1874	33513000	26882	13246	77	0	\N
369592	1874	33516000	26882	13246	78	0	\N
369593	1874	33519000	26882	13246	79	0	\N
369594	1874	33522000	26882	13246	80	0	\N
369595	1874	33525000	26882	13246	81	0	\N
369596	1874	33528000	26882	13246	82	0	\N
369597	1874	33531000	26882	13246	83	0	\N
369598	1874	33534000	26882	13246	84	0	\N
369599	1874	33537000	26882	13246	85	0	\N
369600	1874	33540000	26882	13246	86	0	\N
369601	1874	33543000	26882	13246	87	0	\N
369602	1874	33546000	26882	13246	88	0	\N
369603	1874	33549000	26882	13246	89	0	\N
369604	1874	33552000	26882	13246	90	0	\N
369605	1874	33555000	26882	13246	91	0	\N
369606	1874	33558000	26882	13246	92	0	\N
369607	1874	33561000	26882	13246	93	0	\N
369621	1678	27360856255000	26885	13295	0	0	\N
369622	1874	33579000	26885	13295	1	0	\N
369623	1874	33582000	26885	13295	2	0	\N
369624	1678	27360856256000	26886	13296	0	0	\N
369625	1874	33584000	26886	13296	1	0	\N
369626	1874	33585000	26886	13296	2	0	\N
369627	1874	33588000	26886	13296	3	0	\N
369632	1678	27360856256000	26888	13296	0	0	\N
369633	1874	33584000	26888	13296	1	0	\N
369634	1874	33585000	26888	13296	2	0	\N
369635	1874	33588000	26888	13296	3	0	\N
369639	1678	27360856257000	26890	13297	0	0	\N
369640	1874	33591000	26890	13297	1	0	\N
369641	1874	33593000	26890	13297	2	0	\N
369610	1678	27360856254000	26883	13294	2	0	1
369611	1874	33563000	26883	13294	3	0	2
369612	1874	33565000	26883	13294	4	0	2
369613	1874	33566000	26883	13294	5	0	2
369614	1874	33569000	26883	13294	6	0	2
369616	1874	33575000	26883	13294	8	0	2
369617	1874	33577000	26883	13294	9	0	2
369618	1678	27360856255000	26884	13295	0	0	1
369619	1874	33579000	26884	13295	1	0	2
369620	1874	33582000	26884	13295	2	0	2
369629	1874	33584000	26887	13296	1	0	2
369630	1874	33585000	26887	13296	2	0	2
369631	1874	33588000	26887	13296	3	0	2
369636	1678	27360856257000	26889	13297	0	0	1
369638	1874	33593000	26889	13297	2	0	2
369642	1678	27360856258000	26891	13298	0	0	1
369643	1874	33596000	26891	13298	1	0	2
369644	1874	33598000	26891	13298	2	0	2
369645	1678	27360856259000	26892	13299	0	0	1
369647	1874	33602000	26892	13299	2	0	2
369648	1874	33604000	26892	13299	3	0	2
369649	1678	27360856259000	26893	13299	0	0	\N
369650	1874	33599000	26893	13299	1	0	\N
369651	1874	33602000	26893	13299	2	0	\N
369652	1874	33604000	26893	13299	3	0	\N
369653	1678	27360856252000	26894	13247	0	0	\N
369654	1678	27360856253000	26894	13247	1	0	\N
369655	1678	27360856254000	26894	13247	2	0	\N
369656	1678	27360856255000	26894	13247	3	0	\N
369657	1678	27360856256000	26894	13247	4	0	\N
369658	1678	27360856257000	26894	13247	5	0	\N
369659	1678	27360856258000	26894	13247	6	0	\N
369660	1678	27360856259000	26894	13247	7	0	\N
369661	1678	27360856260000	26894	13247	8	0	\N
369662	1874	33563000	26894	13247	9	0	\N
369663	1874	33565000	26894	13247	10	0	\N
369664	1874	33566000	26894	13247	11	0	\N
369665	1874	33569000	26894	13247	12	0	\N
369666	1874	33572000	26894	13247	13	0	\N
369667	1874	33575000	26894	13247	14	0	\N
369668	1874	33576000	26894	13247	15	0	\N
369669	1874	33577000	26894	13247	17	0	\N
369670	1874	33579000	26894	13247	18	0	\N
369671	1874	33581000	26894	13247	19	0	\N
369672	1874	33583000	26894	13247	20	0	\N
369673	1874	33585000	26894	13247	21	0	\N
369674	1874	33587000	26894	13247	22	0	\N
369675	1874	33589000	26894	13247	23	0	\N
369676	1874	33591000	26894	13247	24	0	\N
369677	1874	33594000	26894	13247	25	0	\N
369678	1874	33597000	26894	13247	26	0	\N
369679	1874	33600000	26894	13247	27	0	\N
369680	1874	33603000	26894	13247	28	0	\N
369681	1874	33606000	26894	13247	29	0	\N
369682	1874	33609000	26894	13247	30	0	\N
369692	1678	27360856260000	26896	13300	0	0	\N
369693	1678	27360856261000	26896	13300	1	0	\N
369694	1678	27360856262000	26896	13300	2	0	\N
369695	1874	33607000	26896	13300	3	0	\N
369696	1874	33610000	26896	13300	4	0	\N
369697	1874	33613000	26896	13300	5	0	\N
369698	1874	33615000	26896	13300	6	0	\N
369699	1874	33617000	26896	13300	7	0	\N
369700	1874	33619000	26896	13300	8	0	\N
369708	1678	27360856265000	26898	13302	0	0	\N
369709	1678	27360856266000	26898	13302	1	0	\N
369710	1678	27360856267000	26898	13302	2	0	\N
369711	1678	27360856268000	26898	13302	3	0	\N
369712	1874	33633000	26898	13302	4	0	\N
369713	1874	33635000	26898	13302	5	0	\N
369714	1874	33637000	26898	13302	6	0	\N
369715	1874	33640000	26898	13302	7	0	\N
369716	1874	33642000	26898	13302	8	0	\N
369717	1874	33645000	26898	13302	9	0	\N
369718	1874	33648000	26898	13302	10	0	\N
369719	1678	27360856265000	26899	13302	0	0	\N
369720	1678	27360856266000	26899	13302	1	0	\N
369721	1678	27360856267000	26899	13302	2	0	\N
369722	1678	27360856268000	26899	13302	3	0	\N
369723	1874	33633000	26899	13302	4	0	\N
369724	1874	33635000	26899	13302	5	0	\N
369725	1874	33637000	26899	13302	6	0	\N
369726	1874	33640000	26899	13302	7	0	\N
369727	1874	33642000	26899	13302	8	0	\N
369728	1874	33645000	26899	13302	9	0	\N
369729	1874	33648000	26899	13302	10	0	\N
369750	1678	27360856271000	26903	13304	0	0	\N
369751	1874	33661000	26903	13304	1	0	\N
369752	1874	33663000	26903	13304	2	0	\N
369765	1678	27360856274000	26907	13307	0	0	\N
369766	1678	27360856275000	26907	13307	1	0	\N
369767	1874	33675000	26907	13307	2	0	\N
369768	1874	33678000	26907	13307	3	0	\N
369769	1874	33681000	26907	13307	4	0	\N
369770	1874	33683000	26907	13307	5	0	\N
369771	1678	27360856276000	26908	13308	0	0	\N
369772	1874	33685000	26908	13308	1	0	\N
369773	1874	33688000	26908	13308	2	0	\N
369777	1678	27360856276000	26910	13308	0	0	\N
369778	1874	33685000	26910	13308	1	0	\N
369779	1874	33688000	26910	13308	2	0	\N
369780	1678	27360856276000	26911	13308	0	0	\N
369781	1874	33685000	26911	13308	1	0	\N
369782	1874	33688000	26911	13308	2	0	\N
369685	1678	27360856262000	26895	13300	2	0	1
369686	1874	33607000	26895	13300	3	0	2
369687	1874	33610000	26895	13300	4	0	2
369688	1874	33613000	26895	13300	5	0	2
369689	1874	33615000	26895	13300	6	0	2
369691	1874	33619000	26895	13300	8	0	2
369701	1678	27360856263000	26897	13301	0	0	1
369702	1678	27360856264000	26897	13301	1	0	1
369703	1874	33621000	26897	13301	2	0	2
369704	1874	33623000	26897	13301	3	0	2
369706	1874	33627000	26897	13301	5	0	2
369707	1874	33630000	26897	13301	6	0	2
369730	1678	27360856265000	26900	13302	0	0	1
369731	1678	27360856266000	26900	13302	1	0	1
369733	1678	27360856268000	26900	13302	3	0	1
369734	1874	33633000	26900	13302	4	0	2
369735	1874	33635000	26900	13302	5	0	2
369736	1874	33637000	26900	13302	6	0	2
369737	1874	33640000	26900	13302	7	0	2
369739	1874	33645000	26900	13302	9	0	2
369740	1874	33648000	26900	13302	10	0	2
369741	1678	27360856269000	26901	13303	0	0	1
369742	1678	27360856270000	26901	13303	1	0	1
369743	1874	33650000	26901	13303	2	0	2
369745	1874	33655000	26901	13303	4	0	2
369746	1874	33658000	26901	13303	5	0	2
369747	1678	27360856271000	26902	13304	0	0	1
369748	1874	33661000	26902	13304	1	0	2
369753	1678	27360856272000	26904	13305	0	0	1
369754	1874	33665000	26904	13305	1	0	2
369755	1874	33668000	26904	13305	2	0	2
369756	1678	27360856273000	26905	13306	0	0	1
369757	1874	33671000	26905	13306	1	0	2
369759	1678	27360856274000	26906	13307	0	0	1
369760	1678	27360856275000	26906	13307	1	0	1
369761	1874	33675000	26906	13307	2	0	2
369762	1874	33678000	26906	13307	3	0	2
369763	1874	33681000	26906	13307	4	0	2
369774	1678	27360856276000	26909	13308	0	0	1
369775	1874	33685000	26909	13308	1	0	2
369776	1874	33688000	26909	13308	2	0	2
369783	1678	27360856277000	26912	13309	0	0	1
369786	1678	27360856278000	26913	13310	0	0	\N
369787	1874	33696000	26913	13310	1	0	\N
369788	1874	33698000	26913	13310	2	0	\N
369794	1678	27360856280000	26916	13312	0	0	\N
369795	1874	33702000	26916	13312	1	0	\N
369796	1874	33705000	26916	13312	2	0	\N
369812	1678	27360856261000	26920	13248	0	0	\N
369813	1678	27360856262000	26920	13248	1	0	\N
369814	1678	27360856263000	26920	13248	2	0	\N
369815	1678	27360856264000	26920	13248	3	0	\N
369816	1678	27360856265000	26920	13248	4	0	\N
369817	1678	27360856266000	26920	13248	5	0	\N
369818	1678	27360856267000	26920	13248	6	0	\N
369819	1678	27360856268000	26920	13248	7	0	\N
369820	1678	27360856269000	26920	13248	8	0	\N
369821	1678	27360856270000	26920	13248	9	0	\N
369822	1678	27360856271000	26920	13248	10	0	\N
369823	1678	27360856272000	26920	13248	11	0	\N
369824	1678	27360856273000	26920	13248	12	0	\N
369825	1678	27360856274000	26920	13248	13	0	\N
369826	1678	27360856275000	26920	13248	14	0	\N
369827	1678	27360856276000	26920	13248	15	0	\N
369828	1678	27360856277000	26920	13248	16	0	\N
369829	1678	27360856278000	26920	13248	17	0	\N
369830	1678	27360856279000	26920	13248	18	0	\N
369831	1678	27360856280000	26920	13248	19	0	\N
369832	1678	27360856281000	26920	13248	20	0	\N
369833	1678	27360856282000	26920	13248	21	0	\N
369834	1678	27360856283000	26920	13248	22	0	\N
369835	1678	27360856284000	26920	13248	23	0	\N
369836	1874	33611000	26920	13248	24	0	\N
369837	1874	33613000	26920	13248	25	0	\N
369838	1874	33615000	26920	13248	26	0	\N
369839	1874	33617000	26920	13248	27	0	\N
369840	1874	33620000	26920	13248	28	0	\N
369841	1874	33623000	26920	13248	29	0	\N
369842	1874	33626000	26920	13248	30	0	\N
369843	1874	33627000	26920	13248	31	0	\N
369844	1874	33629000	26920	13248	32	0	\N
369845	1874	33631000	26920	13248	33	0	\N
369846	1874	33634000	26920	13248	34	0	\N
369847	1874	33637000	26920	13248	35	0	\N
369848	1874	33640000	26920	13248	36	0	\N
369849	1874	33642000	26920	13248	37	0	\N
369850	1874	33644000	26920	13248	38	0	\N
369851	1874	33646000	26920	13248	39	0	\N
369852	1874	33648000	26920	13248	40	0	\N
369853	1874	33650000	26920	13248	41	0	\N
369854	1874	33652000	26920	13248	42	0	\N
369855	1874	33654000	26920	13248	43	0	\N
369856	1874	33657000	26920	13248	44	0	\N
369857	1874	33660000	26920	13248	45	0	\N
369858	1874	33663000	26920	13248	46	0	\N
369859	1874	33666000	26920	13248	47	0	\N
369860	1874	33669000	26920	13248	48	0	\N
369861	1874	33672000	26920	13248	49	0	\N
369862	1874	33675000	26920	13248	50	0	\N
369863	1874	33678000	26920	13248	51	0	\N
369864	1874	33681000	26920	13248	52	0	\N
369865	1874	33684000	26920	13248	53	0	\N
369866	1874	33687000	26920	13248	54	0	\N
369867	1874	33690000	26920	13248	55	0	\N
369868	1874	33693000	26920	13248	56	0	\N
369869	1874	33696000	26920	13248	57	0	\N
369870	1874	33699000	26920	13248	58	0	\N
369871	1874	33702000	26920	13248	59	0	\N
369872	1874	33705000	26920	13248	60	0	\N
369873	1874	33707000	26920	13248	61	0	\N
369874	1874	33709000	26920	13248	62	0	\N
369875	1874	33711000	26920	13248	63	0	\N
369876	1874	33713000	26920	13248	64	0	\N
369877	1874	33715000	26920	13248	65	0	\N
369878	1874	33717000	26920	13248	66	0	\N
369879	1874	33719000	26920	13248	67	0	\N
369880	1874	33721000	26920	13248	68	0	\N
369881	1874	33723000	26920	13248	69	0	\N
369882	1874	33725000	26920	13248	70	0	\N
369883	1678	27360856285000	26921	13315	0	0	\N
369884	1874	33728000	26921	13315	1	0	\N
369885	1874	33730000	26921	13315	2	0	\N
369895	1678	27360856287000	26925	13317	0	0	\N
369896	1874	33738000	26925	13317	1	0	\N
369897	1874	33740000	26925	13317	2	0	\N
369901	1678	27360856288000	26927	13318	0	0	\N
369902	1874	33743000	26927	13318	1	0	\N
369903	1874	33745000	26927	13318	2	0	\N
369907	1678	27360856290000	26929	13320	0	0	\N
369908	1678	27360856291000	26929	13320	1	0	\N
369909	1678	27360856292000	26929	13320	2	0	\N
369910	1874	33752000	26929	13320	3	0	\N
369911	1874	33754000	26929	13320	4	0	\N
369912	1874	33756000	26929	13320	5	0	\N
369913	1874	33759000	26929	13320	6	0	\N
369914	1874	33762000	26929	13320	7	0	\N
369915	1874	33765000	26929	13320	9	0	\N
369790	1874	33696000	26914	13310	1	0	2
369791	1874	33698000	26914	13310	2	0	2
369792	1678	27360856279000	26915	13311	0	0	1
369793	1874	33700000	26915	13311	1	0	2
369797	1678	27360856280000	26917	13312	0	0	1
369799	1874	33705000	26917	13312	2	0	2
369800	1678	27360856281000	26918	13313	0	0	1
369801	1678	27360856282000	26918	13313	1	0	1
369802	1874	33707000	26918	13313	2	0	2
369803	1874	33709000	26918	13313	3	0	2
369805	1874	33715000	26918	13313	5	0	2
369806	1678	27360856283000	26919	13314	0	0	1
369807	1678	27360856284000	26919	13314	1	0	1
369808	1874	33717000	26919	13314	2	0	2
369810	1874	33723000	26919	13314	4	0	2
369811	1874	33725000	26919	13314	5	0	2
369886	1678	27360856285000	26922	13315	0	0	1
369887	1874	33728000	26922	13315	1	0	2
369888	1874	33730000	26922	13315	2	0	2
369890	1874	33733000	26923	13316	1	0	2
369891	1874	33735000	26923	13316	2	0	2
369892	1678	27360856287000	26924	13317	0	0	1
369893	1874	33738000	26924	13317	1	0	2
369894	1874	33740000	26924	13317	2	0	2
369899	1874	33743000	26926	13318	1	0	2
369900	1874	33745000	26926	13318	2	0	2
369904	1678	27360856289000	26928	13319	0	0	1
369905	1874	33748000	26928	13319	1	0	2
369916	1678	27360856290000	26930	13320	0	0	1
369917	1678	27360856291000	26930	13320	1	0	1
369918	1678	27360856292000	26930	13320	2	0	1
369919	1874	33752000	26930	13320	3	0	2
369920	1874	33754000	26930	13320	4	0	2
369925	1678	27360856293000	26931	13321	0	0	\N
369926	1678	27360856294000	26931	13321	1	0	\N
369927	1874	33767000	26931	13321	2	0	\N
369928	1874	33770000	26931	13321	3	0	\N
369929	1874	33772000	26931	13321	4	0	\N
369930	1874	33775000	26931	13321	5	0	\N
369937	1678	27360856293000	26933	13321	0	0	\N
369938	1678	27360856294000	26933	13321	1	0	\N
369939	1874	33767000	26933	13321	2	0	\N
369940	1874	33770000	26933	13321	3	0	\N
369941	1874	33772000	26933	13321	4	0	\N
369942	1874	33775000	26933	13321	5	0	\N
369943	1678	27360856293000	26934	13321	0	0	\N
369944	1678	27360856294000	26934	13321	1	0	\N
369945	1874	33767000	26934	13321	2	0	\N
369946	1874	33770000	26934	13321	3	0	\N
369947	1874	33772000	26934	13321	4	0	\N
369948	1874	33775000	26934	13321	5	0	\N
369955	1678	27360856297000	26937	13324	0	0	\N
369956	1874	33787000	26937	13324	1	0	\N
369957	1874	33790000	26937	13324	2	0	\N
369964	1678	27360856298000	26940	13325	0	0	\N
369965	1874	33792000	26940	13325	1	0	\N
369966	1874	33795000	26940	13325	2	0	\N
369976	1678	27360856299000	26942	13326	0	0	\N
369977	1678	27360856300000	26942	13326	1	0	\N
369978	1678	27360856301000	26942	13326	2	0	\N
369979	1874	33798000	26942	13326	3	0	\N
369980	1874	33801000	26942	13326	4	0	\N
369981	1874	33804000	26942	13326	5	0	\N
369982	1874	33806000	26942	13326	6	0	\N
369983	1874	33808000	26942	13326	7	0	\N
369984	1874	33810000	26942	13326	8	0	\N
369997	1678	27360856306000	26944	13328	0	0	\N
369998	1874	33832000	26944	13328	1	0	\N
369999	1874	33835000	26944	13328	2	0	\N
370003	1678	27360856306000	26946	13328	0	0	\N
370004	1874	33832000	26946	13328	1	0	\N
370005	1874	33835000	26946	13328	2	0	\N
370012	1678	27360856308000	26949	13330	0	0	\N
370013	1874	33843000	26949	13330	1	0	\N
370014	1874	33845000	26949	13330	2	0	\N
370015	1678	27360856309000	26950	13331	0	0	\N
370016	1874	33847000	26950	13331	1	0	\N
370017	1874	33850000	26950	13331	2	0	\N
370021	1678	27360856309000	26952	13331	0	0	\N
370022	1874	33847000	26952	13331	1	0	\N
370023	1874	33850000	26952	13331	2	0	\N
370024	1678	27360856310000	26953	13332	0	0	\N
370025	2047	51290000	26953	13332	1	0	\N
370026	1874	33853000	26953	13332	2	0	\N
370027	1874	33855000	26953	13332	3	0	\N
370032	1678	27360856310000	26955	13332	0	0	\N
370033	2047	51290000	26955	13332	1	0	\N
370034	1874	33853000	26955	13332	2	0	\N
370035	1874	33855000	26955	13332	3	0	\N
370036	1678	27360856310000	26956	13332	0	0	\N
370037	2047	51290000	26956	13332	1	0	\N
370038	1874	33853000	26956	13332	2	0	\N
370039	1874	33855000	26956	13332	3	0	\N
370040	2047	51290000	26957	13332	0	0	\N
370041	1874	33853000	26957	13332	1	0	\N
370042	1874	33855000	26957	13332	2	0	\N
370046	1678	27360856306000	26959	13328	0	0	\N
370047	1678	27360856307000	26959	13328	1	0	\N
370048	1678	27360856308000	26959	13328	2	0	\N
370049	1678	27360856309000	26959	13328	3	0	\N
370050	1678	27360856310000	26959	13328	4	0	\N
370051	1874	33832000	26959	13328	5	0	\N
370052	1874	33834000	26959	13328	6	0	\N
370053	2047	51290000	26959	13328	7	0	\N
370054	1874	33836000	26959	13328	8	0	\N
370055	1874	33838000	26959	13328	9	0	\N
370056	1874	33841000	26959	13328	10	0	\N
369923	1874	33762000	26930	13320	7	0	2
369924	1874	33765000	26930	13320	9	0	2
369931	1678	27360856293000	26932	13321	0	0	1
369932	1678	27360856294000	26932	13321	1	0	1
369933	1874	33767000	26932	13321	2	0	2
369935	1874	33772000	26932	13321	4	0	2
369936	1874	33775000	26932	13321	5	0	2
369949	1678	27360856295000	26935	13322	0	0	1
369950	1874	33778000	26935	13322	1	0	2
369951	1874	33780000	26935	13322	2	0	2
369953	1874	33782000	26936	13323	1	0	2
369954	1874	33785000	26936	13323	2	0	2
369958	1678	27360856297000	26938	13324	0	0	1
369959	1874	33787000	26938	13324	1	0	2
369961	1678	27360856298000	26939	13325	0	0	1
369962	1874	33792000	26939	13325	1	0	2
369963	1874	33795000	26939	13325	2	0	2
369967	1678	27360856299000	26941	13326	0	0	1
369968	1678	27360856300000	26941	13326	1	0	1
369970	1874	33798000	26941	13326	3	0	2
369971	1874	33801000	26941	13326	4	0	2
369972	1874	33804000	26941	13326	5	0	2
369973	1874	33806000	26941	13326	6	0	2
369974	1874	33808000	26941	13326	7	0	2
369985	1678	27360856302000	26943	13327	0	0	1
369986	1678	27360856303000	26943	13327	1	0	1
369987	1678	27360856304000	26943	13327	2	0	1
369988	1678	27360856305000	26943	13327	3	0	1
369990	1874	33815000	26943	13327	6	0	2
369991	1874	33817000	26943	13327	7	0	2
369992	1874	33819000	26943	13327	8	0	2
369993	1874	33821000	26943	13327	9	0	2
369994	1874	33824000	26943	13327	10	0	2
369996	1874	33830000	26943	13327	12	0	2
370000	1678	27360856306000	26945	13328	0	0	1
370001	1874	33832000	26945	13328	1	0	2
370002	1874	33835000	26945	13328	2	0	2
370006	1678	27360856307000	26947	13329	0	0	1
370008	1874	33840000	26947	13329	2	0	2
370009	1678	27360856308000	26948	13330	0	0	1
370010	1874	33843000	26948	13330	1	0	2
370011	1874	33845000	26948	13330	2	0	2
370019	1874	33847000	26951	13331	1	0	2
370020	1874	33850000	26951	13331	2	0	2
370028	1678	27360856310000	26954	13332	0	0	1
370029	2047	51290000	26954	13332	1	0	1
370030	1874	33853000	26954	13332	2	0	2
370043	1678	27360856311000	26958	13333	0	0	1
370044	1874	33858000	26958	13333	1	0	2
370045	1874	33860000	26958	13333	2	0	2
370057	1874	33844000	26959	13328	11	0	\N
370058	1874	33847000	26959	13328	12	0	\N
370059	1874	33850000	26959	13328	13	0	\N
370060	1874	33853000	26959	13328	14	0	\N
370061	1874	33855000	26959	13328	15	0	\N
370068	1678	27360856312000	26961	13334	0	0	\N
370069	1678	27360856313000	26961	13334	1	0	\N
370070	1874	33863000	26961	13334	3	0	\N
370071	1874	33865000	26961	13334	4	0	\N
370072	1874	33868000	26961	13334	5	0	\N
370073	1874	33870000	26961	13334	6	0	\N
370074	1678	27360856314000	26962	13335	0	0	\N
370075	1678	27360856315000	26962	13335	1	0	\N
370076	1874	33872000	26962	13335	2	0	\N
370077	1874	33875000	26962	13335	3	0	\N
370078	1874	33877000	26962	13335	4	0	\N
370093	1678	27360856318000	26967	13338	0	0	\N
370094	1874	33890000	26967	13338	1	0	\N
370095	1874	33892000	26967	13338	2	0	\N
370096	1678	27360856318000	26968	13338	0	0	\N
370097	1874	33890000	26968	13338	1	0	\N
370098	1874	33892000	26968	13338	2	0	\N
370099	1678	27360856318000	26969	13338	0	0	\N
370100	1874	33890000	26969	13338	1	0	\N
370101	1874	33892000	26969	13338	2	0	\N
370102	134	66000100000000	26970	13247	0	0	\N
370103	1874	33227000	26970	13247	2	0	\N
370104	1874	33228000	26970	13247	4	0	\N
370105	2047	51290000	26970	13247	5	0	\N
370106	1874	33230000	26970	13247	6	0	\N
370107	1874	33232000	26970	13247	7	0	\N
370108	1874	33234000	26970	13247	8	0	\N
370109	1874	33236000	26970	13247	9	0	\N
370110	1874	33237000	26970	13247	10	0	\N
370111	1874	33238000	26970	13247	11	0	\N
370112	1874	33239000	26970	13247	12	0	\N
370113	1874	33240000	26970	13247	13	0	\N
370114	1874	33241000	26970	13247	14	0	\N
370115	1874	33242000	26970	13247	15	0	\N
370116	1874	33243000	26970	13247	16	0	\N
370117	1874	33244000	26970	13247	17	0	\N
370118	1874	33245000	26970	13247	18	0	\N
370119	1874	33246000	26970	13247	19	0	\N
370120	1874	33248000	26970	13247	20	0	\N
370121	1874	33250000	26970	13247	21	0	\N
370122	1874	33252000	26970	13247	22	0	\N
370123	1874	33254000	26970	13247	23	0	\N
370124	1874	33256000	26970	13247	24	0	\N
370125	1874	33258000	26970	13247	25	0	\N
370126	1874	33260000	26970	13247	26	0	\N
370127	1874	33263000	26970	13247	27	0	\N
370128	1874	33266000	26970	13247	28	0	\N
370129	1874	33269000	26970	13247	29	0	\N
370130	1874	33272000	26970	13247	30	0	\N
370131	1874	33275000	26970	13247	31	0	\N
370132	1874	33278000	26970	13247	32	0	\N
370133	1874	33280000	26970	13247	33	0	\N
370134	1874	33282000	26970	13247	34	0	\N
370135	1874	33285000	26970	13247	35	0	\N
370136	1874	33286000	26970	13247	36	0	\N
370137	1874	33288000	26970	13247	37	0	\N
370138	1874	33290000	26970	13247	38	0	\N
370139	1874	33292000	26970	13247	39	0	\N
370140	1874	33294000	26970	13247	40	0	\N
370141	1874	33296000	26970	13247	41	0	\N
370142	1874	33298000	26970	13247	42	0	\N
370143	1874	33300000	26970	13247	43	0	\N
370144	1874	33302000	26970	13247	44	0	\N
370145	1874	33304000	26970	13247	45	0	\N
370146	1874	33306000	26970	13247	46	0	\N
370147	1874	33308000	26970	13247	47	0	\N
370148	1874	33310000	26970	13247	48	0	\N
370149	1874	33312000	26970	13247	49	0	\N
370150	1874	33314000	26970	13247	50	0	\N
370151	1874	33315000	26970	13247	51	0	\N
370152	1874	33316000	26970	13247	52	0	\N
370153	1874	33317000	26970	13247	53	0	\N
370154	1874	33318000	26970	13247	54	0	\N
370155	1874	33319000	26970	13247	55	0	\N
370156	1874	33320000	26970	13247	56	0	\N
370157	1874	33321000	26970	13247	57	0	\N
370158	1874	33322000	26970	13247	58	0	\N
370159	1874	33323000	26970	13247	59	0	\N
370160	1874	33324000	26970	13247	60	0	\N
370161	1874	33326000	26970	13247	61	0	\N
370162	1874	33328000	26970	13247	62	0	\N
370163	1874	33330000	26970	13247	63	0	\N
370164	1874	33332000	26970	13247	64	0	\N
370165	1874	33334000	26970	13247	65	0	\N
370166	1874	33336000	26970	13247	66	0	\N
370167	1874	33338000	26970	13247	67	0	\N
370168	1874	33340000	26970	13247	68	0	\N
370169	1874	33342000	26970	13247	69	0	\N
370170	1874	33344000	26970	13247	70	0	\N
370171	1874	33346000	26970	13247	71	0	\N
370172	1874	33348000	26970	13247	72	0	\N
370173	1874	33350000	26970	13247	73	0	\N
370174	1874	33352000	26970	13247	74	0	\N
370175	1874	33354000	26970	13247	75	0	\N
370176	1874	33356000	26970	13247	76	0	\N
370177	1874	33358000	26970	13247	77	0	\N
370178	1874	33360000	26970	13247	78	0	\N
370179	1874	33362000	26970	13247	79	0	\N
370180	1874	33364000	26970	13247	80	0	\N
370181	1874	33366000	26970	13247	81	0	\N
370182	1874	33368000	26970	13247	82	0	\N
370183	1874	33370000	26970	13247	83	0	\N
370184	1874	33372000	26970	13247	84	0	\N
370185	1874	33374000	26970	13247	85	0	\N
370186	1874	33376000	26970	13247	86	0	\N
370187	1874	33378000	26970	13247	87	0	\N
370188	1874	33380000	26970	13247	88	0	\N
370189	1874	33382000	26970	13247	89	0	\N
370190	1874	33384000	26970	13247	90	0	\N
370191	1874	33386000	26970	13247	91	0	\N
370192	1874	33388000	26970	13247	92	0	\N
370064	1874	33863000	26960	13334	3	0	2
370065	1874	33865000	26960	13334	4	0	2
370066	1874	33868000	26960	13334	5	0	2
370067	1874	33870000	26960	13334	6	0	2
370079	1678	27360856314000	26963	13335	0	0	1
370081	1874	33872000	26963	13335	2	0	2
370082	1874	33875000	26963	13335	3	0	2
370083	1874	33877000	26963	13335	4	0	2
370084	1678	27360856316000	26964	13336	0	0	1
370085	1874	33880000	26964	13336	1	0	2
370087	1678	27360856317000	26965	13337	0	0	1
370088	1874	33885000	26965	13337	1	0	2
370089	1874	33887000	26965	13337	2	0	2
370090	1678	27360856318000	26966	13338	0	0	1
370092	1874	33892000	26966	13338	2	0	2
370193	1874	33390000	26970	13247	93	0	\N
370194	1874	33392000	26970	13247	94	0	\N
370195	1874	33394000	26970	13247	95	0	\N
370196	1874	33396000	26970	13247	96	0	\N
370197	1874	33398000	26970	13247	97	0	\N
370198	1874	33400000	26970	13247	98	0	\N
370199	1874	33402000	26970	13247	99	0	\N
370200	1874	33404000	26970	13247	100	0	\N
370201	1874	33406000	26970	13247	102	0	\N
370202	1874	33408000	26970	13247	103	0	\N
370203	1874	33410000	26970	13247	104	0	\N
370204	1874	33412000	26970	13247	105	0	\N
370205	1874	33414000	26970	13247	106	0	\N
370206	1874	33416000	26970	13247	107	0	\N
370207	1874	33418000	26970	13247	108	0	\N
370208	1874	33420000	26970	13247	109	0	\N
370209	1874	33422000	26970	13247	110	0	\N
370210	1874	33424000	26970	13247	111	0	\N
370211	1874	33426000	26970	13247	112	0	\N
370212	1874	33428000	26970	13247	113	0	\N
370213	1874	33430000	26970	13247	114	0	\N
370214	1874	33432000	26970	13247	115	0	\N
370215	1874	33434000	26970	13247	116	0	\N
370216	1874	33436000	26970	13247	117	0	\N
370217	1874	33438000	26970	13247	118	0	\N
370218	1874	33440000	26970	13247	119	0	\N
370219	1874	33442000	26970	13247	120	0	\N
370220	1874	33444000	26970	13247	121	0	\N
370221	1874	33446000	26970	13247	122	0	\N
370222	1874	33448000	26970	13247	123	0	\N
370223	1874	33450000	26970	13247	124	0	\N
370224	1874	33452000	26970	13247	125	0	\N
370228	1678	27360856319000	26972	13339	0	0	\N
370229	1874	33894000	26972	13339	1	0	\N
370230	1874	33897000	26972	13339	2	0	\N
370231	1678	27360856319000	26973	13339	0	0	\N
370232	1874	33894000	26973	13339	1	0	\N
370233	1874	33897000	26973	13339	2	0	\N
370234	1678	27360856320000	26974	13340	0	0	\N
370235	1874	33899000	26974	13340	1	0	\N
370236	1874	33902000	26974	13340	2	0	\N
370240	1678	27360856320000	26976	13340	0	0	\N
370241	1874	33899000	26976	13340	1	0	\N
370242	1874	33902000	26976	13340	2	0	\N
370243	1678	27360856320000	26977	13340	0	0	\N
370244	1874	33899000	26977	13340	1	0	\N
370245	1874	33902000	26977	13340	2	0	\N
370246	1678	27360856320000	26978	13340	0	0	\N
370247	1874	33899000	26978	13340	1	0	\N
370248	1874	33902000	26978	13340	2	0	\N
370249	1678	27360856320000	26979	13340	0	0	\N
370250	1874	33899000	26979	13340	1	0	\N
370251	1874	33902000	26979	13340	2	0	\N
370279	1874	33945000	26985	13345	0	0	\N
370280	1874	33947000	26985	13345	1	0	\N
370298	1678	27360856334000	26991	13350	0	0	\N
370299	1874	33974000	26991	13350	1	0	\N
370300	1874	33977000	26991	13350	2	0	\N
370301	1678	27360856334000	26992	13350	0	0	\N
370302	1874	33974000	26992	13350	1	0	\N
370303	1874	33977000	26992	13350	2	0	\N
370304	1678	27360856335000	26993	13351	0	0	\N
370305	1874	33980000	26993	13351	1	0	\N
370306	1874	33982000	26993	13351	2	0	\N
370321	1678	27360856337000	26997	13353	0	0	\N
370322	1678	27360856338000	26997	13353	1	0	\N
370323	1678	27360856339000	26997	13353	2	0	\N
370324	1874	33990000	26997	13353	3	0	\N
370325	1874	33993000	26997	13353	4	0	\N
370326	1874	33995000	26997	13353	5	0	\N
370327	1874	33997000	26997	13353	6	0	\N
370328	1874	33999000	26997	13353	7	0	\N
370227	1874	33897000	26971	13339	2	0	2
370237	1678	27360856320000	26975	13340	0	0	1
370238	1874	33899000	26975	13340	1	0	2
370239	1874	33902000	26975	13340	2	0	2
370252	1874	33904000	26980	13341	0	0	2
370254	1678	27360856321000	26981	13342	0	0	1
370255	1678	27360856322000	26981	13342	1	0	1
370256	1678	27360856323000	26981	13342	2	0	1
370257	1874	33910000	26981	13342	3	0	2
370258	1874	33913000	26981	13342	4	0	2
370260	1874	33917000	26981	13342	6	0	2
370261	1678	27360856324000	26982	13343	0	0	1
370262	1678	27360856325000	26982	13343	1	0	1
370263	1678	27360856326000	26982	13343	2	0	1
370265	1874	33921000	26982	13343	4	0	2
370266	1874	33923000	26982	13343	5	0	2
370267	1874	33926000	26982	13343	6	0	2
370268	1874	33929000	26982	13343	7	0	2
370269	1874	33932000	26982	13343	8	0	2
370271	1678	27360856328000	26983	13344	1	0	1
370272	1874	33934000	26983	13344	2	0	2
370273	1874	33936000	26983	13344	3	0	2
370274	1874	33939000	26983	13344	4	0	2
370275	1874	33942000	26983	13344	5	0	2
370277	1874	33945000	26984	13345	1	0	2
370278	1874	33947000	26984	13345	2	0	2
370281	1678	27360856330000	26986	13346	0	0	1
370282	1874	33949000	26986	13346	1	0	2
370284	1874	33954000	26987	13347	0	0	2
370285	1874	33957000	26987	13347	1	0	2
370286	1678	27360856331000	26988	13348	0	0	1
370287	1874	33959000	26988	13348	1	0	2
370288	1874	33962000	26988	13348	2	0	2
370290	1678	27360856333000	26989	13349	1	0	1
370291	1874	33965000	26989	13349	2	0	2
370292	1874	33968000	26989	13349	3	0	2
370293	1874	33970000	26989	13349	4	0	2
370294	1874	33972000	26989	13349	5	0	2
370296	1874	33974000	26990	13350	1	0	2
370297	1874	33977000	26990	13350	2	0	2
370307	1678	27360856335000	26994	13351	0	0	1
370308	1874	33980000	26994	13351	1	0	2
370310	1678	27360856336000	26995	13352	0	0	1
370311	1874	33984000	26995	13352	1	0	2
370312	1874	33987000	26995	13352	2	0	2
370313	1678	27360856337000	26996	13353	0	0	1
370314	1678	27360856338000	26996	13353	1	0	1
370316	1874	33990000	26996	13353	3	0	2
370317	1874	33993000	26996	13353	4	0	2
370318	1874	33995000	26996	13353	5	0	2
370319	1874	33997000	26996	13353	6	0	2
370320	1874	33999000	26996	13353	7	0	2
370329	1678	27360856340000	26998	13354	0	0	\N
370330	1874	34002000	26998	13354	1	0	\N
370331	1874	34004000	26998	13354	2	0	\N
370337	1678	27360856341000	27001	13355	0	0	\N
370338	1874	34007000	27001	13355	1	0	\N
370346	1678	27360856343000	27004	13357	0	0	\N
370347	1874	34017000	27004	13357	1	0	\N
370348	1874	34019000	27004	13357	2	0	\N
370349	1678	27360856344000	27005	13358	0	0	\N
370350	1678	27360856345000	27005	13358	1	0	\N
370351	1874	34021000	27005	13358	2	0	\N
370352	1874	34023000	27005	13358	3	0	\N
370353	1874	34026000	27005	13358	4	0	\N
370354	1874	34029000	27005	13358	5	0	\N
370355	1678	27360856344000	27006	13358	0	0	\N
370356	1678	27360856345000	27006	13358	1	0	\N
370357	1874	34021000	27006	13358	2	0	\N
370358	1874	34023000	27006	13358	3	0	\N
370359	1874	34026000	27006	13358	4	0	\N
370360	1874	34029000	27006	13358	5	0	\N
370367	1678	27360856344000	27008	13358	0	0	\N
370368	1678	27360856345000	27008	13358	1	0	\N
370369	1874	34021000	27008	13358	2	0	\N
370370	1874	34023000	27008	13358	3	0	\N
370371	1874	34026000	27008	13358	4	0	\N
370372	1874	34029000	27008	13358	5	0	\N
370376	1874	34031000	27010	13359	0	0	\N
370377	1678	27360856346000	27011	13359	0	0	\N
370378	1874	34032000	27011	13359	1	0	\N
370379	1874	34034000	27011	13359	2	0	\N
370386	1678	27360856349000	27013	13361	0	0	\N
370387	1874	34046000	27013	13361	2	0	\N
370388	1874	34049000	27013	13361	3	0	\N
370389	1678	27360856349000	27014	13361	0	0	\N
370390	1874	34046000	27014	13361	2	0	\N
370391	1874	34049000	27014	13361	3	0	\N
370392	1678	27360856349000	27015	13361	0	0	\N
370393	1874	34046000	27015	13361	2	0	\N
370394	1874	34049000	27015	13361	3	0	\N
370400	1678	27360856351000	27018	13363	0	0	\N
370401	1874	34054000	27018	13363	1	0	\N
370402	1874	34057000	27018	13363	2	0	\N
370403	1678	27360856351000	27019	13363	0	0	\N
370404	1874	34054000	27019	13363	1	0	\N
370408	1678	27360856351000	27021	13363	0	0	\N
370409	1874	34054000	27021	13363	1	0	\N
370410	1874	34057000	27021	13363	2	0	\N
370414	1678	27360856353000	27023	13365	0	0	\N
370415	1874	34065000	27023	13365	1	0	\N
370416	1874	34067000	27023	13365	2	0	\N
370420	1678	27360856354000	27025	13366	0	0	\N
370421	1874	34070000	27025	13366	1	0	\N
370422	1874	34072000	27025	13366	2	0	\N
370425	1678	27360856279000	27027	13311	0	0	\N
370426	1678	27360856280000	27027	13311	1	0	\N
370427	1678	27360856281000	27027	13311	2	0	\N
370428	1678	27360856282000	27027	13311	3	0	\N
370429	1678	27360856283000	27027	13311	4	0	\N
370430	1678	27360856284000	27027	13311	5	0	\N
370431	1678	27360856285000	27027	13311	6	0	\N
370432	1678	27360856286000	27027	13311	7	0	\N
370433	1678	27360856287000	27027	13311	8	0	\N
370434	1678	27360856288000	27027	13311	9	0	\N
370435	1678	27360856289000	27027	13311	10	0	\N
370436	1678	27360856290000	27027	13311	11	0	\N
370437	1678	27360856291000	27027	13311	12	0	\N
370438	1678	27360856292000	27027	13311	13	0	\N
370439	1678	27360856293000	27027	13311	14	0	\N
370440	1678	27360856294000	27027	13311	15	0	\N
370441	1678	27360856295000	27027	13311	16	0	\N
370442	1678	27360856296000	27027	13311	17	0	\N
370443	1678	27360856297000	27027	13311	18	0	\N
370444	1678	27360856298000	27027	13311	19	0	\N
370445	1678	27360856299000	27027	13311	20	0	\N
370446	1678	27360856300000	27027	13311	21	0	\N
370447	1678	27360856301000	27027	13311	22	0	\N
370448	1678	27360856302000	27027	13311	23	0	\N
370449	1678	27360856303000	27027	13311	24	0	\N
370450	1678	27360856304000	27027	13311	25	0	\N
370451	1678	27360856305000	27027	13311	26	0	\N
370452	1678	27360856306000	27027	13311	27	0	\N
370453	1678	27360856307000	27027	13311	28	0	\N
370454	1678	27360856308000	27027	13311	29	0	\N
370455	1678	27360856309000	27027	13311	30	0	\N
370456	1678	27360856310000	27027	13311	31	0	\N
370457	1678	27360856311000	27027	13311	32	0	\N
370458	1678	27360856312000	27027	13311	33	0	\N
370459	1678	27360856313000	27027	13311	34	0	\N
370460	1678	27360856314000	27027	13311	35	0	\N
370461	1678	27360856315000	27027	13311	36	0	\N
370462	1678	27360856316000	27027	13311	37	0	\N
370463	1678	27360856317000	27027	13311	38	0	\N
370464	1678	27360856318000	27027	13311	39	0	\N
370334	1874	34004000	26999	13354	2	0	2
370335	1678	27360856341000	27000	13355	0	0	1
370336	1874	34007000	27000	13355	1	0	2
370339	1678	27360856342000	27002	13356	0	0	1
370340	1874	34009000	27002	13356	1	0	2
370342	1874	34014000	27002	13356	3	0	2
370343	1678	27360856343000	27003	13357	0	0	1
370344	1874	34017000	27003	13357	1	0	2
370345	1874	34019000	27003	13357	2	0	2
370361	1678	27360856344000	27007	13358	0	0	1
370363	1874	34021000	27007	13358	2	0	2
370364	1874	34023000	27007	13358	3	0	2
370365	1874	34026000	27007	13358	4	0	2
370366	1874	34029000	27007	13358	5	0	2
370374	1874	34032000	27009	13359	1	0	2
370375	1874	34034000	27009	13359	2	0	2
370380	1678	27360856347000	27012	13360	0	0	1
370381	1678	27360856348000	27012	13360	1	0	1
370382	1874	34036000	27012	13360	2	0	2
370384	1874	34041000	27012	13360	4	0	2
370385	1874	34044000	27012	13360	5	0	2
370395	1678	27360856349000	27016	13361	0	0	1
370396	1874	34046000	27016	13361	2	0	2
370397	1874	34049000	27016	13361	3	0	2
370399	1874	34052000	27017	13362	1	0	2
370405	1678	27360856351000	27020	13363	0	0	1
370406	1874	34054000	27020	13363	1	0	2
370407	1874	34057000	27020	13363	2	0	2
370412	1874	34060000	27022	13364	1	0	2
370413	1874	34062000	27022	13364	2	0	2
370417	1678	27360856353000	27024	13365	0	0	1
370418	1874	34065000	27024	13365	1	0	2
370419	1874	34067000	27024	13365	2	0	2
370424	1874	34072000	27026	13366	1	0	2
370465	1678	27360856319000	27027	13311	40	0	\N
370466	1678	27360856320000	27027	13311	41	0	\N
370467	1678	27360856321000	27027	13311	42	0	\N
370468	1678	27360856322000	27027	13311	43	0	\N
370469	1678	27360856323000	27027	13311	44	0	\N
370470	1678	27360856324000	27027	13311	45	0	\N
370471	1678	27360856325000	27027	13311	46	0	\N
370472	1678	27360856326000	27027	13311	47	0	\N
370473	1678	27360856327000	27027	13311	48	0	\N
370474	1678	27360856328000	27027	13311	49	0	\N
370475	1678	27360856329000	27027	13311	50	0	\N
370476	1678	27360856330000	27027	13311	51	0	\N
370477	1678	27360856331000	27027	13311	52	0	\N
370478	1678	27360856332000	27027	13311	53	0	\N
370479	1678	27360856333000	27027	13311	54	0	\N
370480	1678	27360856334000	27027	13311	55	0	\N
370481	1678	27360856335000	27027	13311	56	0	\N
370482	1678	27360856336000	27027	13311	57	0	\N
370483	1678	27360856337000	27027	13311	59	0	\N
370484	1678	27360856338000	27027	13311	60	0	\N
370485	1678	27360856339000	27027	13311	61	0	\N
370486	1678	27360856340000	27027	13311	62	0	\N
370487	1678	27360856341000	27027	13311	63	0	\N
370488	1678	27360856342000	27027	13311	64	0	\N
370489	1678	27360856343000	27027	13311	65	0	\N
370490	1678	27360856344000	27027	13311	66	0	\N
370491	1678	27360856345000	27027	13311	67	0	\N
370492	1678	27360856346000	27027	13311	68	0	\N
370493	1678	27360856347000	27027	13311	69	0	\N
370494	1678	27360856348000	27027	13311	70	0	\N
370495	1678	27360856349000	27027	13311	71	0	\N
370496	1678	27360856350000	27027	13311	72	0	\N
370497	1678	27360856351000	27027	13311	73	0	\N
370498	1678	27360856352000	27027	13311	74	0	\N
370499	1678	27360856353000	27027	13311	75	0	\N
370500	1678	27360856354000	27027	13311	76	0	\N
370501	2047	51290000	27027	13311	79	0	\N
370502	1874	33700000	27027	13311	80	0	\N
370503	1874	33702000	27027	13311	81	0	\N
370504	1874	33704000	27027	13311	82	0	\N
370505	1874	33706000	27027	13311	83	0	\N
370506	1874	33708000	27027	13311	84	0	\N
370507	1874	33710000	27027	13311	85	0	\N
370508	1874	33712000	27027	13311	86	0	\N
370509	1874	33715000	27027	13311	87	0	\N
370510	1874	33718000	27027	13311	88	0	\N
370511	1874	33720000	27027	13311	89	0	\N
370512	1874	33722000	27027	13311	90	0	\N
370513	1874	33724000	27027	13311	91	0	\N
370514	1874	33726000	27027	13311	92	0	\N
370515	1874	33728000	27027	13311	93	0	\N
370516	1874	33730000	27027	13311	94	0	\N
370517	1874	33732000	27027	13311	95	0	\N
370518	1874	33734000	27027	13311	96	0	\N
370519	1874	33736000	27027	13311	97	0	\N
370520	1874	33738000	27027	13311	98	0	\N
370521	1874	33740000	27027	13311	99	0	\N
370522	1874	33742000	27027	13311	100	0	\N
370523	1874	33744000	27027	13311	101	0	\N
370524	1874	33746000	27027	13311	102	0	\N
370525	1874	33748000	27027	13311	103	0	\N
370526	1874	33750000	27027	13311	104	0	\N
370527	1874	33752000	27027	13311	105	0	\N
370528	1874	33754000	27027	13311	106	0	\N
370529	1874	33756000	27027	13311	107	0	\N
370530	1874	33758000	27027	13311	108	0	\N
370531	1874	33760000	27027	13311	109	0	\N
370532	1874	33762000	27027	13311	110	0	\N
370533	1874	33764000	27027	13311	111	0	\N
370534	1874	33766000	27027	13311	112	0	\N
370535	1874	33768000	27027	13311	113	0	\N
370536	1874	33770000	27027	13311	114	0	\N
370537	1874	33772000	27027	13311	115	0	\N
370538	1874	33774000	27027	13311	116	0	\N
370539	1874	33776000	27027	13311	117	0	\N
370540	1874	33778000	27027	13311	118	0	\N
370541	1874	33780000	27027	13311	119	0	\N
370542	1874	33782000	27027	13311	120	0	\N
370543	1874	33784000	27027	13311	121	0	\N
370544	1874	33786000	27027	13311	122	0	\N
370545	1874	33788000	27027	13311	123	0	\N
370546	1874	33790000	27027	13311	124	0	\N
370547	1874	33792000	27027	13311	125	0	\N
370548	1678	27360856354000	27028	13367	0	0	\N
370549	1678	27360856355000	27028	13367	1	0	\N
370550	1874	34075000	27028	13367	2	0	\N
370551	1874	34077000	27028	13367	3	0	\N
370556	1678	27360856342000	27030	13356	0	0	\N
370557	1678	27360856343000	27030	13356	1	0	\N
370558	1678	27360856344000	27030	13356	2	0	\N
370559	1678	27360856345000	27030	13356	3	0	\N
370560	1678	27360856346000	27030	13356	4	0	\N
370561	1678	27360856347000	27030	13356	5	0	\N
370562	1678	27360856348000	27030	13356	6	0	\N
370563	1678	27360856349000	27030	13356	7	0	\N
370564	1678	27360856350000	27030	13356	8	0	\N
370565	1678	27360856351000	27030	13356	9	0	\N
370566	1678	27360856352000	27030	13356	10	0	\N
370567	1678	27360856353000	27030	13356	11	0	\N
370568	1678	27360856354000	27030	13356	12	0	\N
370569	1678	27360856355000	27030	13356	13	0	\N
370570	1678	27360856356000	27030	13356	14	0	\N
370571	1874	34009000	27030	13356	15	0	\N
370572	1874	34011000	27030	13356	16	0	\N
370573	1874	34013000	27030	13356	17	0	\N
370574	1874	34015000	27030	13356	18	0	\N
370575	1874	34018000	27030	13356	19	0	\N
370576	1874	34021000	27030	13356	20	0	\N
370577	1874	34023000	27030	13356	21	0	\N
370578	1874	34025000	27030	13356	22	0	\N
370579	1874	34027000	27030	13356	23	0	\N
370580	1874	34029000	27030	13356	24	0	\N
370581	1874	34031000	27030	13356	25	0	\N
370582	1874	34033000	27030	13356	26	0	\N
370583	1874	34035000	27030	13356	27	0	\N
370584	1874	34037000	27030	13356	28	0	\N
370585	1874	34039000	27030	13356	29	0	\N
370586	1874	34041000	27030	13356	30	0	\N
370587	1874	34043000	27030	13356	31	0	\N
370588	1874	34046000	27030	13356	32	0	\N
370589	1678	27360856356000	27031	13368	0	0	\N
370590	1874	34080000	27031	13368	1	0	\N
370591	1874	34082000	27031	13368	2	0	\N
370595	1678	27360856356000	27033	13368	0	0	\N
370596	1874	34080000	27033	13368	1	0	\N
370597	1874	34082000	27033	13368	2	0	\N
370598	1678	27360856356000	27034	13368	0	0	\N
370599	1874	34079000	27034	13368	1	0	\N
370554	1874	34075000	27029	13367	2	0	2
370555	1874	34077000	27029	13367	3	0	2
370592	1678	27360856356000	27032	13368	0	0	1
370593	1874	34080000	27032	13368	1	0	2
370594	1874	34082000	27032	13368	2	0	2
370604	1678	27360856357000	27036	13369	0	0	\N
370605	1874	34085000	27036	13369	1	0	\N
370606	1874	34087000	27036	13369	2	0	\N
370607	2370	100000000	27036	13369	3	0	\N
370608	1678	27360856357000	27037	13369	0	0	\N
370609	1874	34084000	27037	13369	1	0	\N
370610	2370	100000000	27037	13369	2	0	\N
370611	1678	27360856358000	27038	13370	0	0	\N
370612	1874	34089000	27038	13370	1	0	\N
370613	2371	100000000	27038	13370	2	0	\N
370614	2372	100000000	27038	13370	3	0	\N
370615	2373	100000000	27038	13370	4	0	\N
370616	2370	100000000	27039	13360	0	0	\N
370617	2371	100000000	27039	13360	1	0	\N
370618	2372	100000000	27039	13360	2	0	\N
370619	2373	100000000	27039	13360	3	0	\N
370620	1678	27360856358000	27040	13370	0	0	\N
370621	1874	34089000	27040	13370	1	0	\N
370622	2371	100000000	27040	13370	2	0	\N
370623	2372	100000000	27040	13370	3	0	\N
370624	2373	100000000	27040	13370	4	0	\N
370625	1678	27360856285000	27041	13249	0	0	\N
370626	1678	27360856286000	27041	13249	1	0	\N
370627	1678	27360856287000	27041	13249	2	0	\N
370628	1678	27360856288000	27041	13249	3	0	\N
370629	1678	27360856289000	27041	13249	4	0	\N
370630	1678	27360856290000	27041	13249	5	0	\N
370631	1678	27360856291000	27041	13249	6	0	\N
370632	1678	27360856292000	27041	13249	7	0	\N
370633	1678	27360856293000	27041	13249	8	0	\N
370634	1678	27360856294000	27041	13249	9	0	\N
370635	1678	27360856295000	27041	13249	10	0	\N
370636	1678	27360856296000	27041	13249	11	0	\N
370637	1678	27360856297000	27041	13249	12	0	\N
370638	1678	27360856298000	27041	13249	13	0	\N
370639	1678	27360856299000	27041	13249	14	0	\N
370640	1678	27360856300000	27041	13249	15	0	\N
370641	1678	27360856301000	27041	13249	16	0	\N
370642	1678	27360856302000	27041	13249	17	0	\N
370643	1678	27360856303000	27041	13249	18	0	\N
370644	1678	27360856304000	27041	13249	19	0	\N
370645	1678	27360856305000	27041	13249	20	0	\N
370646	1678	27360856306000	27041	13249	21	0	\N
370647	1678	27360856307000	27041	13249	22	0	\N
370648	1678	27360856308000	27041	13249	23	0	\N
370649	1678	27360856309000	27041	13249	24	0	\N
370650	1678	27360856310000	27041	13249	25	0	\N
370651	1678	27360856311000	27041	13249	26	0	\N
370652	1678	27360856312000	27041	13249	27	0	\N
370653	1678	27360856313000	27041	13249	28	0	\N
370654	1678	27360856314000	27041	13249	29	0	\N
370655	1678	27360856315000	27041	13249	30	0	\N
370656	1678	27360856316000	27041	13249	31	0	\N
370657	1678	27360856317000	27041	13249	32	0	\N
370658	1678	27360856318000	27041	13249	33	0	\N
370659	1678	27360856319000	27041	13249	34	0	\N
370660	1678	27360856320000	27041	13249	35	0	\N
370661	1678	27360856321000	27041	13249	36	0	\N
370662	1678	27360856322000	27041	13249	37	0	\N
370663	1678	27360856323000	27041	13249	39	0	\N
370664	1678	27360856324000	27041	13249	40	0	\N
370665	1678	27360856358000	27042	13370	0	0	\N
370666	1874	34089000	27042	13370	1	0	\N
370667	2371	100000000	27042	13370	2	0	\N
370668	2372	100000000	27042	13370	3	0	\N
370669	2373	100000000	27042	13370	4	0	\N
370675	1678	27360856159000	27044	13233	0	0	\N
370676	134	66000100000000	27044	13233	1	0	\N
370677	1874	33081000	27044	13233	3	0	\N
370678	1874	33083000	27044	13233	4	0	\N
370679	2047	51290000	27044	13233	6	0	\N
370680	1874	33086000	27044	13233	7	0	\N
370681	2367	100000000	27044	13233	8	0	\N
370682	2368	100000000	27044	13233	9	0	\N
370683	2370	100000000	27044	13233	10	0	\N
370684	2371	100000000	27044	13233	11	0	\N
370685	2372	100000000	27044	13233	12	0	\N
370686	2373	100000000	27044	13233	13	0	\N
370696	1678	27360856360000	27047	13372	0	0	\N
370697	1678	27360856361000	27047	13372	1	0	\N
370698	1874	34096000	27047	13372	2	0	\N
370699	1874	34099000	27047	13372	3	0	\N
370700	1874	34102000	27047	13372	4	0	\N
370701	1874	34104000	27047	13372	5	0	\N
370708	1678	27360856362000	27049	13373	0	0	\N
370709	1678	27360856363000	27049	13373	1	0	\N
370710	1874	34107000	27049	13373	2	0	\N
370711	1874	34110000	27049	13373	3	0	\N
370712	1874	34112000	27049	13373	4	0	\N
370713	1874	34114000	27049	13373	5	0	\N
370714	1678	27360856364000	27050	13374	0	0	\N
370715	1874	34117000	27050	13374	1	0	\N
370716	1874	34119000	27050	13374	2	0	\N
370717	1678	27360856364000	27051	13374	0	0	\N
370718	1874	34117000	27051	13374	1	0	\N
370719	1874	34119000	27051	13374	2	0	\N
370721	1678	27360856288000	27053	13318	0	0	\N
370722	1678	27360856289000	27053	13318	1	0	\N
370723	1678	27360856290000	27053	13318	2	0	\N
370724	1678	27360856291000	27053	13318	3	0	\N
370725	1678	27360856292000	27053	13318	4	0	\N
370726	1678	27360856293000	27053	13318	5	0	\N
370727	1678	27360856294000	27053	13318	6	0	\N
370728	1678	27360856295000	27053	13318	7	0	\N
370729	1678	27360856296000	27053	13318	8	0	\N
370730	1678	27360856297000	27053	13318	9	0	\N
370731	1678	27360856298000	27053	13318	10	0	\N
370732	1678	27360856299000	27053	13318	11	0	\N
370733	1678	27360856300000	27053	13318	12	0	\N
370734	1678	27360856301000	27053	13318	13	0	\N
370735	1678	27360856302000	27053	13318	14	0	\N
370736	1678	27360856303000	27053	13318	15	0	\N
370603	2370	100000000	27035	13369	3	0	0
370670	1678	27360856358000	27043	13370	0	0	1
370671	1874	34089000	27043	13370	1	0	2
370672	2371	100000000	27043	13370	2	0	0
370673	2372	100000000	27043	13370	3	0	0
370687	1678	27360856359000	27045	13371	0	0	1
370688	1874	34091000	27045	13371	1	0	2
370689	1874	34094000	27045	13371	2	0	2
370690	1678	27360856360000	27046	13372	0	0	1
370691	1678	27360856361000	27046	13372	1	0	1
370693	1874	34099000	27046	13372	3	0	2
370694	1874	34102000	27046	13372	4	0	2
370695	1874	34104000	27046	13372	5	0	2
370702	1678	27360856362000	27048	13373	0	0	1
370704	1874	34107000	27048	13373	2	0	2
370705	1874	34110000	27048	13373	3	0	2
370706	1874	34112000	27048	13373	4	0	2
370707	1874	34114000	27048	13373	5	0	2
370720	1874	34117000	27052	13374	0	0	2
370737	1678	27360856304000	27053	13318	16	0	\N
370746	1678	27360856364000	27055	13375	0	0	\N
370747	1678	27360856365000	27055	13375	1	0	\N
370748	1678	27360856366000	27055	13375	2	0	\N
370749	1874	34120000	27055	13375	3	0	\N
370750	1874	34123000	27055	13375	4	0	\N
370751	1874	34125000	27055	13375	5	0	\N
370752	1874	34127000	27055	13375	6	0	\N
370753	1874	34129000	27055	13375	7	0	\N
370760	1678	27360856367000	27057	13376	0	0	\N
370761	1678	27360856368000	27057	13376	1	0	\N
370762	1874	34131000	27057	13376	2	0	\N
370763	1874	34134000	27057	13376	3	0	\N
370764	1874	34136000	27057	13376	4	0	\N
370765	1874	34139000	27057	13376	5	0	\N
370766	1678	27360856369000	27058	13377	0	0	\N
370767	1874	34141000	27058	13377	1	0	\N
370768	1874	34144000	27058	13377	2	0	\N
370791	1678	27360856375000	27065	13382	0	0	\N
370798	1678	27360856375000	27067	13382	0	0	\N
370799	1678	27360856376000	27067	13382	2	0	\N
370800	1874	34171000	27067	13382	3	0	\N
370801	1874	34173000	27067	13382	4	0	\N
370802	1874	34176000	27067	13382	5	0	\N
370803	1874	34179000	27067	13382	6	0	\N
370804	1678	27360856375000	27068	13382	0	0	\N
370805	1678	27360856376000	27068	13382	2	0	\N
370806	1874	34171000	27068	13382	3	0	\N
370807	1874	34173000	27068	13382	4	0	\N
370808	1874	34176000	27068	13382	5	0	\N
370809	1874	34179000	27068	13382	6	0	\N
370810	1874	33454000	27069	13248	0	0	\N
370811	1874	33456000	27069	13248	1	0	\N
370812	1874	33458000	27069	13248	2	0	\N
370813	1874	33460000	27069	13248	3	0	\N
370814	1874	33462000	27069	13248	4	0	\N
370815	1874	33464000	27069	13248	5	0	\N
370816	1874	33466000	27069	13248	6	0	\N
370817	975	508248127862876	27069	13248	7	0	\N
370818	1095	910776290460314	27069	13248	8	0	\N
370819	1215	614518911673154	27069	13248	9	0	\N
370820	1341	1712411587352407	27069	13248	10	0	\N
370821	1874	33468000	27069	13248	12	0	\N
370822	1874	33470000	27069	13248	13	0	\N
370823	1874	33472000	27069	13248	14	0	\N
370824	1874	33474000	27069	13248	15	0	\N
370825	1874	33476000	27069	13248	16	0	\N
370826	1874	33478000	27069	13248	17	0	\N
370827	1874	33480000	27069	13248	18	0	\N
370828	1874	33482000	27069	13248	19	0	\N
370829	1874	33484000	27069	13248	20	0	\N
370830	1874	33486000	27069	13248	21	0	\N
370831	1874	33488000	27069	13248	22	0	\N
370832	1874	33490000	27069	13248	23	0	\N
370833	1874	33492000	27069	13248	24	0	\N
370834	1874	33494000	27069	13248	25	0	\N
370835	1874	33496000	27069	13248	26	0	\N
370836	1874	33498000	27069	13248	27	0	\N
370837	1874	33500000	27069	13248	28	0	\N
370838	1874	33502000	27069	13248	29	0	\N
370839	1874	33504000	27069	13248	30	0	\N
370840	1874	33506000	27069	13248	31	0	\N
370841	1874	33508000	27069	13248	32	0	\N
370842	1874	33510000	27069	13248	33	0	\N
370843	1874	33512000	27069	13248	34	0	\N
370844	1874	33514000	27069	13248	35	0	\N
370845	2370	100000000	27069	13248	36	0	\N
370846	2371	100000000	27069	13248	37	0	\N
370847	2372	100000000	27069	13248	38	0	\N
370848	2373	100000000	27069	13248	39	0	\N
370849	1874	33516000	27069	13248	40	0	\N
370850	1874	33518000	27069	13248	41	0	\N
370851	1874	33520000	27069	13248	42	0	\N
370852	1874	33522000	27069	13248	43	0	\N
370853	1874	33524000	27069	13248	44	0	\N
370854	1874	33526000	27069	13248	45	0	\N
370855	1874	33528000	27069	13248	46	0	\N
370856	1874	33530000	27069	13248	47	0	\N
370857	1874	33532000	27069	13248	48	0	\N
370858	1874	33534000	27069	13248	49	0	\N
370859	1874	33536000	27069	13248	50	0	\N
370860	1874	33538000	27069	13248	51	0	\N
370861	1874	33540000	27069	13248	52	0	\N
370862	1874	33542000	27069	13248	53	0	\N
370863	1874	33544000	27069	13248	54	0	\N
370864	1874	33546000	27069	13248	55	0	\N
370865	1874	33548000	27069	13248	56	0	\N
370866	1874	33550000	27069	13248	57	0	\N
370867	1874	33552000	27069	13248	58	0	\N
370868	1874	33554000	27069	13248	59	0	\N
370869	1874	33556000	27069	13248	60	0	\N
370870	1874	33558000	27069	13248	61	0	\N
370871	1874	33560000	27069	13248	62	0	\N
370872	1874	33562000	27069	13248	63	0	\N
370740	1678	27360856366000	27054	13375	2	0	1
370741	1874	34120000	27054	13375	3	0	2
370742	1874	34123000	27054	13375	4	0	2
370743	1874	34125000	27054	13375	5	0	2
370744	1874	34127000	27054	13375	6	0	2
370754	1678	27360856367000	27056	13376	0	0	1
370755	1678	27360856368000	27056	13376	1	0	1
370756	1874	34131000	27056	13376	2	0	2
370757	1874	34134000	27056	13376	3	0	2
370758	1874	34136000	27056	13376	4	0	2
370769	1678	27360856369000	27059	13377	0	0	1
370770	1874	34141000	27059	13377	1	0	2
370771	1874	34144000	27059	13377	2	0	2
370772	1678	27360856370000	27060	13378	0	0	1
370774	1874	34149000	27060	13378	2	0	2
370775	1678	27360856371000	27061	13379	0	0	1
370776	1678	27360856372000	27061	13379	1	0	1
370777	1874	34151000	27061	13379	2	0	2
370778	1874	34153000	27061	13379	3	0	2
370780	1874	34159000	27061	13379	5	0	2
370781	1678	27360856373000	27062	13380	0	0	1
370782	1874	34161000	27062	13380	1	0	2
370783	975	508248127862876	27062	13380	2	0	0
370784	1095	910776290460314	27062	13380	3	0	0
370786	1341	1712411587352407	27062	13380	5	0	0
370787	1874	34164000	27062	13380	7	0	2
370788	1678	27360856374000	27063	13381	0	0	1
370789	1874	34166000	27063	13381	1	0	2
370792	1678	27360856375000	27066	13382	0	0	1
370793	1678	27360856376000	27066	13382	2	0	1
370794	1874	34171000	27066	13382	3	0	2
370795	1874	34173000	27066	13382	4	0	2
370796	1874	34176000	27066	13382	5	0	2
370873	1874	33564000	27069	13248	64	0	\N
370874	1874	33566000	27069	13248	65	0	\N
370875	1874	33568000	27069	13248	66	0	\N
370876	1874	33570000	27069	13248	67	0	\N
370877	1874	33572000	27069	13248	68	0	\N
370878	1874	33574000	27069	13248	69	0	\N
370879	1874	33576000	27069	13248	70	0	\N
370880	1874	33578000	27069	13248	71	0	\N
370881	1874	33580000	27069	13248	72	0	\N
370882	1874	33582000	27069	13248	73	0	\N
370883	1874	33584000	27069	13248	74	0	\N
370884	1874	33586000	27069	13248	75	0	\N
370885	1874	33588000	27069	13248	76	0	\N
370886	1874	33590000	27069	13248	77	0	\N
370887	1874	33592000	27069	13248	78	0	\N
370888	1874	33594000	27069	13248	79	0	\N
370889	1874	33596000	27069	13248	80	0	\N
370890	1874	33598000	27069	13248	81	0	\N
370891	1874	33600000	27069	13248	82	0	\N
370892	1874	33602000	27069	13248	83	0	\N
370893	1874	33604000	27069	13248	84	0	\N
370894	1874	33606000	27069	13248	85	0	\N
370895	1874	33608000	27069	13248	86	0	\N
370896	1874	33610000	27069	13248	87	0	\N
370897	1874	33612000	27069	13248	88	0	\N
370898	1874	33614000	27069	13248	89	0	\N
370899	1874	33616000	27069	13248	90	0	\N
370900	1874	33618000	27069	13248	91	0	\N
370901	1874	33620000	27069	13248	92	0	\N
370902	1874	33623000	27069	13248	93	0	\N
370903	1874	33626000	27069	13248	94	0	\N
370904	1874	33629000	27069	13248	95	0	\N
370905	1874	33632000	27069	13248	96	0	\N
370906	1874	33635000	27069	13248	97	0	\N
370907	1874	33638000	27069	13248	98	0	\N
370908	1874	33641000	27069	13248	99	0	\N
370909	1874	33644000	27069	13248	100	0	\N
370910	1874	33647000	27069	13248	102	0	\N
370911	1874	33650000	27069	13248	103	0	\N
370912	1874	33653000	27069	13248	104	0	\N
370913	1874	33656000	27069	13248	105	0	\N
370914	1874	33659000	27069	13248	106	0	\N
370915	1874	33662000	27069	13248	107	0	\N
370916	1874	33665000	27069	13248	108	0	\N
370917	1874	33668000	27069	13248	109	0	\N
370918	1874	33671000	27069	13248	110	0	\N
370919	1874	33674000	27069	13248	111	0	\N
370920	1874	33677000	27069	13248	112	0	\N
370921	1874	33680000	27069	13248	113	0	\N
370922	1874	33683000	27069	13248	114	0	\N
370923	1874	33686000	27069	13248	115	0	\N
370924	1874	33689000	27069	13248	116	0	\N
370925	1874	33692000	27069	13248	117	0	\N
370926	1874	33695000	27069	13248	118	0	\N
370927	1874	33698000	27069	13248	119	0	\N
370928	1874	33701000	27069	13248	120	0	\N
370929	1874	33704000	27069	13248	121	0	\N
370930	1874	33707000	27069	13248	122	0	\N
370931	1874	33710000	27069	13248	123	0	\N
370932	1874	33713000	27069	13248	124	0	\N
370933	1874	33716000	27069	13248	125	0	\N
370940	1678	27360856377000	27071	13383	0	0	\N
370941	1678	27360856378000	27071	13383	1	0	\N
370942	1874	34181000	27071	13383	2	0	\N
370943	1874	34184000	27071	13383	3	0	\N
370944	1874	34187000	27071	13383	4	0	\N
370945	1874	34189000	27071	13383	5	0	\N
370946	1678	27360856379000	27072	13384	0	0	\N
370947	1874	34192000	27072	13384	1	0	\N
370954	1678	27360856380000	27075	13385	0	0	\N
370955	1874	34196000	27075	13385	1	0	\N
370956	1874	34199000	27075	13385	2	0	\N
370962	1678	27360856383000	27077	13387	0	0	\N
370963	1874	34208000	27077	13387	1	0	\N
370964	1874	34211000	27077	13387	2	0	\N
370971	1678	27360856319000	27080	13339	0	0	\N
370972	1678	27360856320000	27080	13339	1	0	\N
370973	1678	27360856321000	27080	13339	2	0	\N
370974	1678	27360856322000	27080	13339	3	0	\N
370975	1678	27360856323000	27080	13339	4	0	\N
370976	1678	27360856324000	27080	13339	5	0	\N
370977	1678	27360856325000	27080	13339	6	0	\N
370978	1678	27360856326000	27080	13339	7	0	\N
370979	1678	27360856327000	27080	13339	9	0	\N
370980	1678	27360856328000	27080	13339	10	0	\N
370981	1678	27360856329000	27080	13339	11	0	\N
370982	1678	27360856330000	27080	13339	12	0	\N
370983	1678	27360856331000	27080	13339	13	0	\N
370984	1678	27360856332000	27080	13339	14	0	\N
370985	1678	27360856333000	27080	13339	15	0	\N
370986	1678	27360856334000	27080	13339	16	0	\N
370987	1678	27360856335000	27080	13339	17	0	\N
370988	1678	27360856336000	27080	13339	18	0	\N
370989	1678	27360856337000	27080	13339	19	0	\N
370990	1678	27360856338000	27080	13339	20	0	\N
370991	1678	27360856339000	27080	13339	21	0	\N
370992	1678	27360856340000	27080	13339	22	0	\N
370993	1678	27360856341000	27080	13339	23	0	\N
370994	1678	27360856342000	27080	13339	24	0	\N
370995	1678	27360856343000	27080	13339	25	0	\N
370996	1678	27360856344000	27080	13339	26	0	\N
370997	1678	27360856345000	27080	13339	27	0	\N
370998	1678	27360856346000	27080	13339	28	0	\N
370999	1678	27360856347000	27080	13339	29	0	\N
371000	1678	27360856348000	27080	13339	30	0	\N
371001	1678	27360856349000	27080	13339	31	0	\N
371002	1678	27360856350000	27080	13339	32	0	\N
371003	1678	27360856351000	27080	13339	33	0	\N
371004	1678	27360856352000	27080	13339	34	0	\N
371005	1678	27360856353000	27080	13339	35	0	\N
371006	1678	27360856354000	27080	13339	36	0	\N
371007	1678	27360856355000	27080	13339	37	0	\N
371008	1678	27360856356000	27080	13339	38	0	\N
370936	1874	34181000	27070	13383	2	0	2
370937	1874	34184000	27070	13383	3	0	2
370938	1874	34187000	27070	13383	4	0	2
370939	1874	34189000	27070	13383	5	0	2
370948	1678	27360856379000	27073	13384	0	0	1
370950	1874	34194000	27073	13384	2	0	2
370951	1678	27360856380000	27074	13385	0	0	1
370952	1874	34196000	27074	13385	1	0	2
370953	1874	34199000	27074	13385	2	0	2
370957	1678	27360856381000	27076	13386	0	0	1
370959	1874	34202000	27076	13386	2	0	2
370960	1874	34204000	27076	13386	3	0	2
370961	1874	34206000	27076	13386	4	0	2
370965	1678	27360856383000	27078	13387	0	0	1
370967	1874	34211000	27078	13387	2	0	2
370968	1678	27360856384000	27079	13388	0	0	1
370969	1874	34214000	27079	13388	1	0	2
370970	1874	34216000	27079	13388	2	0	2
371009	1678	27360856357000	27080	13339	39	0	\N
371010	1678	27360856358000	27080	13339	40	0	\N
371011	1678	27360856359000	27080	13339	41	0	\N
371012	1678	27360856360000	27080	13339	42	0	\N
371013	1678	27360856361000	27080	13339	43	0	\N
371014	1678	27360856362000	27080	13339	44	0	\N
371037	1678	27360856390000	27085	13392	0	0	\N
371038	1678	27360856391000	27085	13392	1	0	\N
371039	1874	34244000	27085	13392	2	0	\N
371040	1874	34246000	27085	13392	3	0	\N
371041	1874	34249000	27085	13392	4	0	\N
371042	1874	34251000	27085	13392	5	0	\N
371043	1678	27360856390000	27086	13392	0	0	\N
371044	1678	27360856391000	27086	13392	1	0	\N
371045	1874	34244000	27086	13392	2	0	\N
371046	1874	34246000	27086	13392	3	0	\N
371047	1874	34249000	27086	13392	4	0	\N
371048	1874	34251000	27086	13392	5	0	\N
371049	1678	27360856390000	27087	13392	0	0	\N
371050	1678	27360856391000	27087	13392	1	0	\N
371051	1874	34244000	27087	13392	2	0	\N
371052	1874	34246000	27087	13392	3	0	\N
371053	1874	34249000	27087	13392	4	0	\N
371054	1874	34251000	27087	13392	5	0	\N
371055	1678	27360856390000	27088	13392	0	0	\N
371056	1678	27360856391000	27088	13392	1	0	\N
371057	1874	34244000	27088	13392	2	0	\N
371058	1874	34246000	27088	13392	3	0	\N
371059	1874	34249000	27088	13392	4	0	\N
371060	1874	34251000	27088	13392	5	0	\N
371064	1678	27360856392000	27090	13393	0	0	\N
371065	1874	34254000	27090	13393	1	0	\N
371066	1874	34256000	27090	13393	2	0	\N
371082	1678	27360856397000	27095	13397	0	0	\N
371083	1874	34278000	27095	13397	1	0	\N
371084	1874	34281000	27095	13397	2	0	\N
371085	1678	27360856397000	27096	13397	0	0	\N
371086	1874	34278000	27096	13397	1	0	\N
371087	1874	34281000	27096	13397	2	0	\N
371100	1678	27360856400000	27102	13399	0	0	\N
371101	1678	27360856401000	27102	13399	1	0	\N
371102	1874	34294000	27102	13399	2	0	\N
371103	1874	34296000	27102	13399	3	0	\N
371104	1874	34299000	27102	13399	4	0	\N
371105	1874	34301000	27102	13399	5	0	\N
371115	1678	27360856404000	27106	13401	0	0	\N
371116	1874	34313000	27106	13401	1	0	\N
371117	1874	34316000	27106	13401	2	0	\N
371118	1678	27360856404000	27107	13401	0	0	\N
371119	1874	34313000	27107	13401	1	0	\N
371120	1874	34316000	27107	13401	2	0	\N
371127	1678	27360856355000	27110	13312	0	0	\N
371128	1678	27360856356000	27110	13312	1	0	\N
371129	1678	27360856357000	27110	13312	2	0	\N
371130	1678	27360856358000	27110	13312	3	0	\N
371131	1678	27360856359000	27110	13312	4	0	\N
371132	1678	27360856360000	27110	13312	5	0	\N
371133	1678	27360856361000	27110	13312	6	0	\N
371134	1678	27360856362000	27110	13312	7	0	\N
371135	1678	27360856363000	27110	13312	8	0	\N
371136	1678	27360856364000	27110	13312	9	0	\N
371137	1678	27360856365000	27110	13312	10	0	\N
371138	1678	27360856366000	27110	13312	11	0	\N
371139	1678	27360856367000	27110	13312	12	0	\N
371140	1678	27360856368000	27110	13312	13	0	\N
371141	1678	27360856369000	27110	13312	14	0	\N
371142	1678	27360856370000	27110	13312	15	0	\N
371143	1678	27360856371000	27110	13312	16	0	\N
371144	1678	27360856372000	27110	13312	17	0	\N
371017	1874	34221000	27081	13389	2	0	2
371018	1678	27360856386000	27082	13390	0	0	1
371019	1874	34224000	27082	13390	1	0	2
371020	1874	34226000	27082	13390	2	0	2
371021	1678	27360856387000	27083	13391	0	0	1
371023	1678	27360856389000	27083	13391	2	0	1
371024	1874	34229000	27083	13391	3	0	2
371025	1874	34232000	27083	13391	4	0	2
371026	1874	34235000	27083	13391	5	0	2
371027	1933	3259268000000	27083	13391	6	0	3
371029	1874	34239000	27083	13391	8	0	2
371030	1874	34241000	27083	13391	9	0	2
371031	1678	27360856390000	27084	13392	0	0	1
371032	1678	27360856391000	27084	13392	1	0	1
371034	1874	34246000	27084	13392	3	0	2
371035	1874	34249000	27084	13392	4	0	2
371036	1874	34251000	27084	13392	5	0	2
371061	1678	27360856392000	27089	13393	0	0	1
371062	1874	34254000	27089	13393	1	0	2
371067	1678	27360856393000	27091	13394	0	0	1
371068	1874	34258000	27091	13394	1	0	2
371069	1874	34261000	27091	13394	2	0	2
371070	1678	27360856394000	27092	13395	0	0	1
371071	1874	34263000	27092	13395	1	0	2
371073	1678	27360856395000	27093	13396	0	0	1
371074	1678	27360856396000	27093	13396	1	0	1
371075	1874	34269000	27093	13396	2	0	2
371076	1874	34271000	27093	13396	3	0	2
371078	1874	34276000	27093	13396	5	0	2
371079	1678	27360856397000	27094	13397	0	0	1
371080	1874	34278000	27094	13397	1	0	2
371081	1874	34281000	27094	13397	2	0	2
371088	1678	27360856398000	27100	13398	0	0	1
371090	1874	34284000	27100	13398	2	0	2
371091	1874	34287000	27100	13398	3	0	2
371092	1874	34289000	27100	13398	4	0	2
371093	1874	34291000	27100	13398	5	0	2
371094	1678	27360856400000	27101	13399	0	0	1
371096	1874	34294000	27101	13399	2	0	2
371097	1874	34296000	27101	13399	3	0	2
371098	1874	34299000	27101	13399	4	0	2
371099	1874	34301000	27101	13399	5	0	2
371107	1678	27360856403000	27103	13400	1	0	1
371108	1874	34303000	27103	13400	2	0	2
371109	1874	34306000	27103	13400	3	0	2
371110	1874	34308000	27103	13400	4	0	2
371111	1874	34311000	27103	13400	5	0	2
371113	1874	34313000	27104	13401	1	0	2
371114	1874	34316000	27104	13401	2	0	2
371121	1678	27360856405000	27108	13402	0	0	1
371122	1874	34319000	27108	13402	1	0	2
371123	1874	34321000	27108	13402	2	0	2
371125	1874	34323000	27109	13403	1	0	2
371126	1874	34326000	27109	13403	2	0	2
371145	1678	27360856373000	27110	13312	18	0	\N
371146	1678	27360856374000	27110	13312	19	0	\N
371147	1678	27360856375000	27110	13312	20	0	\N
371148	1678	27360856376000	27110	13312	21	0	\N
371149	1678	27360856377000	27110	13312	22	0	\N
371150	1678	27360856378000	27110	13312	23	0	\N
371151	1678	27360856379000	27110	13312	24	0	\N
371152	1678	27360856380000	27110	13312	25	0	\N
371153	1678	27360856381000	27110	13312	26	0	\N
371154	1678	27360856382000	27110	13312	27	0	\N
371155	1678	27360856383000	27110	13312	28	0	\N
371156	1678	27360856384000	27110	13312	29	0	\N
371157	1678	27360856385000	27110	13312	30	0	\N
371158	1678	27360856386000	27110	13312	31	0	\N
371159	1678	27360856387000	27110	13312	32	0	\N
371160	1678	27360856388000	27110	13312	33	0	\N
371161	1678	27360856389000	27110	13312	34	0	\N
371162	1678	27360856390000	27110	13312	35	0	\N
371163	1678	27360856391000	27110	13312	36	0	\N
371164	1678	27360856392000	27110	13312	37	0	\N
371165	1678	27360856393000	27110	13312	38	0	\N
371166	1678	27360856394000	27110	13312	39	0	\N
371167	1678	27360856395000	27110	13312	40	0	\N
371168	1678	27360856396000	27110	13312	41	0	\N
371169	1678	27360856397000	27110	13312	42	0	\N
371170	1678	27360856398000	27110	13312	43	0	\N
371171	1678	27360856399000	27110	13312	44	0	\N
371172	1678	27360856400000	27110	13312	45	0	\N
371173	1678	27360856401000	27110	13312	46	0	\N
371174	1678	27360856402000	27110	13312	47	0	\N
371175	1678	27360856403000	27110	13312	48	0	\N
371176	1678	27360856404000	27110	13312	49	0	\N
371177	1678	27360856405000	27110	13312	50	0	\N
371178	1874	33794000	27110	13312	51	0	\N
371179	1874	33796000	27110	13312	52	0	\N
371180	1933	3259268000000	27110	13312	53	0	\N
371181	1874	33798000	27110	13312	54	0	\N
371182	1874	33800000	27110	13312	55	0	\N
371183	1874	33802000	27110	13312	56	0	\N
371184	1874	33804000	27110	13312	57	0	\N
371185	1874	33806000	27110	13312	59	0	\N
371186	1874	33808000	27110	13312	60	0	\N
371187	1874	33810000	27110	13312	61	0	\N
371188	1874	33812000	27110	13312	62	0	\N
371189	1874	33814000	27110	13312	63	0	\N
371190	1874	33816000	27110	13312	64	0	\N
371191	1874	33818000	27110	13312	65	0	\N
371192	1874	33820000	27110	13312	66	0	\N
371193	1874	33822000	27110	13312	67	0	\N
371194	1874	33824000	27110	13312	68	0	\N
371195	975	508248127862876	27110	13312	69	0	\N
371196	1095	910776290460314	27110	13312	70	0	\N
371197	1215	614518911673154	27110	13312	71	0	\N
371198	1341	1712411587352407	27110	13312	72	0	\N
371199	1874	33826000	27110	13312	74	0	\N
371200	1874	33828000	27110	13312	75	0	\N
371201	1874	33830000	27110	13312	76	0	\N
371202	1874	33832000	27110	13312	77	0	\N
371203	1874	33834000	27110	13312	78	0	\N
371204	1874	33836000	27110	13312	79	0	\N
371205	1874	33838000	27110	13312	80	0	\N
371206	1874	33840000	27110	13312	81	0	\N
371207	1874	33842000	27110	13312	82	0	\N
371208	1874	33844000	27110	13312	83	0	\N
371209	1874	33846000	27110	13312	84	0	\N
371210	1874	33848000	27110	13312	85	0	\N
371211	1874	33850000	27110	13312	86	0	\N
371212	1874	33852000	27110	13312	87	0	\N
371213	1874	33854000	27110	13312	88	0	\N
371214	1874	33856000	27110	13312	89	0	\N
371215	1874	33858000	27110	13312	90	0	\N
371216	1874	33860000	27110	13312	91	0	\N
371217	1874	33862000	27110	13312	92	0	\N
371218	1874	33864000	27110	13312	93	0	\N
371219	1874	33866000	27110	13312	94	0	\N
371220	1874	33868000	27110	13312	95	0	\N
371221	1874	33870000	27110	13312	96	0	\N
371222	2370	100000000	27110	13312	97	0	\N
371223	2371	100000000	27110	13312	98	0	\N
371224	2372	100000000	27110	13312	99	0	\N
371225	2373	100000000	27110	13312	100	0	\N
371226	1874	33872000	27110	13312	101	0	\N
371227	1874	33875000	27110	13312	102	0	\N
371228	1874	33878000	27110	13312	103	0	\N
371229	1874	33881000	27110	13312	104	0	\N
371230	1874	33884000	27110	13312	105	0	\N
371231	1874	33887000	27110	13312	106	0	\N
371232	1874	33890000	27110	13312	107	0	\N
371233	1874	33893000	27110	13312	108	0	\N
371234	1874	33896000	27110	13312	109	0	\N
371235	1874	33899000	27110	13312	110	0	\N
371236	1874	33902000	27110	13312	111	0	\N
371237	1874	33905000	27110	13312	112	0	\N
371238	1874	33908000	27110	13312	113	0	\N
371239	1874	33911000	27110	13312	114	0	\N
371240	1874	33914000	27110	13312	115	0	\N
371241	1874	33917000	27110	13312	116	0	\N
371242	1874	33920000	27110	13312	117	0	\N
371243	1874	33923000	27110	13312	118	0	\N
371244	1874	33926000	27110	13312	119	0	\N
371245	1874	33929000	27110	13312	120	0	\N
371246	1874	33932000	27110	13312	121	0	\N
371247	1874	33935000	27110	13312	122	0	\N
371248	1874	33938000	27110	13312	123	0	\N
371249	1874	33941000	27110	13312	124	0	\N
371250	1874	33944000	27110	13312	125	0	\N
371251	1678	27360856407000	27111	13404	0	0	\N
371252	1874	34328000	27111	13404	1	0	\N
371255	1678	27360856408000	27113	13405	0	0	\N
371256	1874	34331000	27113	13405	1	0	\N
371257	1874	34333000	27113	13405	2	0	\N
371264	1678	27360856408000	27116	13406	0	0	\N
371265	1874	34335000	27116	13406	1	0	\N
371266	1874	34338000	27116	13406	2	0	\N
371276	1678	27360856412000	27120	13409	0	0	\N
371277	1874	34351000	27120	13409	1	0	\N
371278	1874	34353000	27120	13409	2	0	\N
371258	1874	34331000	27114	13405	0	0	2
371259	1874	34333000	27114	13405	1	0	2
371260	1678	27360856408000	27115	13406	0	0	1
371261	1678	27360856409000	27115	13406	1	0	1
371262	1874	34335000	27115	13406	2	0	2
371267	1678	27360856410000	27117	13407	0	0	1
371268	1874	34340000	27117	13407	1	0	2
371269	1874	34343000	27117	13407	2	0	2
371270	1678	27360856411000	27118	13408	0	0	1
371271	1874	34346000	27118	13408	1	0	2
371273	1678	27360856412000	27119	13409	0	0	1
371274	1874	34351000	27119	13409	1	0	2
371275	1874	34353000	27119	13409	2	0	2
371279	1678	27360856413000	27121	13410	0	0	1
371290	1678	27360856415000	27123	13411	0	0	\N
371291	1874	34365000	27123	13411	1	0	\N
371292	1874	34368000	27123	13411	2	0	\N
371293	1874	34371000	27123	13411	3	0	\N
371294	1874	34373000	27123	13411	4	0	\N
371307	1678	27360856420000	27128	13416	0	0	\N
371308	1874	34396000	27128	13416	1	0	\N
371309	1874	34398000	27128	13416	2	0	\N
371322	1678	27360856421000	27131	13417	0	0	\N
371323	1678	27360856422000	27131	13417	1	0	\N
371324	1678	27360856423000	27131	13417	2	0	\N
371325	1874	34400000	27131	13417	3	0	\N
371326	1874	34403000	27131	13417	4	0	\N
371327	1874	34406000	27131	13417	5	0	\N
371328	1874	34409000	27131	13417	6	0	\N
371329	1874	34411000	27131	13417	7	0	\N
371330	1874	34413000	27131	13417	8	0	\N
371334	1678	27360856424000	27133	13418	0	0	\N
371335	1874	34415000	27133	13418	1	0	\N
371336	1874	34418000	27133	13418	2	0	\N
371337	1874	34415000	27134	13418	0	0	\N
371338	1874	34418000	27134	13418	1	0	\N
371339	1678	27360856424000	27135	13418	0	0	\N
371340	1874	34415000	27135	13418	1	0	\N
371341	1874	34418000	27135	13418	2	0	\N
371345	1678	27360856425000	27137	13419	0	0	\N
371346	1874	34421000	27137	13419	1	0	\N
371347	1874	34423000	27137	13419	2	0	\N
371351	1678	27360856426000	27140	13420	0	0	\N
371352	1874	34426000	27140	13420	1	0	\N
371353	1874	34428000	27140	13420	2	0	\N
371354	1678	27360856427000	27141	13421	0	0	\N
371355	1874	34430000	27141	13421	1	0	\N
371356	1874	34433000	27141	13421	2	0	\N
371357	1678	27360856427000	27142	13421	0	0	\N
371358	1874	34430000	27142	13421	1	0	\N
371359	1874	34433000	27142	13421	2	0	\N
371371	1678	27360856428000	27145	13422	0	0	\N
371372	1678	27360856429000	27145	13422	1	0	\N
371373	1678	27360856430000	27145	13422	2	0	\N
371374	1874	34435000	27145	13422	3	0	\N
371375	1874	34437000	27145	13422	4	0	\N
371376	1874	34440000	27145	13422	5	0	\N
371377	1874	34443000	27145	13422	6	0	\N
371378	1874	34445000	27145	13422	7	0	\N
371379	1678	27360856431000	27146	13423	0	0	\N
371380	1874	34448000	27146	13423	1	0	\N
371381	1874	34450000	27146	13423	2	0	\N
371382	1678	27360856431000	27147	13423	0	0	\N
371383	1874	34448000	27147	13423	1	0	\N
371384	1874	34450000	27147	13423	2	0	\N
371392	1678	27360856086000	27150	13180	0	0	\N
371393	1678	27360856087000	27150	13180	1	0	\N
371394	1678	27360856088000	27150	13180	2	0	\N
371395	1678	27360856089000	27150	13180	3	0	\N
371396	134	66000100000000	27150	13180	4	0	\N
371397	1678	27360856090000	27150	13180	5	0	\N
371398	1678	27360856091000	27150	13180	6	0	\N
371399	1678	27360856092000	27150	13180	7	0	\N
371400	1678	27360856093000	27150	13180	8	0	\N
371401	1678	27360856094000	27150	13180	9	0	\N
371402	1678	27360856095000	27150	13180	10	0	\N
371403	1678	27360856096000	27150	13180	11	0	\N
371404	1678	27360856097000	27150	13180	12	0	\N
371405	1678	27360856098000	27150	13180	13	0	\N
371406	1678	27360856099000	27150	13180	14	0	\N
371407	1678	27360856100000	27150	13180	15	0	\N
371408	1678	27360856101000	27150	13180	16	0	\N
371409	1678	27360856102000	27150	13180	17	0	\N
371410	1678	27360856103000	27150	13180	18	0	\N
371411	1678	27360856104000	27150	13180	19	0	\N
371412	1678	27360856105000	27150	13180	20	0	\N
371413	1678	27360856106000	27150	13180	21	0	\N
371414	1678	27360856107000	27150	13180	22	0	\N
371415	1678	27360856108000	27150	13180	23	0	\N
371416	1678	27360856109000	27150	13180	24	0	\N
371283	1874	34360000	27121	13410	4	0	2
371284	1874	34363000	27121	13410	5	0	2
371285	1678	27360856415000	27122	13411	0	0	1
371286	1874	34365000	27122	13411	1	0	2
371287	1874	34368000	27122	13411	2	0	2
371289	1874	34373000	27122	13411	4	0	2
371295	1678	27360856416000	27124	13412	0	0	1
371296	1874	34375000	27124	13412	1	0	2
371297	1874	34378000	27124	13412	2	0	2
371298	1678	27360856417000	27125	13413	0	0	1
371300	1874	34383000	27125	13413	2	0	2
371301	1678	27360856418000	27126	13414	0	0	1
371302	1874	34386000	27126	13414	1	0	2
371303	1874	34388000	27126	13414	2	0	2
371305	1874	34391000	27127	13415	1	0	2
371306	1874	34393000	27127	13415	2	0	2
371310	1678	27360856420000	27129	13416	0	0	1
371311	1874	34396000	27129	13416	1	0	2
371312	1874	34398000	27129	13416	2	0	2
371314	1678	27360856422000	27130	13417	1	0	1
371315	1678	27360856423000	27130	13417	2	0	1
371316	1874	34400000	27130	13417	3	0	2
371317	1874	34403000	27130	13417	4	0	2
371318	1874	34406000	27130	13417	5	0	2
371320	1874	34411000	27130	13417	7	0	2
371321	1874	34413000	27130	13417	8	0	2
371331	1678	27360856424000	27132	13418	0	0	1
371332	1874	34415000	27132	13418	1	0	2
371342	1678	27360856425000	27136	13419	0	0	1
371343	1874	34421000	27136	13419	1	0	2
371344	1874	34423000	27136	13419	2	0	2
371348	1678	27360856426000	27139	13420	0	0	1
371349	1874	34426000	27139	13420	1	0	2
371360	1678	27360856427000	27143	13421	0	0	1
371361	1874	34430000	27143	13421	1	0	2
371362	1874	34433000	27143	13421	2	0	2
371363	1678	27360856428000	27144	13422	0	0	1
371364	1678	27360856429000	27144	13422	1	0	1
371366	1874	34435000	27144	13422	3	0	2
371367	1874	34437000	27144	13422	4	0	2
371368	1874	34440000	27144	13422	5	0	2
371369	1874	34443000	27144	13422	6	0	2
371385	1678	27360856431000	27148	13423	0	0	1
371386	1874	34448000	27148	13423	1	0	2
371387	1874	34450000	27148	13423	2	0	2
371388	1874	34453000	27149	13424	0	0	2
371389	1874	34456000	27149	13424	2	0	2
371391	1874	34460000	27149	13424	4	0	2
371417	1678	27360856110000	27150	13180	25	0	\N
371418	1678	27360856111000	27150	13180	26	0	\N
371419	1678	27360856112000	27150	13180	27	0	\N
371420	1678	27360856113000	27150	13180	28	0	\N
371421	1678	27360856114000	27150	13180	29	0	\N
371422	1678	27360856115000	27150	13180	30	0	\N
371423	1678	27360856116000	27150	13180	31	0	\N
371424	1678	27360856117000	27150	13180	32	0	\N
371425	1678	27360856118000	27150	13180	33	0	\N
371426	1678	27360856119000	27150	13180	34	0	\N
371427	1678	27360856120000	27150	13180	35	0	\N
371428	1678	27360856121000	27150	13180	36	0	\N
371429	1678	27360856122000	27150	13180	37	0	\N
371430	1678	27360856123000	27150	13180	38	0	\N
371431	1678	27360856124000	27150	13180	39	0	\N
371432	1678	27360856125000	27150	13180	40	0	\N
371433	1678	27360856126000	27150	13180	41	0	\N
371434	1678	27360856127000	27150	13180	42	0	\N
371435	1678	27360856128000	27150	13180	43	0	\N
371436	1678	27360856129000	27150	13180	44	0	\N
371437	1678	27360856130000	27150	13180	45	0	\N
371438	1678	27360856131000	27150	13180	46	0	\N
371439	1678	27360856132000	27150	13180	47	0	\N
371440	1678	27360856133000	27150	13180	48	0	\N
371441	1678	27360856134000	27150	13180	49	0	\N
371442	1678	27360856135000	27150	13180	50	0	\N
371443	1678	27360856136000	27150	13180	51	0	\N
371444	1678	27360856137000	27150	13180	52	0	\N
371445	1678	27360856138000	27150	13180	53	0	\N
371446	1678	27360856139000	27150	13180	54	0	\N
371447	1678	27360856140000	27150	13180	55	0	\N
371448	1678	27360856141000	27150	13180	56	0	\N
371449	1678	27360856142000	27150	13180	57	0	\N
371450	1678	27360856143000	27150	13180	58	0	\N
371451	1678	27360856144000	27150	13180	59	0	\N
371452	1678	27360856145000	27150	13180	60	0	\N
371453	1678	27360856146000	27150	13180	61	0	\N
371454	1678	27360856147000	27150	13180	63	0	\N
371455	1678	27360856148000	27150	13180	64	0	\N
371456	1678	27360856149000	27150	13180	65	0	\N
371457	1678	27360856150000	27150	13180	66	0	\N
371458	1678	27360856151000	27150	13180	67	0	\N
371459	1678	27360856152000	27150	13180	68	0	\N
371460	1678	27360856153000	27150	13180	69	0	\N
371461	1678	27360856154000	27150	13180	70	0	\N
371462	1678	27360856155000	27150	13180	71	0	\N
371463	1678	27360856156000	27150	13180	72	0	\N
371464	1678	27360856157000	27150	13180	73	0	\N
371465	1678	27360856158000	27150	13180	74	0	\N
371466	1678	27360856159000	27150	13180	75	0	\N
371467	1678	27360856160000	27150	13180	76	0	\N
371468	1678	27360856161000	27150	13180	77	0	\N
371469	1678	27360856162000	27150	13180	78	0	\N
371470	1678	27360856163000	27150	13180	79	0	\N
371471	1678	27360856164000	27150	13180	80	0	\N
371472	1678	27360856165000	27150	13180	81	0	\N
371473	1678	27360856166000	27150	13180	82	0	\N
371474	1678	27360856167000	27150	13180	83	0	\N
371475	1678	27360856168000	27150	13180	84	0	\N
371476	1678	27360856169000	27150	13180	85	0	\N
371477	1678	27360856170000	27150	13180	86	0	\N
371478	1678	27360856171000	27150	13180	87	0	\N
371479	1678	27360856172000	27150	13180	88	0	\N
371480	1678	27360856173000	27150	13180	89	0	\N
371481	1678	27360856174000	27150	13180	90	0	\N
371482	1678	27360856175000	27150	13180	91	0	\N
371483	1678	27360856176000	27150	13180	92	0	\N
371484	1678	27360856177000	27150	13180	93	0	\N
371485	1678	27360856178000	27150	13180	94	0	\N
371486	1678	27360856179000	27150	13180	95	0	\N
371487	1678	27360856180000	27150	13180	96	0	\N
371488	1678	27360856181000	27150	13180	97	0	\N
371489	1678	27360856182000	27150	13180	98	0	\N
371490	1678	27360856183000	27150	13180	99	0	\N
371491	1678	27360856184000	27150	13180	100	0	\N
371492	1678	27360856185000	27150	13180	101	0	\N
371493	1678	27360856186000	27150	13180	102	0	\N
371494	1678	27360856187000	27150	13180	103	0	\N
371495	1678	27360856188000	27150	13180	104	0	\N
371496	1678	27360856189000	27150	13180	105	0	\N
371497	1678	27360856190000	27150	13180	106	0	\N
371498	1678	27360856191000	27150	13180	107	0	\N
371499	1678	27360856192000	27150	13180	108	0	\N
371500	1678	27360856193000	27150	13180	109	0	\N
371501	1678	27360856194000	27150	13180	110	0	\N
371502	1678	27360856195000	27150	13180	111	0	\N
371503	1678	27360856196000	27150	13180	112	0	\N
371504	1678	27360856197000	27150	13180	113	0	\N
371505	1678	27360856198000	27150	13180	114	0	\N
371506	1678	27360856199000	27150	13180	115	0	\N
371507	1678	27360856200000	27150	13180	116	0	\N
371508	1678	27360856201000	27150	13180	117	0	\N
371509	1678	27360856202000	27150	13180	118	0	\N
371510	1678	27360856203000	27150	13180	119	0	\N
371511	1678	27360856204000	27150	13180	120	0	\N
371512	1678	27360856205000	27150	13180	121	0	\N
371513	1678	27360856206000	27150	13180	122	0	\N
371514	1678	27360856207000	27150	13180	123	0	\N
371515	1678	27360856208000	27150	13180	124	0	\N
371516	1678	27360856209000	27150	13180	125	0	\N
371519	1678	27360856432000	27152	13424	0	0	\N
371520	1678	27360856433000	27152	13424	2	0	\N
371521	1678	27360856434000	27152	13424	3	0	\N
371522	1678	27360856435000	27152	13424	4	0	\N
371523	1874	34453000	27152	13424	5	0	\N
371524	1874	34456000	27152	13424	6	0	\N
371525	1874	34459000	27152	13424	7	0	\N
371526	1874	34462000	27152	13424	8	0	\N
371527	1874	34464000	27152	13424	9	0	\N
371528	1874	34466000	27152	13424	10	0	\N
371529	1874	34468000	27152	13424	11	0	\N
371530	1874	34470000	27152	13424	12	0	\N
371531	1678	27360856432000	27153	13424	0	0	\N
371532	1678	27360856433000	27153	13424	2	0	\N
371533	1678	27360856434000	27153	13424	3	0	\N
371534	1678	27360856435000	27153	13424	4	0	\N
371535	1874	34453000	27153	13424	5	0	\N
371536	1874	34456000	27153	13424	6	0	\N
371537	1874	34459000	27153	13424	7	0	\N
371538	1874	34462000	27153	13424	8	0	\N
371539	1874	34464000	27153	13424	9	0	\N
371540	1874	34466000	27153	13424	10	0	\N
371541	1874	34468000	27153	13424	11	0	\N
371542	1874	34470000	27153	13424	12	0	\N
371543	1678	27360856432000	27154	13426	0	0	1
371544	1678	27360856433000	27154	13426	1	0	1
371545	1678	27360856434000	27154	13426	2	0	1
371546	1678	27360856435000	27154	13426	3	0	1
371547	1874	34467000	27154	13426	4	0	2
371549	1678	27360856436000	27155	13427	0	0	1
371550	1874	34473000	27155	13427	1	0	2
371551	1874	34475000	27155	13427	2	0	2
371552	1678	27360856437000	27157	13428	0	0	1
371558	1678	27360856437000	27158	13428	0	0	\N
371559	1678	27360856438000	27158	13428	1	0	\N
371560	1874	34477000	27158	13428	2	0	\N
371561	1874	34479000	27158	13428	3	0	\N
371562	1874	34482000	27158	13428	4	0	\N
371563	1874	34485000	27158	13428	5	0	\N
371576	1678	27360856443000	27161	13431	0	0	\N
371577	1874	34508000	27161	13431	1	0	\N
371578	1874	34510000	27161	13431	2	0	\N
371585	1933	3259268000000	27164	13234	0	0	\N
371586	975	508248127862876	27164	13234	1	0	\N
371587	1095	910776290460314	27164	13234	2	0	\N
371588	1215	614518911673154	27164	13234	3	0	\N
371589	1341	1712411587352407	27164	13234	4	0	\N
371593	1678	27360856446000	27166	13434	0	0	\N
371594	1874	34522000	27166	13434	1	0	\N
371595	1874	34525000	27166	13434	2	0	\N
371596	1678	27360856446000	27167	13434	0	0	\N
371597	1874	34522000	27167	13434	1	0	\N
371598	1874	34525000	27167	13434	2	0	\N
371607	1678	27360856447000	27170	13435	0	0	\N
371608	1678	27360856448000	27170	13435	1	0	\N
371609	1874	34528000	27170	13435	2	0	\N
371610	1874	34530000	27170	13435	3	0	\N
371611	1874	34532000	27170	13435	4	0	\N
371636	1678	27360856457000	27178	13443	0	0	\N
371637	1678	27360856458000	27178	13443	1	0	\N
371638	1874	34575000	27178	13443	2	0	\N
371639	1874	34577000	27178	13443	3	0	\N
371640	1874	34579000	27178	13443	4	0	\N
371641	1874	34582000	27178	13443	5	0	\N
371648	1678	27360856210000	27180	13181	0	0	\N
371649	1678	27360856211000	27180	13181	1	0	\N
371650	1678	27360856212000	27180	13181	2	0	\N
371651	1678	27360856213000	27180	13181	3	0	\N
371652	1678	27360856214000	27180	13181	4	0	\N
371653	1678	27360856215000	27180	13181	5	0	\N
371654	1678	27360856216000	27180	13181	6	0	\N
371655	1678	27360856217000	27180	13181	7	0	\N
371656	1678	27360856218000	27180	13181	8	0	\N
371657	1678	27360856219000	27180	13181	9	0	\N
371658	1678	27360856220000	27180	13181	10	0	\N
371659	1678	27360856221000	27180	13181	11	0	\N
371660	1678	27360856222000	27180	13181	12	0	\N
371661	1678	27360856223000	27180	13181	13	0	\N
371662	1678	27360856224000	27180	13181	14	0	\N
371663	1678	27360856225000	27180	13181	15	0	\N
371664	1678	27360856226000	27180	13181	16	0	\N
371665	1678	27360856227000	27180	13181	17	0	\N
371666	1678	27360856228000	27180	13181	18	0	\N
371667	1678	27360856229000	27180	13181	19	0	\N
371668	1678	27360856230000	27180	13181	20	0	\N
371669	1678	27360856231000	27180	13181	21	0	\N
371670	1678	27360856232000	27180	13181	22	0	\N
371671	1678	27360856233000	27180	13181	23	0	\N
371672	1678	27360856234000	27180	13181	24	0	\N
371673	1678	27360856235000	27180	13181	25	0	\N
371674	1678	27360856236000	27180	13181	26	0	\N
371675	1678	27360856237000	27180	13181	27	0	\N
371676	1678	27360856238000	27180	13181	28	0	\N
371677	1678	27360856239000	27180	13181	29	0	\N
371678	1678	27360856240000	27180	13181	30	0	\N
371679	1678	27360856241000	27180	13181	31	0	\N
371680	1678	27360856242000	27180	13181	32	0	\N
371681	1678	27360856243000	27180	13181	33	0	\N
371682	1678	27360856244000	27180	13181	34	0	\N
371683	1678	27360856245000	27180	13181	35	0	\N
371684	1678	27360856246000	27180	13181	36	0	\N
371685	1678	27360856247000	27180	13181	37	0	\N
371686	1678	27360856248000	27180	13181	38	0	\N
371687	1678	27360856249000	27180	13181	39	0	\N
371688	1678	27360856250000	27180	13181	40	0	\N
371555	1874	34479000	27157	13428	3	0	2
371556	1874	34482000	27157	13428	4	0	2
371557	1874	34485000	27157	13428	5	0	2
371564	1678	27360856439000	27159	13429	0	0	1
371565	1874	34488000	27159	13429	1	0	2
371567	1678	27360856440000	27160	13430	0	0	1
371568	1678	27360856441000	27160	13430	1	0	1
371569	1678	27360856442000	27160	13430	2	0	1
371570	1874	34492000	27160	13430	3	0	2
371571	1874	34494000	27160	13430	4	0	2
371573	1874	34500000	27160	13430	6	0	2
371574	1874	34503000	27160	13430	7	0	2
371575	1874	34505000	27160	13430	8	0	2
371579	1678	27360856443000	27162	13431	0	0	1
371581	1874	34510000	27162	13431	2	0	2
371582	1678	27360856444000	27163	13432	0	0	1
371583	1874	34512000	27163	13432	1	0	2
371584	1874	34515000	27163	13432	2	0	2
371590	1678	27360856445000	27165	13433	0	0	1
371592	1874	34520000	27165	13433	2	0	2
371599	1678	27360856446000	27168	13434	0	0	1
371600	1874	34522000	27168	13434	1	0	2
371601	1874	34525000	27168	13434	2	0	2
371602	1678	27360856447000	27169	13435	0	0	1
371604	1874	34528000	27169	13435	2	0	2
371605	1874	34530000	27169	13435	3	0	2
371606	1874	34532000	27169	13435	4	0	2
371612	1678	27360856449000	27171	13436	0	0	1
371614	1874	34537000	27171	13436	2	0	2
371615	1678	27360856450000	27172	13437	0	0	1
371616	1874	34540000	27172	13437	1	0	2
371617	1874	34542000	27172	13437	2	0	2
371618	1678	27360856451000	27173	13438	0	0	1
371620	1874	34547000	27173	13438	2	0	2
371621	1678	27360856452000	27174	13439	0	0	1
371622	1874	34549000	27174	13439	1	0	2
371623	1874	34552000	27174	13439	2	0	2
371624	1678	27360856453000	27175	13440	0	0	1
371626	1874	34557000	27175	13440	2	0	2
371627	1678	27360856454000	27176	13441	0	0	1
371628	1874	34559000	27176	13441	1	0	2
371629	1874	34562000	27176	13441	2	0	2
371631	1678	27360856456000	27177	13442	1	0	1
371632	1874	34565000	27177	13442	2	0	2
371633	1874	34568000	27177	13442	3	0	2
371634	1874	34570000	27177	13442	4	0	2
371635	1874	34572000	27177	13442	5	0	2
371643	1678	27360856458000	27179	13443	1	0	1
371644	1874	34575000	27179	13443	2	0	2
371645	1874	34577000	27179	13443	3	0	2
371646	1874	34579000	27179	13443	4	0	2
371647	1874	34582000	27179	13443	5	0	2
371689	1678	27360856251000	27180	13181	41	0	\N
371690	1678	27360856252000	27180	13181	42	0	\N
371691	1678	27360856253000	27180	13181	43	0	\N
371692	1678	27360856254000	27180	13181	44	0	\N
371693	1678	27360856255000	27180	13181	45	0	\N
371694	1678	27360856256000	27180	13181	46	0	\N
371695	1678	27360856257000	27180	13181	47	0	\N
371696	1678	27360856258000	27180	13181	48	0	\N
371697	1678	27360856259000	27180	13181	49	0	\N
371698	1678	27360856260000	27180	13181	50	0	\N
371699	1678	27360856261000	27180	13181	51	0	\N
371700	1678	27360856262000	27180	13181	52	0	\N
371701	1678	27360856263000	27180	13181	53	0	\N
371702	1678	27360856264000	27180	13181	54	0	\N
371703	1678	27360856265000	27180	13181	55	0	\N
371704	1678	27360856266000	27180	13181	56	0	\N
371705	1678	27360856267000	27180	13181	57	0	\N
371706	1678	27360856268000	27180	13181	58	0	\N
371707	1678	27360856269000	27180	13181	59	0	\N
371708	1678	27360856270000	27180	13181	60	0	\N
371709	1678	27360856271000	27180	13181	61	0	\N
371710	1678	27360856272000	27180	13181	63	0	\N
371711	1678	27360856273000	27180	13181	64	0	\N
371712	1678	27360856274000	27180	13181	65	0	\N
371713	1678	27360856275000	27180	13181	66	0	\N
371714	1678	27360856276000	27180	13181	67	0	\N
371715	1678	27360856277000	27180	13181	68	0	\N
371716	1678	27360856278000	27180	13181	69	0	\N
371717	1678	27360856279000	27180	13181	70	0	\N
371718	1678	27360856280000	27180	13181	71	0	\N
371719	1678	27360856281000	27180	13181	72	0	\N
371720	1678	27360856282000	27180	13181	73	0	\N
371721	1678	27360856283000	27180	13181	74	0	\N
371722	1678	27360856284000	27180	13181	75	0	\N
371723	1678	27360856285000	27180	13181	76	0	\N
371724	1678	27360856286000	27180	13181	77	0	\N
371725	1678	27360856287000	27180	13181	78	0	\N
371726	1678	27360856288000	27180	13181	79	0	\N
371727	1678	27360856289000	27180	13181	80	0	\N
371728	1678	27360856290000	27180	13181	81	0	\N
371729	1678	27360856291000	27180	13181	82	0	\N
371730	1678	27360856292000	27180	13181	83	0	\N
371731	1678	27360856293000	27180	13181	84	0	\N
371732	1678	27360856294000	27180	13181	85	0	\N
371733	1678	27360856295000	27180	13181	86	0	\N
371734	1678	27360856296000	27180	13181	87	0	\N
371735	1678	27360856297000	27180	13181	88	0	\N
371736	1678	27360856298000	27180	13181	89	0	\N
371737	1678	27360856299000	27180	13181	90	0	\N
371738	1678	27360856300000	27180	13181	91	0	\N
371739	1678	27360856301000	27180	13181	92	0	\N
371740	1678	27360856302000	27180	13181	93	0	\N
371741	1678	27360856303000	27180	13181	94	0	\N
371742	1678	27360856304000	27180	13181	95	0	\N
371743	1678	27360856305000	27180	13181	96	0	\N
371744	1678	27360856306000	27180	13181	97	0	\N
371745	1678	27360856307000	27180	13181	98	0	\N
371746	1678	27360856308000	27180	13181	99	0	\N
371747	1678	27360856309000	27180	13181	100	0	\N
371748	1678	27360856310000	27180	13181	101	0	\N
371749	1678	27360856311000	27180	13181	102	0	\N
371750	1678	27360856312000	27180	13181	103	0	\N
371751	1678	27360856313000	27180	13181	104	0	\N
371752	1678	27360856314000	27180	13181	105	0	\N
371753	1678	27360856315000	27180	13181	106	0	\N
371754	1678	27360856316000	27180	13181	107	0	\N
371755	1678	27360856317000	27180	13181	108	0	\N
371756	1678	27360856318000	27180	13181	109	0	\N
371757	1678	27360856319000	27180	13181	110	0	\N
371758	1678	27360856320000	27180	13181	111	0	\N
371759	1678	27360856321000	27180	13181	112	0	\N
371760	1678	27360856322000	27180	13181	113	0	\N
371761	1678	27360856323000	27180	13181	114	0	\N
371762	1678	27360856324000	27180	13181	115	0	\N
371763	1678	27360856325000	27180	13181	116	0	\N
371764	1678	27360856326000	27180	13181	117	0	\N
371765	1678	27360856327000	27180	13181	118	0	\N
371766	1678	27360856328000	27180	13181	119	0	\N
371767	1678	27360856329000	27180	13181	120	0	\N
371768	1678	27360856330000	27180	13181	121	0	\N
371769	1678	27360856331000	27180	13181	122	0	\N
371770	1678	27360856332000	27180	13181	123	0	\N
371771	1678	27360856333000	27180	13181	124	0	\N
371772	1678	27360856334000	27180	13181	125	0	\N
371776	1678	27360856460000	27182	13445	0	0	\N
371777	1678	27360856461000	27182	13445	2	0	\N
371778	1874	34589000	27182	13445	3	0	\N
371779	1874	34592000	27182	13445	4	0	\N
371780	1874	34595000	27182	13445	5	0	\N
371781	1874	34597000	27182	13445	6	0	\N
371782	1678	27360856460000	27183	13445	0	0	\N
371783	1678	27360856461000	27183	13445	2	0	\N
371784	1874	34589000	27183	13445	3	0	\N
371785	1874	34592000	27183	13445	4	0	\N
371786	1874	34595000	27183	13445	5	0	\N
371787	1874	34597000	27183	13445	6	0	\N
371797	1678	27360856463000	27186	13447	0	0	\N
371798	1874	34604000	27186	13447	1	0	\N
371799	1678	27360856463000	27187	13447	0	0	\N
371800	1874	34604000	27187	13447	1	0	\N
371801	1874	34607000	27187	13447	2	0	\N
371805	1874	34604000	27189	13447	0	0	\N
371806	1874	34607000	27189	13447	1	0	\N
371807	1678	27360856463000	27190	13447	0	0	\N
371808	1874	34604000	27190	13447	1	0	\N
371809	1874	34607000	27190	13447	2	0	\N
371810	1678	27360856464000	27191	13448	0	0	\N
371811	1874	34610000	27191	13448	1	0	\N
371812	1874	34612000	27191	13448	2	0	\N
371824	1678	27360856424000	27195	13418	0	0	\N
371775	1874	34587000	27181	13444	2	0	2
371788	1678	27360856460000	27184	13445	0	0	1
371789	1678	27360856461000	27184	13445	2	0	1
371790	1874	34589000	27184	13445	3	0	2
371791	1874	34592000	27184	13445	4	0	2
371793	1874	34597000	27184	13445	6	0	2
371794	1678	27360856462000	27185	13446	0	0	1
371795	1874	34600000	27185	13446	1	0	2
371796	1874	34602000	27185	13446	2	0	2
371802	1678	27360856463000	27188	13447	0	0	1
371804	1874	34607000	27188	13447	2	0	2
371813	1678	27360856464000	27192	13448	0	0	1
371814	1874	34610000	27192	13448	1	0	2
371815	1874	34612000	27192	13448	2	0	2
371817	1678	27360856466000	27193	13449	1	0	1
371818	1874	34614000	27193	13449	2	0	2
371819	1874	34616000	27193	13449	3	0	2
371820	1874	34619000	27193	13449	4	0	2
371821	1874	34622000	27193	13449	5	0	2
371823	1874	34625000	27194	13450	1	0	2
371825	1678	27360856425000	27195	13418	1	0	\N
371826	1678	27360856426000	27195	13418	2	0	\N
371827	1678	27360856427000	27195	13418	3	0	\N
371828	1678	27360856428000	27195	13418	4	0	\N
371829	1678	27360856429000	27195	13418	5	0	\N
371830	1678	27360856430000	27195	13418	6	0	\N
371831	1678	27360856431000	27195	13418	7	0	\N
371832	1678	27360856432000	27195	13418	8	0	\N
371833	1678	27360856433000	27195	13418	9	0	\N
371834	1678	27360856434000	27195	13418	10	0	\N
371835	1678	27360856435000	27195	13418	11	0	\N
371836	1678	27360856436000	27195	13418	12	0	\N
371837	1678	27360856437000	27195	13418	13	0	\N
371838	1678	27360856438000	27195	13418	14	0	\N
371839	1678	27360856439000	27195	13418	15	0	\N
371840	1678	27360856440000	27195	13418	16	0	\N
371841	1678	27360856441000	27195	13418	17	0	\N
371842	1678	27360856442000	27195	13418	18	0	\N
371843	1678	27360856443000	27195	13418	19	0	\N
371844	1678	27360856444000	27195	13418	20	0	\N
371845	1678	27360856445000	27195	13418	21	0	\N
371846	1678	27360856446000	27195	13418	22	0	\N
371847	1678	27360856447000	27195	13418	23	0	\N
371848	1678	27360856448000	27195	13418	24	0	\N
371849	1678	27360856449000	27195	13418	25	0	\N
371850	1678	27360856450000	27195	13418	26	0	\N
371851	1678	27360856451000	27195	13418	27	0	\N
371852	1678	27360856452000	27195	13418	28	0	\N
371853	1678	27360856453000	27195	13418	29	0	\N
371854	1678	27360856454000	27195	13418	30	0	\N
371855	1678	27360856455000	27195	13418	31	0	\N
371856	1678	27360856456000	27195	13418	32	0	\N
371857	1678	27360856457000	27195	13418	33	0	\N
371858	1678	27360856458000	27195	13418	34	0	\N
371859	1678	27360856459000	27195	13418	35	0	\N
371860	1678	27360856460000	27195	13418	37	0	\N
371861	1678	27360856461000	27195	13418	38	0	\N
371862	1678	27360856462000	27195	13418	39	0	\N
371863	1678	27360856463000	27195	13418	40	0	\N
371864	1678	27360856464000	27195	13418	41	0	\N
371865	1678	27360856465000	27195	13418	42	0	\N
371866	1678	27360856466000	27195	13418	43	0	\N
371867	1678	27360856467000	27195	13418	44	0	\N
371868	1678	27360856468000	27195	13418	45	0	\N
371869	1874	34415000	27195	13418	46	0	\N
371870	1874	34417000	27195	13418	47	0	\N
371871	1874	34419000	27195	13418	48	0	\N
371872	1874	34421000	27195	13418	49	0	\N
371873	1874	34423000	27195	13418	50	0	\N
371874	1874	34425000	27195	13418	51	0	\N
371875	1874	34427000	27195	13418	52	0	\N
371876	1874	34429000	27195	13418	53	0	\N
371877	1874	34432000	27195	13418	54	0	\N
371878	1874	34435000	27195	13418	55	0	\N
371879	1874	34438000	27195	13418	56	0	\N
371880	1874	34441000	27195	13418	57	0	\N
371881	1874	34444000	27195	13418	58	0	\N
371882	1874	34447000	27195	13418	59	0	\N
371883	1874	34450000	27195	13418	60	0	\N
371884	1874	34453000	27195	13418	61	0	\N
371885	1874	34456000	27195	13418	62	0	\N
371886	1874	34459000	27195	13418	63	0	\N
371887	1874	34462000	27195	13418	64	0	\N
371888	1874	34465000	27195	13418	65	0	\N
371889	1874	34468000	27195	13418	66	0	\N
371890	1874	34471000	27195	13418	67	0	\N
371891	1874	34474000	27195	13418	68	0	\N
371892	1874	34477000	27195	13418	69	0	\N
371893	1874	34480000	27195	13418	70	0	\N
371894	1874	34483000	27195	13418	71	0	\N
371895	1874	34486000	27195	13418	72	0	\N
371896	1874	34489000	27195	13418	73	0	\N
371897	1874	34492000	27195	13418	74	0	\N
371898	1874	34495000	27195	13418	75	0	\N
371899	1874	34498000	27195	13418	76	0	\N
371900	1874	34501000	27195	13418	77	0	\N
371901	1874	34504000	27195	13418	78	0	\N
371902	1874	34507000	27195	13418	79	0	\N
371903	1874	34510000	27195	13418	80	0	\N
371904	1874	34513000	27195	13418	81	0	\N
371905	1874	34516000	27195	13418	82	0	\N
371906	1874	34519000	27195	13418	83	0	\N
371907	1874	34522000	27195	13418	84	0	\N
371908	1874	34525000	27195	13418	85	0	\N
371909	1874	34528000	27195	13418	86	0	\N
371910	1874	34531000	27195	13418	87	0	\N
371911	1874	34534000	27195	13418	88	0	\N
371912	1874	34537000	27195	13418	89	0	\N
371913	1874	34540000	27195	13418	90	0	\N
371914	1874	34543000	27195	13418	91	0	\N
371915	1874	34546000	27195	13418	92	0	\N
371916	1874	34549000	27195	13418	93	0	\N
371917	1874	34552000	27195	13418	94	0	\N
371918	1874	34555000	27195	13418	95	0	\N
371919	1874	34558000	27195	13418	96	0	\N
371920	1874	34560000	27195	13418	97	0	\N
371921	1874	34562000	27195	13418	98	0	\N
371922	1874	34564000	27195	13418	99	0	\N
371923	1874	34566000	27195	13418	100	0	\N
371924	1874	34568000	27195	13418	101	0	\N
371925	1874	34570000	27195	13418	102	0	\N
371926	1874	34572000	27195	13418	103	0	\N
371927	1874	34574000	27195	13418	104	0	\N
371928	1874	34576000	27195	13418	105	0	\N
371929	1874	34578000	27195	13418	106	0	\N
371930	1874	34580000	27195	13418	107	0	\N
371931	1874	34582000	27195	13418	108	0	\N
371932	1874	34584000	27195	13418	109	0	\N
371933	1874	34586000	27195	13418	110	0	\N
371934	1874	34588000	27195	13418	111	0	\N
371935	1874	34590000	27195	13418	112	0	\N
371936	1874	34592000	27195	13418	113	0	\N
371937	1874	34594000	27195	13418	114	0	\N
371938	1874	34596000	27195	13418	115	0	\N
371939	1874	34598000	27195	13418	116	0	\N
371940	1874	34600000	27195	13418	117	0	\N
371941	1874	34602000	27195	13418	118	0	\N
371942	1874	34604000	27195	13418	119	0	\N
371943	1874	34606000	27195	13418	120	0	\N
371944	1874	34608000	27195	13418	121	0	\N
371945	1874	34610000	27195	13418	122	0	\N
371946	1874	34612000	27195	13418	123	0	\N
371947	1874	34614000	27195	13418	124	0	\N
371948	1874	34616000	27195	13418	125	0	\N
371951	1874	34628000	27196	13451	2	0	2
371952	1874	34630000	27196	13451	3	0	2
371953	1874	34632000	27196	13451	4	0	2
371954	1874	34635000	27196	13451	5	0	2
371955	1678	27360856470000	27197	13452	0	0	1
371957	1874	34640000	27197	13452	2	0	2
371958	1678	27360856471000	27198	13453	0	0	1
371959	1874	34643000	27198	13453	1	0	2
371960	2374	100000000	27198	13453	2	0	0
371963	1678	27360856471000	27199	13453	0	0	\N
371964	1874	34643000	27199	13453	1	0	\N
371965	2374	100000000	27199	13453	2	0	\N
371966	1874	34645000	27199	13453	3	0	\N
371967	2375	100000000	27199	13453	4	0	\N
371968	1678	27360856471000	27200	13453	0	0	\N
371969	1874	34643000	27200	13453	1	0	\N
371970	2374	100000000	27200	13453	2	0	\N
371971	1874	34645000	27200	13453	3	0	\N
371972	2375	100000000	27200	13453	4	0	\N
371973	2374	100000000	27201	13399	0	0	\N
371974	2375	100000000	27201	13399	1	0	\N
371985	1678	27360856473000	27204	13455	0	0	\N
371986	1678	27360856474000	27204	13455	1	0	\N
371987	1874	34653000	27204	13455	2	0	\N
371988	2376	100000000	27204	13455	3	0	\N
371989	1874	34655000	27204	13455	4	0	\N
371990	1874	34657000	27204	13455	5	0	\N
371991	1874	34660000	27204	13455	6	0	\N
371995	1678	27360856475000	27206	13456	0	0	\N
371996	1874	34662000	27206	13456	1	0	\N
371997	1874	34665000	27206	13456	2	0	\N
372003	1678	27360856478000	27209	13458	0	0	\N
372004	1874	34674000	27209	13458	1	0	\N
372005	1874	34677000	27209	13458	2	0	\N
372006	1678	27360856478000	27210	13458	0	0	\N
372007	1874	34674000	27210	13458	1	0	\N
372008	1874	34677000	27210	13458	2	0	\N
372015	1678	27360856406000	27213	13313	0	0	\N
372016	1678	27360856407000	27213	13313	1	0	\N
372017	1678	27360856408000	27213	13313	2	0	\N
372018	1678	27360856409000	27213	13313	3	0	\N
372019	1678	27360856410000	27213	13313	4	0	\N
372020	1678	27360856411000	27213	13313	5	0	\N
372021	1678	27360856412000	27213	13313	6	0	\N
372022	1678	27360856413000	27213	13313	7	0	\N
372023	1678	27360856414000	27213	13313	8	0	\N
372024	1678	27360856415000	27213	13313	9	0	\N
372025	1678	27360856416000	27213	13313	10	0	\N
372026	1678	27360856417000	27213	13313	11	0	\N
372027	1678	27360856418000	27213	13313	12	0	\N
372028	1678	27360856419000	27213	13313	13	0	\N
372029	1678	27360856420000	27213	13313	14	0	\N
372030	1678	27360856421000	27213	13313	15	0	\N
372031	1678	27360856422000	27213	13313	16	0	\N
372032	1678	27360856423000	27213	13313	17	0	\N
372033	1678	27360856424000	27213	13313	18	0	\N
372034	1678	27360856425000	27213	13313	19	0	\N
372035	1678	27360856426000	27213	13313	20	0	\N
372036	1678	27360856427000	27213	13313	21	0	\N
372037	1678	27360856428000	27213	13313	22	0	\N
372038	1678	27360856429000	27213	13313	23	0	\N
372039	1678	27360856430000	27213	13313	24	0	\N
372040	1678	27360856431000	27213	13313	25	0	\N
372041	1678	27360856432000	27213	13313	26	0	\N
372042	1678	27360856433000	27213	13313	27	0	\N
372043	1678	27360856434000	27213	13313	28	0	\N
372044	1678	27360856435000	27213	13313	29	0	\N
372045	1678	27360856436000	27213	13313	30	0	\N
372046	1678	27360856437000	27213	13313	31	0	\N
372047	1678	27360856438000	27213	13313	32	0	\N
372048	1678	27360856439000	27213	13313	33	0	\N
372049	1678	27360856440000	27213	13313	34	0	\N
372050	1678	27360856441000	27213	13313	35	0	\N
372051	1678	27360856442000	27213	13313	36	0	\N
372052	1678	27360856443000	27213	13313	37	0	\N
372053	1678	27360856444000	27213	13313	38	0	\N
372054	1678	27360856445000	27213	13313	39	0	\N
372055	1678	27360856446000	27213	13313	40	0	\N
372056	1678	27360856447000	27213	13313	41	0	\N
372057	1678	27360856448000	27213	13313	42	0	\N
372058	1678	27360856449000	27213	13313	43	0	\N
372059	1678	27360856450000	27213	13313	44	0	\N
372060	1678	27360856451000	27213	13313	45	0	\N
372061	1678	27360856452000	27213	13313	46	0	\N
372062	1678	27360856453000	27213	13313	47	0	\N
372063	1678	27360856454000	27213	13313	48	0	\N
372064	1678	27360856455000	27213	13313	49	0	\N
372065	1678	27360856456000	27213	13313	50	0	\N
372066	1678	27360856457000	27213	13313	51	0	\N
372067	1678	27360856458000	27213	13313	52	0	\N
372068	1678	27360856459000	27213	13313	53	0	\N
372069	1678	27360856460000	27213	13313	54	0	\N
372070	1678	27360856461000	27213	13313	55	0	\N
372071	1678	27360856462000	27213	13313	56	0	\N
372072	1678	27360856463000	27213	13313	57	0	\N
372073	1678	27360856464000	27213	13313	59	0	\N
372074	1678	27360856465000	27213	13313	60	0	\N
372075	1678	27360856466000	27213	13313	61	0	\N
372076	1678	27360856467000	27213	13313	62	0	\N
372077	1678	27360856468000	27213	13313	63	0	\N
372078	1678	27360856469000	27213	13313	64	0	\N
372079	1678	27360856470000	27213	13313	65	0	\N
372080	1678	27360856471000	27213	13313	66	0	\N
372081	1678	27360856472000	27213	13313	67	0	\N
372082	1678	27360856473000	27213	13313	68	0	\N
372083	1678	27360856474000	27213	13313	69	0	\N
372084	1678	27360856475000	27213	13313	70	0	\N
372085	1678	27360856476000	27213	13313	71	0	\N
372086	1678	27360856477000	27213	13313	72	0	\N
372087	1678	27360856478000	27213	13313	73	0	\N
372088	1678	27360856479000	27213	13313	74	0	\N
372089	1678	27360856480000	27213	13313	75	0	\N
372090	1678	27360856481000	27213	13313	76	0	\N
372091	1678	27360856482000	27213	13313	77	0	\N
372092	1678	27360856483000	27213	13313	78	0	\N
372093	1678	27360856484000	27213	13313	79	0	\N
372094	2374	100000000	27213	13313	80	0	\N
372095	2375	100000000	27213	13313	81	0	\N
372096	2376	100000000	27213	13313	82	0	\N
371975	1678	27360856472000	27202	13454	0	0	1
371976	1874	34647000	27202	13454	1	0	2
371977	1874	34650000	27202	13454	2	0	2
371978	1678	27360856473000	27203	13455	0	0	1
371979	1678	27360856474000	27203	13455	1	0	1
371981	2376	100000000	27203	13455	3	0	0
371982	1874	34655000	27203	13455	4	0	2
371983	1874	34657000	27203	13455	5	0	2
371984	1874	34660000	27203	13455	6	0	2
371992	1678	27360856475000	27205	13456	0	0	1
371994	1874	34665000	27205	13456	2	0	2
371998	1678	27360856476000	27207	13457	0	0	1
371999	1678	27360856477000	27207	13457	1	0	1
372000	1874	34668000	27207	13457	2	0	2
372002	1874	34672000	27207	13457	4	0	2
372009	1678	27360856478000	27211	13458	0	0	1
372010	1874	34674000	27211	13458	1	0	2
372011	1874	34677000	27211	13458	2	0	2
372012	1678	27360856479000	27212	13459	0	0	1
372014	1874	34682000	27212	13459	2	0	2
372097	1874	33947000	27213	13313	83	0	\N
372098	1874	33950000	27213	13313	84	0	\N
372099	1874	33953000	27213	13313	85	0	\N
372100	1874	33956000	27213	13313	86	0	\N
372101	1874	33959000	27213	13313	87	0	\N
372102	1874	33962000	27213	13313	88	0	\N
372103	1874	33965000	27213	13313	89	0	\N
372104	1678	27360856480000	27214	13460	0	0	\N
372105	1678	27360856481000	27214	13460	1	0	\N
372106	1678	27360856482000	27214	13460	2	0	\N
372107	1678	27360856483000	27214	13460	3	0	\N
372108	1678	27360856484000	27214	13460	4	0	\N
372109	1678	27360856485000	27214	13460	5	0	\N
372110	1678	27360856486000	27214	13460	6	0	\N
372111	1874	34684000	27214	13460	7	0	\N
372112	1874	34687000	27214	13460	8	0	\N
372113	1874	34690000	27214	13460	9	0	\N
372114	1874	34693000	27214	13460	10	0	\N
372115	1874	34696000	27214	13460	11	0	\N
372116	1874	34699000	27214	13460	12	0	\N
372117	1874	34702000	27214	13460	13	0	\N
372118	1874	34705000	27214	13460	14	0	\N
372119	1874	34707000	27214	13460	15	0	\N
372120	1874	34709000	27214	13460	16	0	\N
372121	1874	34711000	27214	13460	17	0	\N
372122	1874	34713000	27214	13460	18	0	\N
372123	1874	34715000	27214	13460	19	0	\N
372124	1874	34717000	27214	13460	20	0	\N
372146	1678	27360856469000	27216	13419	0	0	\N
372147	1678	27360856470000	27216	13419	1	0	\N
372148	1678	27360856471000	27216	13419	2	0	\N
372149	1678	27360856472000	27216	13419	3	0	\N
372150	1678	27360856473000	27216	13419	4	0	\N
372151	1678	27360856474000	27216	13419	5	0	\N
372152	1678	27360856475000	27216	13419	6	0	\N
372153	1678	27360856476000	27216	13419	7	0	\N
372154	1678	27360856477000	27216	13419	8	0	\N
372155	1678	27360856478000	27216	13419	9	0	\N
372156	1678	27360856479000	27216	13419	10	0	\N
372157	1678	27360856480000	27216	13419	11	0	\N
372158	1678	27360856481000	27216	13419	12	0	\N
372159	1678	27360856482000	27216	13419	13	0	\N
372160	1678	27360856483000	27216	13419	14	0	\N
372161	1678	27360856484000	27216	13419	15	0	\N
372162	1678	27360856485000	27216	13419	16	0	\N
372163	1678	27360856486000	27216	13419	17	0	\N
372164	1678	27360856487000	27216	13419	18	0	\N
372165	1678	27360856488000	27216	13419	19	0	\N
372166	2374	100000000	27216	13419	20	0	\N
372167	2375	100000000	27216	13419	21	0	\N
372168	2376	100000000	27216	13419	22	0	\N
372169	1874	34619000	27216	13419	23	0	\N
372170	1874	34622000	27216	13419	24	0	\N
372171	1874	34625000	27216	13419	25	0	\N
372172	1874	34628000	27216	13419	26	0	\N
372173	1874	34631000	27216	13419	27	0	\N
372174	1874	34634000	27216	13419	28	0	\N
372175	1874	34637000	27216	13419	29	0	\N
372176	1874	34640000	27216	13419	30	0	\N
372177	1874	34642000	27216	13419	31	0	\N
372178	1874	34644000	27216	13419	32	0	\N
372179	1874	34646000	27216	13419	33	0	\N
372180	1874	34648000	27216	13419	34	0	\N
372181	1874	34650000	27216	13419	35	0	\N
372182	1874	34652000	27216	13419	37	0	\N
372183	1874	34654000	27216	13419	38	0	\N
372184	1874	34656000	27216	13419	39	0	\N
372185	1874	34658000	27216	13419	40	0	\N
372186	1874	34660000	27216	13419	41	0	\N
372187	1874	34662000	27216	13419	42	0	\N
372188	1874	34664000	27216	13419	43	0	\N
372189	1874	34666000	27216	13419	44	0	\N
372190	1874	34668000	27216	13419	45	0	\N
372191	1874	34670000	27216	13419	46	0	\N
372192	1874	34672000	27216	13419	47	0	\N
372193	1874	34674000	27216	13419	48	0	\N
372194	1874	34676000	27216	13419	49	0	\N
372195	1874	34678000	27216	13419	50	0	\N
372196	1874	34681000	27216	13419	51	0	\N
372197	1874	34684000	27216	13419	52	0	\N
372198	1874	34687000	27216	13419	53	0	\N
372199	1874	34690000	27216	13419	54	0	\N
372200	1874	34693000	27216	13419	55	0	\N
372201	1874	34696000	27216	13419	56	0	\N
372202	1874	34699000	27216	13419	57	0	\N
372203	1874	34702000	27216	13419	58	0	\N
372204	1874	34705000	27216	13419	59	0	\N
372205	1874	34708000	27216	13419	60	0	\N
372206	1874	34711000	27216	13419	61	0	\N
372207	1874	34713000	27216	13419	62	0	\N
372208	1874	34715000	27216	13419	63	0	\N
372209	1874	34717000	27216	13419	64	0	\N
372210	1874	34719000	27216	13419	65	0	\N
372211	1874	34721000	27216	13419	66	0	\N
372212	1874	34723000	27216	13419	67	0	\N
372213	1874	34725000	27216	13419	68	0	\N
372214	1874	34727000	27216	13419	69	0	\N
372224	1678	27360856487000	27218	13461	0	0	\N
372225	1678	27360856488000	27218	13461	1	0	\N
372226	1678	27360856489000	27218	13461	2	0	\N
372227	1874	34720000	27218	13461	3	0	\N
372228	1874	34723000	27218	13461	4	0	\N
372229	1874	34726000	27218	13461	5	0	\N
372230	1874	34728000	27218	13461	6	0	\N
372231	1874	34730000	27218	13461	7	0	\N
372232	1874	34732000	27218	13461	8	0	\N
372127	1678	27360856482000	27215	13460	2	0	1
372128	1678	27360856483000	27215	13460	3	0	1
372129	1678	27360856484000	27215	13460	4	0	1
372130	1678	27360856485000	27215	13460	5	0	1
372131	1678	27360856486000	27215	13460	6	0	1
372133	1874	34687000	27215	13460	8	0	2
372134	1874	34690000	27215	13460	9	0	2
372135	1874	34693000	27215	13460	10	0	2
372136	1874	34696000	27215	13460	11	0	2
372137	1874	34699000	27215	13460	12	0	2
372139	1874	34705000	27215	13460	14	0	2
372140	1874	34707000	27215	13460	15	0	2
372141	1874	34709000	27215	13460	16	0	2
372142	1874	34711000	27215	13460	17	0	2
372144	1874	34715000	27215	13460	19	0	2
372145	1874	34717000	27215	13460	20	0	2
372215	1678	27360856487000	27217	13461	0	0	1
372216	1678	27360856488000	27217	13461	1	0	1
372217	1678	27360856489000	27217	13461	2	0	1
372219	1874	34723000	27217	13461	4	0	2
372220	1874	34726000	27217	13461	5	0	2
372221	1874	34728000	27217	13461	6	0	2
372222	1874	34730000	27217	13461	7	0	2
372223	1874	34732000	27217	13461	8	0	2
372233	1678	27360856487000	27219	13461	0	0	\N
372234	1678	27360856488000	27219	13461	1	0	\N
372235	1678	27360856489000	27219	13461	2	0	\N
372236	1874	34720000	27219	13461	3	0	\N
372237	1874	34723000	27219	13461	4	0	\N
372238	1874	34726000	27219	13461	5	0	\N
372239	1874	34728000	27219	13461	6	0	\N
372240	1874	34730000	27219	13461	7	0	\N
372241	1874	34732000	27219	13461	8	0	\N
372242	1678	27360856490000	27220	13462	0	0	\N
372243	1874	34735000	27220	13462	1	0	\N
372244	1874	34737000	27220	13462	2	0	\N
372245	1678	27360856490000	27221	13462	0	0	\N
372246	1874	34735000	27221	13462	1	0	\N
372247	1874	34737000	27221	13462	2	0	\N
372251	1678	27360856491000	27223	13463	0	0	\N
372252	1874	34740000	27223	13463	1	0	\N
372253	1874	34742000	27223	13463	2	0	\N
372254	1678	27360856491000	27224	13463	0	0	\N
372255	1874	34740000	27224	13463	1	0	\N
372256	1874	34742000	27224	13463	2	0	\N
372257	1678	27360856491000	27225	13463	0	0	\N
372258	1874	34740000	27225	13463	1	0	\N
372259	1874	34742000	27225	13463	2	0	\N
372260	1678	27360856491000	27226	13463	0	0	\N
372261	1874	34740000	27226	13463	1	0	\N
372262	1874	34742000	27226	13463	2	0	\N
372266	1678	27360856492000	27228	13464	0	0	\N
372267	1678	27360856493000	27228	13464	1	0	\N
372268	1874	34744000	27228	13464	2	0	\N
372269	1874	34746000	27228	13464	3	0	\N
372270	1874	34749000	27228	13464	4	0	\N
372271	1874	34752000	27228	13464	5	0	\N
372284	1678	27360856495000	27232	13466	0	0	\N
372285	1874	34759000	27232	13466	1	0	\N
372286	1874	34762000	27232	13466	2	0	\N
372287	1678	27360856495000	27233	13466	0	0	\N
372288	1874	34759000	27233	13466	1	0	\N
372289	1874	34762000	27233	13466	2	0	\N
372290	1678	27360856495000	27234	13466	0	0	\N
372291	1874	34759000	27234	13466	1	0	\N
372292	1874	34762000	27234	13466	2	0	\N
372293	1678	27360856495000	27235	13466	0	0	\N
372297	1678	27360856496000	27237	13467	0	0	\N
372298	1874	34765000	27237	13467	1	0	\N
372312	1678	27360856502000	27242	13471	0	0	\N
372313	1874	34782000	27242	13471	1	0	\N
372314	1874	34785000	27242	13471	2	0	\N
372315	2379	100000000	27242	13471	3	0	\N
372316	1678	27360856502000	27243	13471	0	0	\N
372317	1874	34782000	27243	13471	1	0	\N
372318	1874	34785000	27243	13471	2	0	\N
372319	2379	100000000	27243	13471	3	0	\N
372327	2374	100000000	27246	13382	0	0	\N
372328	1678	27360856504000	27247	13473	0	0	\N
372329	1874	34793000	27247	13473	1	0	\N
372330	1874	34795000	27247	13473	2	0	\N
372334	1678	27360856504000	27249	13473	0	0	\N
372335	1874	34793000	27249	13473	1	0	\N
372336	1874	34795000	27249	13473	2	0	\N
372337	1678	27360856504000	27250	13473	0	0	\N
372338	1874	34793000	27250	13473	1	0	\N
372339	1874	34795000	27250	13473	2	0	\N
372340	1678	27360856415000	27251	13411	0	0	\N
372341	1678	27360856416000	27251	13411	1	0	\N
372342	1678	27360856417000	27251	13411	2	0	\N
372343	1678	27360856418000	27251	13411	3	0	\N
372344	1678	27360856419000	27251	13411	4	0	\N
372345	1678	27360856420000	27251	13411	5	0	\N
372346	1678	27360856421000	27251	13411	6	0	\N
372347	1678	27360856422000	27251	13411	7	0	\N
372348	1678	27360856423000	27251	13411	8	0	\N
372349	1678	27360856424000	27251	13411	9	0	\N
372350	1678	27360856425000	27251	13411	10	0	\N
372351	1678	27360856426000	27251	13411	11	0	\N
372352	1678	27360856427000	27251	13411	12	0	\N
372353	1678	27360856428000	27251	13411	13	0	\N
372354	1678	27360856429000	27251	13411	14	0	\N
372355	1678	27360856430000	27251	13411	15	0	\N
372356	1678	27360856431000	27251	13411	16	0	\N
372357	1678	27360856432000	27251	13411	17	0	\N
372358	1678	27360856433000	27251	13411	18	0	\N
372359	1678	27360856434000	27251	13411	19	0	\N
372360	1678	27360856435000	27251	13411	20	0	\N
372361	1678	27360856436000	27251	13411	21	0	\N
372362	1678	27360856437000	27251	13411	22	0	\N
372363	1678	27360856438000	27251	13411	23	0	\N
372364	1678	27360856439000	27251	13411	24	0	\N
372365	1678	27360856440000	27251	13411	25	0	\N
372366	1678	27360856441000	27251	13411	26	0	\N
372367	1678	27360856442000	27251	13411	27	0	\N
372368	1678	27360856443000	27251	13411	28	0	\N
372250	1874	34737000	27222	13462	2	0	2
372263	1678	27360856491000	27227	13463	0	0	1
372264	1874	34740000	27227	13463	1	0	2
372265	1874	34742000	27227	13463	2	0	2
372272	1678	27360856492000	27229	13464	0	0	1
372274	1874	34744000	27229	13464	2	0	2
372275	1874	34746000	27229	13464	3	0	2
372276	1874	34749000	27229	13464	4	0	2
372277	1874	34752000	27229	13464	5	0	2
372278	1678	27360856494000	27230	13465	0	0	1
372280	1874	34757000	27230	13465	2	0	2
372281	1678	27360856495000	27231	13466	0	0	1
372282	1874	34759000	27231	13466	1	0	2
372283	1874	34762000	27231	13466	2	0	2
372295	1874	34764000	27236	13467	1	0	2
372296	1874	34767000	27236	13467	2	0	2
372299	1678	27360856497000	27239	13468	0	0	1
372300	1678	27360856498000	27239	13468	1	0	1
372301	1678	27360856499000	27239	13468	2	0	1
372303	2377	100000000	27239	13468	4	0	0
372304	2378	100000000	27239	13468	5	0	0
372305	1874	34772000	27239	13468	6	0	2
372306	1874	34774000	27239	13468	7	0	2
372307	1874	34776000	27239	13468	8	0	2
372309	1874	34778000	27240	13469	1	0	2
372310	1678	27360856501000	27241	13470	0	0	1
372311	1874	34780000	27241	13470	1	0	2
372320	1678	27360856502000	27244	13471	0	0	1
372322	1874	34785000	27244	13471	2	0	2
372323	2379	100000000	27244	13471	3	0	0
372324	1678	27360856503000	27245	13472	0	0	1
372325	1874	34788000	27245	13472	1	0	2
372326	1874	34790000	27245	13472	2	0	2
372332	1874	34793000	27248	13473	1	0	2
372333	1874	34795000	27248	13473	2	0	2
372369	1678	27360856444000	27251	13411	29	0	\N
372370	1678	27360856445000	27251	13411	30	0	\N
372371	1678	27360856446000	27251	13411	31	0	\N
372372	1678	27360856447000	27251	13411	32	0	\N
372373	1678	27360856448000	27251	13411	33	0	\N
372374	1678	27360856449000	27251	13411	34	0	\N
372375	1678	27360856450000	27251	13411	35	0	\N
372376	1678	27360856451000	27251	13411	36	0	\N
372377	1678	27360856452000	27251	13411	37	0	\N
372378	1678	27360856453000	27251	13411	38	0	\N
372379	1678	27360856454000	27251	13411	39	0	\N
372380	1678	27360856455000	27251	13411	40	0	\N
372381	1678	27360856456000	27251	13411	41	0	\N
372382	1678	27360856457000	27251	13411	42	0	\N
372383	1678	27360856458000	27251	13411	43	0	\N
372384	1678	27360856459000	27251	13411	44	0	\N
372385	1678	27360856460000	27251	13411	45	0	\N
372386	1678	27360856461000	27251	13411	46	0	\N
372387	1678	27360856462000	27251	13411	47	0	\N
372388	1678	27360856463000	27251	13411	48	0	\N
372389	1678	27360856464000	27251	13411	49	0	\N
372390	1678	27360856465000	27251	13411	50	0	\N
372391	1678	27360856466000	27251	13411	51	0	\N
372392	1678	27360856467000	27251	13411	52	0	\N
372393	1678	27360856468000	27251	13411	53	0	\N
372394	1678	27360856469000	27251	13411	54	0	\N
372395	1678	27360856470000	27251	13411	55	0	\N
372396	1678	27360856471000	27251	13411	56	0	\N
372397	1678	27360856472000	27251	13411	57	0	\N
372398	1678	27360856473000	27251	13411	58	0	\N
372399	1678	27360856474000	27251	13411	59	0	\N
372400	1678	27360856475000	27251	13411	60	0	\N
372401	1678	27360856476000	27251	13411	61	0	\N
372402	1678	27360856477000	27251	13411	62	0	\N
372403	1678	27360856478000	27251	13411	63	0	\N
372404	1678	27360856479000	27251	13411	64	0	\N
372405	1678	27360856480000	27251	13411	65	0	\N
372406	1678	27360856481000	27251	13411	66	0	\N
372407	1678	27360856482000	27251	13411	67	0	\N
372408	1678	27360856483000	27251	13411	68	0	\N
372409	1678	27360856484000	27251	13411	69	0	\N
372410	1678	27360856485000	27251	13411	70	0	\N
372411	1678	27360856486000	27251	13411	71	0	\N
372412	1678	27360856487000	27251	13411	72	0	\N
372413	1678	27360856488000	27251	13411	73	0	\N
372414	1678	27360856489000	27251	13411	74	0	\N
372415	1678	27360856490000	27251	13411	75	0	\N
372416	1678	27360856491000	27251	13411	76	0	\N
372417	1678	27360856492000	27251	13411	77	0	\N
372418	1678	27360856493000	27251	13411	78	0	\N
372419	1678	27360856494000	27251	13411	80	0	\N
372420	1678	27360856495000	27251	13411	81	0	\N
372421	1678	27360856496000	27251	13411	82	0	\N
372422	1678	27360856497000	27251	13411	83	0	\N
372423	1678	27360856498000	27251	13411	84	0	\N
372424	1678	27360856499000	27251	13411	85	0	\N
372425	1678	27360856500000	27251	13411	86	0	\N
372426	1678	27360856501000	27251	13411	87	0	\N
372427	1678	27360856502000	27251	13411	88	0	\N
372428	1678	27360856503000	27251	13411	89	0	\N
372429	1678	27360856504000	27251	13411	90	0	\N
372430	2374	100000000	27251	13411	91	0	\N
372431	1874	34365000	27251	13411	92	0	\N
372432	1874	34368000	27251	13411	93	0	\N
372433	1874	34371000	27251	13411	94	0	\N
372434	2375	100000000	27251	13411	95	0	\N
372435	1874	34374000	27251	13411	96	0	\N
372436	1874	34377000	27251	13411	97	0	\N
372437	1874	34380000	27251	13411	98	0	\N
372438	1874	34383000	27251	13411	99	0	\N
372439	2376	100000000	27251	13411	100	0	\N
372440	2377	100000000	27251	13411	101	0	\N
372441	2378	100000000	27251	13411	102	0	\N
372442	1874	34386000	27251	13411	103	0	\N
372443	2379	100000000	27251	13411	104	0	\N
372444	1874	34389000	27251	13411	105	0	\N
372445	1874	34392000	27251	13411	106	0	\N
372446	1874	34395000	27251	13411	107	0	\N
372447	1874	34397000	27251	13411	108	0	\N
372448	1874	34399000	27251	13411	109	0	\N
372449	1874	34401000	27251	13411	110	0	\N
372450	1874	34403000	27251	13411	111	0	\N
372451	1874	34405000	27251	13411	112	0	\N
372452	1874	34407000	27251	13411	113	0	\N
372453	1874	34409000	27251	13411	114	0	\N
372454	1874	34411000	27251	13411	115	0	\N
372455	1874	34413000	27251	13411	116	0	\N
372456	1874	34415000	27251	13411	117	0	\N
372457	1874	34417000	27251	13411	118	0	\N
372458	1874	34419000	27251	13411	119	0	\N
372459	1874	34421000	27251	13411	120	0	\N
372460	1874	34423000	27251	13411	121	0	\N
372461	1874	34425000	27251	13411	122	0	\N
372462	1874	34427000	27251	13411	123	0	\N
372463	1874	34429000	27251	13411	124	0	\N
372464	1874	34432000	27251	13411	125	0	\N
372468	1678	27360856505000	27253	13474	0	0	\N
372469	1874	34798000	27253	13474	1	0	\N
372470	1874	34800000	27253	13474	2	0	\N
372474	1678	27360856507000	27255	13476	0	0	\N
372475	1874	34807000	27255	13476	1	0	\N
372476	1874	34810000	27255	13476	2	0	\N
372480	1678	27360856508000	27258	13477	0	0	\N
372481	1874	34812000	27258	13477	1	0	\N
372482	1874	34815000	27258	13477	2	0	\N
372486	1678	27360856509000	27263	13478	0	0	\N
372487	1874	34818000	27263	13478	1	0	\N
372488	1678	27360856509000	27264	13478	0	0	\N
372489	1874	34818000	27264	13478	1	0	\N
372490	1874	34820000	27264	13478	2	0	\N
372491	1678	27360856509000	27265	13478	0	0	\N
372492	1874	34818000	27265	13478	1	0	\N
372493	1874	34820000	27265	13478	2	0	\N
372500	1678	27360856440000	27269	13431	0	0	\N
372501	1678	27360856441000	27269	13431	1	0	\N
372502	1678	27360856442000	27269	13431	2	0	\N
372503	1874	34492000	27269	13431	3	0	\N
372504	1874	34494000	27269	13431	4	0	\N
372467	1874	34800000	27252	13474	2	0	2
372471	1678	27360856506000	27254	13475	0	0	1
372472	1874	34803000	27254	13475	1	0	2
372473	1874	34805000	27254	13475	2	0	2
372477	1678	27360856507000	27256	13476	0	0	1
372479	1874	34810000	27256	13476	2	0	2
372483	1678	27360856508000	27259	13477	0	0	1
372484	1874	34812000	27259	13477	1	0	2
372485	1874	34815000	27259	13477	2	0	2
372494	1678	27360856509000	27266	13478	0	0	1
372496	1874	34820000	27266	13478	2	0	2
372497	1678	27360856510000	27268	13479	0	0	1
372498	1874	34822000	27268	13479	1	0	2
372499	1874	34825000	27268	13479	2	0	2
372505	1874	34497000	27269	13431	5	0	\N
372506	1874	34500000	27269	13431	6	0	\N
372507	1874	34503000	27269	13431	7	0	\N
372508	1874	34506000	27269	13431	8	0	\N
372509	1874	34509000	27269	13431	9	0	\N
372510	1874	34512000	27269	13431	10	0	\N
372511	1874	34515000	27269	13431	11	0	\N
372512	1874	34518000	27269	13431	12	0	\N
372513	1874	34521000	27269	13431	13	0	\N
372514	1874	34524000	27269	13431	14	0	\N
372515	1874	34527000	27269	13431	15	0	\N
372516	1874	34530000	27269	13431	16	0	\N
372517	1874	34533000	27269	13431	17	0	\N
372518	1874	34536000	27269	13431	18	0	\N
372519	1874	34539000	27269	13431	19	0	\N
372520	1874	34542000	27269	13431	20	0	\N
372521	1874	34545000	27269	13431	21	0	\N
372522	1874	34548000	27269	13431	22	0	\N
372523	1874	34551000	27269	13431	23	0	\N
372524	1874	34554000	27269	13431	24	0	\N
372525	1874	34557000	27269	13431	25	0	\N
372526	1874	34560000	27269	13431	26	0	\N
372527	1874	34563000	27269	13431	27	0	\N
372528	1874	34566000	27269	13431	28	0	\N
372529	1874	34569000	27269	13431	29	0	\N
372530	1874	34572000	27269	13431	30	0	\N
372531	1874	34575000	27269	13431	31	0	\N
372532	1874	34578000	27269	13431	32	0	\N
372533	1874	34581000	27269	13431	33	0	\N
372534	1874	34584000	27269	13431	34	0	\N
372535	1874	34586000	27269	13431	35	0	\N
372536	1874	34588000	27269	13431	36	0	\N
372537	1874	34590000	27269	13431	37	0	\N
372538	1874	34592000	27269	13431	38	0	\N
372539	1874	34594000	27269	13431	39	0	\N
372540	1874	34596000	27269	13431	40	0	\N
372541	1874	34598000	27269	13431	41	0	\N
372542	1874	34600000	27269	13431	42	0	\N
372543	1874	34602000	27269	13431	43	0	\N
372544	1874	34604000	27269	13431	44	0	\N
372545	1874	34606000	27269	13431	45	0	\N
372546	1874	34608000	27269	13431	46	0	\N
372547	1874	34610000	27269	13431	47	0	\N
372548	1874	34612000	27269	13431	48	0	\N
372549	1874	34614000	27269	13431	49	0	\N
372550	1874	34616000	27269	13431	50	0	\N
372551	1874	34618000	27269	13431	51	0	\N
372552	1874	34620000	27269	13431	52	0	\N
372553	1874	34622000	27269	13431	53	0	\N
372554	1874	34624000	27269	13431	54	0	\N
372555	1874	34626000	27269	13431	55	0	\N
372556	1874	34628000	27269	13431	56	0	\N
372557	1874	34630000	27269	13431	57	0	\N
372558	1874	34632000	27269	13431	58	0	\N
372559	1874	34634000	27269	13431	59	0	\N
372560	1874	34636000	27269	13431	60	0	\N
372561	1874	34638000	27269	13431	61	0	\N
372562	1874	34640000	27269	13431	62	0	\N
372563	1874	34642000	27270	13432	0	0	\N
372564	1874	34644000	27270	13432	1	0	\N
372565	1874	34646000	27270	13432	2	0	\N
372566	1874	34648000	27270	13432	3	0	\N
372567	1874	34650000	27270	13432	4	0	\N
372568	1874	34652000	27270	13432	5	0	\N
372569	1874	34654000	27270	13432	6	0	\N
372570	1874	34656000	27270	13432	7	0	\N
372571	1874	34658000	27270	13432	8	0	\N
372572	1874	34660000	27270	13432	9	0	\N
372573	1874	34662000	27270	13432	10	0	\N
372574	1874	34664000	27270	13432	11	0	\N
372575	1874	34666000	27270	13432	12	0	\N
372576	1874	34668000	27270	13432	13	0	\N
372577	1874	34670000	27270	13432	14	0	\N
372578	1874	34672000	27270	13432	15	0	\N
372579	1874	34674000	27270	13432	16	0	\N
372580	1874	34676000	27270	13432	17	0	\N
372581	1874	34678000	27270	13432	18	0	\N
372582	1874	34680000	27270	13432	19	0	\N
372583	1874	34682000	27270	13432	20	0	\N
372584	1874	34684000	27270	13432	21	0	\N
372585	1874	34686000	27270	13432	22	0	\N
372586	1874	34688000	27270	13432	23	0	\N
372587	1874	34690000	27270	13432	25	0	\N
372588	1874	34692000	27270	13432	26	0	\N
372589	1874	34694000	27270	13432	27	0	\N
372590	1874	34696000	27270	13432	28	0	\N
372591	1874	34698000	27270	13432	29	0	\N
372592	1874	34700000	27270	13432	30	0	\N
372593	1874	34702000	27270	13432	31	0	\N
372594	1874	34704000	27270	13432	32	0	\N
372595	1874	34706000	27270	13432	33	0	\N
372596	1874	34708000	27270	13432	34	0	\N
372597	1874	34710000	27270	13432	35	0	\N
372598	1874	34712000	27270	13432	36	0	\N
372599	1874	34714000	27270	13432	37	0	\N
372600	1874	34716000	27270	13432	38	0	\N
372601	1874	34718000	27270	13432	39	0	\N
372602	1678	27360856510000	27271	13479	0	0	\N
372603	1874	34822000	27271	13479	1	0	\N
372604	1874	34825000	27271	13479	2	0	\N
372611	1678	27360856511000	27274	13480	0	0	\N
372612	1678	27360856512000	27274	13480	1	0	\N
372613	1874	34827000	27274	13480	2	0	\N
372614	1874	34829000	27274	13480	3	0	\N
372615	1874	34832000	27274	13480	4	0	\N
372616	1874	34835000	27274	13480	5	0	\N
372620	1678	27360856513000	27276	13481	0	0	\N
372621	1874	34837000	27276	13481	1	0	\N
372622	1874	34840000	27276	13481	2	0	\N
372626	1678	27360856514000	27278	13482	0	0	\N
372627	1874	34842000	27278	13482	1	0	\N
372628	1874	34845000	27278	13482	2	0	\N
372607	1874	34827000	27273	13480	2	0	2
372608	1874	34829000	27273	13480	3	0	2
372609	1874	34832000	27273	13480	4	0	2
372610	1874	34835000	27273	13480	5	0	2
372617	1678	27360856513000	27275	13481	0	0	1
372619	1874	34840000	27275	13481	2	0	2
372623	1678	27360856514000	27277	13482	0	0	1
372624	1874	34842000	27277	13482	1	0	2
372625	1874	34845000	27277	13482	2	0	2
372629	1678	27360856515000	27279	13483	0	0	1
372631	1874	34850000	27279	13483	2	0	2
372632	1678	27360856516000	27281	13484	0	0	1
372633	1678	27360856517000	27281	13484	1	0	1
372634	1678	27360856518000	27281	13484	2	0	1
372636	1874	34856000	27281	13484	4	0	2
372637	1874	34858000	27281	13484	5	0	2
372638	1874	34861000	27281	13484	6	0	2
372639	1874	34863000	27281	13484	7	0	2
372640	1874	34865000	27281	13484	8	0	2
372643	1874	34720000	27283	13433	0	0	\N
372644	1874	34722000	27283	13433	1	0	\N
372645	1874	34724000	27283	13433	2	0	\N
372646	1874	34726000	27283	13433	3	0	\N
372647	1874	34728000	27283	13433	4	0	\N
372648	1874	34730000	27283	13433	5	0	\N
372649	1874	34732000	27283	13433	6	0	\N
372650	1874	34734000	27283	13433	7	0	\N
372651	1874	34736000	27283	13433	8	0	\N
372652	1874	34738000	27283	13433	9	0	\N
372653	1678	27360856411000	27284	13408	0	0	\N
372654	1678	27360856412000	27284	13408	1	0	\N
372655	1678	27360856413000	27284	13408	2	0	\N
372656	1678	27360856414000	27284	13408	3	0	\N
372657	1678	27360856415000	27284	13408	4	0	\N
372658	1678	27360856416000	27284	13408	5	0	\N
372659	1678	27360856417000	27284	13408	6	0	\N
372660	1678	27360856418000	27284	13408	7	0	\N
372661	1678	27360856419000	27284	13408	8	0	\N
372662	1678	27360856420000	27284	13408	9	0	\N
372663	1678	27360856421000	27284	13408	10	0	\N
372664	1678	27360856422000	27284	13408	11	0	\N
372665	1678	27360856423000	27284	13408	12	0	\N
372666	1678	27360856424000	27284	13408	13	0	\N
372667	1678	27360856425000	27284	13408	14	0	\N
372668	1678	27360856426000	27284	13408	15	0	\N
372669	1678	27360856427000	27284	13408	16	0	\N
372670	1678	27360856428000	27284	13408	17	0	\N
372671	1678	27360856429000	27284	13408	18	0	\N
372672	1678	27360856430000	27284	13408	19	0	\N
372673	1678	27360856431000	27284	13408	20	0	\N
372674	1678	27360856432000	27284	13408	21	0	\N
372675	1678	27360856433000	27284	13408	22	0	\N
372676	1678	27360856434000	27284	13408	23	0	\N
372677	1678	27360856435000	27284	13408	24	0	\N
372678	1678	27360856436000	27284	13408	25	0	\N
372679	1678	27360856437000	27284	13408	26	0	\N
372680	1678	27360856438000	27284	13408	27	0	\N
372681	1678	27360856439000	27284	13408	28	0	\N
372682	1678	27360856440000	27284	13408	29	0	\N
372683	1678	27360856441000	27284	13408	30	0	\N
372684	1678	27360856442000	27284	13408	31	0	\N
372685	1678	27360856443000	27284	13408	32	0	\N
372686	1678	27360856444000	27284	13408	33	0	\N
372687	1678	27360856445000	27284	13408	34	0	\N
372688	1678	27360856446000	27284	13408	35	0	\N
372689	1678	27360856447000	27284	13408	36	0	\N
372690	1678	27360856448000	27284	13408	37	0	\N
372691	1678	27360856449000	27284	13408	38	0	\N
372692	1678	27360856450000	27284	13408	39	0	\N
372693	1678	27360856451000	27284	13408	40	0	\N
372694	1678	27360856452000	27284	13408	41	0	\N
372695	1678	27360856453000	27284	13408	42	0	\N
372696	1678	27360856454000	27284	13408	43	0	\N
372697	1678	27360856455000	27284	13408	44	0	\N
372698	1678	27360856456000	27284	13408	45	0	\N
372699	1678	27360856457000	27284	13408	46	0	\N
372700	1678	27360856458000	27284	13408	47	0	\N
372701	1678	27360856459000	27284	13408	48	0	\N
372702	1678	27360856460000	27284	13408	49	0	\N
372703	1678	27360856461000	27284	13408	50	0	\N
372704	1678	27360856462000	27284	13408	51	0	\N
372705	1678	27360856463000	27284	13408	52	0	\N
372706	1678	27360856464000	27284	13408	53	0	\N
372707	1678	27360856465000	27284	13408	54	0	\N
372708	1678	27360856466000	27284	13408	55	0	\N
372709	1678	27360856467000	27284	13408	56	0	\N
372710	1678	27360856468000	27284	13408	57	0	\N
372711	1678	27360856469000	27284	13408	58	0	\N
372712	1678	27360856470000	27284	13408	59	0	\N
372713	1678	27360856471000	27284	13408	60	0	\N
372714	1678	27360856472000	27284	13408	61	0	\N
372715	1678	27360856473000	27284	13408	62	0	\N
372716	1678	27360856474000	27284	13408	63	0	\N
372717	1678	27360856475000	27284	13408	64	0	\N
372718	1678	27360856476000	27284	13408	65	0	\N
372719	1678	27360856477000	27284	13408	66	0	\N
372720	1678	27360856478000	27284	13408	67	0	\N
372721	1678	27360856479000	27284	13408	68	0	\N
372722	1678	27360856480000	27284	13408	69	0	\N
372723	1678	27360856481000	27284	13408	70	0	\N
372724	1678	27360856482000	27284	13408	71	0	\N
372725	1678	27360856483000	27284	13408	72	0	\N
372726	1678	27360856484000	27284	13408	73	0	\N
372727	1678	27360856485000	27284	13408	74	0	\N
372728	1678	27360856486000	27284	13408	75	0	\N
372729	1678	27360856487000	27284	13408	76	0	\N
372730	1678	27360856488000	27284	13408	77	0	\N
372731	1678	27360856489000	27284	13408	78	0	\N
372732	1678	27360856490000	27284	13408	79	0	\N
372733	1678	27360856491000	27284	13408	80	0	\N
372734	1678	27360856492000	27284	13408	81	0	\N
372735	1678	27360856493000	27284	13408	82	0	\N
372736	1678	27360856494000	27284	13408	83	0	\N
372737	1678	27360856495000	27284	13408	84	0	\N
372738	1678	27360856496000	27284	13408	85	0	\N
372739	1678	27360856497000	27284	13408	86	0	\N
372740	1678	27360856498000	27284	13408	87	0	\N
372741	1678	27360856499000	27284	13408	88	0	\N
372742	1678	27360856500000	27284	13408	89	0	\N
372743	1678	27360856501000	27284	13408	90	0	\N
372744	1678	27360856502000	27284	13408	91	0	\N
372745	1678	27360856503000	27284	13408	92	0	\N
372746	1678	27360856504000	27284	13408	93	0	\N
372747	1678	27360856505000	27284	13408	94	0	\N
372748	1678	27360856506000	27284	13408	95	0	\N
372749	1678	27360856507000	27284	13408	96	0	\N
372750	1678	27360856508000	27284	13408	98	0	\N
372751	1678	27360856509000	27284	13408	99	0	\N
372752	1678	27360856510000	27284	13408	100	0	\N
372753	1678	27360856511000	27284	13408	101	0	\N
372754	1678	27360856512000	27284	13408	102	0	\N
372755	1678	27360856513000	27284	13408	103	0	\N
372756	1678	27360856514000	27284	13408	104	0	\N
372757	1678	27360856515000	27284	13408	105	0	\N
372758	1678	27360856516000	27284	13408	106	0	\N
372759	1678	27360856517000	27284	13408	107	0	\N
372760	1678	27360856518000	27284	13408	108	0	\N
372761	1678	27360856519000	27284	13408	109	0	\N
372762	2374	100000000	27284	13408	110	0	\N
372763	2375	100000000	27284	13408	111	0	\N
372764	2376	100000000	27284	13408	112	0	\N
372765	2377	100000000	27284	13408	113	0	\N
372766	2378	100000000	27284	13408	114	0	\N
372767	1874	34346000	27284	13408	115	0	\N
372768	1874	34349000	27284	13408	116	0	\N
372769	1874	34352000	27284	13408	117	0	\N
372770	2379	100000000	27284	13408	118	0	\N
372771	1874	34355000	27284	13408	119	0	\N
372772	1874	34358000	27284	13408	120	0	\N
372773	1874	34361000	27284	13408	121	0	\N
372774	1874	34364000	27284	13408	122	0	\N
372775	1874	34367000	27284	13408	123	0	\N
372776	1874	34370000	27284	13408	124	0	\N
372782	1678	27360856521000	27286	13487	0	0	\N
372783	1874	34881000	27286	13487	1	0	\N
372786	1678	27360856521000	27288	13487	0	0	\N
372787	1874	34881000	27288	13487	1	0	\N
372788	1874	34740000	27289	13434	0	0	\N
372791	1678	27360856522000	27291	13488	0	0	\N
372792	1874	34884000	27291	13488	1	0	\N
372795	1678	27360856523000	27293	13489	0	0	\N
372796	1874	34887000	27293	13489	1	0	\N
372801	1874	34883000	27295	13488	0	0	\N
372805	1678	27360856527000	27297	13492	0	0	\N
372806	1678	27360856528000	27297	13492	1	0	\N
372807	1874	34900000	27297	13492	2	0	\N
372808	1874	34903000	27297	13492	3	0	\N
372809	1874	34905000	27297	13492	4	0	\N
372810	1874	34908000	27297	13492	5	0	\N
372820	1678	27360856530000	27300	13494	0	0	\N
372821	1874	34916000	27300	13494	1	0	\N
372822	1874	34918000	27300	13494	2	0	\N
372835	1678	27360856534000	27304	13497	0	0	\N
372836	1874	34936000	27304	13497	1	0	\N
372837	1874	34938000	27304	13497	2	0	\N
372841	1678	27360856535000	27306	13498	0	0	\N
372842	1874	34941000	27306	13498	1	0	\N
372843	1874	34943000	27306	13498	2	0	\N
372844	1678	27360856535000	27307	13498	0	0	\N
372845	1874	34941000	27307	13498	1	0	\N
372846	1874	34943000	27307	13498	2	0	\N
372847	1678	27360856535000	27308	13498	0	0	\N
372848	1874	34941000	27308	13498	1	0	\N
372849	1874	34943000	27308	13498	2	0	\N
372874	1678	27360856542000	27317	13504	0	0	\N
372875	1874	34976000	27317	13504	1	0	\N
372876	1874	34978000	27317	13504	2	0	\N
372877	1678	27360856543000	27318	13505	0	0	\N
372878	1678	27360856544000	27318	13505	1	0	\N
372879	1874	34980000	27318	13505	2	0	\N
372880	1874	34982000	27318	13505	3	0	\N
372881	1874	34985000	27318	13505	4	0	\N
372882	1874	34988000	27318	13505	5	0	\N
372898	1678	27360856546000	27322	13507	0	0	\N
372899	1678	27360856547000	27322	13507	1	0	\N
372900	1874	34995000	27322	13507	2	0	\N
372901	1874	34997000	27322	13507	3	0	\N
372902	1874	35000000	27322	13507	4	0	\N
372903	1874	35003000	27322	13507	5	0	\N
372907	1678	27360856548000	27324	13508	0	0	\N
372908	1874	35005000	27324	13508	1	0	\N
372909	1874	35008000	27324	13508	2	0	\N
372910	1678	27360856548000	27325	13508	0	0	\N
372911	1874	35005000	27325	13508	1	0	\N
372912	1874	35008000	27325	13508	2	0	\N
372779	1874	34873000	27285	13486	2	0	2
372780	1874	34876000	27285	13486	3	0	2
372781	1874	34878000	27285	13486	4	0	2
372784	1678	27360856521000	27287	13487	0	0	1
372785	1874	34881000	27287	13487	1	0	2
372790	1874	34884000	27290	13488	1	0	2
372793	1678	27360856523000	27292	13489	0	0	1
372794	1874	34887000	27292	13489	1	0	2
372797	1678	27360856524000	27294	13490	0	0	1
372798	1678	27360856525000	27294	13490	1	0	1
372800	1874	34893000	27294	13490	3	0	2
372802	1678	27360856526000	27296	13491	0	0	1
372803	1874	34895000	27296	13491	1	0	2
372804	1874	34898000	27296	13491	2	0	2
372812	1678	27360856528000	27298	13492	1	0	1
372813	1874	34900000	27298	13492	2	0	2
372814	1874	34903000	27298	13492	3	0	2
372815	1874	34905000	27298	13492	4	0	2
372816	1874	34908000	27298	13492	5	0	2
372818	1874	34911000	27299	13493	1	0	2
372819	1874	34913000	27299	13493	2	0	2
372823	1678	27360856530000	27301	13494	0	0	1
372824	1874	34916000	27301	13494	1	0	2
372825	1874	34918000	27301	13494	2	0	2
372827	1678	27360856532000	27302	13495	1	0	1
372828	1874	34921000	27302	13495	2	0	2
372829	1874	34923000	27302	13495	3	0	2
372830	1874	34925000	27302	13495	4	0	2
372832	1678	27360856533000	27303	13496	0	0	1
372833	1874	34931000	27303	13496	1	0	2
372834	1874	34933000	27303	13496	2	0	2
372838	1678	27360856534000	27305	13497	0	0	1
372839	1874	34936000	27305	13497	1	0	2
372850	1678	27360856535000	27309	13498	0	0	1
372851	1874	34941000	27309	13498	1	0	2
372852	1874	34943000	27309	13498	2	0	2
372853	1678	27360856536000	27310	13499	0	0	1
372854	1874	34946000	27310	13499	1	0	2
372856	1678	27360856537000	27311	13500	0	0	1
372857	1874	34950000	27311	13500	1	0	2
372858	1874	34953000	27311	13500	2	0	2
372859	1678	27360856538000	27312	13501	0	0	1
372861	1874	34958000	27312	13501	2	0	2
372862	1678	27360856539000	27314	13502	0	0	1
372863	1678	27360856540000	27314	13502	1	0	1
372864	1874	34961000	27314	13502	2	0	2
372865	1874	34964000	27314	13502	3	0	2
372867	1874	34968000	27314	13502	5	0	2
372868	1678	27360856541000	27315	13503	0	0	1
372869	1874	34971000	27315	13503	1	0	2
372870	1874	34973000	27315	13503	2	0	2
372871	1678	27360856542000	27316	13504	0	0	1
372873	1874	34978000	27316	13504	2	0	2
372883	1678	27360856543000	27319	13505	0	0	1
372884	1678	27360856544000	27319	13505	1	0	1
372885	1874	34980000	27319	13505	2	0	2
372887	1874	34985000	27319	13505	4	0	2
372888	1874	34988000	27319	13505	5	0	2
372889	1678	27360856545000	27320	13506	0	0	1
372890	1874	34991000	27320	13506	1	0	2
372891	1874	34993000	27320	13506	2	0	2
372893	1678	27360856547000	27321	13507	1	0	1
372894	1874	34995000	27321	13507	2	0	2
372895	1874	34997000	27321	13507	3	0	2
372896	1874	35000000	27321	13507	4	0	2
372897	1874	35003000	27321	13507	5	0	2
372905	1874	35005000	27323	13508	1	0	2
372906	1874	35008000	27323	13508	2	0	2
372913	1678	27360856548000	27326	13508	0	0	\N
372914	1874	35005000	27326	13508	1	0	\N
372915	1874	35008000	27326	13508	2	0	\N
372916	1678	27360856548000	27327	13508	0	0	\N
372917	1874	35005000	27327	13508	1	0	\N
372918	1874	35008000	27327	13508	2	0	\N
372919	1678	27360856548000	27328	13508	0	0	\N
372920	1874	35005000	27328	13508	1	0	\N
372921	1874	35008000	27328	13508	2	0	\N
372922	1678	27360856548000	27329	13508	0	0	\N
372923	1874	35005000	27329	13508	1	0	\N
372924	1874	35008000	27329	13508	2	0	\N
372928	1678	27360856549000	27331	13509	0	0	\N
372929	1874	35010000	27331	13509	1	0	\N
372930	1874	35013000	27331	13509	2	0	\N
372938	1678	27360856552000	27334	13512	0	0	\N
372939	1874	35026000	27334	13512	1	0	\N
372940	1874	35028000	27334	13512	2	0	\N
372962	1678	27360856558000	27340	13516	0	0	\N
372963	1874	35055000	27340	13516	1	0	\N
372964	1874	35058000	27340	13516	2	0	\N
372965	1678	27360856558000	27341	13516	0	0	\N
372966	1874	35055000	27341	13516	1	0	\N
372967	1874	35058000	27341	13516	2	0	\N
372983	1678	27360856564000	27346	13521	0	0	\N
372984	1874	35086000	27346	13521	1	0	\N
372985	1874	35088000	27346	13521	2	0	\N
372986	1678	27360856564000	27347	13521	0	0	\N
372987	1874	35086000	27347	13521	1	0	\N
372988	1874	35088000	27347	13521	2	0	\N
372995	1678	27360856565000	27350	13522	0	0	\N
372996	1874	35091000	27350	13522	1	0	\N
372997	1874	35093000	27350	13522	2	0	\N
373013	1678	27360856569000	27354	13524	0	0	\N
373014	1678	27360856570000	27354	13524	1	0	\N
373015	1874	35110000	27354	13524	2	0	\N
373016	1874	35112000	27354	13524	3	0	\N
373017	1874	35115000	27354	13524	4	0	\N
373018	1874	35118000	27354	13524	5	0	\N
373028	1678	27360856571000	27356	13525	0	0	\N
373029	1678	27360856572000	27356	13525	1	0	\N
373030	1678	27360856573000	27356	13525	2	0	\N
373031	1874	35121000	27356	13525	3	0	\N
373032	1874	35124000	27356	13525	4	0	\N
373033	1874	35127000	27356	13525	5	0	\N
373034	1874	35129000	27356	13525	6	0	\N
373035	1874	35131000	27356	13525	7	0	\N
373036	1874	35133000	27356	13525	8	0	\N
373037	1678	27360856571000	27357	13525	0	0	\N
373038	1678	27360856572000	27357	13525	1	0	\N
373039	1678	27360856573000	27357	13525	2	0	\N
373040	1874	35121000	27357	13525	3	0	\N
373041	1874	35124000	27357	13525	4	0	\N
373042	1874	35127000	27357	13525	5	0	\N
373043	1874	35129000	27357	13525	6	0	\N
373044	1874	35131000	27357	13525	7	0	\N
373045	1874	35133000	27357	13525	8	0	\N
373046	1678	27360856571000	27358	13525	0	0	\N
373047	1678	27360856572000	27358	13525	1	0	\N
373048	1678	27360856573000	27358	13525	2	0	\N
372927	1874	35013000	27330	13509	2	0	2
372931	1678	27360856550000	27332	13510	0	0	1
372932	1874	35016000	27332	13510	1	0	2
372933	1874	35018000	27332	13510	2	0	2
372934	1678	27360856551000	27333	13511	0	0	1
372936	1874	35020000	27333	13511	2	0	2
372937	1874	35023000	27333	13511	3	0	2
372941	1678	27360856552000	27335	13512	0	0	1
372942	1874	35026000	27335	13512	1	0	2
372943	1874	35028000	27335	13512	2	0	2
372945	1678	27360856554000	27336	13513	1	0	1
372946	1678	27360856555000	27336	13513	2	0	1
372947	1874	35031000	27336	13513	3	0	2
372948	1874	35033000	27336	13513	4	0	2
372950	1874	35037000	27336	13513	6	0	2
372951	1874	35040000	27336	13513	7	0	2
372952	1874	35043000	27336	13513	8	0	2
372953	1678	27360856556000	27337	13514	0	0	1
372954	1874	35046000	27337	13514	1	0	2
372956	1678	27360856557000	27338	13515	0	0	1
372957	1874	35050000	27338	13515	1	0	2
372958	1874	35053000	27338	13515	2	0	2
372959	1678	27360856558000	27339	13516	0	0	1
372960	1874	35055000	27339	13516	1	0	2
372968	1678	27360856559000	27342	13517	0	0	1
372969	1678	27360856560000	27342	13517	1	0	1
372970	1874	35060000	27342	13517	2	0	2
372971	1874	35063000	27342	13517	3	0	2
372973	1874	35068000	27342	13517	5	0	2
372974	1678	27360856561000	27343	13518	0	0	1
372975	1874	35070000	27343	13518	1	0	2
372976	1874	35073000	27343	13518	2	0	2
372977	1678	27360856562000	27344	13519	0	0	1
372979	1874	35078000	27344	13519	2	0	2
372980	1678	27360856563000	27345	13520	0	0	1
372981	1874	35081000	27345	13520	1	0	2
372982	1874	35083000	27345	13520	2	0	2
372989	1678	27360856564000	27348	13521	0	0	1
372991	1874	35088000	27348	13521	2	0	2
372992	1678	27360856565000	27349	13522	0	0	1
372993	1874	35091000	27349	13522	1	0	2
372994	1874	35093000	27349	13522	2	0	2
372999	1678	27360856567000	27352	13523	1	0	1
373000	1678	27360856568000	27352	13523	2	0	1
373001	1874	35095000	27352	13523	3	0	2
373002	1874	35097000	27352	13523	4	0	2
373003	1874	35100000	27352	13523	5	0	2
373005	1874	35106000	27352	13523	7	0	2
373006	1874	35108000	27352	13523	8	0	2
373007	1678	27360856569000	27353	13524	0	0	1
373008	1678	27360856570000	27353	13524	1	0	1
373009	1874	35110000	27353	13524	2	0	2
373011	1874	35115000	27353	13524	4	0	2
373012	1874	35118000	27353	13524	5	0	2
373019	1678	27360856571000	27355	13525	0	0	1
373020	1678	27360856572000	27355	13525	1	0	1
373022	1874	35121000	27355	13525	3	0	2
373023	1874	35124000	27355	13525	4	0	2
373024	1874	35127000	27355	13525	5	0	2
373025	1874	35129000	27355	13525	6	0	2
373026	1874	35131000	27355	13525	7	0	2
373049	1874	35121000	27358	13525	3	0	\N
373050	1874	35124000	27358	13525	4	0	\N
373051	1874	35127000	27358	13525	5	0	\N
373052	1874	35129000	27358	13525	6	0	\N
373053	1874	35131000	27358	13525	7	0	\N
373054	1874	35133000	27358	13525	8	0	\N
373067	1678	27360856574000	27360	13526	0	0	\N
373068	1678	27360856575000	27360	13526	1	0	\N
373069	1678	27360856576000	27360	13526	2	0	\N
373070	1874	35135000	27360	13526	3	0	\N
373071	1874	35137000	27360	13526	4	0	\N
373072	1874	35139000	27360	13526	5	0	\N
373073	1874	35142000	27360	13526	6	0	\N
373074	1874	35145000	27360	13526	7	0	\N
373075	1874	35148000	27360	13526	8	0	\N
373076	657	66001000000000	27360	13526	9	0	\N
373077	590	66001000000000	27360	13526	10	0	\N
373078	553	66001000000000	27360	13526	12	0	\N
373101	1678	27360856583000	27366	13531	0	0	\N
373102	1874	35181000	27366	13531	1	0	\N
373103	1874	35183000	27366	13531	2	0	\N
373104	1454	0	27367	13435	0	0	\N
373105	657	66001000000000	27367	13435	1	0	\N
373106	590	66001000000000	27367	13435	2	0	\N
373107	553	66001000000000	27367	13435	3	0	\N
373108	1874	34742000	27367	13435	4	0	\N
373109	1874	34744000	27367	13435	5	0	\N
373110	1874	34746000	27367	13435	6	0	\N
373111	1874	34748000	27367	13435	7	0	\N
373112	1874	34750000	27367	13435	8	0	\N
373113	1874	34752000	27367	13435	9	0	\N
373114	1874	34754000	27367	13435	10	0	\N
373115	1874	34756000	27367	13435	11	0	\N
373116	1874	34758000	27367	13435	12	0	\N
373117	1874	34760000	27367	13435	13	0	\N
373118	1874	34762000	27367	13435	14	0	\N
373119	1874	34764000	27367	13435	15	0	\N
373120	1874	34766000	27367	13435	16	0	\N
373121	1874	34768000	27367	13435	17	0	\N
373122	1874	34770000	27367	13435	18	0	\N
373123	1874	34772000	27367	13435	19	0	\N
373124	1874	34774000	27367	13435	20	0	\N
373125	1874	34776000	27367	13435	21	0	\N
373126	1874	34778000	27367	13435	22	0	\N
373127	1874	34780000	27367	13435	23	0	\N
373128	1874	34782000	27367	13435	24	0	\N
373129	1874	34784000	27367	13435	25	0	\N
373130	1874	34786000	27367	13435	26	0	\N
373131	1874	34788000	27367	13435	27	0	\N
373132	1874	34790000	27367	13435	28	0	\N
373133	1874	34792000	27367	13435	29	0	\N
373134	1874	34794000	27367	13435	30	0	\N
373135	1874	34796000	27367	13435	31	0	\N
373136	1874	34798000	27367	13435	32	0	\N
373137	1874	34800000	27367	13435	33	0	\N
373138	1874	34802000	27367	13435	34	0	\N
373139	1874	34804000	27367	13435	35	0	\N
373140	1874	34806000	27367	13435	36	0	\N
373141	1874	34808000	27367	13435	37	0	\N
373142	1874	34810000	27367	13435	38	0	\N
373143	1874	34812000	27367	13435	39	0	\N
373144	1874	34814000	27367	13435	40	0	\N
373145	1874	34816000	27367	13435	41	0	\N
373146	1874	34818000	27367	13435	42	0	\N
373147	1874	34820000	27367	13435	43	0	\N
373148	1874	34822000	27367	13435	44	0	\N
373149	1874	34824000	27367	13435	45	0	\N
373150	1874	34826000	27367	13435	46	0	\N
373151	1874	34828000	27367	13435	47	0	\N
373152	1874	34830000	27367	13435	48	0	\N
373153	1874	34832000	27367	13435	49	0	\N
373154	1874	34834000	27367	13435	50	0	\N
373155	1874	34836000	27367	13435	51	0	\N
373156	1874	34838000	27367	13435	52	0	\N
373157	1874	34840000	27367	13435	53	0	\N
373158	1874	34842000	27367	13435	54	0	\N
373159	1874	34844000	27367	13435	55	0	\N
373160	1874	34846000	27367	13435	56	0	\N
373161	1874	34848000	27367	13435	57	0	\N
373162	1874	34850000	27367	13435	58	0	\N
373163	1874	34852000	27367	13435	59	0	\N
373164	1874	34854000	27367	13435	60	0	\N
373165	1874	34856000	27367	13435	61	0	\N
373172	1678	27360856585000	27370	13533	0	0	\N
373173	1874	35190000	27370	13533	1	0	\N
373174	1874	35193000	27370	13533	2	0	\N
373178	1678	27360856586000	27372	13534	0	0	\N
373179	1874	35196000	27372	13534	1	0	\N
373180	1874	35198000	27372	13534	2	0	\N
373057	1678	27360856576000	27359	13526	2	0	1
373058	1874	35135000	27359	13526	3	0	2
373059	1874	35137000	27359	13526	4	0	2
373060	1874	35139000	27359	13526	5	0	2
373061	1874	35142000	27359	13526	6	0	2
373063	1874	35148000	27359	13526	8	0	2
373064	657	66001000000000	27359	13526	9	0	0
373065	590	66001000000000	27359	13526	10	0	0
373066	553	66001000000000	27359	13526	12	0	0
373079	1678	27360856577000	27361	13527	0	0	1
373081	1678	27360856579000	27361	13527	2	0	1
373082	1874	35150000	27361	13527	3	0	2
373083	1874	35152000	27361	13527	4	0	2
373084	1874	35154000	27361	13527	5	0	2
373086	1874	35160000	27361	13527	7	0	2
373087	1874	35163000	27361	13527	8	0	2
373088	1678	27360856580000	27362	13528	0	0	1
373089	1874	35166000	27362	13528	1	0	2
373090	1874	35168000	27362	13528	2	0	2
373092	1874	35170000	27363	13529	1	0	2
373093	1874	35173000	27363	13529	2	0	2
373094	1678	27360856582000	27364	13530	0	0	1
373095	1874	35176000	27364	13530	1	0	2
373096	1874	35178000	27364	13530	2	0	2
373098	1678	27360856583000	27365	13531	0	0	1
373099	1874	35181000	27365	13531	1	0	2
373100	1874	35183000	27365	13531	2	0	2
373166	1678	27360856584000	27368	13532	0	0	1
373168	1874	35188000	27368	13532	2	0	2
373169	1678	27360856585000	27369	13533	0	0	1
373170	1874	35190000	27369	13533	1	0	2
373171	1874	35193000	27369	13533	2	0	2
373175	1678	27360856586000	27371	13534	0	0	1
373177	1874	35198000	27371	13534	2	0	2
373181	1678	27360856587000	27373	13535	0	0	1
373182	1874	35201000	27373	13535	1	0	2
373183	1874	35203000	27373	13535	2	0	2
373184	1678	27360856588000	27374	13536	0	0	1
373199	1678	27360856588000	27375	13536	0	0	\N
373200	1678	27360856589000	27375	13536	1	0	\N
373201	1678	27360856590000	27375	13536	2	0	\N
373202	1678	27360856591000	27375	13536	3	0	\N
373203	1678	27360856592000	27375	13536	4	0	\N
373204	1874	35205000	27375	13536	5	0	\N
373205	1874	35207000	27375	13536	6	0	\N
373206	1874	35210000	27375	13536	7	0	\N
373207	1874	35213000	27375	13536	8	0	\N
373208	1874	35216000	27375	13536	9	0	\N
373209	1874	35219000	27375	13536	10	0	\N
373210	1874	35222000	27375	13536	11	0	\N
373211	1874	35224000	27375	13536	12	0	\N
373212	1874	35226000	27375	13536	13	0	\N
373213	1874	35228000	27375	13536	14	0	\N
373220	1678	27360856593000	27377	13537	0	0	\N
373221	1678	27360856594000	27377	13537	1	0	\N
373222	1874	35231000	27377	13537	2	0	\N
373223	1874	35233000	27377	13537	3	0	\N
373224	1874	35235000	27377	13537	4	0	\N
373225	1874	35238000	27377	13537	5	0	\N
373229	1678	27360856596000	27379	13539	0	0	\N
373230	1874	35245000	27379	13539	1	0	\N
373231	1874	35248000	27379	13539	2	0	\N
373235	1678	27360856597000	27381	13540	0	0	\N
373236	1678	27360856598000	27381	13540	1	0	\N
373237	1678	27360856599000	27381	13540	2	0	\N
373238	1874	35251000	27381	13540	3	0	\N
373239	1874	35253000	27381	13540	4	0	\N
373240	1874	35256000	27381	13540	5	0	\N
373241	1874	35259000	27381	13540	6	0	\N
373242	1874	35261000	27381	13540	7	0	\N
373243	1874	35263000	27381	13540	8	0	\N
373253	1678	27360856600000	27383	13541	0	0	\N
373254	1874	35265000	27383	13541	1	0	\N
373255	1874	35268000	27383	13541	2	0	\N
373256	1678	27360856600000	27384	13541	0	0	\N
373257	1874	35265000	27384	13541	1	0	\N
373258	1874	35268000	27384	13541	2	0	\N
373259	1678	27360856600000	27385	13541	0	0	\N
373260	1874	35265000	27385	13541	1	0	\N
373261	1874	35268000	27385	13541	2	0	\N
373265	1678	27360856601000	27387	13542	0	0	\N
373266	1678	27360856602000	27387	13542	1	0	\N
373267	1874	35270000	27387	13542	2	0	\N
373268	1874	35272000	27387	13542	3	0	\N
373269	1874	35275000	27387	13542	4	0	\N
373270	1874	35278000	27387	13542	5	0	\N
373271	1678	27360856601000	27388	13542	0	0	\N
373272	1678	27360856602000	27388	13542	1	0	\N
373273	1874	35270000	27388	13542	2	0	\N
373274	1874	35272000	27388	13542	3	0	\N
373275	1874	35275000	27388	13542	4	0	\N
373276	1874	35278000	27388	13542	5	0	\N
373292	1678	27360856605000	27392	13544	0	0	\N
373293	1874	35291000	27392	13544	1	0	\N
373294	1874	35293000	27392	13544	2	0	\N
373316	1678	27360856613000	27397	13548	0	0	\N
373317	1874	35331000	27397	13548	1	0	\N
373318	1874	35333000	27397	13548	2	0	\N
373319	1678	27360856613000	27398	13548	0	0	\N
373320	1874	35331000	27398	13548	1	0	\N
373187	1678	27360856591000	27374	13536	3	0	1
373188	1678	27360856592000	27374	13536	4	0	1
373189	1874	35205000	27374	13536	5	0	2
373190	1874	35207000	27374	13536	6	0	2
373191	1874	35210000	27374	13536	7	0	2
373193	1874	35216000	27374	13536	9	0	2
373194	1874	35219000	27374	13536	10	0	2
373195	1874	35222000	27374	13536	11	0	2
373196	1874	35224000	27374	13536	12	0	2
373197	1874	35226000	27374	13536	13	0	2
373214	1678	27360856593000	27376	13537	0	0	1
373215	1678	27360856594000	27376	13537	1	0	1
373216	1874	35231000	27376	13537	2	0	2
373217	1874	35233000	27376	13537	3	0	2
373219	1874	35238000	27376	13537	5	0	2
373226	1678	27360856595000	27378	13538	0	0	1
373227	1874	35241000	27378	13538	1	0	2
373228	1874	35243000	27378	13538	2	0	2
373232	1678	27360856596000	27380	13539	0	0	1
373234	1874	35248000	27380	13539	2	0	2
373244	1678	27360856597000	27382	13540	0	0	1
373245	1678	27360856598000	27382	13540	1	0	1
373246	1678	27360856599000	27382	13540	2	0	1
373247	1874	35251000	27382	13540	3	0	2
373249	1874	35256000	27382	13540	5	0	2
373250	1874	35259000	27382	13540	6	0	2
373251	1874	35261000	27382	13540	7	0	2
373252	1874	35263000	27382	13540	8	0	2
373263	1874	35265000	27386	13541	1	0	2
373264	1874	35268000	27386	13541	2	0	2
373277	1678	27360856601000	27389	13542	0	0	1
373278	1678	27360856602000	27389	13542	1	0	1
373279	1874	35270000	27389	13542	2	0	2
373281	1874	35275000	27389	13542	4	0	2
373282	1874	35278000	27389	13542	5	0	2
373283	1678	27360856603000	27390	13543	0	0	1
373284	1678	27360856604000	27390	13543	1	0	1
373285	1874	35281000	27390	13543	2	0	2
373287	1874	35286000	27390	13543	4	0	2
373288	1874	35288000	27390	13543	5	0	2
373289	1678	27360856605000	27391	13544	0	0	1
373290	1874	35291000	27391	13544	1	0	2
373295	1678	27360856606000	27395	13546	0	0	1
373296	1678	27360856607000	27395	13546	1	0	1
373297	1678	27360856608000	27395	13546	2	0	1
373298	1678	27360856609000	27395	13546	3	0	1
373299	1678	27360856610000	27395	13546	4	0	1
373301	1874	35299000	27395	13546	6	0	2
373302	1874	35302000	27395	13546	7	0	2
373303	1874	35305000	27395	13546	8	0	2
373304	1874	35308000	27395	13546	9	0	2
373305	1874	35310000	27395	13546	10	0	2
373307	1874	35314000	27395	13546	12	0	2
373308	1874	35316000	27395	13546	13	0	2
373309	1874	35318000	27395	13546	14	0	2
373310	1678	27360856611000	27396	13547	0	0	1
373312	1874	35321000	27396	13547	2	0	2
373313	1874	35323000	27396	13547	3	0	2
373314	1874	35326000	27396	13547	4	0	2
373315	1874	35328000	27396	13547	5	0	2
373321	1874	35333000	27398	13548	2	0	\N
373328	1678	27360856615000	27401	13550	0	0	\N
373329	1874	35341000	27401	13550	1	0	\N
373330	1874	35343000	27401	13550	2	0	\N
373334	1678	27360856615000	27403	13550	0	0	\N
373335	1874	35341000	27403	13550	1	0	\N
373336	1874	35343000	27403	13550	2	0	\N
373340	1678	27360856616000	27405	13551	0	0	\N
373341	1874	35345000	27405	13551	1	0	\N
373342	1874	35348000	27405	13551	2	0	\N
373349	1678	27360856618000	27408	13553	0	0	\N
373350	1874	35356000	27408	13553	1	0	\N
373351	1874	35358000	27408	13553	2	0	\N
373355	1678	27360856619000	27410	13554	0	0	\N
373356	1874	35361000	27410	13554	1	0	\N
373357	1874	35363000	27410	13554	2	0	\N
373358	1678	27360856619000	27411	13554	0	0	\N
373359	1874	35361000	27411	13554	1	0	\N
373360	1874	35363000	27411	13554	2	0	\N
373364	1678	27360856620000	27413	13555	0	0	\N
373365	1874	35366000	27413	13555	1	0	\N
373366	1874	35368000	27413	13555	2	0	\N
373367	1678	27360856620000	27414	13555	0	0	\N
373368	1874	35366000	27414	13555	1	0	\N
373369	1874	35368000	27414	13555	2	0	\N
373370	1678	27360856621000	27415	13556	0	0	\N
373371	1874	35371000	27415	13556	1	0	\N
373372	1874	35373000	27415	13556	2	0	\N
373373	1678	27360856621000	27416	13556	0	0	\N
373374	1874	35371000	27416	13556	1	0	\N
373375	1874	35373000	27416	13556	2	0	\N
373376	1678	27360856621000	27417	13556	0	0	\N
373377	1874	35371000	27417	13556	1	0	\N
373378	1874	35373000	27417	13556	2	0	\N
373382	1678	27360856621000	27419	13556	0	0	\N
373383	1874	35371000	27419	13556	1	0	\N
373384	1874	35373000	27419	13556	2	0	\N
373394	1678	27360856622000	27421	13557	0	0	\N
373395	1678	27360856623000	27421	13557	1	0	\N
373396	1678	27360856624000	27421	13557	2	0	\N
373397	1874	35376000	27421	13557	3	0	\N
373398	1874	35378000	27421	13557	4	0	\N
373399	1874	35380000	27421	13557	5	0	\N
373400	1874	35383000	27421	13557	6	0	\N
373401	1874	35386000	27421	13557	7	0	\N
373402	1874	35388000	27421	13557	8	0	\N
373403	1678	27360856622000	27422	13557	0	0	\N
373404	1678	27360856623000	27422	13557	1	0	\N
373405	1678	27360856624000	27422	13557	2	0	\N
373406	1874	35376000	27422	13557	3	0	\N
373407	1874	35378000	27422	13557	4	0	\N
373408	1874	35380000	27422	13557	5	0	\N
373409	1874	35383000	27422	13557	6	0	\N
373410	1874	35386000	27422	13557	7	0	\N
373411	1874	35388000	27422	13557	8	0	\N
373412	1874	34858000	27423	13436	0	0	\N
373413	1874	34860000	27423	13436	1	0	\N
373414	1874	34862000	27423	13436	2	0	\N
373415	1874	34864000	27423	13436	3	0	\N
373416	1874	34866000	27423	13436	4	0	\N
373417	1874	34868000	27423	13436	5	0	\N
373418	1874	34870000	27423	13436	6	0	\N
373419	1874	34872000	27423	13436	7	0	\N
373420	1874	34874000	27423	13436	8	0	\N
373421	1874	34876000	27423	13436	9	0	\N
373422	1874	34878000	27423	13436	10	0	\N
373423	1874	34880000	27423	13436	11	0	\N
373424	1874	34882000	27423	13436	12	0	\N
373425	1874	34884000	27423	13436	13	0	\N
373426	1874	34886000	27423	13436	14	0	\N
373427	1874	34888000	27423	13436	15	0	\N
373428	1874	34890000	27423	13436	16	0	\N
373429	1874	34892000	27423	13436	17	0	\N
373430	1874	34894000	27423	13436	18	0	\N
373431	1874	34896000	27423	13436	19	0	\N
373432	1874	34898000	27423	13436	20	0	\N
373433	1874	34900000	27423	13436	21	0	\N
373434	1874	34902000	27423	13436	22	0	\N
373435	1874	34904000	27423	13436	23	0	\N
373436	1874	34906000	27423	13436	24	0	\N
373437	1874	34908000	27423	13436	25	0	\N
373438	1874	34910000	27423	13436	26	0	\N
373439	1874	34912000	27423	13436	27	0	\N
373440	1874	34914000	27423	13436	28	0	\N
373441	1874	34916000	27423	13436	30	0	\N
373442	1874	34918000	27423	13436	31	0	\N
373443	1874	34920000	27423	13436	32	0	\N
373444	1874	34922000	27423	13436	33	0	\N
373445	1874	34924000	27423	13436	34	0	\N
373446	1874	34926000	27423	13436	35	0	\N
373447	1874	34928000	27423	13436	36	0	\N
373448	1874	34930000	27423	13436	37	0	\N
373449	1874	34932000	27423	13436	38	0	\N
373450	1874	34934000	27423	13436	39	0	\N
373451	1874	34936000	27423	13436	40	0	\N
373452	1874	34938000	27423	13436	41	0	\N
373324	1874	35333000	27399	13548	2	0	2
373325	1678	27360856614000	27400	13549	0	0	1
373326	1874	35336000	27400	13549	1	0	2
373327	1874	35338000	27400	13549	2	0	2
373331	1678	27360856615000	27402	13550	0	0	1
373333	1874	35343000	27402	13550	2	0	2
373337	1678	27360856616000	27404	13551	0	0	1
373338	1874	35345000	27404	13551	1	0	2
373339	1874	35348000	27404	13551	2	0	2
373343	1678	27360856617000	27406	13552	0	0	1
373345	1874	35353000	27406	13552	2	0	2
373346	1678	27360856618000	27407	13553	0	0	1
373347	1874	35356000	27407	13553	1	0	2
373348	1874	35358000	27407	13553	2	0	2
373353	1874	35361000	27409	13554	1	0	2
373354	1874	35363000	27409	13554	2	0	2
373361	1678	27360856620000	27412	13555	0	0	1
373362	1874	35366000	27412	13555	1	0	2
373363	1874	35368000	27412	13555	2	0	2
373380	1874	35371000	27418	13556	1	0	2
373381	1874	35373000	27418	13556	2	0	2
373385	1678	27360856622000	27420	13557	0	0	1
373386	1678	27360856623000	27420	13557	1	0	1
373387	1678	27360856624000	27420	13557	2	0	1
373389	1874	35378000	27420	13557	4	0	2
373390	1874	35380000	27420	13557	5	0	2
373391	1874	35383000	27420	13557	6	0	2
373392	1874	35386000	27420	13557	7	0	2
373453	1678	27360856625000	27424	13558	0	0	1
373454	1678	27360856626000	27424	13558	1	0	1
373455	1678	27360856627000	27424	13558	2	0	1
373456	1874	35390000	27424	13558	3	0	2
373462	1678	27360856625000	27425	13558	0	0	\N
373463	1678	27360856626000	27425	13558	1	0	\N
373464	1678	27360856627000	27425	13558	2	0	\N
373465	1874	35390000	27425	13558	3	0	\N
373466	1874	35392000	27425	13558	4	0	\N
373467	1874	35394000	27425	13558	5	0	\N
373468	1874	35397000	27425	13558	6	0	\N
373469	1874	35400000	27425	13558	7	0	\N
373470	1874	35403000	27425	13558	8	0	\N
373474	1678	27360856628000	27427	13559	0	0	\N
373475	1874	35405000	27427	13559	1	0	\N
373476	1874	35408000	27427	13559	2	0	\N
373477	1678	27360856629000	27428	13560	0	0	\N
373478	1874	35411000	27428	13560	1	0	\N
373479	1874	35413000	27428	13560	2	0	\N
373480	1678	27360856629000	27429	13560	0	0	\N
373481	1874	35411000	27429	13560	1	0	\N
373482	1874	35413000	27429	13560	2	0	\N
373483	1678	27360856629000	27430	13560	0	0	\N
373484	1874	35411000	27430	13560	1	0	\N
373485	1874	35413000	27430	13560	2	0	\N
373495	1678	27360856631000	27434	13562	0	0	\N
373496	1874	35421000	27434	13562	1	0	\N
373497	1874	35423000	27434	13562	2	0	\N
373498	1678	27360856631000	27435	13562	0	0	\N
373499	1874	35421000	27435	13562	1	0	\N
373500	1874	35423000	27435	13562	2	0	\N
373501	1678	27360856631000	27436	13562	0	0	\N
373502	1874	35421000	27436	13562	1	0	\N
373503	1874	35423000	27436	13562	2	0	\N
373507	315	66000001000000	27438	13406	0	0	\N
373508	1678	27360856633000	27439	13564	0	0	\N
373509	1678	27360856634000	27439	13564	1	0	\N
373510	1874	35430000	27439	13564	2	0	\N
373511	1874	35432000	27439	13564	3	0	\N
373512	1874	35435000	27439	13564	4	0	\N
373513	1874	35438000	27439	13564	5	0	\N
373514	315	66000001000000	27439	13564	6	0	\N
373522	315	66000001000000	27441	13421	0	0	\N
373523	1678	27360856633000	27442	13564	0	0	\N
373524	1678	27360856634000	27442	13564	1	0	\N
373525	1874	35430000	27442	13564	2	0	\N
373526	1874	35432000	27442	13564	3	0	\N
373527	1874	35435000	27442	13564	4	0	\N
373528	1874	35438000	27442	13564	5	0	\N
373529	315	66000001000000	27442	13564	6	0	\N
373530	315	66000001000000	27443	13435	0	0	\N
373531	315	66000001000000	27444	13448	0	0	\N
373535	1678	27360856636000	27446	13566	0	0	\N
373536	1678	27360856637000	27446	13566	1	0	\N
373537	1874	35446000	27446	13566	2	0	\N
373538	1874	35448000	27446	13566	3	0	\N
373539	1874	35451000	27446	13566	4	0	\N
373540	1874	35453000	27446	13566	5	0	\N
373541	1678	27360856636000	27447	13566	0	0	\N
373542	1678	27360856637000	27447	13566	1	0	\N
373543	1874	35446000	27447	13566	2	0	\N
373544	1874	35448000	27447	13566	3	0	\N
373545	1874	35451000	27447	13566	4	0	\N
373546	1874	35453000	27447	13566	5	0	\N
373553	1678	27360856636000	27449	13566	0	0	\N
373554	1678	27360856637000	27449	13566	1	0	\N
373555	1874	35446000	27449	13566	2	0	\N
373556	1874	35448000	27449	13566	3	0	\N
373557	1874	35451000	27449	13566	4	0	\N
373558	1874	35453000	27449	13566	5	0	\N
373559	1678	27360856636000	27450	13566	0	0	\N
373560	1678	27360856637000	27450	13566	1	0	\N
373561	1874	35446000	27450	13566	2	0	\N
373562	1874	35448000	27450	13566	3	0	\N
373563	1874	35451000	27450	13566	4	0	\N
373564	1874	35453000	27450	13566	5	0	\N
373565	1678	27360856638000	27451	13567	0	0	\N
373566	1874	35456000	27451	13567	1	0	\N
373567	1874	35458000	27451	13567	2	0	\N
373577	1678	27360856640000	27455	13569	0	0	\N
373578	1874	35465000	27455	13569	1	0	\N
373579	1874	35468000	27455	13569	2	0	\N
373583	1678	27360856641000	27457	13570	0	0	\N
373584	1874	35470000	27457	13570	1	0	\N
373585	1874	35473000	27457	13570	2	0	\N
373459	1874	35397000	27424	13558	6	0	2
373460	1874	35400000	27424	13558	7	0	2
373461	1874	35403000	27424	13558	8	0	2
373471	1678	27360856628000	27426	13559	0	0	1
373472	1874	35405000	27426	13559	1	0	2
373486	1678	27360856629000	27431	13560	0	0	1
373487	1874	35411000	27431	13560	1	0	2
373488	1874	35413000	27431	13560	2	0	2
373489	1678	27360856630000	27432	13561	0	0	1
373490	1874	35415000	27432	13561	1	0	2
373492	1678	27360856631000	27433	13562	0	0	1
373493	1874	35421000	27433	13562	1	0	2
373494	1874	35423000	27433	13562	2	0	2
373504	1678	27360856632000	27437	13563	0	0	1
373506	1874	35428000	27437	13563	2	0	2
373515	1678	27360856633000	27440	13564	0	0	1
373516	1678	27360856634000	27440	13564	1	0	1
373517	1874	35430000	27440	13564	2	0	2
373518	1874	35432000	27440	13564	3	0	2
373520	1874	35438000	27440	13564	5	0	2
373521	315	66000001000000	27440	13564	6	0	0
373532	1678	27360856635000	27445	13565	0	0	1
373533	1874	35441000	27445	13565	2	0	2
373534	1874	35443000	27445	13565	3	0	2
373548	1678	27360856637000	27448	13566	1	0	1
373549	1874	35446000	27448	13566	2	0	2
373550	1874	35448000	27448	13566	3	0	2
373551	1874	35451000	27448	13566	4	0	2
373568	1678	27360856638000	27452	13567	0	0	1
373569	1874	35456000	27452	13567	1	0	2
373570	1874	35458000	27452	13567	2	0	2
373571	1678	27360856639000	27453	13568	0	0	1
373572	1874	35461000	27453	13568	1	0	2
373574	1678	27360856640000	27454	13569	0	0	1
373575	1874	35465000	27454	13569	1	0	2
373576	1874	35468000	27454	13569	2	0	2
373580	1678	27360856641000	27456	13570	0	0	1
373581	1874	35470000	27456	13570	1	0	2
373586	1678	27360856642000	27458	13571	0	0	1
373587	1678	27360856643000	27458	13571	1	0	1
373588	383	66846781394804	27458	13571	2	0	0
373589	327	66190546738816	27458	13571	3	0	1
373591	266	66233761394804	27458	13571	5	0	2
373592	352	66846781394804	27458	13571	6	0	0
373609	1678	27360856645000	27460	13573	0	0	\N
373610	1874	35491000	27460	13573	1	0	\N
373611	1874	35493000	27460	13573	2	0	\N
373612	452	66846781394804	27460	13573	3	0	\N
373613	275	66846781394804	27460	13573	4	0	\N
373614	402	66846781394804	27460	13573	5	0	\N
373615	2181	845033200907	27460	13573	6	0	\N
373616	458	66192943638921	27460	13573	7	0	\N
373617	690	66846781394804	27460	13573	8	0	\N
373627	1678	27360856645000	27462	13573	0	0	\N
373628	1874	35491000	27462	13573	1	0	\N
373629	1874	35493000	27462	13573	2	0	\N
373630	452	66846781394804	27462	13573	3	0	\N
373631	275	66846781394804	27462	13573	4	0	\N
373632	402	66846781394804	27462	13573	5	0	\N
373633	2181	845033200907	27462	13573	6	0	\N
373634	458	66192943638921	27462	13573	7	0	\N
373635	690	66846781394804	27462	13573	8	0	\N
373636	1874	35491000	27463	13573	0	0	\N
373637	452	66846781394804	27463	13573	1	0	\N
373638	275	66846781394804	27463	13573	2	0	\N
373639	402	66846781394804	27463	13573	3	0	\N
373640	2181	845033200907	27463	13573	4	0	\N
373641	458	66192943638921	27463	13573	5	0	\N
373642	1874	35491000	27464	13573	0	0	\N
373643	452	66846781394804	27464	13573	1	0	\N
373644	275	66846781394804	27464	13573	2	0	\N
373645	402	66846781394804	27464	13573	3	0	\N
373646	2181	845033200907	27464	13573	4	0	\N
373655	1678	27360856646000	27466	13574	0	0	\N
373656	391	66845671394804	27466	13574	1	0	\N
373657	1772	6067000384008	27466	13574	2	0	\N
373658	570	66846781394804	27466	13574	3	0	\N
373659	390	66846781394804	27466	13574	4	0	\N
373660	569	66846781394804	27466	13574	5	0	\N
373661	1874	35495000	27466	13574	6	0	\N
373662	1874	35498000	27466	13574	7	0	\N
373687	1678	27360856647000	27468	13575	0	0	\N
373688	1678	27360856648000	27468	13575	1	0	\N
373689	1678	27360856649000	27468	13575	2	0	\N
373690	894	310759461099813	27468	13575	3	0	\N
373691	342	66191649914597	27468	13575	4	0	\N
373692	1811	2317423500306	27468	13575	5	0	\N
373693	499	66846781394804	27468	13575	6	0	\N
373694	710	5064150105589	27468	13575	7	0	\N
373695	120	66191449337183	27468	13575	8	0	\N
373696	663	66846781394804	27468	13575	9	0	\N
373697	1030	912533541116414	27468	13575	10	0	\N
373698	238	66179713200746	27468	13575	11	0	\N
373699	1874	35501000	27468	13575	12	0	\N
373700	1874	35504000	27468	13575	13	0	\N
373701	1874	35507000	27468	13575	14	0	\N
373702	312	66190546738816	27468	13575	15	0	\N
373703	251	66846781394804	27468	13575	16	0	\N
373704	320	66564769550207	27468	13575	17	0	\N
373705	354	66192943638921	27468	13575	18	0	\N
373706	1276	1715715512165594	27468	13575	19	0	\N
373707	194	66846781394804	27468	13575	20	0	\N
373708	1874	35509000	27468	13575	21	0	\N
373709	1874	35511000	27468	13575	22	0	\N
373710	1874	35513000	27468	13575	23	0	\N
373719	1874	35526000	27471	13577	0	0	\N
373720	399	66846781394804	27471	13577	1	0	\N
373721	1874	35528000	27471	13577	2	0	\N
373722	721	2025660042156	27471	13577	3	0	\N
373723	105	66846781394804	27471	13577	4	0	\N
373724	146	66846781394804	27471	13577	5	0	\N
373725	611	66846781394804	27471	13577	6	0	\N
373726	1874	35526000	27472	13577	0	0	\N
373727	399	66846781394804	27472	13577	1	0	\N
373728	1874	35528000	27472	13577	2	0	\N
373595	421	66846781394804	27458	13571	9	0	0
373596	1874	35475000	27458	13571	10	0	2
373597	1874	35477000	27458	13571	11	0	2
373598	1874	35480000	27458	13571	12	0	2
373599	1874	35483000	27458	13571	13	0	2
373601	534	66846781394804	27459	13572	1	0	0
373602	680	66846781394804	27459	13572	2	0	0
373603	1874	35486000	27459	13572	3	0	2
373604	1874	35488000	27459	13572	4	0	2
373605	82	66846781394804	27459	13572	5	0	0
373607	361	66196779394804	27459	13572	7	0	2
373608	731	2025660042156	27459	13572	8	0	0
373618	1678	27360856645000	27461	13573	0	0	1
373619	1874	35491000	27461	13573	1	0	2
373621	452	66846781394804	27461	13573	3	0	0
373622	275	66846781394804	27461	13573	4	0	0
373623	402	66846781394804	27461	13573	5	0	0
373624	2181	845033200907	27461	13573	6	0	1
373625	458	66192943638921	27461	13573	7	0	1
373647	1678	27360856646000	27465	13574	0	0	1
373648	391	66845671394804	27465	13574	1	0	1
373649	1772	6067000384008	27465	13574	2	0	1
373650	570	66846781394804	27465	13574	3	0	0
373651	390	66846781394804	27465	13574	4	0	0
373653	1874	35495000	27465	13574	6	0	2
373654	1874	35498000	27465	13574	7	0	2
373663	1678	27360856647000	27467	13575	0	0	1
373664	1678	27360856648000	27467	13575	1	0	1
373666	894	310759461099813	27467	13575	3	0	0
373667	342	66191649914597	27467	13575	4	0	1
373668	1811	2317423500306	27467	13575	5	0	1
373669	499	66846781394804	27467	13575	6	0	0
373670	710	5064150105589	27467	13575	7	0	0
373672	663	66846781394804	27467	13575	9	0	0
373673	1030	912533541116414	27467	13575	10	0	0
373674	238	66179713200746	27467	13575	11	0	6
373675	1874	35501000	27467	13575	12	0	2
373676	1874	35504000	27467	13575	13	0	2
373678	312	66190546738816	27467	13575	15	0	1
373679	251	66846781394804	27467	13575	16	0	0
373680	320	66564769550207	27467	13575	17	0	2
373681	354	66192943638921	27467	13575	18	0	1
373683	194	66846781394804	27467	13575	20	0	0
373684	1874	35509000	27467	13575	21	0	2
373685	1874	35511000	27467	13575	22	0	2
373686	1874	35513000	27467	13575	23	0	2
373711	1678	27360856650000	27469	13576	0	0	1
373713	1874	35515000	27469	13576	2	0	2
373714	206	66846781394804	27469	13576	3	0	0
373715	636	66190546738816	27469	13576	4	0	1
373716	1874	35518000	27469	13576	5	0	2
373717	1874	35521000	27469	13576	6	0	2
373729	721	2025660042156	27472	13577	3	0	\N
373730	105	66846781394804	27472	13577	4	0	\N
373731	146	66846781394804	27472	13577	5	0	\N
373732	611	66846781394804	27472	13577	6	0	\N
373766	1678	27360856652000	27478	13579	0	0	\N
373767	1678	27360856653000	27478	13579	1	0	\N
373768	1678	27360856654000	27478	13579	2	0	\N
373769	1874	35530000	27478	13579	3	0	\N
373770	1874	35532000	27478	13579	4	0	\N
373771	1874	35534000	27478	13579	5	0	\N
373772	500	66846781394804	27478	13579	6	0	\N
373773	1874	35537000	27478	13579	7	0	\N
373774	587	66846781394804	27478	13579	8	0	\N
373775	138	66846781394804	27478	13579	9	0	\N
373776	114	66070347649394	27478	13579	10	0	\N
373777	443	66190935859010	27478	13579	11	0	\N
373778	649	66190636998665	27478	13579	12	0	\N
373779	578	66190636998665	27478	13579	13	0	\N
373780	205	66846781394804	27478	13579	14	0	\N
373781	504	66233711394804	27478	13579	15	0	\N
373782	339	66846781394804	27478	13579	16	0	\N
373783	301	66071019153477	27478	13579	17	0	\N
373784	408	66846781394804	27478	13579	18	0	\N
373785	601	66846781394804	27478	13579	19	0	\N
373786	1821	845652594543	27478	13579	20	0	\N
373787	450	66846781394804	27478	13579	21	0	\N
373788	10	32591980141866	27478	13579	22	0	\N
373789	322	66846781394804	27478	13579	23	0	\N
373790	1874	35540000	27478	13579	24	0	\N
373791	1874	35543000	27478	13579	25	0	\N
373800	1678	27360856656000	27480	13581	0	0	\N
373801	1678	27360856657000	27480	13581	1	0	\N
373802	180	66846781394804	27480	13581	2	0	\N
373803	2358	50100000000	27480	13581	3	0	\N
373804	1874	35549000	27480	13581	4	0	\N
373805	165	66190636998665	27480	13581	5	0	\N
373806	237	66190636998665	27480	13581	6	0	\N
373807	2164	845442200907	27480	13581	7	0	\N
373808	1874	35552000	27480	13581	8	0	\N
373809	1874	35554000	27480	13581	9	0	\N
373810	1874	35556000	27480	13581	10	0	\N
373811	691	66846781394804	27480	13581	11	0	\N
373812	600	66846781394804	27480	13581	12	0	\N
373813	245	66846781394804	27480	13581	13	0	\N
373814	620	66846781394804	27480	13581	14	0	\N
373815	594	66846781394804	27480	13581	15	0	\N
373816	201	66846781394804	27480	13581	16	0	\N
373817	163	66846781394804	27480	13581	17	0	\N
373735	1874	35528000	27473	13577	2	0	2
373736	721	2025660042156	27473	13577	3	0	0
373737	105	66846781394804	27473	13577	4	0	0
373738	146	66846781394804	27473	13577	5	0	0
373739	611	66846781394804	27473	13577	6	0	0
373741	1678	27360856653000	27477	13579	1	0	1
373742	1678	27360856654000	27477	13579	2	0	1
373743	1874	35530000	27477	13579	3	0	2
373744	1874	35532000	27477	13579	4	0	2
373745	1874	35534000	27477	13579	5	0	2
373747	1874	35537000	27477	13579	7	0	2
373748	587	66846781394804	27477	13579	8	0	0
373749	138	66846781394804	27477	13579	9	0	0
373750	114	66070347649394	27477	13579	10	0	12
373752	649	66190636998665	27477	13579	12	0	1
373753	578	66190636998665	27477	13579	13	0	1
373754	205	66846781394804	27477	13579	14	0	0
373755	504	66233711394804	27477	13579	15	0	3
373756	339	66846781394804	27477	13579	16	0	0
373758	408	66846781394804	27477	13579	18	0	0
373759	601	66846781394804	27477	13579	19	0	0
373760	1821	845652594543	27477	13579	20	0	2
373761	450	66846781394804	27477	13579	21	0	0
373762	10	32591980141866	27477	13579	22	0	2
373764	1874	35540000	27477	13579	24	0	2
373765	1874	35543000	27477	13579	25	0	2
373792	1678	27360856655000	27479	13580	0	0	1
373793	366	66190546738816	27479	13580	1	0	1
373795	283	66070028153477	27479	13580	3	0	2
373796	308	66846781394804	27479	13580	4	0	0
373797	392	66846781394804	27479	13580	5	0	0
373798	186	66846781394804	27479	13580	6	0	0
373799	1874	35546000	27479	13580	7	0	2
373819	1678	27360856657000	27481	13581	1	0	1
373820	180	66846781394804	27481	13581	2	0	0
373821	2358	50100000000	27481	13581	3	0	0
373822	1874	35549000	27481	13581	4	0	2
373823	165	66190636998665	27481	13581	5	0	1
373825	2164	845442200907	27481	13581	7	0	1
373826	1874	35552000	27481	13581	8	0	2
373827	1874	35554000	27481	13581	9	0	2
373828	1874	35556000	27481	13581	10	0	2
373830	600	66846781394804	27481	13581	12	0	0
373831	245	66846781394804	27481	13581	13	0	0
373832	620	66846781394804	27481	13581	14	0	0
373833	594	66846781394804	27481	13581	15	0	0
373834	201	66846781394804	27481	13581	16	0	0
373836	1678	27360856658000	27482	13582	0	0	1
373837	1874	35559000	27482	13582	1	0	2
373838	1874	35561000	27482	13582	2	0	2
373839	1962	845693570031	27482	13582	3	0	1
373840	748	2728071043671	27482	13582	4	0	1
373842	99	66846781394804	27482	13582	6	0	0
373843	1778	5455864491703	27482	13582	7	0	1
373844	108	66846781394804	27482	13582	8	0	0
373845	1678	27360856659000	27483	13583	0	0	1
373847	1874	35563000	27483	13583	2	0	2
373848	377	66846781394804	27483	13583	3	0	0
373849	225	66846781394804	27483	13583	4	0	0
373850	1874	35566000	27483	13583	5	0	2
373851	1678	27360856660000	27484	13584	0	0	1
373853	1678	27360856662000	27484	13584	2	0	1
373854	1874	35569000	27484	13584	3	0	2
373855	560	66846781394804	27484	13584	4	0	0
373856	893	310759461099813	27484	13584	5	0	0
373857	103	66846781394804	27484	13584	6	0	0
373859	1874	35575000	27484	13584	8	0	2
373860	1874	35577000	27484	13584	9	0	2
373861	1874	35579000	27484	13584	10	0	2
373862	1874	35581000	27484	13584	11	0	2
373864	217	66846781394804	27484	13584	13	0	0
373910	1678	27360856664000	27487	13586	0	0	\N
373911	1678	27360856665000	27487	13586	1	0	\N
373912	1678	27360856666000	27487	13586	2	0	\N
373913	1874	35588000	27487	13586	3	0	\N
373914	1874	35590000	27487	13586	4	0	\N
373915	1874	35592000	27487	13586	5	0	\N
373916	395	66343731646980	27487	13586	6	0	\N
373917	593	66845780394804	27487	13586	7	0	\N
373918	1961	845693570031	27487	13586	8	0	\N
373919	154	66190636998665	27487	13586	9	0	\N
373920	658	66846781394804	27487	13586	10	0	\N
373921	660	66846781394804	27487	13586	11	0	\N
373922	745	2025660042156	27487	13586	12	0	\N
373923	1874	35595000	27487	13586	13	0	\N
373924	1874	35598000	27487	13586	15	0	\N
373925	1874	35601000	27487	13586	16	0	\N
373926	91	66846781394804	27487	13586	17	0	\N
373927	438	66846781394804	27487	13586	18	0	\N
373928	373	66846781394804	27487	13586	19	0	\N
373929	453	66846781394804	27487	13586	20	0	\N
373930	92	66846781394804	27487	13586	21	0	\N
373931	150	66846781394804	27487	13586	22	0	\N
373932	63	66846781394804	27487	13586	23	0	\N
373933	562	66190636998665	27487	13586	24	0	\N
373934	711	3011058115466	27487	13586	25	0	\N
373935	551	66846781394804	27487	13586	26	0	\N
373936	379	66190636998665	27487	13586	27	0	\N
373937	1678	27360856664000	27488	13586	0	0	\N
373938	1678	27360856665000	27488	13586	1	0	\N
373939	1678	27360856666000	27488	13586	2	0	\N
373940	1874	35588000	27488	13586	3	0	\N
373941	1874	35590000	27488	13586	4	0	\N
373942	1874	35592000	27488	13586	5	0	\N
373943	395	66343731646980	27488	13586	6	0	\N
373944	593	66845780394804	27488	13586	7	0	\N
373945	1961	845693570031	27488	13586	8	0	\N
373946	154	66190636998665	27488	13586	9	0	\N
373947	658	66846781394804	27488	13586	10	0	\N
373948	660	66846781394804	27488	13586	11	0	\N
373949	745	2025660042156	27488	13586	12	0	\N
373950	1874	35595000	27488	13586	13	0	\N
373951	1874	35598000	27488	13586	15	0	\N
373952	1874	35601000	27488	13586	16	0	\N
373953	91	66846781394804	27488	13586	17	0	\N
373954	438	66846781394804	27488	13586	18	0	\N
373955	373	66846781394804	27488	13586	19	0	\N
373956	453	66846781394804	27488	13586	20	0	\N
373957	92	66846781394804	27488	13586	21	0	\N
373958	150	66846781394804	27488	13586	22	0	\N
373959	63	66846781394804	27488	13586	23	0	\N
373960	562	66190636998665	27488	13586	24	0	\N
373961	711	3011058115466	27488	13586	25	0	\N
373962	551	66846781394804	27488	13586	26	0	\N
373963	379	66190636998665	27488	13586	27	0	\N
373964	1678	27360856664000	27489	13586	0	0	\N
373965	1678	27360856665000	27489	13586	1	0	\N
373966	1678	27360856666000	27489	13586	2	0	\N
373967	1874	35588000	27489	13586	3	0	\N
373968	1874	35590000	27489	13586	4	0	\N
373969	1874	35592000	27489	13586	5	0	\N
373970	395	66343731646980	27489	13586	6	0	\N
373971	593	66845780394804	27489	13586	7	0	\N
373972	1961	845693570031	27489	13586	8	0	\N
373973	154	66190636998665	27489	13586	9	0	\N
373974	658	66846781394804	27489	13586	10	0	\N
373975	660	66846781394804	27489	13586	11	0	\N
373976	745	2025660042156	27489	13586	12	0	\N
373977	1874	35595000	27489	13586	13	0	\N
373978	1874	35598000	27489	13586	15	0	\N
373979	1874	35601000	27489	13586	16	0	\N
373980	91	66846781394804	27489	13586	17	0	\N
373981	438	66846781394804	27489	13586	18	0	\N
373982	373	66846781394804	27489	13586	19	0	\N
373983	453	66846781394804	27489	13586	20	0	\N
373984	92	66846781394804	27489	13586	21	0	\N
373985	150	66846781394804	27489	13586	22	0	\N
373986	63	66846781394804	27489	13586	23	0	\N
373987	562	66190636998665	27489	13586	24	0	\N
373988	711	3011058115466	27489	13586	25	0	\N
373989	551	66846781394804	27489	13586	26	0	\N
373990	379	66190636998665	27489	13586	27	0	\N
373867	603	66913638346463	27484	13584	16	0	1
373868	35	19446336405681	27484	13584	17	0	0
373869	49	66846781394804	27484	13584	18	0	0
373870	240	66191649914597	27484	13584	19	0	1
373871	262	66190613024638	27484	13584	20	0	4
373873	304	66846781394804	27484	13584	22	0	0
373874	653	66846781394804	27484	13584	23	0	0
373875	1678	27360856663000	27485	13585	0	0	1
373876	2308	187798189530	27485	13585	1	0	1
373877	122	66846781394804	27485	13585	2	0	0
373879	1874	35583000	27485	13585	4	0	2
373880	29	7089810147845	27485	13585	5	0	0
373881	78	66846781394804	27485	13585	6	0	0
373882	1874	35586000	27485	13585	7	0	2
373884	1678	27360856665000	27486	13586	1	0	1
373885	1678	27360856666000	27486	13586	2	0	1
373886	1874	35588000	27486	13586	3	0	2
373887	1874	35590000	27486	13586	4	0	2
373888	1874	35592000	27486	13586	5	0	2
373890	593	66845780394804	27486	13586	7	0	1
373891	1961	845693570031	27486	13586	8	0	1
373892	154	66190636998665	27486	13586	9	0	1
373893	658	66846781394804	27486	13586	10	0	0
373894	660	66846781394804	27486	13586	11	0	0
373896	1874	35595000	27486	13586	13	0	2
373897	1874	35598000	27486	13586	15	0	2
373898	1874	35601000	27486	13586	16	0	2
373899	91	66846781394804	27486	13586	17	0	0
373901	373	66846781394804	27486	13586	19	0	0
373902	453	66846781394804	27486	13586	20	0	0
373903	92	66846781394804	27486	13586	21	0	0
373904	150	66846781394804	27486	13586	22	0	0
373905	63	66846781394804	27486	13586	23	0	0
373907	711	3011058115466	27486	13586	25	0	1
373908	551	66846781394804	27486	13586	26	0	0
373909	379	66190636998665	27486	13586	27	0	1
373991	1678	27360856667000	27490	13587	0	0	1
373992	1678	27360856668000	27490	13587	1	0	1
373994	84	66846781394804	27490	13587	3	0	0
373995	1150	615704563706554	27490	13587	4	0	0
373996	678	66846781394804	27490	13587	5	0	0
373997	1874	35607000	27490	13587	6	0	2
373999	1874	35609000	27490	13587	8	0	2
374000	1874	35611000	27490	13587	9	0	2
374008	1778	5524464345059	27493	13589	0	0	\N
374009	1678	27360856670000	27493	13589	1	0	\N
374010	1874	35619000	27493	13589	2	0	\N
374011	1874	35621000	27493	13589	3	0	\N
374021	1678	27360856674000	27496	13592	0	0	\N
374022	1874	35638000	27496	13592	1	0	\N
374023	1874	35641000	27496	13592	2	0	\N
374027	1678	27360856675000	27498	13593	0	0	\N
374028	2346	389000000	27498	13593	1	0	\N
374029	1874	35643000	27498	13593	2	0	\N
374030	1874	35646000	27498	13593	3	0	\N
374038	1678	27360856676000	27501	13594	0	0	\N
374039	1874	35648000	27501	13594	1	0	\N
374040	1874	35651000	27501	13594	2	0	\N
374041	1678	27360856676000	27502	13594	0	0	\N
374042	1874	35648000	27502	13594	1	0	\N
374043	1874	35651000	27502	13594	2	0	\N
374077	1678	27360856683000	27508	13599	0	0	\N
374078	1678	27360856684000	27508	13599	1	0	\N
374079	1678	27360856685000	27508	13599	2	0	\N
374080	1678	27360856686000	27508	13599	3	0	\N
374081	1678	27360856687000	27508	13599	4	0	\N
374082	1874	35684000	27508	13599	5	0	\N
374083	1874	35686000	27508	13599	6	0	\N
374084	1874	35688000	27508	13599	7	0	\N
374085	1874	35691000	27508	13599	8	0	\N
374086	1874	35694000	27508	13599	9	0	\N
374087	1874	35697000	27508	13599	10	0	\N
374088	1874	35700000	27508	13599	11	0	\N
374089	1874	35702000	27508	13599	12	0	\N
374090	1874	35704000	27508	13599	13	0	\N
374091	1874	35706000	27508	13599	14	0	\N
374101	1678	27360856691000	27510	13601	0	0	\N
374102	1874	35723000	27510	13601	1	0	\N
374103	1874	35726000	27510	13601	2	0	\N
374107	1678	27360856691000	27512	13601	0	0	\N
374108	1874	35724000	27512	13601	1	0	\N
374109	1678	27360856692000	27513	13602	0	0	\N
374110	1874	35729000	27513	13602	2	0	\N
374111	1678	27360856692000	27514	13602	0	0	\N
374112	1874	35729000	27514	13602	2	0	\N
374113	1874	35731000	27514	13602	3	0	\N
374117	1678	27360856692000	27516	13602	0	0	\N
374118	1874	35729000	27516	13602	2	0	\N
374119	1874	35731000	27516	13602	3	0	\N
374120	1678	27360856693000	27517	13603	0	0	\N
374121	1874	35733000	27517	13603	1	0	\N
374122	1874	35736000	27517	13603	2	0	\N
374003	1874	35616000	27491	13588	2	0	2
374004	1778	5524464345059	27492	13589	0	0	1
374005	1678	27360856670000	27492	13589	1	0	1
374006	1874	35619000	27492	13589	2	0	2
374007	1874	35621000	27492	13589	3	0	2
374013	1678	27360856672000	27494	13590	1	0	1
374014	1874	35623000	27494	13590	2	0	2
374015	1874	35625000	27494	13590	3	0	2
374016	1874	35628000	27494	13590	4	0	2
374017	1874	35631000	27494	13590	5	0	2
374019	1874	35634000	27495	13591	1	0	2
374020	1874	35636000	27495	13591	2	0	2
374024	1678	27360856674000	27497	13592	0	0	1
374025	1874	35638000	27497	13592	1	0	2
374031	1678	27360856675000	27499	13593	0	0	1
374032	2346	389000000	27499	13593	1	0	0
374033	1874	35643000	27499	13593	2	0	2
374034	1874	35646000	27499	13593	3	0	2
374035	1678	27360856676000	27500	13594	0	0	1
374037	1874	35651000	27500	13594	2	0	2
374044	1678	27360856677000	27503	13595	0	0	1
374045	1678	27360856678000	27503	13595	1	0	1
374046	1874	35654000	27503	13595	2	0	2
374047	1874	35657000	27503	13595	3	0	2
374049	1874	35661000	27503	13595	5	0	2
374050	1678	27360856679000	27504	13596	0	0	1
374051	1874	35664000	27504	13596	1	0	2
374052	1874	35666000	27504	13596	2	0	2
374054	1678	27360856681000	27505	13597	1	0	1
374055	1874	35669000	27505	13597	2	0	2
374056	1874	35671000	27505	13597	3	0	2
374057	1874	35674000	27505	13597	4	0	2
374058	1874	35676000	27505	13597	5	0	2
374060	1874	35678000	27506	13598	1	0	2
374061	1874	35681000	27506	13598	2	0	2
374062	1678	27360856683000	27507	13599	0	0	1
374063	1678	27360856684000	27507	13599	1	0	1
374064	1678	27360856685000	27507	13599	2	0	1
374066	1678	27360856687000	27507	13599	4	0	1
374067	1874	35684000	27507	13599	5	0	2
374068	1874	35686000	27507	13599	6	0	2
374069	1874	35688000	27507	13599	7	0	2
374071	1874	35694000	27507	13599	9	0	2
374072	1874	35697000	27507	13599	10	0	2
374073	1874	35700000	27507	13599	11	0	2
374074	1874	35702000	27507	13599	12	0	2
374075	1874	35704000	27507	13599	13	0	2
374092	1678	27360856688000	27509	13600	0	0	1
374093	1678	27360856689000	27509	13600	1	0	1
374094	1678	27360856690000	27509	13600	2	0	1
374095	1874	35709000	27509	13600	3	0	2
374096	1874	35712000	27509	13600	4	0	2
374098	1874	35717000	27509	13600	6	0	2
374099	1874	35719000	27509	13600	7	0	2
374100	1874	35721000	27509	13600	8	0	2
374104	1678	27360856691000	27511	13601	0	0	1
374106	1874	35726000	27511	13601	2	0	2
374114	1678	27360856692000	27515	13602	0	0	1
374115	1874	35729000	27515	13602	2	0	2
374116	1874	35731000	27515	13602	3	0	2
374123	1678	27360856693000	27518	13603	0	0	1
374125	1693	2045773623117	27519	13604	0	0	1381
374126	1678	27360856694000	27519	13604	1	0	1
374127	1874	35734000	27519	13604	2	0	2
374128	1874	35736000	27519	13604	3	0	2
374129	1874	35739000	27519	13604	4	0	2
374131	1678	27360856695000	27520	13605	0	0	1
374132	1678	27360856696000	27520	13605	1	0	1
374133	1678	27360856697000	27520	13605	2	0	1
374134	1874	35743000	27520	13605	3	0	2
374136	1874	35748000	27520	13605	5	0	2
374159	1678	27360856702000	27524	13609	0	0	\N
374160	1874	35782000	27524	13609	1	0	\N
374161	1874	35785000	27524	13609	2	0	\N
374165	1678	27360856702000	27526	13609	0	0	\N
374166	1874	35782000	27526	13609	1	0	\N
374167	1874	35785000	27526	13609	2	0	\N
374168	1678	27360856702000	27527	13609	0	0	\N
374169	1874	35782000	27527	13609	1	0	\N
374170	1693	17111099570272	27528	13533	0	0	\N
374171	1874	35189000	27528	13533	1	0	\N
374172	1874	35190000	27528	13533	2	0	\N
374173	2346	388000000	27528	13533	3	0	\N
374174	383	66846781394804	27528	13533	4	0	\N
374175	1874	35191000	27528	13533	5	0	\N
374176	2358	50100000000	27528	13533	6	0	\N
374177	327	66190546738816	27528	13533	7	0	\N
374178	2381	100000000	27528	13533	8	0	\N
374179	652	66846781394804	27528	13533	9	0	\N
374180	2382	100000000	27528	13533	10	0	\N
374181	2381	1200000000	27528	13533	11	0	\N
374182	2383	100000000	27528	13533	12	0	\N
374183	266	66233761394804	27528	13533	13	0	\N
374184	352	66846781394804	27528	13533	14	0	\N
374185	191	66846781394804	27528	13533	15	0	\N
374186	520	66846781394804	27528	13533	16	0	\N
374187	421	66846781394804	27528	13533	17	0	\N
374188	534	66846781394804	27528	13533	18	0	\N
374189	680	66846781394804	27528	13533	19	0	\N
374190	82	66846781394804	27528	13533	20	0	\N
374191	309	66846781394804	27528	13533	21	0	\N
374192	361	66196779394804	27528	13533	22	0	\N
374193	731	2025660042156	27528	13533	23	0	\N
374194	452	66846781394804	27528	13533	24	0	\N
374195	275	66846781394804	27528	13533	25	0	\N
374196	402	66846781394804	27528	13533	26	0	\N
374197	2181	845033200907	27528	13533	27	0	\N
374198	458	66192943638921	27528	13533	28	0	\N
374199	690	66846781394804	27528	13533	29	0	\N
374200	391	66845671394804	27528	13533	30	0	\N
374201	1772	6067000384008	27528	13533	31	0	\N
374202	570	66846781394804	27528	13533	32	0	\N
374203	390	66846781394804	27528	13533	33	0	\N
374204	569	66846781394804	27528	13533	34	0	\N
374205	894	310759461099813	27528	13533	35	0	\N
374206	342	66191649914597	27528	13533	36	0	\N
374207	1811	2317423500306	27528	13533	37	0	\N
374208	499	66846781394804	27528	13533	38	0	\N
374209	710	5064150105589	27528	13533	39	0	\N
374210	120	66191449337183	27528	13533	40	0	\N
374211	663	66846781394804	27528	13533	41	0	\N
374212	1030	912533541116414	27528	13533	42	0	\N
374213	238	66179713200746	27528	13533	43	0	\N
374214	312	66190546738816	27528	13533	44	0	\N
374215	251	66846781394804	27528	13533	45	0	\N
374216	320	66564769550207	27528	13533	46	0	\N
374217	354	66192943638921	27528	13533	47	0	\N
374218	1276	1715715512165594	27528	13533	48	0	\N
374219	1874	35192000	27528	13533	49	0	\N
374220	194	66846781394804	27528	13533	50	0	\N
374221	206	66846781394804	27528	13533	51	0	\N
374222	636	66190546738816	27528	13533	52	0	\N
374223	399	66846781394804	27528	13533	53	0	\N
374224	721	2025660042156	27528	13533	54	0	\N
374225	105	66846781394804	27528	13533	55	0	\N
374226	146	66846781394804	27528	13533	56	0	\N
374227	611	66846781394804	27528	13533	57	0	\N
374228	500	66846781394804	27528	13533	58	0	\N
374229	315	66000001000000	27528	13533	59	0	\N
374230	587	66846781394804	27528	13533	60	0	\N
374231	138	66846781394804	27528	13533	61	0	\N
374232	114	66070347649394	27528	13533	62	0	\N
374233	443	66190935859010	27528	13533	63	0	\N
374234	649	66190636998665	27528	13533	64	0	\N
374235	578	66190636998665	27528	13533	65	0	\N
374236	205	66846781394804	27528	13533	66	0	\N
374237	504	66233711394804	27528	13533	67	0	\N
374238	339	66846781394804	27528	13533	68	0	\N
374239	301	66071019153477	27528	13533	69	0	\N
374240	408	66846781394804	27528	13533	70	0	\N
374241	601	66846781394804	27528	13533	71	0	\N
374242	1821	845652594543	27528	13533	72	0	\N
374243	450	66846781394804	27528	13533	73	0	\N
374244	10	32591980141866	27528	13533	74	0	\N
374245	322	66846781394804	27528	13533	75	0	\N
374246	366	66190546738816	27528	13533	76	0	\N
374247	2017	845380729203	27528	13533	77	0	\N
374248	283	66070028153477	27528	13533	78	0	\N
374249	308	66846781394804	27528	13533	79	0	\N
374250	392	66846781394804	27528	13533	80	0	\N
374251	186	66846781394804	27528	13533	81	0	\N
374252	180	66846781394804	27528	13533	82	0	\N
374253	165	66190636998665	27528	13533	83	0	\N
374254	237	66190636998665	27528	13533	84	0	\N
374255	2164	845442200907	27528	13533	85	0	\N
374256	691	66846781394804	27528	13533	86	0	\N
374257	600	66846781394804	27528	13533	88	0	\N
374258	1678	27360856703000	27529	13610	0	0	\N
374259	1678	27360856704000	27529	13610	1	0	\N
374260	1874	35788000	27529	13610	2	0	\N
374261	1874	35790000	27529	13610	3	0	\N
374262	1874	35792000	27529	13610	4	0	\N
374263	1874	35795000	27529	13610	5	0	\N
374139	1874	35753000	27520	13605	8	0	2
374140	1874	35755000	27520	13605	9	0	2
374141	2382	100000000	27520	13605	10	0	0
374142	2381	1200000000	27520	13605	11	0	0
374143	2383	100000000	27520	13605	12	0	0
374145	1678	27360856698000	27521	13606	0	0	1
374146	1874	35759000	27521	13606	1	0	2
374147	1874	35762000	27521	13606	2	0	2
374148	1874	35764000	27521	13606	3	0	2
374149	1678	27360856699000	27522	13607	0	0	1
374151	1874	35769000	27522	13607	2	0	2
374152	1678	27360856700000	27523	13608	0	0	1
374153	1678	27360856701000	27523	13608	1	0	1
374154	1874	35772000	27523	13608	2	0	2
374156	1874	35776000	27523	13608	4	0	2
374157	1874	35779000	27523	13608	5	0	2
374158	1874	35780000	27523	13608	6	0	2
374162	1678	27360856702000	27525	13609	0	0	1
374163	1874	35782000	27525	13609	1	0	2
374264	1678	27360856703000	27530	13610	0	0	1
374265	1678	27360856704000	27530	13610	1	0	1
374266	1874	35788000	27530	13610	2	0	2
374267	1874	35790000	27530	13610	3	0	2
374268	1874	35792000	27530	13610	4	0	2
374270	1678	27360856705000	27531	13611	0	0	1
374271	1874	35797000	27531	13611	1	0	2
374272	1678	27360856706000	27532	13612	0	0	1
374275	1678	27360856706000	27533	13612	0	0	\N
374276	1874	35799000	27533	13612	1	0	\N
374277	1874	35802000	27533	13612	2	0	\N
374278	1678	27360856505000	27534	13412	0	0	\N
374279	1678	27360856506000	27534	13412	1	0	\N
374280	1678	27360856507000	27534	13412	2	0	\N
374281	1678	27360856508000	27534	13412	3	0	\N
374282	1693	12790979570272	27534	13412	4	0	\N
374283	1678	27360856509000	27534	13412	5	0	\N
374284	1678	27360856510000	27534	13412	6	0	\N
374285	1678	27360856511000	27534	13412	7	0	\N
374286	1678	27360856512000	27534	13412	8	0	\N
374287	1678	27360856513000	27534	13412	9	0	\N
374288	1678	27360856514000	27534	13412	10	0	\N
374289	1678	27360856515000	27534	13412	11	0	\N
374290	1678	27360856516000	27534	13412	12	0	\N
374291	1678	27360856517000	27534	13412	13	0	\N
374292	1678	27360856518000	27534	13412	14	0	\N
374293	1678	27360856519000	27534	13412	15	0	\N
374294	1678	27360856520000	27534	13412	16	0	\N
374295	1678	27360856521000	27534	13412	17	0	\N
374296	1678	27360856522000	27534	13412	18	0	\N
374297	1678	27360856523000	27534	13412	19	0	\N
374298	1678	27360856524000	27534	13412	20	0	\N
374299	1678	27360856525000	27534	13412	21	0	\N
374300	1678	27360856526000	27534	13412	22	0	\N
374301	1678	27360856527000	27534	13412	23	0	\N
374302	1678	27360856528000	27534	13412	24	0	\N
374303	1678	27360856529000	27534	13412	25	0	\N
374304	1678	27360856530000	27534	13412	26	0	\N
374305	1678	27360856531000	27534	13412	27	0	\N
374306	1678	27360856532000	27534	13412	28	0	\N
374307	1678	27360856533000	27534	13412	29	0	\N
374308	1678	27360856534000	27534	13412	30	0	\N
374309	1678	27360856535000	27534	13412	31	0	\N
374310	1678	27360856536000	27534	13412	32	0	\N
374311	1678	27360856537000	27534	13412	33	0	\N
374312	1678	27360856538000	27534	13412	34	0	\N
374313	1678	27360856539000	27534	13412	35	0	\N
374314	1678	27360856540000	27534	13412	36	0	\N
374315	1678	27360856541000	27534	13412	37	0	\N
374316	1678	27360856542000	27534	13412	38	0	\N
374317	1678	27360856543000	27534	13412	39	0	\N
374318	1678	27360856544000	27534	13412	40	0	\N
374319	1678	27360856545000	27534	13412	41	0	\N
374320	1678	27360856546000	27534	13412	42	0	\N
374321	1678	27360856547000	27534	13412	43	0	\N
374322	1678	27360856548000	27534	13412	44	0	\N
374323	1678	27360856549000	27534	13412	45	0	\N
374324	1678	27360856550000	27534	13412	46	0	\N
374325	1678	27360856551000	27534	13412	47	0	\N
374326	1678	27360856552000	27534	13412	48	0	\N
374327	1678	27360856553000	27534	13412	49	0	\N
374328	1678	27360856554000	27534	13412	50	0	\N
374329	1678	27360856555000	27534	13412	51	0	\N
374330	1678	27360856556000	27534	13412	52	0	\N
374331	1678	27360856557000	27534	13412	53	0	\N
374332	1678	27360856558000	27534	13412	54	0	\N
374333	1678	27360856559000	27534	13412	55	0	\N
374334	1678	27360856560000	27534	13412	56	0	\N
374335	1678	27360856561000	27534	13412	57	0	\N
374336	1678	27360856562000	27534	13412	58	0	\N
374337	1678	27360856563000	27534	13412	59	0	\N
374338	1678	27360856564000	27534	13412	60	0	\N
374339	1678	27360856565000	27534	13412	61	0	\N
374340	1678	27360856566000	27534	13412	62	0	\N
374341	1678	27360856567000	27534	13412	63	0	\N
374342	1678	27360856568000	27534	13412	64	0	\N
374343	1678	27360856569000	27534	13412	65	0	\N
374344	1678	27360856570000	27534	13412	66	0	\N
374345	1678	27360856571000	27534	13412	67	0	\N
374346	1678	27360856572000	27534	13412	68	0	\N
374347	1678	27360856573000	27534	13412	69	0	\N
374348	1678	27360856574000	27534	13412	70	0	\N
374349	1678	27360856575000	27534	13412	71	0	\N
374350	1678	27360856576000	27534	13412	72	0	\N
374351	1678	27360856577000	27534	13412	73	0	\N
374352	1444	14587917329999	27535	13613	0	0	\N
374353	1678	27360856707000	27535	13613	1	0	\N
374354	1678	27360856708000	27535	13613	2	0	\N
374355	1874	35805000	27535	13613	3	0	\N
374356	1874	35807000	27535	13613	4	0	\N
374357	1874	35809000	27535	13613	5	0	\N
374358	1874	35812000	27535	13613	6	0	\N
374366	1444	14587917329999	27537	13613	0	0	\N
374367	1678	27360856707000	27537	13613	1	0	\N
374368	1678	27360856708000	27537	13613	2	0	\N
374369	1874	35805000	27537	13613	3	0	\N
374370	1874	35807000	27537	13613	4	0	\N
374371	1874	35809000	27537	13613	5	0	\N
374372	1874	35812000	27537	13613	6	0	\N
374373	1678	27360856709000	27538	13614	0	0	\N
374374	1874	35814000	27538	13614	1	0	\N
374375	1874	35817000	27538	13614	2	0	\N
374379	1678	27360856709000	27540	13614	0	0	\N
374380	1874	35814000	27540	13614	1	0	\N
374381	1874	35817000	27540	13614	2	0	\N
374382	1678	27360856710000	27541	13615	0	0	\N
374383	1778	7424464345059	27541	13615	1	0	\N
374384	1874	35820000	27541	13615	2	0	\N
374389	1678	27360856710000	27543	13615	0	0	\N
374390	1778	7424464345059	27543	13615	1	0	\N
374391	1874	35819000	27543	13615	2	0	\N
374392	1874	35822000	27543	13615	3	0	\N
374393	1678	27360856710000	27544	13615	0	0	\N
374394	1778	7424464345059	27544	13615	1	0	\N
374395	1874	35819000	27544	13615	2	0	\N
374396	1874	35822000	27544	13615	3	0	\N
374406	1678	27360856711000	27546	13616	0	0	\N
374407	1678	27360856712000	27546	13616	1	0	\N
374408	1678	27360856713000	27546	13616	2	0	\N
374359	1444	14587917329999	27536	13613	0	0	13
374360	1678	27360856707000	27536	13613	1	0	1
374361	1678	27360856708000	27536	13613	2	0	1
374362	1874	35805000	27536	13613	3	0	2
374363	1874	35807000	27536	13613	4	0	2
374365	1874	35812000	27536	13613	6	0	2
374376	1678	27360856709000	27539	13614	0	0	1
374377	1874	35814000	27539	13614	1	0	2
374378	1874	35817000	27539	13614	2	0	2
374385	1678	27360856710000	27542	13615	0	0	1
374387	1874	35819000	27542	13615	2	0	2
374388	1874	35822000	27542	13615	3	0	2
374397	1678	27360856711000	27545	13616	0	0	1
374398	1678	27360856712000	27545	13616	1	0	1
374400	1874	35825000	27545	13616	3	0	2
374401	1874	35827000	27545	13616	4	0	2
374402	1874	35829000	27545	13616	5	0	2
374403	1874	35831000	27545	13616	6	0	2
374404	1874	35834000	27545	13616	7	0	2
374409	1874	35825000	27546	13616	3	0	\N
374410	1874	35827000	27546	13616	4	0	\N
374411	1874	35829000	27546	13616	5	0	\N
374412	1874	35831000	27546	13616	6	0	\N
374413	1874	35834000	27546	13616	7	0	\N
374414	1874	35837000	27546	13616	8	0	\N
374415	1678	27360856711000	27547	13616	0	0	\N
374416	1678	27360856712000	27547	13616	1	0	\N
374417	1678	27360856713000	27547	13616	2	0	\N
374418	1874	35825000	27547	13616	3	0	\N
374419	1874	35827000	27547	13616	4	0	\N
374420	1874	35829000	27547	13616	5	0	\N
374421	1874	35831000	27547	13616	6	0	\N
374422	1874	35834000	27547	13616	7	0	\N
374423	1874	35837000	27547	13616	8	0	\N
374430	1678	27360856716000	27549	13618	0	0	\N
374431	1874	35849000	27549	13618	1	0	\N
374432	1874	35852000	27549	13618	2	0	\N
374442	1678	27360856718000	27553	13620	0	0	\N
374443	1874	35857000	27553	13620	1	0	\N
374444	1874	35860000	27553	13620	2	0	\N
374445	1874	35862000	27553	13620	3	0	\N
374446	1678	27360856718000	27554	13620	0	0	\N
374447	1874	35857000	27554	13620	1	0	\N
374448	1874	35860000	27554	13620	2	0	\N
374449	1874	35862000	27554	13620	3	0	\N
374450	1678	27360856718000	27555	13620	0	0	\N
374451	1874	35857000	27555	13620	1	0	\N
374452	1874	35860000	27555	13620	2	0	\N
374453	1874	35862000	27555	13620	3	0	\N
374457	1874	35870000	27557	13622	0	0	\N
374458	1874	35872000	27557	13622	1	0	\N
374465	1678	27360856720000	27560	13623	0	0	\N
374466	1874	35875000	27560	13623	1	0	\N
374467	1403	0	27560	13623	2	0	\N
374468	1874	35877000	27560	13623	3	0	\N
374469	1678	27360856720000	27561	13623	0	0	\N
374470	1874	35875000	27561	13623	1	0	\N
374471	1403	0	27561	13623	2	0	\N
374472	1874	35877000	27561	13623	3	0	\N
374473	1678	27360856720000	27562	13623	0	0	\N
374474	1874	35875000	27562	13623	1	0	\N
374475	1403	0	27562	13623	2	0	\N
374476	1874	35877000	27562	13623	3	0	\N
374477	1678	27360856721000	27563	13624	0	0	\N
374478	1874	35879000	27563	13624	1	0	\N
374479	1874	35882000	27563	13624	2	0	\N
374480	1678	27360856721000	27564	13624	0	0	\N
374481	1874	35879000	27564	13624	1	0	\N
374482	1874	35882000	27564	13624	2	0	\N
374489	1678	27360856722000	27567	13625	0	0	\N
374490	1874	35885000	27567	13625	1	0	\N
374491	1874	35887000	27567	13625	2	0	\N
374501	1678	27360856725000	27570	13627	0	0	\N
374502	1874	35900000	27570	13627	1	0	\N
374503	1874	35902000	27570	13627	2	0	\N
374504	1678	27360856725000	27571	13627	0	0	\N
374505	1874	35900000	27571	13627	1	0	\N
374506	1874	35902000	27571	13627	2	0	\N
374513	1678	27360856728000	27574	13629	0	0	\N
374514	1874	35915000	27574	13629	1	0	\N
374515	1874	35917000	27574	13629	2	0	\N
374519	1678	27360856728000	27576	13629	0	0	\N
374520	1874	35915000	27576	13629	1	0	\N
374521	1874	35917000	27576	13629	2	0	\N
374522	1693	13510991570272	27577	13437	0	0	\N
374523	1874	34939000	27577	13437	1	0	\N
374524	1874	34940000	27577	13437	2	0	\N
374525	2346	388000000	27577	13437	3	0	\N
374526	383	66846781394804	27577	13437	4	0	\N
374527	1874	34941000	27577	13437	5	0	\N
374528	2358	50100000000	27577	13437	6	0	\N
374529	1874	34943000	27577	13437	7	0	\N
374530	1874	34945000	27577	13437	8	0	\N
374531	1874	34947000	27577	13437	9	0	\N
374532	327	66190546738816	27577	13437	10	0	\N
374533	1874	34949000	27577	13437	11	0	\N
374534	652	66846781394804	27577	13437	12	0	\N
374535	1874	34951000	27577	13437	13	0	\N
374536	1874	34953000	27577	13437	14	0	\N
374537	1874	34955000	27577	13437	15	0	\N
374538	266	66233761394804	27577	13437	16	0	\N
374539	352	66846781394804	27577	13437	17	0	\N
374540	191	66846781394804	27577	13437	18	0	\N
374541	520	66846781394804	27577	13437	19	0	\N
374542	421	66846781394804	27577	13437	20	0	\N
374543	534	66846781394804	27577	13437	21	0	\N
374544	680	66846781394804	27577	13437	22	0	\N
374426	1874	35840000	27548	13617	2	0	2
374427	1874	35843000	27548	13617	3	0	2
374428	1874	35845000	27548	13617	4	0	2
374429	1874	35847000	27548	13617	5	0	2
374433	1678	27360856716000	27550	13618	0	0	1
374435	1874	35852000	27550	13618	2	0	2
374436	1678	27360856717000	27551	13619	0	0	1
374437	1874	35855000	27551	13619	1	0	2
374438	1678	27360856718000	27552	13620	0	0	1
374439	1874	35857000	27552	13620	1	0	2
374441	1874	35862000	27552	13620	3	0	2
374454	1678	27360856719000	27556	13621	0	0	1
374455	1874	35864000	27556	13621	1	0	2
374456	1874	35867000	27556	13621	2	0	2
374460	1874	35872000	27558	13622	1	0	2
374461	1678	27360856720000	27559	13623	0	0	1
374462	1874	35875000	27559	13623	1	0	2
374463	1403	0	27559	13623	2	0	0
374464	1874	35877000	27559	13623	3	0	2
374484	1874	35879000	27565	13624	1	0	2
374485	1874	35882000	27565	13624	2	0	2
374486	1678	27360856722000	27566	13625	0	0	1
374487	1874	35885000	27566	13625	1	0	2
374488	1874	35887000	27566	13625	2	0	2
374493	1678	27360856724000	27568	13626	1	0	1
374494	1874	35889000	27568	13626	2	0	2
374495	1874	35891000	27568	13626	3	0	2
374496	1874	35894000	27568	13626	4	0	2
374498	1678	27360856725000	27569	13627	0	0	1
374499	1874	35900000	27569	13627	1	0	2
374500	1874	35902000	27569	13627	2	0	2
374507	1678	27360856726000	27572	13628	0	0	1
374508	1678	27360856727000	27572	13628	1	0	1
374510	1874	35907000	27572	13628	3	0	2
374511	1874	35909000	27572	13628	4	0	2
374512	1874	35912000	27572	13628	5	0	2
374516	1678	27360856728000	27575	13629	0	0	1
374517	1874	35915000	27575	13629	1	0	2
374545	1403	0	27578	13620	0	0	\N
374552	1678	27360856729000	27580	13630	0	0	\N
374553	1678	27360856730000	27580	13630	1	0	\N
374554	1874	35920000	27580	13630	2	0	\N
374555	1874	35922000	27580	13630	3	0	\N
374556	1874	35924000	27580	13630	4	0	\N
374557	1874	35927000	27580	13630	5	0	\N
374574	2068	2000099000000	27585	13633	0	0	\N
374575	1678	27360856735000	27585	13633	1	0	\N
374576	1874	35949000	27585	13633	2	0	\N
374577	1874	35952000	27585	13633	3	0	\N
374585	1678	27360856737000	27588	13635	0	0	\N
374586	1678	27360856738000	27588	13635	1	0	\N
374587	1874	35959000	27588	13635	2	0	\N
374588	1874	35961000	27588	13635	3	0	\N
374589	1874	35964000	27588	13635	4	0	\N
374590	1874	35967000	27588	13635	5	0	\N
374593	1678	27360856739000	27590	13636	0	0	\N
374594	1874	35965000	27590	13636	1	0	\N
374595	1874	35968000	27590	13636	2	0	\N
374596	1874	35970000	27590	13636	3	0	\N
374597	1874	35972000	27590	13636	4	0	\N
374598	1678	27360856740000	27591	13637	0	0	\N
374599	1874	35968000	27591	13637	1	0	\N
374600	1874	35971000	27591	13637	2	0	\N
374601	1874	35973000	27591	13637	3	0	\N
374602	1874	35975000	27591	13637	4	0	\N
374603	1874	35977000	27591	13637	5	0	\N
374613	1678	27360856741000	27594	13638	0	0	\N
374614	1874	35980000	27594	13638	1	0	\N
374615	1874	35982000	27594	13638	2	0	\N
374616	38	66539225269421	27595	13639	0	0	\N
374617	969	506877361461968	27595	13639	1	0	\N
374618	1089	908319888814612	27595	13639	2	0	\N
374619	1209	612861528535553	27595	13639	3	0	\N
374620	1335	1707793141873126	27595	13639	4	0	\N
374621	1678	27360856742000	27595	13639	6	0	\N
374622	1874	35984000	27595	13639	7	0	\N
374623	1874	35987000	27595	13639	8	0	\N
374632	1678	27360856743000	27597	13640	0	0	\N
374633	1678	27360856744000	27597	13640	1	0	\N
374634	2152	109988998000000	27597	13640	2	0	\N
374635	1874	35989000	27597	13640	3	0	\N
374636	1874	35992000	27597	13640	4	0	\N
374637	1874	35995000	27597	13640	5	0	\N
374638	1874	35997000	27597	13640	6	0	\N
374652	1678	27360856745000	27600	13641	0	0	\N
374653	1678	27360856746000	27600	13641	1	0	\N
374654	1874	35999000	27600	13641	2	0	\N
374655	1874	36001000	27600	13641	3	0	\N
374656	1874	36004000	27600	13641	4	0	\N
374657	1874	36007000	27600	13641	5	0	\N
374658	1678	27360856745000	27602	13641	0	0	\N
374659	1678	27360856746000	27602	13641	1	0	\N
374660	1874	35999000	27602	13641	2	0	\N
374661	1874	36001000	27602	13641	3	0	\N
374662	1874	36004000	27602	13641	4	0	\N
374663	1874	36007000	27602	13641	5	0	\N
374675	1678	27360856748000	27606	13643	0	0	\N
374676	1874	36015000	27606	13643	1	0	\N
374677	1874	36017000	27606	13643	2	0	\N
374548	1874	35920000	27579	13630	2	0	2
374549	1874	35922000	27579	13630	3	0	2
374550	1874	35924000	27579	13630	4	0	2
374551	1874	35927000	27579	13630	5	0	2
374558	1678	27360856731000	27581	13631	0	0	1
374560	1874	35930000	27581	13631	2	0	2
374561	1874	35933000	27581	13631	3	0	2
374562	1874	35935000	27581	13631	4	0	2
374563	1874	35937000	27581	13631	5	0	2
374564	1678	27360856733000	27583	13632	0	0	1
374566	1874	35939000	27583	13632	2	0	2
374567	1874	35942000	27583	13632	3	0	2
374568	1874	35944000	27583	13632	4	0	2
374569	1874	35947000	27583	13632	5	0	2
374571	1678	27360856735000	27584	13633	1	0	1
374572	1874	35949000	27584	13633	2	0	2
374573	1874	35952000	27584	13633	3	0	2
374578	1678	27360856736000	27586	13634	0	0	1
374579	1874	35954000	27586	13634	1	0	2
374581	1678	27360856737000	27587	13635	0	0	1
374582	1678	27360856738000	27587	13635	1	0	1
374583	1874	35960000	27587	13635	2	0	2
374584	1874	35963000	27587	13635	3	0	2
374591	1678	27360856739000	27589	13636	0	0	1
374604	1678	27360856740000	27592	13637	0	0	1
374605	1874	35968000	27592	13637	1	0	2
374606	1874	35971000	27592	13637	2	0	2
374607	1874	35973000	27592	13637	3	0	2
374609	1874	35977000	27592	13637	5	0	2
374610	1678	27360856741000	27593	13638	0	0	1
374611	1874	35980000	27593	13638	1	0	2
374612	1874	35982000	27593	13638	2	0	2
374624	38	66539225269421	27596	13639	0	0	0
374626	1089	908319888814612	27596	13639	2	0	0
374627	1209	612861528535553	27596	13639	3	0	0
374628	1335	1707793141873126	27596	13639	4	0	0
374629	1678	27360856742000	27596	13639	6	0	1
374630	1874	35984000	27596	13639	7	0	2
374639	1678	27360856743000	27598	13640	0	0	1
374640	1678	27360856744000	27598	13640	1	0	1
374641	2152	109988998000000	27598	13640	2	0	5
374642	1874	35989000	27598	13640	3	0	2
374644	1874	35995000	27598	13640	5	0	2
374645	1874	35997000	27598	13640	6	0	2
374646	1678	27360856745000	27599	13641	0	0	1
374647	1678	27360856746000	27599	13641	1	0	1
374648	1874	35999000	27599	13641	2	0	2
374650	1874	36004000	27599	13641	4	0	2
374651	1874	36007000	27599	13641	5	0	2
374664	1678	27360856747000	27603	13642	0	0	1
374665	38	66575050395110	27603	13642	1	0	0
374666	969	507150018330014	27603	13642	2	0	0
374668	1209	613191195862646	27603	13642	4	0	0
374669	1335	1708711789192456	27603	13642	5	0	0
374670	1874	36010000	27603	13642	7	0	2
374671	1874	36012000	27603	13642	8	0	2
374673	1874	36015000	27605	13643	1	0	2
374674	1874	36017000	27605	13643	2	0	2
374678	1678	27360856749000	27608	13645	0	0	1
374679	1678	27360856750000	27608	13645	1	0	1
374680	1678	27360856751000	27608	13645	2	0	1
374693	38	66539225269421	27610	13574	0	0	\N
374694	969	506877361461968	27610	13574	1	0	\N
374695	1693	15806184982759	27610	13574	2	0	\N
374696	2068	2000099000000	27610	13574	3	0	\N
374697	1678	27360856646000	27610	13574	4	0	\N
374698	1678	27360856647000	27610	13574	5	0	\N
374699	1678	27360856648000	27610	13574	6	0	\N
374700	1678	27360856649000	27610	13574	7	0	\N
374701	1678	27360856650000	27610	13574	8	0	\N
374702	1678	27360856651000	27610	13574	9	0	\N
374703	1678	27360856652000	27610	13574	10	0	\N
374704	1678	27360856653000	27610	13574	11	0	\N
374705	1089	908319888814612	27610	13574	12	0	\N
374706	1209	612861528535553	27610	13574	13	0	\N
374707	1335	1707793141873126	27610	13574	14	0	\N
374708	38	66575050395110	27610	13574	16	0	\N
374709	969	507150018330014	27610	13574	17	0	\N
374710	1089	908808487586029	27610	13574	18	0	\N
374711	1209	613191195862646	27610	13574	19	0	\N
374712	1335	1708711789192456	27610	13574	20	0	\N
374713	1678	27360856654000	27610	13574	22	0	\N
374714	1678	27360856655000	27610	13574	23	0	\N
374715	1678	27360856656000	27610	13574	24	0	\N
374716	1678	27360856657000	27610	13574	25	0	\N
374717	1678	27360856658000	27610	13574	26	0	\N
374718	1678	27360856659000	27610	13574	27	0	\N
374719	1678	27360856660000	27610	13574	28	0	\N
374720	1678	27360856661000	27610	13574	29	0	\N
374721	1678	27360856662000	27610	13574	30	0	\N
374722	1678	27360856663000	27610	13574	31	0	\N
374723	1678	27360856664000	27610	13574	32	0	\N
374724	1678	27360856665000	27610	13574	33	0	\N
374725	1678	27360856666000	27610	13574	34	0	\N
374726	1678	27360856667000	27610	13574	35	0	\N
374727	1678	27360856668000	27610	13574	36	0	\N
374728	1678	27360856669000	27610	13574	37	0	\N
374729	1678	27360856670000	27610	13574	38	0	\N
374730	1678	27360856671000	27610	13574	39	0	\N
374731	1678	27360856672000	27610	13574	40	0	\N
374732	1678	27360856673000	27610	13574	41	0	\N
374733	1678	27360856674000	27610	13574	42	0	\N
374734	1678	27360856675000	27610	13574	43	0	\N
374735	1678	27360856676000	27610	13574	44	0	\N
374736	1678	27360856677000	27610	13574	45	0	\N
374737	1678	27360856678000	27610	13574	46	0	\N
374738	1678	27360856679000	27610	13574	47	0	\N
374739	1678	27360856680000	27610	13574	48	0	\N
374740	1678	27360856681000	27610	13574	49	0	\N
374741	1678	27360856682000	27610	13574	50	0	\N
374742	1678	27360856683000	27610	13574	51	0	\N
374743	1678	27360856684000	27610	13574	52	0	\N
374744	1678	27360856685000	27610	13574	53	0	\N
374745	1678	27360856686000	27610	13574	54	0	\N
374746	1678	27360856687000	27610	13574	56	0	\N
374747	1678	27360856688000	27610	13574	57	0	\N
374748	1678	27360856689000	27610	13574	58	0	\N
374749	1678	27360856690000	27610	13574	59	0	\N
374750	1678	27360856691000	27610	13574	60	0	\N
374751	1678	27360856692000	27610	13574	61	0	\N
374752	1678	27360856693000	27610	13574	62	0	\N
374753	1678	27360856694000	27610	13574	63	0	\N
374754	1678	27360856695000	27610	13574	64	0	\N
374755	1678	27360856696000	27610	13574	65	0	\N
374756	1678	27360856697000	27610	13574	66	0	\N
374757	1678	27360856698000	27610	13574	67	0	\N
374758	1678	27360856699000	27610	13574	68	0	\N
374759	1678	27360856700000	27610	13574	69	0	\N
374760	1678	27360856701000	27610	13574	70	0	\N
374761	1678	27360856702000	27610	13574	71	0	\N
374762	1678	27360856703000	27610	13574	72	0	\N
374763	1678	27360856704000	27610	13574	73	0	\N
374764	1678	27360856705000	27610	13574	74	0	\N
374765	1678	27360856706000	27610	13574	75	0	\N
374766	1678	27360856707000	27610	13574	76	0	\N
374767	1678	27360856708000	27610	13574	77	0	\N
374768	1678	27360856709000	27610	13574	78	0	\N
374769	1678	27360856710000	27610	13574	79	0	\N
374770	1678	27360856711000	27610	13574	80	0	\N
374771	1678	27360856712000	27610	13574	81	0	\N
374772	1678	27360856713000	27610	13574	82	0	\N
374773	1678	27360856714000	27610	13574	83	0	\N
374774	1678	27360856715000	27610	13574	84	0	\N
374775	1678	27360856716000	27610	13574	85	0	\N
374776	1678	27360856717000	27610	13574	86	0	\N
374777	1678	27360856718000	27610	13574	87	0	\N
374778	1678	27360856719000	27610	13574	88	0	\N
374779	1678	27360856720000	27610	13574	89	0	\N
374780	1678	27360856721000	27610	13574	90	0	\N
374781	1678	27360856722000	27610	13574	91	0	\N
374782	1678	27360856723000	27610	13574	92	0	\N
374783	1678	27360856724000	27610	13574	93	0	\N
374784	1678	27360856725000	27610	13574	94	0	\N
374785	1678	27360856726000	27610	13574	95	0	\N
374786	1678	27360856727000	27610	13574	96	0	\N
374787	1678	27360856728000	27610	13574	97	0	\N
374788	1678	27360856729000	27610	13574	98	0	\N
374789	1678	27360856730000	27610	13574	99	0	\N
374790	1678	27360856731000	27610	13574	100	0	\N
374791	1678	27360856732000	27610	13574	101	0	\N
374792	1678	27360856733000	27610	13574	102	0	\N
374793	1678	27360856734000	27610	13574	103	0	\N
374794	1678	27360856735000	27610	13574	104	0	\N
374795	1678	27360856736000	27610	13574	105	0	\N
374796	1678	27360856737000	27610	13574	106	0	\N
374797	1678	27360856738000	27610	13574	107	0	\N
374798	1678	27360856739000	27610	13574	108	0	\N
374799	1678	27360856740000	27610	13574	109	0	\N
374800	1678	27360856741000	27610	13574	110	0	\N
374801	1678	27360856742000	27610	13574	111	0	\N
374802	1678	27360856743000	27610	13574	112	0	\N
374803	1678	27360856744000	27610	13574	113	0	\N
374804	1678	27360856745000	27610	13574	114	0	\N
374805	1678	27360856746000	27610	13574	115	0	\N
374806	1678	27360856747000	27610	13574	116	0	\N
374807	1678	27360856748000	27610	13574	117	0	\N
374808	1678	27360856749000	27610	13574	118	0	\N
374809	1678	27360856750000	27610	13574	119	0	\N
374810	1678	27360856751000	27610	13574	120	0	\N
374811	1678	27360856752000	27610	13574	121	0	\N
374812	1678	27360856753000	27610	13574	122	0	\N
374813	391	66845671394804	27610	13574	123	0	\N
374814	1874	35494000	27610	13574	124	0	\N
374815	1874	35495000	27610	13574	125	0	\N
374816	38	66539225269421	27611	13576	0	0	\N
374683	1874	36021000	27608	13645	5	0	2
374684	1874	36024000	27608	13645	6	0	2
374685	1874	36027000	27608	13645	7	0	2
374686	1874	36029000	27608	13645	8	0	2
374687	1874	36031000	27608	13645	9	0	2
374689	1874	36037000	27608	13645	11	0	2
374690	1678	27360856753000	27609	13646	0	0	1
374691	1874	36039000	27609	13646	1	0	2
374692	1874	36042000	27609	13646	2	0	2
374817	969	506877361461968	27611	13576	1	0	\N
374818	1693	11143928610808	27611	13576	2	0	\N
374819	2068	2000099000000	27611	13576	3	0	\N
374820	1678	27360856650000	27611	13576	4	0	\N
374821	1678	27360856651000	27611	13576	5	0	\N
374822	1678	27360856652000	27611	13576	6	0	\N
374823	1678	27360856653000	27611	13576	7	0	\N
374824	1089	908319888814612	27611	13576	8	0	\N
374825	1209	612861528535553	27611	13576	9	0	\N
374826	1335	1707793141873126	27611	13576	10	0	\N
374827	38	66575050395110	27611	13576	12	0	\N
374828	969	507150018330014	27611	13576	13	0	\N
374829	1089	908808487586029	27611	13576	14	0	\N
374830	1209	613191195862646	27611	13576	15	0	\N
374831	1335	1708711789192456	27611	13576	16	0	\N
374832	1678	27360856654000	27611	13576	18	0	\N
374833	1678	27360856655000	27611	13576	20	0	\N
374834	1678	27360856656000	27611	13576	21	0	\N
374835	1678	27360856657000	27611	13576	22	0	\N
374836	1678	27360856658000	27611	13576	23	0	\N
374837	1678	27360856659000	27611	13576	24	0	\N
374838	1678	27360856660000	27611	13576	25	0	\N
374839	1678	27360856661000	27611	13576	26	0	\N
374840	1678	27360856662000	27611	13576	27	0	\N
374841	1678	27360856663000	27611	13576	28	0	\N
374842	1678	27360856664000	27611	13576	29	0	\N
374843	1678	27360856665000	27611	13576	30	0	\N
374844	1678	27360856666000	27611	13576	31	0	\N
374845	1678	27360856667000	27611	13576	32	0	\N
374846	1678	27360856668000	27611	13576	33	0	\N
374847	1678	27360856669000	27611	13576	34	0	\N
374848	1678	27360856670000	27611	13576	35	0	\N
374849	1678	27360856671000	27611	13576	36	0	\N
374850	1678	27360856672000	27611	13576	37	0	\N
374851	1678	27360856673000	27611	13576	38	0	\N
374852	1678	27360856674000	27611	13576	39	0	\N
374853	1678	27360856675000	27611	13576	40	0	\N
374854	1678	27360856676000	27611	13576	41	0	\N
374855	1678	27360856677000	27611	13576	42	0	\N
374856	1678	27360856678000	27611	13576	43	0	\N
374857	1678	27360856679000	27611	13576	44	0	\N
374858	1678	27360856680000	27611	13576	45	0	\N
374859	1678	27360856681000	27611	13576	46	0	\N
374860	1678	27360856682000	27611	13576	47	0	\N
374861	1678	27360856683000	27611	13576	48	0	\N
374862	1678	27360856684000	27611	13576	49	0	\N
374863	1678	27360856685000	27611	13576	50	0	\N
374864	1678	27360856686000	27611	13576	51	0	\N
374865	1678	27360856687000	27611	13576	52	0	\N
374866	1678	27360856688000	27611	13576	53	0	\N
374867	1678	27360856689000	27611	13576	54	0	\N
374868	1678	27360856690000	27611	13576	55	0	\N
374869	1678	27360856691000	27611	13576	56	0	\N
374870	1678	27360856692000	27611	13576	57	0	\N
374871	1678	27360856693000	27611	13576	58	0	\N
374872	1678	27360856694000	27611	13576	59	0	\N
374873	1678	27360856695000	27611	13576	60	0	\N
374874	1678	27360856696000	27611	13576	61	0	\N
374875	1678	27360856697000	27611	13576	62	0	\N
374876	1678	27360856698000	27611	13576	63	0	\N
374877	1678	27360856699000	27611	13576	64	0	\N
374878	1678	27360856700000	27611	13576	65	0	\N
374879	1678	27360856701000	27611	13576	66	0	\N
374880	1678	27360856702000	27611	13576	67	0	\N
374881	1678	27360856703000	27611	13576	68	0	\N
374882	1678	27360856704000	27611	13576	69	0	\N
374883	1678	27360856705000	27611	13576	70	0	\N
374884	1678	27360856706000	27611	13576	71	0	\N
374885	1678	27360856707000	27611	13576	72	0	\N
374886	1678	27360856708000	27611	13576	73	0	\N
374887	1678	27360856709000	27611	13576	74	0	\N
374888	1678	27360856710000	27611	13576	75	0	\N
374889	1678	27360856711000	27611	13576	76	0	\N
374890	1678	27360856712000	27611	13576	77	0	\N
374891	1678	27360856713000	27611	13576	78	0	\N
374892	1678	27360856714000	27611	13576	79	0	\N
374893	1678	27360856754000	27612	13647	0	0	\N
374894	1874	36044000	27612	13647	1	0	\N
374895	1874	36047000	27612	13647	2	0	\N
374899	1678	27360856754000	27614	13647	0	0	\N
374900	1874	36044000	27614	13647	1	0	\N
374901	1874	36047000	27614	13647	2	0	\N
374906	1678	27360856755000	27616	13648	0	0	\N
374907	1678	27360856756000	27616	13648	1	0	\N
374908	1678	27360856757000	27616	13648	2	0	\N
374909	1678	27360856758000	27616	13648	3	0	\N
374910	1874	36050000	27616	13648	4	0	\N
374911	1874	36052000	27616	13648	5	0	\N
374912	1874	36054000	27616	13648	6	0	\N
374913	1874	36056000	27616	13648	7	0	\N
374914	1874	36058000	27616	13648	8	0	\N
374915	1874	36061000	27616	13648	9	0	\N
374916	1874	36064000	27616	13648	10	0	\N
374917	1874	36067000	27616	13648	11	0	\N
374938	1678	27360856763000	27619	13651	0	0	\N
374939	1874	36090000	27619	13651	1	0	\N
374940	1874	36092000	27619	13651	2	0	\N
374941	1678	27360856763000	27620	13651	0	0	\N
374942	1874	36090000	27620	13651	1	0	\N
374943	1874	36092000	27620	13651	2	0	\N
374944	1678	27360856763000	27621	13651	0	0	\N
374951	1678	27360856765000	27624	13653	0	0	\N
374952	1678	27360856766000	27624	13653	1	0	\N
374898	1874	36047000	27613	13647	2	0	2
374902	1678	27360856755000	27615	13648	0	0	1
374903	1678	27360856756000	27615	13648	1	0	1
374904	1678	27360856757000	27615	13648	2	0	1
374905	1678	27360856758000	27615	13648	3	0	1
374919	1678	27360856760000	27617	13649	1	0	1
374920	1678	27360856761000	27617	13649	2	0	1
374921	1874	36050000	27617	13649	3	0	2
374922	1874	36052000	27617	13649	4	0	2
374923	1874	36054000	27617	13649	5	0	2
374925	1874	36058000	27617	13649	7	0	2
374926	1874	36060000	27617	13649	8	0	2
374927	1874	36063000	27617	13649	9	0	2
374928	1874	36066000	27617	13649	10	0	2
374930	1874	36070000	27617	13649	12	0	2
374931	1874	36073000	27617	13649	13	0	2
374932	1874	36076000	27617	13649	14	0	2
374933	1874	36079000	27617	13649	15	0	2
374934	1874	36082000	27617	13649	16	0	2
374936	1874	36085000	27618	13650	1	0	2
374937	1874	36087000	27618	13650	2	0	2
374945	1678	27360856763000	27622	13651	0	0	1
374946	1874	36090000	27622	13651	1	0	2
374947	1874	36092000	27622	13651	2	0	2
374949	1874	36094000	27623	13652	1	0	2
374950	1874	36097000	27623	13652	2	0	2
374953	1874	36099000	27624	13653	2	0	\N
374954	1874	36101000	27624	13653	3	0	\N
374955	1874	36104000	27624	13653	4	0	\N
374956	1874	36107000	27624	13653	5	0	\N
374963	1678	27360856765000	27626	13653	0	0	\N
374964	1678	27360856766000	27626	13653	1	0	\N
374965	1874	36099000	27626	13653	2	0	\N
374966	1874	36101000	27626	13653	3	0	\N
374967	1874	36104000	27626	13653	4	0	\N
374968	1874	36107000	27626	13653	5	0	\N
374973	1678	27360856767000	27628	13654	0	0	\N
374974	1874	36110000	27628	13654	1	0	\N
374975	1635	11000000	27628	13654	2	0	\N
374976	1874	36112000	27628	13654	3	0	\N
374986	1678	27360856771000	27631	13657	0	0	\N
374987	1874	36130000	27631	13657	1	0	\N
374988	1874	36132000	27631	13657	2	0	\N
374992	1678	27360856772000	27633	13658	0	0	\N
374993	1874	36135000	27633	13658	1	0	\N
374994	1874	36137000	27633	13658	2	0	\N
374998	1678	27360856772000	27635	13658	0	0	\N
374999	1874	36135000	27635	13658	1	0	\N
375000	1874	36137000	27635	13658	2	0	\N
375001	1678	27360856773000	27640	13660	0	0	\N
375002	1678	27360856774000	27640	13660	1	0	\N
375003	1678	27360856775000	27640	13660	2	0	\N
375004	1678	27360856776000	27640	13660	3	0	\N
375005	1874	36139000	27640	13660	4	0	\N
375006	1874	36142000	27640	13660	5	0	\N
375007	1874	36145000	27640	13660	6	0	\N
375008	1874	36148000	27640	13660	7	0	\N
375009	1874	36151000	27640	13660	8	0	\N
375010	1874	36153000	27640	13660	9	0	\N
375011	1874	36155000	27640	13660	10	0	\N
375012	1874	36157000	27640	13660	11	0	\N
375025	1678	27360856773000	27642	13660	0	0	\N
375026	1678	27360856774000	27642	13660	1	0	\N
375027	1678	27360856775000	27642	13660	2	0	\N
375028	1678	27360856776000	27642	13660	3	0	\N
375029	1874	36139000	27642	13660	4	0	\N
375030	1874	36142000	27642	13660	5	0	\N
375031	1874	36145000	27642	13660	6	0	\N
375032	1874	36148000	27642	13660	7	0	\N
375033	1874	36151000	27642	13660	8	0	\N
375034	1874	36153000	27642	13660	9	0	\N
375035	1874	36155000	27642	13660	10	0	\N
375036	1874	36157000	27642	13660	11	0	\N
375037	1678	27360856773000	27643	13660	0	0	\N
375038	1678	27360856774000	27643	13660	1	0	\N
375039	1678	27360856775000	27643	13660	2	0	\N
375040	1678	27360856776000	27643	13660	3	0	\N
375041	1874	36139000	27643	13660	4	0	\N
375042	1874	36142000	27643	13660	5	0	\N
375043	1874	36145000	27643	13660	6	0	\N
375044	1874	36148000	27643	13660	7	0	\N
375045	1874	36151000	27643	13660	8	0	\N
375046	1874	36153000	27643	13660	9	0	\N
375047	1874	36155000	27643	13660	10	0	\N
375048	1874	36157000	27643	13660	11	0	\N
375049	1678	27360856773000	27644	13660	0	0	\N
375050	1678	27360856774000	27644	13660	1	0	\N
375051	1678	27360856775000	27644	13660	2	0	\N
375052	1678	27360856776000	27644	13660	3	0	\N
375053	1874	36139000	27644	13660	4	0	\N
375054	1874	36142000	27644	13660	5	0	\N
375055	1874	36145000	27644	13660	6	0	\N
375056	1874	36148000	27644	13660	7	0	\N
375057	1874	36151000	27644	13660	8	0	\N
375058	1874	36153000	27644	13660	9	0	\N
375059	1874	36155000	27644	13660	10	0	\N
375060	1874	36157000	27644	13660	11	0	\N
375065	1678	27360856777000	27646	13661	0	0	\N
375066	1474	15030643000043	27646	13661	1	0	\N
375067	1874	36160000	27646	13661	2	0	\N
375068	1874	36162000	27646	13661	3	0	\N
374959	1874	36099000	27625	13653	2	0	2
374960	1874	36101000	27625	13653	3	0	2
374961	1874	36104000	27625	13653	4	0	2
374962	1874	36107000	27625	13653	5	0	2
374969	1678	27360856767000	27627	13654	0	0	1
374971	1635	11000000	27627	13654	2	0	1
374972	1874	36112000	27627	13654	3	0	2
374977	1678	27360856768000	27629	13655	0	0	1
374978	1678	27360856769000	27629	13655	1	0	1
374979	1874	36115000	27629	13655	2	0	2
374981	1874	36120000	27629	13655	4	0	2
374982	1874	36122000	27629	13655	5	0	2
374983	1678	27360856770000	27630	13656	0	0	1
374984	1874	36124000	27630	13656	1	0	2
374989	1678	27360856771000	27632	13657	0	0	1
374990	1874	36130000	27632	13657	1	0	2
374991	1874	36132000	27632	13657	2	0	2
374995	1678	27360856772000	27634	13658	0	0	1
374996	1874	36135000	27634	13658	1	0	2
375013	1678	27360856773000	27641	13660	0	0	1
375014	1678	27360856774000	27641	13660	1	0	1
375015	1678	27360856775000	27641	13660	2	0	1
375016	1678	27360856776000	27641	13660	3	0	1
375017	1874	36139000	27641	13660	4	0	2
375019	1874	36145000	27641	13660	6	0	2
375020	1874	36148000	27641	13660	7	0	2
375021	1874	36151000	27641	13660	8	0	2
375022	1874	36153000	27641	13660	9	0	2
375024	1874	36157000	27641	13660	11	0	2
375061	1678	27360856777000	27645	13661	0	0	1
375062	1474	15030643000043	27645	13661	1	0	29
375063	1874	36160000	27645	13661	2	0	2
375064	1874	36162000	27645	13661	3	0	2
375070	1678	27360856779000	27647	13662	1	0	1
375071	1874	36164000	27647	13662	2	0	2
375072	1874	36166000	27647	13662	3	0	2
375073	1874	36169000	27647	13662	4	0	2
375074	1874	36172000	27647	13662	5	0	2
375076	1678	27360856781000	27648	13663	1	0	1
375077	1874	36174000	27648	13663	2	0	2
375078	1874	36176000	27648	13663	3	0	2
375079	1874	36179000	27648	13663	4	0	2
375081	1474	15030643000043	27650	13664	0	0	29
375082	1474	15030643000043	27650	13664	1	0	29
375083	1678	27360856782000	27650	13664	2	0	1
375084	1678	27360856783000	27650	13664	3	0	1
375085	2314	179869000000	27650	13664	4	0	4
375087	1874	36184000	27650	13664	6	0	2
375088	1874	36186000	27650	13664	7	0	2
375091	1474	15030643000043	27651	13633	0	0	\N
375092	1474	15030643000043	27651	13633	1	0	\N
375093	38	66539225269421	27651	13633	2	0	\N
375094	969	506877361461968	27651	13633	3	0	\N
375095	2068	2000099000000	27651	13633	4	0	\N
375096	1678	27360856735000	27651	13633	5	0	\N
375097	1678	27360856736000	27651	13633	6	0	\N
375098	1678	27360856737000	27651	13633	7	0	\N
375099	1678	27360856738000	27651	13633	8	0	\N
375100	1678	27360856739000	27651	13633	9	0	\N
375101	1678	27360856740000	27651	13633	10	0	\N
375102	2314	179869000000	27651	13633	11	0	\N
375103	1678	27360856741000	27651	13633	12	0	\N
375104	1089	908319888814612	27651	13633	13	0	\N
375105	1209	612861528535553	27651	13633	14	0	\N
375106	1335	1707793141873126	27651	13633	15	0	\N
375107	38	66575050395110	27651	13633	17	0	\N
375108	969	507150018330014	27651	13633	18	0	\N
375109	1089	908808487586029	27651	13633	19	0	\N
375110	1209	613191195862646	27651	13633	20	0	\N
375111	1335	1708711789192456	27651	13633	21	0	\N
375112	1678	27360856742000	27651	13633	23	0	\N
375113	1678	27360856743000	27651	13633	24	0	\N
375114	1678	27360856744000	27651	13633	25	0	\N
375115	1678	27360856745000	27651	13633	26	0	\N
375116	1678	27360856746000	27651	13633	27	0	\N
375117	1678	27360856747000	27651	13633	28	0	\N
375118	1678	27360856748000	27651	13633	29	0	\N
375119	1678	27360856749000	27651	13633	30	0	\N
375120	1678	27360856750000	27651	13633	31	0	\N
375121	1678	27360856751000	27651	13633	32	0	\N
375122	1678	27360856752000	27651	13633	33	0	\N
375123	1678	27360856753000	27651	13633	34	0	\N
375124	1678	27360856754000	27651	13633	35	0	\N
375125	1678	27360856755000	27651	13633	36	0	\N
375126	1678	27360856756000	27651	13633	37	0	\N
375127	1678	27360856757000	27651	13633	38	0	\N
375128	1678	27360856758000	27651	13633	39	0	\N
375129	1678	27360856759000	27651	13633	40	0	\N
375130	1678	27360856760000	27651	13633	41	0	\N
375131	1678	27360856761000	27651	13633	42	0	\N
375132	1678	27360856762000	27651	13633	43	0	\N
375133	1678	27360856763000	27651	13633	44	0	\N
375134	1678	27360856764000	27651	13633	45	0	\N
375135	1678	27360856765000	27651	13633	46	0	\N
375136	1678	27360856766000	27651	13633	47	0	\N
375137	1678	27360856767000	27651	13633	48	0	\N
375138	1678	27360856768000	27651	13633	49	0	\N
375139	1678	27360856769000	27651	13633	50	0	\N
375140	1678	27360856770000	27651	13633	51	0	\N
375141	1678	27360856771000	27651	13633	53	0	\N
375142	1678	27360856772000	27651	13633	54	0	\N
375143	1678	27360856773000	27651	13633	55	0	\N
375144	1474	15030643000043	27651	13633	56	0	\N
375145	1678	27360856774000	27651	13633	57	0	\N
375146	1678	27360856775000	27651	13633	58	0	\N
375147	1678	27360856776000	27651	13633	59	0	\N
375148	1678	27360856777000	27651	13633	60	0	\N
375149	1678	27360856778000	27651	13633	61	0	\N
375150	1678	27360856779000	27651	13633	62	0	\N
375151	1678	27360856780000	27651	13633	63	0	\N
375152	1678	27360856781000	27651	13633	64	0	\N
375153	1678	27360856782000	27651	13633	65	0	\N
375154	1678	27360856783000	27651	13633	66	0	\N
375155	1474	15030643000043	27651	13633	67	0	\N
375156	1635	11000000	27651	13633	68	0	\N
375157	1874	35949000	27651	13633	69	0	\N
375158	1874	35951000	27651	13633	70	0	\N
375159	1874	35953000	27651	13633	71	0	\N
375160	1874	35956000	27651	13633	72	0	\N
375161	1874	35959000	27651	13633	73	0	\N
375162	1874	35961000	27651	13633	74	0	\N
375163	1874	35963000	27651	13633	75	0	\N
375164	1874	35965000	27651	13633	76	0	\N
375165	1874	35967000	27651	13633	77	0	\N
375166	1874	35969000	27651	13633	78	0	\N
375167	1874	35971000	27651	13633	79	0	\N
375168	1874	35973000	27651	13633	80	0	\N
375169	1874	35975000	27651	13633	81	0	\N
375170	1874	35977000	27651	13633	82	0	\N
375171	1874	35979000	27651	13633	83	0	\N
375172	1874	35981000	27651	13633	84	0	\N
375173	1874	35983000	27651	13633	85	0	\N
375174	1874	35985000	27651	13633	86	0	\N
375175	1874	35987000	27651	13633	87	0	\N
375176	1874	35989000	27651	13633	88	0	\N
375177	1874	35991000	27651	13633	89	0	\N
375178	1874	35993000	27651	13633	90	0	\N
375179	1874	35995000	27651	13633	91	0	\N
375180	1874	35997000	27651	13633	92	0	\N
375181	1874	35999000	27651	13633	93	0	\N
375182	1874	36001000	27651	13633	94	0	\N
375183	1874	36003000	27651	13633	95	0	\N
375184	1874	36005000	27651	13633	96	0	\N
375185	1874	36007000	27651	13633	97	0	\N
375186	1874	36009000	27651	13633	98	0	\N
375187	1874	36011000	27651	13633	99	0	\N
375188	1874	36013000	27651	13633	100	0	\N
375189	1874	36015000	27651	13633	101	0	\N
375190	1874	36017000	27651	13633	102	0	\N
375191	1874	36019000	27651	13633	103	0	\N
375192	1874	36021000	27651	13633	104	0	\N
375193	1874	36023000	27651	13633	105	0	\N
375194	1874	36025000	27651	13633	106	0	\N
375195	1874	36027000	27651	13633	107	0	\N
375196	1874	36029000	27651	13633	108	0	\N
375197	1874	36031000	27651	13633	109	0	\N
375198	1874	36033000	27651	13633	110	0	\N
375199	1874	36035000	27651	13633	111	0	\N
375200	1874	36037000	27651	13633	112	0	\N
375201	1874	36039000	27651	13633	113	0	\N
375202	1874	36041000	27651	13633	114	0	\N
375203	1874	36043000	27651	13633	115	0	\N
375204	1874	36045000	27651	13633	116	0	\N
375205	1874	36047000	27651	13633	117	0	\N
375206	1874	36049000	27651	13633	118	0	\N
375207	1874	36051000	27651	13633	119	0	\N
375208	1874	36054000	27651	13633	120	0	\N
375209	1874	36057000	27651	13633	121	0	\N
375210	1874	36060000	27651	13633	122	0	\N
375211	1874	36063000	27651	13633	123	0	\N
375212	1874	36066000	27651	13633	124	0	\N
375213	1874	36069000	27651	13633	125	0	\N
375214	1474	15030643000043	27652	13664	0	0	\N
375215	1474	15030643000043	27652	13664	1	0	\N
375216	1678	27360856782000	27652	13664	2	0	\N
375217	1678	27360856783000	27652	13664	3	0	\N
375218	2314	179869000000	27652	13664	4	0	\N
375219	1474	15030643000043	27652	13664	5	0	\N
375220	1874	36184000	27652	13664	6	0	\N
375221	1874	36186000	27652	13664	7	0	\N
375222	1874	36189000	27652	13664	8	0	\N
375223	1874	36192000	27652	13664	9	0	\N
375224	1678	27360856784000	27653	13665	0	0	1
375227	1678	27360856785000	27654	13666	0	0	\N
375228	1874	36199000	27654	13666	1	0	\N
375229	1874	36202000	27654	13666	2	0	\N
375236	1678	27360856786000	27657	13667	0	0	\N
375237	1874	36205000	27657	13667	1	0	\N
375238	1874	36207000	27657	13667	2	0	\N
375242	1678	27360856787000	27659	13668	0	0	\N
375243	1874	36209000	27659	13668	1	0	\N
375244	1874	36212000	27659	13668	2	0	\N
375259	1678	27360856790000	27663	13671	0	0	\N
375260	1678	27360856791000	27663	13671	1	0	\N
375261	1460	0	27663	13671	2	0	\N
375262	1874	36224000	27663	13671	3	0	\N
375263	1874	36226000	27663	13671	4	0	\N
375264	2172	199001000	27663	13671	5	0	\N
375265	1874	36229000	27663	13671	6	0	\N
375266	1874	36232000	27663	13671	7	0	\N
375273	1678	27360856793000	27666	13673	0	0	\N
375274	1874	36240000	27666	13673	1	0	\N
375275	1874	36242000	27666	13673	2	0	\N
375276	1678	27360856793000	27667	13673	0	0	\N
375277	1874	36240000	27667	13673	1	0	\N
375278	1874	36242000	27667	13673	2	0	\N
375282	1678	27360856794000	27669	13674	0	0	\N
375283	1874	36245000	27669	13674	1	0	\N
375284	1874	36247000	27669	13674	2	0	\N
375285	1678	27360856794000	27670	13674	0	0	\N
375286	1874	36245000	27670	13674	1	0	\N
375287	1874	36247000	27670	13674	2	0	\N
375288	1678	27360856795000	27671	13675	0	0	\N
375289	1874	36250000	27671	13675	1	0	\N
375290	1874	36252000	27671	13675	2	0	\N
375291	1874	36250000	27672	13675	0	0	\N
375292	1874	36252000	27672	13675	1	0	\N
375293	1678	27360856795000	27673	13675	0	0	\N
375294	1874	36250000	27673	13675	1	0	\N
375295	1874	36252000	27673	13675	2	0	\N
375296	1678	27360856795000	27674	13675	0	0	\N
375297	1874	36250000	27674	13675	1	0	\N
375298	1874	36252000	27674	13675	2	0	\N
375299	1678	27360856795000	27675	13675	0	0	\N
375300	1874	36250000	27675	13675	1	0	\N
375301	1874	36252000	27675	13675	2	0	\N
375302	1678	27360856794000	27676	13674	0	0	\N
375303	1678	27360856795000	27676	13674	1	0	\N
375304	1874	36245000	27676	13674	2	0	\N
375305	1874	36247000	27676	13674	3	0	\N
375312	1678	27360856797000	27679	13677	0	0	\N
375313	1874	36259000	27679	13677	1	0	\N
375322	1678	27360856784000	27683	13634	0	0	\N
375323	1678	27360856785000	27683	13634	1	0	\N
375324	1678	27360856786000	27683	13634	2	0	\N
375325	1678	27360856787000	27683	13634	3	0	\N
375326	1678	27360856788000	27683	13634	4	0	\N
375327	1678	27360856789000	27683	13634	5	0	\N
375328	1678	27360856790000	27683	13634	6	0	\N
375329	1678	27360856791000	27683	13634	7	0	\N
375330	1678	27360856792000	27683	13634	8	0	\N
375331	1678	27360856793000	27683	13634	9	0	\N
375332	1678	27360856794000	27683	13634	10	0	\N
375333	1678	27360856795000	27683	13634	11	0	\N
375334	1678	27360856796000	27683	13634	12	0	\N
375335	1678	27360856797000	27683	13634	13	0	\N
375336	1678	27360856798000	27683	13634	14	0	\N
375337	1678	27360856799000	27683	13634	15	0	\N
375338	1874	36071000	27683	13634	16	0	\N
375339	1874	36073000	27683	13634	17	0	\N
375340	1460	0	27683	13634	18	0	\N
375341	2172	199001000	27683	13634	19	0	\N
375342	1874	36076000	27683	13634	20	0	\N
375343	1874	36079000	27683	13634	21	0	\N
375344	1874	36082000	27683	13634	22	0	\N
375345	1874	36085000	27683	13634	23	0	\N
375346	1874	36088000	27683	13634	24	0	\N
375347	1874	36091000	27683	13634	25	0	\N
375348	1874	36094000	27683	13634	26	0	\N
375349	1874	36097000	27683	13634	27	0	\N
375350	1874	36100000	27683	13634	28	0	\N
375351	1874	36103000	27683	13634	29	0	\N
375352	1874	36106000	27683	13634	30	0	\N
375353	1874	36109000	27683	13634	31	0	\N
375354	1874	36112000	27683	13634	32	0	\N
375355	1874	36115000	27683	13634	33	0	\N
375356	1874	36118000	27683	13634	34	0	\N
375357	1874	36120000	27683	13634	35	0	\N
375358	1874	36122000	27683	13634	36	0	\N
375359	1874	36124000	27683	13634	37	0	\N
375360	1874	36126000	27683	13634	38	0	\N
375230	1678	27360856785000	27655	13666	0	0	1
375231	1874	36199000	27655	13666	1	0	2
375232	1874	36202000	27655	13666	2	0	2
375233	1678	27360856786000	27656	13667	0	0	1
375234	1874	36205000	27656	13667	1	0	2
375239	1678	27360856787000	27658	13668	0	0	1
375240	1874	36209000	27658	13668	1	0	2
375241	1874	36212000	27658	13668	2	0	2
375245	1678	27360856788000	27660	13669	0	0	1
375246	1874	36214000	27660	13669	1	0	2
375248	1678	27360856789000	27661	13670	0	0	1
375249	1874	36219000	27661	13670	1	0	2
375250	1874	36222000	27661	13670	2	0	2
375251	1678	27360856790000	27662	13671	0	0	1
375253	1460	0	27662	13671	2	0	0
375254	1874	36224000	27662	13671	3	0	2
375255	1874	36226000	27662	13671	4	0	2
375256	2172	199001000	27662	13671	5	0	2
375257	1874	36229000	27662	13671	6	0	2
375267	1678	27360856792000	27664	13672	0	0	1
375268	1874	36235000	27664	13672	1	0	2
375269	1874	36237000	27664	13672	2	0	2
375270	1678	27360856793000	27665	13673	0	0	1
375271	1874	36240000	27665	13673	1	0	2
375279	1678	27360856794000	27668	13674	0	0	1
375280	1874	36245000	27668	13674	1	0	2
375281	1874	36247000	27668	13674	2	0	2
375306	1678	27360856795000	27677	13675	0	0	1
375308	1874	36252000	27677	13675	2	0	2
375309	1678	27360856796000	27678	13676	0	0	1
375310	1874	36254000	27678	13676	1	0	2
375311	1874	36257000	27678	13676	2	0	2
375314	1678	27360856797000	27680	13677	0	0	1
375316	1678	27360856798000	27681	13678	0	0	1
375317	1874	36261000	27681	13678	1	0	2
375318	1874	36264000	27681	13678	2	0	2
375319	1678	27360856799000	27682	13679	0	0	1
375320	1874	36266000	27682	13679	1	0	2
375361	1874	36128000	27683	13634	39	0	\N
375362	1874	36130000	27683	13634	40	0	\N
375363	1874	36132000	27683	13634	41	0	\N
375364	1874	36134000	27683	13634	42	0	\N
375365	1874	36137000	27683	13634	43	0	\N
375366	1874	36140000	27683	13634	44	0	\N
375367	1874	36143000	27683	13634	45	0	\N
375368	1874	36146000	27683	13634	46	0	\N
375369	1874	36149000	27683	13634	47	0	\N
375370	1874	36152000	27683	13634	48	0	\N
375371	1874	36155000	27683	13634	49	0	\N
375372	1874	36158000	27683	13634	50	0	\N
375373	1874	36161000	27683	13634	51	0	\N
375374	1874	36164000	27683	13634	53	0	\N
375375	1874	36167000	27683	13634	54	0	\N
375376	1874	36170000	27683	13634	55	0	\N
375377	1874	36173000	27683	13634	56	0	\N
375378	1874	36176000	27683	13634	57	0	\N
375379	1874	36179000	27683	13634	58	0	\N
375380	1874	36182000	27683	13634	59	0	\N
375381	1874	36185000	27683	13634	60	0	\N
375382	1874	36188000	27683	13634	61	0	\N
375383	1874	36191000	27683	13634	62	0	\N
375384	1874	36194000	27683	13634	63	0	\N
375385	1874	36197000	27683	13634	64	0	\N
375386	1874	36200000	27683	13634	65	0	\N
375387	1874	36203000	27683	13634	66	0	\N
375388	1874	36206000	27683	13634	67	0	\N
375389	1874	36209000	27683	13634	68	0	\N
375390	1874	36212000	27683	13634	69	0	\N
375391	1874	36215000	27683	13634	70	0	\N
375392	1874	36218000	27683	13634	71	0	\N
375393	1874	36221000	27683	13634	72	0	\N
375394	1874	36224000	27683	13634	73	0	\N
375395	1874	36227000	27683	13634	74	0	\N
375396	1874	36230000	27683	13634	75	0	\N
375397	1874	36233000	27683	13634	76	0	\N
375398	1874	36236000	27683	13634	77	0	\N
375399	1474	24390643000043	27685	13681	0	0	\N
375400	1678	27360856800000	27685	13681	1	0	\N
375401	1678	27360856801000	27685	13681	2	0	\N
375402	1874	36271000	27685	13681	3	0	\N
375403	1874	36273000	27685	13681	4	0	\N
375404	1874	36276000	27685	13681	5	0	\N
375405	1874	36279000	27685	13681	6	0	\N
375413	1678	27360856802000	27687	13682	0	0	\N
375414	1678	27360856803000	27687	13682	1	0	\N
375415	1874	36282000	27687	13682	2	0	\N
375416	1874	36284000	27687	13682	3	0	\N
375417	1874	36286000	27687	13682	4	0	\N
375418	1874	36289000	27687	13682	5	0	\N
375425	1678	27360856804000	27689	13683	0	0	\N
375426	1874	36292000	27689	13683	1	0	\N
375427	1874	36294000	27689	13683	2	0	\N
375428	1678	27360856804000	27690	13683	0	0	\N
375429	1874	36292000	27690	13683	1	0	\N
375430	1874	36294000	27690	13683	2	0	\N
375431	1678	27360856804000	27691	13683	0	0	\N
375432	1874	36292000	27691	13683	1	0	\N
375433	1874	36294000	27691	13683	2	0	\N
375440	1678	27360856806000	27694	13685	0	0	\N
375441	1874	36301000	27694	13685	1	0	\N
375444	1678	27360856807000	27696	13686	0	0	\N
375445	1874	36303000	27696	13686	1	0	\N
375448	1474	23670631000043	27698	13513	0	0	\N
375449	38	66539225269421	27698	13513	1	0	\N
375450	969	506877361461968	27698	13513	2	0	\N
375451	1693	15671039570272	27698	13513	3	0	\N
375452	2068	2000099000000	27698	13513	4	0	\N
375453	1089	908319888814612	27698	13513	5	0	\N
375454	1209	612861528535553	27698	13513	6	0	\N
375455	1335	1707793141873126	27698	13513	7	0	\N
375456	38	66575050395110	27698	13513	9	0	\N
375457	969	507150018330014	27698	13513	10	0	\N
375458	1089	908808487586029	27698	13513	11	0	\N
375459	1209	613191195862646	27698	13513	12	0	\N
375460	1335	1708711789192456	27698	13513	13	0	\N
375461	1874	35029000	27698	13513	15	0	\N
375462	1874	35030000	27698	13513	16	0	\N
375463	2346	388000000	27698	13513	17	0	\N
375464	383	66846781394804	27698	13513	18	0	\N
375465	1874	35031000	27698	13513	19	0	\N
375466	2358	50100000000	27698	13513	20	0	\N
375467	1460	0	27698	13513	21	0	\N
375468	327	66190546738816	27698	13513	22	0	\N
375469	1635	11000000	27698	13513	23	0	\N
375470	652	66846781394804	27698	13513	24	0	\N
375471	266	66233761394804	27698	13513	25	0	\N
375472	352	66846781394804	27698	13513	26	0	\N
375473	191	66846781394804	27698	13513	27	0	\N
375474	520	66846781394804	27698	13513	28	0	\N
375475	421	66846781394804	27698	13513	29	0	\N
375476	534	66846781394804	27698	13513	30	0	\N
375477	680	66846781394804	27698	13513	31	0	\N
375478	82	66846781394804	27698	13513	32	0	\N
375479	309	66846781394804	27698	13513	33	0	\N
375480	361	66196779394804	27698	13513	34	0	\N
375481	731	2025660042156	27698	13513	35	0	\N
375482	2172	199001000	27698	13513	36	0	\N
375483	452	66846781394804	27698	13513	37	0	\N
375484	275	66846781394804	27698	13513	38	0	\N
375485	402	66846781394804	27698	13513	39	0	\N
375486	2181	845033200907	27698	13513	40	0	\N
375487	458	66192943638921	27698	13513	41	0	\N
375488	690	66846781394804	27698	13513	42	0	\N
375489	391	66845671394804	27698	13513	43	0	\N
375490	1772	6067000384008	27698	13513	44	0	\N
375491	570	66846781394804	27698	13513	45	0	\N
375492	390	66846781394804	27698	13513	46	0	\N
375493	569	66846781394804	27698	13513	47	0	\N
375494	894	310759461099813	27698	13513	48	0	\N
375495	342	66191649914597	27698	13513	49	0	\N
375496	1811	2317423500306	27698	13513	50	0	\N
375408	1678	27360856801000	27686	13681	2	0	1
375409	1874	36271000	27686	13681	3	0	2
375410	1874	36273000	27686	13681	4	0	2
375411	1874	36276000	27686	13681	5	0	2
375412	1874	36279000	27686	13681	6	0	2
375420	1678	27360856803000	27688	13682	1	0	1
375421	1874	36282000	27688	13682	2	0	2
375422	1874	36284000	27688	13682	3	0	2
375423	1874	36286000	27688	13682	4	0	2
375424	1874	36289000	27688	13682	5	0	2
375435	1874	36292000	27692	13683	1	0	2
375436	1874	36294000	27692	13683	2	0	2
375437	1678	27360856805000	27693	13684	0	0	1
375438	1874	36296000	27693	13684	1	0	2
375442	1678	27360856806000	27695	13685	0	0	1
375443	1874	36301000	27695	13685	1	0	2
375446	1678	27360856807000	27697	13686	0	0	1
375447	1874	36303000	27697	13686	1	0	2
375497	499	66846781394804	27698	13513	51	0	\N
375498	710	5064150105589	27698	13513	52	0	\N
375499	120	66191449337183	27698	13513	53	0	\N
375500	663	66846781394804	27698	13513	54	0	\N
375501	1030	912533541116414	27698	13513	55	0	\N
375502	238	66179713200746	27698	13513	56	0	\N
375503	312	66190546738816	27698	13513	57	0	\N
375504	251	66846781394804	27698	13513	58	0	\N
375505	320	66564769550207	27698	13513	59	0	\N
375506	354	66192943638921	27698	13513	60	0	\N
375507	1276	1715715512165594	27698	13513	61	0	\N
375508	1874	35032000	27698	13513	62	0	\N
375509	194	66846781394804	27698	13513	63	0	\N
375510	206	66846781394804	27698	13513	64	0	\N
375511	636	66190546738816	27698	13513	65	0	\N
375512	399	66846781394804	27698	13513	66	0	\N
375513	721	2025660042156	27698	13513	67	0	\N
375514	105	66846781394804	27698	13513	68	0	\N
375515	146	66846781394804	27698	13513	69	0	\N
375516	611	66846781394804	27698	13513	70	0	\N
375517	500	66846781394804	27698	13513	71	0	\N
375518	315	66000001000000	27698	13513	72	0	\N
375519	587	66846781394804	27698	13513	73	0	\N
375520	138	66846781394804	27698	13513	74	0	\N
375521	114	66070347649394	27698	13513	75	0	\N
375522	443	66190935859010	27698	13513	76	0	\N
375523	649	66190636998665	27698	13513	77	0	\N
375524	578	66190636998665	27698	13513	78	0	\N
375525	205	66846781394804	27698	13513	79	0	\N
375526	504	66233711394804	27698	13513	80	0	\N
375527	339	66846781394804	27698	13513	81	0	\N
375528	301	66071019153477	27698	13513	82	0	\N
375529	408	66846781394804	27698	13513	83	0	\N
375530	601	66846781394804	27698	13513	84	0	\N
375531	1821	845652594543	27698	13513	85	0	\N
375532	450	66846781394804	27698	13513	86	0	\N
375533	10	32591980141866	27698	13513	87	0	\N
375534	322	66846781394804	27698	13513	88	0	\N
375535	366	66190546738816	27698	13513	89	0	\N
375536	2017	845380729203	27698	13513	90	0	\N
375537	283	66070028153477	27698	13513	91	0	\N
375538	308	66846781394804	27698	13513	92	0	\N
375539	392	66846781394804	27698	13513	93	0	\N
375540	186	66846781394804	27698	13513	94	0	\N
375541	180	66846781394804	27698	13513	95	0	\N
375542	165	66190636998665	27698	13513	96	0	\N
375543	237	66190636998665	27698	13513	97	0	\N
375544	2164	845442200907	27698	13513	98	0	\N
375545	1678	27360856808000	27699	13687	0	0	\N
375546	1678	27360856809000	27699	13687	1	0	\N
375547	1678	27360856810000	27699	13687	2	0	\N
375548	1874	36305000	27699	13687	3	0	\N
375549	1874	36307000	27699	13687	4	0	\N
375550	1874	36309000	27699	13687	5	0	\N
375551	1678	27360856808000	27700	13687	0	0	\N
375552	1678	27360856809000	27700	13687	1	0	\N
375553	1678	27360856810000	27700	13687	2	0	\N
375554	1874	36305000	27700	13687	3	0	\N
375555	1874	36307000	27700	13687	4	0	\N
375556	1874	36309000	27700	13687	5	0	\N
375563	1678	27360856808000	27702	13687	0	0	\N
375564	1678	27360856809000	27702	13687	1	0	\N
375565	1678	27360856810000	27702	13687	2	0	\N
375566	1874	36305000	27702	13687	3	0	\N
375567	1874	36307000	27702	13687	4	0	\N
375568	1874	36309000	27702	13687	5	0	\N
375587	1678	27360856815000	27705	13689	0	0	\N
375588	1678	27360856816000	27705	13689	1	0	\N
375589	2314	248869000000	27705	13689	2	0	\N
375590	2314	317869000000	27705	13689	3	0	\N
375591	1678	27360856817000	27705	13689	4	0	\N
375592	2314	386869000000	27705	13689	5	0	\N
375593	2314	418869000000	27705	13689	6	0	\N
375594	1874	36319000	27705	13689	7	0	\N
375595	1874	36321000	27705	13689	8	0	\N
375596	1874	36323000	27705	13689	9	0	\N
375597	1678	27360856815000	27706	13689	0	0	\N
375598	1678	27360856816000	27706	13689	1	0	\N
375599	2314	248869000000	27706	13689	2	0	\N
375600	2314	317869000000	27706	13689	3	0	\N
375601	1678	27360856817000	27706	13689	4	0	\N
375602	2314	386869000000	27706	13689	5	0	\N
375603	2314	418869000000	27706	13689	6	0	\N
375604	1874	36319000	27706	13689	7	0	\N
375605	1874	36321000	27706	13689	8	0	\N
375606	1874	36323000	27706	13689	9	0	\N
375619	1678	27360856823000	27710	13692	0	0	\N
375620	1874	36335000	27710	13692	1	0	\N
375621	1678	27360856823000	27711	13692	0	0	\N
375622	1874	36335000	27711	13692	1	0	\N
375627	1678	27360856824000	27713	13693	0	0	\N
375628	1678	27360856825000	27713	13693	1	0	\N
375629	1874	36337000	27713	13693	2	0	\N
375630	1874	36339000	27713	13693	3	0	\N
375631	1678	27360856826000	27714	13694	0	0	\N
375632	1874	36341000	27714	13694	1	0	\N
375559	1678	27360856810000	27701	13687	2	0	1
375560	1874	36305000	27701	13687	3	0	2
375561	1874	36307000	27701	13687	4	0	2
375562	1874	36309000	27701	13687	5	0	2
375569	1678	27360856811000	27703	13688	0	0	1
375571	1678	27360856813000	27703	13688	2	0	1
375572	1678	27360856814000	27703	13688	3	0	1
375573	1874	36311000	27703	13688	4	0	2
375574	1874	36313000	27703	13688	5	0	2
375575	1874	36315000	27703	13688	6	0	2
375577	1678	27360856815000	27704	13689	0	0	1
375578	1678	27360856816000	27704	13689	1	0	1
375579	2314	248869000000	27704	13689	2	0	4
375580	2314	317869000000	27704	13689	3	0	4
375582	2314	386869000000	27704	13689	5	0	4
375583	2314	418869000000	27704	13689	6	0	4
375584	1874	36319000	27704	13689	7	0	2
375585	1874	36321000	27704	13689	8	0	2
375586	1874	36323000	27704	13689	9	0	2
375608	1678	27360856819000	27707	13690	1	0	1
375609	1874	36325000	27707	13690	2	0	2
375610	1874	36327000	27707	13690	3	0	2
375611	1678	27360856820000	27708	13691	0	0	1
375612	1678	27360856821000	27708	13691	1	0	1
375614	1874	36329000	27708	13691	3	0	2
375615	1874	36331000	27708	13691	4	0	2
375616	1874	36333000	27708	13691	5	0	2
375617	1678	27360856823000	27709	13692	0	0	1
375623	1678	27360856824000	27712	13693	0	0	1
375624	1678	27360856825000	27712	13693	1	0	1
375625	1874	36337000	27712	13693	2	0	2
375626	1874	36339000	27712	13693	3	0	2
375635	1678	27360856826000	27716	13694	0	0	\N
375636	1874	36341000	27716	13694	1	0	\N
375639	1678	27360856827000	27718	13695	0	0	\N
375640	1874	36343000	27718	13695	1	0	\N
375641	1678	27360856827000	27719	13695	0	0	\N
375642	1874	36343000	27719	13695	1	0	\N
375643	1474	15030643000043	27720	13610	0	0	\N
375644	1474	15030643000043	27720	13610	1	0	\N
375645	1474	24390643000043	27720	13610	2	0	\N
375646	2314	69869000000	27720	13610	3	0	\N
375647	38	66539225269421	27720	13610	4	0	\N
375648	969	506877361461968	27720	13610	5	0	\N
375649	2314	138869000000	27720	13610	6	0	\N
375650	2068	2000099000000	27720	13610	7	0	\N
375651	1678	27360856703000	27720	13610	8	0	\N
375652	1678	27360856704000	27720	13610	9	0	\N
375653	2314	207869000000	27720	13610	10	0	\N
375654	2314	386869000000	27720	13610	11	0	\N
375655	1444	14587917329999	27720	13610	12	0	\N
375656	1778	7424464345059	27720	13610	13	0	\N
375657	2314	418869000000	27720	13610	14	0	\N
375658	1089	908319888814612	27720	13610	15	0	\N
375659	1209	612861528535553	27720	13610	16	0	\N
375660	1335	1707793141873126	27720	13610	17	0	\N
375661	38	66575050395110	27720	13610	19	0	\N
375662	969	507150018330014	27720	13610	20	0	\N
375663	1089	908808487586029	27720	13610	21	0	\N
375664	1209	613191195862646	27720	13610	22	0	\N
375665	1335	1708711789192456	27720	13610	23	0	\N
375666	1678	27360856705000	27720	13610	25	0	\N
375667	1678	27360856706000	27720	13610	26	0	\N
375668	1678	27360856707000	27720	13610	27	0	\N
375669	1678	27360856708000	27720	13610	28	0	\N
375670	1678	27360856709000	27720	13610	29	0	\N
375671	1678	27360856710000	27720	13610	30	0	\N
375672	1678	27360856711000	27720	13610	31	0	\N
375673	1678	27360856712000	27720	13610	32	0	\N
375674	1678	27360856713000	27720	13610	33	0	\N
375675	1678	27360856714000	27720	13610	34	0	\N
375676	1678	27360856715000	27720	13610	35	0	\N
375677	1678	27360856716000	27720	13610	36	0	\N
375678	1678	27360856717000	27720	13610	37	0	\N
375679	1678	27360856718000	27720	13610	38	0	\N
375680	1678	27360856719000	27720	13610	39	0	\N
375681	1678	27360856720000	27720	13610	40	0	\N
375682	1678	27360856721000	27720	13610	41	0	\N
375683	1678	27360856722000	27720	13610	42	0	\N
375684	1678	27360856723000	27720	13610	43	0	\N
375685	1678	27360856724000	27720	13610	44	0	\N
375686	1678	27360856725000	27720	13610	45	0	\N
375687	1678	27360856726000	27720	13610	46	0	\N
375688	1678	27360856727000	27720	13610	47	0	\N
375689	1678	27360856728000	27720	13610	48	0	\N
375690	1678	27360856729000	27720	13610	49	0	\N
375691	1678	27360856730000	27720	13610	50	0	\N
375692	1678	27360856731000	27720	13610	51	0	\N
375693	1678	27360856732000	27720	13610	52	0	\N
375694	1678	27360856733000	27720	13610	53	0	\N
375695	1678	27360856734000	27720	13610	54	0	\N
375696	1678	27360856735000	27720	13610	55	0	\N
375697	1678	27360856736000	27720	13610	56	0	\N
375698	1678	27360856737000	27720	13610	57	0	\N
375699	1678	27360856738000	27720	13610	58	0	\N
375700	1678	27360856739000	27720	13610	59	0	\N
375701	1678	27360856740000	27720	13610	60	0	\N
375702	1678	27360856741000	27720	13610	61	0	\N
375703	1678	27360856742000	27720	13610	62	0	\N
375704	1678	27360856743000	27720	13610	63	0	\N
375705	1678	27360856744000	27720	13610	64	0	\N
375706	1678	27360856745000	27720	13610	65	0	\N
375707	1678	27360856746000	27720	13610	66	0	\N
375708	1678	27360856747000	27720	13610	67	0	\N
375709	1678	27360856748000	27720	13610	68	0	\N
375710	1678	27360856749000	27720	13610	69	0	\N
375711	1678	27360856750000	27720	13610	71	0	\N
375712	1678	27360856751000	27720	13610	72	0	\N
375713	1678	27360856752000	27720	13610	73	0	\N
375714	1678	27360856753000	27720	13610	74	0	\N
375715	1678	27360856754000	27720	13610	75	0	\N
375716	1678	27360856755000	27720	13610	76	0	\N
375717	1678	27360856756000	27720	13610	77	0	\N
375718	1678	27360856757000	27720	13610	78	0	\N
375719	1678	27360856758000	27720	13610	79	0	\N
375720	1678	27360856759000	27720	13610	80	0	\N
375721	1678	27360856760000	27720	13610	81	0	\N
375722	1678	27360856761000	27720	13610	82	0	\N
375723	1678	27360856762000	27720	13610	83	0	\N
375724	1678	27360856763000	27720	13610	84	0	\N
375725	1678	27360856764000	27720	13610	85	0	\N
375726	1678	27360856765000	27720	13610	86	0	\N
375727	1678	27360856766000	27720	13610	87	0	\N
375728	1678	27360856767000	27720	13610	88	0	\N
375729	1678	27360856768000	27720	13610	89	0	\N
375730	1678	27360856769000	27720	13610	90	0	\N
375731	1678	27360856770000	27720	13610	91	0	\N
375732	1678	27360856771000	27720	13610	92	0	\N
375733	1678	27360856772000	27720	13610	93	0	\N
375734	1678	27360856773000	27720	13610	94	0	\N
375735	1474	24390643000043	27720	13610	95	0	\N
375736	1678	27360856774000	27720	13610	96	0	\N
375737	1678	27360856775000	27720	13610	97	0	\N
375738	1678	27360856776000	27720	13610	98	0	\N
375739	1678	27360856777000	27720	13610	99	0	\N
375740	1678	27360856778000	27720	13610	100	0	\N
375741	1678	27360856779000	27720	13610	101	0	\N
375742	1678	27360856780000	27720	13610	102	0	\N
375743	1678	27360856781000	27720	13610	103	0	\N
375744	1678	27360856782000	27720	13610	104	0	\N
375745	1678	27360856783000	27720	13610	105	0	\N
375746	1678	27360856784000	27720	13610	106	0	\N
375747	1678	27360856785000	27720	13610	107	0	\N
375748	1678	27360856786000	27720	13610	108	0	\N
375749	1678	27360856787000	27720	13610	109	0	\N
375750	1678	27360856788000	27720	13610	110	0	\N
375751	1678	27360856789000	27720	13610	111	0	\N
375752	1678	27360856790000	27720	13610	112	0	\N
375753	1678	27360856791000	27720	13610	113	0	\N
375754	1678	27360856792000	27720	13610	114	0	\N
375755	1678	27360856793000	27720	13610	115	0	\N
375756	1678	27360856794000	27720	13610	116	0	\N
375757	1678	27360856795000	27720	13610	117	0	\N
375758	1678	27360856796000	27720	13610	118	0	\N
375759	1678	27360856797000	27720	13610	119	0	\N
375760	1678	27360856798000	27720	13610	120	0	\N
375761	1678	27360856799000	27720	13610	121	0	\N
375762	1678	27360856800000	27720	13610	122	0	\N
375763	1678	27360856801000	27720	13610	123	0	\N
375764	1678	27360856802000	27720	13610	124	0	\N
375765	1678	27360856803000	27720	13610	125	0	\N
375768	1678	27360856828000	27722	13696	0	0	\N
375637	1678	27360856827000	27717	13695	0	0	1
375638	1874	36343000	27717	13695	1	0	2
375766	1678	27360856828000	27721	13696	0	0	1
375767	1874	36345000	27721	13696	1	0	2
375769	1874	36345000	27722	13696	1	0	\N
375770	1678	27360856828000	27723	13696	0	0	\N
375771	1874	36345000	27723	13696	1	0	\N
375775	1678	27360856830000	27725	13698	0	0	\N
375776	1678	27360856831000	27725	13698	1	0	\N
375777	1874	36349000	27725	13698	2	0	\N
375778	1874	36351000	27725	13698	3	0	\N
375779	1678	27360856830000	27727	13698	0	0	\N
375780	1678	27360856831000	27727	13698	1	0	\N
375781	1874	36349000	27727	13698	2	0	\N
375782	1874	36351000	27727	13698	3	0	\N
375787	1678	27360856830000	27729	13698	0	0	\N
375788	1678	27360856831000	27729	13698	1	0	\N
375789	1874	36349000	27729	13698	2	0	\N
375790	1874	36351000	27729	13698	3	0	\N
375793	1678	27360856832000	27731	13699	0	0	\N
375794	1874	36353000	27731	13699	1	0	\N
375795	1678	27360856833000	27732	13700	0	0	\N
375796	1874	36355000	27732	13700	1	0	\N
375807	1678	27360856838000	27736	13703	0	0	\N
375808	1874	36365000	27736	13703	1	0	\N
375809	1678	27360856838000	27737	13703	0	0	\N
375810	1874	36365000	27737	13703	1	0	\N
375815	1678	27360856839000	27740	13704	0	0	\N
375816	1874	36367000	27740	13704	1	0	\N
375831	1678	27360856847000	27742	13706	0	0	\N
375832	1874	36383000	27742	13706	1	0	\N
375833	1678	27360856847000	27743	13706	0	0	\N
375834	1874	36383000	27743	13706	1	0	\N
375835	1678	27360856847000	27744	13706	0	0	\N
375836	1874	36383000	27744	13706	1	0	\N
375839	1678	27360856848000	27746	13707	0	0	\N
375840	1678	27360856849000	27746	13707	1	0	\N
375841	1874	36385000	27746	13707	2	0	\N
375842	1874	36387000	27746	13707	3	0	\N
375849	1678	27360856851000	27749	13709	0	0	\N
375850	1874	36391000	27749	13709	1	0	\N
375851	1678	27360856851000	27750	13709	0	0	\N
375852	1874	36391000	27750	13709	1	0	\N
375853	1678	27360856851000	27751	13709	0	0	\N
375854	1874	36391000	27751	13709	1	0	\N
375859	1678	27360856852000	27754	13710	0	0	\N
375860	1874	36393000	27754	13710	1	0	\N
375861	1874	36393000	27755	13710	0	0	\N
375866	1678	27360856854000	27758	13712	0	0	\N
375867	1874	36397000	27758	13712	1	0	\N
375878	1678	27360856855000	27760	13713	0	0	\N
375879	1678	27360856856000	27760	13713	1	0	\N
375880	1678	27360856857000	27760	13713	2	0	\N
375881	1678	27360856858000	27760	13713	3	0	\N
375882	1678	27360856859000	27760	13713	4	0	\N
375883	1874	36399000	27760	13713	5	0	\N
375884	1874	36401000	27760	13713	6	0	\N
375885	1874	36403000	27760	13713	7	0	\N
375886	1874	36405000	27760	13713	8	0	\N
375887	1874	36407000	27760	13713	9	0	\N
375892	1678	27360856861000	27763	13715	0	0	\N
375893	1874	36411000	27763	13715	1	0	\N
375898	1678	27360856864000	27766	13718	0	0	\N
375899	1874	36417000	27766	13718	1	0	\N
375900	1678	27360856864000	27767	13718	0	0	\N
375901	1874	36417000	27767	13718	1	0	\N
375902	1678	27360856864000	27768	13718	0	0	\N
375903	1874	36417000	27768	13718	1	0	\N
375774	1874	36347000	27724	13697	2	0	2
375783	1678	27360856830000	27728	13698	0	0	1
375784	1678	27360856831000	27728	13698	1	0	1
375785	1874	36349000	27728	13698	2	0	2
375786	1874	36351000	27728	13698	3	0	2
375792	1874	36353000	27730	13699	1	0	2
375797	1678	27360856833000	27733	13700	0	0	1
375798	1874	36355000	27733	13700	1	0	2
375799	1678	27360856834000	27734	13701	0	0	1
375800	1678	27360856835000	27734	13701	1	0	1
375802	1874	36357000	27734	13701	3	0	2
375803	1874	36359000	27734	13701	4	0	2
375804	1874	36361000	27734	13701	5	0	2
375805	1678	27360856837000	27735	13702	0	0	1
375811	1678	27360856838000	27738	13703	0	0	1
375812	1874	36365000	27738	13703	1	0	2
375813	1678	27360856839000	27739	13704	0	0	1
375814	1874	36367000	27739	13704	1	0	2
375817	1678	27360856840000	27741	13705	0	0	1
375819	1678	27360856842000	27741	13705	2	0	1
375820	1678	27360856843000	27741	13705	3	0	1
375821	1678	27360856844000	27741	13705	4	0	1
375822	1678	27360856845000	27741	13705	5	0	1
375823	1678	27360856846000	27741	13705	6	0	1
375825	1874	36371000	27741	13705	8	0	2
375826	1874	36373000	27741	13705	9	0	2
375827	1874	36375000	27741	13705	10	0	2
375828	1874	36377000	27741	13705	11	0	2
375830	1874	36381000	27741	13705	13	0	2
375837	1678	27360856847000	27745	13706	0	0	1
375838	1874	36383000	27745	13706	1	0	2
375843	1678	27360856848000	27747	13707	0	0	1
375844	1678	27360856849000	27747	13707	1	0	1
375846	1874	36387000	27747	13707	3	0	2
375847	1678	27360856850000	27748	13708	0	0	1
375848	1874	36389000	27748	13708	1	0	2
375855	1678	27360856851000	27752	13709	0	0	1
375856	1874	36391000	27752	13709	1	0	2
375858	1874	36393000	27753	13710	1	0	2
375862	1678	27360856853000	27756	13711	0	0	1
375863	1874	36395000	27756	13711	1	0	2
375864	1678	27360856854000	27757	13712	0	0	1
375868	1678	27360856855000	27759	13713	0	0	1
375869	1678	27360856856000	27759	13713	1	0	1
375870	1678	27360856857000	27759	13713	2	0	1
375871	1678	27360856858000	27759	13713	3	0	1
375872	1678	27360856859000	27759	13713	4	0	1
375874	1874	36401000	27759	13713	6	0	2
375875	1874	36403000	27759	13713	7	0	2
375876	1874	36405000	27759	13713	8	0	2
375877	1874	36407000	27759	13713	9	0	2
375888	1678	27360856860000	27761	13714	0	0	1
375890	1678	27360856861000	27762	13715	0	0	1
375891	1874	36411000	27762	13715	1	0	2
375894	1678	27360856862000	27764	13716	0	0	1
375895	1874	36413000	27764	13716	1	0	2
375897	1874	36415000	27765	13717	1	0	2
375904	1678	27360856864000	27769	13718	0	0	1
375919	1678	27360856871000	27774	13723	0	0	\N
375920	1874	36431000	27774	13723	1	0	\N
375927	1678	27360856874000	27777	13725	0	0	\N
375928	1874	36437000	27777	13725	1	0	\N
375929	1678	27360856874000	27778	13725	0	0	\N
375930	1874	36437000	27778	13725	1	0	\N
375937	1678	27360856875000	27781	13726	0	0	\N
375938	1678	27360856876000	27781	13726	1	0	\N
375939	1874	36439000	27781	13726	2	0	\N
375940	1874	36441000	27781	13726	4	0	\N
375941	1678	27360856875000	27782	13726	0	0	\N
375942	1678	27360856876000	27782	13726	1	0	\N
375943	1874	36439000	27782	13726	2	0	\N
375944	1874	36441000	27782	13726	4	0	\N
375962	1678	27360856885000	27787	13731	0	0	\N
375963	1678	27360856886000	27787	13731	1	0	\N
375964	1874	36459000	27787	13731	2	0	\N
375965	1874	36461000	27787	13731	3	0	\N
375966	2385	1000000000	27787	13731	4	0	\N
375977	1678	27360856888000	27791	13733	0	0	\N
375978	121	66000100000000	27791	13733	1	0	\N
375979	1874	36465000	27791	13733	2	0	\N
375980	1678	27360856888000	27792	13733	0	0	\N
375981	121	66000100000000	27792	13733	1	0	\N
375982	1874	36465000	27792	13733	2	0	\N
375992	1678	27360856892000	27795	13736	0	0	\N
375993	1874	36482000	27795	13736	1	0	\N
375994	1874	36485000	27795	13736	2	0	\N
375998	1678	27360856892000	27797	13736	0	0	\N
375999	1874	36482000	27797	13736	1	0	\N
376000	1874	36485000	27797	13736	2	0	\N
376001	1678	27360856893000	27798	13737	0	0	\N
376002	1816	100000000	27798	13737	1	0	\N
376003	1874	36488000	27798	13737	2	0	\N
376004	1874	36490000	27798	13737	3	0	\N
376005	1678	27360856893000	27799	13737	0	0	\N
376006	1816	100000000	27799	13737	1	0	\N
376007	1874	36488000	27799	13737	2	0	\N
376008	1874	36490000	27799	13737	3	0	\N
376013	1678	27360856893000	27801	13737	0	0	\N
376014	1816	100000000	27801	13737	1	0	\N
376015	1874	36488000	27801	13737	2	0	\N
376016	1874	36490000	27801	13737	3	0	\N
376017	1678	27360856894000	27802	13738	0	0	\N
376018	1874	36492000	27802	13738	1	0	\N
376019	1874	36495000	27802	13738	2	0	\N
376029	1678	27360856895000	27805	13739	0	0	\N
376030	1678	27360856896000	27805	13739	1	0	\N
376031	1874	36497000	27805	13739	2	0	\N
376032	1874	36500000	27805	13739	3	0	\N
376033	1874	36503000	27805	13739	4	0	\N
376034	1874	36505000	27805	13739	5	0	\N
376035	1678	27360856897000	27806	13740	0	0	\N
376036	1678	27360856898000	27806	13740	1	0	\N
376037	1874	36507000	27806	13740	2	0	\N
376038	1874	36510000	27806	13740	3	0	\N
376039	1874	36513000	27806	13740	4	0	\N
376040	1874	36515000	27806	13740	5	0	\N
375907	1874	36419000	27770	13719	1	0	2
375908	1678	27360856866000	27772	13721	0	0	1
375909	1678	27360856867000	27772	13721	1	0	1
375910	1874	36421000	27772	13721	2	0	2
375911	1874	36423000	27772	13721	3	0	2
375913	1678	27360856869000	27773	13722	1	0	1
375914	1678	27360856870000	27773	13722	2	0	1
375915	1874	36425000	27773	13722	3	0	2
375916	1874	36427000	27773	13722	4	0	2
375917	1874	36429000	27773	13722	5	0	2
375921	1678	27360856871000	27775	13723	0	0	1
375922	1874	36431000	27775	13723	1	0	2
375923	1678	27360856872000	27776	13724	0	0	1
375924	1678	27360856873000	27776	13724	1	0	1
375926	1874	36435000	27776	13724	3	0	2
375931	1678	27360856874000	27779	13725	0	0	1
375932	1874	36437000	27779	13725	1	0	2
375933	1678	27360856875000	27780	13726	0	0	1
375934	1678	27360856876000	27780	13726	1	0	1
375936	1874	36441000	27780	13726	4	0	2
375945	1600	0	27783	13727	0	0	0
375946	1678	27360856877000	27783	13727	1	0	1
375947	1678	27360856878000	27783	13727	2	0	1
375948	1678	27360856879000	27783	13727	3	0	1
375950	1874	36445000	27783	13727	5	0	2
375951	1874	36447000	27783	13727	6	0	2
375952	1678	27360856880000	27784	13728	0	0	1
375953	1678	27360856881000	27784	13728	1	0	1
375955	1874	36451000	27784	13728	3	0	2
375956	1678	27360856882000	27785	13729	0	0	1
375957	1678	27360856883000	27785	13729	1	0	1
375958	1874	36453000	27785	13729	2	0	2
375959	1874	36455000	27785	13729	3	0	2
375961	1874	36457000	27786	13730	1	0	2
375967	1678	27360856885000	27788	13731	0	0	1
375968	1678	27360856886000	27788	13731	1	0	1
375969	1874	36459000	27788	13731	2	0	2
375970	1874	36461000	27788	13731	3	0	2
375972	1678	27360856887000	27789	13732	0	0	1
375973	1874	36463000	27789	13732	1	0	2
375974	1678	27360856888000	27790	13733	0	0	1
375975	121	66000100000000	27790	13733	1	0	0
375983	1678	27360856889000	27793	13734	0	0	1
375984	1874	36468000	27793	13734	1	0	2
375985	1874	36470000	27793	13734	2	0	2
375986	1678	27360856890000	27794	13735	0	0	1
375987	1678	27360856891000	27794	13735	1	0	1
375989	1874	36476000	27794	13735	3	0	2
375990	1874	36478000	27794	13735	4	0	2
375991	1874	36480000	27794	13735	5	0	2
375995	1678	27360856892000	27796	13736	0	0	1
375996	1874	36482000	27796	13736	1	0	2
376009	1678	27360856893000	27800	13737	0	0	1
376010	1816	100000000	27800	13737	1	0	1
376011	1874	36488000	27800	13737	2	0	2
376012	1874	36490000	27800	13737	3	0	2
376021	1874	36492000	27803	13738	1	0	2
376022	1874	36495000	27803	13738	2	0	2
376023	1678	27360856895000	27804	13739	0	0	1
376024	1678	27360856896000	27804	13739	1	0	1
376025	1874	36497000	27804	13739	2	0	2
376027	1874	36503000	27804	13739	4	0	2
376028	1874	36505000	27804	13739	5	0	2
376041	1678	27360856897000	27807	13740	0	0	\N
376042	1678	27360856898000	27807	13740	1	0	\N
376043	1874	36507000	27807	13740	2	0	\N
376044	1874	36510000	27807	13740	3	0	\N
376045	1874	36513000	27807	13740	4	0	\N
376046	1874	36515000	27807	13740	5	0	\N
376053	1678	27360856897000	27809	13740	0	0	\N
376054	1678	27360856898000	27809	13740	1	0	\N
376055	1874	36507000	27809	13740	2	0	\N
376056	1874	36510000	27809	13740	3	0	\N
376057	1874	36513000	27809	13740	4	0	\N
376058	1874	36515000	27809	13740	5	0	\N
376083	1678	27360856905000	27815	13745	0	0	\N
376084	1678	27360856906000	27815	13745	1	0	\N
376085	1874	36547000	27815	13745	2	0	\N
376086	1874	36550000	27815	13745	3	0	\N
376087	1874	36553000	27815	13745	4	0	\N
376088	1874	36555000	27815	13745	5	0	\N
376095	1678	27360856909000	27818	13748	0	0	\N
376096	1874	36568000	27818	13748	1	0	\N
376097	1874	36570000	27818	13748	2	0	\N
376104	1678	27360856911000	27821	13750	0	0	\N
376105	1874	36577000	27821	13750	1	0	\N
376106	1874	36580000	27821	13750	2	0	\N
376113	1678	27360856912000	27824	13751	0	0	\N
376114	1874	36582000	27824	13751	1	0	\N
376115	1874	36585000	27824	13751	2	0	\N
376116	1678	27360856913000	27825	13752	0	0	\N
376117	1874	36588000	27825	13752	1	0	\N
376118	1874	36590000	27825	13752	2	0	\N
376140	1678	27360856916000	27830	13755	0	0	\N
376141	1678	27360856917000	27830	13755	1	0	\N
376142	1678	27360856918000	27830	13755	2	0	\N
376143	1678	27360856919000	27830	13755	3	0	\N
376144	1874	36603000	27830	13755	4	0	\N
376145	1874	36605000	27830	13755	5	0	\N
376146	1874	36607000	27830	13755	6	0	\N
376147	1874	36609000	27830	13755	7	0	\N
376148	1874	36611000	27830	13755	8	0	\N
376149	1874	36614000	27830	13755	9	0	\N
376150	1874	36617000	27830	13755	10	0	\N
376151	1874	36620000	27830	13755	11	0	\N
376152	1678	27360856916000	27831	13755	0	0	\N
376153	1678	27360856917000	27831	13755	1	0	\N
376154	1678	27360856918000	27831	13755	2	0	\N
376155	1678	27360856919000	27831	13755	3	0	\N
376156	1874	36603000	27831	13755	4	0	\N
376157	1874	36605000	27831	13755	5	0	\N
376158	1874	36607000	27831	13755	6	0	\N
376159	1874	36609000	27831	13755	7	0	\N
376160	1874	36611000	27831	13755	8	0	\N
376161	1874	36614000	27831	13755	9	0	\N
376162	1874	36617000	27831	13755	10	0	\N
376163	1874	36620000	27831	13755	11	0	\N
376167	1678	27360856920000	27833	13756	0	0	\N
376168	1874	36623000	27833	13756	1	0	\N
376169	1874	36625000	27833	13756	2	0	\N
376170	1678	27360856920000	27834	13756	0	0	\N
376171	1874	36623000	27834	13756	1	0	\N
376172	1874	36625000	27834	13756	2	0	\N
376049	1874	36507000	27808	13740	2	0	2
376050	1874	36510000	27808	13740	3	0	2
376051	1874	36513000	27808	13740	4	0	2
376052	1874	36515000	27808	13740	5	0	2
376059	1678	27360856899000	27810	13741	0	0	1
376061	1874	36518000	27810	13741	2	0	2
376062	1874	36521000	27810	13741	3	0	2
376063	1874	36523000	27810	13741	4	0	2
376064	1874	36525000	27810	13741	5	0	2
376065	1678	27360856901000	27811	13742	0	0	1
376067	1874	36530000	27811	13742	2	0	2
376068	1678	27360856902000	27812	13743	0	0	1
376069	1678	27360856903000	27812	13743	1	0	1
376070	1874	36533000	27812	13743	2	0	2
376072	1874	36538000	27812	13743	4	0	2
376073	1874	36540000	27812	13743	5	0	2
376074	1678	27360856904000	27813	13744	0	0	1
376075	1874	36543000	27813	13744	1	0	2
376076	1874	36545000	27813	13744	2	0	2
376078	1678	27360856906000	27814	13745	1	0	1
376079	1874	36547000	27814	13745	2	0	2
376080	1874	36550000	27814	13745	3	0	2
376081	1874	36553000	27814	13745	4	0	2
376082	1874	36555000	27814	13745	5	0	2
376090	1874	36557000	27816	13746	1	0	2
376091	1874	36560000	27816	13746	2	0	2
376092	1678	27360856908000	27817	13747	0	0	1
376093	1874	36563000	27817	13747	1	0	2
376098	1678	27360856909000	27819	13748	0	0	1
376099	1874	36568000	27819	13748	1	0	2
376100	1874	36570000	27819	13748	2	0	2
376101	1678	27360856910000	27820	13749	0	0	1
376102	1874	36573000	27820	13749	1	0	2
376107	1678	27360856911000	27822	13750	0	0	1
376108	1874	36577000	27822	13750	1	0	2
376109	1874	36580000	27822	13750	2	0	2
376110	1678	27360856912000	27823	13751	0	0	1
376111	1874	36582000	27823	13751	1	0	2
376119	1678	27360856913000	27826	13752	0	0	1
376120	1874	36588000	27826	13752	1	0	2
376121	1874	36590000	27826	13752	2	0	2
376122	1678	27360856914000	27827	13753	0	0	1
376124	1874	36595000	27827	13753	2	0	2
376125	1678	27360856915000	27828	13754	0	0	1
376126	1874	36598000	27828	13754	1	0	2
376127	1874	36600000	27828	13754	2	0	2
376128	1678	27360856916000	27829	13755	0	0	1
376130	1678	27360856918000	27829	13755	2	0	1
376131	1678	27360856919000	27829	13755	3	0	1
376132	1874	36603000	27829	13755	4	0	2
376133	1874	36605000	27829	13755	5	0	2
376134	1874	36607000	27829	13755	6	0	2
376136	1874	36611000	27829	13755	8	0	2
376137	1874	36614000	27829	13755	9	0	2
376138	1874	36617000	27829	13755	10	0	2
376139	1874	36620000	27829	13755	11	0	2
376165	1874	36623000	27832	13756	1	0	2
376166	1874	36625000	27832	13756	2	0	2
376173	1678	27360856921000	27835	13757	0	0	1
376174	1874	36627000	27835	13757	1	0	2
376175	1874	36630000	27835	13757	2	0	2
376191	1678	27360856926000	27840	13761	0	0	\N
376192	1874	36653000	27840	13761	1	0	\N
376193	1874	36655000	27840	13761	2	0	\N
376194	1678	27360856926000	27841	13761	0	0	\N
376195	1874	36653000	27841	13761	1	0	\N
376196	1874	36655000	27841	13761	2	0	\N
376197	1678	27360856927000	27842	13762	0	0	\N
376198	1678	27360856928000	27842	13762	1	0	\N
376199	1678	27360856929000	27842	13762	2	0	\N
376200	1874	36657000	27842	13762	3	0	\N
376201	1874	36660000	27842	13762	4	0	\N
376202	1874	36663000	27842	13762	5	0	\N
376203	1874	36666000	27842	13762	6	0	\N
376204	1874	36668000	27842	13762	7	0	\N
376205	1874	36670000	27842	13762	8	0	\N
376224	1678	27360856933000	27846	13765	0	0	\N
376225	1874	36687000	27846	13765	1	0	\N
376226	1874	36690000	27846	13765	2	0	\N
376230	1678	27360856933000	27848	13765	0	0	\N
376231	1874	36687000	27848	13765	1	0	\N
376232	1874	36690000	27848	13765	2	0	\N
376233	1678	27360856934000	27849	13766	0	0	\N
376234	1874	36692000	27849	13766	1	0	\N
376235	1874	36695000	27849	13766	2	0	\N
376236	1678	27360856934000	27850	13766	0	0	\N
376237	1874	36692000	27850	13766	1	0	\N
376238	1874	36695000	27850	13766	2	0	\N
376248	1678	27360856936000	27854	13768	0	0	\N
376249	1874	36703000	27854	13768	2	0	\N
376250	1874	36705000	27854	13768	3	0	\N
376251	1678	27360856937000	27855	13769	0	0	\N
376252	1678	27360856938000	27855	13769	1	0	\N
376253	1874	36708000	27855	13769	2	0	\N
376254	1874	36711000	27855	13769	3	0	\N
376255	1874	36713000	27855	13769	4	0	\N
376256	1874	36715000	27855	13769	5	0	\N
376263	1678	27360856939000	27857	13770	0	0	\N
376264	1874	36717000	27857	13770	1	0	\N
376265	1874	36720000	27857	13770	2	0	\N
376281	1678	27360856943000	27862	13773	0	0	\N
376282	1874	36738000	27862	13773	1	0	\N
376283	1874	36740000	27862	13773	2	0	\N
376306	1678	27360856950000	27869	13779	0	0	\N
376307	1874	36773000	27869	13779	1	0	\N
376308	1874	36775000	27869	13779	2	0	\N
376309	1678	27360856950000	27870	13779	0	0	\N
376310	1874	36773000	27870	13779	1	0	\N
376311	1874	36775000	27870	13779	2	0	\N
376312	1678	27360856897000	27871	13740	0	0	\N
376179	1678	27360856923000	27837	13759	0	0	1
376180	1874	36638000	27837	13759	1	0	2
376181	1874	36640000	27837	13759	2	0	2
376182	1678	27360856924000	27838	13760	0	0	1
376183	1678	27360856925000	27838	13760	1	0	1
376185	1874	36645000	27838	13760	3	0	2
376186	1874	36647000	27838	13760	4	0	2
376187	1874	36650000	27838	13760	5	0	2
376188	1678	27360856926000	27839	13761	0	0	1
376189	1874	36653000	27839	13761	1	0	2
376206	1678	27360856927000	27843	13762	0	0	1
376207	1678	27360856928000	27843	13762	1	0	1
376208	1678	27360856929000	27843	13762	2	0	1
376209	1874	36657000	27843	13762	3	0	2
376211	1874	36663000	27843	13762	5	0	2
376212	1874	36666000	27843	13762	6	0	2
376213	1874	36668000	27843	13762	7	0	2
376214	1874	36670000	27843	13762	8	0	2
376215	1678	27360856930000	27844	13763	0	0	1
376217	1874	36673000	27844	13763	2	0	2
376218	1874	36675000	27844	13763	3	0	2
376219	1874	36677000	27844	13763	4	0	2
376220	1874	36680000	27844	13763	5	0	2
376221	1678	27360856932000	27845	13764	0	0	1
376223	1874	36685000	27845	13764	2	0	2
376227	1678	27360856933000	27847	13765	0	0	1
376228	1874	36687000	27847	13765	1	0	2
376229	1874	36690000	27847	13765	2	0	2
376240	1874	36692000	27851	13766	1	0	2
376241	1874	36695000	27851	13766	2	0	2
376242	1678	27360856935000	27852	13767	0	0	1
376243	1874	36697000	27852	13767	1	0	2
376244	1874	36700000	27852	13767	2	0	2
376246	1874	36703000	27853	13768	2	0	2
376247	1874	36705000	27853	13768	3	0	2
376257	1678	27360856937000	27856	13769	0	0	1
376258	1678	27360856938000	27856	13769	1	0	1
376259	1874	36708000	27856	13769	2	0	2
376261	1874	36713000	27856	13769	4	0	2
376262	1874	36715000	27856	13769	5	0	2
376266	1678	27360856939000	27858	13770	0	0	1
376267	1874	36717000	27858	13770	1	0	2
376269	1678	27360856940000	27859	13771	0	0	1
376270	1678	27360856941000	27859	13771	1	0	1
376271	1874	36723000	27859	13771	2	0	2
376272	1874	36725000	27859	13771	3	0	2
376273	1874	36727000	27859	13771	4	0	2
376275	1678	27360856942000	27860	13772	0	0	1
376276	1874	36733000	27860	13772	1	0	2
376277	1874	36735000	27860	13772	2	0	2
376278	1678	27360856943000	27861	13773	0	0	1
376279	1874	36738000	27861	13773	1	0	2
376284	1678	27360856944000	27863	13774	0	0	1
376285	1874	36743000	27863	13774	1	0	2
376286	1874	36745000	27863	13774	2	0	2
376287	1678	27360856945000	27864	13775	0	0	1
376289	1874	36750000	27864	13775	2	0	2
376290	1678	27360856946000	27865	13776	0	0	1
376291	1874	36753000	27865	13776	1	0	2
376292	2386	100000000	27865	13776	2	0	0
376293	1874	36755000	27865	13776	3	0	2
376295	1678	27360856948000	27866	13777	1	0	1
376296	1874	36757000	27866	13777	3	0	2
376297	1874	36759000	27866	13777	4	0	2
376298	1874	36762000	27866	13777	5	0	2
376299	1874	36765000	27866	13777	6	0	2
376301	1874	36768000	27867	13778	1	0	2
376302	1874	36770000	27867	13778	2	0	2
376303	1678	27360856950000	27868	13779	0	0	1
376304	1874	36773000	27868	13779	1	0	2
376313	1678	27360856898000	27871	13740	1	0	\N
376314	1678	27360856899000	27871	13740	2	0	\N
376315	1678	27360856900000	27871	13740	3	0	\N
376316	1678	27360856901000	27871	13740	4	0	\N
376317	1678	27360856902000	27871	13740	5	0	\N
376318	1678	27360856903000	27871	13740	6	0	\N
376319	1678	27360856904000	27871	13740	7	0	\N
376320	1678	27360856905000	27871	13740	8	0	\N
376321	1678	27360856906000	27871	13740	9	0	\N
376322	1678	27360856907000	27871	13740	10	0	\N
376323	1678	27360856908000	27871	13740	11	0	\N
376324	1678	27360856909000	27871	13740	12	0	\N
376325	1678	27360856910000	27871	13740	13	0	\N
376326	1678	27360856911000	27871	13740	14	0	\N
376327	1678	27360856912000	27871	13740	15	0	\N
376328	1678	27360856913000	27871	13740	16	0	\N
376329	1678	27360856914000	27871	13740	17	0	\N
376330	1678	27360856915000	27871	13740	18	0	\N
376331	1678	27360856916000	27871	13740	19	0	\N
376332	1678	27360856917000	27871	13740	20	0	\N
376333	1678	27360856918000	27871	13740	21	0	\N
376334	1678	27360856919000	27871	13740	22	0	\N
376335	1678	27360856920000	27871	13740	23	0	\N
376336	1678	27360856921000	27871	13740	24	0	\N
376337	1678	27360856922000	27871	13740	25	0	\N
376338	1678	27360856923000	27871	13740	26	0	\N
376339	1678	27360856924000	27871	13740	27	0	\N
376340	1678	27360856925000	27871	13740	28	0	\N
376341	1678	27360856926000	27871	13740	29	0	\N
376342	1678	27360856927000	27871	13740	30	0	\N
376343	1678	27360856928000	27871	13740	31	0	\N
376344	1678	27360856929000	27871	13740	32	0	\N
376345	1678	27360856930000	27871	13740	33	0	\N
376346	1678	27360856931000	27871	13740	34	0	\N
376347	1678	27360856932000	27871	13740	35	0	\N
376348	1678	27360856933000	27871	13740	36	0	\N
376349	1678	27360856934000	27871	13740	37	0	\N
376350	1678	27360856935000	27871	13740	38	0	\N
376351	1678	27360856936000	27871	13740	39	0	\N
376352	1678	27360856937000	27871	13740	40	0	\N
376353	1678	27360856938000	27871	13740	41	0	\N
376354	1678	27360856939000	27871	13740	42	0	\N
376355	1678	27360856940000	27871	13740	43	0	\N
376356	1678	27360856941000	27871	13740	44	0	\N
376357	1678	27360856942000	27871	13740	45	0	\N
376358	1678	27360856943000	27871	13740	47	0	\N
376359	1678	27360856944000	27871	13740	48	0	\N
376360	1678	27360856945000	27871	13740	49	0	\N
376361	1678	27360856946000	27871	13740	50	0	\N
376362	1678	27360856947000	27871	13740	51	0	\N
376363	1678	27360856948000	27871	13740	52	0	\N
376364	1678	27360856949000	27871	13740	53	0	\N
376365	1678	27360856950000	27871	13740	54	0	\N
376366	1874	36507000	27871	13740	56	0	\N
376367	2386	100000000	27871	13740	57	0	\N
376368	1874	36510000	27871	13740	58	0	\N
376369	1874	36513000	27871	13740	59	0	\N
376370	1874	36516000	27871	13740	60	0	\N
376371	1874	36519000	27871	13740	61	0	\N
376372	1874	36522000	27871	13740	62	0	\N
376373	1874	36525000	27871	13740	63	0	\N
376374	1874	36528000	27871	13740	64	0	\N
376375	1874	36531000	27871	13740	65	0	\N
376376	1874	36534000	27871	13740	66	0	\N
376377	1874	36537000	27871	13740	67	0	\N
376378	1874	36540000	27871	13740	68	0	\N
376379	1874	36543000	27871	13740	69	0	\N
376380	1874	36546000	27871	13740	70	0	\N
376381	1874	36549000	27871	13740	71	0	\N
376382	1874	36552000	27871	13740	72	0	\N
376383	1874	36555000	27871	13740	73	0	\N
376384	1874	36558000	27871	13740	74	0	\N
376385	1874	36561000	27871	13740	75	0	\N
376386	1874	36564000	27871	13740	76	0	\N
376387	1874	36567000	27871	13740	77	0	\N
376388	1874	36569000	27871	13740	78	0	\N
376389	1874	36571000	27871	13740	79	0	\N
376390	1874	36573000	27871	13740	80	0	\N
376391	1874	36575000	27871	13740	81	0	\N
376392	1874	36577000	27871	13740	82	0	\N
376393	1874	36579000	27871	13740	83	0	\N
376394	1874	36581000	27871	13740	84	0	\N
376395	1874	36583000	27871	13740	85	0	\N
376396	1874	36585000	27871	13740	86	0	\N
376397	1874	36587000	27871	13740	87	0	\N
376398	1874	36589000	27871	13740	88	0	\N
376399	1874	36591000	27871	13740	89	0	\N
376400	1874	36593000	27871	13740	90	0	\N
376401	1874	36595000	27871	13740	91	0	\N
376402	1874	36597000	27871	13740	92	0	\N
376403	1874	36599000	27871	13740	93	0	\N
376404	1874	36601000	27871	13740	94	0	\N
376405	1874	36603000	27871	13740	95	0	\N
376406	1874	36605000	27871	13740	96	0	\N
376407	1874	36607000	27871	13740	97	0	\N
376408	1874	36609000	27871	13740	98	0	\N
376409	1874	36611000	27871	13740	99	0	\N
376410	1874	36613000	27871	13740	100	0	\N
376411	1874	36615000	27871	13740	101	0	\N
376412	1874	36617000	27871	13740	102	0	\N
376413	1874	36619000	27871	13740	103	0	\N
376414	1874	36621000	27871	13740	104	0	\N
376415	1874	36623000	27871	13740	105	0	\N
376416	1874	36625000	27871	13740	106	0	\N
376417	1874	36627000	27871	13740	107	0	\N
376418	1874	36629000	27871	13740	108	0	\N
376419	1874	36631000	27871	13740	109	0	\N
376420	1874	36633000	27871	13740	110	0	\N
376421	1874	36635000	27871	13740	111	0	\N
376422	1874	36637000	27871	13740	112	0	\N
376423	1874	36639000	27871	13740	113	0	\N
376424	1874	36641000	27871	13740	114	0	\N
376425	1874	36643000	27871	13740	115	0	\N
376426	1874	36645000	27871	13740	116	0	\N
376427	1874	36647000	27871	13740	117	0	\N
376428	1874	36649000	27871	13740	118	0	\N
376429	1874	36651000	27871	13740	119	0	\N
376430	1874	36653000	27871	13740	120	0	\N
376431	1874	36655000	27871	13740	121	0	\N
376432	1874	36657000	27871	13740	122	0	\N
376433	1874	36659000	27871	13740	123	0	\N
376434	1874	36661000	27871	13740	124	0	\N
376435	1874	36663000	27871	13740	125	0	\N
376439	1678	27360856951000	27873	13780	0	0	\N
376440	1874	36777000	27873	13780	1	0	\N
376441	1874	36780000	27873	13780	2	0	\N
376442	1678	27360856952000	27874	13781	0	0	\N
376443	1874	36782000	27874	13781	1	0	\N
376444	1874	36785000	27874	13781	2	0	\N
376438	1874	36780000	27872	13780	2	0	2
376445	1678	27360856952000	27875	13781	0	0	1
376446	1874	36782000	27875	13781	1	0	2
376447	1874	36785000	27875	13781	2	0	2
376448	1678	27360856953000	27876	13782	0	0	1
376451	1678	27360856954000	27877	13783	0	0	\N
376452	1874	36793000	27877	13783	1	0	\N
376453	1874	36795000	27877	13783	2	0	\N
376457	1678	27360856954000	27879	13783	0	0	\N
376458	1874	36793000	27879	13783	1	0	\N
376459	1874	36795000	27879	13783	2	0	\N
376460	1678	27360856955000	27880	13784	0	0	\N
376461	1678	27360856956000	27880	13784	1	0	\N
376462	1874	36797000	27880	13784	2	0	\N
376463	1874	36800000	27880	13784	3	0	\N
376464	1874	36803000	27880	13784	4	0	\N
376465	1874	36806000	27880	13784	5	0	\N
376466	1874	36808000	27880	13784	6	0	\N
376467	1874	36810000	27880	13784	7	0	\N
376476	1474	15030643000043	27882	13626	0	0	\N
376477	1474	15030643000043	27882	13626	1	0	\N
376478	1474	24390643000043	27882	13626	2	0	\N
376479	2314	69869000000	27882	13626	3	0	\N
376480	38	66539225269421	27882	13626	4	0	\N
376481	1600	0	27882	13626	5	0	\N
376482	969	506877361461968	27882	13626	6	0	\N
376483	2314	138869000000	27882	13626	7	0	\N
376484	2068	2000099000000	27882	13626	8	0	\N
376485	2314	207869000000	27882	13626	9	0	\N
376486	2314	386869000000	27882	13626	10	0	\N
376487	2314	418869000000	27882	13626	11	0	\N
376488	1089	908319888814612	27882	13626	12	0	\N
376489	1209	612861528535553	27882	13626	13	0	\N
376490	1335	1707793141873126	27882	13626	14	0	\N
376491	38	66575050395110	27882	13626	16	0	\N
376492	969	507150018330014	27882	13626	17	0	\N
376493	1089	908808487586029	27882	13626	18	0	\N
376494	1209	613191195862646	27882	13626	19	0	\N
376495	1335	1708711789192456	27882	13626	20	0	\N
376496	1474	24390643000043	27882	13626	22	0	\N
376497	1474	24390643000043	27882	13626	23	0	\N
376498	1460	0	27882	13626	25	0	\N
376499	1635	11000000	27882	13626	26	0	\N
376500	2386	100000000	27882	13626	27	0	\N
376501	2152	107998988000000	27882	13626	28	0	\N
376502	2385	1000000000	27882	13626	29	0	\N
376503	2172	199001000	27882	13626	30	0	\N
376528	1678	27360856965000	27887	13789	0	0	\N
376529	1874	36853000	27887	13789	1	0	\N
376530	1874	36855000	27887	13789	2	0	\N
376531	1678	27360856965000	27888	13789	0	0	\N
376532	1874	36853000	27888	13789	1	0	\N
376533	1874	36855000	27888	13789	2	0	\N
376546	1678	27360856968000	27893	13792	0	0	\N
376547	1874	36868000	27893	13792	1	0	\N
376548	1874	36870000	27893	13792	2	0	\N
376549	1678	27360856968000	27894	13792	0	0	\N
376550	1874	36868000	27894	13792	1	0	\N
376551	1874	36870000	27894	13792	2	0	\N
376552	1678	27360856969000	27895	13793	0	0	\N
376553	1678	27360856970000	27895	13793	1	0	\N
376554	1931	7914486000000	27895	13793	2	0	\N
376555	1874	36872000	27895	13793	3	0	\N
376556	1874	36874000	27895	13793	4	0	\N
376557	1874	36877000	27895	13793	5	0	\N
376558	1874	36880000	27895	13793	6	0	\N
376566	1678	27360856969000	27897	13793	0	0	\N
376567	1678	27360856970000	27897	13793	1	0	\N
376568	1931	7914486000000	27897	13793	2	0	\N
376569	1874	36872000	27897	13793	3	0	\N
376570	1874	36874000	27897	13793	4	0	\N
376571	1874	36877000	27897	13793	5	0	\N
376572	1874	36880000	27897	13793	6	0	\N
376573	1678	27360856971000	27898	13794	0	0	\N
376574	1874	36882000	27898	13794	1	0	\N
376575	1874	36885000	27898	13794	2	0	\N
376454	1678	27360856954000	27878	13783	0	0	1
376455	1874	36793000	27878	13783	1	0	2
376456	1874	36795000	27878	13783	2	0	2
376468	1678	27360856955000	27881	13784	0	0	1
376469	1678	27360856956000	27881	13784	1	0	1
376471	1874	36800000	27881	13784	3	0	2
376472	1874	36803000	27881	13784	4	0	2
376473	1874	36806000	27881	13784	5	0	2
376474	1874	36808000	27881	13784	6	0	2
376475	1874	36810000	27881	13784	7	0	2
376505	1874	36813000	27883	13785	1	0	2
376506	1874	36815000	27883	13785	2	0	2
376507	1678	27360856958000	27884	13786	0	0	1
376508	1678	27360856959000	27884	13786	1	0	1
376510	1874	36818000	27884	13786	3	0	2
376511	1874	36820000	27884	13786	4	0	2
376512	1874	36822000	27884	13786	5	0	2
376513	1874	36824000	27884	13786	6	0	2
376514	1874	36827000	27884	13786	7	0	2
376516	1678	27360856961000	27885	13787	0	0	1
376517	1874	36833000	27885	13787	1	0	2
376518	1874	36835000	27885	13787	2	0	2
376519	1678	27360856962000	27886	13788	0	0	1
376520	1678	27360856963000	27886	13788	1	0	1
376522	1874	36838000	27886	13788	3	0	2
376523	1874	36841000	27886	13788	4	0	2
376524	1874	36844000	27886	13788	5	0	2
376525	1874	36846000	27886	13788	7	0	2
376527	1874	36850000	27886	13788	9	0	2
376534	1678	27360856965000	27889	13789	0	0	1
376535	1874	36853000	27889	13789	1	0	2
376536	1874	36855000	27889	13789	2	0	2
376537	1678	27360856966000	27890	13790	0	0	1
376539	1874	36860000	27890	13790	2	0	2
376540	1678	27360856967000	27891	13791	0	0	1
376541	1874	36862000	27891	13791	1	0	2
376542	1874	36865000	27891	13791	2	0	2
376543	1678	27360856968000	27892	13792	0	0	1
376545	1874	36870000	27892	13792	2	0	2
376559	1678	27360856969000	27896	13793	0	0	1
376560	1678	27360856970000	27896	13793	1	0	1
376561	1931	7914486000000	27896	13793	2	0	1
376563	1874	36874000	27896	13793	4	0	2
376564	1874	36877000	27896	13793	5	0	2
376565	1874	36880000	27896	13793	6	0	2
376576	1678	27360856971000	27899	13794	0	0	1
376577	1874	36882000	27899	13794	1	0	2
376579	1678	27360856972000	27900	13795	0	0	1
376580	1874	36888000	27900	13795	1	0	2
376581	1874	36890000	27900	13795	2	0	2
376582	1678	27360856973000	27901	13796	0	0	1
376583	1678	27360856974000	27901	13796	1	0	1
376625	1678	27360856986000	27908	13803	0	0	\N
376626	1874	36957000	27908	13803	1	0	\N
376627	1874	36960000	27908	13803	2	0	\N
376628	1678	27360856986000	27909	13803	0	0	\N
376629	1874	36957000	27909	13803	1	0	\N
376630	1874	36960000	27909	13803	2	0	\N
376640	1678	27360856987000	27912	13804	0	0	\N
376641	1678	27360856988000	27912	13804	1	0	\N
376642	1874	36962000	27912	13804	2	0	\N
376643	1874	36964000	27912	13804	3	0	\N
376644	1874	36967000	27912	13804	4	0	\N
376645	1874	36970000	27912	13804	5	0	\N
376658	1678	27360856993000	27916	13808	0	0	\N
376659	1874	36989000	27916	13808	1	0	\N
376660	1874	36992000	27916	13808	2	0	\N
376664	1678	27360856991000	27918	13807	0	0	\N
376665	1678	27360856992000	27918	13807	1	0	\N
376666	1678	27360856993000	27918	13807	2	0	\N
376667	1874	36980000	27918	13807	4	0	\N
376668	1874	36983000	27918	13807	5	0	\N
376669	1874	36985000	27918	13807	6	0	\N
376670	1874	36988000	27918	13807	7	0	\N
376671	1874	36990000	27918	13807	8	0	\N
376672	1874	36992000	27918	13807	9	0	\N
376676	1678	27360856994000	27920	13809	0	0	\N
376677	1874	36994000	27920	13809	1	0	\N
376678	1874	36997000	27920	13809	2	0	\N
376685	1678	27360856996000	27923	13811	0	0	\N
376686	1874	37005000	27923	13811	1	0	\N
376694	1678	27360856998000	27926	13813	0	0	\N
376695	289	66000000000000	27926	13813	1	0	\N
376696	1874	37015000	27926	13813	2	0	\N
376697	1874	37017000	27926	13813	3	0	\N
376701	1678	27360857000000	27928	13815	0	0	\N
376702	1874	37025000	27928	13815	1	0	\N
376703	1874	37027000	27928	13815	2	0	\N
376707	1678	27360857000000	27930	13815	0	0	\N
376708	1874	37025000	27930	13815	1	0	\N
376709	1874	37027000	27930	13815	2	0	\N
376719	1678	27360857004000	27932	13817	0	0	\N
376720	1874	37042000	27932	13817	1	0	\N
376587	1874	36900000	27901	13796	5	0	2
376588	1678	27360856975000	27902	13797	0	0	1
376589	1874	36902000	27902	13797	1	0	2
376590	1874	36905000	27902	13797	2	0	2
376591	1678	27360856976000	27903	13798	0	0	1
376593	1874	36910000	27903	13798	2	0	2
376594	1678	27360856977000	27904	13799	0	0	1
376595	1874	36913000	27904	13799	1	0	2
376596	1874	36915000	27904	13799	2	0	2
376597	1678	27360856978000	27905	13800	0	0	1
376599	1678	27360856980000	27905	13800	2	0	1
376600	1678	27360856981000	27905	13800	3	0	1
376601	1678	27360856982000	27905	13800	4	0	1
376602	1874	36917000	27905	13800	5	0	2
376604	1874	36919000	27905	13800	7	0	2
376605	1874	36921000	27905	13800	8	0	2
376606	2387	100000000	27905	13800	9	0	0
376607	2388	100000000	27905	13800	10	0	0
376608	2389	100000000	27905	13800	11	0	0
376610	1874	36927000	27905	13800	13	0	2
376611	1874	36930000	27905	13800	14	0	2
376612	1874	36933000	27905	13800	15	0	2
376613	1874	36936000	27905	13800	16	0	2
376614	1874	36938000	27905	13800	17	0	2
376616	1678	27360856983000	27906	13801	0	0	1
376617	1874	36943000	27906	13801	1	0	2
376618	1874	36945000	27906	13801	2	0	2
376619	1678	27360856984000	27907	13802	0	0	1
376621	1874	36947000	27907	13802	2	0	2
376622	1874	36950000	27907	13802	3	0	2
376623	1874	36953000	27907	13802	4	0	2
376624	1874	36955000	27907	13802	5	0	2
376631	1678	27360856986000	27910	13803	0	0	1
376633	1874	36960000	27910	13803	2	0	2
376634	1678	27360856987000	27911	13804	0	0	1
376635	1678	27360856988000	27911	13804	1	0	1
376636	1874	36962000	27911	13804	2	0	2
376637	1874	36964000	27911	13804	3	0	2
376639	1874	36970000	27911	13804	5	0	2
376646	1678	27360856989000	27913	13805	0	0	1
376647	1874	36973000	27913	13805	1	0	2
376648	1874	36975000	27913	13805	2	0	2
376650	2192	101000000000	27914	13806	1	0	0
376651	1874	36977000	27914	13806	2	0	2
376652	1678	27360856991000	27915	13807	0	0	1
376653	1678	27360856992000	27915	13807	1	0	1
376654	1874	36980000	27915	13807	2	0	2
376656	1874	36985000	27915	13807	5	0	2
376657	1874	36987000	27915	13807	6	0	2
376661	1678	27360856993000	27917	13808	0	0	1
376662	1874	36989000	27917	13808	1	0	2
376663	1874	36992000	27917	13808	2	0	2
376674	1874	36994000	27919	13809	1	0	2
376675	1874	36997000	27919	13809	2	0	2
376679	1678	27360856995000	27921	13810	0	0	1
376680	1874	37000000	27921	13810	1	0	2
376682	1678	27360856996000	27922	13811	0	0	1
376683	1874	37005000	27922	13811	1	0	2
376684	1874	37007000	27922	13811	2	0	2
376687	1678	27360856997000	27924	13812	0	0	1
376688	1874	37010000	27924	13812	1	0	2
376690	1678	27360856998000	27925	13813	0	0	1
376691	289	66000000000000	27925	13813	1	0	0
376692	1874	37015000	27925	13813	2	0	2
376693	1874	37017000	27925	13813	3	0	2
376698	1678	27360856999000	27927	13814	0	0	1
376700	1874	37022000	27927	13814	2	0	2
376704	1678	27360857000000	27929	13815	0	0	1
376705	1874	37025000	27929	13815	1	0	2
376706	1874	37027000	27929	13815	2	0	2
376711	1678	27360857002000	27931	13816	1	0	1
376712	1678	27360857003000	27931	13816	2	0	1
376713	2390	99000000000	27931	13816	3	0	0
376714	1874	37029000	27931	13816	4	0	2
376715	1874	37031000	27931	13816	5	0	2
376717	1874	37037000	27931	13816	7	0	2
376718	1874	37040000	27931	13816	8	0	2
376721	1874	37045000	27932	13817	2	0	\N
376732	1678	27360857005000	27935	13818	0	0	\N
376733	1678	27360857006000	27935	13818	1	0	\N
376734	1874	37047000	27935	13818	2	0	\N
376735	1874	37049000	27935	13818	3	0	\N
376736	1760	800000000000	27935	13818	4	0	\N
376737	1874	37052000	27935	13818	5	0	\N
376738	1874	37055000	27935	13818	6	0	\N
376748	1678	27360857009000	27938	13820	0	0	\N
376749	1874	37067000	27938	13820	1	0	\N
376750	1874	37070000	27938	13820	2	0	\N
376751	1678	27360857009000	27939	13820	0	0	\N
376752	1874	37067000	27939	13820	1	0	\N
376753	1874	37070000	27939	13820	2	0	\N
376776	1678	27360857017000	27944	13825	0	0	\N
376777	1874	37107000	27944	13825	1	0	\N
376778	1874	37110000	27944	13825	2	0	\N
376782	1678	27360857017000	27946	13825	0	0	\N
376783	1874	37107000	27946	13825	1	0	\N
376784	1874	37110000	27946	13825	2	0	\N
376785	1678	27360857018000	27947	13826	0	0	\N
376786	1678	27360857019000	27947	13826	1	0	\N
376787	1874	37113000	27947	13826	2	0	\N
376788	1874	37116000	27947	13826	3	0	\N
376789	1874	37118000	27947	13826	4	0	\N
376790	1874	37120000	27947	13826	5	0	\N
376791	1678	27360857018000	27948	13826	0	0	\N
376792	1678	27360857019000	27948	13826	1	0	\N
376793	1874	37113000	27948	13826	2	0	\N
376794	1874	37116000	27948	13826	3	0	\N
376795	1874	37118000	27948	13826	4	0	\N
376796	1874	37120000	27948	13826	5	0	\N
376803	1678	27360857020000	27951	13828	0	0	\N
376804	1678	27360857021000	27951	13828	1	0	\N
376805	1874	37122000	27951	13828	2	0	\N
376806	1874	37124000	27951	13828	3	0	\N
376807	1874	37127000	27951	13828	4	0	\N
376808	1874	37130000	27951	13828	5	0	\N
376815	1678	27360857022000	27953	13829	0	0	\N
376816	1678	27360857023000	27953	13829	1	0	\N
376817	1874	37133000	27953	13829	2	0	\N
376818	1874	37135000	27953	13829	3	0	\N
376819	1874	37138000	27953	13829	4	0	\N
376820	1874	37140000	27953	13829	5	0	\N
376827	1678	27360857024000	27955	13830	0	0	\N
376828	1678	27360857025000	27955	13830	1	0	\N
376829	1874	37143000	27955	13830	2	0	\N
376830	1874	37146000	27955	13830	3	0	\N
376831	1874	37148000	27955	13830	4	0	\N
376832	1874	37150000	27955	13830	5	0	\N
376839	1678	27360857026000	27957	13831	0	0	\N
376840	1874	37153000	27957	13831	1	0	\N
376841	1874	37155000	27957	13831	2	0	\N
376849	1678	27360857026000	27960	13832	0	0	\N
376850	1678	27360857027000	27960	13832	1	0	\N
376851	1678	27360857028000	27960	13832	2	0	\N
376852	1874	37158000	27960	13832	3	0	\N
376853	1874	37161000	27960	13832	4	0	\N
376854	1678	27360857026000	27961	13832	0	0	\N
376855	1678	27360857027000	27961	13832	1	0	\N
376856	1678	27360857028000	27961	13832	2	0	\N
376724	1874	37045000	27933	13817	2	0	2
376725	1678	27360857005000	27934	13818	0	0	1
376726	1678	27360857006000	27934	13818	1	0	1
376727	1874	37047000	27934	13818	2	0	2
376728	1874	37049000	27934	13818	3	0	2
376730	1874	37052000	27934	13818	5	0	2
376731	1874	37055000	27934	13818	6	0	2
376739	1678	27360857007000	27936	13819	0	0	1
376740	1678	27360857008000	27936	13819	1	0	1
376741	1874	37057000	27936	13819	2	0	2
376743	1874	37062000	27936	13819	4	0	2
376744	1874	37065000	27936	13819	5	0	2
376745	1678	27360857009000	27937	13820	0	0	1
376746	1874	37067000	27937	13820	1	0	2
376754	1678	27360857010000	27940	13821	0	0	1
376755	1874	37073000	27940	13821	1	0	2
376756	1874	37075000	27940	13821	2	0	2
376757	1678	27360857011000	27941	13822	0	0	1
376758	1874	37078000	27941	13822	1	0	2
376760	2391	100000000	27941	13822	3	0	0
376761	1678	27360857012000	27942	13823	0	0	1
376762	1678	27360857013000	27942	13823	1	0	1
376763	1874	37083000	27942	13823	2	0	2
376764	1874	37085000	27942	13823	3	0	2
376766	1874	37090000	27942	13823	5	0	2
376767	1678	27360857014000	27943	13824	0	0	1
376768	1678	27360857015000	27943	13824	1	0	1
376769	1678	27360857016000	27943	13824	2	0	1
376771	1874	37094000	27943	13824	4	0	2
376772	1874	37096000	27943	13824	5	0	2
376773	1874	37099000	27943	13824	6	0	2
376774	1874	37102000	27943	13824	7	0	2
376775	1874	37105000	27943	13824	8	0	2
376780	1874	37107000	27945	13825	1	0	2
376781	1874	37110000	27945	13825	2	0	2
376797	1678	27360857018000	27949	13826	0	0	1
376798	1678	27360857019000	27949	13826	1	0	1
376799	1874	37113000	27949	13826	2	0	2
376801	1874	37118000	27949	13826	4	0	2
376802	1874	37120000	27949	13826	5	0	2
376809	1678	27360857020000	27952	13828	0	0	1
376810	1678	27360857021000	27952	13828	1	0	1
376812	1874	37124000	27952	13828	3	0	2
376813	1874	37127000	27952	13828	4	0	2
376814	1874	37130000	27952	13828	5	0	2
376821	1678	27360857022000	27954	13829	0	0	1
376822	1678	27360857023000	27954	13829	1	0	1
376824	1874	37135000	27954	13829	3	0	2
376825	1874	37138000	27954	13829	4	0	2
376826	1874	37140000	27954	13829	5	0	2
376833	1678	27360857024000	27956	13830	0	0	1
376834	1678	27360857025000	27956	13830	1	0	1
376836	1874	37146000	27956	13830	3	0	2
376837	1874	37148000	27956	13830	4	0	2
376838	1874	37150000	27956	13830	5	0	2
376842	1874	37153000	27958	13831	0	0	2
376844	1678	27360857026000	27959	13832	0	0	1
376845	1678	27360857027000	27959	13832	1	0	1
376846	1678	27360857028000	27959	13832	2	0	1
376847	1874	37158000	27959	13832	3	0	2
376848	1874	37161000	27959	13832	4	0	2
376857	1874	37157000	27961	13832	3	0	\N
376858	1874	37160000	27961	13832	4	0	\N
376859	1874	37163000	27961	13832	5	0	\N
376860	1874	37165000	27961	13832	6	0	\N
376861	1678	27360857026000	27962	13832	0	0	\N
376862	1678	27360857027000	27962	13832	1	0	\N
376863	1678	27360857028000	27962	13832	2	0	\N
376864	1874	37157000	27962	13832	3	0	\N
376865	1874	37160000	27962	13832	4	0	\N
376866	1874	37163000	27962	13832	5	0	\N
376867	1874	37165000	27962	13832	6	0	\N
376868	1678	27360857026000	27963	13832	0	0	\N
376869	1678	27360857027000	27963	13832	1	0	\N
376870	1678	27360857028000	27963	13832	2	0	\N
376871	1874	37157000	27963	13832	3	0	\N
376872	1874	37160000	27963	13832	4	0	\N
376873	1874	37163000	27963	13832	5	0	\N
376874	1874	37165000	27963	13832	6	0	\N
376890	1678	27360857034000	27967	13835	0	0	\N
376891	1678	27360857035000	27967	13835	1	0	\N
376892	1678	27360857036000	27967	13835	2	0	\N
376893	1874	37189000	27967	13835	3	0	\N
376894	1874	37191000	27967	13835	4	0	\N
376895	1874	37193000	27967	13835	5	0	\N
376896	1874	37196000	27967	13835	6	0	\N
376897	1874	37199000	27967	13835	7	0	\N
376898	1874	37201000	27967	13835	8	0	\N
376899	1874	37203000	27967	13835	9	0	\N
376900	1874	37205000	27967	13835	10	0	\N
376901	1678	27360857034000	27968	13835	0	0	\N
376902	1678	27360857035000	27968	13835	1	0	\N
376903	1678	27360857036000	27968	13835	2	0	\N
376904	1874	37189000	27968	13835	3	0	\N
376905	1874	37191000	27968	13835	4	0	\N
376906	1874	37193000	27968	13835	5	0	\N
376907	1874	37196000	27968	13835	6	0	\N
376908	1874	37199000	27968	13835	7	0	\N
376909	1874	37201000	27968	13835	8	0	\N
376910	1874	37203000	27968	13835	9	0	\N
376911	1874	37205000	27968	13835	10	0	\N
376912	1678	27360857034000	27969	13835	0	0	\N
376913	1678	27360857035000	27969	13835	1	0	\N
376914	1678	27360857036000	27969	13835	2	0	\N
376915	1874	37189000	27969	13835	3	0	\N
376916	1874	37191000	27969	13835	4	0	\N
376917	1874	37193000	27969	13835	5	0	\N
376918	1874	37196000	27969	13835	6	0	\N
376919	1874	37199000	27969	13835	7	0	\N
376920	1874	37201000	27969	13835	8	0	\N
376921	1874	37203000	27969	13835	9	0	\N
376922	1874	37205000	27969	13835	10	0	\N
376923	1678	27360857034000	27970	13835	0	0	\N
376924	1678	27360857035000	27970	13835	1	0	\N
376925	1678	27360857036000	27970	13835	2	0	\N
376926	1874	37189000	27970	13835	3	0	\N
376927	1874	37192000	27970	13835	4	0	\N
376928	1874	37195000	27970	13835	5	0	\N
376940	1678	27360857034000	27972	13835	0	0	\N
376941	1678	27360857035000	27972	13835	1	0	\N
376942	1678	27360857036000	27972	13835	2	0	\N
376943	1874	37189000	27972	13835	3	0	\N
376944	1874	37191000	27972	13835	4	0	\N
376945	1874	37193000	27972	13835	5	0	\N
376946	1874	37196000	27972	13835	6	0	\N
376947	1874	37199000	27972	13835	7	0	\N
376948	1874	37201000	27972	13835	8	0	\N
376949	1874	37203000	27972	13835	9	0	\N
376950	1874	37205000	27972	13835	10	0	\N
376951	1678	27360857034000	27973	13835	0	0	\N
376952	1678	27360857035000	27973	13835	1	0	\N
376953	1678	27360857036000	27973	13835	2	0	\N
376954	1874	37189000	27973	13835	3	0	\N
376955	1874	37191000	27973	13835	4	0	\N
376956	1874	37193000	27973	13835	5	0	\N
376957	1874	37196000	27973	13835	6	0	\N
376958	1874	37199000	27973	13835	7	0	\N
376959	1874	37201000	27973	13835	8	0	\N
376960	1874	37203000	27973	13835	9	0	\N
376961	1874	37205000	27973	13835	10	0	\N
376965	1678	27360857038000	27975	13837	0	0	\N
376966	1874	37212000	27975	13837	1	0	\N
376967	1874	37215000	27975	13837	2	0	\N
376971	1678	27360856951000	27977	13741	0	0	\N
376972	1678	27360856952000	27977	13741	1	0	\N
376973	1678	27360856953000	27977	13741	2	0	\N
376974	1678	27360856954000	27977	13741	3	0	\N
376975	2192	101000000000	27977	13741	4	0	\N
376976	289	66000000000000	27977	13741	5	0	\N
376977	1678	27360856955000	27977	13741	6	0	\N
376978	1678	27360856956000	27977	13741	7	0	\N
376979	1678	27360856957000	27977	13741	8	0	\N
376980	1678	27360856958000	27977	13741	9	0	\N
376981	1678	27360856959000	27977	13741	10	0	\N
376982	1678	27360856960000	27977	13741	11	0	\N
376983	1678	27360856961000	27977	13741	12	0	\N
376984	1678	27360856962000	27977	13741	13	0	\N
376985	1678	27360856963000	27977	13741	14	0	\N
376986	1678	27360856964000	27977	13741	15	0	\N
376987	1678	27360856965000	27977	13741	16	0	\N
376988	1678	27360856966000	27977	13741	17	0	\N
376989	1678	27360856967000	27977	13741	18	0	\N
376990	1678	27360856968000	27977	13741	19	0	\N
376991	1678	27360856969000	27977	13741	20	0	\N
376992	1678	27360856970000	27977	13741	21	0	\N
376877	1678	27360857031000	27965	13833	2	0	1
376878	1874	37164000	27965	13833	3	0	2
376879	1874	37166000	27965	13833	4	0	2
376880	1874	37168000	27965	13833	5	0	2
376881	1874	37170000	27965	13833	6	0	2
376883	1874	37174000	27965	13833	8	0	2
376884	1874	37177000	27965	13833	9	0	2
376885	1874	37180000	27965	13833	10	0	2
376886	1678	27360857032000	27966	13834	0	0	1
376887	1678	27360857033000	27966	13834	1	0	1
376889	1874	37186000	27966	13834	3	0	2
376929	1678	27360857034000	27971	13835	0	0	1
376930	1678	27360857035000	27971	13835	1	0	1
376931	1678	27360857036000	27971	13835	2	0	1
376933	1874	37191000	27971	13835	4	0	2
376934	1874	37193000	27971	13835	5	0	2
376935	1874	37196000	27971	13835	6	0	2
376936	1874	37199000	27971	13835	7	0	2
376937	1874	37201000	27971	13835	8	0	2
376939	1874	37205000	27971	13835	10	0	2
376962	1678	27360857037000	27974	13836	0	0	1
376963	1874	37207000	27974	13836	1	0	2
376964	1874	37210000	27974	13836	2	0	2
376968	1678	27360857038000	27976	13837	0	0	1
376970	1874	37215000	27976	13837	2	0	2
376993	1678	27360856971000	27977	13741	22	0	\N
376994	1678	27360856972000	27977	13741	23	0	\N
376995	1678	27360856973000	27977	13741	24	0	\N
376996	1678	27360856974000	27977	13741	25	0	\N
376997	1678	27360856975000	27977	13741	26	0	\N
376998	1678	27360856976000	27977	13741	27	0	\N
376999	1678	27360856977000	27977	13741	28	0	\N
377000	1678	27360856978000	27977	13741	29	0	\N
377001	1678	27360856979000	27977	13741	30	0	\N
377002	1678	27360856980000	27977	13741	31	0	\N
377003	1678	27360856981000	27977	13741	32	0	\N
377004	1678	27360856982000	27977	13741	33	0	\N
377005	1678	27360856983000	27977	13741	34	0	\N
377006	1678	27360856984000	27977	13741	35	0	\N
377007	1678	27360856985000	27977	13741	36	0	\N
377008	1678	27360856986000	27977	13741	37	0	\N
377009	1678	27360856987000	27977	13741	38	0	\N
377010	1678	27360856988000	27977	13741	39	0	\N
377011	1678	27360856989000	27977	13741	40	0	\N
377012	1678	27360856990000	27977	13741	41	0	\N
377013	1678	27360856991000	27977	13741	42	0	\N
377014	1678	27360856992000	27977	13741	43	0	\N
377015	1678	27360856993000	27977	13741	44	0	\N
377016	1678	27360856994000	27977	13741	45	0	\N
377017	1678	27360856995000	27977	13741	47	0	\N
377018	1678	27360856996000	27977	13741	48	0	\N
377019	1678	27360856997000	27977	13741	49	0	\N
377020	1678	27360856998000	27977	13741	50	0	\N
377021	1678	27360856999000	27977	13741	51	0	\N
377022	1678	27360857000000	27977	13741	52	0	\N
377023	1678	27360857001000	27977	13741	53	0	\N
377024	1678	27360857002000	27977	13741	54	0	\N
377025	1678	27360857003000	27977	13741	55	0	\N
377026	1678	27360857004000	27977	13741	56	0	\N
377027	1678	27360857005000	27977	13741	57	0	\N
377028	1678	27360857006000	27977	13741	58	0	\N
377029	1678	27360857007000	27977	13741	59	0	\N
377030	1678	27360857008000	27977	13741	60	0	\N
377031	1678	27360857009000	27977	13741	61	0	\N
377032	1678	27360857010000	27977	13741	62	0	\N
377033	1678	27360857011000	27977	13741	63	0	\N
377034	1678	27360857012000	27977	13741	64	0	\N
377035	1678	27360857013000	27977	13741	65	0	\N
377036	1678	27360857014000	27977	13741	66	0	\N
377037	1678	27360857015000	27977	13741	67	0	\N
377038	1678	27360857016000	27977	13741	68	0	\N
377039	1678	27360857017000	27977	13741	69	0	\N
377040	1678	27360857018000	27977	13741	70	0	\N
377041	1678	27360857019000	27977	13741	71	0	\N
377042	1678	27360857020000	27977	13741	72	0	\N
377043	1678	27360857021000	27977	13741	73	0	\N
377044	1678	27360857022000	27977	13741	74	0	\N
377045	1678	27360857023000	27977	13741	75	0	\N
377046	1678	27360857024000	27977	13741	76	0	\N
377047	1678	27360857025000	27977	13741	77	0	\N
377048	1678	27360857026000	27977	13741	78	0	\N
377049	1678	27360857027000	27977	13741	79	0	\N
377050	1678	27360857028000	27977	13741	80	0	\N
377051	1678	27360857029000	27977	13741	81	0	\N
377052	1678	27360857030000	27977	13741	82	0	\N
377053	1678	27360857031000	27977	13741	83	0	\N
377054	1678	27360857032000	27977	13741	84	0	\N
377055	1678	27360857033000	27977	13741	85	0	\N
377056	1678	27360857034000	27977	13741	86	0	\N
377057	1678	27360857035000	27977	13741	87	0	\N
377058	1678	27360857036000	27977	13741	88	0	\N
377059	1865	1299000000	27977	13741	89	0	\N
377060	2387	100000000	27977	13741	90	0	\N
377061	1760	800000000000	27977	13741	91	0	\N
377062	2388	100000000	27977	13741	92	0	\N
377063	2389	100000000	27977	13741	93	0	\N
377064	1874	36665000	27977	13741	94	0	\N
377065	1874	36667000	27977	13741	95	0	\N
377066	1874	36669000	27977	13741	96	0	\N
377067	2391	100000000	27977	13741	97	0	\N
377068	1874	36671000	27977	13741	98	0	\N
377069	1874	36673000	27977	13741	99	0	\N
377070	1874	36675000	27977	13741	100	0	\N
377071	1874	36677000	27977	13741	101	0	\N
377072	1874	36679000	27977	13741	102	0	\N
377073	1874	36681000	27977	13741	103	0	\N
377074	1874	36683000	27977	13741	104	0	\N
377075	1874	36685000	27977	13741	105	0	\N
377076	1874	36687000	27977	13741	106	0	\N
377077	1874	36689000	27977	13741	107	0	\N
377078	1874	36691000	27977	13741	108	0	\N
377079	1874	36693000	27977	13741	109	0	\N
377080	1874	36695000	27977	13741	110	0	\N
377081	1874	36697000	27977	13741	111	0	\N
377082	1874	36699000	27977	13741	112	0	\N
377083	1874	36701000	27977	13741	113	0	\N
377084	1874	36703000	27977	13741	114	0	\N
377085	1874	36705000	27977	13741	115	0	\N
377086	1874	36707000	27977	13741	116	0	\N
377087	1874	36709000	27977	13741	117	0	\N
377088	1874	36711000	27977	13741	118	0	\N
377089	1874	36713000	27977	13741	119	0	\N
377090	1874	36715000	27977	13741	120	0	\N
377091	1874	36717000	27977	13741	121	0	\N
377092	1874	36719000	27977	13741	122	0	\N
377093	1874	36721000	27977	13741	123	0	\N
377094	1874	36723000	27977	13741	124	0	\N
377095	1874	36725000	27977	13741	125	0	\N
377107	1678	27360857042000	27980	13840	0	0	\N
377108	1874	37237000	27980	13840	1	0	\N
377109	1874	37240000	27980	13840	2	0	\N
377110	1678	27360857042000	27981	13840	0	0	\N
377111	1874	37237000	27981	13840	1	0	\N
377112	1874	37240000	27981	13840	2	0	\N
377122	1678	27360857043000	27984	13841	0	0	\N
377123	1678	27360857044000	27984	13841	1	0	\N
377124	1874	37242000	27984	13841	2	0	\N
377125	1874	37244000	27984	13841	3	0	\N
377126	1874	37247000	27984	13841	4	0	\N
377127	1874	37250000	27984	13841	5	0	\N
377098	1874	37217000	27978	13838	2	0	2
377099	1874	37219000	27978	13838	3	0	2
377100	1874	37221000	27978	13838	4	0	2
377101	1874	37224000	27978	13838	5	0	2
377102	1874	37227000	27978	13838	6	0	2
377104	1678	27360857041000	27979	13839	0	0	1
377105	1874	37232000	27979	13839	1	0	2
377106	1874	37235000	27979	13839	2	0	2
377113	1678	27360857042000	27982	13840	0	0	1
377114	1874	37237000	27982	13840	1	0	2
377116	1678	27360857043000	27983	13841	0	0	1
377117	1678	27360857044000	27983	13841	1	0	1
377118	1874	37242000	27983	13841	2	0	2
377119	1874	37244000	27983	13841	3	0	2
377121	1874	37250000	27983	13841	5	0	2
377128	1678	27360857045000	27985	13842	0	0	1
377137	1678	27360857048000	27987	13844	0	0	\N
377138	1678	27360857049000	27987	13844	1	0	\N
377139	1678	27360857050000	27987	13844	2	0	\N
377140	1874	37268000	27987	13844	3	0	\N
377141	1874	37271000	27987	13844	4	0	\N
377142	1874	37274000	27987	13844	5	0	\N
377143	1874	37276000	27987	13844	6	0	\N
377144	1874	37278000	27987	13844	7	0	\N
377145	1874	37280000	27987	13844	8	0	\N
377146	1678	27360857048000	27988	13844	0	0	\N
377147	1678	27360857049000	27988	13844	1	0	\N
377148	1678	27360857050000	27988	13844	2	0	\N
377149	1874	37268000	27988	13844	3	0	\N
377150	1874	37271000	27988	13844	4	0	\N
377151	1874	37274000	27988	13844	5	0	\N
377152	1874	37276000	27988	13844	6	0	\N
377153	1874	37278000	27988	13844	7	0	\N
377154	1874	37280000	27988	13844	8	0	\N
377155	1678	27360857048000	27989	13844	0	0	\N
377156	1678	27360857049000	27989	13844	1	0	\N
377157	1678	27360857050000	27989	13844	2	0	\N
377158	1874	37268000	27989	13844	3	0	\N
377159	1874	37271000	27989	13844	4	0	\N
377160	1874	37274000	27989	13844	5	0	\N
377161	1874	37276000	27989	13844	6	0	\N
377162	1874	37278000	27989	13844	7	0	\N
377163	1874	37280000	27989	13844	8	0	\N
377173	1678	27360857051000	27991	13845	0	0	\N
377174	1874	37283000	27991	13845	1	0	\N
377175	1874	37285000	27991	13845	2	0	\N
377176	1678	27360857051000	27992	13845	0	0	\N
377177	1874	37283000	27992	13845	1	0	\N
377178	1874	37285000	27992	13845	2	0	\N
377182	1678	27360857051000	27994	13845	0	0	\N
377183	1874	37283000	27994	13845	1	0	\N
377184	1874	37285000	27994	13845	2	0	\N
377185	1678	28080869052000	27995	13846	0	0	\N
377186	1874	37288000	27995	13846	1	0	\N
377187	1874	37290000	27995	13846	2	0	\N
377188	1678	28080869052000	27996	13846	0	0	\N
377189	1874	37288000	27996	13846	1	0	\N
377190	1874	37290000	27996	13846	2	0	\N
377197	1678	28080869053000	28000	13847	0	0	\N
377198	1874	37292000	28000	13847	1	0	\N
377199	1874	37295000	28000	13847	2	0	\N
377209	1678	28080869055000	28005	13849	0	0	\N
377210	1678	28080869056000	28005	13849	1	0	\N
377211	1874	37303000	28005	13849	2	0	\N
377212	1874	37306000	28005	13849	3	0	\N
377213	1874	37308000	28005	13849	4	0	\N
377214	1874	37310000	28005	13849	5	0	\N
377215	1678	28080869055000	28006	13849	0	0	\N
377216	1678	28080869056000	28006	13849	1	0	\N
377217	1874	37303000	28006	13849	2	0	\N
377218	1874	37306000	28006	13849	3	0	\N
377219	1874	37308000	28006	13849	4	0	\N
377220	1874	37310000	28006	13849	5	0	\N
377221	1678	28080869057000	28007	13851	0	0	\N
377222	1874	37313000	28007	13851	1	0	\N
377223	1874	37315000	28007	13851	2	0	\N
377224	1678	28080869057000	28008	13851	0	0	\N
377225	1874	37313000	28008	13851	1	0	\N
377226	1874	37315000	28008	13851	2	0	\N
377227	1678	27360857037000	28009	13742	0	0	\N
377228	1678	27360857038000	28009	13742	1	0	\N
377229	1678	27360857039000	28009	13742	2	0	\N
377230	1678	27360857040000	28009	13742	3	0	\N
377231	1678	27360857041000	28009	13742	4	0	\N
377232	1678	27360857042000	28009	13742	5	0	\N
377233	1678	27360857043000	28009	13742	6	0	\N
377234	1678	27360857044000	28009	13742	7	0	\N
377235	1678	27360857045000	28009	13742	8	0	\N
377236	1678	27360857046000	28009	13742	9	0	\N
377237	1678	27360857047000	28009	13742	10	0	\N
377238	1678	27360857048000	28009	13742	11	0	\N
377239	1678	27360857049000	28009	13742	12	0	\N
377240	1678	27360857050000	28009	13742	13	0	\N
377241	1678	27360857051000	28009	13742	14	0	\N
377242	1678	27360857052000	28009	13742	15	0	\N
377243	1678	27360857053000	28009	13742	16	0	\N
377244	1678	27360857054000	28009	13742	17	0	\N
377245	1678	27360857055000	28009	13742	18	0	\N
377246	1678	27360857056000	28009	13742	19	0	\N
377247	1678	27360857057000	28009	13742	20	0	\N
377248	1874	36727000	28009	13742	21	0	\N
377249	1874	36729000	28009	13742	22	0	\N
377250	1874	36731000	28009	13742	23	0	\N
377251	1874	36733000	28009	13742	24	0	\N
377252	1874	36735000	28009	13742	25	0	\N
377253	1874	36737000	28009	13742	26	0	\N
377254	1874	36739000	28009	13742	27	0	\N
377255	1874	36741000	28009	13742	28	0	\N
377256	1874	36743000	28009	13742	29	0	\N
377257	1874	36745000	28009	13742	30	0	\N
377258	1874	36747000	28009	13742	31	0	\N
377259	1874	36749000	28009	13742	32	0	\N
377260	1874	36751000	28009	13742	33	0	\N
377261	1874	36753000	28009	13742	34	0	\N
377262	1874	36755000	28009	13742	35	0	\N
377263	1874	36757000	28009	13742	36	0	\N
377264	1874	36759000	28009	13742	37	0	\N
377131	1678	27360857046000	27986	13843	0	0	1
377132	1678	27360857047000	27986	13843	1	0	1
377133	1874	37258000	27986	13843	2	0	2
377134	1874	37260000	27986	13843	3	0	2
377135	1874	37262000	27986	13843	4	0	2
377164	1678	27360857048000	27990	13844	0	0	1
377165	1678	27360857049000	27990	13844	1	0	1
377166	1678	27360857050000	27990	13844	2	0	1
377167	1874	37268000	27990	13844	3	0	2
377168	1874	37271000	27990	13844	4	0	2
377170	1874	37276000	27990	13844	6	0	2
377171	1874	37278000	27990	13844	7	0	2
377172	1874	37280000	27990	13844	8	0	2
377179	1678	27360857051000	27993	13845	0	0	1
377181	1874	37285000	27993	13845	2	0	2
377191	1678	28080869052000	27997	13846	0	0	1
377192	1874	37288000	27997	13846	1	0	2
377193	1874	37290000	27997	13846	2	0	2
377194	1678	28080869053000	27998	13847	0	0	1
377196	1874	37295000	27998	13847	2	0	2
377200	1678	28080869054000	28002	13848	0	0	1
377201	1874	37298000	28002	13848	1	0	2
377202	1874	37300000	28002	13848	2	0	2
377203	1678	28080869055000	28003	13849	0	0	1
377205	1874	37303000	28004	13850	1	0	2
377206	1874	37306000	28004	13850	2	0	2
377207	1874	37308000	28004	13850	3	0	2
377208	1874	37310000	28004	13850	4	0	2
377265	1874	36761000	28009	13742	38	0	\N
377266	1874	36763000	28009	13742	39	0	\N
377267	1874	36765000	28009	13742	40	0	\N
377268	1874	36767000	28009	13742	41	0	\N
377269	1874	36769000	28009	13742	42	0	\N
377270	1874	36771000	28009	13742	43	0	\N
377271	1874	36773000	28009	13742	44	0	\N
377272	1874	36775000	28009	13742	45	0	\N
377273	1874	36777000	28009	13742	47	0	\N
377274	1874	36779000	28009	13742	48	0	\N
377275	1874	36781000	28009	13742	49	0	\N
377276	1874	36783000	28009	13742	50	0	\N
377277	1874	36785000	28009	13742	51	0	\N
377278	1874	36787000	28009	13742	52	0	\N
377279	1874	36789000	28009	13742	53	0	\N
377280	1874	36791000	28009	13742	54	0	\N
377281	1874	36793000	28009	13742	55	0	\N
377282	1874	36795000	28009	13742	56	0	\N
377283	1874	36797000	28009	13742	57	0	\N
377284	1874	36799000	28009	13742	58	0	\N
377285	1874	36801000	28009	13742	59	0	\N
377286	1874	36803000	28009	13742	60	0	\N
377287	1874	36805000	28009	13742	61	0	\N
377288	1874	36807000	28009	13742	62	0	\N
377289	1874	36809000	28009	13742	63	0	\N
377290	1874	36811000	28009	13742	64	0	\N
377291	1874	36813000	28009	13742	65	0	\N
377292	1874	36815000	28009	13742	66	0	\N
377293	1874	36817000	28009	13742	67	0	\N
377294	1874	36819000	28009	13742	68	0	\N
377295	1874	36821000	28009	13742	69	0	\N
377296	1874	36823000	28009	13742	70	0	\N
377297	1874	36825000	28009	13742	71	0	\N
377298	1874	36827000	28009	13742	72	0	\N
377299	1874	36829000	28009	13742	73	0	\N
377300	1874	36831000	28009	13742	74	0	\N
377301	1874	36833000	28009	13742	75	0	\N
377302	1874	36835000	28009	13742	76	0	\N
377303	1874	36837000	28009	13742	77	0	\N
377304	1874	36839000	28009	13742	78	0	\N
377305	1874	36841000	28009	13742	79	0	\N
377306	1874	36843000	28009	13742	80	0	\N
377307	1874	36845000	28009	13742	81	0	\N
377308	1874	36847000	28009	13742	82	0	\N
377309	1874	36849000	28009	13742	83	0	\N
377310	1874	36851000	28009	13742	84	0	\N
377325	1678	28080869062000	28014	13855	0	0	\N
377326	1874	37336000	28014	13855	1	0	\N
377327	1874	37338000	28014	13855	2	0	\N
377346	1678	28080869068000	28019	13859	0	0	\N
377347	1678	28080869068000	28020	13859	0	0	\N
377348	1874	37365000	28020	13859	1	0	\N
377351	1678	28080869069000	28022	13860	0	0	\N
377352	1874	37368000	28022	13860	1	0	\N
377353	1874	37370000	28022	13860	2	0	\N
377357	1678	28080869070000	28024	13861	0	0	\N
377358	1678	28080869071000	28024	13861	1	0	\N
377359	1874	37372000	28024	13861	2	0	\N
377360	1874	37375000	28024	13861	3	0	\N
377361	1874	37378000	28024	13861	4	0	\N
377362	1874	37380000	28024	13861	5	0	\N
377369	1678	28080869072000	28027	13862	0	0	\N
377370	1874	37382000	28027	13862	1	0	\N
377371	1874	37385000	28027	13862	2	0	\N
377379	1678	28080869074000	28033	13864	0	0	\N
377380	1678	28080869075000	28033	13864	1	0	\N
377381	1678	28080869076000	28033	13864	2	0	\N
377382	1678	28080869077000	28033	13864	3	0	\N
377383	1678	28080869078000	28033	13864	4	0	\N
377384	1874	37393000	28033	13864	5	0	\N
377385	1874	37396000	28033	13864	6	0	\N
377386	1874	37399000	28033	13864	7	0	\N
377387	1874	37402000	28033	13864	8	0	\N
377388	1874	37404000	28033	13864	9	0	\N
377389	1874	37406000	28033	13864	10	0	\N
377390	1874	37408000	28033	13864	11	0	\N
377391	1874	37410000	28033	13864	12	0	\N
377392	1874	37412000	28033	13864	13	0	\N
377393	1874	37415000	28033	13864	14	0	\N
377313	1874	37315000	28010	13851	2	0	2
377314	1678	28080869058000	28011	13852	0	0	1
377315	1874	37318000	28011	13852	1	0	2
377316	1678	28080869059000	28012	13853	0	0	1
377317	1874	37320000	28012	13853	1	0	2
377319	1678	28080869060000	28013	13854	0	0	1
377320	1678	28080869061000	28013	13854	1	0	1
377321	1874	37325000	28013	13854	2	0	2
377322	1874	37328000	28013	13854	3	0	2
377323	1874	37330000	28013	13854	4	0	2
377328	1678	28080869062000	28015	13855	0	0	1
377329	1874	37336000	28015	13855	1	0	2
377330	1874	37338000	28015	13855	2	0	2
377331	1678	28080869063000	28016	13856	0	0	1
377333	1874	37343000	28016	13856	2	0	2
377334	1678	28080869064000	28017	13857	0	0	1
377335	1874	37346000	28017	13857	1	0	2
377336	1874	37348000	28017	13857	2	0	2
377337	1678	28080869065000	28018	13858	0	0	1
377339	1678	28080869067000	28018	13858	2	0	1
377340	1874	37350000	28018	13858	3	0	2
377341	1874	37352000	28018	13858	4	0	2
377342	1874	37354000	28018	13858	5	0	2
377343	1874	37357000	28018	13858	6	0	2
377345	1874	37363000	28018	13858	8	0	2
377349	1678	28080869068000	28021	13859	0	0	1
377350	1874	37365000	28021	13859	1	0	2
377354	1678	28080869069000	28023	13860	0	0	1
377356	1874	37370000	28023	13860	2	0	2
377363	1678	28080869070000	28025	13861	0	0	1
377364	1678	28080869071000	28025	13861	1	0	1
377365	1874	37372000	28025	13861	2	0	2
377366	1874	37375000	28025	13861	3	0	2
377368	1874	37380000	28025	13861	5	0	2
377372	1678	28080869072000	28028	13862	0	0	1
377373	1874	37382000	28028	13862	1	0	2
377374	1874	37385000	28028	13862	2	0	2
377375	1678	28080869073000	28032	13863	0	0	1
377377	1874	37390000	28032	13863	2	0	2
377378	1560	18008867131803	28032	13863	3	0	30
377394	1678	28080869074000	28034	13864	0	0	1
377395	1678	28080869075000	28034	13864	1	0	1
377397	1678	28080869077000	28034	13864	3	0	1
377398	1678	28080869078000	28034	13864	4	0	1
377399	1874	37393000	28034	13864	5	0	2
377400	1874	37396000	28034	13864	6	0	2
377412	1474	15030643000043	28036	13638	0	0	\N
377413	1474	15030643000043	28036	13638	1	0	\N
377414	1474	24390643000043	28036	13638	2	0	\N
377415	2314	69869000000	28036	13638	3	0	\N
377416	38	66539225269421	28036	13638	4	0	\N
377417	2192	101000000000	28036	13638	5	0	\N
377418	1600	0	28036	13638	6	0	\N
377419	969	506877361461968	28036	13638	7	0	\N
377420	2314	138869000000	28036	13638	8	0	\N
377421	289	66000000000000	28036	13638	9	0	\N
377422	2314	207869000000	28036	13638	10	0	\N
377423	2314	386869000000	28036	13638	11	0	\N
377424	2314	418869000000	28036	13638	12	0	\N
377425	1678	27360856741000	28036	13638	13	0	\N
377426	1089	908319888814612	28036	13638	14	0	\N
377427	1209	612861528535553	28036	13638	15	0	\N
377428	1335	1707793141873126	28036	13638	16	0	\N
377429	38	66575050395110	28036	13638	18	0	\N
377430	969	507150018330014	28036	13638	19	0	\N
377431	1089	908808487586029	28036	13638	20	0	\N
377432	1209	613191195862646	28036	13638	21	0	\N
377433	1335	1708711789192456	28036	13638	22	0	\N
377434	1678	27360856742000	28036	13638	25	0	\N
377435	1678	27360856743000	28036	13638	26	0	\N
377436	1678	27360856744000	28036	13638	27	0	\N
377437	1678	27360856745000	28036	13638	28	0	\N
377438	1678	27360856746000	28036	13638	29	0	\N
377439	1678	27360856747000	28036	13638	30	0	\N
377440	1678	27360856748000	28036	13638	31	0	\N
377441	1678	27360856749000	28036	13638	32	0	\N
377442	1678	27360856750000	28036	13638	33	0	\N
377443	1678	27360856751000	28036	13638	34	0	\N
377444	1678	27360856752000	28036	13638	35	0	\N
377445	1678	27360856753000	28036	13638	36	0	\N
377446	1678	27360856754000	28036	13638	37	0	\N
377447	1678	27360856755000	28036	13638	38	0	\N
377448	1678	27360856756000	28036	13638	39	0	\N
377449	1678	27360856757000	28036	13638	40	0	\N
377450	1678	27360856758000	28036	13638	41	0	\N
377451	1678	27360856759000	28036	13638	42	0	\N
377452	1678	27360856760000	28036	13638	43	0	\N
377453	1678	27360856761000	28036	13638	44	0	\N
377454	1678	27360856762000	28036	13638	45	0	\N
377455	1678	27360856763000	28036	13638	46	0	\N
377456	1678	27360856764000	28036	13638	47	0	\N
377457	1678	27360856765000	28036	13638	48	0	\N
377458	1678	27360856766000	28036	13638	49	0	\N
377459	1678	27360856767000	28036	13638	50	0	\N
377460	1678	27360856768000	28036	13638	51	0	\N
377461	1678	27360856769000	28036	13638	52	0	\N
377462	1678	27360856770000	28036	13638	53	0	\N
377463	1678	27360856771000	28036	13638	54	0	\N
377464	1678	27360856772000	28036	13638	55	0	\N
377465	1678	27360856773000	28036	13638	56	0	\N
377466	1474	24290633000043	28036	13638	57	0	\N
377467	1678	27360856774000	28036	13638	58	0	\N
377468	1678	27360856775000	28036	13638	59	0	\N
377469	1678	27360856776000	28036	13638	60	0	\N
377470	1678	27360856777000	28036	13638	61	0	\N
377471	1678	27360856778000	28036	13638	62	0	\N
377472	1678	27360856779000	28036	13638	63	0	\N
377473	1678	27360856780000	28036	13638	64	0	\N
377474	1678	27360856781000	28036	13638	65	0	\N
377475	1678	27360856782000	28036	13638	66	0	\N
377476	1678	27360856783000	28036	13638	67	0	\N
377477	1678	27360856784000	28036	13638	68	0	\N
377478	1678	27360856785000	28036	13638	69	0	\N
377479	1678	27360856786000	28036	13638	70	0	\N
377480	1678	27360856787000	28036	13638	71	0	\N
377481	1678	27360856788000	28036	13638	72	0	\N
377482	1678	27360856789000	28036	13638	73	0	\N
377483	1678	27360856790000	28036	13638	74	0	\N
377484	1678	27360856791000	28036	13638	75	0	\N
377485	1678	27360856792000	28036	13638	76	0	\N
377486	1678	27360856793000	28036	13638	77	0	\N
377487	1678	27360856794000	28036	13638	78	0	\N
377488	1678	27360856795000	28036	13638	79	0	\N
377489	1678	27360856796000	28036	13638	80	0	\N
377490	1678	27360856797000	28036	13638	81	0	\N
377491	1678	27360856798000	28036	13638	82	0	\N
377492	1678	27360856799000	28036	13638	83	0	\N
377493	1678	27360856800000	28036	13638	84	0	\N
377494	1678	27360856801000	28036	13638	85	0	\N
377495	1678	27360856802000	28036	13638	86	0	\N
377496	1678	27360856803000	28036	13638	87	0	\N
377497	1678	27360856804000	28036	13638	88	0	\N
377498	1678	27360856805000	28036	13638	89	0	\N
377499	1678	27360856806000	28036	13638	90	0	\N
377500	1678	27360856807000	28036	13638	91	0	\N
377501	1678	27360856808000	28036	13638	92	0	\N
377502	1678	27360856809000	28036	13638	93	0	\N
377503	1678	27360856810000	28036	13638	94	0	\N
377504	1678	27360856811000	28036	13638	95	0	\N
377505	1474	24290633000043	28036	13638	96	0	\N
377506	2152	109988998000000	28036	13638	97	0	\N
377507	1678	27360856812000	28036	13638	98	0	\N
377508	1678	27360856813000	28036	13638	99	0	\N
377509	1678	27360856814000	28036	13638	100	0	\N
377510	1678	27360856815000	28036	13638	101	0	\N
377511	1678	27360856816000	28036	13638	102	0	\N
377512	1678	27360856817000	28036	13638	103	0	\N
377513	1678	27360856818000	28036	13638	104	0	\N
377514	1678	27360856819000	28036	13638	105	0	\N
377515	1678	27360856820000	28036	13638	106	0	\N
377516	1678	27360856821000	28036	13638	107	0	\N
377517	1678	27360856822000	28036	13638	108	0	\N
377518	1678	27360856823000	28036	13638	109	0	\N
377519	1678	27360856824000	28036	13638	110	0	\N
377520	1678	27360856825000	28036	13638	111	0	\N
377521	1678	27360856826000	28036	13638	112	0	\N
377522	1678	27360856827000	28036	13638	113	0	\N
377523	1678	27360856828000	28036	13638	114	0	\N
377524	1678	27360856829000	28036	13638	115	0	\N
377525	1678	27360856830000	28036	13638	116	0	\N
377526	1678	27360856831000	28036	13638	117	0	\N
377527	1678	27360856832000	28036	13638	118	0	\N
377528	1678	27360856833000	28036	13638	119	0	\N
377529	1678	27360856834000	28036	13638	120	0	\N
377530	1678	27360856835000	28036	13638	121	0	\N
377531	1678	27360856836000	28036	13638	122	0	\N
377532	1678	27360856837000	28036	13638	123	0	\N
377533	1678	27360856838000	28036	13638	124	0	\N
377534	1678	27360856839000	28036	13638	125	0	\N
377535	1678	28080869080000	28037	13866	0	0	\N
377536	1874	37422000	28037	13866	1	0	\N
377403	1874	37404000	28034	13864	9	0	2
377404	1874	37406000	28034	13864	10	0	2
377405	1874	37408000	28034	13864	11	0	2
377406	1874	37410000	28034	13864	12	0	2
377407	1874	37412000	28034	13864	13	0	2
377409	1678	28080869079000	28035	13865	0	0	1
377410	1874	37417000	28035	13865	1	0	2
377411	1874	37420000	28035	13865	2	0	2
377537	1874	37425000	28037	13866	2	0	\N
377541	1678	28080869081000	28039	13867	0	0	\N
377542	1874	37428000	28039	13867	1	0	\N
377549	1874	37433000	28042	13868	0	0	\N
377550	1874	37435000	28042	13868	1	0	\N
377559	1678	28080869085000	28047	13871	0	0	\N
377560	1874	37453000	28047	13871	1	0	\N
377561	1874	37455000	28047	13871	2	0	\N
377562	1678	28080869085000	28048	13871	0	0	\N
377563	1874	37453000	28048	13871	1	0	\N
377564	1874	37455000	28048	13871	2	0	\N
377568	2192	101000000000	28050	13627	0	0	\N
377569	289	66000000000000	28050	13627	1	0	\N
377570	1865	1299000000	28050	13627	2	0	\N
377571	2387	100000000	28050	13627	3	0	\N
377572	1760	800000000000	28050	13627	4	0	\N
377573	2388	100000000	28050	13627	5	0	\N
377574	2389	100000000	28050	13627	6	0	\N
377575	2391	100000000	28050	13627	7	0	\N
377576	1678	28080869086000	28051	13872	0	0	\N
377580	1678	28080869086000	28053	13872	0	0	\N
377581	1874	37458000	28053	13872	1	0	\N
377582	1678	28080869086000	28054	13872	0	0	\N
377583	1874	37458000	28054	13872	1	0	\N
377584	1874	37460000	28054	13872	2	0	\N
377585	1678	28080869086000	28055	13872	0	0	\N
377586	1874	37458000	28055	13872	1	0	\N
377587	1874	37460000	28055	13872	2	0	\N
377591	1678	28080869088000	28057	13874	0	0	\N
377592	1874	37467000	28057	13874	1	0	\N
377593	1874	37470000	28057	13874	2	0	\N
377594	1678	28080869088000	28058	13874	0	0	\N
377595	1874	37467000	28058	13874	1	0	\N
377596	1874	37470000	28058	13874	2	0	\N
377597	1678	28080869088000	28059	13874	0	0	\N
377598	1874	37467000	28059	13874	1	0	\N
377599	1874	37470000	28059	13874	2	0	\N
377609	1678	28080869090000	28063	13876	0	0	\N
377610	1874	37477000	28063	13876	1	0	\N
377611	1874	37480000	28063	13876	2	0	\N
377612	1678	28080869090000	28064	13876	0	0	\N
377613	1874	37477000	28064	13876	1	0	\N
377614	1874	37480000	28064	13876	2	0	\N
377624	1678	28080869094000	28066	13878	0	0	\N
377625	1678	28080869095000	28066	13878	1	0	\N
377626	1874	37497000	28066	13878	2	0	\N
377627	1874	37499000	28066	13878	3	0	\N
377628	1874	37502000	28066	13878	4	0	\N
377629	1874	37505000	28066	13878	5	0	\N
377636	1678	28080869096000	28068	13879	0	0	\N
377637	1874	37507000	28068	13879	1	0	\N
377638	1874	37510000	28068	13879	2	0	\N
377639	2392	100000000	28068	13879	3	0	\N
377644	1678	28080869097000	28070	13880	0	0	\N
377645	1678	28080869098000	28070	13880	1	0	\N
377646	1874	37512000	28070	13880	2	0	\N
377647	1874	37514000	28070	13880	3	0	\N
377654	1678	28080869097000	28072	13880	0	0	\N
377655	1678	28080869098000	28072	13880	1	0	\N
377656	1874	37513000	28072	13880	2	0	\N
377657	1874	37516000	28072	13880	3	0	\N
377658	1874	37518000	28072	13880	4	0	\N
377659	1874	37520000	28072	13880	5	0	\N
377660	1678	27360856840000	28073	13639	0	0	\N
377661	1678	27360856841000	28073	13639	1	0	\N
377662	1678	27360856842000	28073	13639	2	0	\N
377663	1678	27360856843000	28073	13639	3	0	\N
377664	1678	27360856844000	28073	13639	4	0	\N
377665	1678	27360856845000	28073	13639	5	0	\N
377666	1678	27360856846000	28073	13639	6	0	\N
377667	1678	27360856847000	28073	13639	7	0	\N
377668	1678	27360856848000	28073	13639	8	0	\N
377669	1678	27360856849000	28073	13639	9	0	\N
377670	1678	27360856850000	28073	13639	10	0	\N
377671	1678	27360856851000	28073	13639	11	0	\N
377672	1678	27360856852000	28073	13639	12	0	\N
377540	1874	37425000	28038	13866	2	0	2
377543	1678	28080869081000	28040	13867	0	0	1
377544	1874	37428000	28040	13867	1	0	2
377545	1874	37430000	28040	13867	2	0	2
377546	1678	28080869082000	28041	13868	0	0	1
377548	1874	37435000	28041	13868	2	0	2
377551	1874	37437000	28043	13869	0	0	2
377552	1874	37440000	28043	13869	1	0	2
377553	1678	28080869083000	28044	13870	0	0	1
377554	1678	28080869084000	28044	13870	1	0	1
377556	1874	37446000	28044	13870	3	0	2
377557	1874	37448000	28044	13870	4	0	2
377558	1874	37450000	28044	13870	5	0	2
377565	1678	28080869085000	28049	13871	0	0	1
377567	1874	37455000	28049	13871	2	0	2
377577	1678	28080869086000	28052	13872	0	0	1
377578	1874	37458000	28052	13872	1	0	2
377579	1874	37460000	28052	13872	2	0	2
377588	1678	28080869087000	28056	13873	0	0	1
377590	1874	37465000	28056	13873	2	0	2
377600	1678	28080869088000	28060	13874	0	0	1
377601	1874	37467000	28060	13874	1	0	2
377602	1874	37470000	28060	13874	2	0	2
377603	1678	28080869089000	28061	13875	0	0	1
377605	1874	37475000	28061	13875	2	0	2
377606	1678	28080869090000	28062	13876	0	0	1
377607	1874	37477000	28062	13876	1	0	2
377608	1874	37480000	28062	13876	2	0	2
377616	1678	28080869092000	28065	13877	1	0	1
377617	1678	28080869093000	28065	13877	2	0	1
377618	1874	37482000	28065	13877	3	0	2
377619	1874	37484000	28065	13877	4	0	2
377620	1874	37486000	28065	13877	5	0	2
377622	1874	37492000	28065	13877	7	0	2
377623	1874	37495000	28065	13877	8	0	2
377630	1678	28080869094000	28067	13878	0	0	1
377631	1678	28080869095000	28067	13878	1	0	1
377632	1874	37497000	28067	13878	2	0	2
377634	1874	37502000	28067	13878	4	0	2
377635	1874	37505000	28067	13878	5	0	2
377640	1678	28080869096000	28069	13879	0	0	1
377641	1874	37507000	28069	13879	1	0	2
377643	2392	100000000	28069	13879	3	0	0
377648	1678	28080869097000	28071	13880	0	0	1
377649	1678	28080869098000	28071	13880	1	0	1
377650	1874	37513000	28071	13880	2	0	2
377651	1874	37516000	28071	13880	3	0	2
377653	1874	37520000	28071	13880	5	0	2
377673	1678	27360856853000	28073	13639	13	0	\N
377674	1678	27360856854000	28073	13639	14	0	\N
377675	1678	27360856855000	28073	13639	15	0	\N
377676	1678	27360856856000	28073	13639	16	0	\N
377677	1678	27360856857000	28073	13639	17	0	\N
377678	1678	27360856858000	28073	13639	18	0	\N
377679	1678	27360856859000	28073	13639	19	0	\N
377680	1678	27360856860000	28073	13639	20	0	\N
377681	1678	27360856861000	28073	13639	21	0	\N
377682	1678	27360856862000	28073	13639	22	0	\N
377683	1678	27360856863000	28073	13639	24	0	\N
377684	1678	27360856864000	28073	13639	25	0	\N
377685	1678	27360856865000	28073	13639	26	0	\N
377686	1678	27360856866000	28073	13639	27	0	\N
377687	1678	27360856867000	28073	13639	28	0	\N
377688	1678	27360856868000	28073	13639	29	0	\N
377689	1678	27360856869000	28073	13639	30	0	\N
377690	1678	27360856870000	28073	13639	31	0	\N
377691	1678	27360856871000	28073	13639	32	0	\N
377692	1678	27360856872000	28073	13639	33	0	\N
377693	1678	27360856873000	28073	13639	34	0	\N
377694	1678	27360856874000	28073	13639	35	0	\N
377695	1678	27360856875000	28073	13639	36	0	\N
377696	1678	27360856876000	28073	13639	37	0	\N
377697	1678	27360856877000	28073	13639	38	0	\N
377698	1678	27360856878000	28073	13639	39	0	\N
377699	1678	27360856879000	28073	13639	40	0	\N
377700	1678	27360856880000	28073	13639	41	0	\N
377701	1678	27360856881000	28073	13639	42	0	\N
377702	1678	27360856882000	28073	13639	43	0	\N
377703	1678	27360856883000	28073	13639	44	0	\N
377704	1678	27360856884000	28073	13639	45	0	\N
377705	1678	27360856885000	28073	13639	46	0	\N
377706	1678	27360856886000	28073	13639	47	0	\N
377707	1678	27360856887000	28073	13639	48	0	\N
377708	1678	27360856888000	28073	13639	49	0	\N
377709	1678	27360856889000	28073	13639	50	0	\N
377710	1678	27360856890000	28073	13639	51	0	\N
377711	1678	27360856891000	28073	13639	52	0	\N
377712	1678	27360856892000	28073	13639	53	0	\N
377713	1678	27360856893000	28073	13639	54	0	\N
377714	1678	27360856894000	28073	13639	55	0	\N
377715	1678	27360856895000	28073	13639	56	0	\N
377716	1678	27360856896000	28073	13639	57	0	\N
377717	1678	27360856897000	28073	13639	58	0	\N
377718	1678	27360856898000	28073	13639	59	0	\N
377719	1678	27360856899000	28073	13639	60	0	\N
377720	1678	27360856900000	28073	13639	61	0	\N
377721	1678	27360856901000	28073	13639	62	0	\N
377722	1678	27360856902000	28073	13639	63	0	\N
377723	1678	27360856903000	28073	13639	64	0	\N
377724	1678	27360856904000	28073	13639	65	0	\N
377725	1678	27360856905000	28073	13639	66	0	\N
377726	1678	27360856906000	28073	13639	67	0	\N
377727	1678	27360856907000	28073	13639	68	0	\N
377728	1678	27360856908000	28073	13639	69	0	\N
377729	1678	27360856909000	28073	13639	70	0	\N
377730	1678	27360856910000	28073	13639	71	0	\N
377731	1678	27360856911000	28073	13639	72	0	\N
377732	1678	27360856912000	28073	13639	73	0	\N
377733	1678	27360856913000	28073	13639	74	0	\N
377734	1678	27360856914000	28073	13639	75	0	\N
377735	1678	27360856915000	28073	13639	76	0	\N
377736	1678	27360856916000	28073	13639	77	0	\N
377737	1678	27360856917000	28073	13639	78	0	\N
377738	1678	27360856918000	28073	13639	79	0	\N
377739	1678	27360856919000	28073	13639	80	0	\N
377740	1678	27360856920000	28073	13639	81	0	\N
377741	1678	27360856921000	28073	13639	82	0	\N
377742	1678	27360856922000	28073	13639	83	0	\N
377743	1678	27360856923000	28073	13639	84	0	\N
377744	1678	27360856924000	28073	13639	85	0	\N
377745	1678	27360856925000	28073	13639	86	0	\N
377746	1678	27360856926000	28073	13639	87	0	\N
377747	1678	27360856927000	28073	13639	88	0	\N
377748	1678	27360856928000	28073	13639	89	0	\N
377749	1678	27360856929000	28073	13639	90	0	\N
377750	1678	27360856930000	28073	13639	91	0	\N
377751	1678	27360856931000	28073	13639	92	0	\N
377752	1678	27360856932000	28073	13639	93	0	\N
377753	1678	27360856933000	28073	13639	94	0	\N
377754	1678	27360856934000	28073	13639	95	0	\N
377755	1678	27360856935000	28073	13639	96	0	\N
377756	1678	27360856936000	28073	13639	97	0	\N
377757	1678	27360856937000	28073	13639	98	0	\N
377758	1678	27360856938000	28073	13639	99	0	\N
377759	1678	27360856939000	28073	13639	100	0	\N
377760	1678	27360856940000	28073	13639	101	0	\N
377761	1678	27360856941000	28073	13639	102	0	\N
377762	1678	27360856942000	28073	13639	103	0	\N
377763	1678	27360856943000	28073	13639	104	0	\N
377764	1678	27360856944000	28073	13639	105	0	\N
377765	1678	27360856945000	28073	13639	106	0	\N
377766	1678	27360856946000	28073	13639	107	0	\N
377767	1678	27360856947000	28073	13639	108	0	\N
377768	1678	27360856948000	28073	13639	109	0	\N
377769	1678	27360856949000	28073	13639	110	0	\N
377770	1678	27360856950000	28073	13639	111	0	\N
377771	1678	27360856951000	28073	13639	112	0	\N
377772	1678	27360856952000	28073	13639	113	0	\N
377773	1678	27360856953000	28073	13639	114	0	\N
377774	1678	27360856954000	28073	13639	115	0	\N
377775	1678	27360856955000	28073	13639	116	0	\N
377776	1678	27360856956000	28073	13639	117	0	\N
377777	1678	27360856957000	28073	13639	118	0	\N
377778	1678	27360856958000	28073	13639	119	0	\N
377779	1678	27360856959000	28073	13639	120	0	\N
377780	1678	27360856960000	28073	13639	121	0	\N
377781	1678	27360856961000	28073	13639	122	0	\N
377782	1678	27360856962000	28073	13639	123	0	\N
377783	1678	27360856963000	28073	13639	124	0	\N
377784	1678	27360856964000	28073	13639	125	0	\N
377785	1678	28080869099000	28074	13881	0	0	\N
377786	1678	28080869100000	28074	13881	1	0	\N
377787	1678	28080869101000	28074	13881	2	0	\N
377788	1678	28080869102000	28074	13881	3	0	\N
377789	1678	28080869103000	28074	13881	4	0	\N
377790	1874	37522000	28074	13881	5	0	\N
377791	1874	37524000	28074	13881	6	0	\N
377792	1874	37526000	28074	13881	7	0	\N
377793	1874	37528000	28074	13881	8	0	\N
377794	1874	37530000	28074	13881	9	0	\N
377795	1874	37533000	28074	13881	10	0	\N
377796	1874	37536000	28074	13881	11	0	\N
377797	1874	37539000	28074	13881	12	0	\N
377798	1874	37542000	28074	13881	13	0	\N
377799	1874	37545000	28074	13881	14	0	\N
377800	1678	28080869099000	28075	13881	0	0	\N
377801	1678	28080869100000	28075	13881	1	0	\N
377802	1678	28080869101000	28075	13881	2	0	\N
377803	1678	28080869102000	28075	13881	3	0	\N
377804	1678	28080869103000	28075	13881	4	0	\N
377805	1874	37522000	28075	13881	5	0	\N
377806	1874	37524000	28075	13881	6	0	\N
377807	1874	37526000	28075	13881	7	0	\N
377808	1874	37528000	28075	13881	8	0	\N
377809	1874	37530000	28075	13881	9	0	\N
377810	1678	28080869099000	28076	13881	0	0	\N
377811	1678	28080869100000	28076	13881	1	0	\N
377812	1678	28080869101000	28076	13881	2	0	\N
377813	1678	28080869102000	28076	13881	3	0	\N
377814	1678	28080869103000	28076	13881	4	0	\N
377815	1874	37522000	28076	13881	5	0	\N
377816	1874	37524000	28076	13881	6	0	\N
377817	1874	37526000	28076	13881	7	0	\N
377818	1874	37528000	28076	13881	8	0	\N
377819	1874	37530000	28076	13881	9	0	\N
377820	1874	37533000	28076	13881	10	0	\N
377821	1874	37536000	28076	13881	11	0	\N
377822	1874	37539000	28076	13881	12	0	\N
377823	1874	37542000	28076	13881	13	0	\N
377824	1874	37545000	28076	13881	14	0	\N
377830	2392	100000000	28078	13872	0	0	\N
377831	1678	28080869099000	28079	13882	0	0	\N
377832	1678	28080869100000	28079	13882	1	0	\N
377833	1678	28080869101000	28079	13882	2	0	\N
377834	1678	28080869102000	28079	13882	3	0	\N
377835	1678	28080869103000	28079	13882	4	0	\N
377836	1678	28080869104000	28079	13882	5	0	\N
377837	1678	28080869105000	28079	13882	6	0	\N
377838	1678	28080869106000	28079	13882	7	0	\N
377839	1874	37532000	28079	13882	8	0	\N
377840	1874	37534000	28079	13882	9	0	\N
377841	1874	37536000	28079	13882	10	0	\N
377842	1874	37539000	28079	13882	11	0	\N
377843	1874	37542000	28079	13882	12	0	\N
377844	1874	37545000	28079	13882	13	0	\N
377845	1874	37548000	28079	13882	14	0	\N
377846	1874	37551000	28079	13882	15	0	\N
377847	1874	37554000	28079	13882	16	0	\N
377848	1874	37557000	28079	13882	17	0	\N
377849	1874	37560000	28079	13882	18	0	\N
377850	1678	28080869099000	28080	13882	0	0	\N
377851	1678	28080869100000	28080	13882	1	0	\N
377852	1678	28080869101000	28080	13882	2	0	\N
377853	1678	28080869102000	28080	13882	3	0	\N
377854	1678	28080869103000	28080	13882	4	0	\N
377855	1678	28080869104000	28080	13882	5	0	\N
377856	1678	28080869105000	28080	13882	6	0	\N
377857	1678	28080869106000	28080	13882	7	0	\N
377858	1874	37532000	28080	13882	8	0	\N
377859	1874	37534000	28080	13882	9	0	\N
377860	1874	37536000	28080	13882	10	0	\N
377861	1874	37539000	28080	13882	11	0	\N
377862	1874	37542000	28080	13882	12	0	\N
377863	1874	37545000	28080	13882	13	0	\N
377864	1874	37548000	28080	13882	14	0	\N
377865	1874	37551000	28080	13882	15	0	\N
377866	1874	37554000	28080	13882	16	0	\N
377867	1874	37557000	28080	13882	17	0	\N
377868	1874	37560000	28080	13882	18	0	\N
377901	1678	28080869111000	28084	13885	0	0	\N
377902	1678	28080869112000	28084	13885	1	0	\N
377903	1874	37583000	28084	13885	2	0	\N
377904	1874	37585000	28084	13885	3	0	\N
377905	1874	37588000	28084	13885	4	0	\N
377906	1874	37591000	28084	13885	5	0	\N
377907	1678	28080869111000	28085	13885	0	0	\N
377908	1678	28080869112000	28085	13885	1	0	\N
377909	1874	37583000	28085	13885	2	0	\N
377910	1874	37585000	28085	13885	3	0	\N
377911	1874	37588000	28085	13885	4	0	\N
377912	1874	37591000	28085	13885	5	0	\N
377913	1678	28080869111000	28086	13885	0	0	\N
377914	1678	28080869112000	28086	13885	1	0	\N
377915	1874	37583000	28086	13885	2	0	\N
377916	1874	37585000	28086	13885	3	0	\N
377917	1874	37588000	28086	13885	4	0	\N
377918	1874	37591000	28086	13885	5	0	\N
377929	1678	28080869113000	28089	13886	0	0	\N
377930	1874	37594000	28089	13886	1	0	\N
377931	1874	37595000	28089	13886	2	0	\N
377932	1874	37597000	28089	13886	3	0	\N
377933	1678	28080869113000	28090	13886	0	0	\N
377934	1874	37594000	28090	13886	1	0	\N
377935	1874	37595000	28090	13886	2	0	\N
377936	1874	37597000	28090	13886	3	0	\N
377937	1678	28080869114000	28091	13887	0	0	\N
377938	1874	37600000	28091	13887	1	0	\N
377939	1874	37602000	28091	13887	2	0	\N
377943	1678	28080869114000	28093	13887	0	0	\N
377944	1874	37600000	28093	13887	1	0	\N
377827	1874	37526000	28077	13881	2	0	2
377828	1874	37528000	28077	13881	3	0	2
377829	1874	37530000	28077	13881	4	0	2
377869	1678	28080869099000	28081	13882	0	0	1
377870	1678	28080869100000	28081	13882	1	0	1
377872	1678	28080869102000	28081	13882	3	0	1
377873	1678	28080869103000	28081	13882	4	0	1
377874	1678	28080869104000	28081	13882	5	0	1
377875	1678	28080869105000	28081	13882	6	0	1
377876	1678	28080869106000	28081	13882	7	0	1
377878	1874	37534000	28081	13882	9	0	2
377879	1874	37536000	28081	13882	10	0	2
377880	1874	37539000	28081	13882	11	0	2
377881	1874	37542000	28081	13882	12	0	2
377883	1874	37548000	28081	13882	14	0	2
377884	1874	37551000	28081	13882	15	0	2
377885	1874	37554000	28081	13882	16	0	2
377886	1874	37557000	28081	13882	17	0	2
377887	1874	37560000	28081	13882	18	0	2
377889	1874	37563000	28082	13883	1	0	2
377890	1874	37565000	28082	13883	2	0	2
377891	1678	28080869108000	28083	13884	0	0	1
377892	1678	28080869109000	28083	13884	1	0	1
377893	1678	28080869110000	28083	13884	2	0	1
377895	1874	37570000	28083	13884	5	0	2
377896	1874	37572000	28083	13884	6	0	2
377897	1874	37574000	28083	13884	7	0	2
377898	1874	37575000	28083	13884	8	0	2
377900	1874	37581000	28083	13884	10	0	2
377919	1678	28080869111000	28087	13885	0	0	1
377920	1678	28080869112000	28087	13885	1	0	1
377921	1874	37583000	28087	13885	2	0	2
377922	1874	37585000	28087	13885	3	0	2
377924	1874	37591000	28087	13885	5	0	2
377925	1678	28080869113000	28088	13886	0	0	1
377926	1874	37594000	28088	13886	1	0	2
377927	1874	37595000	28088	13886	2	0	2
377928	1874	37597000	28088	13886	3	0	2
377941	1874	37600000	28092	13887	1	0	2
377942	1874	37602000	28092	13887	2	0	2
377945	1874	37602000	28093	13887	2	0	\N
377946	1678	28080869114000	28094	13887	0	0	\N
377947	1874	37600000	28094	13887	1	0	\N
377948	1874	37602000	28094	13887	2	0	\N
377956	1678	28080869116000	28097	13889	0	0	\N
377957	1874	37610000	28097	13889	1	0	\N
377958	1874	37611000	28097	13889	2	0	\N
377959	1874	37613000	28097	13889	3	0	\N
377960	1678	28080869117000	28098	13890	0	0	\N
377961	1678	28080869118000	28098	13890	1	0	\N
377962	1678	28080869119000	28098	13890	2	0	\N
377963	1874	37616000	28098	13890	3	0	\N
377964	1874	37618000	28098	13890	4	0	\N
377965	1874	37619000	28098	13890	5	0	\N
377966	1874	37621000	28098	13890	6	0	\N
377967	1874	37623000	28098	13890	7	0	\N
377968	1874	37626000	28098	13890	8	0	\N
377969	1874	37629000	28098	13890	9	0	\N
377980	1678	28080869117000	28100	13890	0	0	\N
377981	1678	28080869118000	28100	13890	1	0	\N
377982	1678	28080869119000	28100	13890	2	0	\N
377983	1874	37616000	28100	13890	3	0	\N
377984	1874	37618000	28100	13890	4	0	\N
377985	1874	37619000	28100	13890	5	0	\N
377986	1874	37621000	28100	13890	6	0	\N
377987	1874	37623000	28100	13890	7	0	\N
377988	1874	37626000	28100	13890	8	0	\N
377989	1874	37629000	28100	13890	9	0	\N
377993	1678	28080869120000	28102	13891	0	0	\N
377994	1874	37632000	28102	13891	1	0	\N
377995	1874	37634000	28102	13891	2	0	\N
377999	2192	101000000000	28104	13758	0	0	\N
378000	289	66000000000000	28104	13758	1	0	\N
378001	1678	27360856922000	28104	13758	2	0	\N
378002	1678	27360856923000	28104	13758	3	0	\N
378003	1678	27360856924000	28104	13758	4	0	\N
378004	1678	27360856925000	28104	13758	5	0	\N
378005	1678	27360856926000	28104	13758	6	0	\N
378006	1678	27360856927000	28104	13758	7	0	\N
378007	1678	27360856928000	28104	13758	8	0	\N
378008	1678	27360856929000	28104	13758	9	0	\N
378009	1678	27360856930000	28104	13758	10	0	\N
378010	1678	27360856931000	28104	13758	11	0	\N
378011	1678	27360856932000	28104	13758	12	0	\N
378012	1678	27360856933000	28104	13758	13	0	\N
378013	1678	27360856934000	28104	13758	14	0	\N
378014	1678	27360856935000	28104	13758	15	0	\N
378015	1678	27360856936000	28104	13758	16	0	\N
378016	1678	27360856937000	28104	13758	17	0	\N
378017	1678	27360856938000	28104	13758	18	0	\N
378018	1678	27360856939000	28104	13758	19	0	\N
378019	1678	27360856940000	28104	13758	20	0	\N
378020	1678	27360856941000	28104	13758	21	0	\N
378021	1678	27360856942000	28104	13758	22	0	\N
378022	1678	27360856943000	28104	13758	23	0	\N
378023	1678	27360856944000	28104	13758	24	0	\N
378024	1678	27360856945000	28104	13758	25	0	\N
378025	1678	27360856946000	28104	13758	26	0	\N
378026	1678	27360856947000	28104	13758	27	0	\N
378027	1678	27360856948000	28104	13758	28	0	\N
378028	1678	27360856949000	28104	13758	29	0	\N
378029	1678	27360856950000	28104	13758	30	0	\N
378030	1678	27360856951000	28104	13758	31	0	\N
378031	1678	27360856952000	28104	13758	32	0	\N
378032	1678	27360856953000	28104	13758	33	0	\N
378033	1678	27360856954000	28104	13758	34	0	\N
378034	1678	27360856955000	28104	13758	35	0	\N
378035	1678	27360856956000	28104	13758	36	0	\N
378036	1678	27360856957000	28104	13758	37	0	\N
378037	1678	27360856958000	28104	13758	38	0	\N
378038	1678	27360856959000	28104	13758	39	0	\N
378039	1678	27360856960000	28104	13758	40	0	\N
378040	1678	27360856961000	28104	13758	41	0	\N
378041	1678	27360856962000	28104	13758	42	0	\N
378042	1678	27360856963000	28104	13758	43	0	\N
378043	1678	27360856964000	28104	13758	44	0	\N
378044	1678	27360856965000	28104	13758	45	0	\N
378045	1678	27360856966000	28104	13758	46	0	\N
378046	1678	27360856967000	28104	13758	47	0	\N
378047	1678	27360856968000	28104	13758	48	0	\N
378048	1678	27360856969000	28104	13758	49	0	\N
378049	1678	27360856970000	28104	13758	50	0	\N
378050	1678	27360856971000	28104	13758	51	0	\N
378051	1678	27360856972000	28104	13758	52	0	\N
378052	1678	27360856973000	28104	13758	53	0	\N
378053	1678	27360856974000	28104	13758	54	0	\N
378054	1678	27360856975000	28104	13758	55	0	\N
378055	1678	27360856976000	28104	13758	56	0	\N
378056	1678	27360856977000	28104	13758	57	0	\N
378057	1678	27360856978000	28104	13758	58	0	\N
378058	1678	27360856979000	28104	13758	59	0	\N
378059	1678	27360856980000	28104	13758	60	0	\N
378060	1678	27360856981000	28104	13758	61	0	\N
378061	1678	27360856982000	28104	13758	62	0	\N
378062	1678	27360856983000	28104	13758	64	0	\N
378063	1678	27360856984000	28104	13758	65	0	\N
378064	1678	27360856985000	28104	13758	66	0	\N
378065	1678	27360856986000	28104	13758	67	0	\N
378066	1678	27360856987000	28104	13758	68	0	\N
378067	1678	27360856988000	28104	13758	69	0	\N
378068	1678	27360856989000	28104	13758	70	0	\N
378069	1678	27360856990000	28104	13758	71	0	\N
378070	1678	27360856991000	28104	13758	72	0	\N
378071	1678	27360856992000	28104	13758	73	0	\N
378072	1678	27360856993000	28104	13758	74	0	\N
378073	1678	27360856994000	28104	13758	75	0	\N
378074	1678	27360856995000	28104	13758	76	0	\N
378075	1678	27360856996000	28104	13758	77	0	\N
378076	1678	27360856997000	28104	13758	78	0	\N
378077	1678	27360856998000	28104	13758	79	0	\N
378078	1678	27360856999000	28104	13758	80	0	\N
378079	1678	27360857000000	28104	13758	81	0	\N
378080	1678	27360857001000	28104	13758	82	0	\N
377951	1874	37607000	28095	13888	2	0	2
377952	1678	28080869116000	28096	13889	0	0	1
377953	1874	37610000	28096	13889	1	0	2
377954	1874	37611000	28096	13889	2	0	2
377955	1874	37613000	28096	13889	3	0	2
377971	1678	28080869118000	28099	13890	1	0	1
377972	1678	28080869119000	28099	13890	2	0	1
377973	1874	37616000	28099	13890	3	0	2
377974	1874	37618000	28099	13890	4	0	2
377975	1874	37619000	28099	13890	5	0	2
377977	1874	37623000	28099	13890	7	0	2
377978	1874	37626000	28099	13890	8	0	2
377979	1874	37629000	28099	13890	9	0	2
377990	1678	28080869120000	28101	13891	0	0	1
377992	1874	37634000	28101	13891	2	0	2
377996	1678	28080869121000	28103	13892	0	0	1
377997	1874	37637000	28103	13892	1	0	2
377998	1874	37639000	28103	13892	2	0	2
378081	1678	27360857002000	28104	13758	83	0	\N
378082	1678	27360857003000	28104	13758	84	0	\N
378083	1678	27360857004000	28104	13758	85	0	\N
378084	1678	27360857005000	28104	13758	86	0	\N
378085	1678	27360857006000	28104	13758	87	0	\N
378086	1678	27360857007000	28104	13758	88	0	\N
378087	1678	27360857008000	28104	13758	89	0	\N
378088	1678	27360857009000	28104	13758	90	0	\N
378089	1678	27360857010000	28104	13758	91	0	\N
378090	1678	27360857011000	28104	13758	92	0	\N
378091	1678	27360857012000	28104	13758	93	0	\N
378092	1678	27360857013000	28104	13758	94	0	\N
378093	1678	27360857014000	28104	13758	95	0	\N
378094	1678	27360857015000	28104	13758	96	0	\N
378095	1678	27360857016000	28104	13758	97	0	\N
378096	1678	27360857017000	28104	13758	98	0	\N
378097	1678	27360857018000	28104	13758	99	0	\N
378098	1678	27360857019000	28104	13758	100	0	\N
378099	1678	27360857020000	28104	13758	101	0	\N
378100	1678	27360857021000	28104	13758	102	0	\N
378101	1678	27360857022000	28104	13758	103	0	\N
378102	1678	27360857023000	28104	13758	104	0	\N
378103	1678	27360857024000	28104	13758	105	0	\N
378104	1678	27360857025000	28104	13758	106	0	\N
378105	1678	27360857026000	28104	13758	107	0	\N
378106	1678	27360857027000	28104	13758	108	0	\N
378107	1678	27360857028000	28104	13758	109	0	\N
378108	1678	27360857029000	28104	13758	110	0	\N
378109	1678	27360857030000	28104	13758	111	0	\N
378110	1678	27360857031000	28104	13758	112	0	\N
378111	1678	27360857032000	28104	13758	113	0	\N
378112	1678	27360857033000	28104	13758	114	0	\N
378113	1678	27360857034000	28104	13758	115	0	\N
378114	1678	27360857035000	28104	13758	116	0	\N
378115	1678	27360857036000	28104	13758	117	0	\N
378116	1678	27360857037000	28104	13758	118	0	\N
378117	1678	27360857038000	28104	13758	119	0	\N
378118	1678	27360857039000	28104	13758	120	0	\N
378119	1678	27360857040000	28104	13758	121	0	\N
378120	1678	27360857041000	28104	13758	122	0	\N
378121	1678	27360857042000	28104	13758	123	0	\N
378122	1678	27360857043000	28104	13758	124	0	\N
378123	1678	27360857044000	28104	13758	125	0	\N
378124	1678	28080869122000	28105	13893	0	0	\N
378125	1678	28080869123000	28105	13893	1	0	\N
378126	1874	37642000	28105	13893	2	0	\N
378127	1874	37643000	28105	13893	3	0	\N
378128	1874	37645000	28105	13893	4	0	\N
378129	1874	37647000	28105	13893	5	0	\N
378130	1874	37650000	28105	13893	6	0	\N
378138	1678	28080869124000	28107	13894	0	0	\N
378139	1874	37652000	28107	13894	1	0	\N
378140	1874	37655000	28107	13894	2	0	\N
378141	1678	28080869124000	28108	13894	0	0	\N
378142	1874	37652000	28108	13894	1	0	\N
378143	1874	37655000	28108	13894	2	0	\N
378154	1678	28080869125000	28111	13895	0	0	\N
378155	1678	28080869126000	28111	13895	1	0	\N
378156	1874	37658000	28111	13895	2	0	\N
378157	1874	37661000	28111	13895	3	0	\N
378158	1874	37663000	28111	13895	4	0	\N
378159	1874	37664000	28111	13895	5	0	\N
378160	1874	37666000	28111	13895	6	0	\N
378172	1678	28080869128000	28114	13897	0	0	\N
378173	1678	28080869129000	28114	13897	1	0	\N
378174	1874	37673000	28114	13897	2	0	\N
378175	1874	37674000	28114	13897	3	0	\N
378176	1874	37676000	28114	13897	4	0	\N
378177	1874	37679000	28114	13897	5	0	\N
378178	1874	37682000	28114	13897	6	0	\N
378188	1678	28080869132000	28117	13899	0	0	\N
378189	1874	37694000	28117	13899	1	0	\N
378190	1874	37697000	28117	13899	2	0	\N
378203	1678	28080869137000	28121	13903	0	0	\N
378204	1874	37716000	28121	13903	1	0	\N
378205	1678	28080869137000	28122	13903	0	0	\N
378206	1874	37716000	28122	13903	1	0	\N
378207	1678	28080869137000	28123	13903	0	0	\N
378208	1874	37716000	28123	13903	1	0	\N
378209	1678	28080869137000	28124	13903	0	0	\N
378210	1874	37716000	28124	13903	1	0	\N
378213	1678	28080869137000	28126	13903	0	0	\N
378214	1874	37716000	28126	13903	1	0	\N
378215	1678	28080869138000	28127	13904	0	0	\N
378216	1874	37719000	28127	13904	1	0	\N
378133	1874	37642000	28106	13893	2	0	2
378134	1874	37643000	28106	13893	3	0	2
378135	1874	37645000	28106	13893	4	0	2
378136	1874	37647000	28106	13893	5	0	2
378137	1874	37650000	28106	13893	6	0	2
378145	1874	37652000	28109	13894	1	0	2
378146	1874	37655000	28109	13894	2	0	2
378147	1678	28080869125000	28110	13895	0	0	1
378148	1678	28080869126000	28110	13895	1	0	1
378149	1874	37658000	28110	13895	2	0	2
378151	1874	37663000	28110	13895	4	0	2
378152	1874	37664000	28110	13895	5	0	2
378153	1874	37666000	28110	13895	6	0	2
378161	1678	28080869127000	28112	13896	0	0	1
378163	1874	37668000	28112	13896	2	0	2
378164	1874	37671000	28112	13896	3	0	2
378165	1678	28080869128000	28113	13897	0	0	1
378166	1678	28080869129000	28113	13897	1	0	1
378167	1874	37673000	28113	13897	2	0	2
378169	1874	37676000	28113	13897	4	0	2
378170	1874	37679000	28113	13897	5	0	2
378171	1874	37682000	28113	13897	6	0	2
378179	1678	28080869130000	28115	13898	0	0	1
378180	1678	28080869131000	28115	13898	1	0	1
378182	1874	37687000	28115	13898	3	0	2
378183	1874	37690000	28115	13898	4	0	2
378184	1874	37692000	28115	13898	5	0	2
378185	1678	28080869132000	28116	13899	0	0	1
378187	1874	37697000	28116	13899	2	0	2
378191	1678	28080869133000	28118	13900	0	0	1
378192	1874	37700000	28118	13900	1	0	2
378193	1874	37701000	28118	13900	2	0	2
378194	1874	37703000	28118	13900	3	0	2
378196	2393	2159000000000	28119	13901	1	0	0
378197	1874	37706000	28119	13901	2	0	2
378198	1678	28080869135000	28120	13902	0	0	1
378199	1678	28080869136000	28120	13902	1	0	1
378200	1874	37707000	28120	13902	2	0	2
378202	1874	37713000	28120	13902	5	0	2
378211	1678	28080869137000	28125	13903	0	0	1
378212	1874	37716000	28125	13903	1	0	2
378217	1678	28080869138000	28128	13904	0	0	\N
378219	1678	28080869138000	28130	13904	0	0	\N
378220	1874	37719000	28131	13905	0	0	\N
378221	1874	37720000	28131	13905	1	0	\N
378225	1678	28080869140000	28133	13906	0	0	\N
378226	2394	1439000000000	28133	13906	1	0	\N
378227	1874	37723000	28133	13906	2	0	\N
378228	1678	28080869140000	28134	13906	0	0	\N
378229	2394	1439000000000	28134	13906	1	0	\N
378230	1874	37723000	28134	13906	2	0	\N
378245	1678	28080869145000	28140	13911	0	0	\N
378246	1874	37739000	28140	13911	1	0	\N
378249	1678	28080869145000	28142	13911	0	0	\N
378250	1874	37739000	28142	13911	1	0	\N
378262	2394	1439000000000	28146	13873	0	0	\N
378263	2393	1000000000	28146	13873	1	0	\N
378264	2393	2159000000000	28146	13873	2	0	\N
378265	2395	100000000	28146	13873	3	0	\N
378266	2396	100000000	28146	13873	4	0	\N
378267	1874	37456000	28146	13873	5	0	\N
378268	1874	37457000	28146	13873	6	0	\N
378269	1874	37458000	28146	13873	7	0	\N
378270	1874	37459000	28146	13873	8	0	\N
378271	1874	37460000	28146	13873	9	0	\N
378272	1874	37461000	28146	13873	10	0	\N
378273	1874	37462000	28146	13873	11	0	\N
378274	1874	37463000	28146	13873	12	0	\N
378275	1874	37464000	28146	13873	13	0	\N
378276	1874	37465000	28146	13873	14	0	\N
378277	1874	37466000	28146	13873	15	0	\N
378278	1874	37467000	28146	13873	16	0	\N
378279	1874	37468000	28146	13873	17	0	\N
378300	1874	37469000	28154	13874	0	0	\N
378301	1874	37470000	28154	13874	1	0	\N
378302	1874	37471000	28154	13874	2	0	\N
378320	1678	28080869166000	28158	13925	0	0	\N
378321	1678	28080869167000	28158	13925	1	0	\N
378322	1678	28080869168000	28158	13925	2	0	\N
378323	1874	37808000	28158	13925	3	0	\N
378324	1874	37811000	28158	13925	4	0	\N
378325	1874	37814000	28158	13925	5	0	\N
378326	1874	37815000	28158	13925	6	0	\N
378327	1678	28080869166000	28159	13925	0	0	\N
378328	1678	28080869167000	28159	13925	1	0	\N
378329	1678	28080869168000	28159	13925	2	0	\N
378330	1874	37808000	28159	13925	3	0	\N
378331	1874	37811000	28159	13925	4	0	\N
378332	1874	37814000	28159	13925	5	0	\N
378333	1874	37815000	28159	13925	6	0	\N
378334	1678	28080869166000	28160	13925	0	0	\N
378335	1678	28080869167000	28160	13925	1	0	\N
378336	1678	28080869168000	28160	13925	2	0	\N
378337	1874	37808000	28160	13925	3	0	\N
378338	1874	37811000	28160	13925	4	0	\N
378339	1874	37814000	28160	13925	5	0	\N
378340	1874	37815000	28160	13925	6	0	\N
378348	1678	28080869166000	28162	13925	0	0	\N
378349	1678	28080869167000	28162	13925	1	0	\N
378350	1678	28080869168000	28162	13925	2	0	\N
378351	1874	37808000	28162	13925	3	0	\N
378352	1874	37811000	28162	13925	4	0	\N
378223	1874	37719000	28132	13905	1	0	2
378224	1874	37720000	28132	13905	2	0	2
378231	1678	28080869140000	28135	13906	0	0	1
378232	2394	1439000000000	28135	13906	1	0	0
378233	1874	37723000	28135	13906	2	0	2
378235	1874	37726000	28136	13907	1	0	2
378236	2395	100000000	28136	13907	2	0	0
378237	2396	100000000	28136	13907	3	0	0
378238	1678	28080869142000	28137	13908	0	0	1
378239	1874	37729000	28137	13908	1	0	2
378241	1874	37732000	28138	13909	1	0	2
378242	1874	37733000	28138	13909	2	0	2
378243	1678	28080869144000	28139	13910	0	0	1
378244	1874	37736000	28139	13910	1	0	2
378248	1874	37739000	28141	13911	1	0	2
378251	1678	28080869146000	28143	13912	0	0	1
378252	1678	28080869147000	28143	13912	1	0	1
378253	1483	11000000	28143	13912	2	0	0
378254	1874	37740000	28143	13912	3	0	2
378256	1874	37746000	28143	13912	5	0	2
378257	1678	28080869148000	28144	13913	0	0	1
378258	1874	37749000	28144	13913	1	0	2
378259	1678	28080869149000	28145	13914	0	0	1
378260	1874	37750000	28145	13914	1	0	2
378280	1678	28080869150000	28147	13915	0	0	1
378281	1874	37756000	28147	13915	1	0	2
378282	1678	28080869151000	28148	13916	0	0	1
378283	1874	37759000	28148	13916	1	0	2
378285	1874	37762000	28149	13917	1	0	2
378286	1678	28080869153000	28150	13918	0	0	1
378287	1678	28080869154000	28150	13918	1	0	1
378288	1874	37763000	28150	13918	2	0	2
378289	1874	37766000	28150	13918	3	0	2
378291	1678	28080869155000	28151	13919	0	0	1
378292	1874	37772000	28151	13919	1	0	2
378293	1678	28080869156000	28152	13920	0	0	1
378294	1678	28080869157000	28152	13920	1	0	1
378295	1874	37775000	28152	13920	2	0	2
378297	1874	37779000	28152	13920	4	0	2
378298	1678	28080869158000	28153	13921	0	0	1
378299	1874	37782000	28153	13921	1	0	2
378303	1678	28080869159000	28155	13922	0	0	1
378305	1874	37786000	28155	13922	2	0	2
378306	1678	28080869160000	28156	13923	0	0	1
378307	1678	28080869161000	28156	13923	1	0	1
378308	1678	28080869162000	28156	13923	2	0	1
378309	1678	28080869163000	28156	13923	3	0	1
378311	1874	37790000	28156	13923	5	0	2
378312	1874	37793000	28156	13923	6	0	2
378313	1816	100000000	28156	13923	7	0	1
378314	1874	37796000	28156	13923	8	0	2
378315	1874	37799000	28156	13923	9	0	2
378317	1678	28080869165000	28157	13924	1	0	1
378318	1874	37802000	28157	13924	2	0	2
378319	1874	37805000	28157	13924	3	0	2
378341	1678	28080869166000	28161	13925	0	0	1
378343	1678	28080869168000	28161	13925	2	0	1
378344	1874	37808000	28161	13925	3	0	2
378345	1874	37811000	28161	13925	4	0	2
378346	1874	37814000	28161	13925	5	0	2
378347	1874	37815000	28161	13925	6	0	2
378353	1874	37814000	28162	13925	5	0	\N
378354	1874	37815000	28162	13925	6	0	\N
378355	1678	28080869166000	28163	13925	0	0	\N
378356	1678	28080869167000	28163	13925	1	0	\N
378357	1678	28080869168000	28163	13925	2	0	\N
378358	1874	37808000	28163	13925	3	0	\N
378359	1874	37811000	28163	13925	4	0	\N
378360	1874	37814000	28163	13925	5	0	\N
378361	1874	37815000	28163	13925	6	0	\N
378365	1678	28080869170000	28165	13927	0	0	\N
378366	1874	37822000	28165	13927	1	0	\N
378367	1678	28080869170000	28166	13927	0	0	\N
378368	1874	37822000	28166	13927	1	0	\N
378369	1678	28080869170000	28167	13927	0	0	\N
378370	1874	37822000	28167	13927	1	0	\N
378371	2394	1439000000000	28169	13846	0	0	\N
378372	2393	1000000000	28169	13846	1	0	\N
378373	2393	2159000000000	28169	13846	2	0	\N
378374	2392	100000000	28169	13846	3	0	\N
378375	2395	100000000	28169	13846	4	0	\N
378376	2396	100000000	28169	13846	5	0	\N
378377	1560	17288855131803	28169	13846	6	0	\N
378378	1816	100000000	28169	13846	7	0	\N
378379	1874	37281000	28169	13846	8	0	\N
378380	1874	37282000	28169	13846	9	0	\N
378381	1874	37283000	28169	13846	10	0	\N
378382	1874	37284000	28169	13846	11	0	\N
378383	1874	37285000	28169	13846	12	0	\N
378384	1874	37286000	28169	13846	13	0	\N
378385	1874	37287000	28169	13846	14	0	\N
378386	1874	37288000	28169	13846	15	0	\N
378387	1874	37289000	28169	13846	16	0	\N
378388	1874	37290000	28169	13846	17	0	\N
378389	1874	37291000	28169	13846	18	0	\N
378390	1874	37292000	28169	13846	19	0	\N
378391	1874	37293000	28169	13846	20	0	\N
378392	1874	37294000	28169	13846	21	0	\N
378393	1874	37295000	28169	13846	22	0	\N
378394	1874	37296000	28169	13846	23	0	\N
378395	1874	37297000	28169	13846	24	0	\N
378396	1874	37298000	28169	13846	25	0	\N
378397	1874	37299000	28169	13846	26	0	\N
378400	1874	37472000	28171	13875	0	0	\N
378401	1874	37473000	28171	13875	1	0	\N
378402	1816	100000000	28171	13875	2	0	\N
378403	1874	37474000	28171	13875	3	0	\N
378404	1678	28080869171000	28172	13928	0	0	\N
378405	1678	28080869172000	28172	13928	1	0	\N
378406	1678	28080869173000	28172	13928	2	0	\N
378407	1874	37825000	28172	13928	3	0	\N
378408	1874	37828000	28172	13928	4	0	\N
378409	1874	37831000	28172	13928	5	0	\N
378410	1874	37832000	28172	13928	6	0	\N
378420	1678	28080869174000	28175	13929	0	0	\N
378421	1874	37835000	28175	13929	1	0	\N
378422	1678	28080869174000	28176	13929	0	0	\N
378423	1874	37835000	28176	13929	1	0	\N
378424	1678	28080869174000	28177	13929	0	0	\N
378425	1874	37835000	28177	13929	1	0	\N
378426	1678	28080869174000	28178	13929	0	0	\N
378427	1874	37835000	28178	13929	1	0	\N
378428	1678	28080869174000	28179	13929	0	0	\N
378429	1874	37835000	28179	13929	1	0	\N
378438	1678	28080869178000	28182	13932	0	0	\N
378439	1874	37849000	28182	13932	1	0	\N
378440	1874	37852000	28182	13932	2	0	\N
378441	1678	28080869178000	28183	13932	0	0	\N
378442	1874	37849000	28183	13932	1	0	\N
378443	1874	37852000	28183	13932	2	0	\N
378444	1678	28080869178000	28184	13932	0	0	\N
378445	1874	37849000	28184	13932	1	0	\N
378446	1874	37852000	28184	13932	2	0	\N
378450	1678	28080869178000	28186	13932	0	0	\N
378451	1874	37849000	28186	13932	1	0	\N
378452	1874	37852000	28186	13932	2	0	\N
378462	1678	28080869181000	28190	13935	0	0	\N
378463	1678	28080869182000	28190	13935	1	0	\N
378464	1874	37861000	28190	13935	2	0	\N
378465	1874	37864000	28190	13935	3	0	\N
378466	1874	37865000	28190	13935	4	0	\N
378467	1874	37475000	28191	13876	0	0	\N
378468	1874	37476000	28191	13876	1	0	\N
378469	1874	37477000	28191	13876	2	0	\N
378470	1874	37478000	28191	13876	3	0	\N
378488	1678	28080869189000	28200	13942	0	0	\N
378364	1874	37819000	28164	13926	3	0	2
378398	1678	28080869170000	28170	13927	0	0	1
378399	1874	37822000	28170	13927	1	0	2
378411	1678	28080869171000	28173	13928	0	0	1
378412	1678	28080869172000	28173	13928	1	0	1
378414	1874	37825000	28173	13928	3	0	2
378415	1874	37828000	28173	13928	4	0	2
378416	1874	37831000	28173	13928	5	0	2
378417	1874	37832000	28173	13928	6	0	2
378418	1678	28080869174000	28174	13929	0	0	1
378430	1678	28080869175000	28180	13930	0	0	1
378431	1678	28080869176000	28180	13930	1	0	1
378432	1874	37836000	28180	13930	2	0	2
378433	1874	37839000	28180	13930	3	0	2
378435	1874	37845000	28180	13930	5	0	2
378436	1678	28080869177000	28181	13931	0	0	1
378437	1874	37848000	28181	13931	1	0	2
378447	1678	28080869178000	28185	13932	0	0	1
378448	1874	37849000	28185	13932	1	0	2
378453	1678	28080869179000	28187	13933	0	0	1
378454	1874	37855000	28187	13933	1	0	2
378455	1678	28080869180000	28188	13934	0	0	1
378456	1874	37858000	28188	13934	1	0	2
378457	1678	28080869181000	28189	13935	0	0	1
378459	1874	37861000	28189	13935	2	0	2
378460	1874	37864000	28189	13935	3	0	2
378461	1874	37865000	28189	13935	4	0	2
378471	1678	28080869183000	28192	13936	0	0	1
378473	1678	28080869184000	28194	13937	0	0	1
378474	1874	37871000	28194	13937	1	0	2
378475	1678	28080869185000	28195	13938	0	0	1
378476	1874	37872000	28195	13938	1	0	2
378477	1874	37875000	28195	13938	2	0	2
378479	1874	37878000	28196	13939	1	0	2
378480	1678	28080869187000	28197	13940	0	0	1
378481	1874	37881000	28197	13940	1	0	2
378482	1678	28080869188000	28198	13941	0	0	1
378483	1874	37882000	28198	13941	1	0	2
378485	1678	28080869189000	28199	13942	0	0	1
378486	1678	28080869190000	28199	13942	1	0	1
378487	1874	37888000	28199	13942	2	0	2
378489	1874	37888000	28200	13942	1	0	\N
378491	1874	37891000	28202	13943	0	0	\N
378492	1874	37891000	28203	13943	0	0	\N
378498	1678	28080869193000	28205	13945	0	0	\N
378499	1874	37901000	28205	13945	1	0	\N
378500	1678	28080869193000	28206	13945	0	0	\N
378501	1874	37901000	28206	13945	1	0	\N
378509	1678	28080869195000	28210	13947	0	0	\N
378510	1874	37905000	28210	13947	1	0	\N
378511	1874	37908000	28210	13947	2	0	\N
378516	1678	28080869197000	28213	13949	0	0	\N
378517	1874	37914000	28213	13949	1	0	\N
378527	1678	28080869200000	28217	13952	0	0	\N
378528	96	66001212000000	28217	13952	1	0	\N
378529	1874	37924000	28217	13952	3	0	\N
378530	1678	28080869200000	28218	13952	0	0	\N
378531	96	66001212000000	28218	13952	1	0	\N
378532	1874	37924000	28218	13952	3	0	\N
378535	1678	28080869201000	28220	13953	0	0	\N
378536	1874	37927000	28220	13953	1	0	\N
378537	1678	28080869201000	28221	13953	0	0	\N
378538	1874	37927000	28221	13953	1	0	\N
378539	1678	28080869201000	28222	13953	0	0	\N
378540	1874	37927000	28222	13953	1	0	\N
378544	96	66001212000000	28225	13932	0	0	\N
378545	96	66001212000000	28225	13932	1	0	\N
378548	1678	28080869204000	28227	13956	0	0	\N
378549	1874	37937000	28227	13956	1	0	\N
378559	1678	28080869206000	28231	13958	0	0	\N
378560	1678	28080869207000	28231	13958	1	0	\N
378561	1874	37944000	28231	13958	2	0	\N
378562	1874	37947000	28231	13958	4	0	\N
378563	1678	28080869206000	28232	13958	0	0	\N
378564	1678	28080869207000	28232	13958	1	0	\N
378565	1874	37944000	28232	13958	2	0	\N
378566	1874	37947000	28232	13958	4	0	\N
378567	1678	28080869206000	28233	13958	0	0	\N
378568	1678	28080869207000	28233	13958	1	0	\N
378569	1874	37944000	28233	13958	2	0	\N
378570	1874	37947000	28233	13958	4	0	\N
378578	1678	28080869210000	28237	13961	0	0	\N
378579	1874	37957000	28237	13961	1	0	\N
378580	96	66001212000000	28238	13943	0	0	\N
378581	96	66001212000000	28238	13943	1	0	\N
378582	1678	28080869210000	28239	13961	0	0	\N
378583	1874	37957000	28239	13961	1	0	\N
378586	1678	28080869211000	28241	13962	0	0	\N
378587	1874	37960000	28241	13962	1	0	\N
378591	1678	28080869213000	28243	13964	0	0	\N
378592	1874	37967000	28243	13964	1	0	\N
378602	1678	28080869216000	28248	13967	0	0	\N
378603	1874	37977000	28248	13967	2	0	\N
378604	1678	28080869216000	28249	13967	0	0	\N
378605	1874	37977000	28249	13967	2	0	\N
378606	2192	101000000000	28250	13730	0	0	\N
378607	289	66000000000000	28250	13730	1	0	\N
378608	2394	1439000000000	28250	13730	2	0	\N
378609	2393	1000000000	28250	13730	3	0	\N
378610	2393	2159000000000	28250	13730	4	0	\N
378611	1760	800000000000	28250	13730	6	0	\N
378612	2386	100000000	28250	13730	8	0	\N
378613	1865	1299000000	28250	13730	9	0	\N
378614	2387	100000000	28250	13730	10	0	\N
378615	2388	100000000	28250	13730	11	0	\N
378616	2389	100000000	28250	13730	12	0	\N
378617	1816	100000000	28250	13730	13	0	\N
378618	2391	100000000	28250	13730	15	0	\N
378619	2392	100000000	28250	13730	16	0	\N
378620	2395	100000000	28250	13730	17	0	\N
378621	2396	100000000	28250	13730	18	0	\N
378622	1874	36456000	28250	13730	19	0	\N
378623	1874	36457000	28250	13730	20	0	\N
378624	1874	36458000	28250	13730	21	0	\N
378494	1678	28080869192000	28204	13944	1	0	1
378495	1874	37894000	28204	13944	2	0	2
378496	1874	37897000	28204	13944	3	0	2
378497	1874	37898000	28204	13944	4	0	2
378502	1678	28080869193000	28207	13945	0	0	1
378504	1678	28080869194000	28208	13946	0	0	1
378505	1874	37904000	28208	13946	1	0	2
378506	1678	28080869195000	28209	13947	0	0	1
378507	1874	37905000	28209	13947	1	0	2
378508	1874	37908000	28209	13947	2	0	2
378513	1874	37911000	28211	13948	1	0	2
378514	1678	28080869197000	28212	13949	0	0	1
378515	1874	37914000	28212	13949	1	0	2
378518	1678	28080869198000	28214	13950	0	0	1
378520	1874	37918000	28214	13950	2	0	2
378521	96	66001212000000	28215	13951	0	0	1
378522	1678	28080869199000	28215	13951	1	0	1
378523	1874	37921000	28215	13951	2	0	2
378524	1678	28080869200000	28216	13952	0	0	1
378526	1874	37924000	28216	13952	3	0	2
378533	1678	28080869201000	28219	13953	0	0	1
378534	1874	37927000	28219	13953	1	0	2
378541	1678	28080869202000	28224	13954	0	0	1
378542	1874	37930000	28224	13954	1	0	2
378546	1678	28080869203000	28226	13955	0	0	1
378547	1874	37934000	28226	13955	1	0	2
378550	1678	28080869204000	28228	13956	0	0	1
378551	1874	37937000	28228	13956	1	0	2
378553	1874	37940000	28229	13957	1	0	2
378554	1874	37941000	28229	13957	2	0	2
378555	1678	28080869206000	28230	13958	0	0	1
378556	1678	28080869207000	28230	13958	1	0	1
378557	1874	37944000	28230	13958	2	0	2
378571	1678	28080869208000	28234	13959	0	0	1
378572	1874	37948000	28234	13959	1	0	2
378573	1874	37951000	28234	13959	2	0	2
378574	1678	28080869209000	28235	13960	0	0	1
378575	1874	37954000	28235	13960	1	0	2
378577	1874	37957000	28236	13961	1	0	2
378584	1678	28080869211000	28240	13962	0	0	1
378585	1874	37960000	28240	13962	1	0	2
378588	1678	28080869212000	28242	13963	0	0	1
378590	1874	37964000	28242	13963	2	0	2
378593	1678	28080869213000	28244	13964	0	0	1
378594	1874	37967000	28244	13964	1	0	2
378595	1678	28080869214000	28245	13965	0	0	1
378596	1874	37970000	28245	13965	1	0	2
378598	1874	37971000	28246	13966	1	0	2
378599	1874	37974000	28246	13966	2	0	2
378600	1678	28080869216000	28247	13967	0	0	1
378601	1874	37977000	28247	13967	2	0	2
378625	1874	36459000	28250	13730	22	0	\N
378626	1874	36460000	28250	13730	23	0	\N
378627	1874	36461000	28250	13730	24	0	\N
378628	1874	36462000	28250	13730	25	0	\N
378629	1874	36463000	28250	13730	26	0	\N
378630	1874	36464000	28250	13730	27	0	\N
378631	1874	36465000	28250	13730	28	0	\N
378632	1874	36466000	28250	13730	29	0	\N
378633	1874	36467000	28250	13730	30	0	\N
378634	1874	36468000	28250	13730	31	0	\N
378635	1874	36469000	28250	13730	32	0	\N
378636	1874	36470000	28250	13730	33	0	\N
378637	1874	36471000	28250	13730	34	0	\N
378638	1874	36472000	28250	13730	35	0	\N
378639	1874	36473000	28250	13730	36	0	\N
378640	1874	36474000	28250	13730	37	0	\N
378641	1874	36475000	28250	13730	38	0	\N
378642	1874	36476000	28250	13730	39	0	\N
378643	1874	36477000	28250	13730	40	0	\N
378644	1874	36478000	28250	13730	41	0	\N
378645	1874	36479000	28250	13730	42	0	\N
378646	1874	36480000	28250	13730	43	0	\N
378647	1874	36481000	28250	13730	44	0	\N
378648	1874	36482000	28250	13730	45	0	\N
378649	1874	36483000	28250	13730	46	0	\N
378650	1874	36484000	28250	13730	47	0	\N
378651	1874	36485000	28250	13730	48	0	\N
378652	1874	36486000	28250	13730	49	0	\N
378653	1874	36487000	28250	13730	50	0	\N
378654	1874	36488000	28250	13730	51	0	\N
378655	1678	28080869217000	28251	13968	0	0	\N
378656	1678	28080869218000	28251	13968	1	0	\N
378657	1874	37980000	28251	13968	2	0	\N
378658	1874	37983000	28251	13968	3	0	\N
378659	2398	1000000000	28251	13968	4	0	\N
378660	1874	37984000	28251	13968	5	0	\N
378671	1678	28080869220000	28255	13970	0	0	\N
378672	1874	37990000	28255	13970	1	0	\N
378673	1678	28080869221000	28256	13971	0	0	\N
378674	1874	37993000	28256	13971	1	0	\N
378677	1678	28080869221000	28258	13971	0	0	\N
378678	1874	37993000	28258	13971	1	0	\N
378679	1678	28080869221000	28259	13971	0	0	\N
378680	1874	37993000	28259	13971	1	0	\N
378681	1678	28080869222000	28260	13972	0	0	\N
378682	1874	37996000	28260	13972	1	0	\N
378683	1874	37997000	28260	13972	2	0	\N
378687	1678	28080869222000	28262	13972	0	0	\N
378688	1874	37996000	28262	13972	1	0	\N
378689	1874	37997000	28262	13972	2	0	\N
378694	1678	28080869224000	28265	13974	0	0	\N
378695	1874	38003000	28265	13974	1	0	\N
378696	1678	28080869224000	28266	13974	0	0	\N
378697	1874	38003000	28266	13974	1	0	\N
378701	1874	37479000	28268	13878	0	0	\N
378702	1874	37480000	28268	13878	1	0	\N
378703	1874	37481000	28268	13878	3	0	\N
378704	1874	37482000	28268	13878	4	0	\N
378705	1874	37483000	28268	13878	5	0	\N
378706	1874	37484000	28268	13878	6	0	\N
378707	1874	37485000	28268	13878	7	0	\N
378708	1874	37486000	28268	13878	8	0	\N
378709	1874	37487000	28268	13878	9	0	\N
378710	1874	37488000	28268	13878	10	0	\N
378711	2398	1000000000	28268	13878	12	0	\N
378712	1874	37489000	28268	13878	13	0	\N
378713	1874	37490000	28268	13878	14	0	\N
378714	1874	37491000	28268	13878	15	0	\N
378719	1678	28080869227000	28271	13977	0	0	\N
378720	1874	38013000	28271	13977	1	0	\N
378724	1678	28080869229000	28273	13979	0	0	\N
378725	1874	38020000	28273	13979	1	0	\N
378728	1678	28080869229000	28275	13979	0	0	\N
378729	1874	38020000	28275	13979	1	0	\N
378730	1678	28080869229000	28276	13979	0	0	\N
378731	1874	38020000	28276	13979	1	0	\N
378732	1678	28080869229000	28277	13979	0	0	\N
378733	1874	38020000	28277	13979	1	0	\N
378734	1678	28080869230000	28278	13980	0	0	\N
378735	1874	38023000	28278	13980	1	0	\N
378738	1678	28080869230000	28280	13980	0	0	\N
378739	1874	38023000	28280	13980	1	0	\N
378742	1678	28080869232000	28282	13982	0	0	\N
378743	1874	38027000	28282	13982	1	0	\N
378744	1874	38030000	28282	13982	2	0	\N
378750	1678	28080869234000	28285	13984	0	0	\N
378751	1874	38036000	28285	13984	1	0	\N
378752	1678	28080869234000	28286	13984	0	0	\N
378753	1874	38036000	28286	13984	1	0	\N
378754	1678	28080869234000	28287	13984	0	0	\N
378755	1874	38036000	28287	13984	1	0	\N
378758	1678	28080869234000	28289	13984	0	0	\N
378759	1874	38036000	28289	13984	1	0	\N
378760	1678	28080869235000	28290	13985	0	0	\N
378663	1874	37980000	28252	13968	2	0	2
378664	1874	37983000	28252	13968	3	0	2
378665	2398	1000000000	28252	13968	4	0	0
378666	1874	37984000	28252	13968	5	0	2
378667	1678	28080869219000	28253	13969	0	0	1
378669	1678	28080869220000	28254	13970	0	0	1
378670	1874	37990000	28254	13970	1	0	2
378675	1678	28080869221000	28257	13971	0	0	1
378676	1874	37993000	28257	13971	1	0	2
378684	1678	28080869222000	28261	13972	0	0	1
378686	1874	37997000	28261	13972	2	0	2
378690	1678	28080869223000	28263	13973	0	0	1
378691	1874	38000000	28263	13973	1	0	2
378692	1678	28080869224000	28264	13974	0	0	1
378698	1678	28080869225000	28267	13975	0	0	1
378699	1874	38006000	28267	13975	1	0	2
378700	1874	38007000	28267	13975	2	0	2
378715	1678	28080869226000	28269	13976	0	0	1
378716	1874	38010000	28269	13976	1	0	2
378718	1874	38013000	28270	13977	1	0	2
378721	1678	28080869228000	28272	13978	0	0	1
378722	1874	38016000	28272	13978	1	0	2
378723	1874	38017000	28272	13978	2	0	2
378726	1678	28080869229000	28274	13979	0	0	1
378736	1678	28080869230000	28279	13980	0	0	1
378737	1874	38023000	28279	13980	1	0	2
378740	1678	28080869231000	28281	13981	0	0	1
378741	1874	38026000	28281	13981	2	0	2
378746	1874	38027000	28283	13982	1	0	2
378747	1874	38030000	28283	13982	2	0	2
378748	1678	28080869233000	28284	13983	0	0	1
378749	1874	38033000	28284	13983	1	0	2
378756	1678	28080869234000	28288	13984	0	0	1
378761	1874	38037000	28290	13985	1	0	\N
378762	1874	38040000	28290	13985	2	0	\N
378766	1678	28080869236000	28292	13986	0	0	\N
378767	1874	38043000	28292	13986	1	0	\N
378768	1678	28080869236000	28294	13986	0	0	\N
378769	1874	38043000	28294	13986	1	0	\N
378772	1678	28080869237000	28296	13987	0	0	\N
378773	1678	28080869238000	28296	13987	1	0	\N
378774	1874	38046000	28296	13987	2	0	\N
378775	1874	38047000	28296	13987	3	0	\N
378776	1874	38050000	28296	13987	4	0	\N
378788	1678	28080869241000	28300	13989	0	0	\N
378789	1874	38059000	28300	13989	1	0	\N
378790	1678	28080869242000	28301	13990	0	0	\N
378791	1678	28080869243000	28301	13990	1	0	\N
378792	1874	38062000	28301	13990	2	0	\N
378793	1874	38063000	28301	13990	3	0	\N
378794	1483	11000000	28301	13990	4	0	\N
378795	1874	38066000	28301	13990	5	0	\N
378811	1678	28080869246000	28306	13993	0	0	\N
378812	1678	28080869247000	28306	13993	1	0	\N
378813	1874	38076000	28306	13993	2	0	\N
378814	1874	38079000	28306	13993	3	0	\N
378815	1678	28080869248000	28307	13994	0	0	\N
378816	1874	38080000	28307	13994	1	0	\N
378817	1874	38083000	28307	13994	2	0	\N
378836	1678	28080869256000	28311	13997	0	0	\N
378837	1874	38106000	28311	13997	1	0	\N
378842	1678	28080869235000	28314	13985	0	0	\N
378843	1678	28080869236000	28314	13985	1	0	\N
378844	1678	28080869237000	28314	13985	2	0	\N
378845	1678	28080869238000	28314	13985	3	0	\N
378846	1678	28080869239000	28314	13985	4	0	\N
378847	1678	28080869240000	28314	13985	5	0	\N
378848	1678	28080869241000	28314	13985	6	0	\N
378849	1678	28080869242000	28314	13985	7	0	\N
378850	1678	28080869243000	28314	13985	8	0	\N
378851	1678	28080869244000	28314	13985	9	0	\N
378852	1678	28080869245000	28314	13985	10	0	\N
378853	1678	28080869246000	28314	13985	11	0	\N
378854	1678	28080869247000	28314	13985	12	0	\N
378855	1678	28080869248000	28314	13985	13	0	\N
378856	1678	28080869249000	28314	13985	14	0	\N
378857	1678	28080869250000	28314	13985	15	0	\N
378858	1678	28080869251000	28314	13985	16	0	\N
378859	1678	28080869252000	28314	13985	17	0	\N
378860	1678	28080869253000	28314	13985	18	0	\N
378861	1678	28080869254000	28314	13985	19	0	\N
378862	1678	28080869255000	28314	13985	20	0	\N
378863	1678	28080869256000	28314	13985	21	0	\N
378864	1678	28080869257000	28314	13985	22	0	\N
378865	1874	38037000	28314	13985	23	0	\N
378866	1874	38038000	28314	13985	24	0	\N
378867	1874	38039000	28314	13985	25	0	\N
378868	1483	11000000	28314	13985	26	0	\N
378869	1874	38042000	28314	13985	28	0	\N
378870	1874	38045000	28314	13985	29	0	\N
378871	1874	38048000	28314	13985	30	0	\N
378872	1874	38051000	28314	13985	31	0	\N
378873	1874	38052000	28314	13985	32	0	\N
378874	1874	38053000	28314	13985	33	0	\N
378875	1874	38054000	28314	13985	34	0	\N
378876	1874	38055000	28314	13985	35	0	\N
378877	1874	38058000	28314	13985	36	0	\N
378878	1874	38061000	28314	13985	37	0	\N
378879	1874	38064000	28314	13985	38	0	\N
378880	1874	38067000	28314	13985	39	0	\N
378881	1874	38070000	28314	13985	40	0	\N
378882	1874	38073000	28314	13985	41	0	\N
378883	1874	38076000	28314	13985	42	0	\N
378884	1874	38079000	28314	13985	43	0	\N
378885	1874	38082000	28314	13985	44	0	\N
378886	1874	38085000	28314	13985	45	0	\N
378887	1874	38088000	28314	13985	46	0	\N
378888	1874	38091000	28314	13985	47	0	\N
378889	1874	38094000	28314	13985	48	0	\N
378890	1874	38097000	28314	13985	49	0	\N
378891	1874	38100000	28314	13985	50	0	\N
378892	1874	38103000	28314	13985	51	0	\N
378893	1874	38106000	28314	13985	52	0	\N
378894	1874	38109000	28314	13985	53	0	\N
378895	1678	28080869257000	28315	13998	0	0	\N
378896	1874	38109000	28315	13998	1	0	\N
378765	1874	38040000	28291	13985	2	0	2
378770	1678	28080869236000	28295	13986	0	0	1
378771	1874	38043000	28295	13986	1	0	2
378777	1678	28080869237000	28297	13987	0	0	1
378778	1678	28080869238000	28297	13987	1	0	1
378780	1874	38047000	28297	13987	3	0	2
378781	1874	38050000	28297	13987	4	0	2
378782	1678	28080869239000	28298	13988	0	0	1
378783	1678	28080869240000	28298	13988	1	0	1
378784	1874	38053000	28298	13988	3	0	2
378786	1678	28080869241000	28299	13989	0	0	1
378787	1874	38059000	28299	13989	1	0	2
378796	1678	28080869242000	28302	13990	0	0	1
378797	1678	28080869243000	28302	13990	1	0	1
378799	1874	38063000	28302	13990	3	0	2
378800	1483	11000000	28302	13990	4	0	0
378801	1874	38066000	28302	13990	5	0	2
378802	1678	28080869244000	28303	13991	0	0	1
378803	1874	38069000	28303	13991	1	0	2
378805	1874	38070000	28304	13992	1	0	2
378806	1874	38073000	28304	13992	2	0	2
378807	1678	28080869246000	28305	13993	0	0	1
378808	1678	28080869247000	28305	13993	1	0	1
378809	1874	38076000	28305	13993	2	0	2
378818	1678	28080869248000	28308	13994	0	0	1
378819	1874	38080000	28308	13994	1	0	2
378820	1678	28080869249000	28309	13995	0	0	1
378821	1678	28080869250000	28309	13995	1	0	1
378823	1678	28080869252000	28309	13995	3	0	1
378824	1678	28080869253000	28309	13995	4	0	1
378825	1874	38083000	28309	13995	5	0	2
378826	1874	38084000	28309	13995	6	0	2
378827	1874	38087000	28309	13995	7	0	2
378829	1874	38093000	28309	13995	9	0	2
378830	1874	38096000	28309	13995	10	0	2
378831	1678	28080869254000	28310	13996	0	0	1
378832	1678	28080869255000	28310	13996	1	0	1
378833	1874	38097000	28310	13996	2	0	2
378835	1874	38103000	28310	13996	4	0	2
378838	1678	28080869256000	28312	13997	0	0	1
378839	1874	38106000	28312	13997	1	0	2
378840	1678	28080869257000	28313	13998	0	0	1
378902	1678	28080869258000	28317	13999	0	0	\N
378903	1678	28080869259000	28317	13999	1	0	\N
378904	1874	38110000	28317	13999	2	0	\N
378905	1874	38113000	28317	13999	3	0	\N
378906	1874	38116000	28317	13999	4	0	\N
378911	1483	11000000	28320	13976	1	0	\N
378914	1483	11000000	28322	13944	2	0	\N
378915	2398	1000000000	28322	13944	4	0	\N
378923	1678	28080869266000	28324	14004	0	0	\N
378924	1874	38137000	28324	14004	1	0	\N
378925	1678	28080869266000	28325	14004	0	0	\N
378926	1874	38137000	28325	14004	1	0	\N
378927	1678	28080869266000	28326	14004	0	0	\N
378928	1874	38137000	28326	14004	1	0	\N
378933	1678	28080869267000	28329	14005	0	0	\N
378934	1874	38140000	28329	14005	1	0	\N
378935	1678	28080869268000	28330	14006	0	0	\N
378936	1678	28080869269000	28330	14006	1	0	\N
378937	1678	28080869270000	28330	14006	2	0	\N
378938	1874	38143000	28330	14006	3	0	\N
378939	1874	38146000	28330	14006	4	0	\N
378940	1874	38149000	28330	14006	5	0	\N
378941	1678	28080869268000	28331	14006	0	0	\N
378942	1678	28080869269000	28331	14006	1	0	\N
378943	1678	28080869270000	28331	14006	2	0	\N
378944	1874	38143000	28331	14006	3	0	\N
378945	1874	38146000	28331	14006	4	0	\N
378946	1874	38149000	28331	14006	5	0	\N
378953	1678	28080869271000	28333	14007	0	0	\N
378954	1874	38152000	28333	14007	1	0	\N
378955	1678	28080869271000	28334	14007	0	0	\N
378956	1874	38152000	28334	14007	1	0	\N
378959	1678	28080869272000	28336	14008	0	0	\N
378960	1678	28080869273000	28336	14008	1	0	\N
378961	1678	28080869274000	28336	14008	2	0	\N
378962	1678	28080869275000	28336	14008	3	0	\N
378963	1874	38155000	28336	14008	4	0	\N
378964	1874	38158000	28336	14008	5	0	\N
378965	1874	38161000	28336	14008	6	0	\N
378966	1874	38164000	28336	14008	7	0	\N
378977	1678	28080869276000	28339	14009	0	0	\N
378978	1874	38167000	28339	14009	1	0	\N
378981	1678	28080869278000	28341	14011	0	0	\N
378982	1678	28080869279000	28341	14011	1	0	\N
378983	1678	28080869280000	28341	14011	2	0	\N
378984	1678	28080869281000	28341	14011	3	0	\N
378985	1874	38173000	28341	14011	4	0	\N
378986	1874	38176000	28341	14011	5	0	\N
378987	1874	38179000	28341	14011	6	0	\N
378988	1874	38182000	28341	14011	7	0	\N
378989	1678	28080869278000	28342	14011	0	0	\N
378990	1678	28080869279000	28342	14011	1	0	\N
378991	1678	28080869280000	28342	14011	2	0	\N
378992	1678	28080869281000	28342	14011	3	0	\N
378993	1874	38173000	28342	14011	4	0	\N
378994	1874	38176000	28342	14011	5	0	\N
378995	1874	38179000	28342	14011	6	0	\N
378996	1874	38182000	28342	14011	7	0	\N
379007	1678	28080869282000	28345	14012	0	0	\N
379008	1874	38185000	28345	14012	1	0	\N
379017	1678	28080869283000	28347	14013	0	0	\N
379018	1678	28080869284000	28347	14013	1	0	\N
379019	2399	74000000000	28347	14013	2	0	\N
379020	2400	1000000000	28347	14013	3	0	\N
379021	1874	38188000	28347	14013	4	0	\N
379022	1874	38191000	28347	14013	5	0	\N
379023	1874	38194000	28347	14013	6	0	\N
379024	2398	607902747000000	28347	14013	7	0	\N
379025	2399	74000000000	28348	13879	0	0	\N
379026	1253	607903748000000	28348	13879	2	0	\N
379027	2400	1000000000	28348	13879	3	0	\N
379028	1483	11000000	28348	13879	4	0	\N
379029	1874	37492000	28348	13879	6	0	\N
379030	1874	37493000	28348	13879	7	0	\N
379031	1874	37494000	28348	13879	8	0	\N
379032	1874	37495000	28348	13879	9	0	\N
378899	1874	38110000	28316	13999	2	0	2
378900	1874	38113000	28316	13999	3	0	2
378901	1874	38116000	28316	13999	4	0	2
378907	1678	28080869260000	28318	14000	0	0	1
378908	1874	38119000	28318	14000	1	0	2
378910	1874	38122000	28319	14001	1	0	2
378912	1678	28080869262000	28321	14002	0	0	1
378913	1874	38125000	28321	14002	1	0	2
378916	1678	28080869263000	28323	14003	0	0	1
378917	1678	28080869264000	28323	14003	1	0	1
378919	1253	607903748000000	28323	14003	3	0	1
378920	1874	38128000	28323	14003	5	0	2
378921	1874	38131000	28323	14003	6	0	2
378922	1874	38134000	28323	14003	7	0	2
378930	1874	38137000	28327	14004	1	0	2
378931	1678	28080869267000	28328	14005	0	0	1
378932	1874	38140000	28328	14005	1	0	2
378947	1678	28080869268000	28332	14006	0	0	1
378948	1678	28080869269000	28332	14006	1	0	1
378950	1874	38143000	28332	14006	3	0	2
378951	1874	38146000	28332	14006	4	0	2
378952	1874	38149000	28332	14006	5	0	2
378957	1678	28080869271000	28335	14007	0	0	1
378958	1874	38152000	28335	14007	1	0	2
378968	1678	28080869273000	28337	14008	1	0	1
378969	1678	28080869274000	28337	14008	2	0	1
378970	1678	28080869275000	28337	14008	3	0	1
378971	1874	38155000	28337	14008	4	0	2
378973	1874	38161000	28337	14008	6	0	2
378974	1874	38164000	28337	14008	7	0	2
378975	1678	28080869276000	28338	14009	0	0	1
378976	1874	38167000	28338	14009	1	0	2
378979	1678	28080869277000	28340	14010	0	0	1
378997	1678	28080869278000	28343	14011	0	0	1
378998	1678	28080869279000	28343	14011	1	0	1
378999	1678	28080869280000	28343	14011	2	0	1
379000	1678	28080869281000	28343	14011	3	0	1
379001	1874	38173000	28343	14011	4	0	2
379003	1874	38179000	28343	14011	6	0	2
379004	1874	38182000	28343	14011	7	0	2
379005	1678	28080869282000	28344	14012	0	0	1
379006	1874	38185000	28344	14012	1	0	2
379010	1678	28080869284000	28346	14013	1	0	1
379011	2399	74000000000	28346	14013	2	0	0
379012	2400	1000000000	28346	14013	3	0	0
379013	1874	38188000	28346	14013	4	0	2
379014	1874	38191000	28346	14013	5	0	2
379016	2398	607902747000000	28346	14013	7	0	1
379033	1874	37496000	28348	13879	10	0	\N
379034	1874	37497000	28348	13879	11	0	\N
379035	1874	37498000	28348	13879	12	0	\N
379036	1874	37499000	28348	13879	13	0	\N
379037	1874	37500000	28348	13879	14	0	\N
379038	1874	37501000	28348	13879	15	0	\N
379043	1678	28080869287000	28350	14015	0	0	\N
379044	1874	38203000	28350	14015	1	0	\N
379045	1678	28080869287000	28351	14015	0	0	\N
379046	1874	38203000	28351	14015	1	0	\N
379058	1678	28080869292000	28357	14019	0	0	\N
379059	1874	38218000	28357	14019	1	0	\N
379062	1678	28080869292000	28359	14019	0	0	\N
379063	1874	38218000	28359	14019	1	0	\N
379066	1678	28080869293000	28361	14020	0	0	\N
379067	1874	38221000	28361	14020	1	0	\N
379074	1678	28080869294000	28364	14021	0	0	\N
379075	1678	28080869295000	28364	14021	1	0	\N
379076	1678	28080869296000	28364	14021	2	0	\N
379077	1874	38224000	28364	14021	3	0	\N
379078	1874	38227000	28364	14021	4	0	\N
379079	1874	38230000	28364	14021	5	0	\N
379084	1678	28080869298000	28367	14024	0	0	\N
379085	1874	38236000	28367	14024	1	0	\N
379088	1678	28080869299000	28369	14025	0	0	\N
379089	1874	38239000	28369	14025	1	0	\N
379090	1678	28080869299000	28370	14025	0	0	\N
379091	1874	38239000	28370	14025	1	0	\N
379092	1678	28080869299000	28371	14025	0	0	\N
379093	1874	38239000	28371	14025	1	0	\N
379096	1678	28080869300000	28373	14026	0	0	\N
379097	1874	38242000	28373	14026	1	0	\N
379098	1678	28080869301000	28374	14027	0	0	\N
379099	1874	38245000	28374	14027	2	0	\N
379102	1678	28080869301000	28376	14027	0	0	\N
379103	1874	38245000	28376	14027	2	0	\N
379104	2399	74000000000	28377	13824	0	0	\N
379105	2401	1366000000000	28377	13824	1	0	\N
379106	2394	1439000000000	28377	13824	2	0	\N
379107	2393	1000000000	28377	13824	3	0	\N
379108	2393	2159000000000	28377	13824	4	0	\N
379109	2392	100000000	28377	13824	5	0	\N
379110	2400	1000000000	28377	13824	7	0	\N
379111	2395	100000000	28377	13824	8	0	\N
379112	2396	100000000	28377	13824	9	0	\N
379113	1560	16568843131803	28377	13824	10	0	\N
379114	1816	100000000	28377	13824	11	0	\N
379115	1483	11000000	28377	13824	14	0	\N
379116	2398	1000000000	28377	13824	16	0	\N
379117	1874	37091000	28377	13824	17	0	\N
379118	1874	37092000	28377	13824	18	0	\N
379119	1874	37093000	28377	13824	19	0	\N
379120	1874	37094000	28377	13824	20	0	\N
379121	1874	37095000	28377	13824	21	0	\N
379122	1874	37096000	28377	13824	22	0	\N
379123	1874	37097000	28377	13824	23	0	\N
379124	1678	28080869302000	28378	14028	0	0	\N
379125	1874	38248000	28378	14028	1	0	\N
379128	1678	28080869303000	28380	14029	0	0	\N
379129	1874	38251000	28380	14029	1	0	\N
379139	1678	28080869306000	28385	14032	0	0	\N
379140	1874	38260000	28385	14032	1	0	\N
379141	1678	28080869306000	28386	14032	0	0	\N
379142	1874	38260000	28386	14032	1	0	\N
379143	1678	28080869306000	28387	14032	0	0	\N
379144	1874	38260000	28387	14032	1	0	\N
379148	2401	709000000000	28389	13989	0	0	\N
379149	2401	711880000000	28389	13989	1	0	\N
379150	2399	74000000000	28389	13989	2	0	\N
379151	2401	2078880000000	28389	13989	3	0	\N
379152	1253	607903748000000	28389	13989	4	0	\N
379153	2400	1000000000	28389	13989	5	0	\N
379154	1483	11000000	28389	13989	6	0	\N
379155	2401	2078880000000	28390	14033	0	0	\N
379156	1678	28080869307000	28390	14033	1	0	\N
379157	1874	38263000	28390	14033	2	0	\N
379158	2401	2078880000000	28391	14033	0	0	\N
379159	1678	28080869307000	28391	14033	1	0	\N
379160	1874	38263000	28391	14033	2	0	\N
379161	2401	2078880000000	28392	14033	0	0	\N
379162	1678	28080869307000	28392	14033	1	0	\N
379163	1874	38263000	28392	14033	2	0	\N
379164	2401	2078880000000	28393	14033	0	0	\N
379165	1678	28080869307000	28393	14033	1	0	\N
379166	1874	38263000	28393	14033	2	0	\N
379041	1874	38197000	28349	14014	2	0	2
379042	1874	38200000	28349	14014	3	0	2
379047	1678	28080869287000	28352	14015	0	0	1
379048	1874	38203000	28352	14015	1	0	2
379049	1678	28080869288000	28354	14016	0	0	1
379051	2401	1366000000000	28355	14017	0	0	0
379052	1678	28080869289000	28355	14017	1	0	1
379053	1678	28080869290000	28355	14017	2	0	1
379054	1874	38209000	28355	14017	3	0	2
379055	1874	38212000	28355	14017	4	0	2
379057	1874	38215000	28356	14018	1	0	2
379060	1678	28080869292000	28358	14019	0	0	1
379061	1874	38218000	28358	14019	1	0	2
379064	1678	28080869293000	28360	14020	0	0	1
379068	1678	28080869294000	28362	14021	0	0	1
379069	1874	38224000	28362	14021	1	0	2
379070	1678	28080869295000	28363	14022	0	0	1
379071	1678	28080869296000	28363	14022	1	0	1
379072	1874	38227000	28363	14022	2	0	2
379080	1678	28080869297000	28365	14023	0	0	1
379081	1874	38233000	28365	14023	1	0	2
379082	1678	28080869298000	28366	14024	0	0	1
379083	1874	38236000	28366	14024	1	0	2
379086	1678	28080869299000	28368	14025	0	0	1
379094	1678	28080869300000	28372	14026	0	0	1
379095	1874	38242000	28372	14026	1	0	2
379100	1678	28080869301000	28375	14027	0	0	1
379101	1874	38245000	28375	14027	2	0	2
379127	1874	38248000	28379	14028	1	0	2
379130	1678	28080869303000	28381	14029	0	0	1
379131	1874	38251000	28381	14029	1	0	2
379132	1678	28080869304000	28382	14030	0	0	1
379133	1874	38254000	28382	14030	1	0	2
379135	1678	28080869305000	28383	14031	1	0	1
379136	1874	38257000	28383	14031	2	0	2
379137	1678	28080869306000	28384	14032	0	0	1
379138	1874	38260000	28384	14032	1	0	2
379145	2401	2078880000000	28388	14033	0	0	0
379147	1874	38263000	28388	14033	2	0	2
379167	1678	28080869308000	28394	14034	0	0	1
379168	1874	38266000	28394	14034	1	0	2
379171	1678	28080869309000	28396	14035	0	0	\N
379172	1874	38269000	28396	14035	1	0	\N
379173	1874	38269000	28397	14035	0	0	\N
379176	1678	28080869311000	28399	14037	0	0	\N
379177	1379	1693979635751650	28399	14037	1	0	\N
379178	1874	38275000	28399	14037	2	0	\N
379182	1678	28080869312000	28401	14038	0	0	\N
379183	1678	28080869313000	28401	14038	1	0	\N
379184	1874	38278000	28401	14038	2	0	\N
379185	1874	38281000	28401	14038	3	0	\N
379192	1678	28080869314000	28404	14039	0	0	\N
379193	1874	38284000	28404	14039	1	0	\N
379194	1678	28080869314000	28405	14039	0	0	\N
379195	1874	38284000	28405	14039	1	0	\N
379196	1678	28080869314000	28406	14039	0	0	\N
379197	1874	38284000	28406	14039	1	0	\N
379198	1678	28080869314000	28407	14039	0	0	\N
379199	1874	38284000	28407	14039	1	0	\N
379203	1678	28080869315000	28409	14040	0	0	\N
379204	2402	49000000000	28409	14040	1	0	\N
379205	1874	38287000	28409	14040	2	0	\N
379206	1678	28080869315000	28410	14040	0	0	\N
379207	2402	49000000000	28410	14040	1	0	\N
379208	1874	38287000	28410	14040	2	0	\N
379209	1678	28080869315000	28411	14040	0	0	\N
379210	2402	49000000000	28411	14040	1	0	\N
379211	1874	38287000	28411	14040	2	0	\N
379212	1678	28080869316000	28412	14041	0	0	\N
379213	1874	38290000	28412	14041	1	0	\N
379215	2401	2076000000000	28414	14022	0	0	\N
379216	2401	2078880000000	28414	14022	1	0	\N
379217	2402	49000000000	28414	14022	2	0	\N
379218	1678	28080869297000	28414	14022	3	0	\N
379219	1678	28080869298000	28414	14022	4	0	\N
379220	1678	28080869299000	28414	14022	5	0	\N
379221	1678	28080869300000	28414	14022	6	0	\N
379222	1678	28080869301000	28414	14022	7	0	\N
379223	1678	28080869302000	28414	14022	8	0	\N
379224	1678	28080869303000	28414	14022	9	0	\N
379225	1678	28080869304000	28414	14022	10	0	\N
379226	1678	28080869305000	28414	14022	11	0	\N
379227	1678	28080869306000	28414	14022	12	0	\N
379228	1678	28080869307000	28414	14022	13	0	\N
379229	1678	28080869308000	28414	14022	14	0	\N
379230	1678	28080869309000	28414	14022	15	0	\N
379231	1678	28080869310000	28414	14022	16	0	\N
379232	1678	28080869311000	28414	14022	17	0	\N
379233	1678	28080869312000	28414	14022	18	0	\N
379234	1678	28080869313000	28414	14022	20	0	\N
379235	1678	28080869314000	28414	14022	21	0	\N
379236	1678	28080869315000	28414	14022	22	0	\N
379237	1379	1693979635751650	28414	14022	23	0	\N
379238	1874	38233000	28414	14022	24	0	\N
379239	1874	38236000	28414	14022	25	0	\N
379240	1874	38239000	28414	14022	26	0	\N
379241	1874	38242000	28414	14022	27	0	\N
379242	1874	38245000	28414	14022	28	0	\N
379243	1874	38248000	28414	14022	29	0	\N
379244	1874	38251000	28414	14022	30	0	\N
379245	1874	38254000	28414	14022	31	0	\N
379246	1874	38257000	28414	14022	32	0	\N
379247	1874	38260000	28414	14022	33	0	\N
379248	1874	38263000	28414	14022	34	0	\N
379249	1874	38266000	28414	14022	35	0	\N
379250	1874	38269000	28414	14022	36	0	\N
379251	1874	38272000	28414	14022	37	0	\N
379252	1874	38275000	28414	14022	38	0	\N
379253	1874	38278000	28414	14022	39	0	\N
379254	1874	38281000	28414	14022	40	0	\N
379255	1874	38284000	28414	14022	41	0	\N
379274	1678	28080869323000	28420	14046	0	0	\N
379275	1678	28080869324000	28420	14046	1	0	\N
379276	1874	38311000	28420	14046	2	0	\N
379277	1874	38314000	28420	14046	3	0	\N
379278	1678	28080869325000	28421	14047	0	0	\N
379279	1874	38317000	28421	14047	1	0	\N
379282	2401	709000000000	28423	13880	0	0	\N
379283	2401	2076000000000	28423	13880	1	0	\N
379284	2401	2078880000000	28423	13880	2	0	\N
379285	2402	49000000000	28423	13880	3	0	\N
379286	1379	1693979635751650	28423	13880	4	0	\N
379303	1678	28080869333000	28426	14049	0	0	\N
379304	1874	38341000	28426	14049	1	0	\N
379174	1678	28080869310000	28398	14036	0	0	1
379175	1874	38272000	28398	14036	1	0	2
379179	1678	28080869311000	28400	14037	0	0	1
379180	1379	1693979635751650	28400	14037	1	0	1
379181	1874	38275000	28400	14037	2	0	2
379187	1678	28080869313000	28402	14038	1	0	1
379188	1874	38278000	28402	14038	2	0	2
379189	1874	38281000	28402	14038	3	0	2
379190	1678	28080869314000	28403	14039	0	0	1
379191	1874	38284000	28403	14039	1	0	2
379201	2402	49000000000	28408	14040	1	0	0
379202	1874	38287000	28408	14040	2	0	2
379214	1874	38290000	28413	14041	0	0	2
379256	1678	28080869316000	28415	14042	0	0	1
379258	1678	28080869318000	28415	14042	2	0	1
379259	1874	38293000	28415	14042	3	0	2
379260	1874	38296000	28415	14042	4	0	2
379261	1678	28080869319000	28416	14043	0	0	1
379262	1874	38299000	28416	14043	1	0	2
379264	1874	38302000	28417	14044	1	0	2
379265	1678	28080869321000	28418	14045	0	0	1
379266	1678	28080869322000	28418	14045	1	0	1
379267	1507	49990000000	28418	14045	2	0	1
379268	1874	38305000	28418	14045	3	0	2
379270	1678	28080869323000	28419	14046	0	0	1
379271	1678	28080869324000	28419	14046	1	0	1
379272	1874	38311000	28419	14046	2	0	2
379273	1874	38314000	28419	14046	3	0	2
379281	1874	38317000	28422	14047	1	0	2
379287	1678	28080869326000	28424	14048	0	0	1
379288	1678	28080869327000	28424	14048	1	0	1
379289	1678	28080869328000	28424	14048	2	0	1
379290	1678	28080869329000	28424	14048	3	0	1
379292	1678	28080869331000	28424	14048	5	0	1
379293	1678	28080869332000	28424	14048	6	0	1
379294	1874	38320000	28424	14048	7	0	2
379295	1874	38323000	28424	14048	8	0	2
379296	1874	38326000	28424	14048	9	0	2
379298	1874	38332000	28424	14048	11	0	2
379299	1874	38335000	28424	14048	12	0	2
379300	1874	38338000	28424	14048	13	0	2
379301	1678	28080869333000	28425	14049	0	0	1
379305	1678	28080869333000	28427	14049	0	0	\N
379306	1874	38341000	28427	14049	1	0	\N
379307	1678	28080869316000	28428	14041	0	0	\N
379308	1678	28080869317000	28428	14041	1	0	\N
379309	1678	28080869318000	28428	14041	2	0	\N
379310	1678	28080869319000	28428	14041	3	0	\N
379311	1678	28080869320000	28428	14041	4	0	\N
379312	1678	28080869321000	28428	14041	5	0	\N
379313	1678	28080869322000	28428	14041	6	0	\N
379314	1678	28080869323000	28428	14041	7	0	\N
379315	1678	28080869324000	28428	14041	8	0	\N
379316	1678	28080869325000	28428	14041	9	0	\N
379317	1678	28080869326000	28428	14041	10	0	\N
379318	1678	28080869327000	28428	14041	11	0	\N
379319	1678	28080869328000	28428	14041	12	0	\N
379320	1678	28080869329000	28428	14041	13	0	\N
379321	1678	28080869330000	28428	14041	14	0	\N
379322	1678	28080869331000	28428	14041	15	0	\N
379323	1678	28080869332000	28428	14041	16	0	\N
379324	1678	28080869333000	28428	14041	17	0	\N
379325	1507	49990000000	28428	14041	18	0	\N
379326	1874	38290000	28428	14041	19	0	\N
379327	1874	38293000	28428	14041	20	0	\N
379328	1874	38296000	28428	14041	21	0	\N
379329	1874	38299000	28428	14041	22	0	\N
379330	1874	38302000	28428	14041	23	0	\N
379331	1874	38305000	28428	14041	24	0	\N
379332	1874	38308000	28428	14041	25	0	\N
379333	1874	38311000	28428	14041	26	0	\N
379334	1874	38314000	28428	14041	27	0	\N
379335	1874	38317000	28428	14041	28	0	\N
379336	1874	38320000	28428	14041	29	0	\N
379337	1874	38323000	28428	14041	30	0	\N
379338	1874	38326000	28428	14041	31	0	\N
379339	1874	38329000	28428	14041	32	0	\N
379340	1874	38332000	28428	14041	33	0	\N
379341	1874	38335000	28428	14041	34	0	\N
379342	1874	38338000	28428	14041	35	0	\N
379343	1874	38341000	28428	14041	36	0	\N
379348	1678	28080869336000	28430	14051	0	0	\N
379349	1874	38350000	28430	14051	1	0	\N
379354	1678	28080869337000	28433	14052	0	0	\N
379355	1874	38353000	28433	14052	2	0	\N
379365	2401	709000000000	28436	13847	0	0	\N
379366	2401	711880000000	28436	13847	1	0	\N
379367	2399	74000000000	28436	13847	2	0	\N
379368	2401	2078880000000	28436	13847	3	0	\N
379369	2402	49000000000	28436	13847	4	0	\N
379370	2403	1000000000	28436	13847	5	0	\N
379371	2400	1000000000	28436	13847	7	0	\N
379372	1483	11000000	28436	13847	10	0	\N
379373	1874	37300000	28436	13847	11	0	\N
379374	1874	37301000	28436	13847	12	0	\N
379375	2398	1000000000	28436	13847	14	0	\N
379376	1874	37302000	28436	13847	15	0	\N
379377	1874	37303000	28436	13847	16	0	\N
379378	1874	37304000	28436	13847	17	0	\N
379379	1874	37305000	28436	13847	18	0	\N
379380	1874	37306000	28436	13847	19	0	\N
379381	1874	37307000	28436	13847	20	0	\N
379382	1874	37308000	28436	13847	21	0	\N
379383	1874	37309000	28436	13847	22	0	\N
379384	1874	37310000	28436	13847	23	0	\N
379385	1874	37311000	28436	13847	24	0	\N
379386	1874	37312000	28436	13847	25	0	\N
379387	1874	37313000	28436	13847	26	0	\N
379388	1874	37314000	28436	13847	27	0	\N
379389	1874	37315000	28436	13847	28	0	\N
379390	1874	37316000	28436	13847	29	0	\N
379391	1874	37317000	28436	13847	30	0	\N
379392	1874	37318000	28436	13847	31	0	\N
379393	1874	37319000	28436	13847	32	0	\N
379394	1874	37320000	28436	13847	33	0	\N
379395	1874	37321000	28436	13847	34	0	\N
379396	1874	37322000	28436	13847	36	0	\N
379397	1874	37323000	28436	13847	37	0	\N
379398	1874	37324000	28436	13847	38	0	\N
379399	1874	37325000	28436	13847	39	0	\N
379400	1874	37326000	28436	13847	40	0	\N
379401	1678	28080869341000	28437	14054	0	0	\N
379402	1874	38365000	28437	14054	1	0	\N
379403	1678	28080869341000	28438	14054	0	0	\N
379404	1874	38365000	28438	14054	1	0	\N
379405	1678	28080869341000	28439	14054	0	0	\N
379406	1874	38365000	28439	14054	1	0	\N
379412	1678	28080869344000	28442	14057	0	0	\N
379413	1874	38374000	28442	14057	1	0	\N
379421	1678	28080869345000	28445	14058	0	0	\N
379422	1678	28080869346000	28445	14058	1	0	\N
379423	338	67000023000000	28445	14058	2	0	\N
379424	1874	38377000	28445	14058	3	0	\N
379425	1874	38380000	28445	14058	4	0	\N
379426	1678	28080869347000	28446	14059	0	0	\N
379427	1678	28080869348000	28446	14059	1	0	\N
379428	1874	38383000	28446	14059	2	0	\N
379429	1874	38386000	28446	14059	3	0	\N
379430	1678	28080869347000	28447	14059	0	0	\N
379431	1678	28080869348000	28447	14059	1	0	\N
379432	1874	38383000	28447	14059	2	0	\N
379433	1874	38386000	28447	14059	3	0	\N
379434	1678	28080869347000	28448	14059	0	0	\N
379435	1678	28080869348000	28448	14059	1	0	\N
379436	1874	38383000	28448	14059	2	0	\N
379437	1874	38386000	28448	14059	3	0	\N
379346	1874	38344000	28429	14050	2	0	2
379347	1874	38347000	28429	14050	3	0	2
379350	1678	28080869336000	28431	14051	0	0	1
379351	1874	38350000	28431	14051	1	0	2
379352	1678	28080869337000	28432	14052	0	0	1
379356	1678	28080869338000	28434	14053	0	0	1
379357	1678	28080869339000	28434	14053	1	0	1
379358	1678	28080869340000	28434	14053	2	0	1
379359	2403	1000000000	28434	14053	3	0	0
379360	1874	38356000	28434	14053	4	0	2
379362	1874	38362000	28434	14053	6	0	2
379363	1678	28080869341000	28435	14054	0	0	1
379364	1874	38365000	28435	14054	1	0	2
379407	1678	28080869342000	28440	14055	0	0	1
379409	1678	28080869343000	28441	14056	0	0	1
379410	1874	38371000	28441	14056	1	0	2
379411	2403	439000000000	28441	14056	2	0	0
379414	1678	28080869344000	28443	14057	0	0	1
379415	1874	38374000	28443	14057	1	0	2
379417	1678	28080869346000	28444	14058	1	0	1
379418	338	67000023000000	28444	14058	2	0	3
379419	1874	38377000	28444	14058	3	0	2
379420	1874	38380000	28444	14058	4	0	2
379438	1678	28080869347000	28449	14059	0	0	1
379440	1874	38383000	28449	14059	2	0	2
379442	1678	28080869349000	28450	14060	0	0	\N
379443	1874	38389000	28450	14060	1	0	\N
379452	1678	28080869353000	28453	14062	0	0	\N
379453	1874	38401000	28453	14062	1	0	\N
379456	1678	28080869353000	28455	14062	0	0	\N
379457	1874	38401000	28455	14062	1	0	\N
379458	1678	28080869353000	28456	14062	0	0	\N
379459	1874	38401000	28456	14062	1	0	\N
379460	1678	28080869354000	28457	14063	0	0	\N
379461	1874	38404000	28457	14063	1	0	\N
379464	1678	28080869355000	28459	14064	0	0	\N
379465	1874	38407000	28459	14064	1	0	\N
379466	1678	28080869355000	28460	14064	0	0	\N
379467	1874	38407000	28460	14064	1	0	\N
379472	1678	28080869356000	28463	14065	0	0	\N
379473	1874	38410000	28463	14065	1	0	\N
379474	1678	28080869357000	28464	14066	0	0	\N
379475	1874	38413000	28464	14066	1	0	\N
379478	1678	28080869357000	28466	14066	0	0	\N
379479	1874	38413000	28466	14066	1	0	\N
379482	2403	1000000000	28468	13881	0	0	\N
379483	2403	439000000000	28468	13881	1	0	\N
379484	1678	28080869359000	28469	14068	0	0	\N
379485	1678	28080869360000	28469	14068	1	0	\N
379486	1874	38419000	28469	14068	2	0	\N
379487	1874	38422000	28469	14068	3	0	\N
379505	1678	28080869367000	28476	14074	0	0	\N
379506	1874	38443000	28476	14074	1	0	\N
379511	1678	28080869368000	28479	14075	0	0	\N
379512	1874	38446000	28479	14075	1	0	\N
379513	1678	28080869368000	28480	14075	0	0	\N
379514	1874	38446000	28480	14075	1	0	\N
379517	1678	28080869369000	28482	14076	0	0	\N
379518	1874	38449000	28482	14076	1	0	\N
379519	1678	28080869369000	28483	14076	0	0	\N
379520	1874	38449000	28483	14076	1	0	\N
379521	1678	28080869369000	28484	14076	0	0	\N
379522	1874	38449000	28484	14076	1	0	\N
379525	1678	28080869370000	28486	14077	0	0	\N
379526	1874	38452000	28486	14077	1	0	\N
379527	1678	28080869370000	28487	14077	0	0	\N
379528	1874	38452000	28487	14077	1	0	\N
379541	1678	28080869373000	28491	14080	0	0	\N
379542	1678	28080869374000	28491	14080	1	0	\N
379543	1678	28080869375000	28491	14080	2	0	\N
379544	835	3199985404837430	28491	14080	3	0	\N
379545	1874	38461000	28491	14080	4	0	\N
379546	1874	38464000	28491	14080	5	0	\N
379547	1874	38467000	28491	14080	6	0	\N
379548	1678	28080869373000	28492	14080	0	0	\N
379549	1678	28080869374000	28492	14080	1	0	\N
379550	1678	28080869375000	28492	14080	2	0	\N
379551	835	3199985404837430	28492	14080	3	0	\N
379552	1874	38461000	28492	14080	4	0	\N
379553	1874	38464000	28492	14080	5	0	\N
379554	1874	38467000	28492	14080	6	0	\N
379555	1678	28080869376000	28493	14081	0	0	\N
379556	1874	38470000	28493	14081	1	0	\N
379559	1678	28080869377000	28495	14082	0	0	\N
379560	1874	38473000	28495	14082	1	0	\N
379563	1678	28080869377000	28497	14082	0	0	\N
379564	1874	38473000	28497	14082	1	0	\N
379574	1678	28080869382000	28500	14085	0	0	\N
379575	1874	38490000	28500	14085	1	0	\N
379576	1874	38492000	28500	14085	2	0	\N
379445	1874	38389000	28451	14060	1	0	2
379446	1678	28080869350000	28452	14061	0	0	1
379447	1678	28080869351000	28452	14061	1	0	1
379448	1678	28080869352000	28452	14061	2	0	1
379449	1874	38392000	28452	14061	3	0	2
379451	1874	38398000	28452	14061	5	0	2
379454	1678	28080869353000	28454	14062	0	0	1
379455	1874	38401000	28454	14062	1	0	2
379462	1678	28080869354000	28458	14063	0	0	1
379463	1874	38404000	28458	14063	1	0	2
379469	1874	38407000	28461	14064	1	0	2
379470	1678	28080869356000	28462	14065	0	0	1
379471	1874	38410000	28462	14065	1	0	2
379476	1678	28080869357000	28465	14066	0	0	1
379480	1678	28080869358000	28467	14067	0	0	1
379481	1874	38416000	28467	14067	1	0	2
379488	1678	28080869359000	28470	14068	0	0	1
379489	1678	28080869360000	28470	14068	1	0	1
379490	1874	38419000	28470	14068	2	0	2
379492	1678	28080869361000	28471	14069	0	0	1
379493	1678	28080869362000	28471	14069	1	0	1
379494	1874	38425000	28471	14069	2	0	2
379495	1874	38428000	28471	14069	3	0	2
379496	1678	28080869363000	28472	14070	0	0	1
379498	1678	28080869364000	28473	14071	0	0	1
379499	329	66000591000000	28473	14071	1	0	8
379500	1874	38434000	28473	14071	2	0	2
379501	1678	28080869365000	28474	14072	0	0	1
379503	1678	28080869366000	28475	14073	0	0	1
379504	1874	38440000	28475	14073	1	0	2
379507	1678	28080869367000	28477	14074	0	0	1
379508	1874	38443000	28477	14074	1	0	2
379509	1678	28080869368000	28478	14075	0	0	1
379515	1678	28080869369000	28481	14076	0	0	1
379516	1874	38449000	28481	14076	1	0	2
379523	1678	28080869370000	28485	14077	0	0	1
379524	1874	38452000	28485	14077	1	0	2
379529	1678	28080869371000	28488	14078	0	0	1
379531	1874	38455000	28488	14078	2	0	2
379532	1678	28080869372000	28489	14079	0	0	1
379533	1874	38458000	28489	14079	1	0	2
379534	1678	28080869373000	28490	14080	0	0	1
379536	1678	28080869375000	28490	14080	2	0	1
379537	835	3199985404837430	28490	14080	3	0	0
379538	1874	38461000	28490	14080	4	0	2
379539	1874	38464000	28490	14080	5	0	2
379540	1874	38467000	28490	14080	6	0	2
379558	1874	38470000	28494	14081	1	0	2
379561	1678	28080869377000	28496	14082	0	0	1
379562	1874	38473000	28496	14082	1	0	2
379565	1678	28080869378000	28498	14083	0	0	1
379566	1678	28080869379000	28498	14083	1	0	1
379568	1874	38476000	28498	14083	3	0	2
379569	1874	38478000	28498	14083	4	0	2
379570	1874	38481000	28498	14083	5	0	2
379571	1874	38484000	28498	14083	6	0	2
379573	1874	38487000	28499	14084	1	0	2
379580	1678	28080869382000	28502	14085	0	0	\N
379581	1874	38490000	28502	14085	1	0	\N
379582	1874	38492000	28502	14085	2	0	\N
379586	1678	28080869383000	28504	14086	0	0	\N
379587	1874	38495000	28504	14086	1	0	\N
379588	1874	38497000	28504	14086	2	0	\N
379589	1678	28080869383000	28505	14086	0	0	\N
379590	1874	38495000	28505	14086	1	0	\N
379591	1874	38497000	28505	14086	2	0	\N
379592	1678	28080869383000	28506	14086	0	0	\N
379593	1874	38495000	28506	14086	1	0	\N
379594	1874	38497000	28506	14086	2	0	\N
379597	2401	709000000000	28508	13933	0	0	\N
379598	2401	711880000000	28508	13933	1	0	\N
379599	2399	74000000000	28508	13933	2	0	\N
379600	2401	2078880000000	28508	13933	3	0	\N
379601	2402	49000000000	28508	13933	4	0	\N
379602	121	66000099000000	28508	13933	5	0	\N
379603	835	3199985404837430	28508	13933	6	0	\N
379604	2403	1000000000	28508	13933	7	0	\N
379605	2400	1000000000	28508	13933	9	0	\N
379606	1874	37850000	28508	13933	12	0	\N
379607	1483	11000000	28508	13933	13	0	\N
379608	2398	1000000000	28508	13933	15	0	\N
379609	2403	439000000000	28508	13933	16	0	\N
379610	1874	37852000	28508	13933	18	0	\N
379611	1874	37854000	28508	13933	19	0	\N
379612	1874	37856000	28508	13933	20	0	\N
379613	1678	28080869385000	28509	14088	0	0	\N
379614	1874	38501000	28509	14088	1	0	\N
379615	1874	38504000	28509	14088	2	0	\N
379619	1678	28080869385000	28511	14088	0	0	\N
379620	1874	38501000	28511	14088	1	0	\N
379621	1874	38504000	28511	14088	2	0	\N
379627	1678	28080869386000	28513	14089	0	0	\N
379628	1874	38507000	28513	14089	1	0	\N
379629	2404	100000000	28513	14089	2	0	\N
379630	2404	1200000000	28513	14089	3	0	\N
379631	1874	38509000	28513	14089	4	0	\N
379632	1678	28080869386000	28514	14089	0	0	\N
379633	1874	38507000	28514	14089	1	0	\N
379634	2404	100000000	28514	14089	2	0	\N
379635	2404	1200000000	28514	14089	3	0	\N
379636	1874	38509000	28514	14089	4	0	\N
379637	1678	28080869387000	28515	14090	0	0	\N
379638	1874	38512000	28515	14090	1	0	\N
379639	1874	38513000	28515	14090	2	0	\N
379640	1874	38515000	28515	14090	3	0	\N
379641	1678	28080869387000	28516	14090	0	0	\N
379642	1874	38512000	28516	14090	1	0	\N
379643	1874	38513000	28516	14090	2	0	\N
379644	1874	38515000	28516	14090	3	0	\N
379645	2404	100000000	28517	14047	0	0	\N
379646	2404	1200000000	28517	14047	1	0	\N
379654	1678	28080869389000	28520	14092	0	0	\N
379655	1874	38523000	28520	14092	1	0	\N
379656	1874	38525000	28520	14092	2	0	\N
379657	1678	28080869389000	28521	14092	0	0	\N
379658	1874	38523000	28521	14092	1	0	\N
379659	1874	38525000	28521	14092	2	0	\N
379668	2386	80100000000	28524	14093	0	0	\N
379669	1678	28080869390000	28524	14093	1	0	\N
379670	1874	38528000	28524	14093	2	0	\N
379671	2386	80198000000	28524	14093	3	0	\N
379672	1874	38530000	28524	14093	4	0	\N
379673	2386	80100000000	28525	14093	0	0	\N
379674	1678	28080869390000	28525	14093	1	0	\N
379675	1874	38528000	28525	14093	2	0	\N
379676	2386	80198000000	28525	14093	3	0	\N
379677	1874	38530000	28525	14093	4	0	\N
379684	1678	28080869392000	28527	14095	0	0	\N
379685	1874	7538000	28527	14095	1	0	\N
379686	2386	1020228000000	28527	14095	2	0	\N
379687	1874	7541000	28527	14095	3	0	\N
379692	1678	28080869392000	28529	14095	0	0	\N
379693	1874	7538000	28529	14095	1	0	\N
379694	2386	1020228000000	28529	14095	2	0	\N
379695	1874	7541000	28529	14095	3	0	\N
379707	1678	28080869396000	28532	14098	0	0	\N
379708	1874	7559000	28532	14098	1	0	\N
379711	1678	28080869396000	28534	14098	0	0	\N
379712	1874	7559000	28534	14098	1	0	\N
379579	1874	38492000	28501	14085	2	0	2
379583	1678	28080869383000	28503	14086	0	0	1
379584	1874	38495000	28503	14086	1	0	2
379585	1874	38497000	28503	14086	2	0	2
379595	1678	28080869384000	28507	14087	0	0	1
379616	1678	28080869385000	28510	14088	0	0	1
379617	1874	38501000	28510	14088	1	0	2
379618	1874	38504000	28510	14088	2	0	2
379622	1678	28080869386000	28512	14089	0	0	1
379623	1874	38507000	28512	14089	1	0	2
379625	2404	1200000000	28512	14089	3	0	0
379626	1874	38509000	28512	14089	4	0	2
379647	1678	28080869387000	28518	14090	0	0	1
379648	1874	38512000	28518	14090	1	0	2
379650	1874	38515000	28518	14090	3	0	2
379651	1678	28080869388000	28519	14091	0	0	1
379652	1874	38517000	28519	14091	1	0	2
379653	1874	38520000	28519	14091	2	0	2
379660	1678	28080869389000	28522	14092	0	0	1
379662	1874	38525000	28522	14092	2	0	2
379663	2386	80100000000	28523	14093	0	0	0
379664	1678	28080869390000	28523	14093	1	0	1
379665	1874	38528000	28523	14093	2	0	2
379666	2386	80198000000	28523	14093	3	0	0
379678	1678	28080869391000	28526	14094	0	0	1
379679	2386	80228000000	28526	14094	1	0	0
379680	1874	7532000	28526	14094	2	0	3
379681	1874	7535000	28526	14094	3	0	3
379683	2386	880228000000	28526	14094	5	0	0
379688	1678	28080869392000	28528	14095	0	0	1
379689	1874	7538000	28528	14095	1	0	3
379690	2386	1020228000000	28528	14095	2	0	0
379691	1874	7541000	28528	14095	3	0	3
379697	1874	7543000	28530	14096	1	0	3
379698	1874	7546000	28530	14096	2	0	3
379699	1678	28080869394000	28531	14097	0	0	1
379700	1678	28080869395000	28531	14097	1	0	1
379701	1874	7548000	28531	14097	2	0	3
379703	1874	7553000	28531	14097	4	0	3
379704	2386	1090228000000	28531	14097	5	0	0
379705	1874	7556000	28531	14097	6	0	3
379706	1874	7557000	28531	14097	7	0	3
379710	1874	7559000	28533	14098	1	0	3
379713	1678	28080869396000	28535	14098	0	0	\N
379714	1874	7559000	28535	14098	1	0	\N
379719	1678	28080869398000	28537	14100	0	0	\N
379720	1874	7564000	28537	14100	1	0	\N
379721	1678	28080869398000	28538	14100	0	0	\N
379722	1874	7564000	28538	14100	1	0	\N
379725	1678	28080869398000	28540	14100	0	0	\N
379726	1874	7564000	28540	14100	1	0	\N
379729	329	66000591000000	28542	13848	0	0	\N
379730	121	66000099000000	28542	13848	1	0	\N
379731	338	67438024000000	28542	13848	2	0	\N
379732	835	3199985404837430	28542	13848	3	0	\N
379733	2386	130000000	28542	13848	4	0	\N
379734	1874	6327000	28542	13848	5	0	\N
379735	2386	228000000	28542	13848	6	0	\N
379736	2404	100000000	28542	13848	7	0	\N
379737	2404	1200000000	28542	13848	8	0	\N
379738	2403	438994500000	28542	13848	9	0	\N
379739	1874	6328000	28542	13848	10	0	\N
379740	2386	140228000000	28542	13848	11	0	\N
379741	1874	6329000	28542	13848	12	0	\N
379742	1874	6330000	28542	13848	13	0	\N
379743	1874	6331000	28542	13848	14	0	\N
379744	2386	940228000000	28542	13848	15	0	\N
379745	2405	100000000	28542	13848	16	0	\N
379754	1678	28080869401000	28545	14103	0	0	\N
379755	1874	7577000	28545	14103	1	0	\N
379756	1874	7581000	28545	14103	2	0	\N
379757	1678	28080869401000	28546	14103	0	0	\N
379758	1874	7579000	28546	14103	1	0	\N
379761	1678	28080869402000	28548	14104	0	0	\N
379762	1874	7583000	28548	14104	1	0	\N
379763	1678	28080869402000	28549	14104	0	0	\N
379764	1874	7583000	28549	14104	1	0	\N
379765	1678	28080869402000	28550	14104	0	0	\N
379766	1874	7583000	28550	14104	1	0	\N
379767	1678	28080869402000	28551	14104	0	0	\N
379768	1874	7583000	28551	14104	1	0	\N
379769	1678	28080869402000	28552	14104	0	0	\N
379770	1874	7583000	28552	14104	1	0	\N
379775	1678	28080869403000	28554	14105	0	0	\N
379776	1874	7584000	28554	14105	1	0	\N
379777	1874	7586000	28554	14105	2	0	\N
379778	1874	7590000	28554	14105	3	0	\N
379779	1678	28080869403000	28555	14105	0	0	\N
379780	1874	7584000	28555	14105	1	0	\N
379781	1874	7586000	28555	14105	2	0	\N
379782	1874	7590000	28555	14105	3	0	\N
379793	1678	28080869404000	28559	14106	0	0	\N
379794	1678	28080869405000	28559	14106	1	0	\N
379795	1678	28080869406000	28559	14106	2	0	\N
379796	1678	28080869407000	28559	14106	3	0	\N
379797	2406	100000000	28559	14106	4	0	\N
379798	1874	7591000	28559	14106	5	0	\N
379799	1874	7595000	28559	14106	6	0	\N
379800	1874	7599000	28559	14106	7	0	\N
379801	1874	7603000	28559	14106	8	0	\N
379802	1874	7605000	28559	14106	9	0	\N
379803	1874	7607000	28559	14106	10	0	\N
379804	1874	7609000	28559	14106	11	0	\N
379805	1874	7611000	28559	14106	12	0	\N
379818	1678	28080869408000	28562	14109	0	0	\N
379819	1678	28080869409000	28562	14109	1	0	\N
379820	1678	28080869410000	28562	14109	2	0	\N
379821	1874	7615000	28562	14109	3	0	\N
379822	1874	7619000	28562	14109	4	0	\N
379823	1874	7621000	28562	14109	5	0	\N
379824	1874	7623000	28562	14109	6	0	\N
379825	1874	7625000	28562	14109	7	0	\N
379826	1874	7626000	28562	14109	8	0	\N
379830	1678	28080869412000	28564	14111	0	0	\N
379831	1678	28080869413000	28564	14111	1	0	\N
379832	1874	7636000	28564	14111	2	0	\N
379833	1874	7637000	28564	14111	3	0	\N
379834	1874	7639000	28564	14111	4	0	\N
379835	1874	7641000	28564	14111	5	0	\N
379836	1874	7645000	28564	14111	6	0	\N
379844	1678	28080869412000	28566	14111	0	0	\N
379845	1678	28080869413000	28566	14111	1	0	\N
379846	1874	7636000	28566	14111	2	0	\N
379847	1874	7637000	28566	14111	3	0	\N
379848	1874	7639000	28566	14111	4	0	\N
379717	1874	7560000	28536	14099	2	0	3
379718	1874	7562000	28536	14099	3	0	3
379723	1678	28080869398000	28539	14100	0	0	1
379724	1874	7564000	28539	14100	1	0	3
379727	1678	28080869399000	28541	14101	0	0	1
379746	1678	28080869400000	28543	14102	0	0	1
379747	1874	7568000	28543	14102	1	0	3
379748	1874	7572000	28543	14102	2	0	3
379749	1874	7574000	28543	14102	3	0	3
379750	1874	7575000	28543	14102	4	0	3
379752	1874	7577000	28544	14103	1	0	3
379753	1874	7581000	28544	14103	2	0	3
379759	1678	28080869402000	28547	14104	0	0	1
379760	1874	7583000	28547	14104	1	0	3
379772	1874	7584000	28553	14105	1	0	3
379773	1874	7586000	28553	14105	2	0	3
379774	1874	7590000	28553	14105	3	0	3
379783	1678	28080869404000	28557	14106	0	0	1
379784	1874	7594000	28557	14106	1	0	3
379786	1678	28080869405000	28558	14107	0	0	1
379787	1678	28080869406000	28558	14107	1	0	1
379788	2406	100000000	28558	14107	2	0	0
379789	1874	7600000	28558	14107	3	0	3
379790	1874	7602000	28558	14107	4	0	3
379792	1874	7605000	28558	14107	6	0	3
379806	1678	28080869407000	28560	14108	0	0	1
379807	1874	7607000	28560	14108	1	0	3
379808	1874	7611000	28560	14108	2	0	3
379810	1678	28080869409000	28561	14109	1	0	1
379811	1678	28080869410000	28561	14109	2	0	1
379812	1874	7615000	28561	14109	3	0	3
379813	1874	7619000	28561	14109	4	0	3
379814	1874	7621000	28561	14109	5	0	3
379816	1874	7625000	28561	14109	7	0	3
379817	1874	7626000	28561	14109	8	0	3
379827	1678	28080869411000	28563	14110	0	0	1
379828	1874	7630000	28563	14110	1	0	3
379829	1874	7632000	28563	14110	2	0	3
379838	1678	28080869413000	28565	14111	1	0	1
379839	1874	7636000	28565	14111	2	0	3
379840	1874	7637000	28565	14111	3	0	3
379841	1874	7639000	28565	14111	4	0	3
379843	1874	7645000	28565	14111	6	0	3
379849	1874	7641000	28566	14111	5	0	\N
379850	1874	7645000	28566	14111	6	0	\N
379851	1678	28080869414000	28567	14112	0	0	\N
379852	1678	28080869415000	28567	14112	1	0	\N
379853	1678	28080869416000	28567	14112	2	0	\N
379854	1874	7649000	28567	14112	3	0	\N
379855	1874	7653000	28567	14112	4	0	\N
379856	1874	7654000	28567	14112	5	0	\N
379857	1874	7656000	28567	14112	6	0	\N
379858	1874	7658000	28567	14112	7	0	\N
379859	1874	7660000	28567	14112	8	0	\N
379860	1678	28080869414000	28568	14112	0	0	\N
379861	1678	28080869415000	28568	14112	1	0	\N
379862	1678	28080869416000	28568	14112	2	0	\N
379863	1874	7649000	28568	14112	3	0	\N
379864	1874	7653000	28568	14112	4	0	\N
379865	1874	7654000	28568	14112	5	0	\N
379866	1874	7656000	28568	14112	6	0	\N
379867	1874	7658000	28568	14112	7	0	\N
379868	1874	7660000	28568	14112	8	0	\N
379869	329	66000591000000	28569	13882	0	0	\N
379870	121	66000099000000	28569	13882	1	0	\N
379871	835	3199985404837430	28569	13882	2	0	\N
379872	2386	130000000	28569	13882	3	0	\N
379873	1874	6502000	28569	13882	4	0	\N
379874	2386	228000000	28569	13882	6	0	\N
379875	2404	100000000	28569	13882	7	0	\N
379876	2404	1200000000	28569	13882	8	0	\N
379877	1874	6503000	28569	13882	9	0	\N
379878	2386	140228000000	28569	13882	10	0	\N
379879	1874	6504000	28569	13882	11	0	\N
379880	1874	6505000	28569	13882	12	0	\N
379881	1874	6506000	28569	13882	13	0	\N
379882	1874	6507000	28569	13882	14	0	\N
379883	1874	6508000	28569	13882	15	0	\N
379884	1874	6509000	28569	13882	16	0	\N
379885	1874	6510000	28569	13882	17	0	\N
379886	1874	6511000	28569	13882	18	0	\N
379887	2386	940228000000	28569	13882	19	0	\N
379888	2405	100000000	28569	13882	20	0	\N
379889	2406	100000000	28569	13882	21	0	\N
379899	1678	28080869417000	28571	14113	0	0	\N
379900	1678	28080869418000	28571	14113	1	0	\N
379901	1874	7664000	28571	14113	2	0	\N
379902	1540	0	28571	14113	3	0	\N
379903	1874	7666000	28571	14113	4	0	\N
379904	1874	7668000	28571	14113	5	0	\N
379911	2386	80100000000	28573	14093	0	0	\N
379912	1678	28080869390000	28573	14093	1	0	\N
379913	1678	28080869391000	28573	14093	2	0	\N
379914	1678	28080869392000	28573	14093	3	0	\N
379915	1678	28080869393000	28573	14093	4	0	\N
379916	1678	28080869394000	28573	14093	5	0	\N
379917	1678	28080869395000	28573	14093	6	0	\N
379918	1678	28080869396000	28573	14093	7	0	\N
379919	1678	28080869397000	28573	14093	8	0	\N
379920	1678	28080869398000	28573	14093	9	0	\N
379921	1678	28080869399000	28573	14093	10	0	\N
379922	1678	28080869400000	28573	14093	11	0	\N
379923	1678	28080869401000	28573	14093	12	0	\N
379924	1678	28080869402000	28573	14093	13	0	\N
379925	1678	28080869403000	28573	14093	14	0	\N
379926	1678	28080869404000	28573	14093	15	0	\N
379927	1678	28080869405000	28573	14093	16	0	\N
379928	1678	28080869406000	28573	14093	17	0	\N
379929	1678	28080869407000	28573	14093	18	0	\N
379930	1678	28080869408000	28573	14093	19	0	\N
379931	1678	28080869409000	28573	14093	20	0	\N
379932	1678	28080869410000	28573	14093	21	0	\N
379933	1678	28080869411000	28573	14093	22	0	\N
379934	1678	28080869412000	28573	14093	23	0	\N
379935	1678	28080869413000	28573	14093	24	0	\N
379936	1678	28080869414000	28573	14093	25	0	\N
379937	1678	28080869415000	28573	14093	26	0	\N
379938	1678	28080869416000	28573	14093	27	0	\N
379939	1678	28080869417000	28573	14093	28	0	\N
379940	1678	28080869418000	28573	14093	29	0	\N
379941	2386	80130000000	28573	14093	30	0	\N
379942	1874	7528000	28573	14093	31	0	\N
379943	1540	0	28573	14093	32	0	\N
379944	2386	80227000000	28573	14093	33	0	\N
379945	1874	7531000	28573	14093	34	0	\N
379946	1874	7534000	28573	14093	35	0	\N
379947	1874	7535000	28573	14093	36	0	\N
379948	2386	220227000000	28573	14093	37	0	\N
379949	1874	7536000	28573	14093	38	0	\N
379950	1874	7537000	28573	14093	39	0	\N
379951	1874	7538000	28573	14093	40	0	\N
379952	1874	7539000	28573	14093	41	0	\N
379953	1874	7540000	28573	14093	42	0	\N
379954	1874	7541000	28573	14093	43	0	\N
379955	1874	7542000	28573	14093	44	0	\N
379956	1874	7543000	28573	14093	45	0	\N
379957	2386	1020227000000	28573	14093	46	0	\N
379958	2405	100000000	28573	14093	47	0	\N
379959	2406	100000000	28573	14093	48	0	\N
379960	1874	7545000	28573	14093	49	0	\N
379961	1874	7547000	28573	14093	50	0	\N
379962	1874	7549000	28573	14093	52	0	\N
379963	1874	7551000	28573	14093	53	0	\N
379964	1874	7553000	28573	14093	54	0	\N
379965	1874	7555000	28573	14093	55	0	\N
379966	1874	7557000	28573	14093	56	0	\N
379967	1874	7559000	28573	14093	57	0	\N
379968	1874	7561000	28573	14093	58	0	\N
379969	1874	7563000	28573	14093	59	0	\N
379970	1874	7565000	28573	14093	60	0	\N
379971	1874	7567000	28573	14093	61	0	\N
379972	1874	7569000	28573	14093	62	0	\N
379973	1874	7571000	28573	14093	63	0	\N
379974	1874	7573000	28573	14093	64	0	\N
379975	1874	7575000	28573	14093	65	0	\N
379976	1874	7577000	28573	14093	66	0	\N
379977	1874	7579000	28573	14093	67	0	\N
379978	1874	7581000	28573	14093	68	0	\N
379979	1874	7583000	28573	14093	69	0	\N
379980	1874	7585000	28573	14093	70	0	\N
379981	1874	7587000	28573	14093	71	0	\N
379982	1874	7589000	28573	14093	72	0	\N
379983	1874	7591000	28573	14093	73	0	\N
379984	1874	7593000	28573	14093	74	0	\N
379892	1678	28080869416000	28570	14112	2	0	1
379893	1874	7649000	28570	14112	3	0	3
379894	1874	7653000	28570	14112	4	0	3
379895	1874	7654000	28570	14112	5	0	3
379896	1874	7656000	28570	14112	6	0	3
379898	1874	7660000	28570	14112	8	0	3
379905	1678	28080869417000	28572	14113	0	0	1
379906	1678	28080869418000	28572	14113	1	0	1
379907	1874	7664000	28572	14113	2	0	3
379908	1540	0	28572	14113	3	0	6
379910	1874	7668000	28572	14113	5	0	3
379985	1874	7595000	28573	14093	75	0	\N
379986	1874	7597000	28573	14093	76	0	\N
379987	1874	7599000	28573	14093	77	0	\N
379988	1874	7601000	28573	14093	78	0	\N
379989	1874	7603000	28573	14093	79	0	\N
379990	1874	7606000	28573	14093	80	0	\N
379991	1874	7609000	28573	14093	81	0	\N
379992	2386	1090227000000	28573	14093	82	0	\N
379993	1874	7612000	28573	14093	83	0	\N
379994	1874	7615000	28573	14093	84	0	\N
379995	1874	7619000	28573	14093	85	0	\N
379996	1874	7623000	28573	14093	86	0	\N
379997	1874	7627000	28573	14093	87	0	\N
379998	1874	7631000	28573	14093	88	0	\N
379999	1874	7635000	28573	14093	89	0	\N
380000	1874	7639000	28573	14093	90	0	\N
380001	1874	7643000	28573	14093	91	0	\N
380002	1874	7647000	28573	14093	92	0	\N
380003	1874	7651000	28573	14093	93	0	\N
380004	1874	7655000	28573	14093	94	0	\N
380005	1874	7659000	28573	14093	95	0	\N
380006	1874	7663000	28573	14093	96	0	\N
380007	1874	7667000	28573	14093	97	0	\N
380008	1678	28080869417000	28574	14113	0	0	\N
380009	1678	28080869418000	28574	14113	1	0	\N
380010	1874	7664000	28574	14113	2	0	\N
380011	1540	0	28574	14113	3	0	\N
380012	1874	7666000	28574	14113	4	0	\N
380013	1874	7668000	28574	14113	5	0	\N
380014	1678	28080869417000	28575	14113	0	0	\N
380015	1678	28080869418000	28575	14113	1	0	\N
380016	1874	7664000	28575	14113	2	0	\N
380017	1540	0	28575	14113	3	0	\N
380018	1874	7666000	28575	14113	4	0	\N
380019	1874	7668000	28575	14113	5	0	\N
380020	1678	28080869419000	28576	14114	0	0	\N
380021	1678	28080869420000	28576	14114	1	0	\N
380022	1874	7670000	28576	14114	2	0	\N
380023	1874	7672000	28576	14114	3	0	\N
380024	1874	7676000	28576	14114	4	0	\N
380025	1874	7677000	28576	14114	5	0	\N
380026	1874	7681000	28576	14114	6	0	\N
380027	1678	28080869419000	28577	14114	0	0	\N
380028	1678	28080869420000	28577	14114	1	0	\N
380029	1874	7670000	28577	14114	2	0	\N
380030	1874	7672000	28577	14114	3	0	\N
380031	1874	7676000	28577	14114	4	0	\N
380032	1874	7677000	28577	14114	5	0	\N
380033	1874	7681000	28577	14114	6	0	\N
380041	1540	0	28579	13883	0	0	\N
380042	1874	6512000	28579	13883	1	0	\N
380048	1678	28800894421000	28581	14115	0	0	\N
380049	1678	28800894422000	28581	14115	1	0	\N
380050	1874	7685000	28581	14115	2	0	\N
380051	1874	7687000	28581	14115	3	0	\N
380052	1874	7689000	28581	14115	4	0	\N
380053	1678	28800894421000	28582	14115	0	0	\N
380054	1678	28800894422000	28582	14115	1	0	\N
380055	1874	7685000	28582	14115	2	0	\N
380056	1874	7687000	28582	14115	3	0	\N
380057	1874	7689000	28582	14115	4	0	\N
380062	1678	28800894423000	28584	14116	0	0	\N
380063	1874	7691000	28584	14116	1	0	\N
380064	1874	7692000	28584	14116	2	0	\N
380065	1874	7696000	28584	14116	3	0	\N
380075	1678	28800894427000	28586	14118	0	0	\N
380076	1874	7713000	28586	14118	1	0	\N
380077	1874	7717000	28586	14118	2	0	\N
380081	1678	28800894428000	28589	14119	0	0	\N
380082	1874	7719000	28589	14119	2	0	\N
380083	1874	7723000	28589	14119	3	0	\N
380084	1678	28800894428000	28590	14119	0	0	\N
380085	1874	7719000	28590	14119	2	0	\N
380086	1874	7723000	28590	14119	3	0	\N
380103	1392	1711184787751650	28594	14121	0	0	\N
380104	1678	28800894430000	28594	14121	1	0	\N
380105	1146	910123796000000	28594	14121	2	0	\N
380106	1266	612619034000000	28594	14121	3	0	\N
380107	1026	507884011000000	28594	14121	4	0	\N
380108	1874	7730000	28594	14121	5	0	\N
380109	1874	7734000	28594	14121	6	0	\N
380110	1874	7736000	28594	14121	7	0	\N
380111	1874	7738000	28594	14121	8	0	\N
380112	1392	1711184787751650	28595	14121	0	0	\N
380113	1678	28800894430000	28595	14121	1	0	\N
380114	1146	910123796000000	28595	14121	2	0	\N
380115	1266	612619034000000	28595	14121	3	0	\N
380116	1026	507884011000000	28595	14121	4	0	\N
380117	1874	7730000	28595	14121	5	0	\N
380118	1874	7734000	28595	14121	6	0	\N
380119	1874	7736000	28595	14121	7	0	\N
380120	1874	7738000	28595	14121	8	0	\N
380036	1874	7670000	28578	14114	2	0	3
380037	1874	7672000	28578	14114	3	0	3
380038	1874	7676000	28578	14114	4	0	3
380039	1874	7677000	28578	14114	5	0	3
380040	1874	7681000	28578	14114	6	0	3
380044	1678	28800894422000	28580	14115	1	0	1
380045	1874	7685000	28580	14115	2	0	3
380046	1874	7687000	28580	14115	3	0	3
380047	1874	7689000	28580	14115	4	0	3
380058	1678	28800894423000	28583	14116	0	0	1
380060	1874	7692000	28583	14116	2	0	3
380061	1874	7696000	28583	14116	3	0	3
380066	1678	28800894424000	28585	14117	0	0	1
380067	1678	28800894425000	28585	14117	1	0	1
380069	1874	7698000	28585	14117	3	0	3
380070	1874	7699000	28585	14117	4	0	3
380071	1874	7701000	28585	14117	5	0	3
380072	1874	7703000	28585	14117	6	0	3
380073	1874	7707000	28585	14117	7	0	3
380078	1678	28800894427000	28587	14118	0	0	1
380079	1874	7713000	28587	14118	1	0	3
380080	1874	7717000	28587	14118	2	0	3
380087	1678	28800894428000	28591	14119	0	0	1
380088	1874	7719000	28591	14119	2	0	3
380090	1678	28800894429000	28592	14120	0	0	1
380091	1874	7725000	28592	14120	1	0	3
380092	2407	100000000	28592	14120	2	0	0
380093	1874	7726000	28592	14120	3	0	3
380095	1678	28800894430000	28593	14121	1	0	1
380096	1146	910123796000000	28593	14121	2	0	0
380097	1266	612619034000000	28593	14121	3	0	1
380098	1026	507884011000000	28593	14121	4	0	0
380099	1874	7730000	28593	14121	5	0	3
380101	1874	7736000	28593	14121	7	0	3
380102	1874	7738000	28593	14121	8	0	3
380121	1392	1711184787751650	28596	14121	0	0	\N
380122	1678	28800894430000	28596	14121	1	0	\N
380123	1146	910123796000000	28596	14121	2	0	\N
380124	1266	612619034000000	28596	14121	3	0	\N
380125	1026	507884011000000	28596	14121	4	0	\N
380126	1874	7730000	28596	14121	5	0	\N
380127	1874	7734000	28596	14121	6	0	\N
380128	1874	7736000	28596	14121	7	0	\N
380129	1874	7738000	28596	14121	8	0	\N
380133	1678	28800894431000	28598	14122	0	0	\N
380134	1874	7742000	28598	14122	1	0	\N
380135	1874	7744000	28598	14122	2	0	\N
380139	1678	28800894433000	28600	14124	0	0	\N
380140	1874	7749000	28600	14124	1	0	\N
380141	1874	7753000	28600	14124	2	0	\N
380142	1678	28800894433000	28601	14124	0	0	\N
380143	1874	7749000	28601	14124	1	0	\N
380144	1874	7753000	28601	14124	2	0	\N
380151	1678	28800894434000	28604	14125	0	0	\N
380152	1874	7757000	28604	14125	1	0	\N
380153	1874	7759000	28604	14125	2	0	\N
380158	1678	28800894435000	28606	14126	0	0	\N
380159	1874	7761000	28606	14126	1	0	\N
380160	1874	7765000	28606	14126	2	0	\N
380161	1874	7766000	28606	14126	3	0	\N
380162	1392	1711184787751650	28607	14117	0	0	\N
380163	1146	910123796000000	28607	14117	1	0	\N
380164	1266	612619034000000	28607	14117	2	0	\N
380165	1026	507884011000000	28607	14117	3	0	\N
380166	2407	100000000	28607	14117	4	0	\N
380167	1678	28800894436000	28608	14127	0	0	\N
380168	1874	7768000	28608	14127	1	0	\N
380169	1678	28800894436000	28609	14127	0	0	\N
380170	1874	7768000	28609	14127	1	0	\N
380171	1678	28800894436000	28610	14127	0	0	\N
380172	1874	7768000	28610	14127	1	0	\N
380185	1678	28800894440000	28615	14130	0	0	\N
380186	1874	7789000	28615	14130	1	0	\N
380192	1678	28800894442000	28618	14132	0	0	\N
380193	1874	7796000	28618	14132	1	0	\N
380194	1874	7798000	28618	14132	2	0	\N
380195	1874	7802000	28618	14132	3	0	\N
380196	1678	28800894442000	28619	14132	0	0	\N
380197	1874	7796000	28619	14132	1	0	\N
380198	1874	7798000	28619	14132	2	0	\N
380199	1874	7802000	28619	14132	3	0	\N
380200	1678	28800894442000	28620	14132	0	0	\N
380201	1874	7796000	28620	14132	1	0	\N
380202	1874	7798000	28620	14132	2	0	\N
380203	1874	7802000	28620	14132	3	0	\N
380211	1392	1711184787751650	28623	14089	0	0	\N
380212	1146	910123796000000	28623	14089	1	0	\N
380213	1266	612619034000000	28623	14089	2	0	\N
380214	1026	507884011000000	28623	14089	3	0	\N
380215	2386	130000000	28623	14089	4	0	\N
380216	1540	0	28623	14089	5	0	\N
380217	1874	7505000	28623	14089	6	0	\N
380218	2386	227000000	28623	14089	7	0	\N
380219	1874	7506000	28623	14089	8	0	\N
380220	2386	140227000000	28623	14089	9	0	\N
380221	1874	7507000	28623	14089	10	0	\N
380222	1874	7508000	28623	14089	11	0	\N
380223	1874	7509000	28623	14089	12	0	\N
380224	1874	7510000	28623	14089	13	0	\N
380225	1874	7511000	28623	14089	14	0	\N
380226	1874	7512000	28623	14089	15	0	\N
380227	1874	7513000	28623	14089	16	0	\N
380228	1874	7514000	28623	14089	17	0	\N
380229	1874	7515000	28623	14089	18	0	\N
380230	1874	7516000	28623	14089	19	0	\N
380231	1874	7517000	28623	14089	20	0	\N
380232	1874	7518000	28623	14089	21	0	\N
380233	1874	7519000	28623	14089	22	0	\N
380234	1874	7520000	28623	14089	23	0	\N
380235	1874	7521000	28623	14089	24	0	\N
380236	1874	7522000	28623	14089	25	0	\N
380238	1678	28800894445000	28625	14135	0	0	\N
380239	1874	7810000	28625	14135	1	0	\N
380240	1874	7814000	28625	14135	2	0	\N
380241	1874	7815000	28625	14135	3	0	\N
380242	1392	1711184787751650	28626	13884	0	0	\N
380243	1146	910123796000000	28626	13884	1	0	\N
380244	1266	612619034000000	28626	13884	2	0	\N
380245	1026	507884011000000	28626	13884	3	0	\N
380246	1874	6513000	28626	13884	4	0	\N
380247	1874	6514000	28626	13884	5	0	\N
380248	2407	100000000	28626	13884	6	0	\N
380249	1874	6515000	28626	13884	7	0	\N
380250	1874	6516000	28626	13884	8	0	\N
380251	1874	6517000	28626	13884	9	0	\N
380252	1874	6518000	28626	13884	10	0	\N
380253	1874	6519000	28626	13884	11	0	\N
380254	1874	6520000	28626	13884	12	0	\N
380132	1874	7744000	28597	14122	2	0	3
380136	1678	28800894432000	28599	14123	0	0	1
380137	1874	7746000	28599	14123	1	0	3
380138	1874	7747000	28599	14123	2	0	3
380145	1678	28800894433000	28602	14124	0	0	1
380147	1874	7753000	28602	14124	2	0	3
380148	1678	28800894434000	28603	14125	0	0	1
380149	1874	7757000	28603	14125	1	0	3
380150	1874	7759000	28603	14125	2	0	3
380154	1678	28800894435000	28605	14126	0	0	1
380156	1874	7765000	28605	14126	2	0	3
380157	1874	7766000	28605	14126	3	0	3
380173	1678	28800894436000	28611	14127	0	0	1
380174	1874	7768000	28611	14127	1	0	3
380176	1874	7770000	28613	14128	1	0	3
380177	1874	7774000	28613	14128	2	0	3
380178	1678	28800894438000	28614	14129	0	0	1
380179	1678	28800894439000	28614	14129	1	0	1
380180	1874	7778000	28614	14129	2	0	3
380182	1874	7784000	28614	14129	4	0	3
380183	1874	7786000	28614	14129	5	0	3
380184	1874	7787000	28614	14129	6	0	3
380187	1678	28800894440000	28616	14130	0	0	1
380188	1874	7789000	28616	14130	1	0	3
380190	1874	7791000	28617	14131	1	0	3
380191	1874	7795000	28617	14131	2	0	3
380204	1678	28800894442000	28621	14132	0	0	1
380205	1874	7796000	28621	14132	1	0	3
380207	1874	7802000	28621	14132	3	0	3
380208	1678	28800894443000	28622	14133	0	0	1
380209	1874	7804000	28622	14133	1	0	3
380210	1874	7808000	28622	14133	2	0	3
380237	1678	28800894444000	28624	14134	0	0	1
380256	1874	7810000	28627	14135	1	0	3
380274	1874	6521000	28630	13885	0	0	\N
380275	1678	28800894451000	28631	14138	0	0	\N
380276	1874	7844000	28631	14138	1	0	\N
380277	1678	28800894451000	28632	14138	0	0	\N
380278	1874	7844000	28632	14138	1	0	\N
380287	1678	28800894452000	28635	14139	0	0	\N
380288	1678	28800894453000	28635	14139	1	0	\N
380289	1874	7845000	28635	14139	2	0	\N
380290	1874	7847000	28635	14139	3	0	\N
380291	1874	7851000	28635	14139	4	0	\N
380292	1874	7855000	28635	14139	5	0	\N
380293	1678	28800894454000	28636	14140	0	0	\N
380294	1874	7859000	28636	14140	1	0	\N
380297	1678	28800894455000	28638	14141	0	0	\N
380298	1874	7860000	28638	14141	1	0	\N
380299	1392	1711184787751650	28639	13934	0	0	\N
380300	1146	910123796000000	28639	13934	1	0	\N
380301	1266	612619034000000	28639	13934	2	0	\N
380302	1026	507884011000000	28639	13934	3	0	\N
380303	2386	130000000	28639	13934	4	0	\N
380304	1540	0	28639	13934	5	0	\N
380305	2386	227000000	28639	13934	6	0	\N
380306	2404	100000000	28639	13934	7	0	\N
380307	2404	1200000000	28639	13934	8	0	\N
380308	1874	6858000	28639	13934	9	0	\N
380309	1874	6860000	28639	13934	10	0	\N
380310	1874	6862000	28639	13934	11	0	\N
380311	1874	6864000	28639	13934	12	0	\N
380312	2386	800227000000	28639	13934	13	0	\N
380313	2405	100000000	28639	13934	14	0	\N
380314	2406	100000000	28639	13934	15	0	\N
380315	2407	100000000	28639	13934	16	0	\N
380316	1874	6866000	28639	13934	17	0	\N
380317	2386	880227000000	28639	13934	18	0	\N
380318	1874	6868000	28639	13934	19	0	\N
380319	1874	6870000	28639	13934	20	0	\N
380320	1874	6872000	28639	13934	21	0	\N
380321	1874	6874000	28639	13934	22	0	\N
380322	1874	6876000	28639	13934	23	0	\N
380323	1874	6878000	28639	13934	24	0	\N
380324	1874	6880000	28639	13934	25	0	\N
380325	1874	6882000	28639	13934	26	0	\N
380326	1874	6884000	28639	13934	27	0	\N
380327	1874	6886000	28639	13934	28	0	\N
380328	1874	6888000	28639	13934	29	0	\N
380329	1874	6890000	28639	13934	30	0	\N
380330	1874	6892000	28639	13934	31	0	\N
380331	1874	6894000	28639	13934	32	0	\N
380332	1874	6896000	28639	13934	33	0	\N
380333	1874	6898000	28639	13934	34	0	\N
380334	1874	6900000	28639	13934	35	0	\N
380335	1874	6902000	28639	13934	36	0	\N
380336	1874	6904000	28639	13934	37	0	\N
380337	1874	6906000	28639	13934	38	0	\N
380338	1874	6908000	28639	13934	39	0	\N
380339	1874	6910000	28639	13934	40	0	\N
380340	1874	6912000	28639	13934	41	0	\N
380341	1874	6914000	28639	13934	42	0	\N
380342	1874	6916000	28639	13934	43	0	\N
380343	1874	6918000	28639	13934	44	0	\N
380344	1874	6920000	28639	13934	45	0	\N
380345	1874	6922000	28639	13934	46	0	\N
380346	1874	6924000	28639	13934	47	0	\N
380347	1874	6926000	28639	13934	48	0	\N
380348	1874	6928000	28639	13934	49	0	\N
380349	1874	6930000	28639	13934	50	0	\N
380350	1874	6932000	28639	13934	51	0	\N
380351	1874	6934000	28639	13934	52	0	\N
380352	1874	6936000	28639	13934	53	0	\N
380353	1874	6938000	28639	13934	54	0	\N
380354	1874	6940000	28639	13934	55	0	\N
380355	1874	6942000	28639	13934	56	0	\N
380356	1874	6944000	28639	13934	57	0	\N
380357	1874	6946000	28639	13934	58	0	\N
380358	1874	6948000	28639	13934	59	0	\N
380359	1874	6950000	28639	13934	60	0	\N
380360	1874	6952000	28639	13934	61	0	\N
380361	1874	6954000	28639	13934	62	0	\N
380362	1874	6956000	28639	13934	63	0	\N
380363	1874	6958000	28639	13934	64	0	\N
380364	1874	6960000	28639	13934	65	0	\N
380365	1874	6962000	28639	13934	66	0	\N
380366	1874	6964000	28639	13934	68	0	\N
380367	1874	6966000	28639	13934	69	0	\N
380368	1874	6968000	28639	13934	70	0	\N
380369	1874	6970000	28639	13934	71	0	\N
380370	1874	6972000	28639	13934	72	0	\N
380371	1874	6974000	28639	13934	73	0	\N
380372	1874	6976000	28639	13934	74	0	\N
380373	1874	6978000	28639	13934	75	0	\N
380374	1874	6980000	28639	13934	76	0	\N
380375	1874	6982000	28639	13934	77	0	\N
380376	1874	6984000	28639	13934	78	0	\N
380377	1874	6986000	28639	13934	79	0	\N
380378	1874	6988000	28639	13934	80	0	\N
380379	1874	6990000	28639	13934	81	0	\N
380380	1874	6992000	28639	13934	82	0	\N
380381	1874	6994000	28639	13934	83	0	\N
380382	1678	28800894455000	28640	14141	0	0	\N
380383	1874	7860000	28640	14141	1	0	\N
380390	1874	7523000	28643	14090	0	0	\N
380391	1874	7524000	28643	14090	1	0	\N
380392	1874	7525000	28643	14090	2	0	\N
380259	1678	28800894446000	28628	14136	0	0	1
380260	1874	7819000	28628	14136	1	0	3
380261	1874	7821000	28628	14136	2	0	3
380262	1678	28800894447000	28629	14137	0	0	1
380263	1678	28800894448000	28629	14137	1	0	1
380265	1678	28800894450000	28629	14137	3	0	1
380266	1874	7823000	28629	14137	4	0	3
380267	1874	7827000	28629	14137	5	0	3
380268	1874	7828000	28629	14137	6	0	3
380269	1874	7832000	28629	14137	7	0	3
380271	1874	7838000	28629	14137	9	0	3
380272	1874	7840000	28629	14137	10	0	3
380273	1874	7842000	28629	14137	11	0	3
380279	1678	28800894451000	28633	14138	0	0	1
380281	1678	28800894452000	28634	14139	0	0	1
380282	1678	28800894453000	28634	14139	1	0	1
380283	1874	7845000	28634	14139	2	0	3
380284	1874	7847000	28634	14139	3	0	3
380285	1874	7851000	28634	14139	4	0	3
380295	1678	28800894454000	28637	14140	0	0	1
380296	1874	7859000	28637	14140	1	0	3
380384	1678	28800894455000	28641	14141	0	0	1
380385	1874	7860000	28641	14141	1	0	3
380386	1678	28800894456000	28642	14142	0	0	1
380388	1874	7864000	28642	14142	2	0	3
380389	1874	7868000	28642	14142	3	0	3
380393	1874	7526000	28643	14090	3	0	\N
380394	1678	28800894456000	28644	14142	0	0	\N
380395	1678	28800894457000	28644	14142	1	0	\N
380396	1874	7864000	28644	14142	2	0	\N
380397	1874	7868000	28644	14142	3	0	\N
380398	1874	7872000	28645	14143	0	0	\N
380399	1874	7873000	28645	14143	1	0	\N
380400	1678	28800894458000	28646	14143	0	0	\N
380401	1874	7872000	28646	14143	1	0	\N
380402	1874	7873000	28646	14143	2	0	\N
380406	1678	28800894458000	28648	14143	0	0	\N
380407	1874	7872000	28648	14143	1	0	\N
380408	1874	7873000	28648	14143	2	0	\N
380409	1678	28800894459000	28649	14144	0	0	\N
380427	1678	28800894467000	28654	14148	0	0	\N
380428	1678	28800894468000	28654	14148	1	0	\N
380429	1678	28800894469000	28654	14148	2	0	\N
380430	1874	7903000	28654	14148	3	0	\N
380431	1874	7907000	28654	14148	4	0	\N
380432	1874	7908000	28654	14148	5	0	\N
380439	1678	28800894467000	28656	14148	0	0	\N
380440	1678	28800894468000	28656	14148	1	0	\N
380441	1678	28800894469000	28656	14148	2	0	\N
380442	1874	7903000	28656	14148	3	0	\N
380443	1874	7907000	28656	14148	4	0	\N
380444	1874	7908000	28656	14148	5	0	\N
380445	1678	28800894467000	28657	14148	0	0	\N
380446	1678	28800894468000	28657	14148	1	0	\N
380447	1678	28800894469000	28657	14148	2	0	\N
380448	1874	7903000	28657	14148	3	0	\N
380449	1874	7907000	28657	14148	4	0	\N
380450	1874	7908000	28657	14148	5	0	\N
380451	1779	3000000000	28658	14091	0	0	\N
380452	1874	7527000	28658	14091	1	0	\N
380453	1874	7528000	28658	14091	2	0	\N
380454	1874	7529000	28658	14091	3	0	\N
380455	1874	7530000	28658	14091	4	0	\N
380459	1678	28800894471000	28662	14150	0	0	\N
380465	1392	1711184787751650	28665	13945	0	0	\N
380466	2401	709000000000	28665	13945	1	0	\N
380467	2401	711880000000	28665	13945	2	0	\N
380468	2399	74000000000	28665	13945	3	0	\N
380469	2401	2078880000000	28665	13945	4	0	\N
380470	2402	49000000000	28665	13945	5	0	\N
380471	1146	910123796000000	28665	13945	6	0	\N
380472	1266	612619034000000	28665	13945	7	0	\N
380473	1026	507884011000000	28665	13945	8	0	\N
380474	121	66000099000000	28665	13945	9	0	\N
380475	835	3199985404837430	28665	13945	10	0	\N
380476	1779	3000000000	28665	13945	11	0	\N
380477	2386	130000000	28665	13945	12	0	\N
380478	1540	0	28665	13945	13	0	\N
380479	2403	1000000000	28665	13945	14	0	\N
380480	2386	227000000	28665	13945	15	0	\N
380481	2400	1000000000	28665	13945	16	0	\N
380482	2404	100000000	28665	13945	17	0	\N
380483	2404	1200000000	28665	13945	18	0	\N
380484	1874	6890000	28665	13945	19	0	\N
380485	2403	439000000000	28665	13945	20	0	\N
380486	2386	800227000000	28665	13945	21	0	\N
380487	2405	100000000	28665	13945	22	0	\N
380488	2406	100000000	28665	13945	23	0	\N
380489	2407	100000000	28665	13945	24	0	\N
380490	1874	6892000	28665	13945	25	0	\N
380491	1874	6894000	28665	13945	26	0	\N
380492	1874	6896000	28665	13945	27	0	\N
380493	1874	6898000	28665	13945	28	0	\N
380494	1874	6900000	28665	13945	29	0	\N
380495	1874	6902000	28665	13945	31	0	\N
380496	1874	6904000	28665	13945	32	0	\N
380497	1874	6906000	28665	13945	33	0	\N
380498	2386	880227000000	28665	13945	34	0	\N
380499	1874	6908000	28665	13945	35	0	\N
380500	1874	6910000	28665	13945	36	0	\N
380501	1874	6912000	28665	13945	37	0	\N
380502	1874	6914000	28665	13945	38	0	\N
380503	1874	6916000	28665	13945	39	0	\N
380504	1874	6918000	28665	13945	40	0	\N
380505	1874	6920000	28665	13945	41	0	\N
380506	1874	6922000	28665	13945	42	0	\N
380507	1874	6924000	28665	13945	43	0	\N
380508	1874	6926000	28665	13945	44	0	\N
380509	1874	6928000	28665	13945	45	0	\N
380510	1874	6930000	28665	13945	46	0	\N
380511	1874	6932000	28665	13945	47	0	\N
380512	1874	6934000	28665	13945	48	0	\N
380513	1874	6936000	28665	13945	49	0	\N
380514	1874	6938000	28665	13945	50	0	\N
380515	1874	6940000	28665	13945	51	0	\N
380516	1874	6942000	28665	13945	52	0	\N
380517	1874	6944000	28665	13945	53	0	\N
380518	1874	6946000	28665	13945	54	0	\N
380519	1874	6948000	28665	13945	55	0	\N
380520	1874	6950000	28665	13945	56	0	\N
380521	1874	6952000	28665	13945	57	0	\N
380522	1874	6954000	28665	13945	58	0	\N
380523	1874	6956000	28665	13945	59	0	\N
380524	1874	6958000	28665	13945	60	0	\N
380525	1874	6960000	28665	13945	61	0	\N
380526	1874	6962000	28665	13945	62	0	\N
380527	1874	6964000	28665	13945	63	0	\N
380528	1874	6966000	28665	13945	64	0	\N
380405	1874	7873000	28647	14143	2	0	3
380410	1678	28800894459000	28650	14144	0	0	1
380411	1678	28800894460000	28651	14145	0	0	1
380412	1678	28800894461000	28651	14145	1	0	1
380413	1874	7877000	28651	14145	2	0	3
380415	1678	28800894462000	28652	14146	0	0	1
380416	1678	28800894463000	28652	14146	1	0	1
380417	1779	3000000000	28652	14146	2	0	1
380418	1874	7882000	28652	14146	3	0	3
380419	1874	7886000	28652	14146	4	0	3
380421	1678	28800894465000	28653	14147	1	0	1
380422	1678	28800894466000	28653	14147	2	0	1
380423	1874	7887000	28653	14147	3	0	3
380424	1874	7891000	28653	14147	4	0	3
380426	1874	7899000	28653	14147	6	0	3
380433	1678	28800894467000	28655	14148	0	0	1
380434	1678	28800894468000	28655	14148	1	0	1
380435	1678	28800894469000	28655	14148	2	0	1
380436	1874	7903000	28655	14148	3	0	3
380438	1874	7908000	28655	14148	5	0	3
380456	1678	28800894470000	28659	14149	0	0	1
380457	1874	7912000	28659	14149	1	0	3
380458	1678	28800894471000	28661	14150	0	0	1
380460	1678	28800894472000	28663	14151	0	0	1
380462	1874	7917000	28663	14151	2	0	3
380463	1678	28800894473000	28664	14152	0	0	1
380464	1874	7921000	28664	14152	1	0	3
380529	1874	6968000	28665	13945	65	0	\N
380530	1874	6970000	28665	13945	66	0	\N
380531	1874	6972000	28665	13945	67	0	\N
380532	1678	28800894474000	28666	14153	0	0	\N
380533	1874	7925000	28666	14153	1	0	\N
380540	1678	28800894477000	28669	14155	0	0	\N
380541	2400	1693977634750000	28669	14155	1	0	\N
380542	1874	7934000	28669	14155	2	0	\N
380543	1678	28800894477000	28670	14155	0	0	\N
380544	2400	1693977634750000	28670	14155	1	0	\N
380545	1874	7934000	28670	14155	2	0	\N
380549	1392	1711184787751650	28672	14094	0	0	\N
380550	1146	910123796000000	28672	14094	1	0	\N
380551	1266	612619034000000	28672	14094	2	0	\N
380552	1026	507884011000000	28672	14094	3	0	\N
380553	1678	28080869419000	28672	14094	4	0	\N
380554	1678	28080869420000	28672	14094	5	0	\N
380555	1678	28080869421000	28672	14094	6	0	\N
380556	1678	28080869422000	28672	14094	7	0	\N
380557	1678	28080869423000	28672	14094	8	0	\N
380558	1678	28080869424000	28672	14094	9	0	\N
380559	1678	28080869425000	28672	14094	10	0	\N
380560	1678	28080869426000	28672	14094	11	0	\N
380561	1678	28080869427000	28672	14094	12	0	\N
380562	1678	28080869428000	28672	14094	13	0	\N
380563	1678	28080869429000	28672	14094	14	0	\N
380564	1678	28080869430000	28672	14094	15	0	\N
380565	1678	28080869431000	28672	14094	16	0	\N
380566	1678	28080869432000	28672	14094	17	0	\N
380567	1678	28080869433000	28672	14094	18	0	\N
380568	1678	28080869434000	28672	14094	19	0	\N
380569	1678	28080869435000	28672	14094	20	0	\N
380570	1678	28080869436000	28672	14094	21	0	\N
380571	1678	28080869437000	28672	14094	22	0	\N
380572	1678	28080869438000	28672	14094	23	0	\N
380573	1678	28080869439000	28672	14094	24	0	\N
380574	1678	28080869440000	28672	14094	25	0	\N
380575	1678	28080869441000	28672	14094	26	0	\N
380576	1678	28080869442000	28672	14094	27	0	\N
380577	1678	28080869443000	28672	14094	28	0	\N
380578	1678	28080869444000	28672	14094	29	0	\N
380579	1678	28080869445000	28672	14094	30	0	\N
380580	1678	28080869446000	28672	14094	31	0	\N
380581	1678	28080869447000	28672	14094	32	0	\N
380582	1678	28080869448000	28672	14094	33	0	\N
380583	1678	28080869449000	28672	14094	34	0	\N
380584	1678	28080869450000	28672	14094	35	0	\N
380585	1678	28080869451000	28672	14094	36	0	\N
380586	1678	28080869452000	28672	14094	37	0	\N
380587	1678	28080869453000	28672	14094	38	0	\N
380588	1678	28080869454000	28672	14094	39	0	\N
380589	1678	28080869455000	28672	14094	40	0	\N
380590	1678	28080869456000	28672	14094	41	0	\N
380591	1678	28080869457000	28672	14094	42	0	\N
380592	1678	28080869458000	28672	14094	43	0	\N
380593	1678	28080869459000	28672	14094	44	0	\N
380594	1678	28080869460000	28672	14094	45	0	\N
380595	1678	28080869461000	28672	14094	46	0	\N
380596	1678	28080869462000	28672	14094	47	0	\N
380597	1678	28080869463000	28672	14094	48	0	\N
380598	1678	28080869464000	28672	14094	49	0	\N
380599	1678	28080869465000	28672	14094	50	0	\N
380600	1678	28080869466000	28672	14094	51	0	\N
380601	1678	28080869467000	28672	14094	52	0	\N
380602	1678	28080869468000	28672	14094	53	0	\N
380603	1678	28080869469000	28672	14094	54	0	\N
380604	1678	28080869470000	28672	14094	55	0	\N
380605	1678	28080869471000	28672	14094	56	0	\N
380606	1678	28080869472000	28672	14094	57	0	\N
380607	1678	28080869473000	28672	14094	58	0	\N
380608	1678	28080869474000	28672	14094	59	0	\N
380609	1678	28080869475000	28672	14094	60	0	\N
380610	1678	28080869476000	28672	14094	61	0	\N
380611	1678	28080869477000	28672	14094	62	0	\N
380612	1779	3000000000	28672	14094	63	0	\N
380613	1874	7669000	28672	14094	64	0	\N
380614	1874	7671000	28672	14094	65	0	\N
380615	2407	100000000	28672	14094	66	0	\N
380616	1874	7673000	28672	14094	67	0	\N
380617	2400	1693977634750000	28672	14094	68	0	\N
380618	1874	7674000	28672	14094	69	0	\N
380619	1874	7675000	28672	14094	70	0	\N
380620	1874	7676000	28672	14094	71	0	\N
380621	1874	7677000	28672	14094	72	0	\N
380622	1874	7678000	28672	14094	73	0	\N
380623	1874	7679000	28672	14094	74	0	\N
380624	1874	7681000	28672	14094	75	0	\N
380625	1874	7683000	28672	14094	76	0	\N
380626	1874	7685000	28672	14094	77	0	\N
380627	1874	7687000	28672	14094	78	0	\N
380628	1874	7689000	28672	14094	80	0	\N
380629	1874	7691000	28672	14094	81	0	\N
380630	1874	7693000	28672	14094	82	0	\N
380631	1874	7695000	28672	14094	83	0	\N
380632	1874	7696000	28672	14094	84	0	\N
380633	1874	7697000	28672	14094	85	0	\N
380634	1874	7698000	28672	14094	86	0	\N
380635	1874	7699000	28672	14094	87	0	\N
380636	1874	7700000	28672	14094	88	0	\N
380637	1874	7701000	28672	14094	89	0	\N
380638	1874	7702000	28672	14094	90	0	\N
380639	1874	7703000	28672	14094	91	0	\N
380640	1874	7704000	28672	14094	92	0	\N
380641	1874	7705000	28672	14094	93	0	\N
380642	1874	7706000	28672	14094	94	0	\N
380643	1874	7707000	28672	14094	95	0	\N
380644	1874	7709000	28672	14094	96	0	\N
380645	1874	7711000	28672	14094	97	0	\N
380646	1874	7713000	28672	14094	98	0	\N
380647	1874	7715000	28672	14094	99	0	\N
380648	1874	7717000	28672	14094	100	0	\N
380649	1874	7719000	28672	14094	101	0	\N
380650	1874	7721000	28672	14094	102	0	\N
380651	1874	7723000	28672	14094	103	0	\N
380652	1874	7725000	28672	14094	104	0	\N
380653	1874	7727000	28672	14094	105	0	\N
380654	1874	7729000	28672	14094	106	0	\N
380655	1874	7731000	28672	14094	107	0	\N
380656	1874	7733000	28672	14094	108	0	\N
380657	1874	7735000	28672	14094	109	0	\N
380658	1874	7737000	28672	14094	110	0	\N
380659	1874	7739000	28672	14094	111	0	\N
380660	1874	7741000	28672	14094	112	0	\N
380661	1874	7743000	28672	14094	113	0	\N
380662	1874	7745000	28672	14094	114	0	\N
380663	1874	7747000	28672	14094	115	0	\N
380664	1874	7749000	28672	14094	116	0	\N
380536	1678	28800894475000	28668	14154	0	0	1
380537	1678	28800894476000	28668	14154	1	0	1
380538	1874	7926000	28668	14154	2	0	3
380539	1874	7930000	28668	14154	3	0	3
380546	1678	28800894477000	28671	14155	0	0	1
380548	1874	7934000	28671	14155	2	0	3
380665	1874	7751000	28672	14094	117	0	\N
380666	1874	7753000	28672	14094	118	0	\N
380667	1678	28800894478000	28673	14156	0	0	\N
380668	1678	28800894479000	28673	14156	1	0	\N
380669	1874	7935000	28673	14156	2	0	\N
380670	1874	7939000	28673	14156	3	0	\N
380671	1678	28800894478000	28674	14156	0	0	\N
380672	1678	28800894479000	28674	14156	1	0	\N
380673	1874	7935000	28674	14156	2	0	\N
380674	1874	7939000	28674	14156	3	0	\N
380679	1678	28800894478000	28676	14156	0	0	\N
380680	1678	28800894479000	28676	14156	1	0	\N
380681	1874	7935000	28676	14156	2	0	\N
380682	1874	7939000	28676	14156	3	0	\N
380683	1779	3000000000	28677	13886	0	0	\N
380684	1874	6522000	28677	13886	1	0	\N
380685	2400	1693977634750000	28677	13886	2	0	\N
380686	1874	6523000	28677	13886	3	0	\N
380687	1874	6524000	28677	13886	4	0	\N
380688	1874	6525000	28677	13886	5	0	\N
380689	1874	6526000	28677	13886	6	0	\N
380690	1874	6527000	28677	13886	7	0	\N
380691	1874	6528000	28677	13886	8	0	\N
380692	1874	6529000	28677	13886	9	0	\N
380693	1874	6530000	28677	13886	10	0	\N
380702	1678	28800894482000	28680	14158	0	0	\N
380703	1874	7951000	28680	14158	1	0	\N
380704	1874	7952000	28680	14158	2	0	\N
380705	1874	7954000	28680	14158	3	0	\N
380708	1874	6531000	28682	13887	0	0	\N
380716	1678	28800894485000	28686	14161	0	0	\N
380717	1874	7964000	28686	14161	1	0	\N
380718	1874	7965000	28686	14161	2	0	\N
380719	1874	7969000	28686	14161	3	0	\N
380720	1678	28800894485000	28687	14161	0	0	\N
380721	1874	7964000	28687	14161	1	0	\N
380722	1874	7965000	28687	14161	2	0	\N
380723	1874	7969000	28687	14161	3	0	\N
380736	1678	28800894489000	28692	14165	0	0	\N
380737	1874	7988000	28692	14165	1	0	\N
380738	1874	7990000	28692	14165	2	0	\N
380739	1678	28800894489000	28693	14165	0	0	\N
380740	1874	7988000	28693	14165	1	0	\N
380741	1874	7990000	28693	14165	2	0	\N
380744	1678	28800894490000	28695	14166	0	0	\N
380745	1874	7992000	28695	14166	1	0	\N
380746	1678	28800894491000	28696	14167	0	0	\N
380747	1874	7994000	28696	14167	1	0	\N
380748	1874	7998000	28696	14167	2	0	\N
380749	1678	28800894491000	28697	14167	0	0	\N
380750	1874	7994000	28697	14167	1	0	\N
380751	1874	7998000	28697	14167	2	0	\N
380768	1678	28800894496000	28704	14172	0	0	\N
380769	1874	8022000	28704	14172	1	0	\N
380770	1874	8026000	28704	14172	2	0	\N
380774	1874	8022000	28706	14172	0	0	\N
380775	1874	8026000	28706	14172	1	0	\N
380776	1874	8028000	28707	14173	0	0	\N
380777	1874	8028000	28709	14173	0	0	\N
380778	1874	8028000	28711	14173	0	0	\N
380779	1874	8028000	28712	14173	0	0	\N
380780	1874	8028000	28713	14173	0	0	\N
380781	1874	8028000	28714	14173	0	0	\N
380786	1678	28800894497000	28720	14174	0	0	\N
380787	1874	8032000	28720	14174	1	0	\N
380788	1874	8033000	28720	14174	2	0	\N
380789	1874	8035000	28720	14174	3	0	\N
380790	1678	28800894497000	28721	14174	0	0	\N
380791	1874	8032000	28721	14174	1	0	\N
380792	1874	8033000	28721	14174	2	0	\N
380793	1874	8035000	28721	14174	3	0	\N
380794	1678	28800894498000	28722	14175	0	0	\N
380795	1678	28800894499000	28722	14175	1	0	\N
380796	1874	8037000	28722	14175	2	0	\N
380797	1874	8041000	28722	14175	3	0	\N
380798	1874	8043000	28722	14175	4	0	\N
380799	1874	8045000	28722	14175	5	0	\N
380800	1874	8047000	28722	14175	6	0	\N
380677	1874	7935000	28675	14156	2	0	3
380678	1874	7939000	28675	14156	3	0	3
380694	1678	28800894480000	28678	14157	0	0	1
380695	1678	28800894481000	28678	14157	1	0	1
380696	1874	7943000	28678	14157	2	0	3
380698	1678	28800894482000	28679	14158	0	0	1
380699	1874	7951000	28679	14158	1	0	3
380700	1874	7952000	28679	14158	2	0	3
380701	1874	7954000	28679	14158	3	0	3
380706	1678	28800894483000	28681	14159	0	0	1
380709	1678	28800894484000	28683	14160	0	0	1
380710	1874	7960000	28683	14160	1	0	3
380711	1874	7962000	28683	14160	2	0	3
380712	1678	28800894485000	28685	14161	0	0	1
380714	1874	7965000	28685	14161	2	0	3
380715	1874	7969000	28685	14161	3	0	3
380724	1678	28800894486000	28688	14162	0	0	1
380725	1874	7971000	28688	14162	1	0	3
380726	1874	7975000	28688	14162	2	0	3
380728	1874	7977000	28689	14163	1	0	3
380729	1678	28800894488000	28690	14164	0	0	1
380730	1874	7979000	28690	14164	1	0	3
380731	1874	7980000	28690	14164	2	0	3
380732	1874	7984000	28690	14164	3	0	3
380734	1874	7988000	28691	14165	1	0	3
380735	1874	7990000	28691	14165	2	0	3
380742	1678	28800894490000	28694	14166	0	0	1
380743	1874	7992000	28694	14166	1	0	3
380753	1874	7994000	28698	14167	1	0	3
380754	1874	7998000	28698	14167	2	0	3
380755	1678	28800894492000	28699	14168	0	0	1
380756	1874	7999000	28699	14168	1	0	3
380757	1874	8003000	28699	14168	2	0	3
380759	1678	28800894493000	28700	14169	0	0	1
380760	1874	8007000	28700	14169	1	0	3
380761	1874	8011000	28700	14169	2	0	3
380762	1678	28800894494000	28702	14170	0	0	1
380763	1874	8013000	28702	14170	1	0	3
380765	1874	8017000	28703	14171	1	0	3
380766	1874	8019000	28703	14171	2	0	3
380767	1874	8020000	28703	14171	3	0	3
380771	1678	28800894496000	28705	14172	0	0	1
380773	1874	8026000	28705	14172	2	0	3
380782	1874	8028000	28716	14173	0	0	3
380783	1678	28800894497000	28719	14174	0	0	1
380784	1874	8032000	28719	14174	1	0	3
380785	1874	8033000	28719	14174	2	0	3
380801	1678	28800894498000	28723	14175	0	0	\N
380802	1678	28800894499000	28723	14175	1	0	\N
380803	1874	8037000	28723	14175	2	0	\N
380804	1874	8041000	28723	14175	3	0	\N
380805	1874	8043000	28723	14175	4	0	\N
380806	1874	8045000	28723	14175	5	0	\N
380807	1874	8047000	28723	14175	6	0	\N
380817	1678	28800894500000	28726	14176	0	0	\N
380818	1874	8049000	28726	14176	1	0	\N
380819	1678	28800894501000	28730	14177	0	0	\N
380820	1874	8050000	28730	14177	1	0	\N
380821	1874	8054000	28730	14177	2	0	\N
380822	1874	8056000	28730	14177	3	0	\N
380830	1678	28800894502000	28733	14178	0	0	\N
380831	1874	8058000	28733	14178	1	0	\N
380832	1874	8062000	28733	14178	2	0	\N
380833	1464	1014000000	28734	14177	0	0	\N
380834	1678	28800894501000	28734	14177	1	0	\N
380835	1678	28800894502000	28734	14177	2	0	\N
380836	1678	28800894503000	28734	14177	3	0	\N
380837	1874	8050000	28734	14177	4	0	\N
380842	1678	28800894504000	28736	14180	0	0	\N
380843	1874	8069000	28736	14180	1	0	\N
380846	1678	28800894505000	28738	14181	0	0	\N
380847	1874	8073000	28738	14181	1	0	\N
380850	1678	28800894505000	28740	14181	0	0	\N
380851	1874	8073000	28740	14181	1	0	\N
380852	1464	1014000000	28741	14044	0	0	\N
380853	1392	1711184787751650	28741	14044	1	0	\N
380854	1678	28080869320000	28741	14044	2	0	\N
380855	1678	28080869321000	28741	14044	3	0	\N
380856	1678	28080869322000	28741	14044	4	0	\N
380857	1678	28080869323000	28741	14044	5	0	\N
380858	1678	28080869324000	28741	14044	6	0	\N
380859	1678	28080869325000	28741	14044	7	0	\N
380860	1146	910123796000000	28741	14044	8	0	\N
380861	1266	612619034000000	28741	14044	9	0	\N
380862	1026	507884011000000	28741	14044	10	0	\N
380863	1678	28080869326000	28741	14044	11	0	\N
380864	1678	28080869327000	28741	14044	12	0	\N
380865	1678	28080869328000	28741	14044	13	0	\N
380866	1678	28080869329000	28741	14044	14	0	\N
380867	1678	28080869330000	28741	14044	15	0	\N
380868	1678	28080869331000	28741	14044	16	0	\N
380869	1678	28080869332000	28741	14044	17	0	\N
380870	1678	28080869333000	28741	14044	18	0	\N
380871	1678	28080869334000	28741	14044	19	0	\N
380872	1678	28080869335000	28741	14044	20	0	\N
380873	1678	28080869336000	28741	14044	21	0	\N
380874	1678	28080869337000	28741	14044	22	0	\N
380875	1678	28080869338000	28741	14044	23	0	\N
380876	1678	28080869339000	28741	14044	24	0	\N
380877	1678	28080869340000	28741	14044	25	0	\N
380878	1678	28080869341000	28741	14044	26	0	\N
380879	1678	28080869342000	28741	14044	27	0	\N
380880	1678	28080869343000	28741	14044	28	0	\N
380881	1678	28080869344000	28741	14044	29	0	\N
380882	1678	28080869345000	28741	14044	30	0	\N
380883	1678	28080869346000	28741	14044	31	0	\N
380884	1678	28080869347000	28741	14044	32	0	\N
380885	1678	28080869348000	28741	14044	33	0	\N
380886	1678	28080869349000	28741	14044	34	0	\N
380887	1678	28080869350000	28741	14044	35	0	\N
380888	1678	28080869351000	28741	14044	36	0	\N
380889	1678	28080869352000	28741	14044	37	0	\N
380890	1678	28080869353000	28741	14044	38	0	\N
380891	1678	28080869354000	28741	14044	39	0	\N
380892	1678	28080869355000	28741	14044	40	0	\N
380893	1678	28080869356000	28741	14044	41	0	\N
380894	1678	28080869357000	28741	14044	42	0	\N
380895	1678	28080869358000	28741	14044	43	0	\N
380896	1678	28080869359000	28741	14044	44	0	\N
380897	1678	28080869360000	28741	14044	45	0	\N
380898	1678	28080869361000	28741	14044	46	0	\N
380899	1678	28080869362000	28741	14044	47	0	\N
380900	1678	28080869363000	28741	14044	48	0	\N
380901	1678	28080869364000	28741	14044	49	0	\N
380902	1678	28080869365000	28741	14044	50	0	\N
380903	1678	28080869366000	28741	14044	51	0	\N
380904	1678	28080869367000	28741	14044	53	0	\N
380905	1678	28080869368000	28741	14044	54	0	\N
380906	1678	28080869369000	28741	14044	55	0	\N
380907	1678	28080869370000	28741	14044	56	0	\N
380908	1678	28080869371000	28741	14044	57	0	\N
380909	1678	28080869372000	28741	14044	58	0	\N
380910	1678	28080869373000	28741	14044	59	0	\N
380911	1678	28080869374000	28741	14044	60	0	\N
380912	1678	28080869375000	28741	14044	61	0	\N
380913	1678	28080869376000	28741	14044	62	0	\N
380914	1678	28080869377000	28741	14044	63	0	\N
380915	1678	28080869378000	28741	14044	64	0	\N
380916	1678	28080869379000	28741	14044	65	0	\N
380917	1678	28080869380000	28741	14044	66	0	\N
380918	1678	28080869381000	28741	14044	67	0	\N
380919	1678	28080869382000	28741	14044	68	0	\N
380920	1678	28080869383000	28741	14044	69	0	\N
380921	1678	28080869384000	28741	14044	70	0	\N
380922	1678	28080869385000	28741	14044	71	0	\N
380923	1678	28080869386000	28741	14044	72	0	\N
380924	1678	28080869387000	28741	14044	73	0	\N
380925	1678	28080869388000	28741	14044	74	0	\N
380926	1678	28080869389000	28741	14044	75	0	\N
380927	1678	28080869390000	28741	14044	76	0	\N
380928	1678	28080869391000	28741	14044	77	0	\N
380929	1678	28080869392000	28741	14044	78	0	\N
380930	1678	28080869393000	28741	14044	79	0	\N
380931	1678	28080869394000	28741	14044	80	0	\N
380932	1678	28080869395000	28741	14044	81	0	\N
380933	1678	28080869396000	28741	14044	82	0	\N
380934	1678	28080869397000	28741	14044	83	0	\N
380935	1678	28080869398000	28741	14044	84	0	\N
380936	1678	28080869399000	28741	14044	85	0	\N
380810	1874	8037000	28724	14175	2	0	3
380811	1874	8041000	28724	14175	3	0	3
380812	1874	8043000	28724	14175	4	0	3
380813	1874	8045000	28724	14175	5	0	3
380814	1874	8047000	28724	14175	6	0	3
380816	1874	8049000	28725	14176	1	0	3
380823	1678	28800894501000	28731	14177	0	0	1
380824	1874	8050000	28731	14177	1	0	3
380825	1874	8054000	28731	14177	2	0	3
380826	1874	8056000	28731	14177	3	0	3
380828	1874	8058000	28732	14178	1	0	3
380829	1874	8062000	28732	14178	2	0	3
380838	1464	1014000000	28735	14179	0	0	2
380839	1678	28800894503000	28735	14179	1	0	1
380841	1874	8068000	28735	14179	3	0	3
380844	1678	28800894504000	28737	14180	0	0	1
380845	1874	8069000	28737	14180	1	0	3
380848	1678	28800894505000	28739	14181	0	0	1
380849	1874	8073000	28739	14181	1	0	3
380937	1678	28080869400000	28741	14044	86	0	\N
380938	1678	28080869401000	28741	14044	87	0	\N
380939	1678	28080869402000	28741	14044	88	0	\N
380940	1678	28080869403000	28741	14044	89	0	\N
380941	1678	28080869404000	28741	14044	90	0	\N
380942	1678	28080869405000	28741	14044	91	0	\N
380943	1678	28080869406000	28741	14044	92	0	\N
380944	1678	28080869407000	28741	14044	93	0	\N
380945	1678	28080869408000	28741	14044	94	0	\N
380946	1678	28080869409000	28741	14044	95	0	\N
380947	1678	28080869410000	28741	14044	96	0	\N
380948	1678	28080869411000	28741	14044	97	0	\N
380949	1678	28080869412000	28741	14044	98	0	\N
380950	1678	28080869413000	28741	14044	99	0	\N
380951	1678	28080869414000	28741	14044	100	0	\N
380952	1678	28080869415000	28741	14044	101	0	\N
380953	1678	28080869416000	28741	14044	102	0	\N
380954	1678	28080869417000	28741	14044	103	0	\N
380955	1678	28080869418000	28741	14044	104	0	\N
380956	1678	28080869419000	28741	14044	105	0	\N
380957	1678	28080869420000	28741	14044	106	0	\N
380958	1678	28080869421000	28741	14044	107	0	\N
380959	1678	28080869422000	28741	14044	108	0	\N
380960	1678	28080869423000	28741	14044	109	0	\N
380961	1678	28080869424000	28741	14044	110	0	\N
380962	1678	28080869425000	28741	14044	111	0	\N
380963	1678	28080869426000	28741	14044	112	0	\N
380964	1678	28080869427000	28741	14044	113	0	\N
380965	1678	28080869428000	28741	14044	114	0	\N
380966	1678	28080869429000	28741	14044	115	0	\N
380967	1678	28080869430000	28741	14044	116	0	\N
380968	1678	28080869431000	28741	14044	117	0	\N
380969	1678	28080869432000	28741	14044	118	0	\N
380970	1678	28080869433000	28741	14044	119	0	\N
380971	1678	28080869434000	28741	14044	120	0	\N
380972	1678	28080869435000	28741	14044	121	0	\N
380973	1678	28080869436000	28741	14044	122	0	\N
380974	1678	28080869437000	28741	14044	123	0	\N
380975	1678	28080869438000	28741	14044	124	0	\N
380976	1678	28080869439000	28741	14044	125	0	\N
380977	1678	28800894506000	28742	14182	0	0	\N
380978	1874	8077000	28742	14182	1	0	\N
380981	1678	28800894506000	28744	14182	0	0	\N
380982	1874	8077000	28744	14182	1	0	\N
380983	1678	28800894506000	28745	14182	0	0	\N
380984	1874	8077000	28745	14182	1	0	\N
380985	1464	1014000000	28747	13906	0	0	\N
380989	1678	28800894507000	28749	14183	0	0	\N
380990	1874	8078000	28749	14183	1	0	\N
380991	1874	8082000	28749	14183	2	0	\N
380992	1678	28800894507000	28750	14183	0	0	\N
380993	1874	8078000	28750	14183	1	0	\N
380994	1874	8082000	28750	14183	2	0	\N
380997	1464	1014000000	28752	13973	0	0	\N
380998	1464	1014000000	28753	13979	0	0	\N
380999	1464	1014000000	28754	13995	0	0	\N
381000	1678	28800894509000	28755	14185	0	0	\N
381001	1874	8090000	28755	14185	1	0	\N
381004	1678	28800894510000	28757	14186	0	0	\N
381005	1874	8092000	28757	14186	1	0	\N
381006	1874	8093000	28757	14186	2	0	\N
381007	1874	8097000	28757	14186	3	0	\N
381014	1678	28800894511000	28760	14187	0	0	\N
381015	1874	8099000	28760	14187	1	0	\N
381016	1678	28800894511000	28761	14187	0	0	\N
381017	1874	8099000	28761	14187	1	0	\N
381022	1678	28800894513000	28763	14189	0	0	\N
381023	1874	8106000	28763	14189	1	0	\N
381036	1678	28800894514000	28767	14190	0	0	\N
381037	1678	28800894515000	28767	14190	2	0	\N
381038	1874	8114000	28767	14190	3	0	\N
381039	1874	8116000	28767	14190	4	0	\N
381040	1874	8118000	28767	14190	5	0	\N
381041	1874	8119000	28767	14190	6	0	\N
381042	1874	8123000	28767	14190	7	0	\N
381043	1874	8127000	28767	14190	8	0	\N
381044	1678	28800894514000	28768	14190	0	0	\N
381045	1678	28800894515000	28768	14190	2	0	\N
381046	1874	8114000	28768	14190	3	0	\N
381047	1874	8116000	28768	14190	4	0	\N
381048	1874	8118000	28768	14190	5	0	\N
381049	1874	8119000	28768	14190	6	0	\N
381050	1874	8123000	28768	14190	7	0	\N
381051	1874	8127000	28768	14190	8	0	\N
381062	1483	11000000	28771	14192	0	0	\N
381063	1678	28800894518000	28771	14192	1	0	\N
381064	1874	8141000	28771	14192	2	0	\N
381069	1874	8152000	28773	14194	0	0	\N
381070	1678	28800894520000	28774	14194	0	0	\N
381071	1874	8152000	28774	14194	1	0	\N
381072	1874	8154000	28774	14194	2	0	\N
380986	1678	28800894507000	28748	14183	0	0	1
380987	1874	8078000	28748	14183	1	0	3
380988	1874	8082000	28748	14183	2	0	3
380995	1678	28800894508000	28751	14184	0	0	1
380996	1874	8086000	28751	14184	1	0	3
381003	1874	8090000	28756	14185	1	0	3
381008	1678	28800894510000	28758	14186	0	0	1
381009	1874	8092000	28758	14186	1	0	3
381010	1874	8093000	28758	14186	2	0	3
381011	1874	8097000	28758	14186	3	0	3
381013	1874	8099000	28759	14187	1	0	3
381018	2408	2000000000	28762	14188	0	0	0
381019	1678	28800894512000	28762	14188	1	0	1
381020	1874	8103000	28762	14188	2	0	3
381024	1678	28800894513000	28764	14189	0	0	1
381025	1874	8107000	28764	14189	1	0	3
381026	1874	8111000	28764	14189	2	0	3
381027	1874	8112000	28764	14189	3	0	3
381028	1678	28800894514000	28766	14190	0	0	1
381030	1874	8114000	28766	14190	3	0	3
381031	1874	8116000	28766	14190	4	0	3
381032	1874	8118000	28766	14190	5	0	3
381033	1874	8119000	28766	14190	6	0	3
381034	1874	8123000	28766	14190	7	0	3
381052	1678	28800894516000	28769	14191	0	0	1
381053	1678	28800894517000	28769	14191	1	0	1
381054	1874	8131000	28769	14191	2	0	3
381055	1874	8135000	28769	14191	3	0	3
381057	2409	100000000	28769	14191	5	0	0
381058	1874	8139000	28769	14191	6	0	3
381059	1483	11000000	28770	14192	0	0	0
381060	1678	28800894518000	28770	14192	1	0	1
381061	1874	8141000	28770	14192	2	0	3
381066	1874	8142000	28772	14193	1	0	3
381067	1874	8146000	28772	14193	2	0	3
381068	1874	8148000	28772	14193	3	0	3
381073	1678	28800894520000	28775	14194	0	0	\N
381074	1874	8152000	28775	14194	1	0	\N
381075	1874	8154000	28775	14194	2	0	\N
381085	1678	28800894520000	28778	14195	0	0	\N
381086	1678	28800894521000	28778	14195	1	0	\N
381087	1678	28800894522000	28778	14195	2	0	\N
381088	1874	8154000	28778	14195	3	0	\N
381089	1874	8156000	28778	14195	4	0	\N
381090	1874	8157000	28778	14195	5	0	\N
381091	1874	8159000	28778	14195	6	0	\N
381092	1874	8163000	28778	14195	7	0	\N
381099	1678	28800894523000	28780	14196	0	0	\N
381100	1678	28800894524000	28780	14196	1	0	\N
381101	1874	8165000	28780	14196	2	0	\N
381102	1874	8169000	28780	14196	3	0	\N
381103	1874	8173000	28780	14196	4	0	\N
381104	1874	8175000	28780	14196	5	0	\N
381105	1678	28800894523000	28781	14196	0	0	\N
381106	1678	28800894524000	28781	14196	1	0	\N
381107	1874	8165000	28781	14196	2	0	\N
381108	1874	8169000	28781	14196	3	0	\N
381109	1874	8173000	28781	14196	4	0	\N
381110	1874	8175000	28781	14196	5	0	\N
381111	1678	28800894523000	28782	14196	0	0	\N
381112	1678	28800894524000	28782	14196	1	0	\N
381113	1874	8165000	28782	14196	2	0	\N
381114	1874	8169000	28782	14196	3	0	\N
381115	1874	8173000	28782	14196	4	0	\N
381116	1874	8175000	28782	14196	5	0	\N
381129	1678	28800894528000	28786	14199	0	0	\N
381130	1874	8192000	28786	14199	1	0	\N
381131	1874	8196000	28786	14199	2	0	\N
381154	1678	28800894536000	28792	14205	0	0	\N
381155	1678	28800894537000	28792	14205	1	0	\N
381156	1874	8237000	28792	14205	2	0	\N
381157	1874	8239000	28792	14205	3	0	\N
381158	1874	8241000	28792	14205	4	0	\N
381159	1678	28800894536000	28793	14205	0	0	\N
381160	1678	28800894537000	28793	14205	1	0	\N
381161	1874	8237000	28793	14205	2	0	\N
381162	1874	8239000	28793	14205	3	0	\N
381163	1874	8241000	28793	14205	4	0	\N
381169	1678	28800894538000	28795	14206	0	0	\N
381170	1874	8243000	28795	14206	1	0	\N
381171	1874	8247000	28795	14206	2	0	\N
381172	1678	28800894538000	28796	14206	0	0	\N
381173	1874	8243000	28796	14206	1	0	\N
381174	1874	8247000	28796	14206	2	0	\N
381178	1874	8248000	28798	14207	0	0	\N
381179	1874	8252000	28798	14207	1	0	\N
381180	1874	8254000	28798	14207	2	0	\N
381187	1678	28800894540000	28805	14209	0	0	\N
381188	1678	28800894541000	28805	14209	1	0	\N
381189	1874	8264000	28805	14209	2	0	\N
381190	1874	8265000	28805	14209	3	0	\N
381191	1874	8267000	28805	14209	4	0	\N
381192	1874	8269000	28805	14209	6	0	\N
381199	1678	28800894542000	28807	14210	0	0	\N
381200	1874	8273000	28807	14210	1	0	\N
381201	1874	8275000	28807	14210	2	0	\N
381202	1678	28800894542000	28808	14210	0	0	\N
381203	1874	8273000	28808	14210	1	0	\N
381204	1874	8275000	28808	14210	2	0	\N
381208	1678	28800894542000	28810	14210	0	0	\N
381078	1678	28800894521000	28777	14195	1	0	1
381079	1678	28800894522000	28777	14195	2	0	1
381080	1874	8154000	28777	14195	3	0	3
381081	1874	8156000	28777	14195	4	0	3
381082	1874	8157000	28777	14195	5	0	3
381084	1874	8163000	28777	14195	7	0	3
381093	1678	28800894523000	28779	14196	0	0	1
381094	1678	28800894524000	28779	14196	1	0	1
381095	1874	8165000	28779	14196	2	0	3
381096	1874	8169000	28779	14196	3	0	3
381098	1874	8175000	28779	14196	5	0	3
381117	1678	28800894525000	28783	14197	0	0	1
381118	1874	8176000	28783	14197	1	0	3
381119	1874	8180000	28783	14197	2	0	3
381121	1678	28800894526000	28784	14198	0	0	1
381122	1678	28800894527000	28784	14198	1	0	1
381123	1874	8186000	28784	14198	2	0	3
381124	1874	8188000	28784	14198	3	0	3
381125	1874	8190000	28784	14198	4	0	3
381127	1874	8192000	28785	14199	1	0	3
381128	1874	8196000	28785	14199	2	0	3
381132	1678	28800894529000	28787	14200	0	0	1
381133	1874	8197000	28787	14200	1	0	3
381134	1874	8199000	28787	14200	2	0	3
381136	1678	28800894530000	28788	14201	0	0	1
381137	1874	8205000	28788	14201	1	0	3
381138	1678	28800894531000	28789	14202	0	0	1
381139	1678	28800894532000	28789	14202	1	0	1
381141	1874	8206000	28789	14202	3	0	3
381142	1874	8210000	28789	14202	4	0	3
381143	1874	8212000	28789	14202	5	0	3
381144	1874	8214000	28789	14202	6	0	3
381145	1874	8216000	28789	14202	7	0	3
381147	1874	8224000	28789	14202	9	0	3
381148	1678	28800894534000	28790	14203	0	0	1
381149	1874	8226000	28790	14203	1	0	3
381150	1678	28800894535000	28791	14204	0	0	1
381151	1874	8230000	28791	14204	1	0	3
381153	1874	8233000	28791	14204	3	0	3
381164	1678	28800894536000	28794	14205	0	0	1
381165	1678	28800894537000	28794	14205	1	0	1
381166	1874	8237000	28794	14205	2	0	3
381168	1874	8241000	28794	14205	4	0	3
381175	1678	28800894538000	28797	14206	0	0	1
381176	1874	8243000	28797	14206	1	0	3
381177	1874	8247000	28797	14206	2	0	3
381181	1874	8248000	28799	14207	0	0	3
381183	1678	28800894539000	28802	14208	0	0	1
381184	1874	8256000	28802	14208	1	0	3
381185	1874	8258000	28802	14208	2	0	3
381186	1874	8260000	28802	14208	3	0	3
381193	1678	28800894540000	28806	14209	0	0	1
381195	1874	8264000	28806	14209	2	0	3
381196	1874	8265000	28806	14209	3	0	3
381197	1874	8267000	28806	14209	4	0	3
381198	1874	8269000	28806	14209	6	0	3
381206	1874	8273000	28809	14210	1	0	3
381207	1874	8275000	28809	14210	2	0	3
381209	1874	8273000	28810	14210	1	0	\N
381210	1874	8275000	28810	14210	2	0	\N
381214	1678	28800894543000	28812	14211	0	0	\N
381215	1874	8279000	28812	14211	1	0	\N
381216	1678	28800894544000	28813	14212	0	0	\N
381217	1874	8282000	28813	14212	1	0	\N
381218	1874	8284000	28813	14212	2	0	\N
381219	1874	8282000	28814	14212	0	0	\N
381220	1678	28800894544000	28815	14212	0	0	\N
381221	1874	8282000	28815	14212	1	0	\N
381222	1874	8284000	28815	14212	2	0	\N
381229	1678	28800894546000	28818	14214	0	0	\N
381230	1874	8294000	28818	14214	1	0	\N
381231	1874	8296000	28818	14214	2	0	\N
381242	2408	2000000000	28823	14162	0	0	\N
381243	1464	1014000000	28823	14162	1	0	\N
381244	2409	100000000	28823	14162	2	0	\N
381245	1874	7970000	28823	14162	3	0	\N
381246	1874	7971000	28823	14162	4	0	\N
381247	1874	7972000	28823	14162	5	0	\N
381248	1874	7973000	28823	14162	6	0	\N
381249	1874	7974000	28823	14162	7	0	\N
381250	1874	7975000	28823	14162	8	0	\N
381251	1874	7976000	28823	14162	9	0	\N
381252	1874	7977000	28823	14162	10	0	\N
381253	1874	7978000	28823	14162	11	0	\N
381254	1874	7979000	28823	14162	12	0	\N
381255	1874	7980000	28823	14162	13	0	\N
381256	1678	28800894550000	28824	14218	0	0	\N
381257	1678	28800894551000	28824	14218	1	0	\N
381258	1874	8309000	28824	14218	2	0	\N
381259	1874	8310000	28824	14218	3	0	\N
381260	1874	8314000	28824	14218	4	0	\N
381261	1874	8316000	28824	14218	5	0	\N
381262	1874	8318000	28824	14218	6	0	\N
381263	1874	8320000	28824	14218	7	0	\N
381264	1678	28800894550000	28825	14218	0	0	\N
381265	1678	28800894551000	28825	14218	1	0	\N
381266	1874	8309000	28825	14218	2	0	\N
381267	1874	8310000	28825	14218	3	0	\N
381268	1874	8314000	28825	14218	4	0	\N
381269	1874	8316000	28825	14218	5	0	\N
381270	1874	8318000	28825	14218	6	0	\N
381271	1874	8320000	28825	14218	7	0	\N
381283	1678	28800894553000	28828	14220	0	0	\N
381284	1678	28800894554000	28828	14220	1	0	\N
381285	1874	8327000	28828	14220	2	0	\N
381286	1874	8329000	28828	14220	3	0	\N
381287	1874	8331000	28828	14220	4	0	\N
381288	1874	8335000	28828	14220	5	0	\N
381289	1874	8339000	28828	14220	6	0	\N
381290	1678	28800894553000	28829	14220	0	0	\N
381291	1678	28800894554000	28829	14220	1	0	\N
381292	1874	8327000	28829	14220	2	0	\N
381293	1874	8329000	28829	14220	3	0	\N
381294	1874	8331000	28829	14220	4	0	\N
381295	1874	8335000	28829	14220	5	0	\N
381296	1874	8339000	28829	14220	6	0	\N
381297	1678	28800894553000	28830	14220	0	0	\N
381298	1678	28800894554000	28830	14220	1	0	\N
381299	1874	8327000	28830	14220	2	0	\N
381300	1874	8329000	28830	14220	3	0	\N
381301	1874	8331000	28830	14220	4	0	\N
381302	1874	8335000	28830	14220	5	0	\N
381303	1874	8339000	28830	14220	6	0	\N
381311	1678	28800894553000	28832	14220	0	0	\N
381312	1678	28800894554000	28832	14220	1	0	\N
381313	1874	8327000	28832	14220	2	0	\N
381314	1874	8329000	28832	14220	3	0	\N
381315	1874	8331000	28832	14220	4	0	\N
381316	1874	8335000	28832	14220	5	0	\N
381317	1874	8339000	28832	14220	6	0	\N
381331	1678	28800894559000	28836	14224	0	0	\N
381332	1874	8366000	28836	14224	1	0	\N
381333	1874	8368000	28836	14224	2	0	\N
381334	1678	28800894559000	28837	14224	0	0	\N
381335	1874	8366000	28837	14224	1	0	\N
381336	1874	8368000	28837	14224	2	0	\N
381340	1678	28800894559000	28839	14224	0	0	\N
381341	1874	8366000	28839	14224	1	0	\N
381342	1874	8368000	28839	14224	2	0	\N
381213	1874	8281000	28811	14211	2	0	3
381223	1678	28800894544000	28816	14212	0	0	1
381224	1874	8282000	28816	14212	1	0	3
381225	1874	8284000	28816	14212	2	0	3
381226	1678	28800894545000	28817	14213	0	0	1
381228	1874	8290000	28817	14213	2	0	3
381232	1678	28800894546000	28819	14214	0	0	1
381233	1874	8294000	28819	14214	1	0	3
381234	1874	8296000	28819	14214	2	0	3
381235	1678	28800894547000	28820	14215	0	0	1
381237	1678	28800894548000	28821	14216	0	0	1
381238	1874	8302000	28821	14216	1	0	3
381239	1874	8303000	28821	14216	2	0	3
381240	1678	28800894549000	28822	14217	0	0	1
381272	1678	28800894550000	28826	14218	0	0	1
381273	1678	28800894551000	28826	14218	1	0	1
381274	1874	8309000	28826	14218	2	0	3
381275	1874	8310000	28826	14218	3	0	3
381276	1874	8314000	28826	14218	4	0	3
381278	1874	8318000	28826	14218	6	0	3
381279	1874	8320000	28826	14218	7	0	3
381280	1678	28800894552000	28827	14219	0	0	1
381281	1874	8322000	28827	14219	1	0	3
381282	1874	8326000	28827	14219	2	0	3
381305	1678	28800894554000	28831	14220	1	0	1
381306	1874	8327000	28831	14220	2	0	3
381307	1874	8329000	28831	14220	3	0	3
381308	1874	8331000	28831	14220	4	0	3
381310	1874	8339000	28831	14220	6	0	3
381318	1874	8341000	28833	14221	0	0	3
381319	1678	28800894555000	28834	14222	0	0	1
381320	1678	28800894556000	28834	14222	1	0	1
381321	1874	8345000	28834	14222	2	0	3
381323	1874	8349000	28834	14222	4	0	3
381324	1874	8353000	28834	14222	5	0	3
381325	1678	28800894557000	28835	14223	0	0	1
381326	1678	28800894558000	28835	14223	1	0	1
381327	1874	8355000	28835	14223	2	0	3
381329	1874	8361000	28835	14223	4	0	3
381330	1874	8362000	28835	14223	5	0	3
381337	1678	28800894559000	28838	14224	0	0	1
381338	1874	8366000	28838	14224	1	0	3
381343	1678	28800894560000	28840	14225	0	0	1
381344	1678	28800894561000	28840	14225	1	0	1
381350	1678	28800894560000	28841	14225	0	0	\N
381351	1678	28800894561000	28841	14225	1	0	\N
381352	1874	8369000	28841	14225	2	0	\N
381353	1874	8371000	28841	14225	3	0	\N
381354	1874	8375000	28841	14225	4	0	\N
381355	1874	8377000	28841	14225	5	0	\N
381356	1874	8381000	28841	14225	6	0	\N
381357	1678	28800894560000	28842	14225	0	0	\N
381358	1678	28800894561000	28842	14225	1	0	\N
381359	1874	8369000	28842	14225	2	0	\N
381360	1874	8371000	28842	14225	3	0	\N
381361	1874	8375000	28842	14225	4	0	\N
381362	1874	8377000	28842	14225	5	0	\N
381363	1874	8381000	28842	14225	6	0	\N
381366	1678	28800894563000	28845	14227	0	0	\N
381367	1874	8384000	28845	14227	1	0	\N
381368	1874	8386000	28845	14227	2	0	\N
381369	1874	8390000	28845	14227	3	0	\N
381374	1678	28800894563000	28847	14227	0	0	\N
381375	1874	8384000	28847	14227	1	0	\N
381376	1874	8386000	28847	14227	2	0	\N
381377	1874	8390000	28847	14227	3	0	\N
381399	1678	28800894569000	28854	14231	0	0	\N
381400	1678	28800894570000	28854	14231	1	0	\N
381401	1874	8418000	28854	14231	2	0	\N
381402	1874	8420000	28854	14231	3	0	\N
381403	1874	8422000	28854	14231	4	0	\N
381404	1874	8426000	28854	14231	5	0	\N
381432	1678	28800894574000	28857	14233	0	0	\N
381433	1678	28800894575000	28857	14233	1	0	\N
381434	1678	28800894576000	28857	14233	2	0	\N
381435	1678	28800894577000	28857	14233	3	0	\N
381436	1678	28800894578000	28857	14233	4	0	\N
381437	1406	0	28857	14233	5	0	\N
381438	1406	0	28857	14233	6	0	\N
381439	1874	8443000	28857	14233	7	0	\N
381440	1874	8445000	28857	14233	8	0	\N
381441	1874	8447000	28857	14233	9	0	\N
381442	1874	8449000	28857	14233	10	0	\N
381443	1874	8451000	28857	14233	11	0	\N
381444	1874	8455000	28857	14233	12	0	\N
381445	1874	8459000	28857	14233	13	0	\N
381446	1874	8463000	28857	14233	14	0	\N
381447	1874	8467000	28857	14233	15	0	\N
381448	1874	8468000	28857	14233	16	0	\N
381449	1678	28800894574000	28858	14233	0	0	\N
381450	1678	28800894575000	28858	14233	1	0	\N
381451	1678	28800894576000	28858	14233	2	0	\N
381452	1678	28800894577000	28858	14233	3	0	\N
381453	1678	28800894578000	28858	14233	4	0	\N
381454	1406	0	28858	14233	5	0	\N
381455	1406	0	28858	14233	6	0	\N
381456	1874	8443000	28858	14233	7	0	\N
381457	1874	8445000	28858	14233	8	0	\N
381458	1874	8447000	28858	14233	9	0	\N
381459	1874	8449000	28858	14233	10	0	\N
381460	1874	8451000	28858	14233	11	0	\N
381461	1874	8455000	28858	14233	12	0	\N
381462	1874	8459000	28858	14233	13	0	\N
381463	1874	8463000	28858	14233	14	0	\N
381464	1874	8467000	28858	14233	15	0	\N
381465	1874	8468000	28858	14233	16	0	\N
381466	1678	28800894579000	28859	14234	0	0	\N
381467	1874	8470000	28859	14234	1	0	\N
381468	1874	8474000	28859	14234	2	0	\N
381472	1678	28800894579000	28861	14234	0	0	\N
381473	1874	8470000	28861	14234	1	0	\N
381474	1874	8474000	28861	14234	2	0	\N
381475	1678	28800894579000	28862	14234	0	0	\N
381476	1874	8470000	28862	14234	1	0	\N
381477	1874	8474000	28862	14234	2	0	\N
381347	1874	8375000	28840	14225	4	0	3
381348	1874	8377000	28840	14225	5	0	3
381349	1874	8381000	28840	14225	6	0	3
381364	1678	28800894562000	28843	14226	0	0	1
381365	1874	8383000	28843	14226	1	0	3
381371	1874	8384000	28846	14227	1	0	3
381372	1874	8386000	28846	14227	2	0	3
381373	1874	8390000	28846	14227	3	0	3
381378	1678	28800894564000	28850	14228	0	0	1
381379	1678	28800894565000	28850	14228	1	0	1
381381	1874	8394000	28850	14228	3	0	3
381382	1874	8398000	28850	14228	4	0	3
381383	1874	8402000	28850	14228	5	0	3
381384	1678	28800894566000	28851	14229	0	0	1
381386	1874	8403000	28851	14229	2	0	3
381387	1874	8407000	28851	14229	3	0	3
381388	1874	8409000	28851	14229	4	0	3
381389	1874	8411000	28851	14229	5	0	3
381390	1678	28800894568000	28852	14230	0	0	1
381392	1874	8417000	28852	14230	2	0	3
381393	1678	28800894569000	28853	14231	0	0	1
381394	1678	28800894570000	28853	14231	1	0	1
381395	1874	8418000	28853	14231	2	0	3
381396	1874	8420000	28853	14231	3	0	3
381398	1874	8426000	28853	14231	5	0	3
381405	1678	28800894571000	28855	14232	0	0	1
381406	1678	28800894572000	28855	14232	1	0	1
381407	1678	28800894573000	28855	14232	2	0	1
381409	1874	8430000	28855	14232	4	0	3
381410	1874	8434000	28855	14232	5	0	3
381411	1874	8436000	28855	14232	6	0	3
381412	1874	8437000	28855	14232	7	0	3
381413	1874	8441000	28855	14232	8	0	3
381415	1678	28800894574000	28856	14233	0	0	1
381416	1678	28800894575000	28856	14233	1	0	1
381417	1678	28800894576000	28856	14233	2	0	1
381418	1678	28800894577000	28856	14233	3	0	1
381419	1678	28800894578000	28856	14233	4	0	1
381421	1406	0	28856	14233	6	0	0
381422	1874	8443000	28856	14233	7	0	3
381423	1874	8445000	28856	14233	8	0	3
381424	1874	8447000	28856	14233	9	0	3
381426	1874	8451000	28856	14233	11	0	3
381427	1874	8455000	28856	14233	12	0	3
381428	1874	8459000	28856	14233	13	0	3
381429	1874	8463000	28856	14233	14	0	3
381430	1874	8467000	28856	14233	15	0	3
381469	1678	28800894579000	28860	14234	0	0	1
381470	1874	8470000	28860	14234	1	0	3
381471	1874	8474000	28860	14234	2	0	3
381478	1678	28800894580000	28863	14235	0	0	1
381479	1874	8476000	28863	14235	1	0	3
381484	1678	28800894581000	28865	14236	1	0	\N
381485	1874	8483000	28865	14236	2	0	\N
381499	1678	28800894585000	28870	14240	0	0	\N
381500	1874	8500000	28870	14240	1	0	\N
381501	1874	8504000	28870	14240	2	0	\N
381506	656	66543460726895	28872	14242	0	0	\N
381507	1678	28800894587000	28872	14242	1	0	\N
381508	1874	8514000	28872	14242	2	0	\N
381509	1874	8516000	28872	14242	3	0	\N
381510	1874	8517000	28872	14242	4	0	\N
381517	1678	28800894588000	28875	14244	0	0	\N
381518	1874	8523000	28875	14244	1	0	\N
381519	1874	8525000	28875	14244	2	0	\N
381520	1678	28800894588000	28876	14244	0	0	\N
381521	1874	8523000	28876	14244	1	0	\N
381522	1874	8525000	28876	14244	2	0	\N
381531	2411	543010000000	28879	14245	0	0	\N
381532	1678	28800894589000	28879	14245	1	0	\N
381533	1874	8529000	28879	14245	2	0	\N
381534	1874	8530000	28879	14245	3	0	\N
381535	1874	8532000	28879	14245	4	0	\N
381539	1678	28800894590000	28881	14246	0	0	\N
381540	1874	8536000	28881	14246	1	0	\N
381541	1874	8538000	28881	14246	2	0	\N
381542	1678	28800894590000	28882	14246	0	0	\N
381543	1874	8536000	28882	14246	1	0	\N
381544	1874	8538000	28882	14246	2	0	\N
381553	1678	28800894593000	28885	14249	0	0	\N
381554	1678	28800894594000	28885	14249	1	0	\N
381555	1874	8549000	28885	14249	2	0	\N
381556	1874	8553000	28885	14249	3	0	\N
381557	1874	8557000	28885	14249	4	0	\N
381558	1874	8559000	28885	14249	6	0	\N
381559	2413	900971464000000	28885	14249	7	0	\N
381573	1678	28800894597000	28890	14252	0	0	\N
381574	1678	28800894598000	28890	14252	1	0	\N
381575	1874	8572000	28890	14252	2	0	\N
381576	2414	100000000	28890	14252	3	0	\N
381577	1874	8574000	28890	14252	4	0	\N
381578	1874	8576000	28890	14252	5	0	\N
381579	1678	28800894597000	28891	14252	0	0	\N
381580	1678	28800894598000	28891	14252	1	0	\N
381581	1874	8572000	28891	14252	2	0	\N
381582	2414	100000000	28891	14252	3	0	\N
381583	1874	8574000	28891	14252	4	0	\N
381584	1874	8576000	28891	14252	5	0	\N
381591	1678	28800894599000	28893	14253	0	0	\N
381592	1874	8578000	28893	14253	1	0	\N
381593	1874	8582000	28893	14253	2	0	\N
381594	1874	8583000	28893	14253	3	0	\N
381595	1678	28800894599000	28894	14253	0	0	\N
381596	1874	8578000	28894	14253	1	0	\N
381597	1874	8582000	28894	14253	2	0	\N
381598	1874	8583000	28894	14253	3	0	\N
381602	1678	28800894599000	28896	14253	0	0	\N
381603	1874	8578000	28896	14253	1	0	\N
381604	1874	8582000	28896	14253	2	0	\N
381605	1874	8583000	28896	14253	3	0	\N
381610	1678	28800894600000	28898	14254	0	0	\N
381611	1874	8583000	28898	14254	1	0	\N
381612	1874	8587000	28898	14254	2	0	\N
381616	1678	28800894601000	28900	14255	0	0	\N
381483	1874	8483000	28864	14236	2	0	3
381486	1678	28800894582000	28866	14237	0	0	1
381487	1874	8485000	28866	14237	1	0	3
381488	1874	8489000	28866	14237	2	0	3
381489	1678	28800894583000	28867	14238	0	0	1
381491	1874	8493000	28867	14238	2	0	3
381492	1874	8495000	28867	14238	3	0	3
381493	1874	8496000	28867	14238	4	0	3
381494	1678	28800894584000	28868	14239	0	0	1
381495	1874	8498000	28868	14239	1	0	3
381497	1874	8500000	28869	14240	1	0	3
381498	1874	8504000	28869	14240	2	0	3
381502	1678	28800894586000	28871	14241	0	0	1
381503	2411	30000000	28871	14241	1	0	0
381505	1874	8510000	28871	14241	3	0	3
381511	656	66543460726895	28873	14242	0	0	3
381512	1678	28800894587000	28873	14242	1	0	1
381513	1874	8514000	28873	14242	2	0	3
381514	1874	8516000	28873	14242	3	0	3
381516	1874	8519000	28874	14243	0	0	3
381523	1678	28800894588000	28877	14244	0	0	1
381524	1874	8523000	28877	14244	1	0	3
381525	1874	8525000	28877	14244	2	0	3
381526	2411	543010000000	28878	14245	0	0	1
381528	1874	8529000	28878	14245	2	0	3
381529	1874	8530000	28878	14245	3	0	3
381530	1874	8532000	28878	14245	4	0	3
381536	1678	28800894590000	28880	14246	0	0	1
381538	1874	8538000	28880	14246	2	0	3
381545	1678	28800894591000	28883	14247	0	0	1
381546	2412	502774774000000	28883	14247	1	0	0
381547	1874	8540000	28883	14247	2	0	3
381548	1546	15357609800000	28884	14248	0	0	10
381550	1874	8542000	28884	14248	2	0	3
381551	1874	8546000	28884	14248	3	0	3
381552	1874	8547000	28884	14248	4	0	3
381560	1678	28800894593000	28886	14249	0	0	1
381561	1678	28800894594000	28886	14249	1	0	1
381563	1874	8553000	28886	14249	3	0	3
381564	1874	8557000	28886	14249	4	0	3
381565	1874	8559000	28886	14249	6	0	3
381566	2413	900971464000000	28886	14249	7	0	0
381568	1874	8561000	28887	14250	1	0	3
381569	1678	28800894596000	28888	14251	0	0	1
381570	1874	8562000	28888	14251	1	0	3
381571	1874	8564000	28888	14251	2	0	3
381572	1874	8568000	28888	14251	3	0	3
381586	1678	28800894598000	28892	14252	1	0	1
381587	1874	8572000	28892	14252	2	0	3
381588	2414	100000000	28892	14252	3	0	0
381589	1874	8574000	28892	14252	4	0	3
381590	1874	8576000	28892	14252	5	0	3
381600	1874	8580000	28895	14253	1	0	3
381601	1874	8581000	28895	14253	2	0	3
381606	1678	28800894600000	28897	14254	0	0	1
381607	1874	8583000	28897	14254	1	0	3
381609	1874	8589000	28897	14254	3	0	3
381613	1678	28800894601000	28899	14255	0	0	1
381614	1874	8593000	28899	14255	1	0	3
381615	1874	8595000	28899	14255	2	0	3
381617	1874	8593000	28900	14255	1	0	\N
381618	1546	15357609800000	28901	14245	0	0	\N
381619	2411	543000000000	28901	14245	1	0	\N
381620	1678	28800894589000	28901	14245	2	0	\N
381621	1678	28800894590000	28901	14245	3	0	\N
381622	1678	28800894591000	28901	14245	4	0	\N
381623	1678	28800894592000	28901	14245	5	0	\N
381624	1678	28800894593000	28901	14245	6	0	\N
381625	1678	28800894594000	28901	14245	7	0	\N
381626	1678	28800894595000	28901	14245	8	0	\N
381627	1678	28800894596000	28901	14245	9	0	\N
381628	1678	28800894597000	28901	14245	10	0	\N
381629	1678	28800894598000	28901	14245	11	0	\N
381630	1678	28800894599000	28901	14245	12	0	\N
381631	1678	28800894600000	28901	14245	13	0	\N
381632	1678	28800894601000	28901	14245	14	0	\N
381633	1678	28800894602000	28901	14245	15	0	\N
381634	1678	28800894603000	28901	14245	16	0	\N
381635	2412	502774774000000	28901	14245	17	0	\N
381636	1874	8529000	28901	14245	18	0	\N
381637	1874	8533000	28901	14245	19	0	\N
381638	1874	8534000	28901	14245	20	0	\N
381639	1874	8536000	28901	14245	21	0	\N
381640	2414	100000000	28901	14245	22	0	\N
381641	1874	8540000	28901	14245	23	0	\N
381642	1874	8544000	28901	14245	24	0	\N
381643	1874	8548000	28901	14245	25	0	\N
381644	1874	8552000	28901	14245	26	0	\N
381645	1874	8556000	28901	14245	27	0	\N
381646	1874	8560000	28901	14245	28	0	\N
381647	1874	8564000	28901	14245	30	0	\N
381648	1874	8568000	28901	14245	31	0	\N
381649	1874	8572000	28901	14245	32	0	\N
381650	1874	8573000	28901	14245	33	0	\N
381651	1874	8574000	28901	14245	34	0	\N
381652	1874	8575000	28901	14245	35	0	\N
381653	1874	8576000	28901	14245	36	0	\N
381654	1874	8578000	28901	14245	37	0	\N
381655	2413	900971464000000	28901	14245	38	0	\N
381656	1874	8580000	28901	14245	39	0	\N
381657	1874	8582000	28901	14245	40	0	\N
381658	1874	8584000	28901	14245	41	0	\N
381659	1874	8586000	28901	14245	42	0	\N
381660	1874	8588000	28901	14245	43	0	\N
381661	1874	8590000	28901	14245	44	0	\N
381662	1874	8592000	28901	14245	45	0	\N
381663	1874	8594000	28901	14245	46	0	\N
381664	1874	8596000	28901	14245	47	0	\N
381665	1874	8598000	28901	14245	48	0	\N
381666	1874	8600000	28901	14245	49	0	\N
381667	1874	8602000	28901	14245	50	0	\N
381668	1874	8604000	28901	14245	51	0	\N
381669	1678	28800894602000	28902	14256	0	0	\N
381670	1678	28800894603000	28902	14256	1	0	\N
381671	1678	28800894604000	28902	14256	2	0	\N
381672	1874	8599000	28902	14256	3	0	\N
381673	1874	8603000	28902	14256	4	0	\N
381674	1874	8604000	28902	14256	5	0	\N
381675	1874	8606000	28902	14256	6	0	\N
381676	1874	8608000	28902	14256	7	0	\N
381677	1874	8610000	28902	14256	8	0	\N
381678	1678	28800894602000	28903	14256	0	0	\N
381679	1678	28800894603000	28903	14256	1	0	\N
381680	1678	28800894604000	28903	14256	2	0	\N
381681	1874	8599000	28903	14256	3	0	\N
381682	1874	8603000	28903	14256	4	0	\N
381683	1874	8604000	28903	14256	5	0	\N
381684	1874	8606000	28903	14256	6	0	\N
381685	1874	8608000	28903	14256	7	0	\N
381686	1874	8610000	28903	14256	8	0	\N
381693	656	66543460726895	28905	14242	0	0	\N
381694	1546	15357609800000	28905	14242	1	0	\N
381695	2411	543000000000	28905	14242	2	0	\N
381696	1678	28800894587000	28905	14242	3	0	\N
381697	1678	28800894588000	28905	14242	4	0	\N
381698	1678	28800894589000	28905	14242	5	0	\N
381699	1678	28800894590000	28905	14242	6	0	\N
381700	1678	28800894591000	28905	14242	7	0	\N
381701	1678	28800894592000	28905	14242	8	0	\N
381702	1678	28800894593000	28905	14242	9	0	\N
381703	1678	28800894594000	28905	14242	10	0	\N
381704	1678	28800894595000	28905	14242	11	0	\N
381705	1678	28800894596000	28905	14242	12	0	\N
381706	1678	28800894597000	28905	14242	13	0	\N
381707	1678	28800894598000	28905	14242	14	0	\N
381708	1678	28800894599000	28905	14242	15	0	\N
381709	1678	28800894600000	28905	14242	16	0	\N
381710	1678	28800894601000	28905	14242	17	0	\N
381711	1678	28800894602000	28905	14242	18	0	\N
381712	1678	28800894603000	28905	14242	19	0	\N
381713	1678	28800894604000	28905	14242	20	0	\N
381714	1874	8514000	28905	14242	21	0	\N
381715	2412	502774774000000	28905	14242	22	0	\N
381716	1874	8518000	28905	14242	23	0	\N
381717	1874	8522000	28905	14242	24	0	\N
381718	1874	8526000	28905	14242	25	0	\N
381719	2414	100000000	28905	14242	26	0	\N
381720	1874	8528000	28905	14242	27	0	\N
381721	1874	8530000	28905	14242	28	0	\N
381722	1874	8532000	28905	14242	29	0	\N
381723	1874	8534000	28905	14242	30	0	\N
381724	1874	8538000	28905	14242	31	0	\N
381725	1874	8542000	28905	14242	32	0	\N
381726	1874	8546000	28905	14242	33	0	\N
381727	1874	8550000	28905	14242	34	0	\N
381728	1874	8554000	28905	14242	35	0	\N
381729	1874	8558000	28905	14242	36	0	\N
381730	1874	8562000	28905	14242	37	0	\N
381731	1874	8566000	28905	14242	38	0	\N
381732	1874	8570000	28905	14242	39	0	\N
381733	1874	8574000	28905	14242	40	0	\N
381734	1874	8576000	28905	14242	41	0	\N
381735	1874	8577000	28905	14242	42	0	\N
381736	1874	8578000	28905	14242	43	0	\N
381737	1874	8579000	28905	14242	45	0	\N
381738	1874	8580000	28905	14242	46	0	\N
381739	1874	8581000	28905	14242	47	0	\N
381740	1874	8582000	28905	14242	48	0	\N
381741	2413	900971464000000	28905	14242	49	0	\N
381742	1874	8584000	28905	14242	50	0	\N
381743	1874	8586000	28905	14242	51	0	\N
381744	1874	8588000	28905	14242	52	0	\N
381745	1874	8590000	28905	14242	53	0	\N
381746	1874	8592000	28905	14242	54	0	\N
381747	1874	8594000	28905	14242	55	0	\N
381748	1874	8596000	28905	14242	56	0	\N
381749	1874	8598000	28905	14242	57	0	\N
381750	1874	8600000	28905	14242	58	0	\N
381751	1874	8602000	28905	14242	59	0	\N
381752	1874	8604000	28905	14242	60	0	\N
381689	1678	28800894604000	28904	14256	2	0	1
381690	1874	8599000	28904	14256	3	0	3
381691	1874	8603000	28904	14256	4	0	3
381692	1874	8604000	28904	14256	5	0	3
381753	1874	8606000	28905	14242	61	0	\N
381754	1874	8608000	28905	14242	62	0	\N
381755	1874	8610000	28905	14242	63	0	\N
381765	1678	28800894606000	28908	14259	0	0	\N
381766	1874	8621000	28908	14259	1	0	\N
381767	1874	8625000	28908	14259	2	0	\N
381768	1678	28800894606000	28909	14259	0	0	\N
381769	1874	8621000	28909	14259	1	0	\N
381770	1874	8625000	28909	14259	2	0	\N
381780	1874	8642000	28913	14262	0	0	\N
381781	1874	8646000	28913	14262	1	0	\N
381782	1874	8644000	28914	14262	0	0	\N
381783	1874	8642000	28915	14262	0	0	\N
381784	1874	8646000	28915	14262	1	0	\N
381787	1874	8642000	28917	14262	0	0	\N
381788	1874	8646000	28917	14262	1	0	\N
381789	1874	8642000	28918	14262	0	0	\N
381790	1874	8646000	28918	14262	1	0	\N
381799	1678	28800894607000	28922	14264	0	0	\N
381800	1678	28800894608000	28922	14264	1	0	\N
381801	1874	8657000	28922	14264	2	0	\N
381802	1874	8659000	28922	14264	3	0	\N
381803	1874	8661000	28922	14264	4	0	\N
381804	1678	28800894607000	28923	14264	0	0	\N
381805	1678	28800894608000	28923	14264	1	0	\N
381806	1874	8657000	28923	14264	2	0	\N
381807	1874	8659000	28923	14264	3	0	\N
381808	1874	8661000	28923	14264	4	0	\N
381809	1678	28800894609000	28924	14265	0	0	\N
381810	1678	28800894610000	28924	14265	1	0	\N
381811	1874	8663000	28924	14265	2	0	\N
381812	1874	8665000	28924	14265	3	0	\N
381813	1874	8669000	28924	14265	4	0	\N
381814	1874	8673000	28924	14265	5	0	\N
381815	1874	8674000	28924	14265	6	0	\N
381823	1678	28800894609000	28926	14265	0	0	\N
381824	1678	28800894610000	28926	14265	1	0	\N
381825	1874	8663000	28926	14265	2	0	\N
381826	1874	8665000	28926	14265	3	0	\N
381827	1874	8669000	28926	14265	4	0	\N
381828	1874	8673000	28926	14265	5	0	\N
381829	1874	8674000	28926	14265	6	0	\N
381830	1678	28800894611000	28927	14266	0	0	\N
381831	2416	100000000	28927	14266	1	0	\N
381832	1874	8676000	28927	14266	2	0	\N
381833	1874	8680000	28927	14266	3	0	\N
381847	1678	28800894613000	28931	14268	0	0	\N
381848	1678	28800894614000	28931	14268	1	0	\N
381849	1874	8683000	28931	14268	2	0	\N
381850	1874	8687000	28931	14268	3	0	\N
381851	1874	8691000	28931	14268	4	0	\N
381852	1874	8693000	28931	14268	5	0	\N
381853	1874	8695000	28931	14268	6	0	\N
381854	1678	28800894615000	28932	14269	0	0	\N
381855	1874	8699000	28932	14269	1	0	\N
381856	1874	8701000	28932	14269	2	0	\N
381857	1678	28800894615000	28933	14269	0	0	\N
381858	1874	8699000	28933	14269	1	0	\N
381859	1874	8701000	28933	14269	2	0	\N
381869	1678	28800894618000	28937	14272	0	0	\N
381870	1874	8714000	28937	14272	1	0	\N
381871	1874	8716000	28937	14272	2	0	\N
381875	1678	28800894618000	28939	14272	0	0	\N
381876	1874	8714000	28939	14272	1	0	\N
381877	1874	8716000	28939	14272	2	0	\N
381881	1678	28800894619000	28941	14273	0	0	\N
381882	1874	8720000	28941	14273	1	0	\N
381883	1678	28800894619000	28942	14273	0	0	\N
381884	1874	8720000	28942	14273	1	0	\N
381885	1678	28800894619000	28943	14273	0	0	\N
381886	1874	8718000	28943	14273	1	0	\N
381887	1874	8722000	28943	14273	2	0	\N
381758	1874	8610000	28906	14257	2	0	3
381759	1874	8612000	28906	14257	3	0	3
381760	1874	8614000	28906	14257	4	0	3
381761	1874	8616000	28906	14257	5	0	3
381762	1678	28800894605000	28907	14258	0	0	1
381764	1874	8619000	28907	14258	2	0	3
381771	1678	28800894606000	28910	14259	0	0	1
381772	1874	8621000	28910	14259	1	0	3
381773	1874	8625000	28910	14259	2	0	3
381774	1874	8627000	28911	14260	0	0	3
381776	1874	8630000	28911	14260	2	0	3
381777	1874	8634000	28911	14260	3	0	3
381778	1874	8638000	28911	14260	4	0	3
381779	1874	8640000	28912	14261	0	0	3
381786	1874	8646000	28916	14262	1	0	3
381791	1874	8648000	28920	14263	0	0	3
381792	1874	8649000	28920	14263	1	0	3
381793	1874	8653000	28920	14263	2	0	3
381794	1678	28800894607000	28921	14264	0	0	1
381796	1874	8657000	28921	14264	2	0	3
381797	1874	8659000	28921	14264	3	0	3
381798	1874	8661000	28921	14264	4	0	3
381816	1678	28800894609000	28925	14265	0	0	1
381817	1678	28800894610000	28925	14265	1	0	1
381819	1874	8665000	28925	14265	3	0	3
381820	1874	8669000	28925	14265	4	0	3
381821	1874	8673000	28925	14265	5	0	3
381822	1874	8674000	28925	14265	6	0	3
381835	2416	100000000	28928	14266	1	0	0
381836	1874	8676000	28928	14266	2	0	3
381837	1874	8680000	28928	14266	3	0	3
381838	1678	28800894612000	28929	14267	0	0	1
381839	1874	8682000	28929	14267	1	0	3
381841	1678	28800894614000	28930	14268	1	0	1
381842	1874	8683000	28930	14268	2	0	3
381843	1874	8687000	28930	14268	3	0	3
381844	1874	8691000	28930	14268	4	0	3
381845	1874	8693000	28930	14268	5	0	3
381860	1678	28800894615000	28934	14269	0	0	1
381861	1874	8697000	28934	14269	1	0	3
381862	1678	28800894616000	28935	14270	0	0	1
381863	1874	8701000	28935	14270	1	0	3
381865	1874	8704000	28935	14270	3	0	3
381866	1678	28800894617000	28936	14271	0	0	1
381867	1874	8706000	28936	14271	1	0	3
381868	1874	8710000	28936	14271	2	0	3
381872	1678	28800894618000	28938	14272	0	0	1
381874	1874	8716000	28938	14272	2	0	3
381878	1678	28800894619000	28940	14273	0	0	1
381879	1874	8718000	28940	14273	1	0	3
381880	1874	8722000	28940	14273	2	0	3
381888	1678	28800894620000	28944	14274	0	0	1
381891	1678	28800894620000	28945	14274	0	0	\N
381892	1874	8724000	28945	14274	1	0	\N
381893	1874	8725000	28945	14274	2	0	\N
381904	1678	28800894621000	28947	14275	0	0	\N
381905	1678	28800894622000	28947	14275	1	0	\N
381906	1678	28800894623000	28947	14275	2	0	\N
381907	1874	8726000	28947	14275	3	0	\N
381908	1874	8728000	28947	14275	4	0	\N
381909	1874	8730000	28947	14275	5	0	\N
381910	1874	8732000	28947	14275	6	0	\N
381911	1874	8736000	28947	14275	7	0	\N
381912	1874	8740000	28947	14275	8	0	\N
381913	1874	8744000	28947	14275	9	0	\N
381914	1678	28800894624000	28949	14276	0	0	\N
381915	1874	8746000	28949	14276	1	0	\N
381931	1678	28800894629000	28955	14281	0	0	\N
381932	1874	8769000	28955	14281	1	0	\N
381933	1874	8773000	28955	14281	2	0	\N
381944	1678	28800894630000	28958	14282	0	0	\N
381945	1678	28800894631000	28958	14282	1	0	\N
381946	1874	8777000	28958	14282	2	0	\N
381947	1874	8778000	28958	14282	3	0	\N
381948	1874	8780000	28958	14282	4	0	\N
381949	1874	8782000	28958	14282	5	0	\N
381950	2417	100000000	28958	14282	6	0	\N
381951	1678	28800894630000	28959	14282	0	0	\N
381952	1678	28800894631000	28959	14282	1	0	\N
381953	1874	8777000	28959	14282	2	0	\N
381954	1874	8778000	28959	14282	3	0	\N
381955	1874	8780000	28959	14282	4	0	\N
381956	1874	8782000	28959	14282	5	0	\N
381957	2417	100000000	28959	14282	6	0	\N
381961	1678	28800894632000	28961	14283	0	0	\N
381962	1874	8786000	28961	14283	1	0	\N
381963	1874	8788000	28961	14283	2	0	\N
381964	1678	28800894632000	28962	14283	0	0	\N
381965	1874	8786000	28962	14283	1	0	\N
381966	1874	8788000	28962	14283	2	0	\N
381971	1874	8799000	28964	14285	0	0	\N
381972	1678	28800894634000	28965	14285	0	0	\N
381973	1678	28800894635000	28965	14285	1	0	\N
381974	1874	8797000	28965	14285	2	0	\N
381975	1874	8801000	28965	14285	3	0	\N
381976	1874	8803000	28965	14285	4	0	\N
381977	1678	28800894634000	28966	14285	0	0	\N
381978	1678	28800894635000	28966	14285	1	0	\N
381979	1874	8797000	28966	14285	2	0	\N
381980	1874	8801000	28966	14285	3	0	\N
381981	1874	8803000	28966	14285	4	0	\N
381990	1678	28800894636000	28969	14286	0	0	\N
381991	1874	8805000	28969	14286	1	0	\N
381992	1874	8806000	28969	14286	2	0	\N
381993	1874	8810000	28969	14286	3	0	\N
381994	1678	28800894637000	28970	14287	0	0	\N
381995	1874	8811000	28970	14287	1	0	\N
381996	1874	8815000	28970	14287	2	0	\N
381997	1874	8816000	28970	14287	3	0	\N
381998	1678	28800894637000	28971	14287	0	0	\N
381999	1874	8812000	28971	14287	1	0	\N
382000	1874	8816000	28971	14287	2	0	\N
382005	1678	28800894637000	28973	14287	0	0	\N
382006	1874	8811000	28973	14287	1	0	\N
382007	1874	8815000	28973	14287	2	0	\N
382008	1874	8816000	28973	14287	3	0	\N
382018	1678	28800894639000	28976	14289	0	0	\N
382019	1678	28800894640000	28976	14289	1	0	\N
382020	1874	8824000	28976	14289	2	0	\N
382021	1874	8826000	28976	14289	3	0	\N
382022	1874	8827000	28976	14289	4	0	\N
382023	1874	8831000	28976	14289	5	0	\N
382024	1678	28800894641000	28977	14290	0	0	\N
381894	1678	28800894621000	28946	14275	0	0	1
381895	1678	28800894622000	28946	14275	1	0	1
381896	1678	28800894623000	28946	14275	2	0	1
381897	1874	8726000	28946	14275	3	0	3
381898	1874	8728000	28946	14275	4	0	3
381900	1874	8732000	28946	14275	6	0	3
381901	1874	8736000	28946	14275	7	0	3
381902	1874	8740000	28946	14275	8	0	3
381903	1874	8744000	28946	14275	9	0	3
381916	1678	28800894624000	28950	14276	0	0	1
381918	1600	0	28951	14277	1	0	0
381919	1874	8748000	28951	14277	2	0	3
381920	1874	8750000	28951	14277	3	0	3
381921	1874	8752000	28951	14277	4	0	3
381923	1874	8756000	28952	14278	1	0	3
381924	1874	8758000	28952	14278	2	0	3
381925	1874	8759000	28952	14278	3	0	3
381926	1678	28800894627000	28953	14279	0	0	1
381927	1874	8761000	28953	14279	1	0	3
381929	1874	8763000	28954	14280	1	0	3
381930	1874	8767000	28954	14280	2	0	3
381934	1678	28800894629000	28956	14281	0	0	1
381935	1874	8769000	28956	14281	1	0	3
381936	1874	8773000	28956	14281	2	0	3
381938	1678	28800894631000	28957	14282	1	0	1
381939	1874	8777000	28957	14282	2	0	3
381940	1874	8778000	28957	14282	3	0	3
381941	1874	8780000	28957	14282	4	0	3
381943	2417	100000000	28957	14282	6	0	0
381958	1678	28800894632000	28960	14283	0	0	1
381959	1874	8786000	28960	14283	1	0	3
381960	1874	8788000	28960	14283	2	0	3
381967	1678	28800894633000	28963	14284	0	0	1
381969	1874	8793000	28963	14284	2	0	3
381970	1874	8795000	28963	14284	3	0	3
381982	1678	28800894634000	28967	14285	0	0	1
381983	1678	28800894635000	28967	14285	1	0	1
381984	1874	8797000	28967	14285	2	0	3
381986	1874	8803000	28967	14285	4	0	3
381987	1678	28800894636000	28968	14286	0	0	1
381988	1874	8805000	28968	14286	1	0	3
381989	1874	8809000	28968	14286	2	0	3
382002	1874	8811000	28972	14287	1	0	3
382003	1874	8815000	28972	14287	2	0	3
382004	1874	8816000	28972	14287	3	0	3
382009	1678	28800894638000	28974	14288	0	0	1
382010	1874	8820000	28974	14288	1	0	3
382012	1678	28800894639000	28975	14289	0	0	1
382013	1678	28800894640000	28975	14289	1	0	1
382014	1874	8824000	28975	14289	2	0	3
382015	1874	8826000	28975	14289	3	0	3
382016	1874	8827000	28975	14289	4	0	3
382025	1874	8835000	28977	14290	1	0	\N
382026	1874	8837000	28977	14290	2	0	\N
382027	1678	28800894641000	28978	14290	0	0	\N
382028	1874	8835000	28978	14290	1	0	\N
382029	1874	8837000	28978	14290	2	0	\N
382036	1678	28800894642000	28981	14291	0	0	\N
382037	1874	8839000	28981	14291	1	0	\N
382038	1874	8843000	28981	14291	2	0	\N
382046	1678	28800894643000	28983	14292	1	0	\N
382047	1678	28800894644000	28983	14292	2	0	\N
382048	296	66002000000000	28983	14292	3	0	\N
382049	1874	8844000	28983	14292	5	0	\N
382050	1874	8846000	28983	14292	6	0	\N
382051	1874	8848000	28983	14292	7	0	\N
382052	1874	8852000	28983	14292	8	0	\N
382053	1678	28800894605000	28984	14243	1	0	\N
382054	1678	28800894606000	28984	14243	2	0	\N
382055	1678	28800894607000	28984	14243	3	0	\N
382056	1678	28800894608000	28984	14243	4	0	\N
382057	1678	28800894609000	28984	14243	5	0	\N
382058	1678	28800894610000	28984	14243	6	0	\N
382059	1678	28800894611000	28984	14243	7	0	\N
382060	1678	28800894612000	28984	14243	8	0	\N
382061	1678	28800894613000	28984	14243	9	0	\N
382062	1678	28800894614000	28984	14243	10	0	\N
382063	1678	28800894615000	28984	14243	11	0	\N
382064	1678	28800894616000	28984	14243	12	0	\N
382065	1678	28800894617000	28984	14243	13	0	\N
382066	1678	28800894618000	28984	14243	14	0	\N
382067	1678	28800894619000	28984	14243	15	0	\N
382068	1678	28800894620000	28984	14243	16	0	\N
382069	1678	28800894621000	28984	14243	17	0	\N
382070	1678	28800894622000	28984	14243	18	0	\N
382071	1678	28800894623000	28984	14243	19	0	\N
382072	1678	28800894624000	28984	14243	20	0	\N
382073	1678	28800894625000	28984	14243	21	0	\N
382074	1678	28800894626000	28984	14243	22	0	\N
382075	1678	28800894627000	28984	14243	23	0	\N
382076	1678	28800894628000	28984	14243	24	0	\N
382077	1678	28800894629000	28984	14243	25	0	\N
382078	1678	28800894630000	28984	14243	26	0	\N
382079	1678	28800894631000	28984	14243	27	0	\N
382080	1678	28800894632000	28984	14243	28	0	\N
382081	1678	28800894633000	28984	14243	29	0	\N
382082	1678	28800894634000	28984	14243	30	0	\N
382083	1678	28800894635000	28984	14243	31	0	\N
382084	1678	28800894636000	28984	14243	32	0	\N
382085	1678	28800894637000	28984	14243	33	0	\N
382086	1678	28800894638000	28984	14243	34	0	\N
382087	1678	28800894639000	28984	14243	35	0	\N
382088	1678	28800894640000	28984	14243	36	0	\N
382089	1678	28800894641000	28984	14243	37	0	\N
382090	1678	28800894642000	28984	14243	38	0	\N
382091	1678	28800894643000	28984	14243	39	0	\N
382092	1678	28800894644000	28984	14243	40	0	\N
382093	1678	28800894645000	28984	14243	41	0	\N
382094	296	66002000000000	28984	14243	42	0	\N
382095	1874	8612000	28984	14243	43	0	\N
382096	1874	8614000	28984	14243	44	0	\N
382097	1874	8616000	28984	14243	45	0	\N
382098	1874	8618000	28984	14243	46	0	\N
382099	1874	8620000	28984	14243	47	0	\N
382100	1874	8621000	28984	14243	48	0	\N
382101	1874	8622000	28984	14243	49	0	\N
382102	1874	8623000	28984	14243	50	0	\N
382103	2415	100000000	28984	14243	51	0	\N
382104	2416	100000000	28984	14243	52	0	\N
382105	1874	8625000	28984	14243	53	0	\N
382106	1874	8627000	28984	14243	54	0	\N
382107	1874	8629000	28984	14243	55	0	\N
382108	1874	8631000	28984	14243	56	0	\N
382109	1874	8633000	28984	14243	57	0	\N
382110	1874	8635000	28984	14243	58	0	\N
382111	1874	8637000	28984	14243	59	0	\N
382112	1678	28800894645000	28985	14293	0	0	\N
382113	1874	8856000	28985	14293	1	0	\N
382114	1874	8858000	28985	14293	2	0	\N
382118	1678	28800894645000	28987	14293	0	0	\N
382119	1874	8856000	28987	14293	1	0	\N
382120	1874	8858000	28987	14293	2	0	\N
382121	296	66002000000000	28988	14265	1	0	\N
382122	296	66002000000000	28989	14248	1	0	\N
382123	296	66002000000000	28990	14282	1	0	\N
382124	1678	28800894646000	28991	14294	0	0	\N
382125	1874	8860000	28991	14294	1	0	\N
382126	1874	8861000	28991	14294	2	0	\N
382130	1678	28800894646000	28993	14294	0	0	\N
382131	1874	8860000	28993	14294	1	0	\N
382132	1874	8861000	28993	14294	2	0	\N
382136	1678	28800894647000	28995	14295	0	0	\N
382137	1874	8863000	28995	14295	1	0	\N
382138	1874	8867000	28995	14295	2	0	\N
382142	1678	28800894648000	28997	14296	0	0	\N
382143	1874	8871000	28997	14296	1	0	\N
382144	1874	8873000	28997	14296	2	0	\N
382151	1678	28800894650000	29000	14298	0	0	\N
382152	1874	8880000	29000	14298	1	0	\N
382153	1874	8882000	29000	14298	2	0	\N
382032	1874	8837000	28979	14290	2	0	3
382033	1678	28800894642000	28980	14291	0	0	1
382034	1874	8839000	28980	14291	1	0	3
382035	1874	8843000	28980	14291	2	0	3
382039	1678	28800894643000	28982	14292	1	0	1
382041	296	66002000000000	28982	14292	3	0	0
382042	1874	8844000	28982	14292	5	0	3
382043	1874	8846000	28982	14292	6	0	3
382044	1874	8848000	28982	14292	7	0	3
382045	1874	8852000	28982	14292	8	0	3
382116	1874	8856000	28986	14293	1	0	3
382117	1874	8858000	28986	14293	2	0	3
382127	1678	28800894646000	28992	14294	0	0	1
382128	1874	8860000	28992	14294	1	0	3
382133	1678	28800894647000	28994	14295	0	0	1
382134	1874	8863000	28994	14295	1	0	3
382135	1874	8867000	28994	14295	2	0	3
382139	1678	28800894648000	28996	14296	0	0	1
382140	1874	8871000	28996	14296	1	0	3
382145	1678	28800894649000	28998	14297	0	0	1
382146	1874	8875000	28998	14297	1	0	3
382147	1874	8879000	28998	14297	2	0	3
382148	1678	28800894650000	28999	14298	0	0	1
382149	1874	8880000	28999	14298	1	0	3
382154	1678	28800894651000	29001	14299	0	0	1
382155	1678	28800894652000	29001	14299	1	0	1
382156	1874	8884000	29001	14299	2	0	3
382157	1874	8888000	29001	14299	3	0	3
382159	1874	8894000	29001	14299	5	0	3
382160	1678	28800894653000	29002	14300	0	0	1
382173	1678	28800894655000	29005	14302	0	0	\N
382174	1678	28800894656000	29005	14302	1	0	\N
382175	1874	8905000	29005	14302	2	0	\N
382176	1874	8909000	29005	14302	3	0	\N
382177	1874	8911000	29005	14302	4	0	\N
382178	1874	8915000	29005	14302	5	0	\N
382179	1874	8916000	29005	14302	6	0	\N
382188	1678	28800894658000	29008	14304	0	0	\N
382189	1678	28800894659000	29008	14304	1	0	\N
382190	1874	8926000	29008	14304	2	0	\N
382191	1874	8928000	29008	14304	3	0	\N
382192	1874	8930000	29008	14304	4	0	\N
382193	1678	28800894660000	29009	14305	0	0	\N
382194	1874	8931000	29009	14305	1	0	\N
382195	1874	8933000	29009	14305	2	0	\N
382196	1874	8937000	29009	14305	3	0	\N
382201	1678	28800894660000	29011	14305	0	0	\N
382202	1874	8931000	29011	14305	1	0	\N
382203	1874	8933000	29011	14305	2	0	\N
382204	1874	8937000	29011	14305	3	0	\N
382208	1678	28800894661000	29013	14306	0	0	\N
382209	1874	8941000	29013	14306	1	0	\N
382210	1874	8943000	29013	14306	2	0	\N
382211	1678	28800894662000	29014	14307	0	0	\N
382212	1678	28800894663000	29014	14307	1	0	\N
382213	1874	8944000	29014	14307	2	0	\N
382214	1874	8948000	29014	14307	3	0	\N
382215	1874	8950000	29014	14307	4	0	\N
382216	1874	8952000	29014	14307	5	0	\N
382241	1678	28800894669000	29021	14312	0	0	\N
382242	1874	8981000	29021	14312	1	0	\N
382243	1678	28800894670000	29022	14313	0	0	\N
382244	1874	8983000	29022	14313	1	0	\N
382245	1874	8987000	29022	14313	2	0	\N
382246	1874	8988000	29022	14313	3	0	\N
382251	1678	28800894671000	29024	14314	0	0	\N
382252	1678	28800894672000	29024	14314	1	0	\N
382253	1874	8990000	29024	14314	2	0	\N
382254	1874	8994000	29024	14314	3	0	\N
382255	1874	8996000	29024	14314	4	0	\N
382256	1678	28800894671000	29025	14314	0	0	\N
382257	1678	28800894672000	29025	14314	1	0	\N
382258	1874	8990000	29025	14314	2	0	\N
382259	1874	8994000	29025	14314	3	0	\N
382260	1874	8996000	29025	14314	4	0	\N
382261	1678	28800894671000	29026	14314	0	0	\N
382262	1678	28800894672000	29026	14314	1	0	\N
382263	1874	8990000	29026	14314	2	0	\N
382264	1874	8994000	29026	14314	3	0	\N
382265	1874	8996000	29026	14314	4	0	\N
382278	1678	28800894675000	29029	14316	0	0	\N
382279	1678	28800894676000	29029	14316	1	0	\N
382280	1874	9009000	29029	14316	2	0	\N
382281	1874	9013000	29029	14316	3	0	\N
382282	1874	9014000	29029	14316	4	0	\N
382283	1874	9016000	29029	14316	5	0	\N
382293	1678	28800894677000	29032	14317	0	0	\N
382294	1874	9020000	29032	14317	1	0	\N
382295	1874	9022000	29032	14317	2	0	\N
382296	1678	28800894677000	29033	14317	0	0	\N
382163	1874	8901000	29002	14300	3	0	3
382164	1678	28800894654000	29003	14301	0	0	1
382165	1874	8903000	29003	14301	1	0	3
382166	1678	28800894655000	29004	14302	0	0	1
382167	1678	28800894656000	29004	14302	1	0	1
382169	1874	8909000	29004	14302	3	0	3
382170	1874	8911000	29004	14302	4	0	3
382171	1874	8915000	29004	14302	5	0	3
382172	1874	8916000	29004	14302	6	0	3
382180	1678	28800894657000	29006	14303	0	0	1
382182	1874	8922000	29006	14303	2	0	3
382183	1678	28800894658000	29007	14304	0	0	1
382184	1678	28800894659000	29007	14304	1	0	1
382185	1874	8926000	29007	14304	2	0	3
382187	1874	8930000	29007	14304	4	0	3
382197	1678	28800894660000	29010	14305	0	0	1
382198	1874	8931000	29010	14305	1	0	3
382199	1874	8933000	29010	14305	2	0	3
382200	1874	8937000	29010	14305	3	0	3
382206	1874	8941000	29012	14306	1	0	3
382207	1874	8943000	29012	14306	2	0	3
382217	1678	28800894662000	29015	14307	0	0	1
382218	1678	28800894663000	29015	14307	1	0	1
382219	1874	8944000	29015	14307	2	0	3
382221	1874	8950000	29015	14307	4	0	3
382222	1874	8952000	29015	14307	5	0	3
382223	1678	28800894664000	29016	14308	0	0	1
382224	1874	8956000	29016	14308	1	0	3
382226	1540	0	29017	14309	0	0	6
382227	1678	28800894665000	29017	14309	1	0	1
382228	1678	28800894666000	29017	14309	2	0	1
382229	1874	8960000	29017	14309	3	0	3
382230	1874	8961000	29017	14309	4	0	3
382232	1874	8967000	29017	14309	6	0	3
382233	1678	28800894667000	29018	14310	0	0	1
382234	1874	8969000	29018	14310	1	0	3
382235	1874	8973000	29018	14310	2	0	3
382236	1678	28800894668000	29019	14311	0	0	1
382238	1874	8979000	29019	14311	2	0	3
382239	1678	28800894669000	29020	14312	0	0	1
382240	1874	8981000	29020	14312	1	0	3
382247	1678	28800894670000	29023	14313	0	0	1
382249	1874	8987000	29023	14313	2	0	3
382250	1874	8988000	29023	14313	3	0	3
382266	1678	28800894671000	29027	14314	0	0	1
382267	1678	28800894672000	29027	14314	1	0	1
382268	1874	8990000	29027	14314	2	0	3
382270	1874	8996000	29027	14314	4	0	3
382271	1726	121926112000	29028	14315	0	0	8359
382272	1678	28800894673000	29028	14315	1	0	1
382273	1678	28800894674000	29028	14315	2	0	1
382274	1874	9000000	29028	14315	3	0	3
382276	1874	9006000	29028	14315	5	0	3
382277	1874	9007000	29028	14315	6	0	3
382284	1678	28800894675000	29030	14316	0	0	1
382285	1678	28800894676000	29030	14316	1	0	1
382287	1874	9013000	29030	14316	3	0	3
382288	1874	9014000	29030	14316	4	0	3
382289	1874	9016000	29030	14316	5	0	3
382290	1678	28800894677000	29031	14317	0	0	1
382291	1874	9020000	29031	14317	1	0	3
382297	1874	9020000	29033	14317	1	0	\N
382298	1874	9022000	29033	14317	2	0	\N
382299	1678	28800894678000	29034	14318	1	0	\N
382300	1874	9024000	29034	14318	2	0	\N
382301	1874	9028000	29034	14318	3	0	\N
382305	1726	121926112000	29036	14315	0	0	\N
382312	1678	28800894680000	29039	14320	0	0	\N
382313	1874	9034000	29039	14320	1	0	\N
382314	1874	9035000	29039	14320	2	0	\N
382315	1874	9037000	29039	14320	3	0	\N
382322	1678	28800894683000	29042	14323	0	0	\N
382323	1678	28800894684000	29042	14323	1	0	\N
382324	1874	9051000	29042	14323	2	0	\N
382325	1874	9053000	29042	14323	3	0	\N
382326	1874	9057000	29042	14323	4	0	\N
382327	1874	9058000	29042	14323	5	0	\N
382337	1678	28800894685000	29045	14324	0	0	\N
382338	1874	9060000	29045	14324	1	0	\N
382339	1874	9064000	29045	14324	2	0	\N
382346	1678	28800894686000	29047	14325	0	0	\N
382347	1678	28800894687000	29047	14325	1	0	\N
382348	1874	9068000	29047	14325	2	0	\N
382349	1874	9069000	29047	14325	3	0	\N
382350	1874	9071000	29047	14325	4	0	\N
382351	1874	9073000	29047	14325	5	0	\N
382352	1678	28800894686000	29048	14325	0	0	\N
382353	1678	28800894687000	29048	14325	1	0	\N
382354	1874	9068000	29048	14325	2	0	\N
382355	1874	9069000	29048	14325	3	0	\N
382356	1874	9071000	29048	14325	4	0	\N
382357	1874	9073000	29048	14325	5	0	\N
382361	1678	28800894688000	29050	14326	0	0	\N
382362	1874	9075000	29050	14326	1	0	\N
382363	1874	9079000	29050	14326	2	0	\N
382364	1678	28800894688000	29051	14326	0	0	\N
382365	1874	9075000	29051	14326	1	0	\N
382366	1874	9079000	29051	14326	2	0	\N
382367	1678	28800894688000	29052	14326	0	0	\N
382368	1874	9075000	29052	14326	1	0	\N
382369	1874	9079000	29052	14326	2	0	\N
382370	1678	28800894689000	29053	14327	0	0	\N
382371	1874	9081000	29053	14327	1	0	\N
382372	1874	9085000	29053	14327	2	0	\N
382382	1678	28800894690000	29056	14328	0	0	\N
382383	1678	28800894691000	29056	14328	1	0	\N
382384	1874	9087000	29056	14328	2	0	\N
382385	1874	9089000	29056	14328	3	0	\N
382386	1874	9093000	29056	14328	4	0	\N
382387	1874	9094000	29056	14328	5	0	\N
382388	1678	28800894692000	29057	14329	0	0	\N
382389	1874	9098000	29057	14329	1	0	\N
382390	1874	9100000	29057	14329	2	0	\N
382394	1678	28800894693000	29059	14330	0	0	\N
382395	1678	28800894694000	29059	14330	1	0	\N
382396	1678	28800894695000	29059	14330	2	0	\N
382397	1874	9101000	29059	14330	3	0	\N
382398	1874	9105000	29059	14330	4	0	\N
382399	1874	9107000	29059	14330	5	0	\N
382400	1874	9109000	29059	14330	6	0	\N
382401	1874	9111000	29059	14330	7	0	\N
382402	1874	9115000	29059	14330	8	0	\N
382403	1678	28800894693000	29060	14330	0	0	\N
382404	1678	28800894694000	29060	14330	1	0	\N
382405	1678	28800894695000	29060	14330	2	0	\N
382406	1874	9101000	29060	14330	3	0	\N
382407	1874	9105000	29060	14330	4	0	\N
382408	1874	9107000	29060	14330	5	0	\N
382409	1874	9109000	29060	14330	6	0	\N
382410	1874	9111000	29060	14330	7	0	\N
382411	1874	9115000	29060	14330	8	0	\N
382412	1678	28800894693000	29061	14330	0	0	\N
382413	1678	28800894694000	29061	14330	1	0	\N
382414	1678	28800894695000	29061	14330	2	0	\N
382415	1874	9101000	29061	14330	3	0	\N
382416	1874	9105000	29061	14330	4	0	\N
382417	1874	9107000	29061	14330	5	0	\N
382418	1874	9109000	29061	14330	6	0	\N
382419	1874	9111000	29061	14330	7	0	\N
382420	1874	9115000	29061	14330	8	0	\N
382421	1678	28800894693000	29062	14330	0	0	\N
382422	1678	28800894694000	29062	14330	1	0	\N
382423	1678	28800894695000	29062	14330	2	0	\N
382424	1874	9101000	29062	14330	3	0	\N
382425	1874	9105000	29062	14330	4	0	\N
382426	1874	9107000	29062	14330	5	0	\N
382427	1874	9109000	29062	14330	6	0	\N
382428	1874	9111000	29062	14330	7	0	\N
382429	1874	9115000	29062	14330	8	0	\N
382430	1678	28800894693000	29063	14330	0	0	\N
382431	1678	28800894694000	29063	14330	1	0	\N
382432	1678	28800894695000	29063	14330	2	0	\N
382304	1874	9028000	29035	14318	3	0	3
382306	1678	28800894679000	29037	14319	0	0	1
382307	1874	9030000	29037	14319	1	0	3
382308	1678	28800894680000	29038	14320	0	0	1
382309	1874	9034000	29038	14320	1	0	3
382311	1874	9037000	29038	14320	3	0	3
382316	1678	28800894681000	29040	14321	0	0	1
382317	1874	9039000	29040	14321	1	0	3
382318	1874	9043000	29040	14321	2	0	3
382319	1678	28800894682000	29041	14322	0	0	1
382321	1874	9049000	29041	14322	2	0	3
382328	1678	28800894683000	29043	14323	0	0	1
382329	1678	28800894684000	29043	14323	1	0	1
382330	1874	9051000	29043	14323	2	0	3
382332	1874	9057000	29043	14323	4	0	3
382333	1874	9058000	29043	14323	5	0	3
382334	1678	28800894685000	29044	14324	0	0	1
382335	1874	9060000	29044	14324	1	0	3
382336	1874	9064000	29044	14324	2	0	3
382341	1678	28800894687000	29046	14325	1	0	1
382342	1874	9068000	29046	14325	2	0	3
382343	1874	9069000	29046	14325	3	0	3
382344	1874	9071000	29046	14325	4	0	3
382345	1874	9073000	29046	14325	5	0	3
382359	1874	9075000	29049	14326	1	0	3
382360	1874	9079000	29049	14326	2	0	3
382373	1678	28800894689000	29054	14327	0	0	1
382374	1874	9081000	29054	14327	1	0	3
382376	1678	28800894690000	29055	14328	0	0	1
382377	1678	28800894691000	29055	14328	1	0	1
382378	1874	9087000	29055	14328	2	0	3
382379	1874	9089000	29055	14328	3	0	3
382380	1874	9093000	29055	14328	4	0	3
382391	1678	28800894692000	29058	14329	0	0	1
382392	1874	9098000	29058	14329	1	0	3
382393	1874	9100000	29058	14329	2	0	3
382433	1874	9101000	29063	14330	3	0	\N
382434	1874	9105000	29063	14330	4	0	\N
382435	1874	9107000	29063	14330	5	0	\N
382436	1874	9109000	29063	14330	6	0	\N
382437	1874	9111000	29063	14330	7	0	\N
382438	1874	9115000	29063	14330	8	0	\N
382448	1678	28800894696000	29065	14331	0	0	\N
382449	1874	9119000	29065	14331	1	0	\N
382450	1874	9120000	29065	14331	2	0	\N
382451	1874	9122000	29065	14331	3	0	\N
382456	1678	28800894696000	29067	14331	0	0	\N
382457	1874	9119000	29067	14331	1	0	\N
382458	1874	9120000	29067	14331	2	0	\N
382459	1874	9122000	29067	14331	3	0	\N
382460	1678	28800894696000	29068	14331	0	0	\N
382461	1874	9119000	29068	14331	1	0	\N
382462	1874	9120000	29068	14331	2	0	\N
382463	1874	9122000	29068	14331	3	0	\N
382469	1678	28800894699000	29071	14334	0	0	\N
382470	1678	28800894699000	29072	14334	0	0	\N
382471	1874	9134000	29072	14334	1	0	\N
382472	1874	9136000	29072	14334	3	0	\N
382476	1678	28800894699000	29074	14334	0	0	\N
382477	1874	9134000	29074	14334	1	0	\N
382478	1874	9136000	29074	14334	3	0	\N
382479	1678	28800894699000	29075	14334	0	0	\N
382480	1874	9134000	29075	14334	1	0	\N
382481	1874	9136000	29075	14334	3	0	\N
382486	1678	28800894700000	29077	14335	0	0	\N
382487	1874	9137000	29077	14335	1	0	\N
382488	1874	9139000	29077	14335	2	0	\N
382489	1874	9143000	29077	14335	3	0	\N
382490	1678	28800894700000	29078	14335	0	0	\N
382491	1874	9137000	29078	14335	1	0	\N
382492	1874	9139000	29078	14335	2	0	\N
382493	1874	9143000	29078	14335	3	0	\N
382494	1678	28800894700000	29079	14335	0	0	\N
382495	1874	9137000	29079	14335	1	0	\N
382496	1874	9139000	29079	14335	2	0	\N
382497	1678	28800894700000	29080	14335	0	0	\N
382498	1874	9137000	29080	14335	1	0	\N
382499	1874	9139000	29080	14335	2	0	\N
382505	1678	28800894702000	29083	14337	0	0	\N
382506	1874	9147000	29083	14337	1	0	\N
382507	1874	9151000	29083	14337	2	0	\N
382508	1678	28800894702000	29084	14337	0	0	\N
382509	1874	9147000	29084	14337	1	0	\N
382510	1874	9151000	29084	14337	2	0	\N
382511	1678	28800894703000	29085	14338	0	0	\N
382512	1874	9152000	29085	14338	1	0	\N
382513	1874	9154000	29085	14338	2	0	\N
382514	1874	9158000	29085	14338	3	0	\N
382528	1678	28800894707000	29090	14342	0	0	\N
382529	121	66000099000000	29090	14342	1	0	\N
382530	1678	28800894708000	29090	14342	2	0	\N
382531	1874	9175000	29090	14342	3	0	\N
382532	1874	9177000	29090	14342	4	0	\N
382533	1874	9181000	29090	14342	5	0	\N
382543	1678	28800894709000	29093	14343	0	0	\N
382544	1874	9185000	29093	14343	1	0	\N
382545	1874	9187000	29093	14343	2	0	\N
382550	1678	28800894710000	29095	14344	0	0	\N
382551	1874	9191000	29095	14344	1	0	\N
382552	1874	9192000	29095	14344	2	0	\N
382553	1874	9194000	29095	14344	3	0	\N
382554	1678	28800894710000	29096	14344	0	0	\N
382555	1874	9191000	29096	14344	1	0	\N
382556	1874	9192000	29096	14344	2	0	\N
382557	1874	9194000	29096	14344	3	0	\N
382558	1678	28800894710000	29097	14344	0	0	\N
382559	1874	9191000	29097	14344	1	0	\N
382560	1874	9192000	29097	14344	2	0	\N
382561	1874	9194000	29097	14344	3	0	\N
382562	121	66000099000000	29098	14190	2	0	\N
382563	1726	128532112000	29098	14190	4	0	\N
382564	2411	0	29098	14190	5	0	\N
382565	2411	30000000	29098	14190	6	0	\N
382566	2411	543030000000	29098	14190	7	0	\N
382567	296	66002000000000	29098	14190	8	0	\N
382568	1406	0	29098	14190	9	0	\N
382441	1678	28800894695000	29064	14330	2	0	1
382442	1874	9101000	29064	14330	3	0	3
382443	1874	9105000	29064	14330	4	0	3
382444	1874	9107000	29064	14330	5	0	3
382445	1874	9109000	29064	14330	6	0	3
382447	1874	9115000	29064	14330	8	0	3
382452	1678	28800894696000	29066	14331	0	0	1
382453	1874	9119000	29066	14331	1	0	3
382454	1874	9120000	29066	14331	2	0	3
382455	1874	9122000	29066	14331	3	0	3
382465	1874	9124000	29069	14332	1	0	3
382466	1678	28800894698000	29070	14333	0	0	1
382467	1874	9128000	29070	14333	1	0	3
382468	1874	9130000	29070	14333	2	0	3
382474	1874	9134000	29073	14334	1	0	3
382475	1874	9136000	29073	14334	3	0	3
382482	1678	28800894700000	29076	14335	0	0	1
382483	1874	9137000	29076	14335	1	0	3
382484	1874	9139000	29076	14335	2	0	3
382500	1678	28800894701000	29081	14336	0	0	1
382501	1874	9145000	29081	14336	1	0	3
382502	1678	28800894702000	29082	14337	0	0	1
382503	1874	9147000	29082	14337	1	0	3
382504	1874	9151000	29082	14337	2	0	3
382516	1874	9152000	29086	14338	1	0	3
382517	1874	9154000	29086	14338	2	0	3
382518	1874	9158000	29086	14338	3	0	3
382519	1678	28800894704000	29087	14339	0	0	1
382521	1678	28800894705000	29088	14340	0	0	1
382522	1874	9162000	29088	14340	1	0	3
382523	1874	9166000	29088	14340	2	0	3
382524	1678	28800894706000	29089	14341	0	0	1
382525	1874	9168000	29089	14341	1	0	3
382527	1874	9173000	29089	14341	3	0	3
382534	1678	28800894707000	29091	14342	0	0	1
382535	121	66000099000000	29091	14342	1	0	1
382536	1678	28800894708000	29091	14342	2	0	1
382537	1874	9175000	29091	14342	3	0	3
382539	1874	9181000	29091	14342	5	0	3
382540	1678	28800894709000	29092	14343	0	0	1
382541	1874	9185000	29092	14343	1	0	3
382542	1874	9187000	29092	14343	2	0	3
382547	1874	9191000	29094	14344	1	0	3
382548	1874	9192000	29094	14344	2	0	3
382549	1874	9194000	29094	14344	3	0	3
382569	1406	0	29098	14190	10	0	\N
382570	2412	502774774000000	29098	14190	11	0	\N
382571	2413	900971464000000	29098	14190	12	0	\N
382574	1678	28800894711000	29100	14345	0	0	\N
382575	1874	9196000	29100	14345	1	0	\N
382576	1678	28800894712000	29101	14346	0	0	\N
382577	1678	28800894713000	29101	14346	1	0	\N
382578	1678	28800894714000	29101	14346	2	0	\N
382579	1874	9198000	29101	14346	3	0	\N
382580	1874	9200000	29101	14346	4	0	\N
382581	1874	9202000	29101	14346	5	0	\N
382582	1874	9206000	29101	14346	6	0	\N
382583	1874	9210000	29101	14346	7	0	\N
382584	1874	9214000	29101	14346	8	0	\N
382585	1874	9215000	29101	14346	9	0	\N
382596	1678	28800894715000	29103	14347	0	0	\N
382597	1874	9217000	29103	14347	1	0	\N
382600	1540	0	29105	14302	0	0	\N
382601	1678	28800894655000	29105	14302	1	0	\N
382602	1678	28800894656000	29105	14302	2	0	\N
382603	121	66000099000000	29105	14302	4	0	\N
382604	1726	121926112000	29105	14302	5	0	\N
382605	1678	28800894657000	29105	14302	6	0	\N
382606	1678	28800894658000	29105	14302	7	0	\N
382607	1678	28800894659000	29105	14302	8	0	\N
382608	1678	28800894660000	29105	14302	9	0	\N
382609	1678	28800894661000	29105	14302	10	0	\N
382610	1678	28800894662000	29105	14302	11	0	\N
382611	1678	28800894663000	29105	14302	12	0	\N
382612	1678	28800894664000	29105	14302	13	0	\N
382613	1678	28800894665000	29105	14302	14	0	\N
382614	1678	28800894666000	29105	14302	15	0	\N
382615	1678	28800894667000	29105	14302	16	0	\N
382616	1678	28800894668000	29105	14302	17	0	\N
382617	1678	28800894669000	29105	14302	18	0	\N
382618	1678	28800894670000	29105	14302	19	0	\N
382619	1678	28800894671000	29105	14302	20	0	\N
382620	1678	28800894672000	29105	14302	21	0	\N
382621	1678	28800894673000	29105	14302	22	0	\N
382622	1678	28800894674000	29105	14302	23	0	\N
382623	1678	28800894675000	29105	14302	24	0	\N
382624	1678	28800894676000	29105	14302	25	0	\N
382625	1678	28800894677000	29105	14302	26	0	\N
382626	1678	28800894678000	29105	14302	27	0	\N
382627	1678	28800894679000	29105	14302	28	0	\N
382628	1678	28800894680000	29105	14302	29	0	\N
382629	1678	28800894681000	29105	14302	30	0	\N
382630	1678	28800894682000	29105	14302	31	0	\N
382631	1678	28800894683000	29105	14302	32	0	\N
382632	1678	28800894684000	29105	14302	33	0	\N
382633	1678	28800894685000	29105	14302	34	0	\N
382634	1678	28800894686000	29105	14302	35	0	\N
382635	1678	28800894687000	29105	14302	36	0	\N
382636	1678	28800894688000	29105	14302	37	0	\N
382637	1678	28800894689000	29105	14302	38	0	\N
382638	1678	28800894690000	29105	14302	39	0	\N
382639	1678	28800894691000	29105	14302	40	0	\N
382640	1678	28800894692000	29105	14302	41	0	\N
382641	1678	28800894693000	29105	14302	42	0	\N
382642	1678	28800894694000	29105	14302	43	0	\N
382643	1678	28800894695000	29105	14302	44	0	\N
382644	1678	28800894696000	29105	14302	45	0	\N
382645	1678	28800894697000	29105	14302	46	0	\N
382646	1678	28800894698000	29105	14302	47	0	\N
382647	1678	28800894699000	29105	14302	48	0	\N
382648	1678	28800894700000	29105	14302	49	0	\N
382649	1678	28800894701000	29105	14302	50	0	\N
382650	1678	28800894702000	29105	14302	51	0	\N
382651	1678	28800894703000	29105	14302	52	0	\N
382652	1678	28800894704000	29105	14302	53	0	\N
382653	1678	28800894705000	29105	14302	54	0	\N
382654	1678	28800894706000	29105	14302	55	0	\N
382655	1678	28800894707000	29105	14302	56	0	\N
382656	1678	28800894708000	29105	14302	57	0	\N
382657	1678	28800894709000	29105	14302	58	0	\N
382658	1678	28800894710000	29105	14302	59	0	\N
382659	1678	28800894711000	29105	14302	60	0	\N
382660	1678	28800894712000	29105	14302	61	0	\N
382661	1678	28800894713000	29105	14302	62	0	\N
382662	1678	28800894714000	29105	14302	63	0	\N
382663	1678	28800894715000	29105	14302	64	0	\N
382664	1874	8905000	29105	14302	65	0	\N
382665	1874	8909000	29105	14302	66	0	\N
382666	1874	8911000	29105	14302	67	0	\N
382667	1874	8913000	29105	14302	68	0	\N
382668	1874	8915000	29105	14302	69	0	\N
382669	1874	8917000	29105	14302	70	0	\N
382670	1874	8919000	29105	14302	71	0	\N
382671	1874	8923000	29105	14302	72	0	\N
382672	1874	8927000	29105	14302	74	0	\N
382673	1874	8931000	29105	14302	75	0	\N
382674	1874	8935000	29105	14302	76	0	\N
382675	1874	8939000	29105	14302	77	0	\N
382676	1874	8943000	29105	14302	78	0	\N
382677	1874	8947000	29105	14302	79	0	\N
382678	1874	8951000	29105	14302	80	0	\N
382679	1874	8955000	29105	14302	81	0	\N
382680	1874	8959000	29105	14302	82	0	\N
382681	1874	8963000	29105	14302	83	0	\N
382682	1874	8967000	29105	14302	84	0	\N
382683	1874	8971000	29105	14302	85	0	\N
382684	1874	8975000	29105	14302	86	0	\N
382685	1874	8979000	29105	14302	87	0	\N
382686	1874	8983000	29105	14302	88	0	\N
382687	1874	8984000	29105	14302	89	0	\N
382688	1874	8985000	29105	14302	90	0	\N
382689	1874	8986000	29105	14302	91	0	\N
382690	1874	8987000	29105	14302	92	0	\N
382691	1874	8988000	29105	14302	93	0	\N
382692	1874	8989000	29105	14302	94	0	\N
382693	1874	8990000	29105	14302	95	0	\N
382694	1874	8991000	29105	14302	96	0	\N
382695	1874	8992000	29105	14302	97	0	\N
382696	1874	8993000	29105	14302	98	0	\N
382697	1874	8994000	29105	14302	99	0	\N
382698	1874	8995000	29105	14302	100	0	\N
382699	1874	8996000	29105	14302	101	0	\N
382700	1874	8997000	29105	14302	102	0	\N
382701	1874	8998000	29105	14302	103	0	\N
382702	1874	8999000	29105	14302	104	0	\N
382703	1874	9000000	29105	14302	105	0	\N
382704	1874	9001000	29105	14302	106	0	\N
382586	1678	28800894712000	29102	14346	0	0	1
382587	1678	28800894713000	29102	14346	1	0	1
382588	1678	28800894714000	29102	14346	2	0	1
382589	1874	9198000	29102	14346	3	0	3
382590	1874	9200000	29102	14346	4	0	3
382592	1874	9206000	29102	14346	6	0	3
382593	1874	9210000	29102	14346	7	0	3
382594	1874	9214000	29102	14346	8	0	3
382595	1874	9215000	29102	14346	9	0	3
382598	1678	28800894715000	29104	14347	0	0	1
382705	1874	9005000	29105	14302	107	0	\N
382706	1874	9009000	29105	14302	108	0	\N
382707	1874	9013000	29105	14302	109	0	\N
382708	1874	9017000	29105	14302	110	0	\N
382709	1874	9021000	29105	14302	111	0	\N
382710	1874	9025000	29105	14302	112	0	\N
382711	1874	9029000	29105	14302	113	0	\N
382712	1874	9033000	29105	14302	114	0	\N
382713	1874	9037000	29105	14302	115	0	\N
382714	1874	9041000	29105	14302	116	0	\N
382715	1874	9045000	29105	14302	117	0	\N
382716	1874	9049000	29105	14302	118	0	\N
382717	1874	9053000	29105	14302	119	0	\N
382718	1874	9057000	29105	14302	120	0	\N
382719	1874	9061000	29105	14302	121	0	\N
382720	1874	9065000	29105	14302	122	0	\N
382721	1874	9069000	29105	14302	123	0	\N
382722	1874	9073000	29105	14302	124	0	\N
382723	1874	9077000	29105	14302	125	0	\N
382731	1678	28800894717000	29108	14349	0	0	\N
382732	1874	9226000	29108	14349	1	0	\N
382733	1874	9230000	29108	14349	2	0	\N
382743	1678	28800894720000	29111	14351	0	0	\N
382744	1874	9242000	29111	14351	1	0	\N
382745	1874	9244000	29111	14351	2	0	\N
382746	1874	9245000	29111	14351	3	0	\N
382756	1678	28800894724000	29114	14354	0	0	\N
382757	1678	28800894725000	29114	14354	1	0	\N
382758	1678	28800894726000	29114	14354	2	0	\N
382759	1874	9264000	29114	14354	3	0	\N
382760	1874	9266000	29114	14354	4	0	\N
382761	1874	9268000	29114	14354	5	0	\N
382762	1874	9270000	29114	14354	6	0	\N
382763	1874	9274000	29114	14354	7	0	\N
382772	1678	28800894724000	29116	14354	0	0	\N
382773	1678	28800894725000	29116	14354	1	0	\N
382774	1678	28800894726000	29116	14354	2	0	\N
382775	1874	9264000	29116	14354	3	0	\N
382776	1874	9266000	29116	14354	4	0	\N
382777	1874	9268000	29116	14354	5	0	\N
382778	1874	9270000	29116	14354	6	0	\N
382779	1874	9274000	29116	14354	7	0	\N
382780	1678	28800894724000	29117	14354	0	0	\N
382781	1678	28800894725000	29117	14354	1	0	\N
382782	1678	28800894726000	29117	14354	2	0	\N
382783	1874	9264000	29117	14354	3	0	\N
382784	1874	9266000	29117	14354	4	0	\N
382785	1874	9268000	29117	14354	5	0	\N
382786	1874	9270000	29117	14354	6	0	\N
382787	1874	9274000	29117	14354	7	0	\N
382788	1540	0	29118	14294	0	0	\N
382789	121	66000099000000	29118	14294	2	0	\N
382790	1678	28800894646000	29118	14294	3	0	\N
382791	1678	28800894647000	29118	14294	4	0	\N
382792	1726	121926112000	29118	14294	5	0	\N
382793	1678	28800894648000	29118	14294	6	0	\N
382794	1678	28800894649000	29118	14294	7	0	\N
382795	1678	28800894650000	29118	14294	8	0	\N
382796	1678	28800894651000	29118	14294	9	0	\N
382797	1678	28800894652000	29118	14294	10	0	\N
382798	1678	28800894653000	29118	14294	11	0	\N
382799	1678	28800894654000	29118	14294	12	0	\N
382800	1678	28800894655000	29118	14294	13	0	\N
382801	1678	28800894656000	29118	14294	14	0	\N
382802	1678	28800894657000	29118	14294	15	0	\N
382803	1678	28800894658000	29118	14294	16	0	\N
382804	1678	28800894659000	29118	14294	17	0	\N
382805	1678	28800894660000	29118	14294	18	0	\N
382806	1678	28800894661000	29118	14294	19	0	\N
382807	1678	28800894662000	29118	14294	20	0	\N
382808	1678	28800894663000	29118	14294	21	0	\N
382809	1678	28800894664000	29118	14294	22	0	\N
382810	1678	28800894665000	29118	14294	23	0	\N
382811	1678	28800894666000	29118	14294	24	0	\N
382812	1678	28800894667000	29118	14294	25	0	\N
382813	1678	28800894668000	29118	14294	26	0	\N
382814	1678	28800894669000	29118	14294	27	0	\N
382815	1678	28800894670000	29118	14294	28	0	\N
382816	1678	28800894671000	29118	14294	29	0	\N
382817	1678	28800894672000	29118	14294	30	0	\N
382818	1678	28800894673000	29118	14294	31	0	\N
382819	1678	28800894674000	29118	14294	32	0	\N
382820	1678	28800894675000	29118	14294	33	0	\N
382821	1678	28800894676000	29118	14294	34	0	\N
382822	1678	28800894677000	29118	14294	35	0	\N
382823	1678	28800894678000	29118	14294	36	0	\N
382824	1678	28800894679000	29118	14294	37	0	\N
382825	1678	28800894680000	29118	14294	38	0	\N
382826	1678	28800894681000	29118	14294	39	0	\N
382827	1678	28800894682000	29118	14294	40	0	\N
382828	1678	28800894683000	29118	14294	41	0	\N
382829	1678	28800894684000	29118	14294	42	0	\N
382830	1678	28800894685000	29118	14294	43	0	\N
382831	1678	28800894686000	29118	14294	44	0	\N
382832	1678	28800894687000	29118	14294	45	0	\N
382833	1678	28800894688000	29118	14294	46	0	\N
382834	1678	28800894689000	29118	14294	47	0	\N
382835	1678	28800894690000	29118	14294	48	0	\N
382836	1678	28800894691000	29118	14294	49	0	\N
382837	1678	28800894692000	29118	14294	50	0	\N
382838	1678	28800894693000	29118	14294	51	0	\N
382839	1678	28800894694000	29118	14294	52	0	\N
382840	1678	28800894695000	29118	14294	53	0	\N
382726	1874	9220000	29106	14348	2	0	3
382727	1874	9224000	29106	14348	3	0	3
382728	1678	28800894717000	29107	14349	0	0	1
382729	1874	9226000	29107	14349	1	0	3
382730	1874	9230000	29107	14349	2	0	3
382735	1678	28800894719000	29109	14350	1	0	1
382736	1874	9234000	29109	14350	2	0	3
382737	1874	9236000	29109	14350	3	0	3
382738	1874	9238000	29109	14350	4	0	3
382739	1678	28800894720000	29110	14351	0	0	1
382741	1874	9244000	29110	14351	2	0	3
382742	1874	9245000	29110	14351	3	0	3
382747	1678	28800894721000	29112	14352	0	0	1
382748	1874	9247000	29112	14352	1	0	3
382750	1678	28800894722000	29113	14353	0	0	1
382751	1678	28800894723000	29113	14353	1	0	1
382752	1874	9252000	29113	14353	2	0	3
382753	1874	9254000	29113	14353	3	0	3
382754	1874	9256000	29113	14353	4	0	3
382764	1678	28800894724000	29115	14354	0	0	1
382765	1678	28800894725000	29115	14354	1	0	1
382766	1678	28800894726000	29115	14354	2	0	1
382767	1874	9264000	29115	14354	3	0	3
382768	1874	9266000	29115	14354	4	0	3
382770	1874	9270000	29115	14354	6	0	3
382771	1874	9274000	29115	14354	7	0	3
382841	1678	28800894696000	29118	14294	54	0	\N
382842	1678	28800894697000	29118	14294	55	0	\N
382843	1678	28800894698000	29118	14294	56	0	\N
382844	1678	28800894699000	29118	14294	57	0	\N
382845	1678	28800894700000	29118	14294	58	0	\N
382846	1678	28800894701000	29118	14294	59	0	\N
382847	1678	28800894702000	29118	14294	60	0	\N
382848	1678	28800894703000	29118	14294	61	0	\N
382849	1678	28800894704000	29118	14294	62	0	\N
382850	1678	28800894705000	29118	14294	63	0	\N
382851	1678	28800894706000	29118	14294	64	0	\N
382852	1678	28800894707000	29118	14294	65	0	\N
382853	1678	28800894708000	29118	14294	66	0	\N
382854	1678	28800894709000	29118	14294	67	0	\N
382855	1678	28800894710000	29118	14294	68	0	\N
382856	1678	28800894711000	29118	14294	69	0	\N
382857	1678	28800894712000	29118	14294	70	0	\N
382858	1678	28800894713000	29118	14294	71	0	\N
382859	1678	28800894714000	29118	14294	72	0	\N
382860	1678	28800894715000	29118	14294	73	0	\N
382861	1678	28800894716000	29118	14294	74	0	\N
382862	1678	28800894717000	29118	14294	75	0	\N
382863	1678	28800894718000	29118	14294	76	0	\N
382864	1678	28800894719000	29118	14294	77	0	\N
382865	1678	28800894720000	29118	14294	78	0	\N
382866	1678	28800894721000	29118	14294	79	0	\N
382867	1678	28800894722000	29118	14294	80	0	\N
382868	1678	28800894723000	29118	14294	81	0	\N
382869	1678	28800894724000	29118	14294	82	0	\N
382870	1678	28800894725000	29118	14294	83	0	\N
382871	1678	28800894726000	29118	14294	84	0	\N
382872	1874	8860000	29118	14294	85	0	\N
382873	1874	8862000	29118	14294	86	0	\N
382874	1874	8864000	29118	14294	87	0	\N
382875	1874	8865000	29118	14294	88	0	\N
382876	1874	8866000	29118	14294	89	0	\N
382877	1874	8867000	29118	14294	90	0	\N
382878	1874	8869000	29118	14294	91	0	\N
382879	1874	8871000	29118	14294	92	0	\N
382880	1874	8873000	29118	14294	93	0	\N
382881	1874	8877000	29118	14294	94	0	\N
382882	1874	8881000	29118	14294	95	0	\N
382883	1874	8883000	29118	14294	96	0	\N
382884	1874	8887000	29118	14294	97	0	\N
382885	1874	8891000	29118	14294	98	0	\N
382886	1874	8892000	29118	14294	99	0	\N
382887	1874	8893000	29118	14294	100	0	\N
382888	1874	8894000	29118	14294	101	0	\N
382889	1874	8895000	29118	14294	102	0	\N
382890	1874	8896000	29118	14294	103	0	\N
382891	1874	8897000	29118	14294	104	0	\N
382892	1874	8898000	29118	14294	105	0	\N
382893	1874	8899000	29118	14294	106	0	\N
382894	1874	8900000	29118	14294	107	0	\N
382895	1874	8901000	29118	14294	108	0	\N
382896	1874	8902000	29118	14294	109	0	\N
382897	1874	8903000	29118	14294	110	0	\N
382898	1874	8904000	29118	14294	111	0	\N
382899	1874	8905000	29118	14294	112	0	\N
382900	1874	8906000	29118	14294	113	0	\N
382901	1874	8907000	29118	14294	114	0	\N
382902	1874	8908000	29118	14294	115	0	\N
382903	1874	8912000	29118	14294	117	0	\N
382904	1874	8916000	29118	14294	118	0	\N
382905	1874	8920000	29118	14294	119	0	\N
382906	1874	8924000	29118	14294	120	0	\N
382907	1874	8928000	29118	14294	121	0	\N
382908	1874	8932000	29118	14294	122	0	\N
382909	1874	8936000	29118	14294	123	0	\N
382910	1874	8940000	29118	14294	124	0	\N
382911	1874	8944000	29118	14294	125	0	\N
382921	1678	28800894730000	29121	14357	0	0	\N
382922	1874	9290000	29121	14357	1	0	\N
382923	1874	9294000	29121	14357	2	0	\N
382924	1874	9296000	29121	14357	3	0	\N
382925	1678	28800894730000	29122	14357	0	0	\N
382926	1874	9290000	29122	14357	1	0	\N
382927	1874	9294000	29122	14357	2	0	\N
382928	1874	9296000	29122	14357	3	0	\N
382942	121	66000099000000	29126	14235	1	0	\N
382943	1726	126330112000	29126	14235	3	0	\N
382944	2411	0	29126	14235	4	0	\N
382945	2411	30000000	29126	14235	5	0	\N
382946	2411	543030000000	29126	14235	6	0	\N
382947	296	66002000000000	29126	14235	7	0	\N
382948	2412	502774774000000	29126	14235	8	0	\N
382949	1874	8475000	29126	14235	9	0	\N
382950	2414	100000000	29126	14235	10	0	\N
382951	2415	100000000	29126	14235	11	0	\N
382952	2416	100000000	29126	14235	12	0	\N
382953	1874	8476000	29126	14235	13	0	\N
382954	1874	8477000	29126	14235	14	0	\N
382955	1874	8478000	29126	14235	15	0	\N
382956	1874	8479000	29126	14235	16	0	\N
382957	1874	8480000	29126	14235	17	0	\N
382958	1874	8481000	29126	14235	18	0	\N
382959	1874	8482000	29126	14235	19	0	\N
382960	1874	8483000	29126	14235	20	0	\N
382961	1874	8484000	29126	14235	21	0	\N
382962	1874	8485000	29126	14235	22	0	\N
382963	1874	8486000	29126	14235	23	0	\N
382964	1874	8487000	29126	14235	24	0	\N
382965	2413	900971464000000	29126	14235	25	0	\N
382966	2417	100000000	29126	14235	26	0	\N
382967	1874	8488000	29126	14235	27	0	\N
382968	1874	8489000	29126	14235	28	0	\N
382969	1874	8490000	29126	14235	29	0	\N
382970	1874	8491000	29126	14235	30	0	\N
382971	1874	8492000	29126	14235	31	0	\N
382972	1874	8493000	29126	14235	32	0	\N
382973	1874	8494000	29126	14235	33	0	\N
382974	1874	8495000	29126	14235	34	0	\N
382975	1874	8496000	29126	14235	35	0	\N
382976	1874	8497000	29126	14235	36	0	\N
382914	1874	9280000	29119	14355	3	0	3
382915	1874	9281000	29119	14355	4	0	3
382916	1678	28800894728000	29120	14356	0	0	1
382917	1678	28800894729000	29120	14356	1	0	1
382918	1874	9283000	29120	14356	2	0	3
382920	1874	9289000	29120	14356	4	0	3
382929	1678	28800894730000	29123	14357	0	0	1
382930	1874	9290000	29123	14357	1	0	3
382931	1874	9294000	29123	14357	2	0	3
382932	1874	9296000	29123	14357	3	0	3
382934	1874	9298000	29124	14358	1	0	3
382935	1874	9302000	29124	14358	2	0	3
382936	1678	28800894732000	29125	14359	0	0	1
382937	1678	28800894733000	29125	14359	1	0	1
382939	1874	9307000	29125	14359	3	0	3
382940	1874	9309000	29125	14359	4	0	3
382941	1874	9311000	29125	14359	5	0	3
382977	1874	8498000	29126	14235	37	0	\N
382978	1874	8499000	29126	14235	38	0	\N
382979	1874	8500000	29126	14235	39	0	\N
382980	1874	8501000	29126	14235	40	0	\N
382981	1874	8502000	29126	14235	41	0	\N
382982	1874	8503000	29126	14235	42	0	\N
382983	1874	8504000	29126	14235	43	0	\N
382984	1874	8505000	29126	14235	44	0	\N
382985	1874	8506000	29126	14235	45	0	\N
382986	1874	8507000	29126	14235	46	0	\N
382987	1874	8508000	29126	14235	47	0	\N
382988	1874	8509000	29126	14235	48	0	\N
382989	1874	8510000	29126	14235	49	0	\N
382990	1874	8511000	29126	14235	50	0	\N
382991	1874	8512000	29126	14235	51	0	\N
382992	1874	8513000	29126	14235	52	0	\N
382993	1874	8514000	29126	14235	53	0	\N
382994	1874	8515000	29126	14235	54	0	\N
382995	1874	8516000	29126	14235	55	0	\N
382996	1874	8517000	29126	14235	56	0	\N
382997	1874	8518000	29126	14235	57	0	\N
382998	1874	8519000	29126	14235	58	0	\N
382999	1874	8520000	29126	14235	59	0	\N
383000	1874	8521000	29126	14235	60	0	\N
383001	1874	8522000	29126	14235	61	0	\N
383002	1874	8523000	29126	14235	62	0	\N
383015	121	66000099000000	29128	14246	2	0	\N
383016	1678	28800894604000	29128	14246	3	0	\N
383017	1678	28800894605000	29128	14246	4	0	\N
383018	1726	125229112000	29128	14246	5	0	\N
383019	1678	28800894606000	29128	14246	6	0	\N
383020	1678	28800894607000	29128	14246	7	0	\N
383021	1678	28800894608000	29128	14246	8	0	\N
383022	1678	28800894609000	29128	14246	9	0	\N
383023	1678	28800894610000	29128	14246	10	0	\N
383024	1678	28800894611000	29128	14246	11	0	\N
383025	1678	28800894612000	29128	14246	12	0	\N
383026	1678	28800894613000	29128	14246	13	0	\N
383027	1678	28800894614000	29128	14246	14	0	\N
383028	1678	28800894615000	29128	14246	15	0	\N
383029	1678	28800894616000	29128	14246	16	0	\N
383030	1678	28800894617000	29128	14246	17	0	\N
383031	1678	28800894618000	29128	14246	18	0	\N
383032	1678	28800894619000	29128	14246	19	0	\N
383033	1678	28800894620000	29128	14246	20	0	\N
383034	1678	28800894621000	29128	14246	21	0	\N
383035	1678	28800894622000	29128	14246	22	0	\N
383036	1678	28800894623000	29128	14246	23	0	\N
383037	1678	28800894624000	29128	14246	24	0	\N
383038	1678	28800894625000	29128	14246	25	0	\N
383039	1678	28800894626000	29128	14246	26	0	\N
383040	1678	28800894627000	29128	14246	27	0	\N
383041	1678	28800894628000	29128	14246	28	0	\N
383042	1678	28800894629000	29128	14246	29	0	\N
383043	1678	28800894630000	29128	14246	30	0	\N
383044	1678	28800894631000	29128	14246	31	0	\N
383045	1678	28800894632000	29128	14246	32	0	\N
383046	1678	28800894633000	29128	14246	33	0	\N
383047	1678	28800894634000	29128	14246	34	0	\N
383048	1678	28800894635000	29128	14246	35	0	\N
383049	1678	28800894636000	29128	14246	36	0	\N
383050	1678	28800894637000	29128	14246	37	0	\N
383051	1678	28800894638000	29128	14246	38	0	\N
383052	1678	28800894639000	29128	14246	39	0	\N
383053	1678	28800894640000	29128	14246	40	0	\N
383054	1678	28800894641000	29128	14246	41	0	\N
383055	1678	28800894642000	29128	14246	42	0	\N
383056	1678	28800894643000	29128	14246	43	0	\N
383057	1678	28800894644000	29128	14246	44	0	\N
383058	1678	28800894645000	29128	14246	45	0	\N
383059	1678	28800894646000	29128	14246	46	0	\N
383060	1678	28800894647000	29128	14246	47	0	\N
383061	1678	28800894648000	29128	14246	48	0	\N
383062	1678	28800894649000	29128	14246	49	0	\N
383063	1678	28800894650000	29128	14246	50	0	\N
383064	1678	28800894651000	29128	14246	51	0	\N
383065	1678	28800894652000	29128	14246	52	0	\N
383066	1678	28800894653000	29128	14246	53	0	\N
383067	1678	28800894654000	29128	14246	54	0	\N
383068	1678	28800894655000	29128	14246	55	0	\N
383069	1678	28800894656000	29128	14246	56	0	\N
383070	1678	28800894657000	29128	14246	57	0	\N
383071	1678	28800894658000	29128	14246	58	0	\N
383072	1678	28800894659000	29128	14246	59	0	\N
383073	1678	28800894660000	29128	14246	60	0	\N
383074	1678	28800894661000	29128	14246	61	0	\N
383075	1678	28800894662000	29128	14246	62	0	\N
383076	1678	28800894663000	29128	14246	63	0	\N
383077	1678	28800894664000	29128	14246	64	0	\N
383078	1678	28800894665000	29128	14246	65	0	\N
383079	1678	28800894666000	29128	14246	66	0	\N
383080	1678	28800894667000	29128	14246	67	0	\N
383081	1678	28800894668000	29128	14246	68	0	\N
383082	1678	28800894669000	29128	14246	69	0	\N
383083	1678	28800894670000	29128	14246	70	0	\N
383084	1678	28800894671000	29128	14246	71	0	\N
383085	1678	28800894672000	29128	14246	72	0	\N
383086	1678	28800894673000	29128	14246	73	0	\N
383087	1678	28800894674000	29128	14246	74	0	\N
383088	1678	28800894675000	29128	14246	75	0	\N
383089	1678	28800894676000	29128	14246	76	0	\N
383090	1678	28800894677000	29128	14246	77	0	\N
383091	1678	28800894678000	29128	14246	78	0	\N
383092	1678	28800894679000	29128	14246	79	0	\N
383093	1678	28800894680000	29128	14246	80	0	\N
383094	1678	28800894681000	29128	14246	81	0	\N
383095	1678	28800894682000	29128	14246	82	0	\N
383096	1678	28800894683000	29128	14246	83	0	\N
383097	1678	28800894684000	29128	14246	84	0	\N
383098	1678	28800894685000	29128	14246	85	0	\N
383099	1678	28800894686000	29128	14246	86	0	\N
383100	1678	28800894687000	29128	14246	87	0	\N
383101	1678	28800894688000	29128	14246	88	0	\N
383102	1678	28800894689000	29128	14246	89	0	\N
383103	1678	28800894690000	29128	14246	90	0	\N
383104	1678	28800894691000	29128	14246	91	0	\N
383105	1678	28800894692000	29128	14246	92	0	\N
383106	1678	28800894693000	29128	14246	93	0	\N
383107	1678	28800894694000	29128	14246	94	0	\N
383108	1678	28800894695000	29128	14246	95	0	\N
383109	1678	28800894696000	29128	14246	96	0	\N
383110	1678	28800894697000	29128	14246	97	0	\N
383111	1678	28800894698000	29128	14246	98	0	\N
383112	1678	28800894699000	29128	14246	99	0	\N
383005	1678	28800894736000	29127	14360	2	0	1
383006	1678	28800894737000	29127	14360	3	0	1
383007	1874	9313000	29127	14360	4	0	3
383008	1874	9315000	29127	14360	5	0	3
383009	1874	9317000	29127	14360	6	0	3
383011	1874	9320000	29127	14360	8	0	3
383012	1874	9324000	29127	14360	9	0	3
383013	1874	9328000	29127	14360	10	0	3
383014	1874	9332000	29127	14360	11	0	3
383113	1678	28800894700000	29128	14246	100	0	\N
383114	1678	28800894701000	29128	14246	101	0	\N
383115	1678	28800894702000	29128	14246	102	0	\N
383116	1678	28800894703000	29128	14246	104	0	\N
383117	1678	28800894704000	29128	14246	105	0	\N
383118	1678	28800894705000	29128	14246	106	0	\N
383119	1678	28800894706000	29128	14246	107	0	\N
383120	1678	28800894707000	29128	14246	108	0	\N
383121	1678	28800894708000	29128	14246	109	0	\N
383122	1678	28800894709000	29128	14246	110	0	\N
383123	1678	28800894710000	29128	14246	111	0	\N
383124	1678	28800894711000	29128	14246	112	0	\N
383125	1678	28800894712000	29128	14246	113	0	\N
383126	1678	28800894713000	29128	14246	114	0	\N
383127	1678	28800894714000	29128	14246	115	0	\N
383128	1678	28800894715000	29128	14246	116	0	\N
383129	1678	28800894716000	29128	14246	117	0	\N
383130	1678	28800894717000	29128	14246	118	0	\N
383131	1678	28800894718000	29128	14246	119	0	\N
383132	1678	28800894719000	29128	14246	120	0	\N
383133	1678	28800894720000	29128	14246	121	0	\N
383134	1678	28800894721000	29128	14246	122	0	\N
383135	1678	28800894722000	29128	14246	123	0	\N
383136	1678	28800894723000	29128	14246	124	0	\N
383137	1678	28800894724000	29128	14246	125	0	\N
383150	1678	28800894740000	29131	14362	0	0	\N
383151	1678	28800894741000	29131	14362	1	0	\N
383152	1874	9340000	29131	14362	2	0	\N
383153	1874	9344000	29131	14362	3	0	\N
383154	1874	9348000	29131	14362	4	0	\N
383155	1874	9349000	29131	14362	5	0	\N
383156	1874	9351000	29131	14362	6	0	\N
383157	1874	9353000	29131	14362	7	0	\N
383168	1678	28800894745000	29133	14364	0	0	\N
383169	1874	9374000	29133	14364	1	0	\N
383181	1678	28800894749000	29137	14367	0	0	\N
383182	1678	28800894750000	29137	14367	1	0	\N
383183	1874	9391000	29137	14367	2	0	\N
383184	1874	9392000	29137	14367	3	0	\N
383185	1874	9396000	29137	14367	4	0	\N
383186	1874	9400000	29137	14367	5	0	\N
383193	1678	28800894751000	29139	14368	0	0	\N
383194	1874	9402000	29139	14368	1	0	\N
383195	1874	9406000	29139	14368	2	0	\N
383199	1678	28800894751000	29141	14368	0	0	\N
383200	1874	9402000	29141	14368	1	0	\N
383201	1874	9406000	29141	14368	2	0	\N
383211	1678	28800894752000	29143	14369	0	0	\N
383212	1678	28800894753000	29143	14369	1	0	\N
383213	1678	28800894754000	29143	14369	2	0	\N
383214	1874	9408000	29143	14369	3	0	\N
383215	1874	9410000	29143	14369	4	0	\N
383216	1874	9411000	29143	14369	5	0	\N
383217	1874	9415000	29143	14369	6	0	\N
383218	1874	9419000	29143	14369	7	0	\N
383219	1874	9421000	29143	14369	8	0	\N
383225	1678	28800894756000	29146	14371	0	0	\N
383226	1874	9429000	29146	14371	1	0	\N
383227	1678	28800894757000	29147	14372	0	0	\N
383228	1874	9430000	29147	14372	1	0	\N
383229	1874	9434000	29147	14372	2	0	\N
383230	1874	9436000	29147	14372	3	0	\N
383140	1874	9334000	29129	14361	2	0	3
383141	1874	9336000	29129	14361	3	0	3
383142	1678	28800894740000	29130	14362	0	0	1
383143	1678	28800894741000	29130	14362	1	0	1
383144	1874	9340000	29130	14362	2	0	3
383146	1874	9348000	29130	14362	4	0	3
383147	1874	9349000	29130	14362	5	0	3
383148	1874	9351000	29130	14362	6	0	3
383149	1874	9353000	29130	14362	7	0	3
383158	1678	28800894742000	29132	14363	0	0	1
383160	1678	28800894744000	29132	14363	2	0	1
383161	1874	9355000	29132	14363	3	0	3
383162	1874	9356000	29132	14363	4	0	3
383163	1874	9358000	29132	14363	5	0	3
383165	1874	9364000	29132	14363	7	0	3
383166	1874	9368000	29132	14363	8	0	3
383167	1874	9372000	29132	14363	9	0	3
383170	1678	28800894745000	29134	14364	0	0	1
383171	1874	9374000	29134	14364	1	0	3
383173	1678	28800894747000	29135	14365	1	0	1
383174	1874	9375000	29135	14365	2	0	3
383175	1874	9377000	29135	14365	3	0	3
383176	1874	9379000	29135	14365	4	0	3
383177	1874	9383000	29135	14365	5	0	3
383179	1678	28800894748000	29136	14366	0	0	1
383180	1874	9389000	29136	14366	1	0	3
383187	1678	28800894749000	29138	14367	0	0	1
383188	1678	28800894750000	29138	14367	1	0	1
383190	1874	9392000	29138	14367	3	0	3
383191	1874	9396000	29138	14367	4	0	3
383192	1874	9400000	29138	14367	5	0	3
383196	1678	28800894751000	29140	14368	0	0	1
383197	1874	9402000	29140	14368	1	0	3
383202	1678	28800894752000	29142	14369	0	0	1
383203	1678	28800894753000	29142	14369	1	0	1
383204	1678	28800894754000	29142	14369	2	0	1
383205	1874	9408000	29142	14369	3	0	3
383206	1874	9410000	29142	14369	4	0	3
383208	1874	9415000	29142	14369	6	0	3
383209	1874	9419000	29142	14369	7	0	3
383210	1874	9421000	29142	14369	8	0	3
383220	1678	28800894755000	29144	14370	0	0	1
383222	1874	9427000	29144	14370	2	0	3
383223	1678	28800894756000	29145	14371	0	0	1
383224	1874	9429000	29145	14371	1	0	3
383231	1678	28800894757000	29148	14372	0	0	1
383232	1874	9430000	29148	14372	1	0	3
383234	1874	9436000	29148	14372	3	0	3
383235	1678	28800894758000	29149	14373	0	0	1
383236	1678	28800894759000	29149	14373	1	0	1
383237	1874	9440000	29149	14373	2	0	3
383238	1874	9444000	29149	14373	3	0	3
383240	1874	9448000	29149	14373	5	0	3
383241	1678	28800894760000	29150	14374	0	0	1
383242	1678	28800894761000	29150	14374	1	0	1
383243	1874	9450000	29150	14374	2	0	3
383245	1874	9456000	29150	14374	4	0	3
383246	1678	28800894762000	29151	14375	0	0	1
383247	1874	9458000	29151	14375	1	0	3
383248	1874	9462000	29151	14375	2	0	3
383249	1678	28800894763000	29152	14376	0	0	\N
383250	1874	9466000	29152	14376	1	0	\N
383251	1874	9468000	29152	14376	2	0	\N
383254	1678	28800894763000	29154	14376	0	0	\N
383255	1874	9466000	29154	14376	1	0	\N
383256	1874	9468000	29154	14376	2	0	\N
383266	1678	28800894764000	29156	14377	0	0	\N
383267	1678	28800894765000	29156	14377	1	0	\N
383268	1678	28800894766000	29156	14377	2	0	\N
383269	1874	9470000	29156	14377	3	0	\N
383270	1874	9472000	29156	14377	4	0	\N
383271	1874	9474000	29156	14377	5	0	\N
383272	1874	9478000	29156	14377	6	0	\N
383273	1874	9480000	29156	14377	7	0	\N
383274	1874	9482000	29156	14377	8	0	\N
383277	1678	28800894767000	29158	14378	0	0	\N
383278	1874	9484000	29158	14378	1	0	\N
383279	2408	2000000000	29159	14093	1	0	\N
383280	1464	1014000000	29159	14093	2	0	\N
383281	121	66000099000000	29159	14093	3	0	\N
383282	1726	934038112000	29159	14093	5	0	\N
383283	2411	0	29159	14093	6	0	\N
383284	2411	30000000	29159	14093	7	0	\N
383285	2411	543030000000	29159	14093	8	0	\N
383286	296	66002000000000	29159	14093	9	0	\N
383287	2412	502774774000000	29159	14093	10	0	\N
383288	1874	7531000	29159	14093	11	0	\N
383289	1874	7532000	29159	14093	12	0	\N
383290	1874	7533000	29159	14093	13	0	\N
383291	1874	7534000	29159	14093	14	0	\N
383292	2400	1693977634750000	29159	14093	15	0	\N
383293	1874	7535000	29159	14093	16	0	\N
383294	1874	7536000	29159	14093	17	0	\N
383295	1874	7537000	29159	14093	18	0	\N
383296	2413	900971464000000	29159	14093	19	0	\N
383297	1874	7538000	29159	14093	20	0	\N
383298	1874	7539000	29159	14093	21	0	\N
383299	1874	7540000	29159	14093	22	0	\N
383300	1874	7541000	29159	14093	23	0	\N
383301	1874	7542000	29159	14093	24	0	\N
383302	1874	7543000	29159	14093	25	0	\N
383303	1874	7544000	29159	14093	26	0	\N
383304	1874	7545000	29159	14093	27	0	\N
383305	1874	7546000	29159	14093	28	0	\N
383306	1874	7547000	29159	14093	29	0	\N
383307	1874	7548000	29159	14093	30	0	\N
383308	1874	7549000	29159	14093	31	0	\N
383309	1874	7550000	29159	14093	33	0	\N
383310	1874	7551000	29159	14093	34	0	\N
383311	1874	7552000	29159	14093	35	0	\N
383312	1874	7553000	29159	14093	36	0	\N
383313	1874	7554000	29159	14093	37	0	\N
383314	1874	7555000	29159	14093	38	0	\N
383315	1874	7556000	29159	14093	39	0	\N
383316	1874	7557000	29159	14093	40	0	\N
383317	1874	7558000	29159	14093	41	0	\N
383318	1874	7559000	29159	14093	42	0	\N
383319	1874	7560000	29159	14093	43	0	\N
383320	1874	7561000	29159	14093	44	0	\N
383321	1874	7562000	29159	14093	45	0	\N
383322	1678	28800894767000	29160	14378	0	0	\N
383323	1874	9484000	29160	14378	1	0	\N
383326	1678	28800894725000	29162	14247	0	0	\N
383327	1678	28800894726000	29162	14247	1	0	\N
383328	1678	28800894727000	29162	14247	2	0	\N
383329	1678	28800894728000	29162	14247	3	0	\N
383330	1678	28800894729000	29162	14247	4	0	\N
383331	1678	28800894730000	29162	14247	5	0	\N
383332	1678	28800894731000	29162	14247	6	0	\N
383333	1678	28800894732000	29162	14247	7	0	\N
383334	1678	28800894733000	29162	14247	8	0	\N
383335	1678	28800894734000	29162	14247	9	0	\N
383336	1678	28800894735000	29162	14247	10	0	\N
383337	1678	28800894736000	29162	14247	11	0	\N
383338	1678	28800894737000	29162	14247	12	0	\N
383339	1678	28800894738000	29162	14247	13	0	\N
383340	1678	28800894739000	29162	14247	14	0	\N
383341	1678	28800894740000	29162	14247	15	0	\N
383342	1678	28800894741000	29162	14247	16	0	\N
383343	1678	28800894742000	29162	14247	17	0	\N
383344	1678	28800894743000	29162	14247	18	0	\N
383345	1678	28800894744000	29162	14247	19	0	\N
383346	1678	28800894745000	29162	14247	20	0	\N
383347	1678	28800894746000	29162	14247	21	0	\N
383348	1678	28800894747000	29162	14247	22	0	\N
383349	1678	28800894748000	29162	14247	23	0	\N
383350	1678	28800894749000	29162	14247	24	0	\N
383351	1678	28800894750000	29162	14247	25	0	\N
383352	1678	28800894751000	29162	14247	26	0	\N
383353	1678	28800894752000	29162	14247	27	0	\N
383354	1678	28800894753000	29162	14247	28	0	\N
383355	1678	28800894754000	29162	14247	29	0	\N
383356	1678	28800894755000	29162	14247	30	0	\N
383357	1678	28800894756000	29162	14247	31	0	\N
383358	1678	28800894757000	29162	14247	32	0	\N
383359	1678	28800894758000	29162	14247	33	0	\N
383360	1678	28800894759000	29162	14247	34	0	\N
383361	1678	28800894760000	29162	14247	35	0	\N
383362	1678	28800894761000	29162	14247	36	0	\N
383363	1678	28800894762000	29162	14247	37	0	\N
383364	1678	28800894763000	29162	14247	38	0	\N
383365	1678	28800894764000	29162	14247	39	0	\N
383366	1678	28800894765000	29162	14247	40	0	\N
383367	1678	28800894766000	29162	14247	41	0	\N
383368	1678	28800894767000	29162	14247	42	0	\N
383369	296	66002000000000	29162	14247	43	0	\N
383370	1874	8608000	29162	14247	44	0	\N
383371	1874	8610000	29162	14247	45	0	\N
383372	1874	8612000	29162	14247	46	0	\N
383373	1874	8614000	29162	14247	47	0	\N
383374	1874	8616000	29162	14247	48	0	\N
383375	1874	8618000	29162	14247	49	0	\N
383376	1874	8620000	29162	14247	50	0	\N
383377	1874	8621000	29162	14247	51	0	\N
383378	1874	8622000	29162	14247	52	0	\N
383379	1874	8623000	29162	14247	53	0	\N
383380	1874	8627000	29162	14247	54	0	\N
383381	2415	100000000	29162	14247	55	0	\N
383382	2416	100000000	29162	14247	56	0	\N
383383	1874	8629000	29162	14247	57	0	\N
383384	1874	8631000	29162	14247	58	0	\N
383257	1678	28800894764000	29155	14377	0	0	1
383258	1678	28800894765000	29155	14377	1	0	1
383259	1678	28800894766000	29155	14377	2	0	1
383260	1874	9470000	29155	14377	3	0	3
383261	1874	9472000	29155	14377	4	0	3
383263	1874	9478000	29155	14377	6	0	3
383264	1874	9480000	29155	14377	7	0	3
383265	1874	9482000	29155	14377	8	0	3
383275	1678	28800894767000	29157	14378	0	0	1
383276	1874	9484000	29157	14378	1	0	3
383325	1874	9490000	29161	14379	1	0	3
383385	1874	8633000	29162	14247	59	0	\N
383386	1874	8635000	29162	14247	60	0	\N
383387	1874	8639000	29162	14247	61	0	\N
383388	1874	8643000	29162	14247	62	0	\N
383389	1874	8647000	29162	14247	63	0	\N
383390	1874	8651000	29162	14247	64	0	\N
383391	1874	8655000	29162	14247	65	0	\N
383392	1874	8659000	29162	14247	66	0	\N
383393	1874	8663000	29162	14247	67	0	\N
383394	1874	8667000	29162	14247	68	0	\N
383395	1874	8671000	29162	14247	69	0	\N
383396	1874	8673000	29162	14247	70	0	\N
383397	1874	8675000	29162	14247	71	0	\N
383398	1874	8677000	29162	14247	72	0	\N
383399	1874	8679000	29162	14247	73	0	\N
383400	1874	8681000	29162	14247	74	0	\N
383401	1874	8685000	29162	14247	75	0	\N
383402	1874	8689000	29162	14247	76	0	\N
383403	1874	8693000	29162	14247	77	0	\N
383404	1874	8697000	29162	14247	78	0	\N
383405	1874	8701000	29162	14247	79	0	\N
383406	1874	8705000	29162	14247	80	0	\N
383407	1874	8709000	29162	14247	81	0	\N
383408	1874	8713000	29162	14247	82	0	\N
383409	1874	8714000	29162	14247	83	0	\N
383410	1874	8715000	29162	14247	84	0	\N
383411	2417	100000000	29162	14247	85	0	\N
383412	1874	8716000	29162	14247	86	0	\N
383413	1874	8717000	29162	14247	87	0	\N
383414	1874	8718000	29162	14247	88	0	\N
383415	1874	8719000	29162	14247	89	0	\N
383416	1874	8720000	29162	14247	90	0	\N
383417	1874	8721000	29162	14247	91	0	\N
383418	1874	8722000	29162	14247	92	0	\N
383419	1874	8723000	29162	14247	93	0	\N
383420	1874	8724000	29162	14247	94	0	\N
383421	1874	8725000	29162	14247	95	0	\N
383422	1874	8726000	29162	14247	96	0	\N
383423	1874	8727000	29162	14247	97	0	\N
383424	1874	8728000	29162	14247	98	0	\N
383425	1874	8729000	29162	14247	99	0	\N
383426	1874	8730000	29162	14247	100	0	\N
383427	1874	8731000	29162	14247	101	0	\N
383428	1874	8732000	29162	14247	102	0	\N
383429	1874	8733000	29162	14247	104	0	\N
383430	1874	8734000	29162	14247	105	0	\N
383431	1874	8735000	29162	14247	106	0	\N
383432	1874	8736000	29162	14247	107	0	\N
383433	1874	8737000	29162	14247	108	0	\N
383434	1874	8738000	29162	14247	109	0	\N
383435	1874	8739000	29162	14247	110	0	\N
383436	1874	8740000	29162	14247	111	0	\N
383437	1874	8741000	29162	14247	112	0	\N
383438	1874	8742000	29162	14247	113	0	\N
383439	1874	8743000	29162	14247	114	0	\N
383440	1874	8744000	29162	14247	115	0	\N
383441	1874	8746000	29162	14247	116	0	\N
383442	1874	8748000	29162	14247	117	0	\N
383443	1874	8750000	29162	14247	118	0	\N
383444	1874	8752000	29162	14247	119	0	\N
383445	1874	8754000	29162	14247	120	0	\N
383446	1874	8756000	29162	14247	121	0	\N
383447	1874	8758000	29162	14247	122	0	\N
383448	1874	8760000	29162	14247	123	0	\N
383449	1874	8762000	29162	14247	124	0	\N
383450	1874	8764000	29162	14247	125	0	\N
383451	1874	9494000	29163	14380	0	0	\N
383452	1874	9496000	29163	14380	1	0	\N
383455	1874	9494000	29165	14380	0	0	\N
383456	1874	9496000	29165	14380	1	0	\N
383457	1874	9494000	29167	14380	0	0	\N
383458	1874	9496000	29167	14380	1	0	\N
383459	1678	28800894768000	29168	14381	0	0	\N
383460	1678	28800894769000	29168	14381	1	0	\N
383461	1678	28800894770000	29168	14381	2	0	\N
383462	1874	9500000	29168	14381	3	0	\N
383463	1874	9504000	29168	14381	4	0	\N
383472	1678	28800894768000	29170	14381	0	0	\N
383473	1678	28800894769000	29170	14381	1	0	\N
383474	1678	28800894770000	29170	14381	2	0	\N
383475	1874	9500000	29170	14381	3	0	\N
383476	1874	9504000	29170	14381	4	0	\N
383477	1678	28800894768000	29171	14381	0	0	\N
383478	1678	28800894769000	29171	14381	1	0	\N
383479	1678	28800894770000	29171	14381	2	0	\N
383480	1678	28800894768000	29172	14381	0	0	\N
383481	1678	28800894769000	29172	14381	1	0	\N
383482	1678	28800894770000	29172	14381	2	0	\N
383483	1874	9500000	29172	14381	3	0	\N
383484	1874	9504000	29172	14381	4	0	\N
383485	1874	9506000	29172	14381	5	0	\N
383486	1874	9508000	29172	14381	6	0	\N
383487	1874	9510000	29172	14381	7	0	\N
383491	1678	28800894771000	29174	14382	0	0	\N
383492	1874	9512000	29174	14382	1	0	\N
383493	1874	9516000	29174	14382	2	0	\N
383499	1678	28800894774000	29177	14385	0	0	\N
383500	1874	9528000	29177	14385	1	0	\N
383501	1874	9530000	29177	14385	2	0	\N
383505	1678	28800894775000	29179	14386	0	0	\N
383506	1874	9532000	29179	14386	1	0	\N
383507	1874	9536000	29179	14386	2	0	\N
383508	1678	28800894775000	29180	14386	0	0	\N
383509	1874	9532000	29180	14386	1	0	\N
383510	1874	9536000	29180	14386	2	0	\N
383514	121	66000099000000	29182	14277	2	0	\N
383515	1726	123027112000	29182	14277	3	0	\N
383516	296	66002000000000	29182	14277	4	0	\N
383517	2417	100000000	29182	14277	5	0	\N
383520	1678	28800894758000	29184	14373	0	0	\N
383464	1678	28800894768000	29169	14381	0	0	1
383465	1678	28800894769000	29169	14381	1	0	1
383466	1678	28800894770000	29169	14381	2	0	1
383467	1874	9500000	29169	14381	3	0	3
383468	1874	9504000	29169	14381	4	0	3
383470	1874	9508000	29169	14381	6	0	3
383471	1874	9510000	29169	14381	7	0	3
383488	1678	28800894771000	29173	14382	0	0	1
383489	1874	9512000	29173	14382	1	0	3
383490	1874	9516000	29173	14382	2	0	3
383495	1874	9520000	29175	14383	1	0	3
383496	1874	9522000	29175	14383	2	0	3
383497	1678	28800894773000	29176	14384	0	0	1
383498	1874	9524000	29176	14384	1	0	3
383503	1874	9528000	29178	14385	1	0	3
383504	1874	9530000	29178	14385	2	0	3
383511	1678	28800894775000	29181	14386	0	0	1
383512	1874	9532000	29181	14386	1	0	3
383513	1874	9536000	29181	14386	2	0	3
383519	1874	9538000	29183	14387	1	0	3
383521	1678	28800894759000	29184	14373	1	0	\N
383522	1678	28800894760000	29184	14373	2	0	\N
383523	1678	28800894761000	29184	14373	3	0	\N
383524	1678	28800894762000	29184	14373	4	0	\N
383525	1678	28800894763000	29184	14373	5	0	\N
383526	1678	28800894764000	29184	14373	6	0	\N
383527	1678	28800894765000	29184	14373	7	0	\N
383528	1678	28800894766000	29184	14373	8	0	\N
383529	1678	28800894767000	29184	14373	9	0	\N
383530	1678	28800894768000	29184	14373	10	0	\N
383531	1678	28800894769000	29184	14373	11	0	\N
383532	1678	28800894770000	29184	14373	12	0	\N
383533	1678	28800894771000	29184	14373	13	0	\N
383534	1678	28800894772000	29184	14373	14	0	\N
383535	1678	28800894773000	29184	14373	15	0	\N
383536	1678	28800894774000	29184	14373	16	0	\N
383537	1678	28800894775000	29184	14373	17	0	\N
383538	1874	9440000	29184	14373	18	0	\N
383539	1874	9444000	29184	14373	19	0	\N
383540	1874	9446000	29184	14373	20	0	\N
383541	1874	9450000	29184	14373	21	0	\N
383542	1874	9454000	29184	14373	22	0	\N
383543	1874	9458000	29184	14373	23	0	\N
383544	1874	9462000	29184	14373	24	0	\N
383545	1874	9466000	29184	14373	25	0	\N
383546	1874	9470000	29184	14373	26	0	\N
383547	1874	9474000	29184	14373	27	0	\N
383548	1874	9478000	29184	14373	28	0	\N
383549	1874	9482000	29184	14373	29	0	\N
383550	1874	9484000	29184	14373	30	0	\N
383551	1874	9486000	29184	14373	31	0	\N
383552	1874	9488000	29184	14373	32	0	\N
383553	1874	9490000	29184	14373	33	0	\N
383554	1874	9492000	29184	14373	34	0	\N
383555	1874	9494000	29184	14373	35	0	\N
383556	1874	9496000	29184	14373	36	0	\N
383557	1874	9498000	29184	14373	37	0	\N
383558	1874	9502000	29184	14373	38	0	\N
383559	1874	9504000	29184	14373	39	0	\N
383560	1874	9506000	29184	14373	40	0	\N
383561	1874	9508000	29184	14373	41	0	\N
383562	1874	9510000	29184	14373	42	0	\N
383563	1874	9512000	29184	14373	43	0	\N
383564	1874	9514000	29184	14373	44	0	\N
383565	1874	9516000	29184	14373	45	0	\N
383566	1874	9520000	29184	14373	46	0	\N
383567	1874	9524000	29184	14373	47	0	\N
383568	1874	9528000	29184	14373	48	0	\N
383569	1874	9530000	29184	14373	49	0	\N
383570	1874	9532000	29184	14373	50	0	\N
383571	1874	9534000	29184	14373	51	0	\N
383572	1874	9536000	29184	14373	52	0	\N
383573	1874	9538000	29184	14373	53	0	\N
383580	1678	28800894777000	29186	14388	0	0	\N
383581	1678	28800894778000	29186	14388	1	0	\N
383582	1874	9542000	29186	14388	2	0	\N
383583	1874	9546000	29186	14388	3	0	\N
383584	1874	9548000	29186	14388	4	0	\N
383585	1874	9550000	29186	14388	5	0	\N
383586	1678	28800894777000	29187	14388	0	0	\N
383587	1678	28800894778000	29187	14388	1	0	\N
383588	1874	9542000	29187	14388	2	0	\N
383589	1874	9546000	29187	14388	3	0	\N
383590	1874	9548000	29187	14388	4	0	\N
383591	1874	9550000	29187	14388	5	0	\N
383597	1678	28800894781000	29190	14391	0	0	\N
383598	1874	9560000	29190	14391	1	0	\N
383599	1874	9561000	29190	14391	2	0	\N
383600	1874	9565000	29190	14391	3	0	\N
383601	1678	28800894781000	29191	14391	0	0	\N
383602	1874	9560000	29191	14391	1	0	\N
383603	1874	9561000	29191	14391	2	0	\N
383604	1874	9565000	29191	14391	3	0	\N
383609	1678	28800894782000	29194	14392	0	0	\N
383610	1678	28800894783000	29194	14392	1	0	\N
383611	1874	9567000	29194	14392	2	0	\N
383612	1874	9569000	29194	14392	3	0	\N
383613	1874	9573000	29194	14392	4	0	\N
383619	1678	28800894782000	29196	14392	0	0	\N
383620	1678	28800894783000	29196	14392	1	0	\N
383621	1874	9569000	29196	14392	2	0	\N
383626	1678	28800894785000	29198	14394	0	0	\N
383627	1678	28800894786000	29198	14394	1	0	\N
383628	1678	28800894787000	29198	14394	2	0	\N
383629	1874	9582000	29198	14394	3	0	\N
383630	1874	9584000	29198	14394	4	0	\N
383631	1874	9586000	29198	14394	5	0	\N
383632	1874	9590000	29198	14394	7	0	\N
383633	1874	9594000	29198	14394	8	0	\N
383634	1678	28800894785000	29199	14394	0	0	\N
383635	1678	28800894786000	29199	14394	1	0	\N
383636	1678	28800894787000	29199	14394	2	0	\N
383637	1874	9582000	29199	14394	3	0	\N
383638	1874	9584000	29199	14394	4	0	\N
383639	1874	9586000	29199	14394	5	0	\N
383640	1874	9590000	29199	14394	7	0	\N
383641	1874	9594000	29199	14394	8	0	\N
383642	1678	28800894785000	29200	14394	0	0	\N
383643	1678	28800894786000	29200	14394	1	0	\N
383644	1678	28800894787000	29200	14394	2	0	\N
383645	1874	9582000	29200	14394	3	0	\N
383646	1874	9584000	29200	14394	4	0	\N
383647	1874	9586000	29200	14394	5	0	\N
383648	1874	9590000	29200	14394	7	0	\N
383649	1874	9594000	29200	14394	8	0	\N
383650	1678	28800894785000	29201	14394	0	0	\N
383651	1678	28800894786000	29201	14394	1	0	\N
383652	1678	28800894787000	29201	14394	2	0	\N
383653	1874	9582000	29201	14394	3	0	\N
383654	1874	9584000	29201	14394	4	0	\N
383655	1874	9586000	29201	14394	5	0	\N
383656	1874	9590000	29201	14394	7	0	\N
383576	1874	9542000	29185	14388	2	0	3
383577	1874	9546000	29185	14388	3	0	3
383578	1874	9548000	29185	14388	4	0	3
383579	1874	9550000	29185	14388	5	0	3
383592	1678	28800894779000	29188	14389	0	0	1
383594	1874	9556000	29188	14389	2	0	3
383595	1678	28800894780000	29189	14390	0	0	1
383596	1874	9558000	29189	14390	1	0	3
383605	1678	28800894781000	29192	14391	0	0	1
383606	1874	9560000	29192	14391	1	0	3
383608	1874	9565000	29192	14391	3	0	3
383614	1678	28800894782000	29195	14392	0	0	1
383615	1678	28800894783000	29195	14392	1	0	1
383616	1874	9567000	29195	14392	2	0	3
383618	1874	9573000	29195	14392	4	0	3
383622	1678	28800894784000	29197	14393	0	0	1
383623	1874	9575000	29197	14393	1	0	3
383624	1874	9576000	29197	14393	2	0	3
383625	1874	9580000	29197	14393	3	0	3
383657	1874	9594000	29201	14394	8	0	\N
383658	1678	28800894785000	29202	14394	0	0	\N
383659	1678	28800894786000	29202	14394	1	0	\N
383660	1678	28800894787000	29202	14394	2	0	\N
383661	1874	9582000	29202	14394	3	0	\N
383662	1874	9584000	29202	14394	4	0	\N
383663	1874	9586000	29202	14394	5	0	\N
383664	1874	9590000	29202	14394	7	0	\N
383665	1874	9594000	29202	14394	8	0	\N
383672	1678	28800894785000	29204	14394	0	0	\N
383673	1678	28800894786000	29204	14394	1	0	\N
383674	1678	28800894787000	29204	14394	2	0	\N
383675	1874	9582000	29204	14394	3	0	\N
383676	1874	9584000	29204	14394	4	0	\N
383677	1874	9586000	29204	14394	5	0	\N
383678	1874	9590000	29204	14394	7	0	\N
383679	1874	9594000	29204	14394	8	0	\N
383680	1678	28800894788000	29205	14395	0	0	\N
383681	1874	9588000	29205	14395	1	0	\N
383682	1874	9589000	29205	14395	2	0	\N
383683	1874	9593000	29205	14395	3	0	\N
383684	1874	9597000	29205	14395	4	0	\N
383685	1874	9601000	29205	14395	5	0	\N
383692	1678	28800894788000	29207	14395	0	0	\N
383693	1874	9588000	29207	14395	1	0	\N
383694	1874	9589000	29207	14395	2	0	\N
383695	1874	9593000	29207	14395	3	0	\N
383696	1874	9597000	29207	14395	4	0	\N
383697	1874	9601000	29207	14395	5	0	\N
383698	1678	28800894738000	29208	14361	0	0	\N
383699	1678	28800894739000	29208	14361	1	0	\N
383700	1678	28800894740000	29208	14361	2	0	\N
383701	1678	28800894741000	29208	14361	3	0	\N
383702	1678	28800894742000	29208	14361	4	0	\N
383703	1678	28800894743000	29208	14361	5	0	\N
383704	1678	28800894744000	29208	14361	6	0	\N
383705	1678	28800894745000	29208	14361	7	0	\N
383706	1678	28800894746000	29208	14361	8	0	\N
383707	1678	28800894747000	29208	14361	9	0	\N
383708	1678	28800894748000	29208	14361	10	0	\N
383709	1678	28800894749000	29208	14361	11	0	\N
383710	1678	28800894750000	29208	14361	12	0	\N
383711	1678	28800894751000	29208	14361	13	0	\N
383712	1678	28800894752000	29208	14361	14	0	\N
383713	1678	28800894753000	29208	14361	15	0	\N
383714	1678	28800894754000	29208	14361	16	0	\N
383715	1678	28800894755000	29208	14361	17	0	\N
383716	1678	28800894756000	29208	14361	18	0	\N
383717	1678	28800894757000	29208	14361	19	0	\N
383718	1678	28800894758000	29208	14361	20	0	\N
383719	1678	28800894759000	29208	14361	21	0	\N
383720	1678	28800894760000	29208	14361	22	0	\N
383721	1678	28800894761000	29208	14361	23	0	\N
383722	1678	28800894762000	29208	14361	24	0	\N
383723	1678	28800894763000	29208	14361	25	0	\N
383724	1678	28800894764000	29208	14361	26	0	\N
383725	1678	28800894765000	29208	14361	27	0	\N
383726	1678	28800894766000	29208	14361	28	0	\N
383727	1678	28800894767000	29208	14361	29	0	\N
383728	1678	28800894768000	29208	14361	30	0	\N
383729	1678	28800894769000	29208	14361	31	0	\N
383730	1678	28800894770000	29208	14361	32	0	\N
383731	1678	28800894771000	29208	14361	33	0	\N
383732	1678	28800894772000	29208	14361	34	0	\N
383733	1678	28800894773000	29208	14361	35	0	\N
383734	1678	28800894774000	29208	14361	36	0	\N
383735	1678	28800894775000	29208	14361	37	0	\N
383736	1678	28800894776000	29208	14361	38	0	\N
383737	1678	28800894777000	29208	14361	39	0	\N
383738	1678	28800894778000	29208	14361	40	0	\N
383739	1678	28800894779000	29208	14361	41	0	\N
383740	1678	28800894780000	29208	14361	42	0	\N
383741	1678	28800894781000	29208	14361	43	0	\N
383742	1678	28800894782000	29208	14361	44	0	\N
383743	1678	28800894783000	29208	14361	45	0	\N
383744	1678	28800894784000	29208	14361	46	0	\N
383745	1678	28800894785000	29208	14361	47	0	\N
383746	1678	28800894786000	29208	14361	48	0	\N
383747	1678	28800894787000	29208	14361	49	0	\N
383748	1678	28800894788000	29208	14361	50	0	\N
383749	1874	9336000	29208	14361	51	0	\N
383750	1874	9340000	29208	14361	52	0	\N
383751	1874	9344000	29208	14361	53	0	\N
383752	1874	9345000	29208	14361	54	0	\N
383753	1874	9346000	29208	14361	55	0	\N
383754	1874	9347000	29208	14361	56	0	\N
383755	1874	9348000	29208	14361	57	0	\N
383756	1874	9349000	29208	14361	58	0	\N
383757	1874	9350000	29208	14361	59	0	\N
383758	1874	9351000	29208	14361	60	0	\N
383759	1874	9352000	29208	14361	61	0	\N
383760	1874	9353000	29208	14361	62	0	\N
383761	1874	9357000	29208	14361	63	0	\N
383762	1874	9361000	29208	14361	64	0	\N
383763	1874	9365000	29208	14361	65	0	\N
383764	1874	9369000	29208	14361	66	0	\N
383765	1874	9373000	29208	14361	67	0	\N
383766	1874	9377000	29208	14361	68	0	\N
383767	1874	9381000	29208	14361	69	0	\N
383768	1874	9385000	29208	14361	70	0	\N
383769	1874	9389000	29208	14361	71	0	\N
383770	1874	9393000	29208	14361	72	0	\N
383771	1874	9397000	29208	14361	73	0	\N
383772	1874	9401000	29208	14361	74	0	\N
383773	1874	9405000	29208	14361	75	0	\N
383774	1874	9409000	29208	14361	76	0	\N
383775	1874	9413000	29208	14361	77	0	\N
383776	1874	9417000	29208	14361	78	0	\N
383777	1874	9421000	29208	14361	79	0	\N
383778	1874	9425000	29208	14361	80	0	\N
383779	1874	9429000	29208	14361	81	0	\N
383780	1874	9433000	29208	14361	82	0	\N
383781	1874	9437000	29208	14361	84	0	\N
383782	1874	9441000	29208	14361	85	0	\N
383783	1874	9445000	29208	14361	86	0	\N
383784	1874	9449000	29208	14361	87	0	\N
383785	1874	9451000	29208	14361	88	0	\N
383786	1874	9453000	29208	14361	89	0	\N
383787	1874	9455000	29208	14361	90	0	\N
383788	1874	9457000	29208	14361	91	0	\N
383789	1874	9459000	29208	14361	92	0	\N
383790	1874	9461000	29208	14361	93	0	\N
383791	1874	9463000	29208	14361	94	0	\N
383792	1874	9465000	29208	14361	95	0	\N
383668	1678	28800894787000	29203	14394	2	0	1
383669	1874	9582000	29203	14394	3	0	3
383670	1874	9584000	29203	14394	4	0	3
383671	1874	9586000	29203	14394	5	0	3
383686	1678	28800894788000	29206	14395	0	0	1
383688	1874	9589000	29206	14395	2	0	3
383689	1874	9593000	29206	14395	3	0	3
383690	1874	9597000	29206	14395	4	0	3
383691	1874	9601000	29206	14395	5	0	3
383793	1874	9467000	29208	14361	96	0	\N
383794	1874	9469000	29208	14361	97	0	\N
383795	1874	9471000	29208	14361	98	0	\N
383796	1874	9473000	29208	14361	99	0	\N
383797	1874	9475000	29208	14361	100	0	\N
383798	1874	9477000	29208	14361	101	0	\N
383799	1874	9479000	29208	14361	102	0	\N
383800	1874	9481000	29208	14361	103	0	\N
383801	1874	9483000	29208	14361	104	0	\N
383802	1874	9485000	29208	14361	105	0	\N
383803	1874	9487000	29208	14361	106	0	\N
383804	1874	9489000	29208	14361	107	0	\N
383805	1874	9491000	29208	14361	108	0	\N
383806	1874	9493000	29208	14361	109	0	\N
383807	1874	9495000	29208	14361	110	0	\N
383808	1874	9497000	29208	14361	111	0	\N
383809	1874	9499000	29208	14361	112	0	\N
383810	1874	9501000	29208	14361	113	0	\N
383811	1874	9503000	29208	14361	114	0	\N
383812	1874	9505000	29208	14361	115	0	\N
383813	1874	9507000	29208	14361	116	0	\N
383814	1874	9509000	29208	14361	117	0	\N
383815	1874	9511000	29208	14361	118	0	\N
383816	1874	9513000	29208	14361	119	0	\N
383817	1874	9515000	29208	14361	120	0	\N
383818	1874	9517000	29208	14361	121	0	\N
383819	1874	9519000	29208	14361	122	0	\N
383820	1874	9523000	29208	14361	123	0	\N
383821	1874	9527000	29208	14361	124	0	\N
383822	1874	9531000	29208	14361	125	0	\N
383826	1678	28800894789000	29210	14396	0	0	\N
383827	1874	9605000	29210	14396	1	0	\N
383828	1874	9607000	29210	14396	2	0	\N
383829	1678	28800894789000	29211	14396	0	0	\N
383830	1874	9605000	29211	14396	1	0	\N
383831	1874	9607000	29211	14396	2	0	\N
383832	1678	28800894790000	29212	14397	0	0	\N
383833	1874	9611000	29212	14397	1	0	\N
383834	1874	9613000	29212	14397	2	0	\N
383837	1678	28800894791000	29214	14398	0	0	\N
383838	1874	9611000	29214	14398	1	0	\N
383839	1874	9612000	29214	14398	2	0	\N
383840	1874	9616000	29214	14398	3	0	\N
383848	1678	28800894792000	29217	14399	0	0	\N
383849	1874	9620000	29217	14399	1	0	\N
383850	1874	9622000	29217	14399	2	0	\N
383851	1874	9620000	29218	14399	0	0	\N
383852	1874	9622000	29218	14399	1	0	\N
383853	1678	28800894793000	29219	14400	0	0	\N
383854	1874	9626000	29219	14400	1	0	\N
383858	1678	28800894793000	29221	14400	0	0	\N
383859	1874	9624000	29221	14400	1	0	\N
383860	1874	9628000	29221	14400	2	0	\N
383861	1678	28800894794000	29222	14401	0	0	\N
383862	1874	9629000	29222	14401	1	0	\N
383866	1678	28800894794000	29224	14401	0	0	\N
383867	1874	9629000	29224	14401	1	0	\N
383868	1874	9631000	29224	14401	2	0	\N
383869	1678	28800894795000	29225	14402	0	0	\N
383870	1874	9635000	29225	14402	1	0	\N
383871	1874	9637000	29225	14402	2	0	\N
383872	1678	28800894795000	29226	14402	0	0	\N
383873	1874	9635000	29226	14402	1	0	\N
383874	1874	9637000	29226	14402	2	0	\N
383878	1678	28800894796000	29228	14403	0	0	\N
383879	1678	28800894797000	29228	14403	1	0	\N
383880	1874	9641000	29228	14403	2	0	\N
383881	1874	9643000	29228	14403	3	0	\N
383882	1874	9645000	29228	14403	4	0	\N
383892	1678	28800894798000	29231	14404	0	0	\N
383893	1874	9647000	29231	14404	1	0	\N
383894	1874	9651000	29231	14404	2	0	\N
383895	1874	9652000	29231	14404	3	0	\N
383912	1678	28800894804000	29235	14408	0	0	\N
383913	1874	9680000	29235	14408	1	0	\N
383914	1874	9682000	29235	14408	2	0	\N
383915	1874	9686000	29235	14408	3	0	\N
383916	1678	28800894804000	29236	14408	0	0	\N
383917	1874	9680000	29236	14408	1	0	\N
383918	1874	9682000	29236	14408	2	0	\N
383919	1874	9686000	29236	14408	3	0	\N
383920	1678	28800894804000	29237	14408	0	0	\N
383921	1874	9680000	29237	14408	1	0	\N
383922	1874	9682000	29237	14408	2	0	\N
383923	1874	9686000	29237	14408	3	0	\N
383928	1678	28800894804000	29239	14408	0	0	\N
383825	1874	9607000	29209	14396	2	0	3
383835	1678	28800894790000	29213	14397	0	0	1
383836	1874	9609000	29213	14397	1	0	3
383841	1678	28800894791000	29215	14398	0	0	1
383842	1874	9611000	29215	14398	1	0	3
383844	1874	9616000	29215	14398	3	0	3
383845	1678	28800894792000	29216	14399	0	0	1
383846	1874	9620000	29216	14399	1	0	3
383847	1874	9622000	29216	14399	2	0	3
383855	1678	28800894793000	29220	14400	0	0	1
383857	1874	9628000	29220	14400	2	0	3
383863	1678	28800894794000	29223	14401	0	0	1
383864	1874	9629000	29223	14401	1	0	3
383865	1874	9631000	29223	14401	2	0	3
383876	1874	9635000	29227	14402	1	0	3
383877	1874	9637000	29227	14402	2	0	3
383883	1678	28800894796000	29229	14403	0	0	1
383884	1678	28800894797000	29229	14403	1	0	1
383885	1874	9641000	29229	14403	2	0	3
383887	1874	9645000	29229	14403	4	0	3
383888	1678	28800894798000	29230	14404	0	0	1
383889	1874	9647000	29230	14404	1	0	3
383890	1874	9651000	29230	14404	2	0	3
383891	1874	9652000	29230	14404	3	0	3
383897	1874	9656000	29232	14405	1	0	3
383898	1874	9658000	29232	14405	2	0	3
383899	1678	28800894800000	29233	14406	0	0	1
383900	1678	28800894801000	29233	14406	1	0	1
383902	1874	9661000	29233	14406	3	0	3
383903	1874	9665000	29233	14406	4	0	3
383904	1874	9667000	29233	14406	5	0	3
383905	1678	28800894802000	29234	14407	0	0	1
383906	1678	28800894803000	29234	14407	1	0	1
383908	1874	9669000	29234	14407	3	0	3
383909	1874	9671000	29234	14407	4	0	3
383910	1874	9675000	29234	14407	5	0	3
383911	1874	9679000	29234	14407	6	0	3
383924	1678	28800894804000	29238	14408	0	0	1
383926	1874	9682000	29238	14408	2	0	3
383927	1874	9686000	29238	14408	3	0	3
383929	1874	9680000	29239	14408	1	0	\N
383930	1874	9682000	29239	14408	2	0	\N
383931	1874	9686000	29239	14408	3	0	\N
383937	1678	28800894807000	29242	14411	0	0	\N
383938	1874	9696000	29242	14411	1	0	\N
383939	1874	9700000	29242	14411	2	0	\N
383943	1678	28800894807000	29244	14411	0	0	\N
383944	1874	9696000	29244	14411	1	0	\N
383945	1874	9700000	29244	14411	2	0	\N
383959	1678	28800894811000	29248	14414	0	0	\N
383960	1874	9717000	29248	14414	1	0	\N
383961	1874	9718000	29248	14414	2	0	\N
383962	1874	9722000	29248	14414	3	0	\N
383963	1678	28800894811000	29249	14414	0	0	\N
383964	1874	9716000	29249	14414	1	0	\N
383965	1874	9720000	29249	14414	2	0	\N
383966	1678	28800894812000	29250	14415	0	0	\N
383967	1874	9724000	29250	14415	1	0	\N
383977	1678	28800894815000	29254	14418	0	0	\N
383978	1874	9739000	29254	14418	1	0	\N
383979	1874	9743000	29254	14418	2	0	\N
383982	1678	28800894816000	29256	14419	0	0	\N
383983	1874	9743000	29256	14419	1	0	\N
383984	1874	9745000	29256	14419	2	0	\N
383991	1678	28800894817000	29259	14420	0	0	\N
383992	1874	9747000	29259	14420	1	0	\N
383993	1874	9751000	29259	14420	2	0	\N
384013	1678	28800894820000	29263	14423	0	0	\N
384014	1678	28800894821000	29263	14423	1	0	\N
384015	1678	28800894822000	29263	14423	2	0	\N
384016	1678	28800894823000	29263	14423	3	0	\N
384017	1874	9764000	29263	14423	4	0	\N
384018	1874	9768000	29263	14423	5	0	\N
384019	1874	9772000	29263	14423	6	0	\N
384020	1874	9774000	29263	14423	7	0	\N
384021	1874	9776000	29263	14423	8	0	\N
384022	1874	9778000	29263	14423	9	0	\N
384023	1874	9780000	29263	14423	10	0	\N
384024	1874	9781000	29263	14423	11	0	\N
384025	1678	28800894820000	29264	14423	0	0	\N
384026	1678	28800894821000	29264	14423	1	0	\N
384027	1678	28800894822000	29264	14423	2	0	\N
384028	1678	28800894823000	29264	14423	3	0	\N
384029	1874	9764000	29264	14423	4	0	\N
384030	1874	9768000	29264	14423	5	0	\N
384031	1874	9772000	29264	14423	6	0	\N
384032	1874	9774000	29264	14423	7	0	\N
384033	1874	9776000	29264	14423	8	0	\N
384034	1874	9778000	29264	14423	9	0	\N
384035	1874	9780000	29264	14423	10	0	\N
384036	1874	9781000	29264	14423	11	0	\N
384041	121	66000099000000	29266	14309	1	0	\N
384042	596	84178432000000	29266	14309	2	0	\N
384043	1726	121926112000	29266	14309	3	0	\N
384044	2403	1428994500000	29266	14309	4	0	\N
384045	1678	28800894825000	29267	14425	0	0	\N
384046	1678	28800894826000	29267	14425	1	0	\N
384047	1874	9792000	29267	14425	2	0	\N
384048	1874	9796000	29267	14425	3	0	\N
384049	1874	9798000	29267	14425	4	0	\N
384050	1874	9800000	29267	14425	5	0	\N
384051	1678	28800894825000	29268	14425	0	0	\N
384052	1678	28800894826000	29268	14425	1	0	\N
384053	1874	9792000	29268	14425	2	0	\N
384054	1874	9796000	29268	14425	3	0	\N
383934	1678	28800894806000	29241	14410	0	0	1
383935	1874	9690000	29241	14410	1	0	3
383936	1874	9694000	29241	14410	2	0	3
383940	1678	28800894807000	29243	14411	0	0	1
383941	1874	9696000	29243	14411	1	0	3
383946	1678	28800894808000	29245	14412	0	0	1
383947	1874	9702000	29245	14412	1	0	3
383948	1874	9703000	29245	14412	2	0	3
383949	1678	28800894809000	29246	14413	0	0	1
383950	1678	28800894810000	29246	14413	1	0	1
383952	1874	9711000	29246	14413	3	0	3
383953	1874	9713000	29246	14413	4	0	3
383954	1874	9715000	29246	14413	5	0	3
383955	1678	28800894811000	29247	14414	0	0	1
383957	1874	9718000	29247	14414	2	0	3
383958	1874	9722000	29247	14414	3	0	3
383968	1678	28800894812000	29251	14415	0	0	1
383969	1874	9724000	29251	14415	1	0	3
383970	1678	28800894813000	29252	14416	0	0	1
383972	1874	9730000	29252	14416	2	0	3
383973	1678	28800894814000	29253	14417	0	0	1
383974	1874	9734000	29253	14417	1	0	3
383975	1874	9736000	29253	14417	2	0	3
383976	1874	9737000	29253	14417	3	0	3
383981	1874	9741000	29255	14418	1	0	3
383985	1678	28800894816000	29257	14419	0	0	1
383986	1874	9743000	29257	14419	1	0	3
383987	1874	9745000	29257	14419	2	0	3
383989	1874	9747000	29258	14420	1	0	3
383990	1874	9751000	29258	14420	2	0	3
383994	1874	9755000	29260	14421	0	0	3
383995	1874	9757000	29260	14421	1	0	3
383996	1874	9758000	29260	14421	2	0	3
383998	596	84178432000000	29261	14422	1	0	8
383999	1678	28800894819000	29261	14422	2	0	1
384000	1874	9760000	29261	14422	3	0	3
384001	1678	28800894820000	29262	14423	0	0	1
384002	1678	28800894821000	29262	14423	1	0	1
384004	1678	28800894823000	29262	14423	3	0	1
384005	1874	9764000	29262	14423	4	0	3
384006	1874	9768000	29262	14423	5	0	3
384007	1874	9772000	29262	14423	6	0	3
384009	1874	9776000	29262	14423	8	0	3
384010	1874	9778000	29262	14423	9	0	3
384011	1874	9780000	29262	14423	10	0	3
384012	1874	9781000	29262	14423	11	0	3
384037	1678	28800894824000	29265	14424	0	0	1
384039	1874	9786000	29265	14424	2	0	3
384040	1874	9788000	29265	14424	3	0	3
384055	1678	28800894825000	29269	14425	0	0	1
384056	1678	28800894826000	29269	14425	1	0	1
384057	1874	9792000	29269	14425	2	0	3
384059	1874	9798000	29269	14425	4	0	3
384060	1874	9800000	29269	14425	5	0	3
384061	1678	28800894827000	29270	14426	0	0	1
384062	1678	28800894828000	29270	14426	1	0	1
384064	1678	28800894830000	29270	14426	3	0	1
384073	596	84178432000000	29271	14248	0	0	\N
384074	1678	28800894768000	29271	14248	1	0	\N
384075	1678	28800894769000	29271	14248	2	0	\N
384076	1678	28800894770000	29271	14248	3	0	\N
384077	1678	28800894771000	29271	14248	4	0	\N
384078	1678	28800894772000	29271	14248	5	0	\N
384079	1678	28800894773000	29271	14248	6	0	\N
384080	1678	28800894774000	29271	14248	7	0	\N
384081	1678	28800894775000	29271	14248	8	0	\N
384082	1678	28800894776000	29271	14248	9	0	\N
384083	1678	28800894777000	29271	14248	10	0	\N
384084	1678	28800894778000	29271	14248	11	0	\N
384085	1678	28800894779000	29271	14248	12	0	\N
384086	1678	28800894780000	29271	14248	13	0	\N
384087	1678	28800894781000	29271	14248	14	0	\N
384088	1678	28800894782000	29271	14248	15	0	\N
384089	1678	28800894783000	29271	14248	16	0	\N
384090	1678	28800894784000	29271	14248	17	0	\N
384091	1678	28800894785000	29271	14248	18	0	\N
384092	1678	28800894786000	29271	14248	19	0	\N
384093	1678	28800894827000	29272	14426	0	0	\N
384094	1678	28800894828000	29272	14426	1	0	\N
384095	1678	28800894829000	29272	14426	2	0	\N
384096	1678	28800894830000	29272	14426	3	0	\N
384097	1874	9802000	29272	14426	4	0	\N
384098	1874	9803000	29272	14426	5	0	\N
384099	1874	9805000	29272	14426	6	0	\N
384100	1874	9807000	29272	14426	7	0	\N
384101	1874	9809000	29272	14426	8	0	\N
384102	1874	9813000	29272	14426	9	0	\N
384103	1874	9817000	29272	14426	10	0	\N
384104	1874	9821000	29272	14426	11	0	\N
384111	1540	0	29274	14303	0	0	\N
384112	121	66000099000000	29274	14303	2	0	\N
384113	596	84178432000000	29274	14303	3	0	\N
384114	1726	121926112000	29274	14303	4	0	\N
384115	1678	28800894657000	29274	14303	5	0	\N
384116	1678	28800894658000	29274	14303	6	0	\N
384117	1678	28800894659000	29274	14303	7	0	\N
384118	1678	28800894660000	29274	14303	8	0	\N
384119	1678	28800894661000	29274	14303	9	0	\N
384120	1678	28800894662000	29274	14303	10	0	\N
384121	1678	28800894663000	29274	14303	11	0	\N
384122	1678	28800894664000	29274	14303	12	0	\N
384123	1678	28800894665000	29274	14303	13	0	\N
384124	1678	28800894666000	29274	14303	14	0	\N
384125	1678	28800894667000	29274	14303	15	0	\N
384126	1678	28800894668000	29274	14303	16	0	\N
384127	1678	28800894669000	29274	14303	17	0	\N
384128	1678	28800894670000	29274	14303	18	0	\N
384129	1678	28800894671000	29274	14303	19	0	\N
384130	1678	28800894672000	29274	14303	20	0	\N
384131	1678	28800894673000	29274	14303	21	0	\N
384132	1678	28800894674000	29274	14303	22	0	\N
384133	1678	28800894675000	29274	14303	23	0	\N
384134	1678	28800894676000	29274	14303	24	0	\N
384135	1678	28800894677000	29274	14303	25	0	\N
384136	1678	28800894678000	29274	14303	26	0	\N
384137	1678	28800894679000	29274	14303	27	0	\N
384138	1678	28800894680000	29274	14303	28	0	\N
384139	1678	28800894681000	29274	14303	29	0	\N
384140	1678	28800894682000	29274	14303	30	0	\N
384141	1678	28800894683000	29274	14303	31	0	\N
384142	1678	28800894684000	29274	14303	32	0	\N
384143	1678	28800894685000	29274	14303	33	0	\N
384144	1678	28800894686000	29274	14303	34	0	\N
384145	1678	28800894687000	29274	14303	35	0	\N
384146	1678	28800894688000	29274	14303	36	0	\N
384147	1678	28800894689000	29274	14303	37	0	\N
384148	1678	28800894690000	29274	14303	38	0	\N
384149	1678	28800894691000	29274	14303	39	0	\N
384150	1678	28800894692000	29274	14303	40	0	\N
384151	1678	28800894693000	29274	14303	41	0	\N
384152	1678	28800894694000	29274	14303	42	0	\N
384153	1678	28800894695000	29274	14303	43	0	\N
384154	1678	28800894696000	29274	14303	44	0	\N
384155	1678	28800894697000	29274	14303	45	0	\N
384156	1678	28800894698000	29274	14303	46	0	\N
384157	1678	28800894699000	29274	14303	47	0	\N
384158	1678	28800894700000	29274	14303	48	0	\N
384159	1678	28800894701000	29274	14303	49	0	\N
384160	1678	28800894702000	29274	14303	50	0	\N
384161	1678	28800894703000	29274	14303	51	0	\N
384162	1678	28800894704000	29274	14303	52	0	\N
384163	1678	28800894705000	29274	14303	53	0	\N
384164	1678	28800894706000	29274	14303	54	0	\N
384165	1678	28800894707000	29274	14303	55	0	\N
384166	1678	28800894708000	29274	14303	56	0	\N
384167	1678	28800894709000	29274	14303	57	0	\N
384168	1678	28800894710000	29274	14303	58	0	\N
384169	1678	28800894711000	29274	14303	59	0	\N
384170	1678	28800894712000	29274	14303	60	0	\N
384171	1678	28800894713000	29274	14303	61	0	\N
384172	1678	28800894714000	29274	14303	62	0	\N
384173	1678	28800894715000	29274	14303	63	0	\N
384174	1678	28800894716000	29274	14303	65	0	\N
384175	1678	28800894717000	29274	14303	66	0	\N
384176	1678	28800894718000	29274	14303	67	0	\N
384177	1678	28800894719000	29274	14303	68	0	\N
384178	1678	28800894720000	29274	14303	69	0	\N
384179	1678	28800894721000	29274	14303	70	0	\N
384180	1678	28800894722000	29274	14303	71	0	\N
384181	1678	28800894723000	29274	14303	72	0	\N
384182	1678	28800894724000	29274	14303	73	0	\N
384183	1678	28800894725000	29274	14303	74	0	\N
384184	1678	28800894726000	29274	14303	75	0	\N
384185	1678	28800894727000	29274	14303	76	0	\N
384186	1678	28800894728000	29274	14303	77	0	\N
384187	1678	28800894729000	29274	14303	78	0	\N
384188	1678	28800894730000	29274	14303	79	0	\N
384189	1678	28800894731000	29274	14303	80	0	\N
384190	1678	28800894732000	29274	14303	81	0	\N
384191	1678	28800894733000	29274	14303	82	0	\N
384192	1678	28800894734000	29274	14303	83	0	\N
384193	1678	28800894735000	29274	14303	84	0	\N
384194	1678	28800894736000	29274	14303	85	0	\N
384195	1678	28800894737000	29274	14303	86	0	\N
384196	1678	28800894738000	29274	14303	87	0	\N
384197	1678	28800894739000	29274	14303	88	0	\N
384198	1678	28800894740000	29274	14303	89	0	\N
384199	1678	28800894741000	29274	14303	90	0	\N
384200	1678	28800894742000	29274	14303	91	0	\N
384067	1874	9805000	29270	14426	6	0	3
384068	1874	9807000	29270	14426	7	0	3
384069	1874	9809000	29270	14426	8	0	3
384070	1874	9813000	29270	14426	9	0	3
384071	1874	9817000	29270	14426	10	0	3
384105	1678	28800894831000	29273	14427	0	0	1
384106	1678	28800894832000	29273	14427	1	0	1
384107	1874	9823000	29273	14427	2	0	3
384108	1874	9824000	29273	14427	3	0	3
384109	1874	9828000	29273	14427	4	0	3
384201	1678	28800894743000	29274	14303	92	0	\N
384202	1678	28800894744000	29274	14303	93	0	\N
384203	1678	28800894745000	29274	14303	94	0	\N
384204	1678	28800894746000	29274	14303	95	0	\N
384205	1678	28800894747000	29274	14303	96	0	\N
384206	1678	28800894748000	29274	14303	97	0	\N
384207	1678	28800894749000	29274	14303	98	0	\N
384208	1678	28800894750000	29274	14303	99	0	\N
384209	1678	28800894751000	29274	14303	100	0	\N
384210	1678	28800894752000	29274	14303	101	0	\N
384211	1678	28800894753000	29274	14303	102	0	\N
384212	1678	28800894754000	29274	14303	103	0	\N
384213	1678	28800894755000	29274	14303	104	0	\N
384214	1678	28800894756000	29274	14303	105	0	\N
384215	1678	28800894757000	29274	14303	106	0	\N
384216	1678	28800894758000	29274	14303	107	0	\N
384217	1678	28800894759000	29274	14303	108	0	\N
384218	1678	28800894760000	29274	14303	109	0	\N
384219	1678	28800894761000	29274	14303	110	0	\N
384220	1678	28800894762000	29274	14303	111	0	\N
384221	1678	28800894763000	29274	14303	112	0	\N
384222	1678	28800894764000	29274	14303	113	0	\N
384223	1678	28800894765000	29274	14303	114	0	\N
384224	1678	28800894766000	29274	14303	115	0	\N
384225	1678	28800894767000	29274	14303	116	0	\N
384226	1678	28800894768000	29274	14303	117	0	\N
384227	1678	28800894769000	29274	14303	118	0	\N
384228	1678	28800894770000	29274	14303	119	0	\N
384229	1678	28800894771000	29274	14303	120	0	\N
384230	1678	28800894772000	29274	14303	121	0	\N
384231	1678	28800894773000	29274	14303	122	0	\N
384232	1678	28800894774000	29274	14303	123	0	\N
384233	1678	28800894775000	29274	14303	124	0	\N
384234	1678	28800894776000	29274	14303	125	0	\N
384235	1678	28800894833000	29275	14428	0	0	\N
384236	1874	9834000	29275	14428	1	0	\N
384237	1874	9836000	29275	14428	2	0	\N
384238	1678	28800894833000	29276	14428	0	0	\N
384239	1874	9834000	29276	14428	1	0	\N
384240	1874	9836000	29276	14428	2	0	\N
384244	1678	28800894799000	29278	14405	0	0	\N
384245	596	84178432000000	29278	14405	1	0	\N
384246	1678	28800894800000	29278	14405	2	0	\N
384247	1678	28800894801000	29278	14405	3	0	\N
384248	1678	28800894802000	29278	14405	4	0	\N
384249	1678	28800894803000	29278	14405	5	0	\N
384250	1678	28800894804000	29278	14405	6	0	\N
384251	1678	28800894805000	29278	14405	7	0	\N
384252	1678	28800894806000	29278	14405	8	0	\N
384253	1678	28800894807000	29278	14405	9	0	\N
384254	1678	28800894808000	29278	14405	10	0	\N
384255	1678	28800894809000	29278	14405	11	0	\N
384256	1678	28800894810000	29278	14405	12	0	\N
384257	1678	28800894811000	29278	14405	13	0	\N
384258	1678	28800894812000	29278	14405	14	0	\N
384259	1678	28800894813000	29278	14405	15	0	\N
384260	1678	28800894814000	29278	14405	16	0	\N
384261	1678	28800894815000	29278	14405	17	0	\N
384262	1678	28800894816000	29278	14405	18	0	\N
384263	1678	28800894817000	29278	14405	19	0	\N
384264	1678	28800894818000	29278	14405	20	0	\N
384265	1678	28800894819000	29278	14405	21	0	\N
384266	1678	28800894820000	29278	14405	22	0	\N
384267	1678	28800894821000	29278	14405	23	0	\N
384268	1678	28800894822000	29278	14405	24	0	\N
384269	1678	28800894823000	29278	14405	25	0	\N
384270	1678	28800894824000	29278	14405	26	0	\N
384271	1678	28800894825000	29278	14405	27	0	\N
384272	1678	28800894826000	29278	14405	28	0	\N
384273	1678	28800894827000	29278	14405	29	0	\N
384274	1678	28800894828000	29278	14405	30	0	\N
384275	1678	28800894829000	29278	14405	31	0	\N
384276	1678	28800894830000	29278	14405	32	0	\N
384277	1678	28800894831000	29278	14405	33	0	\N
384278	1678	28800894832000	29278	14405	34	0	\N
384279	1678	28800894833000	29278	14405	35	0	\N
384280	1874	9656000	29278	14405	36	0	\N
384281	1874	9657000	29278	14405	37	0	\N
384282	1874	9658000	29278	14405	38	0	\N
384283	1874	9660000	29278	14405	39	0	\N
384284	1874	9662000	29278	14405	40	0	\N
384285	1874	9666000	29278	14405	41	0	\N
384286	2403	1428994500000	29278	14405	42	0	\N
384287	1874	9668000	29278	14405	43	0	\N
384288	1874	9670000	29278	14405	44	0	\N
384289	1874	9672000	29278	14405	45	0	\N
384290	1874	9674000	29278	14405	46	0	\N
384291	1874	9676000	29278	14405	47	0	\N
384292	1874	9678000	29278	14405	48	0	\N
384293	1874	9680000	29278	14405	49	0	\N
384294	1874	9682000	29278	14405	50	0	\N
384295	1874	9686000	29278	14405	51	0	\N
384296	1874	9690000	29278	14405	52	0	\N
384297	1874	9694000	29278	14405	53	0	\N
384298	1874	9698000	29278	14405	54	0	\N
384299	1874	9702000	29278	14405	55	0	\N
384300	1874	9706000	29278	14405	56	0	\N
384301	1874	9710000	29278	14405	57	0	\N
384302	1874	9714000	29278	14405	58	0	\N
384303	1874	9716000	29278	14405	59	0	\N
384304	1874	9718000	29278	14405	60	0	\N
384305	1874	9720000	29278	14405	61	0	\N
384306	1874	9722000	29278	14405	62	0	\N
384307	1874	9724000	29278	14405	63	0	\N
384308	1874	9726000	29278	14405	64	0	\N
384309	1874	9728000	29278	14405	65	0	\N
384310	1874	9730000	29278	14405	66	0	\N
384311	1874	9732000	29278	14405	67	0	\N
384312	1874	9734000	29278	14405	68	0	\N
384313	1874	9736000	29278	14405	70	0	\N
384314	1874	9738000	29278	14405	71	0	\N
384315	1874	9740000	29278	14405	72	0	\N
384316	1874	9742000	29278	14405	73	0	\N
384317	1874	9744000	29278	14405	74	0	\N
384318	1874	9745000	29278	14405	75	0	\N
384319	1874	9746000	29278	14405	76	0	\N
384320	1874	9747000	29278	14405	77	0	\N
384321	1874	9748000	29278	14405	78	0	\N
384322	1874	9749000	29278	14405	79	0	\N
384323	1874	9750000	29278	14405	80	0	\N
384324	1874	9751000	29278	14405	81	0	\N
384325	1874	9752000	29278	14405	82	0	\N
384326	1874	9756000	29278	14405	83	0	\N
384327	1874	9760000	29278	14405	84	0	\N
384328	1874	9764000	29278	14405	85	0	\N
384329	1874	9768000	29278	14405	86	0	\N
384330	1874	9772000	29278	14405	87	0	\N
384331	1874	9776000	29278	14405	88	0	\N
384332	1874	9780000	29278	14405	89	0	\N
384333	1874	9784000	29278	14405	90	0	\N
384334	1874	9788000	29278	14405	91	0	\N
384335	1874	9792000	29278	14405	92	0	\N
384336	1874	9796000	29278	14405	93	0	\N
384243	1874	9836000	29277	14428	2	0	3
384337	1874	9800000	29278	14405	94	0	\N
384338	1874	9804000	29278	14405	95	0	\N
384339	1874	9808000	29278	14405	96	0	\N
384340	1874	9812000	29278	14405	97	0	\N
384341	1874	9816000	29278	14405	98	0	\N
384342	1874	9818000	29278	14405	99	0	\N
384343	1874	9820000	29278	14405	100	0	\N
384344	1874	9822000	29278	14405	101	0	\N
384345	1874	9824000	29278	14405	102	0	\N
384346	1874	9826000	29278	14405	103	0	\N
384347	1874	9828000	29278	14405	104	0	\N
384348	1874	9830000	29278	14405	105	0	\N
384349	1874	9832000	29278	14405	106	0	\N
384350	1874	9834000	29278	14405	107	0	\N
384351	1874	9836000	29278	14405	108	0	\N
384368	1678	28800894838000	29282	14431	0	0	\N
384369	1874	9858000	29282	14431	1	0	\N
384370	1874	9860000	29282	14431	2	0	\N
384371	1678	28800894838000	29283	14431	0	0	\N
384372	1874	9858000	29283	14431	1	0	\N
384373	1874	9860000	29283	14431	2	0	\N
384374	1678	28800894838000	29284	14431	0	0	\N
384375	1874	9858000	29284	14431	1	0	\N
384376	1874	9860000	29284	14431	2	0	\N
384377	1678	28800894838000	29285	14431	0	0	\N
384378	1874	9858000	29285	14431	1	0	\N
384379	1874	9860000	29285	14431	2	0	\N
384383	1678	28800894839000	29287	14432	0	0	\N
384384	1874	9862000	29287	14432	1	0	\N
384385	1874	9866000	29287	14432	2	0	\N
384386	1678	28800894839000	29288	14432	0	0	\N
384387	1874	9862000	29288	14432	1	0	\N
384388	1874	9866000	29288	14432	2	0	\N
384398	1678	28800894842000	29291	14434	0	0	\N
384399	1874	9881000	29291	14434	1	0	\N
384400	1678	28800894843000	29292	14435	0	0	\N
384401	1874	9883000	29292	14435	2	0	\N
384402	1874	9887000	29292	14435	3	0	\N
384403	1678	28800894843000	29293	14435	0	0	\N
384404	1874	9883000	29293	14435	2	0	\N
384405	1874	9887000	29293	14435	3	0	\N
384409	1678	28800894843000	29295	14435	0	0	\N
384410	1874	9883000	29295	14435	2	0	\N
384411	1874	9887000	29295	14435	3	0	\N
384419	1678	28800894846000	29298	14438	0	0	\N
384420	1678	28800894847000	29298	14438	1	0	\N
384421	1874	9902000	29298	14438	2	0	\N
384422	1874	9906000	29298	14438	3	0	\N
384423	1874	9908000	29298	14438	4	0	\N
384424	1678	28800894846000	29299	14438	0	0	\N
384425	1678	28800894847000	29299	14438	1	0	\N
384426	1874	9902000	29299	14438	2	0	\N
384427	1874	9906000	29299	14438	3	0	\N
384428	1874	9908000	29299	14438	4	0	\N
384429	1678	28800894846000	29300	14438	0	0	\N
384430	1678	28800894847000	29300	14438	1	0	\N
384431	1874	9902000	29300	14438	2	0	\N
384432	1874	9906000	29300	14438	3	0	\N
384433	1874	9908000	29300	14438	4	0	\N
384439	1678	28800894846000	29302	14438	0	0	\N
384440	1678	28800894847000	29302	14438	1	0	\N
384441	1874	9902000	29302	14438	2	0	\N
384442	1874	9906000	29302	14438	3	0	\N
384443	1874	9908000	29302	14438	4	0	\N
384453	1678	28800894851000	29305	14441	0	0	\N
384454	1874	9925000	29305	14441	1	0	\N
384455	1874	9926000	29305	14441	2	0	\N
384456	1874	9930000	29305	14441	3	0	\N
384461	1678	28800894852000	29307	14442	0	0	\N
384466	1678	28800894853000	29310	14443	0	0	\N
384467	1874	9934000	29310	14443	1	0	\N
384468	1874	9936000	29310	14443	2	0	\N
384354	1874	9838000	29279	14429	2	0	3
384355	1874	9839000	29279	14429	3	0	3
384356	1874	9841000	29279	14429	4	0	3
384357	1874	9845000	29279	14429	5	0	3
384358	1678	28800894836000	29280	14430	0	0	1
384360	2418	100000000	29280	14430	2	0	0
384361	1874	9847000	29280	14430	3	0	3
384362	1874	9851000	29280	14430	4	0	3
384363	1874	9855000	29280	14430	5	0	3
384364	1874	9857000	29280	14430	6	0	3
384366	1874	9858000	29281	14431	1	0	3
384367	1874	9860000	29281	14431	2	0	3
384380	1678	28800894839000	29286	14432	0	0	1
384381	1874	9862000	29286	14432	1	0	3
384389	1678	28800894840000	29289	14433	0	0	1
384390	1678	28800894841000	29289	14433	1	0	1
384391	1874	9867000	29289	14433	2	0	3
384392	1874	9871000	29289	14433	3	0	3
384393	1874	9875000	29289	14433	4	0	3
384395	1874	9879000	29289	14433	6	0	3
384396	1678	28800894842000	29290	14434	0	0	1
384397	1874	9881000	29290	14434	1	0	3
384406	1678	28800894843000	29294	14435	0	0	1
384407	1874	9883000	29294	14435	2	0	3
384412	1678	28800894844000	29296	14436	0	0	1
384413	1874	9888000	29296	14436	1	0	3
384414	1874	9890000	29296	14436	2	0	3
384415	1874	9894000	29296	14436	3	0	3
384417	1874	9896000	29297	14437	1	0	3
384418	1874	9900000	29297	14437	2	0	3
384434	1678	28800894846000	29301	14438	0	0	1
384435	1678	28800894847000	29301	14438	1	0	1
384436	1874	9902000	29301	14438	2	0	3
384438	1874	9908000	29301	14438	4	0	3
384444	1678	28800894848000	29303	14439	0	0	1
384445	1874	9910000	29303	14439	1	0	3
384446	1874	9914000	29303	14439	2	0	3
384447	1874	9915000	29303	14439	3	0	3
384449	1678	28800894850000	29304	14440	1	0	1
384450	1874	9917000	29304	14440	2	0	3
384451	1874	9919000	29304	14440	3	0	3
384452	1874	9923000	29304	14440	4	0	3
384458	1874	9925000	29306	14441	1	0	3
384459	1874	9926000	29306	14441	2	0	3
384460	1874	9930000	29306	14441	3	0	3
384462	1678	28800894852000	29308	14442	0	0	1
384463	1678	28800894853000	29309	14443	0	0	1
384465	1874	9936000	29309	14443	2	0	3
384469	1678	28800894854000	29311	14444	0	0	1
384470	1678	28800894855000	29311	14444	1	0	1
384471	1874	9938000	29311	14444	2	0	3
384472	1874	9939000	29311	14444	3	0	3
384478	1678	28800894857000	29315	14446	0	0	\N
384479	1874	9955000	29315	14446	1	0	\N
384480	1874	9957000	29315	14446	2	0	\N
384490	1678	28800894859000	29319	14448	0	0	\N
384491	1874	9966000	29319	14448	1	0	\N
384492	1874	9970000	29319	14448	2	0	\N
384493	1678	28800894860000	29320	14449	0	0	\N
384494	1874	9970000	29320	14449	1	0	\N
384495	1874	9972000	29320	14449	2	0	\N
384503	1678	28800894862000	29323	14451	0	0	\N
384504	1874	9983000	29323	14451	1	0	\N
384505	1874	9985000	29323	14451	2	0	\N
384509	1678	28800894862000	29325	14451	0	0	\N
384510	1874	9983000	29325	14451	1	0	\N
384511	1874	9985000	29325	14451	2	0	\N
384514	1678	28800894863000	29327	14452	0	0	\N
384515	1874	9987000	29327	14452	1	0	\N
384516	1678	28800894863000	29328	14452	0	0	\N
384517	1874	9987000	29328	14452	1	0	\N
384530	1678	28800894777000	29331	14304	0	0	\N
384531	1678	28800894778000	29331	14304	1	0	\N
384532	1678	28800894779000	29331	14304	2	0	\N
384533	1678	28800894780000	29331	14304	3	0	\N
384534	1678	28800894781000	29331	14304	4	0	\N
384535	1678	28800894782000	29331	14304	5	0	\N
384536	1678	28800894783000	29331	14304	6	0	\N
384537	1678	28800894784000	29331	14304	7	0	\N
384538	1678	28800894785000	29331	14304	8	0	\N
384539	1678	28800894786000	29331	14304	9	0	\N
384540	1678	28800894787000	29331	14304	10	0	\N
384541	1678	28800894788000	29331	14304	11	0	\N
384542	1678	28800894789000	29331	14304	12	0	\N
384543	1678	28800894790000	29331	14304	13	0	\N
384544	1678	28800894791000	29331	14304	14	0	\N
384545	1678	28800894792000	29331	14304	15	0	\N
384546	1678	28800894793000	29331	14304	16	0	\N
384547	1678	28800894794000	29331	14304	17	0	\N
384548	1678	28800894795000	29331	14304	18	0	\N
384549	1678	28800894796000	29331	14304	19	0	\N
384550	1678	28800894797000	29331	14304	20	0	\N
384551	1678	28800894798000	29331	14304	21	0	\N
384552	1678	28800894799000	29331	14304	22	0	\N
384553	1678	28800894800000	29331	14304	23	0	\N
384554	1678	28800894801000	29331	14304	24	0	\N
384555	1678	28800894802000	29331	14304	25	0	\N
384556	1678	28800894803000	29331	14304	26	0	\N
384557	1678	28800894804000	29331	14304	27	0	\N
384558	1678	28800894805000	29331	14304	28	0	\N
384559	1678	28800894806000	29331	14304	29	0	\N
384560	1678	28800894807000	29331	14304	30	0	\N
384561	1678	28800894808000	29331	14304	31	0	\N
384562	1678	28800894809000	29331	14304	32	0	\N
384563	1678	28800894810000	29331	14304	33	0	\N
384564	1678	28800894811000	29331	14304	34	0	\N
384565	1678	28800894812000	29331	14304	35	0	\N
384566	1678	28800894813000	29331	14304	36	0	\N
384567	1678	28800894814000	29331	14304	37	0	\N
384568	1678	28800894815000	29331	14304	38	0	\N
384569	1678	28800894816000	29331	14304	39	0	\N
384570	1678	28800894817000	29331	14304	40	0	\N
384571	1678	28800894818000	29331	14304	41	0	\N
384572	1678	28800894819000	29331	14304	42	0	\N
384573	1678	28800894820000	29331	14304	43	0	\N
384574	1678	28800894821000	29331	14304	44	0	\N
384575	1678	28800894822000	29331	14304	45	0	\N
384576	1678	28800894823000	29331	14304	46	0	\N
384577	1678	28800894824000	29331	14304	47	0	\N
384578	1678	28800894825000	29331	14304	48	0	\N
384579	1678	28800894826000	29331	14304	49	0	\N
384580	1678	28800894827000	29331	14304	50	0	\N
384581	1678	28800894828000	29331	14304	51	0	\N
384582	1678	28800894829000	29331	14304	52	0	\N
384583	1678	28800894830000	29331	14304	53	0	\N
384584	1678	28800894831000	29331	14304	54	0	\N
384585	1678	28800894832000	29331	14304	55	0	\N
384586	1678	28800894833000	29331	14304	56	0	\N
384587	1678	28800894834000	29331	14304	57	0	\N
384588	1678	28800894835000	29331	14304	58	0	\N
384589	1678	28800894836000	29331	14304	59	0	\N
384590	1678	28800894837000	29331	14304	60	0	\N
384591	1678	28800894838000	29331	14304	61	0	\N
384592	1678	28800894839000	29331	14304	62	0	\N
384593	1678	28800894840000	29331	14304	63	0	\N
384594	1678	28800894841000	29331	14304	65	0	\N
384595	1678	28800894842000	29331	14304	66	0	\N
384596	1678	28800894843000	29331	14304	67	0	\N
384597	1678	28800894844000	29331	14304	68	0	\N
384598	1678	28800894845000	29331	14304	69	0	\N
384599	1678	28800894846000	29331	14304	70	0	\N
384600	1678	28800894847000	29331	14304	71	0	\N
384601	1678	28800894848000	29331	14304	72	0	\N
384602	1678	28800894849000	29331	14304	73	0	\N
384603	1678	28800894850000	29331	14304	74	0	\N
384604	1678	28800894851000	29331	14304	75	0	\N
384605	1678	28800894852000	29331	14304	76	0	\N
384606	1678	28800894853000	29331	14304	77	0	\N
384607	1678	28800894854000	29331	14304	78	0	\N
384608	1678	28800894855000	29331	14304	79	0	\N
384475	1874	9949000	29311	14444	6	0	3
384476	1678	28800894856000	29312	14445	0	0	1
384477	1874	9951000	29312	14445	1	0	3
384481	1678	28800894857000	29316	14446	0	0	1
384482	1874	9955000	29316	14446	1	0	3
384484	1678	28800894858000	29317	14447	0	0	1
384485	1874	9961000	29317	14447	1	0	3
384486	1874	9963000	29317	14447	2	0	3
384487	1874	9964000	29317	14447	3	0	3
384488	1678	28800894859000	29318	14448	0	0	1
384496	1678	28800894860000	29321	14449	0	0	1
384497	1874	9970000	29321	14449	1	0	3
384498	1874	9972000	29321	14449	2	0	3
384499	1678	28800894861000	29322	14450	0	0	1
384501	1874	9975000	29322	14450	2	0	3
384502	1874	9979000	29322	14450	3	0	3
384506	1678	28800894862000	29324	14451	0	0	1
384507	1874	9983000	29324	14451	1	0	3
384508	1874	9985000	29324	14451	2	0	3
384513	1874	9987000	29326	14452	1	0	3
384518	1678	28800894864000	29329	14453	0	0	1
384519	1678	28800894865000	29329	14453	1	0	1
384520	1874	9991000	29329	14453	2	0	3
384521	1874	9993000	29329	14453	3	0	3
384523	1874	9999000	29329	14453	5	0	3
384524	1874	10000000	29329	14453	6	0	3
384525	1678	28800894866000	29330	14454	0	0	1
384526	1874	10002000	29330	14454	1	0	3
384528	2420	0	29330	14454	3	0	0
384529	1874	10006000	29330	14454	4	0	3
384609	1678	28800894856000	29331	14304	80	0	\N
384610	1678	28800894857000	29331	14304	81	0	\N
384611	1678	28800894858000	29331	14304	82	0	\N
384612	1678	28800894859000	29331	14304	83	0	\N
384613	1678	28800894860000	29331	14304	84	0	\N
384614	1678	28800894861000	29331	14304	85	0	\N
384615	1678	28800894862000	29331	14304	86	0	\N
384616	1678	28800894863000	29331	14304	87	0	\N
384617	1678	28800894864000	29331	14304	88	0	\N
384618	1678	28800894865000	29331	14304	89	0	\N
384619	1678	28800894866000	29331	14304	90	0	\N
384620	2418	100000000	29331	14304	91	0	\N
384621	1874	8918000	29331	14304	92	0	\N
384622	1874	8920000	29331	14304	93	0	\N
384623	1874	8922000	29331	14304	94	0	\N
384624	1874	8923000	29331	14304	95	0	\N
384625	1874	8924000	29331	14304	96	0	\N
384626	1874	8926000	29331	14304	97	0	\N
384627	1874	8927000	29331	14304	98	0	\N
384628	2403	1428994500000	29331	14304	99	0	\N
384629	2419	0	29331	14304	100	0	\N
384630	2420	0	29331	14304	101	0	\N
384631	1874	8928000	29331	14304	102	0	\N
384632	1874	8932000	29331	14304	103	0	\N
384633	1874	8936000	29331	14304	104	0	\N
384634	1874	8940000	29331	14304	105	0	\N
384635	1874	8944000	29331	14304	106	0	\N
384636	1874	8948000	29331	14304	107	0	\N
384637	1874	8952000	29331	14304	108	0	\N
384638	1874	8956000	29331	14304	109	0	\N
384639	1874	8960000	29331	14304	110	0	\N
384640	1874	8964000	29331	14304	111	0	\N
384641	1874	8968000	29331	14304	112	0	\N
384642	1874	8972000	29331	14304	113	0	\N
384643	1874	8976000	29331	14304	114	0	\N
384644	1874	8980000	29331	14304	115	0	\N
384645	1874	8984000	29331	14304	116	0	\N
384646	1874	8988000	29331	14304	117	0	\N
384647	1874	8989000	29331	14304	118	0	\N
384648	1874	8990000	29331	14304	119	0	\N
384649	1874	8991000	29331	14304	120	0	\N
384650	1874	8992000	29331	14304	121	0	\N
384651	1874	8993000	29331	14304	122	0	\N
384652	1874	8994000	29331	14304	123	0	\N
384653	1874	8995000	29331	14304	124	0	\N
384654	1874	8996000	29331	14304	125	0	\N
384658	1678	28800894867000	29333	14455	0	0	\N
384659	605	66720000000000	29333	14455	1	0	\N
384660	1874	10008000	29333	14455	2	0	\N
384661	1678	28800894867000	29334	14455	0	0	\N
384662	605	66720000000000	29334	14455	1	0	\N
384663	1874	10008000	29334	14455	2	0	\N
384668	1678	28800894868000	29336	14456	0	0	\N
384669	1874	10009000	29336	14456	1	0	\N
384670	1874	10013000	29336	14456	2	0	\N
384671	1874	10015000	29336	14456	3	0	\N
384682	1678	28800894871000	29339	14458	0	0	\N
384683	1874	10025000	29339	14458	1	0	\N
384684	1874	10029000	29339	14458	2	0	\N
384685	1874	10030000	29339	14458	3	0	\N
384692	1678	28800894874000	29342	14461	0	0	\N
384693	1678	28800894875000	29342	14461	1	0	\N
384694	1874	10046000	29342	14461	2	0	\N
384695	1874	10048000	29342	14461	3	0	\N
384696	1874	10050000	29342	14461	4	0	\N
384697	1874	10051000	29342	14461	5	0	\N
384704	1678	28800894874000	29344	14461	0	0	\N
384705	1678	28800894875000	29344	14461	1	0	\N
384706	1874	10046000	29344	14461	2	0	\N
384707	1874	10048000	29344	14461	3	0	\N
384708	1874	10050000	29344	14461	4	0	\N
384709	1874	10051000	29344	14461	5	0	\N
384716	1678	28800894877000	29347	14463	0	0	\N
384717	1874	10061000	29347	14463	1	0	\N
384718	1874	10063000	29347	14463	2	0	\N
384728	1678	28800894879000	29350	14465	0	0	\N
384729	1678	28800894880000	29350	14465	1	0	\N
384730	1874	10070000	29350	14465	2	0	\N
384731	1874	10074000	29350	14465	3	0	\N
384732	1874	10076000	29350	14465	4	0	\N
384733	1874	10078000	29350	14465	5	0	\N
384734	1678	28800894881000	29351	14466	0	0	\N
384735	1678	28800894882000	29351	14466	1	0	\N
384736	1874	10079000	29351	14466	2	0	\N
384737	1874	10081000	29351	14466	3	0	\N
384738	1874	10083000	29351	14466	4	0	\N
384739	1874	10087000	29351	14466	5	0	\N
384657	1874	10008000	29332	14455	2	0	3
384664	1678	28800894868000	29335	14456	0	0	1
384665	1874	10009000	29335	14456	1	0	3
384666	1874	10013000	29335	14456	2	0	3
384667	1874	10015000	29335	14456	3	0	3
384673	1678	28800894870000	29337	14457	1	0	1
384674	548	67440000000000	29337	14457	2	0	0
384675	1874	10017000	29337	14457	4	0	3
384676	1874	10019000	29337	14457	5	0	3
384677	1874	10023000	29337	14457	6	0	3
384679	1874	10025000	29338	14458	1	0	3
384680	1874	10029000	29338	14458	2	0	3
384681	1874	10030000	29338	14458	3	0	3
384686	1678	28800894872000	29340	14459	0	0	1
384688	1874	10036000	29340	14459	2	0	3
384689	1678	28800894873000	29341	14460	0	0	1
384690	1874	10040000	29341	14460	1	0	3
384691	1874	10042000	29341	14460	2	0	3
384698	1678	28800894874000	29343	14461	0	0	1
384700	1874	10046000	29343	14461	2	0	3
384701	1874	10048000	29343	14461	3	0	3
384702	1874	10050000	29343	14461	4	0	3
384703	1874	10051000	29343	14461	5	0	3
384710	1678	28800894876000	29345	14462	0	0	1
384712	1874	10057000	29345	14462	2	0	3
384713	1678	28800894877000	29346	14463	0	0	1
384714	1874	10061000	29346	14463	1	0	3
384715	1874	10063000	29346	14463	2	0	3
384720	1874	10065000	29348	14464	1	0	3
384721	1874	10066000	29348	14464	2	0	3
384722	1678	28800894879000	29349	14465	0	0	1
384723	1678	28800894880000	29349	14465	1	0	1
384724	1874	10070000	29349	14465	2	0	3
384726	1874	10076000	29349	14465	4	0	3
384727	1874	10078000	29349	14465	5	0	3
384740	1678	28800894881000	29352	14466	0	0	1
384741	1678	28800894882000	29352	14466	1	0	1
384742	1874	10079000	29352	14466	2	0	3
384744	1874	10083000	29352	14466	4	0	3
384749	1678	28800894883000	29354	14467	0	0	\N
384750	1874	10089000	29354	14467	1	0	\N
384751	1874	10093000	29354	14467	2	0	\N
384752	1678	28800894884000	29355	14468	0	0	\N
384753	1874	10095000	29355	14468	1	0	\N
384754	1874	10096000	29355	14468	2	0	\N
384755	1874	10100000	29355	14468	3	0	\N
384760	1678	28800894884000	29357	14468	0	0	\N
384761	1874	10095000	29357	14468	1	0	\N
384762	1874	10096000	29357	14468	2	0	\N
384763	1874	10100000	29357	14468	3	0	\N
384764	1678	28800894885000	29358	14469	0	0	\N
384765	1874	10102000	29358	14469	1	0	\N
384768	1678	28800894886000	29361	14470	0	0	\N
384769	1874	10104000	29361	14470	1	0	\N
384770	1874	10108000	29361	14470	2	0	\N
384783	1678	28800894889000	29366	14473	0	0	\N
384784	1874	10119000	29366	14473	1	0	\N
384785	1874	10123000	29366	14473	2	0	\N
384789	1678	28800894891000	29368	14475	0	0	\N
384790	1874	10130000	29368	14475	1	0	\N
384791	1874	10132000	29368	14475	2	0	\N
384798	1678	28800894892000	29371	14476	0	0	\N
384799	1874	10136000	29371	14476	1	0	\N
384800	1874	10138000	29371	14476	2	0	\N
384812	1678	28800894897000	29376	14481	0	0	\N
384813	1678	28800894898000	29376	14481	1	0	\N
384814	1678	28800894899000	29376	14481	2	0	\N
384815	1874	10159000	29376	14481	3	0	\N
384816	1874	10161000	29376	14481	4	0	\N
384817	1874	10162000	29376	14481	5	0	\N
384818	1874	10164000	29376	14481	6	0	\N
384819	1874	10168000	29376	14481	7	0	\N
384820	1874	10172000	29376	14481	8	0	\N
384830	1678	28800894897000	29378	14481	0	0	\N
384831	1678	28800894898000	29378	14481	1	0	\N
384832	1678	28800894899000	29378	14481	2	0	\N
384833	1874	10159000	29378	14481	3	0	\N
384834	1874	10161000	29378	14481	4	0	\N
384835	1874	10162000	29378	14481	5	0	\N
384836	1874	10164000	29378	14481	6	0	\N
384837	1874	10168000	29378	14481	7	0	\N
384838	1874	10172000	29378	14481	8	0	\N
384851	1678	28800894903000	29383	14485	0	0	\N
384852	1874	10189000	29383	14485	1	0	\N
384853	1874	10193000	29383	14485	2	0	\N
384875	1678	28800894907000	29387	14488	0	0	\N
384876	1678	28800894908000	29387	14488	1	0	\N
384877	1678	28800894909000	29387	14488	2	0	\N
384878	1874	10209000	29387	14488	3	0	\N
384879	1874	10213000	29387	14488	4	0	\N
384880	80	66001000000000	29387	14488	5	0	\N
384747	1874	10089000	29353	14467	1	0	3
384748	1874	10093000	29353	14467	2	0	3
384756	1678	28800894884000	29356	14468	0	0	1
384757	1874	10095000	29356	14468	1	0	3
384758	1874	10096000	29356	14468	2	0	3
384766	1678	28800894885000	29359	14469	0	0	1
384767	1874	10102000	29359	14469	1	0	3
384771	1678	28800894886000	29362	14470	0	0	1
384772	1874	10104000	29362	14470	1	0	3
384773	1874	10108000	29362	14470	2	0	3
384775	1874	10112000	29363	14471	1	0	3
384776	1874	10114000	29363	14471	2	0	3
384777	1678	28800894888000	29364	14472	0	0	1
384778	1874	10115000	29364	14472	1	0	3
384780	1678	28800894889000	29365	14473	0	0	1
384781	1874	10119000	29365	14473	1	0	3
384782	1874	10123000	29365	14473	2	0	3
384786	1678	28800894890000	29367	14474	0	0	1
384787	1874	10125000	29367	14474	1	0	3
384792	1678	28800894891000	29369	14475	0	0	1
384793	1874	10130000	29369	14475	1	0	3
384794	1874	10132000	29369	14475	2	0	3
384795	1678	28800894892000	29370	14476	0	0	1
384796	1874	10136000	29370	14476	1	0	3
384801	1678	28800894893000	29372	14477	0	0	1
384802	1874	10142000	29372	14477	1	0	3
384803	1874	10144000	29372	14477	2	0	3
384804	1678	28800894894000	29373	14478	0	0	1
384806	1874	10149000	29373	14478	2	0	3
384807	1678	28800894895000	29374	14479	0	0	1
384808	1678	28800894896000	29374	14479	1	0	1
384809	1874	10151000	29374	14479	2	0	3
384810	1874	10155000	29374	14479	3	0	3
384821	1678	28800894897000	29377	14481	0	0	1
384822	1678	28800894898000	29377	14481	1	0	1
384823	1678	28800894899000	29377	14481	2	0	1
384824	1874	10159000	29377	14481	3	0	3
384825	1874	10161000	29377	14481	4	0	3
384827	1874	10164000	29377	14481	6	0	3
384828	1874	10168000	29377	14481	7	0	3
384829	1874	10172000	29377	14481	8	0	3
384839	1678	28800894900000	29379	14482	0	0	1
384841	1874	10178000	29379	14482	2	0	3
384842	1678	28800894901000	29380	14483	0	0	1
384843	1874	10180000	29380	14483	1	0	3
384844	1874	10184000	29380	14483	2	0	3
384845	1874	10185000	29380	14483	3	0	3
384847	1874	10187000	29381	14484	1	0	3
384848	1678	28800894903000	29382	14485	0	0	1
384849	1874	10189000	29382	14485	1	0	3
384850	1874	10193000	29382	14485	2	0	3
384854	1678	28800894904000	29384	14486	0	0	1
384856	1874	10194000	29384	14486	2	0	3
384857	1874	10196000	29384	14486	3	0	3
384858	1874	10198000	29384	14486	4	0	3
384859	1874	10202000	29384	14486	5	0	3
384861	1678	28800894906000	29385	14487	0	0	1
384862	1874	10208000	29385	14487	1	0	3
384863	1678	28800894907000	29386	14488	0	0	1
384864	1678	28800894908000	29386	14488	1	0	1
384865	1678	28800894909000	29386	14488	2	0	1
384867	1874	10213000	29386	14488	4	0	3
384868	80	66001000000000	29386	14488	5	0	0
384869	1874	10215000	29386	14488	6	0	3
384870	1874	10217000	29386	14488	7	0	3
384871	1874	10219000	29386	14488	8	0	3
384873	1874	10225000	29386	14488	10	0	3
384874	1874	10229000	29386	14488	11	0	3
384881	1874	10215000	29387	14488	6	0	\N
384882	1874	10217000	29387	14488	7	0	\N
384883	1874	10219000	29387	14488	8	0	\N
384884	1874	10221000	29387	14488	9	0	\N
384885	1874	10225000	29387	14488	10	0	\N
384886	1874	10229000	29387	14488	11	0	\N
384887	1678	28800894907000	29388	14488	0	0	\N
384888	1678	28800894908000	29388	14488	1	0	\N
384889	1678	28800894909000	29388	14488	2	0	\N
384890	1874	10209000	29388	14488	3	0	\N
384891	1874	10213000	29388	14488	4	0	\N
384892	80	66001000000000	29388	14488	5	0	\N
384893	1874	10217000	29388	14488	6	0	\N
384894	1874	10221000	29388	14488	7	0	\N
384903	1678	28800894834000	29391	14406	0	0	\N
384904	1678	28800894835000	29391	14406	1	0	\N
384905	1678	28800894836000	29391	14406	2	0	\N
384906	1678	28800894837000	29391	14406	3	0	\N
384907	1678	28800894838000	29391	14406	4	0	\N
384908	1678	28800894839000	29391	14406	5	0	\N
384909	1678	28800894840000	29391	14406	6	0	\N
384910	1678	28800894841000	29391	14406	7	0	\N
384911	1678	28800894842000	29391	14406	8	0	\N
384912	1678	28800894843000	29391	14406	9	0	\N
384913	1678	28800894844000	29391	14406	10	0	\N
384914	1678	28800894845000	29391	14406	11	0	\N
384915	1678	28800894846000	29391	14406	12	0	\N
384916	1678	28800894847000	29391	14406	13	0	\N
384917	1678	28800894848000	29391	14406	14	0	\N
384918	1678	28800894849000	29391	14406	15	0	\N
384919	1678	28800894850000	29391	14406	16	0	\N
384920	1678	28800894851000	29391	14406	17	0	\N
384921	1678	28800894852000	29391	14406	18	0	\N
384922	1678	28800894853000	29391	14406	19	0	\N
384923	1678	28800894854000	29391	14406	20	0	\N
384924	1678	28800894855000	29391	14406	21	0	\N
384925	1678	28800894856000	29391	14406	22	0	\N
384926	1678	28800894857000	29391	14406	23	0	\N
384927	1678	28800894858000	29391	14406	24	0	\N
384928	1678	28800894859000	29391	14406	25	0	\N
384929	1678	28800894860000	29391	14406	26	0	\N
384930	1678	28800894861000	29391	14406	27	0	\N
384931	1678	28800894862000	29391	14406	28	0	\N
384932	1678	28800894863000	29391	14406	29	0	\N
384933	1678	28800894864000	29391	14406	30	0	\N
384934	1678	28800894865000	29391	14406	31	0	\N
384935	1678	28800894866000	29391	14406	32	0	\N
384936	1678	28800894867000	29391	14406	33	0	\N
384937	1678	28800894868000	29391	14406	34	0	\N
384938	1678	28800894869000	29391	14406	35	0	\N
384939	1678	28800894870000	29391	14406	36	0	\N
384940	1678	28800894871000	29391	14406	37	0	\N
384941	1678	28800894872000	29391	14406	38	0	\N
384942	1678	28800894873000	29391	14406	39	0	\N
384943	1678	28800894874000	29391	14406	40	0	\N
384944	1678	28800894875000	29391	14406	41	0	\N
384945	1678	28800894876000	29391	14406	42	0	\N
384946	1678	28800894877000	29391	14406	43	0	\N
384947	1678	28800894878000	29391	14406	44	0	\N
384948	1678	28800894879000	29391	14406	45	0	\N
384949	1678	28800894880000	29391	14406	46	0	\N
384950	1678	28800894881000	29391	14406	47	0	\N
384951	1678	28800894882000	29391	14406	48	0	\N
384952	1678	28800894883000	29391	14406	49	0	\N
384953	1678	28800894884000	29391	14406	50	0	\N
384954	1678	28800894885000	29391	14406	51	0	\N
384955	1678	28800894886000	29391	14406	52	0	\N
384956	1678	28800894887000	29391	14406	53	0	\N
384957	1678	28800894888000	29391	14406	54	0	\N
384958	1678	28800894889000	29391	14406	55	0	\N
384959	1678	28800894890000	29391	14406	56	0	\N
384960	1678	28800894891000	29391	14406	57	0	\N
384961	1678	28800894892000	29391	14406	58	0	\N
384962	1678	28800894893000	29391	14406	59	0	\N
384963	1678	28800894894000	29391	14406	60	0	\N
384964	1678	28800894895000	29391	14406	61	0	\N
384965	1678	28800894896000	29391	14406	62	0	\N
384966	1678	28800894897000	29391	14406	63	0	\N
384967	1678	28800894898000	29391	14406	64	0	\N
384968	1678	28800894899000	29391	14406	65	0	\N
384969	1678	28800894900000	29391	14406	66	0	\N
384970	1678	28800894901000	29391	14406	67	0	\N
384971	1678	28800894902000	29391	14406	68	0	\N
384972	1678	28800894903000	29391	14406	69	0	\N
384973	1678	28800894904000	29391	14406	70	0	\N
384974	1678	28800894905000	29391	14406	71	0	\N
384975	1678	28800894906000	29391	14406	72	0	\N
384976	1678	28800894907000	29391	14406	73	0	\N
384977	1678	28800894908000	29391	14406	74	0	\N
384978	1678	28800894909000	29391	14406	75	0	\N
384979	1678	28800894910000	29391	14406	76	0	\N
384980	1678	28800894911000	29391	14406	77	0	\N
384981	2418	100000000	29391	14406	78	0	\N
384982	548	67440000000000	29391	14406	79	0	\N
384983	1874	9838000	29391	14406	80	0	\N
384984	605	66720000000000	29391	14406	81	0	\N
384985	1874	9839000	29391	14406	82	0	\N
384986	1874	9840000	29391	14406	83	0	\N
384987	80	66001000000000	29391	14406	84	0	\N
384988	1874	9842000	29391	14406	85	0	\N
384989	1874	9844000	29391	14406	87	0	\N
384990	1874	9845000	29391	14406	88	0	\N
384991	1874	9846000	29391	14406	89	0	\N
384992	1874	9847000	29391	14406	90	0	\N
384993	1874	9848000	29391	14406	91	0	\N
384994	2419	0	29391	14406	92	0	\N
384995	2420	0	29391	14406	93	0	\N
384996	1874	9849000	29391	14406	94	0	\N
384997	1874	9853000	29391	14406	95	0	\N
384998	1874	9857000	29391	14406	96	0	\N
384999	1874	9861000	29391	14406	97	0	\N
385000	1874	9862000	29391	14406	98	0	\N
385001	1874	9863000	29391	14406	99	0	\N
385002	1874	9864000	29391	14406	100	0	\N
385003	1874	9865000	29391	14406	101	0	\N
385004	1874	9866000	29391	14406	102	0	\N
385005	1874	9867000	29391	14406	103	0	\N
385006	1874	9868000	29391	14406	104	0	\N
385007	1874	9869000	29391	14406	105	0	\N
385008	1874	9870000	29391	14406	106	0	\N
385009	1874	9871000	29391	14406	107	0	\N
385010	1874	9872000	29391	14406	108	0	\N
385011	1874	9873000	29391	14406	109	0	\N
385012	1874	9874000	29391	14406	110	0	\N
385013	1874	9875000	29391	14406	111	0	\N
385014	1874	9876000	29391	14406	112	0	\N
385015	1874	9877000	29391	14406	113	0	\N
385016	1874	9878000	29391	14406	114	0	\N
384897	1874	10232000	29389	14489	2	0	3
384898	1874	10236000	29389	14489	3	0	3
384899	1678	28800894911000	29390	14490	0	0	1
384900	1993	2816848532446	29390	14490	1	0	2
384901	1874	10240000	29390	14490	2	0	3
385017	1874	9882000	29391	14406	115	0	\N
385018	1874	9886000	29391	14406	116	0	\N
385019	1874	9890000	29391	14406	117	0	\N
385020	1874	9894000	29391	14406	118	0	\N
385021	1874	9898000	29391	14406	119	0	\N
385022	1874	9902000	29391	14406	120	0	\N
385023	1874	9906000	29391	14406	121	0	\N
385024	1874	9910000	29391	14406	122	0	\N
385025	1874	9914000	29391	14406	123	0	\N
385026	1874	9918000	29391	14406	124	0	\N
385027	1874	9922000	29391	14406	125	0	\N
385030	1678	28800894912000	29393	14491	0	0	\N
385031	1874	10244000	29393	14491	1	0	\N
385032	1678	28800894913000	29394	14492	0	0	\N
385033	1874	10245000	29394	14492	1	0	\N
385034	1874	10247000	29394	14492	2	0	\N
385035	613	66001000000000	29394	14492	3	0	\N
385036	1874	10251000	29394	14492	4	0	\N
385045	1678	28800894915000	29397	14494	0	0	\N
385046	1874	10261000	29397	14494	1	0	\N
385047	1874	10263000	29397	14494	2	0	\N
385048	1678	28800894915000	29398	14494	0	0	\N
385049	1874	10261000	29398	14494	1	0	\N
385050	1874	10263000	29398	14494	2	0	\N
385064	1678	28800894919000	29402	14497	0	0	\N
385065	1874	10280000	29402	14497	1	0	\N
385067	1678	28800894919000	29404	14498	0	0	\N
385068	1678	28800894920000	29404	14498	1	0	\N
385069	1874	10284000	29404	14498	2	0	\N
385070	1874	10285000	29404	14498	3	0	\N
385071	1874	10287000	29404	14498	4	0	\N
385072	1678	28800894911000	29405	14490	0	0	\N
385073	1678	28800894912000	29405	14490	1	0	\N
385074	1678	28800894913000	29405	14490	2	0	\N
385075	1678	28800894914000	29405	14490	3	0	\N
385076	1678	28800894915000	29405	14490	4	0	\N
385077	1678	28800894916000	29405	14490	5	0	\N
385078	1678	28800894917000	29405	14490	6	0	\N
385079	1678	28800894918000	29405	14490	7	0	\N
385080	1678	28800894919000	29405	14490	8	0	\N
385081	1678	28800894920000	29405	14490	9	0	\N
385082	1874	10237000	29405	14490	10	0	\N
385083	613	66001000000000	29405	14490	11	0	\N
385084	2421	334083938283	29405	14490	12	0	\N
385085	1874	10238000	29405	14490	13	0	\N
385086	1874	10239000	29405	14490	14	0	\N
385087	1993	2816848532446	29405	14490	15	0	\N
385088	1874	10243000	29405	14490	16	0	\N
385089	1874	10247000	29405	14490	17	0	\N
385090	1874	10251000	29405	14490	18	0	\N
385091	1874	10255000	29405	14490	19	0	\N
385092	1874	10259000	29405	14490	20	0	\N
385093	1874	10263000	29405	14490	21	0	\N
385094	1874	10267000	29405	14490	22	0	\N
385095	1874	10269000	29405	14490	23	0	\N
385096	1874	10271000	29405	14490	24	0	\N
385097	1874	10273000	29405	14490	25	0	\N
385098	1874	10275000	29405	14490	26	0	\N
385099	1874	10277000	29405	14490	27	0	\N
385100	1874	10279000	29405	14490	28	0	\N
385101	1874	10281000	29405	14490	29	0	\N
385102	1874	10283000	29405	14490	30	0	\N
385103	1874	10285000	29405	14490	31	0	\N
385104	1874	10287000	29405	14490	32	0	\N
385113	1678	28800894922000	29408	14500	0	0	\N
385114	1874	10295000	29408	14500	1	0	\N
385115	2421	543508726895	29408	14500	2	0	\N
385116	1874	10299000	29408	14500	3	0	\N
385121	1678	28800894923000	29410	14501	0	0	\N
385122	1678	28800894924000	29410	14501	2	0	\N
385123	1678	28800894925000	29410	14501	3	0	\N
385124	1874	10303000	29410	14501	4	0	\N
385125	1874	10304000	29410	14501	5	0	\N
385126	1874	10308000	29410	14501	6	0	\N
385127	1874	10310000	29410	14501	7	0	\N
385128	1874	10312000	29410	14501	8	0	\N
385129	1874	10314000	29410	14501	9	0	\N
385139	1684	33843726819412	29413	14310	0	0	\N
385140	2418	100000000	29413	14310	1	0	\N
385141	548	67440000000000	29413	14310	2	0	\N
385142	613	66001000000000	29413	14310	3	0	\N
385143	2421	334083938283	29413	14310	4	0	\N
385144	2421	543508726895	29413	14310	5	0	\N
385145	80	66001000000000	29413	14310	6	0	\N
385146	2419	0	29413	14310	7	0	\N
385147	2420	0	29413	14310	8	0	\N
385148	1684	34563738819412	29414	14502	0	0	\N
385149	1678	28800894926000	29414	14502	1	0	\N
385150	1678	28800894927000	29414	14502	2	0	\N
385151	1678	28800894928000	29414	14502	3	0	\N
385152	1874	10315000	29414	14502	4	0	\N
385037	1678	28800894913000	29395	14492	0	0	1
385038	1874	10245000	29395	14492	1	0	3
385039	1874	10247000	29395	14492	2	0	3
385040	613	66001000000000	29395	14492	3	0	0
385041	1874	10251000	29395	14492	4	0	3
385043	1874	10255000	29396	14493	1	0	3
385044	1874	10257000	29396	14493	2	0	3
385051	1678	28800894915000	29399	14494	0	0	1
385052	1874	10261000	29399	14494	1	0	3
385053	1874	10263000	29399	14494	2	0	3
385055	1678	28800894917000	29400	14495	1	0	1
385056	1874	10265000	29400	14495	2	0	3
385057	1874	10267000	29400	14495	3	0	3
385058	1874	10271000	29400	14495	4	0	3
385060	1678	28800894918000	29401	14496	0	0	1
385061	1874	10276000	29401	14496	1	0	3
385062	2421	334083938283	29401	14496	2	0	0
385063	1874	10278000	29401	14496	3	0	3
385066	1874	10280000	29403	14497	0	0	3
385106	1678	28800894920000	29406	14498	1	0	1
385107	1874	10284000	29406	14498	2	0	3
385108	1874	10285000	29406	14498	3	0	3
385109	1874	10287000	29406	14498	4	0	3
385110	1678	28800894921000	29407	14499	0	0	1
385112	1874	10293000	29407	14499	2	0	3
385117	1678	28800894922000	29409	14500	0	0	1
385118	1874	10295000	29409	14500	1	0	3
385119	2421	543508726895	29409	14500	2	0	0
385130	1678	28800894923000	29411	14501	0	0	1
385131	1678	28800894924000	29411	14501	2	0	1
385132	1678	28800894925000	29411	14501	3	0	1
385133	1874	10303000	29411	14501	4	0	3
385134	1874	10304000	29411	14501	5	0	3
385136	1874	10310000	29411	14501	7	0	3
385137	1874	10312000	29411	14501	8	0	3
385138	1874	10314000	29411	14501	9	0	3
385153	1874	10319000	29414	14502	5	0	\N
385154	1874	10323000	29414	14502	6	0	\N
385155	1874	10325000	29414	14502	7	0	\N
385156	2422	399000000	29414	14502	8	0	\N
385157	1874	10327000	29414	14502	9	0	\N
385158	1874	10329000	29414	14502	10	0	\N
385170	1678	28800894929000	29416	14503	0	0	\N
385171	1874	10333000	29416	14503	1	0	\N
385172	1874	10335000	29416	14503	2	0	\N
385174	1678	28800894930000	29418	14504	0	0	\N
385175	1874	10333000	29418	14504	1	0	\N
385176	1874	10335000	29418	14504	2	0	\N
385177	1874	10336000	29418	14504	3	0	\N
385182	1678	28800894930000	29420	14504	0	0	\N
385183	1874	10333000	29420	14504	1	0	\N
385184	1874	10335000	29420	14504	2	0	\N
385185	1874	10336000	29420	14504	3	0	\N
385189	2423	500000000	29422	14506	0	0	\N
385190	1678	28800894932000	29422	14506	1	0	\N
385191	1874	10346000	29422	14506	2	0	\N
385192	1874	10348000	29422	14506	3	0	\N
385193	2423	500000000	29423	14506	0	0	\N
385194	1678	28800894932000	29423	14506	1	0	\N
385195	1874	10346000	29423	14506	2	0	\N
385196	1874	10348000	29423	14506	3	0	\N
385215	1678	28800894935000	29428	14509	0	0	\N
385216	706	10001000000000	29428	14509	1	0	\N
385217	1874	10359000	29428	14509	2	0	\N
385218	1874	10363000	29428	14509	3	0	\N
385219	1678	28800894936000	29429	14510	0	0	\N
385220	1874	10365000	29429	14510	1	0	\N
385221	1874	10369000	29429	14510	2	0	\N
385222	1678	28800894936000	29430	14510	0	0	\N
385223	1874	10365000	29430	14510	1	0	\N
385224	1874	10369000	29430	14510	2	0	\N
385228	1678	28800894936000	29432	14510	0	0	\N
385229	1874	10365000	29432	14510	1	0	\N
385230	1874	10369000	29432	14510	2	0	\N
385231	1678	28800894936000	29433	14510	0	0	\N
385232	1874	10365000	29433	14510	1	0	\N
385233	1874	10369000	29433	14510	2	0	\N
385234	1678	28800894936000	29434	14510	0	0	\N
385235	1874	10365000	29434	14510	1	0	\N
385236	1874	10369000	29434	14510	2	0	\N
385254	1678	28800894942000	29440	14516	0	0	\N
385255	1678	28800894943000	29440	14516	1	0	\N
385256	1678	28800894944000	29440	14516	2	0	\N
385257	1678	28800894945000	29440	14516	3	0	\N
385258	1874	10397000	29440	14516	4	0	\N
385259	1874	10401000	29440	14516	5	0	\N
385260	1874	10405000	29440	14516	6	0	\N
385261	2424	100000000	29440	14516	7	0	\N
385262	2425	100000000	29440	14516	8	0	\N
385263	1874	10407000	29440	14516	9	0	\N
385264	1874	10409000	29440	14516	10	0	\N
385265	1874	10411000	29440	14516	11	0	\N
385266	1874	10413000	29440	14516	12	0	\N
385267	1874	10414000	29440	14516	13	0	\N
385282	1678	28800894942000	29442	14516	0	0	\N
385283	1678	28800894943000	29442	14516	1	0	\N
385284	1678	28800894944000	29442	14516	2	0	\N
385285	1678	28800894945000	29442	14516	3	0	\N
385286	1874	10397000	29442	14516	4	0	\N
385287	1874	10401000	29442	14516	5	0	\N
385288	1874	10405000	29442	14516	6	0	\N
385161	1678	28800894927000	29415	14502	2	0	1
385162	1678	28800894928000	29415	14502	3	0	1
385163	1874	10315000	29415	14502	4	0	3
385164	1874	10319000	29415	14502	5	0	3
385165	1874	10323000	29415	14502	6	0	3
385167	2422	399000000	29415	14502	8	0	0
385168	1874	10327000	29415	14502	9	0	3
385169	1874	10329000	29415	14502	10	0	3
385173	1678	28800894929000	29417	14503	0	0	1
385178	1678	28800894930000	29419	14504	0	0	1
385180	1874	10335000	29419	14504	2	0	3
385181	1874	10336000	29419	14504	3	0	3
385186	1678	28800894931000	29421	14505	0	0	1
385187	1874	10340000	29421	14505	1	0	3
385197	2423	500000000	29424	14506	0	0	0
385198	1678	28800894932000	29424	14506	1	0	1
385199	1874	10346000	29424	14506	2	0	3
385200	1874	10348000	29424	14506	3	0	3
385201	2423	510000000	29425	14507	0	0	0
385203	2423	520000000	29425	14507	2	0	0
385204	1874	10349000	29425	14507	3	0	3
385205	1874	10351000	29425	14507	4	0	3
385206	2423	1020000000	29426	14508	0	0	0
385207	1678	28800894934000	29426	14508	1	0	1
385209	1874	10355000	29426	14508	3	0	3
385210	1874	10357000	29426	14508	4	0	3
385211	1678	28800894935000	29427	14509	0	0	1
385212	706	10001000000000	29427	14509	1	0	0
385214	1874	10363000	29427	14509	3	0	3
385225	1678	28800894936000	29431	14510	0	0	1
385226	1874	10365000	29431	14510	1	0	3
385227	1874	10369000	29431	14510	2	0	3
385237	1678	28800894937000	29435	14511	0	0	1
385239	1874	10372000	29435	14511	2	0	3
385240	1678	28800894938000	29436	14512	0	0	1
385241	1776	2133002366625	29436	14512	1	0	3
385242	1874	10374000	29436	14512	2	0	3
385243	1874	10378000	29436	14512	3	0	3
385245	1776	2133102366625	29437	14513	1	0	3
385246	1874	10382000	29437	14513	2	0	3
385247	1874	10384000	29437	14513	3	0	3
385248	1678	28800894940000	29438	14514	0	0	1
385250	1874	10387000	29438	14514	2	0	3
385251	1678	28800894941000	29439	14515	0	0	1
385252	1874	10391000	29439	14515	1	0	3
385253	1874	10393000	29439	14515	2	0	3
385268	1678	28800894942000	29441	14516	0	0	1
385270	1678	28800894944000	29441	14516	2	0	1
385271	1678	28800894945000	29441	14516	3	0	1
385272	1874	10397000	29441	14516	4	0	3
385273	1874	10401000	29441	14516	5	0	3
385274	1874	10405000	29441	14516	6	0	3
385276	2425	100000000	29441	14516	8	0	0
385277	1874	10407000	29441	14516	9	0	3
385278	1874	10409000	29441	14516	10	0	3
385279	1874	10411000	29441	14516	11	0	3
385281	1874	10414000	29441	14516	13	0	3
385289	2424	100000000	29442	14516	7	0	\N
385290	2425	100000000	29442	14516	8	0	\N
385291	1874	10407000	29442	14516	9	0	\N
385292	1874	10409000	29442	14516	10	0	\N
385293	1874	10411000	29442	14516	11	0	\N
385294	1874	10413000	29442	14516	12	0	\N
385295	1874	10414000	29442	14516	13	0	\N
385296	1678	28800894946000	29443	14517	0	0	\N
385297	1874	10416000	29443	14517	1	0	\N
385300	1678	28800894946000	29445	14517	0	0	\N
385301	1874	10416000	29445	14517	1	0	\N
385320	1678	28800894952000	29450	14521	0	0	\N
385321	1874	10448000	29450	14521	1	0	\N
385322	1874	10450000	29450	14521	2	0	\N
385334	180	66847791394804	29453	14523	0	0	\N
385335	1678	28800894955000	29453	14523	1	0	\N
385336	1874	10463000	29453	14523	2	0	\N
385337	1874	10465000	29453	14523	3	0	\N
385354	1678	28800894959000	29458	14527	0	0	\N
385355	1678	28800894960000	29458	14527	1	0	\N
385356	345	66001000000000	29458	14527	2	0	\N
385357	1874	10484000	29458	14527	3	0	\N
385358	1874	10485000	29458	14527	4	0	\N
385359	1874	10487000	29458	14527	5	0	\N
385360	1874	10489000	29458	14527	6	0	\N
385361	1678	28800894959000	29459	14527	0	0	\N
385362	1678	28800894960000	29459	14527	1	0	\N
385363	345	66001000000000	29459	14527	2	0	\N
385364	1874	10484000	29459	14527	3	0	\N
385365	1874	10485000	29459	14527	4	0	\N
385366	1874	10487000	29459	14527	5	0	\N
385367	1874	10489000	29459	14527	6	0	\N
385368	1678	28800894959000	29460	14527	0	0	\N
385369	1678	28800894960000	29460	14527	1	0	\N
385370	345	66001000000000	29460	14527	2	0	\N
385371	1874	10484000	29460	14527	3	0	\N
385372	1874	10485000	29460	14527	4	0	\N
385373	1874	10487000	29460	14527	5	0	\N
385374	1874	10489000	29460	14527	6	0	\N
385378	1678	28800894961000	29462	14528	0	0	\N
385379	1874	10493000	29462	14528	1	0	\N
385380	1874	10495000	29462	14528	2	0	\N
385384	1678	28800894962000	29464	14529	0	0	\N
385385	1874	10497000	29464	14529	1	0	\N
385386	1874	10501000	29464	14529	2	0	\N
385395	2402	48039000000	29466	14530	0	0	\N
385396	1678	28800894963000	29466	14530	1	0	\N
385397	1445	1725181000000	29466	14530	2	0	\N
385398	1678	28800894964000	29466	14530	3	0	\N
385399	1874	10503000	29466	14530	4	0	\N
385400	1874	10504000	29466	14530	5	0	\N
385401	1874	10506000	29466	14530	6	0	\N
385402	1874	10510000	29466	14530	7	0	\N
385415	1445	20878181000000	29469	14532	0	0	\N
385416	1678	28800894966000	29469	14532	1	0	\N
385417	1678	28800894967000	29469	14532	2	0	\N
385418	2426	0	29469	14532	3	0	\N
385419	1874	10520000	29469	14532	4	0	\N
385420	1874	10521000	29469	14532	5	0	\N
385421	1874	10523000	29469	14532	6	0	\N
385422	1874	10525000	29469	14532	7	0	\N
385302	1678	28800894947000	29446	14518	2	0	1
385303	1874	10420000	29446	14518	3	0	3
385304	1874	10422000	29446	14518	4	0	3
385305	1874	10423000	29446	14518	5	0	3
385306	1678	28800894948000	29447	14519	0	0	1
385308	1874	10429000	29447	14519	2	0	3
385309	1678	28800894949000	29448	14520	0	0	1
385310	1678	28800894950000	29448	14520	1	0	1
385311	1678	28800894951000	29448	14520	2	0	1
385312	1874	10433000	29448	14520	3	0	3
385314	1874	10436000	29448	14520	5	0	3
385315	1874	10438000	29448	14520	6	0	3
385316	1874	10440000	29448	14520	7	0	3
385317	1874	10444000	29448	14520	8	0	3
385319	1874	10448000	29449	14521	1	0	3
385323	1678	28800894953000	29451	14522	0	0	1
385324	1678	28800894954000	29451	14522	1	0	1
385325	1874	10449000	29451	14522	2	0	3
385326	1874	10453000	29451	14522	3	0	3
385328	1874	10457000	29451	14522	5	0	3
385329	1874	10459000	29451	14522	6	0	3
385330	180	66847791394804	29452	14523	0	0	0
385331	1678	28800894955000	29452	14523	1	0	1
385332	1874	10463000	29452	14523	2	0	3
385338	1678	28800894956000	29454	14524	0	0	1
385339	1874	10467000	29454	14524	1	0	3
385340	1678	28800894957000	29455	14525	0	0	1
385341	1874	10469000	29455	14525	1	0	3
385343	1874	10474000	29455	14525	3	0	3
385344	1678	28800894958000	29456	14526	0	0	1
385345	1874	10476000	29456	14526	1	0	3
385346	1874	10480000	29456	14526	2	0	3
385347	1678	28800894959000	29457	14527	0	0	1
385349	345	66001000000000	29457	14527	2	0	0
385350	1874	10484000	29457	14527	3	0	3
385351	1874	10485000	29457	14527	4	0	3
385352	1874	10487000	29457	14527	5	0	3
385353	1874	10489000	29457	14527	6	0	3
385376	1874	10493000	29461	14528	1	0	3
385377	1874	10495000	29461	14528	2	0	3
385381	1678	28800894962000	29463	14529	0	0	1
385382	1874	10497000	29463	14529	1	0	3
385387	2402	48039000000	29465	14530	0	0	2
385388	1678	28800894963000	29465	14530	1	0	1
385389	1445	1725181000000	29465	14530	2	0	8
385390	1678	28800894964000	29465	14530	3	0	1
385391	1874	10503000	29465	14530	4	0	3
385393	1874	10506000	29465	14530	6	0	3
385394	1874	10510000	29465	14530	7	0	3
385403	1678	28800894965000	29467	14531	0	0	1
385404	1724	18413975500000	29467	14531	1	0	15
385405	1874	10512000	29467	14531	2	0	3
385407	1445	20878181000000	29468	14532	0	0	8
385408	1678	28800894966000	29468	14532	1	0	1
385409	1678	28800894967000	29468	14532	2	0	1
385410	2426	0	29468	14532	3	0	0
385412	1874	10521000	29468	14532	5	0	3
385413	1874	10523000	29468	14532	6	0	3
385414	1874	10525000	29468	14532	7	0	3
385423	2426	1000000000	29470	14533	0	0	0
385424	1678	28800894968000	29470	14533	1	0	1
385430	1678	28800894969000	29472	14534	0	0	\N
385431	1874	10535000	29472	14534	1	0	\N
385432	1874	10537000	29472	14534	2	0	\N
385444	1678	28800894971000	29475	14536	0	0	\N
385445	1507	49990000000	29475	14536	1	0	\N
385446	1678	28800894972000	29475	14536	2	0	\N
385447	1874	10546000	29475	14536	3	0	\N
385448	1874	10550000	29475	14536	4	0	\N
385449	1874	10552000	29475	14536	5	0	\N
385450	2298	907015465626	29475	14536	6	0	\N
385451	1678	28800894973000	29476	14537	1	0	\N
385452	1678	28800894974000	29476	14537	2	0	\N
385453	1678	28800894975000	29476	14537	3	0	\N
385454	1874	10554000	29476	14537	4	0	\N
385455	1874	10555000	29476	14537	5	0	\N
385456	1874	10557000	29476	14537	6	0	\N
385457	1874	10559000	29476	14537	7	0	\N
385458	1874	10563000	29476	14537	8	0	\N
385459	2298	1420366374626	29476	14537	9	0	\N
385460	1874	10567000	29476	14537	10	0	\N
385471	1678	28800894973000	29478	14537	1	0	\N
385472	1678	28800894974000	29478	14537	2	0	\N
385473	1678	28800894975000	29478	14537	3	0	\N
385474	1874	10554000	29478	14537	4	0	\N
385475	1874	10555000	29478	14537	5	0	\N
385476	1874	10557000	29478	14537	6	0	\N
385477	1874	10559000	29478	14537	7	0	\N
385478	1874	10563000	29478	14537	8	0	\N
385479	2298	1420366374626	29478	14537	9	0	\N
385480	1874	10567000	29478	14537	10	0	\N
385481	1678	28800894973000	29479	14537	1	0	\N
385482	1678	28800894974000	29479	14537	2	0	\N
385483	1678	28800894975000	29479	14537	3	0	\N
385484	1874	10554000	29479	14537	4	0	\N
385485	1874	10555000	29479	14537	5	0	\N
385486	1874	10557000	29479	14537	6	0	\N
385487	1874	10559000	29479	14537	7	0	\N
385488	1874	10563000	29479	14537	8	0	\N
385489	2298	1420366374626	29479	14537	9	0	\N
385490	1874	10567000	29479	14537	10	0	\N
385491	1678	28800894973000	29480	14537	1	0	\N
385492	1678	28800894974000	29480	14537	2	0	\N
385493	1678	28800894975000	29480	14537	3	0	\N
385494	1874	10554000	29480	14537	4	0	\N
385495	1874	10555000	29480	14537	5	0	\N
385496	1874	10557000	29480	14537	6	0	\N
385497	1874	10559000	29480	14537	7	0	\N
385498	1874	10563000	29480	14537	8	0	\N
385499	2298	1420366374626	29480	14537	9	0	\N
385500	1874	10567000	29480	14537	10	0	\N
385501	1678	28800894973000	29481	14537	1	0	\N
385502	1678	28800894974000	29481	14537	2	0	\N
385503	1678	28800894975000	29481	14537	3	0	\N
385504	1874	10554000	29481	14537	4	0	\N
385505	1874	10555000	29481	14537	5	0	\N
385506	1874	10557000	29481	14537	6	0	\N
385507	1874	10559000	29481	14537	7	0	\N
385508	1874	10563000	29481	14537	8	0	\N
385509	2298	1420366374626	29481	14537	9	0	\N
385510	1874	10567000	29481	14537	10	0	\N
385511	1678	28800894973000	29482	14537	1	0	\N
385512	1678	28800894974000	29482	14537	2	0	\N
385513	1678	28800894975000	29482	14537	3	0	\N
385514	1874	10554000	29482	14537	4	0	\N
385515	1874	10555000	29482	14537	5	0	\N
385516	1874	10557000	29482	14537	6	0	\N
385517	1874	10559000	29482	14537	7	0	\N
385518	1874	10563000	29482	14537	8	0	\N
385519	2298	1420366374626	29482	14537	9	0	\N
385520	1874	10567000	29482	14537	10	0	\N
385521	1678	28800894976000	29483	14538	0	0	\N
385522	1874	10569000	29483	14538	1	0	\N
385523	1874	10573000	29483	14538	2	0	\N
385524	1678	28800894976000	29484	14538	0	0	\N
385525	1874	10569000	29484	14538	1	0	\N
385526	1874	10573000	29484	14538	2	0	\N
385545	1678	28800894982000	29488	14541	0	0	\N
385546	1678	28800894983000	29488	14541	1	0	\N
385547	1874	10598000	29488	14541	2	0	\N
385548	1874	10602000	29488	14541	3	0	\N
385549	1874	10604000	29488	14541	4	0	\N
385550	1874	10608000	29488	14541	5	0	\N
385551	1874	10610000	29488	14541	6	0	\N
385552	1678	28800894982000	29489	14541	0	0	\N
385553	1678	28800894983000	29489	14541	1	0	\N
385554	1874	10598000	29489	14541	2	0	\N
385555	1874	10602000	29489	14541	3	0	\N
385556	1874	10604000	29489	14541	4	0	\N
385557	1874	10608000	29489	14541	5	0	\N
385558	1874	10610000	29489	14541	6	0	\N
385427	1678	28800894969000	29471	14534	0	0	1
385428	1874	10535000	29471	14534	1	0	3
385429	1874	10537000	29471	14534	2	0	3
385433	1678	28800894970000	29473	14535	0	0	1
385434	1874	10539000	29473	14535	1	0	3
385436	1874	10544000	29473	14535	3	0	3
385437	1678	28800894971000	29474	14536	0	0	1
385438	1507	49990000000	29474	14536	1	0	1
385439	1678	28800894972000	29474	14536	2	0	1
385440	1874	10546000	29474	14536	3	0	3
385442	1874	10552000	29474	14536	5	0	3
385443	2298	907015465626	29474	14536	6	0	1
385461	1678	28800894973000	29477	14537	1	0	1
385462	1678	28800894974000	29477	14537	2	0	1
385464	1874	10554000	29477	14537	4	0	3
385465	1874	10555000	29477	14537	5	0	3
385466	1874	10557000	29477	14537	6	0	3
385467	1874	10559000	29477	14537	7	0	3
385468	1874	10563000	29477	14537	8	0	3
385470	1874	10567000	29477	14537	10	0	3
385527	1678	28800894976000	29485	14538	0	0	1
385528	1874	10569000	29485	14538	1	0	3
385529	1874	10573000	29485	14538	2	0	3
385530	1678	28800894977000	29486	14539	0	0	1
385532	1678	28800894979000	29486	14539	2	0	1
385533	1874	10574000	29486	14539	3	0	3
385534	1874	10578000	29486	14539	4	0	3
385535	1874	10582000	29486	14539	5	0	3
385537	1874	10586000	29486	14539	7	0	3
385538	1874	10588000	29486	14539	8	0	3
385539	1678	28800894980000	29487	14540	0	0	1
385540	1678	28800894981000	29487	14540	1	0	1
385541	1874	10590000	29487	14540	2	0	3
385543	1874	10593000	29487	14540	4	0	3
385544	1874	10597000	29487	14540	5	0	3
385559	1678	28800894982000	29490	14541	0	0	1
385560	1678	28800894983000	29490	14541	1	0	1
385578	1678	28800894988000	29492	14543	0	0	\N
385579	1874	10633000	29492	14543	1	0	\N
385582	1678	28800894989000	29494	14544	0	0	\N
385583	1874	10635000	29494	14544	1	0	\N
385584	1874	10639000	29494	14544	2	0	\N
385585	1678	28800894989000	29495	14544	0	0	\N
385586	1874	10635000	29495	14544	1	0	\N
385587	1874	10639000	29495	14544	2	0	\N
385591	1678	28800894989000	29497	14544	0	0	\N
385592	1874	10635000	29497	14544	1	0	\N
385593	1874	10639000	29497	14544	2	0	\N
385600	1678	28800894992000	29500	14547	0	0	\N
385601	1874	10652000	29500	14547	1	0	\N
385624	1678	28800894998000	29508	14553	0	0	\N
385625	1874	10682000	29508	14553	1	0	\N
385626	2419	1000000000	29508	14553	2	0	\N
385636	1678	28800895000000	29511	14555	0	0	\N
385637	1678	28800895001000	29511	14555	1	0	\N
385638	1874	10689000	29511	14555	3	0	\N
385639	1874	10693000	29511	14555	4	0	\N
385640	1874	10695000	29511	14555	5	0	\N
385641	1874	10697000	29511	14555	6	0	\N
385642	1678	28800895000000	29512	14555	0	0	\N
385643	1678	28800895001000	29512	14555	1	0	\N
385644	1874	10689000	29512	14555	3	0	\N
385645	1874	10693000	29512	14555	4	0	\N
385646	1874	10695000	29512	14555	5	0	\N
385647	1874	10697000	29512	14555	6	0	\N
385652	1678	28800895002000	29514	14556	0	0	\N
385653	1874	10699000	29514	14556	1	0	\N
385654	1874	10703000	29514	14556	2	0	\N
385655	1406	0	29514	14556	3	0	\N
385663	1678	28800895003000	29516	14557	0	0	\N
385664	1678	28800895004000	29516	14557	1	0	\N
385665	1874	10704000	29516	14557	2	0	\N
385666	1874	10708000	29516	14557	4	0	\N
385667	1874	10712000	29516	14557	5	0	\N
385668	1874	10714000	29516	14557	6	0	\N
385669	1874	10716000	29516	14557	7	0	\N
385670	1678	28800895003000	29517	14557	0	0	\N
385671	1678	28800895004000	29517	14557	1	0	\N
385672	1874	10704000	29517	14557	2	0	\N
385673	1874	10708000	29517	14557	4	0	\N
385674	1874	10712000	29517	14557	5	0	\N
385675	1874	10714000	29517	14557	6	0	\N
385676	1874	10716000	29517	14557	7	0	\N
385690	1874	10735000	29520	14559	0	0	\N
385691	1874	10737000	29520	14559	1	0	\N
385692	1874	10735000	29521	14559	0	0	\N
385693	1874	10737000	29521	14559	1	0	\N
385694	1874	10735000	29522	14559	0	0	\N
385695	1874	10737000	29522	14559	1	0	\N
385696	1874	10735000	29523	14559	0	0	\N
385563	1874	10604000	29490	14541	4	0	3
385564	1874	10608000	29490	14541	5	0	3
385565	1874	10610000	29490	14541	6	0	3
385566	1678	28800894984000	29491	14542	0	0	1
385567	1678	28800894985000	29491	14542	1	0	1
385569	1678	28800894987000	29491	14542	3	0	1
385570	1874	10611000	29491	14542	4	0	3
385571	1874	10615000	29491	14542	5	0	3
385572	1874	10619000	29491	14542	6	0	3
385573	1874	10621000	29491	14542	7	0	3
385575	1874	10625000	29491	14542	9	0	3
385576	1874	10627000	29491	14542	10	0	3
385577	1874	10631000	29491	14542	11	0	3
385580	1678	28800894988000	29493	14543	0	0	1
385588	1678	28800894989000	29496	14544	0	0	1
385589	1874	10635000	29496	14544	1	0	3
385590	1874	10639000	29496	14544	2	0	3
385594	1678	28800894990000	29498	14545	0	0	1
385595	1874	10640000	29498	14545	1	0	3
385597	1874	10646000	29498	14545	3	0	3
385598	1678	28800894991000	29499	14546	0	0	1
385599	1874	10648000	29499	14546	1	0	3
385602	1678	28800894992000	29501	14547	0	0	1
385603	1874	10652000	29501	14547	1	0	3
385605	1874	10653000	29502	14548	1	0	3
385606	1874	10655000	29502	14548	2	0	3
385607	1874	10659000	29502	14548	3	0	3
385608	1678	28800894994000	29503	14549	0	0	1
385610	1678	28800894995000	29504	14550	0	0	1
385611	1874	10665000	29504	14550	1	0	3
385612	1874	10667000	29504	14550	2	0	3
385613	1678	28800894996000	29505	14551	0	0	1
385614	1874	10669000	29505	14551	1	0	3
385616	599	67439923000000	29506	14552	0	0	1
385617	1678	28800894997000	29506	14552	1	0	1
385618	1874	10675000	29506	14552	2	0	3
385619	1874	10676000	29506	14552	3	0	3
385620	1874	10680000	29506	14552	4	0	3
385622	1874	10682000	29507	14553	1	0	3
385623	2419	1000000000	29507	14553	2	0	0
385627	1678	28800894999000	29509	14554	0	0	1
385628	1874	10684000	29509	14554	2	0	3
385630	1678	28800895000000	29510	14555	0	0	1
385631	1678	28800895001000	29510	14555	1	0	1
385632	1874	10689000	29510	14555	3	0	3
385633	1874	10693000	29510	14555	4	0	3
385634	1874	10695000	29510	14555	5	0	3
385648	1678	28800895002000	29513	14556	0	0	1
385649	1874	10699000	29513	14556	1	0	3
385650	1874	10703000	29513	14556	2	0	3
385651	1406	0	29513	14556	3	0	0
385656	1678	28800895003000	29515	14557	0	0	1
385658	1874	10704000	29515	14557	2	0	3
385659	1874	10708000	29515	14557	4	0	3
385660	1874	10712000	29515	14557	5	0	3
385661	1874	10714000	29515	14557	6	0	3
385677	1678	28800895005000	29518	14558	0	0	1
385678	1678	28800895006000	29518	14558	1	0	1
385679	1678	28800895007000	29518	14558	2	0	1
385680	1874	10717000	29518	14558	3	0	3
385681	1874	10719000	29518	14558	4	0	3
385683	1874	10725000	29518	14558	6	0	3
385684	1874	10729000	29518	14558	7	0	3
385685	599	67439923090000	29518	14558	8	0	1
385686	599	67439923180000	29518	14558	9	0	1
385687	1874	10731000	29518	14558	10	0	3
385689	1874	10737000	29519	14559	1	0	3
385697	1874	10737000	29523	14559	1	0	\N
385698	1678	28800895008000	29524	14560	0	0	\N
385699	1678	28800895009000	29524	14560	1	0	\N
385700	1874	10739000	29524	14560	2	0	\N
385701	1874	10740000	29524	14560	3	0	\N
385702	1874	10742000	29524	14560	4	0	\N
385703	1874	10746000	29524	14560	5	0	\N
385710	1678	28800895010000	29526	14561	0	0	\N
385711	693	66000100000000	29526	14561	1	0	\N
385712	1874	10748000	29526	14561	2	0	\N
385713	1874	10752000	29526	14561	3	0	\N
385720	180	66847791394804	29529	14341	0	0	\N
385721	1684	33843726819412	29529	14341	2	0	\N
385722	2423	500000000	29529	14341	4	0	\N
385723	121	66000099000000	29529	14341	5	0	\N
385724	2423	510000000	29529	14341	6	0	\N
385725	1678	28800894706000	29529	14341	7	0	\N
385726	1678	28800894707000	29529	14341	8	0	\N
385727	596	84178432000000	29529	14341	9	0	\N
385728	1678	28800894708000	29529	14341	10	0	\N
385729	1678	28800894709000	29529	14341	12	0	\N
385730	1445	1005169000000	29529	14341	13	0	\N
385731	1445	20158169000000	29529	14341	14	0	\N
385732	1678	28800894710000	29529	14341	15	0	\N
385733	1678	28800894711000	29529	14341	16	0	\N
385734	1678	28800894712000	29529	14341	17	0	\N
385735	1678	28800894713000	29529	14341	18	0	\N
385736	2423	520000000	29529	14341	19	0	\N
385737	2423	1020000000	29529	14341	20	0	\N
385738	1678	28800894714000	29529	14341	21	0	\N
385739	1678	28800894715000	29529	14341	22	0	\N
385740	1678	28800894716000	29529	14341	23	0	\N
385741	1678	28800894717000	29529	14341	24	0	\N
385742	1678	28800894718000	29529	14341	25	0	\N
385743	1678	28800894719000	29529	14341	26	0	\N
385744	1678	28800894720000	29529	14341	27	0	\N
385745	1678	28800894721000	29529	14341	28	0	\N
385746	1678	28800894722000	29529	14341	29	0	\N
385747	1678	28800894723000	29529	14341	30	0	\N
385748	1678	28800894724000	29529	14341	31	0	\N
385749	1678	28800894725000	29529	14341	32	0	\N
385750	1678	28800894726000	29529	14341	33	0	\N
385751	1678	28800894727000	29529	14341	34	0	\N
385752	1678	28800894728000	29529	14341	35	0	\N
385753	1678	28800894729000	29529	14341	36	0	\N
385754	1678	28800894730000	29529	14341	37	0	\N
385755	1678	28800894731000	29529	14341	38	0	\N
385756	1678	28800894732000	29529	14341	39	0	\N
385757	1678	28800894733000	29529	14341	40	0	\N
385758	1678	28800894734000	29529	14341	41	0	\N
385759	1678	28800894735000	29529	14341	42	0	\N
385760	1678	28800894736000	29529	14341	43	0	\N
385761	1678	28800894737000	29529	14341	44	0	\N
385762	1678	28800894738000	29529	14341	45	0	\N
385763	1678	28800894739000	29529	14341	46	0	\N
385764	1678	28800894740000	29529	14341	47	0	\N
385765	1678	28800894741000	29529	14341	48	0	\N
385766	1678	28800894742000	29529	14341	49	0	\N
385767	1678	28800894743000	29529	14341	50	0	\N
385768	1678	28800894744000	29529	14341	51	0	\N
385769	1678	28800894745000	29529	14341	52	0	\N
385770	1678	28800894746000	29529	14341	53	0	\N
385771	1678	28800894747000	29529	14341	54	0	\N
385772	1678	28800894748000	29529	14341	55	0	\N
385773	1678	28800894749000	29529	14341	56	0	\N
385774	1678	28800894750000	29529	14341	57	0	\N
385775	1678	28800894751000	29529	14341	58	0	\N
385776	1678	28800894752000	29529	14341	59	0	\N
385777	1678	28800894753000	29529	14341	60	0	\N
385778	1678	28800894754000	29529	14341	61	0	\N
385779	1678	28800894755000	29529	14341	62	0	\N
385780	1678	28800894756000	29529	14341	63	0	\N
385781	1678	28800894757000	29529	14341	64	0	\N
385782	1678	28800894758000	29529	14341	65	0	\N
385783	1678	28800894759000	29529	14341	66	0	\N
385784	1678	28800894760000	29529	14341	67	0	\N
385785	1678	28800894761000	29529	14341	68	0	\N
385786	1678	28800894762000	29529	14341	69	0	\N
385787	1678	28800894763000	29529	14341	70	0	\N
385788	1678	28800894764000	29529	14341	71	0	\N
385789	1678	28800894765000	29529	14341	72	0	\N
385790	1678	28800894766000	29529	14341	73	0	\N
385791	1678	28800894767000	29529	14341	74	0	\N
385792	1678	28800894768000	29529	14341	75	0	\N
385793	1678	28800894769000	29529	14341	76	0	\N
385794	1678	28800894770000	29529	14341	77	0	\N
385795	1678	28800894771000	29529	14341	78	0	\N
385796	1678	28800894772000	29529	14341	79	0	\N
385797	1678	28800894773000	29529	14341	80	0	\N
385798	1678	28800894774000	29529	14341	81	0	\N
385799	1678	28800894775000	29529	14341	82	0	\N
385800	1678	28800894776000	29529	14341	83	0	\N
385801	1678	28800894777000	29529	14341	84	0	\N
385802	1678	28800894778000	29529	14341	85	0	\N
385803	1678	28800894779000	29529	14341	86	0	\N
385804	1678	28800894780000	29529	14341	87	0	\N
385805	1678	28800894781000	29529	14341	88	0	\N
385806	1678	28800894782000	29529	14341	89	0	\N
385807	1678	28800894783000	29529	14341	90	0	\N
385808	1678	28800894784000	29529	14341	91	0	\N
385809	1678	28800894785000	29529	14341	92	0	\N
385810	1678	28800894786000	29529	14341	93	0	\N
385811	1678	28800894787000	29529	14341	95	0	\N
385812	1678	28800894788000	29529	14341	96	0	\N
385813	1678	28800894789000	29529	14341	97	0	\N
385814	1678	28800895012000	29530	14563	0	0	\N
385815	1874	10756000	29530	14563	1	0	\N
385816	1874	10757000	29530	14563	2	0	\N
385817	1874	10761000	29530	14563	3	0	\N
385818	1678	28800895012000	29531	14563	0	0	\N
385819	1874	10756000	29531	14563	1	0	\N
385820	1874	10757000	29531	14563	2	0	\N
385821	1874	10761000	29531	14563	3	0	\N
385822	1678	28800895012000	29532	14563	0	0	\N
385823	1874	10756000	29532	14563	1	0	\N
385824	1874	10757000	29532	14563	2	0	\N
385825	1874	10761000	29532	14563	3	0	\N
385830	1678	28800895012000	29534	14563	0	0	\N
385831	1874	10756000	29534	14563	1	0	\N
385832	1874	10757000	29534	14563	2	0	\N
385706	1874	10739000	29525	14560	2	0	3
385707	1874	10740000	29525	14560	3	0	3
385708	1874	10742000	29525	14560	4	0	3
385709	1874	10746000	29525	14560	5	0	3
385714	1678	28800895010000	29527	14561	0	0	1
385716	1874	10748000	29527	14561	2	0	3
385717	1874	10752000	29527	14561	3	0	3
385718	1678	28800895011000	29528	14562	0	0	1
385719	1874	10754000	29528	14562	1	0	3
385826	1678	28800895012000	29533	14563	0	0	1
385828	1874	10757000	29533	14563	2	0	3
385829	1874	10761000	29533	14563	3	0	3
385833	1874	10761000	29534	14563	3	0	\N
385834	1678	28800895013000	29536	14564	0	0	\N
385835	1874	10763000	29536	14564	1	0	\N
385836	1874	10767000	29536	14564	2	0	\N
385840	1678	28800895013000	29538	14564	0	0	\N
385841	1874	10763000	29538	14564	1	0	\N
385842	1874	10767000	29538	14564	2	0	\N
385849	1678	28800895016000	29542	14566	0	0	\N
385850	1678	28800895017000	29542	14566	1	0	\N
385851	1874	10779000	29542	14566	2	0	\N
385852	1874	10780000	29542	14566	3	0	\N
385853	1874	10782000	29542	14566	4	0	\N
385854	1874	10784000	29542	14566	5	0	\N
385861	1678	28800895016000	29544	14566	0	0	\N
385862	1678	28800895017000	29544	14566	1	0	\N
385863	1874	10779000	29544	14566	2	0	\N
385864	1874	10780000	29544	14566	3	0	\N
385865	1874	10782000	29544	14566	4	0	\N
385866	1874	10784000	29544	14566	5	0	\N
385870	1678	28800895019000	29546	14568	0	0	\N
385871	1678	28800895020000	29546	14568	1	0	\N
385872	1874	10794000	29546	14568	2	0	\N
385873	1874	10796000	29546	14568	3	0	\N
385874	1874	10798000	29546	14568	4	0	\N
385875	1874	10799000	29546	14568	5	0	\N
385876	1874	10803000	29546	14568	6	0	\N
385884	1678	28800895019000	29548	14568	0	0	\N
385885	1678	28800895020000	29548	14568	1	0	\N
385886	1874	10794000	29548	14568	2	0	\N
385887	1874	10796000	29548	14568	3	0	\N
385888	1874	10798000	29548	14568	4	0	\N
385889	1874	10799000	29548	14568	5	0	\N
385890	1874	10803000	29548	14568	6	0	\N
385891	1678	28800895019000	29549	14568	0	0	\N
385892	1678	28800895020000	29549	14568	1	0	\N
385893	1874	10794000	29549	14568	2	0	\N
385894	1874	10796000	29549	14568	3	0	\N
385895	1874	10798000	29549	14568	4	0	\N
385896	1874	10799000	29549	14568	5	0	\N
385897	1874	10803000	29549	14568	6	0	\N
385908	1678	28800895022000	29552	14570	0	0	\N
385909	1678	28800895023000	29552	14570	1	0	\N
385910	1874	10806000	29552	14570	2	0	\N
385911	1874	10810000	29552	14570	3	0	\N
385912	1504	157243000000	29552	14570	4	0	\N
385913	1874	10814000	29552	14570	5	0	\N
385914	1678	28800895022000	29553	14570	0	0	\N
385915	1678	28800895023000	29553	14570	1	0	\N
385916	1874	10806000	29553	14570	2	0	\N
385917	1874	10810000	29553	14570	3	0	\N
385918	1874	10812000	29553	14570	4	0	\N
385919	1504	157243000000	29553	14570	5	0	\N
385920	1874	10814000	29553	14570	6	0	\N
385921	1874	10818000	29553	14570	7	0	\N
385922	1678	28800895022000	29554	14570	0	0	\N
385923	1678	28800895023000	29554	14570	1	0	\N
385924	1874	10806000	29554	14570	2	0	\N
385925	1874	10810000	29554	14570	3	0	\N
385926	1874	10812000	29554	14570	4	0	\N
385927	1504	157243000000	29554	14570	5	0	\N
385928	1874	10814000	29554	14570	6	0	\N
385929	1874	10818000	29554	14570	7	0	\N
385930	180	66847791394804	29555	14362	0	0	\N
385931	1684	33843726819412	29555	14362	2	0	\N
385932	2423	500000000	29555	14362	4	0	\N
385933	2423	510000000	29555	14362	5	0	\N
385934	596	84178432000000	29555	14362	6	0	\N
385935	1678	28800894789000	29555	14362	7	0	\N
385936	1678	28800894790000	29555	14362	8	0	\N
385937	1445	1005169000000	29555	14362	10	0	\N
385938	1445	20158169000000	29555	14362	11	0	\N
385939	1678	28800894791000	29555	14362	12	0	\N
385940	1678	28800894792000	29555	14362	13	0	\N
385941	1678	28800894793000	29555	14362	14	0	\N
385942	1678	28800894794000	29555	14362	15	0	\N
385943	1678	28800894795000	29555	14362	16	0	\N
385944	1678	28800894796000	29555	14362	17	0	\N
385945	1678	28800894797000	29555	14362	18	0	\N
385946	1678	28800894798000	29555	14362	19	0	\N
385947	1678	28800894799000	29555	14362	20	0	\N
385948	1678	28800894800000	29555	14362	21	0	\N
385949	1678	28800894801000	29555	14362	22	0	\N
385950	1678	28800894802000	29555	14362	23	0	\N
385951	2423	520000000	29555	14362	24	0	\N
385952	2423	1020000000	29555	14362	25	0	\N
385953	1678	28800894803000	29555	14362	26	0	\N
385954	1678	28800894804000	29555	14362	27	0	\N
385955	1678	28800894805000	29555	14362	28	0	\N
385956	1678	28800894806000	29555	14362	29	0	\N
385957	1678	28800894807000	29555	14362	30	0	\N
385958	1678	28800894808000	29555	14362	31	0	\N
385959	1678	28800894809000	29555	14362	32	0	\N
385960	1678	28800894810000	29555	14362	33	0	\N
385961	1678	28800894811000	29555	14362	34	0	\N
385962	1678	28800894812000	29555	14362	35	0	\N
385963	1678	28800894813000	29555	14362	36	0	\N
385964	1678	28800894814000	29555	14362	37	0	\N
385965	1678	28800894815000	29555	14362	38	0	\N
385966	1678	28800894816000	29555	14362	39	0	\N
385967	1678	28800894817000	29555	14362	40	0	\N
385968	1678	28800894818000	29555	14362	41	0	\N
385839	1874	10767000	29537	14564	2	0	3
385843	1678	28800895014000	29541	14565	0	0	1
385844	1678	28800895015000	29541	14565	1	0	1
385845	1874	10769000	29541	14565	2	0	3
385846	1874	10773000	29541	14565	3	0	3
385848	1874	10775000	29541	14565	6	0	3
385855	1678	28800895016000	29543	14566	0	0	1
385856	1678	28800895017000	29543	14566	1	0	1
385857	1874	10779000	29543	14566	2	0	3
385858	1874	10780000	29543	14566	3	0	3
385860	1874	10784000	29543	14566	5	0	3
385867	1678	28800895018000	29545	14567	0	0	1
385868	1874	10786000	29545	14567	1	0	3
385869	1874	10790000	29545	14567	2	0	3
385878	1678	28800895020000	29547	14568	1	0	1
385879	1874	10794000	29547	14568	2	0	3
385880	1874	10796000	29547	14568	3	0	3
385881	1874	10798000	29547	14568	4	0	3
385882	1874	10799000	29547	14568	5	0	3
385898	1678	28800895021000	29550	14569	0	0	1
385899	1874	10805000	29550	14569	1	0	3
385900	1678	28800895022000	29551	14570	0	0	1
385901	1678	28800895023000	29551	14570	1	0	1
385902	1874	10806000	29551	14570	2	0	3
385904	1874	10812000	29551	14570	4	0	3
385905	1504	157243000000	29551	14570	5	0	12
385906	1874	10814000	29551	14570	6	0	3
385907	1874	10818000	29551	14570	7	0	3
385969	1678	28800894819000	29555	14362	42	0	\N
385970	1678	28800894820000	29555	14362	43	0	\N
385971	1678	28800894821000	29555	14362	44	0	\N
385972	1678	28800894822000	29555	14362	45	0	\N
385973	1678	28800894823000	29555	14362	46	0	\N
385974	1678	28800894824000	29555	14362	47	0	\N
385975	1678	28800894825000	29555	14362	48	0	\N
385976	1678	28800894826000	29555	14362	49	0	\N
385977	1678	28800894827000	29555	14362	50	0	\N
385978	1678	28800894828000	29555	14362	51	0	\N
385979	1678	28800894829000	29555	14362	52	0	\N
385980	1678	28800894830000	29555	14362	53	0	\N
385981	1678	28800894831000	29555	14362	54	0	\N
385982	1678	28800894832000	29555	14362	55	0	\N
385983	1678	28800894833000	29555	14362	56	0	\N
385984	1678	28800894834000	29555	14362	57	0	\N
385985	1678	28800894835000	29555	14362	58	0	\N
385986	1678	28800894836000	29555	14362	59	0	\N
385987	1678	28800894837000	29555	14362	60	0	\N
385988	1678	28800894838000	29555	14362	61	0	\N
385989	1678	28800894839000	29555	14362	62	0	\N
385990	1678	28800894840000	29555	14362	63	0	\N
385991	1678	28800894841000	29555	14362	64	0	\N
385992	1678	28800894842000	29555	14362	65	0	\N
385993	1678	28800894843000	29555	14362	66	0	\N
385994	1678	28800894844000	29555	14362	67	0	\N
385995	1678	28800894845000	29555	14362	68	0	\N
385996	1678	28800894846000	29555	14362	69	0	\N
385997	1678	28800894847000	29555	14362	70	0	\N
385998	1678	28800894848000	29555	14362	71	0	\N
385999	1678	28800894849000	29555	14362	72	0	\N
386000	1678	28800894850000	29555	14362	73	0	\N
386001	1678	28800894851000	29555	14362	74	0	\N
386002	1678	28800894852000	29555	14362	75	0	\N
386003	1678	28800894853000	29555	14362	76	0	\N
386004	1678	28800894854000	29555	14362	77	0	\N
386005	1678	28800894855000	29555	14362	78	0	\N
386006	1678	28800894856000	29555	14362	79	0	\N
386007	1678	28800894857000	29555	14362	80	0	\N
386008	1678	28800894858000	29555	14362	81	0	\N
386009	1678	28800894859000	29555	14362	82	0	\N
386010	1678	28800894860000	29555	14362	84	0	\N
386011	1678	28800894861000	29555	14362	85	0	\N
386012	1678	28800894862000	29555	14362	86	0	\N
386013	1678	28800894863000	29555	14362	87	0	\N
386014	1678	28800894864000	29555	14362	88	0	\N
386015	1678	28800894865000	29555	14362	89	0	\N
386016	1678	28800894866000	29555	14362	90	0	\N
386017	1678	28800894867000	29555	14362	91	0	\N
386018	1678	28800894868000	29555	14362	92	0	\N
386019	1678	28800894869000	29555	14362	93	0	\N
386020	1678	28800894870000	29555	14362	94	0	\N
386021	1678	28800894871000	29555	14362	95	0	\N
386022	1678	28800894872000	29555	14362	96	0	\N
386023	1678	28800894873000	29555	14362	97	0	\N
386024	1678	28800894874000	29555	14362	98	0	\N
386025	1678	28800894875000	29555	14362	99	0	\N
386026	1678	28800894876000	29555	14362	100	0	\N
386027	1678	28800894877000	29555	14362	101	0	\N
386028	1678	28800894878000	29555	14362	102	0	\N
386029	1678	28800894879000	29555	14362	103	0	\N
386030	1678	28800894880000	29555	14362	104	0	\N
386031	1678	28800894881000	29555	14362	105	0	\N
386032	1678	28800894882000	29555	14362	106	0	\N
386033	1678	28800894883000	29555	14362	107	0	\N
386034	1678	28800894884000	29555	14362	108	0	\N
386035	1678	28800894885000	29555	14362	109	0	\N
386036	1678	28800894886000	29555	14362	110	0	\N
386037	1678	28800894887000	29555	14362	111	0	\N
386038	1678	28800894888000	29555	14362	112	0	\N
386039	1678	28800894889000	29555	14362	113	0	\N
386040	1678	28800894890000	29555	14362	114	0	\N
386041	1678	28800894891000	29555	14362	115	0	\N
386042	1678	28800894892000	29555	14362	116	0	\N
386043	1678	28800894893000	29555	14362	117	0	\N
386044	1678	28800894894000	29555	14362	118	0	\N
386045	1678	28800894895000	29555	14362	119	0	\N
386046	1678	28800894896000	29555	14362	120	0	\N
386047	1678	28800894897000	29555	14362	121	0	\N
386048	1678	28800894898000	29555	14362	122	0	\N
386049	1678	28800894899000	29555	14362	123	0	\N
386050	1678	28800894900000	29555	14362	124	0	\N
386051	1678	28800894901000	29555	14362	125	0	\N
386055	1678	28800895024000	29557	14571	0	0	\N
386056	1560	18728880131803	29557	14571	1	0	\N
386057	1874	10820000	29557	14571	2	0	\N
386065	1678	28800894995000	29560	14550	0	0	\N
386066	1678	28800894996000	29560	14550	1	0	\N
386067	599	67439923000000	29560	14550	2	0	\N
386068	1678	28800894997000	29560	14550	3	0	\N
386069	1678	28800894998000	29560	14550	4	0	\N
386070	1678	28800894999000	29560	14550	5	0	\N
386071	1678	28800895000000	29560	14550	6	0	\N
386072	1678	28800895001000	29560	14550	7	0	\N
386073	1678	28800895002000	29560	14550	8	0	\N
386074	1678	28800895003000	29560	14550	9	0	\N
386075	1678	28800895004000	29560	14550	10	0	\N
386076	1678	28800895005000	29560	14550	11	0	\N
386077	1678	28800895006000	29560	14550	12	0	\N
386078	1678	28800895007000	29560	14550	13	0	\N
386079	1678	28800895008000	29560	14550	14	0	\N
386080	1678	28800895009000	29560	14550	15	0	\N
386081	1678	28800895010000	29560	14550	16	0	\N
386082	1678	28800895011000	29560	14550	17	0	\N
386083	1678	28800895012000	29560	14550	18	0	\N
386084	1678	28800895013000	29560	14550	19	0	\N
386085	1678	28800895014000	29560	14550	20	0	\N
386086	1678	28800895015000	29560	14550	21	0	\N
386087	1678	28800895016000	29560	14550	22	0	\N
386088	1678	28800895017000	29560	14550	23	0	\N
386089	1678	28800895018000	29560	14550	24	0	\N
386090	1678	28800895019000	29560	14550	25	0	\N
386091	1678	28800895020000	29560	14550	26	0	\N
386092	1678	28800895021000	29560	14550	27	0	\N
386093	1678	28800895022000	29560	14550	28	0	\N
386094	1678	28800895023000	29560	14550	29	0	\N
386095	1678	28800895024000	29560	14550	30	0	\N
386096	1678	28800895025000	29560	14550	31	0	\N
386097	1678	28800895026000	29560	14550	32	0	\N
386098	1560	18728880131803	29560	14550	33	0	\N
386099	1874	10665000	29560	14550	35	0	\N
386100	2419	1000000000	29560	14550	36	0	\N
386101	693	66000100000000	29560	14550	37	0	\N
386102	1874	10669000	29560	14550	38	0	\N
386103	599	67439923090000	29560	14550	39	0	\N
386104	599	67439923180000	29560	14550	40	0	\N
386054	1874	10820000	29556	14571	2	0	3
386058	1678	28800895025000	29558	14572	0	0	1
386059	1874	10824000	29558	14572	1	0	3
386060	1874	10826000	29558	14572	2	0	3
386061	1678	28800895026000	29559	14573	0	0	1
386063	1874	10832000	29559	14573	2	0	3
386064	1874	10833000	29559	14573	3	0	3
386105	1406	0	29560	14550	42	0	\N
386106	113	66001000000000	29560	14550	43	0	\N
386107	1874	10671000	29560	14550	44	0	\N
386108	1874	10673000	29560	14550	45	0	\N
386109	1874	10675000	29560	14550	47	0	\N
386110	1874	10677000	29560	14550	48	0	\N
386111	1874	10679000	29560	14550	49	0	\N
386112	1874	10680000	29560	14550	50	0	\N
386113	1874	10681000	29560	14550	51	0	\N
386114	1874	10682000	29560	14550	52	0	\N
386115	1874	10683000	29560	14550	53	0	\N
386116	1874	10684000	29560	14550	54	0	\N
386117	1874	10685000	29560	14550	55	0	\N
386118	1874	10686000	29560	14550	56	0	\N
386119	1874	10687000	29560	14550	57	0	\N
386120	1874	10688000	29560	14550	58	0	\N
386121	1874	10689000	29560	14550	59	0	\N
386122	1874	10691000	29560	14550	60	0	\N
386123	1874	10693000	29560	14550	61	0	\N
386124	1874	10695000	29560	14550	62	0	\N
386125	1874	10697000	29560	14550	63	0	\N
386126	1874	10699000	29560	14550	64	0	\N
386127	1874	10701000	29560	14550	65	0	\N
386128	1874	10703000	29560	14550	66	0	\N
386129	1874	10705000	29560	14550	67	0	\N
386130	1874	10707000	29560	14550	68	0	\N
386131	1874	10709000	29560	14550	69	0	\N
386132	1874	10711000	29560	14550	70	0	\N
386133	1874	10713000	29560	14550	71	0	\N
386134	1874	10715000	29560	14550	72	0	\N
386135	1874	10717000	29560	14550	73	0	\N
386136	1874	10719000	29560	14550	74	0	\N
386137	1874	10721000	29560	14550	75	0	\N
386138	1874	10723000	29560	14550	76	0	\N
386139	1874	10725000	29560	14550	77	0	\N
386140	1874	10727000	29560	14550	78	0	\N
386141	1874	10729000	29560	14550	79	0	\N
386142	1874	10731000	29560	14550	80	0	\N
386143	1874	10733000	29560	14550	81	0	\N
386144	1874	10735000	29560	14550	82	0	\N
386145	1874	10737000	29560	14550	83	0	\N
386146	1874	10739000	29560	14550	84	0	\N
386147	1874	10741000	29560	14550	85	0	\N
386148	1874	10743000	29560	14550	86	0	\N
386149	1874	10745000	29560	14550	87	0	\N
386150	1874	10749000	29560	14550	88	0	\N
386151	1874	10753000	29560	14550	89	0	\N
386152	1874	10757000	29560	14550	90	0	\N
386153	1874	10761000	29560	14550	91	0	\N
386154	1874	10765000	29560	14550	92	0	\N
386155	1874	10769000	29560	14550	93	0	\N
386156	1874	10773000	29560	14550	94	0	\N
386157	1874	10777000	29560	14550	95	0	\N
386158	1874	10781000	29560	14550	96	0	\N
386159	1874	10785000	29560	14550	97	0	\N
386160	1874	10789000	29560	14550	98	0	\N
386161	1874	10793000	29560	14550	99	0	\N
386162	1874	10797000	29560	14550	100	0	\N
386163	1874	10801000	29560	14550	101	0	\N
386164	1874	10805000	29560	14550	102	0	\N
386165	1874	10809000	29560	14550	103	0	\N
386166	1874	10813000	29560	14550	104	0	\N
386167	1874	10817000	29560	14550	105	0	\N
386168	1874	10821000	29560	14550	106	0	\N
386169	1874	10825000	29560	14550	107	0	\N
386170	1874	10829000	29560	14550	108	0	\N
386171	1874	10833000	29560	14550	109	0	\N
386184	1678	28800895031000	29563	14576	0	0	\N
386185	1874	10856000	29563	14576	1	0	\N
386192	1678	28800895033000	29566	14578	0	0	\N
386193	1678	28800895034000	29566	14578	1	0	\N
386194	1874	10867000	29566	14578	2	0	\N
386195	1874	10871000	29566	14578	3	0	\N
386196	1874	10873000	29566	14578	4	0	\N
386197	1874	10875000	29566	14578	5	0	\N
386198	1678	28800895033000	29567	14578	0	0	\N
386199	1678	28800895034000	29567	14578	1	0	\N
386200	1874	10867000	29567	14578	2	0	\N
386201	1874	10871000	29567	14578	3	0	\N
386202	1874	10873000	29567	14578	4	0	\N
386203	1874	10875000	29567	14578	5	0	\N
386210	1678	28800895033000	29569	14578	0	0	\N
386211	1678	28800895034000	29569	14578	1	0	\N
386212	1874	10867000	29569	14578	2	0	\N
386213	1874	10871000	29569	14578	3	0	\N
386214	1874	10873000	29569	14578	4	0	\N
386215	1874	10875000	29569	14578	5	0	\N
386222	1678	28800895037000	29571	14580	0	0	\N
386223	1874	10886000	29571	14580	1	0	\N
386224	1874	10890000	29571	14580	2	0	\N
386225	1678	28800895037000	29572	14580	0	0	\N
386226	1874	10886000	29572	14580	1	0	\N
386227	1874	10890000	29572	14580	2	0	\N
386174	1678	28800895028000	29562	14575	0	0	1
386175	1678	28800895029000	29562	14575	1	0	1
386176	1678	28800895030000	29562	14575	2	0	1
386177	1874	10837000	29562	14575	3	0	3
386178	1874	10841000	29562	14575	4	0	3
386180	1874	10849000	29562	14575	6	0	3
386181	1874	10850000	29562	14575	7	0	3
386182	1874	10852000	29562	14575	8	0	3
386183	1874	10854000	29562	14575	9	0	3
386186	1678	28800895031000	29564	14576	0	0	1
386188	1678	28800895032000	29565	14577	0	0	1
386189	1874	10857000	29565	14577	1	0	3
386190	1874	10859000	29565	14577	2	0	3
386191	1874	10863000	29565	14577	3	0	3
386205	1678	28800895034000	29568	14578	1	0	1
386206	1874	10867000	29568	14578	2	0	3
386207	1874	10871000	29568	14578	3	0	3
386208	1874	10873000	29568	14578	4	0	3
386209	1874	10875000	29568	14578	5	0	3
386217	1678	28800895036000	29570	14579	1	0	1
386218	1874	10877000	29570	14579	2	0	3
386219	1874	10878000	29570	14579	3	0	3
386220	1874	10880000	29570	14579	4	0	3
386221	1874	10884000	29570	14579	5	0	3
386229	1874	10888000	29573	14580	1	0	3
386230	1678	28800895038000	29574	14581	0	0	1
386231	1874	10890000	29574	14581	1	0	3
386232	1874	10892000	29574	14581	2	0	3
386234	1874	10894000	29575	14582	1	0	3
386235	1874	10895000	29575	14582	2	0	3
386236	1874	10899000	29575	14582	3	0	3
386237	403	66300000000000	29576	14583	0	0	0
386238	472	66000500000000	29576	14583	1	0	0
386240	1874	10903000	29576	14583	3	0	3
386242	1678	28800895041000	29577	14584	0	0	\N
386243	1874	10907000	29577	14584	1	0	\N
386250	1678	28800895043000	29580	14586	0	0	\N
386251	1874	10918000	29580	14586	1	0	\N
386252	1874	10920000	29580	14586	2	0	\N
386270	1678	28800895047000	29584	14588	0	0	\N
386271	1874	10939000	29584	14588	1	0	\N
386272	1874	10941000	29584	14588	2	0	\N
386273	1678	28800895047000	29585	14588	0	0	\N
386274	1874	10939000	29585	14588	1	0	\N
386275	1874	10941000	29585	14588	2	0	\N
386276	1678	28800895047000	29586	14588	0	0	\N
386277	1874	10939000	29586	14588	1	0	\N
386278	1874	10941000	29586	14588	2	0	\N
386279	1678	28800895048000	29587	14589	0	0	\N
386280	1678	28800895049000	29587	14589	1	0	\N
386281	1874	10945000	29587	14589	2	0	\N
386282	1874	10946000	29587	14589	3	0	\N
386283	1591	1611000000	29587	14589	4	0	\N
386284	2427	100000000	29587	14589	5	0	\N
386285	1874	10948000	29587	14589	6	0	\N
386286	1874	10950000	29587	14589	7	0	\N
386295	403	66300000000000	29589	14363	0	0	\N
386296	1678	28800894902000	29589	14363	1	0	\N
386297	472	66000500000000	29589	14363	2	0	\N
386298	472	66001100000000	29589	14363	3	0	\N
386299	735	3001100000000	29589	14363	4	0	\N
386300	1678	28800894903000	29589	14363	5	0	\N
386301	1678	28800894904000	29589	14363	6	0	\N
386302	1678	28800894905000	29589	14363	7	0	\N
386303	1678	28800894906000	29589	14363	8	0	\N
386304	1678	28800894907000	29589	14363	9	0	\N
386305	1678	28800894908000	29589	14363	10	0	\N
386306	1678	28800894909000	29589	14363	11	0	\N
386307	1678	28800894910000	29589	14363	12	0	\N
386308	1678	28800894911000	29589	14363	13	0	\N
386309	1678	28800894912000	29589	14363	14	0	\N
386310	1678	28800894913000	29589	14363	15	0	\N
386311	1678	28800894914000	29589	14363	16	0	\N
386312	1678	28800894915000	29589	14363	17	0	\N
386313	1678	28800894916000	29589	14363	18	0	\N
386314	1678	28800894917000	29589	14363	19	0	\N
386315	1678	28800894918000	29589	14363	20	0	\N
386316	1678	28800894919000	29589	14363	21	0	\N
386317	1678	28800894920000	29589	14363	22	0	\N
386318	1678	28800894921000	29589	14363	23	0	\N
386319	1678	28800894922000	29589	14363	24	0	\N
386320	1678	28800894923000	29589	14363	25	0	\N
386321	1678	28800894924000	29589	14363	26	0	\N
386322	1678	28800894925000	29589	14363	27	0	\N
386323	1678	28800894926000	29589	14363	28	0	\N
386324	1678	28800894927000	29589	14363	29	0	\N
386325	1678	28800894928000	29589	14363	30	0	\N
386326	1678	28800894929000	29589	14363	31	0	\N
386327	1678	28800894930000	29589	14363	32	0	\N
386328	1678	28800894931000	29589	14363	33	0	\N
386329	1678	28800894932000	29589	14363	34	0	\N
386330	1678	28800894933000	29589	14363	35	0	\N
386331	1678	28800894934000	29589	14363	36	0	\N
386332	1678	28800894935000	29589	14363	37	0	\N
386333	1678	28800894936000	29589	14363	38	0	\N
386334	1678	28800894937000	29589	14363	39	0	\N
386335	1678	28800894938000	29589	14363	40	0	\N
386336	1678	28800894939000	29589	14363	41	0	\N
386337	1678	28800894940000	29589	14363	42	0	\N
386338	1678	28800894941000	29589	14363	43	0	\N
386339	1678	28800894942000	29589	14363	44	0	\N
386340	1678	28800894943000	29589	14363	45	0	\N
386341	1678	28800894944000	29589	14363	46	0	\N
386342	1678	28800894945000	29589	14363	47	0	\N
386343	1678	28800894946000	29589	14363	48	0	\N
386344	1678	28800894947000	29589	14363	49	0	\N
386345	1678	28800894948000	29589	14363	50	0	\N
386346	1678	28800894949000	29589	14363	51	0	\N
386347	1678	28800894950000	29589	14363	52	0	\N
386348	1678	28800894951000	29589	14363	53	0	\N
386349	1678	28800894952000	29589	14363	54	0	\N
386350	1678	28800894953000	29589	14363	55	0	\N
386351	1678	28800894954000	29589	14363	56	0	\N
386352	1678	28800894955000	29589	14363	57	0	\N
386353	1678	28800894956000	29589	14363	58	0	\N
386354	1678	28800894957000	29589	14363	59	0	\N
386355	1678	28800894958000	29589	14363	60	0	\N
386356	1678	28800894959000	29589	14363	61	0	\N
386357	1678	28800894960000	29589	14363	62	0	\N
386358	1678	28800894961000	29589	14363	63	0	\N
386359	1678	28800894962000	29589	14363	64	0	\N
386360	1678	28800894963000	29589	14363	65	0	\N
386361	1678	28800894964000	29589	14363	66	0	\N
386362	1678	28800894965000	29589	14363	67	0	\N
386363	1678	28800894966000	29589	14363	68	0	\N
386364	1678	28800894967000	29589	14363	69	0	\N
386365	1678	28800894968000	29589	14363	70	0	\N
386366	1678	28800894969000	29589	14363	71	0	\N
386367	1678	28800894970000	29589	14363	72	0	\N
386368	1678	28800894971000	29589	14363	73	0	\N
386369	1678	28800894972000	29589	14363	74	0	\N
386370	1678	28800894973000	29589	14363	75	0	\N
386371	1678	28800894974000	29589	14363	76	0	\N
386372	1678	28800894975000	29589	14363	77	0	\N
386373	1678	28800894976000	29589	14363	78	0	\N
386374	1678	28800894977000	29589	14363	79	0	\N
386375	1678	28800894978000	29589	14363	80	0	\N
386376	1678	28800894979000	29589	14363	81	0	\N
386245	1874	10907000	29578	14584	1	0	3
386246	1678	28800895042000	29579	14585	0	0	1
386247	1874	10908000	29579	14585	1	0	3
386248	1874	10910000	29579	14585	2	0	3
386249	1874	10914000	29579	14585	3	0	3
386254	1874	10918000	29581	14586	1	0	3
386255	1874	10920000	29581	14586	2	0	3
386256	472	66001100000000	29582	14587	0	0	0
386257	735	3001100000000	29582	14587	1	0	0
386258	1678	28800895044000	29582	14587	2	0	1
386260	1678	28800895046000	29582	14587	4	0	1
386261	1874	10924000	29582	14587	5	0	3
386262	1874	10928000	29582	14587	6	0	3
386263	1874	10930000	29582	14587	7	0	3
386265	1874	10934000	29582	14587	9	0	3
386266	1874	10935000	29582	14587	10	0	3
386267	1678	28800895047000	29583	14588	0	0	1
386268	1874	10939000	29583	14588	1	0	3
386269	1874	10941000	29583	14588	2	0	3
386288	1678	28800895049000	29588	14589	1	0	1
386289	1874	10945000	29588	14589	2	0	3
386290	1874	10946000	29588	14589	3	0	3
386291	1591	1611000000	29588	14589	4	0	2
386292	2427	100000000	29588	14589	5	0	0
386294	1874	10950000	29588	14589	7	0	3
386377	1678	28800894980000	29589	14363	82	0	\N
386378	1678	28800894981000	29589	14363	84	0	\N
386379	1678	28800894982000	29589	14363	85	0	\N
386380	1678	28800894983000	29589	14363	86	0	\N
386381	1678	28800894984000	29589	14363	87	0	\N
386382	1678	28800894985000	29589	14363	88	0	\N
386383	1678	28800894986000	29589	14363	89	0	\N
386384	1678	28800894987000	29589	14363	90	0	\N
386385	1678	28800894988000	29589	14363	91	0	\N
386386	1678	28800894989000	29589	14363	92	0	\N
386387	1678	28800894990000	29589	14363	93	0	\N
386388	1678	28800894991000	29589	14363	94	0	\N
386389	1678	28800894992000	29589	14363	95	0	\N
386390	1678	28800894993000	29589	14363	96	0	\N
386396	1678	28800895050000	29591	14590	0	0	\N
386397	1678	28800895051000	29591	14590	1	0	\N
386398	1874	10954000	29591	14590	2	0	\N
386399	1874	10956000	29591	14590	3	0	\N
386400	1874	10960000	29591	14590	4	0	\N
386407	1678	28800895052000	29593	14591	0	0	\N
386408	1678	28800895053000	29593	14591	1	0	\N
386409	1874	10964000	29593	14591	2	0	\N
386410	1874	10966000	29593	14591	3	0	\N
386411	1874	10968000	29593	14591	4	0	\N
386412	1874	10969000	29593	14591	5	0	\N
386416	1678	28800895055000	29595	14593	0	0	\N
386417	1678	28800895056000	29595	14593	1	0	\N
386418	1678	28800895057000	29595	14593	2	0	\N
386419	1678	28800895058000	29595	14593	3	0	\N
386420	1874	10979000	29595	14593	4	0	\N
386421	1874	10983000	29595	14593	5	0	\N
386422	1874	10985000	29595	14593	6	0	\N
386423	1874	10987000	29595	14593	7	0	\N
386424	1874	10991000	29595	14593	8	0	\N
386425	1874	10993000	29595	14593	9	0	\N
386426	1874	10995000	29595	14593	10	0	\N
386427	1874	10996000	29595	14593	11	0	\N
386448	1678	28800895062000	29599	14596	0	0	\N
386449	1874	11008000	29599	14596	1	0	\N
386450	1874	11012000	29599	14596	2	0	\N
386451	1874	11014000	29599	14596	3	0	\N
386463	403	66300000000000	29603	14551	0	0	\N
386464	472	66000500000000	29603	14551	1	0	\N
386465	472	66001100000000	29603	14551	2	0	\N
386466	1678	28800895027000	29603	14551	3	0	\N
386467	1678	28800895028000	29603	14551	4	0	\N
386468	735	3001100000000	29603	14551	5	0	\N
386469	1678	28800895029000	29603	14551	6	0	\N
386470	1678	28800895030000	29603	14551	7	0	\N
386471	1678	28800895031000	29603	14551	8	0	\N
386472	1678	28800895032000	29603	14551	9	0	\N
386473	1678	28800895033000	29603	14551	10	0	\N
386474	1678	28800895034000	29603	14551	11	0	\N
386475	1678	28800895035000	29603	14551	12	0	\N
386476	1678	28800895036000	29603	14551	13	0	\N
386477	1678	28800895037000	29603	14551	14	0	\N
386478	1678	28800895038000	29603	14551	15	0	\N
386479	1678	28800895039000	29603	14551	16	0	\N
386480	1678	28800895040000	29603	14551	17	0	\N
386481	1678	28800895041000	29603	14551	18	0	\N
386482	1678	28800895042000	29603	14551	19	0	\N
386483	1678	28800895043000	29603	14551	20	0	\N
386484	1678	28800895044000	29603	14551	21	0	\N
386485	1678	28800895045000	29603	14551	22	0	\N
386486	1678	28800895046000	29603	14551	23	0	\N
386487	1678	28800895047000	29603	14551	24	0	\N
386488	1678	28800895048000	29603	14551	25	0	\N
386489	1678	28800895049000	29603	14551	26	0	\N
386490	1678	28800895050000	29603	14551	27	0	\N
386491	1678	28800895051000	29603	14551	28	0	\N
386492	1678	28800895052000	29603	14551	29	0	\N
386493	1678	28800895053000	29603	14551	30	0	\N
386494	1678	28800895054000	29603	14551	31	0	\N
386495	1678	28800895055000	29603	14551	32	0	\N
386496	1678	28800895056000	29603	14551	33	0	\N
386497	1678	28800895057000	29603	14551	34	0	\N
386498	1678	28800895058000	29603	14551	35	0	\N
386499	1678	28800895059000	29603	14551	36	0	\N
386500	1678	28800895060000	29603	14551	37	0	\N
386501	1678	28800895061000	29603	14551	38	0	\N
386502	1678	28800895062000	29603	14551	39	0	\N
386503	1678	28800895063000	29603	14551	40	0	\N
386504	1678	28800895064000	29603	14551	41	0	\N
386505	1678	28800895065000	29603	14551	42	0	\N
386506	1591	1611000000	29603	14551	43	0	\N
386507	2427	100000000	29603	14551	44	0	\N
386508	2428	200000000	29603	14551	45	0	\N
386509	1874	10837000	29603	14551	46	0	\N
386510	1874	10841000	29603	14551	47	0	\N
386511	1874	10845000	29603	14551	48	0	\N
386512	1874	10849000	29603	14551	49	0	\N
386393	1874	10954000	29590	14590	2	0	3
386394	1874	10956000	29590	14590	3	0	3
386395	1874	10960000	29590	14590	4	0	3
386401	1678	28800895052000	29592	14591	0	0	1
386402	1678	28800895053000	29592	14591	1	0	1
386404	1874	10966000	29592	14591	3	0	3
386405	1874	10968000	29592	14591	4	0	3
386406	1874	10969000	29592	14591	5	0	3
386413	1678	28800895054000	29594	14592	0	0	1
386414	1874	10973000	29594	14592	1	0	3
386428	1678	28800895055000	29596	14593	0	0	1
386429	1678	28800895056000	29596	14593	1	0	1
386430	1678	28800895057000	29596	14593	2	0	1
386431	1678	28800895058000	29596	14593	3	0	1
386433	1874	10983000	29596	14593	5	0	3
386434	1874	10985000	29596	14593	6	0	3
386435	1874	10987000	29596	14593	7	0	3
386436	1874	10991000	29596	14593	8	0	3
386437	1874	10993000	29596	14593	9	0	3
386439	1874	10996000	29596	14593	11	0	3
386440	1678	28800895059000	29597	14594	0	0	1
386441	1678	28800895060000	29597	14594	2	0	1
386442	1874	10998000	29597	14594	3	0	3
386443	1874	10999000	29597	14594	4	0	3
386445	1874	11005000	29597	14594	6	0	3
386446	1678	28800895061000	29598	14595	0	0	1
386447	1874	11007000	29598	14595	1	0	3
386452	1678	28800895062000	29600	14596	0	0	1
386454	1874	11013000	29600	14596	2	0	3
386455	1678	28800895063000	29601	14597	0	0	1
386456	1874	11017000	29601	14597	1	0	3
386457	1874	11018000	29601	14597	2	0	3
386458	2428	200000000	29601	14597	3	0	0
386460	1678	28800895064000	29602	14598	0	0	1
386461	1874	11022000	29602	14598	1	0	3
386462	1874	11026000	29602	14598	2	0	3
386513	1874	10853000	29603	14551	50	0	\N
386514	1874	10857000	29603	14551	51	0	\N
386515	1874	10858000	29603	14551	52	0	\N
386516	1874	10859000	29603	14551	53	0	\N
386517	1874	10860000	29603	14551	54	0	\N
386518	1874	10861000	29603	14551	55	0	\N
386519	1874	10862000	29603	14551	56	0	\N
386520	1874	10866000	29603	14551	57	0	\N
386521	1874	10870000	29603	14551	58	0	\N
386522	1874	10874000	29603	14551	59	0	\N
386523	1874	10878000	29603	14551	60	0	\N
386524	1874	10882000	29603	14551	61	0	\N
386525	1874	10886000	29603	14551	63	0	\N
386526	1874	10890000	29603	14551	64	0	\N
386527	1874	10894000	29603	14551	65	0	\N
386528	1874	10898000	29603	14551	66	0	\N
386529	1874	10902000	29603	14551	67	0	\N
386530	1874	10906000	29603	14551	68	0	\N
386531	1874	10908000	29603	14551	69	0	\N
386532	1874	10910000	29603	14551	70	0	\N
386533	1874	10912000	29603	14551	71	0	\N
386534	1874	10914000	29603	14551	72	0	\N
386535	1874	10916000	29603	14551	73	0	\N
386536	1874	10918000	29603	14551	74	0	\N
386537	1874	10920000	29603	14551	75	0	\N
386538	1874	10922000	29603	14551	76	0	\N
386539	1874	10924000	29603	14551	77	0	\N
386540	1874	10926000	29603	14551	78	0	\N
386541	1874	10928000	29603	14551	79	0	\N
386542	1874	10930000	29603	14551	80	0	\N
386543	1874	10932000	29603	14551	81	0	\N
386544	1874	10934000	29603	14551	82	0	\N
386545	1874	10936000	29603	14551	83	0	\N
386546	1874	10938000	29603	14551	84	0	\N
386547	1874	10940000	29603	14551	85	0	\N
386548	1874	10942000	29603	14551	86	0	\N
386549	1874	10944000	29603	14551	87	0	\N
386550	1874	10946000	29603	14551	88	0	\N
386551	1874	10948000	29603	14551	89	0	\N
386552	1874	10950000	29603	14551	90	0	\N
386553	1874	10952000	29603	14551	91	0	\N
386554	1874	10954000	29603	14551	92	0	\N
386555	1874	10956000	29603	14551	93	0	\N
386556	1874	10958000	29603	14551	94	0	\N
386557	1874	10960000	29603	14551	95	0	\N
386558	1874	10962000	29603	14551	96	0	\N
386559	1874	10964000	29603	14551	97	0	\N
386560	1874	10966000	29603	14551	98	0	\N
386561	1874	10968000	29603	14551	99	0	\N
386562	1874	10970000	29603	14551	100	0	\N
386563	1874	10972000	29603	14551	101	0	\N
386564	1874	10974000	29603	14551	102	0	\N
386565	1874	10976000	29603	14551	103	0	\N
386566	1874	10978000	29603	14551	104	0	\N
386567	1874	10980000	29603	14551	105	0	\N
386568	1874	10982000	29603	14551	106	0	\N
386569	1874	10983000	29603	14551	107	0	\N
386570	1874	10984000	29603	14551	108	0	\N
386571	1874	10985000	29603	14551	109	0	\N
386572	1874	10986000	29603	14551	110	0	\N
386573	1874	10987000	29603	14551	111	0	\N
386574	1874	10988000	29603	14551	112	0	\N
386575	1874	10992000	29603	14551	113	0	\N
386576	1874	10996000	29603	14551	114	0	\N
386577	1874	11000000	29603	14551	115	0	\N
386578	1874	11004000	29603	14551	116	0	\N
386579	1874	11008000	29603	14551	117	0	\N
386580	1874	11012000	29603	14551	118	0	\N
386581	1874	11016000	29603	14551	119	0	\N
386582	1874	11020000	29603	14551	120	0	\N
386583	1874	11024000	29603	14551	121	0	\N
386584	1874	11028000	29603	14551	122	0	\N
386591	1678	28800895067000	29606	14601	0	0	\N
386592	1874	11039000	29606	14601	1	0	\N
386593	1874	11041000	29606	14601	2	0	\N
386594	1678	28800895067000	29607	14601	0	0	\N
386595	1874	11039000	29607	14601	1	0	\N
386596	1874	11041000	29607	14601	2	0	\N
386603	1578	23000000000	29610	14602	0	0	\N
386604	1678	28800895068000	29610	14602	1	0	\N
386605	1874	11043000	29610	14602	2	0	\N
386626	1678	28800895073000	29613	14604	0	0	\N
386627	1678	28800895074000	29613	14604	1	0	\N
386628	718	2000002000000	29613	14604	2	0	\N
386629	1874	11067000	29613	14604	3	0	\N
386630	1874	11069000	29613	14604	4	0	\N
386631	1874	11073000	29613	14604	5	0	\N
386632	1874	11077000	29613	14604	6	0	\N
386636	1678	28800895076000	29615	14606	0	0	\N
386637	1874	11085000	29615	14606	1	0	\N
386638	1874	11086000	29615	14606	2	0	\N
386640	1678	28800895076000	29617	14607	0	0	\N
386641	1483	11000000	29617	14607	1	0	\N
386642	1678	28800895077000	29617	14607	2	0	\N
386643	1678	28800895078000	29617	14607	3	0	\N
386644	1874	11088000	29617	14607	4	0	\N
386645	1874	11090000	29617	14607	5	0	\N
386646	1874	11092000	29617	14607	6	0	\N
386647	1874	11094000	29617	14607	7	0	\N
386648	1874	11098000	29617	14607	8	0	\N
386587	1678	28800895066000	29605	14600	0	0	1
386588	1874	11032000	29605	14600	1	0	3
386589	1874	11033000	29605	14600	2	0	3
386590	1874	11035000	29605	14600	3	0	3
386597	1678	28800895067000	29608	14601	0	0	1
386599	1874	11041000	29608	14601	2	0	3
386600	1578	23000000000	29609	14602	0	0	0
386601	1678	28800895068000	29609	14602	1	0	1
386602	1874	11043000	29609	14602	2	0	3
386606	1678	28800895069000	29611	14603	0	0	1
386608	1678	28800895071000	29611	14603	2	0	1
386609	1678	28800895072000	29611	14603	3	0	1
386610	1874	11047000	29611	14603	4	0	3
386611	1874	11051000	29611	14603	5	0	3
386613	1874	11056000	29611	14603	7	0	3
386614	1874	11058000	29611	14603	8	0	3
386615	1874	11060000	29611	14603	9	0	3
386616	1874	11062000	29611	14603	10	0	3
386617	1874	11064000	29611	14603	11	0	3
386619	1678	28800895073000	29612	14604	0	0	1
386620	1678	28800895074000	29612	14604	1	0	1
386621	718	2000002000000	29612	14604	2	0	0
386622	1874	11067000	29612	14604	3	0	3
386623	1874	11069000	29612	14604	4	0	3
386625	1874	11077000	29612	14604	6	0	3
386633	1678	28800895075000	29614	14605	0	0	1
386634	1874	11079000	29614	14605	1	0	3
386635	1874	11083000	29614	14605	2	0	3
386658	1678	28800895076000	29619	14607	0	0	\N
386659	1483	11000000	29619	14607	1	0	\N
386660	1678	28800895077000	29619	14607	2	0	\N
386661	1678	28800895078000	29619	14607	3	0	\N
386662	1874	11088000	29619	14607	4	0	\N
386663	1874	11090000	29619	14607	5	0	\N
386664	1874	11092000	29619	14607	6	0	\N
386665	1874	11094000	29619	14607	7	0	\N
386666	1874	11098000	29619	14607	8	0	\N
386673	1678	28800895079000	29621	14608	0	0	\N
386674	1678	28800895080000	29621	14608	1	0	\N
386675	1874	11100000	29621	14608	2	0	\N
386676	1874	11102000	29621	14608	3	0	\N
386677	1874	11103000	29621	14608	4	0	\N
386678	1874	11107000	29621	14608	5	0	\N
386679	1678	28800895079000	29622	14608	0	0	\N
386680	1678	28800895080000	29622	14608	1	0	\N
386681	1874	11100000	29622	14608	2	0	\N
386682	1874	11102000	29622	14608	3	0	\N
386683	1874	11103000	29622	14608	4	0	\N
386684	1874	11107000	29622	14608	5	0	\N
386691	1678	28800895081000	29624	14609	0	0	\N
386692	1678	28800895082000	29624	14609	1	0	\N
386693	1600	0	29624	14609	2	0	\N
386694	1874	11109000	29624	14609	3	0	\N
386695	1874	11111000	29624	14609	4	0	\N
386696	1874	11115000	29624	14609	5	0	\N
386697	1678	28800895083000	29625	14610	0	0	\N
386698	1678	28800895084000	29625	14610	1	0	\N
386699	1678	28800895085000	29625	14610	2	0	\N
386700	1678	28800895086000	29625	14610	3	0	\N
386701	1874	11119000	29625	14610	4	0	\N
386702	1874	11123000	29625	14610	5	0	\N
386703	1874	11124000	29625	14610	6	0	\N
386704	1874	11128000	29625	14610	7	0	\N
386705	1874	11130000	29625	14610	8	0	\N
386706	1874	11132000	29625	14610	9	0	\N
386707	1874	11134000	29625	14610	10	0	\N
386708	1874	11136000	29625	14610	11	0	\N
386709	1874	11137000	29625	14610	12	0	\N
386723	1678	28800895087000	29627	14611	0	0	\N
386724	1874	11141000	29627	14611	1	0	\N
386725	1874	11143000	29627	14611	2	0	\N
386726	1874	11141000	29628	14611	0	0	\N
386727	1874	11143000	29628	14611	1	0	\N
386742	1678	28800895088000	29633	14613	0	0	\N
386743	1678	28800895089000	29633	14613	1	0	\N
386744	1678	28800895090000	29633	14613	2	0	\N
386745	1597	5821000000	29633	14613	3	0	\N
386746	1874	11144000	29633	14613	4	0	\N
386747	2429	100000000	29633	14613	5	0	\N
386748	1874	11148000	29633	14613	6	0	\N
386749	1874	11152000	29633	14613	7	0	\N
386750	1874	11154000	29633	14613	8	0	\N
386751	1874	11156000	29633	14613	9	0	\N
386752	1874	11158000	29633	14613	10	0	\N
386758	1678	28800895092000	29636	14615	0	0	\N
386759	1874	11166000	29636	14615	2	0	\N
386760	1678	28800895092000	29637	14615	0	0	\N
386769	1678	28800895094000	29641	14617	0	0	\N
386770	1874	11175000	29641	14617	1	0	\N
386771	1874	11179000	29641	14617	2	0	\N
386774	1678	28800895095000	29643	14618	0	0	\N
386775	1874	11183000	29643	14618	1	0	\N
386776	1874	11185000	29643	14618	2	0	\N
386777	1678	28800895095000	29644	14618	0	0	\N
386778	1874	11183000	29644	14618	1	0	\N
386779	1874	11185000	29644	14618	2	0	\N
386651	1678	28800895077000	29618	14607	2	0	1
386652	1678	28800895078000	29618	14607	3	0	1
386653	1874	11088000	29618	14607	4	0	3
386654	1874	11090000	29618	14607	5	0	3
386655	1874	11092000	29618	14607	6	0	3
386657	1874	11098000	29618	14607	8	0	3
386667	1678	28800895079000	29620	14608	0	0	1
386668	1678	28800895080000	29620	14608	1	0	1
386669	1874	11100000	29620	14608	2	0	3
386670	1874	11102000	29620	14608	3	0	3
386672	1874	11107000	29620	14608	5	0	3
386685	1678	28800895081000	29623	14609	0	0	1
386686	1678	28800895082000	29623	14609	1	0	1
386687	1600	0	29623	14609	2	0	0
386689	1874	11111000	29623	14609	4	0	3
386690	1874	11115000	29623	14609	5	0	3
386710	1678	28800895083000	29626	14610	0	0	1
386711	1678	28800895084000	29626	14610	1	0	1
386712	1678	28800895085000	29626	14610	2	0	1
386714	1874	11119000	29626	14610	4	0	3
386715	1874	11123000	29626	14610	5	0	3
386716	1874	11124000	29626	14610	6	0	3
386717	1874	11128000	29626	14610	7	0	3
386718	1874	11130000	29626	14610	8	0	3
386720	1874	11134000	29626	14610	10	0	3
386721	1874	11136000	29626	14610	11	0	3
386722	1874	11137000	29626	14610	12	0	3
386728	1678	28800895087000	29629	14611	0	0	1
386730	1874	11143000	29629	14611	2	0	3
386731	1678	28800895088000	29632	14613	0	0	1
386732	1678	28800895089000	29632	14613	1	0	1
386733	1678	28800895090000	29632	14613	2	0	1
386734	1597	5821000000	29632	14613	3	0	6
386736	2429	100000000	29632	14613	5	0	0
386737	1874	11148000	29632	14613	6	0	3
386738	1874	11152000	29632	14613	7	0	3
386739	1874	11154000	29632	14613	8	0	3
386740	1874	11156000	29632	14613	9	0	3
386753	1678	28800895091000	29634	14614	0	0	1
386754	1874	11162000	29634	14614	1	0	3
386755	1874	11164000	29634	14614	2	0	3
386756	1678	28800895092000	29635	14615	0	0	1
386761	1678	28800895093000	29639	14616	0	0	1
386762	1874	11167000	29639	14616	1	0	3
386763	1874	11169000	29639	14616	2	0	3
386764	1874	11173000	29639	14616	3	0	3
386765	1655	0	29639	14616	4	0	0
386767	1874	11175000	29640	14617	1	0	3
386768	1874	11179000	29640	14617	2	0	3
386772	1678	28800895095000	29642	14618	0	0	1
386773	1874	11183000	29642	14618	1	0	3
386780	1678	28800895096000	29645	14619	0	0	1
386782	1874	11186000	29645	14619	2	0	3
386783	1874	11188000	29645	14619	3	0	3
386784	1678	28800895097000	29646	14620	0	0	1
386789	1678	28800895097000	29647	14620	0	0	\N
386790	1874	11192000	29647	14620	1	0	\N
386791	1874	11193000	29647	14620	2	0	\N
386792	1874	11197000	29647	14620	3	0	\N
386793	1874	11199000	29647	14620	4	0	\N
386794	1678	28800895098000	29648	14621	0	0	\N
386795	1874	11200000	29648	14621	1	0	\N
386796	1874	11204000	29648	14621	2	0	\N
386797	1874	11208000	29648	14621	3	0	\N
386798	1874	11212000	29648	14621	4	0	\N
386799	1874	11216000	29648	14621	5	0	\N
386835	1678	28800895101000	29652	14623	0	0	\N
386836	1874	11266000	29652	14623	1	0	\N
386837	1874	11268000	29652	14623	2	0	\N
386838	1874	11269000	29652	14623	3	0	\N
386839	1874	11273000	29652	14623	4	0	\N
386840	1874	11277000	29652	14623	5	0	\N
386841	1874	11279000	29652	14623	6	0	\N
386842	1678	28800895101000	29653	14623	0	0	\N
386843	1874	11266000	29653	14623	1	0	\N
386844	1874	11268000	29653	14623	2	0	\N
386845	1874	11269000	29653	14623	3	0	\N
386846	1874	11273000	29653	14623	4	0	\N
386847	1874	11277000	29653	14623	5	0	\N
386848	1874	11279000	29653	14623	6	0	\N
386906	1678	28800895107000	29657	14626	0	0	\N
386907	1678	28800895108000	29657	14626	1	0	\N
386908	1874	11396000	29657	14626	2	0	\N
386909	1874	11397000	29657	14626	3	0	\N
386910	1874	11398000	29657	14626	4	0	\N
386911	1874	11399000	29657	14626	5	0	\N
386912	1874	11401000	29657	14626	6	0	\N
386913	1874	11403000	29657	14626	7	0	\N
386914	1874	11407000	29657	14626	8	0	\N
386915	718	2000002000000	29657	14626	9	0	\N
386916	1874	11411000	29657	14626	10	0	\N
386917	1874	11415000	29657	14626	11	0	\N
386918	1874	11419000	29657	14626	12	0	\N
386919	1874	11423000	29657	14626	13	0	\N
386920	1874	11427000	29657	14626	14	0	\N
386787	1874	11197000	29646	14620	3	0	3
386788	1874	11199000	29646	14620	4	0	3
386800	1678	28800895098000	29649	14621	0	0	1
386801	1874	11200000	29649	14621	1	0	3
386802	1874	11202000	29649	14621	2	0	3
386804	1874	11208000	29649	14621	4	0	3
386805	1874	11210000	29649	14621	5	0	3
386806	1874	11214000	29649	14621	6	0	3
386807	1874	11218000	29649	14621	7	0	3
386808	1874	11222000	29649	14621	8	0	3
386810	1678	28800895099000	29650	14622	1	0	1
386811	1678	28800895100000	29650	14622	2	0	1
386812	1874	11224000	29650	14622	3	0	3
386813	1874	11226000	29650	14622	4	0	3
386815	1874	11232000	29650	14622	6	0	3
386816	1874	11236000	29650	14622	7	0	3
386817	1874	11240000	29650	14622	8	0	3
386818	1874	11242000	29650	14622	9	0	3
386819	1874	11246000	29650	14622	10	0	3
386821	1874	11249000	29650	14622	12	0	3
386822	1874	11250000	29650	14622	13	0	3
386823	1874	11251000	29650	14622	14	0	3
386824	1874	11252000	29650	14622	15	0	3
386825	1874	11254000	29650	14622	16	0	3
386827	1874	11262000	29650	14622	18	0	3
386828	1678	28800895101000	29651	14623	0	0	1
386829	1874	11266000	29651	14623	1	0	3
386830	1874	11268000	29651	14623	2	0	3
386832	1874	11273000	29651	14623	4	0	3
386833	1874	11277000	29651	14623	5	0	3
386834	1874	11279000	29651	14623	6	0	3
386849	1646	1913000000	29654	14624	1	0	3
386850	1678	28800895102000	29654	14624	2	0	1
386852	1874	11281000	29654	14624	4	0	3
386853	1874	11283000	29654	14624	5	0	3
386854	1874	11285000	29654	14624	6	0	3
386855	1874	11287000	29654	14624	7	0	3
386856	1874	11289000	29654	14624	8	0	3
386858	1874	11295000	29654	14624	10	0	3
386859	1874	11299000	29654	14624	11	0	3
386860	1874	11303000	29654	14624	12	0	3
386861	1874	11307000	29654	14624	13	0	3
386863	1874	11315000	29654	14624	15	0	3
386864	1874	11319000	29654	14624	16	0	3
386865	1874	11320000	29654	14624	17	0	3
386866	1874	11321000	29654	14624	18	0	3
386867	1874	11322000	29654	14624	19	0	3
386869	2430	189526998000	29655	14625	1	0	0
386870	1678	28800895104000	29655	14625	2	0	1
386871	1678	28800895105000	29655	14625	3	0	1
386872	1678	28800895106000	29655	14625	4	0	1
386873	1874	11326000	29655	14625	5	0	3
386875	1874	11331000	29655	14625	7	0	3
386876	1874	11333000	29655	14625	8	0	3
386877	1874	11335000	29655	14625	9	0	3
386878	1874	11337000	29655	14625	10	0	3
386880	1874	11339000	29655	14625	13	0	3
386881	1874	11341000	29655	14625	14	0	3
386882	1874	11343000	29655	14625	15	0	3
386883	1874	11345000	29655	14625	16	0	3
386884	1874	11347000	29655	14625	17	0	3
386886	1874	11351000	29655	14625	19	0	3
386887	1874	11352000	29655	14625	20	0	3
386888	1874	11356000	29655	14625	21	0	3
386889	1874	11360000	29655	14625	22	0	3
386890	1874	11364000	29655	14625	23	0	3
386892	1874	11372000	29655	14625	25	0	3
386893	1874	11376000	29655	14625	26	0	3
386894	1874	11380000	29655	14625	27	0	3
386895	1874	11384000	29655	14625	28	0	3
386897	1874	11392000	29655	14625	30	0	3
386898	1874	11396000	29656	14626	0	0	3
386899	1874	11397000	29656	14626	1	0	3
386900	1874	11398000	29656	14626	2	0	3
386901	1874	11400000	29656	14626	3	0	3
386903	1874	11406000	29656	14626	5	0	3
386904	1874	11410000	29656	14626	6	0	3
386905	1874	11414000	29656	14626	7	0	3
386921	1874	11431000	29657	14626	15	0	\N
386922	1874	11435000	29657	14626	16	0	\N
386923	1874	11437000	29657	14626	18	0	\N
386924	1874	11439000	29657	14626	19	0	\N
386925	1874	11441000	29657	14626	20	0	\N
386926	1874	11443000	29657	14626	21	0	\N
386964	1678	28800895112000	29661	14630	0	0	\N
386965	1874	11502000	29661	14630	1	0	\N
386966	1874	11506000	29661	14630	2	0	\N
386967	1874	11510000	29661	14630	3	0	\N
386968	1874	11511000	29661	14630	4	0	\N
386969	1655	0	29661	14630	5	0	\N
386970	1678	28800895112000	29662	14630	0	0	\N
386971	1874	11502000	29662	14630	1	0	\N
386972	1874	11506000	29662	14630	2	0	\N
386973	1874	11510000	29662	14630	3	0	\N
386974	1874	11511000	29662	14630	4	0	\N
386975	1655	0	29662	14630	5	0	\N
386976	1874	11513000	29662	14630	6	0	\N
386977	1874	11515000	29662	14630	7	0	\N
386978	1874	11517000	29662	14630	8	0	\N
387024	1678	28800895117000	29666	14633	0	0	\N
387025	1678	28800895118000	29666	14633	1	0	\N
387026	1874	11598000	29666	14633	3	0	\N
387027	1874	11600000	29666	14633	4	0	\N
387028	1874	11602000	29666	14633	5	0	\N
387029	1874	11604000	29666	14633	6	0	\N
387030	1874	11606000	29666	14633	7	0	\N
387031	1874	11608000	29666	14633	8	0	\N
387032	1874	11612000	29666	14633	9	0	\N
387033	1874	11616000	29666	14633	10	0	\N
387034	1874	11620000	29666	14633	11	0	\N
387035	1874	11624000	29666	14633	12	0	\N
387036	1874	11628000	29666	14633	13	0	\N
387037	1874	11632000	29666	14633	14	0	\N
387038	1874	11636000	29666	14633	15	0	\N
387039	1874	11640000	29666	14633	16	0	\N
387040	1874	11641000	29666	14633	17	0	\N
387041	1874	11642000	29666	14633	18	0	\N
386929	1874	11415000	29658	14627	2	0	3
386930	1874	11416000	29658	14627	3	0	3
386931	1874	11420000	29658	14627	4	0	3
386932	1874	11424000	29658	14627	5	0	3
386933	1874	11428000	29658	14627	6	0	3
386935	1874	11436000	29658	14627	8	0	3
386936	718	2000001000000	29658	14627	9	0	2
386937	1874	11438000	29658	14627	10	0	3
386938	1874	11440000	29658	14627	11	0	3
386939	1874	11442000	29658	14627	12	0	3
386941	1678	28800895109000	29659	14628	0	0	1
386942	1678	28800895110000	29659	14628	1	0	1
386943	1874	11445000	29659	14628	2	0	3
386944	1874	11449000	29659	14628	3	0	3
386946	1874	11457000	29659	14628	5	0	3
386947	1874	11461000	29659	14628	6	0	3
386948	1874	11465000	29659	14628	7	0	3
386949	1874	11469000	29659	14628	8	0	3
386950	1874	11470000	29659	14628	9	0	3
386952	1874	11474000	29659	14628	11	0	3
386953	1874	11476000	29659	14628	12	0	3
386954	1874	11478000	29659	14628	13	0	3
386955	1874	11480000	29659	14628	14	0	3
386956	1678	28800895111000	29660	14629	0	0	1
386958	1874	11482000	29660	14629	2	0	3
386959	1874	11486000	29660	14629	3	0	3
386960	1874	11490000	29660	14629	4	0	3
386961	1874	11494000	29660	14629	5	0	3
386963	1874	11498000	29660	14629	7	0	3
386979	1678	28800895112000	29663	14630	0	0	1
386980	1874	11502000	29663	14630	1	0	3
386981	1874	11506000	29663	14630	2	0	3
386982	1874	11510000	29663	14630	3	0	3
386984	1655	0	29663	14630	5	0	0
386985	1874	11513000	29663	14630	6	0	3
386986	1874	11515000	29663	14630	7	0	3
386987	1874	11517000	29663	14630	8	0	3
386988	1678	28800895113000	29664	14631	0	0	1
386990	1874	11525000	29664	14631	2	0	3
386991	1874	11526000	29664	14631	3	0	3
386992	1874	11527000	29664	14631	4	0	3
386993	1874	11529000	29664	14631	5	0	3
386995	1483	11000000	29665	14632	0	0	0
386996	2431	769714905251	29665	14632	1	0	0
386997	1678	28800895114000	29665	14632	2	0	1
386998	1678	28800895115000	29665	14632	3	0	1
386999	1678	28800895116000	29665	14632	4	0	1
387001	1874	11539000	29665	14632	6	0	3
387002	1874	11540000	29665	14632	7	0	3
387003	1874	11541000	29665	14632	8	0	3
387004	1874	11542000	29665	14632	9	0	3
387005	1874	11543000	29665	14632	10	0	3
387007	1874	11549000	29665	14632	12	0	3
387008	1874	11551000	29665	14632	13	0	3
387009	1874	11553000	29665	14632	14	0	3
387010	1874	11555000	29665	14632	15	0	3
387012	1874	11559000	29665	14632	17	0	3
387013	1874	11561000	29665	14632	18	0	3
387014	1874	11563000	29665	14632	19	0	3
387015	1874	11565000	29665	14632	20	0	3
387016	1874	11569000	29665	14632	21	0	3
387018	1874	11577000	29665	14632	23	0	3
387019	1874	11581000	29665	14632	24	0	3
387020	1874	11585000	29665	14632	25	0	3
387021	1874	11589000	29665	14632	26	0	3
387022	1874	11593000	29665	14632	27	0	3
387042	1678	28800895117000	29667	14633	0	0	1
387043	1678	28800895118000	29667	14633	1	0	1
387044	1874	11598000	29667	14633	3	0	3
387045	1874	11600000	29667	14633	4	0	3
387047	1874	11604000	29667	14633	6	0	3
387048	1874	11606000	29667	14633	7	0	3
387049	1874	11608000	29667	14633	8	0	3
387050	1874	11612000	29667	14633	9	0	3
387051	1874	11616000	29667	14633	10	0	3
387053	1874	11624000	29667	14633	12	0	3
387054	1874	11628000	29667	14633	13	0	3
387055	1874	11632000	29667	14633	14	0	3
387056	1874	11636000	29667	14633	15	0	3
387060	1678	28800895119000	29668	14634	0	0	\N
387061	1874	11644000	29668	14634	1	0	\N
387062	1874	11645000	29668	14634	2	0	\N
387063	1874	11646000	29668	14634	3	0	\N
387064	1874	11648000	29668	14634	4	0	\N
387065	1874	11650000	29668	14634	5	0	\N
387066	1874	11654000	29668	14634	6	0	\N
387067	1874	11658000	29668	14634	7	0	\N
387068	1874	11662000	29668	14634	8	0	\N
387069	1678	28800895119000	29669	14634	0	0	\N
387070	1874	11644000	29669	14634	1	0	\N
387071	1874	11645000	29669	14634	2	0	\N
387072	1874	11646000	29669	14634	3	0	\N
387073	1874	11648000	29669	14634	4	0	\N
387074	1874	11650000	29669	14634	5	0	\N
387075	1874	11654000	29669	14634	6	0	\N
387076	1874	11658000	29669	14634	7	0	\N
387077	1874	11662000	29669	14634	8	0	\N
387087	1600	0	29671	14635	0	0	\N
387088	1678	28800895120000	29671	14635	1	0	\N
387089	1678	28800895121000	29671	14635	2	0	\N
387090	1874	11664000	29671	14635	3	0	\N
387091	712	6001000000000	29671	14635	4	0	\N
387092	1874	11665000	29671	14635	5	0	\N
387093	1874	11666000	29671	14635	6	0	\N
387094	1874	11667000	29671	14635	7	0	\N
387095	1874	11669000	29671	14635	8	0	\N
387096	1874	11671000	29671	14635	9	0	\N
387097	1874	11673000	29671	14635	10	0	\N
387098	1874	11675000	29671	14635	11	0	\N
387099	1874	11679000	29671	14635	12	0	\N
387100	1874	11683000	29671	14635	13	0	\N
387101	1874	11687000	29671	14635	14	0	\N
387102	1874	11691000	29671	14635	15	0	\N
387103	1874	11695000	29671	14635	16	0	\N
387104	1874	11699000	29671	14635	17	0	\N
387123	1600	0	29673	14635	0	0	\N
387124	1678	28800895120000	29673	14635	1	0	\N
387125	1678	28800895121000	29673	14635	2	0	\N
387126	1874	11664000	29673	14635	3	0	\N
387127	712	6001000000000	29673	14635	4	0	\N
387128	1874	11665000	29673	14635	5	0	\N
387129	1874	11666000	29673	14635	6	0	\N
387130	1874	11667000	29673	14635	7	0	\N
387131	1874	11669000	29673	14635	8	0	\N
387132	1874	11671000	29673	14635	9	0	\N
387133	1874	11673000	29673	14635	10	0	\N
387134	1874	11675000	29673	14635	11	0	\N
387135	1874	11679000	29673	14635	12	0	\N
387136	1874	11683000	29673	14635	13	0	\N
387137	1874	11687000	29673	14635	14	0	\N
387138	1874	11691000	29673	14635	15	0	\N
387139	1874	11695000	29673	14635	16	0	\N
387140	1874	11699000	29673	14635	17	0	\N
387182	677	66001000000000	29677	14639	0	0	\N
387183	1678	28800895126000	29677	14639	1	0	\N
387184	1428	2157912000000	29677	14639	2	0	\N
387185	1874	11800000	29677	14639	3	0	\N
387186	1874	11804000	29677	14639	4	0	\N
387187	1874	11808000	29677	14639	5	0	\N
387188	186	66846521394804	29677	14639	6	0	\N
387189	1874	11812000	29677	14639	7	0	\N
387190	1874	11813000	29677	14639	8	0	\N
387191	1874	11814000	29677	14639	9	0	\N
387192	1874	11816000	29677	14639	10	0	\N
387059	1874	11642000	29667	14633	18	0	3
387078	1678	28800895119000	29670	14634	0	0	1
387079	1874	11644000	29670	14634	1	0	3
387080	1874	11645000	29670	14634	2	0	3
387081	1874	11646000	29670	14634	3	0	3
387083	1874	11650000	29670	14634	5	0	3
387084	1874	11654000	29670	14634	6	0	3
387085	1874	11658000	29670	14634	7	0	3
387086	1874	11662000	29670	14634	8	0	3
387105	1600	0	29672	14635	0	0	0
387107	1678	28800895121000	29672	14635	2	0	1
387108	1874	11664000	29672	14635	3	0	3
387109	712	6001000000000	29672	14635	4	0	0
387110	1874	11665000	29672	14635	5	0	3
387112	1874	11667000	29672	14635	7	0	3
387113	1874	11669000	29672	14635	8	0	3
387114	1874	11671000	29672	14635	9	0	3
387115	1874	11673000	29672	14635	10	0	3
387116	1874	11675000	29672	14635	11	0	3
387118	1874	11683000	29672	14635	13	0	3
387119	1874	11687000	29672	14635	14	0	3
387120	1874	11691000	29672	14635	15	0	3
387121	1874	11695000	29672	14635	16	0	3
387122	1874	11699000	29672	14635	17	0	3
387142	1678	28800895123000	29674	14636	1	0	1
387143	1874	11703000	29674	14636	2	0	3
387144	1874	11705000	29674	14636	3	0	3
387145	1874	11706000	29674	14636	4	0	3
387147	1874	11708000	29674	14636	6	0	3
387148	1874	11712000	29674	14636	7	0	3
387149	1874	11714000	29674	14636	8	0	3
387150	1874	11716000	29674	14636	9	0	3
387151	1874	11718000	29674	14636	10	0	3
387153	1874	11724000	29674	14636	12	0	3
387154	1874	11728000	29674	14636	13	0	3
387155	1874	11732000	29674	14636	14	0	3
387156	1678	28800895124000	29675	14637	0	0	1
387157	1874	11734000	29675	14637	2	0	3
387159	1874	11737000	29675	14637	4	0	3
387160	1874	11739000	29675	14637	5	0	3
387161	1874	11741000	29675	14637	6	0	3
387162	1874	11745000	29675	14637	7	0	3
387164	1874	11747000	29675	14637	9	0	3
387165	1874	11751000	29675	14637	10	0	3
387166	1874	11755000	29675	14637	11	0	3
387167	1874	11757000	29675	14637	12	0	3
387168	1874	11761000	29675	14637	13	0	3
387170	1874	11769000	29675	14637	15	0	3
387171	1874	11773000	29675	14637	16	0	3
387172	1874	11775000	29675	14637	17	0	3
387173	1678	28800895125000	29676	14638	0	0	1
387174	1874	11776000	29676	14638	1	0	3
387176	1874	11780000	29676	14638	3	0	3
387177	1874	11782000	29676	14638	4	0	3
387178	1874	11786000	29676	14638	5	0	3
387179	1874	11790000	29676	14638	6	0	3
387181	1874	11798000	29676	14638	8	0	3
387193	1874	11818000	29677	14639	11	0	\N
387203	677	66001000000000	29679	14639	0	0	\N
387204	1678	28800895126000	29679	14639	1	0	\N
387205	1428	2157912000000	29679	14639	2	0	\N
387206	1874	11800000	29679	14639	3	0	\N
387207	1874	11804000	29679	14639	4	0	\N
387208	1874	11808000	29679	14639	5	0	\N
387209	186	66846521394804	29679	14639	6	0	\N
387210	1874	11812000	29679	14639	7	0	\N
387211	1874	11813000	29679	14639	8	0	\N
387212	1874	11814000	29679	14639	9	0	\N
387213	1874	11816000	29679	14639	10	0	\N
387214	1874	11818000	29679	14639	11	0	\N
387227	1678	28800895128000	29681	14641	0	0	\N
387228	1678	28800895129000	29681	14641	1	0	\N
387229	1874	11838000	29681	14641	2	0	\N
387230	1874	11839000	29681	14641	3	0	\N
387231	1874	11840000	29681	14641	4	0	\N
387232	1874	11842000	29681	14641	6	0	\N
387233	1874	11846000	29681	14641	7	0	\N
387234	1874	11850000	29681	14641	8	0	\N
387235	1874	11854000	29681	14641	9	0	\N
387236	1874	11856000	29681	14641	10	0	\N
387237	1874	11858000	29681	14641	11	0	\N
387238	1874	11860000	29681	14641	12	0	\N
387239	1874	11862000	29681	14641	13	0	\N
387240	1874	11866000	29681	14641	14	0	\N
387241	1874	11870000	29681	14641	15	0	\N
387242	1874	11874000	29681	14641	16	0	\N
387243	1874	11878000	29681	14641	17	0	\N
387244	1678	28800895128000	29682	14641	0	0	\N
387245	1678	28800895129000	29682	14641	1	0	\N
387246	1874	11838000	29682	14641	2	0	\N
387247	1874	11839000	29682	14641	3	0	\N
387248	1874	11840000	29682	14641	4	0	\N
387249	1874	11842000	29682	14641	6	0	\N
387250	1874	11846000	29682	14641	7	0	\N
387251	1874	11850000	29682	14641	8	0	\N
387252	1874	11854000	29682	14641	9	0	\N
387253	1874	11856000	29682	14641	10	0	\N
387254	1874	11858000	29682	14641	11	0	\N
387255	1874	11860000	29682	14641	12	0	\N
387256	1874	11862000	29682	14641	13	0	\N
387257	1874	11866000	29682	14641	14	0	\N
387258	1874	11870000	29682	14641	15	0	\N
387259	1874	11874000	29682	14641	16	0	\N
387260	1874	11878000	29682	14641	17	0	\N
387278	1678	28800895128000	29684	14641	0	0	\N
387279	1678	28800895129000	29684	14641	1	0	\N
387280	1874	11838000	29684	14641	2	0	\N
387281	1874	11839000	29684	14641	3	0	\N
387282	1874	11840000	29684	14641	4	0	\N
387283	1874	11842000	29684	14641	6	0	\N
387284	1874	11846000	29684	14641	7	0	\N
387285	1874	11850000	29684	14641	8	0	\N
387286	1874	11854000	29684	14641	9	0	\N
387287	1874	11856000	29684	14641	10	0	\N
387288	1874	11858000	29684	14641	11	0	\N
387289	1874	11860000	29684	14641	12	0	\N
387290	1874	11862000	29684	14641	13	0	\N
387291	1874	11866000	29684	14641	14	0	\N
387292	1874	11870000	29684	14641	15	0	\N
387293	1874	11874000	29684	14641	16	0	\N
387294	1874	11878000	29684	14641	17	0	\N
387295	1678	28800895130000	29685	14642	0	0	\N
387296	1874	11880000	29685	14642	1	0	\N
387297	1874	11881000	29685	14642	2	0	\N
387298	1874	11883000	29685	14642	3	0	\N
387299	1874	11884000	29685	14642	4	0	\N
387300	1874	11886000	29685	14642	5	0	\N
387301	1874	11890000	29685	14642	6	0	\N
387302	1874	11894000	29685	14642	7	0	\N
387303	1874	11898000	29685	14642	8	0	\N
387304	1874	11902000	29685	14642	9	0	\N
387315	1678	28800895130000	29687	14642	0	0	\N
387316	1874	11880000	29687	14642	1	0	\N
387317	1874	11881000	29687	14642	2	0	\N
387318	1874	11883000	29687	14642	3	0	\N
387319	1874	11884000	29687	14642	4	0	\N
387320	1874	11886000	29687	14642	5	0	\N
387321	1874	11890000	29687	14642	6	0	\N
387322	1874	11894000	29687	14642	7	0	\N
387323	1874	11898000	29687	14642	8	0	\N
387196	1428	2157912000000	29678	14639	2	0	3
387197	1874	11800000	29678	14639	3	0	3
387198	186	66846521394804	29678	14639	4	0	1
387199	1874	11801000	29678	14639	5	0	3
387200	1874	11802000	29678	14639	6	0	3
387202	1874	11806000	29678	14639	8	0	3
387215	1428	2158012000000	29680	14640	0	0	3
387216	1678	28800895127000	29680	14640	1	0	1
387217	1874	11808000	29680	14640	2	0	3
387218	1874	11812000	29680	14640	3	0	3
387220	1874	11820000	29680	14640	5	0	3
387221	1874	11824000	29680	14640	6	0	3
387222	1874	11828000	29680	14640	7	0	3
387223	1874	11832000	29680	14640	8	0	3
387225	1874	11835000	29680	14640	10	0	3
387226	1874	11837000	29680	14640	11	0	3
387261	1678	28800895128000	29683	14641	0	0	1
387262	1678	28800895129000	29683	14641	1	0	1
387263	1874	11838000	29683	14641	2	0	3
387265	1874	11840000	29683	14641	4	0	3
387266	1874	11842000	29683	14641	6	0	3
387267	1874	11846000	29683	14641	7	0	3
387268	1874	11850000	29683	14641	8	0	3
387269	1874	11854000	29683	14641	9	0	3
387271	1874	11858000	29683	14641	11	0	3
387272	1874	11860000	29683	14641	12	0	3
387273	1874	11862000	29683	14641	13	0	3
387274	1874	11866000	29683	14641	14	0	3
387276	1874	11874000	29683	14641	16	0	3
387277	1874	11878000	29683	14641	17	0	3
387305	1678	28800895130000	29686	14642	0	0	1
387306	1874	11880000	29686	14642	1	0	3
387307	1874	11881000	29686	14642	2	0	3
387309	1874	11884000	29686	14642	4	0	3
387310	1874	11886000	29686	14642	5	0	3
387311	1874	11890000	29686	14642	6	0	3
387312	1874	11894000	29686	14642	7	0	3
387313	1874	11898000	29686	14642	8	0	3
387324	1678	28800895131000	29688	14643	0	0	1
387325	1874	11904000	29688	14643	1	0	3
387326	1874	11906000	29688	14643	2	0	3
387327	1874	11908000	29688	14643	3	0	3
387355	1874	11947000	29692	14646	0	0	\N
387356	2432	100000000	29692	14646	1	0	\N
387357	1874	11948000	29692	14646	2	0	\N
387358	1678	28800895135000	29694	14647	0	0	\N
387359	1874	11970000	29694	14647	1	0	\N
387360	1874	11972000	29694	14647	2	0	\N
387361	1874	11974000	29694	14647	3	0	\N
387362	1874	11975000	29694	14647	4	0	\N
387363	1874	11979000	29694	14647	5	0	\N
387364	1678	28800895135000	29696	14647	0	0	\N
387365	1874	11970000	29696	14647	1	0	\N
387366	1874	11972000	29696	14647	2	0	\N
387367	1874	11974000	29696	14647	3	0	\N
387368	1874	11975000	29696	14647	4	0	\N
387369	1874	11979000	29696	14647	5	0	\N
387376	1678	28800895135000	29698	14647	0	0	\N
387377	1874	11970000	29698	14647	1	0	\N
387378	1874	11972000	29698	14647	2	0	\N
387379	1874	11974000	29698	14647	3	0	\N
387380	1874	11975000	29698	14647	4	0	\N
387381	1874	11979000	29698	14647	5	0	\N
387382	1678	28800895135000	29699	14647	0	0	\N
387383	1874	11970000	29699	14647	1	0	\N
387384	1874	11972000	29699	14647	2	0	\N
387385	1874	11974000	29699	14647	3	0	\N
387386	1874	11975000	29699	14647	4	0	\N
387387	1874	11979000	29699	14647	5	0	\N
387388	1678	28800895136000	29702	14648	0	0	\N
387389	1874	11983000	29702	14648	1	0	\N
387390	1874	11984000	29702	14648	2	0	\N
387391	1874	11988000	29702	14648	3	0	\N
387392	1874	11992000	29702	14648	4	0	\N
387393	1874	11993000	29702	14648	5	0	\N
387394	1874	11995000	29702	14648	6	0	\N
387395	1874	11997000	29702	14648	7	0	\N
387396	1874	11999000	29702	14648	8	0	\N
387406	1678	28800895136000	29704	14648	0	0	\N
387407	1874	11983000	29704	14648	1	0	\N
387408	1874	11984000	29704	14648	2	0	\N
387409	1874	11988000	29704	14648	3	0	\N
387410	1874	11990000	29704	14648	4	0	\N
387411	1874	11992000	29704	14648	5	0	\N
387412	1678	28800895136000	29705	14648	0	0	\N
387413	1874	11983000	29705	14648	1	0	\N
387414	1874	11984000	29705	14648	2	0	\N
387415	1874	11988000	29705	14648	3	0	\N
387416	1874	11992000	29705	14648	4	0	\N
387417	1874	11993000	29705	14648	5	0	\N
387418	1874	11995000	29705	14648	6	0	\N
387419	1874	11997000	29705	14648	7	0	\N
387420	1874	11999000	29705	14648	8	0	\N
387428	1678	28800895137000	29707	14649	0	0	\N
387429	1874	12003000	29707	14649	1	0	\N
387430	1874	12005000	29707	14649	2	0	\N
387431	1874	12007000	29707	14649	3	0	\N
387432	1874	12009000	29707	14649	4	0	\N
387433	1874	12013000	29707	14649	5	0	\N
387434	1874	12014000	29707	14649	6	0	\N
387435	1874	12003000	29708	14649	0	0	\N
387436	1874	12005000	29708	14649	1	0	\N
387437	1874	12007000	29708	14649	2	0	\N
387438	1874	12009000	29708	14649	3	0	\N
387439	1874	12013000	29708	14649	4	0	\N
387440	1874	12014000	29708	14649	5	0	\N
387331	1874	11917000	29689	14644	1	0	3
387332	1874	11919000	29689	14644	2	0	3
387333	1874	11920000	29689	14644	3	0	3
387334	1874	11921000	29689	14644	4	0	3
387335	1874	11925000	29689	14644	5	0	3
387337	1874	11929000	29689	14644	7	0	3
387338	1678	28800895133000	29690	14645	0	0	1
387339	1874	11933000	29690	14645	1	0	3
387340	1874	11937000	29690	14645	2	0	3
387341	1874	11938000	29690	14645	3	0	3
387343	1874	11944000	29690	14645	5	0	3
387344	1874	11946000	29690	14645	6	0	3
387345	1678	28800895134000	29691	14646	0	0	1
387346	1874	11950000	29691	14646	1	0	3
387348	1874	11958000	29691	14646	3	0	3
387349	1874	11960000	29691	14646	4	0	3
387350	1874	11961000	29691	14646	5	0	3
387351	2432	100000000	29691	14646	6	0	0
387352	1874	11962000	29691	14646	7	0	3
387354	1874	11966000	29691	14646	9	0	3
387370	1678	28800895135000	29697	14647	0	0	1
387371	1874	11970000	29697	14647	1	0	3
387372	1874	11972000	29697	14647	2	0	3
387373	1874	11974000	29697	14647	3	0	3
387375	1874	11979000	29697	14647	5	0	3
387397	1678	28800895136000	29703	14648	0	0	1
387398	1874	11983000	29703	14648	1	0	3
387399	1874	11984000	29703	14648	2	0	3
387401	1874	11992000	29703	14648	4	0	3
387402	1874	11993000	29703	14648	5	0	3
387403	1874	11995000	29703	14648	6	0	3
387404	1874	11997000	29703	14648	7	0	3
387405	1874	11999000	29703	14648	8	0	3
387422	1874	12003000	29706	14649	1	0	3
387423	1874	12005000	29706	14649	2	0	3
387424	1874	12007000	29706	14649	3	0	3
387425	1874	12009000	29706	14649	4	0	3
387426	1874	12013000	29706	14649	5	0	3
387441	1678	28800895138000	29709	14650	0	0	1
387442	1678	28800895139000	29709	14650	1	0	1
387443	1678	28800895140000	29709	14650	2	0	1
387444	1874	12015000	29709	14650	3	0	3
387446	1874	12017000	29709	14650	6	0	3
387447	1874	12018000	29709	14650	7	0	3
387448	1874	12022000	29709	14650	8	0	3
387449	1874	12026000	29709	14650	9	0	3
387450	1874	12028000	29709	14650	10	0	3
387452	1874	12032000	29709	14650	12	0	3
387453	1874	12034000	29709	14650	13	0	3
387454	1874	12036000	29709	14650	14	0	3
387455	1874	12038000	29709	14650	15	0	3
387456	1874	12040000	29709	14650	16	0	3
387458	1737	2299001100	29709	14650	19	0	1
387459	1874	12046000	29709	14650	20	0	3
387460	1874	12050000	29709	14650	21	0	3
387461	1874	12054000	29709	14650	22	0	3
387463	1874	12062000	29709	14650	24	0	3
387464	1874	12066000	29709	14650	25	0	3
387469	1678	28800895138000	29710	14650	0	0	\N
387470	1678	28800895139000	29710	14650	1	0	\N
387471	1678	28800895140000	29710	14650	2	0	\N
387472	1874	12015000	29710	14650	3	0	\N
387473	1874	12016000	29710	14650	5	0	\N
387474	1874	12017000	29710	14650	6	0	\N
387475	1874	12018000	29710	14650	7	0	\N
387476	1874	12022000	29710	14650	8	0	\N
387477	1874	12026000	29710	14650	9	0	\N
387478	1737	2299001100	29710	14650	11	0	\N
387479	1874	12030000	29710	14650	12	0	\N
387480	1874	12034000	29710	14650	13	0	\N
387481	1874	12038000	29710	14650	14	0	\N
387482	1874	12042000	29710	14650	15	0	\N
387483	1874	12046000	29710	14650	16	0	\N
387484	1874	12050000	29710	14650	17	0	\N
387485	1874	12054000	29710	14650	18	0	\N
387486	1874	12058000	29710	14650	19	0	\N
387487	1874	12062000	29710	14650	20	0	\N
387488	1874	12066000	29710	14650	21	0	\N
387489	1678	28800895138000	29711	14650	0	0	\N
387490	1678	28800895139000	29711	14650	1	0	\N
387491	1678	28800895140000	29711	14650	2	0	\N
387492	1874	12015000	29711	14650	3	0	\N
387493	1874	12016000	29711	14650	5	0	\N
387494	1874	12017000	29711	14650	6	0	\N
387495	1874	12018000	29711	14650	7	0	\N
387496	1874	12022000	29711	14650	8	0	\N
387497	1874	12026000	29711	14650	9	0	\N
387498	1874	12028000	29711	14650	10	0	\N
387499	1874	12030000	29711	14650	11	0	\N
387500	1874	12032000	29711	14650	12	0	\N
387501	1874	12034000	29711	14650	13	0	\N
387502	1874	12036000	29711	14650	14	0	\N
387503	1874	12038000	29711	14650	15	0	\N
387504	1874	12040000	29711	14650	16	0	\N
387505	1874	12042000	29711	14650	17	0	\N
387506	1737	2299001100	29711	14650	19	0	\N
387507	1874	12046000	29711	14650	20	0	\N
387508	1874	12050000	29711	14650	21	0	\N
387509	1874	12054000	29711	14650	22	0	\N
387510	1874	12058000	29711	14650	23	0	\N
387511	1874	12062000	29711	14650	24	0	\N
387512	1874	12066000	29711	14650	25	0	\N
387513	1874	12070000	29711	14650	26	0	\N
387514	1874	12074000	29711	14650	27	0	\N
387515	1874	12078000	29711	14650	28	0	\N
387516	1874	12082000	29711	14650	29	0	\N
387517	1678	28800895138000	29712	14650	0	0	\N
387518	1678	28800895139000	29712	14650	1	0	\N
387519	1678	28800895140000	29712	14650	2	0	\N
387520	1874	12015000	29712	14650	3	0	\N
387521	1874	12016000	29712	14650	5	0	\N
387522	1874	12017000	29712	14650	6	0	\N
387523	1874	12018000	29712	14650	7	0	\N
387524	1874	12022000	29712	14650	8	0	\N
387525	1874	12026000	29712	14650	9	0	\N
387526	1874	12028000	29712	14650	10	0	\N
387527	1874	12030000	29712	14650	11	0	\N
387528	1874	12032000	29712	14650	12	0	\N
387529	1874	12034000	29712	14650	13	0	\N
387530	1874	12036000	29712	14650	14	0	\N
387531	1874	12038000	29712	14650	15	0	\N
387532	1874	12040000	29712	14650	16	0	\N
387533	1874	12042000	29712	14650	17	0	\N
387534	1737	2299001100	29712	14650	19	0	\N
387535	1874	12046000	29712	14650	20	0	\N
387536	1874	12050000	29712	14650	21	0	\N
387537	1874	12054000	29712	14650	22	0	\N
387538	1874	12058000	29712	14650	23	0	\N
387539	1874	12062000	29712	14650	24	0	\N
387540	1874	12066000	29712	14650	25	0	\N
387541	1874	12070000	29712	14650	26	0	\N
387542	1874	12074000	29712	14650	27	0	\N
387543	1874	12078000	29712	14650	28	0	\N
387544	1874	12082000	29712	14650	29	0	\N
387545	1678	28800895138000	29713	14650	0	0	\N
387546	1678	28800895139000	29713	14650	1	0	\N
387547	1678	28800895140000	29713	14650	2	0	\N
387548	1874	12015000	29713	14650	3	0	\N
387549	1874	12016000	29713	14650	5	0	\N
387550	1874	12017000	29713	14650	6	0	\N
387551	1874	12018000	29713	14650	7	0	\N
387552	1874	12022000	29713	14650	8	0	\N
387553	1874	12026000	29713	14650	9	0	\N
387554	1874	12028000	29713	14650	10	0	\N
387555	1874	12030000	29713	14650	11	0	\N
387556	1874	12032000	29713	14650	12	0	\N
387557	1874	12034000	29713	14650	13	0	\N
387558	1874	12036000	29713	14650	14	0	\N
387559	1874	12038000	29713	14650	15	0	\N
387560	1874	12040000	29713	14650	16	0	\N
387561	1874	12042000	29713	14650	17	0	\N
387562	1737	2299001100	29713	14650	19	0	\N
387563	1874	12046000	29713	14650	20	0	\N
387564	1874	12050000	29713	14650	21	0	\N
387565	1874	12054000	29713	14650	22	0	\N
387566	1874	12058000	29713	14650	23	0	\N
387567	1874	12062000	29713	14650	24	0	\N
387568	1874	12066000	29713	14650	25	0	\N
387569	1874	12070000	29713	14650	26	0	\N
387570	1874	12074000	29713	14650	27	0	\N
387571	1874	12078000	29713	14650	28	0	\N
387572	1874	12082000	29713	14650	29	0	\N
387573	2431	769714905251	29714	14572	0	0	\N
387574	1646	1813000000	29714	14572	2	0	\N
387575	677	66001000000000	29714	14572	3	0	\N
387576	1646	1913000000	29714	14572	4	0	\N
387577	403	66300000000000	29714	14572	5	0	\N
387578	1483	11000000	29714	14572	6	0	\N
387579	1578	23000000000	29714	14572	7	0	\N
387580	472	66000500000000	29714	14572	8	0	\N
387581	472	66001100000000	29714	14572	9	0	\N
387582	1678	28800895025000	29714	14572	10	0	\N
387583	1678	28800895026000	29714	14572	11	0	\N
387584	1678	28800895027000	29714	14572	12	0	\N
387585	1678	28800895028000	29714	14572	13	0	\N
387586	2430	189526998000	29714	14572	14	0	\N
387587	1483	11000000	29714	14572	15	0	\N
387588	735	3001100000000	29714	14572	16	0	\N
387589	1678	28800895029000	29714	14572	17	0	\N
387590	1678	28800895030000	29714	14572	18	0	\N
387591	1678	28800895031000	29714	14572	19	0	\N
387592	1678	28800895032000	29714	14572	20	0	\N
387593	1678	28800895033000	29714	14572	21	0	\N
387594	1678	28800895034000	29714	14572	22	0	\N
387595	1678	28800895035000	29714	14572	23	0	\N
387596	1678	28800895036000	29714	14572	24	0	\N
387597	1678	28800895037000	29714	14572	26	0	\N
387598	1678	28800895038000	29714	14572	27	0	\N
387599	1678	28800895039000	29714	14572	28	0	\N
387600	1678	28800895040000	29714	14572	29	0	\N
387467	1874	12078000	29709	14650	28	0	3
387468	1874	12082000	29709	14650	29	0	3
387601	1678	28800895041000	29714	14572	30	0	\N
387602	1678	28800895042000	29714	14572	31	0	\N
387603	1678	28800895043000	29714	14572	32	0	\N
387604	1678	28800895044000	29714	14572	33	0	\N
387605	1678	28800895045000	29714	14572	34	0	\N
387606	1678	28800895046000	29714	14572	35	0	\N
387607	1678	28800895047000	29714	14572	36	0	\N
387608	1678	28800895048000	29714	14572	37	0	\N
387609	1678	28800895049000	29714	14572	38	0	\N
387610	1678	28800895050000	29714	14572	39	0	\N
387611	1678	28800895051000	29714	14572	40	0	\N
387612	1678	28800895052000	29714	14572	41	0	\N
387613	1678	28800895053000	29714	14572	42	0	\N
387614	1678	28800895054000	29714	14572	43	0	\N
387615	1678	28800895055000	29714	14572	44	0	\N
387616	1678	28800895056000	29714	14572	45	0	\N
387617	1678	28800895057000	29714	14572	46	0	\N
387618	1678	28800895058000	29714	14572	47	0	\N
387619	1678	28800895059000	29714	14572	48	0	\N
387620	1678	28800895060000	29714	14572	49	0	\N
387621	1678	28800895061000	29714	14572	50	0	\N
387622	1678	28800895062000	29714	14572	51	0	\N
387623	1678	28800895063000	29714	14572	52	0	\N
387624	1678	28800895064000	29714	14572	53	0	\N
387625	1678	28800895065000	29714	14572	54	0	\N
387626	1678	28800895066000	29714	14572	55	0	\N
387627	1678	28800895067000	29714	14572	56	0	\N
387628	1678	28800895068000	29714	14572	57	0	\N
387629	1678	28800895069000	29714	14572	58	0	\N
387630	1678	28800895070000	29714	14572	59	0	\N
387631	1678	28800895071000	29714	14572	60	0	\N
387632	1678	28800895072000	29714	14572	61	0	\N
387633	1678	28800895073000	29714	14572	62	0	\N
387634	1678	28800895074000	29714	14572	63	0	\N
387635	1678	28800895075000	29714	14572	64	0	\N
387636	1678	28800895076000	29714	14572	65	0	\N
387637	1678	28800895077000	29714	14572	66	0	\N
387638	1678	28800895078000	29714	14572	67	0	\N
387639	1678	28800895079000	29714	14572	68	0	\N
387640	1678	28800895080000	29714	14572	69	0	\N
387641	1678	28800895081000	29714	14572	70	0	\N
387642	1678	28800895082000	29714	14572	71	0	\N
387643	1678	28800895083000	29714	14572	72	0	\N
387644	1678	28800895084000	29714	14572	73	0	\N
387645	1678	28800895085000	29714	14572	74	0	\N
387646	1678	28800895086000	29714	14572	75	0	\N
387647	1678	28800895087000	29714	14572	76	0	\N
387648	1678	28800895088000	29714	14572	77	0	\N
387649	1678	28800895089000	29714	14572	78	0	\N
387650	1678	28800895090000	29714	14572	79	0	\N
387651	1678	28800895091000	29714	14572	80	0	\N
387652	1678	28800895092000	29714	14572	81	0	\N
387653	1678	28800895093000	29714	14572	82	0	\N
387654	1678	28800895094000	29714	14572	83	0	\N
387655	1678	28800895095000	29714	14572	84	0	\N
387656	1678	28800895096000	29714	14572	85	0	\N
387657	1678	28800895097000	29714	14572	86	0	\N
387658	1678	28800895098000	29714	14572	87	0	\N
387659	1678	28800895099000	29714	14572	88	0	\N
387660	1678	28800895100000	29714	14572	89	0	\N
387661	1678	28800895101000	29714	14572	90	0	\N
387662	1678	28800895102000	29714	14572	91	0	\N
387663	1678	28800895103000	29714	14572	92	0	\N
387664	1678	28800895104000	29714	14572	93	0	\N
387665	1678	28800895105000	29714	14572	94	0	\N
387666	1678	28800895106000	29714	14572	95	0	\N
387667	1678	28800895107000	29714	14572	96	0	\N
387668	1678	28800895108000	29714	14572	97	0	\N
387669	1678	28800895109000	29714	14572	98	0	\N
387670	1678	28800895110000	29714	14572	99	0	\N
387671	1678	28800895111000	29714	14572	100	0	\N
387672	1678	28800895112000	29714	14572	101	0	\N
387673	1678	28800895113000	29714	14572	102	0	\N
387674	1678	28800895114000	29714	14572	103	0	\N
387675	1678	28800895115000	29714	14572	104	0	\N
387676	1678	28800895116000	29714	14572	105	0	\N
387677	1678	28800895117000	29714	14572	106	0	\N
387678	1678	28800895118000	29714	14572	107	0	\N
387679	1678	28800895119000	29714	14572	108	0	\N
387680	1678	28800895120000	29714	14572	109	0	\N
387681	1678	28800895121000	29714	14572	110	0	\N
387682	1678	28800895122000	29714	14572	111	0	\N
387683	1678	28800895123000	29714	14572	112	0	\N
387684	1678	28800895124000	29714	14572	113	0	\N
387685	1678	28800895125000	29714	14572	114	0	\N
387686	1678	28800895126000	29714	14572	115	0	\N
387687	1678	28800895127000	29714	14572	116	0	\N
387688	1678	28800895128000	29714	14572	117	0	\N
387689	1678	28800895129000	29714	14572	118	0	\N
387690	1678	28800895130000	29714	14572	119	0	\N
387691	1678	28800895131000	29714	14572	120	0	\N
387692	1678	28800895132000	29714	14572	121	0	\N
387693	1678	28800895133000	29714	14572	122	0	\N
387694	1678	28800895134000	29714	14572	123	0	\N
387695	1678	28800895135000	29714	14572	124	0	\N
387696	1678	28800895136000	29714	14572	125	0	\N
387717	1678	28800895141000	29716	14651	0	0	\N
387718	1269	3000000	29716	14651	1	0	\N
387719	1269	4000000	29716	14651	3	0	\N
387720	1874	12086000	29716	14651	4	0	\N
387721	1874	12090000	29716	14651	5	0	\N
387722	1269	5000000	29716	14651	6	0	\N
387723	1269	6000000	29716	14651	7	0	\N
387724	1874	12092000	29716	14651	8	0	\N
387725	1874	12094000	29716	14651	9	0	\N
387726	1874	12096000	29716	14651	10	0	\N
387727	1874	12100000	29716	14651	11	0	\N
387728	1269	7000000	29716	14651	12	0	\N
387729	1269	8000000	29716	14651	13	0	\N
387730	1269	9000000	29716	14651	14	0	\N
387731	1269	10000000	29716	14651	15	0	\N
387732	1269	11000000	29716	14651	16	0	\N
387733	1269	12000000	29716	14651	17	0	\N
387734	1874	12101000	29716	14651	18	0	\N
387735	1874	12102000	29716	14651	19	0	\N
387699	1269	4000000	29715	14651	3	0	0
387700	1874	12086000	29715	14651	4	0	3
387701	1874	12090000	29715	14651	5	0	3
387702	1269	5000000	29715	14651	6	0	0
387703	1269	6000000	29715	14651	7	0	0
387705	1874	12094000	29715	14651	9	0	3
387706	1874	12096000	29715	14651	10	0	3
387707	1874	12100000	29715	14651	11	0	3
387708	1269	7000000	29715	14651	12	0	0
387709	1269	8000000	29715	14651	13	0	0
387711	1269	10000000	29715	14651	15	0	0
387712	1269	11000000	29715	14651	16	0	0
387713	1269	12000000	29715	14651	17	0	0
387714	1269	13000000	29715	14651	18	0	0
387716	1874	12102000	29715	14651	20	0	3
387736	1678	28800895142000	29717	14652	0	0	1
387751	1678	28800895142000	29718	14652	0	0	\N
387752	1874	12106000	29718	14652	1	0	\N
387753	1874	12110000	29718	14652	2	0	\N
387754	1874	12114000	29718	14652	3	0	\N
387755	1269	13000000	29718	14652	4	0	\N
387756	1269	14000000	29718	14652	5	0	\N
387757	1874	12115000	29718	14652	6	0	\N
387758	1269	15000000	29718	14652	7	0	\N
387759	1269	16000000	29718	14652	8	0	\N
387760	1874	12117000	29718	14652	9	0	\N
387761	1874	12119000	29718	14652	10	0	\N
387762	1874	12121000	29718	14652	11	0	\N
387763	1269	17000000	29718	14652	12	0	\N
387764	1269	18000000	29718	14652	13	0	\N
387765	1269	19000000	29718	14652	14	0	\N
387766	1269	20000000	29718	14652	15	0	\N
387767	1269	21000000	29718	14652	16	0	\N
387768	1269	22000000	29718	14652	17	0	\N
387769	1269	23000000	29718	14652	18	0	\N
387770	1269	24000000	29718	14652	19	0	\N
387771	1269	25000000	29718	14652	20	0	\N
387772	1269	26000000	29718	14652	21	0	\N
387773	1269	27000000	29718	14652	22	0	\N
387774	1269	28000000	29718	14652	23	0	\N
387775	1269	29000000	29718	14652	24	0	\N
387776	1269	30000000	29718	14652	25	0	\N
387777	1269	31000000	29718	14652	26	0	\N
387799	180	66847791394804	29720	14446	0	0	\N
387800	2431	769714905251	29720	14446	1	0	\N
387801	1646	1813000000	29720	14446	4	0	\N
387802	1684	33843726819412	29720	14446	5	0	\N
387803	677	66001000000000	29720	14446	6	0	\N
387804	1646	1913000000	29720	14446	7	0	\N
387805	403	66300000000000	29720	14446	8	0	\N
387806	1483	11000000	29720	14446	9	0	\N
387807	1578	23000000000	29720	14446	11	0	\N
387808	2423	500000000	29720	14446	12	0	\N
387809	1678	28800894857000	29720	14446	13	0	\N
387810	472	66000500000000	29720	14446	14	0	\N
387811	472	66001100000000	29720	14446	15	0	\N
387812	2423	510000000	29720	14446	16	0	\N
387813	2430	189526998000	29720	14446	17	0	\N
387814	1678	28800894858000	29720	14446	18	0	\N
387815	1678	28800894859000	29720	14446	19	0	\N
387816	1678	28800894860000	29720	14446	20	0	\N
387817	735	3001100000000	29720	14446	22	0	\N
387818	1445	1005169000000	29720	14446	23	0	\N
387819	1445	20158169000000	29720	14446	24	0	\N
387820	2423	520000000	29720	14446	25	0	\N
387821	2423	1020000000	29720	14446	26	0	\N
387822	1678	28800894861000	29720	14446	27	0	\N
387823	1678	28800894862000	29720	14446	28	0	\N
387824	1678	28800894863000	29720	14446	29	0	\N
387825	1678	28800894864000	29720	14446	30	0	\N
387826	1678	28800894865000	29720	14446	31	0	\N
387827	1678	28800894866000	29720	14446	32	0	\N
387828	1678	28800894867000	29720	14446	33	0	\N
387829	1678	28800894868000	29720	14446	34	0	\N
387830	1678	28800894869000	29720	14446	35	0	\N
387831	1678	28800894870000	29720	14446	36	0	\N
387832	1678	28800894871000	29720	14446	37	0	\N
387833	1678	28800894872000	29720	14446	38	0	\N
387834	1678	28800894873000	29720	14446	39	0	\N
387835	1678	28800894874000	29720	14446	40	0	\N
387836	1678	28800894875000	29720	14446	41	0	\N
387837	1678	28800894876000	29720	14446	42	0	\N
387838	1678	28800894877000	29720	14446	43	0	\N
387839	1678	28800894878000	29720	14446	44	0	\N
387840	1678	28800894879000	29720	14446	45	0	\N
387841	1678	28800894880000	29720	14446	46	0	\N
387842	1678	28800894881000	29720	14446	47	0	\N
387843	1678	28800894882000	29720	14446	48	0	\N
387844	1678	28800894883000	29720	14446	49	0	\N
387845	1678	28800894884000	29720	14446	50	0	\N
387846	1678	28800894885000	29720	14446	51	0	\N
387847	1678	28800894886000	29720	14446	52	0	\N
387848	1678	28800894887000	29720	14446	53	0	\N
387849	1678	28800894888000	29720	14446	54	0	\N
387850	1678	28800894889000	29720	14446	55	0	\N
387851	1678	28800894890000	29720	14446	56	0	\N
387852	1678	28800894891000	29720	14446	57	0	\N
387853	1678	28800894892000	29720	14446	58	0	\N
387854	1678	28800894893000	29720	14446	59	0	\N
387855	1678	28800894894000	29720	14446	60	0	\N
387856	1678	28800894895000	29720	14446	61	0	\N
387857	1678	28800894896000	29720	14446	62	0	\N
387858	1678	28800894897000	29720	14446	63	0	\N
387859	1678	28800894898000	29720	14446	64	0	\N
387860	1678	28800894899000	29720	14446	66	0	\N
387861	1678	28800894900000	29720	14446	67	0	\N
387862	1678	28800894901000	29720	14446	68	0	\N
387863	1678	28800894902000	29720	14446	69	0	\N
387864	1678	28800894903000	29720	14446	70	0	\N
387865	1678	28800894904000	29720	14446	71	0	\N
387866	1678	28800894905000	29720	14446	72	0	\N
387867	1678	28800894906000	29720	14446	73	0	\N
387868	1678	28800894907000	29720	14446	74	0	\N
387869	1678	28800894908000	29720	14446	75	0	\N
387870	1678	28800894909000	29720	14446	76	0	\N
387871	1678	28800894910000	29720	14446	77	0	\N
387872	1678	28800894911000	29720	14446	78	0	\N
387739	1874	12110000	29717	14652	3	0	3
387740	1874	12114000	29717	14652	4	0	3
387741	1874	12115000	29717	14652	5	0	3
387742	1269	15000000	29717	14652	6	0	0
387743	1269	16000000	29717	14652	7	0	0
387745	1874	12119000	29717	14652	9	0	3
387746	1874	12121000	29717	14652	10	0	3
387747	1269	17000000	29717	14652	11	0	0
387748	1269	18000000	29717	14652	12	0	0
387749	1269	19000000	29717	14652	13	0	0
387778	1428	2158912000000	29719	14653	0	0	3
387779	1678	28800895143000	29719	14653	1	0	1
387780	1269	21000000	29719	14653	2	0	0
387781	1874	12123000	29719	14653	3	0	3
387783	1269	22000000	29719	14653	5	0	0
387784	1874	12126000	29719	14653	6	0	3
387785	1874	12127000	29719	14653	7	0	3
387786	1874	12131000	29719	14653	8	0	3
387787	1874	12135000	29719	14653	9	0	3
387789	1874	12143000	29719	14653	11	0	3
387790	1269	23000000	29719	14653	12	0	0
387791	1269	24000000	29719	14653	13	0	0
387792	1269	25000000	29719	14653	14	0	0
387793	1269	26000000	29719	14653	15	0	0
387795	1269	28000000	29719	14653	17	0	0
387796	1269	29000000	29719	14653	18	0	0
387797	1269	30000000	29719	14653	19	0	0
387798	1269	31000000	29719	14653	20	0	0
387873	1678	28800894912000	29720	14446	79	0	\N
387874	1678	28800894913000	29720	14446	80	0	\N
387875	1678	28800894914000	29720	14446	81	0	\N
387876	1678	28800894915000	29720	14446	82	0	\N
387877	1678	28800894916000	29720	14446	83	0	\N
387878	1678	28800894917000	29720	14446	84	0	\N
387879	1678	28800894918000	29720	14446	85	0	\N
387880	1678	28800894919000	29720	14446	86	0	\N
387881	1678	28800894920000	29720	14446	87	0	\N
387882	1678	28800894921000	29720	14446	88	0	\N
387883	1678	28800894922000	29720	14446	89	0	\N
387884	1678	28800894923000	29720	14446	90	0	\N
387885	1678	28800894924000	29720	14446	91	0	\N
387886	1678	28800894925000	29720	14446	92	0	\N
387887	1678	28800894926000	29720	14446	93	0	\N
387888	1678	28800894927000	29720	14446	94	0	\N
387889	1678	28800894928000	29720	14446	95	0	\N
387890	1678	28800894929000	29720	14446	96	0	\N
387891	1678	28800894930000	29720	14446	97	0	\N
387892	1678	28800894931000	29720	14446	98	0	\N
387893	1678	28800894932000	29720	14446	99	0	\N
387894	1678	28800894933000	29720	14446	100	0	\N
387895	1678	28800894934000	29720	14446	101	0	\N
387896	1678	28800894935000	29720	14446	102	0	\N
387897	1678	28800894936000	29720	14446	103	0	\N
387898	1678	28800894937000	29720	14446	104	0	\N
387899	1678	28800894938000	29720	14446	105	0	\N
387900	1678	28800894939000	29720	14446	106	0	\N
387901	1678	28800894940000	29720	14446	107	0	\N
387902	1678	28800894941000	29720	14446	108	0	\N
387903	1678	28800894942000	29720	14446	109	0	\N
387904	1678	28800894943000	29720	14446	110	0	\N
387905	1678	28800894944000	29720	14446	111	0	\N
387906	1678	28800894945000	29720	14446	112	0	\N
387907	1678	28800894946000	29720	14446	113	0	\N
387908	1678	28800894947000	29720	14446	114	0	\N
387909	1678	28800894948000	29720	14446	115	0	\N
387910	1678	28800894949000	29720	14446	116	0	\N
387911	1678	28800894950000	29720	14446	117	0	\N
387912	1678	28800894951000	29720	14446	118	0	\N
387913	1678	28800894952000	29720	14446	119	0	\N
387914	1678	28800894953000	29720	14446	120	0	\N
387915	1678	28800894954000	29720	14446	121	0	\N
387916	1678	28800894955000	29720	14446	122	0	\N
387917	1678	28800894956000	29720	14446	123	0	\N
387918	1678	28800894957000	29720	14446	124	0	\N
387919	1678	28800894958000	29720	14446	125	0	\N
387920	724	20002150000000	29721	14654	0	0	\N
387921	1678	28800895144000	29721	14654	1	0	\N
387922	1874	12147000	29721	14654	2	0	\N
387923	1874	12151000	29721	14654	3	0	\N
387924	1874	12155000	29721	14654	4	0	\N
387925	1874	12157000	29721	14654	5	0	\N
387926	1874	12158000	29721	14654	6	0	\N
387927	1874	12160000	29721	14654	7	0	\N
387928	1874	12162000	29721	14654	8	0	\N
387929	724	20002150000000	29722	14654	0	0	\N
387930	1678	28800895144000	29722	14654	1	0	\N
387931	1874	12147000	29722	14654	2	0	\N
387932	1874	12151000	29722	14654	3	0	\N
387933	1874	12155000	29722	14654	4	0	\N
387934	1874	12157000	29722	14654	5	0	\N
387935	1874	12158000	29722	14654	6	0	\N
387936	1874	12160000	29722	14654	7	0	\N
387937	1874	12162000	29722	14654	8	0	\N
387947	724	20002150000000	29724	14654	0	0	\N
387948	1678	28800895144000	29724	14654	1	0	\N
387949	1874	12145000	29724	14654	2	0	\N
387950	1874	12146000	29724	14654	3	0	\N
387951	1874	12148000	29724	14654	4	0	\N
387952	1874	12150000	29724	14654	5	0	\N
387953	724	20002150000000	29725	14654	0	0	\N
387954	1678	28800895144000	29725	14654	1	0	\N
387955	1874	12147000	29725	14654	2	0	\N
387956	1874	12151000	29725	14654	3	0	\N
387957	1874	12155000	29725	14654	4	0	\N
387958	1874	12157000	29725	14654	5	0	\N
387959	1874	12158000	29725	14654	6	0	\N
387960	1874	12160000	29725	14654	7	0	\N
387961	1874	12162000	29725	14654	8	0	\N
387979	1678	28800895147000	29727	14656	0	0	\N
387980	1874	12199000	29727	14656	1	0	\N
387981	1874	12200000	29727	14656	2	0	\N
387982	1874	12204000	29727	14656	3	0	\N
387983	1874	12208000	29727	14656	4	0	\N
387984	1874	12212000	29727	14656	5	0	\N
387985	1874	12214000	29727	14656	6	0	\N
387986	1874	12215000	29727	14656	7	0	\N
387987	1874	12217000	29727	14656	8	0	\N
387988	1678	28800895147000	29728	14656	0	0	\N
387989	1874	12199000	29728	14656	1	0	\N
387990	1874	12200000	29728	14656	2	0	\N
387991	1874	12204000	29728	14656	3	0	\N
387992	1874	12208000	29728	14656	4	0	\N
387993	1874	12210000	29728	14656	5	0	\N
388003	1678	28800895148000	29730	14657	0	0	\N
388004	1874	12219000	29730	14657	1	0	\N
388005	1874	12221000	29730	14657	2	0	\N
388006	1874	12222000	29730	14657	3	0	\N
388007	1874	12226000	29730	14657	4	0	\N
388008	1874	12230000	29730	14657	5	0	\N
387940	1874	12147000	29723	14654	2	0	3
387941	1874	12151000	29723	14654	3	0	3
387942	1874	12155000	29723	14654	4	0	3
387943	1874	12157000	29723	14654	5	0	3
387944	1874	12158000	29723	14654	6	0	3
387946	1874	12162000	29723	14654	8	0	3
387962	1956	3000000000	29726	14655	0	0	0
387963	1678	28800895145000	29726	14655	1	0	1
387964	1678	28800895146000	29726	14655	2	0	1
387965	1874	12166000	29726	14655	3	0	3
387967	1874	12170000	29726	14655	5	0	3
387968	1874	12174000	29726	14655	6	0	3
387969	1874	12178000	29726	14655	7	0	3
387970	1874	12179000	29726	14655	8	0	3
387972	1874	12181000	29726	14655	10	0	3
387973	1874	12183000	29726	14655	11	0	3
387974	1874	12185000	29726	14655	12	0	3
387975	1874	12187000	29726	14655	13	0	3
387976	1874	12189000	29726	14655	14	0	3
387978	1874	12197000	29726	14655	16	0	3
387994	1678	28800895147000	29729	14656	0	0	1
387995	1874	12199000	29729	14656	1	0	3
387996	1874	12200000	29729	14656	2	0	3
387997	1874	12204000	29729	14656	3	0	3
387999	1874	12212000	29729	14656	5	0	3
388000	1874	12214000	29729	14656	6	0	3
388001	1874	12215000	29729	14656	7	0	3
388002	1874	12217000	29729	14656	8	0	3
388009	1874	12234000	29730	14657	6	0	\N
388010	1678	28800895148000	29731	14657	0	0	\N
388011	1874	12219000	29731	14657	1	0	\N
388012	1874	12221000	29731	14657	2	0	\N
388013	1874	12222000	29731	14657	3	0	\N
388014	1874	12226000	29731	14657	4	0	\N
388015	1874	12230000	29731	14657	5	0	\N
388016	1874	12234000	29731	14657	6	0	\N
388024	1678	28800895148000	29733	14657	0	0	\N
388025	1874	12219000	29733	14657	1	0	\N
388026	1874	12221000	29733	14657	2	0	\N
388027	1874	12222000	29733	14657	3	0	\N
388028	1874	12226000	29733	14657	4	0	\N
388029	1874	12230000	29733	14657	5	0	\N
388030	1874	12234000	29733	14657	6	0	\N
388031	1678	28800895148000	29734	14657	0	0	\N
388032	1874	12219000	29734	14657	1	0	\N
388033	1874	12221000	29734	14657	2	0	\N
388034	1874	12222000	29734	14657	3	0	\N
388035	1874	12226000	29734	14657	4	0	\N
388036	1874	12230000	29734	14657	5	0	\N
388037	1874	12234000	29734	14657	6	0	\N
388038	1678	28800895148000	29735	14657	0	0	\N
388039	1874	12214000	29735	14657	1	0	\N
388040	1874	12215000	29735	14657	2	0	\N
388041	1874	12216000	29735	14657	3	0	\N
388042	1874	12218000	29735	14657	4	0	\N
388043	1874	12220000	29735	14657	5	0	\N
388044	1874	12222000	29735	14657	6	0	\N
388045	1874	12226000	29735	14657	7	0	\N
388046	1874	12230000	29735	14657	8	0	\N
388047	1678	28800895148000	29736	14657	0	0	\N
388048	1874	12219000	29736	14657	1	0	\N
388049	1874	12220000	29736	14657	2	0	\N
388050	1874	12224000	29736	14657	3	0	\N
388051	1874	12228000	29736	14657	4	0	\N
388052	1678	28800895148000	29737	14657	0	0	\N
388053	1874	12219000	29737	14657	1	0	\N
388054	1874	12221000	29737	14657	2	0	\N
388055	1874	12222000	29737	14657	3	0	\N
388056	1874	12226000	29737	14657	4	0	\N
388057	1874	12230000	29737	14657	5	0	\N
388111	1678	28800895153000	29741	14660	0	0	\N
388112	1874	12311000	29741	14660	1	0	\N
388113	1874	12315000	29741	14660	2	0	\N
388114	1874	12316000	29741	14660	3	0	\N
388115	1874	12320000	29741	14660	4	0	\N
388116	1874	12324000	29741	14660	5	0	\N
388117	1874	12326000	29741	14660	6	0	\N
388118	1874	12328000	29741	14660	7	0	\N
388119	1874	12330000	29741	14660	8	0	\N
388136	1678	28800895156000	29743	14662	0	0	\N
388137	1678	28800895157000	29743	14662	1	0	\N
388138	1874	12368000	29743	14662	2	0	\N
388139	1874	12372000	29743	14662	3	0	\N
388140	1874	12373000	29743	14662	4	0	\N
388141	1874	12374000	29743	14662	5	0	\N
388142	1874	12378000	29743	14662	6	0	\N
388143	1874	12382000	29743	14662	7	0	\N
388144	1874	12386000	29743	14662	8	0	\N
388019	1874	12221000	29732	14657	2	0	3
388020	1874	12222000	29732	14657	3	0	3
388021	1874	12226000	29732	14657	4	0	3
388022	1874	12230000	29732	14657	5	0	3
388023	1874	12234000	29732	14657	6	0	3
388059	1874	12238000	29738	14658	1	0	3
388060	1874	12239000	29738	14658	2	0	3
388061	1874	12240000	29738	14658	3	0	3
388062	1874	12244000	29738	14658	4	0	3
388063	1874	12246000	29738	14658	5	0	3
388065	1678	28800895150000	29739	14659	0	0	1
388066	1678	28800895151000	29739	14659	1	0	1
388067	1678	28800895152000	29739	14659	2	0	1
388068	1874	12250000	29739	14659	3	0	3
388070	1874	12256000	29739	14659	5	0	3
388071	1874	12258000	29739	14659	6	0	3
388072	1874	12260000	29739	14659	7	0	3
388073	1874	12261000	29739	14659	9	0	3
388074	1874	12262000	29739	14659	10	0	3
388076	1874	12264000	29739	14659	12	0	3
388077	1269	32000000	29739	14659	13	0	0
388078	1269	33000000	29739	14659	14	0	0
388079	1269	34000000	29739	14659	15	0	0
388080	1269	35000000	29739	14659	16	0	0
388082	1874	12268000	29739	14659	18	0	3
388083	1874	12270000	29739	14659	19	0	3
388084	1874	12274000	29739	14659	20	0	3
388085	1874	12278000	29739	14659	21	0	3
388087	1874	12286000	29739	14659	23	0	3
388088	1874	12290000	29739	14659	24	0	3
388089	1874	12294000	29739	14659	25	0	3
388090	1874	12298000	29739	14659	26	0	3
388091	1874	12302000	29739	14659	27	0	3
388093	1269	36000000	29739	14659	29	0	0
388094	1269	37000000	29739	14659	30	0	0
388095	1269	38000000	29739	14659	31	0	0
388096	1269	39000000	29739	14659	32	0	0
388097	1269	40000000	29739	14659	33	0	0
388099	1269	42000000	29739	14659	35	0	0
388100	1874	12308000	29739	14659	36	0	3
388101	1874	12310000	29739	14659	37	0	3
388102	1678	28800895153000	29740	14660	0	0	1
388104	1874	12315000	29740	14660	2	0	3
388105	1874	12316000	29740	14660	3	0	3
388106	1874	12320000	29740	14660	4	0	3
388107	1874	12324000	29740	14660	5	0	3
388108	1874	12326000	29740	14660	6	0	3
388110	1874	12330000	29740	14660	8	0	3
388120	1678	28800895154000	29742	14661	0	0	1
388121	1678	28800895155000	29742	14661	1	0	1
388122	1874	12332000	29742	14661	2	0	3
388123	1874	12334000	29742	14661	3	0	3
388125	1874	12342000	29742	14661	5	0	3
388126	1874	12346000	29742	14661	6	0	3
388127	1874	12350000	29742	14661	7	0	3
388128	1874	12354000	29742	14661	8	0	3
388130	1874	12360000	29742	14661	10	0	3
388131	1874	12362000	29742	14661	11	0	3
388132	1874	12364000	29742	14661	12	0	3
388133	1874	12365000	29742	14661	13	0	3
388134	1874	12366000	29742	14661	14	0	3
388145	1874	12390000	29743	14662	9	0	\N
388146	1874	12394000	29743	14662	10	0	\N
388147	1874	12398000	29743	14662	11	0	\N
388148	1678	28800895156000	29744	14662	0	0	\N
388149	1678	28800895157000	29744	14662	1	0	\N
388150	1874	12368000	29744	14662	2	0	\N
388151	1874	12372000	29744	14662	3	0	\N
388152	1874	12374000	29744	14662	4	0	\N
388153	1874	12376000	29744	14662	5	0	\N
388154	1874	12378000	29744	14662	6	0	\N
388155	1874	12380000	29744	14662	7	0	\N
388156	1874	12382000	29744	14662	8	0	\N
388157	1874	12383000	29744	14662	9	0	\N
388158	1874	12384000	29744	14662	10	0	\N
388159	1874	12386000	29744	14662	11	0	\N
388160	1874	12390000	29744	14662	12	0	\N
388161	1874	12394000	29744	14662	13	0	\N
388162	1874	12398000	29744	14662	14	0	\N
388163	1874	12402000	29744	14662	15	0	\N
388164	1874	12406000	29744	14662	16	0	\N
388165	1874	12410000	29744	14662	17	0	\N
388184	1678	28800895156000	29746	14662	0	0	\N
388185	1678	28800895157000	29746	14662	1	0	\N
388186	1874	12368000	29746	14662	2	0	\N
388187	1874	12372000	29746	14662	3	0	\N
388188	1874	12374000	29746	14662	4	0	\N
388189	1874	12376000	29746	14662	5	0	\N
388190	1874	12378000	29746	14662	6	0	\N
388191	1874	12380000	29746	14662	7	0	\N
388192	1874	12382000	29746	14662	8	0	\N
388193	1874	12383000	29746	14662	9	0	\N
388194	1874	12384000	29746	14662	10	0	\N
388195	1874	12386000	29746	14662	11	0	\N
388196	1874	12390000	29746	14662	12	0	\N
388197	1874	12394000	29746	14662	13	0	\N
388198	1874	12398000	29746	14662	14	0	\N
388199	1874	12402000	29746	14662	15	0	\N
388200	1874	12406000	29746	14662	16	0	\N
388201	1874	12410000	29746	14662	17	0	\N
388202	1678	28800895158000	29747	14663	0	0	\N
388203	1678	28800895159000	29747	14663	1	0	\N
388204	1678	28800895160000	29747	14663	2	0	\N
388205	1874	12411000	29747	14663	3	0	\N
388206	1874	12412000	29747	14663	4	0	\N
388207	1874	12413000	29747	14663	5	0	\N
388208	1874	12414000	29747	14663	6	0	\N
388209	1874	12418000	29747	14663	7	0	\N
388210	1874	12422000	29747	14663	8	0	\N
388211	1874	12426000	29747	14663	9	0	\N
388212	1874	12430000	29747	14663	10	0	\N
388213	1874	12434000	29747	14663	11	0	\N
388214	1874	12438000	29747	14663	12	0	\N
388215	1874	12442000	29747	14663	13	0	\N
388216	1874	12446000	29747	14663	14	0	\N
388217	1874	12450000	29747	14663	15	0	\N
388242	1678	28800895158000	29749	14663	0	0	\N
388243	1678	28800895159000	29749	14663	1	0	\N
388244	1678	28800895160000	29749	14663	2	0	\N
388245	1874	12411000	29749	14663	3	0	\N
388246	1874	12412000	29749	14663	4	0	\N
388247	1874	12413000	29749	14663	5	0	\N
388248	1874	12415000	29749	14663	6	0	\N
388249	1874	12417000	29749	14663	7	0	\N
388250	1874	12419000	29749	14663	8	0	\N
388251	1874	12421000	29749	14663	9	0	\N
388252	1874	12423000	29749	14663	10	0	\N
388253	1874	12425000	29749	14663	11	0	\N
388254	1874	12427000	29749	14663	12	0	\N
388255	1874	12429000	29749	14663	13	0	\N
388256	1874	12430000	29749	14663	14	0	\N
388257	1874	12434000	29749	14663	15	0	\N
388258	1874	12438000	29749	14663	16	0	\N
388259	1874	12442000	29749	14663	17	0	\N
388260	1874	12446000	29749	14663	18	0	\N
388261	1874	12450000	29749	14663	19	0	\N
388262	1874	12454000	29749	14663	20	0	\N
388263	1874	12458000	29749	14663	21	0	\N
388264	1874	12462000	29749	14663	22	0	\N
388265	1874	12466000	29749	14663	23	0	\N
388266	1678	28800895158000	29750	14663	0	0	\N
388267	1678	28800895159000	29750	14663	1	0	\N
388268	1678	28800895160000	29750	14663	2	0	\N
388269	1874	12411000	29750	14663	3	0	\N
388270	1874	12412000	29750	14663	4	0	\N
388271	1678	28800895161000	29751	14664	0	0	\N
388272	1874	12467000	29751	14664	1	0	\N
388168	1874	12368000	29745	14662	2	0	3
388169	1874	12372000	29745	14662	3	0	3
388170	1874	12374000	29745	14662	4	0	3
388171	1874	12376000	29745	14662	5	0	3
388172	1874	12378000	29745	14662	6	0	3
388174	1874	12382000	29745	14662	8	0	3
388175	1874	12383000	29745	14662	9	0	3
388176	1874	12384000	29745	14662	10	0	3
388177	1874	12386000	29745	14662	11	0	3
388178	1874	12390000	29745	14662	12	0	3
388180	1874	12398000	29745	14662	14	0	3
388181	1874	12402000	29745	14662	15	0	3
388182	1874	12406000	29745	14662	16	0	3
388183	1874	12410000	29745	14662	17	0	3
388219	1678	28800895159000	29748	14663	1	0	1
388220	1678	28800895160000	29748	14663	2	0	1
388221	1874	12411000	29748	14663	3	0	3
388222	1874	12412000	29748	14663	4	0	3
388223	1874	12413000	29748	14663	5	0	3
388225	1874	12417000	29748	14663	7	0	3
388226	1874	12419000	29748	14663	8	0	3
388227	1874	12421000	29748	14663	9	0	3
388228	1874	12423000	29748	14663	10	0	3
388229	1874	12425000	29748	14663	11	0	3
388231	1874	12429000	29748	14663	13	0	3
388232	1874	12430000	29748	14663	14	0	3
388233	1874	12434000	29748	14663	15	0	3
388234	1874	12438000	29748	14663	16	0	3
388236	1874	12446000	29748	14663	18	0	3
388237	1874	12450000	29748	14663	19	0	3
388238	1874	12454000	29748	14663	20	0	3
388239	1874	12458000	29748	14663	21	0	3
388240	1874	12462000	29748	14663	22	0	3
388273	1678	28800895161000	29752	14664	0	0	1
388274	1874	12468000	29752	14664	1	0	3
388275	1874	12470000	29752	14664	2	0	3
388276	1874	12471000	29752	14664	3	0	3
388277	1874	12475000	29752	14664	4	0	3
388279	1874	12483000	29752	14664	6	0	3
388280	1874	12485000	29752	14664	7	0	3
388281	1678	28800895162000	29753	14665	0	0	\N
388282	1874	12486000	29753	14665	1	0	\N
388283	1874	12487000	29753	14665	2	0	\N
388284	1678	28800895162000	29754	14665	0	0	\N
388285	1874	12487000	29754	14665	1	0	\N
388286	1874	12489000	29754	14665	2	0	\N
388287	1874	12491000	29754	14665	3	0	\N
388288	1874	12492000	29754	14665	4	0	\N
388289	1874	12493000	29754	14665	5	0	\N
388290	1874	12497000	29754	14665	6	0	\N
388291	1874	12501000	29754	14665	7	0	\N
388297	1678	28800895163000	29756	14666	0	0	\N
388298	1678	28800895164000	29756	14666	1	0	\N
388299	342	66277931638598	29756	14666	2	0	\N
388300	1874	12497000	29756	14666	3	0	\N
388301	894	311162277935181	29756	14666	5	0	\N
388302	569	66933430434669	29756	14666	6	0	\N
388303	390	66933430434669	29756	14666	7	0	\N
388304	570	66933430434669	29756	14666	8	0	\N
388305	251	66933430434669	29756	14666	9	0	\N
388306	312	66276827024809	29756	14666	10	0	\N
388307	1772	6689445300164	29756	14666	11	0	\N
388308	1030	913716893004926	29756	14666	12	0	\N
388309	238	66086983695901	29756	14666	13	0	\N
388310	1874	12498000	29756	14666	14	0	\N
388311	1874	12499000	29756	14666	15	0	\N
388312	1874	12500000	29756	14666	16	0	\N
388313	1874	12502000	29756	14666	17	0	\N
388314	1874	12504000	29756	14666	18	0	\N
388333	1678	28800895163000	29758	14666	0	0	\N
388334	1678	28800895164000	29758	14666	2	0	\N
388335	342	66277931638598	29758	14666	3	0	\N
388336	1874	12505000	29758	14666	4	0	\N
388337	1874	12509000	29758	14666	5	0	\N
388338	1874	12513000	29758	14666	6	0	\N
388339	1874	12517000	29758	14666	7	0	\N
388340	894	311162277935181	29758	14666	8	0	\N
388341	569	66933430434669	29758	14666	9	0	\N
388342	390	66933430434669	29758	14666	10	0	\N
388343	570	66933430434669	29758	14666	11	0	\N
388344	251	66933430434669	29758	14666	12	0	\N
388345	312	66276827024809	29758	14666	13	0	\N
388346	1772	6689445300164	29758	14666	14	0	\N
388347	1030	913716893004926	29758	14666	15	0	\N
388348	238	66086983695901	29758	14666	16	0	\N
388349	1874	12518000	29758	14666	17	0	\N
388350	1874	12519000	29758	14666	18	0	\N
388351	1874	12520000	29758	14666	19	0	\N
388352	1874	12522000	29758	14666	20	0	\N
388353	1874	12524000	29758	14666	21	0	\N
388354	1874	12526000	29758	14666	22	0	\N
388355	1874	12528000	29758	14666	23	0	\N
388356	1874	12530000	29758	14666	24	0	\N
388380	1678	28800895166000	29760	14668	0	0	\N
388381	1874	12553000	29760	14668	1	0	\N
388382	1874	12557000	29760	14668	2	0	\N
388383	1874	12558000	29760	14668	3	0	\N
388384	1874	12559000	29760	14668	4	0	\N
388385	1874	12561000	29760	14668	5	0	\N
388386	1874	12563000	29760	14668	6	0	\N
388387	1874	12565000	29760	14668	7	0	\N
388388	1811	2555508410581	29760	14668	8	0	\N
388389	520	66933430434669	29760	14668	9	0	\N
388390	191	66933430434669	29760	14668	10	0	\N
388391	421	66930330434669	29760	14668	11	0	\N
388392	266	66320410434669	29760	14668	12	0	\N
388393	352	66933430434669	29760	14668	13	0	\N
388394	1874	12553000	29761	14668	0	0	\N
388395	1874	12557000	29761	14668	1	0	\N
388396	1874	12558000	29761	14668	2	0	\N
388397	1874	12559000	29761	14668	3	0	\N
388398	1874	12561000	29761	14668	4	0	\N
388399	1874	12563000	29761	14668	5	0	\N
388400	1874	12565000	29761	14668	6	0	\N
388401	1811	2555508410581	29761	14668	7	0	\N
388402	520	66933430434669	29761	14668	8	0	\N
388403	191	66933430434669	29761	14668	9	0	\N
388404	421	66930330434669	29761	14668	10	0	\N
388405	266	66320410434669	29761	14668	11	0	\N
388294	1874	12487000	29755	14665	2	0	3
388295	1874	12491000	29755	14665	3	0	3
388296	1874	12495000	29755	14665	4	0	3
388315	1678	28800895163000	29757	14666	0	0	1
388316	1678	28800895164000	29757	14666	1	0	1
388318	1874	12497000	29757	14666	3	0	3
388319	894	311162277935181	29757	14666	5	0	0
388320	569	66933430434669	29757	14666	6	0	0
388321	390	66933430434669	29757	14666	7	0	0
388322	570	66933430434669	29757	14666	8	0	0
388324	312	66276827024809	29757	14666	10	0	1
388325	1772	6689445300164	29757	14666	11	0	1
388326	1030	913716893004926	29757	14666	12	0	0
388327	238	66086983695901	29757	14666	13	0	7
388329	1874	12499000	29757	14666	15	0	3
388330	1874	12500000	29757	14666	16	0	3
388331	1874	12502000	29757	14666	17	0	3
388332	1874	12504000	29757	14666	18	0	3
388357	1678	28800895165000	29759	14667	0	0	1
388359	320	66651050983763	29759	14667	2	0	2
388360	354	66279227049307	29759	14667	3	0	1
388361	663	66933430434669	29759	14667	4	0	0
388362	710	5070714426784	29759	14667	5	0	0
388363	499	66933430434669	29759	14667	6	0	0
388365	1874	12512000	29759	14667	8	0	3
388366	1874	12516000	29759	14667	9	0	3
388367	1874	12520000	29759	14667	10	0	3
388368	1874	12521000	29759	14667	11	0	3
388370	1874	12527000	29759	14667	13	0	3
388371	1874	12529000	29759	14667	14	0	3
388372	1874	12531000	29759	14667	15	0	3
388373	1874	12533000	29759	14667	16	0	3
388374	1874	12535000	29759	14667	17	0	3
388376	1874	12539000	29759	14667	19	0	3
388377	1874	12541000	29759	14667	20	0	3
388378	1874	12545000	29759	14667	21	0	3
388379	1874	12549000	29759	14667	22	0	3
388406	1678	28800895166000	29762	14668	0	0	1
388408	1874	12557000	29762	14668	2	0	3
388409	1874	12558000	29762	14668	3	0	3
388410	1874	12559000	29762	14668	4	0	3
388411	1874	12561000	29762	14668	5	0	3
388413	1874	12565000	29762	14668	7	0	3
388414	1811	2555508410581	29762	14668	8	0	1
388415	520	66933430434669	29762	14668	9	0	0
388416	191	66933430434669	29762	14668	10	0	0
388420	1678	28800895166000	29763	14668	0	0	\N
388421	1874	12553000	29763	14668	1	0	\N
388422	1874	12557000	29763	14668	2	0	\N
388423	1874	12558000	29763	14668	3	0	\N
388424	1874	12559000	29763	14668	4	0	\N
388425	1811	2555508410581	29763	14668	5	0	\N
388426	520	66933430434669	29763	14668	6	0	\N
388427	191	66933430434669	29763	14668	7	0	\N
388428	421	66930330434669	29763	14668	8	0	\N
388429	266	66320410434669	29763	14668	9	0	\N
388430	352	66933430434669	29763	14668	10	0	\N
388467	1678	28800895169000	29767	14672	0	0	\N
388468	1678	28800895170000	29767	14672	1	0	\N
388469	1874	12612000	29767	14672	2	0	\N
388470	1874	12614000	29767	14672	3	0	\N
388471	322	66933430434669	29767	14672	4	0	\N
388472	10	32602533762605	29767	14672	5	0	\N
388473	1874	12615000	29767	14672	6	0	\N
388474	1874	12619000	29767	14672	7	0	\N
388475	1874	12623000	29767	14672	8	0	\N
388476	1874	12625000	29767	14672	9	0	\N
388477	1874	12627000	29767	14672	10	0	\N
388478	1874	12628000	29767	14672	11	0	\N
388479	1874	12632000	29767	14672	12	0	\N
388480	1874	12636000	29767	14672	13	0	\N
388481	1874	12640000	29767	14672	14	0	\N
388482	1874	12644000	29767	14672	15	0	\N
388483	1874	12648000	29767	14672	16	0	\N
388484	1874	12650000	29767	14672	17	0	\N
388485	1874	12652000	29767	14672	18	0	\N
388486	1678	28800895169000	29768	14672	0	0	\N
388487	1678	28800895170000	29768	14672	1	0	\N
388488	1874	12612000	29768	14672	2	0	\N
388489	1874	12614000	29768	14672	3	0	\N
388490	322	66933430434669	29768	14672	4	0	\N
388491	10	32602533762605	29768	14672	5	0	\N
388492	1874	12615000	29768	14672	6	0	\N
388493	1874	12619000	29768	14672	7	0	\N
388494	1874	12623000	29768	14672	8	0	\N
388495	1874	12625000	29768	14672	9	0	\N
388496	1874	12627000	29768	14672	10	0	\N
388497	1874	12628000	29768	14672	11	0	\N
388498	1874	12632000	29768	14672	12	0	\N
388499	1874	12636000	29768	14672	13	0	\N
388500	1874	12640000	29768	14672	14	0	\N
388501	1874	12644000	29768	14672	15	0	\N
388502	1874	12648000	29768	14672	16	0	\N
388503	1874	12650000	29768	14672	17	0	\N
388504	1874	12652000	29768	14672	18	0	\N
388549	1678	28800895171000	29771	14673	0	0	\N
388550	1678	28800895172000	29771	14673	1	0	\N
388551	322	66933430434669	29771	14673	2	0	\N
388552	10	32602533762605	29771	14673	3	0	\N
388419	352	66933430434669	29762	14668	13	0	0
388431	1874	12569000	29764	14669	0	0	3
388432	1874	12573000	29764	14669	1	0	3
388433	1874	12577000	29764	14669	2	0	3
388434	1874	12579000	29764	14669	3	0	3
388436	1874	12582000	29764	14669	5	0	3
388437	534	66933430434669	29764	14669	6	0	0
388438	327	66276827024809	29764	14669	7	0	1
388439	652	66933430434669	29764	14669	8	0	0
388440	391	66932320434669	29764	14669	9	0	1
388442	1678	28800895167000	29765	14670	0	0	1
388443	1874	12583000	29765	14670	1	0	3
388444	402	66933430434669	29765	14670	2	0	0
388445	275	66933430434669	29765	14670	3	0	0
388447	452	66933430434669	29765	14670	5	0	0
388448	458	66279227049307	29765	14670	6	0	1
388449	690	66933430434669	29765	14670	7	0	0
388450	1874	12588000	29765	14670	8	0	3
388451	1874	12592000	29765	14670	9	0	3
388453	1874	12596000	29765	14670	11	0	3
388454	1678	28800895168000	29766	14671	0	0	1
388455	309	66933429434669	29766	14671	1	0	1
388456	1874	12600000	29766	14671	2	0	3
388457	1874	12604000	29766	14671	3	0	3
388459	1874	12607000	29766	14671	5	0	3
388460	1874	12609000	29766	14671	6	0	3
388461	1874	12611000	29766	14671	7	0	3
388462	82	66933430434669	29766	14671	8	0	0
388464	680	66933430434669	29766	14671	10	0	0
388465	731	2028285770627	29766	14671	11	0	0
388466	366	66276827024809	29766	14671	12	0	1
388505	1678	28800895169000	29769	14672	0	0	1
388506	1678	28800895170000	29769	14672	1	0	1
388508	1874	12614000	29769	14672	3	0	3
388509	1874	12615000	29769	14672	4	0	3
388510	1874	12619000	29769	14672	5	0	3
388511	1874	12623000	29769	14672	6	0	3
388512	1874	12625000	29769	14672	7	0	3
388514	1874	12628000	29769	14672	9	0	3
388515	1874	12632000	29769	14672	10	0	3
388516	1874	12636000	29769	14672	11	0	3
388517	1874	12640000	29769	14672	12	0	3
388519	1874	12648000	29769	14672	14	0	3
388520	1874	12650000	29769	14672	15	0	3
388521	1874	12652000	29769	14672	16	0	3
388522	1678	28800895171000	29770	14673	0	0	1
388523	1678	28800895172000	29770	14673	1	0	1
388525	1874	12658000	29770	14673	3	0	3
388526	1874	12662000	29770	14673	4	0	3
388527	1874	12666000	29770	14673	5	0	3
388528	1874	12668000	29770	14673	7	0	3
388529	1874	12670000	29770	14673	8	0	3
388531	10	32602533762605	29770	14673	10	0	3
388532	1874	12672000	29770	14673	11	0	3
388533	1874	12674000	29770	14673	12	0	3
388534	1874	12676000	29770	14673	13	0	3
388536	1874	12681000	29770	14673	15	0	3
388537	1874	12685000	29770	14673	16	0	3
388538	1874	12689000	29770	14673	17	0	3
388539	450	66933430434669	29770	14673	18	0	0
388540	601	66933430434669	29770	14673	19	0	0
388542	1874	12690000	29770	14673	21	0	3
388543	1874	12691000	29770	14673	22	0	3
388544	1821	932496362778	29770	14673	23	0	2
388545	301	66088290080033	29770	14673	24	0	4
388546	339	66933430434669	29770	14673	25	0	0
388548	392	66933430434669	29770	14673	27	0	0
388553	1874	12653000	29771	14673	4	0	\N
388554	450	66933430434669	29771	14673	5	0	\N
388555	601	66933430434669	29771	14673	7	0	\N
388556	408	66933430434669	29771	14673	8	0	\N
388557	1874	12654000	29771	14673	9	0	\N
388558	1874	12655000	29771	14673	10	0	\N
388559	1821	932496362778	29771	14673	11	0	\N
388560	301	66088290080033	29771	14673	12	0	\N
388561	339	66933430434669	29771	14673	13	0	\N
388562	186	66933170434669	29771	14673	14	0	\N
388563	392	66933430434669	29771	14673	15	0	\N
388595	1678	28800895173000	29773	14674	0	0	\N
388596	1678	28800895174000	29773	14674	1	0	\N
388597	1874	12692000	29773	14674	2	0	\N
388598	1874	12693000	29773	14674	3	0	\N
388599	1874	12697000	29773	14674	4	0	\N
388600	1874	12698000	29773	14674	5	0	\N
388601	1874	12702000	29773	14674	6	0	\N
388602	1874	12706000	29773	14674	7	0	\N
388603	1874	12710000	29773	14674	8	0	\N
388604	1874	12714000	29773	14674	9	0	\N
388605	1874	12716000	29773	14674	10	0	\N
388606	1874	12720000	29773	14674	11	0	\N
388607	1874	12724000	29773	14674	12	0	\N
388608	1874	12728000	29773	14674	13	0	\N
388609	283	66087299080033	29773	14674	14	0	\N
388610	308	66933430434669	29773	14674	15	0	\N
388611	2017	932029769068	29773	14674	16	0	\N
388612	105	66933430434669	29773	14674	17	0	\N
388613	399	66933430434669	29773	14674	18	0	\N
388614	636	66276827024809	29773	14674	19	0	\N
388615	721	2028285770627	29773	14674	20	0	\N
388616	1874	12730000	29773	14674	21	0	\N
388617	1874	12732000	29773	14674	22	0	\N
388618	1874	12734000	29773	14674	23	0	\N
388619	206	66933430434669	29773	14674	24	0	\N
388620	194	66933430434669	29773	14674	25	0	\N
388621	1874	12736000	29773	14674	26	0	\N
388622	1874	12738000	29773	14674	27	0	\N
388623	1276	1717940411415866	29773	14674	28	0	\N
388624	504	66320360434669	29773	14674	29	0	\N
388625	205	66933430434669	29773	14674	30	0	\N
388626	1678	28800895173000	29774	14674	0	0	\N
388627	1678	28800895174000	29774	14674	1	0	\N
388628	1874	12692000	29774	14674	2	0	\N
388629	1874	12693000	29774	14674	3	0	\N
388630	1874	12697000	29774	14674	4	0	\N
388631	1874	12698000	29774	14674	5	0	\N
388632	1874	12702000	29774	14674	6	0	\N
388633	1874	12706000	29774	14674	7	0	\N
388634	1874	12710000	29774	14674	8	0	\N
388635	1874	12714000	29774	14674	9	0	\N
388636	1874	12716000	29774	14674	10	0	\N
388637	1874	12720000	29774	14674	11	0	\N
388638	1874	12724000	29774	14674	12	0	\N
388639	1874	12728000	29774	14674	13	0	\N
388640	283	66087299080033	29774	14674	14	0	\N
388641	308	66933430434669	29774	14674	15	0	\N
388642	2017	932029769068	29774	14674	16	0	\N
388643	105	66933430434669	29774	14674	17	0	\N
388644	399	66933430434669	29774	14674	18	0	\N
388645	636	66276827024809	29774	14674	19	0	\N
388646	721	2028285770627	29774	14674	20	0	\N
388647	1874	12730000	29774	14674	21	0	\N
388648	1874	12732000	29774	14674	22	0	\N
388649	1874	12734000	29774	14674	23	0	\N
388650	206	66933430434669	29774	14674	24	0	\N
388651	194	66933430434669	29774	14674	25	0	\N
388652	1874	12736000	29774	14674	26	0	\N
388653	1874	12738000	29774	14674	27	0	\N
388654	1276	1717940411415866	29774	14674	28	0	\N
388655	504	66320360434669	29774	14674	29	0	\N
388656	205	66933430434669	29774	14674	30	0	\N
388685	1678	28800895177000	29776	14676	0	0	\N
388686	1874	12781000	29776	14676	1	0	\N
388687	1874	12783000	29776	14676	2	0	\N
388688	611	66933430434669	29776	14676	3	0	\N
388566	1874	12692000	29772	14674	2	0	3
388567	1874	12693000	29772	14674	3	0	3
388568	1874	12697000	29772	14674	4	0	3
388569	1874	12698000	29772	14674	5	0	3
388570	1874	12702000	29772	14674	6	0	3
388572	1874	12710000	29772	14674	8	0	3
388573	1874	12714000	29772	14674	9	0	3
388574	1874	12716000	29772	14674	10	0	3
388575	1874	12720000	29772	14674	11	0	3
388576	1874	12724000	29772	14674	12	0	3
388578	283	66087299080033	29772	14674	14	0	3
388579	308	66933430434669	29772	14674	15	0	0
388580	2017	932029769068	29772	14674	16	0	2
388581	105	66933430434669	29772	14674	17	0	0
388583	636	66276827024809	29772	14674	19	0	1
388584	721	2028285770627	29772	14674	20	0	0
388585	1874	12730000	29772	14674	21	0	3
388586	1874	12732000	29772	14674	22	0	3
388587	1874	12734000	29772	14674	23	0	3
388589	194	66933430434669	29772	14674	25	0	0
388590	1874	12736000	29772	14674	26	0	3
388591	1874	12738000	29772	14674	27	0	3
388592	1276	1717940411415866	29772	14674	28	0	0
388593	504	66320360434669	29772	14674	29	0	3
388657	1678	28800895175000	29775	14675	0	0	1
388658	1678	28800895176000	29775	14675	1	0	1
388659	1874	12739000	29775	14675	2	0	3
388660	1874	12740000	29775	14675	3	0	3
388662	1874	12745000	29775	14675	5	0	3
388663	1874	12749000	29775	14675	6	0	3
388664	1874	12753000	29775	14675	7	0	3
388665	1874	12757000	29775	14675	8	0	3
388666	1874	12761000	29775	14675	9	0	3
388668	1874	12769000	29775	14675	11	0	3
388669	578	66276917402319	29775	14675	12	0	1
388670	1874	12771000	29775	14675	13	0	3
388671	1874	12773000	29775	14675	14	0	3
388672	1874	12775000	29775	14675	15	0	3
388674	1874	12779000	29775	14675	17	0	3
388675	649	66276917402319	29775	14675	18	0	1
388676	114	66087621517324	29775	14675	19	0	13
388677	443	66277216652233	29775	14675	20	0	3
388679	500	66933430434669	29775	14675	22	0	0
388680	587	66933430434669	29775	14675	23	0	0
388681	146	66933428309669	29775	14675	24	0	1
388682	225	66933430434669	29775	14675	25	0	0
388683	377	66933430434669	29775	14675	26	0	0
388689	1874	12787000	29776	14676	4	0	\N
388690	1874	12791000	29776	14676	5	0	\N
388691	1874	12795000	29776	14676	6	0	\N
388692	1874	12799000	29776	14676	7	0	\N
388693	252	66933430434669	29776	14676	8	0	\N
388694	108	66933430434669	29776	14676	9	0	\N
388695	1778	7427079110417	29776	14676	10	0	\N
388696	99	66933430434669	29776	14676	11	0	\N
388697	35	19471543399080	29776	14676	12	0	\N
388698	1874	12800000	29776	14676	13	0	\N
388699	1678	28800895177000	29777	14676	0	0	\N
388700	1874	12781000	29777	14676	1	0	\N
388701	1874	12783000	29777	14676	2	0	\N
388702	611	66933430434669	29777	14676	3	0	\N
388703	1874	12787000	29777	14676	4	0	\N
388704	1874	12791000	29777	14676	5	0	\N
388705	1874	12795000	29777	14676	6	0	\N
388706	1874	12799000	29777	14676	7	0	\N
388707	252	66933430434669	29777	14676	8	0	\N
388708	108	66933430434669	29777	14676	9	0	\N
388709	1778	7427079110417	29777	14676	10	0	\N
388710	99	66933430434669	29777	14676	11	0	\N
388711	35	19471543399080	29777	14676	12	0	\N
388712	1874	12800000	29777	14676	13	0	\N
388713	1874	12801000	29777	14676	14	0	\N
388714	1678	28800895177000	29778	14676	0	0	\N
388715	1874	12781000	29778	14676	1	0	\N
388716	1874	12783000	29778	14676	2	0	\N
388717	611	66933430434669	29778	14676	3	0	\N
388718	1874	12787000	29778	14676	4	0	\N
388719	1874	12791000	29778	14676	5	0	\N
388720	1874	12795000	29778	14676	6	0	\N
388721	1874	12799000	29778	14676	7	0	\N
388722	252	66933430434669	29778	14676	8	0	\N
388723	108	66933430434669	29778	14676	9	0	\N
388724	1778	7427079110417	29778	14676	10	0	\N
388725	99	66933430434669	29778	14676	11	0	\N
388726	35	19471543399080	29778	14676	12	0	\N
388727	1874	12800000	29778	14676	13	0	\N
388728	1874	12801000	29778	14676	14	0	\N
388742	1678	28800895177000	29780	14676	0	0	\N
388743	1874	12781000	29780	14676	1	0	\N
388744	1874	12783000	29780	14676	2	0	\N
388745	611	66933430434669	29780	14676	3	0	\N
388746	1874	12787000	29780	14676	4	0	\N
388747	1874	12791000	29780	14676	5	0	\N
388748	1874	12795000	29780	14676	6	0	\N
388749	1874	12799000	29780	14676	7	0	\N
388750	252	66933430434669	29780	14676	8	0	\N
388751	108	66933430434669	29780	14676	9	0	\N
388752	1778	7427079110417	29780	14676	10	0	\N
388753	99	66933430434669	29780	14676	11	0	\N
388754	35	19471543399080	29780	14676	12	0	\N
388755	1874	12800000	29780	14676	13	0	\N
388756	1874	12801000	29780	14676	14	0	\N
388789	1678	28800895163000	29783	14666	0	0	\N
388790	1678	28800895164000	29783	14666	2	0	\N
388791	1678	28800895165000	29783	14666	3	0	\N
388792	1678	28800895166000	29783	14666	4	0	\N
388793	1678	28800895167000	29783	14666	5	0	\N
388794	1678	28800895168000	29783	14666	6	0	\N
388795	1678	28800895169000	29783	14666	7	0	\N
388796	1678	28800895170000	29783	14666	8	0	\N
388797	1678	28800895171000	29783	14666	9	0	\N
388798	1678	28800895172000	29783	14666	10	0	\N
388799	1678	28800895173000	29783	14666	11	0	\N
388800	1678	28800895174000	29783	14666	12	0	\N
388801	1678	28800895175000	29783	14666	13	0	\N
388802	1678	28800895176000	29783	14666	14	0	\N
388803	1678	28800895177000	29783	14666	15	0	\N
388804	1678	28800895178000	29783	14666	16	0	\N
388805	1678	28800895179000	29783	14666	17	0	\N
388806	1678	28800895180000	29783	14666	18	0	\N
388807	342	66277931638598	29783	14666	19	0	\N
388808	1874	12505000	29783	14666	20	0	\N
388809	894	311162277935181	29783	14666	21	0	\N
388810	569	66933430434669	29783	14666	22	0	\N
388811	1874	12506000	29783	14666	23	0	\N
388812	1874	12508000	29783	14666	24	0	\N
388813	1874	12510000	29783	14666	25	0	\N
388814	1874	12512000	29783	14666	26	0	\N
388815	1874	12514000	29783	14666	27	0	\N
388816	1874	12516000	29783	14666	28	0	\N
388817	1874	12518000	29783	14666	29	0	\N
388818	1874	12520000	29783	14666	30	0	\N
388819	1874	12522000	29783	14666	31	0	\N
388820	1874	12524000	29783	14666	32	0	\N
388821	1874	12526000	29783	14666	33	0	\N
388822	1874	12528000	29783	14666	34	0	\N
388823	1874	12530000	29783	14666	35	0	\N
388824	1874	12532000	29783	14666	36	0	\N
388731	1874	12783000	29779	14676	2	0	3
388732	611	66933430434669	29779	14676	3	0	0
388733	1874	12787000	29779	14676	4	0	3
388734	1874	12791000	29779	14676	5	0	3
388735	1874	12795000	29779	14676	6	0	3
388737	252	66933430434669	29779	14676	8	0	0
388738	108	66933430434669	29779	14676	9	0	0
388739	1778	7427079110417	29779	14676	10	0	1
388740	99	66933430434669	29779	14676	11	0	0
388741	1874	12800000	29779	14676	12	0	3
388758	1678	28800895179000	29781	14677	1	0	1
388759	1874	12802000	29781	14677	2	0	3
388760	35	19471543399080	29781	14677	3	0	0
388761	49	66933430434669	29781	14677	4	0	0
388763	1874	12803000	29781	14677	6	0	3
388764	1874	12804000	29781	14677	7	0	3
388765	1874	12805000	29781	14677	8	0	3
388766	1874	12806000	29781	14677	9	0	3
388767	1874	12810000	29781	14677	10	0	3
388769	1874	12818000	29781	14677	12	0	3
388770	1874	12822000	29781	14677	13	0	3
388771	1874	12824000	29781	14677	14	0	3
388772	1874	12826000	29781	14677	15	0	3
388773	54	66933430434669	29781	14677	16	0	0
388775	1874	12830000	29781	14677	18	0	3
388776	1874	12832000	29781	14677	19	0	3
388777	1678	28800895180000	29782	14678	0	0	1
388778	1874	12833000	29782	14678	1	0	3
388780	217	66933430434669	29782	14678	4	0	0
388781	103	66933430434669	29782	14678	5	0	0
388782	893	311162277935181	29782	14678	6	0	0
388783	620	66933430434669	29782	14678	7	0	0
388784	1874	12835000	29782	14678	8	0	3
388786	1874	12841000	29782	14678	10	0	3
388787	1874	12845000	29782	14678	11	0	3
388788	1874	12849000	29782	14678	12	0	3
388825	1874	12534000	29783	14666	37	0	\N
388826	1874	12536000	29783	14666	38	0	\N
388827	1874	12538000	29783	14666	39	0	\N
388828	1874	12540000	29783	14666	40	0	\N
388829	1874	12542000	29783	14666	41	0	\N
388830	1874	12544000	29783	14666	42	0	\N
388831	1874	12546000	29783	14666	43	0	\N
388832	1874	12548000	29783	14666	44	0	\N
388833	1874	12550000	29783	14666	45	0	\N
388834	1874	12552000	29783	14666	46	0	\N
388835	1874	12554000	29783	14666	47	0	\N
388836	1874	12556000	29783	14666	48	0	\N
388837	1874	12558000	29783	14666	49	0	\N
388838	1874	12560000	29783	14666	50	0	\N
388839	1874	12562000	29783	14666	51	0	\N
388840	1874	12564000	29783	14666	52	0	\N
388841	1874	12566000	29783	14666	53	0	\N
388842	1874	12568000	29783	14666	54	0	\N
388843	1874	12570000	29783	14666	55	0	\N
388844	1874	12572000	29783	14666	56	0	\N
388845	1874	12574000	29783	14666	57	0	\N
388846	1874	12576000	29783	14666	58	0	\N
388847	1874	12578000	29783	14666	59	0	\N
388848	1874	12580000	29783	14666	60	0	\N
388849	1874	12582000	29783	14666	61	0	\N
388850	1874	12584000	29783	14666	62	0	\N
388851	1874	12586000	29783	14666	63	0	\N
388852	1874	12588000	29783	14666	64	0	\N
388853	1874	12590000	29783	14666	65	0	\N
388854	1874	12592000	29783	14666	66	0	\N
388855	1874	12594000	29783	14666	67	0	\N
388856	1874	12596000	29783	14666	68	0	\N
388857	1874	12598000	29783	14666	69	0	\N
388858	1874	12600000	29783	14666	70	0	\N
388859	1874	12602000	29783	14666	71	0	\N
388860	1874	12604000	29783	14666	72	0	\N
388861	1874	12606000	29783	14666	73	0	\N
388862	1678	28800895180000	29784	14678	0	0	\N
388863	1874	12833000	29784	14678	1	0	\N
388864	530	66855485387862	29784	14678	3	0	\N
388865	217	66933430434669	29784	14678	4	0	\N
388866	103	66933430434669	29784	14678	5	0	\N
388867	893	311162277935181	29784	14678	6	0	\N
388868	620	66933430434669	29784	14678	7	0	\N
388869	1874	12835000	29784	14678	8	0	\N
388870	1874	12837000	29784	14678	9	0	\N
388871	1874	12841000	29784	14678	10	0	\N
388872	1874	12845000	29784	14678	11	0	\N
388873	1874	12849000	29784	14678	12	0	\N
388874	1678	28800895181000	29785	14679	0	0	\N
388875	1678	28800895182000	29785	14679	1	0	\N
388876	1874	12851000	29785	14679	2	0	\N
388877	1874	12853000	29785	14679	3	0	\N
388878	1874	12854000	29785	14679	4	0	\N
388879	1874	12856000	29785	14679	5	0	\N
388880	1874	12858000	29785	14679	6	0	\N
388881	1874	12860000	29785	14679	7	0	\N
388882	1874	12862000	29785	14679	8	0	\N
388883	245	66933430434669	29785	14679	9	0	\N
388884	600	66933430434669	29785	14679	10	0	\N
388885	691	66933430434669	29785	14679	11	0	\N
388886	2164	932091240772	29785	14679	12	0	\N
388887	165	66276917402319	29785	14679	13	0	\N
388888	180	66933439434669	29785	14679	14	0	\N
388889	237	66276917402319	29785	14679	15	0	\N
388890	2073	931415434669	29785	14679	16	0	\N
388891	1874	12863000	29785	14679	17	0	\N
388892	1874	12864000	29785	14679	18	0	\N
388893	748	2730688722170	29785	14679	19	0	\N
388894	163	66933430434669	29785	14679	20	0	\N
388895	201	66933430434669	29785	14679	21	0	\N
388896	1962	932342609896	29785	14679	22	0	\N
388897	1874	12868000	29785	14679	23	0	\N
388898	1874	12872000	29785	14679	24	0	\N
388899	1874	12876000	29785	14679	25	0	\N
388900	1874	12880000	29785	14679	26	0	\N
388901	1874	12884000	29785	14679	27	0	\N
388902	1874	12888000	29785	14679	28	0	\N
388903	1678	28800895181000	29786	14679	0	0	\N
388904	1678	28800895182000	29786	14679	1	0	\N
388905	1874	12851000	29786	14679	2	0	\N
388906	1874	12853000	29786	14679	3	0	\N
388907	1874	12854000	29786	14679	4	0	\N
388908	1874	12856000	29786	14679	5	0	\N
388909	1874	12858000	29786	14679	6	0	\N
388910	1874	12860000	29786	14679	7	0	\N
388911	1874	12862000	29786	14679	8	0	\N
388912	245	66933430434669	29786	14679	9	0	\N
388913	600	66933430434669	29786	14679	10	0	\N
388914	691	66933430434669	29786	14679	11	0	\N
388915	2164	932091240772	29786	14679	12	0	\N
388916	165	66276917402319	29786	14679	13	0	\N
388917	180	66933439434669	29786	14679	14	0	\N
388918	237	66276917402319	29786	14679	15	0	\N
388919	2073	931415434669	29786	14679	16	0	\N
388920	1874	12863000	29786	14679	17	0	\N
388921	1874	12864000	29786	14679	18	0	\N
388922	748	2730688722170	29786	14679	19	0	\N
388923	163	66933430434669	29786	14679	20	0	\N
388924	201	66933430434669	29786	14679	21	0	\N
388925	1962	932342609896	29786	14679	22	0	\N
388926	1874	12868000	29786	14679	23	0	\N
388927	1874	12872000	29786	14679	24	0	\N
388928	1874	12876000	29786	14679	25	0	\N
388929	1874	12880000	29786	14679	26	0	\N
388930	1874	12884000	29786	14679	27	0	\N
388931	1874	12888000	29786	14679	28	0	\N
388934	1874	12851000	29787	14679	2	0	3
388935	1874	12853000	29787	14679	3	0	3
388936	1874	12854000	29787	14679	4	0	3
388937	1874	12856000	29787	14679	5	0	3
388938	1874	12858000	29787	14679	6	0	3
388940	1874	12862000	29787	14679	8	0	3
388941	245	66933430434669	29787	14679	9	0	0
388942	600	66933430434669	29787	14679	10	0	0
388943	691	66933430434669	29787	14679	11	0	0
388944	2164	932091240772	29787	14679	12	0	1
388946	180	66933439434669	29787	14679	14	0	1
388947	237	66276917402319	29787	14679	15	0	1
388948	2073	931415434669	29787	14679	16	0	2
388949	1874	12863000	29787	14679	17	0	3
388951	748	2730688722170	29787	14679	19	0	1
388952	163	66933430434669	29787	14679	20	0	0
388953	201	66933430434669	29787	14679	21	0	0
388954	1962	932342609896	29787	14679	22	0	1
388955	1874	12868000	29787	14679	23	0	3
388957	1874	12876000	29787	14679	25	0	3
388958	1874	12880000	29787	14679	26	0	3
388959	1874	12884000	29787	14679	27	0	3
388960	1874	12888000	29787	14679	28	0	3
388961	1678	28800895181000	29788	14667	0	0	\N
388962	1678	28800895182000	29788	14667	1	0	\N
388963	1874	12608000	29788	14667	2	0	\N
388964	1874	12610000	29788	14667	3	0	\N
388965	1874	12612000	29788	14667	4	0	\N
388966	1874	12614000	29788	14667	5	0	\N
388967	1874	12616000	29788	14667	6	0	\N
388968	1874	12618000	29788	14667	7	0	\N
388969	1678	28800895181000	29789	14679	0	0	\N
388970	1678	28800895182000	29789	14679	1	0	\N
388971	1874	12851000	29789	14679	2	0	\N
388972	1874	12853000	29789	14679	3	0	\N
388973	1874	12854000	29789	14679	4	0	\N
388974	1874	12856000	29789	14679	5	0	\N
388975	1874	12858000	29789	14679	6	0	\N
388976	1874	12860000	29789	14679	7	0	\N
388977	1874	12862000	29789	14679	8	0	\N
388978	245	66933430434669	29789	14679	9	0	\N
388979	600	66933430434669	29789	14679	10	0	\N
388980	691	66933430434669	29789	14679	11	0	\N
388981	2164	932091240772	29789	14679	12	0	\N
388982	165	66276917402319	29789	14679	13	0	\N
388983	180	66933439434669	29789	14679	14	0	\N
388984	237	66276917402319	29789	14679	15	0	\N
388985	2073	931415434669	29789	14679	16	0	\N
388986	1874	12863000	29789	14679	17	0	\N
388987	1874	12864000	29789	14679	18	0	\N
388988	748	2730688722170	29789	14679	19	0	\N
388989	163	66933430434669	29789	14679	20	0	\N
388990	201	66933430434669	29789	14679	21	0	\N
388991	1962	932342609896	29789	14679	22	0	\N
388992	1874	12868000	29789	14679	23	0	\N
388993	1874	12872000	29789	14679	24	0	\N
388994	1874	12876000	29789	14679	25	0	\N
388995	1874	12880000	29789	14679	26	0	\N
388996	1874	12884000	29789	14679	27	0	\N
388997	1874	12888000	29789	14679	28	0	\N
388998	1678	28800895183000	29791	14680	0	0	\N
388999	1874	12890000	29791	14680	1	0	\N
389000	594	66933430434669	29791	14680	2	0	\N
389001	1874	12891000	29791	14680	3	0	\N
389002	63	66933430434669	29791	14680	4	0	\N
389003	150	66933430434669	29791	14680	5	0	\N
389004	562	66276917402319	29791	14680	6	0	\N
389005	92	66933430434669	29791	14680	7	0	\N
389006	1874	12895000	29791	14680	8	0	\N
389007	1874	12899000	29791	14680	9	0	\N
389008	1874	12903000	29791	14680	10	0	\N
389009	1874	12905000	29791	14680	11	0	\N
389010	1874	12907000	29791	14680	12	0	\N
389024	1678	28800895184000	29793	14681	0	0	\N
389025	373	66933430434669	29793	14681	1	0	\N
389026	1874	12908000	29793	14681	2	0	\N
389027	1874	12909000	29793	14681	3	0	\N
389028	1874	12911000	29793	14681	4	0	\N
389029	1874	12915000	29793	14681	5	0	\N
389030	1874	12919000	29793	14681	6	0	\N
389031	453	66932429434669	29793	14681	7	0	\N
389032	711	3014983071021	29793	14681	8	0	\N
389033	91	66933430434669	29793	14681	9	0	\N
389034	438	66933430434669	29793	14681	10	0	\N
389035	745	2028285770627	29793	14681	11	0	\N
389036	1678	28800895184000	29794	14681	0	0	\N
389037	373	66933430434669	29794	14681	1	0	\N
389038	1874	12908000	29794	14681	2	0	\N
389039	1874	12909000	29794	14681	3	0	\N
389040	1874	12911000	29794	14681	4	0	\N
389041	1874	12915000	29794	14681	5	0	\N
389042	1874	12919000	29794	14681	6	0	\N
389043	453	66932429434669	29794	14681	7	0	\N
389044	711	3014983071021	29794	14681	8	0	\N
389045	91	66933430434669	29794	14681	9	0	\N
389046	438	66933430434669	29794	14681	10	0	\N
389047	745	2028285770627	29794	14681	11	0	\N
389060	1678	28800895184000	29796	14681	0	0	\N
389061	373	66933430434669	29796	14681	1	0	\N
389062	1874	12908000	29796	14681	2	0	\N
389063	1874	12909000	29796	14681	3	0	\N
389064	1874	12911000	29796	14681	4	0	\N
389065	453	66932429434669	29796	14681	5	0	\N
389066	711	3014983071021	29796	14681	6	0	\N
389067	91	66933430434669	29796	14681	7	0	\N
389068	438	66933430434669	29796	14681	8	0	\N
389013	594	66933430434669	29792	14680	2	0	0
389014	1874	12891000	29792	14680	3	0	3
389015	63	66933430434669	29792	14680	4	0	0
389016	150	66933430434669	29792	14680	5	0	0
389017	562	66276917402319	29792	14680	6	0	1
389019	1874	12895000	29792	14680	8	0	3
389020	1874	12899000	29792	14680	9	0	3
389021	1874	12903000	29792	14680	10	0	3
389022	1874	12905000	29792	14680	11	0	3
389023	1874	12907000	29792	14680	12	0	3
389049	373	66933430434669	29795	14681	1	0	0
389050	1874	12908000	29795	14681	2	0	3
389051	1874	12909000	29795	14681	3	0	3
389052	1874	12911000	29795	14681	4	0	3
389054	1874	12919000	29795	14681	6	0	3
389055	453	66932429434669	29795	14681	7	0	1
389056	711	3014983071021	29795	14681	8	0	1
389057	91	66933430434669	29795	14681	9	0	0
389058	438	66933430434669	29795	14681	10	0	0
389069	1299	1706538047667750	29797	14682	0	0	0
389070	1678	28800895185000	29797	14682	1	0	1
389071	1678	28800895186000	29797	14682	2	0	1
389072	1678	28800895187000	29797	14682	3	0	1
389073	1678	28800895188000	29797	14682	4	0	1
389075	383	66933430434669	29797	14682	6	0	0
389076	678	66933430434669	29797	14682	7	0	0
389077	1874	12920000	29797	14682	8	0	3
389078	1874	12924000	29797	14682	9	0	3
389080	1874	12932000	29797	14682	11	0	3
389081	1874	12936000	29797	14682	12	0	3
389082	1874	12937000	29797	14682	13	0	3
389083	1874	12938000	29797	14682	14	0	3
389084	1874	12939000	29797	14682	15	0	3
389086	1874	12941000	29797	14682	17	0	3
389087	1874	12945000	29797	14682	18	0	3
389088	1874	12949000	29797	14682	19	0	3
389089	1874	12953000	29797	14682	20	0	3
389090	1874	12957000	29797	14682	21	0	3
389092	1874	12965000	29797	14682	23	0	3
389093	1874	12969000	29797	14682	24	0	3
389094	1874	12973000	29797	14682	25	0	3
389095	1874	12977000	29797	14682	26	0	3
389129	1678	28800895189000	29798	14683	0	0	\N
389130	1874	13009000	29798	14683	1	0	\N
389131	1874	13010000	29798	14683	2	0	\N
389132	1874	13014000	29798	14683	3	0	\N
389133	1874	13018000	29798	14683	4	0	\N
389134	1874	13022000	29798	14683	5	0	\N
389135	1874	13026000	29798	14683	6	0	\N
389136	1874	13028000	29798	14683	7	0	\N
389137	1874	13030000	29798	14683	8	0	\N
389146	1299	1706538047667750	29800	14667	0	0	\N
389147	1678	28800895165000	29800	14667	1	0	\N
389148	1678	28800895166000	29800	14667	2	0	\N
389149	1678	28800895167000	29800	14667	3	0	\N
389150	1678	28800895168000	29800	14667	4	0	\N
389151	1678	28800895169000	29800	14667	5	0	\N
389152	1678	28800895170000	29800	14667	6	0	\N
389153	1678	28800895171000	29800	14667	7	0	\N
389154	1678	28800895172000	29800	14667	8	0	\N
389155	1678	28800895173000	29800	14667	9	0	\N
389156	1678	28800895174000	29800	14667	10	0	\N
389157	1678	28800895175000	29800	14667	11	0	\N
389158	1678	28800895176000	29800	14667	12	0	\N
389159	1678	28800895177000	29800	14667	13	0	\N
389160	1678	28800895178000	29800	14667	14	0	\N
389161	1678	28800895179000	29800	14667	15	0	\N
389162	1678	28800895180000	29800	14667	16	0	\N
389163	1678	28800895181000	29800	14667	17	0	\N
389164	1678	28800895182000	29800	14667	18	0	\N
389165	1678	28800895183000	29800	14667	19	0	\N
389166	1678	28800895184000	29800	14667	20	0	\N
389167	1678	28800895185000	29800	14667	21	0	\N
389168	1678	28800895186000	29800	14667	22	0	\N
389169	1678	28800895187000	29800	14667	23	0	\N
389170	1678	28800895188000	29800	14667	24	0	\N
389171	1678	28800895189000	29800	14667	25	0	\N
389172	120	66277730799728	29800	14667	26	0	\N
389173	320	66651050983763	29800	14667	27	0	\N
389174	354	66279227049307	29800	14667	28	0	\N
389175	663	66933430434669	29800	14667	29	0	\N
389176	710	5070714426784	29800	14667	30	0	\N
389177	499	66933430434669	29800	14667	31	0	\N
389178	1874	12505000	29800	14667	32	0	\N
389179	1874	12507000	29800	14667	33	0	\N
389180	1874	12509000	29800	14667	34	0	\N
389181	1874	12511000	29800	14667	35	0	\N
389182	1874	12513000	29800	14667	36	0	\N
389183	1874	12514000	29800	14667	37	0	\N
389184	1874	12515000	29800	14667	38	0	\N
389185	1874	12516000	29800	14667	39	0	\N
389186	1874	12517000	29800	14667	40	0	\N
389187	1874	12518000	29800	14667	41	0	\N
389188	1874	12520000	29800	14667	42	0	\N
389189	1874	12522000	29800	14667	43	0	\N
389190	1874	12524000	29800	14667	44	0	\N
389191	1874	12526000	29800	14667	45	0	\N
389192	1874	12527000	29800	14667	46	0	\N
389193	1874	12528000	29800	14667	47	0	\N
389194	1874	12529000	29800	14667	48	0	\N
389195	1874	12530000	29800	14667	49	0	\N
389196	1874	12531000	29800	14667	50	0	\N
389197	1874	12532000	29800	14667	51	0	\N
389198	1874	12533000	29800	14667	52	0	\N
389199	1874	12534000	29800	14667	53	0	\N
389200	1874	12535000	29800	14667	54	0	\N
389201	1874	12536000	29800	14667	55	0	\N
389202	1874	12537000	29800	14667	56	0	\N
389203	1874	12538000	29800	14667	57	0	\N
389204	1874	12539000	29800	14667	58	0	\N
389205	1874	12540000	29800	14667	59	0	\N
389206	1874	12541000	29800	14667	60	0	\N
389207	1874	12542000	29800	14667	61	0	\N
389208	1874	12543000	29800	14667	62	0	\N
389209	1874	12544000	29800	14667	63	0	\N
389210	1874	12545000	29800	14667	64	0	\N
389211	1874	12546000	29800	14667	65	0	\N
389212	1874	12547000	29800	14667	66	0	\N
389213	1874	12548000	29800	14667	67	0	\N
389214	1874	12549000	29800	14667	68	0	\N
389215	1874	12550000	29800	14667	69	0	\N
389216	1874	12551000	29800	14667	70	0	\N
389217	1874	12552000	29800	14667	71	0	\N
389218	1874	12553000	29800	14667	72	0	\N
389219	1874	12554000	29800	14667	73	0	\N
389220	1874	12555000	29800	14667	74	0	\N
389221	1874	12556000	29800	14667	75	0	\N
389222	1874	12557000	29800	14667	76	0	\N
389223	1874	12558000	29800	14667	77	0	\N
389224	1874	12560000	29800	14667	78	0	\N
389225	1874	12562000	29800	14667	79	0	\N
389226	1874	12564000	29800	14667	80	0	\N
389227	1811	2555508410581	29800	14667	81	0	\N
389228	520	66933430434669	29800	14667	82	0	\N
389229	191	66933430434669	29800	14667	83	0	\N
389230	421	66930330434669	29800	14667	84	0	\N
389231	266	66320410434669	29800	14667	85	0	\N
389232	352	66933430434669	29800	14667	86	0	\N
389099	84	66933430434669	29797	14682	30	0	0
389100	2430	275707401654	29797	14682	31	0	1
389101	551	66933430434669	29797	14682	32	0	0
389102	122	66933430434669	29797	14682	33	0	0
389103	2308	274078593184	29797	14682	34	0	1
389105	304	66933430434669	29797	14682	36	0	0
389106	441	66154737066764	29797	14682	37	0	2
389107	240	66277931638598	29797	14682	38	0	1
389108	262	66276893440052	29797	14682	39	0	4
389109	154	66276917402319	29797	14682	40	0	1
389111	658	66933430434669	29797	14682	42	0	0
389112	660	66933430434669	29797	14682	43	0	0
389113	593	66932429434669	29797	14682	44	0	1
389114	395	66131375725798	29797	14682	45	0	3
389116	29	7099000197514	29797	14682	47	0	0
389117	910	509889096950029	29797	14682	48	0	0
389118	1874	12987000	29797	14682	49	0	3
389119	1874	12989000	29797	14682	51	0	3
389120	1874	12991000	29797	14682	52	0	3
389122	1874	12995000	29797	14682	54	0	3
389123	1874	12997000	29797	14682	55	0	3
389124	1874	12999000	29797	14682	56	0	3
389125	1874	13001000	29797	14682	57	0	3
389126	1874	13003000	29797	14682	58	0	3
389128	1874	13007000	29797	14682	60	0	3
389138	1678	28800895189000	29799	14683	0	0	1
389139	1874	13009000	29799	14683	1	0	3
389140	1874	13010000	29799	14683	2	0	3
389142	1874	13018000	29799	14683	4	0	3
389143	1874	13022000	29799	14683	5	0	3
389144	1874	13026000	29799	14683	6	0	3
389145	1874	13028000	29799	14683	7	0	3
389233	534	66933430434669	29800	14667	87	0	\N
389234	327	66276827024809	29800	14667	88	0	\N
389235	652	66933430434669	29800	14667	89	0	\N
389236	391	66932320434669	29800	14667	90	0	\N
389237	2181	931682240772	29800	14667	91	0	\N
389238	402	66933430434669	29800	14667	92	0	\N
389239	275	66933430434669	29800	14667	93	0	\N
389240	452	66933430434669	29800	14667	94	0	\N
389241	458	66279227049307	29800	14667	95	0	\N
389242	690	66933430434669	29800	14667	96	0	\N
389243	309	66933429434669	29800	14667	97	0	\N
389244	82	66933430434669	29800	14667	98	0	\N
389245	361	66283428434669	29800	14667	99	0	\N
389246	680	66933430434669	29800	14667	100	0	\N
389247	731	2028285770627	29800	14667	101	0	\N
389248	1678	28800895190000	29801	14684	0	0	\N
389249	1874	13030000	29801	14684	1	0	\N
389250	1874	13032000	29801	14684	2	0	\N
389251	1874	13033000	29801	14684	3	0	\N
389252	1874	13034000	29801	14684	4	0	\N
389253	1874	13036000	29801	14684	5	0	\N
389254	1874	13040000	29801	14684	6	0	\N
389255	1874	13044000	29801	14684	7	0	\N
389256	1874	13048000	29801	14684	8	0	\N
389257	1874	13052000	29801	14684	9	0	\N
389258	1874	13056000	29801	14684	10	0	\N
389289	1678	28800895193000	29804	14686	0	0	\N
389290	1874	13109000	29804	14686	1	0	\N
389291	1874	13113000	29804	14686	2	0	\N
389292	1874	13114000	29804	14686	3	0	\N
389293	1874	13118000	29804	14686	4	0	\N
389294	1874	13122000	29804	14686	5	0	\N
389310	1678	28800895194000	29807	14687	0	0	\N
389316	1678	28800895195000	29809	14688	0	0	\N
389317	1874	13140000	29809	14688	1	0	\N
389318	1874	13142000	29809	14688	2	0	\N
389319	1874	13143000	29809	14688	3	0	\N
389320	1874	13145000	29809	14688	4	0	\N
389321	1678	28800895195000	29810	14688	0	0	\N
389322	1874	13140000	29810	14688	1	0	\N
389323	1874	13142000	29810	14688	2	0	\N
389324	1874	13143000	29810	14688	3	0	\N
389325	1874	13145000	29810	14688	4	0	\N
389326	1678	28800895195000	29811	14688	0	0	\N
389327	1874	13140000	29811	14688	1	0	\N
389328	1874	13142000	29811	14688	2	0	\N
389329	1874	13143000	29811	14688	3	0	\N
389330	1874	13145000	29811	14688	4	0	\N
389331	1299	1706538047667750	29813	14666	0	0	\N
389332	1678	28800895163000	29813	14666	1	0	\N
389333	1678	28800895164000	29813	14666	2	0	\N
389334	1678	28800895165000	29813	14666	3	0	\N
389335	1678	28800895166000	29813	14666	5	0	\N
389336	1678	28800895167000	29813	14666	6	0	\N
389337	1678	28800895168000	29813	14666	7	0	\N
389338	1678	28800895169000	29813	14666	8	0	\N
389339	1678	28800895170000	29813	14666	9	0	\N
389340	1678	28800895171000	29813	14666	10	0	\N
389341	1678	28800895172000	29813	14666	11	0	\N
389342	1678	28800895173000	29813	14666	12	0	\N
389343	1678	28800895174000	29813	14666	13	0	\N
389344	1678	28800895175000	29813	14666	14	0	\N
389345	1678	28800895176000	29813	14666	15	0	\N
389346	1678	28800895177000	29813	14666	16	0	\N
389347	1678	28800895178000	29813	14666	17	0	\N
389348	1678	28800895179000	29813	14666	18	0	\N
389349	1678	28800895180000	29813	14666	19	0	\N
389350	1678	28800895181000	29813	14666	20	0	\N
389351	1678	28800895182000	29813	14666	21	0	\N
389352	1678	28800895183000	29813	14666	22	0	\N
389353	1678	28800895184000	29813	14666	23	0	\N
389354	1678	28800895185000	29813	14666	24	0	\N
389355	1678	28800895186000	29813	14666	25	0	\N
389356	1678	28800895187000	29813	14666	26	0	\N
389357	1678	28800895188000	29813	14666	27	0	\N
389358	1678	28800895189000	29813	14666	28	0	\N
389359	1678	28800895190000	29813	14666	29	0	\N
389360	1678	28800895191000	29813	14666	30	0	\N
389361	1678	28800895192000	29813	14666	31	0	\N
389362	1678	28800895193000	29813	14666	32	0	\N
389363	1678	28800895194000	29813	14666	33	0	\N
389364	1678	28800895195000	29813	14666	34	0	\N
389365	342	66277931638598	29813	14666	35	0	\N
389366	1874	12497000	29813	14666	36	0	\N
389367	1874	12501000	29813	14666	37	0	\N
389368	1874	12505000	29813	14666	38	0	\N
389261	1874	13032000	29802	14684	2	0	3
389262	1874	13033000	29802	14684	3	0	3
389263	1874	13034000	29802	14684	4	0	3
389264	1874	13036000	29802	14684	5	0	3
389265	1874	13040000	29802	14684	6	0	3
389267	1874	13048000	29802	14684	8	0	3
389268	1874	13052000	29802	14684	9	0	3
389269	1874	13056000	29802	14684	10	0	3
389270	1678	28800895191000	29803	14685	0	0	1
389271	1678	28800895192000	29803	14685	1	0	1
389273	1874	13061000	29803	14685	3	0	3
389274	1874	13065000	29803	14685	4	0	3
389275	1874	13066000	29803	14685	5	0	3
389276	1874	13067000	29803	14685	6	0	3
389278	1874	13075000	29803	14685	8	0	3
389279	1874	13079000	29803	14685	9	0	3
389280	1874	13081000	29803	14685	10	0	3
389281	1874	13083000	29803	14685	11	0	3
389282	1874	13085000	29803	14685	12	0	3
389284	1874	13089000	29803	14685	14	0	3
389285	1874	13093000	29803	14685	15	0	3
389286	1874	13097000	29803	14685	16	0	3
389287	1874	13101000	29803	14685	17	0	3
389288	1874	13105000	29803	14685	18	0	3
389296	1874	13109000	29805	14686	1	0	3
389297	1874	13113000	29805	14686	2	0	3
389298	1874	13114000	29805	14686	3	0	3
389299	1874	13118000	29805	14686	4	0	3
389301	1874	13124000	29805	14686	6	0	3
389302	1874	13126000	29805	14686	7	0	3
389303	1874	13128000	29805	14686	8	0	3
389304	1678	28800895194000	29806	14687	0	0	1
389305	1874	13132000	29806	14687	1	0	3
389307	1874	13135000	29806	14687	3	0	3
389308	1874	13136000	29806	14687	4	0	3
389309	1874	13138000	29806	14687	5	0	3
389311	1678	28800895195000	29808	14688	0	0	1
389312	1874	13140000	29808	14688	1	0	3
389314	1874	13143000	29808	14688	3	0	3
389315	1874	13145000	29808	14688	4	0	3
389369	1874	12509000	29813	14666	39	0	\N
389370	1874	12513000	29813	14666	40	0	\N
389371	894	311162277935181	29813	14666	41	0	\N
389372	569	66933430434669	29813	14666	42	0	\N
389373	390	66933430434669	29813	14666	43	0	\N
389374	570	66933430434669	29813	14666	44	0	\N
389375	251	66933430434669	29813	14666	45	0	\N
389376	312	66276827024809	29813	14666	46	0	\N
389377	1772	6689445300164	29813	14666	47	0	\N
389378	1030	913716893004926	29813	14666	48	0	\N
389379	238	66086983695901	29813	14666	49	0	\N
389380	120	66277730799728	29813	14666	50	0	\N
389381	320	66651050983763	29813	14666	51	0	\N
389382	354	66279227049307	29813	14666	52	0	\N
389383	663	66933430434669	29813	14666	53	0	\N
389384	710	5070714426784	29813	14666	54	0	\N
389385	499	66933430434669	29813	14666	55	0	\N
389386	1874	12517000	29813	14666	56	0	\N
389387	1874	12518000	29813	14666	57	0	\N
389388	1874	12519000	29813	14666	58	0	\N
389389	1874	12520000	29813	14666	59	0	\N
389390	1874	12521000	29813	14666	60	0	\N
389391	1874	12523000	29813	14666	61	0	\N
389392	1874	12525000	29813	14666	62	0	\N
389393	1874	12527000	29813	14666	63	0	\N
389394	1874	12529000	29813	14666	64	0	\N
389395	1874	12531000	29813	14666	65	0	\N
389396	1874	12533000	29813	14666	66	0	\N
389397	1874	12534000	29813	14666	67	0	\N
389398	1874	12535000	29813	14666	68	0	\N
389399	1874	12536000	29813	14666	69	0	\N
389400	1874	12537000	29813	14666	70	0	\N
389401	1874	12538000	29813	14666	71	0	\N
389402	1874	12540000	29813	14666	72	0	\N
389403	1874	12542000	29813	14666	73	0	\N
389404	1874	12544000	29813	14666	74	0	\N
389405	1874	12546000	29813	14666	75	0	\N
389406	1874	12547000	29813	14666	76	0	\N
389407	1874	12548000	29813	14666	77	0	\N
389408	1874	12549000	29813	14666	78	0	\N
389409	1874	12553000	29813	14666	79	0	\N
389410	1874	12557000	29813	14666	80	0	\N
389411	1874	12561000	29813	14666	81	0	\N
389412	1874	12565000	29813	14666	82	0	\N
389413	1874	12569000	29813	14666	83	0	\N
389414	1874	12573000	29813	14666	84	0	\N
389415	1874	12577000	29813	14666	85	0	\N
389416	1874	12578000	29813	14666	86	0	\N
389417	1874	12579000	29813	14666	87	0	\N
389418	1874	12580000	29813	14666	88	0	\N
389419	1874	12581000	29813	14666	89	0	\N
389420	1874	12582000	29813	14666	90	0	\N
389421	1874	12583000	29813	14666	91	0	\N
389422	1874	12584000	29813	14666	92	0	\N
389423	1874	12585000	29813	14666	93	0	\N
389424	1874	12586000	29813	14666	94	0	\N
389425	1874	12587000	29813	14666	95	0	\N
389426	1874	12588000	29813	14666	96	0	\N
389427	1874	12589000	29813	14666	97	0	\N
389428	1874	12590000	29813	14666	98	0	\N
389429	1874	12591000	29813	14666	99	0	\N
389430	1874	12592000	29813	14666	100	0	\N
389431	1874	12593000	29813	14666	101	0	\N
389432	1874	12594000	29813	14666	102	0	\N
389433	1874	12595000	29813	14666	103	0	\N
389434	1874	12596000	29813	14666	104	0	\N
389435	1874	12597000	29813	14666	105	0	\N
389436	1874	12598000	29813	14666	106	0	\N
389437	1874	12599000	29813	14666	107	0	\N
389438	1874	12600000	29813	14666	108	0	\N
389439	1874	12601000	29813	14666	109	0	\N
389440	1874	12602000	29813	14666	110	0	\N
389441	1874	12603000	29813	14666	111	0	\N
389442	1874	12604000	29813	14666	112	0	\N
389443	1874	12605000	29813	14666	113	0	\N
389444	1874	12606000	29813	14666	114	0	\N
389445	1874	12607000	29813	14666	115	0	\N
389446	1874	12608000	29813	14666	116	0	\N
389447	1874	12609000	29813	14666	117	0	\N
389448	1874	12610000	29813	14666	118	0	\N
389449	1874	12611000	29813	14666	119	0	\N
389450	1874	12612000	29813	14666	120	0	\N
389451	1874	12613000	29813	14666	121	0	\N
389452	1874	12614000	29813	14666	122	0	\N
389453	1874	12615000	29813	14666	123	0	\N
389483	1678	28800895196000	29816	14689	0	0	\N
389484	1678	28800895197000	29816	14689	1	0	\N
389485	1678	28800895198000	29816	14689	2	0	\N
389486	1874	13146000	29816	14689	3	0	\N
389487	1874	13150000	29816	14689	4	0	\N
389488	1874	13154000	29816	14689	5	0	\N
389489	1874	13158000	29816	14689	6	0	\N
389490	1874	13160000	29816	14689	7	0	\N
389491	1874	13162000	29816	14689	8	0	\N
389492	1874	13164000	29816	14689	9	0	\N
389493	1874	13166000	29816	14689	10	0	\N
389494	1874	13168000	29816	14689	11	0	\N
389495	1874	13170000	29816	14689	12	0	\N
389496	1874	13172000	29816	14689	13	0	\N
389497	1874	13176000	29816	14689	14	0	\N
389498	1874	13180000	29816	14689	15	0	\N
389499	1874	13184000	29816	14689	16	0	\N
389500	1874	13188000	29816	14689	17	0	\N
389501	1874	13192000	29816	14689	18	0	\N
389502	1874	13196000	29816	14689	19	0	\N
389503	1874	13200000	29816	14689	20	0	\N
389504	1874	13204000	29816	14689	21	0	\N
389456	1874	13146000	29814	14689	2	0	3
389457	1874	13148000	29814	14689	3	0	3
389458	1874	13150000	29814	14689	4	0	3
389459	1874	13152000	29814	14689	5	0	3
389460	1874	13154000	29814	14689	6	0	3
389462	1874	13158000	29814	14689	8	0	3
389463	1874	13159000	29814	14689	9	0	3
389464	1874	13160000	29814	14689	10	0	3
389465	1678	28800895198000	29815	14690	0	0	1
389466	1874	13164000	29815	14690	1	0	3
389468	1874	13166000	29815	14690	3	0	3
389469	1874	13170000	29815	14690	4	0	3
389470	1874	13174000	29815	14690	5	0	3
389471	1874	13176000	29815	14690	6	0	3
389473	1874	13184000	29815	14690	8	0	3
389474	1874	13188000	29815	14690	9	0	3
389475	1874	13192000	29815	14690	10	0	3
389476	1874	13196000	29815	14690	11	0	3
389477	1874	13200000	29815	14690	12	0	3
389479	1874	13208000	29815	14690	14	0	3
389480	1874	13212000	29815	14690	15	0	3
389481	1874	13214000	29815	14690	16	0	3
389482	1874	13216000	29815	14690	17	0	3
389505	1874	13208000	29816	14689	22	0	\N
389506	1874	13209000	29816	14689	23	0	\N
389507	1874	13210000	29816	14689	24	0	\N
389508	1874	13211000	29816	14689	25	0	\N
389509	1874	13212000	29816	14689	26	0	\N
389510	1874	13214000	29816	14689	27	0	\N
389511	1874	13216000	29816	14689	28	0	\N
389526	1678	28800895201000	29819	14693	0	0	\N
389527	1874	13249000	29819	14693	1	0	\N
389528	1874	13250000	29819	14693	2	0	\N
389529	1874	13251000	29819	14693	3	0	\N
389530	1874	13255000	29819	14693	4	0	\N
389531	1874	13259000	29819	14693	5	0	\N
389532	1874	13263000	29819	14693	6	0	\N
389533	1874	13267000	29819	14693	7	0	\N
389534	1874	13271000	29819	14693	8	0	\N
389535	1874	13275000	29819	14693	9	0	\N
389536	1874	13279000	29819	14693	10	0	\N
389537	1874	13283000	29819	14693	11	0	\N
389538	1874	13287000	29819	14693	12	0	\N
389539	1874	13289000	29819	14693	13	0	\N
389540	1874	13291000	29819	14693	14	0	\N
389541	1874	13293000	29819	14693	15	0	\N
389542	1874	13295000	29819	14693	16	0	\N
389543	1874	13297000	29819	14693	17	0	\N
389544	1874	13299000	29819	14693	18	0	\N
389574	1678	28800895203000	29822	14695	0	0	\N
389575	1874	13327000	29822	14695	1	0	\N
389576	1874	13329000	29822	14695	2	0	\N
389577	1874	13331000	29822	14695	3	0	\N
389578	1874	13332000	29822	14695	4	0	\N
389579	1874	13336000	29822	14695	5	0	\N
389580	1874	13340000	29822	14695	6	0	\N
389581	1874	13344000	29822	14695	7	0	\N
389582	1874	13348000	29822	14695	8	0	\N
389603	2314	86859000000	29825	14696	0	0	\N
389604	1678	28800895204000	29825	14696	1	0	\N
389605	1874	13349000	29825	14696	2	0	\N
389606	1874	13353000	29825	14696	3	0	\N
389607	1874	13357000	29825	14696	4	0	\N
389608	1874	13361000	29825	14696	5	0	\N
389609	1874	13365000	29825	14696	6	0	\N
389610	1874	13367000	29825	14696	7	0	\N
389611	1874	13369000	29825	14696	8	0	\N
389612	1874	13370000	29825	14696	9	0	\N
389613	1874	13374000	29825	14696	10	0	\N
389614	2314	86859000000	29826	14696	0	0	\N
389615	1678	28800895204000	29826	14696	1	0	\N
389616	1874	13349000	29826	14696	2	0	\N
389617	1874	13351000	29826	14696	3	0	\N
389618	1874	13353000	29826	14696	4	0	\N
389619	1874	13354000	29826	14696	5	0	\N
389629	1678	28800895205000	29828	14697	0	0	\N
389630	1874	13376000	29828	14697	1	0	\N
389631	1874	13378000	29828	14697	2	0	\N
389632	1874	13380000	29828	14697	3	0	\N
389633	1874	13381000	29828	14697	4	0	\N
389634	1874	13385000	29828	14697	5	0	\N
389635	1874	13389000	29828	14697	6	0	\N
389636	1874	13393000	29828	14697	7	0	\N
389637	1874	13397000	29828	14697	8	0	\N
389638	1678	28800895206000	29829	14698	0	0	\N
389639	1874	13398000	29829	14698	1	0	\N
389640	1874	13399000	29829	14698	2	0	\N
389514	1874	13219000	29817	14691	2	0	3
389515	1874	13221000	29817	14691	3	0	3
389516	1678	28800895200000	29818	14692	0	0	1
389517	1874	13223000	29818	14692	1	0	3
389518	1874	13224000	29818	14692	2	0	3
389520	1874	13230000	29818	14692	4	0	3
389521	1874	13232000	29818	14692	5	0	3
389522	1874	13236000	29818	14692	6	0	3
389523	1874	13240000	29818	14692	7	0	3
389524	1874	13244000	29818	14692	8	0	3
389545	1678	28800895201000	29820	14693	0	0	1
389546	1874	13249000	29820	14693	1	0	3
389547	1874	13250000	29820	14693	2	0	3
389548	1874	13251000	29820	14693	3	0	3
389550	1874	13259000	29820	14693	5	0	3
389551	1874	13263000	29820	14693	6	0	3
389552	1874	13267000	29820	14693	7	0	3
389553	1874	13271000	29820	14693	8	0	3
389554	1874	13275000	29820	14693	9	0	3
389556	1874	13283000	29820	14693	11	0	3
389557	1874	13287000	29820	14693	12	0	3
389558	1874	13289000	29820	14693	13	0	3
389559	1874	13291000	29820	14693	14	0	3
389560	1874	13293000	29820	14693	15	0	3
389562	1874	13297000	29820	14693	17	0	3
389563	1874	13299000	29820	14693	18	0	3
389564	1678	28800895202000	29821	14694	0	0	1
389565	1874	13303000	29821	14694	1	0	3
389567	1874	13311000	29821	14694	3	0	3
389568	1874	13313000	29821	14694	4	0	3
389569	1874	13317000	29821	14694	5	0	3
389570	1874	13321000	29821	14694	6	0	3
389571	1874	13322000	29821	14694	7	0	3
389573	1874	13325000	29821	14694	9	0	3
389583	1678	28800895203000	29823	14695	0	0	1
389584	1874	13327000	29823	14695	1	0	3
389585	1874	13329000	29823	14695	2	0	3
389586	1874	13331000	29823	14695	3	0	3
389588	1874	13336000	29823	14695	5	0	3
389589	1874	13340000	29823	14695	6	0	3
389590	1874	13344000	29823	14695	7	0	3
389591	1874	13348000	29823	14695	8	0	3
389593	1678	28800895204000	29824	14696	1	0	1
389594	1874	13349000	29824	14696	2	0	3
389595	1874	13353000	29824	14696	3	0	3
389596	1874	13357000	29824	14696	4	0	3
389597	1874	13361000	29824	14696	5	0	3
389599	1874	13367000	29824	14696	7	0	3
389600	1874	13369000	29824	14696	8	0	3
389601	1874	13370000	29824	14696	9	0	3
389602	1874	13374000	29824	14696	10	0	3
389620	1678	28800895205000	29827	14697	0	0	1
389622	1874	13378000	29827	14697	2	0	3
389623	1874	13380000	29827	14697	3	0	3
389624	1874	13381000	29827	14697	4	0	3
389625	1874	13385000	29827	14697	5	0	3
389627	1874	13393000	29827	14697	7	0	3
389628	1874	13397000	29827	14697	8	0	3
389641	1874	13401000	29829	14698	3	0	\N
389642	1874	13405000	29829	14698	4	0	\N
389643	1874	13407000	29829	14698	5	0	\N
389644	1678	28800895206000	29831	14698	0	0	\N
389645	1874	13398000	29831	14698	1	0	\N
389646	1874	13399000	29831	14698	2	0	\N
389647	1874	13403000	29831	14698	3	0	\N
389671	1678	28800895209000	29834	14701	0	0	\N
389672	1874	13448000	29834	14701	1	0	\N
389673	1874	13449000	29834	14701	2	0	\N
389674	1874	13451000	29834	14701	3	0	\N
389675	1874	13453000	29834	14701	4	0	\N
389717	1678	28800895212000	29839	14704	0	0	\N
389718	1678	28800895213000	29839	14704	1	0	\N
389719	1874	13479000	29839	14704	2	0	\N
389720	1874	13480000	29839	14704	3	0	\N
389721	1874	13481000	29839	14704	4	0	\N
389722	1874	13485000	29839	14704	5	0	\N
389723	1874	13489000	29839	14704	6	0	\N
389724	1874	13493000	29839	14704	7	0	\N
389725	1874	13497000	29839	14704	8	0	\N
389726	1874	13499000	29839	14704	9	0	\N
389727	1874	13501000	29839	14704	10	0	\N
389728	1874	13503000	29839	14704	11	0	\N
389729	1874	13507000	29839	14704	12	0	\N
389730	1874	13511000	29839	14704	13	0	\N
389731	1874	13515000	29839	14704	14	0	\N
389732	1874	13519000	29839	14704	15	0	\N
389733	1874	13521000	29839	14704	16	0	\N
389734	1874	13523000	29839	14704	17	0	\N
389735	1874	13525000	29839	14704	18	0	\N
389736	1874	13529000	29839	14704	19	0	\N
389737	1874	13533000	29839	14704	20	0	\N
389738	1874	13537000	29839	14704	21	0	\N
389739	1874	13541000	29839	14704	22	0	\N
389650	1874	13398000	29832	14699	2	0	3
389651	1874	13399000	29832	14699	3	0	3
389652	1874	13401000	29832	14699	4	0	3
389653	1874	13402000	29832	14699	5	0	3
389654	1874	13406000	29832	14699	6	0	3
389656	1874	13414000	29832	14699	8	0	3
389657	1874	13418000	29832	14699	9	0	3
389658	1874	13422000	29832	14699	10	0	3
389659	1874	13426000	29832	14699	11	0	3
389660	1874	13430000	29832	14699	12	0	3
389662	1874	13434000	29832	14699	14	0	3
389663	1874	13436000	29832	14699	15	0	3
389664	1874	13438000	29832	14699	16	0	3
389665	1678	28800895208000	29833	14700	0	0	1
389667	1874	13441000	29833	14700	2	0	3
389668	1874	13443000	29833	14700	3	0	3
389669	1874	13445000	29833	14700	4	0	3
389670	1874	13446000	29833	14700	5	0	3
389676	1678	28800895209000	29835	14701	0	0	1
389678	1874	13449000	29835	14701	2	0	3
389679	1874	13451000	29835	14701	3	0	3
389680	1874	13453000	29835	14701	4	0	3
389681	1678	28800895210000	29836	14702	0	0	1
389682	1874	13454000	29836	14702	1	0	3
389684	1874	13457000	29836	14702	3	0	3
389685	1874	13459000	29836	14702	4	0	3
389686	1678	28800895211000	29837	14703	0	0	1
389687	1874	13461000	29837	14703	1	0	3
389689	1874	13466000	29837	14703	3	0	3
389690	1874	13470000	29837	14703	4	0	3
389691	1874	13472000	29837	14703	5	0	3
389692	1874	13474000	29837	14703	6	0	3
389693	1874	13478000	29837	14703	7	0	3
389695	1678	28800895213000	29838	14704	1	0	1
389696	1874	13479000	29838	14704	2	0	3
389697	1874	13480000	29838	14704	3	0	3
389698	1874	13481000	29838	14704	4	0	3
389699	1874	13485000	29838	14704	5	0	3
389701	1874	13493000	29838	14704	7	0	3
389702	1874	13497000	29838	14704	8	0	3
389703	1874	13499000	29838	14704	9	0	3
389704	1874	13501000	29838	14704	10	0	3
389706	1874	13507000	29838	14704	12	0	3
389707	1874	13511000	29838	14704	13	0	3
389708	1874	13515000	29838	14704	14	0	3
389709	1874	13519000	29838	14704	15	0	3
389710	1874	13521000	29838	14704	16	0	3
389712	1874	13525000	29838	14704	18	0	3
389713	1874	13529000	29838	14704	19	0	3
389714	1874	13533000	29838	14704	20	0	3
389715	1874	13537000	29838	14704	21	0	3
389716	1874	13541000	29838	14704	22	0	3
389741	1874	13545000	29840	14705	1	0	3
389742	1874	13546000	29840	14705	2	0	3
389743	1874	13547000	29840	14705	3	0	3
389744	1874	13548000	29840	14705	4	0	3
389746	1874	13550000	29840	14705	6	0	3
389747	1874	13554000	29840	14705	7	0	3
389748	1874	13558000	29840	14705	8	0	3
389749	1874	13562000	29840	14705	9	0	3
389750	1874	13566000	29840	14705	10	0	3
389752	1874	13574000	29840	14705	12	0	3
389753	1874	13578000	29840	14705	13	0	3
389754	1874	13582000	29840	14705	14	0	3
389755	1874	13586000	29840	14705	15	0	3
389756	1874	13590000	29840	14705	16	0	3
389758	1874	13598000	29840	14705	18	0	3
389759	1874	13600000	29840	14705	19	0	3
389760	1874	13602000	29840	14705	20	0	3
389761	1874	13604000	29840	14705	21	0	3
389763	1874	13608000	29840	14705	23	0	3
389764	1874	13610000	29840	14705	24	0	3
389765	1874	13612000	29840	14705	25	0	3
389766	1874	13614000	29840	14705	26	0	3
389767	1874	13618000	29841	14706	0	0	3
389769	1874	13623000	29841	14706	2	0	3
389770	1874	13625000	29841	14706	3	0	3
389771	1874	13627000	29841	14706	4	0	3
389772	1874	13629000	29841	14706	5	0	3
389773	1874	13633000	29841	14706	6	0	3
389775	1874	13641000	29841	14706	8	0	3
389776	1874	13642000	29842	14707	0	0	3
389808	1678	28800895216000	29845	14709	0	0	\N
389809	1874	13695000	29845	14709	1	0	\N
389810	1874	13696000	29845	14709	2	0	\N
389811	1874	13698000	29845	14709	3	0	\N
389812	1874	13700000	29845	14709	4	0	\N
389855	1678	28800895217000	29848	14710	0	0	\N
389856	1678	28800895218000	29848	14710	1	0	\N
389857	1874	13701000	29848	14710	2	0	\N
389858	1874	13702000	29848	14710	3	0	\N
389859	1874	13703000	29848	14710	4	0	\N
389860	1874	13707000	29848	14710	5	0	\N
389861	1874	13711000	29848	14710	6	0	\N
389862	1874	13715000	29848	14710	7	0	\N
389863	1874	13719000	29848	14710	8	0	\N
389864	1874	13723000	29848	14710	10	0	\N
389865	1874	13727000	29848	14710	11	0	\N
389866	1874	13731000	29848	14710	12	0	\N
389867	1874	13735000	29848	14710	13	0	\N
389868	1874	13739000	29848	14710	14	0	\N
389869	1874	13743000	29848	14710	15	0	\N
389870	1874	13747000	29848	14710	16	0	\N
389871	1874	13751000	29848	14710	17	0	\N
389872	1874	13755000	29848	14710	18	0	\N
389873	1874	13759000	29848	14710	19	0	\N
389874	1874	13763000	29848	14710	20	0	\N
389875	1874	13767000	29848	14710	21	0	\N
389876	1874	13771000	29848	14710	22	0	\N
389877	1874	13775000	29848	14710	23	0	\N
389878	1874	13779000	29848	14710	24	0	\N
389879	1874	13783000	29848	14710	25	0	\N
389880	1874	13787000	29848	14710	26	0	\N
389881	1874	13791000	29848	14710	27	0	\N
389882	1874	13795000	29848	14710	28	0	\N
389883	1874	13799000	29848	14710	29	0	\N
389884	1874	13803000	29848	14710	30	0	\N
389885	1874	13807000	29848	14710	31	0	\N
389886	1874	13811000	29848	14710	32	0	\N
389887	1874	13815000	29848	14710	33	0	\N
389888	1874	13819000	29848	14710	34	0	\N
389889	1874	13823000	29848	14710	35	0	\N
389890	1874	13827000	29848	14710	36	0	\N
389891	1874	13831000	29848	14710	37	0	\N
389901	1678	28800895219000	29850	14711	0	0	\N
389902	1874	13845000	29850	14711	1	0	\N
389903	1874	13849000	29850	14711	2	0	\N
389904	1874	13853000	29850	14711	3	0	\N
389905	1874	13857000	29850	14711	4	0	\N
389906	1874	13858000	29850	14711	5	0	\N
389907	1874	13860000	29850	14711	6	0	\N
389908	1874	13862000	29850	14711	7	0	\N
389909	1874	13864000	29850	14711	8	0	\N
389779	1874	13654000	29842	14707	3	0	3
389780	1874	13658000	29842	14707	4	0	3
389781	1874	13659000	29842	14707	5	0	3
389782	1874	13661000	29842	14707	6	0	3
389783	1874	13663000	29842	14707	7	0	3
389785	1874	13666000	29842	14707	9	0	3
389786	1874	13667000	29842	14707	10	0	3
389787	1874	13668000	29842	14707	11	0	3
389788	1874	13669000	29842	14707	12	0	3
389789	1874	13671000	29842	14707	13	0	3
389791	1874	13675000	29842	14707	15	0	3
389792	1874	13677000	29842	14707	16	0	3
389793	1874	13679000	29842	14707	17	0	3
389794	1874	13681000	29842	14707	18	0	3
389796	1874	13685000	29842	14707	20	0	3
389797	1678	28800895215000	29843	14708	0	0	1
389798	1874	13687000	29843	14708	1	0	3
389799	1874	13688000	29843	14708	2	0	3
389800	1874	13689000	29843	14708	3	0	3
389802	1874	13693000	29843	14708	5	0	3
389803	1678	28800895216000	29844	14709	0	0	1
389804	1874	13695000	29844	14709	1	0	3
389805	1874	13696000	29844	14709	2	0	3
389806	1874	13698000	29844	14709	3	0	3
389813	1678	28800895217000	29847	14710	0	0	1
389814	1678	28800895218000	29847	14710	1	0	1
389815	1874	13701000	29847	14710	2	0	3
389816	1874	13702000	29847	14710	3	0	3
389818	1874	13705000	29847	14710	5	0	3
389819	1874	13707000	29847	14710	6	0	3
389820	1874	13709000	29847	14710	7	0	3
389821	1874	13711000	29847	14710	8	0	3
389822	1874	13715000	29847	14710	10	0	3
389824	1874	13723000	29847	14710	12	0	3
389825	1874	13727000	29847	14710	13	0	3
389826	1874	13731000	29847	14710	14	0	3
389827	1874	13735000	29847	14710	15	0	3
389828	1874	13739000	29847	14710	16	0	3
389830	1874	13747000	29847	14710	18	0	3
389831	1874	13751000	29847	14710	19	0	3
389832	1874	13755000	29847	14710	20	0	3
389833	1874	13759000	29847	14710	21	0	3
389835	1874	13767000	29847	14710	23	0	3
389836	1874	13771000	29847	14710	24	0	3
389837	1874	13775000	29847	14710	25	0	3
389838	1874	13779000	29847	14710	26	0	3
389839	1874	13783000	29847	14710	27	0	3
389841	1874	13789000	29847	14710	29	0	3
389842	1874	13793000	29847	14710	30	0	3
389843	1874	13797000	29847	14710	31	0	3
389844	1874	13801000	29847	14710	32	0	3
389845	1874	13805000	29847	14710	33	0	3
389847	1874	13813000	29847	14710	35	0	3
389848	1874	13817000	29847	14710	36	0	3
389849	1874	13821000	29847	14710	37	0	3
389850	1874	13825000	29847	14710	38	0	3
389852	1874	13833000	29847	14710	40	0	3
389853	1874	13837000	29847	14710	41	0	3
389854	1874	13841000	29847	14710	42	0	3
389892	1678	28800895219000	29849	14711	0	0	1
389893	1874	13845000	29849	14711	1	0	3
389895	1874	13853000	29849	14711	3	0	3
389896	1874	13857000	29849	14711	4	0	3
389897	1874	13858000	29849	14711	5	0	3
389898	1874	13860000	29849	14711	6	0	3
389899	1874	13862000	29849	14711	7	0	3
389910	2314	129859000000	29851	14712	0	0	5
389911	2314	215859000000	29851	14712	1	0	5
389912	2314	301859000000	29851	14712	2	0	5
389924	2314	129859000000	29852	14712	0	0	\N
389925	2314	215859000000	29852	14712	1	0	\N
389926	2314	301859000000	29852	14712	2	0	\N
389927	1678	28800895220000	29852	14712	3	0	\N
389928	2314	387859000000	29852	14712	4	0	\N
389929	1874	13868000	29852	14712	5	0	\N
389930	1874	13872000	29852	14712	6	0	\N
389931	1874	13874000	29852	14712	7	0	\N
389932	1874	13876000	29852	14712	8	0	\N
389933	1874	13878000	29852	14712	9	0	\N
389934	1874	13879000	29852	14712	10	0	\N
389935	1874	13883000	29852	14712	11	0	\N
389936	1874	13887000	29852	14712	12	0	\N
389937	1874	13891000	29852	14712	13	0	\N
389938	1874	13892000	29852	14712	14	0	\N
389967	1678	28800895224000	29855	14715	0	0	\N
389968	1874	13964000	29855	14715	1	0	\N
389969	1874	13966000	29855	14715	2	0	\N
389970	1874	13968000	29855	14715	3	0	\N
389971	1874	13969000	29855	14715	4	0	\N
389972	1874	13970000	29855	14715	5	0	\N
389973	1874	13974000	29855	14715	6	0	\N
389974	1874	13978000	29855	14715	7	0	\N
389975	1874	13982000	29855	14715	8	0	\N
389976	1874	13986000	29855	14715	9	0	\N
389987	1678	28800895224000	29857	14715	0	0	\N
389988	1874	13963000	29857	14715	1	0	\N
389989	1874	13964000	29857	14715	2	0	\N
389990	1874	13968000	29857	14715	3	0	\N
389991	1874	13972000	29857	14715	4	0	\N
389992	1874	13976000	29857	14715	5	0	\N
389993	1874	13980000	29857	14715	6	0	\N
390023	1678	28800895227000	29861	14718	0	0	\N
390024	1874	14037000	29861	14718	1	0	\N
390025	1874	14039000	29861	14718	2	0	\N
390026	1874	14041000	29861	14718	3	0	\N
390027	1874	14045000	29861	14718	4	0	\N
390028	1874	14049000	29861	14718	5	0	\N
390029	1874	14053000	29861	14718	6	0	\N
390030	1874	14057000	29861	14718	7	0	\N
390031	1874	14058000	29861	14718	8	0	\N
390032	1874	14062000	29861	14718	9	0	\N
389915	1874	13868000	29851	14712	5	0	3
389916	1874	13872000	29851	14712	6	0	3
389917	1874	13874000	29851	14712	7	0	3
389918	1874	13876000	29851	14712	8	0	3
389919	1874	13878000	29851	14712	9	0	3
389921	1874	13883000	29851	14712	11	0	3
389922	1874	13887000	29851	14712	12	0	3
389923	1874	13888000	29851	14712	13	0	3
389939	1678	28800895221000	29853	14713	0	0	1
389940	1678	28800895222000	29853	14713	1	0	1
389942	1874	13890000	29853	14713	3	0	3
389943	1874	13891000	29853	14713	4	0	3
389944	1874	13895000	29853	14713	5	0	3
389945	1874	13899000	29853	14713	6	0	3
389947	1874	13905000	29853	14713	8	0	3
389948	1874	13907000	29853	14713	9	0	3
389949	1874	13911000	29853	14713	10	0	3
389950	1874	13915000	29853	14713	11	0	3
389951	1874	13919000	29853	14713	12	0	3
389953	1874	13927000	29853	14713	14	0	3
389954	1874	13931000	29853	14713	15	0	3
389955	1874	13933000	29853	14713	16	0	3
389956	1874	13935000	29853	14713	17	0	3
389957	1874	13937000	29853	14713	18	0	3
389959	1874	13941000	29854	14714	1	0	3
389960	1874	13945000	29854	14714	2	0	3
389961	1874	13949000	29854	14714	3	0	3
389962	1874	13953000	29854	14714	4	0	3
389964	1874	13959000	29854	14714	6	0	3
389965	1874	13961000	29854	14714	7	0	3
389966	1874	13962000	29854	14714	8	0	3
389977	1678	28800895224000	29856	14715	0	0	1
389978	1874	13964000	29856	14715	1	0	3
389980	1874	13968000	29856	14715	3	0	3
389981	1874	13969000	29856	14715	4	0	3
389982	1874	13970000	29856	14715	5	0	3
389983	1874	13974000	29856	14715	6	0	3
389984	1874	13978000	29856	14715	7	0	3
389986	1874	13986000	29856	14715	9	0	3
389994	1678	28800895225000	29858	14716	0	0	1
389995	1874	13988000	29858	14716	1	0	3
389996	1874	13992000	29858	14716	2	0	3
389998	1874	13995000	29858	14716	4	0	3
389999	1874	13999000	29858	14716	5	0	3
390000	1874	14003000	29858	14716	6	0	3
390001	1874	14007000	29858	14716	7	0	3
390002	1874	14011000	29858	14716	8	0	3
390004	1874	14012000	29859	14717	1	0	3
390005	1874	14016000	29859	14717	2	0	3
390006	1874	14018000	29859	14717	3	0	3
390007	1874	14020000	29859	14717	4	0	3
390008	1874	14022000	29859	14717	6	0	3
390010	1874	14027000	29859	14717	8	0	3
390011	1874	14031000	29859	14717	9	0	3
390012	1874	14035000	29859	14717	10	0	3
390013	1678	28800895227000	29860	14718	0	0	1
390015	1874	14039000	29860	14718	2	0	3
390016	1874	14041000	29860	14718	3	0	3
390017	1874	14045000	29860	14718	4	0	3
390018	1874	14049000	29860	14718	5	0	3
390019	1874	14053000	29860	14718	6	0	3
390021	1874	14058000	29860	14718	8	0	3
390022	1874	14062000	29860	14718	9	0	3
390033	1678	28800895228000	29862	14719	0	0	1
390034	1678	28800895229000	29862	14719	1	0	1
390035	1874	14064000	29862	14719	2	0	3
390037	1874	14072000	29862	14719	4	0	3
390038	1874	14073000	29862	14719	5	0	3
390039	1874	14074000	29862	14719	6	0	3
390040	1874	14075000	29862	14719	7	0	3
390042	1874	14083000	29862	14719	9	0	3
390043	1874	14087000	29862	14719	10	0	3
390044	1874	14091000	29862	14719	11	0	3
390045	1874	14095000	29862	14719	12	0	3
390046	1874	14099000	29862	14719	13	0	3
390048	1874	14105000	29862	14719	15	0	3
390061	1678	28800895230000	29864	14720	0	0	\N
390062	1874	14115000	29864	14720	1	0	\N
390063	1874	14119000	29864	14720	2	0	\N
390064	1874	14120000	29864	14720	3	0	\N
390065	1874	14121000	29864	14720	4	0	\N
390066	1874	14123000	29864	14720	5	0	\N
390067	1874	14125000	29864	14720	6	0	\N
390068	1874	14129000	29864	14720	7	0	\N
390069	1874	14133000	29864	14720	8	0	\N
390070	1678	28800895230000	29865	14720	0	0	\N
390071	1874	14115000	29865	14720	1	0	\N
390072	1874	14119000	29865	14720	2	0	\N
390073	1874	14120000	29865	14720	3	0	\N
390074	1874	14121000	29865	14720	4	0	\N
390075	1874	14123000	29865	14720	5	0	\N
390076	1874	14125000	29865	14720	6	0	\N
390077	1874	14129000	29865	14720	7	0	\N
390078	1874	14133000	29865	14720	8	0	\N
390079	1950	15963851000000	29866	14721	0	0	\N
390080	1678	28800895231000	29866	14721	1	0	\N
390081	1874	14135000	29866	14721	2	0	\N
390082	1874	14137000	29866	14721	3	0	\N
390083	1874	14138000	29866	14721	4	0	\N
390084	1874	14142000	29866	14721	5	0	\N
390085	1874	14146000	29866	14721	6	0	\N
390086	1874	14150000	29866	14721	7	0	\N
390087	1874	14154000	29866	14721	8	0	\N
390088	1874	14158000	29866	14721	9	0	\N
390089	1950	15963851000000	29867	14721	0	0	\N
390090	1678	28800895231000	29867	14721	1	0	\N
390091	1874	14135000	29867	14721	2	0	\N
390092	1874	14137000	29867	14721	3	0	\N
390093	1874	14138000	29867	14721	4	0	\N
390094	1874	14142000	29867	14721	5	0	\N
390095	1874	14146000	29867	14721	6	0	\N
390096	1874	14150000	29867	14721	7	0	\N
390097	1874	14154000	29867	14721	8	0	\N
390098	1874	14158000	29867	14721	9	0	\N
390109	1950	15963851000000	29869	14721	0	0	\N
390110	1678	28800895231000	29869	14721	1	0	\N
390111	1874	14135000	29869	14721	2	0	\N
390112	1874	14137000	29869	14721	3	0	\N
390113	1874	14138000	29869	14721	4	0	\N
390114	1874	14142000	29869	14721	5	0	\N
390115	1874	14146000	29869	14721	6	0	\N
390116	1874	14150000	29869	14721	7	0	\N
390117	1874	14154000	29869	14721	8	0	\N
390118	1874	14158000	29869	14721	9	0	\N
390139	1678	28800895232000	29871	14722	0	0	\N
390140	1678	28800895233000	29871	14722	1	0	\N
390141	1874	14159000	29871	14722	2	0	\N
390142	1874	14161000	29871	14722	3	0	\N
390143	1874	14162000	29871	14722	4	0	\N
390144	1874	14163000	29871	14722	5	0	\N
390145	1874	14167000	29871	14722	6	0	\N
390146	1874	14171000	29871	14722	7	0	\N
390147	1874	14173000	29871	14722	8	0	\N
390148	1874	14177000	29871	14722	9	0	\N
390149	1874	14181000	29871	14722	10	0	\N
390150	1874	14185000	29871	14722	11	0	\N
390151	1874	14189000	29871	14722	12	0	\N
390152	1874	14191000	29871	14722	13	0	\N
390153	1874	14193000	29871	14722	14	0	\N
390154	1874	14195000	29871	14722	15	0	\N
390155	1874	14197000	29871	14722	16	0	\N
390156	1874	14201000	29871	14722	17	0	\N
390157	1874	14205000	29871	14722	18	0	\N
390158	1874	14209000	29871	14722	19	0	\N
390159	1678	28800895232000	29872	14722	0	0	\N
390160	1678	28800895233000	29872	14722	1	0	\N
390161	1874	14159000	29872	14722	2	0	\N
390162	1874	14160000	29872	14722	3	0	\N
390163	1874	14161000	29872	14722	4	0	\N
390164	1874	14165000	29872	14722	5	0	\N
390165	1874	14169000	29872	14722	6	0	\N
390166	1874	14173000	29872	14722	7	0	\N
390167	1874	14177000	29872	14722	8	0	\N
390168	1874	14181000	29872	14722	9	0	\N
390169	1874	14185000	29872	14722	10	0	\N
390170	1874	14189000	29872	14722	11	0	\N
390171	1874	14193000	29872	14722	12	0	\N
390172	1874	14197000	29872	14722	13	0	\N
390173	1678	28800895234000	29873	14723	0	0	\N
390174	1874	14210000	29873	14723	1	0	\N
390175	1874	14211000	29873	14723	2	0	\N
390176	1874	14215000	29873	14723	3	0	\N
390177	1874	14219000	29873	14723	4	0	\N
390178	1874	14223000	29873	14723	5	0	\N
390179	1874	14227000	29873	14723	6	0	\N
390051	1874	14111000	29862	14719	18	0	3
390052	1678	28800895230000	29863	14720	0	0	1
390053	1874	14115000	29863	14720	1	0	3
390054	1874	14119000	29863	14720	2	0	3
390055	1874	14120000	29863	14720	3	0	3
390057	1874	14123000	29863	14720	5	0	3
390058	1874	14125000	29863	14720	6	0	3
390059	1874	14129000	29863	14720	7	0	3
390060	1874	14133000	29863	14720	8	0	3
390099	1950	15963851000000	29868	14721	0	0	14
390101	1874	14135000	29868	14721	2	0	3
390102	1874	14137000	29868	14721	3	0	3
390103	1874	14138000	29868	14721	4	0	3
390104	1874	14142000	29868	14721	5	0	3
390106	1874	14150000	29868	14721	7	0	3
390107	1874	14154000	29868	14721	8	0	3
390108	1874	14158000	29868	14721	9	0	3
390119	1678	28800895232000	29870	14722	0	0	1
390120	1678	28800895233000	29870	14722	1	0	1
390122	1874	14161000	29870	14722	3	0	3
390123	1874	14162000	29870	14722	4	0	3
390124	1874	14163000	29870	14722	5	0	3
390125	1874	14167000	29870	14722	6	0	3
390126	1874	14171000	29870	14722	7	0	3
390128	1874	14177000	29870	14722	9	0	3
390129	1874	14181000	29870	14722	10	0	3
390130	1874	14185000	29870	14722	11	0	3
390131	1874	14189000	29870	14722	12	0	3
390133	1874	14193000	29870	14722	14	0	3
390134	1874	14195000	29870	14722	15	0	3
390135	1874	14197000	29870	14722	16	0	3
390136	1874	14201000	29870	14722	17	0	3
390137	1874	14205000	29870	14722	18	0	3
390180	1678	28800895234000	29874	14723	0	0	1
390181	1874	14211000	29874	14723	1	0	3
390182	1874	14213000	29874	14723	2	0	3
390183	1874	14214000	29874	14723	3	0	3
390184	1874	14215000	29874	14723	4	0	3
390190	1678	28800895234000	29875	14723	0	0	\N
390191	1874	14211000	29875	14723	1	0	\N
390192	1874	14213000	29875	14723	2	0	\N
390193	1874	14214000	29875	14723	3	0	\N
390194	1874	14215000	29875	14723	4	0	\N
390195	1874	14217000	29875	14723	5	0	\N
390196	2314	43859000000	29876	14690	0	0	\N
390197	2314	129859000000	29876	14690	1	0	\N
390198	2314	215859000000	29876	14690	2	0	\N
390199	1678	28800895199000	29876	14690	3	0	\N
390200	2314	301859000000	29876	14690	4	0	\N
390201	1678	28800895200000	29876	14690	5	0	\N
390202	1678	28800895201000	29876	14690	7	0	\N
390203	1678	28800895202000	29876	14690	8	0	\N
390204	1678	28800895203000	29876	14690	9	0	\N
390205	1678	28800895204000	29876	14690	10	0	\N
390206	1678	28800895205000	29876	14690	11	0	\N
390207	1678	28800895206000	29876	14690	12	0	\N
390208	1678	28800895207000	29876	14690	13	0	\N
390209	1678	28800895208000	29876	14690	14	0	\N
390210	1678	28800895209000	29876	14690	15	0	\N
390211	1678	28800895210000	29876	14690	16	0	\N
390212	1678	28800895211000	29876	14690	17	0	\N
390213	1678	28800895212000	29876	14690	18	0	\N
390214	2314	387859000000	29876	14690	19	0	\N
390215	1678	28800895213000	29876	14690	20	0	\N
390216	1678	28800895214000	29876	14690	21	0	\N
390217	1678	28800895215000	29876	14690	22	0	\N
390218	1678	28800895216000	29876	14690	23	0	\N
390219	1678	28800895217000	29876	14690	24	0	\N
390220	1678	28800895218000	29876	14690	25	0	\N
390221	1678	28800895219000	29876	14690	26	0	\N
390222	1678	28800895220000	29876	14690	27	0	\N
390223	1678	28800895221000	29876	14690	28	0	\N
390224	1678	28800895222000	29876	14690	29	0	\N
390225	1678	28800895223000	29876	14690	30	0	\N
390226	1678	28800895224000	29876	14690	31	0	\N
390227	1678	28800895225000	29876	14690	32	0	\N
390228	1678	28800895226000	29876	14690	33	0	\N
390229	1678	28800895227000	29876	14690	34	0	\N
390230	1678	28800895228000	29876	14690	35	0	\N
390231	1678	28800895229000	29876	14690	36	0	\N
390232	1678	28800895230000	29876	14690	37	0	\N
390233	1678	28800895231000	29876	14690	38	0	\N
390234	1678	28800895232000	29876	14690	39	0	\N
390235	1678	28800895233000	29876	14690	40	0	\N
390236	1678	28800895234000	29876	14690	41	0	\N
390237	1874	13220000	29876	14690	42	0	\N
390238	1874	13221000	29876	14690	43	0	\N
390239	1874	13222000	29876	14690	44	0	\N
390240	1874	13223000	29876	14690	45	0	\N
390241	1874	13224000	29876	14690	46	0	\N
390242	1874	13225000	29876	14690	47	0	\N
390243	1874	13227000	29876	14690	48	0	\N
390244	1874	13229000	29876	14690	49	0	\N
390245	1874	13231000	29876	14690	50	0	\N
390246	1874	13233000	29876	14690	51	0	\N
390247	1874	13235000	29876	14690	52	0	\N
390248	1874	13236000	29876	14690	53	0	\N
390249	1874	13237000	29876	14690	54	0	\N
390250	1874	13238000	29876	14690	55	0	\N
390251	1874	13239000	29876	14690	56	0	\N
390252	1874	13240000	29876	14690	57	0	\N
390253	1874	13241000	29876	14690	58	0	\N
390254	1874	13242000	29876	14690	59	0	\N
390255	1874	13243000	29876	14690	60	0	\N
390256	1874	13244000	29876	14690	61	0	\N
390257	1874	13245000	29876	14690	62	0	\N
390258	1874	13246000	29876	14690	63	0	\N
390259	1874	13247000	29876	14690	64	0	\N
390260	1874	13248000	29876	14690	65	0	\N
390261	1874	13249000	29876	14690	66	0	\N
390262	1874	13250000	29876	14690	67	0	\N
390263	1874	13251000	29876	14690	68	0	\N
390264	1874	13252000	29876	14690	69	0	\N
390265	1874	13253000	29876	14690	70	0	\N
390266	1874	13254000	29876	14690	71	0	\N
390267	1874	13255000	29876	14690	72	0	\N
390268	1874	13256000	29876	14690	73	0	\N
390269	1874	13257000	29876	14690	74	0	\N
390270	1874	13258000	29876	14690	75	0	\N
390271	1874	13259000	29876	14690	76	0	\N
390272	1874	13260000	29876	14690	77	0	\N
390273	1874	13261000	29876	14690	78	0	\N
390274	1874	13262000	29876	14690	79	0	\N
390275	1874	13263000	29876	14690	80	0	\N
390276	1874	13264000	29876	14690	81	0	\N
390277	1874	13265000	29876	14690	82	0	\N
390278	1874	13266000	29876	14690	83	0	\N
390279	1874	13267000	29876	14690	84	0	\N
390280	1874	13268000	29876	14690	85	0	\N
390281	1874	13269000	29876	14690	86	0	\N
390282	1874	13270000	29876	14690	87	0	\N
390283	1874	13271000	29876	14690	88	0	\N
390284	1874	13272000	29876	14690	89	0	\N
390285	1874	13273000	29876	14690	90	0	\N
390286	1874	13274000	29876	14690	91	0	\N
390287	1874	13275000	29876	14690	92	0	\N
390288	1874	13276000	29876	14690	93	0	\N
390289	1874	13277000	29876	14690	94	0	\N
390290	1874	13278000	29876	14690	95	0	\N
390291	1874	13279000	29876	14690	96	0	\N
390292	1874	13280000	29876	14690	97	0	\N
390293	1874	13281000	29876	14690	98	0	\N
390294	1874	13282000	29876	14690	99	0	\N
390295	1874	13283000	29876	14690	100	0	\N
390296	1874	13284000	29876	14690	101	0	\N
390297	1874	13285000	29876	14690	102	0	\N
390298	1874	13286000	29876	14690	103	0	\N
390299	1874	13287000	29876	14690	104	0	\N
390300	1874	13288000	29876	14690	105	0	\N
390301	1874	13289000	29876	14690	106	0	\N
390302	1874	13290000	29876	14690	107	0	\N
390303	1874	13291000	29876	14690	108	0	\N
390304	1874	13292000	29876	14690	109	0	\N
390305	1874	13293000	29876	14690	110	0	\N
390306	1874	13294000	29876	14690	111	0	\N
390307	1874	13295000	29876	14690	112	0	\N
390308	1874	13297000	29876	14690	113	0	\N
390309	1874	13299000	29876	14690	114	0	\N
390310	1874	13301000	29876	14690	115	0	\N
390311	1874	13303000	29876	14690	116	0	\N
390312	1874	13305000	29876	14690	117	0	\N
390313	1874	13307000	29876	14690	118	0	\N
390314	1874	13309000	29876	14690	119	0	\N
390315	1874	13311000	29876	14690	120	0	\N
390187	1874	14227000	29874	14723	7	0	3
390188	1874	14231000	29874	14723	8	0	3
390189	1874	14233000	29874	14723	9	0	3
390316	1876	704963880000	29877	14724	0	0	4
390317	1678	28800895235000	29877	14724	1	0	1
390319	1874	14234000	29877	14724	3	0	3
390320	1874	14238000	29877	14724	4	0	3
390335	2431	769714905251	29878	14592	0	0	\N
390336	1646	1813000000	29878	14592	2	0	\N
390337	677	66001000000000	29878	14592	3	0	\N
390338	1876	704963880000	29878	14592	4	0	\N
390339	1646	1913000000	29878	14592	5	0	\N
390340	1483	11000000	29878	14592	6	0	\N
390341	1578	23000000000	29878	14592	7	0	\N
390342	724	20002150000000	29878	14592	8	0	\N
390343	1956	3000000000	29878	14592	9	0	\N
390344	1299	1706538047667750	29878	14592	10	0	\N
390345	1428	2157912000000	29878	14592	11	0	\N
390346	2430	189526998000	29878	14592	12	0	\N
390347	1483	11000000	29878	14592	13	0	\N
390348	1428	2158012000000	29878	14592	14	0	\N
390349	1428	2158912000000	29878	14592	15	0	\N
390350	1600	0	29878	14592	16	0	\N
390351	1269	3000000	29878	14592	18	0	\N
390352	1269	4000000	29878	14592	19	0	\N
390353	1678	28800895237000	29879	14725	0	0	\N
390354	1874	14283000	29879	14725	1	0	\N
390355	1874	14284000	29879	14725	3	0	\N
390356	1874	14285000	29879	14725	4	0	\N
390357	1874	14289000	29879	14725	5	0	\N
390358	1874	14293000	29879	14725	6	0	\N
390359	1874	14297000	29879	14725	7	0	\N
390360	1874	14301000	29879	14725	8	0	\N
390361	1874	14303000	29879	14725	9	0	\N
390362	1874	14305000	29879	14725	10	0	\N
390413	1678	28800895240000	29883	14727	0	0	\N
390414	1678	28800895241000	29883	14727	1	0	\N
390415	1874	14358000	29883	14727	2	0	\N
390416	1874	14360000	29883	14727	3	0	\N
390417	1874	14362000	29883	14727	4	0	\N
390418	1874	14364000	29883	14727	5	0	\N
390419	1874	14365000	29883	14727	6	0	\N
390420	1874	14366000	29883	14727	7	0	\N
390421	1874	14367000	29883	14727	8	0	\N
390422	1874	14369000	29883	14727	9	0	\N
390423	1874	14371000	29883	14727	10	0	\N
390424	1874	14375000	29883	14727	11	0	\N
390425	1874	14379000	29883	14727	12	0	\N
390426	1874	14383000	29883	14727	13	0	\N
390427	1874	14387000	29883	14727	14	0	\N
390428	1874	14391000	29883	14727	15	0	\N
390429	1874	14395000	29883	14727	16	0	\N
390430	1874	14399000	29883	14727	17	0	\N
390431	1874	14403000	29883	14727	18	0	\N
390432	1874	14407000	29883	14727	19	0	\N
390433	1678	28800895240000	29884	14727	0	0	\N
390434	1678	28800895241000	29884	14727	1	0	\N
390435	1874	14358000	29884	14727	2	0	\N
390436	1874	14360000	29884	14727	3	0	\N
390437	1874	14362000	29884	14727	4	0	\N
390438	1874	14364000	29884	14727	5	0	\N
390439	1874	14365000	29884	14727	6	0	\N
390440	1874	14366000	29884	14727	7	0	\N
390441	1874	14367000	29884	14727	8	0	\N
390442	1874	14369000	29884	14727	9	0	\N
390443	1874	14371000	29884	14727	10	0	\N
390444	1874	14375000	29884	14727	11	0	\N
390445	1874	14379000	29884	14727	12	0	\N
390446	1874	14383000	29884	14727	13	0	\N
390447	1874	14387000	29884	14727	14	0	\N
390448	1874	14391000	29884	14727	15	0	\N
390449	1874	14395000	29884	14727	16	0	\N
390450	1874	14399000	29884	14727	17	0	\N
390451	1874	14403000	29884	14727	18	0	\N
390452	1874	14407000	29884	14727	19	0	\N
390453	1678	28800895242000	29885	14728	0	0	\N
390454	1874	14408000	29885	14728	1	0	\N
390455	1874	14410000	29885	14728	2	0	\N
390456	1874	14414000	29885	14728	3	0	\N
390323	1874	14250000	29877	14724	7	0	3
390324	1874	14251000	29877	14724	8	0	3
390325	1874	14255000	29877	14724	9	0	3
390326	1874	14259000	29877	14724	10	0	3
390327	1874	14263000	29877	14724	11	0	3
390329	1874	14271000	29877	14724	13	0	3
390330	1874	14273000	29877	14724	14	0	3
390331	1874	14275000	29877	14724	15	0	3
390332	1874	14277000	29877	14724	16	0	3
390333	1874	14279000	29877	14724	17	0	3
390363	1678	28800895237000	29880	14725	0	0	1
390364	1874	14283000	29880	14725	1	0	3
390365	1874	14284000	29880	14725	3	0	3
390366	1874	14285000	29880	14725	4	0	3
390368	1874	14293000	29880	14725	6	0	3
390369	1874	14297000	29880	14725	7	0	3
390370	1874	14301000	29880	14725	8	0	3
390371	1874	14303000	29880	14725	9	0	3
390372	1874	14305000	29880	14725	10	0	3
390374	1678	28800895239000	29881	14726	1	0	1
390375	1874	14309000	29881	14726	2	0	3
390376	1874	14313000	29881	14726	3	0	3
390377	1874	14314000	29881	14726	4	0	3
390378	1874	14318000	29881	14726	5	0	3
390380	1874	14326000	29881	14726	7	0	3
390381	1874	14328000	29881	14726	8	0	3
390382	1874	14330000	29881	14726	9	0	3
390383	1874	14332000	29881	14726	10	0	3
390385	1874	14336000	29881	14726	12	0	3
390386	1874	14338000	29881	14726	13	0	3
390387	1874	14339000	29881	14726	14	0	3
390388	1874	14340000	29881	14726	15	0	3
390389	1874	14344000	29881	14726	16	0	3
390391	1874	14352000	29881	14726	18	0	3
390392	1874	14356000	29881	14726	19	0	3
390393	1678	28800895240000	29882	14727	0	0	1
390394	1678	28800895241000	29882	14727	1	0	1
390395	1874	14358000	29882	14727	2	0	3
390397	1874	14362000	29882	14727	4	0	3
390398	1874	14364000	29882	14727	5	0	3
390399	1874	14365000	29882	14727	6	0	3
390400	1874	14366000	29882	14727	7	0	3
390402	1874	14369000	29882	14727	9	0	3
390403	1874	14371000	29882	14727	10	0	3
390404	1874	14375000	29882	14727	11	0	3
390405	1874	14379000	29882	14727	12	0	3
390406	1874	14383000	29882	14727	13	0	3
390408	1874	14391000	29882	14727	15	0	3
390409	1874	14395000	29882	14727	16	0	3
390410	1874	14399000	29882	14727	17	0	3
390411	1874	14403000	29882	14727	18	0	3
390412	1874	14407000	29882	14727	19	0	3
390457	1874	14418000	29885	14728	4	0	\N
390458	1874	14422000	29885	14728	5	0	\N
390459	1874	14426000	29885	14728	6	0	\N
390460	1874	14430000	29885	14728	7	0	\N
390461	1874	14432000	29885	14728	8	0	\N
390462	1678	28800895242000	29886	14728	0	0	\N
390463	1874	14408000	29886	14728	1	0	\N
390464	1874	14410000	29886	14728	2	0	\N
390465	1874	14414000	29886	14728	3	0	\N
390466	1874	14418000	29886	14728	4	0	\N
390467	1874	14422000	29886	14728	5	0	\N
390468	1874	14426000	29886	14728	6	0	\N
390469	1874	14430000	29886	14728	7	0	\N
390470	1874	14432000	29886	14728	8	0	\N
390480	1678	28800895243000	29888	14729	0	0	\N
390481	1874	14434000	29888	14729	1	0	\N
390482	1874	14438000	29888	14729	2	0	\N
390483	1874	14439000	29888	14729	3	0	\N
390484	1874	14443000	29888	14729	4	0	\N
390485	1874	14447000	29888	14729	5	0	\N
390486	1874	14448000	29888	14729	6	0	\N
390487	1874	14450000	29888	14729	7	0	\N
390488	1874	14452000	29888	14729	8	0	\N
390489	1874	14456000	29888	14729	9	0	\N
390500	1678	28800895243000	29890	14729	0	0	\N
390501	1874	14434000	29890	14729	1	0	\N
390502	1874	14435000	29890	14729	2	0	\N
390503	1874	14436000	29890	14729	3	0	\N
390504	1874	14438000	29890	14729	4	0	\N
390505	1874	14440000	29890	14729	5	0	\N
390515	1678	28800895244000	29892	14730	0	0	\N
390516	1874	14458000	29892	14730	1	0	\N
390517	1874	14460000	29892	14730	2	0	\N
390518	1874	14464000	29892	14730	3	0	\N
390519	1874	14468000	29892	14730	4	0	\N
390520	1874	14472000	29892	14730	5	0	\N
390521	1874	14476000	29892	14730	6	0	\N
390522	1874	14477000	29892	14730	7	0	\N
390523	1678	28800895245000	29893	14731	0	0	\N
390524	1874	14481000	29893	14731	1	0	\N
390525	1874	14485000	29893	14731	2	0	\N
390526	1874	14489000	29893	14731	3	0	\N
390527	1874	14493000	29893	14731	4	0	\N
390528	1874	14495000	29893	14731	5	0	\N
390529	1874	14496000	29893	14731	6	0	\N
390530	1874	14497000	29893	14731	7	0	\N
390531	1874	14501000	29893	14731	8	0	\N
390532	1874	14505000	29893	14731	9	0	\N
390533	1678	28800895245000	29894	14731	0	0	\N
390534	1874	14481000	29894	14731	1	0	\N
390535	1874	14485000	29894	14731	2	0	\N
390536	1874	14489000	29894	14731	3	0	\N
390537	1874	14493000	29894	14731	4	0	\N
390538	1874	14495000	29894	14731	5	0	\N
390539	1874	14496000	29894	14731	6	0	\N
390540	1874	14497000	29894	14731	7	0	\N
390541	1874	14501000	29894	14731	8	0	\N
390542	1874	14505000	29894	14731	9	0	\N
390553	1678	28800895245000	29896	14731	0	0	\N
390554	1874	14481000	29896	14731	1	0	\N
390555	1874	14485000	29896	14731	2	0	\N
390556	1874	14489000	29896	14731	3	0	\N
390557	1874	14493000	29896	14731	4	0	\N
390558	1874	14495000	29896	14731	5	0	\N
390559	1874	14496000	29896	14731	6	0	\N
390560	1874	14497000	29896	14731	7	0	\N
390561	1874	14501000	29896	14731	8	0	\N
390562	1874	14505000	29896	14731	9	0	\N
390563	1678	28800895245000	29897	14731	0	0	\N
390564	1874	14481000	29897	14731	1	0	\N
390565	1874	14485000	29897	14731	2	0	\N
390566	1874	14489000	29897	14731	3	0	\N
390567	1874	14493000	29897	14731	4	0	\N
390568	1874	14495000	29897	14731	5	0	\N
390569	1874	14496000	29897	14731	6	0	\N
390570	1874	14497000	29897	14731	7	0	\N
390571	1874	14501000	29897	14731	8	0	\N
390572	1874	14505000	29897	14731	9	0	\N
390573	2238	1002997000000	29898	14732	0	0	\N
390574	1678	28800895246000	29898	14732	1	0	\N
390575	1874	14509000	29898	14732	2	0	\N
390576	1874	14511000	29898	14732	3	0	\N
390577	1874	14512000	29898	14732	4	0	\N
390578	1874	14516000	29898	14732	5	0	\N
390579	1874	14520000	29898	14732	6	0	\N
390580	1874	14524000	29898	14732	7	0	\N
390581	1874	14526000	29898	14732	9	0	\N
390582	2238	1002997000000	29899	14732	0	0	\N
390583	1678	28800895246000	29899	14732	1	0	\N
390584	1874	14509000	29899	14732	2	0	\N
390585	1874	14511000	29899	14732	3	0	\N
390586	1874	14512000	29899	14732	4	0	\N
390587	1874	14516000	29899	14732	5	0	\N
390588	1874	14520000	29899	14732	6	0	\N
390589	1874	14524000	29899	14732	7	0	\N
390590	1874	14526000	29899	14732	9	0	\N
390473	1874	14410000	29887	14728	2	0	3
390474	1874	14414000	29887	14728	3	0	3
390475	1874	14418000	29887	14728	4	0	3
390476	1874	14422000	29887	14728	5	0	3
390477	1874	14426000	29887	14728	6	0	3
390479	1874	14432000	29887	14728	8	0	3
390490	1678	28800895243000	29889	14729	0	0	1
390491	1874	14434000	29889	14729	1	0	3
390492	1874	14438000	29889	14729	2	0	3
390493	1874	14439000	29889	14729	3	0	3
390495	1874	14447000	29889	14729	5	0	3
390496	1874	14448000	29889	14729	6	0	3
390497	1874	14450000	29889	14729	7	0	3
390498	1874	14452000	29889	14729	8	0	3
390506	1678	28800895244000	29891	14730	0	0	1
390507	1874	14458000	29891	14730	1	0	3
390508	1874	14460000	29891	14730	2	0	3
390509	1874	14464000	29891	14730	3	0	3
390510	1874	14468000	29891	14730	4	0	3
390512	1874	14476000	29891	14730	6	0	3
390513	1874	14477000	29891	14730	7	0	3
390514	1874	14479000	29891	14730	8	0	3
390543	1678	28800895245000	29895	14731	0	0	1
390544	1874	14481000	29895	14731	1	0	3
390546	1874	14489000	29895	14731	3	0	3
390547	1874	14493000	29895	14731	4	0	3
390548	1874	14495000	29895	14731	5	0	3
390549	1874	14496000	29895	14731	6	0	3
390551	1874	14501000	29895	14731	8	0	3
390552	1874	14505000	29895	14731	9	0	3
390591	2238	1002997000000	29900	14732	0	0	2
390592	1678	28800895246000	29900	14732	1	0	1
390600	2238	1002997000000	29901	14732	0	0	\N
390601	1678	28800895246000	29901	14732	1	0	\N
390602	1874	14509000	29901	14732	2	0	\N
390603	1874	14511000	29901	14732	3	0	\N
390604	1874	14512000	29901	14732	4	0	\N
390605	1874	14516000	29901	14732	5	0	\N
390606	1874	14520000	29901	14732	6	0	\N
390607	1874	14524000	29901	14732	7	0	\N
390608	1874	14526000	29901	14732	9	0	\N
390609	2238	1002997000000	29902	14732	0	0	\N
390610	1678	28800895246000	29902	14732	1	0	\N
390611	1874	14509000	29902	14732	2	0	\N
390612	1874	14510000	29902	14732	3	0	\N
390613	1874	14514000	29902	14732	4	0	\N
390614	1874	14518000	29902	14732	5	0	\N
390615	1874	14522000	29902	14732	6	0	\N
390635	1678	28800895248000	29905	14734	0	0	\N
390636	1874	14556000	29905	14734	1	0	\N
390637	1874	14558000	29905	14734	2	0	\N
390638	1874	14562000	29905	14734	3	0	\N
390639	1874	14566000	29905	14734	4	0	\N
390640	1874	14570000	29905	14734	5	0	\N
390641	1874	14571000	29905	14734	6	0	\N
390642	1874	14573000	29905	14734	7	0	\N
390643	1874	14575000	29905	14734	8	0	\N
390644	1678	28800895249000	29906	14735	0	0	\N
390645	1874	14576000	29906	14735	1	0	\N
390646	1874	14578000	29906	14735	2	0	\N
390647	1874	14580000	29906	14735	3	0	\N
390648	1874	14581000	29906	14735	5	0	\N
390649	1874	14585000	29906	14735	6	0	\N
390650	1874	14589000	29906	14735	7	0	\N
390651	1874	14593000	29906	14735	8	0	\N
390652	1874	14597000	29906	14735	9	0	\N
390653	1874	14601000	29906	14735	10	0	\N
390664	1874	14602000	29908	14736	0	0	\N
390665	1874	14603000	29909	14736	0	0	\N
390666	1874	14604000	29909	14736	1	0	\N
390667	1874	14606000	29909	14736	2	0	\N
390668	1874	14608000	29909	14736	3	0	\N
390678	1678	28800895251000	29911	14737	0	0	\N
390679	1874	14626000	29911	14737	1	0	\N
390680	1874	14630000	29911	14737	2	0	\N
390681	1874	14631000	29911	14737	3	0	\N
390682	1874	14632000	29911	14737	4	0	\N
390683	1874	14634000	29911	14737	5	0	\N
390684	1874	14638000	29911	14737	6	0	\N
390685	1874	14642000	29911	14737	7	0	\N
390686	1874	14646000	29911	14737	8	0	\N
390687	1874	14650000	29911	14737	9	0	\N
390696	1678	28800895251000	29913	14737	0	0	\N
390697	1874	14626000	29913	14737	1	0	\N
390698	1874	14630000	29913	14737	2	0	\N
390699	1874	14631000	29913	14737	3	0	\N
390700	1874	14632000	29913	14737	4	0	\N
390701	1874	14634000	29913	14737	5	0	\N
390702	1874	14638000	29913	14737	6	0	\N
390703	1874	14642000	29913	14737	7	0	\N
390704	1874	14646000	29913	14737	8	0	\N
390705	1874	14650000	29913	14737	9	0	\N
390706	2238	1002997000000	29914	14668	0	0	\N
390707	1876	704963880000	29914	14668	1	0	\N
390708	1678	28800895183000	29914	14668	2	0	\N
390709	1874	12620000	29914	14668	3	0	\N
390710	1874	12622000	29914	14668	7	0	\N
390711	1678	28800895252000	29915	14738	0	0	\N
390712	1874	14652000	29915	14738	1	0	\N
390713	1874	14654000	29915	14738	2	0	\N
390714	1874	14655000	29915	14738	3	0	\N
390715	1874	14659000	29915	14738	4	0	\N
390716	1874	14663000	29915	14738	5	0	\N
390717	1874	14667000	29915	14738	6	0	\N
390595	1874	14512000	29900	14732	4	0	3
390596	1874	14516000	29900	14732	5	0	3
390597	1874	14520000	29900	14732	6	0	3
390598	1874	14524000	29900	14732	7	0	3
390599	1874	14526000	29900	14732	9	0	3
390617	1874	14527000	29903	14733	1	0	3
390618	1874	14531000	29903	14733	3	0	3
390619	1874	14535000	29903	14733	4	0	3
390620	1874	14539000	29903	14733	5	0	3
390621	1874	14543000	29903	14733	6	0	3
390623	1874	14548000	29903	14733	8	0	3
390624	1874	14550000	29903	14733	9	0	3
390625	1874	14552000	29903	14733	10	0	3
390626	1678	28800895248000	29904	14734	0	0	1
390628	1874	14558000	29904	14734	2	0	3
390629	1874	14562000	29904	14734	3	0	3
390630	1874	14566000	29904	14734	4	0	3
390631	1874	14570000	29904	14734	5	0	3
390632	1874	14571000	29904	14734	6	0	3
390634	1874	14575000	29904	14734	8	0	3
390654	1678	28800895249000	29907	14735	0	0	1
390655	1874	14576000	29907	14735	1	0	3
390656	1874	14578000	29907	14735	2	0	3
390657	1874	14580000	29907	14735	3	0	3
390659	1874	14585000	29907	14735	6	0	3
390660	1874	14589000	29907	14735	7	0	3
390661	1874	14593000	29907	14735	8	0	3
390662	1874	14597000	29907	14735	9	0	3
390669	1678	28800895250000	29910	14736	0	0	1
390670	1874	14603000	29910	14736	1	0	3
390671	1874	14607000	29910	14736	2	0	3
390672	1874	14611000	29910	14736	3	0	3
390673	1874	14615000	29910	14736	4	0	3
390675	1874	14620000	29910	14736	6	0	3
390676	1874	14622000	29910	14736	7	0	3
390677	1874	14624000	29910	14736	8	0	3
390688	1678	28800895251000	29912	14737	0	0	1
390689	1874	14626000	29912	14737	1	0	3
390691	1874	14631000	29912	14737	3	0	3
390692	1874	14633000	29912	14737	4	0	3
390693	1874	14637000	29912	14737	5	0	3
390694	1874	14641000	29912	14737	6	0	3
390718	1678	28800895252000	29916	14738	0	0	1
390719	1874	14646000	29916	14738	1	0	3
390720	1874	14648000	29916	14738	2	0	3
390721	1874	14650000	29916	14738	3	0	3
390722	1874	14651000	29916	14738	4	0	3
390724	1874	14659000	29916	14738	6	0	3
390725	1874	14663000	29916	14738	7	0	3
390726	1874	14667000	29916	14738	8	0	3
390727	1874	14671000	29916	14738	9	0	3
390728	1678	28800895253000	29917	14739	0	0	1
390738	1678	28800895254000	29918	14740	0	0	\N
390739	1874	14697000	29918	14740	1	0	\N
390740	1874	14698000	29918	14740	2	0	\N
390741	1874	14700000	29918	14740	3	0	\N
390742	1678	28800895254000	29919	14740	0	0	\N
390743	1874	14697000	29919	14740	1	0	\N
390744	1874	14698000	29919	14740	2	0	\N
390745	1874	14702000	29919	14740	3	0	\N
390746	1874	14706000	29919	14740	4	0	\N
390747	1874	14708000	29919	14740	5	0	\N
390748	1874	14712000	29919	14740	6	0	\N
390749	1874	14716000	29919	14740	7	0	\N
390750	1874	14720000	29919	14740	8	0	\N
390751	1678	28800895247000	29920	14733	0	0	\N
390752	1678	28800895248000	29920	14733	1	0	\N
390753	1678	28800895249000	29920	14733	2	0	\N
390754	1678	28800895250000	29920	14733	3	0	\N
390755	1678	28800895251000	29920	14733	4	0	\N
390756	1678	28800895252000	29920	14733	5	0	\N
390757	1678	28800895253000	29920	14733	6	0	\N
390758	1678	28800895254000	29920	14733	7	0	\N
390759	1874	14527000	29920	14733	8	0	\N
390760	1874	14531000	29920	14733	10	0	\N
390761	1874	14535000	29920	14733	12	0	\N
390762	1874	14539000	29920	14733	13	0	\N
390763	1874	14543000	29920	14733	14	0	\N
390764	1874	14547000	29920	14733	15	0	\N
390765	1874	14548000	29920	14733	16	0	\N
390766	1874	14552000	29920	14733	17	0	\N
390767	1874	14556000	29920	14733	18	0	\N
390768	1874	14560000	29920	14733	19	0	\N
390769	1874	14564000	29920	14733	20	0	\N
390770	1874	14565000	29920	14733	22	0	\N
390771	1874	14566000	29920	14733	23	0	\N
390772	1874	14567000	29920	14733	24	0	\N
390773	1874	14568000	29920	14733	25	0	\N
390774	1874	14569000	29920	14733	26	0	\N
390775	1874	14570000	29920	14733	27	0	\N
390776	1874	14571000	29920	14733	28	0	\N
390777	1874	14572000	29920	14733	29	0	\N
390778	1874	14573000	29920	14733	30	0	\N
390779	1874	14574000	29920	14733	31	0	\N
390780	1874	14576000	29920	14733	32	0	\N
390781	1874	14578000	29920	14733	33	0	\N
390782	1874	14580000	29920	14733	34	0	\N
390783	1874	14584000	29920	14733	35	0	\N
390784	1874	14588000	29920	14733	36	0	\N
390785	1874	14592000	29920	14733	37	0	\N
390786	1874	14596000	29920	14733	38	0	\N
390787	1874	14600000	29920	14733	39	0	\N
390788	1874	14604000	29920	14733	40	0	\N
390789	1874	14608000	29920	14733	41	0	\N
390790	1874	14612000	29920	14733	42	0	\N
390791	1874	14616000	29920	14733	43	0	\N
390792	1874	14620000	29920	14733	44	0	\N
390793	1874	14624000	29920	14733	45	0	\N
390794	1874	14628000	29920	14733	46	0	\N
390795	1874	14632000	29920	14733	47	0	\N
390796	1874	14636000	29920	14733	48	0	\N
390797	1874	14640000	29920	14733	49	0	\N
390798	1874	14644000	29920	14733	50	0	\N
390799	1874	14648000	29920	14733	51	0	\N
390800	1874	14652000	29920	14733	52	0	\N
390801	1874	14656000	29920	14733	53	0	\N
390802	1874	14660000	29920	14733	54	0	\N
390803	1874	14662000	29920	14733	55	0	\N
390804	1874	14664000	29920	14733	56	0	\N
390805	1874	14666000	29920	14733	57	0	\N
390806	1874	14668000	29920	14733	58	0	\N
390807	1874	14670000	29920	14733	59	0	\N
390808	1874	14672000	29920	14733	60	0	\N
390809	1874	14674000	29920	14733	61	0	\N
390810	1874	14676000	29920	14733	62	0	\N
390811	1874	14678000	29920	14733	63	0	\N
390812	1874	14680000	29920	14733	64	0	\N
390813	1874	14682000	29920	14733	65	0	\N
390814	1874	14684000	29920	14733	66	0	\N
390815	1874	14686000	29920	14733	67	0	\N
390816	1874	14688000	29920	14733	68	0	\N
390817	1874	14690000	29920	14733	69	0	\N
390818	1874	14692000	29920	14733	70	0	\N
390819	1874	14696000	29920	14733	71	0	\N
390820	1874	14700000	29920	14733	72	0	\N
390821	1874	14704000	29920	14733	73	0	\N
390822	1874	14708000	29920	14733	74	0	\N
390823	1874	14712000	29920	14733	75	0	\N
390824	1874	14716000	29920	14733	76	0	\N
390825	1874	14720000	29920	14733	77	0	\N
390835	1678	28800895255000	29922	14741	0	0	\N
390836	1874	14721000	29922	14741	1	0	\N
390837	1874	14723000	29922	14741	2	0	\N
390838	1874	14725000	29922	14741	3	0	\N
390839	1874	14729000	29922	14741	4	0	\N
390840	1874	14733000	29922	14741	5	0	\N
390841	1874	14737000	29922	14741	6	0	\N
390842	1874	14741000	29922	14741	7	0	\N
390843	1678	28800895255000	29923	14741	0	0	\N
390844	1874	14721000	29923	14741	1	0	\N
390845	1874	14723000	29923	14741	2	0	\N
390846	1874	14725000	29923	14741	3	0	\N
390847	1874	14729000	29923	14741	4	0	\N
390848	1874	14733000	29923	14741	5	0	\N
390849	1874	14737000	29923	14741	6	0	\N
390850	1874	14741000	29923	14741	7	0	\N
390864	1678	28800895256000	29926	14742	0	0	\N
390731	1874	14680000	29917	14739	3	0	3
390732	1874	14681000	29917	14739	4	0	3
390733	1874	14683000	29917	14739	5	0	3
390734	1874	14685000	29917	14739	6	0	3
390735	1874	14687000	29917	14739	7	0	3
390737	1874	14695000	29917	14739	9	0	3
390826	1678	28800895254000	29921	14740	0	0	1
390827	1874	14697000	29921	14740	1	0	3
390828	1874	14698000	29921	14740	2	0	3
390829	1874	14702000	29921	14740	3	0	3
390831	1874	14708000	29921	14740	5	0	3
390832	1874	14712000	29921	14740	6	0	3
390833	1874	14716000	29921	14740	7	0	3
390834	1874	14720000	29921	14740	8	0	3
390852	1874	14721000	29924	14741	1	0	3
390853	1874	14723000	29924	14741	2	0	3
390854	1874	14725000	29924	14741	3	0	3
390855	1874	14729000	29924	14741	4	0	3
390856	1874	14733000	29924	14741	5	0	3
390858	1874	14741000	29924	14741	7	0	3
390859	1678	28800895256000	29925	14742	0	0	1
390860	1678	28800895257000	29925	14742	1	0	1
390861	1874	14742000	29925	14742	2	0	3
390862	1874	14743000	29925	14742	3	0	3
390865	1678	28800895257000	29926	14742	1	0	\N
390866	1874	14745000	29926	14742	2	0	\N
390867	1874	14747000	29926	14742	3	0	\N
390868	1874	14749000	29926	14742	4	0	\N
390869	1874	14751000	29926	14742	5	0	\N
390870	1874	14752000	29926	14742	6	0	\N
390871	1874	14753000	29926	14742	7	0	\N
390872	1874	14754000	29926	14742	8	0	\N
390873	1874	14756000	29926	14742	9	0	\N
390874	1874	14758000	29926	14742	10	0	\N
390875	1874	14762000	29926	14742	11	0	\N
390876	1874	14766000	29926	14742	12	0	\N
390877	1874	14770000	29926	14742	13	0	\N
390878	1874	14774000	29926	14742	14	0	\N
390879	1874	14778000	29926	14742	15	0	\N
390880	1874	14782000	29926	14742	16	0	\N
390881	1874	14786000	29926	14742	17	0	\N
390882	1874	14790000	29926	14742	18	0	\N
390883	1678	28800895256000	29927	14742	0	0	\N
390884	1678	28800895257000	29927	14742	1	0	\N
390885	1874	14745000	29927	14742	2	0	\N
390886	1874	14747000	29927	14742	3	0	\N
390887	1874	14749000	29927	14742	4	0	\N
390888	1874	14751000	29927	14742	5	0	\N
390889	1874	14752000	29927	14742	6	0	\N
390890	1874	14753000	29927	14742	7	0	\N
390891	1874	14754000	29927	14742	8	0	\N
390892	1874	14756000	29927	14742	9	0	\N
390893	1874	14758000	29927	14742	10	0	\N
390894	1874	14762000	29927	14742	11	0	\N
390895	1874	14766000	29927	14742	12	0	\N
390896	1874	14770000	29927	14742	13	0	\N
390897	1874	14774000	29927	14742	14	0	\N
390898	1874	14778000	29927	14742	15	0	\N
390899	1874	14782000	29927	14742	16	0	\N
390900	1874	14786000	29927	14742	17	0	\N
390901	1874	14790000	29927	14742	18	0	\N
390902	1678	28800895256000	29928	14742	0	0	\N
390903	1678	28800895257000	29928	14742	1	0	\N
390904	1874	14745000	29928	14742	2	0	\N
390905	1874	14747000	29928	14742	3	0	\N
390906	1874	14749000	29928	14742	4	0	\N
390907	1874	14751000	29928	14742	5	0	\N
390908	1874	14752000	29928	14742	6	0	\N
390909	1874	14753000	29928	14742	7	0	\N
390910	1874	14754000	29928	14742	8	0	\N
390911	1874	14756000	29928	14742	9	0	\N
390912	1874	14758000	29928	14742	10	0	\N
390913	1874	14762000	29928	14742	11	0	\N
390914	1874	14766000	29928	14742	12	0	\N
390915	1874	14770000	29928	14742	13	0	\N
390916	1874	14774000	29928	14742	14	0	\N
390917	1874	14778000	29928	14742	15	0	\N
390918	1874	14782000	29928	14742	16	0	\N
390919	1874	14786000	29928	14742	17	0	\N
390920	1874	14790000	29928	14742	18	0	\N
390945	2238	1002997000000	29930	14727	0	0	\N
390946	1678	28800895240000	29930	14727	1	0	\N
390947	1678	28800895241000	29930	14727	2	0	\N
390948	1678	28800895242000	29930	14727	3	0	\N
390949	1678	28800895243000	29930	14727	4	0	\N
390950	1678	28800895244000	29930	14727	5	0	\N
390951	1678	28800895245000	29930	14727	6	0	\N
390952	1678	28800895246000	29930	14727	7	0	\N
390953	1678	28800895247000	29930	14727	8	0	\N
390954	1678	28800895248000	29930	14727	9	0	\N
390955	1678	28800895249000	29930	14727	10	0	\N
390956	1678	28800895250000	29930	14727	11	0	\N
390957	1678	28800895251000	29930	14727	12	0	\N
390958	1678	28800895252000	29930	14727	13	0	\N
390959	1678	28800895253000	29930	14727	14	0	\N
390960	1678	28800895254000	29930	14727	15	0	\N
390961	1678	28800895255000	29930	14727	16	0	\N
390962	1678	28800895256000	29930	14727	17	0	\N
390963	1678	28800895257000	29930	14727	18	0	\N
390964	1678	28800895258000	29930	14727	19	0	\N
390965	1874	14358000	29930	14727	20	0	\N
390966	1874	14360000	29930	14727	21	0	\N
390967	1874	14362000	29930	14727	22	0	\N
390968	1874	14364000	29930	14727	23	0	\N
390969	1874	14365000	29930	14727	24	0	\N
390970	1874	14366000	29930	14727	25	0	\N
390971	1874	14367000	29930	14727	29	0	\N
390972	1874	14368000	29930	14727	30	0	\N
390973	1874	14369000	29930	14727	31	0	\N
390974	1874	14370000	29930	14727	32	0	\N
390975	1874	14372000	29930	14727	33	0	\N
390976	1874	14374000	29930	14727	34	0	\N
390977	1874	14376000	29930	14727	35	0	\N
390978	1874	14377000	29930	14727	36	0	\N
390979	1874	14378000	29930	14727	37	0	\N
390980	1874	14379000	29930	14727	38	0	\N
390981	1874	14380000	29930	14727	39	0	\N
390982	1874	14381000	29930	14727	40	0	\N
390983	1874	14382000	29930	14727	41	0	\N
390984	1874	14383000	29930	14727	42	0	\N
390985	1874	14384000	29930	14727	43	0	\N
390986	1874	14385000	29930	14727	44	0	\N
390987	1874	14386000	29930	14727	45	0	\N
390988	1874	14387000	29930	14727	46	0	\N
390989	1874	14388000	29930	14727	47	0	\N
390990	1874	14389000	29930	14727	48	0	\N
390991	1874	14390000	29930	14727	49	0	\N
390992	1874	14391000	29930	14727	50	0	\N
390993	1874	14392000	29930	14727	51	0	\N
390994	1874	14393000	29930	14727	52	0	\N
390995	1874	14394000	29930	14727	53	0	\N
390996	1874	14395000	29930	14727	54	0	\N
390997	1874	14396000	29930	14727	55	0	\N
390998	1874	14397000	29930	14727	56	0	\N
390999	1874	14399000	29930	14727	57	0	\N
391000	1874	14401000	29930	14727	58	0	\N
390923	1874	14749000	29929	14743	2	0	3
390924	1874	14751000	29929	14743	3	0	3
390925	1874	14753000	29929	14743	4	0	3
390926	1874	14755000	29929	14743	5	0	3
390927	1874	14757000	29929	14743	6	0	3
390929	1874	14761000	29929	14743	8	0	3
390930	1874	14763000	29929	14743	9	0	3
390931	1874	14767000	29929	14743	10	0	3
390932	1874	14771000	29929	14743	11	0	3
390933	1874	14775000	29929	14743	12	0	3
390935	1874	14783000	29929	14743	14	0	3
390936	1874	14787000	29929	14743	15	0	3
390937	1874	14791000	29929	14743	16	0	3
390938	1874	14795000	29929	14743	17	0	3
390940	1874	14803000	29929	14743	19	0	3
390941	1874	14807000	29929	14743	20	0	3
390942	1874	14811000	29929	14743	21	0	3
390943	1874	14815000	29929	14743	22	0	3
390944	1874	14816000	29929	14743	23	0	3
391001	1874	14403000	29930	14727	59	0	\N
391002	1874	14405000	29930	14727	60	0	\N
391003	1874	14407000	29930	14727	61	0	\N
391004	1874	14409000	29930	14727	62	0	\N
391005	1874	14411000	29930	14727	63	0	\N
391006	1874	14413000	29930	14727	64	0	\N
391007	1874	14415000	29930	14727	65	0	\N
391008	1874	14417000	29930	14727	66	0	\N
391009	1874	14419000	29930	14727	67	0	\N
391010	1874	14421000	29930	14727	68	0	\N
391011	1874	14423000	29930	14727	69	0	\N
391012	1874	14425000	29930	14727	70	0	\N
391013	1874	14427000	29930	14727	71	0	\N
391014	1874	14429000	29930	14727	72	0	\N
391015	1874	14431000	29930	14727	73	0	\N
391016	1874	14433000	29930	14727	74	0	\N
391017	1874	14435000	29930	14727	75	0	\N
391018	1874	14437000	29930	14727	76	0	\N
391019	1874	14439000	29930	14727	77	0	\N
391020	1874	14441000	29930	14727	78	0	\N
391021	1874	14443000	29930	14727	79	0	\N
391022	1874	14445000	29930	14727	80	0	\N
391023	1874	14447000	29930	14727	81	0	\N
391024	1874	14449000	29930	14727	82	0	\N
391025	1874	14451000	29930	14727	83	0	\N
391026	1874	14453000	29930	14727	84	0	\N
391027	1874	14455000	29930	14727	85	0	\N
391028	1874	14457000	29930	14727	86	0	\N
391029	1874	14459000	29930	14727	87	0	\N
391030	1874	14461000	29930	14727	88	0	\N
391031	1874	14463000	29930	14727	89	0	\N
391032	1874	14465000	29930	14727	90	0	\N
391033	1874	14467000	29930	14727	92	0	\N
391034	1874	14469000	29930	14727	93	0	\N
391035	1874	14471000	29930	14727	94	0	\N
391036	1874	14473000	29930	14727	95	0	\N
391052	1678	28800895259000	29933	14744	0	0	\N
391053	1678	28800895260000	29933	14744	1	0	\N
391054	1874	14817000	29933	14744	2	0	\N
391055	1874	14821000	29933	14744	3	0	\N
391056	1874	14825000	29933	14744	4	0	\N
391057	1874	14826000	29933	14744	5	0	\N
391058	1874	14827000	29933	14744	6	0	\N
391059	2433	100000000	29933	14744	7	0	\N
391060	2434	100000000	29933	14744	8	0	\N
391061	1874	14829000	29933	14744	9	0	\N
391062	1874	14831000	29933	14744	10	0	\N
391063	1874	14833000	29933	14744	11	0	\N
391064	1874	14835000	29933	14744	12	0	\N
391065	1874	14837000	29933	14744	13	0	\N
391066	1874	14839000	29933	14744	14	0	\N
391067	1678	28800895261000	29934	14745	0	0	\N
391068	1678	28800895262000	29934	14745	1	0	\N
391069	1874	14840000	29934	14745	2	0	\N
391070	1874	14841000	29934	14745	3	0	\N
391071	1874	14842000	29934	14745	4	0	\N
391072	1874	14844000	29934	14745	5	0	\N
391073	1874	14846000	29934	14745	6	0	\N
391074	1874	14848000	29934	14745	7	0	\N
391075	1874	14850000	29934	14745	8	0	\N
391076	1874	14852000	29934	14745	9	0	\N
391087	1678	28800895261000	29936	14745	0	0	\N
391088	1678	28800895262000	29936	14745	1	0	\N
391089	1874	14840000	29936	14745	2	0	\N
391090	1874	14841000	29936	14745	3	0	\N
391091	1874	14842000	29936	14745	4	0	\N
391092	1874	14844000	29936	14745	5	0	\N
391093	1874	14846000	29936	14745	6	0	\N
391094	1874	14848000	29936	14745	7	0	\N
391095	1874	14850000	29936	14745	8	0	\N
391096	1874	14852000	29936	14745	9	0	\N
391097	1678	28800895261000	29937	14745	0	0	\N
391098	1678	28800895262000	29937	14745	1	0	\N
391099	1874	14840000	29937	14745	2	0	\N
391100	1874	14841000	29937	14745	3	0	\N
391101	1874	14842000	29937	14745	4	0	\N
391102	1874	14844000	29937	14745	5	0	\N
391103	1874	14846000	29937	14745	6	0	\N
391104	1874	14848000	29937	14745	7	0	\N
391105	1874	14850000	29937	14745	8	0	\N
391106	1874	14852000	29937	14745	9	0	\N
391107	1678	28800895256000	29938	14742	0	0	\N
391108	1678	28800895257000	29938	14742	1	0	\N
391109	1678	28800895258000	29938	14742	2	0	\N
391110	1678	28800895259000	29938	14742	3	0	\N
391111	1678	28800895260000	29938	14742	4	0	\N
391112	1678	28800895261000	29938	14742	5	0	\N
391113	1678	28800895262000	29938	14742	6	0	\N
391114	1874	14745000	29938	14742	7	0	\N
391115	1874	14747000	29938	14742	8	0	\N
391116	1874	14749000	29938	14742	9	0	\N
391117	1874	14751000	29938	14742	10	0	\N
391118	1874	14752000	29938	14742	11	0	\N
391119	1874	14753000	29938	14742	12	0	\N
391120	1874	14754000	29938	14742	13	0	\N
391121	1874	14755000	29938	14742	14	0	\N
391122	1874	14757000	29938	14742	15	0	\N
391123	1874	14759000	29938	14742	16	0	\N
391124	1874	14761000	29938	14742	17	0	\N
391125	1874	14763000	29938	14742	18	0	\N
391126	1874	14767000	29938	14742	19	0	\N
391127	1874	14771000	29938	14742	20	0	\N
391128	1874	14775000	29938	14742	21	0	\N
391129	1874	14779000	29938	14742	22	0	\N
391130	1874	14783000	29938	14742	23	0	\N
391131	1874	14787000	29938	14742	24	0	\N
391132	1874	14791000	29938	14742	25	0	\N
391133	1874	14795000	29938	14742	26	0	\N
391134	1874	14799000	29938	14742	27	0	\N
391135	1874	14803000	29938	14742	28	0	\N
391136	1874	14807000	29938	14742	29	0	\N
391039	1874	14817000	29932	14744	2	0	3
391040	1874	14821000	29932	14744	3	0	3
391041	1874	14825000	29932	14744	4	0	3
391042	1874	14826000	29932	14744	5	0	3
391043	1874	14827000	29932	14744	6	0	3
391045	2434	100000000	29932	14744	8	0	0
391046	1874	14829000	29932	14744	9	0	3
391047	1874	14831000	29932	14744	10	0	3
391048	1874	14833000	29932	14744	11	0	3
391049	1874	14835000	29932	14744	12	0	3
391051	1874	14839000	29932	14744	14	0	3
391077	1678	28800895261000	29935	14745	0	0	1
391078	1678	28800895262000	29935	14745	1	0	1
391079	1874	14840000	29935	14745	2	0	3
391081	1874	14842000	29935	14745	4	0	3
391082	1874	14844000	29935	14745	5	0	3
391083	1874	14846000	29935	14745	6	0	3
391084	1874	14848000	29935	14745	7	0	3
391085	1874	14850000	29935	14745	8	0	3
391137	1874	14811000	29938	14742	30	0	\N
391138	1874	14815000	29938	14742	31	0	\N
391139	1874	14819000	29938	14742	33	0	\N
391140	1874	14823000	29938	14742	34	0	\N
391141	2433	100000000	29938	14742	35	0	\N
391142	2434	100000000	29938	14742	36	0	\N
391143	1874	14824000	29938	14742	37	0	\N
391144	1874	14825000	29938	14742	38	0	\N
391145	1874	14826000	29938	14742	39	0	\N
391146	1874	14827000	29938	14742	40	0	\N
391147	1874	14828000	29938	14742	41	0	\N
391148	1874	14829000	29938	14742	42	0	\N
391149	1874	14830000	29938	14742	43	0	\N
391150	1874	14832000	29938	14742	44	0	\N
391151	1874	14834000	29938	14742	45	0	\N
391152	1874	14836000	29938	14742	46	0	\N
391153	1874	14838000	29938	14742	47	0	\N
391154	1874	14840000	29938	14742	48	0	\N
391155	1874	14842000	29938	14742	49	0	\N
391156	1874	14844000	29938	14742	50	0	\N
391157	1874	14846000	29938	14742	51	0	\N
391158	1874	14848000	29938	14742	52	0	\N
391159	1874	14850000	29938	14742	53	0	\N
391160	1874	14852000	29938	14742	54	0	\N
391179	1678	28800895265000	29945	14748	0	0	\N
391180	1874	14868000	29945	14748	1	0	\N
391181	1874	14872000	29945	14748	2	0	\N
391182	1874	14876000	29945	14748	3	0	\N
391183	1874	14878000	29945	14748	4	0	\N
391184	1874	14880000	29945	14748	5	0	\N
391185	1874	14884000	29945	14748	6	0	\N
391186	1874	14888000	29945	14748	7	0	\N
391187	1678	28800895265000	29946	14749	0	0	\N
391188	1678	28800895266000	29946	14749	1	0	\N
391189	1874	14892000	29946	14749	2	0	\N
391190	1874	14893000	29946	14749	3	0	\N
391191	1874	14894000	29946	14749	4	0	\N
391192	1874	14896000	29946	14749	5	0	\N
391193	1874	14898000	29946	14749	6	0	\N
391194	1874	14900000	29946	14749	7	0	\N
391195	1874	14904000	29946	14749	8	0	\N
391196	1874	14908000	29946	14749	9	0	\N
391197	1874	14912000	29946	14749	10	0	\N
391198	1678	28800895265000	29947	14749	0	0	\N
391199	1678	28800895266000	29947	14749	1	0	\N
391200	1874	14892000	29947	14749	2	0	\N
391201	1874	14893000	29947	14749	3	0	\N
391202	1874	14895000	29947	14749	4	0	\N
391203	1874	14897000	29947	14749	5	0	\N
391204	1874	14899000	29947	14749	6	0	\N
391205	1874	14903000	29947	14749	7	0	\N
391206	1874	14907000	29947	14749	8	0	\N
391207	1874	14911000	29947	14749	9	0	\N
391266	1678	28800895271000	29955	14753	0	0	\N
391267	1874	15010000	29955	14753	1	0	\N
391268	1874	15014000	29955	14753	2	0	\N
391269	1874	15018000	29955	14753	3	0	\N
391270	1874	15022000	29955	14753	4	0	\N
391271	1874	15024000	29955	14753	5	0	\N
391272	1874	15025000	29955	14753	6	0	\N
391163	1874	14856000	29939	14746	2	0	3
391164	1874	14857000	29939	14746	3	0	3
391165	1874	14859000	29939	14746	4	0	3
391166	1678	28800895264000	29940	14747	0	0	1
391167	1874	14861000	29940	14747	1	0	3
391169	1874	14864000	29940	14747	3	0	3
391170	1874	14865000	29940	14747	4	0	3
391171	1874	14867000	29940	14747	5	0	3
391172	1874	14868000	29944	14748	0	0	3
391173	1874	14872000	29944	14748	1	0	3
391175	1874	14878000	29944	14748	3	0	3
391176	1874	14880000	29944	14748	4	0	3
391177	1874	14884000	29944	14748	5	0	3
391178	1874	14888000	29944	14748	6	0	3
391209	1678	28800895266000	29948	14749	1	0	1
391210	1874	14892000	29948	14749	2	0	3
391211	1874	14893000	29948	14749	3	0	3
391212	1874	14894000	29948	14749	4	0	3
391213	1874	14896000	29948	14749	5	0	3
391215	1874	14900000	29948	14749	7	0	3
391216	1874	14904000	29948	14749	8	0	3
391217	1874	14908000	29948	14749	9	0	3
391218	1874	14912000	29948	14749	10	0	3
391219	1678	28800895267000	29949	14750	0	0	1
391221	1874	14916000	29949	14750	2	0	3
391222	1874	14917000	29949	14750	3	0	3
391223	1874	14921000	29949	14750	4	0	3
391224	1874	14925000	29949	14750	5	0	3
391226	1874	14933000	29949	14750	7	0	3
391227	1874	14937000	29949	14750	8	0	3
391228	1678	28800895268000	29950	14751	0	0	1
391229	1678	28800895269000	29950	14751	1	0	1
391230	1874	14939000	29950	14751	2	0	3
391232	1874	14941000	29950	14751	4	0	3
391233	1874	14942000	29950	14751	5	0	3
391234	1874	14946000	29950	14751	6	0	3
391235	1874	14948000	29950	14751	7	0	3
391236	1874	14952000	29950	14751	8	0	3
391238	1874	14958000	29950	14751	10	0	3
391239	1874	14960000	29950	14751	11	0	3
391240	1874	14962000	29950	14751	12	0	3
391241	1874	14966000	29950	14751	13	0	3
391243	1874	14974000	29950	14751	15	0	3
391244	1874	14978000	29950	14751	16	0	3
391245	1874	14982000	29950	14751	17	0	3
391246	1874	14986000	29950	14751	18	0	3
391247	1678	28800895270000	29951	14752	0	0	1
391249	1874	14991000	29951	14752	2	0	3
391250	1874	14995000	29951	14752	3	0	3
391251	1874	14999000	29951	14752	4	0	3
391252	1874	15001000	29951	14752	5	0	3
391253	1874	15003000	29951	14752	6	0	3
391255	1874	15008000	29951	14752	8	0	3
391256	1678	28800895271000	29954	14753	0	0	1
391257	1874	15010000	29954	14753	1	0	3
391258	1874	15014000	29954	14753	2	0	3
391260	1874	15022000	29954	14753	4	0	3
391261	1874	15024000	29954	14753	5	0	3
391262	1874	15025000	29954	14753	6	0	3
391263	1874	15027000	29954	14753	7	0	3
391264	1874	15031000	29954	14753	8	0	3
391273	1874	15027000	29955	14753	7	0	\N
391274	1874	15031000	29955	14753	8	0	\N
391275	1874	15035000	29955	14753	9	0	\N
391286	1678	28800895272000	29957	14754	0	0	\N
391287	1874	15037000	29957	14754	1	0	\N
391288	1874	15038000	29957	14754	3	0	\N
391289	1874	15042000	29957	14754	4	0	\N
391290	1874	15043000	29957	14754	5	0	\N
391291	1874	15045000	29957	14754	6	0	\N
391292	1874	15047000	29957	14754	7	0	\N
391293	1874	15051000	29957	14754	8	0	\N
391294	1874	15055000	29957	14754	9	0	\N
391295	1874	15059000	29957	14754	10	0	\N
391296	1678	28800895273000	29958	14755	0	0	\N
391297	1874	15063000	29958	14755	1	0	\N
391298	1874	15067000	29958	14755	2	0	\N
391299	1874	15069000	29958	14755	3	0	\N
391300	1874	15071000	29958	14755	4	0	\N
391301	1874	15072000	29958	14755	5	0	\N
391313	1678	28800895275000	29961	14757	0	0	\N
391314	1874	15080000	29961	14757	1	0	\N
391315	1874	15081000	29961	14757	2	0	\N
391316	1874	15083000	29961	14757	3	0	\N
391317	1874	15085000	29961	14757	4	0	\N
391323	1678	28800895275000	29963	14757	0	0	\N
391324	1874	15080000	29963	14757	1	0	\N
391325	1874	15081000	29963	14757	2	0	\N
391326	1874	15083000	29963	14757	3	0	\N
391327	1874	15085000	29963	14757	4	0	\N
391328	1678	28800895275000	29964	14757	0	0	\N
391329	1874	15080000	29964	14757	1	0	\N
391330	1874	15081000	29964	14757	2	0	\N
391331	1874	15083000	29964	14757	3	0	\N
391332	1874	15085000	29964	14757	4	0	\N
391350	1678	28800895276000	29966	14758	0	0	\N
391351	1874	15089000	29966	14758	1	0	\N
391352	1874	15090000	29966	14758	2	0	\N
391353	1874	15092000	29966	14758	3	0	\N
391354	1874	15094000	29966	14758	4	0	\N
391355	1874	15098000	29966	14758	5	0	\N
391356	1874	15102000	29966	14758	6	0	\N
391357	1874	15106000	29966	14758	7	0	\N
391358	1874	15110000	29966	14758	8	0	\N
391359	1874	15114000	29966	14758	9	0	\N
391360	1874	15118000	29966	14758	10	0	\N
391361	1874	15122000	29966	14758	11	0	\N
391362	1874	15126000	29966	14758	12	0	\N
391363	1874	15130000	29966	14758	13	0	\N
391364	1874	15134000	29966	14758	14	0	\N
391365	1874	15138000	29966	14758	15	0	\N
391366	1874	15142000	29966	14758	16	0	\N
391367	1874	15146000	29966	14758	17	0	\N
391368	1874	15150000	29966	14758	18	0	\N
391382	1678	28800895277000	29968	14759	0	0	\N
391383	1874	15146000	29968	14759	1	0	\N
391384	1874	15150000	29968	14759	2	0	\N
391385	1874	15154000	29968	14759	3	0	\N
391386	1874	15156000	29968	14759	4	0	\N
391387	1874	15157000	29968	14759	5	0	\N
391388	1874	15159000	29968	14759	6	0	\N
391389	1874	15161000	29968	14759	7	0	\N
391390	1874	15162000	29968	14759	8	0	\N
391391	1874	15166000	29968	14759	9	0	\N
391392	1874	15170000	29968	14759	10	0	\N
391393	1874	15174000	29968	14759	11	0	\N
391394	1874	15178000	29968	14759	12	0	\N
391395	1678	28800895278000	29969	14760	0	0	\N
391396	1874	15180000	29969	14760	1	0	\N
391397	1874	15184000	29969	14760	2	0	\N
391398	1874	15185000	29969	14760	3	0	\N
391399	1874	15189000	29969	14760	4	0	\N
391400	1874	15193000	29969	14760	5	0	\N
391401	1874	15197000	29969	14760	6	0	\N
391402	1874	15199000	29969	14760	7	0	\N
391403	1874	15201000	29969	14760	8	0	\N
391404	1678	28800895278000	29970	14760	0	0	\N
391405	1874	15180000	29970	14760	1	0	\N
391406	1874	15184000	29970	14760	2	0	\N
391407	1874	15185000	29970	14760	3	0	\N
391408	1874	15189000	29970	14760	4	0	\N
391278	1874	15038000	29956	14754	3	0	3
391279	1874	15042000	29956	14754	4	0	3
391280	1874	15043000	29956	14754	5	0	3
391281	1874	15045000	29956	14754	6	0	3
391282	1874	15047000	29956	14754	7	0	3
391284	1874	15055000	29956	14754	9	0	3
391285	1874	15059000	29956	14754	10	0	3
391302	1678	28800895273000	29959	14755	0	0	1
391303	1874	15063000	29959	14755	1	0	3
391304	1874	15067000	29959	14755	2	0	3
391306	1874	15071000	29959	14755	4	0	3
391307	1874	15073000	29959	14755	5	0	3
391308	1874	15074000	29959	14755	6	0	3
391309	1678	28800895274000	29960	14756	0	0	1
391311	1874	15078000	29960	14756	2	0	3
391312	1874	15079000	29960	14756	3	0	3
391318	1678	28800895275000	29962	14757	0	0	1
391319	1874	15080000	29962	14757	1	0	3
391320	1874	15081000	29962	14757	2	0	3
391322	1874	15085000	29962	14757	4	0	3
391333	1678	28800895276000	29965	14758	0	0	1
391334	1874	15089000	29965	14758	1	0	3
391335	1874	15090000	29965	14758	2	0	3
391336	1874	15092000	29965	14758	3	0	3
391338	1874	15098000	29965	14758	5	0	3
391339	1874	15102000	29965	14758	6	0	3
391340	1874	15106000	29965	14758	7	0	3
391341	1874	15110000	29965	14758	8	0	3
391343	1874	15118000	29965	14758	10	0	3
391344	1874	15122000	29965	14758	11	0	3
391345	1874	15126000	29965	14758	12	0	3
391346	1874	15130000	29965	14758	13	0	3
391347	1874	15134000	29965	14758	14	0	3
391349	1874	15142000	29965	14758	16	0	3
391369	1678	28800895277000	29967	14759	0	0	1
391370	1874	15146000	29967	14759	1	0	3
391371	1874	15150000	29967	14759	2	0	3
391372	1874	15154000	29967	14759	3	0	3
391374	1874	15157000	29967	14759	5	0	3
391375	1874	15159000	29967	14759	6	0	3
391376	1874	15161000	29967	14759	7	0	3
391377	1874	15162000	29967	14759	8	0	3
391379	1874	15170000	29967	14759	10	0	3
391380	1874	15174000	29967	14759	11	0	3
391381	1874	15178000	29967	14759	12	0	3
391409	1874	15193000	29970	14760	5	0	\N
391410	1874	15197000	29970	14760	6	0	\N
391411	1874	15199000	29970	14760	7	0	\N
391412	1874	15201000	29970	14760	8	0	\N
391422	1678	28800895278000	29972	14760	0	0	\N
391423	1874	15180000	29972	14760	1	0	\N
391424	1874	15184000	29972	14760	2	0	\N
391425	1874	15185000	29972	14760	3	0	\N
391426	1874	15189000	29972	14760	4	0	\N
391427	1874	15193000	29972	14760	5	0	\N
391428	1874	15197000	29972	14760	6	0	\N
391429	1874	15199000	29972	14760	7	0	\N
391430	1874	15201000	29972	14760	8	0	\N
391431	1678	28800895278000	29973	14760	0	0	\N
391432	1874	15180000	29973	14760	1	0	\N
391433	1874	15181000	29973	14760	2	0	\N
391434	1874	15183000	29973	14760	3	0	\N
391435	1874	15185000	29973	14760	4	0	\N
391436	1678	28800895279000	29974	14761	0	0	\N
391437	1678	28800895280000	29974	14761	1	0	\N
391438	1874	15203000	29974	14761	2	0	\N
391439	1874	15205000	29974	14761	3	0	\N
391440	1874	15207000	29974	14761	4	0	\N
391441	1874	15211000	29974	14761	5	0	\N
391442	1874	15215000	29974	14761	6	0	\N
391443	1874	15219000	29974	14761	7	0	\N
391444	1874	15223000	29974	14761	8	0	\N
391445	1874	15224000	29974	14761	9	0	\N
391446	1874	15225000	29974	14761	10	0	\N
391447	1874	15226000	29974	14761	11	0	\N
391448	1874	15230000	29974	14761	12	0	\N
391449	1874	15234000	29974	14761	13	0	\N
391450	1874	15238000	29974	14761	14	0	\N
391451	1874	15242000	29974	14761	15	0	\N
391452	1874	15246000	29974	14761	16	0	\N
391453	1874	15248000	29974	14761	17	0	\N
391472	1678	28800895279000	29976	14761	0	0	\N
391473	1678	28800895280000	29976	14761	1	0	\N
391474	1874	15203000	29976	14761	2	0	\N
391475	1874	15205000	29976	14761	3	0	\N
391476	1874	15207000	29976	14761	4	0	\N
391477	1874	15208000	29976	14761	5	0	\N
391478	1874	15209000	29976	14761	6	0	\N
391479	1874	15210000	29976	14761	7	0	\N
391480	1874	15212000	29976	14761	8	0	\N
391481	1678	28800895281000	29977	14762	0	0	\N
391482	1678	28800895282000	29977	14762	1	0	\N
391483	1874	15252000	29977	14762	2	0	\N
391484	1874	15254000	29977	14762	3	0	\N
391485	1874	15256000	29977	14762	4	0	\N
391486	1874	15257000	29977	14762	5	0	\N
391487	1874	15259000	29977	14762	6	0	\N
391488	1874	15261000	29977	14762	7	0	\N
391489	1874	15263000	29977	14762	8	0	\N
391490	1874	15265000	29977	14762	9	0	\N
391491	1874	15266000	29977	14762	10	0	\N
391492	1874	15267000	29977	14762	11	0	\N
391493	1874	15271000	29977	14762	12	0	\N
391494	1874	15275000	29977	14762	13	0	\N
391495	1874	15279000	29977	14762	14	0	\N
391496	1874	15283000	29977	14762	15	0	\N
391497	1874	15287000	29977	14762	16	0	\N
391498	1874	15291000	29977	14762	17	0	\N
391499	1874	15295000	29977	14762	18	0	\N
391500	1874	15299000	29977	14762	19	0	\N
391540	1678	28800895285000	29980	14764	0	0	\N
391541	1874	15352000	29980	14764	1	0	\N
391542	1874	15354000	29980	14764	2	0	\N
391543	1874	15356000	29980	14764	3	0	\N
391544	1874	15358000	29980	14764	4	0	\N
391415	1874	15184000	29971	14760	2	0	3
391416	1874	15185000	29971	14760	3	0	3
391417	1874	15189000	29971	14760	4	0	3
391418	1874	15193000	29971	14760	5	0	3
391419	1874	15197000	29971	14760	6	0	3
391421	1874	15201000	29971	14760	8	0	3
391454	1678	28800895279000	29975	14761	0	0	1
391455	1678	28800895280000	29975	14761	1	0	1
391456	1874	15203000	29975	14761	2	0	3
391457	1874	15205000	29975	14761	3	0	3
391459	1874	15211000	29975	14761	5	0	3
391460	1874	15215000	29975	14761	6	0	3
391461	1874	15219000	29975	14761	7	0	3
391462	1874	15223000	29975	14761	8	0	3
391464	1874	15225000	29975	14761	10	0	3
391465	1874	15226000	29975	14761	11	0	3
391466	1874	15230000	29975	14761	12	0	3
391467	1874	15234000	29975	14761	13	0	3
391468	1874	15238000	29975	14761	14	0	3
391470	1874	15246000	29975	14761	16	0	3
391471	1874	15248000	29975	14761	17	0	3
391501	1678	28800895281000	29978	14762	0	0	1
391502	1678	28800895282000	29978	14762	1	0	1
391503	1874	15252000	29978	14762	2	0	3
391505	1874	15256000	29978	14762	4	0	3
391506	1874	15257000	29978	14762	5	0	3
391507	1874	15259000	29978	14762	6	0	3
391508	1874	15261000	29978	14762	7	0	3
391510	1874	15265000	29978	14762	9	0	3
391511	1874	15266000	29978	14762	10	0	3
391512	1874	15267000	29978	14762	11	0	3
391513	1874	15271000	29978	14762	12	0	3
391514	1874	15275000	29978	14762	13	0	3
391516	1874	15283000	29978	14762	15	0	3
391517	1874	15287000	29978	14762	16	0	3
391518	1874	15291000	29978	14762	17	0	3
391519	1874	15295000	29978	14762	18	0	3
391520	1874	15299000	29978	14762	19	0	3
391522	1678	28800895284000	29979	14763	1	0	1
391523	1874	15301000	29979	14763	2	0	3
391524	1874	15302000	29979	14763	4	0	3
391525	1874	15303000	29979	14763	5	0	3
391527	1874	15309000	29979	14763	7	0	3
391528	1874	15313000	29979	14763	8	0	3
391529	1874	15317000	29979	14763	9	0	3
391530	1874	15321000	29979	14763	10	0	3
391531	1874	15325000	29979	14763	11	0	3
391533	1874	15333000	29979	14763	13	0	3
391534	1874	15337000	29979	14763	14	0	3
391535	1874	15341000	29979	14763	15	0	3
391536	1874	15342000	29979	14763	16	0	3
391537	1874	15344000	29979	14763	17	0	3
391539	1874	15348000	29979	14763	19	0	3
391545	1874	15359000	29980	14764	5	0	\N
391546	1874	15363000	29980	14764	6	0	\N
391547	1874	15367000	29980	14764	7	0	\N
391548	1874	15371000	29980	14764	8	0	\N
391549	1874	15372000	29980	14764	9	0	\N
391550	1678	28800895285000	29981	14764	0	0	\N
391551	1874	15352000	29981	14764	1	0	\N
391552	1874	15354000	29981	14764	2	0	\N
391553	1874	15356000	29981	14764	3	0	\N
391554	1874	15357000	29981	14764	4	0	\N
391555	1874	15361000	29981	14764	5	0	\N
391556	1874	15365000	29981	14764	6	0	\N
391557	1874	15369000	29981	14764	7	0	\N
391558	1874	15370000	29981	14764	8	0	\N
391569	1678	28800895286000	29983	14765	0	0	\N
391570	1678	28800895287000	29983	14765	1	0	\N
391571	1874	15376000	29983	14765	2	0	\N
391572	1874	15378000	29983	14765	3	0	\N
391573	1874	15380000	29983	14765	4	0	\N
391574	1874	15382000	29983	14765	5	0	\N
391575	1874	15383000	29983	14765	6	0	\N
391576	1874	15384000	29983	14765	7	0	\N
391577	1874	15385000	29983	14765	8	0	\N
391578	1874	15387000	29983	14765	9	0	\N
391579	1874	15389000	29983	14765	10	0	\N
391580	1874	15393000	29983	14765	11	0	\N
391581	1874	15397000	29983	14765	12	0	\N
391582	1874	15401000	29983	14765	13	0	\N
391583	1874	15405000	29983	14765	14	0	\N
391584	1874	15409000	29983	14765	15	0	\N
391585	1874	15413000	29983	14765	16	0	\N
391586	1874	15417000	29983	14765	17	0	\N
391587	1874	15421000	29983	14765	18	0	\N
391607	1678	28800895286000	29985	14765	0	0	\N
391608	1678	28800895287000	29985	14765	1	0	\N
391609	1874	15376000	29985	14765	2	0	\N
391610	1874	15378000	29985	14765	3	0	\N
391611	1874	15380000	29985	14765	4	0	\N
391612	1874	15382000	29985	14765	5	0	\N
391613	1874	15383000	29985	14765	6	0	\N
391614	1874	15384000	29985	14765	7	0	\N
391615	1874	15385000	29985	14765	8	0	\N
391616	1874	15387000	29985	14765	9	0	\N
391617	1874	15389000	29985	14765	10	0	\N
391618	1874	15393000	29985	14765	11	0	\N
391619	1874	15397000	29985	14765	12	0	\N
391620	1874	15401000	29985	14765	13	0	\N
391621	1874	15405000	29985	14765	14	0	\N
391622	1874	15409000	29985	14765	15	0	\N
391623	1874	15413000	29985	14765	16	0	\N
391624	1874	15417000	29985	14765	17	0	\N
391625	1874	15421000	29985	14765	18	0	\N
391626	1678	28800895268000	29986	14751	0	0	\N
391627	1678	28800895269000	29986	14751	1	0	\N
391628	1678	28800895270000	29986	14751	2	0	\N
391629	1678	28800895271000	29986	14751	3	0	\N
391630	1678	28800895272000	29986	14751	4	0	\N
391631	1678	28800895273000	29986	14751	5	0	\N
391632	1678	28800895274000	29986	14751	6	0	\N
391633	1678	28800895275000	29986	14751	7	0	\N
391634	1678	28800895276000	29986	14751	8	0	\N
391635	1678	28800895277000	29986	14751	9	0	\N
391636	1678	28800895278000	29986	14751	10	0	\N
391637	1678	28800895279000	29986	14751	11	0	\N
391638	1678	28800895280000	29986	14751	12	0	\N
391639	1678	28800895281000	29986	14751	13	0	\N
391640	1678	28800895282000	29986	14751	14	0	\N
391641	1678	28800895283000	29986	14751	15	0	\N
391642	1678	28800895284000	29986	14751	16	0	\N
391643	1678	28800895285000	29986	14751	17	0	\N
391644	1678	28800895286000	29986	14751	18	0	\N
391645	1678	28800895287000	29986	14751	19	0	\N
391646	1874	14939000	29986	14751	20	0	\N
391647	1874	14940000	29986	14751	21	0	\N
391648	1874	14941000	29986	14751	22	0	\N
391649	1874	14942000	29986	14751	23	0	\N
391650	1874	14943000	29986	14751	24	0	\N
391651	1874	14947000	29986	14751	25	0	\N
391652	1874	14949000	29986	14751	26	0	\N
391653	1874	14953000	29986	14751	27	0	\N
391654	1874	14957000	29986	14751	28	0	\N
391655	1874	14959000	29986	14751	29	0	\N
391656	1874	14961000	29986	14751	30	0	\N
391657	1874	14963000	29986	14751	31	0	\N
391658	1874	14965000	29986	14751	32	0	\N
391659	1874	14967000	29986	14751	33	0	\N
391660	1874	14969000	29986	14751	34	0	\N
391661	1874	14971000	29986	14751	35	0	\N
391662	1874	14973000	29986	14751	36	0	\N
391663	1874	14975000	29986	14751	37	0	\N
391664	1874	14977000	29986	14751	38	0	\N
391665	1874	14979000	29986	14751	39	0	\N
391666	1874	14981000	29986	14751	40	0	\N
391667	1874	14983000	29986	14751	41	0	\N
391668	1874	14985000	29986	14751	42	0	\N
391669	1874	14987000	29986	14751	43	0	\N
391670	1874	14989000	29986	14751	44	0	\N
391671	1874	14991000	29986	14751	45	0	\N
391672	1874	14993000	29986	14751	47	0	\N
391673	1874	14995000	29986	14751	48	0	\N
391674	1874	14997000	29986	14751	49	0	\N
391675	1874	14999000	29986	14751	50	0	\N
391676	1874	15001000	29986	14751	51	0	\N
391677	1874	15003000	29986	14751	52	0	\N
391678	1874	15005000	29986	14751	53	0	\N
391679	1874	15009000	29986	14751	54	0	\N
391680	1874	15013000	29986	14751	55	0	\N
391561	1874	15354000	29982	14764	2	0	3
391562	1874	15356000	29982	14764	3	0	3
391563	1874	15358000	29982	14764	4	0	3
391564	1874	15359000	29982	14764	5	0	3
391565	1874	15363000	29982	14764	6	0	3
391567	1874	15371000	29982	14764	8	0	3
391568	1874	15372000	29982	14764	9	0	3
391588	1678	28800895286000	29984	14765	0	0	1
391589	1678	28800895287000	29984	14765	1	0	1
391590	1874	15376000	29984	14765	2	0	3
391592	1874	15380000	29984	14765	4	0	3
391593	1874	15382000	29984	14765	5	0	3
391594	1874	15383000	29984	14765	6	0	3
391595	1874	15384000	29984	14765	7	0	3
391597	1874	15387000	29984	14765	9	0	3
391598	1874	15389000	29984	14765	10	0	3
391599	1874	15393000	29984	14765	11	0	3
391600	1874	15397000	29984	14765	12	0	3
391601	1874	15401000	29984	14765	13	0	3
391603	1874	15409000	29984	14765	15	0	3
391604	1874	15413000	29984	14765	16	0	3
391605	1874	15417000	29984	14765	17	0	3
391606	1874	15421000	29984	14765	18	0	3
391681	1874	15017000	29986	14751	56	0	\N
391682	1874	15021000	29986	14751	57	0	\N
391683	1874	15025000	29986	14751	58	0	\N
391684	1874	15029000	29986	14751	59	0	\N
391685	1874	15033000	29986	14751	60	0	\N
391686	1874	15037000	29986	14751	61	0	\N
391687	1874	15041000	29986	14751	62	0	\N
391688	1874	15045000	29986	14751	63	0	\N
391689	1874	15049000	29986	14751	64	0	\N
391690	1874	15053000	29986	14751	65	0	\N
391691	1874	15057000	29986	14751	66	0	\N
391692	1874	15059000	29986	14751	67	0	\N
391693	1874	15061000	29986	14751	68	0	\N
391694	1874	15063000	29986	14751	69	0	\N
391695	1874	15065000	29986	14751	70	0	\N
391696	1874	15067000	29986	14751	71	0	\N
391697	1874	15069000	29986	14751	72	0	\N
391698	1874	15071000	29986	14751	73	0	\N
391699	1874	15073000	29986	14751	74	0	\N
391700	1874	15075000	29986	14751	75	0	\N
391701	1874	15077000	29986	14751	76	0	\N
391702	1874	15079000	29986	14751	77	0	\N
391703	1874	15081000	29986	14751	78	0	\N
391704	1874	15083000	29986	14751	79	0	\N
391705	1874	15085000	29986	14751	80	0	\N
391706	1874	15089000	29986	14751	81	0	\N
391707	1874	15093000	29986	14751	82	0	\N
391708	1874	15097000	29986	14751	83	0	\N
391709	1874	15101000	29986	14751	84	0	\N
391710	1874	15105000	29986	14751	85	0	\N
391711	1874	15109000	29986	14751	86	0	\N
391712	1874	15113000	29986	14751	87	0	\N
391713	1874	15117000	29986	14751	88	0	\N
391714	1874	15121000	29986	14751	89	0	\N
391715	1874	15125000	29986	14751	90	0	\N
391716	1874	15129000	29986	14751	91	0	\N
391717	1874	15133000	29986	14751	92	0	\N
391718	1874	15137000	29986	14751	93	0	\N
391719	1874	15141000	29986	14751	94	0	\N
391720	1874	15145000	29986	14751	95	0	\N
391721	1874	15149000	29986	14751	96	0	\N
391722	1874	15153000	29986	14751	97	0	\N
391723	1874	15157000	29986	14751	98	0	\N
391724	1874	15161000	29986	14751	99	0	\N
391725	1874	15165000	29986	14751	100	0	\N
391726	1874	15169000	29986	14751	101	0	\N
391727	1874	15173000	29986	14751	102	0	\N
391728	1874	15177000	29986	14751	103	0	\N
391729	1874	15181000	29986	14751	104	0	\N
391730	1874	15185000	29986	14751	105	0	\N
391731	1874	15189000	29986	14751	106	0	\N
391732	1874	15193000	29986	14751	107	0	\N
391733	1874	15197000	29986	14751	108	0	\N
391734	1874	15201000	29986	14751	109	0	\N
391735	1874	15205000	29986	14751	110	0	\N
391736	1874	15209000	29986	14751	111	0	\N
391737	1874	15213000	29986	14751	112	0	\N
391738	1874	15217000	29986	14751	113	0	\N
391739	1874	15221000	29986	14751	114	0	\N
391740	1874	15225000	29986	14751	115	0	\N
391741	1874	15229000	29986	14751	116	0	\N
391742	1874	15233000	29986	14751	117	0	\N
391743	1874	15237000	29986	14751	118	0	\N
391744	1874	15241000	29986	14751	119	0	\N
391745	1874	15245000	29986	14751	120	0	\N
391746	1874	15249000	29986	14751	121	0	\N
391747	1678	28800895288000	29987	14766	0	0	\N
391748	1678	28800895289000	29987	14766	1	0	\N
391749	1874	15422000	29987	14766	2	0	\N
391750	1874	15426000	29987	14766	3	0	\N
391751	1874	15430000	29987	14766	4	0	\N
391752	1874	15434000	29987	14766	5	0	\N
391753	1874	15435000	29987	14766	6	0	\N
391754	1874	15439000	29987	14766	7	0	\N
391755	1874	15443000	29987	14766	8	0	\N
391756	1874	15447000	29987	14766	9	0	\N
391757	1874	15449000	29987	14766	10	0	\N
391758	1874	15451000	29987	14766	11	0	\N
391759	1874	15453000	29987	14766	12	0	\N
391760	1874	15455000	29987	14766	13	0	\N
391761	1874	15457000	29987	14766	14	0	\N
391762	1874	15458000	29987	14766	15	0	\N
391763	1874	15462000	29987	14766	16	0	\N
391764	1874	15466000	29987	14766	17	0	\N
391765	1874	15470000	29987	14766	18	0	\N
391780	1678	28800895288000	29989	14766	0	0	\N
391781	1678	28800895289000	29989	14766	1	0	\N
391782	1874	15422000	29989	14766	2	0	\N
391783	1874	15426000	29989	14766	3	0	\N
391784	1874	15430000	29989	14766	4	0	\N
391785	1874	15434000	29989	14766	5	0	\N
391786	1874	15435000	29989	14766	6	0	\N
391787	1874	15439000	29989	14766	7	0	\N
391788	1874	15443000	29989	14766	8	0	\N
391789	1874	15447000	29989	14766	9	0	\N
391790	1874	15449000	29989	14766	10	0	\N
391791	1874	15451000	29989	14766	11	0	\N
391792	1874	15453000	29989	14766	12	0	\N
391793	1874	15455000	29989	14766	13	0	\N
391794	1874	15457000	29989	14766	14	0	\N
391795	1874	15458000	29989	14766	15	0	\N
391796	1874	15462000	29989	14766	16	0	\N
391797	1874	15466000	29989	14766	17	0	\N
391798	1874	15470000	29989	14766	18	0	\N
391813	1678	28800895290000	29991	14767	0	0	\N
391814	1874	15461000	29991	14767	1	0	\N
391815	1874	15465000	29991	14767	2	0	\N
391816	1874	15469000	29991	14767	3	0	\N
391768	1874	15422000	29988	14766	2	0	3
391769	1874	15426000	29988	14766	3	0	3
391770	1874	15430000	29988	14766	4	0	3
391771	1874	15434000	29988	14766	5	0	3
391772	1874	15435000	29988	14766	6	0	3
391774	1874	15443000	29988	14766	8	0	3
391775	1874	15447000	29988	14766	9	0	3
391776	1874	15448000	29988	14766	10	0	3
391777	1874	15452000	29988	14766	11	0	3
391778	1874	15456000	29988	14766	12	0	3
391799	1678	28800895290000	29990	14767	0	0	1
391800	1874	15461000	29990	14767	1	0	3
391801	1874	15465000	29990	14767	2	0	3
391802	1874	15469000	29990	14767	3	0	3
391804	1874	15473000	29990	14767	5	0	3
391805	1874	15475000	29990	14767	6	0	3
391806	1874	15477000	29990	14767	7	0	3
391807	1874	15479000	29990	14767	8	0	3
391808	1874	15481000	29990	14767	9	0	3
391810	1874	15487000	29990	14767	11	0	3
391811	1874	15491000	29990	14767	12	0	3
391812	1874	15495000	29990	14767	13	0	3
391817	1874	15471000	29991	14767	4	0	\N
391818	1874	15473000	29991	14767	5	0	\N
391819	1874	15475000	29991	14767	6	0	\N
391820	1874	15477000	29991	14767	7	0	\N
391821	1874	15479000	29991	14767	8	0	\N
391822	1874	15481000	29991	14767	9	0	\N
391823	1874	15483000	29991	14767	10	0	\N
391824	1874	15487000	29991	14767	11	0	\N
391825	1874	15491000	29991	14767	12	0	\N
391826	1874	15495000	29991	14767	13	0	\N
391837	1678	28800895292000	29993	14769	0	0	\N
391838	1874	15523000	29993	14769	1	0	\N
391839	1874	15524000	29993	14769	2	0	\N
391840	1874	15528000	29993	14769	3	0	\N
391841	1874	15532000	29993	14769	4	0	\N
391842	1874	15536000	29993	14769	5	0	\N
391843	1874	15540000	29993	14769	6	0	\N
391861	1678	28800895293000	29996	14770	0	0	\N
391862	1874	15548000	29996	14770	1	0	\N
391863	1874	15552000	29996	14770	2	0	\N
391864	1874	15553000	29996	14770	3	0	\N
391865	1874	15557000	29996	14770	4	0	\N
391866	1874	15561000	29996	14770	5	0	\N
391867	1678	28800895293000	29997	14770	0	0	\N
391868	1874	15548000	29997	14770	1	0	\N
391869	1874	15552000	29997	14770	2	0	\N
391870	1874	15554000	29997	14770	3	0	\N
391871	1874	15556000	29997	14770	4	0	\N
391872	1874	15557000	29997	14770	5	0	\N
391873	1874	15561000	29997	14770	6	0	\N
391874	1874	15565000	29997	14770	7	0	\N
391894	1678	29520912294000	29999	14771	0	0	\N
391895	1678	29520912295000	29999	14771	1	0	\N
391896	1874	15569000	29999	14771	2	0	\N
391897	1874	15573000	29999	14771	3	0	\N
391898	1874	15577000	29999	14771	4	0	\N
391899	1874	15578000	29999	14771	5	0	\N
391900	1874	15579000	29999	14771	6	0	\N
391901	1874	15583000	29999	14771	8	0	\N
391902	1874	15587000	29999	14771	9	0	\N
391903	1874	15589000	29999	14771	10	0	\N
391904	1874	15593000	29999	14771	11	0	\N
391905	1874	15597000	29999	14771	12	0	\N
391906	1874	15601000	29999	14771	13	0	\N
391907	1874	15602000	29999	14771	14	0	\N
391908	1874	15604000	29999	14771	15	0	\N
391909	1874	15606000	29999	14771	16	0	\N
391910	1874	15608000	29999	14771	17	0	\N
391911	1874	15610000	29999	14771	18	0	\N
391912	1874	15614000	29999	14771	19	0	\N
391923	1678	28800895255000	30001	14734	0	0	\N
391924	1678	28800895256000	30001	14734	1	0	\N
391925	1678	28800895257000	30001	14734	2	0	\N
391926	1678	28800895258000	30001	14734	3	0	\N
391927	1678	28800895259000	30001	14734	4	0	\N
391928	1678	28800895260000	30001	14734	5	0	\N
391929	1678	28800895261000	30001	14734	6	0	\N
391930	1678	28800895262000	30001	14734	7	0	\N
391931	1678	28800895263000	30001	14734	8	0	\N
391932	1678	28800895264000	30001	14734	9	0	\N
391933	1678	28800895265000	30001	14734	10	0	\N
391934	1678	28800895266000	30001	14734	11	0	\N
391935	1678	28800895267000	30001	14734	12	0	\N
391936	1678	28800895268000	30001	14734	13	0	\N
391937	1678	28800895269000	30001	14734	14	0	\N
391938	1678	28800895270000	30001	14734	15	0	\N
391939	1678	28800895271000	30001	14734	16	0	\N
391940	1678	28800895272000	30001	14734	17	0	\N
391941	1678	28800895273000	30001	14734	18	0	\N
391942	1678	28800895274000	30001	14734	19	0	\N
391943	1678	28800895275000	30001	14734	20	0	\N
391944	1678	28800895276000	30001	14734	21	0	\N
391945	1678	28800895277000	30001	14734	22	0	\N
391946	1678	28800895278000	30001	14734	23	0	\N
391947	1678	28800895279000	30001	14734	24	0	\N
391948	1678	28800895280000	30001	14734	25	0	\N
391949	1678	28800895281000	30001	14734	26	0	\N
391950	1678	28800895282000	30001	14734	27	0	\N
391951	1678	28800895283000	30001	14734	28	0	\N
391952	1678	28800895284000	30001	14734	29	0	\N
391829	1874	15503000	29992	14768	2	0	3
391830	1874	15507000	29992	14768	3	0	3
391831	1874	15509000	29992	14768	4	0	3
391832	1874	15511000	29992	14768	5	0	3
391833	1874	15513000	29992	14768	6	0	3
391835	1874	15518000	29992	14768	8	0	3
391836	1874	15519000	29992	14768	9	0	3
391844	1678	28800895292000	29994	14769	0	0	1
391845	1874	15523000	29994	14769	1	0	3
391846	1874	15525000	29994	14769	2	0	3
391848	1874	15528000	29994	14769	4	0	3
391849	1874	15532000	29994	14769	5	0	3
391850	1874	15536000	29994	14769	6	0	3
391851	1874	15540000	29994	14769	7	0	3
391853	1678	28800895293000	29995	14770	0	0	1
391854	1874	15548000	29995	14770	1	0	3
391855	1874	15552000	29995	14770	2	0	3
391856	1874	15554000	29995	14770	3	0	3
391857	1874	15556000	29995	14770	4	0	3
391859	1874	15561000	29995	14770	6	0	3
391860	1874	15565000	29995	14770	7	0	3
391875	1678	29520912294000	29998	14771	0	0	1
391876	1678	29520912295000	29998	14771	1	0	1
391877	1874	15569000	29998	14771	2	0	3
391879	1874	15577000	29998	14771	4	0	3
391880	1874	15578000	29998	14771	5	0	3
391881	1874	15579000	29998	14771	6	0	3
391882	1874	15583000	29998	14771	8	0	3
391884	1874	15589000	29998	14771	10	0	3
391885	1874	15593000	29998	14771	11	0	3
391886	1874	15597000	29998	14771	12	0	3
391887	1874	15601000	29998	14771	13	0	3
391888	1874	15602000	29998	14771	14	0	3
391890	1874	15606000	29998	14771	16	0	3
391891	1874	15608000	29998	14771	17	0	3
391892	1874	15610000	29998	14771	18	0	3
391893	1874	15614000	29998	14771	19	0	3
391913	1678	29520912296000	30000	14772	0	0	1
391915	1874	15618000	30000	14772	2	0	3
391916	1874	15622000	30000	14772	3	0	3
391917	1874	15623000	30000	14772	4	0	3
391918	1874	15627000	30000	14772	5	0	3
391920	1874	15635000	30000	14772	7	0	3
391921	1874	15636000	30000	14772	8	0	3
391922	1874	15638000	30000	14772	9	0	3
391953	1678	28800895285000	30001	14734	30	0	\N
391954	1678	28800895286000	30001	14734	31	0	\N
391955	1678	28800895287000	30001	14734	32	0	\N
391956	1678	28800895288000	30001	14734	33	0	\N
391957	1678	28800895289000	30001	14734	34	0	\N
391958	1678	28800895290000	30001	14734	35	0	\N
391959	1678	28800895291000	30001	14734	36	0	\N
391960	1678	28800895292000	30001	14734	37	0	\N
391961	1678	28800895293000	30001	14734	38	0	\N
391962	1678	28800895294000	30001	14734	39	0	\N
391963	1678	28800895295000	30001	14734	40	0	\N
391964	1678	28800895296000	30001	14734	41	0	\N
391965	1874	14721000	30001	14734	42	0	\N
391966	1874	14723000	30001	14734	43	0	\N
391967	1874	14725000	30001	14734	44	0	\N
391968	1874	14727000	30001	14734	45	0	\N
391969	1874	14729000	30001	14734	46	0	\N
391970	1874	14731000	30001	14734	47	0	\N
391971	1874	14735000	30001	14734	48	0	\N
391972	1874	14736000	30001	14734	49	0	\N
391973	1874	14737000	30001	14734	50	0	\N
391974	1874	14738000	30001	14734	51	0	\N
391975	1874	14739000	30001	14734	52	0	\N
391976	1874	14741000	30001	14734	53	0	\N
391977	1874	14743000	30001	14734	56	0	\N
391978	1874	14745000	30001	14734	57	0	\N
391979	1874	14747000	30001	14734	58	0	\N
391980	2433	100000000	30001	14734	59	0	\N
391981	2434	100000000	30001	14734	60	0	\N
391982	1874	14748000	30001	14734	61	0	\N
391983	1874	14749000	30001	14734	62	0	\N
391984	1874	14750000	30001	14734	63	0	\N
391985	1874	14751000	30001	14734	64	0	\N
391986	1874	14752000	30001	14734	65	0	\N
391987	1874	14753000	30001	14734	66	0	\N
391988	1874	14754000	30001	14734	67	0	\N
391989	1874	14755000	30001	14734	68	0	\N
391990	1874	14756000	30001	14734	69	0	\N
391991	1874	14757000	30001	14734	70	0	\N
391992	1874	14758000	30001	14734	71	0	\N
391993	1874	14759000	30001	14734	72	0	\N
391994	1874	14760000	30001	14734	73	0	\N
391995	1874	14761000	30001	14734	74	0	\N
391996	1874	14762000	30001	14734	75	0	\N
391997	1874	14763000	30001	14734	76	0	\N
391998	1874	14764000	30001	14734	77	0	\N
391999	1874	14765000	30001	14734	78	0	\N
392000	1874	14769000	30001	14734	79	0	\N
392001	1874	14773000	30001	14734	80	0	\N
392002	1874	14777000	30001	14734	81	0	\N
392003	1874	14781000	30001	14734	82	0	\N
392004	1874	14785000	30001	14734	83	0	\N
392005	1874	14789000	30001	14734	84	0	\N
392006	1874	14793000	30001	14734	85	0	\N
392007	1874	14797000	30001	14734	86	0	\N
392008	1874	14801000	30001	14734	87	0	\N
392009	1874	14805000	30001	14734	88	0	\N
392010	1874	14809000	30001	14734	89	0	\N
392011	1874	14813000	30001	14734	90	0	\N
392012	1874	14817000	30001	14734	91	0	\N
392013	1874	14821000	30001	14734	92	0	\N
392014	1874	14825000	30001	14734	93	0	\N
392015	1874	14829000	30001	14734	94	0	\N
392016	1874	14833000	30001	14734	95	0	\N
392017	1874	14837000	30001	14734	96	0	\N
392018	1874	14841000	30001	14734	97	0	\N
392019	1874	14845000	30001	14734	98	0	\N
392020	1874	14849000	30001	14734	99	0	\N
392021	1874	14853000	30001	14734	100	0	\N
392022	1874	14857000	30001	14734	101	0	\N
392023	1874	14861000	30001	14734	102	0	\N
392024	1874	14865000	30001	14734	103	0	\N
392025	1874	14869000	30001	14734	104	0	\N
392026	1874	14873000	30001	14734	105	0	\N
392027	1874	14877000	30001	14734	106	0	\N
392028	1874	14881000	30001	14734	107	0	\N
392029	1874	14885000	30001	14734	108	0	\N
392030	1874	14889000	30001	14734	109	0	\N
392031	1874	14893000	30001	14734	110	0	\N
392032	1874	14897000	30001	14734	111	0	\N
392033	1874	14901000	30001	14734	112	0	\N
392034	1874	14905000	30001	14734	113	0	\N
392035	1874	14909000	30001	14734	114	0	\N
392036	1874	14913000	30001	14734	115	0	\N
392037	1874	14917000	30001	14734	116	0	\N
392038	1874	14921000	30001	14734	117	0	\N
392039	1874	14925000	30001	14734	118	0	\N
392040	1874	14929000	30001	14734	119	0	\N
392041	1874	14933000	30001	14734	120	0	\N
392060	1678	29520912298000	30004	14774	0	0	\N
392061	1874	15665000	30004	14774	1	0	\N
392062	1874	15666000	30004	14774	2	0	\N
392063	1874	15670000	30004	14774	3	0	\N
392064	1874	15674000	30004	14774	4	0	\N
392065	1874	15678000	30004	14774	5	0	\N
392066	1874	15682000	30004	14774	6	0	\N
392067	1874	15684000	30004	14774	7	0	\N
392088	1678	29520912299000	30006	14775	0	0	\N
392044	1874	15646000	30002	14773	2	0	3
392045	1874	15647000	30002	14773	3	0	3
392046	1874	15649000	30002	14773	4	0	3
392047	1874	15651000	30002	14773	5	0	3
392048	1874	15655000	30002	14773	6	0	3
392050	1874	15663000	30002	14773	8	0	3
392051	1678	29520912298000	30003	14774	0	0	1
392052	1874	15665000	30003	14774	1	0	3
392053	1874	15666000	30003	14774	2	0	3
392054	1874	15667000	30003	14774	3	0	3
392056	1874	15675000	30003	14774	5	0	3
392057	1874	15679000	30003	14774	6	0	3
392058	1874	15683000	30003	14774	7	0	3
392059	1874	15685000	30003	14774	8	0	3
392069	1678	29520912300000	30005	14775	1	0	1
392070	1874	15687000	30005	14775	2	0	3
392071	1874	15688000	30005	14775	3	0	3
392072	1874	15689000	30005	14775	4	0	3
392073	1874	15690000	30005	14775	5	0	3
392075	1874	15694000	30005	14775	7	0	3
392076	1874	15696000	30005	14775	8	0	3
392077	1874	15698000	30005	14775	9	0	3
392078	1874	15700000	30005	14775	10	0	3
392079	1874	15704000	30005	14775	11	0	3
392081	1874	15712000	30005	14775	13	0	3
392082	1874	15716000	30005	14775	14	0	3
392083	1874	15720000	30005	14775	15	0	3
392084	1874	15724000	30005	14775	16	0	3
392086	1874	15732000	30005	14775	18	0	3
392087	1874	15736000	30005	14775	19	0	3
392089	1678	29520912300000	30006	14775	1	0	\N
392090	1874	15687000	30006	14775	2	0	\N
392091	1874	15688000	30006	14775	3	0	\N
392092	1874	15689000	30006	14775	4	0	\N
392093	1874	15690000	30006	14775	5	0	\N
392094	1874	15692000	30006	14775	6	0	\N
392095	1874	15694000	30006	14775	7	0	\N
392096	1874	15696000	30006	14775	8	0	\N
392097	1874	15698000	30006	14775	9	0	\N
392098	1874	15700000	30006	14775	10	0	\N
392099	1874	15704000	30006	14775	11	0	\N
392100	1874	15708000	30006	14775	12	0	\N
392101	1874	15712000	30006	14775	13	0	\N
392102	1874	15716000	30006	14775	14	0	\N
392103	1874	15720000	30006	14775	15	0	\N
392104	1874	15724000	30006	14775	16	0	\N
392105	1874	15728000	30006	14775	17	0	\N
392106	1874	15732000	30006	14775	18	0	\N
392107	1874	15736000	30006	14775	19	0	\N
392127	1678	29520912302000	30009	14777	0	0	\N
392128	1874	15764000	30009	14777	1	0	\N
392129	1874	15765000	30009	14777	2	0	\N
392130	1874	15767000	30009	14777	3	0	\N
392131	1874	15771000	30009	14777	4	0	\N
392132	1874	15775000	30009	14777	5	0	\N
392133	1874	15779000	30009	14777	6	0	\N
392134	1874	15783000	30009	14777	7	0	\N
392135	1874	15785000	30009	14777	8	0	\N
392136	1678	29520912302000	30010	14777	0	0	\N
392137	1874	15764000	30010	14777	1	0	\N
392138	1874	15765000	30010	14777	2	0	\N
392139	1874	15767000	30010	14777	3	0	\N
392140	1874	15771000	30010	14777	4	0	\N
392141	1874	15775000	30010	14777	5	0	\N
392142	1874	15779000	30010	14777	6	0	\N
392143	1874	15783000	30010	14777	7	0	\N
392144	1874	15785000	30010	14777	8	0	\N
392201	1678	29520912309000	30016	14782	0	0	\N
392202	1678	29520912310000	30016	14782	1	0	\N
392203	1678	29520912311000	30016	14782	2	0	\N
392204	1874	15932000	30016	14782	3	0	\N
392205	1874	15934000	30016	14782	4	0	\N
392206	1874	15935000	30016	14782	5	0	\N
392207	1874	15936000	30016	14782	6	0	\N
392208	1874	15937000	30016	14782	7	0	\N
392209	1874	15938000	30016	14782	8	0	\N
392210	1874	15940000	30016	14782	9	0	\N
392211	1874	15942000	30016	14782	10	0	\N
392212	1874	15944000	30016	14782	11	0	\N
392213	1874	15946000	30016	14782	12	0	\N
392214	1874	15948000	30016	14782	13	0	\N
392215	1874	15950000	30016	14782	14	0	\N
392216	1874	15952000	30016	14782	15	0	\N
392217	1874	15954000	30016	14782	16	0	\N
392218	1874	15958000	30016	14782	17	0	\N
392219	1874	15962000	30016	14782	18	0	\N
392220	1874	15966000	30016	14782	19	0	\N
392221	1874	15970000	30016	14782	20	0	\N
392222	1874	15974000	30016	14782	21	0	\N
392223	1874	15978000	30016	14782	22	0	\N
392224	1874	15982000	30016	14782	23	0	\N
392110	1874	15739000	30007	14776	2	0	3
392111	1874	15743000	30007	14776	3	0	3
392112	1874	15747000	30007	14776	4	0	3
392113	1874	15751000	30007	14776	5	0	3
392114	1874	15755000	30007	14776	6	0	3
392116	1874	15761000	30007	14776	8	0	3
392117	1874	15763000	30007	14776	9	0	3
392118	1678	29520912302000	30008	14777	0	0	1
392119	1874	15764000	30008	14777	1	0	3
392120	1874	15765000	30008	14777	2	0	3
392122	1874	15771000	30008	14777	4	0	3
392123	1874	15775000	30008	14777	5	0	3
392124	1874	15779000	30008	14777	6	0	3
392125	1874	15783000	30008	14777	7	0	3
392145	1678	29520912303000	30011	14778	0	0	1
392146	1678	29520912304000	30011	14778	1	0	1
392147	1678	29520912305000	30011	14778	2	0	1
392148	1874	15786000	30011	14778	3	0	3
392149	1874	15790000	30011	14778	4	0	3
392151	1874	15794000	30011	14778	6	0	3
392152	1874	15796000	30011	14778	7	0	3
392153	1874	15798000	30011	14778	8	0	3
392154	1874	15800000	30011	14778	9	0	3
392155	1874	15802000	30011	14778	10	0	3
392157	1874	15806000	30011	14778	12	0	3
392158	1874	15810000	30011	14778	13	0	3
392159	1874	15814000	30011	14778	14	0	3
392160	1874	15818000	30011	14778	15	0	3
392162	1874	15826000	30011	14778	17	0	3
392163	1874	15827000	30011	14778	18	0	3
392164	1874	15828000	30011	14778	19	0	3
392165	1874	15829000	30011	14778	20	0	3
392166	1874	15833000	30011	14778	21	0	3
392168	1874	15841000	30011	14778	23	0	3
392169	1874	15845000	30011	14778	24	0	3
392170	1874	15849000	30011	14778	25	0	3
392171	1874	15853000	30011	14778	26	0	3
392172	1874	15857000	30011	14778	27	0	3
392174	1678	29520912306000	30012	14779	0	0	1
392175	1874	15863000	30012	14779	1	0	3
392176	1874	15865000	30012	14779	2	0	3
392177	1874	15866000	30012	14779	3	0	3
392179	1874	15871000	30012	14779	5	0	3
392180	1874	15875000	30012	14779	6	0	3
392181	1874	15879000	30012	14779	7	0	3
392182	1874	15883000	30012	14779	8	0	3
392183	1678	29520912307000	30013	14780	0	0	1
392185	1874	15887000	30013	14780	2	0	3
392186	1874	15889000	30013	14780	3	0	3
392187	1874	15890000	30013	14780	4	0	3
392188	1874	15894000	30013	14780	5	0	3
392189	1874	15898000	30013	14780	6	0	3
392191	1874	15906000	30013	14780	8	0	3
392192	1678	29520912308000	30014	14781	0	0	1
392193	1874	15910000	30014	14781	1	0	3
392194	1874	15914000	30014	14781	2	0	3
392196	1874	15919000	30014	14781	4	0	3
392197	1874	15921000	30014	14781	5	0	3
392198	1874	15925000	30014	14781	6	0	3
392199	1874	15929000	30014	14781	7	0	3
392200	1874	15931000	30014	14781	8	0	3
392225	1874	15986000	30016	14782	24	0	\N
392226	1874	15990000	30016	14782	25	0	\N
392227	1874	15994000	30016	14782	26	0	\N
392228	1874	15998000	30016	14782	27	0	\N
392229	1874	16002000	30016	14782	28	0	\N
392230	1874	16006000	30016	14782	29	0	\N
392231	1678	29520912309000	30017	14782	0	0	\N
392232	1678	29520912310000	30017	14782	1	0	\N
392233	1678	29520912311000	30017	14782	2	0	\N
392234	1874	15932000	30017	14782	3	0	\N
392235	1874	15934000	30017	14782	4	0	\N
392236	1874	15935000	30017	14782	5	0	\N
392237	1874	15936000	30017	14782	6	0	\N
392238	1874	15937000	30017	14782	7	0	\N
392239	1874	15938000	30017	14782	8	0	\N
392240	1874	15940000	30017	14782	9	0	\N
392241	1874	15942000	30017	14782	10	0	\N
392242	1874	15944000	30017	14782	11	0	\N
392243	1874	15946000	30017	14782	12	0	\N
392244	1874	15948000	30017	14782	13	0	\N
392245	1874	15950000	30017	14782	14	0	\N
392246	1874	15952000	30017	14782	15	0	\N
392247	1874	15954000	30017	14782	16	0	\N
392248	1874	15958000	30017	14782	17	0	\N
392249	1874	15962000	30017	14782	18	0	\N
392250	1874	15966000	30017	14782	19	0	\N
392251	1874	15970000	30017	14782	20	0	\N
392252	1874	15974000	30017	14782	21	0	\N
392253	1874	15978000	30017	14782	22	0	\N
392254	1874	15982000	30017	14782	23	0	\N
392255	1874	15986000	30017	14782	24	0	\N
392256	1874	15990000	30017	14782	25	0	\N
392257	1874	15994000	30017	14782	26	0	\N
392258	1874	15998000	30017	14782	27	0	\N
392259	1874	16002000	30017	14782	28	0	\N
392260	1874	16006000	30017	14782	29	0	\N
392261	1678	29520912309000	30019	14782	0	0	\N
392262	1678	29520912310000	30019	14782	1	0	\N
392263	1678	29520912311000	30019	14782	2	0	\N
392264	1874	15932000	30019	14782	3	0	\N
392265	1874	15934000	30019	14782	4	0	\N
392266	1874	15935000	30019	14782	5	0	\N
392267	1874	15936000	30019	14782	6	0	\N
392268	1874	15937000	30019	14782	7	0	\N
392269	1874	15938000	30019	14782	8	0	\N
392270	1874	15940000	30019	14782	9	0	\N
392271	1874	15942000	30019	14782	10	0	\N
392272	1874	15944000	30019	14782	11	0	\N
392273	1874	15946000	30019	14782	12	0	\N
392274	1874	15948000	30019	14782	13	0	\N
392275	1874	15950000	30019	14782	14	0	\N
392276	1874	15952000	30019	14782	15	0	\N
392277	1874	15954000	30019	14782	16	0	\N
392278	1874	15958000	30019	14782	17	0	\N
392279	1874	15962000	30019	14782	18	0	\N
392280	1874	15966000	30019	14782	19	0	\N
392281	1874	15970000	30019	14782	20	0	\N
392282	1874	15974000	30019	14782	21	0	\N
392283	1874	15978000	30019	14782	22	0	\N
392284	1874	15982000	30019	14782	23	0	\N
392285	1874	15986000	30019	14782	24	0	\N
392286	1874	15990000	30019	14782	25	0	\N
392287	1874	15994000	30019	14782	26	0	\N
392288	1874	15998000	30019	14782	27	0	\N
392289	1874	16002000	30019	14782	28	0	\N
392290	1874	16006000	30019	14782	29	0	\N
392321	1678	29520912312000	30024	14783	0	0	\N
392322	1874	16010000	30024	14783	1	0	\N
392323	1874	16012000	30024	14783	2	0	\N
392324	1874	16016000	30024	14783	3	0	\N
392325	1874	16020000	30024	14783	4	0	\N
392326	1874	16024000	30024	14783	5	0	\N
392327	1874	16026000	30024	14783	6	0	\N
392328	1874	16027000	30024	14783	7	0	\N
392336	1678	29520912312000	30026	14783	0	0	\N
392337	1874	16007000	30026	14783	1	0	\N
392338	1678	29520912312000	30027	14783	0	0	\N
392339	1874	16008000	30027	14783	1	0	\N
392340	1874	16010000	30027	14783	2	0	\N
392341	1874	16011000	30027	14783	3	0	\N
392348	1678	29520912313000	30029	14784	0	0	\N
392349	1874	16025000	30029	14784	1	0	\N
392350	1874	16029000	30029	14784	2	0	\N
392351	1874	16030000	30029	14784	3	0	\N
392352	1874	16031000	30029	14784	4	0	\N
392293	1678	29520912311000	30020	14782	2	0	1
392294	1874	15932000	30020	14782	3	0	3
392295	1874	15934000	30020	14782	4	0	3
392296	1874	15935000	30020	14782	5	0	3
392297	1874	15936000	30020	14782	6	0	3
392299	1874	15938000	30020	14782	8	0	3
392300	1874	15940000	30020	14782	9	0	3
392301	1874	15942000	30020	14782	10	0	3
392302	1874	15944000	30020	14782	11	0	3
392303	1874	15946000	30020	14782	12	0	3
392305	1874	15950000	30020	14782	14	0	3
392306	1874	15952000	30020	14782	15	0	3
392307	1874	15954000	30020	14782	16	0	3
392308	1874	15958000	30020	14782	17	0	3
392310	1874	15966000	30020	14782	19	0	3
392311	1874	15970000	30020	14782	20	0	3
392312	1874	15974000	30020	14782	21	0	3
392313	1874	15978000	30020	14782	22	0	3
392314	1874	15982000	30020	14782	23	0	3
392316	1874	15990000	30020	14782	25	0	3
392317	1874	15994000	30020	14782	26	0	3
392318	1874	15998000	30020	14782	27	0	3
392319	1874	16002000	30020	14782	28	0	3
392320	1874	16006000	30020	14782	29	0	3
392330	1874	16010000	30025	14783	1	0	3
392331	1874	16012000	30025	14783	2	0	3
392332	1874	16016000	30025	14783	3	0	3
392333	1874	16020000	30025	14783	4	0	3
392335	1874	16023000	30025	14783	6	0	3
392342	1678	29520912313000	30028	14784	0	0	1
392343	1874	16025000	30028	14784	1	0	3
392344	1874	16029000	30028	14784	2	0	3
392345	1874	16030000	30028	14784	3	0	3
392347	1874	16033000	30028	14784	5	0	3
392353	1678	29520912314000	30030	14785	0	0	1
392354	1874	16037000	30030	14785	1	0	3
392355	1874	16041000	30030	14785	2	0	3
392356	1874	16045000	30030	14785	3	0	3
392358	1874	16053000	30030	14785	5	0	3
392359	1874	16057000	30030	14785	6	0	3
392360	1874	16061000	30030	14785	7	0	3
392385	1678	29520912315000	30032	14786	0	0	\N
392386	1678	29520912316000	30032	14786	1	0	\N
392387	1874	16075000	30032	14786	2	0	\N
392388	1874	16077000	30032	14786	3	0	\N
392389	1874	16079000	30032	14786	4	0	\N
392390	1874	16081000	30032	14786	5	0	\N
392391	1874	16083000	30032	14786	6	0	\N
392392	1874	16085000	30032	14786	7	0	\N
392393	1874	16089000	30032	14786	8	0	\N
392394	1874	16093000	30032	14786	9	0	\N
392395	1874	16097000	30032	14786	10	0	\N
392396	1874	16101000	30032	14786	11	0	\N
392397	1874	16102000	30032	14786	12	0	\N
392398	1874	16103000	30032	14786	13	0	\N
392399	1874	16107000	30032	14786	14	0	\N
392400	1874	16111000	30032	14786	15	0	\N
392401	1874	16115000	30032	14786	16	0	\N
392402	1874	16119000	30032	14786	17	0	\N
392403	1874	16123000	30032	14786	18	0	\N
392433	1678	29520912319000	30035	14788	0	0	\N
392434	1874	16172000	30035	14788	1	0	\N
392435	1874	16174000	30035	14788	2	0	\N
392436	1874	16176000	30035	14788	3	0	\N
392437	1874	16178000	30035	14788	4	0	\N
392438	1874	16182000	30035	14788	5	0	\N
392439	1874	16186000	30035	14788	6	0	\N
392440	1874	16187000	30035	14788	7	0	\N
392441	1874	16191000	30035	14788	8	0	\N
392442	1874	16195000	30035	14788	9	0	\N
392443	1874	16196000	30035	14788	10	0	\N
392444	2433	100000000	30036	14669	0	0	\N
392445	2434	100000000	30036	14669	1	0	\N
392446	1678	29520912320000	30037	14789	0	0	\N
392447	1874	16200000	30037	14789	1	0	\N
392448	1874	16201000	30037	14789	2	0	\N
392449	2435	100000000	30037	14789	3	0	\N
392450	2436	100000000	30037	14789	4	0	\N
392451	1874	16205000	30037	14789	5	0	\N
392452	1874	16209000	30037	14789	6	0	\N
392453	1874	16213000	30037	14789	7	0	\N
392454	1874	16215000	30037	14789	8	0	\N
392455	1874	16217000	30037	14789	9	0	\N
392466	596	86338432000000	30039	14790	0	0	\N
392467	1678	29520912321000	30039	14790	1	0	\N
392468	1678	29520912322000	30039	14790	2	0	\N
392469	1874	16221000	30039	14790	3	0	\N
392470	1874	16225000	30039	14790	4	0	\N
392471	1874	16229000	30039	14790	5	0	\N
392472	1874	16233000	30039	14790	6	0	\N
392473	1874	16234000	30039	14790	7	0	\N
392474	1874	16236000	30039	14790	8	0	\N
392475	1874	16238000	30039	14790	9	0	\N
392476	1874	16240000	30039	14790	10	0	\N
392477	1874	16242000	30039	14790	11	0	\N
392478	355	66000100000000	30039	14790	12	0	\N
392479	1874	16244000	30039	14790	13	0	\N
392480	1874	16246000	30039	14790	14	0	\N
392481	1874	16250000	30039	14790	15	0	\N
392482	1874	16254000	30039	14790	16	0	\N
392483	1874	16258000	30039	14790	17	0	\N
392484	1874	16262000	30039	14790	18	0	\N
392485	1874	16266000	30039	14790	19	0	\N
392486	1874	16267000	30039	14790	20	0	\N
392487	1874	16268000	30039	14790	21	0	\N
392363	1874	16071000	30030	14785	10	0	3
392364	1874	16073000	30030	14785	11	0	3
392365	1874	16074000	30030	14785	12	0	3
392366	1678	29520912315000	30031	14786	0	0	1
392367	1678	29520912316000	30031	14786	1	0	1
392369	1874	16077000	30031	14786	3	0	3
392370	1874	16079000	30031	14786	4	0	3
392371	1874	16081000	30031	14786	5	0	3
392372	1874	16083000	30031	14786	6	0	3
392373	1874	16085000	30031	14786	7	0	3
392375	1874	16093000	30031	14786	9	0	3
392376	1874	16097000	30031	14786	10	0	3
392377	1874	16101000	30031	14786	11	0	3
392378	1874	16102000	30031	14786	12	0	3
392380	1874	16107000	30031	14786	14	0	3
392381	1874	16111000	30031	14786	15	0	3
392382	1874	16115000	30031	14786	16	0	3
392383	1874	16119000	30031	14786	17	0	3
392384	1874	16123000	30031	14786	18	0	3
392405	1678	29520912318000	30033	14787	1	0	1
392406	1874	16125000	30033	14787	2	0	3
392407	1874	16126000	30033	14787	3	0	3
392408	1874	16128000	30033	14787	5	0	3
392409	1874	16132000	30033	14787	6	0	3
392411	1874	16137000	30033	14787	8	0	3
392412	1874	16138000	30033	14787	9	0	3
392413	1874	16140000	30033	14787	10	0	3
392414	1874	16142000	30033	14787	11	0	3
392416	1874	16148000	30033	14787	13	0	3
392417	1874	16152000	30033	14787	14	0	3
392418	1874	16156000	30033	14787	15	0	3
392419	1874	16160000	30033	14787	16	0	3
392420	1874	16164000	30033	14787	17	0	3
392422	1678	29520912319000	30034	14788	0	0	1
392423	1874	16172000	30034	14788	1	0	3
392424	1874	16174000	30034	14788	2	0	3
392425	1874	16176000	30034	14788	3	0	3
392426	1874	16178000	30034	14788	4	0	3
392428	1874	16186000	30034	14788	6	0	3
392429	1874	16187000	30034	14788	7	0	3
392430	1874	16191000	30034	14788	8	0	3
392431	1874	16195000	30034	14788	9	0	3
392456	1678	29520912320000	30038	14789	0	0	1
392457	1874	16200000	30038	14789	1	0	3
392458	1874	16201000	30038	14789	2	0	3
392459	2435	100000000	30038	14789	3	0	0
392460	2436	100000000	30038	14789	4	0	0
392462	1874	16209000	30038	14789	6	0	3
392463	1874	16213000	30038	14789	7	0	3
392464	1874	16215000	30038	14789	8	0	3
392465	1874	16217000	30038	14789	9	0	3
392488	596	86338432000000	30040	14790	0	0	8
392490	1678	29520912322000	30040	14790	2	0	1
392491	1874	16221000	30040	14790	3	0	3
392492	1874	16225000	30040	14790	4	0	3
392493	1874	16229000	30040	14790	5	0	3
392495	1874	16234000	30040	14790	7	0	3
392496	1874	16236000	30040	14790	8	0	3
392510	596	86338432000000	30041	14790	0	0	\N
392511	1678	29520912321000	30041	14790	1	0	\N
392512	1678	29520912322000	30041	14790	2	0	\N
392513	1874	16221000	30041	14790	3	0	\N
392514	1874	16225000	30041	14790	4	0	\N
392515	1874	16229000	30041	14790	5	0	\N
392516	1874	16233000	30041	14790	6	0	\N
392517	1874	16234000	30041	14790	7	0	\N
392518	1874	16236000	30041	14790	8	0	\N
392519	1874	16238000	30041	14790	9	0	\N
392520	1874	16240000	30041	14790	10	0	\N
392521	1874	16242000	30041	14790	11	0	\N
392522	355	66000100000000	30041	14790	12	0	\N
392523	1874	16244000	30041	14790	13	0	\N
392524	1874	16246000	30041	14790	14	0	\N
392525	1874	16250000	30041	14790	15	0	\N
392526	1874	16254000	30041	14790	16	0	\N
392527	1874	16258000	30041	14790	17	0	\N
392528	1874	16262000	30041	14790	18	0	\N
392529	1874	16266000	30041	14790	19	0	\N
392530	1874	16267000	30041	14790	20	0	\N
392531	1874	16268000	30041	14790	21	0	\N
392532	1678	29520912323000	30042	14791	0	0	\N
392533	1678	29520912324000	30042	14791	1	0	\N
392534	1874	16270000	30042	14791	2	0	\N
392535	1874	16271000	30042	14791	3	0	\N
392536	1874	16275000	30042	14791	4	0	\N
392537	2437	100000000	30042	14791	6	0	\N
392538	1874	16279000	30042	14791	7	0	\N
392539	1874	16283000	30042	14791	8	0	\N
392540	1874	16287000	30042	14791	9	0	\N
392541	1874	16291000	30042	14791	10	0	\N
392542	1874	16295000	30042	14791	11	0	\N
392543	1874	16299000	30042	14791	12	0	\N
392544	1874	16303000	30042	14791	13	0	\N
392545	1874	16307000	30042	14791	14	0	\N
392546	1874	16309000	30042	14791	15	0	\N
392547	1874	16311000	30042	14791	16	0	\N
392548	1874	16313000	30042	14791	17	0	\N
392549	1874	16315000	30042	14791	18	0	\N
392550	1874	16316000	30042	14791	19	0	\N
392551	1874	16317000	30042	14791	20	0	\N
392552	1678	29520912323000	30043	14791	0	0	\N
392553	1678	29520912324000	30043	14791	1	0	\N
392554	1874	16270000	30043	14791	2	0	\N
392555	1874	16271000	30043	14791	3	0	\N
392556	1874	16275000	30043	14791	4	0	\N
392557	2437	100000000	30043	14791	6	0	\N
392558	1874	16279000	30043	14791	7	0	\N
392559	1874	16283000	30043	14791	8	0	\N
392560	1874	16287000	30043	14791	9	0	\N
392561	1874	16291000	30043	14791	10	0	\N
392562	1874	16295000	30043	14791	11	0	\N
392563	1874	16299000	30043	14791	12	0	\N
392564	1874	16303000	30043	14791	13	0	\N
392565	1874	16307000	30043	14791	14	0	\N
392566	1874	16309000	30043	14791	15	0	\N
392567	1874	16311000	30043	14791	16	0	\N
392568	1874	16313000	30043	14791	17	0	\N
392569	1874	16315000	30043	14791	18	0	\N
392570	1874	16316000	30043	14791	19	0	\N
392571	1874	16317000	30043	14791	20	0	\N
392612	1678	29520912325000	30046	14792	0	0	\N
392613	1678	29520912326000	30046	14792	1	0	\N
392614	155	66000435000000	30046	14792	2	0	\N
392615	1874	16318000	30046	14792	3	0	\N
392616	1874	16319000	30046	14792	4	0	\N
392617	1874	16320000	30046	14792	5	0	\N
392618	1874	16324000	30046	14792	6	0	\N
392619	1874	16328000	30046	14792	7	0	\N
392620	1874	16332000	30046	14792	8	0	\N
392621	1874	16336000	30046	14792	9	0	\N
392622	1874	16338000	30046	14792	10	0	\N
392623	1874	16340000	30046	14792	11	0	\N
392624	1874	16342000	30046	14792	12	0	\N
392625	1874	16344000	30046	14792	13	0	\N
392626	1874	16346000	30046	14792	14	0	\N
392627	1874	16350000	30046	14792	15	0	\N
392628	1874	16354000	30046	14792	16	0	\N
392629	1874	16358000	30046	14792	17	0	\N
392630	1874	16362000	30046	14792	18	0	\N
392631	1874	16366000	30046	14792	19	0	\N
392632	1678	29520912325000	30047	14792	0	0	\N
392499	1874	16242000	30040	14790	11	0	3
392500	355	66000100000000	30040	14790	12	0	0
392501	1874	16244000	30040	14790	13	0	3
392502	1874	16246000	30040	14790	14	0	3
392503	1874	16250000	30040	14790	15	0	3
392505	1874	16258000	30040	14790	17	0	3
392506	1874	16262000	30040	14790	18	0	3
392507	1874	16266000	30040	14790	19	0	3
392508	1874	16267000	30040	14790	20	0	3
392509	1874	16268000	30040	14790	21	0	3
392573	1678	29520912324000	30044	14791	1	0	1
392574	1874	16270000	30044	14791	2	0	3
392575	1874	16271000	30044	14791	3	0	3
392576	1874	16275000	30044	14791	4	0	3
392578	1874	16279000	30044	14791	7	0	3
392579	1874	16283000	30044	14791	8	0	3
392580	1874	16287000	30044	14791	9	0	3
392581	1874	16291000	30044	14791	10	0	3
392582	1874	16295000	30044	14791	11	0	3
392584	1874	16303000	30044	14791	13	0	3
392585	1874	16307000	30044	14791	14	0	3
392586	1874	16309000	30044	14791	15	0	3
392587	1874	16311000	30044	14791	16	0	3
392588	1874	16313000	30044	14791	17	0	3
392590	1874	16316000	30044	14791	19	0	3
392591	1874	16317000	30044	14791	20	0	3
392592	1678	29520912325000	30045	14792	0	0	1
392593	1678	29520912326000	30045	14792	1	0	1
392595	1874	16318000	30045	14792	3	0	3
392596	1874	16319000	30045	14792	4	0	3
392597	1874	16320000	30045	14792	5	0	3
392598	1874	16324000	30045	14792	6	0	3
392599	1874	16328000	30045	14792	7	0	3
392601	1874	16336000	30045	14792	9	0	3
392602	1874	16338000	30045	14792	10	0	3
392603	1874	16340000	30045	14792	11	0	3
392604	1874	16342000	30045	14792	12	0	3
392605	1874	16344000	30045	14792	13	0	3
392607	1874	16350000	30045	14792	15	0	3
392608	1874	16354000	30045	14792	16	0	3
392609	1874	16358000	30045	14792	17	0	3
392610	1874	16362000	30045	14792	18	0	3
392633	1678	29520912326000	30047	14792	1	0	\N
392634	155	66000435000000	30047	14792	2	0	\N
392635	1874	16318000	30047	14792	3	0	\N
392636	1874	16319000	30047	14792	4	0	\N
392637	1874	16320000	30047	14792	5	0	\N
392638	1874	16324000	30047	14792	6	0	\N
392639	1874	16328000	30047	14792	7	0	\N
392640	1874	16332000	30047	14792	8	0	\N
392641	1874	16336000	30047	14792	9	0	\N
392642	1874	16338000	30047	14792	10	0	\N
392643	1874	16340000	30047	14792	11	0	\N
392644	1874	16342000	30047	14792	12	0	\N
392645	1874	16344000	30047	14792	13	0	\N
392646	1874	16346000	30047	14792	14	0	\N
392647	1874	16350000	30047	14792	15	0	\N
392648	1874	16354000	30047	14792	16	0	\N
392649	1874	16358000	30047	14792	17	0	\N
392650	1874	16362000	30047	14792	18	0	\N
392651	1874	16366000	30047	14792	19	0	\N
392652	1678	29520912327000	30048	14793	0	0	\N
392653	1874	16367000	30048	14793	1	0	\N
392654	1874	16368000	30048	14793	2	0	\N
392655	1874	16372000	30048	14793	3	0	\N
392656	1874	16374000	30048	14793	4	0	\N
392657	1874	16376000	30048	14793	5	0	\N
392658	1874	16378000	30048	14793	6	0	\N
392659	1874	16382000	30048	14793	7	0	\N
392660	1874	16386000	30048	14793	8	0	\N
392661	1874	16390000	30048	14793	9	0	\N
392672	1678	29520912328000	30051	14795	0	0	\N
392673	1678	29520912329000	30051	14795	1	0	\N
392674	1874	16392000	30051	14795	2	0	\N
392675	1874	16393000	30051	14795	3	0	\N
392676	1874	16394000	30051	14795	4	0	\N
392677	1874	16396000	30051	14795	5	0	\N
392678	1874	16398000	30051	14795	6	0	\N
392679	1874	16400000	30051	14795	7	0	\N
392680	1874	16404000	30051	14795	8	0	\N
392681	1874	16408000	30051	14795	9	0	\N
392682	1874	16412000	30051	14795	10	0	\N
392683	1874	16416000	30051	14795	11	0	\N
392684	1874	16420000	30051	14795	12	0	\N
392685	1874	16424000	30051	14795	13	0	\N
392686	1874	16428000	30051	14795	14	0	\N
392687	1874	16432000	30051	14795	15	0	\N
392688	1874	16436000	30051	14795	16	0	\N
392716	1678	29520912330000	30054	14796	0	0	\N
392717	1874	16440000	30054	14796	1	0	\N
392718	1874	16442000	30054	14796	2	0	\N
392719	1874	16444000	30054	14796	3	0	\N
392720	1874	16445000	30054	14796	4	0	\N
392721	1874	16446000	30054	14796	5	0	\N
392722	1874	16450000	30054	14796	6	0	\N
392723	1874	16454000	30054	14796	7	0	\N
392724	1874	16458000	30054	14796	8	0	\N
392725	2041	2879100000000	30054	14796	9	0	\N
392726	1678	29520912331000	30055	14797	0	0	\N
392727	1678	29520912332000	30055	14797	1	0	\N
392728	1874	16462000	30055	14797	2	0	\N
392729	1874	16463000	30055	14797	3	0	\N
392730	1874	16465000	30055	14797	4	0	\N
392731	1874	16467000	30055	14797	5	0	\N
392732	1874	16469000	30055	14797	6	0	\N
392733	1874	16471000	30055	14797	7	0	\N
392734	1874	16473000	30055	14797	8	0	\N
392735	1874	16475000	30055	14797	9	0	\N
392736	1874	16479000	30055	14797	10	0	\N
392737	1874	16480000	30055	14797	11	0	\N
392738	1874	16484000	30055	14797	12	0	\N
392739	1874	16488000	30055	14797	13	0	\N
392740	1874	16492000	30055	14797	14	0	\N
392741	1874	16496000	30055	14797	15	0	\N
392742	1874	16500000	30055	14797	16	0	\N
392743	1874	16501000	30055	14797	17	0	\N
392744	1874	16505000	30055	14797	18	0	\N
392745	1874	16509000	30055	14797	19	0	\N
392766	1678	29520912331000	30057	14797	0	0	\N
392767	1678	29520912332000	30057	14797	1	0	\N
392768	1874	16462000	30057	14797	2	0	\N
392664	1874	16368000	30049	14793	2	0	3
392665	1874	16372000	30049	14793	3	0	3
392666	1874	16374000	30049	14793	4	0	3
392667	1874	16376000	30049	14793	5	0	3
392668	1874	16378000	30049	14793	6	0	3
392670	1874	16386000	30049	14793	8	0	3
392671	1874	16390000	30049	14793	9	0	3
392689	1678	29520912328000	30052	14795	0	0	1
392690	1678	29520912329000	30052	14795	1	0	1
392691	1874	16392000	30052	14795	2	0	3
392693	1874	16394000	30052	14795	4	0	3
392694	1874	16396000	30052	14795	5	0	3
392695	1874	16398000	30052	14795	6	0	3
392696	1874	16400000	30052	14795	7	0	3
392698	1874	16408000	30052	14795	9	0	3
392699	1874	16412000	30052	14795	10	0	3
392700	1874	16416000	30052	14795	11	0	3
392701	1874	16420000	30052	14795	12	0	3
392702	1874	16424000	30052	14795	13	0	3
392704	1874	16432000	30052	14795	15	0	3
392705	1874	16436000	30052	14795	16	0	3
392706	1678	29520912330000	30053	14796	0	0	1
392707	1874	16440000	30053	14796	1	0	3
392708	1874	16442000	30053	14796	2	0	3
392710	1874	16445000	30053	14796	4	0	3
392711	1874	16446000	30053	14796	5	0	3
392712	1874	16450000	30053	14796	6	0	3
392713	1874	16454000	30053	14796	7	0	3
392715	2041	2879100000000	30053	14796	9	0	2
392746	1678	29520912331000	30056	14797	0	0	1
392747	1678	29520912332000	30056	14797	1	0	1
392748	1874	16462000	30056	14797	2	0	3
392749	1874	16463000	30056	14797	3	0	3
392751	1874	16467000	30056	14797	5	0	3
392752	1874	16469000	30056	14797	6	0	3
392753	1874	16471000	30056	14797	7	0	3
392754	1874	16473000	30056	14797	8	0	3
392755	1874	16475000	30056	14797	9	0	3
392757	1874	16480000	30056	14797	11	0	3
392758	1874	16484000	30056	14797	12	0	3
392759	1874	16488000	30056	14797	13	0	3
392760	1874	16492000	30056	14797	14	0	3
392762	1874	16500000	30056	14797	16	0	3
392763	1874	16501000	30056	14797	17	0	3
392764	1874	16505000	30056	14797	18	0	3
392765	1874	16509000	30056	14797	19	0	3
392769	1874	16463000	30057	14797	3	0	\N
392770	1874	16465000	30057	14797	4	0	\N
392771	1874	16467000	30057	14797	5	0	\N
392772	1874	16469000	30057	14797	6	0	\N
392773	1874	16471000	30057	14797	7	0	\N
392774	1874	16473000	30057	14797	8	0	\N
392775	1874	16475000	30057	14797	9	0	\N
392776	1874	16479000	30057	14797	10	0	\N
392777	1874	16480000	30057	14797	11	0	\N
392778	1874	16484000	30057	14797	12	0	\N
392779	1874	16488000	30057	14797	13	0	\N
392780	1874	16492000	30057	14797	14	0	\N
392781	1874	16496000	30057	14797	15	0	\N
392782	1874	16500000	30057	14797	16	0	\N
392783	1874	16501000	30057	14797	17	0	\N
392784	1874	16505000	30057	14797	18	0	\N
392785	1874	16509000	30057	14797	19	0	\N
392805	1678	29520912333000	30059	14798	0	0	\N
392806	1678	29520912334000	30059	14798	1	0	\N
392807	1874	16513000	30059	14798	2	0	\N
392808	1874	16515000	30059	14798	3	0	\N
392809	1874	16517000	30059	14798	4	0	\N
392810	1874	16519000	30059	14798	5	0	\N
392811	1874	16523000	30059	14798	6	0	\N
392812	1874	16527000	30059	14798	7	0	\N
392813	1874	16531000	30059	14798	8	0	\N
392814	1874	16535000	30059	14798	9	0	\N
392815	1874	16539000	30059	14798	10	0	\N
392816	1874	16543000	30059	14798	11	0	\N
392817	1874	16547000	30059	14798	12	0	\N
392818	1874	16551000	30059	14798	13	0	\N
392819	1874	16552000	30059	14798	14	0	\N
392820	1874	16553000	30059	14798	15	0	\N
392821	1874	16554000	30059	14798	16	0	\N
392822	1874	16556000	30059	14798	17	0	\N
392823	1874	16558000	30059	14798	18	0	\N
392832	1678	29520912336000	30061	14800	0	0	\N
392833	1678	29520912337000	30061	14800	1	0	\N
392834	1678	29520912338000	30061	14800	2	0	\N
392835	2438	100000000	30061	14800	3	0	\N
392836	1874	16580000	30061	14800	4	0	\N
392837	1874	16581000	30061	14800	5	0	\N
392838	1874	16582000	30061	14800	6	0	\N
392839	1874	16583000	30061	14800	7	0	\N
392840	1874	16584000	30061	14800	8	0	\N
392881	1678	29520912339000	30064	14801	0	0	\N
392882	1874	16660000	30064	14801	1	0	\N
392883	1874	16661000	30064	14801	2	0	\N
392884	1874	16663000	30064	14801	3	0	\N
392885	1874	16667000	30064	14801	4	0	\N
392886	1874	16671000	30064	14801	5	0	\N
392887	1874	16675000	30064	14801	7	0	\N
392888	1874	16679000	30064	14801	8	0	\N
392788	1874	16513000	30058	14798	2	0	3
392789	1874	16515000	30058	14798	3	0	3
392790	1874	16517000	30058	14798	4	0	3
392791	1874	16519000	30058	14798	5	0	3
392792	1874	16523000	30058	14798	6	0	3
392794	1874	16531000	30058	14798	8	0	3
392795	1874	16535000	30058	14798	9	0	3
392796	1874	16539000	30058	14798	10	0	3
392797	1874	16543000	30058	14798	11	0	3
392798	1874	16547000	30058	14798	12	0	3
392800	1874	16552000	30058	14798	14	0	3
392801	1874	16553000	30058	14798	15	0	3
392802	1874	16554000	30058	14798	16	0	3
392803	1874	16556000	30058	14798	17	0	3
392824	1678	29520912335000	30060	14799	0	0	1
392825	1874	16560000	30060	14799	1	0	3
392826	1874	16561000	30060	14799	2	0	3
392827	1874	16565000	30060	14799	3	0	3
392828	1874	16569000	30060	14799	4	0	3
392830	1874	16577000	30060	14799	6	0	3
392831	1874	16579000	30060	14799	7	0	3
392841	1678	29520912336000	30062	14800	0	0	1
392842	1678	29520912337000	30062	14800	1	0	1
392843	1678	29520912338000	30062	14800	2	0	1
392845	1874	16583000	30062	14800	4	0	3
392846	1874	16587000	30062	14800	5	0	3
392847	1874	16591000	30062	14800	6	0	3
392848	1874	16593000	30062	14800	7	0	3
392850	1874	16597000	30062	14800	9	0	3
392851	1874	16599000	30062	14800	10	0	3
392852	1874	16601000	30062	14800	11	0	3
392853	1874	16603000	30062	14800	12	0	3
392854	1874	16605000	30062	14800	13	0	3
392856	1874	16606000	30062	14800	15	0	3
392857	1874	16607000	30062	14800	16	0	3
392858	1874	16608000	30062	14800	17	0	3
392859	1874	16609000	30062	14800	18	0	3
392860	1874	16610000	30062	14800	19	0	3
392862	1874	16618000	30062	14800	21	0	3
392863	1874	16622000	30062	14800	22	0	3
392864	1874	16626000	30062	14800	23	0	3
392865	1874	16630000	30062	14800	24	0	3
392867	1874	16638000	30062	14800	26	0	3
392868	1874	16642000	30062	14800	27	0	3
392869	1874	16646000	30062	14800	28	0	3
392870	1874	16650000	30062	14800	29	0	3
392871	1874	16654000	30062	14800	30	0	3
392873	1678	29520912339000	30063	14801	0	0	1
392874	1874	16660000	30063	14801	1	0	3
392875	1874	16661000	30063	14801	2	0	3
392876	1874	16663000	30063	14801	3	0	3
392877	1874	16667000	30063	14801	4	0	3
392879	1874	16675000	30063	14801	7	0	3
392880	1874	16679000	30063	14801	8	0	3
392889	1678	29520912340000	30065	14802	0	0	1
392890	1874	16681000	30065	14802	1	0	3
392892	1874	16685000	30065	14802	3	0	3
392893	1874	16689000	30065	14802	4	0	3
392894	1874	16693000	30065	14802	5	0	3
392895	1874	16697000	30065	14802	6	0	3
392896	1874	16701000	30065	14802	7	0	3
392898	1678	29520912341000	30066	14803	0	0	1
392899	1874	16704000	30066	14803	2	0	3
392900	1874	16708000	30066	14803	3	0	3
392901	1874	16712000	30066	14803	4	0	3
392902	1874	16713000	30066	14803	5	0	3
392904	1874	16716000	30066	14803	7	0	3
392916	1678	29520912343000	30068	14805	0	0	\N
392917	1874	16751000	30068	14805	1	0	\N
392918	1874	16752000	30068	14805	2	0	\N
392919	1874	16753000	30068	14805	3	0	\N
392920	1874	16755000	30068	14805	4	0	\N
392921	1874	16757000	30068	14805	5	0	\N
392922	1678	29520912343000	30069	14805	0	0	\N
392923	1874	16751000	30069	14805	1	0	\N
392924	1874	16752000	30069	14805	2	0	\N
392925	1874	16753000	30069	14805	3	0	\N
392926	1874	16757000	30069	14805	4	0	\N
392927	1874	16761000	30069	14805	5	0	\N
392928	1874	16765000	30069	14805	6	0	\N
392929	1874	16769000	30069	14805	7	0	\N
392930	1874	16773000	30069	14805	8	0	\N
392931	1874	16775000	30069	14805	9	0	\N
392932	1874	16777000	30069	14805	10	0	\N
392944	1678	29520912343000	30071	14805	0	0	\N
392945	1874	16751000	30071	14805	1	0	\N
392946	1874	16752000	30071	14805	2	0	\N
392947	1874	16753000	30071	14805	3	0	\N
392948	1874	16757000	30071	14805	4	0	\N
392949	1874	16761000	30071	14805	5	0	\N
392950	1874	16765000	30071	14805	6	0	\N
392951	1874	16769000	30071	14805	7	0	\N
392952	1874	16773000	30071	14805	8	0	\N
392953	1874	16775000	30071	14805	9	0	\N
392954	1874	16777000	30071	14805	10	0	\N
392974	1678	29520912346000	30074	14808	0	0	\N
392975	1678	29520912347000	30074	14808	1	0	\N
392976	1874	16822000	30074	14808	2	0	\N
392977	1874	16824000	30074	14808	3	0	\N
392978	1874	16826000	30074	14808	4	0	\N
392979	1874	16828000	30074	14808	5	0	\N
392980	1874	16830000	30074	14808	6	0	\N
392981	1874	16834000	30074	14808	7	0	\N
392982	1874	16838000	30074	14808	8	0	\N
392983	1874	16842000	30074	14808	9	0	\N
392984	1874	16846000	30074	14808	10	0	\N
392985	1874	16850000	30074	14808	11	0	\N
392986	1874	16854000	30074	14808	12	0	\N
392987	1874	16858000	30074	14808	13	0	\N
392988	1874	16862000	30074	14808	14	0	\N
392989	1874	16866000	30074	14808	15	0	\N
392990	1874	16867000	30074	14808	16	0	\N
392991	1874	16868000	30074	14808	17	0	\N
392992	1874	16869000	30074	14808	18	0	\N
393012	1678	29520912346000	30076	14808	0	0	\N
393013	1678	29520912347000	30076	14808	1	0	\N
393014	1874	16821000	30076	14808	2	0	\N
393015	1874	16822000	30076	14808	3	0	\N
393016	1874	16823000	30076	14808	4	0	\N
393026	1678	29520912349000	30078	14810	0	0	\N
393027	1874	16894000	30078	14810	1	0	\N
393028	1874	16898000	30078	14810	2	0	\N
393029	1874	16902000	30078	14810	3	0	\N
393030	1874	16906000	30078	14810	4	0	\N
393031	1874	16907000	30078	14810	5	0	\N
393032	1874	16908000	30078	14810	6	0	\N
393033	1874	16910000	30078	14810	7	0	\N
393034	1874	16912000	30078	14810	8	0	\N
393035	1874	16916000	30078	14810	9	0	\N
392907	1874	16728000	30066	14803	10	0	3
392908	1678	29520912342000	30067	14804	0	0	1
392909	1874	16729000	30067	14804	1	0	3
392910	1874	16731000	30067	14804	2	0	3
392911	1874	16735000	30067	14804	3	0	3
392913	1874	16741000	30067	14804	5	0	3
392914	1874	16745000	30067	14804	6	0	3
392915	1874	16749000	30067	14804	7	0	3
392933	1678	29520912343000	30070	14805	0	0	1
392934	1874	16751000	30070	14805	1	0	3
392936	1874	16753000	30070	14805	3	0	3
392937	1874	16757000	30070	14805	4	0	3
392938	1874	16761000	30070	14805	5	0	3
392939	1874	16765000	30070	14805	6	0	3
392941	1874	16773000	30070	14805	8	0	3
392942	1874	16775000	30070	14805	9	0	3
392943	1874	16777000	30070	14805	10	0	3
392955	1678	29520912344000	30072	14806	0	0	1
392956	1874	16779000	30072	14806	1	0	3
392958	1874	16785000	30072	14806	3	0	3
392959	1874	16789000	30072	14806	4	0	3
392960	1874	16793000	30072	14806	5	0	3
392961	1874	16797000	30072	14806	6	0	3
392962	1874	16798000	30072	14806	7	0	3
392964	707	9002150000000	30073	14807	1	0	0
392965	1678	29520912345000	30073	14807	2	0	1
392966	1874	16800000	30073	14807	3	0	3
392967	1874	16802000	30073	14807	4	0	3
392969	1874	16810000	30073	14807	6	0	3
392970	1874	16814000	30073	14807	7	0	3
392971	1874	16818000	30073	14807	8	0	3
392972	1874	16819000	30073	14807	9	0	3
392973	1874	16820000	30073	14807	10	0	3
392994	1678	29520912347000	30075	14808	1	0	1
392995	1874	16822000	30075	14808	2	0	3
392996	1874	16824000	30075	14808	3	0	3
392997	1874	16826000	30075	14808	4	0	3
392998	1874	16828000	30075	14808	5	0	3
393000	1874	16834000	30075	14808	7	0	3
393001	1874	16838000	30075	14808	8	0	3
393002	1874	16842000	30075	14808	9	0	3
393003	1874	16846000	30075	14808	10	0	3
393005	1874	16854000	30075	14808	12	0	3
393006	1874	16858000	30075	14808	13	0	3
393007	1874	16862000	30075	14808	14	0	3
393008	1874	16866000	30075	14808	15	0	3
393009	1874	16867000	30075	14808	16	0	3
393011	1874	16869000	30075	14808	18	0	3
393017	1678	29520912348000	30077	14809	0	0	1
393018	1874	16873000	30077	14809	1	0	3
393019	1874	16875000	30077	14809	2	0	3
393020	1874	16877000	30077	14809	3	0	3
393022	1874	16882000	30077	14809	5	0	3
393023	1874	16884000	30077	14809	6	0	3
393024	1874	16888000	30077	14809	7	0	3
393025	1874	16892000	30077	14809	8	0	3
393037	1874	16894000	30079	14810	1	0	3
393038	1874	16898000	30079	14810	2	0	3
393039	1874	16902000	30079	14810	3	0	3
393040	1874	16906000	30079	14810	4	0	3
393056	1678	29520912350000	30081	14811	0	0	\N
393057	1874	16924000	30081	14811	1	0	\N
393058	1874	16926000	30081	14811	2	0	\N
393059	1874	16930000	30081	14811	4	0	\N
393060	1874	16934000	30081	14811	5	0	\N
393061	1874	16938000	30081	14811	6	0	\N
393062	1874	16940000	30081	14811	7	0	\N
393063	1874	16942000	30081	14811	8	0	\N
393064	1874	16943000	30081	14811	9	0	\N
393065	1678	29520912350000	30082	14811	0	0	\N
393066	1874	16924000	30082	14811	1	0	\N
393067	1874	16926000	30082	14811	2	0	\N
393068	1874	16930000	30082	14811	4	0	\N
393069	1874	16934000	30082	14811	5	0	\N
393070	1874	16938000	30082	14811	6	0	\N
393071	1874	16940000	30082	14811	7	0	\N
393072	1874	16942000	30082	14811	8	0	\N
393073	1874	16943000	30082	14811	9	0	\N
393074	1678	29520912350000	30083	14811	0	0	\N
393075	1874	16924000	30083	14811	1	0	\N
393076	1874	16926000	30083	14811	2	0	\N
393077	1874	16930000	30083	14811	4	0	\N
393078	1874	16934000	30083	14811	5	0	\N
393079	1874	16938000	30083	14811	6	0	\N
393080	1874	16940000	30083	14811	7	0	\N
393081	1874	16942000	30083	14811	8	0	\N
393082	1874	16943000	30083	14811	9	0	\N
393083	1678	29520912350000	30084	14811	0	0	\N
393084	1874	16924000	30084	14811	1	0	\N
393085	1874	16926000	30084	14811	2	0	\N
393086	1874	16930000	30084	14811	4	0	\N
393087	1874	16934000	30084	14811	5	0	\N
393088	1874	16936000	30084	14811	6	0	\N
393089	1874	16937000	30084	14811	7	0	\N
393127	1678	29520912355000	30087	14814	0	0	\N
393128	1874	17039000	30087	14814	1	0	\N
393129	1874	17040000	30087	14814	2	0	\N
393130	1874	17042000	30087	14814	3	0	\N
393131	1874	17043000	30087	14814	4	0	\N
393132	1874	17047000	30087	14814	5	0	\N
393133	1874	17051000	30087	14814	6	0	\N
393134	1874	17055000	30087	14814	7	0	\N
393135	1874	17059000	30087	14814	8	0	\N
393136	1678	29520912355000	30088	14814	0	0	\N
393137	1874	17039000	30088	14814	1	0	\N
393138	1874	17040000	30088	14814	2	0	\N
393139	1874	17042000	30088	14814	3	0	\N
393140	1874	17043000	30088	14814	4	0	\N
393141	1874	17047000	30088	14814	5	0	\N
393142	1874	17051000	30088	14814	6	0	\N
393143	1874	17055000	30088	14814	7	0	\N
393144	1874	17059000	30088	14814	8	0	\N
393145	1678	29520912355000	30089	14814	0	0	\N
393146	1874	17039000	30089	14814	1	0	\N
393147	1874	17040000	30089	14814	2	0	\N
393148	1874	17042000	30089	14814	3	0	\N
393149	1874	17043000	30089	14814	4	0	\N
393150	1678	29520912355000	30090	14814	0	0	\N
393151	1874	17039000	30090	14814	1	0	\N
393152	1874	17040000	30090	14814	2	0	\N
393153	1874	17042000	30090	14814	3	0	\N
393154	1874	17043000	30090	14814	4	0	\N
393155	1874	17047000	30090	14814	5	0	\N
393156	1874	17051000	30090	14814	6	0	\N
393157	1874	17055000	30090	14814	7	0	\N
393158	1874	17059000	30090	14814	8	0	\N
393168	1678	29520912356000	30092	14815	0	0	\N
393169	1874	17061000	30092	14815	1	0	\N
393170	1874	17062000	30092	14815	2	0	\N
393171	1874	17066000	30092	14815	3	0	\N
393172	1874	17070000	30092	14815	4	0	\N
393173	1874	17072000	30092	14815	5	0	\N
393174	1874	17076000	30092	14815	6	0	\N
393175	1874	17080000	30092	14815	7	0	\N
393176	1874	17084000	30092	14815	8	0	\N
393043	1874	16910000	30079	14810	7	0	3
393044	1874	16912000	30079	14810	8	0	3
393045	1874	16916000	30079	14810	9	0	3
393046	1874	16920000	30079	14810	10	0	3
393047	1678	29520912350000	30080	14811	0	0	1
393049	1874	16926000	30080	14811	2	0	3
393050	1874	16930000	30080	14811	4	0	3
393051	1874	16934000	30080	14811	5	0	3
393052	1874	16938000	30080	14811	6	0	3
393053	1874	16940000	30080	14811	7	0	3
393055	1874	16943000	30080	14811	9	0	3
393090	1678	29520912351000	30085	14812	0	0	1
393091	1874	16945000	30085	14812	1	0	3
393092	1874	16949000	30085	14812	2	0	3
393094	1874	16957000	30085	14812	4	0	3
393095	1874	16961000	30085	14812	5	0	3
393096	1874	16963000	30085	14812	6	0	3
393097	1874	16964000	30085	14812	7	0	3
393098	1874	16965000	30085	14812	8	0	3
393100	1678	29520912353000	30086	14813	1	0	1
393101	1678	29520912354000	30086	14813	2	0	1
393102	1874	16967000	30086	14813	3	0	3
393103	1874	16968000	30086	14813	4	0	3
393104	1874	16972000	30086	14813	5	0	3
393106	1874	16980000	30086	14813	7	0	3
393107	1874	16984000	30086	14813	8	0	3
393108	1874	16985000	30086	14813	9	0	3
393109	1874	16986000	30086	14813	10	0	3
393111	1874	16991000	30086	14813	12	0	3
393112	1874	16993000	30086	14813	13	0	3
393113	1874	16995000	30086	14813	14	0	3
393114	1874	16997000	30086	14813	15	0	3
393115	1874	16999000	30086	14813	16	0	3
393117	1874	17003000	30086	14813	18	0	3
393118	1874	17005000	30086	14813	19	0	3
393119	1874	17009000	30086	14813	20	0	3
393120	1874	17013000	30086	14813	21	0	3
393121	1874	17017000	30086	14813	22	0	3
393123	1874	17025000	30086	14813	24	0	3
393124	1874	17029000	30086	14813	25	0	3
393125	1874	17033000	30086	14813	26	0	3
393126	1874	17037000	30086	14813	27	0	3
393160	1874	17039000	30091	14814	1	0	3
393161	1874	17040000	30091	14814	2	0	3
393162	1874	17042000	30091	14814	3	0	3
393163	1874	17043000	30091	14814	4	0	3
393164	1874	17047000	30091	14814	5	0	3
393166	1874	17055000	30091	14814	7	0	3
393167	1874	17059000	30091	14814	8	0	3
393177	1678	29520912356000	30093	14815	0	0	\N
393178	1874	17061000	30093	14815	1	0	\N
393179	1874	17062000	30093	14815	2	0	\N
393180	1874	17066000	30093	14815	3	0	\N
393181	1874	17070000	30093	14815	4	0	\N
393182	1874	17072000	30093	14815	5	0	\N
393183	1874	17076000	30093	14815	6	0	\N
393184	1874	17080000	30093	14815	7	0	\N
393194	1678	29520912357000	30095	14816	0	0	\N
393195	1874	17085000	30095	14816	1	0	\N
393196	1874	17089000	30095	14816	2	0	\N
393197	1874	17093000	30095	14816	3	0	\N
393198	1874	17097000	30095	14816	4	0	\N
393199	1874	17101000	30095	14816	5	0	\N
393200	1874	17103000	30095	14816	6	0	\N
393201	1874	17105000	30095	14816	7	0	\N
393202	1874	17106000	30095	14816	8	0	\N
393203	1678	29520912357000	30096	14816	0	0	\N
393204	1874	17085000	30096	14816	1	0	\N
393205	1874	17089000	30096	14816	2	0	\N
393206	1874	17093000	30096	14816	3	0	\N
393207	1874	17097000	30096	14816	4	0	\N
393208	1874	17101000	30096	14816	5	0	\N
393209	1874	17103000	30096	14816	6	0	\N
393210	1874	17105000	30096	14816	7	0	\N
393211	1874	17106000	30096	14816	8	0	\N
393240	455	66002000000000	30099	14773	0	0	\N
393241	707	9002150000000	30099	14773	1	0	\N
393242	596	86338432000000	30099	14773	2	0	\N
393243	1678	29520912297000	30099	14773	3	0	\N
393244	1678	29520912298000	30099	14773	4	0	\N
393245	1678	29520912299000	30099	14773	5	0	\N
393246	1678	29520912300000	30099	14773	6	0	\N
393247	1678	29520912301000	30099	14773	7	0	\N
393248	1678	29520912302000	30099	14773	8	0	\N
393249	1678	29520912303000	30099	14773	9	0	\N
393250	1678	29520912304000	30099	14773	10	0	\N
393251	1678	29520912305000	30099	14773	11	0	\N
393252	1678	29520912306000	30099	14773	12	0	\N
393253	1678	29520912307000	30099	14773	13	0	\N
393254	1678	29520912308000	30099	14773	14	0	\N
393255	1678	29520912309000	30099	14773	15	0	\N
393256	1678	29520912310000	30099	14773	16	0	\N
393257	1678	29520912311000	30099	14773	17	0	\N
393258	1678	29520912312000	30099	14773	18	0	\N
393259	1678	29520912313000	30099	14773	19	0	\N
393260	1678	29520912314000	30099	14773	20	0	\N
393261	1678	29520912315000	30099	14773	21	0	\N
393262	1678	29520912316000	30099	14773	22	0	\N
393263	1678	29520912317000	30099	14773	23	0	\N
393264	1678	29520912318000	30099	14773	24	0	\N
393265	1678	29520912319000	30099	14773	25	0	\N
393266	1678	29520912320000	30099	14773	26	0	\N
393267	1678	29520912321000	30099	14773	27	0	\N
393268	1678	29520912322000	30099	14773	28	0	\N
393269	1678	29520912323000	30099	14773	29	0	\N
393270	1678	29520912324000	30099	14773	30	0	\N
393271	1678	29520912325000	30099	14773	31	0	\N
393272	1678	29520912326000	30099	14773	32	0	\N
393273	1678	29520912327000	30099	14773	33	0	\N
393274	1678	29520912328000	30099	14773	34	0	\N
393275	1678	29520912329000	30099	14773	35	0	\N
393276	1678	29520912330000	30099	14773	36	0	\N
393277	1678	29520912331000	30099	14773	37	0	\N
393278	1678	29520912332000	30099	14773	38	0	\N
393279	1678	29520912333000	30099	14773	39	0	\N
393280	1678	29520912334000	30099	14773	40	0	\N
393281	1678	29520912335000	30099	14773	41	0	\N
393282	1678	29520912336000	30099	14773	42	0	\N
393283	1678	29520912337000	30099	14773	43	0	\N
393284	1678	29520912338000	30099	14773	44	0	\N
393285	1678	29520912339000	30099	14773	45	0	\N
393286	1678	29520912340000	30099	14773	46	0	\N
393287	1678	29520912341000	30099	14773	47	0	\N
393288	1678	29520912342000	30099	14773	48	0	\N
393289	1678	29520912343000	30099	14773	49	0	\N
393290	1678	29520912344000	30099	14773	50	0	\N
393291	1678	29520912345000	30099	14773	51	0	\N
393292	1678	29520912346000	30099	14773	52	0	\N
393293	1678	29520912347000	30099	14773	53	0	\N
393294	1678	29520912348000	30099	14773	54	0	\N
393295	1678	29520912349000	30099	14773	55	0	\N
393296	1678	29520912350000	30099	14773	56	0	\N
393297	1678	29520912351000	30099	14773	57	0	\N
393298	1678	29520912352000	30099	14773	58	0	\N
393299	1678	29520912353000	30099	14773	59	0	\N
393300	1678	29520912354000	30099	14773	60	0	\N
393301	1678	29520912355000	30099	14773	61	0	\N
393302	1678	29520912356000	30099	14773	62	0	\N
393303	1678	29520912357000	30099	14773	63	0	\N
393304	1678	29520912358000	30099	14773	64	0	\N
393305	155	66000435000000	30099	14773	66	0	\N
393306	2435	100000000	30099	14773	67	0	\N
393307	2436	100000000	30099	14773	68	0	\N
393308	1874	15642000	30099	14773	69	0	\N
393309	1874	15646000	30099	14773	70	0	\N
393310	1874	15647000	30099	14773	71	0	\N
393311	1874	15648000	30099	14773	72	0	\N
393312	1874	15649000	30099	14773	73	0	\N
393187	1874	17062000	30094	14815	2	0	3
393188	1874	17066000	30094	14815	3	0	3
393189	1874	17070000	30094	14815	4	0	3
393190	1874	17072000	30094	14815	5	0	3
393191	1874	17076000	30094	14815	6	0	3
393193	1874	17084000	30094	14815	8	0	3
393212	1678	29520912357000	30097	14816	0	0	1
393213	1874	17085000	30097	14816	1	0	3
393214	1678	29520912358000	30098	14817	0	0	1
393215	1678	29520912359000	30098	14817	1	0	1
393217	1874	17093000	30098	14817	3	0	3
393218	1874	17097000	30098	14817	4	0	3
393219	1874	17101000	30098	14817	5	0	3
393220	1874	17105000	30098	14817	6	0	3
393222	1874	17113000	30098	14817	8	0	3
393223	1874	17115000	30098	14817	9	0	3
393224	1874	17119000	30098	14817	10	0	3
393225	1874	17123000	30098	14817	11	0	3
393226	1874	17127000	30098	14817	12	0	3
393228	1874	17135000	30098	14817	14	0	3
393229	1874	17139000	30098	14817	15	0	3
393230	1874	17141000	30098	14817	16	0	3
393231	1874	17142000	30098	14817	17	0	3
393232	1874	17143000	30098	14817	18	0	3
393234	1874	17145000	30098	14817	20	0	3
393235	1874	17147000	30098	14817	21	0	3
393236	1874	17149000	30098	14817	22	0	3
393237	1874	17151000	30098	14817	23	0	3
393239	1874	17155000	30098	14817	25	0	3
393313	1874	15651000	30099	14773	74	0	\N
393314	1874	15653000	30099	14773	75	0	\N
393315	1874	15655000	30099	14773	76	0	\N
393316	1874	15656000	30099	14773	77	0	\N
393317	1874	15657000	30099	14773	78	0	\N
393318	355	66000100000000	30099	14773	79	0	\N
393319	2437	100000000	30099	14773	80	0	\N
393320	2438	100000000	30099	14773	81	0	\N
393321	1874	15658000	30099	14773	82	0	\N
393322	1874	15659000	30099	14773	83	0	\N
393323	1874	15660000	30099	14773	84	0	\N
393324	1874	15661000	30099	14773	85	0	\N
393325	1874	15662000	30099	14773	86	0	\N
393326	1874	15663000	30099	14773	87	0	\N
393327	1874	15664000	30099	14773	88	0	\N
393328	1874	15665000	30099	14773	89	0	\N
393329	1874	15666000	30099	14773	90	0	\N
393330	1874	15667000	30099	14773	91	0	\N
393331	1874	15668000	30099	14773	92	0	\N
393332	1874	15669000	30099	14773	93	0	\N
393333	1874	15670000	30099	14773	94	0	\N
393334	1874	15671000	30099	14773	95	0	\N
393335	1874	15672000	30099	14773	97	0	\N
393336	1874	15673000	30099	14773	98	0	\N
393337	1874	15674000	30099	14773	99	0	\N
393338	1874	15675000	30099	14773	100	0	\N
393339	1874	15676000	30099	14773	101	0	\N
393340	1874	15677000	30099	14773	102	0	\N
393341	1874	15678000	30099	14773	103	0	\N
393342	1874	15679000	30099	14773	104	0	\N
393343	1874	15680000	30099	14773	105	0	\N
393344	1874	15681000	30099	14773	106	0	\N
393345	1874	15682000	30099	14773	107	0	\N
393346	1874	15683000	30099	14773	108	0	\N
393347	1874	15684000	30099	14773	109	0	\N
393348	1874	15685000	30099	14773	110	0	\N
393349	1874	15686000	30099	14773	111	0	\N
393350	1874	15687000	30099	14773	112	0	\N
393351	1874	15688000	30099	14773	113	0	\N
393352	1874	15689000	30099	14773	114	0	\N
393353	1874	15690000	30099	14773	115	0	\N
393354	1874	15691000	30099	14773	116	0	\N
393355	1874	15692000	30099	14773	117	0	\N
393356	1874	15693000	30099	14773	118	0	\N
393357	1874	15694000	30099	14773	119	0	\N
393358	1874	15695000	30099	14773	120	0	\N
393359	1874	15696000	30099	14773	121	0	\N
393360	1874	15697000	30099	14773	122	0	\N
393361	1678	29520912360000	30100	14818	0	0	\N
393362	1874	17157000	30100	14818	1	0	\N
393363	1874	17158000	30100	14818	2	0	\N
393364	1874	17162000	30100	14818	3	0	\N
393365	1874	17164000	30100	14818	4	0	\N
393366	1874	17166000	30100	14818	5	0	\N
393367	1874	17170000	30100	14818	6	0	\N
393368	1874	17174000	30100	14818	7	0	\N
393369	1874	17178000	30100	14818	8	0	\N
393372	1678	29520912360000	30102	14818	0	0	\N
393373	1874	17157000	30102	14818	1	0	\N
393374	1874	17158000	30102	14818	2	0	\N
393375	1874	17162000	30102	14818	3	0	\N
393376	1874	17164000	30102	14818	4	0	\N
393377	1874	17166000	30102	14818	5	0	\N
393378	1874	17170000	30102	14818	6	0	\N
393379	1874	17174000	30102	14818	7	0	\N
393380	1874	17178000	30102	14818	8	0	\N
393381	1678	29520912360000	30103	14818	0	0	\N
393382	1874	17157000	30103	14818	1	0	\N
393383	1874	17158000	30103	14818	2	0	\N
393384	1874	17162000	30103	14818	3	0	\N
393385	1874	17164000	30103	14818	4	0	\N
393386	1874	17168000	30103	14818	5	0	\N
393387	1874	17172000	30103	14818	6	0	\N
393388	1874	17176000	30103	14818	7	0	\N
393389	1678	29520912360000	30104	14818	0	0	\N
393390	1874	17157000	30104	14818	1	0	\N
393391	1874	17158000	30104	14818	2	0	\N
393392	1874	17162000	30104	14818	3	0	\N
393393	1874	17164000	30104	14818	4	0	\N
393394	1874	17166000	30104	14818	5	0	\N
393395	1874	17170000	30104	14818	6	0	\N
393396	1874	17174000	30104	14818	7	0	\N
393397	1874	17178000	30104	14818	8	0	\N
393398	1678	29520912360000	30105	14818	0	0	\N
393399	1874	17157000	30105	14818	1	0	\N
393400	1874	17158000	30105	14818	2	0	\N
393401	1874	17160000	30105	14818	3	0	\N
393402	1874	17162000	30105	14818	4	0	\N
393406	1678	29520912361000	30107	14819	0	0	\N
393407	1678	29520912362000	30107	14819	1	0	\N
393408	1678	29520912363000	30107	14819	2	0	\N
393409	1874	17157000	30107	14819	3	0	\N
393410	1874	17159000	30107	14819	4	0	\N
393411	1874	17160000	30107	14819	5	0	\N
393412	1874	17161000	30107	14819	6	0	\N
393413	1874	17162000	30107	14819	7	0	\N
393414	1874	17166000	30107	14819	8	0	\N
393415	1874	17168000	30107	14819	9	0	\N
393416	1874	17170000	30107	14819	10	0	\N
393417	1874	17172000	30107	14819	11	0	\N
393418	1874	17174000	30107	14819	12	0	\N
393419	1874	17176000	30107	14819	13	0	\N
393420	1874	17178000	30107	14819	14	0	\N
393421	1874	17180000	30107	14819	15	0	\N
393422	1874	17182000	30107	14819	17	0	\N
393423	1874	17184000	30107	14819	18	0	\N
393424	1874	17186000	30107	14819	19	0	\N
393425	1874	17190000	30107	14819	20	0	\N
393426	1874	17194000	30107	14819	21	0	\N
393427	1874	17198000	30107	14819	22	0	\N
393428	1678	29520912361000	30108	14819	0	0	\N
393429	1678	29520912362000	30108	14819	1	0	\N
393430	1678	29520912363000	30108	14819	2	0	\N
393431	1874	17157000	30108	14819	3	0	\N
393432	1874	17159000	30108	14819	4	0	\N
393433	1874	17160000	30108	14819	5	0	\N
393434	1874	17161000	30108	14819	6	0	\N
393435	1874	17162000	30108	14819	7	0	\N
393436	1874	17166000	30108	14819	8	0	\N
393437	1874	17168000	30108	14819	9	0	\N
393438	1874	17170000	30108	14819	10	0	\N
393439	1874	17172000	30108	14819	11	0	\N
393440	1874	17174000	30108	14819	12	0	\N
393441	1874	17176000	30108	14819	13	0	\N
393442	1874	17178000	30108	14819	14	0	\N
393443	1874	17180000	30108	14819	15	0	\N
393444	1874	17182000	30108	14819	17	0	\N
393445	1874	17184000	30108	14819	18	0	\N
393446	1874	17186000	30108	14819	19	0	\N
393447	1874	17190000	30108	14819	20	0	\N
393448	1874	17194000	30108	14819	21	0	\N
393403	1678	29520912361000	30106	14819	0	0	1
393404	1678	29520912362000	30106	14819	1	0	1
393405	1678	29520912363000	30106	14819	2	0	1
393449	1874	17198000	30108	14819	22	0	\N
393450	1874	17202000	30108	14819	23	0	\N
393451	1874	17206000	30108	14819	24	0	\N
393452	1874	17210000	30108	14819	25	0	\N
393453	1874	17214000	30108	14819	26	0	\N
393454	1874	17218000	30108	14819	27	0	\N
393455	1874	17222000	30108	14819	28	0	\N
393456	1874	17226000	30108	14819	29	0	\N
393457	1874	17230000	30108	14819	30	0	\N
393458	1874	17234000	30108	14819	31	0	\N
393459	1874	17238000	30108	14819	32	0	\N
393460	1874	17242000	30108	14819	33	0	\N
393461	1874	17246000	30108	14819	34	0	\N
393462	1874	17250000	30108	14819	35	0	\N
393463	2439	99000000000	30109	14820	0	0	\N
393464	1678	29520912364000	30109	14820	1	0	\N
393465	1678	29520912365000	30109	14820	2	0	\N
393466	1874	17157000	30109	14820	3	0	\N
393467	1874	17159000	30109	14820	4	0	\N
393468	1874	17160000	30109	14820	5	0	\N
393469	1874	17161000	30109	14820	6	0	\N
393470	1874	17162000	30109	14820	7	0	\N
393471	1874	17163000	30109	14820	8	0	\N
393472	1874	17167000	30109	14820	9	0	\N
393473	1874	17169000	30109	14820	10	0	\N
393474	1874	17171000	30109	14820	12	0	\N
393475	1874	17172000	30109	14820	13	0	\N
393476	1874	17174000	30109	14820	14	0	\N
393477	1874	17176000	30109	14820	15	0	\N
393478	1874	17178000	30109	14820	16	0	\N
393479	1874	17180000	30109	14820	17	0	\N
393480	1874	17182000	30109	14820	18	0	\N
393481	1874	17184000	30109	14820	19	0	\N
393482	1874	17186000	30109	14820	20	0	\N
393483	1874	17188000	30109	14820	21	0	\N
393484	1874	17190000	30109	14820	22	0	\N
393485	1874	17194000	30109	14820	23	0	\N
393486	1874	17198000	30109	14820	24	0	\N
393487	1874	17202000	30109	14820	25	0	\N
393488	1874	17203000	30109	14820	26	0	\N
393489	1874	17207000	30109	14820	27	0	\N
393490	1874	17211000	30109	14820	28	0	\N
393491	1874	17215000	30109	14820	29	0	\N
393492	1874	17219000	30109	14820	30	0	\N
393493	1874	17223000	30109	14820	31	0	\N
393494	1874	17227000	30109	14820	32	0	\N
393495	1874	17231000	30109	14820	33	0	\N
393496	1874	17235000	30109	14820	34	0	\N
393497	1874	17239000	30109	14820	35	0	\N
393498	1874	17243000	30109	14820	36	0	\N
393499	1874	17247000	30109	14820	37	0	\N
393500	1874	17251000	30109	14820	38	0	\N
393501	1874	17255000	30109	14820	39	0	\N
393502	1874	17259000	30109	14820	40	0	\N
393503	1874	17263000	30109	14820	41	0	\N
393504	1874	17267000	30109	14820	42	0	\N
393505	1874	17271000	30109	14820	43	0	\N
393506	1874	17275000	30109	14820	44	0	\N
393507	1874	17279000	30109	14820	45	0	\N
393508	1874	17283000	30109	14820	46	0	\N
393509	1874	17287000	30109	14820	47	0	\N
393510	1874	17291000	30109	14820	48	0	\N
393511	1874	17293000	30109	14820	49	0	\N
393512	1874	17295000	30109	14820	50	0	\N
393513	1874	17297000	30109	14820	51	0	\N
393514	1874	17299000	30109	14820	52	0	\N
393515	2439	99000000000	30110	14820	0	0	\N
393516	1678	29520912364000	30110	14820	1	0	\N
393517	1678	29520912365000	30110	14820	2	0	\N
393518	1874	17157000	30110	14820	3	0	\N
393519	1874	17159000	30110	14820	4	0	\N
393520	1874	17160000	30110	14820	5	0	\N
393521	1874	17161000	30110	14820	6	0	\N
393522	1874	17162000	30110	14820	7	0	\N
393523	1874	17163000	30110	14820	8	0	\N
393524	1874	17167000	30110	14820	9	0	\N
393525	1874	17169000	30110	14820	10	0	\N
393526	1874	17171000	30110	14820	12	0	\N
393527	1874	17172000	30110	14820	13	0	\N
393528	1874	17174000	30110	14820	14	0	\N
393529	1874	17176000	30110	14820	15	0	\N
393530	1874	17178000	30110	14820	16	0	\N
393531	1874	17180000	30110	14820	17	0	\N
393532	1874	17182000	30110	14820	18	0	\N
393533	1874	17184000	30110	14820	19	0	\N
393534	1874	17186000	30110	14820	20	0	\N
393535	1874	17188000	30110	14820	21	0	\N
393536	1874	17190000	30110	14820	22	0	\N
393537	1874	17194000	30110	14820	23	0	\N
393538	1874	17198000	30110	14820	24	0	\N
393539	1874	17202000	30110	14820	25	0	\N
393540	1874	17203000	30110	14820	26	0	\N
393541	1874	17207000	30110	14820	27	0	\N
393542	1874	17211000	30110	14820	28	0	\N
393543	1874	17215000	30110	14820	29	0	\N
393544	1874	17219000	30110	14820	30	0	\N
393545	1874	17223000	30110	14820	31	0	\N
393546	1874	17227000	30110	14820	32	0	\N
393547	1874	17231000	30110	14820	33	0	\N
393548	1874	17235000	30110	14820	34	0	\N
393549	1874	17239000	30110	14820	35	0	\N
393550	1874	17243000	30110	14820	36	0	\N
393551	1874	17247000	30110	14820	37	0	\N
393552	1874	17251000	30110	14820	38	0	\N
393553	1874	17255000	30110	14820	39	0	\N
393554	1874	17259000	30110	14820	40	0	\N
393555	1874	17263000	30110	14820	41	0	\N
393556	1874	17267000	30110	14820	42	0	\N
393557	1874	17271000	30110	14820	43	0	\N
393558	1874	17275000	30110	14820	44	0	\N
393559	1874	17279000	30110	14820	45	0	\N
393560	1874	17283000	30110	14820	46	0	\N
393561	1874	17287000	30110	14820	47	0	\N
393562	1874	17291000	30110	14820	48	0	\N
393563	1874	17293000	30110	14820	49	0	\N
393564	1874	17295000	30110	14820	50	0	\N
393565	1874	17297000	30110	14820	51	0	\N
393566	1874	17299000	30110	14820	52	0	\N
393569	1678	29520912365000	30111	14820	2	0	1
393570	1874	17157000	30111	14820	3	0	3
393571	1874	17159000	30111	14820	4	0	3
393572	1874	17160000	30111	14820	5	0	3
393573	1874	17161000	30111	14820	6	0	3
393575	1874	17163000	30111	14820	8	0	3
393576	1874	17167000	30111	14820	9	0	3
393577	1874	17169000	30111	14820	10	0	3
393578	1874	17171000	30111	14820	12	0	3
393579	1874	17172000	30111	14820	13	0	3
393581	1874	17176000	30111	14820	15	0	3
393582	1874	17178000	30111	14820	16	0	3
393583	1874	17180000	30111	14820	17	0	3
393584	1874	17182000	30111	14820	18	0	3
393619	2439	99000000000	30112	14820	0	0	\N
393620	1678	29520912364000	30112	14820	1	0	\N
393621	1678	29520912365000	30112	14820	2	0	\N
393622	1874	17157000	30112	14820	3	0	\N
393623	1874	17159000	30112	14820	4	0	\N
393624	1874	17160000	30112	14820	5	0	\N
393625	1874	17161000	30112	14820	6	0	\N
393626	1874	17162000	30112	14820	7	0	\N
393627	1874	17163000	30112	14820	8	0	\N
393628	1874	17167000	30112	14820	9	0	\N
393629	1874	17169000	30112	14820	10	0	\N
393630	1874	17171000	30112	14820	12	0	\N
393631	1874	17172000	30112	14820	13	0	\N
393632	1874	17174000	30112	14820	14	0	\N
393633	1874	17176000	30112	14820	15	0	\N
393634	1874	17178000	30112	14820	16	0	\N
393635	1874	17180000	30112	14820	17	0	\N
393636	1874	17182000	30112	14820	18	0	\N
393637	1874	17184000	30112	14820	19	0	\N
393638	1874	17186000	30112	14820	20	0	\N
393639	1874	17188000	30112	14820	21	0	\N
393640	1874	17190000	30112	14820	22	0	\N
393641	1874	17194000	30112	14820	23	0	\N
393642	1874	17198000	30112	14820	24	0	\N
393643	1874	17202000	30112	14820	25	0	\N
393644	1874	17203000	30112	14820	26	0	\N
393645	1874	17205000	30112	14820	27	0	\N
393646	1874	17207000	30112	14820	28	0	\N
393647	1874	17209000	30112	14820	29	0	\N
393648	1874	17211000	30112	14820	30	0	\N
393649	2439	99000000000	30113	14820	0	0	\N
393650	1678	29520912364000	30113	14820	1	0	\N
393651	1678	29520912365000	30113	14820	2	0	\N
393652	1874	17157000	30113	14820	3	0	\N
393653	1874	17159000	30113	14820	4	0	\N
393654	1874	17160000	30113	14820	5	0	\N
393655	1874	17161000	30113	14820	6	0	\N
393656	1874	17162000	30113	14820	7	0	\N
393657	1874	17163000	30113	14820	8	0	\N
393658	1874	17167000	30113	14820	9	0	\N
393659	1874	17169000	30113	14820	10	0	\N
393660	1874	17171000	30113	14820	12	0	\N
393661	1874	17172000	30113	14820	13	0	\N
393662	1874	17174000	30113	14820	14	0	\N
393663	1874	17176000	30113	14820	15	0	\N
393664	1874	17178000	30113	14820	16	0	\N
393665	1874	17180000	30113	14820	17	0	\N
393666	1874	17182000	30113	14820	18	0	\N
393667	1874	17184000	30113	14820	19	0	\N
393668	1874	17186000	30113	14820	20	0	\N
393669	1874	17188000	30113	14820	21	0	\N
393670	1874	17190000	30113	14820	22	0	\N
393671	1874	17194000	30113	14820	23	0	\N
393672	1874	17198000	30113	14820	24	0	\N
393673	1874	17202000	30113	14820	25	0	\N
393674	1874	17203000	30113	14820	26	0	\N
393675	1874	17207000	30113	14820	27	0	\N
393676	1874	17211000	30113	14820	28	0	\N
393677	1874	17215000	30113	14820	29	0	\N
393678	1874	17219000	30113	14820	30	0	\N
393679	1874	17223000	30113	14820	31	0	\N
393680	1874	17227000	30113	14820	32	0	\N
393681	1874	17231000	30113	14820	33	0	\N
393682	1874	17235000	30113	14820	34	0	\N
393683	1874	17239000	30113	14820	35	0	\N
393684	1874	17243000	30113	14820	36	0	\N
393685	1874	17247000	30113	14820	37	0	\N
393686	1874	17251000	30113	14820	38	0	\N
393687	1874	17255000	30113	14820	39	0	\N
393688	1874	17259000	30113	14820	40	0	\N
393689	1874	17263000	30113	14820	41	0	\N
393690	1874	17267000	30113	14820	42	0	\N
393691	1874	17271000	30113	14820	43	0	\N
393692	1874	17275000	30113	14820	44	0	\N
393693	1874	17279000	30113	14820	45	0	\N
393694	1874	17283000	30113	14820	46	0	\N
393695	1874	17287000	30113	14820	47	0	\N
393696	1874	17291000	30113	14820	48	0	\N
393697	1874	17293000	30113	14820	49	0	\N
393698	1874	17295000	30113	14820	50	0	\N
393699	1874	17297000	30113	14820	51	0	\N
393700	1874	17299000	30113	14820	52	0	\N
393701	2439	99000000000	30114	14820	0	0	\N
393702	1678	29520912364000	30114	14820	1	0	\N
393703	1678	29520912365000	30114	14820	2	0	\N
393704	1874	17157000	30114	14820	3	0	\N
393705	1874	17159000	30114	14820	4	0	\N
393706	1874	17160000	30114	14820	5	0	\N
393707	1874	17161000	30114	14820	6	0	\N
393708	1874	17162000	30114	14820	7	0	\N
393709	1874	17163000	30114	14820	8	0	\N
393710	1874	17165000	30114	14820	9	0	\N
393711	1874	17167000	30114	14820	10	0	\N
393712	1874	17168000	30114	14820	12	0	\N
393713	1874	17170000	30114	14820	13	0	\N
393714	1874	17172000	30114	14820	14	0	\N
393715	1874	17174000	30114	14820	15	0	\N
393716	1874	17176000	30114	14820	16	0	\N
393717	1874	17178000	30114	14820	17	0	\N
393718	1874	17180000	30114	14820	18	0	\N
393719	1874	17182000	30114	14820	19	0	\N
393720	1874	17184000	30114	14820	20	0	\N
393587	1874	17188000	30111	14820	21	0	3
393588	1874	17190000	30111	14820	22	0	3
393589	1874	17194000	30111	14820	23	0	3
393590	1874	17198000	30111	14820	24	0	3
393591	1874	17202000	30111	14820	25	0	3
393593	1874	17207000	30111	14820	27	0	3
393594	1874	17211000	30111	14820	28	0	3
393595	1874	17215000	30111	14820	29	0	3
393596	1874	17219000	30111	14820	30	0	3
393597	1874	17223000	30111	14820	31	0	3
393599	1874	17231000	30111	14820	33	0	3
393600	1874	17235000	30111	14820	34	0	3
393601	1874	17239000	30111	14820	35	0	3
393602	1874	17243000	30111	14820	36	0	3
393604	1874	17251000	30111	14820	38	0	3
393605	1874	17255000	30111	14820	39	0	3
393606	1874	17259000	30111	14820	40	0	3
393607	1874	17263000	30111	14820	41	0	3
393608	1874	17267000	30111	14820	42	0	3
393610	1874	17275000	30111	14820	44	0	3
393611	1874	17279000	30111	14820	45	0	3
393612	1874	17283000	30111	14820	46	0	3
393613	1874	17287000	30111	14820	47	0	3
393614	1874	17291000	30111	14820	48	0	3
393616	1874	17295000	30111	14820	50	0	3
393617	1874	17297000	30111	14820	51	0	3
393618	1874	17299000	30111	14820	52	0	3
393721	1874	17186000	30114	14820	21	0	\N
393722	1874	17187000	30114	14820	22	0	\N
393723	1874	17189000	30114	14820	23	0	\N
393724	1874	17191000	30114	14820	24	0	\N
393725	1874	17193000	30114	14820	25	0	\N
393726	1874	17195000	30114	14820	26	0	\N
393727	2439	99000000000	30115	14820	0	0	\N
393728	1678	29520912364000	30115	14820	1	0	\N
393729	1678	29520912365000	30115	14820	2	0	\N
393730	1874	17157000	30115	14820	3	0	\N
393731	1874	17159000	30115	14820	4	0	\N
393732	1874	17160000	30115	14820	5	0	\N
393733	1874	17161000	30115	14820	6	0	\N
393734	1874	17162000	30115	14820	7	0	\N
393735	1874	17163000	30115	14820	8	0	\N
393736	1874	17167000	30115	14820	9	0	\N
393737	1874	17169000	30115	14820	10	0	\N
393738	1874	17171000	30115	14820	12	0	\N
393739	1874	17172000	30115	14820	13	0	\N
393740	1874	17174000	30115	14820	14	0	\N
393741	1874	17176000	30115	14820	15	0	\N
393742	1874	17178000	30115	14820	16	0	\N
393743	1874	17180000	30115	14820	17	0	\N
393744	1874	17182000	30115	14820	18	0	\N
393745	1874	17184000	30115	14820	19	0	\N
393746	1874	17186000	30115	14820	20	0	\N
393747	1874	17188000	30115	14820	21	0	\N
393748	1874	17190000	30115	14820	22	0	\N
393749	1874	17194000	30115	14820	23	0	\N
393750	1874	17198000	30115	14820	24	0	\N
393751	1874	17202000	30115	14820	25	0	\N
393752	1874	17203000	30115	14820	26	0	\N
393753	1874	17207000	30115	14820	27	0	\N
393754	1874	17211000	30115	14820	28	0	\N
393755	1874	17215000	30115	14820	29	0	\N
393756	1874	17219000	30115	14820	30	0	\N
393757	1874	17223000	30115	14820	31	0	\N
393758	1874	17227000	30115	14820	32	0	\N
393759	1874	17231000	30115	14820	33	0	\N
393760	1874	17235000	30115	14820	34	0	\N
393761	1874	17239000	30115	14820	35	0	\N
393762	1874	17243000	30115	14820	36	0	\N
393763	1874	17247000	30115	14820	37	0	\N
393764	1874	17251000	30115	14820	38	0	\N
393765	1874	17255000	30115	14820	39	0	\N
393766	1874	17259000	30115	14820	40	0	\N
393767	1874	17263000	30115	14820	41	0	\N
393768	1874	17267000	30115	14820	42	0	\N
393769	1874	17271000	30115	14820	43	0	\N
393770	1874	17275000	30115	14820	44	0	\N
393771	1874	17279000	30115	14820	45	0	\N
393772	1874	17283000	30115	14820	46	0	\N
393773	1874	17287000	30115	14820	47	0	\N
393774	1874	17291000	30115	14820	48	0	\N
393775	1874	17293000	30115	14820	49	0	\N
393776	1874	17295000	30115	14820	50	0	\N
393777	1874	17297000	30115	14820	51	0	\N
393778	1874	17299000	30115	14820	52	0	\N
393786	1678	29520912366000	30117	14821	0	0	\N
393787	1874	17300000	30117	14821	1	0	\N
393788	1874	17302000	30117	14821	2	0	\N
393789	1874	17304000	30117	14821	3	0	\N
393790	1874	17306000	30117	14821	4	0	\N
393791	1874	17307000	30117	14821	6	0	\N
393792	1874	17311000	30117	14821	7	0	\N
393793	1874	17315000	30117	14821	8	0	\N
393794	1874	17319000	30117	14821	9	0	\N
393795	1874	17323000	30117	14821	10	0	\N
393796	1874	17300000	30118	14821	0	0	\N
393797	1874	17302000	30118	14821	1	0	\N
393798	1874	17304000	30118	14821	2	0	\N
393799	1874	17306000	30118	14821	3	0	\N
393800	1874	17307000	30118	14821	5	0	\N
393801	1874	17311000	30118	14821	6	0	\N
393802	1874	17315000	30118	14821	7	0	\N
393803	1874	17319000	30118	14821	8	0	\N
393804	1874	17323000	30118	14821	9	0	\N
393805	1678	29520912366000	30119	14821	0	0	\N
393806	1874	17300000	30119	14821	1	0	\N
393807	1874	17302000	30119	14821	2	0	\N
393808	1874	17304000	30119	14821	3	0	\N
393809	1874	17306000	30119	14821	4	0	\N
393810	1874	17307000	30119	14821	6	0	\N
393811	1874	17311000	30119	14821	7	0	\N
393812	1874	17315000	30119	14821	8	0	\N
393813	1874	17319000	30119	14821	9	0	\N
393814	1874	17323000	30119	14821	10	0	\N
393837	1678	29520912366000	30121	14822	0	0	\N
393838	1678	29520912367000	30121	14822	1	0	\N
393839	1678	29520912368000	30121	14822	2	0	\N
393840	1483	11000000	30121	14822	3	0	\N
393841	1874	17324000	30121	14822	4	0	\N
393842	1874	17326000	30121	14822	5	0	\N
393843	1874	17328000	30121	14822	6	0	\N
393844	1874	17332000	30121	14822	7	0	\N
393845	1874	17333000	30121	14822	9	0	\N
393846	1874	17335000	30121	14822	10	0	\N
393847	1874	17337000	30121	14822	11	0	\N
393848	1874	17339000	30121	14822	12	0	\N
393849	1874	17343000	30121	14822	13	0	\N
393850	1874	17347000	30121	14822	14	0	\N
393851	1874	17351000	30121	14822	15	0	\N
393852	1874	17355000	30121	14822	16	0	\N
393853	1874	17359000	30121	14822	17	0	\N
393854	1874	17363000	30121	14822	18	0	\N
393855	1874	17367000	30121	14822	19	0	\N
393856	1874	17368000	30121	14822	20	0	\N
393781	1874	17304000	30116	14821	2	0	3
393782	1874	17308000	30116	14821	3	0	3
393783	1874	17312000	30116	14821	4	0	3
393784	1874	17316000	30116	14821	5	0	3
393785	1874	17320000	30116	14821	6	0	3
393816	1678	29520912367000	30120	14822	1	0	1
393817	1678	29520912368000	30120	14822	2	0	1
393818	1483	11000000	30120	14822	3	0	0
393819	1874	17324000	30120	14822	4	0	3
393820	1874	17326000	30120	14822	5	0	3
393822	1874	17332000	30120	14822	7	0	3
393823	1874	17333000	30120	14822	9	0	3
393824	1874	17335000	30120	14822	10	0	3
393825	1874	17337000	30120	14822	11	0	3
393827	1874	17343000	30120	14822	13	0	3
393828	1874	17347000	30120	14822	14	0	3
393829	1874	17351000	30120	14822	15	0	3
393830	1874	17355000	30120	14822	16	0	3
393831	1874	17359000	30120	14822	17	0	3
393833	1874	17367000	30120	14822	19	0	3
393834	1874	17368000	30120	14822	20	0	3
393835	1874	17369000	30120	14822	21	0	3
393836	1874	17370000	30120	14822	22	0	3
393857	1874	17369000	30121	14822	21	0	\N
393858	1874	17370000	30121	14822	22	0	\N
393859	1678	29520912366000	30122	14822	0	0	\N
393860	1678	29520912367000	30122	14822	1	0	\N
393861	1678	29520912368000	30122	14822	2	0	\N
393862	1483	11000000	30122	14822	3	0	\N
393863	1874	17324000	30122	14822	4	0	\N
393864	1874	17326000	30122	14822	5	0	\N
393865	1874	17328000	30122	14822	6	0	\N
393866	1874	17332000	30122	14822	7	0	\N
393867	1874	17333000	30122	14822	9	0	\N
393868	1874	17335000	30122	14822	10	0	\N
393869	1874	17337000	30122	14822	11	0	\N
393870	1874	17339000	30122	14822	12	0	\N
393871	1874	17343000	30122	14822	13	0	\N
393872	1874	17347000	30122	14822	14	0	\N
393873	1874	17351000	30122	14822	15	0	\N
393874	1874	17355000	30122	14822	16	0	\N
393875	1874	17359000	30122	14822	17	0	\N
393876	1874	17363000	30122	14822	18	0	\N
393877	1874	17367000	30122	14822	19	0	\N
393878	1874	17368000	30122	14822	20	0	\N
393879	1874	17369000	30122	14822	21	0	\N
393880	1874	17370000	30122	14822	22	0	\N
393948	1678	29520912374000	30126	14825	0	0	\N
393949	1874	17494000	30126	14825	1	0	\N
393950	1874	17496000	30126	14825	2	0	\N
393951	1874	17498000	30126	14825	3	0	\N
393952	1874	17502000	30126	14825	4	0	\N
393953	1874	17506000	30126	14825	5	0	\N
393954	1874	17510000	30126	14825	6	0	\N
393955	1874	17511000	30126	14825	7	0	\N
393956	1874	17512000	30126	14825	8	0	\N
393957	1874	17514000	30126	14825	9	0	\N
393958	1874	17516000	30126	14825	10	0	\N
393959	1874	17518000	30126	14825	11	0	\N
393960	1874	17520000	30126	14825	12	0	\N
393961	1874	17524000	30126	14825	13	0	\N
393962	1874	17528000	30126	14825	14	0	\N
393963	1874	17532000	30126	14825	15	0	\N
393964	1874	17536000	30126	14825	16	0	\N
393965	1874	17540000	30126	14825	17	0	\N
393966	1874	17544000	30126	14825	18	0	\N
393975	1678	29520912376000	30128	14827	0	0	\N
393976	1874	17567000	30128	14827	1	0	\N
393977	1874	17569000	30128	14827	2	0	\N
393978	1874	17571000	30128	14827	3	0	\N
393979	1874	17572000	30128	14827	4	0	\N
393980	1874	17573000	30128	14827	5	0	\N
393981	1678	29520912376000	30129	14827	0	0	\N
393982	1874	17567000	30129	14827	1	0	\N
393983	1874	17569000	30129	14827	2	0	\N
393984	1874	17573000	30129	14827	3	0	\N
393985	1874	17577000	30129	14827	4	0	\N
393986	1874	17578000	30129	14827	5	0	\N
393987	1874	17579000	30129	14827	6	0	\N
393988	1874	17583000	30129	14827	7	0	\N
393989	1874	17587000	30129	14827	8	0	\N
393990	1678	29520912376000	30130	14827	0	0	\N
393991	1874	17567000	30130	14827	1	0	\N
393992	1874	17569000	30130	14827	2	0	\N
393883	1678	29520912371000	30123	14823	2	0	1
393884	1874	17371000	30123	14823	3	0	3
393885	1874	17375000	30123	14823	4	0	3
393886	1874	17379000	30123	14823	5	0	3
393887	1874	17383000	30123	14823	6	0	3
393889	1874	17388000	30123	14823	8	0	3
393890	1874	17389000	30123	14823	9	0	3
393891	1874	17390000	30123	14823	10	0	3
393892	1874	17394000	30123	14823	11	0	3
393893	1874	17398000	30123	14823	12	0	3
393895	1874	17406000	30123	14823	14	0	3
393896	1874	17410000	30123	14823	15	0	3
393897	1874	17414000	30123	14823	16	0	3
393898	1874	17418000	30123	14823	17	0	3
393900	1874	17426000	30123	14823	19	0	3
393901	1874	17428000	30123	14823	20	0	3
393902	1874	17430000	30123	14823	21	0	3
393903	1874	17432000	30123	14823	22	0	3
393904	1874	17434000	30123	14823	23	0	3
393906	1874	17438000	30123	14823	25	0	3
393907	1874	17440000	30123	14823	26	0	3
393908	1874	17442000	30123	14823	27	0	3
393909	1678	29520912372000	30124	14824	0	0	1
393910	1678	29520912373000	30124	14824	1	0	1
393912	1874	17445000	30124	14824	3	0	3
393913	1874	17447000	30124	14824	4	0	3
393914	1874	17449000	30124	14824	5	0	3
393915	1874	17453000	30124	14824	6	0	3
393917	1874	17461000	30124	14824	8	0	3
393918	1874	17465000	30124	14824	9	0	3
393919	1874	17469000	30124	14824	10	0	3
393920	1874	17471000	30124	14824	11	0	3
393921	1874	17473000	30124	14824	12	0	3
393923	1874	17476000	30124	14824	14	0	3
393924	1874	17477000	30124	14824	15	0	3
393925	1874	17481000	30124	14824	16	0	3
393926	1874	17485000	30124	14824	17	0	3
393927	1874	17489000	30124	14824	18	0	3
393929	1678	29520912374000	30125	14825	0	0	1
393930	1874	17494000	30125	14825	1	0	3
393931	1874	17496000	30125	14825	2	0	3
393932	1874	17498000	30125	14825	3	0	3
393934	1874	17506000	30125	14825	5	0	3
393935	1874	17510000	30125	14825	6	0	3
393936	1874	17511000	30125	14825	7	0	3
393937	1874	17512000	30125	14825	8	0	3
393938	1874	17514000	30125	14825	9	0	3
393940	1874	17518000	30125	14825	11	0	3
393941	1874	17520000	30125	14825	12	0	3
393942	1874	17524000	30125	14825	13	0	3
393943	1874	17528000	30125	14825	14	0	3
393944	1874	17532000	30125	14825	15	0	3
393946	1874	17540000	30125	14825	17	0	3
393947	1874	17544000	30125	14825	18	0	3
393967	1678	29520912375000	30127	14826	0	0	1
393968	1874	17548000	30127	14826	1	0	3
393970	1874	17552000	30127	14826	3	0	3
393971	1874	17556000	30127	14826	4	0	3
393972	1874	17557000	30127	14826	5	0	3
393973	1874	17561000	30127	14826	6	0	3
393974	1874	17565000	30127	14826	7	0	3
393993	1874	17571000	30130	14827	3	0	\N
393994	1874	17575000	30130	14827	4	0	\N
393995	1874	17579000	30130	14827	5	0	\N
393996	1874	17580000	30130	14827	6	0	\N
393997	1874	17581000	30130	14827	7	0	\N
393998	1874	17585000	30130	14827	8	0	\N
393999	1874	17589000	30130	14827	9	0	\N
394000	1874	17593000	30130	14827	10	0	\N
394004	1678	29520912376000	30132	14827	0	0	\N
394005	1874	17567000	30132	14827	1	0	\N
394006	1874	17569000	30132	14827	2	0	\N
394007	1874	17571000	30132	14827	3	0	\N
394008	1874	17575000	30132	14827	4	0	\N
394009	1874	17579000	30132	14827	5	0	\N
394010	1874	17580000	30132	14827	6	0	\N
394011	1874	17581000	30132	14827	7	0	\N
394012	1874	17585000	30132	14827	8	0	\N
394013	1874	17589000	30132	14827	9	0	\N
394014	1874	17593000	30132	14827	10	0	\N
394015	1678	29520912376000	30133	14827	0	0	\N
394016	1874	17567000	30133	14827	1	0	\N
394017	1874	17569000	30133	14827	2	0	\N
394018	1874	17570000	30133	14827	3	0	\N
394019	1874	17571000	30133	14827	4	0	\N
394035	1678	29520912378000	30135	14829	0	0	\N
394036	1874	17614000	30135	14829	1	0	\N
394037	1874	17618000	30135	14829	2	0	\N
394038	1874	17620000	30135	14829	3	0	\N
394039	1874	17622000	30135	14829	4	0	\N
394040	1874	17626000	30135	14829	5	0	\N
394041	1874	17630000	30135	14829	6	0	\N
394042	1874	17634000	30135	14829	7	0	\N
394043	1874	17635000	30135	14829	8	0	\N
394044	1874	17636000	30135	14829	9	0	\N
394064	1678	29520912379000	30138	14830	0	0	\N
394065	1874	17618000	30138	14830	1	0	\N
394066	1874	17622000	30138	14830	2	0	\N
394067	1874	17626000	30138	14830	3	0	\N
394068	2440	0	30138	14830	4	0	\N
394069	1874	17628000	30138	14830	5	0	\N
394070	1874	17629000	30138	14830	6	0	\N
394071	1874	17633000	30138	14830	7	0	\N
394072	1874	17637000	30138	14830	8	0	\N
394073	1874	17641000	30138	14830	9	0	\N
394074	1874	17645000	30138	14830	10	0	\N
394075	1874	17649000	30138	14830	11	0	\N
394076	1874	17653000	30138	14830	12	0	\N
394077	1874	17657000	30138	14830	13	0	\N
394078	1678	29520912379000	30139	14830	0	0	\N
394079	1874	17618000	30139	14830	1	0	\N
394080	1874	17622000	30139	14830	2	0	\N
394081	1874	17626000	30139	14830	3	0	\N
394082	2440	0	30139	14830	4	0	\N
394083	1874	17627000	30139	14830	5	0	\N
394084	1874	17631000	30139	14830	6	0	\N
394085	1874	17635000	30139	14830	7	0	\N
394086	1874	17639000	30139	14830	8	0	\N
394087	1874	17643000	30139	14830	9	0	\N
394088	1874	17647000	30139	14830	10	0	\N
394089	1874	17651000	30139	14830	11	0	\N
394090	1678	29520912379000	30140	14830	0	0	\N
394091	1874	17618000	30140	14830	1	0	\N
394092	1874	17622000	30140	14830	2	0	\N
394093	1874	17626000	30140	14830	3	0	\N
394094	2440	0	30140	14830	4	0	\N
394095	1874	17630000	30140	14830	5	0	\N
394096	1874	17634000	30140	14830	6	0	\N
394097	1874	17638000	30140	14830	7	0	\N
394098	1874	17642000	30140	14830	8	0	\N
394099	1874	17646000	30140	14830	9	0	\N
394100	1874	17650000	30140	14830	10	0	\N
394101	1874	17620000	30141	14830	0	0	\N
394102	1874	17624000	30141	14830	1	0	\N
394103	1874	17625000	30141	14830	2	0	\N
394104	1874	17629000	30141	14830	3	0	\N
394105	1874	17633000	30141	14830	4	0	\N
394106	1874	17637000	30141	14830	5	0	\N
394116	1678	29520912380000	30143	14831	0	0	\N
394117	1874	17659000	30143	14831	1	0	\N
394118	1874	17660000	30143	14831	2	0	\N
394119	1874	17662000	30143	14831	3	0	\N
394120	1678	29520912381000	30144	14832	0	0	\N
394121	1874	17684000	30144	14832	1	0	\N
394122	1874	17688000	30144	14832	2	0	\N
394123	1874	17690000	30144	14832	3	0	\N
394124	1874	17692000	30144	14832	4	0	\N
394125	1874	17693000	30144	14832	5	0	\N
394126	1874	17694000	30144	14832	6	0	\N
394127	1874	17698000	30144	14832	7	0	\N
394128	1874	17702000	30144	14832	8	0	\N
394003	1874	17567000	30131	14827	2	0	3
394020	1678	29520912377000	30134	14828	0	0	1
394021	1874	17569000	30134	14828	1	0	3
394022	1874	17571000	30134	14828	2	0	3
394023	1874	17572000	30134	14828	3	0	3
394025	1874	17578000	30134	14828	5	0	3
394026	1874	17582000	30134	14828	6	0	3
394027	1874	17586000	30134	14828	7	0	3
394028	1874	17590000	30134	14828	8	0	3
394029	1874	17594000	30134	14828	9	0	3
394031	1874	17602000	30134	14828	11	0	3
394032	1874	17606000	30134	14828	12	0	3
394033	1874	17608000	30134	14828	13	0	3
394034	1874	17610000	30134	14828	14	0	3
394046	1874	17612000	30136	14829	1	0	3
394047	1874	17614000	30136	14829	2	0	3
394048	1874	17615000	30136	14829	3	0	3
394049	1874	17616000	30136	14829	4	0	3
394050	1678	29520912379000	30137	14830	0	0	1
394052	1874	17622000	30137	14830	2	0	3
394053	1874	17626000	30137	14830	3	0	3
394054	2440	0	30137	14830	4	0	0
394055	1874	17628000	30137	14830	5	0	3
394056	1874	17629000	30137	14830	6	0	3
394058	1874	17637000	30137	14830	8	0	3
394059	1874	17641000	30137	14830	9	0	3
394060	1874	17645000	30137	14830	10	0	3
394061	1874	17649000	30137	14830	11	0	3
394063	1874	17657000	30137	14830	13	0	3
394107	1678	29520912380000	30142	14831	0	0	1
394108	1874	17659000	30142	14831	1	0	3
394109	1874	17660000	30142	14831	2	0	3
394110	1874	17664000	30142	14831	3	0	3
394112	1874	17670000	30142	14831	5	0	3
394113	1874	17674000	30142	14831	6	0	3
394114	1874	17678000	30142	14831	7	0	3
394115	1874	17682000	30142	14831	8	0	3
394129	1874	17706000	30144	14832	9	0	\N
394140	1678	29520912382000	30146	14833	0	0	\N
394141	1874	17708000	30146	14833	1	0	\N
394142	1874	17710000	30146	14833	2	0	\N
394143	1874	17714000	30146	14833	3	0	\N
394144	1874	17718000	30146	14833	4	0	\N
394145	1874	17722000	30146	14833	5	0	\N
394146	1874	17726000	30146	14833	6	0	\N
394147	1874	17727000	30146	14833	7	0	\N
394148	1678	29520912382000	30147	14833	0	0	\N
394149	1874	17708000	30147	14833	1	0	\N
394150	1874	17710000	30147	14833	2	0	\N
394151	1874	17714000	30147	14833	3	0	\N
394152	1874	17718000	30147	14833	4	0	\N
394153	1874	17722000	30147	14833	5	0	\N
394154	1874	17726000	30147	14833	6	0	\N
394155	1874	17727000	30147	14833	7	0	\N
394174	1678	29520912383000	30150	14834	0	0	\N
394175	1874	17729000	30150	14834	1	0	\N
394176	1874	17733000	30150	14834	2	0	\N
394177	1874	17737000	30150	14834	3	0	\N
394178	1874	17741000	30150	14834	4	0	\N
394179	1874	17745000	30150	14834	5	0	\N
394180	1874	17749000	30150	14834	6	0	\N
394181	1874	17750000	30150	14834	7	0	\N
394182	1874	17751000	30150	14834	8	0	\N
394183	1874	17753000	30150	14834	9	0	\N
394184	1678	29520912384000	30153	14837	0	0	\N
394185	1678	29520912385000	30153	14837	1	0	\N
394186	1678	29520912386000	30153	14837	2	0	\N
394187	1678	29520912387000	30153	14837	3	0	\N
394188	1678	29520912388000	30153	14837	4	0	\N
394189	1874	17755000	30153	14837	5	0	\N
394190	1874	17759000	30153	14837	6	0	\N
394191	1874	17763000	30153	14837	7	0	\N
394192	1874	17765000	30153	14837	8	0	\N
394193	1874	17769000	30153	14837	9	0	\N
394194	1874	17773000	30153	14837	10	0	\N
394195	1874	17777000	30153	14837	11	0	\N
394196	1874	17781000	30153	14837	12	0	\N
394197	1874	17785000	30153	14837	13	0	\N
394198	1874	17789000	30153	14837	14	0	\N
394199	1874	17793000	30153	14837	15	0	\N
394200	1874	17797000	30153	14837	16	0	\N
394201	1874	17801000	30153	14837	17	0	\N
394202	1874	17805000	30153	14837	18	0	\N
394203	1874	17807000	30153	14837	19	0	\N
394204	1874	17809000	30153	14837	20	0	\N
394205	1874	17811000	30153	14837	21	0	\N
394206	1874	17813000	30153	14837	22	0	\N
394207	1874	17815000	30153	14837	23	0	\N
394208	1874	17817000	30153	14837	24	0	\N
394209	1874	17819000	30153	14837	25	0	\N
394210	1874	17821000	30153	14837	26	0	\N
394211	1874	17822000	30153	14837	27	0	\N
394212	1874	17823000	30153	14837	28	0	\N
394213	1874	17824000	30153	14837	29	0	\N
394214	1874	17826000	30153	14837	30	0	\N
394215	1874	17828000	30153	14837	31	0	\N
394216	1874	17830000	30153	14837	32	0	\N
394217	1874	17832000	30153	14837	33	0	\N
394218	2440	1000000000	30153	14837	34	0	\N
394219	1874	17836000	30153	14837	35	0	\N
394220	1874	17840000	30153	14837	36	0	\N
394221	1874	17844000	30153	14837	37	0	\N
394222	1874	17848000	30153	14837	38	0	\N
394223	1874	17852000	30153	14837	39	0	\N
394224	1874	17856000	30153	14837	40	0	\N
394225	1874	17860000	30153	14837	41	0	\N
394226	1874	17864000	30153	14837	42	0	\N
394227	1874	17868000	30153	14837	43	0	\N
394228	1874	17872000	30153	14837	44	0	\N
394229	1874	17873000	30153	14837	45	0	\N
394230	1874	17874000	30153	14837	46	0	\N
394231	1874	17875000	30153	14837	47	0	\N
394232	1874	17876000	30153	14837	48	0	\N
394132	1874	17688000	30145	14832	2	0	3
394133	1874	17690000	30145	14832	3	0	3
394134	1874	17692000	30145	14832	4	0	3
394135	1874	17693000	30145	14832	5	0	3
394136	1874	17694000	30145	14832	6	0	3
394138	1874	17702000	30145	14832	8	0	3
394139	1874	17706000	30145	14832	9	0	3
394156	1678	29520912382000	30148	14833	0	0	1
394157	1874	17708000	30148	14833	1	0	3
394158	1874	17710000	30148	14833	2	0	3
394160	1874	17718000	30148	14833	4	0	3
394161	1874	17722000	30148	14833	5	0	3
394162	1874	17726000	30148	14833	6	0	3
394163	1874	17727000	30148	14833	7	0	3
394165	1874	17729000	30149	14834	1	0	3
394166	1874	17733000	30149	14834	2	0	3
394167	1874	17737000	30149	14834	3	0	3
394168	1874	17741000	30149	14834	4	0	3
394169	1874	17745000	30149	14834	5	0	3
394171	1874	17750000	30149	14834	7	0	3
394172	1874	17751000	30149	14834	8	0	3
394173	1874	17753000	30149	14834	9	0	3
394233	1678	29520912384000	30154	14837	0	0	1
394234	1678	29520912385000	30154	14837	1	0	1
394236	1678	29520912387000	30154	14837	3	0	1
394237	1678	29520912388000	30154	14837	4	0	1
394238	1874	17755000	30154	14837	5	0	3
394239	1874	17759000	30154	14837	6	0	3
394241	1874	17765000	30154	14837	8	0	3
394242	1874	17769000	30154	14837	9	0	3
394243	1874	17773000	30154	14837	10	0	3
394244	1874	17777000	30154	14837	11	0	3
394245	1874	17781000	30154	14837	12	0	3
394247	1874	17789000	30154	14837	14	0	3
394248	1874	17793000	30154	14837	15	0	3
394249	1874	17797000	30154	14837	16	0	3
394250	1874	17801000	30154	14837	17	0	3
394251	1874	17805000	30154	14837	18	0	3
394253	1874	17809000	30154	14837	20	0	3
394254	1874	17811000	30154	14837	21	0	3
394255	1874	17813000	30154	14837	22	0	3
394256	1874	17815000	30154	14837	23	0	3
394258	1874	17819000	30154	14837	25	0	3
394259	1874	17821000	30154	14837	26	0	3
394260	1874	17822000	30154	14837	27	0	3
394261	1874	17823000	30154	14837	28	0	3
394262	1874	17824000	30154	14837	29	0	3
394264	1874	17828000	30154	14837	31	0	3
394292	2440	2000000000	30156	14838	0	0	\N
394293	1678	29520912389000	30156	14838	1	0	\N
394294	1874	17877000	30156	14838	2	0	\N
394295	1874	17881000	30156	14838	3	0	\N
394296	1874	17882000	30156	14838	4	0	\N
394297	1874	17884000	30156	14838	5	0	\N
394298	1874	17886000	30156	14838	6	0	\N
394299	1874	17890000	30156	14838	7	0	\N
394300	1874	17894000	30156	14838	8	0	\N
394301	1874	17898000	30156	14838	9	0	\N
394302	2440	2000000000	30157	14838	0	0	\N
394303	1678	29520912389000	30157	14838	1	0	\N
394304	1874	17877000	30157	14838	2	0	\N
394305	1874	17881000	30157	14838	3	0	\N
394306	1874	17883000	30157	14838	4	0	\N
394307	1874	17885000	30157	14838	5	0	\N
394308	1874	17889000	30157	14838	6	0	\N
394309	1874	17893000	30157	14838	7	0	\N
394318	1678	29520912390000	30159	14839	0	0	\N
394319	1874	17899000	30159	14839	1	0	\N
394320	1874	17903000	30159	14839	2	0	\N
394321	1874	17907000	30159	14839	3	0	\N
394322	1874	17911000	30159	14839	4	0	\N
394323	1874	17915000	30159	14839	5	0	\N
394343	1678	29520912393000	30163	14842	0	0	\N
394344	1678	29520912394000	30163	14842	1	0	\N
394345	1678	29520912395000	30163	14842	2	0	\N
394346	1678	29520912396000	30163	14842	3	0	\N
394347	1874	17970000	30163	14842	4	0	\N
394348	1874	17974000	30163	14842	5	0	\N
394349	1874	17975000	30163	14842	6	0	\N
394350	1874	17976000	30163	14842	7	0	\N
394351	1874	17977000	30163	14842	8	0	\N
394352	1874	17978000	30163	14842	9	0	\N
394353	1874	17979000	30163	14842	10	0	\N
394354	1874	17981000	30163	14842	11	0	\N
394355	1874	17983000	30163	14842	12	0	\N
394356	1874	17985000	30163	14842	13	0	\N
394357	1874	17987000	30163	14842	14	0	\N
394358	1874	17989000	30163	14842	15	0	\N
394359	1874	17991000	30163	14842	16	0	\N
394360	1874	17993000	30163	14842	17	0	\N
394361	1874	17995000	30163	14842	18	0	\N
394362	1874	17997000	30163	14842	19	0	\N
394363	1874	17999000	30163	14842	20	0	\N
394364	1874	18001000	30163	14842	21	0	\N
394365	1874	18005000	30163	14842	22	0	\N
394366	1874	18009000	30163	14842	23	0	\N
394367	1874	18013000	30163	14842	24	0	\N
394368	1874	18017000	30163	14842	25	0	\N
394369	1874	18021000	30163	14842	26	0	\N
394370	1874	18025000	30163	14842	27	0	\N
394371	1874	18029000	30163	14842	28	0	\N
394372	1874	18033000	30163	14842	29	0	\N
394373	1874	18037000	30163	14842	31	0	\N
394374	1874	18041000	30163	14842	32	0	\N
394375	1874	18045000	30163	14842	33	0	\N
394376	1874	18049000	30163	14842	34	0	\N
394377	1874	18053000	30163	14842	35	0	\N
394378	1874	18057000	30163	14842	36	0	\N
394379	1874	18061000	30163	14842	37	0	\N
394380	1874	18065000	30163	14842	38	0	\N
394381	1874	18069000	30163	14842	39	0	\N
394382	1678	29520912393000	30164	14842	0	0	\N
394383	1678	29520912394000	30164	14842	1	0	\N
394384	1678	29520912395000	30164	14842	2	0	\N
394385	1678	29520912396000	30164	14842	3	0	\N
394386	1874	17970000	30164	14842	4	0	\N
394387	1874	17974000	30164	14842	5	0	\N
394388	1874	17975000	30164	14842	6	0	\N
394389	1874	17976000	30164	14842	7	0	\N
394390	1874	17977000	30164	14842	8	0	\N
394391	1874	17978000	30164	14842	9	0	\N
394392	1874	17979000	30164	14842	10	0	\N
394393	1874	17981000	30164	14842	11	0	\N
394394	1874	17983000	30164	14842	12	0	\N
394395	1874	17985000	30164	14842	13	0	\N
394396	1874	17987000	30164	14842	14	0	\N
394397	1874	17989000	30164	14842	15	0	\N
394398	1874	17991000	30164	14842	16	0	\N
394399	1874	17993000	30164	14842	17	0	\N
394400	1874	17995000	30164	14842	18	0	\N
394267	2440	1000000000	30154	14837	34	0	0
394268	1874	17836000	30154	14837	35	0	3
394269	1874	17840000	30154	14837	36	0	3
394270	1874	17844000	30154	14837	37	0	3
394271	1874	17848000	30154	14837	38	0	3
394273	1874	17856000	30154	14837	40	0	3
394274	1874	17860000	30154	14837	41	0	3
394275	1874	17864000	30154	14837	42	0	3
394276	1874	17868000	30154	14837	43	0	3
394277	1874	17872000	30154	14837	44	0	3
394279	1874	17874000	30154	14837	46	0	3
394280	1874	17875000	30154	14837	47	0	3
394281	1874	17876000	30154	14837	48	0	3
394282	2440	2000000000	30155	14838	0	0	0
394284	1874	17877000	30155	14838	2	0	3
394285	1874	17881000	30155	14838	3	0	3
394286	1874	17882000	30155	14838	4	0	3
394287	1874	17884000	30155	14838	5	0	3
394288	1874	17886000	30155	14838	6	0	3
394290	1874	17894000	30155	14838	8	0	3
394291	1874	17898000	30155	14838	9	0	3
394310	1678	29520912390000	30158	14839	0	0	1
394311	1874	17899000	30158	14839	1	0	3
394312	1874	17903000	30158	14839	2	0	3
394314	1874	17911000	30158	14839	4	0	3
394315	1874	17915000	30158	14839	5	0	3
394316	1874	17917000	30158	14839	6	0	3
394317	1874	17919000	30158	14839	7	0	3
394325	1874	17923000	30161	14840	1	0	3
394326	1874	17927000	30161	14840	2	0	3
394327	1874	17928000	30161	14840	3	0	3
394328	1874	17932000	30161	14840	4	0	3
394329	1874	17936000	30161	14840	5	0	3
394331	1874	17940000	30161	14840	7	0	3
394332	1678	29520912392000	30162	14841	0	0	1
394333	1874	17942000	30162	14841	1	0	3
394334	1874	17946000	30162	14841	2	0	3
394335	1874	17950000	30162	14841	3	0	3
394337	1874	17952000	30162	14841	5	0	3
394338	1874	17956000	30162	14841	6	0	3
394339	1874	17960000	30162	14841	7	0	3
394340	1874	17964000	30162	14841	8	0	3
394342	1874	17968000	30162	14841	10	0	3
394401	1874	17997000	30164	14842	19	0	\N
394402	1874	17999000	30164	14842	20	0	\N
394403	1874	18001000	30164	14842	21	0	\N
394404	1874	18005000	30164	14842	22	0	\N
394405	1874	18009000	30164	14842	23	0	\N
394406	1874	18013000	30164	14842	24	0	\N
394407	1874	18017000	30164	14842	25	0	\N
394408	1874	18021000	30164	14842	26	0	\N
394409	1874	18025000	30164	14842	27	0	\N
394410	1874	18029000	30164	14842	28	0	\N
394411	1874	18033000	30164	14842	29	0	\N
394412	1874	18037000	30164	14842	31	0	\N
394413	1874	18041000	30164	14842	32	0	\N
394414	1874	18045000	30164	14842	33	0	\N
394415	1874	18049000	30164	14842	34	0	\N
394416	1874	18053000	30164	14842	35	0	\N
394417	1874	18057000	30164	14842	36	0	\N
394418	1874	18061000	30164	14842	37	0	\N
394419	1874	18065000	30164	14842	38	0	\N
394420	1874	18069000	30164	14842	39	0	\N
394460	1678	29520912393000	30166	14842	0	0	\N
394461	1678	29520912394000	30166	14842	1	0	\N
394462	1678	29520912395000	30166	14842	2	0	\N
394463	1678	29520912396000	30166	14842	3	0	\N
394464	1874	17970000	30166	14842	4	0	\N
394465	1874	17974000	30166	14842	5	0	\N
394466	1874	17975000	30166	14842	6	0	\N
394467	1874	17976000	30166	14842	7	0	\N
394468	1874	17977000	30166	14842	8	0	\N
394469	1874	17978000	30166	14842	9	0	\N
394470	1874	17979000	30166	14842	10	0	\N
394471	1874	17981000	30166	14842	11	0	\N
394472	1874	17983000	30166	14842	12	0	\N
394473	1874	17985000	30166	14842	13	0	\N
394474	1874	17987000	30166	14842	14	0	\N
394475	1874	17989000	30166	14842	15	0	\N
394476	1874	17991000	30166	14842	16	0	\N
394477	1874	17993000	30166	14842	17	0	\N
394478	1874	17995000	30166	14842	18	0	\N
394479	1874	17997000	30166	14842	19	0	\N
394480	1874	17999000	30166	14842	20	0	\N
394481	1874	18001000	30166	14842	21	0	\N
394482	1874	18005000	30166	14842	22	0	\N
394483	1874	18009000	30166	14842	23	0	\N
394484	1874	18013000	30166	14842	24	0	\N
394485	1874	18017000	30166	14842	25	0	\N
394486	1874	18021000	30166	14842	26	0	\N
394487	1874	18025000	30166	14842	27	0	\N
394488	1874	18029000	30166	14842	28	0	\N
394489	1874	18033000	30166	14842	29	0	\N
394490	1874	18037000	30166	14842	31	0	\N
394491	1874	18041000	30166	14842	32	0	\N
394492	1874	18045000	30166	14842	33	0	\N
394493	1874	18049000	30166	14842	34	0	\N
394494	1874	18053000	30166	14842	35	0	\N
394495	1874	18057000	30166	14842	36	0	\N
394496	1874	18061000	30166	14842	37	0	\N
394497	1874	18065000	30166	14842	38	0	\N
394498	1874	18069000	30166	14842	39	0	\N
394499	1678	29520912397000	30167	14843	0	0	\N
394500	1874	18071000	30167	14843	1	0	\N
394501	1874	18072000	30167	14843	2	0	\N
394502	1874	18074000	30167	14843	3	0	\N
394503	1874	18078000	30167	14843	4	0	\N
394504	1874	18082000	30167	14843	5	0	\N
394505	1874	18086000	30167	14843	6	0	\N
394506	1874	18090000	30167	14843	7	0	\N
394507	1874	18091000	30167	14843	8	0	\N
394508	1678	29520912397000	30168	14843	0	0	\N
394509	1874	18071000	30168	14843	1	0	\N
394510	1874	18072000	30168	14843	2	0	\N
394511	1874	18076000	30168	14843	3	0	\N
394512	1874	18080000	30168	14843	4	0	\N
394513	1874	18084000	30168	14843	5	0	\N
394514	1874	18088000	30168	14843	6	0	\N
394515	1874	18089000	30168	14843	7	0	\N
394525	1678	29520912398000	30170	14844	0	0	\N
394526	1874	18093000	30170	14844	1	0	\N
394527	1874	18097000	30170	14844	2	0	\N
394528	1874	18099000	30170	14844	3	0	\N
394529	1874	18100000	30170	14844	4	0	\N
394530	1874	18104000	30170	14844	5	0	\N
394531	1874	18108000	30170	14844	6	0	\N
394532	1874	18112000	30170	14844	7	0	\N
394533	1678	29520912398000	30171	14844	0	0	\N
394534	1874	18093000	30171	14844	1	0	\N
394535	1874	18097000	30171	14844	2	0	\N
394536	1874	18099000	30171	14844	3	0	\N
394423	1678	29520912395000	30165	14842	2	0	1
394424	1678	29520912396000	30165	14842	3	0	1
394425	1874	17970000	30165	14842	4	0	3
394426	1874	17974000	30165	14842	5	0	3
394427	1874	17975000	30165	14842	6	0	3
394429	1874	17977000	30165	14842	8	0	3
394430	1874	17978000	30165	14842	9	0	3
394431	1874	17979000	30165	14842	10	0	3
394432	1874	17981000	30165	14842	11	0	3
394433	1874	17983000	30165	14842	12	0	3
394435	1874	17987000	30165	14842	14	0	3
394436	1874	17989000	30165	14842	15	0	3
394437	1874	17991000	30165	14842	16	0	3
394438	1874	17993000	30165	14842	17	0	3
394440	1874	17997000	30165	14842	19	0	3
394441	1874	17999000	30165	14842	20	0	3
394442	1874	18001000	30165	14842	21	0	3
394443	1874	18005000	30165	14842	22	0	3
394444	1874	18009000	30165	14842	23	0	3
394446	1874	18017000	30165	14842	25	0	3
394447	1874	18021000	30165	14842	26	0	3
394448	1874	18025000	30165	14842	27	0	3
394449	1874	18029000	30165	14842	28	0	3
394450	1874	18033000	30165	14842	29	0	3
394452	1874	18041000	30165	14842	32	0	3
394453	1874	18045000	30165	14842	33	0	3
394454	1874	18049000	30165	14842	34	0	3
394455	1874	18053000	30165	14842	35	0	3
394457	1874	18061000	30165	14842	37	0	3
394458	1874	18065000	30165	14842	38	0	3
394459	1874	18069000	30165	14842	39	0	3
394516	1678	29520912397000	30169	14843	0	0	1
394517	1874	18071000	30169	14843	1	0	3
394519	1874	18074000	30169	14843	3	0	3
394520	1874	18078000	30169	14843	4	0	3
394521	1874	18082000	30169	14843	5	0	3
394522	1874	18086000	30169	14843	6	0	3
394523	1874	18090000	30169	14843	7	0	3
394537	1874	18100000	30171	14844	4	0	\N
394538	1874	18104000	30171	14844	5	0	\N
394539	1874	18108000	30171	14844	6	0	\N
394540	1874	18112000	30171	14844	7	0	\N
394549	1678	29520912399000	30173	14845	0	0	\N
394550	1874	18116000	30173	14845	1	0	\N
394551	1874	18118000	30173	14845	2	0	\N
394552	1874	18120000	30173	14845	3	0	\N
394553	1874	18124000	30173	14845	4	0	\N
394554	1874	18128000	30173	14845	5	0	\N
394555	1874	18132000	30173	14845	6	0	\N
394556	1874	18133000	30173	14845	7	0	\N
394557	1874	18134000	30173	14845	8	0	\N
394577	2238	1002997000000	30176	14594	0	0	\N
394578	455	66002000000000	30176	14594	1	0	\N
394579	707	9002150000000	30176	14594	2	0	\N
394580	2439	99000000000	30176	14594	3	0	\N
394581	1483	11000000	30176	14594	4	0	\N
394582	718	2000002000000	30176	14594	6	0	\N
394583	155	66000435000000	30176	14594	7	0	\N
394584	342	66277931638598	30176	14594	8	0	\N
394585	1678	29520912401000	30177	14847	0	0	\N
394586	1678	29520912402000	30177	14847	1	0	\N
394587	1874	18161000	30177	14847	2	0	\N
394588	1874	18163000	30177	14847	3	0	\N
394589	1874	18164000	30177	14847	4	0	\N
394590	1874	18166000	30177	14847	5	0	\N
394591	1874	18168000	30177	14847	6	0	\N
394592	1874	18170000	30177	14847	7	0	\N
394593	1874	18171000	30177	14847	8	0	\N
394594	1874	18172000	30177	14847	9	0	\N
394595	1874	18176000	30177	14847	10	0	\N
394596	1874	18180000	30177	14847	11	0	\N
394597	1874	18184000	30177	14847	12	0	\N
394598	1874	18188000	30177	14847	13	0	\N
394599	1874	18192000	30177	14847	14	0	\N
394600	1874	18196000	30177	14847	15	0	\N
394601	1874	18200000	30177	14847	16	0	\N
394602	1874	18204000	30177	14847	17	0	\N
394603	1874	18208000	30177	14847	18	0	\N
394604	1678	29520912401000	30178	14847	0	0	\N
394605	1678	29520912402000	30178	14847	1	0	\N
394606	1874	18161000	30178	14847	2	0	\N
394607	1874	18163000	30178	14847	3	0	\N
394608	1874	18164000	30178	14847	4	0	\N
394609	1874	18166000	30178	14847	5	0	\N
394610	1874	18168000	30178	14847	6	0	\N
394611	1874	18170000	30178	14847	7	0	\N
394612	1874	18171000	30178	14847	8	0	\N
394613	1874	18172000	30178	14847	9	0	\N
394633	1678	29520912403000	30180	14848	0	0	\N
394634	1874	18210000	30180	14848	1	0	\N
394635	1874	18212000	30180	14848	2	0	\N
394636	1874	18213000	30180	14848	3	0	\N
394637	1874	18217000	30180	14848	4	0	\N
394638	1874	18221000	30180	14848	5	0	\N
394639	1874	18225000	30180	14848	6	0	\N
394640	1874	18229000	30180	14848	7	0	\N
394649	1678	29520912403000	30182	14848	0	0	\N
394650	1874	18210000	30182	14848	1	0	\N
394651	1874	18212000	30182	14848	2	0	\N
394652	1874	18213000	30182	14848	3	0	\N
394662	1678	29520912404000	30184	14849	0	0	\N
394663	1874	18230000	30184	14849	1	0	\N
394664	1874	18232000	30184	14849	2	0	\N
394665	1874	18233000	30184	14849	3	0	\N
394666	1874	18237000	30184	14849	4	0	\N
394667	1874	18241000	30184	14849	5	0	\N
394668	1874	18245000	30184	14849	6	0	\N
394669	1874	18249000	30184	14849	7	0	\N
394670	2431	769714905251	30185	14587	0	0	\N
394671	1646	1813000000	30185	14587	2	0	\N
394672	2238	1002997000000	30185	14587	3	0	\N
394543	1874	18097000	30172	14844	2	0	3
394544	1874	18099000	30172	14844	3	0	3
394545	1874	18100000	30172	14844	4	0	3
394546	1874	18104000	30172	14844	5	0	3
394547	1874	18108000	30172	14844	6	0	3
394558	1678	29520912399000	30174	14845	0	0	1
394559	1874	18116000	30174	14845	1	0	3
394560	1874	18118000	30174	14845	2	0	3
394561	1874	18120000	30174	14845	3	0	3
394562	1874	18124000	30174	14845	4	0	3
394564	1874	18132000	30174	14845	6	0	3
394565	1874	18133000	30174	14845	7	0	3
394566	1874	18134000	30174	14845	8	0	3
394567	1678	29520912400000	30175	14846	0	0	1
394569	1874	18138000	30175	14846	2	0	3
394570	1874	18139000	30175	14846	3	0	3
394571	2441	0	30175	14846	4	0	0
394572	1874	18143000	30175	14846	5	0	3
394573	1874	18147000	30175	14846	6	0	3
394575	1874	18155000	30175	14846	8	0	3
394576	1874	18159000	30175	14846	9	0	3
394614	1678	29520912401000	30179	14847	0	0	1
394615	1678	29520912402000	30179	14847	1	0	1
394616	1874	18161000	30179	14847	2	0	3
394618	1874	18164000	30179	14847	4	0	3
394619	1874	18166000	30179	14847	5	0	3
394620	1874	18168000	30179	14847	6	0	3
394621	1874	18170000	30179	14847	7	0	3
394623	1874	18172000	30179	14847	9	0	3
394624	1874	18176000	30179	14847	10	0	3
394625	1874	18180000	30179	14847	11	0	3
394626	1874	18184000	30179	14847	12	0	3
394627	1874	18188000	30179	14847	13	0	3
394629	1874	18196000	30179	14847	15	0	3
394630	1874	18200000	30179	14847	16	0	3
394631	1874	18204000	30179	14847	17	0	3
394632	1874	18208000	30179	14847	18	0	3
394641	1678	29520912403000	30181	14848	0	0	1
394643	1874	18212000	30181	14848	2	0	3
394644	1874	18213000	30181	14848	3	0	3
394645	1874	18217000	30181	14848	4	0	3
394646	1874	18221000	30181	14848	5	0	3
394648	1874	18229000	30181	14848	7	0	3
394653	1678	29520912404000	30183	14849	0	0	1
394654	1874	18230000	30183	14849	1	0	3
394655	1874	18232000	30183	14849	2	0	3
394656	1874	18234000	30183	14849	3	0	3
394658	1874	18239000	30183	14849	5	0	3
394659	1874	18243000	30183	14849	6	0	3
394660	1874	18247000	30183	14849	7	0	3
394661	1874	18251000	30183	14849	8	0	3
394673	677	66001000000000	30185	14587	4	0	\N
394674	1876	704963880000	30185	14587	5	0	\N
394675	1646	1913000000	30185	14587	6	0	\N
394676	1483	11000000	30185	14587	7	0	\N
394677	1578	23000000000	30185	14587	8	0	\N
394678	455	66002000000000	30185	14587	9	0	\N
394679	724	20002150000000	30185	14587	10	0	\N
394680	707	9002150000000	30185	14587	11	0	\N
394681	1956	3000000000	30185	14587	12	0	\N
394682	1299	1706538047667750	30185	14587	13	0	\N
394683	2439	99000000000	30185	14587	14	0	\N
394684	2430	189526998000	30185	14587	15	0	\N
394685	1483	11000000	30185	14587	16	0	\N
394686	1428	2159632000000	30185	14587	17	0	\N
394687	1483	11000000	30185	14587	18	0	\N
394688	1269	3000000	30185	14587	21	0	\N
394689	1269	4000000	30185	14587	22	0	\N
394690	718	2000002000000	30185	14587	23	0	\N
394691	155	66000435000000	30185	14587	24	0	\N
394692	342	66277931638598	30185	14587	25	0	\N
394693	1591	1611000000	30185	14587	27	0	\N
394694	1269	5000000	30185	14587	29	0	\N
394695	1269	6000000	30185	14587	30	0	\N
394696	2428	200000000	30185	14587	31	0	\N
394697	186	66846521394804	30185	14587	32	0	\N
394698	2441	0	30185	14587	33	0	\N
394699	712	6001000000000	30185	14587	34	0	\N
394700	894	311162277935181	30185	14587	35	0	\N
394701	569	66933430434669	30185	14587	36	0	\N
394702	390	66933430434669	30185	14587	37	0	\N
394703	570	66933430434669	30185	14587	38	0	\N
394704	251	66933430434669	30185	14587	39	0	\N
394705	312	66276827024809	30185	14587	40	0	\N
394706	1772	6689445300164	30185	14587	41	0	\N
394707	1030	913716893004926	30185	14587	42	0	\N
394708	238	66086983695901	30185	14587	43	0	\N
394709	120	66277730799728	30185	14587	44	0	\N
394710	320	66651050983763	30185	14587	45	0	\N
394711	354	66279227049307	30185	14587	46	0	\N
394712	663	66933430434669	30185	14587	47	0	\N
394713	710	5070714426784	30185	14587	48	0	\N
394714	499	66933430434669	30185	14587	49	0	\N
394715	2440	0	30185	14587	53	0	\N
394716	718	2000003000000	30185	14587	55	0	\N
394717	1269	7000000	30185	14587	56	0	\N
394718	1269	8000000	30185	14587	57	0	\N
394719	1269	9000000	30185	14587	58	0	\N
394720	1269	10000000	30185	14587	59	0	\N
394721	1269	11000000	30185	14587	60	0	\N
394722	1269	12000000	30185	14587	61	0	\N
394723	1269	13000000	30185	14587	62	0	\N
394724	1269	14000000	30185	14587	64	0	\N
394725	1269	15000000	30185	14587	65	0	\N
394726	1269	16000000	30185	14587	66	0	\N
394727	2440	1000000000	30185	14587	67	0	\N
394728	2440	2000000000	30185	14587	68	0	\N
394729	1269	17000000	30185	14587	69	0	\N
394730	1269	18000000	30185	14587	70	0	\N
394731	1811	2555508410581	30185	14587	71	0	\N
394732	520	66933430434669	30185	14587	72	0	\N
394733	191	66933430434669	30185	14587	73	0	\N
394734	421	66930330434669	30185	14587	74	0	\N
394742	1678	29520912406000	30187	14851	0	0	\N
394743	1678	29520912407000	30187	14851	1	0	\N
394744	1874	18272000	30187	14851	2	0	\N
394745	1874	18274000	30187	14851	3	0	\N
394746	1874	18276000	30187	14851	4	0	\N
394747	1874	18278000	30187	14851	5	0	\N
394748	1874	18280000	30187	14851	6	0	\N
394749	1874	18282000	30187	14851	7	0	\N
394750	1678	29520912406000	30188	14851	0	0	\N
394751	1678	29520912407000	30188	14851	1	0	\N
394752	1874	18271000	30188	14851	2	0	\N
394753	1874	18273000	30188	14851	3	0	\N
394754	1874	18277000	30188	14851	4	0	\N
394755	1874	18281000	30188	14851	5	0	\N
394756	1874	18283000	30188	14851	6	0	\N
394757	1874	18285000	30188	14851	7	0	\N
394758	1874	18287000	30188	14851	8	0	\N
394759	1874	18289000	30188	14851	9	0	\N
394760	1874	18291000	30188	14851	10	0	\N
394761	1874	18292000	30188	14851	11	0	\N
394762	1874	18293000	30188	14851	12	0	\N
394763	1874	18297000	30188	14851	13	0	\N
394764	1874	18301000	30188	14851	14	0	\N
394765	1874	18305000	30188	14851	16	0	\N
394766	1874	18309000	30188	14851	17	0	\N
394767	1874	18313000	30188	14851	18	0	\N
394768	1874	18317000	30188	14851	19	0	\N
394769	1874	18321000	30188	14851	20	0	\N
394770	1678	29520912406000	30189	14851	0	0	\N
394771	1678	29520912407000	30189	14851	1	0	\N
394772	1874	18271000	30189	14851	2	0	\N
394773	1874	18273000	30189	14851	3	0	\N
394774	1874	18275000	30189	14851	4	0	\N
394775	1874	18277000	30189	14851	5	0	\N
394776	1874	18279000	30189	14851	6	0	\N
394777	1874	18281000	30189	14851	7	0	\N
394778	1874	18283000	30189	14851	8	0	\N
394779	1874	18284000	30189	14851	9	0	\N
394780	1874	18285000	30189	14851	10	0	\N
394801	2439	629000000000	30191	14852	0	0	\N
394802	1678	29520912408000	30191	14852	1	0	\N
394803	1874	18323000	30191	14852	2	0	\N
394804	1874	18325000	30191	14852	3	0	\N
394805	1874	18329000	30191	14852	4	0	\N
394806	1874	18330000	30191	14852	5	0	\N
394807	1874	18331000	30191	14852	6	0	\N
394808	1874	18335000	30191	14852	7	0	\N
394737	1874	18256000	30186	14850	2	0	3
394738	1874	18258000	30186	14850	3	0	3
394739	1874	18262000	30186	14850	4	0	3
394740	1874	18266000	30186	14850	5	0	3
394741	1874	18270000	30186	14850	6	0	3
394782	1678	29520912407000	30190	14851	1	0	1
394783	1874	18271000	30190	14851	2	0	3
394784	1874	18273000	30190	14851	3	0	3
394785	1874	18277000	30190	14851	4	0	3
394786	1874	18281000	30190	14851	5	0	3
394788	1874	18285000	30190	14851	7	0	3
394789	1874	18287000	30190	14851	8	0	3
394790	1874	18289000	30190	14851	9	0	3
394791	1874	18291000	30190	14851	10	0	3
394793	1874	18293000	30190	14851	12	0	3
394794	1874	18297000	30190	14851	13	0	3
394795	1874	18301000	30190	14851	14	0	3
394796	1874	18305000	30190	14851	16	0	3
394797	1874	18309000	30190	14851	17	0	3
394799	1874	18317000	30190	14851	19	0	3
394800	1874	18321000	30190	14851	20	0	3
394809	1874	18339000	30191	14852	8	0	\N
394810	1874	18343000	30191	14852	9	0	\N
394821	2441	2010000000	30193	14853	0	0	\N
394822	1726	113512112000	30193	14853	1	0	\N
394823	1540	0	30193	14853	2	0	\N
394824	1874	18344000	30193	14853	3	0	\N
394825	1874	18346000	30193	14853	4	0	\N
394826	1874	18347000	30193	14853	5	0	\N
394827	1874	18348000	30193	14853	6	0	\N
394828	1874	18350000	30193	14853	7	0	\N
394829	1874	18352000	30193	14853	8	0	\N
394830	1874	18356000	30193	14853	10	0	\N
394831	1874	18360000	30193	14853	11	0	\N
394832	1874	18362000	30193	14853	12	0	\N
394833	975	508710445186036	30193	14853	13	0	\N
394834	1874	18366000	30193	14853	14	0	\N
394835	1874	18370000	30193	14853	15	0	\N
394836	1874	18374000	30193	14853	16	0	\N
394837	1874	18378000	30193	14853	17	0	\N
394838	1874	18382000	30193	14853	18	0	\N
394839	1874	18386000	30193	14853	19	0	\N
394840	1095	911604759142284	30193	14853	20	0	\N
394841	1215	615077896001284	30193	14853	21	0	\N
394842	1341	1713969246884862	30193	14853	22	0	\N
394843	1874	18390000	30193	14853	23	0	\N
394844	2441	2010000000	30194	14853	0	0	\N
394845	1726	113512112000	30194	14853	1	0	\N
394846	1540	0	30194	14853	2	0	\N
394847	1874	18345000	30194	14853	3	0	\N
394848	1874	18347000	30194	14853	4	0	\N
394849	1874	18349000	30194	14853	5	0	\N
394850	1874	18351000	30194	14853	7	0	\N
394851	975	508710445186036	30194	14853	8	0	\N
394852	1095	911604759142284	30194	14853	9	0	\N
394853	1215	615077896001284	30194	14853	10	0	\N
394854	1341	1713969246884862	30194	14853	11	0	\N
394883	2440	3000000000	30197	14854	0	0	\N
394884	1874	18391000	30197	14854	1	0	\N
394885	1874	18395000	30197	14854	2	0	\N
394886	1874	18399000	30197	14854	3	0	\N
394887	1874	18403000	30197	14854	4	0	\N
394888	1874	18407000	30197	14854	5	0	\N
394889	1874	18409000	30197	14854	6	0	\N
394890	1874	18411000	30197	14854	7	0	\N
394891	1874	18413000	30197	14854	8	0	\N
394892	2439	629000000000	30198	14838	0	0	\N
394893	1540	0	30198	14838	1	0	\N
394894	975	508710445186036	30198	14838	3	0	\N
394895	1095	911604759142284	30198	14838	4	0	\N
394896	1215	615077896001284	30198	14838	5	0	\N
394897	1341	1713969246884862	30198	14838	6	0	\N
394918	1678	29520912409000	30200	14855	0	0	\N
394919	1874	18401000	30200	14855	1	0	\N
394920	1874	18402000	30200	14855	2	0	\N
394921	1874	18404000	30200	14855	3	0	\N
394922	1874	18406000	30200	14855	4	0	\N
394923	1874	18408000	30200	14855	5	0	\N
394924	1874	18409000	30200	14855	6	0	\N
394925	1874	18413000	30200	14855	7	0	\N
394926	1874	18417000	30200	14855	8	0	\N
394927	1874	18421000	30200	14855	9	0	\N
394928	1874	18425000	30200	14855	10	0	\N
394929	1874	18429000	30200	14855	11	0	\N
394930	1874	18433000	30200	14855	12	0	\N
394931	1874	18437000	30200	14855	13	0	\N
394932	1874	18441000	30200	14855	14	0	\N
394933	1874	18445000	30200	14855	15	0	\N
394934	1874	18446000	30200	14855	16	0	\N
394935	1874	18450000	30200	14855	17	0	\N
394936	1874	18454000	30200	14855	18	0	\N
394937	1874	18456000	30200	14855	19	0	\N
394938	2441	7010000000	30202	14856	0	0	\N
394939	1678	29520912410000	30202	14856	1	0	\N
394940	1678	29520912411000	30202	14856	2	0	\N
394941	1874	18458000	30202	14856	3	0	\N
394942	1874	18459000	30202	14856	4	0	\N
394943	1874	18463000	30202	14856	5	0	\N
394944	1874	18464000	30202	14856	6	0	\N
394813	1874	18323000	30192	14852	2	0	3
394814	1874	18325000	30192	14852	3	0	3
394815	1874	18329000	30192	14852	4	0	3
394816	1874	18330000	30192	14852	5	0	3
394817	1874	18331000	30192	14852	6	0	3
394819	1874	18339000	30192	14852	8	0	3
394820	1874	18343000	30192	14852	9	0	3
394855	2441	2010000000	30195	14853	0	0	0
394856	1726	113512112000	30195	14853	1	0	8373
394857	1540	0	30195	14853	2	0	6
394859	1874	18346000	30195	14853	4	0	3
394860	1874	18347000	30195	14853	5	0	3
394861	1874	18348000	30195	14853	6	0	3
394862	1874	18350000	30195	14853	7	0	3
394864	1874	18356000	30195	14853	10	0	3
394865	1874	18360000	30195	14853	11	0	3
394866	1874	18362000	30195	14853	12	0	3
394867	975	508710445186036	30195	14853	13	0	0
394868	1874	18366000	30195	14853	14	0	3
394870	1874	18374000	30195	14853	16	0	3
394871	1874	18378000	30195	14853	17	0	3
394872	1874	18382000	30195	14853	18	0	3
394873	1874	18386000	30195	14853	19	0	3
394874	1095	911604759142284	30195	14853	20	0	0
394876	1341	1713969246884862	30195	14853	22	0	0
394877	1874	18390000	30195	14853	23	0	3
394878	2440	3000000000	30196	14854	0	0	0
394879	1874	18391000	30196	14854	1	0	3
394881	1874	18395000	30196	14854	3	0	3
394882	1874	18397000	30196	14854	4	0	3
394898	1678	29520912409000	30199	14855	0	0	1
394899	1874	18401000	30199	14855	1	0	3
394900	1874	18402000	30199	14855	2	0	3
394902	1874	18406000	30199	14855	4	0	3
394903	1874	18408000	30199	14855	5	0	3
394904	1874	18409000	30199	14855	6	0	3
394905	1874	18413000	30199	14855	7	0	3
394906	1874	18417000	30199	14855	8	0	3
394908	1874	18425000	30199	14855	10	0	3
394909	1874	18429000	30199	14855	11	0	3
394910	1874	18433000	30199	14855	12	0	3
394911	1874	18437000	30199	14855	13	0	3
394913	1874	18445000	30199	14855	15	0	3
394914	1874	18446000	30199	14855	16	0	3
394915	1874	18450000	30199	14855	17	0	3
394916	1874	18454000	30199	14855	18	0	3
394917	1874	18456000	30199	14855	19	0	3
394945	1874	18465000	30202	14856	7	0	\N
394946	1874	18469000	30202	14856	8	0	\N
394947	1874	18473000	30202	14856	9	0	\N
394948	1874	18475000	30202	14856	10	0	\N
394949	1874	18479000	30202	14856	11	0	\N
394950	1874	18483000	30202	14856	12	0	\N
394951	1874	18487000	30202	14856	13	0	\N
394952	1874	18491000	30202	14856	14	0	\N
394953	1874	18495000	30202	14856	15	0	\N
394954	1874	18499000	30202	14856	16	0	\N
394955	1874	18501000	30202	14856	17	0	\N
394956	1874	18503000	30202	14856	18	0	\N
394957	1874	18505000	30202	14856	19	0	\N
394958	1874	18507000	30202	14856	20	0	\N
394980	2441	927010000000	30204	14857	0	0	\N
394981	1678	29520912412000	30204	14857	1	0	\N
394982	1874	18508000	30204	14857	2	0	\N
394983	1874	18509000	30204	14857	3	0	\N
394984	1874	18513000	30204	14857	4	0	\N
394985	1874	18517000	30204	14857	5	0	\N
394986	2442	0	30204	14857	6	0	\N
394987	1874	18521000	30204	14857	7	0	\N
394988	1874	18525000	30204	14857	8	0	\N
394989	1874	18529000	30204	14857	9	0	\N
394990	1874	18531000	30204	14857	10	0	\N
394991	1874	18533000	30204	14857	11	0	\N
394992	2441	927010000000	30205	14857	0	0	\N
394993	1678	29520912412000	30205	14857	1	0	\N
394994	1874	18508000	30205	14857	2	0	\N
394995	1874	18509000	30205	14857	3	0	\N
394996	1874	18513000	30205	14857	4	0	\N
394997	1874	18517000	30205	14857	5	0	\N
394998	2442	0	30205	14857	6	0	\N
394999	1874	18521000	30205	14857	7	0	\N
395000	1874	18525000	30205	14857	8	0	\N
395001	1874	18529000	30205	14857	9	0	\N
395002	1874	18531000	30205	14857	10	0	\N
395003	1874	18533000	30205	14857	11	0	\N
395004	2441	927010000000	30206	14857	0	0	\N
395005	1678	29520912412000	30206	14857	1	0	\N
395006	1874	18508000	30206	14857	2	0	\N
395007	1874	18509000	30206	14857	3	0	\N
395008	1874	18513000	30206	14857	4	0	\N
395009	1874	18517000	30206	14857	5	0	\N
395010	2442	0	30206	14857	6	0	\N
395011	1874	18521000	30206	14857	7	0	\N
395012	1874	18525000	30206	14857	8	0	\N
395013	1874	18529000	30206	14857	9	0	\N
395014	1874	18531000	30206	14857	10	0	\N
395015	1874	18533000	30206	14857	11	0	\N
395016	2439	629000000000	30207	14832	0	0	\N
395017	1678	29520912381000	30207	14832	1	0	\N
395018	1678	29520912382000	30207	14832	2	0	\N
395019	1678	29520912383000	30207	14832	3	0	\N
395020	1678	29520912384000	30207	14832	4	0	\N
395021	1678	29520912385000	30207	14832	5	0	\N
395022	1678	29520912386000	30207	14832	6	0	\N
395023	1678	29520912387000	30207	14832	7	0	\N
395024	1678	29520912388000	30207	14832	8	0	\N
395025	1678	29520912389000	30207	14832	9	0	\N
395026	1678	29520912390000	30207	14832	10	0	\N
395027	1678	29520912391000	30207	14832	11	0	\N
395028	1678	29520912392000	30207	14832	12	0	\N
395029	1678	29520912393000	30207	14832	13	0	\N
395030	1678	29520912394000	30207	14832	14	0	\N
395031	1678	29520912395000	30207	14832	15	0	\N
395032	1678	29520912396000	30207	14832	16	0	\N
395033	1678	29520912397000	30207	14832	17	0	\N
395034	1678	29520912398000	30207	14832	18	0	\N
395035	1678	29520912399000	30207	14832	19	0	\N
395036	1678	29520912400000	30207	14832	20	0	\N
395037	1678	29520912401000	30207	14832	21	0	\N
395038	1678	29520912402000	30207	14832	22	0	\N
395039	1678	29520912403000	30207	14832	23	0	\N
395040	1678	29520912404000	30207	14832	24	0	\N
395041	1678	29520912405000	30207	14832	25	0	\N
395042	1678	29520912406000	30207	14832	26	0	\N
395043	1678	29520912407000	30207	14832	27	0	\N
395044	1678	29520912408000	30207	14832	28	0	\N
395045	1678	29520912409000	30207	14832	29	0	\N
395046	1678	29520912410000	30207	14832	30	0	\N
395047	1678	29520912411000	30207	14832	31	0	\N
395048	1678	29520912412000	30207	14832	32	0	\N
395049	1540	0	30207	14832	33	0	\N
395050	1874	17684000	30207	14832	34	0	\N
395051	1874	17688000	30207	14832	36	0	\N
395052	2441	0	30207	14832	37	0	\N
395053	2441	2010000000	30207	14832	38	0	\N
395054	1726	113512112000	30207	14832	39	0	\N
395055	2441	7010000000	30207	14832	40	0	\N
395056	2441	927010000000	30207	14832	41	0	\N
395057	2442	0	30207	14832	43	0	\N
395058	1874	17690000	30207	14832	44	0	\N
395059	1874	17692000	30207	14832	45	0	\N
395060	1874	17694000	30207	14832	46	0	\N
395061	1874	17696000	30207	14832	47	0	\N
395062	1874	17698000	30207	14832	48	0	\N
395063	975	508710445186036	30207	14832	49	0	\N
395064	1874	17699000	30207	14832	50	0	\N
395065	1874	17700000	30207	14832	51	0	\N
395066	1874	17704000	30207	14832	52	0	\N
395067	1874	17708000	30207	14832	53	0	\N
395068	1874	17712000	30207	14832	54	0	\N
395069	1874	17716000	30207	14832	55	0	\N
395070	1874	17720000	30207	14832	56	0	\N
395071	1874	17724000	30207	14832	57	0	\N
395072	1874	17728000	30207	14832	58	0	\N
395073	1874	17732000	30207	14832	59	0	\N
395074	1874	17736000	30207	14832	60	0	\N
395075	1874	17740000	30207	14832	61	0	\N
395076	1874	17744000	30207	14832	62	0	\N
395077	1874	17748000	30207	14832	63	0	\N
395078	1874	17752000	30207	14832	64	0	\N
395079	1874	17756000	30207	14832	65	0	\N
395080	1874	17760000	30207	14832	66	0	\N
394961	1678	29520912411000	30203	14856	2	0	1
394962	1874	18458000	30203	14856	3	0	3
394963	1874	18459000	30203	14856	4	0	3
394964	1874	18463000	30203	14856	5	0	3
394965	1874	18464000	30203	14856	6	0	3
394967	1874	18469000	30203	14856	8	0	3
394968	1874	18473000	30203	14856	9	0	3
394969	1874	18475000	30203	14856	10	0	3
394970	1874	18479000	30203	14856	11	0	3
394971	1874	18483000	30203	14856	12	0	3
394973	1874	18491000	30203	14856	14	0	3
394974	1874	18495000	30203	14856	15	0	3
394975	1874	18499000	30203	14856	16	0	3
394976	1874	18501000	30203	14856	17	0	3
394978	1874	18505000	30203	14856	19	0	3
394979	1874	18507000	30203	14856	20	0	3
395081	1874	17764000	30207	14832	67	0	\N
395082	1874	17768000	30207	14832	68	0	\N
395083	1874	17772000	30207	14832	69	0	\N
395084	1874	17776000	30207	14832	70	0	\N
395085	1874	17780000	30207	14832	71	0	\N
395086	1874	17784000	30207	14832	72	0	\N
395087	1874	17788000	30207	14832	73	0	\N
395088	1874	17792000	30207	14832	74	0	\N
395089	1874	17796000	30207	14832	75	0	\N
395090	1874	17798000	30207	14832	76	0	\N
395091	1874	17800000	30207	14832	77	0	\N
395092	1874	17802000	30207	14832	78	0	\N
395093	1874	17804000	30207	14832	79	0	\N
395094	1874	17806000	30207	14832	80	0	\N
395095	1874	17808000	30207	14832	81	0	\N
395096	1874	17810000	30207	14832	82	0	\N
395097	1874	17812000	30207	14832	83	0	\N
395098	1874	17814000	30207	14832	84	0	\N
395099	1874	17816000	30207	14832	85	0	\N
395100	1874	17818000	30207	14832	86	0	\N
395101	1874	17819000	30207	14832	87	0	\N
395102	1874	17820000	30207	14832	88	0	\N
395103	1874	17821000	30207	14832	89	0	\N
395104	1874	17822000	30207	14832	90	0	\N
395105	1874	17823000	30207	14832	91	0	\N
395106	1874	17824000	30207	14832	92	0	\N
395107	1095	911604759142284	30207	14832	93	0	\N
395108	1215	615077896001284	30207	14832	94	0	\N
395109	1341	1713969246884862	30207	14832	95	0	\N
395110	1874	17826000	30207	14832	96	0	\N
395111	1874	17828000	30207	14832	97	0	\N
395112	1874	17830000	30207	14832	98	0	\N
395113	1874	17832000	30207	14832	99	0	\N
395114	1874	17834000	30207	14832	100	0	\N
395115	1874	17836000	30207	14832	101	0	\N
395116	2440	1000000000	30207	14832	102	0	\N
395117	2440	2000000000	30207	14832	103	0	\N
395118	2440	3000000000	30207	14832	104	0	\N
395119	1874	17840000	30207	14832	105	0	\N
395120	1874	17844000	30207	14832	106	0	\N
395121	1874	17848000	30207	14832	107	0	\N
395122	1874	17852000	30207	14832	108	0	\N
395123	1874	17856000	30207	14832	109	0	\N
395124	1874	17860000	30207	14832	110	0	\N
395125	1874	17864000	30207	14832	111	0	\N
395126	1874	17868000	30207	14832	112	0	\N
395127	1874	17872000	30207	14832	113	0	\N
395128	1874	17876000	30207	14832	114	0	\N
395129	1874	17880000	30207	14832	115	0	\N
395130	1874	17884000	30207	14832	116	0	\N
395131	1874	17888000	30207	14832	117	0	\N
395132	1874	17892000	30207	14832	118	0	\N
395133	1874	17896000	30207	14832	119	0	\N
395134	1874	17900000	30207	14832	120	0	\N
395137	1678	29520912412000	30210	14858	0	0	\N
395138	1678	29520912413000	30210	14858	1	0	\N
395139	1678	29520912414000	30210	14858	2	0	\N
395140	1874	18508000	30210	14858	3	0	\N
395141	1874	18509000	30210	14858	4	0	\N
395142	1874	18513000	30210	14858	5	0	\N
395143	1874	18517000	30210	14858	6	0	\N
395144	1874	18518000	30210	14858	7	0	\N
395145	1874	18522000	30210	14858	8	0	\N
395146	1874	18526000	30210	14858	9	0	\N
395147	1874	18530000	30210	14858	10	0	\N
395148	1874	18534000	30210	14858	11	0	\N
395149	1874	18536000	30210	14858	12	0	\N
395150	1874	18538000	30210	14858	13	0	\N
395151	2444	100000000	30210	14858	14	0	\N
395152	2445	100000000	30210	14858	15	0	\N
395153	2446	100000000	30210	14858	16	0	\N
395154	1874	18542000	30210	14858	17	0	\N
395155	1874	18546000	30210	14858	18	0	\N
395156	1874	18547000	30210	14858	20	0	\N
395157	1874	18548000	30210	14858	21	0	\N
395158	1874	18552000	30210	14858	22	0	\N
395159	1874	18554000	30210	14858	23	0	\N
395160	1874	18556000	30210	14858	24	0	\N
395161	1874	18558000	30210	14858	25	0	\N
395162	1874	18560000	30210	14858	26	0	\N
395163	1874	18562000	30210	14858	27	0	\N
395164	1874	18564000	30210	14858	28	0	\N
395165	1874	18568000	30210	14858	29	0	\N
395166	1874	18572000	30210	14858	30	0	\N
395167	1874	18576000	30210	14858	31	0	\N
395168	1874	18580000	30210	14858	32	0	\N
395169	1874	18584000	30210	14858	33	0	\N
395170	1678	29520912412000	30211	14858	0	0	\N
395171	1678	29520912413000	30211	14858	1	0	\N
395172	1678	29520912414000	30211	14858	2	0	\N
395173	1874	18508000	30211	14858	3	0	\N
395174	1874	18509000	30211	14858	4	0	\N
395175	1874	18513000	30211	14858	5	0	\N
395176	1874	18517000	30211	14858	6	0	\N
395177	1874	18518000	30211	14858	7	0	\N
395178	1874	18522000	30211	14858	8	0	\N
395179	1874	18526000	30211	14858	9	0	\N
395180	1874	18530000	30211	14858	10	0	\N
395181	1874	18534000	30211	14858	11	0	\N
395182	1874	18536000	30211	14858	12	0	\N
395183	1874	18538000	30211	14858	13	0	\N
395184	2444	100000000	30211	14858	14	0	\N
395185	2445	100000000	30211	14858	15	0	\N
395186	2446	100000000	30211	14858	16	0	\N
395187	1874	18542000	30211	14858	17	0	\N
395188	1874	18546000	30211	14858	18	0	\N
395189	1874	18547000	30211	14858	20	0	\N
395190	1874	18548000	30211	14858	21	0	\N
395191	1874	18552000	30211	14858	22	0	\N
395192	1874	18554000	30211	14858	23	0	\N
395193	1874	18556000	30211	14858	24	0	\N
395194	1874	18558000	30211	14858	25	0	\N
395195	1874	18560000	30211	14858	26	0	\N
395196	1874	18562000	30211	14858	27	0	\N
395197	1874	18564000	30211	14858	28	0	\N
395198	1874	18568000	30211	14858	29	0	\N
395199	1874	18572000	30211	14858	30	0	\N
395200	1874	18576000	30211	14858	31	0	\N
395201	1874	18580000	30211	14858	32	0	\N
395202	1678	29520912412000	30213	14858	0	0	\N
395203	1678	29520912413000	30213	14858	1	0	\N
395204	1678	29520912414000	30213	14858	2	0	\N
395205	1874	18508000	30213	14858	3	0	\N
395206	1874	18509000	30213	14858	4	0	\N
395207	1874	18513000	30213	14858	5	0	\N
395208	1874	18517000	30213	14858	6	0	\N
395209	1874	18518000	30213	14858	7	0	\N
395210	1874	18522000	30213	14858	8	0	\N
395211	1874	18526000	30213	14858	9	0	\N
395212	1874	18530000	30213	14858	10	0	\N
395213	1874	18534000	30213	14858	11	0	\N
395214	1874	18536000	30213	14858	12	0	\N
395215	1874	18538000	30213	14858	13	0	\N
395216	2444	100000000	30213	14858	14	0	\N
395217	2445	100000000	30213	14858	15	0	\N
395218	2446	100000000	30213	14858	16	0	\N
395219	1874	18542000	30213	14858	17	0	\N
395220	1874	18546000	30213	14858	18	0	\N
395221	1874	18547000	30213	14858	20	0	\N
395222	1874	18548000	30213	14858	21	0	\N
395223	1874	18552000	30213	14858	22	0	\N
395224	1874	18554000	30213	14858	23	0	\N
395225	1874	18556000	30213	14858	24	0	\N
395226	1874	18558000	30213	14858	25	0	\N
395227	1874	18560000	30213	14858	26	0	\N
395228	1874	18562000	30213	14858	27	0	\N
395229	1874	18564000	30213	14858	28	0	\N
395230	1874	18568000	30213	14858	29	0	\N
395231	1874	18572000	30213	14858	30	0	\N
395232	1874	18576000	30213	14858	31	0	\N
395233	1874	18580000	30213	14858	32	0	\N
395234	1874	18584000	30213	14858	33	0	\N
395268	2440	533000000000	30215	14859	0	0	\N
395269	1678	29520912415000	30215	14859	1	0	\N
395270	1874	18585000	30215	14859	2	0	\N
395271	1874	18589000	30215	14859	3	0	\N
395272	1874	18593000	30215	14859	4	0	\N
395273	1874	18595000	30215	14859	5	0	\N
395274	1874	18597000	30215	14859	6	0	\N
395275	1874	18601000	30215	14859	7	0	\N
395276	1874	18605000	30215	14859	8	0	\N
395277	2442	1000000	30215	14859	9	0	\N
395278	2440	533000000000	30216	14859	0	0	\N
395279	1678	29520912415000	30216	14859	1	0	\N
395280	1874	18585000	30216	14859	2	0	\N
395281	1874	18589000	30216	14859	3	0	\N
395282	1874	18593000	30216	14859	4	0	\N
395283	1874	18595000	30216	14859	5	0	\N
395284	1874	18597000	30216	14859	6	0	\N
395285	1874	18601000	30216	14859	7	0	\N
395286	1874	18605000	30216	14859	8	0	\N
395287	2442	1000000	30216	14859	9	0	\N
395288	2440	533000000000	30217	14859	0	0	\N
395289	1678	29520912415000	30217	14859	1	0	\N
395290	1874	18581000	30217	14859	2	0	\N
395291	1874	18583000	30217	14859	3	0	\N
395292	1874	18587000	30217	14859	4	0	\N
395293	1874	18591000	30217	14859	5	0	\N
395294	1874	18595000	30217	14859	6	0	\N
395295	1874	18597000	30217	14859	7	0	\N
395296	1874	18601000	30217	14859	8	0	\N
395297	2442	1000000	30217	14859	9	0	\N
395298	2440	533000000000	30218	14859	0	0	\N
395299	1678	29520912415000	30218	14859	1	0	\N
395300	1874	18581000	30218	14859	2	0	\N
395301	1874	18583000	30218	14859	3	0	\N
395302	1874	18587000	30218	14859	4	0	\N
395303	1874	18591000	30218	14859	5	0	\N
395304	1874	18595000	30218	14859	6	0	\N
395305	1874	18597000	30218	14859	7	0	\N
395306	1874	18601000	30218	14859	8	0	\N
395307	1874	18605000	30218	14859	9	0	\N
395308	2442	1000000	30218	14859	10	0	\N
395309	2440	533000000000	30219	14859	0	0	\N
395310	1678	29520912415000	30219	14859	1	0	\N
395311	1874	18585000	30219	14859	2	0	\N
395312	1874	18589000	30219	14859	3	0	\N
395313	1874	18593000	30219	14859	4	0	\N
395314	1874	18595000	30219	14859	5	0	\N
395315	1874	18597000	30219	14859	6	0	\N
395316	1874	18601000	30219	14859	7	0	\N
395317	1874	18605000	30219	14859	8	0	\N
395318	2442	1000000	30219	14859	9	0	\N
395346	455	66002000000000	30223	14735	0	0	\N
395347	707	9002150000000	30223	14735	1	0	\N
395348	1678	28800895297000	30223	14735	2	0	\N
395349	2439	99000000000	30223	14735	3	0	\N
395350	2439	629000000000	30223	14735	4	0	\N
395351	1678	28800895298000	30223	14735	5	0	\N
395352	1678	28800895299000	30223	14735	6	0	\N
395237	1678	29520912414000	30214	14858	2	0	1
395238	1874	18508000	30214	14858	3	0	3
395239	1874	18509000	30214	14858	4	0	3
395240	1874	18513000	30214	14858	5	0	3
395241	1874	18517000	30214	14858	6	0	3
395243	1874	18522000	30214	14858	8	0	3
395244	1874	18526000	30214	14858	9	0	3
395245	1874	18530000	30214	14858	10	0	3
395246	1874	18534000	30214	14858	11	0	3
395247	1874	18536000	30214	14858	12	0	3
395249	2444	100000000	30214	14858	14	0	0
395250	2445	100000000	30214	14858	15	0	0
395251	2446	100000000	30214	14858	16	0	0
395252	1874	18542000	30214	14858	17	0	3
395254	1874	18547000	30214	14858	20	0	3
395255	1874	18548000	30214	14858	21	0	3
395256	1874	18552000	30214	14858	22	0	3
395257	1874	18554000	30214	14858	23	0	3
395258	1874	18556000	30214	14858	24	0	3
395260	1874	18560000	30214	14858	26	0	3
395261	1874	18562000	30214	14858	27	0	3
395262	1874	18564000	30214	14858	28	0	3
395263	1874	18568000	30214	14858	29	0	3
395264	1874	18572000	30214	14858	30	0	3
395266	1874	18580000	30214	14858	32	0	3
395267	1874	18584000	30214	14858	33	0	3
395319	2440	533000000000	30220	14859	0	0	0
395320	1678	29520912415000	30220	14859	1	0	1
395322	1874	18589000	30220	14859	3	0	3
395323	1874	18593000	30220	14859	4	0	3
395324	1874	18595000	30220	14859	5	0	3
395325	1874	18597000	30220	14859	6	0	3
395326	1874	18601000	30220	14859	7	0	3
395328	2442	1000000	30220	14859	9	0	0
395329	1678	29520912416000	30221	14860	0	0	1
395330	1874	18607000	30221	14860	1	0	3
395331	1874	18608000	30221	14860	2	0	3
395332	1874	18609000	30221	14860	3	0	3
395334	1874	18615000	30221	14860	5	0	3
395335	1874	18619000	30221	14860	6	0	3
395336	1874	18623000	30221	14860	7	0	3
395337	1874	18627000	30221	14860	8	0	3
395339	1874	18629000	30222	14861	1	0	3
395340	1874	18630000	30222	14861	2	0	3
395341	1874	18632000	30222	14861	3	0	3
395342	1874	18636000	30222	14861	4	0	3
395343	1874	18640000	30222	14861	5	0	3
395345	1874	18648000	30222	14861	7	0	3
395353	1678	28800895300000	30223	14735	7	0	\N
395354	1678	28800895301000	30223	14735	8	0	\N
395355	1678	28800895302000	30223	14735	9	0	\N
395356	1678	28800895303000	30223	14735	10	0	\N
395357	1678	28800895304000	30223	14735	11	0	\N
395358	1678	28800895305000	30223	14735	12	0	\N
395359	1678	28800895306000	30223	14735	13	0	\N
395360	1678	28800895307000	30223	14735	14	0	\N
395361	1678	28800895308000	30223	14735	15	0	\N
395362	1678	28800895309000	30223	14735	16	0	\N
395363	1678	28800895310000	30223	14735	17	0	\N
395364	1678	28800895311000	30223	14735	18	0	\N
395365	1678	28800895312000	30223	14735	19	0	\N
395366	1678	28800895313000	30223	14735	20	0	\N
395367	1678	28800895314000	30223	14735	21	0	\N
395368	1678	28800895315000	30223	14735	22	0	\N
395369	1678	28800895316000	30223	14735	23	0	\N
395370	1678	28800895317000	30223	14735	24	0	\N
395371	1678	28800895318000	30223	14735	25	0	\N
395372	1678	28800895319000	30223	14735	26	0	\N
395373	1678	28800895320000	30223	14735	27	0	\N
395374	1678	28800895321000	30223	14735	28	0	\N
395375	1678	28800895322000	30223	14735	29	0	\N
395376	1678	28800895323000	30223	14735	30	0	\N
395377	1678	28800895324000	30223	14735	31	0	\N
395378	1678	28800895325000	30223	14735	32	0	\N
395379	1678	28800895326000	30223	14735	33	0	\N
395380	1678	28800895327000	30223	14735	34	0	\N
395381	1678	28800895328000	30223	14735	35	0	\N
395382	1678	28800895329000	30223	14735	36	0	\N
395383	1678	28800895330000	30223	14735	37	0	\N
395384	1678	28800895331000	30223	14735	38	0	\N
395385	1678	28800895332000	30223	14735	39	0	\N
395386	1678	28800895333000	30223	14735	40	0	\N
395387	1678	28800895334000	30223	14735	41	0	\N
395388	1678	28800895335000	30223	14735	42	0	\N
395389	1678	28800895336000	30223	14735	43	0	\N
395390	1678	28800895337000	30223	14735	44	0	\N
395391	1678	28800895338000	30223	14735	45	0	\N
395392	1678	28800895339000	30223	14735	46	0	\N
395393	1678	28800895340000	30223	14735	47	0	\N
395394	1678	28800895341000	30223	14735	48	0	\N
395395	1678	28800895342000	30223	14735	49	0	\N
395396	1678	28800895343000	30223	14735	56	0	\N
395397	1678	28800895344000	30223	14735	57	0	\N
395398	1678	28800895345000	30223	14735	58	0	\N
395399	1678	28800895346000	30223	14735	59	0	\N
395400	1678	28800895347000	30223	14735	60	0	\N
395401	1678	28800895348000	30223	14735	61	0	\N
395402	1678	28800895349000	30223	14735	62	0	\N
395403	1678	28800895350000	30223	14735	63	0	\N
395404	1678	28800895351000	30223	14735	64	0	\N
395405	1678	28800895352000	30223	14735	65	0	\N
395406	1678	28800895353000	30223	14735	66	0	\N
395407	1678	28800895354000	30223	14735	67	0	\N
395408	1678	28800895355000	30223	14735	68	0	\N
395409	1678	28800895356000	30223	14735	69	0	\N
395410	1678	28800895357000	30223	14735	70	0	\N
395411	1678	28800895358000	30223	14735	71	0	\N
395412	1678	28800895359000	30223	14735	72	0	\N
395413	1678	28800895360000	30223	14735	73	0	\N
395414	1678	28800895361000	30223	14735	74	0	\N
395415	1678	28800895362000	30223	14735	75	0	\N
395416	1678	28800895363000	30223	14735	76	0	\N
395417	1678	28800895364000	30223	14735	77	0	\N
395418	1678	28800895365000	30223	14735	78	0	\N
395419	1678	28800895366000	30223	14735	79	0	\N
395420	1678	28800895367000	30223	14735	80	0	\N
395421	1678	28800895368000	30223	14735	81	0	\N
395422	1678	28800895369000	30223	14735	82	0	\N
395423	1678	28800895370000	30223	14735	83	0	\N
395424	1678	28800895371000	30223	14735	84	0	\N
395425	1678	28800895372000	30223	14735	85	0	\N
395426	1678	28800895373000	30223	14735	86	0	\N
395427	1678	28800895374000	30223	14735	87	0	\N
395428	1678	28800895375000	30223	14735	88	0	\N
395429	1678	28800895376000	30223	14735	89	0	\N
395430	1678	28800895377000	30223	14735	90	0	\N
395431	1678	28800895378000	30223	14735	91	0	\N
395432	1678	28800895379000	30223	14735	92	0	\N
395433	1678	28800895380000	30223	14735	93	0	\N
395434	1678	28800895381000	30223	14735	94	0	\N
395435	1678	28800895382000	30223	14735	95	0	\N
395436	1678	28800895383000	30223	14735	96	0	\N
395446	1678	29520912419000	30225	14863	0	0	\N
395447	1560	19448916131803	30225	14863	1	0	\N
395448	1874	18671000	30225	14863	2	0	\N
395449	1874	18672000	30225	14863	3	0	\N
395450	1874	18676000	30225	14863	4	0	\N
395451	1874	18678000	30225	14863	5	0	\N
395452	1874	18682000	30225	14863	6	0	\N
395453	1874	18686000	30225	14863	7	0	\N
395454	1874	18690000	30225	14863	8	0	\N
395455	1874	18694000	30225	14863	9	0	\N
395456	1874	18695000	30225	14863	10	0	\N
395457	1678	29520912419000	30226	14863	0	0	\N
395458	1560	19448916131803	30226	14863	1	0	\N
395459	1874	18671000	30226	14863	2	0	\N
395460	1874	18672000	30226	14863	3	0	\N
395461	1874	18676000	30226	14863	4	0	\N
395462	1874	18678000	30226	14863	5	0	\N
395463	1874	18682000	30226	14863	6	0	\N
395464	1874	18686000	30226	14863	7	0	\N
395465	1874	18690000	30226	14863	8	0	\N
395466	1874	18694000	30226	14863	9	0	\N
395467	1874	18695000	30226	14863	10	0	\N
395468	1678	29520912417000	30227	14861	0	0	\N
395469	1874	18629000	30227	14861	1	0	\N
395470	1874	18630000	30227	14861	2	0	\N
395471	1874	18632000	30227	14861	3	0	\N
395472	1874	18636000	30227	14861	4	0	\N
395473	1874	18640000	30227	14861	5	0	\N
395474	1874	18644000	30227	14861	6	0	\N
395475	1874	18648000	30227	14861	7	0	\N
395476	1874	18652000	30227	14861	8	0	\N
395488	1678	29520912419000	30229	14863	0	0	\N
395439	1874	18652000	30224	14862	2	0	3
395440	1874	18654000	30224	14862	3	0	3
395441	1874	18656000	30224	14862	4	0	3
395442	1874	18660000	30224	14862	5	0	3
395443	1874	18661000	30224	14862	6	0	3
395445	1874	18669000	30224	14862	8	0	3
395477	1678	29520912419000	30228	14863	0	0	1
395478	1560	19448916131803	30228	14863	1	0	30
395479	1874	18671000	30228	14863	2	0	3
395480	1874	18672000	30228	14863	3	0	3
395482	1874	18678000	30228	14863	5	0	3
395483	1874	18682000	30228	14863	6	0	3
395484	1874	18686000	30228	14863	7	0	3
395485	1874	18690000	30228	14863	8	0	3
395487	1874	18695000	30228	14863	10	0	3
395489	1560	19448916131803	30229	14863	1	0	\N
395490	1874	18671000	30229	14863	2	0	\N
395491	1874	18672000	30229	14863	3	0	\N
395492	1874	18676000	30229	14863	4	0	\N
395493	1874	18678000	30229	14863	5	0	\N
395494	1874	18682000	30229	14863	6	0	\N
395495	1874	18686000	30229	14863	7	0	\N
395496	1874	18690000	30229	14863	8	0	\N
395497	1874	18694000	30229	14863	9	0	\N
395498	1874	18695000	30229	14863	10	0	\N
395526	1678	29520912423000	30231	14865	0	0	\N
395527	1874	18769000	30231	14865	1	0	\N
395528	1874	18773000	30231	14865	2	0	\N
395529	1874	18774000	30231	14865	3	0	\N
395530	1874	18776000	30231	14865	4	0	\N
395531	1874	18778000	30231	14865	5	0	\N
395532	1874	18780000	30231	14865	6	0	\N
395533	1874	18784000	30231	14865	7	0	\N
395534	1874	18788000	30231	14865	8	0	\N
395535	1874	18789000	30231	14865	9	0	\N
395536	1678	29520912423000	30232	14865	0	0	\N
395537	1874	18769000	30232	14865	1	0	\N
395538	1874	18773000	30232	14865	2	0	\N
395539	1874	18774000	30232	14865	3	0	\N
395540	1874	18776000	30232	14865	4	0	\N
395541	1874	18778000	30232	14865	5	0	\N
395542	1874	18780000	30232	14865	6	0	\N
395543	1874	18784000	30232	14865	7	0	\N
395544	1874	18788000	30232	14865	8	0	\N
395545	1874	18789000	30232	14865	9	0	\N
395546	1678	29520912423000	30233	14865	0	0	\N
395547	1874	18769000	30233	14865	1	0	\N
395548	1874	18773000	30233	14865	2	0	\N
395549	1874	18774000	30233	14865	3	0	\N
395550	1874	18776000	30233	14865	4	0	\N
395551	1874	18778000	30233	14865	5	0	\N
395552	1874	18780000	30233	14865	6	0	\N
395553	1874	18784000	30233	14865	7	0	\N
395554	1874	18788000	30233	14865	8	0	\N
395555	1874	18789000	30233	14865	9	0	\N
395556	1678	29520912423000	30234	14865	0	0	\N
395557	1874	18769000	30234	14865	1	0	\N
395558	1874	18773000	30234	14865	2	0	\N
395559	1874	18774000	30234	14865	3	0	\N
395560	1874	18776000	30234	14865	4	0	\N
395561	1874	18778000	30234	14865	5	0	\N
395562	1874	18780000	30234	14865	6	0	\N
395563	1874	18784000	30234	14865	7	0	\N
395564	1874	18788000	30234	14865	8	0	\N
395565	1874	18789000	30234	14865	9	0	\N
395566	1678	29520912423000	30235	14865	0	0	\N
395567	1874	18766000	30235	14865	1	0	\N
395568	1874	18768000	30235	14865	2	0	\N
395569	1874	18770000	30235	14865	3	0	\N
395570	1874	18772000	30235	14865	4	0	\N
395571	1874	18773000	30235	14865	5	0	\N
395572	1678	29520912423000	30236	14865	0	0	\N
395573	1874	18769000	30236	14865	1	0	\N
395574	1874	18773000	30236	14865	2	0	\N
395575	1874	18774000	30236	14865	3	0	\N
395576	1874	18776000	30236	14865	4	0	\N
395577	1874	18778000	30236	14865	5	0	\N
395578	1874	18780000	30236	14865	6	0	\N
395579	1874	18784000	30236	14865	7	0	\N
395580	1874	18788000	30236	14865	8	0	\N
395581	1874	18789000	30236	14865	9	0	\N
395618	1678	29520912426000	30240	14867	0	0	\N
395619	1874	18837000	30240	14867	1	0	\N
395620	1874	18839000	30240	14867	2	0	\N
395621	1874	18841000	30240	14867	3	0	\N
395622	1678	29520912426000	30241	14867	0	0	\N
395623	1874	18837000	30241	14867	1	0	\N
395501	1678	29520912422000	30230	14864	2	0	1
395502	1874	18699000	30230	14864	3	0	3
395503	1874	18700000	30230	14864	4	0	3
395504	1874	18701000	30230	14864	5	0	3
395505	1874	18702000	30230	14864	6	0	3
395507	1874	18707000	30230	14864	8	0	3
395508	1874	18711000	30230	14864	9	0	3
395509	1874	18715000	30230	14864	10	0	3
395510	1874	18719000	30230	14864	11	0	3
395511	1874	18723000	30230	14864	12	0	3
395513	1874	18729000	30230	14864	14	0	3
395514	1874	18731000	30230	14864	15	0	3
395515	1874	18733000	30230	14864	16	0	3
395516	1874	18737000	30230	14864	17	0	3
395518	1874	18745000	30230	14864	19	0	3
395519	1874	18749000	30230	14864	20	0	3
395520	1874	18753000	30230	14864	21	0	3
395521	1874	18757000	30230	14864	22	0	3
395522	1874	18759000	30230	14864	23	0	3
395524	1874	18763000	30230	14864	25	0	3
395525	1874	18765000	30230	14864	26	0	3
395582	1874	18766000	30237	14865	0	0	3
395583	1874	18768000	30237	14865	1	0	3
395584	1874	18770000	30237	14865	2	0	3
395586	1874	18773000	30237	14865	4	0	3
395587	1678	29520912423000	30238	14866	0	0	1
395588	1678	29520912424000	30238	14866	1	0	1
395589	1678	29520912425000	30238	14866	2	0	1
395591	1874	18778000	30238	14866	4	0	3
395592	1874	18782000	30238	14866	5	0	3
395593	1874	18786000	30238	14866	6	0	3
395594	1874	18790000	30238	14866	7	0	3
395595	1874	18794000	30238	14866	8	0	3
395597	1874	18802000	30238	14866	10	0	3
395598	1874	18804000	30238	14866	12	0	3
395599	1874	18806000	30238	14866	13	0	3
395600	1874	18808000	30238	14866	14	0	3
395601	1874	18810000	30238	14866	15	0	3
395603	1874	18812000	30238	14866	17	0	3
395604	1874	18816000	30238	14866	18	0	3
395605	1874	18820000	30238	14866	19	0	3
395606	1874	18824000	30238	14866	20	0	3
395608	1874	18832000	30238	14866	22	0	3
395609	1874	18836000	30238	14866	23	0	3
395610	1678	29520912426000	30239	14867	0	0	1
395611	1874	18840000	30239	14867	1	0	3
395612	1874	18844000	30239	14867	2	0	3
395614	1874	18852000	30239	14867	4	0	3
395615	1874	18853000	30239	14867	5	0	3
395616	1874	18855000	30239	14867	6	0	3
395617	1874	18857000	30239	14867	7	0	3
395624	1678	29520912427000	30242	14868	0	0	1
395661	1678	29520912431000	30246	14872	0	0	\N
395662	1678	29520912432000	30246	14872	1	0	\N
395663	1874	18951000	30246	14872	2	0	\N
395664	1874	18952000	30246	14872	3	0	\N
395665	1874	18954000	30246	14872	4	0	\N
395666	1874	18956000	30246	14872	5	0	\N
395667	1874	18958000	30246	14872	6	0	\N
395668	1874	18960000	30246	14872	7	0	\N
395669	1874	18961000	30246	14872	8	0	\N
395670	1874	18962000	30246	14872	9	0	\N
395671	1874	18966000	30246	14872	10	0	\N
395672	1874	18970000	30246	14872	11	0	\N
395673	1874	18974000	30246	14872	12	0	\N
395674	1874	18978000	30246	14872	13	0	\N
395675	1874	18982000	30246	14872	14	0	\N
395676	1874	18986000	30246	14872	15	0	\N
395677	1874	18990000	30246	14872	16	0	\N
395678	1874	18994000	30246	14872	17	0	\N
395679	1874	18998000	30246	14872	18	0	\N
395699	1678	29520912433000	30248	14873	0	0	\N
395700	1874	19002000	30248	14873	1	0	\N
395701	1874	19004000	30248	14873	2	0	\N
395702	1874	19006000	30248	14873	3	0	\N
395703	1874	19007000	30248	14873	4	0	\N
395704	2447	100000000	30248	14873	5	0	\N
395705	1538	100000000	30248	14873	6	0	\N
395706	1874	19008000	30248	14873	7	0	\N
395707	1874	19012000	30248	14873	8	0	\N
395708	1874	19016000	30248	14873	9	0	\N
395709	1874	19020000	30248	14873	10	0	\N
395710	1678	29520912433000	30249	14873	0	0	\N
395711	1874	19002000	30249	14873	1	0	\N
395712	1874	19004000	30249	14873	2	0	\N
395713	1874	19006000	30249	14873	3	0	\N
395714	1874	19007000	30249	14873	4	0	\N
395715	2447	100000000	30249	14873	5	0	\N
395716	1538	100000000	30249	14873	6	0	\N
395717	1874	19008000	30249	14873	7	0	\N
395718	1874	19012000	30249	14873	8	0	\N
395719	1874	19016000	30249	14873	9	0	\N
395720	1874	19020000	30249	14873	10	0	\N
395730	1678	29520912433000	30251	14873	0	0	\N
395731	1874	19002000	30251	14873	1	0	\N
395732	1874	19004000	30251	14873	2	0	\N
395733	1874	19006000	30251	14873	3	0	\N
395734	1874	19007000	30251	14873	4	0	\N
395735	2447	100000000	30251	14873	5	0	\N
395736	1538	100000000	30251	14873	6	0	\N
395737	1874	19008000	30251	14873	7	0	\N
395738	1874	19012000	30251	14873	8	0	\N
395739	1874	19016000	30251	14873	9	0	\N
395740	1874	19020000	30251	14873	10	0	\N
395741	1678	29520912434000	30252	14874	0	0	\N
395742	1874	19019000	30252	14874	1	0	\N
395743	1874	19023000	30252	14874	2	0	\N
395744	1874	19027000	30252	14874	3	0	\N
395745	1874	19028000	30252	14874	4	0	\N
395746	1874	19029000	30252	14874	5	0	\N
395747	1874	19033000	30252	14874	6	0	\N
395748	1874	19035000	30252	14874	7	0	\N
395749	1874	19037000	30252	14874	8	0	\N
395627	1874	18864000	30242	14868	3	0	3
395628	1874	18865000	30242	14868	4	0	3
395629	1874	18869000	30242	14868	5	0	3
395630	1874	18873000	30242	14868	6	0	3
395631	1874	18877000	30242	14868	7	0	3
395633	1874	18881000	30242	14868	9	0	3
395634	1678	29520912428000	30243	14869	0	0	1
395635	1874	18885000	30243	14869	1	0	3
395636	1874	18889000	30243	14869	2	0	3
395637	1874	18893000	30243	14869	3	0	3
395639	1874	18898000	30243	14869	5	0	3
395640	1874	18900000	30243	14869	6	0	3
395641	2226	109000000	30244	14870	0	0	1
395642	1678	29520912429000	30245	14871	0	0	1
395644	1874	18904000	30245	14871	2	0	3
395645	1874	18908000	30245	14871	3	0	3
395646	1874	18909000	30245	14871	4	0	3
395647	1874	18910000	30245	14871	5	0	3
395648	1874	18911000	30245	14871	6	0	3
395650	1874	18915000	30245	14871	8	0	3
395651	1874	18917000	30245	14871	9	0	3
395652	1874	18919000	30245	14871	10	0	3
395653	1874	18921000	30245	14871	11	0	3
395654	1874	18925000	30245	14871	12	0	3
395656	1874	18933000	30245	14871	14	0	3
395657	1874	18937000	30245	14871	15	0	3
395658	1874	18941000	30245	14871	16	0	3
395659	1874	18945000	30245	14871	17	0	3
395680	1678	29520912431000	30247	14872	0	0	1
395681	1678	29520912432000	30247	14872	1	0	1
395682	1874	18951000	30247	14872	2	0	3
395683	1874	18952000	30247	14872	3	0	3
395684	1874	18954000	30247	14872	4	0	3
395686	1874	18958000	30247	14872	6	0	3
395687	1874	18960000	30247	14872	7	0	3
395688	1874	18961000	30247	14872	8	0	3
395689	1874	18962000	30247	14872	9	0	3
395690	1874	18966000	30247	14872	10	0	3
395692	1874	18974000	30247	14872	12	0	3
395693	1874	18978000	30247	14872	13	0	3
395694	1874	18982000	30247	14872	14	0	3
395695	1874	18986000	30247	14872	15	0	3
395697	1874	18994000	30247	14872	17	0	3
395698	1874	18998000	30247	14872	18	0	3
395721	1678	29520912433000	30250	14873	0	0	1
395722	1874	19002000	30250	14873	1	0	3
395723	1874	19004000	30250	14873	2	0	3
395725	1874	19007000	30250	14873	4	0	3
395726	2447	100000000	30250	14873	5	0	0
395727	1538	100000000	30250	14873	6	0	0
395728	1874	19011000	30250	14873	7	0	3
395729	1874	19015000	30250	14873	8	0	3
395751	1874	19019000	30253	14874	1	0	3
395752	1874	19023000	30253	14874	2	0	3
395753	1874	19027000	30253	14874	3	0	3
395754	1874	19028000	30253	14874	4	0	3
395756	1874	19033000	30253	14874	6	0	3
395757	1874	19037000	30253	14874	7	0	3
395758	1874	19039000	30253	14874	8	0	3
395759	1874	19041000	30253	14874	9	0	3
395760	1678	29520912435000	30254	14875	0	0	1
395769	1678	29520912436000	30255	14876	0	0	\N
395770	1678	29520912437000	30255	14876	1	0	\N
395771	1874	19066000	30255	14876	2	0	\N
395772	1874	19068000	30255	14876	3	0	\N
395773	1874	19072000	30255	14876	4	0	\N
395774	1874	19074000	30255	14876	5	0	\N
395775	1874	19075000	30255	14876	6	0	\N
395776	1874	19079000	30255	14876	7	0	\N
395777	1874	19081000	30255	14876	8	0	\N
395778	1874	19082000	30255	14876	9	0	\N
395779	1874	19086000	30255	14876	10	0	\N
395780	1874	19090000	30255	14876	11	0	\N
395781	1874	19091000	30255	14876	12	0	\N
395782	1874	19095000	30255	14876	13	0	\N
395783	1874	19099000	30255	14876	14	0	\N
395784	1874	19103000	30255	14876	15	0	\N
395785	1874	19107000	30255	14876	16	0	\N
395786	1874	19111000	30255	14876	17	0	\N
395787	1678	29520912436000	30256	14876	0	0	\N
395788	1678	29520912437000	30256	14876	1	0	\N
395789	1874	19066000	30256	14876	2	0	\N
395790	1874	19068000	30256	14876	3	0	\N
395791	1874	19072000	30256	14876	4	0	\N
395792	1874	19074000	30256	14876	5	0	\N
395793	1874	19075000	30256	14876	6	0	\N
395794	1874	19079000	30256	14876	7	0	\N
395795	1874	19081000	30256	14876	8	0	\N
395796	1874	19082000	30256	14876	9	0	\N
395797	1874	19086000	30256	14876	10	0	\N
395798	1874	19090000	30256	14876	11	0	\N
395799	1874	19091000	30256	14876	12	0	\N
395800	1874	19095000	30256	14876	13	0	\N
395801	1874	19099000	30256	14876	14	0	\N
395802	1874	19103000	30256	14876	15	0	\N
395803	1874	19107000	30256	14876	16	0	\N
395804	1874	19111000	30256	14876	17	0	\N
395823	2015	333750000000	30258	14877	0	0	\N
395824	1678	29520912438000	30258	14877	1	0	\N
395825	1678	29520912439000	30258	14877	2	0	\N
395826	1678	29520912440000	30258	14877	3	0	\N
395827	1678	29520912441000	30258	14877	4	0	\N
395828	664	66011484726895	30258	14877	5	0	\N
395829	1874	19112000	30258	14877	6	0	\N
395830	1874	19116000	30258	14877	7	0	\N
395831	1874	19117000	30258	14877	8	0	\N
395832	1874	19118000	30258	14877	9	0	\N
395833	1874	19119000	30258	14877	10	0	\N
395834	1874	19120000	30258	14877	11	0	\N
395835	1874	19124000	30258	14877	12	0	\N
395836	1874	19128000	30258	14877	13	0	\N
395837	1874	19132000	30258	14877	14	0	\N
395838	1874	19136000	30258	14877	15	0	\N
395839	1874	19140000	30258	14877	16	0	\N
395840	1874	19141000	30258	14877	17	0	\N
395841	1874	19143000	30258	14877	18	0	\N
395842	1874	19145000	30258	14877	19	0	\N
395843	1874	19147000	30258	14877	20	0	\N
395844	1874	19149000	30258	14877	21	0	\N
395845	1874	19151000	30258	14877	22	0	\N
395846	1874	19153000	30258	14877	23	0	\N
395847	1874	19157000	30258	14877	24	0	\N
395848	1874	19161000	30258	14877	25	0	\N
395849	1874	19165000	30258	14877	26	0	\N
395850	1874	19169000	30258	14877	27	0	\N
395851	1874	19173000	30258	14877	28	0	\N
395852	1874	19177000	30258	14877	29	0	\N
395853	1874	19181000	30258	14877	30	0	\N
395854	1874	19185000	30258	14877	31	0	\N
395855	1874	19189000	30258	14877	32	0	\N
395856	1874	19193000	30258	14877	33	0	\N
395857	1874	19197000	30258	14877	34	0	\N
395858	1874	19201000	30258	14877	35	0	\N
395859	1874	19203000	30258	14877	36	0	\N
395860	1874	19205000	30258	14877	37	0	\N
395861	1874	19207000	30258	14877	38	0	\N
395862	1874	19209000	30258	14877	39	0	\N
395863	1874	19211000	30258	14877	40	0	\N
395864	2015	333750000000	30259	14877	0	0	\N
395865	1678	29520912438000	30259	14877	1	0	\N
395866	1678	29520912439000	30259	14877	2	0	\N
395867	1678	29520912440000	30259	14877	3	0	\N
395868	1678	29520912441000	30259	14877	4	0	\N
395869	664	66011484726895	30259	14877	5	0	\N
395870	1874	19112000	30259	14877	6	0	\N
395871	1874	19116000	30259	14877	7	0	\N
395872	1874	19117000	30259	14877	8	0	\N
395873	1874	19118000	30259	14877	9	0	\N
395874	1874	19119000	30259	14877	10	0	\N
395875	1874	19120000	30259	14877	11	0	\N
395876	1874	19124000	30259	14877	12	0	\N
395877	1874	19128000	30259	14877	13	0	\N
395878	1874	19132000	30259	14877	14	0	\N
395879	1874	19136000	30259	14877	15	0	\N
395880	1874	19140000	30259	14877	16	0	\N
395881	1874	19141000	30259	14877	17	0	\N
395882	1874	19143000	30259	14877	18	0	\N
395883	1874	19145000	30259	14877	19	0	\N
395884	1874	19147000	30259	14877	20	0	\N
395885	1874	19149000	30259	14877	21	0	\N
395886	1874	19151000	30259	14877	22	0	\N
395887	1874	19153000	30259	14877	23	0	\N
395888	1874	19157000	30259	14877	24	0	\N
395889	1874	19161000	30259	14877	25	0	\N
395890	1874	19165000	30259	14877	26	0	\N
395891	1874	19169000	30259	14877	27	0	\N
395892	1874	19173000	30259	14877	28	0	\N
395893	1874	19177000	30259	14877	29	0	\N
395894	1874	19181000	30259	14877	30	0	\N
395895	1874	19185000	30259	14877	31	0	\N
395896	1874	19189000	30259	14877	32	0	\N
395763	1874	19049000	30254	14875	3	0	3
395764	1874	19050000	30254	14875	4	0	3
395765	1874	19052000	30254	14875	5	0	3
395766	1874	19056000	30254	14875	6	0	3
395767	1874	19060000	30254	14875	7	0	3
395805	1678	29520912436000	30257	14876	0	0	1
395806	1678	29520912437000	30257	14876	1	0	1
395807	1874	19066000	30257	14876	2	0	3
395808	1874	19068000	30257	14876	3	0	3
395809	1874	19072000	30257	14876	4	0	3
395811	1874	19075000	30257	14876	6	0	3
395812	1874	19079000	30257	14876	7	0	3
395813	1874	19081000	30257	14876	8	0	3
395814	1874	19082000	30257	14876	9	0	3
395816	1874	19090000	30257	14876	11	0	3
395817	1874	19091000	30257	14876	12	0	3
395818	1874	19095000	30257	14876	13	0	3
395819	1874	19099000	30257	14876	14	0	3
395820	1874	19103000	30257	14876	15	0	3
395822	1874	19111000	30257	14876	17	0	3
395897	1874	19193000	30259	14877	33	0	\N
395898	1874	19197000	30259	14877	34	0	\N
395899	1874	19201000	30259	14877	35	0	\N
395900	1874	19203000	30259	14877	36	0	\N
395901	1874	19205000	30259	14877	37	0	\N
395902	1874	19207000	30259	14877	38	0	\N
395903	1874	19209000	30259	14877	39	0	\N
395904	1874	19211000	30259	14877	40	0	\N
395976	1396	1020000000	30263	14879	0	0	\N
395982	1678	29520912445000	30265	14880	0	0	\N
395983	1874	19287000	30265	14880	1	0	\N
395984	1874	19289000	30265	14880	2	0	\N
395985	1874	19291000	30265	14880	3	0	\N
395986	1874	19293000	30265	14880	4	0	\N
395987	1874	19297000	30265	14880	5	0	\N
395988	1874	19301000	30265	14880	6	0	\N
395989	1874	19305000	30265	14880	7	0	\N
395990	1874	19309000	30265	14880	8	0	\N
396024	2015	333750000000	30267	14812	0	0	\N
396025	2226	109000000	30267	14812	1	0	\N
396026	1396	1020000000	30267	14812	2	0	\N
396027	2439	99000000000	30267	14812	3	0	\N
396028	2439	629000000000	30267	14812	4	0	\N
396029	1678	29520912351000	30267	14812	5	0	\N
396030	1678	29520912352000	30267	14812	6	0	\N
396031	1678	29520912353000	30267	14812	7	0	\N
396032	1678	29520912354000	30267	14812	8	0	\N
395907	1678	29520912438000	30261	14878	0	0	1
395908	1678	29520912439000	30261	14878	1	0	1
395909	1678	29520912440000	30261	14878	2	0	1
395910	1678	29520912441000	30261	14878	3	0	1
395911	1678	29520912442000	30261	14878	4	0	1
395913	1874	19116000	30261	14878	6	0	3
395914	1874	19117000	30261	14878	7	0	3
395915	1874	19118000	30261	14878	8	0	3
395916	1874	19119000	30261	14878	9	0	3
395917	1874	19120000	30261	14878	10	0	3
395919	1874	19128000	30261	14878	12	0	3
395920	1874	19132000	30261	14878	13	0	3
395921	1874	19136000	30261	14878	14	0	3
395922	1874	19140000	30261	14878	15	0	3
395924	1874	19142000	30261	14878	17	0	3
395925	1874	19144000	30261	14878	18	0	3
395926	1874	19146000	30261	14878	19	0	3
395927	1874	19148000	30261	14878	20	0	3
395928	1874	19150000	30261	14878	21	0	3
395930	1874	19154000	30261	14878	23	0	3
395931	1874	19158000	30261	14878	24	0	3
395932	1874	19162000	30261	14878	25	0	3
395933	1874	19166000	30261	14878	26	0	3
395934	1874	19170000	30261	14878	27	0	3
395936	1874	19178000	30261	14878	29	0	3
395937	1874	19182000	30261	14878	30	0	3
395938	1874	19186000	30261	14878	31	0	3
395939	1874	19190000	30261	14878	32	0	3
395941	1874	19198000	30261	14878	34	0	3
395942	1874	19202000	30261	14878	35	0	3
395943	1874	19206000	30261	14878	36	0	3
395944	1874	19210000	30261	14878	37	0	3
395945	1874	19214000	30261	14878	38	0	3
395947	1874	19222000	30261	14878	40	0	3
395948	1874	19224000	30261	14878	41	0	3
395949	1874	19226000	30261	14878	42	0	3
395950	1874	19228000	30261	14878	43	0	3
395951	1874	19229000	30261	14878	44	0	3
395953	1874	19233000	30261	14878	46	0	3
395954	1874	19235000	30261	14878	47	0	3
395955	1874	19237000	30261	14878	48	0	3
395956	1396	1020000000	30262	14879	0	0	3
395958	1678	29520912444000	30262	14879	2	0	1
395959	1874	19239000	30262	14879	3	0	3
395960	1874	19240000	30262	14879	4	0	3
395961	1874	19241000	30262	14879	5	0	3
395962	1874	19242000	30262	14879	6	0	3
395964	1874	19246000	30262	14879	8	0	3
395965	1874	19248000	30262	14879	9	0	3
395966	1874	19250000	30262	14879	10	0	3
395967	1874	19254000	30262	14879	11	0	3
395968	1874	19258000	30262	14879	12	0	3
395970	1874	19266000	30262	14879	14	0	3
395971	1874	19270000	30262	14879	15	0	3
395972	1874	19274000	30262	14879	16	0	3
395973	1874	19278000	30262	14879	17	0	3
395975	1874	19286000	30262	14879	19	0	3
395977	1678	29520912445000	30264	14880	0	0	1
395978	1874	19287000	30264	14880	1	0	3
395979	1874	19289000	30264	14880	2	0	3
395980	1874	19291000	30264	14880	3	0	3
395991	1678	29520912446000	30266	14881	0	0	1
395992	1678	29520912447000	30266	14881	1	0	1
395993	1678	29520912448000	30266	14881	2	0	1
395994	1874	19294000	30266	14881	3	0	3
395995	1874	19296000	30266	14881	4	0	3
395997	1874	19299000	30266	14881	6	0	3
395998	1874	19301000	30266	14881	7	0	3
395999	1874	19303000	30266	14881	8	0	3
396000	1874	19307000	30266	14881	9	0	3
396002	1874	19315000	30266	14881	11	0	3
396003	1874	19319000	30266	14881	12	0	3
396004	1874	19323000	30266	14881	13	0	3
396005	1874	19327000	30266	14881	15	0	3
396006	1874	19331000	30266	14881	16	0	3
396008	1874	19333000	30266	14881	18	0	3
396009	1874	19335000	30266	14881	19	0	3
396010	1874	19339000	30266	14881	20	0	3
396011	1874	19343000	30266	14881	21	0	3
396012	1874	19347000	30266	14881	22	0	3
396014	1874	19355000	30266	14881	24	0	3
396015	1874	19359000	30266	14881	25	0	3
396016	1874	19363000	30266	14881	26	0	3
396017	1874	19365000	30266	14881	27	0	3
396019	1874	19369000	30266	14881	29	0	3
396020	1874	19371000	30266	14881	30	0	3
396021	1874	19375000	30266	14881	31	0	3
396022	1874	19379000	30266	14881	32	0	3
396023	1874	19383000	30266	14881	33	0	3
396033	1678	29520912355000	30267	14812	9	0	\N
396034	1678	29520912356000	30267	14812	10	0	\N
396035	1678	29520912357000	30267	14812	11	0	\N
396036	1678	29520912358000	30267	14812	12	0	\N
396037	1678	29520912359000	30267	14812	13	0	\N
396038	1678	29520912360000	30267	14812	14	0	\N
396039	1678	29520912361000	30267	14812	15	0	\N
396040	1678	29520912362000	30267	14812	16	0	\N
396041	1678	29520912363000	30267	14812	17	0	\N
396042	1678	29520912364000	30267	14812	18	0	\N
396043	1678	29520912365000	30267	14812	19	0	\N
396044	1678	29520912366000	30267	14812	20	0	\N
396045	1678	29520912367000	30267	14812	21	0	\N
396046	1678	29520912368000	30267	14812	22	0	\N
396047	1678	29520912369000	30267	14812	23	0	\N
396048	1678	29520912370000	30267	14812	24	0	\N
396049	1678	29520912371000	30267	14812	25	0	\N
396050	1678	29520912372000	30267	14812	26	0	\N
396051	1678	29520912373000	30267	14812	27	0	\N
396052	1678	29520912374000	30267	14812	28	0	\N
396053	1678	29520912375000	30267	14812	29	0	\N
396054	1678	29520912376000	30267	14812	30	0	\N
396055	1678	29520912377000	30267	14812	31	0	\N
396056	1678	29520912378000	30267	14812	32	0	\N
396057	1678	29520912379000	30267	14812	33	0	\N
396058	1678	29520912380000	30267	14812	34	0	\N
396059	1678	29520912381000	30267	14812	35	0	\N
396060	1678	29520912382000	30267	14812	36	0	\N
396061	1678	29520912383000	30267	14812	37	0	\N
396062	1678	29520912384000	30267	14812	38	0	\N
396063	1678	29520912385000	30267	14812	39	0	\N
396064	1678	29520912386000	30267	14812	40	0	\N
396065	1678	29520912387000	30267	14812	41	0	\N
396066	1678	29520912388000	30267	14812	42	0	\N
396067	1678	29520912389000	30267	14812	43	0	\N
396068	1678	29520912390000	30267	14812	44	0	\N
396069	1678	29520912391000	30267	14812	45	0	\N
396070	1678	29520912392000	30267	14812	46	0	\N
396071	1678	29520912393000	30267	14812	47	0	\N
396072	1678	29520912394000	30267	14812	48	0	\N
396073	1678	29520912395000	30267	14812	49	0	\N
396074	1678	29520912396000	30267	14812	50	0	\N
396075	1678	29520912397000	30267	14812	51	0	\N
396076	1678	29520912398000	30267	14812	52	0	\N
396077	1678	29520912399000	30267	14812	53	0	\N
396078	1678	29520912400000	30267	14812	54	0	\N
396079	1678	29520912401000	30267	14812	55	0	\N
396080	1678	29520912402000	30267	14812	56	0	\N
396081	1678	29520912403000	30267	14812	57	0	\N
396082	1678	29520912404000	30267	14812	58	0	\N
396083	1678	29520912405000	30267	14812	59	0	\N
396084	1678	29520912406000	30267	14812	60	0	\N
396085	1678	29520912407000	30267	14812	61	0	\N
396086	1678	29520912408000	30267	14812	62	0	\N
396087	1678	29520912409000	30267	14812	63	0	\N
396088	1678	29520912410000	30267	14812	64	0	\N
396089	1678	29520912411000	30267	14812	65	0	\N
396090	1678	29520912412000	30267	14812	66	0	\N
396091	1678	29520912413000	30267	14812	67	0	\N
396092	1678	29520912414000	30267	14812	68	0	\N
396093	1678	29520912415000	30267	14812	69	0	\N
396094	1678	29520912416000	30267	14812	70	0	\N
396095	1678	29520912417000	30267	14812	71	0	\N
396096	1678	29520912418000	30267	14812	72	0	\N
396097	1678	29520912419000	30267	14812	73	0	\N
396098	1678	29520912420000	30267	14812	74	0	\N
396099	1678	29520912421000	30267	14812	75	0	\N
396100	1678	29520912422000	30267	14812	76	0	\N
396101	1678	29520912423000	30267	14812	77	0	\N
396102	1678	29520912424000	30267	14812	78	0	\N
396103	1678	29520912425000	30267	14812	79	0	\N
396104	1678	29520912426000	30267	14812	80	0	\N
396105	1678	29520912427000	30267	14812	81	0	\N
396106	1678	29520912428000	30267	14812	82	0	\N
396107	1678	29520912429000	30267	14812	83	0	\N
396108	1678	29520912430000	30267	14812	84	0	\N
396109	1678	29520912431000	30267	14812	85	0	\N
396110	1678	29520912432000	30267	14812	86	0	\N
396111	1678	29520912433000	30267	14812	87	0	\N
396112	1678	29520912434000	30267	14812	88	0	\N
396113	1678	29520912435000	30267	14812	89	0	\N
396114	1678	29520912436000	30267	14812	90	0	\N
396115	1678	29520912437000	30267	14812	91	0	\N
396116	1678	29520912438000	30267	14812	92	0	\N
396117	1678	29520912439000	30267	14812	93	0	\N
396118	1678	29520912440000	30267	14812	94	0	\N
396119	1678	29520912441000	30267	14812	95	0	\N
396120	1678	29520912442000	30267	14812	96	0	\N
396121	1678	29520912443000	30267	14812	97	0	\N
396122	1678	29520912444000	30267	14812	98	0	\N
396123	1678	29520912445000	30267	14812	99	0	\N
396124	1678	29520912446000	30267	14812	100	0	\N
396125	1678	29520912447000	30267	14812	101	0	\N
396126	1678	29520912448000	30267	14812	102	0	\N
396127	1483	11000000	30267	14812	103	0	\N
396128	2441	0	30267	14812	104	0	\N
396129	2441	2010000000	30267	14812	105	0	\N
396130	1726	113512112000	30267	14812	106	0	\N
396131	2441	7010000000	30267	14812	107	0	\N
396132	2441	927010000000	30267	14812	108	0	\N
396133	1874	16945000	30267	14812	109	0	\N
396134	2442	0	30267	14812	111	0	\N
396135	2444	100000000	30267	14812	112	0	\N
396136	2445	100000000	30267	14812	113	0	\N
396137	2446	100000000	30267	14812	114	0	\N
396138	1874	16949000	30267	14812	116	0	\N
396139	1874	16953000	30267	14812	117	0	\N
396140	1874	16957000	30267	14812	118	0	\N
396141	1874	16961000	30267	14812	119	0	\N
396142	2447	100000000	30267	14812	120	0	\N
396143	1538	100000000	30267	14812	121	0	\N
396144	2440	0	30267	14812	123	0	\N
396145	1678	29520912449000	30268	14882	0	0	\N
396146	1678	29520912450000	30268	14882	1	0	\N
396147	2448	0	30268	14882	2	0	\N
396148	1874	19387000	30268	14882	3	0	\N
396149	1874	19388000	30268	14882	4	0	\N
396150	1874	19389000	30268	14882	5	0	\N
396151	1874	19391000	30268	14882	6	0	\N
396152	1874	19395000	30268	14882	7	0	\N
396153	1874	19399000	30268	14882	8	0	\N
396154	1874	19403000	30268	14882	9	0	\N
396155	1874	19407000	30268	14882	10	0	\N
396156	1874	19411000	30268	14882	11	0	\N
396157	1874	19415000	30268	14882	12	0	\N
396158	1874	19419000	30268	14882	13	0	\N
396159	1874	19423000	30268	14882	14	0	\N
396160	1874	19425000	30268	14882	15	0	\N
396161	1874	19427000	30268	14882	16	0	\N
396162	1874	19429000	30268	14882	17	0	\N
396163	1874	19431000	30268	14882	18	0	\N
396164	1874	19432000	30268	14882	19	0	\N
396167	2448	0	30269	14882	2	0	0
396168	1874	19384000	30269	14882	3	0	3
396206	1678	29520912452000	30272	14884	0	0	\N
396207	2446	1100000000	30272	14884	1	0	\N
396208	1874	19457000	30272	14884	2	0	\N
396209	1874	19461000	30272	14884	3	0	\N
396210	1874	19465000	30272	14884	4	0	\N
396211	1874	19467000	30272	14884	5	0	\N
396212	1874	19471000	30272	14884	6	0	\N
396213	1874	19475000	30272	14884	7	0	\N
396214	1874	19479000	30272	14884	8	0	\N
396215	1874	19481000	30272	14884	9	0	\N
396216	1874	19483000	30272	14884	10	0	\N
396239	1678	29520912453000	30274	14885	0	0	\N
396240	1678	29520912454000	30274	14885	1	0	\N
396241	1678	29520912455000	30274	14885	2	0	\N
396242	1678	29520912456000	30274	14885	3	0	\N
396243	2449	0	30274	14885	4	0	\N
396244	1874	19485000	30274	14885	5	0	\N
396245	1874	19487000	30274	14885	6	0	\N
396246	1874	19491000	30274	14885	7	0	\N
396247	1874	19495000	30274	14885	8	0	\N
396248	1874	19496000	30274	14885	9	0	\N
396249	1874	19500000	30274	14885	10	0	\N
396250	1874	19504000	30274	14885	11	0	\N
396251	1874	19505000	30274	14885	12	0	\N
396252	1874	19506000	30274	14885	13	0	\N
396253	1874	19507000	30274	14885	14	0	\N
396254	1874	19508000	30274	14885	15	0	\N
396255	1874	19509000	30274	14885	16	0	\N
396256	1874	19513000	30274	14885	17	0	\N
396257	1874	19517000	30274	14885	18	0	\N
396258	1874	19521000	30274	14885	19	0	\N
396259	1874	19525000	30274	14885	20	0	\N
396260	1874	19529000	30274	14885	21	0	\N
396261	1874	19533000	30274	14885	22	0	\N
396262	1874	19537000	30274	14885	23	0	\N
396263	1874	19541000	30274	14885	24	0	\N
396264	1874	19545000	30274	14885	25	0	\N
396265	1874	19547000	30274	14885	26	0	\N
396266	1874	19549000	30274	14885	27	0	\N
396267	1874	19551000	30274	14885	28	0	\N
396268	1874	19553000	30274	14885	29	0	\N
396269	1874	19555000	30274	14885	30	0	\N
396270	1874	19557000	30274	14885	31	0	\N
396271	1874	19559000	30274	14885	32	0	\N
396272	1874	19561000	30274	14885	33	0	\N
396273	1874	19563000	30274	14885	34	0	\N
396274	1874	19567000	30274	14885	35	0	\N
396275	1874	19571000	30274	14885	36	0	\N
396276	1874	19575000	30274	14885	37	0	\N
396277	1874	19579000	30274	14885	38	0	\N
396171	1874	19389000	30269	14882	6	0	3
396172	1874	19391000	30269	14882	7	0	3
396173	1874	19393000	30269	14882	8	0	3
396174	1874	19395000	30269	14882	9	0	3
396175	1874	19396000	30269	14882	10	0	3
396177	1874	19400000	30270	14883	1	0	3
396178	1874	19401000	30270	14883	2	0	3
396179	1874	19402000	30270	14883	3	0	3
396180	1874	19406000	30270	14883	4	0	3
396181	1874	19410000	30270	14883	5	0	3
396183	1874	19416000	30270	14883	7	0	3
396184	1874	19418000	30270	14883	8	0	3
396185	1874	19420000	30270	14883	9	0	3
396186	1874	19424000	30270	14883	10	0	3
396188	1874	19432000	30270	14883	12	0	3
396189	1874	19436000	30270	14883	13	0	3
396190	1874	19440000	30270	14883	14	0	3
396191	1874	19444000	30270	14883	15	0	3
396192	1874	19448000	30270	14883	16	0	3
396194	1874	19456000	30270	14883	18	0	3
396195	1678	29520912452000	30271	14884	0	0	1
396196	2446	1100000000	30271	14884	1	0	0
396197	1874	19457000	30271	14884	2	0	3
396198	1874	19461000	30271	14884	3	0	3
396200	1874	19467000	30271	14884	5	0	3
396201	1874	19471000	30271	14884	6	0	3
396202	1874	19475000	30271	14884	7	0	3
396203	1874	19479000	30271	14884	8	0	3
396205	1874	19483000	30271	14884	10	0	3
396217	1678	29520912453000	30273	14885	0	0	1
396218	1678	29520912454000	30273	14885	1	0	1
396219	1678	29520912455000	30273	14885	2	0	1
396220	1678	29520912456000	30273	14885	3	0	1
396222	1874	19485000	30273	14885	5	0	3
396223	1874	19487000	30273	14885	6	0	3
396224	1874	19488000	30273	14885	7	0	3
396225	1874	19489000	30273	14885	8	0	3
396226	1874	19490000	30273	14885	9	0	3
396228	1874	19492000	30273	14885	11	0	3
396229	1874	19493000	30273	14885	12	0	3
396230	1874	19495000	30273	14885	13	0	3
396231	1874	19497000	30273	14885	14	0	3
396233	1874	19501000	30273	14885	16	0	3
396234	1874	19503000	30273	14885	17	0	3
396235	1874	19505000	30273	14885	18	0	3
396236	1874	19507000	30273	14885	19	0	3
396237	1874	19509000	30273	14885	20	0	3
396278	1678	29520912457000	30275	14886	0	0	1
396279	1874	19513000	30275	14886	1	0	3
396280	1874	19515000	30275	14886	2	0	3
396281	1874	19517000	30275	14886	3	0	3
396282	1678	29520912458000	30276	14887	0	0	1
396284	1874	19519000	30276	14887	2	0	3
396285	1874	19523000	30276	14887	3	0	3
396286	1874	19527000	30276	14887	4	0	3
396287	1874	19531000	30276	14887	5	0	3
396289	1874	19535000	30276	14887	7	0	3
396290	1874	19537000	30276	14887	8	0	3
396291	1874	19541000	30276	14887	9	0	3
396292	1874	19545000	30276	14887	10	0	3
396293	1874	19549000	30276	14887	11	0	3
396295	1874	19557000	30276	14887	13	0	3
396296	1874	19561000	30276	14887	14	0	3
396297	1874	19565000	30276	14887	15	0	3
396298	1874	19569000	30276	14887	16	0	3
396299	1874	19573000	30276	14887	17	0	3
396301	1874	19581000	30276	14887	19	0	3
396302	1874	19585000	30276	14887	20	0	3
396303	1874	19589000	30276	14887	21	0	3
396304	1874	19593000	30276	14887	22	0	3
396333	1678	29520912460000	30279	14889	0	0	\N
396334	1874	19657000	30279	14889	1	0	\N
396335	1874	19661000	30279	14889	2	0	\N
396336	2450	100000000	30279	14889	3	0	\N
396337	1874	19662000	30279	14889	4	0	\N
396338	1874	19663000	30279	14889	5	0	\N
396339	1874	19667000	30279	14889	6	0	\N
396340	1874	19671000	30279	14889	7	0	\N
396341	2015	333750000000	30280	14866	0	0	\N
396342	2226	109000000	30280	14866	1	0	\N
396343	1396	1020000000	30280	14866	2	0	\N
396344	664	66011484726895	30280	14866	3	0	\N
396345	2448	0	30280	14866	4	0	\N
396346	2449	0	30280	14866	5	0	\N
396347	2446	1100000000	30280	14866	6	0	\N
396348	2447	100000000	30280	14866	7	0	\N
396349	1538	100000000	30280	14866	8	0	\N
396350	1538	200000000	30280	14866	9	0	\N
396351	2450	100000000	30280	14866	10	0	\N
396352	1678	29520912460000	30281	14889	0	0	\N
396353	1874	19657000	30281	14889	1	0	\N
396354	1874	19661000	30281	14889	2	0	\N
396355	2450	100000000	30281	14889	3	0	\N
396356	1874	19662000	30281	14889	4	0	\N
396357	1874	19663000	30281	14889	5	0	\N
396358	1874	19667000	30281	14889	6	0	\N
396359	1874	19671000	30281	14889	7	0	\N
396360	1678	29520912461000	30282	14890	0	0	\N
396361	1874	19672000	30282	14890	1	0	\N
396362	1874	19676000	30282	14890	2	0	\N
396363	1874	19680000	30282	14890	3	0	\N
396364	1874	19684000	30282	14890	4	0	\N
396371	1678	29520912462000	30284	14891	0	0	\N
396372	1874	19689000	30284	14891	1	0	\N
396373	1678	29520912462000	30285	14891	0	0	\N
396374	1874	19692000	30285	14891	1	0	\N
396375	1874	19696000	30285	14891	2	0	\N
396376	1874	19697000	30285	14891	3	0	\N
396377	1874	19701000	30285	14891	4	0	\N
396378	1874	19705000	30285	14891	5	0	\N
396379	1678	29520912462000	30286	14891	0	0	\N
396380	1874	19692000	30286	14891	1	0	\N
396381	1874	19696000	30286	14891	2	0	\N
396382	1874	19697000	30286	14891	3	0	\N
396383	1874	19701000	30286	14891	4	0	\N
396384	1874	19705000	30286	14891	5	0	\N
396391	1678	29520912463000	30288	14892	0	0	\N
396392	1678	29520912464000	30288	14892	1	0	\N
396393	1874	19706000	30288	14892	2	0	\N
396394	1874	19707000	30288	14892	3	0	\N
396395	1874	19708000	30288	14892	4	0	\N
396396	1678	29520912463000	30289	14892	0	0	\N
396397	1678	29520912464000	30289	14892	1	0	\N
396398	1874	19709000	30289	14892	2	0	\N
396399	1874	19710000	30289	14892	3	0	\N
396400	1874	19714000	30289	14892	4	0	\N
396401	1874	19715000	30289	14892	5	0	\N
396402	1874	19716000	30289	14892	6	0	\N
396403	1874	19720000	30289	14892	7	0	\N
396404	1874	19724000	30289	14892	8	0	\N
396405	1874	19728000	30289	14892	9	0	\N
396406	1874	19732000	30289	14892	10	0	\N
396407	1874	19736000	30289	14892	11	0	\N
396408	1874	19740000	30289	14892	12	0	\N
396409	1678	29520912463000	30290	14892	0	0	\N
396410	1678	29520912464000	30290	14892	1	0	\N
396411	1874	19709000	30290	14892	2	0	\N
396412	1874	19710000	30290	14892	3	0	\N
396413	1874	19714000	30290	14892	4	0	\N
396414	1874	19715000	30290	14892	5	0	\N
396415	1874	19716000	30290	14892	6	0	\N
396416	1874	19720000	30290	14892	7	0	\N
396417	1874	19724000	30290	14892	8	0	\N
396418	1874	19728000	30290	14892	9	0	\N
396419	1874	19732000	30290	14892	10	0	\N
396420	1874	19736000	30290	14892	11	0	\N
396421	1874	19740000	30290	14892	12	0	\N
396422	1678	29520912463000	30291	14892	0	0	\N
396423	1678	29520912464000	30291	14892	1	0	\N
396424	1874	19709000	30291	14892	2	0	\N
396425	1874	19710000	30291	14892	3	0	\N
396426	1874	19714000	30291	14892	4	0	\N
396427	1874	19715000	30291	14892	5	0	\N
396428	1874	19716000	30291	14892	6	0	\N
396429	1874	19720000	30291	14892	7	0	\N
396430	1874	19724000	30291	14892	8	0	\N
396431	1874	19728000	30291	14892	9	0	\N
396432	1874	19732000	30291	14892	10	0	\N
396433	1874	19736000	30291	14892	11	0	\N
396434	1874	19740000	30291	14892	12	0	\N
396435	1678	29520912463000	30292	14892	0	0	\N
396436	1678	29520912464000	30292	14892	1	0	\N
396437	1874	19709000	30292	14892	2	0	\N
396438	1874	19710000	30292	14892	3	0	\N
396439	1874	19714000	30292	14892	4	0	\N
396440	1874	19715000	30292	14892	5	0	\N
396307	1874	19605000	30276	14887	26	0	3
396308	1874	19609000	30276	14887	27	0	3
396309	1874	19613000	30276	14887	28	0	3
396310	1874	19617000	30276	14887	29	0	3
396311	1874	19621000	30276	14887	30	0	3
396313	1874	19626000	30276	14887	32	0	3
396314	1678	29520912459000	30277	14888	0	0	1
396315	1874	19628000	30277	14888	1	0	3
396316	1874	19630000	30277	14888	2	0	3
396317	1874	19632000	30277	14888	3	0	3
396319	1874	19640000	30277	14888	5	0	3
396320	1874	19644000	30277	14888	6	0	3
396321	1874	19645000	30277	14888	7	0	3
396322	1538	200000000	30277	14888	8	0	0
396324	1874	19653000	30277	14888	10	0	3
396325	1678	29520912460000	30278	14889	0	0	1
396326	1874	19657000	30278	14889	1	0	3
396327	1874	19661000	30278	14889	2	0	3
396328	2450	100000000	30278	14889	3	0	0
396330	1874	19663000	30278	14889	5	0	3
396331	1874	19667000	30278	14889	6	0	3
396332	1874	19671000	30278	14889	7	0	3
396365	1678	29520912461000	30283	14890	0	0	1
396366	1874	19672000	30283	14890	1	0	3
396368	1874	19680000	30283	14890	3	0	3
396369	1874	19684000	30283	14890	4	0	3
396370	1874	19688000	30283	14890	5	0	3
396385	1678	29520912462000	30287	14891	0	0	1
396387	1874	19696000	30287	14891	2	0	3
396388	1874	19697000	30287	14891	3	0	3
396389	1874	19701000	30287	14891	4	0	3
396390	1874	19705000	30287	14891	5	0	3
396441	1874	19716000	30292	14892	6	0	\N
396442	1874	19720000	30292	14892	7	0	\N
396443	1874	19724000	30292	14892	8	0	\N
396444	1874	19728000	30292	14892	9	0	\N
396445	1874	19732000	30292	14892	10	0	\N
396446	1874	19736000	30292	14892	11	0	\N
396447	1874	19740000	30292	14892	12	0	\N
396461	1678	29520912465000	30294	14893	0	0	\N
396462	1874	19741000	30294	14893	1	0	\N
396463	1874	19742000	30294	14893	2	0	\N
396464	1874	19746000	30294	14893	3	0	\N
396465	1874	19750000	30294	14893	4	0	\N
396466	1874	19754000	30294	14893	5	0	\N
396467	1874	19758000	30294	14893	6	0	\N
396468	1678	29520912465000	30295	14893	0	0	\N
396469	1874	19741000	30295	14893	1	0	\N
396470	1874	19742000	30295	14893	2	0	\N
396471	1874	19746000	30295	14893	3	0	\N
396472	1874	19750000	30295	14893	4	0	\N
396473	1874	19754000	30295	14893	5	0	\N
396474	1874	19758000	30295	14893	6	0	\N
396475	1678	29520912465000	30296	14893	0	0	\N
396476	1874	19741000	30296	14893	1	0	\N
396477	1874	19742000	30296	14893	2	0	\N
396478	1874	19746000	30296	14893	3	0	\N
396479	1874	19750000	30296	14893	4	0	\N
396480	1874	19754000	30296	14893	5	0	\N
396481	1874	19758000	30296	14893	6	0	\N
396487	1678	29520912466000	30298	14894	1	0	\N
396488	1874	19757000	30298	14894	2	0	\N
396489	1874	19758000	30298	14894	3	0	\N
396490	1874	19759000	30298	14894	4	0	\N
396491	1678	29520912466000	30299	14894	3	0	\N
396492	1874	19757000	30299	14894	4	0	\N
396493	1874	19758000	30299	14894	5	0	\N
396494	1874	19759000	30299	14894	6	0	\N
396495	1874	19763000	30299	14894	7	0	\N
396496	1874	19767000	30299	14894	8	0	\N
396497	1874	19771000	30299	14894	9	0	\N
396498	1678	29520912466000	30300	14894	3	0	\N
396499	1874	19757000	30300	14894	4	0	\N
396500	1874	19758000	30300	14894	5	0	\N
396501	1874	19759000	30300	14894	6	0	\N
396502	1874	19763000	30300	14894	7	0	\N
396503	1874	19767000	30300	14894	8	0	\N
396504	1874	19771000	30300	14894	9	0	\N
396519	1678	29520912467000	30303	14895	0	0	\N
396520	1874	19772000	30303	14895	1	0	\N
396521	1874	19773000	30303	14895	2	0	\N
396522	1678	29520912468000	30304	14896	0	0	\N
396523	1678	29520912469000	30304	14896	1	0	\N
396524	1874	19791000	30304	14896	2	0	\N
396525	1874	19793000	30304	14896	3	0	\N
396526	1874	19797000	30304	14896	4	0	\N
396527	1718	15376664519070	30304	14896	5	0	\N
396528	1874	19801000	30304	14896	6	0	\N
396536	1678	29520912467000	30306	14895	0	0	\N
396537	1678	29520912468000	30306	14895	1	0	\N
396538	1678	29520912469000	30306	14895	2	0	\N
396539	1874	19773000	30306	14895	3	0	\N
396540	1874	19775000	30306	14895	4	0	\N
396541	1874	19776000	30306	14895	5	0	\N
396542	1718	15376664519070	30306	14895	6	0	\N
396543	1874	19777000	30306	14895	7	0	\N
396544	1678	29520912470000	30307	14897	0	0	\N
396545	1874	19805000	30307	14897	1	0	\N
396546	1678	29520912470000	30308	14897	0	0	\N
396547	1874	19805000	30308	14897	1	0	\N
396548	1678	29520912470000	30309	14897	0	0	\N
396549	1874	19805000	30309	14897	1	0	\N
396552	1678	29520912470000	30311	14897	0	0	\N
396553	1678	29520912470000	30312	14897	0	0	\N
396559	1678	29520912471000	30314	14898	0	0	\N
396560	1534	180000000	30314	14898	1	0	\N
396561	1874	19806000	30314	14898	2	0	\N
396562	1874	19810000	30314	14898	3	0	\N
396563	1874	19812000	30314	14898	4	0	\N
396564	1678	29520912471000	30315	14898	0	0	\N
396565	1534	180000000	30315	14898	1	0	\N
396566	1874	19806000	30315	14898	2	0	\N
396567	1874	19810000	30315	14898	3	0	\N
396568	1874	19812000	30315	14898	4	0	\N
396571	1678	29520912473000	30317	14900	0	0	\N
396572	1874	19820000	30317	14900	1	0	\N
396573	1874	19822000	30317	14900	3	0	\N
396574	1678	29520912473000	30318	14900	0	0	\N
396575	1874	19820000	30318	14900	1	0	\N
396576	1874	19822000	30318	14900	3	0	\N
396450	1874	19709000	30293	14892	2	0	3
396451	1874	19710000	30293	14892	3	0	3
396452	1874	19714000	30293	14892	4	0	3
396453	1874	19715000	30293	14892	5	0	3
396454	1874	19716000	30293	14892	6	0	3
396456	1874	19724000	30293	14892	8	0	3
396457	1874	19728000	30293	14892	9	0	3
396458	1874	19732000	30293	14892	10	0	3
396459	1874	19736000	30293	14892	11	0	3
396460	1874	19740000	30293	14892	12	0	3
396483	1874	19744000	30297	14893	1	0	3
396484	1874	19748000	30297	14893	2	0	3
396485	1874	19752000	30297	14893	3	0	3
396486	1874	19756000	30297	14893	4	0	3
396506	1874	19757000	30301	14894	4	0	3
396507	1874	19758000	30301	14894	5	0	3
396508	1874	19759000	30301	14894	6	0	3
396509	1874	19763000	30301	14894	7	0	3
396510	1874	19767000	30301	14894	8	0	3
396512	1678	29520912467000	30302	14895	0	0	1
396513	1874	19772000	30302	14895	1	0	3
396514	1874	19776000	30302	14895	2	0	3
396515	1874	19777000	30302	14895	3	0	3
396516	1874	19781000	30302	14895	4	0	3
396518	1874	19789000	30302	14895	6	0	3
396529	1678	29520912468000	30305	14896	0	0	1
396530	1678	29520912469000	30305	14896	1	0	1
396531	1874	19791000	30305	14896	2	0	3
396533	1874	19797000	30305	14896	4	0	3
396534	1718	15376664519070	30305	14896	5	0	13
396535	1874	19801000	30305	14896	6	0	3
396550	1678	29520912470000	30310	14897	0	0	1
396551	1874	19805000	30310	14897	1	0	3
396555	1534	180000000	30313	14898	1	0	1
396556	1874	19806000	30313	14898	2	0	3
396557	1874	19810000	30313	14898	3	0	3
396558	1874	19812000	30313	14898	4	0	3
396569	1678	29520912472000	30316	14899	0	0	1
32979	1677	719000000000	2	2	0	0	0
61414	1397	1439990000000	3	3	0	0	1
61415	1397	1439940000000	3	3	1	0	2
34881	1679	719000000000	3	3	4	0	0
34882	1679	719120000000	3	3	5	0	0
35829	1680	719000000000	4	4	2	0	0
35830	1680	719060000000	4	4	3	0	0
61421	1397	1439760000000	5	5	1	0	8
36193	1681	719000000000	5	5	3	0	0
36194	1681	719070000000	5	5	4	0	0
36489	1683	1439000000000	7	6	1	0	0
36490	1683	1439010000000	7	6	2	0	0
27756	1637	720000000000	11	7	1	0	0
27757	1637	720010000000	11	7	2	0	0
39583	1685	719000000000	12	8	1	0	0
39584	1685	719010000000	12	8	2	0	0
30325	1656	720000000000	14	9	0	0	0
229620	1678	0	18	11	0	0	0
61431	1397	1438700000000	18	11	1	0	14
40632	1686	719000000000	18	11	2	0	0
40633	1686	719020000000	18	11	3	0	0
229621	1678	1000	22	13	0	0	0
61440	1397	1438649998000	24	14	1	0	19
30326	1656	1440000000000	24	14	3	0	0
31644	1671	720000000000	25	15	2	0	0
31645	1671	720020000000	25	15	3	0	0
229632	1678	7000	29	17	0	0	0
61450	1397	1438589992000	29	17	1	0	25
16236	1476	720000000000	29	17	2	0	0
16247	1476	720020000000	29	17	3	0	0
27450	1634	720000000000	31	18	1	0	0
27451	1634	720010000000	31	18	2	0	0
15937	1474	720000000000	34	20	1	0	0
15938	1474	720010000000	34	20	2	0	0
229640	1678	13000	36	22	0	0	0
38959	1684	719000000000	36	22	1	0	0
38961	1684	719010000000	36	22	2	0	0
61458	1397	1438529986000	37	23	0	0	31
635	55	66720000000000	37	23	3	0	0
644	55	66720030000000	37	23	4	0	0
229645	1678	18000	38	24	1	0	0
61463	1397	1438479981000	38	24	2	0	36
32980	1677	1439000000000	38	24	3	0	0
24965	1607	720000000000	39	25	1	0	0
24966	1607	720010000000	39	25	2	0	0
61473	1397	1438439977000	48	28	0	0	40
13402	1447	720000000000	48	28	1	0	0
13403	1447	720010000000	48	28	2	0	0
61476	1397	1438429976000	51	29	0	0	41
229659	1678	24000	51	29	0	0	0
19348	1546	720000000000	51	29	1	0	0
19350	1546	720010000000	51	29	2	0	0
36501	1683	7199040000000	52	30	1	0	0
22093	1573	720000000000	55	31	2	0	0
22094	1573	720020000000	55	31	3	0	0
24577	1602	720000000000	56	32	1	0	0
24580	1602	720010000000	56	32	2	0	0
44706	1691	719000000000	58	33	1	0	0
44707	1691	719010000000	58	33	2	0	0
61486	1397	1438369970000	59	34	0	0	47
229669	1678	30000	59	34	0	0	0
44975	1692	719000000000	62	35	1	0	0
44976	1692	719010000000	62	35	2	0	0
12981	1444	720000000000	63	36	1	0	0
12982	1444	720010000000	63	36	2	0	0
29953	1654	720000000000	66	37	1	0	0
29955	1654	720010000000	66	37	2	0	0
229678	1678	35000	67	38	1	0	0
61498	1397	1438309964000	69	39	0	0	53
46061	1693	719000000000	69	39	1	0	0
46062	1693	719010000000	69	39	2	0	0
1747	311	66720000000000	72	41	1	0	0
1748	311	66720010000000	72	41	2	0	0
26403	1622	720000000000	73	42	1	0	0
26404	1622	720010000000	73	42	2	0	0
47009	1694	719000000000	74	43	1	0	0
47010	1694	719010000000	74	43	2	0	0
61504	1397	1438259959000	75	44	0	0	58
229687	1678	41000	75	44	0	0	0
19677	1547	720000000000	75	44	1	0	0
19679	1547	720010000000	75	44	2	0	0
25970	1613	720000000000	76	45	2	0	0
25971	1613	720020000000	76	45	3	0	0
14878	1458	720000000000	77	46	2	0	0
14879	1458	720020000000	77	46	3	0	0
29417	1649	720000000000	79	47	1	0	0
29418	1649	720010000000	79	47	2	0	0
61512	1397	1438199953000	80	48	0	0	64
229695	1678	47000	80	48	0	0	0
16975	1504	720000000000	80	48	1	0	0
16976	1504	720010000000	80	48	2	0	0
47450	1695	719000000000	81	49	2	0	0
47451	1695	719020000000	81	49	3	0	0
47763	1696	719000000000	82	50	1	0	0
47764	1696	719010000000	82	50	2	0	0
27153	1624	720000000000	83	51	1	0	0
27154	1624	720010000000	83	51	2	0	0
229703	1678	52000	85	52	0	0	0
61521	1397	1438139947000	85	52	1	0	70
229705	1678	54000	85	52	2	0	0
229706	1678	55000	86	53	0	0	0
26670	1623	720000000000	87	54	1	0	0
26671	1623	720010000000	87	54	2	0	0
61526	1397	1438089942000	88	55	0	0	75
11634	1422	720000000000	88	55	1	0	0
11635	1422	720010000000	88	55	2	0	0
2376	470	66720000000000	89	56	2	0	0
2379	470	66720020000000	89	56	3	0	0
229712	1697	0	90	57	0	0	0
36512	1683	11519080000000	90	57	2	0	0
16606	1489	720000000000	93	58	1	0	0
16607	1489	720010000000	93	58	2	0	0
61536	1397	1438039937000	94	59	0	0	80
1912	369	66720000000000	94	59	3	0	0
1913	369	66720030000000	94	59	4	0	0
229723	1678	66000	96	60	0	0	0
48490	1699	719000000000	96	60	1	0	0
48491	1699	719010000000	96	60	2	0	0
12679	1440	720000000000	99	61	1	0	0
12680	1440	720010000000	99	61	2	0	0
61545	1397	1437979931000	100	62	1	0	86
49119	1701	719000000000	100	62	3	0	0
49120	1701	719030000000	100	62	4	0	0
229739	1678	71000	104	63	0	0	0
20633	1559	720000000000	104	63	3	0	0
20635	1559	720030000000	104	63	4	0	0
61559	1397	1437939927000	105	64	0	0	90
22350	1587	720000000000	105	64	1	0	0
22360	1587	720010000000	105	64	2	0	0
229749	1678	76000	109	66	0	0	0
11062	1419	720000000000	109	66	2	0	0
11063	1419	720020000000	109	66	3	0	0
32991	1677	3599050000000	111	67	1	0	0
61570	1397	1437879921000	112	68	0	0	96
229759	1678	82000	116	69	2	0	0
23938	1599	720000000000	117	70	1	0	0
23939	1599	720010000000	117	70	2	0	0
61580	1397	1437819915000	119	71	0	0	102
229774	1678	87000	126	73	0	0	0
23024	1593	720000000000	126	73	3	0	0
23025	1593	720030000000	126	73	4	0	0
61594	1397	1437769910000	127	74	0	0	107
30629	1657	720000000000	127	74	3	0	0
30630	1657	720030000000	127	74	4	0	0
229780	1678	93000	128	75	0	0	0
21762	1571	10000000	128	75	1	0	0
21770	1571	720010000000	128	75	2	0	0
61602	1397	1437709904000	131	77	0	0	113
36519	1683	14399130000000	131	77	3	0	0
229788	1678	99000	133	79	0	0	0
50142	1705	719000000000	133	79	1	0	0
50143	1705	719010000000	133	79	2	0	0
61609	1397	1437659899000	135	80	1	0	118
61610	1397	1437649898000	136	81	0	0	119
36438	1682	719000000000	136	81	1	0	0
36440	1682	719010000000	136	81	2	0	0
229799	1678	104000	140	82	1	0	0
61621	1397	1437589892000	145	86	0	0	125
20925	1560	720000000000	145	86	1	0	0
20926	1560	720010000000	145	86	2	0	0
43666	1690	719000000000	147	87	1	0	0
43668	1690	719010000000	147	87	2	0	0
229807	1678	110000	148	88	0	0	0
17593	1509	720000000000	150	89	2	0	0
17594	1509	720020000000	150	89	3	0	0
34892	1679	2879160000000	152	90	2	0	0
61632	1397	1437529886000	153	91	0	0	131
229818	1678	116000	156	93	0	0	0
27767	1637	2880050000000	156	93	3	0	0
61642	1397	1437479881000	158	94	1	0	136
229827	1678	121000	158	94	3	0	0
14575	1457	720000000000	159	95	3	0	0
14576	1457	720030000000	159	95	4	0	0
61650	1397	1437419875000	161	96	0	0	142
229837	1678	127000	163	97	0	0	0
36525	1683	18719160000000	164	98	2	0	0
61658	1397	1437359869000	165	99	1	0	148
229841	1678	131000	165	99	1	0	0
229842	1678	132000	165	99	2	0	0
61663	1397	1437319865000	167	101	2	0	152
50830	1708	719000000000	167	101	4	0	0
50831	1708	719130000000	167	101	5	0	0
229856	1678	137000	170	102	0	0	0
51139	1709	719000000000	170	102	1	0	0
51140	1709	719010000000	170	102	2	0	0
4737	641	66720000000000	176	104	1	0	0
4738	641	66720010000000	176	104	2	0	0
61683	1397	1437259859000	178	105	0	0	158
229868	1678	143000	180	107	0	0	0
35846	1680	2879090000000	180	107	2	0	0
41324	1688	719000000000	182	108	1	0	0
41328	1688	719010000000	182	108	2	0	0
61690	1397	1437199853000	184	110	1	0	164
229877	1678	148000	186	111	0	0	0
61700	1397	1437149848000	188	112	1	0	169
49657	1703	719000000000	188	112	2	0	0
49659	1703	719020000000	188	112	3	0	0
229887	1678	154000	193	115	0	0	0
19983	1549	720000000000	193	115	1	0	0
19984	1549	720010000000	193	115	2	0	0
30947	1668	720000000000	197	117	1	0	0
30948	1668	720010000000	197	117	2	0	0
19179	1541	720000000000	201	118	1	0	0
19180	1541	720010000000	201	118	2	0	0
61713	1397	1437089842000	202	119	0	0	175
229899	1678	160000	204	120	0	0	0
33001	1677	5759090000000	205	121	1	0	0
61723	1397	1437029836000	210	123	1	0	181
229910	1678	165000	213	124	0	0	0
61731	1571	720000000000	216	127	0	0	1
51437	1710	719000000000	216	127	3	0	0
51439	1710	719030000000	216	127	4	0	0
229916	1678	171000	217	128	0	0	0
515	44	66720000000000	217	128	1	0	0
516	44	66720010000000	217	128	2	0	0
36208	1681	2879110000000	220	130	2	0	0
61738	1397	1436929826000	221	131	0	0	191
25389	1610	720000000000	225	133	1	0	0
25391	1610	720010000000	225	133	2	0	0
229926	1678	177000	227	134	0	0	0
61747	1703	719010000000	229	135	0	0	1
61748	1397	1436889822000	229	135	1	0	195
24281	1601	720000000000	229	135	2	0	0
24283	1601	720020000000	229	135	3	0	0
229934	1678	180000	232	137	0	0	0
2731	484	66720000000000	232	137	1	0	0
2732	484	66720010000000	232	137	2	0	0
61756	1397	1436839817000	235	139	1	0	200
229941	1678	186000	237	141	0	0	0
13703	1448	720000000000	241	142	1	0	0
13704	1448	720010000000	241	142	2	0	0
61768	1397	1436779811000	243	143	0	0	206
43442	1689	719000000000	243	143	1	0	0
43446	1689	719010000000	243	143	2	0	0
15586	1471	720000000000	245	144	1	0	0
15587	1471	720010000000	245	144	2	0	0
229957	1678	192000	247	145	2	0	0
61778	1397	1436739807000	247	145	3	0	210
36540	1683	23039220000000	249	146	3	0	0
229964	1678	197000	250	147	1	0	0
33009	1677	7199140000000	250	147	4	0	0
20349	1555	720000000000	252	148	0	0	0
61786	1701	1439050000000	255	149	0	0	1
229970	1678	202000	255	149	4	0	0
61792	1397	1436629796000	257	151	0	0	221
40946	1687	719000000000	257	151	1	0	0
40949	1687	719010000000	257	151	2	0	0
229979	1678	206000	265	154	0	0	0
229980	1678	207000	265	154	1	0	0
61802	1397	1436579791000	266	155	0	0	226
47016	1694	2879000000000	266	155	4	0	1
229990	1678	212000	270	157	0	0	0
61814	1397	1436529786000	274	159	0	0	231
45006	1692	3599070000000	277	160	1	0	0
230001	1678	218000	282	163	0	0	0
52332	1715	719000000000	286	164	1	0	0
52333	1715	719010000000	286	164	2	0	0
61827	1397	1436469780000	288	165	0	0	237
36550	1683	27359240000000	288	165	1	0	0
23374	1594	720000000000	290	166	2	0	0
23375	1594	720020000000	290	166	3	0	0
230011	1678	223000	291	167	0	0	0
1127	149	66720000000000	291	167	1	0	0
1128	149	66720010000000	291	167	2	0	0
61834	1397	1436419775000	294	169	0	0	242
230018	1678	229000	296	171	1	0	0
61846	1397	1436359769000	299	172	0	0	248
52608	1716	719000000000	301	173	1	0	0
52610	1716	719010000000	301	173	2	0	0
230032	1678	234000	303	174	2	0	0
46146	1693	2159030000000	303	174	3	0	0
46148	1693	2159060000000	303	174	4	0	0
61854	1504	616970000000	304	175	1	0	4
230037	1678	238000	304	175	4	0	0
52895	1717	719000000000	304	175	5	0	0
52896	1717	719050000000	304	175	6	0	0
61859	1504	516969000000	305	176	1	0	5
39596	1685	2879050000000	308	177	2	0	0
3660	606	66720000000000	309	178	1	0	0
3662	606	66720010000000	309	178	2	0	0
230048	152	66000000000000	312	180	0	0	0
61870	1397	1436229756000	313	181	0	0	261
33018	1677	9359170000000	316	182	2	0	0
230060	1697	302000000000	318	183	1	0	0
61883	1397	1436189752000	320	184	0	0	265
36557	1683	31679281000000	320	184	1	0	0
61885	1397	1436179751000	322	185	0	0	266
31969	1672	720000000000	323	186	1	0	0
31970	1672	720010000000	323	186	2	0	0
230070	1678	252000	325	187	0	0	0
4	42	66720000000000	325	187	2	0	0
5	42	66720020000000	325	187	3	0	0
61895	1397	1436119745000	327	188	1	0	272
18844	1536	720000000000	328	189	1	0	0
18849	1536	720010000000	328	189	2	0	0
230079	1678	258000	331	191	0	0	0
3233	563	66720000000000	335	192	1	0	0
3234	563	66720010000000	335	192	2	0	0
61909	1397	1436059739000	338	193	1	0	278
45017	1692	4319100000000	338	193	3	0	0
230095	1678	264000	342	195	1	0	0
27775	1637	5040110000000	342	195	3	0	0
61920	1397	1436009734000	345	197	0	0	283
34912	1679	5039201000000	345	197	4	0	0
230106	1678	268000	347	198	0	0	0
33025	1677	11519211000000	347	198	2	0	0
61929	1613	719010000000	349	200	1	0	1
12003	1426	720000000000	349	200	3	0	0
12004	1426	720030000000	349	200	4	0	0
230117	1503	0	355	202	0	0	0
230118	1678	272000	355	202	1	0	0
61943	1682	1428100000000	357	203	0	0	3
230127	1678	276000	358	204	1	0	0
61948	1397	1435899723000	358	204	2	0	294
36569	1683	35999311000000	359	205	2	0	0
230135	622	66002980000000	362	207	0	0	1
61956	1397	1435849718000	362	207	1	0	299
10063	1396	720000000000	367	209	2	0	0
10064	1396	720020000000	367	209	3	0	0
230148	1678	286000	370	210	0	0	0
61970	1710	718930000000	371	211	0	0	1
36575	1683	38879361000000	372	212	2	0	0
230158	1678	291000	378	214	0	0	0
61979	1397	1435749708000	379	215	0	0	309
53843	1723	719000000000	380	216	1	0	0
53844	1723	719010000000	380	216	2	0	0
230164	1678	295000	381	217	0	0	0
61985	1397	1435709704000	382	218	0	0	313
230171	1722	1436000000000	385	219	4	0	0
61993	1397	1435679701000	386	220	0	0	316
33034	1677	13679231000000	386	220	1	0	0
32316	1673	720000000000	390	222	1	0	0
32317	1673	720010000000	390	222	2	0	0
230182	1678	302000	392	223	0	0	0
54117	1724	719000000000	392	223	1	0	0
54118	1724	719010000000	392	223	2	0	0
62003	1397	1435639697000	393	224	0	0	320
17284	1508	720000000000	394	225	1	0	0
17285	1508	720010000000	394	225	2	0	0
62018	1397	1435599693000	401	227	0	0	324
62019	1397	1435589692000	401	227	1	0	325
230199	1678	308000	401	227	1	0	0
230204	1678	313000	403	229	1	0	0
62029	1397	1435529686000	406	230	0	0	331
20351	1555	1440000000000	407	231	1	0	0
230215	1678	318000	411	234	0	0	0
62037	1397	1435479681000	413	235	0	0	336
29207	1643	720000000000	414	236	1	0	0
29208	1643	720010000000	414	236	2	0	0
13317	1445	720000000000	416	237	2	0	0
13319	1445	720020000000	416	237	3	0	0
62044	1397	1435429676000	417	238	0	0	341
230224	1678	324000	417	238	0	0	0
230232	578	66000100000000	420	240	0	0	0
62053	1693	2876640000000	420	240	1	0	4
22685	1588	720000000000	420	240	3	0	0
22686	1588	720030000000	420	240	4	0	0
230245	1678	331000	429	244	0	0	0
62066	1397	1435349668000	430	245	0	0	349
16971	1502	720010000000	430	245	2	0	0
230249	379	66000100000000	433	246	0	0	0
230250	1678	333000	433	246	1	0	0
23684	1596	720000000000	433	246	2	0	0
23686	1596	720020000000	433	246	3	0	0
45023	1692	5039100000000	436	247	1	0	0
62087	1397	1435309664000	443	249	0	0	353
12314	1428	720000000000	443	249	3	0	0
12315	1428	720030000000	443	249	4	0	0
230276	1678	338000	446	250	0	0	0
14885	1458	2880070000000	447	251	2	0	0
62099	1397	1435269660000	448	252	0	0	357
18249	1516	720000000000	448	252	1	0	0
18252	1516	720010000000	448	252	2	0	0
41346	1688	2879050000000	449	253	2	0	0
230282	1678	343000	450	254	2	0	0
36586	1683	43199401000000	450	254	3	0	0
36588	1683	43199411000000	450	254	4	0	0
62107	1397	1435209654000	454	256	1	0	363
19358	1546	2880060000000	454	256	3	0	0
230294	1678	348000	460	258	0	0	0
14571	1456	1440140000000	460	258	2	0	0
33045	1677	15839271000000	462	259	1	0	0
54497	1727	719000000000	464	260	1	0	0
54498	1727	719010000000	464	260	2	0	0
62119	1397	1435159649000	465	261	0	0	368
34940	1679	7199251000000	467	262	1	0	0
230304	1678	354000	469	263	1	0	0
207	43	66720000000000	469	263	4	0	0
211	43	66720040000000	469	263	5	0	0
62132	1397	1435099643000	472	264	0	0	374
33049	1677	16559291000000	472	264	2	0	0
230321	1678	360000	475	265	2	0	0
46289	1693	3596530000000	475	265	3	0	5
46290	1693	3596560000000	475	265	4	0	5
62147	1686	1437930000000	478	267	0	0	1
31267	1670	720000000000	478	267	2	0	0
31268	1670	720110000000	478	267	3	0	0
230331	1678	363000	480	268	0	0	0
15950	1474	2880040000000	480	268	2	0	0
62153	1397	1435019635000	482	270	0	0	382
62159	1397	1435009634000	488	271	0	0	383
52030	1714	719000000000	488	271	1	0	0
52032	1714	719010000000	488	271	2	0	0
230345	1678	369000	490	272	2	0	0
4416	633	66720000000000	491	273	1	0	0
4417	633	66720010000000	491	273	2	0	0
21788	1571	2880040000000	493	274	2	0	1
62170	1397	1434949628000	495	275	0	0	389
49146	1701	2878770000000	495	275	3	0	2
230353	1678	375000	496	276	0	0	0
62176	1397	1434889622000	498	278	0	0	395
30330	1656	2160030000000	498	278	2	0	0
30333	1656	2160041000000	498	278	3	0	0
230358	1678	379000	499	279	0	0	0
5242	700	66720000000000	499	279	1	0	0
5244	700	66720010000000	499	279	2	0	0
62182	1397	1434849618000	502	281	1	0	399
230365	1732	100000000	503	282	2	0	0
41349	1688	3599050000000	503	282	3	0	0
5306	1271	1334046000000000	504	283	1	0	0
5307	1271	1334046010000000	504	283	2	0	0
62194	1397	1434809614000	507	284	1	0	403
230380	1678	389000	512	286	0	0	0
54905	1733	719000000000	512	286	1	0	0
54906	1733	719010000000	512	286	2	0	0
62203	1397	1434749608000	513	287	2	0	409
27781	1637	7200140000000	513	287	4	0	0
230385	1678	394000	514	288	0	0	0
230387	1678	395000	517	290	0	0	0
62209	1397	1434699603000	517	290	2	0	414
12703	1440	2880050000000	519	291	3	0	0
230395	886	63455161096354	520	292	1	0	0
62217	1397	1434659599000	520	292	3	0	418
230406	1678	405000	523	294	0	0	0
62228	1397	1434599593000	523	294	2	0	424
33051	1677	17279291000000	525	296	1	0	0
230413	1678	410000	527	297	0	0	0
62235	1397	1434559589000	528	298	0	0	428
51702	1711	719000000000	528	298	1	0	0
51704	1711	719010000000	528	298	2	0	0
230419	1678	415000	532	302	0	0	0
10073	1402	720000000000	532	302	1	0	0
10074	1402	720010000000	532	302	2	0	0
62243	1397	1434499583000	536	304	0	0	434
54732	1729	719000000000	540	306	1	0	0
54733	1729	719010000000	540	306	2	0	0
230431	1678	420000	541	307	0	0	0
36603	1683	47519442000000	541	307	2	0	0
62259	1397	1434449578000	547	309	0	0	439
230442	1678	425000	548	310	0	0	0
50469	1706	719000000000	550	311	1	0	0
50470	1706	719010000000	550	311	2	0	0
62265	1397	1434399573000	551	312	0	0	444
36611	1683	51839492000000	558	315	2	0	0
230453	1678	431000	559	316	0	0	0
62275	1397	1434339567000	560	317	1	0	450
41364	1688	5759122000000	560	317	2	0	0
230466	1678	437000	569	321	0	0	0
39612	1685	5039100000000	570	322	2	0	0
62288	1397	1434279561000	571	323	0	0	456
14017	1451	720000000000	571	323	1	0	0
14018	1451	720010000000	571	323	2	0	0
62290	1397	1434269560000	573	324	0	0	457
62296	1397	1434259559000	577	325	0	0	458
230477	1678	442000	577	325	1	0	0
62302	1397	1434219555000	579	327	1	0	462
230485	1678	448000	582	329	0	0	0
62314	1397	1434159549000	588	332	0	0	468
36618	1683	56159512000000	590	334	1	0	0
230494	1590	0	591	335	0	0	0
62319	1397	1434129546000	591	335	2	0	471
27790	1637	9360201000000	591	335	3	0	0
230501	1678	457000	596	338	0	0	0
33059	1677	19439341000000	596	338	2	0	0
62328	1397	1434069540000	599	340	0	0	477
230513	1678	463000	607	343	0	0	0
4118	632	66720000000000	607	343	1	0	0
4120	632	66720010000000	607	343	2	0	0
62344	1397	1434009534000	615	346	0	0	483
230521	1678	466000	615	346	0	0	0
230524	1678	467000	618	347	0	0	0
53765	1722	3594020000000	622	349	3	0	1
62351	1397	1433959529000	623	350	0	0	488
230530	1678	473000	624	351	1	0	0
25727	1611	720000000000	630	353	1	0	0
25729	1611	720010000000	630	353	2	0	0
62363	1397	1433899523000	631	354	0	0	494
10080	1402	2880060000000	631	354	2	0	0
36626	1683	60479542000000	633	355	1	0	0
230543	1678	479000	634	356	0	0	0
54947	1738	719000000000	637	357	1	0	0
54948	1738	719010000000	637	357	2	0	0
33076	1677	21599381000000	638	358	1	0	0
62375	1397	1433839517000	643	360	0	0	500
16287	1476	2880050000000	643	360	2	0	0
230553	1678	484000	644	361	0	0	0
17966	1513	720000000000	644	361	1	0	0
17967	1513	720010000000	644	361	2	0	0
62382	1397	1433789512000	647	363	1	0	505
1702	298	66720010000000	649	364	2	0	0
230575	1477	0	654	365	0	0	0
62402	1397	1433739507000	655	366	0	0	510
230585	1678	495000	658	367	0	0	0
14344	1455	720000000000	658	367	1	0	0
14346	1455	720010000000	658	367	2	0	0
62421	1397	1433679501000	662	368	3	0	516
48524	1699	2879089000000	662	368	5	0	1
230600	1678	500000	664	369	0	0	0
3253	576	66720010000000	665	370	2	0	0
62426	1397	1433649498000	667	371	0	0	519
62428	1397	1433639497000	669	372	0	0	520
230608	1678	506000	670	373	1	0	0
62434	1397	1433579491000	670	373	4	0	526
36658	1683	64799592000000	670	373	6	0	0
34954	1679	7919261000000	672	374	1	0	0
34959	1679	7919271000000	672	374	2	0	0
230615	1678	512000	673	375	0	0	0
33085	1677	23039421000000	673	375	2	0	0
62442	1397	1433519485000	676	377	1	0	532
230621	1678	517000	676	377	3	0	0
62450	1724	718760000000	680	379	0	0	1
45062	1692	7199131000000	680	379	2	0	0
230630	1678	521000	681	380	1	0	0
43681	1690	2879060000000	682	381	2	0	0
36667	1683	67679672000000	684	382	2	0	0
62457	1397	1433429476000	685	383	0	0	541
34754	1678	720000524000	685	383	1	0	0
34755	1678	720010524000	685	383	2	0	0
230641	1678	720010527000	690	385	0	0	0
48154	1698	719000000000	694	387	1	0	0
48155	1698	719010000000	694	387	2	0	0
62473	1397	1433369470000	698	388	0	0	547
230652	1678	720010532000	699	389	0	0	0
62482	1397	1433319465000	703	391	0	0	552
230659	1678	720010535000	703	391	0	0	0
230660	1678	720010536000	703	391	1	0	0
27800	1637	11520441000000	705	393	1	0	0
62488	1397	1433259459000	706	394	0	0	558
230666	1678	720010542000	707	395	0	0	0
62504	1397	1433199453000	714	398	0	0	564
21737	1569	720000000000	714	398	1	0	0
21738	1569	720010000000	714	398	2	0	0
230682	1678	720010548000	717	400	0	0	0
62509	1397	1433149448000	718	401	1	0	569
230687	1678	720010553000	718	401	2	0	0
36685	1683	71999752000000	718	401	4	0	0
62517	578	66000090000000	721	403	2	0	1
230695	1678	720010558000	724	405	2	0	0
62528	1397	1433069440000	726	406	0	0	577
29752	1650	720000000000	726	406	1	0	0
29753	1650	720010000000	726	406	2	0	0
55151	1740	719000000000	728	407	2	0	0
55152	1740	719020000000	728	407	3	0	0
230705	1678	720010564000	730	409	0	0	0
46392	1693	5036570000000	730	409	1	0	5
46393	1693	5036580000000	730	409	2	0	5
62534	1397	1433019435000	731	410	0	0	582
2410	470	68880050000000	731	410	2	0	0
230712	1678	720010569000	736	413	1	0	0
11071	1419	2880070000000	736	413	3	0	0
62545	1397	1432959429000	741	415	0	0	588
230721	1678	720010575000	743	417	1	0	0
30958	1668	2880040000000	744	418	2	0	0
62553	1397	1432899423000	747	419	0	0	594
40656	1686	2877950000000	747	419	2	0	1
33097	1677	25199561000000	749	420	2	0	0
62561	1397	1432869420000	755	422	0	0	597
20642	1559	2880070000000	755	422	2	0	0
62562	1397	1432859419000	756	423	0	0	598
230734	1678	720010581000	756	423	0	0	0
230751	1736	0	766	426	1	0	0
62583	1397	1432819415000	766	426	2	0	602
230761	1736	0	770	428	3	0	0
62597	886	63455041096354	772	429	0	0	3
62602	1397	1432749408000	774	431	1	0	609
230771	1678	720010592000	774	431	1	0	0
1389	171	66720000000000	779	432	1	0	0
1391	171	66720010000000	779	432	2	0	0
230794	1678	720010596000	786	435	0	0	0
62626	1397	1432699403000	786	435	1	0	614
230795	1678	720010597000	786	435	1	0	0
10088	1402	5040090000000	790	437	2	0	0
31299	1670	2160240000000	793	439	1	0	0
31300	1670	2160250000000	793	439	2	0	0
62637	1397	1432639397000	794	440	0	0	620
230806	1678	720010603000	794	440	0	0	0
14590	1457	3600100000000	794	440	3	0	0
36701	1683	76319892000000	796	441	2	0	0
62649	1397	1432589392000	804	444	0	0	625
230819	1678	720010609000	804	444	1	0	0
24974	1607	2880040000000	805	445	2	0	0
53769	1722	5034060000000	806	446	4	0	1
62658	1397	1432529386000	808	447	0	0	631
230827	1678	720010614000	808	447	0	0	0
36231	1681	5039150000000	809	448	2	0	1
26285	1616	720000000000	812	449	1	0	0
26287	1616	720010000000	812	449	2	0	0
62669	1397	1432469380000	817	452	0	0	637
230838	1678	720010620000	817	452	0	0	0
45092	1692	9359411000000	819	453	2	0	0
62681	1397	1432429376000	825	455	1	0	641
230853	1678	720010625000	827	456	0	0	0
27815	1637	12960471000000	832	458	2	0	0
22119	1573	2880060000000	833	459	2	0	0
39618	1685	7199140000000	836	460	1	0	0
62694	1397	1432369370000	837	461	0	0	647
230863	1678	720010630000	837	461	0	0	0
29962	1654	2160040000000	837	461	3	0	0
62697	1397	1432339367000	838	462	1	0	650
62698	1397	1432329366000	839	463	0	0	651
230872	1678	720010636000	842	464	0	0	0
33108	1677	27359591000000	846	467	2	0	0
62708	1397	1432269360000	847	468	0	0	657
23948	1599	2880050000000	847	468	3	0	0
230879	1678	720010642000	848	469	0	0	0
36718	1683	80639912000000	848	469	1	0	0
18265	1516	2880150000000	850	471	2	0	0
21388	1564	720000000000	851	472	1	0	0
21389	1564	720010000000	851	472	2	0	0
62714	1397	1432209354000	853	474	0	0	663
230884	1678	720010647000	853	474	1	0	0
62723	1397	1432159349000	855	475	1	0	668
2743	484	68880060000000	855	475	4	0	0
230899	1678	720010653000	859	476	0	0	0
62738	1397	1432109344000	861	477	3	0	673
230911	1737	1000000000	865	479	0	0	0
38991	1684	3599030000000	867	480	1	0	0
62748	1397	1432059339000	869	482	0	0	678
230921	1678	720010662000	873	483	0	0	0
18889	1536	2880060000000	873	483	2	0	0
62756	1397	1432009334000	875	485	1	0	683
230927	1678	720010668000	876	486	1	0	0
230929	1678	720010670000	877	487	1	0	0
230930	1678	720010671000	877	487	2	0	0
62762	1397	1431949328000	878	488	0	0	689
36724	1683	82079922000000	879	489	2	0	0
36726	1683	82079942000000	879	489	3	0	0
230939	1678	720010677000	884	492	0	0	0
52345	1715	2879040000000	884	492	2	0	0
62771	394	66000090000000	885	493	0	0	1
53862	1723	3599060000000	889	494	1	0	0
53863	1723	3599070000000	889	494	2	0	0
62788	1712	2385000000	892	495	2	0	6
230957	1742	100000000	892	495	2	0	0
230963	1678	720010685000	896	498	0	0	0
62795	1397	1431809314000	896	498	1	0	703
36742	1683	86399972000000	900	501	2	0	0
230971	1678	720010690000	902	502	1	0	0
62803	1397	1431759309000	902	502	2	0	708
13722	1448	2880170000000	902	502	4	0	0
25410	1610	2880070000000	906	503	3	0	0
62817	1397	1431709304000	910	506	0	0	713
230986	1678	720010696000	910	506	0	0	0
33119	1677	29519621000000	914	508	1	0	0
230995	1744	1000000000	915	509	0	0	0
62827	1397	1431659299000	915	509	1	0	718
62833	1397	1431619295000	917	510	3	0	722
62836	1397	1431609294000	920	511	0	0	723
231005	1678	720010706000	920	511	0	0	0
43694	1690	5039130000000	920	511	2	0	0
1758	311	69600080000000	921	512	2	0	0
51172	1709	2879040000000	923	514	2	0	0
53772	1722	6474080000000	924	515	1	0	1
62842	1397	1431559289000	925	516	0	0	728
231013	1678	720010712000	928	517	0	0	0
13416	1447	2880040000000	928	517	2	0	0
62857	1397	1431499283000	936	520	0	0	734
231025	1678	720010717000	936	520	0	0	0
21623	1566	720000000000	936	520	1	0	0
21624	1566	720010000000	936	520	2	0	0
25128	1608	720000000000	938	522	1	0	0
25132	1608	720010000000	938	522	2	0	0
62864	1397	1431449278000	942	524	1	0	739
231033	1678	720010723000	942	524	2	0	0
26684	1623	2880040000000	944	525	2	0	0
36764	1683	90720012000000	946	527	3	0	0
62871	1397	1431389272000	947	528	0	0	745
31664	1671	2880090000000	947	528	2	0	0
231041	1678	720010729000	949	529	0	0	0
30341	1656	4320071000000	949	529	2	0	0
679	58	68160060000000	951	530	3	0	0
13002	1444	2880070000000	952	531	3	0	0
62880	1397	1431329266000	953	532	0	0	751
231048	1678	720010734000	953	532	0	0	0
43478	1689	2879080000000	953	532	2	0	0
62888	1397	1431279261000	959	535	0	0	756
231057	1678	720010740000	959	535	1	0	0
41390	1688	7919212000000	959	535	7	0	0
62900	1397	1431219255000	961	536	0	0	762
231068	1678	720010745000	961	536	0	0	0
231069	1678	720010746000	961	536	1	0	0
33145	1677	31679691000000	964	537	2	0	0
62913	1397	1431159249000	970	540	0	0	768
231084	1678	720010752000	973	541	0	0	0
47063	1694	5039030000000	976	542	1	0	1
47065	1694	5039040000000	976	542	2	0	1
62926	1397	1431109244000	983	545	0	0	773
231103	1678	720010758000	992	547	0	0	0
41404	1688	10079232000000	995	549	1	0	0
62941	1397	1431049238000	998	551	0	0	779
231110	1678	720010763000	999	552	0	0	0
50479	1706	2876851000000	1001	553	2	0	2
32604	1675	720000000000	1004	555	1	0	0
32607	1675	720010000000	1004	555	2	0	0
62950	1397	1430989232000	1007	557	1	0	785
231119	1678	1440030769000	1008	558	0	0	0
62955	1397	1430939227000	1008	558	4	0	790
231129	1678	1440030775000	1013	560	0	0	0
13741	1448	3600170000000	1014	561	1	0	0
13742	1448	3600180000000	1014	561	2	0	0
62967	1397	1430879221000	1019	564	0	0	796
231136	1678	1440030780000	1020	565	0	0	0
62969	1397	1430859219000	1021	566	0	0	798
62972	1397	1430849218000	1024	567	0	0	799
1066	101	66720000000000	1028	569	1	0	0
1067	101	66720010000000	1028	569	2	0	0
231147	1678	1440030786000	1029	570	0	0	0
40670	1686	3597950000000	1030	571	1	0	1
40671	1686	3597960000000	1030	571	2	0	1
62982	1397	1430789212000	1032	572	0	0	805
17607	1509	2880080000000	1034	574	2	0	0
36783	1683	95040032000000	1035	575	2	0	0
231155	1678	1440030792000	1037	576	0	0	0
39627	1685	9359200000000	1038	577	1	0	0
62990	1397	1430729206000	1040	578	0	0	811
18355	1519	720010000000	1040	578	2	0	0
10097	1402	7200130000000	1042	579	1	0	0
231165	1678	1440030797000	1047	581	0	0	0
63003	1397	1430679201000	1049	582	1	0	816
231175	1678	1440030802000	1050	583	1	0	0
63009	1693	6363558572031	1051	584	1	0	9
231181	138	66037333809323	1051	584	5	0	0
63015	1693	5667199359191	1051	584	7	0	15
35020	1679	10079491000000	1051	584	10	0	0
231195	304	66037333809323	1053	585	1	0	0
63029	1693	5555167931222	1053	585	3	0	18
231201	191	66037333809323	1053	585	7	0	0
231202	122	66037333809323	1053	585	8	0	0
63035	1693	5323327104091	1053	585	9	0	24
231208	408	66037333809323	1053	585	14	0	0
63041	1693	5099264248153	1053	585	15	0	30
63046	1693	4776320400786	1053	585	20	0	35
231214	106	66037333809323	1053	585	20	0	0
231219	84	66037333809323	1053	585	25	0	0
63052	1693	4585631707730	1053	585	26	0	41
231225	710	5002828318886	1053	585	31	0	0
63058	1693	4396074342229	1053	585	32	0	47
15257	1467	720000000000	1053	585	36	0	0
15259	1467	721350000000	1053	585	37	0	0
63168	1693	4074327339327	1058	586	0	0	49
63169	1397	1430609194000	1058	586	1	0	823
231337	1678	1440030806000	1058	586	1	0	0
231338	105	66037333809323	1058	586	2	0	0
63175	1693	3886466965162	1058	586	7	0	55
231344	678	66037333809323	1058	586	8	0	0
63181	1693	3662404109224	1058	586	13	0	61
231350	37	65364953683265	1058	586	14	0	0
63228	1693	3206885179062	1060	587	1	0	65
231397	739	10005656637772	1060	587	2	0	0
63234	1693	2878274693923	1060	587	7	0	71
231403	245	66037333809323	1060	587	8	0	0
63240	1693	1733355792078	1060	587	13	0	77
63241	1693	1696011982755	1060	587	14	0	78
231409	108	66037333809323	1060	587	14	0	0
63242	1693	1658668173432	1060	587	15	0	79
33174	1677	33839731000000	1061	588	3	0	0
231420	1678	1440030809000	1064	589	0	0	0
63254	1397	1430559189000	1065	590	0	0	828
48786	1700	719000000000	1065	590	1	0	0
48788	1700	719010000000	1065	590	2	0	0
27835	1637	15120501000000	1067	591	2	0	0
231430	1678	1440030815000	1073	594	0	0	0
36803	1683	99360067999541	1073	594	3	0	0
63266	1397	1430499183000	1075	595	0	0	834
52656	1716	2879070000000	1076	596	1	0	0
52657	1716	2879080000000	1076	596	2	0	0
14895	1458	5040110000000	1077	597	2	0	0
231441	1678	1440030821000	1079	598	1	0	0
63274	1397	1430449178000	1079	598	2	0	839
25433	1610	4320080000000	1079	598	3	0	0
25439	1610	4320110000000	1079	598	4	0	0
11928	1423	10000000	1080	599	1	0	0
11932	1423	720010000000	1080	599	2	0	0
682	58	68880060000000	1084	601	1	0	0
683	58	68880070000000	1084	601	2	0	0
231450	1678	1440030826000	1088	602	0	0	0
63284	1693	1545495417913	1089	603	1	0	83
231456	186	66037333809323	1089	603	5	0	0
63290	1397	1430389172000	1089	603	7	0	845
231462	663	66037333809323	1089	603	11	0	0
63295	1693	1131875122029	1089	603	12	0	92
231484	1678	1440030829000	1092	604	0	0	0
231485	201	66037333809323	1092	604	1	0	0
63318	1693	971629140211	1092	604	2	0	97
231491	377	66037333809323	1092	604	7	0	0
63324	1693	747566284273	1092	604	8	0	103
63329	1693	598191046981	1093	605	4	0	107
231497	601	66037333809323	1093	605	4	0	0
231502	660	66037333809323	1093	605	9	0	0
63339	1397	1430359169000	1095	606	0	0	848
33188	1677	35279771000000	1095	606	4	0	0
33189	1677	35279811000000	1095	606	5	0	0
48589	1699	3599089000000	1098	607	1	0	1
48591	1699	3599099000000	1098	607	2	0	1
231518	1678	1440030833000	1100	608	0	0	0
63351	1397	1430329166000	1101	609	0	0	851
63366	1397	1430279161000	1114	614	0	0	856
231534	1678	1440030839000	1114	614	0	0	0
36246	1681	6479200000000	1114	614	3	0	1
41436	1688	12239262000000	1117	616	1	0	0
63377	1397	1430229156000	1121	617	1	0	861
231545	1678	1440030844000	1121	617	1	0	0
63378	1397	1430219155000	1122	618	0	0	862
36815	1683	103680107999541	1122	618	3	0	0
231620	298	68159430000000	1126	620	0	0	2
231621	1678	1440030848000	1126	620	1	0	0
63456	1397	1430169150000	1129	622	0	0	867
231628	1678	1440030854000	1132	625	1	0	0
63464	1397	1430109144000	1135	627	0	0	873
231640	1678	1440030860000	1142	630	0	0	0
63473	1397	1430059139000	1143	631	0	0	878
10103	1402	9360190000000	1143	631	1	0	0
231650	1678	1440030865000	1151	634	1	0	0
63490	1397	1429999133000	1154	635	1	0	884
1891	363	66720000000000	1154	635	3	0	0
1892	363	66720030000000	1154	635	4	0	0
231663	1678	1440030871000	1158	638	0	0	0
33207	1677	37439841000000	1159	639	2	0	0
63498	1397	1429939127000	1161	640	0	0	890
231675	1678	1440030877000	1166	642	1	0	0
63510	1397	1429889122000	1169	643	0	0	895
63513	1397	1429869120000	1172	645	0	0	897
63514	1397	1429859119000	1173	646	0	0	898
231685	1678	1440030882000	1175	647	0	0	0
63524	1397	1429799113000	1179	650	1	0	904
231693	1678	1440030888000	1180	651	0	0	0
41459	1688	14399392000000	1180	651	1	0	0
35051	1679	12239671000000	1181	652	2	0	0
1759	311	70320080000000	1183	653	1	0	0
63531	1397	1429739107000	1185	655	0	0	910
231700	1678	1440030894000	1185	655	1	0	0
63539	1397	1429699103000	1187	656	2	0	914
231708	1678	1440030898000	1190	657	0	0	0
36841	1683	108000137999541	1195	659	1	0	0
63554	1397	1429639097000	1200	661	0	0	920
35886	1680	5039120000000	1200	661	2	0	0
231723	1678	1440030904000	1201	662	0	0	0
33220	1677	39599871000000	1204	664	2	0	0
63565	1397	1429579091000	1210	666	0	0	926
231734	1678	1440030910000	1211	667	0	0	0
12378	1439	720010000000	1211	667	2	0	0
63572	1397	1429529086000	1215	669	2	0	931
36857	1683	110880157999541	1215	669	3	0	0
36859	1683	110880187999541	1215	669	4	0	0
231742	1678	1440030915000	1217	670	0	0	0
54966	1739	2159040000000	1219	671	2	0	0
231745	1678	1440030917000	1220	672	0	0	0
231746	1678	1440030918000	1221	673	0	0	0
63586	1397	1429469080000	1224	674	0	0	937
10111	1402	11520220000000	1225	675	1	0	0
231759	1678	1440030924000	1227	676	0	0	0
22380	1587	2160030000000	1227	676	2	0	0
63593	1397	1429409074000	1229	678	0	0	943
19992	1549	2880041000000	1229	678	2	0	0
231767	1678	1440030930000	1233	681	0	0	0
63600	1397	1429359069000	1234	682	0	0	948
24620	1602	3600050000000	1234	682	2	0	0
24622	1602	3600070000000	1234	682	3	0	0
49391	1702	719000000000	1236	684	1	0	0
49397	1702	719010000000	1236	684	2	0	0
231775	1678	1440030935000	1240	685	0	0	0
27459	1634	2880060000000	1240	685	2	0	0
63609	1397	1429299063000	1242	687	0	0	954
231784	1678	1440030941000	1249	691	0	0	0
18908	1536	4320080000000	1250	692	1	0	0
18910	1536	4320090000000	1250	692	2	0	0
63619	1397	1429239057000	1252	693	0	0	960
33234	1677	41759891000000	1252	693	2	0	0
29246	1643	2160030000000	1256	694	1	0	0
29247	1643	2160040000000	1256	694	2	0	0
231794	1678	1440030947000	1258	696	0	0	0
63627	1397	1429189052000	1258	696	1	0	965
3561	596	67440020000000	1259	697	2	0	0
231805	1678	1440030952000	1263	698	0	0	0
63639	1397	1429129046000	1263	698	2	0	971
39639	1685	11519240000000	1263	698	4	0	0
63667	1397	1429109044000	1267	699	0	0	973
63668	1397	1429099043000	1267	699	1	0	974
231837	1678	1440030958000	1267	699	2	0	0
49942	1704	719000000000	1271	701	1	0	0
49943	1704	719010000000	1271	701	2	0	0
63678	1397	1429039037000	1276	704	0	0	980
36891	1683	115200217999541	1276	704	2	0	0
231848	1678	1440030964000	1278	705	0	0	0
19993	1549	3600041000000	1278	705	1	0	0
19994	1549	3600051000000	1278	705	2	0	0
12381	1439	1440010000000	1286	709	1	0	0
63689	1397	1428979031000	1287	710	0	0	986
231857	1678	1440030969000	1287	710	0	0	0
18430	1522	720000000000	1287	710	1	0	0
18433	1522	720010000000	1287	710	2	0	0
63696	1397	1428929026000	1293	714	0	0	991
231865	312	66000100000000	1293	714	1	0	0
47482	1695	2878950000000	1293	714	2	0	1
47488	1695	2878970000000	1293	714	3	0	1
231881	1678	1440030976000	1299	716	0	0	0
231882	1678	1440030977000	1299	716	1	0	0
63716	1397	1428879021000	1299	716	3	0	996
33271	1677	43919931000000	1299	716	4	0	0
10116	1402	12960250000000	1301	717	2	0	0
231893	1740	2160540000000	1303	718	2	0	0
47104	1694	7199090000000	1304	719	2	0	1
63727	1397	1428829016000	1305	720	0	0	1001
29428	1649	2880061000000	1306	721	4	0	0
231900	1678	1440030987000	1311	722	0	0	0
63733	1397	1428789012000	1312	723	0	0	1005
41491	1688	15839412000000	1317	725	1	0	0
41494	1688	15839422000000	1317	725	2	0	0
27847	1637	17280541000000	1319	726	2	0	0
231909	1678	1440030992000	1320	727	0	0	0
63743	1397	1428729006000	1320	727	2	0	1011
231920	1678	1440030998000	1324	728	1	0	0
63757	1397	1428679001000	1326	729	0	0	1016
231930	1678	1440031003000	1329	731	0	0	0
63763	1397	1428628996000	1330	732	0	0	1021
63821	1397	1428608994000	1335	734	0	0	1023
63822	1397	1428598993000	1335	734	1	0	1024
35910	1680	6479130000000	1335	734	2	0	0
35911	1680	6479150000000	1335	734	3	0	0
231991	1678	1440031008000	1336	735	0	0	0
55190	1740	5037549000000	1341	737	2	0	1
39649	1685	12959300000000	1345	739	2	0	0
63839	1397	1428538987000	1348	740	0	0	1030
232010	1678	1440031014000	1351	741	0	0	0
3265	576	68880030000000	1351	741	1	0	0
3266	576	68880040000000	1351	741	2	0	0
232017	1678	1440031018000	1356	744	0	0	0
63850	1397	1428478981000	1356	744	1	0	1036
232018	1678	1440031019000	1356	744	1	0	0
63858	1397	1428438977000	1362	747	0	0	1040
232027	418	66000000000000	1362	747	1	0	0
33288	1677	46080001000000	1365	748	1	0	0
36916	1683	119520248999541	1366	749	2	0	0
51718	1711	2879050000000	1370	751	2	0	0
63871	1397	1428388972000	1372	752	0	0	1045
232041	1678	1440031029000	1374	753	0	0	0
54750	1729	2879040000000	1377	754	2	0	0
63880	1397	1428338967000	1379	756	1	0	1050
232048	1678	1440031033000	1379	756	1	0	0
54132	1724	2878540000000	1379	756	3	0	2
54137	1724	2878660000000	1379	756	4	0	2
52038	1714	2878950000000	1382	757	3	0	1
63913	1397	1428288962000	1383	758	1	0	1055
232082	1678	1440031039000	1383	758	2	0	0
36937	1683	123840318999541	1384	759	1	0	0
63919	1397	1428228956000	1385	760	0	0	1061
63932	1397	1428218955000	1388	761	0	0	1062
232100	1678	1440031045000	1388	761	0	0	0
63933	1397	1428208954000	1388	761	1	0	1063
232105	1678	1440031049000	1388	761	5	0	0
63943	1397	1428158949000	1394	763	0	0	1068
30646	1657	2880070000000	1397	764	3	0	0
232119	1678	1440031055000	1399	765	1	0	0
63953	1397	1428098943000	1399	765	3	0	1074
232128	1678	1440031061000	1405	768	0	0	0
63961	1722	5756080000000	1405	768	1	0	2
55534	1746	719000000000	1409	769	1	0	0
55536	1746	719010000000	1409	769	2	0	0
232143	1678	1440031065000	1414	771	0	0	0
63982	1397	1428008934000	1419	772	0	0	1083
2449	470	71040070000000	1419	772	2	0	0
2451	470	71040081000000	1419	772	3	0	0
526	44	68880140000000	1421	773	2	0	0
36955	1683	128160358999541	1422	774	0	0	0
232159	1678	1440031068000	1426	775	0	0	0
232160	1678	1440031069000	1426	775	1	0	0
63996	1397	1427958929000	1427	776	0	0	1088
232167	1678	1440031075000	1430	778	2	0	0
64002	1397	1427908924000	1431	779	0	0	1093
232177	1678	2160041081000	1436	782	0	0	0
64012	1397	1427848918000	1436	782	1	0	1099
48803	1700	2879120000000	1439	784	2	0	1
232187	1678	2160041086000	1442	785	0	0	0
23707	1596	2880070000000	1442	785	3	0	0
64082	1397	1427788912000	1446	786	0	0	1105
10126	1402	15120301000000	1446	786	2	0	0
64083	1397	1427778911000	1447	787	0	0	1106
29765	1650	2880050000000	1449	788	2	0	0
232252	1678	2160041092000	1450	789	1	0	0
64090	1397	1427728906000	1452	791	0	0	1111
48687	1699	5759169000000	1452	791	2	0	1
232258	1678	2160041096000	1453	792	2	0	0
47133	1694	9359205000000	1453	792	4	0	1
64102	1397	1427688902000	1458	794	0	0	1115
232273	1678	2160041100000	1460	795	1	0	0
64111	1397	1427638897000	1461	796	0	0	1120
232280	1678	2160041106000	1466	799	0	0	0
56358	1751	719000000000	1467	800	1	0	0
56359	1751	719010000000	1467	800	2	0	0
64118	1397	1427578891000	1468	801	0	0	1126
232308	1678	2160041110000	1470	802	0	0	0
33304	1677	47520041000000	1470	802	2	0	0
232309	1678	2160041111000	1471	803	0	0	0
29971	1654	4320090000000	1471	803	2	0	0
64154	1397	1427518885000	1475	805	1	0	1132
232321	1678	2160041117000	1475	805	3	0	0
46202	1693	2478317500454	1475	805	6	0	116
64165	1397	1427468880000	1479	807	0	0	1137
3567	596	69600082000000	1479	807	4	0	0
232338	1678	2160041122000	1482	808	0	0	0
27854	1637	18720611000000	1482	808	2	0	0
64176	1397	1427418875000	1484	810	0	0	1142
232345	1735	1420000000000	1486	811	1	0	4
64186	1752	97000000	1489	813	1	0	2
232355	1678	2160041131000	1492	815	0	0	0
36973	1683	132480388999541	1494	817	2	0	0
64226	1397	1427328866000	1498	818	0	0	1151
64227	1397	1427318865000	1498	818	1	0	1152
232394	1753	12000000000	1498	818	3	0	0
24291	1601	2880100000000	1498	818	5	0	0
64233	1397	1427278861000	1501	821	0	0	1156
232399	1678	2160041140000	1502	822	0	0	0
13330	1445	2880050000000	1502	822	1	0	0
64246	1397	1427218855000	1512	827	0	0	1162
232412	1678	2160041146000	1512	827	1	0	0
31698	1671	4320140000000	1514	828	2	0	0
31700	1671	4320160000000	1514	828	3	0	0
48173	1698	2878940000000	1515	829	2	0	1
64253	1397	1427168850000	1516	830	0	0	1167
232420	1678	2160041151000	1516	830	2	0	0
64262	1397	1427118845000	1520	832	0	0	1172
232427	1678	2160041155000	1520	832	0	0	0
232428	1678	2160041156000	1520	832	1	0	0
15991	1474	5040070000000	1524	834	2	0	0
64272	1397	1427058839000	1525	835	1	0	1178
232438	1678	2160041162000	1525	835	2	0	0
33322	1677	49680071000000	1525	835	4	0	0
33323	1677	49680111000000	1525	835	5	0	0
36989	1683	136800418999541	1527	836	1	0	0
64283	1397	1427008834000	1531	838	0	0	1183
36995	1683	138240428999541	1531	838	1	0	0
36996	1683	138240438999541	1531	838	2	0	0
39657	1685	15119330000000	1534	839	2	0	0
232454	1678	2160041168000	1537	840	0	0	0
1768	311	71760100000000	1538	841	1	0	0
64336	1397	1426948828000	1548	844	0	0	1189
64344	1397	1426938827000	1555	846	0	0	1190
232509	1678	2160041173000	1555	846	0	0	0
50164	1705	2874870000000	1555	846	4	0	2
1413	171	68880060000000	1558	848	2	0	0
64353	1397	1426878821000	1559	849	1	0	1196
232518	1678	2160041179000	1559	849	1	0	0
33337	1677	51840151000000	1559	849	3	0	0
64364	1397	1426818815000	1568	854	0	0	1202
232529	1678	2160041185000	1568	854	0	0	0
4129	632	68880080000000	1575	858	2	0	0
64373	1397	1426768810000	1577	859	0	0	1207
232538	1678	2160041190000	1577	859	0	0	0
40969	1687	2879041000000	1584	861	2	0	0
37017	1683	142560468999541	1586	862	2	0	0
64389	1397	1426708804000	1589	863	0	0	1213
232554	1678	2160041196000	1589	863	0	0	0
33355	1677	54000201000000	1589	863	2	0	0
1930	369	69600080000000	1590	864	1	0	0
64486	1397	1426668800000	1598	866	0	0	1217
232651	1678	2160041200000	1598	866	0	0	0
16319	1476	5040100000000	1598	866	2	0	0
64509	1397	1426658799000	1604	867	0	0	1218
232674	1678	2160041201000	1604	867	0	0	0
39034	1684	5759090000000	1604	867	2	0	0
39035	1684	5759110000000	1604	867	3	0	0
64641	1397	1426608794000	1609	870	0	0	1223
232806	1678	2160041206000	1609	870	0	0	0
64642	1397	1426598793000	1609	870	1	0	1224
232807	1678	2160041207000	1609	870	1	0	0
64653	1397	1426538787000	1615	873	0	0	1230
232818	1678	2160041213000	1615	873	0	0	0
36451	1682	2867110000000	1617	874	2	0	4
41525	1688	17999472000000	1620	875	2	0	0
232872	1678	2160041216000	1625	876	0	0	0
23908	1597	720000000000	1625	876	1	0	0
23909	1597	720010000000	1625	876	2	0	0
232873	1678	2160041217000	1626	877	0	0	0
64714	1397	1426478781000	1632	879	0	0	1236
232885	1678	2160041223000	1635	881	1	0	0
2281	404	66720000000000	1635	881	2	0	0
2282	404	66720020000000	1635	881	3	0	0
64721	1397	1426428776000	1636	882	0	0	1241
18272	1516	5040210000000	1636	882	1	0	0
27862	1637	20880641000000	1638	883	1	0	0
64743	1397	1426378771000	1648	887	0	0	1246
232908	1678	2160041229000	1648	887	0	0	0
20952	1560	2880070000000	1648	887	1	0	0
20954	1560	2880080000000	1648	887	2	0	0
64744	1397	1426368770000	1649	888	0	0	1247
232920	1678	2160041234000	1656	892	0	0	0
64759	1397	1426308764000	1659	893	0	0	1253
27196	1633	2160040000000	1659	893	2	0	0
232928	1678	2160041240000	1660	894	3	0	0
13335	1445	4320120000000	1660	894	5	0	0
64773	1397	1426248758000	1663	895	1	0	1259
31334	1670	4320310000000	1669	896	3	0	0
232963	1678	2160041246000	1670	897	1	0	0
64799	1397	1426198753000	1671	898	0	0	1264
232969	1678	2160041251000	1673	899	3	0	0
232978	1678	2160041252000	1676	900	0	0	0
64816	1397	1426138747000	1679	901	0	0	1270
3682	606	68160020000000	1683	903	1	0	0
3684	606	68160030000000	1683	903	2	0	0
45152	1692	11519441000000	1684	904	1	0	0
45154	1692	11519451000000	1684	904	2	0	0
232988	1678	2160041258000	1687	906	0	0	0
46311	1693	3918337500454	1687	906	2	0	116
64824	1397	1426078741000	1688	907	0	0	1276
37044	1683	146880508999541	1689	908	2	0	0
64839	1397	1426028736000	1693	910	1	0	1281
233004	1678	2160041264000	1693	910	1	0	0
53777	1722	6493081000000	1695	912	1	0	4
233009	1401	0	1697	914	1	0	0
64845	1397	1425988732000	1697	914	2	0	1285
39663	1685	17279400000000	1697	914	5	0	0
64882	1397	1425958729000	1706	917	0	0	1288
64883	1397	1425948728000	1706	917	1	0	1289
47166	1694	11519225000000	1706	917	2	0	1
233124	1678	2160041273000	1709	918	0	0	0
233125	1401	0	1709	918	1	0	0
64966	1268	994990000000	1711	919	1	0	1
233133	1678	2160041278000	1715	921	1	0	0
23033	1593	2880070000000	1715	921	3	0	0
64985	1397	1425848718000	1721	924	1	0	1299
233152	1678	2160041284000	1721	924	3	0	0
64996	1397	1425798713000	1725	926	0	0	1304
233163	1678	2160041289000	1727	928	0	0	0
54172	1724	5758680000000	1727	928	1	0	2
65011	1397	1425758709000	1731	930	0	0	1308
65012	1397	1425748708000	1731	930	1	0	1309
54925	1735	2139990000000	1731	930	3	0	7
233185	1678	2160041295000	1740	934	0	0	0
37059	1683	151200528999541	1743	935	1	0	0
65026	1397	1425688702000	1744	936	0	0	1315
233203	1678	2160041301000	1752	938	0	0	0
3051	519	66720000000000	1753	939	1	0	0
3053	519	66720010000000	1753	939	2	0	0
65043	1397	1425628696000	1757	941	0	0	1321
233212	1678	2160041306000	1759	942	0	0	0
65052	1397	1425578691000	1762	943	2	0	1326
23397	1594	2160030000000	1763	944	1	0	0
23401	1594	2160040000000	1763	944	2	0	0
233220	1678	2160041312000	1765	946	0	0	0
24989	1607	5040080000000	1767	947	2	0	0
65058	1397	1425518685000	1770	949	0	0	1332
27871	1637	23760661000000	1770	949	3	0	0
233226	1678	2160041318000	1771	950	0	0	0
20669	1559	5040140000000	1771	950	3	0	0
65064	1397	1425458679000	1772	951	1	0	1338
45161	1692	12239451000000	1776	952	1	0	0
233234	1678	2160041323000	1777	953	0	0	0
12016	1426	2880070000000	1781	954	3	0	0
65080	1397	1425408674000	1785	955	0	0	1343
233245	1678	2160041326000	1785	955	0	0	0
233251	1678	2160041327000	1787	956	0	0	0
65093	1397	1425348668000	1790	957	0	0	1349
27877	1637	25200751000000	1790	957	2	0	0
233259	1678	2160041333000	1791	958	0	0	0
65127	1397	1425288662000	1797	961	0	0	1355
233293	1756	6479140000000	1798	962	0	0	0
33381	1677	56160231000000	1798	962	3	0	0
65136	1397	1425248658000	1802	964	0	0	1359
233306	1678	2160041343000	1805	965	0	0	0
65146	1397	1425208654000	1808	967	0	0	1363
37077	1683	155520568999541	1808	967	1	0	0
65149	1397	1425198653000	1811	968	0	0	1364
233315	1678	2160041348000	1812	969	0	0	0
47178	1694	13679285000000	1814	970	1	0	1
25978	1613	1438000000000	1816	971	0	0	2
65158	1397	1425138647000	1817	972	2	0	1370
233324	1678	2160041354000	1817	972	3	0	0
35100	1679	14399691000000	1817	972	4	0	0
35102	1679	14399731000000	1817	972	5	0	0
18250	1516	720000000000	1819	974	2	0	1
65167	1397	1425078641000	1826	976	0	0	1376
233332	1678	2160041359000	1826	976	0	0	0
10139	1402	17280341000000	1827	977	2	0	0
25988	1613	2158000000000	1834	979	0	0	2
65177	1397	1425028636000	1836	981	0	0	1381
233344	1678	2160041365000	1838	982	0	0	0
20674	1559	5760140000000	1840	983	1	0	0
20675	1559	5760150000000	1840	983	2	0	0
41551	1688	20159512000000	1844	985	2	0	0
4767	641	68880250000000	1848	986	1	0	0
4768	641	68880260000000	1848	986	2	0	0
65193	1397	1424968630000	1851	987	0	0	1387
233361	1678	2160041371000	1854	988	0	0	0
16625	1489	2160040000000	1854	988	2	0	0
52703	1716	5039130000000	1856	989	2	0	0
65207	1397	1424908624000	1862	992	0	0	1393
233372	1678	2160041376000	1862	992	0	0	0
5168	676	66720000000000	1862	992	1	0	0
27466	1634	5040100000000	1865	994	2	0	0
233377	1678	2160041379000	1867	995	0	0	0
65295	1397	1424868620000	1871	996	0	0	1397
233460	1678	2160041380000	1871	996	0	0	0
65298	1397	1424858619000	1873	997	0	0	1398
21825	1571	5040070000000	1875	998	2	0	1
233473	1678	2160041386000	1880	1000	0	0	0
65310	1397	1424798613000	1882	1001	0	0	1404
233484	1678	2160041392000	1890	1005	0	0	0
65320	1397	1424738607000	1891	1006	0	0	1410
51451	1710	2878960000000	1891	1006	2	0	1
27202	1633	2880050000000	1894	1008	2	0	0
233490	1678	2160041397000	1896	1010	0	0	0
65326	1397	1424688602000	1896	1010	1	0	1415
33405	1677	58320371000000	1896	1010	3	0	0
233497	1678	2160041403000	1899	1012	2	0	0
65333	1397	1424628596000	1900	1013	0	0	1421
48729	1699	7199189000000	1900	1013	2	0	1
29982	1654	6480110000000	1905	1015	2	0	0
39672	1685	19439420000000	1910	1016	1	0	0
233510	165	66000100000000	1911	1017	1	0	0
65346	1397	1424578591000	1911	1017	2	0	1426
53889	1723	5759120000000	1911	1017	4	0	0
233513	1678	2160041411000	1913	1019	0	0	0
233516	1678	2160041412000	1915	1020	0	0	0
52052	1714	5038990000000	1915	1020	3	0	1
65353	1397	1424538587000	1916	1021	0	0	1430
37095	1683	159840608999541	1923	1024	1	0	0
233531	1678	2160041417000	1927	1025	0	0	0
65368	1397	1424478581000	1927	1025	2	0	1436
53354	1719	719000000000	1927	1025	3	0	0
53360	1719	719030000000	1927	1025	4	0	0
45202	1692	14399492000000	1930	1026	1	0	0
233543	1678	2160041423000	1934	1028	0	0	0
2794	484	71040090000000	1934	1028	2	0	0
50181	1705	5034910000000	1936	1029	2	0	2
65385	1397	1424418575000	1939	1030	0	0	1442
22702	1588	2880060000000	1939	1030	2	0	0
43705	1690	7199310000000	1942	1031	2	0	0
65441	1397	1424388572000	1947	1032	0	0	1445
233606	1678	2160041428000	1947	1032	0	0	0
65442	1397	1424378571000	1948	1033	0	0	1446
39063	1684	7919160000000	1949	1034	2	0	0
4440	633	68880040000000	1954	1035	2	0	0
233618	1678	2160041434000	1956	1036	1	0	0
16327	1476	5760100000000	1956	1036	2	0	0
16331	1476	5760120000000	1956	1036	3	0	0
65454	1397	1424318565000	1957	1037	0	0	1452
53798	1722	8653121000000	1964	1039	2	0	4
233631	1678	2160041440000	1966	1040	1	0	0
65467	1397	1424258559000	1966	1040	2	0	1458
233636	1678	2160041445000	1967	1041	0	0	0
65472	1397	1424208554000	1967	1041	1	0	1463
47774	1696	2878061000000	1967	1041	3	0	1
37116	1683	162720638999541	1972	1043	2	0	0
65607	1397	1424178551000	1976	1044	0	0	1466
233772	1678	2160041449000	1976	1044	0	0	0
65609	1397	1424168550000	1978	1045	0	0	1467
233774	1678	2160041450000	1978	1045	0	0	0
20994	1560	5040110000000	1982	1047	2	0	0
65619	1397	1424108544000	1985	1049	0	0	1473
233784	1678	2160041456000	1985	1049	0	0	0
233785	1678	2160041457000	1985	1049	1	0	0
233786	1678	2160041458000	1986	1050	0	0	0
33426	1677	60480421000000	1993	1053	1	0	0
65630	1397	1424048538000	1995	1054	0	0	1479
233797	1678	2160041464000	1996	1055	1	0	0
37129	1683	167040658999541	1998	1056	1	0	0
37131	1683	167040668999541	1998	1056	2	0	0
65692	1397	1423998533000	2003	1058	0	0	1484
65695	1397	1423988532000	2005	1059	0	0	1485
19381	1546	5040100000000	2005	1059	3	0	0
233866	1678	2160041470000	2008	1060	0	0	0
33440	1677	61920471000000	2008	1060	4	0	0
65705	1397	1423928526000	2010	1062	0	0	1491
233955	1678	2160041475000	2015	1063	0	0	0
233956	1678	2160041476000	2015	1063	1	0	0
52908	1717	1439080000000	2015	1063	4	0	0
65804	1397	1423868520000	2023	1066	0	0	1497
20000	1549	5760091000000	2023	1066	3	0	0
233971	1678	2160041482000	2024	1067	0	0	0
46420	1693	5358257500454	2024	1067	3	0	117
65809	1397	1423818515000	2025	1068	1	0	1502
233980	1678	2160041488000	2030	1071	0	0	0
27881	1637	25920751000000	2030	1071	1	0	0
27884	1637	25920761000000	2030	1071	2	0	0
1775	311	73920030000000	2034	1072	2	0	0
65823	1397	1423758509000	2035	1073	0	0	1508
65826	1397	1423748508000	2037	1074	0	0	1509
65827	1397	1423738507000	2037	1074	1	0	1510
233992	1678	2160041493000	2037	1074	1	0	0
14032	1451	2880140000000	2039	1076	2	0	0
65835	1397	1423678501000	2042	1078	0	0	1516
234000	1678	2160041499000	2042	1078	0	0	0
30378	1656	6480111000000	2042	1078	2	0	0
65890	1397	1423618495000	2046	1080	4	0	1522
234055	1678	2160041505000	2046	1080	4	0	0
17011	1506	2880020000000	2046	1080	6	0	0
17012	1506	2880080000000	2046	1080	7	0	0
234057	1678	2160041507000	2047	1081	0	0	0
234058	1678	2160041508000	2048	1082	0	0	0
37147	1683	171360708999541	2048	1082	2	0	0
65896	1397	1423568490000	2051	1084	0	0	1527
33459	1677	64080511000000	2051	1084	2	0	0
33460	1677	64080531000000	2051	1084	3	0	0
234071	1678	2160041514000	2059	1087	0	0	0
65908	1397	1423508484000	2061	1089	0	0	1533
13043	1444	5040100000000	2061	1089	2	0	0
25144	1608	2880050000000	2063	1090	2	0	0
49190	1701	5038200000000	2065	1091	1	0	4
234080	1678	2160041520000	2068	1093	0	0	0
41591	1688	22319542000000	2068	1093	1	0	0
65919	1397	1423448478000	2072	1095	0	0	1539
10151	1402	19440361000000	2074	1096	1	0	0
234092	1678	2160041525000	2078	1097	0	0	0
65932	1397	1423398473000	2083	1099	0	0	1544
41615	1688	24479582000000	2084	1100	1	0	0
41625	1688	25199592000000	2086	1101	1	0	0
41626	1688	25199602000000	2086	1101	2	0	0
234102	1678	2160041531000	2087	1102	1	0	0
65939	1397	1423338467000	2089	1103	0	0	1550
234110	1678	2160041537000	2093	1105	0	0	0
65950	1397	1423278461000	2096	1106	1	0	1556
37173	1683	175680748999541	2096	1106	3	0	0
234120	1678	2160041542000	2099	1108	0	0	0
33474	1677	66240561000000	2101	1109	2	0	0
65962	1397	1423228456000	2106	1110	0	0	1561
29436	1649	5040101000000	2106	1110	2	0	0
66089	1397	1423218455000	2109	1111	0	0	1562
234254	1678	2160041545000	2109	1111	0	0	0
234255	1678	2160041546000	2110	1112	0	0	0
53804	1722	10813141000000	2115	1115	2	0	4
66099	1397	1423158449000	2117	1116	0	0	1568
66100	1397	1423148448000	2117	1116	1	0	1569
234265	1678	2160041552000	2117	1116	1	0	0
1720	298	71039470000000	2120	1118	2	0	2
41654	1688	27359662000000	2125	1120	3	0	0
66111	1397	1423088442000	2126	1121	0	0	1575
234276	1678	2160041558000	2126	1121	0	0	0
234282	1678	2160041563000	2132	1126	0	0	0
66118	1397	1423028436000	2133	1127	0	0	1581
52909	1717	2159080000000	2133	1127	1	0	0
66132	1397	1422978431000	2145	1132	0	0	1586
234297	1678	2160041569000	2145	1132	0	0	0
55224	1740	7196543000000	2148	1135	1	0	3
55225	1740	7196553000000	2148	1135	2	0	3
66138	1397	1422918425000	2149	1136	0	0	1592
234303	1678	2160041575000	2149	1136	0	0	0
12734	1440	5040080000000	2153	1138	2	0	0
234310	1678	2160041580000	2154	1139	1	0	0
11091	1419	5040110000000	2154	1139	3	0	0
66148	1397	1422858419000	2157	1140	0	0	1598
55829	1747	719000000000	2157	1140	2	0	0
55833	1747	719020000000	2157	1140	3	0	0
37189	1683	180000768999541	2160	1141	1	0	0
1138	149	68880060000000	2166	1143	2	0	0
66163	633	69598950000000	2168	1144	0	0	1
234328	120	66001000000000	2168	1144	0	0	0
234329	1678	2160041586000	2168	1144	1	0	0
234333	1678	2160041587000	2171	1145	0	0	0
27897	1637	28080801000000	2171	1145	2	0	0
66173	1397	1422758409000	2175	1147	0	0	1608
234342	1678	2160041593000	2179	1149	0	0	0
48201	1698	5039020000000	2179	1149	4	0	1
66183	1397	1422698403000	2181	1150	1	0	1614
234367	1678	2160041599000	2187	1152	0	0	0
66206	1397	1422648398000	2190	1154	0	0	1619
43727	1690	9359360000000	2190	1154	1	0	0
234378	1678	2160041604000	2194	1156	0	0	0
247	43	68880100000000	2194	1156	4	0	0
66279	1397	1422598393000	2197	1157	0	0	1624
66281	1397	1422588392000	2199	1158	0	0	1625
234448	1678	2160041610000	2199	1158	2	0	0
37208	1683	184320798999541	2202	1159	1	0	0
66292	1397	1422528386000	2206	1161	0	0	1631
234463	1678	2160041616000	2209	1162	1	0	0
234465	1678	2160041618000	2210	1163	1	0	0
234467	1678	2160041619000	2212	1164	0	0	0
66303	1397	1422468380000	2213	1165	0	0	1637
45248	1692	16559532000000	2213	1165	1	0	0
14919	1458	7200140000000	2219	1168	1	0	0
44728	1691	2879040000000	2221	1169	2	0	0
66315	1397	1422418375000	2223	1170	0	0	1642
234480	1678	2160041625000	2223	1170	0	0	0
39689	1685	21599450000000	2223	1170	1	0	0
66321	1397	1422368370000	2225	1172	0	0	1647
234486	1678	2160041630000	2225	1172	0	0	0
52359	1715	5039111000000	2225	1172	3	0	0
23961	1599	5040080000000	2228	1174	2	0	0
234495	1678	2160041635000	2233	1177	0	0	0
66331	1397	1422308364000	2233	1177	1	0	1653
41709	1688	29519702000000	2237	1179	2	0	0
66340	1397	1422268360000	2239	1180	1	0	1657
234505	1678	2160041640000	2239	1180	1	0	0
56607	1759	719000000000	2246	1183	0	0	0
66351	1397	1422218355000	2251	1184	1	0	1662
234516	1678	2160041645000	2251	1184	1	0	0
66369	1397	1422168350000	2259	1186	2	0	1667
234534	1678	2160041650000	2259	1186	2	0	0
66370	395	66034303809323	2259	1186	3	0	1
32627	1675	2880070000000	2259	1186	5	0	0
234542	1678	2160041653000	2262	1188	2	0	0
66378	1397	1422128346000	2262	1188	3	0	1671
18412	1521	1440050000000	2262	1188	5	0	0
17299	1508	2880050000000	2266	1189	3	0	0
52361	1715	5759131000000	2269	1191	3	0	0
234562	1678	2160041659000	2274	1193	0	0	0
66398	1397	1422068340000	2274	1193	1	0	1677
234581	1678	2160041664000	2282	1196	1	0	0
66418	1397	1422018335000	2285	1198	0	0	1682
716	58	71040120000000	2291	1202	2	0	0
234595	1678	2160041670000	2294	1203	0	0	0
66431	1397	1421958329000	2294	1203	1	0	1688
234601	1678	2160041674000	2296	1204	1	0	0
33496	1677	68400701000000	2296	1204	3	0	0
234602	1678	2160041675000	2297	1205	0	0	0
66567	1397	1421898323000	2303	1207	0	0	1694
31998	1672	2880050000000	2303	1207	2	0	0
66568	1397	1421888322000	2304	1208	0	0	1695
36461	1682	5027170000000	2304	1208	2	0	4
30998	1668	5040070000000	2306	1209	2	0	0
234739	1678	2160041680000	2312	1210	0	0	0
234740	1678	2160041681000	2312	1210	1	0	0
66592	1397	1421828316000	2316	1212	0	0	1701
41771	1688	31679722000000	2316	1212	2	0	0
41773	1688	31679742000000	2316	1212	3	0	0
234760	1678	2160041687000	2317	1213	1	0	0
43742	1690	11519410000000	2320	1214	2	0	0
37230	1683	188640838999541	2322	1215	1	0	0
66600	1397	1421768310000	2323	1216	0	0	1707
14607	1457	5760120000000	2323	1216	1	0	0
11118	1419	7200140000000	2325	1218	1	0	0
234768	1678	2160041693000	2326	1219	0	0	0
66626	1397	1421718305000	2336	1221	0	0	1712
234794	1678	2160041698000	2336	1221	3	0	0
66634	1397	1421658299000	2340	1223	2	0	1718
1824	337	66720020000000	2342	1224	3	0	0
66642	1397	1421628296000	2344	1225	0	0	1721
234807	1678	2160041704000	2344	1225	0	0	0
66643	1397	1421618295000	2344	1225	1	0	1722
48836	1700	4319140000000	2345	1226	1	0	1
48841	1700	4319150000000	2345	1226	2	0	1
31368	1670	6480340000000	2347	1227	2	0	0
16637	1489	4320080000000	2348	1228	2	0	0
234814	1678	2160041710000	2349	1229	0	0	0
66650	1397	1421558289000	2349	1229	1	0	1728
35189	1679	17279751000000	2349	1229	2	0	0
234827	1678	2160041715000	2357	1232	0	0	0
22410	1587	4320070000000	2357	1232	2	0	0
66664	1397	1421498283000	2359	1234	0	0	1734
66792	1397	1421488282000	2363	1235	0	0	1735
234957	1678	2160041718000	2363	1235	0	0	0
66793	1397	1421478281000	2363	1235	1	0	1736
234958	1678	2160041719000	2363	1235	1	0	0
1433	171	70320090000000	2371	1238	3	0	0
66807	1397	1421428276000	2372	1239	0	0	1741
234972	1678	2160041724000	2372	1239	0	0	0
41837	1688	33839822000000	2372	1239	2	0	0
24962	1606	720000000000	2378	1244	1	0	0
66814	1397	1421368270000	2379	1245	0	0	1747
234979	1678	2160041730000	2379	1245	0	0	0
37242	1683	191520868999541	2389	1248	2	0	0
66826	1397	1421328266000	2390	1249	1	0	1751
234991	1678	2160041734000	2390	1249	1	0	0
20361	1555	2160010000000	2391	1250	0	0	0
66834	1397	1421268260000	2395	1252	3	0	1757
234999	1678	2160041740000	2395	1252	3	0	0
33512	1677	70560731000000	2398	1255	1	0	0
66844	1397	1421208254000	2404	1257	0	0	1763
235009	1678	2160041746000	2404	1257	0	0	0
235010	1678	2160041747000	2405	1258	0	0	0
66852	1397	1421158249000	2411	1261	0	0	1768
27473	1634	6480120000000	2411	1261	1	0	0
27474	1634	6480130000000	2411	1261	2	0	0
235019	1678	2160041753000	2412	1262	1	0	0
32327	1673	2880300000000	2412	1262	3	0	0
54525	1727	2879040000000	2415	1264	2	0	0
66859	1397	1421098243000	2416	1265	1	0	1774
235030	1678	2160041758000	2419	1266	1	0	0
37256	1683	195840908999541	2422	1267	2	0	0
66873	1397	1421048238000	2423	1268	1	0	1779
31399	1670	8640370000000	2423	1268	2	0	0
235039	1678	2160041763000	2424	1269	0	0	0
51222	1709	5039230000000	2427	1271	2	0	0
66882	1397	1420998233000	2432	1273	0	0	1784
235052	1678	2160041769000	2435	1274	1	0	0
25745	1611	2880050000000	2435	1274	3	0	0
66898	1397	1420938227000	2440	1276	0	0	1790
26700	1623	5040091000000	2440	1276	2	0	0
235067	1678	2160041775000	2444	1278	0	0	0
37270	1683	198720938999541	2444	1278	1	0	0
37271	1683	198720948999541	2444	1278	2	0	0
66908	1397	1420878221000	2450	1282	0	0	1796
3574	596	71760102000000	2450	1282	1	0	0
235075	1678	2160041780000	2452	1283	0	0	0
15268	1467	2161380000000	2452	1283	3	0	0
66914	1397	1420848218000	2455	1284	0	0	1799
39696	1685	23759610000000	2455	1284	1	0	0
66915	1397	1420838217000	2456	1285	0	0	1800
235083	1678	2160041786000	2456	1285	3	0	0
2824	484	73200110000000	2458	1287	1	0	0
66923	1397	1420778211000	2461	1288	0	0	1806
235093	1678	2160041792000	2464	1290	0	0	0
66932	1397	1420718205000	2467	1292	1	0	1812
35965	1680	9359200000000	2468	1293	1	0	0
235099	1678	2160041797000	2469	1294	0	0	0
66941	1397	1420668200000	2475	1296	1	0	1817
235109	1678	2160041803000	2475	1296	4	0	0
52362	1715	5759181000000	2475	1296	5	0	0
31418	1670	9360390000000	2476	1297	1	0	0
31419	1670	9360400000000	2476	1297	2	0	0
56904	1762	719000000000	2479	1298	1	0	0
56905	1762	719010000000	2479	1298	2	0	0
66949	1397	1420608194000	2480	1299	0	0	1823
67057	1397	1420588192000	2486	1302	0	0	1825
235222	1678	2160041808000	2486	1302	0	0	0
67058	1397	1420578191000	2486	1302	1	0	1826
235223	1678	2160041809000	2486	1302	1	0	0
45284	1692	18719562000000	2492	1305	1	0	0
67068	1519	719000000000	2494	1306	1	0	1
235233	1763	0	2494	1306	1	0	0
67077	1397	1420468180000	2499	1309	0	0	1837
235242	1678	2160041820000	2499	1309	0	0	0
4802	641	71040330000000	2500	1310	5	0	0
67151	1516	0	2502	1311	0	0	2
235316	1756	7919139000000	2502	1311	0	0	1
235317	1678	2160041825000	2502	1311	1	0	0
31740	1671	6480200000000	2504	1312	2	0	0
13431	1447	5040070000000	2505	1313	2	0	0
67161	1397	1420368170000	2506	1314	0	0	1847
235327	1678	2160041831000	2507	1315	0	0	0
19244	1541	2880080000000	2507	1315	3	0	0
67170	1397	1420308164000	2510	1317	0	0	1853
31024	1668	6480080000000	2510	1317	1	0	0
31025	1668	6480090000000	2510	1317	2	0	0
235338	1678	2160041837000	2512	1318	0	0	0
33527	1677	72720771000000	2513	1319	1	0	0
37285	1683	203040978999541	2514	1320	2	0	0
67177	1397	1420258159000	2515	1321	0	0	1858
235344	1678	2160041842000	2517	1322	0	0	0
67188	1397	1420218155000	2520	1323	0	0	1862
67189	1397	1420208154000	2520	1323	1	0	1863
235356	1765	100000000	2520	1323	3	0	0
17057	1506	5040130000000	2523	1325	2	0	0
67199	1397	1420158149000	2524	1326	1	0	1868
45300	1692	19439572000000	2524	1326	3	0	0
45301	1692	19439602000000	2524	1326	4	0	0
235366	1678	2160041853000	2525	1327	0	0	0
52082	1714	7189020000000	2525	1327	3	0	2
2481	470	73200161000000	2527	1328	2	0	0
27911	1637	30240831000000	2529	1329	2	0	0
67207	1397	1420098143000	2530	1330	0	0	1874
235373	1678	2160041858000	2531	1331	0	0	0
235425	1678	2160041859000	2534	1333	0	0	0
235426	1678	2160041860000	2534	1333	1	0	0
56594	1758	400400000	2534	1333	5	0	1
12398	1439	3600060000000	2536	1334	1	0	0
67267	1706	4316771000000	2538	1335	0	0	3
49728	1703	2879140000000	2538	1335	3	0	1
20706	1559	7920200000000	2542	1337	2	0	0
235438	1678	2160041865000	2543	1338	0	0	0
67275	1397	1419998133000	2545	1340	0	0	1884
51762	1711	5039080000000	2545	1340	2	0	0
235449	1678	2160041871000	2549	1341	3	0	0
67286	1397	1419938127000	2551	1343	0	0	1890
41046	1687	5039071000000	2551	1343	3	0	1
67369	1397	1419908124000	2554	1345	0	0	1893
235534	1678	2160041876000	2554	1345	0	0	0
67370	1397	1419898123000	2554	1345	1	0	1894
10177	1402	21600421000000	2554	1345	2	0	0
35232	1679	18719781000000	2558	1348	1	0	0
35234	1679	18719791000000	2558	1348	2	0	0
235542	1678	2160041882000	2559	1349	0	0	0
67428	1397	1419838117000	2563	1350	0	0	1900
235593	1678	2160041883000	2563	1350	0	0	0
235594	1678	2160041884000	2563	1350	1	0	0
48229	1698	7199060000000	2563	1350	2	0	1
67450	1397	1419778111000	2571	1354	1	0	1906
33544	1677	74880821000000	2571	1354	2	0	0
235616	1678	2160041890000	2572	1355	0	0	0
67455	1397	1419728106000	2574	1357	0	0	1911
67457	1397	1419708104000	2575	1358	0	0	1913
235622	1678	2160041896000	2575	1358	0	0	0
43758	1690	13679430000000	2575	1358	1	0	0
67458	1397	1419698103000	2576	1359	0	0	1914
26010	1613	4318050000000	2580	1360	4	0	2
235632	1678	2160041901000	2582	1361	0	0	0
67471	1397	1419638097000	2587	1363	0	0	1920
235644	1678	2160041907000	2593	1366	0	0	0
20340	1552	2160020000000	2593	1366	1	0	0
67482	1397	1419578091000	2595	1367	1	0	1926
18941	1536	6480160000000	2595	1367	3	0	0
46530	1693	6797157500454	2598	1368	1	0	118
46532	1693	6797167500454	2598	1368	2	0	118
36278	1681	8639253195920	2604	1370	5	0	1
235657	1678	2160041913000	2605	1371	0	0	0
67493	1397	1419528086000	2605	1371	1	0	1931
235694	1678	2160041916000	2610	1373	0	0	0
235695	1678	2160041917000	2610	1373	1	0	0
37307	1683	207361008999541	2612	1374	2	0	0
67535	1397	1419468080000	2613	1375	1	0	1937
235703	1678	2160041923000	2613	1375	4	0	0
67548	1397	1419408074000	2621	1378	0	0	1943
235717	1678	2160041929000	2624	1380	0	0	0
48766	1699	9359209000000	2624	1380	2	0	1
67554	1397	1419358069000	2625	1381	0	0	1948
33557	1677	76320861000000	2625	1381	2	0	0
45337	1692	21599642000000	2629	1383	2	0	0
235724	1678	2160041934000	2630	1384	0	0	0
67565	1397	1419298063000	2634	1386	0	0	1954
25160	1608	5040090000000	2636	1387	2	0	0
235738	1678	2160041940000	2642	1389	0	0	0
47204	1694	15119305000000	2643	1390	2	0	1
47205	1694	15119325000000	2643	1390	3	0	1
67576	1397	1419238057000	2644	1391	0	0	1960
274	43	71040130000000	2644	1391	1	0	0
275	43	71040140000000	2644	1391	2	0	0
235746	1678	2160041946000	2649	1394	0	0	0
67584	1397	1419188052000	2651	1395	1	0	1965
235756	1678	2160041951000	2654	1396	2	0	0
67593	1397	1419138047000	2654	1396	4	0	1970
67682	1397	1419128046000	2658	1397	0	0	1971
235847	1678	2160041954000	2658	1397	0	0	0
235848	1678	2160041955000	2659	1398	0	0	0
36303	1681	10799303195920	2662	1399	3	0	1
27924	1637	32400851000000	2666	1400	1	0	0
67694	1397	1419068040000	2668	1402	0	0	1977
235860	1678	2160041961000	2668	1402	1	0	0
22157	1573	5040090000000	2671	1403	2	0	0
22441	1587	6480090000000	2674	1405	1	0	0
22442	1587	6480100000000	2674	1405	2	0	0
67713	1397	1419008034000	2677	1406	1	0	1983
235879	1678	2160041967000	2677	1406	2	0	0
67718	1397	1418958029000	2679	1408	0	0	1988
235884	1678	2160041972000	2680	1409	0	0	0
67816	1397	1418938027000	2684	1410	0	0	1990
235981	1678	2160041973000	2684	1410	0	0	0
29321	1643	4320090000000	2684	1410	2	0	0
67817	1397	1418928026000	2685	1411	0	0	1991
235982	1678	2160041974000	2685	1411	0	0	0
53914	1723	7919150000000	2685	1411	2	0	0
67829	1397	1418868020000	2695	1416	0	0	1997
235994	1678	2160041980000	2695	1416	0	0	0
32643	1675	3600090000000	2695	1416	3	0	0
67963	1397	1418818015000	2704	1420	0	0	2002
236128	1678	2160041985000	2704	1420	0	0	0
67964	1397	1418808014000	2704	1420	1	0	2003
236129	1678	2160041986000	2704	1420	1	0	0
17630	1509	5040110000000	2704	1420	2	0	0
33576	1677	78480891000000	2705	1421	2	0	0
50511	1706	5036781000000	2711	1424	2	0	3
67974	1397	1418748008000	2715	1426	0	0	2009
236139	1678	2160041992000	2715	1426	0	0	0
37325	1683	211681028999541	2716	1427	1	0	0
67983	1397	1418688002000	2720	1429	1	0	2015
236148	1678	2160041998000	2720	1429	1	0	0
68090	1397	1418637997000	2729	1432	0	0	2020
236255	1678	2160042003000	2729	1432	0	0	0
57512	1768	719000000000	2729	1432	1	0	0
57513	1768	719010000000	2729	1432	2	0	0
68091	1397	1418627996000	2730	1433	0	0	2021
236256	1678	2160042004000	2730	1433	0	0	0
13779	1448	5760220000000	2731	1434	3	0	0
3741	606	71040070000000	2733	1435	1	0	0
29191	1639	720020000000	2735	1436	3	0	0
68101	1397	1418567990000	2736	1437	0	0	2027
236266	1678	2160042010000	2736	1437	0	0	0
68183	1397	1418527986000	2747	1440	0	0	2031
68192	1397	1418517985000	2758	1442	0	0	2032
236358	1678	2160042016000	2758	1442	1	0	0
43511	1689	5039120000000	2758	1442	3	0	0
68317	1397	1418497983000	2761	1443	0	0	2034
236482	1678	2160042017000	2761	1443	0	0	0
68318	1397	1418487982000	2761	1443	1	0	2035
236483	1678	2160042018000	2761	1443	1	0	0
39100	1684	10079200000000	2761	1443	5	0	0
68326	1397	1418427976000	2767	1446	1	0	2041
236491	1678	2160042024000	2767	1446	1	0	0
51483	1710	5039050000000	2767	1446	5	0	1
68332	1397	1418367970000	2772	1450	0	0	2047
236497	1678	2160042030000	2772	1450	0	0	0
33598	1677	80640931000000	2772	1450	1	0	0
33600	1677	80640941000000	2772	1450	2	0	0
50852	1708	2879180000000	2773	1451	2	0	0
68343	1397	1418317965000	2779	1454	0	0	2052
236508	1678	2160042035000	2779	1454	0	0	0
236509	1678	2160042036000	2779	1454	1	0	0
23744	1596	5760110000000	2783	1456	1	0	0
24331	1601	5040150000000	2784	1457	2	0	0
53831	1722	12973181000000	2785	1458	1	0	4
68352	1397	1418257959000	2787	1459	0	0	2058
236518	528	66002000000000	2787	1459	1	0	0
26710	1623	7200111000000	2787	1459	2	0	0
68480	1397	1418247958000	2789	1460	0	0	2059
236645	1678	2160042042000	2789	1460	0	0	0
52376	1715	8639201000000	2789	1460	1	0	0
68482	1397	1418237957000	2791	1461	0	0	2060
236647	1678	2160042043000	2791	1461	0	0	0
19164	1540	720000000000	2791	1461	1	0	0
19172	1540	720010000000	2791	1461	2	0	0
32665	1675	4320090000000	2793	1462	1	0	0
68496	1397	1418177951000	2799	1464	3	0	2066
236661	1678	2160042049000	2799	1464	3	0	0
68638	1397	1418137947000	2806	1466	0	0	2070
236803	1678	2160042053000	2806	1466	0	0	0
68641	1397	1418127946000	2808	1467	0	0	2071
236806	1678	2160042054000	2808	1467	0	0	0
15603	1471	2880060000000	2810	1469	2	0	0
68648	1397	1418067940000	2815	1472	0	0	2077
236813	1678	2160042060000	2815	1472	0	0	0
45382	1692	23759682000000	2822	1474	3	0	0
68654	1769	2998000000	2825	1475	1	0	1
236819	1474	6474061000000	2825	1475	1	0	3
33627	1677	83520992000000	2827	1477	0	0	0
68667	1397	1417987932000	2829	1478	4	0	2085
236832	1678	2160042068000	2829	1478	4	0	0
68676	1397	1417927926000	2834	1481	0	0	2091
236841	1678	2160042074000	2834	1481	0	0	0
1950	369	71760120000000	2834	1481	1	0	0
35280	1679	20879842000000	2836	1482	5	0	0
68681	1397	1417887922000	2838	1484	0	0	2095
68682	1397	1417877921000	2838	1484	1	0	2096
236847	1678	2160042079000	2838	1484	1	0	0
15289	1467	4321440000000	2838	1484	4	0	0
17305	1508	5040080000000	2840	1485	2	0	0
41077	1687	5759071000000	2841	1486	2	0	1
41079	1687	5759091000000	2841	1486	3	0	1
236852	1678	2160042084000	2842	1487	0	0	0
68688	1397	1417817915000	2842	1487	1	0	2102
27933	1637	34560881000000	2846	1490	1	0	0
236859	1678	2160042090000	2847	1491	1	0	0
5254	700	68160020000000	2847	1491	2	0	0
68695	1397	1417757909000	2849	1492	0	0	2108
17642	1509	6480150000000	2850	1493	2	0	0
13058	1444	6480120000000	2854	1495	2	0	0
13059	1444	6480140000000	2854	1495	3	0	0
68703	1397	1417707904000	2856	1496	1	0	2113
236868	1678	2160042096000	2856	1496	1	0	0
14382	1455	2880061000000	2856	1496	4	0	0
3582	596	73920162000000	2863	1498	2	0	0
236885	1678	2160042100000	2865	1499	0	0	0
68721	1397	1417657899000	2866	1500	0	0	2118
4161	632	71040130000000	2871	1502	3	0	0
236897	1678	2160042106000	2873	1503	0	0	0
68734	1397	1417597893000	2876	1504	0	0	2124
68748	1397	1417547888000	2888	1509	0	0	2129
236913	1678	2160042112000	2888	1509	0	0	0
236915	1678	2160042113000	2890	1510	0	0	0
55260	1740	9356603000000	2890	1510	2	0	3
16023	1474	7194062000000	2895	1511	3	0	3
68759	1397	1417487882000	2896	1512	1	0	2135
10204	1402	23760481000000	2896	1512	2	0	0
10205	1402	23760501000000	2896	1512	3	0	0
236926	1678	2160042119000	2898	1513	0	0	0
27209	1633	3600050000000	2903	1515	1	0	0
68772	1397	1417427876000	2906	1517	1	0	2141
236938	1678	2160042125000	2906	1517	2	0	0
68839	1397	1417397873000	2913	1518	0	0	2144
68840	1397	1417387872000	2913	1518	1	0	2145
237007	1678	2160042130000	2913	1518	3	0	0
68852	1397	1417327866000	2918	1520	1	0	2151
237019	1678	2160042136000	2919	1521	0	0	0
68982	1397	1417297863000	2923	1522	0	0	2154
237147	1678	2160042137000	2923	1522	0	0	0
68983	1397	1417287862000	2923	1522	1	0	2155
237148	1678	2160042138000	2923	1522	1	0	0
13442	1447	6480100000000	2923	1522	3	0	0
37352	1683	216001078999541	2926	1523	0	0	0
23975	1599	7200140000000	2930	1524	2	0	0
43776	1690	15839470000000	2932	1525	2	0	0
69000	1397	1417227856000	2935	1527	1	0	2161
237165	1678	2160042144000	2935	1527	1	0	0
57176	1764	719000000000	2941	1529	1	0	0
57178	1764	719010000000	2941	1529	2	0	0
69009	1397	1417167850000	2949	1533	0	0	2167
237174	1678	2160042150000	2949	1533	0	0	0
27944	1637	36720911000000	2949	1533	1	0	0
69014	1397	1417117845000	2952	1535	0	0	2172
237179	1678	2160042155000	2952	1535	0	0	0
237186	1678	2160042160000	2956	1537	0	0	0
69022	1397	1417057839000	2958	1538	0	0	2178
237187	1678	2160042161000	2958	1538	0	0	0
33644	1677	87121032000000	2968	1542	1	0	0
69034	1397	1416997833000	2969	1543	1	0	2184
237199	1678	2160042167000	2969	1543	1	0	0
69039	1397	1416947828000	2971	1545	2	0	2189
33653	1677	88561082000000	2971	1545	4	0	0
237208	1678	2160042173000	2973	1546	0	0	0
2530	470	75360221000000	2973	1546	2	0	0
69051	1397	1416887822000	2981	1550	0	0	2195
237216	1678	2160042178000	2981	1550	0	0	0
46661	1693	8957197500454	2981	1550	1	0	118
46662	1693	8957207500454	2981	1550	2	0	118
50194	1705	5754910000000	2984	1552	1	0	2
50197	1705	5754920000000	2984	1552	2	0	2
30398	1656	7920211000000	2990	1554	1	0	0
69061	1397	1416827816000	2990	1554	3	0	2201
237226	1678	2160042184000	2990	1554	3	0	0
31053	1668	8640120000000	2994	1556	2	0	0
16049	1474	7914092000000	2995	1557	2	0	3
16050	1474	7914112000000	2995	1557	3	0	3
69074	1706	5756591000000	2999	1558	0	0	4
69143	1397	1416777811000	3010	1563	0	0	2206
237308	1678	2160042189000	3010	1563	0	0	0
69144	1397	1416767810000	3010	1563	1	0	2207
39702	1685	25199640000000	3012	1564	2	0	0
44748	1691	5039080000000	3015	1565	1	0	0
44749	1691	5039090000000	3015	1565	2	0	0
237317	1678	2160042194000	3018	1567	0	0	0
69156	1397	1416707804000	3022	1569	0	0	2213
237321	1678	2160042196000	3022	1569	0	0	0
237322	1678	2160042197000	3023	1570	0	0	0
54770	1729	5039070000000	3023	1570	2	0	0
18964	1536	8640200000000	3028	1572	2	0	0
37372	1683	221761098999541	3029	1573	2	0	0
49210	1701	6478230000000	3030	1574	2	0	4
69166	1397	1416647798000	3032	1575	0	0	2219
237334	1678	2160042203000	3035	1576	0	0	0
69175	1397	1416597793000	3040	1579	0	0	2224
237342	1678	2160042209000	3042	1580	1	0	0
4854	641	73200410000000	3042	1580	3	0	0
3300	576	71760070000000	3045	1582	1	0	0
69217	1397	1416537787000	3047	1583	0	0	2230
237383	1678	2160042214000	3047	1583	1	0	0
33673	1677	91441012000000	3047	1583	3	0	0
47543	1695	5759001000000	3049	1584	1	0	1
69225	1397	1416477781000	3051	1586	0	0	2236
69226	1397	1416467780000	3052	1587	0	0	2237
237391	1678	2160042220000	3052	1587	0	0	0
69235	1397	1416417775000	3063	1590	0	0	2242
237400	1678	2160042225000	3063	1590	0	0	0
32036	1672	5040080000000	3064	1591	2	0	0
237405	1678	2160042230000	3068	1594	1	0	0
69241	1397	1416357769000	3070	1596	0	0	2248
29789	1650	4320060000000	3070	1596	2	0	0
29793	1650	4320080000000	3070	1596	3	0	0
37382	1683	226081118999541	3071	1597	1	0	0
47264	1694	17999375000000	3073	1598	1	0	1
69373	1397	1416317765000	3077	1599	0	0	2252
237538	1678	2160042235000	3077	1599	0	0	0
69375	1397	1416307764000	3079	1600	0	0	2253
237540	1678	2160042236000	3079	1600	0	0	0
29460	1649	7200141000000	3079	1600	1	0	0
52091	1714	7909020000000	3086	1601	1	0	2
52095	1714	7909030000000	3086	1601	2	0	2
21024	1560	7200170000000	3087	1602	3	0	0
53386	1719	2879120000000	3089	1603	2	0	0
69412	1397	1416247758000	3091	1605	0	0	2259
237577	1678	2160042242000	3091	1605	0	0	0
27949	1637	38160941000000	3091	1605	2	0	0
69547	1397	1416237757000	3094	1606	0	0	2260
237712	1678	2160042243000	3094	1606	0	0	0
69548	1397	1416227756000	3094	1606	1	0	2261
237713	1678	2160042244000	3094	1606	1	0	0
69554	1770	4034710760393	3094	1606	7	0	1
237719	1771	69383739594	3094	1606	7	0	0
237729	1678	2160042251000	3096	1607	1	0	0
237730	1771	69384135534	3096	1607	2	0	0
33690	1677	93601072000000	3096	1607	4	0	0
69573	1397	1416127746000	3102	1610	0	0	2271
237742	1678	2160042257000	3106	1612	0	0	0
43526	1689	6479130000000	3106	1612	1	0	0
43527	1689	6479140000000	3106	1612	2	0	0
69579	1397	1416077741000	3108	1614	0	0	2276
237751	1678	2160042263000	3110	1615	1	0	0
69592	1397	1416017735000	3114	1617	0	0	2282
25481	1610	6480150000000	3114	1617	2	0	0
237763	1678	2160042268000	3116	1618	2	0	0
69601	1397	1415957729000	3118	1620	0	0	2288
35318	1679	23039902000000	3119	1621	2	0	0
237781	1771	69384137414	3121	1622	1	0	0
69618	1397	1415927726000	3121	1622	3	0	2291
237787	291	66069405749490	3121	1622	7	0	0
69624	1770	2420358283411	3121	1622	9	0	10
48897	1700	6479420000000	3121	1622	13	0	1
237795	1678	2160042275000	3123	1623	0	0	0
69633	1397	1415887722000	3124	1624	0	0	2295
69634	1397	1415877721000	3124	1624	1	0	2296
237801	1771	70253739593	3124	1624	3	0	0
69640	1397	1415827716000	3128	1627	0	0	2301
237807	1678	2160042286000	3128	1627	2	0	0
69661	1397	1415767710000	3134	1630	0	0	2307
237827	1678	2160042291000	3135	1631	0	0	0
25173	1608	5760090000000	3135	1631	1	0	0
25177	1608	5760100000000	3135	1631	2	0	0
69672	1397	1415717705000	3139	1632	3	0	2312
37400	1683	230401168999541	3139	1632	4	0	0
37401	1683	230401208999541	3139	1632	5	0	0
237839	1678	2160042297000	3140	1633	1	0	0
57525	1768	2879050000000	3140	1633	3	0	0
69678	1397	1415657699000	3141	1634	3	0	2318
52928	1717	4319140000000	3141	1634	5	0	0
237848	1678	2160042303000	3145	1635	0	0	0
54544	1727	4319050000000	3145	1635	1	0	0
54545	1727	4319060000000	3145	1635	2	0	0
43790	1690	17999510000000	3149	1637	2	0	0
69690	1397	1415597693000	3150	1638	0	0	2324
41906	1688	35999822000000	3150	1638	1	0	0
41907	1688	35999832000000	3150	1638	2	0	0
237860	1678	2160042308000	3153	1639	0	0	0
33714	1677	95761122000000	3156	1641	1	0	0
237867	1678	2160042311000	3160	1642	0	0	0
69705	1397	1415547688000	3163	1643	0	0	2329
237870	1678	2160042312000	3163	1643	0	0	0
37404	1683	231841208999541	3163	1643	1	0	0
69711	1397	1415487682000	3165	1645	4	0	2335
237876	1678	2160042318000	3165	1645	4	0	0
37422	1683	236161278999541	3168	1647	1	0	0
52739	1716	7199160000000	3170	1648	2	0	0
69727	1397	1415427676000	3178	1650	1	0	2341
237892	1678	2160042324000	3178	1650	1	0	0
24017	1599	9360180000000	3178	1650	2	0	0
69737	1397	1415377671000	3186	1654	0	0	2346
237902	1678	2160042329000	3186	1654	0	0	0
69745	1397	1415317665000	3191	1657	0	0	2352
237910	1678	2160042335000	3191	1657	0	0	0
24351	1601	5760150000000	3191	1657	1	0	0
24353	1601	5760160000000	3191	1657	2	0	0
33729	1677	97201142000000	3193	1658	1	0	0
33730	1677	97201152000000	3193	1658	2	0	0
39709	1685	27359670000000	3200	1661	2	0	0
1468	171	72480120000000	3201	1662	0	0	0
69764	1397	1415257659000	3203	1663	0	0	2358
237929	1678	2160042341000	3203	1663	0	0	0
69769	1397	1415207654000	3203	1663	5	0	2363
237934	1678	2160042346000	3203	1663	5	0	0
69770	1397	1415197653000	3203	1663	6	0	2364
23049	1593	5040180000000	3203	1663	8	0	0
27961	1637	40320991000000	3205	1665	2	0	0
49436	1702	2879040000000	3208	1666	2	0	0
238066	1678	2160042351000	3210	1667	0	0	0
238067	1678	2160042352000	3210	1667	1	0	0
69903	1397	1415137647000	3211	1668	0	0	2370
69905	1397	1415117645000	3213	1670	0	0	2372
69906	1397	1415107644000	3213	1670	1	0	2373
238074	1678	2160042358000	3216	1672	0	0	0
69921	1706	6476491000000	3226	1675	0	0	5
238088	1678	2160042363000	3226	1675	2	0	0
69927	1693	8758054549570	3226	1675	6	0	122
238093	373	66087112047044	3226	1675	7	0	0
69932	1693	8454015514083	3226	1675	11	0	127
238129	1678	2160042364000	3230	1676	0	0	0
69968	1693	7575345674899	3230	1676	4	0	132
238135	397	66087112047044	3231	1677	0	0	0
238137	1678	2160042365000	3231	1677	2	0	0
238138	1678	2160042366000	3231	1677	3	0	0
69974	1397	1414997633000	3232	1678	0	0	2384
69979	1693	7089922835712	3232	1678	5	0	139
238144	122	66087112047044	3232	1678	5	0	0
37438	1683	240481318999541	3232	1678	6	0	0
69995	1693	6890769884828	3234	1679	5	0	143
238160	420	66087112047044	3234	1679	5	0	0
238165	534	66087112047044	3235	1680	2	0	0
70001	1693	6641828696223	3235	1680	3	0	148
70008	1693	6113263058288	3239	1682	3	0	152
238173	500	66087112047044	3239	1682	3	0	0
70014	1693	5859032359625	3239	1682	9	0	158
238179	251	66087112047044	3239	1682	9	0	0
238184	1678	2160042374000	3239	1682	14	0	0
70020	1397	1414917625000	3239	1682	15	0	2392
70041	1397	1414907624000	3241	1683	0	0	2393
70042	1693	5560302933299	3241	1683	1	0	164
238208	710	5006599397497	3241	1683	2	0	0
238284	1678	2160042380000	3248	1686	0	0	0
70121	1397	1414857619000	3250	1687	0	0	2398
238286	1678	2160042381000	3250	1687	0	0	0
70131	1397	1414797613000	3256	1691	0	0	2404
238296	1678	2160042387000	3256	1691	0	0	0
56485	1756	8639139000000	3257	1692	1	0	1
56486	1756	8639149000000	3257	1692	2	0	1
37449	1683	243361408999541	3259	1693	2	0	0
4476	633	71038970000000	3261	1694	2	0	1
70138	1693	5555003423251	3262	1695	0	0	166
238304	295	66087112047044	3262	1695	1	0	0
45430	1692	25919732000000	3265	1696	1	0	0
45433	1692	25919742000000	3265	1696	2	0	0
70146	1397	1414707604000	3266	1697	0	0	2413
238311	1678	2160042396000	3266	1697	0	0	0
33756	1677	99361362000000	3266	1697	2	0	0
70202	1397	1414687602000	3272	1699	0	0	2415
70203	1397	1414677601000	3272	1699	1	0	2416
29364	1643	6480150000000	3272	1699	3	0	0
238373	1678	2160042402000	3275	1701	0	0	0
70211	1693	5405638710088	3276	1702	2	0	169
37465	1683	247681518999541	3276	1702	5	0	0
238387	1678	2160042405000	3279	1703	1	0	0
70225	1397	1414587592000	3281	1705	0	0	2425
238392	1678	2160042410000	3282	1706	0	0	0
70233	1397	1414537587000	3284	1707	0	0	2430
238410	1772	259000000000	3287	1708	0	0	0
238411	150	66087112047044	3287	1708	1	0	0
70249	1693	5106909283762	3287	1708	4	0	175
238417	1678	2160042414000	3287	1708	7	0	0
57531	1768	3599050000000	3287	1708	8	0	0
57533	1768	3599130000000	3287	1708	9	0	0
70276	1693	4858474928124	3293	1709	2	0	180
238444	1678	2160042416000	3296	1710	0	0	0
70283	1397	1414487582000	3298	1711	1	0	2435
238453	1150	608707084465919	3301	1713	0	0	0
70291	1397	1414457579000	3301	1713	3	0	2438
34762	1678	2880082421000	3301	1713	5	0	0
39137	1684	11519280000000	3303	1714	3	0	0
238463	436	66001500000000	3305	1716	0	0	0
70301	1397	1414437577000	3305	1716	3	0	2440
238472	1678	2880082426000	3310	1718	0	0	0
70310	1397	1414397573000	3312	1719	1	0	2444
41983	1688	38159962000000	3312	1719	3	0	0
70319	1397	1414387572000	3317	1720	0	0	2445
70320	1397	1414377571000	3317	1720	1	0	2446
33768	1677	101521412000000	3317	1720	3	0	0
238488	1678	2880082430000	3319	1721	0	0	0
24	42	68880070000000	3319	1721	3	0	0
70330	1693	4051470426409	3321	1722	3	0	188
238496	504	66087112047044	3321	1722	4	0	0
70355	1397	1414347568000	3323	1723	0	0	2449
238521	1678	2880082433000	3323	1723	1	0	0
70360	1693	2400790533220	3323	1723	5	0	197
238526	108	66087112047044	3323	1723	6	0	0
70366	1693	2102061106894	3323	1723	11	0	203
238532	352	66087112047044	3323	1723	12	0	0
70372	1693	1663935330893	3323	1723	17	0	209
238538	361	66087112047044	3323	1723	18	0	0
27969	1637	42481261000000	3323	1723	20	0	0
238545	10	32558500000000	3325	1724	1	0	0
238546	10	32559000000000	3325	1724	2	0	0
70382	114	66003470000000	3325	1724	3	0	3
238552	1678	2880082437000	3328	1727	0	0	0
70388	1773	8738330301113	3328	1727	1	0	1
238558	1293	1697928308166936	3328	1727	6	0	0
70406	1397	1414287562000	3330	1728	0	0	2455
30424	1656	10080261000000	3330	1728	3	0	0
238580	1678	2880082441000	3332	1729	2	0	0
70416	10	32558990000000	3332	1729	3	0	1
51783	1711	7199100000000	3332	1729	4	0	0
10227	1402	25920641000000	3334	1730	4	0	0
37491	1683	252001768999541	3335	1731	2	0	0
238593	1483	0	3337	1732	0	0	0
70429	1397	1414217555000	3337	1732	1	0	2462
238599	1678	2880082449000	3339	1734	1	0	0
70435	1397	1414167550000	3339	1734	2	0	2467
43794	1690	18719530000000	3341	1735	1	0	0
43797	1690	18719540000000	3341	1735	2	0	0
238608	1745	8406000000	3343	1736	2	0	2
70444	1397	1414127546000	3344	1737	0	0	2471
70451	1397	1414117545000	3346	1738	0	0	2472
70452	1693	1564358855451	3346	1738	1	0	211
238620	201	66087112047044	3346	1738	5	0	0
70458	1693	1315417666846	3347	1739	1	0	216
238626	112	66087112047044	3347	1739	4	0	0
70464	1693	1051985536364	3347	1739	7	0	222
238631	680	66087112047044	3347	1739	9	0	0
25024	1607	8640230000000	3347	1739	10	0	0
70474	1693	747946500877	3349	1740	2	0	227
238722	1772	518000000000	3352	1741	0	0	0
238723	1678	2880082458000	3352	1741	1	0	0
70560	1772	517750000000	3353	1742	0	0	1
238729	1678	2880082463000	3354	1743	1	0	0
70615	1397	1414027536000	3357	1744	0	0	2481
70617	1397	1414017535000	3359	1745	0	0	2482
238786	1678	2880082469000	3361	1747	1	0	0
26028	1613	6478110000000	3361	1747	3	0	2
37504	1683	256321818999541	3362	1748	1	0	0
70623	1397	1413957529000	3363	1749	0	0	2488
23441	1594	4320180000000	3363	1749	2	0	0
238792	1678	2880082474000	3366	1751	0	0	0
1158	149	71040120000000	3366	1751	2	0	0
238856	1678	2880082476000	3370	1753	0	0	0
70692	1397	1413897523000	3370	1753	1	0	2494
238857	1678	2880082477000	3370	1753	1	0	0
70698	1397	1413847518000	3373	1755	3	0	2499
238864	1396	20000000	3373	1755	4	0	3
35374	1679	25199972000000	3373	1755	5	0	0
35375	1679	25200022000000	3373	1755	6	0	0
15619	1471	5040100000000	3374	1756	3	0	0
2858	484	74640130000000	3378	1757	0	0	0
70830	1397	1413817515000	3379	1758	0	0	2502
238995	1678	2880082485000	3379	1758	0	0	0
70831	1397	1413807514000	3379	1758	1	0	2503
238996	1678	2880082486000	3379	1758	1	0	0
17662	1509	8640210000000	3384	1760	2	0	0
31454	1670	11520430000000	3387	1762	2	0	0
70870	1397	1413747508000	3390	1764	0	0	2509
239035	1678	2880082492000	3390	1764	0	0	0
70872	1397	1413737507000	3392	1765	0	0	2510
71000	1397	1413717505000	3396	1767	0	0	2512
239165	1678	2880082495000	3396	1767	0	0	0
36009	1680	11519230000000	3396	1767	1	0	0
71006	1397	1413707504000	3399	1768	0	0	2513
239171	1678	2880082496000	3399	1768	0	0	0
11161	1419	9360190000000	3403	1769	1	0	0
11162	1419	9360200000000	3403	1769	2	0	0
239231	1678	2880082499000	3413	1774	0	0	0
239232	1678	2880082500000	3413	1774	1	0	0
33780	1677	103681513000000	3413	1774	3	0	0
71069	1397	1413647498000	3414	1775	0	0	2519
37524	1683	260641848999541	3415	1776	2	0	0
239243	1678	2880082506000	3421	1778	1	0	0
71088	1397	1413587492000	3427	1780	1	0	2525
39715	1685	28799680000000	3431	1782	1	0	0
39717	1685	28799690000000	3431	1782	2	0	0
36321	1681	12239313195920	3435	1784	0	0	1
239261	1759	6480000000000	3444	1788	0	0	0
71097	1722	3612181000000	3444	1788	1	0	6
27976	1637	44641312000000	3451	1791	0	0	0
26720	1623	9360161000000	3463	1798	0	0	0
20758	1559	10800230000000	3471	1802	0	0	0
3589	596	76080212000000	3476	1805	0	0	0
14962	1458	9360172798540	3478	1806	0	0	0
71227	1521	1437049000000	3488	1812	0	0	1
239392	1775	2000000000	3488	1812	0	0	0
50538	1706	7196491000000	3488	1812	1	0	5
33805	1677	106561563000000	3490	1813	0	0	0
71407	1749	703989000000	3495	1814	0	0	2
239572	1764	8651010000000	3495	1814	0	0	0
14978	1458	10080172798540	3495	1814	1	0	0
71409	1764	5040009000000	3498	1816	0	0	1
239574	1749	4314989000000	3498	1816	0	0	2
239637	1521	1437059000000	3504	1819	0	0	1
239640	1500	0	3509	1821	0	0	0
19416	1546	7200120000000	3509	1821	1	0	0
37539	1683	264961848999541	3517	1825	0	0	0
42035	1688	40319982000000	3518	1826	0	0	0
12446	1439	5760100000000	3520	1828	1	0	0
71487	1775	1967000000	3529	1832	0	0	3
36469	1682	7187190000000	3532	1833	2	0	4
25041	1607	10800331000000	3544	1839	0	0	0
37547	1683	266401848999541	3563	1849	0	0	0
33823	1677	110161564000000	3571	1853	0	0	0
10246	1402	28800661000000	3590	1865	0	0	0
35468	1679	28080042000000	3593	1867	0	0	0
42057	1688	41039982000000	3608	1872	0	0	0
19704	1547	3600030000000	3613	1874	0	0	0
22714	1588	5040080000000	3619	1878	0	0	0
239666	348	66001000000000	3632	1882	0	0	0
48265	1698	9359091000000	3633	1883	2	0	1
71507	1709	6478221000000	3635	1885	0	0	3
50866	1708	5039190000000	3641	1888	0	0	0
239683	1776	1000000000	3644	1891	0	0	0
39181	1684	13679310000000	3647	1893	0	0	0
23776	1596	8640120000000	3652	1895	0	0	0
21910	1571	7200100000008	3653	1896	1	0	1
21912	1571	7200111000008	3653	1896	2	0	1
51270	1709	7197211000000	3662	1901	0	0	4
71524	1693	6506836500877	3666	1903	0	0	228
37582	1683	273601858999541	3666	1903	2	0	0
239689	1779	2000000000	3669	1905	2	0	0
71533	1397	1413507484000	3676	1908	0	0	2533
33839	1677	113041574000000	3676	1908	2	0	0
39188	1684	14399310000000	3678	1909	1	0	0
71538	1397	1413477481000	3681	1911	0	0	2536
239700	1678	2880082519000	3681	1911	0	0	0
71539	1397	1413467480000	3682	1912	0	0	2537
11675	1422	3600030000000	3682	1912	1	0	0
54973	1739	5039270000000	3683	1913	1	0	0
53938	1723	10079190000000	3685	1914	4	0	0
239711	1678	2880082524000	3687	1915	0	0	0
71550	1397	1413417475000	3687	1915	1	0	2542
1978	369	73920140000000	3689	1916	1	0	0
239724	1678	2880082529000	3696	1919	0	0	0
71564	1754	798000000	3696	1919	2	0	2
239738	1678	2880082533000	3703	1922	1	0	0
71577	1754	673543211	3703	1922	2	0	3
16641	1489	5040121000000	3703	1922	3	0	0
239746	1678	2880082538000	3709	1926	1	0	0
71585	1397	1413277461000	3709	1926	2	0	2556
54261	1724	8638700000000	3711	1927	2	0	2
239755	1678	2880082543000	3713	1928	0	0	0
53751	1722	1440080000000	3713	1928	2	0	8
71596	1397	1413217455000	3716	1930	0	0	2562
239774	1678	2880082546000	3722	1931	0	0	0
239775	1678	2880082547000	3723	1932	0	0	0
71619	1397	1413167450000	3729	1935	0	0	2567
37602	1683	277921888999541	3729	1935	2	0	0
14434	1455	5040081000000	3734	1937	1	0	0
14436	1455	5040091000000	3734	1937	2	0	0
239789	1678	2880082553000	3736	1938	0	0	0
22177	1573	6480090000000	3739	1939	1	0	0
22178	1573	6480100000000	3739	1939	2	0	0
71633	1397	1413107444000	3741	1940	0	0	2573
239805	1678	2880082558000	3747	1942	0	0	0
71646	1397	1413057439000	3749	1944	0	0	2578
239812	1678	2880082563000	3751	1945	0	0	0
42119	1688	43200022000000	3751	1945	2	0	0
46553	1693	7226736500877	3753	1946	2	0	229
71655	1397	1413007434000	3756	1948	0	0	2583
239820	1678	2880082569000	3757	1949	1	0	0
51286	1709	7917211000000	3757	1949	2	0	4
51287	1709	7917231000000	3757	1949	3	0	4
71665	1397	1412947428000	3762	1952	0	0	2589
37617	1683	282241908999541	3762	1952	1	0	0
54785	1729	7199100000000	3764	1953	2	0	0
71675	1397	1412917425000	3768	1954	0	0	2592
239837	1678	2880082575000	3768	1954	0	0	0
71676	1397	1412907424000	3768	1954	1	0	2593
23058	1593	7200220000000	3769	1955	3	0	0
48282	1698	10799101000000	3770	1956	1	0	1
48283	1698	10799111000000	3770	1956	2	0	1
239844	1678	2880082580000	3775	1957	0	0	0
57823	1780	719000000000	3775	1957	1	0	0
57824	1780	719010000000	3775	1957	2	0	0
71685	1397	1412847418000	3780	1959	0	0	2599
33868	1677	115201595000000	3787	1961	1	0	0
33870	1677	115201605000000	3787	1961	2	0	0
239860	1678	2880082586000	3788	1962	0	0	0
19449	1546	9360130000000	3788	1962	2	0	0
19450	1546	9360150000000	3788	1962	3	0	0
71700	1397	1412787412000	3789	1963	0	0	2605
13121	1444	9360160000000	3789	1963	4	0	0
239870	1678	2880082592000	3792	1964	0	0	0
71710	1397	1412737407000	3794	1965	0	0	2610
42175	1688	45360052000000	3795	1966	1	0	0
42176	1688	45360062000000	3795	1966	2	0	0
239877	1678	2880082597000	3799	1969	0	0	0
49233	1701	7918271000000	3799	1969	1	0	4
49234	1701	7918281000000	3799	1969	2	0	4
71719	1397	1412677401000	3801	1970	1	0	2616
54274	1724	9358720000000	3801	1970	2	0	2
54275	1724	9358740000000	3801	1970	3	0	2
239893	1678	2880082603000	3806	1972	2	0	0
71733	1397	1412617395000	3808	1974	0	0	2622
33889	1677	117361635000000	3809	1975	2	0	0
239904	1678	2880082609000	3814	1977	1	0	0
49793	1703	5039160000000	3814	1977	2	0	1
49794	1703	5039180000000	3814	1977	3	0	1
71746	1397	1412567390000	3817	1978	0	0	2627
239908	1678	2880082610000	3817	1978	0	0	0
37631	1683	286561938999541	3817	1978	1	0	0
239910	1678	2880082611000	3819	1979	0	0	0
71754	562	66000090000000	3824	1983	0	0	1
239917	1678	2880082616000	3824	1983	1	0	0
20008	1549	8640111000000	3825	1984	2	0	0
71869	1765	70000000	3827	1985	0	0	1
71870	1397	1412487382000	3827	1985	1	0	2635
56524	1756	10799229000000	3827	1985	3	0	1
52754	1716	9359180000000	3828	1986	2	0	0
240033	1678	2880082620000	3829	1987	0	0	0
71878	1397	1412447378000	3832	1989	1	0	2639
240040	1678	2880082623000	3832	1989	2	0	0
240041	1678	2880082624000	3832	1989	3	0	0
240042	1678	2880082625000	3833	1990	0	0	0
71884	1397	1412387372000	3834	1991	1	0	2645
240048	1678	2880082631000	3836	1993	1	0	0
24053	1599	11520230000000	3837	1994	1	0	0
71889	1397	1412337367000	3838	1995	0	0	2650
33905	1677	119521665000000	3838	1995	2	0	0
72016	1397	1412327366000	3841	1996	0	0	2651
240177	1678	2880082634000	3841	1996	0	0	0
72025	1397	1412317365000	3846	1997	0	0	2652
240186	1678	2880082635000	3846	1997	0	0	0
10265	1402	30960691000000	3853	2000	1	0	0
72037	1397	1412257359000	3854	2001	0	0	2658
240198	1678	2880082641000	3854	2001	0	0	0
24411	1601	7920201000000	3854	2001	2	0	0
72049	1397	1412197353000	3860	2004	0	0	2664
240210	1678	2880082647000	3860	2004	0	0	0
41158	1687	8639111000000	3860	2004	2	0	1
33920	1677	121681685000000	3863	2006	3	0	0
72061	1397	1412147348000	3866	2007	0	0	2669
240222	1678	2880082652000	3866	2007	0	0	0
15326	1467	6481570000000	3870	2010	1	0	0
72071	1397	1412087342000	3874	2012	0	0	2675
240232	1678	2880082658000	3874	2012	0	0	0
52955	1717	6479210000000	3875	2013	2	0	0
37647	1683	290881988999541	3881	2016	1	0	0
72080	1397	1412027336000	3883	2018	0	0	2681
240241	1678	2880082664000	3883	2018	0	0	0
72081	1397	1412017335000	3883	2018	1	0	2682
72085	1397	1412007334000	3886	2019	0	0	2683
25517	1610	8640220000000	3889	2020	3	0	0
240251	1678	2880082669000	3893	2021	0	0	0
31079	1668	10800180000000	3893	2021	2	0	0
72095	1397	1411947328000	3896	2023	0	0	2689
14004	1449	720024000459	3896	2023	1	0	0
14005	1449	720034000459	3896	2023	2	0	0
240262	1678	2880082675000	3902	2026	0	0	0
39731	1685	31679710000000	3902	2026	2	0	0
72106	1397	1411887322000	3905	2028	0	0	2695
240274	1678	2880082681000	3909	2030	0	0	0
42229	1688	47520092000000	3909	2030	2	0	0
72117	1397	1411837317000	3912	2031	1	0	2700
18999	1536	10800230000000	3912	2031	2	0	0
32060	1672	7200130000000	3917	2032	2	0	0
33950	1677	123841735000000	3919	2033	1	0	0
240282	1678	2880082686000	3920	2034	0	0	0
72129	1397	1411777311000	3925	2036	1	0	2706
240355	1678	2880082690000	3928	2037	0	0	0
37664	1683	293762028999541	3928	2037	2	0	0
240356	1678	2880082691000	3929	2038	0	0	0
45478	1692	28799762000000	3932	2039	2	0	0
72203	1397	1411717305000	3933	2040	0	0	2712
17694	1509	10080220000000	3934	2041	1	0	0
17695	1509	10080230000000	3934	2041	2	0	0
240367	1678	2880082697000	3936	2042	0	0	0
43808	1690	21599581000000	3937	2043	1	0	0
72209	1397	1411667300000	3938	2044	1	0	2717
52147	1714	10789080000000	3938	2044	2	0	2
240374	1678	2880082703000	3942	2046	0	0	0
72218	1397	1411607294000	3945	2048	0	0	2723
72219	1397	1411597293000	3945	2048	1	0	2724
240381	1749	5755089000000	3945	2048	2	0	2
72225	1722	78000000	3946	2049	4	0	10
33969	1677	126001776000000	3946	2049	5	0	0
240387	1678	2880082709000	3947	2050	0	0	0
13353	1445	7920180000000	3948	2051	1	0	0
72231	1397	1411527286000	3950	2053	0	0	2731
240394	1678	2880082715000	3952	2054	0	0	0
49488	1702	5034081000000	3952	2054	2	0	1
72239	1397	1411477281000	3958	2058	0	0	2736
240401	1678	2880082720000	3959	2059	0	0	0
17987	1513	2880040000000	3963	2060	2	0	0
72258	1397	1411417275000	3971	2063	0	0	2742
33978	1677	127441810000000	3971	2063	2	0	0
240423	1678	2880082726000	3975	2064	0	0	0
16370	1476	8640160000000	3978	2066	2	0	0
37674	1683	296642048999541	3979	2067	2	0	0
72271	1397	1411357269000	3983	2068	0	0	2748
240433	1678	2880082732000	3984	2069	0	0	0
72279	1397	1411307264000	3989	2072	0	0	2753
240445	1678	2880082737000	3994	2073	0	0	0
240449	1678	2880082739000	3998	2075	0	0	0
240450	1678	2880082740000	3998	2075	1	0	0
39238	1684	16559340000000	4001	2076	1	0	0
72294	1397	1411247258000	4003	2077	0	0	2759
24478	1601	10080241000000	4003	2077	2	0	0
54561	1727	6479100000000	4005	2078	2	0	0
37680	1683	298082048999541	4006	2079	2	0	0
240460	1678	2880082746000	4007	2080	0	0	0
20032	1549	10080251000000	4009	2081	2	0	0
72306	1397	1411187252000	4013	2082	0	0	2765
43814	1690	23759641000000	4013	2082	2	0	0
22716	1588	5760080000000	4018	2084	1	0	0
240476	1678	2880082752000	4020	2085	0	0	0
72316	1397	1411137247000	4020	2085	1	0	2770
240481	1678	2880082756000	4022	2087	1	0	0
24681	1602	5760230000000	4022	2087	3	0	0
35510	1679	29520052000000	4023	2088	1	0	0
35511	1679	29520062000000	4023	2088	2	0	0
72322	1397	1411087242000	4024	2089	0	0	2775
240490	1678	2880082762000	4031	2093	0	0	0
30668	1657	5040100000000	4031	2093	2	0	0
72334	1397	1411027236000	4036	2095	0	0	2781
15014	1458	12240193798540	4038	2096	2	0	0
240499	1678	2880082768000	4040	2098	1	0	0
72339	1397	1410977231000	4040	2098	2	0	2786
240509	1678	2880082773000	4046	2101	0	0	0
18356	1519	1439000000000	4046	2101	1	0	1
72350	1397	1410917225000	4047	2102	1	0	2792
753	58	73200190000000	4047	2102	4	0	0
34003	1677	129601840000000	4048	2103	1	0	0
34004	1677	129601850000000	4048	2103	2	0	0
72355	1397	1410887222000	4051	2104	0	0	2795
72356	1397	1410877221000	4052	2105	0	0	2796
240517	1678	2880082779000	4052	2105	0	0	0
72366	1167	608321416666323	4056	2107	2	0	1
240527	1726	1000100000000	4056	2107	2	0	0
52402	1715	10799241000000	4061	2110	2	0	0
240537	1678	2880082789000	4063	2111	1	0	0
72377	1397	1410767210000	4063	2111	2	0	2807
56661	1759	9360029000000	4063	2111	3	0	1
37704	1683	302402088999541	4066	2113	1	0	0
34020	1677	131761880000000	4067	2114	2	0	0
72384	1397	1410717205000	4069	2115	1	0	2812
240545	1678	2880082795000	4069	2115	1	0	0
21413	1564	3600032000000	4071	2116	1	0	0
41	42	71760190000000	4074	2117	1	0	0
72400	1397	1410657199000	4081	2120	1	0	2818
240561	1678	2880082801000	4081	2120	1	0	0
14632	1457	7920150000000	4082	2121	1	0	0
24500	1601	10800241000000	4084	2122	1	0	0
240571	1758	1600400000	4090	2125	0	0	1
72411	1397	1410607194000	4090	2125	1	0	2823
72416	1397	1410567190000	4091	2126	4	0	2827
240577	1678	2880082810000	4091	2126	4	0	0
32340	1673	5040470000000	4091	2126	6	0	0
18474	1522	4320040000000	4094	2128	1	0	0
240586	1678	2880082813000	4096	2129	0	0	0
43820	1690	25199681000000	4096	2129	2	0	0
240587	1678	2880082814000	4097	2130	0	0	0
19272	1541	5037128000000	4097	2130	3	0	2
72428	1397	1410507184000	4098	2131	0	0	2833
240598	1678	2880082819000	4103	2133	1	0	0
51810	1711	9359270000000	4103	2133	3	0	0
72446	1397	1410467180000	4107	2134	1	0	2837
42312	1688	49680212000000	4108	2135	1	0	0
42313	1688	49680222000000	4108	2135	2	0	0
240611	1678	2880082823000	4110	2137	0	0	0
72455	1397	1410427176000	4115	2138	0	0	2841
72583	1397	1410407174000	4118	2140	0	0	2843
240744	1678	2880082826000	4118	2140	0	0	0
72584	1397	1410397173000	4118	2140	1	0	2844
240745	1678	2880082827000	4118	2140	1	0	0
25047	1607	12960381000000	4118	2140	3	0	0
72592	1397	1410337167000	4123	2144	0	0	2850
240753	1678	2880082833000	4123	2144	0	0	0
45511	1692	30959812000000	4127	2146	0	0	0
72602	1397	1410277161000	4131	2149	0	0	2856
240763	1678	2880082839000	4131	2149	0	0	0
37729	1683	306722129999541	4132	2150	1	0	0
42380	1688	51840262000000	4134	2151	2	0	0
46722	1693	10106787500877	4137	2152	2	0	229
72619	1726	994900000000	4139	2153	1	0	4
240780	1785	200000000	4139	2153	1	0	0
72625	1397	1410227156000	4139	2153	7	0	2861
240786	1678	2880082844000	4139	2153	7	0	0
72626	1397	1410217155000	4139	2153	8	0	2862
48651	1699	4786010500039	4141	2154	3	0	2
240796	1678	2880082850000	4145	2156	1	0	0
72636	1397	1410157149000	4146	2157	0	0	2868
2866	484	75360130000000	4146	2157	1	0	0
10290	1402	33120731000000	4147	2158	2	0	0
240803	1678	2880082855000	4151	2160	0	0	0
21062	1560	9360220000000	4155	2161	1	0	0
72647	1726	989700000000	4156	2162	0	0	8
34036	1677	133921910000000	4158	2163	2	0	0
240817	1678	2880082860000	4163	2165	0	0	0
72659	329	66714600000000	4165	2166	0	0	3
240827	1678	2880082865000	4168	2168	2	0	0
72667	1775	1944000000	4168	2168	3	0	5
4183	632	73200250000000	4170	2170	2	0	0
240833	1678	2880082869000	4173	2172	0	0	0
42438	1688	54000382000000	4173	2172	1	0	0
42439	1688	54000392000000	4173	2172	2	0	0
72675	1397	1409957129000	4176	2174	0	0	2888
37746	1683	309602179999541	4176	2174	4	0	0
240843	1678	2880082874000	4178	2175	1	0	0
2001	369	76080190000000	4178	2175	2	0	0
72683	1397	1409917125000	4179	2176	0	0	2892
240920	1678	2880082876000	4182	2177	0	0	0
240921	44	71040180000000	4183	2178	0	0	0
72771	1397	1409897123000	4185	2179	0	0	2894
72772	1397	1409887122000	4185	2179	1	0	2895
240944	1678	2880082879000	4188	2180	2	0	0
72787	1397	1409857119000	4190	2181	0	0	2898
240954	1793	200000000	4193	2183	0	0	0
72795	1397	1409827116000	4193	2183	2	0	2901
240959	1406	0	4193	2183	5	0	0
26728	1623	12960171000000	4195	2184	1	0	0
72808	1397	1409787112000	4197	2185	0	0	2905
23468	1594	6480230000000	4197	2185	3	0	0
240977	1678	2880082891000	4199	2186	2	0	0
72821	1397	1409737107000	4203	2187	0	0	2910
42496	1688	56160682000000	4203	2187	2	0	0
240986	1678	2880082896000	4204	2188	3	0	0
72834	1397	1409687102000	4207	2189	0	0	2915
240995	1678	2880082898000	4207	2189	0	0	0
240997	1678	2880082899000	4209	2190	0	0	0
3813	606	73200130000000	4212	2191	1	0	0
3814	606	73200140000000	4212	2191	2	0	0
36054	1680	13679260000000	4214	2192	1	0	0
36055	1680	13679270000000	4214	2192	2	0	0
72849	1397	1409637097000	4222	2194	0	0	2920
241016	1678	2880082905000	4225	2195	1	0	0
72862	1643	324223113700	4227	2196	3	0	4
241025	1678	2880082907000	4227	2196	5	0	0
37760	1683	313922859999541	4227	2196	10	0	0
72869	1397	1409557089000	4229	2197	0	0	2928
241032	1678	2880082912000	4231	2198	0	0	0
72875	1726	981900000000	4232	2199	0	0	14
241038	1678	2880082917000	4232	2199	3	0	0
36353	1681	14399335195920	4236	2200	2	0	1
72888	1397	1409467080000	4237	2201	0	0	2937
72897	1397	1409457079000	4242	2202	0	0	2938
47792	1696	5038101000000	4242	2202	2	0	1
72899	1397	1409447078000	4244	2203	0	0	2939
18504	1522	5760160000000	4244	2203	1	0	0
18505	1522	5760170000000	4244	2203	2	0	0
241138	1737	1300001100	4246	2204	0	0	0
241139	1678	2880082923000	4246	2204	1	0	0
72997	1397	1409397073000	4250	2205	1	0	2944
241161	1678	2880082929000	4254	2207	0	0	0
73007	1397	1409337067000	4255	2208	2	0	2950
241170	1678	2880082935000	4260	2210	0	0	0
46786	1693	11546797500877	4261	2211	1	0	229
46787	1693	11546807500877	4261	2211	2	0	229
73023	1397	1409287062000	4268	2213	0	0	2955
31767	1671	9360850000000	4268	2213	1	0	0
241184	1678	2880082940000	4270	2214	1	0	0
39269	1684	18719500000000	4270	2214	2	0	0
34050	1677	136081960000000	4271	2215	1	0	0
73032	1397	1409237057000	4274	2217	1	0	2960
73117	1397	1409227056000	4278	2218	0	0	2961
241274	1678	2880082944000	4278	2218	0	0	0
73118	1397	1409217055000	4278	2218	1	0	2962
241275	1678	2880082945000	4278	2218	1	0	0
37782	1683	318242909999541	4278	2218	3	0	0
22202	1573	8640130000000	4280	2219	2	0	0
73127	1397	1409157049000	4284	2222	2	0	2968
241284	1678	2880082951000	4284	2222	2	0	0
31106	1668	12960200000000	4284	2222	3	0	0
73145	1397	1409107044000	4293	2227	1	0	2973
241302	1678	2880082956000	4293	2227	1	0	0
40674	1686	3811846500013	4293	2227	2	0	2
13466	1447	8640120000000	4297	2229	1	0	0
13467	1447	8640130000000	4297	2229	2	0	0
73153	1397	1409067040000	4304	2231	0	0	2977
241310	1678	2880082960000	4304	2231	0	0	0
73281	1397	1409047038000	4307	2233	0	0	2979
241437	1678	2880082962000	4307	2233	0	0	0
30015	1654	7920150000000	4307	2233	2	0	0
73282	1397	1409037037000	4308	2234	0	0	2980
241438	1678	2880082963000	4308	2234	0	0	0
34061	1677	138242090000000	4308	2234	2	0	0
56220	1749	6475088000000	4310	2235	1	0	3
56223	1749	6475098000000	4310	2235	2	0	3
73293	1397	1408987032000	4315	2237	1	0	2985
241449	1678	2880082968000	4315	2237	1	0	0
73305	1397	1408927026000	4325	2241	0	0	2991
241461	1678	2880082974000	4325	2241	0	0	0
73306	1397	1408917025000	4325	2241	1	0	2992
4497	633	72478980000000	4327	2242	1	0	1
4499	633	72478990000000	4327	2242	2	0	1
241470	1678	2880082979000	4333	2245	0	0	0
13152	1444	11520350000000	4333	2245	1	0	0
73316	1397	1408857019000	4334	2246	1	0	2998
27252	1633	6480070000000	4334	2246	2	0	0
21085	1560	10080230000000	4335	2247	1	0	0
21087	1560	10080240000000	4335	2247	2	0	0
241479	1678	2880082985000	4339	2249	2	0	0
34069	1677	140402150000000	4341	2250	1	0	0
73368	1397	1408797013000	4346	2251	0	0	3004
73494	1397	1408787012000	4348	2252	0	0	3005
241649	1678	2880082988000	4348	2252	0	0	0
73495	1397	1408777011000	4348	2252	1	0	3006
241650	1678	2880082989000	4348	2252	1	0	0
57967	1801	719000000000	4348	2252	3	0	0
57968	1801	719030000000	4348	2252	4	0	0
73501	1397	1408717005000	4351	2254	3	0	3012
241656	1678	2880082995000	4351	2254	3	0	0
56929	1762	3599060000000	4351	2254	4	0	0
73509	1397	1408667000000	4358	2259	0	0	3017
241664	1678	2880083000000	4358	2259	0	0	0
37803	1683	322563029999541	4358	2259	1	0	0
47575	1695	7919041000000	4360	2260	2	0	1
37815	1683	324003039999541	4362	2262	1	0	0
37816	1683	324003049999541	4362	2262	2	0	0
73517	1397	1408626996000	4364	2263	0	0	3021
241672	1678	2880083004000	4364	2263	0	0	0
241673	1678	2880083005000	4364	2263	1	0	0
241675	1678	2880083006000	4366	2264	0	0	0
73525	1769	2950900000	4368	2265	3	0	10
12043	1426	5760190000000	4368	2265	5	0	0
241682	1678	2880083110000	4369	2266	0	0	0
34075	1677	141842180000000	4372	2268	2	0	0
73535	1397	1408526986000	4378	2270	0	0	3031
47295	1694	20159415000000	4378	2270	1	0	1
241692	1678	2880083116000	4380	2272	0	0	0
11197	1419	11520250000000	4380	2272	2	0	0
20385	1555	5760060000000	4384	2273	1	0	0
73545	1601	11520251000000	4386	2274	1	0	1
20782	1559	12960250000000	4386	2274	2	0	0
73627	1601	8393676900000	4390	2276	0	0	2
73628	1693	12200337731495	4390	2276	1	0	231
241780	569	66153481816426	4390	2276	1	0	0
3329	576	73920210000000	4391	2277	4	0	0
73642	1601	6730862800000	4393	2278	0	0	3
241794	1142	902636269100000	4393	2278	0	0	0
73648	1693	11662216893990	4393	2278	6	0	238
241800	217	66153481816426	4393	2278	6	0	0
73653	1693	10555037196324	4393	2278	11	0	243
241805	1030	903068611238925	4393	2278	11	0	0
43832	1690	27359831000000	4393	2278	13	0	0
241809	1678	2880083123000	4394	2279	3	0	0
241810	397	66153481816426	4394	2279	4	0	0
73659	1693	10289518118796	4394	2279	5	0	247
241816	339	66153481816426	4394	2279	11	0	0
73691	1397	1408426976000	4398	2280	0	0	3041
73696	1693	9443183531004	4398	2280	5	0	257
241848	399	66153481816426	4398	2280	5	0	0
241853	1678	2880083125000	4399	2281	0	0	0
73702	1693	9111284684094	4399	2281	1	0	262
241859	89	66153481816426	4399	2281	6	0	0
73708	1693	8333118488910	4399	2281	7	0	268
73741	1693	8133979180764	4403	2282	0	0	271
73742	1397	1408406974000	4403	2282	1	0	3043
241895	84	66153481816426	4403	2282	2	0	0
73748	1693	7797042321028	4403	2282	7	0	277
241900	710	5011627410323	4403	2282	7	0	0
73773	1693	7529502038380	4406	2283	3	0	282
241925	194	66153481816426	4406	2283	3	0	0
73778	1693	7197603191470	4406	2283	8	0	287
73904	1397	1408386972000	4408	2284	0	0	3045
242055	1678	2880083128000	4408	2284	0	0	0
73905	1693	7131223422088	4408	2284	1	0	288
242056	245	66153481816426	4408	2284	1	0	0
73911	1693	6733620570727	4408	2284	7	0	294
242062	78	66153481816426	4408	2284	7	0	0
34085	1677	144002390000000	4408	2284	10	0	0
73917	1693	5913102786705	4409	2285	3	0	299
242068	452	66153481816426	4409	2285	3	0	0
73922	1693	5614833300833	4409	2285	8	0	304
242073	6	32633713045112	4409	2285	8	0	0
42556	1688	59040832000000	4409	2285	10	0	0
73928	1693	3645855591785	4410	2286	4	0	309
242079	652	66153481816426	4410	2286	4	0	0
242081	390	66153481816426	4410	2286	6	0	0
242082	353	66153481816426	4410	2286	7	0	0
73944	1397	1408356969000	4412	2287	0	0	3048
242098	600	66153481816426	4412	2287	3	0	0
73949	1693	2739885754986	4412	2287	5	0	319
242104	82	66153481816426	4412	2287	9	0	0
45536	1692	33119832000000	4412	2287	10	0	0
73955	1726	971500000000	4413	2288	1	0	22
242109	261	66153481816426	4413	2288	4	0	0
73961	1693	2275227369312	4413	2288	7	0	326
242115	383	66153481816426	4413	2288	10	0	0
73966	1693	1990390722513	4413	2288	12	0	331
242121	1678	2880083134000	4414	2289	3	0	0
73972	1397	1408306964000	4414	2289	5	0	3053
242126	551	66153481816426	4414	2289	8	0	0
74000	1397	1408296963000	4417	2290	0	0	3054
74001	1693	1454291090128	4417	2290	1	0	337
242156	237	66000100000000	4417	2290	5	0	0
74007	1769	2948900000	4417	2290	7	0	12
242170	1678	2880083140000	4421	2292	0	0	0
74022	1397	1408256959000	4421	2292	1	0	3058
46088	1693	1041411551364	4423	2293	1	0	341
242198	1678	2880083144000	4426	2295	0	0	0
74052	1397	1408216955000	4428	2296	0	0	3062
17109	1506	7200160000000	4429	2297	2	0	0
242235	1809	200000000	4433	2298	0	0	0
242236	1678	2880083147000	4433	2298	1	0	0
74094	1397	1408176951000	4435	2299	0	0	3066
242246	1678	2880083152000	4437	2300	1	0	0
34092	1677	146162573000000	4437	2300	2	0	0
74113	1726	963700000000	4444	2303	0	0	28
242263	1811	100000000	4444	2303	3	0	0
74121	1397	1408106944000	4447	2304	0	0	3073
74122	1800	199000000	4447	2304	1	0	1
42573	1688	59760932000000	4447	2304	2	0	0
42574	1688	59760943000000	4447	2304	3	0	0
242296	1483	0	4453	2307	1	0	0
35544	1679	31680212000000	4453	2307	3	0	0
74156	1397	1408066940000	4454	2308	0	0	3077
242304	1678	2880083164000	4459	2311	0	0	0
30449	1656	12240301000000	4459	2311	2	0	0
74164	1726	959800000000	4460	2312	0	0	31
12795	1440	7200100000000	4460	2312	4	0	0
12815	1440	7200320000000	4460	2312	5	0	0
74296	1397	1408006934000	4465	2313	0	0	3083
242436	1678	2880083166000	4465	2313	0	0	0
54979	1739	6479300000000	4465	2313	2	0	0
74299	1397	1407996933000	4469	2315	0	0	3084
242439	1678	2880083167000	4469	2315	0	0	0
34101	1677	147602633000000	4469	2315	4	0	0
37844	1683	328323169999541	4470	2316	2	0	0
74305	1397	1407946928000	4471	2317	2	0	3089
242445	1678	2880083172000	4471	2317	2	0	0
74314	1397	1407896923000	4473	2318	5	0	3094
242454	1678	2880083177000	4473	2318	5	0	0
52178	1714	12949120000000	4478	2320	0	0	2
74332	1397	1407856919000	4484	2322	0	0	3098
242468	1678	2880083182000	4485	2323	0	0	0
3596	596	78240242000000	4489	2326	1	0	0
74346	41	66000471816426	4494	2327	1	0	1
242482	1811	228090000000	4494	2327	2	0	1
41221	1687	10799131000000	4494	2327	3	0	1
242496	1817	200000000	4498	2328	0	0	0
242497	1811	251090000000	4498	2328	1	0	1
74365	5	6697563753375	4498	2328	4	0	1
242505	1678	2880083190000	4500	2329	2	0	0
74372	1397	1407746908000	4501	2330	0	0	3109
242517	1678	2880083196000	4509	2333	0	0	0
74438	1397	1407696903000	4512	2334	0	0	3114
74439	1397	1407686902000	4512	2334	1	0	3115
45562	1692	34559952000000	4518	2336	2	0	0
242581	1678	2880083201000	4519	2337	0	0	0
74450	1397	1407626896000	4521	2339	0	0	3121
242590	1678	2880083207000	4527	2342	0	0	0
51513	1710	7199080000000	4530	2343	1	0	1
74475	1397	1407566890000	4534	2345	0	0	3127
37864	1683	332643239999541	4538	2346	2	0	0
242615	1678	2880083213000	4540	2348	0	0	0
15640	1471	7200120000000	4540	2348	2	0	0
74484	1397	1407516885000	4543	2350	0	0	3132
53431	1719	5039160000000	4543	2350	3	0	0
242621	1678	2880083217000	4544	2351	1	0	0
74490	1397	1407466880000	4547	2353	0	0	3137
242625	542	66001000000000	4548	2354	0	0	0
242626	1678	2880083221000	4548	2354	1	0	0
74497	1726	952000000000	4553	2356	2	0	37
242633	458	66002400000000	4553	2356	4	0	0
74502	1726	945500000000	4553	2356	8	0	42
242639	1488	2400000000	4553	2356	11	0	0
74508	1397	1407416875000	4553	2356	14	0	3142
26735	1623	14400791000000	4553	2356	15	0	0
74553	1397	1407406874000	4562	2358	0	0	3143
16933	1493	720000000000	4562	2358	1	0	0
74554	1397	1407396873000	4563	2359	0	0	3144
242688	1678	2880083227000	4563	2359	0	0	0
74563	1397	1407356869000	4567	2362	1	0	3148
242697	1678	2880083231000	4567	2362	1	0	0
43840	1690	29519971000000	4568	2363	2	0	0
4890	641	75360430000000	4570	2364	2	0	0
74692	1397	1407326866000	4572	2365	0	0	3151
242825	1678	2880083234000	4572	2365	0	0	0
74693	1397	1407316865000	4572	2365	1	0	3152
242826	1678	2880083235000	4572	2365	1	0	0
34111	1677	149762763000000	4573	2366	3	0	0
46260	1693	3199321551364	4574	2367	1	0	343
25793	1611	5040100000000	4577	2368	3	0	0
74703	1397	1407266860000	4579	2369	0	0	3157
242836	1678	2880083240000	4579	2369	0	0	0
18545	1522	7920200000000	4583	2370	2	0	0
4217	632	75360371000000	4584	2371	2	0	0
74712	1397	1407216855000	4585	2372	3	0	3162
242845	1678	2880083245000	4585	2372	3	0	0
74817	1397	1407196853000	4590	2373	0	0	3164
242950	1678	2880083247000	4590	2373	0	0	0
74818	1397	1407186852000	4590	2373	1	0	3165
242951	1678	2880083248000	4590	2373	1	0	0
51818	1711	10079280000000	4592	2374	2	0	0
74850	354	66002390000000	4594	2376	0	0	1
242982	1483	0	4594	2376	0	0	0
74859	1397	1407086842000	4599	2379	0	0	3175
242991	1678	2880083258000	4599	2379	0	0	0
45580	1692	35279952000000	4599	2379	3	0	0
39305	1684	20159590000000	4600	2380	2	0	0
74864	1397	1407036837000	4601	2381	1	0	3180
242996	1678	2880083263000	4601	2381	1	0	0
37880	1683	336963369999541	4602	2382	1	0	0
74873	1397	1406976831000	4609	2386	1	0	3186
243005	1678	2880083269000	4609	2386	1	0	0
74982	1397	1406926826000	4618	2391	0	0	3191
243114	1678	2880083274000	4618	2391	0	0	0
74984	1397	1406916825000	4620	2392	0	0	3192
243116	1678	2880083275000	4620	2392	0	0	0
75001	1397	1406856819000	4633	2396	0	0	3198
243133	1678	2880083281000	4633	2396	0	0	0
48323	1698	12959261000000	4637	2398	3	0	1
55888	1747	3599140000000	4638	2399	1	0	0
303	43	73200170000000	4644	2400	2	0	0
75031	1397	1406796813000	4645	2401	0	0	3204
243163	1678	2880083287000	4645	2401	0	0	0
34123	1677	152642803000000	4645	2401	1	0	0
23077	1593	9360250000000	4650	2402	2	0	0
243169	1678	2880083289000	4651	2403	0	0	0
243170	1678	2880083290000	4651	2403	1	0	0
75040	1397	1406746808000	4652	2404	0	0	3209
42629	1688	61920993000000	4652	2404	3	0	0
243180	702	44134190840027	4656	2406	1	0	0
75050	1773	1650585563572	4656	2406	3	0	10
50229	1705	7915010000000	4656	2406	8	0	2
243186	1678	2880083295000	4657	2407	0	0	0
39743	1685	33839820000000	4658	2408	2	0	0
75056	1397	1406696803000	4659	2409	0	0	3214
22490	1587	8640150000000	4659	2409	2	0	0
243194	1678	2880083300000	4665	2412	0	0	0
75065	1397	1406646798000	4668	2414	0	0	3219
34128	1677	154082833000000	4668	2414	2	0	0
75073	1397	1406626796000	4673	2416	0	0	3221
75199	1397	1406616795000	4675	2417	0	0	3222
243331	1678	2880083305000	4675	2417	0	0	0
243333	1678	2880083306000	4677	2418	0	0	0
27994	1637	47521332000000	4677	2418	2	0	0
23495	1594	8640250000000	4681	2419	1	0	0
75209	1397	1406576791000	4683	2420	0	0	3226
49510	1702	6474091000000	4683	2420	1	0	1
49512	1702	6474101000000	4683	2420	2	0	1
75210	1397	1406566790000	4684	2421	0	0	3227
22327	1580	720010000000	4684	2421	1	0	0
243345	1678	2880083312000	4687	2423	0	0	0
4227	632	76080371000000	4688	2424	1	0	0
75228	1397	1406506784000	4696	2428	0	0	3233
243362	1821	0	4696	2428	2	0	0
17999	1513	5040090000000	4696	2428	4	0	0
37904	1683	341283409999541	4702	2431	1	0	0
75263	1397	1406456779000	4706	2432	0	0	3238
17737	1509	12240281000000	4706	2432	2	0	0
243397	1678	3600093322000	4708	2433	0	0	0
50584	1706	9356312000000	4710	2435	1	0	6
75269	1397	1406406774000	4711	2436	0	0	3243
243406	1678	3600093328000	4716	2438	0	0	0
75279	1693	3199221551364	4719	2440	1	0	344
243413	1678	3600093333000	4721	2442	0	0	0
31788	1671	10800880000000	4721	2442	2	0	0
75295	1397	1406296763000	4729	2445	0	0	3254
243428	1818	100000000	4729	2445	1	0	0
75305	1397	1406266760000	4733	2447	0	0	3257
243441	1678	3600093342000	4737	2449	0	0	0
243442	1821	150000000000	4737	2449	1	0	0
10319	1402	35280791000000	4738	2450	2	0	0
75313	1397	1406216755000	4739	2451	0	0	3262
243473	1678	3600093348000	4743	2453	0	0	0
75347	1397	1406166750000	4747	2454	0	0	3267
75348	1397	1406156749000	4747	2454	1	0	3268
243491	1678	3600093354000	4753	2456	0	0	0
15047	1458	14400254908540	4753	2456	2	0	0
75363	1821	149990000000	4756	2458	1	0	1
57239	1764	7920028000000	4756	2458	2	0	2
243499	1678	3600093358000	4759	2459	1	0	0
47604	1695	9359161000000	4766	2462	1	0	1
47605	1695	9359171000000	4766	2462	2	0	1
75403	1397	1406046738000	4767	2463	0	0	3279
243542	1678	3600093364000	4771	2465	0	0	0
75413	1397	1405996733000	4771	2465	3	0	3284
243548	1678	3600093370000	4774	2467	1	0	0
75426	1397	1405936727000	4781	2470	0	0	3290
243560	1678	3600093375000	4783	2472	0	0	0
21121	1560	12240300000000	4783	2472	3	0	0
75433	1397	1405876721000	4787	2475	0	0	3296
243569	1678	3600093381000	4789	2476	1	0	0
37923	1683	345603449999541	4790	2477	2	0	0
75442	1397	1405826716000	4792	2478	0	0	3301
34137	1677	156242873000000	4793	2479	1	0	0
34138	1677	156242883000000	4793	2479	2	0	0
243577	1678	3600093387000	4795	2481	0	0	0
243578	1678	3600093388000	4796	2482	0	0	0
75456	1726	935100000000	4799	2483	1	0	50
243592	1827	200000000	4799	2483	5	0	0
75462	1397	1405766710000	4800	2484	0	0	3307
42689	1688	64081033000000	4800	2484	2	0	0
29834	1650	7200100000000	4802	2485	2	0	0
10341	1402	36720821000000	4804	2486	1	0	0
10342	1402	36720831000000	4804	2486	2	0	0
243601	1678	3600093393000	4806	2487	0	0	0
23809	1596	10800150000000	4806	2487	2	0	0
75470	1397	1405726706000	4807	2488	0	0	3311
35579	1679	33840262000000	4808	2489	2	0	0
75581	1397	1405696703000	4812	2491	0	0	3314
243713	1678	3600093397000	4812	2491	0	0	0
75582	1826	0	4813	2492	0	0	1
243714	1828	300000000	4813	2492	0	0	0
21967	1571	9360141000008	4814	2493	2	0	1
13823	1448	7920260000000	4815	2494	2	0	0
75593	1397	1405646698000	4820	2496	0	0	3319
243725	1678	3600093402000	4820	2496	0	0	0
17320	1508	7200100000000	4820	2496	1	0	0
57257	1764	8640058000000	4822	2498	2	0	2
75601	1397	1405606694000	4824	2499	1	0	3323
243733	1678	3600093406000	4824	2499	1	0	0
34144	1677	158402983000000	4824	2499	3	0	0
75727	1397	1405596693000	4826	2500	0	0	3324
243859	1678	3600093407000	4826	2500	0	0	0
75728	1397	1405586692000	4829	2502	0	0	3325
243860	1678	3600093408000	4829	2502	0	0	0
51843	1711	10799280000000	4829	2502	2	0	0
75761	1397	1405536687000	4836	2505	0	0	3330
75762	1397	1405526686000	4836	2505	1	0	3331
243894	1678	3600093414000	4836	2505	1	0	0
47336	1694	21599465000000	4836	2505	4	0	1
56711	1759	11520179000000	4839	2506	0	0	1
20415	1555	7200080000000	4840	2507	1	0	0
20416	1555	7200090000000	4840	2507	2	0	0
37933	1683	349923479999541	4841	2508	1	0	0
4900	641	76080430000000	4842	2509	2	0	0
4901	641	76080450000000	4842	2509	3	0	0
75896	1397	1405466680000	4844	2510	0	0	3337
244028	1678	3600093420000	4844	2510	0	0	0
75899	1397	1405456679000	4847	2511	0	0	3338
244031	1678	3600093421000	4847	2511	0	0	0
39754	1685	35999940000000	4847	2511	1	0	0
54986	1739	8639340000000	4849	2512	2	0	0
75910	1397	1405416675000	4854	2515	1	0	3342
244042	1678	3600093425000	4854	2515	1	0	0
25212	1608	8640120000000	4859	2516	1	0	0
76040	1397	1405396673000	4862	2517	0	0	3344
244172	1678	3600093427000	4862	2517	0	0	0
76041	1397	1405386672000	4862	2517	1	0	3345
244173	1678	3600093428000	4862	2517	1	0	0
25563	1610	10800340000000	4864	2518	1	0	0
76051	1397	1405326666000	4867	2521	0	0	3351
244183	1678	3600093434000	4867	2521	0	0	0
56722	1759	12240179000000	4867	2521	1	0	1
56724	1759	12240189000000	4867	2521	2	0	1
42720	1688	65521043000000	4870	2522	1	0	0
42722	1688	65521053000000	4870	2522	2	0	0
32347	1673	7200490000000	4872	2523	1	0	0
76181	1397	1405296663000	4875	2524	0	0	3354
244313	1678	3600093437000	4875	2524	0	0	0
37940	1683	354243609999541	4875	2524	1	0	0
76182	1397	1405286662000	4876	2525	0	0	3355
244314	1678	3600093438000	4876	2525	0	0	0
55318	1740	11516643000000	4876	2525	2	0	3
76200	1397	1405226656000	4884	2529	0	0	3361
244332	1678	3600093444000	4884	2529	0	0	0
14648	1457	10080180000000	4887	2531	2	0	0
76208	1397	1405186652000	4889	2533	1	0	3365
244340	1678	3600093448000	4889	2533	1	0	0
2898	484	77520171000000	4889	2533	3	0	0
37945	1683	357123629999541	4891	2535	1	0	0
37947	1683	357123639999541	4891	2535	2	0	0
76318	1397	1405146648000	4896	2536	0	0	3369
244450	1678	3600093452000	4896	2536	0	0	0
55575	1746	2879040000000	4896	2536	2	0	0
76320	1397	1405136647000	4900	2537	0	0	3370
244452	1678	3600093453000	4900	2537	0	0	0
31505	1670	13680480000000	4908	2541	4	0	0
76340	1397	1405086642000	4914	2542	0	0	3375
244472	1678	3600093458000	4914	2542	0	0	0
4534	633	74639260000000	4915	2543	5	0	1
76346	1397	1405036637000	4916	2544	1	0	3380
244478	1678	3600093463000	4916	2544	1	0	0
50876	1708	5759190000000	4921	2546	1	0	0
76357	1397	1404986632000	4926	2549	0	0	3385
244489	1678	3600093468000	4926	2549	0	0	0
50607	1706	10076322000000	4928	2550	1	0	6
50608	1706	10076332000000	4928	2550	2	0	6
76366	1397	1404926626000	4931	2552	1	0	3391
244498	1678	3600093474000	4931	2552	1	0	0
52423	1715	12959281000000	4932	2553	3	0	0
76372	542	66000988890000	4934	2555	0	0	1
244504	1492	21000000	4934	2555	0	0	0
28007	1637	49681372000000	4938	2557	1	0	0
26428	1622	3600030000000	4940	2558	1	0	0
76396	1397	1404836617000	4942	2559	0	0	3400
244528	1678	3600093483000	4942	2559	0	0	0
39321	1684	20879590000000	4942	2559	1	0	0
244529	1678	3600093484000	4943	2560	0	0	0
244533	1678	3600093485000	4947	2561	0	0	0
24717	1602	7920260000000	4947	2561	2	0	0
76406	1397	1404776611000	4950	2563	2	0	3406
244540	1678	3600093491000	4950	2563	4	0	0
13486	1447	10800200000000	4950	2563	6	0	0
2027	369	78240310000000	4952	2565	1	0	0
76413	1397	1404716605000	4955	2567	0	0	3412
244547	1678	3600093497000	4957	2569	0	0	0
34156	1677	160563023000000	4959	2570	2	0	0
76419	1397	1404676601000	4960	2571	1	0	3416
564	44	72480190000000	4960	2571	3	0	0
244555	1678	3600093501000	4962	2572	0	0	0
76429	1397	1404616595000	4965	2574	1	0	3422
76433	1397	1404596593000	4968	2576	0	0	3424
244565	1678	3600093507000	4968	2576	0	0	0
76436	1397	1404586592000	4970	2577	0	0	3425
32704	1675	6480250000000	4970	2577	2	0	0
37962	1683	361443769999541	4974	2579	3	0	0
27169	1629	720000000000	4975	2580	1	0	0
76447	1397	1404536587000	4977	2581	0	0	3430
244578	1678	3600093513000	4977	2581	0	0	0
76460	1397	1404486582000	4980	2582	3	0	3435
244589	1678	3600093518000	4980	2582	3	0	0
15648	1471	7920120000000	4982	2583	1	0	0
15650	1471	7920130000000	4982	2583	2	0	0
76479	1397	1404436577000	4988	2585	0	0	3440
244608	1678	3600093524000	4989	2586	0	0	0
45632	1692	37440032000000	4989	2586	2	0	0
76487	1397	1404386572000	4994	2589	1	0	3445
244616	1678	3600093529000	4994	2589	2	0	0
76497	1397	1404336567000	4997	2591	2	0	3450
244626	1678	3600093534000	4999	2592	0	0	0
22726	1588	7920110000000	4999	2592	1	0	0
35611	1679	36000282000000	5003	2594	1	0	0
76508	1397	1404296563000	5007	2595	1	0	3454
41276	1687	12959211000000	5009	2596	1	0	1
244639	1678	3600093539000	5010	2597	0	0	0
37970	1683	365763919999541	5012	2598	2	0	0
76517	1397	1404236557000	5015	2601	0	0	3460
42775	1688	67681193000000	5016	2602	2	0	0
244646	1678	3600093545000	5017	2603	0	0	0
76523	1397	1404176551000	5019	2605	1	0	3466
244651	1678	3600093550000	5020	2606	0	0	0
37975	1683	370083949999541	5021	2607	2	0	0
76530	1397	1404136547000	5023	2608	1	0	3470
14469	1455	7200131000000	5024	2609	2	0	0
244662	1678	3600093555000	5029	2610	0	0	0
16675	1489	7920171000000	5029	2610	1	0	0
244666	1678	3600093557000	5033	2612	0	0	0
244672	1678	3600093558000	5038	2613	0	0	0
76546	1397	1404076541000	5038	2613	1	0	3476
51878	1711	12959180000000	5040	2614	2	0	0
43847	1690	31680011000000	5046	2616	2	0	0
244686	1678	3600093564000	5047	2617	0	0	0
76560	1397	1404016535000	5048	2618	0	0	3482
76565	1397	1403966530000	5050	2620	0	0	3487
244692	1678	3600093570000	5050	2620	0	0	0
57262	1764	9360058000000	5051	2621	3	0	2
76569	1397	1403936527000	5052	2622	0	0	3490
76571	1397	1403926526000	5054	2623	0	0	3491
244698	1678	3600093574000	5054	2623	0	0	0
12059	1426	7200260000000	5054	2623	2	0	0
22739	1588	10080140000000	5061	2626	1	0	0
4945	641	78240480000000	5064	2627	2	0	0
76583	1397	1403866520000	5066	2628	1	0	3497
244710	1678	3600093580000	5066	2628	1	0	0
51315	1709	10077271000000	5066	2628	3	0	4
13177	1444	12960480000000	5072	2631	2	0	0
12841	1440	9360360000000	5074	2632	2	0	0
76595	1765	40000000	5075	2633	1	0	2
244722	872	109739603307813	5075	2633	1	0	0
14087	1451	5040210000000	5075	2633	5	0	0
76600	1397	1403766510000	5077	2635	0	0	3507
244727	1678	3600093590000	5077	2635	0	0	0
39360	1684	23039650000000	5077	2635	1	0	0
76617	1397	1403726506000	5087	2639	1	0	3511
244744	1678	3600093594000	5087	2639	1	0	0
37986	1683	374403999999541	5088	2640	1	0	0
76627	1397	1403666500000	5094	2644	0	0	3517
244754	1678	3600093600000	5094	2644	0	0	0
27527	1634	9360160000000	5094	2644	2	0	0
76634	1397	1403616495000	5098	2646	1	0	3522
244761	1678	3600093605000	5098	2646	1	0	0
54311	1724	11518800000000	5098	2646	4	0	2
47810	1696	7198121000000	5099	2647	1	0	1
76644	1397	1403566490000	5106	2650	0	0	3527
244771	1678	3600093610000	5106	2650	0	0	0
5320	1271	1336926030000000	5106	2650	1	0	0
19033	1536	12960270000000	5113	2654	1	0	0
76662	1397	1403506484000	5121	2656	1	0	3533
244789	1678	3600093616000	5121	2656	1	0	0
76669	1397	1403456479000	5124	2658	2	0	3538
244796	1678	3600093621000	5124	2658	2	0	0
244807	1678	3600093622000	5130	2659	0	0	0
244808	1678	3600093623000	5130	2659	1	0	0
76692	1397	1403396473000	5134	2661	2	0	3544
244821	1678	3600093629000	5135	2662	0	0	0
2573	470	77520281000000	5135	2662	2	0	0
76707	1397	1403346468000	5142	2664	0	0	3549
76708	1397	1403336467000	5142	2664	1	0	3550
244836	1678	3600093634000	5143	2665	0	0	0
26742	1623	16561440899898	5143	2665	2	0	0
35627	1679	38160312000000	5145	2667	2	0	0
76714	1397	1403286462000	5146	2668	0	0	3555
244841	1678	3600093638000	5146	2668	0	0	0
22229	1573	10800370000000	5148	2669	2	0	0
21161	1560	14400340000000	5150	2670	3	0	0
16400	1476	10800200000000	5151	2671	1	0	0
76724	1397	1403226456000	5154	2673	0	0	3561
244851	1678	3600093644000	5154	2673	0	0	0
28017	1637	51121392000000	5154	2673	1	0	0
28019	1637	51121402000000	5154	2673	2	0	0
48937	1700	8639450000000	5155	2674	2	0	1
1044	69	66720010000000	5156	2675	2	0	0
38000	1683	378724039999541	5157	2676	2	0	0
76729	1397	1403176451000	5158	2677	0	0	3566
244860	1678	3600093650000	5162	2678	0	0	0
46370	1693	4639051551364	5163	2679	2	0	346
76739	1397	1403116445000	5167	2682	0	0	3572
244866	1678	3600093655000	5167	2682	0	0	0
30475	1656	13680311000000	5172	2686	0	0	0
12309	1427	719750000000	5177	2688	0	0	0
76758	1397	1403056439000	5180	2689	0	0	3578
244885	1678	3600093661000	5180	2689	0	0	0
58119	1837	200000010	5180	2689	6	0	0
58113	1831	200000001	5180	2689	8	1	0
76763	1397	1403006434000	5181	2690	0	0	3583
29500	1649	9360280999992	5181	2690	1	0	0
244891	1678	3600093667000	5182	2691	0	0	0
46421	1693	5359051551364	5185	2694	1	0	346
76769	1397	1402946428000	5186	2695	0	0	3589
244896	1678	3600093672000	5186	2695	0	0	0
76777	1397	1402886422000	5192	2699	0	0	3595
244904	1678	3600093678000	5192	2699	0	0	0
45661	1692	39600092000000	5192	2699	1	0	0
26053	1613	8638400000000	5196	2702	1	0	2
76784	1397	1402836417000	5199	2704	0	0	3600
244912	1816	100000000	5199	2704	1	0	1
3378	576	76080270000000	5199	2704	2	0	0
38012	1683	381604089999541	5200	2705	3	0	0
42826	1688	69841223000000	5203	2706	2	0	0
76795	1397	1402786412000	5207	2708	0	0	3605
244922	1678	3600093688000	5207	2708	0	0	0
2603	470	78240301000000	5208	2709	1	0	0
2604	470	78240311000000	5208	2709	2	0	0
76801	1397	1402736407000	5215	2711	2	0	3610
244928	1678	3600093693000	5215	2711	2	0	0
32093	1672	9360260000000	5216	2712	2	0	0
244937	1678	3600093696000	5221	2714	0	0	0
244938	1678	3600093697000	5221	2714	1	0	0
76812	1397	1402686402000	5222	2715	0	0	3615
42849	1688	71281233000000	5228	2718	1	0	0
42850	1688	71281243000000	5228	2718	2	0	0
244951	1678	3600093703000	5231	2719	1	0	0
76831	1397	1402626396000	5239	2720	0	0	3621
25571	1610	11520350000000	5239	2720	3	0	0
25574	1610	11520380000000	5239	2720	4	0	0
244967	1678	3600093709000	5247	2723	0	0	0
76841	1397	1402566390000	5248	2724	0	0	3627
38022	1683	385924129999541	5248	2724	2	0	0
55904	1747	4319150000000	5250	2725	0	0	0
76844	1397	1402556389000	5253	2726	0	0	3628
36370	1681	16559365195920	5254	2727	0	0	1
244974	1678	3600093714000	5256	2728	1	0	0
35634	1679	39600342000000	5260	2730	1	0	0
35635	1679	39600352000000	5260	2730	2	0	0
76851	1397	1402496383000	5262	2731	1	0	3634
244981	1678	3600093720000	5264	2733	0	0	0
76858	711	3002390000000	5267	2735	0	0	1
244990	1678	3600093724000	5269	2736	1	0	0
29233	1643	1764243113700	5271	2737	2	0	5
76867	1397	1402406374000	5272	2738	0	0	3643
18414	1521	2157100000000	5272	2738	3	0	1
244997	1678	3600093729000	5273	2739	1	0	0
21447	1564	5760062000000	5274	2740	1	0	0
76875	1397	1402346368000	5277	2742	0	0	3649
53457	1719	6479180000000	5281	2743	1	0	0
53458	1719	6479190000000	5281	2743	2	0	0
245012	1678	3600093735000	5284	2744	0	0	0
47362	1694	23759515000000	5286	2746	2	0	1
76890	1397	1402286362000	5288	2747	0	0	3655
245023	1678	3600093741000	5293	2749	0	0	0
76898	1397	1402236357000	5295	2751	0	0	3660
30059	1654	10080180000000	5295	2751	2	0	0
245032	1678	3600093746000	5300	2753	1	0	0
28033	1637	53281442000000	5303	2755	2	0	0
76909	1397	1402176351000	5304	2756	0	0	3666
56246	1749	9355148000000	5305	2757	2	0	3
245039	1678	3600093752000	5306	2758	0	0	0
52992	1717	8639230000000	5306	2758	2	0	0
30068	1654	10800180000000	5308	2759	1	0	0
76916	1397	1402126346000	5309	2760	0	0	3671
245048	1678	3600093757000	5313	2762	0	0	0
4981	641	80400520000000	5313	2762	2	0	0
76927	1397	1402076341000	5319	2764	0	0	3676
55349	1740	12956673000000	5319	2764	1	0	3
55358	1740	13676673000000	5319	2764	2	0	3
77038	1397	1402056339000	5326	2766	0	0	3678
245165	1678	3600093761000	5326	2766	0	0	0
38034	1683	390244169999541	5326	2766	2	0	0
77044	1397	1402046338000	5332	2767	0	0	3679
245171	1678	3600093762000	5332	2767	0	0	0
53967	1723	12239820000000	5333	2768	2	0	0
50255	1705	10075060000000	5336	2769	2	0	2
25064	1607	15120412000000	5339	2770	2	0	0
77059	1397	1401986332000	5344	2773	0	0	3685
245186	1678	3600093768000	5344	2773	0	0	0
56970	1762	5039110000000	5348	2776	1	0	0
77067	1397	1401926326000	5351	2777	0	0	3691
245194	1678	3600093774000	5351	2777	0	0	0
5262	700	70320080000000	5351	2777	1	0	0
28043	1637	55441472000000	5352	2778	2	0	0
568	44	73920320000000	5353	2779	1	0	0
77074	1397	1401876321000	5357	2781	1	0	3696
245201	1678	3600093779000	5357	2781	1	0	0
22526	1587	10800190000000	5357	2781	3	0	0
245228	1678	3600093783000	5362	2784	0	0	0
245229	1678	3600093784000	5362	2784	1	0	0
77103	1397	1401816315000	5363	2785	0	0	3702
49268	1701	10078312000000	5363	2785	2	0	4
245236	1678	3600093790000	5367	2788	1	0	0
10371	1402	38880971000000	5367	2788	3	0	0
77110	1397	1401756309000	5368	2789	0	0	3708
38043	1683	394564189999541	5368	2789	1	0	0
39765	1685	38159970000000	5370	2791	0	0	0
32105	1672	10080260000000	5372	2793	0	0	0
55365	1740	14396673000000	5375	2796	0	0	3
793	58	75360230000000	5378	2798	0	0	0
77113	1840	899000000	5379	2799	0	0	1
54805	1729	9359150000000	5381	2800	0	0	0
13362	1445	9360200000000	5382	2801	0	0	0
52203	1714	15109140000000	5396	2808	0	0	2
27559	1634	11520209899999	5399	2809	0	0	0
38051	1683	400324200999541	5401	2811	0	0	0
77115	1639	716118000000	5404	2813	0	0	2
245243	1639	716218000000	5410	2815	0	0	2
52793	1716	12239220000000	5422	2820	1	0	0
31825	1671	12960900000000	5443	2832	0	0	0
2047	369	79680330000000	5445	2833	0	0	0
45702	1692	41760103000000	5448	2835	0	0	0
38058	1683	408964200999541	5451	2837	0	0	0
77190	1726	914300000000	5458	2840	0	0	66
245314	1843	200000000	5458	2840	0	0	0
77196	1726	906500000000	5458	2840	6	0	72
245320	1849	200000000	5458	2840	6	0	0
2921	484	79680221000000	5459	2841	1	0	0
17172	1506	8640170000000	5484	2854	0	0	0
25827	1611	7920110000000	5486	2855	0	0	0
29325	1643	4644253113700	5503	2862	0	0	5
46590	1693	7519201551364	5504	2863	2	0	346
38065	1683	416164200999541	5507	2866	0	0	0
32111	1672	10800260000000	5509	2867	0	0	0
26749	1623	18721480899898	5519	2871	0	0	0
21230	1560	16560480000000	5520	2872	0	0	0
35642	1679	42480363000000	5535	2878	0	0	0
77258	240	66001100000000	5539	2880	0	0	1
245382	1483	0	5539	2880	0	0	0
62	42	73920220000000	5546	2883	0	0	0
11703	1422	5760060000000	5547	2884	0	0	0
47394	1694	26639535000000	5548	2885	0	0	1
43854	1690	34560051000000	5552	2887	0	0	0
50915	1708	7919230000000	5563	2893	0	0	0
38076	1683	423364300999541	5593	2907	0	0	0
28055	1637	58321473000000	5608	2914	0	0	0
1513	171	75360130000000	5614	2916	0	0	0
77274	1562	990000000	5631	2925	0	0	1
245398	492	66719000000000	5631	2925	0	0	0
47842	1696	9358271000000	5635	2928	0	0	1
14522	1455	10800141000000	5652	2932	0	0	0
27304	1633	9360110000000	5654	2933	0	0	0
38081	1683	429124300999541	5663	2937	0	0	0
20084	1549	12960391000000	5677	2943	0	0	0
38082	1683	430564300999541	5686	2947	0	0	0
39777	1685	42479970000000	5689	2949	0	0	0
45720	1692	42480103000000	5698	2954	0	0	0
52442	1715	15120031000000	5699	2955	1	0	0
24394	1601	7560925600000	5704	2958	0	0	5
17778	1509	14400401000000	5710	2961	2	0	0
77315	1844	1200000000	5717	2964	1	0	2
245439	1483	0	5717	2964	1	0	0
77326	1397	1401686302000	5745	2977	0	0	3715
245450	1678	3600093798000	5745	2977	0	0	0
31831	1671	13680900000000	5745	2977	1	0	0
10068	1398	720000000000	5746	2978	1	0	0
31538	1670	15840500000000	5751	2981	1	0	0
77333	1397	1401636297000	5752	2982	0	0	3720
245457	1678	3600093803000	5752	2982	0	0	0
57290	1764	11520118000000	5752	2982	2	0	2
51548	1710	9359220000000	5756	2984	1	0	1
51550	1710	9359230000000	5756	2984	2	0	1
77343	1397	1401576291000	5759	2986	0	0	3726
245467	1678	3600093809000	5759	2986	0	0	0
43861	1690	38160061000000	5761	2987	2	0	0
77354	1397	1401516285000	5764	2989	1	0	3732
245478	1678	3600093815000	5764	2989	1	0	0
245481	1678	3600093818000	5765	2990	1	0	0
245482	1678	3600093819000	5765	2990	2	0	0
77359	1397	1401466280000	5766	2991	0	0	3737
21246	1560	17280480000000	5766	2991	2	0	0
245490	1678	3600093825000	5774	2994	1	0	0
28063	1637	61921673000000	5774	2994	2	0	0
77367	1397	1401406274000	5775	2995	0	0	3743
43556	1689	9359181000000	5775	2995	2	0	0
245496	1678	3600093831000	5777	2996	3	0	0
4105	623	66720000000000	5777	2996	4	0	0
77373	1397	1401346268000	5778	2997	0	0	3749
42912	1688	74881253000000	5778	2997	2	0	0
3607	596	80400282000000	5779	2998	1	0	0
245501	1678	3600093836000	5780	2999	1	0	0
77378	1397	1401296263000	5781	3000	0	0	3754
77435	1397	1401266260000	5784	3002	0	0	3757
77436	1397	1401256259000	5784	3002	1	0	3758
54343	1724	13678860000000	5784	3002	3	0	2
245567	1852	200000000	5788	3003	0	0	0
10419	1402	42481181000000	5788	3003	4	0	0
77452	1397	1401216255000	5794	3006	0	0	3762
245577	1678	3600093846000	5794	3006	1	0	0
38091	1683	436324320999541	5799	3008	2	0	0
77464	1397	1401156249000	5800	3009	1	0	3768
245588	1678	3600093851000	5800	3009	1	0	0
17184	1506	9360170000000	5800	3009	2	0	0
339	43	76080230000000	5803	3011	1	0	0
77470	1397	1401106244000	5807	3013	0	0	3773
46734	1693	10399221551364	5807	3013	1	0	346
245596	1678	3600093857000	5809	3014	0	0	0
57582	1768	6479161110000	5809	3014	1	0	0
58209	1850	9345010000000	5813	3016	2	0	0
77480	1397	1401046238000	5815	3018	0	0	3779
245605	1678	3600093863000	5815	3018	1	0	0
11968	1423	2880060000000	5822	3021	2	0	0
77492	1397	1400986232000	5825	3022	0	0	3785
245616	1678	3600093868000	5825	3022	0	0	0
18588	1522	10080230000000	5825	3022	2	0	0
245619	1678	3600093869000	5828	3023	0	0	0
30485	1656	14400311000000	5828	3023	1	0	0
245620	1678	3600093870000	5829	3024	0	0	0
77499	1397	1400936227000	5831	3026	0	0	3790
3869	606	75360190000000	5835	3028	2	0	0
245636	1854	200000000	5838	3029	0	0	0
38100	1683	439204470999541	5838	3029	1	0	0
77515	1397	1400896223000	5838	3029	4	0	3794
77524	1397	1400886222000	5841	3030	0	0	3795
11714	1422	6480060000000	5841	3030	1	0	0
77525	1397	1400876221000	5842	3031	0	0	3796
245650	1678	3600093880000	5842	3031	1	0	0
29519	1649	10080320999992	5842	3031	4	0	0
19726	1547	5760040000000	5844	3032	1	0	0
19727	1547	5760050000000	5844	3032	2	0	0
21993	1571	12240161000008	5849	3034	2	0	1
77537	1397	1400816215000	5850	3035	0	0	3802
245661	1678	3600093885000	5850	3035	0	0	0
77545	1397	1400756209000	5857	3039	1	0	3808
245669	1678	3600093891000	5857	3039	1	0	0
77614	1397	1400706204000	5869	3041	2	0	3813
245739	1678	3600093897000	5870	3042	0	0	0
15356	1467	8641590000000	5870	3042	2	0	0
56986	1762	5759120000000	5871	3043	1	0	0
56987	1762	5759130000000	5871	3043	2	0	0
54809	1729	10079170000000	5872	3044	3	0	0
77622	1397	1400646198000	5874	3045	0	0	3819
245746	1678	3600093902000	5874	3045	0	0	0
245753	1678	3600093907000	5879	3048	1	0	0
77632	1397	1400586192000	5881	3049	0	0	3825
245756	1678	3600093908000	5881	3049	0	0	0
39396	1684	25199680000000	5881	3049	2	0	0
26450	1622	5759069999976	5885	3052	0	0	0
77637	1397	1400566190000	5891	3054	1	0	3827
245762	1678	3600093911000	5891	3054	2	0	0
28070	1637	64081723799997	5895	3055	1	0	0
77654	1397	1400506184000	5896	3056	1	0	3833
245779	1678	3600093917000	5896	3056	2	0	0
77657	1397	1400476181000	5896	3056	4	0	3836
77658	1397	1400466180000	5897	3057	0	0	3837
13533	1447	13680220000000	5897	3057	2	0	0
20826	1559	15120280000000	5900	3058	1	0	0
245786	1678	4320143922000	5901	3059	0	0	0
36091	1680	16559290000000	5902	3060	1	0	0
77669	1397	1400406174000	5908	3062	1	0	3843
53014	1717	10799262000000	5908	3062	3	0	0
245796	1678	4320143928000	5911	3064	0	0	0
77679	1397	1400346168000	5916	3067	1	0	3849
245814	1678	4320143934000	5920	3068	0	0	0
38107	1683	443524610999541	5925	3070	1	0	0
77702	1397	1400296163000	5930	3071	0	0	3854
245828	1678	4320143939000	5931	3072	0	0	0
14114	1451	7200230000000	5932	3073	2	0	0
77738	1397	1400236157000	5937	3075	0	0	3860
245864	1678	4320143945000	5939	3077	0	0	0
31144	1668	15120250000000	5939	3077	1	0	0
19509	1546	12240170000000	5940	3078	3	0	0
77750	1397	1400176151000	5943	3079	0	0	3866
245876	1678	4320143951000	5945	3081	0	0	0
77757	1397	1400126146000	5947	3082	1	0	3871
245884	1678	4320143956000	5950	3084	0	0	0
28079	1637	65521753799997	5953	3085	2	0	0
245889	1678	4320143959000	5954	3086	1	0	0
15705	1471	10800170000000	5954	3086	3	0	0
77766	1397	1400066140000	5955	3087	0	0	3877
245890	1678	4320143960000	5955	3087	0	0	0
48350	1698	15119291000000	5956	3088	2	0	1
77773	877	203054343117107	5959	3090	2	0	2
245897	1772	728750000000	5959	3090	2	0	1
34177	1677	162723343000000	5959	3090	5	0	0
39784	1685	44640000000000	5960	3091	1	0	0
77778	1397	1399986132000	5962	3093	0	0	3885
245906	1678	4320143969000	5966	3094	0	0	0
46829	1693	12559281551364	5967	3095	3	0	346
77791	1397	1399926126000	5971	3097	0	0	3891
245915	1678	4320143974000	5971	3097	0	0	0
77793	1397	1399906124000	5972	3098	0	0	3893
77795	1397	1399896123000	5974	3099	0	0	3894
38115	1683	447844650999541	5975	3100	1	0	0
245924	1678	4320143980000	5979	3102	0	0	0
12494	1439	7920120000000	5981	3103	2	0	0
77806	1397	1399836117000	5983	3104	0	0	3900
245937	1678	4320143986000	5987	3106	0	0	0
77818	1397	1399776111000	5992	3109	0	0	3906
245948	1678	4320143991000	5995	3110	1	0	0
21383	1563	720020000000	5995	3110	3	0	0
77827	1397	1399726106000	5996	3111	2	0	3911
42937	1688	77041303000000	5996	3111	5	0	0
245959	1678	4320143997000	5998	3112	0	0	0
22249	1573	12960400000000	5998	3112	1	0	0
77842	1665	719900000000	6000	3113	2	0	2
2931	484	81840242000000	6003	3114	1	0	0
245970	1678	4320144003000	6007	3117	0	0	0
77851	1397	1399626096000	6007	3117	1	0	3921
34185	1677	164883413000000	6007	3117	2	0	0
32358	1673	9360520000000	6008	3118	2	0	0
38123	1683	452164690999541	6011	3119	1	0	0
44783	1691	7199120000000	6015	3120	2	0	0
245988	1678	4320144008000	6017	3121	0	0	0
77871	1397	1399576091000	6018	3122	0	0	3926
24754	1602	10080280000000	6018	3122	1	0	0
24755	1602	10080290000000	6018	3122	2	0	0
77880	1397	1399526086000	6023	3125	1	0	3931
245997	1678	4320144014000	6023	3125	1	0	0
16095	1474	10074243000000	6023	3125	2	0	3
77888	1397	1399476081000	6026	3127	0	0	3936
246005	1678	4320144019000	6026	3127	0	0	0
77900	1397	1399436077000	6031	3129	1	0	3940
246017	1678	4320144023000	6031	3129	1	0	0
77907	1861	0	6035	3132	2	0	1
246024	1665	718880000000	6035	3132	2	0	3
246025	1678	4320144027000	6036	3133	0	0	0
13204	1444	15120520000000	6036	3133	2	0	0
246026	1861	718000000000	6037	3134	0	0	1
77913	1397	1399366070000	6039	3136	0	0	3947
246033	1678	4320144031000	6041	3137	1	0	0
54994	1739	10799390000000	6042	3138	3	0	0
77919	1397	1399326066000	6043	3139	0	0	3951
246040	1678	4320144037000	6047	3142	0	0	0
15084	1458	16560274908540	6047	3142	2	0	0
30913	1662	720000000000	6049	3143	2	0	0
77936	1397	1399266060000	6052	3144	0	0	3957
77938	1397	1399256059000	6054	3145	0	0	3958
246053	1678	4320144042000	6055	3146	0	0	0
56756	1759	14400239000000	6059	3147	3	0	1
77952	1397	1399196053000	6064	3149	0	0	3964
246067	1678	4320144048000	6065	3150	0	0	0
38133	1683	455044740999541	6066	3151	4	0	0
77961	1397	1399136047000	6068	3152	1	0	3970
246076	1678	4320144054000	6069	3153	0	0	0
77973	1397	1399086042000	6077	3156	1	0	3975
246093	1678	4320144059000	6081	3157	0	0	0
34196	1677	167043493000000	6088	3160	1	0	0
77990	1397	1399026036000	6091	3162	0	0	3981
246105	1678	4320144065000	6091	3162	1	0	0
31873	1671	15840940000000	6091	3162	3	0	0
15097	1458	17280304908540	6094	3163	4	0	0
78005	1397	1398966030000	6096	3164	0	0	3987
246120	1678	4320144071000	6096	3164	1	0	0
50654	1706	12236382000000	6096	3164	3	0	6
42951	1688	78481383000000	6097	3165	3	0	0
36410	1681	19439385195920	6101	3166	1	0	1
78017	1397	1398916025000	6104	3167	0	0	3992
17357	1508	10080120000000	6104	3167	1	0	0
246137	1863	0	6107	3168	0	0	0
78039	1397	1398876021000	6113	3170	0	0	3996
246154	1678	4320144080000	6115	3171	0	0	0
52810	1716	14399241000000	6118	3172	3	0	0
2056	369	80400330000000	6119	3173	1	0	0
78049	1397	1398816015000	6122	3174	0	0	4002
246162	1678	4320144085000	6122	3174	0	0	0
38147	1683	459364770999541	6122	3174	2	0	0
246163	1865	200000000	6123	3175	0	0	0
78054	1397	1398776011000	6125	3177	2	0	4006
26760	1623	20881500899898	6125	3177	3	0	0
246172	1678	4320144091000	6130	3179	0	0	0
78065	1397	1398736007000	6135	3181	0	0	4010
78068	1397	1398726006000	6138	3182	0	0	4011
34205	1677	168483523000000	6140	3184	2	0	0
246186	1678	4320144097000	6144	3185	0	0	0
78078	1397	1398666000000	6152	3187	0	0	4017
14686	1457	12240210000000	6152	3187	1	0	0
14689	1457	12240220000000	6152	3187	2	0	0
246196	1678	4320144102000	6157	3189	0	0	0
28086	1637	67681783799997	6162	3191	2	0	0
78090	1397	1398605994000	6163	3192	1	0	4023
4596	633	77519300000000	6163	3192	4	0	1
246207	1678	4320144108000	6166	3193	0	0	0
14704	1457	12960220000000	6166	3193	1	0	0
39791	1685	46800050000000	6171	3195	1	0	0
78100	1397	1398555989000	6172	3196	0	0	4028
246216	1678	4320144114000	6173	3197	2	0	0
38157	1683	463684940999541	6173	3197	5	0	0
78124	1397	1398495983000	6179	3199	0	0	4034
246239	1678	4320144119000	6179	3199	2	0	0
18020	1513	7200110000000	6181	3200	2	0	0
78133	1397	1398435977000	6183	3201	0	0	4040
246250	1866	9000000000	6185	3202	0	0	0
78140	1397	1398405974000	6185	3202	3	0	4043
38162	1683	468004970999541	6185	3202	4	0	0
34772	1678	5040154127000	6186	3203	2	0	0
246256	1866	12152037273550	6187	3204	1	0	0
49853	1703	7919200000000	6187	3204	3	0	1
78152	1687	804883726450	6193	3206	0	0	4
246267	1678	5040154131000	6193	3206	2	0	0
10454	1402	44641201000000	6194	3207	1	0	0
27612	1634	13680229899999	6195	3208	1	0	0
27614	1634	13680239899999	6195	3208	2	0	0
78173	1866	11991625815924	6203	3210	1	0	2
246288	846	574692567058364	6203	3210	3	0	0
78178	1866	4238921951632	6203	3210	6	0	7
246294	1678	5040154135000	6203	3210	9	0	0
44985	1692	1459113000000	6204	3211	2	0	4
246299	1678	5040154137000	6206	3212	0	0	0
78187	1397	1398285962000	6206	3212	1	0	4055
246300	1678	5040154138000	6206	3212	1	0	0
23127	1593	12240290000000	6211	3214	1	0	0
23130	1593	12240300000000	6211	3214	2	0	0
78201	1397	1398235957000	6213	3215	3	0	4060
246314	1678	5040154143000	6213	3215	3	0	0
78206	1397	1398225956000	6215	3216	0	0	4061
78217	1397	1398195953000	6221	3219	1	0	4064
246328	1678	5040154147000	6221	3219	1	0	0
47659	1695	12239191000000	6221	3219	4	0	1
246336	1678	5040154152000	6226	3221	0	0	0
54360	1724	15838880000000	6226	3221	1	0	2
78226	1397	1398135947000	6227	3222	0	0	4070
16433	1476	12240250000000	6227	3222	3	0	0
38172	1683	472325420999541	6229	3223	1	0	0
78254	1397	1398085942000	6231	3224	2	0	4075
246364	1678	5040154158000	6231	3224	2	0	0
30717	1657	7200120000000	6233	3225	1	0	0
78281	1397	1398025936000	6241	3228	0	0	4081
246390	1678	5040154164000	6241	3228	0	0	0
32753	1675	8640419999977	6241	3228	1	0	0
42967	1688	80641413000000	6244	3230	2	0	0
246398	1678	5040154169000	6247	3232	0	0	0
10478	1402	46081221000000	6247	3232	1	0	0
10479	1402	46081231000000	6247	3232	2	0	0
78293	1397	1397965930000	6250	3233	0	0	4087
78298	1397	1397915925000	6252	3235	2	0	4092
246407	1678	5040154175000	6252	3235	2	0	0
22765	1588	12240160000000	6253	3236	1	0	0
78306	1397	1397885922000	6256	3238	1	0	4095
246415	1678	5040154178000	6256	3238	1	0	0
25602	1610	13680420000000	6257	3239	2	0	0
246420	1678	5040154183000	6259	3241	0	0	0
78312	1397	1397825916000	6260	3242	0	0	4101
39418	1684	27359700000000	6261	3243	1	0	0
78321	1397	1397775911000	6266	3245	1	0	4106
246430	1678	5040154189000	6266	3245	1	0	0
34219	1677	170643563000000	6267	3246	2	0	0
246433	1678	5040154192000	6268	3247	1	0	0
29875	1650	9360230000000	6268	3247	2	0	0
246434	1678	5040154193000	6269	3248	0	0	0
78327	1397	1397715905000	6270	3249	1	0	4112
78337	1397	1397695903000	6273	3250	0	0	4114
78338	1397	1397685902000	6273	3250	1	0	4115
246448	1678	5040154199000	6273	3250	2	0	0
35651	1679	45360393000000	6273	3250	4	0	0
1538	171	76080130000000	6282	3253	1	0	0
78357	1397	1397625896000	6284	3254	0	0	4121
246467	1678	5040154205000	6285	3255	0	0	0
39798	1685	48960120000000	6285	3255	1	0	0
16712	1489	10080201000000	6286	3256	2	0	0
48620	1699	4209932500051	6289	3258	3	0	3
78364	1397	1397565890000	6290	3259	0	0	4127
246473	1678	5040154210000	6290	3259	0	0	0
30744	1657	8640150000000	6292	3260	1	0	0
30745	1657	8640160000000	6292	3260	2	0	0
53509	1719	9359210000000	6301	3262	2	0	0
78379	1397	1397515885000	6304	3263	1	0	4132
246489	1678	5040154216000	6305	3264	0	0	0
50288	1705	12235100000000	6305	3264	1	0	2
78395	1397	1397475881000	6308	3265	4	0	4136
24457	1601	9721195600000	6308	3265	6	0	5
246506	1678	5040154220000	6310	3266	0	0	0
78406	1397	1397415875000	6315	3269	1	0	4142
246515	1678	5040154225000	6315	3269	1	0	0
40970	1687	2964933726450	6320	3271	1	0	4
78416	1397	1397365870000	6324	3273	0	0	4147
246527	1678	5040154231000	6326	3274	0	0	0
15729	1471	12960320000000	6329	3276	2	0	0
78424	1397	1397305864000	6330	3277	2	0	4153
246534	1678	5040154237000	6331	3278	0	0	0
78561	1397	1397245858000	6341	3282	0	0	4159
246666	1678	5040154242000	6341	3282	0	0	0
78563	1397	1397235857000	6343	3283	0	0	4160
246668	1678	5040154243000	6343	3283	0	0	0
78691	1397	1397225856000	6347	3284	0	0	4161
246796	1678	5040154244000	6347	3284	0	0	0
78692	1397	1397215855000	6348	3285	0	0	4162
246797	1678	5040154245000	6348	3285	0	0	0
29535	1649	10800320999992	6348	3285	1	0	0
38184	1683	476645470999541	6350	3286	1	0	0
78703	1397	1397155849000	6354	3288	2	0	4168
246808	1678	5040154251000	6354	3288	2	0	0
56556	1756	12959769000000	6354	3288	4	0	1
78712	1397	1397095843000	6359	3292	0	0	4174
246817	1678	5040154257000	6359	3292	0	0	0
38191	1683	479525500999541	6359	3292	2	0	0
34227	1677	172803593000000	6362	3294	2	0	0
58425	1871	719000000000	6364	3295	1	0	0
58426	1871	719010000000	6364	3295	2	0	0
78730	1397	1397045838000	6366	3296	0	0	4179
246834	1678	5040154262000	6366	3296	0	0	0
46886	1693	14719331551364	6369	3298	2	0	346
78737	1397	1396985832000	6371	3300	0	0	4185
246841	1678	5040154268000	6371	3300	0	0	0
246845	1678	5040154269000	6373	3301	0	0	0
78746	1397	1396945828000	6376	3302	0	0	4189
16461	1476	13680270000000	6376	3302	1	0	0
16462	1476	13680280000000	6376	3302	2	0	0
78748	1397	1396935827000	6378	3303	0	0	4190
246854	1678	5040154274000	6379	3304	1	0	0
78754	1397	1396895823000	6381	3306	0	0	4194
1061	96	66721210000000	6383	3307	2	0	0
246861	1678	5040154279000	6384	3308	0	0	0
42986	1688	82081423000000	6386	3310	1	0	0
42987	1688	82081433000000	6386	3310	2	0	0
78762	1397	1396835817000	6388	3311	1	0	4200
246869	1678	5040154284000	6390	3312	0	0	0
12521	1439	9360150000000	6390	3312	1	0	0
12522	1439	9360160000000	6390	3312	2	0	0
11232	1419	13680300000000	6391	3313	2	0	0
43880	1690	40320201000000	6394	3314	2	0	0
78778	1397	1396785812000	6401	3316	0	0	4205
246884	1678	5040154290000	6401	3316	2	0	0
45010	1692	3619153000000	6401	3316	3	0	4
78788	1397	1396725806000	6404	3318	2	0	4211
34234	1677	174963613000000	6404	3318	4	0	0
246899	1678	5040154296000	6407	3319	0	0	0
78799	1397	1396665800000	6408	3320	1	0	4217
246904	1678	5040154301000	6408	3320	2	0	0
35657	1679	46800483000000	6408	3320	5	0	0
78804	1726	886990000000	6410	3322	1	0	88
246914	1678	5040154307000	6414	3324	0	0	0
78818	1397	1396585792000	6414	3324	2	0	4225
78933	1726	886930000000	6423	3326	0	0	94
78934	1397	1396555789000	6423	3326	1	0	4228
247011	1678	5040154311000	6423	3326	1	0	0
247013	1678	5040154312000	6425	3327	1	0	0
38204	1683	483845560999541	6425	3327	3	0	0
78962	1397	1396525786000	6430	3328	3	0	4231
20450	1555	9360160000000	6430	3328	5	0	0
48963	1700	10799490000000	6431	3329	2	0	1
48965	1700	10799510000000	6431	3329	3	0	1
78974	1726	886870000000	6436	3331	1	0	100
247030	1678	5040154318000	6439	3332	3	0	0
78983	1397	1396475781000	6439	3332	4	0	4236
78989	1397	1396445778000	6440	3333	4	0	4239
3417	576	77520300000000	6440	3333	6	0	0
3419	576	77520360000000	6440	3333	7	0	0
247036	1678	5040154324000	6441	3334	1	0	0
78999	1726	886780000000	6446	3336	0	0	109
28102	1637	70561824799997	6447	3337	2	0	0
79004	1726	886760000000	6448	3338	1	0	111
31905	1671	18001000000000	6448	3338	2	0	0
247044	1678	5040154329000	6450	3339	1	0	0
79012	1397	1396355769000	6452	3341	2	0	4248
79017	1726	886720000000	6454	3342	1	0	115
28109	1637	72001894799997	6454	3342	3	0	0
79018	1726	886710000000	6456	3344	0	0	116
52461	1715	17280091000000	6456	3344	4	0	0
247052	1678	5040154335000	6457	3345	0	0	0
79024	1726	886690000000	6457	3345	2	0	118
79038	1726	886650000000	6461	3347	0	0	122
40722	1686	5971986500013	6461	3347	4	0	2
247064	1678	5040154341000	6463	3348	0	0	0
79047	1726	886630000000	6463	3348	1	0	124
58217	1850	10065010000000	6463	3348	2	0	0
79056	1726	884220000000	6468	3351	1	0	126
247072	1874	200000000	6468	3351	1	0	0
79064	1397	1396165750000	6473	3355	0	0	4267
247080	1678	5040154350000	6473	3355	0	0	0
79073	1726	882889997000	6477	3357	1	0	130
20123	1549	15120431000000	6477	3357	3	0	0
247090	1678	5040154353000	6478	3358	0	0	0
46930	1693	16159411551364	6478	3358	5	0	346
79085	1397	1396115745000	6482	3359	1	0	4272
247101	1678	5040154355000	6482	3359	1	0	0
34242	1677	177123703000000	6485	3361	2	0	0
79095	1726	882829991000	6487	3362	1	0	136
247111	1874	200009000	6487	3362	1	0	0
79154	1397	1396075741000	6490	3363	0	0	4276
247132	1678	5040154359000	6490	3363	0	0	0
79155	1397	1396065740000	6490	3363	1	0	4277
247133	1678	5040154360000	6490	3363	1	0	0
22560	1587	12960220000000	6491	3364	3	0	0
79161	1397	1396045738000	6492	3365	1	0	4279
247139	1678	5040154362000	6492	3365	1	0	0
38216	1683	488165620999541	6492	3365	3	0	0
79175	1397	1396015735000	6497	3367	3	0	4282
247153	1678	5040154365000	6497	3367	3	0	0
28116	1637	74881934799997	6501	3369	2	0	0
79182	1397	1395985732000	6502	3370	0	0	4285
247160	1678	5040154368000	6502	3370	0	0	0
43005	1688	84241603000000	6505	3372	3	0	0
79190	1397	1395955729000	6506	3373	0	0	4288
247168	1678	5040154371000	6506	3373	0	0	0
38219	1683	489605620999541	6506	3373	4	0	0
38221	1683	489605660999541	6506	3373	5	0	0
79198	1397	1395925726000	6509	3375	0	0	4291
247176	1678	5040154374000	6509	3375	0	0	0
79209	1726	882639972000	6514	3377	1	0	155
247187	1874	200028000	6514	3377	1	0	0
51576	1710	11519290000000	6514	3377	5	0	1
79227	1726	882619970000	6521	3379	1	0	157
247205	1874	200030000	6521	3379	1	0	0
35667	1679	48960603000000	6525	3381	3	0	0
79237	1726	882589967000	6526	3382	1	0	160
247215	1874	200033000	6526	3382	1	0	0
43581	1689	11519231000000	6526	3382	2	0	0
79248	1397	1395815715000	6532	3385	0	0	4302
247226	1678	5040154385000	6532	3385	0	0	0
26103	1613	11518420000000	6534	3386	2	0	2
17402	1508	12240170000000	6537	3387	2	0	0
79260	1397	1395785712000	6539	3388	0	0	4305
247238	1678	5040154388000	6539	3388	0	0	0
11759	1422	8640100000000	6539	3388	2	0	0
79270	1726	882499958000	6544	3391	0	0	169
247248	1874	200042000	6544	3391	0	0	0
247249	1678	5040154391000	6544	3391	1	0	0
247250	1874	200043000	6546	3392	0	0	0
79275	1397	1395735707000	6546	3392	3	0	4310
362	43	77520310000000	6546	3392	7	0	0
247256	1678	5040154395000	6547	3393	0	0	0
79281	1726	882449953000	6548	3394	1	0	174
247266	1678	5040154398000	6553	3396	0	0	0
79289	1726	882429951000	6553	3396	1	0	176
79290	1540	715009000000	6553	3396	2	0	1
15105	1458	18000304908540	6553	3396	3	0	0
48705	1699	6369962500051	6557	3397	2	0	3
247278	1678	5040154400000	6559	3398	0	0	0
79314	1726	882399948000	6567	3400	0	0	179
1893	363	67440030000000	6567	3400	2	0	0
247295	1874	200053000	6568	3401	1	0	0
31164	1668	16560280000000	6568	3401	2	0	0
14157	1451	9360270000000	6571	3402	3	0	0
79324	1397	1395615695000	6572	3403	0	0	4322
247305	1874	200056000	6572	3403	3	0	0
38231	1683	493925740999541	6572	3403	5	0	0
79339	1397	1395595693000	6576	3404	1	0	4324
15375	1467	10081620000000	6577	3405	2	0	0
15377	1467	10081640000000	6577	3405	3	0	0
247329	1540	715009000000	6583	3406	0	0	1
17215	1506	11520240000000	6583	3406	3	0	0
79359	1876	3980000000	6585	3407	0	0	2
247340	1874	200060000	6585	3407	3	0	0
13927	1448	11520351000000	6585	3407	6	0	0
79380	1726	882289937000	6589	3408	1	0	190
247361	1874	200064000	6589	3408	4	0	0
79385	1397	1395535687000	6589	3408	6	0	4330
247366	1874	200066000	6590	3409	0	0	0
79391	1397	1395505684000	6591	3410	1	0	4333
247376	1678	5040154418000	6595	3412	0	0	0
21296	1560	19440540000000	6595	3412	2	0	0
247396	1678	5040154419000	6602	3414	0	0	0
79419	1397	1395465680000	6602	3414	1	0	4337
247397	1678	5040154420000	6602	3414	1	0	0
57023	1762	7919210000000	6602	3414	7	0	0
79424	1397	1395445678000	6603	3415	0	0	4339
79425	1397	1395435677000	6603	3415	1	0	4340
247403	1678	5040154423000	6603	3415	1	0	0
79426	1726	882189927000	6603	3415	2	0	200
38241	1683	498245820999541	6603	3415	5	0	0
18030	1513	9360160000000	6605	3416	3	0	0
247421	1678	5040154426000	6607	3417	1	0	0
79444	1397	1395395673000	6607	3417	2	0	4344
247426	1874	200078000	6607	3417	6	0	0
79450	1726	882119920000	6608	3418	0	0	207
247438	1874	200082000	6616	3420	0	0	0
79461	1397	1395355669000	6616	3420	1	0	4348
247444	1678	5040154434000	6619	3423	0	0	0
79467	1726	882069915000	6619	3423	1	0	212
247453	1678	5040154437000	6623	3425	1	0	0
79477	1726	882039912000	6623	3425	3	0	215
247470	1678	5040154438000	6626	3426	3	0	0
79493	1397	1395275661000	6626	3426	4	0	4356
247476	1678	5040154442000	6631	3427	3	0	0
79499	1726	881989907000	6631	3427	4	0	220
27358	1633	12240140000000	6635	3428	2	0	0
247489	1678	5040154444000	6636	3429	1	0	0
38246	1683	502565860999541	6636	3429	2	0	0
79515	1397	1395215655000	6638	3430	1	0	4362
247497	1874	200098000	6638	3430	5	0	0
79520	1397	1395185652000	6639	3431	0	0	4365
247503	1678	5040154450000	6640	3432	1	0	0
79526	1726	881899898000	6641	3433	0	0	229
34254	1677	179283763000000	6641	3433	4	0	0
247508	1678	5040154453000	6642	3434	0	0	0
79532	1726	881879896000	6642	3434	2	0	231
247514	1678	5040154456000	6644	3436	0	0	0
79537	1726	881849893000	6644	3436	1	0	234
247521	1678	5040154457000	6647	3437	1	0	0
43025	1688	86401663000000	6647	3437	3	0	0
247524	1874	200109000	6649	3438	0	0	0
79549	1397	1395075641000	6649	3438	3	0	4376
54628	1727	9359130000000	6651	3439	3	0	0
247532	1678	5040154461000	6652	3440	0	0	0
79559	1397	1395035637000	6654	3441	1	0	4380
79561	1726	881789887000	6654	3441	3	0	240
79562	1726	881779886000	6654	3441	4	0	241
247540	1874	200114000	6654	3441	4	0	0
14741	1457	15120250000000	6654	3441	6	0	0
247558	1874	200118000	6663	3444	0	0	0
79581	1397	1395005634000	6663	3444	1	0	4383
247572	1678	5040154469000	6668	3446	1	0	0
30524	1656	16560351000000	6668	3446	2	0	0
79599	1397	1394965630000	6670	3447	0	0	4387
79608	1397	1394945628000	6672	3448	1	0	4389
247586	1678	5040154472000	6672	3448	1	0	0
247593	1678	5040154474000	6676	3450	2	0	0
79631	1397	1394915625000	6676	3450	3	0	4392
247604	1726	881649872000	6680	3453	0	0	255
79642	1726	881639871000	6680	3453	1	0	256
79652	1798	160000000	6682	3454	1	0	2
247615	1726	881639870000	6682	3454	1	0	257
26113	1613	12238470000000	6682	3454	4	0	2
247628	1874	200133000	6685	3455	3	0	0
79673	1726	881599866000	6687	3456	0	0	261
247641	1678	5040154485000	6687	3456	5	0	0
79679	1798	158000000	6687	3456	6	0	3
38254	1683	506885920999541	6687	3456	11	0	0
79684	1726	881574863000	6688	3457	0	0	264
247647	1874	200137000	6688	3457	0	0	0
820	58	76800240000000	6688	3457	4	0	0
825	58	76800280000000	6688	3457	5	0	0
79941	1726	881554861000	6692	3458	0	0	266
247874	1874	200139000	6692	3458	0	0	0
79942	1726	881544860000	6692	3458	1	0	267
247875	1874	200140000	6692	3458	1	0	0
21620	1565	720040000000	6692	3458	5	0	0
79948	1397	1394745608000	6694	3460	1	0	4409
247881	1678	5040154492000	6694	3460	1	0	0
52250	1714	18709210000000	6694	3460	7	0	2
79958	1726	881484854000	6696	3461	1	0	273
247891	1874	200146000	6696	3461	1	0	0
79963	1397	1394705604000	6697	3462	2	0	4413
247896	1678	5040154496000	6697	3462	2	0	0
34263	1677	180723863000000	6697	3462	5	0	0
79969	1397	1394685602000	6699	3463	0	0	4415
79970	1726	881454851000	6699	3463	1	0	276
17416	1508	12960190000000	6699	3463	2	0	0
17417	1508	12960210000000	6699	3463	3	0	0
54391	1724	17998910000000	6701	3464	2	0	2
248033	1874	200151000	6703	3465	0	0	0
248034	1874	200152000	6703	3465	1	0	0
80103	1397	1394655599000	6703	3465	3	0	4418
14541	1455	12960171000000	6703	3465	4	0	0
80105	1726	881404846000	6704	3466	1	0	281
80106	1726	881394845000	6704	3466	2	0	282
248040	1678	5040154502000	6704	3466	3	0	0
32373	1673	10080520000000	6704	3466	6	0	0
32376	1673	10080580000000	6704	3466	7	0	0
80112	1397	1394605594000	6707	3468	0	0	4423
248046	1678	5040154507000	6707	3468	1	0	0
80118	1726	881344840000	6708	3469	0	0	287
248051	1874	200160000	6708	3469	0	0	0
24073	1599	12960240000000	6709	3470	2	0	0
24076	1599	12960260000000	6709	3470	3	0	0
80123	1397	1394555589000	6710	3471	1	0	4428
248061	1874	200163000	6713	3472	0	0	0
22788	1588	13680230000000	6714	3473	3	0	0
248067	1874	200165000	6716	3474	0	0	0
80135	1397	1394525586000	6716	3474	1	0	4431
248068	1678	5040154514000	6716	3474	1	0	0
80141	1397	1394495583000	6718	3476	1	0	4434
248074	1678	5040154517000	6718	3476	1	0	0
34269	1677	182883983000000	6718	3476	5	0	0
80146	1726	881244830000	6719	3477	2	0	297
248080	1874	200171000	6719	3477	3	0	0
80170	1726	881204826000	6724	3479	0	0	301
248103	1874	200174000	6724	3479	0	0	0
55937	1747	5039150000000	6724	3479	2	0	0
43047	1688	88561703000000	6726	3480	2	0	0
80178	1726	881174823000	6729	3482	0	0	304
248111	1874	200177000	6729	3482	0	0	0
80189	1726	881144820000	6733	3484	1	0	307
248123	1678	5040154528000	6733	3484	2	0	0
80201	1726	881124818000	6738	3486	1	0	309
248134	1874	200182000	6738	3486	1	0	0
34273	1677	184324043000000	6741	3488	3	0	0
80211	1726	881094815000	6743	3489	1	0	312
248144	1874	200185000	6743	3489	1	0	0
57623	1768	8639201110000	6743	3489	2	0	0
38264	1683	511206045999541	6746	3491	2	0	0
80218	1726	881064812000	6747	3492	0	0	315
248152	1678	5040154537000	6747	3492	1	0	0
80228	1397	1394265560000	6750	3494	0	0	4457
248161	1678	5040154540000	6750	3494	0	0	0
80240	1397	1394235557000	6756	3497	0	0	4460
248173	1678	5040154543000	6756	3497	0	0	0
80241	1726	881004806000	6756	3497	1	0	321
80242	1726	880994805000	6757	3498	0	0	322
248181	1874	200197000	6759	3499	2	0	0
80250	1726	880954801000	6759	3499	4	0	326
248186	1678	5040154548000	6759	3499	7	0	0
248208	1880	200000000	6763	3500	0	0	0
248209	1881	200000000	6763	3500	1	0	0
80277	1397	1394175551000	6763	3500	2	0	4466
576	44	76080480000000	6763	3500	5	0	0
80285	1726	875734799000	6765	3501	2	0	332
248218	1874	200201000	6765	3501	2	0	0
38279	1683	514086125999541	6769	3504	5	0	0
80295	1726	875704796000	6770	3505	0	0	335
248228	1874	200204000	6770	3505	0	0	0
16736	1489	11520221000000	6770	3505	2	0	0
16738	1489	11520241000000	6770	3505	3	0	0
34274	1677	185044043000000	6773	3506	2	0	0
248239	1874	200206000	6776	3507	1	0	0
80307	1726	875674793000	6777	3508	0	0	338
80312	1397	1394075541000	6779	3510	1	0	4476
248245	1678	5040154559000	6779	3510	1	0	0
20137	1549	15840431000000	6779	3510	2	0	0
20139	1549	15840451000000	6779	3510	3	0	0
46969	1693	18319471551364	6781	3511	2	0	346
80320	1726	875624788000	6784	3513	1	0	343
248253	1874	200212000	6784	3513	1	0	0
13573	1447	15840260000000	6786	3514	4	0	0
248262	1678	5040154565000	6788	3515	0	0	0
80330	1726	875594785000	6788	3515	1	0	346
80343	1397	1393985532000	6793	3517	0	0	4485
248276	1678	5040154568000	6793	3517	0	0	0
28129	1637	77042014799997	6797	3519	2	0	0
80353	1726	875544780000	6798	3520	0	0	351
248286	1874	200220000	6798	3520	0	0	0
248291	1874	200223000	6798	3520	5	0	0
80359	1726	874204776000	6799	3521	0	0	356
80371	1726	874184774000	6807	3523	1	0	358
248304	1874	200226000	6807	3523	1	0	0
23158	1593	14400390000000	6808	3524	5	0	0
80384	1397	1393885522000	6811	3525	0	0	4495
80385	1726	874154771000	6811	3525	1	0	361
248318	1874	200229000	6811	3525	1	0	0
52828	1716	16559291000000	6811	3525	2	0	0
43898	1690	42480261000000	6812	3526	2	0	0
248323	1887	200000000	6813	3527	2	0	0
80391	1397	1393865520000	6813	3527	3	0	4497
53999	1723	13680050000000	6813	3527	5	0	0
35677	1679	51120683000000	6816	3528	5	0	0
248337	1678	5040154583000	6817	3529	0	0	0
80405	1726	871504766000	6817	3529	1	0	368
248338	1874	200234000	6817	3529	1	0	0
32774	1675	10080469999977	6818	3530	3	0	0
80412	1726	870184764000	6820	3531	2	0	371
38287	1683	518406305999541	6820	3531	3	0	0
248346	1678	5040154586000	6821	3532	0	0	0
80418	1726	870154761000	6821	3532	5	0	374
248356	1874	200240000	6824	3533	0	0	0
80430	1726	870124758000	6827	3535	1	0	377
248363	1874	200242000	6827	3535	1	0	0
80435	1397	1393735507000	6827	3535	6	0	4510
248369	1678	5040154594000	6827	3535	7	0	0
80460	1726	870064752000	6837	3538	0	0	383
248394	1678	5040154597000	6837	3538	1	0	0
26468	1622	7919099999976	6837	3538	3	0	0
80476	1397	1393665500000	6843	3540	0	0	4517
248409	1678	5040154600000	6843	3540	0	0	0
80493	1726	870004746000	6847	3542	1	0	389
248427	1874	200255000	6847	3542	2	0	0
80514	1397	1393615495000	6851	3543	0	0	4522
80515	1726	869984744000	6851	3543	1	0	391
2654	470	80400361000000	6851	3543	3	0	0
248452	1874	200257000	6853	3544	0	0	0
80524	1397	1393585492000	6854	3545	3	0	4525
248457	1678	5040154608000	6854	3545	3	0	0
852	58	78960380000000	6854	3545	5	0	0
80534	1397	1393575491000	6856	3546	5	0	4526
248467	1678	5040154610000	6856	3546	6	0	0
248478	1678	5040154613000	6858	3547	0	0	0
80548	1726	869904736000	6858	3547	1	0	399
248479	1874	200264000	6858	3547	1	0	0
80558	1726	869874733000	6862	3549	3	0	402
248489	1874	200267000	6862	3549	3	0	0
43078	1688	90721753000000	6863	3550	3	0	0
80564	1726	868554731000	6864	3551	3	0	405
248495	1890	200000000	6864	3551	3	0	0
32781	1675	10800469999977	6864	3551	5	0	0
32783	1675	10800609999977	6864	3551	6	0	0
38294	1683	522726385999541	6867	3552	2	0	0
80574	1726	868514727000	6868	3553	1	0	409
248505	1874	200273000	6868	3553	1	0	0
80586	1726	868494725000	6872	3554	1	0	411
248517	1874	200275000	6872	3554	1	0	0
50045	1704	2879110000000	6872	3554	3	0	0
80740	1397	1393395473000	6883	3557	0	0	4544
248671	1678	5040154627000	6883	3557	0	0	0
80741	1726	868464722000	6883	3557	1	0	414
248672	1874	200278000	6883	3557	1	0	0
80761	1397	1393365470000	6890	3559	0	0	4547
248692	1678	5040154630000	6890	3559	0	0	0
38300	1683	525606455999541	6890	3559	4	0	0
80767	1726	868414717000	6892	3561	1	0	419
248698	1874	200283000	6892	3561	1	0	0
80776	1397	1393325466000	6895	3562	2	0	4551
248707	1678	5040154634000	6895	3562	2	0	0
80786	1397	1393285462000	6901	3565	0	0	4555
248717	1678	5040154638000	6901	3565	0	0	0
80787	1726	868354711000	6901	3565	1	0	425
45040	1692	5779253000000	6901	3565	3	0	4
35686	1679	53280783000000	6903	3566	2	0	0
248725	1874	200292000	6904	3567	2	0	0
80795	1397	1393255459000	6904	3567	3	0	4558
10516	1402	48961271000000	6905	3568	2	0	0
248732	1678	5040154643000	6907	3569	1	0	0
5328	1271	1339086070000000	6907	3569	2	0	0
80810	1726	868294705000	6912	3570	1	0	431
2089	369	82560370000000	6912	3570	2	0	0
248755	1874	200297000	6920	3572	0	0	0
248756	1678	5040154646000	6920	3572	1	0	0
57327	1764	13680268000000	6920	3572	3	0	2
80830	1397	1393195453000	6922	3573	0	0	4564
248768	1678	5040154649000	6924	3574	1	0	0
38306	1683	529926515999541	6924	3574	3	0	0
80838	1397	1393165450000	6925	3575	0	0	4567
47879	1696	12238371000000	6925	3575	2	0	1
47880	1696	12238391000000	6925	3575	3	0	1
248783	1874	200304000	6931	3577	1	0	0
80853	1397	1393145448000	6931	3577	2	0	4569
11271	1419	15840360000000	6934	3578	2	0	0
248788	1874	200306000	6937	3579	0	0	0
80858	1726	868174693000	6937	3579	1	0	443
28140	1637	78482094799997	6938	3580	3	0	0
248794	1678	5040154658000	6939	3581	0	0	0
80864	1726	868154691000	6939	3581	1	0	445
34280	1677	186484163000000	6940	3582	2	0	0
248803	1874	200312000	6945	3584	0	0	0
80873	1726	868114687000	6945	3584	1	0	449
248811	1891	200000000	6947	3585	1	0	0
80881	1397	1393035437000	6947	3585	2	0	4580
80979	1397	1392985432000	6955	3588	0	0	4585
248910	1678	5040154668000	6955	3588	0	0	0
80980	1726	866794685000	6955	3588	1	0	452
248911	1874	200315000	6955	3588	1	0	0
80986	1397	1392975431000	6956	3589	1	0	4586
248917	1678	5040154669000	6956	3589	1	0	0
31563	1670	18000580000000	6962	3591	3	0	0
81001	1397	1392945428000	6964	3592	1	0	4589
248932	1678	5040154672000	6964	3592	1	0	0
5018	641	82560620000000	6964	3592	2	0	0
81008	1397	1392915425000	6968	3595	0	0	4592
248939	1678	5040154675000	6968	3595	0	0	0
81014	1397	1392885422000	6970	3597	3	0	4595
248945	1678	5040154678000	6970	3597	3	0	0
81020	1397	1392855419000	6971	3598	0	0	4598
248951	1678	5040154681000	6971	3598	0	0	0
81036	1726	866604666000	6978	3600	1	0	471
248967	1874	200334000	6978	3600	1	0	0
81044	1726	866574663000	6981	3602	3	0	474
248975	1874	200337000	6981	3602	3	0	0
25074	1607	18000422000000	6983	3603	2	0	0
81054	1726	866544660000	6984	3604	3	0	477
248985	1874	200340000	6984	3604	3	0	0
51612	1710	13679360000000	6984	3604	5	0	1
81057	1397	1392755409000	6986	3606	0	0	4608
81058	1726	866524658000	6986	3606	1	0	479
248990	1874	200343000	6987	3607	0	0	0
38314	1683	534246555999541	6987	3607	3	0	0
81066	1397	1392725406000	6990	3609	1	0	4611
248998	1874	200346000	6990	3609	2	0	0
249022	1874	200347000	6994	3610	0	0	0
249023	1718	200000000	6994	3610	1	0	0
81094	1726	865164652000	6994	3610	3	0	486
249029	1874	200349000	6994	3610	7	0	0
81099	1726	865144650000	6994	3610	8	0	488
29402	1644	1440200000000	6994	3610	10	0	0
90	42	76797860000000	6996	3611	2	0	4
249037	1678	5040154702000	6999	3613	0	0	0
81107	1726	865114647000	6999	3613	1	0	491
18296	1518	2160040000000	7007	3614	3	0	0
249053	1678	5040154705000	7009	3615	1	0	0
81124	1726	865084644000	7009	3615	3	0	494
249073	1874	200358000	7015	3617	0	0	0
81143	1397	1392595393000	7015	3617	1	0	4624
249083	1678	5040154710000	7018	3619	0	0	0
81153	1726	865034639000	7018	3619	1	0	499
47404	1694	29519605000000	7018	3619	5	0	1
249096	1678	5040154713000	7021	3620	1	0	0
81167	1726	865004636000	7021	3620	3	0	502
25251	1608	10800270000000	7021	3620	4	0	0
249108	1874	200366000	7023	3621	3	0	0
81178	1726	864974633000	7023	3621	4	0	505
249118	1874	200369000	7025	3622	3	0	0
47698	1695	14399351000000	7025	3622	4	0	1
81194	1726	864944630000	7028	3623	0	0	508
81195	1397	1392475381000	7028	3623	1	0	4636
249129	1874	200371000	7029	3624	2	0	0
43103	1688	92881833000000	7029	3624	5	0	0
81205	1726	864914627000	7031	3625	1	0	511
23526	1594	10800290000000	7031	3625	2	0	0
23529	1594	10800310000000	7031	3625	3	0	0
249139	1678	5040154723000	7032	3626	2	0	0
34293	1677	189364243000000	7032	3626	4	0	0
81211	1397	1392415375000	7033	3627	1	0	4642
38320	1683	538566615999541	7034	3628	2	0	0
249145	1678	5040154727000	7035	3629	0	0	0
81216	1726	864854621000	7035	3629	2	0	517
249150	1874	200380000	7036	3630	1	0	0
32400	1673	12240700000000	7036	3630	3	0	0
81222	1397	1392355369000	7038	3632	0	0	4648
249153	1678	5040154731000	7038	3632	0	0	0
249154	1874	200382000	7038	3632	1	0	0
14548	1455	15120251000000	7038	3632	2	0	0
22269	1573	15120550000000	7041	3633	2	0	0
81232	1397	1392325366000	7042	3634	2	0	4651
249164	1874	200384000	7042	3634	4	0	0
10543	1402	50401551000000	7042	3634	7	0	0
81241	1397	1392315365000	7044	3635	2	0	4652
249174	1874	200388000	7045	3636	0	0	0
886	58	81120440000000	7045	3636	3	0	0
81247	1726	863454611000	7046	3637	2	0	528
249179	1874	200390000	7046	3637	3	0	0
1189	149	73200140000000	7050	3639	2	0	0
81265	1397	1392245358000	7053	3640	0	0	4659
249197	1874	200393000	7053	3640	1	0	0
28150	1637	80642154799997	7053	3640	3	0	0
81274	1726	863394605000	7055	3641	3	0	534
249207	1874	200396000	7056	3642	1	0	0
46991	1693	20479521551364	7056	3642	2	0	346
81282	1397	1392195353000	7059	3644	1	0	4664
55411	1740	16557923000000	7059	3644	3	0	3
249214	1678	5040154748000	7060	3645	0	0	0
81288	1397	1392165350000	7062	3646	1	0	4667
249224	1874	200402000	7065	3647	0	0	0
81378	1726	863304596000	7071	3649	0	0	543
249309	1874	200404000	7071	3649	0	0	0
81379	1726	862004596000	7071	3649	1	0	544
249310	1893	200000000	7071	3649	1	0	0
43910	1690	44640341000000	7071	3649	6	0	0
81389	1693	20479431551364	7076	3652	0	0	347
249320	327	66000100000000	7076	3652	0	0	0
81395	1726	860634589000	7076	3652	6	0	552
249326	1874	200411000	7076	3652	6	0	0
81400	1397	1392065340000	7076	3652	11	0	4677
249331	1678	5040154760000	7076	3652	11	0	0
81541	1726	860624588000	7080	3653	0	0	553
249472	1874	200412000	7080	3653	0	0	0
81542	1397	1392045338000	7080	3653	1	0	4679
249473	1678	5040154762000	7080	3653	1	0	0
43915	1690	46080631000000	7080	3653	5	0	0
81548	1397	1392015335000	7081	3654	3	0	4682
249479	1678	5040154765000	7081	3654	3	0	0
26776	1623	23041560899898	7081	3654	4	0	0
81562	1397	1391985332000	7085	3656	1	0	4685
249493	1678	5040154768000	7085	3656	1	0	0
81569	1397	1391955329000	7089	3659	0	0	4688
249500	1678	5040154771000	7089	3659	0	0	0
45075	1692	7939333000000	7090	3660	3	0	4
48380	1698	17279321000000	7091	3661	1	0	1
81578	1726	860504576000	7093	3662	1	0	565
249509	1874	200424000	7093	3662	1	0	0
81593	1726	860474573000	7101	3665	0	0	568
249524	1874	200427000	7101	3665	0	0	0
34305	1677	190804323000000	7103	3666	3	0	0
81599	1726	860444570000	7104	3667	1	0	571
249530	1874	200430000	7104	3667	1	0	0
81603	1397	1391865320000	7106	3668	0	0	4697
81604	1726	860434569000	7106	3668	1	0	572
249542	1874	200433000	7109	3670	0	0	0
81614	1397	1391835317000	7109	3670	3	0	4700
249548	1678	5040154784000	7110	3671	2	0	0
81624	1397	1391795313000	7112	3672	1	0	4704
249557	1874	200438000	7112	3672	3	0	0
36419	1681	21599455195920	7112	3672	4	0	1
81629	1726	860334559000	7113	3673	2	0	582
249561	1678	5040154788000	7113	3673	3	0	0
249562	1678	5040154789000	7113	3673	4	0	0
81635	1397	1391755309000	7114	3674	2	0	4708
249568	1874	200444000	7115	3675	1	0	0
81641	1397	1391715305000	7116	3676	1	0	4712
249574	1874	200446000	7116	3676	3	0	0
81657	1726	858954551000	7118	3677	2	0	591
249590	1678	5040154796000	7118	3677	4	0	0
81663	1726	858934549000	7118	3677	8	0	593
249596	154	66000100000000	7118	3677	10	0	0
57650	1768	10079351110000	7118	3677	12	0	0
81671	1397	1391635297000	7121	3679	1	0	4720
249604	1896	200000000	7121	3679	3	0	0
81682	1726	857584544000	7123	3680	1	0	599
249615	1678	5040154805000	7123	3680	3	0	0
51366	1709	12237371000000	7123	3680	7	0	4
81690	1726	857564542000	7125	3681	1	0	601
249623	1874	200459000	7126	3682	1	0	0
81696	1726	857534539000	7128	3684	1	0	604
249631	1874	200462000	7130	3685	1	0	0
81708	1397	1391535287000	7134	3687	0	0	4730
249641	1874	200465000	7134	3687	2	0	0
3458	576	79680440000000	7138	3688	3	0	0
81721	1726	857454531000	7141	3690	0	0	612
249657	1874	200470000	7143	3691	1	0	0
28154	1637	82082174799997	7143	3691	3	0	0
28156	1637	82082204799997	7143	3691	4	0	0
23841	1596	12849160000000	7144	3692	1	0	1
81734	1726	856114527000	7149	3694	0	0	617
5040	641	83280640000000	7149	3694	2	0	0
81861	1726	856094525000	7151	3695	0	0	619
249792	1874	200475000	7151	3695	0	0	0
81862	1726	856084524000	7151	3695	1	0	620
249793	1874	200476000	7151	3695	1	0	0
81879	1522	11519970000000	7160	3698	0	0	1
81880	1726	856044520000	7160	3698	1	0	624
249812	1874	200481000	7160	3698	2	0	0
38333	1683	542886695999541	7163	3700	1	0	0
4632	633	79679370000000	7168	3702	2	0	1
81894	1726	855984514000	7171	3703	0	0	630
249826	1874	200487000	7172	3704	0	0	0
39807	1685	50400190000000	7172	3704	6	0	0
81900	1726	855934509000	7173	3705	0	0	635
249831	1874	200491000	7173	3705	0	0	0
249835	1874	200493000	7175	3706	0	0	0
249836	1874	200494000	7175	3706	1	0	0
25081	1607	20160472000000	7175	3706	3	0	0
81908	1726	855884504000	7177	3707	0	0	640
249845	1874	200500000	7183	3711	0	0	0
53541	1719	11519250000000	7184	3712	2	0	0
81916	1726	855824498000	7185	3713	0	0	646
18628	1522	12239970000000	7185	3713	1	0	1
43121	1688	94321843000000	7186	3714	1	0	0
43122	1688	94321853000000	7186	3714	2	0	0
38339	1683	547206725999541	7187	3715	1	0	0
12861	1440	12240410000000	7189	3716	1	0	0
249852	1874	200506000	7190	3717	0	0	0
81923	1726	855764492000	7191	3718	1	0	652
34317	1677	192964403000000	7194	3719	3	0	0
249861	1874	200511000	7195	3720	0	0	0
81932	1726	855714487000	7196	3721	0	0	657
249881	1874	200517000	7205	3723	1	0	0
81952	1726	855654481000	7207	3725	0	0	663
249888	1874	200523000	7210	3727	0	0	0
43590	1689	12959301000000	7211	3728	2	0	0
81960	1726	855594475000	7213	3729	0	0	669
47005	1693	22639351551364	7213	3729	1	0	348
249897	1874	200528000	7216	3731	1	0	0
11789	1422	10800170000000	7216	3731	3	0	0
81968	1726	855544470000	7217	3732	0	0	674
249911	1874	200533000	7226	3735	0	0	0
81983	1726	855494465000	7229	3737	0	0	679
82101	1726	855484464000	7232	3738	0	0	680
250032	1874	200536000	7232	3738	0	0	0
82102	1726	855474463000	7232	3738	1	0	681
250033	1874	200537000	7232	3738	1	0	0
920	58	83280470000000	7235	3740	2	0	0
18038	1513	11520350000000	7239	3741	1	0	0
82117	1726	855414457000	7244	3744	0	0	687
250048	1874	200543000	7244	3744	0	0	0
56281	1749	11515228000000	7244	3744	3	0	3
82123	1726	855354451000	7247	3747	0	0	693
250054	1874	200549000	7247	3747	0	0	0
34330	1677	195124533000000	7252	3750	1	0	0
82132	1726	855304446000	7254	3751	0	0	698
250063	1874	200554000	7254	3751	0	0	0
82263	1726	855254441000	7261	3756	0	0	703
250194	1874	200559000	7261	3756	0	0	0
82264	1726	855244440000	7261	3756	1	0	704
250195	1874	200560000	7261	3756	1	0	0
10573	1402	52561601000000	7261	3756	3	0	0
31922	1671	19441060000000	7271	3759	3	0	0
82278	1726	855184434000	7273	3760	0	0	710
250209	1874	200566000	7273	3760	0	0	0
34340	1677	196564573000000	7274	3761	3	0	0
82286	1726	855154431000	7281	3763	0	0	713
82287	1726	855144430000	7281	3763	1	0	714
35694	1679	55440863000000	7283	3764	1	0	0
250221	1874	200572000	7284	3765	0	0	0
38354	1683	550086765999541	7284	3765	3	0	0
82295	1726	855084424000	7287	3767	1	0	720
250230	1874	200577000	7290	3768	0	0	0
38355	1683	551526765999541	7294	3770	2	0	0
82309	1726	855024418000	7298	3771	1	0	726
250241	1874	200583000	7298	3771	2	0	0
250245	1874	200584000	7301	3772	0	0	0
82322	1726	854974413000	7303	3773	2	0	731
45108	1692	10099363000000	7305	3774	0	0	4
250259	1874	200590000	7307	3775	0	0	0
47411	1694	31679655000000	7308	3776	2	0	1
82331	1726	854914407000	7309	3777	0	0	737
250265	1874	200596000	7310	3778	1	0	0
82337	1726	854864402000	7310	3778	3	0	742
5277	700	71760250000000	7310	3778	5	0	0
250276	1874	200601000	7316	3781	0	0	0
82349	1726	854814397000	7317	3782	0	0	747
250286	1874	200607000	7321	3784	0	0	0
82361	1726	854754391000	7325	3786	0	0	753
39820	1685	53280220000000	7325	3786	1	0	0
25856	1611	11520210000000	7327	3787	2	0	0
28163	1637	84242234799997	7332	3789	2	0	0
250298	1874	200613000	7334	3790	0	0	0
58259	1850	12225070000000	7334	3790	1	0	0
82376	1643	2011330092700	7336	3791	1	0	7
250308	1874	200614000	7336	3791	4	0	0
82386	1726	854684384000	7338	3792	2	0	760
38363	1683	554406835999541	7338	3792	5	0	0
82520	1726	854654381000	7342	3794	0	0	763
250447	1874	200619000	7342	3794	0	0	0
82521	1726	854644380000	7342	3794	1	0	764
250448	1874	200620000	7342	3794	1	0	0
82528	1693	23102159534670	7346	3797	2	0	350
250455	150	66282077824773	7346	3797	2	0	0
32148	1672	13680321000000	7346	3797	7	0	0
82541	1693	22587735501282	7348	3798	1	0	354
250467	322	66282077824773	7348	3798	2	0	0
82546	1693	21944705459547	7348	3798	6	0	359
250472	91	66282077824773	7348	3798	7	0	0
82558	1693	21430281426159	7350	3799	0	0	363
82559	1693	21301675417812	7350	3799	1	0	364
250486	1874	200626000	7350	3799	3	0	0
82565	1693	20658645376077	7350	3799	7	0	369
250500	383	66282077824773	7352	3800	1	0	0
82579	1693	18832516178210	7352	3800	5	0	375
250505	678	66282077824773	7352	3800	6	0	0
12098	1426	9360360000000	7352	3800	9	0	0
250572	731	2008547812829	7355	3801	0	0	0
250573	1874	200628000	7355	3801	1	0	0
82650	1693	18571397312794	7355	3801	2	0	378
250579	105	66282077824773	7355	3801	7	0	0
82656	1693	17799761262712	7355	3801	8	0	384
250594	304	66282077824773	7357	3802	4	0	0
82671	1693	17410036388949	7357	3802	5	0	388
250599	878	203450976855173	7357	3802	9	0	2
82676	1693	13061095172553	7357	3802	10	0	393
250605	205	66282077824773	7357	3802	15	0	0
82682	1693	12405006532842	7357	3802	16	0	399
50952	1708	10079470000000	7357	3802	19	0	0
82711	1726	854534369000	7360	3803	0	0	775
82712	1693	12387450713546	7360	3803	1	0	401
250638	146	66282077824773	7360	3803	3	0	0
82718	1693	10764834116150	7360	3803	7	0	407
250643	611	66282077824773	7360	3803	8	0	0
250677	225	66282077824773	7365	3804	0	0	0
250678	377	66282077824773	7365	3804	1	0	0
82757	1726	854524368000	7365	3804	4	0	776
250684	894	308134249033327	7365	3804	7	0	0
20855	1559	17280330000000	7365	3804	8	0	0
82776	1693	9138154801690	7368	3805	1	0	416
250704	127	66130067824773	7368	3805	5	0	1
82796	1693	8457705012081	7371	3806	0	0	422
250723	1030	904824004033700	7371	3806	3	0	0
3908	606	77520250000000	7371	3806	7	0	1
82802	1740	16557888000000	7372	3807	0	0	5
250729	710	5021369532156	7372	3807	4	0	0
82807	1693	6158631818414	7372	3807	5	0	429
250735	421	66282077824773	7372	3807	10	0	0
82813	1693	5386995768332	7372	3807	11	0	435
250740	266	66282077824773	7372	3807	15	0	0
82819	1693	4615359718250	7372	3807	17	0	441
250746	112	66131057824773	7372	3807	21	0	2
82824	1693	3503104437178	7372	3807	22	0	446
82825	1693	3439657636593	7372	3807	23	0	447
82826	1693	3311051628246	7372	3807	24	0	448
250752	201	66282077824773	7372	3807	27	0	0
82861	1726	854474363000	7374	3808	0	0	781
19094	1536	16560390000000	7374	3808	1	0	0
250786	1874	200638000	7377	3809	0	0	0
250789	1874	200639000	7380	3810	0	0	0
82873	1726	854414357000	7385	3813	1	0	787
250797	1874	200645000	7386	3814	1	0	0
82879	1693	2668021586511	7389	3816	1	0	453
250804	163	66282077824773	7390	3817	1	0	0
82885	1693	2153597553123	7390	3817	4	0	457
50690	1706	14396432000000	7392	3818	2	0	6
250815	1874	200651000	7394	3819	0	0	0
38375	1683	558726895999541	7396	3820	3	0	0
82900	1726	854304346000	7398	3821	0	0	798
16484	1476	15840320000000	7399	3822	2	0	0
250824	1874	200656000	7400	3823	0	0	0
82905	1726	851674343000	7400	3823	3	0	803
250830	1874	200660000	7400	3823	6	0	0
82914	1623	24481650899898	7403	3825	0	0	1
250838	1874	200664000	7403	3825	2	0	0
21331	1560	21600580000000	7403	3825	3	0	0
28170	1637	86402264799997	7407	3828	2	0	0
82921	1726	851564332000	7408	3829	0	0	814
250845	1903	98000000000	7408	3829	2	0	0
34360	1677	198724643000000	7408	3829	4	0	0
30098	1654	12960240000000	7409	3830	2	0	0
82929	1726	851524328000	7412	3831	0	0	818
250864	1874	200674000	7419	3833	1	0	0
39437	1684	29519740000000	7419	3833	3	0	0
39442	1684	29519761000000	7419	3833	4	0	0
82945	1726	851484324000	7421	3834	1	0	822
17241	1506	13680300000000	7421	3834	2	0	0
250869	1874	200678000	7423	3836	0	0	0
83076	1726	851454321000	7426	3837	0	0	825
250996	1874	200679000	7426	3837	0	0	0
83077	1726	851444320000	7426	3837	1	0	826
250997	1874	200680000	7426	3837	1	0	0
23537	1594	11520310000000	7427	3838	2	0	0
2709	470	82560401000000	7430	3839	2	0	0
52844	1716	18719351000000	7433	3840	1	0	0
83089	1726	851384314000	7434	3841	0	0	832
251009	1874	200686000	7434	3841	0	0	0
56565	1756	15119819000000	7435	3842	2	0	1
36138	1680	18719400000000	7439	3845	1	0	0
83097	1522	12239960000000	7441	3846	0	0	2
251017	1898	10000000	7441	3846	0	0	0
83098	1726	851324308000	7441	3846	1	0	838
13375	1445	12240230000000	7445	3848	1	0	0
251024	1874	200696000	7447	3850	0	0	0
83106	1726	851264302000	7449	3852	0	0	844
17813	1509	16560431000000	7449	3852	3	0	0
51408	1709	14397401000000	7450	3853	2	0	4
51409	1709	14397421000000	7450	3853	3	0	4
251032	1874	200702000	7452	3854	0	0	0
83114	1522	12239940000000	7453	3855	0	0	3
49307	1701	12958362000000	7453	3855	4	0	4
251040	1874	200707000	7457	3857	0	0	0
83122	1726	851164292000	7459	3858	0	0	854
34368	1677	200884693000000	7462	3859	4	0	0
251052	1874	200712000	7463	3860	0	0	0
28178	1637	88562294799997	7463	3860	1	0	0
46232	1693	2873607553123	7464	3861	2	0	457
83134	1726	851104286000	7465	3862	0	0	860
251059	1874	200716000	7470	3864	0	0	0
251060	1874	200717000	7470	3864	1	0	0
83165	1726	851044280000	7474	3866	1	0	866
38384	1683	563046925999541	7474	3866	2	0	0
45172	1692	12979393000000	7478	3867	2	0	4
251093	1874	200722000	7479	3868	0	0	0
83176	1726	851004276000	7481	3870	1	0	870
12884	1440	13680450000000	7486	3872	2	0	0
251106	1874	200727000	7487	3873	0	0	0
83195	1726	850954271000	7491	3874	0	0	875
41054	1687	5124993726450	7491	3874	1	0	4
251118	1874	200731000	7494	3876	1	0	0
26786	1623	25201650899898	7494	3876	2	0	1
10602	1402	54721731000000	7495	3877	2	0	0
83202	1900	69000000	7496	3878	0	0	4
583	44	78240830000000	7496	3878	2	0	0
251124	1874	200736000	7498	3880	0	0	0
83207	1726	850864262000	7498	3880	2	0	884
38394	1683	567366986999541	7498	3880	3	0	0
251132	1874	200742000	7503	3883	1	0	0
83217	1726	850804256000	7505	3884	1	0	890
251139	1874	200746000	7507	3886	0	0	0
83346	1726	850764252000	7512	3888	0	0	894
251265	1874	200748000	7512	3888	0	0	0
83347	1726	850754251000	7512	3888	1	0	895
251266	1874	200749000	7512	3888	1	0	0
34381	1677	203044738000000	7514	3889	1	0	0
83357	1726	850714247000	7517	3892	0	0	899
251276	1874	200753000	7517	3892	0	0	0
50314	1705	14395250000000	7520	3893	3	0	2
83369	1726	850664242000	7523	3895	0	0	904
83370	1726	850654241000	7524	3896	0	0	905
251289	1874	200759000	7524	3896	0	0	0
43143	1688	96481893000000	7524	3896	2	0	0
83626	1726	850624238000	7531	3898	0	0	908
251541	1874	200762000	7531	3898	0	0	0
83627	1900	68000000	7531	3898	1	0	5
251542	1874	200763000	7532	3899	0	0	0
10610	1402	55441751000000	7535	3900	2	0	0
10611	1402	55441762000000	7535	3900	3	0	0
54830	1729	12239220000000	7538	3902	1	0	0
83642	1726	850574233000	7540	3903	0	0	913
83644	1726	850564232000	7542	3904	0	0	914
38402	1683	571687037999541	7542	3904	1	0	0
251556	1874	200769000	7543	3905	0	0	0
53043	1717	12239292000000	7543	3905	3	0	0
43927	1690	48240661000000	7546	3906	2	0	0
11300	1419	17280390000000	7547	3907	2	0	0
11301	1419	17280410000000	7547	3907	3	0	0
83654	1726	850504226000	7548	3908	0	0	920
29567	1649	12960530999992	7548	3908	1	0	0
251566	1874	200775000	7549	3909	0	0	0
38409	1683	574567077999541	7552	3911	3	0	0
83664	1726	850444220000	7557	3913	0	0	926
251575	1874	200780000	7557	3913	0	0	0
28185	1637	90722334799997	7558	3914	1	0	0
22278	1573	17280660000000	7561	3915	1	0	0
39831	1685	55440270000000	7564	3916	1	0	0
83675	1726	850394215000	7568	3918	0	0	931
251592	1874	200786000	7574	3919	0	0	0
43929	1690	48960661000000	7577	3920	1	0	0
43931	1690	48960671000000	7577	3920	2	0	0
251651	1874	200788000	7582	3921	0	0	0
251652	1874	200789000	7583	3922	0	0	0
83747	1726	850334209000	7585	3924	0	0	937
35703	1679	57600953000000	7585	3924	4	0	0
251664	1874	200795000	7589	3925	0	0	0
83763	1726	850284204000	7593	3927	0	0	942
251674	1874	200800000	7593	3927	4	0	0
83768	1726	848944200000	7593	3927	5	0	947
16771	1489	13680531000000	7593	3927	8	0	0
83777	1726	847634199000	7595	3928	0	0	949
53049	1717	12959292000000	7595	3928	1	0	0
83779	1726	847624198000	7597	3929	0	0	950
251742	1874	200803000	7599	3930	0	0	0
251743	1874	200804000	7600	3931	0	0	0
83842	1726	847574193000	7601	3932	2	0	955
251749	1874	200808000	7601	3932	4	0	0
19334	1543	720010000000	7603	3934	2	0	0
24797	1602	12240370000000	7604	3935	2	0	0
83848	1726	846224188000	7605	3936	0	0	961
12106	1426	10080360000000	7608	3937	1	0	0
12107	1426	10080370000000	7608	3937	2	0	0
251756	1908	0	7610	3938	0	0	0
83860	1726	846184184000	7613	3939	2	0	965
251772	1874	200818000	7616	3940	1	0	0
34387	1677	205204768000000	7616	3940	2	0	0
83875	1699	1653829000078	7622	3943	2	0	4
251782	1874	200823000	7623	3944	1	0	0
38425	1683	578887297999541	7623	3944	5	0	0
83889	1726	846074173000	7626	3945	1	0	976
25633	1610	15840510000000	7626	3945	3	0	0
251798	1874	200829000	7629	3946	1	0	0
83896	1726	846034169000	7629	3946	4	0	980
251803	1874	200833000	7630	3947	0	0	0
44818	1691	9359150000000	7630	3947	2	0	0
40750	1686	7412066500013	7631	3948	2	0	2
83902	1726	845974163000	7633	3950	0	0	986
43164	1688	98641973000000	7634	3951	2	0	0
251809	1874	200839000	7635	3952	0	0	0
83911	1480	715960000000	7640	3954	2	0	4
83913	1773	5978570270530	7640	3954	4	0	14
251818	702	44205235731806	7640	3954	4	0	0
83914	1773	5167398127791	7640	3954	5	0	15
251885	1874	200843000	7645	3955	0	0	0
251886	1874	200844000	7646	3956	0	0	0
83982	1726	845894155000	7646	3956	1	0	994
25270	1608	12240340000000	7646	3956	3	0	0
251902	1874	200850000	7652	3960	1	0	0
83998	1480	714950000000	7652	3960	2	0	5
25095	1607	22320562000000	7652	3960	3	0	0
27644	1634	15840289899999	7653	3961	3	0	0
84005	1726	845794145000	7656	3963	0	0	1004
251910	1874	200855000	7656	3963	0	0	0
251920	1874	200859000	7664	3967	2	0	0
84016	1726	845744140000	7664	3967	3	0	1009
251932	1874	200862000	7669	3969	1	0	0
26120	1613	12958470000000	7669	3969	2	0	2
84029	1726	845714137000	7671	3970	0	0	1012
38433	1683	583207357999541	7671	3970	2	0	0
84034	1480	712930000000	7674	3973	2	0	7
251939	1913	0	7674	3973	2	0	0
50321	1705	15115280000000	7674	3973	5	0	2
50322	1705	15115330000000	7674	3973	6	0	2
251949	1874	200869000	7677	3975	3	0	0
84045	1726	845644130000	7677	3975	4	0	1019
84050	1726	845614127000	7683	3979	0	0	1022
84051	1726	845604126000	7683	3979	1	0	1023
251957	1874	200875000	7683	3979	2	0	0
30777	1657	10800200000000	7687	3982	2	0	0
84061	1726	845544120000	7689	3983	0	0	1029
251967	1874	200881000	7689	3983	1	0	0
34781	1678	7200194813000	7689	3983	3	0	0
58286	1850	14385190000000	7691	3985	0	0	0
84068	1726	845494115000	7693	3986	2	0	1034
251973	1874	200885000	7693	3986	2	0	0
1587	171	78240190000000	7695	3987	1	0	0
22285	1573	18720700000000	7697	3988	2	0	0
19543	1546	14400250000000	7701	3990	1	0	0
84078	1726	845444110000	7703	3991	0	0	1039
251986	1874	200891000	7706	3992	0	0	0
28196	1637	92882364799997	7709	3993	2	0	0
15412	1467	12241700000000	7713	3995	1	0	0
84093	1726	845384104000	7714	3996	0	0	1045
252000	1874	200897000	7716	3997	0	0	0
35711	1679	59041013000000	7722	3999	2	0	0
252009	1874	200901000	7724	4000	1	0	0
45226	1692	15139553000000	7724	4000	2	0	4
84105	1726	845324098000	7725	4001	0	0	1051
252010	1874	200902000	7725	4001	0	0	0
84110	1726	843984094000	7729	4004	1	0	1056
252016	1874	200907000	7729	4004	2	0	0
84117	1726	843924088000	7733	4007	2	0	1062
252024	1874	200913000	7735	4008	0	0	0
41082	1687	5845023726450	7738	4010	3	0	4
84143	1726	843864082000	7741	4012	0	0	1068
252048	1874	200918000	7741	4012	0	0	0
38449	1683	587527377999541	7744	4014	0	0	0
84153	1726	843814077000	7749	4017	0	0	1073
28204	1637	94322404799997	7749	4017	2	0	0
252059	1874	200924000	7750	4018	0	0	0
119	42	78957930000000	7750	4018	2	0	4
49613	1702	8634141000000	7754	4019	2	0	2
84163	1726	843754071000	7758	4022	0	0	1079
34393	1677	208084798000000	7761	4023	0	0	0
252072	1874	200930000	7762	4024	0	0	0
14168	1451	10080270000000	7764	4025	1	0	0
84174	1726	843694065000	7767	4027	1	0	1085
252079	1874	200935000	7767	4027	1	0	0
43185	1688	100801993000000	7768	4028	3	0	0
84179	1726	843644060000	7769	4029	0	0	1090
45251	1692	16579613000000	7769	4029	2	0	4
252085	1874	200941000	7770	4030	0	0	0
84186	1726	843614057000	7776	4032	0	0	1093
84188	1726	843604056000	7778	4033	0	0	1094
15757	1471	15120360000000	7783	4035	1	0	0
252100	1874	200947000	7785	4036	0	0	0
39841	1685	56880310000000	7785	4036	3	0	0
84198	1726	843544050000	7786	4037	1	0	1100
46391	1693	5033657553123	7786	4037	4	0	457
252105	1874	200951000	7787	4038	0	0	0
13973	1448	13680621000000	7789	4039	4	0	0
84205	1726	840914047000	7790	4040	0	0	1105
48516	1699	2373829000078	7790	4040	1	0	4
252116	1874	200955000	7796	4042	0	0	0
51650	1710	15839380000000	7796	4042	1	0	1
84215	1726	840864042000	7799	4044	1	0	1110
13625	1447	19440490000000	7801	4045	2	0	0
252125	1874	200961000	7804	4047	0	0	0
50719	1706	16556452000000	7804	4047	1	0	6
84229	1726	840804036000	7811	4049	1	0	1116
252137	1874	200966000	7814	4051	0	0	0
20176	1549	18720471000000	7814	4051	1	0	0
252145	1874	200968000	7820	4054	0	0	0
252146	1874	200969000	7820	4054	1	0	0
84242	1726	840744030000	7820	4054	2	0	1122
13258	1444	17280600000000	7820	4054	5	0	0
595	44	79680880000000	7822	4055	3	0	0
35719	1679	61201043000000	7824	4056	2	0	0
84250	1726	840694025000	7825	4057	0	0	1127
252155	1874	200975000	7825	4057	0	0	0
21529	1564	10800222000000	7825	4057	2	0	0
57369	1764	15840318000000	7827	4058	1	0	2
15137	1458	20160345908540	7828	4059	1	0	0
56371	1755	2159050000000	7833	4061	2	0	0
4269	632	78240421000000	7835	4062	1	0	0
84264	1726	840634019000	7839	4063	0	0	1133
252169	1874	200981000	7839	4063	0	0	0
252180	1874	200985000	7842	4064	4	0	0
84276	1726	840584014000	7842	4064	5	0	1138
52483	1715	18720161000000	7843	4065	2	0	0
84285	1726	840534009000	7849	4068	0	0	1143
252190	1874	200991000	7849	4068	0	0	0
38462	1683	593287397999541	7849	4068	2	0	0
28210	1637	96482434799997	7850	4069	2	0	0
84292	1726	840474003000	7853	4071	0	0	1149
252197	1874	200997000	7853	4071	0	0	0
23193	1593	16560540000000	7855	4072	2	0	0
53068	1717	14399312000000	7856	4073	2	0	0
10646	1402	57601792000000	7857	4074	2	0	0
252207	1874	201002000	7863	4076	0	0	0
17820	1509	17280431000000	7863	4076	1	0	0
17821	1509	17280441000000	7863	4076	2	0	0
84320	1726	840413997000	7867	4077	0	0	1155
84321	1726	840403996000	7868	4078	0	0	1156
16137	1474	12234283000000	7868	4078	1	0	3
84322	1726	840393995000	7869	4079	0	0	1157
43942	1690	51120721000000	7874	4080	2	0	0
252236	1874	201008000	7875	4081	0	0	0
21347	1560	23040640000000	7875	4081	3	0	0
84339	1726	840333989000	7878	4082	1	0	1163
252248	1874	201013000	7882	4084	0	0	0
84349	1726	840283984000	7886	4086	0	0	1168
43211	1688	102962043000000	7886	4086	1	0	0
252255	1874	201018000	7888	4088	0	0	0
38478	1683	597607467999541	7888	4088	1	0	0
84357	1726	840233979000	7894	4091	0	0	1173
34402	1677	210244818000000	7894	4091	1	0	0
56792	1759	16560350000000	7898	4092	2	0	1
252271	1874	201024000	7901	4093	1	0	0
84376	1726	840183974000	7906	4095	0	0	1178
252281	1874	201027000	7907	4096	0	0	0
252283	1874	201028000	7909	4097	0	0	0
57067	1762	10079240000000	7910	4098	2	0	0
36151	1680	20879420000000	7911	4099	1	0	0
84383	1726	840123968000	7913	4101	0	0	1184
252291	1874	201034000	7915	4102	0	0	0
34409	1677	211684848000000	7916	4103	2	0	0
84391	1726	840073963000	7918	4104	1	0	1189
34410	1677	212404848000000	7918	4104	3	0	0
252301	1874	201040000	7920	4105	1	0	0
43222	1688	105122083000000	7920	4105	2	0	0
84402	1726	840013957000	7923	4107	0	0	1195
252308	1918	1439137000000	7923	4107	2	0	1
84411	1726	839963952000	7928	4110	0	0	1200
29950	1653	1440010000000	7928	4110	1	0	0
84544	1726	839943950000	7934	4112	0	0	1202
252448	1874	201050000	7934	4112	0	0	0
14775	1457	17280360000000	7934	4112	1	0	0
84545	1726	839933949000	7935	4113	0	0	1203
252449	1874	201051000	7935	4113	0	0	0
43610	1689	15119341000000	7937	4114	2	0	0
32420	1673	14400750000000	7947	4117	2	0	0
45287	1692	18739663000000	7950	4118	2	0	4
84561	1726	839873943000	7951	4119	0	0	1209
252465	1874	201057000	7951	4119	0	0	0
39448	1684	30239761000000	7955	4122	1	0	0
52301	1714	21589340000000	7956	4123	2	0	2
84601	1726	839813937000	7960	4124	0	0	1215
252505	1874	201063000	7960	4124	0	0	0
84602	1726	839803936000	7961	4125	0	0	1216
252510	1874	201068000	7962	4126	1	0	0
38489	1683	600487487999541	7962	4126	3	0	0
38490	1683	600487517999541	7962	4126	4	0	0
84609	1726	839743930000	7964	4127	0	0	1222
252523	1474	12954293000000	7971	4129	3	0	3
84621	1726	839693925000	7972	4130	0	0	1227
31196	1668	18720330000000	7973	4131	1	0	0
252529	1874	201079000	7975	4133	0	0	0
84626	1726	839643920000	7975	4133	1	0	1232
5095	641	85440790000000	7975	4133	3	0	0
34416	1677	214564898000000	7976	4134	1	0	0
252542	1874	201084000	7982	4136	0	0	0
84640	1693	5033547553123	7982	4136	2	0	458
45302	1692	19459663000000	7983	4137	1	0	4
252548	1874	201088000	7984	4138	2	0	0
84646	1726	839553911000	7985	4139	1	0	1241
56572	1756	17279859000000	7985	4139	3	0	1
252553	1874	201091000	7986	4140	1	0	0
252554	1874	201092000	7986	4140	2	0	0
84654	1726	839513907000	7988	4141	0	0	1245
252565	1874	201098000	7991	4143	0	0	0
84662	1726	839453901000	7992	4144	0	0	1251
26494	1622	10079149999976	7992	4144	2	0	0
38498	1683	604807567999541	7993	4145	3	0	0
252576	1874	201104000	8000	4147	0	0	0
28220	1637	98642464799997	8000	4147	2	0	0
84678	1726	839393895000	8006	4148	0	0	1257
252587	1874	201109000	8010	4151	0	0	0
84684	1726	839343890000	8011	4152	0	0	1262
252599	1874	201114000	8016	4154	2	0	0
84696	1726	839293885000	8017	4155	0	0	1267
32828	1675	12960669999977	8021	4158	3	0	0
252607	1874	201120000	8022	4159	0	0	0
84704	1726	839233879000	8022	4159	1	0	1273
12906	1440	15840601000000	8022	4159	3	0	0
252618	1874	201125000	8029	4162	0	0	0
39849	1685	57600320000000	8029	4162	2	0	0
55985	1747	7198690000000	8031	4163	0	0	0
84733	1726	839183874000	8034	4164	0	0	1278
84734	1726	839173873000	8034	4164	1	0	1279
252642	1919	200000000	8034	4164	5	0	0
84740	1726	833953871000	8034	4164	7	0	1285
252648	1874	201131000	8034	4164	11	0	0
84759	1726	831313867000	8038	4166	0	0	1291
35731	1679	63361093000000	8038	4166	2	0	0
252672	1874	201136000	8047	4169	0	0	0
39853	1685	58320320000000	8047	4169	1	0	0
38512	1683	609127607999541	8049	4170	2	0	0
84775	1726	831263862000	8052	4171	0	0	1296
34426	1677	216724938000000	8053	4172	1	0	0
252684	1874	201142000	8055	4173	0	0	0
84782	1726	831203856000	8057	4175	0	0	1302
252689	1874	201145000	8059	4176	0	0	0
252690	1874	201146000	8059	4176	1	0	0
55008	1739	12959480000000	8061	4177	1	0	0
84794	1726	831153851000	8064	4179	0	0	1307
252700	1745	8406000000	8065	4180	1	0	2
38517	1683	613447727999541	8065	4180	2	0	0
15787	1471	16560380000000	8069	4182	1	0	0
15788	1471	16560390000000	8069	4182	2	0	0
84803	1726	831113847000	8070	4183	1	0	1311
10676	1402	59762482000000	8071	4184	3	0	0
252712	1874	201156000	8073	4185	0	0	0
84811	1726	831063842000	8074	4186	1	0	1316
252717	1924	1200000000	8074	4186	3	0	0
47425	1694	33839760000000	8078	4188	1	0	1
84823	1726	831023838000	8080	4189	0	0	1320
252729	1874	201163000	8081	4190	0	0	0
84828	1919	150000000	8082	4191	0	0	1
252735	1735	3580020000000	8082	4191	3	0	7
84836	1752	95000000	8086	4193	1	0	4
252742	1874	201168000	8088	4195	0	0	0
84857	1726	830933829000	8101	4198	0	0	1329
51923	1711	15119230000000	8101	4198	1	0	0
252763	1745	1803000000	8102	4199	1	0	5
19774	1547	7920202000000	8102	4199	3	0	0
84865	1726	829623828000	8104	4200	1	0	1331
84866	1726	829613827000	8104	4200	2	0	1332
252774	1874	201175000	8107	4202	0	0	0
36425	1681	23039515195920	8107	4202	2	0	1
38526	1683	617767759999541	8108	4203	2	0	0
84873	1726	829563822000	8110	4205	0	0	1337
252779	1874	201180000	8111	4206	0	0	0
43230	1688	106562123000000	8111	4206	2	0	0
84881	1726	829503816000	8114	4207	3	0	1343
252787	1874	201186000	8114	4207	5	0	0
84888	1726	829463812000	8118	4209	0	0	1347
13384	1445	13680260000000	8118	4209	2	0	0
36168	1680	23039450000000	8120	4210	1	0	0
252800	1874	201190000	8124	4212	1	0	0
84899	1726	829413807000	8124	4212	4	0	1352
25671	1610	18000540000000	8124	4212	5	0	0
252806	1874	201195000	8127	4214	0	0	0
52497	1715	20160232000000	8131	4215	2	0	0
84910	1726	829353801000	8134	4217	0	0	1358
45339	1692	21619814000000	8134	4217	2	0	4
252816	1874	201201000	8135	4218	0	0	0
30558	1656	18720401000000	8136	4219	1	0	0
84915	1726	829303796000	8137	4220	1	0	1363
252825	1874	201207000	8142	4222	0	0	0
16805	1489	15840561000000	8142	4222	2	0	0
252833	1874	201208000	8147	4223	0	0	0
84931	1726	829243790000	8148	4224	0	0	1369
252841	1874	201213000	8150	4225	3	0	0
30803	1657	12960230000000	8152	4226	2	0	0
84987	1726	827893785000	8154	4227	0	0	1375
2132	369	84720462000000	8154	4227	1	0	0
14560	1455	18000301000000	8156	4228	1	0	0
252903	1874	201219000	8163	4231	0	0	0
85000	1726	827843780000	8163	4231	1	0	1380
85001	1726	827833779000	8165	4232	0	0	1381
85007	1726	827823778000	8169	4233	0	0	1382
252914	1874	201224000	8171	4234	0	0	0
10703	1402	61922512000000	8171	4234	1	0	0
38539	1683	622087799999541	8174	4235	2	0	0
85022	1726	827763772000	8179	4237	0	0	1388
252928	1874	201230000	8181	4239	0	0	0
85028	1726	827703766000	8182	4240	2	0	1394
48580	1699	3093879000078	8182	4240	5	0	4
252938	1874	201236000	8184	4241	0	0	0
85038	1726	827653761000	8188	4244	0	0	1399
252944	1874	201241000	8190	4246	0	0	0
34440	1677	218164969000000	8190	4246	2	0	0
48464	1698	22319401000000	8194	4248	3	0	1
85053	1726	827593755000	8197	4249	0	0	1405
252961	1874	201247000	8201	4251	0	0	0
252965	1929	200000000	8203	4252	0	0	0
85067	1726	824953751000	8205	4253	0	0	1411
22821	1588	15840510000000	8205	4253	2	0	0
43952	1690	53280791000000	8206	4254	2	0	0
253034	1874	201252000	8211	4256	0	0	0
85132	1726	824903746000	8212	4257	1	0	1416
38546	1683	626407819999541	8215	4259	1	0	0
85137	1726	824873743000	8217	4260	0	0	1419
85138	1726	823573743000	8217	4260	1	0	1420
253042	1930	200000000	8217	4260	1	0	0
28227	1637	100802494799997	8227	4264	1	0	0
253057	1874	201262000	8229	4265	0	0	0
85154	1726	823513737000	8230	4266	0	0	1426
55646	1746	5039091000000	8230	4266	3	0	0
55651	1746	5039121000000	8230	4266	4	0	0
253075	1874	201268000	8237	4268	0	0	0
53179	1718	2160220000000	8237	4268	1	0	0
53180	1718	2160230000000	8237	4268	2	0	0
85176	1726	823453731000	8243	4270	0	0	1432
38554	1683	629287869999541	8243	4270	2	0	0
34451	1677	220325009000000	8249	4272	2	0	0
85193	1726	823403726000	8253	4273	0	0	1437
253097	1874	201274000	8253	4273	0	0	0
253100	1874	201275000	8255	4274	0	0	0
54031	1723	15840081000000	8255	4274	3	0	0
85207	1929	1300000000	8262	4278	0	0	1
253112	1874	201280000	8262	4278	2	0	0
39472	1684	32399901000000	8262	4278	6	0	0
85219	1726	823303716000	8264	4279	0	0	1447
253123	1874	201285000	8265	4280	0	0	0
15172	1458	22320385908540	8265	4280	2	0	0
85224	1726	823263712000	8266	4281	1	0	1451
38562	1683	635047889999541	8266	4281	3	0	0
253132	1521	2877088000000	8269	4282	0	0	3
85235	1726	823223708000	8273	4285	1	0	1455
2944	484	84000352000000	8273	4285	3	0	0
253142	1874	201294000	8275	4286	0	0	0
85250	1726	823173703000	8280	4288	0	0	1460
253154	1874	201298000	8281	4289	0	0	0
11336	1419	19440450000000	8281	4289	2	0	0
85258	1726	823133699000	8286	4291	1	0	1464
253164	1874	201303000	8289	4293	0	0	0
1218	149	75360180000000	8289	4293	2	0	0
85269	1521	1599000000	8291	4294	2	0	5
24504	1601	11161215600000	8291	4294	3	0	5
85274	1726	823083694000	8295	4295	0	0	1469
85275	1726	823073693000	8295	4295	1	0	1470
253177	1874	201307000	8295	4295	1	0	0
85291	1726	823033689000	8307	4299	0	0	1474
253193	1874	201311000	8307	4299	0	0	0
22582	1587	15120290000000	8307	4299	2	0	0
54656	1727	11519171000000	8309	4300	3	0	0
253305	1874	201313000	8312	4301	0	0	0
253306	1874	201314000	8313	4302	0	0	0
85405	1726	821693685000	8313	4302	1	0	1479
43247	1688	108722165000000	8313	4302	4	0	0
43960	1690	55440821000000	8315	4304	0	0	0
85409	1726	821673683000	8316	4305	1	0	1481
85410	1726	821663682000	8316	4305	2	0	1482
253312	1874	201318000	8316	4305	2	0	0
14797	1457	18720381000000	8321	4307	2	0	0
85428	1726	821623678000	8323	4308	1	0	1486
253330	1874	201322000	8323	4308	1	0	0
28237	1637	102962535799997	8325	4309	2	0	0
43249	1688	109442175000000	8327	4310	2	0	0
253339	1874	201327000	8330	4312	0	0	0
85438	1726	821563672000	8331	4313	0	0	1492
31603	1670	20160620000000	8333	4315	1	0	0
85443	1726	821513667000	8335	4317	1	0	1497
253345	1874	201333000	8335	4317	1	0	0
11595	1420	720000000000	8338	4319	0	0	0
85456	1726	818873663000	8344	4321	1	0	1503
253358	1874	201337000	8344	4321	1	0	0
253363	1874	201338000	8345	4322	0	0	0
85462	1726	813653661000	8346	4323	0	0	1509
253371	1874	201340000	8349	4324	0	0	0
253372	1874	201341000	8349	4324	1	0	0
43250	1688	110162175000000	8349	4324	3	0	0
85479	1726	813613657000	8352	4325	1	0	1513
253387	1874	201345000	8354	4326	1	0	0
85490	1726	813573653000	8356	4327	0	0	1517
17960	1511	720011000000	8357	4328	3	0	0
253397	1874	201350000	8359	4329	0	0	0
85498	1726	813523648000	8360	4330	0	0	1522
253402	1874	201355000	8361	4331	1	0	0
47433	1694	36000290000000	8361	4331	2	0	1
38574	1683	637927930999541	8362	4332	2	0	0
85503	1726	813473643000	8363	4333	0	0	1527
34459	1677	222485070000000	8363	4333	3	0	0
23008	1592	720000000000	8366	4335	1	0	0
253410	1874	201361000	8368	4336	0	0	0
49008	1700	12959560000000	8368	4336	2	0	1
85512	1726	813413637000	8370	4337	1	0	1533
19576	1546	15840300000000	8370	4337	3	0	0
22849	1588	17280520000000	8371	4338	1	0	0
22851	1588	17280530000000	8371	4338	2	0	0
253418	1874	201366000	8374	4340	0	0	0
20202	1549	20880501000000	8374	4340	1	0	0
85519	1934	199000000	8375	4341	1	0	1
253423	1874	201368000	8376	4342	2	0	0
85542	1726	813343630000	8382	4343	0	0	1540
4289	632	80400473000000	8382	4343	2	0	0
85545	1726	813313627000	8383	4344	1	0	1543
85546	1726	813303626000	8383	4344	2	0	1544
253447	1874	201374000	8383	4344	2	0	0
56825	1759	18720370000000	8385	4345	2	0	1
4664	633	81839400000000	8386	4346	2	0	1
253580	1874	201377000	8389	4347	0	0	0
85680	904	114218749973438	8389	4347	1	0	1
253581	1941	718971000000	8389	4347	1	0	1
85683	1726	813263622000	8391	4348	0	0	1548
85684	1726	813253621000	8392	4349	0	0	1549
49336	1701	15118382000000	8397	4351	1	0	4
253594	1874	201382000	8398	4352	0	0	0
85697	1726	813203616000	8402	4354	0	0	1554
35739	1679	65521123000000	8402	4354	1	0	0
53584	1719	13679270000000	8404	4355	1	0	0
53586	1719	13679280000000	8404	4355	2	0	0
253605	1874	201388000	8409	4358	0	0	0
85710	1726	811853611000	8412	4359	1	0	1560
58525	1943	719000000000	8424	4364	0	0	0
1225	149	76080295000000	8447	4376	2	0	0
253617	592	66720000000000	8448	4377	0	0	0
1234	149	76800295000000	8448	4377	1	0	0
85718	1726	810533609000	8449	4378	1	0	1563
23859	1596	14557435000000	8449	4378	3	0	6
38588	1683	645128159999541	8453	4380	1	0	0
253628	1874	201395000	8455	4381	0	0	0
405	43	79680350000000	8458	4382	2	0	0
85739	1726	810473603000	8462	4383	0	0	1569
28246	1637	105122586799997	8462	4383	1	0	0
253641	1874	201398000	8463	4384	0	0	0
34474	1677	224645095000000	8463	4384	1	0	0
253642	1874	201399000	8464	4385	0	0	0
10733	1402	64082552000000	8466	4386	1	0	0
85747	1726	810413597000	8468	4387	2	0	1575
253650	640	66000010000000	8468	4387	4	0	0
3490	576	81840520000000	8468	4387	6	0	0
3656	603	66721200000000	8470	4388	1	0	0
15428	1467	14401730000000	8473	4389	1	0	0
85760	1726	810353593000	8475	4390	0	0	1580
26793	1623	25921670899898	8476	4391	1	0	1
26799	1623	25921680899898	8476	4391	2	0	1
253664	1945	200000000	8477	4392	1	0	0
53594	1719	14399280000000	8480	4393	1	0	0
85769	1726	809103589000	8481	4394	1	0	1585
58317	1850	16545320000000	8481	4394	2	0	0
253680	1874	201413000	8486	4395	1	0	0
47439	1694	38160330000000	8487	4396	2	0	1
85787	1543	0	8491	4398	1	0	1
253691	1874	201418000	8493	4399	0	0	0
85796	1726	809003579000	8499	4402	0	0	1595
39869	1685	61200350000000	8502	4403	1	0	0
253702	1874	201424000	8504	4405	0	0	0
46602	1693	7913607553123	8505	4406	2	0	458
85807	1726	808943573000	8510	4408	0	0	1601
38596	1683	649448189999541	8510	4408	1	0	0
253711	1874	201429000	8513	4410	0	0	0
85820	1726	808893568000	8520	4413	0	0	1606
85821	1726	808883567000	8520	4413	1	0	1607
253724	1874	201435000	8522	4415	0	0	0
85827	1726	808833562000	8523	4416	1	0	1612
56320	1749	14395328000000	8523	4416	3	0	3
253731	1874	201440000	8526	4418	0	0	0
20224	1549	22320566000000	8526	4418	2	0	0
85839	1726	808773556000	8534	4421	0	0	1618
26161	1613	15118620000000	8534	4421	1	0	2
253742	1874	201445000	8536	4422	0	0	0
85845	1726	808723551000	8537	4423	3	0	1623
253750	1874	201451000	8541	4425	0	0	0
10745	1402	64802562000000	8541	4425	1	0	0
10747	1402	64802572000000	8541	4425	2	0	0
2720	470	84720421000000	8545	4427	1	0	0
85859	1726	808663545000	8547	4428	0	0	1629
253762	1874	201457000	8548	4429	0	0	0
32449	1673	16560770000000	8550	4430	1	0	0
85866	1726	808603539000	8555	4433	0	0	1635
43266	1688	112322225000000	8555	4433	1	0	0
253768	1874	201462000	8556	4434	0	0	0
4302	632	81840513000000	8556	4434	2	0	0
38609	1683	652328229999541	8560	4436	2	0	0
85873	1726	808553534000	8562	4438	0	0	1640
601	44	81120910000000	8562	4438	3	0	0
253778	1874	201468000	8564	4439	0	0	0
253779	1874	201469000	8564	4439	1	0	0
54440	1724	19438960000000	8569	4441	2	0	2
85886	1726	808493528000	8571	4442	0	0	1646
15821	1471	18720430000000	8571	4442	3	0	0
253792	1874	201475000	8573	4443	1	0	0
25107	1607	23760622000000	8573	4443	3	0	0
85895	1726	808433522000	8576	4445	1	0	1652
12929	1440	18000632000000	8578	4447	1	0	0
253799	1874	201481000	8579	4448	0	0	0
38617	1683	656648279999541	8579	4448	2	0	0
18648	1522	12959940000000	8581	4449	1	0	3
18650	1522	12959950000000	8581	4449	2	0	3
85902	1726	808383517000	8583	4450	0	0	1657
86004	1726	808373516000	8585	4451	0	0	1658
21566	1564	12960252000000	8585	4451	1	0	0
86005	1726	808363515000	8586	4452	0	0	1659
253909	1874	201486000	8589	4453	0	0	0
253916	1874	201490000	8595	4456	0	0	0
86016	1480	710919000000	8595	4456	1	0	9
253917	1946	0	8595	4456	1	0	0
48670	1699	5254110000078	8598	4458	2	0	4
44856	1691	11519291000000	8599	4459	1	0	0
50744	1706	17996472000000	8601	4460	1	0	6
86043	1726	808253504000	8604	4461	1	0	1670
253944	1874	201496000	8604	4461	1	0	0
86048	1726	808203499000	8604	4461	6	0	1675
253950	1874	201502000	8604	4461	8	0	0
86054	1480	705914000000	8604	4461	13	0	14
253955	1910	1000000000	8604	4461	13	0	0
86111	1726	808183497000	8607	4462	0	0	1677
254012	1874	201503000	8607	4462	0	0	0
86112	1726	808173496000	8607	4462	1	0	1678
34492	1677	226805135000000	8611	4464	1	0	0
254043	1874	201509000	8613	4465	0	0	0
86143	1726	808113490000	8613	4465	1	0	1684
18059	1513	14400420000000	8613	4465	3	0	0
254050	1874	201512000	8618	4467	0	0	0
254051	1874	201513000	8619	4468	0	0	0
45385	1692	23779854000000	8621	4469	1	0	4
86156	1726	808053484000	8625	4471	1	0	1690
86282	1726	808043483000	8628	4472	0	0	1691
86283	1726	808033482000	8628	4472	1	0	1692
27687	1634	18000344899999	8628	4472	3	0	0
254187	1874	201519000	8630	4473	0	0	0
254188	1874	201520000	8630	4473	1	0	0
46677	1693	9353637553123	8630	4473	3	0	458
86384	238	66000190000000	8636	4475	0	0	1
86385	1726	808003479000	8636	4475	1	0	1695
254295	1874	201525000	8644	4478	1	0	0
38625	1683	660968329999541	8644	4478	2	0	0
38627	1683	660968349999541	8644	4478	3	0	0
86396	1726	807943473000	8646	4479	1	0	1701
254301	1874	201531000	8646	4479	5	0	0
86404	1726	807883467000	8648	4480	1	0	1707
254308	1874	201536000	8649	4481	2	0	0
86409	1726	807833462000	8650	4482	0	0	1712
48700	1699	5974110000078	8650	4482	1	0	4
413	43	80400350000000	8659	4484	1	0	0
254324	1874	201541000	8663	4485	0	0	0
124	42	79677960000000	8663	4485	2	0	4
254326	1874	201542000	8665	4486	0	0	0
86426	1726	807783457000	8665	4486	1	0	1717
254332	441	66000020000000	8667	4488	3	0	0
86432	1726	807733452000	8668	4489	0	0	1722
11816	1422	12960210000000	8669	4490	1	0	0
17269	1506	15120340000000	8671	4491	2	0	0
86437	1397	1391515285000	8678	4497	1	0	4732
254338	1678	8640244815000	8678	4497	1	0	0
22291	1573	20880740000000	8678	4497	3	0	0
57667	1768	11519361110000	8681	4499	1	0	0
57669	1768	11519371110000	8681	4499	2	0	0
86528	1397	1391485282000	8683	4500	0	0	4735
86529	1397	1391475281000	8684	4501	0	0	4736
976	58	85440825000000	8684	4501	2	0	0
254431	1678	8640244820000	8686	4502	0	0	0
2167	369	86160532000000	8686	4502	3	0	0
86552	1397	1391425276000	8693	4506	0	0	4741
254454	1678	8640244825000	8693	4506	1	0	0
50356	1705	17275490000000	8694	4507	2	0	2
254457	1678	8640244827000	8696	4508	0	0	0
254459	1678	8640244828000	8698	4509	0	0	0
28257	1637	106562646799997	8698	4509	2	0	0
29896	1650	10800300000000	8701	4510	2	0	0
86562	1397	1391365270000	8702	4511	0	0	4747
86572	1397	1391325266000	8704	4512	0	0	4751
254471	1678	8640244834000	8704	4512	0	0	0
86578	1397	1391265260000	8706	4514	3	0	4757
254477	1678	8640244840000	8706	4514	3	0	0
20489	1555	11520220000000	8706	4514	5	0	0
3643	596	83280342000000	8708	4516	2	0	0
254490	1678	8640244845000	8711	4518	0	0	0
86592	1397	1391205254000	8711	4518	1	0	4763
86597	1726	806483448000	8711	4518	6	0	1727
254496	1947	200000000	8711	4518	6	0	0
86723	1726	806453445000	8717	4520	0	0	1730
254622	1874	201555000	8717	4520	0	0	0
86724	1397	1391155249000	8717	4520	1	0	4768
254623	1678	8640244851000	8717	4520	1	0	0
86734	1397	1391125246000	8720	4522	1	0	4771
254633	1678	8640244854000	8720	4522	1	0	0
86748	1726	806393439000	8724	4524	1	0	1736
254647	1874	201561000	8724	4524	1	0	0
86753	1397	1391075241000	8724	4524	6	0	4776
254652	1678	8640244859000	8724	4524	6	0	0
21357	1560	26640670000000	8724	4524	7	0	0
38636	1683	665288399999541	8726	4525	3	0	0
436	43	81840400000000	8727	4526	3	0	0
86761	1726	806343434000	8730	4527	2	0	1741
254660	1874	201566000	8730	4527	2	0	0
23579	1594	13680360000000	8732	4528	2	0	0
86769	1397	1391025236000	8734	4529	1	0	4781
86770	1726	806313431000	8735	4530	0	0	1744
254670	1678	8640244865000	8735	4530	1	0	0
86776	1726	806283428000	8736	4531	0	0	1747
254675	1874	201572000	8736	4531	0	0	0
25872	1611	14390230000000	8736	4531	2	0	1
86782	1726	806263426000	8738	4533	2	0	1749
254681	1874	201574000	8738	4533	2	0	0
38643	1683	669608479999541	8738	4533	5	0	0
86787	1397	1390935227000	8739	4534	3	0	4790
30840	1657	15120250000000	8739	4534	4	0	0
254687	1678	8640244874000	8740	4535	0	0	0
10780	1402	66962612000000	8741	4536	3	0	0
86797	1726	806203420000	8744	4537	1	0	1755
254696	1874	201580000	8744	4537	1	0	0
86805	1397	1390875221000	8748	4540	1	0	4796
254704	1678	8640244879000	8748	4540	1	0	0
43278	1688	114482285000000	8748	4540	2	0	0
34506	1677	228965175000000	8749	4541	2	0	0
86817	1726	806143414000	8755	4543	0	0	1761
254717	1678	8640244882000	8755	4543	1	0	0
40780	1686	9572116500013	8755	4543	3	0	2
86829	1726	806113411000	8761	4546	0	0	1764
254728	1874	201589000	8761	4546	0	0	0
254729	1678	8640244885000	8761	4546	1	0	0
254734	1678	8640244886000	8764	4547	0	0	0
86849	1397	1390785212000	8771	4549	0	0	4805
38656	1683	673928519999541	8771	4549	2	0	0
254756	1678	8640244889000	8773	4550	0	0	0
86860	1726	806073407000	8773	4550	3	0	1768
254762	1874	201596000	8774	4551	0	0	0
86868	1397	1390735207000	8776	4552	1	0	4810
254769	1874	201598000	8777	4553	1	0	0
86876	1726	804793400000	8780	4555	1	0	1776
254777	1949	200000000	8780	4555	3	0	0
53324	1718	12237468999992	8784	4556	2	0	1
86899	1726	803563398000	8788	4557	0	0	1779
254801	1678	8640244900000	8791	4558	1	0	0
34515	1677	230405255000000	8791	4558	5	0	0
86917	1726	803533395000	8795	4559	0	0	1782
86918	1726	803523394000	8795	4559	1	0	1783
254818	1678	8640244901000	8795	4559	2	0	0
86926	1726	803503392000	8798	4561	1	0	1785
27395	1633	14400180000000	8798	4561	2	0	0
254828	1678	8640244905000	8800	4562	0	0	0
48474	1698	24479461000000	8801	4563	3	0	1
86936	1397	1390595193000	8803	4564	1	0	4824
45423	1692	25219904000000	8803	4564	3	0	4
254836	1874	201612000	8805	4565	0	0	0
3526	576	84000550000000	8805	4565	4	0	0
86941	1397	1390565190000	8806	4566	0	0	4827
254841	1874	201614000	8806	4566	1	0	0
1649	235	66720000000000	8808	4567	3	0	0
86955	1397	1390535187000	8813	4569	0	0	4830
254855	1874	201617000	8813	4569	1	0	0
52869	1716	20879401000000	8815	4570	3	0	0
86965	1726	802193382000	8817	4571	1	0	1796
254865	1874	201619000	8817	4571	2	0	0
43645	1689	17279432000000	8817	4571	4	0	0
254869	1678	8640244916000	8819	4572	0	0	0
38663	1683	678248569999541	8819	4572	3	0	0
86976	1726	800953379000	8821	4573	0	0	1800
26293	1616	2160050000000	8821	4573	3	0	0
254878	1874	201622000	8822	4574	1	0	0
86982	1397	1390465180000	8823	4575	0	0	4837
30595	1656	20880421000000	8823	4575	2	0	0
254886	1678	8640244921000	8825	4576	1	0	0
87008	1726	800903374000	8829	4577	1	0	1805
254909	1678	8640244923000	8829	4577	3	0	0
35751	1679	67681173000000	8829	4577	6	0	0
87019	1948	100000000	8831	4578	0	0	1
254921	1951	200000000	8832	4579	0	0	0
87025	1726	799643369000	8832	4579	3	0	1811
254927	1678	8640244928000	8833	4580	0	0	0
87033	1726	799623367000	8835	4581	1	0	1813
87046	1726	799613366000	8839	4582	0	0	1814
254945	1874	201634000	8839	4582	0	0	0
87047	1726	799603365000	8839	4582	1	0	1815
254961	1874	201638000	8842	4583	2	0	0
87063	1397	1390345168000	8842	4583	3	0	4849
21363	1560	28800780000000	8842	4583	6	0	0
58482	1933	1439011000000	8846	4584	1	0	0
254978	1874	201639000	8848	4585	1	0	0
87080	1726	799553360000	8848	4585	2	0	1820
254989	1678	8640244938000	8853	4587	1	0	0
87095	1397	1390275161000	8856	4588	0	0	4856
254999	1874	201645000	8858	4590	1	0	0
87101	1726	799493354000	8859	4591	0	0	1826
255001	1678	8640244942000	8859	4591	1	0	0
38670	1683	682568659999541	8859	4591	2	0	0
255004	1678	8640244943000	8861	4592	0	0	0
87113	1397	1390215155000	8865	4594	0	0	4862
255016	1678	8640244946000	8867	4595	0	0	0
16167	1474	14574323000000	8867	4595	3	0	4
87122	1726	799433348000	8869	4596	1	0	1832
255030	1678	8640244949000	8873	4597	0	0	0
87134	1726	799413346000	8874	4598	1	0	1834
255044	1678	8640244952000	8877	4599	1	0	0
87156	1726	799383343000	8880	4600	0	0	1837
255057	1678	8640244955000	8880	4600	2	0	0
87165	1726	799363341000	8882	4601	1	0	1839
39508	1684	35280041000000	8882	4601	4	0	1
255067	1874	201661000	8883	4602	0	0	0
87171	1726	799333338000	8883	4602	3	0	1842
25701	1610	20160710000000	8883	4602	4	0	0
255072	1874	201663000	8884	4603	1	0	0
38675	1683	685448719999541	8885	4604	3	0	0
87177	1397	1390045138000	8886	4605	1	0	4879
87178	1726	799303335000	8886	4605	2	0	1845
255078	1678	8640244963000	8886	4605	3	0	0
34523	1677	232565660000000	8886	4605	9	0	0
87186	1397	1390015135000	8888	4606	0	0	4882
255086	1874	201669000	8888	4606	1	0	0
45436	1692	25939924000000	8893	4607	3	0	4
87198	1397	1389985132000	8895	4609	2	0	4885
255097	1678	8640244968000	8895	4609	2	0	0
5139	646	66000001980000	8895	4609	5	0	0
87217	1726	799213326000	8899	4610	3	0	1854
255120	1678	8640244971000	8901	4611	0	0	0
43286	1688	115922355000000	8901	4611	4	0	0
87234	1397	1389935127000	8906	4613	0	0	4890
255134	1874	201677000	8906	4613	1	0	0
255137	1678	8640244974000	8907	4614	2	0	0
255138	1678	8640244975000	8907	4614	3	0	0
87242	1397	1389905124000	8909	4615	0	0	4893
87247	1397	1389875121000	8910	4616	3	0	4896
255146	1678	8640244979000	8910	4616	3	0	0
38683	1683	689768839999541	8910	4616	7	0	0
87255	1397	1389855119000	8913	4618	1	0	4898
255154	1678	8640244981000	8913	4618	1	0	0
255160	1874	201687000	8916	4620	2	0	0
87262	1726	797863312000	8916	4620	3	0	1869
17861	1509	19440502000000	8916	4620	6	0	0
87274	1726	797843310000	8920	4622	1	0	1871
255173	1874	201690000	8920	4622	1	0	0
87280	1397	1389775111000	8922	4624	0	0	4906
255179	1678	8640244989000	8922	4624	0	0	0
255186	1678	8640244991000	8925	4626	1	0	0
87290	1726	797783304000	8927	4627	0	0	1877
11366	1419	21600490000000	8929	4628	3	0	0
87297	1397	1389725106000	8930	4629	1	0	4911
255196	1874	201698000	8930	4629	2	0	0
31233	1668	20880350000000	8930	4629	3	0	0
87303	1726	797733299000	8932	4631	0	0	1882
255202	1678	8640244997000	8932	4631	1	0	0
87315	1397	1389665100000	8936	4633	0	0	4917
255213	1678	8640245000000	8936	4633	0	0	0
87316	1726	797703296000	8936	4633	1	0	1885
32176	1672	15840402000000	8936	4633	2	0	0
255223	1678	8640245003000	8941	4637	2	0	0
87326	1397	1389625096000	8941	4637	3	0	4921
255229	1954	200000000	8941	4637	8	0	0
87332	1726	795233291000	8941	4637	9	0	1892
20883	1559	18720540000000	8941	4637	11	0	0
36183	1680	25199490000000	8942	4638	2	0	0
255236	1874	201711000	8944	4639	1	0	0
87339	1397	1389595093000	8944	4639	2	0	4924
255245	1874	201713000	8947	4640	4	0	0
38691	1683	694089060999541	8947	4640	6	0	0
87354	1397	1389565090000	8950	4641	0	0	4927
87360	1397	1389545088000	8952	4643	1	0	4929
255256	1678	8640245012000	8952	4643	1	0	0
87375	1726	795133281000	8957	4645	0	0	1902
255270	1874	201719000	8957	4645	0	0	0
255273	1678	8640245016000	8957	4645	3	0	0
51429	1709	16557511000000	8957	4645	5	0	4
87509	1726	795113279000	8960	4646	0	0	1904
255403	1874	201721000	8960	4646	0	0	0
87510	1397	1389495083000	8960	4646	1	0	4934
255410	1678	8640245019000	8962	4647	0	0	0
255411	1874	201723000	8962	4647	1	0	0
87518	1726	795083276000	8963	4648	0	0	1907
255417	1874	201726000	8964	4649	3	0	0
38696	1683	698410100999541	8964	4649	4	0	0
87524	1397	1389435077000	8965	4650	0	0	4940
34539	1677	234725740000000	8965	4650	3	0	0
87530	1397	1389415075000	8967	4651	3	0	4942
255424	1678	8640245025000	8967	4651	3	0	0
255438	1957	10000000	8970	4652	4	0	0
87545	1397	1389385072000	8971	4653	0	0	4945
12566	1439	11520210000000	8971	4653	3	0	0
255444	1874	201733000	8972	4654	3	0	0
87551	1726	794983266000	8972	4654	4	0	1917
32866	1675	15120709999977	8973	4655	3	0	0
87619	1726	794953263000	8976	4656	0	0	1920
87620	1397	1389335067000	8976	4656	1	0	4950
255513	1678	8640245033000	8976	4656	1	0	0
48736	1699	7414160000078	8976	4656	3	0	4
255524	1874	201740000	8982	4659	0	0	0
87632	1397	1389305064000	8982	4659	1	0	4953
255550	1874	201741000	8990	4661	0	0	0
255551	1678	8640245038000	8990	4661	2	0	0
87665	1397	1389275061000	8990	4661	5	0	4956
255562	1874	201745000	8993	4663	0	0	0
87676	1397	1389255059000	8993	4663	1	0	4958
255570	1941	717956000000	8995	4664	4	0	3
87689	1397	1389225056000	8997	4665	0	0	4961
255580	1678	8640245045000	8997	4665	4	0	0
34545	1677	236165820000000	8997	4665	7	0	0
87701	1726	794813249000	8999	4666	0	0	1934
255596	1678	8640245049000	9002	4667	0	0	0
87710	1726	794793247000	9002	4667	1	0	1936
16532	1476	18000350000000	9002	4667	2	0	0
87722	1726	794763244000	9010	4670	0	0	1939
255609	1874	201756000	9010	4670	0	0	0
87723	1726	794753243000	9010	4670	1	0	1940
51978	1711	17999380000000	9010	4670	5	0	0
255618	1874	201758000	9012	4671	1	0	0
87733	1726	794723240000	9013	4672	1	0	1943
19614	1546	17280320000000	9013	4672	4	0	0
255624	1874	201761000	9014	4673	1	0	0
87741	1726	794703238000	9016	4674	1	0	1945
255632	1678	8640245060000	9017	4675	3	0	0
87746	1397	1389055039000	9018	4676	0	0	4978
255637	44	81840990000000	9018	4676	4	0	0
18809	1532	720045000000	9018	4676	6	0	0
87754	1397	1389035037000	9020	4677	1	0	4980
34547	1677	236885820000000	9022	4678	2	0	0
255646	1678	8640245066000	9023	4679	1	0	0
87761	1726	794623230000	9023	4679	3	0	1953
39529	1684	36720166000000	9023	4679	5	0	1
255658	1678	8640245068000	9027	4681	1	0	0
87774	1726	794593227000	9029	4682	0	0	1956
53087	1717	15839353000000	9029	4682	3	0	0
255670	1874	201774000	9032	4683	2	0	0
20249	1549	25200616000000	9032	4683	4	0	0
87788	1397	1388945028000	9034	4684	1	0	4989
255679	1874	201777000	9035	4685	1	0	0
16833	1489	18000591000000	9035	4685	2	0	0
255682	1874	201778000	9037	4686	0	0	0
87796	1397	1388925026000	9037	4686	2	0	4991
255683	1678	8640245074000	9037	4686	2	0	0
58450	1893	209900000	9037	4686	4	1	0
39882	1685	63360390000000	9041	4688	2	0	0
87810	1726	794513219000	9044	4689	0	0	1964
255698	1874	201782000	9044	4689	1	0	0
87823	1726	794483216000	9047	4690	1	0	1967
255710	1678	8640245079000	9047	4690	2	0	0
87829	1397	1388835017000	9048	4691	3	0	5000
255715	1678	8640245083000	9048	4691	3	0	0
87834	1726	794453213000	9048	4691	8	0	1970
255721	1959	200000000	9048	4691	9	0	0
15446	1467	15841750100000	9048	4691	13	0	0
87867	1726	793213210000	9052	4692	0	0	1974
87868	1397	1388805014000	9052	4692	1	0	5003
255757	1874	201791000	9054	4693	0	0	0
10808	1402	69122672000000	9054	4693	3	0	0
87876	1397	1388775011000	9055	4694	3	0	5006
255762	1678	8640245089000	9055	4694	3	0	0
43299	1688	118082455000000	9058	4695	3	0	0
3953	606	79680270000000	9060	4696	2	0	1
3954	606	79680290000000	9060	4696	3	0	1
87894	1397	1388745008000	9061	4697	0	0	5009
255780	1678	8640245092000	9061	4697	0	0	0
31953	1671	22321080000000	9061	4697	4	0	0
87906	1726	791923202000	9064	4698	1	0	1983
255793	1678	8640245094000	9064	4698	2	0	0
56587	1757	719030000000	9064	4698	4	0	0
54849	1729	13679250000000	9065	4699	2	0	0
87912	1397	1388695003000	9067	4700	2	0	5014
255798	1678	8640245097000	9067	4700	2	0	0
87920	1726	791873197000	9070	4702	1	0	1988
255806	1874	201803000	9070	4702	1	0	0
87925	1726	791833193000	9070	4702	6	0	1992
255812	1678	8640245100000	9070	4702	7	0	0
87931	1397	1388624996000	9071	4703	1	0	5021
255817	1678	8640245104000	9071	4703	1	0	0
255818	1483	0	9072	4704	0	0	0
87937	1397	1388594993000	9073	4705	0	0	5024
255824	1874	201811000	9073	4705	1	0	0
38712	1683	702730321999541	9074	4706	2	0	0
87942	1397	1388574991000	9075	4707	1	0	5026
255830	1678	8640245110000	9076	4708	1	0	0
87948	1726	791763186000	9076	4708	6	0	1999
255835	1874	201815000	9076	4708	7	0	0
87963	1726	791733183000	9080	4710	3	0	2002
255861	1678	8640245114000	9085	4711	0	0	0
88012	1516	1115766709	9087	4712	0	0	6
88013	1726	791723182000	9087	4712	1	0	2003
255902	1678	8640245116000	9087	4712	4	0	0
88031	1397	1388494983000	9090	4713	2	0	5034
255919	1678	8640245119000	9090	4713	4	0	0
88037	1726	790473178000	9090	4713	8	0	2008
255925	1963	366305000000	9090	4713	10	0	1
255953	1874	201823000	9097	4714	0	0	0
255954	1678	8640245120000	9097	4714	1	0	0
88071	772	1000900000000	9099	4715	0	0	1
255964	1874	201826000	9102	4717	0	0	0
88079	1397	1388434977000	9102	4717	1	0	5040
138	42	81118000000000	9105	4718	3	0	4
255980	1874	201829000	9110	4720	0	0	0
88095	1397	1388404974000	9110	4720	1	0	5043
28268	1637	108722704819997	9111	4721	3	0	0
255985	1678	8640245129000	9112	4722	1	0	0
88100	1726	790383169000	9112	4722	2	0	2017
255995	1874	201834000	9114	4723	3	0	0
12149	1426	12240430000000	9114	4723	5	0	0
88118	1726	790343165000	9118	4724	0	0	2021
88130	1397	1388324966000	9123	4725	0	0	5051
88131	1726	790323163000	9123	4725	1	0	2023
256017	1874	201837000	9123	4725	1	0	0
256028	1678	8640245137000	9127	4727	0	0	0
88143	1726	790293160000	9127	4727	1	0	2026
38721	1683	707050473999541	9129	4728	4	0	0
256052	1678	8640245140000	9131	4729	0	0	0
88168	1726	790263157000	9131	4729	1	0	2029
88175	1397	1388234957000	9135	4732	0	0	5060
256060	1678	8640245143000	9135	4732	0	0	0
35765	1679	69121261980000	9137	4733	4	0	0
256069	1678	8640245145000	9139	4734	1	0	0
34562	1677	239045900000000	9139	4734	2	0	0
88185	1397	1388204954000	9140	4735	0	0	5063
24538	1601	12601296600000	9141	4736	3	0	5
256075	1678	8640245148000	9142	4737	1	0	0
88191	1397	1388174951000	9142	4737	2	0	5066
88201	1726	788943146000	9144	4738	2	0	2041
256086	1874	201854000	9144	4738	2	0	0
256089	1966	200000000	9144	4738	5	0	0
256090	1874	201855000	9144	4738	6	0	0
88219	1397	1388134947000	9148	4739	1	0	5070
38727	1683	709930573999541	9148	4739	5	0	0
256108	1678	8640245155000	9149	4740	1	0	0
88225	1726	787683141000	9149	4740	3	0	2047
256120	1678	8640245158000	9153	4742	1	0	0
88238	1726	787653138000	9155	4743	0	0	2050
5337	1271	1340526240000000	9156	4744	3	0	0
256129	1874	201864000	9158	4745	0	0	0
88246	1726	787623135000	9159	4746	0	0	2053
256137	1678	8640245165000	9161	4747	2	0	0
88254	1726	787613134000	9161	4747	4	0	2054
256147	1874	201870000	9163	4748	0	0	0
88263	1726	787563129000	9163	4748	1	0	2059
88265	1397	1387984932000	9163	4748	3	0	5085
88266	1397	1387974931000	9164	4749	0	0	5086
256152	1874	201872000	9164	4749	1	0	0
50374	1705	19435550000000	9166	4751	3	0	2
88276	1726	787523125000	9170	4752	0	0	2063
256162	1678	8640245172000	9170	4752	1	0	0
39891	1685	64800550000000	9170	4752	3	0	0
88285	1726	787503123000	9173	4754	1	0	2065
256171	425	66000010000000	9173	4754	2	0	0
88290	277	66000000000000	9174	4755	2	0	1
256176	1483	0	9174	4755	3	0	0
43973	1690	57600901000000	9174	4755	7	0	0
88302	1397	1387884922000	9179	4757	0	0	5095
256188	1874	201881000	9179	4757	1	0	0
54049	1723	17280241000000	9179	4757	4	0	0
88320	1726	787433116000	9182	4758	0	0	2072
256206	1678	8640245181000	9182	4758	1	0	0
55452	1740	18718008000000	9182	4758	2	0	5
88325	1397	1387824916000	9184	4760	1	0	5101
256211	1678	8640245185000	9184	4760	2	0	0
88339	1397	1387794913000	9188	4762	0	0	5104
256225	1678	8640245188000	9188	4762	1	0	0
256226	1874	201889000	9188	4762	2	0	0
88349	1397	1387774911000	9190	4763	2	0	5106
256243	761	1003857250000	9193	4764	0	0	0
38737	1683	714250643999541	9193	4764	4	0	0
88361	1726	787333106000	9194	4765	0	0	2082
256249	509	66254578500000	9194	4765	3	0	0
88367	55	67125247000000	9195	4766	0	0	7
256254	178	66254578500000	9195	4766	2	0	0
14215	1451	12240340000000	9195	4766	5	0	0
88501	1726	787313104000	9198	4767	0	0	2084
256384	1874	201896000	9198	4767	0	0	0
88502	1397	1387724906000	9198	4767	1	0	5111
256385	1678	8640245194000	9198	4767	1	0	0
45465	1692	28100002020000	9199	4768	3	0	4
88510	1397	1387694903000	9202	4770	1	0	5114
256393	1678	8640245197000	9202	4770	1	0	0
50982	1708	12239500000000	9202	4770	2	0	0
1611	171	80400260000000	9203	4771	3	0	0
88524	1726	787243097000	9206	4773	1	0	2091
256407	1874	201903000	9206	4773	1	0	0
88529	1397	1387644898000	9206	4773	6	0	5119
256412	1678	8640245202000	9206	4773	6	0	0
88535	1397	1387614895000	9208	4775	0	0	5122
256418	1678	8640245205000	9208	4775	0	0	0
88537	1397	1387604894000	9209	4776	0	0	5123
88538	1726	787193092000	9209	4776	1	0	2096
39550	1684	38880276000000	9209	4776	3	0	1
256424	1967	360451500000	9210	4777	2	0	0
88548	1397	1387574891000	9212	4778	2	0	5126
256441	1678	8640245210000	9215	4779	0	0	0
88562	1726	787143087000	9215	4779	4	0	2101
43311	1688	120242555000000	9215	4779	7	0	0
256463	1678	8640245213000	9219	4780	0	0	0
88583	1726	787113084000	9219	4780	3	0	2104
256473	1874	201918000	9223	4782	0	0	0
88607	1726	785873081000	9230	4783	1	0	2108
256492	1678	8640245218000	9231	4784	0	0	0
88613	1726	785853079000	9233	4786	1	0	2110
256497	1678	8640245221000	9234	4787	0	0	0
256498	1874	201922000	9234	4787	1	0	0
34574	1677	241205991000000	9235	4788	2	0	0
88620	1726	785823076000	9237	4789	0	0	2113
256506	1874	201925000	9237	4789	3	0	0
17467	1508	15120310000000	9237	4789	5	0	0
43983	1690	59761021000000	9238	4790	3	0	0
88626	1726	785793073000	9239	4791	0	0	2116
256512	1874	201928000	9240	4792	1	0	0
5124	641	88320930000000	9241	4793	3	0	0
88641	1726	785763070000	9245	4794	0	0	2119
256526	910	505400512229673	9245	4794	2	0	0
88646	1726	785743068000	9246	4795	2	0	2121
256532	395	66341270665601	9246	4795	5	0	1
88652	1397	1387364870000	9246	4795	8	0	5147
32199	1672	17280542000000	9246	4795	11	0	0
256538	1874	201933000	9247	4796	1	0	0
88658	1397	1387334867000	9247	4796	4	0	5150
256543	205	66344300665601	9247	4796	6	0	0
88663	1693	11084978486463	9247	4796	9	0	469
256549	1961	343222840828	9247	4796	12	0	0
88669	1693	9176821190273	9247	4796	15	0	475
256555	399	66344300665601	9247	4796	18	0	0
88673	1693	8545024830987	9247	4796	19	0	479
88674	1726	785703064000	9248	4797	0	0	2125
256560	122	66344300665601	9248	4797	3	0	0
88680	1693	8233860626847	9248	4797	6	0	484
38753	1683	718570803999541	9248	4797	9	0	0
256566	1874	201938000	9249	4798	1	0	0
88686	1693	8109394945191	9249	4798	4	0	486
256572	1150	611075881460537	9249	4798	7	0	0
88691	1693	7347694835001	9249	4798	9	0	491
256577	392	66344300665601	9249	4798	12	0	0
88697	1693	6974297790033	9249	4798	15	0	497
256607	1678	8640245239000	9251	4799	2	0	0
88727	1693	6849832108377	9251	4799	5	0	499
256613	373	66344300665601	9251	4799	9	0	0
88732	1693	6600900745065	9251	4799	11	0	503
256618	1874	201941000	9251	4799	14	0	0
88738	1693	6289736540925	9251	4799	17	0	508
256624	731	2010433353450	9251	4799	20	0	0
88744	1693	5976676796164	9251	4799	23	0	514
88895	1397	1387254859000	9254	4800	0	0	5158
256778	1678	8640245241000	9254	4800	0	0	0
88896	1726	785643058000	9254	4800	1	0	2131
256779	1874	201942000	9254	4800	1	0	0
49049	1700	15119660000000	9254	4800	8	0	1
88917	1397	1387244858000	9257	4801	0	0	5159
256800	1678	8640245242000	9257	4801	0	0	0
88923	1693	5292115547056	9257	4801	6	0	525
256806	180	66344300665601	9257	4801	6	0	0
30157	1654	15120280000000	9257	4801	8	0	0
88944	1726	785623056000	9260	4802	3	0	2133
256827	1874	201944000	9260	4802	3	0	0
88945	1693	5041288643123	9260	4802	4	0	530
88946	1693	4979055802295	9260	4802	5	0	531
256841	600	66344300665601	9262	4803	1	0	0
88960	1693	4792357279811	9262	4803	3	0	534
256847	103	66344300665601	9262	4803	7	0	0
88981	1397	1387214855000	9264	4804	1	0	5162
256867	1678	8640245246000	9264	4804	4	0	0
88986	1693	4356727394015	9264	4804	6	0	541
256873	663	66344300665601	9264	4804	10	0	0
88992	1693	3253678568755	9264	4804	12	0	547
256880	1483	0	9268	4805	1	0	0
88999	1693	2821828159128	9268	4805	3	0	551
256885	569	66344300665601	9268	4805	6	0	0
89004	1726	785583052000	9268	4805	8	0	2137
40804	1686	11012136500013	9268	4805	9	0	2
40805	1686	11012226500013	9268	4805	10	0	2
256891	1678	8640245249000	9269	4806	3	0	0
89010	1726	785573051000	9269	4806	5	0	2138
256897	560	66344300665601	9269	4806	9	0	0
89019	1397	1387164850000	9271	4807	0	0	5167
43316	1688	122402725000000	9271	4807	3	0	0
256911	1678	8640245252000	9274	4808	0	0	0
256912	1874	201952000	9274	4808	1	0	0
89030	1726	785533047000	9275	4809	0	0	2142
256920	1874	201955000	9278	4811	1	0	0
89040	1397	1387104844000	9280	4812	0	0	5173
256932	1874	201958000	9284	4814	1	0	0
89051	1726	785473041000	9286	4815	0	0	2148
38759	1683	721451073999541	9286	4815	4	0	0
256938	1678	8640245260000	9287	4816	1	0	0
89056	1397	1387054839000	9288	4817	0	0	5178
89187	1397	1387034837000	9292	4819	0	0	5180
257070	1678	8640245263000	9292	4819	0	0	0
89188	1397	1387024836000	9292	4819	1	0	5181
257071	1678	8640245264000	9292	4819	1	0	0
89196	1397	1387004834000	9295	4821	0	0	5183
257079	1678	8640245266000	9295	4821	0	0	0
52320	1714	23749410000000	9297	4823	2	0	2
89202	1726	785373031000	9298	4824	0	0	2158
257085	1874	201969000	9298	4824	0	0	0
31637	1670	22320690000000	9298	4824	2	0	0
89209	1726	785343028000	9301	4826	1	0	2161
257092	1874	201972000	9301	4826	1	0	0
24124	1599	15120350000000	9301	4826	7	0	0
89217	1397	1386924826000	9303	4827	1	0	5191
257100	1678	8640245274000	9303	4827	1	0	0
89226	1397	1386914825000	9305	4828	0	0	5192
257114	1678	8640245276000	9305	4828	5	0	0
89232	1397	1386894823000	9305	4828	6	0	5194
29291	1643	3456285113700	9305	4828	8	0	9
257119	1678	8640245280000	9306	4829	2	0	0
25117	1607	25920693000000	9306	4829	5	0	0
89246	1726	785263020000	9309	4830	0	0	2169
257141	1874	201982000	9314	4831	0	0	0
89267	1397	1386834817000	9316	4832	0	0	5200
469	43	84720459890000	9316	4832	4	0	0
89280	1397	1386804814000	9322	4834	0	0	5203
257157	1678	8640245286000	9322	4834	0	0	0
257162	1678	8640245288000	9322	4834	5	0	0
38761	1683	722891073999541	9322	4834	6	0	0
38762	1683	722891133999541	9322	4834	7	0	0
89286	1397	1386774811000	9323	4835	0	0	5206
14008	1449	730023000459	9323	4835	4	0	2
14009	1449	730063000459	9323	4835	5	0	2
89291	1726	785163010000	9324	4836	1	0	2179
257168	1874	201990000	9324	4836	1	0	0
34585	1677	242646261000000	9326	4837	6	0	0
89298	1726	785133007000	9327	4838	0	0	2182
257175	1874	201993000	9327	4838	0	0	0
257177	1483	0	9327	4838	3	0	0
257178	1678	8640245294000	9327	4838	4	0	0
43992	1690	61201091000000	9327	4838	7	0	0
89308	1726	785113005000	9330	4839	1	0	2184
257188	1678	8640245298000	9332	4841	0	0	0
604	44	82560990000000	9332	4841	2	0	0
89313	1726	785083002000	9333	4842	0	0	2187
257194	1678	8640245302000	9334	4843	2	0	0
51007	1708	12959520000000	9334	4843	4	0	0
51008	1708	12959551000000	9334	4843	5	0	0
89326	1397	1386634797000	9336	4844	0	0	5220
257206	1874	202001000	9336	4844	3	0	0
89332	1726	785032997000	9337	4845	1	0	2192
43325	1688	124562795000000	9339	4846	2	0	0
257216	1678	8640245306000	9341	4847	0	0	0
89345	1397	1386594793000	9344	4848	0	0	5224
257228	1874	202008000	9347	4850	0	0	0
38768	1683	727211223999541	9347	4850	3	0	0
89355	1474	16834314000000	9349	4851	0	0	5
89356	1397	1386564790000	9349	4851	1	0	5227
257235	1874	202010000	9349	4851	4	0	0
89362	1726	784942988000	9350	4852	1	0	2201
257245	1678	8640245314000	9354	4854	0	0	0
89374	1726	784912985000	9356	4855	1	0	2204
35777	1679	70561291980000	9358	4856	2	0	0
257253	1874	202016000	9363	4857	1	0	0
89383	1726	784892983000	9366	4858	1	0	2206
257264	1874	202019000	9369	4860	0	0	0
2958	484	86160522000000	9369	4860	2	0	0
89391	1397	1386454779000	9370	4861	1	0	5238
21368	1560	30240879000000	9371	4862	3	0	1
257272	1969	1000000000	9373	4863	0	0	0
89399	1900	66000000	9373	4863	3	0	7
257281	1678	8640245324000	9375	4864	2	0	0
89410	1726	784822976000	9377	4865	1	0	2213
257291	1678	8640245326000	9379	4866	2	0	0
89427	1397	1386384772000	9383	4867	1	0	5245
89555	1397	1386374771000	9386	4868	0	0	5246
257430	1678	8640245329000	9386	4868	0	0	0
89556	1726	784782972000	9386	4868	1	0	2217
257431	1874	202028000	9386	4868	1	0	0
54077	1723	19440360999760	9387	4869	3	0	0
89564	1397	1386344768000	9389	4870	3	0	5249
257439	1678	8640245332000	9389	4870	3	0	0
23610	1594	15840420000000	9390	4871	3	0	0
89570	1397	1386314765000	9391	4872	2	0	5252
257445	1678	8640245335000	9391	4872	2	0	0
257455	1874	202035000	9394	4873	0	0	0
257456	1874	202036000	9394	4873	1	0	0
89583	1397	1386294763000	9394	4873	3	0	5254
55025	1739	15119520000000	9394	4873	4	0	0
257462	1874	202038000	9395	4874	3	0	0
34593	1677	244806341000000	9395	4874	5	0	0
89589	1726	784672961000	9396	4875	1	0	2228
257468	1678	8640245340000	9396	4875	5	0	0
89599	1726	782232959000	9399	4876	0	0	2232
257481	1678	8640245343000	9401	4877	1	0	0
89608	1726	782212957000	9401	4877	3	0	2234
40837	1686	13172286500013	9403	4878	3	0	2
257491	1874	202045000	9404	4879	1	0	0
89618	1724	20878090000000	9404	4879	3	0	3
257497	1678	8640245347000	9404	4879	7	0	0
89624	1397	1386174751000	9404	4879	9	0	5266
39901	1685	66960778571430	9404	4879	11	0	0
89627	1726	782152951000	9406	4880	0	0	2240
89628	1397	1386164750000	9406	4880	1	0	5267
52510	1715	22320282000000	9406	4880	3	0	0
257504	1874	202050000	9407	4881	0	0	0
38781	1683	731531303999541	9407	4881	3	0	0
19823	1547	10080282000000	9408	4882	3	0	0
89634	1726	782122948000	9409	4883	1	0	2243
257510	1874	202053000	9409	4883	2	0	0
89640	1397	1386104744000	9409	4883	7	0	5273
257516	1874	202056000	9410	4884	0	0	0
57094	1762	12239330000000	9410	4884	3	0	0
89651	1726	782062942000	9415	4886	0	0	2249
257527	1874	202059000	9415	4886	1	0	0
89661	1726	782042940000	9417	4887	2	0	2251
257537	1874	202061000	9417	4887	3	0	0
19128	1536	18720440000000	9420	4888	2	0	0
34602	1677	246966441000000	9424	4889	3	0	0
89671	1726	782002936000	9425	4890	0	0	2255
257547	1874	202065000	9425	4890	1	0	0
89676	1397	1385984732000	9426	4891	1	0	5285
257552	1874	202066000	9426	4891	2	0	0
89686	1449	30053000459	9430	4892	3	0	3
257564	1678	8640245370000	9432	4893	0	0	0
89727	1726	779522930000	9439	4895	0	0	2263
257601	1874	202070000	9439	4895	0	0	0
257602	1678	8640245372000	9439	4895	1	0	0
32467	1673	18720820000000	9439	4895	3	0	0
89734	1726	779502928000	9441	4896	3	0	2265
28279	1637	110882794819997	9441	4896	5	0	0
257610	1874	202073000	9442	4897	1	0	0
38786	1683	735851423999541	9442	4897	2	0	0
89746	1397	1385894723000	9445	4898	3	0	5294
257624	1874	202076000	9447	4899	1	0	0
20524	1555	13680262000000	9447	4899	2	0	0
11864	1422	15840321000000	9448	4900	3	0	0
89756	44	82551009000000	9450	4901	1	0	1
89762	1397	1385854719000	9452	4902	0	0	5298
257636	1678	8640245381000	9452	4902	0	0	0
89763	1726	779442922000	9452	4902	1	0	2271
257649	1874	202080000	9455	4903	1	0	0
89780	1726	779412919000	9459	4904	0	0	2274
56337	1749	15835348000000	9462	4906	1	0	3
257665	1874	202083000	9465	4907	0	0	0
89792	1397	1385794713000	9465	4907	1	0	5304
15488	1467	18002011100000	9465	4907	3	0	0
257670	1678	8640245388000	9466	4908	2	0	0
89797	1397	1385774711000	9466	4908	3	0	5306
12949	1440	20160672000000	9467	4909	2	0	0
257703	1678	8640245392000	9469	4910	2	0	0
89830	1397	1385734707000	9469	4910	3	0	5310
257712	1874	202091000	9471	4911	1	0	0
57423	1764	18720419100000	9471	4911	2	0	2
89967	1726	779302908000	9474	4912	0	0	2285
257840	1874	202092000	9474	4912	0	0	0
89968	1397	1385724706000	9474	4912	1	0	5311
257841	1678	8640245394000	9474	4912	1	0	0
30607	1656	22320501000000	9475	4913	5	0	0
89976	1397	1385684702000	9477	4914	0	0	5315
257849	1678	8640245398000	9477	4914	0	0	0
38792	1683	740171503999541	9477	4914	2	0	0
89982	1397	1385664700000	9479	4916	0	0	5317
257855	1678	8640245400000	9479	4916	0	0	0
257861	1678	8640245401000	9482	4917	0	0	0
257862	1874	202098000	9482	4917	1	0	0
90000	1726	776812901000	9485	4918	1	0	2294
257877	1678	8640245403000	9485	4918	5	0	0
90006	1726	776782898000	9486	4919	0	0	2297
257883	1976	200000000	9488	4921	0	0	0
43339	1688	126722917000000	9488	4921	2	0	0
90014	1726	775552896000	9490	4922	0	0	2300
257890	1678	8640245409000	9491	4923	1	0	0
90019	1397	1385564690000	9492	4924	1	0	5327
34610	1677	248406601000000	9492	4924	4	0	0
257901	1678	8640245411000	9494	4925	2	0	0
90030	1726	775512892000	9494	4925	4	0	2304
25884	1611	15830600000000	9494	4925	6	0	1
90033	1726	775502891000	9496	4926	0	0	2305
90034	1397	1385534687000	9496	4926	1	0	5330
257913	1874	202111000	9499	4927	1	0	0
90044	1397	1385504684000	9500	4928	1	0	5333
257932	1956	2000000000	9506	4929	0	0	0
56033	1747	8638700000000	9506	4929	3	0	0
56039	1747	8638970000000	9506	4929	4	0	0
28284	1637	113042834819997	9508	4930	2	0	0
90066	1726	775442885000	9509	4931	0	0	2311
257940	1678	8640245419000	9509	4931	1	0	0
13291	1444	19440633000000	9509	4931	2	0	0
38799	1683	744491703999541	9511	4932	3	0	0
90077	1397	1385444678000	9513	4933	0	0	5339
257954	1678	8640245423000	9515	4934	0	0	0
90089	1397	1385414675000	9519	4936	0	0	5342
257963	1874	202120000	9519	4936	1	0	0
90113	1397	1385394673000	9523	4937	4	0	5344
257987	1874	202122000	9523	4937	5	0	0
28289	1637	113763004819997	9523	4937	7	0	0
257993	1678	8640245428000	9525	4938	0	0	0
257994	1678	8640245429000	9525	4938	1	0	0
90123	1726	775352876000	9525	4938	3	0	2320
34620	1677	250566702000000	9525	4938	6	0	0
258000	1678	8640245430000	9526	4939	2	0	0
90129	9	32565998000000	9526	4939	4	0	2
43347	1688	128162977000000	9527	4940	3	0	0
258011	1874	202127000	9530	4942	1	0	0
90140	1397	1385344668000	9530	4942	3	0	5349
258021	1678	8640245434000	9532	4943	1	0	0
90150	1726	775302871000	9532	4943	3	0	2325
13665	1447	21600650000000	9532	4943	6	0	0
258034	916	505655775000000	9537	4945	0	0	0
90163	1726	775272868000	9537	4945	2	0	2328
90169	1397	1385274661000	9539	4946	3	0	5356
258042	1678	8640245439000	9539	4946	3	0	0
90170	1726	775262867000	9539	4946	4	0	2329
258047	1678	8640245441000	9540	4947	3	0	0
90184	1397	1385244658000	9543	4948	1	0	5359
258061	1874	202138000	9545	4950	1	0	0
52885	1716	22319491000000	9545	4950	3	0	0
90192	1397	1385204654000	9547	4951	1	0	5363
258069	1874	202141000	9548	4952	1	0	0
12180	1426	14400490000000	9548	4952	3	0	0
90197	1397	1385184652000	9549	4953	0	0	5365
258078	1678	8640245451000	9558	4955	1	0	0
90207	1726	775152856000	9558	4955	3	0	2340
258084	1678	8640245453000	9559	4956	3	0	0
23654	1594	17280510000000	9559	4956	5	0	0
90213	1726	775122853000	9560	4957	1	0	2343
258090	1874	202149000	9562	4959	1	0	0
90218	1726	775092850000	9562	4959	2	0	2346
10832	1402	71282712000000	9562	4959	4	0	0
258102	1950	889410000000	9565	4960	2	0	3
90233	1397	1385074641000	9567	4961	1	0	5376
258112	1874	202156000	9569	4962	3	0	0
90241	1397	1385054639000	9569	4962	5	0	5378
258127	1972	300000000	9571	4963	0	0	0
90255	1397	1385024636000	9571	4963	1	0	5381
258129	1874	202157000	9571	4963	2	0	0
38809	1683	747371973999541	9571	4963	4	0	0
258132	1678	8640245465000	9573	4964	0	0	0
90263	1726	774992840000	9575	4966	0	0	2356
258138	1874	202161000	9576	4967	0	0	0
90270	1958	705988000000	9579	4969	0	0	1
258145	1678	8640245470000	9579	4969	2	0	0
90278	1397	1384944628000	9582	4971	0	0	5389
258156	1874	202166000	9584	4972	1	0	0
90290	1726	774922833000	9586	4973	0	0	2363
258166	1678	8640245476000	9588	4974	1	0	0
38815	1683	751692043999541	9590	4975	3	0	0
90306	1726	774892830000	9594	4976	0	0	2366
90307	1397	1384884622000	9594	4976	1	0	5395
258180	1874	202172000	9595	4977	1	0	0
53646	1719	16559320000000	9595	4977	4	0	0
90313	1397	1384854619000	9596	4978	1	0	5398
258185	1874	202174000	9597	4979	0	0	0
23877	1596	15997575000000	9597	4979	4	0	6
90326	1397	1384824616000	9600	4980	1	0	5401
258198	1950	3989400000000	9600	4980	2	0	4
23226	1593	18720571000000	9602	4981	2	0	0
90334	1397	1384804614000	9603	4982	1	0	5403
34631	1677	252726802000000	9603	4982	3	0	0
258207	1874	202178000	9604	4983	1	0	0
90340	1694	38880368000000	9604	4983	5	0	3
258220	1678	8640245490000	9607	4984	2	0	0
39917	1685	69120858571430	9607	4984	5	0	0
90356	1726	774772818000	9608	4985	1	0	2378
26826	1623	28081890899898	9608	4985	5	0	1
258226	1678	8640245493000	9609	4986	0	0	0
90361	1694	38880367000000	9609	4986	2	0	4
54692	1727	13679325000000	9609	4986	6	0	0
28293	1637	114483004819997	9613	4987	2	0	0
90378	1726	774732814000	9615	4988	1	0	2382
49933	1703	11519550000000	9615	4988	3	0	1
258244	1874	202187000	9618	4989	0	0	0
90397	1397	1384664600000	9620	4990	4	0	5417
258258	1678	8640245500000	9620	4990	4	0	0
16203	1474	17556304000000	9620	4990	9	0	6
90411	1397	1384654599000	9622	4991	0	0	5418
258272	1678	8640245501000	9622	4991	0	0	0
258273	1678	8640245502000	9622	4991	1	0	0
90417	1726	774642805000	9623	4992	0	0	2391
258279	1678	8640245504000	9623	4992	1	0	0
90423	1726	774622803000	9623	4992	6	0	2393
258285	1678	8640245507000	9624	4993	1	0	0
90428	1397	1384584592000	9625	4994	1	0	5425
5282	700	73200280000000	9625	4994	3	0	0
258290	1678	8640245509000	9626	4995	1	0	0
90434	1694	37518253931096	9626	4995	5	0	9
258296	52	66454027022968	9626	4995	7	0	0
90440	1694	35024085909986	9626	4995	11	0	15
90441	1694	34570048887018	9626	4995	12	0	16
90442	1694	34116011864050	9626	4995	13	0	17
258302	164	66454027022968	9626	4995	13	0	0
258307	628	66454027022968	9626	4995	18	0	0
90448	1694	31391789726242	9626	4995	19	0	23
258313	220	66454027022968	9626	4995	24	0	0
90454	1694	28667567588434	9626	4995	25	0	29
90459	1694	2172274127629	9626	4995	30	0	34
258319	1317	1705884771860440	9626	4995	30	0	0
43359	1688	130323559000000	9626	4995	32	0	0
3997	606	81840350000000	9628	4996	3	0	1
258326	1678	8640245512000	9629	4997	2	0	0
90467	1397	1384534587000	9629	4997	3	0	5430
258339	1874	202205000	9631	4998	1	0	0
90480	1726	774532794000	9631	4998	2	0	2402
45505	1692	30260042020000	9631	4998	3	0	4
90486	1726	774522793000	9634	5000	3	0	2403
258346	1874	202207000	9634	5000	3	0	0
258351	1262	610821326200000	9634	5000	8	0	0
90492	1601	2378370600000	9634	5000	9	0	9
258373	1678	8640245521000	9642	5002	0	0	0
90514	1726	774472788000	9642	5002	1	0	2408
90521	1726	774442785000	9647	5005	0	0	2411
258381	1874	202215000	9647	5005	0	0	0
258389	1874	202217000	9650	5007	0	0	0
90530	1397	1384404574000	9650	5007	1	0	5443
35793	1679	72721351980000	9650	5007	3	0	0
258399	1678	8640245528000	9654	5009	2	0	0
90540	1979	16240261610390	9655	5010	0	0	4
258401	1678	8640245529000	9655	5010	1	0	0
258402	1874	202220000	9655	5010	3	0	0
32479	1673	20881000000000	9655	5010	4	0	0
90545	1397	1384364570000	9656	5011	2	0	5447
258408	1678	8640245532000	9657	5012	2	0	0
90551	1979	823876553266	9657	5012	5	0	8
38821	1683	756012153999541	9657	5012	7	0	0
258418	1678	8640245534000	9661	5014	0	0	0
90564	1726	774342775000	9663	5015	1	0	2421
258429	1874	202226000	9665	5016	0	0	0
90572	1397	1384294563000	9665	5016	3	0	5454
23666	1594	18000550000000	9665	5016	5	0	0
90577	1726	774302771000	9668	5018	0	0	2425
258437	1874	202229000	9668	5018	0	0	0
90578	1397	1384274561000	9668	5018	1	0	5456
992	58	86880865000000	9671	5019	3	0	0
258457	1874	202231000	9674	5020	2	0	0
90598	1726	774272768000	9674	5020	3	0	2428
258462	1390	1693980637758216	9675	5021	2	0	0
90604	1633	15120239987586	9675	5021	4	0	3
258481	1024	502777775001948	9679	5022	3	0	0
19648	1546	18720440000000	9679	5022	5	0	0
90632	1522	15119910000000	9682	5023	0	0	6
16862	1489	20160671000000	9684	5024	2	0	0
258503	1874	202236000	9687	5025	0	0	0
90644	1397	1384194553000	9687	5025	1	0	5464
258508	1980	1000000000	9688	5026	3	0	0
90650	596	83898262000000	9689	5027	0	0	1
258514	1678	8640245550000	9689	5027	4	0	0
29606	1649	15120600999992	9689	5027	5	0	0
90665	1633	5061500922591	9691	5028	0	0	6
258530	1874	202241000	9691	5028	5	0	0
90671	1726	774172758000	9691	5028	6	0	2438
258535	1678	8640245554000	9692	5029	0	0	0
258540	1874	202243000	9695	5030	0	0	0
90681	1850	17975550000000	9695	5030	1	0	1
258541	1682	11441000000	9695	5030	1	0	6
90722	1981	100900000000	9700	5031	0	0	1
90723	1397	1384104544000	9700	5031	1	0	5473
38834	1683	760332203999541	9700	5031	3	0	0
258586	1678	8640245557000	9701	5032	1	0	0
90729	1850	10379540000000	9701	5032	4	0	2
258592	911	505032775000000	9701	5032	7	0	0
90735	1397	1384084542000	9702	5033	2	0	5475
258611	1678	8640245559000	9706	5034	0	0	0
90754	1726	774112752000	9706	5034	3	0	2444
44005	1690	63361221000000	9706	5034	5	0	0
258619	764	1000010000000	9708	5035	2	0	0
54099	1723	21600440999760	9711	5036	2	0	0
90767	1726	774092750000	9713	5037	1	0	2446
90920	1726	774082749000	9720	5038	0	0	2447
258773	1874	202251000	9720	5038	0	0	0
90921	470	69760381000000	9720	5038	1	0	4
258774	1183	610880750000000	9720	5038	1	0	0
90931	1536	18409250000000	9722	5039	1	0	1
258784	260	66311200000000	9722	5039	1	0	0
90994	596	81618162000000	9726	5040	0	0	2
258846	940	505057775000000	9726	5040	0	0	0
90995	1726	774052746000	9726	5040	1	0	2450
258847	1874	202254000	9726	5040	1	0	0
91001	1701	9974294736852	9726	5040	7	0	7
258853	1042	904568230701196	9726	5040	7	0	0
91020	1397	1383974531000	9728	5041	4	0	5486
258872	1678	8640245569000	9728	5041	4	0	0
91025	1536	936310000000	9728	5041	9	0	5
258877	947	505148475000000	9728	5041	9	0	0
34646	1677	254886892000000	9731	5042	2	0	0
91048	1536	0	9733	5043	0	0	6
258900	260	67247500000000	9733	5043	0	0	0
91054	1671	7732365128278	9733	5043	6	0	2
258906	1119	906038704109009	9733	5043	6	0	0
91059	1726	773972738000	9733	5043	11	0	2458
258911	1874	202262000	9733	5043	11	0	0
258949	1678	8640245577000	9738	5045	0	0	0
91098	1476	10732380000000	9738	5045	1	0	1
258950	1371	1701968637751650	9738	5045	1	0	0
11405	1419	23760530000000	9738	5045	7	0	0
91115	1726	773942735000	9741	5046	0	0	2461
258967	1874	202265000	9741	5046	0	0	0
91120	1476	0	9741	5046	5	0	5
91121	1689	16348030489454	9741	5046	6	0	3
258973	909	505147213510546	9741	5046	6	0	0
91126	1397	1383864520000	9743	5047	0	0	5497
258987	1678	8640245581000	9745	5048	2	0	0
91137	1689	12102015979905	9745	5048	4	0	4
258996	1874	202271000	9748	5050	0	0	0
91146	1689	9237145057216	9748	5050	3	0	5
259003	1678	8640245585000	9750	5051	3	0	0
20915	1559	20880651000000	9750	5051	5	0	0
91155	1726	773872728000	9752	5052	0	0	2468
47952	1696	15118421000000	9752	5052	3	0	1
259013	1874	202273000	9754	5053	1	0	0
38842	1683	764652425999541	9754	5053	2	0	0
91163	1726	773852726000	9755	5054	1	0	2470
259019	1984	1254900000000	9756	5055	3	0	0
91173	1726	773832724000	9759	5056	1	0	2472
259029	1678	8640245592000	9761	5058	1	0	0
91178	1726	773822723000	9761	5058	2	0	2473
259034	1874	202278000	9762	5059	3	0	0
91184	1397	1383724506000	9762	5059	5	0	5511
149	42	83278060000000	9762	5059	7	0	4
259040	1610	0	9763	5060	2	0	6
91226	1726	773772718000	9768	5061	1	0	2478
259067	1874	202283000	9768	5061	5	0	0
91231	1711	18719399000000	9768	5061	6	0	1
91248	1726	773752716000	9770	5062	1	0	2480
43372	1688	132483629000000	9770	5062	3	0	0
259078	1874	202286000	9772	5064	0	0	0
18695	1522	15839910000000	9772	5064	2	0	6
91257	1726	773722713000	9776	5065	0	0	2483
259084	1874	202287000	9776	5065	0	0	0
91258	1397	1383644498000	9776	5065	1	0	5519
259085	1678	8640245602000	9776	5065	1	0	0
91264	1711	1244355000000	9777	5066	5	0	9
259091	1367	1701968637751650	9777	5066	5	0	0
22610	1587	17280331000000	9779	5067	4	0	0
91274	1397	1383614495000	9780	5068	1	0	5522
259101	1678	8640245605000	9780	5068	1	0	0
91286	1397	1383594493000	9783	5069	3	0	5524
259113	1678	8640245607000	9783	5069	3	0	0
32900	1675	17280749999977	9784	5070	2	0	0
91292	1397	1383564490000	9786	5072	0	0	5527
259119	1678	8640245610000	9786	5072	0	0	0
91298	1675	11060749999977	9787	5073	2	0	2
259125	1096	904965465000000	9787	5073	2	0	0
91310	1726	773622703000	9789	5074	0	0	2493
259137	1874	202297000	9789	5074	0	0	0
91316	1587	1146594000000	9789	5074	6	0	5
259143	272	66282330000000	9789	5074	6	0	0
1259	149	78960327000000	9789	5074	8	0	0
91322	1602	6391360000000	9790	5075	4	0	3
259149	1243	609889750000000	9790	5075	4	0	0
91327	1726	773592700000	9791	5076	1	0	2496
259154	1874	202300000	9791	5076	1	0	0
38852	1683	768972565999541	9791	5076	3	0	0
91335	1726	772352697000	9794	5078	2	0	2500
259162	1874	202303000	9794	5078	2	0	0
14817	1457	20880501000000	9794	5078	5	0	0
91341	1602	0	9796	5080	2	0	5
259168	1989	860340000000	9796	5080	2	0	0
91352	1988	190000000	9799	5081	4	0	1
259179	1678	8640245623000	9799	5081	6	0	0
91358	1672	1005703000000	9799	5081	10	0	4
28309	1637	116643054819997	9799	5081	11	0	0
259192	1678	8640245624000	9805	5083	0	0	0
91371	1972	299000000	9806	5084	2	0	1
259198	1678	8640245627000	9807	5085	1	0	0
91384	1726	772272689000	9810	5086	0	0	2508
259211	1974	0	9810	5086	2	0	1
91390	1972	292000000	9810	5086	6	0	8
259217	1974	0	9810	5086	8	0	1
12957	1440	21600740000000	9810	5086	10	0	0
91420	1726	772262688000	9815	5087	0	0	2509
259245	1874	202312000	9815	5087	0	0	0
91421	1522	13833920000000	9815	5087	1	0	7
34658	1677	257047093000000	9815	5087	6	0	0
259251	1874	202313000	9816	5088	0	0	0
91427	1397	1383374471000	9816	5088	1	0	5546
46292	1693	3622570053757	9816	5088	3	0	562
259281	1972	189000000	9819	5089	4	0	11
91457	1974	96000000	9819	5089	5	0	5
259286	1972	189000000	9819	5089	9	0	11
91462	1974	91000000	9819	5089	10	0	10
259304	1974	90000000	9821	5090	3	0	11
91480	1972	186000000	9821	5090	4	0	14
91632	1564	7843257000000	9825	5091	0	0	1
259451	1338	1699817637751650	9825	5091	0	0	0
45530	1692	32420133020000	9825	5091	1	0	4
91633	1564	4738242000000	9826	5092	0	0	2
259452	1092	904078465000000	9826	5092	0	0	0
91639	1726	772212683000	9826	5092	6	0	2514
259458	1874	202317000	9826	5092	6	0	0
91645	1972	182000000	9826	5092	12	0	18
259464	1974	89000000	9826	5092	12	0	12
91650	1974	86000000	9826	5092	17	0	15
259469	1972	180000000	9826	5092	17	0	20
91656	1974	80000000	9826	5092	23	0	21
259475	1972	180000000	9826	5092	23	0	20
43383	1688	134643699000000	9826	5092	26	0	0
91667	1564	545112000000	9828	5093	0	0	5
91743	1397	1383304464000	9830	5094	0	0	5553
259558	1678	8640245636000	9830	5094	0	0	0
259559	1678	8640245637000	9830	5094	1	0	0
91749	1726	772162678000	9830	5094	6	0	2519
259565	1874	202323000	9830	5094	7	0	0
54466	1724	21598090000000	9830	5094	9	0	3
91755	1668	14669835000000	9831	5095	3	0	3
259571	1874	202324000	9831	5095	4	0	0
91760	1726	772112673000	9832	5096	1	0	2524
2377	470	66720011000000	9832	5096	2	0	6
259579	1874	202328000	9834	5097	0	0	0
91769	1726	772062668000	9834	5097	5	0	2529
259585	1678	8640245645000	9834	5097	6	0	0
91775	1668	11357246000000	9834	5097	11	0	4
259591	1370	1703211432751650	9834	5097	12	0	0
91780	1726	772042666000	9836	5099	1	0	2531
52520	1715	24480342000000	9836	5099	2	0	0
259598	1874	202335000	9838	5100	0	0	0
58527	1943	1438920000000	9838	5100	3	0	1
91794	1397	1383124446000	9843	5102	1	0	5571
259612	1678	8640245655000	9845	5103	0	0	0
91804	1726	771992661000	9847	5104	0	0	2536
91805	1726	771982660000	9847	5104	1	0	2537
259623	1678	8640245658000	9847	5104	4	0	0
259625	1874	202341000	9848	5105	0	0	0
91812	1726	771962658000	9850	5106	0	0	2539
259627	1874	202342000	9850	5106	0	0	0
15190	1458	23760445908540	9850	5106	3	0	0
35800	1679	74881452980000	9851	5107	5	0	0
91818	1444	19439533000000	9852	5108	0	0	1
259633	207	66001110000000	9852	5108	0	0	0
91826	1726	771922654000	9856	5111	1	0	2543
259642	1381	1702275295351650	9856	5111	2	0	0
2186	369	87600572000000	9856	5111	7	0	0
91832	1726	771892651000	9857	5112	0	0	2546
259647	1874	202349000	9857	5112	0	0	0
91838	1444	4271309990000	9858	5113	4	0	4
259653	1015	505239650540000	9858	5113	4	0	0
43387	1688	135363918000000	9858	5113	8	0	0
91843	1397	1382954429000	9859	5114	2	0	5588
259659	1678	8640245672000	9859	5114	3	0	0
56858	1759	21600499999999	9859	5114	5	0	1
38862	1683	771852635999541	9860	5115	3	0	0
91856	1397	1382914425000	9866	5117	0	0	5592
259671	1678	8640245675000	9866	5117	0	0	0
91870	1726	771802642000	9870	5119	1	0	2555
259685	1874	202358000	9870	5119	1	0	0
10862	1402	73442803000000	9870	5119	2	0	0
18441	1522	1773910000000	9871	5120	3	0	10
91879	1397	1382854419000	9875	5122	0	0	5598
259695	1874	202361000	9875	5122	1	0	0
91885	1726	771752637000	9876	5123	4	0	2560
259700	1874	202363000	9876	5123	4	0	0
38868	1683	776172715999541	9876	5123	6	0	0
34667	1677	259207184000000	9885	5125	3	0	0
91905	1726	771722634000	9890	5126	1	0	2563
259720	1874	202366000	9890	5126	1	0	0
91910	1397	1382764410000	9892	5128	0	0	5607
259732	1874	202369000	9895	5129	0	0	0
46395	1693	5062710053757	9895	5129	5	0	562
91922	1397	1382734407000	9896	5130	1	0	5610
259737	1678	8640245693000	9896	5130	1	0	0
43393	1688	137523968000000	9898	5131	3	0	0
22297	1573	23040810000000	9900	5132	3	0	0
91932	1726	771642626000	9901	5133	1	0	2571
259747	1874	202374000	9901	5133	1	0	0
29935	1650	12960440000000	9903	5135	3	0	0
91937	1397	1382674401000	9904	5136	0	0	5616
91938	1726	771612623000	9904	5136	1	0	2574
259753	1874	202377000	9904	5136	1	0	0
30859	1657	17280320000000	9904	5136	2	0	0
259761	1874	202379000	9909	5139	1	0	0
259762	1874	202380000	9909	5139	2	0	0
91948	1726	771572619000	9909	5139	3	0	2578
34672	1677	261367224000000	9909	5139	8	0	0
259768	1874	202383000	9910	5140	0	0	0
91954	1397	1382614395000	9910	5140	1	0	5622
13390	1445	15840320000000	9910	5140	3	0	0
22014	1571	13680221001000	9911	5141	5	0	1
91963	1397	1382584392000	9913	5142	0	0	5625
259778	1678	8640245708000	9913	5142	0	0	0
259783	1874	202387000	9915	5144	2	0	0
91969	1726	771502612000	9915	5144	3	0	2585
259792	619	66000500000000	9918	5146	2	0	0
91978	1710	13833317340144	9919	5147	0	0	2
91983	1726	771462608000	9919	5147	5	0	2589
259798	1874	202392000	9919	5147	5	0	0
50769	1706	19436522000000	9922	5149	2	0	6
259805	1678	8640245719000	9923	5150	0	0	0
91991	1726	771432605000	9923	5150	1	0	2592
259818	1154	610330156151454	9927	5152	1	0	0
92004	1710	1774335473290	9927	5152	2	0	5
92009	1726	771392601000	9930	5154	1	0	2596
259824	1874	202399000	9930	5154	1	0	0
259831	1678	8640245725000	9933	5156	2	0	0
92017	1397	1382404374000	9933	5156	3	0	5643
259848	984	505877914565232	9937	5158	2	0	0
92034	1681	15416468106056	9937	5158	3	0	4
92047	1397	1382374371000	9942	5159	1	0	5646
259862	1678	8640245729000	9942	5159	1	0	0
27193	1633	1476209985638	9942	5159	3	0	8
52325	1714	25189480000000	9943	5160	4	0	2
259867	1874	202407000	9944	5161	1	0	0
23391	1594	1442050000000	9944	5161	3	0	5
92053	1726	771302592000	9945	5162	0	0	2605
259873	1874	202410000	9946	5163	3	0	0
92059	1726	771272589000	9946	5163	4	0	2608
28318	1637	118803584819997	9948	5164	0	0	0
92070	1397	1382304364000	9949	5165	3	0	5653
259885	1678	8640245736000	9949	5165	3	0	0
92073	1397	1382274361000	9949	5165	6	0	5656
92074	1397	1382264360000	9949	5165	7	0	5657
259890	1874	202416000	9950	5166	0	0	0
34789	1678	9360245741000	9951	5167	2	0	0
92082	1397	1382234357000	9955	5169	0	0	5660
259897	1678	9360265743000	9955	5169	0	0	0
259898	1678	9360265744000	9955	5169	1	0	0
56335	1749	15555357000000	9955	5169	5	0	4
39929	1685	71280898571430	9961	5170	1	0	0
92113	1397	1382204354000	9966	5171	0	0	5663
259929	1874	202420000	9966	5171	1	0	0
92118	1397	1382184352000	9966	5171	5	0	5665
260018	1295	1701047467188501	9972	5172	0	0	0
92208	1397	1382164350000	9973	5173	0	0	5667
92222	1397	1382154349000	9977	5174	0	0	5668
260036	1678	9360265751000	9977	5174	0	0	0
92223	1726	771142576000	9977	5174	1	0	2621
260037	1874	202424000	9977	5174	1	0	0
53336	1718	14297552889008	9979	5175	2	0	2
92243	1726	771112573000	9982	5176	0	0	2624
260057	1874	202427000	9982	5176	0	0	0
55740	1746	7199241000000	9982	5176	7	0	0
92255	1397	1382104344000	9984	5177	0	0	5673
260069	1678	9360265756000	9984	5177	0	0	0
92306	1397	1382084342000	9989	5178	0	0	5675
260120	1678	9360265758000	9989	5178	0	0	0
92312	1726	771062568000	9990	5179	0	0	2629
260126	1874	202432000	9990	5179	0	0	0
48792	1700	1745660276737	9990	5179	3	0	6
15865	1471	21600470000000	9991	5180	2	0	0
92318	1397	1382034337000	9993	5182	0	0	5680
260132	1678	9360265763000	9993	5182	0	0	0
92323	619	66000499000000	9993	5182	5	0	1
260137	1652	490000000	9993	5182	5	0	3
92492	1397	1382004334000	10001	5184	0	0	5683
260305	1678	9360265766000	10001	5184	0	0	0
92493	44	66000000000000	10001	5184	1	0	3
260306	1991	16540007000000	10001	5184	1	0	0
3240	564	66720011000000	10001	5184	3	0	0
38885	1683	780492765999541	10002	5185	3	0	0
58903	1992	719000000000	10004	5186	2	0	0
58904	1992	719020000000	10004	5186	3	0	0
92522	1397	1381974331000	10007	5187	1	0	5686
260335	1678	9360265769000	10007	5187	1	0	0
92528	1991	16288916155534	10007	5187	8	0	1
260341	83	66251089844466	10007	5187	8	0	0
92533	1991	13372904944501	10007	5187	13	0	6
260346	959	504689421833169	10007	5187	13	0	0
30619	1656	24480703000000	10007	5187	17	0	0
19892	1547	13680383000000	10008	5188	3	0	0
92539	1397	1381934327000	10009	5189	0	0	5690
260352	1678	9360265773000	10009	5189	0	0	0
11889	1422	18000422000000	10010	5190	3	0	0
92552	606	69197768048272	10013	5191	1	0	6
260365	1169	610441411885612	10013	5191	1	0	0
92557	1991	1195085441475	10014	5192	2	0	10
260370	1406	0	10014	5192	2	0	0
92563	1726	770902552000	10015	5193	3	0	2645
260376	1874	202448000	10015	5193	3	0	0
92569	1749	13553394000000	10016	5194	4	0	8
260382	1722	1442118000000	10016	5194	4	0	10
24160	1599	17280440000000	10017	5195	3	0	0
92631	1397	1381834317000	10021	5196	0	0	5700
260444	1678	9360265783000	10021	5196	0	0	0
92632	1726	770852547000	10021	5196	1	0	2650
260445	1874	202453000	10021	5196	1	0	0
92650	1726	770842546000	10023	5197	3	0	2651
260463	1874	202454000	10023	5197	3	0	0
92656	1680	16590087121150	10023	5197	9	0	3
260469	1027	906692283348880	10023	5197	9	0	0
92661	641	80013406000000	10024	5198	2	0	2
260474	970	505753031000000	10024	5198	2	0	0
92667	1397	1381774311000	10026	5200	0	0	5706
260480	1678	9360265789000	10026	5200	0	0	0
43454	1689	720050287614	10026	5200	5	0	7
92673	1764	10162676100000	10027	5201	2	0	5
260486	1334	1702537637751650	10027	5201	2	0	0
34692	1677	264247384000000	10027	5201	3	0	0
92678	1397	1381734307000	10029	5203	0	0	5710
260491	1678	9360265793000	10029	5203	0	0	0
92707	1397	1381704304000	10032	5205	0	0	5713
260520	1678	9360265796000	10032	5205	0	0	0
92723	1726	770722534000	10035	5206	1	0	2663
260536	1874	202466000	10035	5206	1	0	0
92728	1397	1381674301000	10036	5207	1	0	5716
260541	1678	9360265799000	10036	5207	1	0	0
34697	1677	265687465000000	10036	5207	3	0	0
54876	1729	15839450000000	10039	5208	3	0	0
92742	1397	1381644298000	10040	5209	2	0	5719
260555	1678	9360265802000	10040	5209	2	0	0
92814	1397	1381614295000	10047	5211	0	0	5722
260627	1678	9360265805000	10047	5211	0	0	0
92815	1726	770662528000	10047	5211	1	0	2669
260628	1874	202472000	10047	5211	1	0	0
34703	1677	267847545000000	10050	5212	3	0	0
92828	1726	770632525000	10055	5215	0	0	2672
260641	1874	202475000	10055	5215	0	0	0
35807	1679	77041492980000	10055	5215	4	0	0
92837	1702	151000000	10057	5216	2	0	3
260650	1651	9354000000000	10057	5216	2	0	0
38897	1683	784812846999541	10057	5216	3	0	0
92858	1397	1381524286000	10061	5218	3	0	5731
260671	1678	9360265814000	10061	5218	3	0	0
92864	1726	765752521000	10061	5218	9	0	2680
260677	1996	200000000	10061	5218	9	0	0
92871	1423	3336987230768	10063	5219	1	0	1
260684	199	66263082769232	10063	5219	1	0	0
92889	1423	2810801692304	10066	5220	1	0	3
92890	1423	2547708923072	10066	5220	2	0	4
260703	282	66263082769232	10066	5220	2	0	0
92896	1423	969152307680	10066	5220	8	0	10
260709	343	66263082769232	10066	5220	8	0	0
260731	1874	202483000	10069	5221	0	0	0
260732	1678	9360265818000	10069	5221	1	0	0
92932	1397	1381474281000	10071	5222	1	0	5736
260748	1998	200000000	10071	5222	4	0	0
92937	1726	763272515000	10071	5222	6	0	2688
260754	1678	9360265821000	10071	5222	10	0	0
92943	1764	5611175100000	10071	5222	12	0	6
260759	1874	202488000	10072	5223	1	0	0
92949	58	69984694999659	10072	5223	4	0	5
38904	1683	787692958999541	10072	5223	8	0	0
260765	1348	1704113322026672	10073	5224	0	0	0
92954	1397	1381424276000	10073	5224	2	0	5741
260771	1874	202489000	10073	5224	6	0	0
92960	1726	762002509000	10073	5224	8	0	2695
260776	982	505785181543521	10073	5224	11	0	0
92969	1397	1381384272000	10076	5226	1	0	5745
260785	1874	202493000	10076	5226	4	0	0
92974	1759	493999999	10076	5226	6	0	7
260791	269	66411417920446	10077	5227	3	0	0
92987	1397	1381354269000	10079	5228	0	0	5748
260803	683	66146585999999	10079	5228	3	0	0
92999	1726	760732503000	10081	5229	0	0	2702
260815	1678	9360265834000	10082	5230	1	0	0
93004	1749	3996392000000	10082	5230	3	0	10
34709	1677	270727583000000	10083	5231	2	0	0
93034	1397	1381304264000	10085	5232	0	0	5753
260847	1678	9360265836000	10085	5232	0	0	0
93035	1397	1381294263000	10085	5232	1	0	5754
260849	1678	9360265838000	10085	5232	2	0	0
260850	22	22439350095941	10085	5232	3	0	0
93041	1684	39586618150927	10085	5232	7	0	6
260856	333	66335084938283	10085	5232	9	0	0
93047	1684	37576048521229	10085	5232	13	0	12
260862	474	66335084938283	10085	5232	15	0	0
93052	1684	35900573829814	10085	5232	18	0	17
260867	490	66335084938283	10085	5232	20	0	0
93058	1726	759482499000	10085	5232	24	0	2707
260917	1874	202503000	10088	5233	0	0	0
93108	1684	33554909261833	10088	5233	4	0	24
260923	539	66335084938283	10088	5233	6	0	0
93113	1684	31879434570418	10088	5233	9	0	29
260928	573	66335084938283	10088	5233	11	0	0
93119	1397	1381264260000	10088	5233	15	0	5757
260934	585	66335084938283	10088	5233	17	0	0
93125	1750	4182000000	10088	5233	21	0	18
260940	1678	9360265841000	10089	5234	1	0	0
93130	1726	759442495000	10089	5234	4	0	2711
260945	616	66335084938283	10089	5234	6	0	0
93136	1684	26517915557890	10089	5234	10	0	45
93251	311	66000950000000	10091	5235	0	0	1
261064	1762	22318510000000	10091	5235	0	0	0
93252	1684	25847725681324	10091	5235	1	0	47
261065	629	66335084938283	10091	5235	1	0	0
93258	1684	24507345928192	10091	5235	7	0	51
261071	664	66335084938283	10091	5235	7	0	0
18310	1518	4320291000000	10091	5235	13	0	0
93264	1695	8689341000000	10092	5236	1	0	2
261077	1330	1700410637751650	10092	5236	1	0	0
93269	1684	22831871236777	10092	5236	6	0	56
261082	681	66335084938283	10092	5236	6	0	0
93275	1684	22791194880623	10092	5236	13	0	62
261088	769	1005077044519	10092	5236	13	0	0
93281	1729	10493378000000	10092	5236	19	0	2
261094	1087	904404765000000	10092	5236	19	0	0
47982	1696	16558906000000	10092	5236	23	0	1
93347	1695	6381241000000	10096	5237	0	0	3
261160	1204	610212750000000	10096	5237	0	0	0
93348	1695	2961141000000	10096	5237	1	0	4
261161	1084	904393465000000	10096	5237	1	0	0
44013	1690	65521431000000	10098	5238	4	0	0
93358	298	66000970000000	10099	5239	0	0	5
261171	1768	17997411110000	10099	5239	0	0	0
93364	1651	10580274162690	10099	5239	6	0	3
261177	1301	1702887352934139	10099	5239	6	0	0
26514	1622	12239359999976	10099	5239	11	0	0
24297	1601	3818420600000	10101	5240	1	0	9
93369	1397	1381144248000	10102	5241	0	0	5769
261182	1678	9360265852000	10102	5241	0	0	0
93375	1651	3236050115	10103	5242	5	0	6
261188	935	505421310789138	10103	5242	5	0	0
12999	1444	2734875160000	10103	5242	6	0	5
38914	1683	792013059999541	10109	5244	4	0	0
93388	1397	1381094243000	10110	5245	0	0	5774
261201	1678	9360265857000	10110	5245	0	0	0
93393	1596	2777217963415	10110	5245	5	0	9
261206	1237	610550647619768	10110	5245	5	0	0
93527	1726	759402491000	10113	5246	0	0	2715
261340	1874	202509000	10113	5246	0	0	0
93528	1397	1381074241000	10113	5246	1	0	5776
261341	1678	9360265859000	10113	5246	1	0	0
93534	1719	14462199000000	10113	5246	7	0	1
261347	986	504874935000000	10113	5246	7	0	0
93551	1726	759382489000	10115	5247	2	0	2717
261364	1874	202511000	10115	5247	2	0	0
93556	149	74393317000341	10116	5248	2	0	1
261369	1283	1699608907751650	10116	5248	2	0	0
93562	1397	1381044238000	10116	5248	8	0	5779
261375	1678	9360265862000	10116	5248	8	0	0
30908	1660	720000000000	10117	5249	3	0	0
93573	1397	1381024236000	10120	5250	0	0	5781
93574	1726	755722486000	10120	5250	1	0	2723
261387	1874	202514000	10120	5250	1	0	0
261402	1308	1701277837751650	10122	5251	0	0	0
261403	1062	904855165000000	10122	5251	1	0	0
93593	1397	1381014235000	10122	5251	4	0	5782
261409	1874	202515000	10122	5251	7	0	0
93599	1397	1380984232000	10122	5251	10	0	5785
93727	1726	754462481000	10124	5252	0	0	2729
261540	1874	202519000	10124	5252	0	0	0
93728	1397	1380974231000	10124	5252	1	0	5786
261541	1678	9360265869000	10124	5252	1	0	0
93741	1397	1380954229000	10130	5254	1	0	5788
261554	1678	9360265871000	10130	5254	1	0	0
93754	1726	753202476000	10134	5256	2	0	2735
261567	1874	202524000	10134	5256	2	0	0
93759	1762	11549540000000	10136	5257	1	0	3
261572	1061	905796315000000	10136	5257	1	0	0
93918	1726	753182474000	10142	5258	0	0	2737
261730	1874	202526000	10142	5258	0	0	0
93919	1397	1380914225000	10142	5258	1	0	5792
261731	1678	9360265875000	10142	5258	1	0	0
93925	1726	753162472000	10143	5259	4	0	2739
261737	1874	202528000	10143	5259	4	0	0
13692	1447	23760797000000	10143	5259	7	0	0
93943	1397	1380854219000	10152	5262	0	0	5798
261755	1678	9360265881000	10152	5262	0	0	0
11068	1419	2620817280064	10152	5262	2	0	3
93954	1397	1380834217000	10156	5264	1	0	5800
261766	1678	9360265883000	10156	5264	1	0	0
25390	1610	720000000000	10156	5264	4	0	6
10881	1402	74882983000000	10158	5265	3	0	0
93966	1726	753072463000	10161	5266	1	0	2748
261778	1874	202537000	10161	5266	1	0	0
23255	1593	20880726000000	10161	5266	2	0	0
93981	171	79165121590727	10164	5267	0	0	1
93982	1726	753062462000	10164	5267	1	0	2749
261798	1248	610268692849109	10164	5267	5	0	0
93988	1705	19530143600955	10164	5267	7	0	5
261801	1114	903096471754765	10164	5267	8	0	0
261802	1234	609337184961334	10164	5267	9	0	0
93994	1726	753052461000	10165	5268	1	0	2750
35814	1679	79201892980000	10165	5268	2	0	0
261812	1678	9360265889000	10168	5269	1	0	0
94009	1397	1380754209000	10173	5271	1	0	5808
261824	170	66468147446254	10173	5271	4	0	0
94015	1560	28620176768730	10173	5271	7	0	6
261829	382	66468147446254	10173	5271	9	0	0
94021	1560	22892138354864	10173	5271	13	0	12
261835	1165	612000302614993	10173	5271	15	0	0
44022	1690	67681502000000	10173	5271	17	0	0
94026	1726	753012457000	10174	5272	1	0	2754
43404	1688	141124369000000	10174	5272	2	0	0
47022	1694	2892294127629	10175	5273	3	0	34
261855	1874	202545000	10181	5275	0	0	0
94046	1397	1380714205000	10181	5275	3	0	5812
261873	1874	202547000	10186	5276	1	0	0
94077	1397	1380694203000	10190	5277	3	0	5814
261898	412	66000000000000	10192	5278	0	0	0
94089	1397	1380674201000	10192	5278	3	0	5816
261904	1678	10080285901000	10192	5278	6	0	0
94095	1726	751702447000	10193	5279	2	0	2765
261919	1874	202555000	10197	5280	0	0	0
31270	1670	720610000000	10197	5280	2	0	6
34718	1677	271447623000000	10199	5281	3	0	0
94113	1397	1380604194000	10200	5282	0	0	5823
94114	1726	751662443000	10200	5282	1	0	2769
10889	1402	75602983000000	10200	5282	2	0	0
261929	1874	202558000	10202	5283	0	0	0
94124	1726	751632440000	10205	5285	1	0	2772
1393	171	67430240524688	10205	5285	3	0	4
261939	1678	10080285910000	10207	5286	0	0	0
261940	1874	202561000	10207	5286	1	0	0
94143	1726	750392437000	10213	5288	0	0	2776
261957	1874	202565000	10213	5288	2	0	0
94148	1397	1380524186000	10213	5288	5	0	5831
261971	1678	10080285916000	10218	5290	0	0	0
94162	1397	1380494183000	10218	5290	3	0	5834
261976	1874	202569000	10219	5291	1	0	0
94238	1726	750292427000	10225	5292	3	0	2786
262052	1678	10080285920000	10225	5292	5	0	0
35820	1679	81362012980000	10225	5292	9	0	0
94243	1726	750282426000	10226	5293	0	0	2787
262060	1874	202575000	10229	5294	2	0	0
94249	1726	750262424000	10229	5294	3	0	2789
94325	1397	1380414175000	10231	5295	0	0	5842
262136	1678	10080285925000	10231	5295	0	0	0
262137	1678	10080285926000	10231	5295	1	0	0
94334	1455	17820231000000	10233	5296	0	0	1
262146	1678	10080285928000	10233	5296	1	0	0
15511	1467	20882243100000	10237	5297	2	0	0
94362	1397	1380364170000	10240	5298	1	0	5847
32493	1673	22321081000000	10240	5298	3	0	0
262174	1678	10080285931000	10242	5299	0	0	0
34728	1677	273607803000000	10242	5299	5	0	0
94371	1397	1380334167000	10247	5300	0	0	5850
262183	1874	202585000	10247	5300	1	0	0
94377	1397	1380314165000	10248	5301	4	0	5852
262189	1678	10080285936000	10248	5301	5	0	0
25328	1608	16560440000000	10249	5302	3	0	0
94409	1726	748922411000	10252	5303	0	0	2803
262220	2012	200000000	10252	5303	0	0	0
94410	1726	748912410000	10252	5303	1	0	2804
262221	1874	202590000	10252	5303	1	0	0
94416	1448	15101975996189	10253	5304	0	0	1
262227	741	5018666003811	10253	5304	0	0	0
94422	1448	7080551816496	10253	5304	6	0	7
262233	1185	610174180476079	10253	5304	6	0	0
94427	1448	756572000001	10253	5304	11	0	8
262238	1311	1700304607568145	10253	5304	11	0	0
94433	1726	748842403000	10253	5304	17	0	2811
262244	1874	202597000	10253	5304	17	0	0
94441	1397	1380184152000	10258	5307	1	0	5865
262252	1678	10080285948000	10258	5307	1	0	0
32008	1672	3165784000000	10258	5307	6	0	4
94460	1397	1380154149000	10262	5308	1	0	5868
262271	1678	10080285951000	10262	5308	1	0	0
94470	1455	11082031000000	10265	5310	1	0	3
262281	1086	905298465000000	10265	5310	1	0	0
94476	1397	1380124146000	10265	5310	7	0	5871
262287	1678	10080285954000	10265	5310	7	0	0
4688	633	83279840000000	10265	5310	9	0	1
11909	1422	20160492000000	10267	5311	2	0	0
43413	1688	143284589000000	10269	5312	2	0	0
94491	1726	747512391000	10270	5313	0	0	2824
262302	1874	202609000	10270	5313	0	0	0
94497	1726	747482388000	10273	5316	0	0	2827
262308	1874	202612000	10273	5316	0	0	0
94503	1397	1380044138000	10275	5318	1	0	5879
262314	1678	10080285962000	10275	5318	1	0	0
94508	1726	747452385000	10275	5318	6	0	2830
262319	1874	202615000	10275	5318	6	0	0
94514	1397	1380004134000	10276	5319	5	0	5883
262325	1678	10080285966000	10276	5319	5	0	0
94545	1397	1379984132000	10281	5320	0	0	5885
262356	1678	10080285968000	10281	5320	0	0	0
94546	1726	747402380000	10281	5320	1	0	2835
262357	1874	202620000	10281	5320	1	0	0
94552	1705	11047505316625	10282	5321	5	0	11
262363	994	505420610261745	10282	5321	5	0	0
38930	1683	796333689999541	10282	5321	12	0	0
94563	1726	747372377000	10285	5322	0	0	2838
262374	1874	202623000	10285	5322	0	0	0
94572	1724	11017618600000	10287	5323	2	0	6
262383	1057	905712285400000	10287	5323	2	0	0
94588	1397	1379924126000	10292	5325	1	0	5891
262399	1678	10080285974000	10292	5325	1	0	0
34737	1677	275767893000000	10292	5325	4	0	0
94604	1397	1379904124000	10295	5326	4	0	5893
262415	1678	10080285976000	10295	5326	4	0	0
39942	1685	73441179571430	10295	5326	5	0	0
43421	1688	145444669000000	10297	5327	2	0	0
94613	1726	747292369000	10299	5328	2	0	2846
262424	1874	202631000	10299	5328	2	0	0
94619	1726	746062367000	10300	5329	1	0	2849
262430	2014	200000000	10300	5329	1	0	0
1825	337	67440020000000	10303	5330	2	0	0
94628	1397	1379824116000	10304	5331	2	0	5901
262439	1678	10080285984000	10304	5331	2	0	0
94633	1726	746012362000	10305	5332	3	0	2854
262444	1874	202638000	10305	5332	3	0	0
94657	1726	746002361000	10310	5333	0	0	2855
94658	1397	1379794113000	10310	5333	1	0	5904
262472	100	66337270000000	10311	5334	1	0	0
94664	1726	745982359000	10312	5335	0	0	2857
262481	1678	10080285990000	10315	5336	1	0	0
262482	1678	10080285991000	10315	5336	2	0	0
94676	1726	745962357000	10315	5336	3	0	2859
94681	1397	1379734107000	10316	5337	2	0	5910
262488	1678	10080285993000	10316	5337	2	0	0
94687	1726	745922353000	10317	5338	3	0	2863
262494	1874	202647000	10317	5338	3	0	0
262499	1167	610827828691356	10317	5338	8	0	1
48805	1700	3185770276737	10317	5338	10	0	6
94703	1726	745902351000	10319	5339	0	0	2865
26842	1623	30241990899898	10319	5339	3	0	1
94712	1397	1379674101000	10321	5340	3	0	5916
262519	1678	10080285999000	10321	5340	3	0	0
20933	1560	2033997277001	10321	5340	5	0	15
59119	2000	200000001	10321	5340	5	1	0
38936	1683	799213719999541	10324	5341	2	0	0
94726	1726	745852346000	10325	5342	3	0	2870
262533	1874	202654000	10325	5342	3	0	0
262542	1054	906181830077410	10328	5344	0	0	0
94736	1714	14280219598078	10328	5344	1	0	5
94746	1397	1379604094000	10330	5345	1	0	5923
262553	1678	10080286006000	10330	5345	1	0	0
43429	1688	146884790000000	10330	5345	6	0	0
94752	1726	745782339000	10332	5347	0	0	2877
262559	1874	202661000	10332	5347	0	0	0
262564	1678	10080286010000	10332	5347	5	0	0
46604	1693	7942741053757	10332	5347	7	0	563
94758	1773	0	10333	5348	0	0	24
94763	1726	745742335000	10333	5348	5	0	2881
262570	1874	202665000	10333	5348	5	0	0
48830	1700	3905770276737	10334	5349	3	0	6
94774	1726	745722333000	10337	5350	1	0	2883
262581	1874	202667000	10337	5350	1	0	0
262586	1678	10080286018000	10339	5352	0	0	0
94780	1726	745692330000	10339	5352	1	0	2886
2405	470	68160111000000	10339	5352	3	0	6
94796	1726	745672328000	10345	5354	0	0	2888
94797	1726	745662327000	10345	5354	1	0	2889
262605	1874	202674000	10345	5354	2	0	0
94803	1726	745642325000	10346	5355	1	0	2891
262615	1678	10080286024000	10349	5356	0	0	0
262621	1874	202677000	10351	5357	0	0	0
262622	1874	202678000	10351	5357	1	0	0
94817	1397	1379404074000	10351	5357	3	0	5943
20279	1549	28080716000000	10351	5357	4	0	0
262638	1678	10080286028000	10359	5359	1	0	0
94834	1726	745582319000	10364	5360	0	0	2897
262646	1678	10080286031000	10365	5361	3	0	0
94849	333	66324984938283	10368	5362	0	0	1
262660	1678	10080286033000	10368	5362	5	0	0
41123	1687	7285184726450	10368	5362	6	0	4
94860	1397	1379324066000	10370	5363	1	0	5951
262679	1678	10080286035000	10376	5364	3	0	0
94873	1397	1379304064000	10376	5364	4	0	5953
21397	1564	1986173000000	10376	5364	6	0	5
262685	1678	10080286039000	10377	5365	4	0	0
94879	1397	1379264060000	10377	5365	5	0	5957
44032	1690	69841606000000	10377	5365	9	0	0
262690	1009	504335775000000	10378	5366	0	0	0
94885	1650	6724110000000	10378	5366	2	0	4
262706	1874	202693000	10381	5367	0	0	0
94900	1726	745452306000	10381	5367	1	0	2910
262712	1678	10080286044000	10382	5368	2	0	0
94908	1397	1379214055000	10384	5369	0	0	5962
95044	1726	745412302000	10390	5371	0	0	2914
262851	1874	202698000	10390	5371	0	0	0
95045	1397	1379194053000	10390	5371	1	0	5964
262852	1678	10080286047000	10390	5371	1	0	0
95053	1726	745382299000	10393	5373	0	0	2917
262860	1874	202701000	10393	5373	0	0	0
95066	1397	1379134047000	10399	5376	0	0	5970
262873	1678	10080286053000	10399	5376	0	0	0
95067	1726	745352296000	10399	5376	1	0	2920
262880	1874	202706000	10402	5378	0	0	0
95075	1397	1379114045000	10403	5379	1	0	5972
38949	1683	803533819999541	10403	5379	2	0	0
262886	1678	10080286057000	10405	5381	1	0	0
95081	1397	1379074041000	10405	5381	3	0	5976
262889	1874	202710000	10405	5381	4	0	0
262890	1874	202711000	10405	5381	5	0	0
27714	1634	20160443899999	10406	5382	2	0	0
95088	1397	1379054039000	10408	5383	0	0	5978
262898	1874	202714000	10408	5383	3	0	0
27204	1633	2916269985638	10408	5383	5	0	8
95099	1726	745232284000	10410	5384	2	0	2932
1145	149	69149637000341	10410	5384	6	0	4
262909	1678	10080286065000	10411	5385	0	0	0
95105	1726	745212282000	10412	5386	2	0	2934
34747	1677	277207932000000	10412	5386	4	0	0
262916	31	1323893248766000	10414	5387	1	0	0
95112	1726	745202281000	10414	5387	4	0	2935
262927	1678	10080286070000	10416	5388	0	0	0
95123	1397	1378954029000	10416	5388	3	0	5988
262939	1678	10080286072000	10419	5389	1	0	0
95135	1726	745142275000	10420	5390	2	0	2941
262944	1874	202727000	10420	5390	4	0	0
95140	1688	129725092671000	10420	5390	7	0	7
262950	1678	10080286075000	10420	5390	10	0	0
12207	1426	16560630000000	10420	5390	12	0	0
95172	1726	745102271000	10424	5391	1	0	2945
262982	792	613571113264101	10425	5392	2	0	0
4751	641	67831570000000	10425	5392	5	0	4
95178	1397	1378874021000	10426	5393	1	0	5996
263002	1678	10080286081000	10428	5394	1	0	0
95198	1688	116579618037000	10428	5394	4	0	12
95201	1726	745072268000	10428	5394	7	0	2948
263008	1874	202732000	10428	5394	7	0	0
95202	1726	745062267000	10428	5394	8	0	2949
263014	823	1731919963467760	10428	5394	13	0	0
95208	1688	27720427904000	10428	5394	14	0	18
263022	480	66001000000000	10431	5396	1	0	0
51468	1710	3934415473290	10431	5396	3	0	5
95228	1397	1378814015000	10436	5397	0	0	6002
263035	1678	10080286085000	10436	5397	0	0	0
263036	1874	202737000	10436	5397	1	0	0
38955	1683	807853879999541	10436	5397	2	0	0
95233	1445	6675310000000	10437	5398	3	0	3
263042	1874	202739000	10438	5399	1	0	0
95239	1726	744992260000	10439	5400	1	0	2956
30222	1654	18000451000000	10439	5400	3	0	0
263048	1874	202741000	10440	5401	0	0	0
95245	1397	1378754009000	10440	5401	4	0	6008
30875	1657	19441012000000	10440	5401	5	0	0
263053	1678	10080286092000	10441	5402	0	0	0
4325	632	84000623000000	10441	5402	3	0	0
95253	1397	1378734007000	10443	5403	2	0	6010
35833	1680	1449149500035	10443	5403	3	0	6
263065	1678	10080286094000	10445	5404	1	0	0
95262	1679	73461673341000	10445	5404	5	0	4
263071	853	246870194966225	10445	5404	7	0	0
24591	1602	1440200000000	10445	5404	11	0	5
95493	1726	744922253000	10455	5405	0	0	2963
263300	1874	202747000	10455	5405	0	0	0
95494	1679	59652345518000	10455	5405	2	0	7
263301	855	130585080959125	10455	5405	2	0	0
95500	1679	39199738031000	10455	5405	8	0	12
263307	869	260039024940845	10455	5405	8	0	0
95525	2017	343100000000	10458	5406	0	0	1
263332	1483	0	10458	5406	0	0	0
95548	1397	1378674001000	10461	5407	0	0	6016
263355	1678	10080286099000	10461	5407	0	0	0
33113	1677	28728101325000	10461	5407	6	0	1
95564	1679	18347955835000	10465	5408	1	0	18
263371	891	495322720879750	10465	5408	1	0	0
95570	1679	17179532223000	10466	5409	0	0	21
263377	901	117076279480250	10466	5409	0	0	0
95575	1679	14957292711000	10466	5409	5	0	22
263382	905	421024312747938	10466	5409	5	0	0
95599	1397	1378603994000	10469	5410	2	0	6023
263406	1678	10080286106000	10469	5410	2	0	0
95605	1397	1378583992000	10470	5411	4	0	6025
263412	1678	10080286108000	10470	5411	4	0	0
95609	1726	741172241000	10470	5411	8	0	2978
95610	1972	177000000	10470	5411	9	0	23
263417	1406	0	10470	5411	9	0	0
95616	1972	171000000	10470	5411	15	0	29
263423	1406	0	10470	5411	15	0	0
46678	1693	9382761053757	10470	5411	19	0	563
95624	295	66000000665601	10473	5413	0	0	2
263431	1483	0	10473	5413	0	0	0
263433	1678	10080286110000	10473	5413	2	0	0
263434	1678	10080286111000	10474	5414	0	0	0
95629	1726	741132237000	10475	5415	0	0	2982
263445	1874	202764000	10477	5416	1	0	0
95640	1397	1378533987000	10477	5416	3	0	6030
45569	1692	34580240019999	10477	5416	5	0	4
263465	1678	10080286116000	10482	5418	0	0	0
95660	1397	1378483982000	10482	5418	2	0	6035
263470	1874	202769000	10482	5418	5	0	0
95665	1397	1378473981000	10483	5419	1	0	6036
263476	1678	10080286123000	10483	5419	5	0	0
95671	1726	741042228000	10483	5419	7	0	2991
95747	1698	24777896660710	10494	5422	0	0	3
263554	556	66419564339290	10494	5422	0	0	0
95748	1726	741012225000	10494	5422	1	0	2994
263559	1678	10080286125000	10494	5422	5	0	0
95754	1397	1378393973000	10494	5422	7	0	6044
263565	1050	906692283348880	10494	5422	11	0	0
95760	1698	1256783550035	10494	5422	13	0	7
263569	487	66176478352080	10494	5422	15	0	0
263570	744	2005347828843	10494	5422	16	0	0
95765	1706	16767224672027	10494	5422	18	0	11
263576	1874	202780000	10495	5423	0	0	0
12966	1440	24480840000000	10495	5423	1	0	0
95771	1726	740952219000	10496	5424	1	0	3000
263582	988	505106484932068	10496	5424	5	0	0
95777	1706	6411518026475	10496	5424	7	0	19
263587	1678	10080286131000	10496	5424	10	0	0
58138	1850	2798660000000	10496	5424	12	0	5
95826	1397	1378343968000	10501	5425	1	0	6049
263637	1678	10080286134000	10502	5426	3	0	0
95834	1726	739702215000	10504	5427	1	0	3005
263663	1874	202789000	10507	5428	3	0	0
95858	1397	1378303964000	10507	5428	5	0	6053
263668	1678	10080286139000	10507	5428	8	0	0
44042	1690	72001827000000	10507	5428	9	0	0
95866	1726	739642209000	10510	5429	1	0	3011
22897	1588	19440590000000	10510	5429	3	0	0
263685	1678	10080286143000	10514	5430	3	0	0
95880	1726	739612206000	10514	5430	5	0	3014
95887	1726	739602205000	10516	5431	0	0	3015
95888	1397	1378223956000	10516	5431	1	0	6061
3678	606	67819584812962	10516	5431	2	0	8
263701	1874	202796000	10519	5432	1	0	0
3016	495	66720020000000	10519	5432	3	0	0
263716	1874	202798000	10524	5434	0	0	0
95910	1726	739562201000	10524	5434	1	0	3019
263717	1874	202799000	10524	5434	1	0	0
95916	1397	1378163950000	10525	5435	3	0	6067
263723	1678	10800326150000	10525	5435	3	0	0
95968	1726	739512196000	10528	5436	0	0	3024
263776	1874	202805000	10528	5436	1	0	0
95978	1950	6387389000000	10530	5437	2	0	6
263785	2024	1000000000	10530	5437	2	0	0
14241	1451	14400461000000	10530	5437	4	0	0
48017	1696	17998926000000	10531	5438	4	0	1
48018	1696	17998957000000	10531	5438	5	0	1
95988	1726	739472192000	10533	5439	0	0	3028
263795	1874	202808000	10533	5439	0	0	0
36656	1683	63792902149541	10533	5439	7	0	1
95993	1726	739452190000	10534	5440	0	0	3030
263801	1678	10800326160000	10534	5440	1	0	0
2966	484	87600592000000	10534	5440	3	0	0
33127	1677	30888241325000	10537	5442	3	0	1
96001	1397	1378033937000	10538	5443	0	0	6080
263808	1678	10800326163000	10538	5443	0	0	0
16871	1489	20880711000000	10538	5443	3	0	0
96007	1397	1378013935000	10540	5445	1	0	6082
263814	1678	10800326165000	10540	5445	1	0	0
96032	1726	739382183000	10549	5447	0	0	3037
96033	1726	739372182000	10549	5447	1	0	3038
263841	1678	10800326167000	10549	5447	2	0	0
263842	1678	10800326168000	10549	5447	3	0	0
41680	1688	28440468904000	10549	5447	6	0	18
29767	1650	2914041000000	10550	5448	3	0	5
96088	1726	739352180000	10553	5449	0	0	3040
263897	1874	202822000	10553	5449	2	0	0
96094	1397	1377943928000	10553	5449	6	0	6089
22370	1587	1440040000000	10553	5449	7	0	7
263903	1874	202824000	10554	5450	1	0	0
96111	1726	739302175000	10557	5451	2	0	3045
96238	1397	1377903924000	10559	5452	0	0	6093
264045	1678	10800326176000	10559	5452	0	0	0
96239	1726	739282173000	10559	5452	1	0	3047
264046	1874	202827000	10559	5452	1	0	0
24986	1607	4578184644388	10559	5452	3	0	9
96245	1397	1377873921000	10562	5455	1	0	6096
264052	1678	10800326179000	10562	5455	1	0	0
96263	1397	1377843918000	10570	5458	1	0	6099
264070	1678	10800326182000	10570	5458	1	0	0
96272	1726	739192164000	10574	5460	1	0	3056
264079	1874	202836000	10574	5460	1	0	0
36671	1683	68112972149541	10575	5461	4	0	1
96280	1726	739172162000	10577	5462	1	0	3058
264087	1874	202838000	10577	5462	1	0	0
57192	1764	1441723100000	10577	5462	3	0	8
96286	1397	1377753909000	10578	5463	5	0	6108
264093	1678	10800326191000	10578	5463	5	0	0
96289	1726	739122157000	10580	5465	0	0	3063
96290	1397	1377733907000	10580	5465	1	0	6110
54527	1727	3066636000000	10580	5465	2	0	7
264102	1678	10800326194000	10583	5466	0	0	0
10909	1402	77763073000000	10586	5467	2	0	0
96304	1397	1377703904000	10587	5468	1	0	6113
264112	1678	10800326197000	10588	5469	0	0	0
264113	1874	202847000	10588	5469	1	0	0
264118	1874	202848000	10591	5470	0	0	0
96314	1397	1377673901000	10591	5470	3	0	6116
36686	1683	72433072149541	10594	5471	2	0	1
264130	1874	202851000	10595	5472	0	0	0
96325	1397	1377653899000	10595	5472	2	0	6118
264140	1874	202854000	10598	5474	0	0	0
96335	1726	739002145000	10599	5475	0	0	3075
264149	1678	10800326206000	10602	5476	1	0	0
5343	1271	1342686290000000	10605	5477	3	0	0
96349	1397	1377583892000	10606	5478	0	0	6125
55490	1740	20155165000000	10606	5478	3	0	8
264163	1678	10800326209000	10609	5479	1	0	0
96362	1397	1377553889000	10611	5480	1	0	6128
264173	1678	10800326212000	10612	5481	1	0	0
28332	1637	120963624819997	10612	5481	2	0	0
96370	1726	738922137000	10614	5482	1	0	3083
30627	1656	25920754000000	10614	5482	4	0	0
264180	1678	10800326214000	10615	5483	1	0	0
96419	1726	738892134000	10621	5485	0	0	3086
264229	1678	10800326217000	10621	5485	3	0	0
51051	1708	15119672000000	10621	5485	5	0	0
96424	1726	738862131000	10622	5486	1	0	3089
96425	1726	738852130000	10622	5486	2	0	3090
96426	1397	1377483882000	10622	5486	3	0	6135
264235	1678	10800326220000	10622	5486	5	0	0
33165	1677	33048301325000	10624	5487	3	0	1
96442	1397	1377443878000	10627	5488	1	0	6139
264249	1678	10800326222000	10627	5488	1	0	0
264250	2024	832330000000	10627	5488	2	0	0
41732	1688	30600528904000	10628	5489	3	0	18
96452	1726	738802125000	10632	5491	1	0	3095
264260	2027	999000000000	10632	5491	2	0	0
36205	1681	2662988759830	10634	5492	2	0	6
96462	1397	1377403874000	10636	5493	1	0	6143
264271	1874	202878000	10637	5494	0	0	0
96468	1397	1377373871000	10637	5494	5	0	6146
264276	1678	10800326230000	10637	5494	6	0	0
96476	1726	738732118000	10640	5496	1	0	3102
264284	563	83474526000000	10640	5496	2	0	4
36702	1683	76753173149541	10640	5496	3	0	1
96513	1726	738712116000	10644	5498	1	0	3104
264322	1113	905222065000000	10644	5498	3	0	0
96519	1397	1377303864000	10645	5499	3	0	6153
264329	1874	202887000	10647	5500	0	0	0
96541	1397	1377273861000	10653	5501	3	0	6156
264349	1678	10800326240000	10655	5503	0	0	0
96554	1726	738632108000	10658	5504	0	0	3112
264363	1678	10800326242000	10658	5504	2	0	0
17278	1506	18000500000000	10658	5504	4	0	0
96562	1397	1377223856000	10660	5505	0	0	6161
44905	1691	14399402000000	10660	5505	1	0	0
96563	1397	1377213855000	10661	5506	0	0	6162
264378	1678	10800326246000	10666	5507	0	0	0
26853	1623	32402070899898	10666	5507	2	0	1
264390	1874	202896000	10669	5508	0	0	0
264391	1678	10800326247000	10669	5508	1	0	0
96585	1397	1377183852000	10669	5508	2	0	6165
264403	1678	10800326251000	10671	5509	2	0	0
96597	1726	738562101000	10671	5509	3	0	3119
96616	1397	1377143848000	10674	5510	2	0	6169
264423	1678	10800326252000	10674	5510	2	0	0
49139	1701	2230173600056	10675	5511	3	0	9
264432	1874	202905000	10678	5512	1	0	0
33187	1677	35208401325000	10678	5512	3	0	1
96628	1397	1377103844000	10680	5513	0	0	6173
264442	1678	10800326258000	10683	5515	1	0	0
96636	1726	738462091000	10684	5516	0	0	3129
28346	1637	122403725819997	10684	5516	3	0	0
96646	1397	1377053839000	10689	5519	0	0	6178
264453	1678	10800326261000	10689	5519	0	0	0
264462	1678	10800326263000	10692	5520	0	0	0
96656	1726	738422087000	10692	5520	1	0	3133
264468	1233	610771650000000	10695	5522	4	0	0
96662	1397	1377003834000	10696	5523	0	0	6183
36727	1683	82513257149541	10696	5523	3	0	1
96675	1726	738392084000	10698	5524	2	0	3136
264482	1874	202916000	10698	5524	2	0	0
264487	993	505148575000000	10698	5524	7	0	0
13720	1448	2196664000001	10698	5524	9	0	8
96705	1397	1376953829000	10702	5525	0	0	6188
96706	1726	738342079000	10702	5525	1	0	3141
264519	1678	10800326273000	10704	5526	3	0	0
96714	1726	738302075000	10705	5527	1	0	3145
264521	1874	202925000	10705	5527	1	0	0
264522	1874	202926000	10705	5527	2	0	0
96720	1397	1376893823000	10705	5527	7	0	6194
264528	2028	19439100000000	10705	5527	8	0	0
17516	1508	17280452000000	10705	5527	10	0	0
18872	1536	2160060000000	10709	5529	1	0	6
96738	1726	738262071000	10711	5530	0	0	3149
264553	1678	10800326281000	10715	5531	0	0	0
96756	1726	738232068000	10720	5533	0	0	3152
264564	1678	10800326283000	10720	5533	1	0	0
96768	1397	1376813815000	10722	5534	4	0	6202
264576	944	505239650540000	10722	5534	5	0	0
44051	1690	73442028000000	10722	5534	7	0	0
40866	1686	15332346500013	10724	5535	3	0	2
96899	576	79210244938283	10726	5536	0	0	2
264706	1229	610709990000000	10726	5536	0	0	0
96900	576	75052594938283	10726	5536	1	0	3
264707	1109	905131095000000	10726	5536	1	0	0
96915	1726	738182063000	10728	5537	0	0	3157
264722	1874	202937000	10728	5537	0	0	0
59218	2029	719000000000	10730	5538	1	0	0
59219	2029	719010000000	10730	5538	2	0	0
28353	1637	124563797819997	10733	5539	4	0	0
96927	1726	738152060000	10734	5540	0	0	3160
264734	1874	202940000	10734	5540	0	0	0
96934	1726	738132058000	10736	5541	3	0	3162
264741	1874	202942000	10736	5541	3	0	0
36743	1683	86833347149541	10737	5542	4	0	1
96944	1397	1376703804000	10740	5543	1	0	6213
264751	1678	10800326296000	10740	5543	1	0	0
221	43	67440469890000	10740	5543	2	0	1
96950	1726	738072052000	10742	5545	1	0	3168
264757	1874	202948000	10742	5545	1	0	0
96962	1397	1376653799000	10747	5547	1	0	6218
264769	1678	10800326301000	10747	5547	1	0	0
96969	1397	1376643798000	10750	5548	0	0	6219
96970	1726	738042049000	10750	5548	1	0	3171
26537	1622	12959359999976	10750	5548	3	0	0
26540	1622	12959389999976	10750	5548	4	0	0
264784	1874	202952000	10752	5549	2	0	0
96979	1726	735592046000	10752	5549	4	0	3176
264790	1874	202956000	10753	5550	1	0	0
96985	1397	1376603794000	10753	5550	3	0	6223
264793	1678	10800326307000	10753	5550	4	0	0
264794	1678	10800326308000	10753	5550	5	0	0
96990	1397	1376563790000	10756	5552	0	0	6227
264802	1678	10800326311000	10758	5553	1	0	0
55160	1740	4121190000000	10758	5553	3	0	11
97010	1726	735522039000	10762	5554	2	0	3183
264820	1678	10800326314000	10763	5555	1	0	0
22028	1571	15840301001000	10764	5556	3	0	1
97016	1726	735482035000	10765	5557	0	0	3187
264825	1678	10800326316000	10765	5557	2	0	0
34799	1678	11520366317000	10765	5557	5	0	0
97029	2031	199000000	10768	5558	1	0	1
33205	1677	37368495325000	10768	5558	3	0	1
264839	1541	2036000000	10769	5559	2	0	4
97047	1726	735442031000	10773	5560	1	0	3191
264857	1874	202971000	10774	5561	0	0	0
97053	1474	15419858987543	10774	5561	3	0	9
264867	1874	202972000	10776	5562	1	0	0
97063	1397	1376433777000	10776	5562	4	0	6240
14831	1457	22320541000000	10776	5562	5	0	0
264873	1678	11520366325000	10778	5564	1	0	0
10934	1402	79923153000000	10778	5564	3	0	0
97075	1397	1376393773000	10781	5565	1	0	6244
97211	1726	735362023000	10785	5566	0	0	3199
265018	1874	202977000	10785	5566	0	0	0
97212	1726	734152023000	10785	5566	1	0	3200
265019	2032	200000000	10785	5566	1	0	0
44058	1690	75602149000000	10785	5566	5	0	0
97221	1726	734132021000	10788	5568	0	0	3202
265028	1874	202979000	10788	5568	0	0	0
50155	1705	2478799500145	10788	5568	4	0	14
97227	1726	734102018000	10790	5570	0	0	3205
265034	1874	202982000	10790	5570	0	0	0
20917	1559	21118352000000	10790	5570	6	0	1
97238	1726	734082016000	10792	5571	0	0	3207
265045	1874	202984000	10792	5571	0	0	0
97241	1397	1376313765000	10792	5571	3	0	6252
97242	1397	1376303764000	10792	5571	4	0	6253
36762	1683	89713477149541	10792	5571	7	0	1
265051	1540	0	10793	5572	0	0	4
97248	1397	1376273761000	10793	5572	4	0	6256
265072	1678	11520366340000	10799	5573	0	0	0
265073	1874	202989000	10799	5573	1	0	0
97270	1559	17922902000000	10800	5574	3	0	2
265079	1678	11520366343000	10801	5575	0	0	0
97275	1726	733992007000	10801	5575	3	0	3216
3708	606	69259686812962	10801	5575	5	0	8
97405	1726	733982006000	10804	5576	0	0	3217
265212	1874	202994000	10804	5576	0	0	0
97406	1726	733972005000	10804	5576	1	0	3218
265213	1874	202995000	10804	5576	1	0	0
97418	1726	733952003000	10808	5578	1	0	3220
265225	1874	202997000	10808	5578	1	0	0
97548	1726	733942002000	10811	5579	0	0	3221
265355	1874	202998000	10811	5579	0	0	0
97549	1397	1376173751000	10811	5579	1	0	6266
265356	1678	11520366349000	10811	5579	1	0	0
19670	1546	20880551000000	10811	5579	4	0	0
97560	1726	733922000000	10816	5581	2	0	3223
265367	1874	203000000	10816	5581	2	0	0
97566	1718	8083826528460	10816	5581	8	0	7
265373	1172	609999479414015	10816	5581	8	0	0
12393	1439	3172182998477	10816	5581	10	0	6
97576	1397	1376113745000	10820	5583	0	0	6272
265382	1874	203004000	10820	5583	1	0	0
97584	1726	731451995000	10823	5585	1	0	3230
265390	1874	203006000	10823	5585	2	0	0
23702	1596	2160080000000	10823	5585	4	0	11
97599	1726	730211992000	10828	5587	1	0	3234
265405	1874	203009000	10828	5587	2	0	0
15214	1458	25920536908540	10828	5587	5	0	0
97604	1397	1376043738000	10830	5589	1	0	6279
13440	1447	5914380944000	10830	5589	3	0	5
265416	1678	11520366363000	10833	5590	0	0	0
97616	1726	728961988000	10833	5590	5	0	3239
58148	1850	4958760000000	10833	5590	7	0	5
265422	1874	203013000	10834	5591	0	0	0
33218	1677	39528565325000	10835	5592	0	0	1
97622	1506	17137509999713	10836	5593	1	0	3
265428	1007	502777775002188	10836	5593	2	0	0
97627	1726	728921984000	10836	5593	6	0	3243
265433	1874	203017000	10836	5593	7	0	0
32628	1675	3021819999977	10836	5593	10	0	4
97651	1397	1375973731000	10840	5594	0	0	6286
97652	1506	17137469983586	10840	5594	1	0	7
265459	1874	203018000	10841	5595	1	0	0
97658	1726	728891981000	10841	5595	5	0	3246
265465	1007	502777775004376	10842	5596	0	0	0
97676	1506	16850136967172	10845	5597	0	0	13
265481	598	66287273000574	10845	5597	0	0	0
265482	1007	504966173004376	10845	5597	1	0	0
97681	1397	1375933727000	10845	5597	5	0	6290
265488	1678	11520366374000	10846	5598	0	0	0
97692	1397	1375913725000	10848	5599	2	0	6292
265499	1373	1701353880766396	10848	5599	4	0	0
97698	1726	728821974000	10849	5600	3	0	3253
265504	95	66000000000000	10849	5600	4	0	0
97705	1397	1375873721000	10852	5602	0	0	6296
265512	1874	203028000	10852	5602	2	0	0
97711	1726	728781970000	10853	5603	2	0	3257
265518	1874	203031000	10853	5603	4	0	0
39958	1685	75601349571430	10853	5603	6	0	0
97830	1726	728751967000	10855	5604	0	0	3260
265634	1874	203033000	10855	5604	0	0	0
97831	1397	1375823716000	10855	5604	1	0	6301
265635	1678	11520366384000	10855	5604	1	0	0
36781	1683	94033537149541	10855	5604	3	0	1
97847	1726	728721964000	10861	5606	3	0	3263
265651	1874	203036000	10861	5606	3	0	0
2201	369	89040672000000	10861	5606	4	0	0
33232	1677	41688645325000	10864	5607	3	0	1
97866	1723	22303851906979	10868	5609	0	0	2
265670	1000	502777775002781	10868	5609	0	0	0
97917	1726	728671959000	10872	5610	0	0	3268
265721	1874	203041000	10872	5610	0	0	0
23437	1594	4225000000000	10872	5610	3	0	5
97923	1397	1375733707000	10875	5611	0	0	6310
97924	1440	24479840000000	10875	5611	1	0	1
265731	1678	11520366394000	10875	5611	4	0	0
2977	484	89760702000000	10878	5612	3	0	0
97946	1440	23363790000000	10880	5613	0	0	2
265750	2040	1116040000000	10880	5613	0	0	0
265751	1678	11520366396000	10880	5613	1	0	0
97984	1397	1375693703000	10888	5614	1	0	6314
265789	1874	203046000	10888	5614	2	0	0
97991	1397	1375683702000	10890	5615	2	0	6315
265797	924	504692775000000	10891	5616	1	0	0
98002	1397	1375653699000	10893	5617	0	0	6318
265807	1874	203050000	10893	5617	1	0	0
98056	1726	728571949000	10896	5618	4	0	3278
98057	1726	728561948000	10896	5618	5	0	3279
265861	1874	203052000	10896	5618	5	0	0
98058	1726	728551947000	10896	5618	6	0	3280
265881	1874	203055000	10901	5621	1	0	0
98078	1726	728521944000	10901	5621	2	0	3283
265882	1874	203056000	10901	5621	2	0	0
36799	1683	98353627149541	10901	5621	6	0	1
98084	633	72755869900000	10903	5623	1	0	3
265888	1138	905377465000000	10903	5623	1	0	0
98089	1397	1375553689000	10903	5623	6	0	6328
265894	1874	203059000	10903	5623	7	0	0
30882	1657	20161212000000	10903	5623	12	0	0
98095	1755	2156950000000	10904	5624	1	0	1
265899	406	66002000000000	10904	5624	1	0	0
98105	1397	1375513685000	10906	5625	0	0	6332
265909	1678	11520366415000	10906	5625	0	0	0
98110	1656	6750394000000	10907	5626	1	0	3
265915	977	505786775000000	10907	5626	2	0	0
98119	1726	728411933000	10910	5628	1	0	3294
265923	1874	203067000	10910	5628	1	0	0
98187	1608	7396460000000	10915	5630	1	0	2
265991	1043	904405465000000	10915	5630	1	0	0
98192	1397	1375453679000	10915	5630	6	0	6338
98193	1397	1375443678000	10915	5630	7	0	6339
265997	1678	11520366422000	10915	5630	7	0	0
36812	1683	102673707149541	10915	5630	8	0	1
98194	1726	728371929000	10916	5631	0	0	3298
32516	1673	24526611000000	10916	5631	2	0	2
266006	1874	203074000	10919	5632	3	0	0
98204	1397	1375423676000	10919	5632	5	0	6341
266013	1874	203075000	10921	5633	1	0	0
58674	1991	1915083441475	10921	5633	2	0	12
58675	1991	1915103441475	10921	5633	3	0	12
266024	1094	904405024600000	10925	5634	0	0	0
98221	1726	728321924000	10925	5634	1	0	3303
266025	1874	203076000	10925	5634	1	0	0
41765	1688	31320568904000	10925	5634	2	0	18
98227	1422	8662651198464	10927	5635	4	0	5
266050	1874	203078000	10931	5636	0	0	0
17890	1509	20880651000000	10931	5636	3	1	0
98262	1726	728281920000	10937	5638	1	0	3307
266069	1874	203081000	10939	5639	0	0	0
14261	1451	15840553000000	10941	5640	3	0	0
98280	1397	1375323666000	10946	5641	1	0	6351
266084	1678	11520366434000	10946	5641	1	0	0
53851	1723	2518927085979	10947	5642	1	0	6
98316	1397	1375303664000	10951	5643	3	0	6353
266121	1678	11520366437000	10951	5643	4	0	0
98323	1726	728191911000	10954	5645	2	0	3316
266128	1678	11520366439000	10954	5645	3	0	0
59429	2041	719000000000	10954	5645	5	0	0
59430	2041	719340000000	10954	5645	6	0	0
98331	1397	1375253659000	10956	5646	0	0	6358
98332	1726	728181910000	10957	5647	0	0	3317
266138	1678	11520366442000	10957	5647	2	0	0
266191	1534	0	10959	5648	0	0	0
266192	1874	203092000	10959	5648	1	0	0
98389	1397	1375233657000	10959	5648	2	0	6360
266212	1874	203093000	10962	5649	4	0	0
98409	1726	728141906000	10962	5649	5	0	3321
98426	1726	728121904000	10970	5651	1	0	3323
266230	1874	203096000	10970	5651	1	0	0
11087	1419	4781007280064	10971	5652	1	0	3
266238	1874	203098000	10973	5653	3	0	0
2439	470	69600181000000	10973	5653	5	0	6
98435	1726	728091901000	10974	5654	0	0	3326
266246	1874	203101000	10977	5656	0	0	0
98443	1397	1375133647000	10977	5656	1	0	6370
98454	1726	728051897000	10981	5658	1	0	3330
266258	1874	203103000	10981	5658	1	0	0
266267	1678	11520366457000	10985	5660	2	0	0
98464	1397	1375083642000	10985	5660	3	0	6375
98465	1397	1375073641000	10985	5660	4	0	6376
98466	1726	728011893000	10985	5660	5	0	3334
52066	1714	5926223103056	10985	5660	7	0	7
266273	1678	11520366460000	10988	5662	2	0	0
58919	1992	2879080990000	10988	5662	5	0	0
98484	1726	727971889000	10992	5663	1	0	3338
266289	1678	11520366462000	10992	5663	2	0	0
266290	1678	11520366463000	10992	5663	3	0	0
98494	1397	1375013635000	10994	5664	3	0	6382
266300	1874	203114000	10995	5665	1	0	0
41826	1688	33480908904000	10995	5665	3	0	18
28361	1637	126723837819997	10998	5666	2	0	0
98505	1726	727921884000	11002	5667	0	0	3343
266320	1874	203117000	11008	5668	2	0	0
98535	1397	1374963630000	11012	5669	1	0	6387
266339	1678	11520366471000	11012	5669	4	0	0
1156	149	70590027000341	11013	5670	2	0	4
98547	1509	18956312312008	11015	5671	0	0	2
266351	1320	1702889714432878	11015	5671	3	0	0
98552	1397	1374933627000	11015	5671	5	0	6390
266371	1678	11520366475000	11018	5672	3	0	0
29636	1649	16560821999992	11018	5672	5	0	0
98575	1397	1374903624000	11020	5673	1	0	6393
266382	1874	203125000	11022	5674	2	0	0
44066	1690	77042429000000	11025	5675	2	0	0
98606	1726	727811873000	11028	5676	0	0	3354
98607	411	66008410000000	11028	5676	1	0	5
266410	1678	11520366479000	11028	5676	4	0	0
98613	1726	727801872000	11028	5676	7	0	3355
266416	1678	11520366482000	11029	5677	0	0	0
98619	1397	1374833617000	11030	5678	1	0	6400
12695	1440	2879020000000	11030	5678	2	0	6
266421	1874	203133000	11031	5679	1	0	0
18068	1513	16560540000000	11031	5679	3	0	0
98725	1397	1374803614000	11036	5681	0	0	6403
266524	1678	11520366486000	11036	5681	0	0	0
266525	1874	203135000	11036	5681	1	0	0
98741	1397	1374783612000	11044	5683	0	0	6405
98742	1726	727711863000	11044	5683	1	0	3364
18471	1522	3933990000000	11044	5683	3	0	10
266549	1678	12240386489000	11048	5684	1	0	0
98758	1726	727671859000	11052	5686	1	0	3368
266559	1678	12240386492000	11052	5686	3	0	0
266561	1874	203143000	11053	5687	1	0	0
266562	1678	12240386493000	11053	5687	2	0	0
98764	1397	1374723606000	11053	5687	3	0	6411
14355	1455	753851000000	11059	5689	3	0	5
98829	1726	727611853000	11061	5690	2	0	3374
266628	1874	203147000	11061	5690	2	0	0
10960	1402	81363403000000	11061	5690	7	0	0
98835	1726	727591851000	11062	5691	2	0	3376
266634	1874	203149000	11062	5691	2	0	0
36834	1683	106993838149541	11062	5691	4	0	1
53114	1717	17999773000000	11065	5692	2	0	0
266645	1678	12240386502000	11066	5693	1	0	0
98851	1546	21599641000000	11069	5694	0	0	1
44069	1690	77762429000000	11069	5694	3	0	0
4427	633	68763849900000	11070	5695	2	0	5
98858	1397	1374613595000	11072	5696	0	0	6422
266657	1678	12240386505000	11072	5696	0	0	0
41175	1687	9445364726450	11072	5696	2	0	4
47469	1695	2492111000000	11073	5697	3	0	5
98989	1397	1374593593000	11076	5698	0	0	6424
266787	1678	12240386507000	11076	5698	0	0	0
98990	1726	727521844000	11076	5698	1	0	3383
266788	1874	203156000	11076	5698	1	0	0
99003	1726	727491841000	11082	5701	0	0	3386
266801	1874	203159000	11082	5701	0	0	0
99009	1397	1374553589000	11084	5702	0	0	6428
99010	1726	727481840000	11084	5702	1	0	3387
266809	1678	12240386512000	11085	5703	0	0	0
99019	1397	1374533587000	11087	5704	2	0	6430
266817	1678	12240386513000	11087	5704	2	0	0
99025	1726	727421834000	11090	5707	1	0	3393
266823	1874	203166000	11090	5707	1	0	0
44075	1690	79922529000000	11090	5707	2	0	0
99033	1397	1374483582000	11093	5709	1	0	6435
266842	1874	203169000	11099	5710	0	0	0
266843	1678	12240386519000	11099	5710	1	0	0
15527	1467	23042323100000	11099	5710	2	0	0
99059	1691	9334650322910	11101	5711	3	0	3
266859	1284	1699817619025558	11101	5711	5	0	0
24624	1602	3600350000000	11101	5711	10	0	5
99166	1397	1374443578000	11106	5712	0	0	6439
99167	1397	1374433577000	11106	5712	1	0	6440
266966	1874	203172000	11106	5712	2	0	0
45624	1692	36740420019999	11106	5712	5	0	4
266969	1874	203174000	11107	5713	0	0	0
266970	1678	12240386524000	11107	5713	2	0	0
48170	1698	2696813550035	11107	5713	3	0	7
99184	1397	1374413575000	11112	5714	0	0	6442
266987	1678	12240386527000	11113	5715	0	0	0
99190	1726	724891823000	11113	5715	1	0	3406
99211	1726	724871821000	11119	5716	2	0	3408
267009	1874	203179000	11119	5716	2	0	0
161	42	86158240000000	11119	5716	5	0	4
267018	1678	12240386532000	11123	5718	1	0	0
99221	1397	1374333567000	11124	5719	0	0	6450
99301	1726	724821816000	11126	5720	0	0	3413
99302	1397	1374323566000	11126	5720	1	0	6451
267109	1678	12240386535000	11130	5721	0	0	0
267110	1874	203185000	11130	5721	1	0	0
28368	1637	128883887819997	11130	5721	4	0	0
99440	1397	1374293563000	11132	5722	0	0	6454
99441	1726	724791813000	11132	5722	1	0	3416
267242	1678	12240386538000	11134	5723	0	0	0
267243	1874	203188000	11134	5723	1	0	0
16272	1476	2160030000000	11134	5723	2	0	5
99459	1397	1374263560000	11138	5724	3	0	6457
267259	1874	203191000	11138	5724	5	0	0
33267	1677	43848696325000	11139	5725	3	0	1
99467	1397	1374233557000	11141	5726	1	0	6460
26862	1623	34562261899898	11141	5726	2	0	1
267269	1678	12240386545000	11143	5727	1	0	0
99478	1726	724701804000	11145	5728	1	0	3425
267278	1678	12240386547000	11145	5728	3	0	0
99494	1726	724681802000	11151	5731	1	0	3427
267294	1678	12240386550000	11151	5731	3	0	0
18913	1536	4320550000000	11151	5731	5	0	6
14902	1458	5853486908540	11152	5732	2	0	4
99500	1726	724651799000	11153	5733	1	0	3430
58582	1980	10079080000000	11153	5733	3	0	1
267302	1874	203202000	11155	5734	1	0	0
99507	1726	724621796000	11156	5735	2	0	3433
46782	1693	11543011053757	11156	5735	3	0	563
267307	1678	12240386555000	11158	5736	1	0	0
99513	1726	724601794000	11163	5737	3	0	3435
267313	1874	203208000	11163	5737	5	0	0
99519	1397	1374063540000	11165	5739	1	0	6477
25406	1610	2160081000000	11165	5739	3	0	6
41923	1688	36360998904000	11167	5740	0	0	18
267345	1874	203212000	11176	5741	1	0	0
99683	1726	724531787000	11180	5742	0	0	3442
267480	1874	203213000	11180	5742	0	0	0
99684	1726	724521786000	11180	5742	1	0	3443
267481	1874	203214000	11180	5742	1	0	0
56618	1759	2160565999999	11180	5742	5	0	7
99689	1726	724511785000	11181	5743	2	0	3444
99690	1726	724501784000	11181	5743	3	0	3445
267487	1874	203216000	11181	5743	3	0	0
46810	1693	12263041053757	11181	5743	4	0	563
99713	1726	724461780000	11191	5746	0	0	3449
267510	1874	203220000	11191	5746	0	0	0
267514	1678	12240386570000	11193	5747	0	0	0
267515	1874	203221000	11193	5747	1	0	0
56961	1762	4641720994000	11193	5747	3	0	4
10989	1402	83523463000000	11196	5748	3	0	0
99725	1397	1373943528000	11197	5749	0	0	6489
267525	1678	12240386573000	11198	5750	1	0	0
99730	1726	724411775000	11198	5750	3	0	3454
267533	1678	12240386576000	11201	5752	1	0	0
99738	1726	723171772000	11202	5753	1	0	3458
267541	1678	12240386578000	11204	5754	1	0	0
99747	1726	723151770000	11204	5754	4	0	3460
267565	1874	203231000	11208	5755	1	0	0
99770	1397	1373853519000	11208	5755	3	0	6498
267571	1874	203234000	11210	5757	1	0	0
99779	1937	100000000	11212	5758	0	0	2
54762	1729	3886756000000	11212	5758	3	0	4
267579	1874	203236000	11213	5759	0	0	0
99785	1726	723061761000	11213	5759	3	0	3469
267585	1678	12240386586000	11213	5759	6	0	0
99790	1397	1373783512000	11213	5759	8	0	6505
53365	1719	740140000000	11213	5759	10	0	5
267591	1874	203241000	11214	5760	2	0	0
99799	1397	1373743508000	11216	5761	1	0	6509
267599	1678	12240386594000	11217	5762	2	0	0
99805	1397	1373713505000	11218	5763	1	0	6512
267607	1678	12240386597000	11221	5765	0	0	0
99812	1397	1373683502000	11222	5766	0	0	6515
267617	1678	12240386599000	11224	5767	2	0	0
99822	1726	722941749000	11225	5768	0	0	3481
33285	1677	46008746325000	11225	5768	2	0	1
99825	1397	1373643498000	11226	5769	1	0	6519
267622	1678	12240386602000	11226	5769	1	0	0
99826	1397	1373633497000	11227	5770	0	0	6520
267633	1678	12240386605000	11229	5771	0	0	0
99837	1397	1373603494000	11229	5771	1	0	6523
41988	1688	38521038904000	11229	5771	5	0	18
267665	1678	12240386607000	11235	5772	0	0	0
267666	1678	12240386608000	11235	5772	1	0	0
99870	1397	1373573491000	11235	5772	2	0	6526
99881	1726	722903738000	11239	5773	1	0	3492
267678	1874	203262000	11239	5773	1	0	0
49407	1702	1440171000000	11239	5773	2	0	3
28375	1637	131044067819997	11240	5774	3	0	0
99887	1397	1373513485000	11241	5775	2	0	6532
267684	1678	12240386615000	11241	5775	2	0	0
267689	1874	203267000	11243	5776	1	0	0
4346	632	86160694000000	11243	5776	3	0	0
99893	1397	1373493483000	11244	5777	0	0	6534
99906	1397	1373463480000	11247	5778	1	0	6537
267703	1678	12240386620000	11247	5778	1	0	0
99912	1693	12119867131640	11248	5779	3	0	566
267709	217	66414824089930	11248	5779	3	0	0
267734	1678	12240386623000	11251	5780	3	0	0
99938	1693	11785830714280	11251	5780	4	0	569
99943	1693	10172293464881	11251	5780	9	0	574
267740	1030	906636022402500	11251	5780	9	0	0
99949	1397	1373423476000	11252	5781	0	0	6541
267746	1678	12240386624000	11252	5781	0	0	0
267751	390	66414824089930	11252	5781	5	0	0
99955	1726	722890725000	11252	5781	6	0	3505
99960	1693	8861243627205	11253	5782	4	0	586
267757	252	66414824089930	11253	5782	4	0	0
99961	1693	8790710202876	11253	5782	5	0	587
99962	1693	8720176778547	11253	5782	6	0	588
267763	361	66414824089930	11254	5783	2	0	0
99968	1693	8438043081231	11254	5783	4	0	592
267768	1874	203277000	11254	5783	7	0	0
36887	1683	114193978149541	11255	5784	0	0	1
99974	1693	8085375959586	11259	5785	2	0	597
267774	452	66414824089930	11259	5785	5	0	0
99979	1693	7732708837941	11259	5785	7	0	602
267780	180	66414824089930	11259	5785	11	0	0
99985	1693	7377894642837	11259	5785	13	0	608
267785	352	66414824089930	11259	5785	16	0	0
267786	691	66414824089930	11259	5785	17	0	0
99991	1397	1373383472000	11259	5785	19	0	6545
267792	1874	203280000	11259	5785	23	0	0
100020	1693	7025227521192	11261	5786	0	0	613
267822	600	66414824089930	11261	5786	5	0	0
100026	1726	722884719000	11261	5786	6	0	3511
267844	2017	413423424329	11265	5787	3	0	2
100049	1693	6390426702231	11265	5787	5	0	622
267850	1874	203282000	11265	5787	9	0	0
100054	1726	722882717000	11265	5787	10	0	3513
267856	186	66414824089930	11266	5788	4	0	0
100060	1397	1373333467000	11266	5788	5	0	6550
267861	383	66414824089930	11266	5788	9	0	0
100066	1693	5103959956448	11266	5788	11	0	633
267867	450	66414824089930	11266	5788	15	0	0
100071	1693	4751292834803	11266	5788	16	0	638
267873	63	66414824089930	11266	5788	21	0	0
100077	1693	4328092288829	11266	5788	22	0	644
267878	500	66414824089930	11266	5788	26	0	0
100083	1693	3501271690966	11266	5788	28	0	650
267884	1874	203284000	11266	5788	32	0	0
100088	1726	722880715000	11266	5788	33	0	3515
17610	1509	3551723851155	11266	5788	37	0	5
267890	1961	413736265157	11267	5789	2	0	1
100094	1693	3078071144992	11267	5789	3	0	656
100097	1726	722877712000	11267	5789	6	0	3518
23731	1596	4320110000000	11267	5789	7	0	11
100106	1693	2866470872005	11270	5790	0	0	659
267903	194	66414824089930	11270	5790	0	0	0
100112	1397	1373293463000	11270	5790	6	0	6554
267909	1678	12240386637000	11270	5790	6	0	0
46105	1693	1494413003699	11275	5792	1	0	664
267921	1678	12240386639000	11276	5793	0	0	0
100125	1613	11840477800000	11276	5793	1	0	3
267922	1349	1698698829951650	11276	5793	1	0	0
100130	1726	722873708000	11276	5793	6	0	3522
267928	1874	203293000	11276	5793	7	0	0
33307	1677	48168870325000	11276	5793	8	0	1
100229	1397	1373243458000	11282	5795	3	0	6559
268027	1874	203295000	11282	5795	4	0	0
36216	1681	4103069759830	11282	5795	6	0	6
35854	1680	3609259500035	11283	5796	2	0	6
100237	1397	1373223456000	11286	5797	0	0	6561
100238	1726	722868703000	11286	5797	1	0	3527
42026	1688	39961143904000	11286	5797	3	0	18
268038	1678	12240386645000	11288	5798	0	0	0
689	58	70266264999659	11289	5799	2	0	6
100248	1726	722865700000	11291	5800	1	0	3530
15905	1471	23040521000000	11291	5800	3	0	0
268048	1678	12240386648000	11293	5801	0	0	0
100256	1397	1373153449000	11294	5802	1	0	6568
268054	1874	203303000	11294	5802	2	0	0
268062	1678	12240386652000	11298	5803	0	0	0
268063	1874	203305000	11298	5803	1	0	0
100269	1397	1373133447000	11302	5804	0	0	6570
53866	1723	3959047085979	11302	5804	2	0	6
14305	1451	18000583000000	11304	5805	2	0	0
268074	1678	12240386656000	11307	5807	0	0	0
100278	1726	722857692000	11307	5807	1	0	3538
23295	1593	23040856000000	11307	5807	2	0	0
20975	1560	4194088277001	11309	5809	4	0	15
268087	1678	12240386659000	11313	5810	0	0	0
100291	1726	722854689000	11313	5810	1	0	3541
268097	1874	203313000	11319	5812	1	0	0
100301	1397	1373043438000	11320	5813	0	0	6579
27743	1634	22320523899999	11322	5814	1	0	0
268110	1874	203316000	11327	5816	0	0	0
100314	1397	1373013435000	11328	5817	0	0	6582
36914	1683	118514263149541	11329	5818	3	0	1
268118	1678	12240386668000	11331	5819	0	0	0
100322	1726	722846681000	11331	5819	1	0	3549
100327	1726	722844679000	11332	5820	4	0	3551
268123	1874	203321000	11332	5820	4	0	0
100337	1726	722841676000	11336	5822	1	0	3554
268133	1874	203324000	11336	5822	1	0	0
25908	1611	17990851000000	11336	5822	3	0	1
100351	1726	722838673000	11340	5824	2	0	3557
268147	1874	203327000	11340	5824	2	0	0
22399	1587	2880253000000	11340	5824	4	0	7
44715	1691	2123002100019	11342	5825	5	0	5
100362	1397	1372873421000	11344	5826	0	0	6596
268158	1678	12240386679000	11344	5826	0	0	0
100374	1397	1372843418000	11346	5827	0	0	6599
268170	1678	12240386682000	11346	5827	0	0	0
100375	1726	722832667000	11346	5827	1	0	3563
268184	1678	12240386685000	11351	5829	0	0	0
100389	1726	722829664000	11351	5829	1	0	3566
33324	1677	50328954325000	11351	5829	2	0	1
48181	1698	4136864550035	11352	5830	2	0	7
268192	1678	12240386687000	11356	5832	0	0	0
268193	1874	203339000	11356	5832	1	0	0
100399	1397	1372783412000	11358	5833	0	0	6605
268195	1678	12240386688000	11358	5833	0	0	0
100415	1397	1372733407000	11361	5834	4	0	6610
268212	1874	203340000	11361	5834	5	0	0
10995	1402	85683650000000	11361	5834	11	0	0
100421	1397	1372723406000	11362	5835	0	0	6611
268218	1874	203345000	11362	5835	1	0	0
19706	1547	4173224000000	11362	5835	3	0	6
35150	1679	16397332711000	11363	5836	2	0	22
100431	1726	722818653000	11365	5837	2	0	3577
268227	1874	203347000	11365	5837	2	0	0
100444	1397	1372663400000	11369	5839	1	0	6617
268241	1678	12240386701000	11369	5839	2	0	0
100450	1726	722812647000	11370	5840	1	0	3583
28386	1637	132484100819997	11370	5840	3	0	0
268249	1678	12240386703000	11372	5841	0	0	0
100458	1726	722809644000	11373	5842	3	0	3586
268254	1874	203356000	11373	5842	3	0	0
16890	1489	22320742000000	11376	5844	3	0	0
100469	1397	1372583392000	11378	5845	0	0	6625
268266	1678	12240386709000	11378	5845	1	0	0
100483	1397	1372553389000	11383	5847	0	0	6628
268280	1874	203362000	11383	5847	1	0	0
52699	1716	4366638000000	11383	5847	3	0	4
15928	1472	720000000000	11386	5848	2	0	0
42069	1688	41401186904000	11389	5850	1	0	18
100494	1397	1372523386000	11389	5850	2	0	6631
268290	1678	12240386714000	11389	5850	2	0	0
100505	1397	1372513385000	11392	5851	0	0	6632
100506	1726	722798633000	11392	5851	1	0	3597
268308	1874	203368000	11395	5852	1	0	0
39031	1684	5731228880623	11395	5852	3	0	66
100520	1397	1372473381000	11400	5855	0	0	6636
268318	1874	203370000	11400	5855	2	0	0
100530	1397	1372443378000	11403	5857	0	0	6639
268327	1874	203373000	11403	5857	1	0	0
268330	1678	12240386723000	11405	5858	0	0	0
268331	1678	12240386724000	11405	5858	1	0	0
100537	1726	722790625000	11405	5858	3	0	3605
36933	1683	122834297149541	11405	5858	4	0	1
268341	1874	203377000	11407	5859	3	0	0
51497	1710	6094486473290	11407	5859	4	0	5
100547	1397	1372383372000	11408	5860	1	0	6645
268350	1874	203380000	11410	5861	1	0	0
56153	1749	2720472000000	11410	5861	4	0	11
100559	1397	1372363370000	11412	5862	0	0	6647
45654	1692	38900521019999	11412	5862	2	0	4
268360	1678	12240386731000	11416	5864	0	0	0
100570	1397	1372343368000	11419	5865	0	0	6649
32532	1673	27406664000000	11419	5865	2	0	2
268370	1678	12240386734000	11421	5867	0	0	0
100576	1726	721569614000	11421	5867	2	0	3617
268380	1678	12240386737000	11424	5869	0	0	0
48653	1699	4893887050108	11424	5869	2	0	5
100718	1397	1372283362000	11429	5870	0	0	6655
268513	1678	12240386738000	11429	5870	0	0	0
100719	1397	1372273361000	11429	5870	1	0	6656
268514	1678	12240386739000	11429	5870	1	0	0
100725	1397	1372243358000	11431	5872	0	0	6659
268520	1678	12240386742000	11431	5872	0	0	0
100737	1726	721559604000	11436	5874	0	0	3627
268532	1874	203396000	11436	5874	0	0	0
100744	1397	1372193353000	11440	5877	0	0	6664
268539	1678	12240386747000	11440	5877	0	0	0
100873	1397	1372173351000	11442	5878	0	0	6666
268668	1678	12240386749000	11442	5878	0	0	0
100874	1397	1372163350000	11442	5878	1	0	6667
268669	1678	12240386750000	11442	5878	1	0	0
100884	1726	721552597000	11444	5879	3	0	3634
268679	1874	203403000	11444	5879	3	0	0
100894	1397	1372103344000	11451	5882	1	0	6673
268689	1678	12240386756000	11451	5882	1	0	0
42133	1688	43561242904000	11451	5882	5	0	18
100899	1726	721546591000	11452	5883	2	0	3640
268694	1874	203409000	11452	5883	2	0	0
35196	1679	17837366711000	11452	5883	5	0	22
36953	1683	127154340149541	11453	5884	2	0	1
100905	1726	720333588000	11454	5885	2	0	3644
268700	1874	203412000	11454	5885	2	0	0
100973	1397	1372043338000	11457	5887	0	0	6679
268768	1678	12240386762000	11457	5887	0	0	0
100974	1726	720331586000	11457	5887	1	0	3646
268769	1874	203414000	11457	5887	1	0	0
100984	1726	720328583000	11462	5890	1	0	3649
268779	1874	203417000	11462	5890	1	0	0
100990	1726	720325580000	11465	5893	1	0	3652
268785	1874	203420000	11465	5893	1	0	0
31316	1670	2880711000000	11465	5893	3	0	6
33340	1677	52488997325000	11467	5894	2	0	1
101003	1422	3744970860211	11470	5895	2	0	7
268798	971	505003883106880	11470	5895	2	0	0
101009	1397	1371923326000	11471	5896	5	0	6691
268804	1874	203423000	11471	5896	6	0	0
101025	1397	1371913325000	11473	5897	1	0	6692
268823	1678	12240386776000	11476	5898	0	0	0
21419	1564	4146245000000	11476	5898	3	0	5
101034	1726	720316571000	11477	5899	1	0	3661
268832	1678	12240386779000	11479	5900	1	0	0
25158	1608	4605484000000	11479	5900	5	0	4
101046	1726	720313568000	11481	5901	1	0	3664
101049	1397	1371853319000	11483	5902	0	0	6698
101050	1726	720312567000	11483	5902	1	0	3665
268842	1874	203433000	11483	5902	1	0	0
30350	1656	5181306000000	11483	5902	3	0	4
101064	1397	1371813315000	11492	5904	4	0	6702
268855	1874	203435000	11492	5904	6	0	0
49181	1701	4390215600056	11492	5904	8	0	9
101082	1747	8734807000000	11495	5905	2	0	4
268871	1874	203437000	11495	5905	3	0	0
36240	1681	6263091759830	11495	5905	5	0	6
268873	1678	12240386788000	11496	5906	0	0	0
268874	1874	203439000	11496	5906	1	0	0
13462	1447	8074461944000	11496	5906	2	0	5
101178	1397	1371773311000	11499	5907	0	0	6706
101187	1726	719095560000	11501	5908	0	0	3673
101188	1397	1371763310000	11501	5908	1	0	6707
268971	1874	203441000	11501	5908	5	0	0
35236	1679	19277402711000	11501	5908	7	0	22
101200	1704	66194000000	11503	5909	1	0	1
269015	1678	12240386792000	11505	5910	0	0	0
269016	1874	203443000	11505	5910	1	0	0
101244	1397	1371723306000	11506	5911	1	0	6711
269022	1874	203445000	11506	5911	4	0	0
101251	1726	719089554000	11508	5912	1	0	3679
20306	1549	30240777000000	11512	5913	2	0	0
269034	1874	203448000	11513	5914	1	0	0
12238	1426	18720821000000	11513	5914	2	0	0
101267	1726	719086551000	11517	5915	1	0	3682
269072	1874	203450000	11521	5917	2	0	0
33353	1677	53929051325000	11521	5917	5	0	1
101303	1726	719083548000	11522	5918	1	0	3685
269078	1678	12240386804000	11523	5919	2	0	0
101308	1726	719082547000	11523	5919	4	0	3686
101451	1397	1371603294000	11526	5920	0	0	6723
269221	1678	12240386806000	11526	5920	0	0	0
101452	1397	1371593293000	11526	5920	1	0	6724
269222	1678	12240386807000	11526	5920	1	0	0
101457	1397	1371573291000	11527	5921	0	0	6726
101458	1397	1371563290000	11527	5921	1	0	6727
269228	1678	12240386810000	11527	5921	1	0	0
42170	1688	45001276904000	11527	5921	6	0	18
101469	1397	1371543288000	11530	5923	0	0	6729
269239	1678	12240386812000	11530	5923	0	0	0
269244	1874	203465000	11532	5925	1	0	0
44086	1690	82082580000000	11532	5925	2	0	0
101475	1397	1371513285000	11533	5926	0	0	6732
101484	1397	1371503284000	11535	5927	0	0	6733
269254	1678	12240386816000	11535	5927	0	0	0
269286	44	66000000000000	11540	5928	0	0	3
269287	1678	12240386817000	11540	5928	1	0	0
101518	1397	1371483282000	11540	5928	2	0	6735
269302	1678	12240386820000	11543	5929	0	0	0
101533	1726	716644529000	11543	5929	1	0	3706
54546	1727	4506678000000	11544	5930	2	0	7
11004	1402	87843672000000	11546	5931	2	0	0
101542	1726	716641526000	11548	5932	0	0	3709
269312	1874	203474000	11548	5932	0	0	0
269318	1874	203479000	11554	5937	1	0	0
101551	1726	716635520000	11556	5938	0	0	3715
42221	1688	47161288904000	11556	5938	1	0	18
26572	1622	15119431999976	11558	5940	3	0	0
269326	1874	203485000	11559	5941	1	0	0
101557	1726	716629514000	11560	5942	0	0	3721
36970	1683	131474364149541	11560	5942	2	0	1
45678	1692	40340544019999	11562	5943	2	0	4
101564	1726	716624509000	11565	5945	0	0	3726
269334	1874	203491000	11565	5945	0	0	0
28394	1637	134644123819997	11568	5946	2	0	0
51082	1708	17279717000000	11572	5949	2	0	0
269342	1874	203496000	11573	5950	0	0	0
101574	1726	716618503000	11575	5951	0	0	3732
269349	1874	203501000	11578	5954	0	0	0
101580	1726	716613498000	11578	5954	1	0	3737
33373	1677	56089074325000	11579	5955	2	0	1
36984	1683	135794368149541	11586	5959	1	0	1
101587	1726	716608493000	11587	5960	0	0	3742
269357	1874	203507000	11587	5960	0	0	0
49203	1701	5830241600056	11587	5960	2	0	9
57508	1767	719001000000	11588	5961	2	0	0
101594	1726	716604489000	11594	5964	0	0	3746
101597	1726	716603488000	11596	5965	0	0	3747
269367	1874	203512000	11596	5965	0	0	0
12251	1426	19440834000000	11596	5965	3	0	0
24198	1599	19440519999999	11600	5966	2	0	0
18212	1514	3800	11600	5966	3	1	0
50178	1705	4638890500145	11603	5968	0	0	14
101733	1726	716597482000	11605	5969	0	0	3753
269502	1874	203518000	11605	5969	0	0	0
101734	1726	716596481000	11605	5969	1	0	3754
269503	1874	203519000	11605	5969	1	0	0
101742	1726	716590475000	11609	5972	0	0	3760
269511	1874	203525000	11609	5972	0	0	0
101748	1726	716584469000	11611	5974	2	0	3766
269517	1874	203531000	11611	5974	2	0	0
20581	1555	16560372000000	11612	5975	2	0	0
269593	1874	203534000	11614	5976	0	0	0
269595	1874	203535000	11616	5977	0	0	0
58936	1992	5039141990000	11616	5977	2	0	0
101827	1726	716579464000	11617	5978	0	0	3771
51732	1711	3404455000000	11617	5978	1	0	9
269607	1874	203541000	11624	5982	0	0	0
101839	1726	716573458000	11624	5982	1	0	3777
36997	1683	138674372149541	11624	5982	3	0	1
269613	1874	203546000	11625	5983	3	0	0
101845	1726	716568453000	11625	5983	4	0	3782
269620	1874	203551000	11630	5986	0	0	0
13469	1447	8794472944000	11630	5986	1	0	5
101854	1726	716563448000	11633	5987	0	0	3787
101971	1726	716562447000	11636	5988	0	0	3788
269740	1874	203553000	11636	5988	0	0	0
101972	1726	716561446000	11636	5988	1	0	3789
269741	1874	203554000	11636	5988	1	0	0
23464	1594	6385031000000	11639	5990	1	0	5
29667	1649	18720852999992	11640	5991	2	0	0
101983	1726	716555440000	11646	5992	0	0	3795
269752	1874	203560000	11646	5992	0	0	0
54777	1729	6046897000000	11646	5992	1	0	4
46327	1693	4233392155041	11656	5995	2	0	666
102001	1726	716550435000	11658	5996	0	0	3800
39047	1684	7171229880623	11658	5996	1	0	66
102004	1726	716549434000	11662	5997	0	0	3801
269773	1874	203566000	11662	5997	0	0	0
269778	1874	203570000	11663	5998	4	0	0
17538	1508	19440512000000	11663	5998	5	0	0
102018	1726	716544429000	11672	5999	0	0	3806
18944	1536	6480583000000	11674	6001	1	0	6
33409	1677	58969076325000	11675	6002	1	0	1
269792	1874	203576000	11677	6004	0	0	0
102026	1726	716538423000	11680	6005	0	0	3812
56172	1749	4160506000000	11680	6005	4	0	11
102031	2042	1550390000000	11682	6007	0	0	2
269800	411	66006400000000	11682	6007	0	0	6
269805	1874	203582000	11682	6007	5	0	0
102037	1726	716532417000	11682	6007	6	0	3818
269836	1874	203586000	11686	6008	0	0	0
269837	1874	203587000	11686	6008	1	0	0
47524	1695	4652126000000	11686	6008	3	0	5
102072	1726	716526411000	11689	6010	0	0	3824
44091	1690	83522594000000	11693	6011	2	0	0
269848	1874	203593000	11695	6013	1	0	0
37019	1683	142994378149541	11695	6013	2	0	1
102082	1726	716521406000	11697	6014	0	0	3829
33421	1677	60409080325000	11698	6015	2	0	1
269858	1874	203599000	11704	6019	0	0	0
102092	1726	716515400000	11707	6020	0	0	3835
28401	1637	136804129819997	11711	6022	3	0	0
31004	1668	5726513000000	11712	6023	2	0	5
269873	1874	203604000	11715	6024	0	0	0
102107	1726	716509394000	11720	6026	0	0	3841
46429	1693	5673394155041	11720	6026	2	0	666
269891	1874	203610000	11733	6030	0	0	0
102123	641	68061357200000	11734	6031	0	0	5
102148	1726	716504389000	11739	6032	0	0	3846
102149	1726	716503388000	11739	6032	1	0	3847
269918	1874	203612000	11739	6032	1	0	0
269923	1874	203616000	11741	6034	0	0	0
23310	1593	24480879000000	11741	6034	2	0	0
102156	1726	715288383000	11743	6035	0	0	3853
4466	633	70923893900000	11747	6038	1	0	5
269935	1874	203622000	11750	6039	0	0	0
102167	1726	715282377000	11750	6039	1	0	3859
33442	1677	62569083325000	11751	6040	2	0	1
45703	1692	41780545019999	11755	6043	1	0	4
102173	1726	715277372000	11758	6045	0	0	3864
269942	1874	203628000	11758	6045	0	0	0
25182	1608	6045498000000	11758	6045	2	0	4
269953	1874	203633000	11763	6047	1	0	0
102185	1686	15097674705523	11764	6048	0	0	3
269959	1874	203636000	11765	6049	1	0	0
31352	1670	5040733000000	11765	6049	3	0	6
102195	1686	12873315312881	11768	6050	0	0	6
269964	1023	505067760241128	11768	6050	0	0	0
269965	1874	203637000	11768	6050	1	0	0
18076	1513	18720575000000	11768	6050	2	0	0
37046	1683	147314381149541	11770	6051	3	0	1
102203	1686	1651781550062	11771	6052	0	0	9
102334	1726	715265360000	11775	6053	0	0	3876
270103	1874	203640000	11775	6053	0	0	0
102335	1737	1299001100	11775	6053	1	0	1
270104	1646	0	11775	6053	1	0	0
15980	1474	3984366000023	11777	6055	2	0	12
1417	171	69590272524688	11784	6057	2	0	4
102346	1726	715259354000	11785	6058	0	0	3882
270115	1874	203646000	11785	6058	0	0	0
102477	1726	715257352000	11790	6059	0	0	3884
270246	1874	203648000	11790	6059	0	0	0
12728	1440	5039072000000	11790	6059	1	0	6
102478	1726	715256351000	11791	6060	0	0	3885
270247	1874	203649000	11791	6060	0	0	0
59463	2055	719000000000	11791	6060	2	0	0
59464	2055	719002000000	11791	6060	3	0	0
102609	1726	715253348000	11797	6062	0	0	3888
270371	1874	203652000	11797	6062	0	0	0
42307	1688	49321292904000	11797	6062	2	0	18
102610	1726	715252347000	11798	6063	0	0	3889
270372	1874	203653000	11798	6063	0	0	0
102622	1726	715246341000	11808	6068	0	0	3895
270384	1874	203659000	11808	6068	0	0	0
37062	1683	151634414149541	11817	6072	2	0	1
102633	1726	715240335000	11818	6073	0	0	3901
270395	1874	203665000	11818	6073	0	0	0
1906	365	66720001000000	11820	6074	2	0	0
102641	1726	715235330000	11821	6075	1	0	3906
270403	1874	203670000	11821	6075	1	0	0
102648	1634	23111628574599	11826	6078	3	0	4
270410	241	66308156237945	11826	6078	3	0	0
102654	1726	715232327000	11826	6078	9	0	3909
270416	1874	203673000	11826	6078	9	0	0
102663	1726	715227322000	11831	6081	0	0	3914
270425	1874	203678000	11831	6081	0	0	0
249	43	68880490890000	11831	6081	2	0	1
102669	1726	715221316000	11832	6082	4	0	3920
270431	1874	203684000	11832	6082	4	0	0
35295	1679	22157444711000	11832	6082	5	0	22
102681	1726	715219314000	11835	6083	1	0	3922
102682	1726	715218313000	11835	6083	2	0	3923
270447	2056	200000000	11837	6085	0	0	0
17547	1508	20160526000000	11837	6085	2	0	0
37080	1683	155954422149541	11839	6086	1	0	1
102689	1726	714003308000	11840	6087	0	0	3929
14605	1457	5664171040000	11840	6087	1	0	4
270453	1874	203694000	11841	6088	1	0	0
42365	1688	51481295904000	11844	6090	1	0	18
102701	1726	712788303000	11851	6092	0	0	3935
270465	1874	203699000	11853	6093	0	0	0
102718	1726	712783298000	11859	6095	0	0	3940
59245	2039	3601026000000	11859	6095	2	0	1
270487	1874	203704000	11863	6097	1	0	0
30011	1654	7487931000000	11863	6097	4	0	4
102852	1726	712779294000	11865	6098	0	0	3944
270614	1874	203706000	11865	6098	0	0	0
102856	1726	712778293000	11869	6099	0	0	3945
270618	1874	203707000	11869	6099	0	0	0
26872	1623	36722294899898	11869	6099	1	0	1
37091	1683	158834435149541	11870	6100	3	0	1
102865	1555	9630580064175	11873	6102	0	0	3
270627	1221	609998863722186	11873	6102	0	0	0
270698	1874	203714000	11876	6103	0	0	0
270699	1874	203715000	11877	6104	0	0	0
102949	1726	712769284000	11881	6105	1	0	3954
102958	1726	712768283000	11884	6106	0	0	3955
102959	1726	712767282000	11884	6106	1	0	3956
270723	1874	203720000	11884	6106	3	0	0
55041	1739	17279613000000	11888	6109	1	0	0
102967	1726	712761276000	11890	6110	0	0	3962
17015	1506	2880971967172	11890	6110	1	0	17
37119	1683	163154448149541	11891	6111	2	0	1
270731	1874	203726000	11892	6112	0	0	0
43472	1689	2160062287614	11892	6112	2	0	7
14933	1458	8013507908540	11893	6113	2	0	4
103096	1726	712756271000	11895	6114	0	0	3967
270858	1874	203729000	11895	6114	0	0	0
103097	1726	712755270000	11895	6114	1	0	3968
270859	1874	203730000	11895	6114	1	0	0
103103	1726	712749264000	11899	6118	1	0	3974
270865	1874	203736000	11899	6118	1	0	0
45738	1692	43940550019999	11905	6122	1	0	4
103113	1726	712743258000	11906	6123	0	0	3980
270875	1874	203742000	11906	6123	0	0	0
22937	1588	21600736000000	11906	6123	2	0	0
20314	1549	31680790000000	11908	6125	2	0	0
103120	1726	712738253000	11913	6128	0	0	3985
270882	1874	203747000	11913	6128	0	0	0
42428	1688	53641299904000	11919	6132	1	0	18
270914	1874	203752000	11921	6133	0	0	0
103153	1726	712732247000	11921	6133	1	0	3991
270915	1874	203753000	11921	6133	1	0	0
33461	1677	64729085325000	11922	6134	1	0	1
103159	1726	712726241000	11926	6138	0	0	3997
270921	1874	203759000	11926	6138	0	0	0
24216	1599	20160521996199	11927	6139	1	0	0
103168	1726	712721236000	11931	6141	2	0	4002
270932	1874	203765000	11933	6142	0	0	0
37139	1683	168914454149541	11938	6145	4	0	1
103208	1726	712715230000	11940	6147	0	0	4008
270970	1874	203770000	11940	6147	0	0	0
103222	1573	14081808000000	11942	6148	4	0	3
270984	1192	611801750000000	11942	6148	4	0	0
103225	1726	712710225000	11942	6148	7	0	4013
103227	1726	712709224000	11944	6149	0	0	4014
54797	1729	8206900000000	11945	6150	1	0	4
270991	1874	203778000	11946	6151	0	0	0
33472	1677	66169090325000	11946	6151	3	0	1
54148	1724	4269292000000	11950	6152	0	0	7
103282	1726	712704219000	11954	6153	2	0	4019
271045	1874	203782000	11954	6153	3	0	0
271049	1874	203784000	11956	6154	1	0	0
16305	1476	4320053000000	11956	6154	2	0	5
271050	1874	203785000	11957	6155	0	0	0
103291	1726	712698213000	11959	6156	1	0	4025
271068	1874	203791000	11968	6159	0	0	0
103311	1726	712693208000	11971	6160	0	0	4030
49685	1703	1440572000000	11971	6160	3	0	3
13039	1444	4894956160000	11972	6161	1	0	5
42458	1688	55081302904000	11974	6162	2	0	18
57201	1764	3606742100000	11975	6163	1	0	8
271079	1874	203797000	11976	6164	0	0	0
103318	1726	712687202000	11976	6164	1	0	4036
271090	1874	203802000	11984	6168	0	0	0
37154	1683	173234456149541	11984	6168	1	0	1
103333	1726	712681196000	11989	6170	0	0	4042
26877	1623	38162297899898	11989	6170	2	0	1
3267	576	69395596938283	11991	6171	2	0	4
271101	1874	203808000	11993	6173	0	0	0
28414	1637	138964131819997	11993	6173	1	0	0
103344	1726	712676191000	11998	6174	0	0	4047
5189	686	67440010000000	11998	6174	1	0	0
48881	1700	6065860276737	11999	6175	1	0	6
271113	1874	203813000	12002	6177	1	0	0
103353	1726	712671186000	12004	6178	0	0	4052
30386	1656	7341321999990	12004	6178	3	0	4
271121	1874	203818000	12008	6180	0	0	0
103361	1726	712666181000	12010	6181	0	0	4057
103362	1726	712665180000	12011	6182	0	0	4058
271128	1874	203822000	12011	6182	4	0	0
103368	1726	712661176000	12012	6183	0	0	4062
26595	1622	17279434999976	12012	6183	2	0	0
103568	1726	712660175000	12016	6184	0	0	4063
271330	1874	203825000	12016	6184	0	0	0
103569	1726	712659174000	12016	6184	1	0	4064
271331	1874	203826000	12016	6184	1	0	0
46592	1693	7833397155041	12017	6185	2	0	666
53198	1718	3686680763340	12022	6186	2	0	8
103579	1726	712653168000	12025	6189	0	0	4070
271341	1874	203832000	12025	6189	0	0	0
53382	1719	2180252000000	12025	6189	2	0	5
20379	1555	5235138979096	12026	6190	3	0	4
50515	1706	5252092600135	12032	6192	1	0	20
44097	1690	85682598000000	12033	6193	2	0	0
103591	1939	2150980000000	12034	6194	0	0	2
271353	1449	8053016459	12034	6194	0	0	5
103597	1726	712643158000	12038	6197	0	0	4080
271359	1874	203842000	12038	6197	0	0	0
11106	1419	6221038280064	12041	6198	2	0	3
37178	1683	177554459149541	12042	6199	1	0	1
4355	632	89040698000000	12044	6200	2	0	0
103611	1726	712637152000	12052	6203	0	0	4086
271373	1874	203848000	12052	6203	0	0	0
103620	1726	712633148000	12058	6206	0	0	4090
103683	1726	712632147000	12060	6207	0	0	4091
271443	1874	203853000	12060	6207	0	0	0
11014	1402	90003685000000	12060	6207	1	0	0
103809	1726	712631146000	12062	6208	0	0	4092
271568	1874	203854000	12062	6208	0	0	0
103810	1769	1707900000	12062	6208	1	0	26
25993	1613	2807683600000	12062	6208	3	0	6
271569	1874	203855000	12063	6209	0	0	0
103908	1726	712627142000	12068	6211	0	0	4096
271659	1874	203858000	12068	6211	0	0	0
103909	1726	711417142000	12068	6211	1	0	4097
271660	2060	200000000	12068	6211	1	0	0
103915	1726	711412137000	12071	6214	0	0	4102
271666	1874	203864000	12072	6215	0	0	0
103924	2058	583000000	12075	6217	2	0	3
271674	1874	203870000	12077	6219	0	0	0
103931	1726	711402127000	12081	6221	1	0	4112
271689	1874	203875000	12086	6222	0	0	0
33492	1677	68329094325000	12086	6222	2	0	1
103949	1775	873000000	12090	6224	1	0	15
271729	1874	203879000	12092	6225	0	0	0
271730	1874	203880000	12092	6225	1	0	0
45765	1692	45380555019999	12094	6226	4	0	4
104029	1726	711391116000	12095	6227	0	0	4123
271776	1874	203886000	12095	6227	2	0	0
14326	1451	19440595000000	12097	6229	1	0	0
104034	1726	711386111000	12098	6230	0	0	4128
104041	1726	711383108000	12101	6231	1	0	4131
271786	1874	203892000	12101	6231	1	0	0
104044	1950	3349852000000	12103	6232	0	0	13
11018	1402	91443690000000	12103	6232	2	0	0
1176	149	72030040000341	12105	6233	2	0	5
271796	1874	203896000	12110	6236	0	0	0
104053	1726	711377102000	12112	6238	0	0	4137
42511	1688	57241315904000	12113	6239	2	0	18
271804	1874	203901000	12116	6240	0	0	0
104063	1726	710162097000	12121	6243	0	0	4143
28423	1637	141124138819997	12122	6244	1	0	0
33511	1677	70489100325000	12126	6245	2	0	1
271815	1874	203907000	12127	6246	0	0	0
104071	1726	710157092000	12127	6246	1	0	4148
271830	1874	203912000	12134	6248	2	0	0
104087	1726	710151086000	12136	6250	0	0	4154
47082	1694	5772345127629	12137	6251	1	0	34
44738	1691	4283014100019	12138	6252	1	0	5
271838	1874	203918000	12142	6254	1	0	0
104099	641	68472826200000	12145	6255	1	0	9
37202	1683	181874464149541	12145	6255	5	0	1
271848	1874	203920000	12146	6256	0	0	0
104104	1726	710144079000	12147	6257	0	0	4161
31685	1671	3648219530515	12149	6258	1	0	4
33526	1677	72649104325000	12152	6259	2	0	1
271857	2062	200000000	12156	6261	0	0	0
104128	1726	708929074000	12162	6262	0	0	4167
271873	1874	203926000	12162	6262	0	0	0
271874	1874	203927000	12162	6262	1	0	0
104139	1726	708923068000	12166	6264	1	0	4173
271885	1874	203933000	12166	6264	2	0	0
23760	1596	6480173000000	12166	6264	4	0	11
37221	1683	186194470149541	12168	6265	1	0	1
104146	1726	708918063000	12172	6267	0	0	4178
55048	1739	18719617000000	12172	6267	3	0	0
271893	1874	203939000	12173	6268	0	0	0
104158	1726	708912057000	12176	6269	1	0	4184
271904	1874	203944000	12176	6269	2	0	0
19391	1546	5760615000000	12176	6269	3	0	6
26885	1623	40322304899898	12178	6270	2	0	1
104165	1726	708906051000	12179	6271	3	0	4190
24998	1607	6018204644388	12179	6271	4	0	9
271919	1950	3949852000000	12182	6272	0	0	13
29692	1649	20880859999992	12182	6272	2	0	0
104177	1726	708904049000	12184	6273	0	0	4192
104280	1726	708903048000	12186	6274	0	0	4193
272025	1874	203952000	12186	6274	0	0	0
272026	1874	203953000	12186	6274	1	0	0
41251	1687	11605407726450	12186	6274	3	0	4
52730	1716	6526643000000	12189	6276	4	0	4
104321	1726	708897042000	12193	6277	0	0	4199
104323	1726	708896041000	12195	6278	0	0	4200
272068	1874	203959000	12195	6278	0	0	0
28426	1637	141844139819997	12196	6279	2	0	0
28427	1637	141844141819997	12196	6279	3	0	0
104329	1705	5176761500145	12199	6282	0	0	15
272074	1360	1703067102686953	12199	6282	0	0	0
737	58	72426269999659	12200	6283	1	0	7
37237	1683	190514573149541	12201	6284	1	0	1
272079	1234	611165531836822	12202	6285	0	0	0
104335	1705	5014501500145	12202	6285	1	0	17
104340	1726	708884029000	12204	6287	0	0	4212
272085	1874	203971000	12204	6287	0	0	0
51535	1710	8254511473290	12204	6287	1	0	5
35355	1679	25037452711000	12205	6288	1	0	22
104355	1726	707669024000	12213	6291	0	0	4218
272100	1874	203976000	12213	6291	0	0	0
1728	301	66720490000000	12213	6291	1	0	1
104486	1726	707665020000	12218	6294	0	0	4222
272230	1874	203980000	12218	6294	0	0	0
104487	1726	707664019000	12218	6294	1	0	4223
272231	1874	203981000	12218	6294	1	0	0
33542	1677	74809128325000	12223	6296	2	0	1
104503	1726	707658013000	12227	6298	0	0	4229
272247	1874	203987000	12227	6298	0	0	0
52529	1715	26640425000000	12230	6299	2	0	0
104513	1726	707656011000	12232	6300	3	0	4231
272257	1874	203989000	12232	6300	3	0	0
58960	1992	7199143990000	12232	6300	5	0	0
37253	1683	194834587149541	12234	6301	1	0	1
104524	1726	707651006000	12243	6304	0	0	4236
272268	1874	203994000	12243	6304	0	0	0
272273	1141	904403846488639	12245	6306	1	0	0
104530	1508	13217473416525	12245	6306	2	0	4
272274	1261	610219296745574	12245	6306	2	0	0
104538	1726	707646001000	12248	6308	2	0	4241
272282	1874	203999000	12248	6308	2	0	0
33560	1677	76969131325000	12253	6309	2	0	1
104566	1726	707640996000	12258	6312	0	0	4246
272314	1874	204005000	12260	6313	0	0	0
14618	1457	7104177040000	12260	6313	4	0	4
104697	1726	707636992000	12262	6314	0	0	4250
272441	1874	204008000	12262	6314	0	0	0
104712	1726	707635991000	12265	6315	0	0	4251
272456	1874	204009000	12265	6315	0	0	0
104720	1426	6764817000000	12270	6318	4	0	4
272464	998	504693775000000	12270	6318	4	0	0
104721	1726	707633989000	12270	6318	5	0	4253
104722	1726	707632988000	12270	6318	6	0	4254
272474	1474	4814357000023	12282	6322	0	0	13
104732	1726	707627983000	12283	6323	0	0	4259
272479	1017	504693775000000	12285	6325	0	0	0
104738	1649	6763830999992	12285	6325	3	0	4
15624	1471	6379494000000	12286	6326	2	0	4
272486	1874	204022000	12289	6328	0	0	0
104765	1687	2872460524804	12292	6330	0	0	5
272513	1874	204026000	12293	6331	1	0	0
104781	1866	9327244264194	12295	6332	1	0	10
272528	936	505014385078944	12295	6332	4	0	0
104787	1866	0	12295	6332	7	0	16
32028	1672	4320934000000	12295	6332	10	0	5
272538	1874	204029000	12297	6333	0	0	0
39084	1684	9331235880623	12297	6333	1	0	66
104796	1726	707614970000	12298	6334	1	0	4272
44107	1690	87842713000000	12298	6334	3	0	0
51760	1711	4844458000000	12300	6335	2	0	9
272545	1046	900974465000000	12302	6336	0	0	0
272546	1874	204032000	12302	6336	1	0	0
37279	1683	200594801149541	12304	6337	3	0	1
104811	1451	6979997000000	12306	6338	0	0	6
272558	1874	204035000	12306	6338	3	0	0
45787	1692	47540729019999	12307	6339	2	0	4
104817	1726	707607963000	12308	6340	1	0	4279
4112	631	66720500000000	12309	6341	1	0	0
272564	1874	204039000	12310	6342	1	0	0
104822	1726	707604960000	12312	6344	1	0	4282
21010	1560	6354201277001	12312	6344	3	0	15
272570	1874	204043000	12315	6346	0	0	0
11022	1402	92883694000000	12315	6346	1	0	0
104831	1726	707598954000	12319	6348	1	0	4288
50189	1705	5680451500145	12319	6348	2	0	18
40648	1686	2371781550062	12320	6349	1	0	9
104890	1726	707596952000	12322	6350	0	0	4290
104891	1726	707595951000	12322	6350	1	0	4291
272635	1874	204049000	12322	6350	1	0	0
58587	1980	12239147000000	12322	6350	2	0	1
104897	1726	707589945000	12325	6353	1	0	4297
272641	1874	204055000	12325	6353	1	0	0
272659	1874	204060000	12334	6357	0	0	0
33578	1677	79129133325000	12334	6357	1	0	1
29346	1643	5616367113700	12336	6358	0	0	9
104916	1726	707583939000	12337	6359	0	0	4303
104926	1726	707579935000	12343	6362	1	0	4307
272670	1874	204065000	12343	6362	1	0	0
58685	1991	4075618441475	12343	6362	5	0	12
12073	1426	8204819000000	12345	6363	2	0	4
104936	1696	9358519180000	12347	6365	1	0	4
272680	1178	612445521340000	12347	6365	1	0	0
272681	1304	1698521409091650	12347	6365	2	0	0
272682	1874	204070000	12347	6365	3	0	0
4492	633	72363895900000	12348	6366	1	0	5
13487	1447	10954476944000	12351	6368	0	0	5
104945	1726	707570926000	12353	6369	0	0	4316
272692	1874	204076000	12355	6370	1	0	0
56626	1759	4320569999999	12356	6371	3	0	7
104951	1726	707565921000	12357	6372	0	0	4321
15553	1467	25922357100000	12360	6374	2	0	0
272702	1874	204082000	12364	6375	0	0	0
104961	1726	707559915000	12365	6376	1	0	4327
272707	1874	204087000	12367	6378	0	0	0
104969	1726	707553909000	12371	6380	0	0	4333
12428	1439	5332277998477	12371	6380	2	0	6
105096	1726	707551907000	12373	6381	0	0	4335
272837	1874	204093000	12373	6381	0	0	0
31702	1671	4368221530515	12373	6381	2	0	4
105097	1726	707550906000	12374	6382	0	0	4336
272838	1874	204094000	12374	6382	0	0	0
28437	1637	144724143819997	12374	6382	1	0	0
51164	1709	2160023000000	12382	6386	2	0	7
2478	470	72480295000000	12383	6387	1	0	6
105107	1726	707544900000	12384	6388	0	0	4342
272848	1874	204100000	12384	6388	0	0	0
17639	1509	6431728851155	12384	6388	1	0	5
33606	1677	81289139325000	12391	6391	3	0	1
19721	1547	5613225000000	12393	6392	1	0	6
105117	1726	706329895000	12394	6393	0	0	4348
272858	131	66001200000000	12394	6393	0	0	0
105128	1726	706324890000	12400	6396	0	0	4353
272869	1874	204110000	12400	6396	0	0	0
105129	1726	706323889000	12400	6396	1	0	4354
37296	1683	204914903149541	12400	6396	2	0	1
105132	1726	706322888000	12403	6398	0	0	4355
4760	641	68499788000000	12403	6398	2	0	12
272878	1874	204116000	12406	6400	1	0	0
105145	1726	706316882000	12414	6402	0	0	4361
54807	1729	9646903000000	12415	6403	2	0	4
272895	1874	204121000	12420	6404	2	0	0
42565	1688	59401320904000	12420	6404	4	0	18
105157	1726	706311877000	12424	6405	1	0	4366
11027	1402	95043697000000	12424	6405	2	0	0
44752	1691	5723016100019	12450	6416	0	0	5
272967	1773	4104187299982	12460	6420	0	0	24
57547	1768	4910626110000	12460	6420	2	0	6
272969	182	66497436792432	12465	6422	0	0	0
105231	1773	2475868345358	12465	6422	3	0	28
272975	1269	1000000	12465	6422	6	0	0
45811	1692	50422241019999	12465	6422	7	0	4
2288	405	66720000000000	12466	6423	0	0	0
105269	1726	706310876000	12479	6430	0	0	4367
105270	1726	705100876000	12479	6430	1	0	4368
44117	1690	90002846000000	12479	6430	4	0	0
273014	2067	200000000	12480	6431	1	0	0
105276	1726	701467873000	12482	6433	0	0	4374
11708	1422	5904973860211	12482	6433	2	0	7
25923	1611	20870853000000	12483	6434	1	0	1
273019	1874	204129000	12484	6435	0	0	0
105290	1726	701461867000	12487	6436	3	0	4380
37322	1683	210674906149541	12487	6436	4	0	1
28445	1637	146884146819997	12490	6437	2	0	0
273037	1874	204135000	12493	6438	0	0	0
22429	1587	5040276000000	12493	6438	1	0	7
105306	1397	1371423276000	12500	6440	0	0	6741
33626	1677	83449152325000	12500	6440	2	0	1
273050	1874	204138000	12501	6441	1	0	0
105327	1726	701454860000	12507	6443	0	0	4387
273070	2067	1400000000	12508	6444	1	0	0
105333	1397	1371353269000	12508	6444	5	0	6748
273076	1874	204141000	12508	6444	7	0	0
105338	1726	700240856000	12508	6444	10	0	4392
273082	1678	12960388834000	12509	6445	1	0	0
20324	1549	34560796000000	12509	6445	4	0	0
105344	1397	1371313265000	12510	6446	0	0	6752
273087	1678	12960388836000	12511	6447	0	0	0
273089	1874	204149000	12511	6447	2	0	0
273090	1678	12960388837000	12512	6448	0	0	0
105350	1397	1371283262000	12512	6448	1	0	6755
15243	1464	1440000000000	12512	6448	4	0	0
33635	1677	85609164325000	12514	6449	3	0	1
105357	1397	1371263260000	12515	6450	0	0	6757
273098	1678	12960388840000	12515	6450	0	0	0
105369	1397	1371233257000	12521	6453	0	0	6760
273110	1678	12960388843000	12521	6453	0	0	0
273119	1678	12960388846000	12523	6454	1	0	0
105379	1397	1371193253000	12523	6454	2	0	6764
105396	1726	699013839000	12526	6455	1	0	4410
273137	1874	204161000	12526	6455	1	0	0
11034	1402	97923710000000	12526	6455	3	0	0
26892	1623	42482418899898	12528	6456	3	0	1
105401	1726	699011837000	12529	6457	0	0	4412
33647	1677	87769187325000	12529	6457	2	0	1
105402	1397	1371163250000	12530	6458	0	0	6767
273145	1874	204164000	12530	6458	2	0	0
105415	1397	1371133247000	12536	6461	0	0	6770
273157	1678	12960388854000	12536	6461	1	0	0
37344	1683	214994943149541	12538	6462	2	0	1
105433	1397	1371103244000	12542	6463	0	0	6773
273175	1678	12960388857000	12542	6463	1	0	0
105438	1397	1371073241000	12543	6464	1	0	6776
273181	1874	204172000	12543	6464	3	0	0
22952	1588	23759737000000	12543	6464	5	0	1
55842	1747	1456806000000	12546	6465	2	0	5
105582	1397	1371053239000	12553	6468	0	0	6778
273323	1678	12960388861000	12553	6468	0	0	0
105583	1397	1371043238000	12553	6468	1	0	6779
273324	1678	12960388862000	12553	6468	1	0	0
105589	1726	698996822000	12554	6469	1	0	4427
273330	1874	204178000	12554	6469	1	0	0
105595	1726	698993819000	12555	6470	5	0	4430
273336	1874	204181000	12555	6470	5	0	0
37358	1683	217874998149541	12555	6470	7	0	1
1205	149	74190053000341	12558	6471	3	0	5
105612	1726	698991817000	12561	6472	2	0	4432
273353	1874	204183000	12561	6472	2	0	0
273365	1678	12960388872000	12564	6474	0	0	0
273366	1874	204186000	12564	6474	1	0	0
105626	1397	1370933227000	12565	6475	0	0	6790
16926	1489	24480755000000	12565	6475	3	0	0
273374	1678	12960388876000	12568	6477	1	0	0
105634	1397	1370893223000	12568	6477	2	0	6794
105639	1726	698983809000	12568	6477	7	0	4440
273380	1874	204191000	12568	6477	7	0	0
273389	1874	204194000	12572	6479	1	0	0
105649	1397	1370853219000	12573	6480	0	0	6798
37374	1683	222195076149541	12574	6481	3	0	1
273397	1678	12960388884000	12576	6482	1	0	0
105657	1726	698977803000	12576	6482	2	0	4446
105662	1599	12856556807349	12577	6483	3	0	3
273403	1161	610329513257268	12577	6483	3	0	0
105673	1588	11300275000000	12580	6484	2	0	4
273414	1146	905299076000000	12580	6484	2	0	0
105674	1588	8388612000000	12580	6484	3	0	5
273422	1874	204201000	12584	6486	1	0	0
43505	1689	4320075287625	12584	6486	3	0	7
105682	1397	1370773211000	12585	6487	0	0	6806
273428	1874	204203000	12585	6487	5	0	0
105688	1726	698970796000	12585	6487	6	0	4453
53895	1723	6119070085979	12585	6487	8	0	6
273433	1874	204206000	12586	6488	2	0	0
105693	1726	698967793000	12586	6488	3	0	4456
273459	1678	12960388897000	12592	6492	0	0	0
105719	1397	1370683202000	12592	6492	1	0	6815
27476	1634	6671580641004	12594	6493	2	0	9
273471	1678	12960388900000	12596	6494	0	0	0
105731	1397	1370653199000	12596	6494	1	0	6818
273476	1874	204214000	12596	6494	5	0	0
105736	1726	698959785000	12596	6494	6	0	4464
33661	1677	89929220325000	12597	6495	3	0	1
273482	1874	204218000	12598	6496	1	0	0
105742	1397	1370603194000	12599	6497	0	0	6823
34810	1678	13680399906000	12599	6497	3	0	0
273488	1874	204221000	12601	6499	1	0	0
32550	1673	29566680000000	12601	6499	2	0	2
105756	1397	1370573191000	12604	6500	0	0	6826
273497	1678	13680399909000	12604	6500	0	0	0
273498	1678	13680399910000	12604	6500	1	0	0
105761	1726	698950776000	12604	6500	5	0	4473
21459	1564	6306290000000	12604	6500	6	0	5
273504	1874	204225000	12605	6501	1	0	0
56990	1762	6081732994000	12605	6501	3	0	4
37392	1683	227955108149541	12607	6502	2	0	1
105769	1726	698947773000	12608	6503	1	0	4476
30902	1657	23041258000000	12608	6503	3	0	0
273512	1874	204228000	12609	6504	1	0	0
28450	1637	149044168819997	12609	6504	2	0	0
105777	1726	698944770000	12612	6506	1	0	4479
273519	1678	13680399918000	12613	6507	0	0	0
105782	1750	4181000000	12613	6507	4	0	19
273525	1874	204232000	12613	6507	6	0	0
18966	1536	8640586000000	12615	6508	2	0	6
105798	1397	1370443178000	12617	6509	0	0	6839
11165	1419	9821153280064	12617	6509	2	0	3
273541	1678	13680399923000	12618	6510	0	0	0
105804	1397	1370413175000	12619	6511	0	0	6842
273546	1678	13680399926000	12619	6511	1	0	0
105809	1726	698934760000	12620	6512	1	0	4489
24391	1601	7418498600000	12620	6512	3	0	9
105810	1397	1370383172000	12621	6513	0	0	6845
273552	1678	13680399929000	12621	6513	1	0	0
105816	1397	1370353169000	12622	6514	0	0	6848
273558	1678	13680399932000	12622	6514	1	0	0
105822	1397	1370323166000	12625	6516	0	0	6851
273563	1678	13680399934000	12625	6516	0	0	0
26615	1622	19439446999976	12625	6516	3	0	0
759	58	73866294999659	12632	6517	3	0	7
105835	1726	698925751000	12635	6518	1	0	4498
273579	1678	13680399937000	12637	6519	0	0	0
105843	1726	698922748000	12637	6519	5	0	4501
4362	632	91200730000000	12637	6519	6	0	0
273585	1678	13680399940000	12638	6520	0	0	0
105849	1726	698919745000	12638	6520	5	0	4504
273590	1874	204255000	12638	6520	5	0	0
105981	1397	1370233157000	12641	6521	0	0	6860
273722	1678	13680399943000	12641	6521	0	0	0
105982	1726	698918744000	12641	6521	1	0	4505
273723	1874	204256000	12641	6521	1	0	0
50532	1706	6692105600135	12645	6522	3	0	20
3298	576	71555600938283	12646	6523	2	0	4
105999	1726	698915741000	12649	6524	1	0	4508
273740	1874	204259000	12649	6524	1	0	0
106005	1726	698913739000	12650	6525	5	0	4510
273746	1874	204261000	12650	6525	5	0	0
33675	1677	92089242325000	12650	6525	7	0	1
106017	1726	698910736000	12653	6527	1	0	4513
273758	1874	204264000	12653	6527	1	0	0
273769	1874	204265000	12655	6528	3	0	0
273770	1874	204266000	12655	6528	4	0	0
106030	1726	698907733000	12655	6528	5	0	4516
273786	1678	13680399956000	12659	6530	0	0	0
106046	1726	698905731000	12659	6530	1	0	4518
106054	1726	697694730000	12661	6531	3	0	4520
273795	2069	200000000	12661	6531	3	0	0
37411	1683	232275183149541	12661	6531	7	0	1
51209	1709	4320037000000	12662	6532	3	0	7
273803	1678	13680399959000	12665	6533	0	0	0
106063	1397	1370063140000	12665	6533	1	0	6877
273812	1874	204274000	12667	6534	1	0	0
106072	1750	4174000000	12667	6534	2	0	26
106080	1726	695268724000	12671	6536	2	0	4528
273821	1874	204276000	12671	6536	2	0	0
106081	1726	695267723000	12671	6536	3	0	4529
106082	1750	4173000000	12671	6536	4	0	27
273842	1678	13680399966000	12677	6538	0	0	0
106104	1726	695264720000	12677	6538	3	0	4532
273852	1678	13680399969000	12681	6540	0	0	0
106114	1726	695261717000	12681	6540	4	0	4535
18213	1514	5700	12681	6540	6	1	0
273860	1678	13680399972000	12684	6542	0	0	0
32055	1672	6481748000000	12684	6542	2	0	5
106126	1397	1369933127000	12688	6543	0	0	6890
273872	1874	204287000	12690	6544	1	0	0
33688	1677	93529308323100	12693	6545	2	0	1
106140	1726	695256712000	12695	6546	1	0	4540
273884	1874	204289000	12696	6547	2	0	0
106148	1726	695253709000	12698	6548	1	0	4543
37424	1683	236595205149541	12698	6548	2	0	1
273892	1678	13680399981000	12700	6550	0	0	0
14407	1455	3633916000000	12700	6550	2	0	5
106157	1397	1369843118000	12702	6551	0	0	6899
273901	1874	204295000	12702	6551	3	0	0
273905	1874	204296000	12704	6552	1	0	0
106165	1397	1369813115000	12705	6553	0	0	6902
273906	1678	13680399985000	12705	6553	0	0	0
106185	1397	1369783112000	12712	6555	0	0	6905
273926	1678	13680399988000	12712	6555	0	0	0
46698	1693	9993453155041	12712	6555	3	0	666
106198	1726	695243699000	12715	6556	3	0	4553
273940	1874	204302000	12715	6556	4	0	0
32685	1675	5181993999977	12715	6556	7	0	4
106332	1397	1369743108000	12718	6557	0	0	6909
274073	1678	13680399992000	12718	6557	0	0	0
106333	1397	1369733107000	12718	6557	1	0	6910
274074	1678	13680399993000	12718	6557	1	0	0
106339	1726	695238694000	12719	6558	2	0	4558
274080	1874	204306000	12719	6558	2	0	0
106345	1726	695235691000	12720	6559	4	0	4561
274086	1874	204309000	12720	6559	4	0	0
45829	1692	51862350019999	12720	6559	7	0	4
22724	1588	7414765000000	12721	6560	2	0	6
106357	1397	1369663100000	12724	6561	0	0	6917
106358	1397	1369653099000	12724	6561	1	0	6918
274099	1678	13680400001000	12724	6561	1	0	0
37440	1683	240915249149541	12724	6561	4	0	1
47793	1696	5537247840000	12726	6562	2	0	5
106399	1397	1369623096000	12727	6563	1	0	6921
274140	1678	13680400004000	12727	6563	1	0	0
274206	1678	13680400006000	12730	6564	0	0	0
106466	1726	695226682000	12730	6564	1	0	4570
274207	1874	204318000	12730	6564	1	0	0
45833	1692	52582350019999	12730	6564	2	0	4
45834	1692	52582361019999	12730	6564	3	0	4
58166	1850	7118833000000	12731	6565	1	0	5
106477	1726	695225681000	12736	6567	3	0	4571
274219	1874	204320000	12736	6567	4	0	0
42607	1688	60841353904000	12737	6568	2	0	18
106488	1726	695221677000	12741	6569	1	0	4575
106489	1397	1369543088000	12742	6570	0	0	6929
274230	1678	13680400012000	12742	6570	0	0	0
106490	1726	695220676000	12742	6570	1	0	4576
25210	1608	8205524000000	12742	6570	2	0	4
274249	1678	13680400015000	12749	6572	1	0	0
54820	1729	11086957000000	12749	6572	4	0	4
106512	1397	1369503084000	12750	6573	0	0	6933
274269	1678	13680400019000	12753	6574	0	0	0
106532	1397	1369463080000	12753	6574	1	0	6937
106537	1726	695213669000	12753	6574	6	0	4583
274275	1874	204331000	12753	6574	6	0	0
274291	1678	13680400023000	12755	6575	1	0	0
106554	1708	16770835119061	12755	6575	2	0	1
274297	1116	907019073000000	12755	6575	7	0	0
106560	1549	9695676000000	12755	6575	8	0	5
28460	1637	151204214819997	12755	6575	11	0	0
106565	1726	695208664000	12756	6576	2	0	4588
274303	1874	204336000	12756	6576	2	0	0
274308	1874	204339000	12757	6577	3	0	0
106579	1397	1369383072000	12760	6578	0	0	6945
274317	1678	13680400028000	12760	6578	0	0	0
274318	1678	13680400029000	12760	6578	1	0	0
106585	1397	1369353069000	12761	6579	1	0	6948
274324	1678	13680400032000	12762	6580	0	0	0
106590	1397	1369333067000	12763	6581	0	0	6950
12467	1439	6772312998477	12763	6581	3	0	6
274330	1678	13680400034000	12764	6582	0	0	0
106596	1726	695197653000	12764	6582	4	0	4599
274335	1874	204348000	12764	6582	5	0	0
3190	532	67440001000000	12769	6584	2	0	0
106604	1397	1369273061000	12770	6585	0	0	6956
274343	1874	204351000	12770	6585	1	0	0
106621	1726	695191647000	12778	6587	1	0	4605
33712	1677	95689331323100	12780	6588	2	0	1
106632	1397	1369243058000	12782	6589	0	0	6959
274370	1678	13680400042000	12782	6589	0	0	0
106633	1397	1369233057000	12782	6589	1	0	6960
274375	1874	204356000	12782	6589	6	0	0
106639	1397	1369213055000	12783	6590	0	0	6962
52923	1717	3707828000023	12783	6590	4	0	4
274389	1678	13680400047000	12787	6592	0	0	0
106653	1397	1369173051000	12787	6592	2	0	6966
274395	1678	13680400050000	12788	6593	0	0	0
106658	1657	20943506000000	12788	6593	1	0	2
274402	1678	13680400053000	12791	6595	2	0	0
106666	1657	17202285000000	12791	6595	4	0	3
274424	1874	204364000	12795	6597	1	0	0
106688	1726	695178634000	12795	6597	3	0	4618
274436	1678	13680400057000	12797	6598	0	0	0
106699	1657	7643883000000	12797	6598	1	0	5
52536	1715	28800475000000	12797	6598	3	0	0
274441	1678	13680400059000	12799	6600	0	0	0
106707	1397	1369063040000	12801	6601	0	0	6977
274449	1874	204374000	12802	6602	1	0	0
23779	1596	8640311000000	12802	6602	2	0	11
274450	1678	13680400062000	12803	6603	0	0	0
106722	1397	1369033037000	12808	6604	0	0	6980
44127	1690	92162909000000	12808	6604	3	0	0
18085	1513	20160628000000	12809	6605	4	0	0
106727	1397	1369013035000	12811	6606	0	0	6982
274465	1678	13680400065000	12811	6606	0	0	0
106739	1397	1368953029000	12816	6609	0	0	6988
274477	1678	13680400071000	12816	6609	0	0	0
37459	1683	245235292149541	12816	6609	2	0	1
51559	1710	9694534473290	12819	6611	2	0	5
274482	1678	13680400076000	12821	6613	1	0	0
106746	1397	1368893023000	12823	6614	0	0	6994
42651	1688	63001387904000	12826	6617	1	0	18
106756	1397	1368843018000	12832	6619	0	0	6999
274494	1678	13680400082000	12832	6619	0	0	0
106761	1397	1368833017000	12837	6620	0	0	7000
57841	1790	201900000	12837	6620	2	0	0
106763	1397	1368823016000	12839	6621	0	0	7001
35401	1679	26477467711000	12839	6621	2	0	22
274505	1874	204376000	12840	6622	3	0	0
14036	1451	3498781000000	12840	6622	5	0	9
106773	1726	692747623000	12842	6623	1	0	4631
274520	1678	13680400088000	12847	6625	0	0	0
274613	1678	13680400089000	12850	6626	0	0	0
106876	1726	692744620000	12850	6626	1	0	4634
274614	1874	204380000	12850	6626	1	0	0
32083	1672	7921804000000	12851	6627	3	0	5
37470	1683	249555313149541	12853	6628	2	0	1
106885	1397	1368743008000	12855	6629	0	0	7009
274624	1874	204383000	12855	6629	1	0	0
28467	1637	153364300819997	12855	6629	2	0	0
106899	1397	1368713005000	12860	6631	0	0	7012
106900	1726	692738614000	12860	6631	1	0	4640
274638	1874	204386000	12860	6631	1	0	0
274643	2077	3000000000	12861	6632	4	0	0
106906	1726	692737613000	12861	6632	5	0	4641
274666	1678	13680400101000	12865	6633	2	0	0
106929	1726	692734610000	12865	6633	3	0	4644
106934	1397	1368632997000	12866	6634	1	0	7020
274672	1678	13680400103000	12866	6634	1	0	0
274677	1678	13680400105000	12867	6635	0	0	0
106940	1397	1368602994000	12867	6635	1	0	7023
274683	1874	204398000	12867	6635	6	0	0
106946	1726	691515601000	12867	6635	7	0	4654
15564	1467	27362412100000	12867	6635	9	0	0
106959	1726	691514600000	12869	6636	4	0	4655
274697	1874	204400000	12869	6636	4	0	0
53427	1719	4340309000000	12869	6636	10	0	5
274702	1678	13680400113000	12870	6637	0	0	0
106965	1726	691510596000	12870	6637	1	0	4659
33736	1677	97849374323100	12870	6637	3	0	1
274716	1874	204406000	12875	6639	2	0	0
106979	1726	691507593000	12875	6639	3	0	4662
274722	1678	13680400117000	12877	6640	0	0	0
274723	1874	204408000	12877	6640	1	0	0
107054	1397	1368472981000	12882	6642	0	0	7036
107055	1726	691504590000	12882	6642	1	0	4665
274799	1874	204411000	12886	6643	1	0	0
107073	1726	691501587000	12893	6645	1	0	4668
274815	1874	204414000	12896	6646	1	0	0
107081	1726	691498584000	12898	6648	1	0	4671
274824	1678	13680400126000	12901	6649	0	0	0
107094	1726	691496582000	12903	6650	2	0	4673
17658	1509	8591751851155	12903	6650	4	0	5
274838	1678	13680400129000	12905	6651	0	0	0
31043	1668	7886536000000	12905	6651	3	0	5
107104	1726	691493579000	12906	6652	2	0	4676
274848	1678	13680400132000	12908	6653	0	0	0
30418	1656	9501337999990	12908	6653	3	0	4
274860	1678	13680400133000	12912	6655	0	0	0
107123	1397	1368322966000	12912	6655	1	0	7051
274861	1678	13680400134000	12912	6655	1	0	0
107128	1726	691487573000	12912	6655	6	0	4682
274867	1874	204428000	12912	6655	7	0	0
21044	1560	8514212277001	12915	6656	2	0	15
107185	1397	1368282962000	12917	6657	0	0	7055
107186	1397	1368272961000	12917	6657	1	0	7056
274926	1874	204431000	12917	6657	3	0	0
107196	1726	691481567000	12920	6659	1	0	4688
274937	1678	13680400142000	12922	6660	0	0	0
37496	1683	253875346149541	12923	6661	2	0	1
107206	1397	1368212955000	12925	6662	1	0	7062
274945	1874	204436000	12925	6662	2	0	0
26011	1613	4967753600000	12925	6662	4	0	6
11050	1402	100083766000000	12927	6663	3	0	0
107215	1397	1368192953000	12928	6664	0	0	7064
797	58	76026327999659	12928	6664	3	0	7
275022	1678	13680400148000	12933	6665	0	0	0
275023	1874	204440000	12933	6665	1	0	0
25476	1610	5760209000000	12933	6665	2	0	6
22736	1588	9574810000000	12934	6666	2	0	6
107296	1397	1368162950000	12936	6667	0	0	7067
275037	1678	13680400153000	12936	6667	3	0	0
107302	1726	691470556000	12936	6667	6	0	4699
107312	1397	1368122946000	12938	6668	0	0	7071
107313	1726	691468554000	12938	6668	1	0	4701
275051	1874	204446000	12938	6668	1	0	0
24694	1602	6480354000000	12942	6670	1	0	5
275063	1874	204448000	12944	6671	2	0	0
107326	1726	691465551000	12944	6671	3	0	4704
275071	1678	13680400160000	12948	6674	0	0	0
107334	1726	691462548000	12948	6674	1	0	4707
3759	606	71419732812962	12948	6674	3	0	8
4770	641	69219790000000	12949	6675	2	0	12
107343	1726	691460546000	12951	6676	2	0	4709
275081	1874	204454000	12951	6676	2	0	0
275086	1874	204457000	12953	6678	1	0	0
107349	1397	1368002934000	12954	6679	0	0	7083
35905	1680	5769282500035	12955	6680	2	0	6
275095	1874	204460000	12958	6681	1	0	0
107358	1397	1367972931000	12959	6682	0	0	7086
107363	1726	691452538000	12961	6683	3	0	4717
275101	1874	204462000	12961	6683	3	0	0
275112	1678	13680400174000	12964	6685	0	0	0
107375	1397	1367912925000	12964	6685	1	0	7092
42726	1688	65881441904000	12964	6685	6	0	18
275118	1678	13680400177000	12965	6686	0	0	0
107381	1726	691445531000	12965	6686	1	0	4724
33758	1677	100009473323100	12965	6686	3	0	1
28477	1637	154804333819997	12969	6688	3	0	0
107390	1397	1367862920000	12970	6689	0	0	7097
275128	1678	13680400180000	12970	6689	0	0	0
275129	1874	204472000	12970	6689	1	0	0
275138	1678	13680400181000	12975	6690	0	0	0
107407	1726	691440526000	12977	6691	2	0	4729
275150	1874	204475000	12979	6692	1	0	0
107421	1726	691437523000	12984	6694	1	0	4732
22454	1587	6480310000000	12984	6694	3	0	7
275162	1874	204478000	12986	6695	1	0	0
107429	1726	691435521000	12988	6696	2	0	4734
37516	1683	258195401149541	12988	6696	4	0	1
275177	1678	13680400190000	12991	6697	0	0	0
107441	1397	1367752909000	12992	6698	0	0	7108
107442	1397	1367742908000	12992	6698	1	0	7109
27244	1633	5796301985638	12992	6698	4	0	8
275183	1678	13680400193000	12994	6700	0	0	0
107448	1726	691429515000	12994	6700	3	0	4740
275216	1678	13680400196000	13004	6702	0	0	0
107481	1397	1367692903000	13005	6703	1	0	7114
275221	1874	204488000	13005	6703	3	0	0
107491	1397	1367662900000	13007	6704	1	0	7117
275232	1874	204491000	13007	6704	4	0	0
107497	1726	691421507000	13008	6705	1	0	4748
22107	1573	2138818000000	13008	6705	3	0	5
17341	1508	8676206500009	13009	6706	2	0	6
275242	1678	13680400204000	13012	6707	0	0	0
107507	1726	691418504000	13013	6708	2	0	4751
16333	1476	6480088000000	13013	6708	4	0	5
275249	1874	204497000	13015	6709	1	0	0
107519	1397	1367582892000	13017	6710	2	0	7125
275259	1678	13680400210000	13018	6711	2	0	0
107525	1726	691414500000	13018	6711	3	0	4755
24452	1601	9578520600000	13018	6711	6	0	9
275266	1483	0	13020	6712	0	0	0
275267	1678	13680400211000	13020	6712	1	0	0
107539	1397	1367542888000	13023	6713	0	0	7129
275284	1874	204505000	13027	6715	2	0	0
107550	1726	691408494000	13027	6715	3	0	4761
275295	1874	204508000	13030	6717	2	0	0
107561	2073	412999000000	13030	6717	3	0	1
36267	1681	8423148759830	13030	6717	5	0	6
275300	1678	13680400218000	13031	6718	2	0	0
107567	1726	691404490000	13031	6718	4	0	4765
275308	1874	204513000	13033	6719	1	0	0
107577	1397	1367452879000	13035	6720	0	0	7138
107578	1397	1367442878000	13035	6720	1	0	7139
275316	1678	13680400224000	13035	6720	5	0	0
107584	1726	691400486000	13035	6720	7	0	4769
275321	1874	204517000	13035	6720	10	0	0
107590	1726	691394480000	13035	6720	13	0	4775
275327	1483	10000000	13035	6720	16	0	0
107595	1397	1367402874000	13036	6721	0	0	7143
11035	1402	98095350337136	13036	6721	2	0	3
275336	1874	204526000	13038	6722	2	0	0
42776	1688	68041588904000	13038	6722	3	0	18
107615	1397	1367372871000	13041	6723	1	0	7146
275352	809	60001356617753	13041	6723	4	0	0
107621	1726	691385471000	13041	6723	7	0	4784
275366	1678	13680400231000	13043	6724	2	0	0
107634	1726	691383469000	13043	6724	4	0	4786
275372	1874	204534000	13044	6725	2	0	0
107640	1397	1367332867000	13045	6726	1	0	7150
275377	850	1155020382824210	13045	6726	4	0	0
107646	1726	691378464000	13045	6726	7	0	4791
275383	1874	204538000	13046	6727	2	0	0
107656	1726	690166462000	13049	6728	1	0	4794
275409	1678	13680400236000	13053	6729	0	0	0
275410	1874	204541000	13053	6729	1	0	0
26900	1623	43922441899898	13053	6729	3	0	1
107677	1726	688952458000	13054	6730	0	0	4799
33769	1677	102169537323100	13054	6730	2	0	1
275416	1874	204545000	13055	6731	3	0	0
107683	1726	688948454000	13055	6731	4	0	4803
107737	1397	1367272861000	13060	6732	0	0	7156
107738	1397	1367262860000	13060	6732	1	0	7157
275475	858	329060974492151	13060	6732	4	0	0
107744	1402	58537998102164	13060	6732	7	0	17
275480	874	2430052982831172	13060	6732	9	0	0
107750	1726	688946452000	13060	6732	13	0	4805
275486	1874	204550000	13060	6732	15	0	0
107755	1726	688942446000	13061	6733	2	0	4809
275492	882	585012754989949	13062	6734	2	0	0
107761	1402	38969482557689	13062	6734	5	0	25
275497	898	65298223692326	13062	6734	7	0	0
107767	1402	33243483331619	13062	6734	11	0	31
275503	2081	983784944532	13062	6734	13	0	0
107772	1726	688939440000	13062	6734	16	0	4812
275536	1678	14400545244000	13066	6735	0	0	0
275537	1874	204566000	13066	6735	1	0	0
275538	1874	204568000	13066	6735	2	0	0
107805	1726	688934431000	13066	6735	3	0	4817
275556	1874	204574000	13069	6736	4	0	0
107823	1726	688931425000	13069	6736	5	0	4820
107845	1726	688928419000	13075	6738	1	0	4823
275579	1874	204581000	13075	6738	1	0	0
107849	1726	688924411000	13075	6738	5	0	4827
37526	1683	261075563149541	13075	6738	7	0	1
107850	1397	1367172851000	13076	6739	0	0	7166
275584	1678	14400545249000	13076	6739	0	0	0
107863	1726	688919402000	13079	6740	2	0	4832
275597	1874	204598000	13079	6740	2	0	0
107891	1397	1367132847000	13087	6742	1	0	7170
275625	1678	14400545253000	13087	6742	1	0	0
107896	1726	687702389000	13087	6742	6	0	4840
275630	2083	200000000	13087	6742	6	0	0
55060	1739	20879642000000	13088	6743	4	0	0
107902	1726	687698383000	13089	6744	1	0	4844
275636	1874	204617000	13089	6744	1	0	0
33783	1677	104329572323100	13091	6745	1	0	1
107911	1726	687694375000	13092	6746	3	0	4848
275645	1874	204625000	13092	6746	3	0	0
30049	1654	9647948000000	13092	6746	7	0	4
107916	1726	687690369000	13093	6747	2	0	4852
275650	1874	204631000	13093	6747	2	0	0
23806	1596	10080379000000	13094	6748	5	0	11
107922	1397	1367052839000	13095	6749	1	0	7178
275656	1678	14400545261000	13095	6749	1	0	0
107928	1726	687681351000	13095	6749	7	0	4861
275662	1874	204649000	13095	6749	7	0	0
42827	1688	70201758904000	13096	6750	4	0	18
107941	1397	1367032837000	13099	6751	0	0	7180
275675	1678	14400545263000	13099	6751	0	0	0
275676	1874	204658000	13099	6751	1	0	0
52114	1714	8806256103056	13099	6751	4	0	7
107955	1726	687673335000	13102	6752	2	0	4869
275690	1874	204667000	13102	6752	3	0	0
1458	171	71750296524688	13103	6753	3	0	4
107961	1726	687669329000	13104	6754	1	0	4873
275696	1874	204674000	13104	6754	2	0	0
107971	1726	687665320000	13108	6755	2	0	4877
275706	1874	204682000	13108	6755	3	0	0
107977	1726	687661314000	13109	6756	4	0	4881
275712	1874	204688000	13109	6756	5	0	0
107989	1397	1366962830000	13112	6757	0	0	7187
107990	1397	1366952829000	13112	6757	1	0	7188
275728	1874	204697000	13112	6757	5	0	0
107996	1726	687654300000	13112	6757	8	0	4888
275733	1874	204704000	13113	6758	2	0	0
108008	1726	687650293000	13116	6759	1	0	4892
40687	1686	4531856550062	13116	6759	4	0	9
275745	1874	204710000	13117	6760	1	0	0
108013	1397	1366912825000	13118	6761	0	0	7192
275751	1874	204718000	13118	6761	4	0	0
108019	1726	687642278000	13118	6761	6	0	4900
275764	1874	204727000	13120	6762	1	0	0
51789	1711	7724460000000	13120	6762	4	0	9
108033	1397	1366882822000	13121	6763	0	0	7195
275770	1874	204733000	13121	6763	3	0	0
108038	1726	687635264000	13121	6763	5	0	4907
275776	1874	204745000	13121	6763	9	0	0
108044	1726	687629252000	13121	6763	11	0	4913
11601	1420	1434900220000	13121	6763	12	0	1
275781	1874	204751000	13122	6764	2	0	0
108050	1726	687625245000	13123	6765	2	0	4917
275787	1874	204758000	13124	6766	1	0	0
108058	1397	1366822816000	13127	6767	0	0	7201
275796	1874	204764000	13127	6767	4	0	0
108064	1726	687618233000	13127	6767	6	0	4924
275801	1874	204773000	13127	6767	9	0	0
51580	1710	11754546473290	13127	6767	13	0	6
108092	1397	1366792813000	13130	6768	0	0	7204
275826	1678	14400545287000	13130	6768	0	0	0
275827	1874	204779000	13130	6768	1	0	0
108097	1726	687608213000	13130	6768	5	0	4934
275833	1678	14400545288000	13132	6769	0	0	0
108103	1397	1366742808000	13132	6769	4	0	7209
275839	1874	204793000	13132	6769	6	0	0
108109	1726	687601200000	13132	6769	10	0	4941
275844	1874	204802000	13132	6769	11	0	0
108114	1726	687596189000	13132	6769	15	0	4946
275854	1678	14400545293000	13134	6770	0	0	0
108121	1726	687594186000	13134	6770	1	0	4948
108122	1726	687593183000	13134	6770	2	0	4949
275864	1874	204823000	13136	6771	2	0	0
108143	1397	1366712805000	13140	6772	0	0	7212
275880	1874	204830000	13140	6772	3	0	0
56634	1759	5760601999999	13142	6773	1	0	7
108157	1726	687585168000	13142	6773	3	0	4957
275894	1874	204838000	13142	6773	6	0	0
108162	1726	687580158000	13142	6773	8	0	4962
275913	1368	1702661297751650	13147	6775	0	0	0
108181	1397	1366662800000	13147	6775	2	0	7217
275918	1678	14400545303000	13147	6775	5	0	0
108187	1726	687576151000	13147	6775	8	0	4966
275924	1874	204855000	13147	6775	11	0	0
108192	1726	687571142000	13147	6775	13	0	4971
275930	1874	204867000	13147	6775	17	0	0
108198	1726	687565130000	13147	6775	19	0	4977
44141	1690	94323042000000	13147	6775	22	0	0
275940	1678	14400545305000	13149	6776	1	0	0
108209	1726	687561121000	13149	6776	4	0	4981
275945	1874	204881000	13150	6777	1	0	0
275957	1014	505330736600000	13154	6778	0	0	0
108225	1397	1366592793000	13154	6778	2	0	7224
275963	1874	204884000	13154	6778	6	0	0
108231	1726	687556111000	13154	6778	8	0	4986
10286	1402	32974059319298	13154	6778	10	0	33
275982	1678	14400545310000	13159	6780	1	0	0
108250	1726	687554106000	13159	6780	3	0	4988
108263	1397	1366552789000	13162	6781	0	0	7228
275997	1678	14400545311000	13162	6781	0	0	0
108264	1397	1366542788000	13162	6781	1	0	7229
276003	1874	204906000	13162	6781	6	0	0
108270	1726	687548091000	13162	6781	7	0	4994
15652	1471	8539551900000	13162	6781	11	0	4
276014	1874	204916000	13165	6783	1	0	0
108281	1726	687544081000	13165	6783	2	0	4998
276024	1874	204926000	13167	6784	1	0	0
108291	1397	1366492783000	13168	6785	0	0	7234
39112	1684	10771258880623	13168	6785	3	0	66
108420	1397	1366482782000	13171	6786	0	0	7235
276154	1678	14400545318000	13171	6786	0	0	0
108421	1726	687539070000	13171	6786	1	0	5003
276155	1874	204930000	13171	6786	1	0	0
108445	1397	1366462780000	13176	6788	0	0	7237
276179	1678	14400545320000	13176	6788	0	0	0
108451	1726	687534057000	13176	6788	6	0	5008
276185	1874	204943000	13176	6788	6	0	0
23491	1594	8545037000000	13176	6788	10	0	5
108456	1397	1366432777000	13177	6789	1	0	7240
276190	1678	14400545323000	13177	6789	1	0	0
108462	1726	687529045000	13177	6789	8	0	5013
276196	1874	204955000	13177	6789	8	0	0
276225	1678	14400545326000	13180	6790	0	0	0
108492	1397	1366392773000	13180	6790	1	0	7244
276226	1678	14400545327000	13180	6790	1	0	0
108497	1726	687521025000	13180	6790	6	0	5021
276232	1874	204977000	13180	6790	7	0	0
108503	1726	687517015000	13182	6792	2	0	5025
276238	1874	204987000	13182	6792	3	0	0
108630	1397	1366352769000	13184	6793	0	0	7248
276364	1678	14400545331000	13184	6793	0	0	0
108631	1397	1366342768000	13184	6793	1	0	7249
276365	1678	14400545332000	13184	6793	1	0	0
108639	1397	1366322766000	13186	6794	1	0	7251
276373	1678	14400545334000	13186	6794	1	0	0
33802	1677	106489602323100	13186	6794	2	0	1
108645	1726	687506991000	13187	6795	5	0	5035
276379	1874	205009000	13187	6795	5	0	0
108650	1726	687503983000	13188	6796	3	0	5038
276384	1874	205017000	13188	6796	3	0	0
108689	1726	687500976000	13194	6798	0	0	5041
276423	1874	205024000	13194	6798	0	0	0
108690	1726	687499973000	13194	6798	1	0	5042
276437	1678	14400545341000	13197	6799	0	0	0
108704	1397	1366242758000	13197	6799	1	0	7259
276442	1874	205047000	13197	6799	5	0	0
108710	1726	687490951000	13198	6800	1	0	5051
19422	1546	7200640000000	13198	6800	4	0	6
276448	1874	205054000	13199	6801	2	0	0
108715	1726	687487943000	13199	6801	3	0	5054
276454	1874	205064000	13200	6802	3	0	0
108721	1726	687483933000	13200	6802	4	0	5058
48227	1698	7016907550035	13200	6802	6	0	7
276465	1874	205074000	13202	6803	2	0	0
37550	1683	266835600149541	13202	6803	3	0	1
108735	1726	687479923000	13204	6804	1	0	5062
276477	1874	205084000	13207	6805	2	0	0
108744	1397	1366152749000	13208	6806	0	0	7268
55066	1739	23039690000000	13208	6806	4	0	0
276483	1874	205094000	13209	6807	2	0	0
57596	1768	7070675110000	13209	6807	4	0	6
108756	1397	1366132747000	13211	6808	0	0	7270
276490	1678	14400545353000	13211	6808	0	0	0
276491	1678	14400545354000	13211	6808	2	0	0
33810	1677	107929638323100	13211	6808	3	0	1
108762	1726	687468896000	13212	6809	4	0	5073
276497	1874	205107000	13212	6809	5	0	0
108772	1726	687465888000	13214	6810	2	0	5076
276508	1874	205116000	13214	6810	4	0	0
39971	1685	77041445571430	13214	6810	6	0	0
108778	1397	1366072741000	13216	6812	0	0	7276
276513	1874	205123000	13216	6812	1	0	0
47807	1696	6977283840000	13216	6812	4	0	5
108912	1397	1366062740000	13219	6813	0	0	7277
276646	1678	14400545360000	13219	6813	0	0	0
108913	1397	1366052739000	13219	6813	1	0	7278
276647	1678	14400545361000	13219	6813	1	0	0
108926	1726	687454862000	13221	6814	5	0	5087
276660	1874	205138000	13221	6814	5	0	0
31383	1670	7200757000000	13222	6815	3	0	6
109019	1397	1366022736000	13230	6817	0	0	7281
109020	1397	1366012735000	13230	6817	1	0	7282
276754	1678	14400545365000	13230	6817	1	0	0
276759	1874	205158000	13230	6817	6	0	0
109026	1726	687445839000	13231	6818	0	0	5096
109096	1397	1366002734000	13239	6819	0	0	7283
276830	1678	14400545366000	13239	6819	0	0	0
57217	1764	5766766100000	13239	6819	1	0	8
109100	1397	1365992733000	13241	6820	0	0	7284
276834	1678	14400545367000	13241	6820	0	0	0
109114	1726	687440827000	13244	6821	2	0	5101
276848	1874	205173000	13244	6821	2	0	0
109130	1726	687437819000	13250	6824	1	0	5104
276864	1874	205181000	13250	6824	1	0	0
13068	1444	7054983160000	13250	6824	5	0	5
109135	1726	687433810000	13251	6825	2	0	5108
276869	1874	205190000	13251	6825	2	0	0
109141	1726	687430803000	13254	6827	2	0	5111
276875	1874	205197000	13254	6827	2	0	0
109147	1726	687426793000	13256	6828	2	0	5115
276881	1874	205207000	13256	6828	2	0	0
53919	1723	8279168085979	13256	6828	6	0	6
109154	606	71419722812962	13258	6829	1	0	9
276887	1874	205217000	13258	6829	2	0	0
109160	1726	687420778000	13260	6831	2	0	5121
276893	1874	205225000	13260	6831	3	0	0
28489	1637	156964492819997	13260	6831	4	0	0
276900	1678	14400545381000	13263	6833	0	0	0
276901	1678	14400545382000	13263	6833	1	0	0
109171	1726	687416768000	13263	6833	3	0	5125
276922	1678	14400545383000	13267	6834	0	0	0
109191	1397	1365822716000	13267	6834	1	0	7301
276937	1678	14400545386000	13272	6836	0	0	0
109206	1726	687409752000	13272	6836	1	0	5132
52541	1715	30240509000000	13272	6836	3	0	0
109213	1397	1365792713000	13276	6837	0	0	7304
109214	1726	687408749000	13276	6837	1	0	5133
276948	1678	14400545388000	13277	6838	0	0	0
19002	1536	10800640999959	13277	6838	3	0	6
33825	1677	110809667324100	13278	6839	0	0	1
109220	1397	1365762710000	13279	6840	1	0	7307
276954	1874	205261000	13279	6840	3	0	0
109226	1726	687400729000	13279	6840	7	0	5141
28495	1637	159124541819997	13279	6840	10	0	0
276964	1678	14400545392000	13283	6841	0	0	0
58479	1933	720129000000	13283	6841	3	0	2
109235	1397	1365732707000	13284	6842	0	0	7310
276969	1874	205281000	13284	6842	2	0	0
17059	1506	5041040967172	13284	6842	6	0	17
109241	1397	1365712705000	13285	6843	0	0	7312
276975	1874	205293000	13285	6843	2	0	0
52942	1717	5147872000023	13285	6843	4	0	4
109250	1397	1365692703000	13288	6845	0	0	7314
276984	1874	205303000	13288	6845	2	0	0
109258	1726	687385692000	13290	6846	2	0	5156
53224	1718	5346726763340	13290	6846	4	0	9
276998	1678	14400545400000	13292	6847	1	0	0
109270	1726	687381682000	13292	6847	5	0	5160
59634	2087	719000000000	13292	6847	6	0	0
59635	2087	719024000000	13292	6847	7	0	0
277010	1678	14400545402000	13294	6848	1	0	0
109282	1726	687378675000	13294	6848	5	0	5163
277016	1874	205327000	13295	6849	1	0	0
109287	606	71417702812962	13296	6850	1	0	11
277021	1874	205335000	13296	6850	3	0	0
32398	1673	11846114000000	13296	6850	5	0	8
109293	1726	687373663000	13297	6851	3	0	5168
277027	1874	205342000	13297	6851	5	0	0
42868	1688	72361833904000	13297	6851	7	0	18
277033	1874	205347000	13299	6852	2	0	0
27513	1634	8831624641004	13299	6852	3	0	9
109302	1397	1365582692000	13300	6853	0	0	7325
277034	1678	14400545408000	13300	6853	0	0	0
109408	1397	1365572691000	13304	6855	0	0	7326
109409	1397	1365562690000	13304	6855	1	0	7327
277143	1874	205355000	13304	6855	3	0	0
109415	1726	687362635000	13304	6855	7	0	5179
35476	1679	28637491711000	13304	6855	9	0	22
277155	1678	14400545412000	13306	6856	0	0	0
109430	1726	687358625000	13308	6857	1	0	5183
277163	1874	205377000	13308	6857	2	0	0
109452	1397	1365512685000	13316	6859	0	0	7332
277184	1678	14400545415000	13316	6859	0	0	0
277185	1874	205385000	13316	6859	1	0	0
49982	1704	1506195000000	13316	6859	3	0	1
109458	1397	1365492683000	13318	6861	0	0	7334
277191	1874	205395000	13318	6861	1	0	0
59266	2039	5761082000000	13319	6862	4	0	1
109464	1726	687347598000	13320	6863	1	0	5194
277197	1874	205405000	13320	6863	2	0	0
109513	1397	1365452679000	13323	6865	0	0	7338
109514	1397	1365442678000	13323	6865	1	0	7339
277246	1678	14400545422000	13323	6865	1	0	0
109520	1726	687339578000	13323	6865	7	0	5202
277252	1874	205422000	13323	6865	7	0	0
109526	1397	1365402674000	13326	6868	0	0	7343
277258	1678	14400545426000	13326	6868	0	0	0
109531	1726	687332560000	13326	6868	5	0	5209
277263	1874	205440000	13326	6868	5	0	0
109646	1397	1365382672000	13329	6869	0	0	7345
277377	1678	14400545428000	13329	6869	0	0	0
109647	1726	687330555000	13329	6869	1	0	5211
277378	1874	205445000	13329	6869	1	0	0
26908	1623	46082473899898	13329	6869	4	0	1
55205	1740	6281225000000	13330	6870	4	0	11
109653	1397	1365362670000	13331	6871	0	0	7347
277384	1678	14400545430000	13331	6871	0	0	0
43522	1689	5760086287625	13331	6871	5	0	7
109659	1397	1365342668000	13332	6872	1	0	7349
277390	1678	14400545432000	13332	6872	1	0	0
109704	1726	684903540000	13337	6873	3	0	5220
277435	1874	205460000	13337	6873	3	0	0
109710	1726	683688531000	13337	6873	9	0	5226
277441	1874	205469000	13337	6873	9	0	0
277442	1874	205472000	13337	6873	10	0	0
109716	1726	683683521000	13338	6874	3	0	5231
277452	1678	14400545435000	13340	6875	0	0	0
109725	1726	683680515000	13340	6875	5	0	5234
277458	1874	205490000	13340	6875	7	0	0
22502	1587	8640344000000	13340	6875	9	0	7
109739	1726	683675504000	13342	6876	2	0	5239
277471	1874	205497000	13342	6876	3	0	0
109749	1726	683670495000	13345	6878	0	0	5244
277481	1874	205508000	13345	6878	1	0	0
109753	1726	683667489000	13346	6879	1	0	5247
109754	1726	683666486000	13346	6879	2	0	5248
37573	1683	271155636149541	13346	6879	4	0	1
277492	1678	14400545440000	13348	6880	0	0	0
109765	1726	683866479000	13348	6880	4	0	5252
277505	1678	14400545441000	13351	6881	0	0	0
109779	1726	683862471000	13352	6882	4	0	5256
277511	1874	532000	13352	6882	5	0	1
109790	1726	683858464000	13355	6883	2	0	5260
3317	576	72995659938283	13355	6883	4	0	4
277535	1874	538000	13360	6884	1	0	1
30067	1654	10367961000000	13360	6884	5	0	4
109936	1397	1365212655000	13363	6885	0	0	7362
277666	1678	14400545445000	13363	6885	0	0	0
109937	1397	1365202654000	13364	6886	0	0	7363
277667	1678	14400545446000	13364	6886	0	0	0
109943	1397	1365192653000	13365	6887	0	0	7364
277673	1678	14400545447000	13365	6887	0	0	0
109969	1726	683847444000	13368	6888	3	0	5271
277698	1874	556000	13368	6888	3	0	1
109974	1397	1365152649000	13369	6889	1	0	7368
277703	1678	14400545451000	13369	6889	1	0	0
109980	1726	683838426000	13369	6889	7	0	5280
277709	1874	574000	13369	6889	7	0	1
277717	1678	14400545452000	13371	6890	0	0	0
277718	1678	14400545453000	13371	6890	1	0	0
109993	1726	683835420000	13371	6890	5	0	5283
277724	1874	583000	13371	6890	7	0	1
109998	1726	683830411000	13371	6890	10	0	5288
277733	1874	593000	13373	6891	2	0	1
29489	1649	8923855999992	13373	6891	4	0	4
110015	1726	683826404000	13376	6892	1	0	5292
277746	1874	601000	13376	6892	3	0	1
110021	1726	683821393000	13377	6893	3	0	5297
277752	1402	34414096319298	13378	6894	1	0	33
110025	1726	683819389000	13378	6894	3	0	5299
110026	1726	683818387000	13378	6894	4	0	5300
277762	1678	14400545461000	13381	6896	1	0	0
110036	1726	683816383000	13381	6896	4	0	5302
277767	1874	620000	13381	6896	6	0	1
110042	1726	683810372000	13381	6896	10	0	5308
277773	1874	629000	13381	6896	12	0	1
110055	1397	1365032637000	13383	6897	0	0	7380
277787	1874	638000	13383	6897	3	0	1
110061	1726	682592356000	13383	6897	6	0	5317
46853	1693	13593513155041	13383	6897	8	0	667
277800	1678	14400545465000	13385	6898	0	0	0
18328	1518	7200305000000	13385	6898	3	0	0
110075	1726	682588350000	13386	6899	1	0	5321
28500	1637	161284578819997	13386	6899	3	0	0
277809	1678	14400545467000	13388	6900	0	0	0
110089	1397	1364982632000	13392	6901	0	0	7385
277828	1678	14400545469000	13394	6902	0	0	0
110102	1726	682581338000	13394	6902	3	0	5328
277833	1874	665000	13394	6902	5	0	1
296	43	72480674890000	13394	6902	8	0	1
110115	1726	682577332000	13396	6903	2	0	5332
277846	1874	673000	13396	6903	4	0	1
110142	1397	1364932627000	13400	6904	0	0	7390
277871	1678	14400545473000	13400	6904	0	0	0
277872	1678	14400545474000	13400	6904	1	0	0
110148	1726	682568315000	13400	6904	6	0	5341
37588	1683	274035687149541	13400	6904	8	0	1
277878	1678	14400545475000	13401	6905	0	0	0
110154	1726	682564309000	13401	6905	5	0	5345
110173	1397	1364892623000	13407	6906	0	0	7394
277902	1678	14400545477000	13407	6906	0	0	0
110174	1726	682563308000	13407	6906	1	0	5346
277911	1678	14400545479000	13409	6907	1	0	0
110184	1726	682559300000	13409	6907	3	0	5350
277917	485	67438999000000	13409	6907	7	0	1
42908	1688	74521857904000	13409	6907	8	0	18
110190	1726	682555293000	13411	6908	1	0	5354
277923	1678	14400545482000	13412	6909	1	0	0
110195	1726	682552287000	13412	6909	2	0	5357
56654	1759	7920653999999	13412	6909	7	0	7
277930	1678	14400545483000	13414	6910	0	0	0
110203	1726	682548281000	13414	6910	2	0	5361
277936	1678	14400545486000	13415	6911	1	0	0
33841	1677	113689687324100	13415	6911	2	0	1
110209	1397	1364782612000	13416	6912	1	0	7405
277942	1874	728000	13416	6912	5	0	1
110214	1726	682541270000	13416	6912	6	0	5368
277947	1678	14400545489000	13418	6913	0	0	0
110220	1726	682536263000	13418	6913	2	0	5373
277953	1678	14400545491000	13420	6915	0	0	0
110226	1750	4168000000	13420	6915	2	0	32
51813	1711	9884497000000	13420	6915	6	0	9
277959	1678	14400545493000	13421	6916	0	0	0
110231	1397	1364722606000	13421	6916	1	0	7411
277982	1874	748000	13424	6917	2	0	1
110255	1726	682527249000	13424	6917	4	0	5382
277985	1874	754000	13424	6917	5	0	1
277986	1874	756000	13424	6917	6	0	1
24503	1601	11018674600000	13424	6917	11	0	9
110266	1397	1364702604000	13427	6918	0	0	7413
277997	1874	766000	13427	6918	2	0	1
110272	1726	682518231000	13429	6919	1	0	5391
278008	1678	14400545498000	13431	6920	0	0	0
11200	1419	11981188280064	13431	6920	3	0	3
110282	1397	1364672601000	13432	6921	0	0	7416
278013	1678	14400545501000	13432	6921	2	0	0
110288	1726	682510216000	13432	6921	6	0	5399
278019	1874	789000	13432	6921	8	0	1
110293	1726	682505205000	13432	6921	11	0	5404
278025	1874	798000	13433	6922	2	0	1
110297	1726	682502199000	13433	6922	3	0	5407
110298	1397	1364632597000	13434	6923	0	0	7420
278030	1874	807000	13434	6923	3	0	1
110309	1726	682497189000	13437	6924	2	0	5412
278046	1678	14400545506000	13441	6925	1	0	0
110320	1726	682495186000	13441	6925	4	0	5414
278052	1874	819000	13441	6925	7	0	1
110325	1726	682490177000	13441	6925	9	0	5419
278057	1874	829000	13441	6925	12	0	1
37605	1683	278355800149541	13441	6925	16	0	1
110331	1397	1364572591000	13442	6926	0	0	7426
42934	1688	76681909904000	13442	6926	1	0	18
278069	1874	835000	13445	6928	1	0	1
110343	1726	682481159000	13445	6928	5	0	5428
278075	1874	847000	13445	6928	8	0	1
54843	1729	13247005000000	13445	6928	10	0	4
110374	1726	682476148000	13449	6929	0	0	5433
278110	1678	14400545512000	13452	6930	0	0	0
110384	1726	682472141000	13452	6930	3	0	5437
57025	1762	8241808994000	13452	6930	6	0	4
278124	1678	14400545514000	13455	6931	0	0	0
278125	1874	862000	13455	6931	1	0	1
110399	1397	1364502584000	13457	6933	1	0	7433
278131	1874	868000	13457	6933	4	0	1
110404	1726	682464129000	13457	6933	6	0	5445
278140	1874	876000	13461	6934	2	0	1
26643	1622	21599491999976	13461	6934	4	0	0
110413	1726	682460123000	13462	6935	1	0	5449
278148	1874	880000	13464	6936	1	0	1
110499	1397	1364462580000	13467	6937	0	0	7437
110500	1726	682456117000	13467	6937	1	0	5453
278231	1874	886000	13469	6938	1	0	1
110509	1397	1364432577000	13471	6939	1	0	7440
278240	1874	894000	13471	6939	4	0	1
29540	1649	11083921999992	13471	6939	8	0	4
110524	1397	1364422576000	13475	6940	0	0	7441
278272	1678	14400545525000	13480	6941	0	0	0
278273	1874	900000	13480	6941	1	0	1
54191	1724	6429308000000	13480	6941	5	0	7
110548	1397	1364402574000	13481	6942	0	0	7443
278279	1678	14400545529000	13481	6942	3	0	0
110554	1726	682444094000	13481	6942	6	0	5465
278285	1874	910000	13481	6942	9	0	1
110560	1726	682438085000	13481	6942	12	0	5471
278290	1874	918000	13481	6942	14	0	1
110565	1726	682433078000	13481	6942	17	0	5476
110575	1397	1364352569000	13483	6943	0	0	7448
110576	1397	1364342568000	13483	6943	1	0	7449
278305	1678	14400545533000	13483	6943	2	0	0
110582	1726	682428070000	13483	6943	7	0	5481
278311	1874	931000	13483	6943	8	0	1
110597	1726	682425066000	13485	6944	4	0	5484
278325	1874	934000	13485	6944	4	0	1
110602	1397	1364292563000	13486	6945	0	0	7454
278331	1678	14400545538000	13486	6945	1	0	0
110608	1726	682417054000	13486	6945	7	0	5492
278337	1874	948000	13486	6945	8	0	1
110620	1397	1364252559000	13488	6946	1	0	7458
278348	1678	14400545541000	13488	6946	1	0	0
110627	1726	679991045000	13490	6947	2	0	5500
278355	1874	957000	13490	6947	3	0	1
41034	1687	5032528524804	13490	6947	6	0	5
110647	1397	1364212555000	13493	6948	2	0	7462
278375	1874	961000	13493	6948	4	0	1
110653	1726	679983033000	13493	6948	8	0	5508
16010	1474	6754358000023	13493	6948	9	0	13
278383	1678	14400545546000	13495	6949	0	0	0
54567	1727	6666691000000	13495	6949	1	0	7
110665	1726	679980028000	13497	6950	3	0	5511
278393	2095	200000000	13497	6950	5	0	0
278395	1678	14400545548000	13499	6951	0	0	0
110676	1397	1364172551000	13502	6952	0	0	7466
278411	1678	14400545550000	13505	6953	0	0	0
37619	1683	282675868149541	13505	6953	3	0	1
110689	1397	1364152549000	13507	6954	0	0	7468
278418	1874	984000	13507	6954	3	0	1
110694	1726	678760013000	13507	6954	5	0	5522
278423	1874	991000	13507	6954	8	0	1
110700	1726	677546007000	13508	6955	1	0	5527
110762	1397	1364112545000	13511	6956	0	0	7472
110763	1726	677544004000	13511	6956	1	0	5529
278489	1874	996000	13511	6956	1	0	1
57631	1768	9230688110000	13511	6956	3	0	6
110769	1397	1364082542000	13513	6958	1	0	7475
278495	1678	14400545558000	13513	6958	1	0	0
37630	1683	285555916149541	13513	6958	7	0	1
278504	1678	14400545559000	13517	6959	0	0	0
110779	1726	677535992000	13517	6959	1	0	5537
110784	2077	1438999000000	13518	6960	3	0	1
278510	1653	8000000	13518	6960	3	0	3
13748	1448	3636687000001	13518	6960	4	0	8
110798	1726	677529983000	13522	6962	1	0	5543
278524	1874	1017000	13522	6962	1	0	1
278530	1678	14400545563000	13524	6963	0	0	0
278531	1874	1020000	13524	6963	1	0	1
110824	1397	1364022536000	13529	6964	0	0	7481
278553	1874	1024000	13529	6964	3	0	1
110829	1726	676312973000	13529	6964	6	0	5551
18515	1522	6094036000000	13529	6964	8	0	10
39989	1685	79201469571430	13530	6965	1	0	0
39990	1685	79201470571430	13530	6965	2	0	0
278559	1874	1032000	13531	6966	2	0	1
110838	1726	676308967000	13533	6967	1	0	5555
110846	1397	1363982532000	13536	6968	0	0	7485
110847	1726	676306964000	13536	6968	1	0	5557
278573	1874	1036000	13536	6968	1	0	1
30093	1654	12527997000000	13536	6968	4	0	4
49464	1702	3600226000000	13539	6969	3	0	3
110868	1726	676302958000	13544	6970	1	0	5561
278594	1874	1042000	13544	6970	1	0	1
22756	1588	11014897000000	13551	6972	2	0	6
110900	1726	676299953000	13558	6973	2	0	5564
278626	1874	1047000	13558	6973	2	0	1
110908	1397	1363922526000	13560	6974	0	0	7491
278634	1678	14400545574000	13560	6974	0	0	0
50217	1705	7120493500145	13562	6975	2	0	18
110916	1397	1363882522000	13563	6976	2	0	7495
278642	1678	14400545578000	13563	6976	2	0	0
110922	1726	676287935000	13563	6976	8	0	5576
278648	1874	1065000	13563	6976	8	0	1
4527	633	74523954900000	13563	6976	10	0	5
37646	1683	289875962149541	13564	6977	4	0	1
110927	1397	1363862520000	13565	6978	0	0	7497
278653	1678	14400545580000	13565	6978	0	0	0
110933	1726	676283929000	13565	6978	6	0	5580
278659	1874	1071000	13565	6978	6	0	1
110991	1397	1363852519000	13569	6979	0	0	7498
278717	1678	14400545581000	13569	6979	0	0	0
110992	1726	676281926000	13569	6979	1	0	5582
278718	1874	1074000	13569	6979	1	0	1
14639	1457	9264253040000	13569	6979	4	0	4
111043	1726	676277920000	13576	6981	1	0	5586
278769	1874	1080000	13576	6981	1	0	1
111049	1726	676274916000	13577	6982	4	0	5589
278775	1874	1084000	13577	6982	4	0	1
31068	1668	10046560000000	13577	6982	9	0	5
111054	2058	571500000	13578	6983	0	0	4
278780	2047	40500000	13578	6983	0	0	0
111060	1726	676267905000	13579	6984	2	0	5596
278786	1874	1095000	13579	6984	2	0	1
111066	1397	1363752509000	13580	6985	1	0	7508
278792	1678	14400545591000	13580	6985	1	0	0
111071	1726	676259890000	13580	6985	7	0	5604
278797	1874	1110000	13580	6985	7	0	1
278801	1874	1119000	13580	6985	11	0	1
278802	1874	1120000	13580	6985	12	0	1
111081	1397	1363732507000	13582	6986	0	0	7510
111091	1726	676250872000	13584	6987	2	0	5613
278816	1874	1128000	13584	6987	2	0	1
111105	1726	676246863000	13587	6988	2	0	5617
278830	1874	1138000	13587	6988	3	0	1
111111	1726	675032856000	13588	6989	4	0	5622
278835	1874	1144000	13588	6989	4	0	1
111125	1397	1363692503000	13592	6990	0	0	7514
111126	1726	675031854000	13592	6990	1	0	5623
4377	632	93360797000000	13592	6990	3	0	0
278854	1874	1152000	13593	6991	2	0	1
47109	1694	7212370127629	13593	6991	5	0	34
111149	1397	1363672501000	13599	6992	0	0	7516
25240	1608	9645559000000	13599	6992	4	0	4
278881	1874	1162000	13602	6993	1	0	1
111159	1726	675022834000	13602	6993	3	0	5632
28509	1637	163444614819997	13602	6993	4	0	0
278913	1678	14400545603000	13604	6994	2	0	0
111191	1397	1363612495000	13604	6994	4	0	7522
278919	1874	1171000	13604	6994	8	0	1
111197	1726	675018824000	13604	6994	10	0	5636
278925	1874	1183000	13604	6994	14	0	1
111203	1726	675012812000	13604	6994	16	0	5642
278930	1874	1194000	13604	6994	19	0	1
111208	1726	675007803000	13604	6994	21	0	5647
278936	1874	1206000	13604	6994	25	0	1
278937	1874	1207000	13604	6994	26	0	1
111218	1397	1363582492000	13607	6996	0	0	7525
278942	1678	14400545608000	13607	6996	0	0	0
111224	1726	674997782000	13607	6996	6	0	5657
278948	1874	1218000	13607	6996	6	0	1
31745	1671	6528269530515	13607	6996	9	0	4
111237	1726	674995779000	13610	6997	3	0	5659
278962	1874	1225000	13610	6997	5	0	1
111243	1397	1363542488000	13611	6998	0	0	7529
278967	1874	1233000	13611	6998	1	0	1
111249	1397	1363532487000	13613	6999	0	0	7530
111250	1726	674987763000	13613	6999	1	0	5667
278980	1678	14400545614000	13615	7000	0	0	0
111260	1726	674982752000	13615	7000	3	0	5672
37666	1683	294196050149541	13615	7000	5	0	1
278994	1874	1251000	13618	7001	3	0	1
111274	1726	674978745000	13619	7002	1	0	5676
278999	1874	1260000	13619	7002	3	0	1
33859	1677	115129705324100	13619	7002	5	0	1
111288	1726	674974737000	13623	7003	2	0	5680
279014	1874	1267000	13624	7004	1	0	1
111331	1397	1363472481000	13630	7006	0	0	7536
279057	1678	14400545622000	13630	7006	3	0	0
111337	1726	674967722000	13630	7006	6	0	5687
279062	1874	1281000	13630	7006	8	0	1
111342	1726	674962713000	13630	7006	11	0	5692
279068	1874	1293000	13630	7006	14	0	1
111348	1726	674957703000	13631	7007	1	0	5697
279073	1874	1302000	13631	7007	3	0	1
279074	1678	14400545624000	13632	7008	0	0	0
111354	1397	1363412475000	13633	7009	0	0	7542
111385	1397	1363382472000	13636	7010	1	0	7545
279108	1678	14400545628000	13636	7010	1	0	0
111386	1726	674952691000	13636	7010	2	0	5702
279114	1874	1319000	13636	7010	7	0	1
111392	1726	674946679000	13636	7010	8	0	5708
279119	1874	1328000	13636	7010	12	0	1
111430	1397	1363372471000	13640	7011	0	0	7546
279157	1874	1333000	13640	7011	4	0	1
111435	1726	674939666000	13640	7011	5	0	5715
279163	1874	1345000	13640	7011	10	0	1
111441	1726	674933654000	13640	7011	11	0	5721
279168	1874	1355000	13640	7011	15	0	1
33873	1677	115849757324100	13640	7011	17	0	1
111447	1726	674928643000	13641	7012	1	0	5726
279174	1874	1363000	13642	7013	1	0	1
111452	1726	674924636000	13642	7013	2	0	5730
2228	369	91920760000000	13642	7013	5	0	0
42952	1688	78841952904000	13647	7014	3	0	18
279192	1678	14400545636000	13648	7015	0	0	0
111470	1726	674920628000	13648	7015	1	0	5734
58197	1850	9278864000000	13648	7015	3	0	5
279198	1678	14400545638000	13651	7017	0	0	0
111477	1726	674916618000	13651	7017	2	0	5738
111639	1397	1363262460000	13661	7021	0	0	7557
279360	1678	14400545640000	13661	7021	0	0	0
111640	1397	1363252459000	13661	7021	1	0	7558
279361	1678	14400545641000	13661	7021	1	0	0
111646	1726	674911607000	13661	7021	7	0	5743
279367	1874	1393000	13661	7021	7	0	1
111652	1726	674905595000	13661	7021	13	0	5749
279373	1874	1405000	13661	7021	13	0	1
111687	1601	7986677600000	13664	7022	0	0	10
111688	1397	1363212455000	13664	7022	1	0	7562
279412	1262	612167826200000	13664	7022	4	0	0
111694	1397	1363182452000	13664	7022	7	0	7565
279418	1874	1412000	13664	7022	10	0	1
111700	1726	674912173000	13664	7022	13	0	5755
279424	1678	14400545649000	13666	7023	0	0	0
111705	1726	674908165000	13666	7023	2	0	5759
279436	1874	1429000	13670	7024	2	0	1
111720	1397	1363142448000	13673	7026	0	0	7569
58708	1991	6235661441475	13673	7026	3	0	12
279450	1678	14400545653000	13676	7027	0	0	0
111732	1397	1363122446000	13677	7028	0	0	7571
279459	1678	14400545655000	13679	7029	0	0	0
111740	1726	674897142000	13679	7029	2	0	5770
279468	1678	14400545657000	13683	7031	0	0	0
111750	1679	27218813117000	13683	7031	3	0	23
279474	1874	1460000	13683	7031	6	0	1
49503	1702	5760262000000	13686	7032	2	0	3
111764	1679	26027876652000	13689	7033	0	0	24
279485	889	225633308357249	13689	7033	0	0	0
279486	1874	1466000	13689	7033	1	0	1
3200	532	68880026000000	13689	7033	2	0	0
20671	1559	5722593000000	13691	7034	2	0	4
111775	1397	1363032437000	13693	7035	1	0	7580
279498	1874	1475000	13693	7035	3	0	1
111866	1397	1363022436000	13695	7036	0	0	7581
111867	1397	1363012435000	13695	7036	1	0	7582
279590	1874	1484000	13695	7036	5	0	1
111875	1726	674884103000	13697	7037	1	0	5783
279597	1678	14400545669000	13699	7039	0	0	0
11965	1423	2193224999985	13699	7039	2	0	15
111881	1726	674881094000	13700	7040	1	0	5786
279605	1874	1499000	13702	7041	2	0	1
111907	1397	1362932427000	13705	7042	0	0	7590
279625	1678	14400545673000	13705	7042	0	0	0
279626	1874	1505000	13705	7042	1	0	1
15700	1471	10699598900000	13705	7042	3	0	4
33891	1677	118009801324100	13706	7043	5	0	1
111913	1397	1362902424000	13707	7044	0	0	7593
279632	1874	1514000	13707	7044	1	0	1
37693	1683	299956118149541	13708	7045	4	0	1
111931	1397	1362882422000	13712	7046	0	0	7595
111932	1726	674871068000	13712	7046	1	0	5796
279650	1874	1522000	13712	7046	1	0	1
279655	1678	14400545680000	13713	7047	2	0	0
111938	1726	674868062000	13713	7047	3	0	5799
279661	1874	1538000	13713	7047	8	0	1
111953	631	66000801000000	13715	7048	0	0	2
111958	1726	674860046000	13715	7048	5	0	5807
279676	1874	1544000	13715	7048	5	0	1
279681	1678	14400545684000	13716	7049	1	0	0
111964	1726	674856038000	13716	7049	2	0	5811
279687	1874	1562000	13716	7049	7	0	1
111970	2099	718499000000	13716	7049	8	0	1
2989	484	91920781000000	13716	7049	10	0	0
111975	1726	674848022000	13717	7050	4	0	5819
279693	1874	1568000	13717	7050	4	0	1
279702	1874	1576000	13719	7051	2	0	1
111985	1726	674843013000	13719	7051	3	0	5824
279716	1678	14400545689000	13723	7053	0	0	0
111999	1726	674839004000	13723	7053	1	0	5828
11972	1423	2913235999985	13723	7053	4	0	15
112004	1726	674834996000	13724	7054	2	0	5832
279722	1874	1594000	13724	7054	2	0	1
279736	1874	1598000	13728	7056	1	0	1
112019	1726	674831990000	13728	7056	2	0	5835
23984	1599	7539739393047	13728	7056	7	0	4
279749	1678	14400545693000	13730	7057	0	0	0
112032	1726	674826980000	13730	7057	1	0	5840
279753	1678	14400545694000	13731	7058	0	0	0
279754	1874	1616000	13731	7058	1	0	1
112037	1726	674822972000	13731	7058	2	0	5844
279764	1874	1625000	13733	7059	3	0	1
112057	1397	1362702404000	13737	7060	0	0	7613
42965	1688	80282009904000	13737	7060	3	0	18
112065	1726	674815959000	13739	7061	1	0	5851
112066	1726	674814956000	13739	7061	2	0	5852
279784	1874	1634000	13739	7061	2	0	1
55879	1747	2896846000000	13739	7061	5	0	5
279793	1678	14400545701000	13741	7062	3	0	0
112076	1397	1362642398000	13741	7062	4	0	7619
279799	1874	1646000	13741	7062	9	0	1
112082	1726	674807942000	13741	7062	10	0	5859
112087	1726	674802932000	13741	7062	15	0	5864
279805	1874	1658000	13741	7062	15	0	1
31428	1670	10080894000000	13741	7062	20	0	6
279875	1678	14400545703000	13746	7063	0	0	0
112158	1726	674797923000	13746	7063	1	0	5869
37720	1683	304276157149541	13746	7063	4	0	1
279889	1874	1673000	13749	7064	2	0	1
112172	1726	674793914000	13749	7064	3	0	5873
279890	1874	1676000	13749	7064	3	0	1
112184	1726	674789906000	13751	7065	1	0	5877
279903	1874	1685000	13751	7065	2	0	1
112190	1397	1362592393000	13752	7066	0	0	7624
279909	1874	1696000	13752	7066	1	0	1
40003	1685	81361495571430	13752	7066	4	0	0
112196	1726	674779887000	13753	7067	2	0	5887
279914	1874	1703000	13753	7067	2	0	1
57068	1762	10401844994000	13753	7067	4	0	4
112202	1397	1362572391000	13755	7068	0	0	7626
112203	1726	674777882000	13755	7068	1	0	5889
279932	1678	14400545710000	13757	7069	0	0	0
112217	1726	674773875000	13757	7069	3	0	5893
279938	1874	1721000	13757	7069	6	0	1
112243	1726	674768864000	13762	7070	1	0	5898
279963	1874	1730000	13762	7070	3	0	1
1106	114	66722740000000	13762	7070	4	0	6
112252	1726	674764857000	13764	7071	2	0	5902
279973	1874	1738000	13765	7072	1	0	1
15574	1467	29522581100000	13765	7072	4	0	0
112262	1397	1362512385000	13767	7073	0	0	7632
279983	1874	1748000	13767	7073	3	0	1
52751	1716	8686690000000	13767	7073	4	0	4
112268	1726	674756840000	13768	7074	2	0	5910
279988	1874	1754000	13768	7074	4	0	1
112273	1726	674751830000	13768	7074	7	0	5915
37732	1683	307156222149541	13768	7074	9	0	1
280003	1874	1763000	13771	7075	2	0	1
29572	1649	13244086999992	13771	7075	4	0	4
112288	1726	674747822000	13772	7076	1	0	5919
22522	1587	10080385000000	13772	7076	5	0	7
280029	1678	14400545720000	13778	7078	0	0	0
280030	1678	14400545721000	13778	7078	1	0	0
112314	1397	1362432377000	13778	7078	3	0	7640
280036	1874	1780000	13778	7078	7	0	1
112319	1726	674740809000	13778	7078	8	0	5926
280042	1874	1792000	13778	7078	13	0	1
112325	1726	674734797000	13778	7078	14	0	5932
112452	1397	1362422376000	13782	7079	0	0	7641
280170	1678	14400545724000	13782	7079	0	0	0
112453	1726	674732792000	13782	7079	1	0	5934
280171	1874	1798000	13782	7079	1	0	1
112465	1726	674728783000	13784	7080	3	0	5938
280183	1874	1807000	13784	7080	3	0	1
10318	1402	35134120319298	13784	7080	7	0	33
112471	1726	674724773000	13785	7081	3	0	5942
280189	1874	1817000	13785	7081	3	0	1
112497	1397	1362382372000	13789	7082	0	0	7645
112498	1397	1362372371000	13789	7082	1	0	7646
280218	1874	1823000	13789	7082	3	0	1
112504	1726	674717760000	13789	7082	7	0	5949
280233	1591	718512000000	13792	7083	1	0	1
112524	1397	1362352369000	13795	7084	0	0	7648
280244	1874	1841000	13795	7084	2	0	1
20679	1559	6442617000000	13795	7084	5	0	4
112529	1726	674710746000	13796	7085	1	0	5956
280249	1874	1847000	13796	7085	3	0	1
112543	1726	674706737000	13799	7086	2	0	5960
280268	1678	14400545734000	13801	7087	0	0	0
112554	1726	674702730000	13801	7087	4	0	5964
280274	2102	200000000	13801	7087	6	0	0
112559	1726	672279724000	13801	7087	9	0	5969
280283	1874	1868000	13803	7088	1	0	1
112569	1397	1362282362000	13804	7089	1	0	7655
280289	1874	1877000	13804	7089	3	0	1
280305	1678	14400545739000	13808	7090	0	0	0
280306	1874	1880000	13808	7090	1	0	1
112589	1726	672271707000	13808	7090	2	0	5977
112595	1397	1362262360000	13810	7091	0	0	7657
280313	1678	14400545740000	13810	7091	0	0	0
1241	149	77070087000341	13810	7091	5	0	5
112606	1397	1362242358000	13812	7092	1	0	7659
280324	1678	14400545742000	13812	7092	1	0	0
112609	1726	672261688000	13812	7092	4	0	5987
112610	1726	672260686000	13812	7092	5	0	5988
280329	1874	1907000	13812	7092	6	0	1
112626	1726	672255676000	13815	7093	4	0	5993
280349	1678	14400545744000	13817	7094	0	0	0
112636	1726	672253671000	13817	7094	5	0	5995
280355	1874	1920000	13817	7094	6	0	1
112641	1726	672248662000	13817	7094	10	0	6000
280360	1874	1931000	13817	7094	11	0	1
32417	1673	14006218000000	13817	7094	17	0	8
112663	1397	1362182352000	13819	7095	0	0	7665
280396	1678	14400545749000	13822	7096	0	0	0
112683	1726	672238641000	13822	7096	5	0	6010
280402	1874	1950000	13822	7096	6	0	1
112688	1726	672235635000	13823	7097	3	0	6013
280407	1874	1956000	13823	7097	4	0	1
11230	1419	13421257280064	13823	7097	8	0	3
112697	1397	1362122346000	13826	7098	2	0	7671
280416	1874	1963000	13826	7098	3	0	1
112703	1726	672226618000	13826	7098	8	0	6022
280422	1874	1975000	13826	7098	9	0	1
112708	1397	1362102344000	13827	7099	1	0	7673
280427	1678	14400545757000	13827	7099	2	0	0
112714	1726	672219603000	13827	7099	7	0	6029
280433	1874	1989000	13827	7099	8	0	1
280434	1874	1990000	13827	7099	9	0	1
112720	1726	672213591000	13827	7099	13	0	6035
280440	1874	2002000	13827	7099	15	0	1
44155	1690	96483078000000	13827	7099	16	0	0
37753	1683	311476255149541	13828	7100	2	0	1
112747	1397	1362062340000	13831	7101	0	0	7677
112748	1397	1362052339000	13831	7101	1	0	7678
280469	1678	14400545764000	13831	7101	4	0	0
112754	1726	672209583000	13832	7102	1	0	6039
280474	1874	2011000	13832	7102	3	0	1
112760	1726	672203571000	13832	7102	7	0	6045
280480	1874	2023000	13832	7102	9	0	1
112765	1726	672198561000	13832	7102	12	0	6050
280486	1874	2035000	13832	7102	15	0	1
112771	1726	672192549000	13832	7102	18	0	6056
280491	1874	2044000	13832	7102	20	0	1
2525	470	74640330000000	13832	7102	21	0	6
112930	1397	1361992333000	13839	7104	0	0	7684
280648	1678	14400545767000	13839	7104	0	0	0
112931	1397	1361982332000	13839	7104	1	0	7685
280649	1678	14400545768000	13839	7104	1	0	0
112937	1726	672182529000	13839	7104	7	0	6066
280655	1874	2061000	13839	7104	7	0	1
24944	1605	40000000	13840	7105	2	0	0
112943	1726	672178522000	13840	7105	6	0	6070
280661	1874	2068000	13840	7105	6	0	1
112980	1397	1361932327000	13844	7106	2	0	7690
280698	1678	14400545773000	13844	7106	2	0	0
280721	1678	14400545775000	13847	7107	0	0	0
280722	1874	2074000	13847	7107	1	0	1
113007	1726	672172510000	13847	7107	4	0	6076
280728	1874	2086000	13847	7107	7	0	1
113013	1726	672166498000	13847	7107	10	0	6082
113033	1397	1361902324000	13850	7108	0	0	7693
280751	1678	14400545776000	13850	7108	0	0	0
14990	1458	10893535908540	13850	7108	1	0	4
113059	1397	1361892323000	13855	7109	0	0	7694
280781	1874	2104000	13855	7109	4	0	1
113065	1726	672158481000	13855	7109	6	0	6090
45863	1692	54742408019999	13855	7109	11	0	4
280787	1678	14400545778000	13856	7110	0	0	0
113071	1726	672154474000	13856	7110	2	0	6094
280793	1874	2125000	13856	7110	6	0	1
113076	1726	672149463000	13856	7110	7	0	6099
33907	1677	120169860324100	13856	7110	8	0	1
280798	1874	2133000	13857	7111	3	0	1
113082	1726	672145456000	13858	7112	1	0	6103
42988	1688	82442049904000	13861	7113	1	0	18
280819	1678	14400545783000	13863	7114	0	0	0
113103	1726	672142450000	13864	7115	1	0	6106
280825	1874	2149000	13864	7115	5	0	1
113108	1726	672137439000	13864	7115	6	0	6111
53943	1723	10439307085979	13864	7115	10	0	6
280830	1678	14400545785000	13865	7116	0	0	0
113114	1726	672132429000	13865	7116	2	0	6116
280836	1874	2167000	13866	7117	2	0	1
113120	1726	672127420000	13866	7117	4	0	6121
280851	1678	14400545787000	13869	7118	0	0	0
280852	1678	14400545788000	13869	7118	1	0	0
113135	1726	672124414000	13869	7118	2	0	6124
280858	1874	2187000	13869	7118	7	0	1
32103	1672	9361841000000	13869	7118	9	0	5
113151	1397	1361772311000	13872	7119	0	0	7706
113153	1726	672117399000	13872	7119	2	0	6131
113154	1726	672116397000	13872	7119	3	0	6132
280874	1678	14400545791000	13873	7120	1	0	0
113160	1726	672112390000	13873	7120	5	0	6136
280879	1874	2203000	13873	7120	6	0	1
113170	1726	672109384000	13875	7121	5	0	6139
280889	1874	2209000	13875	7121	6	0	1
113175	1726	672105375000	13875	7121	10	0	6143
280895	1874	2218000	13875	7121	12	0	1
113197	1726	672101367000	13879	7122	2	0	6147
280916	1874	2224000	13879	7122	3	0	1
113228	1397	1361692303000	13883	7123	0	0	7714
280947	1678	14400545798000	13883	7123	1	0	0
113233	1726	672094354000	13884	7124	2	0	6154
280953	1874	2241000	13884	7124	4	0	1
113239	1726	672088342000	13884	7124	8	0	6160
280958	1874	2251000	13884	7124	9	0	1
113245	1726	672083331000	13885	7125	1	0	6165
280964	1874	2260000	13885	7125	2	0	1
45877	1692	56902473019999	13885	7125	3	0	4
113250	1726	672079324000	13886	7126	3	0	6169
27549	1634	10991711641004	13886	7126	4	0	9
280985	1678	14400545803000	13891	7127	0	0	0
280986	1678	14400545804000	13892	7128	0	0	0
113325	1397	1361612295000	13897	7129	0	0	7722
113326	1397	1361602294000	13897	7129	1	0	7723
43006	1688	84602079904000	13897	7129	2	0	18
281079	1678	14400545810000	13899	7130	3	0	0
113363	1726	672078321000	13899	7130	5	0	6170
281085	1874	2277000	13899	7130	9	0	1
113369	1726	672072309000	13899	7130	11	0	6176
281090	1874	2287000	13899	7130	14	0	1
113374	1726	672067300000	13899	7130	16	0	6181
281096	1874	2298000	13899	7130	20	0	1
113380	1726	672061289000	13899	7130	22	0	6187
281102	1874	2310000	13899	7130	26	0	1
113386	1726	672055277000	13899	7130	28	0	6193
113485	1397	1361542288000	13904	7131	0	0	7729
281203	1678	14400545812000	13904	7131	0	0	0
113486	1726	672052271000	13904	7131	1	0	6196
281204	1874	2319000	13904	7131	1	0	1
33924	1677	122329915324100	13904	7131	4	0	1
113496	1726	672047261000	13906	7132	3	0	6201
281214	1874	2329000	13906	7132	3	0	1
113510	1726	672043253000	13908	7133	5	0	6205
281228	1874	2337000	13908	7133	5	0	1
113517	1726	672039244000	13910	7134	2	0	6209
281235	1874	2346000	13910	7134	2	0	1
35471	1679	28187902652000	13913	7135	1	0	24
281257	1678	14400545818000	13920	7137	0	0	0
281258	1678	14400545819000	13920	7137	1	0	0
113542	1726	672036238000	13920	7137	3	0	6212
281264	1874	2359000	13920	7137	7	0	1
113548	1726	672030226000	13920	7137	9	0	6218
37769	1683	315796319149541	13920	7137	12	0	1
281274	1874	2370000	13922	7138	2	0	1
113557	1726	672026219000	13922	7138	3	0	6222
55662	1746	5554323000000	13922	7138	5	0	2
113571	1397	1361452279000	13927	7139	0	0	7738
113578	1397	1361442278000	13930	7140	0	0	7739
281298	1874	2376000	13930	7140	2	0	1
113584	1397	1361432277000	13932	7141	0	0	7740
281304	1678	14400545825000	13932	7141	2	0	0
113590	1726	672017198000	13932	7141	6	0	6231
281310	1874	2396000	13932	7141	8	0	1
113599	1397	1361402274000	13935	7142	0	0	7743
281319	1874	2404000	13935	7142	2	0	1
17371	1508	10836241500009	13935	7142	4	0	6
113611	1726	672008180000	13940	7143	2	0	6240
281338	1678	14400545828000	13942	7144	0	0	0
113628	1397	1361372271000	13944	7145	0	0	7746
281348	1874	2419000	13944	7145	2	0	1
26029	1613	7127799600000	13944	7145	4	0	6
113633	1726	672001168000	13945	7146	1	0	6247
281353	1874	2426000	13945	7146	3	0	1
47557	1695	6812151000000	13945	7146	5	0	5
113644	1726	671996158000	13948	7147	3	0	6252
281364	1874	2434000	13949	7148	1	0	1
113655	1726	671992150000	13953	7150	0	0	6256
281375	1874	2444000	13953	7150	2	0	1
28520	1637	165604659819997	13953	7150	3	0	0
113660	1726	671988141000	13954	7151	2	0	6260
281380	1874	2452000	13954	7151	4	0	1
22038	1571	16560301001024	13954	7151	7	0	1
113666	1397	1361302264000	13955	7152	1	0	7753
281385	1874	2458000	13955	7152	2	0	1
281386	1874	2461000	13955	7152	3	0	1
113676	1397	1361292263000	13957	7153	0	0	7754
281408	1678	14400545839000	13960	7154	1	0	0
113693	1726	671976117000	13960	7154	4	0	6272
281414	1874	2479000	13960	7154	7	0	1
113697	1726	671972110000	13960	7154	8	0	6276
113698	1726	671971108000	13960	7154	9	0	6277
23519	1594	10705120000000	13960	7154	11	0	5
46914	1693	15753587155041	13961	7155	0	0	667
281419	1950	5499852000000	13962	7156	1	0	13
113704	1397	1361232257000	13962	7156	4	0	7760
281425	1678	14400545846000	13962	7156	7	0	0
113710	1726	671967099000	13962	7156	10	0	6281
281431	1874	2497000	13962	7156	13	0	1
113715	1726	671962090000	13962	7156	15	0	6286
281436	1874	2506000	13962	7156	18	0	1
113721	1726	671956078000	13962	7156	21	0	6292
281442	1874	2518000	13962	7156	24	0	1
113727	1726	671950066000	13962	7156	27	0	6298
58743	1991	7675784441475	13962	7156	30	0	12
281474	1874	2528000	13965	7157	1	0	1
113758	1726	671946057000	13965	7157	3	0	6302
281496	1678	14400545849000	13970	7159	1	0	0
113781	1726	671944054000	13970	7159	4	0	6304
281502	1874	2542000	13970	7159	7	0	1
113787	1726	671938042000	13970	7159	10	0	6310
281511	1678	15120584852000	13972	7160	1	0	0
113795	1726	671935036000	13972	7160	3	0	6313
281516	1874	2560000	13972	7160	6	0	1
281528	1678	15120584853000	13975	7161	0	0	0
113811	1726	671930025000	13975	7161	1	0	6318
281529	1874	2565000	13975	7161	1	0	1
113834	1397	1361122246000	13979	7162	0	0	7771
113835	1397	1361112245000	13979	7162	1	0	7772
281555	1874	2571000	13979	7162	3	0	1
113857	1726	671925015000	13981	7163	3	0	6323
281577	1874	2578000	13981	7163	5	0	1
113863	1726	671919003000	13981	7163	9	0	6329
281582	1874	2589000	13981	7163	10	0	1
113868	1726	671913994000	13981	7163	14	0	6334
281599	1678	15120584859000	13983	7164	0	0	0
4812	641	71379824000000	13983	7164	4	0	12
113888	1397	1361062240000	13985	7165	0	0	7777
281608	1874	2608000	13985	7165	2	0	1
836	58	78186377999659	13985	7165	6	0	7
113894	1397	1361052239000	13986	7166	0	0	7778
281613	1874	2617000	13986	7166	1	0	1
41089	1687	6472554524804	13986	7166	4	0	5
113903	1726	671900967000	13988	7167	1	0	6347
281623	1874	2626000	13988	7167	3	0	1
32125	1672	11521880000000	13988	7167	5	0	5
113909	1726	671897961000	13989	7168	3	0	6350
281629	1874	2632000	13989	7168	5	0	1
113927	1397	1361002234000	13994	7170	0	0	7783
281646	1874	2638000	13994	7170	1	0	1
113932	1726	671889946000	13994	7170	5	0	6358
281652	1874	2649000	13994	7170	7	0	1
281658	1678	15120584867000	13996	7171	0	0	0
281659	1678	15120584868000	13996	7171	1	0	0
113943	1925	1198000000	13996	7171	3	0	2
281665	1874	2658000	13996	7171	7	0	1
37784	1683	318676372149541	13996	7171	10	0	1
113962	1397	1360972231000	13999	7172	0	0	7786
113969	1397	1360952229000	14001	7173	1	0	7788
113970	1397	1360942228000	14001	7173	2	0	7789
281689	1874	2663000	14001	7173	3	0	1
113976	1726	671877920000	14001	7173	8	0	6370
281694	1874	2670000	14001	7173	8	0	1
113982	1726	671871908000	14001	7173	14	0	6376
281700	1874	2682000	14001	7173	14	0	1
113987	1775	861300000	14004	7176	0	0	16
281706	1678	15120584876000	14004	7176	2	0	0
113993	1726	671866897000	14004	7176	6	0	6381
281711	1874	2694000	14004	7176	7	0	1
113999	1726	671860885000	14004	7176	12	0	6387
281717	1874	2706000	14004	7176	13	0	1
114017	1397	1360872221000	14006	7177	3	0	7796
43026	1688	86762119904000	14006	7177	4	0	18
281736	1874	2708000	14007	7178	1	0	1
114023	1726	671854873000	14007	7178	5	0	6393
281741	1874	2718000	14007	7178	6	0	1
114029	1726	671848861000	14007	7178	11	0	6399
281747	1874	2730000	14007	7178	12	0	1
18099	1513	23040756000000	14007	7178	14	0	0
114039	1726	671846858000	14010	7180	1	0	6401
281758	1874	2736000	14010	7180	3	0	1
23062	1593	7749854000000	14010	7180	7	0	4
114045	1924	1197000000	14011	7181	1	0	3
281763	1874	2743000	14011	7181	2	0	1
1258	149	78510162000341	14011	7181	6	0	5
114051	1726	671839843000	14012	7182	2	0	6408
281769	1874	2749000	14012	7182	3	0	1
114068	1726	671836837000	14016	7183	2	0	6411
281787	1874	2758000	14016	7183	4	0	1
281805	1678	15120584887000	14020	7185	0	0	0
281806	1678	15120584888000	14020	7185	1	0	0
114091	1924	1196000000	14020	7185	2	0	4
281812	1874	2770000	14020	7185	7	0	1
114097	1726	671828819000	14020	7185	8	0	6419
59780	2097	200000001	14020	7185	11	1	0
114152	1397	1360772211000	14027	7186	0	0	7806
114153	1726	671826814000	14027	7186	1	0	6421
281871	1874	2780000	14027	7186	3	0	1
28525	1637	167044682819997	14028	7187	2	0	0
114160	1726	671823808000	14030	7188	1	0	6424
281877	1874	2783000	14030	7188	2	0	1
322	43	74640728890000	14030	7188	6	0	1
10345	1402	37294159319298	14035	7189	1	0	33
114184	1397	1360732207000	14039	7190	0	0	7810
281901	1678	15120584894000	14039	7190	1	0	0
114189	1726	671815789000	14039	7190	5	0	6432
281907	1874	2804000	14039	7190	7	0	1
45894	1692	58342536019999	14039	7190	9	0	4
114203	1726	671811782000	14041	7191	3	0	6436
281920	1874	2810000	14041	7191	4	0	1
281932	1678	15120584897000	14043	7192	0	0	0
114217	1397	1360682202000	14043	7192	1	0	7815
281933	1678	15120584898000	14043	7192	1	0	0
17122	1506	7201086967172	14043	7192	2	0	17
114230	1726	671804768000	14045	7193	4	0	6443
281946	1874	2826000	14045	7193	6	0	1
114236	1726	671798756000	14045	7193	10	0	6449
47143	1694	9372463127629	14045	7193	12	0	34
114282	1397	1360662200000	14051	7194	0	0	7817
114283	1925	1194000000	14051	7194	1	0	6
281992	1745	1803000000	14051	7194	1	0	5
44791	1691	7883053100019	14051	7194	6	0	5
282004	1678	15120584902000	14054	7195	1	0	0
114296	1726	671794747000	14054	7195	2	0	6453
282010	1874	2852000	14054	7195	7	0	1
16072	1474	8914463000023	14054	7195	9	0	13
114302	1397	1360632197000	14055	7196	0	0	7820
114317	1726	671785729000	14059	7197	1	0	6462
282026	1874	2861000	14059	7197	1	0	1
282031	1874	2868000	14059	7197	6	0	1
114323	1726	671780720000	14059	7197	7	0	6467
282050	1678	15120584906000	14066	7199	0	0	0
114342	1726	671776711000	14066	7199	1	0	6471
114352	1726	671772704000	14069	7200	2	0	6475
282061	1874	2886000	14069	7200	2	0	1
46932	1693	16473600155041	14069	7200	5	0	667
282082	1678	15120584908000	14073	7201	0	0	0
282083	1874	2891000	14073	7201	1	0	1
114377	1726	671769698000	14073	7201	2	0	6478
114378	1726	671768696000	14073	7201	3	0	6479
282089	1874	2898000	14077	7203	3	0	1
114384	1726	671764687000	14077	7203	5	0	6483
282095	1874	2909000	14083	7204	1	0	1
114390	1726	669341681000	14083	7204	3	0	6488
282124	2103	1400000000	14087	7205	0	0	0
114419	1397	1360532187000	14087	7205	2	0	7830
282130	1874	2921000	14087	7205	6	0	1
114425	1726	668123666000	14087	7205	8	0	6497
20063	1549	11855714000000	14094	7207	2	0	5
282172	1678	15120584916000	14097	7208	0	0	0
114467	1726	668121662000	14097	7208	2	0	6499
282177	1874	2934000	14097	7208	5	0	1
114472	1726	668116651000	14097	7208	7	0	6504
282196	1874	2943000	14102	7210	1	0	1
114491	1726	668112644000	14102	7210	3	0	6508
282205	1678	15120584919000	14104	7211	0	0	0
282206	1874	2952000	14104	7211	1	0	1
114502	1726	668107633000	14104	7211	3	0	6513
282217	1874	2963000	14107	7212	3	0	1
114535	1397	1360452179000	14113	7213	0	0	7838
114536	1397	1360442178000	14115	7214	0	0	7839
282246	1874	2967000	14115	7214	4	0	1
114542	1726	668100620000	14115	7214	6	0	6520
282251	1874	2976000	14115	7214	9	0	1
114548	1726	668094608000	14115	7214	12	0	6526
282257	1678	15120584925000	14116	7215	0	0	0
114553	1726	668090599000	14116	7215	2	0	6530
282263	1874	2997000	14117	7216	2	0	1
33956	1677	124489979324100	14117	7216	4	0	1
114563	1397	1360392173000	14119	7217	0	0	7844
282272	1874	3005000	14119	7217	3	0	1
49768	1703	3600625000000	14119	7217	4	0	3
114570	1726	668081581000	14121	7218	2	0	6539
282291	1874	3014000	14126	7219	1	0	1
114587	1726	668077573000	14126	7219	3	0	6543
114668	1397	1360362170000	14134	7220	0	0	7847
282374	1678	15120584930000	14134	7220	0	0	0
114669	1397	1360352169000	14134	7220	1	0	7848
282375	1678	15120584931000	14134	7220	1	0	0
114675	1726	668072562000	14134	7220	8	0	6548
282381	1874	3028000	14134	7220	8	0	1
56161	1749	3405102000000	14134	7220	12	0	14
114710	1726	668067552000	14138	7221	2	0	6553
282416	1874	3038000	14138	7221	2	0	1
114715	1726	668064547000	14139	7222	4	0	6556
282421	1874	3043000	14139	7222	4	0	1
114878	1397	1360302164000	14147	7223	0	0	7853
282583	1678	15120584936000	14147	7223	0	0	0
114879	1726	668062542000	14147	7223	1	0	6558
282584	1874	3048000	14147	7223	1	0	1
114895	1726	668059534000	14153	7225	3	0	6561
282600	1874	3056000	14153	7225	3	0	1
114901	1726	668054522000	14154	7226	1	0	6566
282606	1874	3068000	14154	7226	1	0	1
14094	1451	5658827000000	14154	7226	3	0	9
282614	1678	15120584941000	14160	7227	0	0	0
282615	1874	3073000	14160	7227	1	0	1
40023	1685	83521548571430	14160	7227	3	0	0
114915	1726	668050512000	14162	7228	0	0	6570
58759	1991	9115794441475	14162	7228	1	0	12
58760	1991	9115795441475	14162	7228	2	0	12
282624	1874	3083000	14163	7229	3	0	1
114921	1726	668046502000	14163	7229	5	0	6574
114922	1726	668045499000	14163	7229	6	0	6575
282633	1874	3096000	14165	7230	2	0	1
114934	1726	668041489000	14167	7231	2	0	6579
282641	1678	15120584947000	14168	7232	1	0	0
114940	1726	668037479000	14168	7232	5	0	6583
282647	1678	15120584949000	14170	7234	0	0	0
114945	1726	668035474000	14170	7234	3	0	6585
282653	1874	3122000	14170	7234	6	0	1
114951	1726	668029462000	14170	7234	9	0	6591
282658	1874	3130000	14171	7235	1	0	1
114961	1726	668025454000	14173	7236	1	0	6595
282668	1874	3137000	14173	7236	3	0	1
114966	1397	1360122146000	14174	7237	1	0	7871
282674	1874	3146000	14174	7237	4	0	1
114972	1726	666807438000	14174	7237	7	0	6604
3372	576	75875702938283	14174	7237	8	0	4
282719	1678	15120584956000	14185	7238	1	0	0
115018	1726	666804433000	14186	7239	3	0	6607
282725	1874	3161000	14186	7239	5	0	1
16366	1476	8640129000000	14186	7239	9	0	5
115023	1397	1360082142000	14187	7240	0	0	7875
37818	1683	324436424149541	14187	7240	1	0	1
282737	1874	3169000	14189	7241	2	0	1
33968	1677	125930017324100	14189	7241	5	0	1
282752	1678	15120584960000	14194	7242	0	0	0
115048	1726	666796416000	14194	7242	1	0	6615
282753	1874	3174000	14194	7242	1	0	1
26554	1622	13500275000014	14194	7242	5	0	5
115055	1726	666792409000	14196	7243	3	0	6619
282760	1874	3181000	14196	7243	3	0	1
115057	1726	666790404000	14196	7243	5	0	6621
115059	1397	1360032137000	14198	7244	0	0	7880
282767	1874	3192000	14198	7244	3	0	1
31478	1670	12240986000000	14198	7244	4	0	6
115065	1726	666785395000	14199	7245	2	0	6626
282772	1678	15120584966000	14200	7246	1	0	0
115071	1726	666781388000	14200	7246	5	0	6630
282778	1874	3207000	14200	7246	7	0	1
115076	1726	666778382000	14202	7248	1	0	6633
282784	1874	3213000	14202	7248	4	0	1
115082	1397	1359962130000	14203	7249	1	0	7887
37834	1683	327316464149541	14203	7249	3	0	1
282805	1874	3217000	14206	7250	1	0	1
115104	1726	666769365000	14206	7250	5	0	6642
282811	1874	3229000	14206	7250	7	0	1
53963	1723	11879354085979	14206	7250	10	0	6
115109	1726	666765357000	14207	7251	1	0	6646
282817	1678	15840599973000	14208	7252	0	0	0
115115	1726	666760346000	14208	7252	3	0	6651
282826	1874	3245000	14210	7253	1	0	1
115125	1726	666756339000	14211	7254	1	0	6655
282832	1874	3256000	14211	7254	3	0	1
115130	1726	666752331000	14212	7255	2	0	6659
13117	1444	9215050159999	14212	7255	5	0	5
282852	1874	3263000	14214	7256	1	0	1
115154	1397	1359882122000	14216	7257	0	0	7895
282861	1874	3271000	14216	7257	2	0	1
115164	1397	1359852119000	14218	7258	2	0	7898
282871	1874	3277000	14218	7258	4	0	1
115169	1726	666740307000	14218	7258	7	0	6671
282877	1874	3289000	14218	7258	10	0	1
115175	1726	666735297000	14219	7259	3	0	6676
282881	1874	3295000	14219	7259	4	0	1
282886	1874	3298000	14222	7260	0	0	1
43042	1688	88202174904000	14222	7260	3	0	18
115185	1726	666731289000	14223	7261	2	0	6680
282892	1874	3304000	14223	7261	4	0	1
28538	1637	169204726819997	14223	7261	7	0	0
115190	1726	666727282000	14224	7262	1	0	6684
115203	1397	1359802114000	14226	7263	0	0	7903
282908	1678	15840599986000	14226	7263	0	0	0
115204	1726	666724276000	14226	7263	1	0	6687
33980	1677	128090069324100	14226	7263	5	0	1
282913	1874	3320000	14227	7264	1	0	1
115210	1726	666719265000	14227	7264	3	0	6692
18105	1513	25200808000000	14227	7264	5	0	0
282919	1874	3331000	14228	7265	3	0	1
115228	1726	666715258000	14232	7266	1	0	6696
37860	1683	331636528149541	14232	7266	5	0	1
282949	1874	3338000	14236	7267	1	0	1
115245	1726	666711250000	14236	7267	2	0	6700
282969	1874	3349000	14240	7268	2	0	1
115266	1726	666705238000	14240	7268	4	0	6706
282975	1678	15840599993000	14241	7269	2	0	0
115272	1726	666702232000	14241	7269	4	0	6709
282981	1874	3367000	14241	7269	8	0	1
10377	1402	39454192319298	14241	7269	9	0	33
115277	1397	1359722106000	14242	7270	0	0	7911
32731	1675	7342040999977	14242	7270	5	0	4
282988	1678	15840599995000	14244	7271	0	0	0
115285	1726	666693214000	14244	7271	2	0	6718
4388	632	95520845000000	14244	7271	4	0	0
282994	1874	3382000	14245	7272	2	0	1
115294	1397	1359682102000	14247	7273	1	0	7915
283003	1874	3389000	14247	7273	5	0	1
115299	1726	666685199000	14247	7273	6	0	6726
18333	1518	8640368000000	14247	7273	9	0	0
283008	1874	3397000	14248	7274	2	0	1
115305	1397	1359662100000	14249	7275	0	0	7917
283014	1678	15840600001000	14250	7276	0	0	0
115311	1726	666676181000	14250	7276	2	0	6735
115344	1397	1359642098000	14255	7277	0	0	7919
283049	1678	15840600002000	14255	7277	0	0	0
115345	1397	1359632097000	14255	7277	1	0	7920
283050	1678	15840600003000	14255	7277	1	0	0
115351	1726	666671171000	14256	7278	5	0	6740
283056	1874	3419000	14256	7278	5	0	1
115357	1726	666666161000	14257	7279	1	0	6745
283062	1874	3429000	14257	7279	1	0	1
59783	2097	200000021	14257	7279	5	1	0
115362	1726	666662154000	14258	7280	2	0	6749
283067	1874	3436000	14258	7280	2	0	1
115376	1397	1359582092000	14262	7282	0	0	7925
283081	1678	15840600008000	14262	7282	0	0	0
115505	1397	1359572091000	14264	7283	0	0	7926
283210	1678	15840600009000	14264	7283	0	0	0
115506	1726	666654137000	14264	7283	1	0	6757
283211	1874	3453000	14264	7283	1	0	1
15722	1471	12859628900000	14264	7283	4	0	4
115516	1726	666651131000	14266	7284	3	0	6760
283221	1874	3459000	14266	7284	3	0	1
115522	1726	666645119000	14266	7284	9	0	6766
283227	1874	3471000	14266	7284	9	0	1
12123	1426	11084892000000	14266	7284	13	0	4
115556	1726	666641112000	14271	7285	2	0	6770
283261	1874	3478000	14271	7285	2	0	1
40030	1685	84961586571430	14271	7285	5	0	0
115562	1726	666637103000	14272	7286	4	0	6774
283267	1874	3487000	14272	7286	4	0	1
115578	1726	666632094000	14275	7287	2	0	6779
283283	1874	3496000	14275	7287	2	0	1
115583	1397	1359492083000	14276	7288	4	0	7934
283288	1678	15840600017000	14276	7288	4	0	0
283289	1678	15840600018000	14276	7288	5	0	0
283302	1678	15840600019000	14278	7289	0	0	0
115601	1726	666628085000	14278	7289	4	0	6783
115602	1726	666627083000	14278	7289	5	0	6784
283308	1874	3508000	14278	7289	6	0	1
115608	1397	1359452079000	14279	7290	1	0	7938
115738	1397	1359442078000	14283	7291	0	0	7939
283443	1678	15840600022000	14283	7291	0	0	0
115739	1397	1359432077000	14283	7291	1	0	7940
283444	1678	15840600023000	14283	7291	1	0	0
115745	1726	666617064000	14283	7291	7	0	6794
283450	1874	3526000	14283	7291	7	0	1
115751	1726	666611052000	14283	7291	13	0	6800
283456	1874	3538000	14283	7291	13	0	1
54867	1729	15407044000000	14283	7291	14	0	4
115788	1397	1359412075000	14291	7293	0	0	7942
283493	1678	15840600025000	14291	7293	0	0	0
115794	1726	666603035000	14291	7293	6	0	6808
283499	1874	3555000	14291	7293	6	0	1
45920	1692	60502586019999	14291	7293	8	0	4
37876	1683	335956563149541	14294	7294	5	0	1
115807	1726	666598024000	14296	7295	1	0	6813
283512	1874	3566000	14296	7295	1	0	1
115812	1726	666595018000	14297	7296	4	0	6816
283517	1874	3572000	14297	7296	4	0	1
32436	1673	15446264000000	14297	7296	10	0	8
115818	1726	666591010000	14298	7297	1	0	6820
283523	1874	3580000	14298	7297	1	0	1
57095	1762	12561883994000	14298	7297	4	0	4
115824	1726	666587003000	14299	7298	3	0	6824
283529	1874	3587000	14299	7298	3	0	1
34006	1677	130250110324100	14299	7298	9	0	1
115849	1397	1359332067000	14303	7299	0	0	7950
283554	1678	15840600033000	14303	7299	0	0	0
115855	1726	666578987000	14303	7299	6	0	6832
283560	1874	3603000	14303	7299	6	0	1
283561	1874	3605000	14303	7299	7	0	1
283562	1874	3608000	14303	7299	8	0	1
115986	1397	1359302064000	14305	7300	0	0	7953
115987	1397	1359292063000	14305	7300	1	0	7954
283693	1874	3615000	14305	7300	2	0	1
283697	1874	3625000	14305	7300	6	0	1
116000	1397	1359282062000	14307	7301	0	0	7955
283705	1678	15840600038000	14307	7301	0	0	0
116006	1726	666563955000	14307	7301	6	0	6847
283711	1874	3635000	14307	7301	6	0	1
40728	1686	6691882550062	14307	7301	7	0	9
116014	1397	1359262060000	14309	7302	0	0	7957
116015	1726	666562954000	14309	7302	1	0	6848
283728	1874	3642000	14311	7303	2	0	1
116031	1397	1359242058000	14314	7304	0	0	7959
283745	1678	15840600043000	14317	7305	0	0	0
116050	1397	1359222056000	14320	7306	0	0	7961
283758	1874	3659000	14320	7306	3	0	1
116059	1397	1359202054000	14322	7307	1	0	7963
283768	1874	3667000	14322	7307	5	0	1
116069	1397	1359192053000	14324	7308	0	0	7964
283777	1874	3674000	14324	7308	3	0	1
116075	1726	666541911000	14325	7309	2	0	6869
283786	1874	3683000	14327	7310	1	0	1
116083	1726	666537904000	14327	7310	3	0	6873
283792	1874	3692000	14328	7311	3	0	1
116089	1726	666533895000	14329	7312	1	0	6877
283799	1874	3698000	14331	7313	1	0	1
37891	1683	338836591149541	14331	7313	5	0	1
116101	1397	1359132047000	14333	7314	0	0	7970
283809	2108	200000000	14333	7314	3	0	0
116106	1726	665316881000	14333	7314	5	0	6885
44164	1690	97923178000000	14333	7314	9	0	0
283815	1874	3715000	14334	7315	1	0	1
116112	1726	665311870000	14334	7315	3	0	6890
283820	1874	3721000	14335	7316	2	0	1
116118	1726	665307863000	14335	7316	5	0	6894
283826	1678	15840600058000	14336	7317	0	0	0
116123	1726	665303854000	14336	7317	2	0	6898
283832	1874	3742000	14337	7318	2	0	1
283833	1874	3744000	14337	7318	3	0	1
116133	1397	1359062040000	14339	7319	0	0	7977
283838	1678	15840600060000	14339	7319	0	0	0
116139	1726	665294836000	14339	7319	6	0	6907
283844	1874	3754000	14339	7319	6	0	1
10395	1402	40894267319298	14339	7319	9	0	33
116145	1397	1359042038000	14341	7320	0	0	7979
116146	1726	665292833000	14341	7320	1	0	6909
283868	1678	15840600063000	14344	7321	0	0	0
116166	1726	665287822000	14344	7321	3	0	6914
283873	1874	3772000	14344	7321	5	0	1
22554	1587	12240426000000	14344	7321	8	0	7
116172	1726	665283815000	14345	7322	2	0	6918
283879	1874	3780000	14345	7322	4	0	1
116177	1726	665278804000	14345	7322	7	0	6923
283893	1874	3790000	14347	7323	2	0	1
116315	1397	1358992033000	14349	7324	0	0	7984
284019	1678	15840600067000	14349	7324	0	0	0
116316	1726	665274797000	14349	7324	1	0	6927
284020	1874	3793000	14349	7324	1	0	1
116322	1726	665270789000	14350	7325	4	0	6931
284026	1874	3801000	14350	7325	4	0	1
34022	1677	132410173324100	14350	7325	8	0	1
116335	1726	665265779000	14352	7326	3	0	6936
284039	1874	3811000	14352	7326	3	0	1
58598	1980	13679175000000	14352	7326	5	0	1
116344	1397	1358942028000	14355	7328	0	0	7989
284048	1678	15840600072000	14355	7328	0	0	0
35513	1679	29627937652000	14355	7328	1	0	24
116350	1726	665258765000	14356	7329	5	0	6943
284054	1874	3825000	14356	7329	5	0	1
116362	1726	665253755000	14358	7330	3	0	6948
284066	1874	3835000	14358	7330	3	0	1
116629	1397	1358912025000	14365	7331	0	0	7992
284333	1678	15840600075000	14365	7331	0	0	0
116630	1726	665252753000	14365	7331	1	0	6949
284334	1874	3837000	14365	7331	1	0	1
116648	1397	1358892023000	14371	7333	0	0	7994
284352	1678	15840600077000	14371	7333	0	0	0
116845	1397	1358882022000	14378	7336	0	0	7995
284548	1678	15840600078000	14378	7336	0	0	0
116846	1397	1358872021000	14378	7336	1	0	7996
284549	1678	15840600079000	14378	7336	1	0	0
116864	1726	664034733000	14381	7337	3	0	6958
284567	1874	3857000	14381	7337	3	0	1
116870	1726	664028718000	14381	7337	9	0	6964
284573	1874	3872000	14381	7337	9	0	1
40036	1685	87121632571430	14381	7337	12	0	0
116875	1726	664025710000	14382	7338	3	0	6967
284578	1874	3880000	14382	7338	3	0	1
116887	1397	1358802014000	14385	7340	0	0	8003
284590	1678	15840600086000	14385	7340	0	0	0
116893	1397	1358782012000	14386	7341	0	0	8005
284596	1678	15840600088000	14386	7341	0	0	0
116904	1397	1358752009000	14389	7342	2	0	8008
284607	1678	15840600091000	14389	7342	2	0	0
116910	1726	664011675000	14389	7342	8	0	6981
284613	1874	3915000	14389	7342	8	0	1
116916	1397	1358722006000	14390	7343	0	0	8011
284619	1678	15840600094000	14390	7343	0	0	0
23079	1593	9909885000000	14390	7343	4	0	4
116925	1726	664002653000	14393	7344	2	0	6990
284628	1874	3937000	14393	7344	2	0	1
116931	1726	663998643000	14395	7346	2	0	6994
284634	1874	3947000	14395	7346	2	0	1
1368	162	67440010000000	14395	7346	3	0	0
46972	1693	18633541155041	14399	7347	4	0	668
116945	1726	663994633000	14401	7348	2	0	6998
284648	1874	3957000	14401	7348	2	0	1
284653	1678	15840600100000	14403	7349	0	0	0
284654	44	66000000000000	14403	7349	1	0	3
116964	1726	663991625000	14407	7350	0	0	7001
116965	1726	663990623000	14407	7350	1	0	7002
284675	1678	15840600102000	14412	7352	0	0	0
116976	1397	1358601994000	14412	7352	4	0	8023
284681	1874	3969000	14412	7352	6	0	1
116982	1726	663984616000	14412	7352	10	0	7008
8150	1395	57868010193533700	14412	7352	11	0	0
8152	1395	57868010249533700	14412	7352	12	0	0
284686	1678	15840600107000	14413	7353	0	0	0
116987	1726	663982612000	14413	7353	4	0	7010
284704	1874	3982000	14415	7354	1	0	1
117006	1726	663977601000	14415	7354	4	0	7015
284710	1874	3997000	14415	7354	7	0	1
50897	1708	6515732000021	14415	7354	11	0	4
117012	1397	1358561990000	14416	7355	0	0	8027
284715	1874	4007000	14416	7355	2	0	1
18822	1534	1440060000000	14416	7355	3	0	0
117027	1726	663969581000	14422	7357	1	0	7023
284731	1874	4017000	14422	7357	4	0	1
45938	1692	62662621019999	14423	7358	3	0	4
117033	1397	1358521986000	14424	7359	0	0	8031
284738	1678	15840600115000	14426	7360	0	0	0
117041	1726	663960560000	14426	7360	3	0	7032
5406	1394	2880053000000	14426	7360	5	0	0
284747	1678	15840600117000	14428	7361	1	0	0
117050	1726	663957554000	14428	7361	4	0	7035
284753	1874	4042000	14428	7361	7	0	1
117099	1397	1358481982000	14431	7362	0	0	8035
284799	1678	15840600118000	14431	7362	0	0	0
117100	1397	1358471981000	14432	7363	0	0	8036
284800	1678	15840600119000	14432	7363	0	0	0
117106	1726	663949537000	14432	7363	6	0	7043
284806	1874	4053000	14432	7363	6	0	1
117117	1397	1358451979000	14434	7364	1	0	8038
284817	1678	15840600121000	14434	7364	1	0	0
41139	1687	7912693524804	14434	7364	5	0	5
117122	1726	663942524000	14435	7365	2	0	7050
284822	1874	4066000	14435	7365	2	0	1
117131	1397	1358421976000	14437	7366	0	0	8041
284831	1678	15840600124000	14437	7366	0	0	0
19766	1547	7773285000000	14437	7366	3	0	6
117137	1726	663932505000	14438	7367	3	0	7060
284837	1874	4085000	14438	7367	3	0	1
117142	1726	663929498000	14439	7368	4	0	7063
284842	1874	4092000	14439	7368	4	0	1
117152	1397	1358371971000	14442	7370	0	0	8046
284852	1678	15840600129000	14442	7370	0	0	0
51839	1711	10604534000000	14442	7370	5	0	9
117158	1726	663920481000	14443	7371	2	0	7072
284858	1874	4109000	14443	7371	2	0	1
117176	1726	663916474000	14447	7373	1	0	7076
284875	1874	4116000	14447	7373	1	0	1
117182	1726	663910462000	14448	7374	4	0	7082
284881	1874	4128000	14448	7374	4	0	1
117190	1726	663905450000	14451	7376	2	0	7087
284889	1874	4140000	14451	7376	2	0	1
21092	1560	10674237277001	14451	7376	3	0	15
117198	1726	663902444000	14454	7378	1	0	7090
284897	1874	4146000	14454	7378	1	0	1
117208	1726	663898435000	14456	7379	3	0	7094
284907	1874	4155000	14456	7379	3	0	1
117214	1726	663893426000	14457	7380	1	0	7099
284913	1874	4164000	14457	7380	1	0	1
8158	1395	57870170296533700	14457	7380	5	0	0
117219	1726	663890420000	14458	7381	2	0	7102
284918	1874	4170000	14458	7381	2	0	1
284921	1874	4176000	14458	7381	5	0	1
284922	1874	4179000	14458	7381	6	0	1
117229	1726	663885409000	14460	7382	1	0	7107
59288	2039	7921104000000	14460	7382	4	0	1
117240	1397	1358251959000	14463	7383	0	0	8058
117241	1726	663882403000	14463	7383	1	0	7110
284940	1874	4187000	14463	7383	1	0	1
52556	1715	32400548000000	14463	7383	5	0	0
117252	1726	663878396000	14466	7384	3	0	7114
284951	1874	4194000	14466	7384	3	0	1
284964	1678	15840600144000	14469	7385	0	0	0
117266	1726	663873385000	14469	7385	1	0	7119
26061	1613	9287844600000	14469	7385	4	0	6
117287	1726	663869378000	14471	7386	2	0	7123
284986	1874	4212000	14471	7386	2	0	1
43546	1689	7920158287625	14471	7386	3	0	7
117294	1397	1358181952000	14474	7388	1	0	8065
284993	1678	15840600148000	14474	7388	1	0	0
284998	1874	4224000	14474	7388	6	0	1
117300	1726	663862363000	14474	7388	7	0	7130
49239	1701	7990310600056	14474	7388	10	0	9
117305	1726	663857354000	14474	7388	13	0	7135
285004	1874	4236000	14474	7388	13	0	1
117317	1726	663853346000	14478	7389	3	0	7139
285016	1874	4244000	14478	7389	3	0	1
285029	1678	15840600153000	14480	7390	0	0	0
117331	1397	1358121946000	14480	7390	1	0	8071
117336	1726	663845329000	14480	7390	6	0	7147
285035	1874	4261000	14480	7390	6	0	1
117347	1397	1358101944000	14484	7391	0	0	8073
285046	1678	15840600156000	14484	7391	0	0	0
48259	1698	9176956550035	14485	7392	1	0	7
285066	1678	15840600158000	14489	7393	0	0	0
117369	1397	1358071941000	14489	7393	1	0	8076
285067	1678	15840600159000	14489	7393	1	0	0
117370	1397	1358061940000	14489	7393	2	0	8077
285090	1678	15840600163000	14491	7394	0	0	0
117393	1726	663834307000	14491	7394	1	0	7158
285096	1874	4292000	14491	7394	6	0	1
117399	1726	663828295000	14491	7394	7	0	7164
285101	1874	4303000	14491	7394	11	0	1
117404	1726	663823286000	14491	7394	12	0	7169
285156	1678	15840600164000	14494	7395	0	0	0
117459	1726	663818275000	14494	7395	1	0	7174
8162	1395	57870890309533700	14494	7395	5	0	0
57250	1764	7926837100000	14499	7396	2	0	8
285183	1678	15840600165000	14502	7397	0	0	0
117487	1397	1358001934000	14502	7397	1	0	8083
285188	1874	4328000	14502	7397	5	0	1
117492	1726	663810259000	14502	7397	6	0	7182
285196	1678	15840600169000	14505	7399	0	0	0
285197	1678	15840600170000	14505	7399	1	0	0
117502	1397	1357941928000	14505	7399	3	0	8089
117505	1726	663806252000	14505	7399	6	0	7186
117506	1726	663805249000	14505	7399	7	0	7187
285203	1874	4341000	14505	7399	7	0	1
117512	1726	663799237000	14505	7399	13	0	7193
285209	1874	4353000	14505	7399	13	0	1
285214	1874	4362000	14505	7399	18	0	1
117518	1397	1357931927000	14506	7400	0	0	8090
117523	1726	663790220000	14506	7400	5	0	7202
285220	1874	4370000	14506	7400	5	0	1
117529	1726	663786211000	14507	7401	3	0	7206
285226	1874	4379000	14507	7401	3	0	1
285232	1874	4386000	14510	7402	3	0	1
117536	1726	663781202000	14510	7402	4	0	7211
26576	1622	15660291000014	14510	7402	7	0	5
59125	2004	200000018	14510	7402	8	1	0
117554	1726	663778196000	14513	7403	2	0	7214
285251	1874	4394000	14513	7403	2	0	1
8163	1395	57871610309533700	14513	7403	6	0	0
117578	1397	1357851919000	14521	7405	0	0	8098
285275	1678	15840600181000	14521	7405	0	0	0
285280	1874	4412000	14521	7405	5	0	1
117584	1397	1357831917000	14522	7406	0	0	8100
5418	1394	7200091000000	14523	7407	2	0	0
117589	1397	1357811915000	14524	7408	0	0	8102
285286	1678	15840600185000	14524	7408	0	0	0
52977	1717	7307932000023	14524	7408	7	0	4
117595	1397	1357791913000	14525	7409	0	0	8104
285292	1678	15840600187000	14525	7409	0	0	0
285297	1874	4439000	14525	7409	5	0	1
117607	1397	1357771911000	14529	7410	0	0	8106
45954	1692	64822675019999	14529	7410	2	0	4
117616	1726	663756145000	14534	7412	1	0	7236
285313	1874	4445000	14534	7412	1	0	1
117624	1726	663753139000	14537	7414	3	0	7239
285321	1874	4451000	14537	7414	3	0	1
23556	1594	12865197000000	14537	7414	5	0	5
285326	1678	15840600197000	14539	7416	0	0	0
117630	1397	1357681902000	14539	7416	1	0	8115
285329	1874	4460000	14539	7416	3	0	1
285330	1874	4463000	14539	7416	4	0	1
117635	1397	1357671901000	14540	7417	0	0	8116
18552	1522	8254113000000	14540	7417	4	0	10
117650	1397	1357661900000	14543	7418	0	0	8117
117651	1397	1357651899000	14543	7418	1	0	8118
285348	1678	15840600201000	14543	7418	1	0	0
117657	1726	663740107000	14544	7419	1	0	7252
285354	1874	4483000	14544	7419	1	0	1
8171	1395	57873770366533700	14544	7419	2	0	0
285363	1678	15840600205000	14547	7421	0	0	0
117667	1397	1357601894000	14547	7421	1	0	8123
117672	1726	663735094000	14547	7421	6	0	7257
285369	1874	4496000	14547	7421	6	0	1
32153	1672	13681906000000	14547	7421	12	0	5
117710	647	66234984938283	14552	7422	0	0	1
285407	2113	99000000000	14552	7422	0	0	0
285412	1874	4513000	14552	7422	5	0	1
117716	1726	663727074000	14552	7422	6	0	7265
117727	1726	663723064000	14555	7423	1	0	7269
285424	1874	4526000	14555	7423	1	0	1
19029	1536	12240690999959	14558	7424	4	0	6
117739	1726	663720056000	14559	7425	1	0	7272
285436	1874	4534000	14559	7425	1	0	1
117872	1726	663717048000	14565	7427	0	0	7275
285569	1874	4542000	14565	7427	0	0	1
117875	1397	1357501884000	14567	7428	0	0	8133
285572	1678	15840600216000	14567	7428	0	0	0
17179	1506	8641119967172	14567	7428	6	0	17
117881	1397	1357471881000	14568	7429	0	0	8136
285578	1678	15840600219000	14568	7429	0	0	0
31763	1671	8688301530515	14568	7429	6	0	4
117909	1397	1357441878000	14574	7430	0	0	8139
285606	1678	15840600222000	14574	7430	0	0	0
285607	1874	4560000	14574	7430	1	0	1
29408	1646	720011000000	14574	7430	3	0	0
29596	1649	14684127999992	14575	7431	3	0	4
117915	1397	1357421876000	14577	7432	0	0	8141
117916	1726	663709024000	14577	7432	1	0	7283
48932	1700	8225885276737	14579	7433	1	0	6
285617	1874	4572000	14580	7434	0	0	1
17408	1508	12276268500009	14582	7435	2	0	6
117926	1726	663703007000	14585	7437	1	0	7289
40042	1685	89281670571430	14585	7437	3	0	0
285628	1874	4585000	14587	7438	1	0	1
117935	1726	663698997000	14588	7439	2	0	7293
43081	1688	91082224904000	14588	7439	3	0	18
285639	1678	15840600227000	14591	7440	0	0	0
117946	1726	663695990000	14592	7441	1	0	7296
285645	1678	15840600229000	14593	7442	0	0	0
117964	1726	663691980000	14598	7443	1	0	7300
2246	369	94080807000000	14598	7443	4	0	0
285669	1678	15840600231000	14602	7444	0	0	0
3045	506	66720012000000	14602	7444	4	0	0
117979	1726	663687970000	14604	7445	1	0	7304
285677	1874	4623000	14604	7445	2	0	1
28553	1637	171364762819988	14605	7446	4	0	0
117989	1397	1357321866000	14608	7447	0	0	8151
285688	1874	4633000	14608	7447	2	0	1
117995	1397	1357281862000	14609	7448	3	0	8155
285694	1874	4638000	14609	7448	5	0	1
118001	1726	663676942000	14609	7448	9	0	7315
285699	1874	4650000	14609	7448	10	0	1
46995	1693	20793600155041	14611	7449	2	0	668
118023	1726	663673935000	14614	7450	1	0	7318
49784	1703	4320638000000	14614	7450	3	0	3
285725	1678	15840600241000	14616	7451	0	0	0
118032	1397	1357231857000	14617	7452	1	0	8160
285731	1874	4665000	14617	7452	3	0	1
118038	1726	663665915000	14617	7452	7	0	7326
285736	1874	4678000	14617	7452	8	0	1
53995	1723	13319402085979	14617	7452	10	0	6
285737	1678	15840600245000	14618	7453	0	0	0
285738	1874	4680000	14618	7453	1	0	1
4576	633	76684016900000	14618	7453	3	0	5
118052	1397	1357201854000	14623	7454	0	0	8163
118053	1726	663661905000	14623	7454	1	0	7330
5433	1394	11520138000000	14623	7454	3	0	0
285759	1874	4690000	14626	7455	1	0	1
118065	1397	1357171851000	14627	7456	1	0	8166
285765	1874	4700000	14627	7456	4	0	1
869	58	80346436999641	14627	7456	6	0	7
118071	1726	663653885000	14628	7457	1	0	7338
285773	1678	15840600251000	14630	7458	0	0	0
14669	1457	11424280040000	14630	7458	4	0	4
118091	1397	1357141848000	14633	7459	0	0	8169
285791	1874	4715000	14633	7459	3	0	1
118097	1726	663646867000	14633	7459	6	0	7345
285803	1678	15840600255000	14637	7460	0	0	0
118109	1726	663642857000	14637	7460	3	0	7349
285808	1874	4738000	14637	7460	5	0	1
57663	1768	11390751110000	14640	7461	2	0	6
118249	1726	663637845000	14643	7462	0	0	7354
285946	1874	4745000	14643	7462	0	0	1
118250	1726	663636842000	14643	7462	1	0	7355
285947	1874	4748000	14643	7462	1	0	1
118256	1726	663632832000	14644	7463	5	0	7359
285953	1874	4758000	14644	7463	5	0	1
118262	1726	663626817000	14644	7463	11	0	7365
285959	1874	4773000	14644	7463	11	0	1
44173	1690	100083213000000	14645	7464	4	0	0
118270	1726	663623810000	14647	7465	1	0	7368
285967	1874	4780000	14647	7465	1	0	1
118397	1397	1357051839000	14649	7466	0	0	8178
286094	1678	15840600261000	14649	7466	0	0	0
118398	1397	1357041838000	14649	7466	1	0	8179
286095	1678	15840600262000	14649	7466	1	0	0
44816	1691	9323090100019	14649	7466	8	0	5
118404	1726	663617795000	14650	7467	1	0	7374
286101	1874	4795000	14650	7467	1	0	1
51260	1709	6480059999976	14659	7468	3	0	7
118441	1397	1357001834000	14662	7469	1	0	8183
286138	1678	15840600266000	14662	7469	1	0	0
286145	1678	15840600267000	14664	7470	0	0	0
118449	1726	663610778000	14664	7470	1	0	7381
286146	1874	4812000	14664	7470	1	0	1
8183	1395	57875930391533700	14664	7470	3	0	0
118455	1693	19661991475715	14665	7471	4	0	672
286152	1030	908221538475200	14665	7471	4	0	0
5443	1394	14400213000000	14665	7471	7	0	0
118457	1693	18831153617299	14666	7472	0	0	673
118458	1397	1356971831000	14666	7472	1	0	8186
286158	54	66530973005524	14666	7472	4	0	0
118464	1726	663607770000	14666	7472	7	0	7384
5444	1394	15840213000000	14666	7472	8	0	0
286163	1678	15840600270000	14667	7473	1	0	0
118470	1693	17807585211605	14667	7473	5	0	681
286169	225	66530973005524	14667	7473	7	0	0
118475	1693	16802982745492	14667	7473	10	0	686
286175	390	66530973005524	14667	7473	13	0	0
118481	1693	15682221363785	14667	7473	16	0	692
286180	391	66530973005524	14667	7473	18	0	0
118487	1726	663605764000	14667	7473	22	0	7386
286194	163	66530973005524	14669	7474	0	0	0
118500	1397	1356931827000	14669	7474	3	0	8190
286200	82	66530973005524	14669	7474	6	0	0
118515	1693	14288314376657	14671	7475	2	0	704
286214	534	66530973005524	14671	7475	4	0	0
118521	1726	663602755000	14671	7475	8	0	7389
118621	1397	1356911825000	14677	7476	0	0	8192
286318	1678	15840600275000	14677	7476	0	0	0
118622	1397	1356901824000	14677	7476	1	0	8193
286319	1678	15840600276000	14677	7476	1	0	0
118628	1693	13242884136311	14677	7476	7	0	713
286325	600	66530973005524	14677	7476	7	0	0
118634	1693	12545930642747	14677	7476	13	0	719
286331	680	66530973005524	14677	7476	13	0	0
118639	1693	11965136064777	14677	7476	18	0	724
286336	392	66530973005524	14677	7476	18	0	0
118645	1693	11616659317995	14678	7477	0	0	727
286342	691	66530973005524	14678	7477	0	0	0
118651	1693	10194863619225	14678	7477	6	0	732
286348	551	66530973005524	14678	7477	6	0	0
118656	1693	9730227956849	14678	7477	11	0	736
286353	92	66530973005524	14678	7477	11	0	0
43099	1688	92522390904000	14678	7477	18	0	18
118662	1397	1356851819000	14679	7478	1	0	8198
286359	1678	15840600281000	14679	7478	1	0	0
118668	1693	8917115547691	14679	7478	7	0	743
286365	408	66530973005524	14679	7478	7	0	0
118673	1693	8448950221219	14679	7478	12	0	748
286370	504	66530973005524	14679	7478	12	0	0
118679	1693	7751996727655	14679	7478	18	0	754
286376	395	66527943005524	14679	7478	18	0	1
118796	1693	6738720163227	14684	7479	0	0	757
286493	138	66530973005524	14684	7479	0	0	0
118797	1397	1356831817000	14684	7479	1	0	8200
286494	1678	15840600283000	14684	7479	1	0	0
118803	1749	2405105000000	14684	7479	7	0	15
286500	1950	7169852000000	14684	7479	7	0	13
118828	1693	5693289922881	14688	7480	4	0	766
286525	206	66530973005524	14688	7480	4	0	0
54599	1727	8106814000000	14688	7480	8	0	7
118839	1693	5344813176099	14690	7481	2	0	769
286536	194	66530973005524	14690	7481	2	0	0
118857	1397	1356791813000	14695	7483	0	0	8204
286554	1678	15840600287000	14695	7483	0	0	0
286555	1678	15840600288000	14695	7483	1	0	0
118865	1397	1356761810000	14698	7485	0	0	8207
118866	1726	663586707000	14698	7485	1	0	7405
286563	1874	4883000	14698	7485	1	0	1
8192	1395	57877370436533700	14703	7486	5	0	0
118950	1726	663583698000	14704	7487	1	0	7408
286647	1874	4892000	14704	7487	1	0	1
286656	1778	4450090000000	14708	7489	2	0	1
118960	1726	663581692000	14708	7489	3	0	7410
118965	1726	663579686000	14709	7490	3	0	7412
286662	1874	4904000	14709	7490	3	0	1
39160	1684	12931347880623	14709	7490	6	0	66
119135	1397	1356661800000	14714	7491	0	0	8217
286832	1678	15840600300000	14714	7491	0	0	0
119136	1397	1356651799000	14714	7491	1	0	8218
286833	1678	15840600301000	14714	7491	1	0	0
119137	1397	1356641798000	14714	7491	2	0	8219
119138	1397	1356631797000	14714	7491	3	0	8220
286839	1874	4919000	14714	7491	7	0	1
119144	1726	663572665000	14714	7491	9	0	7419
286857	1874	4931000	14718	7493	1	0	1
119162	1726	663569656000	14719	7494	1	0	7422
286862	1874	4937000	14720	7495	2	0	1
58984	1992	9359209990000	14720	7495	4	0	0
119167	1397	1356561790000	14721	7496	0	0	8227
888	58	81786493999641	14722	7497	3	0	7
286882	1678	15840600313000	14728	7498	1	0	0
119187	1726	663564641000	14728	7498	3	0	7427
23833	1596	11520517000000	14728	7498	5	0	11
286898	1678	15840600316000	14732	7500	1	0	0
119203	1397	1356481782000	14732	7500	3	0	8235
286903	1874	4961000	14732	7500	6	0	1
119216	1397	1356471781000	14736	7501	0	0	8236
286917	1874	4967000	14736	7501	4	0	1
119222	1726	663556617000	14736	7501	6	0	7435
286925	1678	15840600324000	14739	7503	0	0	0
52773	1716	10126726000000	14739	7503	3	0	4
119232	1397	1356411775000	14741	7504	0	0	8242
286932	1874	4988000	14741	7504	3	0	1
119245	1726	663550599000	14744	7505	1	0	7441
5454	1394	20160529000000	14744	7505	2	0	0
119346	1397	1356381772000	14746	7506	0	0	8245
287043	1678	15840600328000	14746	7506	0	0	0
119347	1726	663549596000	14746	7506	1	0	7442
287044	1874	4994000	14746	7506	1	0	1
119353	1726	663546587000	14748	7508	1	0	7445
287050	1874	5003000	14748	7508	1	0	1
119361	1726	663543578000	14752	7511	1	0	7448
287058	1874	5012000	14752	7511	1	0	1
4614	633	78124051900000	14752	7511	3	0	5
30439	1656	11661474999990	14753	7512	2	0	4
119368	1397	1356291763000	14756	7514	0	0	8254
287065	1678	15840600337000	14756	7514	0	0	0
119375	1726	663537560000	14760	7517	1	0	7454
287072	1874	5030000	14760	7517	1	0	1
11269	1419	15579289280064	14760	7517	3	0	3
119383	1726	663535554000	14763	7519	3	0	7456
287080	1874	5036000	14763	7519	3	0	1
119398	1726	663532545000	14766	7520	3	0	7459
287095	1874	5045000	14766	7520	3	0	1
31782	1671	10128400530515	14766	7520	6	0	4
287099	1678	15840600346000	14768	7521	0	0	0
287100	1874	5051000	14768	7521	1	0	1
48608	1699	3669735750126	14768	7521	2	0	6
119408	1726	663529536000	14770	7522	2	0	7462
119409	1726	663528533000	14770	7522	3	0	7463
31093	1668	12206633000000	14770	7522	4	0	5
119410	1397	1356171751000	14771	7523	0	0	8266
287108	1874	5060000	14771	7523	1	0	1
119422	1397	1356131747000	14778	7525	2	0	8270
287120	1874	5066000	14778	7525	3	0	1
4848	641	72819880000000	14778	7525	7	0	12
56689	1759	10080702999999	14781	7526	3	0	7
119430	1397	1356111745000	14782	7527	0	0	8272
287127	1678	15840600355000	14782	7527	0	0	0
22047	1571	18000330001024	14783	7528	2	0	1
119435	1397	1356081742000	14784	7529	1	0	8275
287133	1874	5084000	14784	7529	2	0	1
25512	1610	7920246000000	14784	7529	4	0	6
119447	1726	663516497000	14788	7531	1	0	7475
287145	1678	15840600361000	14789	7532	0	0	0
119453	1726	663513488000	14790	7533	1	0	7478
287150	1874	5102000	14790	7533	1	0	1
45973	1692	66262697019999	14790	7533	2	0	4
5464	1394	24480562000000	14791	7534	2	0	0
119458	1397	1356001734000	14793	7536	0	0	8283
287156	1678	15840600367000	14793	7536	1	0	0
119464	1397	1355971731000	14795	7537	0	0	8286
287162	1874	5120000	14795	7537	1	0	1
119473	1726	663505464000	14798	7539	1	0	7486
287170	1874	5126000	14798	7539	1	0	1
119480	1726	663503458000	14801	7541	2	0	7488
287178	1874	5135000	14801	7541	3	0	1
119486	1726	663500449000	14802	7542	4	0	7491
287186	1678	15840600377000	14804	7543	0	0	0
28561	1637	173524797819988	14807	7544	3	0	0
28563	1637	173524818819988	14807	7544	4	0	0
119500	1397	1355871721000	14809	7545	0	0	8296
287197	1678	15840600379000	14809	7545	0	0	0
119507	1397	1355851719000	14812	7547	2	0	8298
287205	1678	15840600382000	14812	7547	3	0	0
119513	1726	663493428000	14812	7547	8	0	7498
18829	1534	2880094000000	14812	7547	9	0	0
287220	1678	15840600384000	14814	7548	0	0	0
5469	1394	27360616000000	14814	7548	3	0	0
46122	1693	1580228406843	14815	7549	2	0	772
119528	1726	663490419000	14816	7550	1	0	7501
287225	1874	5171000	14816	7550	1	0	1
119533	1726	663488413000	14818	7552	2	0	7503
287231	1874	5180000	14818	7552	3	0	1
287233	1874	5183000	14819	7553	1	0	1
287236	1678	15840600391000	14821	7554	0	0	0
1279	149	80670192000341	14821	7554	2	0	5
119541	1397	1355741708000	14822	7555	0	0	8309
57267	1764	9366851100000	14822	7555	2	0	8
119545	1397	1355721706000	14824	7556	1	0	8311
119546	1726	663483398000	14824	7556	2	0	7508
287243	1874	5192000	14824	7556	2	0	1
119556	1726	663480389000	14826	7557	4	0	7511
287253	1874	5201000	14826	7557	4	0	1
4395	632	96960892000000	14826	7557	7	0	0
287258	1678	15840600400000	14828	7559	1	0	0
119562	1726	663477380000	14828	7559	2	0	7514
24737	1602	8640398000000	14833	7560	2	0	5
119637	1726	663474371000	14836	7561	1	0	7517
287334	1874	5219000	14836	7561	1	0	1
12511	1439	8932390998477	14837	7562	3	0	6
119643	1397	1355591693000	14838	7563	3	0	8324
287340	1678	15840600407000	14838	7563	3	0	0
287361	1678	15840600408000	14841	7564	0	0	0
119665	1726	663468353000	14841	7564	1	0	7523
58778	1991	11275809441475	14841	7564	4	0	12
57675	1768	12110764110000	14843	7565	3	0	6
287369	1678	15840600410000	14845	7566	0	0	0
119674	1726	663466347000	14845	7566	1	0	7525
287370	1874	5243000	14845	7566	1	0	1
171	42	87598251000000	14845	7566	2	0	4
119759	1397	1355551689000	14849	7567	0	0	8328
119760	1397	1355541688000	14849	7567	1	0	8329
287460	1874	5252000	14849	7567	5	0	1
5475	1394	31680671000000	14849	7567	7	0	0
119766	1726	663462335000	14850	7568	1	0	7529
287468	1874	5261000	14853	7570	1	0	1
8201	1395	57879530491533700	14853	7570	3	0	0
119807	1397	1355481682000	14861	7571	1	0	8335
35932	1680	7209380500035	14861	7571	3	0	6
287505	1678	15840600420000	14861	7571	4	0	0
287506	1874	5264000	14861	7571	5	0	1
119812	1726	663458323000	14862	7572	1	0	7533
119821	1397	1355441678000	14864	7573	0	0	8339
287517	1678	15840600422000	14864	7573	0	0	0
119822	1726	663454311000	14864	7573	1	0	7537
287529	2115	1000000000	14870	7576	0	0	0
119834	1397	1355411675000	14870	7576	1	0	8342
287534	1874	5291000	14870	7576	5	0	1
15277	1467	3566607100039	14870	7576	8	0	4
119854	1397	1355381672000	14873	7577	0	0	8345
287560	1874	5300000	14877	7578	2	0	1
119865	1726	663446287000	14877	7578	3	0	7545
287566	1874	5309000	14878	7579	1	0	1
119871	1726	663442280000	14878	7579	2	0	7549
287571	1874	5318000	14879	7580	2	0	1
5485	1394	36000719000000	14879	7580	4	0	0
119886	1726	661019272000	14881	7581	1	0	7554
287586	2114	1400000000	14881	7581	5	0	0
119891	1726	659807267000	14881	7581	6	0	7557
287601	1760	501000000000	14883	7582	2	0	2
119906	1726	659803258000	14883	7582	3	0	7561
47598	1695	8972189000000	14883	7582	5	0	5
287606	1874	5339000	14884	7583	2	0	1
119915	1726	659798247000	14886	7584	1	0	7566
287615	1874	5351000	14886	7584	5	0	1
119920	1726	659793238000	14886	7584	6	0	7571
287621	1874	5363000	14886	7584	11	0	1
119926	1397	1355291663000	14887	7585	0	0	8354
287626	1678	15840600441000	14887	7585	4	0	0
119932	1726	659787226000	14887	7585	6	0	7577
287632	1874	5373000	14887	7585	10	0	1
119937	1726	659782215000	14887	7585	11	0	7582
287642	1678	15840600444000	14890	7587	0	0	0
119947	1726	659778208000	14890	7587	1	0	7586
287643	1874	5382000	14890	7587	1	0	1
119953	1726	659773197000	14891	7588	3	0	7591
287649	1874	5393000	14891	7588	3	0	1
119962	1397	1355201654000	14893	7589	0	0	8363
287663	1874	5400000	14893	7589	6	0	1
119968	1726	659768187000	14893	7589	7	0	7596
40057	1685	90721707571430	14893	7589	10	0	0
287684	1874	5409000	14897	7590	2	0	1
119998	1397	1355171651000	14900	7591	0	0	8366
20106	1549	14015760000000	14900	7591	3	0	5
287698	1874	5416000	14901	7592	1	0	1
54891	1729	16847159000000	14901	7592	3	0	4
120007	1397	1355151649000	14903	7593	0	0	8368
14442	1455	5073952000000	14903	7593	5	0	5
287716	1874	5423000	14906	7594	1	0	1
120021	1726	659756165000	14906	7594	2	0	7608
15026	1458	13053605908540	14906	7594	3	0	4
287721	1874	5428000	14908	7596	1	0	1
120027	1726	659752157000	14908	7596	3	0	7612
43131	1688	95402478904000	14908	7596	4	0	18
287735	1874	5439000	14911	7597	3	0	1
53485	1719	7220360000000	14911	7597	5	0	5
120044	1397	1355101644000	14913	7598	0	0	8373
287745	1678	15840600458000	14914	7599	1	0	0
120050	1397	1355071641000	14914	7599	2	0	8376
287750	1874	5443000	14914	7599	6	0	1
120056	1726	658534144000	14914	7599	8	0	7621
287756	1874	5457000	14914	7599	12	0	1
120061	1726	658529130000	14914	7599	13	0	7626
5491	1394	40320745000000	14914	7599	14	0	0
35547	1679	31787958652000	14915	7600	2	0	24
287764	1874	5469000	14917	7601	2	0	1
120075	1397	1355011635000	14920	7602	0	0	8382
287777	1678	15840600466000	14922	7603	0	0	0
287780	1678	15840600467000	14925	7604	0	0	0
120086	1726	658523114000	14925	7604	2	0	7632
44181	1690	102243235000000	14926	7605	2	0	0
120089	1397	1354971631000	14927	7606	0	0	8386
120090	1726	658521109000	14927	7606	1	0	7634
287786	1874	5481000	14927	7606	1	0	1
8214	1395	57881690526533700	14928	7607	4	0	0
120098	1397	1354931627000	14932	7609	1	0	8390
287794	1678	15840600473000	14932	7609	1	0	0
34822	1678	16560623473000	14932	7609	6	0	0
287824	1874	5496000	14939	7610	1	0	1
120135	1397	1354911625000	14943	7611	0	0	8392
120140	1397	1354871621000	14945	7613	2	0	8396
287836	1678	16560623479000	14945	7613	2	0	0
120146	1726	658510084000	14945	7613	8	0	7645
287842	1874	5506000	14945	7613	8	0	1
25932	1611	23030876000000	14945	7613	13	0	1
287849	1678	16560623482000	14947	7614	0	0	0
120154	1726	658505077000	14947	7614	1	0	7650
1494	171	74630378524688	14947	7614	3	0	4
120169	1726	658502073000	14951	7615	4	0	7653
287865	1874	5517000	14951	7615	4	0	1
120181	1726	658499068000	14957	7618	1	0	7656
287877	1874	5522000	14957	7618	1	0	1
287888	1874	5526000	14960	7619	3	0	1
120193	1726	658495063000	14960	7619	4	0	7660
120200	1397	1354741608000	14964	7622	0	0	8409
287896	1678	16560623492000	14964	7622	0	0	0
54950	1738	1438910000000	14964	7622	3	0	1
120206	1397	1354721606000	14966	7624	0	0	8411
287902	1678	16560623494000	14966	7624	0	0	0
287909	1678	16560623497000	14970	7626	1	0	0
120214	1726	658486050000	14970	7626	2	0	7669
287913	1874	5543000	14970	7626	5	0	1
26084	1613	10727901600000	14970	7626	7	0	6
287914	1678	16560623498000	14971	7627	0	0	0
120219	1726	657273045000	14971	7627	1	0	7673
120225	1726	657271042000	14974	7629	1	0	7675
120226	1726	657270041000	14974	7629	2	0	7676
287922	1874	5549000	14974	7629	2	0	1
120232	1726	657267037000	14976	7631	1	0	7679
287928	1874	5553000	14976	7631	1	0	1
287942	1874	5558000	14982	7633	1	0	1
120247	1726	657263031000	14982	7633	2	0	7683
27277	1633	7956362985638	14986	7634	1	0	8
32181	1672	15841975000000	14987	7635	3	0	5
120255	1397	1354581592000	14988	7636	0	0	8425
287951	1678	16560623508000	14988	7636	0	0	0
59948	2112	719000000000	14988	7636	3	0	0
59950	2112	719012000000	14988	7636	4	0	0
120270	1397	1354551589000	14993	7638	1	0	8428
287966	1678	16560623511000	14993	7638	1	0	0
32457	1673	17606377000000	14993	7638	6	0	8
287976	1874	5571000	14995	7639	1	0	1
120281	1726	656044018000	14995	7639	2	0	7693
28577	1637	175684854819988	14997	7640	4	0	0
120294	1397	1354511585000	15001	7642	1	0	8432
287990	1678	16560623515000	15001	7642	1	0	0
55248	1740	8441335000000	15001	7642	5	0	11
120423	1397	1354501584000	15003	7643	0	0	8433
288119	1678	16560623516000	15003	7643	0	0	0
120424	1726	656039011000	15003	7643	1	0	7698
288120	1874	5579000	15003	7643	1	0	1
48954	1700	9665931276737	15006	7644	6	0	6
120439	1397	1354471581000	15008	7645	0	0	8436
288135	1678	16560623519000	15008	7645	0	0	0
8225	1395	57883850559533700	15009	7646	2	0	0
120447	1397	1354441578000	15012	7648	0	0	8439
288143	1678	16560623522000	15012	7648	0	0	0
5508	1394	44640835000000	15014	7649	3	0	0
120455	1397	1354421576000	15015	7650	0	0	8441
288151	1678	16560623524000	15015	7650	0	0	0
351	43	76800768890000	15016	7651	1	0	1
120461	1397	1354391573000	15017	7652	0	0	8444
288157	1678	16560623527000	15017	7652	0	0	0
120475	1397	1354371571000	15022	7654	0	0	8446
288171	1678	16560623529000	15022	7654	0	0	0
56405	1756	4787788575609	15022	7654	2	0	3
120480	1397	1354331567000	15023	7655	3	0	8450
288176	1678	16560623533000	15023	7655	3	0	0
120486	1726	656015977000	15023	7655	9	0	7721
288182	1874	5613000	15023	7655	9	0	1
40063	1685	92881788571430	15023	7655	11	0	0
120497	1397	1354321566000	15025	7656	0	0	8451
288193	1678	16560623534000	15025	7656	0	0	0
120504	1397	1354311565000	15028	7657	0	0	8452
288200	1678	16560623535000	15028	7657	0	0	0
120510	1726	656011971000	15030	7659	1	0	7725
288206	1874	5619000	15030	7659	1	0	1
2252	369	96240841000000	15030	7659	3	0	0
120569	1726	656008967000	15035	7661	2	0	7728
288264	1874	5623000	15035	7661	2	0	1
120577	1726	656005963000	15040	7663	2	0	7731
288272	1874	5627000	15040	7663	2	0	1
120598	1397	1354211555000	15049	7666	0	0	8462
288293	1678	16560623545000	15049	7666	0	0	0
120678	1397	1354191553000	15055	7668	0	0	8464
288373	1678	16560623547000	15055	7668	0	0	0
120679	1726	656000954000	15055	7668	1	0	7736
288374	1874	5636000	15055	7668	1	0	1
8232	1395	57886010593533700	15056	7669	3	0	0
120694	1397	1354151549000	15061	7671	0	0	8468
288389	1678	16560623551000	15061	7671	0	0	0
59513	2086	2159037000000	15061	7671	4	0	0
120714	1397	1354111545000	15067	7673	0	0	8472
288409	1678	16560623555000	15067	7673	0	0	0
10425	1402	43054311319298	15072	7675	2	0	33
45988	1692	67702730019999	15073	7676	2	0	4
120723	1397	1354081542000	15074	7677	0	0	8475
288418	1678	16560623558000	15074	7677	0	0	0
12162	1426	13244930000000	15075	7678	2	0	4
120739	1397	1354041538000	15079	7680	1	0	8479
288434	1678	16560623562000	15079	7680	1	0	0
120745	1726	655989932000	15080	7681	2	0	7747
288440	1874	5658000	15080	7681	2	0	1
120753	1726	655987928000	15083	7683	1	0	7749
288448	1874	5662000	15083	7683	1	0	1
5517	1394	48960869000000	15083	7683	2	0	0
120762	1397	1353941528000	15089	7687	0	0	8489
288457	1678	16560623572000	15089	7687	0	0	0
288458	1678	16560623573000	15090	7688	0	0	0
25532	1610	9360290000000	15090	7688	3	0	6
18739	1526	720000000000	15093	7690	0	0	0
16397	1476	10800167000000	15094	7691	1	0	5
120770	1726	655981916000	15098	7693	0	0	7755
120773	1397	1353911525000	15100	7694	0	0	8492
288468	1678	16560623575000	15100	7694	0	0	0
5523	1394	53280890000000	15100	7694	2	0	0
120779	1397	1353871521000	15105	7697	0	0	8496
288474	1678	16560623579000	15105	7697	0	0	0
288493	2121	200000000	15108	7698	3	0	0
120799	1726	652347909000	15108	7698	4	0	7762
24022	1599	9699787393047	15108	7698	6	0	4
120810	1397	1353831517000	15111	7700	1	0	8500
288505	1678	16560623583000	15111	7700	1	0	0
120816	1397	1353811515000	15114	7702	0	0	8502
288511	1678	16560623585000	15114	7702	0	0	0
30756	1657	9361327000000	15114	7702	3	0	6
288516	1874	5694000	15116	7704	1	0	1
120822	1726	652337894000	15116	7704	2	0	7772
35580	1679	33948001652000	15116	7704	3	0	24
36297	1681	10583194759830	15118	7706	2	0	6
120831	1726	652335890000	15121	7707	1	0	7774
288526	1874	5700000	15121	7707	1	0	1
120843	1726	652333886000	15128	7710	1	0	7776
288538	1874	5704000	15128	7710	1	0	1
288543	1874	5708000	15129	7711	4	0	1
16670	1489	7823899000000	15129	7711	5	0	4
120854	1397	1353681502000	15131	7712	0	0	8515
29638	1649	16844222999992	15132	7713	3	0	4
120859	1397	1353651499000	15134	7715	0	0	8518
288554	1678	16560623601000	15134	7715	0	0	0
8241	1395	57888170645533700	15134	7715	3	0	0
120870	1397	1353611495000	15140	7718	0	0	8522
288565	1678	16560623605000	15140	7718	0	0	0
120871	1726	652326872000	15140	7718	1	0	7783
288566	1874	5718000	15140	7718	1	0	1
56715	1759	11520725999999	15140	7718	3	0	7
120872	1397	1353601494000	15141	7719	0	0	8523
288567	1678	16560623606000	15141	7719	0	0	0
47847	1696	9857295840000	15141	7719	1	0	5
47848	1696	9857305840000	15141	7719	2	0	5
120875	1397	1353591493000	15144	7720	0	0	8524
288570	1678	16560623607000	15144	7720	0	0	0
120876	1726	652325870000	15144	7720	1	0	7784
288571	1874	5720000	15144	7720	1	0	1
18594	1522	10414136000000	15144	7720	2	0	10
18595	1522	10414147000000	15144	7720	3	0	10
120905	1397	1353581492000	15147	7721	0	0	8525
288600	1678	16560623608000	15147	7721	0	0	0
120906	1397	1353571491000	15147	7721	1	0	8526
288601	1678	16560623609000	15147	7721	1	0	0
120907	1397	1353561490000	15147	7721	2	0	8527
288602	1678	16560623610000	15147	7721	2	0	0
120908	1726	652324868000	15147	7721	3	0	7785
288603	1874	5722000	15147	7721	3	0	1
120909	1726	652323867000	15147	7721	4	0	7786
288604	1874	5723000	15147	7721	4	0	1
120910	1726	651113867000	15147	7721	5	0	7787
288605	2123	200000000	15147	7721	5	0	0
120911	1726	651112865000	15147	7721	6	0	7788
288606	1874	5725000	15147	7721	6	0	1
40069	1685	94321863571430	15147	7721	8	0	0
120912	1397	1353551489000	15148	7722	0	0	8528
288607	1678	16560623611000	15148	7722	0	0	0
120913	1397	1353541488000	15148	7722	1	0	8529
288608	1678	16560623612000	15148	7722	1	0	0
120914	1397	1353531487000	15148	7722	2	0	8530
288609	1678	16560623613000	15148	7722	2	0	0
120915	1726	651111864000	15148	7722	3	0	7789
288610	1874	5726000	15148	7722	3	0	1
120916	1726	651110862000	15148	7722	4	0	7790
288611	1874	5728000	15148	7722	4	0	1
120917	1726	651109861000	15148	7722	5	0	7791
288612	1874	5729000	15148	7722	5	0	1
4399	632	97680925000000	15148	7722	7	0	0
120930	1397	1353521486000	15151	7723	0	0	8531
288625	1678	16560623614000	15151	7723	0	0	0
24324	1601	4970159600000	15153	7724	2	0	13
60177	2116	201000000	15153	7724	4	0	0
18836	1534	4320181000000	15157	7726	3	0	0
5534	1394	57600924000000	15160	7728	4	0	0
32766	1675	9502139999977	15163	7729	1	0	4
5357	1271	1344126353000000	15181	7735	7	0	0
288729	1678	16560623632000	15188	7738	0	0	0
121046	1397	1353331467000	15190	7739	0	0	8550
288740	1678	16560623633000	15190	7739	0	0	0
121047	1397	1353321466000	15190	7739	1	0	8551
121053	1726	647454823000	15190	7739	7	0	7819
288746	1874	5767000	15190	7739	7	0	1
23117	1593	12069978000000	15191	7740	3	0	4
121059	1397	1353291463000	15192	7741	0	0	8554
288752	1678	16560623637000	15192	7741	0	0	0
121067	1397	1353271461000	15195	7743	0	0	8556
288760	1678	16560623639000	15195	7743	0	0	0
121154	1726	647443807000	15200	7745	2	0	7830
288847	1874	5783000	15200	7745	2	0	1
59328	2039	10801363000000	15200	7745	4	0	1
121177	1397	1353221456000	15209	7748	0	0	8561
288870	1678	16560623644000	15209	7748	0	0	0
121178	1397	1353211455000	15209	7748	1	0	8562
288871	1678	16560623645000	15209	7748	1	0	0
15750	1471	15019664900000	15209	7748	4	0	4
43151	1688	96842514904000	15210	7749	4	0	18
121184	1397	1353191453000	15211	7750	0	0	8564
288877	1678	16560623647000	15211	7750	0	0	0
51617	1710	13914578473290	15211	7750	2	0	6
46302	1693	3740270406843	15215	7752	2	0	772
121196	1397	1353161450000	15217	7753	0	0	8567
288889	1678	16560623650000	15217	7753	0	0	0
121211	1397	1353141448000	15220	7754	0	0	8569
288904	1678	16560623652000	15220	7754	0	0	0
121222	1726	647426783000	15222	7755	1	0	7847
288915	1874	5807000	15222	7755	1	0	1
121240	1726	647423778000	15231	7758	1	0	7850
288933	1874	5812000	15231	7758	1	0	1
121253	1397	1353071441000	15236	7760	0	0	8576
288946	1678	16560623659000	15236	7760	0	0	0
121263	1397	1353041438000	15241	7763	0	0	8579
288956	1678	16560623662000	15241	7763	0	0	0
121269	1726	647413764000	15241	7763	6	0	7860
288962	1874	5826000	15241	7763	6	0	1
32473	1673	19766433000000	15241	7763	8	0	8
8257	1395	57889610689533700	15242	7764	4	0	0
121274	1726	647410760000	15243	7765	1	0	7863
288967	1874	5830000	15243	7765	1	0	1
121282	1397	1352971431000	15246	7767	0	0	8586
288975	1678	16560623669000	15246	7767	0	0	0
121295	1726	647404751000	15248	7768	4	0	7869
288988	1874	5839000	15248	7768	4	0	1
121303	1726	647400745000	15250	7769	2	0	7873
288996	1874	5845000	15250	7769	2	0	1
289003	1678	16560623675000	15253	7771	0	0	0
289004	1678	16560623676000	15253	7771	1	0	0
121313	1726	647397741000	15253	7771	3	0	7876
14466	1455	6513986000000	15253	7771	5	0	5
121322	1397	1352891423000	15256	7772	0	0	8594
289018	1678	16560623680000	15256	7772	3	0	0
121328	1726	647394737000	15256	7772	6	0	7879
289024	1874	5858000	15256	7772	10	0	1
53512	1719	9380427000000	15256	7772	11	0	5
28583	1637	177844886819988	15259	7773	3	0	0
121359	1397	1352841418000	15262	7774	0	0	8599
289054	1874	5862000	15262	7774	2	0	1
121364	1726	647386725000	15263	7775	2	0	7887
289067	1678	16560623686000	15268	7777	1	0	0
121377	1726	647383721000	15268	7777	4	0	7890
289082	1874	5871000	15271	7778	2	0	1
18111	1513	27360832000000	15271	7778	4	0	0
121392	1726	646170716000	15272	7779	1	0	7894
289087	1678	16560623690000	15273	7780	1	0	0
121397	1534	180000000	15273	7780	4	0	1
289093	1874	5879000	15273	7780	7	0	1
121411	1726	646165709000	15275	7781	2	0	7899
5552	1394	61921082000000	15275	7781	4	0	0
289115	1874	5884000	15279	7782	1	0	1
121428	1726	646161704000	15281	7783	1	0	7903
58212	1850	9998886000000	15282	7784	2	0	5
289123	1678	16560623697000	15283	7785	0	0	0
5557	1394	64801128000000	15283	7785	4	0	0
121433	1397	1352681402000	15284	7786	0	0	8615
56167	1749	3845128000000	15284	7786	3	0	15
289138	1678	16560623699000	15286	7787	0	0	0
289139	1678	16560623700000	15286	7787	1	0	0
121449	1726	646157698000	15286	7787	4	0	7907
121450	1726	646156697000	15286	7787	5	0	7908
289145	1874	5896000	15286	7787	7	0	1
52796	1716	12286804000000	15286	7787	11	0	4
121456	1726	646151690000	15287	7788	1	0	7913
289151	1678	16560623705000	15288	7789	1	0	0
121462	1397	1352601394000	15289	7790	0	0	8623
289156	1874	5906000	15289	7790	1	0	1
13150	1444	11375072159999	15290	7791	3	0	5
121467	1397	1352581392000	15291	7792	0	0	8625
289162	1874	5910000	15292	7793	1	0	1
121476	1726	646141675000	15294	7794	2	0	7923
289171	1874	5916000	15295	7795	1	0	1
14118	1451	7818873000000	15295	7795	2	0	9
13517	1447	12394512943000	15298	7796	3	0	5
121500	1397	1352521386000	15303	7798	1	0	8631
289193	1678	16560623715000	15303	7798	2	0	0
121505	1726	646135667000	15303	7798	6	0	7929
289263	1678	16560623716000	15308	7799	0	0	0
5564	1394	69121175000000	15310	7800	4	0	0
121578	1397	1352481382000	15311	7801	0	0	8635
121585	1397	1352471381000	15314	7802	0	0	8636
289277	1678	16560623719000	15314	7802	0	0	0
121586	1726	646130659000	15314	7802	1	0	7934
289278	1874	5931000	15314	7802	1	0	1
44201	1690	103683279000000	15315	7803	5	0	0
121592	1397	1352441378000	15316	7804	0	0	8639
289284	1678	16560623722000	15316	7804	0	0	0
26117	1613	12887922600000	15316	7804	3	0	6
43170	1688	99002546904000	15318	7805	3	0	18
121600	1726	646123649000	15319	7806	1	0	7941
289292	1874	5941000	15319	7806	1	0	1
121605	1726	646120645000	15320	7807	4	0	7944
289297	1874	5945000	15320	7807	4	0	1
25280	1608	12525582000000	15321	7808	3	0	4
20721	1559	8602681000000	15323	7809	2	0	4
121615	1726	646117641000	15325	7810	1	0	7947
289307	1874	5949000	15325	7810	1	0	1
10466	1402	45214398319298	15326	7811	4	0	33
121621	1726	646113635000	15327	7812	1	0	7951
289313	1874	5955000	15327	7812	1	0	1
121628	1726	646111632000	15329	7813	4	0	7953
289320	1874	5958000	15329	7813	4	0	1
23851	1596	13680551000000	15331	7814	4	0	11
121640	1397	1352301364000	15333	7815	0	0	8653
289332	1678	16560623736000	15333	7815	0	0	0
12819	1440	7919143000000	15333	7815	5	0	6
121669	1397	1352271361000	15339	7817	0	0	8656
289361	1678	16560623739000	15339	7817	0	0	0
121674	1726	646101617000	15339	7817	5	0	7963
289366	1874	5973000	15339	7817	5	0	1
16125	1474	11074498000023	15339	7817	7	0	13
121680	1726	646098613000	15340	7818	4	0	7966
289372	1874	5977000	15340	7818	4	0	1
44203	1690	104403279000000	15340	7818	7	0	0
121691	1397	1352201354000	15344	7820	0	0	8663
289383	1678	16560623746000	15344	7820	0	0	0
121702	1397	1352181352000	15349	7822	0	0	8665
289394	1678	16560623748000	15349	7822	0	0	0
121713	1397	1352151349000	15356	7825	0	0	8668
289405	1678	16560623751000	15356	7825	0	0	0
289411	1678	16560623752000	15358	7826	0	0	0
289412	1874	5996000	15358	7826	1	0	1
121721	1397	1352131347000	15360	7827	0	0	8670
121722	1726	646084593000	15360	7827	1	0	7980
289420	1874	6000000	15364	7828	3	0	1
53003	1717	9467989000023	15364	7828	6	0	4
121750	1397	1352101344000	15369	7829	0	0	8673
289446	1874	6006000	15369	7829	4	0	1
121756	1726	646077583000	15370	7830	1	0	7987
46010	1692	69862763019999	15370	7830	3	0	4
289454	1874	6010000	15372	7831	2	0	1
56177	1749	4565140000000	15372	7831	4	0	15
27582	1634	12431744641004	15373	7832	2	0	9
121797	1397	1352051339000	15378	7833	0	0	8678
289493	1874	6014000	15378	7833	4	0	1
121803	1397	1352031337000	15379	7834	0	0	8680
289499	1874	6019000	15379	7834	5	0	1
121809	1726	646068570000	15379	7834	6	0	7996
35969	1680	9369438500035	15379	7834	8	0	6
289505	1874	6023000	15381	7835	3	0	1
121816	1726	646065565000	15381	7835	4	0	7999
5577	1394	72001209000000	15383	7836	3	0	0
289511	1874	6027000	15385	7837	1	0	1
121822	1726	646062561000	15385	7837	2	0	8002
289519	1874	6033000	15391	7839	2	0	1
121830	1397	1351941328000	15392	7840	0	0	8689
8276	1395	57891770746533700	15396	7841	3	0	0
289531	1678	16560623774000	15398	7842	0	0	0
121842	1726	646056552000	15398	7842	1	0	8008
5578	1394	73441209000000	15398	7842	3	0	0
289537	1874	6042000	15400	7844	1	0	1
121848	1397	1351891323000	15401	7845	0	0	8694
24774	1602	10800455000000	15401	7845	6	0	5
289546	1678	16560623779000	15403	7846	0	0	0
121857	1726	646049542000	15403	7846	2	0	8015
289547	1874	6048000	15403	7846	2	0	1
121858	1726	646048541000	15403	7846	3	0	8016
289556	1874	6052000	15406	7848	3	0	1
121867	1726	646045537000	15406	7848	4	0	8019
289574	1874	6056000	15410	7849	3	0	1
121885	1397	1351821316000	15411	7850	0	0	8701
289583	933	505337374679600	15413	7851	2	0	0
121894	1726	646041531000	15413	7851	3	0	8023
5584	1394	76321245000000	15415	7852	4	0	0
289597	1874	6063000	15418	7853	1	0	1
121908	1726	646037525000	15418	7853	2	0	8027
289607	1678	16560623790000	15422	7855	0	0	0
121918	1726	646034521000	15422	7855	1	0	8030
289615	1678	16560623792000	15425	7857	0	0	0
121926	1726	646031516000	15425	7857	1	0	8033
28590	1637	180004931819988	15425	7857	2	0	0
49272	1701	10150336600056	15428	7858	3	0	9
289627	1874	6078000	15430	7859	2	0	1
12187	1426	15404963000000	15430	7859	3	0	4
121941	1397	1351711305000	15432	7860	0	0	8712
289636	1874	6082000	15432	7860	5	0	1
121947	1726	646024506000	15432	7860	6	0	8040
8283	1395	57893930801533700	15432	7860	8	0	0
289648	1874	6087000	15434	7861	3	0	1
121959	1726	646021502000	15434	7861	4	0	8043
43191	1688	101162616904000	15435	7862	5	0	18
289668	1678	16560623802000	15439	7863	0	0	0
121979	1397	1351631297000	15439	7863	1	0	8720
122011	1397	1351621296000	15441	7864	0	0	8721
289701	1678	16560623804000	15441	7864	0	0	0
122012	1726	646015493000	15441	7864	1	0	8049
289702	1874	6097000	15441	7864	1	0	1
12526	1439	9652413998477	15445	7865	6	0	6
122024	1397	1351591293000	15446	7866	0	0	8724
289714	1678	16560623807000	15446	7866	0	0	0
122030	1726	646009485000	15447	7867	4	0	8055
289720	1874	6105000	15447	7867	4	0	1
122038	1726	646005479000	15449	7868	2	0	8059
289728	1874	6111000	15449	7868	2	0	1
122051	1726	646002475000	15453	7870	5	0	8062
289741	1874	6115000	15453	7870	5	0	1
122075	1397	1351491283000	15460	7873	0	0	8734
289765	1678	16560623817000	15460	7873	0	0	0
122202	1397	1351481282000	15462	7874	0	0	8735
289891	1678	16560623818000	15462	7874	0	0	0
122203	1726	645997467000	15462	7874	1	0	8067
289892	1874	6123000	15462	7874	1	0	1
8290	1395	57896090846533700	15462	7874	3	0	0
122213	1397	1351451279000	15469	7876	0	0	8738
289902	1678	16560623821000	15469	7876	0	0	0
5599	1394	80641302000000	15470	7877	3	0	0
122219	1726	645990457000	15471	7878	1	0	8074
289908	1874	6133000	15471	7878	1	0	1
122232	1397	1351401274000	15477	7880	1	0	8743
289921	1678	16560623826000	15477	7880	1	0	0
26916	1623	48962519899898	15477	7880	5	0	1
122251	1726	645984449000	15481	7881	2	0	8080
289940	1874	6141000	15481	7881	2	0	1
4888	641	74979947000000	15481	7881	5	0	12
122257	1726	645980443000	15483	7883	1	0	8084
289946	1874	6147000	15483	7883	1	0	1
122267	1397	1351341268000	15489	7885	0	0	8749
289956	1678	16560623832000	15489	7885	0	0	0
122272	1397	1351331267000	15494	7886	0	0	8750
289961	1678	16560623833000	15494	7886	0	0	0
122278	1397	1351311265000	15495	7887	0	0	8752
289967	1678	16560623835000	15495	7887	0	0	0
122299	1397	1351281262000	15500	7888	0	0	8755
289988	1678	16560623838000	15500	7888	0	0	0
122304	1726	645967424000	15501	7889	2	0	8097
289993	1874	6166000	15501	7889	2	0	1
122313	1726	645965421000	15504	7891	4	0	8099
290002	1874	6169000	15504	7891	4	0	1
122325	1726	645960414000	15511	7893	0	0	8104
290014	1874	6176000	15511	7893	0	0	1
46408	1693	5180359406843	15515	7894	1	0	772
122345	1397	1351201254000	15516	7895	0	0	8763
290034	1678	16560623846000	15516	7895	0	0	0
52569	1715	34560589000002	15516	7895	4	0	0
122351	1726	645954405000	15517	7896	3	0	8110
290040	1874	6185000	15517	7896	3	0	1
8297	1395	57897530882533700	15519	7898	4	0	0
122357	1397	1351151249000	15521	7899	0	0	8768
290046	1678	16560623851000	15521	7899	0	0	0
31508	1670	13681032000000	15521	7899	5	0	6
122374	1397	1351131247000	15524	7900	1	0	8770
290063	1678	16560623853000	15524	7900	1	0	0
51877	1711	12764589000000	15524	7900	7	0	9
122380	1726	645945392000	15525	7901	1	0	8119
290069	1874	6198000	15525	7901	1	0	1
35613	1679	36108036652000	15528	7902	2	0	24
122390	1726	645943389000	15529	7903	3	0	8121
290079	1874	6201000	15529	7903	3	0	1
122401	1397	1351061240000	15531	7904	0	0	8777
290090	1678	16560623860000	15531	7904	0	0	0
122402	1726	645939384000	15531	7904	1	0	8125
290091	1874	6206000	15531	7904	1	0	1
8299	1395	57898250882533700	15531	7904	3	0	0
122416	1726	645936379000	15536	7906	4	0	8128
290105	1874	6211000	15536	7906	4	0	1
122422	1726	645932374000	15537	7907	4	0	8132
290111	1874	6216000	15537	7907	4	0	1
122427	1397	1350981232000	15539	7909	1	0	8785
290116	1678	16560623868000	15539	7909	1	0	0
122441	1397	1350961230000	15543	7911	0	0	8787
290130	1678	16560623870000	15543	7911	0	0	0
122451	1726	645922359000	15545	7912	2	0	8142
290140	1874	6231000	15545	7912	2	0	1
122456	1726	645921358000	15546	7913	4	0	8143
290145	1874	6232000	15546	7913	4	0	1
54027	1723	15479468085979	15546	7913	10	0	6
122462	1397	1350881222000	15547	7914	1	0	8795
290151	1678	16560623878000	15547	7914	1	0	0
51296	1709	8640104999976	15549	7915	3	0	7
122475	1397	1350861220000	15551	7916	0	0	8797
290164	1678	16560623880000	15551	7916	0	0	0
122480	1726	645910342000	15551	7916	6	0	8154
290169	1874	6248000	15551	7916	6	0	1
8308	1395	57899690945533706	15551	7916	10	0	0
122487	1726	645907338000	15554	7918	2	0	8157
290176	1874	6252000	15554	7918	2	0	1
122510	1726	644694333000	15558	7919	3	0	8161
290199	2118	1400000000	15558	7919	3	0	0
20418	1555	7395164979096	15558	7919	6	0	4
122644	1397	1350781212000	15561	7920	0	0	8805
290333	1678	16560623888000	15561	7920	0	0	0
122645	1397	1350771211000	15561	7920	1	0	8806
290334	1678	16560623889000	15561	7920	1	0	0
5610	1394	84961327000000	15561	7920	6	0	0
122653	1397	1350731207000	15566	7922	0	0	8810
290342	1678	16560623893000	15566	7922	0	0	0
26138	1613	14327966600000	15567	7923	3	0	6
122662	1397	1350671201000	15569	7924	2	0	8816
290351	1678	16560623899000	15569	7924	2	0	0
23596	1594	15025219000000	15569	7924	3	0	5
2564	470	76800373000000	15570	7925	1	0	6
122667	1397	1350641198000	15572	7927	1	0	8819
2263	369	98400875000000	15572	7927	2	0	0
290359	1678	16560623903000	15576	7928	0	0	0
22595	1587	15840495000000	15577	7929	1	0	7
122673	1397	1350611195000	15578	7930	0	0	8822
290361	1678	16560623905000	15578	7930	0	0	0
122674	1397	1350601194000	15578	7930	1	0	8823
290362	1678	16560623906000	15578	7930	1	0	0
122683	1397	1350551189000	15580	7931	4	0	8828
290371	1678	16560623911000	15580	7931	4	0	0
122693	1397	1350521186000	15586	7934	0	0	8831
290381	1678	16560623914000	15586	7934	0	0	0
122702	2133	98995992000	15588	7935	1	0	4
290390	1874	489000	15588	7935	1	0	2
122720	2133	98992986000	15591	7936	5	0	7
290408	1874	495000	15591	7936	5	0	2
122732	2133	98988978000	15596	7938	1	0	11
290420	1874	503000	15596	7938	1	0	2
29411	1646	1440013000000	15596	7938	3	0	0
52138	1714	10246284103056	15597	7939	3	0	7
122737	1397	1350431177000	15599	7941	0	0	8840
290425	1678	16560623923000	15599	7941	0	0	0
40759	1686	8131941550062	15599	7941	4	0	9
35626	1679	37548068652000	15604	7943	3	0	24
122749	1397	1350401174000	15605	7944	0	0	8843
290437	1678	16560623926000	15605	7944	0	0	0
122759	2133	98980962000	15608	7945	4	0	19
290447	1874	520000	15608	7945	4	0	2
5619	1394	89281409000000	15608	7945	7	0	0
122767	2133	98977956000	15610	7946	2	0	22
290455	1874	527000	15610	7946	2	0	2
48289	1698	11336989550035	15610	7946	3	0	7
47612	1695	9692203000000	15615	7948	2	0	5
122781	2133	98974950000	15616	7949	1	0	25
290469	1874	533000	15616	7949	1	0	2
17211	1506	10801185967172	15617	7950	5	0	17
122794	1397	1350301164000	15620	7951	0	0	8853
290482	1678	16560623936000	15620	7951	0	0	0
3795	606	72477748812962	15620	7951	3	0	12
122803	2133	98970942000	15622	7952	3	0	29
290491	1874	546000	15622	7952	3	0	2
13781	1448	5796723000001	15622	7952	4	0	8
122809	2133	98968938000	15623	7953	5	0	31
290497	1874	556000	15623	7953	5	0	2
122814	1397	1350261160000	15625	7954	0	0	8857
290502	1678	16560623940000	15625	7954	0	0	0
122820	2133	98966934000	15626	7955	2	0	33
290508	1874	567000	15626	7955	2	0	2
39174	1684	13651380880623	15626	7955	3	0	66
21749	1569	720846000000	15628	7956	4	0	2
122838	2134	98992979000	15633	7957	2	0	7
290526	1874	577000	15633	7957	2	0	2
40083	1685	97201898571430	15633	7957	3	0	0
122879	1397	1350211155000	15641	7959	0	0	8862
290567	1678	16560623945000	15641	7959	0	0	0
25941	1611	25190955000000	15641	7959	3	0	1
122895	2134	98988967000	15646	7961	1	0	11
290583	1874	594000	15646	7961	1	0	2
122901	2134	98986961000	15647	7962	3	0	13
290589	1874	603000	15647	7962	3	0	2
122910	2132	148991992000	15649	7963	2	0	8
290598	1874	611000	15649	7963	2	0	2
122916	2134	98983952000	15650	7964	4	0	16
290604	1874	621000	15650	7964	4	0	2
8319	1395	57901850992533706	15652	7965	4	0	0
122928	2133	98954910000	15654	7966	1	0	45
290616	1874	630000	15654	7966	1	0	2
122933	2134	98980943000	15655	7967	2	0	19
290621	1874	639000	15655	7967	2	0	2
20141	1549	16175807000000	15655	7967	4	0	5
122942	2133	98951904000	15657	7968	5	0	48
290630	1874	649000	15657	7968	5	0	2
122951	1397	1350081142000	15659	7969	0	0	8875
290639	1678	16560623958000	15659	7969	0	0	0
122952	2134	98977934000	15659	7969	1	0	22
290640	1874	653000	15659	7969	1	0	2
122958	2134	98975928000	15661	7971	1	0	24
290646	1874	663000	15661	7971	1	0	2
122964	2134	98974925000	15662	7972	3	0	25
290652	1874	671000	15662	7972	3	0	2
28596	1637	182164966819988	15662	7972	6	0	0
122969	2134	98972919000	15663	7973	2	0	27
290657	1874	681000	15663	7973	2	0	2
122993	1397	1350001134000	15668	7975	1	0	8883
290681	1678	16560623966000	15668	7975	1	0	0
123009	1397	1349981132000	15671	7976	1	0	8885
290697	1678	16560623968000	15671	7976	1	0	0
123014	2132	148986987000	15671	7976	6	0	13
290702	1874	708000	15671	7976	6	0	2
50592	1706	9572142600135	15671	7976	7	0	20
50241	1705	9275486500145	15675	7977	4	0	20
123041	2133	98938878000	15677	7978	2	0	61
290729	1874	716000	15677	7978	2	0	2
123073	2134	98963892000	15687	7980	1	0	36
290761	1874	727000	15687	7980	1	0	2
123090	1397	1349931127000	15691	7981	0	0	8890
290778	1678	16560623973000	15691	7981	0	0	0
123091	1397	1349921126000	15691	7981	1	0	8891
290779	1678	16560623974000	15691	7981	1	0	0
22151	1573	5018906000000	15691	7981	8	0	5
123097	1397	1349911125000	15693	7982	0	0	8892
290785	1678	16560623975000	15693	7982	0	0	0
123110	1397	1349891123000	15697	7984	0	0	8894
290798	1678	16560623977000	15697	7984	0	0	0
123125	1397	1349871121000	15701	7985	2	0	8896
290813	1678	16560623979000	15701	7985	2	0	0
123151	2133	98930862000	15705	7986	2	0	69
290839	1874	765000	15705	7986	2	0	2
123166	2134	98954865000	15707	7987	2	0	45
290854	1874	777000	15707	7987	2	0	2
3002	484	93360814000000	15707	7987	4	0	0
22780	1588	13174922000000	15708	7988	3	0	6
123171	1397	1349821116000	15710	7989	1	0	8901
290859	1678	16560623984000	15710	7989	1	0	0
123177	2134	98952859000	15710	7989	7	0	47
290865	1874	792000	15710	7989	7	0	2
44216	1690	106563339000000	15710	7989	10	0	0
56225	1749	6725198000000	15714	7990	4	0	15
123194	1397	1349791113000	15716	7991	0	0	8904
290882	1678	16560623987000	15716	7991	0	0	0
123333	1397	1349781112000	15719	7992	0	0	8905
291021	1678	16560623988000	15719	7992	0	0	0
123334	1397	1349771111000	15719	7992	1	0	8906
291022	1678	16560623989000	15719	7992	1	0	0
123340	2134	98947844000	15719	7992	7	0	52
291028	1874	819000	15719	7992	7	0	2
60242	2135	719000000000	15719	7992	10	0	0
123346	1397	1349741108000	15721	7994	0	0	8909
291034	1678	16560623992000	15721	7994	0	0	0
123355	1397	1349731107000	15724	7995	0	0	8910
291043	1678	16560623993000	15724	7995	0	0	0
123356	2134	98942829000	15724	7995	1	0	57
291044	1874	838000	15724	7995	1	0	2
5631	1394	93601468000000	15726	7996	4	0	0
123369	1397	1349711105000	15728	7997	0	0	8912
291057	1678	16560623995000	15728	7997	0	0	0
15316	1467	5726653100039	15729	7998	4	0	4
123378	1397	1349691103000	15731	7999	0	0	8914
291066	1678	16560623997000	15731	7999	0	0	0
123383	2134	98937814000	15731	7999	5	0	62
291071	1874	865000	15731	7999	5	0	2
123389	2132	148976977000	15732	8000	4	0	23
291077	1874	872000	15732	8000	4	0	2
123395	2133	98907816000	15733	8001	2	0	92
291083	1874	883000	15733	8001	2	0	2
123403	1397	1349621096000	15736	8003	1	0	8921
291091	1678	16560624004000	15736	8003	1	0	0
123409	2133	98904810000	15736	8003	7	0	95
291097	1874	896000	15736	8003	7	0	2
123426	2134	98929790000	15738	8004	2	0	70
291114	1874	907000	15738	8004	2	0	2
123440	2134	98927784000	15741	8005	4	0	72
291128	1874	915000	15741	8005	4	0	2
123449	1397	1349561090000	15744	8007	0	0	8927
291137	1678	16560624010000	15744	8007	0	0	0
123459	1397	1349541088000	15746	8008	2	0	8929
291147	1678	16560624012000	15746	8008	2	0	0
123499	688	66000000000000	15750	8009	0	0	1
291187	1474	11074422000023	15750	8009	0	0	14
123500	1397	1349531087000	15750	8009	1	0	8930
291188	1678	16560624013000	15750	8009	1	0	0
123506	2133	98896794000	15750	8009	7	0	103
291194	1874	945000	15750	8009	7	0	2
123512	2134	98919760000	15750	8009	13	0	80
291200	1874	960000	15750	8009	13	0	2
27306	1633	9396546985638	15750	8009	15	0	8
123517	2134	98917754000	15751	8010	4	0	82
291205	1874	967000	15751	8010	4	0	2
123537	2134	98915748000	15754	8011	3	0	84
291225	1874	977000	15754	8011	3	0	2
5639	1394	96481518000000	15754	8011	8	0	0
123551	2134	98914745000	15756	8012	2	0	85
291239	1874	985000	15756	8012	2	0	2
10495	1402	47374422319298	15756	8012	6	0	33
123559	2134	98912739000	15758	8013	1	0	87
291247	1874	995000	15758	8013	1	0	2
30154	1654	14688133999798	15758	8013	4	0	4
123569	1397	1349411075000	15761	8015	0	0	8942
291257	1678	16560624025000	15761	8015	0	0	0
123575	2134	98909730000	15761	8015	6	0	90
291263	1874	1012000	15761	8015	6	0	2
123580	2134	98908727000	15762	8016	2	0	91
291268	1874	1021000	15762	8016	2	0	2
123589	2134	98906721000	15765	8018	2	0	93
291277	1874	1030000	15765	8018	2	0	2
51914	1711	14924723000000	15765	8018	5	0	9
123602	2133	98877756000	15767	8019	4	0	122
291290	1874	1036000	15767	8019	4	0	2
123614	2134	98903712000	15769	8020	2	0	96
291302	1874	1047000	15769	8020	2	0	2
123620	1397	1349311065000	15771	8022	0	0	8952
291308	1678	16560624035000	15771	8022	0	0	0
21126	1560	12834274277001	15771	8022	3	0	15
123633	1397	1349301064000	15773	8023	0	0	8953
291321	1678	16560624036000	15773	8023	0	0	0
123634	1397	1349291063000	15773	8023	1	0	8954
291322	1678	16560624037000	15773	8023	1	0	0
123640	2134	98899700000	15773	8023	7	0	100
291328	1874	1065000	15773	8023	7	0	2
46024	1692	72022830019999	15773	8023	11	0	4
123662	1397	1349251059000	15777	8025	0	0	8958
291350	1678	16560624041000	15777	8025	0	0	0
123667	2133	98870742000	15777	8025	5	0	129
291355	1874	1086000	15777	8025	5	0	2
123677	1397	1349231057000	15781	8027	0	0	8960
291365	1678	16560624043000	15781	8027	0	0	0
8330	1395	57904011029533706	15781	8027	3	0	0
123683	2133	98865732000	15782	8028	3	0	134
291371	1874	1106000	15782	8028	3	0	2
123695	2133	98864730000	15785	8029	4	0	135
291383	1874	1114000	15785	8029	4	0	2
123701	1397	1349181052000	15787	8031	0	0	8965
291389	1678	16560624048000	15787	8031	0	0	0
123707	1397	1349161050000	15788	8032	0	0	8967
291395	1678	16560624050000	15788	8032	0	0	0
123715	1397	1349141048000	15790	8033	0	0	8969
291403	1678	16560624052000	15790	8033	0	0	0
123721	2133	98856714000	15791	8034	1	0	143
291409	1874	1150000	15791	8034	1	0	2
31821	1671	12288446530515	15791	8034	4	0	4
31134	1668	14366692000000	15793	8035	4	0	5
123731	1397	1349111045000	15794	8036	0	0	8972
291419	1678	16560624055000	15794	8036	0	0	0
123736	2134	98880643000	15794	8036	5	0	119
291424	1874	1169000	15794	8036	5	0	2
43214	1688	103322650904000	15794	8036	6	0	18
123742	1397	1349071041000	15796	8038	1	0	8976
291430	1678	16560624059000	15796	8038	1	0	0
123748	2133	98851704000	15796	8038	8	0	148
291436	1874	1181000	15796	8038	8	0	2
123753	2134	98877634000	15796	8038	13	0	122
291441	1874	1192000	15796	8038	13	0	2
123759	2133	98846694000	15797	8039	2	0	153
291447	1874	1206000	15797	8039	2	0	2
44851	1691	11483136100019	15797	8039	4	0	5
123763	1397	1349021036000	15799	8040	0	0	8981
291451	1678	16560624064000	15799	8040	0	0	0
123764	2132	148957958000	15799	8040	1	0	42
291452	1874	1207000	15799	8040	1	0	2
123770	1397	1349001034000	15801	8042	1	0	8983
291458	1678	16560624066000	15801	8042	1	0	0
123776	2134	98869610000	15802	8043	4	0	130
291464	1874	1226000	15802	8043	4	0	2
8337	1395	57906171068533706	15802	8043	5	0	0
123784	2133	98841684000	15805	8045	2	0	158
291472	1874	1230000	15805	8045	2	0	2
41240	1687	11512738524804	15806	8046	4	0	5
123803	1397	1348951029000	15809	8047	0	0	8988
291491	1678	16560624071000	15809	8047	0	0	0
23151	1593	14230001000000	15809	8047	4	0	4
123834	1688	99655639030000	15813	8048	2	0	21
291522	40	66430661911000	15813	8048	2	0	0
123839	2134	98864595000	15813	8048	7	0	135
291527	1874	1250000	15813	8048	7	0	2
123845	2134	98862589000	15813	8048	13	0	137
291533	1874	1263000	15813	8048	13	0	2
123890	1688	92111542473000	15817	8049	5	0	25
291578	785	223671268846807	15817	8049	5	0	0
123895	1688	83868926300000	15817	8049	10	0	30
291583	800	153763195008607	15817	8049	10	0	0
123897	2133	98835672000	15817	8049	12	0	164
291585	1874	1265000	15817	8049	12	0	2
123898	2133	98834670000	15817	8049	13	0	165
291586	1874	1267000	15817	8049	13	0	2
123904	1688	83449744529000	15818	8050	0	0	32
291592	802	153791643333275	15818	8050	0	0	0
123915	1397	1348861020000	15820	8051	1	0	8997
291603	1678	16560624080000	15820	8051	1	0	0
123920	2133	98831664000	15820	8051	6	0	168
291608	1874	1286000	15820	8051	6	0	2
123926	2132	148952953000	15820	8051	12	0	47
291614	1874	1300000	15820	8051	12	0	2
124008	1679	28715239930000	15825	8052	5	0	29
291696	851	2243792044281750	15825	8052	5	0	0
124013	1679	27157937909000	15825	8052	11	0	32
291701	857	329993876187608	15825	8052	11	0	0
124019	2133	98826654000	15825	8052	17	0	173
291707	1874	1312000	15825	8052	17	0	2
124084	1679	25275996603000	15830	8053	0	0	34
291772	865	400139905992417	15830	8053	0	0	0
124085	1679	19917968120000	15830	8053	1	0	35
291773	867	2436942285185000	15830	8053	1	0	0
28602	1637	184325017819988	15830	8053	5	0	0
124091	1679	13517267762000	15831	8054	2	0	38
291779	875	213608521244583	15831	8054	2	0	0
124109	1679	11731231602000	15834	8055	3	0	41
291797	883	90257121652500	15834	8055	3	0	0
5647	1394	100801597000000	15834	8055	8	0	0
124114	1679	11138944255000	15835	8056	1	0	42
291802	887	269380502712154	15835	8056	1	0	0
23621	1594	16465303000000	15835	8056	7	0	5
124120	1397	1348781012000	15836	8057	1	0	9005
291808	1678	16560624088000	15836	8057	1	0	0
124126	1679	8134741853000	15836	8057	7	0	48
291814	905	421952043725938	15836	8057	7	0	0
124131	2134	98844535000	15836	8057	12	0	155
291819	1874	1350000	15836	8057	12	0	2
124142	2133	98817636000	15839	8058	1	0	182
291830	1874	1360000	15839	8058	1	0	2
57119	1762	14721941994000	15839	8058	3	0	4
124163	1397	1348721006000	15845	8060	0	0	9011
291851	1678	16560624094000	15845	8060	0	0	0
124179	1397	1348711005000	15848	8061	0	0	9012
291867	1678	16560624095000	15848	8061	0	0	0
124180	1397	1348701004000	15848	8061	1	0	9013
291868	1678	16560624096000	15848	8061	1	0	0
124186	2132	148947948000	15848	8061	7	0	52
291874	1874	1386000	15848	8061	7	0	2
8346	1395	58031184088007706	15848	8061	10	0	0
124216	2134	98837514000	15852	8062	3	0	162
291904	1874	1395000	15852	8062	3	0	2
52168	1714	12406308103056	15852	8062	4	0	7
124225	2134	98835508000	15854	8063	4	0	164
291913	1874	1402000	15854	8063	4	0	2
124243	2133	98808618000	15859	8065	1	0	191
291931	1874	1411000	15859	8065	1	0	2
3243	568	66720000000000	15859	8065	3	0	0
124249	2133	98807616000	15860	8066	4	0	192
291937	1874	1422000	15860	8066	4	0	2
40092	1685	98641956571430	15863	8067	2	0	0
124303	2133	98805612000	15863	8067	3	0	194
291991	1874	1430000	15863	8067	3	0	2
124312	1397	1348600994000	15866	8068	0	0	9023
292000	1678	16560624106000	15866	8068	0	0	0
124313	2133	98804610000	15866	8068	1	0	195
292001	1874	1432000	15866	8068	1	0	2
26927	1623	50402587899898	15866	8068	5	0	1
124319	1397	1348580992000	15868	8070	0	0	9025
292007	1678	16560624108000	15868	8070	0	0	0
28607	1637	185765150819988	15868	8070	4	0	0
124325	1397	1348560990000	15870	8072	0	0	9027
292013	1678	16560624110000	15870	8072	0	0	0
124334	2134	98824475000	15872	8073	1	0	175
292022	1874	1460000	15872	8073	1	0	2
124344	1397	1348530987000	15875	8075	0	0	9030
292032	1678	16560624113000	15875	8075	0	0	0
124357	2134	98821466000	15881	8076	2	0	178
292045	1874	1478000	15881	8076	2	0	2
124376	2134	98819460000	15888	8077	4	0	180
292064	1874	1485000	15888	8077	4	0	2
124382	2133	98793588000	15889	8078	4	0	206
292070	1874	1491000	15889	8078	4	0	2
124396	2133	98791584000	15892	8079	1	0	208
292084	1874	1504000	15892	8079	1	0	2
124401	2134	98814445000	15893	8080	2	0	185
292089	1874	1513000	15893	8080	2	0	2
39219	1684	15811417880623	15894	8081	3	0	66
124407	1397	1348410975000	15895	8082	2	0	9042
292095	1678	16560624125000	15895	8082	2	0	0
124413	2133	98786574000	15895	8082	8	0	213
292101	1874	1533000	15895	8082	8	0	2
10513	1402	48814482319298	15896	8083	4	0	33
124424	2134	98808427000	15899	8084	1	0	191
292112	1874	1541000	15899	8084	1	0	2
32221	1672	18002031000000	15900	8085	3	0	5
124441	1397	1348370971000	15903	8086	0	0	9046
292129	1678	16560624129000	15903	8086	0	0	0
124442	1397	1348360970000	15903	8086	1	0	9047
292130	1678	16560624130000	15903	8086	1	0	0
124460	1397	1348340968000	15906	8087	1	0	9049
292148	1678	16560624132000	15906	8087	1	0	0
40102	1685	100801993571430	15906	8087	7	0	0
124474	2133	98778558000	15909	8088	1	0	221
292162	1874	1570000	15909	8088	1	0	2
47200	1694	14412475127629	15911	8089	4	0	34
124482	2133	98776554000	15912	8090	1	0	223
292170	1874	1577000	15912	8090	1	0	2
124494	1397	1348280962000	15915	8092	1	0	9055
292182	1678	16560624138000	15915	8092	1	0	0
124517	1397	1348260960000	15919	8093	1	0	9057
292205	1678	16560624140000	15919	8093	1	0	0
124522	1397	1348250959000	15920	8094	0	0	9058
292210	1678	16560624141000	15920	8094	0	0	0
52574	1715	36720626000002	15920	8094	3	0	0
124537	1397	1348230957000	15924	8096	0	0	9060
292225	1678	16560624143000	15924	8096	0	0	0
124543	1397	1348210955000	15925	8097	0	0	9062
292231	1678	16560624145000	15925	8097	0	0	0
3825	606	73917772812962	15929	8098	2	0	12
124556	1397	1348190953000	15930	8099	0	0	9064
292244	1678	16560624147000	15930	8099	0	0	0
124562	2133	98764530000	15930	8099	6	0	235
292250	1874	1643000	15930	8099	6	0	2
124580	1397	1348160950000	15934	8100	0	0	9067
292268	1678	16560624150000	15934	8100	0	0	0
124581	2133	98762526000	15934	8100	1	0	237
292269	1874	1650000	15934	8100	1	0	2
124593	2134	98784355000	15938	8102	1	0	215
292281	1874	1661000	15938	8102	1	0	2
41726	1688	30311626708000	15941	8103	4	0	36
124605	1397	1348110945000	15942	8104	1	0	9072
292293	1678	16560624155000	15942	8104	1	0	0
124610	1397	1348100944000	15943	8105	0	0	9073
292298	1678	16560624156000	15943	8105	0	0	0
16706	1489	9983955000000	15943	8105	6	0	4
124619	1397	1348080942000	15945	8106	0	0	9075
292307	1678	16560624158000	15945	8106	0	0	0
28617	1637	187925210819988	15945	8106	4	0	0
124628	1397	1348060940000	15949	8108	0	0	9077
292316	1678	16560624160000	15949	8108	0	0	0
124633	2134	98775328000	15949	8108	5	0	224
292321	1874	1708000	15949	8108	5	0	2
124645	2133	98749500000	15952	8110	2	0	250
292333	1874	1718000	15952	8110	2	0	2
12844	1440	10079167000000	15952	8110	3	0	6
124657	2134	98771316000	15956	8112	2	0	228
292345	1874	1728000	15956	8112	2	0	2
22624	1587	18000565000000	15958	8113	3	0	7
124686	1397	1347980932000	15964	8114	1	0	9085
292374	1678	16560624168000	15964	8114	1	0	0
124692	2134	98767304000	15965	8115	1	0	232
292380	1874	1746000	15965	8115	1	0	2
55091	1739	26639738000000	15966	8116	0	0	0
124710	2134	98766301000	15969	8117	4	0	233
292398	1874	1755000	15969	8117	4	0	2
124724	1397	1347940928000	15972	8118	0	0	9089
292412	1678	16560624172000	15972	8118	0	0	0
124725	2134	98764295000	15972	8118	1	0	235
292413	1874	1761000	15972	8118	1	0	2
59352	2039	12961395000000	15973	8119	4	0	1
124731	2134	98762289000	15974	8120	1	0	237
292419	1874	1771000	15974	8120	1	0	2
44227	1690	108723400000000	15974	8120	3	0	0
124742	1397	1347870921000	15977	8121	4	0	9096
292430	1678	16560624179000	15977	8121	4	0	0
124747	2134	98758277000	15977	8121	9	0	241
292435	1874	1785000	15977	8121	9	0	2
124753	2133	98733468000	15977	8121	15	0	266
292441	1874	1798000	15977	8121	15	0	2
22181	1573	7178930000000	15977	8121	16	0	5
124765	2133	98731464000	15981	8123	2	0	268
292453	1874	1808000	15981	8123	2	0	2
124770	2133	98729460000	15982	8124	4	0	270
292458	1874	1815000	15982	8124	4	0	2
1062	96	67441210000000	15983	8125	3	0	0
124779	2133	98727456000	15985	8126	1	0	272
292467	1874	1825000	15985	8126	1	0	2
43570	1689	10080192287625	15985	8126	3	0	7
124788	2133	98726454000	15987	8127	4	0	273
292476	1874	1836000	15987	8127	4	0	2
59697	2087	2879071000000	15990	8128	4	0	0
124799	1397	1347770911000	15991	8129	0	0	9106
292487	1678	16560624189000	15991	8129	0	0	0
46035	1692	74182890019999	15991	8129	3	0	4
44232	1690	110163446000000	15992	8130	4	0	0
124805	1397	1347750909000	15993	8131	0	0	9108
292493	1678	16560624191000	15993	8131	0	0	0
8366	1395	58032624149007706	15993	8131	4	0	0
5665	1394	105121669000000	15995	8132	4	0	0
124814	1397	1347730907000	15996	8133	0	0	9110
292502	1678	16560624193000	15996	8133	0	0	0
124819	2133	98718438000	15997	8134	2	0	281
292507	1874	1873000	15997	8134	2	0	2
124825	2133	98716434000	15998	8135	5	0	283
292513	1874	1877000	15998	8135	5	0	2
49817	1703	5760708000000	15998	8135	11	0	3
124841	1397	1347670901000	16000	8136	1	0	9116
292529	1678	16560624199000	16000	8136	1	0	0
124846	2134	98737214000	16000	8136	6	0	262
292534	1874	1896000	16000	8136	6	0	2
14161	1451	9978944000000	16000	8136	10	0	9
124849	1397	1347650899000	16001	8137	0	0	9118
292537	1678	16560624201000	16001	8137	0	0	0
124850	2133	98712426000	16001	8137	1	0	287
292538	1874	1902000	16001	8137	1	0	2
124859	1397	1347630897000	16004	8139	0	0	9120
292547	1678	16560624203000	16004	8139	0	0	0
124865	2133	98710422000	16004	8139	6	0	289
292553	1874	1920000	16004	8139	6	0	2
124880	2133	98707416000	16006	8140	1	0	292
292568	1874	1929000	16006	8140	1	0	2
124886	1397	1347550889000	16007	8141	4	0	9128
292574	1678	16560624211000	16007	8141	4	0	0
124892	2133	98704410000	16007	8141	10	0	295
292580	1874	1947000	16007	8141	10	0	2
124897	2134	98726181000	16007	8141	15	0	273
292585	1874	1958000	16007	8141	15	0	2
124953	2134	98724175000	16016	8143	1	0	275
292641	1874	1967000	16016	8143	1	0	2
24927	1603	1440062000000	16016	8143	4	0	0
1532	171	76070388524688	16018	8144	3	0	4
124965	2132	148933934000	16020	8145	1	0	66
292653	1874	1975000	16020	8145	1	0	2
124970	2134	98721166000	16021	8146	2	0	278
292658	1874	1985000	16021	8146	2	0	2
34980	1679	8854741853000	16021	8146	3	0	48
30488	1656	14541521999990	16022	8147	4	0	4
124976	2132	148932933000	16023	8148	3	0	67
292664	1874	1993000	16023	8148	3	0	2
59006	1992	10799275990000	16023	8148	6	0	0
124995	1397	1347470881000	16027	8149	0	0	9136
292683	1678	16560624219000	16027	8149	0	0	0
124996	1397	1347460880000	16027	8149	1	0	9137
292684	1678	16560624220000	16027	8149	1	0	0
125002	2134	98717154000	16027	8149	7	0	282
292690	1874	2008000	16027	8149	7	0	2
125011	1397	1347430877000	16030	8151	0	0	9140
292699	1678	16560624223000	16030	8151	0	0	0
125016	2132	148930931000	16031	8152	2	0	69
292704	1874	2023000	16031	8152	2	0	2
125022	2133	98687376000	16033	8153	1	0	312
292710	1874	2035000	16033	8153	1	0	2
125035	2132	148929930000	16035	8154	4	0	70
292723	1874	2044000	16035	8154	4	0	2
5671	1394	109441767000000	16035	8154	7	0	0
125044	2133	98684370000	16037	8155	2	0	315
292732	1874	2051000	16037	8155	2	0	2
11318	1419	18459333280064	16037	8155	6	0	3
125050	2134	98706121000	16038	8156	2	0	293
292738	1874	2064000	16038	8156	2	0	2
48328	1698	13497026550035	16040	8157	4	0	7
125068	2133	98680362000	16043	8158	1	0	319
292756	1874	2072000	16043	8158	1	0	2
24825	1602	12960478000000	16043	8158	3	0	5
125073	1397	1347310865000	16045	8160	0	0	9152
292761	1678	16560624235000	16045	8160	0	0	0
125083	2133	98677356000	16047	8161	2	0	322
292771	1874	2091000	16047	8161	2	0	2
49000	1700	12545956276737	16048	8162	3	0	6
125092	2134	98699100000	16050	8163	2	0	300
292780	1874	2101000	16050	8163	2	0	2
2269	369	99990897000000	16050	8163	4	0	0
125097	1397	1347260860000	16052	8165	0	0	9157
292785	1678	16560624240000	16052	8165	0	0	0
125230	1397	1347240858000	16056	8166	0	0	9159
292918	1678	16560624242000	16056	8166	0	0	0
125231	2133	98671344000	16056	8166	1	0	328
292919	1874	2119000	16056	8166	1	0	2
125237	2133	98670342000	16057	8167	3	0	329
292925	1874	2125000	16057	8167	3	0	2
19480	1546	10800811000000	16057	8167	7	0	6
125257	2134	98692079000	16061	8168	1	0	307
292945	1874	2136000	16061	8168	1	0	2
125258	2133	98668338000	16061	8168	2	0	331
292946	1874	2138000	16061	8168	2	0	2
14718	1457	13584316040000	16061	8168	5	0	4
125276	2134	98690073000	16065	8169	4	0	309
292964	1874	2147000	16065	8169	4	0	2
125292	1397	1347170851000	16069	8171	0	0	9166
292980	1678	16560624249000	16069	8171	0	0	0
125297	2134	98688067000	16069	8171	5	0	311
292985	1874	2162000	16069	8171	5	0	2
41757	1688	31031651708000	16069	8171	8	0	36
125324	2134	98686061000	16073	8172	4	0	313
293012	1874	2171000	16073	8172	4	0	2
40785	1686	10292010550062	16076	8173	3	0	9
125351	2134	98683052000	16081	8174	1	0	316
293039	1874	2182000	16081	8174	1	0	2
125361	1397	1347100844000	16085	8176	0	0	9173
293049	1678	16560624256000	16085	8176	0	0	0
5681	1394	113761817000000	16085	8176	3	0	0
125399	1397	1347080842000	16091	8178	0	0	9175
293087	1678	16560624258000	16091	8178	0	0	0
125400	1397	1347070841000	16091	8178	1	0	9176
293088	1678	16560624259000	16091	8178	1	0	0
125406	2133	98655312000	16091	8178	7	0	344
293094	1874	2201000	16091	8178	7	0	2
125412	2134	98678037000	16091	8178	13	0	321
293100	1874	2216000	16091	8178	13	0	2
125417	2133	98651304000	16091	8178	18	0	348
293105	1874	2230000	16091	8178	18	0	2
58606	1980	15119378000000	16091	8178	23	0	1
125423	2133	98649300000	16092	8179	2	0	350
293111	1874	2236000	16092	8179	2	0	2
125429	2133	98647296000	16093	8180	1	0	352
293117	1874	2247000	16093	8180	1	0	2
125440	2134	98670013000	16096	8181	3	0	329
293128	1874	2256000	16096	8181	3	0	2
125446	2133	98644290000	16097	8182	5	0	355
293134	1874	2266000	16097	8182	5	0	2
125578	1397	1346950829000	16101	8184	0	0	9188
293266	1678	16560624271000	16101	8184	0	0	0
125579	2133	98642286000	16101	8184	1	0	357
293267	1874	2273000	16101	8184	1	0	2
125591	1397	1346930827000	16105	8186	0	0	9190
293279	1678	16560624273000	16105	8186	0	0	0
125597	2134	98662992000	16105	8186	6	0	336
293285	1874	2293000	16105	8186	6	0	2
21502	1564	9186376000000	16105	8186	7	0	5
24368	1601	6410191620000	16109	8187	3	0	13
125615	2134	98660986000	16110	8188	1	0	338
293303	1874	2301000	16110	8188	1	0	2
5692	1394	118081854000000	16110	8188	3	0	0
125621	1397	1346880822000	16112	8190	0	0	9195
293309	1678	16560624278000	16112	8190	0	0	0
125627	2133	98635272000	16112	8190	6	0	364
293315	1874	2315000	16112	8190	6	0	2
125632	2133	98633268000	16112	8190	11	0	366
293320	1874	2328000	16112	8190	11	0	2
125641	2133	98630262000	16115	8192	1	0	369
293329	1874	2337000	16115	8192	1	0	2
26930	1623	51122587899898	16115	8192	3	0	1
26931	1623	51122599899898	16115	8192	4	0	1
125657	1397	1346810815000	16119	8194	0	0	9202
293345	1678	16560624285000	16119	8194	0	0	0
125662	2134	98650956000	16119	8194	5	0	348
293350	1874	2356000	16119	8194	5	0	2
125665	2134	98649953000	16120	8195	2	0	349
293353	1874	2361000	16120	8195	2	0	2
125666	2132	148911912000	16120	8195	3	0	88
293354	1874	2362000	16120	8195	3	0	2
15053	1458	14493642908540	16120	8195	5	0	4
15342	1467	7886714100039	16121	8196	4	0	4
125675	2133	98624250000	16123	8197	2	0	375
293363	1874	2372000	16123	8197	2	0	2
50926	1708	8675767000021	16123	8197	4	0	4
125688	2134	98646944000	16125	8198	5	0	352
293376	1874	2380000	16125	8198	5	0	2
46043	1692	76342939019999	16125	8198	7	0	4
125693	1397	1346730807000	16127	8200	0	0	9210
293381	1678	16560624293000	16127	8200	0	0	0
125737	2132	148909910000	16130	8201	3	0	90
293425	1874	2399000	16130	8201	3	0	2
28627	1637	190085245819988	16133	8202	3	0	0
125763	2133	98618238000	16136	8203	3	0	381
293451	1874	2407000	16136	8203	3	0	2
125780	1397	1346670801000	16140	8204	1	0	9216
293468	1678	17280636299000	16140	8204	1	0	0
125786	1397	1346650799000	16141	8205	1	0	9218
293474	1678	17280636301000	16141	8205	1	0	0
125792	2134	98635911000	16142	8206	1	0	363
293480	1874	2434000	16142	8206	1	0	2
5699	1394	120961890000000	16144	8207	4	0	0
125809	1397	1346620796000	16147	8208	0	0	9221
293497	1678	17280636304000	16147	8208	0	0	0
125810	1397	1346610795000	16147	8208	1	0	9222
293498	1678	17280636305000	16147	8208	1	0	0
125819	2134	98631899000	16149	8209	1	0	367
293507	1874	2453000	16149	8209	1	0	2
8377	1395	58034784199007706	16150	8210	5	0	0
125829	1397	1346580792000	16152	8211	0	0	9225
293517	1678	17280636308000	16152	8211	0	0	0
125865	2134	98628890000	16155	8212	2	0	370
293553	1874	2471000	16155	8212	2	0	2
35029	1679	11014801853000	16161	8213	3	0	48
125886	2134	98626884000	16162	8214	2	0	372
293574	1874	2480000	16162	8214	2	0	2
57291	1764	11526898100000	16163	8215	3	0	8
125892	2133	98602206000	16164	8216	1	0	397
293580	1874	2489000	16164	8216	1	0	2
125897	2134	98623875000	16165	8217	3	0	375
293585	1874	2498000	16165	8217	3	0	2
8387	1395	58036944236007706	16166	8218	4	0	0
125903	2134	98621869000	16167	8219	2	0	377
293591	1874	2508000	16167	8219	2	0	2
60254	2141	719000000000	16171	8220	4	0	0
60255	2141	719013000000	16171	8220	5	0	0
125927	2134	98619863000	16174	8221	1	0	379
293615	1874	2517000	16174	8221	1	0	2
126053	1397	1346470781000	16176	8222	0	0	9236
293741	1678	17280636319000	16176	8222	0	0	0
126054	2133	98597196000	16176	8222	1	0	402
293742	1874	2519000	16176	8222	1	0	2
40113	1685	102962066571430	16176	8222	3	0	0
126067	2133	98595192000	16180	8224	1	0	404
293755	1874	2529000	16180	8224	1	0	2
126105	1397	1346440778000	16185	8226	0	0	9239
293790	1678	17280636322000	16185	8226	0	0	0
126106	1397	1346430777000	16185	8226	1	0	9240
293791	1678	17280636323000	16185	8226	1	0	0
126112	2133	98591184000	16185	8226	7	0	408
293797	1874	2548000	16185	8226	8	0	2
126133	2133	98590182000	16188	8227	2	0	409
293817	1874	2559000	16188	8227	3	0	2
52814	1716	14446829000000	16188	8227	4	0	4
126144	2133	98589180000	16191	8228	3	0	410
293827	1874	2564000	16191	8228	4	0	2
126150	1684	16530434880623	16192	8229	2	0	69
293833	1874	2573000	16192	8229	3	0	2
126156	2133	98585172000	16193	8230	1	0	414
293839	1874	2583000	16193	8230	2	0	2
126161	2134	98605821000	16194	8231	2	0	393
293844	1874	2592000	16194	8231	3	0	2
126171	2132	148897898000	16196	8232	2	0	102
293854	1874	2602000	16196	8232	3	0	2
126189	2133	98581164000	16202	8234	1	0	418
293875	2142	2850002000000	16204	8235	0	0	1
126197	2134	98600806000	16204	8235	4	0	398
293880	1874	2616000	16204	8235	5	0	2
54643	1727	10267018000000	16204	8235	6	0	7
126214	1397	1346290763000	16208	8236	0	0	9254
126215	1726	138645109000	16208	8236	1	0	8171
293897	2143	200000000	16208	8236	1	0	0
293898	2144	200000000	16208	8236	2	0	0
126221	1729	18203081000000	16208	8236	7	0	5
293904	1087	904515869720300	16208	8236	8	0	0
53537	1719	10820497000000	16208	8236	12	0	5
126227	2134	98598800000	16209	8237	2	0	400
13181	1444	13535130159999	16209	8237	3	0	5
293920	1678	17280636339000	16211	8238	0	0	0
126242	2134	98596794000	16211	8238	4	0	402
293925	1874	2635000	16211	8238	5	0	2
17725	1509	11471845851155	16211	8238	8	0	5
126253	2134	98594788000	16213	8239	3	0	404
293936	1874	2645000	16213	8239	4	0	2
126266	2134	98593785000	16215	8240	3	0	405
293949	1874	2653000	16215	8240	4	0	2
4647	633	81004084900000	16215	8240	6	0	5
126271	2133	98571144000	16216	8241	2	0	428
293957	1678	17280636346000	16218	8242	0	0	0
126284	2134	98590776000	16220	8243	1	0	408
293967	1874	2671000	16220	8243	2	0	2
29819	1650	5794072000000	16220	8243	3	0	5
126290	2134	98588770000	16222	8245	2	0	410
293980	1678	17280636350000	16224	8246	0	0	0
126302	2134	98586764000	16224	8246	4	0	412
293985	2147	554000000000	16224	8246	5	0	0
126308	2134	98585761000	16225	8247	2	0	413
26299	1616	3600108410000	16225	8247	4	0	0
293991	1678	17280636353000	16226	8248	0	0	0
126314	2134	98583755000	16226	8248	5	0	415
293997	1874	2706000	16226	8248	6	0	2
126336	1397	1346100744000	16230	8250	0	0	9273
294019	1874	2714000	16230	8250	1	0	2
126345	1397	1346080742000	16233	8252	0	0	9275
126346	2133	98560122000	16233	8252	1	0	439
294028	1874	2722000	16233	8252	1	0	2
294046	1678	17280636359000	16236	8253	0	0	0
294047	1303	1702889985351650	16236	8253	1	0	0
12218	1426	17565039000000	16236	8253	4	0	4
126374	1397	1346060740000	16238	8254	0	0	9277
294058	1874	2735000	16238	8254	3	0	2
19810	1547	9933332000000	16238	8254	5	0	6
126469	2134	98576734000	16241	8255	1	0	422
294156	1874	2744000	16243	8256	1	0	2
5711	1394	125281940000000	16243	8256	4	0	0
126481	1397	1346030737000	16245	8257	0	0	9280
126482	2134	98574728000	16245	8257	1	0	424
294165	1874	2752000	16245	8257	3	0	2
294169	1874	2755000	16247	8258	1	0	2
294178	1678	17280636365000	16252	8259	0	0	0
126498	2134	98572722000	16252	8259	1	0	426
294184	1874	2766000	16253	8260	3	0	2
46572	1693	7340383406843	16253	8260	4	0	772
126504	1397	1345990733000	16254	8261	0	0	9284
59431	2041	1439339000000	16254	8261	3	0	1
126509	2133	98551104000	16255	8262	2	0	448
294190	1874	2776000	16255	8262	2	0	2
126644	1397	1345970731000	16260	8263	0	0	9286
294325	1678	17280636369000	16260	8263	0	0	0
126645	2134	98568710000	16260	8263	1	0	430
294326	1874	2779000	16260	8263	1	0	2
41824	1688	33191689708000	16260	8263	4	0	36
126656	2133	98549100000	16262	8264	4	0	450
294337	1874	2789000	16262	8264	4	0	2
126662	2133	98547096000	16263	8265	3	0	452
294343	1874	2797000	16263	8265	3	0	2
126670	2133	98545092000	16265	8266	1	0	454
294351	1874	2805000	16265	8266	1	0	2
40121	1685	105122102571430	16265	8266	3	0	0
40122	1685	105122114571430	16265	8266	4	0	0
20757	1559	10762705000000	16267	8267	0	0	4
126676	2133	98543088000	16268	8268	4	0	456
294357	1874	2815000	16268	8268	4	0	2
126682	1397	1345880722000	16270	8270	0	0	9295
294363	1678	17280636378000	16270	8270	0	0	0
126687	2133	98541084000	16270	8270	5	0	458
294368	1874	2827000	16270	8270	5	0	2
126693	2134	98557677000	16270	8270	11	0	441
294374	1874	2843000	16270	8270	12	0	2
5713	1394	126721940000000	16270	8270	13	0	0
5715	1394	126721989000000	16270	8270	14	0	0
126707	2134	98555671000	16272	8271	4	0	443
294387	1874	2852000	16272	8271	6	0	2
126720	2134	98553665000	16274	8272	1	0	445
10547	1402	50974532319298	16274	8272	4	0	33
294399	1678	17280636385000	16275	8273	0	0	0
32489	1673	21926500000000	16275	8273	3	0	8
126730	2132	148881882000	16277	8274	1	0	118
294409	1874	2870000	16277	8274	3	0	2
55953	1747	5056884000000	16277	8274	5	0	5
126756	1397	1345790713000	16285	8275	0	0	9304
126757	2134	98550656000	16285	8275	1	0	448
16438	1476	12960191000000	16285	8275	3	0	5
294443	1678	17280636388000	16290	8276	0	0	0
294444	1874	2877000	16290	8276	1	0	2
126770	2133	98531064000	16291	8277	1	0	468
57705	1768	14270798110000	16291	8277	3	0	6
294450	1874	2886000	16292	8278	2	0	2
55295	1740	10601377000000	16292	8278	5	0	11
126900	1397	1345750709000	16294	8279	0	0	9308
126901	1397	1345740708000	16294	8279	1	0	9309
294577	1874	2893000	16294	8279	3	0	2
294578	1874	2895000	16294	8279	4	0	2
27636	1634	15311810641004	16294	8279	7	0	9
126911	2133	98527056000	16296	8280	1	0	472
294588	1678	17280636394000	16297	8281	0	0	0
126923	1397	1345710705000	16300	8282	0	0	9312
294600	1678	17280636396000	16301	8283	0	0	0
126928	2132	148878879000	16301	8283	2	0	121
294605	1874	2923000	16302	8284	2	0	2
126940	2133	98523048000	16305	8285	2	0	476
127036	1397	1345670701000	16307	8286	0	0	9316
127037	2134	98539623000	16307	8286	1	0	459
294710	1874	2933000	16307	8286	2	0	2
8396	1395	58039104272007706	16307	8286	3	0	0
294739	1678	17280636400000	16312	8287	0	0	0
294740	1678	17280636401000	16312	8287	1	0	0
127071	2134	98537617000	16312	8287	4	0	461
294746	1678	17280636402000	16313	8288	0	0	0
127077	1397	1345630697000	16314	8289	0	0	9320
294752	1874	2955000	16314	8289	3	0	2
127082	1397	1345610695000	16315	8290	1	0	9322
294757	1874	2962000	16315	8290	4	0	2
127098	1397	1345600694000	16318	8291	1	0	9323
294775	1678	17280636407000	16320	8292	0	0	0
127109	2134	98531599000	16320	8292	2	0	467
294781	1874	2981000	16322	8294	1	0	2
127114	2134	98529593000	16322	8294	2	0	469
294786	1874	2990000	16323	8295	3	0	2
56433	1756	6227824575609	16323	8295	5	0	3
127120	2133	98511024000	16324	8296	1	0	488
294792	1874	3000000	16325	8297	2	0	2
28640	1637	192245269819988	16325	8297	3	0	0
127130	2132	148873874000	16327	8298	1	0	126
294802	1678	17280636415000	16328	8299	1	0	0
127135	2133	98508018000	16328	8299	2	0	491
294807	1678	17280636416000	16329	8300	1	0	0
127141	1397	1345490683000	16329	8300	2	0	9334
294813	1874	3018000	16329	8300	7	0	2
127147	2134	98522572000	16329	8300	8	0	476
127152	2134	98517557000	16329	8300	13	0	481
294819	1874	3036000	16329	8300	13	0	2
294824	1874	3046000	16329	8300	18	0	2
127158	2132	148872873000	16329	8300	19	0	127
5721	1394	131042187000000	16329	8300	22	0	0
127181	1397	1345440678000	16331	8301	0	0	9339
127182	2133	98500002000	16331	8301	1	0	499
294849	1874	3053000	16331	8301	2	0	2
294858	1678	17280636423000	16334	8302	0	0	0
127196	495	66709820000000	16335	8303	0	0	2
294864	1678	17280636425000	16335	8303	2	0	0
127202	1397	1345400674000	16336	8304	0	0	9343
294870	1874	3069000	16336	8304	2	0	2
127207	2134	98512542000	16337	8305	1	0	486
29671	1649	19004258999992	16337	8305	4	0	4
294875	1678	17280636428000	16338	8306	0	0	0
127213	1397	1345370671000	16339	8307	1	0	9346
294881	1874	3087000	16339	8307	3	0	2
5729	1394	135362409000000	16339	8307	5	1	0
127219	2133	98491986000	16340	8308	3	0	507
294887	1874	3095000	16341	8309	1	0	2
127224	2133	98489982000	16342	8310	1	0	509
294895	1678	17280636433000	16344	8311	0	0	0
127233	1397	1345320666000	16345	8312	0	0	9351
294901	1874	3114000	16345	8312	2	0	2
52830	1716	16606878000000	16347	8313	3	0	4
127248	1397	1345300664000	16350	8314	0	0	9353
294916	1874	3124000	16350	8314	2	0	2
31543	1670	15841089000000	16350	8314	4	0	6
127256	1397	1345270661000	16352	8315	2	0	9356
294924	1874	3125000	16352	8315	4	0	2
127262	2134	98500506000	16352	8315	8	0	498
294930	1874	3140000	16352	8315	10	0	2
127268	1397	1345250659000	16353	8316	0	0	9358
294936	1678	17280636443000	16353	8316	2	0	0
127273	2133	98478960000	16353	8316	5	0	520
294941	1874	3156000	16353	8316	7	0	2
127279	1397	1345210655000	16354	8317	1	0	9362
294947	1874	3166000	16354	8317	3	0	2
12856	1440	12239204000000	16354	8317	6	0	6
127285	2133	98475954000	16355	8318	1	0	523
5734	1394	139682433000000	16355	8318	3	0	0
294961	1678	17280636447000	16358	8319	0	0	0
127297	2134	98492482000	16358	8319	2	0	506
127298	2132	148863864000	16358	8319	3	0	136
294966	1678	17280636449000	16359	8320	1	0	0
127304	2133	98472948000	16359	8320	5	0	526
294976	1874	3195000	16361	8321	1	0	2
58521	1941	2157968000000	16361	8321	4	0	3
127314	2134	98488470000	16362	8322	1	0	510
40128	1685	107282150571430	16362	8322	4	0	0
294984	946	505422075000000	16364	8323	0	0	0
294985	1678	17280636452000	16364	8323	1	0	0
294986	1874	3206000	16364	8323	2	0	2
127321	2134	98487467000	16364	8323	3	0	511
295003	1678	17280636454000	16366	8324	4	0	0
127338	563	66000617000000	16366	8324	5	0	10
295009	1874	3220000	16366	8324	10	0	2
24052	1599	11140179393047	16366	8324	12	0	4
127346	2134	98484458000	16368	8325	0	0	514
295018	1874	3230000	16370	8326	2	0	2
127355	1397	1345100644000	16372	8327	0	0	9373
295026	1678	17280636458000	16373	8328	1	0	0
127361	2133	98463930000	16373	8328	2	0	535
11351	1419	20619394280064	16373	8328	5	0	3
295046	1874	3246000	16375	8329	2	0	2
127384	2134	98479443000	16375	8329	3	0	519
295051	1678	17280636461000	16376	8330	0	0	0
127389	2134	98477437000	16376	8330	1	0	521
295066	1874	3265000	16380	8331	3	0	2
127404	2133	98458920000	16380	8331	4	0	540
295075	1678	17280636465000	16383	8333	0	0	0
127413	2133	98456916000	16383	8333	1	0	542
295083	1874	3281000	16385	8334	2	0	2
127421	2134	98473425000	16385	8334	3	0	525
36015	1680	11529561500035	16386	8335	3	0	6
295092	1678	17280636469000	16388	8336	1	0	0
127430	2134	98471419000	16388	8336	2	0	527
127433	2133	98453910000	16388	8336	5	0	545
127434	2133	98452908000	16388	8336	6	0	546
295098	1678	17280636470000	16389	8337	0	0	0
127440	2133	98451906000	16389	8337	5	0	547
295103	1874	3306000	16389	8337	5	0	2
19056	1536	14400751999959	16389	8337	12	0	6
127450	1397	1344930627000	16391	8338	0	0	9390
295112	1874	3318000	16391	8338	1	0	2
30779	1657	10801364000000	16391	8338	5	0	6
127464	1397	1344910625000	16394	8339	1	0	9392
295121	1678	17280636475000	16394	8339	1	0	0
295122	1678	17280636476000	16394	8339	2	0	0
127470	2134	98465401000	16394	8339	7	0	533
295128	1874	3334000	16394	8339	8	0	2
3440	576	78755813938283	16394	8339	10	0	4
127489	1397	1344880622000	16398	8341	0	0	9395
295147	2150	200000000	16398	8341	1	0	0
127494	2134	98460386000	16398	8341	5	0	538
295152	1874	3351000	16398	8341	6	0	2
127510	1397	1344850619000	16402	8343	0	0	9398
295168	1678	17280636482000	16402	8343	1	0	0
127516	2133	98439882000	16402	8343	7	0	559
929	58	83946538999641	16402	8343	8	0	7
295174	1678	17280636483000	16403	8344	0	0	0
8405	1395	58041264332007706	16403	8344	3	0	0
127524	2133	98437878000	16405	8345	1	0	561
295182	1874	3379000	16405	8345	2	0	2
29244	1643	2016390114700	16406	8346	3	0	13
127535	2134	98453365000	16409	8347	1	0	545
295193	1874	3388000	16409	8347	2	0	2
127544	2134	98451359000	16411	8348	4	0	547
295202	1874	3398000	16411	8348	5	0	2
127561	2134	98450356000	16415	8349	3	0	548
295222	1874	3407000	16417	8350	0	0	2
46657	1693	8780410406843	16417	8350	3	0	772
127570	1397	1344760610000	16419	8351	0	0	9407
127571	1397	1344750609000	16419	8351	1	0	9408
295235	1678	17280636492000	16421	8352	0	0	0
127581	2133	98430864000	16421	8352	3	0	568
24422	1601	8570217620000	16421	8352	4	0	13
295251	1874	3422000	16424	8353	2	0	2
127597	2134	98445341000	16424	8353	5	0	553
295261	1678	17280636495000	16426	8354	0	0	0
295262	1874	3432000	16426	8354	2	0	2
5742	1394	144002469000000	16426	8354	4	0	0
127616	1397	1344700604000	16429	8355	0	0	9413
295289	1678	17280636497000	16433	8356	0	0	0
127640	2134	98442332000	16433	8356	2	0	556
127646	1397	1344660600000	16434	8357	1	0	9417
295295	1678	17280636500000	16434	8357	1	0	0
127651	1769	1693900000	16434	8357	6	0	40
295300	1874	3456000	16434	8357	7	0	2
47243	1694	16572571127629	16434	8357	13	0	34
127661	1397	1344640598000	16436	8358	0	0	9419
295309	1874	3465000	16436	8358	1	0	2
43584	1689	11520230287625	16436	8358	5	0	7
47884	1696	12737352835100	16438	8359	3	0	5
127673	1397	1344630597000	16440	8360	0	0	9420
295321	1874	3478000	16440	8360	2	0	2
127680	2133	98418840000	16442	8361	2	0	580
295328	1874	3485000	16443	8362	1	0	2
127686	2134	98433305000	16444	8363	2	0	565
5751	1394	146882507000000	16444	8363	5	0	0
295334	1678	17280636507000	16445	8364	0	0	0
127692	2134	98432302000	16445	8364	4	0	566
295340	1874	3502000	16445	8364	6	0	2
127697	2134	98430296000	16445	8364	9	0	568
127708	1397	1344560590000	16447	8365	0	0	9427
127709	2134	98429293000	16447	8365	1	0	569
295355	1874	3513000	16447	8365	1	0	2
127715	2133	98411826000	16448	8366	5	0	587
295361	1874	3523000	16448	8366	5	0	2
127728	1397	1344510585000	16451	8368	1	0	9432
295374	1678	18000647515000	16451	8368	1	0	0
127733	2132	148842843000	16451	8368	6	0	157
295379	1874	3538000	16451	8368	6	0	2
127876	1397	1344500584000	16455	8369	0	0	9433
295517	1678	18000647516000	16455	8369	0	0	0
127877	2133	98407818000	16455	8369	1	0	591
295518	1874	3542000	16455	8369	1	0	2
5757	1394	151202567000000	16455	8369	3	0	0
127886	1397	1344470581000	16458	8371	1	0	9436
295527	1678	18000647519000	16458	8371	1	0	0
295529	1874	3551000	16458	8371	3	0	2
295530	1874	3553000	16458	8371	4	0	2
127892	2134	98421269000	16458	8371	7	0	577
28648	1637	194405318819988	16458	8371	10	0	0
295536	1678	18000647521000	16459	8372	0	0	0
127897	2134	98418260000	16459	8372	2	0	580
295549	1874	3577000	16462	8373	2	0	2
127910	2133	98400804000	16463	8374	1	0	598
295556	1874	3584000	16465	8375	2	0	2
127926	2134	98415251000	16468	8376	2	0	583
44244	1690	112323473000000	16468	8376	4	0	0
295574	1874	3593000	16470	8377	1	0	2
127951	1397	1344390573000	16474	8378	0	0	9444
20172	1549	18335857000000	16474	8378	3	0	5
295592	1874	3602000	16476	8379	1	0	2
127960	2134	98412242000	16476	8379	3	0	586
295597	1874	3611000	16477	8380	2	0	2
8416	1395	58043424378007706	16477	8380	3	0	0
127969	2134	98410236000	16479	8381	2	0	588
127977	2134	98409233000	16482	8382	1	0	589
127978	2132	148837838000	16482	8382	2	0	162
295612	1874	3620000	16482	8382	2	0	2
18243	1515	720028603400	16482	8382	5	0	1
5763	1394	154082633000000	16483	8383	3	0	0
127984	1397	1344310565000	16483	8383	5	0	9452
295618	1678	18000647535000	16483	8383	5	0	0
295623	1874	3633000	16483	8383	10	0	2
127990	2134	98406224000	16483	8383	11	0	592
128007	2134	98404218000	16488	8384	1	0	594
295641	1874	3646000	16488	8384	1	0	2
128013	2134	98402212000	16490	8386	1	0	596
295647	1874	3656000	16490	8386	1	0	2
11762	1422	8785039860211	16490	8386	4	0	7
295652	1874	3662000	16491	8387	2	0	2
128019	2133	98384772000	16491	8387	3	0	614
5769	1394	158402696000000	16491	8387	5	0	0
128028	2133	98382768000	16493	8388	4	0	616
295662	1874	3671000	16493	8388	4	0	2
295668	1678	18000647542000	16495	8389	0	0	0
295669	1874	3676000	16495	8389	1	0	2
128038	1860	978700000	16496	8390	0	0	4
295675	1678	18000647545000	16496	8390	3	0	0
128044	2133	98379762000	16496	8390	6	0	619
295681	1874	3692000	16496	8390	9	0	2
128049	2134	98395191000	16496	8390	11	0	603
295686	1874	3704000	16497	8391	1	0	2
128055	2134	98392182000	16498	8392	1	0	606
295692	2153	200000000	16499	8393	0	0	0
128061	2134	98391179000	16499	8393	3	0	607
295701	1874	3722000	16501	8394	2	0	2
128077	1397	1344150549000	16503	8395	1	0	9468
295714	1874	3727000	16503	8395	4	0	2
128083	2132	148831832000	16503	8395	7	0	168
295731	1874	3738000	16506	8396	2	0	2
40137	1685	109442187571430	16506	8396	4	0	0
128100	1397	1344100544000	16507	8397	2	0	9473
295737	1874	3744000	16507	8397	5	0	2
128105	2133	98369742000	16507	8397	7	0	629
295742	1874	3754000	16507	8397	10	0	2
128111	2132	148829830000	16508	8398	2	0	170
128113	2133	98365734000	16508	8398	4	0	633
128114	2134	98383155000	16508	8398	5	0	615
295748	1874	3762000	16508	8398	5	0	2
5775	1394	162722743000000	16508	8398	7	0	0
128127	1397	1344030537000	16510	8399	5	0	9480
295761	1678	18000647563000	16510	8399	5	0	0
295766	1874	3775000	16510	8399	10	0	2
128133	2134	98380146000	16510	8399	11	0	618
128138	2133	98360724000	16510	8399	16	0	638
295772	1874	3791000	16510	8399	16	0	2
128166	2134	98375131000	16518	8401	1	0	623
295800	1874	3800000	16518	8401	1	0	2
31162	1668	16526742000000	16518	8401	3	0	5
295805	1678	18000647566000	16520	8402	0	0	0
295806	1874	3803000	16520	8402	1	0	2
25300	1608	13965618000000	16520	8402	5	0	4
128176	2133	98356716000	16521	8403	1	0	642
295812	1874	3813000	16521	8403	3	0	2
128198	2134	98372122000	16525	8404	2	0	626
295828	1874	3821000	16526	8405	2	0	2
128204	1397	1343950529000	16527	8406	0	0	9488
295833	2088	2012300000	16527	8406	2	0	0
128210	2134	98369113000	16527	8406	6	0	629
46755	1693	10940470406843	16527	8406	8	0	772
295839	1874	3836000	16528	8407	1	0	2
128228	1397	1343910525000	16532	8408	1	0	9492
295858	1874	3847000	16532	8408	4	0	2
128243	1397	1343900524000	16536	8409	0	0	9493
295872	1874	3855000	16536	8409	2	0	2
59830	2106	2159034000000	16536	8409	3	0	0
128251	1397	1343890523000	16542	8410	0	0	9494
128252	2152	29748981300000	16542	8410	1	0	3
295883	1874	3856000	16542	8410	5	0	2
128258	2133	98346696000	16542	8410	7	0	652
295889	1874	3870000	16542	8410	11	0	2
128264	2134	98361089000	16542	8410	13	0	637
295948	1678	18000647581000	16552	8411	0	0	0
295949	1874	3878000	16552	8411	1	0	2
128325	2134	98359083000	16553	8412	0	0	639
295955	1874	3887000	16554	8413	2	0	2
5785	1394	165602852000000	16554	8413	6	0	0
128331	1397	1343820516000	16555	8414	0	0	9501
295961	1678	18000647587000	16555	8414	3	0	0
128337	2132	148821822000	16555	8414	6	0	178
295966	1874	3903000	16555	8414	8	0	2
128342	2133	98338680000	16555	8414	11	0	660
26597	1622	17820341000005	16555	8414	13	0	5
295972	1874	3916000	16556	8415	1	0	2
58807	1991	13435844441475	16556	8415	4	0	12
128354	2133	98336676000	16559	8416	1	0	662
295987	1874	3925000	16561	8417	1	0	2
128363	1597	2160034000000	16562	8418	1	0	1
295992	1874	3933000	16562	8418	4	0	2
128368	1397	1343740508000	16563	8419	0	0	9509
128440	1397	1343730507000	16565	8420	0	0	9510
128441	2134	98348050000	16565	8420	1	0	650
296066	1874	3943000	16565	8420	1	0	2
128447	2134	98347047000	16566	8421	3	0	651
296072	1874	3951000	16566	8421	3	0	2
296073	1874	3954000	16566	8421	4	0	2
296074	1874	3956000	16566	8421	5	0	2
128453	2133	98328660000	16567	8422	3	0	670
296118	1678	18000647598000	16573	8423	1	0	0
128496	2132	148817818000	16573	8423	4	0	182
41916	1688	36071726708000	16573	8423	6	0	36
296124	2155	10000000	16574	8424	1	0	0
128502	2133	98325654000	16574	8424	4	0	673
296129	1874	3980000	16575	8425	1	0	2
128535	1397	1343650499000	16577	8426	0	0	9518
128536	1397	1343640498000	16577	8426	1	0	9519
296151	1874	3984000	16577	8426	3	0	2
128542	2133	98321646000	16577	8426	7	0	677
296157	1874	3999000	16577	8426	9	0	2
128568	2133	98319642000	16580	8427	3	0	679
296212	1678	18000647606000	16585	8428	0	0	0
296213	1678	18000647607000	16585	8428	1	0	0
128603	2133	98318640000	16585	8428	4	0	680
296219	1874	4018000	16585	8428	7	0	2
1664	238	66720196000000	16585	8428	9	0	3
128738	1397	1343580492000	16588	8429	0	0	9525
296348	1678	18000647608000	16588	8429	0	0	0
128739	1397	1343570491000	16588	8429	1	0	9526
296349	1678	18000647609000	16588	8429	1	0	0
128745	1397	1343560490000	16589	8430	1	0	9527
296355	1678	18000647610000	16589	8430	1	0	0
128751	1397	1343550489000	16590	8431	2	0	9528
296361	1678	18000647611000	16590	8431	2	0	0
128758	2133	98313630000	16592	8432	2	0	685
296368	1874	4044000	16592	8432	2	0	2
35066	1679	13174850853000	16592	8432	3	0	48
39213	1684	15120436880623	16596	8433	5	0	70
128785	1397	1343520486000	16600	8434	0	0	9531
296394	1874	4052000	16600	8434	2	0	2
128791	2134	98324981000	16602	8436	0	0	673
128841	1397	1343500484000	16611	8437	0	0	9533
296449	1678	18000647616000	16611	8437	0	0	0
128842	1397	1343490483000	16611	8437	1	0	9534
296454	1874	4071000	16611	8437	5	0	2
5797	1394	169922933000000	16611	8437	7	0	0
128848	2133	98307618000	16612	8438	1	0	691
296460	1874	4081000	16613	8439	2	0	2
128854	2134	98320969000	16614	8440	1	0	677
296466	1874	4089000	16616	8441	1	0	2
128859	2134	98319966000	16616	8441	2	0	678
21175	1560	14994322277001	16616	8441	3	0	15
296471	1874	4097000	16619	8442	3	0	2
128868	2134	98317960000	16621	8443	1	0	680
128974	1397	1343420476000	16624	8444	0	0	9541
296581	1678	18000647624000	16624	8444	0	0	0
128975	2132	148809810000	16624	8444	1	0	190
296582	1874	4103000	16624	8444	1	0	2
48348	1698	14937063550035	16624	8444	3	0	7
128984	2133	98300604000	16627	8446	2	0	698
296591	1874	4110000	16627	8446	2	0	2
128990	2134	98313948000	16628	8447	1	0	684
296597	1874	4122000	16628	8447	1	0	2
129113	1397	1343370471000	16630	8448	0	0	9546
296720	1678	18000647629000	16630	8448	0	0	0
129114	2133	98297598000	16630	8448	1	0	701
296721	1874	4126000	16630	8448	1	0	2
41986	1688	38231786708000	16630	8448	3	0	36
129120	2133	98296596000	16631	8449	4	0	702
296727	1874	4132000	16631	8449	4	0	2
129139	484	75725786000000	16636	8451	0	0	2
296746	1073	907346465000000	16636	8451	0	0	0
129144	2134	98309936000	16636	8451	5	0	688
296751	1874	4145000	16636	8451	5	0	2
296753	1874	4147000	16637	8452	1	0	2
296754	1874	4150000	16637	8452	2	0	2
8427	1395	58044864424007706	16637	8452	4	0	0
129150	2132	148806807000	16638	8453	2	0	193
296760	1874	4158000	16638	8453	5	0	2
129163	2133	98290584000	16640	8454	1	0	708
296773	1874	4168000	16641	8455	1	0	2
129168	2134	98304921000	16641	8455	3	0	693
11377	1419	22059442280064	16641	8455	5	0	3
5802	1394	174242970000000	16643	8456	0	0	0
296778	1678	18000647640000	16644	8457	2	0	0
129174	2133	98288580000	16644	8457	5	0	710
296784	1874	4184000	16644	8457	8	0	2
129180	2133	98286576000	16644	8457	11	0	712
28656	1637	196565381819988	16644	8457	12	0	0
296805	1874	4196000	16646	8458	2	0	2
129202	1397	1343230457000	16648	8459	0	0	9560
129203	2133	98284572000	16648	8459	1	0	714
296816	1678	18000647645000	16650	8460	1	0	0
129212	2133	98283570000	16650	8460	4	0	715
40145	1685	111602223571430	16650	8460	6	0	0
296856	1678	18000647647000	16656	8461	1	0	0
129252	2134	98296897000	16656	8461	4	0	701
296862	1678	18000647648000	16657	8462	0	0	0
129257	2134	98294891000	16657	8462	2	0	703
17230	1506	12241232967172	16657	8462	4	0	17
296867	1874	4230000	16658	8463	2	0	2
129281	1397	1343140448000	16661	8464	2	0	9569
296889	1874	4231000	16661	8464	3	0	2
296890	1874	4234000	16661	8464	4	0	2
129287	2134	98290879000	16661	8464	8	0	707
296920	1874	4246000	16665	8465	1	0	2
27753	1635	720000000000	16665	8465	3	0	0
129322	2134	98288873000	16666	8466	1	0	709
296926	1678	18000647655000	16667	8467	0	0	0
129338	1397	1343100444000	16670	8468	0	0	9573
129339	2133	98272548000	16670	8468	1	0	726
296941	1874	4265000	16670	8468	2	0	2
8433	1395	58046304448007706	16670	8468	4	0	0
129354	2132	148799800000	16673	8469	4	0	200
296956	1874	4273000	16673	8469	5	0	2
129374	2134	98283858000	16676	8470	4	0	714
296976	1874	4282000	16676	8470	5	0	2
47649	1695	11852237000000	16676	8470	7	0	5
129389	2134	98282855000	16679	8471	2	0	715
296991	1678	18000647662000	16680	8472	0	0	0
129395	1397	1343010435000	16681	8473	2	0	9582
296997	1874	4295000	16681	8473	3	0	2
129401	2133	98264532000	16681	8473	8	0	734
297003	1874	4310000	16681	8473	9	0	2
19841	1547	11373413000000	16681	8473	11	0	6
129413	2133	98262528000	16683	8474	3	0	736
297015	1874	4315000	16683	8474	4	0	2
53250	1718	7506761763340	16685	8475	2	0	9
129546	1397	1342970431000	16688	8476	0	0	9586
297146	1678	18000647669000	16688	8476	0	0	0
129547	1397	1342960430000	16688	8476	1	0	9587
297147	1678	18000647670000	16688	8476	1	0	0
129553	2134	98273828000	16688	8476	7	0	724
297153	1874	4331000	16688	8476	7	0	2
129559	2134	98271822000	16688	8476	13	0	726
297159	1874	4345000	16688	8476	13	0	2
297161	1874	4350000	16688	8476	15	0	2
297162	1678	18000647674000	16689	8477	0	0	0
129564	2133	98255514000	16689	8477	2	0	743
297168	1874	4361000	16689	8477	6	0	2
129584	1397	1342890423000	16692	8478	1	0	9594
297188	1874	4369000	16692	8478	5	0	2
8436	1395	58047024448007706	16692	8478	7	0	0
129590	1397	1342880422000	16693	8479	0	0	9595
34828	1678	18720659678000	16693	8479	4	0	0
297195	1678	18720659679000	16695	8480	0	0	0
42024	1688	39671821708000	16695	8480	3	0	36
129597	1397	1342860420000	16696	8481	0	0	9597
297201	1874	4387000	16696	8481	4	0	2
129603	2133	98249502000	16696	8481	6	0	749
20444	1555	8835257979096	16696	8481	10	0	4
297207	1874	4398000	16697	8482	1	0	2
32811	1675	12382204999977	16697	8482	3	0	4
129609	1397	1342830417000	16698	8483	0	0	9600
129610	2133	98246496000	16698	8483	1	0	752
297212	1874	4407000	16698	8483	3	0	2
129616	1397	1342810415000	16700	8485	0	0	9602
297218	1678	18720659686000	16701	8486	0	0	0
129629	1397	1342790413000	16704	8487	0	0	9604
297231	1874	4425000	16704	8487	2	0	2
129634	2134	98255774000	16705	8488	2	0	742
297236	1874	4433000	16705	8488	4	0	2
129768	1397	1342760410000	16708	8489	0	0	9607
297368	1678	18720659690000	16708	8489	0	0	0
129769	2134	98253768000	16708	8489	1	0	744
297369	1874	4439000	16708	8489	1	0	2
129896	1397	1342750409000	16710	8490	0	0	9608
297496	1678	18720659691000	16710	8490	0	0	0
129897	1397	1342740408000	16710	8490	1	0	9609
297497	1678	18720659692000	16710	8490	1	0	0
129903	2134	98252765000	16710	8490	7	0	745
297503	1874	4451000	16710	8490	7	0	2
129925	1397	1342710405000	16718	8492	0	0	9612
297525	1678	18720659695000	16718	8492	0	0	0
129933	2134	98247750000	16720	8493	2	0	750
297533	1874	4470000	16720	8493	2	0	2
130113	1397	1342680402000	16724	8494	0	0	9615
297712	1678	18720659698000	16724	8494	0	0	0
130114	1397	1342670401000	16724	8494	1	0	9616
297713	1678	18720659699000	16724	8494	1	0	0
4934	641	77139971000000	16724	8494	7	0	12
130125	1397	1342660400000	16726	8495	0	0	9617
297724	1678	18720659700000	16726	8495	0	0	0
12571	1439	11812436998477	16726	8495	5	0	6
130136	2134	98241732000	16728	8496	1	0	756
297735	1874	4500000	16728	8496	1	0	2
130146	2133	98227458000	16733	8498	1	0	771
297745	1874	4505000	16733	8498	1	0	2
5817	1394	178563007000000	16733	8498	4	0	0
130153	2133	98226456000	16735	8499	1	0	772
130154	2134	98239726000	16735	8499	2	0	758
297764	1340	1700432510151650	16738	8500	1	0	0
130170	2132	148784785000	16738	8500	4	0	215
22634	1587	19440611000000	16738	8500	6	0	7
297789	1678	18720659708000	16742	8501	2	0	0
130197	2133	98223450000	16742	8501	5	0	775
22062	1571	20160462001024	16742	8501	9	0	1
130356	1397	1342570391000	16748	8502	0	0	9626
297948	1678	18720659709000	16748	8502	0	0	0
130357	1397	1342560390000	16748	8502	1	0	9627
297949	1678	18720659710000	16748	8502	1	0	0
130363	2133	98222448000	16748	8502	7	0	776
297955	1874	4541000	16748	8502	7	0	2
48715	1699	6549790750126	16748	8502	10	0	6
130377	2133	98219442000	16751	8503	3	0	779
297969	1874	4550000	16751	8503	3	0	2
130382	2134	98230699000	16753	8505	1	0	767
297974	1874	4557000	16753	8505	1	0	2
12243	1426	19005079000000	16753	8505	3	0	4
297979	1678	18720659715000	16755	8506	0	0	0
297980	1874	4561000	16755	8506	1	0	2
130524	2132	148781782000	16760	8507	0	0	218
298114	1874	4565000	16760	8507	0	0	2
130525	2133	98216436000	16760	8507	1	0	782
298115	1874	4567000	16760	8507	1	0	2
5824	1394	182883045000000	16760	8507	4	0	0
130537	2134	98226687000	16764	8509	1	0	771
298127	1874	4578000	16764	8509	1	0	2
17763	1509	13631880851155	16765	8510	3	0	5
130606	1397	1342470381000	16768	8511	0	0	9636
130607	2133	98212428000	16768	8511	1	0	786
298198	1874	4585000	16768	8511	2	0	2
130613	1397	1342450379000	16770	8513	0	0	9638
298203	1678	18720659721000	16770	8513	0	0	0
130619	2132	148779780000	16770	8513	6	0	220
298209	1874	4604000	16770	8513	6	0	2
130766	1397	1342430377000	16774	8514	0	0	9640
298356	1678	18720659723000	16774	8514	0	0	0
130767	1397	1342420376000	16774	8514	1	0	9641
298357	1678	18720659724000	16774	8514	1	0	0
130773	2133	98207418000	16774	8514	7	0	791
298363	1874	4614000	16774	8514	7	0	2
130779	1397	1342390373000	16775	8515	0	0	9644
298369	1678	18720659727000	16775	8515	0	0	0
130787	2132	148777778000	16777	8516	2	0	222
298377	1874	4631000	16777	8516	2	0	2
130793	2133	98201406000	16778	8517	1	0	797
298383	1874	4643000	16778	8517	1	0	2
40820	1686	12452046550062	16778	8517	3	0	9
298388	1678	18720659731000	16780	8518	0	0	0
298389	1874	4648000	16780	8518	1	0	2
23862	1596	15120553000000	16780	8518	3	0	11
130816	1397	1342330367000	16783	8519	1	0	9650
298409	1874	4657000	16783	8519	4	0	2
130821	2133	98198400000	16783	8519	6	0	800
130907	1397	1342320366000	16787	8520	0	0	9651
130908	2134	98210639000	16787	8520	1	0	787
49564	1702	7200296000000	16787	8520	4	0	3
298501	1678	18720659735000	16790	8521	0	0	0
130920	2134	98208633000	16791	8522	1	0	789
298506	1874	4676000	16791	8522	2	0	2
10580	1402	53134581319298	16791	8522	4	0	33
130932	1397	1342280362000	16795	8524	1	0	9655
298518	1874	4683000	16795	8524	2	0	2
298542	414	66000011000000	16798	8525	0	0	1
298543	1678	18720659739000	16798	8525	1	0	0
130959	1397	1342260360000	16798	8525	2	0	9657
298549	1874	4688000	16798	8525	7	0	2
130965	2132	148774775000	16798	8525	8	0	225
44260	1690	114483530000000	16798	8525	11	0	0
130969	2133	98192388000	16799	8526	1	0	806
130970	2134	98203618000	16799	8526	2	0	794
298555	1874	4700000	16799	8526	2	0	2
298564	1678	18720659743000	16802	8528	0	0	0
130980	2134	98201612000	16802	8528	1	0	796
298578	1678	18720659745000	16807	8530	0	0	0
130994	2134	98199606000	16807	8530	1	0	798
131018	1397	1342180352000	16813	8533	1	0	9665
298601	1678	18720659748000	16813	8533	1	0	0
298606	1874	4729000	16813	8533	6	0	2
131024	2134	98198603000	16813	8533	7	0	799
298625	1874	4744000	16816	8534	1	0	2
131043	1397	1342150349000	16817	8535	0	0	9668
131048	2134	98193588000	16818	8536	3	0	804
298631	1874	4752000	16818	8536	3	0	2
8456	1395	58049184498007706	16818	8536	5	0	0
298641	1874	4761000	16822	8538	1	0	2
131059	2133	98182368000	16822	8538	2	0	816
298651	1874	4769000	16826	8540	2	0	2
131069	2134	98188573000	16826	8540	3	0	809
29249	1643	2408423114700	16826	8540	4	0	17
298657	1874	4775000	16828	8541	1	0	2
298658	1874	4777000	16828	8541	2	0	2
131080	2133	98179362000	16830	8542	1	0	819
131133	1397	1342070341000	16834	8543	0	0	9676
131134	2133	98178360000	16834	8543	1	0	820
298704	1874	4787000	16834	8543	2	0	2
131223	2133	98177358000	16842	8545	1	0	821
298792	1874	4796000	16842	8545	2	0	2
298793	1678	18720659762000	16843	8546	0	0	0
298794	1678	18720659763000	16843	8546	1	0	0
131229	2132	148767768000	16843	8546	4	0	232
31565	1670	18001138000000	16843	8546	8	0	6
298803	1678	18720659764000	16845	8547	0	0	0
131237	2133	98174352000	16845	8547	2	0	824
131241	1397	1342010335000	16847	8548	0	0	9682
131242	2133	98173350000	16847	8548	1	0	825
298812	1678	18720659766000	16848	8549	0	0	0
131248	1397	1341990333000	16849	8550	0	0	9684
298817	1874	4825000	16849	8550	1	0	2
131346	1397	1341970331000	16857	8552	0	0	9686
298915	1678	18720659770000	16857	8552	1	0	0
131351	2134	98175534000	16857	8552	5	0	822
13557	1447	14554583943000	16857	8552	8	0	5
298924	1678	18720659771000	16864	8553	0	0	0
57134	1762	16161977994000	16864	8553	4	0	4
298930	1678	18720659772000	16866	8554	0	0	0
131363	2132	148764765000	16866	8554	1	0	235
298931	1874	4850000	16866	8554	1	0	2
5839	1394	187203069000000	16866	8554	4	0	0
131491	1397	1341930327000	16869	8556	0	0	9690
131492	1397	1341920326000	16869	8556	1	0	9691
299060	1678	18720659776000	16869	8556	3	0	0
131498	2133	98163330000	16869	8556	7	0	835
299065	1874	4864000	16869	8556	8	0	2
299066	1874	4867000	16869	8556	9	0	2
40153	1685	113762297571430	16869	8556	13	0	0
131530	1397	1341890323000	16872	8557	0	0	9694
131531	2133	98161326000	16872	8557	1	0	837
299106	1678	18720659778000	16875	8558	0	0	0
131545	1397	1341860320000	16876	8559	1	0	9697
299112	1678	18720659781000	16876	8559	2	0	0
131551	2134	98164501000	16876	8559	7	0	833
299117	1874	4897000	16876	8559	7	0	2
8464	1395	58051344534007706	16876	8559	9	0	0
131556	2133	98156316000	16877	8560	3	0	842
299123	1678	18720659783000	16879	8561	0	0	0
131562	2134	98162495000	16879	8561	5	0	835
299129	1874	4915000	16879	8561	6	0	2
131571	1397	1341800314000	16881	8562	0	0	9703
299137	1678	18720659786000	16881	8562	0	0	0
50273	1705	11435535500145	16881	8562	4	0	20
131579	2134	98157480000	16883	8563	2	0	840
299146	1678	18720659788000	16884	8564	0	0	0
14740	1457	15024354040000	16884	8564	5	0	4
131710	1397	1341770311000	16886	8565	0	0	9706
299274	1678	18720659789000	16886	8565	0	0	0
131711	2133	98149302000	16886	8565	1	0	849
299275	1874	4942000	16886	8565	1	0	2
30197	1654	16125128999798	16886	8565	3	0	7
131847	1397	1341760310000	16891	8566	0	0	9707
299411	1678	18720659790000	16891	8566	0	0	0
131848	2133	98148300000	16891	8566	1	0	850
299412	1874	4947000	16891	8566	1	0	2
45246	1692	16339971719999	16891	8566	3	0	5
131854	2132	148758759000	16893	8568	1	0	241
299418	1874	4956000	16893	8568	1	0	2
131885	1397	1341730307000	16902	8570	0	0	9710
299449	1678	18720659793000	16902	8570	0	0	0
131890	2134	98150459000	16902	8570	5	0	847
299454	1874	4972000	16902	8570	5	0	2
131902	2133	98142288000	16906	8572	1	0	856
299466	1874	4982000	16906	8572	1	0	2
131908	2132	148756757000	16907	8573	4	0	243
299472	1874	4989000	16907	8573	4	0	2
299473	1874	4991000	16907	8573	5	0	2
299474	1874	4993000	16907	8573	6	0	2
131913	2134	98144441000	16907	8573	9	0	853
51350	1709	10800165999976	16907	8573	11	0	7
299480	1874	5002000	16908	8574	2	0	2
131919	2133	98137278000	16908	8574	5	0	861
131958	1397	1341630297000	16916	8575	0	0	9720
131959	2134	98141432000	16916	8575	1	0	856
299523	1874	5015000	16916	8575	1	0	2
22817	1588	15334959000000	16916	8575	3	0	6
56207	1749	5885258930000	16917	8576	3	0	17
299539	1678	18720659805000	16921	8577	0	0	0
131976	2133	98134272000	16921	8577	1	0	864
299565	1678	18720659808000	16925	8578	2	0	0
132002	1397	1341570291000	16925	8578	3	0	9726
132007	2132	148753754000	16925	8578	8	0	246
299571	1874	5040000	16925	8578	8	0	2
299576	2157	200000000	16926	8579	1	0	0
132013	2133	98130264000	16926	8579	2	0	868
44268	1690	115923719000000	16928	8580	4	0	0
299606	1874	5058000	16930	8581	0	0	2
132043	2133	98128260000	16930	8581	1	0	870
299612	1678	18720659812000	16932	8582	0	0	0
299613	1874	5066000	16932	8582	1	0	2
132051	1397	1341530287000	16933	8583	0	0	9730
132057	1397	1341520286000	16935	8584	0	0	9731
132058	2132	148751752000	16935	8584	1	0	248
299622	1874	5074000	16935	8584	1	0	2
132064	2134	98127390000	16936	8585	5	0	870
299628	1874	5085000	16936	8585	5	0	2
47279	1694	18732657127629	16936	8585	8	0	34
299647	1678	18720659818000	16940	8587	0	0	0
132084	2133	98122248000	16940	8587	1	0	876
8470	1395	58052784595007706	16940	8587	4	0	0
132222	1397	1341450279000	16948	8590	0	0	9738
299784	1678	18720659821000	16948	8590	0	0	0
132223	2132	148749750000	16948	8590	1	0	250
299785	1874	5098000	16948	8590	1	0	2
5850	1394	190083092000000	16949	8591	2	0	0
5852	1394	190083103000000	16949	8591	3	0	0
132229	2133	98118240000	16951	8592	2	0	880
299791	1874	5104000	16951	8592	2	0	2
132235	2133	98115234000	16953	8593	3	0	883
299797	1874	5111000	16953	8593	3	0	2
42065	1688	41111855708000	16953	8593	5	0	36
132262	2133	98113230000	16958	8594	4	0	885
299824	1874	5115000	16958	8594	4	0	2
132271	2132	148746747000	16962	8597	1	0	253
299833	1874	5119000	16962	8597	1	0	2
45271	1692	17780029719999	16962	8597	4	0	5
132291	2133	98109222000	16965	8598	4	0	889
299853	1874	5125000	16965	8598	4	0	2
132326	1397	1341300264000	16975	8600	0	0	9753
299888	1678	18720659836000	16975	8600	0	0	0
299889	1874	5132000	16975	8600	1	0	2
55747	1746	7714360000000	16975	8600	2	0	2
132331	1397	1341290263000	16979	8601	0	0	9754
36315	1681	12023228759830	16979	8601	2	0	6
132332	1397	1341280262000	16980	8602	0	0	9755
299902	1874	5137000	16983	8603	1	0	2
132347	1397	1341250259000	16985	8604	1	0	9758
299918	1678	18720659842000	16987	8605	0	0	0
132362	1397	1341230257000	16990	8606	0	0	9760
299927	1874	5147000	16991	8607	1	0	2
187	42	89758399000000	16991	8607	3	0	4
132367	1397	1341210255000	16994	8608	0	0	9762
299933	1874	5152000	16998	8609	2	0	2
132373	2133	98096196000	16998	8609	4	0	902
46848	1693	13100615406843	16999	8610	2	0	772
299943	1874	5160000	17002	8611	1	0	2
132383	2132	148740741000	17003	8612	1	0	259
299948	1678	18720659852000	17004	8613	1	0	0
132388	2133	98091186000	17004	8613	3	0	907
22208	1573	9339014000000	17004	8613	4	0	5
299962	1874	5171000	17007	8614	3	0	2
132402	1397	1341110245000	17008	8615	0	0	9772
20778	1559	12922742000000	17008	8615	3	0	4
299968	1874	5175000	17009	8616	2	0	2
132408	2133	98086176000	17009	8616	4	0	912
299978	1874	5181000	17011	8617	2	0	2
132418	1397	1341070241000	17012	8618	0	0	9776
299986	1874	5188000	17014	8619	2	0	2
132426	2134	98122375000	17014	8619	4	0	875
25590	1610	12960373000000	17014	8619	7	0	6
299995	1874	5201000	17016	8620	1	0	2
132441	1397	1341030237000	17019	8621	0	0	9780
300020	1678	18720659864000	17022	8622	0	0	0
300021	1678	18720659865000	17022	8622	1	0	0
132460	2134	98119366000	17022	8622	2	0	878
28664	1637	198005466819988	17022	8622	8	0	0
132477	1397	1341000234000	17026	8623	0	0	9783
300039	1678	18720659866000	17026	8623	0	0	0
132478	2133	98078160000	17026	8623	1	0	920
300153	1874	5226000	17029	8624	0	0	2
300154	1874	5227000	17029	8624	1	0	2
132605	1397	1340990233000	17034	8625	0	0	9784
132606	2134	98116357000	17034	8625	1	0	881
5862	1394	194403160000000	17036	8626	4	0	0
300175	1678	18720659869000	17037	8627	0	0	0
132615	2134	98114351000	17037	8627	2	0	883
300184	1874	5246000	17039	8628	3	0	2
53030	1717	11628022000023	17039	8628	4	0	4
132624	2134	98112345000	17040	8629	1	0	885
300189	1874	5254000	17041	8630	1	0	2
132629	1397	1340930227000	17042	8631	0	0	9790
300195	1678	18720659875000	17043	8632	1	0	0
132635	2134	98108333000	17043	8632	3	0	889
32244	1672	19442055000000	17043	8632	6	0	5
300207	1874	5273000	17046	8633	1	0	2
132647	2132	148732733000	17046	8633	3	0	267
300216	1874	5281000	17048	8634	2	0	2
132658	2134	98105324000	17050	8635	1	0	892
300224	1874	5291000	17051	8636	2	0	2
54057	1723	17639504085979	17051	8636	4	0	6
132799	1397	1340860220000	17056	8637	0	0	9797
300361	1678	18720659880000	17056	8637	0	0	0
132800	1726	125335109000	17056	8637	1	0	8182
300362	2160	200000000	17056	8637	1	0	0
132806	2134	98102315000	17057	8638	2	0	895
300368	1874	5302000	17057	8638	2	0	2
132812	2134	98101312000	17058	8639	5	0	896
300374	1874	5310000	17058	8639	5	0	2
55338	1740	12761439000000	17058	8639	7	0	11
132817	1397	1340810215000	17060	8641	0	0	9802
300379	1678	18720659885000	17060	8641	0	0	0
53574	1719	12980562000000	17060	8641	4	0	5
132827	2132	148729730000	17062	8642	3	0	270
300389	1874	5329000	17062	8642	3	0	2
17443	1508	14436292500009	17062	8642	4	0	6
132859	2133	98058120000	17066	8644	5	0	940
300421	1874	5332000	17066	8644	5	0	2
300425	1874	5341000	17066	8644	9	0	2
132864	2134	98095294000	17066	8644	10	0	902
300426	1874	5344000	17066	8644	10	0	2
12882	1440	13679289000000	17066	8644	14	0	6
132873	2134	98092285000	17068	8645	1	0	905
132874	2133	98054112000	17068	8645	2	0	944
300437	1678	18720659892000	17069	8646	0	0	0
132884	2134	98090279000	17071	8647	2	0	907
300447	1874	5366000	17071	8647	3	0	2
1307	149	82830238000341	17071	8647	4	0	5
132897	2133	98051106000	17076	8649	3	0	947
300459	1874	5374000	17076	8649	3	0	2
28670	1637	200165503819988	17078	8650	4	0	0
132906	1397	1340680202000	17079	8651	1	0	9815
300469	2111	2200000000	17079	8651	2	0	0
132912	2132	148726727000	17079	8651	7	0	273
8483	1395	58054944619007706	17079	8651	8	0	0
300475	1678	18720659899000	17080	8652	0	0	0
132918	2132	148725726000	17080	8652	5	0	274
300480	1874	5393000	17080	8652	5	0	2
132923	2134	98082255000	17080	8652	10	0	915
300486	1958	3485987000000	17081	8653	0	0	2
132933	2133	98043090000	17083	8654	1	0	955
300496	1874	5414000	17083	8654	2	0	2
132939	1397	1340610195000	17085	8656	0	0	9822
300501	1678	18720659905000	17085	8656	0	0	0
132944	2134	98077240000	17085	8656	5	0	920
16750	1489	12864017000000	17085	8656	6	0	4
133070	1397	1340590193000	17087	8657	0	0	9824
300632	1678	18720659907000	17087	8657	0	0	0
133071	2134	98076237000	17087	8657	1	0	921
300633	1874	5435000	17087	8657	1	0	2
5868	1394	198723196000000	17088	8658	4	0	0
133077	2134	98074231000	17089	8659	1	0	923
300639	1874	5444000	17089	8659	1	0	2
133086	2133	98036076000	17093	8661	1	0	962
300648	1874	5451000	17093	8661	1	0	2
50964	1708	10835791000021	17094	8662	2	0	4
133101	2133	98034072000	17097	8663	2	0	964
300663	1874	5455000	17097	8663	2	0	2
300702	1678	18720659915000	17102	8665	0	0	0
300703	1678	18720659916000	17102	8665	1	0	0
133143	2133	98031066000	17102	8665	3	0	967
133151	1397	1340490183000	17105	8666	0	0	9834
133152	2132	148720721000	17105	8666	1	0	279
300716	1678	18720659918000	17106	8667	0	0	0
133160	1397	1340460180000	17109	8669	0	0	9837
300724	1874	5472000	17109	8669	2	0	2
11424	1419	24219492280064	17109	8669	5	0	3
133173	1397	1340440178000	17114	8671	0	0	9839
300736	1874	5476000	17114	8671	1	0	2
133264	1397	1340420176000	17119	8673	0	0	9841
55354	1740	13481464000000	17119	8673	2	0	11
300828	1678	18720659925000	17120	8674	0	0	0
16457	1476	13680214000000	17120	8674	3	0	5
133270	2132	148717718000	17121	8675	2	0	282
300835	1678	18720659927000	17123	8676	0	0	0
300836	1874	5488000	17123	8676	1	0	2
133280	2133	98018040000	17126	8678	1	0	980
133281	2132	148716717000	17126	8678	2	0	283
133317	1397	1340360170000	17128	8679	0	0	9847
300879	1678	18720659930000	17128	8679	0	0	0
5873	1394	203043219000000	17128	8679	1	0	0
133326	2133	98016036000	17131	8681	2	0	982
300888	1874	5498000	17131	8681	2	0	2
1084	111	68880040000000	17131	8681	3	0	0
27362	1633	12276616985638	17134	8682	4	0	8
300900	1678	18720659935000	17135	8683	0	0	0
133339	2133	98013030000	17135	8683	1	0	985
11433	1419	24939492280064	17137	8684	2	0	3
11434	1419	24939503280064	17137	8684	3	0	3
133348	1726	122895109000	17140	8686	0	0	8185
300910	2161	200000000	17140	8686	0	0	0
133354	2134	98073228000	17141	8687	3	0	924
300916	1874	5515000	17141	8687	3	0	2
300921	1874	5519000	17142	8688	4	0	2
133360	2134	98072225000	17142	8688	5	0	925
133368	2133	98006016000	17144	8689	1	0	992
300930	1874	5532000	17144	8689	1	0	2
15088	1458	16653714908540	17144	8689	4	0	4
133374	1397	1340200154000	17147	8692	1	0	9863
300936	1678	18720659946000	17147	8692	1	0	0
300941	1874	5548000	17147	8692	6	0	2
133380	2134	98066207000	17147	8692	7	0	931
133385	2133	98002008000	17148	8693	4	0	996
300947	1874	5559000	17148	8693	4	0	2
133519	1397	1340160150000	17152	8695	0	0	9867
301081	1678	18720659950000	17152	8695	0	0	0
133520	2134	98062195000	17152	8695	1	0	935
301082	1874	5568000	17152	8695	1	0	2
44274	1690	118083754000000	17152	8695	4	0	0
133536	2134	98061192000	17154	8696	4	0	936
301098	1874	5574000	17154	8696	4	0	2
42124	1688	43271879708000	17154	8696	10	0	36
133571	188	66000900000000	17158	8697	0	0	1
301133	1474	12513412000023	17158	8697	0	0	15
133572	1397	1340130147000	17158	8697	1	0	9870
301134	1678	18720659953000	17158	8697	1	0	0
23171	1593	15670150000000	17158	8697	8	0	4
133599	1397	1340110145000	17162	8698	0	0	9872
301161	1678	18720659955000	17162	8698	0	0	0
133605	1397	1340080142000	17163	8699	2	0	9875
301167	1678	18720659958000	17163	8699	2	0	0
133610	2133	97992990000	17163	8699	7	0	1005
301172	1874	5614000	17163	8699	7	0	2
133616	1397	1340060140000	17165	8701	0	0	9877
301178	1678	18720659960000	17165	8701	0	0	0
133745	1397	1340050139000	17167	8702	0	0	9878
301307	1678	18720659961000	17167	8702	0	0	0
133746	1397	1340040138000	17167	8702	1	0	9879
301308	1678	18720659962000	17167	8702	1	0	0
133752	2133	97987980000	17167	8702	7	0	1010
301314	1874	5640000	17167	8702	7	0	2
133779	2133	97984974000	17170	8703	3	0	1013
301341	1874	5647000	17170	8703	3	0	2
133787	2133	97982970000	17172	8704	1	0	1015
301349	1874	5657000	17172	8704	1	0	2
133797	2134	98043138000	17175	8706	1	0	954
301359	1874	5668000	17175	8706	1	0	2
25958	1611	27350990000000	17179	8707	3	0	1
133814	1397	1339960130000	17180	8708	0	0	9887
301376	1678	19440671970000	17180	8708	0	0	0
301377	1460	0	17180	8708	1	0	0
301378	1874	5677000	17180	8708	2	0	2
133819	2134	98040129000	17180	8708	5	0	957
133835	1397	1339950129000	17188	8710	0	0	9888
133836	1397	1339940128000	17188	8710	1	0	9889
301399	1678	19440671973000	17188	8710	2	0	0
133842	2133	97976958000	17188	8710	7	0	1021
301405	1874	5700000	17188	8710	8	0	2
133857	1397	1339910125000	17191	8712	0	0	9892
301419	1678	19440671975000	17191	8712	0	0	0
5882	1394	207363276000000	17191	8712	4	0	0
133862	2133	97972950000	17192	8713	2	0	1025
56746	1759	13680785999999	17192	8713	4	0	7
301430	1678	19440671977000	17195	8714	0	0	0
133880	2134	98032105000	17198	8715	1	0	965
301443	1874	5727000	17198	8715	2	0	2
133886	2134	98030099000	17199	8716	4	0	967
301448	1874	5735000	17199	8716	4	0	2
40854	1686	14612096550062	17199	8716	6	0	9
133897	1397	1339840118000	17203	8718	0	0	9899
301460	1874	5744000	17203	8718	1	0	2
39245	1684	16560506880623	17209	8719	4	0	70
133928	1397	1339820116000	17211	8720	0	0	9901
301491	1874	5753000	17211	8720	1	0	2
4960	641	79300020000000	17211	8720	4	0	12
133934	2133	97964934000	17212	8721	2	0	1033
301496	1874	5762000	17212	8721	2	0	2
28682	1637	202325538819988	17215	8722	4	0	0
301514	1678	19440671987000	17218	8723	0	0	0
133953	1397	1339780112000	17218	8723	1	0	9905
301515	1678	19440671988000	17218	8723	1	0	0
133966	1397	1339770111000	17220	8724	0	0	9906
301528	1678	19440671989000	17220	8724	0	0	0
133967	1397	1339760110000	17220	8724	1	0	9907
301534	1678	19440671991000	17222	8725	0	0	0
133973	2133	97959924000	17222	8725	1	0	1038
59971	2112	2879048000000	17222	8725	4	0	0
301545	1874	5797000	17225	8726	2	0	2
133985	2134	98017060000	17226	8727	1	0	980
301551	1874	5805000	17227	8728	2	0	2
133990	2134	98016057000	17227	8728	3	0	981
10608	1402	55294605319298	17227	8728	4	0	33
301563	1874	5815000	17229	8729	4	0	2
134002	2134	98014051000	17229	8729	5	0	983
8489	1395	58056384698007706	17231	8730	2	0	0
301575	1874	5822000	17231	8730	4	0	2
134015	2132	148696697000	17231	8730	6	0	303
301595	1874	5832000	17234	8731	2	0	2
134034	2134	98010039000	17234	8731	3	0	987
301601	1874	5843000	17235	8732	1	0	2
134040	2133	97949904000	17235	8732	2	0	1048
27675	1634	17471845641004	17235	8732	3	0	9
301611	1678	19440672004000	17240	8734	1	0	0
134051	2132	148694695000	17240	8734	3	0	305
301631	1678	19440672005000	17243	8735	0	0	0
134070	2134	98005024000	17243	8735	1	0	992
134206	1397	1339600094000	17249	8737	0	0	9923
301768	1678	19440672006000	17249	8737	0	0	0
134207	1397	1339590093000	17249	8737	1	0	9924
301769	1678	19440672007000	17249	8737	1	0	0
134216	2133	97942890000	17251	8738	1	0	1055
301778	1874	5881000	17251	8738	1	0	2
301786	1678	19440672009000	17253	8739	0	0	0
301787	1678	19440672010000	17253	8739	1	0	0
134228	2134	97999006000	17253	8739	4	0	998
134242	2134	97998003000	17257	8740	0	0	999
134248	1397	1339550089000	17259	8741	0	0	9928
301810	1678	19440672011000	17259	8741	0	0	0
134254	2134	97997000000	17260	8742	2	0	1000
301816	1874	5904000	17260	8742	2	0	2
4144	632	69740921000000	17260	8742	8	0	5
301821	1678	19440672015000	17262	8743	0	0	0
134260	2133	97935876000	17262	8743	1	0	1062
134265	1397	1339490083000	17265	8745	0	0	9934
301827	1678	19440672017000	17265	8745	0	0	0
52846	1716	18766913000000	17265	8745	3	0	4
51654	1710	16074634473290	17267	8746	1	0	6
134274	2134	97990982000	17268	8747	2	0	1006
301836	1874	5934000	17268	8747	2	0	2
24475	1601	10010244620000	17270	8748	3	0	13
301841	1874	5942000	17272	8749	1	0	2
134280	2133	97930866000	17272	8749	2	0	1067
5891	1394	211683322000000	17272	8749	4	0	0
134288	2134	97986970000	17277	8751	1	0	1010
301850	1874	5952000	17277	8751	1	0	2
8499	1395	58057824715007706	17281	8752	5	0	0
134306	2133	97926858000	17283	8753	1	0	1071
301868	1874	5961000	17283	8753	1	0	2
2738	484	68588746000000	17283	8753	3	0	4
301873	1874	5970000	17284	8754	3	0	2
134312	2133	97925856000	17284	8754	4	0	1072
29699	1649	21164272999992	17284	8754	6	0	4
134329	2134	97981955000	17287	8755	3	0	1015
301891	1874	5977000	17287	8755	3	0	2
134335	1397	1339350069000	17288	8756	0	0	9948
301897	1678	19440672031000	17288	8756	0	0	0
301902	1874	5999000	17288	8756	5	0	2
58822	1991	15595892441475	17288	8756	6	0	12
134341	1397	1339330067000	17289	8757	0	0	9950
134350	2133	97917840000	17294	8759	1	0	1080
301912	1874	6006000	17294	8759	1	0	2
301924	1678	19440672036000	17296	8760	0	0	0
301925	1678	19440672037000	17296	8760	1	0	0
134365	2133	97916838000	17296	8760	3	0	1081
134369	2133	97915836000	17296	8760	7	0	1082
301931	1874	6025000	17296	8760	7	0	2
134370	2133	97914834000	17296	8760	8	0	1083
52586	1715	38880660000002	17297	8761	3	0	0
301937	1678	19440672041000	17298	8762	1	0	0
134376	1397	1339240058000	17298	8762	2	0	9959
301942	1874	6040000	17298	8762	6	0	2
134382	2134	97966910000	17298	8762	8	0	1030
301948	1678	19440672044000	17299	8763	0	0	0
134387	2134	97965907000	17299	8763	1	0	1031
301969	1874	6062000	17302	8764	3	0	2
134408	2133	97906818000	17302	8764	4	0	1091
301980	1874	6069000	17304	8765	2	0	2
20196	1549	20495904000000	17304	8765	5	0	5
134420	1397	1339180052000	17305	8766	0	0	9965
301986	1874	6079000	17305	8766	4	0	2
134425	2134	97960892000	17305	8766	5	0	1036
24517	1601	11450256620000	17306	8767	3	0	13
301995	1874	6090000	17308	8768	1	0	2
134434	1397	1339140048000	17309	8769	0	0	9969
59978	2112	3599048000000	17311	8770	1	0	0
59980	2112	3599049000000	17311	8770	2	0	0
302011	1678	19440672053000	17314	8771	0	0	0
134451	2133	97899804000	17314	8771	2	0	1098
19518	1546	12240880000000	17314	8771	4	0	6
302019	1874	6108000	17316	8772	1	0	2
134458	1397	1339100044000	17317	8773	0	0	9973
302025	1874	6118000	17318	8774	2	0	2
49040	1700	14705981276737	17318	8774	3	0	6
134464	1397	1339080042000	17319	8775	0	0	9975
42181	1688	45431941708000	17319	8775	2	0	36
302036	1874	6126000	17322	8776	2	0	2
134483	1397	1339060040000	17324	8777	1	0	9977
302049	1874	6133000	17324	8777	5	0	2
134488	2134	97948856000	17324	8777	6	0	1048
23880	1596	16560726000000	17324	8777	8	0	11
302065	1678	19440672062000	17327	8778	0	0	0
302066	1874	6139000	17327	8778	1	0	2
3872	606	76077829812962	17327	8778	2	0	12
134583	1866	9330827500718	17330	8779	0	0	17
134584	1866	9327039506772	17330	8779	1	0	18
302150	1056	906734945016128	17330	8779	5	0	0
134590	1866	0	17330	8779	7	0	24
302165	1678	19440672064000	17332	8780	0	0	0
134605	2133	97892790000	17332	8780	2	0	1105
193	42	91198456000000	17332	8780	5	0	4
302177	1678	19440672066000	17336	8782	0	0	0
134617	2133	97889784000	17336	8782	2	0	1108
302183	1874	6163000	17336	8782	6	0	2
134623	2134	97941835000	17336	8782	8	0	1055
302189	1678	19440672069000	17338	8784	0	0	0
134629	2133	97886778000	17338	8784	2	0	1111
302193	1874	6182000	17339	8785	1	0	2
302194	1874	6184000	17339	8785	2	0	2
134637	2133	97884774000	17341	8786	1	0	1113
29851	1650	7954135000000	17341	8786	3	0	5
134642	1397	1338940028000	17343	8787	0	0	9989
134643	2134	97936820000	17343	8787	1	0	1060
302206	1874	6194000	17343	8787	2	0	2
5901	1394	216003394000000	17343	8787	3	0	0
40172	1685	115922369571430	17346	8788	3	0	0
134663	1397	1338910025000	17351	8790	1	0	9992
302226	1874	6202000	17351	8790	2	0	2
134669	2133	97880766000	17352	8791	2	0	1117
302231	1874	6212000	17352	8791	2	0	2
25325	1608	16125666000000	17353	8792	2	0	4
134692	1397	1338860020000	17356	8793	2	0	9997
302255	1874	6218000	17356	8793	3	0	2
134698	2133	97877760000	17356	8793	9	0	1120
302270	1678	19440672081000	17360	8794	0	0	0
134719	2133	97875756000	17363	8795	2	0	1122
302281	1874	6240000	17363	8795	2	0	2
45316	1692	20660076719999	17363	8795	4	0	5
134739	1397	1338820016000	17368	8797	0	0	10001
302302	1678	19440672085000	17368	8797	1	0	0
134745	2134	97922778000	17368	8797	6	0	1074
302310	1678	19440672087000	17370	8798	0	0	0
134764	1397	1338770011000	17376	8800	0	0	10006
302326	1678	19440672089000	17376	8800	0	0	0
302329	1678	19440672090000	17377	8801	0	0	0
302330	1874	6273000	17377	8801	1	0	2
134769	2134	97918766000	17377	8801	2	0	1078
302336	1874	6284000	17378	8802	4	0	2
134775	2133	97867740000	17378	8802	5	0	1130
134782	1397	1338730007000	17380	8803	0	0	10010
134783	1397	1338720006000	17380	8803	1	0	10011
302348	1874	6291000	17380	8803	4	0	2
134789	2134	97913751000	17380	8803	7	0	1083
302353	1678	19440672097000	17381	8804	1	0	0
134795	2133	97863732000	17381	8804	5	0	1134
302365	1874	6312000	17383	8805	1	0	2
134812	1397	1338670001000	17387	8807	0	0	10016
302377	1874	6321000	17387	8807	3	0	2
134954	1397	1338649999000	17390	8808	0	0	10018
302516	1678	19440672101000	17390	8808	0	0	0
134955	1397	1338639998000	17390	8808	1	0	10019
302517	1678	19440672102000	17390	8808	1	0	0
134961	2133	97859724000	17390	8808	7	0	1138
302523	1874	6332000	17390	8808	7	0	2
134983	1397	1338599994000	17393	8809	1	0	10023
302545	1678	19440672106000	17393	8809	1	0	0
134988	2134	97903721000	17393	8809	6	0	1093
302550	1874	6351000	17393	8809	6	0	2
2627	470	78960445000000	17393	8809	9	0	6
134999	2134	97901715000	17395	8810	4	0	1095
302561	1874	6361000	17395	8810	4	0	2
8511	1395	58059984761007706	17396	8811	3	0	0
135005	2133	97851708000	17397	8812	3	0	1146
302567	1874	6366000	17397	8812	3	0	2
135010	2133	97849704000	17397	8812	9	0	1148
302572	1874	6379000	17397	8812	9	0	2
34835	1678	20160708112000	17397	8812	11	0	0
135016	2134	97896700000	17398	8813	5	0	1100
302578	1874	6386000	17398	8813	5	0	2
54698	1727	13867188000000	17398	8813	10	0	7
302602	1874	6396000	17402	8814	0	0	2
302603	1874	6399000	17402	8814	1	0	2
5912	1394	220323454000000	17402	8814	2	0	0
135042	1397	1338499984000	17403	8815	0	0	10033
135047	2134	97891685000	17404	8816	2	0	1105
302609	1874	6409000	17404	8816	2	0	2
135051	1397	1338479982000	17406	8817	0	0	10035
135052	2133	97842690000	17406	8817	1	0	1155
302618	1874	6416000	17407	8818	2	0	2
135058	2134	97889679000	17407	8818	4	0	1107
302629	1678	20160708122000	17409	8819	1	0	0
135070	2133	97839684000	17409	8819	4	0	1158
15795	1471	17899735900000	17409	8819	5	0	4
302641	1874	6437000	17412	8820	2	0	2
135088	2133	97837680000	17416	8821	1	0	1160
3039	498	66721252000000	17416	8821	3	0	3
302654	1874	6450000	17418	8823	1	0	2
26302	1616	5040132410000	17418	8823	3	0	0
135094	2133	97834674000	17419	8824	0	0	1163
16482	1476	15840242000000	17419	8824	3	0	5
302667	1678	20160708125000	17422	8825	1	0	0
135108	2134	97879649000	17422	8825	4	0	1117
302679	928	505508850559092	17424	8826	1	0	0
135119	2134	97878646000	17424	8826	3	0	1118
43598	1689	13680499287625	17424	8826	5	0	7
302689	1678	20160708128000	17426	8827	3	0	0
135129	2134	97876640000	17426	8827	5	0	1120
16776	1489	14304063000000	17426	8827	8	0	4
302696	1678	20160708129000	17428	8828	0	0	0
135137	2133	97829664000	17429	8829	1	0	1168
15370	1467	10046738100039	17429	8829	3	0	4
302702	1516	593364520000	17430	8830	1	0	11
135142	2133	97828662000	17430	8830	3	0	1169
135275	1397	1338339968000	17434	8831	0	0	10049
302837	1678	20160708132000	17434	8831	0	0	0
135276	2134	97872628000	17434	8831	1	0	1124
302838	1874	6496000	17434	8831	1	0	2
30528	1656	16701656999990	17436	8832	4	0	4
135306	1397	1338309965000	17441	8833	1	0	10052
302868	1678	20160708135000	17441	8833	1	0	0
40178	1685	117362415571430	17441	8833	7	0	0
135323	1397	1338299964000	17444	8834	0	0	10053
302885	1678	20160708136000	17444	8834	0	0	0
135324	2134	97868616000	17444	8834	1	0	1128
302886	1874	6514000	17444	8834	1	0	2
28689	1637	204485562819988	17444	8834	2	0	0
135336	2133	97823652000	17446	8835	5	0	1174
302898	1874	6524000	17446	8835	5	0	2
135350	1693	14291746841724	17450	8837	3	0	775
302912	620	66613938193897	17450	8837	3	0	0
135355	1693	13051671659117	17450	8837	8	0	780
302917	520	66613938193897	17450	8837	8	0	0
135361	2134	97864604000	17450	8837	14	0	1132
302923	1874	6530000	17450	8837	14	0	2
135490	1397	1338239958000	17452	8838	0	0	10059
303052	1678	20160708142000	17452	8838	0	0	0
135491	1693	12719770905625	17452	8838	1	0	784
303053	392	66613938193897	17452	8838	1	0	0
135497	1693	12387870152133	17453	8839	1	0	788
303059	91	66613938193897	17453	8839	1	0	0
135510	1397	1338219956000	17455	8840	0	0	10061
303072	1678	20160708144000	17455	8840	0	0	0
135515	1693	11211049269155	17455	8840	5	0	797
303077	1772	4389917417867	17455	8840	5	0	1
135521	1397	1338199954000	17456	8841	3	0	10063
303083	1678	20160708146000	17456	8841	3	0	0
135527	1693	10630222950544	17456	8841	9	0	804
303089	395	66110897193897	17456	8841	9	0	2
135532	1693	9740493172656	17456	8841	14	0	809
303094	146	66613938193897	17456	8841	14	0	0
16938	1494	720154000000	17456	8841	20	0	0
135609	1397	1338189953000	17459	8842	0	0	10064
303171	1678	20160708147000	17459	8842	0	0	0
135610	1397	1338179952000	17459	8842	1	0	10065
303172	1678	20160708148000	17459	8842	1	0	0
135616	1693	9242642042418	17459	8842	7	0	815
303178	658	66613938193897	17459	8842	7	0	0
135622	2133	97816638000	17459	8842	13	0	1181
303184	1874	6559000	17459	8842	13	0	2
51954	1711	16364734000000	17459	8842	17	0	9
135627	1693	6615470122780	17460	8843	1	0	822
303189	622	66616918193897	17460	8843	1	0	1
135633	2133	97814634000	17460	8843	7	0	1183
303195	1874	6569000	17460	8843	7	0	2
58251	1850	12158991000000	17460	8843	10	0	5
135710	2134	97854574000	17465	8844	4	0	1142
303272	1874	6580000	17465	8844	4	0	2
135874	1693	6200594180915	17469	8845	0	0	827
303436	54	66613938193897	17469	8845	0	0	0
135875	1693	6194298939379	17469	8845	1	0	828
303437	710	5046510469181	17469	8845	1	0	0
135881	1397	1338129947000	17472	8846	3	0	10070
303443	1678	20160708153000	17472	8846	3	0	0
135887	1693	5284077156597	17472	8846	9	0	837
303449	320	66332738193897	17472	8846	9	0	2
135892	1693	3819654922605	17472	8846	14	0	842
303454	390	66613938193897	17472	8846	14	0	0
135898	1693	3019077752324	17472	8846	20	0	848
303460	560	66613938193897	17472	8846	20	0	0
135904	2133	97812630000	17472	8846	26	0	1185
303466	1874	6588000	17472	8846	26	0	2
135938	2133	97810626000	17475	8847	2	0	1187
303500	1874	6598000	17475	8847	2	0	2
8526	1395	58062144809007706	17475	8847	4	0	0
135944	1397	1338089943000	17477	8849	2	0	10074
303506	1678	20160708157000	17477	8849	2	0	0
135950	2133	97807620000	17477	8849	8	0	1190
303512	1874	6613000	17477	8849	8	0	2
35121	1679	15334886853000	17477	8849	9	0	48
135971	1693	2355276245340	17480	8850	4	0	856
303533	1962	612850369124	17480	8850	4	0	1
135985	1693	2106350680221	17482	8851	2	0	859
303547	402	66613938193897	17482	8851	2	0	0
136028	1693	1774449926729	17488	8852	0	0	863
303590	680	66613938193897	17488	8852	0	0	0
136029	1693	1691474738356	17488	8852	1	0	864
303591	690	66613938193897	17488	8852	1	0	0
136035	2133	97804614000	17488	8852	7	0	1193
303597	1874	6628000	17488	8852	7	0	2
136041	1693	1274074699883	17489	8853	5	0	870
303603	420	66083228193897	17489	8853	5	0	2
10628	1402	56734692319298	17489	8853	10	0	33
136062	1693	1191099511510	17492	8854	1	0	871
303624	191	66613938193897	17492	8854	1	0	0
136068	2134	97842538000	17492	8854	7	0	1154
303630	1874	6638000	17492	8854	7	0	2
136076	2134	97839529000	17496	8857	1	0	1157
303638	1874	6647000	17496	8857	1	0	2
54256	1724	8587330000000	17497	8858	2	0	9
136085	1397	1337969931000	17501	8860	0	0	10086
303647	1678	20160708169000	17501	8860	0	0	0
136091	1397	1337959930000	17502	8861	0	0	10087
303653	1678	20160708170000	17502	8861	0	0	0
136103	1397	1337939928000	17505	8863	0	0	10089
303665	1678	20160708172000	17505	8863	0	0	0
136108	2133	97794594000	17505	8863	5	0	1203
303670	1874	6684000	17505	8863	5	0	2
136123	2133	97792590000	17509	8865	4	0	1205
303685	1874	6694000	17509	8865	4	0	2
45356	1692	22820102619999	17509	8865	5	0	5
303689	1874	6696000	17510	8866	3	0	2
303690	1874	6698000	17510	8866	4	0	2
136129	2134	97829499000	17510	8866	5	0	1167
136156	1397	1337869921000	17513	8867	0	0	10096
136157	2134	97826490000	17513	8867	1	0	1170
303719	1874	6712000	17513	8867	1	0	2
136169	1397	1337839918000	17518	8870	0	0	10099
303731	1678	20160708182000	17518	8870	0	0	0
11476	1419	27099576280064	17518	8870	4	0	3
303743	1678	20160708184000	17523	8872	0	0	0
136182	2134	97821475000	17523	8872	1	0	1175
39272	1684	18720565880623	17523	8872	3	0	70
136189	2134	97820472000	17525	8873	4	0	1176
303751	1874	6736000	17525	8873	4	0	2
136195	1397	1337769911000	17526	8874	2	0	10106
303757	1678	20160708189000	17526	8874	2	0	0
303762	1874	6755000	17526	8874	7	0	2
136201	2134	97816460000	17526	8874	8	0	1180
136206	2133	97779564000	17528	8876	1	0	1218
303768	1874	6765000	17528	8876	1	0	2
136222	2133	97777560000	17531	8877	2	0	1220
303784	1874	6778000	17531	8877	2	0	2
11989	1423	4353299999985	17531	8877	4	0	15
303789	1874	6785000	17533	8879	1	0	2
136228	2134	97810442000	17533	8879	2	0	1186
136245	2134	97809439000	17535	8880	4	0	1187
303807	1874	6791000	17535	8880	4	0	2
136251	2134	97807433000	17535	8880	11	0	1189
303813	1874	6805000	17535	8880	11	0	2
32267	1672	20882149000000	17535	8880	13	0	5
303824	1678	20160708200000	17539	8882	0	0	0
136263	2134	97804424000	17539	8882	1	0	1192
303825	1874	6816000	17539	8882	1	0	2
303826	1874	6818000	17539	8882	2	0	2
55374	1740	15045300000000	17539	8882	3	0	11
136273	1397	1337649899000	17542	8883	0	0	10118
136274	1397	1337639898000	17542	8883	1	0	10119
303840	1874	6828000	17542	8883	5	0	2
136290	2134	97801415000	17545	8884	1	0	1195
42234	1688	47591976708000	17547	8885	3	0	36
303862	1678	20160708205000	17549	8886	0	0	0
136302	2134	97799409000	17549	8886	2	0	1197
51673	1710	18234658473290	17549	8886	3	0	6
303870	1874	6846000	17551	8887	2	0	2
136328	2133	97763532000	17558	8888	1	0	1234
303900	1874	6856000	17561	8889	2	0	2
5931	1394	224643479000000	17561	8889	3	0	0
136343	2133	97761528000	17563	8890	1	0	1236
303915	1874	6864000	17565	8891	2	0	2
136355	2133	97759524000	17565	8891	4	0	1238
303920	1874	6874000	17566	8892	1	0	2
19547	1546	14400942000000	17566	8892	3	0	6
136369	1397	1337529887000	17571	8893	0	0	10130
303935	1874	6883000	17571	8893	4	0	2
1831	338	66720000000000	17571	8893	6	0	0
136421	1397	1337509885000	17575	8894	0	0	10132
303983	1678	20160708215000	17575	8894	0	0	0
136422	2134	97789379000	17575	8894	1	0	1207
303984	1874	6889000	17575	8894	1	0	2
394	43	78960801890000	17575	8894	3	0	1
136440	2133	97753512000	17581	8896	1	0	1244
304002	1874	6898000	17581	8896	1	0	2
13226	1444	16415225159999	17581	8896	3	0	5
136473	2134	97786370000	17586	8897	4	0	1210
304035	1874	6906000	17586	8897	4	0	2
49867	1703	7920782000000	17586	8897	10	0	3
136478	1397	1337449879000	17587	8898	0	0	10138
304040	1678	20160708221000	17587	8898	0	0	0
136492	1494	144000000	17590	8899	0	0	1
304054	1950	11889851000000	17590	8899	0	0	14
57321	1764	12966946100000	17590	8899	2	0	8
304098	1678	20160708223000	17594	8900	0	0	0
304099	1678	20160708224000	17594	8900	1	0	0
136540	2134	97780352000	17594	8900	4	0	1216
59039	1992	12959321990000	17595	8901	2	0	0
304105	1874	6941000	17595	8901	3	0	2
136669	1397	1337399874000	17597	8902	0	0	10143
136670	2134	97778346000	17597	8902	1	0	1218
304233	1874	6946000	17597	8902	2	0	2
18659	1522	13294184000000	17597	8902	3	0	10
136850	1397	1337389873000	17602	8903	0	0	10144
304412	1678	20160708227000	17602	8903	0	0	0
136851	2134	97777343000	17602	8903	1	0	1219
304413	1874	6949000	17602	8903	1	0	2
40186	1685	119522452571430	17602	8903	2	0	0
136876	1397	1337349869000	17607	8905	3	0	10148
304438	1678	20160708231000	17607	8905	3	0	0
136882	2133	97739484000	17607	8905	9	0	1258
304444	1874	6968000	17607	8905	9	0	2
5945	1394	227523504000000	17608	8906	3	0	0
136899	2133	97738482000	17612	8907	2	0	1259
304461	1874	6976000	17612	8907	2	0	2
136911	2133	97735476000	17616	8909	1	0	1262
304473	1874	6985000	17616	8909	1	0	2
47948	1696	14897414835100	17618	8910	4	0	5
136927	2134	97768316000	17622	8911	1	0	1228
304489	1874	6996000	17622	8911	1	0	2
136938	1397	1337269861000	17626	8913	0	0	10156
304500	1678	20160708239000	17626	8913	0	0	0
304505	1874	7013000	17626	8913	5	0	2
136962	1397	1337249859000	17631	8914	0	0	10158
304524	1678	20160708241000	17631	8914	0	0	0
136963	2134	97764304000	17631	8914	1	0	1232
2082	369	81941434000000	17631	8914	4	0	4
137090	1397	1337239858000	17633	8915	0	0	10159
304652	1678	20160708242000	17633	8915	0	0	0
137091	2134	97763301000	17633	8915	1	0	1233
304653	1874	7021000	17633	8915	1	0	2
53612	1719	15140596000000	17633	8915	3	0	5
137100	2133	97726458000	17636	8917	1	0	1271
304662	1874	7030000	17636	8917	1	0	2
137233	1397	1337209855000	17640	8918	0	0	10162
304795	1678	20160708245000	17640	8918	0	0	0
137234	2133	97725456000	17640	8918	1	0	1272
304796	1874	7035000	17640	8918	1	0	2
5954	1394	231843540000000	17640	8918	4	0	0
14208	1451	12138980000000	17642	8919	4	0	9
137243	1397	1337189853000	17643	8920	1	0	10164
304805	1678	20160708247000	17643	8920	1	0	0
8536	1395	58064304883007706	17643	8920	5	0	0
137270	1726	118055109000	17647	8921	2	0	8189
304832	2167	200000000	17647	8921	2	0	0
137275	1397	1337169851000	17648	8922	0	0	10166
304837	1678	20160708249000	17648	8922	0	0	0
137281	2133	97721448000	17648	8922	6	0	1276
304843	1874	7065000	17648	8922	6	0	2
59380	2039	16561444000000	17648	8922	7	0	1
45391	1692	24260147619999	17650	8923	3	0	5
137411	1397	1337129847000	17652	8924	0	0	10170
304973	1678	20160708253000	17652	8924	0	0	0
137412	2134	97752268000	17652	8924	1	0	1244
304974	1874	7071000	17652	8924	1	0	2
137434	2134	97749259000	17660	8927	1	0	1247
304996	1874	7080000	17660	8927	1	0	2
15823	1471	19339820900000	17661	8928	5	0	4
137444	1397	1337059840000	17663	8929	1	0	10177
305006	1678	20160708260000	17663	8929	1	0	0
4169	632	71901188000000	17663	8929	5	0	5
137455	1397	1337039838000	17668	8931	0	0	10179
305017	1678	20160708262000	17668	8931	0	0	0
47687	1695	14012285000000	17669	8932	2	0	5
137586	1397	1337019836000	17672	8933	0	0	10181
305148	1678	20160708264000	17672	8933	0	0	0
137587	2134	97741235000	17672	8933	1	0	1255
305149	1874	7104000	17672	8933	1	0	2
8550	1395	58066464928007706	17672	8933	2	0	0
137603	2134	97740232000	17674	8934	5	0	1256
305165	1874	7107000	17674	8934	5	0	2
58501	1933	2283214000000	17674	8934	10	0	2
137613	2134	97735217000	17677	8935	1	0	1261
305175	1874	7122000	17677	8935	1	0	2
305185	1874	7128000	17680	8937	1	0	2
137624	1397	1336929827000	17681	8938	0	0	10190
305186	1678	20160708273000	17681	8938	0	0	0
23205	1593	17830225000000	17681	8938	3	0	4
137633	2134	97731205000	17684	8939	2	0	1265
137634	1397	1336909825000	17685	8940	0	0	10192
305197	1874	7137000	17685	8940	1	0	2
137659	1397	1336859820000	17689	8941	4	0	10197
305222	1678	20160708281000	17689	8941	5	0	0
137665	2134	97727193000	17689	8941	10	0	1269
305227	1874	7146000	17689	8941	10	0	2
137670	2134	97722178000	17689	8941	15	0	1274
21535	1564	11346435000000	17689	8941	16	0	5
305251	1678	20160708284000	17692	8942	0	0	0
137698	2134	97719169000	17694	8943	3	0	1277
305261	1678	20160708287000	17695	8944	0	0	0
137704	1397	1336759810000	17697	8946	1	0	10207
305266	1678	20160708290000	17697	8946	1	0	0
8556	1395	58068624961007706	17697	8946	6	0	0
137711	2134	97713151000	17699	8947	0	0	1283
625	45	66000000001300	17699	8947	2	1	0
305278	1678	20160708292000	17702	8948	0	0	0
137729	1397	1336709805000	17708	8950	0	0	10212
305292	1874	7197000	17708	8950	1	0	2
137742	2134	97708136000	17713	8952	2	0	1288
305304	1874	7203000	17713	8952	2	0	2
31841	1671	14448471530515	17713	8952	4	0	4
137747	2134	97705127000	17714	8953	3	0	1291
305318	1678	20160708301000	17717	8954	0	0	0
305321	1874	7218000	17717	8954	3	0	2
5970	1394	236163584000000	17717	8954	5	0	0
137774	1726	113215109000	17720	8955	0	0	8193
305336	2171	200000000	17720	8955	0	0	0
137775	1397	1336629797000	17720	8955	1	0	10220
305342	1874	7227000	17720	8955	6	0	2
56785	1759	15840809999889	17720	8955	7	0	7
137788	1397	1336609795000	17722	8956	0	0	10222
5291	733	2720000000000	17723	8957	3	0	0
305361	1678	20160708307000	17726	8958	0	0	0
137800	2133	97717440000	17726	8958	1	0	1280
305366	1874	7242000	17727	8959	2	0	2
137805	2133	97716438000	17727	8959	3	0	1281
305372	1874	7253000	17728	8960	1	0	2
137811	2133	97714434000	17728	8960	2	0	1283
28698	1637	205205585819988	17728	8960	4	0	0
13832	1448	7956761000001	17730	8961	4	0	8
305393	1678	20160708312000	17732	8962	0	0	0
137832	1397	1336529787000	17732	8962	1	0	10230
305398	1874	7271000	17732	8962	5	0	2
137837	338	66720014000000	17733	8963	0	0	1
137843	2133	97709424000	17733	8963	6	0	1288
305404	1874	7281000	17733	8963	6	0	2
28701	1637	205925585819988	17733	8963	8	0	0
137849	2134	97689079000	17734	8964	4	0	1307
305410	1874	7290000	17734	8964	5	0	2
137861	1397	1336469781000	17736	8965	2	0	10236
305421	1678	20160708320000	17736	8965	3	0	0
137867	2133	97705416000	17736	8965	8	0	1292
305427	1874	7305000	17736	8965	9	0	2
137873	2134	97684064000	17737	8966	3	0	1312
305433	1874	7316000	17737	8966	4	0	2
44288	1690	120243825000000	17737	8966	8	0	0
137930	1397	1336429777000	17747	8967	0	0	10240
305489	1678	20160708323000	17747	8967	0	0	0
137931	1397	1336419776000	17747	8967	1	0	10241
305490	1678	20160708324000	17747	8967	1	0	0
137943	2134	97681055000	17749	8968	1	0	1315
305502	1874	7332000	17749	8968	1	0	2
138025	1397	1336389773000	17754	8970	0	0	10244
305582	1678	20160708327000	17754	8970	0	0	0
31193	1668	18686768000000	17754	8970	3	0	5
138030	2133	97696398000	17755	8971	2	0	1301
305587	1874	7350000	17755	8971	2	0	2
17791	1509	15791929851155	17755	8971	4	0	5
138036	2133	97695396000	17756	8972	4	0	1302
305593	1874	7353000	17756	8972	4	0	2
305594	1874	7355000	17756	8972	5	0	2
138041	2134	97675037000	17756	8972	9	0	1321
138042	2134	97674034000	17756	8972	10	0	1322
305600	1874	7370000	17756	8972	11	0	2
58282	1850	14319061000000	17759	8973	3	0	5
138087	2134	97672028000	17765	8974	1	0	1324
305645	1874	7380000	17765	8974	2	0	2
138093	2133	97689384000	17766	8975	4	0	1308
305650	1874	7385000	17766	8975	4	0	2
138098	2134	97669019000	17767	8976	2	0	1327
305656	1874	7396000	17767	8976	3	0	2
5978	1394	240483643000000	17767	8976	7	0	0
138111	2134	97667013000	17769	8977	1	0	1329
305669	1874	7407000	17769	8977	2	0	2
45426	1692	25700195619999	17769	8977	3	0	5
138132	2131	199000000	17771	8978	4	0	1
305687	1874	7410000	17771	8978	6	0	2
138137	2134	97665007000	17771	8978	9	0	1331
305693	1874	7424000	17771	8978	12	0	2
138143	1397	1336219756000	17772	8979	0	0	10261
305699	1874	7433000	17772	8979	3	0	2
138153	1397	1336189753000	17774	8980	2	0	10264
305708	1874	7436000	17774	8980	4	0	2
138158	2134	97660995000	17774	8980	7	0	1335
305724	1678	20160708348000	17776	8981	0	0	0
138174	2133	97677360000	17776	8981	3	0	1320
57142	1762	18322026994000	17776	8981	5	0	4
305729	1874	7457000	17777	8982	1	0	2
138177	2134	97656983000	17777	8982	2	0	1339
305730	1874	7460000	17777	8982	2	0	2
138178	1397	1336159750000	17780	8984	0	0	10267
305736	1874	7468000	17780	8984	5	0	2
138184	1397	1336139748000	17781	8985	0	0	10269
53058	1717	13788058000023	17781	8985	3	0	4
305742	1874	7478000	17782	8986	2	0	2
138202	1397	1336119746000	17789	8987	0	0	10271
305773	1678	20160708356000	17795	8988	1	0	0
138221	2133	97670346000	17795	8988	2	0	1327
42332	1688	50472047708000	17795	8988	7	0	36
305779	1874	7497000	17796	8989	0	0	2
138227	2133	97668342000	17796	8989	1	0	1329
305785	1874	7505000	17797	8990	4	0	2
138233	1397	1336069741000	17798	8991	0	0	10276
305799	1874	7513000	17802	8992	1	0	2
138247	2133	97665336000	17802	8992	2	0	1332
138269	2134	97645950000	17807	8993	5	0	1350
305819	1874	7523000	17807	8993	5	0	2
138276	2132	148674675000	17809	8994	4	0	325
305826	1874	7530000	17809	8994	4	0	2
138281	2133	97660326000	17809	8994	9	0	1337
305831	1874	7542000	17809	8994	9	0	2
8565	1395	58070065033007706	17809	8994	11	0	0
26948	1623	53282634899898	17810	8995	3	0	1
138298	2132	148673674000	17816	8997	1	0	326
305848	1874	7556000	17816	8997	1	0	2
138307	2133	97655316000	17820	8999	1	0	1342
305857	1874	7565000	17820	8999	1	0	2
44297	1690	121683876000000	17820	8999	4	0	0
138312	2134	97635920000	17821	9000	3	0	1360
305862	1874	7574000	17821	9000	3	0	2
5986	1394	244803693000000	17821	9000	4	0	0
5988	1394	244803706000000	17821	9000	5	0	0
138317	1397	1335989733000	17823	9001	0	0	10284
305867	1678	20160708367000	17823	9001	0	0	0
138318	2133	97653312000	17823	9001	1	0	1344
305868	1874	7576000	17823	9001	1	0	2
138324	2134	97633914000	17824	9002	4	0	1362
305874	1874	7586000	17824	9002	4	0	2
138349	1397	1335949729000	17831	9004	0	0	10288
305899	1678	20160708371000	17831	9004	0	0	0
1582	171	78230425524688	17831	9004	3	0	4
138368	2132	148670671000	17835	9006	2	0	329
305918	1874	7601000	17835	9006	2	0	2
138403	1397	1335909725000	17842	9007	1	0	10292
305953	1678	20160708375000	17842	9007	1	0	0
138409	2133	97644294000	17843	9008	1	0	1353
305959	1874	7623000	17843	9008	1	0	2
138437	2134	97624887000	17849	9009	2	0	1371
305987	1874	7632000	17849	9009	2	0	2
31606	1670	20161173000000	17851	9010	4	0	6
138449	2133	97641288000	17853	9011	2	0	1356
138450	2134	97622881000	17853	9011	3	0	1373
305998	1874	7642000	17853	9011	3	0	2
30811	1657	12961412000000	17853	9011	5	0	6
306125	1678	20160708380000	17856	9012	0	0	0
306126	1874	7644000	17856	9012	1	0	2
138585	1397	1335849719000	17858	9013	0	0	10298
138586	2134	97621878000	17858	9013	1	0	1374
14501	1455	8674049000000	17858	9013	3	0	5
306140	1678	20160708382000	17861	9014	0	0	0
306141	1874	7653000	17861	9014	1	0	2
138602	2132	148667668000	17863	9015	1	0	332
22232	1573	11499110000000	17863	9015	4	0	5
306155	1678	20160708384000	17865	9016	0	0	0
138648	1397	1335809715000	17867	9017	0	0	10302
306192	1874	7669000	17867	9017	3	0	2
138653	2133	97634274000	17867	9017	5	0	1363
306197	1678	20160708387000	17868	9018	0	0	0
138659	2134	97615860000	17868	9018	3	0	1380
306203	1874	7686000	17868	9018	6	0	2
22656	1587	21600704000000	17868	9018	10	0	7
138670	1397	1335759710000	17871	9019	0	0	10307
306214	1874	7698000	17871	9019	3	0	2
15123	1458	18813749908540	17871	9019	5	0	4
138675	2134	97611848000	17872	9020	1	0	1384
306219	1874	7705000	17873	9021	1	0	2
138685	2134	97609842000	17875	9022	1	0	1386
8570	1395	58071505045007706	17875	9022	4	0	0
8571	1395	58071505058007706	17875	9022	5	0	0
306233	1678	20160708394000	17877	9023	0	0	0
138698	1397	1335709705000	17879	9024	0	0	10312
306242	1874	7721000	17879	9024	3	0	2
138703	2134	97607836000	17879	9024	5	0	1388
306247	1874	7733000	17879	9024	8	0	2
138715	2133	97622250000	17882	9025	1	0	1375
138721	1397	1335659700000	17884	9026	1	0	10317
306262	1678	20160708400000	17884	9026	1	0	0
138722	2133	97621248000	17884	9026	2	0	1376
3480	576	81635861938283	17884	9026	7	0	4
306281	1678	20160708401000	17888	9027	0	0	0
138741	1397	1335639698000	17888	9027	1	0	10319
306282	1678	20160708402000	17888	9027	1	0	0
138759	2133	97619244000	17891	9028	3	0	1378
306300	1874	7763000	17891	9028	3	0	2
138771	2133	97616238000	17894	9029	2	0	1381
138900	1726	110795110000	17897	9030	0	0	8195
306439	2175	200000000	17897	9030	0	0	0
138901	1397	1335609695000	17897	9030	1	0	10322
306440	1678	20160708405000	17897	9030	1	0	0
138907	2134	97597806000	17897	9030	7	0	1398
306446	1874	7776000	17897	9030	7	0	2
138913	2133	97611228000	17897	9030	13	0	1386
306452	1874	7789000	17897	9030	13	0	2
138935	1397	1335549689000	17899	9031	1	0	10328
306474	1678	20160708411000	17899	9031	1	0	0
138948	1397	1335539688000	17901	9032	0	0	10329
306487	1678	20160708412000	17901	9032	0	0	0
138954	2134	97589782000	17901	9032	6	0	1406
306493	1874	7820000	17901	9032	6	0	2
2127	369	84101482000000	17901	9032	8	0	4
6003	1394	249123759000000	17906	9033	3	0	0
138994	2134	97587776000	17910	9034	0	0	1408
138995	2133	97605216000	17910	9034	1	0	1392
306547	1678	20160708414000	17913	9035	0	0	0
306548	1874	7832000	17913	9035	1	0	2
139013	2134	97585770000	17913	9035	5	0	1410
306560	1874	7844000	17915	9036	1	0	2
139025	2133	97601208000	17916	9037	2	0	1396
306566	1874	7852000	17916	9037	4	0	2
52199	1714	14566454103056	17916	9037	7	0	7
139033	1397	1335479682000	17918	9038	0	0	10335
306574	1874	7862000	17918	9038	2	0	2
139039	2132	148655656000	17921	9040	1	0	344
306580	1874	7870000	17921	9040	3	0	2
139045	1397	1335439678000	17923	9042	0	0	10339
306586	1874	7880000	17923	9042	2	0	2
139056	2133	97594194000	17926	9043	2	0	1403
306600	1874	7887000	17928	9044	1	0	2
139078	1397	1335409675000	17932	9045	0	0	10342
306618	1874	7895000	17932	9045	4	0	2
139084	2134	97574737000	17932	9045	6	0	1421
306624	1874	7907000	17933	9046	3	0	2
139097	1397	1335379672000	17937	9047	0	0	10345
306640	1874	7914000	17939	9048	1	0	2
139106	2134	97571728000	17939	9048	3	0	1424
4196	632	74061235000000	17939	9048	5	0	5
410	43	79680826890000	17941	9049	5	0	1
306649	1678	20160708431000	17942	9050	0	0	0
139115	2133	97586178000	17942	9050	1	0	1411
58844	1991	17755939441475	17942	9050	3	0	12
4682	633	83164122900000	17944	9051	4	0	5
139144	1397	1335329667000	17948	9052	0	0	10350
306679	1678	20160708433000	17948	9052	0	0	0
139145	1397	1335319666000	17948	9052	1	0	10351
306681	1874	7936000	17948	9052	2	0	2
306682	1874	7938000	17948	9052	3	0	2
139151	1397	1335309665000	17949	9053	0	0	10352
306688	1874	7949000	17949	9053	2	0	2
50630	1706	11012192600135	17949	9053	4	0	20
139157	1397	1335289663000	17951	9055	0	0	10354
306694	1874	7959000	17951	9055	2	0	2
24119	1599	14740241393047	17951	9055	4	0	4
139162	2133	97579164000	17952	9056	1	0	1418
41024	1687	4940096223172	17952	9056	4	0	6
139292	1397	1335269661000	17955	9057	0	0	10356
306823	1678	20160708439000	17955	9057	0	0	0
139293	2134	97561698000	17955	9057	1	0	1434
306824	1874	7968000	17955	9057	1	0	2
60399	2176	719000000000	17955	9057	3	0	0
60400	2176	719012000000	17955	9057	4	0	0
30219	1654	17565177999798	17957	9058	5	0	7
139365	1397	1335249659000	17960	9059	0	0	10358
306887	1678	20160708441000	17960	9059	0	0	0
139465	1397	1335229657000	17962	9060	0	0	10360
306978	1678	20160708443000	17962	9060	0	0	0
139466	1397	1335219656000	17962	9060	1	0	10361
306979	1678	20160708444000	17962	9060	1	0	0
3170	529	66720025000000	17962	9060	8	0	0
139472	1397	1335209655000	17963	9061	0	0	10362
306985	1678	20160708445000	17963	9061	0	0	0
139498	2133	97571148000	17966	9062	3	0	1426
307011	1874	8004000	17966	9062	3	0	2
139503	2134	97552671000	17966	9062	8	0	1443
307016	1874	8016000	17966	9062	8	0	2
6011	1394	253443796000000	17968	9063	3	0	0
42390	1688	51912104708000	17971	9064	3	0	36
139530	1397	1335139648000	17974	9065	0	0	10369
307043	1678	20160708452000	17974	9065	0	0	0
139536	2134	97550665000	17974	9065	6	0	1445
307049	1874	8033000	17974	9065	6	0	2
139537	2134	97549662000	17974	9065	7	0	1446
139550	1688	43559771908000	17977	9066	0	0	37
307066	1874	8041000	17977	9066	3	0	2
28708	1637	208085644819988	17977	9066	4	0	0
139556	2132	148645646000	17978	9067	2	0	354
307081	1678	20160708456000	17981	9068	1	0	0
139571	2134	97546653000	17981	9068	4	0	1449
42147	1688	44279771908000	17981	9068	6	0	37
307087	2177	21671722800000	17982	9069	1	0	0
139576	2132	148644645000	17982	9069	3	0	355
307089	1874	8058000	17982	9069	3	0	2
307090	1874	8060000	17982	9069	4	0	2
45448	1692	27140293619999	17982	9069	9	0	5
139582	1397	1335059640000	17983	9070	1	0	10377
307096	2177	23219780000000	17983	9070	2	0	0
139588	2133	97557120000	17983	9070	7	0	1440
307102	2177	26927880000000	17984	9071	0	0	0
139593	2134	97540635000	17984	9071	4	0	1455
307107	1874	8087000	17984	9071	6	0	2
139599	2134	97538629000	17985	9072	2	0	1457
52594	1715	41040732000002	17985	9072	3	0	0
307113	2177	54143319399541	17986	9073	1	0	0
139605	1677	0	17987	9074	1	0	3
307119	1874	8103000	17987	9074	3	0	2
139613	2133	97552110000	17989	9075	2	0	1445
307132	2178	200000000	17991	9076	1	0	0
139624	1726	108375110000	17992	9077	0	0	8197
307138	1678	20160708469000	17992	9077	2	0	0
139630	2134	97533614000	17992	9077	6	0	1462
307144	1874	8124000	17992	9077	8	0	2
139635	2133	97548102000	17992	9077	11	0	1449
307149	1874	8133000	17993	9078	1	0	2
139742	1397	1334939628000	17997	9079	0	0	10389
307253	1678	20160708472000	17997	9079	0	0	0
139743	2133	97546098000	17997	9079	1	0	1451
307254	1874	8137000	17997	9079	1	0	2
8582	1395	58073665095007706	17998	9080	3	0	0
139759	2133	97544094000	18001	9081	2	0	1453
307270	1874	8144000	18001	9081	2	0	2
41768	1688	31679385908000	18001	9081	5	0	38
139771	2134	97527596000	18005	9083	3	0	1468
307282	1874	8153000	18005	9083	3	0	2
30844	1657	15121469990100	18005	9083	7	0	6
139792	2133	97541088000	18008	9084	2	0	1456
307303	1874	8161000	18008	9084	2	0	2
139806	420	66000217193897	18011	9085	4	0	4
307317	2164	612599000000	18011	9085	4	0	1
139823	1397	1334859620000	18015	9087	0	0	10397
139824	2133	97538082000	18015	9087	1	0	1459
307337	1874	8180000	18015	9087	3	0	2
139833	1397	1334839618000	18018	9089	0	0	10399
307345	1874	8187000	18018	9089	1	0	2
139845	1804	1400000000	18021	9090	3	0	1
307357	1678	20160708484000	18022	9091	0	0	0
139850	2133	97533072000	18022	9091	4	0	1464
307361	1874	8200000	18022	9091	4	0	2
307362	1874	8203000	18022	9091	5	0	2
6017	1394	257763888000000	18023	9092	3	0	0
139856	2132	148635636000	18024	9093	1	0	364
307368	1874	8211000	18024	9093	2	0	2
48378	1698	17097118550035	18024	9093	5	0	7
139864	2134	97514557000	18027	9095	1	0	1481
58310	1850	16479110000000	18027	9095	2	0	5
307376	1678	20160708490000	18028	9096	0	0	0
139878	2134	97512551000	18032	9097	1	0	1483
28718	1637	210245693819988	18032	9097	2	0	0
307406	1678	20160708492000	18035	9098	0	0	0
139906	2132	148633634000	18037	9099	1	0	366
307415	1874	8237000	18037	9099	2	0	2
139935	1397	1334689603000	18043	9102	0	0	10414
307439	1874	8246000	18043	9102	1	0	2
36057	1680	13689596500035	18043	9102	3	0	6
139945	1397	1334679602000	18046	9103	1	0	10415
139946	2134	97505530000	18046	9103	2	0	1490
307450	1678	20160708499000	18047	9104	0	0	0
8591	1395	58075825129007706	18047	9104	3	0	0
44920	1691	15083198100019	18051	9105	3	0	5
139959	1397	1334649599000	18052	9106	0	0	10418
307463	1678	20160708502000	18052	9106	1	0	0
139965	2134	97500515000	18054	9107	2	0	1495
307484	1678	20160708504000	18059	9108	0	0	0
139985	2134	97499512000	18059	9108	4	0	1496
307489	1874	8273000	18059	9108	5	0	2
5363	1271	1346286388000000	18059	9108	6	0	0
307502	1678	20160708506000	18062	9109	0	0	0
307503	1678	20160708507000	18062	9109	1	0	0
140003	2134	97496503000	18062	9109	4	0	1499
307511	1678	20160708508000	18065	9110	1	0	0
35060	1679	12958819653000	18066	9111	1	0	50
140011	1397	1334559590000	18067	9112	0	0	10427
307521	1678	20160708511000	18070	9113	0	0	0
51010	1708	12995828000021	18070	9113	2	0	4
140028	1397	1334539588000	18074	9114	0	0	10429
307534	1874	8296000	18074	9114	3	0	2
140034	1397	1334499584000	18075	9115	2	0	10433
307540	1874	8305000	18075	9115	5	0	2
140040	1397	1334479582000	18076	9116	1	0	10435
307546	1874	8313000	18076	9116	4	0	2
140045	2134	97485470000	18077	9117	1	0	1510
307556	1874	8320000	18080	9118	2	0	2
6024	1394	262083943000000	18082	9119	2	0	0
140059	1397	1334439578000	18084	9120	0	0	10439
307565	1874	8324000	18084	9120	3	0	2
140065	2134	97480455000	18084	9120	6	0	1515
140094	1397	1334409575000	18088	9121	0	0	10442
140095	2134	97479452000	18088	9121	1	0	1516
140221	1397	1334399574000	18090	9122	0	0	10443
307723	1678	20160708526000	18090	9122	0	0	0
140228	1397	1334389573000	18093	9123	0	0	10444
307730	1678	20160708527000	18093	9123	0	0	0
40200	1685	121682499571430	18093	9123	3	0	0
140234	2134	97476443000	18095	9125	1	0	1519
307736	1874	8346000	18095	9125	1	0	2
40885	1686	16772158550062	18095	9125	2	0	9
8596	1395	58077985151007706	18097	9126	3	0	0
140242	1397	1334339568000	18099	9128	0	0	10449
307744	1678	20160708532000	18099	9128	0	0	0
140247	1397	1334309565000	18101	9130	1	0	10452
307749	1678	20160708535000	18101	9130	1	0	0
28726	1637	211684726819988	18102	9131	3	0	0
140253	2132	148620621000	18103	9132	1	0	379
307755	1874	8367000	18103	9132	1	0	2
307769	1678	20160708539000	18108	9134	1	0	0
307770	1874	8376000	18108	9134	2	0	2
21228	1560	16434378277001	18108	9134	4	0	15
140285	1397	1334259560000	18110	9135	0	0	10457
44311	1690	123843933000000	18110	9135	4	0	0
49076	1700	16866016276737	18111	9136	2	0	6
140331	1397	1334239558000	18117	9137	0	0	10459
307833	1678	20160708542000	18117	9137	0	0	0
140337	2134	97463404000	18117	9137	6	0	1532
307839	1874	8389000	18117	9137	6	0	2
140359	1397	1334189553000	18121	9138	0	0	10464
307861	1678	20160708547000	18121	9138	0	0	0
140360	2132	148617618000	18121	9138	1	0	382
1607	171	80390489524688	18121	9138	3	0	4
307867	1874	8409000	18122	9139	3	0	2
140371	1397	1334159550000	18125	9140	0	0	10467
307936	1678	20160708552000	18127	9141	0	0	0
140435	1397	1334129547000	18127	9141	1	0	10470
307937	1678	20160708553000	18127	9141	1	0	0
140440	2134	97452371000	18127	9141	6	0	1543
307950	1678	20160708555000	18129	9142	0	0	0
140456	2134	97449362000	18131	9143	1	0	1546
307959	1874	8436000	18131	9143	2	0	2
51389	1709	12960198999976	18134	9144	2	0	7
140583	1397	1334069541000	18137	9145	0	0	10476
308075	1678	20160708559000	18137	9145	0	0	0
140584	1397	1334059540000	18137	9145	1	0	10477
308076	1678	20160708560000	18137	9145	1	0	0
140597	1397	1334039538000	18139	9146	0	0	10479
308089	1678	20160708562000	18139	9146	0	0	0
26183	1613	16488002600000	18141	9147	3	0	6
140610	2134	97442341000	18143	9148	2	0	1553
308102	1874	8458000	18143	9148	2	0	2
140619	1397	1333989533000	18147	9150	0	0	10484
308111	1678	20160708567000	18147	9150	0	0	0
140794	2165	190000000	18154	9152	0	0	1
140795	1397	1333969531000	18154	9152	1	0	10486
308282	1678	20160708569000	18154	9152	1	0	0
308283	1678	20160708570000	18154	9152	2	0	0
140801	2133	97529064000	18154	9152	7	0	1468
308289	1874	8478000	18154	9152	8	0	2
140807	2134	97436323000	18154	9152	14	0	1559
308295	1874	8492000	18154	9152	15	0	2
11497	1419	29259670280064	18154	9152	16	0	3
140826	1397	1333909525000	18156	9153	3	0	10492
308313	1874	8493000	18156	9153	5	0	2
308314	1874	8496000	18156	9153	6	0	2
140832	2134	97431308000	18156	9153	9	0	1564
308320	1874	8511000	18156	9153	12	0	2
4991	641	80740194000000	18156	9153	15	0	12
140845	1397	1333879522000	18158	9154	1	0	10495
308333	1874	8521000	18158	9154	4	0	2
140850	2132	148608609000	18158	9154	6	0	391
23240	1593	19990286000000	18158	9154	8	0	4
308345	1874	8526000	18160	9155	2	0	2
140863	2134	97427296000	18160	9155	5	0	1568
308355	1874	8539000	18162	9156	2	0	2
140877	2165	80000000	18164	9157	1	0	3
140882	1397	1333829517000	18165	9158	0	0	10500
308365	1874	8547000	18165	9158	2	0	2
6034	1394	266403978000000	18165	9158	3	0	0
140888	2133	97514034000	18166	9159	3	0	1483
29881	1650	9394172000000	18166	9159	5	0	5
308370	1678	20160708585000	18167	9160	0	0	0
8605	1395	58080145208007706	18167	9160	3	0	0
140894	1397	1333779512000	18168	9161	2	0	10505
308376	1874	8559000	18168	9161	3	0	2
140897	2133	97512030000	18168	9161	5	0	1485
140898	2133	97511028000	18168	9161	6	0	1486
308382	1874	8574000	18168	9161	9	0	2
44319	1690	126004038000000	18168	9161	11	0	0
140907	2133	97509024000	18170	9162	2	0	1488
308390	1678	20160708591000	18171	9163	1	0	0
140913	2134	97417266000	18171	9163	5	0	1578
308402	1678	20160708593000	18173	9164	1	0	0
140929	1397	1333719506000	18175	9165	0	0	10511
308413	1874	8598000	18175	9165	3	0	2
140935	2165	30000000	18176	9166	1	0	8
308418	1678	20160708599000	18176	9166	5	0	0
140941	2134	97412251000	18176	9166	7	0	1583
308426	1678	20160708600000	18179	9167	0	0	0
140948	2134	97408239000	18179	9167	1	0	1587
46165	1693	2299210758018	18179	9167	2	0	875
308457	1678	20160708602000	18189	9170	0	0	0
308458	1678	20160708603000	18189	9170	1	0	0
140980	2134	97406233000	18189	9170	2	0	1589
308502	1874	8631000	18200	9171	2	0	2
141024	2134	97403224000	18200	9171	3	0	1592
24559	1601	13610303620000	18200	9171	4	0	13
27166	1625	1440051000000	18201	9172	3	0	0
141045	1397	1333589493000	18205	9173	0	0	10524
141046	1740	15765332000000	18205	9173	1	0	12
308524	1899	1997000000	18205	9173	3	0	2
141064	1397	1333579492000	18211	9175	0	0	10525
308540	1678	20160708609000	18211	9175	1	0	0
141070	2134	97399212000	18211	9175	6	0	1596
308546	1874	8651000	18211	9175	7	0	2
141092	2132	148597598000	18215	9176	1	0	402
308571	1874	8661000	18219	9177	1	0	2
141107	2157	195000000	18219	9177	3	0	5
6039	1394	269284028000000	18219	9177	6	0	0
997	58	88266613999641	18221	9178	2	0	7
141187	1397	1333499484000	18224	9179	0	0	10533
308642	1678	20160708616000	18224	9179	0	0	0
141188	1397	1333489483000	18224	9179	1	0	10534
308643	1678	20160708617000	18224	9179	1	0	0
141194	2157	191000000	18225	9180	2	0	7
308649	1929	1302000000	18225	9180	2	0	1
141323	1397	1333469481000	18228	9181	0	0	10536
308771	1678	20160708619000	18228	9181	0	0	0
141324	2157	189960000	18228	9181	1	0	8
308772	1929	1302040000	18228	9181	1	0	1
8615	1395	58082305255007706	18229	9182	4	0	0
141330	1397	1333449479000	18230	9183	0	0	10538
308778	1678	20160708621000	18230	9183	0	0	0
41833	1688	33839430908000	18232	9184	3	0	38
308858	1678	20160708623000	18234	9185	0	0	0
308859	1874	8688000	18234	9185	1	0	2
141425	1397	1333419476000	18237	9186	0	0	10541
141439	1397	1333389473000	18242	9188	1	0	10544
308877	1678	20160708627000	18242	9188	1	0	0
141441	2134	97384167000	18242	9188	3	0	1611
141442	2134	97383164000	18242	9188	4	0	1612
32283	1672	23042168000000	18245	9189	2	0	5
308890	1678	20160708629000	18246	9190	0	0	0
141455	1397	1333349469000	18247	9191	1	0	10548
308895	1874	8708000	18247	9191	3	0	2
141461	1397	1333329467000	18248	9192	0	0	10550
308901	1874	8721000	18248	9192	2	0	2
24153	1599	16900318393047	18252	9193	2	0	4
141499	1397	1333309465000	18254	9194	0	0	10552
308940	1874	8730000	18255	9195	1	0	2
40209	1685	123122556571430	18255	9195	3	0	0
141510	2134	97373134000	18258	9196	2	0	1622
308956	1874	8737000	18261	9197	1	0	2
22247	1573	12939145000000	18261	9197	3	0	5
141522	1397	1333249459000	18263	9199	1	0	10558
308962	1874	8744000	18263	9199	3	0	2
6045	1394	273604073000000	18263	9199	6	0	0
141527	2134	97368119000	18264	9200	1	0	1627
308970	1874	8754000	18266	9201	2	0	2
141537	1397	1333209455000	18269	9203	0	0	10562
27388	1633	13716670985638	18269	9203	2	0	8
308977	1874	8760000	18270	9204	1	0	2
141543	2134	97364107000	18271	9205	3	0	1631
308993	1678	20160708649000	18274	9206	0	0	0
308994	1678	20160708650000	18274	9206	1	0	0
141558	2134	97361098000	18274	9206	3	0	1634
46299	1693	3739244758018	18274	9206	5	0	875
309000	1874	8777000	18275	9207	2	0	2
56226	1749	7045303930000	18275	9207	4	0	18
141564	1397	1333129447000	18276	9208	0	0	10570
309010	1874	8787000	18279	9209	1	0	2
26960	1623	55442703899898	18279	9209	3	0	1
141574	2134	97356083000	18280	9210	1	0	1639
14771	1457	17184388040000	18280	9210	3	0	4
31876	1671	15888517530515	18281	9211	3	0	4
141577	1397	1333089443000	18282	9212	0	0	10574
309015	1678	20160708657000	18282	9212	0	0	0
141578	1397	1333079442000	18282	9212	1	0	10575
309021	1874	8803000	18283	9213	1	0	2
141663	1397	1333059440000	18285	9214	0	0	10577
8621	1395	58084465290007706	18285	9214	3	0	0
309113	1678	20160708661000	18288	9215	2	0	0
141676	1397	1333039438000	18288	9215	3	0	10579
309118	1678	20160708663000	18289	9216	0	0	0
141681	1643	1226180514700	18289	9216	1	0	20
18123	1513	28800866000000	18289	9216	6	0	0
309124	1678	20160708664000	18290	9217	0	0	0
141687	2134	97347056000	18290	9217	1	0	1648
56001	1747	7216908000000	18290	9217	3	0	5
309133	1678	20160708665000	18293	9218	0	0	0
309134	1874	8823000	18293	9218	1	0	2
141705	2134	97345050000	18296	9219	1	0	1650
141716	1397	1332989433000	18302	9220	0	0	10584
141717	2132	148581582000	18302	9220	1	0	418
309156	1929	1311243001	18302	9220	2	0	1
12269	1426	20445116000000	18302	9220	3	0	4
32854	1675	14542241999977	18306	9221	2	0	4
141730	2157	172256999	18307	9222	2	0	12
26619	1622	19980415000005	18307	9222	3	0	5
309207	946	505554325000000	18310	9223	0	0	0
141774	1397	1332949429000	18310	9223	5	0	10588
309212	1678	20160708671000	18310	9223	5	0	0
141779	2134	97341038000	18310	9223	10	0	1654
309218	1874	8842000	18310	9223	11	0	2
141785	2132	148579580000	18310	9223	16	0	420
309224	1726	105955111000	18310	9223	17	0	8199
27709	1634	19631892641004	18310	9223	19	0	9
24869	1602	15120524000000	18311	9224	2	0	5
141797	2118	1396000000	18314	9225	1	0	3
309235	1726	105956112000	18314	9225	1	0	8199
141858	369	83119112000000	18317	9226	0	0	9
309296	946	505560945000000	18317	9226	0	0	0
141859	369	83107162000000	18317	9226	1	0	10
309297	1066	905960815000000	18317	9226	1	0	0
141865	2134	97335020000	18317	9226	7	0	1660
309303	1874	8860000	18317	9226	7	0	2
49631	1702	9360330000000	18319	9227	2	0	3
141877	1397	1332849419000	18323	9229	0	0	10598
309315	1678	20160708681000	18323	9229	0	0	0
141882	2132	148576577000	18325	9231	1	0	423
309320	1874	8877000	18325	9231	1	0	2
12901	1440	15839312049920	18325	9231	2	0	6
44326	1690	128164072000000	18329	9232	5	0	0
141904	1397	1332799414000	18331	9233	0	0	10603
309342	1678	20160708686000	18331	9233	0	0	0
47322	1694	20892680127629	18331	9233	5	0	34
141910	2134	97324990000	18332	9234	1	0	1670
309348	1874	8893000	18332	9234	1	0	2
141915	2132	148574575000	18333	9235	4	0	425
309353	1874	8900000	18333	9235	4	0	2
141921	2132	148573574000	18336	9238	2	0	426
309359	1874	8904000	18336	9238	2	0	2
10664	1402	58894705319298	18338	9239	2	0	33
141932	1397	1332689403000	18342	9241	1	0	10614
309370	1678	20160708697000	18342	9241	1	0	0
141937	2157	170256999	18342	9241	6	0	14
309375	1874	8923000	18342	9241	8	0	2
52599	1715	42480803990002	18342	9241	10	1	0
141945	2134	97313957000	18345	9243	1	0	1681
6061	1394	277924109000000	18345	9243	6	0	0
309392	1678	20160708701000	18348	9244	0	0	0
141962	1397	1332629397000	18348	9244	2	0	10620
141974	1397	1332619396000	18350	9245	0	0	10621
309404	1678	20160708704000	18350	9245	0	0	0
309405	1874	8940000	18350	9245	1	0	2
141980	2134	97309945000	18350	9245	6	0	1685
141985	2132	148569570000	18352	9247	2	0	430
309411	1874	8947000	18352	9247	2	0	2
141986	2134	97307939000	18352	9247	3	0	1687
309417	1874	8959000	18354	9249	1	0	2
8629	1395	58086625336007706	18354	9249	2	0	0
141992	1397	1332559390000	18355	9250	0	0	10627
309425	1678	20160708712000	18357	9251	1	0	0
142001	2134	97301921000	18357	9251	3	0	1693
309431	1874	8973000	18359	9253	1	0	2
142012	1397	1332509385000	18363	9254	0	0	10632
57724	1768	16430822110000	18363	9254	2	0	6
309445	1874	8980000	18365	9255	3	0	2
142020	2134	97297909000	18365	9255	4	0	1697
142152	1397	1332469381000	18369	9257	0	0	10636
309577	1678	20160708719000	18369	9257	0	0	0
142153	1397	1332459380000	18369	9257	1	0	10637
309578	1678	20160708720000	18369	9257	1	0	0
54286	1724	10747375500000	18369	9257	5	0	9
142282	1397	1332449379000	18371	9258	0	0	10638
309702	1678	20160708721000	18371	9258	0	0	0
142283	2134	97293897000	18371	9258	1	0	1701
309703	1874	8996000	18371	9258	1	0	2
18693	1522	15454218000000	18371	9258	2	0	10
6068	1394	282244143000000	18374	9260	2	0	0
142294	2134	97290888000	18376	9261	1	0	1704
309714	1874	9005000	18376	9261	1	0	2
142422	1397	1332389373000	18382	9264	0	0	10644
309838	1678	20160708727000	18382	9264	0	0	0
142423	1397	1332379372000	18382	9264	2	0	10645
309839	1678	20160708728000	18382	9264	2	0	0
142429	2132	148562563000	18383	9265	2	0	437
309845	1874	9020000	18383	9265	2	0	2
17499	1508	16596553500009	18383	9265	5	0	6
142435	1397	1332329367000	18386	9267	1	0	10650
309851	1678	20160708733000	18386	9267	1	0	0
142443	2132	148561562000	18388	9268	2	0	438
309859	1874	9039000	18388	9268	2	0	2
6077	1394	286564187000000	18388	9268	3	0	0
58871	1991	19915983441475	18390	9269	2	0	12
47998	1696	17057447835100	18393	9270	3	0	5
142458	2134	97277849000	18395	9271	1	0	1717
309874	1874	9048000	18395	9271	1	0	2
2321	415	66720011000000	18397	9273	3	0	0
142464	1397	1332259360000	18398	9274	0	0	10657
309880	1678	20160708740000	18398	9274	0	0	0
15848	1471	21499842900000	18398	9274	3	0	4
142473	2134	97273837000	18400	9275	2	0	1721
309889	1874	9062000	18400	9275	2	0	2
142485	2132	148558559000	18404	9277	2	0	441
309901	1874	9072000	18404	9277	2	0	2
142494	2132	148557558000	18407	9279	2	0	442
309910	1874	9079000	18407	9279	2	0	2
142499	1926	1191000000	18409	9281	2	0	9
309915	1483	10000000	18409	9281	2	0	0
142511	2134	97264810000	18413	9283	2	0	1730
309927	1874	9094000	18413	9283	2	0	2
142527	2133	97506018000	18415	9284	5	0	1491
309943	1874	9100000	18415	9284	5	0	2
142529	2134	97262804000	18415	9284	7	0	1732
309945	1874	9105000	18415	9284	7	0	2
142530	2133	97504014000	18415	9284	8	0	1493
309946	1874	9107000	18415	9284	8	0	2
142553	2134	97259795000	18420	9286	1	0	1735
309969	1874	9118000	18420	9286	1	0	2
142593	1397	1332079342000	18423	9288	0	0	10675
310009	1678	20160708758000	18423	9288	0	0	0
142601	1397	1332059340000	18426	9290	0	0	10677
310017	1678	20160708760000	18426	9290	0	0	0
142661	2134	97255783000	18428	9291	3	0	1739
310077	1874	9144000	18428	9291	3	0	2
142665	1397	1332039338000	18430	9292	0	0	10679
310081	1678	20160708762000	18430	9292	0	0	0
142666	2133	97495998000	18430	9292	1	0	1501
310082	1874	9146000	18430	9292	1	0	2
8637	1395	58088785371007706	18430	9292	3	0	0
142693	2134	97252774000	18434	9293	4	0	1742
310109	1874	9156000	18434	9293	4	0	2
142821	1397	1332009335000	18436	9294	0	0	10682
310232	1678	20160708765000	18436	9294	0	0	0
142822	2134	97251771000	18436	9294	1	0	1743
310233	1874	9163000	18436	9294	1	0	2
16810	1489	16464409000000	18436	9294	3	0	4
142838	2132	148551552000	18441	9295	4	0	448
310249	1874	9171000	18441	9295	4	0	2
41953	1688	37439497908000	18441	9295	7	0	38
142847	2134	97248762000	18444	9297	1	0	1746
310258	1874	9181000	18444	9297	1	0	2
142855	1397	1331949329000	18447	9299	0	0	10688
310266	1678	20160708771000	18447	9299	0	0	0
6089	1394	290884223000000	18447	9299	4	0	0
142875	2134	97245753000	18452	9300	2	0	1749
310286	1874	9199000	18452	9300	2	0	2
142994	1397	1331929327000	18454	9301	0	0	10690
310405	1678	20160708773000	18454	9301	0	0	0
142995	2133	97484976000	18454	9301	1	0	1512
310406	1874	9201000	18454	9301	1	0	2
35092	1679	14398850653000	18454	9301	3	0	50
143019	1397	1331909325000	18462	9303	0	0	10692
310430	1678	20160708775000	18462	9303	0	0	0
143031	1397	1331879322000	18467	9305	1	0	10695
310442	1678	20160708778000	18467	9305	1	0	0
143036	2133	97479966000	18467	9305	6	0	1517
310447	1874	9228000	18467	9305	6	0	2
143049	2134	97239735000	18469	9306	5	0	1755
310460	1874	9233000	18469	9306	5	0	2
29714	1649	23324309999992	18469	9306	11	0	4
143060	1397	1331839318000	18472	9307	0	0	10699
310471	1678	20160708782000	18472	9307	0	0	0
143138	1397	1331829317000	18483	9308	0	0	10700
310549	1678	20160708783000	18483	9308	0	0	0
143139	1397	1331819316000	18483	9308	1	0	10701
310550	1678	20160708784000	18483	9308	1	0	0
143145	2172	198999000	18483	9308	7	0	1
310556	2131	194998000	18483	9308	7	0	5
59749	2087	4319107000000	18483	9308	9	0	1
143151	2134	97233717000	18484	9309	5	0	1761
310562	1874	9264000	18484	9309	5	0	2
143156	1397	1331769311000	18485	9310	0	0	10706
310567	1678	20160708789000	18485	9310	0	0	0
143162	2133	97468944000	18485	9310	6	0	1528
310573	1874	9289000	18485	9310	6	0	2
56444	1756	6913109545609	18485	9310	8	0	5
143184	1397	1331749309000	18489	9312	0	0	10708
310595	1678	20160708791000	18489	9312	0	0	0
143196	1397	1331729307000	18493	9314	0	0	10710
310607	1678	20160708793000	18493	9314	0	0	0
30562	1656	18861681999990	18493	9314	5	0	4
143202	2134	97224690000	18494	9315	2	0	1770
310613	1874	9313000	18494	9315	2	0	2
143212	1397	1331709305000	18497	9316	0	0	10712
143213	2131	193997000	18497	9316	1	0	6
310625	1874	9318000	18497	9316	2	0	2
310626	1874	9320000	18497	9316	3	0	2
143219	2134	97222684000	18498	9317	3	0	1772
310632	1678	20160708798000	18499	9318	1	0	0
143225	2134	97221681000	18499	9318	5	0	1773
143352	1397	1331669301000	18501	9319	0	0	10716
310763	1678	20160708799000	18501	9319	0	0	0
143353	2134	97219675000	18501	9319	1	0	1775
310764	1874	9339000	18501	9319	1	0	2
143362	1397	1331649299000	18504	9321	0	0	10718
310773	1678	20160708801000	18504	9321	0	0	0
143371	2133	97454916000	18506	9322	3	0	1542
310782	1874	9355000	18506	9322	3	0	2
143381	2133	97452912000	18511	9323	1	0	1544
310792	1874	9365000	18511	9323	1	0	2
15397	1467	11486762100039	18511	9323	3	0	4
143446	1726	102326112000	18515	9325	1	0	8202
310855	1874	9372000	18515	9325	2	0	2
32879	1675	15982287999977	18515	9325	6	0	4
143452	2185	199000000	18516	9326	2	0	1
310861	1874	9379000	18516	9326	3	0	2
143461	1397	1331569291000	18518	9327	0	0	10726
310870	1874	9389000	18518	9327	1	0	2
143470	2132	148538539000	18522	9329	3	0	461
310879	1874	9397000	18522	9329	4	0	2
51687	1710	20394784473290	18522	9329	8	0	6
143476	2134	97207639000	18523	9330	2	0	1787
143486	1397	1331529287000	18526	9331	0	0	10730
310893	1678	20160708813000	18526	9331	0	0	0
143487	2132	148537538000	18526	9331	1	0	462
25343	1608	18285713000000	18526	9331	4	0	4
310897	1678	20160708814000	18527	9332	0	0	0
310898	1874	9415000	18527	9332	1	0	2
143493	1397	1331509285000	18528	9333	0	0	10732
28740	1637	213844884819988	18528	9333	4	0	0
310904	1874	9425000	18529	9334	1	0	2
40217	1685	125282591571430	18529	9334	4	0	0
143499	1397	1331489283000	18530	9335	0	0	10734
6101	1394	295204248000000	18530	9335	3	0	0
310910	1678	20160708818000	18531	9336	1	0	0
143504	1397	1331469281000	18531	9336	2	0	10736
310915	1874	9441000	18531	9336	6	0	2
35132	1679	15838997653000	18531	9336	8	0	50
143510	1397	1331449279000	18532	9337	1	0	10738
310921	1874	9451000	18532	9337	5	0	2
143516	1397	1331439278000	18533	9338	0	0	10739
310938	1678	20160708824000	18537	9339	1	0	0
143534	2133	97433874000	18537	9339	2	0	1563
310943	1874	9468000	18537	9339	6	0	2
8651	1395	58090225420007706	18537	9339	8	0	0
143540	2133	97431870000	18538	9340	1	0	1565
310949	1874	9478000	18539	9341	2	0	2
143552	2132	148533534000	18542	9342	1	0	466
310961	1874	9487000	18543	9343	1	0	2
143557	2133	97428864000	18543	9343	2	0	1568
56244	1749	9205347930000	18546	9344	3	0	18
310976	2186	524057693786	18548	9345	0	0	0
143573	2134	97190588000	18548	9345	2	0	1804
6109	1394	299524284000000	18548	9345	4	0	0
310986	1678	20160708832000	18551	9347	0	0	0
143583	1397	1331319266000	18551	9347	2	0	10751
310992	1874	9508000	18551	9347	6	0	2
143588	2133	97423854000	18551	9347	7	0	1573
310997	1678	20160708835000	18552	9348	1	0	0
143594	2133	97422852000	18552	9348	3	0	1574
311003	1678	20160708839000	18554	9350	3	0	0
143600	2134	97184570000	18554	9350	5	0	1810
311009	1874	9537000	18554	9350	9	0	2
143605	2133	97419846000	18554	9350	10	0	1577
42017	1688	39599608908000	18554	9350	14	0	38
143621	1397	1331259260000	18556	9351	0	0	10757
143622	2133	97417842000	18556	9351	1	0	1579
311027	1874	9544000	18556	9351	1	0	2
143628	2134	97180558000	18557	9352	3	0	1814
311033	1874	9553000	18557	9352	3	0	2
25619	1610	14400532000000	18557	9352	5	0	6
311041	1678	20160708842000	18560	9353	0	0	0
143641	1397	1331219256000	18561	9354	2	0	10761
311047	1874	9561000	18561	9354	3	0	2
6116	1394	303844421000000	18561	9354	7	0	0
143646	1397	1331209255000	18562	9355	0	0	10762
53659	1719	16580683000000	18562	9355	3	0	5
311061	1126	907761861072558	18565	9356	0	0	0
143660	2134	97176546000	18565	9356	4	0	1818
311066	1874	9576000	18565	9356	5	0	2
22672	1587	24480727000000	18567	9357	2	0	7
143675	1397	1331169251000	18569	9358	1	0	10766
311081	1874	9584000	18569	9358	2	0	2
143684	2132	148526527000	18572	9359	3	0	473
6121	1394	306724667000000	18576	9360	2	0	0
311092	1678	20160708852000	18578	9361	0	0	0
143691	2132	148525526000	18579	9362	2	0	474
311097	1874	9595000	18579	9362	3	0	2
143697	1397	1331099244000	18581	9364	1	0	10773
311103	1874	9604000	18581	9364	2	0	2
60300	2148	2159068000000	18581	9364	5	0	0
143702	1397	1331069241000	18582	9365	2	0	10776
311109	1874	9610000	18582	9365	4	0	2
143708	1397	1331049239000	18583	9366	1	0	10778
311114	1874	9617000	18583	9366	2	0	2
143726	1397	1331029237000	18588	9368	1	0	10780
311132	1678	20160708864000	18588	9368	2	0	0
6122	1394	308164667000000	18588	9368	6	0	0
143735	1397	1331009235000	18591	9369	0	0	10782
49296	1701	12310398600056	18591	9369	2	0	9
143767	1397	1330999234000	18598	9370	0	0	10783
311172	1678	20160708866000	18598	9370	0	0	0
143768	1397	1330989233000	18598	9370	1	0	10784
311173	1678	20160708867000	18598	9370	1	0	0
8664	1395	58092385463007706	18598	9370	6	0	0
143777	1397	1330969231000	18602	9372	0	0	10786
311182	1678	20160708869000	18602	9372	0	0	0
57152	1762	20482071994000	18602	9372	3	0	4
143785	1397	1330939228000	18606	9375	0	0	10789
311190	1678	20160708872000	18606	9375	0	0	0
143799	2134	97151471000	18612	9377	1	0	1843
311204	1874	9657000	18612	9377	1	0	2
143822	1397	1330879222000	18614	9378	4	0	10795
311227	1678	20160708878000	18614	9378	4	0	0
143828	2134	97149465000	18614	9378	10	0	1845
311233	1874	9665000	18614	9378	10	0	2
143833	2134	97145453000	18614	9378	15	0	1849
311238	1874	9678000	18614	9378	15	0	2
8670	1395	58094545488007706	18617	9380	1	0	0
143840	2132	148516517000	18618	9381	1	0	483
311245	1874	9685000	18618	9381	1	0	2
143854	1397	1330789213000	18624	9384	0	0	10804
311259	1678	20160708887000	18624	9384	0	0	0
16530	1476	18000339000000	18624	9384	4	0	5
143859	1611	26029312550000	18625	9385	2	0	2
311264	975	504819475450000	18625	9385	2	0	0
46449	1693	5899312757818	18625	9385	6	0	875
143870	1397	1330739208000	18628	9387	1	0	10809
311275	1678	20160708892000	18628	9387	1	0	0
40225	1685	127442637571430	18628	9387	6	0	0
143881	2134	97133417000	18630	9388	2	0	1861
311286	1874	9717000	18630	9388	2	0	2
143894	1397	1330709205000	18633	9389	0	0	10812
143895	1397	1330699204000	18633	9389	1	0	10813
311301	1874	9724000	18633	9389	2	0	2
3511	576	83075920938283	18633	9389	5	0	4
311308	1678	20160708897000	18635	9390	0	0	0
311309	1678	20160708898000	18635	9390	1	0	0
143906	2134	97129405000	18635	9390	3	0	1865
8675	1395	58095985532007706	18635	9390	6	0	0
42077	1688	41759642908000	18636	9391	2	0	38
311315	1678	20160708900000	18637	9392	0	0	0
143912	1397	1330639198000	18637	9392	2	0	10819
311321	2190	1000000000	18637	9392	6	0	0
143917	2134	97124390000	18637	9392	7	0	1870
20229	1549	22656003000000	18637	9392	9	0	5
311330	1874	9750000	18639	9393	3	0	2
143927	42	76509360000000	18640	9394	1	0	8
311336	1874	9756000	18640	9394	5	0	2
23901	1596	18720972000000	18640	9394	8	0	11
143946	1397	1330599194000	18645	9395	0	0	10823
311362	1874	9763000	18648	9396	2	0	2
143958	2134	97118372000	18648	9396	3	0	1876
55415	1740	17205345000000	18650	9397	1	0	12
311369	1874	9773000	18651	9398	1	0	2
143966	2134	97115363000	18652	9399	1	0	1879
6132	1394	312484722000000	18652	9399	3	0	0
311375	1874	9780000	18653	9400	2	0	2
143988	1397	1330529187000	18657	9401	0	0	10830
311397	1874	9787000	18657	9401	4	0	2
143993	2134	97111351000	18657	9401	5	0	1883
311414	1678	20160708916000	18661	9403	0	0	0
144011	2157	1999	18661	9403	2	0	22
59399	2039	18721506000000	18661	9403	3	0	1
144058	1397	1330479182000	18664	9405	0	0	10835
311463	1678	20160708918000	18664	9405	0	0	0
144059	2134	97107339000	18664	9405	1	0	1887
311464	1874	9803000	18664	9405	1	0	2
144071	2134	97105333000	18670	9407	2	0	1889
311476	1874	9809000	18670	9407	2	0	2
144197	1474	13229404000023	18675	9408	0	0	17
311600	2192	1000000000	18675	9408	0	0	0
144198	1397	1330449179000	18675	9408	1	0	10838
311601	1678	20880720921000	18675	9408	1	0	0
28748	1637	216005029819988	18675	9408	4	0	0
144209	2134	97103327000	18678	9409	4	0	1891
311612	1874	9816000	18678	9409	4	0	2
49094	1700	18306081276737	18678	9409	6	0	6
42117	1688	43199676908000	18679	9410	4	0	38
144215	1397	1330399174000	18680	9411	2	0	10843
311618	1678	20880720926000	18680	9411	2	0	0
144220	2134	97100318000	18680	9411	7	0	1894
311623	1874	9827000	18680	9411	7	0	2
3913	606	78237895812962	18680	9411	11	0	12
144316	1397	1330369171000	18682	9412	0	0	10846
311719	1678	20880720929000	18682	9412	0	0	0
144317	1932	636819152658	18682	9412	1	0	3
311720	2196	1000000000	18682	9412	1	0	0
144328	1932	38809152658	18685	9413	1	0	4
311731	2196	599000000000	18685	9413	1	0	0
1324	149	84270283000341	18685	9413	4	0	5
144340	2134	97093297000	18691	9416	4	0	1901
311743	1874	9850000	18691	9416	4	0	2
2765	484	70028806000000	18691	9416	9	0	4
144352	2134	97090288000	18693	9417	2	0	1904
311755	1874	9859000	18693	9417	2	0	2
144412	1397	1330269161000	18701	9419	1	0	10856
311815	1678	20880720939000	18701	9419	1	0	0
144418	2132	148499500000	18702	9420	3	0	500
311821	1874	9876000	18702	9420	3	0	2
144427	2134	97082264000	18706	9422	1	0	1912
311830	1874	9885000	18706	9422	1	0	2
8683	1395	58098145787007706	18706	9422	3	0	0
144433	2134	97080258000	18707	9423	5	0	1914
311836	1874	9892000	18707	9423	5	0	2
144434	2134	97079255000	18707	9423	6	0	1915
311842	1874	9902000	18708	9424	4	0	2
144440	1397	1330169151000	18709	9425	0	0	10866
311872	1678	20880720950000	18712	9426	0	0	0
311873	1678	20880720951000	18712	9426	1	0	0
144474	2134	97076246000	18712	9426	5	0	1918
311879	1874	9909000	18712	9426	7	0	2
144489	1397	1330119146000	18714	9427	0	0	10871
52222	1714	16726515103056	18714	9427	3	0	7
311895	1678	20880720955000	18715	9428	0	0	0
26966	1623	57602826899898	18715	9428	2	0	1
144495	2134	97070228000	18716	9429	1	0	1924
311902	1874	9928000	18718	9430	1	0	2
144503	2134	97068222000	18719	9431	2	0	1926
311908	1678	20880720960000	18720	9432	0	0	0
144511	2132	148493494000	18722	9433	1	0	506
311917	1678	20880720963000	18723	9434	1	0	0
144517	2134	97064210000	18723	9434	4	0	1930
311928	1678	20880720964000	18726	9435	0	0	0
144529	2134	97061201000	18727	9436	1	0	1933
22882	1588	18935061000000	18727	9436	2	0	6
311936	1874	9958000	18729	9437	1	0	2
6139	1394	316804757000000	18729	9437	2	0	0
144541	2132	148491492000	18732	9439	2	0	508
311947	1678	20880720969000	18733	9440	0	0	0
144547	2134	97056186000	18733	9440	3	0	1938
23291	1593	22870431000000	18733	9440	5	0	4
311962	1678	20880720972000	18736	9441	1	0	0
144563	2134	97054180000	18736	9441	5	0	1940
144572	1397	1329919126000	18738	9442	0	0	10891
311975	1678	20880720974000	18738	9442	0	0	0
144573	2132	148489490000	18738	9442	1	0	510
311986	1678	20880720975000	18741	9443	0	0	0
311987	1678	20880720976000	18741	9443	1	0	0
144586	2134	97051171000	18741	9443	3	0	1943
44931	1691	16523254100019	18741	9443	6	0	5
311993	1874	9994000	18742	9444	2	0	2
144596	1397	1329879122000	18744	9445	0	0	10895
312003	1874	10001000	18745	9446	1	0	2
17818	1509	17231955851155	18745	9446	2	0	5
144601	1397	1329859120000	18746	9447	0	0	10897
56472	1756	8353149545609	18746	9447	3	0	5
312008	1874	10007000	18747	9448	2	0	2
144607	2132	148487488000	18747	9448	4	0	512
312017	1678	20880720985000	18750	9450	1	0	0
144616	2134	97041141000	18750	9450	3	0	1953
2140	369	85236695000000	18750	9450	5	0	12
53089	1717	15948116000023	18751	9451	2	0	4
312023	1678	20880720987000	18752	9452	0	0	0
144621	2134	97039135000	18752	9452	1	0	1955
312032	1874	10031000	18754	9453	3	0	2
144633	2134	97037129000	18756	9454	1	0	1957
8691	1395	58100305821007706	18758	9455	3	0	0
312042	1874	10038000	18759	9456	1	0	2
144656	1397	1329739108000	18765	9457	0	0	10909
45489	1692	29300328619999	18765	9457	4	0	5
144661	2134	97033117000	18766	9458	2	0	1961
312063	1874	10047000	18766	9458	2	0	2
42174	1688	45359820908000	18766	9458	4	0	38
312076	1874	10054000	18772	9460	2	0	2
144678	1397	1329699104000	18774	9461	0	0	10913
312086	1678	20880721000000	18776	9462	3	0	0
144686	850	1149782543924210	18776	9462	4	0	2
144691	2134	97026096000	18776	9462	10	0	1968
312092	1874	10070000	18776	9462	10	0	2
41087	1687	6380148223172	18776	9462	11	0	6
144705	1397	1329639098000	18782	9464	0	0	10919
144706	2134	97024090000	18782	9464	1	0	1970
312107	1874	10077000	18782	9464	1	0	2
144715	2132	148480481000	18785	9466	2	0	519
312116	1874	10084000	18785	9466	2	0	2
11521	1419	30699720280064	18785	9466	6	0	3
312124	1678	20880721006000	18787	9467	0	0	0
312125	1874	10093000	18787	9467	1	0	2
144726	1397	1329579092000	18788	9468	1	0	10925
312141	1678	20880721009000	18792	9469	0	0	0
144741	2134	97016066000	18792	9469	1	0	1978
14802	1457	20064422040000	18792	9469	2	0	4
312153	1874	10109000	18794	9470	4	0	2
144753	2132	148478479000	18794	9470	5	0	521
312158	1678	20880721015000	18795	9471	3	0	0
144759	2132	148477478000	18795	9471	5	0	522
312164	1874	10123000	18795	9471	9	0	2
144764	2134	97009045000	18795	9471	10	0	1985
44334	1690	130324126000000	18795	9471	11	0	0
50304	1705	13595592500145	18796	9472	3	0	20
312179	1874	10133000	18800	9473	1	0	2
144779	1397	1329469081000	18801	9474	0	0	10936
312184	1874	10139000	18802	9475	2	0	2
144785	2132	148475476000	18802	9475	4	0	524
35201	1679	17999077653000	18802	9475	6	0	50
312195	1874	10149000	18805	9477	1	0	2
6147	1394	319684802000000	18805	9477	3	0	0
144798	1397	1329419076000	18807	9478	0	0	10941
312221	1678	20880721026000	18814	9480	0	0	0
144821	1397	1329389073000	18814	9480	1	0	10944
28754	1637	218165063819988	18814	9480	5	0	0
312226	1678	20880721029000	18815	9481	0	0	0
24566	1601	15770372620000	18815	9481	1	0	13
144828	1397	1329349069000	18818	9483	0	0	10948
4219	632	75501246000000	18822	9485	1	0	5
312236	1678	20880721034000	18824	9486	0	0	0
144836	2132	148471472000	18824	9486	1	0	528
144843	1397	1329299064000	18830	9488	0	0	10953
50669	1706	13172278600135	18830	9488	2	0	20
144844	1397	1329289063000	18831	9489	0	0	10954
312247	1874	10163000	18831	9489	2	0	2
144850	2132	148469470000	18834	9492	1	0	530
6161	1394	324004833000000	18834	9492	3	0	0
312252	1678	20880721042000	18835	9493	0	0	0
54710	1727	16027212000000	18835	9493	2	0	7
29226	1643	1760532914700	18837	9494	1	0	21
312257	1874	10165000	18838	9495	2	0	2
17525	1508	18036609500009	18838	9495	4	0	6
144858	1397	1329199054000	18840	9496	0	0	10963
312259	1678	20880721046000	18840	9496	0	0	0
44337	1690	131044193000000	18841	9497	3	0	0
144863	1397	1329159050000	18843	9499	0	0	10967
312265	1678	20880721051000	18843	9499	1	0	0
40240	1685	129602658571430	18844	9500	1	0	0
144869	2132	148465466000	18845	9501	2	0	534
312274	1678	20880721055000	18847	9502	0	0	0
54082	1723	19799528085979	18847	9502	1	0	6
54315	1724	12187420500000	18849	9504	3	0	9
144882	1397	1329069041000	18855	9506	0	0	10976
312283	1678	20880721059000	18855	9506	0	0	0
39351	1684	22320619880623	18856	9507	2	0	70
144888	1397	1329029037000	18859	9509	0	0	10980
312290	1678	20880721064000	18860	9510	0	0	0
19879	1547	13533470000000	18860	9510	3	0	6
30258	1654	19725211999798	18863	9511	3	0	7
144899	1397	1328989033000	18864	9512	0	0	10984
312301	1678	20880721068000	18864	9512	1	0	0
8702	1395	58102465854007706	18866	9513	1	0	0
144913	1397	1328939028000	18871	9516	0	0	10989
312314	1678	20880721072000	18871	9516	0	0	0
8705	1395	58103185885007706	18871	9516	4	0	0
53680	1719	18740820000000	18872	9517	2	0	5
144991	1397	1328909025000	18877	9518	0	0	10992
8706	1395	58103905885007706	18877	9518	1	0	0
144992	1397	1328899024000	18878	9519	0	0	10993
312393	1678	20880721076000	18878	9519	0	0	0
312394	1678	20880721077000	18878	9519	1	0	0
11785	1422	10225063860211	18880	9521	2	0	7
144998	2132	148457458000	18881	9522	1	0	542
47723	1695	15452318999000	18881	9522	3	1	5
312400	1678	20880721081000	18882	9523	0	0	0
21565	1564	12786545000000	18884	9524	2	0	5
42227	1688	47519854908000	18885	9525	3	0	38
145005	1397	1328809015000	18887	9527	0	0	11002
312407	1678	20880721086000	18887	9527	1	0	0
145012	1397	1328769011000	18890	9529	1	0	11006
312414	1678	20880721090000	18891	9530	0	0	0
59064	1992	15119344990000	18897	9531	2	0	0
145032	2132	148453454000	18900	9533	1	0	546
24571	1601	17210404620000	18900	9533	3	0	13
312434	1678	20880721094000	18901	9534	0	0	0
47340	1694	21612703127629	18901	9534	1	0	34
2686	470	81120503000000	18903	9535	4	0	6
51054	1708	15155885000021	18906	9536	1	0	4
145049	1397	1328679002000	18907	9537	0	0	11015
312450	1678	20880721099000	18907	9537	1	0	0
145054	1397	1328638998000	18910	9538	0	0	11019
312455	1678	20880721103000	18911	9539	0	0	0
145064	2132	148449450000	18915	9541	1	0	550
312467	1678	20880721107000	18917	9542	0	0	0
14239	1451	14299004000000	18918	9543	2	0	9
145118	1397	1328548989000	18921	9545	0	0	11028
145121	1397	1328538988000	18924	9546	0	0	11029
312521	1678	20880721112000	18924	9546	0	0	0
10688	1402	61054761319298	18930	9549	1	0	33
312531	1678	20880721116000	18932	9550	0	0	0
145132	2132	148446447000	18932	9550	1	0	553
312532	1874	10187000	18932	9550	1	0	2
3115	526	69600085000000	18932	9550	3	0	0
53287	1718	9666808763340	18934	9551	1	0	9
45516	1692	31460369619999	18936	9552	2	0	5
145143	1397	1328448979000	18940	9555	0	0	11038
312543	1678	20880721121000	18940	9555	0	0	0
8716	1395	58105345946007706	18942	9556	4	0	0
145156	1474	13213364000023	18945	9557	0	0	21
312557	1678	20880721125000	18945	9557	1	0	0
44339	1690	131764193000000	18945	9557	2	0	0
24897	1602	18000575000000	18950	9559	1	0	5
145167	1397	1328368971000	18952	9560	0	0	11046
312567	1678	20880721129000	18952	9560	0	0	0
36086	1680	15849620500035	18954	9561	3	0	6
145176	1397	1328338968000	18957	9563	0	0	11049
312576	1678	20880721132000	18957	9563	0	0	0
145189	1397	1328308965000	18965	9566	0	0	11052
312594	1678	20880721136000	18968	9567	0	0	0
11547	1419	32859771280064	18970	9568	3	0	3
52867	1716	20206948000000	18971	9569	2	0	4
145207	1397	1328258960000	18975	9570	0	0	11057
312607	1678	20880721140000	18975	9570	0	0	0
145215	2132	148438439000	18977	9571	4	0	561
312615	1874	10195000	18977	9571	4	0	2
13274	1444	18575270159999	18982	9573	2	0	5
145233	1397	1328178952000	18988	9575	0	0	11065
312634	1095	904632174710000	18988	9575	1	0	0
145246	2132	148436437000	18994	9577	1	0	563
312646	1874	10197000	18994	9577	1	0	2
25871	1611	13743021000000	18994	9577	3	0	5
145249	1397	1328138948000	18997	9579	0	0	11069
145250	1397	1328128947000	18998	9580	0	0	11070
24180	1599	18340352393047	18998	9580	2	0	4
312686	1678	20880721155000	19006	9583	0	0	0
312687	1874	10199000	19006	9583	1	0	2
22679	1587	25920783000000	19006	9583	3	0	7
145290	1397	1328088943000	19009	9585	0	0	11074
58357	1850	19359168000000	19009	9585	1	0	5
49100	1700	19746104276737	19012	9586	3	0	6
312705	1874	10200000	19017	9587	1	0	2
29914	1650	11554208000000	19017	9587	3	0	5
145307	1474	15311354000023	19018	9588	1	0	22
312715	1874	10201000	19021	9589	3	0	2
145316	1397	1328028937000	19022	9590	0	0	11080
312722	1678	20880721167000	19026	9592	2	0	0
145324	2132	148431432000	19026	9592	4	0	568
6183	1394	328324864000000	19027	9593	3	0	0
312728	1678	20880721171000	19029	9595	0	0	0
145330	2132	148429430000	19029	9595	2	0	570
60004	2112	5759094000000	19029	9595	4	0	0
312736	1874	10205000	19034	9598	1	0	2
145337	1397	1327898924000	19035	9599	0	0	11093
44346	1690	133924233000000	19037	9601	1	0	0
312743	1874	10206000	19039	9602	1	0	2
145345	1397	1327848919000	19042	9604	0	0	11098
312749	1874	10207000	19042	9604	4	0	2
145357	1397	1327808915000	19044	9605	0	0	11102
312763	1678	20880721188000	19047	9606	0	0	0
145364	1397	1327768911000	19048	9607	0	0	11106
312768	1678	20880721192000	19049	9608	2	0	0
145370	2132	148423424000	19049	9608	4	0	576
6188	1394	332644885000000	19051	9609	1	0	0
312782	1874	10211000	19053	9610	2	0	2
145384	1397	1327678902000	19054	9611	1	0	11115
145385	1397	1327668901000	19054	9611	2	0	11116
145386	1397	1327658900000	19054	9611	3	0	11117
312788	1874	10212000	19054	9611	5	0	2
312813	2201	200000000	19063	9613	0	0	0
145414	1397	1327628897000	19063	9613	1	0	11120
312814	1678	20880721203000	19063	9613	1	0	0
145420	1726	86597112000	19063	9613	7	0	8215
312820	2207	200000000	19063	9613	7	0	0
145425	2205	199000000	19065	9615	1	0	1
312826	1874	10214000	19065	9615	2	0	2
439	43	81840848890000	19067	9616	2	0	1
145434	1397	1327578892000	19070	9618	0	0	11125
312837	1678	20880721209000	19073	9619	0	0	0
145446	2132	148417418000	19077	9622	1	0	582
312847	1678	20880721213000	19079	9623	0	0	0
145454	2204	100000000	19083	9626	0	0	1
5154	662	66720000000000	19083	9626	3	0	0
312859	1678	20880721218000	19085	9627	0	0	0
145468	2203	190000000	19085	9627	3	0	1
312870	1678	20880721221000	19088	9628	0	0	0
145483	1726	84177112000	19089	9629	0	0	8217
145488	2203	160000000	19089	9629	5	0	4
312876	1874	10219000	19089	9629	6	0	2
6199	1394	336964915000000	19089	9629	7	0	0
145521	2133	97411830000	19091	9630	2	0	1585
145522	2132	148413414000	19091	9630	3	0	586
312906	1874	10228000	19091	9630	5	0	2
145564	1397	1327378872000	19098	9632	0	0	11145
312946	1678	20880721228000	19098	9632	0	0	0
312947	1874	10236000	19098	9632	1	0	2
145582	1397	1327358870000	19102	9634	0	0	11147
312965	1678	20880721231000	19102	9634	1	0	0
145587	2133	97406820000	19102	9634	5	0	1590
6206	1394	341285000000000	19102	9634	6	0	0
312977	1874	10258000	19104	9635	1	0	2
14819	1457	21504446040000	19104	9635	3	0	4
145599	2134	96989988000	19105	9636	3	0	2004
312982	1678	20880721234000	19106	9637	1	0	0
145605	2133	97402812000	19106	9637	5	0	1594
52237	1714	18166584103056	19106	9637	9	0	7
312993	1678	20880721236000	19108	9638	0	0	0
145616	2203	130000000	19108	9638	2	0	7
312999	1874	10284000	19109	9639	1	0	2
145622	2200	801998000000	19109	9639	2	0	2
8727	1395	58108225968007706	19109	9639	3	0	0
313004	1874	10290000	19111	9641	1	0	2
40250	1685	131762699571430	19111	9641	2	0	0
145629	2134	96981964000	19113	9642	0	0	2012
32511	1673	24085496000000	19113	9642	2	0	10
28768	1637	220325115819988	19114	9643	0	0	0
145634	2134	96979958000	19116	9644	4	0	2014
313011	1874	10299000	19116	9644	4	0	2
42345	1688	51120013908000	19116	9644	7	0	38
145672	1397	1327208855000	19122	9646	0	0	11162
145673	1397	1327198854000	19122	9646	1	0	11163
313051	1874	10308000	19122	9646	2	0	2
145691	2134	96973940000	19129	9648	1	0	2020
313068	1874	10317000	19129	9648	1	0	2
313122	1678	20880721249000	19131	9649	0	0	0
313123	1678	20880721250000	19131	9649	1	0	0
145750	2134	96971934000	19131	9649	5	0	2022
21277	1560	18594426277001	19131	9649	7	0	15
313135	1678	20880721252000	19133	9650	1	0	0
145761	2132	148412413000	19133	9650	4	0	587
313141	1678	20880721254000	19134	9651	1	0	0
145767	2133	97399806000	19134	9651	4	0	1597
313146	1874	10341000	19134	9651	6	0	2
145773	1397	1327098844000	19135	9652	0	0	11173
313152	1874	10353000	19135	9652	2	0	2
145778	2134	96964913000	19136	9653	2	0	2029
313165	1874	10363000	19139	9654	2	0	2
145791	2134	96962907000	19140	9655	1	0	2031
145796	1397	1327058840000	19142	9656	0	0	11177
313173	1678	20880721260000	19142	9656	0	0	0
145797	1397	1327048839000	19142	9656	1	0	11178
313179	1874	10380000	19142	9656	6	0	2
145811	1397	1327038838000	19145	9657	0	0	11179
313193	1874	10390000	19146	9658	2	0	2
25651	1610	16560597019950	19146	9658	4	0	6
145817	1397	1327018836000	19147	9659	0	0	11181
8736	1395	58109666014007706	19147	9659	4	0	0
313202	1874	10397000	19149	9660	1	0	2
145826	2134	96956889000	19149	9660	2	0	2037
313208	1678	20880721269000	19150	9661	3	0	0
145832	1397	1326958830000	19150	9661	4	0	11187
313209	1678	20880721270000	19150	9661	4	0	0
313210	1874	10402000	19150	9661	5	0	2
145838	2134	96954883000	19150	9661	10	0	2039
313216	1874	10411000	19150	9661	11	0	2
145843	2133	97385778000	19150	9661	15	0	1611
313222	1874	10425000	19150	9661	17	0	2
145853	2133	97381770000	19152	9662	3	0	1615
313231	1874	10433000	19152	9662	4	0	2
51697	1710	22554829473290	19152	9662	5	0	6
6211	1394	344165074000000	19156	9663	5	0	0
145871	1397	1326928827000	19157	9664	0	0	11190
313249	1874	10441000	19157	9664	1	0	2
145879	2133	97378764000	19159	9665	2	0	1618
26975	1623	59762930899898	19159	9665	4	0	1
313264	1678	20880721275000	19161	9666	0	0	0
145891	2134	96945856000	19161	9666	4	0	2048
313269	1874	10457000	19161	9666	5	0	2
145903	2133	97375758000	19164	9667	2	0	1621
35242	1679	19439130653000	19164	9667	4	0	50
313291	1678	20880721278000	19167	9668	0	0	0
145918	2132	148404405000	19167	9668	4	0	595
313297	1874	10475000	19167	9668	6	0	2
42422	1688	53280063908000	19167	9668	8	0	38
145924	2134	96941844000	19168	9669	3	0	2052
313302	1874	10483000	19168	9669	4	0	2
145929	2134	96939838000	19169	9670	1	0	2054
145930	2133	97370748000	19169	9670	2	0	1626
313311	1678	20880721283000	19171	9671	0	0	0
145939	2133	97368744000	19172	9672	2	0	1628
51981	1711	18525315000000	19172	9672	3	0	9
313317	1678	21600733285000	19173	9673	0	0	0
145945	1397	1326788813000	19173	9673	5	0	11204
313322	1678	21600733287000	19173	9673	5	0	0
145950	2134	96935826000	19173	9673	10	0	2058
313328	1874	10512000	19173	9673	11	0	2
145956	2134	96933820000	19174	9674	2	0	2060
313334	1874	10523000	19174	9674	3	0	2
41151	1687	8540176223172	19174	9674	4	0	6
145968	2134	96931814000	19178	9676	1	0	2062
313345	1874	10531000	19178	9676	1	0	2
313346	1874	10533000	19178	9676	2	0	2
145973	2134	96930811000	19179	9677	3	0	2063
146105	1502	1439910000000	19182	9678	0	0	1
146106	1397	1326738808000	19182	9678	1	0	11209
313482	1678	21600733292000	19182	9678	1	0	0
313483	1874	10542000	19182	9678	2	0	2
146119	1397	1326718806000	19186	9680	1	0	11211
313495	1874	10550000	19186	9680	3	0	2
146125	2133	97358724000	19186	9680	7	0	1638
313512	1678	21600733296000	19189	9681	0	0	0
146142	1397	1326688803000	19190	9682	0	0	11214
313517	1874	10570000	19190	9682	2	0	2
6217	1394	348485123000000	19190	9682	4	0	0
146148	2134	96923790000	19191	9683	3	0	2070
313523	1874	10579000	19191	9683	5	0	2
146167	2133	97352712000	19195	9684	2	0	1644
313542	1874	10589000	19196	9685	1	0	2
146172	1397	1326628797000	19197	9686	1	0	11220
313547	1874	10595000	19197	9686	3	0	2
8746	1395	58111826152007706	19197	9686	7	0	0
146317	1397	1326618796000	19201	9687	0	0	11221
313688	1678	21600733304000	19201	9687	0	0	0
146318	1397	1326608795000	19201	9687	1	0	11222
313689	1678	21600733305000	19201	9687	1	0	0
146335	1397	1326598794000	19204	9688	0	0	11223
313706	1678	21600733306000	19204	9688	0	0	0
146337	2133	97346700000	19204	9688	2	0	1650
146338	2133	97345698000	19204	9688	3	0	1651
14525	1455	10834081000000	19204	9688	6	0	5
313712	1678	21600733308000	19205	9689	0	0	0
146344	1397	1326548789000	19205	9689	3	0	11228
313717	1874	10625000	19205	9689	5	0	2
146350	2163	1198999000000	19205	9689	9	0	1
313723	1874	10635000	19205	9689	11	0	2
146355	2133	97342692000	19205	9689	14	0	1654
313729	1678	21600733313000	19206	9690	0	0	0
146366	1397	1326518786000	19209	9691	0	0	11231
313739	1874	10657000	19209	9691	2	0	2
146372	2132	148393394000	19210	9692	3	0	606
313752	1874	10666000	19213	9693	1	0	2
313753	1874	10668000	19213	9693	2	0	2
313788	1678	21600733317000	19216	9694	0	0	0
146418	1397	1326478782000	19216	9694	1	0	11235
313794	1874	10670000	19216	9694	6	0	2
146424	2132	148392393000	19216	9694	7	0	607
313800	1874	10683000	19216	9694	12	0	2
146430	2134	96902727000	19216	9694	13	0	2091
313805	1874	10696000	19216	9694	17	0	2
146435	2133	97331670000	19216	9694	18	0	1665
313831	1874	10701000	19219	9695	3	0	2
146461	2133	97329666000	19219	9695	4	0	1667
313837	1874	10716000	19219	9695	10	0	2
146487	1397	1326398774000	19223	9696	0	0	11243
146488	1397	1326388773000	19223	9696	1	0	11244
313862	1874	10723000	19223	9696	4	0	2
313896	2213	200000000	19231	9697	0	0	0
146528	1397	1326378772000	19231	9697	1	0	11245
313897	1678	21600733328000	19231	9697	1	0	0
146535	2133	97323654000	19233	9698	2	0	1673
313904	1874	10737000	19233	9698	2	0	2
3653	599	67440024000000	19233	9698	4	0	0
146560	2133	97321650000	19242	9700	1	0	1675
313930	1874	10747000	19242	9700	2	0	2
6225	1394	352805159000000	19242	9700	4	0	0
146566	2133	97320648000	19243	9701	4	0	1676
313935	1874	10753000	19243	9701	4	0	2
146572	2133	97319646000	19244	9702	5	0	1677
313941	1874	10761000	19244	9702	5	0	2
146577	2132	148387388000	19245	9703	3	0	612
313950	2214	0	19247	9704	0	0	0
146589	2133	97315638000	19249	9705	2	0	1681
313958	1874	10776000	19249	9705	2	0	2
36344	1681	14183264759830	19249	9705	7	0	6
146595	2133	97313634000	19250	9706	1	0	1683
313964	1874	10787000	19250	9706	1	0	2
45542	1692	33620391619999	19253	9707	3	0	5
146606	1397	1326258760000	19254	9708	0	0	11257
313976	1678	21600733341000	19254	9708	1	0	0
146609	1592	33000000	19254	9708	3	0	2
146610	2134	96881664000	19254	9708	4	0	2112
313981	1874	10804000	19254	9708	6	0	2
32527	1673	26245546000000	19254	9708	9	0	10
146746	1397	1326238758000	19261	9709	0	0	11259
314113	1678	21600733342000	19261	9709	0	0	0
146747	1397	1326228757000	19261	9709	1	0	11260
314114	1678	21600733343000	19261	9709	1	0	0
146753	2134	96879658000	19261	9709	7	0	2114
314120	1874	10816000	19261	9709	7	0	2
6231	1394	357125216000000	19261	9709	10	0	0
146759	1397	1326198754000	19263	9711	0	0	11263
314126	1678	21600733346000	19263	9711	0	0	0
146764	2132	148383384000	19264	9712	2	0	616
314131	1874	10836000	19264	9712	2	0	2
146786	2134	96872637000	19267	9714	1	0	2121
314153	1874	10846000	19267	9714	1	0	2
56272	1749	10645382930000	19267	9714	4	0	18
314164	1678	21600733350000	19271	9715	0	0	0
314165	1874	10851000	19271	9715	1	0	2
42475	1688	55440160908000	19271	9715	3	0	38
146801	2132	148382383000	19272	9716	1	0	617
314171	1678	21600733352000	19273	9717	0	0	0
146806	2134	96869628000	19273	9717	2	0	2124
314186	1874	10869000	19277	9718	3	0	2
22084	1571	22320521001024	19277	9718	5	0	1
146821	1397	1326108745000	19278	9719	1	0	11272
314191	1874	10876000	19278	9719	4	0	2
16837	1489	18624453000000	19278	9719	6	0	4
146836	2134	96866619000	19281	9720	1	0	2127
314206	1874	10884000	19282	9721	1	0	2
146841	2134	96865616000	19282	9721	3	0	2128
314212	1874	10891000	19283	9722	3	0	2
146847	2133	97293594000	19283	9722	5	0	1703
314232	38	66083861377858	19286	9723	1	0	0
146868	1571	19682871786155	19286	9723	4	0	5
314238	1874	10903000	19286	9723	7	0	2
146881	2133	97290588000	19288	9724	1	0	1706
146882	2134	96861604000	19288	9724	2	0	2132
314252	1678	21600733363000	19289	9725	1	0	0
146888	2134	96859598000	19289	9725	4	0	2134
314257	2216	200000000	19289	9725	6	0	0
146894	1726	75761112000	19289	9725	10	0	8224
314263	2218	200000000	19289	9725	12	0	0
28779	1637	222485182819988	19289	9725	15	0	0
146899	1397	1326008735000	19290	9726	1	0	11282
314269	1874	10925000	19290	9726	4	0	2
146919	1397	1325998734000	19293	9727	0	0	11283
314288	1874	10935000	19293	9727	2	0	2
314297	1874	10936000	19296	9728	2	0	2
146931	2133	97284576000	19296	9728	3	0	1712
314298	1874	10938000	19296	9728	3	0	2
146939	2134	96853580000	19298	9729	1	0	2140
314307	1874	10951000	19298	9729	2	0	2
146945	2132	148376377000	19300	9731	1	0	623
314313	1874	10959000	19300	9731	2	0	2
48021	1696	18497471835100	19300	9731	4	0	5
146991	1571	18216450031949	19305	9734	0	0	7
314356	38	66119808346940	19305	9734	0	0	0
146996	1571	17121956673230	19305	9734	5	0	10
314362	1335	1697052733158970	19305	9734	6	0	0
147002	2134	96849568000	19305	9734	11	0	2144
314368	1874	10974000	19305	9734	12	0	2
147008	2132	148375376000	19305	9734	17	0	624
314373	1874	10986000	19305	9734	17	0	2
147031	1397	1325888723000	19307	9735	0	0	11294
147032	1397	1325878722000	19307	9735	1	0	11295
314398	1874	10994000	19307	9735	4	0	2
36361	1681	15623420759830	19307	9735	8	0	6
147045	2134	96843550000	19309	9736	0	0	2150
6242	1394	361445278000000	19309	9736	2	0	0
314411	1874	11007000	19310	9737	1	0	2
147051	1571	15581360560182	19311	9738	1	0	13
314416	1678	21600733380000	19311	9738	3	0	0
147056	2132	148373374000	19311	9738	6	0	626
314422	1874	11013000	19311	9738	9	0	2
3952	606	79678037812962	19311	9738	12	0	12
147062	2134	96840541000	19312	9739	1	0	2153
55792	1746	9154395000000	19312	9739	4	0	2
314436	1678	21600733382000	19316	9740	0	0	0
314437	1678	21600733383000	19316	9740	1	0	0
147077	2133	97267542000	19316	9740	4	0	1729
314443	1678	21600733384000	19317	9741	0	0	0
147082	1571	11993050635898	19317	9741	2	0	18
314449	1874	11034000	19317	9741	6	0	2
147096	1397	1325808715000	19319	9742	0	0	11302
11813	1422	12385138860211	19319	9742	4	0	7
314462	1678	21600733386000	19320	9743	0	0	0
147102	2132	148371372000	19320	9743	3	0	628
147274	1397	1325788713000	19323	9744	0	0	11304
314634	1678	21600733387000	19323	9744	0	0	0
147275	1397	1325778712000	19323	9744	1	0	11305
314635	1678	21600733388000	19323	9744	1	0	0
147281	2134	96833520000	19323	9744	7	0	2160
314641	1874	11059000	19323	9744	7	0	2
147287	1571	9528045254706	19324	9745	4	0	25
314647	1209	610330156151454	19324	9745	4	0	0
147289	2133	97260528000	19324	9745	6	0	1736
147290	2134	96831514000	19324	9745	7	0	2162
314683	1483	10000000	19328	9746	0	0	0
147327	2134	96830511000	19328	9746	4	0	2163
314689	1874	11075000	19328	9746	6	0	2
147333	2134	96828505000	19328	9746	10	0	2165
314705	1678	21600733394000	19330	9747	0	0	0
314706	1678	21600733395000	19330	9747	1	0	0
147349	1571	6925727350606	19330	9747	5	0	29
314712	1874	11086000	19330	9747	8	0	2
2333	417	66720073000000	19330	9747	12	0	0
147365	1397	1325698704000	19332	9748	0	0	11313
314728	1874	11097000	19332	9748	3	0	2
147379	1571	4722665150830	19335	9749	2	0	34
314741	1335	1702582504892146	19335	9749	4	0	0
147384	1397	1325668701000	19335	9749	7	0	11316
314747	1874	11105000	19335	9749	10	0	2
147390	2134	96823490000	19335	9749	13	0	2170
314753	1874	11113000	19336	9750	1	0	2
58887	1991	21356018441475	19336	9750	5	0	12
147399	1397	1325648699000	19338	9751	0	0	11318
314761	1874	11123000	19338	9751	2	0	2
147424	1397	1325628697000	19341	9752	1	0	11320
147425	1769	1582900000	19341	9752	2	0	51
147426	2132	148366367000	19341	9752	3	0	633
314781	1874	11132000	19341	9752	8	0	2
147432	2133	97247502000	19341	9752	9	0	1749
2812	484	72188829000000	19341	9752	10	0	4
10717	1402	63214791319298	19344	9753	3	0	33
314801	1874	11142000	19345	9754	1	0	2
147458	2133	97245498000	19345	9754	2	0	1751
6252	1394	365765442000000	19345	9754	3	0	0
314806	1874	11150000	19346	9755	3	0	2
147488	1397	1325588693000	19350	9756	0	0	11324
314839	1678	21600733409000	19354	9758	1	0	0
147500	1397	1325558690000	19354	9758	2	0	11327
314841	1678	21600733411000	19354	9758	3	0	0
314842	1874	11159000	19354	9758	4	0	2
147506	2134	96813460000	19354	9758	8	0	2180
314848	1874	11175000	19354	9758	10	0	2
42520	1688	57600268908000	19354	9758	12	0	38
147511	1397	1325528687000	19355	9759	1	0	11330
314854	1142	910452755600000	19355	9759	4	0	0
147517	2132	148363364000	19355	9759	7	0	636
314859	1874	11180000	19355	9759	9	0	2
147523	2133	97237482000	19355	9759	13	0	1759
13300	1444	20014359159999	19355	9759	16	0	6
147581	1397	1325508685000	19360	9760	0	0	11332
314920	1678	21600733415000	19360	9760	0	0	0
147582	2133	97235478000	19360	9760	1	0	1761
314930	1874	11203000	19362	9761	3	0	2
147592	1397	1325488683000	19363	9762	0	0	11334
314935	1874	11211000	19363	9762	4	0	2
39370	1684	23760663880623	19363	9762	6	0	70
147604	2133	97232472000	19366	9763	1	0	1764
6257	1394	367205454000000	19366	9763	3	0	0
6259	1394	367205466000000	19366	9763	4	0	0
314947	1874	11219000	19367	9764	2	0	2
147609	2134	96801424000	19367	9764	3	0	2192
314960	1874	11229000	19369	9765	1	0	2
147622	2134	96800421000	19369	9765	2	0	2193
314965	1874	11238000	19370	9766	4	0	2
147633	1397	1325418676000	19372	9767	0	0	11341
35289	1679	21599166653000	19372	9767	4	0	50
314988	1678	21600733425000	19378	9768	0	0	0
314989	1874	11245000	19378	9768	1	0	2
147653	2134	96797412000	19378	9768	2	0	2196
315008	1874	11254000	19384	9770	2	0	2
147672	2133	97224456000	19384	9770	3	0	1772
315018	1678	21600733430000	19387	9772	1	0	0
147682	1397	1325348669000	19387	9772	2	0	11348
315023	1874	11267000	19387	9772	6	0	2
147687	2134	96792397000	19387	9772	7	0	2201
315029	1874	11281000	19387	9772	12	0	2
147693	2132	148358359000	19387	9772	13	0	641
147709	1397	1325328667000	19391	9773	0	0	11350
147710	417	66000000000000	19391	9773	1	0	1
315050	1874	11288000	19391	9773	4	0	2
28785	1637	224645257819988	19391	9773	5	0	0
53107	1717	17388170000023	19392	9774	3	0	4
147718	2224	719053000000	19395	9775	0	0	1
315057	1874	11295000	19395	9775	2	0	2
147724	1504	657246000000	19396	9776	2	0	10
315075	1678	21600733436000	19400	9777	0	0	0
147741	2132	148356357000	19400	9777	3	0	643
54387	1724	17937471500000	19403	9778	2	0	9
315090	1678	21600733438000	19405	9779	0	0	0
147756	2134	96785376000	19405	9779	3	0	2208
8763	1395	58113986214007706	19405	9779	5	0	0
315098	1678	21600733439000	19407	9780	0	0	0
147890	1397	1325258660000	19409	9781	0	0	11357
315217	1678	21600733440000	19409	9781	0	0	0
147891	2134	96782367000	19409	9781	1	0	2211
315218	1874	11328000	19409	9781	1	0	2
147900	2134	96781364000	19411	9782	4	0	2212
315227	1874	11336000	19411	9782	4	0	2
147906	2134	96778355000	19413	9784	3	0	2215
315233	1874	11347000	19413	9784	3	0	2
147911	2134	96777352000	19414	9785	2	0	2216
315238	1874	11356000	19414	9785	2	0	2
8770	1395	58115426265007706	19416	9786	5	0	0
315250	1678	21600733447000	19418	9787	0	0	0
147924	2134	96775346000	19418	9787	1	0	2218
315251	1874	11365000	19418	9787	1	0	2
6267	1394	371525515000000	19418	9787	4	0	0
147940	2133	97202412000	19421	9788	4	0	1794
315265	1874	11373000	19421	9788	4	0	2
147955	2133	97200408000	19424	9789	2	0	1796
315281	1874	11382000	19424	9789	3	0	2
147965	2133	97198404000	19426	9790	2	0	1798
315290	1874	11393000	19426	9790	2	0	2
147969	2134	96769328000	19427	9791	2	0	2224
147970	2133	97197402000	19427	9791	3	0	1799
315299	1678	21600733454000	19429	9792	0	0	0
147979	1397	1325108645000	19430	9793	2	0	11372
315305	1678	21600733456000	19430	9793	3	0	0
147985	2133	97195398000	19430	9793	8	0	1801
315310	1874	11413000	19430	9793	8	0	2
147993	1397	1325078642000	19433	9795	0	0	11375
315319	1678	21600733459000	19433	9795	1	0	0
147999	2211	1021000000	19433	9795	6	0	3
315325	1874	11431000	19433	9795	7	0	2
18714	1522	17614262000000	19433	9795	8	0	10
148034	1397	1325038638000	19440	9797	1	0	11379
315359	1678	21600733462000	19440	9797	1	0	0
148039	2211	920000000	19440	9797	6	0	4
315365	1874	11440000	19440	9797	7	0	2
148045	2134	96758295000	19440	9797	12	0	2235
315371	1874	11454000	19440	9797	13	0	2
148051	1397	1324998634000	19441	9798	0	0	11383
315376	1678	21600733466000	19441	9798	0	0	0
148056	2225	717098000000	19442	9799	1	0	1
315382	1874	11471000	19442	9799	2	0	2
8776	1395	58117586303007706	19442	9799	5	0	0
315385	1874	11476000	19443	9800	1	0	2
315386	1874	11478000	19443	9800	2	0	2
148062	1397	1324968631000	19446	9802	0	0	11386
18372	1520	100000001	19446	9802	6	1	0
315418	1678	21600733471000	19451	9803	0	0	0
148094	2134	96751274000	19451	9803	1	0	2242
148104	2133	97179366000	19453	9804	4	0	1817
315429	1874	11494000	19453	9804	4	0	2
148105	2133	97178364000	19453	9804	5	0	1818
148106	2134	96750271000	19453	9804	6	0	2243
315434	1874	11505000	19453	9804	9	0	2
6281	1394	375845691000000	19453	9804	11	0	0
148112	2133	97176360000	19454	9805	2	0	1820
51083	1708	17315983000021	19454	9805	3	0	4
315443	1874	11515000	19456	9806	2	0	2
148121	2132	148344345000	19457	9807	2	0	655
315449	1678	21600733478000	19458	9808	1	0	0
148126	2134	96745256000	19458	9808	3	0	2248
315454	1874	11531000	19458	9808	6	0	2
148132	2133	97171350000	19458	9808	9	0	1825
315465	1874	11542000	19461	9809	2	0	2
49922	1703	10080815000000	19461	9809	3	0	3
148145	1397	1324838618000	19464	9811	0	0	11399
315473	1874	11550000	19464	9811	3	0	2
148154	2134	96740241000	19466	9812	1	0	2253
315482	1678	21600733485000	19467	9813	1	0	0
148160	2132	148341342000	19467	9813	4	0	658
315488	1874	11565000	19467	9813	7	0	2
148166	2133	97164336000	19467	9813	10	0	1832
315494	1874	11576000	19468	9814	2	0	2
42570	1688	59760341908000	19468	9814	3	0	38
148175	2133	97162332000	19471	9815	1	0	1834
10742	1402	64654837319298	19471	9815	4	0	33
315503	1874	11582000	19472	9816	1	0	2
21598	1564	14946584000000	19472	9816	5	0	5
148181	1397	1324758610000	19473	9817	0	0	11407
19910	1547	15693522000000	19473	9817	3	0	6
315509	1678	21600733491000	19474	9818	0	0	0
148187	1726	63751112000	19474	9818	3	0	8234
315515	1874	11597000	19474	9818	6	0	2
315521	1678	21600733492000	19476	9819	0	0	0
148197	2134	96731214000	19476	9819	1	0	2262
315522	1874	11600000	19476	9819	1	0	2
148216	2134	96730211000	19479	9820	3	0	2263
315541	1874	11606000	19479	9820	3	0	2
40258	1685	133202760571430	19479	9820	7	0	0
40259	1685	133922760571430	19479	9820	9	0	0
148223	2133	97155318000	19481	9821	1	0	1841
315548	1874	11615000	19481	9821	1	0	2
148237	2133	97153314000	19486	9823	1	0	1843
315562	1874	11623000	19486	9823	1	0	2
148243	2214	2501990000000	19488	9824	0	0	1
148244	1397	1324688603000	19488	9824	1	0	11414
31231	1668	20846877000000	19488	9824	4	0	5
315585	2230	0	19492	9825	0	0	0
148263	2132	148337338000	19492	9825	3	0	662
55106	1739	28799815000000	19492	9825	6	0	0
315595	1874	11640000	19494	9826	1	0	2
40901	1686	18212192550062	19494	9826	4	0	9
148273	1397	1324648599000	19495	9827	1	0	11418
315600	1874	11644000	19495	9827	3	0	2
148278	2134	96721184000	19495	9827	6	0	2272
315606	1874	11658000	19495	9827	9	0	2
148284	2133	97146300000	19496	9828	2	0	1850
315615	1874	11668000	19498	9829	2	0	2
148305	2132	148335336000	19502	9830	2	0	664
315654	1678	21600733506000	19507	9831	0	0	0
148332	2133	97142292000	19507	9831	3	0	1854
315657	1874	11678000	19507	9831	3	0	2
315658	1874	11681000	19507	9831	4	0	2
148342	2132	148334335000	19509	9832	3	0	665
25683	1610	18720636019950	19509	9832	5	0	6
315687	1678	21600733509000	19515	9833	0	0	0
148367	2134	96713160000	19515	9833	5	0	2280
315697	1678	21600733511000	19517	9834	0	0	0
148384	1397	1324538588000	19519	9835	0	0	11429
148385	2133	97137282000	19519	9835	1	0	1859
315710	1874	11708000	19519	9835	1	0	2
6294	1394	380165715000000	19523	9836	3	0	0
148402	2134	96709148000	19525	9837	1	0	2284
315727	1874	11719000	19525	9837	1	0	2
26637	1622	21420451000005	19525	9837	4	0	5
42615	1688	61200390908000	19530	9838	5	0	38
148423	1397	1324498584000	19531	9839	0	0	11433
315748	1678	21600733516000	19531	9839	0	0	0
148428	2134	96706139000	19532	9840	2	0	2287
315753	1874	11735000	19532	9840	2	0	2
41193	1687	9980225223172	19532	9840	8	0	6
148437	2133	97130268000	19534	9841	2	0	1866
315762	1874	11745000	19534	9841	2	0	2
315806	1678	21600733521000	19539	9843	0	0	0
148482	2132	148330331000	19539	9843	1	0	669
315807	1874	11754000	19539	9843	1	0	2
32298	1672	25202202000000	19539	9843	5	0	5
148494	2134	96701124000	19542	9844	2	0	2292
315837	1678	21600733523000	19545	9845	0	0	0
148513	1397	1324418576000	19545	9845	1	0	11441
148514	1397	1324408575000	19545	9845	2	0	11442
315843	1874	11771000	19545	9845	6	0	2
148520	2134	96699118000	19545	9845	8	0	2294
315861	1874	11782000	19548	9846	1	0	2
44356	1690	136084296000000	19548	9846	3	0	0
148546	1397	1324378572000	19550	9847	1	0	11445
315874	1874	11790000	19550	9847	4	0	2
148551	2134	96695106000	19550	9847	6	0	2298
13587	1447	16713625943000	19550	9847	8	0	6
315951	1678	21600733529000	19552	9848	0	0	0
315952	1678	21600733530000	19552	9848	1	0	0
148636	2134	96693100000	19552	9848	5	0	2300
315958	1874	11807000	19553	9849	1	0	2
19622	1546	17281019000000	19553	9849	3	0	6
148689	1397	1324338568000	19558	9850	0	0	11449
148690	2134	96691094000	19558	9850	1	0	2302
316015	1678	21600733533000	19560	9851	0	0	0
148698	2134	96689088000	19561	9852	1	0	2304
316020	1874	11827000	19561	9852	3	0	2
148704	2132	148326327000	19562	9853	3	0	673
316026	1874	11835000	19563	9854	1	0	2
148709	2134	96686079000	19564	9855	1	0	2307
6304	1394	384485751000000	19564	9855	3	0	0
316035	1874	11846000	19566	9856	1	0	2
148846	1397	1324268561000	19569	9857	0	0	11456
316166	1678	21600733539000	19569	9857	0	0	0
148847	2134	96684073000	19569	9857	1	0	2309
316167	1874	11852000	19569	9857	1	0	2
148864	2134	96683070000	19575	9859	3	0	2310
316184	1874	11861000	19575	9859	3	0	2
25371	1608	20445749000000	19576	9860	4	0	4
148870	1397	1324218556000	19577	9861	1	0	11461
316190	1678	21600733544000	19577	9861	1	0	0
28797	1637	226805341819988	19577	9861	4	0	0
148875	2132	148323324000	19578	9862	2	0	676
316195	1874	11877000	19578	9862	2	0	2
12614	1439	13252486998477	19578	9862	8	0	6
316201	1874	11888000	19580	9863	1	0	2
148882	1397	1324198554000	19581	9864	0	0	11463
316202	1678	21600733546000	19581	9864	0	0	0
2170	369	86676742000000	19581	9864	4	0	12
148895	2134	96676049000	19584	9865	3	0	2317
316215	1874	11899000	19584	9865	3	0	2
148913	2133	97099206000	19591	9867	1	0	1897
316234	1874	11909000	19591	9867	2	0	2
148921	1397	1324158550000	19595	9868	0	0	11467
148922	2134	96673040000	19595	9868	1	0	2320
316245	1874	11917000	19596	9869	1	0	2
148928	1397	1324138548000	19597	9870	0	0	11469
316251	1874	11922000	19597	9870	3	0	2
148934	2134	96670031000	19597	9870	6	0	2323
316257	1874	11936000	19597	9870	9	0	2
148939	2133	97093194000	19598	9871	1	0	1903
15420	1467	13646796100039	19598	9871	3	0	4
316272	1678	21600733557000	19601	9872	1	0	0
148955	2134	96666019000	19601	9872	4	0	2327
12287	1426	22605173000000	19601	9872	7	0	4
316278	1678	21600733558000	19602	9873	0	0	0
148961	1397	1324068541000	19603	9874	0	0	11476
316287	1678	21600733560000	19605	9875	0	0	0
148969	2133	97088184000	19605	9875	2	0	1908
8783	1395	58119746339007706	19605	9875	4	0	0
316306	1874	11968000	19608	9876	2	0	2
148989	2133	97087182000	19608	9876	5	0	1909
316331	1874	11981000	19610	9877	1	0	2
52023	1711	20685340000000	19610	9877	3	0	9
149014	1397	1324008535000	19611	9878	1	0	11482
316337	1874	11991000	19611	9878	4	0	2
316338	1874	11993000	19611	9878	5	0	2
149019	2132	148317318000	19611	9878	6	0	682
316351	1874	12001000	19613	9879	4	0	2
149032	2133	97082172000	19613	9879	5	0	1914
316357	1874	12007000	19614	9880	3	0	2
149038	2134	96654986000	19614	9880	4	0	2338
316362	1874	12020000	19614	9880	8	0	2
20479	1555	10995291979096	19614	9880	9	0	4
149061	1397	1323948529000	19617	9881	0	0	11488
149062	1397	1323938528000	19617	9881	1	0	11489
316386	1874	12027000	19617	9881	6	0	2
149068	2132	148315316000	19617	9881	8	0	684
42661	1688	63360469907800	19617	9881	10	0	38
149213	1397	1323918526000	19621	9882	0	0	11491
316533	1678	21600733574000	19621	9882	0	0	0
149214	1397	1323908525000	19621	9882	1	0	11492
316534	1678	21600733575000	19621	9882	1	0	0
149227	1397	1323898524000	19623	9883	0	0	11493
316547	1678	21600733576000	19623	9883	0	0	0
10756	1402	65374849319298	19623	9883	4	0	33
149233	2133	97070148000	19624	9884	3	0	1926
316553	1874	12053000	19624	9884	3	0	2
46563	1693	7339336757818	19624	9884	7	0	875
149238	1397	1323858520000	19625	9885	1	0	11497
316558	1678	21600733580000	19625	9885	1	0	0
149244	2133	97067142000	19625	9885	7	0	1929
316564	1874	12067000	19625	9885	7	0	2
149276	1397	1323828517000	19628	9886	0	0	11500
316596	1678	21600733583000	19628	9886	0	0	0
149281	2133	97064136000	19628	9886	5	0	1932
316601	1874	12089000	19628	9886	5	0	2
6315	1394	388805813000000	19628	9886	7	0	0
149287	2134	96637935000	19630	9888	1	0	2355
316607	1874	12100000	19630	9888	1	0	2
316616	1678	21600733587000	19632	9889	0	0	0
316617	1678	21600733588000	19632	9889	1	0	0
149300	2133	97061130000	19632	9889	4	0	1935
149371	1397	1323768511000	19634	9890	0	0	11506
316691	1678	21600733589000	19634	9890	0	0	0
149372	2133	97059126000	19634	9890	1	0	1937
316697	1874	12121000	19635	9891	3	0	2
149378	2134	96633923000	19635	9891	4	0	2359
316717	1874	12132000	19641	9892	1	0	2
24227	1599	20500400393047	19641	9892	4	0	4
149409	1397	1323728507000	19644	9893	0	0	11510
316733	1874	12141000	19644	9893	4	0	2
149414	2133	97055118000	19644	9893	5	0	1941
316745	1874	12151000	19646	9894	3	0	2
149426	2133	97053114000	19646	9894	4	0	1943
316746	1874	12153000	19646	9894	4	0	2
45619	1692	36500540619999	19646	9894	6	0	5
149536	1397	1323688503000	19648	9895	0	0	11514
149537	1397	1323678502000	19648	9895	1	0	11515
316860	1874	12161000	19648	9895	4	0	2
149543	1397	1323668501000	19649	9896	0	0	11516
316866	1678	21600733600000	19650	9897	0	0	0
20835	1559	15802833000000	19650	9897	4	0	4
149558	1397	1323648499000	19653	9898	0	0	11518
316880	1874	12178000	19653	9898	2	0	2
316881	1874	12181000	19653	9898	3	0	2
316882	1874	12183000	19653	9898	4	0	2
149563	2134	96621887000	19653	9898	5	0	2371
316891	1874	12194000	19656	9900	1	0	2
149572	2133	97044096000	19656	9900	2	0	1952
316897	1874	12200000	19657	9901	4	0	2
149578	2134	96618878000	19657	9901	5	0	2374
316902	1874	12211000	19658	9902	2	0	2
149586	1397	1323578492000	19660	9903	0	0	11525
316911	1874	12221000	19661	9904	2	0	2
149600	1693	7302017834936	19664	9905	0	0	876
149601	1693	7264673912054	19664	9905	1	0	877
149602	1397	1323558490000	19664	9905	2	0	11527
55445	1740	18645386000000	19664	9905	4	0	12
316925	710	5049338796669	19665	9906	2	0	0
149608	1693	6780579979035	19665	9906	5	0	883
316930	1874	12225000	19665	9906	7	0	2
6321	1394	391685913000000	19665	9906	10	0	0
149624	1397	1323538488000	19667	9907	2	0	11529
316946	251	66651272116779	19667	9907	4	0	0
149629	1693	5974468128596	19667	9907	7	0	889
44939	1691	18683358100019	19667	9907	11	0	5
316970	663	66651272116779	19670	9908	0	0	0
149653	1693	5688867221946	19670	9908	3	0	893
316975	99	66651272116779	19670	9908	5	0	0
149672	1397	1323518486000	19673	9909	1	0	11531
316994	225	66651272116779	19673	9909	3	0	0
149677	1693	5427459761772	19673	9909	6	0	900
317000	402	66651272116779	19673	9909	9	0	0
149683	1693	5203396224480	19673	9909	12	0	906
317005	1874	12241000	19673	9909	14	0	2
149725	1693	5128708378716	19676	9910	0	0	908
317045	309	66651272116779	19676	9910	0	0	0
317046	2073	649447026849	19676	9910	1	0	1
149730	1693	4941988764306	19676	9910	5	0	913
317052	1678	21600733616000	19676	9910	7	0	0
149736	1693	4828815664668	19676	9910	11	0	917
149737	1693	4791471741786	19676	9910	12	0	918
149738	1693	4754127818904	19676	9910	13	0	919
317058	180	66651272116779	19676	9910	13	0	0
317081	1678	21600733617000	19678	9911	0	0	0
149762	1693	4716783896022	19678	9911	1	0	920
317087	1874	12260000	19678	9911	7	0	2
149768	2134	96606842000	19678	9911	8	0	2386
18145	1513	30240971000000	19678	9911	9	0	0
149782	1693	4074164884715	19680	9912	4	0	929
317102	1150	613903155292823	19680	9912	4	0	0
317135	1678	21600733619000	19684	9913	1	0	0
149816	1693	3962133116069	19684	9913	2	0	932
317141	1874	12271000	19684	9913	7	0	2
59769	2087	5759132000000	19684	9913	8	0	1
149860	1397	1323458480000	19689	9914	0	0	11537
317180	1678	21600733620000	19689	9914	0	0	0
317181	392	66651272116779	19689	9914	1	0	0
149865	1693	3663381733013	19689	9914	5	0	940
317187	678	66651272116779	19689	9914	7	0	0
24383	1601	7093608620000	19689	9914	11	0	17
149877	1693	3551349964367	19691	9915	0	0	943
149878	1693	3514006041485	19691	9915	1	0	944
317200	438	66651272116779	19691	9915	3	0	0
149884	2133	97027062000	19691	9915	7	0	1969
150035	1693	3400832941847	19696	9916	0	0	948
317355	745	2019735518605	19696	9916	0	0	0
150036	1397	1323438478000	19696	9916	1	0	11539
317356	1678	21600733622000	19696	9916	1	0	0
150042	2134	96601827000	19696	9916	7	0	2391
317362	1874	12284000	19696	9916	7	0	2
150048	1693	3135455823191	19697	9917	4	0	956
317368	29	7069074315355	19697	9917	4	0	0
150053	1693	2701676938084	19697	9917	9	0	961
317373	910	507738856265767	19697	9917	9	0	0
150059	2134	96600824000	19697	9917	15	0	2392
317379	1874	12293000	19697	9917	15	0	2
150065	1693	2402925555028	19698	9918	4	0	969
317385	194	66651272116779	19698	9918	4	0	0
150070	1693	1370037854034	19698	9918	9	0	972
317390	653	66651272116779	19698	9918	9	0	0
150076	2133	97023054000	19698	9918	15	0	1973
317396	1874	12301000	19698	9918	15	0	2
8789	1395	58121906495007706	19698	9918	18	0	0
150213	1397	1323378472000	19703	9920	0	0	11545
317533	1678	21600733628000	19703	9920	0	0	0
150214	2134	96595809000	19703	9920	1	0	2397
317534	1874	12314000	19703	9920	1	0	2
13888	1448	10116798000001	19703	9920	3	0	8
150220	2134	96593803000	19704	9921	4	0	2399
317540	1874	12324000	19704	9921	4	0	2
11853	1422	14545186860211	19704	9921	7	0	7
150226	2134	96591797000	19705	9922	4	0	2401
317546	1874	12334000	19705	9922	4	0	2
317563	1678	21600733633000	19709	9923	0	0	0
317564	304	66651272116779	19709	9923	1	0	0
150246	2133	97015038000	19709	9923	3	0	1981
15142	1458	20253805908540	19709	9923	5	0	4
317576	1874	12346000	19712	9924	2	0	2
17550	1508	20196722500009	19712	9924	4	0	6
150260	2134	96588788000	19714	9925	1	0	2404
150387	1397	1323298464000	19716	9926	0	0	11553
317707	1678	21600733636000	19716	9926	0	0	0
150388	1397	1323288463000	19716	9926	1	0	11554
317708	1678	21600733637000	19716	9926	1	0	0
150394	2133	97011030000	19716	9926	7	0	1985
317714	1874	12361000	19716	9926	7	0	2
50707	1706	15332299600135	19716	9926	9	0	20
150400	2133	97008024000	19718	9928	1	0	1988
317720	1874	12370000	19718	9928	1	0	2
6327	1394	396006141000000	19718	9928	4	0	0
150409	2133	97006020000	19720	9929	3	0	1990
317729	1874	12377000	19720	9929	3	0	2
54721	1727	18187246999999	19720	9929	6	0	7
150417	2134	96581767000	19722	9930	2	0	2411
150534	1397	1323218456000	19727	9931	0	0	11561
317854	1678	21600733644000	19727	9931	0	0	0
317855	1678	21600733645000	19727	9931	1	0	0
150548	2133	97003014000	19730	9932	2	0	1993
317869	1874	12400000	19730	9932	3	0	2
150553	2133	97001010000	19731	9933	2	0	1995
150557	1397	1323178452000	19733	9934	0	0	11565
317878	1678	21600733649000	19733	9934	1	0	0
52459	1715	16586814436096	19733	9934	6	0	9
150563	1397	1323158450000	19734	9935	0	0	11567
317883	1678	21600733650000	19734	9935	0	0	0
47366	1694	23772733127629	19734	9935	3	0	34
317990	1678	21600733651000	19740	9936	0	0	0
317991	1874	12425000	19740	9936	1	0	2
150676	1397	1323138448000	19742	9937	0	0	11569
318000	1874	12436000	19743	9938	1	0	2
44367	1690	137524344000000	19743	9938	3	0	0
150681	1397	1323118446000	19744	9939	0	0	11571
318006	1874	12446000	19744	9939	5	0	2
150687	2133	96992994000	19744	9939	6	0	2003
59091	1992	17279379990000	19744	9939	7	0	0
150689	1397	1323088443000	19745	9940	1	0	11574
150690	1397	1323078442000	19745	9940	2	0	11575
318011	1678	21600733659000	19745	9940	3	0	0
150696	2134	96565719000	19745	9940	8	0	2427
318017	1874	12464000	19745	9940	9	0	2
150702	2134	96564716000	19746	9941	2	0	2428
318023	1678	21600733661000	19747	9942	0	0	0
318113	1678	21600733662000	19750	9943	0	0	0
150794	2134	96562710000	19750	9943	1	0	2430
318114	1874	12481000	19750	9943	1	0	2
150803	2134	96560704000	19754	9945	1	0	2432
318123	1874	12491000	19754	9945	1	0	2
19087	1536	15840775999959	19754	9945	4	0	6
8795	1395	58124066675007706	19756	9946	3	0	0
150811	2133	96981972000	19758	9947	1	0	2014
318131	1874	12500000	19758	9947	1	0	2
22928	1588	21095095000000	19758	9947	3	0	6
28806	1637	228965397819988	19760	9948	2	0	0
150819	1397	1322968431000	19761	9949	1	0	11586
318139	1678	21600733669000	19761	9949	1	0	0
6335	1394	400326225000000	19761	9949	7	0	0
150825	2134	96555689000	19762	9950	1	0	2437
318145	1874	12518000	19762	9950	1	0	2
150826	2133	96977964000	19762	9950	2	0	2018
318167	1874	12527000	19767	9952	1	0	2
150848	1726	58947112000	19767	9952	2	0	8238
318172	2184	2599000000	19767	9952	6	0	1
150854	1726	54143112000	19767	9952	8	0	8242
318272	1678	21600733673000	19770	9953	0	0	0
318273	1874	12534000	19770	9953	1	0	2
25888	1611	15903055000000	19770	9953	4	0	5
150955	1397	1322918426000	19771	9954	0	0	11591
318279	1874	12543000	19772	9955	1	0	2
150961	2134	96549671000	19772	9955	3	0	2443
150962	2133	96971952000	19772	9955	4	0	2024
318285	1678	21600733677000	19773	9956	1	0	0
150968	2134	96547665000	19773	9956	4	0	2445
318290	1874	12563000	19773	9956	6	0	2
35329	1679	23759214653000	19773	9956	8	0	50
150974	1397	1322868421000	19775	9958	0	0	11596
318296	1874	12573000	19775	9958	2	0	2
150982	2133	96966942000	19777	9959	2	0	2029
318319	1874	12579000	19780	9960	2	0	2
151002	2133	96965940000	19780	9960	5	0	2030
318324	1678	21600733683000	19781	9961	0	0	0
151008	2133	96962934000	19781	9961	4	0	2033
318330	1874	12598000	19781	9961	6	0	2
16556	1476	20160361000000	19781	9961	9	0	5
151016	1397	1322798414000	19784	9962	0	0	11603
318339	1678	21600733687000	19785	9963	0	0	0
151022	2133	96959928000	19785	9963	3	0	2036
318344	1874	12615000	19785	9963	5	0	2
40267	1685	135362799571430	19785	9963	9	0	0
151028	2134	96536632000	19786	9964	2	0	2456
318350	1874	12624000	19786	9964	4	0	2
151040	1397	1322748409000	19788	9965	0	0	11608
318363	1874	12634000	19788	9965	3	0	2
151046	2134	96533623000	19789	9966	2	0	2459
318371	1874	12642000	19791	9967	1	0	2
18152	1513	31680997000000	19791	9967	4	0	0
151055	2133	96952914000	19792	9968	2	0	2043
318385	1678	21600733695000	19796	9969	0	0	0
318386	1874	12652000	19796	9969	1	0	2
151068	1397	1322698404000	19797	9970	0	0	11613
10783	1402	67534873319298	19797	9970	3	0	33
318408	1204	612520750000000	19800	9971	1	0	0
151090	1695	2104930999000	19800	9971	3	0	9
318414	1874	12666000	19800	9971	7	0	2
151103	1397	1322678402000	19802	9972	0	0	11615
151104	1397	1322668401000	19802	9972	1	0	11616
318427	1678	21600733700000	19803	9973	0	0	0
151110	1397	1322628397000	19803	9973	3	0	11620
318433	1874	12676000	19803	9973	6	0	2
151116	2134	96522590000	19803	9973	9	0	2470
318449	1874	12689000	19805	9974	2	0	2
8803	1395	58126226734007706	19805	9974	3	0	0
151131	1397	1322598394000	19806	9975	1	0	11623
318457	1678	21600733707000	19808	9976	0	0	0
151146	1397	1322578392000	19811	9977	0	0	11625
318471	1678	21600733710000	19814	9979	0	0	0
151154	1397	1322538388000	19815	9980	1	0	11629
318477	1874	12709000	19815	9980	4	0	2
151159	2134	96513563000	19815	9980	6	0	2479
48428	1698	19977156550035	19815	9980	7	0	7
318482	1874	12716000	19816	9981	2	0	2
151167	1397	1322498384000	19818	9982	0	0	11633
8808	1395	58127666767007706	19818	9982	3	0	0
318490	1678	21600733717000	19819	9983	1	0	0
45646	1692	38660601619999	19819	9983	4	0	5
151173	2233	170000000	19820	9984	0	0	2
151178	2134	96507545000	19820	9984	6	0	2485
318496	1874	12735000	19820	9984	6	0	2
318506	1874	12740000	19823	9986	2	0	2
151189	2132	148291292000	19823	9986	3	0	708
42699	1688	64800540905200	19823	9986	6	0	38
318512	1678	21600733723000	19825	9988	0	0	0
151195	2133	96946902000	19825	9988	1	0	2049
318513	1874	12751000	19825	9988	1	0	2
34845	1678	22320744723000	19825	9988	3	0	0
318519	1874	12753000	19828	9989	0	0	2
151214	2134	96502530000	19832	9990	1	0	2490
318537	1678	22320744725000	19834	9991	0	0	0
14836	1457	22944459040000	19834	9991	3	0	4
151223	2134	96500524000	19835	9992	1	0	2492
318543	1874	12773000	19835	9992	3	0	2
151229	1397	1322378372000	19837	9994	0	0	11645
318548	1874	12781000	19837	9994	1	0	2
30599	1656	21021740999990	19837	9994	4	0	4
151235	1397	1322368371000	19839	9995	0	0	11646
151236	2134	96497515000	19839	9995	1	0	2495
318561	1874	12789000	19841	9996	1	0	2
151246	1397	1322348369000	19842	9997	0	0	11648
318576	1678	22320744732000	19846	9998	0	0	0
151261	2134	96493503000	19846	9998	3	0	2499
318581	1874	12809000	19846	9998	5	0	2
151291	2133	96934878000	19848	9999	1	0	2061
6341	1394	404646250000000	19848	9999	3	0	0
318612	1874	12815000	19849	10000	1	0	2
151297	1701	11893806916880	19849	10000	4	0	11
318635	1594	17185313000000	19853	10001	1	0	5
151320	2132	148286287000	19853	10001	4	0	713
318646	1678	22320744737000	19856	10002	0	0	0
151331	1726	49339112000	19856	10002	3	0	8246
318649	2236	200000000	19856	10002	3	0	0
318650	1162	612314712579855	19856	10002	4	0	0
42716	1688	65520555905200	19856	10002	7	0	38
151343	2134	96488488000	19858	10003	3	0	2504
318662	1678	22320744739000	19859	10004	0	0	0
151364	1397	1322258360000	19863	10005	0	0	11657
318683	1148	612672289000000	19863	10005	1	0	0
12919	1440	17279349049920	19863	10005	3	0	6
12926	1440	17999349049920	19863	10005	6	0	6
151369	1397	1322248359000	19864	10006	0	0	11658
151370	2134	96485479000	19864	10006	1	0	2507
318688	1874	12850000	19864	10006	1	0	2
151376	1727	2395169999999	19866	10008	0	0	11
318694	1274	1707265437751650	19866	10008	0	0	0
151382	1397	1322198354000	19866	10008	6	0	11663
318700	1678	22320744746000	19866	10008	6	0	0
151387	2133	96925860000	19866	10008	11	0	2070
318705	1874	12864000	19866	10008	11	0	2
151393	2134	96481467000	19866	10008	17	0	2511
318711	1874	12878000	19866	10008	17	0	2
151445	1397	1322168351000	19872	10010	0	0	11666
318763	1678	22320744749000	19872	10010	0	0	0
318788	1678	22320744750000	19876	10011	0	0	0
318789	1874	12896000	19876	10011	1	0	2
151472	2132	148282283000	19876	10011	2	0	717
5070	641	84340264000000	19876	10011	5	0	12
318795	1874	12904000	19878	10013	1	0	2
151478	2134	96475449000	19878	10013	2	0	2517
318801	1874	12912000	19879	10014	4	0	2
151484	2134	96474446000	19879	10014	5	0	2518
151537	1397	1322108345000	19881	10015	0	0	11672
151538	2133	96913836000	19881	10015	1	0	2082
318857	1874	12923000	19881	10015	2	0	2
21319	1560	20754463277001	19881	10015	3	0	15
151549	2132	148280281000	19884	10016	4	0	719
318868	1874	12932000	19884	10016	5	0	2
29735	1649	25484381999992	19884	10016	7	0	4
151560	1397	1322068341000	19888	10018	0	0	11676
318879	1874	12942000	19888	10018	1	0	2
151565	2132	148279280000	19889	10019	2	0	720
318884	1874	12947000	19889	10019	3	0	2
57755	1768	18590920110000	19889	10019	7	0	6
151571	1711	18851854000000	19890	10020	1	0	10
318890	1241	613859250000000	19890	10020	2	0	0
151577	2134	96465419000	19890	10020	7	0	2527
318896	1874	12963000	19890	10020	8	0	2
42771	1688	67680643905200	19890	10020	12	0	38
151593	2233	88969999	19892	10021	1	0	7
318912	1874	12968000	19892	10021	2	0	2
6350	1394	408966295500000	19892	10021	4	0	0
318942	1678	22320744765000	19900	10022	0	0	0
318943	1874	12973000	19900	10022	1	0	2
151627	2134	96462410000	19900	10022	3	0	2530
318949	1874	12982000	19901	10023	3	0	2
151633	2133	96901812000	19901	10023	5	0	2094
28817	1637	230405445819988	19901	10023	8	0	0
151645	1397	1321978332000	19904	10024	0	0	11685
151646	2133	96900810000	19904	10024	1	0	2095
318965	1874	12992000	19904	10024	2	0	2
151662	2134	96458398000	19906	10025	4	0	2534
318980	1874	12996000	19906	10025	4	0	2
151682	1455	10978017000000	19909	10026	0	0	6
319000	2011	1475000000000	19909	10026	0	0	0
151697	1455	6831817000000	19912	10027	1	0	8
319016	1678	23040756773000	19912	10027	2	0	0
15908	1471	23659957900000	19912	10027	6	0	4
151703	1397	1321918326000	19913	10028	1	0	11691
319021	1678	23040756774000	19913	10028	1	0	0
151713	1643	2262511437200	19916	10030	0	0	22
319031	1299	1704974641817750	19916	10030	0	0	0
151718	1397	1321888323000	19917	10031	0	0	11694
319037	1053	906821162404900	19917	10031	1	0	0
151724	1397	1321878322000	19918	10032	1	0	11695
319042	1678	23040756778000	19918	10032	1	0	0
31642	1670	22321293000000	19918	10032	8	0	6
151756	1397	1321858320000	19922	10033	0	0	11697
319074	1678	23040756780000	19922	10033	0	0	0
319075	1874	13052000	19922	10033	1	0	2
151765	1397	1321848319000	19926	10035	0	0	11698
319085	1874	13063000	19926	10035	2	0	2
151771	2133	96885780000	19927	10036	3	0	2110
8816	1395	58129826906007706	19927	10036	5	0	0
319094	1678	23040756783000	19930	10038	0	0	0
151777	1397	1321818316000	19930	10038	1	0	11701
151778	2133	96883776000	19930	10038	2	0	2112
15444	1467	15806879100039	19930	10038	5	0	4
319109	1678	23040756785000	19933	10039	0	0	0
151794	2133	96882774000	19933	10039	3	0	2113
319129	1678	23040756787000	19940	10041	0	0	0
151948	1397	1321778312000	19945	10042	0	0	11705
319266	1678	23040756788000	19945	10042	0	0	0
151949	1397	1321768311000	19945	10042	1	0	11706
319267	1678	23040756789000	19945	10042	1	0	0
53709	1719	20900867000000	19945	10042	8	0	5
151955	1397	1321758310000	19946	10043	0	0	11707
319273	1678	23040756790000	19946	10043	0	0	0
151961	2134	96436332000	19947	10044	3	0	2556
319279	1874	13114000	19947	10044	3	0	2
151981	1397	1321718306000	19949	10045	1	0	11711
319299	1678	23040756794000	19949	10045	1	0	0
151987	1571	1151617151056	19949	10045	7	0	41
319305	1335	1703811343055074	19949	10045	7	0	0
151993	2133	96874758000	19949	10045	13	0	2121
319311	1874	13134000	19949	10045	13	0	2
59416	2039	20161542000000	19950	10046	4	0	1
152004	1397	1321688303000	19953	10047	0	0	11714
319322	1678	23040756797000	19953	10047	0	0	0
152010	2133	96869748000	19953	10047	6	0	2126
319328	1874	13148000	19953	10047	6	0	2
319329	1874	13151000	19953	10047	7	0	2
319330	1874	13154000	19953	10047	8	0	2
152029	1397	1321638298000	19955	10048	2	0	11719
319349	1874	13158000	19955	10048	4	0	2
3993	606	81838172812962	19955	10048	5	0	12
152034	2134	96427305000	19956	10049	2	0	2565
319355	1874	13172000	19956	10049	5	0	2
152040	2133	96866742000	19956	10049	8	0	2129
319360	1874	13183000	19956	10049	10	0	2
152046	2133	96863736000	19957	10050	3	0	2132
152172	1397	1321598294000	19959	10051	0	0	11723
319490	1678	23040756806000	19959	10051	0	0	0
152173	2134	96421287000	19959	10051	1	0	2571
319491	1874	13192000	19959	10051	1	0	2
152182	2134	96419281000	19962	10053	1	0	2573
319500	1874	13202000	19962	10053	1	0	2
152197	1397	1321568291000	19965	10054	0	0	11726
152198	2134	96418278000	19965	10054	1	0	2574
319523	1678	23040756810000	19967	10055	0	0	0
152208	2133	96857724000	19967	10055	3	0	2138
319528	1874	13220000	19967	10055	5	0	2
152214	2134	96415269000	19968	10056	3	0	2577
319534	1874	13228000	19968	10056	5	0	2
28827	1637	232565507819988	19968	10056	8	0	0
152222	2134	96413263000	19970	10057	1	0	2579
6362	1394	413286352500000	19970	10057	3	0	0
319550	1678	23040756816000	19972	10058	1	0	0
152235	2134	96412260000	19972	10058	4	0	2580
319555	1874	13247000	19972	10058	6	0	2
152278	2132	148261262000	19979	10060	3	0	738
319598	1874	13254000	19979	10060	5	0	2
152283	2133	96849708000	19979	10060	8	0	2146
319601	1874	13260000	19979	10060	8	0	2
319602	1678	23040756820000	19980	10061	0	0	0
152289	2133	96847704000	19980	10061	5	0	2148
319608	1678	23040756822000	19981	10062	0	0	0
152295	2133	96846702000	19981	10062	5	0	2149
319620	1678	23040756823000	19984	10063	0	0	0
152309	2133	96844698000	19986	10064	0	0	2151
319628	606	81835204812962	19986	10064	1	0	13
11575	1419	35019844280064	19986	10064	3	0	3
152320	2134	96403233000	19988	10065	3	0	2589
152321	2132	148259260000	19988	10065	4	0	740
319639	1874	13292000	19988	10065	4	0	2
152327	1397	1321408275000	19990	10066	0	0	11742
319650	1678	23040756827000	19991	10067	2	0	0
152333	1397	1321378272000	19991	10067	3	0	11745
319655	1874	13303000	19991	10067	7	0	2
152339	2133	96839688000	19991	10067	9	0	2156
319679	1874	13316000	19996	10068	1	0	2
152362	2133	96838686000	19996	10068	2	0	2157
319685	1874	13323000	19997	10069	4	0	2
152373	1670	3988993000000	19999	10070	0	0	9
319695	1874	13329000	19999	10070	4	0	2
152495	1397	1321338268000	20002	10071	0	0	11749
319813	1678	23040756832000	20002	10071	0	0	0
152496	1594	9122077000000	20002	10071	1	0	7
319814	1326	1709341117751650	20002	10071	1	0	0
152522	2134	96394206000	20007	10072	2	0	2598
319840	1874	13337000	20007	10072	2	0	2
57359	1764	15126970100000	20007	10072	4	0	8
152533	1594	1497000000	20009	10073	4	0	10
319851	960	507336815000000	20009	10073	4	0	0
152538	2133	96833676000	20009	10073	9	0	2162
319856	1874	13345000	20009	10073	9	0	2
152544	1716	2781957000000	20010	10074	4	0	8
319862	1316	1711798937751650	20010	10074	4	0	0
53134	1717	19548210000023	20010	10074	7	0	4
319886	1678	23040756838000	20018	10076	0	0	0
152569	2132	148255256000	20018	10076	1	0	744
319887	1874	13358000	20018	10076	1	0	2
152578	2133	96828666000	20020	10077	2	0	2167
319897	1874	13368000	20020	10077	3	0	2
152584	1397	1321248259000	20022	10079	0	0	11758
319903	1678	23040756842000	20022	10079	1	0	0
152590	2134	96386182000	20022	10079	6	0	2606
319908	1874	13383000	20022	10079	6	0	2
152593	1726	44535112000	20022	10079	9	0	8250
152594	1979	14125259179083	20023	10080	0	0	11
319914	1051	907981037590826	20023	10080	2	0	0
152600	1397	1321228257000	20023	10080	6	0	11760
319920	1874	13389000	20023	10080	8	0	2
58369	1850	20079250000000	20023	10080	10	0	5
152606	2133	96823656000	20024	10081	3	0	2172
29943	1650	13714233000000	20024	10081	4	0	5
319925	1678	23040756845000	20026	10082	0	0	0
152611	2134	96382170000	20026	10082	4	0	2610
20243	1549	24816037000000	20026	10082	5	0	5
319936	1874	13407000	20031	10083	1	0	2
152622	2134	96380164000	20032	10084	1	0	2612
319942	1874	13416000	20032	10084	3	0	2
8834	1395	58131986943007706	20033	10085	4	0	0
152631	1397	1321168251000	20035	10086	0	0	11766
319950	1874	13423000	20035	10086	1	0	2
152639	353	66000000000000	20037	10087	2	0	3
319959	1874	13429000	20037	10087	4	0	2
28833	1637	234005531819988	20040	10088	4	0	0
152653	1397	1321138248000	20042	10089	0	0	11769
319973	1874	13439000	20042	10089	2	0	2
2189	369	88116767000000	20042	10089	4	0	12
152663	2133	96813636000	20044	10090	3	0	2182
319986	1678	23040756854000	20046	10091	0	0	0
152672	2134	96374146000	20046	10091	4	0	2618
319992	1874	13455000	20046	10091	6	0	2
152684	1397	1321088243000	20051	10093	0	0	11774
320004	1874	13465000	20051	10093	2	0	2
152690	1694	24103503366853	20052	10094	2	0	36
320009	57	66714679919853	20052	10094	3	0	0
320010	60	66714679919853	20052	10094	4	0	0
152695	1694	22800188882428	20052	10094	7	0	41
320016	129	66260677919853	20052	10094	10	0	2
152701	1694	21236211501118	20052	10094	13	0	47
320022	371	66714679919853	20052	10094	17	0	0
152707	1694	19672234119808	20052	10094	20	0	53
320027	574	66714679919853	20052	10094	22	0	0
152712	1694	18368919635383	20052	10094	25	0	58
320033	1191	614629496764309	20052	10094	28	0	0
152718	2133	96808626000	20052	10094	31	0	2187
25704	1610	20160941019950	20052	10094	33	0	6
320039	1874	13476000	20053	10095	2	0	2
26660	1622	25020512000005	20053	10095	3	0	5
152724	2134	96368128000	20054	10096	2	0	2624
6374	1394	416166499500000	20054	10096	5	0	0
152754	1397	1321048239000	20056	10097	0	0	11778
320072	1678	23040756861000	20056	10097	0	0	0
152755	2119	196000000	20056	10097	1	0	4
36382	1681	17783455759830	20056	10097	4	0	6
1018	58	89706660999641	20058	10098	4	0	7
320109	1678	23040756863000	20060	10099	0	0	0
152792	1397	1321018236000	20060	10099	1	0	11781
320115	1874	13497000	20060	10099	6	0	2
152798	2134	96364116000	20060	10099	7	0	2628
320120	1816	100000000	20060	10099	11	0	1
152803	2133	96800610000	20060	10099	12	0	2195
320126	909	507060990769063	20061	10100	3	0	0
152809	2134	96362110000	20061	10100	4	0	2630
320132	742	5048100000000	20061	10100	9	0	0
152815	2133	96799608000	20061	10100	10	0	2196
320137	1029	908648950959568	20061	10100	14	0	0
45669	1692	40100678619999	20061	10100	16	0	5
152826	1397	1320958230000	20064	10101	0	0	11787
320145	1874	13528000	20064	10101	1	0	2
320146	1874	13530000	20064	10101	2	0	2
152931	1397	1320948229000	20069	10102	0	0	11788
152932	1689	7463337179995	20069	10102	1	0	10
320258	1874	13538000	20071	10103	1	0	2
152942	1689	1015355019933	20071	10103	3	0	11
42824	1688	69840689905200	20071	10103	5	0	38
320279	1678	23040756874000	20077	10105	0	0	0
152963	2134	96355089000	20077	10105	2	0	2637
320281	1874	13550000	20077	10105	2	0	2
28834	1637	234725531819988	20077	10105	3	0	0
320282	1678	23040756875000	20078	10106	0	0	0
56511	1756	10513192545609	20078	10106	4	0	5
152968	1397	1320898224000	20079	10107	1	0	11793
320288	1984	2270230732316	20079	10107	3	0	0
152981	2112	3323654080099	20081	10108	2	0	2
320301	372	66651405291044	20081	10108	4	0	0
152987	2112	2843659338903	20082	10109	1	0	4
320306	577	66651405291044	20082	10109	2	0	0
152992	2134	96352080000	20082	10109	7	0	2640
320312	1678	23040756879000	20083	10110	2	0	0
152998	2132	148246247000	20083	10110	5	0	753
1643	212	66000004060000	20083	10110	9	0	0
153029	271	66651395291044	20087	10111	0	0	1
153030	1684	24710963270724	20087	10111	1	0	73
320344	258	66544510726895	20087	10111	1	0	0
320349	1678	23040756882000	20087	10111	6	0	0
153036	1684	24292091693500	20087	10111	7	0	75
320355	429	66544510726895	20087	10111	12	0	0
153042	1684	23035476961828	20087	10111	13	0	81
153047	1684	21988298018768	20087	10111	18	0	86
320361	483	66544510726895	20087	10111	18	0	0
320366	512	66544510726895	20087	10111	23	0	0
153053	1684	20731683287096	20087	10111	24	0	92
320372	558	66243200726895	20087	10111	29	0	3
153059	1684	19475068555424	20087	10111	30	0	98
153064	2132	148245246000	20087	10111	35	0	754
320378	1874	13583000	20087	10111	35	0	2
320383	572	66544510726895	20088	10112	1	0	0
153070	1684	19056196978200	20088	10112	2	0	100
320389	595	66544510726895	20088	10112	7	0	0
153076	1684	17799582246528	20088	10112	8	0	106
153081	1895	1439936000000	20089	10113	0	0	1
320395	1497	0	20089	10113	0	0	0
320400	1678	23040756884000	20089	10113	5	0	0
153087	1684	16542967514856	20089	10113	6	0	112
320406	1874	13597000	20089	10113	11	0	2
153093	361	66001270116779	20089	10113	12	0	2
21777	1571	1871617151056	20089	10113	13	0	41
153102	1587	2203285000000	20091	10114	4	0	11
320416	991	508244145000000	20091	10114	4	0	0
320417	272	67581824000000	20091	10114	5	0	0
320418	319	66717580000000	20091	10114	6	0	0
153108	1684	14867481205960	20091	10114	10	0	120
320424	670	66544510726895	20091	10114	12	0	0
153114	2132	148244245000	20091	10114	16	0	755
320430	1874	13603000	20091	10114	18	0	2
8840	1395	58134146968007706	20091	10114	19	0	0
8842	1395	58134147131007706	20091	10114	20	0	0
153137	1684	13813946026882	20093	10115	1	0	126
153138	1684	13807589790864	20093	10115	2	0	127
320454	763	1008250162528	20093	10115	4	0	0
153144	1684	9244382280923	20093	10115	8	0	133
320460	1678	23040756886000	20093	10115	10	0	0
153150	2133	96780570000	20093	10115	14	0	2215
320466	1874	13613000	20093	10115	16	0	2
19939	1547	17853559000000	20093	10115	17	0	6
153192	2132	148243244000	20097	10116	3	0	756
320506	1874	13618000	20097	10116	5	0	2
153205	1684	2724219748	20099	10117	1	0	136
320519	1678	23040756891000	20099	10117	3	0	0
153211	2133	96776562000	20099	10117	7	0	2219
320525	1874	13634000	20099	10117	9	0	2
24914	1602	19440598000000	20099	10117	12	0	5
153228	2142	4629991000000	20101	10118	0	0	3
320542	1096	908957465000000	20101	10118	2	0	0
153234	1397	1320718206000	20101	10118	6	0	11811
320548	1874	13645000	20101	10118	8	0	2
58898	1991	22796129441475	20101	10118	12	0	12
320571	1371	1710570537751650	20104	10119	0	0	0
153260	1397	1320708205000	20104	10119	1	0	11812
320572	1678	23040756895000	20104	10119	1	0	0
153265	2133	96772554000	20104	10119	6	0	2223
320578	1874	13655000	20104	10119	7	0	2
6386	1394	420486554500000	20104	10119	9	0	0
153290	1476	0	20108	10120	0	0	11
153291	1397	1320698204000	20108	10120	1	0	11813
8844	1395	58134867131007706	20108	10120	4	0	0
320606	1678	23040756897000	20109	10121	0	0	0
153297	2134	96333023000	20110	10122	1	0	2659
320611	1136	910778465000000	20111	10123	1	0	0
153303	2134	96332020000	20111	10123	5	0	2660
56816	1759	18000877999889	20111	10123	7	0	7
320617	1678	23040756899000	20112	10124	0	0	0
153308	2134	96330014000	20113	10125	1	0	2662
320635	1365	1710262743410483	20117	10126	0	0	0
153326	1397	1320648199000	20117	10126	3	0	11818
320640	1874	13688000	20117	10126	5	0	2
54431	1724	19377550500000	20117	10126	8	0	9
153332	1719	19423092000000	20118	10127	2	0	6
320646	1226	613968310000000	20118	10127	4	0	0
153337	1397	1320628197000	20119	10128	0	0	11820
320659	1016	508248775000000	20121	10129	0	0	0
153350	2134	96326002000	20121	10129	3	0	2666
320664	1874	13708000	20121	10129	5	0	2
153356	1397	1320588193000	20122	10130	2	0	11824
320670	1874	13714000	20122	10130	4	0	2
153361	2134	96322993000	20122	10130	7	0	2669
6393	1394	424806654500000	20122	10130	8	0	0
6394	1394	424806779500000	20122	10130	9	0	0
320684	1313	1709341167751650	20124	10131	2	0	0
153375	1536	1152110999959	20124	10131	5	0	10
320689	1678	23040756908000	20125	10132	1	0	0
320690	1678	23040756909000	20125	10132	2	0	0
153381	1719	0	20125	10132	5	0	10
153427	1397	1320548189000	20131	10133	0	0	11828
320739	1678	23040756911000	20131	10133	0	0	0
153428	1522	16145291000000	20131	10133	1	0	11
320745	1874	13740000	20131	10133	6	0	2
153434	1397	1320538188000	20132	10134	0	0	11829
320750	1874	13742000	20132	10134	4	0	2
11874	1422	16705240860211	20132	10134	7	0	7
153466	1397	1320528187000	20136	10135	0	0	11830
320782	1874	13747000	20136	10135	4	0	2
153471	2133	96752514000	20136	10135	5	0	2243
320788	1678	23040756916000	20137	10136	0	0	0
153477	2133	96750510000	20137	10136	1	0	2245
25712	1610	20880953019950	20138	10137	4	0	6
320802	1009	505985775000000	20142	10138	0	0	0
153492	1397	1320478182000	20142	10138	2	0	11835
320808	1375	1704789637751650	20143	10139	1	0	0
153497	1397	1320468181000	20143	10139	2	0	11836
6404	1394	429127264500000	20143	10139	7	0	0
153614	1397	1320458180000	20148	10140	0	0	11837
320926	1678	23040756920000	20148	10140	0	0	0
153615	2133	96746502000	20148	10140	1	0	2249
320927	1874	13779000	20148	10140	1	0	2
49133	1701	2158096500103	20148	10140	4	0	14
153624	2133	96744498000	20151	10142	1	0	2251
320936	1874	13789000	20151	10142	1	0	2
153630	1397	1320418176000	20153	10144	0	0	11841
320942	1678	23040756924000	20153	10144	0	0	0
153635	2133	96741492000	20153	10144	5	0	2254
320947	1874	13807000	20153	10144	5	0	2
153641	2134	96303936000	20155	10146	2	0	2688
320953	1874	13817000	20155	10146	2	0	2
320963	1678	23040756928000	20158	10147	0	0	0
320964	1678	23040756929000	20158	10147	1	0	0
153656	2133	96737484000	20158	10147	5	0	2258
320970	1678	23040756930000	20159	10148	1	0	0
153661	1397	1320328167000	20159	10148	4	0	11850
320976	1874	13830000	20159	10148	7	0	2
153667	2133	96736482000	20159	10148	10	0	2259
320981	1874	13842000	20159	10148	12	0	2
153673	1610	13752822189950	20160	10149	1	0	8
320987	1314	1711491918671650	20160	10149	3	0	0
153678	2134	96296915000	20160	10149	6	0	2695
153827	1773	15460243628123	20164	10150	0	0	31
321137	182	66770027864240	20164	10150	0	0	0
153828	1397	1320308165000	20164	10150	1	0	11852
321138	1678	23040756935000	20164	10150	1	0	0
153834	2133	96731472000	20164	10150	7	0	2264
321144	1874	13854000	20164	10150	7	0	2
153840	1423	4704939826911	20165	10151	0	0	16
321150	104	66631395942306	20165	10151	0	0	0
153845	1423	2863123961541	20165	10151	5	0	21
321155	314	66631395942306	20165	10151	5	0	0
153851	1423	652944923097	20165	10151	11	0	27
321161	559	66631395942306	20165	10151	11	0	0
153857	1397	1320268161000	20165	10151	17	0	11856
321167	1678	23040756939000	20165	10151	17	0	0
153862	2133	96728466000	20165	10151	22	0	2267
321172	1874	13875000	20165	10151	22	0	2
32624	1675	2444104999977	20165	10151	27	0	8
153874	1540	367206120000	20167	10152	2	0	5
321184	1876	703463880000	20167	10152	2	0	4
153880	1397	1320248159000	20168	10153	2	0	11858
321190	1678	23040756941000	20168	10153	2	0	0
153885	2133	96724458000	20168	10153	7	0	2271
321195	1874	13896000	20168	10153	7	0	2
59099	1992	19439431990000	20168	10153	9	0	0
153900	2134	96286885000	20170	10154	4	0	2705
321210	1874	13904000	20170	10154	4	0	2
153906	2134	96284879000	20172	10156	0	0	2707
321216	1874	13912000	20172	10156	0	0	2
153911	2133	96718446000	20174	10158	0	0	2277
321221	1874	13918000	20174	10158	0	0	2
57772	1768	20751095110000	20174	10158	5	0	6
153917	2133	96717444000	20175	10159	1	0	2278
321227	1874	13924000	20175	10159	1	0	2
8857	1395	58137027189007706	20175	10159	5	0	0
321236	1678	23040756946000	20177	10160	0	0	0
321237	1678	23040756947000	20177	10160	1	0	0
153928	1397	1320178152000	20177	10160	2	0	11865
153933	2133	96713436000	20177	10160	7	0	2282
321243	1874	13942000	20177	10160	7	0	2
153943	2132	148234235000	20179	10161	3	0	765
321253	1874	13954000	20179	10161	3	0	2
154089	1397	1320148149000	20183	10163	0	0	11868
321399	1678	23040756951000	20183	10163	0	0	0
154090	1397	1320138148000	20183	10163	1	0	11869
321400	1678	23040756952000	20183	10163	1	0	0
154096	2132	148233234000	20183	10163	7	0	766
321406	1874	13971000	20183	10163	7	0	2
154226	1397	1320108145000	20186	10165	0	0	11872
321534	1678	23040756955000	20186	10165	0	0	0
154227	1397	1320098144000	20186	10165	1	0	11873
321535	1678	23040756956000	20186	10165	1	0	0
154233	2134	96270837000	20186	10165	7	0	2721
321541	1874	13992000	20186	10165	7	0	2
53370	1719	1440061000000	20186	10165	11	0	10
154245	1397	1320068141000	20190	10167	0	0	11876
321553	1678	23040756959000	20190	10167	0	0	0
154250	1397	1320048139000	20191	10168	1	0	11878
321558	1678	23040756961000	20191	10168	1	0	0
154256	2133	96700410000	20191	10168	7	0	2295
321564	1874	14020000	20191	10168	7	0	2
30274	1654	21885270999798	20191	10168	10	0	7
17854	1509	19392091851155	20192	10169	4	0	5
154262	1397	1320018136000	20193	10170	0	0	11881
321570	1678	23040756964000	20193	10170	0	0	0
154279	1397	1319998134000	20196	10171	0	0	11883
321587	1678	23040756966000	20196	10171	0	0	0
154285	1397	1319988133000	20197	10172	0	0	11884
321593	1678	23040756967000	20197	10172	0	0	0
154295	1397	1319968131000	20199	10173	2	0	11886
321603	1678	23040756969000	20199	10173	2	0	0
154300	2132	148228229000	20199	10173	7	0	771
321608	1874	14057000	20199	10173	7	0	2
4716	633	85324181900000	20199	10173	9	0	5
10812	1402	69694911319298	20201	10174	3	0	33
154309	2133	96690390000	20202	10175	2	0	2305
321617	1874	14067000	20202	10175	2	0	2
12405	1439	4303571578477	20204	10176	4	0	10
154394	1397	1319928127000	20207	10177	0	0	11890
321702	1678	23040756973000	20207	10177	0	0	0
154395	2133	96688386000	20207	10177	1	0	2307
321703	1874	14074000	20207	10177	1	0	2
8863	1395	58139187252007706	20207	10177	3	0	0
154416	1397	1319898124000	20213	10179	1	0	11893
321724	1678	23040756976000	20213	10179	1	0	0
154422	2133	96685380000	20213	10179	7	0	2310
321730	1874	14091000	20213	10179	7	0	2
6414	1394	433447302500000	20214	10180	4	0	0
154441	1397	1319868121000	20217	10181	1	0	11896
321749	1678	23040756979000	20217	10181	1	0	0
321797	1678	23040756980000	20223	10182	0	0	0
321798	1678	23040756981000	20223	10182	1	0	0
154491	1397	1319838118000	20223	10182	2	0	11899
321804	1874	14113000	20223	10182	7	0	2
154497	2134	96248771000	20223	10182	8	0	2743
154498	2134	96247768000	20223	10182	9	0	2744
321822	1678	23040756984000	20228	10184	0	0	0
154516	2133	96678366000	20228	10184	2	0	2317
321827	1874	14133000	20228	10184	5	0	2
154522	2133	96676362000	20229	10185	2	0	2319
30959	1668	3393466000000	20229	10185	4	0	9
321833	1874	14142000	20230	10186	1	0	2
154530	1397	1319778112000	20232	10187	0	0	11905
321842	1874	14147000	20232	10187	4	0	2
16859	1489	20064535000000	20232	10187	7	0	4
154540	1397	1319768111000	20234	10188	0	0	11906
321851	1874	14155000	20234	10188	3	0	2
50329	1705	15755627500145	20234	10188	4	0	20
154603	2134	96239744000	20237	10189	2	0	2752
26223	1613	18648099600000	20237	10189	4	0	6
321913	1874	14163000	20238	10190	1	0	2
321914	1874	14165000	20238	10190	2	0	2
154608	1397	1319738108000	20239	10191	1	0	11909
44385	1690	139684476000000	20239	10191	5	0	0
321928	1049	908328241448562	20242	10192	1	0	0
154622	606	66766513286230	20242	10192	3	0	18
8874	1395	58140627333007706	20242	10192	8	0	0
321934	1678	23040756994000	20243	10193	0	0	0
154628	2134	96235732000	20243	10193	2	0	2756
6422	1394	437767338500000	20243	10193	3	0	0
321939	1678	23040756996000	20244	10194	2	0	0
154633	2132	148220221000	20244	10194	4	0	779
154634	2133	96667344000	20244	10194	5	0	2328
60468	2248	1439285000000	20244	10194	9	0	0
321945	1678	23040756997000	20245	10195	0	0	0
154640	2134	96232723000	20245	10195	3	0	2759
58530	1943	2878931000000	20245	10195	6	0	1
321951	1678	23040756999000	20246	10196	0	0	0
154646	2133	96663336000	20246	10196	3	0	2332
321956	1874	14210000	20246	10196	5	0	2
154651	1397	1319638098000	20247	10197	1	0	11919
321962	1874	14218000	20247	10197	4	0	2
154657	2134	96227708000	20247	10197	7	0	2764
321977	1874	14229000	20249	10198	1	0	2
154672	2133	96657324000	20250	10199	1	0	2338
46180	1693	2342214908632	20250	10199	4	0	979
321989	1678	23040757006000	20252	10200	0	0	0
154684	2134	96223696000	20252	10200	3	0	2768
321995	1874	14247000	20252	10200	6	0	2
154703	1397	1319558090000	20254	10201	2	0	11927
322014	1874	14252000	20254	10201	5	0	2
154709	2133	96651312000	20254	10201	8	0	2344
322019	1874	14262000	20254	10201	10	0	2
154714	1397	1319538088000	20255	10202	0	0	11929
322030	1678	23040757013000	20258	10203	0	0	0
154725	2134	96217678000	20258	10203	3	0	2774
322036	1874	14284000	20258	10203	6	0	2
154731	2133	96647304000	20259	10204	2	0	2348
6429	1394	440647398500000	20259	10204	4	0	0
322041	1874	14292000	20260	10205	1	0	2
19952	1547	19293730000000	20260	10205	4	0	6
322062	1678	23040757017000	20265	10206	0	0	0
154755	1397	1319478082000	20265	10206	1	0	11935
322063	1678	23040757018000	20265	10206	1	0	0
154761	1397	1319468081000	20266	10207	0	0	11936
322069	1678	23040757019000	20266	10207	0	0	0
48450	1698	21417215550035	20266	10207	4	0	7
154770	1397	1319458080000	20269	10208	0	0	11937
154771	2134	96211660000	20269	10208	1	0	2780
20878	1559	18682858000000	20269	10208	3	0	4
322081	1678	23040757021000	20270	10209	0	0	0
154777	2134	96209654000	20270	10209	4	0	2782
322101	1678	23040757022000	20274	10210	0	0	0
154798	2134	96208651000	20274	10210	5	0	2783
322107	1874	14334000	20274	10210	6	0	2
154803	2132	148211212000	20275	10211	3	0	788
322113	1874	14342000	20275	10211	5	0	2
154809	2134	96204639000	20276	10212	2	0	2787
322118	1874	14351000	20276	10212	3	0	2
22358	1587	720000000000	20276	10212	6	0	14
154952	2132	148210211000	20281	10213	0	0	789
322258	1874	14356000	20281	10213	0	0	2
154953	1397	1319378072000	20282	10214	0	0	11945
322259	1678	23040757028000	20282	10214	0	0	0
154971	1397	1319358070000	20285	10215	0	0	11947
322277	1678	23040757030000	20285	10215	0	0	0
155002	1397	1319338068000	20290	10216	0	0	11949
322308	1678	23040757032000	20290	10216	0	0	0
155007	2133	96628266000	20290	10216	5	0	2367
322313	1874	14386000	20290	10216	5	0	2
12296	1426	24045235000000	20290	10216	8	0	4
322339	1678	23040757034000	20295	10217	0	0	0
322340	1874	14389000	20295	10217	1	0	2
155037	1397	1319298064000	20296	10218	1	0	11953
322346	1874	14397000	20296	10218	4	0	2
155041	2133	96625260000	20296	10218	5	0	2370
155042	2133	96624258000	20296	10218	6	0	2371
322352	1678	23040757039000	20297	10219	1	0	0
155048	2133	96623256000	20297	10219	3	0	2372
322357	1874	14416000	20297	10219	6	0	2
155057	2133	96621252000	20299	10220	2	0	2374
322366	1874	14424000	20300	10221	2	0	2
155062	2133	96619248000	20300	10221	4	0	2376
40282	1685	137522861571430	20300	10221	8	0	0
322372	1874	14435000	20301	10222	1	0	2
8886	1395	58142787406007706	20301	10222	4	0	0
155068	1397	1319218056000	20302	10223	0	0	11961
322380	1678	23040757045000	20304	10224	0	0	0
155077	2133	96616242000	20304	10224	3	0	2379
467	43	84000972890000	20304	10224	4	0	1
322386	1874	14453000	20305	10225	2	0	2
22267	1573	15099281000000	20305	10225	4	0	5
155082	1397	1319178052000	20306	10226	1	0	11965
322392	1874	14461000	20306	10226	5	0	2
155091	1397	1319168051000	20308	10227	0	0	11966
322400	1678	23040757050000	20309	10228	0	0	0
23907	1596	20881018000000	20309	10228	4	0	11
155097	1397	1319148049000	20310	10229	0	0	11968
322406	1874	14478000	20310	10229	3	0	2
155102	2133	96610230000	20310	10229	5	0	2385
322412	1874	14490000	20311	10230	2	0	2
6440	1394	444967434500000	20311	10230	3	0	0
155113	2134	96177558000	20314	10231	1	0	2814
322426	1874	14499000	20316	10232	1	0	2
155127	1397	1319088043000	20318	10233	2	0	11974
322436	1874	14503000	20318	10233	5	0	2
155132	2134	96173546000	20318	10233	7	0	2818
322454	1874	14514000	20320	10234	4	0	2
155150	2133	96604218000	20320	10234	6	0	2391
322457	1874	14520000	20320	10234	7	0	2
322458	1874	14522000	20320	10234	8	0	2
155156	1681	3491034109853	20320	10234	12	0	11
25401	1610	2160046999950	20320	10234	13	0	11
322464	1678	23040757061000	20321	10235	1	0	0
155161	2133	96601212000	20321	10235	4	0	2394
155179	1397	1319038038000	20326	10236	0	0	11979
155180	2134	96169534000	20326	10236	1	0	2822
322486	1874	14535000	20326	10236	1	0	2
322491	1874	14540000	20327	10237	2	0	2
155186	2134	96168531000	20327	10237	3	0	2823
155322	1397	1319008035000	20331	10238	0	0	11982
322628	1678	23040757065000	20331	10238	0	0	0
155323	2133	96596202000	20331	10238	1	0	2399
322629	1874	14547000	20331	10238	1	0	2
28842	1637	236885612819988	20331	10238	4	0	0
155329	1397	1318988033000	20333	10240	0	0	11984
322635	1678	23040757067000	20333	10240	0	0	0
155335	2133	96593196000	20334	10241	3	0	2402
322641	1874	14564000	20334	10241	3	0	2
155340	1397	1318948029000	20335	10242	1	0	11988
322646	1678	23040757071000	20335	10242	1	0	0
155352	2133	96589188000	20337	10243	1	0	2406
322658	1874	14584000	20337	10243	1	0	2
155364	369	86101373736560	20339	10244	3	0	13
322670	946	508296362263440	20339	10244	3	0	0
155418	2134	96158501000	20343	10245	2	0	2833
322724	1874	14596000	20343	10245	2	0	2
322729	1874	14603000	20344	10246	2	0	2
155424	2133	96585180000	20344	10246	3	0	2410
322730	1874	14605000	20344	10246	3	0	2
8896	1395	58144947465007706	20346	10247	4	0	0
155433	1397	1318868021000	20347	10248	0	0	11996
322739	1678	23040757079000	20347	10248	0	0	0
155438	2134	96153486000	20347	10248	5	0	2838
322745	1874	14626000	20347	10248	6	0	2
14847	1457	25104522040000	20347	10248	9	0	4
155444	2133	96579168000	20348	10249	2	0	2416
322750	1874	14635000	20348	10249	2	0	2
36128	1680	18009739490035	20348	10249	3	0	6
155449	2133	96578166000	20350	10250	1	0	2417
155450	2134	96150477000	20350	10250	2	0	2841
6450	1394	447847482500000	20350	10250	4	0	0
322768	1678	23040757085000	20355	10252	0	0	0
155468	1397	1318798014000	20357	10253	0	0	12003
322777	1678	23040757087000	20358	10254	0	0	0
155474	2134	96147468000	20358	10254	3	0	2844
322782	1874	14662000	20358	10254	5	0	2
155525	2134	96145462000	20360	10255	2	0	2846
322834	1874	14669000	20361	10256	2	0	2
44947	1691	20843395100019	20361	10256	4	0	5
155531	1596	7704086180381	20362	10257	1	0	13
322840	1874	14675000	20362	10257	4	0	2
155543	2133	96569148000	20364	10258	1	0	2426
322851	1678	23040757093000	20365	10259	0	0	0
8903	1395	58146387487507701	20365	10259	4	0	0
155551	1596	720000000000	20367	10260	0	0	16
322860	1678	23040757095000	20368	10261	0	0	0
155557	2133	96566142000	20368	10261	3	0	2429
322865	1874	14700000	20368	10261	5	0	2
35406	1679	26639318653000	20368	10261	6	0	50
322882	1678	23040757097000	20370	10262	0	0	0
155579	1560	21889679986418	20370	10262	3	0	16
322888	264	66772980736837	20370	10262	6	0	0
155584	1560	20365508533503	20370	10262	8	0	21
155585	1560	20060674242920	20370	10262	9	0	22
155586	1560	19755839952337	20370	10262	10	0	23
322894	505	66772980736837	20370	10262	12	0	0
155592	1560	2889580131803	20370	10262	16	0	29
322916	1678	23040757098000	20372	10263	0	0	0
42873	1688	72720779905200	20372	10263	4	0	38
155615	2134	96135432000	20373	10264	1	0	2856
322922	1874	14715000	20373	10264	2	0	2
41213	1687	10700237223172	20376	10265	4	0	6
155687	1397	1318647999000	20379	10266	0	0	12018
322995	1874	14723000	20379	10266	2	0	2
11120	1419	7487973560130	20379	10266	6	0	6
155693	1397	1318627997000	20380	10267	0	0	12020
323000	1874	14733000	20380	10267	1	0	2
323001	1874	14735000	20380	10267	2	0	2
323005	1678	23040757104000	20382	10268	0	0	0
44395	1690	141844538000000	20382	10268	4	0	0
155702	1397	1318607995000	20383	10269	0	0	12022
323011	1874	14745000	20384	10270	1	0	2
10839	1402	71854949319298	20384	10270	3	0	33
155735	1397	1318587993000	20386	10271	0	0	12024
155736	2133	96555120000	20386	10271	1	0	2440
323048	1678	23040757109000	20389	10273	1	0	0
155745	2134	96127408000	20389	10273	4	0	2864
323053	1874	14763000	20389	10273	6	0	2
155751	2134	96124399000	20390	10274	1	0	2867
323059	1678	23040757112000	20391	10275	0	0	0
155756	2133	96550110000	20391	10275	3	0	2445
323065	1874	14783000	20391	10275	6	0	2
155778	1397	1318507985000	20396	10276	0	0	12032
323086	1874	14792000	20396	10276	2	0	2
155910	1397	1318487983000	20400	10278	0	0	12034
323216	1678	23040757117000	20400	10278	0	0	0
155911	2133	96545100000	20400	10278	1	0	2450
323217	1874	14796000	20400	10278	1	0	2
155963	1397	1318457980000	20405	10280	1	0	12037
323269	1678	23040757120000	20405	10280	1	0	0
323273	1874	14809000	20405	10280	5	0	2
323274	1874	14811000	20405	10280	6	0	2
155969	2133	96541092000	20405	10280	7	0	2454
23695	1596	1440048000000	20405	10280	13	0	16
155974	1397	1318427977000	20406	10281	0	0	12040
323280	1678	23040757123000	20406	10281	0	0	0
155980	2134	96111360000	20407	10282	3	0	2880
323286	1874	14835000	20407	10282	3	0	2
46304	1693	3782226908632	20407	10282	6	0	979
323291	907	508157428951432	20408	10283	2	0	0
155986	1680	11611991096895	20408	10283	3	0	9
156006	1397	1318387973000	20412	10284	0	0	12044
156007	1680	8966092477127	20412	10284	1	0	10
323315	1993	2816349532446	20412	10284	3	0	1
156029	1397	1318367971000	20414	10285	1	0	12046
323337	1874	14853000	20414	10285	3	0	2
156035	1726	36128112000	20414	10285	7	0	8257
323342	1874	14857000	20414	10285	8	0	2
156055	1726	34927112000	20417	10286	2	0	8258
323363	2255	200000000	20417	10286	4	0	0
156072	2134	96105342000	20420	10287	3	0	2886
323380	1874	14875000	20420	10287	5	0	2
6461	1394	452167532500000	20422	10288	4	0	0
156084	1397	1318317966000	20423	10289	0	0	12051
323391	1874	14881000	20423	10289	1	0	2
40918	1686	20372228550062	20423	10289	4	0	9
57386	1764	16567131100000	20428	10290	2	0	8
156101	2133	96527064000	20428	10290	3	0	2468
323417	1678	23040757136000	20431	10291	0	0	0
323418	1678	23040757137000	20431	10291	1	0	0
156116	2134	96100327000	20431	10291	5	0	2891
323424	1874	14899000	20431	10291	7	0	2
156131	1397	1318277962000	20434	10292	0	0	12055
156132	1991	23188695338131	20434	10292	1	0	13
323452	1678	23040757139000	20436	10293	0	0	0
156148	2133	96523056000	20436	10293	2	0	2472
323457	675	66578558947810	20436	10293	5	0	0
156154	1991	14917115212725	20436	10293	8	0	19
28850	1637	239045660819988	20436	10293	11	0	0
323484	1678	23040757140000	20439	10294	0	0	0
156180	2133	96522054000	20439	10294	2	0	2473
32311	1672	27362252000000	20442	10295	3	0	5
323497	1678	23040757142000	20444	10296	0	0	0
35466	1679	28079381653000	20444	10296	3	0	50
156195	1397	1318227957000	20446	10297	0	0	12060
323504	1874	14928000	20446	10297	3	0	2
156204	2134	96094309000	20448	10298	2	0	2897
10855	1402	73294985319298	20448	10298	4	0	33
323519	1874	14938000	20451	10299	2	0	2
156221	2224	717943000000	20453	10300	1	0	2
323531	1874	14944000	20453	10300	5	0	2
6468	1394	456487581500000	20453	10300	7	0	0
156239	2134	96091300000	20456	10301	1	0	2900
323545	1874	14947000	20456	10301	1	0	2
323546	1874	14949000	20456	10301	2	0	2
156253	2133	96513036000	20461	10303	1	0	2482
323560	1874	14957000	20461	10303	2	0	2
156261	1397	1318147949000	20464	10305	0	0	12068
27739	1634	21792388641004	20464	10305	2	0	9
156266	2256	90000000	20466	10306	0	0	1
323572	1498	0	20466	10306	0	0	0
156267	1397	1318137948000	20466	10306	1	0	12069
323702	1678	23040757153000	20468	10307	0	0	0
323703	1874	14973000	20468	10307	1	0	2
156398	2133	96509028000	20468	10307	2	0	2486
8911	1395	58148547524507701	20468	10307	5	0	0
156404	1397	1318117946000	20470	10308	0	0	12071
156405	2134	96085282000	20470	10308	1	0	2906
323713	1678	23040757155000	20471	10309	0	0	0
156415	2133	96506022000	20473	10310	1	0	2489
323723	1874	14994000	20473	10310	3	0	2
156426	1703	10080817000000	20477	10312	1	0	4
323733	1874	14998000	20477	10312	2	0	2
156554	633	78456198900000	20479	10313	0	0	6
323860	1384	1710568637751650	20479	10313	0	0	0
156555	633	74037178900000	20479	10313	1	0	7
323861	1138	909796465000000	20479	10313	1	0	0
156561	1397	1318047939000	20479	10313	7	0	12078
323867	1678	23040757161000	20479	10313	7	0	0
156567	2134	96081270000	20479	10313	13	0	2910
323873	1874	15005000	20479	10313	13	0	2
156572	2133	96502014000	20479	10313	18	0	2493
323878	1874	15018000	20479	10313	18	0	2
156578	2133	96499008000	20479	10313	24	0	2496
323884	1874	15031000	20479	10313	24	0	2
4443	633	69309303900000	20479	10313	27	0	9
23314	1593	25030476000000	20481	10314	3	0	4
156596	2134	96075252000	20485	10315	2	0	2916
323902	1874	15038000	20485	10315	2	0	2
156637	2133	96495000000	20488	10316	2	0	2500
323943	1874	15043000	20488	10316	2	0	2
323954	1678	23040757169000	20491	10317	0	0	0
323955	1874	15052000	20491	10317	1	0	2
156650	2134	96072243000	20491	10317	2	0	2919
28855	1637	240485715819988	20491	10317	4	0	0
323961	1874	15061000	20492	10318	4	0	2
156656	2134	96069234000	20492	10318	5	0	2922
36221	1681	4211070109853	20492	10318	10	0	11
156661	2134	96068231000	20493	10319	1	0	2923
323967	1874	15073000	20493	10319	1	0	2
323972	1874	15081000	20494	10320	2	0	2
156667	1397	1317907925000	20495	10321	0	0	12092
30604	1656	21741751999990	20495	10321	3	0	4
156674	1397	1317897924000	20499	10322	0	0	12093
156675	2132	148182183000	20499	10322	1	0	817
323983	1874	15089000	20499	10322	3	0	2
156689	1397	1317877922000	20503	10324	0	0	12095
323997	1874	15099000	20503	10324	2	0	2
1347	149	86430628000341	20503	10324	4	0	5
156698	2134	96063216000	20507	10325	3	0	2928
156826	1397	1317857920000	20510	10326	0	0	12097
324132	1678	23040757180000	20510	10326	0	0	0
156827	2134	96062213000	20510	10326	1	0	2929
324133	1874	15108000	20510	10326	1	0	2
59105	1992	21599525990000	20510	10326	3	0	0
1624	171	81830544524688	20514	10327	4	0	4
156884	1397	1317827917000	20517	10328	1	0	12100
324190	1678	23040757183000	20517	10328	1	0	0
156890	1726	31324112000	20517	10328	7	0	8261
324196	2206	3799000000	20517	10328	7	0	1
59527	2086	2335310300069	20517	10328	11	0	2
156895	2134	96056195000	20517	10328	13	0	2935
324201	1874	15132000	20517	10328	13	0	2
156901	1726	30123112000	20517	10328	19	0	8262
324207	2205	3799000000	20517	10328	19	0	1
156917	2133	96475962000	20520	10329	2	0	2519
324223	1874	15144000	20520	10329	2	0	2
324225	1874	15149000	20520	10329	4	0	2
324226	1874	15152000	20520	10329	5	0	2
156928	2134	96053186000	20522	10330	1	0	2938
32548	1673	29125594000000	20522	10330	4	0	10
324246	963	506768371327637	20525	10331	1	0	0
156942	1651	19486456745295	20525	10331	3	0	8
156945	1474	10849153951023	20525	10331	6	0	24
156946	2133	96472956000	20525	10331	7	0	2522
324252	1874	15160000	20525	10331	7	0	2
324257	1210	614519753200000	20525	10331	12	0	0
4133	632	69597201000000	20525	10331	13	0	9
156952	1474	8604958183403	20526	10332	0	0	25
324263	1172	611542919692213	20526	10332	5	0	0
156958	1718	978396519070	20526	10332	6	0	13
156963	2133	96470952000	20527	10333	3	0	2524
324269	1874	15170000	20527	10333	3	0	2
324278	1678	23040757193000	20530	10335	0	0	0
156973	2134	96049174000	20530	10335	1	0	2942
324302	1874	15183000	20535	10336	3	0	2
156997	2134	96048171000	20535	10336	4	0	2943
157029	2133	96466944000	20538	10337	4	0	2528
324335	1874	15192000	20538	10337	4	0	2
324340	1678	23040757198000	20540	10339	0	0	0
157035	1474	2350325000043	20540	10339	1	0	26
324346	1874	15207000	20541	10340	1	0	2
59953	2112	720011000000	20541	10340	3	0	6
157041	1397	1317657900000	20542	10341	0	0	12117
157046	2179	190000000	20543	10342	1	0	1
324352	1678	23040757201000	20543	10342	2	0	0
157052	2134	96042153000	20543	10342	7	0	2949
324357	1874	15221000	20543	10342	7	0	2
324361	1874	15228000	20544	10343	2	0	2
51455	1710	3113874664140	20544	10343	4	0	10
324365	1678	23040757204000	20546	10344	0	0	0
157061	2134	96040147000	20546	10344	1	0	2951
157069	2134	96039144000	20551	10346	3	0	2952
324374	1874	15237000	20551	10346	3	0	2
157081	2133	96454920000	20554	10347	2	0	2540
324386	1874	15249000	20554	10347	2	0	2
157082	1397	1317577892000	20555	10348	0	0	12125
8921	1395	58150707561507701	20555	10348	5	0	0
324398	1678	23040757209000	20558	10349	0	0	0
157095	1634	22479815909139	20558	10349	2	0	11
324404	965	507350663452652	20558	10349	6	0	0
157101	1634	12406468095072	20558	10349	8	0	17
324410	1874	15260000	20558	10349	12	0	2
157106	2133	96451914000	20558	10349	13	0	2543
17880	1509	20832231351155	20558	10349	15	0	5
324494	2003	2428970654821	20565	10351	0	0	1
157192	1397	1317527887000	20565	10351	2	0	12130
324497	1874	15268000	20565	10351	3	0	2
324498	1874	15270000	20565	10351	4	0	2
157350	1397	1317517886000	20574	10352	0	0	12131
324653	1678	23040757214000	20574	10352	0	0	0
157351	2133	96447906000	20574	10352	1	0	2547
324654	1874	15280000	20574	10352	1	0	2
157353	2245	199000000	20574	10352	3	0	1
44405	1690	144004601000000	20574	10352	4	0	0
157358	2179	90000000	20576	10353	0	0	2
324771	1678	23040757216000	20581	10354	0	0	0
324772	1874	15289000	20581	10354	1	0	2
157473	2133	96445902000	20581	10354	2	0	2549
324786	1874	15295000	20583	10355	4	0	2
157487	2133	96444900000	20583	10355	5	0	2550
157489	1397	1317467881000	20584	10356	0	0	12136
157490	1506	12997246967172	20584	10356	1	0	18
324792	1248	612520075567628	20584	10356	3	0	0
157496	1506	1960016967172	20584	10356	7	0	21
324797	1874	15303000	20584	10356	8	0	2
157526	2134	96026105000	20588	10357	3	0	2965
324837	1678	23040757221000	20592	10358	0	0	0
41268	1687	12860273223172	20592	10358	3	0	6
157541	1440	10002643045924	20593	10359	1	0	8
324843	1874	15318000	20593	10359	3	0	2
157681	1397	1317427877000	20597	10360	0	0	12140
324980	1678	23040757223000	20597	10360	0	0	0
157682	2133	96439890000	20597	10360	1	0	2555
324981	1874	15323000	20597	10360	1	0	2
157688	2132	148167168000	20599	10362	2	0	832
324987	1874	15331000	20599	10362	2	0	2
8927	1395	58152867608507701	20599	10362	4	0	0
157701	2133	96435882000	20604	10364	1	0	2559
325000	1874	15341000	20604	10364	1	0	2
157734	2133	96434880000	20609	10365	4	0	2560
325032	1874	15347000	20609	10365	4	0	2
157740	2134	96019084000	20610	10366	4	0	2972
325038	1874	15353000	20610	10366	4	0	2
325041	1874	15360000	20610	10366	7	0	2
325042	1874	15362000	20610	10366	8	0	2
6480	1394	460807626500000	20610	10366	10	0	0
157756	1397	1317327867000	20612	10367	0	0	12150
157762	1397	1317317866000	20614	10368	0	0	12151
157763	2133	96428868000	20614	10368	1	0	2566
325061	1874	15372000	20614	10368	1	0	2
157772	2134	96014069000	20616	10369	4	0	2977
325070	1678	23040757236000	20617	10370	0	0	0
157778	1397	1317277862000	20618	10371	0	0	12155
325075	1874	15390000	20618	10371	1	0	2
157783	2133	96424860000	20618	10371	5	0	2570
20514	1555	13155363979096	20618	10371	7	0	4
325081	2262	200000000	20619	10372	1	0	0
157789	2134	96010057000	20619	10372	4	0	2981
325106	2264	200000000	20621	10373	3	0	0
157904	2179	0	20625	10374	0	0	3
325187	2260	280000000	20625	10374	0	0	0
157905	2133	96421854000	20625	10374	1	0	2573
325188	1874	15406000	20625	10374	1	0	2
157911	1397	1317267861000	20626	10375	0	0	12156
325194	1874	15417000	20626	10375	2	0	2
2406	470	68160114000000	20626	10375	7	0	11
157917	1397	1317257860000	20627	10376	0	0	12157
325200	1874	15429000	20627	10376	2	0	2
157922	1397	1317247859000	20628	10377	0	0	12158
325205	1678	23040757243000	20628	10377	2	0	0
157928	2133	96414840000	20628	10377	6	0	2580
325211	1369	1707805295351650	20628	10377	8	0	0
157934	1397	1317217856000	20629	10378	0	0	12161
325217	1874	15446000	20629	10378	2	0	2
157939	2134	96002033000	20629	10378	5	0	2989
325222	1308	1708575037751650	20630	10379	0	0	0
157945	1397	1317197854000	20630	10379	4	0	12163
325228	1874	15456000	20630	10379	6	0	2
157951	2132	148159160000	20630	10379	11	0	840
8934	1395	58154308059507701	20630	10379	14	0	0
325234	1307	1712116157751650	20631	10380	0	0	0
157956	1397	1317177852000	20631	10380	3	0	12165
325239	1035	910608555000000	20631	10380	5	0	0
157962	2133	96409830000	20631	10380	9	0	2585
325245	1874	15475000	20631	10380	11	0	2
40291	1685	139682908571430	20631	10380	12	0	0
157979	1397	1317157850000	20633	10381	3	0	12167
325262	1037	908124585000000	20633	10381	5	0	0
157984	2134	95996015000	20633	10381	8	0	2995
325267	1874	15481000	20633	10381	10	0	2
157993	1397	1317137848000	20636	10383	0	0	12169
325276	1678	23040757253000	20637	10384	0	0	0
158003	1397	1317117846000	20639	10385	0	0	12171
325286	1874	15499000	20639	10385	2	0	2
158008	2133	96402816000	20640	10386	2	0	2592
325291	1678	23040757257000	20641	10387	1	0	0
158014	2132	148156157000	20641	10387	5	0	843
325297	1874	15514000	20642	10388	1	0	2
35835	1680	1453061499559	20642	10388	3	0	12
158026	2133	96398808000	20645	10389	2	0	2596
56284	1749	11525395930000	20645	10389	3	0	19
158149	1397	1317057840000	20648	10390	0	0	12177
325423	1678	23040757260000	20648	10390	0	0	0
158150	2132	148155156000	20648	10390	1	0	844
325424	1874	15523000	20648	10390	1	0	2
158282	1397	1317047839000	20653	10391	0	0	12178
325555	1678	23040757261000	20653	10391	0	0	0
158283	2134	95986988000	20653	10391	1	0	3004
325556	1874	15531000	20653	10391	1	0	2
6486	1394	465127687500000	20654	10392	3	0	0
158304	2134	95984982000	20659	10393	1	0	3006
325577	1874	15541000	20659	10393	1	0	2
158305	2133	96394800000	20659	10393	2	0	2600
158306	2132	148154155000	20659	10393	3	0	845
325585	1874	15549000	20661	10394	2	0	2
325589	1678	23040757265000	20664	10395	0	0	0
158331	1397	1316997834000	20666	10396	0	0	12183
325608	1874	15553000	20666	10396	4	0	2
158337	2133	96389790000	20666	10396	6	0	2605
325614	1874	15566000	20666	10396	10	0	2
158342	2134	95980970000	20666	10396	11	0	3010
325632	1874	15575000	20668	10397	2	0	2
158364	2134	95978964000	20670	10398	2	0	3012
19965	1547	21453763000000	20670	10398	4	0	6
325647	1874	15585000	20673	10399	2	0	2
158385	1397	1316917826000	20675	10400	1	0	12191
325662	1874	15590000	20675	10400	5	0	2
158390	2134	95976958000	20675	10400	6	0	3014
13618	1447	18873639943000	20675	10400	9	0	6
325688	1874	15602000	20679	10401	1	0	2
58467	1918	2879161000000	20679	10401	4	0	1
158449	1397	1316887823000	20681	10402	0	0	12194
325722	1678	23040757277000	20681	10402	0	0	0
158450	2132	148150151000	20681	10402	1	0	849
325723	1874	15605000	20681	10402	1	0	2
51108	1708	18756019000021	20681	10402	4	0	4
158583	1397	1316877822000	20685	10403	0	0	12195
158584	2134	95972946000	20685	10403	1	0	3018
325857	1874	15612000	20685	10403	2	0	2
325858	1678	23040757279000	20686	10404	0	0	0
158593	2134	95970940000	20688	10405	1	0	3020
325867	1874	15623000	20688	10405	3	0	2
28863	1637	242645763819988	20688	10405	5	0	0
8943	1395	58156468095507701	20689	10406	4	0	0
158604	1397	1316837818000	20692	10407	0	0	12199
325878	1874	15633000	20692	10407	2	0	2
158609	1397	1316817816000	20693	10408	2	0	12201
325883	1874	15639000	20693	10408	4	0	2
158651	1656	9754523999990	20696	10409	0	0	6
325924	977	508248775000000	20696	10409	2	0	0
158663	2134	95965925000	20698	10410	0	0	3025
5196	686	68880045000000	20698	10410	2	0	0
325944	1678	23040757286000	20700	10411	0	0	0
158676	2132	148147148000	20700	10411	3	0	852
325949	1874	15658000	20700	10411	5	0	2
3096	526	68160114000000	20700	10411	8	0	2
158701	2133	96369750000	20704	10412	1	0	2625
1407	171	68826645696494	20704	10412	4	0	8
325974	1678	23040757290000	20705	10413	0	0	0
158707	2134	95960910000	20705	10413	4	0	3030
325980	1874	15676000	20705	10413	6	0	2
158712	2133	96366744000	20706	10414	1	0	2628
158719	1397	1316727807000	20711	10415	0	0	12210
158720	2133	96365742000	20711	10415	1	0	2629
325991	1874	15682000	20711	10415	1	0	2
325993	1874	15686000	20711	10415	3	0	2
326004	1678	23040757294000	20715	10416	0	0	0
16243	1476	720000000000	20715	10416	3	0	11
158816	1397	1316707805000	20718	10417	0	0	12212
326089	1678	23040757296000	20720	10418	0	0	0
15192	1458	23853850908540	20720	10418	2	0	4
158996	1397	1316687803000	20729	10420	0	0	12214
326266	1678	23040757297000	20729	10420	0	0	0
158997	1397	1316677802000	20729	10420	1	0	12215
326267	1678	23040757298000	20729	10420	1	0	0
159003	2133	96361734000	20729	10420	7	0	2633
326273	1874	15710000	20729	10420	7	0	2
159009	2258	199000000	20730	10421	3	0	1
326279	1483	10000000	20730	10421	3	0	0
159014	2132	148143144000	20730	10421	8	0	856
326284	1874	15724000	20730	10421	8	0	2
159030	2133	96354720000	20732	10422	4	0	2640
326300	1874	15734000	20732	10422	4	0	2
48063	1696	20657558835100	20733	10423	3	0	5
159043	1397	1316597794000	20736	10424	0	0	12223
326313	1678	23040757306000	20736	10424	0	0	0
159051	2132	148141142000	20738	10425	2	0	858
326321	1874	15751000	20738	10425	2	0	2
159067	1688	71094449872200	20740	10426	4	0	41
326337	40	66569445570000	20740	10426	4	0	0
159073	1688	70393491800200	20741	10427	0	0	43
326343	780	308196473040051	20741	10427	0	0	0
159078	2133	96348708000	20741	10427	5	0	2646
326348	1874	15769000	20741	10427	5	0	2
50359	1705	17915678500145	20741	10427	7	0	20
159097	2133	96347706000	20744	10428	4	0	2647
326367	1874	15772000	20744	10428	4	0	2
159103	2133	96346704000	20745	10429	4	0	2648
326373	1874	15780000	20745	10429	4	0	2
159115	2133	96345702000	20747	10430	4	0	2649
326385	1874	15782000	20747	10430	4	0	2
159130	1688	54830476494200	20750	10431	0	0	54
159131	1397	1316517786000	20750	10431	1	0	12231
326401	1678	23040757314000	20750	10431	1	0	0
326402	823	1739885117760760	20750	10431	2	0	0
159137	1698	19351753841201	20751	10432	1	0	9
326408	1050	911103943218016	20751	10432	2	0	0
159143	2134	95939847000	20751	10432	7	0	3051
326414	1678	23040757316000	20752	10433	0	0	0
159148	2132	148138139000	20752	10433	4	0	861
326435	1678	23040757317000	20756	10434	0	0	0
159170	2134	95937841000	20756	10434	5	0	3053
29769	1650	2992863000000	20756	10434	7	0	9
326501	1706	16053356600135	20761	10436	0	0	20
159236	1397	1316467781000	20761	10436	5	0	12236
326507	853	247856948044225	20761	10436	6	0	0
159241	2132	148137138000	20761	10436	10	0	862
326512	1874	15810000	20761	10436	11	0	2
159419	1679	18810610696000	20766	10437	0	0	60
326689	865	400855996215417	20766	10437	0	0	0
159420	1679	14449449713000	20766	10437	1	0	61
326690	867	2441303436168000	20766	10437	1	0	0
159445	2133	96337686000	20769	10438	2	0	2657
326715	1874	15819000	20769	10438	2	0	2
159477	1679	10754122645000	20773	10439	5	0	68
326747	891	497302551695750	20773	10439	5	0	0
159482	2133	96335682000	20773	10439	10	0	2659
326752	1874	15823000	20773	10439	10	0	2
159506	2133	96334680000	20776	10440	4	0	2660
326776	1874	15826000	20776	10440	4	0	2
159512	2133	96332676000	20777	10441	5	0	2662
326782	1874	15831000	20777	10441	5	0	2
58537	1943	4319013000000	20777	10441	7	0	1
45726	1692	42980781619999	20779	10442	3	0	5
159522	1397	1316367771000	20780	10443	2	0	12246
326792	1678	23040757329000	20780	10443	2	0	0
41428	1688	12022886210200	20780	10443	9	0	56
159528	1397	1316347769000	20781	10444	0	0	12248
326798	1678	23040757331000	20781	10444	0	0	0
159529	2133	96327666000	20781	10444	1	0	2667
50748	1706	18210367600135	20781	10444	3	0	20
159530	1440	3040153045924	20782	10445	0	0	10
326804	1874	15843000	20782	10445	4	0	2
159588	1397	1316327767000	20788	10446	0	0	12250
326858	1678	23040757333000	20788	10446	0	0	0
326859	1011	507974815000000	20789	10447	0	0	0
159594	1397	1316307765000	20790	10448	0	0	12252
326865	875	213990794972583	20790	10448	1	0	0
6501	1394	469447748500000	20790	10448	3	0	0
159603	2132	148132133000	20792	10449	2	0	867
326875	1678	23040757337000	20793	10450	0	0	0
159609	1706	17692670842297	20794	10451	2	0	22
326880	744	2017112805578	20794	10451	3	0	0
159615	1706	9800864302936	20795	10452	2	0	26
326886	1354	1708465542884770	20795	10452	3	0	0
159626	1397	1316257760000	20797	10453	0	0	12257
326898	1874	15863000	20798	10454	1	0	2
14265	1451	16459046000000	20798	10454	2	0	9
6509	1394	472327832500000	20800	10455	4	0	0
159632	1397	1316227757000	20801	10456	0	0	12260
326903	1874	15868000	20801	10456	1	0	2
24246	1599	22660438393047	20801	10456	3	0	4
159638	2133	96314640000	20802	10457	4	0	2680
326909	1874	15873000	20802	10457	5	0	2
27468	1634	5422905259504	20802	10457	8	0	18
159645	576	77846549225192	20805	10459	0	0	5
326917	1229	613178594344390	20805	10459	2	0	0
159651	2133	96311634000	20805	10459	6	0	2683
326922	1874	15880000	20806	10460	1	0	2
59113	1992	23039560990000	20806	10460	3	0	0
1898	364	66720012000000	20808	10461	4	0	0
159660	1397	1316147749000	20809	10462	0	0	12268
159668	1397	1316137748000	20813	10463	0	0	12269
326937	1678	23040757352000	20813	10463	0	0	0
159669	2132	148127128000	20813	10463	1	0	872
159804	1397	1316117746000	20820	10465	0	0	12271
327072	1678	23040757354000	20820	10465	0	0	0
159805	2133	96305622000	20820	10465	1	0	2689
327073	1874	15893000	20820	10465	1	0	2
327081	1874	15898000	20824	10467	2	0	2
60609	2261	719000000000	20824	10467	3	0	0
60612	2261	719012000000	20824	10467	4	0	0
159819	1397	1316087743000	20827	10468	0	0	12274
327087	1678	23040757357000	20827	10468	0	0	0
49150	1701	3598110500103	20827	10468	2	0	14
159825	2132	148125126000	20829	10470	2	0	874
327093	1874	15905000	20829	10470	2	0	2
8959	1395	58158628251507701	20829	10470	3	0	0
14855	1457	26544605040000	20834	10471	5	0	4
159842	1397	1316047739000	20835	10472	0	0	12278
34906	1679	5038459654000	20835	10472	3	0	75
327147	1678	23040757362000	20838	10473	0	0	0
159887	2132	148124125000	20838	10473	4	0	875
53147	1717	21708333000023	20838	10473	6	0	4
327163	1306	1709649637751650	20842	10474	0	0	0
159904	1397	1316007735000	20844	10476	0	0	12282
327173	1678	23040757366000	20847	10477	0	0	0
159917	1992	4320510990000	20849	10478	0	0	5
327183	1678	23040757368000	20849	10478	2	0	0
159923	2132	148122123000	20850	10479	2	0	877
327188	1874	15928000	20850	10479	3	0	2
19655	1546	19441084000000	20852	10480	4	0	6
159942	1705	16147086490145	20854	10481	0	0	21
159943	1397	1315937728000	20854	10481	1	0	12289
327207	1678	23040757372000	20854	10481	1	0	0
159949	2133	96286584000	20854	10481	7	0	2708
327213	1874	15937000	20854	10481	7	0	2
327220	1114	908975568495245	20856	10482	0	0	0
327221	1678	23040757376000	20856	10482	1	0	0
159959	2133	96283578000	20856	10482	3	0	2711
48505	1699	1440296750126	20856	10482	5	0	7
23386	1594	1441521000000	20858	10483	2	0	10
327231	1360	1703067102686958	20859	10484	1	0	0
159968	1397	1315877722000	20859	10484	2	0	12295
327237	1381	1710569952951650	20859	10484	7	0	0
159974	1444	6246075689999	20859	10484	8	0	10
327242	1874	15951000	20859	10484	12	0	2
159980	2133	96278568000	20859	10484	14	0	2716
6519	1394	476647955500000	20859	10484	15	0	0
59968	2112	2160054000000	20860	10485	3	0	6
327248	1678	23040757383000	20861	10486	0	0	0
159985	1932	1382918664093	20861	10486	1	0	6
159991	2133	96274560000	20862	10487	4	0	2720
327254	1874	15964000	20862	10487	4	0	2
327264	1874	15969000	20864	10488	4	0	2
160002	1397	1315777712000	20865	10489	0	0	12305
160118	1397	1315767711000	20870	10490	0	0	12306
327379	1678	23040757389000	20870	10490	0	0	0
160119	2132	148116117000	20870	10490	1	0	883
327380	1874	15972000	20870	10490	1	0	2
50187	1705	5600489580140	20870	10490	3	0	25
20966	1560	3609580131803	20871	10491	4	0	29
160127	1397	1315737708000	20873	10492	0	0	12309
327388	1678	23040757392000	20873	10492	0	0	0
55505	1740	21525605000000	20874	10493	3	0	12
160137	1397	1315707705000	20876	10494	1	0	12312
327398	1678	23040757395000	20876	10494	1	0	0
28873	1637	244805838819988	20876	10494	5	0	0
160241	1397	1315697704000	20878	10495	0	0	12313
327500	1678	23040757396000	20878	10495	0	0	0
160242	2133	96263538000	20878	10495	1	0	2731
327501	1874	15989000	20878	10495	1	0	2
16868	1489	20784545000000	20881	10497	2	0	4
160345	149	69695228000341	20884	10498	1	0	10
327603	58	70307296999641	20884	10498	1	0	12
160346	2133	96261534000	20884	10498	2	0	2733
327611	1874	15999000	20888	10500	1	0	2
160358	1397	1315637698000	20892	10501	0	0	12319
21617	1564	17106620000000	20892	10501	3	0	5
327623	1874	16004000	20894	10502	2	0	2
160367	2133	96256524000	20895	10503	1	0	2738
327625	1874	16006000	20895	10503	1	0	2
327626	1678	23040757405000	20896	10504	0	0	0
8967	1395	58160788370507701	20896	10504	2	0	0
160375	2132	148111112000	20898	10505	2	0	888
6525	1394	480968067500000	20898	10505	3	0	0
327637	1874	16013000	20900	10506	1	0	2
38988	1684	2882755219748	20904	10507	2	0	136
160394	1397	1315557690000	20906	10508	1	0	12327
327654	1874	16018000	20906	10508	3	0	2
160405	1397	1315537688000	20909	10510	0	0	12329
327664	1678	23040757413000	20909	10510	1	0	0
160410	2133	96247506000	20909	10510	5	0	2747
327670	1678	23040757415000	20910	10511	0	0	0
160416	2132	148108109000	20910	10511	4	0	891
327676	1874	16036000	20910	10511	6	0	2
160550	242	66648395291044	20914	10513	0	0	1
327806	2269	2000000000	20914	10513	0	0	0
160551	1397	1315467681000	20914	10513	1	0	12336
327807	1678	23040757419000	20914	10513	1	0	0
41379	1688	7198721910100	20914	10513	5	0	57
160566	2133	96240492000	20917	10514	3	0	2754
327822	1874	16043000	20917	10514	3	0	2
44415	1690	146164659000000	20917	10514	5	0	0
51167	1709	2160046000000	20918	10515	2	0	8
160574	2133	96237486000	20920	10516	2	0	2757
327830	1874	16049000	20920	10516	2	0	2
26242	1613	20808173600000	20920	10516	4	0	6
160581	2039	18325785000000	20923	10518	1	0	3
327837	924	507246525000000	20923	10518	1	0	0
160587	2132	148105106000	20924	10519	4	0	894
327843	1874	16057000	20924	10519	4	0	2
56924	1762	3525294994000	20924	10519	5	0	8
160595	1397	1315367671000	20928	10522	0	0	12346
327851	1678	23040757429000	20928	10522	0	0	0
6529	1394	483848113500000	20928	10522	3	0	0
6530	1394	483848125500000	20928	10522	4	0	0
160608	1397	1315347669000	20931	10524	0	0	12348
327864	1678	23040757431000	20931	10524	0	0	0
51748	1711	4026742000000	20931	10524	6	0	13
160614	2133	96227466000	20931	10524	7	0	2767
327870	1874	16072000	20931	10524	7	0	2
160617	2133	96226464000	20932	10525	1	0	2768
160620	1564	10961600000000	20934	10526	0	0	6
327878	1212	612204750000000	20934	10526	2	0	0
160626	2133	96225462000	20934	10526	6	0	2769
327883	1874	16079000	20934	10526	7	0	2
35850	1680	2893188499559	20934	10526	10	0	12
327912	2270	699000000000	20938	10527	0	0	0
327913	1678	23040757437000	20938	10527	1	0	0
160659	1397	1315277662000	20939	10528	0	0	12355
327919	1874	16086000	20939	10528	4	0	2
160664	2132	148101102000	20939	10528	5	0	898
8979	1395	58162228523507701	20940	10529	5	0	0
327925	1678	23040757441000	20941	10530	0	0	0
160670	2133	96219450000	20941	10530	1	0	2775
327930	2100	1434960000000	20942	10531	3	0	3
160676	1516	3562056390000	20943	10532	0	0	15
327936	1874	16096000	20943	10532	4	0	2
22943	1588	22535541000000	20943	10532	6	0	6
160681	1397	1315217656000	20944	10533	0	0	12361
327949	1678	23040757447000	20946	10534	1	0	0
160694	1397	1315177652000	20946	10534	2	0	12365
327954	1874	16107000	20946	10534	6	0	2
160707	2132	148098099000	20948	10535	1	0	901
327969	1678	23040757451000	20951	10537	0	0	0
160714	2133	96209430000	20951	10537	1	0	2785
40299	1685	141843147571430	20951	10537	2	0	0
327977	1874	16119000	20954	10539	2	0	2
160724	1397	1315117646000	20956	10540	0	0	12371
327984	1678	23040757457000	20957	10541	2	0	0
160730	2133	96205422000	20957	10541	4	0	2789
30863	1657	17281498990100	20957	10541	7	0	6
327996	1678	23040757458000	20960	10542	1	0	0
160741	2133	96202416000	20960	10542	2	0	2792
57415	1764	18007132100000	20960	10542	3	0	8
28878	1637	246965881819988	20962	10543	4	0	0
328005	1678	23040757461000	20963	10544	0	0	0
160750	2133	96200412000	20963	10544	1	0	2794
160767	1397	1315037638000	20965	10545	0	0	12379
160768	1397	1315027637000	20965	10545	1	0	12380
328026	1874	16139000	20965	10545	3	0	2
12995	1444	2247575329999	20967	10546	2	0	12
160782	1397	1315007635000	20971	10547	0	0	12382
328038	1678	23040757465000	20971	10547	0	0	0
328039	1874	16144000	20971	10547	1	0	2
48087	1696	22097592835100	20971	10547	3	0	5
160792	2132	148093094000	20973	10548	4	0	906
328049	1874	16147000	20973	10548	5	0	2
58622	1980	18719446000000	20974	10549	3	0	1
160800	1397	1314987633000	20976	10550	1	0	12384
11173	1419	10368068560130	20976	10550	4	0	6
328058	1678	23040757468000	20977	10551	0	0	0
22394	1587	2880098000000	20977	10551	3	0	14
160809	2133	96191394000	20979	10552	1	0	2803
328068	1678	23040757470000	20981	10553	0	0	0
10893	1402	76175068319298	20981	10553	3	0	33
160821	2133	96188388000	20985	10555	1	0	2806
328078	1874	16163000	20985	10555	2	0	2
41398	1688	9358754910100	20988	10556	3	0	57
160830	2133	96186384000	20989	10557	1	0	2808
8984	1395	58162948523507701	20989	10557	2	0	0
328092	1874	16169000	20992	10558	1	0	2
160850	2133	96184380000	20996	10559	2	0	2810
328107	1874	16174000	20996	10559	3	0	2
160882	1397	1314877622000	20999	10560	4	0	12395
328139	1678	23040757479000	20999	10560	5	0	0
160887	2133	96181374000	20999	10560	9	0	2813
160889	2133	96179370000	20999	10560	11	0	2815
328145	1874	16182000	20999	10560	11	0	2
160890	2132	148089090000	20999	10560	12	0	910
49412	1702	1440439000000	20999	10560	14	0	5
328272	1678	23040757482000	21001	10561	0	0	0
328273	1678	23040757483000	21001	10561	1	0	0
161032	1397	1314817616000	21006	10562	0	0	12401
161033	2133	96176364000	21006	10562	1	0	2818
15956	1474	3070325000043	21006	10562	2	0	26
328295	1678	23040757485000	21008	10563	0	0	0
161047	1397	1314787613000	21010	10564	0	0	12404
328304	1874	16197000	21010	10564	1	0	2
161174	1397	1314777612000	21012	10565	0	0	12405
328428	1678	23040757488000	21012	10565	0	0	0
161175	2133	96172356000	21012	10565	1	0	2822
328429	1874	16199000	21012	10565	1	0	2
30346	1656	5035283999990	21012	10565	3	0	8
161184	1608	4760542000000	21014	10566	4	0	7
328438	1163	613197810000000	21014	10566	4	0	0
21802	1571	4032042151056	21014	10566	7	0	41
328441	1678	23040757491000	21015	10567	0	0	0
328442	1678	23040757492000	21015	10567	1	0	0
161190	2133	96168348000	21015	10567	3	0	2826
60484	2248	3599334000000	21015	10567	6	0	0
328469	1678	23040757494000	21023	10569	0	0	0
161216	1397	1314707605000	21023	10569	1	0	12412
328505	1678	23040757497000	21029	10570	0	0	0
161252	2133	96164340000	21029	10570	1	0	2830
328521	1678	23040757499000	21035	10572	0	0	0
161271	1397	1314657600000	21039	10573	0	0	12417
6538	1394	488168257500000	21039	10573	2	0	0
328535	1678	23040757502000	21043	10575	0	0	0
161282	1397	1314627597000	21043	10575	1	0	12420
328541	1874	16234000	21044	10576	1	0	2
161295	1397	1314607595000	21048	10577	0	0	12422
161297	2132	148081082000	21048	10577	2	0	918
161303	1397	1314597594000	21051	10578	0	0	12423
328558	1874	16239000	21051	10578	1	0	2
161319	1397	1314567591000	21057	10580	0	0	12426
328574	1874	16244000	21057	10580	1	0	2
328577	1678	23040757511000	21059	10582	0	0	0
328578	1678	23040757512000	21059	10582	1	0	0
161325	2133	96151314000	21059	10582	2	0	2843
28884	1637	249125925819988	21059	10582	5	0	0
161330	1397	1314527587000	21060	10583	2	0	12430
328584	1678	23040757513000	21060	10583	2	0	0
41421	1688	11518787910100	21060	10583	4	0	57
161419	1850	4296178949999	21064	10584	4	0	9
328673	911	507467575000000	21064	10584	4	0	0
161548	1397	1314507585000	21067	10585	0	0	12432
328802	1678	23040757515000	21067	10585	0	0	0
161549	2133	96147306000	21067	10585	1	0	2847
328803	1874	16257000	21067	10585	1	0	2
161561	2133	96145302000	21070	10586	4	0	2849
328815	1874	16262000	21070	10586	4	0	2
161569	1397	1314457580000	21073	10588	0	0	12437
161570	2133	96142296000	21073	10588	1	0	2852
328824	1874	16269000	21073	10588	1	0	2
44957	1691	22283446100019	21073	10588	3	0	5
328838	1874	16274000	21079	10590	2	0	2
50518	1706	5322004450256	21079	10590	4	0	27
161587	1397	1314427577000	21081	10591	0	0	12440
328846	1678	23040757526000	21083	10593	1	0	0
161593	2132	148075076000	21083	10593	2	0	924
328849	1874	16283000	21083	10593	5	0	2
6544	1394	492488302500000	21083	10593	6	0	0
328866	1678	23040757527000	21089	10594	0	0	0
161616	1397	1314377572000	21091	10595	0	0	12445
328874	1874	16290000	21091	10595	4	0	2
161644	1397	1314347569000	21097	10596	1	0	12448
328908	1874	16295000	21100	10597	1	0	2
20269	1549	26976165000000	21100	10597	4	0	5
161656	1397	1314327567000	21101	10598	0	0	12450
328914	1678	23040757535000	21104	10600	0	0	0
161662	2133	96128268000	21104	10600	2	0	2866
328939	1874	16306000	21109	10601	3	0	2
45758	1692	45140835619999	21109	10601	5	0	5
161694	1397	1314267561000	21114	10603	0	0	12456
328954	1874	16311000	21116	10604	1	0	2
161702	2133	96123258000	21117	10605	1	0	2871
161705	2132	148070071000	21118	10606	2	0	929
328959	1874	16316000	21118	10606	2	0	2
161706	1397	1314227557000	21119	10607	0	0	12460
328968	1874	16321000	21121	10608	1	0	2
161715	2133	96119250000	21121	10608	2	0	2875
41449	1688	13678930910100	21121	10608	3	0	57
328974	1874	16327000	21122	10609	4	0	2
161721	2133	96116244000	21122	10609	5	0	2878
328984	1874	16334000	21126	10611	1	0	2
161733	1397	1314157550000	21128	10612	0	0	12467
328987	1678	23040757550000	21128	10612	0	0	0
328988	1874	16336000	21128	10612	1	0	2
34938	1679	7198483654000	21128	10612	2	0	75
24617	1602	3456213170000	21131	10613	4	0	9
161768	1397	1314127547000	21140	10615	1	0	12470
329023	1678	23040757554000	21140	10615	2	0	0
161774	1397	1314107545000	21141	10616	0	0	12472
329029	1874	16348000	21141	10616	1	0	2
161783	2133	96106224000	21144	10617	3	0	2888
329038	1678	23040757558000	21145	10618	0	0	0
9005	1395	58164388576507701	21146	10619	2	0	0
161789	1397	1314057540000	21146	10619	3	0	12477
329044	1678	23040757561000	21146	10619	4	0	0
161795	2133	96102216000	21146	10619	9	0	2892
329050	1874	16364000	21146	10619	10	0	2
161808	2133	96100212000	21150	10621	3	0	2894
329063	1874	16368000	21150	10621	4	0	2
21428	1564	4746540000000	21150	10621	6	0	9
161814	2133	96097206000	21151	10622	3	0	2897
329069	1874	16374000	21151	10622	4	0	2
44425	1690	148324713000000	21151	10622	5	0	0
6559	1394	495368325500000	21154	10624	3	0	0
161824	1397	1313957530000	21156	10625	0	0	12487
329079	1874	16380000	21156	10625	1	0	2
161831	1397	1313927527000	21159	10627	1	0	12490
329086	1678	23040757574000	21159	10627	2	0	0
161839	2133	96088188000	21161	10628	1	0	2906
161842	1397	1313897524000	21163	10629	0	0	12493
329096	1678	23040757576000	21163	10629	0	0	0
161843	2133	96087186000	21163	10629	1	0	2907
58150	1850	5016189949999	21164	10630	3	0	9
329104	1678	23040757579000	21167	10632	0	0	0
161851	2133	96084180000	21167	10632	1	0	2910
161993	1397	1313857520000	21174	10633	0	0	12497
329247	1678	23040757580000	21174	10633	0	0	0
161994	2133	96083178000	21174	10633	1	0	2911
329248	1874	16400000	21174	10633	1	0	2
28891	1637	251285991819988	21174	10633	2	0	0
329261	1678	23040757581000	21178	10634	0	0	0
329262	1678	23040757582000	21178	10634	1	0	0
162012	1397	1313817516000	21179	10635	0	0	12501
59236	2039	3499277000000	21179	10635	2	0	6
329270	1678	23040757585000	21181	10636	0	0	0
162022	1397	1313787513000	21183	10637	0	0	12504
329278	1678	23040757588000	21184	10638	0	0	0
162027	2133	96076164000	21184	10638	3	0	2918
329283	1874	16418000	21184	10638	5	0	2
162280	1397	1313737508000	21191	10640	0	0	12509
329534	1678	23040757592000	21191	10640	0	0	0
162281	1397	1313727507000	21191	10640	1	0	12510
329535	1678	23040757593000	21191	10640	1	0	0
162287	2133	96070152000	21191	10640	7	0	2924
329541	1874	16426000	21191	10640	7	0	2
40309	1685	144003220571430	21191	10640	8	0	0
6574	1394	499688380500000	21194	10642	3	0	0
162298	1397	1313677502000	21196	10643	0	0	12515
329552	1678	23040757598000	21196	10643	0	0	0
55811	1746	11314443000000	21196	10643	3	0	2
162305	1397	1313647499000	21199	10645	1	0	12518
329559	1678	23040757601000	21199	10645	1	0	0
162311	2247	648999000000	21199	10645	7	0	1
329565	1540	0	21199	10645	7	0	6
29750	1649	27644489999992	21199	10645	11	0	4
162325	2133	96062136000	21203	10646	3	0	2932
329579	1874	16442000	21203	10646	3	0	2
162457	1397	1313587493000	21207	10648	0	0	12524
329711	1678	23040757607000	21207	10648	0	0	0
162458	2133	96058128000	21207	10648	1	0	2936
329712	1874	16450000	21207	10648	1	0	2
10914	1402	78335090319298	21210	10650	2	0	33
162466	2133	96055122000	21211	10651	1	0	2939
329720	1874	16456000	21211	10651	1	0	2
162478	1397	1313517486000	21218	10654	1	0	12531
329732	1678	23040757614000	21218	10654	1	0	0
162485	1397	1313487483000	21221	10655	2	0	12534
329739	1678	23040757617000	21221	10655	2	0	0
162491	1397	1313467481000	21223	10657	0	0	12536
329745	1678	23040757619000	21223	10657	0	0	0
6583	1394	504008435500000	21225	10658	3	0	0
162499	2133	96044100000	21226	10659	2	0	2950
329753	1874	16478000	21226	10659	2	0	2
162508	2133	96041094000	21228	10660	3	0	2953
329762	1874	16484000	21228	10660	3	0	2
162518	1397	1313377472000	21232	10663	0	0	12545
329772	1678	23040757628000	21232	10663	0	0	0
162524	1397	1313367471000	21235	10664	0	0	12546
162525	2133	96037086000	21235	10664	1	0	2957
329802	1386	1712107637751650	21239	10666	0	0	0
329803	1140	910615465000000	21239	10666	1	0	0
162551	1397	1313347469000	21239	10666	3	0	12548
329809	1095	908290884420000	21239	10666	7	0	0
162557	1611	3015085000000	21239	10666	9	0	9
329841	1874	16500000	21246	10668	1	0	2
162588	1397	1313317466000	21247	10669	0	0	12551
6589	1394	508328467500000	21247	10669	2	0	0
329846	1678	23040757635000	21248	10670	2	0	0
162594	1426	4650258000000	21248	10670	4	0	8
329868	1257	613969750000000	21251	10671	2	0	0
162616	1397	1313297464000	21251	10671	4	0	12553
54464	1724	21537585500000	21251	10671	8	0	9
329882	1678	23040757638000	21253	10672	0	0	0
162632	1397	1313267461000	21256	10673	0	0	12556
329890	1678	23040757641000	21258	10675	0	0	0
162638	1397	1313237458000	21259	10676	0	0	12559
329904	1678	23040757644000	21262	10678	0	0	0
162652	1397	1313197454000	21262	10678	2	0	12563
329910	1874	16524000	21262	10678	6	0	2
162657	2133	96020052000	21262	10678	7	0	2974
162682	1397	1313177452000	21268	10679	0	0	12565
329937	1678	23040757649000	21268	10679	1	0	0
329938	1874	16528000	21268	10679	2	0	2
45784	1692	47300871619999	21268	10679	4	0	5
13015	1444	3687609329999	21269	10680	2	0	12
162689	1397	1313147449000	21271	10681	0	0	12568
329945	1678	23040757653000	21271	10681	2	0	0
162695	1726	13309112000	21271	10681	6	0	8276
329951	2274	200000000	21271	10681	8	0	0
6600	1394	512648500500000	21271	10681	9	0	0
55192	1740	5490626000000	21273	10682	2	0	13
162710	1397	1313107445000	21274	10683	0	0	12572
329966	1678	23040757657000	21274	10683	2	0	0
162716	2134	93533835000	21274	10683	6	0	3057
329972	2282	1400000000	21274	10683	8	0	0
162722	2132	148062063000	21274	10683	12	0	937
329978	2277	200000000	21274	10683	14	0	0
162727	1726	3701112000	21274	10683	17	0	8284
329983	2284	200000000	21274	10683	19	0	0
162733	2134	88717832000	21274	10683	23	0	3063
329989	1874	16550000	21274	10683	25	0	2
36243	1681	6371159109853	21274	10683	28	0	11
162739	2134	87515829000	21275	10684	2	0	3065
162833	1397	1313067441000	21282	10685	0	0	12576
330087	1678	23040757659000	21282	10685	0	0	0
162834	1397	1313057440000	21282	10685	1	0	12577
330088	1678	23040757660000	21282	10685	1	0	0
41477	1688	15118976910040	21282	10685	5	0	57
162846	2134	87512820000	21284	10686	1	0	3068
330100	1874	16571000	21284	10686	1	0	2
40314	1685	145443288571430	21285	10687	5	0	0
162852	1397	1313027437000	21286	10688	0	0	12580
330106	1678	23040757663000	21286	10688	0	0	0
17578	1508	23076745500009	21286	10688	3	0	6
162857	2133	96004020000	21287	10689	2	0	2990
330111	1874	16589000	21287	10689	2	0	2
12041	1426	5370270000000	21287	10689	4	0	8
162867	1397	1312987433000	21290	10691	1	0	12584
330121	1678	23040757667000	21290	10691	1	0	0
162883	2132	148058059000	21293	10692	1	0	941
330137	1874	16606000	21293	10692	1	0	2
28899	1637	252726026819988	21293	10692	5	0	0
162900	2134	87504796000	21296	10693	2	0	3076
330154	1874	16614000	21296	10693	2	0	2
9029	1395	58166548657507701	21296	10693	7	0	0
162912	2134	87502790000	21299	10694	2	0	3078
330166	1874	16626000	21299	10694	2	0	2
163052	1397	1312927427000	21305	10696	0	0	12590
330306	1678	23040757673000	21305	10696	0	0	0
163053	2133	95995002000	21305	10696	1	0	2999
330307	1874	16634000	21305	10696	1	0	2
17021	1506	3172600967172	21307	10697	4	0	22
163196	2134	87498778000	21313	10698	0	0	3082
330450	1874	16645000	21313	10698	0	0	2
163197	2132	148056057000	21313	10698	1	0	943
330451	1874	16646000	21313	10698	1	0	2
1095	111	71040077000000	21313	10698	3	0	0
163202	1397	1312907425000	21315	10699	0	0	12592
163203	1397	1312897424000	21315	10699	1	0	12593
330461	1874	16654000	21316	10700	1	0	2
163235	1397	1312877422000	21319	10701	0	0	12595
330489	1678	23040757678000	21319	10701	0	0	0
330490	1678	23040757679000	21319	10701	1	0	0
163241	2133	95990994000	21319	10701	6	0	3003
330496	1874	16664000	21319	10701	7	0	2
163246	2133	95988990000	21319	10701	11	0	3005
330502	1874	16680000	21320	10702	0	0	2
44430	1690	149764752000000	21320	10702	5	0	0
163252	1397	1312837418000	21321	10703	0	0	12599
330507	1678	23040757683000	21321	10703	1	0	0
163261	2133	95984982000	21323	10704	2	0	3009
330516	1678	23040757685000	21324	10705	0	0	0
163266	1397	1312797414000	21325	10706	0	0	12603
330522	1874	16704000	21325	10706	3	0	2
163288	1458	22110672908540	21332	10708	0	0	5
330543	1678	23040757688000	21332	10708	1	0	0
18465	1522	3643305000000	21332	10708	5	0	14
163297	2133	95979972000	21334	10709	1	0	3014
23422	1594	2881568000000	21334	10709	3	0	10
330559	1678	23040757689000	21337	10710	0	0	0
163315	1458	14721272908540	21340	10711	1	0	7
330571	1874	16728000	21340	10711	3	0	2
163321	2134	87481727000	21341	10712	2	0	3099
163343	1397	1312737408000	21346	10713	0	0	12609
330597	1678	23040757692000	21346	10713	0	0	0
163344	1397	1312727407000	21346	10713	1	0	12610
330603	1323	1712107637751650	21348	10714	0	0	0
163350	1397	1312717406000	21348	10714	1	0	12611
330609	1874	16753000	21348	10714	6	0	2
163356	1514	700010030400	21348	10714	7	0	1
330614	1874	16760000	21348	10714	11	0	2
60403	2199	719000000000	21348	10714	12	0	0
163365	1397	1312687403000	21350	10715	0	0	12614
330619	1678	23040757697000	21350	10715	0	0	0
330620	1874	16761000	21350	10715	1	0	2
163377	2133	95970954000	21352	10716	2	0	3023
330632	1874	16770000	21352	10716	3	0	2
39023	1684	5042790219748	21352	10716	6	0	136
163383	1514	9030400	21353	10717	2	0	2
330638	1874	16781000	21353	10717	3	0	2
50222	1705	7760545580140	21353	10717	4	0	25
163388	2134	87471697000	21354	10718	3	0	3109
59984	2112	3600112000000	21354	10718	5	0	6
330647	1678	23040757702000	21356	10719	0	0	0
163398	1397	1312607395000	21357	10720	2	0	12622
330653	1874	16794000	21357	10720	3	0	2
163404	2133	95963940000	21357	10720	8	0	3030
330659	1874	16808000	21357	10720	9	0	2
163435	1397	1312567391000	21360	10721	3	0	12626
330690	1678	23040757710000	21360	10721	4	0	0
163441	2134	87465679000	21360	10721	9	0	3115
330696	1874	16819000	21360	10721	10	0	2
163447	2133	95961936000	21360	10721	15	0	3032
330702	1874	16834000	21360	10721	16	0	2
163458	1397	1312527387000	21362	10722	1	0	12630
330713	1874	16840000	21362	10722	2	0	2
48120	1696	24257637835100	21362	10722	7	0	5
163487	1397	1312517386000	21367	10723	0	0	12631
163488	2132	148044045000	21367	10723	1	0	955
330743	1874	16851000	21367	10723	2	0	2
330759	1678	23040757715000	21371	10724	0	0	0
330760	1678	23040757716000	21371	10724	1	0	0
163508	2134	87456652000	21371	10724	3	0	3124
13655	1447	21033697943000	21371	10724	6	0	6
330786	1874	16867000	21377	10725	1	0	2
163534	2132	148043044000	21377	10725	3	0	956
330792	1514	9030400	21380	10726	3	0	2
163539	1397	1312467381000	21381	10727	0	0	12636
330797	1874	16882000	21381	10727	4	0	2
20901	1559	20122905000000	21381	10727	7	0	4
163545	1397	1312447379000	21382	10728	0	0	12638
330803	1874	16892000	21382	10728	4	0	2
163551	2133	95947908000	21382	10728	6	0	3046
330829	1678	23040757724000	21389	10730	0	0	0
163576	694	66522947693786	21389	10730	1	0	1
330834	1874	16907000	21390	10731	1	0	2
163582	1397	1312397374000	21391	10732	0	0	12643
18859	1536	1440024000000	21391	10732	4	0	11
163713	1397	1312387373000	21394	10733	0	0	12644
330967	1678	23040757727000	21394	10733	0	0	0
163714	2134	87445619000	21394	10733	1	0	3135
330968	1874	16918000	21394	10733	1	0	2
163761	1547	22892809000000	21402	10735	0	0	7
331015	683	66339585999999	21402	10735	0	0	0
163762	1397	1312367371000	21402	10735	1	0	12646
331021	1874	16935000	21402	10735	6	0	2
163768	2133	95941896000	21402	10735	7	0	3052
331025	1874	16942000	21402	10735	10	0	2
331033	683	66626585999999	21404	10736	0	0	0
163781	1397	1312327367000	21404	10736	2	0	12650
331039	1874	16952000	21404	10736	6	0	2
163794	1397	1312317366000	21407	10737	0	0	12651
331053	1252	612316750000000	21408	10738	1	0	0
163800	1397	1312307365000	21408	10738	2	0	12652
9035	1395	58168708691507701	21408	10738	5	0	0
163933	1397	1312297364000	21412	10739	0	0	12653
331187	1678	23040757736000	21412	10739	0	0	0
163934	2133	95934882000	21412	10739	1	0	3059
331188	1874	16965000	21412	10739	1	0	2
163946	2134	87435589000	21415	10740	4	0	3145
331200	1874	16971000	21415	10740	4	0	2
163952	2133	95931876000	21415	10740	11	0	3062
331206	1874	16984000	21415	10740	11	0	2
20285	1549	28416262000000	21415	10740	12	0	5
163991	2134	87431577000	21420	10742	1	0	3149
331245	1874	16992000	21420	10742	1	0	2
164003	2134	87430574000	21424	10744	1	0	3150
331257	1874	16998000	21424	10744	1	0	2
164013	1397	1312217356000	21427	10746	0	0	12661
331267	1678	23040757744000	21427	10746	0	0	0
164017	2134	87428568000	21427	10746	4	0	3152
164018	2134	87427565000	21427	10746	5	0	3153
331272	1874	17016000	21427	10746	5	0	2
164034	2134	87425559000	21429	10747	5	0	3155
331288	1874	17024000	21429	10747	5	0	2
6616	1394	516968562500000	21429	10747	10	0	0
164043	2133	95921856000	21431	10748	1	0	3072
331297	1874	17034000	21431	10748	1	0	2
331298	1874	17037000	21431	10748	2	0	2
22405	1587	3600122000000	21433	10749	4	0	14
164051	1397	1312147349000	21434	10750	0	0	12668
331307	1874	17043000	21434	10750	2	0	2
164063	1397	1312127347000	21436	10751	0	0	12670
331319	1874	17054000	21436	10751	2	0	2
164069	2133	95917848000	21436	10751	6	0	3076
53404	1719	3600108000000	21436	10751	7	0	10
331325	1678	23040757755000	21438	10752	0	0	0
164075	1686	21518995869379	21439	10753	0	0	10
331331	1874	17068000	21439	10753	2	0	2
164081	1397	1312087343000	21440	10754	1	0	12674
331337	1874	17073000	21440	10754	3	0	2
14296	1451	17899069000000	21440	10754	6	0	9
164093	1686	14792873546422	21443	10755	1	0	14
331348	1678	23040757758000	21443	10755	2	0	0
164098	2133	95913840000	21443	10755	6	0	3080
44436	1690	151925245000000	21443	10755	9	0	0
331354	1678	23040757760000	21444	10756	0	0	0
164104	2133	95911836000	21444	10756	4	0	3082
47514	1695	4265024999000	21444	10756	7	0	9
331360	1678	23040757761000	21445	10757	0	0	0
164113	1397	1312027337000	21447	10758	1	0	12680
331368	1874	17102000	21447	10758	2	0	2
164118	2133	95908830000	21447	10758	7	0	3085
331374	1678	23040757764000	21448	10759	1	0	0
164124	1771	598166214766	21449	10760	1	0	1
331380	1874	17120000	21449	10760	3	0	2
164141	2133	95905824000	21451	10761	3	0	3088
331396	1678	23040757767000	21452	10762	0	0	0
60619	2261	2879047000000	21452	10762	4	0	0
164163	1397	1311977332000	21454	10763	0	0	12685
164164	2133	95903820000	21454	10763	1	0	3090
17585	1508	25236782500009	21454	10763	3	0	6
331420	1678	23040757769000	21455	10764	0	0	0
331465	1678	23040757770000	21457	10765	0	0	0
164212	1397	1311947329000	21457	10765	1	0	12688
331466	1678	23040757771000	21457	10765	1	0	0
164218	1397	1311937328000	21458	10766	0	0	12689
331472	1678	23040757772000	21458	10766	0	0	0
164223	2134	87400484000	21458	10766	5	0	3180
331478	1874	17163000	21458	10766	6	0	2
164241	2133	95896806000	21464	10768	1	0	3097
331495	1874	17170000	21464	10768	1	0	2
164257	2132	148025026000	21466	10769	4	0	974
331511	1874	17176000	21466	10769	4	0	2
164262	2133	95893800000	21466	10769	9	0	3100
58948	1992	5760560990000	21466	10769	11	0	5
164289	1397	1311867321000	21471	10770	0	0	12696
331543	1678	23040757779000	21471	10770	0	0	0
164290	2134	87393463000	21471	10770	1	0	3187
331551	1678	23040757782000	21476	10771	2	0	0
164299	2133	95890794000	21476	10771	4	0	3103
331557	1874	17208000	21476	10771	8	0	2
12456	1439	6463604578477	21476	10771	10	0	10
164321	1397	1311827317000	21481	10772	0	0	12700
331575	1678	23040757783000	21481	10772	0	0	0
331576	1874	17213000	21481	10772	1	0	2
164334	2134	87388448000	21484	10773	1	0	3192
11939	1423	720582750023	21484	10773	3	0	29
331590	1678	23040757786000	21485	10774	1	0	0
164340	2134	87386442000	21485	10774	5	0	3194
6623	1394	519848649500000	21485	10774	8	0	0
331596	1678	23040757787000	21486	10775	0	0	0
164349	2133	95884782000	21488	10776	1	0	3109
331604	1874	17240000	21488	10776	2	0	2
164354	2133	95883780000	21489	10777	3	0	3110
28914	1637	254886073819988	21489	10777	5	0	0
331610	1874	17248000	21490	10778	1	0	2
9047	1395	58170868777507701	21491	10779	1	0	0
164365	2134	87380424000	21495	10780	2	0	3200
41513	1688	17278988910040	21495	10780	3	0	57
331626	1483	10000000	21497	10781	1	0	0
164376	1397	1311707305000	21498	10782	0	0	12712
331631	1874	17263000	21498	10782	1	0	2
32671	1675	4604129999977	21498	10782	2	0	8
19341	1544	720011000000	21499	10783	3	0	0
164381	2134	87375409000	21500	10784	1	0	3205
58705	1991	5661285355805	21500	10784	3	0	21
331641	1678	23040757799000	21503	10785	1	0	0
53156	1717	23148366000023	21503	10785	5	0	4
164391	2134	87372400000	21504	10786	1	0	3208
331653	1678	23040757802000	21506	10787	1	0	0
164403	2134	87369391000	21506	10787	5	0	3211
25149	1608	3738303000000	21506	10787	6	0	8
331658	1678	23040757804000	21507	10788	0	0	0
19191	1541	722036000000	21507	10788	4	0	4
164412	1397	1311607295000	21509	10789	0	0	12722
331668	1874	17298000	21509	10789	2	0	2
6631	1394	524168705500000	21509	10789	4	0	0
164418	2133	95880774000	21510	10790	3	0	3113
331674	1874	17306000	21510	10790	5	0	2
164424	2133	95878770000	21511	10791	2	0	3115
164425	2134	87364376000	21511	10791	3	0	3216
331679	1874	17314000	21511	10791	3	0	2
164426	2133	95877768000	21511	10791	4	0	3116
32572	1673	31285632000000	21511	10791	6	0	10
331689	1874	17325000	21513	10792	3	0	2
164436	1397	1311547289000	21514	10793	0	0	12728
164564	1397	1311537288000	21516	10794	0	0	12729
331818	1678	23040757812000	21516	10794	0	0	0
164565	2133	95874762000	21516	10794	1	0	3119
331819	1874	17332000	21516	10794	1	0	2
12684	1440	1440143045924	21516	10794	3	0	11
331949	1678	23040757813000	21519	10795	0	0	0
331950	1874	17337000	21519	10795	1	0	2
164697	2134	87359361000	21519	10795	2	0	3221
164698	1397	1311517286000	21520	10796	0	0	12731
54103	1723	21959573085979	21520	10796	4	0	6
331959	1678	23040757815000	21522	10797	0	0	0
164707	2134	87357355000	21522	10797	2	0	3223
331971	1678	23040757817000	21527	10799	0	0	0
164719	2134	87355349000	21527	10799	2	0	3225
331976	1874	17366000	21527	10799	5	0	2
331982	1678	23040757819000	21530	10800	0	0	0
164729	2134	87353343000	21530	10800	1	0	3227
331983	1874	17369000	21530	10800	1	0	2
164751	2134	87351337000	21539	10802	1	0	3229
332005	1874	17379000	21539	10802	1	0	2
164897	1397	1311437278000	21544	10803	0	0	12739
332151	1678	23040757822000	21544	10803	0	0	0
164898	1397	1311427277000	21544	10803	1	0	12740
332152	1678	23040757823000	21544	10803	1	0	0
164904	2134	87349331000	21544	10803	7	0	3231
332158	1874	17393000	21544	10803	7	0	2
164915	2134	87346322000	21549	10805	1	0	3234
332169	1874	17406000	21549	10805	1	0	2
164920	2134	87344316000	21551	10807	1	0	3236
332174	1874	17418000	21551	10807	1	0	2
165050	1397	1311397274000	21555	10808	0	0	12743
332304	1678	23040757826000	21555	10808	0	0	0
165051	2134	87343313000	21555	10808	1	0	3237
332305	1874	17421000	21555	10808	1	0	2
165060	2133	95854722000	21558	10810	1	0	3139
332314	1874	17430000	21558	10810	1	0	2
165075	2134	87339301000	21563	10812	1	0	3241
332329	1874	17441000	21563	10812	1	0	2
59637	2087	720193000000	21563	10812	2	0	2
165088	1397	1311337268000	21567	10814	0	0	12749
332342	1678	23040757832000	21567	10814	0	0	0
57438	1764	20167251100000	21572	10815	4	0	8
165105	1397	1311317266000	21573	10816	0	0	12751
332359	1678	23040757834000	21573	10816	0	0	0
165106	2133	95848710000	21573	10816	1	0	3145
17939	1509	22272262851155	21573	10816	4	0	5
332377	1678	23040757836000	21578	10818	0	0	0
165135	1397	1311287263000	21581	10819	0	0	12754
332389	1678	23040757837000	21581	10819	0	0	0
332401	1678	23760767838000	21583	10820	0	0	0
165152	2134	87331277000	21583	10820	5	0	3249
332407	1874	17480000	21583	10820	6	0	2
165157	2133	95843700000	21583	10820	10	0	3150
332413	1874	17490000	21584	10821	1	0	2
165166	2134	87328268000	21586	10822	2	0	3252
332424	1678	23760767842000	21588	10823	0	0	0
50239	1705	9200582580140	21588	10823	4	0	25
165178	2134	87326262000	21590	10824	2	0	3254
332433	1874	17509000	21590	10824	3	0	2
9059	1395	58172308824507701	21590	10824	4	0	0
18759	1527	273999976	21590	10824	10	1	0
165323	1397	1311207255000	21595	10825	0	0	12762
332577	1678	23760767845000	21595	10825	0	0	0
165324	1397	1311197254000	21595	10825	1	0	12763
332578	1678	23760767846000	21595	10825	1	0	0
165336	2133	95835684000	21597	10826	1	0	3158
332590	1874	17525000	21597	10826	1	0	2
51133	1708	20916328500022	21600	10827	4	0	4
165362	2134	87320244000	21607	10828	1	0	3260
332616	1874	17536000	21607	10828	1	0	2
165370	2133	95831676000	21610	10830	2	0	3162
332624	1874	17542000	21610	10830	2	0	2
52045	1714	4605480171760	21610	10830	6	0	11
165377	2134	87317235000	21612	10831	1	0	3263
165378	2133	95830674000	21612	10831	2	0	3163
332636	1678	23760767853000	21614	10832	0	0	0
41530	1688	18719025910040	21614	10832	4	0	57
165390	2133	95828670000	21616	10833	2	0	3165
165533	1397	1311107245000	21624	10834	0	0	12772
332787	1678	23760767855000	21624	10834	0	0	0
165534	1397	1311097244000	21624	10834	1	0	12773
332788	1678	23760767856000	21624	10834	1	0	0
165670	1397	1311087243000	21627	10835	0	0	12774
332924	1678	23760767857000	21627	10835	0	0	0
165671	2133	95825664000	21627	10835	1	0	3168
332925	1874	17575000	21627	10835	1	0	2
6642	1394	528488729500000	21627	10835	3	0	0
332929	1678	23760767858000	21629	10836	0	0	0
332930	1678	23760767859000	21629	10836	1	0	0
165680	2133	94613660000	21629	10836	5	0	3171
332936	1874	17588000	21629	10836	7	0	2
11209	1419	12528093560130	21629	10836	8	0	6
165692	1508	22684405117393	21633	10838	0	0	7
332948	1874	17596000	21633	10838	2	0	2
165712	1508	18110553132541	21637	10839	1	0	8
332968	1387	1709029915128959	21637	10839	3	0	0
45799	1692	49460949619999	21637	10839	4	0	5
165718	2133	94610654000	21638	10840	3	0	3174
31985	1672	2161225000000	21638	10840	4	0	10
332979	1874	17608000	21640	10841	1	0	2
165729	2133	94607648000	21641	10842	1	0	3177
332988	1678	23760767866000	21643	10843	0	0	0
39052	1684	7202851219748	21643	10843	3	0	136
165742	1397	1310987233000	21645	10844	0	0	12784
332998	1874	17627000	21645	10844	2	0	2
44966	1691	24443494100019	21645	10844	6	0	5
165748	1397	1310967231000	21646	10845	1	0	12786
333004	1508	6680255156616	21646	10845	3	0	10
165754	2134	87299181000	21646	10845	8	0	3281
333027	1874	17646000	21651	10846	1	0	2
165903	1397	1310947229000	21654	10847	0	0	12788
333157	1678	23760767871000	21654	10847	0	0	0
165904	1397	1310937228000	21654	10847	1	0	12789
333158	1678	23760767872000	21654	10847	1	0	0
165910	2134	87296172000	21654	10847	7	0	3284
333164	1874	17660000	21654	10847	7	0	2
165921	1397	1310917226000	21656	10848	0	0	12791
165922	2133	94597628000	21656	10848	1	0	3187
9068	1395	58174468836957278	21656	10848	3	0	0
333179	1483	10000000	21657	10849	1	0	0
56425	1756	5600742195609	21657	10849	4	0	6
165928	886	63455021096354	21658	10850	0	0	5
333184	1874	17675000	21658	10850	2	0	2
35899	1680	5053235499559	21658	10850	5	0	12
165934	2133	94594622000	21659	10851	2	0	3190
48137	1696	26417659335104	21659	10851	3	0	5
333195	1874	17686000	21662	10852	1	0	2
165944	1693	7381573908632	21663	10853	1	0	980
333201	1678	23760767880000	21664	10854	0	0	0
166086	2290	90000000	21669	10855	0	0	1
333340	1483	10000000	21669	10855	0	0	0
166087	1397	1310847219000	21669	10855	1	0	12798
333341	1678	23760767881000	21669	10855	1	0	0
166099	1397	1310827217000	21671	10856	1	0	12800
333353	1678	23760767883000	21671	10856	1	0	0
166105	2134	87284136000	21673	10857	1	0	3296
333359	1874	17716000	21673	10857	1	0	2
13044	1444	5127664329999	21673	10857	3	0	12
166113	1573	14899271000000	21677	10859	0	0	6
333367	1958	5231186000000	21677	10859	0	0	3
166119	2134	87281127000	21678	10860	2	0	3299
333373	1874	17733000	21678	10860	2	0	2
166262	1397	1310767211000	21682	10862	0	0	12806
333516	1678	23760767889000	21682	10862	0	0	0
166263	2133	94582598000	21682	10862	1	0	3202
333517	1874	17740000	21682	10862	1	0	2
44442	1690	154085305000000	21682	10862	4	0	0
166286	1397	1310747209000	21689	10864	0	0	12808
333540	1678	23760767891000	21689	10864	0	0	0
166314	1546	3312316000000	21692	10865	1	0	10
333568	1339	1709341667751650	21692	10865	1	0	0
166319	2133	94578590000	21692	10865	6	0	3206
333573	1874	17757000	21692	10865	6	0	2
23345	1593	27190555000000	21692	10865	13	0	4
166325	2133	94576586000	21693	10866	1	0	3208
333579	1874	17770000	21693	10866	1	0	2
166333	1397	1310697204000	21695	10867	0	0	12813
166334	1397	1310687203000	21695	10867	1	0	12814
333597	1678	23760767898000	21697	10868	0	0	0
166346	2133	94573580000	21697	10868	3	0	3211
333605	1678	23760767899000	21699	10869	0	0	0
333613	1678	23760767900000	21702	10870	0	0	0
166360	2134	87268088000	21702	10870	1	0	3312
333614	1874	17796000	21702	10870	1	0	2
166365	1397	1310617196000	21703	10871	3	0	12821
333620	1874	17800000	21703	10871	4	0	2
166371	2134	87266082000	21703	10871	9	0	3314
333626	1874	17815000	21703	10871	10	0	2
166385	1397	1310597194000	21707	10873	1	0	12823
333639	1678	23760767906000	21707	10873	1	0	0
166390	2133	94564562000	21707	10873	6	0	3220
333645	1874	17833000	21707	10873	7	0	2
46620	1693	8101573908632	21707	10873	8	0	980
166401	1397	1310557190000	21710	10875	1	0	12827
333656	1874	17840000	21710	10875	2	0	2
166410	2134	87258058000	21712	10876	2	0	3322
333664	1874	17850000	21712	10876	2	0	2
25161	1608	5178338000000	21712	10876	3	0	8
166429	2134	87256052000	21716	10877	4	0	3324
333684	1874	17860000	21716	10877	5	0	2
53188	1718	2418432519070	21716	10877	7	0	13
166435	2133	94557548000	21717	10878	4	0	3227
333690	1874	17865000	21717	10878	5	0	2
166441	2134	87252040000	21717	10878	10	0	3328
333695	1874	17878000	21717	10878	10	0	2
166446	1397	1310467181000	21719	10880	0	0	12836
333701	1874	17887000	21719	10880	1	0	2
166455	1397	1310447179000	21722	10882	0	0	12838
333710	1874	17897000	21722	10882	1	0	2
166466	2134	87247025000	21726	10883	0	0	3333
166467	2133	94549532000	21726	10883	1	0	3235
26323	1619	1440012000000	21726	10883	2	0	0
333725	1874	17910000	21728	10884	1	0	2
48143	1696	27857697335104	21728	10884	3	0	5
6652	1394	532808753500000	21729	10885	0	0	0
333851	1874	17913000	21734	10886	0	0	2
333852	1442	0	21734	10886	1	0	0
166600	2134	87243013000	21734	10886	3	0	3337
166601	2134	87242010000	21734	10886	4	0	3338
166602	2133	94547528000	21734	10886	5	0	3237
333858	1874	17928000	21734	10886	7	0	2
24266	1599	24820463393047	21734	10886	9	0	4
166749	1397	1310437178000	21738	10887	0	0	12839
334003	1678	23760767922000	21738	10887	0	0	0
166750	1397	1310427177000	21738	10887	1	0	12840
334004	1678	23760767923000	21738	10887	1	0	0
334036	1678	23760767924000	21745	10888	0	0	0
166783	2134	87239001000	21745	10888	1	0	3341
334037	1874	17943000	21745	10888	1	0	2
166789	2134	87236995000	21747	10890	1	0	3343
334043	1874	17953000	21747	10890	1	0	2
41561	1688	20879097910040	21747	10890	4	0	57
47087	1694	6298796197225	21749	10891	4	0	62
166800	1397	1310377172000	21751	10892	0	0	12845
334055	1874	17963000	21751	10892	1	0	2
60005	2112	5760148000000	21751	10892	3	0	6
166913	1397	1310367171000	21755	10893	0	0	12846
334167	1678	23760767929000	21755	10893	0	0	0
166914	2133	94536506000	21755	10893	1	0	3248
334168	1874	17967000	21755	10893	1	0	2
14937	1458	8585096908540	21757	10894	4	0	8
166923	2134	87231980000	21758	10895	1	0	3348
334177	1874	17978000	21758	10895	1	0	2
166944	2134	87229974000	21763	10897	2	0	3350
334198	1874	17988000	21763	10897	2	0	2
28931	1637	257046146819988	21763	10897	5	0	0
12320	1428	2160042000000	21765	10898	4	0	0
166958	1397	1310307165000	21768	10899	0	0	12852
334212	1678	23760767935000	21768	10899	0	0	0
27490	1634	7582951259504	21768	10899	7	0	18
166973	1397	1310287163000	21771	10900	0	0	12854
334227	1678	23760767937000	21771	10900	0	0	0
166982	1397	1310267161000	21774	10902	0	0	12856
334236	1678	23760767939000	21774	10902	0	0	0
166987	1397	1310237158000	21775	10903	2	0	12859
334241	1678	23760767942000	21775	10903	2	0	0
166993	2134	87220947000	21775	10903	8	0	3359
334247	1874	18035000	21775	10903	8	0	2
167063	1397	1310227157000	21777	10904	0	0	12860
334317	1678	23760767943000	21777	10904	0	0	0
167064	1397	1310217156000	21777	10904	1	0	12861
334318	1678	23760767944000	21777	10904	1	0	0
167070	2134	87217938000	21779	10905	1	0	3362
334324	1874	18048000	21779	10905	1	0	2
1435	171	70986689696494	21784	10906	3	0	8
167088	2133	94518470000	21786	10907	3	0	3266
334342	1874	18057000	21786	10907	3	0	2
11908	1422	19585288860211	21786	10907	5	0	7
167104	1397	1310157150000	21790	10909	1	0	12867
334358	1678	23760767950000	21790	10909	1	0	0
167110	2134	87212923000	21790	10909	7	0	3367
334364	1874	18077000	21790	10909	7	0	2
4808	641	71043622000000	21790	10909	9	0	16
167186	1397	1310147149000	21793	10910	0	0	12868
334440	1678	23760767951000	21793	10910	0	0	0
167187	1573	8682270000000	21793	10910	1	0	7
334441	1318	1710516637751650	21793	10910	1	0	0
27001	1623	61922979899898	21793	10910	7	0	1
167193	1397	1310137148000	21794	10911	0	0	12869
334447	1678	23760767952000	21794	10911	0	0	0
9081	1395	58176628882957278	21794	10911	6	0	0
167450	1397	1310117146000	21798	10912	0	0	12871
334704	1678	23760767954000	21798	10912	0	0	0
167451	1397	1310107145000	21798	10912	1	0	12872
334705	1678	23760767955000	21798	10912	1	0	0
167463	2133	94508450000	21801	10913	1	0	3276
334717	1874	18104000	21801	10913	1	0	2
167487	2134	87205902000	21805	10914	4	0	3374
334741	1874	18114000	21805	10914	4	0	2
167504	2133	94505444000	21807	10915	3	0	3279
334758	1874	18122000	21807	10915	3	0	2
4164	632	71757513000000	21809	10916	3	0	9
167522	1397	1310037138000	21812	10917	0	0	12879
334776	1678	23760767962000	21812	10917	0	0	0
167534	2133	94500434000	21814	10918	3	0	3284
334788	1874	18141000	21814	10918	3	0	2
167539	2134	87197878000	21816	10919	2	0	3382
334793	1874	18150000	21816	10919	2	0	2
6663	1394	537128813500000	21816	10919	7	0	0
167551	2134	87195872000	21818	10920	2	0	3384
334805	1874	18160000	21818	10920	2	0	2
167553	2133	94496426000	21818	10920	4	0	3288
167554	2134	87194869000	21818	10920	5	0	3385
60307	2148	2160071880750	21818	10920	7	0	2
334817	1874	18169000	21820	10921	2	0	2
167566	2134	87192863000	21820	10921	5	0	3387
56846	1759	20160987999889	21820	10921	6	0	7
334822	1678	23760767972000	21822	10922	1	0	0
167572	2133	94492418000	21822	10922	5	0	3292
334828	1874	18185000	21822	10922	7	0	2
167577	2134	87189854000	21822	10922	10	0	3390
334845	1678	23760767975000	21824	10923	0	0	0
334846	1678	23760767976000	21824	10923	1	0	0
167595	2134	87187848000	21824	10923	4	0	3392
58163	1850	6456224949999	21824	10923	7	0	9
334852	1678	23760767978000	21825	10924	1	0	0
167601	2133	94487408000	21825	10924	4	0	3297
334872	1678	23760767980000	21829	10925	1	0	0
167620	2133	94484402000	21829	10925	3	0	3300
334877	1678	23760767981000	21831	10926	0	0	0
167626	2133	94483400000	21831	10926	3	0	3301
334883	1874	18236000	21831	10926	6	0	2
167634	1397	1309817116000	21833	10927	0	0	12901
334893	1678	23760767986000	21835	10928	1	0	0
167641	2133	94478390000	21835	10928	3	0	3306
167762	1397	1309787113000	21837	10929	0	0	12904
335016	1678	23760767987000	21837	10929	0	0	0
167763	2134	87176815000	21837	10929	1	0	3403
335017	1874	18257000	21837	10929	1	0	2
23455	1594	5041603000000	21838	10930	4	0	10
167772	2134	87174809000	21840	10931	1	0	3405
335026	1874	18267000	21840	10931	1	0	2
167784	1397	1309737108000	21844	10933	1	0	12909
335038	1678	23760767992000	21844	10933	1	0	0
167938	1397	1309727107000	21849	10934	0	0	12910
335192	1678	23760767993000	21849	10934	0	0	0
167939	1397	1309717106000	21849	10934	1	0	12911
335193	1678	23760767994000	21849	10934	1	0	0
167945	2134	87168791000	21849	10934	7	0	3411
335199	1874	18297000	21849	10934	7	0	2
167954	2133	94467368000	21852	10936	1	0	3317
335208	1874	18306000	21852	10936	1	0	2
48187	1698	4388771550062	21852	10936	3	0	12
167959	2133	94466366000	21853	10937	3	0	3318
335213	1874	18311000	21853	10937	3	0	2
167961	2133	94465364000	21853	10937	5	0	3319
167962	2133	94464362000	21853	10937	6	0	3320
6665	1394	538568813500000	21853	10937	9	0	0
6666	1394	538568849500000	21853	10937	10	0	0
335252	1678	23760768001000	21859	10938	0	0	0
335253	1874	18326000	21859	10938	1	0	2
168001	1397	1309637098000	21860	10939	0	0	12919
335259	1874	18337000	21861	10940	1	0	2
4479	633	71469336900000	21861	10940	3	0	9
168007	1397	1309617096000	21862	10941	0	0	12921
335265	1874	18346000	21863	10942	1	0	2
168012	2134	87158761000	21863	10942	2	0	3421
168180	1397	1309597094000	21873	10945	0	0	12923
335434	1678	23760768006000	21873	10945	0	0	0
168181	1397	1309587093000	21873	10945	1	0	12924
335435	1678	23760768007000	21873	10945	1	0	0
168187	2133	94456346000	21873	10945	7	0	3328
335441	1874	18364000	21873	10945	7	0	2
168222	2133	94454342000	21878	10947	2	0	3330
335476	1874	18374000	21878	10947	2	0	2
9095	1395	58178788941957278	21878	10947	3	0	0
168227	2133	94453340000	21879	10948	4	0	3331
335481	1874	18382000	21879	10948	4	0	2
168235	1397	1309527087000	21882	10949	0	0	12930
168236	1397	1309517086000	21882	10949	1	0	12931
335493	1874	18391000	21882	10949	4	0	2
168245	2133	94449332000	21884	10950	1	0	3335
28939	1637	259206194819988	21884	10950	3	0	0
335502	1874	18402000	21885	10951	1	0	2
168251	2133	94447328000	21886	10952	1	0	3337
335507	1678	23760768018000	21887	10953	0	0	0
168256	1397	1309467081000	21888	10954	0	0	12936
335516	1874	18421000	21891	10955	0	0	2
335517	1874	18424000	21891	10955	1	0	2
168274	1397	1309447079000	21895	10956	1	0	12938
335535	1874	18431000	21897	10957	1	0	2
168283	1397	1309427077000	21898	10958	0	0	12940
335541	1874	18442000	21898	10958	4	0	2
168288	2133	94440314000	21898	10958	5	0	3344
54114	1723	24119620085979	21902	10959	3	0	6
335558	1678	23760768026000	21903	10960	0	0	0
168306	2134	87137698000	21903	10960	2	0	3442
168435	1397	1309387073000	21906	10961	0	0	12944
335689	1678	23760768027000	21906	10961	0	0	0
168436	2134	87136695000	21906	10961	1	0	3443
335690	1874	18457000	21906	10961	1	0	2
46732	1693	10261734908632	21906	10961	3	0	980
168442	2134	87135692000	21907	10962	4	0	3444
335696	1874	18466000	21907	10962	4	0	2
168460	2133	94433300000	21911	10964	1	0	3351
335714	1874	18476000	21911	10964	1	0	2
168465	2133	94431296000	21914	10966	0	0	3353
335719	1874	18486000	21914	10966	0	0	2
168471	2134	87129674000	21915	10967	6	0	3450
335725	1874	18494000	21915	10967	6	0	2
168485	2134	87127668000	21918	10968	5	0	3452
335739	1874	18504000	21918	10968	5	0	2
168496	2133	94427288000	21920	10969	4	0	3357
335750	1874	18512000	21920	10969	4	0	2
168505	1397	1309237058000	21923	10970	3	0	12959
168506	1397	1309227057000	21923	10970	4	0	12960
335760	1678	23760768043000	21923	10970	4	0	0
168512	2134	87121650000	21923	10970	10	0	3458
335766	1874	18526000	21923	10970	10	0	2
335771	1874	18539000	21923	10970	15	0	2
168518	2133	94423280000	21923	10970	16	0	3361
40740	1686	6871801700122	21923	10970	21	0	17
168523	1397	1309197054000	21924	10971	0	0	12963
335777	1678	23760768046000	21924	10971	0	0	0
3282	576	70397466726897	21924	10971	4	0	9
335786	1678	23760768047000	21927	10972	0	0	0
335787	1874	18557000	21927	10972	1	0	2
59261	2039	5659325000000	21927	10972	3	0	6
168543	1397	1309177052000	21931	10973	0	0	12965
335801	1874	18567000	21931	10973	4	0	2
168551	2133	94415264000	21933	10974	1	0	3369
49672	1703	720819000000	21940	10975	4	0	5
335823	1678	23760768052000	21941	10976	0	0	0
168570	2134	87112623000	21941	10976	1	0	3467
9103	1395	58180228977957278	21941	10976	4	0	0
335831	1874	18581000	21943	10977	3	0	2
168579	2133	94411256000	21943	10977	4	0	3373
28947	1637	261366229819988	21943	10977	7	0	0
335837	1874	18594000	21944	10978	2	0	2
45819	1692	51621037619999	21944	10978	3	0	5
168585	1397	1309097044000	21945	10979	0	0	12973
168596	2133	94408250000	21949	10980	2	0	3376
335849	1874	18604000	21949	10980	2	0	2
335854	1874	18608000	21950	10981	4	0	2
168602	2133	94405244000	21950	10981	5	0	3379
335869	1678	23760768062000	21952	10982	1	0	0
168617	2134	87103596000	21952	10982	2	0	3476
41598	1688	23039156910040	21952	10982	7	0	57
168622	1397	1309017036000	21953	10983	1	0	12981
335875	1678	23760768064000	21953	10983	1	0	0
6684	1394	542888921500000	21953	10983	7	0	0
168654	1397	1309007035000	21958	10985	0	0	12982
335907	1678	23760768065000	21958	10985	0	0	0
168655	1397	1308997034000	21958	10985	1	0	12983
335913	1874	18648000	21958	10985	6	0	2
168661	2134	87098581000	21958	10985	7	0	3481
335925	1678	23760768068000	21960	10986	0	0	0
335926	1874	18656000	21960	10986	1	0	2
168685	2134	87095572000	21964	10987	1	0	3484
335964	1678	23760768071000	21974	10988	1	0	0
168714	2133	94394222000	21974	10988	3	0	3390
335991	1874	18677000	21980	10989	1	0	2
168869	1397	1308927027000	21983	10990	0	0	12990
336121	1678	23760768073000	21983	10990	0	0	0
168870	1397	1308917026000	21983	10990	1	0	12991
336122	1678	23760768074000	21983	10990	1	0	0
168876	2133	94390214000	21984	10991	1	0	3394
336128	1874	18691000	21984	10991	1	0	2
26255	1613	22248219600000	21984	10991	4	0	6
27007	1623	63363031899898	21986	10992	4	0	1
168885	2134	87087548000	21987	10993	1	0	3492
336137	1874	18702000	21987	10993	1	0	2
168890	1397	1308857020000	21989	10995	1	0	12997
336142	1678	23760768080000	21989	10995	1	0	0
2064	369	80772351412810	21989	10995	7	0	15
168896	2133	94384202000	21990	10996	1	0	3400
336148	1874	18718000	21990	10996	1	0	2
168911	2133	94383200000	21994	10997	4	0	3401
336163	1874	18729000	21994	10997	4	0	2
168913	1397	1308817016000	21995	10998	0	0	13001
168914	2134	87081530000	21995	10998	1	0	3498
57587	1768	6946556110000	21995	10998	3	0	10
336168	1678	23760768085000	21996	10999	0	0	0
22112	1573	2739279000000	21996	10999	3	0	10
168920	2134	87079524000	21997	11000	1	0	3500
169050	1397	1308787013000	22000	11001	0	0	13004
336301	1678	23760768087000	22000	11001	0	0	0
169051	2134	87078521000	22000	11001	1	0	3501
336302	1874	18749000	22000	11001	1	0	2
14862	1457	28704641040000	22000	11001	3	0	4
169063	2134	87076515000	22004	11003	1	0	3503
336314	1874	18759000	22004	11003	1	0	2
169069	369	71556064190850	22005	11004	4	0	16
336320	1312	1712574323973610	22005	11004	4	0	0
336329	1678	23760768092000	22008	11005	0	0	0
336330	1874	18774000	22008	11005	1	0	2
169080	2133	94373180000	22008	11005	2	0	3411
20559	1555	15315426979096	22008	11005	4	0	4
34972	1679	8638529654000	22009	11006	1	0	75
336344	1874	18784000	22013	11007	1	0	2
169094	2133	94371176000	22013	11007	2	0	3413
6696	1394	547208969500000	22013	11007	4	0	0
336353	1874	18794000	22016	11009	2	0	2
169103	2133	94369172000	22016	11009	3	0	3415
336381	1678	23760768098000	22024	11011	0	0	0
169131	2134	87067488000	22024	11011	1	0	3512
12707	1440	2880178045924	22024	11011	4	0	11
336388	1678	23760768100000	22027	11013	0	0	0
169138	2134	87065482000	22027	11013	1	0	3514
9113	1395	58181669001957278	22027	11013	4	0	0
2747	484	68973814000000	22029	11014	2	0	8
336404	1057	909797285400000	22031	11015	1	0	0
169154	1724	8454665500000	22031	11015	2	0	12
336409	1678	23760768104000	22031	11015	6	0	0
169159	2132	148017018000	22031	11015	7	0	982
336415	1874	18832000	22031	11015	12	0	2
169165	2133	94361156000	22031	11015	13	0	3423
30305	1654	24045294999798	22031	11015	14	0	7
336426	1874	18840000	22035	11017	1	0	2
169176	2134	87060467000	22035	11017	2	0	3519
31289	1670	1440806000000	22035	11017	4	0	11
169303	1397	1308586993000	22037	11018	0	0	13024
336554	1678	23760768107000	22037	11018	0	0	0
169304	1397	1308576992000	22037	11018	1	0	13025
336555	1678	23760768108000	22037	11018	1	0	0
169310	2134	87058461000	22037	11018	7	0	3521
336561	1874	18857000	22037	11018	7	0	2
169316	1397	1308546989000	22039	11020	0	0	13028
336567	1678	23760768111000	22039	11020	0	0	0
169321	2134	87054449000	22040	11021	3	0	3525
336572	1874	18876000	22040	11021	3	0	2
169322	1397	1308526987000	22041	11022	0	0	13030
336582	1874	18885000	22043	11023	1	0	2
6705	1394	551528993500000	22043	11023	2	0	0
169346	1397	1308506985000	22045	11024	0	0	13032
336601	1874	18887000	22045	11024	4	0	2
336602	1874	18888000	22045	11024	5	0	2
169352	2133	94350134000	22045	11024	6	0	3434
169357	2133	94349132000	22045	11024	11	0	3435
336608	1874	18904000	22045	11024	11	0	2
169373	1397	1308456980000	22052	11026	0	0	13037
336624	1678	23760768120000	22052	11026	0	0	0
336629	1874	18921000	22053	11027	1	0	2
169379	2134	87045422000	22053	11027	2	0	3534
169387	2133	94342118000	22057	11029	1	0	3442
336638	1874	18931000	22057	11029	1	0	2
45854	1692	53781097619999	22057	11029	4	0	5
169399	1397	1308406975000	22061	11031	0	0	13042
336650	1678	23760768125000	22061	11031	0	0	0
336655	1874	18945000	22061	11031	5	0	2
169405	2133	94338110000	22061	11031	6	0	3446
169413	2134	87038401000	22063	11032	1	0	3541
336664	1874	18959000	22063	11032	1	0	2
169422	2134	87036395000	22066	11034	1	0	3543
336673	1874	18969000	22066	11034	1	0	2
336681	1874	18975000	22068	11035	2	0	2
169431	2134	87034389000	22068	11035	3	0	3545
35026	1679	10798567654000	22068	11035	7	0	75
169442	2134	87033386000	22070	11036	2	0	3546
336693	1874	18987000	22070	11036	2	0	2
497	43	86161008890000	22070	11036	4	0	1
169479	1654	15750361999798	22076	11037	0	0	8
169480	1397	1308316966000	22076	11037	1	0	13051
336733	1874	18991000	22076	11037	4	0	2
169486	1397	1308296964000	22077	11038	1	0	13053
336737	1874	18996000	22077	11038	2	0	2
336738	1874	18997000	22077	11038	3	0	2
169495	2134	87030377000	22079	11039	1	0	3549
336747	1678	23760768138000	22080	11040	1	0	0
9116	1395	58182389001957278	22080	11040	4	0	0
169500	1397	1308266961000	22081	11041	0	0	13056
41641	1688	26639203910040	22081	11041	3	0	57
169594	1397	1308256960000	22087	11042	0	0	13057
336844	1678	23760768140000	22087	11042	0	0	0
169595	1397	1308246959000	22087	11042	1	0	13058
336849	1874	19026000	22087	11042	5	0	2
169601	1397	1308236958000	22088	11043	0	0	13059
336860	1874	19037000	22091	11044	1	0	2
169612	1397	1308216956000	22092	11045	1	0	13061
336866	1874	19043000	22092	11045	5	0	2
169617	2134	87021350000	22092	11045	6	0	3558
336871	1874	19055000	22092	11045	11	0	2
169623	2132	148005006000	22092	11045	13	0	994
336873	1874	19058000	22092	11045	13	0	2
336874	1874	19059000	22092	11045	14	0	2
40764	1686	8311947700122	22092	11045	16	0	17
169632	2133	94316066000	22095	11047	1	0	3468
336883	1874	19069000	22095	11047	2	0	2
169637	2132	148003004000	22096	11048	3	0	996
336889	1874	19078000	22097	11049	1	0	2
169650	2134	87015332000	22099	11050	2	0	3564
336901	1874	19084000	22099	11050	3	0	2
169663	2133	94311056000	22101	11051	1	0	3473
336914	1874	19096000	22101	11051	2	0	2
169668	1397	1308106945000	22103	11053	0	0	13072
336920	1678	23760768157000	22103	11053	2	0	0
169674	2134	87009314000	22103	11053	6	0	3570
336925	1874	19113000	22103	11053	7	0	2
169680	2133	94306046000	22104	11054	2	0	3478
336931	1874	19121000	22104	11054	3	0	2
169689	1397	1308056940000	22106	11055	0	0	13077
336941	1874	19131000	22106	11055	2	0	2
17945	1509	24432325351155	22106	11055	4	0	5
169695	1397	1308036938000	22107	11056	2	0	13079
336946	1874	19135000	22107	11056	3	0	2
50269	1705	11360652580140	22107	11056	9	0	25
169707	1397	1308026937000	22110	11057	0	0	13080
336958	1874	19146000	22110	11057	1	0	2
20308	1549	30576301000000	22110	11057	3	0	5
169712	1397	1308016936000	22111	11058	2	0	13081
169774	2133	94299032000	22113	11059	0	0	3485
337022	1874	19156000	22113	11059	0	0	2
169775	2134	87001290000	22113	11059	1	0	3578
337023	1874	19159000	22113	11059	1	0	2
48148	1696	29297713335104	22113	11059	4	0	5
169789	2133	94298030000	22116	11060	4	0	3486
337037	1874	19165000	22116	11060	4	0	2
169795	2133	94297028000	22117	11061	5	0	3487
337043	1874	19171000	22117	11061	5	0	2
15993	1474	5230397000043	22117	11061	10	0	26
169814	1397	1307956930000	22120	11062	0	0	13087
337062	1678	23760768170000	22120	11062	0	0	0
169820	2133	94293020000	22120	11062	6	0	3491
337068	1874	19191000	22120	11062	6	0	2
28959	1637	263526291819988	22121	11063	5	0	0
169826	1397	1307926927000	22122	11064	0	0	13090
337074	1678	23760768173000	22122	11064	0	0	0
169834	2133	94290014000	22124	11065	2	0	3494
337082	1874	19207000	22124	11065	2	0	2
6713	1394	555849028500000	22124	11065	3	0	0
169843	2134	86990257000	22127	11067	1	0	3589
337091	1874	19216000	22127	11067	1	0	2
22438	1587	5760180000000	22128	11068	4	0	14
169849	1397	1307866921000	22129	11069	1	0	13096
337097	1678	23760768179000	22129	11069	1	0	0
169854	2133	94285004000	22129	11069	6	0	3499
337102	1874	19231000	22129	11069	6	0	2
169865	2133	94284002000	22131	11070	4	0	3500
169866	2133	94283000000	22131	11070	5	0	3501
337114	1874	19241000	22131	11070	5	0	2
55820	1746	12754469000000	22134	11071	5	0	2
169886	1397	1307816916000	22137	11072	1	0	13101
337134	1678	23760768184000	22137	11072	1	0	0
337139	1874	19257000	22137	11072	6	0	2
169892	2133	94280996000	22137	11072	7	0	3503
169897	2134	86981230000	22138	11073	2	0	3598
337145	1874	19266000	22138	11073	2	0	2
337146	1874	19268000	22138	11073	3	0	2
169903	2134	86979224000	22139	11074	2	0	3600
25449	1610	5040094999950	22139	11074	3	0	11
337172	1678	23760768189000	22142	11075	0	0	0
169938	1397	1307746909000	22144	11076	1	0	13108
337184	1874	19287000	22144	11076	3	0	2
169943	2133	94272980000	22144	11076	6	0	3511
58194	1850	8616296949999	22144	11076	8	0	9
337195	1874	19296000	22146	11077	1	0	2
169956	2134	86974209000	22147	11078	1	0	3605
337201	1678	23760768194000	22148	11079	0	0	0
169962	2134	86972203000	22148	11079	4	0	3607
337207	1874	19316000	22148	11079	6	0	2
16006	1474	6670483000043	22148	11079	8	0	26
169967	2133	94267970000	22149	11080	2	0	3516
337212	1874	19324000	22150	11081	1	0	2
39077	1684	8642887219748	22150	11081	4	0	136
6719	1394	560169065500000	22151	11082	0	0	0
169983	1397	1307656900000	22153	11083	2	0	13117
337228	1874	19330000	22153	11083	4	0	2
169989	2134	86968191000	22153	11083	8	0	3611
30929	1664	10000000	22153	11083	11	0	0
170021	1397	1307646899000	22158	11084	0	0	13118
337264	1678	23760768201000	22158	11084	0	0	0
170022	2133	94262960000	22158	11084	1	0	3521
337269	1874	19350000	22159	11085	3	0	2
9128	1395	58184549067957278	22159	11085	5	0	0
170033	1397	1307626897000	22161	11086	0	0	13120
337298	1678	23760768204000	22165	11087	0	0	0
337299	1874	19357000	22165	11087	1	0	2
170058	1696	27043433305104	22166	11088	0	0	6
337305	1874	19366000	22166	11088	4	0	2
35059	1679	12958701654000	22166	11088	5	0	75
170073	1696	23003941195104	22169	11089	0	0	7
337321	1874	19371000	22169	11089	5	0	2
25796	1611	5175523000000	22169	11089	7	0	9
170079	1696	12683606335104	22170	11090	0	0	9
337326	1320	1710262743410446	22170	11090	4	0	0
170085	2294	718998000000	22170	11090	6	0	2
337332	1874	19379000	22171	11091	2	0	2
55253	1740	9090695000000	22171	11091	3	0	13
170090	1397	1307566891000	22172	11092	0	0	13126
15620	1471	5705202900000	22172	11092	4	0	8
337338	1874	19387000	22173	11093	1	0	2
170096	2134	86958161000	22173	11093	2	0	3621
337343	1874	19396000	22174	11094	3	0	2
170102	2133	94253942000	22174	11094	5	0	3530
337356	1874	19406000	22176	11095	2	0	2
170114	1397	1307516886000	22177	11096	0	0	13131
337362	1874	19415000	22177	11096	5	0	2
170120	2133	94249934000	22177	11096	6	0	3534
337373	1874	19421000	22179	11097	3	0	2
170132	2134	86951140000	22179	11097	5	0	3628
28969	1637	264966350819988	22180	11098	4	0	0
337379	1678	23760768219000	22181	11099	0	0	0
170137	2133	94245926000	22181	11099	1	0	3538
170138	2134	86949134000	22181	11099	2	0	3630
337385	1874	19441000	22182	11100	2	0	2
170144	2134	86947128000	22182	11100	4	0	3632
170277	1397	1307436878000	22185	11101	0	0	13139
337519	1678	23760768222000	22185	11101	0	0	0
170278	1397	1307426877000	22185	11101	1	0	13140
337520	1678	23760768223000	22185	11101	1	0	0
170284	1397	1307416876000	22186	11102	0	0	13141
337526	1678	23760768224000	22186	11102	0	0	0
170290	2134	86943116000	22187	11103	3	0	3636
337532	1874	19468000	22187	11103	3	0	2
40325	1685	147603362571430	22188	11104	4	0	0
170295	1397	1307386873000	22189	11105	0	0	13144
337537	1678	23760768227000	22189	11105	0	0	0
59278	2039	7099360000000	22189	11105	4	0	6
23479	1594	7201639000000	22190	11106	4	0	10
170301	1397	1307366871000	22191	11107	0	0	13146
337543	1678	23760768229000	22191	11107	0	0	0
170311	2133	94234904000	22193	11108	2	0	3549
337553	1874	19493000	22193	11108	2	0	2
337554	1874	19495000	22193	11108	3	0	2
25188	1608	6618387000000	22193	11108	8	0	8
170316	1397	1307336868000	22194	11109	0	0	13149
337560	1874	19506000	22194	11109	2	0	2
6726	1394	564489090500000	22194	11109	4	0	0
170326	1397	1307316866000	22196	11110	2	0	13151
337570	1874	19510000	22196	11110	6	0	2
170332	2133	94230896000	22196	11110	8	0	3553
337575	1874	19521000	22198	11111	1	0	2
45869	1692	55941147619999	22198	11111	3	0	5
170462	1397	1307306865000	22200	11112	0	0	13152
337699	1678	23760768235000	22200	11112	0	0	0
170463	1397	1307296864000	22200	11112	1	0	13153
337700	1678	23760768236000	22200	11112	1	0	0
170475	2133	94226888000	22202	11113	1	0	3557
337712	1874	19535000	22202	11113	1	0	2
9136	1395	58186709118957278	22202	11113	3	0	0
170485	1397	1307266861000	22205	11115	0	0	13156
337722	1678	23760768239000	22205	11115	0	0	0
170490	2133	94223882000	22206	11116	1	0	3560
337727	1874	19551000	22206	11116	1	0	2
60025	2112	7920184000000	22206	11116	3	0	6
41685	1688	28799252910040	22207	11117	4	0	57
170556	1397	1307236858000	22209	11118	0	0	13159
337793	1678	23760768242000	22209	11118	0	0	0
170557	1397	1307226857000	22209	11118	1	0	13160
337799	1874	19568000	22209	11118	6	0	2
170563	2134	86924059000	22209	11118	7	0	3655
337814	1678	23760768246000	22211	11119	1	0	0
170579	2134	86921050000	22211	11119	3	0	3658
337828	1678	23760768247000	22213	11120	0	0	0
337829	1678	23760768248000	22213	11120	1	0	0
170593	1397	1307166851000	22213	11120	2	0	13166
337835	1874	19598000	22213	11120	7	0	2
170599	2132	147972974000	22213	11120	8	0	1026
22961	1588	25415564000000	22213	11120	9	0	6
337850	1874	19607000	22217	11122	1	0	2
170614	2132	147971973000	22217	11122	2	0	1027
337855	1874	19618000	22217	11122	6	0	2
170619	2133	94210856000	22217	11122	7	0	3573
337861	1874	19631000	22221	11123	4	0	2
170625	1654	5897241999798	22222	11124	0	0	11
25817	1611	6615660000000	22222	11124	5	0	9
337867	1874	19639000	22223	11125	1	0	2
170725	1397	1307116846000	22232	11126	0	0	13171
337962	1678	23760768254000	22232	11126	0	0	0
170726	2133	94206848000	22232	11126	1	0	3577
337963	1874	19641000	22232	11126	1	0	2
170732	2134	86909014000	22233	11127	2	0	3670
337969	1874	19650000	22233	11127	2	0	2
170738	2132	147968970000	22234	11128	2	0	1030
337975	1874	19658000	22234	11128	2	0	2
170759	1397	1307066841000	22237	11129	1	0	13176
337996	1678	23760768259000	22237	11129	1	0	0
170765	2133	94200836000	22237	11129	7	0	3583
338002	1874	19673000	22237	11129	7	0	2
57447	1764	21607332100000	22237	11129	9	0	8
170778	1717	16297474321623	22240	11131	2	0	6
338015	1040	910120239268005	22240	11131	2	0	0
21007	1560	5769636131803	22240	11131	7	0	29
170783	1397	1307036838000	22241	11132	0	0	13179
338020	1678	23760768262000	22241	11132	0	0	0
50302	1705	13520700580140	22241	11132	4	0	25
170797	1397	1307026837000	22244	11133	3	0	13180
338034	1678	23760768263000	22244	11133	3	0	0
170820	1397	1307016836000	22247	11134	0	0	13181
170821	2134	86900990000	22247	11134	1	0	3678
338058	1874	19694000	22247	11134	1	0	2
338073	1874	19699000	22251	11135	2	0	2
170837	2134	86899987000	22251	11135	3	0	3679
338086	1874	19710000	22253	11136	2	0	2
170850	2132	147965967000	22253	11136	3	0	1033
24442	1601	9253678620000	22253	11136	8	0	17
170855	2134	86895975000	22254	11137	1	0	3683
338092	1874	19721000	22254	11137	1	0	2
338108	1678	23760768271000	22259	11139	0	0	0
170872	2134	86893969000	22259	11139	1	0	3685
338109	1874	19731000	22259	11139	1	0	2
59678	2087	2160249000000	22259	11139	5	0	2
170880	1397	1306926827000	22262	11141	0	0	13190
338117	1678	23760768273000	22262	11141	0	0	0
170888	2134	86890960000	22264	11142	2	0	3688
338126	1874	19750000	22264	11142	3	0	2
28972	1637	265686350819988	22264	11142	5	0	0
170894	2133	94184804000	22265	11143	3	0	3599
338131	1874	19752000	22265	11143	3	0	2
170900	2134	86888954000	22265	11143	9	0	3690
338137	1874	19763000	22265	11143	9	0	2
57616	1768	8386593110000	22267	11144	4	0	10
170919	1397	1306866821000	22269	11145	0	0	13196
338157	1874	19773000	22269	11145	1	0	2
170925	2134	86883939000	22270	11146	3	0	3695
338162	1874	19782000	22270	11146	3	0	2
170931	2133	94177790000	22271	11147	1	0	3606
338168	1874	19789000	22271	11147	1	0	2
6732	1394	568809128500000	22271	11147	3	0	0
170936	2133	94175786000	22272	11148	3	0	3608
338174	1874	19799000	22272	11148	4	0	2
50978	1708	11588088115923	22272	11148	8	0	7
170942	2134	86879927000	22273	11149	1	0	3699
338179	1874	19806000	22273	11149	1	0	2
9146	1395	58188149179957278	22273	11149	4	0	0
170951	2133	94173782000	22275	11150	4	0	3610
338188	1874	19814000	22275	11150	4	0	2
170953	1397	1306776812000	22276	11151	0	0	13205
170954	2134	86877921000	22276	11151	1	0	3701
338197	1874	19823000	22278	11152	1	0	2
170963	2134	86875915000	22280	11153	1	0	3703
338204	1874	19832000	22282	11154	1	0	2
6740	1394	573129154500000	22282	11154	4	0	0
171099	1397	1306746809000	22285	11155	0	0	13208
338335	1678	23760768291000	22285	11155	0	0	0
171100	2134	86873909000	22285	11155	1	0	3705
338336	1874	19840000	22285	11155	1	0	2
171112	1397	1306716806000	22289	11157	1	0	13211
338348	1678	23760768294000	22289	11157	1	0	0
1967	369	72996365190840	22289	11157	8	0	16
171132	1397	1306706805000	22293	11159	0	0	13212
338368	1678	23760768295000	22293	11159	0	0	0
338369	1678	23760768296000	22293	11159	1	0	0
338370	1874	19861000	22293	11159	2	0	2
171137	2133	94162760000	22293	11159	5	0	3621
6748	1394	576009204500000	22293	11159	8	0	0
338376	1678	23760768298000	22294	11160	1	0	0
171143	2134	86867891000	22294	11160	4	0	3711
171274	1397	1306666801000	22297	11161	0	0	13216
338508	1678	23760768299000	22297	11161	0	0	0
171275	2133	94159754000	22297	11161	1	0	3624
338509	1874	19881000	22297	11161	1	0	2
34850	1678	24480768299000	22297	11161	3	0	0
171284	2132	147955957000	22299	11162	4	0	1043
338518	1874	19885000	22299	11162	4	0	2
171290	2134	86864882000	22299	11162	10	0	3714
338524	1874	19897000	22299	11162	10	0	2
21835	1571	5472155151480	22299	11162	15	0	41
171298	2133	94154744000	22301	11163	1	0	3629
338532	1874	19908000	22301	11163	1	0	2
171307	1397	1306586793000	22304	11165	1	0	13224
338541	1678	24480780307000	22304	11165	1	0	0
171313	2134	86856858000	22304	11165	7	0	3722
338547	1874	19927000	22304	11165	7	0	2
15467	1467	17246962100039	22304	11165	12	0	4
171321	2133	94149734000	22306	11166	1	0	3634
338555	1874	19934000	22306	11166	1	0	2
171432	1397	1306556790000	22310	11167	0	0	13227
338666	1678	24480780310000	22310	11167	0	0	0
171433	2132	147952954000	22310	11167	1	0	1046
338667	1874	19938000	22310	11167	1	0	2
171439	1397	1306536788000	22312	11169	0	0	13229
338673	1678	24480780312000	22312	11169	0	0	0
171449	2132	147951953000	22314	11170	3	0	1047
338683	1874	19959000	22314	11170	3	0	2
171454	2134	86850840000	22316	11171	4	0	3728
338688	1874	19962000	22316	11171	4	0	2
171468	1555	10919816296305	22318	11172	2	0	7
338702	1221	611762327909290	22318	11172	2	0	0
171474	1657	11705990990100	22318	11172	8	0	8
338708	1098	908293245000000	22318	11172	8	0	0
50548	1706	7482018450256	22318	11172	12	0	27
171490	1397	1306466781000	22320	11173	1	0	13236
338724	1678	24480780319000	22320	11173	1	0	0
41718	1688	30239323910040	22320	11173	7	0	57
171496	2132	147949951000	22320	11173	8	0	1049
338730	1874	19990000	22320	11173	8	0	2
171497	2133	94140716000	22320	11173	9	0	3643
171498	2133	94139714000	22320	11173	10	0	3644
16956	1501	104000000	22320	11173	13	1	0
338754	1874	19998000	22323	11174	2	0	2
171522	1657	1441167990100	22323	11174	4	0	11
338788	1678	24480780323000	22329	11175	0	0	0
338789	1874	20002000	22329	11175	1	0	2
171565	1397	1306416776000	22332	11177	0	0	13241
338801	1678	24480780326000	22332	11177	2	0	0
171570	2133	94133702000	22332	11177	5	0	3650
338818	1678	24480780328000	22334	11178	1	0	0
171587	2133	94130696000	22334	11178	4	0	3653
338823	1874	20029000	22334	11178	6	0	2
171593	1397	1306366771000	22335	11179	0	0	13246
338829	1874	20041000	22335	11179	2	0	2
171598	2133	94129694000	22335	11179	5	0	3654
338838	1874	20051000	22337	11180	1	0	2
171607	2134	86832786000	22338	11181	1	0	3746
338843	1678	24480780333000	22339	11182	0	0	0
6758	1394	580329242500000	22339	11182	5	0	0
171633	1397	1306316766000	22342	11183	0	0	13251
171634	1397	1306306765000	22342	11183	1	0	13252
338869	1678	24480780336000	22342	11183	2	0	0
48819	1700	3834155979053	22342	11183	7	0	10
171640	1397	1306286763000	22343	11184	0	0	13254
338875	1678	24480780338000	22343	11184	1	0	0
171646	2134	86828774000	22343	11184	6	0	3750
338880	1874	20085000	22343	11184	6	0	2
1099	111	71760102000000	22343	11184	8	0	0
171660	2134	86825765000	22345	11185	4	0	3753
338903	1678	24480780340000	22348	11186	0	0	0
51485	1710	5273921664140	22348	11186	5	0	10
171674	2133	94117670000	22349	11187	1	0	3666
338973	1678	24480780342000	22351	11188	0	0	0
338974	1874	20106000	22351	11188	1	0	2
171744	2132	147942944000	22353	11189	2	0	1056
338996	1678	24480780344000	22357	11190	0	0	0
4508	633	73629398900000	22357	11190	3	0	9
171768	1397	1306206755000	22359	11191	0	0	13262
171769	2134	86820750000	22359	11191	1	0	3758
171770	2133	94113662000	22359	11191	2	0	3670
339013	1678	24480780346000	22362	11192	0	0	0
23353	1593	29350615000000	22362	11192	5	0	4
171784	1397	1306176752000	22363	11193	1	0	13265
339018	1678	24480780348000	22363	11193	1	0	0
171790	2133	94110656000	22363	11193	7	0	3673
339024	1874	20144000	22363	11193	7	0	2
171795	2132	147940942000	22364	11194	3	0	1058
339034	1678	24480780351000	22366	11195	0	0	0
41767	1688	31679336710020	22366	11195	4	0	57
171805	2134	86813729000	22367	11196	2	0	3765
339039	1874	20160000	22367	11196	2	0	2
339065	1678	24480780354000	22371	11197	0	0	0
171832	1397	1306106745000	22372	11198	0	0	13272
339066	1678	24480780355000	22372	11198	0	0	0
171837	2133	94103642000	22373	11199	2	0	3680
339072	1874	20176000	22373	11199	3	0	2
9153	1395	58190309229957278	22373	11199	8	0	0
171843	2133	94101638000	22374	11200	1	0	3682
339078	1874	20189000	22374	11200	2	0	2
171849	2134	86806708000	22375	11201	4	0	3772
339083	1874	20196000	22375	11201	4	0	2
14871	1457	30864687040000	22375	11201	7	0	4
171861	2134	86805705000	22377	11202	2	0	3773
339096	1874	20205000	22377	11202	3	0	2
11996	1425	1537412000000	22377	11202	6	0	0
171867	2134	86803699000	22378	11203	2	0	3775
339102	1874	20216000	22378	11203	3	0	2
45882	1692	57381187619999	22378	11203	5	0	5
171876	1560	5768587131803	22381	11205	1	0	30
339110	2199	720338000000	22381	11205	1	0	0
171882	2133	94093622000	22383	11206	2	0	3690
339117	1874	20232000	22383	11206	3	0	2
29457	1649	6951473999968	22384	11207	3	0	8
171891	2134	86798684000	22386	11208	1	0	3780
339126	1874	20242000	22386	11208	2	0	2
171983	1397	1305966731000	22391	11209	0	0	13286
339217	1678	24480780369000	22391	11209	0	0	0
171984	2134	86797681000	22391	11209	1	0	3781
339218	1874	20245000	22391	11209	1	0	2
171994	1397	1305946729000	22394	11211	0	0	13288
339228	1678	24480780371000	22394	11211	0	0	0
14997	1458	11465157908540	22395	11212	4	0	8
172000	1397	1305926727000	22396	11213	0	0	13290
339234	1678	24480780373000	22396	11213	0	0	0
27438	1633	16596762975638	22396	11213	5	0	8
172023	1397	1305906725000	22401	11214	1	0	13292
339257	1678	24480780375000	22401	11214	1	0	0
172036	1397	1305886723000	22403	11215	1	0	13294
339270	1678	24480780377000	22403	11215	1	0	0
172041	2133	94082600000	22403	11215	6	0	3701
172068	1397	1305876722000	22405	11216	0	0	13295
339302	1678	24480780378000	22405	11216	0	0	0
339327	1678	24480780380000	22412	11218	0	0	0
172094	1397	1305846719000	22412	11218	1	0	13298
339328	1678	24480780381000	22412	11218	1	0	0
172100	2134	86787651000	22412	11218	7	0	3791
339334	1874	20307000	22412	11218	7	0	2
6766	1394	584649304500000	22412	11218	11	0	0
172105	2134	86784642000	22413	11219	2	0	3794
339340	1874	20319000	22413	11219	3	0	2
16284	1476	2880036000000	22413	11219	4	0	11
172116	2133	94074584000	22417	11221	1	0	3709
339350	1874	20326000	22417	11221	1	0	2
49197	1701	5758161500103	22420	11222	2	0	14
172159	2134	86781633000	22424	11223	2	0	3797
339393	1874	20334000	22424	11223	2	0	2
172164	1397	1305766711000	22426	11224	0	0	13306
339399	1678	24480780390000	22426	11224	1	0	0
172170	2134	86778624000	22426	11224	6	0	3800
339404	1874	20353000	22426	11224	6	0	2
172177	1397	1305736708000	22430	11226	0	0	13309
172178	2134	86776618000	22430	11226	1	0	3802
339413	1874	20363000	22430	11226	2	0	2
172184	1397	1305716706000	22432	11228	0	0	13311
339419	1874	20371000	22432	11228	1	0	2
172210	2133	94064564000	22436	11229	2	0	3719
339444	1874	20379000	22436	11229	2	0	2
172344	1397	1305696704000	22439	11230	0	0	13313
339578	1678	24480780396000	22439	11230	0	0	0
172345	1397	1305686703000	22439	11230	1	0	13314
339579	1678	24480780397000	22439	11230	1	0	0
172351	2134	86771603000	22439	11230	7	0	3807
339585	1874	20390000	22439	11230	7	0	2
172453	1397	1305676702000	22443	11231	0	0	13315
339687	1678	24480780398000	22443	11231	0	0	0
172454	2134	86770600000	22443	11231	1	0	3808
339688	1874	20393000	22443	11231	1	0	2
2465	470	71760229000000	22445	11232	3	0	11
172463	2134	86768594000	22446	11233	1	0	3810
339697	1874	20403000	22446	11233	1	0	2
30016	1654	8057266999798	22446	11233	4	0	11
172479	1397	1305636698000	22451	11235	0	0	13319
339713	1678	24480780402000	22451	11235	0	0	0
172484	2132	147924926000	22451	11235	5	0	1074
339718	1874	20419000	22451	11235	5	0	2
9163	1395	58192469277957278	22451	11235	7	0	0
339729	1874	20426000	22455	11237	2	0	2
172496	2134	86764582000	22455	11237	3	0	3814
339730	1874	20429000	22455	11237	3	0	2
172516	2134	86762576000	22461	11239	2	0	3816
339750	1874	20439000	22461	11239	2	0	2
172521	1397	1305566691000	22463	11241	0	0	13326
339756	1874	20448000	22463	11241	1	0	2
172530	2134	86759567000	22465	11242	3	0	3819
339764	1874	20456000	22465	11242	3	0	2
172665	1397	1305546689000	22470	11243	0	0	13328
339899	1678	24480780411000	22470	11243	0	0	0
172666	2134	86758564000	22470	11243	1	0	3820
339900	1874	20459000	22470	11243	1	0	2
172672	2133	94046528000	22471	11244	4	0	3737
339906	1874	20466000	22471	11244	4	0	2
172685	1397	1305486683000	22474	11245	3	0	13334
339919	1678	24480780417000	22474	11245	3	0	0
172690	2134	86753549000	22474	11245	8	0	3825
339924	1874	20484000	22474	11245	8	0	2
6773	1394	588969329500000	22474	11245	13	0	0
172696	1693	10210650245940	22475	11246	1	0	981
339930	2181	700610585574	22475	11246	1	0	1
172724	1397	1305466681000	22479	11247	0	0	13336
172725	1693	10066055243367	22479	11247	1	0	984
339959	240	66047839524375	22479	11247	1	0	1
339964	1772	5023827484556	22479	11247	6	0	1
172731	2133	94040516000	22479	11247	7	0	3743
339970	92	66702358779471	22480	11248	3	0	0
172737	1693	9346328364119	22480	11248	4	0	993
172750	1693	9193040521774	22482	11249	1	0	996
339984	395	66199315633740	22482	11249	1	0	2
339989	91	66702358779471	22482	11249	6	0	0
172756	1693	8987573442164	22482	11249	7	0	1001
339995	658	66702358779471	22482	11249	13	0	0
172762	1397	1305436678000	22482	11249	14	0	13339
18160	1513	33841153000000	22482	11249	19	0	0
172776	1397	1305426677000	22485	11250	0	0	13340
340010	1678	24480780423000	22485	11250	0	0	0
340011	150	66702358779471	22485	11250	1	0	0
172782	1693	8051377514279	22485	11250	6	0	1012
340017	1874	20519000	22485	11250	7	0	2
172788	1693	7949184188895	22486	11251	2	0	1014
340023	1150	614373845207994	22486	11251	3	0	0
172793	1693	7325194285648	22486	11251	7	0	1018
340028	108	66702358779471	22486	11251	8	0	0
172799	1693	7068259838258	22486	11251	13	0	1024
340034	1874	20525000	22486	11251	14	0	2
172823	1693	7017163175566	22488	11252	1	0	1025
340058	283	66047229092394	22488	11252	2	0	1
172828	1693	6851921165075	22488	11252	6	0	1030
340063	1874	20535000	22488	11252	7	0	2
36272	1681	8531247909853	22488	11252	10	0	11
172869	1397	1305386673000	22494	11253	0	0	13344
172870	1397	1305376672000	22494	11253	1	0	13345
340107	1874	20540000	22494	11253	4	0	2
172876	2134	86742516000	22494	11253	7	0	3836
340117	1874	20551000	22496	11254	2	0	2
39124	1684	10802953219748	22496	11254	4	0	136
172893	1397	1305346669000	22499	11255	2	0	13348
340129	2164	701019585574	22499	11255	4	0	1
172898	1693	6498592379788	22499	11255	7	0	1037
340135	377	66702358779471	22499	11255	10	0	0
340137	530	66625396763316	22499	11255	12	0	1
172904	1693	6014301240164	22499	11255	13	0	1043
340138	893	310088064614009	22499	11255	13	0	0
172910	1693	5715906442397	22499	11255	19	0	1049
340144	339	66702358779471	22499	11255	19	0	0
172915	2133	94029494000	22499	11255	24	0	3754
340150	1874	20563000	22499	11255	25	0	2
172921	1693	5562616454321	22501	11256	2	0	1052
340155	252	66702358779471	22501	11256	2	0	0
172927	2134	86738504000	22501	11256	8	0	3840
340161	1874	20571000	22501	11256	8	0	2
172941	1693	5267651774610	22504	11257	4	0	1059
340176	578	66046828809135	22504	11257	5	0	1
172947	1693	5012358154437	22504	11257	10	0	1065
340181	353	66004148160270	22504	11257	10	0	3
172953	2134	86736498000	22504	11257	16	0	3842
340187	1874	20578000	22504	11257	16	0	2
172988	1693	3477622708117	22508	11259	3	0	1071
340223	620	66702358779471	22508	11259	4	0	0
172993	1693	3269077897079	22508	11259	8	0	1076
172994	1693	3217981234387	22508	11259	9	0	1077
340228	452	66702358779471	22508	11259	9	0	0
173000	2134	86734492000	22508	11259	15	0	3844
340234	1874	20586000	22508	11259	15	0	2
173026	1693	3017940808405	22510	11260	1	0	1081
340260	352	66702358779471	22510	11260	1	0	0
173035	2133	94020476000	22512	11261	2	0	3763
340269	1874	20603000	22512	11261	2	0	2
51771	1711	6186779000000	22512	11261	3	0	13
340274	1678	24480780440000	22515	11262	0	0	0
340275	1874	20604000	22515	11262	1	0	2
6782	1394	593289493500000	22515	11262	4	0	0
173049	1693	2966844145713	22517	11263	1	0	1082
340285	191	66702358779471	22517	11263	3	0	0
173055	1693	2766805348502	22518	11264	1	0	1086
340291	82	66702358779471	22518	11264	3	0	0
173060	1693	2520017090656	22518	11264	6	0	1091
340296	1874	20616000	22518	11264	8	0	2
173075	1693	2366727102580	22520	11265	3	0	1094
340311	327	66046738745395	22520	11265	5	0	1
173081	1397	1305216656000	22521	11266	0	0	13361
340317	1041	909304391472409	22521	11266	2	0	0
173086	1693	1984627940711	22521	11266	5	0	1098
340322	721	2021283599286	22521	11266	7	0	0
173092	2134	86728474000	22521	11266	11	0	3850
340341	1678	24480780445000	22523	11267	0	0	0
173111	1693	1028410618920	22523	11267	4	0	1106
340347	690	66702358779471	22523	11267	6	0	0
40343	1685	149763459571430	22523	11267	10	0	0
173116	1397	1305196654000	22524	11268	0	0	13363
340352	1874	20637000	22524	11268	2	0	2
173122	2133	94012460000	22525	11269	3	0	3771
173129	1397	1305176652000	22528	11270	0	0	13365
173130	1397	1305166651000	22528	11270	1	0	13366
340364	1678	24480780449000	22528	11270	1	0	0
173136	2133	94011458000	22529	11271	3	0	3772
340370	1874	20652000	22529	11271	3	0	2
340375	1874	20664000	22529	11271	8	0	2
6789	1394	597609681500000	22529	11271	9	0	0
173158	1397	1305136648000	22532	11272	0	0	13369
173163	2134	86719447000	22532	11272	6	0	3859
340397	1874	20674000	22532	11272	6	0	2
173169	1397	1305106645000	22533	11273	5	0	13372
340403	1678	24480780455000	22533	11273	5	0	0
340408	1874	20681000	22533	11273	10	0	2
173175	2133	94005446000	22533	11273	11	0	3778
340409	1874	20683000	22533	11273	11	0	2
340410	1874	20685000	22533	11273	12	0	2
35133	1679	15839046654000	22533	11273	14	0	75
173180	2133	94003442000	22534	11274	3	0	3780
340416	1874	20690000	22534	11274	5	0	2
30381	1656	7195343999990	22534	11274	8	0	8
173189	2133	94001438000	22536	11275	1	0	3782
11254	1419	14688188560130	22536	11275	3	0	6
340437	1811	1920594636015	22538	11276	0	0	1
173207	1693	1396072292484	22538	11276	4	0	1117
340442	1874	20704000	22538	11276	5	0	2
173212	2133	94000436000	22538	11276	9	0	3783
340448	1874	20717000	22538	11276	11	0	2
56860	1759	21601080999889	22538	11276	13	0	7
60494	2248	7199408000000	22540	11277	3	0	0
173228	1397	1305026637000	22544	11278	0	0	13380
340464	1678	24480780464000	22545	11279	0	0	0
173234	2133	93995426000	22545	11279	4	0	3788
340469	1678	24480780465000	22547	11280	0	0	0
173239	2134	86707411000	22547	11280	4	0	3871
340475	1874	20741000	22547	11280	6	0	2
173245	2132	147905907000	22547	11280	10	0	1093
340481	1874	20754000	22547	11280	12	0	2
31324	1670	3600843000000	22547	11280	13	0	11
23718	1596	3600084000000	22549	11281	3	0	16
173264	1397	1304956630000	22550	11282	0	0	13387
173265	2132	147904906000	22550	11282	1	0	1094
340499	1874	20760000	22550	11282	1	0	2
173266	2133	93989414000	22550	11282	2	0	3794
340511	1874	20771000	22552	11283	3	0	2
173278	2133	93988412000	22552	11283	4	0	3795
340521	1678	24480780474000	22556	11285	0	0	0
173288	2133	93985406000	22556	11285	1	0	3798
340532	1874	20788000	22559	11286	1	0	2
173299	2134	86697381000	22559	11286	2	0	3881
6796	1394	600489732500000	22559	11286	3	0	0
340541	1874	20797000	22561	11287	4	0	2
173308	2132	147902904000	22561	11287	5	0	1096
340548	1678	24480780478000	22563	11288	0	0	0
340549	1874	20805000	22563	11288	1	0	2
173317	1397	1304866621000	22564	11289	0	0	13396
340573	1678	24480780481000	22568	11290	1	0	0
173340	1397	1304836618000	22568	11290	2	0	13399
340579	1773	3775000000000	22568	11290	7	0	36
173346	2087	1155375147766	22568	11290	8	0	3
41309	1687	15020326223172	22568	11290	12	0	6
340584	1678	24480780483000	22569	11291	0	0	0
173352	2133	93977390000	22569	11291	2	0	3806
60039	2112	10080220000000	22569	11291	3	0	6
18916	1536	5040097000000	22571	11292	3	0	11
340596	2298	81793760832	22573	11293	0	0	0
173363	1397	1304806615000	22573	11293	1	0	13402
340602	1293	1715841505382575	22573	11293	6	0	0
173369	2133	93975386000	22573	11293	7	0	3808
9180	1395	58194629520957278	22573	11293	10	0	0
340617	1874	20841000	22575	11294	1	0	2
173413	1397	1304786613000	22578	11295	0	0	13404
173414	1397	1304776612000	22578	11295	1	0	13405
340651	1874	20850000	22578	11295	4	0	2
173420	2133	93973382000	22578	11295	7	0	3810
340657	1647	20000000	22578	11295	10	0	0
52080	1714	6765542171760	22578	11295	12	0	11
173426	2133	93970376000	22579	11296	2	0	3813
340662	1874	20866000	22579	11296	4	0	2
173431	2134	86682336000	22580	11297	2	0	3896
24494	1601	10693704620000	22580	11297	4	0	17
173558	1866	14036160040241	22582	11298	0	0	25
340792	481	66538923411010	22582	11298	0	0	0
173559	1866	14031846886335	22582	11298	1	0	26
340793	734	2016331012363	22582	11298	1	0	0
173583	1866	10498102594221	22585	11299	1	0	29
340817	936	507110804697234	22585	11299	1	0	0
340818	1056	908738217092021	22585	11299	2	0	0
173589	2134	86680330000	22585	11299	7	0	3898
340824	1874	20881000	22585	11299	8	0	2
173594	2133	93966368000	22586	11300	3	0	3817
340834	1874	20890000	22588	11301	1	0	2
173604	2132	147896898000	22589	11302	2	0	1102
41827	1688	33839370720020	22589	11302	3	0	57
340839	1678	24480780498000	22591	11303	0	0	0
173610	2133	93963362000	22591	11303	5	0	3820
340845	1874	20900000	22591	11303	6	0	2
173615	2134	86677321000	22591	11303	10	0	3901
340851	1874	20915000	22591	11303	12	0	2
173637	1397	1304646599000	22593	11304	0	0	13418
340871	1874	20927000	22593	11304	2	0	2
173652	2133	93957350000	22596	11305	2	0	3826
340887	1678	24480780504000	22598	11306	1	0	0
173660	2246	0	22598	11306	4	0	3
340893	1874	20938000	22598	11306	7	0	2
173666	2134	86667291000	22598	11306	10	0	3911
340898	1874	20952000	22598	11306	12	0	2
6801	1394	601929804500000	22598	11306	16	0	0
173697	1397	1304586593000	22601	11307	0	0	13424
173698	1397	1304576592000	22601	11307	1	0	13425
340930	1874	20962000	22601	11307	3	0	2
173710	2133	93952340000	22603	11308	3	0	3831
340942	1874	20972000	22603	11308	5	0	2
6802	1394	603369804500000	22603	11308	6	0	0
23968	1599	6776726097983	22605	11309	2	0	8
173720	1397	1304536588000	22607	11310	1	0	13429
340951	1678	24480780513000	22607	11310	2	0	0
340953	1874	20978000	22607	11310	4	0	2
340954	1874	20981000	22607	11310	5	0	2
173725	2134	86660270000	22607	11310	6	0	3918
340984	1874	20992000	22613	11312	2	0	2
173755	2133	93947330000	22613	11312	3	0	3836
341001	1874	21004000	22616	11313	1	0	2
173786	1397	1304496584000	22621	11314	0	0	13433
341020	1874	21011000	22621	11314	4	0	2
173791	1397	1304476582000	22622	11315	0	0	13435
341030	1874	21017000	22624	11316	1	0	2
173801	2133	93940316000	22624	11316	2	0	3843
35920	1680	6493247499559	22624	11316	4	0	12
173810	1397	1304456580000	22627	11317	0	0	13437
173811	1397	1304446579000	22627	11317	1	0	13438
341043	1874	21027000	22627	11317	3	0	2
173823	2133	93937310000	22629	11318	1	0	3846
341054	1874	21037000	22629	11318	2	0	2
58214	1850	10056318949999	22630	11319	4	0	9
173853	1397	1304416576000	22636	11320	0	0	13441
341084	1678	24480780525000	22636	11320	1	0	0
173858	2134	86648234000	22636	11320	5	0	3930
341093	1678	24480780526000	22638	11321	0	0	0
341094	1874	21055000	22638	11321	1	0	2
173872	2134	86646228000	22640	11322	1	0	3932
28982	1637	267126415819988	22640	11322	3	0	0
341110	1678	24480780528000	22643	11323	0	0	0
173896	1397	1304356570000	22647	11324	1	0	13447
341128	1874	21073000	22647	11324	3	0	2
173901	2132	147886888000	22647	11324	6	0	1112
341140	1874	21082000	22649	11325	1	0	2
53880	1723	5041656085979	22649	11325	4	0	12
173914	2133	93927290000	22650	11326	2	0	3856
9186	1395	58196789921957278	22650	11326	3	0	0
341159	1874	21092000	22655	11327	1	0	2
173933	2134	86640210000	22656	11328	1	0	3938
341173	1678	24480780535000	22660	11329	0	0	0
173945	2134	86639207000	22660	11329	2	0	3939
173946	2133	93924284000	22660	11329	3	0	3859
341178	1874	21108000	22660	11329	5	0	2
173962	1397	1304266561000	22662	11330	2	0	13456
341194	1874	21115000	22662	11330	4	0	2
173968	2133	93921278000	22662	11330	8	0	3862
341200	1678	24480780540000	22663	11331	0	0	0
173973	2133	93919274000	22663	11331	3	0	3864
341205	1874	21133000	22663	11331	5	0	2
173983	1397	1304226557000	22668	11332	0	0	13460
341215	1874	21143000	22668	11332	2	0	2
173989	2133	93915266000	22669	11333	2	0	3868
341224	1678	24480780546000	22671	11334	1	0	0
341225	1874	21154000	22671	11334	2	0	2
341226	1874	21155000	22671	11334	3	0	2
173997	2134	86628174000	22671	11334	4	0	3950
341232	1874	21167000	22672	11335	2	0	2
174006	1397	1304176552000	22674	11336	0	0	13465
341241	1874	21177000	22675	11337	2	0	2
174012	2132	147880882000	22675	11337	3	0	1118
341252	1678	24480780551000	22679	11339	0	0	0
174023	2133	93908252000	22679	11339	1	0	3875
44736	1691	4031001300052	22679	11339	3	0	10
46220	1693	2836696292484	22680	11340	4	0	1117
341258	1678	24480780553000	22681	11341	0	0	0
174029	1397	1304116546000	22681	11341	1	0	13471
341264	1874	21204000	22681	11341	6	0	2
174042	1397	1304106545000	22684	11342	0	0	13472
341283	1678	24480780556000	22687	11343	1	0	0
174054	2132	147878880000	22687	11343	2	0	1120
341293	1144	907614042293421	22690	11345	1	0	0
174064	1397	1304076542000	22690	11345	2	0	13475
341299	2028	18495268170000	22690	11345	7	0	4
174078	1397	1304056540000	22692	11346	0	0	13477
174087	1397	1304046539000	22694	11347	0	0	13478
174088	2133	93898232000	22694	11347	1	0	3885
341318	1874	21223000	22694	11347	1	0	2
174100	1397	1304026537000	22696	11348	1	0	13480
341330	1678	24480780563000	22696	11348	1	0	0
174106	2133	93895226000	22696	11348	7	0	3888
341336	1874	21230000	22696	11348	7	0	2
174111	2132	147875877000	22697	11349	3	0	1123
341341	1874	21235000	22697	11349	3	0	2
341364	1678	24480780567000	22703	11350	0	0	0
341365	1874	21237000	22703	11350	1	0	2
174139	2028	2446524320000	22703	11350	5	0	12
341371	1678	24480780569000	22704	11351	1	0	0
174145	2133	93889214000	22704	11351	5	0	3894
18410	1521	1440013000000	22704	11351	7	0	7
341388	1678	24480780571000	22708	11352	0	0	0
174166	1397	1303926527000	22710	11353	1	0	13490
341398	1874	21249000	22710	11353	3	0	2
174184	2133	93885206000	22713	11354	2	0	3898
341416	1874	21257000	22713	11354	4	0	2
174190	2133	93882200000	22714	11355	2	0	3901
13686	1447	23193745943000	22714	11355	4	0	6
341422	1678	24480780578000	22715	11356	0	0	0
15654	1471	8585269900000	22715	11356	2	0	8
174195	2133	93879194000	22716	11357	1	0	3904
44750	1691	5471035300052	22716	11357	3	0	10
341432	1678	24480780580000	22719	11358	0	0	0
17064	1506	5332635967172	22719	11358	3	0	22
174210	2133	93877190000	22723	11360	1	0	3906
341442	1874	21274000	22723	11360	3	0	2
29823	1650	5872910000000	22724	11361	3	0	9
174216	1397	1303806515000	22725	11362	1	0	13502
174217	2133	93874184000	22725	11362	2	0	3909
174218	2132	147869871000	22725	11362	3	0	1129
341448	1874	21279000	22725	11362	3	0	2
3689	606	68206608286230	22725	11362	4	0	18
341463	1874	21283000	22730	11364	2	0	2
174234	2133	93871178000	22730	11364	3	0	3912
27016	1623	65523077899898	22730	11364	5	0	1
341469	1874	21290000	22732	11366	1	0	2
174240	2134	86618144000	22732	11366	2	0	3960
174245	1397	1303726507000	22736	11368	1	0	13510
341475	1678	24480780593000	22736	11368	1	0	0
341480	1874	21304000	22736	11368	6	0	2
174251	2133	93864164000	22736	11368	7	0	3919
341486	1874	21317000	22736	11368	12	0	2
174257	2134	86613129000	22736	11368	13	0	3965
52934	1717	4860995000055	22736	11368	14	0	8
341502	1678	24480780596000	22738	11369	0	0	0
341503	1678	24480780597000	22738	11369	1	0	0
174276	2133	93863162000	22738	11369	4	0	3920
35200	1679	17999070654000	22738	11369	6	0	75
341513	1874	21333000	22740	11370	1	0	2
6818	1394	607689875500000	22740	11370	4	0	0
174286	1397	1303666501000	22741	11371	0	0	13516
341519	1874	21341000	22741	11371	3	0	2
174292	2133	93859154000	22742	11372	2	0	3924
341524	1874	21348000	22742	11372	4	0	2
29004	1637	270006452819988	22742	11372	6	0	0
174297	1397	1303626497000	22743	11373	1	0	13520
341530	1874	21358000	22743	11373	4	0	2
174310	2133	93857150000	22745	11374	2	0	3926
48234	1698	7268834550062	22745	11374	6	0	12
341543	1678	24480780605000	22746	11375	0	0	0
174316	2132	147863865000	22746	11375	3	0	1135
341551	1874	21376000	22748	11376	1	0	2
174455	1397	1303586493000	22755	11377	0	0	13524
341684	1678	24480780607000	22755	11377	0	0	0
174456	1397	1303576492000	22755	11377	1	0	13525
341685	1678	24480780608000	22755	11377	1	0	0
174462	2134	86600090000	22755	11377	7	0	3978
341691	1874	21389000	22755	11377	7	0	2
9196	1395	58198949960957278	22757	11378	3	0	0
174478	1397	1303546489000	22758	11379	0	0	13528
341707	1678	24480780611000	22758	11379	0	0	0
174483	2132	147861863000	22759	11380	2	0	1137
341712	1874	21407000	22759	11380	2	0	2
174491	1397	1303526487000	22761	11381	0	0	13530
174492	1397	1303516486000	22761	11381	1	0	13531
341724	1678	24480780615000	22763	11382	0	0	0
174498	2133	93845126000	22763	11382	3	0	3938
341740	1874	21425000	22766	11383	1	0	2
174514	2134	86592066000	22767	11384	1	0	3986
14319	1451	19339114000000	22767	11384	2	0	9
341749	1874	21433000	22769	11385	1	0	2
49474	1702	3600487000000	22769	11385	5	0	5
174523	1397	1303466481000	22770	11386	0	0	13536
341755	1874	21444000	22770	11386	3	0	2
6824	1394	612009937500000	22770	11386	4	0	0
174529	2133	93839114000	22771	11387	2	0	3944
341761	1874	21454000	22771	11387	5	0	2
341802	1678	24480780622000	22774	11388	0	0	0
341803	1678	24480780623000	22774	11388	1	0	0
174577	1397	1303416476000	22774	11388	2	0	13541
174582	2134	86587051000	22774	11388	7	0	3991
341809	1874	21458000	22774	11388	7	0	2
174588	2133	93836108000	22774	11388	13	0	3947
341815	1874	21471000	22774	11388	14	0	2
174594	2134	86583039000	22774	11388	19	0	3995
341820	1874	21483000	22774	11388	19	0	2
40363	1685	151923504571430	22774	11388	21	0	0
174602	1397	1303366471000	22777	11390	0	0	13546
341829	1874	21494000	22777	11390	1	0	2
174608	2133	93829094000	22778	11391	2	0	3954
341835	1678	24480780631000	22779	11392	0	0	0
174614	2132	147855857000	22780	11393	2	0	1143
341840	1874	21510000	22780	11393	2	0	2
174634	2003	2075960654821	22784	11394	0	0	2
174635	1397	1303326467000	22784	11394	1	0	13550
341864	1874	21519000	22784	11394	4	0	2
174641	1397	1303306465000	22785	11395	0	0	13552
5379	1271	1348446447000000	22785	11395	3	0	0
341870	1678	24480780636000	22786	11396	0	0	0
174647	2134	86573009000	22786	11396	3	0	4005
341882	754	1010530128434	22789	11397	1	0	0
174659	2134	86572006000	22789	11397	4	0	4006
341888	1874	21544000	22789	11397	7	0	2
9203	1395	58200390029957278	22789	11397	9	0	0
174665	2133	93820076000	22790	11398	2	0	3963
341894	1874	21552000	22790	11398	5	0	2
45904	1692	59541249619999	22790	11398	8	0	5
174671	1397	1303236458000	22791	11399	2	0	13559
341899	1874	21560000	22791	11399	4	0	2
174676	2132	147852854000	22791	11399	7	0	1146
341905	1236	615511707000000	22791	11399	10	0	0
341906	996	509069236000000	22791	11399	11	0	0
6832	1394	614889972500000	22791	11399	12	0	0
174682	2134	86565988000	22792	11400	1	0	4012
41947	1688	37439449720020	22792	11400	3	0	57
341918	1874	21573000	22794	11401	2	0	2
174694	2134	86563982000	22794	11401	4	0	4014
11926	1422	21025348860211	22794	11401	7	0	7
341944	1874	21585000	22799	11402	2	0	2
174719	2133	93813062000	22799	11402	3	0	3970
341966	1874	21595000	22806	11404	0	0	2
60317	2148	4320096880750	22806	11404	1	0	2
174742	1397	1303166451000	22807	11405	1	0	13566
341972	1874	21603000	22807	11405	5	0	2
174748	2134	86558967000	22808	11406	1	0	4019
341978	1874	21613000	22809	11407	2	0	2
60832	2299	719000000000	22809	11407	3	0	0
60833	2299	719012000000	22809	11407	4	0	0
174756	1397	1303136448000	22811	11408	0	0	13569
174762	1397	1303126447000	22813	11409	0	0	13570
174763	2134	86555958000	22813	11409	1	0	4022
341989	1874	21620000	22813	11409	1	0	2
174782	2133	93805046000	22818	11410	4	0	3978
342008	1874	21632000	22818	11410	4	0	2
174788	2133	93803042000	22819	11411	5	0	3980
342014	1874	21642000	22819	11411	5	0	2
9211	1395	58202550079957278	22819	11411	8	0	0
22976	1588	27575625000000	22820	11412	3	0	6
174793	1397	1303076442000	22821	11413	0	0	13575
342019	1678	24480780658000	22821	11413	0	0	0
174799	2134	86548937000	22822	11414	2	0	4029
342025	1874	21659000	22822	11414	2	0	2
174806	2133	93798032000	22825	11415	5	0	3985
342032	1874	21666000	22825	11415	5	0	2
3120	526	69600160000000	22825	11415	10	0	2
174821	1397	1303026437000	22828	11416	0	0	13580
342047	1678	24480780663000	22828	11416	0	0	0
342048	1874	21678000	22828	11416	1	0	2
30648	1657	2881230990100	22828	11416	4	0	11
174831	2133	93795026000	22830	11417	3	0	3988
342058	1678	24480780665000	22831	11418	0	0	0
29014	1637	271446501819988	22831	11418	5	0	0
174841	2134	86541916000	22833	11419	1	0	4036
342068	1874	21696000	22833	11419	2	0	2
174854	1397	1302976432000	22838	11421	0	0	13585
342081	1678	24480780669000	22838	11421	1	0	0
174860	2132	147844846000	22838	11421	6	0	1154
342087	1678	24480780670000	22839	11422	0	0	0
174869	2134	86536901000	22844	11423	2	0	4041
342100	2300	59000000000	22846	11424	0	0	0
174878	2134	86535898000	22846	11424	4	0	4042
6839	1394	619210017500000	22846	11424	5	0	0
342105	1678	24480780673000	22847	11425	0	0	0
174890	2133	93785006000	22850	11426	2	0	3998
17698	1509	10463247503835	22850	11426	3	0	9
174905	1397	1302906425000	22856	11427	0	0	13592
342131	1678	24480780675000	22856	11427	0	0	0
174906	1580	24000000	22856	11427	1	0	2
342137	1874	21743000	22857	11428	2	0	2
174912	2134	86532889000	22857	11428	3	0	4045
342156	1672	3601284000000	22861	11429	2	0	10
13943	1448	12276833000001	22861	11429	4	0	8
174945	1397	1302876422000	22865	11430	0	0	13595
342175	1874	21760000	22865	11430	4	0	2
174958	1397	1302866421000	22868	11431	0	0	13596
342184	1678	24480780679000	22868	11431	0	0	0
342185	1874	21763000	22868	11431	1	0	2
58631	1980	20159471000000	22868	11431	4	0	1
174973	2133	93778994000	22871	11432	2	0	4004
342200	1678	24480780681000	22872	11433	0	0	0
174979	2134	86525868000	22873	11434	2	0	4052
342206	1874	21780000	22873	11434	3	0	2
2797	484	71133862000000	22873	11434	5	0	8
174984	2134	86524865000	22874	11435	2	0	4053
342211	1874	21786000	22874	11435	3	0	2
23505	1594	9361663000000	22874	11435	6	0	10
175008	2134	86522859000	22879	11436	2	0	4055
342235	1874	21797000	22879	11436	3	0	2
175018	2133	93772982000	22882	11438	2	0	4010
342245	1678	25200791688000	22883	11439	0	0	0
175023	1397	1302766411000	22884	11440	0	0	13606
342250	1678	25200791690000	22884	11440	1	0	0
175035	1397	1302746409000	22886	11441	0	0	13608
175036	2134	86516841000	22886	11441	1	0	4061
342262	1874	21824000	22886	11441	1	0	2
29024	1637	273606550819988	22886	11441	4	0	0
175100	1397	1302726407000	22892	11443	0	0	13610
342326	1678	25200791693000	22892	11443	0	0	0
342327	1874	21835000	22892	11443	1	0	2
19248	1541	2882265000000	22892	11443	3	0	4
175115	1397	1302706405000	22897	11445	0	0	13612
342342	1874	21845000	22897	11445	1	0	2
175123	2134	86511826000	22899	11446	1	0	4066
342354	1678	25200791697000	22901	11447	0	0	0
175143	2134	86509820000	22904	11448	1	0	4068
342370	1874	21862000	22904	11448	2	0	2
40798	1686	10472010700122	22904	11448	5	0	17
175152	1397	1302656400000	22907	11450	0	0	13617
342379	1678	25200791701000	22907	11450	1	0	0
175157	2133	93758954000	22907	11450	5	0	4024
342385	1874	21876000	22907	11450	7	0	2
175163	1447	17718630793000	22907	11450	11	0	7
342390	1099	909132525338000	22907	11450	12	0	0
11283	1419	16848227560130	22907	11450	15	0	6
175179	1397	1302626397000	22909	11451	0	0	13620
175180	2134	86504805000	22909	11451	1	0	4073
342411	1678	25200791704000	22911	11452	0	0	0
175192	1397	1302596394000	22913	11453	1	0	13623
342420	1874	21896000	22913	11453	3	0	2
175198	2133	93752942000	22913	11453	7	0	4030
342425	1874	21908000	22913	11453	8	0	2
175203	2134	86499790000	22914	11454	2	0	4078
29032	1637	275766587819988	22914	11454	5	0	0
342437	1678	25200791709000	22917	11455	0	0	0
175215	1397	1302556390000	22918	11456	0	0	13627
342443	1874	21924000	22918	11456	2	0	2
44773	1691	6911072300052	22918	11456	5	0	10
342478	1678	25200791711000	22921	11457	0	0	0
342479	1874	21929000	22921	11457	1	0	2
175254	2297	9362106805640	22921	11457	2	0	2
175274	2132	147831833000	22926	11458	3	0	1167
342500	1874	21938000	22926	11458	3	0	2
175361	1397	1302516386000	22930	11460	0	0	13631
342587	1678	25200791714000	22930	11460	0	0	0
175362	2134	86493772000	22930	11460	1	0	4084
342588	1874	21946000	22930	11460	1	0	2
60567	2250	203000000	22930	11460	4	1	0
58245	1850	11496369949999	22934	11461	5	0	9
175384	1397	1302496384000	22938	11462	0	0	13633
342610	1678	25200791716000	22938	11462	0	0	0
35241	1679	19439118654000	22938	11462	3	0	75
32716	1675	6764184999977	22940	11463	3	0	8
175498	2134	86489760000	22943	11464	0	0	4088
342724	1874	21967000	22943	11464	0	0	2
175499	2133	93741920000	22943	11464	1	0	4041
342725	1874	21969000	22943	11464	1	0	2
175521	1397	1302466381000	22945	11465	1	0	13636
342747	1678	25200791719000	22945	11465	1	0	0
175527	2133	93738914000	22945	11465	7	0	4044
342753	1874	21980000	22945	11465	7	0	2
175532	2134	86486751000	22945	11465	12	0	4091
342758	1874	21988000	22945	11465	12	0	2
21028	1560	7208660131803	22945	11465	17	0	30
175544	2133	93736910000	22948	11466	2	0	4046
342770	1874	21996000	22948	11466	2	0	2
17346	1508	8840351156616	22948	11466	4	0	10
175673	1397	1302416376000	22951	11467	0	0	13641
342899	1678	25200791724000	22951	11467	0	0	0
175674	1397	1302406375000	22951	11467	1	0	13642
342900	1678	25200791725000	22951	11467	1	0	0
175680	2134	86482739000	22951	11467	7	0	4095
342906	1874	22007000	22951	11467	7	0	2
6858	1394	623530064500000	22951	11467	8	0	0
175741	1397	1302396374000	22954	11468	0	0	13643
175742	2133	93733904000	22954	11468	1	0	4049
23361	1593	30790642000000	22954	11468	4	0	4
342972	1874	22017000	22955	11469	2	0	2
343012	1678	25200791728000	22957	11470	0	0	0
175787	1397	1302366371000	22957	11470	1	0	13646
343013	1678	25200791729000	22957	11470	1	0	0
175793	2132	147826828000	22957	11470	7	0	1172
343019	1874	22018000	22957	11470	7	0	2
175798	2133	93728894000	22957	11470	12	0	4054
343025	1874	22029000	22957	11470	13	0	2
175804	2134	86475718000	22957	11470	18	0	4102
343030	1874	22044000	22957	11470	18	0	2
9223	1395	58204710201957278	22957	11470	20	0	0
175824	2133	93725888000	22963	11472	1	0	4057
343050	1874	22051000	22963	11472	1	0	2
60049	2112	14206641101924	22963	11472	4	0	7
175834	2132	147824826000	22966	11473	3	0	1174
4186	632	73917550000000	22966	11473	4	0	9
343064	1678	25200791736000	22968	11474	0	0	0
175843	2134	86470703000	22968	11474	5	0	4107
343069	1874	22070000	22968	11474	5	0	2
175850	1397	1302276362000	22972	11475	0	0	13655
175851	2134	86469700000	22972	11475	1	0	4108
53211	1718	4578468519070	22972	11475	2	0	13
343081	1874	22079000	22973	11476	3	0	2
20696	1559	7506072999999	22973	11476	5	0	8
175860	2134	86467694000	22975	11477	1	0	4110
175990	1397	1302236358000	22981	11479	0	0	13659
343216	1678	25200791742000	22981	11479	0	0	0
175991	1397	1302226357000	22981	11479	1	0	13660
343217	1678	25200791743000	22981	11479	1	0	0
175997	2133	93716870000	22981	11479	7	0	4066
343223	1874	22096000	22981	11479	7	0	2
44458	1690	156245318000000	22981	11479	8	0	0
176011	2133	93714866000	22983	11480	5	0	4068
343237	1874	22100000	22983	11480	5	0	2
176035	2133	93711860000	22988	11482	1	0	4071
343261	1874	22107000	22988	11482	1	0	2
343269	1678	25200791749000	22990	11483	0	0	0
343270	1678	25200791750000	22990	11483	1	0	0
176046	2133	93709856000	22990	11483	3	0	4073
32582	1673	32580688000000	22990	11483	4	0	12
343281	1874	22114000	22992	11484	3	0	2
176057	1397	1302116346000	22993	11485	0	0	13671
343287	1874	22123000	22994	11486	1	0	2
176062	2134	86464685000	22994	11486	2	0	4113
6869	1394	626410127500000	22994	11486	5	0	0
343292	1874	22130000	22995	11487	2	0	2
176068	2133	93704846000	22995	11487	4	0	4078
51793	1711	8346816000000	22995	11487	6	0	13
343298	1678	25200791760000	22996	11488	2	0	0
176074	2134	86461676000	22996	11488	4	0	4116
343304	1874	22147000	22996	11488	8	0	2
176079	2133	93701840000	22996	11488	9	0	4081
343309	1874	22159000	22996	11488	13	0	2
176088	2134	86457664000	22998	11489	1	0	4120
343318	1874	22169000	22999	11490	2	0	2
58255	1850	12216381949999	22999	11490	4	0	9
176103	2134	86455658000	23003	11491	1	0	4122
343329	1874	22172000	23003	11491	1	0	2
176104	2133	93696830000	23003	11491	2	0	4086
343330	1874	22174000	23003	11491	2	0	2
9227	1395	58205430213957278	23003	11491	4	0	0
176105	1397	1302006335000	23004	11492	0	0	13682
343331	1678	25200791765000	23004	11492	0	0	0
176106	2132	147816818000	23004	11492	1	0	1182
343332	1874	22175000	23004	11492	1	0	2
176107	2133	93695828000	23004	11492	2	0	4087
343333	1874	22177000	23004	11492	2	0	2
176108	2134	86454655000	23004	11492	3	0	4123
343334	1874	22180000	23004	11492	3	0	2
27544	1634	10462988259504	23004	11492	4	0	18
27545	1634	10463001259504	23004	11492	5	0	18
176115	1397	1301996334000	23007	11493	0	0	13683
343341	1678	25200791766000	23007	11493	0	0	0
176116	2134	86453652000	23007	11493	1	0	4124
343342	1874	22183000	23007	11493	1	0	2
176117	2133	93694826000	23007	11493	2	0	4088
343343	1874	22185000	23007	11493	2	0	2
13064	1444	6567712329999	23007	11493	4	0	12
176144	1397	1301986333000	23012	11494	0	0	13684
343370	1678	25200791767000	23012	11494	0	0	0
176145	1397	1301976332000	23012	11494	1	0	13685
343371	1678	25200791768000	23012	11494	1	0	0
176146	2132	147815817000	23012	11494	2	0	1183
343372	1874	22186000	23012	11494	2	0	2
176147	2133	93693824000	23012	11494	3	0	4089
343373	1874	22188000	23012	11494	3	0	2
343410	1678	25200791770000	23019	11497	0	0	0
343411	1678	25200791771000	23019	11497	1	0	0
343417	1874	22211000	23019	11497	7	0	2
176192	2134	86446631000	23019	11497	8	0	4131
343481	1678	25200791774000	23022	11498	0	0	0
176256	2134	86445628000	23022	11498	1	0	4132
176257	2133	93686810000	23022	11498	2	0	4096
176268	1397	1301906325000	23029	11499	0	0	13692
343505	1678	25200791776000	23033	11500	0	0	0
176283	2134	86442619000	23033	11500	4	0	4135
343511	1874	22241000	23033	11500	6	0	2
31721	1671	5423870003785	23033	11500	7	0	8
176289	2133	93683804000	23034	11501	3	0	4099
343517	1874	22246000	23034	11501	5	0	2
176294	2134	86440613000	23034	11501	8	0	4137
49231	1701	7918196500103	23034	11501	10	0	14
343532	1678	25200791781000	23036	11502	0	0	0
176310	2134	86437604000	23036	11502	4	0	4140
343537	1874	22266000	23036	11502	5	0	2
343538	1874	22268000	23036	11502	6	0	2
176326	1397	1301816316000	23038	11503	0	0	13701
343554	1874	22276000	23038	11503	2	0	2
176331	2134	86434595000	23038	11503	5	0	4143
343567	1874	22286000	23040	11504	1	0	2
176350	2133	93674786000	23043	11505	1	0	4108
343582	1678	25200791788000	23045	11506	0	0	0
176360	1397	1301766311000	23046	11507	0	0	13706
343588	1874	22305000	23046	11507	2	0	2
176393	1397	1301756310000	23049	11508	0	0	13707
176394	1397	1301746309000	23049	11508	1	0	13708
343624	1874	22315000	23049	11508	5	0	2
176403	1397	1301736308000	23051	11509	0	0	13709
48867	1700	5274212979053	23051	11509	4	0	10
343632	1874	22323000	23052	11510	0	0	2
176409	1397	1301716306000	23053	11511	1	0	13711
343638	1874	22332000	23053	11511	4	0	2
176414	2133	93666770000	23053	11511	6	0	4116
51522	1710	7433973664140	23053	11511	8	0	10
343651	1678	25200791796000	23056	11513	0	0	0
176427	2134	86422559000	23056	11513	2	0	4155
343656	1874	22351000	23058	11514	2	0	2
6880	1394	630730164500000	23058	11514	3	0	0
176447	1397	1301666301000	23062	11515	1	0	13716
343673	1678	25200791799000	23062	11515	1	0	0
343674	1874	22356000	23062	11515	2	0	2
16316	1476	5040074000000	23062	11515	6	0	11
176452	1397	1301656300000	23064	11516	0	0	13717
343680	1874	22367000	23064	11516	2	0	2
57652	1768	10546641110000	23064	11516	5	0	10
176472	2133	93659756000	23068	11517	2	0	4123
343700	1874	22376000	23068	11517	4	0	2
1472	171	73146737696494	23068	11517	7	0	8
176478	2134	86415538000	23070	11518	2	0	4162
343708	1678	25200791804000	23072	11519	0	0	0
176493	1397	1301606295000	23075	11520	0	0	13722
343721	1874	22395000	23075	11520	2	0	2
176499	2133	93653744000	23077	11522	1	0	4129
343727	1874	22403000	23077	11522	3	0	2
12740	1440	5040218045924	23077	11522	6	0	11
176513	2134	86410523000	23080	11523	2	0	4167
14330	1451	20059137000000	23080	11523	4	0	9
343740	1678	25200791809000	23081	11524	0	0	0
176518	2133	93650738000	23082	11525	1	0	4132
343746	1874	22422000	23082	11525	3	0	2
29039	1637	277926611819988	23083	11526	3	0	0
176524	1397	1301536288000	23084	11527	0	0	13729
343752	1678	25200791814000	23084	11527	2	0	0
176529	2134	86405508000	23084	11527	5	0	4172
176530	2134	86404505000	23084	11527	6	0	4173
343757	1874	22439000	23084	11527	7	0	2
42014	1688	39599485720020	23084	11527	10	0	57
176541	2133	93645728000	23087	11528	2	0	4137
343843	1678	25200791816000	23090	11529	0	0	0
343844	1678	25200791817000	23090	11529	1	0	0
176622	2132	147800802000	23090	11529	5	0	1198
343850	1874	22452000	23090	11529	7	0	2
176627	2134	86402499000	23090	11529	10	0	4175
343856	1874	22468000	23090	11529	13	0	2
176633	2133	93640718000	23090	11529	16	0	4142
343861	1874	22478000	23091	11530	1	0	2
176639	2133	93638714000	23092	11531	2	0	4144
343881	1678	25200791824000	23095	11532	1	0	0
176658	2133	93636710000	23095	11532	4	0	4146
343887	1678	25200791825000	23096	11533	0	0	0
3135	526	71040221000000	23096	11533	4	0	2
176667	1397	1301396274000	23098	11534	0	0	13743
176668	1397	1301386273000	23098	11534	1	0	13744
343895	1874	22502000	23098	11534	2	0	2
176674	2133	93632702000	23099	11535	1	0	4150
343901	1874	22514000	23099	11535	2	0	2
4858	641	73203802000000	23101	11536	3	0	16
176681	2132	147796798000	23102	11537	1	0	1202
343908	1874	22522000	23102	11537	2	0	2
176686	2133	93629696000	23103	11538	2	0	4153
343913	1678	25200791832000	23104	11539	0	0	0
176695	2133	93627692000	23106	11540	2	0	4155
42028	1688	40319534720020	23106	11540	4	0	57
343926	1678	25200791834000	23108	11541	0	0	0
32032	1672	4321284000000	23108	11541	4	0	10
176712	2134	86384445000	23111	11542	1	0	4193
343939	1874	22551000	23111	11542	2	0	2
6890	1394	635050189500000	23112	11543	4	0	0
176717	1397	1301286263000	23113	11544	0	0	13754
343944	1874	22559000	23113	11544	1	0	2
343945	1874	22560000	23113	11544	2	0	2
343946	1874	22562000	23113	11544	3	0	2
3747	606	71086633286230	23113	11544	4	0	18
176723	1397	1301256260000	23115	11545	2	0	13757
343952	1874	22569000	23115	11545	5	0	2
176729	2134	86380433000	23115	11545	8	0	4197
343958	2113	543308726895	23116	11546	1	0	1
176734	2134	86378427000	23116	11546	3	0	4199
343970	1874	22585000	23120	11547	2	0	2
176747	2134	86376421000	23120	11547	5	0	4201
56315	1749	13685441930000	23120	11547	6	0	19
343976	1874	22597000	23121	11548	2	0	2
20423	1555	7445893540449	23121	11548	3	0	8
176753	2134	86374415000	23122	11549	2	0	4203
27237	1633	5088549125277	23122	11549	4	0	12
343985	1874	22603000	23124	11550	2	0	2
176761	2133	93615668000	23124	11550	4	0	4167
343991	1678	25200791848000	23126	11551	0	0	0
176768	1397	1301166251000	23127	11552	0	0	13766
343997	1346	1711775637751650	23127	11552	3	0	0
24661	1602	5616250170000	23127	11552	6	0	9
176911	1397	1301156250000	23132	11553	0	0	13767
344137	1678	25200791850000	23132	11553	0	0	0
176912	1397	1301146249000	23132	11553	1	0	13768
344138	1678	25200791851000	23132	11553	1	0	0
177027	1397	1301136248000	23138	11554	0	0	13769
344253	1678	25200791852000	23138	11554	0	0	0
177028	1397	1301126247000	23138	11554	1	0	13770
344254	1678	25200791853000	23138	11554	1	0	0
177034	2134	86367394000	23138	11554	7	0	4210
344260	1874	22641000	23138	11554	7	0	2
60630	2261	5039111000000	23138	11554	10	0	0
177040	2133	93606650000	23139	11555	4	0	4176
344266	1874	22649000	23139	11555	4	0	2
53448	1719	5760205000000	23139	11555	7	0	10
177066	2133	93605648000	23143	11556	2	0	4177
344292	1874	22660000	23143	11556	2	0	2
9240	1395	58209030262957278	23144	11557	4	0	0
177072	2133	93603644000	23145	11558	1	0	4179
344298	1874	22668000	23145	11558	1	0	2
177073	2134	86361376000	23145	11558	2	0	4216
177074	1397	1301066241000	23146	11559	0	0	13776
344304	1678	25200791861000	23147	11560	1	0	0
177080	2132	147787789000	23147	11560	3	0	1211
344309	1874	22684000	23147	11560	6	0	2
177086	2134	86357364000	23147	11560	9	0	4220
344318	1874	22697000	23149	11561	2	0	2
177225	1397	1301016236000	23153	11562	0	0	13781
344451	1678	25200791864000	23153	11562	0	0	0
177226	2133	93597632000	23153	11562	1	0	4185
344452	1874	22699000	23153	11562	1	0	2
344512	1678	25200791865000	23159	11564	0	0	0
344513	1678	25200791866000	23159	11564	1	0	0
177289	2134	86354355000	23159	11564	3	0	4223
344521	1678	25200791868000	23161	11565	0	0	0
177297	1397	1300966231000	23162	11566	0	0	13786
344527	1874	22723000	23162	11566	4	0	2
177311	1397	1300946229000	23165	11567	0	0	13788
344541	1678	25200791873000	23166	11568	0	0	0
177327	1397	1300916226000	23171	11569	0	0	13791
344560	1874	22739000	23173	11570	1	0	2
177460	1397	1300896224000	23175	11571	0	0	13793
344686	1678	25200791876000	23175	11571	0	0	0
177461	1397	1300886223000	23175	11571	1	0	13794
344687	1678	25200791877000	23175	11571	1	0	0
9247	1395	58211190324957278	23177	11572	4	0	0
9249	1395	58211190337957278	23177	11572	5	0	0
177472	1397	1300866221000	23178	11573	0	0	13796
344698	1678	25200791879000	23178	11573	0	0	0
177599	1397	1300856220000	23180	11574	0	0	13797
344825	1678	25200791880000	23180	11574	0	0	0
177600	1397	1300846219000	23180	11574	1	0	13798
344826	1678	25200791881000	23180	11574	1	0	0
39156	1684	12243037819748	23180	11574	4	0	136
60730	2275	200000008	23180	11574	9	0	0
177767	1397	1300806215000	23185	11575	0	0	13802
344993	1678	25200791885000	23185	11575	0	0	0
177768	2134	86339310000	23185	11575	1	0	4238
344994	1874	22757000	23185	11575	1	0	2
35288	1679	21599154654000	23185	11575	7	0	75
177774	1397	1300796214000	23186	11576	0	0	13803
345000	1678	25200791886000	23186	11576	0	0	0
177782	2134	86331286000	23188	11577	1	0	4246
345008	1874	22782000	23188	11577	1	0	2
177800	2134	86329280000	23195	11579	2	0	4248
345026	1874	22789000	23195	11579	2	0	2
52614	1716	720000000000	23195	11579	3	0	9
345033	1678	25200791892000	23199	11581	0	0	0
345034	1874	22795000	23199	11581	1	0	2
177810	2134	86326271000	23200	11582	1	0	4251
345044	1678	25200791895000	23203	11584	0	0	0
177820	2134	86324265000	23203	11584	2	0	4253
44475	1690	157685387000000	23203	11584	5	0	0
46271	1693	3556707292484	23208	11585	3	0	1117
345066	1678	25200791898000	23212	11586	0	0	0
177841	2134	86321256000	23212	11586	1	0	4256
9251	1395	58211910337957278	23212	11586	2	0	0
177972	1397	1300666201000	23216	11587	0	0	13816
345198	1678	25200791899000	23216	11587	0	0	0
177973	394	66001818809135	23216	11587	1	0	2
345199	2308	44000000000	23216	11587	1	0	0
44478	1690	158405387000000	23216	11587	3	0	0
57482	1764	23767391100000	23218	11588	3	0	8
177986	2308	43990000000	23221	11590	0	0	1
345212	1483	10000000	23221	11590	0	0	0
178056	394	66001718809135	23225	11591	0	0	3
178057	1397	1300626197000	23225	11591	1	0	13820
345285	1874	22829000	23225	11591	3	0	2
178198	1397	1300606195000	23231	11592	0	0	13822
345424	1678	25200791905000	23231	11592	0	0	0
178199	2134	86314235000	23231	11592	1	0	4263
345425	1874	22835000	23231	11592	1	0	2
6906	1394	639370234500000	23234	11594	1	0	0
178209	1397	1300576192000	23237	11596	0	0	13825
345435	1678	25200791908000	23237	11596	0	0	0
1192	149	73295289000341	23237	11596	2	0	10
345445	1678	25200791910000	23242	11598	0	0	0
345446	1874	22853000	23242	11598	1	0	2
178221	1397	1300546189000	23243	11599	0	0	13828
178236	2134	86305208000	23246	11600	3	0	4272
345462	1874	22862000	23246	11600	3	0	2
13505	1447	11801699683000	23249	11601	3	0	10
178263	2134	86302199000	23256	11603	1	0	4275
345489	1874	22871000	23256	11603	1	0	2
29048	1637	280086709819988	23256	11603	2	0	0
345498	1678	25200791919000	23261	11606	0	0	0
178273	2134	86299190000	23261	11606	1	0	4278
107	42	77949393000000	23261	11606	3	0	8
178278	2134	86297184000	23263	11608	2	0	4280
345504	1874	22886000	23263	11608	2	0	2
6920	1394	643690257500000	23263	11608	3	0	0
59488	2086	720344300069	23265	11609	3	0	3
178301	1397	1300416176000	23273	11611	0	0	13841
178302	1397	1300406175000	23273	11611	1	0	13842
345528	1678	25200791925000	23273	11611	1	0	0
345537	1678	25200791927000	23276	11612	0	0	0
178312	2134	86291166000	23276	11612	1	0	4286
54243	1724	7614677500000	23276	11612	3	0	13
345543	1678	25200791930000	23278	11614	0	0	0
178320	1397	1300346169000	23280	11615	0	0	13848
178327	2134	86286151000	23283	11617	1	0	4291
345553	1874	22919000	23283	11617	1	0	2
16337	1476	6480121000000	23283	11617	3	0	11
178438	1397	1300316166000	23285	11618	0	0	13851
345664	1678	25200791934000	23285	11618	0	0	0
178439	1397	1300306165000	23285	11618	1	0	13852
345665	1678	25200791935000	23285	11618	1	0	0
178451	2134	86282139000	23287	11619	1	0	4295
345677	1874	22931000	23287	11619	1	0	2
178581	1397	1300266161000	23291	11621	0	0	13856
345807	1678	25200791939000	23291	11621	0	0	0
178582	1397	1300256160000	23291	11621	1	0	13857
345808	1678	25200791940000	23291	11621	1	0	0
178596	1397	1300226157000	23295	11623	1	0	13860
345822	1678	25200791943000	23295	11623	1	0	0
178604	1397	1300196154000	23298	11625	1	0	13863
345830	1678	25200791946000	23298	11625	1	0	0
178609	1397	1300176152000	23300	11627	0	0	13865
345835	1678	25200791948000	23300	11627	0	0	0
178740	1397	1300156150000	23304	11629	0	0	13867
345966	1678	25200791950000	23304	11629	0	0	0
178741	2134	86269100000	23304	11629	1	0	4308
345967	1874	22970000	23304	11629	1	0	2
178751	2134	86266091000	23308	11631	3	0	4311
345977	1874	22979000	23308	11631	3	0	2
6928	1394	648010301500000	23310	11632	2	0	0
3311	576	72557499726897	23311	11633	1	0	9
178866	1397	1300096144000	23313	11634	0	0	13873
346092	1678	25200791956000	23313	11634	0	0	0
178867	1397	1300086143000	23313	11634	1	0	13874
346093	1678	25200791957000	23313	11634	1	0	0
178877	2134	86261076000	23316	11635	2	0	4316
346103	1874	22994000	23316	11635	2	0	2
47119	1694	8458844197225	23318	11636	4	0	62
178887	1397	1300036138000	23319	11637	0	0	13879
346113	1678	25920813962000	23319	11637	0	0	0
178894	2134	86255058000	23322	11639	1	0	4322
346120	1874	23012000	23322	11639	1	0	2
346121	1678	25920813965000	23323	11640	0	0	0
346122	1874	23015000	23323	11640	1	0	2
39202	1684	14403071819412	23323	11640	3	0	136
178907	2134	86252049000	23329	11641	3	0	4325
346137	1874	23024000	23331	11642	1	0	2
179010	1397	1299966131000	23334	11643	0	0	13886
179011	2134	86250043000	23334	11643	1	0	4327
346243	1874	23033000	23337	11645	1	0	2
179019	2134	86247034000	23339	11646	1	0	4330
346252	1874	23039000	23341	11647	2	0	2
346258	2305	199000000000	23343	11648	0	0	0
179033	1397	1299906125000	23343	11648	1	0	13892
346259	1678	25920813975000	23343	11648	1	0	0
179040	2134	86242019000	23345	11649	1	0	4335
58745	1991	7821308355805	23345	11649	2	0	21
346268	1874	23054000	23347	11650	0	0	2
179059	2134	86239010000	23352	11652	2	0	4338
346286	1874	23063000	23352	11652	3	0	2
6933	1394	650890345500000	23352	11652	5	0	0
179165	1397	1299846119000	23355	11653	0	0	13898
179166	2134	86237004000	23355	11653	1	0	4340
346393	1678	25920813982000	23356	11654	0	0	0
346394	1678	25920813983000	23356	11654	1	0	0
49240	1701	8638233500103	23356	11654	4	0	14
179172	2134	86233995000	23357	11655	1	0	4343
35316	1679	23039313654000	23358	11656	1	0	75
346404	1678	25920813986000	23361	11657	0	0	0
42093	1688	42479568720020	23361	11657	4	0	57
179182	2134	86230986000	23362	11658	1	0	4346
346410	1874	23087000	23363	11659	1	0	2
179189	2134	86228980000	23365	11660	2	0	4348
346418	1678	25920813991000	23367	11661	0	0	0
179196	1397	1299726107000	23368	11662	0	0	13910
346424	1874	23102000	23368	11662	2	0	2
6937	1394	653770367500000	23372	11663	2	0	0
6938	1394	653770378500000	23372	11663	3	0	0
179214	1397	1299696104000	23376	11664	0	0	13913
346447	1678	25920813997000	23378	11665	0	0	0
179224	2134	86219953000	23378	11665	3	0	4357
346454	1874	23120000	23380	11666	1	0	2
179246	1397	1299636098000	23384	11668	1	0	13919
346474	1874	23129000	23384	11668	3	0	2
179249	1397	1299626097000	23385	11669	0	0	13920
179250	2134	86214938000	23385	11669	1	0	4362
23531	1594	10801709000000	23385	11669	3	0	10
346487	1678	25920814007000	23390	11670	3	0	0
179263	2134	86213935000	23390	11670	5	0	4363
346492	1874	23144000	23390	11670	8	0	2
9265	1395	58214070370957278	23390	11670	10	0	0
179279	1397	1299556090000	23392	11671	1	0	13927
4548	633	75789448900000	23392	11671	4	0	9
179393	1397	1299546089000	23398	11672	0	0	13928
346619	1678	25920814011000	23398	11672	0	0	0
179394	2134	86206914000	23398	11672	1	0	4370
346620	1874	23156000	23398	11672	1	0	2
52485	1715	18746874436096	23401	11674	2	0	9
179402	2134	86203905000	23402	11675	1	0	4373
346628	1874	23165000	23402	11675	1	0	2
40965	1687	2288819848312	23402	11675	2	0	7
179408	1397	1299466081000	23404	11677	3	0	13936
346634	1678	25920814019000	23404	11677	3	0	0
36299	1681	10691273909853	23404	11677	8	0	11
179429	1397	1299456080000	23407	11678	0	0	13937
346655	1678	25920814020000	23407	11678	0	0	0
179562	1397	1299426077000	23411	11680	0	0	13940
346788	1678	25920814023000	23411	11680	0	0	0
179563	2134	86194878000	23411	11680	1	0	4382
346789	1874	23192000	23411	11680	1	0	2
179573	2134	86191869000	23414	11682	3	0	4385
346799	1874	23201000	23414	11682	3	0	2
22451	1587	6480202000000	23414	11682	5	0	14
346838	1678	25920814027000	23418	11683	0	0	0
346839	1874	23204000	23418	11683	1	0	2
44486	1690	160565430000000	23419	11684	3	0	0
179617	1397	1299366071000	23420	11685	0	0	13946
46384	1693	4996729292484	23420	11685	3	0	1117
346882	1678	25920814030000	23422	11686	0	0	0
179657	1397	1299346069000	23422	11686	1	0	13948
179658	1397	1299336068000	23422	11686	2	0	13949
45932	1692	61701319619999	23422	11686	7	0	5
346899	1678	25920814033000	23426	11687	0	0	0
179675	1397	1299316066000	23427	11688	0	0	13951
346906	1874	23228000	23429	11689	1	0	2
179697	1397	1299286063000	23439	11691	0	0	13954
60508	2248	9359476000000	23439	11691	2	0	0
346934	1874	23237000	23447	11692	1	0	2
346937	1678	25920814039000	23449	11693	0	0	0
179712	2134	86178830000	23449	11693	1	0	4398
346938	1874	23240000	23449	11693	1	0	2
179824	1397	1299236058000	23455	11696	0	0	13959
179825	2133	93596630000	23455	11696	1	0	4186
347051	1874	23248000	23455	11696	1	0	2
18948	1536	7200133000000	23455	11696	3	0	11
35959	1680	8653284499559	23456	11697	3	0	12
179954	1397	1299216056000	23463	11698	0	0	13961
347180	1678	25920814044000	23463	11698	0	0	0
179955	1397	1299206055000	23463	11698	1	0	13962
347181	1678	25920814045000	23463	11698	1	0	0
179961	2134	86171809000	23463	11698	7	0	4405
347187	1874	23269000	23463	11698	7	0	2
179967	2133	93591620000	23464	11699	4	0	4191
347193	1874	23279000	23464	11699	4	0	2
9271	1395	58216230458957278	23464	11699	6	0	0
179972	2134	86168800000	23465	11700	3	0	4408
347198	1874	23287000	23465	11700	3	0	2
21950	1571	8352193151808	23465	11700	4	0	41
347209	1678	25920814051000	23469	11702	0	0	0
347210	1874	23295000	23469	11702	1	0	2
179985	2133	93587612000	23469	11702	2	0	4195
347224	1678	25920814053000	23473	11704	0	0	0
179999	2133	93585608000	23473	11704	1	0	4197
180014	1397	1299106045000	23480	11707	0	0	13972
347240	1678	25920814055000	23480	11707	0	0	0
347245	1874	23320000	23480	11707	5	0	2
180020	2133	93583604000	23480	11707	6	0	4199
1980	369	74436427290830	23480	11707	10	0	16
347251	1874	23331000	23481	11708	1	0	2
180026	2134	86159773000	23481	11708	2	0	4417
180034	1397	1299046039000	23484	11710	1	0	13978
347260	1678	25920814061000	23484	11710	1	0	0
6955	1394	658090426500000	23484	11710	7	0	0
347271	1678	25920814062000	23487	11711	0	0	0
180046	2133	93576590000	23487	11711	1	0	4206
347283	1874	23358000	23492	11712	2	0	2
20447	1555	8885929540449	23492	11712	4	0	8
180058	1397	1299016036000	23493	11713	0	0	13981
180063	2133	93573584000	23493	11713	5	0	4209
347289	1874	23368000	23493	11713	5	0	2
180082	1397	1298996034000	23498	11714	0	0	13983
180083	2133	93572582000	23498	11714	1	0	4210
15030	1458	13625183908540	23498	11714	4	0	8
347329	1678	25920814067000	23501	11715	0	0	0
180113	1397	1298976032000	23503	11716	0	0	13985
347342	1874	23383000	23503	11716	3	0	2
180119	2134	86149743000	23503	11716	6	0	4427
347345	1874	23390000	23503	11716	6	0	2
347346	1678	25920814070000	23504	11717	0	0	0
180133	2133	93567572000	23508	11718	1	0	4215
3140	526	72480245000000	23508	11718	4	0	2
347368	1678	25920814072000	23511	11719	0	0	0
180150	2134	86145731000	23513	11720	0	0	4431
347386	1874	23411000	23516	11721	1	0	2
59925	2106	5759107000000	23516	11721	2	0	0
180177	2134	86144728000	23520	11723	2	0	4432
347404	1874	23419000	23520	11723	3	0	2
180182	2134	86142722000	23520	11723	7	0	4434
347410	1678	25920814077000	23521	11724	1	0	0
180188	2134	86139713000	23521	11724	5	0	4437
347416	1874	23440000	23521	11724	7	0	2
180264	1397	1298866021000	23524	11725	0	0	13996
347490	1678	25920814079000	23524	11725	0	0	0
180265	2133	93558554000	23524	11725	1	0	4224
347491	1874	23445000	23524	11725	1	0	2
53493	1719	7920276000000	23525	11726	3	0	10
42151	1688	44639591720020	23526	11727	0	0	57
180271	1397	1298836018000	23528	11728	1	0	13999
347497	1678	25920814082000	23528	11728	1	0	0
180277	1448	204796000001	23528	11728	7	0	13
347503	489	66458391250309	23528	11728	7	0	0
180282	2134	86135701000	23528	11728	12	0	4441
347508	1874	23465000	23528	11728	12	0	2
60728	2266	200000020	23528	11728	16	0	0
56333	1749	15125563529980	23528	11728	16	1	19
32750	1675	8204220999977	23530	11729	4	0	8
180303	1397	1298806015000	23531	11730	0	0	14002
347529	1678	25920814085000	23531	11730	0	0	0
10937	1402	80495186319298	23531	11730	4	0	33
180313	2134	86131689000	23533	11731	2	0	4445
347539	1874	23485000	23533	11731	2	0	2
30409	1656	8635413999990	23533	11731	4	0	8
180328	2132	147764766000	23536	11732	4	0	1234
347554	1874	23486000	23536	11732	4	0	2
180343	1397	1298766011000	23538	11733	0	0	14006
180344	1397	1298756010000	23538	11733	1	0	14007
347570	1678	25920814090000	23538	11733	1	0	0
180350	2134	86128680000	23538	11733	7	0	4448
347576	1874	23506000	23538	11733	7	0	2
42172	1688	45359628720020	23538	11733	11	0	57
347587	1874	23517000	23541	11734	2	0	2
6966	1394	662410467500000	23541	11734	4	0	0
180364	1397	1298726007000	23543	11735	0	0	14010
9280	1395	58217670507957278	23543	11735	4	0	0
180369	2133	93543524000	23544	11736	2	0	4239
347595	1874	23527000	23544	11736	2	0	2
21067	1560	9368695131803	23545	11737	5	0	30
180378	2133	93541520000	23547	11738	1	0	4241
347604	1874	23535000	23547	11738	1	0	2
261	43	70320042890000	23547	11738	4	0	3
347623	1678	25920814097000	23552	11739	0	0	0
347624	1678	25920814098000	23552	11739	1	0	0
180401	2133	93539516000	23552	11739	4	0	4243
347636	1678	25920814099000	23554	11740	0	0	0
180412	2134	86118650000	23554	11740	2	0	4458
347660	1678	25920814101000	23558	11741	0	0	0
180436	2132	147760762000	23558	11741	2	0	1238
347665	1874	23570000	23558	11741	5	0	2
6972	1394	666730504500000	23558	11741	6	0	0
180448	2134	86114638000	23560	11742	2	0	4462
347677	1874	23580000	23560	11742	5	0	2
29065	1637	282246753819988	23560	11742	6	0	0
180453	2132	147759761000	23561	11743	1	0	1239
40808	1686	11192023700122	23561	11743	5	0	17
347695	1678	25920814105000	23565	11744	1	0	0
180471	2134	86111629000	23565	11744	3	0	4465
180478	1397	1298595994000	23568	11745	0	0	14023
180479	1397	1298585993000	23568	11745	1	0	14024
347706	1874	23593000	23568	11745	2	0	2
180485	2106	88000000	23569	11746	1	0	2
347712	1874	23601000	23569	11746	2	0	2
180509	1397	1298555990000	23576	11748	0	0	14027
347736	1874	23612000	23576	11748	1	0	2
180517	2133	93525488000	23578	11749	1	0	4257
347744	1874	23620000	23578	11749	2	0	2
51201	1709	3600090000000	23579	11750	5	0	8
180527	1397	1298525987000	23581	11751	0	0	14030
347753	1678	25920814113000	23581	11751	0	0	0
347754	1874	23627000	23581	11751	1	0	2
180537	2134	86103605000	23583	11752	3	0	4473
347772	1678	25920814115000	23586	11753	0	0	0
180553	2133	93520478000	23588	11754	1	0	4262
25495	1610	7200140999950	23588	11754	3	0	11
347785	1678	25920814117000	23590	11755	0	0	0
180569	1397	1298475982000	23592	11756	0	0	14035
347796	1678	25920814119000	23592	11756	1	0	0
58974	1992	7920607990000	23592	11756	7	0	5
180600	1397	1298455980000	23596	11757	0	0	14037
347827	1678	25920814121000	23596	11757	1	0	0
180605	2133	93516470000	23596	11757	5	0	4266
180641	1397	1298435978000	23599	11758	0	0	14039
347867	1678	25920814122000	23599	11758	0	0	0
180642	2134	86095581000	23599	11758	1	0	4481
347872	1209	611982415663305	23600	11759	3	0	0
180648	1571	4940555124154	23600	11759	5	0	47
347878	1874	23682000	23600	11759	10	0	2
180654	2133	93513464000	23600	11759	11	0	4269
347895	1678	25920814125000	23602	11760	0	0	0
347896	1874	23692000	23602	11760	1	0	2
180673	2133	93511460000	23602	11760	2	0	4271
51030	1708	13748183115923	23606	11761	4	0	7
347925	1874	23702000	23611	11762	1	0	2
180703	2132	147752754000	23611	11762	2	0	1246
13784	1448	6439776000001	23611	11762	3	0	16
347931	1874	23707000	23612	11763	4	0	2
180709	2133	93507452000	23612	11763	5	0	4275
347936	1874	23719000	23612	11763	9	0	2
180736	1397	1298345969000	23617	11765	0	0	14048
347964	1874	23729000	23617	11765	5	0	2
180745	1397	1298325967000	23619	11766	0	0	14050
180746	2134	86084548000	23619	11766	1	0	4492
347973	1874	23738000	23620	11767	2	0	2
53511	1719	9360338000000	23620	11767	5	0	10
180756	1397	1298305965000	23622	11768	0	0	14052
347982	1874	23741000	23622	11768	4	0	2
180762	2133	93501440000	23622	11768	6	0	4281
19414	1546	6717363800000	23622	11768	9	0	10
348008	1874	23750000	23625	11769	2	0	2
180789	2134	86081539000	23625	11769	3	0	4495
348014	1874	23766000	23625	11769	8	0	2
180920	1397	1298255960000	23627	11770	0	0	14057
348138	1678	25920814140000	23627	11770	0	0	0
180921	1397	1298245959000	23627	11770	1	0	14058
348139	1678	25920814141000	23627	11770	1	0	0
180927	1397	1298235958000	23628	11771	0	0	14059
348145	1678	25920814142000	23628	11771	0	0	0
180936	2133	93494426000	23630	11772	3	0	4288
348154	1874	23787000	23630	11772	3	0	2
348163	1678	25920814145000	23633	11773	0	0	0
180946	2134	86072512000	23633	11773	1	0	4504
348164	1874	23796000	23633	11773	1	0	2
180955	1397	1298175952000	23636	11775	1	0	14065
348173	1678	25920814148000	23636	11775	1	0	0
180986	1397	1298165951000	23640	11776	0	0	14066
348204	1678	25920814149000	23640	11776	0	0	0
180991	2133	93487412000	23640	11776	5	0	4295
348209	1874	23824000	23640	11776	5	0	2
181000	2134	86065491000	23642	11777	2	0	4511
348218	1874	23835000	23642	11777	2	0	2
181006	2134	86064488000	23643	11778	5	0	4512
348224	1874	23843000	23643	11778	5	0	2
181017	2134	86062482000	23645	11779	2	0	4514
18962	1536	8640169000000	23645	11779	4	0	11
181021	1397	1298105945000	23647	11780	0	0	14072
348239	1678	25920814155000	23647	11780	0	0	0
181027	2134	86060476000	23648	11781	3	0	4516
348245	1874	23862000	23648	11781	3	0	2
181037	2134	86059473000	23650	11782	6	0	4517
348255	1874	23865000	23650	11782	6	0	2
42223	1688	47519653720020	23653	11783	3	0	57
181069	1397	1298065941000	23658	11784	0	0	14076
348286	1678	25920814159000	23658	11784	0	0	0
181075	2133	93477392000	23658	11784	6	0	4305
348292	1874	23881000	23658	11784	6	0	2
348309	1678	25920814162000	23661	11785	0	0	0
348310	1874	23890000	23661	11785	1	0	2
181094	2134	86054458000	23661	11785	2	0	4522
55114	1739	30239828000000	23665	11786	3	0	0
181112	2133	93473384000	23667	11787	1	0	4309
348329	1874	23899000	23667	11787	1	0	2
21090	1560	10088706131803	23667	11787	3	0	30
181128	1397	1297985933000	23671	11789	1	0	14084
348345	1678	25920814167000	23671	11789	1	0	0
348350	1874	23917000	23671	11789	6	0	2
2522	470	74640273000000	23671	11789	7	0	11
181153	1397	1297975932000	23675	11790	0	0	14085
181154	2134	86049443000	23675	11790	1	0	4527
30070	1654	10937365999798	23675	11790	3	0	11
348380	1874	23926000	23678	11791	2	0	2
181173	1397	1297955930000	23682	11792	0	0	14087
348394	1874	23931000	23682	11792	4	0	2
181179	2133	93466370000	23682	11792	6	0	4316
348399	1678	25920814173000	23684	11793	1	0	0
181184	2133	93464366000	23684	11793	3	0	4318
348405	1874	23948000	23684	11793	7	0	2
181190	1397	1297915926000	23685	11794	0	0	14091
44497	1690	162725476000000	23685	11794	3	0	0
348411	1874	23956000	23686	11795	1	0	2
52970	1717	7021070000055	23686	11795	3	0	8
181196	1397	1297895924000	23687	11796	0	0	14093
348416	1874	23965000	23687	11796	3	0	2
181201	2133	93459356000	23687	11796	5	0	4323
6991	1394	671050571500000	23687	11796	7	0	0
348422	1874	23975000	23688	11797	2	0	2
181207	2134	86038410000	23689	11798	1	0	4538
348428	1874	23984000	23690	11799	1	0	2
181213	1397	1297845919000	23691	11800	0	0	14098
348443	1678	25920814182000	23694	11801	0	0	0
348444	1678	25920814183000	23694	11801	1	0	0
181228	2132	147735737000	23694	11801	2	0	1263
34856	1678	25920836183000	23694	11801	4	0	0
348482	1678	26640839184000	23699	11802	0	0	0
181266	1397	1297805915000	23699	11802	1	0	14102
348488	1874	24012000	23699	11802	6	0	2
181272	1746	3990488000000	23699	11802	7	0	6
348493	1874	24017000	23701	11803	3	0	2
181277	2134	86029383000	23701	11803	4	0	4547
348499	2309	2742644000000	23701	11803	9	0	0
181283	1397	1297765911000	23702	11804	0	0	14106
9299	1395	58219830556957278	23702	11804	5	0	0
181292	1397	1297755910000	23705	11805	0	0	14107
181293	2134	86027377000	23705	11805	1	0	4549
348510	1874	24037000	23705	11805	1	0	2
2817	484	72573900000000	23705	11805	4	0	8
27034	1623	67683124899898	23706	11806	4	0	1
348515	1678	26640839192000	23707	11807	0	0	0
181299	2133	93444326000	23707	11807	1	0	4338
348521	1874	24055000	23708	11808	3	0	2
181312	1397	1297715906000	23711	11809	0	0	14111
181317	2134	86022362000	23711	11809	5	0	4554
348534	1874	24065000	23711	11809	5	0	2
348539	1678	26640839197000	23713	11811	0	0	0
181323	2134	86020356000	23713	11811	1	0	4556
60063	2112	16366691101924	23713	11811	3	0	7
348561	1874	24079000	23718	11812	4	0	2
181345	2133	93437312000	23718	11812	5	0	4345
181350	2134	86017347000	23719	11813	2	0	4559
348567	1874	24092000	23719	11813	2	0	2
12502	1439	8623665578477	23719	11813	3	0	10
348583	1678	26640839201000	23724	11814	0	0	0
348584	1678	26640839202000	23724	11814	1	0	0
181371	2134	86015341000	23724	11814	5	0	4561
31356	1670	5040940000000	23724	11814	7	0	11
348590	1678	26640839204000	23725	11815	1	0	0
181377	2309	2742643000000	23725	11815	5	0	1
348596	1874	24113000	23725	11815	7	0	2
181382	2134	86012332000	23726	11816	2	0	4564
348601	1874	24120000	23726	11816	4	0	2
21857	1571	6380579124154	23726	11816	7	0	47
181388	2134	86010326000	23727	11817	1	0	4566
348607	1678	26640839208000	23728	11818	0	0	0
181394	2133	93427292000	23728	11818	4	0	4355
348613	1874	24140000	23728	11818	6	0	2
181399	2134	86007317000	23729	11819	2	0	4569
348618	1678	26640839212000	23730	11820	1	0	0
181405	2134	86005311000	23730	11820	5	0	4571
348624	1874	24157000	23730	11820	7	0	2
181411	1397	1297505885000	23731	11821	1	0	14132
348630	1874	24166000	23731	11821	3	0	2
16908	1489	23664602000000	23731	11821	6	0	4
181416	2058	535500000	23732	11822	0	0	9
348635	1874	24174000	23732	11822	3	0	2
22985	1588	29015648000000	23732	11822	5	0	6
181556	1397	1297485883000	23736	11823	0	0	14134
348769	1678	26640839217000	23736	11823	0	0	0
181557	2133	93419276000	23736	11823	1	0	4363
348770	1874	24179000	23736	11823	1	0	2
45945	1692	63861380619999	23736	11823	3	0	5
181561	2134	85998290000	23737	11824	2	0	4578
181562	2132	147724726000	23737	11824	3	0	1274
348776	1874	24191000	23737	11824	4	0	2
181588	2134	85997287000	23744	11826	1	0	4579
348802	1874	24200000	23744	11826	2	0	2
181594	1397	1297405875000	23746	11827	4	0	14142
348807	1678	26640839225000	23746	11827	4	0	0
181599	2132	147723725000	23746	11827	9	0	1275
348813	1874	24208000	23746	11827	10	0	2
181605	2132	147722724000	23746	11827	15	0	1276
348819	1874	24223000	23746	11827	16	0	2
181611	2134	85991269000	23746	11827	21	0	4585
348824	1874	24234000	23746	11827	21	0	2
181616	2134	85989263000	23747	11828	3	0	4587
348830	1874	24244000	23747	11828	4	0	2
56968	1762	4965363994000	23747	11828	8	0	8
348891	1678	26640839230000	23751	11829	0	0	0
348892	1874	24250000	23751	11829	1	0	2
181681	2134	85987257000	23751	11829	2	0	4589
48266	1698	9428847550062	23756	11830	3	0	12
181821	1397	1297335868000	23758	11831	0	0	14149
349032	1678	26640839232000	23758	11831	0	0	0
181822	2133	93403244000	23758	11831	1	0	4379
349033	1874	24260000	23758	11831	1	0	2
181956	1397	1297325867000	23761	11832	0	0	14150
349167	1678	26640839233000	23761	11832	0	0	0
181957	1397	1297315866000	23761	11832	1	0	14151
349168	1678	26640839234000	23761	11832	1	0	0
182094	2133	93400238000	23764	11833	0	0	4382
349304	1874	24276000	23764	11833	0	0	2
182095	2134	85982242000	23764	11833	1	0	4594
349305	1874	24279000	23764	11833	1	0	2
182106	1397	1297305865000	23766	11834	0	0	14152
182107	1397	1297295864000	23766	11834	1	0	14153
349318	1678	26640839237000	23766	11834	2	0	0
52991	1717	8461126000055	23766	11834	6	0	8
182113	2134	85979233000	23767	11835	3	0	4597
349324	1874	24296000	23767	11835	4	0	2
182122	2134	85977227000	23771	11837	2	0	4599
349332	1874	24304000	23771	11837	2	0	2
46595	1693	7876803092484	23771	11837	5	0	1117
182131	2133	93393224000	23773	11838	3	0	4389
349342	1874	24313000	23773	11838	4	0	2
182137	2133	93392222000	23774	11839	2	0	4390
349357	1678	26640839244000	23778	11840	0	0	0
7007	1394	675370634500000	23778	11840	3	0	0
182152	2133	93390218000	23780	11841	2	0	4392
349362	1874	24330000	23780	11841	2	0	2
182165	2134	85971209000	23783	11842	3	0	4605
349376	1874	24340000	23783	11842	4	0	2
349396	1678	26640839248000	23789	11844	0	0	0
182187	1397	1297165851000	23789	11844	1	0	14166
349397	1678	26640839249000	23789	11844	1	0	0
182226	1397	1297155850000	23800	11846	0	0	14167
349436	1678	26640839250000	23800	11846	0	0	0
21454	1564	6126575000000	23800	11846	4	0	10
182231	1397	1297125847000	23801	11847	1	0	14170
349442	1874	24366000	23801	11847	2	0	2
182244	1397	1297115846000	23803	11848	0	0	14171
349454	1678	26640839254000	23803	11848	0	0	0
182245	2134	85963185000	23803	11848	1	0	4613
349463	1874	24386000	23805	11849	3	0	2
39249	1684	16563095819412	23805	11849	4	0	136
182254	1397	1297095844000	23806	11850	0	0	14173
349469	1874	24396000	23806	11850	5	0	2
182260	1419	17567031560130	23807	11851	0	0	7
349474	1874	24402000	23807	11851	4	0	2
24713	1602	7776566170000	23807	11851	6	0	9
182276	1397	1297065841000	23811	11852	0	0	14176
29074	1637	283686813819988	23811	11852	4	0	0
349494	1874	24412000	23813	11853	2	0	2
182288	1397	1297045839000	23815	11854	0	0	14178
42292	1688	48959690720020	23815	11854	4	0	57
349503	1874	24422000	23816	11855	2	0	2
182294	2132	147711713000	23816	11855	3	0	1287
16364	1476	7920190000000	23817	11856	2	0	11
349508	1874	24427000	23817	11856	4	0	2
182299	2134	85954158000	23817	11856	5	0	4622
349524	1678	26640839265000	23820	11857	0	0	0
349525	1678	26640839266000	23820	11857	1	0	0
182318	2133	93369176000	23820	11857	4	0	4413
349531	1678	26640839267000	23821	11858	0	0	0
13550	1447	13961731683000	23821	11858	3	0	10
182332	1397	1296965831000	23824	11859	1	0	14186
349545	1874	24451000	23824	11859	4	0	2
182337	2134	85949143000	23824	11859	6	0	4627
349558	1874	24463000	23826	11860	1	0	2
182351	2134	85946134000	23827	11861	1	0	4630
349586	1678	26640839273000	23832	11862	1	0	0
182377	2133	93363164000	23832	11862	2	0	4419
182378	2133	93362162000	23832	11862	3	0	4420
349609	1678	26640839274000	23836	11863	0	0	0
182401	2133	93360158000	23836	11863	2	0	4422
349614	1874	24492000	23836	11863	5	0	2
182409	2133	93359156000	23838	11864	2	0	4423
349625	1874	24502000	23840	11865	2	0	2
182417	1397	1296875822000	23841	11866	1	0	14195
349631	1874	24510000	23841	11866	5	0	2
182423	1397	1296865821000	23842	11867	0	0	14196
44505	1690	164165524000000	23842	11867	4	0	0
349636	1678	26640839280000	23843	11868	0	0	0
182429	2134	85935101000	23843	11868	3	0	4641
349642	1874	24529000	23843	11868	6	0	2
51847	1711	11226901000000	23843	11868	7	0	13
182440	2134	85934098000	23846	11869	1	0	4642
182567	1397	1296825817000	23848	11870	0	0	14200
349776	1678	26640839283000	23848	11870	0	0	0
182568	1397	1296815816000	23848	11870	1	0	14201
349777	1678	26640839284000	23848	11870	1	0	0
182574	2134	85933095000	23848	11870	7	0	4643
349783	1874	24544000	23848	11870	7	0	2
18998	1536	10800220000000	23849	11871	4	0	11
182580	1397	1296785813000	23850	11872	0	0	14204
349789	1678	26640839287000	23850	11872	0	0	0
349793	1678	26640839288000	23851	11873	0	0	0
182585	2133	93346130000	23851	11873	1	0	4436
349794	1874	24563000	23851	11873	1	0	2
9307	1395	58221990594957278	23851	11873	4	0	0
182715	1397	1296765811000	23854	11874	0	0	14206
182716	2133	93345128000	23854	11874	1	0	4437
10971	1402	82655235319298	23854	11874	3	0	33
2366	446	66719999900001	23858	11876	0	0	0
349947	1678	26640839290000	23862	11877	0	0	0
349948	1678	26640839291000	23862	11877	1	0	0
182743	2134	85926074000	23862	11877	4	0	4650
349954	1874	24581000	23862	11877	7	0	2
182759	1397	1296725807000	23864	11878	0	0	14210
349970	1874	24591000	23864	11878	3	0	2
182764	2133	93341120000	23864	11878	5	0	4441
349975	1874	24600000	23865	11879	1	0	2
55835	1747	785943000000	23865	11879	4	0	6
182776	1397	1296685803000	23868	11880	1	0	14214
349987	1874	24609000	23868	11880	4	0	2
182782	2133	93336110000	23869	11881	1	0	4446
182790	1397	1296665801000	23872	11882	0	0	14216
182791	1397	1296655800000	23872	11882	1	0	14217
349999	1678	26640839300000	23872	11882	1	0	0
19770	1547	7914755000000	23872	11882	7	0	12
350010	1678	26640839301000	23875	11883	0	0	0
182803	1397	1296635798000	23875	11883	1	0	14219
350016	1874	24633000	23875	11883	6	0	2
182809	2134	85916044000	23875	11883	7	0	4660
182963	1397	1296615796000	23880	11885	0	0	14221
350170	1678	26640839304000	23880	11885	0	0	0
182964	1397	1296605795000	23880	11885	1	0	14222
350171	1678	26640839305000	23880	11885	1	0	0
182970	2133	93329096000	23880	11885	7	0	4453
350177	1874	24648000	23880	11885	7	0	2
182976	2133	93327092000	23880	11885	13	0	4455
350183	1874	24664000	23880	11885	13	0	2
182981	2133	93325088000	23881	11886	4	0	4457
350188	1874	24668000	23881	11886	4	0	2
182987	1397	1296535788000	23882	11887	1	0	14229
350194	1678	26640839312000	23882	11887	1	0	0
182996	1397	1296525787000	23884	11888	0	0	14230
350203	1678	26640839313000	23884	11888	0	0	0
350204	1874	24693000	23884	11888	1	0	2
183001	2133	93320078000	23885	11889	2	0	4462
350210	1874	24702000	23885	11889	4	0	2
27271	1633	7248623125277	23885	11889	8	0	12
183007	2133	93318074000	23886	11890	1	0	4464
350216	1678	26640839317000	23887	11891	0	0	0
183013	2133	92216072000	23887	11891	4	0	4466
350221	1874	24717000	23887	11891	5	0	2
183024	2134	85897990000	23890	11892	2	0	4678
24532	1601	12133841620000	23890	11892	5	0	17
350239	1678	26640839320000	23893	11893	0	0	0
183040	2133	92212064000	23896	11894	1	0	4470
350249	1874	24738000	23896	11894	3	0	2
60636	2261	7199133000000	23896	11894	4	0	0
183053	1397	1296425777000	23901	11896	0	0	14240
350261	1874	24746000	23901	11896	1	0	2
183071	2132	147692694000	23907	11897	0	0	1306
53910	1723	7201681085979	23907	11897	2	0	12
183072	1397	1296415776000	23908	11898	0	0	14241
350282	1874	24756000	23908	11898	3	0	2
47158	1694	10618903197225	23908	11898	4	0	62
183088	2133	92207054000	23912	11899	2	0	4475
350298	1874	24764000	23912	11899	5	0	2
59811	2106	720088000000	23912	11899	7	0	2
183101	2133	92205050000	23914	11900	1	0	4477
350310	1678	26640839328000	23915	11901	0	0	0
183106	1397	1296345769000	23915	11901	3	0	14248
350316	1874	24779000	23915	11901	6	0	2
183112	2133	92204048000	23915	11901	9	0	4478
53545	1719	11520435000000	23915	11901	13	0	10
183223	1397	1296335768000	23918	11902	0	0	14249
350430	1678	26640839332000	23918	11902	0	0	0
183224	1397	1296325767000	23918	11902	1	0	14250
350431	1678	26640839333000	23918	11902	1	0	0
183230	2134	85883948000	23918	11902	7	0	4692
350437	1874	24803000	23918	11902	7	0	2
1999	369	75876515290830	23918	11902	12	0	16
183236	2134	85881942000	23919	11903	2	0	4694
350443	1874	24812000	23919	11903	2	0	2
32778	1675	10364247999977	23920	11904	4	0	8
183244	1397	1296285763000	23922	11905	0	0	14254
350451	1678	26640839337000	23922	11905	0	0	0
183259	1397	1296265761000	23927	11907	0	0	14256
350466	1678	26640839339000	23927	11907	0	0	0
183265	2133	92193026000	23928	11908	3	0	4489
350472	1874	24839000	23928	11908	3	0	2
350477	1678	26640839341000	23930	11909	0	0	0
350478	1678	26640839342000	23930	11909	1	0	0
183274	2132	147686688000	23930	11909	4	0	1312
350484	1874	24849000	23930	11909	7	0	2
31753	1671	7583919003785	23930	11909	10	0	8
183280	1397	1296215756000	23931	11910	0	0	14261
31014	1668	6273549000000	23931	11910	4	0	9
350493	1678	26640839345000	23933	11911	0	0	0
183293	1397	1296195754000	23935	11912	0	0	14263
350519	1678	26640839347000	23940	11913	0	0	0
183315	2134	85870909000	23940	11913	3	0	4705
9314	1395	58224150645957278	23940	11913	5	0	0
350531	1678	26640839349000	23942	11914	1	0	0
183327	2134	85867900000	23942	11914	4	0	4708
183338	1397	1296155750000	23946	11915	0	0	14267
183339	2134	85866897000	23946	11915	1	0	4709
350546	1874	24889000	23946	11915	1	0	2
350575	1874	24893000	23952	11917	3	0	2
183369	2133	92181002000	23952	11917	4	0	4501
350587	1874	24905000	23954	11918	3	0	2
183381	2134	85863888000	23954	11918	4	0	4712
1791	326	66720015000000	23954	11918	7	0	0
183392	1397	1296095744000	23958	11920	0	0	14273
350599	1678	26640839356000	23958	11920	0	0	0
21125	1560	12248767131803	23958	11920	4	0	30
350606	1874	24926000	23960	11921	2	0	2
183400	1397	1296075742000	23961	11922	0	0	14275
350609	1874	24929000	23961	11922	2	0	2
350610	1874	24932000	23961	11922	3	0	2
183406	1397	1296055740000	23962	11923	0	0	14277
350616	1874	24939000	23962	11923	3	0	2
183411	2133	92172986000	23962	11923	5	0	4509
350622	1874	24951000	23963	11924	2	0	2
23091	1593	10752672000000	23963	11924	4	0	8
183544	1397	1296025737000	23966	11925	0	0	14280
350751	1678	26640839363000	23966	11925	0	0	0
183545	1402	82133653373639	23966	11925	1	0	35
350752	795	56052696220424	23966	11925	1	0	0
52122	1714	8925587171760	23966	11925	5	0	11
183551	1397	1296015736000	23968	11927	1	0	14281
350758	1678	26640839364000	23968	11927	1	0	0
183557	1402	74122001778122	23968	11927	7	0	42
350764	844	156664358883961	23968	11927	7	0	0
183562	2133	92167976000	23968	11927	12	0	4514
350769	1874	24963000	23968	11927	12	0	2
7021	1394	679690671500000	23968	11927	13	0	0
183582	1402	41743347053908	23970	11928	5	0	51
350789	870	260976309470763	23970	11928	5	0	0
56438	1756	6320837195609	23970	11928	11	0	6
183605	1402	30545180810740	23973	11929	0	0	53
183606	1402	29973188312672	23973	11929	1	0	54
350813	880	135574925957243	23973	11929	1	0	0
350818	1874	24974000	23973	11929	6	0	2
183612	2133	92165972000	23973	11929	7	0	4516
42340	1688	51119715720020	23973	11929	8	0	57
33	42	70700617000000	23974	11930	4	0	12
350824	1874	24983000	23975	11931	1	0	2
183618	2134	85847840000	23975	11931	2	0	4728
11758	1422	8154615804270	23975	11931	4	0	12
32053	1672	6481321000000	23977	11932	4	0	10
183626	2133	92161964000	23978	11933	1	0	4520
350833	1874	24993000	23978	11933	1	0	2
15499	1467	19407027100039	23978	11933	3	0	4
25837	1611	8775721000000	23979	11934	4	0	9
350867	1678	26640839372000	23981	11935	0	0	0
183661	2133	92159960000	23981	11935	1	0	4522
4891	641	75363839000000	23984	11936	3	0	16
350877	1678	26640839374000	23985	11937	0	0	0
183671	2134	85841822000	23985	11937	1	0	4734
25222	1608	8778434000000	23985	11937	4	0	8
350883	1678	26640839375000	23987	11938	0	0	0
350884	1874	25018000	23987	11938	1	0	2
12094	1426	8970321000000	23987	11938	2	0	8
183682	2134	85840819000	23989	11939	1	0	4735
350896	1874	25028000	23991	11940	2	0	2
30104	1654	13097403999798	23991	11940	3	0	11
183818	1397	1295875722000	23994	11941	0	0	14295
351025	1678	26640839378000	23994	11941	0	0	0
183819	2134	85838813000	23994	11941	1	0	4737
351026	1874	25031000	23994	11941	1	0	2
183838	1397	1295845719000	23999	11943	1	0	14298
351045	1678	26640839381000	23999	11943	1	0	0
183844	2133	92150942000	23999	11943	7	0	4531
351051	1874	25051000	23999	11943	7	0	2
183861	1397	1295815716000	24005	11945	0	0	14301
351068	1678	26640839384000	24005	11945	0	0	0
183867	2133	92146934000	24006	11946	1	0	4535
351074	1874	25065000	24006	11946	1	0	2
183875	1397	1295785713000	24010	11948	0	0	14304
183876	1397	1295775712000	24010	11948	1	0	14305
351084	1874	25074000	24010	11948	2	0	2
183889	2134	85827780000	24013	11949	1	0	4748
351096	1874	25084000	24013	11949	1	0	2
183895	2134	85825774000	24017	11951	1	0	4750
351102	1874	25094000	24017	11951	1	0	2
183908	1402	25019782421307	24021	11953	0	0	58
351116	1678	26640839393000	24021	11953	1	0	0
17376	1508	11000387156616	24021	11953	5	0	10
183914	2134	85822765000	24022	11954	2	0	4753
351121	1874	25111000	24022	11954	2	0	2
7034	1394	684010828500000	24022	11954	3	0	0
183920	2134	85821762000	24023	11955	5	0	4754
351127	1874	25116000	24023	11955	5	0	2
183931	2134	85820759000	24025	11956	4	0	4755
351139	1874	25121000	24025	11956	5	0	2
183943	1613	18250029400000	24027	11957	4	0	7
351150	1349	1703417022151650	24027	11957	4	0	0
351153	983	508532350000000	24027	11957	7	0	0
351154	1874	25123000	24027	11957	8	0	2
183949	2134	85819756000	24027	11957	10	0	4756
351163	1874	25136000	24029	11958	2	0	2
57681	1768	12706675110000	24029	11958	4	0	10
183966	1397	1295655700000	24033	11959	0	0	14317
351178	1874	25143000	24034	11960	2	0	2
183972	2133	92130902000	24034	11960	3	0	4551
351183	1874	25154000	24035	11961	1	0	2
183985	1397	1295615696000	24039	11962	0	0	14321
10154	1402	19622778145435	24041	11963	3	0	66
351199	1678	26640839406000	24043	11964	0	0	0
183993	2134	85811732000	24043	11964	1	0	4764
351207	1678	26640839407000	24046	11966	0	0	0
184001	2133	92124890000	24046	11966	1	0	4557
351212	1874	25180000	24047	11967	2	0	2
184007	2134	85807720000	24047	11967	4	0	4768
59318	2039	10699409000000	24047	11967	6	0	6
184014	1397	1295555690000	24049	11968	0	0	14327
184015	1397	1295545689000	24049	11968	1	0	14328
351223	1874	25190000	24049	11968	2	0	2
184037	1397	1295515686000	24055	11970	0	0	14331
351245	1874	25199000	24055	11970	1	0	2
9326	1395	58226310673957278	24055	11970	4	0	0
184043	1397	1295495684000	24057	11972	0	0	14333
351250	1678	26640839416000	24057	11972	0	0	0
27043	1623	69843147899898	24057	11972	2	0	1
184050	2134	85798693000	24060	11974	1	0	4777
351258	1678	26640839419000	24061	11975	0	0	0
7044	1394	688330936500000	24061	11975	2	0	0
184186	1397	1295455680000	24067	11977	0	0	14337
351393	1678	26640839420000	24067	11977	0	0	0
184187	1397	1295445679000	24067	11977	1	0	14338
351394	1678	26640839421000	24067	11977	1	0	0
184193	1397	1295415676000	24068	11978	1	0	14341
351400	1678	26640839424000	24068	11978	1	0	0
184199	2134	85791672000	24068	11978	7	0	4784
351406	1874	25238000	24068	11978	7	0	2
58109	1818	1440156890000	24068	11978	11	0	1
184204	1397	1295365671000	24070	11980	0	0	14346
351411	1678	26640839429000	24070	11980	0	0	0
35393	1679	25919347653000	24072	11981	3	0	75
184212	1397	1295335668000	24073	11982	0	0	14349
351419	1678	26640839432000	24073	11982	0	0	0
56874	1759	23761124999889	24073	11982	3	0	7
351425	1678	26640839434000	24076	11984	0	0	0
351426	1874	25265000	24076	11984	1	0	2
184220	1397	1295305665000	24077	11985	0	0	14352
184225	2134	85780639000	24078	11986	3	0	4795
351432	1874	25271000	24078	11986	3	0	2
184241	1397	1295245659000	24083	11988	1	0	14358
351448	1678	26640839441000	24083	11988	1	0	0
351455	1678	26640839443000	24086	11990	1	0	0
184249	1397	1295215656000	24086	11990	2	0	14361
184254	2134	85770609000	24086	11990	7	0	4805
351461	1874	25301000	24086	11990	7	0	2
21483	1564	7566641000000	24090	11991	3	0	10
184281	1397	1295185653000	24091	11992	0	0	14364
184282	2134	85768603000	24091	11992	1	0	4807
29084	1637	285846886819988	24091	11992	3	0	0
351491	1874	25310000	24092	11993	1	0	2
7053	1394	691210980500000	24092	11993	3	0	0
184288	2134	85765594000	24093	11994	3	0	4810
351496	1678	26640839451000	24094	11995	0	0	0
15687	1471	10025302900000	24094	11995	3	0	8
18816	1533	720000000000	24100	11997	1	0	0
184306	1397	1295115646000	24103	11998	0	0	14371
351514	1874	25325000	24103	11998	1	0	2
184313	2134	85760579000	24106	12000	1	0	4815
45969	1692	66021441619999	24106	12000	3	0	5
351522	1874	25337000	24108	12001	0	0	2
41018	1687	4448876848312	24108	12001	1	0	7
29482	1649	8391523999968	24111	12002	1	0	8
184322	1397	1295085643000	24118	12005	0	0	14374
351530	1678	26640839458000	24118	12005	1	0	0
184328	2134	85753558000	24118	12005	6	0	4822
351536	1380	1702582504891650	24118	12005	7	0	0
184345	2134	85750549000	24121	12006	1	0	4825
351556	1678	26640839463000	24123	12007	1	0	0
351563	1678	26640839464000	24125	12008	0	0	0
184357	2134	85747540000	24125	12008	1	0	4828
351564	1874	25370000	24125	12008	1	0	2
184363	2134	85744531000	24127	12010	1	0	4831
351570	1874	25379000	24127	12010	1	0	2
30428	1656	10795461999990	24129	12011	3	0	8
184372	1397	1294945629000	24131	12012	2	0	14388
351580	1874	25385000	24131	12012	3	0	2
60915	2307	719035000000	24131	12012	9	0	0
184386	1397	1294935628000	24133	12013	0	0	14389
351593	1678	26640839472000	24133	12013	0	0	0
184392	1397	1294915626000	24134	12014	0	0	14391
351599	1678	26640839474000	24134	12014	0	0	0
184403	2134	85735504000	24138	12015	3	0	4840
351611	1678	26640839477000	24139	12016	0	0	0
184409	2134	85733498000	24140	12017	3	0	4842
351616	1874	25412000	24140	12017	3	0	2
184417	2134	85729486000	24142	12018	3	0	4846
351624	1874	25424000	24142	12018	3	0	2
184532	1397	1294825617000	24147	12019	0	0	14400
351739	1678	26640839483000	24147	12019	0	0	0
351740	1874	25427000	24147	12019	1	0	2
184587	1397	1294815616000	24151	12020	0	0	14401
184588	1397	1294805615000	24152	12021	0	0	14402
351799	1874	25434000	24152	12021	4	0	2
26335	1619	3600052000000	24152	12021	5	0	0
184599	2134	85725474000	24154	12022	1	0	4850
351810	1874	25440000	24155	12023	2	0	2
40378	1685	154083614571430	24155	12023	4	0	0
184605	1397	1294755610000	24156	12024	0	0	14407
351825	1678	26640839491000	24161	12025	0	0	0
25841	1611	9495721000000	24161	12025	2	0	9
184628	1397	1294735608000	24164	12027	0	0	14409
351835	1678	26640839492000	24164	12027	0	0	0
351836	1678	26640839493000	24164	12027	1	0	0
184634	2134	85718453000	24164	12027	6	0	4857
351842	1874	25460000	24164	12027	7	0	2
26058	1613	9217276200000	24164	12027	9	0	10
15067	1458	15785308908540	24165	12028	2	0	8
184642	2134	85716447000	24167	12029	2	0	4859
351850	1874	25467000	24167	12029	3	0	2
46742	1693	10756859092484	24167	12029	6	0	1117
184655	2134	85714441000	24170	12030	1	0	4861
351868	1678	26640839499000	24172	12031	0	0	0
184666	1397	1294645599000	24173	12032	0	0	14418
351874	1678	26640839502000	24173	12032	1	0	0
184672	2134	85709426000	24173	12032	6	0	4866
351880	1874	25490000	24173	12032	7	0	2
5146	646	66720042920000	24173	12032	9	0	0
184681	2134	85707420000	24177	12034	1	0	4868
351889	1678	26640839506000	24178	12035	0	0	0
184687	2134	85705414000	24178	12035	5	0	4870
351895	1874	25506000	24178	12035	6	0	2
184690	1397	1294565591000	24180	12036	0	0	14426
184691	2134	85703408000	24180	12036	1	0	4872
351907	1678	26640839511000	24184	12038	0	0	0
184702	1397	1294535588000	24185	12039	0	0	14429
22497	1587	8640313000000	24185	12039	2	0	14
351912	1874	25522000	24186	12040	1	0	2
40838	1686	13352076700123	24186	12040	3	0	17
184744	2134	85698393000	24190	12041	1	0	4877
35987	1680	10093319499559	24190	12041	3	0	12
351963	1874	25531000	24195	12042	2	0	2
11330	1419	19007055560130	24195	12042	4	0	7
184758	2133	92119880000	24196	12043	1	0	4562
31387	1670	7200989000000	24196	12043	5	0	11
351969	1678	26640839518000	24197	12044	1	0	0
351970	1874	25539000	24197	12044	2	0	2
184764	2133	92117876000	24197	12044	3	0	4564
7061	1394	695531049500000	24197	12044	7	0	0
351976	1874	25552000	24198	12045	2	0	2
184774	1397	1294455580000	24200	12046	0	0	14437
57494	1764	25927448100000	24200	12046	5	0	8
184813	2134	85691372000	24203	12047	1	0	4884
352020	1874	25561000	24203	12047	1	0	2
184833	1397	1294435578000	24207	12048	0	0	14439
184834	1397	1294425577000	24207	12048	1	0	14440
352043	1874	25566000	24207	12048	3	0	2
40393	1685	155523671571430	24207	12048	7	0	0
184840	2133	92111864000	24208	12049	1	0	4570
3354	576	74717532726897	24208	12049	3	0	9
352056	1678	26640839525000	24211	12050	0	0	0
184853	2133	92109860000	24211	12050	4	0	4572
352062	1874	25587000	24211	12050	6	0	2
184865	2134	85686357000	24213	12051	2	0	4889
352077	1874	25594000	24215	12052	1	0	2
22994	1588	31895708000000	24215	12052	4	0	6
184880	2133	92106854000	24218	12053	2	0	4575
352093	1874	25603000	24220	12054	1	0	2
9339	1395	58228470722957278	24220	12054	3	0	0
184893	2133	92105852000	24222	12055	2	0	4576
352105	1678	26640839532000	24224	12056	0	0	0
352106	1874	25616000	24224	12056	1	0	2
184913	1397	1294325567000	24228	12057	0	0	14450
352135	1678	26640839534000	24232	12058	0	0	0
184930	2133	92101844000	24232	12058	2	0	4580
40395	1685	156243671571430	24232	12058	3	0	0
49273	1701	10798278500103	24233	12059	3	0	14
352148	1678	26640839536000	24236	12060	0	0	0
184943	2132	147658671000	24236	12060	2	0	1330
42415	1688	53279800720020	24236	12060	4	0	57
352153	1874	25642000	24237	12061	1	0	2
60076	2112	18526760101924	24237	12061	3	0	7
184948	2134	85676327000	24238	12062	1	0	4899
184969	1397	1294265561000	24242	12063	0	0	14456
184970	2134	85675324000	24242	12063	1	0	4900
352178	1874	25652000	24242	12063	2	0	2
13843	1448	8599816000001	24242	12063	3	0	16
184988	1397	1294245559000	24247	12065	0	0	14458
352196	1874	25661000	24247	12065	1	0	2
184994	1397	1294205555000	24248	12066	3	0	14462
352201	1678	26640839545000	24248	12066	3	0	0
184999	2134	85670309000	24248	12066	8	0	4905
352207	1874	25678000	24248	12066	9	0	2
185018	1397	1294185553000	24250	12067	1	0	14464
352226	1874	25686000	24250	12067	2	0	2
13581	1447	16121804683000	24250	12067	8	0	10
185031	1397	1294175552000	24252	12068	0	0	14465
352238	1678	26640839548000	24252	12068	0	0	0
352241	1110	908979810688432	24252	12068	3	0	0
352242	1230	613306790973693	24252	12068	4	0	0
185036	1622	2483900800048	24252	12068	5	0	10
57002	1762	7125462994000	24252	12068	9	0	8
352256	1678	26640839551000	24257	12070	2	0	0
185050	1397	1294135548000	24257	12070	3	0	14469
352262	1874	25710000	24257	12070	8	0	2
185056	2134	85664291000	24257	12070	9	0	4911
352280	1678	26640839553000	24259	12071	0	0	0
185074	2133	92082806000	24259	12071	1	0	4599
352290	1874	25732000	24261	12072	2	0	2
44515	1690	166325559000000	24261	12072	4	0	0
185097	558	66242190726895	24265	12073	0	0	4
185098	1397	1294105545000	24265	12073	1	0	14472
352309	2310	1000000000	24265	12073	5	0	0
185104	2133	92079800000	24265	12073	7	0	4602
352314	1874	25745000	24265	12073	10	0	2
185110	2132	147652665000	24265	12073	13	0	1336
18541	1522	7243639000000	24265	12073	16	0	14
352335	1874	25755000	24267	12074	1	0	2
9348	1395	58229910759957278	24267	12074	4	0	0
185134	1397	1294055540000	24270	12075	0	0	14477
352349	1678	26640839561000	24272	12076	0	0	0
185144	2134	85653258000	24272	12076	2	0	4922
352362	1678	26640839562000	24275	12077	1	0	0
185172	1397	1294025537000	24280	12078	0	0	14480
352379	1678	26640839563000	24280	12078	0	0	0
352380	1874	25777000	24280	12078	1	0	2
29093	1637	288006923819988	24280	12078	5	0	0
185177	2133	92071784000	24282	12079	1	0	4610
352392	1678	26640839565000	24288	12080	0	0	0
7074	1394	699851061500000	24288	12080	3	0	0
7075	1394	699851073500000	24288	12080	4	0	0
185197	2134	85648243000	24291	12081	1	0	4927
352406	1874	25796000	24291	12081	3	0	2
42433	1688	53999826720020	24291	12081	5	0	57
185206	1397	1293975532000	24294	12083	0	0	14485
352414	1678	26640839569000	24294	12083	1	0	0
185211	2134	85645234000	24294	12083	5	0	4930
352420	1874	25812000	24294	12083	7	0	2
185241	1397	1293945529000	24299	12084	0	0	14488
185242	1397	1293935528000	24299	12084	1	0	14489
352451	1874	25822000	24299	12084	3	0	2
185248	2133	92062766000	24300	12085	1	0	4619
352456	1874	25832000	24300	12085	2	0	2
1035	64	68160030000000	24300	12085	4	0	0
30677	1657	5041253990100	24301	12086	3	0	11
185277	1397	1293905525000	24307	12087	0	0	14492
352485	1678	26640839576000	24307	12087	1	0	0
185282	2132	147646659000	24307	12087	6	0	1342
352498	1678	26640839577000	24309	12088	0	0	0
185295	2133	92057756000	24310	12089	1	0	4624
352503	1874	25859000	24310	12089	2	0	2
24751	1602	9936611170000	24310	12089	3	0	9
352516	1678	26640839579000	24313	12090	0	0	0
352517	1678	26640839580000	24313	12090	1	0	0
185313	2134	85634201000	24313	12090	4	0	4941
352523	1874	25870000	24313	12090	7	0	2
22144	1573	4899327000000	24313	12090	9	0	10
185325	1397	1293835518000	24315	12091	0	0	14499
352536	1874	25879000	24315	12091	4	0	2
185331	2133	92052746000	24315	12091	6	0	4629
352541	1874	25888000	24316	12092	2	0	2
185337	2132	147643656000	24317	12093	2	0	1345
352547	1874	25897000	24317	12093	5	0	2
45983	1692	67461540619999	24317	12093	8	0	5
185342	1397	1293785513000	24318	12094	0	0	14504
352553	1874	25907000	24318	12094	4	0	2
11787	1422	10314659804270	24318	12094	6	0	12
185361	1397	1293765511000	24320	12095	0	0	14506
352571	1678	26640839592000	24320	12095	3	0	0
185367	2133	92046734000	24320	12095	6	0	4635
185369	2134	85623168000	24320	12095	8	0	4952
185370	2132	147642655000	24320	12095	9	0	1346
352577	1874	25924000	24320	12095	9	0	2
185376	2133	92042726000	24321	12096	2	0	4639
352583	1874	25933000	24321	12096	2	0	2
185382	2133	92040722000	24322	12097	4	0	4641
352588	1874	25940000	24322	12097	4	0	2
185399	2134	85617150000	24325	12098	2	0	4958
352604	1874	25956000	24325	12098	3	0	2
185405	2134	85616147000	24326	12099	1	0	4959
352610	1874	25967000	24326	12099	2	0	2
46802	1693	12196905092484	24330	12100	4	0	1117
185464	1506	5040080967172	24335	12101	0	0	23
352668	1007	506698773004376	24335	12101	0	0	0
352669	1678	26640839598000	24335	12101	1	0	0
185469	2134	85613138000	24335	12101	5	0	4962
352675	1874	25982000	24335	12101	7	0	2
50348	1705	17120790580140	24335	12101	11	0	25
185478	1397	1293645499000	24337	12102	0	0	14518
352684	1874	25994000	24337	12102	2	0	2
7086	1394	704171107500000	24339	12103	4	0	0
185487	1397	1293625497000	24340	12104	0	0	14520
352692	1874	26002000	24340	12104	1	0	2
29099	1637	289446959819988	24340	12104	3	0	0
185495	1397	1293605495000	24343	12106	0	0	14522
352701	1874	26010000	24343	12106	2	0	2
185504	1397	1293585493000	24346	12108	0	0	14524
185505	1397	1293575492000	24346	12108	1	0	14525
185506	2133	92026694000	24346	12108	2	0	4655
352710	1874	26017000	24346	12108	2	0	2
352715	1678	26640839609000	24347	12109	0	0	0
185512	2134	85604111000	24347	12109	1	0	4971
50614	1706	10362124450256	24347	12109	3	0	27
352730	1874	26035000	24350	12110	3	0	2
185527	2133	92023688000	24350	12110	4	0	4658
185538	2134	85600099000	24355	12112	1	0	4975
352742	1874	26046000	24355	12112	1	0	2
352754	1874	26053000	24360	12114	1	0	2
49757	1703	2880862000000	24360	12114	3	0	5
185553	1397	1293495484000	24362	12115	0	0	14533
352765	1292	1710568637751650	24365	12117	0	0	0
185562	1397	1293475482000	24365	12117	1	0	14535
185567	1397	1293455480000	24366	12118	1	0	14537
352771	1678	26640839620000	24366	12118	1	0	0
352778	1678	26640839622000	24368	12119	0	0	0
185575	2134	85591072000	24368	12119	1	0	4984
352784	1874	26079000	24369	12120	4	0	2
185581	2134	85589066000	24369	12120	5	0	4986
352785	1874	26082000	24369	12120	5	0	2
352786	1874	26085000	24369	12120	6	0	2
185594	1397	1293385473000	24374	12122	0	0	14544
352800	1874	26093000	24374	12122	2	0	2
56879	1759	25921137999889	24377	12123	3	0	7
185636	1397	1293365471000	24379	12124	0	0	14546
352843	1874	26097000	24381	12125	1	0	2
185641	1397	1293345469000	24382	12126	0	0	14548
185642	1397	1293335468000	24382	12126	1	0	14549
352848	1874	26106000	24382	12126	3	0	2
185648	2132	147628641000	24384	12127	3	0	1360
352854	1874	26113000	24384	12127	5	0	2
9355	1395	58232070793957278	24389	12128	3	0	0
185674	1397	1293285463000	24391	12129	0	0	14554
352880	1874	26123000	24391	12129	2	0	2
185752	1397	1293265461000	24398	12131	0	0	14556
352956	1678	26640839639000	24398	12131	0	0	0
352957	1874	26129000	24398	12131	1	0	2
19031	1536	12960267000000	24398	12131	3	0	11
185761	1397	1293235458000	24401	12133	1	0	14559
352966	1874	26136000	24401	12133	2	0	2
4902	641	76083851000000	24401	12133	3	0	16
185767	2132	147625638000	24403	12135	2	0	1363
53012	1717	10621186000055	24403	12135	4	0	8
352975	1678	26640839645000	24405	12136	0	0	0
185777	1611	8663559824916	24407	12137	2	0	10
185778	1611	7172315202966	24407	12137	3	0	11
352982	1095	909782128041950	24407	12137	3	0	0
7095	1394	708491132500000	24407	12137	6	0	0
185784	2134	85567000000	24409	12139	0	0	5008
352988	1874	26156000	24409	12139	0	0	2
185792	2134	85564994000	24412	12141	2	0	5010
352996	1874	26163000	24412	12141	2	0	2
57708	1768	14866734110000	24414	12143	3	0	10
185801	1397	1293125447000	24417	12144	0	0	14570
353005	1678	26640839653000	24417	12144	0	0	0
185807	2134	85559979000	24417	12144	6	0	5015
353011	1874	26179000	24417	12144	6	0	2
31774	1671	9743979003785	24417	12144	7	0	8
185991	1397	1293085443000	24423	12146	0	0	14574
353194	1678	26640839657000	24423	12146	0	0	0
185992	1397	1293075442000	24423	12146	1	0	14575
353195	1678	26640839658000	24423	12146	1	0	0
185998	1397	1293055440000	24424	12147	0	0	14577
353201	1678	26640839660000	24424	12147	0	0	0
186004	2134	85552958000	24424	12147	6	0	5022
353207	1874	26202000	24424	12147	6	0	2
186016	2134	85550952000	24429	12149	2	0	5024
353219	1874	26209000	24429	12149	2	0	2
10196	1402	22502800145435	24429	12149	3	0	66
186031	2134	85548946000	24436	12152	3	0	5026
353234	1874	26215000	24436	12152	3	0	2
46869	1693	14356940092484	24436	12152	7	0	1117
186044	114	66043463685762	24439	12154	0	0	9
353247	2003	2081960654821	24439	12154	0	0	2
186049	2134	85543931000	24440	12155	1	0	5031
353252	1874	26232000	24440	12155	1	0	2
9364	1395	58234230837957278	24440	12155	3	0	0
186050	1397	1292935428000	24441	12156	0	0	14589
7102	1394	711371179500000	24441	12156	3	0	0
353281	1874	26241000	24447	12158	1	0	2
186079	2132	147616629000	24447	12158	2	0	1372
55307	1740	11250764000000	24447	12158	3	0	14
353302	1678	26640839677000	24453	12160	0	0	0
186100	2134	85537913000	24453	12160	1	0	5037
4213	632	75357587000000	24453	12160	4	0	9
353307	1874	26255000	24454	12161	2	0	2
186105	1397	1292855420000	24455	12162	0	0	14597
19446	1546	8877399800000	24455	12162	3	0	10
353316	1874	26262000	24457	12163	2	0	2
186114	2134	85533901000	24457	12163	3	0	5041
353330	1678	26640839684000	24463	12165	0	0	0
353331	1874	26269000	24463	12165	1	0	2
12114	1426	10410355000000	24463	12165	4	0	8
186130	1397	1292805415000	24464	12166	0	0	14602
353337	1874	26278000	24464	12166	4	0	2
186135	2134	85528886000	24464	12166	5	0	5046
353343	1022	509273064000000	24465	12167	3	0	0
186141	1397	1292775412000	24465	12167	4	0	14605
353351	1678	26640839690000	24467	12168	0	0	0
186150	2134	85525877000	24467	12168	2	0	5049
353364	1678	26640839693000	24472	12170	1	0	0
186162	2134	85523871000	24472	12170	2	0	5051
19453	1546	9597411800000	24472	12170	4	0	10
353382	1678	26640839695000	24479	12172	0	0	0
186180	2134	85520862000	24479	12172	1	0	5054
353387	1874	26312000	24481	12173	3	0	2
186185	2134	85518856000	24481	12173	4	0	5056
186186	1397	1292675402000	24484	12174	0	0	14615
353393	1678	26640839700000	24486	12176	0	0	0
186192	2132	147608621000	24486	12176	2	0	1380
47547	1695	6425046999000	24486	12176	5	0	9
353399	1678	26640839703000	24487	12177	1	0	0
186198	2134	85512838000	24487	12177	3	0	5062
353404	1874	26338000	24488	12178	2	0	2
186203	1397	1292595394000	24489	12179	1	0	14623
353414	1874	26345000	24491	12180	1	0	2
186219	2134	85508826000	24494	12181	1	0	5066
353434	1678	26640839711000	24498	12183	1	0	0
186233	2134	85505817000	24498	12183	3	0	5069
353439	1678	26640839712000	24499	12184	0	0	0
186238	1397	1292525387000	24500	12185	0	0	14630
353445	1874	26371000	24501	12186	2	0	2
186368	1397	1292505385000	24503	12187	0	0	14632
353571	1678	26640839715000	24503	12187	0	0	0
186369	2134	85500802000	24503	12187	1	0	5074
353572	1874	26374000	24503	12187	1	0	2
42491	1688	56159850720020	24503	12187	2	0	57
729	58	71747319999641	24506	12188	3	0	12
186377	2132	147603616000	24507	12189	3	0	1385
353580	1874	26381000	24507	12189	3	0	2
186389	2132	147602615000	24512	12191	2	0	1386
353592	1874	26388000	24512	12191	2	0	2
186529	1397	1292435378000	24516	12192	0	0	14639
353732	1678	26640839722000	24516	12192	0	0	0
186530	1397	1292425377000	24516	12192	1	0	14640
353733	1678	26640839723000	24516	12192	1	0	0
353737	1874	26401000	24516	12192	5	0	2
353738	1874	26404000	24516	12192	6	0	2
186578	1397	1292405375000	24524	12193	0	0	14642
32813	1675	12524294999977	24524	12193	2	0	8
186788	1397	1292395374000	24529	12194	0	0	14643
353990	1678	26640839726000	24529	12194	0	0	0
186789	1397	1292385373000	24529	12194	1	0	14644
353991	1678	26640839727000	24529	12194	1	0	0
7111	1394	715691236500000	24529	12194	6	0	0
186795	1397	1292365371000	24532	12196	0	0	14646
353997	1678	26640839729000	24532	12196	0	0	0
48928	1700	8154236979053	24532	12196	2	0	10
186801	2134	85484754000	24533	12197	4	0	5090
354003	1874	26427000	24533	12197	4	0	2
13124	1444	9447734329999	24533	12197	5	0	12
36319	1681	12131351909853	24534	12198	5	0	11
186838	1397	1292315366000	24540	12201	0	0	14651
354040	1678	26640839734000	24540	12201	0	0	0
354041	1678	26640839735000	24540	12201	1	0	0
186844	2134	85481745000	24540	12201	6	0	5093
354047	1874	26441000	24540	12201	7	0	2
53581	1719	13678626000000	24540	12201	10	0	10
186850	2134	85477733000	24541	12202	3	0	5097
354057	1678	26640839740000	24547	12203	0	0	0
186859	2132	147596609000	24547	12203	4	0	1392
46921	1693	15797009092484	24547	12203	6	0	1117
354062	1678	26640839742000	24548	12204	0	0	0
186868	1397	1292225357000	24553	12205	0	0	14660
186869	2134	85473721000	24553	12205	1	0	5101
52504	1715	20906909436096	24553	12205	2	0	9
354076	1874	26466000	24555	12206	2	0	2
187007	1397	1292195354000	24558	12207	0	0	14663
354209	1678	26640839746000	24558	12207	0	0	0
187008	2134	85470712000	24558	12207	1	0	5104
354210	1874	26473000	24558	12207	1	0	2
49290	1701	12238324500103	24558	12207	3	0	14
23563	1594	12961767000000	24561	12209	3	0	10
187015	1397	1292165351000	24562	12210	0	0	14666
354217	1678	26640839749000	24562	12210	0	0	0
7117	1394	720011280500000	24562	12210	3	0	0
40419	1685	158403829571430	24563	12211	3	0	0
187023	2134	85465697000	24565	12212	1	0	5109
354225	1874	26490000	24565	12212	1	0	2
35467	1679	28079391653000	24567	12213	5	0	75
187044	1397	1292115346000	24571	12214	0	0	14671
354246	1678	26640839754000	24571	12214	0	0	0
47172	1694	12778962197225	24571	12214	3	0	62
187059	1397	1292075342000	24573	12215	3	0	14675
354261	1678	26640839758000	24573	12215	3	0	0
53240	1718	6738539519070	24573	12215	9	0	13
187067	1397	1292065341000	24575	12216	0	0	14676
354269	1678	26640839759000	24575	12216	0	0	0
10207	1402	23942834145435	24575	12216	3	0	66
187075	1397	1292045339000	24578	12218	0	0	14678
354277	1678	26640839761000	24578	12218	0	0	0
354281	2291	255757211465	24580	12220	0	0	0
354282	1678	26640839763000	24580	12220	1	0	0
187081	1397	1292015336000	24580	12220	2	0	14681
354288	1874	26536000	24580	12220	7	0	2
39275	1684	18723153819412	24580	12220	8	0	136
187087	1397	1291995334000	24581	12221	0	0	14683
187092	1397	1291975332000	24582	12222	0	0	14685
354294	1678	26640839768000	24582	12222	0	0	0
20014	1549	9071357000000	24582	12222	5	0	10
354299	1874	26550000	24582	12222	6	0	2
187098	2134	85446640000	24582	12222	7	0	5128
31048	1668	8433607000000	24588	12223	3	0	9
187138	1397	1291935328000	24590	12224	0	0	14689
187139	1397	1291925327000	24590	12224	1	0	14690
354342	1678	26640839774000	24590	12224	2	0	0
187159	1397	1291895324000	24594	12225	1	0	14693
354362	1678	26640839777000	24594	12225	2	0	0
53048	1717	12781242000055	24594	12225	8	0	8
187167	1397	1291875322000	24596	12226	0	0	14695
354369	1678	26640839778000	24596	12226	0	0	0
187178	2134	85437613000	24601	12228	1	0	5137
354381	1874	26583000	24601	12228	2	0	2
7125	1394	724331314500000	24601	12228	3	0	0
187189	2134	85435607000	24605	12230	1	0	5139
16392	1476	10080218000000	24605	12230	3	0	11
354392	1678	26640839783000	24606	12231	0	0	0
187195	2134	85433601000	24606	12231	5	0	5141
354397	1874	26598000	24606	12231	5	0	2
10228	1402	26102878145435	24606	12231	7	0	66
187221	1397	1291795314000	24615	12233	0	0	14703
354423	1678	26640839786000	24615	12233	0	0	0
354424	1874	26607000	24615	12233	1	0	2
29111	1637	291606992819988	24615	12233	3	0	0
187229	1397	1291755310000	24617	12234	3	0	14707
354432	1678	26640839791000	24617	12234	4	0	0
187235	2134	85428586000	24617	12234	9	0	5146
354438	1874	26624000	24617	12234	10	0	2
187240	2133	92016674000	24617	12234	14	0	4665
354443	1874	26635000	24617	12234	15	0	2
24008	1599	8936770097983	24619	12235	3	0	8
187283	1397	1291725307000	24626	12236	0	0	14710
187284	2133	92012666000	24626	12236	1	0	4669
354486	1874	26644000	24626	12236	1	0	2
187290	1715	20395206013166	24628	12238	0	0	11
354492	2288	776757211465	24628	12238	0	0	0
354497	1874	26660000	24628	12238	5	0	2
187296	2133	92008658000	24628	12238	6	0	4673
187310	2134	85419559000	24632	12239	1	0	5155
354512	1874	26672000	24632	12239	1	0	2
187316	2133	92006654000	24633	12240	4	0	4675
354518	1874	26679000	24633	12240	4	0	2
354523	1874	26687000	24634	12241	4	0	2
187346	1467	17088711371984	24640	12242	0	0	5
187351	1467	2320229272869	24640	12242	5	0	9
354552	1874	26690000	24640	12242	6	0	2
354553	1874	26692000	24640	12242	7	0	2
187499	1715	18289204689316	24645	12243	0	0	13
354697	1006	508416004675840	24645	12243	0	0	0
187500	1397	1291635298000	24645	12243	1	0	14719
354698	1678	26640839802000	24645	12243	1	0	0
187522	2133	92001644000	24650	12244	3	0	4680
354720	1874	26703000	24650	12244	3	0	2
50891	1708	6120481500051	24650	12244	5	0	8
17071	1506	5760192967172	24652	12245	5	0	23
187540	1715	6503518663945	24655	12246	1	0	16
354738	1372	1712977205175714	24655	12246	1	0	0
187545	2134	85412538000	24655	12246	6	0	5162
354743	1874	26715000	24655	12246	6	0	2
187546	2134	85411535000	24655	12246	7	0	5163
53933	1723	9361820085979	24655	12246	9	0	12
354752	1678	26640839808000	24658	12248	0	0	0
187555	2134	85409529000	24658	12248	1	0	5165
51555	1710	9594008664140	24660	12249	4	0	10
354769	1678	26640839810000	24663	12250	0	0	0
187572	2134	85407523000	24663	12250	1	0	5167
60965	2313	719000000000	24663	12250	4	0	0
60966	2313	719013000000	24663	12250	5	0	0
354779	1874	26742000	24666	12251	1	0	2
187587	1397	1291535288000	24669	12252	0	0	14729
9378	1395	58236390860957278	24669	12252	3	0	0
354790	1874	26751000	24670	12253	2	0	2
187593	2133	91991624000	24670	12253	3	0	4690
354804	1874	26754000	24673	12254	4	0	2
187607	1673	16336169000000	24673	12254	5	0	14
354809	1874	26765000	24673	12254	9	0	2
187612	2133	91989620000	24673	12254	10	0	4692
354819	1678	26640839818000	24677	12256	0	0	0
187622	2134	85400502000	24677	12256	1	0	5174
354825	1874	26784000	24678	12257	2	0	2
47570	1695	7865093999000	24678	12257	4	0	9
187628	1397	1291455280000	24679	12258	0	0	14737
354826	1678	26640839820000	24679	12258	0	0	0
187633	1397	1291445279000	24680	12259	0	0	14738
354832	1874	26793000	24680	12259	1	0	2
187639	2132	147571584000	24681	12260	3	0	1417
354838	23	32937710000000	24681	12260	4	0	0
9385	1395	58237830930957278	24681	12260	5	0	0
187645	2133	91981604000	24681	12260	10	0	4700
354843	1874	26809000	24681	12260	10	0	2
9386	1395	58238550930957278	24681	12260	12	0	0
187681	1397	1291395274000	24686	12262	0	0	14743
187682	1397	1291385273000	24686	12262	1	0	14744
354880	1678	26640839827000	24686	12262	1	0	0
187688	2134	85392478000	24686	12262	7	0	5182
354886	1874	26826000	24686	12262	7	0	2
354898	1874	26837000	24689	12263	2	0	2
187701	1673	8855435000000	24689	12263	3	0	18
12518	1439	9343690578477	24689	12263	5	0	10
7139	1394	728651459500000	24691	12264	4	0	0
187716	1397	1291345269000	24693	12265	0	0	14748
354914	1678	26640839831000	24693	12265	0	0	0
187737	1693	15721176330507	24697	12266	0	0	1118
354935	245	66778181541448	24697	12266	0	0	0
354950	1678	26640839834000	24700	12267	0	0	0
187753	1693	15436995979531	24700	12267	1	0	1120
187758	2133	91970582000	24700	12267	6	0	4711
354956	1874	26858000	24700	12267	6	0	2
354961	601	66778181541448	24701	12268	3	0	0
187764	1693	14830595305742	24701	12268	4	0	1128
354962	1821	776898579462	24701	12268	4	0	2
187797	1397	1291275262000	24703	12269	3	0	14755
354995	1678	26640839838000	24703	12269	3	0	0
187802	1693	14414498624560	24703	12269	8	0	1134
355001	500	66778181541448	24703	12269	9	0	0
187808	1693	13960143835022	24703	12269	14	0	1140
355006	138	66778181541448	24703	12269	14	0	0
187814	2132	147567580000	24703	12269	20	0	1421
355012	1874	26867000	24703	12269	20	0	2
187817	2133	91966574000	24703	12269	23	0	4715
187818	2134	85383451000	24703	12269	24	0	5191
355018	1874	26882000	24703	12269	26	0	2
187878	1693	11483485492142	24706	12270	3	0	1148
355077	721	2023581258730	24706	12270	4	0	0
11350	1419	20446117559750	24706	12270	8	0	8
187884	1693	11329512308744	24707	12271	2	0	1151
355083	710	5058953147009	24707	12271	3	0	0
187889	2133	91964570000	24707	12271	7	0	4717
355089	1874	26893000	24707	12271	9	0	2
187895	1397	1291245259000	24708	12272	3	0	14758
355094	312	66122238827087	24708	12272	4	0	1
355097	1874	26898000	24708	12272	8	0	2
355109	1772	5574212177275	24711	12273	0	0	1
187912	1693	9138577559614	24711	12273	1	0	1162
187917	2133	91962566000	24711	12273	6	0	4719
355115	1874	26903000	24711	12273	6	0	2
2305	411	66726452000000	24711	12273	8	0	6
9394	1395	58240710972957278	24715	12274	3	0	0
187951	1693	8558581986164	24717	12275	2	0	1166
355149	390	66778181541448	24717	12275	2	0	0
187953	1693	8480762986694	24717	12275	4	0	1168
187954	2134	85376430000	24717	12275	5	0	5198
355154	1678	26640839846000	24718	12276	1	0	0
187960	2133	91959560000	24718	12276	5	0	4722
355160	1874	26920000	24718	12276	7	0	2
40432	1685	160563915571430	24718	12276	8	0	0
187990	1397	1291155250000	24723	12278	3	0	14767
355190	82	66778181541448	24723	12278	5	0	0
187995	1693	8101599176809	24723	12278	8	0	1173
355195	458	66124633253615	24723	12278	10	0	1
188001	1693	7646922551215	24723	12278	14	0	1179
355201	652	66778181541448	24723	12278	16	0	0
188007	1693	7192248659638	24723	12278	20	0	1185
355207	191	66778181541448	24723	12278	22	0	0
188012	1693	6190280399986	24723	12278	25	0	1190
355212	678	66778181541448	24723	12278	27	0	0
188018	1693	5735606405455	24723	12278	31	0	1196
355218	1874	26922000	24723	12278	33	0	2
188024	2133	91956554000	24723	12278	37	0	4725
355224	1874	26935000	24723	12278	39	0	2
188029	2134	85370412000	24723	12278	42	0	5204
46479	1693	6453298746011	24723	12278	44	0	1197
188119	1693	6377806984034	24726	12279	0	0	1198
355317	453	66778181541448	24726	12279	0	0	0
188120	1693	6301974222057	24726	12279	1	0	1199
355318	373	66778181541448	24726	12279	1	0	0
188126	1693	5417699893618	24726	12279	7	0	1205
355324	711	3007950736827	24726	12279	7	0	1
188132	2133	91953548000	24726	12279	13	0	4728
355330	1874	26949000	24726	12279	13	0	2
7151	1394	732971731500000	24726	12279	17	0	0
188137	1693	5257986027726	24727	12280	1	0	1208
355335	29	7082534405834	24727	12280	1	0	0
188146	2134	85365397000	24729	12281	1	0	5209
355344	1874	26965000	24729	12281	1	0	2
188152	2133	91949540000	24732	12282	4	0	4732
355350	1874	26969000	24732	12282	4	0	2
355369	660	66778181541448	24736	12283	1	0	0
188172	1693	4652290498232	24736	12283	2	0	1216
355370	304	66778181541448	24736	12283	2	0	0
32080	1672	7921385000000	24736	12283	9	0	10
188186	1397	1291085243000	24738	12284	1	0	14774
355384	1678	26640839857000	24738	12284	1	0	0
188192	2133	91947536000	24738	12284	7	0	4734
355390	1874	26983000	24738	12284	7	0	2
188197	1693	3617764053785	24739	12285	4	0	1226
355395	603	66844584212192	24739	12285	4	0	1
7156	1394	735851950500000	24739	12285	8	0	0
188236	1693	3595696523039	24742	12286	0	0	1227
188237	1693	3519863761062	24742	12286	1	0	1228
355437	1678	26640839861000	24742	12286	3	0	0
188243	1693	3290067460535	24742	12286	7	0	1232
355443	377	66778181541448	24742	12286	9	0	0
188249	2134	85360382000	24742	12286	13	0	5214
355448	1874	26993000	24742	12286	14	0	2
188262	1693	2835070888673	24744	12287	0	0	1238
355462	748	2725998633389	24744	12287	2	0	1
188268	2134	85358376000	24744	12287	6	0	5216
15719	1471	12185389900000	24744	12287	9	0	8
355476	1678	26640839863000	24746	12288	0	0	0
188282	1693	2302586094226	24746	12288	4	0	1246
355481	1874	27007000	24746	12288	5	0	2
188295	1397	1291005235000	24748	12289	1	0	14782
355495	1874	27016000	24748	12289	3	0	2
355505	691	66778181541448	24750	12290	1	0	0
355506	620	66778181541448	24750	12290	2	0	0
188309	2133	91941524000	24750	12290	3	0	4740
355512	1678	26640839867000	24751	12291	0	0	0
188315	1397	1290975232000	24751	12291	1	0	14785
188320	2133	91937516000	24751	12291	6	0	4744
355518	1874	27036000	24751	12291	6	0	2
42535	1688	58318958720020	24751	12291	9	0	57
355523	1874	27044000	24752	12292	3	0	2
188330	1397	1290945229000	24754	12293	0	0	14788
188363	1397	1290935228000	24762	12294	0	0	14789
188364	1397	1290925227000	24762	12294	1	0	14790
355563	1874	27050000	24762	12294	2	0	2
188370	1588	23643327000000	24763	12295	0	0	8
355569	1678	26640839874000	24763	12295	1	0	0
188376	2133	91931504000	24763	12295	6	0	4750
355574	1874	27062000	24763	12295	6	0	2
188388	1397	1290895224000	24765	12296	1	0	14793
355587	1874	27072000	24765	12296	2	0	2
50912	1708	7560538500051	24765	12296	9	0	8
188394	1397	1290885223000	24766	12297	0	0	14794
355593	1874	27084000	24766	12297	1	0	2
22773	1588	12961763000000	24766	12297	3	0	12
15272	1467	3040229272869	24769	12298	3	0	9
188405	1397	1290865221000	24770	12299	0	0	14796
355603	1678	26640839879000	24770	12299	0	0	0
188417	2134	85340322000	24773	12300	1	0	5234
355616	1874	27102000	24773	12300	2	0	2
20487	1555	11046088540449	24775	12301	3	0	8
188429	2132	147553566000	24777	12302	2	0	1435
355628	1874	27110000	24777	12302	3	0	2
50366	1705	18560884580140	24777	12302	5	0	25
188441	2133	91921484000	24779	12303	4	0	4760
355639	1874	27118000	24779	12303	4	0	2
355641	1678	26640839885000	24780	12304	0	0	0
355642	1874	27122000	24780	12304	1	0	2
188446	2132	147552565000	24780	12304	3	0	1436
188502	1397	1290795214000	24782	12305	0	0	14803
188503	2134	85335307000	24782	12305	1	0	5239
355702	1678	26640839887000	24784	12306	0	0	0
188509	1397	1290745209000	24784	12306	4	0	14808
355708	1874	27135000	24784	12306	6	0	2
188515	2134	85333301000	24784	12306	10	0	5241
355713	1874	27146000	24784	12306	11	0	2
188520	2133	91914470000	24784	12306	15	0	4767
48287	1698	10868932550062	24784	12306	18	0	12
355719	1678	26640839892000	24785	12307	0	0	0
4223	632	76077587000000	24785	12307	4	0	9
188526	1397	1290725207000	24786	12308	0	0	14810
355725	1874	27165000	24786	12308	2	0	2
15112	1458	18665369908540	24786	12308	6	0	8
188536	1397	1290705205000	24790	12309	0	0	14812
355734	1874	27174000	24790	12309	1	0	2
188555	1397	1290685203000	24794	12310	1	0	14814
355754	1874	27182000	24794	12310	3	0	2
188561	2134	85324274000	24794	12310	7	0	5250
355760	1403	0	24794	12310	9	0	0
188567	2134	85322268000	24795	12311	3	0	5252
355765	1874	27201000	24795	12311	4	0	2
188572	2134	85320262000	24796	12312	1	0	5254
29119	1637	293767092819988	24796	12312	3	0	0
355775	1678	26640839902000	24798	12313	0	0	0
355777	1874	27213000	24798	12313	2	0	2
355778	1874	27216000	24798	12313	3	0	2
44529	1690	169205572000000	24798	12313	4	0	0
188582	1397	1290625197000	24799	12314	0	0	14820
355784	1874	27223000	24800	12315	2	0	2
188588	2134	85317253000	24800	12315	3	0	5257
188593	2133	91899440000	24801	12316	4	0	4782
355790	1874	27232000	24801	12316	4	0	2
355795	2314	122000000000	24803	12318	1	0	0
188599	114	66000936901851	24803	12318	2	0	12
355811	2314	429000000000	24806	12319	1	0	0
188615	2134	85313241000	24806	12319	2	0	5261
30161	1654	15257449999798	24806	12319	4	0	11
188747	1397	1290565191000	24813	12321	0	0	14826
355944	1678	26640839909000	24813	12321	0	0	0
188748	1397	1290555190000	24813	12321	1	0	14827
355945	1678	26640839910000	24813	12321	1	0	0
188882	1397	1290545189000	24816	12322	0	0	14828
356079	1678	26640839911000	24816	12322	0	0	0
188883	2134	85310232000	24816	12322	1	0	5264
356080	1874	27261000	24816	12322	1	0	2
29124	1637	295207116819988	24816	12322	3	0	0
188894	2133	91892426000	24818	12323	4	0	4789
356091	1874	27269000	24818	12323	4	0	2
1220	149	75455323000341	24819	12324	3	0	10
188900	1397	1290495184000	24820	12325	2	0	14833
356097	1678	26640839916000	24820	12325	2	0	0
188905	2133	91890422000	24820	12325	7	0	4791
188906	2133	91889420000	24820	12325	8	0	4792
356102	1874	27281000	24820	12325	8	0	2
188928	2134	85304214000	24823	12326	1	0	5270
356123	1874	27293000	24823	12326	1	0	2
188953	2132	147542555000	24827	12327	4	0	1446
356148	1874	27299000	24827	12327	4	0	2
7168	1394	740172032500000	24827	12327	9	0	0
188958	2133	91884410000	24828	12328	1	0	4797
356153	1874	27308000	24828	12328	1	0	2
3823	606	73246680286230	24828	12328	4	0	18
188975	1397	1290425177000	24834	12330	1	0	14840
356170	1678	26640839923000	24834	12330	1	0	0
188981	1397	1290415176000	24835	12331	0	0	14841
356176	1678	26640839924000	24835	12331	0	0	0
9407	1395	58242871031957278	24835	12331	3	0	0
356189	1678	26640839925000	24837	12332	0	0	0
356190	1678	26640839926000	24837	12332	1	0	0
188996	1397	1290385173000	24837	12332	2	0	14844
356196	1874	27342000	24837	12332	7	0	2
189002	2134	85295187000	24837	12332	8	0	5279
356209	1874	27351000	24839	12333	3	0	2
189015	2134	85293181000	24839	12333	4	0	5281
356227	1874	27361000	24843	12334	1	0	2
189033	2134	85291175000	24843	12334	2	0	5283
356235	1874	27372000	24847	12336	1	0	2
189041	2132	147538551000	24847	12336	2	0	1450
189042	2133	91872386000	24847	12336	3	0	4809
25255	1608	10938481000000	24847	12336	5	0	8
356245	2152	107000000000000	24849	12337	3	0	3
189052	2133	91870382000	24849	12337	5	0	4811
356250	1874	27387000	24849	12337	8	0	2
189058	1397	1290285163000	24850	12338	1	0	14854
356256	1874	27396000	24850	12338	4	0	2
189063	2134	85284154000	24850	12338	6	0	5290
7178	1394	744492094500000	24850	12338	7	0	0
356262	1874	27404000	24851	12339	3	0	2
189069	2134	85282148000	24851	12339	5	0	5292
356267	1678	26640839940000	24852	12340	1	0	0
189078	1397	1290245159000	24854	12341	0	0	14858
356276	1678	26640839942000	24855	12342	0	0	0
189083	2134	85279139000	24855	12342	2	0	5295
356282	1874	27433000	24855	12342	6	0	2
47939	1696	14843691335104	24855	12342	7	0	9
189103	2133	91860362000	24858	12343	1	0	4821
356315	1678	26640839946000	24861	12344	1	0	0
189125	2133	91858358000	24861	12344	4	0	4823
10243	1402	28262965145435	24861	12344	8	0	66
356321	1678	26640839947000	24862	12345	0	0	0
189130	1397	1290175152000	24862	12345	1	0	14865
356322	1678	26640839948000	24862	12345	1	0	0
189136	1397	1290165151000	24863	12346	0	0	14866
356328	1678	26640839949000	24863	12346	0	0	0
44812	1691	9071096300052	24868	12347	2	0	10
189157	1397	1290155150000	24871	12348	0	0	14867
356349	1678	26640839951000	24871	12348	1	0	0
189162	2134	85270112000	24871	12348	5	0	5304
356354	1406	0	24871	12348	6	0	0
189168	2133	91851344000	24871	12348	11	0	4830
356360	1874	27482000	24871	12348	12	0	2
189174	2134	85266100000	24872	12349	1	0	5308
356366	1874	27496000	24872	12349	2	0	2
19051	1536	14400301000000	24872	12349	4	0	11
189177	2134	85265097000	24873	12350	1	0	5309
189178	2133	91848338000	24873	12350	2	0	4833
21511	1564	9726664000000	24873	12350	4	0	10
356375	1678	26640839956000	24875	12351	0	0	0
7184	1394	747372156500000	24875	12351	4	0	0
189197	2133	91846334000	24879	12352	1	0	4835
356390	2315	10000000000	24880	12353	0	0	0
291	43	72480056890000	24880	12353	4	0	3
189210	1397	1290065141000	24883	12354	0	0	14876
356403	1874	27520000	24883	12354	2	0	2
50658	1706	12522160450256	24883	12354	4	0	27
189218	2134	85261085000	24885	12355	2	0	5313
356411	1874	27526000	24886	12356	1	0	2
189230	2134	85259079000	24889	12357	2	0	5315
356426	1874	27539000	24891	12358	1	0	2
9415	1395	58244311057957278	24891	12358	3	0	0
189239	2133	91840322000	24892	12359	3	0	4841
356432	1874	27544000	24892	12359	5	0	2
189244	2134	85256070000	24892	12359	8	0	5318
356445	1874	27555000	24894	12360	2	0	2
189262	2133	91837316000	24896	12361	2	0	4844
356454	1874	27565000	24897	12362	2	0	2
189268	1397	1289955130000	24898	12363	1	0	14887
356457	1678	26640839970000	24898	12363	1	0	0
356458	1874	27568000	24898	12363	2	0	2
7194	1394	751692228500000	24898	12363	7	0	0
189281	1397	1289945129000	24901	12364	0	0	14888
356472	1874	27580000	24901	12364	2	0	2
189287	2134	85249049000	24902	12365	2	0	5325
356478	1874	27590000	24902	12365	4	0	2
25515	1610	8640187999950	24902	12365	7	0	11
189302	2134	85247043000	24905	12366	2	0	5327
356492	1678	26640839975000	24906	12367	0	0	0
189318	1397	1289895124000	24910	12368	0	0	14893
189319	2133	91828298000	24910	12368	1	0	4853
356509	1874	27608000	24910	12368	2	0	2
54284	1724	10494711500000	24914	12369	3	0	13
189344	2133	91826294000	24918	12370	1	0	4855
356534	1874	27616000	24918	12370	2	0	2
30455	1656	12955496999990	24918	12370	5	0	8
29130	1637	297367152819988	24919	12371	3	0	0
189350	1397	1289855120000	24920	12372	0	0	14897
356539	1678	26640839980000	24920	12372	0	0	0
189355	2134	85240022000	24921	12373	2	0	5334
356545	1874	27635000	24921	12373	3	0	2
189371	1397	1289815116000	24925	12375	2	0	14901
356561	1874	27643000	24925	12375	3	0	2
189526	1397	1289805115000	24932	12376	0	0	14902
356714	1678	26640839985000	24932	12376	0	0	0
189527	2134	85236010000	24932	12376	1	0	5338
356715	1874	27653000	24932	12376	1	0	2
189569	1397	1289785113000	24937	12378	0	0	14904
356757	1678	26640839987000	24937	12378	0	0	0
356758	1874	27664000	24937	12378	1	0	2
189575	2132	147521534000	24938	12379	3	0	1467
356764	1678	26640839989000	24940	12380	0	0	0
189580	2133	91815272000	24940	12380	4	0	4866
189588	1397	1289745109000	24945	12381	0	0	14908
356776	1678	26640839991000	24945	12381	0	0	0
189589	2133	91813268000	24945	12381	1	0	4868
356781	1874	27691000	24947	12382	2	0	2
189598	1397	1289725107000	24952	12383	0	0	14910
356819	1874	27700000	24955	12384	1	0	2
59343	2039	12859579000000	24955	12384	3	0	6
189633	1397	1289705105000	24956	12385	0	0	14912
58770	1991	9981356355805	24956	12385	5	0	21
356837	1678	26640839996000	24961	12386	0	0	0
189650	2133	91808258000	24961	12386	1	0	4873
356842	1950	14438851000000	24962	12387	2	0	14
189656	2134	85222971000	24962	12387	4	0	5351
13605	1447	17561851683000	24962	12387	9	0	10
356856	1678	26640839999000	24964	12388	0	0	0
189670	2134	85221968000	24964	12388	2	0	5352
356862	1678	26640840001000	24966	12390	0	0	0
189675	1397	1289635098000	24966	12390	1	0	14919
356865	1874	27737000	24966	12390	3	0	2
356866	1874	27738000	24966	12390	4	0	2
189681	2134	85219962000	24966	12390	7	0	5354
356872	1678	26640840004000	24967	12391	0	0	0
189690	1397	1289605095000	24969	12392	0	0	14922
356881	1874	27762000	24969	12392	3	0	2
40439	1685	162004006571430	24969	12392	5	0	0
189695	2133	91798238000	24970	12393	1	0	4883
356890	1874	27767000	24973	12394	2	0	2
189705	2133	91797236000	24973	12394	5	0	4884
189724	1397	1289565091000	24976	12395	0	0	14926
356912	1678	26640840009000	24976	12395	0	0	0
189725	2134	85211938000	24976	12395	1	0	5362
53959	1723	11522082085979	24976	12395	3	0	12
7200	1394	756012273440200	24978	12396	3	0	0
356927	1678	26640840011000	24981	12397	0	0	0
189740	2133	91793228000	24981	12397	1	0	4888
59692	2087	2595398147766	24981	12397	3	0	3
356932	1874	27796000	24982	12398	3	0	2
189759	1397	1289525087000	24986	12399	0	0	14930
356951	1874	27801000	24986	12399	4	0	2
189764	2133	91790222000	24986	12399	5	0	4891
356957	1874	27815000	24986	12399	10	0	2
189916	1397	1289495084000	24990	12400	0	0	14933
357104	1678	26640840016000	24990	12400	0	0	0
189917	1397	1289485083000	24990	12400	1	0	14934
357105	1678	26640840017000	24990	12400	1	0	0
189923	2134	85204917000	24990	12400	7	0	5369
357111	1874	27825000	24990	12400	7	0	2
189966	1397	1289455080000	24997	12402	0	0	14937
357153	1678	26640840020000	24997	12402	0	0	0
357154	1678	26640840021000	24997	12402	1	0	0
189971	2133	91784210000	24997	12402	5	0	4897
357164	1678	26640840023000	24999	12403	1	0	0
189982	2133	91781204000	24999	12403	4	0	4900
357170	1874	27856000	24999	12403	7	0	2
22800	1588	14401822000000	24999	12403	9	0	12
190001	1397	1289405075000	25002	12404	0	0	14942
190002	2132	147510523000	25002	12404	1	0	1478
21942	1571	7820628124154	25002	12404	4	0	47
357202	1678	26640840027000	25006	12405	1	0	0
190021	2133	91778198000	25006	12405	4	0	4903
357211	1874	27864000	25008	12406	1	0	2
32849	1675	13964340999977	25008	12406	4	0	8
190030	1397	1289365071000	25009	12407	0	0	14946
26093	1613	11377361200000	25010	12408	3	0	10
357217	1678	26640840031000	25011	12409	0	0	0
190035	2133	91773188000	25011	12409	1	0	4908
58413	1855	200004980	25012	12410	5	1	0
27062	1623	71283180898598	25012	12410	6	0	1
357224	1678	26640840033000	25014	12411	0	0	0
46	42	72140637000000	25014	12411	3	0	12
60332	2148	6480122880750	25017	12412	0	0	2
190047	1397	1289315066000	25019	12413	0	0	14951
357234	1874	27878000	25019	12413	4	0	2
190053	2133	91769180000	25019	12413	6	0	4912
357256	1678	26640840038000	25022	12414	1	0	0
190074	2133	91766174000	25022	12414	2	0	4915
24322	1601	4705835620000	25022	12414	5	0	21
357268	1874	27891000	25027	12416	1	0	2
190087	2133	91764170000	25028	12417	1	0	4917
357273	1874	27895000	25029	12418	2	0	2
357274	1874	27897000	25029	12418	3	0	2
7207	1394	758892318440200	25029	12418	6	0	0
190098	1397	1289215056000	25031	12419	0	0	14961
357290	1678	26640840045000	25035	12421	0	0	0
190108	1397	1289195054000	25035	12421	1	0	14963
7209	1394	760332329440200	25037	12422	3	0	0
190150	1397	1289175052000	25042	12423	0	0	14965
190151	1397	1289165051000	25042	12423	1	0	14966
357332	1678	26640840049000	25042	12423	1	0	0
357337	1678	26640840050000	25043	12424	0	0	0
190157	1397	1289145049000	25043	12424	1	0	14968
14673	1457	11520198800000	25043	12424	5	0	8
357343	1874	27917000	25044	12425	1	0	2
190163	2133	91753148000	25044	12425	2	0	4928
23593	1594	14401840000000	25044	12425	4	0	10
190169	1397	1289105045000	25048	12428	0	0	14972
357350	1678	26640840055000	25048	12428	0	0	0
357357	1874	27928000	25051	12430	1	0	2
190177	2133	91748138000	25051	12430	2	0	4933
357367	1874	27935000	25055	12432	2	0	2
190187	2133	91745132000	25055	12432	3	0	4936
9431	1395	58246471074957278	25055	12432	5	0	0
190192	2134	85197896000	25056	12433	4	0	5376
357373	1874	27941000	25056	12433	4	0	2
357378	1874	27950000	25057	12434	1	0	2
190198	2133	91741124000	25057	12434	2	0	4940
59000	1992	10081019990000	25057	12434	3	0	5
357388	1678	26640840065000	25060	12436	0	0	0
190208	2133	91739120000	25060	12436	1	0	4942
190219	1397	1288985033000	25064	12438	0	0	14984
357400	1678	26640840067000	25064	12438	0	0	0
357405	1874	27977000	25065	12439	2	0	2
190225	2133	91736114000	25065	12439	3	0	4945
44544	1690	170645611000000	25065	12439	5	0	0
357409	1874	27984000	25066	12440	2	0	2
357410	1678	26640840070000	25067	12441	0	0	0
190231	2134	85189872000	25067	12441	2	0	5384
7210	1394	761772329440200	25067	12441	3	0	0
357416	1874	27992000	25068	12442	3	0	2
190236	2133	91732106000	25068	12442	4	0	4949
357422	1874	28005000	25069	12443	2	0	2
190249	2133	91730102000	25071	12444	0	0	4951
51244	1709	5760117000000	25071	12444	3	0	8
357441	1678	26640840075000	25073	12445	1	0	0
190262	2133	91728098000	25073	12445	3	0	4953
190265	2134	85183854000	25073	12445	6	0	5390
190269	1397	1288885023000	25075	12446	0	0	14994
357450	1678	26640840077000	25075	12446	0	0	0
190275	2132	147494507000	25076	12447	3	0	1494
357456	1874	28032000	25076	12447	3	0	2
357476	1874	28036000	25081	12449	2	0	2
190296	2133	91723088000	25081	12449	3	0	4958
190301	1397	1288835018000	25082	12450	0	0	14999
357482	1678	26640840082000	25082	12450	0	0	0
20056	1549	11231371000000	25083	12451	3	0	10
190307	1397	1288815016000	25084	12452	0	0	15001
357488	1678	26640840084000	25084	12452	0	0	0
357493	1874	28064000	25084	12452	5	0	2
190313	2134	85173824000	25084	12452	6	0	5400
190318	2133	91718078000	25084	12452	11	0	4963
357499	1874	28077000	25084	12452	11	0	2
190349	1397	1288765011000	25089	12454	0	0	15006
357530	1678	26640840089000	25089	12454	0	0	0
357535	1874	28095000	25089	12454	5	0	2
190358	1397	1288745009000	25091	12455	0	0	15008
47184	1694	14219011197225	25091	12455	5	0	62
357560	1678	26640840092000	25097	12456	0	0	0
190380	2133	91712066000	25097	12456	1	0	4969
357561	1874	28103000	25097	12456	1	0	2
190452	1397	1288715006000	25107	12458	0	0	15011
190453	1397	1288705005000	25107	12458	1	0	15012
357634	1678	26640840095000	25107	12458	1	0	0
190459	2133	91709060000	25107	12458	7	0	4972
357640	1874	28122000	25107	12458	7	0	2
357664	1874	28132000	25110	12459	2	0	2
190484	1397	1288675002000	25111	12460	0	0	15015
190489	2133	91705052000	25112	12461	1	0	4976
357670	1874	28140000	25112	12461	1	0	2
190498	2132	147487500000	25115	12463	1	0	1501
357679	1874	28152000	25115	12463	1	0	2
357681	1678	26640840101000	25116	12464	0	0	0
357682	1678	26640840102000	25116	12464	1	0	0
190504	2134	85156773000	25116	12464	4	0	5417
190654	1397	1288624997000	25123	12465	0	0	15020
357835	1678	26640840103000	25123	12465	0	0	0
190655	2134	85155770000	25123	12465	1	0	5418
357836	1874	28167000	25123	12465	1	0	2
190665	1397	1288604995000	25126	12467	0	0	15022
357846	1678	26640840105000	25126	12467	0	0	0
190671	1397	1288584993000	25128	12469	0	0	15024
357852	1678	26640840107000	25128	12469	0	0	0
190673	2134	85151758000	25128	12469	2	0	5422
190674	2132	147485498000	25128	12469	3	0	1503
357857	1874	28194000	25129	12470	1	0	2
24049	1599	11096858097983	25129	12470	3	0	8
190697	2134	85149752000	25133	12471	2	0	5424
357880	1874	28203000	25133	12471	4	0	2
190720	2134	85147746000	25137	12472	1	0	5426
51578	1710	11754034664140	25137	12472	4	0	10
357912	1678	26640840112000	25141	12473	0	0	0
60519	2248	10799522000000	25141	12473	4	0	0
190734	1397	1288524987000	25142	12474	0	0	15030
357917	1874	28222000	25142	12474	2	0	2
42624	1688	61919074720020	25142	12474	3	0	57
190743	2132	147483496000	25144	12475	3	0	1505
357926	1678	26640840115000	25145	12476	0	0	0
23739	1596	5040130000000	25145	12476	1	0	16
190752	2133	91687016000	25147	12477	1	0	4994
21168	1560	14408818131803	25147	12477	4	0	30
357938	1678	26640840117000	25149	12478	0	0	0
190760	2119	190000000	25149	12478	3	0	10
190811	1397	1288474982000	25153	12479	0	0	15035
357992	1678	26640840118000	25153	12479	0	0	0
190812	2288	774754211465	25153	12479	1	0	2
357993	2320	1000000000	25153	12479	1	0	0
190818	2134	85139722000	25154	12480	3	0	5434
357999	1874	28254000	25154	12480	3	0	2
44554	1690	172805650000000	25154	12480	5	0	0
190824	2026	75199000000	25155	12481	5	0	1
358005	1540	0	25155	12481	5	0	6
31794	1671	11184150003785	25155	12481	7	0	8
7222	1394	766092366440200	25159	12482	3	0	0
190861	2320	775741211465	25161	12483	1	0	2
358042	1600	0	25161	12483	1	0	0
26440	1622	4643925800048	25161	12483	4	0	10
59524	2086	2160367300069	25163	12484	4	0	3
190885	1397	1288414976000	25167	12485	0	0	15041
358066	1678	26640840124000	25167	12485	0	0	0
51883	1711	13386951000000	25167	12485	4	0	13
52153	1714	11085636171760	25171	12486	3	0	11
190901	1397	1288404975000	25172	12487	0	0	15042
358082	1678	26640840125000	25172	12487	0	0	0
190906	2133	91675994000	25173	12488	1	0	5005
358087	1874	28293000	25173	12488	1	0	2
358089	1874	28297000	25173	12488	3	0	2
358090	1678	26640840128000	25174	12489	0	0	0
190912	1397	1288364971000	25175	12490	0	0	15046
358096	1678	26640840130000	25176	12491	0	0	0
190918	2133	91672988000	25176	12491	3	0	5008
358102	1874	28318000	25177	12492	2	0	2
10260	1402	30423015145435	25177	12492	3	0	66
190923	2133	91670984000	25178	12493	1	0	5010
358107	1874	28326000	25179	12494	1	0	2
190969	1397	1288314966000	25185	12495	0	0	15051
190970	1397	1288304965000	25185	12495	1	0	15052
358154	1874	28332000	25185	12495	4	0	2
190976	2134	85124677000	25185	12495	7	0	5449
358160	1874	28344000	25185	12495	10	0	2
191018	2132	147476489000	25190	12496	2	0	1512
358201	1069	910373894650000	25190	12496	4	0	0
191027	1759	8137245139889	25192	12497	2	0	11
7228	1394	768972404440200	25192	12497	6	0	0
358219	2317	777595211465	25195	12498	0	0	1
191041	2133	91663970000	25195	12498	3	0	5017
358225	1874	28362000	25196	12499	2	0	2
358226	1874	28365000	25196	12499	3	0	2
191047	2133	91661966000	25196	12499	5	0	5019
358232	1874	28374000	25197	12500	1	0	2
191052	2133	91660964000	25197	12500	2	0	5020
191199	1397	1288224957000	25203	12501	0	0	15060
358380	1678	26640840143000	25203	12501	0	0	0
191200	1397	1288214956000	25203	12501	1	0	15061
358381	1678	26640840144000	25203	12501	1	0	0
191206	1397	1288204955000	25204	12502	0	0	15062
358387	1678	26640840145000	25204	12502	0	0	0
191212	2134	85111638000	25206	12503	3	0	5462
358393	1874	28398000	25206	12503	3	0	2
54313	1724	11934760500000	25206	12503	8	0	13
191217	1397	1288164951000	25207	12504	1	0	15066
358398	1678	26640840149000	25207	12504	1	0	0
191218	2133	91654952000	25207	12504	2	0	5026
23137	1593	12912715000000	25207	12504	7	0	8
191233	2133	91652948000	25211	12505	1	0	5028
358413	1874	28415000	25211	12505	1	0	2
4038	610	66720012000000	25211	12505	4	0	0
191242	1397	1288134948000	25214	12507	0	0	15069
358422	1678	26640840152000	25214	12507	0	0	0
191247	2133	91649942000	25215	12508	2	0	5031
358427	1874	28434000	25215	12508	2	0	2
191253	1764	14070457100000	25216	12509	5	0	11
358433	1334	1709415637751650	25216	12509	5	0	0
52371	1715	7223533663945	25216	12509	7	0	16
191266	2133	91646936000	25220	12511	1	0	5034
358446	1874	28447000	25220	12511	1	0	2
40445	1685	164164056571430	25220	12511	4	0	0
191275	2134	85101608000	25222	12512	3	0	5472
358455	1874	28456000	25222	12512	3	0	2
25799	1611	5522386241757	25225	12513	2	0	13
191302	2134	85099602000	25229	12514	4	0	5474
358482	1874	28466000	25229	12514	4	0	2
191315	1397	1288044939000	25233	12516	0	0	15078
358495	1678	26640840161000	25233	12516	0	0	0
358497	1874	28474000	25233	12516	2	0	2
358498	1874	28477000	25233	12516	3	0	2
7233	1394	773292330440200	25237	12517	0	0	0
191343	1397	1288034938000	25240	12518	0	0	15079
358527	1874	28484000	25240	12518	4	0	2
191349	1749	8444585529980	25240	12518	6	0	22
191353	2132	147468481000	25241	12519	2	0	1520
358533	1874	28491000	25241	12519	2	0	2
191354	2133	91638920000	25241	12519	3	0	5042
358662	1678	26640840166000	25244	12521	0	0	0
358663	1678	26640840167000	25244	12521	1	0	0
191485	2132	147467480000	25244	12521	2	0	1521
191489	2133	91635914000	25244	12521	6	0	5045
191511	1397	1287974932000	25248	12522	0	0	15085
358690	1678	26640840168000	25248	12522	0	0	0
9446	1395	58248631112957278	25248	12522	4	0	0
191517	2133	91633910000	25249	12523	3	0	5047
358696	1874	28519000	25249	12523	3	0	2
358701	1874	28527000	25250	12524	2	0	2
191523	2134	85086563000	25250	12524	3	0	5487
7239	1394	777612392440200	25250	12524	8	0	0
191528	2133	91629902000	25251	12525	1	0	5051
358707	1874	28537000	25251	12525	1	0	2
191544	2134	85084557000	25253	12526	4	0	5489
358723	1874	28544000	25253	12526	4	0	2
358728	1874	28556000	25253	12526	9	0	2
191550	1397	1287884923000	25254	12527	0	0	15094
191559	2134	85080545000	25256	12528	1	0	5493
358738	1874	28565000	25256	12528	1	0	2
191565	2133	91622888000	25258	12530	1	0	5058
358744	1874	28574000	25258	12530	1	0	2
358765	1874	28583000	25263	12531	3	0	2
191587	1397	1287834918000	25264	12532	0	0	15099
358785	1678	26640840183000	25266	12533	0	0	0
358786	1678	26640840184000	25266	12533	1	0	0
191609	1397	1287794914000	25266	12533	3	0	15103
358792	1874	28590000	25266	12533	7	0	2
191615	2133	91618880000	25266	12533	9	0	5062
358798	1874	28605000	25266	12533	13	0	2
191621	2134	85071518000	25266	12533	15	0	5502
358803	1678	26640840189000	25267	12534	1	0	0
191625	2134	85070515000	25267	12534	2	0	5503
191626	2133	91615874000	25267	12534	3	0	5065
358816	1678	26640840191000	25269	12535	1	0	0
191639	2134	85068509000	25269	12535	3	0	5505
358938	1678	26640840192000	25272	12536	0	0	0
358939	1874	28637000	25272	12536	1	0	2
191761	2133	91611866000	25272	12536	2	0	5069
191762	1397	1287724907000	25273	12537	0	0	15110
27069	1623	72723206898598	25273	12537	4	0	1
358945	1874	28646000	25274	12538	1	0	2
191768	2132	147459472000	25274	12538	3	0	1529
15136	1458	20105443908540	25274	12538	5	0	8
358967	1874	28656000	25278	12539	3	0	2
191790	2133	91607858000	25278	12539	5	0	5073
358978	1874	28665000	25280	12540	2	0	2
22529	1587	10800348000000	25280	12540	4	0	14
191805	1397	1287674902000	25282	12541	0	0	15115
44562	1690	174965736000000	25282	12541	4	0	0
359000	1678	26640840200000	25285	12542	1	0	0
191823	2133	91604852000	25285	12542	3	0	5076
359006	1874	28682000	25286	12543	1	0	2
191829	2134	85057476000	25286	12543	3	0	5516
359011	1874	28692000	25287	12544	2	0	2
35525	1679	30959476653000	25287	12544	4	0	75
191837	2134	85055470000	25289	12545	1	0	5518
10278	1402	31863053145435	25289	12545	3	0	66
191965	1397	1287624897000	25292	12546	0	0	15120
359144	1678	26640840203000	25292	12546	0	0	0
191966	2133	91599842000	25292	12546	1	0	5081
359145	1874	28699000	25292	12546	1	0	2
191972	1397	1287604895000	25294	12548	0	0	15122
359151	1678	26640840205000	25294	12548	0	0	0
191978	2134	85051458000	25295	12549	3	0	5522
359157	1874	28719000	25295	12549	3	0	2
359177	1678	26640840207000	25298	12550	0	0	0
359178	1874	28722000	25298	12550	1	0	2
17740	1509	12623281503835	25298	12550	3	0	9
192006	2134	85049452000	25300	12551	1	0	5524
359190	1874	28732000	25302	12552	1	0	2
192015	2133	91592828000	25303	12553	1	0	5088
4591	633	77229494900000	25303	12553	5	0	9
359196	1678	26640840211000	25304	12554	0	0	0
16044	1474	7830488000043	25304	12554	4	0	29
192021	1397	1287534888000	25305	12555	0	0	15129
359201	1874	28750000	25305	12555	2	0	2
9453	1395	58250791136957278	25306	12556	2	0	0
192026	1397	1287524887000	25308	12557	0	0	15130
192044	1397	1287504885000	25315	12558	0	0	15132
359222	1678	26640840215000	25315	12558	0	0	0
192045	2134	85042431000	25315	12558	1	0	5531
359243	1874	28769000	25319	12559	1	0	2
192066	2133	91586816000	25319	12559	2	0	5094
359256	1678	26640840219000	25323	12560	2	0	0
192080	2133	91584812000	25323	12560	4	0	5096
359262	1874	28787000	25323	12560	8	0	2
7245	1394	781932453440200	25323	12560	10	0	0
192085	1397	1287454880000	25324	12561	0	0	15137
359268	1874	28796000	25324	12561	5	0	2
192091	2133	91582808000	25324	12561	6	0	5098
359283	1678	26640840223000	25326	12562	0	0	0
192107	2132	147450463000	25326	12562	2	0	1538
359297	1874	28811000	25329	12563	3	0	2
192123	1397	1287404875000	25331	12564	0	0	15142
359325	2321	11000000000	25336	12565	0	0	0
359326	1678	26640840226000	25336	12565	1	0	0
192150	2134	85032401000	25336	12565	3	0	5541
359332	1874	28827000	25336	12565	7	0	2
192162	2134	85030395000	25339	12566	1	0	5543
192177	222	66681879919853	25344	12567	0	0	3
192178	1397	1287364871000	25344	12567	1	0	15146
359357	1678	26640840230000	25344	12567	2	0	0
192184	2133	91572788000	25344	12567	7	0	5108
359362	1874	28843000	25344	12567	7	0	2
192199	2133	91570784000	25348	12569	4	0	5110
359377	1874	28850000	25348	12569	4	0	2
29235	1643	1868524914700	25348	12569	6	0	25
192217	1397	1287314866000	25354	12571	2	0	15151
359396	1874	28856000	25354	12571	3	0	2
192231	2133	91567778000	25358	12572	1	0	5113
359409	1874	28866000	25358	12572	1	0	2
40452	1685	166324091571430	25358	12572	4	0	0
192237	1397	1287284863000	25360	12574	0	0	15154
359415	1678	26640840237000	25360	12574	0	0	0
192242	2134	85021368000	25360	12574	5	0	5552
359421	1874	28883000	25360	12574	6	0	2
192252	2132	147445458000	25362	12575	1	0	1543
359430	1874	28891000	25362	12575	1	0	2
11382	1419	22606154559750	25362	12575	5	0	8
57987	1807	200000007	25362	12575	6	0	0
192258	2133	91560764000	25363	12576	3	0	5120
359436	1874	28900000	25363	12576	3	0	2
7254	1394	786252614440200	25363	12576	6	0	0
359455	1678	26640840243000	25368	12577	0	0	0
359456	1874	28907000	25368	12577	1	0	2
192279	2133	91559762000	25368	12577	2	0	5121
24068	1599	12536897097983	25368	12577	5	0	8
359462	1874	28917000	25369	12578	3	0	2
57728	1768	17026997110000	25369	12578	5	0	10
192288	1397	1287204855000	25371	12579	0	0	15162
24363	1601	6145859620000	25371	12579	4	0	21
359471	1874	28927000	25372	12580	2	0	2
192297	222	66178879919853	25374	12581	0	0	8
359479	1874	28933000	25374	12581	4	0	2
42679	1688	64079124720020	25374	12581	5	0	57
192315	1397	1287174852000	25376	12582	0	0	15165
192316	2133	91554752000	25376	12582	1	0	5126
359512	1874	28943000	25382	12583	2	0	2
192339	2132	147442455000	25384	12584	1	0	1546
359533	1874	28952000	25390	12585	1	0	2
192363	2132	147441454000	25393	12586	0	0	1547
359551	1678	26640840252000	25395	12587	0	0	0
192375	1397	1287114846000	25395	12587	2	0	15171
359557	1874	28970000	25395	12587	6	0	2
192391	1397	1287094844000	25399	12588	1	0	15173
359573	1874	28976000	25399	12588	5	0	2
2560	470	76800310000000	25399	12588	6	0	11
359597	2321	654500000000	25403	12589	0	0	0
192420	1397	1287084843000	25403	12589	1	0	15174
359598	1678	26640840257000	25403	12589	1	0	0
192425	2133	91545734000	25403	12589	6	0	5135
192444	222	66002679919853	25406	12590	0	0	10
359622	2321	710000000000	25406	12590	0	0	0
192445	1397	1287074842000	25406	12590	1	0	15175
359628	1874	28992000	25406	12590	6	0	2
192451	2133	91543730000	25406	12590	7	0	5137
359633	1678	26640840261000	25407	12591	0	0	0
192457	2134	84997296000	25407	12591	2	0	5576
7262	1394	790572787440200	25407	12591	3	0	0
359639	1678	26640840263000	25409	12593	0	0	0
192462	2133	91539722000	25409	12593	1	0	5141
359661	1678	26640840265000	25416	12595	1	0	0
192484	2134	84993284000	25416	12595	2	0	5580
12541	1439	10783769578477	25416	12595	3	0	10
359681	1874	29031000	25420	12596	3	0	2
192508	1397	1286984833000	25422	12597	0	0	15184
359692	1678	26640840268000	25424	12598	0	0	0
192515	2133	91534712000	25424	12598	1	0	5146
45003	1692	3340677619999	25425	12599	4	0	6
359713	1678	26640840270000	25429	12600	0	0	0
192536	1397	1286944829000	25429	12600	1	0	15188
359718	1874	29059000	25429	12600	5	0	2
192556	1397	1286934828000	25432	12601	0	0	15189
359734	1678	26640840272000	25432	12601	0	0	0
359735	1874	29063000	25432	12601	1	0	2
192561	2134	84985260000	25433	12602	2	0	5588
32882	1675	16124402999977	25433	12602	5	0	8
359741	1678	26640840274000	25434	12603	0	0	0
9466	1395	58252951142957278	25434	12603	3	0	0
192581	1397	1286904825000	25441	12604	0	0	15192
192582	2133	91527698000	25441	12604	1	0	5153
359768	1678	26640840276000	25444	12605	0	0	0
192602	2134	84981248000	25447	12606	2	0	5592
359781	1874	29090000	25447	12606	3	0	2
60090	2112	20686906101924	25447	12606	5	0	7
192613	2134	84980245000	25449	12607	3	0	5593
359792	1483	11000000	25449	12607	4	0	0
192621	2132	147433446000	25451	12608	1	0	1555
359801	1874	29108000	25451	12608	3	0	2
16695	1489	9023067040000	25451	12608	4	0	10
192638	2321	709899000000	25457	12610	0	0	2
359817	1678	26640840282000	25457	12610	1	0	0
192648	2134	84975230000	25461	12611	2	0	5598
359827	1874	29124000	25461	12611	3	0	2
39317	1684	20163313819412	25461	12611	5	0	136
192657	2133	91517678000	25463	12612	3	0	5163
359837	1874	29134000	25463	12612	5	0	2
19821	1547	10074816000000	25465	12613	4	0	12
192666	1397	1286784813000	25466	12614	0	0	15204
359845	1874	29141000	25466	12614	1	0	2
192675	2133	91514672000	25468	12615	2	0	5166
42729	1688	66239262720020	25468	12615	3	0	57
359862	1678	26640840289000	25472	12616	0	0	0
359863	1874	29153000	25472	12616	1	0	2
40458	1685	167764227571430	25476	12617	1	0	0
192700	2133	91512668000	25476	12617	2	0	5168
359885	1678	26640840291000	25478	12618	0	0	0
19077	1536	15840314000000	25478	12618	3	0	11
192710	1397	1286734808000	25479	12619	0	0	15209
192716	1397	1286724807000	25481	12620	0	0	15210
359894	1678	26640840293000	25481	12620	0	0	0
192717	2133	91509662000	25481	12620	1	0	5171
13148	1444	10887831329999	25481	12620	4	0	12
359903	1874	29180000	25484	12621	2	0	2
192730	2134	84963194000	25486	12622	1	0	5610
359912	1874	29190000	25487	12623	2	0	2
192740	2134	84961188000	25490	12624	1	0	5612
359928	1874	29197000	25493	12625	2	0	2
192751	2134	84960185000	25493	12625	3	0	5613
359948	1874	29208000	25498	12626	1	0	2
11814	1422	12474695804270	25498	12626	3	0	12
192775	1397	1286644799000	25500	12627	0	0	15218
359957	1874	29217000	25501	12628	1	0	2
192781	1397	1286624797000	25502	12629	0	0	15220
59359	2039	14299615000000	25502	12629	4	0	6
359963	1874	29227000	25503	12630	1	0	2
192786	2134	84954167000	25503	12630	2	0	5619
49791	1703	4320886000000	25503	12630	4	0	5
359980	1678	26640840306000	25509	12632	0	0	0
192804	2133	91496636000	25509	12632	2	0	5184
7276	1394	794892923440200	25511	12633	3	0	0
360007	1678	26640840308000	25518	12634	0	0	0
360008	1874	29248000	25518	12634	1	0	2
192831	2133	91494632000	25518	12634	2	0	5186
40466	1685	169924254571430	25518	12634	4	0	0
16432	1476	12240244000000	25522	12635	2	0	11
192845	2133	91492628000	25523	12636	3	0	5188
360023	1874	29254000	25523	12636	3	0	2
31075	1668	10593722000000	25523	12636	8	0	9
192852	1397	1286534788000	25525	12637	0	0	15229
192853	2134	84947146000	25525	12637	1	0	5626
360032	1874	29267000	25525	12637	2	0	2
192874	2134	84945140000	25530	12638	4	0	5628
360052	1874	29273000	25530	12638	4	0	2
41134	1687	7328972848312	25530	12638	10	0	7
192880	2134	84943134000	25531	12639	1	0	5630
360058	1874	29285000	25531	12639	1	0	2
53072	1717	14941287000055	25532	12640	4	0	8
192888	1397	1286474782000	25534	12641	0	0	15235
360067	1874	29295000	25534	12641	1	0	2
192897	1397	1286454780000	25537	12643	0	0	15237
360075	1678	26640840320000	25537	12643	0	0	0
192907	1397	1286434778000	25540	12644	0	0	15239
360085	1678	26640840322000	25540	12644	0	0	0
55514	1741	719000000000	25540	12644	2	0	0
192912	2134	84936113000	25541	12645	3	0	5637
360091	1874	29325000	25541	12645	4	0	2
192920	2134	84934107000	25544	12646	4	0	5639
360098	1874	29332000	25544	12646	4	0	2
192926	2134	84931098000	25546	12648	1	0	5642
360104	1874	29343000	25546	12648	1	0	2
192931	2134	84930095000	25548	12649	3	0	5643
360110	1874	29351000	25548	12649	4	0	2
26460	1622	6803964800048	25549	12650	1	0	10
192937	1397	1286344769000	25550	12651	0	0	15248
360115	1678	26640840331000	25550	12651	0	0	0
20519	1555	13206137540449	25550	12651	4	0	8
193018	1397	1286334768000	25552	12652	0	0	15249
360196	1678	26640840332000	25552	12652	0	0	0
193019	2134	84926083000	25552	12652	1	0	5647
360197	1874	29368000	25552	12652	1	0	2
193031	2134	84924077000	25555	12653	4	0	5649
360209	1874	29378000	25555	12653	4	0	2
193158	1397	1286304765000	25557	12654	0	0	15252
360336	1678	26640840335000	25557	12654	0	0	0
193159	2134	84923074000	25557	12654	1	0	5650
360337	1874	29383000	25557	12654	1	0	2
193165	2133	91466576000	25558	12655	4	0	5214
360343	1874	29393000	25558	12655	4	0	2
3397	576	76877618726897	25558	12655	6	0	9
193183	1397	1286254760000	25565	12657	1	0	15257
360361	1678	26640840340000	25565	12657	1	0	0
193188	2134	84919062000	25565	12657	6	0	5654
360366	1874	29409000	25565	12657	6	0	2
24779	1602	11376634170000	25565	12657	9	0	9
193212	2134	84915050000	25568	12658	3	0	5658
360390	1874	29421000	25568	12658	3	0	2
193218	1397	1286204755000	25570	12660	0	0	15262
360396	1678	26640840345000	25570	12660	0	0	0
193260	1397	1286174752000	25576	12661	0	0	15265
360438	1678	26640840348000	25576	12661	0	0	0
193261	1397	1286164751000	25576	12661	1	0	15266
360439	1678	26640840349000	25576	12661	1	0	0
193267	2134	84911038000	25576	12661	7	0	5662
360445	1874	29443000	25576	12661	7	0	2
193273	2134	84909032000	25576	12661	13	0	5664
360451	1874	29457000	25576	12661	13	0	2
7283	1394	797772959440200	25577	12662	4	0	0
193287	1397	1286134748000	25583	12663	0	0	15269
360465	1678	26640840352000	25583	12663	0	0	0
193308	1397	1286094744000	25588	12664	3	0	15273
360486	1678	26640840356000	25588	12664	3	0	0
193314	2133	91448540000	25588	12664	9	0	5232
360492	1874	29486000	25588	12664	9	0	2
60868	2306	2159096000000	25588	12664	13	0	0
193322	2134	84901008000	25590	12665	2	0	5672
360500	1874	29495000	25590	12665	2	0	2
193328	2133	91443530000	25592	12667	3	0	5237
360506	1874	29505000	25592	12667	3	0	2
193338	2133	91441526000	25599	12669	2	0	5239
360516	1874	29515000	25599	12669	2	0	2
44570	1690	177125760000000	25599	12669	3	0	0
193343	2133	91439522000	25600	12670	4	0	5241
360521	1874	29522000	25600	12670	4	0	2
193355	2134	84892984000	25602	12671	4	0	5680
360533	1874	29533000	25602	12671	4	0	2
360547	1678	26640840366000	25605	12672	0	0	0
360548	1678	26640840367000	25605	12672	1	0	0
193373	2133	91436516000	25605	12672	4	0	5244
55883	1747	2945998999992	25605	12672	7	0	6
360554	1874	29548000	25606	12673	1	0	2
193378	1397	1285964731000	25608	12674	0	0	15286
193393	1397	1285944729000	25611	12675	0	0	15288
360571	1678	26640840371000	25611	12675	0	0	0
193394	2134	84886966000	25611	12675	1	0	5686
15745	1471	14345437900000	25611	12675	6	0	8
360579	1678	26640840372000	25613	12676	0	0	0
193403	2134	84885963000	25613	12676	2	0	5687
31830	1671	13344198003785	25615	12677	4	0	8
360597	1678	26640840374000	25619	12678	0	0	0
193421	1159	615190749000000	25619	12678	2	0	1
360603	1874	29585000	25619	12678	6	0	2
193426	1397	1285894724000	25621	12679	0	0	15293
360608	1874	29592000	25621	12679	4	0	2
193432	2134	84879945000	25622	12680	0	0	5693
360630	1678	26640840380000	25625	12681	2	0	0
193454	2134	84877939000	25625	12681	4	0	5695
360636	1874	29613000	25625	12681	8	0	2
193459	2133	91421486000	25625	12681	9	0	5259
29147	1637	300247243819988	25625	12681	11	0	0
360661	1874	29621000	25628	12682	3	0	2
193485	2133	91419482000	25628	12682	5	0	5261
60347	2148	8640295880750	25628	12682	7	0	2
360667	1874	29630000	25629	12683	3	0	2
193491	1397	1285794714000	25630	12684	0	0	15303
360678	1678	26640840387000	25632	12685	0	0	0
360679	1678	26640840388000	25632	12685	1	0	0
193502	2134	84871921000	25632	12685	2	0	5701
50388	1705	20720932580140	25632	12685	7	0	25
360685	1678	26640840390000	25633	12686	1	0	0
193508	2134	84869915000	25633	12686	2	0	5703
360703	1678	26640840392000	25635	12687	1	0	0
193526	1397	1285724707000	25635	12687	2	0	15310
193529	2134	84867909000	25635	12687	5	0	5705
193530	2133	91410464000	25635	12687	6	0	5270
360708	1874	29664000	25635	12687	6	0	2
193542	1397	1285704705000	25638	12688	0	0	15312
360720	1678	26640840395000	25638	12688	0	0	0
45034	1692	5500714619999	25638	12688	4	0	6
193551	1397	1285684703000	25641	12690	0	0	15314
360729	1678	26640840397000	25641	12690	0	0	0
193685	1397	1285674702000	25645	12691	0	0	15315
360863	1678	26640840398000	25645	12691	0	0	0
193686	1397	1285664701000	25645	12691	1	0	15316
360864	1678	26640840399000	25645	12691	1	0	0
16056	1474	8550512000043	25645	12691	7	0	29
193692	1397	1285644699000	25646	12692	1	0	15318
360870	1678	26640840401000	25646	12692	1	0	0
9482	1395	58255111203957278	25646	12692	6	0	0
193698	2134	84856876000	25647	12693	1	0	5716
360876	1874	29715000	25647	12693	1	0	2
193716	2134	84855873000	25652	12694	3	0	5717
360894	1874	29722000	25652	12694	3	0	2
7293	1394	802092995440200	25655	12696	4	0	0
193735	1397	1285604695000	25658	12697	0	0	15322
360913	1678	26640840405000	25658	12697	0	0	0
193741	1397	1285584693000	25659	12698	0	0	15324
360919	1678	26640840407000	25659	12698	0	0	0
193746	2134	84849855000	25659	12698	5	0	5723
360924	1874	29750000	25659	12698	5	0	2
193752	2134	84848852000	25660	12699	4	0	5724
360930	1874	29755000	25660	12699	4	0	2
193758	2133	91390424000	25660	12699	10	0	5290
360936	1874	29770000	25660	12699	10	0	2
193763	2134	84844840000	25661	12700	3	0	5728
360941	1874	29777000	25661	12700	3	0	2
360949	1678	26640840415000	25664	12701	0	0	0
360950	1874	29785000	25664	12701	1	0	2
193776	1397	1285494684000	25666	12702	0	0	15333
360964	1874	29795000	25669	12703	1	0	2
193788	1397	1285474682000	25670	12704	0	0	15335
360975	1874	29805000	25673	12705	1	0	2
193798	2133	91382408000	25673	12705	2	0	5298
52189	1714	13245699171760	25673	12705	4	0	11
193805	1397	1285454680000	25676	12706	0	0	15337
193806	2134	84837819000	25676	12706	1	0	5735
361025	1678	26640840422000	25683	12707	1	0	0
193851	2133	91379402000	25683	12707	5	0	5301
361031	1874	29821000	25683	12707	7	0	2
10308	1402	34023114145435	25683	12707	11	0	66
193857	2133	91377398000	25684	12708	1	0	5303
35568	1679	33119512653000	25684	12708	4	0	75
361043	1678	26640840425000	25686	12709	0	0	0
193868	2133	91376396000	25686	12709	3	0	5304
361048	1874	29842000	25686	12709	5	0	2
46331	1693	4310966570272	25688	12710	3	0	1248
193880	2134	84830798000	25689	12711	1	0	5742
14047	1451	4027759000000	25689	12711	3	0	13
361063	1678	26640840429000	25691	12712	0	0	0
193889	2133	91371386000	25691	12712	4	0	5309
32108	1672	10081435000000	25691	12712	7	0	10
361069	1678	26640840431000	25692	12713	0	0	0
193894	2134	84827789000	25692	12713	3	0	5745
361074	1874	29866000	25692	12713	5	0	2
193900	2134	84825783000	25692	12713	9	0	5747
361085	1678	26640840434000	25695	12714	0	0	0
361086	1874	29877000	25695	12714	1	0	2
193916	2134	84823777000	25698	12715	3	0	5749
361102	1874	29887000	25701	12716	1	0	2
193933	2133	91364372000	25704	12717	2	0	5316
193941	1397	1285274662000	25707	12718	0	0	15355
193942	2134	84820768000	25707	12718	1	0	5752
361120	1874	29897000	25707	12718	1	0	2
50950	1708	9720586500051	25707	12718	4	0	8
361128	1874	29904000	25709	12719	3	0	2
193951	2133	91361366000	25709	12719	4	0	5319
361163	1678	26640840443000	25714	12720	2	0	0
193986	2133	91360364000	25714	12720	3	0	5320
193991	2133	91358360000	25714	12720	8	0	5322
361169	1874	29927000	25714	12720	8	0	2
361186	1874	29935000	25718	12722	1	0	2
194009	2133	91356356000	25718	12722	2	0	5324
12157	1426	12570391000000	25718	12722	4	0	8
361195	1874	29944000	25721	12724	1	0	2
194018	2134	84810738000	25721	12724	2	0	5762
194029	2133	91353350000	25723	12725	4	0	5327
361207	1874	29955000	25723	12725	4	0	2
9490	1395	58256551264957278	25724	12726	4	0	0
361212	1678	26640840451000	25725	12727	0	0	0
194035	2134	84806726000	25725	12727	1	0	5766
40480	1685	172084320571430	25725	12727	4	0	0
361217	1874	29969000	25726	12728	2	0	2
361218	1874	29971000	25726	12728	3	0	2
194041	2134	84805723000	25726	12728	4	0	5767
4946	641	78243885000000	25726	12728	6	0	16
45070	1692	7660762619999	25728	12729	4	0	6
194049	1397	1285104645000	25729	12730	0	0	15372
361227	1678	26640840455000	25729	12730	0	0	0
194055	2134	84801711000	25729	12730	6	0	5771
361233	1874	29992000	25729	12730	6	0	2
361244	1874	30002000	25732	12731	2	0	2
194067	1397	1285064641000	25733	12732	0	0	15376
194072	2133	91341326000	25734	12733	2	0	5339
361250	1874	30009000	25734	12733	2	0	2
194073	2133	91340324000	25734	12733	3	0	5340
194074	2134	84797699000	25734	12733	4	0	5775
361278	1874	30022000	25740	12734	2	0	2
194105	1769	1570700000	25740	12734	4	0	62
2026	369	78036575290830	25740	12734	6	0	16
361304	1874	30027000	25748	12736	2	0	2
194135	2134	84793687000	25748	12736	4	0	5779
761	58	73907404999641	25748	12736	5	0	12
361314	1874	30037000	25751	12738	1	0	2
194144	1769	1569700000	25751	12738	2	0	63
361326	1678	26640840468000	25755	12740	0	0	0
194156	2134	84790678000	25755	12740	1	0	5782
361343	1874	30054000	25759	12741	2	0	2
194180	2134	84788672000	25762	12742	1	0	5784
55611	1746	4128946999989	25762	12742	4	0	7
361356	1678	26640840471000	25764	12743	0	0	0
361357	1874	30061000	25764	12743	1	0	2
194196	1397	1284934628000	25769	12744	0	0	15389
361371	1874	30071000	25770	12745	1	0	2
3423	576	77597654726897	25770	12745	4	0	9
194214	1397	1284914626000	25773	12746	0	0	15391
194215	2133	91327298000	25773	12746	1	0	5353
5180	685	66720000000000	25773	12746	3	0	0
361389	1874	30082000	25774	12747	1	0	2
27074	1623	74883243898598	25774	12747	3	0	1
194221	1397	1284884623000	25775	12748	1	0	15394
361394	1874	30090000	25775	12748	3	0	2
194238	2134	84780648000	25778	12749	1	0	5792
361413	1678	26640840479000	25780	12750	0	0	0
194246	1397	1284854620000	25781	12751	0	0	15397
361419	1874	30109000	25781	12751	3	0	2
194252	1397	1284834618000	25782	12752	0	0	15399
361424	1874	30117000	25782	12752	2	0	2
194279	1397	1284814616000	25787	12753	0	0	15401
361451	1874	30129000	25787	12753	2	0	2
42778	1688	68399298720020	25787	12753	3	0	57
194284	610	67438023000000	25788	12754	2	0	1
361471	1874	30137000	25793	12755	2	0	2
361490	1678	26640840487000	25795	12756	0	0	0
194321	1397	1284774612000	25795	12756	1	0	15405
361491	1678	26640840488000	25795	12756	1	0	0
194327	2134	84770618000	25795	12756	7	0	5802
361497	1874	30145000	25795	12756	7	0	2
194332	2133	91313270000	25795	12756	12	0	5367
361503	1874	30160000	25795	12756	13	0	2
194344	2133	91309262000	25799	12757	1	0	5371
361514	1874	30166000	25799	12757	1	0	2
7305	1394	806413042440200	25799	12757	3	0	0
194347	1397	1284724607000	25801	12758	0	0	15410
194348	2134	84766606000	25801	12758	1	0	5806
361528	1874	30176000	25804	12759	2	0	2
10334	1402	36183151145435	25804	12759	4	0	66
194363	1397	1284694604000	25806	12760	1	0	15413
361537	1874	30186000	25806	12760	5	0	2
57757	1768	19187021110000	25806	12760	6	0	10
194375	685	66000011000000	25808	12761	1	0	1
361552	1678	26640840498000	25810	12762	0	0	0
194384	2133	91303250000	25810	12762	2	0	5377
361564	1678	26640840500000	25814	12764	0	0	0
194396	2134	84759585000	25814	12764	2	0	5813
361594	1678	26640840504000	25819	12766	3	0	0
194426	2134	84757579000	25819	12766	5	0	5815
361599	1874	30220000	25819	12766	8	0	2
194431	2133	91298240000	25819	12766	10	0	5382
361605	1678	26640840506000	25821	12768	0	0	0
194437	2133	91295234000	25821	12768	2	0	5385
361611	1874	30241000	25821	12768	6	0	2
361628	1678	26640840508000	25824	12769	0	0	0
194459	1397	1284564591000	25824	12769	1	0	15426
361629	1678	26640840509000	25824	12769	1	0	0
194464	2133	91292228000	25824	12769	6	0	5388
361635	1874	30253000	25824	12769	7	0	2
29858	1650	8032978000000	25826	12770	3	0	9
194473	1397	1284534588000	25827	12771	0	0	15429
361644	1874	30264000	25827	12771	1	0	2
194483	1397	1284524587000	25829	12772	0	0	15430
194484	1397	1284514586000	25829	12772	1	0	15431
361656	1874	30268000	25829	12772	3	0	2
194490	1397	1284504585000	25830	12773	0	0	15432
361662	1874	30281000	25830	12773	2	0	2
194499	547	66000009000000	25832	12774	3	0	2
16714	1489	10463105040000	25832	12774	5	0	10
361686	1874	30288000	25836	12775	1	0	2
194529	547	66000004000000	25840	12776	1	0	3
361700	1874	30296000	25840	12776	3	0	2
194547	2133	91282208000	25844	12777	3	0	5398
361718	1874	30303000	25845	12778	1	0	2
9501	1395	58258711300957278	25845	12778	3	0	0
194559	2134	84738522000	25849	12779	3	0	5834
361730	1874	30313000	25849	12779	5	0	2
3871	606	75406831286230	25849	12779	7	0	18
194564	1397	1284404575000	25850	12780	2	0	15442
361735	1874	30319000	25850	12780	4	0	2
194570	2133	91276196000	25850	12780	8	0	5404
361741	1678	26640840527000	25851	12781	1	0	0
194576	2134	84734510000	25851	12781	4	0	5838
361747	1874	30340000	25852	12782	1	0	2
194590	1397	1284364571000	25856	12783	0	0	15446
60773	2292	2159050000000	25856	12783	4	0	0
361767	1874	30351000	25859	12784	0	0	2
361776	1678	26640840530000	25861	12785	0	0	0
194610	1397	1284334568000	25861	12785	2	0	15449
361782	1874	30360000	25861	12785	6	0	2
194632	1397	1284324567000	25864	12786	0	0	15450
194633	2134	84727489000	25864	12786	1	0	5845
35595	1679	35279537653000	25864	12786	3	0	75
194760	1397	1284314566000	25866	12787	0	0	15451
361927	1678	26640840534000	25866	12787	0	0	0
194761	1397	1284304565000	25866	12787	1	0	15452
361928	1678	26640840535000	25866	12787	1	0	0
50700	1706	14682184450256	25866	12787	6	0	27
194767	2134	84724480000	25867	12788	1	0	5848
361934	1874	30381000	25867	12788	1	0	2
22561	1587	12960397000000	25867	12788	3	0	14
194810	2133	91264172000	25877	12789	4	0	5416
361977	1874	30391000	25877	12789	4	0	2
194821	2133	91262168000	25879	12790	3	0	5418
361988	1874	30395000	25879	12790	3	0	2
194831	2133	91258160000	25883	12792	1	0	5422
361998	1874	30403000	25883	12792	1	0	2
14419	1455	4351599000000	25883	12792	3	0	10
194847	1397	1284184553000	25889	12795	1	0	15464
362014	1678	26640840547000	25889	12795	1	0	0
44579	1690	179285685000000	25889	12795	4	0	0
194854	1397	1284164551000	25892	12797	0	0	15466
362021	1678	26640840549000	25892	12797	0	0	0
39356	1684	22323328819412	25892	12797	3	0	136
7318	1394	809293089440200	25894	12798	2	0	0
362038	1678	26640840551000	25896	12799	0	0	0
362039	1678	26640840552000	25896	12799	1	0	0
194873	1397	1284124547000	25896	12799	2	0	15470
362045	1874	30423000	25896	12799	7	0	2
194879	2133	91247138000	25896	12799	8	0	5433
10359	1402	38343199145435	25896	12799	11	0	66
194884	470	77519349000000	25898	12801	0	0	12
362051	2327	10000000	25898	12801	0	0	0
194895	1397	1284074542000	25902	12802	0	0	15475
194896	2133	91242128000	25902	12802	1	0	5438
362064	1678	26640840559000	25904	12803	0	0	0
194911	2133	91240124000	25907	12804	3	0	5440
362079	1874	30441000	25907	12804	4	0	2
194930	1397	1284014536000	25913	12806	0	0	15481
362098	1874	30447000	25913	12806	1	0	2
9511	1395	58260871346957278	25913	12806	3	0	0
194940	2133	91234112000	25916	12807	3	0	5446
362110	1678	26640840567000	25918	12808	0	0	0
194956	2133	91231106000	25924	12810	1	0	5449
27080	1623	77043278898598	25924	12810	3	0	1
362124	1678	26640840570000	25925	12811	0	0	0
194962	2133	91228100000	25925	12811	5	0	5452
7334	1394	815053134440200	25925	12811	6	0	0
362132	1678	26640840573000	25927	12812	0	0	0
194969	2133	91226096000	25928	12813	2	0	5454
362137	1874	30469000	25928	12813	3	0	2
194977	1678	26640830578000	25931	12815	2	0	1
362145	1874	30473000	25931	12815	3	0	2
42829	1688	70559333720020	25931	12815	5	0	57
194983	2133	91220084000	25932	12816	3	0	5460
362155	1678	26640830581000	25934	12817	0	0	1
47992	1696	17003752335104	25935	12818	2	0	9
194992	1397	1283824517000	25936	12819	0	0	15500
362160	1678	26640830584000	25936	12819	1	0	1
194998	1397	1283794514000	25937	12820	0	0	15503
362182	1678	26640830587000	25940	12821	0	0	1
362183	1678	26640830588000	25940	12821	1	0	1
195020	2133	91213070000	25940	12821	5	0	5467
57771	1768	20627113110000	25940	12821	7	0	10
362189	1874	30497000	25940	12821	8	0	2
195042	1397	1283744509000	25943	12822	0	0	15508
45096	1692	9820806619999	25943	12822	1	0	6
195053	1397	1283734508000	25948	12823	0	0	15509
362223	1874	30503000	25948	12823	3	0	2
18417	1521	2160069000000	25948	12823	5	0	7
195063	2133	91207058000	25952	12824	2	0	5473
22576	1587	14400455000000	25952	12824	5	0	14
362232	1678	26640830596000	25953	12825	0	0	1
195075	2133	91204052000	25956	12826	2	0	5476
362248	1678	26640830599000	25958	12827	1	0	1
195088	1397	1283654500000	25960	12828	0	0	15517
17767	1509	14063305503835	25960	12828	2	0	9
362280	1678	26640830602000	25966	12829	1	0	1
195116	2133	91199042000	25966	12829	4	0	5481
362285	1874	30523000	25967	12830	1	0	2
195132	2133	91196036000	25971	12831	1	0	5484
362301	1874	30529000	25972	12832	1	0	2
195137	1397	1283584493000	25974	12834	0	0	15524
362305	1874	30533000	25974	12834	1	0	2
362307	1678	26640830608000	25976	12835	0	0	1
52393	1715	9383579663945	25976	12835	3	0	16
195146	2133	91191026000	25978	12836	2	0	5489
362315	1678	26640830611000	25979	12837	0	0	1
40487	1685	174244342571430	25979	12837	2	0	0
48952	1700	9594270979053	25980	12838	3	0	10
195152	1397	1283524487000	25981	12839	0	0	15530
362321	1678	26640830614000	25982	12840	0	0	1
195161	1397	1283494484000	25985	12841	1	0	15533
195162	1397	1283484483000	25985	12841	2	0	15534
362330	1874	30549000	25985	12841	3	0	2
51290	1709	7920155000000	25985	12841	6	0	8
195168	1397	1283464481000	25987	12843	0	0	15536
362336	1874	30557000	25987	12843	1	0	2
7344	1394	819373189440200	25987	12843	2	0	0
7345	1394	819373200440200	25987	12843	3	0	0
195180	1397	1283434478000	25993	12846	0	0	15539
362348	1874	30563000	25993	12846	1	0	2
42855	1688	71999375720020	25993	12846	2	0	57
195185	2133	91175996000	25994	12847	3	0	5504
362369	1678	26640830625000	26001	12850	0	0	1
195207	2133	91172990000	26001	12850	5	0	5507
362375	1403	0	26001	12850	6	0	0
195228	2134	84720468000	26006	12852	3	0	5852
362395	1874	30581000	26006	12852	4	0	2
195233	2133	91168982000	26007	12853	1	0	5511
362400	1874	30590000	26007	12853	2	0	2
10392	1402	40503288145435	26007	12853	3	0	66
195239	2133	91166978000	26008	12854	4	0	5513
362406	1874	30600000	26008	12854	5	0	2
9521	1395	58262311395957278	26008	12854	7	0	0
195245	2133	91164974000	26010	12856	1	0	5515
362412	1874	30610000	26010	12856	2	0	2
195257	2133	91163972000	26013	12857	3	0	5516
316	43	74640103890000	26013	12857	4	0	3
195383	1397	1283284463000	26015	12858	0	0	15554
362549	1678	26640830637000	26015	12858	0	0	1
195384	2133	91162970000	26015	12858	1	0	5517
362550	1874	30617000	26015	12858	1	0	2
195397	2134	84711441000	26021	12860	1	0	5861
362563	1874	30628000	26021	12860	1	0	2
30730	1657	7201323990100	26021	12860	2	0	11
9522	1395	58263031395957278	26024	12862	2	0	0
195407	2134	84708432000	26026	12863	1	0	5864
362573	1874	30637000	26026	12863	1	0	2
58645	1980	23039556000000	26026	12863	2	0	1
362578	1678	26640830643000	26030	12864	0	0	1
362579	1874	30640000	26030	12864	1	0	2
195541	1397	1283214456000	26036	12865	0	0	15561
195542	2134	84706426000	26036	12865	1	0	5866
362712	1874	30649000	26037	12866	3	0	2
362721	1678	26640830647000	26040	12867	0	0	1
195556	2134	84703417000	26040	12867	1	0	5869
362722	1874	30652000	26040	12867	1	0	2
42888	1688	73439408720020	26044	12868	3	0	57
3158	526	74640291000000	26045	12869	2	0	2
195568	1397	1283144449000	26046	12870	1	0	15568
362734	1678	26640830651000	26046	12870	1	0	1
195569	2134	84700408000	26046	12870	2	0	5872
195570	2134	84699405000	26046	12870	3	0	5873
44585	1690	181445740000000	26048	12871	2	0	0
362742	1678	26640830654000	26049	12872	1	0	1
195578	1688	70783506612020	26049	12872	3	0	59
362747	1874	30667000	26049	12872	6	0	2
195584	2134	84695393000	26049	12872	9	0	5877
362753	1678	26640830656000	26050	12873	2	0	1
195589	1688	64934639255020	26050	12873	4	0	64
362759	799	14034180722181	26050	12873	8	0	0
195595	2134	84693387000	26050	12873	10	0	5879
20550	1555	14646159540449	26050	12873	11	0	8
53606	1719	15118638000000	26052	12874	2	0	10
362774	801	14036777239666	26053	12875	0	0	0
195611	1688	55902912159020	26053	12875	3	0	73
362780	1900	65126000	26053	12875	6	0	8
195616	1397	1283074442000	26053	12875	8	0	15575
362798	1678	26640830660000	26058	12877	0	0	1
40494	1685	176404430571430	26058	12877	2	0	0
195634	1679	34436108583000	26059	12878	0	0	76
362803	849	1157959544926640	26059	12878	3	0	3
195703	1679	26241293952000	26061	12879	0	0	80
362869	851	2252855616099750	26061	12879	0	0	0
362870	1678	26640830662000	26061	12879	1	0	1
195705	1679	25684651640000	26061	12879	2	0	81
195706	1679	25390204008000	26061	12879	3	0	82
362876	867	2446786067934000	26061	12879	7	0	0
195712	1679	11170445765000	26061	12879	9	0	88
362882	1874	30703000	26062	12880	2	0	2
7346	1394	820813200440200	26062	12880	4	0	0
195722	1679	10967375329000	26064	12881	0	0	89
362891	891	498419384091750	26064	12881	3	0	0
195727	1679	8500548510000	26064	12881	5	0	94
362897	1678	26640830665000	26064	12881	9	0	1
195733	1397	1282984433000	26064	12881	11	0	15584
21545	1564	11886713000000	26064	12881	15	0	10
362903	1678	26640830668000	26065	12882	0	0	1
195739	1679	5222585143000	26065	12882	2	0	98
362908	1874	30718000	26065	12882	5	0	2
195744	2134	84679345000	26065	12882	7	0	5893
362929	1678	26640830673000	26068	12883	2	0	1
195765	2134	84677339000	26068	12883	4	0	5895
362935	1678	26640830676000	26069	12884	2	0	1
195771	2134	84675333000	26069	12884	4	0	5897
362940	1874	30745000	26069	12884	7	0	2
195782	1397	1282864421000	26071	12885	1	0	15596
362956	1874	30754000	26073	12886	1	0	2
195794	2134	84668312000	26075	12887	1	0	5904
362974	1874	30763000	26082	12889	2	0	2
195812	1397	1282804415000	26084	12890	1	0	15602
362981	1874	30766000	26084	12890	4	0	2
195817	2134	84663297000	26084	12890	6	0	5909
20743	1559	9666095999999	26084	12890	8	0	8
362985	1678	26640830688000	26085	12891	0	0	1
362986	1874	30778000	26085	12891	1	0	2
195825	1397	1282754410000	26088	12893	0	0	15607
363000	1874	30787000	26092	12894	1	0	2
195837	1397	1282724407000	26094	12896	0	0	15610
7352	1394	825133244440200	26094	12896	2	0	0
363006	1874	30796000	26095	12897	1	0	2
195968	1397	1282704405000	26098	12898	0	0	15612
363134	1678	26640830695000	26098	12898	0	0	1
195969	2134	84654270000	26098	12898	1	0	5918
363135	1874	30799000	26098	12898	1	0	2
29257	1643	2588647914700	26100	12900	2	0	25
195979	1397	1282674402000	26102	12901	0	0	15615
363145	1678	26640830698000	26102	12901	0	0	1
195980	1397	1282664401000	26102	12901	1	0	15616
363157	1678	26640830701000	26106	12903	0	0	1
195992	1397	1282634398000	26106	12903	1	0	15619
363225	1874	30823000	26111	12904	1	0	2
16113	1474	10710547000043	26111	12904	3	0	29
196064	2134	84645243000	26113	12905	1	0	5927
363233	1874	30832000	26115	12907	1	0	2
25283	1608	13098516000000	26115	12907	2	0	8
196069	1397	1282584393000	26116	12908	0	0	15624
7358	1394	829453288440200	26116	12908	2	0	0
363239	1874	30841000	26117	12909	3	0	2
196075	1397	1282554390000	26118	12910	0	0	15627
363244	1678	26640830712000	26119	12911	0	0	1
196081	2134	84637219000	26119	12911	2	0	5935
58795	1991	12141402355805	26119	12911	5	0	21
363252	1678	26640830715000	26122	12913	0	0	1
196088	1397	1282494384000	26122	12913	1	0	15633
7365	1394	832333343440200	26122	12913	5	0	0
363257	1874	30865000	26123	12914	1	0	2
363260	1678	26640830718000	26125	12915	0	0	1
196096	2134	84631201000	26125	12915	1	0	5941
9529	1395	58265191428957278	26125	12915	2	0	0
363276	1678	26640830721000	26133	12918	0	0	1
196112	2134	84628192000	26133	12918	1	0	5944
34903	1679	5038092657000	26133	12918	2	0	100
196115	1397	1282434378000	26135	12919	0	0	15639
196116	2134	84627189000	26135	12919	1	0	5945
19117	1536	18000349000000	26135	12919	2	0	11
363286	1874	30883000	26137	12920	2	0	2
25297	1608	13818549000000	26137	12920	5	0	8
196126	2134	84624180000	26139	12921	1	0	5948
363295	1874	30892000	26141	12922	1	0	2
196138	2134	84621171000	26145	12924	1	0	5951
363305	1874	30900000	26146	12925	1	0	2
36348	1681	14291478909853	26146	12925	3	0	11
196143	1397	1282344369000	26147	12926	1	0	15648
363311	1874	30910000	26147	12926	4	0	2
196149	2133	91157960000	26148	12927	1	0	5522
363352	1678	26640830733000	26151	12928	0	0	1
196191	2133	91156958000	26151	12928	4	0	5523
363381	1678	26640830735000	26156	12929	0	0	1
196219	2134	84614150000	26156	12929	3	0	5958
363404	1678	26640830736000	26160	12930	0	0	1
363405	1678	26640830737000	26160	12930	1	0	1
196243	1726	996795112000	26160	12930	4	0	8290
363411	1874	30943000	26160	12930	7	0	2
196249	1726	994593112000	26161	12931	2	0	8292
196250	1726	993492112000	26161	12931	3	0	8293
363417	1874	30948000	26161	12931	5	0	2
7374	1394	836653365440200	26162	12932	3	0	0
196259	1397	1282254360000	26164	12933	0	0	15657
363425	1678	26640830741000	26164	12933	1	0	1
47629	1695	10745141999000	26164	12933	6	0	9
196265	1397	1282234358000	26165	12934	0	0	15659
363431	1874	30966000	26165	12934	1	0	2
31434	1670	10081062000000	26165	12934	4	0	11
196273	2133	91146938000	26167	12935	2	0	5533
363440	1874	30975000	26167	12935	4	0	2
196279	1397	1282204355000	26168	12936	0	0	15662
363445	1874	30981000	26168	12936	1	0	2
196299	1397	1282194354000	26175	12940	0	0	15663
363465	1678	26640830747000	26175	12940	1	0	1
196304	2133	91142930000	26175	12940	5	0	5537
363471	1874	30995000	26175	12940	7	0	2
196310	2134	84601111000	26175	12940	11	0	5971
363476	1874	31007000	26175	12940	12	0	2
196316	2133	91138922000	26176	12941	3	0	5541
363482	1874	31016000	26176	12941	4	0	2
196335	2133	91136918000	26179	12942	1	0	5543
41440	1688	12310609113020	26179	12942	2	0	77
363502	1874	31025000	26180	12943	1	0	2
196347	1397	1282114346000	26183	12944	0	0	15671
363513	1874	31035000	26183	12944	1	0	2
59042	1992	12961080990000	26183	12944	4	0	5
196435	1397	1282104345000	26186	12945	0	0	15672
363600	1678	26640830755000	26186	12945	0	0	1
196436	2133	91133912000	26186	12945	1	0	5546
363601	1874	31039000	26186	12945	1	0	2
196446	2134	84592084000	26188	12946	3	0	5980
363611	1874	31047000	26188	12946	3	0	2
196576	1397	1282084343000	26191	12947	0	0	15674
363741	1678	26640830757000	26191	12947	0	0	1
196577	1397	1282074342000	26191	12947	1	0	15675
363742	1678	26640830758000	26191	12947	1	0	1
196583	2133	91129904000	26191	12947	7	0	5550
363748	1874	31059000	26191	12947	7	0	2
196589	2134	84588072000	26192	12948	2	0	5984
363754	1874	31067000	26192	12948	2	0	2
196723	1397	1282044339000	26195	12949	0	0	15678
363888	1678	26640830761000	26195	12949	0	0	1
196724	1397	1282034338000	26195	12949	1	0	15679
363889	1678	26640830762000	26195	12949	1	0	1
56659	1759	8857245139889	26195	12949	6	0	11
196735	1726	985785112000	26197	12950	1	0	8300
363900	2341	100000000	26197	12950	1	0	0
196746	2133	91124894000	26199	12951	2	0	5555
363911	1874	31090000	26199	12951	2	0	2
196751	2133	91122890000	26201	12953	1	0	5557
363916	1874	31100000	26201	12953	1	0	2
9538	1395	58267351474957278	26203	12954	4	0	0
196763	1397	1281974332000	26205	12955	1	0	15685
363928	1678	26640830768000	26205	12955	1	0	1
196769	2134	84578042000	26205	12955	7	0	5994
363934	1874	31117000	26205	12955	7	0	2
363937	1874	31123000	26205	12955	10	0	2
363938	1874	31125000	26205	12955	11	0	2
196774	2133	91117880000	26205	12955	12	0	5562
363956	1874	31134000	26210	12957	1	0	2
196792	2132	147421434000	26210	12957	2	0	1567
196793	2134	84575033000	26210	12957	3	0	5997
196794	1397	1281924327000	26211	12958	0	0	15690
9545	1395	58268791548957278	26211	12958	4	0	0
363962	1678	26640830774000	26212	12959	0	0	1
7384	1394	840973415440200	26212	12959	3	0	0
196800	1397	1281904325000	26213	12960	0	0	15692
363967	1874	31153000	26213	12960	2	0	2
196810	2134	84571021000	26215	12961	3	0	6001
363985	1678	26640830778000	26218	12962	1	0	1
196823	2134	84569015000	26218	12962	4	0	6003
363991	1874	31171000	26219	12963	1	0	2
196836	1397	1281854320000	26222	12964	0	0	15697
364003	1874	31180000	26222	12964	2	0	2
196849	2133	91106858000	26224	12965	3	0	5573
364016	1874	31188000	26224	12965	5	0	2
196978	1397	1281824317000	26226	12966	0	0	15700
364143	1678	26640830783000	26226	12966	0	0	1
196979	1397	1281814316000	26226	12966	1	0	15701
364144	1678	26640830784000	26226	12966	1	0	1
196985	1726	984684112000	26226	12966	7	0	8301
364150	2342	100000000	26226	12966	7	0	0
196991	2133	91100846000	26226	12966	13	0	5579
364156	1874	31204000	26226	12966	13	0	2
196996	2134	84562997000	26226	12966	18	0	6009
364161	1874	31213000	26226	12966	18	0	2
24087	1599	13976910097983	26226	12966	24	0	8
197026	1397	1281754310000	26228	12967	0	0	15707
364191	1678	26640830790000	26228	12967	0	0	1
7392	1394	843853464440200	26229	12968	4	0	0
197032	1397	1281734308000	26230	12969	0	0	15709
364197	1678	26640830792000	26230	12969	0	0	1
197037	2134	84553970000	26230	12969	5	0	6018
364202	1874	31248000	26230	12969	5	0	2
364211	1678	26640830794000	26232	12970	0	0	1
364212	1874	31251000	26232	12970	1	0	2
197050	1397	1281694304000	26233	12971	1	0	15713
364218	1874	31261000	26233	12971	4	0	2
197063	1397	1281684303000	26236	12972	0	0	15714
197065	2133	91090826000	26236	12972	2	0	5589
197072	1397	1281674302000	26242	12973	0	0	15715
364237	1678	26640830798000	26242	12973	0	0	1
9551	1395	58270951585957278	26242	12973	4	0	0
364242	1678	26640830801000	26243	12974	2	0	1
337	43	76080173890000	26243	12974	3	0	3
197078	1397	1281634298000	26243	12974	4	0	15719
364248	1874	31284000	26243	12974	9	0	2
197084	2134	84545946000	26243	12974	10	0	6026
197089	2132	147412425000	26243	12974	15	0	1576
364254	1874	31293000	26243	12974	15	0	2
364259	1874	31302000	26244	12975	2	0	2
61204	2330	103000000	26244	12975	4	0	0
61287	2333	101000000	26244	12975	4	1	0
197104	1397	1281614296000	26248	12976	0	0	15721
48033	1696	19163787335104	26248	12976	3	0	9
364274	1874	31312000	26249	12977	2	0	2
46484	1693	6471002570272	26249	12977	3	0	1248
197110	1397	1281594294000	26250	12978	0	0	15723
197115	1397	1281574292000	26251	12979	1	0	15725
364280	1678	26640830808000	26251	12979	1	0	1
364285	1874	31323000	26251	12979	6	0	2
197121	2134	84539928000	26251	12979	7	0	6032
364291	1874	31339000	26251	12979	12	0	2
197127	1397	1281544289000	26252	12980	0	0	15728
197132	2133	91075796000	26253	12981	2	0	5604
364297	1874	31349000	26253	12981	2	0	2
364305	1678	26640830814000	26256	12983	0	0	1
197141	2133	91073792000	26256	12983	1	0	5606
10420	1402	42663324145435	26256	12983	3	0	66
364320	1678	26640830816000	26261	12985	0	0	1
197156	2133	91071788000	26261	12985	1	0	5608
1542	171	76746783696494	26261	12985	6	0	8
197161	1397	1281484283000	26262	12986	0	0	15734
364326	1678	26640830817000	26262	12986	0	0	1
364331	1874	31384000	26262	12986	5	0	2
197167	2134	84527892000	26262	12986	6	0	6044
364344	1678	26640830821000	26265	12988	1	0	1
197180	2134	84525886000	26265	12988	2	0	6046
364345	1874	31395000	26265	12988	2	0	2
364346	1874	31396000	26265	12988	3	0	2
7402	1394	848173539440200	26265	12988	8	0	0
197185	1397	1281434278000	26266	12989	0	0	15739
364352	1874	31408000	26266	12989	2	0	2
197194	1397	1281414276000	26269	12991	0	0	15741
364361	1874	31418000	26269	12991	2	0	2
197201	2132	147405418000	26271	12992	1	0	1583
197202	2134	84520871000	26271	12992	3	0	6051
34929	1679	6478128656999	26271	12992	6	0	100
364369	1678	26640830826000	26272	12993	0	0	1
197208	2134	84519868000	26273	12994	2	0	6052
364375	1874	31432000	26274	12995	1	0	2
197222	1397	1281354270000	26277	12996	1	0	15747
364389	1874	31443000	26277	12996	3	0	2
197227	1397	1281344269000	26278	12997	0	0	15748
364394	1874	31452000	26278	12997	2	0	2
51934	1711	15547000000000	26278	12997	4	0	13
197233	2134	84514853000	26279	12998	2	0	6057
197373	1397	1281324267000	26283	12999	0	0	15750
364538	1678	26640830833000	26283	12999	0	0	1
197374	1397	1281314266000	26283	12999	1	0	15751
364539	1678	26640830834000	26283	12999	1	0	1
197389	1397	1281294264000	26286	13000	0	0	15753
364554	1678	26640830836000	26286	13000	0	0	1
27626	1634	14783095259504	26286	13000	3	0	18
39390	1684	24483358819412	26287	13001	2	0	136
197395	1397	1281254260000	26288	13002	2	0	15757
364560	1678	26640830840000	26288	13002	2	0	1
197400	1397	1281244259000	26289	13003	0	0	15758
364565	1678	26640830841000	26289	13003	0	0	1
365	43	78240209890000	26289	13003	3	0	3
9557	1395	58273111658957278	26290	13004	3	0	0
197408	2134	84503820000	26292	13005	1	0	6068
364573	1874	31494000	26292	13005	1	0	2
18572	1522	9403677000000	26292	13005	2	0	14
7412	1394	852493586440200	26293	13006	3	0	0
197425	1397	1281174252000	26295	13007	3	0	15765
364590	1678	26640830848000	26295	13007	3	0	1
197430	2134	84499808000	26295	13007	8	0	6072
364595	1874	31508000	26295	13007	8	0	2
55361	1740	14130800000000	26295	13007	11	0	14
364618	1678	26640830850000	26300	13009	0	0	1
197454	1397	1281144249000	26300	13009	1	0	15768
364619	1678	26640830851000	26300	13009	1	0	1
58650	1980	24479601000000	26300	13009	6	0	1
197465	1397	1281114246000	26302	13010	2	0	15771
364630	1678	26640830854000	26302	13010	2	0	1
197470	1397	1281094244000	26303	13011	1	0	15773
364636	1874	31531000	26303	13011	2	0	2
197473	2134	84490781000	26303	13011	4	0	6081
197474	1397	1281084243000	26304	13012	0	0	15774
364644	1874	31541000	26306	13013	0	0	2
60106	2112	22846943101924	26306	13013	1	0	7
197534	2134	84488775000	26313	13015	3	0	6083
364701	1874	31550000	26313	13015	5	0	2
197561	1397	1281024237000	26320	13017	1	0	15780
364728	1874	31557000	26320	13017	3	0	2
16749	1489	12623155040000	26320	13017	6	0	10
197576	1397	1281004235000	26323	13018	1	0	15782
364743	1874	31566000	26323	13018	3	0	2
197590	1397	1280984233000	26328	13020	0	0	15784
364755	1678	26640830867000	26328	13020	0	0	1
364756	1874	31573000	26328	13020	1	0	2
197613	1397	1280954230000	26334	13022	0	0	15787
197614	2134	84478745000	26334	13022	1	0	6093
364780	1874	31580000	26334	13022	2	0	2
197620	1397	1280934228000	26336	13024	0	0	15789
364786	1678	26640830873000	26336	13024	1	0	1
41466	1688	14470655113020	26336	13024	4	0	77
4265	632	78237637000000	26337	13025	2	0	9
197627	1397	1280904225000	26339	13026	0	0	15792
364792	1678	26640830875000	26339	13026	0	0	1
197642	1397	1280884223000	26342	13027	0	0	15794
364808	1874	31606000	26342	13027	1	0	2
10444	1402	44103372145435	26342	13027	3	0	66
52208	1714	15405747171760	26346	13028	3	0	11
197661	1397	1280864221000	26351	13030	0	0	15796
364827	1678	26640830880000	26351	13030	1	0	1
197667	2134	84464703000	26351	13030	6	0	6107
364832	1874	31623000	26351	13030	6	0	2
7422	1394	856813609440200	26351	13030	7	0	0
197681	1397	1280814216000	26356	13033	0	0	15801
364847	1678	26640830885000	26356	13033	1	0	1
197687	2134	84459688000	26356	13033	6	0	6112
197820	1397	1280784213000	26359	13034	0	0	15804
364985	1678	26640830887000	26359	13034	0	0	1
197821	2134	84458685000	26359	13034	1	0	6113
364986	1874	31642000	26359	13034	1	0	2
60981	2329	304566222819988	26361	13036	2	0	0
197830	1397	1280754210000	26363	13037	0	0	15807
364995	1678	26640830890000	26363	13037	0	0	1
17412	1508	12440410156616	26364	13038	3	0	10
197836	1397	1280724207000	26366	13040	1	0	15810
365001	1678	26640830893000	26366	13040	1	0	1
197841	2132	147384397000	26366	13040	6	0	1604
365006	1874	31666000	26366	13040	6	0	2
7429	1394	861133666440200	26367	13041	4	0	0
197847	1397	1280674202000	26368	13042	1	0	15815
365012	1678	26640830898000	26368	13042	1	0	1
26354	1619	5760108000000	26368	13042	3	0	0
197858	2134	84446649000	26370	13043	4	0	6125
365023	1874	31684000	26370	13043	4	0	2
365025	1678	26640830900000	26371	13044	0	0	1
365026	1874	31687000	26371	13044	1	0	2
197863	2338	9000000	26371	13044	3	0	1
365044	1678	26640830902000	26374	13045	1	0	1
197881	2133	91051748000	26374	13045	3	0	5628
197882	2134	84443640000	26374	13045	4	0	6128
365050	1678	26640830904000	26375	13046	1	0	1
197888	2134	84442637000	26375	13046	4	0	6129
365055	1874	31708000	26375	13046	6	0	2
15310	1467	5200266272869	26375	13046	8	0	9
197902	2133	91047740000	26377	13047	2	0	5632
365072	1874	31718000	26379	13048	1	0	2
197913	2132	147380393000	26381	13049	1	0	1608
365097	1678	26640830908000	26386	13050	0	0	1
197935	1397	1280564191000	26387	13051	0	0	15826
365102	1874	31737000	26387	13051	2	0	2
197941	2133	91041728000	26388	13052	3	0	5638
365108	1874	31745000	26388	13052	5	0	2
1248	149	77615406000341	26388	13052	8	0	10
197946	1397	1280524187000	26389	13053	1	0	15830
365114	1874	31755000	26389	13053	4	0	2
197952	1397	1280504185000	26390	13054	1	0	15832
365119	1874	31762000	26390	13054	3	0	2
198080	1397	1280494184000	26393	13055	0	0	15833
365245	1678	26640830916000	26393	13055	0	0	1
198081	1397	1280484183000	26393	13055	1	0	15834
365246	1678	26640830917000	26393	13055	1	0	1
50412	1705	22880980580140	26393	13055	8	0	25
198087	1397	1280474182000	26394	13056	0	0	15835
365252	1678	26640830918000	26394	13056	0	0	1
9571	1395	58275271695957278	26394	13056	4	0	0
198093	2133	91033712000	26395	13057	3	0	5646
365258	1874	31790000	26395	13057	3	0	2
198105	2134	84425586000	26397	13058	5	0	6146
365270	1874	31797000	26397	13058	5	0	2
19489	1546	11037469800000	26397	13058	9	0	10
56479	1756	8480871195609	26398	13059	2	0	6
198111	2134	84422577000	26399	13060	1	0	6149
365276	1874	31807000	26399	13060	1	0	2
198117	2132	147375388000	26400	13061	3	0	1613
365282	1874	31817000	26400	13061	3	0	2
198122	2133	91026698000	26402	13063	1	0	5653
365287	1874	31824000	26402	13063	1	0	2
7437	1394	865453713440200	26402	13063	3	0	0
198162	1397	1280374172000	26408	13065	0	0	15845
365327	1678	26640830928000	26408	13065	0	0	1
198163	1397	1280364171000	26408	13065	1	0	15846
365328	1678	26640830929000	26408	13065	1	0	1
198289	1397	1280354170000	26411	13066	0	0	15847
365454	1678	26640830930000	26411	13066	0	0	1
198290	2132	147373386000	26411	13066	1	0	1615
365455	1874	31844000	26411	13066	1	0	2
27092	1623	79203325898598	26413	13067	4	0	1
198299	1397	1280334168000	26414	13068	0	0	15849
365464	1678	26640830932000	26414	13068	0	0	1
198305	2134	84413550000	26414	13068	6	0	6158
365470	1874	31858000	26414	13068	6	0	2
198310	2134	84410541000	26414	13068	11	0	6161
365475	1874	31867000	26414	13068	11	0	2
198316	2133	91016678000	26414	13068	17	0	5663
365481	1874	31880000	26414	13068	17	0	2
198344	1741	1439010000000	26418	13070	1	0	2
365509	3	145418010000000	26418	13070	1	0	0
198349	2133	91012670000	26419	13071	3	0	5667
365514	1874	31892000	26419	13071	3	0	2
7444	1394	868333762440200	26419	13071	8	0	0
198355	2134	84405526000	26420	13072	2	0	6166
365520	1874	31904000	26420	13072	2	0	2
47230	1694	16379047197225	26420	13072	3	0	62
198453	1397	1280234158000	26425	13073	0	0	15859
365618	1678	26640830942000	26425	13073	0	0	1
198454	2134	84404523000	26425	13073	1	0	6167
365619	1874	31907000	26425	13073	1	0	2
57055	1762	9285610994000	26425	13073	4	0	8
198470	2133	91008662000	26430	13075	1	0	5671
365635	1874	31916000	26430	13075	1	0	2
59469	2055	2159014000000	26431	13076	3	0	0
198476	1397	1280194154000	26432	13077	0	0	15863
365641	1678	26640830946000	26432	13077	0	0	1
198481	2132	147368381000	26432	13077	6	0	1620
365646	1874	31934000	26432	13077	6	0	2
198514	2134	84398505000	26437	13078	4	0	6173
365679	1874	31943000	26437	13078	4	0	2
198527	1397	1280144149000	26441	13080	0	0	15868
365692	1678	26640830951000	26441	13080	0	0	1
26124	1613	13537405400000	26441	13080	4	0	10
198538	2133	91000646000	26443	13081	2	0	5679
365703	1874	31959000	26443	13081	2	0	2
365705	1874	31964000	26443	13081	4	0	2
365706	1874	31967000	26443	13081	5	0	2
44594	1690	182885796000000	26443	13081	7	0	0
198550	2132	147366379000	26446	13082	2	0	1622
198565	1397	1280104145000	26451	13083	0	0	15872
198566	2133	90997640000	26451	13083	1	0	5682
365731	1874	31975000	26451	13083	1	0	2
50728	1706	16842246450256	26451	13083	3	0	27
9580	1395	58277431733957278	26453	13084	2	0	0
198666	2132	147365378000	26456	13085	2	0	1623
365831	1874	31985000	26456	13085	2	0	2
365836	1678	26640830959000	26458	13087	0	0	1
198672	1397	1280054140000	26458	13087	1	0	15877
365841	1874	32000000	26458	13087	5	0	2
198677	2134	84386469000	26458	13087	6	0	6185
365842	1874	32003000	26458	13087	6	0	2
198795	1397	1280044139000	26460	13088	0	0	15878
198796	2133	90992630000	26460	13088	1	0	5687
365965	1874	32011000	26462	13089	2	0	2
198802	2133	90991628000	26462	13089	4	0	5688
365977	1874	32024000	26464	13090	2	0	2
365978	1678	26640830964000	26465	13091	0	0	1
198814	2134	84381454000	26465	13091	1	0	6190
199063	1397	1280004135000	26469	13092	0	0	15882
366227	1678	26640830965000	26469	13092	0	0	1
199064	1397	1279994134000	26469	13092	1	0	15883
366228	1678	26640830966000	26469	13092	1	0	1
199070	2134	84379448000	26469	13092	7	0	6192
366234	1874	32040000	26469	13092	7	0	2
366249	1678	26640830968000	26473	13094	0	0	1
366250	1678	26640830969000	26473	13094	1	0	1
199087	2133	90984614000	26473	13094	2	0	5695
199092	1397	1279954130000	26474	13095	0	0	15887
366256	1678	26640830970000	26474	13095	0	0	1
11977	1423	3600627750023	26474	13095	6	0	29
199110	1397	1279944129000	26477	13096	0	0	15888
366274	1678	26640830971000	26477	13096	0	0	1
199111	2134	84374433000	26477	13096	1	0	6197
366279	1874	32069000	26478	13097	1	0	2
199117	2133	90980606000	26478	13097	3	0	5699
366289	1874	32075000	26480	13098	3	0	2
60990	2329	306726258819988	26480	13098	5	0	0
199141	1397	1279914126000	26485	13099	0	0	15891
7452	1394	872653799440200	26485	13099	4	0	0
366309	1874	32085000	26486	13100	1	0	2
199146	2133	90977600000	26486	13100	2	0	5702
366314	1874	32093000	26487	13101	3	0	2
199152	2133	90975596000	26488	13102	1	0	5704
366327	1874	32099000	26490	13103	2	0	2
199165	2134	84366409000	26490	13103	4	0	6205
366333	1874	32111000	26491	13104	1	0	2
199170	2134	84365406000	26491	13104	2	0	6206
199302	1397	1279834118000	26495	13106	0	0	15899
366466	1678	27360855982000	26495	13106	0	0	1
199303	1397	1279824117000	26495	13106	1	0	15900
366467	1678	27360855983000	26495	13106	1	0	1
199309	2133	90970586000	26495	13106	7	0	5709
366473	1874	32131000	26495	13106	7	0	2
9591	1395	58279591768957278	26495	13106	10	0	0
50981	1708	11880623500051	26497	13107	4	0	8
199319	1397	1279794114000	26499	13108	0	0	15903
366483	1678	27360855986000	26499	13108	0	0	1
199324	2133	90965576000	26499	13108	5	0	5714
366488	1874	32150000	26499	13108	5	0	2
16470	1476	14400320000000	26499	13108	7	0	11
7460	1394	876973835440200	26500	13109	4	0	0
199330	1397	1279754110000	26501	13110	1	0	15907
366494	1678	27360855990000	26501	13110	1	0	1
199343	1397	1279744109000	26503	13111	0	0	15908
366507	1678	27360855991000	26503	13111	0	0	1
29309	1643	4028682914700	26503	13111	4	0	25
199351	2134	84353370000	26505	13112	2	0	6218
366515	1874	32177000	26505	13112	2	0	2
199357	2133	90958562000	26507	13114	1	0	5721
366521	1874	32185000	26507	13114	1	0	2
366522	1874	32188000	26507	13114	2	0	2
199476	1397	1279694104000	26511	13116	0	0	15913
199477	1397	1279684103000	26511	13116	1	0	15914
366642	1678	27360855998000	26511	13116	2	0	1
199483	2134	84348355000	26511	13116	8	0	6223
366648	1874	32207000	26511	13116	9	0	2
40505	1685	177844490571430	26511	13116	12	0	0
199493	2132	147352365000	26513	13117	3	0	1636
366657	1874	32212000	26513	13117	3	0	2
366658	1874	32214000	26513	13117	4	0	2
13179	1444	13047891329999	26513	13117	8	0	12
199498	2134	84344343000	26514	13118	1	0	6227
366673	1678	27360856002000	26518	13119	0	0	1
199513	2133	90949544000	26519	13120	1	0	5730
199514	2132	147351364000	26519	13120	2	0	1637
366679	1874	32236000	26519	13120	3	0	2
199534	2134	84340331000	26526	13122	1	0	6231
366698	1874	32244000	26526	13122	1	0	2
24803	1602	12816693170000	26526	13122	4	0	9
199540	1397	1279584093000	26528	13124	0	0	15924
366704	1678	27360856007000	26528	13124	0	0	1
199548	2134	84337322000	26530	13125	2	0	6234
46598	1693	7911038570272	26530	13125	4	0	1248
366713	1678	27360856009000	26531	13126	0	0	1
199554	1397	1279544089000	26533	13127	1	0	15928
366718	1678	27360856011000	26533	13127	1	0	1
199560	2133	90941528000	26533	13127	7	0	5738
366724	1874	32281000	26533	13127	7	0	2
199597	2133	90939524000	26538	13128	3	0	5740
366762	1874	32288000	26538	13128	4	0	2
7467	1394	881293861440200	26538	13128	7	0	0
199603	2134	84330301000	26539	13129	2	0	6241
366767	1874	32299000	26539	13129	2	0	2
44602	1690	185045821000000	26539	13129	4	0	0
199609	2351	98000000	26540	13130	4	0	2
366773	1874	32309000	26540	13130	6	0	2
22835	1588	16561897000000	26540	13130	10	0	12
199621	1397	1279474082000	26542	13131	0	0	15935
366786	1874	32317000	26542	13131	4	0	2
199627	2132	147346359000	26542	13131	6	0	1642
22594	1587	15840479000000	26544	13132	3	0	14
366795	1678	27360856020000	26546	13133	0	0	1
366796	1678	27360856021000	26546	13133	1	0	1
199637	2133	90931508000	26546	13133	3	0	5748
366802	1874	32338000	26546	13133	7	0	2
199642	2133	90930506000	26546	13133	8	0	5749
22854	1588	17281909000000	26547	13134	5	0	12
199650	1397	1279414076000	26549	13135	0	0	15941
366811	1678	27360856024000	26549	13135	0	0	1
199651	2133	90927500000	26549	13135	1	0	5752
41482	1688	15190677113020	26549	13135	2	0	77
366816	1874	32355000	26550	13136	3	0	2
36038	1680	12253347499559	26550	13136	5	0	12
199660	2134	84319268000	26552	13137	1	0	6252
15803	1471	17945496900000	26552	13137	4	0	8
366825	1874	32362000	26553	13138	2	0	2
199666	2134	84317262000	26553	13138	4	0	6254
34946	1679	7918187656999	26553	13138	8	0	100
366831	1678	27360856030000	26554	13139	1	0	1
199671	2134	84316259000	26554	13139	2	0	6255
366839	1678	27360856031000	26556	13140	0	0	1
199680	2134	84314253000	26556	13140	2	0	6257
366848	1874	32392000	26558	13141	3	0	2
199697	2134	84312247000	26561	13142	1	0	6259
23767	1596	7200255000002	26561	13142	3	0	16
366862	1874	32402000	26562	13143	2	0	2
9598	1395	58281031829957278	26562	13143	4	0	0
199830	1397	1279304065000	26565	13144	0	0	15952
366991	1678	27360856035000	26565	13144	0	0	1
199831	2133	90916478000	26565	13144	1	0	5763
366992	1874	32404000	26565	13144	1	0	2
199837	1397	1279284063000	26567	13146	0	0	15954
366998	1678	27360856037000	26567	13146	0	0	1
199856	2134	84307232000	26571	13147	3	0	6264
367017	1874	32422000	26571	13147	3	0	2
61006	2329	308166321819988	26571	13147	8	0	0
199865	2338	8000000	26573	13148	1	0	2
367026	2346	190000000	26573	13148	1	0	0
199871	1397	1279234058000	26576	13150	0	0	15959
367032	1678	27360856042000	26576	13150	0	0	1
199877	2134	84302217000	26576	13150	6	0	6269
367038	1874	32445000	26576	13150	6	0	2
199882	2133	90907460000	26576	13150	11	0	5772
367043	1874	32455000	26576	13150	11	0	2
199900	1397	1279184053000	26579	13152	1	0	15964
367061	1678	27360856047000	26579	13152	1	0	1
367065	1874	32471000	26579	13152	5	0	2
199932	1397	1279174052000	26584	13153	0	0	15965
367093	1678	27360856048000	26584	13153	0	0	1
199933	1397	1279164051000	26584	13153	1	0	15966
367099	1874	32482000	26584	13153	7	0	2
199959	1397	1279154050000	26588	13154	0	0	15967
367125	1874	32492000	26588	13154	5	0	2
199971	1397	1279134048000	26590	13155	0	0	15969
51616	1710	13914071664140	26590	13155	5	0	10
367136	1678	27360856053000	26591	13156	0	0	1
199976	1397	1279114046000	26591	13156	1	0	15971
367142	1678	27360856055000	26592	13157	0	0	1
199982	2134	84290181000	26592	13157	1	0	6281
367158	1874	32516000	26595	13158	2	0	2
199998	2134	84289178000	26595	13158	3	0	6282
367181	1874	32527000	26599	13159	1	0	2
200021	2132	147334347000	26599	13159	2	0	1654
7481	1394	885613947440200	26599	13159	4	0	0
7482	1394	885613960440200	26599	13159	5	0	0
367191	1874	32537000	26601	13160	3	0	2
200031	2134	84285166000	26601	13160	4	0	6286
367201	1678	27360856061000	26604	13162	0	0	1
367202	1678	27360856062000	26604	13162	1	0	1
200042	1397	1279024037000	26604	13162	2	0	15980
200047	2133	90889424000	26604	13162	7	0	5790
367208	1874	32557000	26604	13162	7	0	2
30492	1656	15115557999990	26604	13162	11	0	8
200057	1397	1279004035000	26607	13164	0	0	15982
367218	1678	27360856065000	26607	13164	0	0	1
200058	2133	90886418000	26607	13164	1	0	5793
367232	1874	32574000	26611	13165	2	0	2
200073	2132	147331344000	26612	13166	1	0	1657
367238	1874	32585000	26612	13166	5	0	2
39415	1684	26643405819412	26612	13166	6	0	136
200079	2134	84276139000	26613	13167	1	0	6295
29555	1649	11991570999968	26613	13167	2	0	8
367268	1874	32595000	26617	13168	3	0	2
200108	2133	90878402000	26617	13168	4	0	5801
367333	1678	27360856069000	26622	13169	0	0	1
200174	1397	1278944029000	26622	13169	2	0	15988
367337	1678	27360856073000	26622	13169	4	0	1
367338	1874	32607000	26622	13169	5	0	2
200180	2134	84272127000	26622	13169	8	0	6299
367344	1874	32620000	26622	13169	11	0	2
200185	1726	969270112000	26622	13169	13	0	8315
367350	1874	32625000	26622	13169	17	0	2
200191	2133	90875396000	26622	13169	19	0	5804
200193	2133	90873392000	26622	13169	22	0	5806
200197	1397	1278914026000	26624	13170	0	0	15991
367358	1678	27360856074000	26624	13170	0	0	1
7492	1394	889934039440200	26625	13171	3	0	0
200203	1397	1278894024000	26626	13172	0	0	15993
367364	1678	27360856076000	26626	13172	0	0	1
200209	2134	84263100000	26627	13173	3	0	6308
367370	1874	32654000	26627	13173	3	0	2
200228	1724	12653766500000	26630	13174	1	0	14
367389	2362	0	26630	13174	1	0	0
200238	2133	90866378000	26632	13175	3	0	5813
367399	1874	32670000	26632	13175	3	0	2
34985	1679	9358211656999	26633	13176	3	0	100
58304	1850	15816467949999	26634	13177	3	0	9
200252	1397	1278834018000	26637	13178	0	0	15999
367413	1678	27360856082000	26637	13178	0	0	1
13895	1448	10759865000001	26637	13178	5	0	16
200270	1397	1278814016000	26640	13179	1	0	16001
367431	1678	27360856084000	26640	13179	1	0	1
200276	2134	84256079000	26640	13179	7	0	6315
367437	1874	32698000	26640	13179	7	0	2
200300	1397	1278784013000	26644	13181	0	0	16004
367461	1678	27360856087000	26644	13181	0	0	1
200305	2134	84253070000	26644	13181	5	0	6318
367466	1874	32714000	26644	13181	5	0	2
367485	1678	27360856089000	26649	13182	0	0	1
367486	1874	32715000	26649	13182	1	0	2
40870	1686	15512127700123	26649	13182	4	0	17
200329	2133	90855356000	26650	13183	1	0	5824
200330	2134	84251064000	26650	13183	2	0	6320
367623	1678	27360856091000	26654	13184	0	0	1
367624	1874	32728000	26654	13184	1	0	2
7502	1394	894254099440200	26654	13184	3	0	0
200465	1397	1278734008000	26655	13185	0	0	16009
200466	2133	90853352000	26655	13185	1	0	5826
367634	1678	27360856093000	26657	13186	0	0	1
200479	1397	1278714006000	26659	13187	0	0	16011
367643	1678	27360856096000	26660	13188	1	0	1
200485	2134	84245046000	26660	13188	4	0	6326
367648	1874	32756000	26660	13188	6	0	2
200506	2133	90848342000	26663	13189	1	0	5831
367701	1678	27360856099000	26669	13190	1	0	1
200543	2134	84243040000	26669	13190	5	0	6328
59715	2087	3315423147766	26669	13190	9	0	3
367714	1678	27360856100000	26671	13191	0	0	1
200556	1397	1278643999000	26672	13192	0	0	16018
367719	1874	32783000	26672	13192	2	0	2
200561	2132	147319332000	26673	13193	2	0	1669
60667	2261	10079247000000	26673	13193	4	0	0
367733	1874	32792000	26676	13194	1	0	2
200575	2134	84237022000	26677	13195	1	0	6334
367739	1874	32802000	26678	13196	1	0	2
200584	1397	1278583993000	26680	13197	1	0	16024
367745	1678	27360856107000	26680	13197	1	0	1
367746	1874	32805000	26680	13197	2	0	2
200589	2133	90838322000	26680	13197	6	0	5841
367758	1678	27360856109000	26682	13198	1	0	1
200601	2133	90836318000	26682	13198	5	0	5843
200602	2134	84233010000	26682	13198	6	0	6338
367764	1874	32826000	26682	13198	7	0	2
801	58	76067492999641	26682	13198	9	0	12
200633	2133	90834314000	26687	13199	3	0	5845
367794	1874	32833000	26687	13199	3	0	2
200639	2134	84227995000	26688	13200	1	0	6343
367800	1874	32843000	26688	13200	1	0	2
41517	1688	17350714113020	26688	13200	3	0	77
200664	2133	90832310000	26692	13201	3	0	5847
367826	1874	32850000	26692	13201	4	0	2
200670	2132	147315328000	26692	13201	9	0	1673
367831	1874	32861000	26692	13201	9	0	2
200676	2134	84222980000	26695	13203	1	0	6348
367837	1874	32869000	26695	13203	1	0	2
61016	2329	310326382819988	26695	13203	4	0	0
200681	2134	84221977000	26696	13204	3	0	6349
3460	576	79757702726897	26696	13204	5	0	9
367847	1678	27360856120000	26698	13205	0	0	1
200697	2134	84219971000	26701	13206	2	0	6351
367858	1874	32887000	26701	13206	2	0	2
200706	2132	147313326000	26703	13207	5	0	1675
367867	1874	32896000	26703	13207	5	0	2
200711	2134	84215959000	26704	13208	3	0	6355
367873	1874	32906000	26704	13208	4	0	2
23156	1593	14352789000000	26704	13208	6	0	8
200850	1397	1278393974000	26707	13209	0	0	16043
368011	1678	27360856126000	26707	13209	0	0	1
200851	1397	1278383973000	26707	13209	1	0	16044
368012	1678	27360856127000	26707	13209	1	0	1
368017	1874	32915000	26707	13209	6	0	2
200857	2134	84213953000	26707	13209	7	0	6357
368018	1874	32918000	26707	13209	7	0	2
200863	2133	90817280000	26708	13210	2	0	5862
368024	1874	32926000	26708	13210	2	0	2
200996	1397	1278343969000	26711	13211	0	0	16048
368157	1678	27360856131000	26711	13211	0	0	1
200997	2134	84209941000	26711	13211	1	0	6361
368158	1874	32938000	26711	13211	1	0	2
201003	2133	90814274000	26712	13212	4	0	5865
368164	1874	32948000	26712	13212	4	0	2
26363	1619	7920159000000	26712	13212	7	0	0
201012	1397	1278313966000	26714	13213	0	0	16051
201013	1397	1278303965000	26714	13213	1	0	16052
368176	1874	32956000	26714	13213	3	0	2
16142	1474	12870607000043	26714	13213	7	0	29
201023	2133	90810266000	26716	13214	1	0	5869
368185	1874	32964000	26716	13214	2	0	2
12356	1434	2879144000000	26716	13214	5	0	1
201032	1397	1278273962000	26719	13216	0	0	16055
368194	1874	32975000	26719	13216	1	0	2
201042	2133	90807260000	26722	13217	2	0	5872
7510	1394	897134136440200	26722	13217	5	0	0
368205	1678	27360856140000	26724	13218	0	0	1
201048	2133	90805256000	26724	13218	4	0	5874
368210	1874	32989000	26724	13218	5	0	2
201054	2133	90803252000	26725	13219	2	0	5876
368216	1874	33001000	26725	13219	3	0	2
201073	1397	1278203955000	26729	13221	0	0	16062
368236	1874	33009000	26729	13221	2	0	2
201079	2134	84195899000	26729	13221	6	0	6375
368241	1678	27360856147000	26730	13222	0	0	1
31097	1668	12753747000000	26730	13222	3	0	9
201096	2133	90798242000	26734	13223	2	0	5881
368258	2366	100000000	26734	13223	3	0	0
201101	2132	147305318000	26735	13224	2	0	1683
368264	1678	27360856150000	26736	13225	0	0	1
201107	2133	90795236000	26736	13225	4	0	5884
368269	1874	33043000	26736	13225	5	0	2
9616	1395	58283191891957278	26736	13225	7	0	0
41543	1688	19510765113020	26737	13226	3	0	77
21232	1560	16568843131803	26738	13227	0	0	30
368299	1678	27360856153000	26745	13228	0	0	1
201139	1397	1278113946000	26745	13228	1	0	16071
368300	1678	27360856154000	26745	13228	1	0	1
201144	2132	147304317000	26745	13228	6	0	1684
201145	1397	1278103945000	26746	13229	0	0	16072
368306	1678	27360856155000	26746	13229	0	0	1
201146	1397	1278093944000	26746	13229	1	0	16073
368312	1874	33070000	26746	13229	6	0	2
201173	1397	1278083943000	26749	13230	0	0	16074
57350	1764	14483516100000	26749	13230	3	0	12
368338	1874	33077000	26751	13231	1	0	2
60927	2307	2879060000000	26751	13231	3	0	0
201214	1397	1278063941000	26755	13232	0	0	16076
368399	1678	27360856160000	26760	13233	0	0	1
201242	1397	1278043939000	26760	13233	1	0	16078
368405	1678	27360856162000	26762	13234	0	0	1
201248	2134	84179851000	26762	13234	1	0	6391
7520	1394	901454195440200	26762	13234	4	0	0
368410	1874	33106000	26763	13235	2	0	2
201271	1397	1278013936000	26766	13236	0	0	16081
368429	1678	27360856164000	26766	13236	0	0	1
368430	1678	27360856165000	26766	13236	1	0	1
201276	2133	90781208000	26766	13236	5	0	5898
368436	1874	33119000	26766	13236	7	0	2
201291	1397	1277983933000	26768	13237	0	0	16084
201292	1397	1277973932000	26768	13237	1	0	16085
368452	1874	33128000	26768	13237	3	0	2
32921	1675	19004437999977	26768	13237	6	0	8
201298	1397	1277953930000	26769	13238	1	0	16087
368457	1874	33134000	26769	13238	2	0	2
201304	1397	1277933928000	26770	13239	1	0	16089
368463	1678	27360856173000	26770	13239	2	0	1
201309	2133	90775196000	26770	13239	6	0	5904
368469	1874	33145000	26770	13239	8	0	2
201315	2133	90771188000	26770	13239	12	0	5908
368474	1874	33155000	26770	13239	13	0	2
201321	2134	84167815000	26770	13239	18	0	6403
368480	1874	33173000	26770	13239	19	0	2
201358	2133	90768182000	26774	13240	3	0	5911
368518	1874	33183000	26774	13240	5	0	2
4967	641	79683945000000	26774	13240	7	0	16
201611	1397	1277863921000	26777	13241	0	0	16096
368769	1678	27360856179000	26777	13241	0	0	1
201612	2134	84163803000	26777	13241	1	0	6407
368770	1874	33186000	26777	13241	1	0	2
201618	1397	1277843919000	26779	13243	0	0	16098
368776	1678	27360856181000	26779	13243	0	0	1
201624	1726	960462112000	26779	13243	7	0	8323
368782	2368	100000000	26779	13243	7	0	0
201629	2132	147295308000	26779	13243	12	0	1693
368787	1874	33210000	26779	13243	12	0	2
24418	1601	8305946620000	26782	13244	3	0	21
201663	2134	84157785000	26785	13245	2	0	6413
368821	1874	33220000	26785	13245	2	0	2
368833	1874	33226000	26788	13246	3	0	2
60932	2307	3599072000000	26788	13246	4	0	0
368837	1678	27360856187000	26790	13247	0	0	1
201680	2133	90759164000	26790	13247	1	0	5920
4728	640	67440007000000	26790	13247	3	0	1
201688	2132	147293306000	26792	13248	3	0	1695
368846	1874	33232000	26792	13248	3	0	2
201689	2133	90758162000	26792	13248	4	0	5921
201690	2133	90757160000	26792	13248	5	0	5922
368852	1874	33247000	26792	13248	9	0	2
59378	2039	16459684000000	26792	13248	11	0	6
201705	2134	84151767000	26796	13249	1	0	6419
15153	1458	21545467908540	26796	13249	4	0	8
368868	1874	33254000	26798	13250	1	0	2
201713	2134	84150764000	26799	13251	2	0	6420
368877	1874	33262000	26801	13252	1	0	2
201721	1397	1277703905000	26802	13253	0	0	16112
368886	1874	33273000	26804	13254	1	0	2
201730	2132	147291304000	26804	13254	3	0	1697
368891	1874	33278000	26805	13255	2	0	2
201736	1397	1277663901000	26806	13256	1	0	16116
368897	1874	33284000	26806	13256	4	0	2
201741	2134	84145749000	26806	13256	6	0	6425
368903	1678	27360856201000	26807	13257	0	0	1
201747	2133	90745136000	26807	13257	2	0	5934
7531	1394	905774231440200	26807	13257	4	0	0
368917	1874	33307000	26811	13258	2	0	2
201762	2132	147289302000	26812	13259	2	0	1699
368923	1874	33315000	26812	13259	5	0	2
201774	1397	1277603895000	26814	13260	0	0	16122
368936	1874	33319000	26814	13260	4	0	2
201780	2134	84137725000	26814	13260	6	0	6433
368941	1874	33333000	26814	13260	9	0	2
201786	2133	90738122000	26814	13260	12	0	5941
9626	1395	58285351942957278	26814	13260	13	0	0
368951	1874	33343000	26816	13261	3	0	2
201795	134	66000090000000	26817	13262	0	0	1
368965	1678	27360856211000	26820	13263	1	0	1
201809	2133	90735116000	26820	13263	3	0	5944
201879	1397	1277533888000	26822	13264	0	0	16129
369037	1678	27360856212000	26822	13264	0	0	1
201880	2133	90734114000	26822	13264	1	0	5945
369038	1874	33357000	26822	13264	1	0	2
35033	1679	11518248656999	26822	13264	3	0	100
30216	1654	17417546999798	26827	13265	5	0	11
201901	1397	1277513886000	26828	13266	0	0	16131
369059	1678	27360856214000	26828	13266	0	0	1
7538	1394	908654255440200	26828	13266	3	0	0
201911	2132	147285298000	26831	13268	1	0	1703
369069	1874	33374000	26831	13268	1	0	2
201919	2133	90729104000	26833	13269	2	0	5950
369077	1874	33384000	26833	13269	2	0	2
201927	2134	84125689000	26835	13270	5	0	6445
369085	1874	33392000	26835	13270	5	0	2
201933	2133	90725096000	26836	13271	1	0	5954
369091	1874	33402000	26836	13271	1	0	2
201945	1397	1277423877000	26840	13273	0	0	16140
369103	1678	27360856223000	26840	13273	0	0	1
369105	1874	33414000	26840	13273	2	0	2
369106	1874	33416000	26840	13273	3	0	2
201951	2134	84120674000	26841	13274	2	0	6450
29893	1650	10193045000000	26841	13274	3	0	9
369115	1874	33426000	26843	13275	2	0	2
201960	2134	84118668000	26844	13276	2	0	6452
201961	2132	147282295000	26844	13276	3	0	1706
7544	1394	912974293440200	26844	13276	5	0	0
201962	1397	1277383873000	26845	13277	0	0	16144
369121	1678	27360856228000	26845	13277	1	0	1
201968	2133	90718082000	26845	13277	6	0	5961
369126	1874	33439000	26845	13277	6	0	2
201974	2134	84114656000	26845	13277	12	0	6456
369132	1874	33453000	26845	13277	12	0	2
27099	1623	81363350898598	26845	13277	13	0	1
201979	2134	84113653000	26847	13279	2	0	6457
369138	1874	33460000	26847	13279	3	0	2
201985	2133	90712070000	26848	13280	1	0	5967
369143	1874	33468000	26848	13280	1	0	2
201994	1397	1277283863000	26851	13282	1	0	16154
369152	1678	27360856237000	26851	13282	1	0	1
201999	2134	84108638000	26851	13282	6	0	6462
41569	1688	20950814113019	26851	13282	8	1	77
369161	1678	27360856238000	26853	13283	0	0	1
202137	1397	1277263861000	26857	13284	0	0	16156
369295	1678	27360856239000	26857	13284	0	0	1
202138	1397	1277253860000	26857	13284	1	0	16157
369296	1678	27360856240000	26857	13284	1	0	1
202144	2133	90707060000	26857	13284	7	0	5972
369302	1874	33504000	26857	13284	7	0	2
14722	1457	13680314800000	26857	13284	11	0	8
202291	1397	1277223857000	26864	13286	0	0	16160
369449	1678	27360856243000	26864	13286	0	0	1
202292	1397	1277213856000	26864	13286	1	0	16161
369450	1678	27360856244000	26864	13286	1	0	1
202305	1397	1277203855000	26866	13287	0	0	16162
369463	1678	27360856245000	26866	13287	0	0	1
9636	1395	58286792016957278	26866	13287	4	0	0
202311	2132	147276289000	26867	13288	3	0	1712
369469	1874	33535000	26867	13288	3	0	2
29190	1639	720013000000	26867	13288	5	0	3
202328	2133	90698042000	26873	13290	1	0	5981
369486	1874	33542000	26873	13290	1	0	2
202334	2132	147275288000	26874	13291	4	0	1713
369492	1874	33551000	26874	13291	4	0	2
61028	2329	313206453819988	26876	13292	4	0	0
202349	2133	90695036000	26879	13293	2	0	5984
369507	1874	33561000	26879	13293	2	0	2
202450	1397	1277133848000	26883	13294	0	0	16169
369608	1678	27360856252000	26883	13294	0	0	1
202451	1397	1277123847000	26883	13294	1	0	16170
369609	1678	27360856253000	26883	13294	1	0	1
202457	2134	84092590000	26883	13294	7	0	6478
369615	1874	33572000	26883	13294	7	0	2
202470	1397	1277093844000	26887	13296	0	0	16173
369628	1678	27360856256000	26887	13296	0	0	1
202479	2134	84088578000	26889	13297	1	0	6482
369637	1874	33591000	26889	13297	1	0	2
7554	1394	917294343440200	26891	13298	4	0	0
202488	2132	147272285000	26892	13299	1	0	1716
369646	1874	33599000	26892	13299	1	0	2
202525	1397	1277053840000	26895	13300	0	0	16177
369683	1678	27360856260000	26895	13300	0	0	1
202526	1397	1277043839000	26895	13300	1	0	16178
369684	1678	27360856261000	26895	13300	1	0	1
202532	2133	90685016000	26895	13300	7	0	5994
369690	1874	33617000	26895	13300	7	0	2
53092	1717	16381337000055	26895	13300	10	0	8
202547	2134	84082560000	26897	13301	4	0	6488
369705	1874	33626000	26897	13301	4	0	2
202574	1397	1276983833000	26900	13302	2	0	16184
369732	1678	27360856267000	26900	13302	2	0	1
202580	2133	90679004000	26900	13302	8	0	6000
369738	1874	33642000	26900	13302	8	0	2
202586	2133	90677000000	26901	13303	3	0	6002
369744	1874	33652000	26901	13303	3	0	2
202591	2133	90675998000	26902	13304	2	0	6003
369749	1874	33663000	26902	13304	2	0	2
25324	1608	15978585000000	26902	13304	4	0	8
202600	2133	90673994000	26905	13306	2	0	6005
369758	1874	33673000	26905	13306	2	0	2
51972	1711	17707061000000	26905	13306	4	0	13
202606	2133	90671990000	26906	13307	5	0	6007
369764	1874	33683000	26906	13307	5	0	2
13633	1447	19721899683000	26906	13307	7	0	10
202626	2133	90669986000	26912	13309	1	0	6009
369784	1874	33690000	26912	13309	1	0	2
369785	1874	33693000	26912	13309	2	0	2
369789	1678	27360856278000	26914	13310	0	0	1
17450	1508	14600447156616	26914	13310	4	0	10
202635	2133	90667982000	26915	13311	1	0	6011
31868	1671	15504258003785	26915	13311	3	0	8
369798	1874	33702000	26917	13312	1	0	2
202641	2134	84066512000	26917	13312	2	0	6504
202642	1397	1276843819000	26918	13313	0	0	16198
369804	1874	33712000	26918	13313	4	0	2
39429	1684	28803458819412	26918	13313	6	0	136
202648	1397	1276823817000	26919	13314	0	0	16200
369809	1874	33720000	26919	13314	3	0	2
202728	1397	1276803815000	26922	13315	0	0	16202
7561	1394	921614414440200	26922	13315	3	0	0
369889	1678	27360856286000	26923	13316	0	0	1
202733	2133	90660968000	26923	13316	2	0	6018
26479	1622	8964028800048	26924	13317	3	0	10
369898	1678	27360856288000	26926	13318	0	0	1
202742	2133	90658964000	26926	13318	2	0	6020
369906	1874	33750000	26928	13319	2	0	2
202760	1397	1276733808000	26930	13320	2	0	16209
369921	1874	33756000	26930	13320	5	0	2
369922	1874	33759000	26930	13320	6	0	2
202765	2134	84055479000	26930	13320	7	0	6515
40516	1685	179284562571430	26930	13320	8	0	0
369934	1874	33770000	26932	13321	3	0	2
202777	2133	90652952000	26932	13321	4	0	6026
202778	2134	84052470000	26932	13321	5	0	6518
59872	2106	3600186000000	26932	13321	7	0	2
369952	1678	27360856296000	26936	13323	0	0	1
202796	2134	84050464000	26936	13323	2	0	6520
369960	1874	33790000	26938	13324	2	0	2
36069	1680	14413377499559	26938	13324	3	0	12
202805	2134	84048458000	26939	13325	2	0	6522
57779	1768	23507126110000	26939	13325	3	0	10
369969	1678	27360856301000	26941	13326	2	0	1
202813	2134	84046452000	26941	13326	4	0	6524
369975	1874	33810000	26941	13326	8	0	2
202828	1397	1276623797000	26943	13327	1	0	16220
369989	1874	33813000	26943	13327	5	0	2
202834	2133	90643934000	26943	13327	7	0	6035
369995	1874	33827000	26943	13327	11	0	2
202839	2134	84041437000	26943	13327	12	0	6529
370007	1874	33837000	26947	13329	1	0	2
202851	2134	84039431000	26947	13329	2	0	6531
370018	1678	27360856309000	26951	13331	0	0	1
202863	2134	84037425000	26951	13331	2	0	6533
50419	1705	25041004580140	26951	13331	3	0	25
370031	1874	33855000	26954	13332	3	0	2
46705	1693	10070954570272	26954	13332	4	0	1249
202886	1397	1276543789000	26958	13333	0	0	16228
17804	1509	16223430503835	26958	13333	3	0	9
370062	1678	27360856312000	26960	13334	0	0	1
370063	1678	27360856313000	26960	13334	1	0	1
202908	2134	84034416000	26960	13334	3	0	6536
3911	606	77566903286230	26960	13334	8	0	18
202924	1397	1276513786000	26963	13335	0	0	16231
202925	1397	1276503785000	26963	13335	1	0	16232
370080	1678	27360856315000	26963	13335	1	0	1
202931	2133	90630908000	26964	13336	2	0	6048
370086	1874	33882000	26964	13336	2	0	2
60125	2112	25006980101924	26964	13336	3	0	7
370091	1874	33890000	26966	13338	1	0	2
202937	2133	90628904000	26966	13338	2	0	6050
203072	1397	1276463781000	26971	13339	0	0	16236
370225	1678	27360856319000	26971	13339	0	0	1
203073	2133	90627902000	26971	13339	1	0	6051
370226	1874	33894000	26971	13339	1	0	2
203100	2134	84026392000	26980	13341	1	0	6544
370253	1874	33907000	26980	13341	1	0	2
203106	2133	90624896000	26981	13342	5	0	6054
370259	1874	33915000	26981	13342	5	0	2
32926	1675	20444531999977	26981	13342	8	0	8
203111	2133	90622892000	26982	13343	3	0	6056
370264	1874	33919000	26982	13343	3	0	2
20766	1559	11826164999999	26982	13343	9	0	8
203117	1397	1276383773000	26983	13344	0	0	16244
370270	1678	27360856327000	26983	13344	0	0	1
203123	1397	1276363771000	26984	13345	0	0	16246
370276	1678	27360856329000	26984	13345	0	0	1
203130	2134	84017365000	26986	13346	2	0	6553
370283	1874	33952000	26986	13346	2	0	2
7574	1394	925934487440200	26986	13346	3	0	0
59071	1992	15121106990000	26987	13347	3	0	5
36377	1681	17134780358535	26988	13348	3	0	11
203136	1397	1276333768000	26989	13349	0	0	16249
370289	1678	27360856332000	26989	13349	0	0	1
203142	1397	1276313766000	26990	13350	0	0	16251
370295	1678	27360856334000	26990	13350	0	0	1
55925	1747	4386022999992	26990	13350	4	0	6
203156	2133	90610868000	26994	13351	2	0	6068
370309	1874	33982000	26994	13351	2	0	2
203162	1397	1276263761000	26996	13353	2	0	16256
370315	1678	27360856339000	26996	13353	2	0	1
19529	1546	13197518800000	26996	13353	8	0	10
203179	1397	1276253760000	26999	13354	0	0	16257
370332	1678	27360856340000	26999	13354	0	0	1
370333	1874	34002000	26999	13354	1	0	2
48324	1698	13028981550062	27000	13355	2	0	12
203186	1397	1276233758000	27002	13356	0	0	16259
203187	2133	90604856000	27002	13356	1	0	6074
370341	1874	34011000	27002	13356	2	0	2
41606	1688	23110851113019	27002	13356	5	0	77
203208	1397	1276213756000	27007	13358	0	0	16261
370362	1678	27360856345000	27007	13358	1	0	1
203220	1397	1276193754000	27009	13359	0	0	16263
370373	1678	27360856346000	27009	13359	0	0	1
203229	2133	90598844000	27012	13360	2	0	6080
370383	1874	34038000	27012	13360	3	0	2
9648	1395	58288952064957278	27012	13360	7	0	0
203244	2134	83998308000	27016	13361	3	0	6572
48062	1696	20603824335104	27016	13361	5	0	9
370398	1678	27360856350000	27017	13362	0	0	1
18617	1522	11563751000000	27020	13363	3	0	14
203258	1397	1276133748000	27022	13364	0	0	16269
370411	1678	27360856352000	27022	13364	0	0	1
203266	2133	90593834000	27024	13365	2	0	6085
58813	1991	14301437355805	27024	13365	3	0	21
370423	1874	34070000	27026	13366	0	0	2
203401	1397	1276113746000	27029	13367	0	0	16271
370552	1678	27360856354000	27029	13367	0	0	1
203402	1397	1276103745000	27029	13367	1	0	16272
370553	1678	27360856355000	27029	13367	1	0	1
49533	1702	6480545000000	27029	13367	5	0	5
203449	1397	1276083743000	27035	13369	0	0	16274
370600	1678	27360856357000	27035	13369	0	0	1
370601	1874	34085000	27035	13369	1	0	2
370602	1874	34087000	27035	13369	2	0	2
203519	1397	1276073742000	27043	13370	0	0	16275
203520	2133	90588824000	27043	13370	1	0	6090
370674	2373	100000000	27043	13370	4	0	0
203540	2134	83989281000	27045	13371	2	0	6581
370692	1874	34096000	27046	13372	2	0	2
203546	2133	90585818000	27046	13372	5	0	6093
7586	1394	930254523440200	27046	13372	6	0	0
370703	1678	27360856363000	27048	13373	1	0	1
203557	2133	90584816000	27048	13373	4	0	6094
370738	1678	27360856364000	27054	13375	0	0	1
370739	1678	27360856365000	27054	13375	1	0	1
203592	2134	83983263000	27054	13375	3	0	6587
203593	2134	83982260000	27054	13375	4	0	6588
203594	2133	90582812000	27054	13375	5	0	6096
370745	1874	34129000	27054	13375	7	0	2
203608	2134	83981257000	27056	13376	3	0	6589
370759	1874	34139000	27056	13376	5	0	2
203623	1397	1275953730000	27060	13378	0	0	16287
370773	1874	34147000	27060	13378	1	0	2
203628	2133	90575798000	27061	13379	2	0	6103
370779	1874	34156000	27061	13379	4	0	2
203634	1611	5687627453965	27062	13380	2	0	14
370785	1215	614518911673154	27062	13380	4	0	0
203640	1397	1275913726000	27063	13381	0	0	16291
370790	1874	34169000	27063	13381	2	0	2
7592	1394	933134583440200	27063	13381	4	0	0
203646	2133	90571790000	27066	13382	3	0	6107
370797	1874	34179000	27066	13382	6	0	2
21970	1571	9980674124162	27066	13382	7	0	47
203787	1397	1275883723000	27070	13383	0	0	16294
370934	1678	27360856377000	27070	13383	0	0	1
203788	1397	1275873722000	27070	13383	1	0	16295
370935	1678	27360856378000	27070	13383	1	0	1
60356	2148	10800332880750	27070	13383	6	0	2
203802	2134	83969221000	27073	13384	1	0	6601
370949	1874	34192000	27073	13384	1	0	2
9658	1395	58291112099957278	27074	13385	4	0	0
203811	1397	1275833718000	27076	13386	1	0	16299
370958	1678	27360856382000	27076	13386	1	0	1
32133	1672	12241482000000	27076	13386	6	0	10
203819	2133	90563774000	27078	13387	1	0	6115
370966	1874	34208000	27078	13387	1	0	2
44844	1691	11231132300052	27079	13388	4	0	10
203868	1397	1275803715000	27081	13389	0	0	16302
371015	1678	27360856385000	27081	13389	0	0	1
203869	2134	83964206000	27081	13389	1	0	6606
371016	1874	34219000	27081	13389	1	0	2
203875	1397	1275773712000	27083	13391	1	0	16305
371022	1678	27360856388000	27083	13391	1	0	1
203881	2133	90559766000	27083	13391	7	0	6119
371028	1874	34237000	27083	13391	7	0	2
203886	2134	83959191000	27084	13392	2	0	6611
371033	1874	34244000	27084	13392	2	0	2
203916	2133	90554756000	27089	13393	2	0	6124
371063	1874	34256000	27089	13393	2	0	2
10500	1402	47703444145435	27089	13393	4	0	66
40524	1685	181444587571430	27091	13394	4	0	0
203925	2134	83955179000	27092	13395	2	0	6615
371072	1874	34266000	27092	13395	2	0	2
203930	2133	90550748000	27093	13396	4	0	6128
371077	1874	34273000	27093	13396	4	0	2
47270	1694	18539085197225	27094	13397	3	0	62
203942	1397	1275663701000	27100	13398	1	0	16316
371089	1678	27360856399000	27100	13398	1	0	1
21568	1564	13326847000000	27100	13398	6	0	10
203948	1397	1275643699000	27101	13399	1	0	16318
371095	1678	27360856401000	27101	13399	1	0	1
203959	1397	1275633698000	27103	13400	0	0	16319
371106	1678	27360856402000	27103	13400	0	0	1
203965	1397	1275613696000	27104	13401	0	0	16321
371112	1678	27360856404000	27104	13401	0	0	1
7598	1394	937454631440200	27104	13401	4	0	0
203977	1397	1275593694000	27109	13403	0	0	16323
371124	1678	27360856406000	27109	13403	0	0	1
204107	1397	1275583693000	27112	13404	0	0	16324
371253	1678	27360856407000	27112	13404	0	0	1
204108	2133	90539726000	27112	13404	1	0	6139
371254	1874	34328000	27112	13404	1	0	2
61039	2329	315366481819988	27114	13405	3	0	0
204117	2134	83941137000	27115	13406	3	0	6629
371263	1874	34338000	27115	13406	3	0	2
25553	1610	10800259999950	27115	13406	5	0	11
204126	2133	90535718000	27118	13408	2	0	6143
371272	1874	34348000	27118	13408	2	0	2
204134	1397	1275513686000	27121	13410	1	0	16331
371280	1678	27360856414000	27121	13410	1	0	1
371281	1874	34355000	27121	13410	2	0	2
371282	1874	34358000	27121	13410	3	0	2
204137	2133	90532712000	27121	13410	4	0	6146
204138	2134	83936122000	27121	13410	5	0	6634
371288	1874	34371000	27122	13411	3	0	2
7604	1394	941774669440200	27122	13411	6	0	0
204149	1397	1275493684000	27124	13412	0	0	16333
371299	1874	34380000	27125	13413	1	0	2
204155	1397	1275473682000	27126	13414	0	0	16335
371304	1678	27360856419000	27127	13415	0	0	1
204160	2133	90526700000	27127	13415	2	0	6152
371313	1678	27360856421000	27130	13417	0	0	1
204169	1397	1275423677000	27130	13417	2	0	16340
371319	1874	34409000	27130	13417	6	0	2
204175	2133	90522692000	27130	13417	8	0	6156
371333	1874	34418000	27132	13418	2	0	2
204197	2134	83924086000	27136	13419	1	0	6646
9662	1395	58291832099957278	27136	13419	3	0	0
371350	1874	34428000	27139	13420	2	0	2
204215	2133	90518684000	27143	13421	1	0	6160
371365	1678	27360856430000	27144	13422	2	0	1
204221	2133	90516680000	27144	13422	4	0	6162
371370	1874	34445000	27144	13422	7	0	2
204240	2134	83919071000	27148	13423	1	0	6651
371390	1874	34458000	27149	13424	3	0	2
45142	1692	11260822819983	27149	13424	6	1	6
204371	2133	90511670000	27151	13425	0	0	6167
371517	1874	34462000	27151	13425	0	0	2
204372	2134	83916062000	27151	13425	1	0	6654
371518	1874	34465000	27151	13425	1	0	2
204402	2134	83915059000	27154	13426	5	0	6655
371548	1874	34470000	27154	13426	5	0	2
7612	1394	946094717440200	27154	13426	6	0	0
371553	1678	27360856438000	27157	13428	1	0	1
204408	2133	90508664000	27157	13428	2	0	6170
371554	1874	34477000	27157	13428	2	0	2
204409	2133	90507662000	27157	13428	3	0	6171
204410	2134	83913053000	27157	13428	4	0	6657
7617	1394	947534783440200	27157	13428	7	0	0
371566	1874	34490000	27159	13429	2	0	2
46775	1693	11510991570272	27159	13429	4	0	1249
204422	1397	1275243659000	27160	13430	1	0	16358
371572	1874	34497000	27160	13430	5	0	2
204428	2134	83908038000	27160	13430	7	0	6662
371580	1874	34508000	27162	13431	1	0	2
204436	1397	1275213656000	27163	13432	0	0	16361
7618	1394	948974783440200	27163	13432	3	0	0
371591	1874	34518000	27165	13433	1	0	2
204454	1397	1275193654000	27168	13434	0	0	16363
371603	1678	27360856448000	27169	13435	1	0	1
204460	2133	90498644000	27169	13435	3	0	6180
69	42	74300698000000	27169	13435	6	0	12
371613	1874	34535000	27171	13436	1	0	2
48995	1700	12474304979053	27171	13436	3	0	10
204470	1397	1275153650000	27172	13437	0	0	16367
371619	1874	34544000	27173	13438	1	0	2
20098	1549	13391420000000	27173	13438	3	0	10
204476	1397	1275133648000	27174	13439	0	0	16369
371625	1874	34555000	27175	13440	1	0	2
204482	1397	1275113646000	27176	13441	0	0	16371
371630	1678	27360856455000	27177	13442	0	0	1
204487	2134	83896002000	27177	13442	2	0	6674
41628	1688	25270876113019	27177	13442	6	0	77
371642	1678	27360856457000	27179	13443	0	0	1
204499	2134	83893996000	27179	13443	2	0	6676
61049	2329	317526529819988	27179	13443	7	0	0
204628	1397	1275063641000	27181	13444	0	0	16376
371773	1678	27360856459000	27181	13444	0	0	1
204629	2133	90486620000	27181	13444	1	0	6192
371774	1874	34584000	27181	13444	1	0	2
204647	2134	83889984000	27184	13445	5	0	6680
371792	1874	34595000	27184	13445	5	0	2
46805	1693	12231001570272	27184	13445	7	0	1249
204658	2133	90482612000	27188	13447	1	0	6196
371803	1874	34604000	27188	13447	1	0	2
50758	1706	19002282450256	27188	13447	3	0	27
204671	1397	1275003635000	27193	13449	0	0	16382
371816	1678	27360856465000	27193	13449	0	0	1
204677	1397	1274983633000	27194	13450	0	0	16384
371822	1678	27360856467000	27194	13450	0	0	1
204804	1397	1274973632000	27196	13451	0	0	16385
371949	1678	27360856468000	27196	13451	0	0	1
204805	1397	1274963631000	27196	13451	1	0	16386
371950	1678	27360856469000	27196	13451	1	0	1
40531	1685	182884635571430	27196	13451	7	0	0
204811	2133	90476600000	27197	13452	1	0	6202
371956	1874	34637000	27197	13452	1	0	2
371961	1874	34645000	27198	13453	3	0	2
204817	1726	953856112000	27198	13453	4	0	8329
371962	2375	100000000	27198	13453	4	0	0
12183	1426	14730429000000	27198	13453	5	0	8
204830	1397	1274933628000	27202	13454	0	0	16389
9673	1395	58293992159957278	27202	13454	3	0	0
371980	1874	34653000	27203	13455	2	0	2
204836	1726	952755112000	27203	13455	3	0	8330
371993	1874	34662000	27205	13456	1	0	2
204849	2134	83875942000	27205	13456	2	0	6694
372001	1874	34670000	27207	13457	3	0	2
204857	2133	90469586000	27207	13457	4	0	6209
41655	1688	27430923113019	27207	13457	5	0	77
372013	1874	34680000	27212	13459	1	0	2
204869	2133	90467582000	27212	13459	2	0	6211
51332	1709	10080232000000	27212	13459	3	0	8
204980	1397	1274853620000	27215	13460	0	0	16397
372125	1678	27360856480000	27215	13460	0	0	1
204981	1397	1274843619000	27215	13460	1	0	16398
372126	1678	27360856481000	27215	13460	1	0	1
204987	2133	90466580000	27215	13460	7	0	6212
372132	1874	34684000	27215	13460	7	0	2
204993	2134	83866915000	27215	13460	13	0	6703
372138	1874	34702000	27215	13460	13	0	2
204998	2133	90462572000	27215	13460	18	0	6216
372143	1874	34713000	27215	13460	18	0	2
205073	2134	83864909000	27217	13461	3	0	6705
372218	1874	34720000	27217	13461	3	0	2
7624	1394	953294819440200	27217	13461	9	0	0
205103	1397	1274753610000	27222	13462	0	0	16407
372248	1678	27360856490000	27222	13462	0	0	1
205104	2134	83861900000	27222	13462	1	0	6708
372249	1874	34735000	27222	13462	1	0	2
31896	1671	16944306003785	27222	13462	3	0	8
205128	1397	1274723607000	27229	13464	1	0	16410
372273	1678	27360856493000	27229	13464	1	0	1
54347	1724	14092796500000	27229	13464	7	0	15
205134	2134	83857888000	27230	13465	1	0	6712
372279	1874	34755000	27230	13465	1	0	2
205149	1397	1274693604000	27236	13467	0	0	16413
372294	1678	27360856496000	27236	13467	0	0	1
205157	2134	83854879000	27239	13468	3	0	6715
372302	1874	34770000	27239	13468	3	0	2
205163	1397	1274653600000	27240	13469	0	0	16417
372308	1678	27360856500000	27240	13469	0	0	1
205176	2133	90444536000	27244	13471	1	0	6234
372321	1874	34782000	27244	13471	1	0	2
9683	1395	58296152268957278	27245	13472	3	0	0
205186	1397	1274613596000	27248	13473	0	0	16421
372331	1678	27360856504000	27248	13473	0	0	1
57078	1762	11445659994000	27248	13473	4	0	8
205320	1397	1274603595000	27252	13474	0	0	16422
372465	1678	27360856505000	27252	13474	0	0	1
205321	2134	83850867000	27252	13474	1	0	6719
372466	1874	34798000	27252	13474	1	0	2
53662	1719	17278685000000	27252	13474	3	0	10
412	43	80400269890000	27254	13475	4	0	3
205333	2133	90439526000	27256	13476	1	0	6239
372478	1874	34807000	27256	13476	1	0	2
205350	2134	83846855000	27266	13478	1	0	6723
372495	1874	34818000	27266	13478	1	0	2
9688	1395	58297592304957278	27266	13478	4	0	0
205460	1397	1274543589000	27273	13480	0	0	16428
372605	1678	27360856511000	27273	13480	0	0	1
205461	1397	1274533588000	27273	13480	1	0	16429
372606	1678	27360856512000	27273	13480	1	0	1
205473	2133	90433514000	27275	13481	1	0	6245
372618	1874	34837000	27275	13481	1	0	2
16495	1476	16560383000000	27277	13482	3	0	11
205485	2134	83840837000	27279	13483	1	0	6729
372630	1874	34848000	27279	13483	1	0	2
205490	2134	83839834000	27281	13484	3	0	6730
372635	1874	34853000	27281	13484	3	0	2
21984	1571	11420749124178	27281	13484	10	0	47
205496	2133	90427502000	27282	13485	0	0	6251
372641	1874	34867000	27282	13485	0	0	2
205497	2134	83836825000	27282	13485	1	0	6733
372642	1874	34870000	27282	13485	1	0	2
23626	1594	16561901000000	27282	13485	3	0	10
205632	1397	1274463581000	27285	13486	0	0	16436
372777	1678	27360856519000	27285	13486	0	0	1
205633	1397	1274453580000	27285	13486	1	0	16437
372778	1678	27360856520000	27285	13486	1	0	1
205634	2134	83835822000	27285	13486	2	0	6734
372789	1678	27360856522000	27290	13488	0	0	1
205645	2134	83832813000	27290	13488	1	0	6737
372799	1874	34890000	27294	13490	2	0	2
205655	2134	83829804000	27294	13490	3	0	6740
372811	1678	27360856527000	27298	13492	0	0	1
205667	1397	1274373572000	27298	13492	1	0	16445
372817	1678	27360856529000	27299	13493	0	0	1
205673	2134	83825792000	27299	13493	1	0	6744
372826	1678	27360856531000	27302	13495	0	0	1
205682	1397	1274333568000	27302	13495	1	0	16449
372831	1874	34928000	27302	13495	5	0	2
205687	1397	1274323567000	27303	13496	0	0	16450
32379	1673	10295447000000	27303	13496	3	0	18
372840	1874	34938000	27305	13497	2	0	2
205705	1397	1274303565000	27309	13498	0	0	16452
372855	1874	34948000	27310	13499	2	0	2
205711	1397	1274283563000	27311	13500	0	0	16454
35058	1679	12958284656999	27311	13500	4	0	100
372860	1874	34956000	27312	13501	1	0	2
205716	2133	90413474000	27312	13501	2	0	6265
372866	1874	34966000	27314	13502	4	0	2
205722	2133	90411470000	27314	13502	5	0	6267
7635	1394	957614903440200	27315	13503	3	0	0
372872	1874	34976000	27316	13504	1	0	2
205728	2133	90409466000	27316	13504	2	0	6269
372886	1874	34982000	27319	13505	3	0	2
205742	2134	83811750000	27319	13505	4	0	6758
372892	1678	27360856546000	27321	13507	0	0	1
205748	1397	1274183553000	27321	13507	1	0	16464
20590	1555	16806288540449	27321	13507	7	0	8
372904	1678	27360856548000	27323	13508	0	0	1
205760	2133	90403454000	27323	13508	1	0	6275
205780	1397	1274163551000	27330	13509	0	0	16466
372925	1678	27360856549000	27330	13509	0	0	1
205781	2133	90402452000	27330	13509	1	0	6276
372926	1874	35010000	27330	13509	1	0	2
205790	1751	1439011000000	27333	13511	1	0	1
372935	1454	0	27333	13511	1	0	0
41710	1688	29590970113019	27333	13511	4	0	77
205799	1397	1274123547000	27336	13513	0	0	16470
372944	1678	27360856553000	27336	13513	0	0	1
205804	2133	90397442000	27336	13513	5	0	6281
372949	1874	35035000	27336	13513	5	0	2
46871	1693	14391039570272	27336	13513	9	0	1249
205810	2133	90395438000	27337	13514	2	0	6283
372955	1874	35048000	27337	13514	2	0	2
841	58	78227565999641	27338	13515	3	0	12
205816	2134	83796705000	27339	13516	2	0	6773
372961	1874	35058000	27339	13516	2	0	2
1271	149	79775430000341	27339	13516	3	0	10
205827	2134	83794699000	27342	13517	4	0	6775
372972	1874	35066000	27342	13517	4	0	2
9696	1395	58299752362957278	27343	13518	4	0	0
205833	2134	83792693000	27344	13519	1	0	6777
372978	1874	35076000	27344	13519	1	0	2
205845	2134	83790687000	27348	13521	1	0	6779
372990	1874	35086000	27348	13521	1	0	2
16176	1474	15030631000043	27348	13521	3	0	29
205853	1397	1273993534000	27352	13523	0	0	16483
372998	1678	27360856566000	27352	13523	0	0	1
205859	2134	83787678000	27352	13523	6	0	6782
373004	1874	35103000	27352	13523	6	0	2
205865	2133	90381410000	27353	13524	3	0	6297
373010	1874	35112000	27353	13524	3	0	2
205876	1397	1273923527000	27355	13525	2	0	16490
373021	1678	27360856573000	27355	13525	2	0	1
205882	2133	90378404000	27355	13525	8	0	6300
373027	1874	35133000	27355	13525	8	0	2
35127	1679	15838320656999	27355	13525	9	0	100
205910	1397	1273913526000	27359	13526	0	0	16491
373055	1678	27360856574000	27359	13526	0	0	1
205911	1397	1273903525000	27359	13526	1	0	16492
373056	1678	27360856575000	27359	13526	1	0	1
205917	2134	83779654000	27359	13526	7	0	6790
373062	1874	35145000	27359	13526	7	0	2
4635	633	80109580900000	27359	13526	11	0	9
205935	1397	1273873522000	27361	13527	1	0	16495
373080	1678	27360856578000	27361	13527	1	0	1
205940	2134	83777648000	27361	13527	6	0	6792
373085	1874	35157000	27361	13527	6	0	2
27670	1634	16943180259504	27361	13527	10	0	18
205946	1397	1273843519000	27363	13529	0	0	16498
373091	1678	27360856581000	27363	13529	0	0	1
205952	1726	948351112000	27364	13530	3	0	8334
373097	2380	100000000	27364	13530	3	0	0
206022	2134	83770627000	27368	13532	1	0	6799
373167	1874	35186000	27368	13532	1	0	2
206031	2134	83768621000	27371	13534	1	0	6801
373176	1874	35196000	27371	13534	1	0	2
206040	1397	1273763511000	27374	13536	1	0	16506
373185	1678	27360856589000	27374	13536	1	0	1
206041	1397	1273753510000	27374	13536	2	0	16507
373186	1678	27360856590000	27374	13536	2	0	1
206042	1397	1273743509000	27374	13536	3	0	16508
373192	1874	35213000	27374	13536	8	0	2
206048	2134	83764609000	27374	13536	9	0	6805
373198	1874	35228000	27374	13536	14	0	2
206069	1397	1273723507000	27376	13537	0	0	16510
373218	1874	35235000	27376	13537	4	0	2
206074	2134	83760597000	27376	13537	5	0	6809
49331	1701	14398384500103	27376	13537	7	0	14
11442	1419	25486215559748	27378	13538	4	0	8
373233	1874	35245000	27380	13539	1	0	2
206089	2134	83758591000	27380	13539	2	0	6811
2065	369	80916633290830	27380	13539	3	0	16
373248	1874	35253000	27382	13540	4	0	2
206104	2134	83756585000	27382	13540	5	0	6813
373262	1678	27360856600000	27386	13541	0	0	1
206118	2133	90351350000	27386	13541	1	0	6327
49832	1703	6480908000000	27386	13541	3	0	5
373280	1874	35272000	27389	13542	3	0	2
206136	2134	83753576000	27389	13542	4	0	6816
373286	1874	35283000	27390	13543	3	0	2
206142	2134	83750567000	27390	13543	4	0	6819
373291	1874	35293000	27391	13544	2	0	2
29577	1649	13431621999968	27391	13544	4	0	8
206150	1397	1273593494000	27395	13546	0	0	16523
373300	1874	35296000	27395	13546	5	0	2
206156	2134	83747558000	27395	13546	6	0	6822
373306	1874	35312000	27395	13546	11	0	2
206162	2133	90343334000	27395	13546	12	0	6335
10536	1402	49863540145435	27395	13546	16	0	66
373311	1678	27360856612000	27396	13547	1	0	1
206167	2134	83743546000	27396	13547	2	0	6826
206177	1397	1273523487000	27399	13548	0	0	16530
373322	1678	27360856613000	27399	13548	0	0	1
206178	2134	83741540000	27399	13548	1	0	6828
373323	1874	35331000	27399	13548	1	0	2
56705	1759	11017294139889	27399	13548	3	0	11
206187	2134	83739534000	27402	13550	1	0	6830
373332	1874	35341000	27402	13550	1	0	2
7648	1394	960494939440200	27402	13550	4	0	0
27310	1633	9408647125277	27404	13551	3	0	12
206199	2134	83737528000	27406	13552	1	0	6832
373344	1874	35351000	27406	13552	1	0	2
50429	1705	27201040580140	27406	13552	3	0	25
206207	1397	1273463481000	27409	13554	0	0	16536
373352	1678	27360856619000	27409	13554	0	0	1
206234	1397	1273443479000	27418	13556	0	0	16538
373379	1678	27360856621000	27418	13556	0	0	1
9708	1395	58301912398957278	27418	13556	4	0	0
206243	2134	83732513000	27420	13557	3	0	6837
373388	1874	35376000	27420	13557	3	0	2
206248	2133	90327302000	27420	13557	8	0	6351
373393	1874	35388000	27420	13557	8	0	2
373457	1874	35392000	27424	13558	4	0	2
206313	2133	90324296000	27424	13558	5	0	6354
373458	1874	35394000	27424	13558	5	0	2
206314	2134	83729504000	27424	13558	6	0	6840
373473	1874	35408000	27426	13559	2	0	2
60539	2248	12239534000000	27426	13559	3	0	0
206341	1397	1273363471000	27431	13560	0	0	16546
55397	1740	16290871000000	27431	13560	3	0	14
373491	1874	35418000	27432	13561	2	0	2
206347	1397	1273343469000	27433	13562	0	0	16548
7659	1394	964814999440200	27433	13562	4	0	0
373505	1874	35426000	27437	13563	1	0	2
206361	2133	90319286000	27437	13563	2	0	6359
51652	1710	16074096664140	27437	13563	3	0	10
373519	1874	35435000	27440	13564	4	0	2
206375	2134	83720477000	27440	13564	5	0	6849
60936	2307	4319085000000	27440	13564	7	0	0
57869	1796	200000005	27445	13565	5	0	0
21642	1568	225000	27445	13565	5	1	0
51017	1708	13320657324650	27445	13565	6	1	8
373547	1678	27360856636000	27448	13566	0	0	1
206403	1397	1273283463000	27448	13566	1	0	16554
373552	1874	35453000	27448	13566	5	0	2
13954	1448	12919913000001	27448	13566	7	0	16
206423	1397	1273273462000	27452	13567	0	0	16555
373573	1874	35463000	27453	13568	2	0	2
3948	606	79006915286230	27453	13568	3	0	18
206429	1397	1273253460000	27454	13569	0	0	16557
373582	1874	35473000	27456	13570	2	0	2
206441	1397	1273233458000	27458	13571	0	0	16559
373590	652	66846781394804	27458	13571	4	0	0
206446	1693	14836988098475	27458	13571	5	0	1253
373593	191	66846781394804	27458	13571	7	0	0
206449	1693	14631185538407	27458	13571	8	0	1256
373594	520	66846781394804	27458	13571	8	0	0
206450	1693	14562584685051	27458	13571	9	0	1257
373600	1678	27360856644000	27459	13572	0	0	1
206456	1693	14493983831695	27459	13572	1	0	1258
373606	309	66846781394804	27459	13572	6	0	0
206462	1693	14219580418271	27459	13572	7	0	1262
40538	1685	185044701571430	27459	13572	10	0	0
373620	1874	35493000	27461	13573	2	0	2
206476	1693	14148899781489	27461	13573	3	0	1264
373626	690	66846781394804	27461	13573	8	0	0
206502	1397	1273193454000	27465	13574	0	0	16563
373652	569	66846781394804	27465	13574	5	0	0
206508	2133	90305258000	27465	13574	6	0	6373
12206	1426	16170472000000	27465	13574	9	0	8
373665	1678	27360856649000	27467	13575	2	0	1
206521	1693	12720082164317	27467	13575	3	0	1275
373671	120	66191449337183	27467	13575	8	0	1
206527	1693	12252570330335	27467	13575	9	0	1281
373677	1874	35507000	27467	13575	14	0	2
206533	1693	11179131096209	27467	13575	15	0	1284
373682	1276	1715715512165594	27467	13575	19	0	0
206538	1693	9143928610808	27467	13575	20	0	1289
373712	1678	27360856651000	27469	13576	1	0	1
206568	2133	90301250000	27469	13576	2	0	6377
373718	1874	35523000	27469	13576	7	0	2
39445	1684	29523508819412	27469	13576	9	0	136
206588	2134	83702423000	27473	13577	0	0	6867
373733	1874	35526000	27473	13577	0	0	2
206589	1693	8938417992367	27473	13577	1	0	1292
373734	399	66846781394804	27473	13577	1	0	0
14091	1451	5467790000000	27473	13577	8	0	13
206595	1397	1273133448000	27477	13579	0	0	16569
373740	1678	27360856652000	27477	13579	0	0	1
206601	1693	8661934795517	27477	13579	6	0	1297
373746	500	66846781394804	27477	13579	6	0	0
206606	1693	8388112027959	27477	13579	11	0	1301
373751	443	66190935859010	27477	13579	11	0	3
206612	1693	7977382039261	27477	13579	17	0	1307
373757	301	66071019153477	27477	13579	17	0	3
206618	1693	7600525086288	27477	13579	23	0	1313
373763	322	66846781394804	27477	13579	23	0	0
7671	1394	969135115440200	27477	13579	27	0	0
206649	1693	7463615321203	27479	13580	2	0	1315
373794	2017	845380729203	27479	13580	2	0	2
206673	1397	1273093444000	27481	13581	0	0	16573
373818	1678	27360856656000	27481	13581	0	0	1
206679	1693	6984284479149	27481	13581	6	0	1322
373824	237	66190636998665	27481	13581	6	0	1
206684	1693	6847082772437	27481	13581	11	0	1324
373829	691	66846781394804	27481	13581	11	0	0
206690	1693	6435477652301	27481	13581	17	0	1330
373835	163	66846781394804	27481	13581	17	0	0
25596	1610	13680344999950	27481	13581	19	0	11
206696	1693	6296202535307	27482	13582	5	0	1333
373841	2073	844766394804	27482	13582	5	0	2
206701	1693	6088328899908	27483	13583	1	0	1337
373846	252	66846781394804	27483	13583	1	0	0
206707	1397	1273043439000	27484	13584	1	0	16578
373852	1678	27360856661000	27484	13584	1	0	1
206713	2134	83692393000	27484	13584	7	0	6877
373858	1874	35572000	27484	13584	7	0	2
206718	315	66000000000000	27484	13584	12	0	1
373863	1515	1440048603400	27484	13584	12	0	2
373865	530	66769204972448	27484	13584	14	0	1
206721	1693	5289504567292	27484	13584	15	0	1345
373866	54	66846781394804	27484	13584	15	0	0
206722	1693	5220449433021	27484	13584	16	0	1346
373872	441	66068456767695	27484	13584	21	0	2
206728	1693	4858362418871	27484	13584	22	0	1352
47669	1695	12905228999000	27484	13584	25	0	9
373878	910	509228741176357	27485	13585	3	0	0
206734	2133	90288224000	27485	13585	4	0	6390
373883	1678	27360856664000	27486	13586	0	0	1
206739	1397	1273003435000	27486	13586	1	0	16582
373889	395	66343731646980	27486	13586	6	0	2
206745	1693	3916992886990	27486	13586	7	0	1360
373895	745	2025660042156	27486	13586	12	0	0
206751	2134	83689384000	27486	13586	13	0	6880
373900	438	66846781394804	27486	13586	18	0	0
206756	1693	3434998978544	27486	13586	19	0	1368
373906	562	66190636998665	27486	13586	24	0	1
206762	1693	3089178181597	27486	13586	25	0	1374
373993	1874	35604000	27490	13587	2	0	2
206849	1693	2883667470001	27490	13587	3	0	1377
373998	89	66846781394804	27490	13587	7	0	0
206854	2133	90284216000	27490	13587	8	0	6394
374001	1678	27360856669000	27491	13588	0	0	1
206857	2134	83684369000	27491	13588	1	0	6885
374002	1874	35614000	27491	13588	1	0	2
206858	2133	90282212000	27491	13588	2	0	6396
13230	1444	16487927329999	27492	13589	5	0	12
374012	1678	27360856671000	27494	13590	0	0	1
206868	1397	1272933428000	27494	13590	1	0	16589
7676	1394	973455150440200	27494	13590	6	0	0
374018	1678	27360856673000	27495	13591	0	0	1
206874	2134	83680357000	27495	13591	1	0	6889
374026	1874	35641000	27497	13592	2	0	2
206886	1397	1272903425000	27499	13593	0	0	16592
374036	1874	35648000	27500	13594	1	0	2
206892	2134	83677348000	27500	13594	2	0	6892
374048	1874	35659000	27503	13595	4	0	2
206904	2133	90273194000	27503	13595	5	0	6405
374053	1678	27360856680000	27505	13597	0	0	1
206909	1397	1272843419000	27505	13597	1	0	16598
374059	1678	27360856682000	27506	13598	0	0	1
206915	2133	90269186000	27506	13598	1	0	6409
374065	1678	27360856686000	27507	13599	3	0	1
206921	1397	1272783413000	27507	13599	4	0	16604
374070	1874	35691000	27507	13599	8	0	2
206926	2134	83668321000	27507	13599	9	0	6901
374076	1874	35706000	27507	13599	14	0	2
206947	1397	1272773412000	27509	13600	0	0	16605
374097	1874	35715000	27509	13600	5	0	2
206953	2133	90263174000	27509	13600	6	0	6415
374105	1874	35723000	27511	13601	1	0	2
206961	2134	83662303000	27511	13601	2	0	6907
374124	1874	35733000	27518	13603	1	0	2
32937	1675	22604578999977	27518	13603	3	0	8
206980	1444	14487917329999	27519	13604	0	0	13
374130	1874	35742000	27519	13604	5	0	2
206986	1397	1272703405000	27520	13605	0	0	16612
374135	1874	35746000	27520	13605	4	0	2
206991	2133	90256160000	27520	13605	5	0	6422
374137	1874	35750000	27520	13605	6	0	2
206993	1726	947250112000	27520	13605	7	0	8335
374138	2381	100000000	27520	13605	7	0	0
206994	2134	83657288000	27520	13605	8	0	6912
374144	1874	35758000	27520	13605	13	0	2
207000	1397	1272673402000	27521	13606	0	0	16615
7684	1394	977775198440200	27521	13606	4	0	0
374150	1874	35767000	27522	13607	1	0	2
207006	2133	90252152000	27522	13607	2	0	6426
25748	1611	3593499402899	27522	13607	3	0	18
374155	1874	35774000	27523	13608	3	0	2
207011	2133	90250148000	27523	13608	4	0	6428
374164	1874	35785000	27525	13609	2	0	2
207119	1397	1272623397000	27530	13610	0	0	16620
374269	1874	35795000	27530	13610	5	0	2
207125	1397	1272603395000	27531	13611	0	0	16622
374273	1874	35799000	27532	13612	1	0	2
207129	2134	83648261000	27532	13612	2	0	6921
374274	1874	35802000	27532	13612	2	0	2
4278	632	79677684000000	27532	13612	4	0	9
207214	1693	1945763623117	27536	13613	0	0	1382
374364	1874	35809000	27536	13613	5	0	2
207220	2134	83646255000	27536	13613	6	0	6923
374386	1778	7424464345059	27542	13615	1	0	1
207242	2133	90241130000	27542	13615	2	0	6437
9724	1395	58304072422957278	27542	13615	4	0	0
374399	1678	27360856713000	27545	13616	2	0	1
207255	2134	83643246000	27545	13616	3	0	6926
374405	1874	35837000	27545	13616	8	0	2
207279	1397	1272513386000	27548	13617	0	0	16631
374424	1678	27360856714000	27548	13617	0	0	1
207280	1397	1272503385000	27548	13617	1	0	16632
374425	1678	27360856715000	27548	13617	1	0	1
207289	2133	90235118000	27550	13618	1	0	6443
374434	1874	35849000	27550	13618	1	0	2
40897	1686	17672164700123	27550	13618	3	0	17
207295	2134	83636225000	27552	13620	2	0	6933
374440	1874	35860000	27552	13620	2	0	2
60882	2306	3599121000000	27552	13620	5	0	0
207314	2134	83634219000	27558	13622	0	0	6935
374459	1874	35870000	27558	13622	0	0	2
22186	1573	7779423000000	27558	13622	3	0	10
7690	1394	982095246440200	27559	13623	4	0	0
207338	1397	1272443379000	27565	13624	0	0	16638
374483	1678	27360856721000	27565	13624	0	0	1
207347	1397	1272423377000	27568	13626	0	0	16640
374492	1678	27360856723000	27568	13626	0	0	1
207352	2134	83629204000	27568	13626	5	0	6940
374497	1874	35897000	27568	13626	5	0	2
26372	1619	9360245000000	27568	13626	7	0	0
25341	1608	18138609000000	27569	13627	3	0	8
207364	2134	83627198000	27572	13628	2	0	6942
374509	1874	35905000	27572	13628	2	0	2
207373	2133	90222092000	27575	13629	2	0	6456
374518	1874	35917000	27575	13629	2	0	2
41745	1688	31031007113019	27575	13629	4	0	77
207401	1397	1272363371000	27579	13630	0	0	16646
374546	1678	27360856729000	27579	13630	0	0	1
207402	1397	1272353370000	27579	13630	1	0	16647
374547	1678	27360856730000	27579	13630	1	0	1
7697	1394	984975295440200	27579	13630	7	0	0
207414	1397	1272333368000	27581	13631	1	0	16649
374559	1678	27360856732000	27581	13631	1	0	1
207420	1397	1272313366000	27583	13632	1	0	16651
374565	1678	27360856734000	27583	13632	1	0	1
207425	1588	16224799000000	27584	13633	0	0	13
374570	2068	2000099000000	27584	13633	0	0	1
207435	2134	83617168000	27586	13634	2	0	6952
374580	1874	35957000	27586	13634	2	0	2
40545	1685	187204773571430	27586	13634	4	0	0
207447	2134	83614159000	27589	13636	1	0	6955
374592	1874	35966000	27589	13636	1	0	2
207463	2133	90211070000	27592	13637	4	0	6467
374608	1874	35975000	27592	13637	4	0	2
207481	1571	12038110913010	27596	13639	1	0	49
374625	969	506877361461968	27596	13639	1	0	0
207487	2133	90208064000	27596	13639	7	0	6470
374631	1874	35987000	27596	13639	8	0	2
207499	2133	90207062000	27598	13640	3	0	6471
374643	1874	35992000	27598	13640	4	0	2
207505	2133	90205058000	27599	13641	2	0	6473
374649	1874	36001000	27599	13641	3	0	2
207523	1571	7097799805035	27603	13642	2	0	55
374667	1089	908808487586029	27603	13642	3	0	0
207528	2134	83606135000	27603	13642	7	0	6963
374672	1678	27360856748000	27605	13643	0	0	1
10566	1402	52023581145435	27607	13644	0	0	66
207537	1397	1272153350000	27608	13645	1	0	16667
207538	1397	1272143349000	27608	13645	2	0	16668
374681	1678	27360856752000	27608	13645	3	0	1
374682	1874	36019000	27608	13645	4	0	2
207544	2133	90199046000	27608	13645	8	0	6479
374688	1874	36034000	27608	13645	10	0	2
207550	2134	83600117000	27609	13646	2	0	6969
19854	1547	12234840000000	27609	13646	3	0	12
207758	1397	1272113346000	27613	13647	0	0	16671
374896	1678	27360856754000	27613	13647	0	0	1
207759	2133	90196040000	27613	13647	1	0	6482
374897	1874	36044000	27613	13647	1	0	2
207780	1397	1272063341000	27617	13649	0	0	16676
374918	1678	27360856759000	27617	13649	0	0	1
207786	2133	90193034000	27617	13649	6	0	6485
374924	1874	36056000	27617	13649	6	0	2
207791	2133	90190028000	27617	13649	11	0	6488
374929	1874	36068000	27617	13649	11	0	2
53681	1719	19438720000000	27617	13649	17	0	10
207797	1397	1272033338000	27618	13650	0	0	16679
374935	1678	27360856762000	27618	13650	0	0	1
23198	1593	17232813000000	27618	13650	3	0	8
207809	2133	90187022000	27622	13651	2	0	6491
207810	1397	1272013336000	27623	13652	0	0	16681
374948	1678	27360856764000	27623	13652	0	0	1
2087	369	82356669290830	27623	13652	4	0	16
374957	1678	27360856765000	27625	13653	0	0	1
374958	1678	27360856766000	27625	13653	1	0	1
207822	2133	90184016000	27625	13653	3	0	6494
9730	1395	58306232467957278	27625	13653	6	0	0
374970	1874	36110000	27627	13654	1	0	2
207834	2133	90183014000	27627	13654	3	0	6495
60132	2112	27167031101924	27627	13654	4	0	7
374980	1874	36118000	27629	13655	3	0	2
207843	2133	90182012000	27629	13655	4	0	6496
374985	1874	36127000	27630	13656	2	0	2
54363	1724	16252928500000	27630	13656	4	0	15
207852	2134	83582063000	27632	13657	1	0	6987
374997	1874	36137000	27634	13658	2	0	2
864	58	79667613999641	27634	13658	4	0	12
207876	1397	1271913326000	27641	13660	1	0	16691
375018	1874	36142000	27641	13660	5	0	2
207881	2134	83579054000	27641	13660	6	0	6990
375023	1874	36155000	27641	13660	10	0	2
17155	1506	7920263967172	27641	13660	13	0	23
207923	1397	1271883323000	27645	13661	0	0	16694
375069	1678	27360856778000	27647	13662	0	0	1
207933	2133	90171992000	27647	13662	2	0	6506
58340	1850	17976503949999	27647	13662	6	0	9
375075	1678	27360856780000	27648	13663	0	0	1
207938	1397	1271843319000	27648	13663	1	0	16698
375080	1874	36182000	27648	13663	5	0	2
41188	1687	9489020848312	27648	13663	7	0	7
207944	657	66000990000000	27650	13664	1	0	1
207945	1397	1271833318000	27650	13664	2	0	16699
207946	1397	1271823317000	27650	13664	3	0	16700
375086	1474	15030643000043	27650	13664	5	0	29
375089	1874	36189000	27650	13664	8	0	2
207952	2134	83570027000	27650	13664	9	0	6999
375090	1874	36192000	27650	13664	9	0	2
208088	1397	1271813316000	27653	13665	0	0	16701
208089	2133	90165980000	27653	13665	1	0	6512
375225	1874	36194000	27653	13665	1	0	2
375226	1874	36197000	27653	13665	2	0	2
9737	1395	58308392527957278	27653	13665	4	0	0
60681	2261	11519346000000	27655	13666	4	0	0
208098	2134	83567018000	27656	13667	1	0	7002
375235	1874	36207000	27656	13667	2	0	2
35197	1679	17998450656999	27656	13667	3	0	100
30759	1657	9361396990100	27658	13668	3	0	11
208110	2133	90161972000	27660	13669	1	0	6516
375247	1874	36217000	27660	13669	2	0	2
18182	1513	35281215000000	27660	13669	4	0	0
208115	1397	1271753310000	27662	13671	0	0	16707
375252	1678	27360856791000	27662	13671	1	0	1
208121	2134	83563006000	27662	13671	6	0	7006
375258	1874	36232000	27662	13671	7	0	2
41776	1688	31751007113019	27662	13671	8	0	77
208135	2134	83559997000	27665	13673	1	0	7009
375272	1874	36242000	27665	13673	2	0	2
59396	2039	18619720000000	27668	13674	4	0	6
208170	1397	1271703305000	27677	13675	0	0	16712
375307	1874	36250000	27677	13675	1	0	2
7710	1394	989295369440200	27678	13676	4	0	0
208178	1397	1271683303000	27680	13677	0	0	16714
375315	1874	36259000	27680	13677	1	0	2
208184	2133	90150950000	27682	13679	1	0	6527
375321	1874	36269000	27682	13679	2	0	2
208270	526	66000305000000	27686	13681	0	0	3
375406	1474	24390643000043	27686	13681	0	0	29
208271	1397	1271653300000	27686	13681	1	0	16717
375407	1678	27360856800000	27686	13681	1	0	1
208283	1397	1271633298000	27688	13682	0	0	16719
375419	1678	27360856802000	27688	13682	0	0	1
208298	1397	1271613296000	27692	13683	0	0	16721
375434	1678	27360856804000	27692	13683	0	0	1
208303	2134	83548964000	27693	13684	2	0	7020
375439	1874	36299000	27693	13684	2	0	2
46102	1693	1485789623117	27693	13684	4	0	1383
208423	1397	1271573292000	27701	13687	0	0	16725
375557	1678	27360856808000	27701	13687	0	0	1
208424	1397	1271563291000	27701	13687	1	0	16726
375558	1678	27360856809000	27701	13687	1	0	1
208436	1397	1271533288000	27703	13688	1	0	16729
375570	1678	27360856812000	27703	13688	1	0	1
208442	2133	90135920000	27703	13688	7	0	6542
375576	1874	36317000	27703	13688	7	0	2
61062	2329	321126614819988	27703	13688	8	0	0
208447	1397	1271483283000	27704	13689	4	0	16734
375581	1678	27360856817000	27704	13689	4	0	1
9743	1395	58310552550957278	27704	13689	10	0	0
208473	1397	1271473282000	27707	13690	0	0	16735
375607	1678	27360856818000	27707	13690	0	0	1
58830	1991	16461497355805	27707	13690	4	0	21
208479	1397	1271433278000	27708	13691	2	0	16739
375613	1678	27360856822000	27708	13691	2	0	1
208484	2133	90126902000	27709	13692	1	0	6551
375618	1874	36335000	27709	13692	1	0	2
208489	1397	1271413276000	27712	13693	0	0	16741
208490	1397	1271403275000	27712	13693	1	0	16742
375633	1678	27360856826000	27715	13694	0	0	1
375634	1874	36341000	27715	13694	1	0	2
208504	2133	90122894000	27717	13695	1	0	6555
208634	1397	1271373272000	27721	13696	0	0	16745
208635	2133	90121892000	27721	13696	1	0	6556
375772	1678	27360856829000	27724	13697	0	0	1
375773	1950	15576851000000	27724	13697	1	0	14
7720	1394	993615412440200	27724	13697	4	0	0
208653	2133	90119888000	27728	13698	2	0	6558
17506	1508	16760471156616	27728	13698	4	0	10
375791	1678	27360856832000	27730	13699	0	0	1
57390	1764	16643551100000	27733	13700	2	0	12
208667	1397	1271313266000	27734	13701	0	0	16751
375801	1678	27360856836000	27734	13701	2	0	1
208672	2133	90113876000	27734	13701	5	0	6564
375806	1874	36363000	27735	13702	1	0	2
61065	2329	321846658819988	27735	13702	2	0	0
61067	2329	321846669819988	27735	13702	3	0	0
208682	2133	90110870000	27739	13704	1	0	6567
375818	1678	27360856841000	27741	13705	1	0	1
208690	1397	1271203255000	27741	13705	5	0	16762
375824	1874	36369000	27741	13705	7	0	2
208695	2133	90106862000	27741	13705	10	0	6571
375829	1874	36379000	27741	13705	12	0	2
208711	1397	1271173252000	27747	13707	0	0	16765
375845	1874	36385000	27747	13707	2	0	2
208723	1397	1271143249000	27752	13709	0	0	16768
375857	1678	27360856852000	27753	13710	0	0	1
208731	2133	90096842000	27756	13711	1	0	6581
375865	1874	36397000	27757	13712	1	0	2
13672	1447	21881944683000	27757	13712	3	0	10
208739	1397	1271073242000	27759	13713	3	0	16775
375873	1874	36399000	27759	13713	5	0	2
208745	2133	90090830000	27759	13713	9	0	6587
375889	1874	36409000	27761	13714	1	0	2
208762	1397	1271033238000	27764	13716	0	0	16779
208763	2133	90087824000	27764	13716	1	0	6590
375896	1678	27360856863000	27765	13717	0	0	1
15339	1467	7360315272869	27765	13717	2	0	9
375905	1874	36417000	27769	13718	1	0	2
23667	1594	18001933000000	27769	13718	2	0	10
375906	1678	27360856865000	27770	13719	0	0	1
208775	2133	90084818000	27770	13719	1	0	6593
19870	1547	12954852000000	27771	13720	0	0	12
375912	1678	27360856868000	27773	13722	0	0	1
208781	1397	1270963231000	27773	13722	1	0	16786
208786	2318	9000000	27773	13722	6	0	1
375918	2152	109998988000000	27773	13722	6	0	5
50792	1706	20442339450256	27773	13722	8	0	27
375925	1874	36433000	27776	13724	2	0	2
208794	2133	90076802000	27776	13724	3	0	6601
55428	1740	17730977000000	27776	13724	5	0	14
375935	1874	36439000	27780	13726	2	0	2
48554	1699	2880363750126	27780	13726	3	0	7
208804	2133	90073796000	27780	13726	4	0	6604
208817	2133	90072794000	27783	13727	4	0	6605
375949	1874	36443000	27783	13727	4	0	2
375954	1874	36449000	27784	13728	2	0	2
208823	2133	90068786000	27784	13728	3	0	6609
7726	1394	997935456440200	27785	13729	4	0	0
375960	1678	27360856884000	27786	13730	0	0	1
208829	2133	90065780000	27786	13730	1	0	6612
208839	329	67442611000000	27788	13731	4	0	6
375971	2385	1000000000	27788	13731	4	0	0
9753	1395	58312712656957278	27788	13731	5	0	0
375976	1874	36465000	27790	13733	2	0	2
208851	1397	1270763211000	27793	13734	0	0	16806
50437	1705	29361077580140	27793	13734	3	0	25
375988	1874	36473000	27794	13735	2	0	2
208857	2134	83545955000	27794	13735	3	0	7023
208865	2134	83544952000	27796	13736	2	0	7024
375997	1874	36485000	27796	13736	2	0	2
22622	1587	18000514000000	27800	13737	5	0	14
376020	1678	27360856894000	27803	13738	0	0	1
208889	2133	90055760000	27803	13738	1	0	6622
376026	1874	36500000	27804	13739	3	0	2
208895	2134	83540940000	27804	13739	4	0	7028
61073	2329	324006715819988	27804	13739	7	0	0
208915	1397	1270683203000	27808	13740	0	0	16814
376047	1678	27360856897000	27808	13740	0	0	1
208916	1397	1270673202000	27808	13740	1	0	16815
376048	1678	27360856898000	27808	13740	1	0	1
208928	1397	1270653200000	27810	13741	1	0	16817
376060	1678	27360856900000	27810	13741	1	0	1
208934	2134	83535925000	27811	13742	1	0	7033
376066	1874	36528000	27811	13742	1	0	2
208939	2134	83533919000	27812	13743	3	0	7035
376071	1874	36536000	27812	13743	3	0	2
47291	1694	19979133197225	27812	13743	7	0	62
40554	1685	189364796571430	27813	13744	3	0	0
208945	1397	1270603195000	27814	13745	0	0	16822
376077	1678	27360856905000	27814	13745	0	0	1
208957	1397	1270583193000	27816	13746	0	0	16824
376089	1678	27360856907000	27816	13746	0	0	1
208962	2133	90041732000	27817	13747	2	0	6636
376094	1874	36565000	27817	13747	2	0	2
208971	2133	90039728000	27820	13749	2	0	6638
376103	1874	36575000	27820	13749	2	0	2
18653	1522	13003823000000	27822	13750	3	0	14
208980	2134	83524892000	27823	13751	2	0	7044
376112	1874	36585000	27823	13751	2	0	2
208991	2133	90035720000	27827	13753	1	0	6642
376123	1874	36592000	27827	13753	1	0	2
7733	1394	1002255501440200	27827	13753	3	0	0
208997	1397	1270483183000	27829	13755	1	0	16834
376129	1678	27360856917000	27829	13755	1	0	1
209003	2133	90031712000	27829	13755	7	0	6646
376135	1874	36609000	27829	13755	7	0	2
209032	1397	1270453180000	27832	13756	0	0	16837
376164	1678	27360856920000	27832	13756	0	0	1
209033	2134	83516868000	27832	13756	1	0	7052
209034	2133	90029708000	27832	13756	2	0	6648
23932	1598	2160070000000	27832	13756	3	0	3
41838	1688	33911068113019	27835	13757	3	0	77
376176	1678	27360856922000	27836	13758	0	0	1
376177	1874	36633000	27836	13758	1	0	2
209046	2133	90027704000	27836	13758	2	0	6650
376178	1874	36635000	27836	13758	2	0	2
209052	2134	83512856000	27838	13760	2	0	7056
376184	1874	36643000	27838	13760	2	0	2
209057	2134	83510850000	27839	13761	1	0	7058
376190	1874	36655000	27839	13761	2	0	2
209078	2134	83509847000	27843	13762	4	0	7059
376210	1874	36660000	27843	13762	4	0	2
209084	1397	1270343169000	27844	13763	1	0	16848
376216	1678	27360856931000	27844	13763	1	0	1
209089	1397	1270333168000	27845	13764	0	0	16849
376222	1874	36682000	27845	13764	1	0	2
7739	1394	1006575561440200	27847	13765	3	0	0
209107	1397	1270313166000	27851	13766	0	0	16851
376239	1678	27360856934000	27851	13766	0	0	1
209113	1397	1270293164000	27853	13768	0	0	16853
376245	1678	27360856936000	27853	13768	0	0	1
24129	1599	15417049097983	27853	13768	1	0	8
209127	2134	83499817000	27856	13769	2	0	7069
376260	1874	36711000	27856	13769	3	0	2
209136	2134	83497811000	27858	13770	2	0	7071
376268	1874	36720000	27858	13770	2	0	2
209142	2134	83495805000	27859	13771	5	0	7073
376274	1874	36730000	27859	13771	5	0	2
209147	2134	83493799000	27861	13773	1	0	7075
376280	1874	36740000	27861	13773	2	0	2
9766	1395	58314872715957278	27863	13774	3	0	0
209156	2134	83491793000	27864	13775	1	0	7077
376288	1874	36748000	27864	13775	1	0	2
27108	1623	83523423898598	27864	13775	3	0	1
209162	1397	1270183153000	27866	13777	0	0	16864
376294	1678	27360856947000	27866	13777	0	0	1
209167	2134	83489787000	27866	13777	5	0	7079
7746	1394	1009455610440200	27866	13777	8	0	0
209169	1397	1270163151000	27867	13778	0	0	16866
376300	1678	27360856949000	27867	13778	0	0	1
209170	2134	83487781000	27867	13778	1	0	7081
376305	1874	36775000	27868	13779	2	0	2
209306	1397	1270143149000	27872	13780	0	0	16868
376436	1678	27360856951000	27872	13780	0	0	1
209307	2133	89998646000	27872	13780	1	0	6679
376437	1874	36777000	27872	13780	1	0	2
209319	2134	83483769000	27876	13782	1	0	7085
376449	1874	36788000	27876	13782	1	0	2
376450	1874	36790000	27876	13782	2	0	2
209339	1397	1270093144000	27881	13784	1	0	16873
376470	1874	36797000	27881	13784	2	0	2
209344	2133	89993636000	27881	13784	6	0	6684
376504	1678	27360856957000	27883	13785	0	0	1
209381	1397	1270063141000	27884	13786	1	0	16876
376509	1678	27360856960000	27884	13786	2	0	1
209387	2134	83476748000	27884	13786	7	0	7092
376515	1874	36830000	27884	13786	8	0	2
16786	1489	14783233040000	27884	13786	9	0	10
209392	1397	1270033138000	27886	13788	0	0	16879
376521	1678	27360856964000	27886	13788	2	0	1
209398	2133	89986622000	27886	13788	7	0	6691
376526	1874	36848000	27886	13788	8	0	2
209410	1397	1269993134000	27890	13790	0	0	16883
376538	1874	36857000	27890	13790	1	0	2
7752	1394	1013775646440200	27890	13790	4	0	0
209415	2134	83468724000	27891	13791	2	0	7100
7753	1394	1015215646440200	27891	13791	3	0	0
7754	1394	1015215658440200	27891	13791	4	0	0
376544	1874	36868000	27892	13792	1	0	2
9774	1395	58316312763957278	27892	13792	3	0	0
209434	1521	67000000	27896	13793	2	0	8
376562	1874	36872000	27896	13793	3	0	2
209449	1397	1269943129000	27899	13794	0	0	16888
209450	2133	89977604000	27899	13794	1	0	6700
376578	1874	36885000	27899	13794	2	0	2
1287	149	81935466000341	27900	13795	3	0	10
209456	1397	1269913126000	27901	13796	1	0	16891
376584	1874	36893000	27901	13796	2	0	2
376585	1874	36896000	27901	13796	3	0	2
376586	1874	36898000	27901	13796	4	0	2
209462	2133	89973596000	27902	13797	1	0	6704
376592	1874	36907000	27903	13798	1	0	2
32159	1672	14401547000000	27903	13798	4	0	10
209467	1397	1269883123000	27904	13799	0	0	16894
53129	1717	19261366000055	27904	13799	3	0	8
376598	1678	27360856979000	27905	13800	1	0	1
209473	1397	1269843119000	27905	13800	3	0	16898
376603	1865	1299000000	27905	13800	6	0	1
209479	1726	940644112000	27905	13800	9	0	8341
376609	1874	36924000	27905	13800	12	0	2
209484	2134	83455685000	27905	13800	14	0	7113
376615	1874	36940000	27905	13800	18	0	2
209490	2134	83452676000	27906	13801	1	0	7116
376620	1678	27360856985000	27907	13802	1	0	1
209496	2134	83450670000	27907	13802	4	0	7118
376632	1874	36957000	27910	13803	1	0	2
209507	1397	1269783113000	27911	13804	0	0	16904
376638	1874	36967000	27911	13804	4	0	2
209519	1397	1269763111000	27913	13805	0	0	16906
376649	1678	27360856990000	27914	13806	0	0	1
209525	1397	1269743109000	27915	13807	0	0	16908
376655	1874	36983000	27915	13807	4	0	2
209530	2133	89956562000	27915	13807	6	0	6721
376673	1678	27360856994000	27919	13809	0	0	1
209548	2134	83442646000	27919	13809	2	0	7126
376681	1874	37002000	27921	13810	2	0	2
40561	1685	191524844571430	27921	13810	3	0	0
209557	2133	89952554000	27922	13811	2	0	6725
376689	1874	37012000	27924	13812	2	0	2
209564	2199	720328000000	27925	13813	1	0	1
32952	1675	24764676999977	27925	13813	5	0	8
376699	1874	37019000	27927	13814	1	0	2
209577	1397	1269653100000	27929	13815	0	0	16917
209578	2134	83436628000	27929	13815	1	0	7132
4049	610	67440044000000	27929	13815	4	0	3
376710	1678	27360857001000	27931	13816	0	0	1
209587	2133	89947544000	27931	13816	4	0	6730
376716	1874	37034000	27931	13816	6	0	2
376722	1678	27360857004000	27933	13817	0	0	1
209596	2133	89945540000	27933	13817	1	0	6732
376723	1874	37042000	27933	13817	1	0	2
48351	1698	15189016550062	27933	13817	3	0	12
209601	2133	89943536000	27934	13818	3	0	6734
376729	1760	800000000000	27934	13818	4	0	2
7768	1394	1019535731440200	27934	13818	8	0	0
209614	2133	89942534000	27936	13819	2	0	6735
376742	1874	37059000	27936	13819	3	0	2
209620	2134	83427601000	27937	13820	2	0	7141
376747	1874	37070000	27937	13820	2	0	2
209631	2134	83425595000	27941	13822	1	0	7143
376759	1874	37080000	27941	13822	2	0	2
209637	2133	89937524000	27942	13823	3	0	6740
376765	1874	37087000	27942	13823	4	0	2
209643	2133	89935520000	27943	13824	3	0	6742
376770	1874	37092000	27943	13824	3	0	2
209648	2134	83420580000	27943	13824	8	0	7148
376779	1678	27360857017000	27945	13825	0	0	1
9782	1395	58318472852457278	27945	13825	3	0	0
209672	2134	83418574000	27949	13826	2	0	7150
376800	1874	37116000	27949	13826	3	0	2
209684	2133	89929508000	27952	13828	2	0	6748
376811	1874	37122000	27952	13828	2	0	2
209695	1397	1269423077000	27954	13829	1	0	16940
376823	1874	37133000	27954	13829	2	0	2
61081	2329	326166763819988	27954	13829	7	0	0
209707	1397	1269403075000	27956	13830	1	0	16942
376835	1874	37143000	27956	13830	2	0	2
209715	2134	83410550000	27958	13831	0	0	7158
209716	2133	89923496000	27958	13831	1	0	6754
376843	1874	37155000	27958	13831	1	0	2
46349	1693	4365826623117	27958	13831	3	0	1383
52414	1715	11543634663945	27959	13832	6	0	16
209748	1397	1269363071000	27965	13833	0	0	16946
376875	1678	27360857029000	27965	13833	0	0	1
376876	1678	27360857030000	27965	13833	1	0	1
209754	2133	89920490000	27965	13833	6	0	6757
376882	1874	37172000	27965	13833	7	0	2
209759	1397	1269333068000	27966	13834	0	0	16949
376888	1874	37183000	27966	13834	2	0	2
209804	1397	1269293064000	27971	13835	2	0	16953
376932	1874	37189000	27971	13835	3	0	2
209810	2133	89915480000	27971	13835	8	0	6762
376938	1874	37203000	27971	13835	9	0	2
209837	2134	83399517000	27974	13836	2	0	7169
9791	1395	58320632900457278	27974	13836	4	0	0
376969	1874	37212000	27976	13837	1	0	2
209969	1397	1269263061000	27978	13838	0	0	16956
377096	1678	27360857039000	27978	13838	0	0	1
209970	1397	1269253060000	27978	13838	1	0	16957
377097	1678	27360857040000	27978	13838	1	0	1
209976	2134	83395505000	27978	13838	7	0	7173
377103	1874	37230000	27978	13838	7	0	2
209986	1397	1269233058000	27982	13840	0	0	16959
209987	2133	89906462000	27982	13840	1	0	6771
377115	1874	37240000	27982	13840	2	0	2
7778	1394	1023855779440200	27982	13840	4	0	0
209993	2134	83392496000	27983	13841	4	0	7176
377120	1874	37247000	27983	13841	4	0	2
377129	1874	37252000	27985	13842	1	0	2
377130	1874	37255000	27985	13842	2	0	2
210005	1397	1269183053000	27986	13843	1	0	16964
377136	1874	37265000	27986	13843	5	0	2
9794	1395	58321352900457278	27986	13843	6	0	0
9796	1395	58321352924457278	27986	13843	7	0	0
210037	1397	1269173052000	27990	13844	0	0	16965
377169	1874	37274000	27990	13844	5	0	2
210043	2133	89900450000	27990	13844	6	0	6777
52653	1716	2160092000000	27990	13844	9	0	9
377180	1874	37283000	27993	13845	1	0	2
210064	1397	1269133048000	27997	13846	0	0	16969
377195	1874	37292000	27998	13847	1	0	2
210069	2134	83382466000	27998	13847	2	0	7186
377204	1678	28080869056000	28004	13850	0	0	1
210078	2134	83380460000	28004	13850	1	0	7188
210184	1397	1269083043000	28010	13851	0	0	16974
377311	1678	28080869057000	28010	13851	0	0	1
210185	2134	83378454000	28010	13851	1	0	7190
377312	1874	37313000	28010	13851	1	0	2
14458	1455	6511635000000	28011	13852	3	0	10
210191	2134	83376448000	28012	13853	2	0	7192
377318	1874	37323000	28012	13853	2	0	2
31138	1668	14913795000000	28012	13853	3	0	9
210197	2134	83374442000	28013	13854	5	0	7194
377324	1874	37333000	28013	13854	5	0	2
210205	2133	89886422000	28016	13856	1	0	6791
377332	1874	37340000	28016	13856	1	0	2
210211	1397	1268993034000	28018	13858	1	0	16983
377338	1678	28080869066000	28018	13858	1	0	1
210217	2134	83369427000	28018	13858	7	0	7199
377344	1874	37360000	28018	13858	7	0	2
54013	1723	14402131085979	28018	13858	9	0	12
210228	2134	83367421000	28023	13860	1	0	7201
377355	1874	37368000	28023	13860	1	0	2
210240	2134	83365415000	28025	13861	4	0	7203
377367	1874	37378000	28025	13861	4	0	2
39467	1684	31683556819412	28025	13861	6	0	136
4300	632	81837741000000	28028	13862	4	0	9
210249	2133	89876402000	28032	13863	1	0	6801
377376	1874	37387000	28032	13863	1	0	2
210267	1397	1268913026000	28034	13864	0	0	16991
210268	1397	1268903025000	28034	13864	1	0	16992
377396	1678	28080869076000	28034	13864	2	0	1
210274	2134	83360400000	28034	13864	7	0	7208
377401	1874	37399000	28034	13864	7	0	2
377402	1874	37402000	28034	13864	8	0	2
210280	2133	89871392000	28034	13864	13	0	6806
377408	1874	37415000	28034	13864	14	0	2
210413	1397	1268853020000	28038	13866	0	0	16997
377538	1678	28080869080000	28038	13866	0	0	1
210414	2133	89869388000	28038	13866	1	0	6808
377539	1874	37422000	28038	13866	1	0	2
57420	1764	18083574100000	28038	13866	3	0	12
210422	2134	83354382000	28041	13868	1	0	7214
377547	1874	37433000	28041	13868	1	0	2
52263	1714	19005818171760	28041	13868	3	0	11
210430	2134	83352376000	28044	13870	2	0	7216
377555	1874	37443000	28044	13870	2	0	2
210441	2134	83350370000	28049	13871	1	0	7218
377566	1874	37453000	28049	13871	1	0	2
7788	1394	1028175815440200	28052	13872	3	0	0
210464	2133	89861372000	28056	13873	1	0	6816
377589	1874	37462000	28056	13873	1	0	2
210479	2134	83346358000	28061	13875	1	0	7222
377604	1874	37473000	28061	13875	1	0	2
10595	1402	54183617145435	28061	13875	4	0	66
210490	1397	1268743009000	28065	13877	0	0	17008
377615	1678	28080869091000	28065	13877	0	0	1
210496	2134	83344352000	28065	13877	6	0	7224
377621	1874	37489000	28065	13877	6	0	2
9806	1395	58323512973457278	28065	13877	10	0	0
210508	2133	89853356000	28067	13878	3	0	6824
377633	1874	37499000	28067	13878	3	0	2
210517	2134	83339337000	28069	13879	2	0	7229
377642	1874	37510000	28069	13879	2	0	2
36090	1680	15853414499559	28069	13879	5	0	12
210527	2133	89851352000	28071	13880	4	0	6826
377652	1874	37518000	28071	13880	4	0	2
210700	2133	89849348000	28077	13881	0	0	6828
377825	1874	37522000	28077	13881	0	0	2
210701	2133	89848346000	28077	13881	1	0	6829
377826	1874	37524000	28077	13881	1	0	2
210746	1397	1268642999000	28081	13882	2	0	17018
377871	1678	28080869101000	28081	13882	2	0	1
210752	2133	89844338000	28081	13882	8	0	6833
377877	1874	37532000	28081	13882	8	0	2
210757	2134	83334322000	28081	13882	13	0	7234
377882	1874	37545000	28081	13882	13	0	2
27112	1623	84963448898598	28081	13882	19	0	1
210763	1397	1268582993000	28082	13883	0	0	17024
377888	1678	28080869107000	28082	13883	0	0	1
18345	1518	10800418000000	28082	13883	4	0	0
210769	2133	89840330000	28083	13884	4	0	6837
377894	1874	37567000	28083	13884	4	0	2
210774	2134	83326298000	28083	13884	9	0	7242
377899	1874	37578000	28083	13884	9	0	2
60688	2261	13679412000000	28083	13884	11	0	0
210798	2134	83324292000	28087	13885	4	0	7244
377923	1874	37588000	28087	13885	4	0	2
210801	2134	83322286000	28088	13886	1	0	7246
210802	2132	147265278000	28088	13886	2	0	1723
377940	1678	28080869114000	28092	13887	0	0	1
377949	1678	28080869115000	28095	13888	0	0	1
210825	2133	89833316000	28095	13888	1	0	6844
377950	1874	37604000	28095	13888	1	0	2
210845	1397	1268482983000	28099	13890	0	0	17034
377970	1678	28080869117000	28099	13890	0	0	1
210850	2132	147263276000	28099	13890	5	0	1725
377976	1874	37621000	28099	13890	6	0	2
41936	1688	36791129113019	28099	13890	10	0	77
210866	2134	83315265000	28101	13891	1	0	7253
377991	1874	37632000	28101	13891	1	0	2
26167	1613	15697493400000	28103	13892	4	0	10
211006	1397	1268432978000	28106	13893	0	0	17039
378131	1678	28080869122000	28106	13893	0	0	1
211007	1397	1268422977000	28106	13893	1	0	17040
378132	1678	28080869123000	28106	13893	1	0	1
4666	633	82269628900000	28106	13893	8	0	9
211019	1397	1268412976000	28109	13894	0	0	17041
378144	1678	28080869124000	28109	13894	0	0	1
211025	2134	83309247000	28110	13895	3	0	7259
378150	1874	37661000	28110	13895	3	0	2
211037	1464	2158024000000	28112	13896	1	0	1
378162	2393	1000000000	28112	13896	1	0	0
211043	2132	147260273000	28113	13897	3	0	1728
378168	1874	37674000	28113	13897	3	0	2
57784	1768	24947175110000	28113	13897	8	0	10
211056	2133	89818286000	28115	13898	2	0	6859
378181	1874	37684000	28115	13898	2	0	2
47707	1695	15065252999000	28115	13898	6	0	9
211061	2133	89816282000	28116	13899	1	0	6861
378186	1874	37694000	28116	13899	1	0	2
211070	1397	1268312966000	28119	13901	0	0	17051
378195	1678	28080869134000	28119	13901	0	0	1
61090	2329	328326787819988	28119	13901	3	0	0
211073	1397	1268302965000	28120	13902	0	0	17052
211074	1397	1268292964000	28120	13902	1	0	17053
378201	1874	37710000	28120	13902	3	0	2
5387	1271	1349886506000000	28120	13902	4	0	0
5221	697	66000001999996	28120	13902	7	0	0
211093	1397	1268272962000	28129	13904	0	0	17055
378218	1678	28080869138000	28129	13904	0	0	1
378222	1678	28080869139000	28132	13905	0	0	1
211108	2134	83296208000	28135	13906	2	0	7272
378234	1678	28080869141000	28136	13907	0	0	1
211113	1397	1268232958000	28137	13908	0	0	17059
378240	1678	28080869143000	28138	13909	0	0	1
211119	2134	83292196000	28139	13910	1	0	7276
378247	1678	28080869145000	28141	13911	0	0	1
211129	2132	147255268000	28143	13912	3	0	1733
378255	1874	37743000	28143	13912	4	0	2
49359	1701	16558472500103	28144	13913	3	0	14
211134	1397	1268162951000	28145	13914	0	0	17066
378261	1874	37753000	28145	13914	2	0	2
11620	1420	2154962980000	28145	13914	3	0	1
45168	1692	12700835819983	28147	13915	3	0	6
211158	2134	83285175000	28148	13916	1	0	7283
378284	1678	28080869152000	28149	13917	0	0	1
211164	2134	83283169000	28150	13918	3	0	7285
378290	1874	37769000	28150	13918	4	0	2
30790	1657	11521444990100	28150	13918	5	0	11
32963	1675	26924713999977	28151	13919	2	0	8
211169	1397	1268082943000	28152	13920	1	0	17074
378296	1874	37776000	28152	13920	3	0	2
211178	1397	1268062941000	28155	13922	0	0	17076
378304	1874	37785000	28155	13922	1	0	2
41985	1688	38231200113019	28155	13922	4	0	77
211184	1397	1268022937000	28156	13923	3	0	17080
378310	1874	37787000	28156	13923	4	0	2
211189	2134	83274142000	28156	13923	8	0	7294
378316	1678	28080869164000	28157	13924	0	0	1
211216	1397	1267992934000	28161	13925	0	0	17083
211217	1397	1267982933000	28161	13925	1	0	17084
378342	1678	28080869167000	28161	13925	1	0	1
211237	1397	1267962931000	28164	13926	0	0	17086
378362	1678	28080869169000	28164	13926	0	0	1
378363	1874	37818000	28164	13926	2	0	2
211287	1397	1267932928000	28173	13928	1	0	17089
378413	1678	28080869173000	28173	13928	2	0	1
211292	2132	147247260000	28173	13928	6	0	1741
378419	1874	37835000	28174	13929	1	0	2
211308	2134	83261103000	28180	13930	3	0	7307
378434	1874	37842000	28180	13930	4	0	2
211323	2132	147245258000	28185	13932	1	0	1743
378449	1874	37852000	28185	13932	2	0	2
55984	1747	6546070999992	28185	13932	4	0	6
7800	1394	1032495852440200	28187	13933	2	0	0
211331	2134	83255085000	28188	13934	1	0	7313
378458	1678	28080869182000	28189	13935	1	0	1
211346	1397	1267822917000	28192	13936	0	0	17100
211347	2134	83252076000	28192	13936	1	0	7316
378472	1874	37868000	28192	13936	1	0	2
12622	1439	13663875578477	28192	13936	2	0	10
211353	1397	1267792914000	28196	13939	0	0	17103
378478	1678	28080869186000	28196	13939	0	0	1
211359	2134	83247061000	28198	13941	2	0	7321
378484	1874	37885000	28198	13941	2	0	2
15831	1471	20105519900000	28198	13941	3	0	8
378490	1874	37891000	28201	13943	0	0	2
211368	1397	1267742909000	28204	13944	0	0	17108
378493	1678	28080869191000	28204	13944	0	0	1
211378	2134	83242046000	28207	13945	1	0	7326
378503	1874	37901000	28207	13945	1	0	2
7808	1394	1036815897440200	28208	13946	2	0	0
30922	1662	2160044000000	28209	13947	4	0	0
211387	1397	1267692904000	28211	13948	0	0	17113
378512	1678	28080869196000	28211	13948	0	0	1
211394	2132	147239252000	28214	13950	1	0	1749
378519	1874	37915000	28214	13950	1	0	2
211400	2394	1438974500000	28216	13952	1	0	3
378525	96	66001212000000	28216	13952	1	0	1
59412	2039	20059860000000	28216	13952	2	0	6
7814	1394	1039695931440200	28219	13953	3	0	0
211418	2132	147238251000	28224	13954	2	0	1750
378543	1874	37931000	28224	13954	2	0	2
21288	1560	18728879131803	28224	13954	4	0	30
24161	1599	17577072097983	28228	13956	2	0	8
211427	1397	1267602895000	28229	13957	0	0	17122
378552	1678	28080869205000	28229	13957	0	0	1
19136	1536	20160387000000	28229	13957	3	0	11
211433	1769	1568700000	28230	13958	3	0	64
378558	1874	37947000	28230	13958	4	0	2
50444	1705	30801127580140	28230	13958	7	0	25
211457	1397	1267562891000	28235	13960	0	0	17126
378576	1678	28080869210000	28236	13961	0	0	1
211470	2134	83223992000	28240	13962	1	0	7344
31485	1670	12241109000000	28240	13962	2	0	11
378589	1874	37963000	28242	13963	1	0	2
9818	1395	58325672996457278	28242	13963	3	0	0
211480	1397	1267512886000	28245	13965	0	0	17131
211481	2134	83220983000	28245	13965	1	0	7347
5023	641	82563948000000	28245	13965	2	0	16
211482	1397	1267502885000	28246	13966	0	0	17132
378597	1678	28080869215000	28246	13966	0	0	1
89	42	76460742000000	28246	13966	4	0	12
211553	1397	1267482883000	28252	13968	0	0	17134
378661	1678	28080869217000	28252	13968	0	0	1
378662	1678	28080869218000	28252	13968	1	0	1
211559	1397	1267462881000	28253	13969	0	0	17136
378668	1874	37987000	28253	13969	1	0	2
31158	1668	16353835500000	28254	13970	2	0	9
211568	2134	83213962000	28257	13971	1	0	7354
378685	1874	37996000	28261	13972	1	0	2
61099	2329	330486844819988	28263	13973	2	0	0
211584	1397	1267412876000	28264	13974	0	0	17141
378693	1874	38003000	28264	13974	1	0	2
9823	1395	58327113032457278	28267	13975	4	0	0
211611	2134	83208947000	28269	13976	1	0	7359
378717	1678	28080869227000	28270	13977	0	0	1
19565	1546	15357598800000	28270	13977	2	0	10
211617	2134	83206941000	28272	13978	1	0	7361
211618	2132	147230243000	28272	13978	2	0	1758
50812	1706	22602375450256	28272	13978	4	0	27
378727	1874	38020000	28274	13979	1	0	2
7826	1394	1044015965440200	28279	13980	3	0	0
211636	2358	50097000000	28281	13981	1	0	3
378745	1678	28080869232000	28283	13982	0	0	1
18811	1532	1440057000000	28283	13982	4	0	0
211645	2134	83201926000	28284	13983	1	0	7366
378757	1874	38036000	28288	13984	1	0	2
16538	1476	18000427000000	28288	13984	3	0	11
378763	1678	28080869235000	28291	13985	0	0	1
378764	1874	38037000	28291	13985	1	0	2
211661	2134	83199920000	28291	13985	2	0	7368
20804	1559	13986224999999	28291	13985	3	0	8
378779	1874	38046000	28297	13987	2	0	2
211676	2132	147227240000	28297	13987	3	0	1761
46508	1693	6525850623117	28297	13987	5	0	1383
211682	2134	83194905000	28298	13988	4	0	7373
378785	1874	38056000	28298	13988	4	0	2
898	58	81827671999641	28298	13988	6	0	12
211695	2134	83192899000	28302	13990	2	0	7375
378798	1874	38062000	28302	13990	2	0	2
11477	1419	27646264559748	28303	13991	2	0	8
211701	1397	1267202855000	28304	13992	0	0	17162
378804	1678	28080869245000	28304	13992	0	0	1
14129	1451	8347824000000	28304	13992	4	0	13
211707	2134	83187884000	28305	13993	3	0	7380
378810	1874	38079000	28305	13993	3	0	2
211719	1397	1267142849000	28309	13995	2	0	17168
378822	1678	28080869251000	28309	13995	2	0	1
211725	2134	83184875000	28309	13995	8	0	7383
378828	1874	38090000	28309	13995	8	0	2
211731	2134	83181866000	28310	13996	3	0	7386
378834	1874	38100000	28310	13996	3	0	2
40910	1686	19112211700123	28310	13996	6	0	17
211738	2134	83178857000	28313	13998	1	0	7389
378841	1874	38109000	28313	13998	1	0	2
211795	1397	1267072842000	28316	13999	0	0	17175
378897	1678	28080869258000	28316	13999	0	0	1
211796	1397	1267062841000	28316	13999	1	0	17176
378898	1678	28080869259000	28316	13999	1	0	1
211807	1397	1267042839000	28319	14001	0	0	17178
378909	1678	28080869261000	28319	14001	0	0	1
211821	1397	1267002835000	28323	14003	2	0	17182
378918	1678	28080869265000	28323	14003	2	0	1
40569	1685	192964923571430	28323	14003	4	0	0
211832	1397	1266992834000	28327	14004	0	0	17183
378929	1678	28080869266000	28327	14004	0	0	1
15361	1467	8800338272869	28328	14005	3	0	9
211852	1397	1266952830000	28332	14006	2	0	17187
378949	1678	28080869270000	28332	14006	2	0	1
55696	1746	6288969999989	28335	14007	2	0	7
211870	1397	1266932828000	28337	14008	0	0	17189
378967	1678	28080869272000	28337	14008	0	0	1
211875	2134	83162809000	28337	14008	5	0	7405
378972	1874	38158000	28337	14008	5	0	2
211883	2134	83158797000	28340	14010	1	0	7409
378980	1874	38170000	28340	14010	1	0	2
211900	1397	1266872822000	28343	14011	0	0	17195
211901	1397	1266862821000	28343	14011	1	0	17196
379002	1874	38176000	28343	14011	5	0	2
211907	2134	83154785000	28343	14011	7	0	7413
42084	1688	41831312113019	28343	14011	9	0	77
51060	1708	15480716324650	28344	14012	3	0	8
379009	1678	28080869283000	28346	14013	0	0	1
211915	1379	1693978636751650	28346	14013	3	0	1
379015	1874	38194000	28346	14013	6	0	2
211944	1397	1266802815000	28349	14014	0	0	17202
379039	1678	28080869285000	28349	14014	0	0	1
379040	1678	28080869286000	28349	14014	1	0	1
55138	1739	32399862000000	28352	14015	2	0	0
211954	1397	1266772812000	28354	14016	0	0	17205
379050	1874	38206000	28354	14016	1	0	2
211960	2134	83144755000	28355	14017	4	0	7423
379056	1678	28080869291000	28356	14018	0	0	1
211969	1397	1266722807000	28360	14020	0	0	17210
379065	1874	38221000	28360	14020	1	0	2
211977	2134	83139740000	28363	14022	2	0	7428
379073	1874	38230000	28363	14022	3	0	2
17848	1509	19103499503835	28363	14022	5	0	9
25630	1610	15840391999950	28365	14023	3	0	11
211991	1397	1266662801000	28368	14025	0	0	17216
379087	1874	38239000	28368	14025	1	0	2
7838	1394	1048336043440200	28372	14026	3	0	0
212006	2134	83133722000	28375	14027	2	0	7434
212035	1397	1266632798000	28379	14028	0	0	17219
379126	1678	28080869302000	28379	14028	0	0	1
212036	2134	83132719000	28379	14028	1	0	7435
3494	576	81917726726897	28382	14030	2	0	9
379134	2401	2076000000000	28383	14031	0	0	0
212044	1397	1266602795000	28383	14031	1	0	17222
22635	1587	20160538000000	28383	14031	3	0	14
379146	1678	28080869307000	28388	14033	1	0	1
212056	2134	83127704000	28388	14033	2	0	7440
9833	1395	58329273066457278	28394	14034	3	0	0
379169	1678	28080869309000	28395	14035	0	0	1
379170	1874	38269000	28395	14035	1	0	2
212083	1397	1266552790000	28398	14036	0	0	17227
379186	1678	28080869312000	28402	14038	0	0	1
212096	1397	1266522787000	28402	14038	1	0	17230
42143	1688	43991355113019	28402	14038	4	0	77
379200	1678	28080869315000	28408	14040	0	0	1
212110	1507	49990000000	28408	14040	1	0	1
212165	1397	1266492784000	28415	14042	0	0	17233
212166	1397	1266482783000	28415	14042	1	0	17234
379257	1678	28080869317000	28415	14042	1	0	1
212172	1397	1266452780000	28417	14044	0	0	17237
379263	1678	28080869320000	28417	14044	0	0	1
212178	2134	83112659000	28418	14045	4	0	7455
379269	1874	38308000	28418	14045	4	0	2
20831	1559	15426275499999	28418	14045	6	0	8
212189	1397	1266402775000	28422	14047	0	0	17242
379280	1678	28080869325000	28422	14047	0	0	1
212200	1397	1266352770000	28424	14048	4	0	17247
379291	1678	28080869330000	28424	14048	4	0	1
212206	2134	83105638000	28424	14048	10	0	7462
379297	1874	38329000	28424	14048	10	0	2
30254	1654	19577671999798	28424	14048	15	0	11
212211	2134	83101626000	28425	14049	1	0	7466
379302	1874	38341000	28425	14049	1	0	2
379344	1678	28080869334000	28429	14050	0	0	1
379345	1678	28080869335000	28429	14050	1	0	1
212260	2134	83098617000	28431	14051	1	0	7469
45209	1692	14860893819983	28431	14051	3	0	6
379353	1874	38353000	28432	14052	2	0	2
212268	338	67438024000000	28434	14053	3	0	2
379361	1874	38359000	28434	14053	5	0	2
212273	2134	83093602000	28435	14054	1	0	7474
212321	1397	1266232758000	28440	14055	0	0	17259
212322	2134	83092599000	28440	14055	1	0	7475
379408	1874	38368000	28440	14055	1	0	2
115	42	78620785000000	28440	14055	2	0	12
7851	1394	1052656065440200	28443	14057	2	0	0
212330	1397	1266202755000	28444	14058	0	0	17262
379416	1678	28080869345000	28444	14058	0	0	1
30531	1656	17275581999990	28444	14058	5	0	8
212353	1397	1266172752000	28449	14059	1	0	17265
379439	1678	28080869348000	28449	14059	1	0	1
379441	1874	38386000	28449	14059	3	0	2
53294	1718	10336630519070	28449	14059	4	0	13
379444	1678	28080869349000	28451	14060	0	0	1
212360	1397	1266152750000	28452	14061	0	0	17267
379450	1874	38395000	28452	14061	4	0	2
212368	1397	1266122747000	28454	14062	0	0	17270
31177	1668	17793868500000	28454	14062	3	0	9
59928	2106	5760214000000	28458	14063	2	0	2
379468	1678	28080869355000	28461	14064	0	0	1
56736	1759	12457328139889	28461	14064	3	0	11
212384	1397	1266092744000	28462	14065	0	0	17273
60546	2248	13679584000000	28462	14065	2	0	0
379477	1874	38413000	28465	14066	1	0	2
212395	2134	83076551000	28467	14067	1	0	7491
379491	1874	38422000	28470	14068	3	0	2
61107	2329	332646888819988	28470	14068	4	0	0
212407	1397	1266032738000	28471	14069	1	0	17279
7861	1394	1056976098440200	28471	14069	4	0	0
379497	1874	38431000	28472	14070	1	0	2
56503	1756	9920906195609	28472	14070	3	0	6
212413	2401	2078874500000	28473	14071	1	0	1
379502	1874	38437000	28474	14072	1	0	2
212418	2134	83068527000	28475	14073	1	0	7499
379510	1874	38446000	28478	14075	1	0	2
9847	1395	58331433144457278	28478	14075	3	0	0
212430	2134	83065518000	28481	14076	1	0	7502
18683	1522	14443846000000	28481	14076	2	0	14
212437	1397	1265952730000	28485	14077	0	0	17287
212438	2134	83064515000	28485	14077	1	0	7503
379530	121	66000099000000	28488	14078	1	0	1
212448	1397	1265922727000	28490	14080	0	0	17290
379535	1678	28080869374000	28490	14080	1	0	1
212454	2134	83059500000	28490	14080	6	0	7508
10634	1402	57063686812105	28490	14080	8	0	66
379557	1678	28080869376000	28494	14081	0	0	1
212479	1397	1265872722000	28498	14083	0	0	17295
379567	1678	28080869380000	28498	14083	2	0	1
212485	2134	83054485000	28498	14083	6	0	7513
379572	1678	28080869381000	28499	14084	0	0	1
379577	1678	28080869382000	28501	14085	0	0	1
379578	1874	38490000	28501	14085	1	0	2
212497	1397	1265822717000	28503	14086	0	0	17300
379596	1874	38499000	28507	14087	1	0	2
12235	1426	18330516000000	28507	14087	3	0	8
212535	1397	1265802715000	28510	14088	0	0	17302
44896	1691	14111180300052	28510	14088	3	0	10
379624	2404	100000000	28512	14089	2	0	0
212544	1726	931836112000	28512	14089	3	0	8349
35238	1679	19438487656999	28512	14089	6	0	100
379649	1874	38513000	28518	14090	2	0	2
212569	2133	89808266000	28518	14090	3	0	6869
212570	1397	1265772712000	28519	14091	0	0	17305
379661	1874	38523000	28522	14092	1	0	2
212582	2133	9556262000	28523	14093	0	0	6872
379667	1874	38530000	28523	14093	4	0	2
212598	1874	7530000	28526	14094	1	0	3
379682	1874	7536000	28526	14094	4	0	3
212607	1397	1265732708000	28528	14095	0	0	17309
23799	1596	10080316000002	28528	14095	4	0	16
379696	1678	28080869393000	28530	14096	0	0	1
212617	2134	83042449000	28530	14096	2	0	7525
379702	1874	7550000	28531	14097	3	0	3
212623	2134	12791446000	28531	14097	5	0	7527
9854	1395	58333593167457278	28531	14097	8	0	0
379709	1678	28080869396000	28533	14098	0	0	1
212634	1397	1265682703000	28536	14099	0	0	17314
379715	1678	28080869397000	28536	14099	0	0	1
379716	2405	100000000	28536	14099	1	0	0
212646	1397	1265662701000	28541	14101	0	0	17316
379728	1874	7566000	28541	14101	2	0	3
212669	2132	7215229000	28543	14102	4	0	1773
379751	1678	28080869401000	28544	14103	0	0	1
212679	2133	9542234000	28547	14104	1	0	6886
15188	1458	23705501908540	28547	14104	3	0	8
379771	1678	28080869403000	28553	14105	0	0	1
46614	1693	7965897623117	28553	14105	5	0	1383
212703	2134	12786427000	28557	14106	1	0	7532
379785	1874	7596000	28557	14106	2	0	3
212705	1397	1265602695000	28558	14107	0	0	17322
212706	1397	1265592694000	28558	14107	1	0	17323
379791	1874	7604000	28558	14107	5	0	3
45252	1692	17020917819983	28558	14107	7	0	6
212725	1397	1265582693000	28560	14108	0	0	17324
379809	1678	28080869408000	28561	14109	0	0	1
212731	2134	12783415000	28561	14109	3	0	7535
379815	1874	7623000	28561	14109	6	0	3
212736	2132	7212226000	28561	14109	8	0	1776
379837	1678	28080869412000	28565	14111	0	0	1
212758	2134	12780403000	28565	14111	2	0	7538
379842	1874	7641000	28565	14111	5	0	3
379890	1678	28080869414000	28570	14112	0	0	1
212810	1397	1265502685000	28570	14112	1	0	17332
379891	1678	28080869415000	28570	14112	1	0	1
212815	2133	9530210000	28570	14112	6	0	6898
379897	1874	7658000	28570	14112	7	0	3
212827	2386	1090227000000	28572	14113	3	0	1
379909	1874	7666000	28572	14113	4	0	3
212953	1397	1265462681000	28578	14114	0	0	17336
380034	1678	28080869419000	28578	14114	0	0	1
212954	1397	1265452680000	28578	14114	1	0	17337
380035	1678	28080869420000	28578	14114	1	0	1
212962	1397	1265442679000	28580	14115	0	0	17338
380043	1678	28800894421000	28580	14115	0	0	1
212977	1397	1265422677000	28583	14116	0	0	17340
212978	2133	9521192000	28583	14116	1	0	6907
380059	1874	7691000	28583	14116	1	0	3
380068	1678	28800894426000	28585	14117	2	0	1
212988	2133	9520190000	28585	14117	3	0	6908
380074	1874	7711000	28585	14117	8	0	3
7876	1394	1061296144440200	28585	14117	9	0	0
212997	1397	1265382673000	28587	14118	0	0	17344
213008	2134	12768355000	28591	14119	3	0	7550
380089	1874	7723000	28591	14119	3	0	3
30271	1654	21737695999798	28592	14120	4	0	11
380094	1392	1711184787751650	28593	14121	0	0	0
213014	1397	1265352670000	28593	14121	1	0	17347
380100	1874	7734000	28593	14121	6	0	3
213020	2133	9514178000	28593	14121	7	0	6914
380130	1678	28800894431000	28597	14122	0	0	1
380131	1874	7742000	28597	14122	1	0	3
7887	1394	1064176204440200	28597	14122	4	0	0
213055	1397	1265332668000	28599	14123	0	0	17349
48090	1696	22763871335104	28599	14123	3	0	9
380146	1874	7749000	28602	14124	1	0	3
29616	1649	15591672999968	28602	14124	4	0	8
213067	1397	1265312666000	28603	14125	0	0	17351
7889	1394	1065616216440200	28603	14125	4	0	0
380155	1874	7761000	28605	14126	1	0	3
213076	2132	7204218000	28605	14126	3	0	1784
380175	1678	28800894437000	28613	14128	0	0	1
213096	2134	12761327000	28613	14128	2	0	7557
32188	1672	16561581000000	28613	14128	3	0	10
380181	1874	7782000	28614	14129	3	0	3
213102	2133	9504158000	28614	14129	5	0	6924
30813	1657	12961503990100	28614	14129	8	0	11
5083	641	84724008500000	28616	14130	2	0	16
380189	1678	28800894441000	28617	14131	0	0	1
213110	2134	12758315000	28617	14131	2	0	7560
213123	1397	1265232658000	28621	14132	0	0	17359
213124	2132	7202216000	28621	14132	1	0	1786
380206	1874	7798000	28621	14132	2	0	3
42216	1688	46871428113019	28622	14133	4	0	77
213156	1397	1265212656000	28624	14134	0	0	17361
380255	1678	28800894445000	28627	14135	0	0	1
380257	1874	7814000	28627	14135	2	0	3
380258	1874	7815000	28627	14135	3	0	3
57107	1762	13605704994000	28627	14135	4	0	8
213179	2134	12754299000	28628	14136	1	0	7564
40582	1685	195124951571430	28628	14136	3	0	0
380264	1678	28800894449000	28629	14137	2	0	1
213184	1397	1265152650000	28629	14137	3	0	17367
380270	1874	7836000	28629	14137	8	0	3
213190	2133	9496142000	28629	14137	9	0	6932
26379	1619	10800305000000	28629	14137	13	0	0
380280	1874	7844000	28633	14138	1	0	3
213201	1397	1265122647000	28634	14139	1	0	17370
380286	1874	7855000	28634	14139	5	0	3
213214	1397	1265112646000	28637	14140	0	0	17371
3230	555	67440075000000	28637	14140	2	0	0
213303	1397	1265102645000	28641	14141	0	0	17372
213304	2132	7198212000	28641	14141	1	0	1790
380387	1678	28800894457000	28642	14142	1	0	1
380403	1678	28800894458000	28647	14143	0	0	1
213323	2134	12745263000	28647	14143	1	0	7573
380404	1874	7872000	28647	14143	1	0	3
49038	1700	14634363979053	28647	14143	3	0	10
213333	2134	12743255000	28651	14145	3	0	7575
380414	1874	7881000	28651	14145	3	0	3
213338	2134	12742251000	28652	14146	4	0	7576
380420	1678	28800894464000	28653	14147	0	0	1
213344	2134	12740243000	28653	14147	5	0	7578
380425	1874	7895000	28653	14147	5	0	3
213356	2134	12737231000	28655	14148	4	0	7581
380437	1874	7907000	28655	14148	4	0	3
7893	1394	1067056216440200	28661	14150	1	0	0
213379	1397	1264932628000	28663	14151	0	0	17389
380461	1874	7913000	28663	14151	1	0	3
213453	1397	1264912626000	28667	14153	0	0	17391
380534	1678	28800894474000	28667	14153	0	0	1
213454	2134	12733215000	28667	14153	1	0	7585
380535	1874	7925000	28667	14153	1	0	3
10670	1402	59223773812105	28668	14154	5	0	66
213466	1379	2000001650	28671	14155	1	0	2
380547	2400	1693977634750000	28671	14155	1	0	1
213594	1397	1264872622000	28675	14156	0	0	17395
380675	1678	28800894478000	28675	14156	0	0	1
213595	1397	1264862621000	28675	14156	1	0	17396
380676	1678	28800894479000	28675	14156	1	0	1
213616	2134	12728195000	28678	14157	3	0	7590
380697	1874	7947000	28678	14157	3	0	3
213626	2133	9490130000	28681	14159	1	0	6938
380707	1874	7956000	28681	14159	1	0	3
17535	1508	18920526156616	28681	14159	2	0	10
213632	2133	9488126000	28685	14161	1	0	6940
380713	1874	7964000	28685	14161	1	0	3
2883	484	75453960000000	28685	14161	5	0	8
213646	1397	1264782613000	28689	14163	0	0	17404
380727	1678	28800894487000	28689	14163	0	0	1
213652	1397	1264762611000	28691	14165	0	0	17406
380733	1678	28800894489000	28691	14165	0	0	1
213661	1397	1264752610000	28694	14166	0	0	17407
213662	2133	9483116000	28694	14166	1	0	6945
24862	1602	14976736169996	28694	14166	3	0	9
380752	1678	28800894491000	28698	14167	0	0	1
16807	1489	16223290040000	28698	14167	3	0	10
213676	2134	12720163000	28699	14168	2	0	7598
380758	1874	8005000	28699	14168	3	0	3
213682	2133	9479108000	28702	14170	1	0	6949
380764	1678	28800894495000	28703	14171	0	0	1
213690	1397	1264692604000	28705	14172	0	0	17413
380772	1874	8022000	28705	14172	1	0	3
47742	1695	17225310999000	28716	14173	1	0	9
213704	2132	7185199000	28719	14174	2	0	1803
380808	1678	28800894498000	28724	14175	0	0	1
380809	1678	28800894499000	28724	14175	1	0	1
213732	2133	9474098000	28724	14175	5	0	6954
380815	1678	28800894500000	28725	14176	0	0	1
213743	2132	7184198000	28731	14177	1	0	1804
9863	1395	58335753468457278	28731	14177	4	0	0
380827	1678	28800894502000	28732	14178	0	0	1
20131	1549	15551455000000	28732	14178	3	0	10
213757	2393	2157990000000	28735	14179	0	0	1
380840	1874	8066000	28735	14179	2	0	3
60371	2148	12960379880750	28735	14179	4	0	2
7905	1394	1071376261440200	28737	14180	2	0	0
213767	1397	1264602595000	28739	14181	0	0	17422
19145	1536	21600433000000	28739	14181	3	0	11
213898	1397	1264592594000	28743	14182	0	0	17423
380979	1678	28800894506000	28743	14182	0	0	1
213899	2134	12709119000	28743	14182	1	0	7609
380980	1874	8077000	28743	14182	1	0	3
14159	1451	9787848000000	28748	14183	4	0	13
213921	1397	1264562591000	28756	14185	0	0	17426
381002	1678	28800894509000	28756	14185	0	0	1
56129	1749	1442609529980	28756	14185	3	0	23
213929	2132	7181195000	28758	14186	2	0	1807
213930	2134	12705103000	28758	14186	3	0	7613
381012	1678	28800894511000	28759	14187	0	0	1
11856	1422	14634743804270	28759	14187	3	0	12
213940	2133	9466082000	28762	14188	3	0	6962
381021	1874	8105000	28762	14188	3	0	3
213948	1397	1264502585000	28766	14190	2	0	17432
381029	1678	28800894515000	28766	14190	2	0	1
213953	2134	12702091000	28766	14190	7	0	7616
381035	1874	8127000	28766	14190	8	0	3
213975	2133	9461072000	28769	14191	4	0	6967
381056	1874	8137000	28769	14191	4	0	3
41266	1687	12369044648287	28770	14192	3	0	7
213984	1397	1264462581000	28772	14193	0	0	17436
381065	1678	28800894519000	28772	14193	0	0	1
381076	1874	8152000	28776	14194	0	0	3
213996	1397	1264452580000	28777	14195	0	0	17437
381077	1678	28800894520000	28777	14195	0	0	1
214002	2133	9455060000	28777	14195	6	0	6973
381083	1874	8159000	28777	14195	6	0	3
16214	1474	25730678000043	28777	14195	9	0	30
214016	2134	12694059000	28779	14196	4	0	7624
381097	1874	8173000	28779	14196	4	0	3
214039	2133	9452054000	28783	14197	3	0	6976
381120	1874	8182000	28783	14197	3	0	3
35286	1679	21598535656999	28783	14197	5	0	100
31926	1671	19824329003785	28784	14198	5	0	8
214045	1397	1264372572000	28785	14199	0	0	17445
381126	1678	28800894528000	28785	14199	0	0	1
17202	1506	10080298967172	28785	14199	4	0	23
214054	2134	12690043000	28787	14200	3	0	7628
381135	1874	8203000	28787	14200	3	0	3
45304	1692	19901087819983	28787	14200	4	0	6
214059	1397	1264322567000	28789	14202	2	0	17450
381140	1678	28800894533000	28789	14202	2	0	1
214065	2134	12688035000	28789	14202	8	0	7630
381146	1874	8220000	28789	14202	8	0	3
214066	2134	12687031000	28789	14202	9	0	7631
61115	2329	334086921819988	28790	14203	2	0	0
381152	1874	8231000	28791	14204	2	0	3
214072	2133	9442034000	28791	14204	3	0	6986
381167	1874	8239000	28794	14205	3	0	3
214094	1397	1264272562000	28797	14206	0	0	17455
381182	1874	8252000	28799	14207	1	0	3
214102	1397	1264262561000	28802	14208	0	0	17456
381194	1678	28800894541000	28806	14209	1	0	1
214114	2134	12681007000	28806	14209	2	0	7637
381205	1678	28800894542000	28809	14210	0	0	1
214126	2133	9434018000	28809	14210	2	0	6994
381211	1678	28800894543000	28811	14211	0	0	1
381212	1874	8277000	28811	14211	1	0	3
214143	2132	7170184000	28816	14212	1	0	1818
381227	1874	8288000	28817	14213	1	0	3
214152	2134	12676991000	28819	14214	1	0	7641
381236	1874	8298000	28820	14215	1	0	3
9876	1395	58337913519457278	28820	14215	2	0	0
214158	2132	7169183000	28821	14216	2	0	1819
381241	1874	8307000	28822	14217	1	0	3
7916	1394	1075696308440200	28822	14217	2	0	0
214193	2133	9428006000	28826	14218	2	0	7000
381277	1874	8316000	28826	14218	5	0	3
51363	1709	11520282000000	28826	14218	9	0	8
214199	1397	1264132548000	28827	14219	0	0	17469
214201	2134	12672975000	28827	14219	2	0	7645
214223	1397	1264122547000	28831	14220	0	0	17470
381304	1678	28800894553000	28831	14220	0	0	1
381309	1874	8335000	28831	14220	5	0	3
214229	2134	12670967000	28831	14220	6	0	7647
381322	1874	8347000	28834	14222	3	0	3
214242	2133	9418988000	28834	14222	4	0	7009
214247	2134	12667955000	28835	14223	3	0	7650
381328	1874	8359000	28835	14223	3	0	3
10695	1402	61383797812105	28835	14223	6	0	66
381339	1874	8368000	28838	14224	2	0	3
51086	1708	17640740324650	28838	14224	4	0	8
214262	1397	1264052540000	28840	14225	0	0	17477
381345	1874	8369000	28840	14225	2	0	3
381346	1874	8371000	28840	14225	3	0	3
214268	2134	12664943000	28840	14225	6	0	7653
18192	1513	37441253000000	28840	14225	7	0	0
381370	1678	28800894563000	28846	14227	0	0	1
214291	2133	9411974000	28846	14227	2	0	7016
39496	1684	33843613819412	28846	14227	4	0	136
381380	1874	8392000	28850	14228	2	0	3
214301	2134	12662935000	28850	14228	4	0	7655
381385	1678	28800894567000	28851	14229	1	0	1
214307	2133	9408968000	28851	14229	4	0	7019
381391	1874	8415000	28852	14230	1	0	3
214312	1397	1263962531000	28853	14231	0	0	17486
381397	1874	8422000	28853	14231	4	0	3
48386	1698	17349052550062	28853	14231	6	0	12
214324	1397	1263942529000	28855	14232	0	0	17488
381408	1874	8428000	28855	14232	3	0	3
214330	2133	9401954000	28855	14232	6	0	7026
381414	2410	100000000	28855	14232	9	0	0
61124	2329	336246955819988	28855	14232	10	0	0
214335	1397	1263902525000	28856	14233	1	0	17492
214337	1397	1263882523000	28856	14233	3	0	17494
214338	1397	1263872522000	28856	14233	4	0	17495
381420	1406	0	28856	14233	5	0	0
214344	2133	9397946000	28856	14233	10	0	7030
381425	1874	8449000	28856	14233	10	0	3
214350	2132	7160174000	28856	14233	16	0	1828
381431	1874	8468000	28856	14233	16	0	3
214398	2133	9394940000	28863	14235	1	0	7033
381480	1874	8477000	28863	14235	2	0	3
381481	1874	8481000	28863	14235	3	0	3
60147	2112	28607069101924	28863	14235	5	0	7
381482	1678	28800894581000	28864	14236	1	0	1
26498	1622	10404073800048	28864	14236	4	0	10
214407	1397	1263832518000	28866	14237	0	0	17499
2629	470	79555372000000	28866	14237	3	0	13
381490	2411	0	28867	14238	1	0	0
214413	2133	9391934000	28867	14238	3	0	7036
9882	1395	58339353565457278	28868	14239	3	0	0
381496	1678	28800894585000	28869	14240	0	0	1
214418	2133	9389930000	28869	14240	1	0	7038
44630	1690	187205860000000	28869	14240	4	0	0
381504	1874	8506000	28871	14241	2	0	3
214432	2411	10000000	28873	14242	0	0	1
381515	1874	8517000	28873	14242	4	0	3
40590	1685	197284997571430	28874	14243	1	0	0
214444	1397	1263772512000	28877	14244	0	0	17505
381527	1678	28800894589000	28878	14245	1	0	1
214449	2134	12643859000	28878	14245	2	0	7674
381537	1874	8536000	28880	14246	1	0	3
7924	1394	1078576343440200	28880	14246	4	0	0
214466	1397	1263742509000	28883	14247	0	0	17508
381549	1678	28800894592000	28884	14248	1	0	1
214472	2134	12641851000	28884	14248	3	0	7676
214473	2132	7155169000	28884	14248	4	0	1833
214481	1397	1263722507000	28886	14249	0	0	17510
381562	1874	8549000	28886	14249	2	0	3
214487	1133	1000000000	28886	14249	7	0	1
49617	1702	8640615000000	28886	14249	8	0	5
381567	1678	28800894595000	28887	14250	0	0	1
214493	2134	12638839000	28888	14251	3	0	7679
381585	1678	28800894597000	28892	14252	0	0	1
214510	2133	9376904000	28892	14252	4	0	7051
381599	1678	28800894599000	28895	14253	0	0	1
214528	2133	9374900000	28897	14254	1	0	7053
381608	1874	8585000	28897	14254	2	0	3
46724	1693	10125922623117	28897	14254	4	0	1383
7932	1394	1082896369440200	28899	14255	4	0	0
214608	1397	1263632498000	28904	14256	0	0	17519
381687	1678	28800894602000	28904	14256	0	0	1
214609	1397	1263622497000	28904	14256	1	0	17520
381688	1678	28800894603000	28904	14256	1	0	1
214610	1397	1263612496000	28904	14256	2	0	17521
27121	1623	86403606898598	28904	14256	7	0	1
381756	1874	8608000	28906	14257	0	0	3
381757	2415	100000000	28906	14257	1	0	0
214679	2133	9371894000	28906	14257	2	0	7056
49064	1700	16074392979053	28906	14257	7	0	10
381763	1874	8618000	28907	14258	1	0	3
214685	2132	7151165000	28907	14258	2	0	1837
214696	2133	9364880000	28911	14260	1	0	7063
381775	1874	8629000	28911	14260	1	0	3
15396	1467	10960363272869	28912	14261	2	0	9
381785	1874	8642000	28916	14262	0	0	3
214707	2134	12627795000	28916	14262	1	0	7690
445	43	82560295890000	28920	14263	4	0	3
381795	1678	28800894608000	28921	14264	1	0	1
214717	2134	12625787000	28921	14264	2	0	7692
214739	2133	9358868000	28925	14265	2	0	7069
381818	1874	8663000	28925	14265	2	0	3
214755	1397	1263542489000	28928	14266	0	0	17528
381834	1678	28800894611000	28928	14266	0	0	1
214756	1726	123027112000	28928	14266	1	0	8358
57795	1768	27107244110000	28929	14267	3	0	10
381840	1678	28800894613000	28930	14268	0	0	1
214762	1397	1263512486000	28930	14268	1	0	17531
381846	1874	8695000	28930	14268	6	0	3
214781	1397	1263502485000	28934	14269	0	0	17532
381864	1874	8703000	28935	14270	2	0	3
214786	2132	7146160000	28935	14270	3	0	1842
381873	1874	8714000	28938	14272	1	0	3
214795	2133	9349850000	28938	14272	2	0	7078
58860	1991	18621542355805	28940	14273	3	0	21
381889	1874	8724000	28944	14274	1	0	3
214811	2132	7145159000	28944	14274	2	0	1843
381890	1874	8725000	28944	14274	2	0	3
214819	2133	9346844000	28946	14275	4	0	7081
381899	1874	8730000	28946	14275	5	0	3
7943	1394	1087216431440200	28946	14275	11	0	0
214837	1397	1263412476000	28950	14276	0	0	17541
381917	1678	28800894625000	28951	14277	0	0	1
214843	1397	1263392474000	28952	14278	0	0	17543
381922	1678	28800894626000	28952	14278	0	0	1
49370	1701	18718542500103	28952	14278	5	0	14
214848	2133	9340832000	28953	14279	1	0	7087
23223	1593	18672869000000	28953	14279	3	0	8
381928	1678	28800894628000	28954	14280	0	0	1
32401	1673	12455495000000	28954	14280	3	0	18
214857	2134	12609723000	28956	14281	2	0	7708
381937	1678	28800894630000	28957	14282	0	0	1
214863	2133	9336824000	28957	14282	5	0	7091
381942	1874	8782000	28957	14282	5	0	3
214881	2133	9335822000	28960	14283	2	0	7092
214888	1397	1263322467000	28963	14284	0	0	17550
381968	1874	8792000	28963	14284	1	0	3
214905	2133	9333818000	28967	14285	2	0	7094
381985	1874	8801000	28967	14285	3	0	3
214922	1397	1263282463000	28972	14287	0	0	17554
382001	1678	28800894637000	28972	14287	0	0	1
24230	1599	21177132097983	28972	14287	4	0	8
214931	2134	12602695000	28974	14288	1	0	7715
382011	1874	8822000	28974	14288	2	0	3
214937	2132	7139153000	28975	14289	4	0	1849
382017	1874	8831000	28975	14289	5	0	3
382030	1678	28800894641000	28979	14290	0	0	1
382031	1874	8835000	28979	14290	1	0	3
214955	2133	9325802000	28980	14291	1	0	7102
382040	1678	28800894644000	28982	14292	2	0	1
214963	1963	731505120000	28982	14292	3	0	2
215039	1397	1263202455000	28986	14293	0	0	17562
382115	1678	28800894645000	28986	14293	0	0	1
215040	2134	12597675000	28986	14293	1	0	7720
382129	1874	8861000	28992	14294	2	0	3
215061	2133	9320792000	28994	14295	1	0	7107
382141	1874	8873000	28996	14296	2	0	3
215073	2133	9318788000	28998	14297	1	0	7109
382150	1874	8882000	28999	14298	2	0	3
215081	1397	1263142449000	29001	14299	0	0	17568
382158	1874	8890000	29001	14299	4	0	3
215087	1397	1263122447000	29002	14300	0	0	17570
382161	1874	8898000	29002	14300	1	0	3
382162	1874	8899000	29002	14300	2	0	3
42317	1688	49751477113019	29002	14300	5	0	77
215093	1397	1263102445000	29004	14302	0	0	17572
382168	1874	8905000	29004	14302	2	0	3
215098	2134	12589643000	29004	14302	5	0	7728
382181	1874	8918000	29006	14303	1	0	3
215111	1397	1263062441000	29007	14304	1	0	17576
382186	1874	8928000	29007	14304	3	0	3
7952	1394	1091536454440200	29007	14304	5	0	0
215126	2133	9307766000	29010	14305	2	0	7120
382205	1678	28800894661000	29012	14306	0	0	1
215144	1397	1263032438000	29015	14307	0	0	17579
382220	1874	8948000	29015	14307	3	0	3
215150	1397	1263012436000	29016	14308	0	0	17581
382225	1874	8958000	29016	14308	2	0	3
53707	1719	20878786000000	29016	14308	4	0	10
215153	296	66001900000000	29017	14309	0	0	1
215154	1397	1263002435000	29017	14309	1	0	17582
382231	1874	8963000	29017	14309	5	0	3
19905	1547	15114875000000	29017	14309	7	0	12
215160	1397	1262982433000	29018	14310	0	0	17584
22213	1573	9939447000000	29018	14310	3	0	10
382237	1874	8975000	29019	14311	1	0	3
215166	1397	1262962431000	29020	14312	0	0	17586
27132	1623	88563646898598	29020	14312	3	0	1
382248	1874	8983000	29023	14313	1	0	3
215177	2132	7130144000	29023	14313	3	0	1858
382269	1874	8994000	29027	14314	3	0	3
215198	693	66000000000000	29028	14315	0	0	1
382275	1874	9004000	29028	14315	4	0	3
215204	2132	7129143000	29028	14315	6	0	1859
382286	1874	9009000	29030	14316	2	0	3
215215	2132	7128142000	29030	14316	4	0	1860
382292	1874	9022000	29031	14317	2	0	3
215231	1397	1262872422000	29035	14318	1	0	17595
382302	1678	28800894678000	29035	14318	1	0	1
382303	1874	9024000	29035	14318	2	0	3
9894	1395	58341513624457278	29037	14319	3	0	0
215238	2134	12572575000	29038	14320	1	0	7745
382310	1874	9035000	29038	14320	2	0	3
215247	2134	12571571000	29040	14321	2	0	7746
382320	1874	9047000	29041	14322	1	0	3
215259	2133	9285722000	29043	14323	2	0	7142
382331	1874	9053000	29043	14323	3	0	3
215265	2134	12568559000	29044	14324	2	0	7749
7959	1394	1095856501440200	29044	14324	3	0	0
382340	1678	28800894686000	29046	14325	0	0	1
215273	2133	9282716000	29046	14325	4	0	7145
382358	1678	28800894688000	29049	14326	0	0	1
215289	2134	12566551000	29049	14326	2	0	7751
215302	1397	1262762411000	29054	14327	0	0	17606
382375	1874	9085000	29054	14327	2	0	3
27354	1633	11568713625277	29054	14327	3	0	12
215308	2133	9277706000	29055	14328	3	0	7150
382381	1874	9094000	29055	14328	5	0	3
10713	1402	62824123812105	29055	14328	7	0	66
45331	1692	21341136819983	29058	14329	4	0	6
215368	1397	1262722407000	29064	14330	0	0	17610
382439	1678	28800894693000	29064	14330	0	0	1
382440	1678	28800894694000	29064	14330	1	0	1
215373	2133	9275702000	29064	14330	5	0	7152
382446	1874	9111000	29064	14330	7	0	3
215383	2132	7122136000	29066	14331	2	0	1866
382464	1678	28800894697000	29069	14332	0	0	1
215397	2133	9270692000	29070	14333	2	0	7157
24508	1601	11186054620000	29070	14333	3	0	21
382473	1678	28800894699000	29073	14334	0	0	1
215412	2132	7121135000	29076	14335	1	0	1867
382485	1874	9143000	29076	14335	3	0	3
52009	1711	19867098000000	29076	14335	4	0	13
215429	1397	1262642399000	29081	14336	0	0	17618
215430	2133	9267686000	29081	14336	1	0	7160
382515	1678	28800894703000	29086	14338	0	0	1
215446	2133	9265682000	29086	14338	2	0	7162
382520	1874	9160000	29087	14339	1	0	3
16562	1476	20160474000000	29087	14339	3	0	11
215452	2134	12554503000	29088	14340	2	0	7763
382526	1874	9169000	29089	14341	2	0	3
215463	1397	1262582393000	29091	14342	0	0	17624
382538	1874	9177000	29091	14342	4	0	3
215469	1397	1262562391000	29092	14343	0	0	17626
18698	1522	15883903000000	29092	14343	4	0	14
382546	1678	28800894710000	29094	14344	0	0	1
215478	2133	9258668000	29094	14344	3	0	7169
382572	1678	28800894711000	29099	14345	0	0	1
382573	1874	9196000	29099	14345	1	0	3
215519	1397	1262512386000	29102	14346	2	0	17631
382591	1874	9202000	29102	14346	5	0	3
215525	2134	12547475000	29102	14346	8	0	7770
382599	1874	9217000	29104	14347	1	0	3
9906	1395	58343673684457278	29104	14347	3	0	0
215656	1397	1262492384000	29106	14348	0	0	17633
382724	1678	28800894716000	29106	14348	0	0	1
215657	2133	9252656000	29106	14348	1	0	7175
382725	1874	9219000	29106	14348	1	0	3
3530	576	84077786726897	29106	14348	4	0	9
215666	1397	1262472382000	29109	14350	0	0	17635
382734	1678	28800894718000	29109	14350	0	0	1
215672	2134	12543459000	29110	14351	1	0	7774
382740	1874	9242000	29110	14351	1	0	3
215681	2134	12542455000	29112	14352	2	0	7775
382749	1874	9251000	29112	14352	2	0	3
61136	2329	338407017819988	29112	14352	3	0	0
215687	2134	12541451000	29113	14353	5	0	7776
382755	1874	9260000	29113	14353	5	0	3
215697	1397	1262402375000	29115	14354	1	0	17642
215698	1397	1262392374000	29115	14354	2	0	17643
382769	1874	9268000	29115	14354	5	0	3
215845	1397	1262382373000	29119	14355	0	0	17644
382912	1678	28800894727000	29119	14355	0	0	1
215846	2134	12538439000	29119	14355	1	0	7779
382913	1874	9278000	29119	14355	1	0	3
7971	1394	1098736547440200	29119	14355	2	0	0
215852	2133	9239630000	29120	14356	3	0	7188
382919	1874	9285000	29120	14356	3	0	3
215866	1397	1262342369000	29124	14358	0	0	17648
382933	1678	28800894731000	29124	14358	0	0	1
7979	1394	1103056572440200	29124	14358	3	0	0
215871	2134	12534423000	29125	14359	2	0	7783
382938	1874	9306000	29125	14359	2	0	3
25666	1610	18000427999950	29125	14359	6	0	11
383003	1678	28800894734000	29127	14360	0	0	1
383004	1678	28800894735000	29127	14360	1	0	1
215940	1397	1262292364000	29127	14360	2	0	17653
383010	1874	9318000	29127	14360	7	0	3
215946	2133	9231614000	29127	14360	8	0	7196
216075	1397	1262272362000	29129	14361	0	0	17655
383138	1678	28800894738000	29129	14361	0	0	1
216076	1397	1262262361000	29129	14361	1	0	17656
383139	1678	28800894739000	29129	14361	1	0	1
216082	2134	12529403000	29130	14362	3	0	7788
383145	1874	9344000	29130	14362	3	0	3
216096	1397	1262222357000	29132	14363	1	0	17660
383159	1678	28800894743000	29132	14363	1	0	1
216101	2133	9224600000	29132	14363	6	0	7203
383164	1874	9360000	29132	14363	6	0	3
216107	1397	1262202355000	29134	14364	0	0	17662
216108	2133	9223598000	29134	14364	1	0	7204
11504	1419	29806322559748	29134	14364	2	0	8
383172	1678	28800894746000	29135	14365	0	0	1
216114	2134	12524383000	29135	14365	5	0	7793
383178	1874	9387000	29135	14365	6	0	3
4317	632	83997789000000	29135	14365	8	0	9
46820	1693	12285972623117	29136	14366	2	0	1383
216126	2133	9219590000	29138	14367	2	0	7208
383189	1874	9391000	29138	14367	2	0	3
216134	2133	9218588000	29140	14368	1	0	7209
383198	1874	9406000	29140	14368	2	0	3
216143	2133	9216584000	29142	14369	4	0	7211
383207	1874	9411000	29142	14369	5	0	3
216158	2133	9214580000	29144	14370	1	0	7213
383221	1874	9423000	29144	14370	1	0	3
48416	1698	18789099550062	29145	14371	3	0	12
216169	2132	7104118000	29148	14372	1	0	1884
383233	1874	9434000	29148	14372	2	0	3
31520	1670	14401143000000	29148	14372	4	0	11
216175	2134	12514343000	29149	14373	3	0	7803
383239	1874	9446000	29149	14373	4	0	3
216181	2133	9208568000	29150	14374	3	0	7219
383244	1874	9452000	29150	14374	3	0	3
216189	1397	1262022337000	29153	14376	0	0	17680
383252	1678	28800894763000	29153	14376	0	0	1
383253	1874	9466000	29153	14376	1	0	3
216198	2133	9206564000	29155	14377	4	0	7221
383262	1874	9474000	29155	14377	5	0	3
216213	2133	9202556000	29157	14378	1	0	7225
216263	2133	9201554000	29161	14379	0	0	7226
383324	1874	9486000	29161	14379	0	0	3
216264	2134	12508319000	29161	14379	1	0	7809
216392	2134	12507315000	29164	14380	0	0	7810
383453	1874	9494000	29164	14380	0	0	3
216393	2133	9200552000	29164	14380	1	0	7227
383454	1874	9496000	29164	14380	1	0	3
216408	2133	9199550000	29169	14381	5	0	7228
383469	1874	9506000	29169	14381	5	0	3
10749	1402	64984160812105	29173	14382	4	0	66
216433	1397	1261932328000	29175	14383	0	0	17689
383494	1678	28800894772000	29175	14383	0	0	1
9911	1395	58345833733457278	29175	14383	3	0	0
216441	1397	1261912326000	29178	14385	0	0	17691
383502	1678	28800894774000	29178	14385	0	0	1
216459	1397	1261892324000	29183	14387	0	0	17693
383518	1678	28800894776000	29183	14387	0	0	1
216515	1397	1261882323000	29185	14388	0	0	17694
383574	1678	28800894777000	29185	14388	0	0	1
216516	1397	1261872322000	29185	14388	1	0	17695
383575	1678	28800894778000	29185	14388	1	0	1
31948	1671	21984385003785	29185	14388	6	0	8
216534	2133	9188528000	29188	14389	1	0	7239
383593	1874	9552000	29188	14389	1	0	3
216548	2132	7103117000	29192	14391	2	0	1885
383607	1874	9561000	29192	14391	2	0	3
216558	2133	9184520000	29195	14392	3	0	7243
383617	1874	9569000	29195	14392	3	0	3
14755	1457	15840363800000	29197	14393	5	0	8
216607	1397	1261802315000	29203	14394	0	0	17702
383666	1678	28800894785000	29203	14394	0	0	1
383667	1678	28800894786000	29203	14394	1	0	1
3985	606	81166997286229	29203	14394	7	0	18
216627	1397	1261772312000	29206	14395	0	0	17705
383687	1874	9588000	29206	14395	1	0	3
216632	2134	12492255000	29206	14395	5	0	7825
24934	1604	3700000	29206	14395	7	0	0
216764	1397	1261762311000	29209	14396	0	0	17706
383823	1678	28800894789000	29209	14396	0	0	1
216765	2134	12491251000	29209	14396	1	0	7826
383824	1874	9605000	29209	14396	1	0	3
937	58	83987697999641	29213	14397	3	0	12
216784	2132	7100114000	29215	14398	2	0	1888
383843	1874	9612000	29215	14398	2	0	3
216785	2134	12490247000	29215	14398	3	0	7827
216786	1397	1261732308000	29216	14399	0	0	17709
7987	1394	1107376619440200	29216	14399	3	0	0
383856	1874	9624000	29220	14400	1	0	3
216804	1397	1261712306000	29223	14401	0	0	17711
36137	1680	18013450499559	29223	14401	4	0	12
383875	1678	28800894795000	29227	14402	0	0	1
27391	1633	13728810625277	29227	14402	3	0	12
216824	1397	1261692304000	29229	14403	0	0	17713
383886	1874	9643000	29229	14403	3	0	3
9918	1395	58347993770457278	29229	14403	5	0	0
216829	1397	1261672302000	29230	14404	0	0	17715
383896	1678	28800894799000	29232	14405	0	0	1
216839	2133	9168488000	29232	14405	2	0	7259
383901	1874	9659000	29233	14406	2	0	3
216845	2133	9166484000	29233	14406	5	0	7261
383907	2403	1428994500000	29234	14407	2	0	1
216850	2133	9164480000	29234	14407	4	0	7263
383925	1874	9680000	29238	14408	1	0	3
216868	2134	12480207000	29238	14408	3	0	7837
383932	1678	28800894805000	29240	14409	0	0	1
383933	1874	9688000	29240	14409	1	0	3
42382	1688	51911513113019	29241	14410	3	0	77
216881	1397	1261582293000	29243	14411	0	0	17724
383942	1874	9700000	29243	14411	2	0	3
216889	2132	7095109000	29245	14412	2	0	1893
9926	1395	58350153831457278	29245	14412	3	0	0
383951	1874	9707000	29246	14413	2	0	3
216895	2133	9157466000	29246	14413	5	0	7270
383956	1874	9717000	29247	14414	1	0	3
216910	2133	9155462000	29251	14415	1	0	7272
383971	1874	9726000	29252	14416	1	0	3
216915	2134	12473179000	29253	14417	1	0	7844
30302	1654	23897744999798	29253	14417	4	0	11
216921	1397	1261502285000	29255	14418	0	0	17732
383980	1678	28800894815000	29255	14418	0	0	1
216922	2134	12472175000	29255	14418	1	0	7845
21594	1564	14766917000000	29255	14418	3	0	10
383988	1678	28800894817000	29258	14420	0	0	1
216931	2134	12471171000	29258	14420	2	0	7846
32415	1673	13895522000000	29260	14421	4	0	18
383997	1678	28800894818000	29261	14422	0	0	1
216940	1397	1261462281000	29261	14422	2	0	17736
54043	1723	16562200085979	29261	14422	4	0	12
384003	1678	28800894822000	29262	14423	2	0	1
216945	1397	1261422277000	29262	14423	3	0	17740
384008	1874	9774000	29262	14423	7	0	3
216951	2133	9145442000	29262	14423	9	0	7282
384038	1874	9782000	29265	14424	1	0	3
216981	2133	9143438000	29265	14424	3	0	7284
7995	1394	1111696703440200	29265	14424	4	0	0
384058	1874	9796000	29269	14425	3	0	3
217001	2133	9142436000	29269	14425	4	0	7285
384063	1678	28800894829000	29270	14426	2	0	1
217007	2133	9140432000	29270	14426	4	0	7287
384065	1874	9802000	29270	14426	4	0	3
384066	1874	9803000	29270	14426	5	0	3
217013	2134	12462135000	29270	14426	10	0	7855
384072	1874	9821000	29270	14426	11	0	3
53144	1717	21421400000055	29270	14426	12	0	8
217050	2132	7088102000	29273	14427	3	0	1900
384110	1874	9830000	29273	14427	5	0	3
24250	1599	23337179097983	29273	14427	6	0	8
217184	1397	1261322267000	29277	14428	0	0	17750
384241	1678	28800894833000	29277	14428	0	0	1
217185	2134	12459123000	29277	14428	1	0	7858
384242	1874	9834000	29277	14428	1	0	3
1320	149	84095523000341	29277	14428	3	0	10
217295	1397	1261312266000	29279	14429	0	0	17751
384352	1678	28800894834000	29279	14429	0	0	1
217296	1397	1261302265000	29279	14429	1	0	17752
384353	1678	28800894835000	29279	14429	1	0	1
217302	1397	1261282263000	29280	14430	1	0	17754
384359	1678	28800894837000	29280	14430	1	0	1
35326	1679	23758594656999	29280	14430	8	0	100
217308	1397	1261272262000	29281	14431	0	0	17755
384365	1678	28800894838000	29281	14431	0	0	1
31209	1668	19953927500000	29281	14431	4	0	9
217325	2134	12455107000	29286	14432	2	0	7862
384382	1874	9866000	29286	14432	2	0	3
217332	1397	1261252260000	29289	14433	0	0	17757
217333	1397	1261242259000	29289	14433	1	0	17758
384394	1874	9877000	29289	14433	5	0	3
217339	1397	1261232258000	29290	14434	0	0	17759
384408	1874	9887000	29294	14435	3	0	3
217356	2132	7084098000	29296	14436	1	0	1904
384416	1678	28800894845000	29297	14437	0	0	1
217361	2134	12450087000	29297	14437	2	0	7867
49086	1700	18234452979053	29297	14437	4	0	10
384437	1874	9906000	29301	14438	3	0	3
217387	1397	1261172252000	29303	14439	0	0	17765
2905	484	77613998000000	29303	14439	5	0	8
384448	1678	28800894849000	29304	14440	0	0	1
217393	2133	9118388000	29304	14440	2	0	7309
384457	1678	28800894851000	29306	14441	0	0	1
217402	2132	7082096000	29306	14441	2	0	1906
9939	1395	58352313892457278	29306	14441	5	0	0
27417	1633	15168844625277	29308	14442	2	0	12
384464	1874	9934000	29309	14443	1	0	3
217412	1397	1261112246000	29311	14444	0	0	17771
384473	1874	9941000	29311	14444	4	0	3
384474	1874	9945000	29311	14444	5	0	3
217418	2134	12443059000	29311	14444	6	0	7874
8002	1394	1114576752440200	29311	14444	8	0	0
217426	2133	9111374000	29316	14446	2	0	7316
384483	1874	9957000	29316	14446	2	0	3
20615	1555	18966335540449	29316	14446	4	0	8
2691	470	81715420000000	29317	14447	4	0	13
217432	2133	9109370000	29318	14448	1	0	7318
384489	1874	9966000	29318	14448	1	0	3
384500	1874	9973000	29322	14450	1	0	3
217444	2133	9107366000	29322	14450	2	0	7320
3057	519	68161928000000	29322	14450	4	0	0
217455	1397	1261022237000	29326	14452	0	0	17780
384512	1678	28800894863000	29326	14452	0	0	1
59616	2086	5040415300069	29326	14452	2	0	3
217465	2133	9103358000	29329	14453	4	0	7324
384522	1874	9995000	29329	14453	4	0	3
217466	2134	12436031000	29329	14453	5	0	7881
42442	1688	54071575113019	29329	14453	8	0	77
384527	2419	0	29330	14454	2	0	0
217472	2134	12435027000	29330	14454	4	0	7882
384655	1678	28800894867000	29332	14455	0	0	1
384656	605	66720000000000	29332	14455	1	0	0
217607	1397	1260972232000	29335	14456	0	0	17785
217608	2132	7077091000	29335	14456	1	0	1911
8008	1394	1118896787440200	29335	14456	5	0	0
384672	1678	28800894869000	29337	14457	0	0	1
217618	2133	9099350000	29337	14457	4	0	7328
60161	2112	30767113101924	29337	14457	7	0	7
384678	1678	28800894871000	29338	14458	0	0	1
217624	2132	7076090000	29338	14458	3	0	1912
384687	1874	10032000	29340	14459	1	0	3
217633	2134	12430007000	29341	14460	1	0	7887
384699	1678	28800894875000	29343	14461	1	0	1
217645	2133	9093338000	29343	14461	4	0	7334
384711	1874	10053000	29345	14462	1	0	3
61147	2329	339847065819988	29345	14462	4	0	0
217657	2134	12426995000	29346	14463	1	0	7890
8014	1394	1123216835440200	29346	14463	4	0	0
384719	1678	28800894878000	29348	14464	0	0	1
217665	1397	1260862221000	29349	14465	0	0	17796
384725	1874	10074000	29349	14465	3	0	3
217683	1397	1260842219000	29352	14466	0	0	17798
384743	1874	10081000	29352	14466	3	0	3
384745	1874	10087000	29352	14466	5	0	3
217689	1397	1260822217000	29353	14467	0	0	17800
384746	1678	28800894883000	29353	14467	0	0	1
217701	2132	7072086000	29356	14468	2	0	1916
384759	1874	10100000	29356	14468	3	0	3
217716	2134	12420971000	29362	14470	2	0	7896
46860	1693	13726007623117	29362	14470	4	0	1383
384774	1678	28800894887000	29363	14471	0	0	1
217722	2133	9080312000	29364	14472	2	0	7347
384779	1874	10117000	29364	14472	2	0	3
217730	2133	9078308000	29367	14474	1	0	7349
384788	1874	10129000	29367	14474	2	0	3
26387	1619	13680341000000	29367	14474	3	0	0
217737	2133	9077306000	29369	14475	2	0	7350
23251	1593	20832892000000	29369	14475	3	0	8
217738	1397	1260732208000	29370	14476	0	0	17809
384797	1874	10138000	29370	14476	2	0	3
9950	1395	58354473940457278	29372	14477	4	0	0
217747	1397	1260712206000	29373	14478	0	0	17811
384805	1874	10148000	29373	14478	1	0	3
217753	2134	12413943000	29374	14479	3	0	7903
384811	1874	10157000	29374	14479	4	0	3
217767	2133	9072296000	29377	14481	3	0	7355
384826	1874	10162000	29377	14481	5	0	3
217782	1397	1260652200000	29379	14482	0	0	17817
384840	1874	10176000	29379	14482	1	0	3
217788	2132	7067081000	29380	14483	3	0	1921
384846	1678	28800894902000	29381	14484	0	0	1
217793	2134	12408923000	29382	14485	2	0	7908
384855	1678	28800894905000	29384	14486	1	0	1
217802	2134	12407919000	29384	14486	5	0	7909
384860	1874	10206000	29384	14486	6	0	3
42498	1688	56231612113019	29384	14486	8	0	77
217808	1397	1260562191000	29386	14488	2	0	17826
384866	1874	10209000	29386	14488	3	0	3
217813	2133	9061274000	29386	14488	7	0	7366
384872	1874	10221000	29386	14488	9	0	3
50454	1705	32961191580140	29386	14488	13	0	25
384895	1678	28800894910000	29389	14489	0	0	1
217839	2132	7064078000	29389	14489	1	0	1924
384896	1874	10230000	29389	14489	1	0	3
217845	2133	9057266000	29390	14490	3	0	7370
384902	1874	10242000	29390	14490	3	0	3
217971	1397	1260532188000	29392	14491	0	0	17829
385028	1678	28800894912000	29392	14491	0	0	1
217972	2133	9056264000	29392	14491	1	0	7371
385029	1874	10244000	29392	14491	1	0	3
217985	1397	1260512186000	29396	14493	0	0	17831
385042	1678	28800894914000	29396	14493	0	0	1
217997	1397	1260492184000	29400	14495	0	0	17833
385054	1678	28800894916000	29400	14495	0	0	1
218002	2132	7062076000	29400	14495	5	0	1926
385059	1874	10272000	29400	14495	5	0	3
218009	2133	9049250000	29403	14497	0	0	7378
218048	1397	1260462181000	29406	14498	0	0	17836
385105	1678	28800894919000	29406	14498	0	0	1
218054	2134	12394867000	29407	14499	1	0	7922
385111	1874	10291000	29407	14499	1	0	3
61155	2329	342007102819988	29407	14499	4	0	0
385120	1874	10299000	29409	14500	3	0	3
218073	1397	1260422177000	29411	14501	0	0	17840
218078	2134	12391855000	29411	14501	6	0	7925
385135	1874	10308000	29411	14501	6	0	3
385159	1684	34563738819412	29415	14502	0	0	136
385160	1678	28800894926000	29415	14502	1	0	1
218104	1397	1260382173000	29415	14502	2	0	17844
385166	1874	10325000	29415	14502	7	0	3
218110	2005	0	29415	14502	8	0	1
58874	1991	20060703355805	29415	14502	12	0	21
218122	2134	12388843000	29419	14504	1	0	7928
385179	1874	10333000	29419	14504	1	0	3
385188	1874	10342000	29421	14505	2	0	3
54399	1724	18412963500000	29421	14505	3	0	15
54403	1724	18412975500000	29421	14505	4	0	15
218140	612	66543000726895	29424	14506	0	0	1
218145	1397	1260322167000	29425	14507	1	0	17850
385202	1678	28800894933000	29425	14507	1	0	1
218146	612	66542960726895	29425	14507	2	0	3
8021	1394	1127536860440200	29425	14507	5	0	0
385208	126	66001000000000	29426	14508	2	0	0
218152	2134	12385831000	29426	14508	3	0	7931
60840	2301	1439029750000	29426	14508	6	0	0
385213	1874	10359000	29427	14509	2	0	3
218168	1397	1260292164000	29431	14510	0	0	17853
51120	1708	19800781181790	29431	14510	3	0	8
385238	1874	10371000	29435	14511	1	0	3
218182	2132	7056070000	29435	14511	2	0	1932
23678	1594	20161990000000	29435	14511	4	0	10
385244	1678	28800894939000	29437	14513	0	0	1
218188	706	10000895062500	29437	14513	1	0	1
385249	1874	10385000	29438	14514	1	0	3
218194	1397	1260242159000	29439	14515	0	0	17858
13325	1445	1724181000000	29439	14515	4	0	8
385269	1678	28800894943000	29441	14516	1	0	1
218213	1397	1260212156000	29441	14516	2	0	17861
385275	2424	100000000	29441	14516	7	0	0
218219	1726	118623112000	29441	14516	8	0	8362
385280	1874	10413000	29441	14516	12	0	3
218241	1397	1260192154000	29444	14517	0	0	17863
385298	1678	28800894946000	29444	14517	0	0	1
385299	1874	10416000	29444	14517	1	0	3
218248	2134	12376795000	29446	14518	3	0	7940
48426	1698	19509312550062	29446	14518	7	0	12
385307	1874	10427000	29447	14519	1	0	3
218254	1397	1260162151000	29448	14520	0	0	17866
385313	1874	10434000	29448	14520	4	0	3
218260	2133	9019190000	29448	14520	6	0	7408
385318	1678	28800894952000	29449	14521	0	0	1
218268	1397	1260122147000	29451	14522	0	0	17870
385327	1874	10455000	29451	14522	4	0	3
218274	2133	9015182000	29451	14522	6	0	7412
385333	1874	10465000	29452	14523	3	0	3
218283	1397	1260092144000	29454	14524	0	0	17873
218284	2133	9013178000	29454	14524	1	0	7414
385342	1874	10470000	29455	14525	2	0	3
218290	2133	9011174000	29456	14526	1	0	7416
385348	1678	28800894960000	29457	14527	1	0	1
218296	2132	7049063000	29457	14527	4	0	1939
385375	1678	28800894961000	29461	14528	0	0	1
218322	2133	9008168000	29461	14528	2	0	7419
385383	1874	10501000	29463	14529	2	0	3
218334	2039	21498862000000	29465	14530	2	0	7
385392	1874	10504000	29465	14530	5	0	3
36148	1680	20172518499559	29465	14530	9	0	13
218348	1397	1260002135000	29467	14531	0	0	17882
385406	1874	10516000	29467	14531	3	0	3
218353	1397	1259992134000	29468	14532	1	0	17883
385411	1874	10520000	29468	14532	4	0	3
218359	2133	9002156000	29468	14532	7	0	7425
385425	1874	10527000	29470	14533	2	0	3
385426	1874	10531000	29470	14533	3	0	3
45372	1692	23501192819983	29470	14533	4	0	6
218373	2134	12360731000	29471	14534	1	0	7956
385435	1874	10543000	29473	14535	2	0	3
218381	2132	7046060000	29473	14535	3	0	1942
385441	1874	10550000	29474	14536	4	0	3
218387	2133	8997146000	29474	14536	5	0	7430
385463	1678	28800894975000	29477	14537	3	0	1
218411	2133	8996144000	29477	14537	4	0	7431
218416	702	44000000000515	29477	14537	9	0	1
385469	2298	1420366374626	29477	14537	9	0	1
218417	2134	12356715000	29477	14537	10	0	7960
4005	606	82607092286229	29477	14537	11	0	18
218479	1397	1259892124000	29485	14538	0	0	17893
385531	1678	28800894978000	29486	14539	1	0	1
218485	2132	7044058000	29486	14539	3	0	1944
385536	1874	10584000	29486	14539	6	0	3
218491	1397	1259852120000	29487	14540	0	0	17897
385542	1874	10592000	29487	14540	3	0	3
218496	2134	12352699000	29487	14540	5	0	7964
47751	1695	19385346999000	29487	14540	6	0	9
385561	1874	10598000	29490	14541	2	0	3
385562	1874	10602000	29490	14541	3	0	3
218516	2134	12350691000	29490	14541	5	0	7966
25800	1611	5752535402899	29490	14541	7	0	18
385568	1678	28800894986000	29491	14542	2	0	1
218522	2132	7041055000	29491	14542	4	0	1947
385574	1874	10623000	29491	14542	8	0	3
218527	2133	8983118000	29491	14542	9	0	7444
385581	1874	10633000	29493	14543	1	0	3
218541	2133	8980112000	29496	14544	1	0	7447
385596	1874	10644000	29498	14545	2	0	3
218550	1397	1259742109000	29499	14546	0	0	17908
218554	1397	1259732108000	29501	14547	0	0	17909
218555	2134	12344667000	29501	14547	1	0	7972
9958	1395	58356633975457278	29501	14547	2	0	0
385604	1678	28800894993000	29502	14548	0	0	1
30565	1656	19435895499990	29502	14548	4	0	8
218561	2133	8976104000	29503	14549	1	0	7451
385609	1874	10661000	29503	14549	1	0	3
218567	2134	12341655000	29505	14551	2	0	7975
385615	1874	10673000	29505	14551	2	0	3
218572	2134	12340651000	29506	14552	4	0	7976
8036	1394	1131856939440200	29506	14552	6	0	0
385621	1678	28800894998000	29507	14553	0	0	1
218581	2133	8971094000	29509	14554	2	0	7456
385629	1874	10688000	29509	14554	3	0	3
218587	2134	12338643000	29510	14555	4	0	7978
385635	1874	10697000	29510	14555	6	0	3
218606	2134	12337639000	29513	14556	2	0	7979
10782	1402	67144200812105	29513	14556	5	0	66
385657	1678	28800895004000	29515	14557	1	0	1
12646	1439	15103942578477	29515	14557	3	0	10
218616	2134	12335631000	29515	14557	5	0	7981
385662	1874	10716000	29515	14557	7	0	3
218636	2132	7035049000	29518	14558	3	0	1953
385682	1874	10721000	29518	14558	5	0	3
218641	613	66000088910000	29518	14558	8	0	2
385688	1874	10735000	29519	14559	0	0	3
385704	1678	28800895008000	29525	14560	0	0	1
218661	1397	1259562091000	29525	14560	1	0	17926
385705	1678	28800895009000	29525	14560	1	0	1
218671	1726	118522112000	29527	14561	1	0	8363
385715	693	66000100000000	29527	14561	1	0	1
218785	1397	1259532088000	29533	14563	0	0	17929
218786	2133	8957066000	29533	14563	1	0	7470
385827	1874	10756000	29533	14563	1	0	3
385837	1678	28800895013000	29537	14564	0	0	1
385838	1874	10763000	29537	14564	1	0	3
61162	2329	344167188819988	29537	14564	4	0	0
218802	1397	1259512086000	29541	14565	0	0	17931
385847	113	66001000000000	29541	14565	5	0	0
218808	2133	8954060000	29541	14565	6	0	7473
218819	2133	8953058000	29543	14566	4	0	7474
385859	1874	10782000	29543	14566	4	0	3
2131	369	84516753290830	29543	14566	7	0	16
218827	1397	1259472082000	29545	14567	0	0	17935
218828	2133	8951054000	29545	14567	1	0	7476
385877	1678	28800895019000	29547	14568	0	0	1
218841	2133	8949050000	29547	14568	4	0	7478
385883	1874	10803000	29547	14568	6	0	3
31550	1670	16561181000000	29547	14568	7	0	11
42542	1688	58391682113019	29550	14569	3	0	77
218861	1397	1259422077000	29551	14570	1	0	17940
385903	1874	10810000	29551	14570	3	0	3
218866	2133	8946044000	29551	14570	6	0	7481
219015	1397	1259412076000	29556	14571	0	0	17941
386052	1678	28800895024000	29556	14571	0	0	1
219016	388	66772975736837	29556	14571	1	0	1
386053	1560	18728880131803	29556	14571	1	0	30
219025	2133	8943038000	29559	14573	1	0	7484
386062	1874	10828000	29559	14573	1	0	3
219137	1397	1259382073000	29561	14574	0	0	17944
386172	1678	28800895027000	29561	14574	0	0	1
219138	2133	8942036000	29561	14574	1	0	7485
386173	1874	10835000	29561	14574	1	0	3
219144	2134	12317559000	29562	14575	5	0	7999
386179	1874	10845000	29562	14575	5	0	3
219152	2133	8938028000	29564	14576	1	0	7489
386187	1874	10856000	29564	14576	1	0	3
22877	1588	18420805000000	29564	14576	3	0	17
219169	1397	1259322067000	29568	14578	0	0	17950
386204	1678	28800895033000	29568	14578	0	0	1
219181	1397	1259302065000	29570	14579	0	0	17952
386216	1678	28800895035000	29570	14579	0	0	1
219193	1397	1259282063000	29573	14580	0	0	17954
386228	1678	28800895037000	29573	14580	0	0	1
46957	1693	17326071623117	29573	14580	3	0	1383
44653	1690	189365884000000	29574	14581	3	0	0
219198	1397	1259262061000	29575	14582	0	0	17956
386233	1678	28800895039000	29575	14582	0	0	1
57440	1764	20243609100000	29575	14582	4	0	12
219204	1397	1259252060000	29576	14583	2	0	17957
386239	1678	28800895040000	29576	14583	2	0	1
386241	1874	10905000	29576	14583	4	0	3
972	58	85427708999641	29576	14583	5	0	12
386244	1678	28800895041000	29578	14584	0	0	1
59938	2106	7920251000000	29578	14584	2	0	2
219212	2132	7024038000	29579	14585	1	0	1964
386253	1678	28800895043000	29581	14586	0	0	1
219220	2133	8926004000	29581	14586	2	0	7501
386259	1678	28800895045000	29582	14587	3	0	1
219226	2134	12306515000	29582	14587	5	0	8010
386264	1874	10932000	29582	14587	8	0	3
219232	1397	1259182053000	29583	14588	0	0	17964
219233	2134	12304507000	29583	14588	1	0	8012
219234	2133	8921996000	29583	14588	2	0	7505
8045	1394	1136176963440200	29583	14588	3	0	0
386287	1678	28800895048000	29588	14589	0	0	1
219257	1726	117421112000	29588	14589	5	0	8364
386293	1874	10948000	29588	14589	6	0	3
386391	1678	28800895050000	29590	14590	0	0	1
386392	1678	28800895051000	29590	14590	1	0	1
219359	2133	8918990000	29590	14590	3	0	7508
19154	1536	23760483000000	29590	14590	6	0	11
386403	1874	10964000	29592	14591	2	0	3
219369	2133	8917988000	29592	14591	3	0	7509
219370	2133	8916986000	29592	14591	4	0	7510
386415	1874	10975000	29594	14592	2	0	3
219394	1397	1259092044000	29596	14593	1	0	17973
386432	1874	10979000	29596	14593	4	0	3
219400	2133	8913980000	29596	14593	7	0	7513
386438	1874	10995000	29596	14593	10	0	3
9976	1395	58358794010457278	29596	14593	12	0	0
219405	1397	1259062041000	29597	14594	0	0	17976
386444	1874	11001000	29597	14594	5	0	3
219411	1397	1259042039000	29598	14595	0	0	17978
40600	1685	199445022571430	29598	14595	2	0	0
386453	1874	11011000	29600	14596	1	0	3
219421	2134	12293463000	29601	14597	1	0	8023
386459	1874	11020000	29601	14597	4	0	3
219426	2133	8905964000	29602	14598	1	0	7521
219550	1397	1259002035000	29604	14599	0	0	17982
386585	1678	28800895065000	29604	14599	0	0	1
219551	2133	8904962000	29604	14599	1	0	7522
386586	1874	11028000	29604	14599	1	0	3
32226	1672	18721665000000	29604	14599	2	0	10
219563	2134	12290451000	29608	14601	1	0	8026
386598	1874	11039000	29608	14601	1	0	3
12368	1436	720000000000	29608	14601	3	0	0
219572	1397	1258952030000	29611	14603	1	0	17987
386607	1678	28800895070000	29611	14603	1	0	1
219577	2132	7016030000	29611	14603	6	0	1972
386612	1874	11052000	29611	14603	6	0	3
219583	2132	7015029000	29611	14603	12	0	1973
386618	1874	11065000	29611	14603	12	0	3
26308	1616	6480158410000	29611	14603	13	0	0
219589	2134	12286435000	29612	14604	5	0	8030
386624	1874	11073000	29612	14604	5	0	3
57809	1768	30707367110000	29612	14604	7	0	10
219604	2132	7014028000	29616	14606	0	0	1974
386639	1874	11084000	29616	14606	0	0	3
386649	1678	28800895076000	29618	14607	0	0	1
386650	1483	11000000	29618	14607	1	0	0
219619	2133	8893940000	29618	14607	5	0	7533
386656	1874	11094000	29618	14607	7	0	3
219634	2133	8890934000	29620	14608	2	0	7536
386671	1874	11103000	29620	14608	4	0	3
40930	1686	21272248700123	29620	14608	7	0	17
219650	1397	1258842019000	29623	14609	0	0	17998
219651	1397	1258832018000	29623	14609	1	0	17999
386688	1874	11109000	29623	14609	3	0	3
29665	1649	18471734249968	29623	14609	7	0	8
219676	1397	1258812016000	29626	14610	1	0	18001
386713	1678	28800895086000	29626	14610	3	0	1
219682	2134	12277399000	29626	14610	7	0	8039
386719	1874	11132000	29626	14610	9	0	3
219687	2132	7011025000	29626	14610	12	0	1977
16227	1474	27890762000043	29626	14610	14	0	30
386729	1874	11141000	29629	14611	1	0	3
219698	1397	1258752010000	29632	14613	2	0	18007
386735	1874	11144000	29632	14613	4	0	3
219704	2133	8881916000	29632	14613	8	0	7545
386741	1874	11158000	29632	14613	10	0	3
219720	2133	8878910000	29634	14614	2	0	7548
386757	1874	11166000	29635	14615	2	0	3
8055	1394	1140496999440200	29635	14615	3	0	0
219731	2133	8876906000	29639	14616	2	0	7550
386766	1678	28800895094000	29640	14617	0	0	1
219740	1397	1258702005000	29642	14618	0	0	18012
386781	1874	11184000	29645	14619	1	0	3
219751	2133	8873900000	29645	14619	3	0	7553
386785	1874	11192000	29646	14620	1	0	3
386786	1874	11193000	29646	14620	2	0	3
219768	1397	1258672002000	29649	14621	0	0	18015
386803	1874	11206000	29649	14621	3	0	3
219774	2134	12266355000	29649	14621	6	0	8050
52704	1716	5040116000000	29649	14621	9	0	9
219777	451	66564522585011	29650	14622	0	0	1
386809	1646	1813000000	29650	14622	0	0	3
219778	1397	1258662001000	29650	14622	1	0	18016
386814	1874	11228000	29650	14622	5	0	3
219784	2134	12262339000	29650	14622	7	0	8054
386820	1874	11248000	29650	14622	11	0	3
219790	2132	7004018000	29650	14622	13	0	1984
386826	1874	11258000	29650	14622	17	0	3
219795	2134	12258323000	29650	14622	18	0	8058
386831	1874	11269000	29651	14623	3	0	3
219801	2134	12255311000	29651	14623	5	0	8061
386851	1678	28800895103000	29654	14624	3	0	1
219821	2133	8860874000	29654	14624	4	0	7566
219826	2133	8855864000	29654	14624	9	0	7571
386857	1874	11291000	29654	14624	9	0	3
386862	1874	11311000	29654	14624	14	0	3
219832	2134	12249287000	29654	14624	15	0	8067
386868	1483	11000000	29655	14625	0	0	0
219838	379	66000000000665	29655	14625	1	0	3
219843	2134	12246275000	29655	14625	6	0	8070
386874	1874	11330000	29655	14625	6	0	3
386879	1874	11338000	29655	14625	11	0	3
219849	2132	6995009000	29655	14625	13	0	1993
386885	1874	11349000	29655	14625	18	0	3
219855	2133	8846846000	29655	14625	19	0	7580
219860	2134	12242259000	29655	14625	24	0	8074
386891	1874	11368000	29655	14625	24	0	3
386896	1874	11388000	29655	14625	29	0	3
219866	2134	12236235000	29655	14625	30	0	8080
22231	1573	11379650000000	29655	14625	32	0	10
386902	1874	11402000	29656	14626	4	0	3
219872	2134	12234227000	29656	14626	5	0	8082
1591	171	78906822696494	29656	14626	9	0	8
386927	1678	28800895107000	29658	14627	0	0	1
219899	1397	1258571992000	29658	14627	1	0	18025
386928	1678	28800895108000	29658	14627	1	0	1
219905	2134	12228203000	29658	14627	7	0	8088
386934	1874	11432000	29658	14627	7	0	3
219911	2133	8840834000	29658	14627	13	0	7586
386940	1874	11444000	29658	14627	13	0	3
219913	1397	1258551990000	29659	14628	1	0	18027
219914	2132	6989003000	29659	14628	2	0	1999
386945	1874	11453000	29659	14628	4	0	3
219920	2134	12221175000	29659	14628	8	0	8095
386951	1874	11472000	29659	14628	10	0	3
219926	2133	8835824000	29659	14628	14	0	7591
386957	1874	11481000	29660	14629	1	0	3
219931	2134	12219167000	29660	14629	4	0	8097
386962	1874	11496000	29660	14629	6	0	3
35403	1679	26638867656999	29660	14629	8	0	100
219952	2134	12216155000	29663	14630	2	0	8100
386983	1874	11511000	29663	14630	4	0	3
219958	2133	8830814000	29663	14630	8	0	7596
386989	1874	11521000	29664	14631	1	0	3
219963	2132	6982997000	29664	14631	4	0	2005
386994	1874	11531000	29664	14631	6	0	3
219969	1397	1258501985000	29665	14632	3	0	18032
387000	1874	11535000	29665	14632	5	0	3
219975	2132	6979994000	29665	14632	9	0	2008
387006	1874	11547000	29665	14632	11	0	3
219980	2133	8825804000	29665	14632	14	0	7601
387011	1874	11557000	29665	14632	16	0	3
219986	2133	8819792000	29665	14632	20	0	7607
387017	1874	11573000	29665	14632	22	0	3
219992	2134	12204107000	29665	14632	26	0	8112
387023	1874	11597000	29665	14632	28	0	3
13263	1444	17467987329999	29667	14633	2	0	13
220015	2132	6977992000	29667	14633	3	0	2010
387046	1874	11602000	29667	14633	5	0	3
220021	2134	12201095000	29667	14633	9	0	8115
387052	1874	11620000	29667	14633	11	0	3
220027	2134	12195071000	29667	14633	15	0	8121
387057	1874	11640000	29667	14633	16	0	3
387058	1874	11641000	29667	14633	17	0	3
220049	1397	1258461981000	29670	14634	0	0	18036
220050	2133	8813780000	29670	14634	1	0	7613
387082	1874	11648000	29670	14634	4	0	3
220056	2134	12192059000	29670	14634	7	0	8124
387106	1678	28800895120000	29672	14635	1	0	1
220080	453	66845780394804	29672	14635	4	0	1
387111	1874	11666000	29672	14635	6	0	3
220085	2133	8808770000	29672	14635	9	0	7618
387117	1874	11679000	29672	14635	12	0	3
220091	2134	12187039000	29672	14635	15	0	8129
12834	1440	8640274045924	29672	14635	18	0	11
387141	1678	28800895122000	29674	14636	0	0	1
220115	2133	8805764000	29674	14636	3	0	7621
387146	1874	11707000	29674	14636	5	0	3
220120	2133	8804762000	29674	14636	8	0	7622
387152	1874	11720000	29674	14636	11	0	3
220126	2134	12180011000	29674	14636	14	0	8136
387158	1874	11735000	29675	14637	3	0	3
220132	2133	8798750000	29675	14637	5	0	7628
387163	1874	11746000	29675	14637	8	0	3
220137	2134	12178003000	29675	14637	10	0	8138
387169	1874	11765000	29675	14637	14	0	3
220143	2134	12172983000	29675	14637	16	0	8143
8061	1394	1144817039440200	29675	14637	18	0	0
387175	1874	11778000	29676	14638	2	0	3
220149	2133	8792738000	29676	14638	4	0	7634
387180	1874	11794000	29676	14638	7	0	3
25698	1610	20160485999950	29676	14638	9	0	11
220166	651	66718925000000	29678	14639	0	0	1
387194	677	66001000000000	29678	14639	0	0	0
387195	1678	28800895126000	29678	14639	1	0	1
220172	2132	6961976000	29678	14639	6	0	2026
387201	1874	11804000	29678	14639	7	0	3
220187	735	3000990000000	29680	14640	0	0	1
220188	1397	1258381973000	29680	14640	1	0	18044
387219	1874	11816000	29680	14640	4	0	3
220194	2134	12163947000	29680	14640	7	0	8152
387224	1874	11833000	29680	14640	9	0	3
53153	1717	22861490000055	29680	14640	13	0	8
220234	1397	1258361971000	29683	14641	1	0	18046
387264	1874	11839000	29683	14641	3	0	3
26520	1622	12564145800048	29683	14641	5	0	10
220239	2134	12161939000	29683	14641	7	0	8154
387270	1874	11856000	29683	14641	10	0	3
220245	2133	8781716000	29683	14641	13	0	7645
387275	1874	11870000	29683	14641	15	0	3
26546	1622	13284145800048	29683	14641	18	0	10
220278	2133	8780714000	29686	14642	1	0	7646
387308	1874	11883000	29686	14642	3	0	3
220283	2134	12154911000	29686	14642	6	0	8161
387314	1874	11902000	29686	14642	9	0	3
220298	2133	8776706000	29688	14643	2	0	7650
387328	1874	11909000	29688	14643	4	0	3
387329	1874	11913000	29688	14643	5	0	3
27144	1623	90723676898598	29688	14643	7	0	1
387330	1678	28800895132000	29689	14644	0	0	1
220304	2133	8774702000	29689	14644	2	0	7652
387336	1874	11927000	29689	14644	6	0	3
220309	2133	8772698000	29689	14644	7	0	7654
387342	1874	11942000	29690	14645	4	0	3
220315	2133	8771696000	29690	14645	5	0	7655
387347	1874	11954000	29691	14646	2	0	3
220321	2133	8769692000	29691	14646	4	0	7657
220322	2132	6950965000	29691	14646	5	0	2037
387353	1874	11964000	29691	14646	8	0	3
220343	2134	12141859000	29697	14647	1	0	8174
387374	1874	11975000	29697	14647	4	0	3
220370	2134	12139851000	29703	14648	1	0	8176
387400	1874	11988000	29703	14648	3	0	3
220375	2133	8764682000	29703	14648	6	0	7662
17892	1509	21263534503835	29703	14648	9	0	9
387421	1678	28800895137000	29706	14649	0	0	1
220396	2133	8760674000	29706	14649	3	0	7666
387427	1874	12014000	29706	14649	6	0	3
220415	1397	1258251960000	29709	14650	2	0	18057
387445	1874	12016000	29709	14650	5	0	3
220420	2132	6941956000	29709	14650	7	0	2046
387451	1874	12030000	29709	14650	11	0	3
220426	2133	8755664000	29709	14650	13	0	7671
387457	1874	12042000	29709	14650	17	0	3
220432	487	66563721585011	29709	14650	19	0	1
387462	1874	12058000	29709	14650	23	0	3
220437	2134	12128807000	29709	14650	24	0	8187
387465	1874	12070000	29709	14650	26	0	3
387466	1874	12074000	29709	14650	27	0	3
220680	1397	1258241959000	29715	14651	0	0	18058
387697	1678	28800895141000	29715	14651	0	0	1
220681	1268	1003913681688	29715	14651	1	0	4
387698	1269	3000000	29715	14651	1	0	0
12651	1439	15823957578477	29715	14651	2	0	10
220687	2133	8750654000	29715	14651	8	0	7676
387704	1874	12092000	29715	14651	8	0	3
220693	1268	1003901681688	29715	14651	14	0	10
387710	1269	9000000	29715	14651	14	0	0
220698	2132	6940955000	29715	14651	19	0	2047
387715	1874	12101000	29715	14651	19	0	3
387737	1269	14000000	29717	14652	1	0	0
387738	1874	12106000	29717	14652	2	0	3
220723	2134	12117763000	29717	14652	4	0	8198
387744	1874	12117000	29717	14652	8	0	3
220729	2133	8745644000	29717	14652	10	0	7681
220730	1268	1003885681688	29717	14652	11	0	18
387750	1269	20000000	29717	14652	14	0	0
8068	1394	1147697148565200	29717	14652	16	0	0
220763	1268	1003877681688	29719	14653	2	0	22
387782	1874	12125000	29719	14653	4	0	3
220769	2134	12116759000	29719	14653	8	0	8199
387788	1874	12139000	29719	14653	10	0	3
220774	1268	1003871681688	29719	14653	13	0	25
387794	1269	27000000	29719	14653	16	0	0
220780	1268	1003859681688	29719	14653	19	0	31
220925	498	67440214000000	29723	14654	0	0	4
387938	724	20002150000000	29723	14654	0	0	5
220926	1397	1258211956000	29723	14654	1	0	18061
387939	1678	28800895144000	29723	14654	1	0	1
220932	2133	8741636000	29723	14654	7	0	7685
387945	1874	12160000	29723	14654	7	0	3
220953	2133	8739632000	29726	14655	4	0	7687
387966	1874	12168000	29726	14655	4	0	3
220958	2132	6933948000	29726	14655	9	0	2054
387971	1874	12180000	29726	14655	9	0	3
220964	2134	12106719000	29726	14655	15	0	8209
387977	1874	12193000	29726	14655	15	0	3
26216	1613	17857532400000	29726	14655	17	0	10
220985	2134	12103707000	29729	14656	4	0	8212
387998	1874	12208000	29729	14656	4	0	3
30312	1654	26057814999798	29729	14656	9	0	11
221004	1397	1258171952000	29732	14657	0	0	18065
388017	1678	28800895148000	29732	14657	0	0	1
221005	2133	8730614000	29732	14657	1	0	7696
388018	1874	12219000	29732	14657	1	0	3
221045	1397	1258161951000	29738	14658	0	0	18066
388058	1678	28800895149000	29738	14658	0	0	1
221051	2133	8727608000	29738	14658	6	0	7699
388064	1874	12248000	29738	14658	6	0	3
56765	1759	14617375139889	29738	14658	8	0	11
221056	2134	12096679000	29739	14659	4	0	8219
388069	1874	12254000	29739	14659	4	0	3
221062	2132	6924939000	29739	14659	11	0	2063
388075	1874	12263000	29739	14659	11	0	3
221068	2133	8722598000	29739	14659	17	0	7704
388081	1874	12266000	29739	14659	17	0	3
221073	2134	12093667000	29739	14659	22	0	8222
388086	1874	12282000	29739	14659	22	0	3
221079	2134	12087643000	29739	14659	28	0	8228
388092	1874	12306000	29739	14659	28	0	3
221085	1268	1003837681688	29739	14659	34	0	42
388098	1269	41000000	29739	14659	34	0	0
221090	2132	6922937000	29740	14660	1	0	2065
388103	1874	12311000	29740	14660	1	0	3
221096	2133	8716586000	29740	14660	7	0	7710
388109	1874	12328000	29740	14660	7	0	3
221111	2134	12083627000	29742	14661	4	0	8232
388124	1874	12338000	29742	14661	4	0	3
221116	2134	12078607000	29742	14661	9	0	8237
388129	1874	12358000	29742	14661	9	0	3
221122	2132	6918933000	29742	14661	15	0	2069
388135	1874	12367000	29742	14661	15	0	3
8076	1394	1152017230565200	29742	14661	16	0	0
221153	1397	1258091944000	29745	14662	0	0	18073
388166	1678	28800895156000	29745	14662	0	0	1
221154	1397	1258081943000	29745	14662	1	0	18074
388167	1678	28800895157000	29745	14662	1	0	1
221160	2133	8706566000	29745	14662	7	0	7720
388173	1874	12380000	29745	14662	7	0	3
221166	2134	12075595000	29745	14662	13	0	8240
388179	1874	12394000	29745	14662	13	0	3
221205	1397	1258071942000	29748	14663	0	0	18075
388218	1678	28800895158000	29748	14663	0	0	1
221211	2133	8703560000	29748	14663	6	0	7723
388224	1874	12415000	29748	14663	6	0	3
221217	2133	8697548000	29748	14663	12	0	7729
388230	1874	12427000	29748	14663	12	0	3
221222	2134	12068567000	29748	14663	17	0	8247
388235	1874	12442000	29748	14663	17	0	3
221228	2134	12062543000	29748	14663	23	0	8253
388241	1874	12466000	29748	14663	23	0	3
60701	2261	15119489000000	29748	14663	25	0	0
221265	2134	12060535000	29752	14664	5	0	8255
388278	1874	12479000	29752	14664	5	0	3
20165	1549	17711492000000	29752	14664	8	0	10
221279	1397	1258031938000	29755	14665	0	0	18079
388292	1678	28800895162000	29755	14665	0	0	1
221280	2132	6909924000	29755	14665	1	0	2078
388293	1874	12486000	29755	14665	1	0	3
49895	1703	8640954000000	29755	14665	5	0	5
221304	1693	17239788899116	29757	14666	2	0	1384
388317	342	66277931638598	29757	14666	2	0	1
221310	1693	16490370904288	29757	14666	9	0	1389
388323	251	66933430434669	29757	14666	9	0	0
221315	2132	6907922000	29757	14666	14	0	2080
388328	1874	12498000	29757	14666	14	0	3
21871	1571	6800869387299	29757	14666	22	1	59
221345	1693	14425726855927	29759	14667	1	0	1394
388358	120	66277730799728	29759	14667	1	0	1
221351	2134	12056519000	29759	14667	7	0	8259
388364	1874	12508000	29759	14667	7	0	3
221356	2134	12052503000	29759	14667	12	0	8263
388369	1874	12525000	29759	14667	12	0	3
221362	2133	8684522000	29759	14667	18	0	7742
388375	1874	12537000	29759	14667	18	0	3
221394	2134	12049491000	29762	14668	1	0	8266
388407	1874	12553000	29762	14668	1	0	3
221399	2133	8680514000	29762	14668	6	0	7746
388412	1874	12563000	29762	14668	6	0	3
388417	421	66930330434669	29762	14668	11	0	1
221405	1693	13488608541325	29762	14668	12	0	1404
388418	266	66320410434669	29762	14668	12	0	2
55480	1740	19891021000000	29762	14668	15	0	14
221418	2134	12047483000	29764	14669	0	0	8268
221419	2134	12046479000	29764	14669	1	0	8269
388435	1874	12580000	29764	14669	4	0	3
221425	1693	13229027175602	29764	14669	7	0	1407
388441	2181	931682240772	29764	14669	10	0	1
39525	1684	36003748819412	29764	14669	11	0	136
221431	1693	12882427016142	29765	14670	2	0	1411
388446	1874	12584000	29765	14670	4	0	3
221436	1693	12536192486161	29765	14670	7	0	1415
388452	1874	12594000	29765	14670	10	0	3
221442	1693	12449542446296	29766	14671	1	0	1416
388458	1874	12605000	29766	14671	4	0	3
221448	2133	8672498000	29766	14671	7	0	7754
388463	361	66283428434669	29766	14671	9	0	2
221453	1693	12100684312237	29766	14671	12	0	1421
388507	1874	12612000	29769	14672	2	0	3
221497	2134	12040455000	29769	14672	5	0	8275
388513	1874	12627000	29769	14672	8	0	3
221503	2134	12037443000	29769	14672	11	0	8278
388518	1874	12644000	29769	14672	13	0	3
221508	2133	8667488000	29769	14672	16	0	7759
388524	1874	12654000	29770	14673	2	0	3
221514	2134	12031419000	29770	14673	5	0	8284
388530	322	66933430434669	29770	14673	9	0	0
221520	2133	8662478000	29770	14673	12	0	7764
388535	1874	12677000	29770	14673	14	0	3
221525	2134	12028407000	29770	14673	17	0	8287
388541	408	66933430434669	29770	14673	20	0	0
221531	1693	11624674763803	29770	14673	23	0	1427
388547	186	66933170434669	29770	14673	26	0	1
3550	576	85517836726897	29770	14673	28	0	9
58003	1807	200000055	29770	14673	29	1	0
221551	1397	1257921927000	29772	14674	0	0	18090
388564	1678	28800895173000	29772	14674	0	0	1
221552	1397	1257911926000	29772	14674	1	0	18091
388565	1678	28800895174000	29772	14674	1	0	1
221558	2134	12025395000	29772	14674	7	0	8290
388571	1874	12706000	29772	14674	7	0	3
221564	2134	12020375000	29772	14674	13	0	8295
388577	1874	12728000	29772	14674	13	0	3
221569	1693	10845560631636	29772	14674	18	0	1436
388582	399	66933430434669	29772	14674	18	0	0
221575	1693	10670002577307	29772	14674	24	0	1439
388588	206	66933430434669	29772	14674	24	0	0
221581	1693	8185152207440	29772	14674	30	0	1443
388594	205	66933430434669	29772	14674	30	0	0
221648	2132	6886901000	29775	14675	4	0	2101
388661	1874	12741000	29775	14675	4	0	3
221654	2134	12014351000	29775	14675	10	0	8301
388667	1874	12765000	29775	14675	10	0	3
221660	2133	8651456000	29775	14675	16	0	7775
388673	1874	12777000	29775	14675	16	0	3
221665	1693	7753372699114	29775	14675	21	0	1448
388678	138	66933430434669	29775	14675	21	0	0
221671	1693	7233472459924	29775	14675	27	0	1454
388684	560	66933420434669	29775	14675	27	0	1
18815	1532	2880170538460	29775	14675	29	0	0
221716	1397	1257881923000	29779	14676	0	0	18094
388729	1678	28800895177000	29779	14676	0	0	1
221717	2133	8649452000	29779	14676	1	0	7777
388730	1874	12781000	29779	14676	1	0	3
221723	2134	12009331000	29779	14676	7	0	8306
388736	1874	12799000	29779	14676	7	0	3
221744	1397	1257871922000	29781	14677	0	0	18095
388757	1678	28800895178000	29781	14677	0	0	1
221749	1693	6685174656010	29781	14677	5	0	1462
388762	603	67000861192295	29781	14677	5	0	1
221755	2134	12007323000	29781	14677	11	0	8308
388768	1874	12814000	29781	14677	11	0	3
221761	2133	8644442000	29781	14677	17	0	7782
388774	1874	12828000	29781	14677	17	0	3
11523	1419	31243377559748	29782	14678	2	0	12
221766	1693	6512243200731	29782	14678	3	0	1464
388779	530	66855485387862	29782	14678	3	0	1
221772	2133	8640434000	29782	14678	9	0	7786
388785	1874	12837000	29782	14678	9	0	3
61211	2332	100000300	29782	14678	18	0	0
221919	1397	1257841919000	29787	14679	0	0	18098
388932	1678	28800895181000	29787	14679	0	0	1
221920	1397	1257831918000	29787	14679	1	0	18099
388933	1678	28800895182000	29787	14679	1	0	1
221926	2133	8635424000	29787	14679	7	0	7791
388939	1874	12860000	29787	14679	7	0	3
221932	1693	5416593682654	29787	14679	13	0	1473
388945	165	66276917402319	29787	14679	13	0	1
221937	2132	6877892000	29787	14679	18	0	2110
388950	1874	12864000	29787	14679	18	0	3
221943	2134	12000295000	29787	14679	24	0	8315
388956	1874	12872000	29787	14679	24	0	3
221998	1397	1257821917000	29792	14680	0	0	18100
389011	1678	28800895183000	29792	14680	0	0	1
221999	2133	8633420000	29792	14680	1	0	7793
389012	1874	12890000	29792	14680	1	0	3
222005	1693	4461561838062	29792	14680	7	0	1485
389018	92	66933430434669	29792	14680	7	0	0
24265	1599	24777281097983	29792	14680	14	0	8
222035	1397	1257811916000	29795	14681	0	0	18101
389048	1678	28800895184000	29795	14681	0	0	1
222040	2134	11992263000	29795	14681	5	0	8323
389053	1874	12915000	29795	14681	5	0	3
222046	1693	4108408994576	29795	14681	11	0	1491
389059	745	2028285770627	29795	14681	11	0	0
52295	1714	20445862171760	29795	14681	13	0	11
222061	1693	4021758954711	29797	14682	5	0	1492
389074	89	66933430434669	29797	14682	5	0	0
222066	2134	11989251000	29797	14682	10	0	8326
389079	1874	12928000	29797	14682	10	0	3
222072	2132	6869884000	29797	14682	16	0	2118
389085	1874	12940000	29797	14682	16	0	3
222078	2134	11982223000	29797	14682	22	0	8333
389091	1874	12961000	29797	14682	22	0	3
222083	2134	11977203000	29797	14682	27	0	8338
389096	1874	12981000	29797	14682	27	0	3
389097	1874	12985000	29797	14682	28	0	3
389098	1150	616502994805690	29797	14682	29	0	0
222089	1693	2703795252596	29797	14682	33	0	1499
222090	1693	2617513848942	29797	14682	34	0	1500
389104	653	66933430434669	29797	14682	35	0	0
222096	1693	2099086927074	29797	14682	40	0	1506
389110	1961	932342609896	29797	14682	41	0	1
222102	1693	1579190648931	29797	14682	46	0	1512
389115	78	66933430434669	29797	14682	46	0	0
222107	2133	8627408000	29797	14682	52	0	7799
389121	1874	12993000	29797	14682	53	0	3
222113	2133	8621396000	29797	14682	58	0	7805
389127	1874	13005000	29797	14682	59	0	3
59132	2004	200008463	29797	14682	65	1	0
222128	2134	11975195000	29799	14683	3	0	8340
389141	1874	13014000	29799	14683	3	0	3
57884	1796	200000016	29799	14683	9	0	0
60187	2126	250550006	29799	14683	11	0	0
222246	1397	1257751910000	29802	14684	0	0	18107
389259	1678	28800895190000	29802	14684	0	0	1
222247	2133	8616386000	29802	14684	1	0	7810
389260	1874	13030000	29802	14684	1	0	3
222253	2134	11970175000	29802	14684	7	0	8345
389266	1874	13044000	29802	14684	7	0	3
10809	1402	69304254812105	29802	14684	11	0	66
222259	2132	6864879000	29803	14685	2	0	2123
389272	1874	13057000	29803	14685	2	0	3
222264	2134	11964151000	29803	14685	7	0	8351
389277	1874	13071000	29803	14685	7	0	3
222270	2133	8610374000	29803	14685	13	0	7816
389283	1874	13087000	29803	14685	13	0	3
222282	1397	1257721907000	29805	14686	0	0	18110
389295	1678	28800895193000	29805	14686	0	0	1
222287	2134	11954111000	29805	14686	5	0	8361
389300	1874	13122000	29805	14686	5	0	3
222293	2133	8605364000	29806	14687	2	0	7821
389306	1874	13134000	29806	14687	2	0	3
222300	2133	8602358000	29808	14688	2	0	7824
389313	1874	13142000	29808	14688	2	0	3
222441	1397	1257691904000	29814	14689	0	0	18113
389454	1678	28800895196000	29814	14689	0	0	1
222442	1397	1257681903000	29814	14689	1	0	18114
389455	1678	28800895197000	29814	14689	1	0	1
222448	2133	8596346000	29814	14689	7	0	7830
389461	1874	13156000	29814	14689	7	0	3
222454	2132	6854869000	29815	14690	2	0	2133
389467	1874	13165000	29815	14690	2	0	3
222459	2134	11949091000	29815	14690	7	0	8366
389472	1874	13180000	29815	14690	7	0	3
222465	2134	11943067000	29815	14690	13	0	8372
389478	1874	13204000	29815	14690	13	0	3
58373	1850	20136560949999	29815	14690	18	0	9
222499	1397	1257661901000	29817	14691	0	0	18116
389512	1678	28800895199000	29817	14691	0	0	1
222500	2132	6852867000	29817	14691	1	0	2135
389513	1874	13217000	29817	14691	1	0	3
9987	1395	58360234103457278	29817	14691	4	0	0
222506	2134	11940055000	29818	14692	3	0	8375
389519	1874	13228000	29818	14692	3	0	3
222512	2134	11936039000	29818	14692	9	0	8379
389525	1874	13248000	29818	14692	9	0	3
58562	1964	200000028	29818	14692	15	0	0
21884	1571	6800869387675	29818	14692	16	1	59
222536	2134	11935035000	29820	14693	4	0	8380
389549	1874	13255000	29820	14693	4	0	3
222542	2134	11929011000	29820	14693	10	0	8386
389555	1874	13279000	29820	14693	10	0	3
222548	2133	8583320000	29820	14693	16	0	7843
389561	1874	13295000	29820	14693	16	0	3
222553	2134	11924995000	29821	14694	2	0	8390
389566	1874	13307000	29821	14694	2	0	3
222559	2132	6846861000	29821	14694	8	0	2141
389572	1874	13323000	29821	14694	8	0	3
49379	1701	20878611500094	29821	14694	10	0	14
222574	2132	6845860000	29823	14695	4	0	2142
389587	1874	13332000	29823	14695	4	0	3
222579	238	66000973695901	29824	14696	0	0	8
389592	2314	86859000000	29824	14696	0	0	5
222585	2134	11913951000	29824	14696	6	0	8401
389598	1874	13365000	29824	14696	6	0	3
222608	2133	8573300000	29827	14697	1	0	7853
389621	1874	13376000	29827	14697	1	0	3
222613	2134	11910939000	29827	14697	6	0	8404
389626	1874	13389000	29827	14697	6	0	3
222635	1397	1257591894000	29832	14699	0	0	18123
389648	1678	28800895206000	29832	14699	0	0	1
222636	1397	1257581893000	29832	14699	1	0	18124
389649	1678	28800895207000	29832	14699	1	0	1
222642	2134	11906923000	29832	14699	7	0	8408
389655	1874	13410000	29832	14699	7	0	3
222648	2133	8569292000	29832	14699	13	0	7857
389661	1874	13432000	29832	14699	13	0	3
50827	1706	24762456450256	29832	14699	18	0	27
222653	2132	6838853000	29833	14700	1	0	2149
389666	1874	13439000	29833	14700	1	0	3
222664	2133	8562278000	29835	14701	1	0	7864
389677	1874	13448000	29835	14701	1	0	3
222670	2132	6834849000	29836	14702	2	0	2153
389683	1874	13455000	29836	14702	2	0	3
222675	2134	11900899000	29837	14703	2	0	8414
389688	1874	13465000	29837	14703	2	0	3
61316	2367	100002101	29837	14703	10	0	0
58012	1807	200000106	29837	14703	12	1	0
222681	1397	1257531888000	29838	14704	0	0	18129
389694	1678	28800895212000	29838	14704	0	0	1
222687	2134	11896883000	29838	14704	6	0	8418
389700	1874	13489000	29838	14704	6	0	3
222692	2133	8552258000	29838	14704	11	0	7874
389705	1874	13503000	29838	14704	11	0	3
222698	2133	8550254000	29838	14704	17	0	7876
389711	1874	13523000	29838	14704	17	0	3
222727	1397	1257511886000	29840	14705	0	0	18131
389740	1678	28800895214000	29840	14705	0	0	1
222732	2132	6826841000	29840	14705	5	0	2161
389745	1874	13549000	29840	14705	5	0	3
222738	2134	11880819000	29840	14705	11	0	8434
389751	1874	13570000	29840	14705	11	0	3
222744	2134	11874795000	29840	14705	17	0	8440
389757	1874	13594000	29840	14705	17	0	3
222749	2133	8545244000	29840	14705	22	0	7881
389762	1874	13606000	29840	14705	22	0	3
8085	1394	1156337300565200	29840	14705	27	0	0
222755	2134	11871783000	29841	14706	1	0	8443
389768	1874	13622000	29841	14706	1	0	3
222761	2134	11869775000	29841	14706	7	0	8445
389774	1874	13637000	29841	14706	7	0	3
389777	1874	13646000	29842	14707	1	0	3
389778	1874	13650000	29842	14707	2	0	3
222766	2134	11865759000	29842	14707	3	0	8449
222769	2133	8537228000	29842	14707	6	0	7889
222770	2133	8536226000	29842	14707	7	0	7890
389784	1874	13665000	29842	14707	8	0	3
222776	2133	8534222000	29842	14707	13	0	7892
389790	1874	13673000	29842	14707	14	0	3
222782	2133	8528210000	29842	14707	19	0	7898
389795	1874	13683000	29842	14707	19	0	3
222787	2132	6816831000	29843	14708	3	0	2171
389801	1874	13691000	29843	14708	4	0	3
44671	1690	191525944000000	29843	14708	6	0	0
222793	2133	8522198000	29844	14709	3	0	7904
389807	1874	13700000	29844	14709	4	0	3
222804	2132	6812827000	29847	14710	4	0	2175
389817	1874	13703000	29847	14710	4	0	3
42583	1688	59831979702819	29847	14710	9	0	77
222809	2134	11863751000	29847	14710	10	0	8451
389823	1874	13719000	29847	14710	11	0	3
222815	2134	11857727000	29847	14710	16	0	8457
389829	1874	13743000	29847	14710	17	0	3
222821	2134	11851703000	29847	14710	22	0	8463
389834	1874	13763000	29847	14710	22	0	3
222826	2134	11846683000	29847	14710	27	0	8468
389840	1874	13787000	29847	14710	28	0	3
222832	2134	11841663000	29847	14710	33	0	8473
389846	1874	13809000	29847	14710	34	0	3
222838	2134	11835639000	29847	14710	39	0	8479
389851	1874	13829000	29847	14710	39	0	3
21651	1568	650000	29847	14710	44	1	0
222880	2134	11831623000	29849	14711	1	0	8483
389894	1874	13849000	29849	14711	2	0	3
222886	2133	8514182000	29849	14711	7	0	7912
389900	1874	13864000	29849	14711	8	0	3
57890	1796	200000022	29849	14711	10	0	0
10001	1395	58362394142457072	29849	14711	10	1	0
389913	1678	28800895220000	29851	14712	3	0	1
222901	114	66001611517324	29851	14712	4	0	14
389914	2314	387859000000	29851	14712	4	0	5
222905	2133	8511176000	29851	14712	8	0	7915
222906	2133	8510174000	29851	14712	9	0	7916
389920	1874	13879000	29851	14712	10	0	3
222927	1397	1257431878000	29853	14713	1	0	18139
389941	1874	13889000	29853	14713	2	0	3
222933	2134	11821583000	29853	14713	7	0	8493
389946	1874	13903000	29853	14713	7	0	3
222938	2134	11818571000	29853	14713	12	0	8496
389952	1874	13923000	29853	14713	13	0	3
222944	2133	8505164000	29853	14713	18	0	7921
389958	1678	28800895223000	29854	14714	0	0	1
222950	2134	11810539000	29854	14714	5	0	8504
389963	1874	13957000	29854	14714	5	0	3
15877	1471	22265555900000	29854	14714	9	0	8
222965	2133	8502158000	29856	14715	1	0	7924
389979	1874	13966000	29856	14715	2	0	3
222971	2134	11808531000	29856	14715	7	0	8506
389985	1874	13982000	29856	14715	8	0	3
58909	1992	1441109990000	29856	14715	10	0	6
222984	2133	8498150000	29858	14716	3	0	7928
389997	1874	13994000	29858	14716	3	0	3
222989	2134	11801503000	29858	14716	8	0	8513
26573	1622	15444184800048	29858	14716	9	0	10
390003	1678	28800895226000	29859	14717	0	0	1
222995	2133	8495144000	29859	14717	6	0	7931
390009	1874	14023000	29859	14717	7	0	3
12276	1426	20490564704350	29859	14717	12	0	8
61319	2367	100002501	29859	14717	13	1	0
60422	2221	200170000	29859	14717	14	0	0
223001	2133	8494142000	29860	14718	1	0	7932
390014	1874	14037000	29860	14718	1	0	3
223006	2134	11794475000	29860	14718	6	0	8520
390020	1874	14057000	29860	14718	7	0	3
59141	2004	200025963	29860	14718	13	0	0
223022	2133	8491136000	29862	14719	2	0	7935
390036	1874	14068000	29862	14719	3	0	3
223028	2134	11789455000	29862	14719	8	0	8525
390041	1874	14079000	29862	14719	8	0	3
223033	2134	11784435000	29862	14719	13	0	8530
390047	1874	14103000	29862	14719	14	0	3
390049	1874	14107000	29862	14719	16	0	3
390050	1874	14109000	29862	14719	17	0	3
223039	1397	1257351870000	29863	14720	0	0	18147
223041	2134	11781423000	29863	14720	2	0	8533
223042	2132	6795810000	29863	14720	3	0	2192
390056	1874	14121000	29863	14720	4	0	3
223086	2314	849000000	29868	14721	0	0	6
390100	1678	28800895231000	29868	14721	1	0	1
223092	2134	11777407000	29868	14721	6	0	8537
390105	1874	14146000	29868	14721	6	0	3
223107	1397	1257321867000	29870	14722	1	0	18150
390121	1874	14159000	29870	14722	2	0	3
223113	2134	11772387000	29870	14722	7	0	8542
390127	1874	14173000	29870	14722	8	0	3
223119	2133	8480114000	29870	14722	13	0	7946
390132	1874	14191000	29870	14722	13	0	3
223124	2134	11766363000	29870	14722	18	0	8548
390138	1874	14209000	29870	14722	19	0	3
8093	1394	1159217402565200	29870	14722	21	0	0
223171	2132	6788803000	29874	14723	4	0	2199
390185	1874	14219000	29874	14723	5	0	3
390186	1874	14223000	29874	14723	6	0	3
135	42	80780851500000	29874	14723	10	0	12
223303	689	67438422000000	29877	14724	0	0	1
223304	1397	1257301865000	29877	14724	1	0	18152
390318	1678	28800895236000	29877	14724	2	0	1
390321	1874	14242000	29877	14724	5	0	3
390322	1874	14246000	29877	14724	6	0	3
223310	2134	11757327000	29877	14724	7	0	8557
223313	2134	11755319000	29877	14724	10	0	8559
223314	2134	11754315000	29877	14724	11	0	8560
390328	1874	14267000	29877	14724	12	0	3
223320	2133	8470094000	29877	14724	17	0	7956
390334	1874	14281000	29877	14724	18	0	3
22922	1588	20581063000000	29877	14724	20	0	17
223356	2134	11751303000	29880	14725	5	0	8563
390367	1874	14289000	29880	14725	5	0	3
223361	2133	8466086000	29880	14725	10	0	7960
20859	1559	17586320499999	29880	14725	11	0	8
60195	2126	251550006	29880	14725	14	1	0
61225	2332	100003100	29880	14725	15	1	0
390373	1678	28800895238000	29881	14726	0	0	1
223367	2134	11745279000	29881	14726	5	0	8569
390379	1874	14322000	29881	14726	6	0	3
223373	2133	8462078000	29881	14726	11	0	7964
390384	1874	14334000	29881	14726	11	0	3
223378	2134	11742267000	29881	14726	16	0	8572
390390	1874	14348000	29881	14726	17	0	3
2171	369	86676807290830	29881	14726	20	0	16
223384	2133	8459072000	29882	14727	2	0	7967
390396	1874	14360000	29882	14727	3	0	3
223390	2132	6778793000	29882	14727	8	0	2209
390401	1874	14367000	29882	14727	8	0	3
223395	2134	11736243000	29882	14727	13	0	8578
390407	1874	14387000	29882	14727	14	0	3
223401	2134	11730219000	29882	14727	19	0	8584
223460	1397	1257231858000	29887	14728	0	0	18159
390471	1678	28800895242000	29887	14728	0	0	1
223461	2132	6777792000	29887	14728	1	0	2210
390472	1874	14408000	29887	14728	1	0	3
223467	2134	11725199000	29887	14728	7	0	8589
390478	1874	14430000	29887	14728	7	0	3
223483	2134	11723191000	29889	14729	4	0	8591
390494	1874	14443000	29889	14729	4	0	3
223488	2134	11721183000	29889	14729	9	0	8593
390499	1874	14456000	29889	14729	9	0	3
41300	1687	13809120648287	29889	14729	11	0	7
223500	2134	11718171000	29891	14730	5	0	8596
390511	1874	14472000	29891	14730	5	0	3
223534	2134	11716163000	29895	14731	2	0	8598
390545	1874	14485000	29895	14731	2	0	3
223539	2132	6772787000	29895	14731	7	0	2215
390550	1874	14497000	29895	14731	7	0	3
390593	1874	14509000	29900	14732	2	0	3
223585	2133	8443040000	29900	14732	3	0	7983
390594	1874	14511000	29900	14732	3	0	3
223586	2132	6771786000	29900	14732	4	0	2216
223610	1397	1257181853000	29903	14733	0	0	18164
390616	1678	28800895247000	29903	14733	0	0	1
223616	2134	11704115000	29903	14733	6	0	8610
390622	1874	14547000	29903	14733	7	0	3
13690	1447	23321987683000	29903	14733	11	0	10
223621	1397	1257171852000	29904	14734	0	0	18165
390627	1874	14556000	29904	14734	1	0	3
223627	2132	6768783000	29904	14734	6	0	2219
390633	1874	14573000	29904	14734	7	0	3
58025	1807	200000177	29904	14734	12	1	0
21894	1571	6800869388131	29904	14734	14	1	59
223653	2133	8435024000	29907	14735	3	0	7991
390658	1874	14581000	29907	14735	5	0	3
223658	2134	11696083000	29907	14735	8	0	8618
390663	1874	14601000	29907	14735	10	0	3
55145	1739	33839916000000	29907	14735	12	0	0
223669	2134	11692067000	29910	14736	3	0	8622
390674	1874	14616000	29910	14736	5	0	3
223685	1397	1257141849000	29912	14737	0	0	18168
390690	1874	14630000	29912	14737	2	0	3
223690	2134	11688051000	29912	14737	5	0	8626
390695	1874	14645000	29912	14737	7	0	3
11549	1419	33403434424689	29912	14737	8	0	12
223721	2133	8428010000	29916	14738	3	0	7998
223722	2132	6762777000	29916	14738	4	0	2225
390723	1874	14655000	29916	14738	5	0	3
223728	1397	1257121847000	29917	14739	0	0	18170
390729	1874	14675000	29917	14739	1	0	3
390730	1874	14679000	29917	14739	2	0	3
223734	2133	8426006000	29917	14739	6	0	8000
390736	1874	14691000	29917	14739	8	0	3
223829	2133	8424002000	29921	14740	1	0	8002
390830	1874	14706000	29921	14740	4	0	3
223835	2134	11672991000	29921	14740	7	0	8641
40609	1685	200885063571430	29921	14740	10	0	0
390851	1678	28800895255000	29924	14741	0	0	1
223857	2134	11670983000	29924	14741	4	0	8643
223858	2134	11669979000	29924	14741	5	0	8644
390857	1874	14737000	29924	14741	6	0	3
223864	2132	6756771000	29925	14742	3	0	2231
390863	1874	14744000	29925	14742	4	0	3
39538	1684	37443800819412	29925	14742	6	0	136
390921	1678	28800895258000	29929	14743	0	0	1
390922	1874	14745000	29929	14743	1	0	3
223927	2133	8418992000	29929	14743	4	0	8007
390928	1874	14759000	29929	14743	7	0	3
223932	2133	8413982000	29929	14743	9	0	8012
390934	1874	14779000	29929	14743	13	0	3
223938	2134	11660943000	29929	14743	15	0	8653
390939	1874	14799000	29929	14743	18	0	3
223944	2134	11654919000	29929	14743	21	0	8659
224042	1397	1257061841000	29932	14744	0	0	18176
391037	1678	28800895259000	29932	14744	0	0	1
224043	1397	1257051840000	29932	14744	1	0	18177
391038	1678	28800895260000	29932	14744	1	0	1
224049	1726	114118112000	29932	14744	7	0	8367
391044	2433	100000000	29932	14744	7	0	0
224055	2133	8408972000	29932	14744	13	0	8017
391050	1874	14837000	29932	14744	13	0	3
21897	1571	6800869388195	29932	14744	20	1	59
224085	2132	6748763000	29935	14745	3	0	2239
391080	1874	14841000	29935	14745	3	0	3
224091	2133	8402960000	29935	14745	9	0	8023
391086	1874	14852000	29935	14745	9	0	3
224166	1397	1257021837000	29939	14746	0	0	18180
391161	1678	28800895263000	29939	14746	0	0	1
224167	2133	8401958000	29939	14746	1	0	8024
391162	1874	14854000	29939	14746	1	0	3
19935	1547	17275053000000	29939	14746	5	0	12
224173	2132	6745760000	29940	14747	2	0	2242
391168	1874	14862000	29940	14747	2	0	3
224179	2134	11649899000	29944	14748	2	0	8664
391174	1874	14876000	29944	14748	2	0	3
51669	1710	18234139414140	29944	14748	7	0	10
224213	1397	1257001835000	29948	14749	0	0	18182
391208	1678	28800895265000	29948	14749	0	0	1
224219	2133	8392940000	29948	14749	6	0	8033
391214	1874	14898000	29948	14749	6	0	3
224225	2133	8390936000	29949	14750	1	0	8035
391220	1874	14914000	29949	14750	1	0	3
224230	2134	11640863000	29949	14750	6	0	8673
391225	1874	14929000	29949	14750	6	0	3
224236	2132	6739754000	29950	14751	3	0	2248
391231	1874	14940000	29950	14751	3	0	3
224242	2134	11635843000	29950	14751	9	0	8678
391237	1874	14956000	29950	14751	9	0	3
224247	2134	11633835000	29950	14751	14	0	8680
391242	1874	14970000	29950	14751	14	0	3
224253	2134	11628815000	29951	14752	1	0	8685
391248	1874	14990000	29951	14752	1	0	3
224259	2134	11625803000	29951	14752	7	0	8688
391254	1874	15007000	29951	14752	7	0	3
224264	2134	11623795000	29954	14753	3	0	8690
391259	1874	15018000	29954	14753	3	0	3
224265	2134	11622791000	29954	14753	4	0	8691
224266	2133	8380916000	29954	14753	5	0	8045
391265	1874	15035000	29954	14753	9	0	3
32252	1672	20161691000000	29954	14753	10	0	10
391276	1678	28800895272000	29956	14754	0	0	1
224282	2133	8378912000	29956	14754	1	0	8047
391277	1874	15037000	29956	14754	1	0	3
224288	2134	11618775000	29956	14754	8	0	8695
391283	1874	15051000	29956	14754	8	0	3
61236	2332	100004400	29956	14754	15	0	0
224309	2134	11614759000	29959	14755	2	0	8699
391305	1874	15069000	29959	14755	3	0	3
224315	2133	8372900000	29960	14756	1	0	8053
391310	1874	15076000	29960	14756	1	0	3
46131	1693	1629655825590	29960	14756	5	0	1514
224326	2133	8370896000	29962	14757	3	0	8055
391321	1874	15083000	29962	14757	3	0	3
42630	1688	61992049650513	29962	14757	5	0	77
224341	2133	8368892000	29965	14758	3	0	8057
391337	1874	15094000	29965	14758	4	0	3
224347	2134	11608735000	29965	14758	9	0	8705
391342	1874	15114000	29965	14758	9	0	3
224353	2134	11602711000	29965	14758	15	0	8711
391348	1874	15138000	29965	14758	15	0	3
224377	2134	11598695000	29967	14759	3	0	8715
391373	1874	15156000	29967	14759	4	0	3
224383	2134	11597691000	29967	14759	9	0	8716
391378	1874	15166000	29967	14759	9	0	3
224418	1397	1256871822000	29971	14760	0	0	18195
391413	1678	28800895278000	29971	14760	0	0	1
224419	2133	8363882000	29971	14760	1	0	8062
391414	1874	15180000	29971	14760	1	0	3
224425	2133	8362880000	29971	14760	7	0	8063
391420	1874	15199000	29971	14760	7	0	3
224463	2133	8358872000	29975	14761	4	0	8067
391458	1874	15207000	29975	14761	4	0	3
224468	2132	6723738000	29975	14761	9	0	2264
391463	1874	15224000	29975	14761	9	0	3
224474	2134	11582631000	29975	14761	15	0	8731
391469	1874	15242000	29975	14761	15	0	3
224509	2133	8356868000	29978	14762	3	0	8069
391504	1874	15254000	29978	14762	3	0	3
224514	2133	8352860000	29978	14762	8	0	8073
391509	1874	15263000	29978	14762	8	0	3
224520	2134	11577611000	29978	14762	14	0	8736
391515	1874	15279000	29978	14762	14	0	3
224526	1397	1256821817000	29979	14763	0	0	18200
391521	1678	28800895283000	29979	14763	0	0	1
224531	2133	8349854000	29979	14763	6	0	8076
391526	1874	15305000	29979	14763	6	0	3
224537	2134	11566567000	29979	14763	12	0	8747
391532	1874	15329000	29979	14763	12	0	3
224538	2134	11565563000	29979	14763	13	0	8748
391538	1874	15346000	29979	14763	18	0	3
224544	2133	8346848000	29979	14763	19	0	8079
58662	1980	26639673000000	29979	14763	20	0	1
57908	1796	200000037	29979	14763	21	0	0
21668	1568	1400000	29979	14763	21	1	0
60437	2221	200300000	29979	14763	23	0	0
391559	1678	28800895285000	29982	14764	0	0	1
391560	1874	15352000	29982	14764	1	0	3
224569	2132	6714729000	29982	14764	5	0	2273
391566	1874	15367000	29982	14764	7	0	3
59157	2004	200039335	29982	14764	11	1	0
224593	1397	1256791814000	29984	14765	0	0	18203
391591	1874	15378000	29984	14765	3	0	3
224599	2132	6712727000	29984	14765	6	0	2275
391596	1874	15385000	29984	14765	8	0	3
224605	2134	11556527000	29984	14765	12	0	8757
391602	1874	15405000	29984	14765	14	0	3
224610	2134	11551507000	29984	14765	17	0	8762
224771	1397	1256771812000	29988	14766	0	0	18205
391766	1678	28800895288000	29988	14766	0	0	1
224772	1397	1256761811000	29988	14766	1	0	18206
391767	1678	28800895289000	29988	14766	1	0	1
224778	2134	11546487000	29988	14766	7	0	8767
391773	1874	15439000	29988	14766	7	0	3
224784	2134	11541467000	29988	14766	13	0	8772
391779	1874	15460000	29988	14766	13	0	3
224808	2133	8337830000	29990	14767	4	0	8088
391803	1874	15471000	29990	14767	4	0	3
224809	2133	8336828000	29990	14767	5	0	8089
224810	2133	8335826000	29990	14767	6	0	8090
391809	1874	15483000	29990	14767	10	0	3
224816	2134	11537451000	29990	14767	12	0	8776
391827	1678	28800895291000	29992	14768	0	0	1
391828	1874	15499000	29992	14768	1	0	3
224836	2133	8330816000	29992	14768	4	0	8095
391834	1874	15514000	29992	14768	7	0	3
224841	2132	6704719000	29992	14768	9	0	2283
50458	1705	33681191580140	29992	14768	10	0	25
391847	1874	15526000	29994	14769	3	0	3
224854	2134	11530423000	29994	14769	5	0	8783
391852	1874	15544000	29994	14769	8	0	3
224860	2134	11525403000	29995	14770	2	0	8788
391858	1874	15557000	29995	14770	5	0	3
224865	2134	11523395000	29995	14770	7	0	8790
34876	1678	29520895293000	29995	14770	8	0	1
391878	1874	15573000	29998	14771	3	0	3
224885	2132	6701716000	29998	14771	5	0	2286
391883	1874	15587000	29998	14771	9	0	3
224891	2134	11516367000	29998	14771	12	0	8797
391889	1874	15604000	29998	14771	15	0	3
224896	2133	8320796000	29998	14771	17	0	8105
60210	2126	252450006	29998	14771	23	0	0
60710	2261	16559542381228	29998	14771	25	0	0
391914	1874	15616000	30000	14772	1	0	3
224921	2134	11513355000	30000	14772	3	0	8800
391919	1874	15631000	30000	14772	6	0	3
224927	2133	8316788000	30000	14772	9	0	8109
225047	1397	1256681803000	30002	14773	0	0	18214
392042	1678	29520912297000	30002	14773	0	0	1
225048	2134	11509339000	30002	14773	1	0	8804
392043	1874	15642000	30002	14773	1	0	3
225054	2134	11506327000	30002	14773	7	0	8807
392049	1874	15659000	30002	14773	7	0	3
225060	2134	11504319000	30003	14774	4	0	8809
392055	1874	15671000	30003	14774	4	0	3
54069	1723	18722270085979	30003	14774	9	0	12
225073	1397	1256661801000	30005	14775	0	0	18216
392068	1678	29520912299000	30005	14775	0	0	1
225079	2133	8310776000	30005	14775	6	0	8115
392074	1874	15692000	30005	14775	6	0	3
225081	2133	8308772000	30005	14775	8	0	8117
225082	2133	8307770000	30005	14775	9	0	8118
392080	1874	15708000	30005	14775	12	0	3
225088	2134	11496287000	30005	14775	15	0	8817
392085	1874	15728000	30005	14775	17	0	3
392108	1678	29520912301000	30007	14776	0	0	1
225114	2133	8305766000	30007	14776	1	0	8120
392109	1874	15738000	30007	14776	1	0	3
225119	2134	11488255000	30007	14776	6	0	8825
392115	1874	15759000	30007	14776	7	0	3
35479	1679	28798943656999	30007	14776	10	0	100
225125	2132	6688703000	30008	14777	2	0	2299
392121	1874	15767000	30008	14777	3	0	3
225131	2133	8301758000	30008	14777	8	0	8124
392126	1874	15785000	30008	14777	8	0	3
51405	1709	13680334000000	30008	14777	10	0	8
225154	2134	11482231000	30011	14778	4	0	8831
392150	1874	15792000	30011	14778	5	0	3
225160	2133	8295746000	30011	14778	10	0	8130
392156	1874	15804000	30011	14778	11	0	3
225166	2134	11478215000	30011	14778	16	0	8835
392161	1874	15822000	30011	14778	16	0	3
225171	2134	11476207000	30011	14778	21	0	8837
392167	1874	15837000	30011	14778	22	0	3
225177	2134	11470183000	30011	14778	27	0	8843
392173	1874	15861000	30011	14778	28	0	3
61175	2329	345607312819988	30011	14778	29	0	0
225183	2132	6682697000	30012	14779	4	0	2305
392178	1874	15867000	30012	14779	4	0	3
61342	2367	100006101	30012	14779	11	0	0
8115	1394	1163537477299216	30012	14779	13	0	0
21921	1571	7520895388419	30012	14779	14	1	59
225188	1397	1256581793000	30013	14780	0	0	18224
392184	1874	15885000	30013	14780	1	0	3
225194	2134	11463155000	30013	14780	6	0	8850
392190	1874	15902000	30013	14780	7	0	3
225200	2132	6680695000	30014	14781	3	0	2307
392195	1874	15915000	30014	14781	3	0	3
225205	2133	8286728000	30014	14781	8	0	8139
225296	1397	1256561791000	30020	14782	0	0	18226
392291	1678	29520912309000	30020	14782	0	0	1
225297	1397	1256551790000	30020	14782	1	0	18227
392292	1678	29520912310000	30020	14782	1	0	1
225303	2132	6676691000	30020	14782	7	0	2311
392298	1874	15937000	30020	14782	7	0	3
225309	2133	8280716000	30020	14782	13	0	8145
392304	1874	15948000	30020	14782	13	0	3
225314	2134	11454119000	30020	14782	18	0	8859
392309	1874	15962000	30020	14782	18	0	3
225320	2134	11448095000	30020	14782	24	0	8865
392315	1874	15986000	30020	14782	24	0	3
225334	1397	1256531788000	30025	14783	0	0	18229
392329	1678	29520912312000	30025	14783	0	0	1
225339	2133	8275706000	30025	14783	5	0	8150
392334	1874	16022000	30025	14783	5	0	3
4019	606	84766024286229	30025	14783	8	0	19
225351	2132	6672687000	30028	14784	4	0	2315
392346	1874	16031000	30028	14784	4	0	3
25367	1608	20298656000000	30028	14784	6	0	8
225358	1397	1256511786000	30030	14785	0	0	18231
225359	2134	11438055000	30030	14785	1	0	8875
392357	1874	16049000	30030	14785	4	0	3
225365	2134	11432031000	30030	14785	7	0	8881
392361	1874	16065000	30030	14785	8	0	3
392362	1874	16069000	30030	14785	9	0	3
225371	1397	1256501785000	30031	14786	0	0	18232
392368	1874	16075000	30031	14786	2	0	3
225376	2133	8268692000	30031	14786	5	0	8157
392374	1874	16089000	30031	14786	8	0	3
225382	2134	11426007000	30031	14786	11	0	8887
392379	1874	16103000	30031	14786	13	0	3
225388	2134	11421991000	30031	14786	17	0	8891
10019	1395	58364554229457072	30031	14786	20	0	0
392404	1678	29520912317000	30033	14787	0	0	1
225412	2132	6667682000	30033	14787	3	0	2320
392410	1874	16136000	30033	14787	7	0	3
225418	2133	8263682000	30033	14787	10	0	8162
392415	1874	16144000	30033	14787	12	0	3
225424	2134	11414963000	30033	14787	16	0	8898
392421	1874	16168000	30033	14787	18	0	3
58041	1807	200000264	30033	14787	23	0	0
59162	2004	200039479	30033	14787	24	0	0
225429	2133	8260676000	30034	14788	2	0	8165
392427	1874	16182000	30034	14788	5	0	3
225435	2134	11408939000	30034	14788	8	0	8904
392432	1874	16196000	30034	14788	10	0	3
26587	1622	16884259774848	30034	14788	12	0	10
61245	2332	100005800	30034	14788	13	1	0
225464	1726	111916112000	30038	14789	3	0	8369
392461	1874	16205000	30038	14789	5	0	3
225469	2133	8257670000	30038	14789	8	0	8168
53725	1719	23038859000000	30038	14789	11	0	10
225493	1992	1236990000	30040	14790	0	0	7
225494	1397	1256441779000	30040	14790	1	0	18238
392489	1678	29520912321000	30040	14790	1	0	1
392494	1874	16233000	30040	14790	6	0	3
225500	2132	6661676000	30040	14790	7	0	2326
392497	1874	16238000	30040	14790	9	0	3
392498	1874	16240000	30040	14790	10	0	3
225506	2133	8251658000	30040	14790	13	0	8174
392504	1874	16254000	30040	14790	16	0	3
225511	2134	11395887000	30040	14790	18	0	8917
392572	1678	29520912323000	30044	14791	0	0	1
225581	2133	8249654000	30044	14791	2	0	8176
392577	2437	100000000	30044	14791	6	0	0
225587	2134	11391871000	30044	14791	8	0	8921
392583	1874	16299000	30044	14791	12	0	3
225592	2134	11386851000	30044	14791	13	0	8926
392589	1874	16315000	30044	14791	18	0	3
225598	2132	6657672000	30044	14791	19	0	2330
392594	155	66000435000000	30045	14792	2	0	0
225604	2132	6654669000	30045	14792	4	0	2333
392600	1874	16332000	30045	14792	8	0	3
225609	2134	11381831000	30045	14792	9	0	8931
392606	1874	16346000	30045	14792	14	0	3
225615	2134	11380827000	30045	14792	15	0	8932
392611	1874	16366000	30045	14792	19	0	3
225670	1397	1256381773000	30049	14793	0	0	18244
392662	1678	29520912327000	30049	14793	0	0	1
225671	2132	6652667000	30049	14793	1	0	2335
392663	1874	16367000	30049	14793	1	0	3
225677	2134	11374803000	30049	14793	7	0	8938
392669	1874	16382000	30049	14793	7	0	3
48455	1698	21669354550062	30050	14794	0	0	12
225700	2132	6650665000	30052	14795	3	0	2337
392692	1874	16393000	30052	14795	3	0	3
225705	2134	11371791000	30052	14795	8	0	8941
392697	1874	16404000	30052	14795	8	0	3
225711	2134	11365767000	30052	14795	14	0	8947
392703	1874	16428000	30052	14795	14	0	3
57916	1796	200000046	30052	14795	18	0	0
20181	1549	19151580854742	30052	14795	19	1	10
225717	2133	8231618000	30053	14796	3	0	8194
392709	1874	16444000	30053	14796	3	0	3
225722	2134	11359743000	30053	14796	8	0	8953
392714	1874	16458000	30053	14796	8	0	3
225758	2133	8230616000	30056	14797	4	0	8195
392750	1874	16465000	30056	14797	4	0	3
225761	2133	8227610000	30056	14797	7	0	8198
225762	2133	8226608000	30056	14797	8	0	8199
392756	1874	16479000	30056	14797	10	0	3
225768	2134	11354723000	30056	14797	14	0	8958
392761	1874	16496000	30056	14797	15	0	3
225794	1397	1256321767000	30058	14798	0	0	18250
392786	1678	29520912333000	30058	14798	0	0	1
392787	1678	29520912334000	30058	14798	1	0	1
225799	2133	8222600000	30058	14798	5	0	8203
392793	1874	16527000	30058	14798	7	0	3
225805	2134	11343679000	30058	14798	11	0	8969
392799	1874	16551000	30058	14798	13	0	3
225811	2133	8221598000	30058	14798	17	0	8204
392804	1874	16558000	30058	14798	18	0	3
225835	2134	11340667000	30060	14799	3	0	8972
392829	1874	16573000	30060	14799	5	0	3
225850	1397	1256281763000	30062	14800	1	0	18254
392844	1874	16581000	30062	14800	3	0	3
225856	2133	8215586000	30062	14800	7	0	8210
392849	1874	16595000	30062	14800	8	0	3
225861	2133	8210576000	30062	14800	12	0	8215
392855	2438	100000000	30062	14800	14	0	0
225867	2132	6636651000	30062	14800	18	0	2351
392861	1874	16614000	30062	14800	20	0	3
225873	2134	11330627000	30062	14800	24	0	8982
392866	1874	16634000	30062	14800	25	0	3
225878	2134	11325607000	30062	14800	29	0	8987
392872	1874	16658000	30062	14800	31	0	3
225884	2133	8207570000	30063	14801	3	0	8218
392878	1874	16671000	30063	14801	5	0	3
60165	2112	31487142101924	30063	14801	6	0	7
21679	1568	1775000	30063	14801	11	0	0
60444	2221	200410000	30063	14801	11	1	0
225897	1397	1256251760000	30065	14802	0	0	18257
225898	2133	8206568000	30065	14802	1	0	8219
392891	1874	16683000	30065	14802	2	0	3
225904	2134	11315567000	30065	14802	7	0	8997
392897	1874	16702000	30065	14802	8	0	3
225910	2134	11313559000	30066	14803	4	0	8999
392903	1874	16714000	30066	14803	6	0	3
392905	1874	16720000	30066	14803	8	0	3
225915	2134	11311551000	30066	14803	9	0	9001
392906	1874	16724000	30066	14803	9	0	3
225921	2134	11308539000	30067	14804	4	0	9004
392912	1874	16739000	30067	14804	4	0	3
10025	1395	58366714303457072	30067	14804	9	0	0
225944	2132	6629644000	30070	14805	2	0	2358
392935	1874	16752000	30070	14805	2	0	3
225949	2134	11302515000	30070	14805	7	0	9010
392940	1874	16769000	30070	14805	7	0	3
225966	2133	8195546000	30072	14806	2	0	8230
392957	1874	16781000	30072	14806	2	0	3
225972	1533	717960000000	30073	14807	0	0	1
392963	455	66002000000000	30073	14807	0	0	0
225977	2134	11296491000	30073	14807	5	0	9016
392968	1874	16806000	30073	14807	5	0	3
226002	1397	1256191754000	30075	14808	0	0	18263
392993	1678	29520912346000	30075	14808	0	0	1
226008	2133	8188532000	30075	14808	6	0	8237
392999	1874	16830000	30075	14808	6	0	3
226013	2134	11288459000	30075	14808	11	0	9024
393004	1874	16850000	30075	14808	11	0	3
226019	2132	6623638000	30075	14808	17	0	2364
393010	1874	16868000	30075	14808	17	0	3
226030	2132	6621636000	30077	14809	4	0	2366
393021	1874	16878000	30077	14809	4	0	3
226033	2134	11281431000	30077	14809	7	0	9031
226034	2134	11280427000	30077	14809	8	0	9032
393036	1678	29520912349000	30079	14810	0	0	1
226050	2132	6620635000	30079	14810	5	0	2367
393041	1874	16907000	30079	14810	5	0	3
393042	1874	16908000	30079	14810	6	0	3
226056	1397	1256151750000	30080	14811	0	0	18267
393048	1874	16924000	30080	14811	1	0	3
226061	2134	11271391000	30080	14811	6	0	9041
393054	1874	16942000	30080	14811	8	0	3
226101	2134	11270387000	30085	14812	2	0	9042
393093	1874	16953000	30085	14812	3	0	3
226107	2132	6616631000	30085	14812	8	0	2371
25818	1611	7192572402899	30085	14812	9	0	18
393099	1678	29520912352000	30086	14813	0	0	1
226112	2132	6615630000	30086	14813	4	0	2372
393105	1874	16976000	30086	14813	6	0	3
226118	2132	6613628000	30086	14813	10	0	2374
393110	1874	16987000	30086	14813	11	0	3
226124	2133	8172500000	30086	14813	16	0	8253
393116	1874	17001000	30086	14813	17	0	3
226129	2134	11260347000	30086	14813	21	0	9052
393122	1874	17021000	30086	14813	23	0	3
226135	2134	11254323000	30086	14813	27	0	9058
10032	1395	58368154376206711	30086	14813	29	0	0
393159	1678	29520912355000	30091	14814	0	0	1
226169	2133	8168492000	30091	14814	1	0	8257
226170	2132	6611626000	30091	14814	2	0	2376
393165	1874	17051000	30091	14814	6	0	3
226176	2134	11250307000	30091	14814	8	0	9062
393185	1678	29520912356000	30094	14815	0	0	1
393186	1874	17061000	30094	14815	1	0	3
226199	2133	8165486000	30094	14815	5	0	8260
393192	1874	17080000	30094	14815	7	0	3
42671	1688	63432117545072	30094	14815	10	0	77
226222	2132	6608623000	30097	14816	1	0	2379
48125	1696	24923916335104	30097	14816	2	0	9
393216	1874	17089000	30098	14817	2	0	3
226228	2134	11241271000	30098	14817	5	0	9071
393221	1874	17109000	30098	14817	7	0	3
226234	2134	11236251000	30098	14817	11	0	9076
393227	1874	17131000	30098	14817	13	0	3
226239	2133	8163482000	30098	14817	16	0	8262
393233	1874	17144000	30098	14817	19	0	3
226245	2133	8161478000	30098	14817	22	0	8264
393238	1874	17153000	30098	14817	24	0	3
226380	1397	1256051740000	30101	14818	0	0	18277
393370	1678	29520912360000	30101	14818	0	0	1
226381	2132	6603618000	30101	14818	1	0	2384
393371	1874	17156000	30101	14818	1	0	3
61391	2393	2877990000000	30106	14819	3	0	1
226577	234	66531385942306	30111	14820	0	0	1
393567	2439	99000000000	30111	14820	0	0	0
226578	1397	1256011736000	30111	14820	1	0	18281
393568	1678	29520912364000	30111	14820	1	0	1
226584	2132	6599614000	30111	14820	7	0	2388
393574	1874	17162000	30111	14820	7	0	3
226590	2133	8154464000	30111	14820	14	0	8271
393580	1874	17174000	30111	14820	14	0	3
226595	2133	8149454000	30111	14820	19	0	8276
393585	1874	17184000	30111	14820	19	0	3
393586	1874	17186000	30111	14820	20	0	3
226601	2134	11228219000	30111	14820	25	0	9084
393592	1874	17203000	30111	14820	26	0	3
226607	2134	11223199000	30111	14820	31	0	9089
393598	1874	17227000	30111	14820	32	0	3
226612	2134	11218179000	30111	14820	36	0	9094
393603	1874	17247000	30111	14820	37	0	3
226618	2134	11212155000	30111	14820	42	0	9100
393609	1874	17271000	30111	14820	43	0	3
226624	2134	11206131000	30111	14820	48	0	9106
393615	1874	17293000	30111	14820	49	0	3
18719	1522	18043978000000	30111	14820	53	0	14
226789	2132	6595610000	30116	14821	0	0	2392
393779	1874	17300000	30116	14821	0	0	3
226790	2133	8141438000	30116	14821	1	0	8284
393780	1874	17302000	30116	14821	1	0	3
19954	1547	19435142000000	30116	14821	7	0	12
226828	1397	1255991734000	30120	14822	0	0	18283
393815	1678	29520912366000	30120	14822	0	0	1
226834	2133	8138432000	30120	14822	6	0	8287
393821	1874	17328000	30120	14822	6	0	3
226839	2133	8136428000	30120	14822	11	0	8289
393826	1874	17339000	30120	14822	12	0	3
226845	2134	11195087000	30120	14822	17	0	9117
393832	1874	17363000	30120	14822	18	0	3
226849	2132	6592607000	30120	14822	21	0	2395
226850	2132	6591606000	30120	14822	22	0	2396
20208	1549	21311690886322	30120	14822	24	0	10
393881	1678	29520912369000	30123	14823	0	0	1
393882	1678	29520912370000	30123	14823	1	0	1
226902	2134	11191071000	30123	14823	5	0	9121
393888	1874	17387000	30123	14823	7	0	3
226908	2134	11188059000	30123	14823	11	0	9124
393894	1874	17402000	30123	14823	13	0	3
226913	2134	11183039000	30123	14823	16	0	9129
393899	1874	17422000	30123	14823	18	0	3
226919	2133	8132420000	30123	14823	22	0	8293
393905	1874	17436000	30123	14823	24	0	3
31255	1668	22114007500000	30123	14823	29	0	9
226925	1397	1255931728000	30124	14824	0	0	18289
393911	1874	17443000	30124	14824	2	0	3
226930	2133	8124404000	30124	14824	5	0	8301
393916	1874	17457000	30124	14824	7	0	3
226936	2133	8123402000	30124	14824	11	0	8302
393922	1874	17475000	30124	14824	13	0	3
226942	2134	11172999000	30124	14824	17	0	9139
393928	1874	17493000	30124	14824	19	0	3
226947	2133	8120396000	30125	14825	2	0	8305
393933	1874	17502000	30125	14825	4	0	3
226953	2132	6581596000	30125	14825	8	0	2406
393939	1874	17516000	30125	14825	10	0	3
226959	2134	11165971000	30125	14825	14	0	9146
393945	1874	17536000	30125	14825	16	0	3
58053	1807	200000302	30125	14825	23	0	0
226983	1397	1255901725000	30127	14826	0	0	18292
226985	2133	8114384000	30127	14826	2	0	8311
393969	1874	17550000	30127	14826	2	0	3
226986	2133	8113382000	30127	14826	3	0	8312
8125	1394	1167857529299216	30127	14826	9	0	0
394001	1678	29520912376000	30131	14827	0	0	1
227018	2132	6579594000	30131	14827	1	0	2408
394002	1874	17566000	30131	14827	1	0	3
40623	1685	203045111571430	30131	14827	4	0	0
227040	2133	8110376000	30134	14828	4	0	8315
394024	1874	17574000	30134	14828	4	0	3
227045	2134	11152919000	30134	14828	9	0	9159
394030	1874	17598000	30134	14828	10	0	3
227061	1397	1255871722000	30136	14829	0	0	18295
394045	1678	29520912378000	30136	14829	0	0	1
227067	2133	8105366000	30137	14830	1	0	8320
394051	1874	17618000	30137	14830	1	0	3
227072	2132	6574589000	30137	14830	6	0	2413
394057	1874	17633000	30137	14830	7	0	3
227078	2134	11141875000	30137	14830	12	0	9170
394062	1874	17653000	30137	14830	12	0	3
227123	1397	1255851720000	30142	14831	0	0	18297
227124	2133	8103362000	30142	14831	1	0	8322
394111	1874	17668000	30142	14831	4	0	3
227130	2134	11136855000	30142	14831	7	0	9175
394130	1678	29520912381000	30145	14832	0	0	1
394131	1874	17684000	30145	14832	1	0	3
227150	2133	8099354000	30145	14832	4	0	8326
394137	1874	17698000	30145	14832	7	0	3
227155	2134	11131835000	30145	14832	9	0	9180
394159	1874	17714000	30148	14833	3	0	3
227177	2134	11128823000	30148	14833	5	0	9183
1793	326	67440032000000	30148	14833	9	0	0
394164	1678	29520912383000	30149	14834	0	0	1
227183	2134	11125811000	30149	14834	3	0	9186
394170	1874	17749000	30149	14834	6	0	3
227188	2132	6568583000	30149	14834	8	0	2419
10043	1395	58370314466906275	30149	14834	11	0	0
394235	1678	29520912386000	30154	14837	2	0	1
227253	1397	1255771712000	30154	14837	4	0	18305
394240	1874	17763000	30154	14837	7	0	3
227257	2133	8093342000	30154	14837	8	0	8332
227258	2134	11119787000	30154	14837	9	0	9192
394246	1874	17785000	30154	14837	13	0	3
227264	2134	11113763000	30154	14837	15	0	9198
394252	1874	17807000	30154	14837	19	0	3
227270	2133	8090336000	30154	14837	21	0	8335
394257	1874	17817000	30154	14837	24	0	3
227275	2133	8085326000	30154	14837	26	0	8340
394263	1874	17826000	30154	14837	30	0	3
227281	2133	8082320000	30154	14837	32	0	8343
394265	1874	17830000	30154	14837	32	0	3
394266	1874	17832000	30154	14837	33	0	3
227287	2134	11106735000	30154	14837	38	0	9205
394272	1874	17852000	30154	14837	39	0	3
227292	2134	11101715000	30154	14837	43	0	9210
394278	1874	17873000	30154	14837	45	0	3
17553	1508	20360549156616	30154	14837	49	0	10
227298	664	66541497726895	30155	14838	0	0	4
394283	1678	29520912389000	30155	14838	1	0	1
227304	2133	8079314000	30155	14838	6	0	8346
394289	1874	17890000	30155	14838	7	0	3
227327	2132	6558573000	30158	14839	1	0	2429
394313	1874	17907000	30158	14839	3	0	3
227333	2133	8077310000	30158	14839	7	0	8348
1646	216	66720000000000	30158	14839	8	0	0
394324	1678	29520912391000	30161	14840	0	0	1
227345	2134	11088663000	30161	14840	5	0	9223
394330	1874	17938000	30161	14840	6	0	3
227350	2134	11087659000	30162	14841	2	0	9224
394336	1874	17951000	30162	14841	4	0	3
227356	2134	11083643000	30162	14841	8	0	9228
394341	1874	17966000	30162	14841	9	0	3
227437	1397	1255721707000	30165	14842	0	0	18310
394421	1678	29520912393000	30165	14842	0	0	1
227438	1397	1255711706000	30165	14842	1	0	18311
394422	1678	29520912394000	30165	14842	1	0	1
227444	2132	6553568000	30165	14842	7	0	2434
394428	1874	17976000	30165	14842	7	0	3
227450	2133	8068292000	30165	14842	13	0	8357
394434	1874	17985000	30165	14842	13	0	3
227455	2133	8063282000	30165	14842	18	0	8362
394439	1874	17995000	30165	14842	18	0	3
227461	2134	11079627000	30165	14842	24	0	9232
394445	1874	18013000	30165	14842	24	0	3
227467	2134	11073603000	30165	14842	31	0	9238
394451	1874	18037000	30165	14842	31	0	3
227472	2134	11068583000	30165	14842	36	0	9243
394456	1874	18057000	30165	14842	36	0	3
61404	2430	275707601654	30165	14842	42	1	1
61260	2332	100006900	30165	14842	44	1	0
227532	1397	1255681703000	30169	14843	0	0	18314
227533	2133	8059274000	30169	14843	1	0	8366
394518	1874	18072000	30169	14843	2	0	3
227539	2134	11061555000	30169	14843	7	0	9250
394524	1874	18091000	30169	14843	8	0	3
22657	1587	22320600750000	30169	14843	9	0	14
60231	2126	253800006	30169	14843	11	1	0
59179	2004	200039668	30169	14843	13	0	0
394541	1678	29520912398000	30172	14844	0	0	1
394542	1874	18093000	30172	14844	1	0	3
227561	2132	6547562000	30172	14844	4	0	2440
394548	1874	18112000	30172	14844	7	0	3
56107	1747	10146139599975	30172	14844	9	0	6
227575	2134	11056535000	30174	14845	1	0	9255
394563	1874	18128000	30174	14845	5	0	3
227581	2132	6546561000	30174	14845	7	0	2441
20886	1559	19026346897799	30174	14845	9	0	8
394568	1874	18136000	30175	14846	1	0	3
227587	180	66932438434669	30175	14846	4	0	2
394574	1874	18151000	30175	14846	7	0	3
227592	2134	11048503000	30175	14846	9	0	9263
394617	1874	18163000	30179	14847	3	0	3
227636	2133	8049254000	30179	14847	5	0	8376
394622	1874	18171000	30179	14847	8	0	3
227642	2134	11046495000	30179	14847	11	0	9265
394628	1874	18192000	30179	14847	14	0	3
227647	2134	11041475000	30179	14847	16	0	9270
394642	1874	18210000	30181	14848	1	0	3
227661	2132	6540555000	30181	14848	3	0	2447
394647	1874	18225000	30181	14848	6	0	3
227665	2134	11035451000	30181	14848	7	0	9276
227670	1397	1255611696000	30183	14849	0	0	18321
394657	1874	18235000	30183	14849	4	0	3
227676	2134	11033443000	30183	14849	6	0	9278
394735	1678	29520912405000	30186	14850	0	0	1
394736	1874	18255000	30186	14850	1	0	3
227764	2133	8042240000	30186	14850	3	0	8383
227807	1397	1255591694000	30190	14851	0	0	18323
394781	1678	29520912406000	30190	14851	0	0	1
227808	1397	1255581693000	30190	14851	1	0	18324
394787	1874	18283000	30190	14851	6	0	3
227814	2133	8039234000	30190	14851	7	0	8386
394792	1874	18292000	30190	14851	11	0	3
227820	2134	11024407000	30190	14851	13	0	9287
394798	1874	18313000	30190	14851	18	0	3
227825	2134	11019387000	30190	14851	19	0	9292
57934	1796	200000063	30190	14851	22	0	0
21698	1568	2100000	30190	14851	22	1	0
394811	2439	629000000000	30192	14852	0	0	0
394812	1678	29520912408000	30192	14852	1	0	1
227841	2134	11017379000	30192	14852	4	0	9294
394818	1874	18335000	30192	14852	7	0	3
61191	2329	348487366819988	30192	14852	10	0	0
227883	180	66930178434669	30195	14853	0	0	3
394858	1874	18344000	30195	14853	3	0	3
227888	2132	6530545000	30195	14853	5	0	2457
394863	1874	18352000	30195	14853	8	0	3
227894	2134	11012359000	30195	14853	11	0	9299
394869	1874	18370000	30195	14853	15	0	3
227900	2134	11008343000	30195	14853	17	0	9303
394875	1215	615077896001284	30195	14853	21	0	0
227905	1611	3785156527184	30195	14853	22	0	22
394880	1874	18393000	30196	14854	2	0	3
227911	2133	8027210000	30196	14854	4	0	8398
394901	1874	18404000	30199	14855	3	0	3
227933	2133	8024204000	30199	14855	5	0	8401
227937	2134	11001315000	30199	14855	9	0	9310
394907	1874	18421000	30199	14855	9	0	3
227938	2134	11000311000	30199	14855	10	0	9311
394912	1874	18441000	30199	14855	14	0	3
227944	2132	6525540000	30199	14855	16	0	2462
39569	1684	39603900494436	30199	14855	21	0	136
394959	2441	7010000000	30203	14856	0	0	0
394960	1678	29520912410000	30203	14856	1	0	1
227991	1397	1255541689000	30203	14856	2	0	18328
227996	2132	6522537000	30203	14856	7	0	2465
394966	1874	18465000	30203	14856	7	0	3
228002	2134	10987259000	30203	14856	13	0	9324
394972	1874	18487000	30203	14856	13	0	3
394977	1874	18503000	30203	14856	18	0	3
228008	2133	8018192000	30203	14856	19	0	8407
10051	1395	58372474565906275	30203	14856	22	0	0
228166	180	66000103434669	30208	14857	0	0	6
395135	2441	927010000000	30208	14857	0	0	0
228167	512	66543508726895	30208	14857	1	0	2
395136	2442	0	30208	14857	1	0	0
228266	1397	1255531688000	30214	14858	0	0	18329
395235	1678	29520912412000	30214	14858	0	0	1
228267	1397	1255521687000	30214	14858	1	0	18330
395236	1678	29520912413000	30214	14858	1	0	1
228273	2132	6519534000	30214	14858	7	0	2468
395242	1874	18518000	30214	14858	7	0	3
228279	2133	8015186000	30214	14858	13	0	8410
395248	1874	18538000	30214	14858	13	0	3
228284	2134	10976215000	30214	14858	18	0	9335
395253	1874	18546000	30214	14858	18	0	3
228290	2133	8012180000	30214	14858	25	0	8413
395259	1874	18558000	30214	14858	25	0	3
228296	2134	10972199000	30214	14858	31	0	9339
395265	1874	18576000	30214	14858	31	0	3
57938	1796	200000064	30214	14858	35	0	0
228350	664	66010484726895	30220	14859	0	0	6
228351	1397	1255501685000	30220	14859	1	0	18332
395321	1874	18585000	30220	14859	2	0	3
228357	2134	10967179000	30220	14859	7	0	9344
395327	1874	18605000	30220	14859	8	0	3
12671	1439	17984007578477	30220	14859	10	0	10
228363	2132	6514529000	30221	14860	3	0	2473
395333	1874	18611000	30221	14860	4	0	3
228368	2134	10962159000	30221	14860	8	0	9349
395338	1678	29520912417000	30222	14861	0	0	1
228374	2134	10960151000	30222	14861	5	0	9351
395344	1874	18644000	30222	14861	6	0	3
395437	1678	29520912418000	30224	14862	0	0	1
395438	1540	0	30224	14862	1	0	6
228471	2133	8002160000	30224	14862	3	0	8423
395444	1874	18665000	30224	14862	7	0	3
228476	2134	10954127000	30224	14862	8	0	9357
2925	484	79774088250000	30224	14862	10	0	8
228508	1397	1255461681000	30228	14863	0	0	18336
228509	2441	927007000000	30228	14863	1	0	1
395481	1874	18676000	30228	14863	4	0	3
228515	2134	10951115000	30228	14863	7	0	9360
395486	1874	18694000	30228	14863	9	0	3
395499	1678	29520912420000	30230	14864	0	0	1
395500	1678	29520912421000	30230	14864	1	0	1
228532	1397	1255431678000	30230	14864	2	0	18339
228537	2132	6506521000	30230	14864	7	0	2481
395506	1874	18703000	30230	14864	7	0	3
228543	2134	10942079000	30230	14864	13	0	9369
395512	1874	18727000	30230	14864	13	0	3
395517	1874	18741000	30230	14864	18	0	3
228549	2134	10939067000	30230	14864	19	0	9372
228554	2133	7994144000	30230	14864	24	0	8431
395523	1874	18761000	30230	14864	24	0	3
228616	2133	7989134000	30237	14865	3	0	8436
395585	1874	18772000	30237	14865	3	0	3
228617	2132	6504519000	30237	14865	4	0	2483
228618	1397	1255421677000	30238	14866	0	0	18340
395590	1874	18774000	30238	14866	3	0	3
228624	2134	10933043000	30238	14866	6	0	9378
395596	1874	18798000	30238	14866	9	0	3
10826	1402	70744385811104	30238	14866	11	0	66
228630	2133	7987130000	30238	14866	13	0	8438
395602	1874	18811000	30238	14866	16	0	3
228635	2134	10928023000	30238	14866	18	0	9383
395607	1874	18828000	30238	14866	21	0	3
61373	2367	100007701	30238	14866	26	0	0
60456	2221	200850000	30238	14866	26	1	0
228641	1397	1255391674000	30239	14867	0	0	18343
395613	1874	18848000	30239	14867	3	0	3
228647	2133	7984124000	30239	14867	6	0	8441
31570	1670	18001223474693	30239	14867	8	0	11
58080	1807	200000342	30239	14867	9	1	0
61275	2332	100008000	30239	14867	11	0	0
59193	2004	200039785	30239	14867	11	1	0
395625	1874	18859000	30242	14868	1	0	3
395626	1874	18863000	30242	14868	2	0	3
228658	2132	6499514000	30242	14868	3	0	2488
395632	1874	18879000	30242	14868	8	0	3
228664	2133	7980116000	30242	14868	9	0	8445
395638	1874	18897000	30243	14869	4	0	3
228670	2132	6497512000	30243	14869	5	0	2490
395643	1678	29520912430000	30245	14871	1	0	1
228675	2134	10909951000	30245	14871	2	0	9401
395649	1874	18913000	30245	14871	7	0	3
228681	2133	7977110000	30245	14871	8	0	8448
395655	1874	18929000	30245	14871	13	0	3
228687	2134	10905935000	30245	14871	14	0	9405
395660	1874	18949000	30245	14871	18	0	3
228711	1397	1255341669000	30247	14872	0	0	18348
395685	1874	18956000	30247	14872	5	0	3
228717	2133	7970096000	30247	14872	6	0	8455
395691	1874	18970000	30247	14872	11	0	3
228723	2134	10898907000	30247	14872	12	0	9412
395696	1874	18990000	30247	14872	16	0	3
228728	2134	10893887000	30247	14872	17	0	9417
228753	2134	10891879000	30250	14873	1	0	9419
228754	2133	7968092000	30250	14873	2	0	8457
395724	1874	19006000	30250	14873	3	0	3
228760	2134	10889871000	30250	14873	8	0	9421
52433	1715	13703657663945	30250	14873	9	0	16
395750	1678	29520912434000	30253	14874	0	0	1
228786	2132	6488503000	30253	14874	5	0	2499
395755	1874	19029000	30253	14874	5	0	3
228791	1397	1255301665000	30254	14875	0	0	18352
395761	1874	19043000	30254	14875	1	0	3
395762	1874	19045000	30254	14875	2	0	3
228797	2134	10882843000	30254	14875	6	0	9428
14784	1457	17280421800000	30254	14875	8	0	8
395768	1874	19064000	30254	14875	9	0	3
228839	2133	7960076000	30257	14876	3	0	8465
395810	1874	19074000	30257	14876	5	0	3
228844	2133	7958072000	30257	14876	8	0	8467
395815	1874	19086000	30257	14876	10	0	3
228850	2134	10874811000	30257	14876	14	0	9436
395821	1874	19107000	30257	14876	16	0	3
8137	1394	1172177575299216	30257	14876	18	0	0
228936	333	66209360726895	30260	14877	0	0	3
395905	2015	333750000000	30260	14877	0	0	1
228937	2440	531992750000	30260	14877	1	0	2
395906	664	66011484726895	30260	14877	1	0	6
228943	2132	6483498000	30261	14878	5	0	2504
395912	1874	19112000	30261	14878	5	0	3
228949	2134	10869791000	30261	14878	11	0	9441
395918	1874	19124000	30261	14878	11	0	3
228954	2132	6478493000	30261	14878	16	0	2509
395923	1874	19141000	30261	14878	16	0	3
228960	2133	7953062000	30261	14878	22	0	8472
395929	1874	19152000	30261	14878	22	0	3
228966	2134	10860755000	30261	14878	28	0	9450
395935	1874	19174000	30261	14878	28	0	3
228971	2134	10855735000	30261	14878	33	0	9455
395940	1874	19194000	30261	14878	33	0	3
228977	2134	10849711000	30261	14878	39	0	9461
395946	1874	19218000	30261	14878	39	0	3
228983	2133	7948052000	30261	14878	45	0	8477
395952	1874	19231000	30261	14878	45	0	3
228988	1397	1255221657000	30262	14879	1	0	18360
395957	1678	29520912443000	30262	14879	1	0	1
228994	2133	7943042000	30262	14879	7	0	8482
395963	1874	19244000	30262	14879	7	0	3
229000	2134	10845695000	30262	14879	13	0	9465
395969	1874	19262000	30262	14879	13	0	3
229005	2134	10840675000	30262	14879	18	0	9470
395974	1874	19282000	30262	14879	18	0	3
229012	2133	7937030000	30264	14880	4	0	8488
395981	1874	19293000	30264	14880	4	0	3
229025	2132	6471486000	30266	14881	3	0	2516
229026	2133	7936028000	30266	14881	4	0	8489
395996	1874	19297000	30266	14881	5	0	3
229032	2134	10837663000	30266	14881	10	0	9473
396001	1874	19311000	30266	14881	10	0	3
229038	2132	6469484000	30266	14881	17	0	2518
396007	1874	19332000	30266	14881	17	0	3
229043	2134	10829631000	30266	14881	22	0	9481
396013	1874	19351000	30266	14881	23	0	3
229049	2133	7930016000	30266	14881	28	0	8495
396018	1874	19367000	30266	14881	28	0	3
21715	1568	2475000	30266	14881	35	1	0
15415	1467	12400472122718	30266	14881	36	1	9
229198	1397	1255161651000	30269	14882	0	0	18366
396165	1678	29520912449000	30269	14882	0	0	1
229199	1397	1255151650000	30269	14882	1	0	18367
396166	1678	29520912450000	30269	14882	1	0	1
396169	1874	19385000	30269	14882	4	0	3
396170	1874	19387000	30269	14882	5	0	3
229205	2133	7925006000	30269	14882	7	0	8500
57951	1796	200000073	30269	14882	12	0	0
60589	2252	201300000	30269	14882	14	0	0
396176	1678	29520912451000	30270	14883	0	0	1
229211	2132	6464479000	30270	14883	2	0	2523
396182	1874	19414000	30270	14883	6	0	3
229216	2133	7922000000	30270	14883	7	0	8503
396187	1874	19428000	30270	14883	11	0	3
229222	2134	10814571000	30270	14883	13	0	9496
396193	1874	19452000	30270	14883	17	0	3
229228	1397	1255131648000	30271	14884	0	0	18369
396199	1874	19465000	30271	14884	4	0	3
229233	2133	7918994000	30271	14884	5	0	8506
396204	1874	19481000	30271	14884	9	0	3
229250	1397	1255121647000	30273	14885	0	0	18370
396221	2449	0	30273	14885	4	0	0
229256	2133	7914986000	30273	14885	6	0	8510
396227	1874	19491000	30273	14885	10	0	3
229261	2132	6457472000	30273	14885	11	0	2530
396232	1874	19499000	30273	14885	15	0	3
229267	2133	7909976000	30273	14885	17	0	8515
396238	1874	19511000	30273	14885	21	0	3
24910	1602	18576863857496	30273	14885	23	0	9
229311	1397	1255081643000	30275	14886	0	0	18374
229312	2133	7904966000	30275	14886	1	0	8520
396283	1874	19518000	30276	14887	1	0	3
229318	2134	10803527000	30276	14887	3	0	9507
396288	1874	19533000	30276	14887	6	0	3
229324	2134	10800515000	30276	14887	9	0	9510
396294	1874	19553000	30276	14887	12	0	3
229329	2134	10795495000	30276	14887	14	0	9515
396300	1874	19577000	30276	14887	18	0	3
229335	2134	10789471000	30276	14887	20	0	9521
396305	1874	19597000	30276	14887	23	0	3
396306	1874	19601000	30276	14887	25	0	3
229341	2134	10783447000	30276	14887	27	0	9527
396312	1874	19625000	30276	14887	31	0	3
229346	2132	6453468000	30276	14887	32	0	2534
61384	2367	100008401	30276	14887	34	1	0
396318	1874	19636000	30277	14888	4	0	3
229352	2134	10777423000	30277	14888	5	0	9533
396323	1874	19649000	30277	14888	9	0	3
35522	1679	30959027656999	30277	14888	11	0	100
60238	2126	255050006	30277	14888	14	0	0
58091	1807	200000371	30277	14888	14	1	0
61283	2332	100078300	30277	14888	16	1	0
229358	1397	1255051640000	30278	14889	0	0	18377
396329	1874	19662000	30278	14889	4	0	3
229363	2132	6450465000	30278	14889	5	0	2537
40939	1686	22712303700123	30278	14889	9	0	17
396367	1874	19676000	30283	14890	2	0	3
229401	2134	10768387000	30283	14890	3	0	9542
396386	1874	19692000	30287	14891	1	0	3
229421	2132	6448463000	30287	14891	3	0	2539
229481	1397	1255021637000	30293	14892	0	0	18380
396448	1678	29520912463000	30293	14892	0	0	1
229482	1397	1255011636000	30293	14892	1	0	18381
396449	1678	29520912464000	30293	14892	1	0	1
229488	2134	10759351000	30293	14892	7	0	9551
396455	1874	19720000	30293	14892	7	0	3
229515	1397	1255001635000	30297	14893	0	0	18382
396482	1678	29520912465000	30297	14893	0	0	1
229545	100	66769680000000	30301	14894	0	0	1
396505	1678	29520912466000	30301	14894	3	0	1
229551	2132	6442457000	30301	14894	6	0	2545
396511	1874	19771000	30301	14894	9	0	3
10058	1395	58374634611906275	30301	14894	10	0	0
229557	2134	10746299000	30302	14895	2	0	9564
396517	1874	19785000	30302	14895	5	0	3
396532	1874	19793000	30305	14896	3	0	3
229576	2134	10742283000	30305	14896	4	0	9568
10851	1402	72904500210775	30310	14897	3	0	66
396554	1678	29520912471000	30313	14898	0	0	1
229598	2440	531988750000	30313	14898	1	0	3
229613	2134	10738267000	30316	14899	1	0	9572
396570	1874	19816000	30316	14899	1	0	3
45424	1692	25661529819983	30316	14899	2	0	6
13994	1449	24000459	1050	583	3	0	0
1687	262	66000100000000	2034	1072	2	0	0
22326	1580	10000000	2337	1222	0	0	0
5286	707	9000150000000	2913	1518	5	0	0
16953	1501	100000000	2992	1555	1	0	0
20327	1550	10000000	3069	1595	0	0	0
21861	1571	6480100000008	3243	1684	2	0	1
57849	1791	1200000024	5033	2612	2	0	0
26044	1613	7918400000000	5040	2614	2	0	2
18745	1527	250000000	5177	2688	0	0	0
2326	416	66000010000000	5771	2993	2	0	0
4111	631	66000500000000	8031	4163	0	0	0
11597	1420	720000110000	8780	4555	5	0	0
5140	646	66000002970000	8992	4662	2	0	0
623	45	66000000001060	9179	4757	7	0	0
19158	1539	1000000	9701	5032	9	0	0
1351	152	66000100000000	9948	5164	0	0	0
18240	1515	15603400	10074	5225	0	0	1
11992	1425	97400000000	10096	5237	4	0	0
24930	1604	100000	10370	5363	2	0	0
59217	2021	699000000000	10458	5406	5	0	0
1847	341	66001000000001	11600	5966	2	0	0
58670	1988	190000010	11818	6073	4	0	1
18371	1520	100000000	12550	6467	0	0	0
56892	1761	10100002	12837	6620	1	0	0
59448	2052	200000001	12994	6700	4	0	0
59450	2052	200000012	13036	6721	3	0	0
57842	1790	202900000	13113	6758	4	0	0
11952	1423	1473224999985	13619	7002	4	0	15
59782	2097	200000011	14257	7279	4	0	0
59943	2111	1000000000	14411	7351	2	0	0
59124	2004	200000009	14507	7401	6	0	0
30910	1660	1317030000000	17536	8881	3	0	0
60179	2123	2400000000	18102	9131	3	0	0
58406	1855	200000200	19617	9881	10	0	0
58102	1817	200000010	21240	10667	3	0	0
60738	2284	198500000	21651	10846	3	0	2
60604	2260	280000010	22289	11157	8	0	0
3054	519	66721917000000	24023	11955	6	0	0
1122	132	66001000000000	24537	12200	0	0	0
58412	1855	200003780	25012	12410	4	0	0
23756	1596	5760230000002	25237	12517	0	0	16
61203	2330	101000000	26244	12975	3	0	0
12345	1432	1441025000000	29415	14502	11	0	0
\.


--
-- Data for Name: blocks; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.blocks (id, state_hash, parent_id, parent_hash, creator_id, block_winner_id, snarked_ledger_hash_id, staking_epoch_data_id, next_epoch_data_id, ledger_hash, height, global_slot, global_slot_since_genesis, "timestamp", chain_status) FROM stdin;
7251	3NKb9fdwkyArMmgbVCvMZNXJReTakeKBGN3YYZvotGJ73yV3SzM7	7249	3NKm3TyAuPxm1FJXfnXuu84nU4Qsg3DrbJynaur1f2fUVXHmapay	80	1027	81	1	6301	jxMHDN1NxpAz4cDbczybc2WznbF3Bas43KM7iaH4eo4uw8z6XCv	3749	5297	5297	1616892660000	canonical
2	3NLyWnjZqUECniE1q719CoLmes6WDQAod4vrTeLfN7XXJbHv6EHH	1	3NKeMoncuHab5ScarV5ViyF16cJPT4taWNSaTLS64Dp67wuXigPZ	1407	1395	1	1	3	jwCtBkoHByTR65wDXSWXFJBQQ59trDsH3NfCh4czw7ur8ZtjkiV	2	1	1	1615939380000	canonical
3	3NKd5So3VNqGZtRZiWsti4yaEe1fX79yz5TbfG6jBZqgMnCQQp3R	2	3NLyWnjZqUECniE1q719CoLmes6WDQAod4vrTeLfN7XXJbHv6EHH	1405	867	1	1	4	jx98RBFA7dS1wf5rS6pFt1HX4SUPVTUjSj2ji6Ab87hCY7a8XRh	3	2	2	1615939560000	canonical
4	3NL9qBsNibXPm5Nh8cSg5CCqrbzX5VUVY9gJzAbg7EVCF3hfhazG	3	3NKd5So3VNqGZtRZiWsti4yaEe1fX79yz5TbfG6jBZqgMnCQQp3R	80	1273	1	1	5	jxw3wNhAUhyVT4AK4dGxtn4Kpx6pvk3AXVoi2A6BAEQweyV8Uwe	4	3	3	1615939740000	canonical
5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	4	3NL9qBsNibXPm5Nh8cSg5CCqrbzX5VUVY9gJzAbg7EVCF3hfhazG	1477	1350	1	1	6	jwrUXdDdGkJ7xA7vd2s3sjhE4JR3jfxs2AUNKUYaDc83ZLJ6iCL	5	4	4	1615939920000	canonical
7	3NKqRR2BZFV7Ad5kxtGKNNL59neXohf4ZEC5EMKrrnijB1jy4R5v	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	1406	1393	1	1	8	jxqrHaBcJzZAPW2rSa84chAxEHW7ot2GbqmRsWuNhwctZ8TFA2K	6	5	5	1615940100000	canonical
6	3NKqMEewA8gvEiW7So7nZ3DN6tPnmCtHpWuAzADN5ff9wiqkGf45	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	1503	1277	1	1	7	jy24pVnJM6khgDRERUMbK8UPwGHUQggX55xeBinb3vQv4inHzXs	6	5	5	1615940100000	orphaned
11	3NLGcwFVQF1p1PrZpusw2fZwBe5HKXGtrGy1Vc4aPkeBtT8nMNUc	7	3NKqRR2BZFV7Ad5kxtGKNNL59neXohf4ZEC5EMKrrnijB1jy4R5v	1637	816	1	1	12	jwFtwfnhd2PDb15c23uVgNqjS3PNVWP4HpZzYSVGQAv64Y2bdV5	7	6	6	1615940280000	canonical
10	3NL7dd6X6316xu6JtJj6cHwAhHrXwZC4SdBU9TUDUUhfAkB8cSoK	7	3NKqRR2BZFV7Ad5kxtGKNNL59neXohf4ZEC5EMKrrnijB1jy4R5v	1406	1393	1	1	11	jxYNAauXskqWQiwdNjomSFMepSwYHrgeBvFhhGRL1D8wFUVb2im	7	6	6	1615940280000	orphaned
12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	11	3NLGcwFVQF1p1PrZpusw2fZwBe5HKXGtrGy1Vc4aPkeBtT8nMNUc	1581	778	1	1	13	jx4nLzztQxDvRLTShNX355STsSbFxXkD1NVFJ1acTfUWNr9W2Ap	8	7	7	1615940460000	canonical
14	3NKknQGpDQu6Afe1VYuHYbEfnjbHT3xGZaFCd8sueL8CoJkx5kPw	12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	1656	1097	1	1	15	jxQnxih5zyWLVHxi5n79Af65Gcib78BpmYRxPDeHJaGXyRAh8Du	9	8	8	1615940640000	canonical
13	3NKK3QwQbAgMSmrHq4wpgqEwXp5pd9B18CMQjgYsjKTdq8CAsuM6	12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	1503	911	1	1	14	jwD8YdaprwhpRV8Ki6q5dSSnjPh9UmDjcfpuBP9eqZ8p1S9jvoW	9	8	8	1615940640000	orphaned
15	3NKYjQ6h8xw8RdYvGk8Rc3NnNQHLXjRczUDDZLCXkTJsZFHDhsH6	12	3NLVZQz4FwFbvW4hejfyRpw5NyP8XvQjhj4wSsCjCKdHNBjwWsPG	1652	1315	1	1	16	jwWgD8vcJfT3a17v99jifctcCjSVFQU29uTeE8X5xL26vrz64QL	9	8	8	1615940640000	orphaned
16	3NKGgTk7en3347KH81yDra876GPAUSoSePrfVKPmwR1KHfMpvJC5	14	3NKknQGpDQu6Afe1VYuHYbEfnjbHT3xGZaFCd8sueL8CoJkx5kPw	1406	1393	1	1	17	jwDQkke4fjVcxy91DR9cMd1z4JbWfhJK4RaWMpEcyW8QDWSmg2R	10	9	9	1615940820000	canonical
17	3NKHYHrqKpDcon6ToV5CLDiheanjshk5gcsNqefnK78phCFTR2aL	14	3NKknQGpDQu6Afe1VYuHYbEfnjbHT3xGZaFCd8sueL8CoJkx5kPw	1577	961	1	1	18	jwee36gWPsQS2iEu26QixkjaWVvE4Q8vC9B1jVwkFYWyboFittA	10	9	9	1615940820000	orphaned
18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	16	3NKGgTk7en3347KH81yDra876GPAUSoSePrfVKPmwR1KHfMpvJC5	1579	1023	1	1	19	jxZVWjsyuQkPVSj7ZbqC8PPx8FXzHQjxUYA3bhvdnQQZ15jn7mR	11	11	11	1615941180000	canonical
19	3NKkJDmNZGYdKVDDJkkamGdvNzASia2SXxKpu18imps7KqbNXENY	18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	80	1027	1	1	20	jwVZUkFNgb5fBf6ZRBtYXrwWs32erEyPTLXzdduGNhH6F71wjan	12	12	12	1615941360000	canonical
20	3NKDpimRQtNPUz8PPwSZVFL7kK83itXDaxYou1sZzYscqmJNNetD	18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	1405	881	1	1	21	jxR1Fsbf8HthWBisdMr2H9ZHjRyo8owy7aZd8Lp19r7poEhF7gF	12	12	12	1615941360000	orphaned
21	3NKaUU9un6G7XgnN4P2Gprsx1NmjUWncHskDKSCn1uyzD44CWsP3	18	3NLMeYAFXxsmhSFtLHFxdtjGcfHTVFmBmBF8uTJvP4Ve5yEmxYeA	1647	845	1	1	22	jwgMw1bmnJxWs5mPW7pM5fGKkUPjk3gzWPFMZriC7idS425569C	12	12	12	1615941360000	orphaned
22	3NKXzc1hAE1bK9BSkJUhBBSznMhwW3ZxUTgdoLoqzW6SvqVFcAw5	19	3NKkJDmNZGYdKVDDJkkamGdvNzASia2SXxKpu18imps7KqbNXENY	1406	1393	1	1	23	jwoM6sfB6wgGKd8Jtqj2u3dNu8t2fQ2eoMfjEiEyQP5yjdKHcxq	13	13	13	1615941540000	canonical
23	3NKHEHXsScTUd6kMDtoB4tf45MavdXv91qo3HZkLKrkc8XpX5CDv	19	3NKkJDmNZGYdKVDDJkkamGdvNzASia2SXxKpu18imps7KqbNXENY	1513	1133	1	1	24	jwWEndSF3zitf5Lpa1gTpoxzNKQVoQEpFbjQdqXC8PSW9BAh5av	13	13	13	1615941540000	orphaned
24	3NKDTKbWye6GcdjRu28sSSUgwkNDZXZJvsVZpXAR4YeawhYLqjtE	22	3NKXzc1hAE1bK9BSkJUhBBSznMhwW3ZxUTgdoLoqzW6SvqVFcAw5	1656	1217	1	1	25	jwGs6WcWBfbCQ2imLiTMoCooCmr6wAsPeoJNsECuMQXyGBN1RM7	14	15	15	1615941900000	canonical
25	3NKkVW47d5Zxi7zvKufBrbiAvLzyKnFgsnN9vgCw65sffvHpv63M	24	3NKDTKbWye6GcdjRu28sSSUgwkNDZXZJvsVZpXAR4YeawhYLqjtE	1671	999	1	1	26	jw93aP6yFRU2zCeqMddnTcrX1xRM5aQdwTGjLTNSVKKp6XBhUVr	15	17	17	1615942260000	canonical
26	3NLLdKZxuwxPVax8VLCx6sqKYzRvT1cT2vQ1MqHD1pCSktj4PinA	24	3NKDTKbWye6GcdjRu28sSSUgwkNDZXZJvsVZpXAR4YeawhYLqjtE	632	1256	1	1	27	jwNWHTfwSUH9hNbH3sV79ceNzX8U2iTeBG94DsSFQHbjTAXGP6q	15	17	17	1615942260000	orphaned
27	3NL1sy75LXQScPZda2ywNmdVPiJDnYFe5wV7YLzyRcPVgmDkemW9	25	3NKkVW47d5Zxi7zvKufBrbiAvLzyKnFgsnN9vgCw65sffvHpv63M	1637	816	1	1	28	jxtnyRqHcpQACg2XW4tcQP98Wuj6PNjEjUdY3xkrPQ4x7qQWxo3	16	18	18	1615942440000	canonical
29	3NKDWsSnHUHN6iakRuBY4LcNou8ToQ3jHpMWkyp6gposjjXC6XUu	27	3NL1sy75LXQScPZda2ywNmdVPiJDnYFe5wV7YLzyRcPVgmDkemW9	1476	1371	1	1	30	jwKNCo1RwEBmyEZ5K2Wh96q7ptyE9H5MPetZq7Ub7Ku43YwbTjT	17	20	20	1615942800000	canonical
28	3NKtGiwd1kg2r5Vx7qJ666H8PYkRaG8DTsrKz3DLz7quZkic2zVH	27	3NL1sy75LXQScPZda2ywNmdVPiJDnYFe5wV7YLzyRcPVgmDkemW9	1503	1277	1	1	29	jx2WFh4hpCpFzaoMba888AtBXLQwbY5hQfxKpw5NbNwspYSqPS1	17	20	20	1615942800000	orphaned
31	3NLZhhUTMGiWe9UYxY8aYHvRVSoKJTHgKJvopBdC2RA9KisGfPuo	29	3NKDWsSnHUHN6iakRuBY4LcNou8ToQ3jHpMWkyp6gposjjXC6XUu	1634	1085	1	1	32	jxafAkere8pbVuReH5VZMNqz8qPduVUwRyGAAGF6aQmgCUP7HVu	18	21	21	1615942980000	canonical
30	3NLJq2sfiVtNWSsYHkgJAy2MREmDKc3bD4g24Z5c4Rs8MjW7xwzC	29	3NKDWsSnHUHN6iakRuBY4LcNou8ToQ3jHpMWkyp6gposjjXC6XUu	1403	824	1	1	31	jwF8dqux7ehhgCUvBdy6nhzt5394dhZJ7g4sGgTLELFHUboc6EB	18	21	21	1615942980000	orphaned
32	3NLEu5K5pmEH1CSKZJd94eJatDTM3djoeJTVE3RkcNztJ4z63bM6	31	3NLZhhUTMGiWe9UYxY8aYHvRVSoKJTHgKJvopBdC2RA9KisGfPuo	1406	1393	1	1	33	jxhmxNsVfao1SSdzuoacnYvBBQeB4L7tJouANagaXRVg9sQ3tJt	19	22	22	1615943160000	canonical
7252	3NKMgQ9Edyry53TFBU1YtZiV1b9SxKTF5nzuvCCteRCpYynzqMir	7251	3NKb9fdwkyArMmgbVCvMZNXJReTakeKBGN3YYZvotGJ73yV3SzM7	1407	1395	81	1	6301	jxc9nXLwKbLnJLEqedGPxbVc5nLKeDS7J9GpxyEXiUCswoZ4WEE	3750	5298	5298	1616892840000	canonical
9612	3NKGnUPFUjFteYDsN5KVGvDw4pzeaPdgSudrPDvjjpvjDPSfVTSo	9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	1611	1341	122	1	6301	jwVbJ8E3o1FeN4k74hvLFHuRy6gc3sEvAuhKHRaUV31dwmh1neJ	4987	7017	7017	1617202260000	orphaned
33	3NL7a7hz1wBwSyebWJ7CLvVPVPreWc5G7yoySrNmhtGaRuFV74hi	32	3NLEu5K5pmEH1CSKZJd94eJatDTM3djoeJTVE3RkcNztJ4z63bM6	1406	1393	1	1	34	jxyyWuhkAiZSiEzTNqe7j6S4dqBphSQhS8ffEZ1cjb7WQ1YiHz8	20	23	23	1615943340000	orphaned
35	3NKZ6DTHiMtuaeP3tJq2xe4uujVRnGT9FX1rBiZY521uNToSppUZ	34	3NLPpt5SyVnD1U5uJAqR3DL1Cqj5dG26SuWutRQ6AQpbQtQUWSYA	1474	1329	1	1	36	jxmr2WKiGk3bi4yNp46RMWAppXJsdhafYi6Rwhy5y4t1vKunvMg	21	24	24	1615943520000	canonical
36	3NLHt6ojM9EWVE5MgZ4YjZ4bjEuzumZCfE6csRWWihC7pHmv8jW4	35	3NKZ6DTHiMtuaeP3tJq2xe4uujVRnGT9FX1rBiZY521uNToSppUZ	1460	376	1	1	37	jxKqFF5iBTxtmPbeWZsmqUek485yWArtL5rX9NseNu5BhVCSBCJ	22	25	25	1615943700000	canonical
37	3NKbWvjyJgCkAPm3T6Q5qNJxQsuVFqTw9fd4TzhmUAjFizJ1XTCf	36	3NLHt6ojM9EWVE5MgZ4YjZ4bjEuzumZCfE6csRWWihC7pHmv8jW4	55	509	1	1	38	jwUaJ45BU36DrWwSAT6zTvfYTL38imKVDMps9ryY88FG1WuBpoK	23	28	28	1615944240000	canonical
38	3NLmTNxxLQ9YvdRgwgTTw67DkEHNkD7BxukW1cWemkhWKqdzCPE6	37	3NKbWvjyJgCkAPm3T6Q5qNJxQsuVFqTw9fd4TzhmUAjFizJ1XTCf	1407	1395	1	1	39	jw8gMXbxvHzkq95BodwDTheBfzTCHqKy1P5k1Djuaze45jB6u3G	24	31	31	1615944780000	canonical
39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	38	3NLmTNxxLQ9YvdRgwgTTw67DkEHNkD7BxukW1cWemkhWKqdzCPE6	1607	1102	1	1	40	jwnxMJTRc79MUqpiX9bKFfcsnBQS5a4ncwhU1HrMxLpawN2kjry	25	32	32	1615944960000	canonical
40	3NLVctcthSLkPTjZ9ZPdmfqeD6grbXPAYRRFWkkKFnxw3f6svKPj	38	3NLmTNxxLQ9YvdRgwgTTw67DkEHNkD7BxukW1cWemkhWKqdzCPE6	1619	909	1	1	41	jxCXECybgUm3z1ibN1tERHJbWQedB4fQuGGzDJ8m4SZiVDJPDr9	25	32	32	1615944960000	orphaned
41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	80	1273	1	1	42	jxHSh5orES6maFGFacDW9hEtgn6SGyMbb2cA3Pk2QAUnrqwctMc	26	33	33	1615945140000	canonical
44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1407	1395	1	1	45	jxNBCzxPKpqd4nDSREDgMvniuW8rj1gPDAJtgdPitaDT2KuGwJc	27	34	34	1615945320000	canonical
46	3NKsxA2WUYgmXM6WE5Qk7xRDPipsfBtqcdeVU2k7UcyGzQwm6sRJ	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1406	1393	1	1	47	jwHwjkkCHwWox3KhDW3T83Ps2i9VeRN4Jpv9Stx3HEsewqeJo3k	27	34	34	1615945320000	orphaned
47	3NLE9tTNvK9smvS16afzMhiYdAW5YZkqzQRHLoxpxcHHJ9Gr1LDh	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1553	776	1	1	48	jwDutueBB8KzMjt8VjqwRgP64aP92uDKAfvUZoq28Sz5HVsG3GT	27	34	34	1615945320000	orphaned
48	3NLwyF8poBuv19sfzVH7Pyc47TabSdzPK3TfbnJamS9yNyWkkAxo	44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	1447	1099	1	1	49	jx3PqUmEDxm1JKvsp2wAisb9zCMndJx8h9Kwixrr9yUT4RJRZB3	28	35	35	1615945500000	canonical
50	3NKaYKL5hUtGo5RSKxCtNYzEYaMYe658157az7Nk2T7Phr1oarAh	44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	1547	1132	1	1	51	jwikZFY3v82BeNPxhyNo4MXCrUMvSpFwmDEvsToYh6bi3d8WVzf	28	35	35	1615945500000	orphaned
49	3NKGvigwGX8B95ZepxgcgXYJ5FtBkVmexqApb9KfSs2Si5sqdYFC	44	3NKgxWDjLCiUopApJ1TBN6GoJAw2c77JCAiLun78Q3rTE6dPNUTJ	1546	1339	1	1	50	jwnizex29ZSUE8wdH2BK3jQbTa8S28tgvVvUFomWRpW1gUVJBQq	28	35	35	1615945500000	orphaned
51	3NKLdj1Mmxmmn5tGUALomRwXmFdg4UkPDGqWrxSbWyT3vxcJ4sM8	48	3NLwyF8poBuv19sfzVH7Pyc47TabSdzPK3TfbnJamS9yNyWkkAxo	1546	1213	1	1	52	jwAB49n5jJs1yriuVSfFXaKY7ory9Kf3WWsTwbHxfqibnwZmcdw	29	36	36	1615945680000	canonical
52	3NLsuVoPLnRzdzjrdFKWmkqNzqNEQxrfa7iQMwu1WxcstZjmorUs	51	3NKLdj1Mmxmmn5tGUALomRwXmFdg4UkPDGqWrxSbWyT3vxcJ4sM8	1406	1393	1	1	53	jwDsm6EkFKk5XuAR1x92iMqPEzonGuWr2BBAX2BmL5235wD2CmG	30	37	37	1615945860000	canonical
53	3NLpGhdRifLr31DGc61jUhsAdZiTy7EUw8cap41jrmzbTem5hc3V	51	3NKLdj1Mmxmmn5tGUALomRwXmFdg4UkPDGqWrxSbWyT3vxcJ4sM8	1559	1107	1	1	54	jxJZY8GVkta9jV21ipS2tyGKxFJUwF3msqRRxuGGYoaw26cQs3b	30	37	37	1615945860000	orphaned
55	3NL7yV9h6ihis5BQEYoLF2ewR31NJZNamo3L71HZwEBa7MLyQiZ3	52	3NLsuVoPLnRzdzjrdFKWmkqNzqNEQxrfa7iQMwu1WxcstZjmorUs	1573	952	1	1	56	jxL5ENQkKBishdQMpo9SKdxUENiGLc1B9NfA7fG4Q6Eh5Ls9GiS	31	39	39	1615946220000	canonical
54	3NKQzfWDJSQkYrNC61nrMqMgJiVvrsvyF2e8Xtx18Vt4LvbasE9Z	52	3NLsuVoPLnRzdzjrdFKWmkqNzqNEQxrfa7iQMwu1WxcstZjmorUs	1403	824	1	1	55	jx7T8En89gQUHXBRtLpCBNedBLWkerFzpbgJ2gER2sNjmYffgMV	31	39	39	1615946220000	orphaned
56	3NLjXoZKCxt9JooK7typwq8WpayWsnLjGwgPHNPGW3Dpe6hbzNbG	55	3NL7yV9h6ihis5BQEYoLF2ewR31NJZNamo3L71HZwEBa7MLyQiZ3	1602	1369	1	1	57	jxrRGoEaXBVaSajW7K8d1YmU39Qv7k1kziwo9WNDJ81SKeWUvD2	32	40	40	1615946400000	canonical
58	3NLWKJycMJbbVFgsedUj9hAKF7QzUcfoxBSt6K4eHzQ8B37xRwQ3	56	3NLjXoZKCxt9JooK7typwq8WpayWsnLjGwgPHNPGW3Dpe6hbzNbG	1648	918	1	1	59	jy37nJKPgpBDaS3ZfFfjAz9BDBCtBG9Jr2dykkzyab5tdWKKmmV	33	41	41	1615946580000	canonical
57	3NKREKrhaAzKrpaC5JTD9oq5idtUsfZ9BWugaNbMGSngAon6VchZ	56	3NLjXoZKCxt9JooK7typwq8WpayWsnLjGwgPHNPGW3Dpe6hbzNbG	1447	1345	1	1	58	jxqcLumdg9ennsTrkzxEfeCpM2JYjKFd1xo5CchXUpeaXoMTMtK	33	41	41	1615946580000	orphaned
59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	58	3NLWKJycMJbbVFgsedUj9hAKF7QzUcfoxBSt6K4eHzQ8B37xRwQ3	1406	1393	1	1	60	jwgvRFXTJ5NmdDf27wx1mgf1kiMzGXxc85Jnx5dTsLZJDZwNXjU	34	42	42	1615946760000	canonical
62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	1631	794	1	1	63	jxHfzJxavps5hFRcweor4KX1chjnNgYnKuKgt6bCkoy7ke5ZBEH	35	43	43	1615946940000	canonical
60	3NKF1TaV6jJc1sLVqMEKuWjTksDbYBFvMuCx7UTf5FJQjy77Gc4L	59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	1406	1393	1	1	61	jwcnWYriawp31Z6TWHrVZx7GZce1gNT77fiXoRfzXLqm7tQyt1c	35	43	43	1615946940000	orphaned
61	3NKY38U72tAB4Tt2yLM6isEoyrJFDmDPUCGL5uf2gS8Zx19jCoRx	59	3NLDkubfQTYggeX6sAdVVJvmUxP1Dc3WF5vQLA5mwyMrFUeu3rGv	1587	1357	1	1	62	jxDZKRNDKqWme1QCWWdq2G1L8YN3z4FGUGGUhbaQkpWC1VTZrye	35	43	43	1615946940000	orphaned
63	3NKPeTYgM1vUrF7wwa8fwVPE4UeqYEFxBURKGWiWHSwfbUo9pZvb	62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	1444	1381	1	1	64	jxGsnsRXWuyD1nrWKaUW2B8VXi4qLVR4ooudezkd6hxwcmdc8fJ	36	44	44	1615947120000	canonical
64	3NK67TjTno1bN7H1uKV5B2ZaCyAua8dvBGMkKRVtquaTck6La91v	62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	1407	1395	1	1	65	jwVppRb4sh6dF1zeohRgZQJG2z9u2Bmwj3QFjn3WAVBH9YtoFhu	36	44	44	1615947120000	orphaned
7254	3NL8S4Ef4BUEujzRzPh5Q4mjEiwEJKCpHyYN6qSXJgyNiHexmwF9	7252	3NKMgQ9Edyry53TFBU1YtZiV1b9SxKTF5nzuvCCteRCpYynzqMir	1529	1316	81	1	6301	jwgMxiWDSrNEoHu3zRGyjvmsYA4Nx5A6LP3i4TsSW5gNsgdmTMx	3751	5299	5299	1616893020000	canonical
66	3NLxk2H7EsMu9sg3CnZBnzGvwzdMcn4npFGS2LBF41cvVZnnQ41S	63	3NKPeTYgM1vUrF7wwa8fwVPE4UeqYEFxBURKGWiWHSwfbUo9pZvb	1654	1094	1	1	67	jxsmtoHcPt8vmtdaBdJH2nmQzSnpoUGf4UasvA7XpHz82GJWnKJ	37	45	45	1615947300000	canonical
67	3NKmJGt3kDyafEHnF6JamW5hdtwJgVytKkYpH6tFkmUyYePPKrzM	66	3NLxk2H7EsMu9sg3CnZBnzGvwzdMcn4npFGS2LBF41cvVZnnQ41S	1406	1393	1	1	68	jwUjxoK5Jh9KJHWQNWA1y2cEnE2u8YVQYznNB4F6fdR98uxHJer	38	47	47	1615947660000	canonical
68	3NKHRjmpWr3HTbTNfVXUS6cNtM7gdHvVzojRGxsh428eP3kS1N3t	66	3NLxk2H7EsMu9sg3CnZBnzGvwzdMcn4npFGS2LBF41cvVZnnQ41S	1483	1030	1	1	69	jxh2d8M2bstEMSXFYd9UyxYTmRM8XHcMDV95KLUtEQpVPgwpwAe	38	47	47	1615947660000	orphaned
69	3NKwuqkJGrJRKJg3nUwjK6YnJ4aftExS3ZuMbHSjhEPc1oxtUaSu	67	3NKmJGt3kDyafEHnF6JamW5hdtwJgVytKkYpH6tFkmUyYePPKrzM	1483	275	1	1	70	jwrVmU2zshURS9z5FFQbCkYx7gwj2kbfUhpqNHr9M11yTp3D4CX	39	48	48	1615947840000	canonical
70	3NKjssd1iCRU3aQPdi6o4AueRiaSMVk8NhVw48DSMQzBwrexCnDr	69	3NKwuqkJGrJRKJg3nUwjK6YnJ4aftExS3ZuMbHSjhEPc1oxtUaSu	1407	1395	1	1	71	jxgTsrrr69sy5XMaECcM3F3fnveD1YZizHdWTdNQekhD1YAQoaa	40	49	49	1615948020000	canonical
72	3NKd8FSjqsZzaTK4LDvBEaafS5X36VipWcydr4HaYwtt84kUZeFd	70	3NKjssd1iCRU3aQPdi6o4AueRiaSMVk8NhVw48DSMQzBwrexCnDr	311	941	1	1	73	jxRprdeMkwgZN9u3amjFn2LrnSkPFD4tmCbSrPkrpiqntpD92vM	41	50	50	1615948200000	canonical
71	3NKEsy4j1ZQLMGZAJt7q2e3tMoFPJ6UudGga3CmKZnoSKEHnmq2g	70	3NKjssd1iCRU3aQPdi6o4AueRiaSMVk8NhVw48DSMQzBwrexCnDr	1596	1363	1	1	72	jxo8mMqocJ1Jcm83JLN7B3HR2ZxSxqDb7Rccsut4Jmz3CxD21JS	41	50	50	1615948200000	orphaned
73	3NLuesuqs8NoehpUnNouzr6ArcmQcnjQhJaGsPfHMpT7BQZD6erj	72	3NKd8FSjqsZzaTK4LDvBEaafS5X36VipWcydr4HaYwtt84kUZeFd	1622	1110	1	1	74	jwEvJh6shAEEqxHv2nK3zykQfh9MNo7nX5F7dJJA13xMinrfmkj	42	51	51	1615948380000	canonical
75	3NK8xY5aCcBj7zVLk1DZRiw4NVsrqwQHNey5V8kDw3bYCuN6S3zR	74	3NLAgYAh6UdzRsDKwzYKegdEoB71u6s5z9Kh5gejGQGquchy1qoN	1547	1012	1	1	76	jxamcWH8ZELLnaYEDVdxnQ7yp2J2EQUaBFrbNZoLs8qtsZiSsQ9	44	53	53	1615948740000	canonical
76	3NKeRteEV1i2C4duGWB2YKYQvfD4mGUinLceoxxJz7K1pM2tPAZU	75	3NK8xY5aCcBj7zVLk1DZRiw4NVsrqwQHNey5V8kDw3bYCuN6S3zR	1613	1349	1	1	77	jwVqLsDbPSk5nGfnebop9h3KYo8VGHQiLcLDj8CQ6YEUiPfiZBw	45	55	55	1615949100000	canonical
77	3NLa3ZxXMMqrBUjqKbsSeuCPLABnrTBj9rapDNxYQEKGfokg8D5r	76	3NKeRteEV1i2C4duGWB2YKYQvfD4mGUinLceoxxJz7K1pM2tPAZU	1458	1197	1	1	78	jxSvZbSNN2v6cPmWx5YXMPbLLg16xu8DCXHqDWQMh4qkDzrvBAu	46	57	57	1615949460000	canonical
78	3NK7dbrMhBb8ittPPh86yR9Ym3ox9VdzYgPtgm6evdcgyPBCDiCL	76	3NKeRteEV1i2C4duGWB2YKYQvfD4mGUinLceoxxJz7K1pM2tPAZU	1623	839	1	1	79	jwFg6PoWdVx6y1Wrk358Ew1Nw8tRnZVpK4JPyj8JdL7Fg6axYtk	46	57	57	1615949460000	orphaned
79	3NKdPZWJtwYTY6mpeTEgf2RbfLaJTV5HoAYy3GZcvJJ2cE8qTRVp	77	3NLa3ZxXMMqrBUjqKbsSeuCPLABnrTBj9rapDNxYQEKGfokg8D5r	1649	1257	1	1	80	jxwSP6uwv6mdmT7P7MPxLnVjxvakDjNTVJpi33nA8EWWUFdKE4e	47	58	58	1615949640000	canonical
82	3NLJeP3pBr2UFgLZpNgwKEw37UeYEsyuP63U9A3Q8D8ATBStWw6Y	81	3NLoHwSAML7FfGQLiEF4Fz4D2P1uaYZ3u5hwwGjBx8ELRqZyTcG1	1542	1304	1	1	83	jxKMWHWCvoWYfxTpZrmsBcUKBQg6n2oGX54FTuBMk4f9QtEMZhD	50	62	62	1615950360000	canonical
83	3NKGCTXDCGafAtsnFWHWMLqPCAt5Q1DKyeKasaG6T6NPdTtQ44CD	82	3NLJeP3pBr2UFgLZpNgwKEw37UeYEsyuP63U9A3Q8D8ATBStWw6Y	1624	1334	1	1	84	jwRWsaQRr8gyfXV2jTistQZNSQwCzJxa2tW8UzgyjSbKzokdP31	51	63	63	1615950540000	canonical
84	3NLnsYgXCrsFN64KSpKXFP21WMTY1PvCeeBjyfc8X6BmBecGLdLH	83	3NKGCTXDCGafAtsnFWHWMLqPCAt5Q1DKyeKasaG6T6NPdTtQ44CD	1407	1395	1	1	85	jwyteL9nypaLGUybdPptduyg5BhmW1YWrQYhFsK4SBdDAUsmc9T	52	66	66	1615951080000	orphaned
88	3NLH1Waj2ujVpbfFRrJJbgAkBVsLCEEkv84GKZezd3PA6UQxr5D1	87	3NKxn9iD4s9uJ6j8ut9YMtVN7JRaC8o14k4AKvauCSguGksFoX6Y	1422	1091	1	1	89	jxXxZQDAVFiFaYWar3uHDC365AUHG6wC3zD5Pjeq93ovKb5WPuo	55	70	70	1615951800000	canonical
89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	88	3NLH1Waj2ujVpbfFRrJJbgAkBVsLCEEkv84GKZezd3PA6UQxr5D1	470	470	1	1	90	jxzyigj6bBstAb61G4kJCpfZs6yHrD93sJdNWVzqq6j9Bk28f72	56	72	72	1615952160000	canonical
90	3NLuaJ8A7ubV4vFtc6YtnPUaMpiKAks2d7HmXByH6NkRS8EKG9Q8	89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	1406	1393	1	1	91	jwSgRBkXhc79WMaek6Dyo2ZQFXkYtN6A1VWZCRZ49GegHSNN5i8	57	73	73	1615952340000	canonical
92	3NKRrZouMYCKo9WppHm4j8EgjPBMCPXJg3d9dCoinUVWgQwMbUX6	89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	1578	930	1	1	93	jwfWnB9T8emHW4ix3BHFoVFJ7freykdgP1KqPTGotXAhn4YPjrj	57	73	73	1615952340000	orphaned
93	3NKYGK7R7TJP4vHNifuZYUJygoikskpjKULVWjKur9wRMKE7obNB	90	3NLuaJ8A7ubV4vFtc6YtnPUaMpiKAks2d7HmXByH6NkRS8EKG9Q8	1489	1380	1	1	94	jx7sVUMpH37FtqtZohESoPtWRYbmEEaUneTdgLPt1DUQCa6uPq9	58	74	74	1615952520000	canonical
96	3NKu5MoEy2xvRMpKCg5FYVJ13paiFPzM3cuof5qr46v7XfXuRAdg	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	1527	1293	1	1	97	jxnYeqGnNAGpB2w6CB2S5dTs5yNdbBJ1cSwyFRdFvoKzjrN4AS2	60	78	78	1615953240000	canonical
95	3NKP31VbUuudpRoCkyXhd1DNNGW5Y67AS5kED62whs9WwvAXQjGa	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	1542	1058	1	1	96	jxmodA75noneHFiXMDj64Wdjb4dV6F7abwZ2WVTxtE1pEvE2PZh	60	78	78	1615953240000	orphaned
99	3NL6SMuZKjUrWYLoayQrRmsFbFzwfAp7WZydHkXaGakTzNqBkkNv	96	3NKu5MoEy2xvRMpKCg5FYVJ13paiFPzM3cuof5qr46v7XfXuRAdg	1440	1011	1	1	100	jwBkT263EHTuQcTzM3ERFhVhmKXDPJM4f7yerDJDxh7918eD13Y	61	79	79	1615953420000	canonical
100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	99	3NL6SMuZKjUrWYLoayQrRmsFbFzwfAp7WZydHkXaGakTzNqBkkNv	1617	1162	1	1	101	jxeUmczvdhS1vv9HsPCtuJ4hWnpzFxaSm38d7GVhKW9RZUM8DbJ	62	82	82	1615953960000	canonical
101	3NKBupxvxcso3xiWQr3f4fzPJQhSh9efLJMoA49aqKbrjC3saRsv	99	3NL6SMuZKjUrWYLoayQrRmsFbFzwfAp7WZydHkXaGakTzNqBkkNv	1581	778	1	1	102	jxH7aJncfq7YfQQeUbH5JQeQ4gBDwHJQ2GNhHFmD1mWm5CYzpkj	62	82	82	1615953960000	orphaned
104	3NL3W58MGw9VD2Tjmg685KJUAPmjq7zDU37TqCcAsJ35rcJKFKJa	100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	1559	1353	1	1	105	jx9DTMz2BU8prQaGoAMoufj6bmcxuD7oU9EGwD3Ynk2b7bMbBTf	63	84	84	1615954320000	canonical
103	3NLReQ6wpqdUYKoiprFYqkmsAsK2JyU94CaR3vTphqBaNWzmdoBF	100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	1527	1293	1	1	104	jxAfJX2WF6hHFVz255LgThwozENP6oA5aBaCgojvhAo3Uvri7CM	63	84	84	1615954320000	orphaned
108	3NKMEx8HJZceqUX1h6RGrZJDKdAiYeXJ2PY2Rd17teVfQiSvvu4z	106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	1406	1393	1	1	109	jwUmHfBVHNJu8y9BSEw85S1Rx4DUnAU32DvU1wTvSgDjwuPxfUK	66	89	89	1615955220000	orphaned
7266	3NLm1M4V8u7X1LKdBfT9ZvAVWWP7L8Rpcwv6KvfvypCBuekK5Nih	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1600	1372	82	1	6301	jwus4ULKhCXuq5eydu1ojKrHQxzSQgeQ3bMmF8Vjeaj4pP2zdAz	3757	5307	5307	1616894460000	orphaned
7267	3NKF6qxs5dJHQY4hvEMhSPY42GLZPnytMK4muLPAoTMbSQmHdyho	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1460	1078	82	1	6301	jwDsRmpcjnZjWbXjmjcUxuDo7Srero7MUwPXXS1UhoM6BbASrcU	3757	5307	5307	1616894460000	orphaned
81	3NLoHwSAML7FfGQLiEF4Fz4D2P1uaYZ3u5hwwGjBx8ELRqZyTcG1	80	3NKM57jFp1XXwVyrg9SgxkEJ2zvcY3VuiCjCxXdsaBvdnPDZRmsD	152	1330	1	1	82	jwGA4SgMN3etZ2zaVy3KWGhLxNmQ7S7BFuhrHwqaMaCYLSzwRhW	49	61	61	1615950180000	canonical
85	3NLY4ci13GgX1GGkUrfTKr1Zt69U6Xj546d15nU9o1WrfHVnbosd	83	3NKGCTXDCGafAtsnFWHWMLqPCAt5Q1DKyeKasaG6T6NPdTtQ44CD	311	941	1	1	86	jwfhn5RDc4yktgM5jejQoG9Kqq8PsiBwGLVn72mb2YMfGMobJR8	52	66	66	1615951080000	canonical
86	3NKYK9ZCxE2dFqwrTHmPtvTVn5297c6ix6AP5CwR6cA2iHoTGxyW	85	3NLY4ci13GgX1GGkUrfTKr1Zt69U6Xj546d15nU9o1WrfHVnbosd	1671	1119	1	1	87	jxqRDi8NqNak9bhgxbLMsGGNSckZW29HoeZfUbMn9jS3K6f8uZj	53	68	68	1615951440000	canonical
87	3NKxn9iD4s9uJ6j8ut9YMtVN7JRaC8o14k4AKvauCSguGksFoX6Y	86	3NKYK9ZCxE2dFqwrTHmPtvTVn5297c6ix6AP5CwR6cA2iHoTGxyW	1623	830	1	1	88	jxikiDQcKQG2SozjjX1iUeRoeqWYwrGgW5UKQcicpU8gDUdKNbB	54	69	69	1615951620000	canonical
91	3NKWDr5JxnekJFpuTsz4jjnBa5VvUthh2aFdoestvmAzVS9KuRKN	89	3NLNnrR7ipdgeUwb4GfQmBnJNywgUE4mFWRwpDB4PNyRAybx9AeG	1407	1395	1	1	92	jx7kDH697fW7wHgDtaqoFGdNQMTeJB8ZMoq86uwoCA5JRnzS7yQ	57	73	73	1615952340000	orphaned
94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	93	3NKYGK7R7TJP4vHNifuZYUJygoikskpjKULVWjKur9wRMKE7obNB	369	1312	1	1	95	jwhtrWfPbqCN9yK2EB9FMLeARfaYN8a6qtfEkTY8g9oQ43UeDHo	59	77	77	1615953060000	canonical
97	3NKCdQt2pAeLqrPYxLHNs7UeusGGrTL8X6HcaFs8yJH4YAe45oLz	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	448	1305	1	1	98	jwdsK5ukwfWoXNeaeFHPtaF75NqAMsFBSLREWq8DvnkwaqsUsQR	60	78	78	1615953240000	orphaned
102	3NKPkSDMLMHxttJFbfBRoYFzYaTPxywUsYZbeiTfGAq1LJYrxgn6	100	3NLLGF8XpAiaNsgMJRkGpJF8QNi2uCd3zHBiRH7ZXmBfwkHnq73x	1403	824	1	1	103	jwqzK86vxbkdv77PBRqpEABSiYguJz2GqaqbVt4J9ungy7hh9Xz	63	84	84	1615954320000	orphaned
106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	105	3NKcqgxhZhuPohp7Lan1A1fQMf5cS7tTruEVvoiGb5koyPRJrxsJ	1405	867	1	1	107	jxikoyBzK3NZZjwKR4CJAciy9ZdVYiqwR52nLq3TC7UUCtMrZqQ	65	87	87	1615954860000	canonical
109	3NLryNvd9P4hGdzNBsZPsy1D8CMckiWP8ScWA73Ba6vW3hT2AtPe	106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	1419	814	1	1	110	jwvqnNvM88rY7w6cH1bEV1QcCn7c5TM7bAmCuXw7UAAq4KHtTgd	66	89	89	1615955220000	canonical
107	3NLxHifB9s96eUpkPgExzeKkp1vhW6Rhwv5yMqkDKHERVwpRWSvg	106	3NL8wcwzpQHUofAxuJaZytwPrRuXJ9WvzHX5isd4gFHAUpQcZj7h	1407	1395	1	1	108	jwQt6zWhvzSSbXNFA1n1EpkytmpKzusYCogC1zjzAmFxM4rZVDX	66	89	89	1615955220000	orphaned
111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	109	3NLryNvd9P4hGdzNBsZPsy1D8CMckiWP8ScWA73Ba6vW3hT2AtPe	1407	1395	1	1	112	jwhwk3p3WKhuhffx5nC2PU5cQho8ei2Ypj3KaXSpwVSUQBrF1KR	67	90	90	1615955400000	canonical
110	3NLKre9hW1wRShnnyMt3k5HYwc2GbTUivUMiDPuQsHc1dZfyULLy	109	3NLryNvd9P4hGdzNBsZPsy1D8CMckiWP8ScWA73Ba6vW3hT2AtPe	1403	824	1	1	111	jxad4XY7yReM3rLAZDDcptdB95C2wgYsCuJkfci3rLFj7ebEJXw	67	90	90	1615955400000	orphaned
112	3NLEUNSiAfmN5gohvmYuKWpB1JF84RqgKrsRUj19ybRbXx6p7ow6	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	470	943	1	1	113	jwhGXAMGKbsWyBQJQrpMFZzs9Qm8SsXfyw8W6BGPMKTwNtN8ayC	68	91	91	1615955580000	canonical
113	3NKxZfJbFLv3UoRnPUKsimRZQuzW1NaoAA3YBEqywQ4uRbftiUgd	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	1483	1276	1	1	114	jwFXRbpGsRJdHcjqBX6zBhuK1yaxfSg9KbPUEEgnz7LFqMf82TH	68	91	91	1615955580000	orphaned
116	3NLFZqfhFZxn9CWAw4dUsDnppdfRpe5zCrXSgCvUzwEDgrYTY2su	112	3NLEUNSiAfmN5gohvmYuKWpB1JF84RqgKrsRUj19ybRbXx6p7ow6	369	946	1	1	116	jwgGip1VBDsrHm8C4NWwkXJi4eSDXgRLtkHnX27gGyQBeDgJwX6	69	95	95	1615956300000	canonical
117	3NK6gZY6xoC98wTJdmfprmfWxeEU2o1mtFgKN9vh8z27LjnowLrz	116	3NLFZqfhFZxn9CWAw4dUsDnppdfRpe5zCrXSgCvUzwEDgrYTY2su	1599	1161	1	1	117	jwCKVEed8QGMy5UAb6tgmFxLRF7zWhcfnMj4aXEDQzoeKQimNFU	70	96	96	1615956480000	canonical
118	3NLLW8wvytn913FtfqvqETPfJWW9GEGqEYTqYKSriAKGXUFqqnDi	116	3NLFZqfhFZxn9CWAw4dUsDnppdfRpe5zCrXSgCvUzwEDgrYTY2su	1581	778	1	1	118	jwqtFgJAWuVXDmNMCku5Mpxb2jCtkK47yVBzzW2Nohf8ttcgv9S	70	96	96	1615956480000	orphaned
119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	117	3NK6gZY6xoC98wTJdmfprmfWxeEU2o1mtFgKN9vh8z27LjnowLrz	1406	1393	1	1	119	jwRB15pao6GxRwSruwNnFht9165izvSpzYJkxJS8NGZ6aVaxavg	71	97	97	1615956660000	canonical
120	3NLsorVVc9VmXBKmomsLBuAFYfkTcC4B7qn8BHUqakxgzMFQ9shi	117	3NK6gZY6xoC98wTJdmfprmfWxeEU2o1mtFgKN9vh8z27LjnowLrz	1522	1322	1	1	120	jx2hBbsgCkD6P3SwWR2wswb3Fn1eYRYT2WNrUXBteC2PcoUSXXr	71	97	97	1615956660000	orphaned
122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	1474	1083	1	1	122	jxkEeKw9RDhZgTBU8bkoJ1bv68wa6bp42uc2Gghh2aJ3HjXuHDV	72	98	98	1615956840000	canonical
121	3NLBQ2UBs7mb3ckrPuA7iC9PkCUxagnaJdZiyYcHiQdgDerwPPcp	119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	1656	1343	1	1	121	jy2YdNLbMyDydRCiPhs1KgVE56MFF8vvENPAgqNkeMLaiwtuE2g	72	98	98	1615956840000	orphaned
123	3NKF3gkPkEAa6Nozz3bB4fekkrMi1nXmECioJ9SjrcbF5BKK7jDh	119	3NKKJqqZovA2TnivikmkZjMtgcewSPBkXsJz5UqvwrFttMhRsztJ	1581	778	1	1	123	jwrzByauKtESeFdyT36v9HfMV7pQLzAwCEsNLJcv2BG67bMaYFV	72	98	98	1615956840000	orphaned
126	3NLhgoB9XJAma495Vkv29ghngFPzr5SppCwn2qvjZeH9EaHF65FF	122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	1593	1346	1	1	126	jxQG4FRC5ZyNnEw1dSggyf51stptQ7mTnXV9ceWPbihrrs73xEn	73	101	101	1615957380000	canonical
124	3NLRgvHYBxbxwphPTXD2ktUz4eYuycWvCwMr1UiVjEo2fAr9QPyx	122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	1571	969	1	1	124	jwxdQjHS3Kyg4NmDCARXoWoXcMJoQmNF5nGogJHmVdjozBJiNc4	73	101	101	1615957380000	orphaned
125	3NLpvnuo5PAo3TrUb75drNfkacrau2p8EzQwLLk1AmFDUpKMrsuh	122	3NLjEUEg2888QNjKyKgphTtAdwLV2tmgMycFP3nPFHmy7q9uEwmk	1523	1321	1	1	125	jx8RfaUeYKX4JUiCTgqwEnZtQnDdymM5mVz2MeXVNDws5dU3mqE	73	101	101	1615957380000	orphaned
127	3NKjAjygbeZPh3ebdjq9JfbWwn8Vj99kKkQgeh6BcS3EfajmpHTQ	126	3NLhgoB9XJAma495Vkv29ghngFPzr5SppCwn2qvjZeH9EaHF65FF	1657	978	1	1	127	jxXWfNknRhscaPzyiCtNAcTg4apipE5S7wEH75fvLuNpD5UKDBt	74	104	104	1615957920000	canonical
128	3NK4unW4nVKn8qETiSQpcez6wsLkXpU5jBgzjRcQzrmvB8GP4z1a	127	3NKjAjygbeZPh3ebdjq9JfbWwn8Vj99kKkQgeh6BcS3EfajmpHTQ	1571	969	1	1	128	jwWPS85497fNrQPBotTNhDZtde8LjAeeugBipV7hM65LRauXrzB	75	105	105	1615958100000	canonical
7281	3NL9YcdaEKRdH16cH6wUSX9o58csz38d57BMXdGAQWMDrfMkZru5	7278	3NL6xVFVUXFoiCg12f1mFowogRctw6bGRZQujpduLb7LzmTKXBdd	1500	1297	82	1	6301	jxm97VPdQ3JLwn4rHhYAhS5aNvQmDdjEQFvyhd1wCREEm6GQDCW	3763	5315	5315	1616895900000	canonical
130	3NK9UP94qo6YgZrYVS7S8BTD1uQoFDLtoyWVk3L2Cdkv6hpYyGkW	128	3NK4unW4nVKn8qETiSQpcez6wsLkXpU5jBgzjRcQzrmvB8GP4z1a	1637	816	1	1	130	jxDwEsbgs1twqRUSKcAmeBuokCtGdJnqmtmE4CW5GAnuozuNPhJ	76	107	107	1615958460000	orphaned
131	3NL1JQVhA7N68L4n5t18Mt1QQVEwox31ZWuWaLqJ3iBMs7Fu4oSD	129	3NLppkyBnB8bVJJbkkbF6biLMNcTXov4qhfY1ZxtFDXgwbnVuq3q	1406	1393	1	1	131	jxd2BLEeT1b8Wd1fERpd6VMnUbVcB5kKN3n4HdHus9Zjp1khLok	77	109	109	1615958820000	canonical
132	3NLvdt5xHD17RtjWZdarhJyE53wmP5PBefQFMd7SRumoEQazgu13	131	3NL1JQVhA7N68L4n5t18Mt1QQVEwox31ZWuWaLqJ3iBMs7Fu4oSD	1405	887	1	1	132	jwz64eFciKFiMoMzoRxuNR7TjMAQSnTxE6ULtf98WchLNpZrkb1	78	110	110	1615959000000	canonical
133	3NLVJ2NXzsHaFDVRgyqyqYrCWCNuPuxvfPC6Zu4o5CcxXfEQNwZT	132	3NLvdt5xHD17RtjWZdarhJyE53wmP5PBefQFMd7SRumoEQazgu13	1501	1360	1	1	133	jxff6W6tWhhMRjB3qis9DiH5Yb4at6cCao8LK4B6HLm4GpvzHgk	79	111	111	1615959180000	canonical
135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	133	3NLVJ2NXzsHaFDVRgyqyqYrCWCNuPuxvfPC6Zu4o5CcxXfEQNwZT	1631	794	1	1	135	jwd4QVxtgCoTFrGhvmnTT1bjFGwvPCkoZzHfLhxe542wEMYyaFX	80	113	113	1615959540000	canonical
134	3NKGCV6HQB8JxVva4fEB7EBAmmUBHHamvmazZQPDTwtMBZKDWsbq	133	3NLVJ2NXzsHaFDVRgyqyqYrCWCNuPuxvfPC6Zu4o5CcxXfEQNwZT	1542	1058	1	1	134	jw9xJFfrm7qxYCbpVGnpH3WgpXnxcmShycEusUA5d6th4JDouq9	80	113	113	1615959540000	orphaned
138	3NKNNGFf169C9B9j2h2An5bYEYwoPLHe2yB3gMEFdLAzNiAiqTeg	135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	152	1330	1	1	138	jxSzeG2J9jqWHMQNSz7XQuEn7FYh8SXYhLzaPo1RAtNvV3Vkxs5	81	114	114	1615959720000	orphaned
139	3NKmsGqZ1qf56qeso9dCeqfPu2C7dYHUECvq6nVEd2FJGWKZ8Sqa	136	3NLud5r6RmCymkHLZFTKypvyv298pkX97B1kYxSi4mnaTTctw3Xy	1474	1329	1	1	139	jx8inMpUETjjuqZvk29M7xKqSerGSvrZVXUw86kua29uQ9okqDB	82	116	116	1615960080000	orphaned
141	3NLBkBXSqcSEr27tXh9rwpWdsqrDP2b3w1o2YH8ULPhbzt4m923a	140	3NLQAAxZezvRsey98HZpTjCMRfoK7NWYzXeJNUSuncvTbrdjcshH	1637	816	1	1	141	jxmCn1mE6FDHMWHuzQqgvSs4VCf6K5iifbqJKpfAbGJPzcbcmtD	83	117	117	1615960260000	canonical
142	3NL9jBREsPPiZvzMJGXnvrJhaa274TLkz1eUYHrcmkmNmLqjbr8G	141	3NLBkBXSqcSEr27tXh9rwpWdsqrDP2b3w1o2YH8ULPhbzt4m923a	1671	1119	1	1	142	jxLWVaQvTMrrkEPU2hciY8cAnLDHQew7HSpDvSzBeBNCPGmGFsQ	84	118	118	1615960440000	orphaned
144	3NKY6THQfXZRbb6YQcxJg8Spi6Pgtj45JJHnwZsVRgvtuYAAu71e	143	3NLftXM1dfzGJwLef5NCk974CXq8oXtAaQAkkhpJZxpaBwLFiemo	1546	973	1	1	144	jwUWJnyGSVoRyvSnxWi4LukkWd6jowLESsLJZWYshFSqfn7uzN8	85	119	119	1615960620000	canonical
145	3NKFw4ZVh3rbiRDup8n2qHZmBJr5rZKvRmdHZEY3jqUUBG51EZw8	144	3NKY6THQfXZRbb6YQcxJg8Spi6Pgtj45JJHnwZsVRgvtuYAAu71e	1560	925	1	1	145	jx5633SwZxKwvR1bRCnTSDUYBsf4Fa9kRSeh71drTcoQmeiJ3Ug	86	120	120	1615960800000	canonical
147	3NKU9K29gncR4JtCP49MTaj2oGrroeB1pbn46TUQXCpEyGcrZgmt	145	3NKFw4ZVh3rbiRDup8n2qHZmBJr5rZKvRmdHZEY3jqUUBG51EZw8	1553	776	1	1	147	jxELmHiCDLoFyVdhMcF3c2xNcuGhgCy38bLPf5BcYTdKf7Y4qwg	87	121	121	1615960980000	canonical
146	3NKAJFaipEzHSUNe4mwyV1ozJJmAF9GvY5HXYR3nNW24CXmt4nTA	145	3NKFw4ZVh3rbiRDup8n2qHZmBJr5rZKvRmdHZEY3jqUUBG51EZw8	1619	1275	1	1	146	jwwB1ntwpNx8ifaYwa9cvRMmSRtmA9sGNijmLatYKRZx19VX3yB	87	121	121	1615960980000	orphaned
150	3NLdvNALUiJZvSscUoc2PJotDeFZQZZ4NSKKaH4WgjVMNPzhWrwQ	148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	1509	1320	1	1	150	jwxndatu9V3JDZ9YVaUWBo19Cs1xxJf3vX3hxkUdrwePtT2crMX	89	124	124	1615961520000	canonical
149	3NLGFikKPfBnCtmY8na47yd5SHGajzLSY6jVGT6dCzCFmCpsSV2y	148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	1546	1339	1	1	149	jxTSZReppbq61LTD3NwD6bFdft5aazeJ2rKc8H6zPbR29bybLXg	89	124	124	1615961520000	orphaned
152	3NKqFMMNG4aqRmJnTHtQdeUi9sKoKCeN6Bb2UFEdmi21oW1rmT1e	150	3NLdvNALUiJZvSscUoc2PJotDeFZQZZ4NSKKaH4WgjVMNPzhWrwQ	1405	851	1	1	152	jx1zkN5jcDKHggTgX8kt3i3y2wvwsuNJyiBjcJ9H3aZHSKBwHTr	90	125	125	1615961700000	canonical
153	3NKSWPVxC1dUg7NcsWV5vji1ZwFowU5SSLMEFPcKT6dKpCFzxacp	152	3NKqFMMNG4aqRmJnTHtQdeUi9sKoKCeN6Bb2UFEdmi21oW1rmT1e	1405	851	1	1	153	jxDnqMtg7iAP1hTUgvXRBCyMHLZx2onhB4waeN1vCCRB5zekKi1	91	126	126	1615961880000	canonical
155	3NKWsin4QitwZ78snY2cEUYG98TCAAk71uFB2pLJzXk66xNAzvZ8	153	3NKSWPVxC1dUg7NcsWV5vji1ZwFowU5SSLMEFPcKT6dKpCFzxacp	1406	1393	1	1	155	jxmzPFNgTqqhL5qE7enGSqXr6jQNkrdiEbtaEBjfgpb1uYAZ2RJ	92	127	127	1615962060000	canonical
156	3NKtRVucFdvWDNuC96KykT23Vj5fdsrRReQkSRWqZecFTCPZBwHL	155	3NKWsin4QitwZ78snY2cEUYG98TCAAk71uFB2pLJzXk66xNAzvZ8	1637	816	1	1	156	jwrKo1H5gCVyXqut2CjGdmieco5YcP5eyU9fDTknTsJmVPyrhEd	93	129	129	1615962420000	canonical
158	3NK7n6j2Bx9yCVjv2AKnfxwvwvCL9uww9mQaefkm3zyabdrcczjA	156	3NKtRVucFdvWDNuC96KykT23Vj5fdsrRReQkSRWqZecFTCPZBwHL	1631	794	1	1	158	jxfJsRMFEzg3ohN4EfiXBGxAcoYXCimh7c4BqS5UoFc2vPNQu43	94	133	133	1615963140000	canonical
159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	158	3NK7n6j2Bx9yCVjv2AKnfxwvwvCL9uww9mQaefkm3zyabdrcczjA	1457	1391	1	1	159	jx1mMFf433UeHdb6c4pPHcMvyRGsdmzEaYh7p66m49Cz7RJmPXR	95	136	136	1615963680000	canonical
162	3NKXu6Epr1PqhoJNAQkRoc7neKRm5LvVvyeVJmqFmNigWRvxDg7z	159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	1518	788	1	1	162	jwDFfqkdxSh6SNkRLEuC8kAfegUttwLZwZAJprENtj4iUNGehmw	96	138	138	1615964040000	orphaned
163	3NLgPYVDSV6y7ZKSQrjowedjZn9RuLwdx311vheWZEy3mBjKDbmj	161	3NKqUTiHax7cJjVy1sJ2hUZ1oWw4auqG8e6vMJEh4kv9L6qMWyFj	1477	1104	1	1	163	jxaJQn6oKpki6gSJfqQUEFKowD2W9ox7EDpcsbH7wXmdaCx5WDb	97	140	140	1615964400000	canonical
165	3NLdywCHZmuqxS4hUnW7Uuu6sr97iifh5Ldc6m9EbzVZyLqbxqCh	164	3NLAuBJPgT4Tk4LpufAEDQq4Jv9QVUefq3n3eB9x9VgGqe6LKzWp	1458	1077	1	1	165	jxVcdY8ZJEFhEdZCq7W94eT1XyugU6j5wjmT2f7WX7ysodZAXsL	99	144	144	1615965120000	canonical
166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	165	3NLdywCHZmuqxS4hUnW7Uuu6sr97iifh5Ldc6m9EbzVZyLqbxqCh	1407	1395	1	1	166	jwWHNKQPdgLxHCsBki57a6zBfNPUFkAQmsrCNq3E7Q8oiNCNdkm	100	145	145	1615965300000	canonical
167	3NLxUL8Mc9zEFvJ7zjWExJxuLwJmZ7meprnDYixBQr9zcEYrqJDZ	166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	1627	1385	1	1	167	jxDwUbxwEE4ZnpzZKJMZWXuue7wAmVwNdVah4PhrwecdZMqjXcp	101	148	148	1615965840000	canonical
169	3NLVwpAyDreuBDKHhyGQ9ZTXBgoed8ng5N33bPcXEDEd55T58o4w	166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	1553	776	1	1	169	jxLkw4fTR4Jgc9s2z5bJrfwb53BWvgNVoxkoAJSBWMdrnpzHuPW	101	148	148	1615965840000	orphaned
170	3NKp6WmnaSCYXceiv36cFLVLk4Zr1i8PvN65qdvwqpSTJJL8V5ga	167	3NLxUL8Mc9zEFvJ7zjWExJxuLwJmZ7meprnDYixBQr9zcEYrqJDZ	1500	1297	1	1	170	jwKaVwyiVGKRoEYvwH5M9EzDN3nq1XAbFd2hR57Sks7dPWJyMJb	102	149	149	1615966020000	canonical
7289	3NLW4Ahbb4C3gTNo752ZkMK9Jom29kGC9TgKee9qmbipAUJGkWNn	7287	3NLbBT9sN98S7BfDTTGFCuMUa875MmP1mYmkFEUuryYA9Xekpk2M	1403	824	82	1	6301	jxBMUQ3xuUaLCRNYzH81Z2SBDcCLQ3EghtMVtt2gfspjA1Vxu2b	3768	5322	5322	1616897160000	orphaned
140	3NLQAAxZezvRsey98HZpTjCMRfoK7NWYzXeJNUSuncvTbrdjcshH	136	3NLud5r6RmCymkHLZFTKypvyv298pkX97B1kYxSi4mnaTTctw3Xy	1559	1107	1	1	140	jx3bFEvSFGVeWtwHXYnDYtrveHEes3Brt2yQCEie25pqd4sj5Sh	82	116	116	1615960080000	canonical
143	3NLftXM1dfzGJwLef5NCk974CXq8oXtAaQAkkhpJZxpaBwLFiemo	141	3NLBkBXSqcSEr27tXh9rwpWdsqrDP2b3w1o2YH8ULPhbzt4m923a	1581	778	1	1	143	jxWnvVsM2HCdPrEi5E2QV6FRQWL3oWBPVr7BgPBHACvLUux9WBe	84	118	118	1615960440000	canonical
148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	147	3NKU9K29gncR4JtCP49MTaj2oGrroeB1pbn46TUQXCpEyGcrZgmt	1406	1393	1	1	148	jx8wWyUR66zWSbnEcMbXjgsQdz7bnYPJsmvmsKx33TvYnvSqbGn	88	122	122	1615961160000	canonical
151	3NLPfAvmqxN6BR9TJGni8nL1w4ZesntR35L7fZFhvVi4ze8fabf7	148	3NLHzqDoKStFtj5vd2s7UxFCrBrZrEDryZChtegHY92bynNMU2Sn	1553	776	1	1	151	jwm8FWmxy81GNWM7u123BeBotLg72SPhUFzzY7HuyyT9HLcfbVX	89	124	124	1615961520000	orphaned
154	3NLRUisuGPu1N2dQxLvC5WqCMxUTiqkwjGL1zLd6ojmkC6cNYqmM	152	3NKqFMMNG4aqRmJnTHtQdeUi9sKoKCeN6Bb2UFEdmi21oW1rmT1e	1624	1334	1	1	154	jxCj8QrQD5FoUq8R9LV8WRNWZAUm7gkze5AyJCc8PFiF2nDk7Qn	91	126	126	1615961880000	orphaned
157	3NK5zDgjQcY5g5VF74vSuHCMvkEjgjuavCNQEYqQU46d2no9FopH	156	3NKtRVucFdvWDNuC96KykT23Vj5fdsrRReQkSRWqZecFTCPZBwHL	1646	1354	1	1	157	jxLX7YV4qu8DemuSVp4F2cL6wBEP4MVoeiVN2GUijTpCeCxuNF4	94	133	133	1615963140000	orphaned
161	3NKqUTiHax7cJjVy1sJ2hUZ1oWw4auqG8e6vMJEh4kv9L6qMWyFj	159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	1652	1189	1	1	161	jxGXta8esr3FSnBvSkgAz5PMMqqVRHX4cp9fvTRjHVgbegQsfBG	96	138	138	1615964040000	canonical
164	3NLAuBJPgT4Tk4LpufAEDQq4Jv9QVUefq3n3eB9x9VgGqe6LKzWp	163	3NLgPYVDSV6y7ZKSQrjowedjZn9RuLwdx311vheWZEy3mBjKDbmj	1406	1393	1	1	164	jwZhLnqoA7gngY3F5jMf9SXEXRS76LqHt2YZkZ6e2whURiNt5ZV	98	141	141	1615964580000	canonical
171	3NK89nY6UKeDmu8g7zjeoepC1sKMAh3mXfxa5D3gdqduMfjwZ3rK	167	3NLxUL8Mc9zEFvJ7zjWExJxuLwJmZ7meprnDYixBQr9zcEYrqJDZ	1647	1176	1	1	171	jwjSM2k8x5uWzbKhkb4Lv3LepVJ79HqFGhZzU1fgRnTYq15F4SJ	102	149	149	1615966020000	orphaned
172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	170	3NKp6WmnaSCYXceiv36cFLVLk4Zr1i8PvN65qdvwqpSTJJL8V5ga	1407	1395	1	1	172	jwchntqCj9vkAiVKaspqU5Fj6CCkqRjxvM83b9uF55RnNvuo1BF	103	151	151	1615966380000	canonical
173	3NLTbzHyK2fEbYZ27UvFcDgQiqNz3a4WFhgCL4WrAV8fVXPqffXm	170	3NKp6WmnaSCYXceiv36cFLVLk4Zr1i8PvN65qdvwqpSTJJL8V5ga	1617	1042	1	1	173	jwoxKcLyC1xggvDXoPTpN67rXoJAbXQB5bY313gNMoQKncm2qRd	103	151	151	1615966380000	orphaned
176	3NLLKV4MK9g8pExnNHhwF2tv77iqr48sAArPMw4nZioFMTDcmPmV	172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	641	1090	1	1	176	jy1VoNG3LR3KJ3bwZSM63FfCgaZo7LYtbwWXUGuhdRo4N2HSn95	104	152	152	1615966560000	canonical
174	3NK8VVU7sSLSQXBqtapDUCjANfjx2BV5eZ53iMp7C6pSGY8frGxB	172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	1403	824	1	1	174	jxLwBau7BqM71kJXrS2Wxt4RosyeCbTmKSohN8hYjnKCZcCJs84	104	152	152	1615966560000	orphaned
178	3NKaedAQ1R1Az8RZdVWRu4Gt3utnZygt5HT7rdEfWSdxqafuq8ey	176	3NLLKV4MK9g8pExnNHhwF2tv77iqr48sAArPMw4nZioFMTDcmPmV	1405	867	1	1	178	jwUCphCFxihND98W4DTVn8AY331tPuVkd8QqM5mDD18Zm9jiKEU	105	153	153	1615966740000	canonical
177	3NKYXgdPvNG71Fk8tRMheg6BppRuadyPJTnuLN4eHgc6P4ncgPVm	176	3NLLKV4MK9g8pExnNHhwF2tv77iqr48sAArPMw4nZioFMTDcmPmV	1671	1239	1	1	177	jwUMYz1TqsfotTJsjmxwPbwto6ou1j8U9pcJsQ2kqxEiAiXRK7d	105	153	153	1615966740000	orphaned
179	3NLpqwrzfDE3hFCu7qmzz2JXKqcFKi8RRbtsEimcJzcWn9tjuNwh	178	3NKaedAQ1R1Az8RZdVWRu4Gt3utnZygt5HT7rdEfWSdxqafuq8ey	1458	1197	1	1	179	jxehQYq6ua7vpJZn7FG4sajNdLpA1XNzeKQd9nEewPynSwfVLw3	106	154	154	1615966920000	canonical
180	3NLUe826dj7g7cd1VgyvtV3o1tpVHbsUfvoA9yAttprBLFNHmrg6	179	3NLpqwrzfDE3hFCu7qmzz2JXKqcFKi8RRbtsEimcJzcWn9tjuNwh	80	1027	1	1	180	jwVBYMsszsCdfJjPozc6Yiyez5SvWGzVCahLux4Jt56vxjezASb	107	155	155	1615967100000	canonical
182	3NLxmqo1M4t77ig42a1C4rbQ3UERvcYPYcnmC44ncxpSSP5kDVMi	180	3NLUe826dj7g7cd1VgyvtV3o1tpVHbsUfvoA9yAttprBLFNHmrg6	1403	823	1	1	182	jwvDxECUffpSmeuB7Kt31zvNnuGujoVvFZgJxCbKnrmMZ62GzrC	108	156	156	1615967280000	canonical
181	3NKmNCCZoG4fLJuQMPfXkUvARY8qUhzaG37rpsBj9FzjgdJnuNGt	180	3NLUe826dj7g7cd1VgyvtV3o1tpVHbsUfvoA9yAttprBLFNHmrg6	1467	1130	1	1	181	jwsdoNcGFXpPDAsFzJPAYsw38RuU3G8cGWRhzJgUgh3dN4UKYqU	108	156	156	1615967280000	orphaned
183	3NKGUXQYm1nF1hdEDEzwuLRWZjBTdSeKqHfqS3JPCzJ2i31mrovV	182	3NLxmqo1M4t77ig42a1C4rbQ3UERvcYPYcnmC44ncxpSSP5kDVMi	1477	1104	1	1	183	jxEE8wKJnxLD5ySfWoH9MMU9oZP8R9bYBbdPdQ9qdwGd2QJvCtB	109	157	157	1615967460000	canonical
184	3NLGyeXGLGJfrZ6ESVNVyEMt35Kmyw3RswGjDD29eNSUJ1vhW3ob	183	3NKGUXQYm1nF1hdEDEzwuLRWZjBTdSeKqHfqS3JPCzJ2i31mrovV	152	1084	1	1	184	jwx6BgpxQiPMY8L4yV8w4x9QLzK6wdXP7rdaSu6oRnSrs8AXr57	110	159	159	1615967820000	canonical
186	3NL33j16AWm3Jhjj1Ud25E54hu7HpUq4WBQcAiijEKMfXqwFJwzK	184	3NLGyeXGLGJfrZ6ESVNVyEMt35Kmyw3RswGjDD29eNSUJ1vhW3ob	1617	1162	1	1	186	jxN9vGamS11EfAWsysPDadXMpZ37u1eJmpa5enkVHtaSUZMDLg5	111	162	162	1615968360000	canonical
185	3NLj4yaEa4kGamq93k8ZMqbiZWuR26USzzndXVGoBupEZRQ6zJjm	184	3NLGyeXGLGJfrZ6ESVNVyEMt35Kmyw3RswGjDD29eNSUJ1vhW3ob	1406	1393	1	1	185	jx4SpMv8zHZqnbV9sHQXk9BRntgst41sybLoDgV6Vw3ejMhWGAq	111	162	162	1615968360000	orphaned
188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	186	3NL33j16AWm3Jhjj1Ud25E54hu7HpUq4WBQcAiijEKMfXqwFJwzK	1651	1301	1	1	187	jw9vhPJrAw5rNJrCzBLStxk4TH6jU6chdPN7Dtx4mZUpMV82LGU	112	164	164	1615968720000	canonical
187	3NKXAsEpwmRGArLdd4bcnxYfC5q1apRHZpFGyz2aCQuLegbmFKFk	186	3NL33j16AWm3Jhjj1Ud25E54hu7HpUq4WBQcAiijEKMfXqwFJwzK	1651	1301	1	1	187	jxjzhn3rrPTT13ihkY5qEmhrmDymYKL7FJGHQpN4zCr32QHFiEi	112	164	164	1615968720000	orphaned
190	3NK528UG9QPGCiThqJgLx5gZXbm3XvLWMq8szLVNh1EJVBESLGvx	188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	1440	1377	1	1	189	jweQ1CvV1TBCVW9aAjzLmU9YQLZazTXKfJQNLqLTtaeVGRWPyZE	113	165	165	1615968900000	canonical
189	3NKAfXH5Miy4aYZbSfE37MiQSkKVdpFgfT8dMb4UaeLBhaEbgUJN	188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	1407	1395	1	1	188	jxNS378HQQSzhv9qHQUyPy8qrzyPqo1e5LwWnqCZksGRLk5gHv2	113	165	165	1615968900000	orphaned
191	3NKp5qnN5KADjnX5gRpdzuuzRxYdDe9J5yLBbyKstXGw1wE3kkVP	188	3NKTBRmBVs7VvbxazgPiYbQXk2sUfMJd4DNp7Jm8UxNic4PQy3b1	1489	1380	1	1	190	jxv5vXRP1x9zv2UHq2epiEbPEdi2JxdFdiazNBvXb1znnsp1Q5S	113	165	165	1615968900000	orphaned
192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	190	3NK528UG9QPGCiThqJgLx5gZXbm3XvLWMq8szLVNh1EJVBESLGvx	1631	794	1	1	191	jxfr6NUJnwixVesAvAhpSziyd6cU2xmAwuz2rqMAsrCeNhPWaxi	114	166	166	1615969080000	canonical
7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	1611	1215	82	1	6301	jwAbZjXD5XqQWv7uN9TSdQDytz6uR6riBgazZstEMiE4243GunF	3787	5355	5355	1616903100000	canonical
194	3NKAa5kAEvAhSRLVQZLC5iAsBbMjjY7QxpNKvd3bq4X917vFZKoH	192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	1507	914	1	1	193	jxYCfM58wB24cjUiegjHqzA6KLRWVaSqAFsvdTsmAmsrEsG419w	115	167	167	1615969260000	orphaned
196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	193	3NKxBqpTfp2PPn7rGZ51aRNyz9Npt1si8y7MXWdZrA77GAEgc1eb	80	907	1	1	195	jxMpujd6jcNeeWrKqw9FxmtGPwN4J6EzxUSgQMx6JkEzgqiK4tm	116	168	168	1615969440000	canonical
197	3NKpj5NkT4zrqAy1XPjWLe6BJuyprKEbu89kbxXxFYexabtEGKu1	196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	1668	1370	1	1	196	jxPfoF5enFiwK8oYHF25isAHiC1J7gWWyJjAcPnSpDkFdYnwWPS	117	169	169	1615969620000	canonical
199	3NLCUCD6Vbg1yvaSe4YmGPY3nwSRkdwiQdVexvSLe7xgeVZA21Pp	196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	1611	1215	1	1	198	jxXRmZnK15jwkJv3pwXVVwr51TgfWodTB3ocsxhieA5VUApx8of	117	169	169	1615969620000	orphaned
200	3NLgqwocJHbVDSionMVKw916f5kcpFyvx8JVZVyHivJW1DF4TorS	197	3NKpj5NkT4zrqAy1XPjWLe6BJuyprKEbu89kbxXxFYexabtEGKu1	1406	1393	1	1	199	jwxhq3zLGSvaSw6s5ybjEsyPMVESy9B2RSrX6n4o7g48Ln3wSqn	118	170	170	1615969800000	orphaned
204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	202	3NKrBFVpgTrkdoEGUF4JJMEN3iSKRb7aeEsjPajcMHjByb3XnLgs	1506	1373	1	1	203	jx5jYGvMJq4xhaB2VutXw3vzUy9StVcyZMB23ygi8xmNvszxk5v	120	173	173	1615970340000	canonical
203	3NKFoxsSXhZ5YVfAUWgkEh6FXdATjHgUxfjTnGtJcrTuUZavq7d1	202	3NKrBFVpgTrkdoEGUF4JJMEN3iSKRb7aeEsjPajcMHjByb3XnLgs	1642	1001	1	1	202	jwitPfMPjcmaXJP2R54MVbZm26PKf8uQhHEoy8kkpSGe34k7qjY	120	173	173	1615970340000	orphaned
206	3NL9oScSvsJgB1e7SD4XWL2fEhybHnk4cBTGYMxS5bfvWTkrrY4t	204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	1649	1257	1	1	205	jxuDyFyBtxvbYszRMV8aXrg1iniycUv9t5stTPqbjwyKct6nPvJ	121	174	174	1615970520000	orphaned
208	3NLDFJGwBMzzRhYnEmmrRxQDXGyoFqNGa4FMm1svj8NRVeZkUn92	205	3NKEm5TYpXwxqLHNqpkGWX1QAV8g43rXmcYhxKmh1CcMC3v9oZ5D	1559	1353	1	1	207	jwFVEk6k1jBRHmGYsuNqcVkAQRtTLv8cphFVAySoW8pHS3dnp5W	122	175	175	1615970700000	canonical
211	3NKGjizyLVPZiLvGHojXL1yWPuR8EHPEhStmr2aAX2FZAo596K7C	208	3NLDFJGwBMzzRhYnEmmrRxQDXGyoFqNGa4FMm1svj8NRVeZkUn92	1617	1288	1	1	210	jxGchjQ3TbJx1hq2dZGhPTcNBDv3CobTBuptpupkT8C8yx5Ru63	123	177	177	1615971060000	orphaned
212	3NLUSnu6iknwLCkkewnaHRDEFC611oCoWnxFDmjLvEkBKWcwZ3k1	210	3NKCVcMuYmNsBvjgiHBSHox4HSq3ZuwrPbGjUQTQx8SHSHFnRzDa	1403	824	1	1	211	jxyKHh8r4NLcUzNoB9TpqsmHBxbwyisgJGFvRA3QJC3aJ8VmEMM	124	178	178	1615971240000	orphaned
214	3NKMzHr2jpcHwGw2UJ4SH417ePMxPRRSLResAgUmHMguNDaYUgNS	213	3NLqqXwMZhR6ffs6PCYL67wFWn7pmcYd5qAcgTkbRzX5c7FqZm1A	1579	1389	1	1	213	jxGn37Hts5FMXuhhbpW8P3Bd2fwhWCxCWCc2TNADt5Y4Ag4Kcq1	125	179	179	1615971420000	canonical
215	3NKjyLahF2GU73KLAqAjcoZWjy4z1ek6rZ5ktLefvbc2A9EAeRqE	214	3NKMzHr2jpcHwGw2UJ4SH417ePMxPRRSLResAgUmHMguNDaYUgNS	1581	778	1	1	214	jx5KZyDKUVvo725Pc5GFFp3pBuZs7U2mNrPSgjY3mzqLyWxiHEs	126	181	181	1615971780000	canonical
216	3NKEtm8C4zwxe7zkiyd3HHiaEbUTSBZ4rV99njyH3wEznedfYY8q	215	3NKjyLahF2GU73KLAqAjcoZWjy4z1ek6rZ5ktLefvbc2A9EAeRqE	1507	1280	1	1	215	jxnvwa7kmPJLZiYEKWAXGpnERD9TH5aXSeKXGQbCePLZeWRRuE5	127	183	183	1615972140000	canonical
218	3NLcCBE6dDQisz94nbKuWBQwSZqS1kjWyygF6odLcep2aPgRcN3j	217	3NLTjXS1Ch7RHn3Pn3Zp7daoKz9RCZjdws6d5Y3BH4i79C6gHTUK	1407	1395	1	1	217	jxPv4Ww9ckXodyGUfRRnBWXS2YW4Xz17LdqZzQpQWhiyzK92GV4	129	185	185	1615972500000	canonical
219	3NLZ6GJ7WXxhF6MdSZ2C6R5aFHgxhBo2p7V9Dkh9ixTzTsvFusxD	218	3NLcCBE6dDQisz94nbKuWBQwSZqS1kjWyygF6odLcep2aPgRcN3j	700	832	1	1	218	jxaCjxmMT9zXg64vKgoLt6jG4vmSV8BkapYoVx79RNsFsY4wPSE	130	186	186	1615972680000	orphaned
221	3NLDzhZq7vwEsebgenzciaa65yWm6RsEtfphXz5WUifJNbtmBvsi	220	3NKMG7SSJEvd9pQgNYem4Sxb7pTEfTccdiTranuFNkWSWhM6gNVw	1668	1004	1	1	220	jwEUMHokJwhym8x4o1USRr3C7EbxmSGmxUGZkUVj1Gao6b7hezu	131	187	187	1615972860000	canonical
222	3NLFRCtiqeBHhaZ8RdfUWMt2qXgmM4DuQjXhQjm5e92qnVjkMcT2	220	3NKMG7SSJEvd9pQgNYem4Sxb7pTEfTccdiTranuFNkWSWhM6gNVw	152	1330	1	1	221	jw8NkxY9cDFPvK3kQdGnZ6YhSXPHs7VvVppWhMXc4URhK3qccbp	131	187	187	1615972860000	orphaned
224	3NLXj3ZwKKZbiHn7eRevQ7Qt7rK5vxSiCjo2tXJ9eEZCy4Rj8eah	221	3NLDzhZq7vwEsebgenzciaa65yWm6RsEtfphXz5WUifJNbtmBvsi	1527	1167	1	1	223	jwTYdPWZ4E2GBWiYeYYNr9Yy3ckiRFbAXpVgvgVVwiQemdCi7yP	132	188	188	1615973040000	orphaned
225	3NKzHoZtSyoeQiL61Jzc1Po6HVCnYbnXFwDoUfsBPaqz8kyuFTTB	223	3NKgNo9Z3minLdnobnXLMrEPCfLoHnSkJ7E3YKGeQESzXQVm5ci1	1610	1314	1	1	224	jwidiwmuX9WoXzZiubggPcfsUppMQkbDMjCUszkp3z9YVhLYnbH	133	189	189	1615973220000	canonical
227	3NKUHRMsozc5H8Cjazua45sVUk8QRRxAQ5a73vL2Dtychvdyn45w	225	3NKzHoZtSyoeQiL61Jzc1Po6HVCnYbnXFwDoUfsBPaqz8kyuFTTB	152	1084	1	1	226	jwSxHgkNukAJMc9RA4YRrFiGbFEknekHgrwnaTAURB1LAVWozKX	134	190	190	1615973400000	canonical
228	3NLdMZ6Xv7Ume11cX8HDvpJYi4z6paHn5dE5QcKhQyTZhJuCcu5V	227	3NKUHRMsozc5H8Cjazua45sVUk8QRRxAQ5a73vL2Dtychvdyn45w	1560	1291	1	1	227	jxfC4qeYoYhRVMTkDvgqPRqQT5ioZMx1T2trqgy4MnpSgFZkQ3c	135	191	191	1615973580000	orphaned
230	3NKPp7Yf6cY1v3KyXuWkkdasnarFKUUwXzzLwVTWYXDLDjc5ddt9	229	3NLCEWuKssvAxk6sp6pGWNftfE2U6CWmA1rDS51JiaV3tSLhtutk	1573	1192	1	1	229	jwFfBf3b3ethv1ZDcGcF2YCvCtV5Ka1pQK8Rd1q58BwQzjaaxVe	136	192	192	1615973760000	canonical
231	3NLircUtp3qoRA3j6N2HMKwkU75wGbBowP2MqmnXJ6WKwDgrSqjB	230	3NKPp7Yf6cY1v3KyXuWkkdasnarFKUUwXzzLwVTWYXDLDjc5ddt9	1403	824	1	1	230	jwH99cxJRuDzFyW4T2yWQUetRmnVcYbBodBvnuUAJ3K2hvXUhgQ	137	193	193	1615973940000	orphaned
233	3NKZhycHJVd13yGJ37ERpaTYuEiPPWsKVirMEpGmSgQ9pthejW7r	232	3NKs5hFQoWDZ47wiiGxj71Dx688bBxpuhR5BbRWmC2rGFYHB2KXg	484	1319	1	1	232	jx1wyQhUTCsdjYXYX2sGkECcjtDqx1q5dJQqDDYpnezpsgacsk8	138	194	194	1615974120000	canonical
234	3NLk8uJHrHhgnmweZr3vWNo7vM2W3P7Tp9AGt5NZgnkwNzFAWRLD	232	3NKs5hFQoWDZ47wiiGxj71Dx688bBxpuhR5BbRWmC2rGFYHB2KXg	1541	1172	1	1	233	jxCGSLYQjXsdv3KBxiMUS34DeMDkuSFZkeN3Bf3JkzocrAR3WFH	138	194	194	1615974120000	orphaned
236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	235	3NK6r5ciM4qoruuneg7xxqYCVzQzFMYSSw5H7NyNiwrg9oipSf7Y	1406	1393	1	1	235	jxGnKK9KsRQoZm5fAXsbVgqgsepJ5JWoj5SFiij2WsHEQngbv1e	140	198	198	1615974840000	canonical
237	3NKqhVB5yw7m5EFrmTo4S8FiRyivr7ZbrfDVhH4vbASGveZHZK8m	236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	1406	1393	1	1	236	jxBYvY25bETYyJ2tn1M3a188rvRUc89My56ZpKm66hye8Kr5Vs1	141	200	200	1615975200000	canonical
239	3NLQXsaXuFCSoqKzJqjfcsY5bxjFqgNtvcFHZ39eMyW3pVgwTaQn	236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	700	840	1	1	238	jxrx6iYvciardWqhXKFVWP8mkkVJfnbgK53bgQa1nUvv1L5exgn	141	200	200	1615975200000	orphaned
7473	3NLEfXZv6txVuccKGtM6E3xwaxkGRRYKuzJ29E33DE9fsSYAGHo4	7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	1673	1122	82	1	6301	jxj9CLbopeX8bqriwqwnEH2ePZrnAA2bmcB98QZshasXkjZMr57	3787	5466	5466	1616923080000	orphaned
9634	3NLn1bsWFjycHNJGGLy3KSxXSW6ixmFrunn1iym5GWjTXxkt6oFi	9632	3NKYJR1m2hFXw169JR3gUrxYv6KhG8TFRaidZJb17SXjxBChYfEG	1516	928	123	1	6301	jwfy3pPMQvnUrtpKSupvYwbx1BPDaghHhsqSd3ZVinVVx9vsKgX	5000	7042	7042	1617206760000	canonical
201	3NL4fohfZnCfm4goCS2hqxBQS88XqM6jtnaqCGAdA8aAtNBgd8Ah	197	3NKpj5NkT4zrqAy1XPjWLe6BJuyprKEbu89kbxXxFYexabtEGKu1	1541	1298	1	1	200	jx7DdKbVpawq46k85FyPAEkb5h5pmrCT6FcGjzpXbiJsbF4gGw2	118	170	170	1615969800000	canonical
202	3NKrBFVpgTrkdoEGUF4JJMEN3iSKRb7aeEsjPajcMHjByb3XnLgs	201	3NL4fohfZnCfm4goCS2hqxBQS88XqM6jtnaqCGAdA8aAtNBgd8Ah	1637	816	1	1	201	jx1SG2riCEDqdxvVzqviozestbzeDySrGqC4LvoRL1tZNM5LVFw	119	172	172	1615970160000	canonical
205	3NKEm5TYpXwxqLHNqpkGWX1QAV8g43rXmcYhxKmh1CcMC3v9oZ5D	204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	1407	1395	1	1	204	jxFBH5RyciPvdQo2TrS4yzpUCgiv9y45vdZXk9V3svje8C9z6WU	121	174	174	1615970520000	canonical
209	3NLa6WLkktrXSXBcSSSeRFV7cpf4PpiAYZpp73fZc9ZEMHxEULAY	205	3NKEm5TYpXwxqLHNqpkGWX1QAV8g43rXmcYhxKmh1CcMC3v9oZ5D	1631	793	1	1	208	jxVXdNsRmkv5SueFCfbG3GSK4iCrHDYVsL4ra6YyiH8ecSzirxv	122	175	175	1615970700000	orphaned
210	3NKCVcMuYmNsBvjgiHBSHox4HSq3ZuwrPbGjUQTQx8SHSHFnRzDa	208	3NLDFJGwBMzzRhYnEmmrRxQDXGyoFqNGa4FMm1svj8NRVeZkUn92	1444	1381	1	1	209	jxUDwGirvtVuQRZsCFijF4g734P7JZmRNLYZ5FBA35xENe4whEh	123	177	177	1615971060000	canonical
213	3NLqqXwMZhR6ffs6PCYL67wFWn7pmcYd5qAcgTkbRzX5c7FqZm1A	210	3NKCVcMuYmNsBvjgiHBSHox4HSq3ZuwrPbGjUQTQx8SHSHFnRzDa	1623	839	1	1	212	jx6Wgv2kfH5paU9m5hD9gDRSt15SrKdLuKwtVgXEysxtRyf8xMa	124	178	178	1615971240000	canonical
217	3NLTjXS1Ch7RHn3Pn3Zp7daoKz9RCZjdws6d5Y3BH4i79C6gHTUK	216	3NKEtm8C4zwxe7zkiyd3HHiaEbUTSBZ4rV99njyH3wEznedfYY8q	44	1325	1	1	216	jxAhZTu1hTh2zZSYupXfSRzAAYo94rWCHqAvHXRRSZ3dqkRHKcA	128	184	184	1615972320000	canonical
220	3NKMG7SSJEvd9pQgNYem4Sxb7pTEfTccdiTranuFNkWSWhM6gNVw	218	3NLcCBE6dDQisz94nbKuWBQwSZqS1kjWyygF6odLcep2aPgRcN3j	1477	984	1	1	219	jxvZept3WS3aV5D8ma56nvXqp6nv2RPDVHhJf5mCoGDop9jdCCw	130	186	186	1615972680000	canonical
226	3NKjYdSnZazz43mKA8NqjgKy5nLfWdELm5fTFT6gavecN9AvkX7H	225	3NKzHoZtSyoeQiL61Jzc1Po6HVCnYbnXFwDoUfsBPaqz8kyuFTTB	1407	1395	1	1	225	jwLFs9WLBPgnuQgPCAtwGaXXcXwJA8DFctAYEUCc7u5SppTSzPR	134	190	190	1615973400000	orphaned
229	3NLCEWuKssvAxk6sp6pGWNftfE2U6CWmA1rDS51JiaV3tSLhtutk	227	3NKUHRMsozc5H8Cjazua45sVUk8QRRxAQ5a73vL2Dtychvdyn45w	1601	1262	1	1	228	jwmALpJm4NB1smBTKpjau5mJuvRRZccwMboB3BypHtfHQPXLWpj	135	191	191	1615973580000	canonical
232	3NKs5hFQoWDZ47wiiGxj71Dx688bBxpuhR5BbRWmC2rGFYHB2KXg	230	3NKPp7Yf6cY1v3KyXuWkkdasnarFKUUwXzzLwVTWYXDLDjc5ddt9	484	1073	1	1	231	jwXFmwqyANRrjNis9h9XEzujbaaoJXiN5ias3a5uCjx1XeNy6D5	137	193	193	1615973940000	canonical
235	3NK6r5ciM4qoruuneg7xxqYCVzQzFMYSSw5H7NyNiwrg9oipSf7Y	233	3NKZhycHJVd13yGJ37ERpaTYuEiPPWsKVirMEpGmSgQ9pthejW7r	1483	1276	1	1	234	jwfPAQWtLAsXZDG79bcP1JTB8h73VJhg2gryFAcYEStPNKYXrWH	139	196	196	1615974480000	canonical
238	3NLYS5AFDXg8v9QajRcA2P9LozodEgPMqNrh1tDnRgDfV2QLb9TE	236	3NKbmQBifa4QsU2hZTDhXZ1K9x2gsAr29QruZ4cXNgaWiksMUjDk	1672	1285	1	1	237	jw7187r7QxxSgXWw5qPrNLKu94F5ze1M7FUF5kNSgQR7sesz7Z6	141	200	200	1615975200000	orphaned
241	3NL3DFe4tnnneaHPc9nf8yBmsSK2TPjYdPBXX3vUt4Z9cFhvTfJ2	237	3NKqhVB5yw7m5EFrmTo4S8FiRyivr7ZbrfDVhH4vbASGveZHZK8m	1448	1311	1	1	240	jwt7D18cjZuZwM5C1pUc8f1Gyiup5MHJrrQZ3TDL4w5KRDi7dR1	142	201	201	1615975380000	canonical
240	3NL2HEAZUveLHewGAQpxYvEohSu6B2WxFTmUnMJgoFAX61pXFXG7	237	3NKqhVB5yw7m5EFrmTo4S8FiRyivr7ZbrfDVhH4vbASGveZHZK8m	43	1310	1	1	239	jxfuyoXmzh7M9zRLD5vRBqPcjSLDe2agpxFhi1bcuCH2QECtsNr	142	201	201	1615975380000	orphaned
243	3NKo2MWEsMtsnUYrFDGXowMhhwAY249yY3WSR8HkpRseT5pt27T4	241	3NL3DFe4tnnneaHPc9nf8yBmsSK2TPjYdPBXX3vUt4Z9cFhvTfJ2	1619	1275	1	1	242	jwhKhtmcWu9PATAbjhLjXrZzKPWrfrRDQMqmhr33F9FC1ThsmLH	143	202	202	1615975560000	canonical
242	3NK9H85ra3AWW1whEUCxBjBiDh7pVQDw6wSEFSjttskmYniJYkTB	241	3NL3DFe4tnnneaHPc9nf8yBmsSK2TPjYdPBXX3vUt4Z9cFhvTfJ2	1654	1214	1	1	241	jxYDj1gtvuwfxxa4a1ezjZbt8tE2e52ykW2Tm8TCqtUDfvrUFAo	143	202	202	1615975560000	orphaned
245	3NKvGoscbc18Ptqfym93QBhuhvhbB7szyuBvuVEuzJzygNAvkGWC	243	3NKo2MWEsMtsnUYrFDGXowMhhwAY249yY3WSR8HkpRseT5pt27T4	1471	1140	1	1	244	jw8tSz5X1vpgcritf6E4fGk5zXoq4a3rBeQdyLPPcSScLZjfo4D	144	203	203	1615975740000	canonical
244	3NKQvg3dWGS3aDuppXwd8cBPJzix5TupsLi8BjG13r6jBkCqu4mm	243	3NKo2MWEsMtsnUYrFDGXowMhhwAY249yY3WSR8HkpRseT5pt27T4	1406	1393	1	1	243	jxxxbAZKcjvooxiEdopHrrUxQ3LWbP1ZrXktV3gUyADoRsq1jVP	144	203	203	1615975740000	orphaned
247	3NLDXZLMrEib23F4WegmBTB8u83wvsXnkVWrJp5e7HxXKAmYHVqM	245	3NKvGoscbc18Ptqfym93QBhuhvhbB7szyuBvuVEuzJzygNAvkGWC	1456	244	1	1	246	jwgB8zF1SJra5ZeA2ZUiiNVoxTzjVCaM2AtK2eidibFegn811XJ	145	206	206	1615976280000	canonical
246	3NLBYkeQJoTBWFya2efMTwC2JBwxuUi7uGJwpGamPFut9y7SBxja	245	3NKvGoscbc18Ptqfym93QBhuhvhbB7szyuBvuVEuzJzygNAvkGWC	596	1306	1	1	245	jxRCExunc4tjVxbFFe3f4TzpH84nKZCQgeRqZrD9yRQhaMrr536	145	206	206	1615976280000	orphaned
249	3NKotenkTz5RSnSzbrCsUJtZfuD6YyDt3L42mu75XesMAkzLEt1N	247	3NLDXZLMrEib23F4WegmBTB8u83wvsXnkVWrJp5e7HxXKAmYHVqM	1406	1393	1	1	248	jwnYtpsVKVA6rTX2AE2PWR4ZMtZdtVqaWQKEPF72zs79H51MRG3	146	208	208	1615976640000	canonical
248	3NLNuNfKNBZs7cxxRbqLST6BgMuVwSBp3X3P6LQh8AXmriiBWEqs	247	3NLDXZLMrEib23F4WegmBTB8u83wvsXnkVWrJp5e7HxXKAmYHVqM	1405	881	1	1	247	jxjmr42AyyvePDa8R63tPxB9pfiWS4aBWFSmzsK3uL88LfeCTaf	146	208	208	1615976640000	orphaned
250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	249	3NKotenkTz5RSnSzbrCsUJtZfuD6YyDt3L42mu75XesMAkzLEt1N	1407	1395	1	1	249	jwJUoufECGXomomZX2HTMHpT9baHjPahc57WD9Bg4mQZL66mgAN	147	211	211	1615977180000	canonical
252	3NLvNe6X9Y8ArGibbeF3E43sx9887psAvh9y872cyK4dEpyojNjm	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1555	1221	1	1	251	jwZq4cAmok39J539GENxQ7Dyw5rurDgPgbQ1HJ3m886omemyJ6a	148	212	212	1615977360000	canonical
251	3NLB2D5VB1nWfihw4ugDt5d4YYwFQikYjwym5GbDJ8zETucZgQ9S	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1553	776	1	1	250	jx1EA6VVDXHke3fQe4cP7NEZprEYZtH5JcKz15KXjm4X2hNxBQF	148	212	212	1615977360000	orphaned
255	3NKUrHbmQQL4DL9vUYrd9VFYep8eUtdpk5MkkzVWPwrofASZVN4u	252	3NLvNe6X9Y8ArGibbeF3E43sx9887psAvh9y872cyK4dEpyojNjm	1534	951	1	1	254	jwUb5rQaPQww72zR4AHUeJd4TMp5mDjWM8VUYFdTme8459MtjMD	149	215	215	1615977900000	canonical
256	3NKWovz2sP2AnyVHXoKYgo7ZwZmP9Ud2vVp2uPRCd46XyRC4zew3	255	3NKUrHbmQQL4DL9vUYrd9VFYep8eUtdpk5MkkzVWPwrofASZVN4u	1406	1393	1	1	255	jx3MWWYnC5gRLXKXr8P2suP12wHaYS2AHegMBEakHnP3AM1Hqdd	150	216	216	1615978080000	canonical
7331	3NLWyL4MUcPJEdiacHbsFuW12MkktxqJ8biCdPSWMgW1AU1HC25p	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1647	1056	82	1	6301	jws1ou2Dywd3v3xvum9J8Wp2fL6DWs92BnViFhy3EAzniyraEUQ	3788	5356	5356	1616903280000	orphaned
260	3NL7enp8w1fcBnTdBDV7K2BKSEgCUCfJxUfLhzK6DWsfQqqqtkFB	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	1633	1390	1	1	258	jwGSKLsN4KGiB1e5587AfGUmVFvwE9xPJDVASinDALfWRXTEwUL	152	218	218	1615978440000	orphaned
264	3NKe2ynue5GvD6z4ggzYUR3PQW5Cy4gLyapgcE32r7ZXAJuWL2gT	259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	369	946	1	1	261	jwTrCNuo3vmVi9BhKgKZtUw2qRjCbpCkqBgvc75Fr7m95LjWwms	153	219	219	1615978620000	canonical
263	3NL5V725WiyfuqUaTiKXVm7mcWiMG9pQ9u1NFR4YLtr2TXEL1tPR	259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	369	946	1	1	261	jwX4KKVn4HzXX57o45Ng22XZGszkV9UAQz1uFLN2uGvSmS2X899	153	219	219	1615978620000	orphaned
267	3NL7R1KzArCiYL6CiYAkNK2WaKtD4uni2BUQz6CNrjxeLVr6PHPq	265	3NK3MTJqd2CRK3fNhEVstus7xWWzcFpJyGrsKstDY5q2wM6aqj8Q	152	1084	1	1	264	jwq35iVvLQwAxgcGuV1qNmbpnuv4B4SsHnB5MAGeJApRHt19Rt2	155	223	223	1615979340000	orphaned
268	3NLE1MUivhAC3vKq8vYNSfXSDw57sXA4YBmCp2tXF7BL919Kmaxy	266	3NKxvtNmx71q4LQD4Yocaea3dNMe3iQtkPYRLNDMaKX6XLbCofp2	171	1128	1	1	265	jwCk9SJjRNSxnC73ksSNvBXS3HrDkjghSGVkNZAqBXQQKMgUH1m	156	224	224	1615979520000	orphaned
270	3NLee6vS1JUYmYGq9qeBEyLK9zB9DVA865NbNdoS5EsgKeHBewmq	269	3NLgvAtQKTwVpm44AP3EwGfxTE1BpPMr72fETFu4BbMEgmXUesCZ	1407	1395	1	1	267	jxmVH7VbsA7XP9qZ2crYczZ15wPtvbvXmAJ29ZEuC6221KhxjK5	157	225	225	1615979700000	canonical
271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	270	3NLee6vS1JUYmYGq9qeBEyLK9zB9DVA865NbNdoS5EsgKeHBewmq	1571	1209	1	1	268	jwHKZZ28cuGtm277XUv19fiEmyxtVBPAvefcwQb4KZ6QynfNrV3	158	226	226	1615979880000	canonical
274	3NLt7yR2AoX8exdJDLSyUrxqL7MyyJr4pDmt6QQxP8fe8TYc5amc	271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	1407	1395	1	1	271	jxbedzsvm1xa1LXbbS2hhG9C8NPbFnGNkkncLgz6JNBCtKDke6A	159	227	227	1615980060000	canonical
275	3NLnHoU6KoGQhW6EKiUvyvtzcXt4n4EnZ7u4SzwEED5JG1rR7Z5J	271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	1576	605	1	1	272	jxZ4Sx3dDAVt21fZvB3FamhWtpr1hcQoaYaWoaPXNQxyum66TJG	159	227	227	1615980060000	orphaned
277	3NKnyyavbo6Gd4PEdptuv3t2L8x44BCa7BuSAuBM6X2ifybT2ZJ1	274	3NLt7yR2AoX8exdJDLSyUrxqL7MyyJr4pDmt6QQxP8fe8TYc5amc	1631	794	1	1	274	jwnboQquuESViWcEe9HjLb48wPWosxmzsUaMgsqKiWYHKe7ESLA	160	228	228	1615980240000	canonical
278	3NLUtRbJDbms8QtwQcoJUjq2FVE6mDGMUCUXPLoQLCE1LwB6pDKG	277	3NKnyyavbo6Gd4PEdptuv3t2L8x44BCa7BuSAuBM6X2ifybT2ZJ1	1445	1164	1	1	275	jy37KDpiYdd1pmoAdCqacRxwxygT337TJC8a4WuJdNLM9CVxqxx	161	229	229	1615980420000	orphaned
281	3NKcHWtoPjY2fZ7JGuos2hWK6rJChr6WMGFgy7TCSZcKLhBzh7Rd	279	3NLv1VfzX158LBMfd8zqsR1XoB1SiE58BbAmcjGzufj9RWZs6XpT	1577	1081	1	1	278	jwPytQMvd24eLoheEYJA7v8xADTGumBXrUxPvJMrdg2c2kfAcBg	162	230	230	1615980600000	canonical
280	3NK7pTgDP5JKPwTPpAPQ6XhuUxcpMfARm3c5ghc3QrNianiBN3Hy	279	3NLv1VfzX158LBMfd8zqsR1XoB1SiE58BbAmcjGzufj9RWZs6XpT	1455	1332	1	1	277	jxVBmo5M7aJhtD8XQRt4R7Cmt3BCYtvVxSWmup2ND66qf2QCrVF	162	230	230	1615980600000	orphaned
283	3NKxfpsY58PTfgGGn71TQ7FjTH9sjDvhXyuUSNnUQyn7N1QQR9QR	281	3NKcHWtoPjY2fZ7JGuos2hWK6rJChr6WMGFgy7TCSZcKLhBzh7Rd	1637	816	1	1	280	jxopVEGNmD5394525ScCRrSHkuWxax4u3Sr87UMpb7dk1W6K9fe	163	231	231	1615980780000	orphaned
286	3NKtgjWMBqrmpDyTNvDNsUQbMoKSPa3hz98bXZcEdkQYR8DbYwY7	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	1600	1372	1	1	283	jwR77nVNLvhrrRDj8N6ooeUyHZhfxtYxTVSwoVjkeUS1QtTitDw	164	232	232	1615980960000	canonical
284	3NKrdRNp78V3BaCBeovhsm5FSCd2jCKBHN1L68VVKdng6o6dzqMb	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	80	1147	1	1	281	jwggebK9A4TMZsQwU3acvC9qwKj9TZ8ywCytKpNVwjQz3zct8vZ	164	232	232	1615980960000	orphaned
287	3NK7ACi7yLMsSuvoBBKoYQrsgYgW4k6zdFu6z7huNyESdccb2XHY	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	1549	1362	1	1	284	jxf9HudKiLdvsEiSHrZL1N1HpTFntrfG6k8mB8kZG5R4KbdbbwX	164	232	232	1615980960000	orphaned
289	3NKrzpubRfiCe4Zm1GCqBrVo8XEjipVhHhb5yE2ndV1KRtqiKALm	286	3NKtgjWMBqrmpDyTNvDNsUQbMoKSPa3hz98bXZcEdkQYR8DbYwY7	606	1169	1	1	286	jwp4XgcsApYFxFXeH2zAk5yk1FwcjDMMi67JihFhZuZCFjvUSHE	165	233	233	1615981140000	orphaned
290	3NLkQjhLyqCcHpha9Nt93ZxGuRhfKAuYkaYHLR69D6b7rGy9JXrK	288	3NLqh2XF9xceyAhqUydiAm15pNscjBDdgM2BV8zhQC1YnfeeJCMh	1594	1326	1	1	287	jy1KrkSsVktxJ415oxBytdgJcySX9HT3UxdEFRpPM18PSr4TYTE	166	235	235	1615981500000	canonical
292	3NLnSEG1RWsTRifrn5kNdSGBCijXXjMRmdHKAp39kfuNQ21vTttv	291	3NLphTnhBsHxSySQajJVTsoMTHRzCXtWcR1Xg5BwH2B44ktbfk7F	1403	824	1	1	289	jwn38ZGDfHyerYikyQnZggSGiK7jXaZ3AC8vxd5bJ3Nn8hpAYdo	168	237	237	1615981860000	canonical
293	3NLjECjRkyh969PsNm2WZHeGg4EcFwub4TTUtEz6XKiafpNQRGim	291	3NLphTnhBsHxSySQajJVTsoMTHRzCXtWcR1Xg5BwH2B44ktbfk7F	1529	950	1	1	290	jxTz6VTEj8ogBVXT4uceyARcowooNMKuSncE8iZ8FVq8HJ4awNL	168	237	237	1615981860000	orphaned
295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	294	3NLvuqb5SkHshrNv6svMWNxEHvDo7WyEk6tN7a1wJFuqWQnSJdSg	1637	816	1	1	292	jxY89fbuL52dNm6ZgzDgVa4KCwF6vNFekXaLwoncwzm5YsRjap3	170	240	240	1615982400000	canonical
297	3NL7f7ifxb9LGrjsXEeiN9oauBE86gzU7B56MACVmF6W6fnHk4XF	295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	1407	1395	1	1	294	jy2ZDYZ22bqqfxEDZiKApSuoqqZtgDyqKiprcQ9qeJZNKRpNSTR	171	243	243	1615982940000	orphaned
301	3NKWc9MGWbVjuhzbyzMnUvgeVuY7FmCevUu5KYkehDca6qVDyU9Z	299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	1529	1316	1	1	298	jwfHjNMNfMFwJuD11nxZAyRTvRyPWzgX4sqqAEb5nHxqgGUCM65	173	245	245	1615983300000	canonical
304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	303	3NKwpBPcUva36bwJHoBgwFv6iTEMq7cqP1HJ4PHAZYNzGQgXEKiG	1589	920	1	1	301	jx23CQTB4jQ4HhKSxB68sg7yN9dux9tsEZALHFFG7VA8FiMKU9j	175	251	251	1615984380000	canonical
307	3NLjv5ajLNev18TUc9REZUKdU7U7XRkNWwts6EetYTW7bzrHaDcx	304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	1559	1107	1	1	304	jwwvoW7jXbQ1dkWieeeZSoDTWEofd5ezLh2HhEJkUDErDbTcTh7	176	252	252	1615984560000	orphaned
309	3NKPmyDa7ja4NzHig5UG9tqMRzDCwuCnorZs3PAmf9nSS9HL18F8	308	3NLCP5QPi4fKpT8d5QeRfbVLg7N9TPzgVsdp1XRzF6uwkQThj6SF	606	1049	1	1	306	jwbSevsERHMpL3MzaionrpED17QoRfLHPhMiQeLMXhqAPuznvR9	178	254	254	1615984920000	canonical
310	3NLRjacT5RPtEc3T5wM81SJcDoL7crG6gJW4PsvN464hQmmcPCWb	309	3NKPmyDa7ja4NzHig5UG9tqMRzDCwuCnorZs3PAmf9nSS9HL18F8	1407	1395	1	1	307	jx6ahYLsUswzWiLUdTtxtmN66EAsBhNWKfHke5ukQWRXZg1Jt4f	179	255	255	1615985100000	orphaned
315	3NKSZdU7MMtAVNyUAwDrTUQawwcK2GzXEHMQVuR83uKKQ37rHfjq	312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	1555	1221	1	1	312	jxZjUev7NPcwn76gFKoQ6oLBBvAiTxCB4C8WeSsaaqR6g6CoQgy	181	258	258	1615985640000	orphaned
7866	3NLBZAnUrYn8W4zUZuQ9T2s3qUaXFTnAoRKnT7DBHKvoNA4CYPJg	7338	3NKvaa18vd7t6YobauH6437FnzNZa91QfCbXoyZgYuejf61NEBmU	1542	1304	83	1	6301	jwcT2afRytkX63wGG18frB6WHdza4caNBxbn6B7KLya3sNGDg2L	3793	5751	5751	1616974380000	orphaned
262	3NLfQ1boKxvTL5RqaBXjqaPcHeTrTWc1y7jYK6MGRuf2cbuCg6us	259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	1406	1393	1	1	260	jxyJwwfiiH7cE7nTUgt5PEVCLrNUKk9qFhhSeBVc65k4rpbjsFJ	153	219	219	1615978620000	orphaned
265	3NK3MTJqd2CRK3fNhEVstus7xWWzcFpJyGrsKstDY5q2wM6aqj8Q	264	3NKe2ynue5GvD6z4ggzYUR3PQW5Cy4gLyapgcE32r7ZXAJuWL2gT	1527	1047	1	1	262	jwGwCTunUj1ko8wHfsbZrzo7VLjweFRaXKYnD7T3tGZvgxR52LW	154	221	221	1615978980000	canonical
266	3NKxvtNmx71q4LQD4Yocaea3dNMe3iQtkPYRLNDMaKX6XLbCofp2	265	3NK3MTJqd2CRK3fNhEVstus7xWWzcFpJyGrsKstDY5q2wM6aqj8Q	1534	156	1	1	263	jxwWJrtiyQDhgFrHZK5GrV94LAv5i4PJYMnqHfNBLzspKzjnKZi	155	223	223	1615979340000	canonical
269	3NLgvAtQKTwVpm44AP3EwGfxTE1BpPMr72fETFu4BbMEgmXUesCZ	266	3NKxvtNmx71q4LQD4Yocaea3dNMe3iQtkPYRLNDMaKX6XLbCofp2	1601	1388	1	1	266	jxBci9XVsjDTn3DdZVYPdD9QUSE9reAdipx2wkFeMF3AEEib17Y	156	224	224	1615979520000	canonical
272	3NL269N9dqVw4GS6UiNYQrXUmKubSqX2A7JCs5RzwiGH71HeeVAM	270	3NLee6vS1JUYmYGq9qeBEyLK9zB9DVA865NbNdoS5EsgKeHBewmq	1590	1300	1	1	269	jxrFBSzKB2DwqiB261AZJbKuvbPTqZ3o8CuCsGbiqXhJwe56D5C	158	226	226	1615979880000	orphaned
273	3NLNspguYhduGTGsMYBWBavejnoCEDUmfnftnWQxHLDndeggGTmt	271	3NLBwXkUx2d6tF46oYWrASgjcVbqarjYzyCVuzCCuozjYprPBYz8	1406	1393	1	1	270	jxyjWb6DRH2xDRdRnVnqqmTJbovTG6aVi4Sw8bpeUfwWjYdiZcZ	159	227	227	1615980060000	orphaned
276	3NLWc5eoogmpbXezrMhK7BDv6rxNmhRS9X2JxzDJ8qihe13y9wNx	274	3NLt7yR2AoX8exdJDLSyUrxqL7MyyJr4pDmt6QQxP8fe8TYc5amc	1483	1276	1	1	273	jwB52E23eX8oC21txTVUXiQQ5VBmFF1rGi5wvQxDBTVhmH95JDs	160	228	228	1615980240000	orphaned
279	3NLv1VfzX158LBMfd8zqsR1XoB1SiE58BbAmcjGzufj9RWZs6XpT	277	3NKnyyavbo6Gd4PEdptuv3t2L8x44BCa7BuSAuBM6X2ifybT2ZJ1	1633	1264	1	1	276	jxVK2RN99fxgFcFs7vvR6dFbuTYf58z2a8rWfZdNRK3YdRmFVpp	161	229	229	1615980420000	canonical
285	3NKVzHSbHSd2wpFqJa7iRfGbTk8tptXBHiQHcmwYnuMwzB4gBvo8	282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	1406	1393	1	1	282	jwQQrq6pKmz66zHW5Xqga8rJt3rRc1e5PzNEGbKdwFCh8UVDdmY	164	232	232	1615980960000	orphaned
288	3NLqh2XF9xceyAhqUydiAm15pNscjBDdgM2BV8zhQC1YnfeeJCMh	286	3NKtgjWMBqrmpDyTNvDNsUQbMoKSPa3hz98bXZcEdkQYR8DbYwY7	1406	1393	1	1	285	jxAnbm9XyLp8sRfc2zS5WrYbpH6ECmQTuG6mKCrosSGTtT7EWTs	165	233	233	1615981140000	canonical
291	3NLphTnhBsHxSySQajJVTsoMTHRzCXtWcR1Xg5BwH2B44ktbfk7F	290	3NLkQjhLyqCcHpha9Nt93ZxGuRhfKAuYkaYHLR69D6b7rGy9JXrK	149	917	1	1	288	jwiNeaKLa5UimYx3rwX7u11maspWEbL38Z7VQThrkCYB87mPfqk	167	236	236	1615981680000	canonical
294	3NLvuqb5SkHshrNv6svMWNxEHvDo7WyEk6tN7a1wJFuqWQnSJdSg	292	3NLnSEG1RWsTRifrn5kNdSGBCijXXjMRmdHKAp39kfuNQ21vTttv	1594	1326	1	1	291	jy1w5ZiFkMciHkXDPQn32NU1r1o544X8oEFS23Mho7Sxs1hiKv2	169	238	238	1615982040000	canonical
296	3NKsbj3fgjpoQPFThBoNW7ubxKb5MdoaXSX2DyBHkaiPZ7L6jXp8	295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	1457	1025	1	1	293	jxv2TJwZjdntczBMpD42JET6spFLEmQKTcpswpj4gPqvuBRCCt7	171	243	243	1615982940000	canonical
298	3NKFJConE4XmXg3LnwUFi8aSNyoBxHRsLD8sjbFSJjy64GMSAp6o	295	3NKghRxMLs4j6n442h2LuP59WNaQNx7GVGD6KtapC12q51G9EyxN	1600	1126	1	1	295	jwUkSgoh4pTxUSy1Q3Wumf4vZvA5yKy3bKDn6pxyEna18nsCb5Y	171	243	243	1615982940000	orphaned
299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	296	3NKsbj3fgjpoQPFThBoNW7ubxKb5MdoaXSX2DyBHkaiPZ7L6jXp8	1542	1304	1	1	296	jwqUW7YipVmksB8jXcLU4q65RYnjsPYfkCSGKitBcjTSgpFeKGM	172	244	244	1615983120000	canonical
300	3NLTVKQTPBGD3R4HS9VJhPmU8Kve6r15359aZjLeKHSoR5EPeZWY	299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	298	1308	1	1	297	jwnydg5k3Kw3b4cKxRrnko8xBjAA2kWyeson4gE9mfQTeRcAjm9	173	245	245	1615983300000	orphaned
303	3NKwpBPcUva36bwJHoBgwFv6iTEMq7cqP1HJ4PHAZYNzGQgXEKiG	301	3NKWc9MGWbVjuhzbyzMnUvgeVuY7FmCevUu5KYkehDca6qVDyU9Z	1483	1030	1	1	300	jxQWhwuqgQzzBc6J977fmmTKL61HQ3LutGRcAGwGi4HkUeqmiN5	174	247	247	1615983660000	canonical
305	3NKEWAPuz3NrTQ3r8Bv51qf2PBjHYG8JwcbuwBhN3s3fSiq2aQYX	304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	1406	1393	1	1	302	jxmWpqZDQsQQwvFakTnrQ3Tm2Z34Aab7SoXu8HJ8CrwgwYiTypY	176	252	252	1615984560000	canonical
306	3NK8MbzX6MrjU3smAByLbeQfkwbiAnn36EShFHKSiNVULo6f5NFK	304	3NL8sAi9AfoZNhYA9JQ4oFQayHPkT5M3Bfbs3jfF22aiwvBUaUUz	1507	1280	1	1	303	jwGBgFknXUS2EwvZ3icETxWC2Z1T2w3tSFZUbcBqpqs8JUXv5mW	176	252	252	1615984560000	orphaned
308	3NLCP5QPi4fKpT8d5QeRfbVLg7N9TPzgVsdp1XRzF6uwkQThj6SF	305	3NKEWAPuz3NrTQ3r8Bv51qf2PBjHYG8JwcbuwBhN3s3fSiq2aQYX	1581	777	1	1	305	jwnfYiyBjRpXpnNgVVciQpSjXoNx7ipVGchSfP4rymT8HJRm8HC	177	253	253	1615984740000	canonical
311	3NKCr1JDqXhyY4NJFzvVTH1n52hLuWLQH5vCjDePTBpbhx94ZajT	309	3NKPmyDa7ja4NzHig5UG9tqMRzDCwuCnorZs3PAmf9nSS9HL18F8	1654	1214	1	1	308	jwyXqcamTxxZnnMSqh1jX198iArZqh96oCS3oQ27jNWk5n2d3oY	179	255	255	1615985100000	canonical
312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	311	3NKCr1JDqXhyY4NJFzvVTH1n52hLuWLQH5vCjDePTBpbhx94ZajT	1503	1277	1	1	309	jwaPf8y8LG23dWFFtxM5ovyHTDMLpnrHo8CduH7K6FWj87b6m6s	180	256	256	1615985280000	canonical
313	3NKGvm3BpovrE4g6KMAZ5yW3MadnbKhYTUdJwD3E2PMY99kB3w5C	312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	1406	1393	1	1	310	jwJY5LuzDRBt9VjLs43dt8DuqSEzgd32pCZdbfd8SdHVZjydGaw	181	258	258	1615985640000	canonical
314	3NLhn971xP5RH7DUNx196safQKrKNtA4FuhWbW2qmnTa4yymMJrs	312	3NLKhwsz55mBVvB7obm2EL3nbcNDwCPtgwjEv4qYBAVrMrFeGRKj	1541	1298	1	1	311	jxQKuKi61DSZHyVowxQxrUV678N1SWXe9ykkJBm9hap7XUQSqNU	181	258	258	1615985640000	orphaned
316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	313	3NKGvm3BpovrE4g6KMAZ5yW3MadnbKhYTUdJwD3E2PMY99kB3w5C	1407	1395	1	1	313	jxX2RkYz9ccYhbqxSRsFdV2tm2wfyUWWT1uBvxZwBTxiYCH8xtN	182	259	259	1615985820000	canonical
318	3NKufRLNcazp23YUsV5zo9xiL3yW5zrtJVNX6ZKWnqufFs8vrVg8	316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	1407	1395	1	1	315	jxLD27iqMQRUJMHM6Qaew4cTEpjiEphRzMp27RJDcadq7iFddAJ	183	260	260	1615986000000	canonical
317	3NKzFEV1UTiFYrCGE17WDuQsf2T9EatXr4hsQ9c8toVc8eUMGe7n	316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	1403	782	1	1	314	jxsGGDy5cM6bcCLui3fgjzsVrM5Ngj5DTXqA7YLDf3SnUhgBxzF	183	260	260	1615986000000	orphaned
319	3NKAg1fDaT79x4v69M9u3Cb4X674vHvS5gh7UMeZjvvqyHAEu1ND	316	3NL9q3zMuJwTuru1CSBHFBkSCrqZJnRWHyCtWAid2tMubtVms8CC	1631	794	1	1	316	jx2qnXmBqcJqNCpVeC6azAC7awfqybA8ncvgh8FSY7Y71rxYV38	183	260	260	1615986000000	orphaned
320	3NKpBHMh1uJonbxwUx5s1a3PHRzVm5LPav88ikCv2ii3YpyPVQA8	318	3NKufRLNcazp23YUsV5zo9xiL3yW5zrtJVNX6ZKWnqufFs8vrVg8	1406	1393	1	1	317	jwdmeRSLYXsrAYLKnPWqd5MBjtwQHY2zUFgjur5DixiETVrBmB1	184	261	261	1615986180000	canonical
7366	3NLGuTv6PXLSBAY9aHEKjs8ub396AfHHu5MF8ELf1R8zPPz4hb9K	7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	1451	1046	83	1	6301	jw8RhTBTRyfxWp9oGEHqZigSmmBoaqjfmia9LcSirQS8en3FGP9	3805	5378	5378	1616907240000	orphaned
322	3NKQ3K2SNp58PEAb8UjpBe5uo3KQKxphURuE9Eq2J8JYBVCD7PSu	320	3NKpBHMh1uJonbxwUx5s1a3PHRzVm5LPav88ikCv2ii3YpyPVQA8	1553	776	1	1	319	jxPgyLee8L9hLbuaNvDDvMLcMeEYMVVPhiDwG2YjqvzgUMnejiM	185	263	263	1615986540000	canonical
323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	322	3NKQ3K2SNp58PEAb8UjpBe5uo3KQKxphURuE9Eq2J8JYBVCD7PSu	1672	1039	1	1	320	jxFaPeRcqUFJ9puVJ4NFfpa66k25pmFc8KfFsmdcfFxaDTxgvJF	186	264	264	1615986720000	canonical
325	3NKWLL5sHjwE4jizSYHPBb3Yj9JfPFvDcmRP46t7dhnJsQHeU3zZ	323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	42	1361	1	1	322	jxK5bVuKn2rpCqKUao8KYqGwcm2rDZ5XnZvaCEUjc4FryJ1o5Vf	187	266	266	1615987080000	canonical
324	3NL4WKqpCiWTuorgbLt5nVH5aWKCFnFKseY1gbLJzq7fcXif4fpm	323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	1406	1393	1	1	321	jwVHvpEoy8oqKDAC4A8Ay977bVGJSoQhzkTks1UZupMR2JWH2hn	187	266	266	1615987080000	orphaned
327	3NKoHTgf5eGfMcU13wmZx4qNcpE1UEyqNLT2NRazbrYAC7vLGZit	325	3NKWLL5sHjwE4jizSYHPBb3Yj9JfPFvDcmRP46t7dhnJsQHeU3zZ	1407	1395	1	1	324	jxtbzaZ5kh1fFYjiudKCEPAWdverpaTftuY8sbn2s79N9qzhjKm	188	268	268	1615987440000	canonical
328	3NLoV2xF3YWkQ74o9cCP96hpqJGZfCt3QxQNZADGsfpDNK4eoeeK	327	3NKoHTgf5eGfMcU13wmZx4qNcpE1UEyqNLT2NRazbrYAC7vLGZit	1536	1313	1	1	325	jwu8bmwApJT7zq6w5RsFGTmuuNzbNfqiseMJs7viRP5bKE8zUo6	189	269	269	1615987620000	canonical
329	3NK8F24XUQaztxZ4eByUXJhb7YVGso2GbXGr6m4X2YTRsk1bCmrv	327	3NKoHTgf5eGfMcU13wmZx4qNcpE1UEyqNLT2NRazbrYAC7vLGZit	1516	928	1	1	326	jwnCU9LFeXu7eTAF46TGwkuK5oV3r4NYh7xyd3cUzphEnSCi9Jh	189	269	269	1615987620000	orphaned
330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	328	3NLoV2xF3YWkQ74o9cCP96hpqJGZfCt3QxQNZADGsfpDNK4eoeeK	1440	1377	1	1	327	jwhmkoL3pWcRgke613BXGdfbgWNpwsoj4CEiyU63vx9qyhAssqM	190	270	270	1615987800000	canonical
332	3NKixCUBUaivA195eGoGMP46Y7J4KyvhRUJ6urQ5zH68cRgcEoy6	330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	606	1049	1	1	329	jxMRWWCGrLdTEv7nbhKZyNHD1P1LKccFD8PwpGv78SYEELyWezU	191	271	271	1615987980000	orphaned
335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	331	3NKYWBSZyxQ7su3hH9qhUsGD4dLAaTdiYQFFHSxZySA9v9q2SGj5	563	1233	1	1	332	jwrJGagt6SDNDxnF9eE36UTZP5NW8CbapfQnjzzR7DWbQygSFrb	192	272	272	1615988160000	canonical
338	3NKmMj9Bg963MA3fpzgiyVZdBRuW3Fmm27ztPaH76hJfD4uHDsTW	335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	1631	794	1	1	335	jwEJnaWUEQk1gEU5pjyQkmdeuXqQs16TSkx6tNxpUxQ2Qh9JFX5	193	274	274	1615988520000	canonical
339	3NKPiCZjthSPYyeXZzAn1WybqKLwUG1uceP2yPzpDom9hMmVEpHa	338	3NKmMj9Bg963MA3fpzgiyVZdBRuW3Fmm27ztPaH76hJfD4uHDsTW	1406	1393	1	1	336	jwP5b1izuEYqdHsFexN6k7KG97k9RgjuPjAUHKSRMamuTSArfFZ	194	275	275	1615988700000	canonical
342	3NKzqbUb1wQx9kgdLAV4M9pm7iY1YeDZMBvRJhXhSbvZWyvJERHg	339	3NKPiCZjthSPYyeXZzAn1WybqKLwUG1uceP2yPzpDom9hMmVEpHa	1637	816	1	1	339	jxvqPdfRXdNteq2Nx32FVv64eCg6rr5xnvCZemNDVDyuWybe3xK	195	277	277	1615989060000	canonical
345	3NLESDKboCbsFHsMeHBHRPkNjW5gNrf9TrZNSXVddd7oMsmEatbe	343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	1405	867	1	1	342	jwqrEjiUe2Un6X3Me8QebG1MV8iZjma43SemGZ4XVvxdM74H8sB	197	280	280	1615989600000	canonical
348	3NLigq6xRmEeRBToYNJ4Hx22mRS9DtzTDW1CrEXRm7fJVtwz8WWe	347	3NKb9A64shsGEYHYVNecTUR4A76nabCkriNFt8qqNSq1BYayuwaL	1406	1393	1	1	345	jwmVDewhybBUU4HgvHrV9RvcL989vfZnfLZjfq1eKzA5n1DZFEQ	199	282	282	1615989960000	canonical
351	3NLN2cXhiQtp9W6nirkDhkRqiHmbF71XjVg3qfuy1qvJNg34kMo3	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1657	1344	1	1	348	jxKrxXup1qMxv1RjRFrKC9j5hAA5nXM1HahCSsmt7JFrgJtDZQ1	201	284	284	1615990320000	canonical
354	3NKkbDjZ9qs4JViTonTjxnHDAdfSxDHHZ4RgYjE52rNkwFQdPbdg	351	3NLN2cXhiQtp9W6nirkDhkRqiHmbF71XjVg3qfuy1qvJNg34kMo3	1407	1395	1	1	350	jwMPdM5xjNjnLKR8vpAxnkCHYqaXGwDEC1hgRXw9af4jzJewLUb	202	286	286	1615990680000	orphaned
358	3NL5jPQerGtoLYTLhnxnbqwW9Y81jc8eoJWGTVG5z71LNtyCYxpG	357	3NLVGieupLJWUYBrCDtB9TV9KGYoQtk955qnEeizswvSYdKJnCXo	1619	1275	1	1	354	jwwmBGX3dJkgoH5Ven4BaKZqTiNLssewYb9oUzKgjW9C2Y5ZQ2X	204	291	291	1615991580000	canonical
359	3NKFt2eJnKqCqviaZ7mftzRCJyzQs8t6iNNeUvmHZb4AqsRuiZ4X	358	3NL5jPQerGtoLYTLhnxnbqwW9Y81jc8eoJWGTVG5z71LNtyCYxpG	1406	1393	1	1	355	jxaxNPqjzJrCuUpTRyzoqmq12s8TW2nFykP56r5Ju8duJ9Yjfpn	205	293	293	1615991940000	canonical
364	3NLHzADsbmA6iqmWBkRZduT1f376iAScbJNSz9xHMR1JD7qz3ek6	362	3NLv4DxBe2ptFtW6wYHDi1jwLQ84ASp5TN3ZTJesFnjLGmmwM6c7	1407	1395	1	1	360	jy1vomNnyBgJy7mmLzZzYwAwjzdwqDbJhkKgqUAncZpLjc5Axm8	208	296	296	1615992480000	orphaned
367	3NK6B4QJGXHnGGPJNeh5diw59ugW9fUSzK6u272Sbwb9CJ9VaE1c	365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	1396	436	1	1	363	jwKNxbLvPVi9H2DYHde1K6SrT2Vpn4KaW9dQdP99jXXPN6M4LGY	209	298	298	1615992840000	canonical
370	3NKr3ie113yjCgEzckFawyU1xtAg3DccYiLvDrJVSiUdSGAgtGb1	367	3NK6B4QJGXHnGGPJNeh5diw59ugW9fUSzK6u272Sbwb9CJ9VaE1c	1483	1276	1	1	366	jwzpvVoLsYVDWWZSmAdnFyU6URVLM7qqBGcjyER318oiPazNn9K	210	300	300	1615993200000	canonical
373	3NL7c3B78NXp2AuAawmXq6SgtJENprGzUnLfkuQAtRFxeXU3P43U	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1524	119	1	1	369	jxnooLhPvV3zs4ktggg5kzH4Tsm3AyQxopbSRY96BUEiBLcv45n	213	303	303	1615993740000	orphaned
379	3NLBYPTuQV9EpfbjnS1d1s47Ny1Q6MuffWZFKw7oMCNftysoKiQz	378	3NKfBKYgysLTUumXscGUFK51cbj7eeYy38ka1sEVZxwaF23GHdFB	1405	849	1	1	375	jxFoacQRmcCnp8nkPwRyPdzssFau3vohLD2YucqcwoD8Yb5Xv4E	215	306	306	1615994280000	canonical
382	3NLUMVTutHHFoeyYR54QjzMJQrr6wi9vxXW5zFhgeVsESSiKg5t9	381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	1407	1395	1	1	378	jxcvPe3XdE8cC4Bpy9ZdUARaGwFdCHtrqRN1WsoDb7EA8YqTTPR	218	309	309	1615994820000	canonical
389	3NKFFQDkj7Xx8oN2uQQFVXroviSZque3QTfs6D77sxMWiXEKPSuG	386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	1643	1173	1	1	385	jwG1NMs17nTZNNpEFsgYKh2Ecn1pt87wGNrsviXvy63ALow37As	221	313	313	1615995540000	orphaned
393	3NKtrWSsvVixbehntw11iFG5SW89mWb2vMHMZEnZotEKqQ4B2XBS	392	3NKdAwzou2W8DhrtFwPDPJkYz4jDj7KU4Y5NxUsiW15EUevPw91m	1581	778	1	1	389	jwj7iw1M7rZHRkeFx5oLwacLqL77rVxkhZG4FPp4K6LfsqFPqES	224	316	316	1615996080000	canonical
394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	393	3NKtrWSsvVixbehntw11iFG5SW89mWb2vMHMZEnZotEKqQ4B2XBS	1508	1387	1	1	390	jwGB1hV3neh1sg1PpHzhTF9Sx7eY6jbspiH8oEs3vQSxEi29i76	225	317	317	1615996260000	canonical
397	3NL8AiW3y4epGxtoL5G4DBUoWVBwHLQvaVfbQXUGpQigQKxqPa21	394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	1607	1348	1	1	393	jxnzUP8zX3emJ4DJsgMkJ3qEun6GdYioigttiY3RvNkPitirzbk	226	319	319	1615996620000	orphaned
7392	3NKCtCmntVqqYikLjgiYL2rJYaBr9sWZcudrWydoF1LZbV9ru9Ak	7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	1646	1228	84	1	6301	jwJpwKMHp82VGUD1NUnW929sdrxZs2NfSvcDLQveuqbh6Y8xEdB	3818	5396	5396	1616910480000	canonical
9641	3NLQp9fMLRbsB7Spzn6DqenPoKvZ79wYStg9BurjHQaZ4wHgEniC	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1483	601	123	1	6301	jxyAPEpYnRPYVAZXAEn9F7m4D1FfMn1WaXs1UzGuCNuqAGKi2mB	5002	7045	7045	1617207300000	orphaned
333	3NKS5oAfJRmLDuREhRqXFBStMfba7Tsu1HYwcZxMDseau2ZKfuiM	330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	1581	778	1	1	330	jxghWJP8sZ6vp1ttMoZNN1vN6p7VffpJy1mRzq7BPRT2n86c2nz	191	271	271	1615987980000	orphaned
334	3NLLB1qq3hV1exeZ8SdUM6pP1kVWui3zr7RuPLWUVYGm14xF6rd7	331	3NKYWBSZyxQ7su3hH9qhUsGD4dLAaTdiYQFFHSxZySA9v9q2SGj5	1529	1316	1	1	331	jxq6VK71AmAoHzoFZKSvMZYPNrJghJppGE83CvWSomGNWcvRm1m	192	272	272	1615988160000	orphaned
336	3NKTSf6X9mGEKhmsBz2XjmP6JuDi4T2mt1rWS4LSRwcTSKRvC7ez	335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	1406	1393	1	1	333	jwE2ZNSdqbb4mdXvb2PniF4gtagkuquh4dMCyqMKZ9NowQL1R13	193	274	274	1615988520000	orphaned
340	3NLTgYRVxW7g8W5U5kTW6rC3xCD1sv51jn6FF9MRcUe87WETMioV	338	3NKmMj9Bg963MA3fpzgiyVZdBRuW3Fmm27ztPaH76hJfD4uHDsTW	1631	794	1	1	337	jwNisQ5wwHLbAjfYNdismdLHY1Pe9WZWJt655iPLgmJBXHB1eYU	194	275	275	1615988700000	orphaned
341	3NKFBzGMixEa8AU6riAsen6xoKgEoMUh2LzXNim6c2L9pgn5V8kC	339	3NKPiCZjthSPYyeXZzAn1WybqKLwUG1uceP2yPzpDom9hMmVEpHa	1405	867	1	1	338	jwd78LvkzrwfN5j4aAU6gUvkCXJyacXDGnUch83DG4ugchyksJz	195	277	277	1615989060000	orphaned
343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	342	3NKzqbUb1wQx9kgdLAV4M9pm7iY1YeDZMBvRJhXhSbvZWyvJERHg	1527	927	1	1	340	jwEVsvrmJdYZjbP8BM3btpX4B4sptxJVjRakBTLGtFPsNjupBMu	196	278	278	1615989240000	canonical
344	3NK6AGwYVDdhCipZpWbJmp5Zv4vShAWrVVpyN4MtfSK1McYQqt3a	343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	1406	1393	1	1	341	jxVMgqWNBb9uJ5igEk29gQn9m8bboyVs68C8V1c3JGAdavc2iQU	197	280	280	1615989600000	orphaned
346	3NLsCQVQBSaNcCpiNv7cGTVjse1Rf9aDJ91bNnHkPHVH3ACWxmrj	343	3NKGCwX6soMPm5Z75ynLbEudUMyvhPc26zEK2KDexEFBwFNTq5jL	1448	1311	1	1	343	jwf1msCugsLH1QRAnJDt8R3X7VBtDuUyAFve5QiM1dVW9khvPhk	197	280	280	1615989600000	orphaned
347	3NKb9A64shsGEYHYVNecTUR4A76nabCkriNFt8qqNSq1BYayuwaL	345	3NLESDKboCbsFHsMeHBHRPkNjW5gNrf9TrZNSXVddd7oMsmEatbe	1407	1395	1	1	344	jwiAZrvotQG7yaiqhoPGeiTZCjqPCK1FeLJCAw3NRg5WxD7ft77	198	281	281	1615989780000	canonical
349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	348	3NLigq6xRmEeRBToYNJ4Hx22mRS9DtzTDW1CrEXRm7fJVtwz8WWe	1426	1118	1	1	346	jwXXYzFUkxTU2zz5CfmtHpDM1KP7GtcHxvRyDZG8NjJdFN3CGqK	200	283	283	1615990140000	canonical
350	3NLKxkstFTXLERmS5nQGEGf89AxVsj3kEcjKFC2DevAWkwAFkPsH	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1405	843	1	1	347	jxWaStfkk2VK9mtLbppmxr7VkndqJdD2wnAjZhfnT2uifqQCCV7	201	284	284	1615990320000	orphaned
355	3NLYdJbJ479DDBoBjVtV2X3W6SGwLb9AkxUW2J3GRFbWuWCCyuHH	351	3NLN2cXhiQtp9W6nirkDhkRqiHmbF71XjVg3qfuy1qvJNg34kMo3	1448	1311	1	1	351	jxTLTb7jcxpXJGBK5UttM5EAdjpDsKd7D871NZTffeFFDu4p9Wg	202	286	286	1615990680000	canonical
356	3NKgskw1jmCB7gmBBw6FADC5G3n1BgcLJLSRGXLPeA7etjesJK2y	355	3NLYdJbJ479DDBoBjVtV2X3W6SGwLb9AkxUW2J3GRFbWuWCCyuHH	1460	1324	1	1	352	jxyDK8sTCzYcknFr7fFqMp5bPTXM8q1F8AKKJDfVHjdtRxrJGhN	203	288	288	1615991040000	orphaned
361	3NKKtgbHoJ5RnUHcR1oqQNN5g8UTnvxHxeuXMDCYC7nrJjfQYiv3	359	3NKFt2eJnKqCqviaZ7mftzRCJyzQs8t6iNNeUvmHZb4AqsRuiZ4X	1610	1068	1	1	357	jxRswh2Dw76ZDixyCyp2zxZBicqFX4Vb1KfPxtFs6xWKJNLYF5R	206	294	294	1615992120000	canonical
362	3NLv4DxBe2ptFtW6wYHDi1jwLQ84ASp5TN3ZTJesFnjLGmmwM6c7	361	3NKKtgbHoJ5RnUHcR1oqQNN5g8UTnvxHxeuXMDCYC7nrJjfQYiv3	1406	1393	1	1	358	jwJnE3zTP72mvfFFgT3qUMTCGonWuJZLQf6Ng14YSaqk8nktEYx	207	295	295	1615992300000	canonical
365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	362	3NLv4DxBe2ptFtW6wYHDi1jwLQ84ASp5TN3ZTJesFnjLGmmwM6c7	1477	1350	1	1	361	jxrDxYRgvXxhbgN6XEqV7uHUdzshJ4WvcNPzCTSk31SVsA3qpmV	208	296	296	1615992480000	canonical
366	3NKJTJ96ZP3AiroYn5WGVTHzEQ8gKPLgsoATgp6tbrZFhp7x1sxG	365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	1406	1393	1	1	362	jxBEeaYzHSE4URCveoFnPcJBKBkdKE9vxYubfj4Zc1HuSXp1ZaG	209	298	298	1615992840000	orphaned
371	3NKkxASK4PW5Lh4Xiaz3TuquEn7GRDK2guDiXtE7qpy92WELaN9u	370	3NKr3ie113yjCgEzckFawyU1xtAg3DccYiLvDrJVSiUdSGAgtGb1	44	83	1	1	367	jwHPGAzGorszMkgAE8ycWZvCPhooLq2ANy8eQjtc9qYF68vXM1S	211	301	301	1615993380000	canonical
376	3NKTWmW9t4DFkaR5bnpEoqdn2jBxRdWa8SS3CJucEBXHEFU6Teuo	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1407	1395	1	1	372	jxJNtpHUdoujuF9a48LaMH5na8SqBjfkKtVmnWZ81xvcuZt6SE7	213	303	303	1615993740000	canonical
374	3NKzu5QbFCSzUrGxPqZRNTS3VfiJ1c9qa7QDr6a55JPCzLkxZXL3	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1405	851	1	1	370	jwqEi3v2uimXbNEHBiSaSHrfAmCZ1TCLYDvDpQeSzY7EHi7jNEV	213	303	303	1615993740000	orphaned
377	3NK4ZhCVmCGDEz1o2HGGkpKJm34jHCMV79bVBHgyGvWJ4sdXmmdU	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	1581	778	1	1	373	jw8of9k3uzpR3nNAi1m8eQp1f3CLSkdaRi5c9wbvPQWDHdwhFY8	213	303	303	1615993740000	orphaned
380	3NLSa2ctSd1MXxJb5pBBZTfQXjvodBQXcXmG7aB5ybciq5kNqroL	379	3NLBYPTuQV9EpfbjnS1d1s47Ny1Q6MuffWZFKw7oMCNftysoKiQz	1585	1240	1	1	376	jxhtaXt5sdbppEsTT3gid61xQh8jyPejFif1M3HepCvzE5vyYR8	216	307	307	1615994460000	canonical
383	3NLScDpvTrfefxVmMC8KHvHymZzDv6fFaYfcNzDRiSwKFckWAJBv	381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	1460	1324	1	1	379	jwrzh3Lg6qqTpfy3xaPyM3sjgC9wA4Uqj2CXgzwKVTK9twFbb8e	218	309	309	1615994820000	orphaned
386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	385	3NK8iwLoZYmUUdQsseZ3sbLeRW5Dy46mtFuKmPz1DjvWZTLPJmfY	1407	1395	1	1	382	jx1UgeiJSA98574dc7WGVuPLWA1nQArJzPRuh4Ljcaucwwza2Ht	220	312	312	1615995360000	canonical
387	3NLVTYxNX5bp3o6wM8kBrvLDKGkg3Q973ZwFUAo2sVyUSw9A72wg	386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	596	1180	1	1	383	jxxDkM5ot6r8dEfV43MsCcmJZUwEPxfmYn4CetM5Pu3BCi8iKqp	221	313	313	1615995540000	orphaned
390	3NKKZiNZKKUkorMQdFmvmwPUwvpwhgaa9hgsjyp3kGJNmtDHnVRG	388	3NLk3PwP9TNtv5trqYB7mPzKbMG3EghP5mznzG1jKyCijquVHh89	1673	1242	1	1	386	jx1nJimgeSvsNDh5yu5QEoaPS1ZEQaZ44HimwWJBkixYtr42Qjy	222	314	314	1615995720000	canonical
391	3NLWdQqiBkDbYzduZ8RJra4EiRFACF2pusb4CL2a9oyGNCmDyFBW	390	3NKKZiNZKKUkorMQdFmvmwPUwvpwhgaa9hgsjyp3kGJNmtDHnVRG	1407	1395	1	1	387	jwQXUHi5WfXj9qpvn6J6bmfobFHmdjVTesVAAm7MqPVuuZUC9dh	223	315	315	1615995900000	orphaned
398	3NKKLkGspf4qqBY84hRyZzZkGNiVSrdMk75WBN2EAFKSbNmnnkyT	394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	1476	1371	1	1	394	jwoKuS3S5sMqAHGPRNEq16EjVpGTGvZqu7gQ2e97d8xDBMr86rW	226	319	319	1615996620000	orphaned
7598	3NLNG9vMWK4Ge6AsGaZs1avUQPnzGAPXbB4VW6YCaxoNAZist37C	7511	3NKDHNLXn1tch9ZAhNDaeJyGy27SQfLYr76icPZ8bPjzGamd4n7S	1607	1222	85	1	6301	jxt66aep5U6TW8B8zzQEg3M8NpspxanaJ7hKeCsKvzWCnHiQVtX	3819	5549	5549	1616938020000	orphaned
360	3NK7qH4xU5FQrvBhjMgNvwXTUKpU4iPdcEhne4neJMaFoCLwMqag	358	3NL5jPQerGtoLYTLhnxnbqwW9Y81jc8eoJWGTVG5z71LNtyCYxpG	1560	1291	1	1	356	jwjAKYjPtEcbDBrv8AcTQdKN3nfsoQbbALVeBC7KyPvE8UWiiZP	205	293	293	1615991940000	orphaned
363	3NL5ZzDcDD1vy9wkxpJRgqRd2JT8kqwyVKXJzftUJkWf3AyvcCHC	361	3NKKtgbHoJ5RnUHcR1oqQNN5g8UTnvxHxeuXMDCYC7nrJjfQYiv3	1455	1332	1	1	359	jxAtqaSDWje9wqPX4hm9i1r5JHssnAJR2fy5SAbxzzL1ByGjk6z	207	295	295	1615992300000	orphaned
368	3NKVfcGRwB7w2naBGvWhF7sMowVavWP7ZjyDktgF48YvWbjh2vwY	365	3NKKWUQGYAHkNUH3t4ycPD9StToYuN7DtKWh3gSaEGL9MbHMm6NT	641	1210	1	1	364	jxACvnEH5ZhTSaJXFZpwBeEzj56QbAs7726e9yZmwhe63H9hJEf	209	298	298	1615992840000	orphaned
369	3NLUY4JatL5DEHEoyChLCMsLq4dwrkixFQgwmCV9a7CLLLBBzmsX	367	3NK6B4QJGXHnGGPJNeh5diw59ugW9fUSzK6u272Sbwb9CJ9VaE1c	1509	1320	1	1	365	jwjcWvPGPLExzZ9zhCnXQZR2VzoErxGhoTmLXjNHN1j8HdLcyM4	210	300	300	1615993200000	orphaned
372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	371	3NKkxASK4PW5Lh4Xiaz3TuquEn7GRDK2guDiXtE7qpy92WELaN9u	1406	1393	1	1	368	jx9YFEp4DmnKbwvri85fnHGTmjPanhfyRVSrsUrVCc3PShyphhq	212	302	302	1615993560000	canonical
378	3NKfBKYgysLTUumXscGUFK51cbj7eeYy38ka1sEVZxwaF23GHdFB	376	3NKTWmW9t4DFkaR5bnpEoqdn2jBxRdWa8SS3CJucEBXHEFU6Teuo	1536	1067	1	1	374	jx6duACWMdrAGhZDz5WTZXTYYtaWSPqgfZHpqK31mNfzCxWPbA9	214	304	304	1615993920000	canonical
381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	380	3NLSa2ctSd1MXxJb5pBBZTfQXjvodBQXcXmG7aB5ybciq5kNqroL	1637	816	1	1	377	jwEoPYJ1urKJztm4FkGXfLeT8UtZzcfMY1DJjqZ7rC5AhK5tN2X	217	308	308	1615994640000	canonical
384	3NK5hBdcATJ2hZUBkS41LWUAUUj4Fk7koA2h354vFkvP5CnhZQwF	381	3NKwBBMPM8bsYWtz6SS6UdtSJMJ3pNdnQTd7Qo9gnZ4ksctEVFRQ	149	1283	1	1	380	jx6QjDvWQAjAVr2cWtLWikCzweNJbfGaeUWgL6m4DSkd51WfLUP	218	309	309	1615994820000	orphaned
388	3NLk3PwP9TNtv5trqYB7mPzKbMG3EghP5mznzG1jKyCijquVHh89	386	3NLm6nVDzhwg1Q4nFkjknJC1UNGsWM8TVJfCi7JsVXWUPvKPvufk	1406	1393	1	1	384	jw7GEpETVY97dLi5g4H6MzwXwV7hJ9j3hzdYT2gcv88Vg1jvd55	221	313	313	1615995540000	canonical
392	3NKdAwzou2W8DhrtFwPDPJkYz4jDj7KU4Y5NxUsiW15EUevPw91m	390	3NKKZiNZKKUkorMQdFmvmwPUwvpwhgaa9hgsjyp3kGJNmtDHnVRG	532	1303	1	1	388	jwQxKTNKJ5hSfKETdEVEjZTT5PyXUqobiR49ers45gvzyMYkD42	223	315	315	1615995900000	canonical
395	3NLEM28fNtqkJ24z4ni85PY88SA1UbHdSaD9Vr2u1GCAvgSfgTBY	393	3NKtrWSsvVixbehntw11iFG5SW89mWb2vMHMZEnZotEKqQ4B2XBS	1581	778	1	1	391	jxe8N5AjcijGbYjRRK4vVK6yKE45msshrn7EH52TqdUDvJ7iprp	225	317	317	1615996260000	orphaned
396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	394	3NLatxCdz2jjTkYQeNRa9YaJpCuCbG5xNx5pnZpbpii8bfXnEQMW	1403	824	1	1	392	jwwFxR35ToNc8UBPs589BErH6ASNZM98NLmiLyD8ekGY1swkxua	226	319	319	1615996620000	canonical
401	3NKDeQnVTpehtKHyFEJ8pmSezsBxnzr6Kco8hhMfH9bQaoMoHP1B	396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	1601	1388	1	1	397	jxgVNLX3BMDV1uyxTamafTHb6U54Pez8BSdn4TpgXnZCkkgfcpp	227	322	322	1615997160000	canonical
399	3NLkpT7znSRzMhB1bgtfGD5CGLS7xtxsruRbQJTgS9mmvQ4FDZh4	396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	1460	1078	1	1	395	jxD6g8pdjNWLv2ZN3LbX9XndLJP6z5uHigxeZhVHzQdWqUfZB7U	227	322	322	1615997160000	orphaned
402	3NLrZ81Ew9JgpkKYhED3BNkeQY388BZKPfviBPqPzr1c6i7Xb6at	401	3NKDeQnVTpehtKHyFEJ8pmSezsBxnzr6Kco8hhMfH9bQaoMoHP1B	1637	815	1	1	398	jxv1ED5kRErfSWKgpDrxdFUC1RPFCqSKqRrLEtQn2ycuVtAfTWy	228	324	324	1615997520000	canonical
403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	402	3NLrZ81Ew9JgpkKYhED3BNkeQY388BZKPfviBPqPzr1c6i7Xb6at	1571	1089	1	1	399	jx4JSTe8mDRChdFcoUYQ4XCrRyRmH7ziGgwMASrhUNBusg8ZxZr	229	326	326	1615997880000	canonical
406	3NKGYJLoksXd76aGsMr1F2TAKYQ9uXopyXM5nxMaiex3edw6EPib	403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	1585	1120	1	1	402	jxfQuhK2z8rCiU5DjSqMu74eqi7jXE38ZjWVKH8DQq9FVeDKSxn	230	327	327	1615998060000	canonical
404	3NLy2pnWZjy3oLcbZZTYuDAWh6BmpmehfM5ykyvvtgzPTFjQWwHy	403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	1407	1395	1	1	400	jx2tBBmTk3RLwxw9V5oyFp2QsjXcMonLGAqHFbDWTA97AxJ72uq	230	327	327	1615998060000	orphaned
405	3NKpodPQHWajSxxqDLugXgyS69Wrn8nrTc2LPBGfZErtyipL44X1	403	3NLcCqWG5hygfnG3WpkPHfPacDbHhsvPHMa87Xf1kxFbRsLoJhEY	1406	1393	1	1	401	jxDxhnUoXG14Ti3DAMeiBbm4ja7qqVp7MCwj7yxV3eEc3HigjhP	230	327	327	1615998060000	orphaned
407	3NKUE2NdwPbwXcHSsaRsTZ1u3PRHTggA1NnMXBVQFdWkJazjssJY	406	3NKGYJLoksXd76aGsMr1F2TAKYQ9uXopyXM5nxMaiex3edw6EPib	1555	1347	1	1	403	jwYXDUnsxkZJq9EQzLgVesbpM2x5vPgfSQMt44MpPAgyDfQxS4B	231	328	328	1615998240000	canonical
408	3NLNPCBZiQYdsoS1e7qfXw2LUMRerJxnQe6vZWRWqihcU6mH6kEw	407	3NKUE2NdwPbwXcHSsaRsTZ1u3PRHTggA1NnMXBVQFdWkJazjssJY	1407	1395	1	1	404	jxTYb6UCrzz2kxJhQRrBcPhXqERqJQC9tJoY7nC1odF6YFaH97p	232	329	329	1615998420000	canonical
409	3NL1ocfoyJj94ingD4cQoYo2AgF54mYUeyPzXBAggiZru7W3HawZ	408	3NLNPCBZiQYdsoS1e7qfXw2LUMRerJxnQe6vZWRWqihcU6mH6kEw	1403	786	1	1	405	jx4g4k4ve2CPAgADsD9s6KtxYZUbtDgu1a2ouVsaMyp22ugevv3	233	330	330	1615998600000	orphaned
411	3NLt1RN78sAC2FkjsBJx91NE8wcPT53eg17FM22x1frzEXeuvt3D	410	3NLZ2zcTEwW8XUfk2GShmNo56hBkM6dL7fXP1QmBwTKZSoQYQLKb	1406	1393	1	1	407	jwwjN76u6gMb7dCqgdYkKufogNH43PRBA8w8tLzAcbo1A6SbvS1	234	331	331	1615998780000	canonical
413	3NKVKNv3SXb3rZb9EYkWggNym2d3ce5tayymRRrnSqivV9xWpUp2	411	3NLt1RN78sAC2FkjsBJx91NE8wcPT53eg17FM22x1frzEXeuvt3D	1546	1093	1	1	409	jwTDae76ubQ3V3zwKXBBbWnwL6GBU4WpnqTq1Kr1MEKVmKprHE9	235	333	333	1615999140000	canonical
414	3NKgiRyR2529b1Kj79Bh3i8gi7KNgQjhf2TAWp1LVt7EsjFcnkiG	413	3NKVKNv3SXb3rZb9EYkWggNym2d3ce5tayymRRrnSqivV9xWpUp2	1643	933	1	1	410	jwEAVgHrR1E3u332GWaJhYKncFGDYrncKCcKMSXQQkX8mDjxbcj	236	334	334	1615999320000	canonical
416	3NLPxKtgVtcM292DdcBeThfyJdVWq5Q3LzvdgxwFLCF7gm63txgz	414	3NKgiRyR2529b1Kj79Bh3i8gi7KNgQjhf2TAWp1LVt7EsjFcnkiG	1445	1164	1	1	412	jxZcWyymbQeQhTdoEhJ5xbJkHvE9P6RhNxTijC1iFHjyoiQhjmh	237	336	336	1615999680000	canonical
415	3NLF2dBmVb4aWCAyVgfMEeHoDeizT6Q5M71iPPd6NaAFcB2sGSSu	414	3NKgiRyR2529b1Kj79Bh3i8gi7KNgQjhf2TAWp1LVt7EsjFcnkiG	1406	1393	1	1	411	jwr1NRksqppKwAQFAuKLQWN7juj6sQjyQUL1ryhee2shLxJA7Yw	237	336	336	1615999680000	orphaned
419	3NLYr8A5kNnvppkuWvGy53UBeC6jenzzykqrRNST6q6z4hMvpvnK	417	3NL92s7ddNfmGHgHEGTkbuxLXNAs8jg4EApsSTq8d4WN448v6JFh	1617	1288	1	1	415	jwRbiYwQXpQuWyXYuwLsyCk7jzfEz1icxbyybExCxMTf9UuULvD	239	339	339	1616000220000	canonical
420	3NKyaUoktVv7u481S2bMNYa3cCXkSxoeT81BVyGdminUeRWwozgr	419	3NLYr8A5kNnvppkuWvGy53UBeC6jenzzykqrRNST6q6z4hMvpvnK	1588	1392	1	1	416	jwfSF4HjsyjiVAzAQtDVCKEB8QocEijyHmSEYaKnrNWYMDWy3FY	240	340	340	1616000400000	canonical
7644	3NKq9a8uw3gSWQQ7RnZz7C3BXFBJTytmH7XbkgWNYa7Wr8wLb3oR	7598	3NLNG9vMWK4Ge6AsGaZs1avUQPnzGAPXbB4VW6YCaxoNAZist37C	1607	982	85	1	6301	jxTp2giY8fYxG4wuhzJQ8dKTv49FR6MgJfyd4zEe7udFr232amu	3820	5589	5589	1616945220000	orphaned
9643	3NLMdyXBQLtAFHPfJGatp5b2fs9sY7PhLkz8MN22HnzhTkwQ4Scw	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1560	279	123	1	6301	jwBVPCaXo8yeDBiSbUGsJvVfdTJtFeG9oNXnT9p7Bi1JzTwXq3Q	5002	7045	7045	1617207300000	orphaned
412	3NLMiWQcwjezCdXHhnx9Gj9SYDqtJXveQeu8wketFicwxVGpPYFL	410	3NLZ2zcTEwW8XUfk2GShmNo56hBkM6dL7fXP1QmBwTKZSoQYQLKb	1405	887	1	1	408	jxtMxfDNc9DWAqcia13CmxUP8b3W6fogqDBt7FKYubVLKmUQFQS	234	331	331	1615998780000	orphaned
417	3NL92s7ddNfmGHgHEGTkbuxLXNAs8jg4EApsSTq8d4WN448v6JFh	416	3NLPxKtgVtcM292DdcBeThfyJdVWq5Q3LzvdgxwFLCF7gm63txgz	1407	1395	1	1	413	jx5RKvJX6MDy611WX6NgGDeELTb89EzZ2MJHE9HTjyMQB1QhbHf	238	338	338	1616000040000	canonical
418	3NL4o8nrBGj5EpMYww4McwPh3duiRGFGkwWALHKwGhAbcr21jvk4	417	3NL92s7ddNfmGHgHEGTkbuxLXNAs8jg4EApsSTq8d4WN448v6JFh	1403	824	1	1	414	jxsWB26ntcUVYrwKx4ubLFcL1tLottAnsWme79LeehirRSB8wX4	239	339	339	1616000220000	orphaned
421	3NLjk3f6a83L2PiYfKa7SjryAeF4P3du7hFpFMCa2YgP8xgWoXcW	419	3NLYr8A5kNnvppkuWvGy53UBeC6jenzzykqrRNST6q6z4hMvpvnK	1624	1088	1	1	417	jxJ8BhGLTYMKjtMjwTeohZJCUvZahyYgDnQg1PqgqMN3QVKXUoB	240	340	340	1616000400000	orphaned
423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	420	3NKyaUoktVv7u481S2bMNYa3cCXkSxoeT81BVyGdminUeRWwozgr	311	1307	1	1	419	jxtT3gJ9mRn8DsQ7e7EDu3WHcPytKAf8JUm9jZS379NgnzEReeE	241	341	341	1616000580000	canonical
422	3NLQ1KisssptAHUi5bhUmxPZtr8tjoQkkHxbKC6YR9jsqbDyu9LJ	420	3NKyaUoktVv7u481S2bMNYa3cCXkSxoeT81BVyGdminUeRWwozgr	632	1136	1	1	418	jwW7XoqhD8wU9BZrguFqsmggzJhbk35bJnEhtiMhRjBVvAS5NZq	241	341	341	1616000580000	orphaned
424	3NKRiaXJFqj5qtaT8AbT2hB2x7dD4g4T4Phopg9rDyo9ehNRhZzm	423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	1600	1372	1	1	420	jxcNuQSmmHg8BJVrhZu1h7wVeegreRHqCmyTX15nc73rHFvbAgT	242	342	342	1616000760000	canonical
426	3NK61RUJDwdabaM8ZWR9oqWJFoaEHWgbs4R6CaEhC8zTpQzQeSU6	423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	1594	1200	1	1	422	jx3Jri5sVL8WLbq5dCpu7gya97nj1hJrk3bz2TfmNUkoVeAxHVG	242	342	342	1616000760000	orphaned
427	3NKJQ2xa2Yng2aE6PuDvs2MHBRGHM7J1mVNK4QvW2AtVn8ucpAoR	424	3NKRiaXJFqj5qtaT8AbT2hB2x7dD4g4T4Phopg9rDyo9ehNRhZzm	1405	1	1	1	423	jxt8PVosyejPScqkkfd1HhhpYEiCX7J5SXQomw8n76CR81ahrYu	243	343	343	1616000940000	canonical
429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	427	3NKJQ2xa2Yng2aE6PuDvs2MHBRGHM7J1mVNK4QvW2AtVn8ucpAoR	1447	1345	1	1	425	jxPfUDB3TTpYbVVEGHzpyXGzhMss5mMDjcVnyrDqCWo11gbMHAY	244	344	344	1616001120000	canonical
428	3NLakPEDxNz493AVS78VMGFbFGhvXk2YsgTAxPwyNKNgR9ovuMFi	427	3NKJQ2xa2Yng2aE6PuDvs2MHBRGHM7J1mVNK4QvW2AtVn8ucpAoR	1671	1365	1	1	424	jxVy8TnhDY5f4RtuiUyBF71XsDngiFn9p8znHHAfbNQrtHRsn2i	244	344	344	1616001120000	orphaned
430	3NKA4xbSAcfhA9YjfF8JC4UEzJV8osDE8mfJT1jHzRUBDM4gmM1f	429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	1502	128	1	1	426	jxnhysWTjwhvQXfWhZcDSfYaYGNeweUsLN4zytjechjrinwozqM	245	345	345	1616001300000	canonical
431	3NLqbjcGgB5oUZGoduRAGKnrfe8AGZ88EkkpJ4r8HS6BigagzC6n	429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	1447	1345	1	1	427	jwtfVZJ7ud6TtPqsWvMNAdvihDBpuxKD4WFV3GWeDrkCS4pBLGM	245	345	345	1616001300000	orphaned
433	3NLgHQDDtb2t3EkwceDiEvgNNsVQX1jNPw6GSayz7bxJaxCh3UTp	430	3NKA4xbSAcfhA9YjfF8JC4UEzJV8osDE8mfJT1jHzRUBDM4gmM1f	1596	1363	1	1	429	jxbjRANgkTCxBXWqhwEKAzH5NFe3v3yctdvFGaHcVyFyDgZToeR	246	346	346	1616001480000	canonical
434	3NLiRQ1fJU7TBbARnkYmZwZpzYrFnUELHxC7KHi8Sb67PGcPrrgE	430	3NKA4xbSAcfhA9YjfF8JC4UEzJV8osDE8mfJT1jHzRUBDM4gmM1f	1581	778	1	1	430	jx7wc2ErDhq2JLsdosUFpzMfjioikifAq6LkXahb5qiXsJg1ejh	246	346	346	1616001480000	orphaned
436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	433	3NLgHQDDtb2t3EkwceDiEvgNNsVQX1jNPw6GSayz7bxJaxCh3UTp	1631	794	1	1	432	jwfDUWg74MAvG2HS7j422hARYxrKySXECeGiUsgLbnbA5TjCkfC	247	347	347	1616001660000	canonical
437	3NKgEqivMfJRRYyJ268GPpfjtRRMwMYdATkDBgtcLsgo66xFSQWT	436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	684	1352	1	1	433	jwZsjh6v5HizoZav4bqY4tFUBoaq1Je5CQXScrhd98sqbnTezcs	248	348	348	1616001840000	orphaned
439	3NL72GBdyDCaSjMcMkXeBdSKKYzAJJeGazZrodHWbxGpSLkYKhCh	436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	1616	2	1	1	435	jx87zqAuXJbacVhFq1DEPkRWqSrrkgHmpLMdmFsJaHfPAoiTbQw	248	348	348	1616001840000	orphaned
440	3NL8hiKDSuCBhUnjKdeUrh9wXN15KA8Zo6dpfB8UifDQRj8foKTF	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1588	1392	1	1	436	jwaWxz7pFu6CsPHFDCmBXdJVQwjw22NH68tTJYkGGoNZPLv5vLE	249	350	350	1616002200000	orphaned
442	3NKRogCaDVQF8Ew6oPoEjbCGEgV2nRhans4Wh3d9iLqeTXXEAV5r	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1457	1391	1	1	438	jxRWiWp2V5FSQqhgakaW4d5G2jW1iYJBNSWsfEtZfCXEA3CY75q	249	350	350	1616002200000	orphaned
446	3NLtkKctMEauqAzgu7YAHKGL1sJFvvReTD4u6icznJDpxrQpZCw5	443	3NKtFJx9Xairvn3iBvGF9U3d5rUKxKGqPpk27CySzQPTJC6ndy8K	1553	776	1	1	442	jwKgWiKhR8g1shV3xqKnfmLPXsFTZETSy8UagRp71XeLn2NdvP9	250	351	351	1616002380000	canonical
448	3NLXHhHWreiCvfZKTgLU4CfYhSuywQm31mFak8YxEnCr6KjLubrH	447	3NLjDeVhtn3hPruqxR8oaoBjDJNz8G1WQip1YtjhYbj3BW9ToymX	1516	1168	1	1	444	jxLAs1er3GD7MLPTXmrESdNgxdUHVWsXzN5Qv7ytQykkT2HVfDv	252	353	353	1616002740000	canonical
449	3NLFAHqWkRmT81kqzM5pD99mo3HPsji9gCZ9UfTnVEQQh5qnbmAm	448	3NLXHhHWreiCvfZKTgLU4CfYhSuywQm31mFak8YxEnCr6KjLubrH	1403	824	1	1	445	jwZimUopRh6mEXUvLySbrHheXvdP2XWEoZSJJTyJ6HukQTNvi5L	253	354	354	1616002920000	canonical
450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	449	3NLFAHqWkRmT81kqzM5pD99mo3HPsji9gCZ9UfTnVEQQh5qnbmAm	1406	1393	1	1	446	jwouRe8fbVhr4Q2wSGUApKVH61AA6TGvfi1UZKRRnbPG2sSkmFU	254	356	356	1616003280000	canonical
453	3NK3NYoaQ3kgDf8Rwv5ws5PacvKqdZCeYMVnrsSFKqB6hprr9gfL	450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	1508	1021	1	1	449	jwDV1NsL8EMmrHb6B9yNK2cgXekhyuXoNrHCqGP2dU1mAwAxPat	255	357	357	1616003460000	canonical
451	3NLRYHASLKbjKXaBxmq7mnP491fdAi9G4wWvCc8Du3f8dGPSX9Wo	450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	1406	1393	1	1	447	jxHvot2EEfUZbQdjcpRezrSPssMsC7kp1S1bJJiGAMaHgqHWq5q	255	357	357	1616003460000	orphaned
454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	453	3NK3NYoaQ3kgDf8Rwv5ws5PacvKqdZCeYMVnrsSFKqB6hprr9gfL	1546	1339	1	1	450	jwSxbGruyANM6aVMheByZJqM88cJj8gc4VzEPb7CmksVJvMNQYW	256	359	359	1616003820000	canonical
455	3NKbSx9228q1gGzugzB2TXr5Cayvrq3DsuQvzwALvnrdjPu3uC99	453	3NK3NYoaQ3kgDf8Rwv5ws5PacvKqdZCeYMVnrsSFKqB6hprr9gfL	1445	1164	1	1	451	jxy13SRXhCbe5Yw4MzjugkJ6QWhaRWGgP5XUnex4TL74EWzuizk	256	359	359	1616003820000	orphaned
7398	3NKTPxcpRLhztyNx8MAvbjevic5uNVn1pK4XHbcYxWHSoYQi3t1h	7396	3NLvj2DjVTbmxKJiwY6brtGcwe3TPEUSDrap99meYBJGKn5e9Tyu	1623	830	84	1	6301	jy2HRBwdcPpZRADZVY58D4p521d1HvUiu2vBV6tfKSX5TKKWj5P	3821	5400	5400	1616911200000	canonical
10230	3NKgAwD9ETY1KGRwKuJi1sCeJawoWZzs2F9mXCyMFAE5VrCZDcb3	9648	3NLfqtTEXkXSdtNcsEPtobAwFcJey3X7v4hxvJaULCrJgacbqq3K	411	411	123	6301	6707	jx9HRKUUxNQ2QJwXP2gkQg3GWBGGC8FBFHeEoLBQv1DSWJ1q417	5007	7452	7452	1617280560000	orphaned
438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	436	3NKGAkAKVTyZNm5t7KCBBFi4zPMqoYVFXs9iTgdx9YVvweRX1rTz	149	1283	1	1	434	jxk9JU4ZY1WvAf44NNnXqXJm3UgvzU6ZKNhgm48yEVUYXyfU74p	248	348	348	1616001840000	canonical
443	3NKtFJx9Xairvn3iBvGF9U3d5rUKxKGqPpk27CySzQPTJC6ndy8K	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1428	472	1	1	439	jxQ7BYBbfivuco44LHfYS9DsKT7P4b3jiSJg3ckxnEiLqEpR4Mz	249	350	350	1616002200000	canonical
441	3NKLSyrTR4CvWuFNGJQCMyLnM7YKu8XJCLBJ17KfzPmYwcYYcwLh	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1406	1393	1	1	437	jxL6r8i67Vcer3oPk2z4UnUGwrRjDypEbmZzG1bGr7hkqNcxmQ5	249	350	350	1616002200000	orphaned
447	3NLjDeVhtn3hPruqxR8oaoBjDJNz8G1WQip1YtjhYbj3BW9ToymX	446	3NLtkKctMEauqAzgu7YAHKGL1sJFvvReTD4u6icznJDpxrQpZCw5	1458	1323	1	1	443	jxjNAJtsDZVoWeCunfZWgFJSFmh5fzu9B5dyrVd7i5gwEohPH3j	251	352	352	1616002560000	canonical
452	3NKgf9aBUwDThvHFkKVfH7HmTjiTFAy1XVbgwyqx9cL4LgBV7w77	450	3NKRZBNBqdudcYS8EoL7mvmaJbwHqAH4aTgf9XJ51ZUNbbs6x1JX	1440	1377	1	1	448	jwPm5zU1NrL8vdHZw8bP3kqWHZpyVPVnd1WvM6dNQePcPyH4abv	255	357	357	1616003460000	orphaned
457	3NLRSPQDMr9uLZ9jn3zkpSd3CMvht3ayf97uUvDSSvSGx4rUSnMz	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1599	1287	1	1	453	jwe5fb4CwW38KXkFDEY9wWNcFmTNYaQ3UrCP2Hfu9bUJEBSQ4mM	257	360	360	1616004000000	canonical
456	3NKoM1VxH5yuL5R9Aw1QT9VFwouFWS4ZFKvYokoy4nneYWC2MysG	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1407	1395	1	1	452	jwwKfrpMtQFgFBdYqD4pg5cTm8iFwAdGt1z9E2HPmQDZZ2VZdJY	257	360	360	1616004000000	orphaned
459	3NL6hTZv56Z3teHq64D8QMrnWm9Ba4RJaVjefAA1xwknvqqdy19Y	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1651	1055	1	1	454	jxpGvqH5Uhiuov6oT9awad2hefFtsd4pBnYTf561Mwhnip214U3	257	360	360	1616004000000	orphaned
460	3NKAeNaky9h4XanuyQXy9qe46uT4f8VZ4iETxK46sk5kQ8HrHjDh	457	3NLRSPQDMr9uLZ9jn3zkpSd3CMvht3ayf97uUvDSSvSGx4rUSnMz	1456	244	1	1	455	jxkYMvMP7NnBRTb2P8jUDoSCvFbnECYkUnz2iE2s1T9nY5DM5zR	258	361	361	1616004180000	canonical
461	3NLyEPh9ZrEyTK88kzSNtUk4hPYLjw6n5veDTv6zDQKK72bFeyVM	457	3NLRSPQDMr9uLZ9jn3zkpSd3CMvht3ayf97uUvDSSvSGx4rUSnMz	1623	830	1	1	456	jwn6k8AbKZgL1wDUJXRyyzBoZkuxfeR6nHUr8LKpWEizR6xbCwx	258	361	361	1616004180000	orphaned
462	3NKsDL7UTKidrZrwQ2BZcJy9MQRhpv7FGco8Dng1WXy1qFULe5E8	460	3NKAeNaky9h4XanuyQXy9qe46uT4f8VZ4iETxK46sk5kQ8HrHjDh	1407	1395	1	1	457	jxX1usu2wBWfaWFLtQ6DqYKzRT2ps8jmCpMBybTWecd4mVjwUMx	259	362	362	1616004360000	canonical
464	3NKuqJ13aUcmTsAJBdmuA5XsXTmybgyJptaTcb35Ec74UttkWcZN	462	3NKsDL7UTKidrZrwQ2BZcJy9MQRhpv7FGco8Dng1WXy1qFULe5E8	1490	1274	1	1	459	jwVTfjLCr84v5GPPfFG72sWzxo2r9BHoGes9t4bPeivMqe2KX2F	260	363	363	1616004540000	canonical
463	3NL3hSUiDjfYzQ3tpdecGBMTgQ85fAbqnPB8uten3AHdgKzobaLN	462	3NKsDL7UTKidrZrwQ2BZcJy9MQRhpv7FGco8Dng1WXy1qFULe5E8	1440	1377	1	1	458	jxMdbABm8YHJ7aasJZr4UXdkBPzotdMT8hUK3SZdYPUteDY4QQe	260	363	363	1616004540000	orphaned
465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	464	3NKuqJ13aUcmTsAJBdmuA5XsXTmybgyJptaTcb35Ec74UttkWcZN	1426	1238	1	1	460	jxMThTfi23qnykGVTUDj3iq76sET24XLi6aovR9gwnhw2goBNi2	261	364	364	1616004720000	canonical
468	3NKdQNMriDvCUr9kAMBrqdM8EiFTReKcYn29eFedudRhmGJRnRav	465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	1534	638	1	1	463	jwF8BcrhM9jMNvw7yqZZwHxJV4g2uxkwV182bVyk999UW1bsFhy	262	365	365	1616004900000	orphaned
466	3NKwxwe8PZ7NLjbQVcY2Jy3JwhYfcoTMcdYgsowsEaHgVKng8Asj	465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	1588	1392	1	1	461	jwQXwcLJz6gnY1VQEroMTm5Gm65Hj2ns1QBxYRzYuWe7M6JCirN	262	365	365	1616004900000	orphaned
469	3NKzj5BPi1EGZnaNpytc5hiz7eiKRB65o7D33xNeZ89Um8AoJmRX	467	3NKAY8PLSuKQdfH1XtBHRL4Y66nkCmgVAgncbAKagcPA5U4vY1d7	43	1064	1	1	464	jxPEa9ZpSgfB6n4PGUBBhQpmt7vp6oRojoDTrVBYuXYuXvsjvDa	263	369	369	1616005620000	canonical
471	3NLheZJyNoyxZYaKc8GGGaB4YdyfS9LZe2tzJDnMpf1sjGkB6jp3	469	3NKzj5BPi1EGZnaNpytc5hiz7eiKRB65o7D33xNeZ89Um8AoJmRX	1656	1343	1	1	466	jxZGQV6pLEVLmCzLkxThDcwnhYpDMVTr7ZCDvB9rQfG2q4ahQme	264	370	370	1616005800000	orphaned
475	3NKneazcQZKKzAHMF2kHFiqogsLgmqY8RVTWaa8cKzauP4pJaxwZ	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1483	894	1	1	470	jwnGbSJhqzZMU8wwnG1iZpSMMzycvNZVeeVjx6c1Bs9kMXtsdim	265	373	373	1616006340000	canonical
474	3NLjyHQKWiVBTvAkhqZEak3ipUmPcvCHrzk7MFPVPeNgZrbqaTJD	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1406	1393	1	1	469	jx5WaGzSJxSdX8GTP6TCSK2Mk2aZzgNUTbckEx6URh2chnqNnQW	265	373	373	1616006340000	orphaned
473	3NLqAfVw3VVCnbCeYjcBiF8WhQVbLjsF6psWs4BvZci4dVL8V9Kw	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1407	1395	1	1	468	jw9XKkxBZ1cW1qJaneF1RNkjS2oN4yQcnLJQ5A9cSwQ3RHeQXHJ	265	373	373	1616006340000	orphaned
478	3NLVNtVvdgqZ5JDjp361ZsJA37zSTS8FACboTfT7ms8RYTSBnVb2	477	3NK4V3wyauPAezphikyUgkQq9NRNX9fgiHdw6d5Q2wvC2aWaN2fs	1670	1282	1	1	473	jxBXdyGDRVdzDLEmzFbFKR993yskxyxFs3DWNLdsrg4n3DPZ6km	267	375	375	1616006700000	canonical
479	3NL1hYLpDSJZbQ2xZGiZXsTo9cCPtqbxcaS2TsXu4EnmtiMMGFnF	477	3NK4V3wyauPAezphikyUgkQq9NRNX9fgiHdw6d5Q2wvC2aWaN2fs	1609	1087	1	1	474	jxoYcMusPBtLC1VBmyDWNfSGhGY42FaHSBSGnuSfbo3h54MQG1L	267	375	375	1616006700000	orphaned
482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	481	3NKThxzkP5GcEqftfRSiSCgPhZcxnD7DQj1U1YmEAbd7JTpiobYJ	1503	1277	1	1	477	jxfqwfyZtw2LiDVGmSEH6ctpCGegepz2vtLqd95XFn6SbYjudbt	270	378	378	1616007240000	canonical
483	3NKBv5HL64TyUgAk8N8cc2WX2JSDEWbxr2XrBBpT23TuvA1s1XmV	481	3NKThxzkP5GcEqftfRSiSCgPhZcxnD7DQj1U1YmEAbd7JTpiobYJ	1483	108	1	1	478	jxEzHiWe2BVXEfto4afnoZgS4faz4CUVMG8KmpanM4xombPnFRJ	270	378	378	1616007240000	orphaned
488	3NL3S1uijngAMqnexmJJ5aqc2ATCzB294azRdfoUhkNmPYchknnM	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1590	1054	1	1	482	jxho1cmFWcS3ZLfjAe2Xh4AWyb3fzBzPbc815ZfpRZ4pP4fsWhC	271	379	379	1616007420000	canonical
486	3NKsPREqT97JQEvsFKNSvBL2LwXsTTHLLMggGW27bis6ZRbud1Tc	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1651	1055	1	1	481	jxENebVkwWzmDKLb6LVbjdSnM19jNWUc1XVGQCjLSbbJ7Wk4uA9	271	379	379	1616007420000	orphaned
485	3NKhAVEDtrv1gZS8ZSSrCe2bpSyr6P54R7fLpqZ5hUSJAXx2cpYt	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1506	1373	1	1	480	jwAX6Yh5J6NB76RnMReMxaoMWygTzrAnScU3pTFkp3eXKbYVFx3	271	379	379	1616007420000	orphaned
7651	3NK8TMUr2nHQbDWkNP7b8UP13sJnr1JtiXpVzjt4UDVGTYkcGAgk	7644	3NKq9a8uw3gSWQQ7RnZz7C3BXFBJTytmH7XbkgWNYa7Wr8wLb3oR	1607	1348	86	1	6301	jxqzQy3metmnrt5isKjC9RQp3Vz1wJTYWQHaLEZHs6STvq1M7ok	3821	5598	5598	1616946840000	orphaned
470	3NL2eErjBhjUPzKfoTTUDJx1cMPMXb5anSRHSZHTzf4RzheAo7VG	467	3NKAY8PLSuKQdfH1XtBHRL4Y66nkCmgVAgncbAKagcPA5U4vY1d7	1613	1103	1	1	465	jx8dWTugD348jiqS33TfbZ8oRozvbduUvwMU4teA5gAgfmYGLj5	263	369	369	1616005620000	orphaned
472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	469	3NKzj5BPi1EGZnaNpytc5hiz7eiKRB65o7D33xNeZ89Um8AoJmRX	1407	1395	1	1	467	jwpFLyvC6anhuvwB5dTLJu93XpsEZCcihSt9YxRW6XWpuexVrfQ	264	370	370	1616005800000	canonical
477	3NK4V3wyauPAezphikyUgkQq9NRNX9fgiHdw6d5Q2wvC2aWaN2fs	475	3NKneazcQZKKzAHMF2kHFiqogsLgmqY8RVTWaa8cKzauP4pJaxwZ	1631	794	1	1	472	jwLGE5REZmVwz7WeFAXSsQTTUQFLeiqGKaJpdPkUnXbwoKLGHfb	266	374	374	1616006520000	canonical
480	3NLnqr1cQFwJSgtZycKiutfWEp2WDwYmYWCR2Zg2xKid34wPNG71	478	3NLVNtVvdgqZ5JDjp361ZsJA37zSTS8FACboTfT7ms8RYTSBnVb2	1474	1329	1	1	475	jxEejDHnhQSJAu4rk32U6exhY6ujTaNA7UkTDc2JapXyhvbhpRs	268	376	376	1616006880000	canonical
481	3NKThxzkP5GcEqftfRSiSCgPhZcxnD7DQj1U1YmEAbd7JTpiobYJ	480	3NLnqr1cQFwJSgtZycKiutfWEp2WDwYmYWCR2Zg2xKid34wPNG71	1634	1331	1	1	476	jwm8b61UY9EVoBRRcjEcaBwTFmvySHtLzRUCcu77pSQsJaVzNmm	269	377	377	1616007060000	canonical
484	3NK8AqzYCPKg89PteBjG3Niv8S8Fi9yZhqgvzP34KrE23uggiqyc	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1406	1393	1	1	479	jxKrSpm3hcr8bgdUWAmjZ4pYULS8YJKWMNeZyhLtU9wEEVU6SqD	271	379	379	1616007420000	orphaned
490	3NLegoreZWiuK42oVLJ4RefJKo7pP9HxC7ZLTD5R3aGXrTXjyLYh	488	3NL3S1uijngAMqnexmJJ5aqc2ATCzB294azRdfoUhkNmPYchknnM	1536	1313	1	1	484	jxG3zrUKPSxNSP5sxtW5tneHwzeYCoRLD18oBF4wcaGdfLL7SUd	272	382	382	1616007960000	canonical
489	3NKaj125SVrZ9XzFb3EseE86kbvzLiErfTAnBiexfCxqpVsNzva4	488	3NL3S1uijngAMqnexmJJ5aqc2ATCzB294azRdfoUhkNmPYchknnM	1403	824	1	1	483	jw8BPu13P8jEvnS4QCZZHjh6i1D54Fs2usK3kd8eFBmU6NyCgVa	272	382	382	1616007960000	orphaned
491	3NKKyqEG72Yz9M28BEvxgi4wQgfnZm35kn1ztxUAWcidRNCxF96q	490	3NLegoreZWiuK42oVLJ4RefJKo7pP9HxC7ZLTD5R3aGXrTXjyLYh	633	1018	1	1	485	jwEgXfBdv1pLRe3kcYCs8kxFJWEc6jTTNfCpthUyq2mRzKJDdR3	273	383	383	1616008140000	canonical
492	3NL1R4et5p4BeHYSYFumuHJZHfnECkYd7NdwaMwzMzgiNVFnuSXy	490	3NLegoreZWiuK42oVLJ4RefJKo7pP9HxC7ZLTD5R3aGXrTXjyLYh	576	1355	1	1	486	jxKsvrMt2knm7Ky6gsh4RZhory3osbHDi8mUh9ATVPsnNUr4rHE	273	383	383	1616008140000	orphaned
493	3NLpdoGupgNLDPUoDpd4RGNpJgSUMWy14F8pbtmFmZhnMWS5gJex	491	3NKKyqEG72Yz9M28BEvxgi4wQgfnZm35kn1ztxUAWcidRNCxF96q	1571	969	1	1	487	jxAyqZ1CRkh9GMRjEZCCAtKCs6mvWk954MSCDfTopUSZXUZvgVa	274	384	384	1616008320000	canonical
494	3NKi7Vq6VyZWS4yvrmBku1vevnzH4hWfwVGnB22yCdz7Y1bG8So3	491	3NKKyqEG72Yz9M28BEvxgi4wQgfnZm35kn1ztxUAWcidRNCxF96q	1406	1393	1	1	488	jwd3EEeP8LwbSgTZbSkQ59oBZE9Zviy4fCxei7m2apvz9UVf4sn	274	384	384	1616008320000	orphaned
495	3NLcRJXE7zEfsYpxENDcAr23kmYWZTm4qKCeSmfd5FSnU9PWsBDH	493	3NLpdoGupgNLDPUoDpd4RGNpJgSUMWy14F8pbtmFmZhnMWS5gJex	1617	1288	1	1	489	jwn2zCK1XohsycKHkBnjcAfKjQrXLpSJg5Tr26XUGT65Y5N2CBT	275	387	387	1616008860000	canonical
496	3NLiDUAr9FR4NyE15mLVdoxx7sFdrjoM8h5GE1VnF8pUvKZrhcVh	495	3NLcRJXE7zEfsYpxENDcAr23kmYWZTm4qKCeSmfd5FSnU9PWsBDH	1647	1302	1	1	490	jxHdcTVzoPqYbKzSwJgnxWLEcA33fvZoJxzYBxmwAiSaZ1CApc6	276	388	388	1616009040000	canonical
497	3NLtz2f6CuF5H2ptcqtihjYPxHxxF8ACBjdnUidiMvk7H78Uqo3Y	496	3NLiDUAr9FR4NyE15mLVdoxx7sFdrjoM8h5GE1VnF8pUvKZrhcVh	1444	1381	1	1	491	jxcVYVaFxuWGTthSKaYuXKMGpZXvUqxaNu4NTs2HgLWo7qT1N4y	277	390	390	1616009400000	canonical
498	3NK63uN5Q95WhbS1jdWgJBdeWM3ftyxBBRjS3n4z3aU6yJ4HLB1a	497	3NLtz2f6CuF5H2ptcqtihjYPxHxxF8ACBjdnUidiMvk7H78Uqo3Y	1656	977	1	1	492	jxRYX32zKV8Z5NwKk6tDt8dRjkUyG8R9UH26cQE5yQkm2r6dCtZ	278	391	391	1616009580000	canonical
499	3NLF5ZQFs2M44c9jUvrnum9o746J2rnZgxEA51gQxUQRQJHuMo2L	498	3NK63uN5Q95WhbS1jdWgJBdeWM3ftyxBBRjS3n4z3aU6yJ4HLB1a	700	832	1	1	493	jwFdhRP6DzucHpbVKhMJKT52fRN35hs54Jqi4BHP4EKy1MY7Mqn	279	392	392	1616009760000	canonical
501	3NLn6GUP654hLLbXe2QhVkGLxJHyhKXuNtvy48hC2mK5h2T2PaQ4	499	3NLF5ZQFs2M44c9jUvrnum9o746J2rnZgxEA51gQxUQRQJHuMo2L	1672	1039	1	1	495	jxdk8yQiR1Nwb451h3fwaTrRLF8bhB7SVQ9EdRJwhSbixQxoQ92	280	393	393	1616009940000	canonical
500	3NKS4591rFCTxcapowbMcRTX6KA4eC9WvP2V27vgDndndW4LpwGu	499	3NLF5ZQFs2M44c9jUvrnum9o746J2rnZgxEA51gQxUQRQJHuMo2L	1527	1167	1	1	494	jwXjxSCWrkpsAJ51D6gi1czge1q6uezhpFURFBdNSfaEtyeqqzd	280	393	393	1616009940000	orphaned
502	3NKbLivvz5EN8YyCQHoKF1hQCSctofNcK5JUsy1MeBa8fNc6PtJw	501	3NLn6GUP654hLLbXe2QhVkGLxJHyhKXuNtvy48hC2mK5h2T2PaQ4	1482	226	1	1	496	jwdJiR9UvxNnk3sYwc6FWQwrwJG1LPpRQ42SaEBkQ1g9KBBfraA	281	395	395	1616010300000	canonical
503	3NLMciB9XuoEUo5QxnoN4znXbuFfXxsR64uDSPc1sJKkP28EeMsi	502	3NKbLivvz5EN8YyCQHoKF1hQCSctofNcK5JUsy1MeBa8fNc6PtJw	1403	824	1	1	497	jwNxMDTEiKx398JpmFsx2dLr6Yg6eJuKMzDD3q5GBQSEsi8VcPw	282	396	396	1616010480000	canonical
504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	503	3NLMciB9XuoEUo5QxnoN4znXbuFfXxsR64uDSPc1sJKkP28EeMsi	1461	1271	1	1	498	jwAVsgwHaPFpiCXSVJdiEEtEmmMCT91mfiL5fQkN1ehVyX9CNEJ	283	397	397	1616010660000	canonical
507	3NLmWJGjYzQ2umAFAVA4cbnmqhCYcYHCe5RJMh3wtrnd59iAeCVA	504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	1581	778	1	1	501	jxiNLFkg4QL7bjZJQyKA6iMByQ6cG42j76t937koCyf9j7Dd5wR	284	400	400	1616011200000	canonical
505	3NKGpTxox935efB7sPUDU3jL8fwxt1QMD6RV1Z5nHwqd1pbfmWoA	504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	1460	1198	1	1	499	jx2gxcC5NMXsAvgm5Cmrz2TbiQy5rpPsa2eYvCBMF7SndPtkZbB	284	400	400	1616011200000	orphaned
509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	507	3NLmWJGjYzQ2umAFAVA4cbnmqhCYcYHCe5RJMh3wtrnd59iAeCVA	563	1113	1	1	503	jxyi9GYw2kv3RkE16h581vDsfN5pDQwmCfX6n3YxJDRTHpt3NcC	285	401	401	1616011380000	canonical
508	3NKELvoHSPjJ3NpNvhbMzCQwsMs1YHkv8a8zJiFapFZF57k9LSeA	507	3NLmWJGjYzQ2umAFAVA4cbnmqhCYcYHCe5RJMh3wtrnd59iAeCVA	1458	1077	1	1	502	jxZEoa9GZW4qvEpGKjzPFiy9v2AXDFB2A1rq2j9dJ29GtbLfLEF	285	401	401	1616011380000	orphaned
510	3NLK2nmLyvnjkQ4u6EC9WxRNWZKF6eBW4QQEDvCoP4dRMufyZMjp	509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	1405	849	1	1	504	jx9otETpDgbpKkxH8itxZkHLyPtrFbRMNfP8FgDRo2hDrqr95Wx	286	402	402	1616011560000	orphaned
511	3NLRui1UYsMseTJzr8ZdYUsGuLJNtbqV7occfaHzQ7XYoQ7BuKJ7	509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	1517	197	1	1	505	jwVLzPTdsbuyyFC9TDTRa2XmqL4r4exniiy4DTgNLJDCNHNVrDZ	286	402	402	1616011560000	orphaned
514	3NLWPavoWPgLg3EPB4Ja2V62V3wNtGUStVYSWqEC7mmhsRMp9gFx	513	3NLaTehr2ZSL4LqE4zQkCaKznrRpwVKrovrgeJHe6raiVnhbUq4P	1460	1324	1	1	507	jxMivgEmxoi6fwqme2wWGVrgwC6qe6jHfkWw2JBGuUhagPE7t3c	288	407	407	1616012460000	canonical
7399	3NLJnYm5NPjYNfMvuDhYHkgZoJNLiiNNNfwpviTwsXDuAxJYYhWr	7398	3NKTPxcpRLhztyNx8MAvbjevic5uNVn1pK4XHbcYxWHSoYQi3t1h	1476	1245	84	1	6301	jwFRyaVSRxmi5aF65EWmWEpqPF3QAMRR3JtfGN3phem1SStMDh3	3822	5401	5401	1616911380000	canonical
515	3NKTPvUGkbswczqo9hJNkmiUtLDqzdaHD8fgzYHrunzmVMpQDZup	513	3NLaTehr2ZSL4LqE4zQkCaKznrRpwVKrovrgeJHe6raiVnhbUq4P	1483	1030	1	1	508	jxSFWd49zSwwhKpgvtaSSt6VF9TcmugTTsvHgrPyyinHPngSr5L	288	407	407	1616012460000	orphaned
517	3NL8Ejp27qj4EZT68Z4zfP1yZHZcLthd17fQUU6PF1TtaTVx43wj	516	3NK8vC11n2vWYBrztr5S8KPFvP6DQ4s9rDECKYifZJNAdfg39bAa	687	687	1	1	510	jwxPaiGio8X76AbqfPHfz3EMmkuEA76q37MBV8en7WXQRrVkibF	290	410	410	1616013000000	canonical
518	3NLUmbA2WYSJToMCwBFaAokkpjAq5o5bDQGfLiwbUnbxuMnLud6X	517	3NL8Ejp27qj4EZT68Z4zfP1yZHZcLthd17fQUU6PF1TtaTVx43wj	1460	1078	1	1	511	jwRDbnjrJTYv48t8VdmeDZVGCVKpwe4pABy7btbDKoxoVFfVxcH	291	412	412	1616013360000	orphaned
520	3NKWbkL7bDA8mnEyTHnsHjS269AJHkYh4XZ36Ab9EMeSAZiDwQpw	519	3NKLjgEuAFmcJzKLkaHCCxsng9PDdWp6ARsYDudwa3XKKpFXeck4	1403	824	1	1	513	jwbdddkr5g5LtZihqXfwfcQFJ1jRbYiFwQy5ty6ok9HqzUyDNuh	292	415	415	1616013900000	canonical
521	3NLVGwAyVhdxnd56TwfYqqfkZpufEHwghyEEEcwJ1fQnfUr5FJTD	519	3NKLjgEuAFmcJzKLkaHCCxsng9PDdWp6ARsYDudwa3XKKpFXeck4	576	1109	1	1	514	jx7t91eEoFmdPoDCzorCVNAs6H5U3C6x8PeRLVYB5xLXy9f1gHp	292	415	415	1616013900000	orphaned
524	3NL7d9qrbtUK9veMiM83onqvXh7KhZepqhfHTY38vv5J7N5Yc62c	523	3NLa2BY6XBKhtNBGt9toFubHmaDA1c6bumo7xtTBJWzCgPiAZLFj	1406	1393	1	1	517	jxQZsiD2stGxoxxfbh21wE9zLLCVmz6hubsWCF3ynK6h29mHLKA	295	421	421	1616014980000	canonical
525	3NKuvVNi87EcAAkHRaPruK1zbo5smMs5cESArm4dZwKtne2FaJLM	524	3NL7d9qrbtUK9veMiM83onqvXh7KhZepqhfHTY38vv5J7N5Yc62c	1407	1395	1	1	518	jxmBpzJCnkB5HrPSrgKSxyx4YQjaA5M8fpMTsWTELaEAgBJePBN	296	422	422	1616015160000	canonical
526	3NLTaDbarbN7dgm9APz7Bq1FfrJf9HTZQED1V2jx5E72t5XVyXAq	525	3NKuvVNi87EcAAkHRaPruK1zbo5smMs5cESArm4dZwKtne2FaJLM	1403	824	1	1	519	jxeCZAZ1j8ZPhVnuLUdZLYRFWf4659wHBM8L6nWyYfa35eRi38J	297	423	423	1616015340000	orphaned
529	3NLfk4TrZEDFU7ekD4uxDEBY3fG7qp3M8nfufvRrdmpYZjLvyiF4	528	3NLqyguzus94qW6iC2TUZzzB2hqoZw7sqQhWLKvHHNwmHfhcBuuQ	1500	1297	1	1	522	jx9TDT44BCumPj2n8NpacxaZUhZzsEnLLdo2VkzAdgA1vM7P51z	299	425	425	1616015700000	canonical
531	3NK5YnUDoAzXJr5ZuimsYb2g4AeugEVjfGA6dZqnvQHcptWzJ26N	530	3NLyNBekM9J9Ghfc6jpzXgy3sFp4tumguVV4csXHBqsfA5HqGd18	1631	794	1	1	524	jxDFTndQj7y4dnrNs3D9RTmz4zxehnHDU4yBGLqZPktakB2pfKr	301	427	427	1616016060000	canonical
532	3NLaqckVBiJJDRwYjnXeLJXM93zzgD5k7K7oMZqs8SaBxisKsFX7	531	3NK5YnUDoAzXJr5ZuimsYb2g4AeugEVjfGA6dZqnvQHcptWzJ26N	1402	807	1	1	525	jwEe8VbhTzpW2X4L89ik4H69L1iWaSXDni6mfubCJupsuSwxEAz	302	428	428	1616016240000	canonical
534	3NLL2DqWf4AYfaLqyQBSAHJurhrM2L3BCaxckMduUVNECDfSmWiv	532	3NLaqckVBiJJDRwYjnXeLJXM93zzgD5k7K7oMZqs8SaBxisKsFX7	1458	1323	1	1	527	jxzn9x1dUWssqXmeXqo5wYh4GkMcHdsD5qL77VGxnUKccfPwnUG	303	429	429	1616016420000	orphaned
535	3NL4V4HRon1pnDc3r7uGAynyMwSS33Z4D9dA32UPPoiGvhLJaGyq	533	3NKQvqG1a5MJrtRaJHezuASArkDZWtMV6UfJMUUR5gQ8qTcSmEvy	1657	1218	1	1	528	jwDMuEs79eNtJUx7SQXE669zi4fKVj8JYwjHP4Gfc3mhZ7YETp8	304	430	430	1616016600000	orphaned
537	3NL5qBpY57zQnYgyK1TL4kWsiG7EFhLuqjmT7CZtQtxhPCw3GGue	536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	1406	1393	1	1	530	jx4EEpw5XyZffTD95mMaaHfsku2K4d5E4gqh7wNurLB6fDiZibA	305	431	431	1616016780000	canonical
538	3NKvDYqMnmpR9kgsUTnyvbanh33khJkJvwhSDxwud3ELQA3cWX9r	536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	1508	1387	1	1	531	jwKpk7vUBmewpsXtXPrFjZcCTKiDTueXKpvUVFmTi3kPJ9ALnaE	305	431	431	1616016780000	orphaned
540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	537	3NL5qBpY57zQnYgyK1TL4kWsiG7EFhLuqjmT7CZtQtxhPCw3GGue	1609	1333	1	1	533	jx2qHzYpymrETxsLBJie1fv1pCF4zcjXvBSk8WunfjAdk4AVXhd	306	432	432	1616016960000	canonical
543	3NKLQu98TFYw7D7KXaAG91Rz4yEPJq16EEFStrrA4k5hmuJnwH7q	540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	1457	1391	1	1	536	jxJsHdszc1jNBDcUFbYEWhMwSM9Gv3AgNGADc4eMEdCVG7225tr	307	433	433	1616017140000	orphaned
546	3NL1RXdg4r37MmbYca9qLCZyoRCNiqfSoMzCFJ11S56L9e6eDPT2	545	3NKzXZQ1SafcWwpk8i61bbPZX2g3Yzx4cq3Wii56teHGH2is9Det	1648	1038	1	1	539	jwoG5jc5okXd8hhKgzYb7CkhmmG849CvVFpUZhawjVG6Ph8JpvM	309	437	437	1616017860000	orphaned
550	3NLNGqDy93b9ikqNb7SAfz7aPq2NtfnLjaC1uVNrak8GEjVTyyPA	548	3NKqx1YQwo1YtAx8kU3gbkfTpDNykg29DCEiThMhMwHx74rh8M95	1646	1354	1	1	543	jxF7mzsgGghfX1ph1NoHH1sxihPVDTQ1wHdGqNuhUKzo77nmGCg	311	439	439	1616018220000	canonical
553	3NLEy6mCYg1DS5Eg9gMKL3n1wBQM17JLXMJeN7fKbMj5t34n7Fvo	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	152	1084	1	1	546	jwkyMhmRcEwh3cyjTq1awcGeDNPqjhmF2aTmWE4Q4uyi8kso86d	313	441	441	1616018580000	orphaned
556	3NLs5fiUVxttbxgLHjaZti9AdXYB5TeWoW3t5piVDE9hf3RLLstK	552	3NLHruUPfiVugvGDEUBMLkWc68oyZxZ6mmLQRSdPf7v7Th6FgTGY	1476	1371	1	1	549	jxJLFA94DNPhkJzWRKkvHRWbpsdRqrSkMdsf3CDJ3gF4SMUSQPE	314	442	442	1616018760000	canonical
559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	558	3NKTaN9cmsb8KQVNtJyW8nAXJGPgGZVWH4WhNgEfpyX2q5R5KBEZ	1403	811	1	1	552	jxdWswU9epZk4rTQEFxAvM6PX2jF1VfGYqNtbvmcNPmdekWRh4U	316	444	444	1616019120000	canonical
565	3NKTNkFd9pmPpv2rK6s7xXcSKCrdbBrsmnJbwFJUB3WH75kUc6b2	563	3NLvk2sX7poiZhhRmxj8iB2521uXbB352Hrf2etGNNfpE4P3Vgjg	484	1319	1	1	558	jxD3XRqNtDUjeDwiLgE1npUFyfcw47AVLRdLCFfVhvBuEdBUdmZ	319	448	448	1616019840000	canonical
568	3NLgBLZKt5j1AWBHLQLS4KfRctqMm9PT9xuNoTz9xTARRymiqJbf	566	3NKVymQwMRHhaQse4cDt5uqiXBRxSAWCaeYAcmfQsqif6BM2SwJk	1403	824	1	1	561	jxGgKAhkLh1ipWn1P82jGGXQZ7H9RMiGs4WCoJ17BNVw8fWyJGp	321	450	450	1616020200000	orphaned
571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	570	3NLAStcBA6mgqfTKyP1V1UfhiJdJ9n8zZHWFCcXHCBfH6UN7evJA	1451	1046	1	1	564	jwbLyH6vmyNijKmBqFkfeVwMh2EXdb3YhxtaiNq3th4p3DC5QMx	323	452	452	1616020560000	canonical
574	3NKmU2r7wDMmwTSDH6C3NMQEZhbF8nhc7T1DKvSaCYYgfGeoqEdX	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1617	1042	1	1	567	jxaa6fuNJ9wReggUxvxca8t3KzpCeSnRDTitjjZkQiqu4EjzMmG	324	453	453	1616020740000	orphaned
577	3NKawRzPLjzyK391HvfFAKLTsH1RsCJXtc5CoKsyrfq2CRCJzEnd	573	3NLhKdEji2R81drSvzPskybWTMuN9pvr72CrnzV4YcXuTs57D6cN	149	1037	1	1	570	jxHZbvZuZzLL7Vf1Cax7Ho7adCSuPfcq2jHyS1TEKfu4DLAkg37	325	456	456	1616021280000	canonical
580	3NKyGsgzCHWWHnQs1ttV8MdiMVuhHJMuyYP7u4SDHBhJQeUqYjNu	578	3NL9bRYB7nU47SHRCkn7YrTN7qtELgAhThtsjZo9pPSs3H5zFc7x	1501	1234	1	1	573	jxg65jxp9gswCj83LUW1JGCXy6c8XADZhPJ77ko1s7ABFghV3BT	327	459	459	1616021820000	orphaned
583	3NKk5UgwsE8a8s7DXK4FY9aRuTy4w8V4BwuW2vvEu8LdFnXUaSKR	582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	1457	401	1	1	576	jwfWisov6V72R18AD5icttL1kbJTD5PecBYzvAHeXtEKuJ15Jta	330	462	462	1616022360000	canonical
7419	3NLUo5FbZpT9Pn9U8FWhTdLu2WQpzaGuMMk3ZHBCW1NytEjza6ja	7417	3NLfodMP46EP2Y1pZdrwHd7wYMiB87sne73ADoy4xYBHCSKGJUCo	1460	430	85	1	6301	jwCvbuf5Tr9f7CpfUKipE3Y3NtFfcsA1tPAqGwbYoimFmu2m63q	3833	5420	5420	1616914800000	canonical
516	3NK8vC11n2vWYBrztr5S8KPFvP6DQ4s9rDECKYifZJNAdfg39bAa	514	3NLWPavoWPgLg3EPB4Ja2V62V3wNtGUStVYSWqEC7mmhsRMp9gFx	1460	1078	1	1	509	jxZRLUk9BscdxSpCTVUBabwqMGkDnXhs3w8rjPgV5axkT5Jouix	289	409	409	1616012820000	canonical
519	3NKLjgEuAFmcJzKLkaHCCxsng9PDdWp6ARsYDudwa3XKKpFXeck4	517	3NL8Ejp27qj4EZT68Z4zfP1yZHZcLthd17fQUU6PF1TtaTVx43wj	1440	1011	1	1	512	jwCrJp4rkFv8DnHY2QxSHNWHryXQa8EstjtdkrjftoCWPUgUFcC	291	412	412	1616013360000	canonical
522	3NKj1D2zRTcobUMuUAkAbDTZTwSK3twroWGfzQiGDhNoaZdffRCc	520	3NKWbkL7bDA8mnEyTHnsHjS269AJHkYh4XZ36Ab9EMeSAZiDwQpw	1419	814	1	1	515	jxFfcApN5Q1kSsosExx2kiLQ5mj2d5rshqSm7rBKbMrsRmuigHD	293	417	417	1616014260000	canonical
523	3NLa2BY6XBKhtNBGt9toFubHmaDA1c6bumo7xtTBJWzCgPiAZLFj	522	3NKj1D2zRTcobUMuUAkAbDTZTwSK3twroWGfzQiGDhNoaZdffRCc	1610	1188	1	1	516	jwQsz5kh1Y6DDsLMNELa3kAXXUJ9qSCo1Ddt8kNPERS6nj3jKZh	294	420	420	1616014800000	canonical
527	3NKJqaYgfYiTVb2RXiKLkzPQzbruWNShRHw9szgES1uPySpMC1ZY	525	3NKuvVNi87EcAAkHRaPruK1zbo5smMs5cESArm4dZwKtne2FaJLM	1637	816	1	1	520	jwr7nk48fWAtYqjPvkgj5QtDTmRUwPZsAfeLSuXCV6eWHPMNF42	297	423	423	1616015340000	canonical
530	3NLyNBekM9J9Ghfc6jpzXgy3sFp4tumguVV4csXHBqsfA5HqGd18	529	3NLfk4TrZEDFU7ekD4uxDEBY3fG7qp3M8nfufvRrdmpYZjLvyiF4	1401	71	1	1	523	jwoQDMYpP8C4bxfvaqyMj3jitcaRCR3qntoXRh4xcrXL5bjDiT4	300	426	426	1616015880000	canonical
533	3NKQvqG1a5MJrtRaJHezuASArkDZWtMV6UfJMUUR5gQ8qTcSmEvy	532	3NLaqckVBiJJDRwYjnXeLJXM93zzgD5k7K7oMZqs8SaBxisKsFX7	1407	1395	1	1	526	jwHWK4eiRfXYa6enbyTLBEWjj3KzEqZvHEsgRmyeku5bH1jVE3Q	303	429	429	1616016420000	canonical
536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	533	3NKQvqG1a5MJrtRaJHezuASArkDZWtMV6UfJMUUR5gQ8qTcSmEvy	1637	815	1	1	529	jwVPd6VGsz54gvPNNcJUMVVhRN2C6jmYURDAknTGeT1DqK79Epg	304	430	430	1616016600000	canonical
541	3NKvMjGv26YCWaNR98fME83Qxnjn1HUBSHid6V3CkF3QyJrt6iEb	540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	1406	1393	1	1	534	jwGm41Gk1oQEfPS31da8oiWWi1X5a2GBM5euNtxfkWwBAhGGaYm	307	433	433	1616017140000	canonical
542	3NKy12UDjbMnNBtTSZRwgdwBDR7AJztRsFoX9z14CDxbYQwUQEjX	540	3NKfuV4CXefA8BDNTpJfrximFsiSwEU1ZiSsa2NchKaNkbq3hScX	1405	861	1	1	535	jwf5FnBv7Vrtg6W7mnD62U6r7Sezaw7fBqM2YJxijFcphrzWcvK	307	433	433	1616017140000	orphaned
545	3NKzXZQ1SafcWwpk8i61bbPZX2g3Yzx4cq3Wii56teHGH2is9Det	541	3NKvMjGv26YCWaNR98fME83Qxnjn1HUBSHid6V3CkF3QyJrt6iEb	1623	830	1	1	538	jwqTBeFfhwNkrkHeLJkxN62P4GfjdkvV71iERdKhLarX1WD5Gx4	308	434	434	1616017320000	canonical
544	3NKnys9eTgvaKvnZfCt1SRJprh1YAjoidjtY9ByubfsRs7XhVe7T	541	3NKvMjGv26YCWaNR98fME83Qxnjn1HUBSHid6V3CkF3QyJrt6iEb	80	1027	1	1	537	jx6fNCzntQ37PCiFyQnaRqeMzAh7JLFt11JEVeCNFv4VHeR1aFk	308	434	434	1616017320000	orphaned
547	3NKt3FDcs1PLz3mnRQaDehxXuLUnCEsMKF2A3SrKsxkgoqG4ggHg	545	3NKzXZQ1SafcWwpk8i61bbPZX2g3Yzx4cq3Wii56teHGH2is9Det	1406	1393	1	1	540	jwzupj84nNm4D8fudczT2VRpYne4yCjTYcZW9gnGoeoLifThPv8	309	437	437	1616017860000	canonical
548	3NKqx1YQwo1YtAx8kU3gbkfTpDNykg29DCEiThMhMwHx74rh8M95	547	3NKt3FDcs1PLz3mnRQaDehxXuLUnCEsMKF2A3SrKsxkgoqG4ggHg	1406	1393	1	1	541	jwrb1ae4VgRAn5VnxczswzJsXpHiT11u6fJeLqPbiK8gvkc36gM	310	438	438	1616018040000	canonical
549	3NLpWvMnyUKWNXndN4LZL8P2UyfGuEbTLSJLDugAebAigrauC2AL	548	3NKqx1YQwo1YtAx8kU3gbkfTpDNykg29DCEiThMhMwHx74rh8M95	1406	1393	1	1	542	jxPv1qJw1xXLASUb1JMFQ7HMRXwx6koqGqcUjcxSWSKAVSUYDV3	311	439	439	1616018220000	orphaned
551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	550	3NLNGqDy93b9ikqNb7SAfz7aPq2NtfnLjaC1uVNrak8GEjVTyyPA	633	1258	1	1	544	jxyZ5kTrxkmZgtseQMdKPka6SA82uZqGpVB53hhCK6r2ARFebLc	312	440	440	1616018400000	canonical
552	3NLHruUPfiVugvGDEUBMLkWc68oyZxZ6mmLQRSdPf7v7Th6FgTGY	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	1588	1026	1	1	545	jwh4m8yZ8RKH2Vw7xBkSB5KD9YcnJf2mW6DGZjdoDtccy2CqeFi	313	441	441	1616018580000	canonical
554	3NL5bMFvv1XLb9ZntdK912bXG1qr2LBTk7g7GK1wEwFXAwCuKST7	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	1619	1275	1	1	547	jxPFydmAnELV9eCpiSsV1DuXvn2hvgokWY1Teq5SpJFfXWzPgxQ	313	441	441	1616018580000	orphaned
557	3NKotxAdCPAKAG2gQYb4QLboWCMjTkjFH8nkCLcBMkn7MiJcHfrK	552	3NLHruUPfiVugvGDEUBMLkWc68oyZxZ6mmLQRSdPf7v7Th6FgTGY	42	1361	1	1	550	jxivBbUtn5r8NjUg2uECTMwkS6cBzK4Bry2UVNiuhiQavucarJK	314	442	442	1616018760000	orphaned
560	3NKkADv6LNAeuJNHtkcLsWBMFXZNN1qMKaXQfCwi15Bmr9Cs9QDw	559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	1403	824	1	1	553	jwjwdvvGiqC5ngz5XBis2NuxcJFMkMctviRbmtPMzvnckfmTBn2	317	446	446	1616019480000	canonical
562	3NKh3VUUt7yhGxhPE6hagzFVifRj1a6oZXZyzrfk1B8Mmp6qPqSi	559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	470	1309	1	1	555	jwpcFstDm7KNCAyWukDEPvXA13waMYjAGMFsZshCNHv4Vzm1zd9	317	446	446	1616019480000	orphaned
563	3NLvk2sX7poiZhhRmxj8iB2521uXbB352Hrf2etGNNfpE4P3Vgjg	560	3NKkADv6LNAeuJNHtkcLsWBMFXZNN1qMKaXQfCwi15Bmr9Cs9QDw	1607	1222	1	1	556	jx5mKn5PxaE4HtsVbhGtrMM2JBiQZXQTV2FSHXgZeVtzncJBUjs	318	447	447	1616019660000	canonical
566	3NKVymQwMRHhaQse4cDt5uqiXBRxSAWCaeYAcmfQsqif6BM2SwJk	565	3NKTNkFd9pmPpv2rK6s7xXcSKCrdbBrsmnJbwFJUB3WH75kUc6b2	1406	1393	1	1	559	jxnFa8gzPi9kynk6kFQ6wQjuXr4RdbPzu1oJcSiEgv752HTJc3X	320	449	449	1616020020000	canonical
569	3NLdH55p95q2GviiTVLVEzdz6bkrXWAy44etMzT8TLWTrwRfsa5C	566	3NKVymQwMRHhaQse4cDt5uqiXBRxSAWCaeYAcmfQsqif6BM2SwJk	606	1295	1	1	562	jx15i9cFkFp1HjtgchDgznMVkNfzjPtRC2giZMsee4G63jJwQXm	321	450	450	1616020200000	canonical
572	3NKJvdnkY43kbCVpRHg7kiZ1F9kMfjcoBqhY3H8SwnWjzJ1kmUkA	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1406	1393	1	1	565	jwvatWDiBHYBVSCmhwB6ctmH7sRyrWoatFcWoY55FKQjaotwUf7	324	453	453	1616020740000	orphaned
578	3NL9bRYB7nU47SHRCkn7YrTN7qtELgAhThtsjZo9pPSs3H5zFc7x	577	3NKawRzPLjzyK391HvfFAKLTsH1RsCJXtc5CoKsyrfq2CRCJzEnd	1402	852	1	1	571	jwvp1mL1tResMWtgdu5tyDic1dHHk4fpskevBSrd7NggTmCmWnn	326	457	457	1616021460000	canonical
581	3NKBioP9qbXeoixxcPdUoKaPEPRVLBzEy4YXGM3jA7tJRcLg8FFR	579	3NK7W5va9JDQGRX1wLZtXh1xEEBpdur5zSxw1LtX6VcSNRdrK4TE	1649	1383	1	1	574	jxF9FTX1VoZXq6BuZfKh45sEfDPHBA4ZEVSkkKVhyBA9mRAtd9L	328	460	460	1616022000000	canonical
582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	581	3NKBioP9qbXeoixxcPdUoKaPEPRVLBzEy4YXGM3jA7tJRcLg8FFR	470	470	1	1	575	jwRvGoXaTmckGZ1LN2pU7xK4URuztdTesLwgwxve9a9sCWMp49j	329	461	461	1616022180000	canonical
586	3NKtDwm1BrLNbVNtu9fH4ED4WREdsj1RUSqgrMJDbiocn8rrJs8Q	583	3NKk5UgwsE8a8s7DXK4FY9aRuTy4w8V4BwuW2vvEu8LdFnXUaSKR	684	1352	1	1	579	jwAbQpEe1LpAMwBt5rK7JUKbCemWeRiJ6hQvEqNdURdKmcwKGTq	331	463	463	1616022540000	orphaned
7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	7426	3NKYPuWKUVpV9s3pV745Y25BifqEPXC8zrKQxoXyxpbRraZz9LP4	1594	1326	85	1	6301	jxkKJ3jiw9aPmhaWas1HgdTuyQevQFqhFqPw5uK5mP2P3iQqf95	3838	5429	5429	1616916420000	canonical
558	3NKTaN9cmsb8KQVNtJyW8nAXJGPgGZVWH4WhNgEfpyX2q5R5KBEZ	556	3NLs5fiUVxttbxgLHjaZti9AdXYB5TeWoW3t5piVDE9hf3RLLstK	1406	1393	1	1	551	jwsDuSmkozxV8RtytjJ1EV3KbfTDMMAN4JBzhzB1x38sgWka9V8	315	443	443	1616018940000	canonical
561	3NLiCLGNwFxs8Hy7NgNMV3ZnvV7k42NxBHaZSeT4HiWDwTU1EyLn	559	3NK8jgGEUNidgPPan72CN9FDzbkqvtZam6E7qP3B8kxZB1f4nUpA	1648	918	1	1	554	jwN73EScmCx8YXQBQUbpwVw1uy1Sjf58GDsp37c6XgQ8R9rvckf	317	446	446	1616019480000	orphaned
564	3NLpfRhYxHCwqDaWBRWfTUWENc97QQzF8DzMLa5V5bM92QcdzN8k	563	3NLvk2sX7poiZhhRmxj8iB2521uXbB352Hrf2etGNNfpE4P3Vgjg	1403	824	1	1	557	jwNrZKLPmdgQHaVqJew81RpeeV4MwfDcivagKagQ6tduNTbE9tD	319	448	448	1616019840000	orphaned
567	3NLErxp4MG8yDV3KjMqDUTVB7qc8fTf4VjbBxeVPwRMvHi8miQSF	565	3NKTNkFd9pmPpv2rK6s7xXcSKCrdbBrsmnJbwFJUB3WH75kUc6b2	1555	1221	1	1	560	jxqKWaXe3Lpm972Fp1PKJhfwnsrqUaFTzZYgHAkwraeP4V1CYts	320	449	449	1616020020000	orphaned
570	3NLAStcBA6mgqfTKyP1V1UfhiJdJ9n8zZHWFCcXHCBfH6UN7evJA	569	3NLdH55p95q2GviiTVLVEzdz6bkrXWAy44etMzT8TLWTrwRfsa5C	1581	778	1	1	563	jwJQZMqK2Jgcf5LjgovPxNtxaa4YdZUoDBEqCcLu2RwSnvtd4eQ	322	451	451	1616020380000	canonical
573	3NLhKdEji2R81drSvzPskybWTMuN9pvr72CrnzV4YcXuTs57D6cN	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1619	909	1	1	566	jxW5CYyqKewbtFfpcR5poicBm35ddGwjA6WUxMVviM6GYDB7s5G	324	453	453	1616020740000	canonical
576	3NKAafy17sWJvqNbWuzLy97NC37cFWmRQM5isxD3u8p3V1qYNpkr	573	3NLhKdEji2R81drSvzPskybWTMuN9pvr72CrnzV4YcXuTs57D6cN	1599	921	1	1	569	jwTGw3QakREA88ZYtYLzFapTtu2nPXcirG2TiU7vvU8WwMhEvPC	325	456	456	1616021280000	orphaned
579	3NK7W5va9JDQGRX1wLZtXh1xEEBpdur5zSxw1LtX6VcSNRdrK4TE	578	3NL9bRYB7nU47SHRCkn7YrTN7qtELgAhThtsjZo9pPSs3H5zFc7x	1407	1395	1	1	572	jwzuYie9xEKvAAi7L1Rh7CG84sHFiRtgBS9CmTdxXq6b8hjaQnP	327	459	459	1616021820000	canonical
587	3NLZEH3KrGSUk2w56hCTn6FyCFHTnTBjHvijkGgmrbiNiXzoF8WH	583	3NKk5UgwsE8a8s7DXK4FY9aRuTy4w8V4BwuW2vvEu8LdFnXUaSKR	563	993	1	1	580	jxTmeKhnHrAE9gjbCSAdo99hiFdmfsQe3cV8gHX1ZvpCKrRTBxf	331	463	463	1616022540000	canonical
588	3NK9NJ9ZpuncuyZw2Lo7yZURGWPeKYK4EJaaMoCMFmYZRMJ8BLqZ	587	3NLZEH3KrGSUk2w56hCTn6FyCFHTnTBjHvijkGgmrbiNiXzoF8WH	1406	1393	1	1	581	jwfc6cvRu2UAYreJr6ZQQtpgfLB9Kjhzt26gr4r4PzMyLVk2pL9	332	464	464	1616022720000	canonical
589	3NKt5pQpZUXLbYGe3Cf7KMHy4d381V7RRRwXc3aU9f6pLCZpy987	588	3NK9NJ9ZpuncuyZw2Lo7yZURGWPeKYK4EJaaMoCMFmYZRMJ8BLqZ	1460	617	1	1	582	jxckeM2Gq7kyymTTU9yfxCAdiTGaMqk6Lmvgs4LUCEWGfkntsk3	333	465	465	1616022900000	canonical
590	3NLXhcxVUNc9aBi7Yw1bwfxMyURJDqQfhUV5KE9v8bE51VKrUnSZ	589	3NKt5pQpZUXLbYGe3Cf7KMHy4d381V7RRRwXc3aU9f6pLCZpy987	1406	1393	1	1	583	jwfeiPbDom7d6w7ELxLconMoZqQMpqpymPN2MVAC52vzPBWM123	334	466	466	1616023080000	canonical
591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	590	3NLXhcxVUNc9aBi7Yw1bwfxMyURJDqQfhUV5KE9v8bE51VKrUnSZ	1637	816	1	1	584	jwvUgveJ1ZRkVJU1FN5f1TVGd1mjcKyZt1iYpauA1bYPsvijdB3	335	467	467	1616023260000	canonical
592	3NLKLMFAwDMFG5ciJfBG9bE6snrWVoFuez1sC5XhZtQC8VeCpmfo	591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	1500	1297	1	1	585	jwsMEDj2kaCAQVihkEedSQ6gPWkbmNPpkDPxMLHo6p4xSwRLugr	336	468	468	1616023440000	canonical
594	3NLgHMgLExtTteHj8fGh1qtChV25xNh5qt6RTzfgw7pwSTx8GQkG	591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	1649	1383	1	1	587	jx4dAAMnWNAWZTfJgZqyxZiC97Gxrtb99vbKUvHmAzM17dcTY3m	336	468	468	1616023440000	orphaned
597	3NKgZKWsVJ5Tr4VjSsi3YtoUAkeXh9fVtv5s92nHWzZWJS8xrgSg	596	3NKETdZnRgXNbsVtwsHXEf6YGYBrbJ7hy5i6qk8HhD2VoADnVMrw	1476	1371	1	1	590	jxPi5zsG86cTtpTr7rqjqs2A32o93QS3mmz6cuAVm6ZbcTohRxx	339	472	472	1616024160000	canonical
600	3NL7fjr68ek7KDNPhX5gbLqkiqt5qWzEXJnpK16Pun6Qdtyf8JCE	599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	1407	1395	1	1	593	jwBwUWqbu8MTPWw8gNYFADR28xitCQqHBGYnQA8UB67yV6jNjQp	341	474	474	1616024520000	orphaned
603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	1516	1168	1	1	596	jwXkuz3e3XpgsS2pW26vgvhXrJFgdHdvLafH28RvfnsfmKAYM6e	342	475	475	1616024700000	canonical
606	3NL9Qq7cgkqmQTshbpUn9MpnGn3qW3ch3tESXBiQGsXmSENjzEmf	603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	1406	1393	1	1	599	jwyqq8KGrjbsf3Ntp6yyWt8EujeofjoGNXjsaYiK3xz3EfNQNGf	343	476	476	1616024880000	orphaned
610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	607	3NLtJZ9SyFJ9vx72Vw1s7TGCC7w817TSdp9QoiuSDtTkdzxQKjR4	1607	1102	1	1	603	jxB57bX4sPzY74G71yE8uFituWfFzzgAWQYMXaGtcuMNfPxhjqb	344	477	477	1616025060000	canonical
613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	1483	127	1	1	606	jwLmFMBid99yTnQbRwSd5y5r8tn1fFkjfUGNSqPfHzMmQ4tx8rU	345	478	478	1616025240000	canonical
612	3NLqviTqQFsJkaT8ZBiDJKWaCuAVDV5pLLBmF3mrQNqspsmZhz5K	610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	1589	1160	1	1	605	jwyQS9er1nfW3eFZ4G19XExjgVjX9ZdS4FRpQL2bvhR3wUbvmYq	345	478	478	1616025240000	orphaned
615	3NKBrssp28qEoy1UyuwAmkQbCmFca3sEp6wW3nnKxftM9stViB4B	613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	1407	1395	1	1	608	jwTAxAjDEWpd8u2L3hZnXiFKSE2duZn3VvXudhDGw8iTxy1cLAi	346	479	479	1616025420000	canonical
616	3NKEymFwNDaVakiPBHBSLavNX27FLjbHFXwpbap171D73Fo82n6t	613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	1519	860	1	1	609	jxdr8m63MnVsJ5soNbrZvotWaECwCN9S1EtbeXW4TAz5fBSZm9N	346	479	479	1616025420000	orphaned
618	3NKn5SSb2EpdXLGURYTCr4zSDQqPf4tLKrN6sMg4Y6xmFVdMM7va	615	3NKBrssp28qEoy1UyuwAmkQbCmFca3sEp6wW3nnKxftM9stViB4B	1656	1343	1	1	611	jxRG5jB2nBQ6DNGiCjcS1gdQH8fPA3EPEGacnWGwpa3p8WXHHUR	347	480	480	1616025600000	canonical
619	3NLS5Wb3p99YtaQtyzT29bLDE6FzeBXSoNEMV6HjBrYLZcJUeurw	618	3NKn5SSb2EpdXLGURYTCr4zSDQqPf4tLKrN6sMg4Y6xmFVdMM7va	1624	1208	1	1	612	jxiMuNiTTzvrcKrKULQQRXnem2SFobaDkNrUFtTeaqadJrn66Ew	348	481	481	1616025780000	canonical
622	3NKYXdjtvchDhRkuRNFNrxi1Kr2BnLKGMPtiT7NFDMyyn7kir7Pm	619	3NLS5Wb3p99YtaQtyzT29bLDE6FzeBXSoNEMV6HjBrYLZcJUeurw	1577	1327	1	1	613	jxAYTtWbFMo5FSaVQBfqJ7u8jYediq2x3qsH4TcFzjRbtdjjv3d	349	483	483	1616026140000	canonical
628	3NL26HZHa6ETjnoKL7WhxHBfAvSW9H41D3WWreRau8UC7AXxsbTJ	627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	576	1355	1	1	620	jwcPCEvCuSKokZSTG4ZU3UadHXAZZVGvZjZ13zW4DAbhUQUc64P	353	489	489	1616027220000	orphaned
631	3NKhoNtdnTkEoDVEoBaE7GWxBj9BVPUkB5rRiYhRqExUgLXc7Bry	630	3NLGLr6ar8BwvuAWfGKPAnwgGouxzyJHYSy88M1KjuXp497Siq6r	1402	858	1	1	623	jxStA14Zbbz53XYPaGEGoZw5AwcFsuXTpR9e3bamtNjBjjoq37Q	354	490	490	1616027400000	canonical
7434	3NLDq7vESa4T27eEJ8eZ73zEetHBzazpexvfvMtmfr1bK4ojieYM	7433	3NLBENDzteMPfQQKQHNFW4APnkJam7euy4RqYE8hx473YGk78NBT	1608	1043	85	1	6301	jwMS2NN5EycTa6xnibSdQWwPfJnJvApjgDmJnbtpLxP6vvEbWjG	3841	5432	5432	1616916960000	canonical
595	3NKE9x3beNsEPp3BLmqwaGwDQYhhFh5YKsVzXry7xksA6w35h5ZU	592	3NLKLMFAwDMFG5ciJfBG9bE6snrWVoFuez1sC5XhZtQC8VeCpmfo	1406	1393	1	1	588	jxafaLpQ1JQnF2A59G3LNT4FnnM8BpXB4iAFGYutPkD1P19BAVH	337	469	469	1616023620000	canonical
596	3NKETdZnRgXNbsVtwsHXEf6YGYBrbJ7hy5i6qk8HhD2VoADnVMrw	595	3NKE9x3beNsEPp3BLmqwaGwDQYhhFh5YKsVzXry7xksA6w35h5ZU	1407	1395	1	1	589	jxeW1fAkyXTCp4t6fw1AKZB8hEGU7g9vhKMM13WUmnKn11u2gx6	338	471	471	1616023980000	canonical
621	3NKgmj6D2KTxnUKvy1d5yA74CEAsv45ncKWh4UPGnqxU6UvtbJK5	595	3NKE9x3beNsEPp3BLmqwaGwDQYhhFh5YKsVzXry7xksA6w35h5ZU	1577	1327	1	1	614	jxwRdKQ6mkGu3k1Fent2vHRwRjuthbPfshZDpaKrr4ssZs5kBDJ	338	483	483	1616026140000	orphaned
599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	597	3NKgZKWsVJ5Tr4VjSsi3YtoUAkeXh9fVtv5s92nHWzZWJS8xrgSg	1457	1025	1	1	592	jwA7rG24tMQ1zLpGC1mX3pCWDTnsAs8rrwxhKD1p8Teae245rj8	340	473	473	1616024340000	canonical
602	3NLbpzez9u2beYhBktZxmpyBGZu6oUMJdGVAKzh2XkKfWaMzq3w3	599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	641	1336	1	1	595	jxN4StQkeFQjUSavNf9SLXdCTFJij5nkecErJej4TyCzrFSk2iH	341	474	474	1616024520000	orphaned
604	3NKQmbXHgLiLy6u2cpQSgBmmUgprREfXxFRAvSr3VA7Tb7AWLbuM	601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	1652	1069	1	1	597	jy1TbT2cmbTK6AfBvNQbiZfz4FZBatMLRMXrCnoHNVWqpEmNNKR	342	475	475	1616024700000	orphaned
608	3NK7FHt6ubXtMu4abHgA7pRN4G8FoX3khYyC4KsLbaWwxWTA7AVY	603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	1553	776	1	1	601	jxvqQmT6Nd28ctVAotH8maZHzNCzfU1Cm4icDxsh4QxW3K7cMzF	343	476	476	1616024880000	orphaned
609	3NKNWgbJoDLZDBavLrzPnsAhKVJbP4Me9TxPC2KmsTjJ6oobXM5A	607	3NLtJZ9SyFJ9vx72Vw1s7TGCC7w817TSdp9QoiuSDtTkdzxQKjR4	1407	1395	1	1	602	jw7cC6d3rNMUYADpV483ixQnL4enjY5rrAhEuVMLk7YWD4MJ4zP	344	477	477	1616025060000	orphaned
624	3NLZu7zL8Q1tumxWvrXRcqexmNi264qo1b5Zu1qhxDuCxTkWYtYP	623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	1402	796	1	1	616	jwwdwjsvFY8DsPTDbJ58LANrLgW3ce2K3EgYuXjpVuE4sijN1Gz	351	486	486	1616026680000	canonical
626	3NK8jMkLZFqGXi7o4WH7E9EGPJTVHKdeYajTqPGtS8oApMrg1tRT	623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	1637	816	1	1	618	jw7a6ufUbhQht5xQBiY4Wrr1X9kQH3C8Dkzd7dftCwtZY6ddMo5	351	486	486	1616026680000	orphaned
636	3NKZeHFu3QcLuRxs3m2Ev4QPyHiB6R3iqtYfvzf5VhgrKjJzyz8q	633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	1406	1393	1	1	628	jxzagdZLktwftRrJTMKbyWXzPcVFEy1Dg8p4ZSfUxHHydBQMFUk	356	492	492	1616027760000	orphaned
638	3NLDfDqnQ321z7ZUwqhQvB7pmfEwGtHdq2ZUwCYrnsctU5tXG3Q4	637	3NLKYRpLDX9LTfBgua8tgf5UV2EfmdDdyxB68TAfzNaxg5Wdn24C	1407	1395	1	1	630	jxbokFWPTxY6Jk34gDoFPrkVmUkghyy3sD3XANrk8CHdR55HhN9	358	494	494	1616028120000	canonical
639	3NK5fjQmb2odKYPHBWN9t5VaTu5fzRjbMyjuajyEzBskzyCtJmio	638	3NLDfDqnQ321z7ZUwqhQvB7pmfEwGtHdq2ZUwCYrnsctU5tXG3Q4	1671	1365	1	1	631	jwfDaZucUYNabUjuhdjPrHStabMCvpztzGPwEHiwocFnrYrHdvd	359	495	495	1616028300000	orphaned
642	3NKaW94sgCN3ZuGRtcxex3M1jFkcaRbPE4PhEx35edvDhiym5Cb4	640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	1406	1393	1	1	634	jx4KZ9NSwUk9ymyZHfSTMaTni5VGnsaTuD4ceeL1DWnYDMD6vSU	360	496	496	1616028480000	orphaned
644	3NLT86f7DYwN32jV6VypFvKTn9UVBDDSAmx1mQHGLfK7cqtKVo6p	643	3NKSnn6v2xvss1fbPcjYb6vjuZKT596pLmw9S12QjtPeyqFPq7N2	1513	1133	1	1	636	jxpchxGCvjgc3V1HjNnyVkGvjzbsAWkyE4aqGHnUcLm2BcpomHE	361	497	497	1616028660000	canonical
646	3NLT3WqSbEQ8chxJNMsfDytuPDuf8HQprLUJ6vtgCbfed8uDZuQw	644	3NLT86f7DYwN32jV6VypFvKTn9UVBDDSAmx1mQHGLfK7cqtKVo6p	1407	1395	1	1	638	jxszN6stUnmX4EP2MqMd4jSrZLKjsXS1KCZbRd7V2JZFf1iNAxZ	362	499	499	1616029020000	canonical
645	3NKGEDEh5EVxJVMtRQEXaKbCD7KSFoaEA3vSffhucMQFdWUdcvee	644	3NLT86f7DYwN32jV6VypFvKTn9UVBDDSAmx1mQHGLfK7cqtKVo6p	1600	1126	1	1	637	jxndFHzXFnN16UPxHbvVN4dScQ9xxUcJJ5wepbKqWZnZXBdzgRm	362	499	499	1616029020000	orphaned
648	3NL1FQgwGcQuKjprUbHMAxtYHAFLukpvQcfUtCdXuuLURn62ArbG	647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	484	1193	1	1	640	jxaq1sVKUdxdADdWyvhwWkDDAM8GcgAD7hNmzFnqqnL9RZSWS3r	364	502	502	1616029560000	orphaned
652	3NKqzMqWAp3td2hYHn59Y6Yob4gdVDWNTR22vPLEUkGxntABwz2j	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	1407	1395	1	1	644	jxcCYvnqkH51Z3awT6NyCmggo5o9CCp9sPAQTvNYeyJwrDej3aQ	365	505	505	1616030100000	orphaned
653	3NLbNnKtSMXqaNrznTAoCUofnxoXndoxzbThevywkSePtL15fKER	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	152	1084	1	1	645	jx5LxLZ6cKJNdJPkWFF8tGo3QYk3kT5Y2Q7FF7pRuWGcULw6Kpv	365	505	505	1616030100000	orphaned
656	3NLTn9NzoUjTKLAx7GEe2pv428qXWBPCSgSBYwAArzt3anv8oE5r	654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	1609	1087	1	1	648	jwYw61uDJK9jgHMMZ3fgNYoqZgYSYbF9SzHtSitNBE8j1hS8UAV	366	507	507	1616030460000	orphaned
662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	1527	1293	1	1	654	jx9NRVrHHGpRxuMan4WJw2zr9LcNxhkWSberkittXUTD3cVdqH7	368	512	512	1616031360000	canonical
660	3NLyEPkbrG7ahPEdisoKsB7e149dKtnzHq5dc2R5QceF91GhyRRu	658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	1516	1048	1	1	652	jxywxzMVjAUkQbi2KNAB23GmGAXfiZcqUfYdAMDEZ1d7oyXqmtr	368	512	512	1616031360000	orphaned
665	3NKHENTgEi9dUeNP6ckFV2KbPfQyLjnwFXzdkT9wE7rJnRSMyqft	664	3NLxSQHeX4wAdikWpKJH5G5XzSxJrHgBbTR8p2LXtXJ4hBBv7zmK	576	1355	1	1	657	jxepjSdiCzNKkpZmNwNoDxA3mWk57z3TjTmqQzsh6DN37BKzYz3	370	514	514	1616031720000	canonical
669	3NKSf3nctjjf8GkwvrsuK8dhy4Jwyp4BeTqD95shicD7H7tgCgmh	667	3NLyQmQVXvFs7YeLHZ9ntXkVix4nNyevHRDdw2akvfs1jLm5RKoQ	1406	1393	1	1	661	jxSxZR8sG6bwcggd3z8H8ac7k5cXR42AoH8hBhu5Zbv8CFRUvQ3	372	517	517	1616032260000	canonical
672	3NKZCraBfQxyhKAYzLg5BCF3Y8tVHE8XAUqDHdJEeFPVj8pMsuYj	670	3NLpcfkDK39Yf6x9UxxDoMD1XMMWGFTELTwkm5dBuJa7YnUAr7BE	1405	873	1	1	664	jxpvpz3gKR7w41mk3nQpHntYcPsGTeMfQvYGzcSDDjEBJCyxaay	374	524	524	1616033520000	canonical
675	3NL5ue4GHuTY9ha97n1iW1yUFtwNgoKmwhGQW7GDpHmUbPLWHUQd	673	3NLWQZ3nGtRkFwLBvc41tqwPAX8ysNGyyZYSQF2hZXoCDcTPoL7J	1587	1231	1	1	667	jxJRKnpAgyQUmmxr5Pt8P4xNLc11Ad4W14aJVWKrskZS3NVSYnE	376	526	526	1616033880000	canonical
678	3NLGFRDzcS61VmXnUC6iAXiRHQEHnaMxD9jLX53BYv2J51tReM8q	676	3NKfsB3LdZKVWiPeUq8AKHy4oVZpdK862nJWtxJaB55VjQuDuciS	1407	1395	1	1	670	jwLqzDyWrcVA2o5EyvDH15jTmdxJmSQg37uKf6f9vW1SdvczhbA	378	532	532	1616034960000	orphaned
680	3NKt4zEgQWm7KYZraDqwh8bLaLBTxDjnNJ8Wqx8ygU5kBnHJT9eq	677	3NLBA68xLDPbKtSH7cotvFVpCAHpKPVRkis63W2ACvRZgmzcWD5z	1631	794	1	1	672	jxRLmo5zUZEs7Co39wSaTWSzmHMxAyMsKSJ8ZD6fvQDTzRQT6Wz	379	533	533	1616035140000	canonical
7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	7457	3NKzr3KQ7DG5e3yX4czvCyERDspLj29FvDu5tkHv5MF5hDs3sGTg	1407	1395	85	1	6301	jx1EkUWLswodhCHvnNLLbsJAxFKmfrzPshU1vmFvriWDHyxq7vs	3858	5454	5454	1616920920000	canonical
601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	599	3NKuoD9QFMgY3xoLmQUSUAmJnWyPTg6hpRECHbQ3MUi8BW3kg5qk	1637	816	1	1	594	jxvM5w2WQfH5LQc165stYPAkYZPPwcwtynshDFedggEs4sWVmNV	341	474	474	1616024520000	canonical
607	3NLtJZ9SyFJ9vx72Vw1s7TGCC7w817TSdp9QoiuSDtTkdzxQKjR4	603	3NKDTpcfwwM1t4E5fpuQCYwKhsQ2CGC1z9zUHh17JghfTYh6a9r5	632	1382	1	1	600	jwYJe1zPT9s8jZBV9yLm785vqivR1AbaJgVMKfuUN6yXgd79MQ8	343	476	476	1616024880000	canonical
611	3NLkeUUCkXAUxYkcP4XtZzMsqeRARGtLtF8eg3LM69zM7d5nm179	610	3NLQk5fPmpG8dRgfE5pkVE3sDvNAmykJrbfNDPpKSJYrfXMJ79Wq	1407	1395	1	1	604	jxnwVn8tXCbUPrDWw1dsRBeCAoWdVWBNQyQ9Jr1cy64pMmAN2zk	345	478	478	1616025240000	orphaned
614	3NKTY29wveoM7vY4g6Hwk6ypgr4xyjKrrTymRwHtiWga5uKW85tS	613	3NLchtsiKTecRw7d8F6SvC3q4VQBRocNaegdSLcPfj7mZmrUoU5W	1608	1043	1	1	607	jwaBB5bL8HqrPS6KVvo8cfcnXMkFMZcrKkPn2f6NLBAiBq37D42	346	479	479	1616025420000	orphaned
617	3NLbaf1j3n1gp3JURFYyoL1LCy5UVbZWxSopM9Sk8DPxkQcjCktC	615	3NKBrssp28qEoy1UyuwAmkQbCmFca3sEp6wW3nnKxftM9stViB4B	43	1310	1	1	610	jxcztGjtF2ySJe1MBKrR2DLDAMZC8PeuCKFwUJtZwCxiBc6NuRn	347	480	480	1616025600000	orphaned
620	3NLq4fMp6amjdaQJd3sthExqqMbSD6kz518dFvXzJLVXB8WTYMvS	619	3NLS5Wb3p99YtaQtyzT29bLDE6FzeBXSoNEMV6HjBrYLZcJUeurw	1577	1327	1	1	613	jwzQVVRbxLjnJP5sqjQSPCT7ZXpUFZrDt14omwYdU7qoxhcZUwr	349	483	483	1616026140000	orphaned
623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	622	3NKYXdjtvchDhRkuRNFNrxi1Kr2BnLKGMPtiT7NFDMyyn7kir7Pm	1406	1393	1	1	615	jxDQfgiMEb7bYihQmPuy5dM5Li5BjdfEdzRLChEEyDgw34fEHLr	350	484	484	1616026320000	canonical
625	3NK3YN3d6LGRczrUq3dJLyPitczz4NQjTVGAkqvu55RD5zhaSUuy	623	3NLFuecA5E8UjjnVnsguF8SmDhgUSqsayF3aKrWpwqHS7kkc5avW	1407	1395	1	1	617	jwZsGK98gbmn6rAcKbHf72ChzD3D8roJxH7UXrsguL1u3Z39hya	351	486	486	1616026680000	orphaned
630	3NLGLr6ar8BwvuAWfGKPAnwgGouxzyJHYSy88M1KjuXp497Siq6r	627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	1611	1341	1	1	622	jxqsu3ZT5znqnrro5aaUVuEgc7UBJPUT1yVdMSdp1VRA13Bq1rd	353	489	489	1616027220000	canonical
629	3NKKTbSECA224tYr8kKmoP2c6tuYnVCQoy7C4zNCo1pv97dD6jga	627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	1405	865	1	1	621	jwJ8cvQrMAGXMHU2NoBo7gbhhuaHn6bycDddY3AiqaQJeCuXE3y	353	489	489	1616027220000	orphaned
632	3NKpHk5cy1ZWVz9gbfVMpSUHrLMN7rMTfAxmDswZACu7jkXLiJvE	630	3NLGLr6ar8BwvuAWfGKPAnwgGouxzyJHYSy88M1KjuXp497Siq6r	1407	1395	1	1	624	jxhFBxX64PVSCgNCqskosMMWBAahpDN2J3McZBKm1nDVzYE1sKz	354	490	490	1616027400000	orphaned
633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	631	3NKhoNtdnTkEoDVEoBaE7GWxBj9BVPUkB5rRiYhRqExUgLXc7Bry	1406	1393	1	1	625	jwvthmKYd52WC6pVAQc92eahnxo9e883qc6YHZ6zzneXWoQMvxL	355	491	491	1616027580000	canonical
635	3NKFxafKrnZJaEC37scp8Vv8qRARFWzb2m2iiRpSAmQujLcnsuGz	633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	1457	1265	1	1	627	jwQvsbkLp6Zy9r5Fj1FRrerDz6JM6ms1MRGKE2XqmnTYjMfQ2n3	356	492	492	1616027760000	orphaned
637	3NLKYRpLDX9LTfBgua8tgf5UV2EfmdDdyxB68TAfzNaxg5Wdn24C	634	3NL6MhzM8ubVJNdWJquYohajr3toZbkY2wv9AgBL8Rgpab5Ec2iH	175	175	1	1	629	jxb8jJHJBrTam6NENoPYYxbF4ABBJ37qLNXtNrTHRwHos9UPJPa	357	493	493	1616027940000	canonical
640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	638	3NLDfDqnQ321z7ZUwqhQvB7pmfEwGtHdq2ZUwCYrnsctU5tXG3Q4	1402	796	1	1	632	jwsiHDBUw3eDbkaXNGF2YEd2nPLg4RE8FEUnf7qiXyNmz8yyShS	359	495	495	1616028300000	canonical
643	3NKSnn6v2xvss1fbPcjYb6vjuZKT596pLmw9S12QjtPeyqFPq7N2	640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	1476	1005	1	1	635	jw6gQbCLwUVxkMfHb38yaEtJnPRK7x1FhaBHUbBYk3JSfJbqaTF	360	496	496	1616028480000	canonical
649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	298	1182	1	1	641	jx2FhM7B9ArUg8vydtpDPztnp6JLK7sX26JnLQ1bQLgDbdPEviW	364	502	502	1616029560000	canonical
655	3NKTW5jLTWRkGXC565bSZmpEgWhJ4QSHCHfxBeZmvDKwu1TiHf3j	654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	1637	816	1	1	647	jxHo17QxBWLcjyNx7otehHt2CAtfeUEthSwGRWJCDkfGfXdsizM	366	507	507	1616030460000	canonical
658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	655	3NKTW5jLTWRkGXC565bSZmpEgWhJ4QSHCHfxBeZmvDKwu1TiHf3j	1455	1206	1	1	650	jwbctG7oWKTA8Q7tDKesXKrUuCqVgFN8zw7E8BPJptBQV75tJxU	367	508	508	1616030640000	canonical
664	3NLxSQHeX4wAdikWpKJH5G5XzSxJrHgBbTR8p2LXtXJ4hBBv7zmK	662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	58	1281	1	1	656	jwbCuVqQL28d6ePaDdgC7debXJ5dhvPUSSnzEhPMURt9PznULUy	369	513	513	1616031540000	canonical
667	3NLyQmQVXvFs7YeLHZ9ntXkVix4nNyevHRDdw2akvfs1jLm5RKoQ	665	3NKHENTgEi9dUeNP6ckFV2KbPfQyLjnwFXzdkT9wE7rJnRSMyqft	1668	1370	1	1	659	jxCrqFpZeNA5DJ3NZCQSbNnqrQVQhQsDXMvoVGjKpSTbhbBbxjs	371	515	515	1616031900000	canonical
670	3NLpcfkDK39Yf6x9UxxDoMD1XMMWGFTELTwkm5dBuJa7YnUAr7BE	669	3NKSf3nctjjf8GkwvrsuK8dhy4Jwyp4BeTqD95shicD7H7tgCgmh	1406	1393	1	1	662	jwTAaieRQrDoXGXE7HFtXANK4aZGmWHsR9kDQAVY7FMs2huknyV	373	523	523	1616033340000	canonical
673	3NLWQZ3nGtRkFwLBvc41tqwPAX8ysNGyyZYSQF2hZXoCDcTPoL7J	672	3NKZCraBfQxyhKAYzLg5BCF3Y8tVHE8XAUqDHdJEeFPVj8pMsuYj	1407	1395	1	1	665	jxdSKX6qWXE9LiMAynRgimbDy5ecSmzKg8eYNayDfXPCX22hRED	375	525	525	1616033700000	canonical
676	3NKfsB3LdZKVWiPeUq8AKHy4oVZpdK862nJWtxJaB55VjQuDuciS	675	3NL5ue4GHuTY9ha97n1iW1yUFtwNgoKmwhGQW7GDpHmUbPLWHUQd	632	1136	1	1	668	jwHuMHdPiocLjpksJWx22uRuZzkBggoPMmKgnpaV3sDRxr4Vwfs	377	531	531	1616034780000	canonical
679	3NLMBdE8hvfpZFUfL6oRGGgm6KfehnrRGt86orGJda6CVg8uu4eT	677	3NLBA68xLDPbKtSH7cotvFVpCAHpKPVRkis63W2ACvRZgmzcWD5z	1448	1065	1	1	671	jweuLj3fL3X9kvNCehYPzNbBiDbLEXxKswybpuov2qp2sXMVBzU	379	533	533	1616035140000	orphaned
684	3NLcTcLnqmx4GXpph3VssJrJEVmD8ojjMbFj9kL9roh65UL63dKx	682	3NKuQ7riRA9BVyfRMuGVxjWta449VQdEJn47bhMwGiTg4uPTYNA5	1406	1393	1	1	676	jwgkrEVnPT1mAGsMb1pDxeBSgt47HT7snbrRrpS4ZKHV2ntihUp	382	536	536	1616035680000	canonical
687	3NLbZB6MpS94FF8GVAMqgghLGm96pFH4USwwTVuooAQjcu82xhAk	685	3NKh1stsDAepway3Joa3RUTwDL2c3aZ3M992QqraCTbmAFSzRoxo	43	1310	1	1	679	jx2W6dJawV6h1eXAm8C2aREZk7KNGAi5gNbVFWu5EnAGabBRQaX	384	539	539	1616036220000	orphaned
690	3NKeUGQeXNZb2srxhTmdBysDehDPinNq5vxwYddEGiJgD1G4MDCY	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	298	1308	1	1	682	jxNB4aYArFr3H22s219fVgv4y3sDgUPDRbHV3E3B2UY7gZZBsaV	385	540	540	1616036400000	canonical
693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	690	3NKeUGQeXNZb2srxhTmdBysDehDPinNq5vxwYddEGiJgD1G4MDCY	1631	793	1	1	685	jxaTHHTg7feCu3ewhpeCctpJUm7Dx7VzFU7gWJNKEPS2fM7s6JT	386	541	541	1616036580000	canonical
7488	3NLENm4KKXUnW8LcLFZbtUu9bD2qAMYY8PzGQop9vPL5ZcCxCcNG	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1564	1338	86	1	6301	jwghuLkJFwmgXki5gZqyRjhbCDx7eYe7cfntRHVBK2r6kmbcTaF	3873	5474	5474	1616924520000	orphaned
10045	3NLT6eKE2wU2WEJZFjR9qdkhJZ8dWmkvYpPFnnYbsaqKN6LwFgEs	9824	3NKriBpYYwWMmTRqYo8ojBmy46h9y1Q7Y7BBV7k3D28ygpkUrdQY	1439	1279	125	6301	6540	jwsBzTJxTyK7fmTJs8vNwuACVL31qbzvRQ6xcpX1xy6hC33GLvx	5015	7330	7330	1617258600000	orphaned
650	3NLTNHy1Urwyd1AKSWC37imBgyAu8gehNFqL2gPCuyY2oi3etWWU	647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	1631	794	1	1	642	jw7mdKnUCh1Etea4PZhceGWVacCgSzGyKDQuFMgpUWX66FS2ztw	364	502	502	1616029560000	orphaned
654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	1477	1350	1	1	646	jxoG3K3BriujLWuoT49BxyDvJ1U1GVYHGY7NitFtAiFvAkpjfec	365	505	505	1616030100000	canonical
651	3NLGdiEMsZT9u1FtkDAx7oEb5fW9kcqojTn7Ve4FkoCV3DFnKFKi	649	3NKD4avL7Si99Z13QgP6FkR93sAYjwsEnpCxyXJK5i4fUXfnCcC5	1534	1317	1	1	643	jwr3ccHCeJv1Lxn8ZmjdCew5QLEC3j15SVwBykYCWnvpma7bm1e	365	505	505	1616030100000	orphaned
657	3NLYMTR2FHW3HWoLHfhakf4VT5SZ5CPA3mmwioa6CPu2rVgKh72X	654	3NLr8BUkCMs8PEw3Ggth33tQhnAmyhR9Jnt8iVAzLTYGPkxius6M	1631	794	1	1	649	jy1wYrHN2Qw4wYPdszZUVPhQxvP7mVvPUQY1Kcf5rejKhTRDQRq	366	507	507	1616030460000	orphaned
659	3NK866B9UU9YuiPhHKRuP3QdxtWm4Bba4DAK6MHv9fsR5ggSFhX7	655	3NKTW5jLTWRkGXC565bSZmpEgWhJ4QSHCHfxBeZmvDKwu1TiHf3j	1477	1350	1	1	651	jxWYSfioLjDgNYu6xSdVF6nzrEAovZ5r6FkwvxKWCvcns1Ci2CP	367	508	508	1616030640000	orphaned
661	3NLKdYh4Q7i11gcA2axwbPfw2m2ake63MTLRMoAbzzaDRzTgVngC	658	3NK3qyVCmRX4mAG3Vd33KSMFwQA1sDdKiAGhMiUtR2dNtnggQYAr	1407	1395	1	1	653	jxndsW5TCpzQf49psgwMohnsXLeHYqa9PECcDxS638Lemejw2rZ	368	512	512	1616031360000	orphaned
663	3NKMQqrUdFZcWnnQCbHFK4FrVWNTy6eLD5Sv1Vfo61aBaXy4s4M2	662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	1406	1393	1	1	655	jxV3ns6Bb6oXFJCZ8GkY8McQnyN69waSP7BvMnLa3XL9vZDaVVB	369	513	513	1616031540000	orphaned
666	3NKPFLME3wsKHVsFJKijGyGRZprW1vVknx4w1DRFXBqiTcD4YjJi	664	3NLxSQHeX4wAdikWpKJH5G5XzSxJrHgBbTR8p2LXtXJ4hBBv7zmK	1623	829	1	1	658	jwqaHPM8giue8B18x71Wz4qmPTeQDEPkBGkXEvEG9QcUbsGcdkJ	370	514	514	1616031720000	orphaned
671	3NK55Q3Jg5Rci6e6hFxsgp8sDbWTNPVVHLowAFNhfdkXYfPR7g7R	670	3NLpcfkDK39Yf6x9UxxDoMD1XMMWGFTELTwkm5dBuJa7YnUAr7BE	1403	824	1	1	663	jw8wVcYzoAH54hCpGWH4tytd2ifdyJxDdVqPMznUCaU4AzEraM8	374	524	524	1616033520000	orphaned
674	3NLCxFzTqEmVytcR7rAjnorWLar7fFQNi7T5SurKEgk1RsrKAJ6b	673	3NLWQZ3nGtRkFwLBvc41tqwPAX8ysNGyyZYSQF2hZXoCDcTPoL7J	1608	1163	1	1	666	jxEbHjP7VC6DKVuR4gwnq5gyEhQn7z5fw6ne3Fhy4iMXdZ8AjNZ	376	526	526	1616033880000	orphaned
677	3NLBA68xLDPbKtSH7cotvFVpCAHpKPVRkis63W2ACvRZgmzcWD5z	676	3NKfsB3LdZKVWiPeUq8AKHy4oVZpdK862nJWtxJaB55VjQuDuciS	1406	1393	1	1	669	jxtX36XztiBxYNj5JmzsEVTqMBRBLdFubk5gDQxRVU4QNWj91ii	378	532	532	1616034960000	canonical
681	3NKK2jzAKiQSAKdaWA8Y8YZUiA7NTTrw1CPTc1buj8eMK4aGrsBv	680	3NKt4zEgQWm7KYZraDqwh8bLaLBTxDjnNJ8Wqx8ygU5kBnHJT9eq	1673	1242	1	1	673	jxPRrKEN1KCFM9ooQDcv5Ty6Pn7wcnGWJNsK1mUxcYPQiDbGKWS	380	534	534	1616035320000	canonical
682	3NKuQ7riRA9BVyfRMuGVxjWta449VQdEJn47bhMwGiTg4uPTYNA5	681	3NKK2jzAKiQSAKdaWA8Y8YZUiA7NTTrw1CPTc1buj8eMK4aGrsBv	1553	776	1	1	674	jwnez5WZfpddBeLfbCMfWTUrwyodhCpH3rzDrrVyK2dFDFm8FjK	381	535	535	1616035500000	canonical
683	3NL6QqBPV3b3YvMZuGsocV3w8P1nToFV4uDPtvvJActArKuwEVDT	682	3NKuQ7riRA9BVyfRMuGVxjWta449VQdEJn47bhMwGiTg4uPTYNA5	1546	973	1	1	675	jxnv11BbKLuUMJqjUbEq9pK6mRokqevFDtNf9do8sQZJUBuHRFv	382	536	536	1616035680000	orphaned
685	3NKh1stsDAepway3Joa3RUTwDL2c3aZ3M992QqraCTbmAFSzRoxo	684	3NLcTcLnqmx4GXpph3VssJrJEVmD8ojjMbFj9kL9roh65UL63dKx	1397	838	1	1	677	jwsi7XZEBucNQySw4jYZ9RTKgjjBRbYKjzCTBfUL3pRRWfiNY4j	383	537	537	1616035860000	canonical
686	3NLT2qBcgSwBgVhGbvX6URzcBBbWLmePsRWcHCazRNL8dpvqL6ur	684	3NLcTcLnqmx4GXpph3VssJrJEVmD8ojjMbFj9kL9roh65UL63dKx	1587	991	1	1	678	jxFQnzDstrXQwf5JRCcTZpWyhFga2D1bgxQk28n5RGmRFQqCYo7	383	537	537	1616035860000	orphaned
688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	685	3NKh1stsDAepway3Joa3RUTwDL2c3aZ3M992QqraCTbmAFSzRoxo	311	1307	1	1	680	jxyhzEaBBKHXzUKiksJTPhMP3ZR6cePBq9N22wonMnzbG5aXMsS	384	539	539	1616036220000	canonical
689	3NLCHhb3kZiptFJ9iYqtbbCtKBdCjuqgHLaE5n8i5XVH6FhxEqJZ	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	1406	1393	1	1	681	jxgzK7g6Jg7iWYcn3FMddDTuBFWZGYqvHeFU37k7KsXGy1wLSof	385	540	540	1616036400000	orphaned
694	3NLCYo73myHRgdaGF21rjA7HMtXnTjzYb2vS5N9J3k913bK8xxur	693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	1578	1050	1	1	686	jxfhtbhDknuT2hrdAKUDpzvowKW82w9fJqzRsvLeoNpLUVpzSba	387	542	542	1616036760000	canonical
695	3NKfhSKFwoKiEzzX3jwTbYRuMc4s1FZNV7HRaQZGhkSgjYbPGsum	693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	1471	1386	1	1	687	jxMi9QssH4ZXoSHFS3yuFhyJh24iWAkNAP8kBEUwsLdtgVyJvuq	387	542	542	1616036760000	orphaned
698	3NKx8a5WnSs6KD5NNuYNMeLxXXXhiZVmMujTnsZcVEKUxuDVuWx9	694	3NLCYo73myHRgdaGF21rjA7HMtXnTjzYb2vS5N9J3k913bK8xxur	1407	1395	1	1	690	jwHpiAxd2saMvZnVKHy2bZUrraA1GAyWG6xxWUfLVm1p4gwrz1p	388	544	544	1616037120000	canonical
697	3NKC3Qygz8cqb34bwDZ3AM1xje6zStF4jzqeuwuuLQyWCqi5cfZ2	694	3NLCYo73myHRgdaGF21rjA7HMtXnTjzYb2vS5N9J3k913bK8xxur	1402	807	1	1	689	jwD1Uwva53mbA7QMPsMekkRzp31puEyMcqDmrVjFirmGmDM9sLv	388	544	544	1616037120000	orphaned
699	3NLbKtzXkm49aHgZYQbmhmb33CFYe6QS96WuLbFSky8TsZ4vDxrY	698	3NKx8a5WnSs6KD5NNuYNMeLxXXXhiZVmMujTnsZcVEKUxuDVuWx9	1633	1390	1	1	691	jwR1cPoSroQtaJpXLxuUMAvURanzCsrSHBzCTCS3BN8A26CbHyV	389	546	546	1616037480000	canonical
700	3NL72qcP9jGmq9xAnL7mr3H9qZypnF9sapQD3rFX8Z6ZNAPWrVXt	699	3NLbKtzXkm49aHgZYQbmhmb33CFYe6QS96WuLbFSky8TsZ4vDxrY	1402	862	1	1	692	jxJGqBZemUUHvLks8e6BJ9MuP5saE38kFPznvotXeK6XJ9AVgfs	390	547	547	1616037660000	canonical
701	3NK4bcDXLQRmK9Ej1JECCj3r3rsbts2nSACTjFyyyooPQRaqf4w8	699	3NLbKtzXkm49aHgZYQbmhmb33CFYe6QS96WuLbFSky8TsZ4vDxrY	1656	1343	1	1	693	jwGFEczAYSaxunqstWbWGb5hpef14bmS5Svp2Rqn5qoD7eM53rL	390	547	547	1616037660000	orphaned
703	3NLS6EEeKQLXv8EvWqWDPtkwzvN5kVWQwMvXyXCiR5Phfem2V7nL	700	3NL72qcP9jGmq9xAnL7mr3H9qZypnF9sapQD3rFX8Z6ZNAPWrVXt	1581	778	1	1	695	jxjuzzheTaY8DWeR8HgyWyq81SqAMcKF79TwwNn59EBjfTUEDXD	391	550	550	1616038200000	canonical
702	3NKKjqyxdN1Xb6fVkbEyaYXCm62WGW7urMVa7wsjYCAjydZQvcKb	700	3NL72qcP9jGmq9xAnL7mr3H9qZypnF9sapQD3rFX8Z6ZNAPWrVXt	1448	1065	1	1	694	jx3rpetEF4466SGyqYoQ7HFiqymo2P6fdHQ4uANq51MgjRw4QQG	391	550	550	1616038200000	orphaned
704	3NK9Rta4W25z6Cw4UzpCVqj8iRBe2df8ww6sUDTzkSJQs71jQkuN	703	3NLS6EEeKQLXv8EvWqWDPtkwzvN5kVWQwMvXyXCiR5Phfem2V7nL	1406	1393	1	1	696	jwTpeCXQ5yrMWJNifjU8kdxWhdUpdEAjTx8a5JbRRsnHewhCtEb	392	552	552	1616038560000	canonical
7502	3NLAc6VRM9qtoDocuEFszen7tyC5Dq32Ej5iHsa5PujnXiSfmonr	7501	3NLfVmN6RURGxBMbFZzqqJxpyFupZ8oZRcpwNxBUVJ7E6R1o8vG6	1439	1279	86	1	6301	jwBwjN8Rne2nVDbaT3J2G3usLee2pfQhAkXpG9zVG617tk1hAwp	3882	5486	5486	1616926680000	canonical
713	3NL8pgSLioPS8EpfB44EEb8HSnDpVRJeBT5bpbmswU9ieY8Ppke1	589	3NKt5pQpZUXLbYGe3Cf7KMHy4d381V7RRRwXc3aU9f6pLCZpy987	1569	485	1	1	705	jwCWucYHmBKi1of5rKM9Xc2cr9EaBQJ9BuYCGxaMHnpLBUppY91	334	560	560	1616040000000	orphaned
705	3NLLjFhivU1WoosniCUNC6ekMhwzQM8pmU79GdXCkPgRUG5cgHJW	704	3NK9Rta4W25z6Cw4UzpCVqj8iRBe2df8ww6sUDTzkSJQs71jQkuN	1637	816	1	1	697	jxAH7aa3ougcBh2GchjCvDXmLECcetk3ThqGesiTYV7TaWqu8tn	393	553	553	1616038740000	canonical
706	3NLc4q7QJ2rmdnRjH4NWQrRJHoqfNkEzjaF1VBdnAp4kUuNJLW97	705	3NLLjFhivU1WoosniCUNC6ekMhwzQM8pmU79GdXCkPgRUG5cgHJW	1577	1081	1	1	698	jwHsN2h5h4B43U2bwx16J2Zep3v2ou1xtHKkNZZKXjDQfkL3fDZ	394	554	554	1616038920000	canonical
707	3NLMxQ4ZXPa1DPe8iQQGyBfqtknjmkjz6qTQoV4AfzJY7fNXoFF7	706	3NLc4q7QJ2rmdnRjH4NWQrRJHoqfNkEzjaF1VBdnAp4kUuNJLW97	1634	1331	1	1	699	jxM8dHCzAm9XPQuXJd41AF9UBxjCiw6zcZeasDJAMVnXV5M96tN	395	557	557	1616039460000	canonical
708	3NK5EWwL1HRaP9N3Ru9Se23Ua9UKA6BYwN1DSEVA3s4D5Q6uszCu	707	3NLMxQ4ZXPa1DPe8iQQGyBfqtknjmkjz6qTQoV4AfzJY7fNXoFF7	1549	1116	1	1	700	jxLB1UxQSuM6UV7udbMDrKJCYqPrvSAiSUoVXRX5MDHm29dpPce	396	558	558	1616039640000	canonical
709	3NK4VCptj5kjSyxBvTJhDb5wjsnMPwoXo2NWsm9b9sGZPn5znnPK	708	3NK5EWwL1HRaP9N3Ru9Se23Ua9UKA6BYwN1DSEVA3s4D5Q6uszCu	1596	1363	1	1	701	jxi7UvHrSvkrEJos3EHRHWYh2nknWiEPDoaZw8rewrh8obNXfJn	397	559	559	1616039820000	canonical
710	3NLmRk8uqNFYwRTVf4QeubyK6dym6ac72qmJh1187gqAxnBeFegT	708	3NK5EWwL1HRaP9N3Ru9Se23Ua9UKA6BYwN1DSEVA3s4D5Q6uszCu	1613	983	1	1	702	jw7QRu7RpccC84sG3rB5SCLG3c1hB36AqcUMvMPf8HoXi2sJUpj	397	559	559	1616039820000	orphaned
714	3NKiXUVVzKNP6CEY9syosgmHNHNbrVnJSnUaLxrY352mbabCVhy8	709	3NK4VCptj5kjSyxBvTJhDb5wjsnMPwoXo2NWsm9b9sGZPn5znnPK	1569	485	1	1	706	jwiokcgJoE7zbJabVi3krzDCjNQthecyPokVQh2Ky798yrXTcmF	398	560	560	1616040000000	canonical
715	3NKQy6zNWYS9xrYQcqd4KfTE8AcZ61beujRcbgUrfUzfApVrDtyu	714	3NKiXUVVzKNP6CEY9syosgmHNHNbrVnJSnUaLxrY352mbabCVhy8	1403	824	1	1	707	jxcnSmcnQ5L1enTDiHfhCBcdfLzGEAYascN66dVdLA1HR49UUws	399	561	561	1616040180000	canonical
716	3NKaQveh9H2ktHPNecR6wsgSAUDpBhCjszY9iVrYMAgNHoV9upbz	714	3NKiXUVVzKNP6CEY9syosgmHNHNbrVnJSnUaLxrY352mbabCVhy8	1407	1395	1	1	708	jwg399qNYZgPLvsqVDSr6Nq4jJZEfYuSvqtRQrhagxWinbJoKMM	399	561	561	1616040180000	orphaned
717	3NKNRF4hjhDJk4VLkhRPZbveBdhyUDgyAxn6z2FGm46mbGnxRBdL	715	3NKQy6zNWYS9xrYQcqd4KfTE8AcZ61beujRcbgUrfUzfApVrDtyu	1406	1393	1	1	709	jxNv5VX1TEAAik2SZczDqDm3Q5jg64DWEyzM7SDbcJFYqg8Lg2c	400	563	563	1616040540000	canonical
718	3NLoQbwyq1KUagQ4cGGz5s8YaTHtyoRP8sfALfwFZJhYuQNfrJ3c	717	3NKNRF4hjhDJk4VLkhRPZbveBdhyUDgyAxn6z2FGm46mbGnxRBdL	1406	1393	1	1	710	jxZsnkHqh3UKrRJgfPvdt3aQpnWdf6e2WDNibxLHdoFvaDCMKxh	401	566	566	1616041080000	canonical
719	3NLVJeW8eEQtbKZ17rxsgDQyXLXxe385i5NP2tSGwRyh4iPFUcuv	718	3NLoQbwyq1KUagQ4cGGz5s8YaTHtyoRP8sfALfwFZJhYuQNfrJ3c	1407	1395	1	1	711	jw78LnLNdvQ3aYJDpDCiyo4kfAZLfDCxPADUja55ZZBbFdPdMcw	402	567	567	1616041260000	canonical
720	3NLHKv5uDA23cCqeTGtEBe2XbToFWXya5TVWvTgr6P1Jfzs9Kj57	718	3NLoQbwyq1KUagQ4cGGz5s8YaTHtyoRP8sfALfwFZJhYuQNfrJ3c	1637	816	1	1	712	jwdBvLMyx5Wm92kukSRy1s1BY8EsKDsd3qgZ2czKJrMouxxSdzm	402	567	567	1616041260000	orphaned
721	3NLVoAiRYBYAatrt9V6PzLwarfRac8iYtBunDvnFkKcvMc9qEBsy	719	3NLVJeW8eEQtbKZ17rxsgDQyXLXxe385i5NP2tSGwRyh4iPFUcuv	1516	1294	1	1	713	jwpQMpm6nSj5VhDyR2cbPpTygU58GVZEG1tyY3z2RKzcu1WqUWu	403	568	568	1616041440000	canonical
722	3NKUkcRbqprZqsJpnxwcgZy2HthhYig3efTewmeh8m9FC2meiLKs	721	3NLVoAiRYBYAatrt9V6PzLwarfRac8iYtBunDvnFkKcvMc9qEBsy	44	959	1	1	714	jwekneCFrwVNHRQ8u5PriQLD2ejjJWVdBLNXJLEVpTuonZsbqis	404	569	569	1616041620000	canonical
723	3NLKYkDfZqBtEUcN3UtkK3VqTDfQj9tx9fyz2F3KxzFFey9mESw2	721	3NLVoAiRYBYAatrt9V6PzLwarfRac8iYtBunDvnFkKcvMc9qEBsy	1631	794	1	1	715	jxxXTKBJXxwEtHtviucTcAPEJhAdUAaM68pmgPKgYG3X55CmrMm	404	569	569	1616041620000	orphaned
724	3NKjbnFwFSVeTCoUkBNWenk24xopLpHqLjfB9to9ah5GJM9eq4qn	722	3NKUkcRbqprZqsJpnxwcgZy2HthhYig3efTewmeh8m9FC2meiLKs	1671	1365	1	1	716	jwzz3PR5SDmwSs72DUtu1Tvp1ZerXJz6zkvzmpGdRWjV9en4aXa	405	572	572	1616042160000	canonical
730	3NKU1FBBm2KQbawyFLBpR1yPdLoxe2G72aQhZtMfnkPav2bPA1L2	729	3NKCxs5ERnZ443WpZwj87rs1qYNg2TofuvG97E5EJnMzVYMQG8c2	1483	593	1	1	722	jxRhAUiueagsEis7Qgxiatv72aH1yAjcp4dr8ccDqqmQfdwuHeS	409	577	577	1616043060000	canonical
732	3NLFMRbSGw7mdxNJVcnSyQ4zpfCJkpDmKf42Ujwc9RZPw1wHuBmr	730	3NKU1FBBm2KQbawyFLBpR1yPdLoxe2G72aQhZtMfnkPav2bPA1L2	1508	1261	1	1	724	jw95mCXmXmPjcWGy6UaxvpaWoN6TCCTTfLe5UdCDVxusdrDa6R9	410	578	578	1616043240000	orphaned
733	3NKqTd5CyUr2sPpVaotxsA4zERk8WRSteYXKcBuR6EknM8CRhy18	731	3NLpLdun67dVw8TK2LG59h93R7RKP9un98d9dDFUzwFxzZJobJwK	1675	1096	1	1	725	jxswtvyGcjUhf3RovAxN7zej2ZahgrJvYSBFHejDPJ7HGGgAxib	411	579	579	1616043420000	orphaned
739	3NKZj8R6mdmn9kUkDNcd5tm4yv4Nex8vN8Ces3izF7GbLPLCYUfS	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1608	1163	1	1	731	jxitBoXwM1JN2V2iruiGSRE825yDc8fLwqHEnXXwetaxXva162i	414	583	583	1616044140000	orphaned
741	3NKzaF8zbbWKLHzuyxdKQXdoNWgV6Xi7jQmGgVTHi26jKgfLaHhn	740	3NLJ4j4ZsmGFmkhnY2ykQ8oZMuXoSC25t9ogpMK9uYgg2beMG6Zk	1405	849	1	1	733	jxM4kEM8J57wDzGBtL34Ha2Gxu8s3gzMSpzvQnT1UCCsGe2Uy6s	415	585	585	1616044500000	canonical
748	3NLmfZengoBEsv3jwgiUw4Be64nUEmBgRLrVc1tkVDzeg34mghhu	744	3NLSSDGYMeaFyXLsSGrpbDBDL5aU4stawymC4Ta8YJhZwJEgf34X	1446	518	1	1	740	jwjVi77bbx9mgtGng92usUrnzdmaLrbRK9NykwL543zSmtCP9HS	419	590	590	1616045400000	orphaned
751	3NKdbPnpEcpcjooYEnSuQbxPyt7E6mZ6Th9CCgr9Rk5TPp7EcSzv	747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	1594	1326	1	1	743	jwUKXTdnaaJjUqMudhSbzuPu4hMEizoWH34p8KajNqENqZMzcrt	420	591	591	1616045580000	orphaned
754	3NLx5SNqjQjSAijAyA1fDesQtrcNV5gXyJNEkb1zUHSZt1CBRnXe	752	3NKSwuxYr81rTWZ5Svw6vstXCxC1wZVbPJKZPP3S4BNZJvtYmcVs	1600	1126	1	1	746	jxJqCrAW1XCQBiM1M8JhhKL7rwNqqD4PrKq1nKahvuhFU12bNcB	422	593	593	1616045940000	orphaned
757	3NLB9fEURAg5tJzQjWcZKNmAegvGhNtUT6vJgzdurRUCGVsjAq1v	755	3NLmBcTFPRzM28ePnVaeVwLsiiVWwpzZo8JW7m72FCXbgZaZUBLE	152	964	1	1	749	jx8QdERtbbX6eQPN3f5rGF4KXRJxUgSTzKTfVgh9o8oMCZXrE5C	423	595	595	1616046300000	orphaned
763	3NKNW5NvkLYgnkXjoiK4SjPQ987WXEH44pwe32PVcsysRJg9AG6x	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	341	341	1	1	755	jwY3mmfRUwkLFgd5WFeWnDurUVCQJQ5nTvoLpzp1hxCkJABEh5x	424	596	596	1616046480000	orphaned
772	3NL5HdHGTHdbC87J7AcNdPRNkiSBnSzrqN2sEDaiUmkCv3xRvsJ4	770	3NKBBe7Mq9LGifmQayk7C6YvzryUQ8a1tVNQAXCd1BNx6ZPD2zmU	58	915	1	1	764	jwEgsy8X59J6Zz77kZpLxcRHN8pU2BJrDYohS6JPsUJUjg87m5R	429	603	603	1616047740000	canonical
7510	3NL6tugUENf73tRWjhfXF2bJCzoZgtGwYzSMskyi3kGgymNXHgb1	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1406	1393	86	1	6301	jwMcBGVsDg7hGmuVokm6dWGtoP6AajbwH9AKDzt8ZxzhBd2imgZ	3888	5496	5496	1616928480000	orphaned
727	3NLLXfo8SBrtWgEgxmSqeCg7ByzUSX6Y8PqfDJsJsFuhZBBvg9kN	724	3NKjbnFwFSVeTCoUkBNWenk24xopLpHqLjfB9to9ah5GJM9eq4qn	1637	816	1	1	719	jxvneWoq4D11NZCdvtTny8CKWzNYyX6i9iuiK6JFbYguN2XenZg	406	573	573	1616042340000	orphaned
728	3NK4yGR9BVJjhMi57gNBu8E9gusLzU1FLogXt5MyJg4aGs8u7Xju	726	3NKtKCciQZe8MiHPLdHZ9HhRCeWsYhqpF8DL6H5SNaWZYGbYozg9	563	993	1	1	720	jwoyu4z9V5hf8b1MCiXr67ASv1J2gFAFPDzezan6z8g6DUEFfCe	407	575	575	1616042700000	canonical
731	3NLpLdun67dVw8TK2LG59h93R7RKP9un98d9dDFUzwFxzZJobJwK	730	3NKU1FBBm2KQbawyFLBpR1yPdLoxe2G72aQhZtMfnkPav2bPA1L2	470	1063	1	1	723	jwoYZS16ACq9XR8945SG5Lp691ZoXxdh1HcEwHmvbmLsTgMop9R	410	578	578	1616043240000	canonical
734	3NKryXbzFExaZBfzZLuY5sjMef7WcoAMXRYCym8XhCXmoSQuFWUb	731	3NLpLdun67dVw8TK2LG59h93R7RKP9un98d9dDFUzwFxzZJobJwK	1419	814	1	1	726	jwntYTWVga5ubkCq1foyCp3PYdFP41vWsukFA7gzMUjbrEV5jDL	411	579	579	1616043420000	canonical
740	3NLJ4j4ZsmGFmkhnY2ykQ8oZMuXoSC25t9ogpMK9uYgg2beMG6Zk	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1579	1023	1	1	732	jxhZkaDKV3mcAFHtYT1X5HNi4naqacXimX6hvWHkNyZMLQZvCfS	414	583	583	1616044140000	canonical
738	3NK7rwAceYgWw3wJK3wXFWz9FByFCLtMvrftP4b5tFLQxEKbWaHa	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1585	1366	1	1	730	jxx8HeKMqfwgwxBccZexcN8QkmqUbLSQ9rj47m9QezV16QEPJ62	414	583	583	1616044140000	orphaned
742	3NKGUu18HMBXaRSKXGpC31HgB2zgS86euT5p6VAivpvkBebF1uct	741	3NKzaF8zbbWKLHzuyxdKQXdoNWgV6Xi7jQmGgVTHi26jKgfLaHhn	1581	778	1	1	734	jy3BqVWGiWixj9Hp1PRaSEeaHrwybqpfc9wcE1u2DwhCh6TsD8U	416	586	586	1616044680000	canonical
745	3NL2cw43tepXT1g2dsgWfuawe46pd745d7av5xQizARC4KdQdgc4	743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	1406	1393	1	1	737	jx3kWDT25FZcRqrgvtQBPKdxffiUUvdkjUjeNgY47nuqhiwwdN5	418	589	589	1616045220000	orphaned
749	3NLkwXrcxVgcLFLonB3SEBTgAT4sSJuZBdjkDbwqBjk66rGVzhV2	747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	1407	1395	1	1	741	jxga5oKUMJwxvbQnnMwcUooHcNaRLai6vwYg6M2vSf5WK85ju4w	420	591	591	1616045580000	canonical
752	3NKSwuxYr81rTWZ5Svw6vstXCxC1wZVbPJKZPP3S4BNZJvtYmcVs	749	3NLkwXrcxVgcLFLonB3SEBTgAT4sSJuZBdjkDbwqBjk66rGVzhV2	1534	1191	1	1	744	jwCgvQZDvSq3rMCnQZx7dDyZnjUKWZAE6EiGnBPXTzRUkUaqQig	421	592	592	1616045760000	canonical
755	3NLmBcTFPRzM28ePnVaeVwLsiiVWwpzZo8JW7m72FCXbgZaZUBLE	752	3NKSwuxYr81rTWZ5Svw6vstXCxC1wZVbPJKZPP3S4BNZJvtYmcVs	1559	1353	1	1	747	jxc4tPRWkC8bBPQW1DENRwz1QsQqjmevcEqt35EosA2JPJFYNj8	422	593	593	1616045940000	canonical
760	3NKW4zGHmVStQhRoturqeA6tDkurCgFp7Dse4G8dj48vR8Azrk8o	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1483	82	1	1	752	jxwuzMXSUKZD51jVKuWZ9cAgiQvw5JF3BFRpkB49CTwA2LaTdSk	424	596	596	1616046480000	canonical
758	3NLB81Q5DvaWEuJ1qRXPQfGsoTB6U8CWsd4NWUgYYrhCbcKfpSnX	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1423	561	1	1	750	jx88FatTzBBGg2nNo6c152TkjLFVDcXvU2fUj9635hGjWQmJMfv	424	596	596	1616046480000	orphaned
764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	760	3NKW4zGHmVStQhRoturqeA6tDkurCgFp7Dse4G8dj48vR8Azrk8o	1642	1121	1	1	756	jxsHfzvHJ7a53CDsrYC5TunhNTVypyqBzLk3SJFZECuMaG9mKk9	425	597	597	1616046660000	canonical
766	3NKLeJ5UfR9WyNj2ZKnRq2ht14kz7yj89rt7bNqiiMqo2XXJoMQr	764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	1406	1393	1	1	758	jwLmamsssaVreLBBGEdw6wrVwPk7NSMEsvcDzEmVmEUtztpChPu	426	598	598	1616046840000	canonical
767	3NKWxcBNfTT7kuYc2yD4fJ5buH6JL5xeRTMztq2P44a6UJDZo3kY	764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	1581	778	1	1	759	jx7hVc3K2yAzhjdsoVrTASgdUnTpgVHScE2sXRPwgCmmCfhm9hM	426	598	598	1616046840000	orphaned
769	3NLDotPg6HMrwfQFBvXiteRAik8ZCNtNwcJgpaqvP8kUmfGG7brG	766	3NKLeJ5UfR9WyNj2ZKnRq2ht14kz7yj89rt7bNqiiMqo2XXJoMQr	1407	1395	1	1	761	jxypj83oS9dYaFcbBkXRmxWxxAWFo78KmQ66p5Xr8PEQRSwGPbi	427	599	599	1616047020000	canonical
770	3NKBBe7Mq9LGifmQayk7C6YvzryUQ8a1tVNQAXCd1BNx6ZPD2zmU	769	3NLDotPg6HMrwfQFBvXiteRAik8ZCNtNwcJgpaqvP8kUmfGG7brG	1670	1282	1	1	762	jwkZda92DQZHp7JBoHfn3yrxGCby51Nr6eHhTv26wtS8fZfAvAX	428	601	601	1616047380000	canonical
773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	772	3NL5HdHGTHdbC87J7AcNdPRNkiSBnSzrqN2sEDaiUmkCv3xRvsJ4	1448	1065	1	1	765	jxCxKBptHm4Y5HeyyV7vzsE9cKgtg8MJjtxwsZSAtFbegVeR5zV	430	604	604	1616047920000	canonical
781	3NLpLLSLP3d1BZyLHsLnfU5Y3H2VTZMxiGoGvw84YRzxTgkABHZ8	779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	1637	816	1	1	773	jwy9iuGHrdS6hApqNY7xkLkNWx3h9VyV4JnPxpBy41zahKkCQEC	433	608	608	1616048640000	orphaned
784	3NLTFuuD6kf6xHpVzLcPoGUvUeR8Vuhj2vLHs6Gdr4MJn4AFy7Fu	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	1654	1340	1	1	776	jxShygmB1eTKTsCx9jm3JXxRCeBCpuXj3dD4V5yqyfCrRstyf8e	435	611	611	1616049180000	orphaned
790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	789	3NKmWJRJpxFKpNY64iJhh6cSqwNqsmh3q2dCMr8J9Wn3fpRqdiAP	1402	900	1	1	782	jxy7EHZYm4BFyiyBMWAYRn2MufDqH5msi3SR3ki3UTw8B2CQDuy	437	613	613	1616049540000	canonical
792	3NLafWB9tfj8XjDjWEJfHV11aVwcvDhJt6QrVjcveHbhFJBfyRC6	790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	1600	1372	1	1	784	jxwiJ7DgmaLhYqkC4apZ6pDsmmenDM74zaDZyXxVqhJDvXrpkrJ	438	614	614	1616049720000	canonical
795	3NLmTwef7xbmRU236UyaNghSzBfBpCduep3Cd8GwSyqdDAhABurA	794	3NLZtjDaZH2AptVEbixrHppF5QyXEYt6hbt4pnbQwpMcgYpxbaKS	1668	1124	1	1	787	jwC2KLdaYRr2fmWXJgP8MMJgXL7vXhvTm8QFWwfyZkbhmwMzEXe	441	618	618	1616050440000	orphaned
798	3NKHKedGWUExQjMXJv1mSViVPLBmK7MhGnAMPYWD3UTDzPFwVyLZ	796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	1426	1364	1	1	790	jwLn4cc575LR3riXW4RvsmUciLd5ArDxMNqprg54cgnhG72xyCH	442	619	619	1616050620000	orphaned
801	3NLfVwsTqdN7w1ZFtU4tzHCBCyD9WLXEdJKE6rheGZvJwVGr11bQ	799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	1637	816	1	1	793	jxrboFkYhnbeXZE3XcBWZaMSJAFG1Wk6TWBBNR4n7mzLNfYGfGt	443	620	620	1616050800000	orphaned
804	3NLv8ku1kuh28Wm1tCMPExFZ6Fu92w5wxHfWLe11BgWPjtwDikbu	802	3NKAZb5NcNrgsmS2FdqoidMivve6YawQT9djYVjevWBJi3mykSKa	1481	790	1	1	796	jxb5A1WoPvbwwxefSAgMkvapnHdqUAT6Z6kcjbnYYtgHkZNd9TT	444	622	622	1616051160000	canonical
810	3NKQs2rHK5vM2fWEQjVi59sjoEmZTTjgewa5epAthLEysQgp6Phh	808	3NKrJvpG2jyyj7N4dYMR49cvkxVnixJ1XK4r38TDTVnzBu4DNwZM	1631	794	1	1	802	jxbjKhV6iKApFNrTiMn7D4N9dVpJ5ZSzNKUcmDRAWezg3DaHqN6	448	629	629	1616052420000	orphaned
813	3NLWwupMVwKFqx6QZ8WhJmUAe6kbGT7R7wHYhqj4Eo7TSKKj11Ju	812	3NLPD5Z1aRvma6cZs4uoAG4LbiLPRt35BSX3y7exdhgAaEkKZ98c	1607	1222	1	1	805	jxgNhuJhVpe7M3Bc2wwGyMkUTnBYwq2o5qHsDFBFoFPMnH9mqgf	450	631	631	1616052780000	orphaned
7513	3NL14GVJrT9WA3GaybHsVymk3MMH6jvFFkhHTHGuSQ3xe7AjdGdq	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1573	1318	86	1	6301	jxqJC85ye6dt19BipeYuenfS5oBx5WBbUiPCoyeUpnxTfKiFzCB	3888	5496	5496	1616928480000	orphaned
726	3NKtKCciQZe8MiHPLdHZ9HhRCeWsYhqpF8DL6H5SNaWZYGbYozg9	724	3NKjbnFwFSVeTCoUkBNWenk24xopLpHqLjfB9to9ah5GJM9eq4qn	1650	1375	1	1	718	jxzmFZiyhC559gBhXfoYcQszurw1Xo6z8YcZgkHsvAXpgE4LFjz	406	573	573	1616042340000	canonical
729	3NKCxs5ERnZ443WpZwj87rs1qYNg2TofuvG97E5EJnMzVYMQG8c2	728	3NK4yGR9BVJjhMi57gNBu8E9gusLzU1FLogXt5MyJg4aGs8u7Xju	1406	1393	1	1	721	jwHx5dEWf5BLxri7A7EgmUVeigTLYm4wUjqQqQtpxwsWe9DM3AU	408	576	576	1616042880000	canonical
735	3NLGF84Yy9tAttYjk9XCfVQ1MhM6fwH6WVFXXbEZ7cdaRBpDBUWx	734	3NKryXbzFExaZBfzZLuY5sjMef7WcoAMXRYCym8XhCXmoSQuFWUb	1426	1238	1	1	727	jxE5Bd823hWhMLEshSVTUuU27TxEmp9TNmnkhRcEN4zXEUmxboL	412	580	580	1616043600000	canonical
736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	735	3NLGF84Yy9tAttYjk9XCfVQ1MhM6fwH6WVFXXbEZ7cdaRBpDBUWx	1419	814	1	1	728	jxLKwTimNEk6Rerh5tMStd9HjaKZpMenM5cwyDWTFxMcAvLQJfr	413	582	582	1616043960000	canonical
737	3NLFUqqvNiDxZhM1hFfMS8mXhd5WEUdrvfeyrhD6nTDHY4EJx6SF	736	3NKpgb19AWr5qGvBVCNUjexmnP5RnFZ4gUJpar6t1EddAGTrbBFa	1536	947	1	1	729	jwWQDBbCriayosFJwSdQmA1tes7N3iQhm25SCSNbr5vpZMPD8Pa	414	583	583	1616044140000	orphaned
743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	742	3NKGUu18HMBXaRSKXGpC31HgB2zgS86euT5p6VAivpvkBebF1uct	1585	1366	1	1	735	jx7M22yKcTfFQULzeNqWGhTjU1HgyjrC4xrgQmeHcGq9jWFmmY7	417	588	588	1616045040000	canonical
744	3NLSSDGYMeaFyXLsSGrpbDBDL5aU4stawymC4Ta8YJhZwJEgf34X	743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	1668	1370	1	1	736	jxwbHbvLtSX3dpaaPnbyUDEty1USJBhP7redRwygcyc3pfNz3Cx	418	589	589	1616045220000	canonical
747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	744	3NLSSDGYMeaFyXLsSGrpbDBDL5aU4stawymC4Ta8YJhZwJEgf34X	1579	1389	1	1	739	jwrWMAse53a7LKxq9euqNqGeNPoyZMheydRTqYabskjNZADVdrb	419	590	590	1616045400000	canonical
753	3NLhAbi6tjPW1D7nUSLnqfbo4MysmhEU5FKLjrTZa9kNu4Zi2GGB	749	3NLkwXrcxVgcLFLonB3SEBTgAT4sSJuZBdjkDbwqBjk66rGVzhV2	1547	1012	1	1	745	jwWoToC6DiXFaEHvKHHdo12gXVrviYwG6hjKK8bWUS7SxX6a44f	421	592	592	1616045760000	orphaned
756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	755	3NLmBcTFPRzM28ePnVaeVwLsiiVWwpzZo8JW7m72FCXbgZaZUBLE	1642	1367	1	1	748	jwp98zZFRgqHF23w59nfLj7rGrk16eqH9nLAn8Cww5rw54xvgdP	423	595	595	1616046300000	canonical
759	3NK3JnmzJHRgDrDy8zNZD5H4Wtu6WfV7DEkLx5Nq4TbBncfGysTf	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1617	1288	1	1	751	jwXzhuW1rWH4iu9XA1fmZgS9YDE59qkodybGP1QJo6cvhzh3qnj	424	596	596	1616046480000	orphaned
765	3NLC2mJF4hivx2WyvTWmP9C1eCdNuNN1bgjMavSbY4g2RAcFjcd4	764	3NL5jaVJpk7FfrgMXupgeRznhxXduLoChvfgqd2agTcdXTmdM52Q	1587	991	1	1	757	jwuPwtDvove3nThaZrMa9HeWR4Rh8A5GWqeKDhvpuPypuceFJVF	426	598	598	1616046840000	orphaned
768	3NLkNDu5h5g9GUewRb3KSJRk5yEMAURYx64GoRXxBxrtZJQuZuqG	766	3NKLeJ5UfR9WyNj2ZKnRq2ht14kz7yj89rt7bNqiiMqo2XXJoMQr	1585	1120	1	1	760	jxquc3kfb6tFxBNTVpzm83tc23AgikYdy29Dzaqw4Zcz7zyZE8H	427	599	599	1616047020000	orphaned
771	3NKe3LZUtjBZKH341jqrDzzw8LwetaWgF7Szzsg9SKW56phfyYig	769	3NLDotPg6HMrwfQFBvXiteRAik8ZCNtNwcJgpaqvP8kUmfGG7brG	1553	776	1	1	763	jwZWVznzqkXPknBvfMXG4LyDwDLrtgch3SoEq7skuA5Gki5kYtg	428	601	601	1616047380000	orphaned
774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	1434	642	1	1	766	jxwr3rEBsYC44w64nweLe85CZjMcvCbZzP93cx2ZFfjmbvH9uZ8	431	605	605	1616048100000	canonical
776	3NK4SAF1RfbCCKjLSJr9G3xv2yj6dPq1S5zahCaJHszunBKzWjME	773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	1483	893	1	1	768	jwu7gRoKy4vLWPLUUpyMskM9NLQyrDcRMSW7PcXhPKtoXqoYem2	431	605	605	1616048100000	orphaned
779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	171	1374	1	1	771	jxQGKE22cf5gBdgzT3QAbJFi96Ejfpme2i4p7GHfRWsAMWcoP3Z	432	606	606	1616048280000	canonical
778	3NL24frm7BihjS93sqK55C2WnZMD8H5oJ7E3FArQm3qXYBS75jLv	774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	1541	1052	1	1	770	jx9698HMTgo5y6SZVziNNhAUhe3pT2irtW1ziBgWHcFEaNuFMfm	432	606	606	1616048280000	orphaned
782	3NLeCj6vU17hCKeA13BRgtbH6byvEvf2SLrpH5CS5akXr4beTGNA	779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	1553	776	1	1	774	jxUYffy8CnuRDVC31eJmyN3UYPyb2FDVRiEPaNgJpX5tNXg8YZh	433	608	608	1616048640000	canonical
780	3NKX5XBQNCr13GDFshPTNWcMeULNEBPMpss5oub3UN8tu4uXCe67	779	3NKJxa3CVr8jnfCGtJumo6pXNKKu9P31gvxv28LtnCdWQMg4ctU3	576	1355	1	1	772	jxxJRZGtFkvDWuekpExuGMifzsBWuV3YeVKLAfs2TXYkaM8SCNV	433	608	608	1616048640000	orphaned
783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	782	3NLeCj6vU17hCKeA13BRgtbH6byvEvf2SLrpH5CS5akXr4beTGNA	1631	794	1	1	775	jxRx3BcVBbLGkUpUH6AiPXPVnsYU2kKASmAWemUD2Djg9WzAk7A	434	609	609	1616048820000	canonical
787	3NK3m39VvMpYj3PHcn7h694s5Px67ew7xWjiwGwTd9q7FFU4ZT5c	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	44	1325	1	1	779	jx9VXYehdV2GRGjNRY4De5xrZdPPkZwP3hMRWtc6VghbvFBoSBp	435	611	611	1616049180000	orphaned
785	3NKpJ5tD84QZPSkvTzHsCCi4vhDYq1UbFALSppxuG66oN7MDS1N5	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	1407	1395	1	1	777	jwmUD23VEePyPrH5jfatkuSyY7bWsEUBZekgSmyrYnDjpyN9CSZ	435	611	611	1616049180000	orphaned
789	3NKmWJRJpxFKpNY64iJhh6cSqwNqsmh3q2dCMr8J9Wn3fpRqdiAP	786	3NKpRx2RL32dAk86yB6jXtGxPDt6S3xGcwGcir5CuQYW9KefRhyu	1573	1318	1	1	781	jwSnKyiZiubyYR2EajeqVmSSPJvqKYxaJD2QuHymry4dXW3p5mC	436	612	612	1616049360000	canonical
788	3NLGz1QWSckQP5CfrnLGBUQpFnoTAMTT2zUaeQYLdrfJVTrB4Z8L	786	3NKpRx2RL32dAk86yB6jXtGxPDt6S3xGcwGcir5CuQYW9KefRhyu	1646	1354	1	1	780	jxvZadspDYLr41DKrm19Xk7XZPTTRqjQzHxjqRmcy5aFXMpH4xM	436	612	612	1616049360000	orphaned
793	3NLemXZYqAZPeD9D4amTGCD2B5EirAnPVB95bhBK8pc53qfFbSM4	792	3NLafWB9tfj8XjDjWEJfHV11aVwcvDhJt6QrVjcveHbhFJBfyRC6	1670	1282	1	1	785	jxPyKs7KTBrumb2vXFJadFTeHWnTnymnimrAzmSC2UwetrSTbCz	439	615	615	1616049900000	canonical
796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	794	3NLZtjDaZH2AptVEbixrHppF5QyXEYt6hbt4pnbQwpMcgYpxbaKS	1406	1393	1	1	788	jwMjks8wCsxihK4mSbkavkYx8awbtx71RapYUCmS1XxJd1QDjwH	441	618	618	1616050440000	canonical
799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	1637	816	1	1	791	jxRb3RNjLLY5GSg27fvKgG8imwq7VXSiEURzNsgax9YuFVRSdL6	442	619	619	1616050620000	canonical
802	3NKAZb5NcNrgsmS2FdqoidMivve6YawQT9djYVjevWBJi3mykSKa	799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	1440	1011	1	1	794	jx4P9tYJBW9Z2hM3sPPVU3zRFRGEHbe8rnbak7CDeqEq25JBzPS	443	620	620	1616050800000	canonical
7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	7524	3NKjUMSS5s4mchc8VGjcnubgmCYSBQio4DStGFN6zzsaQ5enyyTV	641	1336	86	1	6301	jwuofGjsZe4Axp4YnWJWnF77vuDnLRXfqkF35x1QLLFeRVV7Vtm	3897	5508	5508	1616930640000	canonical
9680	3NKK2uS2SRiiP17m25PEo2EXohQv7WyD6ERAu6NvrGZKRwA7tDHP	9676	3NKtEUWPZtCuXuNU4Yqb5cwQTVS8151vCV3ovdeNRrRVaMhp2phu	1577	1327	124	1	6301	jwCSHXGuD4WP43xTPpQP2CnR4gpo59xmd532D7ZZP6U5pvLAKd7	5022	7068	7068	1617211440000	orphaned
791	3NKz6QX7UEHmVNHnYJTTUy1WdTRkdYcavz7xp1ZRQYZpXZS7ZgjF	790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	1402	852	1	1	783	jxe9XaHS1pTbqWNnrQnfq8ttH5v3XCbEg2XPNwswmsaj1sAw2o8	438	614	614	1616049720000	orphaned
794	3NLZtjDaZH2AptVEbixrHppF5QyXEYt6hbt4pnbQwpMcgYpxbaKS	793	3NLemXZYqAZPeD9D4amTGCD2B5EirAnPVB95bhBK8pc53qfFbSM4	1457	1265	1	1	786	jxnQaqyqVi3SNxhmXov693o8YD2De8N9f3UQUmZPBxPoGjsKxqc	440	617	617	1616050260000	canonical
797	3NKV2UBTH3iijZjFrjGydr8TAVa1tUqpgc6FJvjebutcPRvHyq59	796	3NKY86KixWT8U3kvabLKxFYSXLMX693rf7op6ZtkbzgjbXvRHq4q	1403	824	1	1	789	jw7dD8iJV6jykoHw75G13hMWZmJtCujehk35zJzgqioSRDa433T	442	619	619	1616050620000	orphaned
800	3NKKasi2HGN7jiikHBFuVUUxqC5c1XF4c8zcAb85yYZPfo5AarTc	799	3NLLGzvaq9K15o6tsotrDtmiWWRWyiWHmCAMFeKJJpvPb8HdXx4U	1657	1344	1	1	792	jxoh8FXs7osbDf4gxMGY6sK7brpRp8WHwv2ruoNmAaWakFGfxKG	443	620	620	1616050800000	orphaned
803	3NLputsiGMDzCwHPUWJQ9HswrzGZ97fd58frY3kGdenXoocDTzeo	802	3NKAZb5NcNrgsmS2FdqoidMivve6YawQT9djYVjevWBJi3mykSKa	1613	1349	1	1	795	jwErq1DYRPMVCrKUTbxneeNfcEfvMNA1QRPMd6oY9ScBKPhs8eA	444	622	622	1616051160000	orphaned
805	3NKyonQmsiW7S9AgsLA7UZ2YnjqMZhgMUbCYKEUzHnDhEv2jstWD	804	3NLv8ku1kuh28Wm1tCMPExFZ6Fu92w5wxHfWLe11BgWPjtwDikbu	1607	1348	1	1	797	jwMpr69FSV7Df2Lin6ssVRA5rAunoU8qSn6WfkWDdrqmfxu1BxM	445	623	623	1616051340000	canonical
806	3NKHVPVEpdT2zo1T6jHsnava51QehUMxBf4Bc3grmA2MHjJVv2HB	805	3NKyonQmsiW7S9AgsLA7UZ2YnjqMZhgMUbCYKEUzHnDhEv2jstWD	1652	1315	1	1	798	jxPuedTephU1tCHUZ75YA52D9atQ8yFBMH1aKkJA3Eg3GcNCuqz	446	626	626	1616051880000	canonical
807	3NKc7xg83z1Ee9cBnYEATz68oYpq65VPykE29HuRgVmWcuJA6BQy	805	3NKyonQmsiW7S9AgsLA7UZ2YnjqMZhgMUbCYKEUzHnDhEv2jstWD	1553	776	1	1	799	jxodZ9Be27BRcFD363KCwtnUHmK9y1aXvWiMjVcg2LjHkAnkL4W	446	626	626	1616051880000	orphaned
809	3NLgmkPdfsXKkdWMsUvnTKUMZHPWubDWcUyy58iAZxWpnLcr5Cci	808	3NKrJvpG2jyyj7N4dYMR49cvkxVnixJ1XK4r38TDTVnzBu4DNwZM	1477	1224	1	1	801	jxK2BnbdCvBGU4gzzSV68NrJuPgKAEinyF2be3Gak5JaTCKchKu	448	629	629	1616052420000	canonical
812	3NLPD5Z1aRvma6cZs4uoAG4LbiLPRt35BSX3y7exdhgAaEkKZ98c	809	3NLgmkPdfsXKkdWMsUvnTKUMZHPWubDWcUyy58iAZxWpnLcr5Cci	1616	2	1	1	804	jxaWkNhBKiybXEVFVKtggM5xL2xfCzZ45v5UfnGGdERoSx5xqkW	449	630	630	1616052600000	canonical
811	3NLwyuioYjzdrKeSZDK1RSuiqDar8SEejXv99D9JLriQx7c9WMcc	809	3NLgmkPdfsXKkdWMsUvnTKUMZHPWubDWcUyy58iAZxWpnLcr5Cci	1637	816	1	1	803	jxfkFti2fZ5gY8xwkqrcahSaeoUYyzGFKW2riuvGnhFbRaAzXxv	449	630	630	1616052600000	orphaned
814	3NKQsVYdtqdCvXTnZrgEF9z4i4vEQM5ohXpHbJ8kF3Wq7oDSQXRf	812	3NLPD5Z1aRvma6cZs4uoAG4LbiLPRt35BSX3y7exdhgAaEkKZ98c	1590	1174	1	1	806	jxV2zj4YrHvbNLgLPKRZzMoscJxCLpTkcPYFWCXQ4w88vDCbvbp	450	631	631	1616052780000	canonical
815	3NLjGGQ2SpxyQ3yv77in1un67vDCdfn8gShc7vv6DKYyGqL3zMJR	814	3NKQsVYdtqdCvXTnZrgEF9z4i4vEQM5ohXpHbJ8kF3Wq7oDSQXRf	1617	267	1	1	807	jxeQb1HptiMXKsDA9hcdXkHP1ZSzg9sKU42Le4LwrY3YiXqiwSu	451	632	632	1616052960000	canonical
816	3NL39vLX2ZYvoekqspRtgzMQHJcTtPyLjHXfTyGpjLHgv915hZR9	814	3NKQsVYdtqdCvXTnZrgEF9z4i4vEQM5ohXpHbJ8kF3Wq7oDSQXRf	1553	776	1	1	808	jx1KfPB8MhR12t5epgpwK112hyst9BQThNc86VPG1oURzipKVp1	451	632	632	1616052960000	orphaned
817	3NKu1cuuUbvoXV1VdcpsMiW4gw3h4AvscaJjtT3EaBYH8sg9BvPy	815	3NLjGGQ2SpxyQ3yv77in1un67vDCdfn8gShc7vv6DKYyGqL3zMJR	1607	1102	1	1	809	jwS3rZs3WJ983bCsfrZqPf29R2Vx6XKYUYjPcKVXMMW5XxwiDUD	452	633	633	1616053140000	canonical
819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	817	3NKu1cuuUbvoXV1VdcpsMiW4gw3h4AvscaJjtT3EaBYH8sg9BvPy	1631	794	1	1	811	jwnNRc9zAG8JathRGz47VpmGcbSGhk2bg6JvnU8wZazCFVU3ehm	453	634	634	1616053320000	canonical
818	3NKRzpw61KtCxYbSHVCkCjNWe1KX75S4wA7tAfvbed18rhCusuw3	817	3NKu1cuuUbvoXV1VdcpsMiW4gw3h4AvscaJjtT3EaBYH8sg9BvPy	1609	1087	1	1	810	jy13aJ9W5rpPjam9Zz6MsqucLnubAvWBw9LnTYsRGHpsJiyNLF9	453	634	634	1616053320000	orphaned
820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	1458	1077	1	1	812	jwbL29nEUYnWZ6ndfd11WA6XPggHN7FZG1BfGwypbHnAaSht6to	454	635	635	1616053500000	canonical
821	3NKhZbEPUeH2JtL1LeDXWaiwEczaXBrjyERT23GD7GFaGxGogGBh	819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	1611	1215	1	1	813	jwQFMGk2u3zRJZhs2Rx69ra538LZMMoKE5AWjGEQkqJt8CAR193	454	635	635	1616053500000	orphaned
825	3NKjgNTBRyhoyCDaEhxpPKYqeD5kRhubcT2nZztZDPVXuYdvAXaC	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	1649	1137	1	1	817	jwWuuUCqDJ485hiqtnvZkH7x1p6e89aTY4iashM6em5cY4EJRrV	455	637	637	1616053860000	canonical
823	3NKRFSEz8vxt3rPxLwEtkUz7uyxciEcvuaRkz9e1AA2n6T3u5hEL	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	1406	1393	1	1	815	jxNmQ95vAnwUg3c2wp9ytVZrQivw8hJqLRiJh1Ngfb9fRFZUrrB	455	637	637	1616053860000	orphaned
824	3NL1heM4udhiLFLiuGHEiL2SD2kCy2S8aivA2c7S4gj3A2uyi66K	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	1407	1395	1	1	816	jxZHQmce1bJ1edgZ9ZBUhvKsiRTqWbPNWNMBqYrYZPCVkCPYFh7	455	637	637	1616053860000	orphaned
827	3NLiMuLVfUxmycU8pDeaEPk9cw1PRVkZfbxKRFXU67BZiyyCg4vY	825	3NKjgNTBRyhoyCDaEhxpPKYqeD5kRhubcT2nZztZDPVXuYdvAXaC	1406	1393	1	1	819	jxb1wiBnT77YohZ6ayt1rXYirkKHBjviEiNSumF6wma4BBaag6g	456	638	638	1616054040000	canonical
828	3NKrsKWGEKHJeGD5HVP2UvPmxXP92hqKcuTy2TR1h6PaC7RJNKgG	825	3NKjgNTBRyhoyCDaEhxpPKYqeD5kRhubcT2nZztZDPVXuYdvAXaC	1407	1395	1	1	820	jxBzgLSW9SVizwSG53B3JC8eUEQsjp1cSroNaatwLE1ojmhV5du	456	638	638	1616054040000	orphaned
829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	827	3NLiMuLVfUxmycU8pDeaEPk9cw1PRVkZfbxKRFXU67BZiyyCg4vY	1406	1393	1	1	821	jwGxayhnCCp7tP8BinYopBc9P4BjR54pA7QsFJZZLMNyX7hMPph	457	639	639	1616054220000	canonical
832	3NLMyN8qSUJTAkWEHoXqLH7Z4QfYa1F7PnNbRUM5YG5773b1hcx6	829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	1637	816	1	1	824	jxRnBgfZWgcLStZmnfNWJtf2ZJKFJqC2NFdxt1SL8PY8GDZqCvJ	458	640	640	1616054400000	canonical
830	3NLCiCbJBf9RJ7RiQpBvUduFy7TxuTqGsrNChZTn6EWbPgWDkK3M	829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	1588	1146	1	1	822	jxiTETj1h4YFWk82fgA3pTY6LK1mSvR8uHPaoiJcBw9UsB9N7vg	458	640	640	1616054400000	orphaned
831	3NLG91jsNFsFyEh1ySES4ueM7CmUojgvV8Bzd3RUtCRnad4tj7WA	829	3NK3eFCy1g3YM8vZruXBsWWmMY8bCDPYB3dJXrcyJFSr29uGHNKa	1553	776	1	1	823	jwEDjr8z5Ft1nuruNxe6HvGE6LUbEw7zzes3gvL3KvfLceGMwSu	458	640	640	1616054400000	orphaned
7544	3NKuNSgcNfA4VyTQdD668pbJjWaCSXcnNqFM732t2BoP34W6SGHu	7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	1402	850	86	1	6301	jy2t399CKkQ7tn6vii5U1oEMP9JUwEuKSousprxDRfXjGr4bbyE	3905	5517	5517	1616932260000	orphaned
834	3NKT6TZ5h7WdycDbqRbu1ZMEVbfbSb3bWRGr88LLNHF7RANvPSf4	832	3NLMyN8qSUJTAkWEHoXqLH7Z4QfYa1F7PnNbRUM5YG5773b1hcx6	1561	3	1	1	826	jxjroAMzw2r3DEs345GKCJjhDYUK7ceN8UMgcPnkJQe6KyJXGeQ	459	641	641	1616054580000	orphaned
836	3NLTL6uwMERP1buYg4zGVeDFqfjCgHJCDL3av9uJp18d2Noxso83	833	3NLrLSb62TLh39wWitnF6AC2wNAMVzcuk6AH5YB8pk9PtMjmyR5t	1581	778	1	1	828	jwxQ2PNNSFEEBtQeGjZSFdaamGjSwpC5WM2RsshZewNA4GfQ8jm	460	642	642	1616054760000	canonical
835	3NLovJvnbkSkYP38JZZgC46GHuXcVDnhtMBoAPh8ktEQGJ2x9UHo	833	3NLrLSb62TLh39wWitnF6AC2wNAMVzcuk6AH5YB8pk9PtMjmyR5t	1643	1053	1	1	827	jwU66KbTFrrAmbn9pHCNWBFSGUsZXjknoFfHWHCGivUtK1wA84K	460	642	642	1616054760000	orphaned
837	3NKxfdPqfUDKx6HM3R2JiCNYQfTPyz49QRRMuJARgZmaxmNrbTux	836	3NLTL6uwMERP1buYg4zGVeDFqfjCgHJCDL3av9uJp18d2Noxso83	1654	1340	1	1	829	jxKQVoEGzRettAHxKQvPCcqJpCB8aS2ToGi82cVXgefUpz3fiaZ	461	644	644	1616055120000	canonical
838	3NKZSvG3PgsJGr15yddyFKHedmxqNaoZXbg9wrUcCWH5E2bwTWgX	837	3NKxfdPqfUDKx6HM3R2JiCNYQfTPyz49QRRMuJARgZmaxmNrbTux	532	1303	1	1	830	jxGzZ7vhzEx3mzRjWmzLis63QLeYzo6YuZAVuJRtSLfpaFnhYKD	462	646	646	1616055480000	canonical
839	3NL96fDfbzAbCD9UHj6pjQQSGWtBm4GPDiMAHvssn2VJ1CwCQPAP	838	3NKZSvG3PgsJGr15yddyFKHedmxqNaoZXbg9wrUcCWH5E2bwTWgX	1624	1334	1	1	831	jwUwJnbsPFjMggnndYeyCsKX7ayHZ11XakRmRoahoJFmfVaWz14	463	648	648	1616055840000	canonical
840	3NKg1wTjvcyy4nugVzc2Fhv4LX5rT84eS5fZbQJqBJQ1rqdX89nW	838	3NKZSvG3PgsJGr15yddyFKHedmxqNaoZXbg9wrUcCWH5E2bwTWgX	1483	99	1	1	832	jxq388nxDMJ7aw4bBXG5FetqCe4J6mYJWoBU1cooES5NCXsf4N7	463	648	648	1616055840000	orphaned
842	3NLKB8iCJGDMjLHZHNxCf9fv4Gq1PcHVwNsXNc2WMBHg6EnAiVNk	839	3NL96fDfbzAbCD9UHj6pjQQSGWtBm4GPDiMAHvssn2VJ1CwCQPAP	1483	390	1	1	834	jxk8tR5dTwusq4oWESRLEQbFAPPxiTxBm1iki1hjdFrPBgwdtNC	464	649	649	1616056020000	canonical
844	3NLvqdksbbFRj1YadGy6KRmSebjdkGYmmCafADUEDd1mVPLmwLFE	842	3NLKB8iCJGDMjLHZHNxCf9fv4Gq1PcHVwNsXNc2WMBHg6EnAiVNk	1481	789	1	1	836	jwNrG5cGpV2QQtqGriTi1ifoCpKybNWJNFBFbKUr81YXZiGfVjx	465	650	650	1616056200000	canonical
843	3NKpMmwatqrbVmvAY6QJTCUbDTjWMeHSpRCbq8hvd1noEqqYoGk5	842	3NLKB8iCJGDMjLHZHNxCf9fv4Gq1PcHVwNsXNc2WMBHg6EnAiVNk	1457	1391	1	1	835	jx1xDdrcFL4nEqzyFiPpp6wwr1UD3orcgvvw6R5xx8s5Cma5khn	465	650	650	1616056200000	orphaned
845	3NLnHYxj469cZkJJ1BThw34dBu6GRbkTznTx3uoXJbUgoPBPK1er	844	3NLvqdksbbFRj1YadGy6KRmSebjdkGYmmCafADUEDd1mVPLmwLFE	1585	1240	1	1	837	jwYrmVjZ1eaMAb3b7pbCYAAYmf9i8W1yJYzkmHj28rTsH43Zdxn	466	651	651	1616056380000	canonical
846	3NLyDDhQRJiz7im1uEf5RtervXUCan6YkMVVurEEue1Ap6G8PUu7	845	3NLnHYxj469cZkJJ1BThw34dBu6GRbkTznTx3uoXJbUgoPBPK1er	1407	1395	1	1	838	jxv2yzhSGHKXcofTuC8rRhSuXFqoNkFqdyynhzimhxtkVoai5QY	467	652	652	1616056560000	canonical
847	3NKGrXoMpZSYSoNxeHoft1iVNUrKkjGAtomxyXjST8ajhWjNi8hy	846	3NLyDDhQRJiz7im1uEf5RtervXUCan6YkMVVurEEue1Ap6G8PUu7	1599	1041	1	1	839	jxR72P4bd9xZhxCmYMQ3pryjshMwkZyPb4Rton44VkwzicuaQoF	468	654	654	1616056920000	canonical
848	3NKhfcwMXWxSSKLkFbWsYv6rssEw6xNhQZPMDW32zZBFghBUJJ8g	847	3NKGrXoMpZSYSoNxeHoft1iVNUrKkjGAtomxyXjST8ajhWjNi8hy	1406	1393	1	1	840	jwAptmyLSd5nwAv4MFA4FLRg27DS5H4qBxJ3R4h6benj6pjpGBm	469	655	655	1616057100000	canonical
851	3NLQCCAsGfWCd4EaLrLncAHMZwBTzPRDVNGZYFQtiJ4XeZowpHz6	850	3NKmKacb8QGKU5h1L1r535ZV7rJ7eTn8dCMAf6pySFVv2ngWPYnL	1564	972	1	1	843	jw8byb9NcNyLT8v2bM9u2uxVYpzHBGqfg8jcQALJhNsZNS3C5h8	472	658	658	1616057640000	canonical
854	3NKp5FizKdGiXww4ANh53UxQLuhdyVUWa1XXD1U7bMF9intrv29L	852	3NLoYYKU7BE5571a6iUiybxRzZ4So3tmsvi4Y6cRQLbpPKDbzrBv	1541	1052	1	1	846	jwjRmUnt2bgSS8PLP7bxeLzHUpNUHWVgDWwLSnwL27zeGvZGttw	474	662	662	1616058360000	orphaned
856	3NKuH14r4KJVQUVbsDmgA644uJL2d6gvPqPqDPjrKn1NBU8v139R	853	3NLmrj3BjsaiJDhJwpWS3DB97HSDA25GUVFLJxwFEx5Q6DmqnATY	1476	1371	1	1	848	jwe9wD5PQoMjizPK5Gtuw2rWuXoFbYTMEqSVHUk69N5PtAuLLk1	475	665	665	1616058900000	orphaned
859	3NLcXheihU3VDGvgGCYKmnUGdzYYoLmyzs3asWZYnTD9q8MxeJ6V	855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	1573	1192	1	1	850	jxYbvYvinDJVxQkFsnykgUrzdEFz8xWH9go89HAc6Nod5WKYAZw	476	666	666	1616059080000	canonical
857	3NLedkwGqfhn1KkWtunVPvATn7krYSnWDuHab6RxfPsSRHbv2Lp8	855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	1651	1055	1	1	849	jwRWgy2F1Mj6BGyypnHqHMyV738aPNzTveeZpnLwdyYn7ZmRgKG	476	666	666	1616059080000	orphaned
860	3NLtJB8grjunVZesq4GsfUK88Z9sfXarNYBBfi3ajm5dCd8phukU	859	3NLcXheihU3VDGvgGCYKmnUGdzYYoLmyzs3asWZYnTD9q8MxeJ6V	1585	1366	1	1	851	jxio7VKt1TtKJi69jS8fvrzvJsREQeYGk3MA2LgWeN3Zr2H1fmi	477	669	669	1616059620000	orphaned
863	3NKFnsJcV1vw13JQ76zEdoymhGNa51yfJfGe5WFifSw6tiCYFDCS	861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	1405	873	1	1	854	jxaXREtuBhE9hCUYh5qXjSX8YXdpPbnoXbfN7FmZxL8Rwv8XgPh	478	670	670	1616059800000	orphaned
866	3NK3b9cjS19xtShY6HSX8ztWPSfjLVzbkGhN8YtgiwgkbHSnMiRw	864	3NLsY8aYqUkw6JQizXGDX7qLJJXNx8PXZG1G4rR8C3a2CtZtcLk2	563	1359	1	1	857	jx7MLAQPEj71nXNgxkpKu2Q59YJtgQDfBgmtateUsgZJ9f9t5M8	479	671	671	1616059980000	orphaned
869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	868	3NLdxz4Kd6ExpLrGpvEpA4pyLVgB7c1RpGpUuRdNtL9CfcbEngqE	1593	1220	1	1	860	jwZNX4CXiSYwR4tj8Fz35AEzUqeA82VxbgLgXhYZMY19ME7aUXZ	482	674	674	1616060520000	canonical
873	3NKfgnZaAUh7wbk6FNvDKSeF6VbRTLmVXXQmX3g9Q2xgRUFaQWW3	869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	1536	1313	1	1	864	jx3GdXqrTUwBecq8xVvX7vLheD4u4agnZmcVpcgqda9YTBeErWQ	483	675	675	1616060700000	canonical
877	3NK5jtZLo3tRmpGXD4cYunDtRiZirv2PcVnCGqvdDwdCYDqFBo8R	876	3NLvLBVZ7Z9QR3jX1NAgwPrKueYVkDWZfoy9oKuGAsBqLdJwXPTJ	1654	1094	1	1	868	jxqGFsYfnF7bbAt26GDaxzWMSqdz1YueqNRF5YHLPzMRbwmwhK2	487	684	684	1616062320000	canonical
880	3NLG1f32AeBYUVpHz8Ms8tdbEPwusd69mTF2EfyAP4J9KMFUjy6m	878	3NLNusfazoy3tNuSMHZqSLBSYL3BikvyMmUkGhkgABG4igFvSM5Y	1422	1337	1	1	871	jxkurxWdirwHG3GgNQoJgxb2z1UxF3WSihwvTqT2WG846LjeVps	489	687	687	1616062860000	orphaned
883	3NKSDC2Y3R5KCmq3CHV8aLGQfu1GMkW1fWm8VBG7ypbxQvkx687r	882	3NKQMATK8ophUKZ1imjmbzmn6UAs86yy7dK6fivi84swfkyokqCi	1637	816	1	1	874	jx42BDw6sgmtbK9sKGC3EsrvmhztMcW2JFTowZZLz3ZEesy9YMd	491	689	689	1616063220000	canonical
887	3NKULx437jYfTo3PEh32nK46pGoeybD1RuM71KSoS6EK1A93GHyH	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1516	1168	1	1	878	jxJf6zyiGmMAgGtdpyLij97y3jrFJh3ANJ8qoMuYZDr3qjbfHCB	493	691	691	1616063580000	orphaned
889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	885	3NKj3XovsHpw5rDvdoQgoprCQ9BcNtGDhRvUdEqNbSrPSwSz2ZWd	1585	1120	1	1	880	jwyFMwk2TMV66EDjd8BL8ndMEeohbNpczbiewpHasGWKFUJZbj4	494	692	692	1616063760000	canonical
7563	3NKS8PhxeqVY8k65ZWfeS9fYyQ6f71YA9UfPPprtfuobvhDy6TG7	7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	1675	1342	87	1	6301	jxhxfcxrpNUcZUPRY91d3XVkn5fGctzLG7NhjjuwrgUYGdTbHth	3916	5530	5530	1616934600000	orphaned
852	3NLoYYKU7BE5571a6iUiybxRzZ4So3tmsvi4Y6cRQLbpPKDbzrBv	851	3NLQCCAsGfWCd4EaLrLncAHMZwBTzPRDVNGZYFQtiJ4XeZowpHz6	1602	1369	1	1	844	jwX82KZ496YaaXztWPxmRCYPfWpzkv62ovDXMr1fDK2Lr8vxkYD	473	660	660	1616058000000	canonical
855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	853	3NLmrj3BjsaiJDhJwpWS3DB97HSDA25GUVFLJxwFEx5Q6DmqnATY	484	1193	1	1	847	jxs9Z8fTBcHTBWJCENYQedSFZbFWVB2QeUrsGi16xbRkUfd3BXP	475	665	665	1616058900000	canonical
858	3NKFrJkjX3Gb6zA5hZspZBfwm9dzuGEdn3t8VRytiZ4YFGYKxvqJ	855	3NL1K4v1ZCqyFV8ZCBAFn3dSwFKzSpuxbNaFg4yV6ALWPwo2oVTk	1651	1055	1	1	849	jx3HMZy1zukpuzGgmjjcACJP28r8ZNjuCfBgat7UEBPgZiV8kDx	476	666	666	1616059080000	orphaned
861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	859	3NLcXheihU3VDGvgGCYKmnUGdzYYoLmyzs3asWZYnTD9q8MxeJ6V	641	1090	1	1	852	jwoYCMNoMaJrVQQnNv6vLum5GyyrfzXDETuBR3KJHcZPkmdh8Kw	477	669	669	1616059620000	canonical
864	3NLsY8aYqUkw6JQizXGDX7qLJJXNx8PXZG1G4rR8C3a2CtZtcLk2	861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	1541	932	1	1	855	jxTgHTy91MGMEUmvmzM5iVKeJZEr5VKwMLQyHagrH8ra5ByHnz1	478	670	670	1616059800000	canonical
867	3NLBQQ1SYGvVYahiTrjjBZv6KwiMkrVfc5Q48qPe3m5GtbnHCQvk	865	3NKLM8bt3Y4peQETFBuLpRR1jR31nEUMGjn26Vp8fJMsPAvi1UPQ	1460	1324	1	1	858	jwBPZ4LaMvXDRXxKUdKAWSsowZA8igL1DZqPZAA4bFEWvrYjB3B	480	672	672	1616060160000	canonical
870	3NKUVUiB1DrDXPDtpRk5buL42h2LSqwwiF7tdnePnzpNcvKobV6N	868	3NLdxz4Kd6ExpLrGpvEpA4pyLVgB7c1RpGpUuRdNtL9CfcbEngqE	1637	816	1	1	861	jxepCWqHeNwwzRHiwAc6PGuJSihF4MbMoWyFcGmnHmFXseW1jvh	482	674	674	1616060520000	orphaned
871	3NLkBH8bBhMvtHzsSMgm6ctaMsU5ZuBHrHfZ5VEUVkdhj467VBha	869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	1406	1393	1	1	862	jxyha7kA5QPFQ2CCNh4rCCHdfTM7KaGivXZWHJd4yQgK4uRjbBc	483	675	675	1616060700000	orphaned
875	3NKTWV8ZvNg8MZxg8CB4ArkxW2rm4w6H4dTRCwBRVHThtzkdUw6j	874	3NKXbwgjHPjpyj762DJcFXfuNDfHbhMWKHefYDXXnCAf7A1jxUFJ	1407	1395	1	1	866	jwi8JEP5dMTbGpdpnTCDxhonNrEKrvWEVEAMUR35AEPT2Spwm6W	485	679	679	1616061420000	canonical
878	3NLNusfazoy3tNuSMHZqSLBSYL3BikvyMmUkGhkgABG4igFvSM5Y	877	3NK5jtZLo3tRmpGXD4cYunDtRiZirv2PcVnCGqvdDwdCYDqFBo8R	1407	1395	1	1	869	jxazEx6X99iwRidign8SSvRb5R3QXP3fVTu61ELVEE5xJRgYNEy	488	685	685	1616062500000	canonical
881	3NKXeqKonVwqYSVj7dMmLiAQezVSKhqtj1M7TVSdp3qxrZDcCRvT	879	3NKVA8SaH4t5awv3PWUKbLFjCCGUa79ay3FyPDk1qBVMdBYibQf2	1578	556	1	1	872	jxMbgsJdBRY3pJtQP1yuCDNQUSttWvoqRVFm9dvSrRWbgfTFWbt	490	688	688	1616063040000	orphaned
884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	883	3NKSDC2Y3R5KCmq3CHV8aLGQfu1GMkW1fWm8VBG7ypbxQvkx687r	1600	1126	1	1	875	jwntVNSxVeVr3NuXW57x2rihcjcA6gHmVHpZ6kntCSye9nUQGhU	492	690	690	1616063400000	canonical
886	3NLoCtV1hrynWYCXq26hbJAawuqxVQx2PV3haxADSYiAxWREzoMW	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1637	816	1	1	877	jxGxkxmqb1f7KYbQGgESrXgNdqDttUYbBdiFeD8x5Yw48qNB7dx	493	691	691	1616063580000	orphaned
892	3NKj7a7MieLkgjUEtkUoJNu1kr2Qoasnw4fT7GrNK1Yd5rZedAiD	889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	1600	1372	1	1	883	jwfMYfEQ5mJpBV6YvYkUzfRKS7gFfSvcr5hBsFjyxk93bZZySbk	495	694	694	1616064120000	canonical
890	3NKMNLsVydsyhKZPvKtWPZh51zjoG11LLQQud8wGEjmWGnawKgrc	889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	1402	852	1	1	881	jwDyywi4u9CiDFxtkcYzoXQRZhHB4nrNFn1mGijgc3fRGyTV5Pj	495	694	694	1616064120000	orphaned
894	3NK5YxxLBRfiYeCxhviSxsCVCtQZedXnwh4V1BwaAp6XKh83hERD	892	3NKj7a7MieLkgjUEtkUoJNu1kr2Qoasnw4fT7GrNK1Yd5rZedAiD	1407	1395	1	1	885	jxEnxU8fqpvsYW1TYkp74Ay9VUfY9xb5eT9VMd9MV6Aj5KF2LMf	496	695	695	1616064300000	orphaned
895	3NKwbWe4r3f1UD9iuvt4dK6QwtZJWiR3jy6puErT3YKHzyyUgCyM	893	3NLDVx59XjQJ7Jt5PtykjeaicVoK9Yh5hUUnivD4MaUMZmU9mcTR	1646	988	1	1	886	jx5TN8yZAqd1YHEXggp95ZbQDCBk8iwKDSgLRz5AioZkBtFAL4N	497	697	697	1616064660000	canonical
896	3NKiCdmgaobCiiNgyhi8pAVq81r6z6rxq4P9FVE2zJpA9R2ppkvB	895	3NKwbWe4r3f1UD9iuvt4dK6QwtZJWiR3jy6puErT3YKHzyyUgCyM	1509	1194	1	1	887	jwZcyKNb46yJY2XaGKR3yBwx5PRcK7QJUkgZAHgdpBQ3t3CJrsT	498	699	699	1616065020000	canonical
899	3NLf7x7odrpc3oRogqd6ZD3BMy4sbtu5Szdcsq4f7ofxwWE7oWLZ	897	3NKdX9tBNoFmAWKWkHjsrSipULgAGUpYsCMK9bT28UP9ohhJ9HLa	1637	815	1	1	890	jwn4xcLgAB8BY6FaxJtVqy9pN74bqxfxDrT8vp51HdFUJwHcBP6	500	701	701	1616065380000	orphaned
902	3NLQqHbGMZQq1BJzJrHqKDMvE2kMgVq5ifYSC5TffCKLyjJQPCcS	900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	1448	945	1	1	893	jwxHdgHMW7ts9wZg8eMujgM6e85mZGzsxCagX1KYbgDrAc5hEm7	502	704	704	1616065920000	canonical
905	3NLMCuqsm9y7dG9tx6iPp47wpMx7qNVPuGEohpcE82PMkDdkPUQx	902	3NLQqHbGMZQq1BJzJrHqKDMvE2kMgVq5ifYSC5TffCKLyjJQPCcS	43	1310	1	1	896	jxLAkWb1oE33o58kJXrjzUiTT7WCfLR5cYDtigYpikHsaDNaXMh	503	706	706	1616066280000	orphaned
908	3NL2CMP8VurBrxRuB4cvaqF194aGey9M9JM2dQ96heizMgNk6QNB	907	3NLFqX5eaLoapEKHbCPi9hYgrCc3nEsrLv4fCATBhe2CP36KDuub	80	1273	1	1	899	jxY9BZQWXNzR4hRqXG7wQBxGeVXrkF72WMJtzvg1kEMn6WcHHgK	505	708	708	1616066640000	canonical
911	3NKv3cHY159cXb7xcLbWx86xongyhgxHk5X6kCceDSzQr2CGPYK3	910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	1622	1356	1	1	902	jx4d4WiGmL5FcJCY513DqTJnhySgrn1ZbxMEBFoVN5vRKP7z7MH	507	712	712	1616067360000	orphaned
914	3NLmQPpQfxzgatWGAGZ6L3musejmRkCAhyDDYbp8zrxDaxXLVLgw	912	3NKft7qRgXvzVVt5NNWuVfCAaviK3iCP8KchWP3BBBdaxFGvBzXt	1407	1395	1	1	905	jxSMPL8r9MfT8bd7ei4PtA4Jzhs2NrGgozZ8WXxSzYZeuQEHauF	508	713	713	1616067540000	canonical
917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	915	3NKEkxjT4J7X4aRk1qQzVYrjMYyJ9disvD2iuNhXpzFkFtRKY2KK	1407	1395	1	1	908	jwS2zVMiaeKACSG37rek3SM9Dv6dHGgPkJTMhbq4NR3C5cqujRk	510	718	718	1616068440000	canonical
918	3NL5CbVMLJW9A77MJhSH6Eu6oRoGhvgwZi3eNnfUiVgW6FwxjiYr	917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	1403	782	1	1	909	jwXDcFuxSsyV8jxiCsH1cChuMwj6tw2tHENRRW35WiaKZwQSkcV	511	719	719	1616068620000	orphaned
921	3NKk3meAQka7pygkcMLLGDeudCFnmrS59LioDqcukGGQiVcZAHbp	920	3NKD1BxHLCkvgjh1GuCf3uHew5QvYs2SGRePwWXuJJurDNp1bQh9	311	1307	1	1	912	jxZD69UCPB9FRPKDGv4Qh5MdFTKLCK9yFEqpsZLBeHe323wvoyk	512	720	720	1616068800000	canonical
930	3NKxcF8szE2wyM72VS2NS7uS6BjEjxeE7Av3n2ocUUKER2NAArGG	928	3NKUQTHTwGeZmGgE3uym1oeijkCyk9huLcxeUqpjvAGbzCgyaUkp	1402	868	1	1	921	jwFLd3QLQvL2PenEk9HQuNvXFU17CL3CnBYL8PChyzkpN3wR3qG	518	727	727	1616070060000	canonical
933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	930	3NKxcF8szE2wyM72VS2NS7uS6BjEjxeE7Av3n2ocUUKER2NAArGG	1407	1395	1	1	924	jwz6xdHDsjw8HCr5oenYaWJoo6euT1fE9ZXiqoXUByfaM5iRE7e	519	729	729	1616070420000	canonical
7580	3NK8zSr4ayLaRwVDbiLFnrQH21QoZBgTge1Yo5iqxWEYmDN8iCKM	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	1406	1393	87	1	6301	jwo4HiVVQvVLXfTa9DHZwwaZLghraUc5PkhuPwVqagUNsF6VNyJ	3921	5535	5535	1616935500000	orphaned
853	3NLmrj3BjsaiJDhJwpWS3DB97HSDA25GUVFLJxwFEx5Q6DmqnATY	852	3NLoYYKU7BE5571a6iUiybxRzZ4So3tmsvi4Y6cRQLbpPKDbzrBv	1559	987	1	1	845	jxzmM1M2amb8yDswYnTsANHNwUBBaA25Zxo1HhhAQVMLhgEvqFq	474	662	662	1616058360000	canonical
862	3NLtPCCnWLPFiW2pCKTsets6Gxa6uF67jPbT3A6pYcs9Z5QJG4QN	861	3NL7TZQmhfD89Pa72xgHL8QdxLmPFukbYkEMjyCTSE7VtJDy5xki	152	1330	1	1	853	jwsYjaCtoHjrWKEWMFL68AuiSE3kj4fXEnc9uNMyrUCUG2asdU5	478	670	670	1616059800000	orphaned
865	3NKLM8bt3Y4peQETFBuLpRR1jR31nEUMGjn26Vp8fJMsPAvi1UPQ	864	3NLsY8aYqUkw6JQizXGDX7qLJJXNx8PXZG1G4rR8C3a2CtZtcLk2	1451	1046	1	1	856	jxUCjN61P9dYpUYCt2YXC8frTSgCzgmrjcAXqCpzEtDuPckgE8h	479	671	671	1616059980000	canonical
868	3NLdxz4Kd6ExpLrGpvEpA4pyLVgB7c1RpGpUuRdNtL9CfcbEngqE	867	3NLBQQ1SYGvVYahiTrjjBZv6KwiMkrVfc5Q48qPe3m5GtbnHCQvk	1518	788	1	1	859	jxbEiDPBeVQeTqQag5gUpR9H2bgTooh4Me8ie3yLi3CfpZhN9cf	481	673	673	1616060340000	canonical
872	3NKhkDHAaQnaQcJvEQHmzEwuD64oj9yKmVCPHWtAjLK6nZkwZoz2	869	3NL8nLyKM22Gs4UyGsqYsSthk4PaBMVjz2y3j8HzxzuH62PkpG6L	1447	1345	1	1	863	jxKLnd5VHPKed73hvHfYVCEWMr4n8ZvTvrHyQkxVdDwDyGv1RL9	483	675	675	1616060700000	orphaned
876	3NLvLBVZ7Z9QR3jX1NAgwPrKueYVkDWZfoy9oKuGAsBqLdJwXPTJ	875	3NKTWV8ZvNg8MZxg8CB4ArkxW2rm4w6H4dTRCwBRVHThtzkdUw6j	1602	1123	1	1	867	jxX6zRrzuRhmCmEeMn7WtWw73Zbrj8do6u259Y2Uf5aBkHwMT6C	486	681	681	1616061780000	canonical
879	3NKVA8SaH4t5awv3PWUKbLFjCCGUa79ay3FyPDk1qBVMdBYibQf2	878	3NLNusfazoy3tNuSMHZqSLBSYL3BikvyMmUkGhkgABG4igFvSM5Y	1406	1393	1	1	870	jxKrqJkopK7BgA1LaK26XUhecQZSbFMKSCsPevMWbwvK1eVz3LQ	489	687	687	1616062860000	canonical
882	3NKQMATK8ophUKZ1imjmbzmn6UAs86yy7dK6fivi84swfkyokqCi	879	3NKVA8SaH4t5awv3PWUKbLFjCCGUa79ay3FyPDk1qBVMdBYibQf2	1646	1108	1	1	873	jxpAb2qPXU5Ru94cdMSxVR4yLRQmW1RjdjLh5mFC1Um38SQcJbC	490	688	688	1616063040000	canonical
888	3NL23fDxeAgdYPMPZUyy3C5ygfLuaeg3s936p57iqsXYQ7GTSCmQ	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1513	1379	1	1	879	jy1zT5dXhY83555jcxUid7SE8wSiY94nQYneEwxCMVemR9k4mAn	493	691	691	1616063580000	orphaned
893	3NLDVx59XjQJ7Jt5PtykjeaicVoK9Yh5hUUnivD4MaUMZmU9mcTR	892	3NKj7a7MieLkgjUEtkUoJNu1kr2Qoasnw4fT7GrNK1Yd5rZedAiD	484	1319	1	1	884	jxNi7ZDgJXUgj4iYGAG4N386oDZ3NUTiLJHwS7QLYxatSqdfgHC	496	695	695	1616064300000	canonical
897	3NKdX9tBNoFmAWKWkHjsrSipULgAGUpYsCMK9bT28UP9ohhJ9HLa	896	3NKiCdmgaobCiiNgyhi8pAVq81r6z6rxq4P9FVE2zJpA9R2ppkvB	1406	1393	1	1	888	jwSB4KnhSfcZ1UJfUqCjzMwfKQaaJiRXYCQY6bTT2Metw5pmQ76	499	700	700	1616065200000	canonical
898	3NLvPY2Xm9d7Vg95rG62tY31f3TodJfHQ4QRswgr6NCB6F5u7yTy	897	3NKdX9tBNoFmAWKWkHjsrSipULgAGUpYsCMK9bT28UP9ohhJ9HLa	1406	1393	1	1	889	jwZH2NfN2gSWoBQYFAKLkm758U12fjRYDdNjjtN2DYuodQt2P7w	500	701	701	1616065380000	canonical
900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	898	3NLvPY2Xm9d7Vg95rG62tY31f3TodJfHQ4QRswgr6NCB6F5u7yTy	1406	1393	1	1	891	jxrFn6gABcmHtLASofBwRvfmAPUyAvGbvCCHnDveVdi4FarLvQa	501	702	702	1616065560000	canonical
901	3NLSVoawFQgz5k7BPiKoMuJEL1Xvj2GxAF6HvwPARGncuHWEx1MZ	898	3NLvPY2Xm9d7Vg95rG62tY31f3TodJfHQ4QRswgr6NCB6F5u7yTy	1637	816	1	1	892	jx3F6DkfB653vjusy6nVaa65hb2NV1VVf9vt42jDYtFBre4cEin	501	702	702	1616065560000	orphaned
903	3NLWknmWvFvmKNjuAYczn9P6Vk4wrTvNE5PvdRhKm93gohyQnha9	900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	1405	861	1	1	894	jx2E9Kx4MMp4ERaHt65C61JwjNBE5xeGH6pzPFCkfFjuuUBekqs	502	704	704	1616065920000	orphaned
906	3NKqoWT8YdR3WXkSaGDDqe2sBPcPu6uN9XGc3W82Z5JxzBk95pXV	902	3NLQqHbGMZQq1BJzJrHqKDMvE2kMgVq5ifYSC5TffCKLyjJQPCcS	1610	1188	1	1	897	jxqatDkwzHp5SaMXE5bfRdyCogWTw7MwwwvsemdkvBbjbUF9qxU	503	706	706	1616066280000	canonical
907	3NLFqX5eaLoapEKHbCPi9hYgrCc3nEsrLv4fCATBhe2CP36KDuub	906	3NKqoWT8YdR3WXkSaGDDqe2sBPcPu6uN9XGc3W82Z5JxzBk95pXV	1406	1393	1	1	898	jxeThcwmYNA5PkeB2HaiUbFKHcVPstvznCrWzPYkiDgXA6L3nwj	504	707	707	1616066460000	canonical
909	3NLeSw2agsqZDtnu1DXvqGTUdz2ofF1F8gSUEABGuEsWqSz8JnKD	907	3NLFqX5eaLoapEKHbCPi9hYgrCc3nEsrLv4fCATBhe2CP36KDuub	1637	816	1	1	900	jxnbYo5UF9HgRQ9ziioGHQ5MQmf4ZrK1oYLjViWApvoKXk84v7q	505	708	708	1616066640000	orphaned
910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	908	3NL2CMP8VurBrxRuB4cvaqF194aGey9M9JM2dQ96heizMgNk6QNB	1402	852	1	1	901	jwciaMzgKLagKMHk9Jo737ekP96hBo17n46XRitNYLMfgQ5W42q	506	710	710	1616067000000	canonical
912	3NKft7qRgXvzVVt5NNWuVfCAaviK3iCP8KchWP3BBBdaxFGvBzXt	910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	1670	1036	1	1	903	jwvKjDco4pKLSkqk2NHkBrzZCayCSWGCu7PMuEmQiZg5jYJq5P7	507	712	712	1616067360000	canonical
915	3NKEkxjT4J7X4aRk1qQzVYrjMYyJ9disvD2iuNhXpzFkFtRKY2KK	914	3NLmQPpQfxzgatWGAGZ6L3musejmRkCAhyDDYbp8zrxDaxXLVLgw	1405	851	1	1	906	jxjwsxfWYNbzJ7ov8FmahVC556XXRiKs5wKGHQTpgGLwYHiZe2V	509	714	714	1616067720000	canonical
920	3NKD1BxHLCkvgjh1GuCf3uHew5QvYs2SGRePwWXuJJurDNp1bQh9	917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	1553	776	1	1	911	jxmWAYXvnrWqU2wc2fAo53pw8RqXrq4HiAnA6mYA8dx3zw4yxzX	511	719	719	1616068620000	canonical
923	3NKZBAx9CNXjwoMSZDwE6S4PArnQfhtrG4iGwBkps5hTwwgVMWMN	922	3NLy8Y2CnVrgqVgbVNQFcp4ptMHt6wVqT1Nkwe4y58gZhGdHUHUe	1500	1171	1	1	914	jx7ZvEZA25exhwzG1oZek747wvfE95dLb4hwk138N9RWACchioQ	514	722	722	1616069160000	canonical
924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	923	3NKZBAx9CNXjwoMSZDwE6S4PArnQfhtrG4iGwBkps5hTwwgVMWMN	1577	1327	1	1	915	jxJqUwJnLkquco2fmLKNKHRiM2XPbA5FAKQnV5UwaHzh3K4U8wv	515	723	723	1616069340000	canonical
926	3NKnC1EbEVrwCDia6Q2A98pSDjewANXDaCjd2a4sfiaDzvvCYHkB	924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	1657	1344	1	1	917	jxwmiUuEaSB3a7xenr8Ca4NuHEh2BTFDc7Fq3Yc7JL5LNLumwC1	516	724	724	1616069520000	orphaned
928	3NKUQTHTwGeZmGgE3uym1oeijkCyk9huLcxeUqpjvAGbzCgyaUkp	925	3NKmk7KxV9ukriqp5ibubDdwjYeMLmHxgdfb3xj5DCscUaEyr38p	1447	1345	1	1	919	jxyZcPs3uyBzfj3Sx6ixFsgfKhWLfYheeZBVS6QNNqqCdCHYn5k	517	725	725	1616069700000	canonical
932	3NKVdjxBvPj5HAUM1JuF2m62wv1hHDh1seLgM5k9txBkVPeaYDGf	930	3NKxcF8szE2wyM72VS2NS7uS6BjEjxeE7Av3n2ocUUKER2NAArGG	1523	1075	1	1	923	jxv6Ry72AUB36ayNHDtkRtRi6cEc37ifPYhtC1cennJzwW1BFeF	519	729	729	1616070420000	orphaned
935	3NLqhGP9YeoRk8J4jwEooHBBTqD7P1HH1Jnrry16NT7zBRPeZk89	933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	1407	1395	1	1	926	jwDcKyE5bkvqib5J5hUHgpkgo384D2JpJXCNYvRmviZPVdtWgu6	520	730	730	1616070600000	orphaned
938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	937	3NLoqBuXvxfXg1uDC5Cw7YXnvnnjCGfUDRtefh1uNg3T4Zego1H8	1608	1289	1	1	929	jxUVL9V3B4myExDTRwPYL2md4pHNyUU4B6YZZjaGKZ9uEbcZaCY	522	732	732	1616070960000	canonical
7581	3NKzXESXts54Yz46Cq8SrSKzqcCWtmLm9ysv2cZj9kKipBwk4dsG	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	1654	1340	87	1	6301	jxccwjorixxG367ms6bpkjca7Tq5xeizBpLJBrk3QY5gXBRgTJe	3921	5535	5535	1616935500000	orphaned
919	3NLva9AFEsndKt8gkTSaNyfE3wM35PE58ZNMAoPw3gyAp4zmtoSc	917	3NKeP3o4j7f81toULvwr8Wq1dPwJ8Hcuu8pyNWEVgqDPE1dqgSw9	1534	21	1	1	910	jwHYSsYZefTNLXZmsdJ4f9RzhAthHmepiyaRceS3EH9RLGs6Jqq	511	719	719	1616068620000	orphaned
922	3NLy8Y2CnVrgqVgbVNQFcp4ptMHt6wVqT1Nkwe4y58gZhGdHUHUe	921	3NKk3meAQka7pygkcMLLGDeudCFnmrS59LioDqcukGGQiVcZAHbp	1549	1116	1	1	913	jxS3oJFoesFDaKahtoAzqAJQ5nUA84P8bZoAqQ2EqamsNg1jhWq	513	721	721	1616068980000	canonical
925	3NKmk7KxV9ukriqp5ibubDdwjYeMLmHxgdfb3xj5DCscUaEyr38p	924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	1457	1145	1	1	916	jwDfqr4Azup3a2sH7y8BtNXXw4rcJj7KbNkhUjiui2troRio15i	516	724	724	1616069520000	canonical
927	3NKMkY4SaGmrMbYFqwJqLT9n3Tu2GzPCQ5E9sSMaDP29QKrEAgF1	924	3NKVNX83vvSNfz99k5HupipWVMtPR4ueQ3hNBozNmHwzcoXcFYrH	69	69	1	1	918	jwGH5Fg1RuUJGrV1ESCVw8ZpWuM3v5ip5wjij5DNwQhXPn1xxAb	516	724	724	1616069520000	orphaned
929	3NKzfTsZm7KA6ibBBJT2aFabFBhaXpjHHdKqn2wPLSMaucGab3gs	925	3NKmk7KxV9ukriqp5ibubDdwjYeMLmHxgdfb3xj5DCscUaEyr38p	1407	1395	1	1	920	jwUFBJCt6vXzbvoJZ6R69Sq8ibvdU88egZb4GBMPMnyZ9oFdAoF	517	725	725	1616069700000	orphaned
931	3NKpVKaUdKpDLhgBHW5UyEgVai4p8QFtCgqN51GLvHL9MKYvhtg2	928	3NKUQTHTwGeZmGgE3uym1oeijkCyk9huLcxeUqpjvAGbzCgyaUkp	1407	1395	1	1	922	jxRQXPXQJ4L1xgr9viTS7pLdvtEq8YhHTXAGJ3FLnT5ATu41g3U	518	727	727	1616070060000	orphaned
936	3NKZjiju1xQSqFodEwgPvANaTcY76FnAeLWkyMBAXBHjZo9xhyLu	933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	1566	318	1	1	927	jxLcrtETu3ScH1zEgcCym6EqqzgB6DtU6Dihz8oUhejcZcrmR3V	520	730	730	1616070600000	canonical
934	3NLBEcYy3CuWgm3AiTp3GS55LSFEpySvupKzTe3BsXMBUortHQ79	933	3NLfASnZQ4rVyAGQboLSHqFsP1YwAuKb52ZJszvV1t9gWCNoDrhp	1406	1393	1	1	925	jwkuwEUM1z9w6TCbVCuSgSHpH9CHcJe6pL5rK7CAmZx6njLxYMm	520	730	730	1616070600000	orphaned
939	3NKEipCSVKUDWV3EqTxJB496opY2GB5SWcJZtqz4TkQTF8ui8YCt	938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	1403	824	1	1	930	jwr3NwLihHGAVFuvdrFkaUwUja8kBWTJJk59dvCapg9zZq2S6HR	523	733	733	1616071140000	canonical
940	3NKXyQgmTD4icPVcyL56LgsUAeNLzJc6Dq3uCUpFHbw6zesRybqT	938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	1406	1393	1	1	931	jxMsRV3WceAkd6eR1bCmgSUVTyo7HzBvYPg8ckWDYFbznHWpzUh	523	733	733	1616071140000	orphaned
942	3NKKBsTBtCKs6PfGcgvWndBQwvDbK7kgfuv9edbci2c6cUKtGXwG	939	3NKEipCSVKUDWV3EqTxJB496opY2GB5SWcJZtqz4TkQTF8ui8YCt	1581	778	1	1	933	jxNAkBKhYi6MqbBD13coq726eye7XaBPPt8gwitThATR5EGkGZg	524	736	736	1616071680000	canonical
944	3NLsgAq9Dq18xX6P3ZFuVoP6TpAfznmoZ9MhoDjQ2ecMtw3xXHTo	942	3NKKBsTBtCKs6PfGcgvWndBQwvDbK7kgfuv9edbci2c6cUKtGXwG	1623	830	1	1	935	jwGGkxAoLgwHCTTEpvbYerGdnGhws2zdo6bnHdV27Gfj2bU4toS	525	737	737	1616071860000	canonical
943	3NKbDmL2ZdnujM1aabrFF4dDzYx6kfY8tm2pqJeeV6zS93MqWyjd	942	3NKKBsTBtCKs6PfGcgvWndBQwvDbK7kgfuv9edbci2c6cUKtGXwG	1407	1395	1	1	934	jwNveBsUurUb6Aq1x6G6M2W9UUJuLTmVX597NQCvrPeXCb2ikG6	525	737	737	1616071860000	orphaned
945	3NKS2cWFXqDNBokqEdB7VmSydEGei3hYR2mChYAr38xnCPwgtjLB	944	3NLsgAq9Dq18xX6P3ZFuVoP6TpAfznmoZ9MhoDjQ2ecMtw3xXHTo	1406	1393	1	1	936	jwNTjXzrpckkYtU387wKJXVbFmdgMX7h5uhUNu2XbD7bUq8UDsy	526	738	738	1616072040000	canonical
946	3NKzmmJqEBHBhAP4uS6kzxJpz7TtJEYhc24wJ5CNLacTPphJnaJt	945	3NKS2cWFXqDNBokqEdB7VmSydEGei3hYR2mChYAr38xnCPwgtjLB	1406	1393	1	1	937	jx7v1JSi9xfAz8wLsdxZUaCbNRDJS3tYGs2T31f12d6km1R5koa	527	740	740	1616072400000	canonical
947	3NKREjfwpjSmdro47F21noeUya8EE9hG95CrpFBH7Dt58tHimdTZ	946	3NKzmmJqEBHBhAP4uS6kzxJpz7TtJEYhc24wJ5CNLacTPphJnaJt	1671	1365	1	1	938	jwEzjnUGFb4qcm3jwVN2jRnEPadq14ZcPLj3L7ibqN364hRz6Kg	528	742	742	1616072760000	canonical
948	3NLTbW3twbr3W8hraUWzvMu3mhwwEVi5i6o48rSGVpTrtVzxt5UY	946	3NKzmmJqEBHBhAP4uS6kzxJpz7TtJEYhc24wJ5CNLacTPphJnaJt	1407	1395	1	1	939	jxCGXeuQtmGCWdqBHnx5xDSs5UsnbbQsDUDSBdYAjKsqvM6KnP6	528	742	742	1616072760000	orphaned
949	3NKkrqWniP1oLX3H1nKY76jjXK7HotMKo6TsbqEjBbMFX4deXSQZ	947	3NKREjfwpjSmdro47F21noeUya8EE9hG95CrpFBH7Dt58tHimdTZ	1656	977	1	1	940	jwYz91C3uSWQUuAu9RmR4MPzvMJKujCwW6rv12TRv4onZcd86Eg	529	743	743	1616072940000	canonical
951	3NLeWQrqkYG2794g2b4vECBeyS1KdrCkECDtcEzye74NNTMqnULT	949	3NKkrqWniP1oLX3H1nKY76jjXK7HotMKo6TsbqEjBbMFX4deXSQZ	58	915	1	1	942	jxbEVfKaGLecNSzx2FBYMT9D1f2cyokQijtnoJsqvp9pdwyFyB1	530	745	745	1616073300000	canonical
950	3NLvc8Wqv29yz1ykmDGg5hVyXH1NFNzH3dGa8nydGjk5A7QG7kqh	949	3NKkrqWniP1oLX3H1nKY76jjXK7HotMKo6TsbqEjBbMFX4deXSQZ	633	1384	1	1	941	jxr5NzmSN595sKKsojZQqNf4wpSas8FyvfSRjxG21UW45PGDxnN	530	745	745	1616073300000	orphaned
952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	951	3NLeWQrqkYG2794g2b4vECBeyS1KdrCkECDtcEzye74NNTMqnULT	1444	1381	1	1	943	jx6Et3DevvZaZPirWURD48xehxB6J6iWS8FwWXYvczdrCJ3g1y6	531	747	747	1616073660000	canonical
953	3NLjfpxTVo49r5R2gFv13FfSyt1Go7Sr4qn9yDg46KcCF61dRiMF	952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	1619	1029	1	1	944	jxQH6rQyjtmSBLhuBNdwAjbNGhH8xgtoDp1FCiVcXHAB5vqvW15	532	748	748	1616073840000	canonical
954	3NLs7XBvRHHJTZTYyin2oEarSVzNW6tV38Q8EDSHxD9K9gry1nWj	952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	684	986	1	1	945	jw9VGaCx2tBr3vaeH4ArbretTxBxr6GwoFwwUb72TRazLoeST8C	532	748	748	1616073840000	orphaned
955	3NK3u1YSK72RVDoLLaAGW6Yrk9WPka4XYMEnydJvSS32V4ZcEGLs	952	3NKAB3tm2ZbNcwTiBoXCHG6ZPVEUaeNPzYWE5aFTQLmW3rPdnAm8	1581	778	1	1	946	jwAwU7KixZgRfeesxDxPHaBfBmiUZTPhEbzCeKqkgzCdQHeQfA3	532	748	748	1616073840000	orphaned
956	3NLN8YKzipB7Ce9YoR9T6jSKYAtD8fXTjaJZwntTdeMAwDydnarV	953	3NLjfpxTVo49r5R2gFv13FfSyt1Go7Sr4qn9yDg46KcCF61dRiMF	1509	1074	1	1	947	jx8jKgsDuky1Tt6HMdp4ewsnvHpQEjXuFdXCx14dxxNewAdeCf7	533	751	751	1616074380000	canonical
957	3NK4Xu363xhG9Cxtuf8t1dYvxi9soTLGYzVuEzqxWh8fk3gHJ11h	956	3NLN8YKzipB7Ce9YoR9T6jSKYAtD8fXTjaJZwntTdeMAwDydnarV	633	1258	1	1	948	jxtB3ZMoXECFyS9ayzq2DFT4g8Qs47CJ7DUZD54sZMs4WBCbjHj	534	752	752	1616074560000	canonical
958	3NKxcaNTgig2UtRq7NF5tSaTjYYtmgixPJC91TSVjkMW4bChqoba	956	3NLN8YKzipB7Ce9YoR9T6jSKYAtD8fXTjaJZwntTdeMAwDydnarV	1599	921	1	1	949	jw8JuV9xStcqodt31dnwUxKUAtaodahRKUUTYbXEsNvToj9kHkN	534	752	752	1616074560000	orphaned
959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	957	3NK4Xu363xhG9Cxtuf8t1dYvxi9soTLGYzVuEzqxWh8fk3gHJ11h	1403	824	1	1	950	jxwqXKnLCB9pEQKz5v1Cog5jhMs93eupqYxSz2x3J2ZzKN78yiW	535	758	758	1616075640000	canonical
960	3NK4mgMYyEKtdSMvSqPgrZkW6H63ufXSSEcPSbBX78zPdeZf6pob	957	3NK4Xu363xhG9Cxtuf8t1dYvxi9soTLGYzVuEzqxWh8fk3gHJ11h	1407	1395	1	1	951	jxCPFXA8TzutaPQVYQd5wMtXj7aKz7LZKMsiRrLyh5sErBLTq19	535	758	758	1616075640000	orphaned
7607	3NKk7M76ViMQGsGMSXTzMyK9PLqRkDeQm8BZBvLxkb7yJpyuJ3fh	7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	1426	998	87	1	6301	jwZoEABmDDhGakTBaS2ybQbQ8eNfV7P3dC3rmGzFLvxWrXGCV1f	3937	5560	5560	1616940000000	orphaned
962	3NLTeSwRjA9FuWnwDXQT4NxnkBWKZPs8G9tBNStvr4SZhbzTPk8j	959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	1407	1395	1	1	953	jxTjy8BsHsnNPStom68gEMtMCwaiACTafbGn4BAkHEgDHFvczMC	536	760	760	1616076000000	orphaned
964	3NKodosK1tAsJiny2z5M4QNygtunaGhR4iBHqjxttqgKER5Qx88c	961	3NL5La3n6voFLsZyEefubBrKbdVoUnGAiCdWxo1Ug8dwDyAGBeK8	1407	1395	1	1	955	jwAAu9FL4aDmafcmFENRpQxMF4m4Z1CAskB2UPm2BtJAiDiT5kt	537	762	762	1616076360000	canonical
965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	964	3NKodosK1tAsJiny2z5M4QNygtunaGhR4iBHqjxttqgKER5Qx88c	1564	1338	1	1	956	jxfcxHyZHwMu2phdGLXnMbySH8bWgPRihwFXMkei4fmgW3mRHrV	538	763	763	1616076540000	canonical
966	3NLTdfPvDe5F83q22YmgSKJvV6FUvE4Pi5bhDqT4xDCYW6vhVnEC	964	3NKodosK1tAsJiny2z5M4QNygtunaGhR4iBHqjxttqgKER5Qx88c	1593	1346	1	1	957	jwBxo6T41VNmjqT8CKfqhJSQQo9iYYBVM7tnkzA5BqE3CwLERSA	538	763	763	1616076540000	orphaned
967	3NKZHK9Ruv4w8rPvXgH5bkPVZZpeBBB8wTwxtNgHDYoo85g1VJ4x	965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	1403	824	1	1	958	jxRk4jndxx9LAfEsCGBbjURKScZ4moep2acHKr9FU94VJ3wPKTg	539	764	764	1616076720000	canonical
968	3NLmWdwtjrmtSeTZin6jhgFGeXCLuuC2mez1bFuEkaFuBrEkiKct	965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	1555	1347	1	1	959	jwLkjLTjGckMPhMqvUQXEpNuZqAFQSaxcvz6fPT8UAw77zc55qc	539	764	764	1616076720000	orphaned
969	3NLtx9DzEVFf9RojUwvsbS3gNt14MoknQeRAdFuBFG36ZAmw9ihi	965	3NLMoyBXQ41gqYqrvXoLGuhwVVwnEkoPEZCweqZ212R8yixqXY3M	1581	778	1	1	960	jwDaatWSnVAPHGhies3gYLqPxLG2wk7jRt4itcTtfD1Cy8QSvBa	539	764	764	1616076720000	orphaned
970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	967	3NKZHK9Ruv4w8rPvXgH5bkPVZZpeBBB8wTwxtNgHDYoo85g1VJ4x	1640	174	1	1	961	jxLYsFgtS11ixkt1zvtVzcKeUf9u7PkhJe1pTrLaixDrmYW4HyN	540	765	765	1616076900000	canonical
971	3NKsGqmSteCBVR5DRVFcjLw9AAd348AJKEC1BvQatcKY1jDpojBW	967	3NKZHK9Ruv4w8rPvXgH5bkPVZZpeBBB8wTwxtNgHDYoo85g1VJ4x	1406	1393	1	1	962	jwZ93ULRN637vzt6XHTiiU6bWXum5wdULNBdzK8VrTUAttbWjYC	540	765	765	1616076900000	orphaned
973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	1406	1393	1	1	964	jxzKCdf1Bw35e6ha1sXHhsBNNrNyctLbScDxsZxegh4aGsd3su1	541	766	766	1616077080000	canonical
972	3NLqLpabmMJ6yFF99yxvSvgC3Yc5zAt9L2APmzbtBakTV3iQ6EZ3	970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	1500	1171	1	1	963	jxy2yRk1y1RZ5aN4i4iJfKRqDzMSZJsDeX9boEQ5nT8rggPMSRg	541	766	766	1616077080000	orphaned
976	3NLBmqNM8j9o72113b8qr7xLuu1e8xDQMPXZPg7rp8JjPu1SA3XX	973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	1534	222	1	1	967	jwuypbyVXF8cHsMyJyM1JaxW4T8gcvFe4PtBJDDsnX9MF2NtE5Z	542	767	767	1616077260000	canonical
975	3NKCFSNvSXCRjCKB33St5rVUP3g5Dkpkq4KytWQReXScnQMm1Br3	973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	1600	1372	1	1	966	jxywKQhN6zGgcYGymKgEFEE4dvqpJ4BHdqRMcmp7MURTFATFRWE	542	767	767	1616077260000	orphaned
977	3NLdQ2TGRjT6FhVJ8me5B3UeuM9Jj6FF2GtvWzr4uRyU75Maw769	973	3NKsLeBmAxEJ84hcceVHwiR6psBy2xXieABVgT7sP1FsSdApmMCB	1637	816	1	1	968	jxLtFqkRtFMQordhmHYpjGH9vezznupUZaVRgBN9sXujbbAEQk1	542	767	767	1616077260000	orphaned
978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	976	3NLBmqNM8j9o72113b8qr7xLuu1e8xDQMPXZPg7rp8JjPu1SA3XX	1403	824	1	1	969	jwcx8NSJ5AY1iBPMjCi3tN9dRDGDHtFuBXTpmrrFzn4VLWzwd6L	543	768	768	1616077440000	canonical
979	3NLZkSru6jt19z52q6HeBSjLa6kZbmfMnuyUcGXfpHf1d1zx4U9S	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	596	1180	1	1	970	jx3DQsYZRoj2Wb1ev22bTpcGjWfgBCdJq1vpsNWhss2DzRhwThV	544	769	769	1616077620000	canonical
981	3NKQtE6rcoxFAebLmMt66LGnT3N95FXRpNmWqc8abjGMXtVuvQbV	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	1407	1395	1	1	972	jwCbxbWhss9erFK56FWPi8Rc7K1vLAMjY7y1tDw6V2BrRBcLKHz	544	769	769	1616077620000	orphaned
982	3NKasQn3T2R3Zoah9imvqDSbQSJg8sG9ZQ7gbgphCHKTk9bX86s2	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	641	1090	1	1	973	jxTc3GRVZ47Wvt68VTLD85YYbhmt6MgQUvQcRcM6KwmCNYsi4zu	544	769	769	1616077620000	orphaned
985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	298	1062	1	1	976	jwJnwQRCZd1r8SLNtAqX9dtr5T1nQEhzJdNUGhdSjZibfabzSPn	546	771	771	1616077980000	canonical
990	3NLPtLQKxsogTWBFC3WoXdeciU5GszxsMVXQGqZWrZFBjf8FWsfX	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	1406	1393	1	1	981	jxoxKCYuzc7n7GrtK2L8zrmyZMcaWZsMbk3EYKuhwuxHEsPKorb	547	772	772	1616078160000	orphaned
991	3NL24PAon1rTbko9ujSVJkPM1avTPwEC3yQjLBt1MqF3g3HMnzdE	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	684	1352	1	1	982	jwxYVTGDaVuCn2S2vca3eAQQjoBBkm2cUXKkoM3HvynkxNT4L9v	547	772	772	1616078160000	orphaned
994	3NKGwQmrSzft9hJR6KjVWdqc9d1TLqhEAoJ9FK7Xw5mNSNaocCft	992	3NKPKdZz44JbV5SxKRN86zNRGkT7qe2zKw2AfSry7FdSB1rwKu26	43	1184	1	1	985	jxtNQKkjooZtwhbUuzXPPgq5ATicNZBdAEtRyVGEeiBwANhQqKh	548	773	773	1616078340000	canonical
997	3NLkkmjPUrxVgahoiHr2h7WJFHE6WmmmSbwqMtjkuV7fS987fm4G	995	3NKm7aQemBruz2dxymXjy4Z8TMMBxob7T6y2Cnn65nJ8jfdZA7Jy	1403	823	1	1	988	jxcUUrs7NnxWVuBAFMrhcz2epDuoJ2Esgwq3wPyrkRJv7HACrJH	550	775	775	1616078700000	canonical
1001	3NKkvv1tRzTToKwGA1E1QrTrZwpcPxd8jMFPH75mgmt8tQLWfkaE	999	3NKQBgrwa3jEc8Ge8YNXyeaZTZRGFQ8TTMmCBf4rao5UgLR2ftZ4	1646	1354	1	1	992	jxpa3nHUxf5MjQWY5DWM8evn2UvTcke4txGqGVgT6nMFHFUTZNy	553	778	778	1616079240000	canonical
1002	3NL9PJTmL2eXzRaFZkjAUYXaoVBnymCYVx5ex94FGSC1RwLUZPJ3	1001	3NKkvv1tRzTToKwGA1E1QrTrZwpcPxd8jMFPH75mgmt8tQLWfkaE	1529	1316	1	1	993	jxbBFiDbVMgVDfxd2ne1xXwskZzU38azAFevYnFkLLYHRz1DHcZ	554	779	779	1616079420000	canonical
1006	3NKUCsXwKzxN14jm2QCnToYVTL5BjtP5xBsueKeGRLub7HD2MJYU	1004	3NKTZPWZeDQdSqUf1SVgsioY8CmFNd2GSyF5Qpex6bQLuigqkH7e	1457	1145	1	1	997	jxVWEZxVLGBn83iQZ18BqLKXGnUAZqQbrmzsVQxk41FsjWBgxnh	556	781	781	1616079780000	orphaned
1007	3NLjy1R3J7uxriRDkLfDfeeN8X43eQb5yyFvBqwEiDw8jZrXQrZ1	1005	3NL44VHTpU6UfeYNgMsmrXrzUEbcqdkSPTDQ3LBCD3T6XyedjUZu	1397	838	1	1	998	jwVe6XKm9pgh9HGNd6m3UJpxMjspx1Dn3m4N4prCXVUDSUmwPnt	557	782	782	1616079960000	canonical
1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	1007	3NLjy1R3J7uxriRDkLfDfeeN8X43eQb5yyFvBqwEiDw8jZrXQrZ1	1671	1239	1	1	999	jwKLSikcQ9g4JLRpK3uxnZgPGUETK4yRG1Vj17VsLTbdDnBsoMT	558	787	787	1616080860000	canonical
1014	3NLwbqf9TTiSkiHXHLZLF4sRjjQ24oMy1uf839rVkpVM2hhHYxvs	1013	3NKamCWDRi38NEmGumJ3bYZj6ghwiP1aZWZuwNq6eVX9euwZTcDs	1448	1065	1	1	1004	jx6wM1sFYMkTYPTGjxwkzr6b76EK4V2dbzQeqMLrUfWCr2881HU	561	790	790	1616081400000	canonical
7618	3NKE8qLm2jzf31DCrCzsqshBZTuf8vFhW9tKzTLRFoSfuES1RyTp	7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	1489	1134	87	1	6301	jxrV41B7qZHXRYTeUuFwSeNnDFf5PvD4TfxAzaM87z4giPup8Yh	3941	5566	5566	1616941080000	canonical
984	3NKtpPSDZnAzRTFbVorMv7AuHLJw6eqCEjr1wfbNvEVNBor3EvEm	979	3NLZkSru6jt19z52q6HeBSjLa6kZbmfMnuyUcGXfpHf1d1zx4U9S	1675	1342	1	1	975	jwUCCw7TuiFAxSkKAcKFJ2WEnUe4GZ7wWXZ8DrRvWUa2bSi9pcE	545	770	770	1616077800000	orphaned
986	3NKQMn2FU8Js2ivkKTs1AV84vXMZLATqKqTJ4Zr5fVnasKwkPMME	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	1406	1393	1	1	977	jxMaycWrbWShF1kWM2W3SAVP1X7hVfB6LxS3BWR8WHMog6dhSZu	546	771	771	1616077980000	orphaned
993	3NL5DAxAgFLQ8v95SCEJuWc5wgfT7hoTZ6mGXHpQP13YJo4w5a6p	992	3NKPKdZz44JbV5SxKRN86zNRGkT7qe2zKw2AfSry7FdSB1rwKu26	1403	786	1	1	984	jxjuJpCtV6QEqU1rDBetiLJzt7CTCUbPbboStkjmzGFJFLoKNTf	548	773	773	1616078340000	orphaned
996	3NLNKErrvcwooGb4s731agdjQqSpdmJTjVM5t8x92WW7afHmTTjt	994	3NKGwQmrSzft9hJR6KjVWdqc9d1TLqhEAoJ9FK7Xw5mNSNaocCft	1627	1259	1	1	987	jwaFLuvxMdDoKeUi6y1n5FR8nVc9vwPaVMdCrQ6zPSsbVgx2MaE	549	774	774	1616078520000	orphaned
1000	3NLHj5S6s6WHeQ3KA78QLwxdqMgz6W6W4s2jQbvbJq5aJtir2EjJ	999	3NKQBgrwa3jEc8Ge8YNXyeaZTZRGFQ8TTMmCBf4rao5UgLR2ftZ4	1405	861	1	1	991	jwHh1MUGyS4vr8MHuE3rnZ54C3RhvfzXeEM46bJEcWpdW6JeTyd	553	778	778	1616079240000	orphaned
1003	3NKrHznMZGYoGpM6EwvmJdBBw5XmGs5tgVQgcKRQRWPC6P1jRtJR	1002	3NL9PJTmL2eXzRaFZkjAUYXaoVBnymCYVx5ex94FGSC1RwLUZPJ3	1407	1395	1	1	994	jxpWThAH8DLWJvWUA5hwGp2wnufKKViXj3bNTzKad2xWQcQUW7Z	555	780	780	1616079600000	orphaned
1011	3NLic5kz1tymMKLQnoWuijmWz6CSkpYdhmpe9cZRu1YGqnrqVYDV	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	532	1057	1	1	1002	jy2rruXRjD8xQoRGVZW5YhAh2KmXz5w5UjqwSXujVQSUX1TgsP9	559	788	788	1616081040000	canonical
1009	3NLsokqag4JvevowPd1A2enCYaVJtjCLpsgfTpyD1tW9QmEB1shT	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	1602	1369	1	1	1000	jx4sPcKWLu1eyrhs5GRbJfV32KHErYkKtuBASVA4nznredNFLkZ	559	788	788	1616081040000	orphaned
1017	3NLus1rdUwbzwMnBn7rJSKMvwSszZag37bY21dYx7nshoNAKvJDo	1016	3NKLtNoN4GPkPX7j7vz9avFvGAyiaXc8tLYWRuxwZSxqsb9rAfdT	1403	824	1	1	1007	jwiqL9qwR2pFzYvsk3d2BDiuf92VsNmG5rd2qCpsr6ZBTLWbXEj	563	792	792	1616081760000	canonical
1018	3NKU1uCr5eo4zKKUtaTwXN7txaVN4GNRzBt1odfRWE5z2xigoM2C	1016	3NKLtNoN4GPkPX7j7vz9avFvGAyiaXc8tLYWRuxwZSxqsb9rAfdT	576	989	1	1	1008	jxPWitGfzoJ1x1RJoeXbZxn4XzWhrNFu7vrNyq8u9LZcbL4ps9j	563	792	792	1616081760000	orphaned
1020	3NKue26TDEcZHe8J321ZmCwT51s5WSc5ABDBkNQYSzfi9gq4jo7R	1019	3NLroFgcZpvjTihHynU6gMbzpWHR6Pa3fJ2i8smuHqXzpxf7pUPp	171	1248	1	1	1010	jwpkt9bYELbzrNEiB1CupFFU32ngchaoFTB44VB3rQhut3bTjL6	565	794	794	1616082120000	canonical
1021	3NKpZPFFqSErtVx6uhU8TCzxMWrj5qT62HSL3TPd6d5dX5KRdWHH	1020	3NKue26TDEcZHe8J321ZmCwT51s5WSc5ABDBkNQYSzfi9gq4jo7R	1593	1346	1	1	1011	jwfGugBShQBKXvNWNbPYRuM8GbNidNgC9bAbbhVu8ZZehc1FUFj	566	795	795	1616082300000	canonical
1024	3NKe4ZyhVHFypRegDzJw2jJ6fYZYmcFNpfhtoBpH3CYd5aYJgeYt	1021	3NKpZPFFqSErtVx6uhU8TCzxMWrj5qT62HSL3TPd6d5dX5KRdWHH	1637	816	1	1	1014	jwZiom7ysQJEAcv6goZZA1LpQsPvezNtQncXbehoK6UhkpreFBv	567	796	796	1616082480000	canonical
1023	3NLAN7GdeEugi7Q2vqEwdngxcJ4RAtbSEJCqGrQtecuyLoC9gb8i	1021	3NKpZPFFqSErtVx6uhU8TCzxMWrj5qT62HSL3TPd6d5dX5KRdWHH	1546	1339	1	1	1013	jwcKJxv9UqT5HfBLEw3VEVQzThCtocFMaav8YYZ1UbEAsTZ3YhV	567	796	796	1616082480000	orphaned
1026	3NLgQXpiXQtVQS8Vt7z73LbKo8UJRT8i5Br53sNF5FWaNnsqXpGC	1024	3NKe4ZyhVHFypRegDzJw2jJ6fYZYmcFNpfhtoBpH3CYd5aYJgeYt	1623	830	1	1	1016	jwjrDZJ2sZHZQERBY2usRqYK5X2gzbsKxm7c5HDYXkd5vFBAJHs	568	798	798	1616082840000	orphaned
1027	3NL363PWEX9eLVGVkrDuTLUMJ8ctw8Y8vkwS21AGbYLJpsHZ6drp	1025	3NKTTkJuvskanfRRqWzqCkBcwMxEFQ6e67nvwBrePvvzWkfrgoHL	152	964	1	1	1017	jxVQcrfQfDuNxnTYyDMgJGVAV5Z9g9tG9yzbKJ7nunmUPCBhhE8	569	799	799	1616083020000	orphaned
1029	3NKcXkkTTS7UQh3iNA4iAjzDF7SrLawPJR9NvYmpnRSCDGfcyFnj	1028	3NLJEJMyNsppz1uctCpB2sR4RL8cW1y7Ueq9UtFPZtY2nsZm2381	1571	1335	1	1	1019	jx5gc21yZ67cspmGqmXYTfDXHfTA7NGtz2rYoLFZi39hUKVXiN4	570	800	800	1616083200000	canonical
1030	3NKdcQP7U824HYkVTd3f9nTwFfhyuRypHhJUsuxXfyehCUwdCuYA	1029	3NKcXkkTTS7UQh3iNA4iAjzDF7SrLawPJR9NvYmpnRSCDGfcyFnj	1579	1389	1	1	1020	jwA279RjQe8KgDrYGSNQwh3qP2c8vMDzxJ9VSo3weqTM63ZSzdy	571	801	801	1616083380000	canonical
1035	3NK64f4cKgdaQM5o6E1HgTgb9Ph1jEi7JUG6LrRHzYeuzMuCpJLV	1034	3NLksm5Qyghdamva9xnTXMxLRYCyf36s1HtCv1m7bmCXusmpQBKm	1406	1393	1	1	1025	jxo9RyCCTcpm9FFhoJyaJWtVzRBwckcvPNqsBfRSWnJvLaKM5rU	575	805	805	1616084100000	canonical
1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1038	3NKs57YfHb5u25rCvYT1qhqyFaH4dgEnN1i1uMyXD7FtAt6d8K1T	1519	863	1	1	1030	jwhkgAZCbFBv8ia3UMuejuskMQyrzHgs4dFEavX183p2AYJ7Kzo	578	808	808	1616084640000	canonical
1043	3NLWtVTdKtzqPNZj2VrKYQW372bJdGBw3jApP6T7yp1PNkY88eTn	1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1647	1056	1	1	1033	jwKdBe5J3pVgAHcSzb2omnR4gLiAQ4wGNtPGxFSkSpi2XSVpdXQ	579	809	809	1616084820000	orphaned
1046	3NLTv2BVHcB69e8XqyYZEBvNjoPXdjZMWT9t8KCRSZdHnQCsByXF	1045	3NKysjSA5quBZ9aMupbyLq3WvkW9jXaRJheDg5n9tfPdStaW4nk1	1457	1391	1	1	1036	jw6oxme6VtderUuRgUZiUBCjoGHAwoiauGoxQhU6LSzJpEhPpgY	581	811	811	1616085180000	orphaned
1049	3NKrvcLgkrCc4sDb7pzdQjkzwrsRvm9iu9iiHBLGQ5mFkYHyaTGP	1047	3NL21URm3pdCjTpxbNC9F4qCxF9FfBCVtfzN2yA4qRrN7e4QaDuv	1402	874	1	1	1039	jxdnZvcGUTQjSxNGvk3vTaBcGLHHeJnKqpRL8gfNJHhFTMQ15KW	582	815	815	1616085900000	canonical
1052	3NLXkdrZbjcvBaZegX4RgYvrzTEJNQtSGwg3UvoVPYFXG9FMybwK	1050	3NKQkwAitnSHvvKU2cHLqmRAzaueQMQsXKKxiurQoR7759s555Xu	1581	778	1	1	1042	jwaqjt5jzRun5N8VV79fre1CnfTMPQajNE9W1kWmJUuQ5vuUP2n	584	817	817	1616086260000	orphaned
1055	3NKAc6PiN5s4s9khixwmXGgnZgqaEwYpFA43PL5KmpnWmXxjeKtS	1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1579	291	1	1	1045	jwpouf5Put3DB5GFs8abpDmBsxcU4bC3YsBBoRL8Yey26RJpPnY	585	819	819	1616086620000	orphaned
1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	1064	3NL61j9pdbJXtm4ZrVdxbJWdKhcjQkuVvDy86cuhSzY1jQ4mz3DY	448	448	1	1	1055	jwRe6ZMCrgjzithifAf6LQ6YHGQWWxPKuX9JfrtxhT8BsyVyCGC	590	825	825	1616087700000	canonical
1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1067	3NKDkTYRpZTYhTQjigXosbtk8RKNUyp3fR7yKfNAqxmqMifjFTuk	1405	851	1	1	1058	jwQLUqJcWbzg4YsYs3p7Hf2jdswodfxM1cyb9rk3GxU8hCCVTMB	592	827	827	1616088060000	canonical
1071	3NLRDXRpYVzw8GxmigCESVeL6tViCWQHUQn3uFQycTx3gW65eSs4	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1490	1274	1	1	1061	jwhQPGq8tAX9fAzfT75qKQsaYV6QF1s5sQeBGLmU82Ti2G3mptD	593	828	828	1616088240000	orphaned
1074	3NKMnz1vVFN6tvULMu3FjmuHq3BYZWG5fawjNRrXVAc7D7pXYxUT	1069	3NKs8G48E5e29brbV9MfcJztTrfCWW39w3PudUUAWV98vdmAUhQm	1631	794	1	1	1064	jwVfhjD1WsNXfnNgE6z2mN2uEfcNtggMVzAvudEUex268oKkMdw	594	830	830	1616088600000	orphaned
7619	3NLEPc2PjEFNpUF7jfqVvuwDequvaZpRrLd9YyB8EHkDx9xRWSc3	7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	1488	458	87	1	6301	jwYhYa7Yj12aBPWNY5jfvAQursuMbHfUxZk2qF3nGuiA51JrFay	3941	5566	5566	1616941080000	orphaned
987	3NLxVwpu18LziTW2x8HnUvnutSaiaCRUz9ZE8BJrjLRNwqQFU5pQ	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	1527	1167	1	1	978	jwmXSRZhXQhMhVdjGMALB2hZCCntadTwVKoZQDbnhDo74M4dwfe	546	771	771	1616077980000	orphaned
992	3NKPKdZz44JbV5SxKRN86zNRGkT7qe2zKw2AfSry7FdSB1rwKu26	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	1401	231	1	1	983	jx17HeVRf6PWkzuSdAhBhszUdgHaxWYq5FwuQQPQh8ozTntQkvi	547	772	772	1616078160000	canonical
989	3NLvWbCwMjSUzfGDWY4XW6kCvSPi5YUQcdmN6v3g7dTFxnEYEivw	985	3NKdQzaB8EjY3Hzppg7ficzruxejoB5jCMfPYthsmPsugqx6A968	1439	1279	1	1	980	jwgaUsADefSCDtmWLLGuWnvFMRDXdVbakufe588WaU6xATqwiNW	547	772	772	1616078160000	orphaned
995	3NKm7aQemBruz2dxymXjy4Z8TMMBxob7T6y2Cnn65nJ8jfdZA7Jy	994	3NKGwQmrSzft9hJR6KjVWdqc9d1TLqhEAoJ9FK7Xw5mNSNaocCft	1403	824	1	1	986	jwCAsRAMwuL4MjDJQkGdYCRVtNd3BbM6b64Aa2f1smpGjjRW9L9	549	774	774	1616078520000	canonical
998	3NLBqUWTWLSysNcehaYrF6VVJ7QAxu1EuB7w75Xg1aFw6VV9Nmos	997	3NLkkmjPUrxVgahoiHr2h7WJFHE6WmmmSbwqMtjkuV7fS987fm4G	1656	1097	1	1	989	jwb4QJMXbgTHfSFxa4CjA87teD7rgrv2pMuNvzvEcfmiAj6ivzX	551	776	776	1616078880000	canonical
999	3NKQBgrwa3jEc8Ge8YNXyeaZTZRGFQ8TTMmCBf4rao5UgLR2ftZ4	998	3NLBqUWTWLSysNcehaYrF6VVJ7QAxu1EuB7w75Xg1aFw6VV9Nmos	1534	951	1	1	990	jwLEXbvLUmabvMgvnkcAzmst7fXSvUR2Q1LGGwfSNExLgdgfFzv	552	777	777	1616079060000	canonical
1004	3NKTZPWZeDQdSqUf1SVgsioY8CmFNd2GSyF5Qpex6bQLuigqkH7e	1002	3NL9PJTmL2eXzRaFZkjAUYXaoVBnymCYVx5ex94FGSC1RwLUZPJ3	1675	1216	1	1	995	jwcYU2igSiKSUtvdGpa8s5yzBR1mSBN39Yfd4ENrbVpTaaAoZNv	555	780	780	1616079600000	canonical
1005	3NL44VHTpU6UfeYNgMsmrXrzUEbcqdkSPTDQ3LBCD3T6XyedjUZu	1004	3NKTZPWZeDQdSqUf1SVgsioY8CmFNd2GSyF5Qpex6bQLuigqkH7e	1406	1393	1	1	996	jwtEv9eniWYfndqbMLLNA2D1Pu31kZ4tMLGV4AJJYAJLLAzaoui	556	781	781	1616079780000	canonical
1013	3NKamCWDRi38NEmGumJ3bYZj6ghwiP1aZWZuwNq6eVX9euwZTcDs	1011	3NLic5kz1tymMKLQnoWuijmWz6CSkpYdhmpe9cZRu1YGqnrqVYDV	1609	1087	1	1	1003	jwWjFKR25YFHgw7BXyEU67ARQWNQQ3Nb4eoFX8pax9hLq1Gbgps	560	789	789	1616081220000	canonical
1015	3NKfAncZr3BxoQVmJBBhBq2s8YhTKW19hfwfzGP5YunYv8bU6d2W	1013	3NKamCWDRi38NEmGumJ3bYZj6ghwiP1aZWZuwNq6eVX9euwZTcDs	1646	1108	1	1	1005	jwVxBj2B1UPYcehR3ZVwA68mMWgF5t3nfZbLdL3ykzjrCQKdArc	561	790	790	1616081400000	orphaned
1016	3NKLtNoN4GPkPX7j7vz9avFvGAyiaXc8tLYWRuxwZSxqsb9rAfdT	1014	3NLwbqf9TTiSkiHXHLZLF4sRjjQ24oMy1uf839rVkpVM2hhHYxvs	1444	1255	1	1	1006	jwkMgfbFkiFFfa1VezqVBfvGrgXuxEruqaoGZ2wRKKGiRCpmjY2	562	791	791	1616081580000	canonical
1019	3NLroFgcZpvjTihHynU6gMbzpWHR6Pa3fJ2i8smuHqXzpxf7pUPp	1017	3NLus1rdUwbzwMnBn7rJSKMvwSszZag37bY21dYx7nshoNAKvJDo	1407	1395	1	1	1009	jwxycgihLWvUopC5Fvsu96ivNRfLB28Y2n8iRb3QaJMGfj6Peh8	564	793	793	1616081940000	canonical
1022	3NL5EtQEwSHfGwJvMhdfVgq9BneafjFK7J8hmqLK9hoBzATvK7Ww	1020	3NKue26TDEcZHe8J321ZmCwT51s5WSc5ABDBkNQYSzfi9gq4jo7R	1509	1320	1	1	1012	jwbsgbs8kmnKDmth13rTQj2bGAyBe4PkWXv8coZopVB5t3rzWiL	566	795	795	1616082300000	orphaned
1031	3NLoDPZPM3CwM9gJUrf7fMJZ5nv4Ys1t6MQ4UouNGnY3NNW9iw5x	1029	3NKcXkkTTS7UQh3iNA4iAjzDF7SrLawPJR9NvYmpnRSCDGfcyFnj	1609	967	1	1	1021	jwoefseczoPRAbfPUe6Vzn84nfE1jZtJcWYrSRmhMBb9rNuEKaJ	571	801	801	1616083380000	orphaned
1032	3NLgRiup1Cn6k95YPafnGzBt2fmdYRDduFV3Cs1HQiyXu7uhakdy	1030	3NKdcQP7U824HYkVTd3f9nTwFfhyuRypHhJUsuxXfyehCUwdCuYA	1516	479	1	1	1022	jx7pBb5YZV8LAJSCyRciL61ie2uSXCPZkQ2HF256YkxiSpN8xrg	572	802	802	1616083560000	canonical
1059	3NKxYRUZXbcuGm4xBiT5VL1LDD9DHsoGtcnfn4Drnj1schtzDegH	1030	3NKdcQP7U824HYkVTd3f9nTwFfhyuRypHhJUsuxXfyehCUwdCuYA	1523	1321	1	1	1049	jxQEc6chLsx9Y6k6d738uAtBETFytuHUfn1Y5vq3huzyVmkvtKr	572	820	820	1616086800000	orphaned
1033	3NKjbrAio8WUy8zGfGGgw9ssMoidGjCgDGHNPGvASb48Y6yEfJzS	1032	3NLgRiup1Cn6k95YPafnGzBt2fmdYRDduFV3Cs1HQiyXu7uhakdy	1585	1366	1	1	1023	jwjGdWaYAtTAptu8HSSvBwKFHUjP9Dd2hBZNSWYA2Rtwr39TjEY	573	803	803	1616083740000	canonical
1036	3NKBBGrh9thykFLRo3qSg1CyCQGtt6bX7HoiWzqCBXKXFGyDQGLD	1035	3NK64f4cKgdaQM5o6E1HgTgb9Ph1jEi7JUG6LrRHzYeuzMuCpJLV	1599	1287	1	1	1026	jx5ju6KBj6wDaDksVBcVaxpFbp1qHra156CCmEo7qWjapvNFdZn	576	806	806	1616084280000	orphaned
1039	3NKjHQAmVKRorZbGoN54iwiiVNkB9rRcb4vQfH3vPbNdEoXUxuL4	1038	3NKs57YfHb5u25rCvYT1qhqyFaH4dgEnN1i1uMyXD7FtAt6d8K1T	1405	887	1	1	1029	jxXEJhJi1wC7pk2VYodyJMdVXrwx8zekyfa6gzXBygSFoPCg3L3	578	808	808	1616084640000	orphaned
1042	3NKEJTMwm86VVqTNWPVYdRq4KkXYqB7mnCMpSECUZDc3dAVymLYR	1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1402	868	1	1	1032	jxD5XRektdERbEyXnfXYjm4m4pt6b13fmoWiBfJxYiR8U5tUKg1	579	809	809	1616084820000	canonical
1045	3NKysjSA5quBZ9aMupbyLq3WvkW9jXaRJheDg5n9tfPdStaW4nk1	1042	3NKEJTMwm86VVqTNWPVYdRq4KkXYqB7mnCMpSECUZDc3dAVymLYR	243	243	1	1	1035	jwPz8NYjCwBaoU74zo1S2qujXDcAFmGjdxB4QZxq7wxeF85E5L1	580	810	810	1616085000000	canonical
1047	3NL21URm3pdCjTpxbNC9F4qCxF9FfBCVtfzN2yA4qRrN7e4QaDuv	1045	3NKysjSA5quBZ9aMupbyLq3WvkW9jXaRJheDg5n9tfPdStaW4nk1	1402	874	1	1	1037	jwyv3HKEcVV1TA3oiQnqbwVPJme5UyTUFCXUtm3EQM96u5XbiuQ	581	811	811	1616085180000	canonical
1050	3NKQkwAitnSHvvKU2cHLqmRAzaueQMQsXKKxiurQoR7759s555Xu	1049	3NKrvcLgkrCc4sDb7pzdQjkzwrsRvm9iu9iiHBLGQ5mFkYHyaTGP	1406	1393	1	1	1040	jwTHWwHT5dDJZmTT7qSdfiyzXJqCj3RmoYiwfzCcZttHkMBr7b6	583	816	816	1616086080000	canonical
1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1467	1250	1	1	1043	jwmXeDAevYWgiGshovpR9AKctHrLv5iTg6tbZuS8aYUCwZBEJTr	585	819	819	1616086620000	canonical
1058	3NKw2Kse6NY1vMcEUhgroogBrFPWUy14WaHdSHkXuochQ5SSYRNd	1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1500	1051	1	1	1048	jxXD9Re3cvNsemroNoNcrWi2zjm6HnFH7gAjDzZqctST8m5JuiS	586	820	820	1616086800000	canonical
1056	3NKqwBBrybVCppmXgZTnw7tKxrDBeu3TSZCBUb3xHWyqctGiD7cf	1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1523	1321	1	1	1046	jwkc9KXQpsURQAv4b7bp8feimoZpA54xW6WhMo3TkcCKGmte49R	586	820	820	1616086800000	orphaned
1061	3NKt4qLYVYny3DEsb4afjjx4bUV9R1rTKjpCfZWDD8mwddP7qJ2Y	1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	1407	1395	1	1	1051	jwZrcUWYiZKfg2EqBHQnXrQMrrLbndmGB6HhTesuECnYvp4sLxp	588	822	822	1616087160000	canonical
1066	3NLRvXeP46ntPpFsHSCTL9jogbXca3ASmqCjKnV8RZKXYJtSZ4KM	1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	1406	1393	1	1	1056	jwvria5RhSebLPhhJPtSXce2VdgamFPjXpt6ztB9sf67VmPR9r6	591	826	826	1616087880000	orphaned
1069	3NKs8G48E5e29brbV9MfcJztTrfCWW39w3PudUUAWV98vdmAUhQm	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1407	1395	1	1	1059	jxzr3xbXsJn3kS4euaY6hoQDQZE3U2fS5GDFgbPaJwCwHFYDZAh	593	828	828	1616088240000	canonical
7628	3NLK58aUowmbyj9NXdgibDZhXkSLZsPkD27q75tgjtj7GXK7h65o	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1560	1045	88	1	6301	jwqqwQTN8jLgzN5GuZ3x5QqR9CKAZ1Yn9CPiPU7UPVJEKJhjr16	3945	5574	5574	1616942520000	orphaned
1028	3NLJEJMyNsppz1uctCpB2sR4RL8cW1y7Ueq9UtFPZtY2nsZm2381	1025	3NKTTkJuvskanfRRqWzqCkBcwMxEFQ6e67nvwBrePvvzWkfrgoHL	101	101	1	1	1018	jxdG7R13oC5YKsJuCwCiYdpQiaUw8aRXtiStWnDUALGA59y7GhA	569	799	799	1616083020000	canonical
1034	3NLksm5Qyghdamva9xnTXMxLRYCyf36s1HtCv1m7bmCXusmpQBKm	1033	3NKjbrAio8WUy8zGfGGgw9ssMoidGjCgDGHNPGvASb48Y6yEfJzS	1509	954	1	1	1024	jxwgY37XV6Qt2AXmggSnnqCSYcqsQgvNfXB3Cuz3f2YXseW3Wkp	574	804	804	1616083920000	canonical
1037	3NLuQY5w6iVbABdVMZvwd4LaAHP57pFrfEmx4BzBgKMq3yFMRGhp	1035	3NK64f4cKgdaQM5o6E1HgTgb9Ph1jEi7JUG6LrRHzYeuzMuCpJLV	1477	984	1	1	1027	jwiRuobd7nCsmzco4FwNn3tUnGbD3Rf6yHB88mfpm1dPdqJ5VAJ	576	806	806	1616084280000	canonical
1038	3NKs57YfHb5u25rCvYT1qhqyFaH4dgEnN1i1uMyXD7FtAt6d8K1T	1037	3NLuQY5w6iVbABdVMZvwd4LaAHP57pFrfEmx4BzBgKMq3yFMRGhp	1581	778	1	1	1028	jwYdkXAdAvhoQNUFcm4gArRBd3iYyfvR3D5f1TaiR6jZtA2t1i2	577	807	807	1616084460000	canonical
1041	3NKqsx4Cpzgmh4eGcHJdeP4PLNFm4jwVXpDf7LWuUp5VYgkXaGHB	1040	3NLJDCNKL9JEKQCpyh3SgSdmhaZpUpHVo6vUH35BSuLoHj4NNMw6	1406	1393	1	1	1031	jxeaQuU4rvQTr3AasPhygNDniqf5x6dg7vdsSw3nRask7QaDL4w	579	809	809	1616084820000	orphaned
1044	3NLAtDMMrd8QBL4t3rvpfjV5aPZYRKNHgnepzJEYnDSooV9mDCYz	1042	3NKEJTMwm86VVqTNWPVYdRq4KkXYqB7mnCMpSECUZDc3dAVymLYR	1407	1395	1	1	1034	jwGgsLgfB4Wah7wHUSwRYdkPoTY3c8M2dyekBzqfsFjKoXBoCa5	580	810	810	1616085000000	orphaned
1048	3NLMumjvAp8FwrALEEH1LBv5DbL96tAEkAo8E15CnSCpyjGwAjLU	1047	3NL21URm3pdCjTpxbNC9F4qCxF9FfBCVtfzN2yA4qRrN7e4QaDuv	1600	1372	1	1	1038	jwJ6z92ocp5pNoTVDjNfG9BNmHKyrLmi1yekTuRhgKt2iJMBfkX	582	815	815	1616085900000	orphaned
1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1050	3NKQkwAitnSHvvKU2cHLqmRAzaueQMQsXKKxiurQoR7759s555Xu	1405	1	1	1	1041	jwirNKJgzLByib68moVThjy9pS74YLMuzakCiMYDC3ac6NtKysx	584	817	817	1616086260000	canonical
1057	3NLYeNESCNPDi6TBuWhKR7w8E3jpYP8pBehvJrt34jrjrmFFKT23	1053	3NLX6cktR54KDz9QKQLBUvVJForRBqNSbNvmrCMDtBVT5otpRRme	1407	1395	1	1	1047	jw9zQppuYHmkYgqs3xPTdpbN5BwivjDQXA8dWEeVhAWJPidAguy	586	820	820	1616086800000	orphaned
1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	1058	3NKw2Kse6NY1vMcEUhgroogBrFPWUy14WaHdSHkXuochQ5SSYRNd	1553	775	1	1	1050	jxiBxUxgPoJHMomTqGe9654X8U3bAy8XzoEjTEVw8aUYdvqUJWd	587	821	821	1616086980000	canonical
1062	3NLr9ajAguT4nTotZ33TZ4Mru5G8EiMUNXRHhTdzHDyX97r3m6Tg	1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	1439	1153	1	1	1052	jxyVTL7AVboUCB6msQHVxbbiXoV6LPkgWXt1BxLcJYDYYJokHPX	588	822	822	1616087160000	orphaned
1064	3NL61j9pdbJXtm4ZrVdxbJWdKhcjQkuVvDy86cuhSzY1jQ4mz3DY	1061	3NKt4qLYVYny3DEsb4afjjx4bUV9R1rTKjpCfZWDD8mwddP7qJ2Y	1406	1393	1	1	1054	jwDer5ntfZMak3wnY29JyquNfza3hb6Dxs2NTKniuT8sXpumqcw	589	824	824	1616087520000	canonical
1067	3NKDkTYRpZTYhTQjigXosbtk8RKNUyp3fR7yKfNAqxmqMifjFTuk	1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	1637	816	1	1	1057	jwGotQd373dgvTejWVgdxNYV5PV5MH6A4Z5JvjrBcEkkdp8kChF	591	826	826	1616087880000	canonical
1070	3NLRQUQek8bPhkdDYqyLWoiLuZNGz4eoxUU1Ztj26oL92a5qSN1f	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1610	467	1	1	1060	jwUDJ7jQ6cFx8mvhK75zHPWbsjtpRsFqSg4EVLZZkmVaeqvBaiA	593	828	828	1616088240000	orphaned
1073	3NKH5uWrHTFToEe5j29yTCeWoUMPexq2RLG1j28YpfZmpgawB7g6	1069	3NKs8G48E5e29brbV9MfcJztTrfCWW39w3PudUUAWV98vdmAUhQm	1406	1393	1	1	1063	jwvenaQxnGFuLa2B3sM6i875CSUd2MC3nokQrcbPCMHZ1BQmW4s	594	830	830	1616088600000	canonical
1075	3NL4wiJ9mn4UkEHNUWe2MPMENkNc6A9LJ72jenLG9EfkBwVHJ5s3	1073	3NKH5uWrHTFToEe5j29yTCeWoUMPexq2RLG1j28YpfZmpgawB7g6	1513	1379	1	1	1065	jxhKyEPDjkgoB43SQx5uKP6rtYb4HQvj1nvUnoFudAJivgCc8Fa	595	831	831	1616088780000	canonical
1076	3NLZKH4qa3ogzRX7be9CdUixEB96MaCzwXb2R7FkK3rWTNEP2mZ3	1075	3NL4wiJ9mn4UkEHNUWe2MPMENkNc6A9LJ72jenLG9EfkBwVHJ5s3	1529	950	1	1	1066	jxvqEaHFgUACiFXXJgewuw8qadNNaYetAaaouFNi7nC4BstWrUp	596	832	832	1616088960000	canonical
1077	3NLA7xCwgzYbyJv4vt5wC1MZqJdM3zc1e22ipvCxbzx2uJTdKTmN	1076	3NLZKH4qa3ogzRX7be9CdUixEB96MaCzwXb2R7FkK3rWTNEP2mZ3	1458	1323	1	1	1067	jwi7GFam187t64aJHtLWjVrQBevLdymBLqM4WRGuuhkChs4Vn17	597	833	833	1616089140000	canonical
1078	3NKLAUJQDLnqXMG8jrromaGNk3LHZ37c2KEoPAUpcmbFdCLTgbzK	1077	3NLA7xCwgzYbyJv4vt5wC1MZqJdM3zc1e22ipvCxbzx2uJTdKTmN	1585	1366	1	1	1068	jxKDW93PsS6NFmVdEFtYi9ePXEN4tbHvooZuQqxQmY4WuHLh8dR	598	836	836	1616089680000	orphaned
1080	3NKkWHCBdivA1j9WkSbw4LH75z3bERMbnVfpn4axvbSv9Dq1c7Fk	1079	3NLxhuv3ncQRdbRxb1oCXYhyMdiwyCUQXsXduvpwg7vDyWXifHTH	1423	314	1	1	1070	jxdPLypMVxLsRi6afSw7R3yyse7Fjcgxx9ZbHTYhzmMVvwkDYBe	599	837	837	1616089860000	canonical
1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1080	3NKkWHCBdivA1j9WkSbw4LH75z3bERMbnVfpn4axvbSv9Dq1c7Fk	1474	1329	1	1	1071	jwXpu1hLHQT4EqVHe1muLNgiCubt7CkKaW1RoZcZkesokuM3NRm	600	838	838	1616090040000	canonical
1082	3NKb8E5ePpzyUCCHq5ga8NA2TvQwSUhELEECDcc7UP3VUiQg1yzy	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1536	1313	1	1	1072	jwNS8PoXYmb8hkxUxRipxLmsNXZc5janmRiS4XvVBLnd4G2Sovg	601	839	839	1616090220000	orphaned
1085	3NL81PDErgwdPB4rLmCmhGddFJd3d19i522xhdG3yujHo9MswBLh	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1495	196	1	1	1075	jwe5qsN6txeDa8qzg51NWhzB7p94NvKwU2hBpBDrYodrp4mn9SF	601	839	839	1616090220000	orphaned
1088	3NKHEdWdb95ds3ebeidWGtFuzsAHKKpjbM1awuPz4gRZ9cufRrhi	1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	58	1035	1	1	1077	jxkEt9soh7CP2mvimmYTHoRv6xh9SFAQb9VyMx7V9UQ1smGj1wg	602	840	840	1616090400000	canonical
1086	3NKZJM4ZydgQbrbSn57BsVgr39j8gTAQEjqwmucVgBpv7Nt525wm	1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	1422	1337	1	1	1076	jxCMr7Z9a8XSPhiULmWz3uqyMG8yttBKVD36rSjYKMcjkwAqY8f	602	840	840	1616090400000	orphaned
1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1088	3NKHEdWdb95ds3ebeidWGtFuzsAHKKpjbM1awuPz4gRZ9cufRrhi	1405	867	1	1	1078	jxsqEjMiBNSa32SgukwMD7GRjZ12ewpCEPmgwaCL7zG3BxduGpP	603	842	842	1616090760000	canonical
1090	3NLVSY3TLht5zN4cQbw7HjPcoen15WgSYp65GEgmoTf4B7NcTZTU	1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1489	1134	1	1	1079	jwvZMusGT6UM7jmKDQKZUSj57RJrrX4TL9LnTFZhEjXfjVJkrPU	604	843	843	1616090940000	orphaned
1091	3NKwJM7pGsDEvN86HVfQR4TsxucegB1h5VM5NsEsPWWZj8hyfxUQ	1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1489	1134	1	1	1079	jx5sRdfUYCfuHKDD4rwzCKBMqtrX7QyFkaTkDVnbA1QHFnBqzKa	604	843	843	1616090940000	orphaned
1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1092	3NLrZJdvYHz27t3cfmocN4F1M5craKvb6iV218NrjJLzoZacLmzP	448	939	1	1	1081	jxFLK99EMacCLUsAoc33tVkY9fBYQi9gyte52275TbfuUhEmyVw	605	844	844	1616091120000	canonical
7641	3NKnjCFz4muihCC5vzvhxSuLFEPXEM6Zz5Q78fmCVkEWd8kLrAmz	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1596	997	88	1	6301	jw8hNXKsb4BGMAHgkBN58r8J5fmSfJmPPXKMRaupKCvvRfi1Mrg	3953	5589	5589	1616945220000	orphaned
9998	3NL2f54NN5uZn34RwwgYJxnu5kbqSGRmQKLdr9yfhHpWnefdS3H8	9696	3NKuMSXeYsMMc2QDvwpKuY2ZvWrDiMFdhbxgZma8Byxu7xFt1PkK	1643	1299	124	6301	6496	jwX3Vs2wmni79fEzpG4op84oCVAVUrX3EojfJ3cso2uryK6ZyJP	5027	7291	7291	1617251580000	orphaned
1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	58	1281	1	1	1074	jxYrQqsvhNoVExpofk7gZvgX3Rg7f3dLw5F7zZaiKVZBC3kvdEZ	601	839	839	1616090220000	canonical
1083	3NLUDRHFTouoztJWHCoCJN47VpecwwYoU9zRcQPMH9WpgrJSKzc3	1081	3NKXoW43QsNV7jh762tEczJE9S31GoUGvq6QSkUoXNBN79dgGXb4	1602	1369	1	1	1073	jwg4Bd2xuyVNLF84VNTvznpj8vAENaFu6McBy5CEr6LHpYR8JR2	601	839	839	1616090220000	orphaned
1087	3NLHGmB1yZQjjGFWiCNF5FGYH8BLSt4EtpCrsCy9SbvgQcSGtScg	1084	3NL3TeaZjbpfqwmBdsjRP8dZVCrXpaTHnaYivQAhUgRedMzzuAhM	1422	1337	1	1	1076	jwemL2b1HTJvN6MV2qAwbPX9xEPcrAU3SfodhCMT6PyF2AS3AqS	602	840	840	1616090400000	orphaned
1092	3NLrZJdvYHz27t3cfmocN4F1M5craKvb6iV218NrjJLzoZacLmzP	1089	3NLrYzhNB1SEEoS1xdB7H2NkvHPHxms5ESSvy9gh4U72KT7iDhpM	1531	294	1	1	1080	jwuh9ebSLkx1g3Xzub1n6shE1trjqazXaJrrn5pDedtvQn99h2c	604	843	843	1616090940000	canonical
1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1407	1395	1	1	1083	jxLyHsGCjFq4VqLnGdbavVdv9JQ1kZuDz6KYJcxz7F2wDk7aMeM	606	845	845	1616091300000	canonical
1094	3NLrRXbJW4CYx2y8BXfUNniPjF1sGYjuGa49Gb7bCyxHGRSYnQab	1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1403	824	1	1	1082	jwtGZZAq4zQMYFiQGQ7R2XcLStuRRYC4rbiq9VwQvu3z75UXPEg	606	845	845	1616091300000	orphaned
1098	3NLxJygTkcyKpo1MBZyUMGJqPRC27tYCU5Dte3Qey8piP6dEAZik	1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1527	1047	1	1	1086	jxoGr8Mo5nsenwiZi2CHJ4ytakjXbjY6rNiQiWpNxwzjR9F9ZUM	607	846	846	1616091480000	canonical
1097	3NKgbJw8og1uV58wx5AmTNAof2PQXyC7Zg8dj4PjhpHtm73TP9JD	1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1407	1395	1	1	1085	jwnMW83BtzuMfNxfPYN4x6mvjdRFM8eadQZowhBzyU1zUDUfLpW	607	846	846	1616091480000	orphaned
1100	3NLBu8HNXphV7uSev97xGY5VxqUpDmvxpSNE623EY28S7Kd5ru8m	1098	3NLxJygTkcyKpo1MBZyUMGJqPRC27tYCU5Dte3Qey8piP6dEAZik	1650	1249	1	1	1088	jwTV4L1yWi7zSr7gZx1P1XFdrvhYBg7puvFVBLicq3T7dffDvfP	608	847	847	1616091660000	canonical
1101	3NKse8WRaMweBua5sEMeuzytRA1Qe1RRjWUwCMDNhMhQCia4PtJV	1100	3NLBu8HNXphV7uSev97xGY5VxqUpDmvxpSNE623EY28S7Kd5ru8m	1407	1395	1	1	1089	jwcuqnaiUhDQRkgtCDM5jDYdwvx9ejBEWyM7cyAA5ackhkrU9vf	609	848	848	1616091840000	canonical
1102	3NL3pV4g44VDsADJvjRSQ6LT1jauiBD86SWCBzQoxKBiKtAVZvzT	1101	3NKse8WRaMweBua5sEMeuzytRA1Qe1RRjWUwCMDNhMhQCia4PtJV	1668	1124	1	1	1090	jxcmU5Dg1u5QAMH1aqzQUzUgcHCBQ4Y5EUmCHQbG234BeiCdDPq	610	849	849	1616092020000	canonical
1103	3NK7fHXJwH8nVU7tbZGWZgQTAxLLEXiSPdbPfXYwsPvyRXyNjJUX	1101	3NKse8WRaMweBua5sEMeuzytRA1Qe1RRjWUwCMDNhMhQCia4PtJV	1631	794	1	1	1091	jxjohudNU5Amsce6NsYbPFYnPFs7LwpmRAA8zajFifdt9DtHLpm	610	849	849	1616092020000	orphaned
1104	3NKr6SXFPfMMi97ot5sKwevAwh8Tfxam4zh5XkPT186U6XWGHVuk	1102	3NL3pV4g44VDsADJvjRSQ6LT1jauiBD86SWCBzQoxKBiKtAVZvzT	1445	1290	1	1	1092	jwr46d6DhXqtE7hyXx9ReKJ8gjZSLem6QxRQRTU2PWCWxRHexKy	611	850	850	1616092200000	canonical
1105	3NKK3t9hnMJfD5JwiaXHHzcZYu1YW6kPoTC6zqtF6bcbEbCByzj7	1102	3NL3pV4g44VDsADJvjRSQ6LT1jauiBD86SWCBzQoxKBiKtAVZvzT	1559	1353	1	1	1093	jxrgdk9VZ2M3Ym5F3B4NHQQkivW1NG1kfDztEBBeNJ9TL7CZCX4	611	850	850	1616092200000	orphaned
1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1104	3NKr6SXFPfMMi97ot5sKwevAwh8Tfxam4zh5XkPT186U6XWGHVuk	1406	1393	1	1	1094	jxeBqpTFX4fWJqoZ2oyz5Bp1RN8xNMTM6Wom2GDAVP3uNgpNvxP	612	851	851	1616092380000	canonical
1107	3NKoSbnJe53Zik8KHWaWpvC9jWQm6nKHT7xzAWES8cz4a55wBMbf	1104	3NKr6SXFPfMMi97ot5sKwevAwh8Tfxam4zh5XkPT186U6XWGHVuk	1500	1051	1	1	1095	jxj5c58qiwRb9Y2b2yKoepX8VB9NX8Qqh6Yrxxgiip3WFWpRnm4	612	851	851	1616092380000	orphaned
1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1406	1393	1	1	1097	jxGXVJZ4LH4sRYQD7GdXCwcsuAr7NwiWPMN8TMpGKjPG2VnfEJ4	613	852	852	1616092560000	canonical
1108	3NKjnRUBuWkhsYrYvvA8HA6erdwqmET85H13B48DWqWbFzewEXiy	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1670	916	1	1	1096	jy1znkpUC8r8AQ51xeP8JGQEtQcUCkdiXgfHB6PXKZdFmsTAh8C	613	852	852	1616092560000	orphaned
1110	3NKL3RJ3DKakcTxk6QagX6EjS9n9SEqneuQPJq8LMzbtemok84Fx	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1608	1289	1	1	1098	jxRccvmdMsQJcwmwd1ptj61VAYuxjhXE3n4hxZtGXPzRjimvTsE	613	852	852	1616092560000	orphaned
1114	3NKGsCDCbNm4CvsuPciF7V9skwgkmTeDuS1iduyTn4ajfZ7LPXFG	1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1477	1350	1	1	1102	jwn2tjJVND8ctgnWJUqyv7jPAbzHsCeLNaLwUYsNp9odfkDp9Ma	614	854	854	1616092920000	canonical
1112	3NL68YvDFuia7S8xosf4FuSPoxqm9aycoUdoFzkapChkexYRyanB	1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1523	1321	1	1	1100	jwZGXW4rQZgLezZPsaTPWrYZGsoBd71dzoGeSDiC5CU9HJ4AAZq	614	854	854	1616092920000	orphaned
1113	3NLJ3UQbPuKoTM2mqnfjPWiFEiquoXncG3cx8di3arVdbxUc55xx	1109	3NKN5GCMJ8MPbaqo1f2ek3qgqdjnn4rsdVXQrkotsG1MuMUkG5HR	1506	1373	1	1	1101	jwwzJUPDgEudm5EmxE9k4a1LnZusFxjiXgepRmjqMAWAH28u24c	614	854	854	1616092920000	orphaned
1116	3NKG1bL7p438mYCfUnRWxWQebXRat1sdRotjdt3iLbGUuEGyzHzq	1114	3NKGsCDCbNm4CvsuPciF7V9skwgkmTeDuS1iduyTn4ajfZ7LPXFG	1447	1345	1	1	1104	jxds8kn9xqBDXvmeocaxVQ67zesVnwh4cEjmwYEDShxYu3aTdNz	615	855	855	1616093100000	canonical
1115	3NK99UV3oXM18dw61AqDY5WTf5zTc5C4gGvEvShCSg2bEuxPgHn4	1114	3NKGsCDCbNm4CvsuPciF7V9skwgkmTeDuS1iduyTn4ajfZ7LPXFG	1534	1191	1	1	1103	jxW1goeLQ8vZ1MeeUh91tS8KxVekHq3f683wV9xSMvQa1BTJMyg	615	855	855	1616093100000	orphaned
1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	1116	3NKG1bL7p438mYCfUnRWxWQebXRat1sdRotjdt3iLbGUuEGyzHzq	1403	824	1	1	1105	jwBPyAMqrhoSBTQNC6PAQMZYC6gc2HPPpYnd7W5arv6TB4JGVfw	616	856	856	1616093280000	canonical
1118	3NKDEw4rXCPoHQxVG21QN6dwfGXBeNkXuTq5ffSUpLk2mgy2Rj9D	1116	3NKG1bL7p438mYCfUnRWxWQebXRat1sdRotjdt3iLbGUuEGyzHzq	1627	1385	1	1	1106	jx7qttKXkHjsZ7DqJ4xS8MGtcbsAr69nJJPZMCNEZTHfMdXou92	616	856	856	1616093280000	orphaned
1119	3NLhYeGGifKgYaeJDmHuekMFTibasEmUUrquYk1yWZTHNFdUCj6t	1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	43	1310	1	1	1107	jwWfjUxULd3sS6vkEMBJjv4JysMipT67H4v7TQqE9rXV8XtDKb2	617	858	858	1616093640000	orphaned
1120	3NKEg6JevvXjyweh3k6Hz2FQeLn4Prrd9cJSemnUjxTs9P5SKVJn	1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	1637	816	1	1	1108	jxn2F65pfW65Dx26tDLsmPn989eytozPDxvbZJ184apGnNxvFf6	617	858	858	1616093640000	orphaned
7663	3NKVkdZNjJbgMHb7gqRqd3RcB1wDcYigtcjTHxZVwyj7mZSCUmx3	7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	1467	1376	88	1	6301	jxFBzyiEuVKAoL4bUWHpb2kGBgvCUNVVqcyLSUCeAB3ziFd8gBp	3966	5607	5607	1616948460000	orphaned
1123	3NLHHuT3iAfB867LuBfT6knyCAep5nP2N1HFXeYKzgtypWEMWBYs	1122	3NKzxUF7LWQZgZwbdDpjf6xM31UoiUoyeR7boJZv5UwP1i9GVzKz	80	1273	1	1	1111	jxfT1Lm3qbJWgUJrUJtV2tnvm3gfBZFmftU1piHwwq3ysysUtbU	619	861	861	1616094180000	orphaned
1126	3NKncLXAovbVPYpAcEsSt1xYebLqoh1EUE6GPviNiY7WRqCc7Lip	1124	3NKUBTrWHVnekiaQHWpKirHAmmfD4NuUf7s3NECdcm8ZkbsRWdpT	1403	824	1	1	1114	jwPQx1SsiCKeMHmBPsr72nLC2UvX4BsHRveQF4AdFvBJcXRqUjR	620	862	862	1616094360000	canonical
1127	3NLSgrQj4xJxbUfuDUTvCDw1S7BbfMGYkGRL2PacBcdHVVPKFz6K	1126	3NKncLXAovbVPYpAcEsSt1xYebLqoh1EUE6GPviNiY7WRqCc7Lip	1483	1150	1	1	1115	jxMWxWU6Jd2XGk4vapBeW29L8xEkp1NsuVfbFVww57cwbij5xQM	621	863	863	1616094540000	canonical
1130	3NKrKNWjdUw1s9QAonfMxQETAUp7aSfQthVFn9AnBQYRxs8vkv7Z	1129	3NKcKG9d9ntHngatKU8W6XaSMn8dpzpn266WaWiSWNbGUmE425ZB	1406	1393	1	1	1118	jx2AGXBmyoJLvgAom896qp67MJokTibf47GYCVAfhi31ZZRiNqW	623	865	865	1616094900000	canonical
1135	3NLRiRbKhyvjdHHq2DVYj41uieiM1vYBr9MPWVqDxCSvYcZutF1e	1133	3NLMfTrZSLSUWNZircp9dXbMqQZWHvatgsZuzfeZgB1iDruta2oz	1476	1371	1	1	1123	jwDSGxpwFeCw8cJ2e8ARNQc6wSnR2qxuYt7Dc8yQq7KYUAhSSVM	627	871	871	1616095980000	canonical
1140	3NLQL23wLon971SAwTKRoNArFNT11sfoxxDLBDx84WbncapaSdKY	1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	1483	893	1	1	1128	jwahchGcKhZTC3hpkw1y2u7CzALMY6PGSvJnQ1mua5pyBb3BPUk	629	873	873	1616096340000	canonical
1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1402	852	1	1	1131	jwxX6w7iiZTjFn88hTeAxuahmKJauLRzNzF4PcAu5sA15kqx8DZ	631	875	875	1616096700000	canonical
1146	3NKDToQQekbsVJ8wLs896rCvy2LdRLqMzWEEAFtWLxpEiK2bjSsy	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1403	824	1	1	1134	jwHmLGdmRXQK6TQeuK8QSjA8FGuXhpb8sokZGRr9vR8SEMXyHum	632	876	876	1616096880000	orphaned
1152	3NKB5HozftkwYM8xzWJKSxg2JJgnx5rmZYvZwWizPXtEy3u3zj9k	1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	1406	1393	1	1	1140	jxcrFf4p6w9EJy9KDwq2MuzjR8VP6t85ZfNoUFPXx5XD8RshVux	635	882	882	1616097960000	orphaned
1157	3NLXUWg5Df7CNctB95NgqMf6Aqqd6xDrWUvQWEQPdNFbhcxHKhY5	1156	3NLHC83JNXT3AbLWWr47H8cjamUV5WupgFnQNNXGXKvwdtBSFqVe	576	1355	1	1	1145	jxDdM1WQuoQgUiH38yAFRrvsXNZGdnpLCLSkh1XXeHd5j3KFDsk	637	884	884	1616098320000	canonical
1160	3NKDLWcUsrBAEBxBecC9JZ9vhjYTuwtHLQmWNoU9HAvU4uewYfvb	1158	3NLRYFPJbDQA2fcjMnPRWHFBn7xx1ELJYaYwEVbR6wHb7HejhBWm	298	1308	1	1	1148	jxXcTY8eBiYvdKwBCvrJLi19sEBCEBYP2zckQH3SpBFJjUy2n9x	639	886	886	1616098680000	orphaned
1163	3NLJc6tqBSB9oychfkaQjkFjKg19miMH7pw1prHGJQmcRrW9QGSt	1161	3NKXWoQiEtRYorVZ8oxFxR31sWXDMwaRHBT7P7Giz78LVwESmQEm	633	1384	1	1	1151	jxARHpWrECyNEfThz7YeKwr1nLCe4YBwVU3M7YFrWQCs9pGGLVt	641	889	889	1616099220000	orphaned
1168	3NLTWQM8BwFL49TEpZN3YEhKF4zZsUmSpLJFH332kgwcrfAxtUZB	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1403	824	1	1	1156	jwRY2YwXCSEv7Wb5wsEyFmob84qa8u76uPS75f1tuoWCCR7YHt2	643	892	892	1616099760000	orphaned
1172	3NLWNHLsYoaPXqJGzE97jBGkyPvTLEii5nvSp2qBSWGBvgqqZnb4	1171	3NL3STGisLGwAGU36ce28KfMKBGnSkmABYdostGGgY82NXnCaZbi	1546	1213	1	1	1160	jxnGw48ws4wNnrfrZTTo24kJD4FudouuvtRQ9WcruBE6jTbsmW3	645	894	894	1616100120000	canonical
1175	3NKxX8RBWHumRQL1Dy7sVbWgZx5z2mk1oQE9PciS5zmZCJRRdWiH	1173	3NKxtZBymBtGThGrypPcBhfbbFAZgtyXstj7Gjj1GqmbJ748eLQ5	1581	778	1	1	1163	jxnUYgb4xtg1kfwvu4SWrx9tPgpeemY61AydSxfKEVKzEfvLiL9	647	897	897	1616100660000	canonical
1180	3NKKYiZHchb9weFbJPMgr486cq1BFiUJxNanZpTvTuad2MjfVGL7	1179	3NKwQrCyUyPj3bZG3V3iVUu3hrAVoyKPNkVHTpWFkRXgw2UL2BVa	1403	824	1	1	1168	jxpuMUZdDSM82zYHfhQVYFbLbrfDtBu1kQvz8j2jsvaii4bTfGA	651	902	902	1616101560000	canonical
1183	3NL6RsrL2hjWtad6shrpbqfmi3YdAfB8Nhr54nTNxkbrRCGN7tpU	1181	3NLGLrMbrmY9Hp7YyRYeY8JMWjFaiwUYEvsf7NrZd3inkNdHqZiJ	311	1307	1	1	1171	jwtxzQT7jWzXwVkwUkZGqdkRdxmCgqY2Ssk9XVVGToMHTQ1SuiU	653	904	904	1616101920000	canonical
1192	3NLsuS4p1U5M5Y8BnRzxeYnbRCF8ZFWTukTqYrmApUYr8ejZcd2C	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1483	520	1	1	1180	jwQ1G66z2QGU2caoTL1UXrp5hsYKivaTc8M8xYgYFXiRTgx8Sk1	658	914	914	1616103720000	orphaned
1195	3NLMMSxR6SyKmNKEoPLFk34EG9bLkvNWjtjJsuXAzSRzeoQJFeEg	1193	3NKW5ezMpEewPUEuNftFm8jcw5LxvBsFvFv1m7Dd22n82T8MLxRA	1406	1393	1	1	1183	jxJd8R7f5s7y48dQQ8oUxaz6b6pWxR51fdMmCVRSBsA1xCTx4kh	659	915	915	1616103900000	canonical
1198	3NLHyYRQR9seC6SWTsdreooZFBdo1j8gyAzrQ3Bp23oVsX3tr3xb	1195	3NLMMSxR6SyKmNKEoPLFk34EG9bLkvNWjtjJsuXAzSRzeoQJFeEg	1481	790	1	1	1186	jxFPSyCZnVxwn2uYtebLWo8cRXHqPfURML4Q8AU75jKWdV3zwg2	660	916	916	1616104080000	orphaned
1201	3NLf7o3f58S67L2469JZ8QXoQvsyY2KruGaUcmpbiTwKBjvTjomx	1200	3NKJ6gPu7cXU5epG6sExjxgThyC12ugmevmYzTtSqoRyjbdnbnb5	700	832	1	1	1189	jwzzCoQWsAxgEFdK4hsWYytx2maL28kXHxALb7nqzCJazwD9FQp	662	918	918	1616104440000	canonical
1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1201	3NLf7o3f58S67L2469JZ8QXoQvsyY2KruGaUcmpbiTwKBjvTjomx	1406	1393	1	1	1190	jxwijipiE41WBvTcqpZXATn82WHxxfvU4e34E8BkUkrPmTBGjm1	663	919	919	1616104620000	canonical
1205	3NKRdJGTLUGUXMnekiTA5U78mDkjPZ91bhB4DdtWjVncEHxGUUXN	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	44	1325	1	1	1193	jwznK8hqyvvhTz9wonNkiyUUqBJPmE6RqrNCtpJu58f6DUB62xh	664	920	920	1616104800000	orphaned
1217	3NK4Bb83CNaUd3zU9rh238d9oVThm7M7mfX38D86xxbJ3mYciT3Y	1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1460	1078	1	1	1205	jxCS8JcrXTcceRAkmV3SaVbGJF9WR4XNksaxknUZZZbznTXHmHX	670	929	929	1616106420000	canonical
1220	3NLFQuDeREdH5WnXuegpVBa8KLNMSdLydBfrfiHc8SCBcicwyN8t	1219	3NLwuHvciBeEWvuEqMsagU828qAvF3jBMxAptNFyvJ2DFRzqRiRn	563	1113	1	1	1208	jwHJfAqbY7KDs64t2xtu5rjhs99R7eHac339zW4fYcn2bpV9mf9	672	931	931	1616106780000	canonical
1223	3NLsWAFJfG3K7VA2QY9N5XV7cbkfBMQbFWDDeJJgo4hSqijtokKu	1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1589	1160	1	1	1211	jxWf7fkKLXWB25EwAbBwJGdNYMhUCiifEMocQxiywSSb7GyXrv4	674	936	936	1616107680000	orphaned
1226	3NKPtj4yWQrGymtFQZXNSiUQd47XgpmPAzrNYEwis2ScfafasLHa	1225	3NKtctPtvdsJGdcYXh6wNpJwaTAYbVVLTaTjvkLyJGfDpvouqHXi	1406	1393	1	1	1214	jxSh2juA5uafZ7tQQWuzGvTM4W5XvzXKVxcm75xQdeTjk7HpfCQ	676	938	938	1616108040000	orphaned
1229	3NLqfvGbzMvahBm8P8osf555Ba3Bmvsqhk7u4KUBpxXN8KiH7KE1	1228	3NLAbccH5GLR1NyeSLCE1pt4KtbK5gp5HDdLdv1vYNSwUpfnnS7p	1549	996	1	1	1217	jxw6M8fFiWRD3YtVkQXACF5TTuCchAknGTLX1MgdyZXLE4Tc175	678	940	940	1616108400000	canonical
1232	3NLd4wid7Ptv8zCs6W9zje6eeFR3yBJo4VZkZsaBh9xz8e7QV2jy	1231	3NL14RwMouSQenxPqZ9WxTpCC6jsmftVLzFoTfXtAjsHkSwKrMPU	1403	824	1	1	1220	jxATE1mPaZnZX8dcv3rynE1WL3di9ZDvuFrxK1WHfiduuE5sT4K	680	943	943	1616108940000	canonical
7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	7664	3NLpZsX4sAYoCoiZwJ3itX2spaAW4etdSH6Qpnmvk76RnKjooqkv	1596	1363	88	1	6301	jwWKn2SPNopyBPdVG1Kfnt67BFxwcm5P9NyXJqCoEYzkxG8qKs2	3968	5609	5609	1616948820000	canonical
1189	3NLSrfwZh3ytKmgLJ2URddbE5w6MYvh9FnL6Mn5TTpWFpWwQr5jY	1092	3NLrZJdvYHz27t3cfmocN4F1M5craKvb6iV218NrjJLzoZacLmzP	1560	1291	1	1	1177	jwjmApGayQH7SJoaxNsjaLMTFLsn2aZQwyr2QELCKjTJvAFFpac	605	911	911	1616103180000	orphaned
1122	3NKzxUF7LWQZgZwbdDpjf6xM31UoiUoyeR7boJZv5UwP1i9GVzKz	1121	3NL4a8k48MpKUtMj6vQn9StXc72KA72pJa2T9yN6HKpJ1gSacdod	1406	1393	1	1	1110	jxrMt18wZq3xTbY6KbGwoSsardTdfKVKKZ6EFLueiwbZHW4CqA8	618	860	860	1616094000000	canonical
1124	3NKUBTrWHVnekiaQHWpKirHAmmfD4NuUf7s3NECdcm8ZkbsRWdpT	1122	3NKzxUF7LWQZgZwbdDpjf6xM31UoiUoyeR7boJZv5UwP1i9GVzKz	1403	782	1	1	1112	jwFUtftMS2BnSV71tviYGoxryMPqnYTsmeEf1AoLCbMF2N3ffyA	619	861	861	1616094180000	canonical
1129	3NKcKG9d9ntHngatKU8W6XaSMn8dpzpn266WaWiSWNbGUmE425ZB	1127	3NLSgrQj4xJxbUfuDUTvCDw1S7BbfMGYkGRL2PacBcdHVVPKFz6K	1501	1360	1	1	1117	jx5Pcua3ipXB6kceasGUcccpgWZnGwj8G9yu9HVipfgwyxJcko3	622	864	864	1616094720000	canonical
1128	3NKS33KYdWBcqro2UAzrevFG7AWNiFirSqHEAsWZVq6q4E9AaTR2	1127	3NLSgrQj4xJxbUfuDUTvCDw1S7BbfMGYkGRL2PacBcdHVVPKFz6K	1588	1392	1	1	1116	jwwTWZZWcrwZCVXXh2AHQXtZw1XTqpELpNYmXrNW5TyiovkanHD	622	864	864	1616094720000	orphaned
1131	3NL1mTXCGeXNwKXTycQmcjZ1PqU5jc2UUwUMV36tYBL8ypJZCxDf	1130	3NKrKNWjdUw1s9QAonfMxQETAUp7aSfQthVFn9AnBQYRxs8vkv7Z	1447	1099	1	1	1119	jwgn7FegHjkAbdTVkWCsrZHfzRC7o1MyaG4tocBfdZEqSUtd7mM	624	866	866	1616095080000	canonical
1134	3NK8b1fRXnJnqUcY7TJxnxM6rb69szBrzkF2nXcJvboRUTU1nHaE	1133	3NLMfTrZSLSUWNZircp9dXbMqQZWHvatgsZuzfeZgB1iDruta2oz	298	1182	1	1	1122	jxnTDji1frC1Fe3DBKe8emn1uSGFyV1voxzLLR8YnAaHYKCHQef	627	871	871	1616095980000	orphaned
1137	3NKrMphnBpvXRWEMiW9rQ9YLGytLYLKbtu8bAgZyarPVj1mfon3f	1135	3NLRiRbKhyvjdHHq2DVYj41uieiM1vYBr9MPWVqDxCSvYcZutF1e	1651	935	1	1	1125	jwKNvLAAYKMTeXrMcmESBaykLTJGz2kBW4bDnndSLcme41YEU5m	628	872	872	1616096160000	orphaned
1141	3NLvbs3S1rRB1pDoXcxUg6UUXvEQBpHDhXTnALvdDTXMzU2RXKMP	1140	3NLQL23wLon971SAwTKRoNArFNT11sfoxxDLBDx84WbncapaSdKY	1460	496	1	1	1129	jwMCWB511MK98oE3C7pCnHPfXRJx99CBMN5m2iGCDdrMT1NRAvw	630	874	874	1616096520000	orphaned
1144	3NLgcYv4nPsd4kdKTvipAxWuEFax5qgvQAzhq44tqrGVKmdhUXt6	1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1672	1159	1	1	1132	jwo1tXeUsjgjYkBSz8RYNwuw2pb9o9N8tkqbPNJxKWgqpfASQXh	631	875	875	1616096700000	orphaned
1147	3NKbMu3pmNu7wFTcPziBvVvScfKN3dMMsA9YP9gNC1JrSAb2D5ZU	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1407	1395	1	1	1135	jwK1smgtTgb7hmRm8MyftGKnZkCFwr3qPmB1koMx3YhKhTZ7qge	632	876	876	1616096880000	canonical
1150	3NKfGC21ujdZg3bYrXeJ1CxcJ1r4pLDCu8bMy3CSJ4njud4bf5Nx	1147	3NKbMu3pmNu7wFTcPziBvVvScfKN3dMMsA9YP9gNC1JrSAb2D5ZU	1467	1376	1	1	1138	jwNHAnEa46ij4ZYBo9n9qfzcF8Vtsrmsv1sRD95FTWbVrAUPFL5	633	877	877	1616097060000	canonical
1153	3NKHnaF366qzhxRG81yRCH6fMMU56stMUKURhYakjQ4wEDDSMv6m	1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	1405	875	1	1	1141	jx2GNsaQsB7UVDsDGq1MvAhXqqpQ2RLTWDifrEGts3PFGuuebFD	635	882	882	1616097960000	orphaned
1156	3NLHC83JNXT3AbLWWr47H8cjamUV5WupgFnQNNXGXKvwdtBSFqVe	1154	3NKdBziQvLEcpFPfy2iaK3W5CjZDt6M8ZqKqvC9AtWwQU3RUx59N	1631	794	1	1	1144	jxe2rMiDXPHUmraCjE1TxAhEr1UtVTsNcgZM5ffXzN9NXAYpFQf	636	883	883	1616098140000	canonical
1159	3NLvULuLcCwdTmDf3BkD7c3VQwt3GBqBqSssFUoHcpdvvsPixg8o	1158	3NLRYFPJbDQA2fcjMnPRWHFBn7xx1ELJYaYwEVbR6wHb7HejhBWm	1407	1395	1	1	1147	jxR3gRqypAvALjvT1cvcc3RjZWWzBpatS21awNPALKq1HbX92nw	639	886	886	1616098680000	canonical
1162	3NL67gL1n8SyzLRgAVxQZSqDUNENiRAuj2NAQjDB8AxYEEDko8kP	1159	3NLvULuLcCwdTmDf3BkD7c3VQwt3GBqBqSssFUoHcpdvvsPixg8o	1445	1164	1	1	1150	jxsxEUDg5k41s9e3TAU965w4WEJcgk97Nr1bqXyF4Y3WNeo3C6U	640	888	888	1616099040000	orphaned
1165	3NLnvokp6D82EJ9AeCjQX4fxTtbUBJGR1QMWS2oDPbpcbFThyFS9	1164	3NL8GNpTAkudvUoHnQvkEpcY4G88eWiQFUpZFVrD2axtJWjSnawc	1670	1282	1	1	1153	jxQXuGLpfNjvCFN722zP9nTw97bPWCuJCzK1YKyhJbY3oy867MQ	642	891	891	1616099580000	orphaned
1170	3NKvxiZ9hGWAN9qW4KYi2VPW6EFy2FXxPqyLZRtVY9AL7mpYCqtS	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1559	1353	1	1	1158	jxXH383z87eHUs2yFChvW3YuZYkR5pvEPBt4nYPNVFr6zPUUaXb	643	892	892	1616099760000	orphaned
1171	3NL3STGisLGwAGU36ce28KfMKBGnSkmABYdostGGgY82NXnCaZbi	1169	3NKpu8E7qb4JksnfqBtpGXUF8ecPYz5yHKFLoh92i1cxYjyQFEEt	1402	34	1	1	1159	jxXoSQ8xrMvdi4yC8GWCDmMtbkPovWHmhXDqbYmxyAvnzGdnwJR	644	893	893	1616099940000	canonical
1176	3NLYgg2qbWSUxxyCzEjCJyh1RpTtPqFA4w5UtXWoefpYLEKjf78D	1175	3NKxX8RBWHumRQL1Dy7sVbWgZx5z2mk1oQE9PciS5zmZCJRRdWiH	1518	788	1	1	1164	jxkjJ73pTmgqxcGfrAJGrFFSc7QkgG4L6tmFimuxQxzMpRiWWLg	648	898	898	1616100840000	canonical
1179	3NKwQrCyUyPj3bZG3V3iVUu3hrAVoyKPNkVHTpWFkRXgw2UL2BVa	1177	3NLbrv3cPmsXikLeAL2F8nfqtqfX2EGnEcPWMMPDbUi9JKZXKcuv	1553	775	1	1	1167	jwyeKWHayLML5VLBm1fhQvLTJX7bccMvGbUmWvBM8a8ZE3JajYL	650	901	901	1616101380000	canonical
1182	3NKSecfXhaxrViEU538jKsyA9qYH237ec7usd1pr1ApZgdEzH2sJ	1181	3NLGLrMbrmY9Hp7YyRYeY8JMWjFaiwUYEvsf7NrZd3inkNdHqZiJ	1406	1393	1	1	1170	jxVRPWhAAk3Qs6htuyhos7nto6RDG9efDoSBwEwehjHchbCixRN	653	904	904	1616101920000	orphaned
1186	3NLjBffdssnWyhB47hPPZchuFzLHmdeD5FczdfP51ZbG1uVNBv23	1184	3NKekzkfojZbM2Mh4wsYBAGvzubkr2gDGpeivEdSrjWPZWqfKbcA	1402	852	1	1	1174	jwrzNFRKgRTT4DJ1nxSoCHYh4Z1uRu8LNTJndKKfxpYQ5Qxr6GY	655	908	908	1616102640000	orphaned
1187	3NLdcCqH5xuLVFyGjTxhKuWYwYbNefekPS7GB2mHEtZa7navTvfL	1185	3NKFjdiKRTohpZajdH3vnfvrp3mAP3ttuvr6USFdNKdxhKrfJQd9	1560	1291	1	1	1175	jwfKE7ZMrNU67YPWMQGcdYSuvo82JjX9BYcrtRAygb36CZ2vQZS	656	911	911	1616103180000	canonical
1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1187	3NLdcCqH5xuLVFyGjTxhKuWYwYbNefekPS7GB2mHEtZa7navTvfL	576	1229	1	1	1178	jw8dv7pzSGMou78QDpGDbmmpVejnAy5MUgAg3K88sCDQt9AZX3A	657	912	912	1616103360000	canonical
1193	3NKW5ezMpEewPUEuNftFm8jcw5LxvBsFvFv1m7Dd22n82T8MLxRA	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1650	1009	1	1	1181	jxiR7qEAc3ApvtZ1N1Erq2xAVSRVdexQFCLf3YhgxVNz5srGNjw	658	914	914	1616103720000	canonical
1196	3NLkZrFcwUYTyrAmf4qwbvcePHJkJdzTT7rpFrsF6U6yCK7oqmCn	1193	3NKW5ezMpEewPUEuNftFm8jcw5LxvBsFvFv1m7Dd22n82T8MLxRA	1513	1133	1	1	1184	jwFazx8s5GcpGQ3QgVSyebFQJsgTJNYYQRGwgP4qCeqdJMrKmxy	659	915	915	1616103900000	orphaned
1199	3NK99hGwo9zVm3bJ1SRkX3C3Zv7WDub9gTdx4MujjXDWohyGHVFC	1197	3NLDD34Uas7K24RANqpmZinGXEmJBQKj2ejSVH7Pe1LHRVA9B5ZC	1622	990	1	1	1187	jwyaRm12YDu3QUoCYfzqDHCr3daj5kr14jaNP5392v21ywQoNZp	661	917	917	1616104260000	orphaned
1204	3NL1mtdjnRm9ZVXHyYraLSK1Qq6pxdYm2FsYekKNRfuUszjF6u7N	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1407	1395	1	1	1192	jwmmU8p7esLGu35Cqn5B3dxa74hMNHinCmQPcSTzkCvvWmii2F4	664	920	920	1616104800000	canonical
7669	3NLhN76maJ7dNNgqwQ5iB6edJ31K4sUdnMMko7N93wd1REcsXCVr	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1613	1349	88	1	6301	jxwBeY6T5Sx4fzusJULRYiP1xidyAZu8DDVfnwXAK1AUMb1ou2L	3969	5610	5610	1616949000000	canonical
1188	3NLaXZY7wEGsdjMzJxTTBuheExn7xB4dc94H69N2A4wPkqaWjrax	1131	3NL1mTXCGeXNwKXTycQmcjZ1PqU5jc2UUwUMV36tYBL8ypJZCxDf	1560	1291	1	1	1176	jxJSedbZJrJBj2prkDK9ok24x7Pr4uwk8XsFybmShoHdGoC4DFe	625	911	911	1616103240995	orphaned
1133	3NLMfTrZSLSUWNZircp9dXbMqQZWHvatgsZuzfeZgB1iDruta2oz	1132	3NKyXT4WNvNQjMVwVLdg98362kwPACaygj1AQcdQqpkoi8gGQ2C8	1581	778	1	1	1121	jx68dU9FahE9P1tUAsvtu5BbvtzDNehDqJqEC7pCxEzYq5hgfJk	626	869	869	1616095620000	canonical
1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	1135	3NLRiRbKhyvjdHHq2DVYj41uieiM1vYBr9MPWVqDxCSvYcZutF1e	1444	1135	1	1	1124	jwezBa2fAYQcm74P8QNLgfmEdj2ZKf2qVpR9PMtQA3t2HN7CL1m	628	872	872	1616096160000	canonical
1139	3NLXGvXLEAg1YFhiEbTAgYhFNyG9iz5U8MFbLxtSK6BYa9pAikXz	1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	1578	1050	1	1	1127	jwyjxTKpCR5gJJPjt4rfus2eVkS1Ch9WPKAbv9oiizSK9umXjXj	629	873	873	1616096340000	orphaned
1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1140	3NLQL23wLon971SAwTKRoNArFNT11sfoxxDLBDx84WbncapaSdKY	1590	934	1	1	1130	jxKBc94PngixrrYYLKKzdimUnGAH7YbRJfzzZyYm2KE4vnfTHJx	630	874	874	1616096520000	canonical
1145	3NKVJREkMnTjcEJA6tL7cRKepQXLH7YvifAPtkMheJoin8kCh2eu	1142	3NKRi2BUt63quCoUpczvmYzdDLLpU4JMsWZCcde8oDzHHXxuzZTb	1631	794	1	1	1133	jwpy27ETJVpR7Mpkq7nqGEuTikyhvshNW16HMU9QaxCJtjEhTPY	631	875	875	1616096700000	orphaned
1148	3NKCdQW7jiFAscKviUFh7GHP2pvSfJ5eC1b1CEaz2JoFnN1RVSkS	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	448	1305	1	1	1136	jxzzbAntyV7WsNCkJgdBfGUXFVxHT5hS1KT6Hm9U2yAvRmS3obP	632	876	876	1616096880000	orphaned
1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	1150	3NKfGC21ujdZg3bYrXeJ1CxcJ1r4pLDCu8bMy3CSJ4njud4bf5Nx	1501	1114	1	1	1139	jxXEvf4KKTQ9nkWdzJbh5dKPY9vAkkhXg6bpvXZenA2g6E1j3Ue	634	879	879	1616097420000	canonical
1155	3NKqN8ZTQB1qGcrL1hX64UwYXziRMyYYJsdPAkxb4h8RwLqs14cH	1154	3NKdBziQvLEcpFPfy2iaK3W5CjZDt6M8ZqKqvC9AtWwQU3RUx59N	1541	1298	1	1	1143	jxY6T4wCoxtqk9HixEYCdu5PcAAYmX6yhAvsPQcQQmPikJYgjuh	636	883	883	1616098140000	orphaned
1158	3NLRYFPJbDQA2fcjMnPRWHFBn7xx1ELJYaYwEVbR6wHb7HejhBWm	1157	3NLXUWg5Df7CNctB95NgqMf6Aqqd6xDrWUvQWEQPdNFbhcxHKhY5	448	1059	1	1	1146	jxQGALdkQ6Ynn3RTgqWqzY5mqYiPj9BhP9SKaBQjLZA3frxeqLb	638	885	885	1616098500000	canonical
1161	3NKXWoQiEtRYorVZ8oxFxR31sWXDMwaRHBT7P7Giz78LVwESmQEm	1159	3NLvULuLcCwdTmDf3BkD7c3VQwt3GBqBqSssFUoHcpdvvsPixg8o	1406	1393	1	1	1149	jwrnRwkB4VrFdqhXQrY7WTYdPofiL25oHfirF1TxdpGFnkuvSJU	640	888	888	1616099040000	canonical
1164	3NL8GNpTAkudvUoHnQvkEpcY4G88eWiQFUpZFVrD2axtJWjSnawc	1161	3NKXWoQiEtRYorVZ8oxFxR31sWXDMwaRHBT7P7Giz78LVwESmQEm	1508	1021	1	1	1152	jw8LwNMjUxbhuZYDU4V9pJ9WF838xhsi2LgjMvDg4wqADyEnpzU	641	889	889	1616099220000	canonical
1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1164	3NL8GNpTAkudvUoHnQvkEpcY4G88eWiQFUpZFVrD2axtJWjSnawc	1536	1313	1	1	1154	jxSo9M4Zfre28dfo3GSneC2nqfWm5wmFe2n2XRHaVVzFQtfcMAN	642	891	891	1616099580000	canonical
1169	3NKpu8E7qb4JksnfqBtpGXUF8ecPYz5yHKFLoh92i1cxYjyQFEEt	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1407	1395	1	1	1157	jwUvcYwx7EzH9KwsQABuzc6pPmCBYdFZf2FqpppwT95uBZ5Wtz8	643	892	892	1616099760000	canonical
1167	3NLWRMT48QKZXCb8HwsFCQygPGoEa5oJ4VbbfpoPft4PsZgC6KJQ	1166	3NLjKwjTED4dEBcg1T66tbZowanShdQnLqQ1k2swrfgJhdZZEmfT	1671	1119	1	1	1155	jy1CuqQ51szmvK6k6e1LnsUGACkuFq8coH9TkLGBNMSvJPxYoWY	643	892	892	1616099760000	orphaned
1173	3NKxtZBymBtGThGrypPcBhfbbFAZgtyXstj7Gjj1GqmbJ748eLQ5	1172	3NLWNHLsYoaPXqJGzE97jBGkyPvTLEii5nvSp2qBSWGBvgqqZnb4	1407	1395	1	1	1161	jwtnFNdWvD8YzPSXV1ej194bUS93QmoFHT9yWrsgdBRWqcZe3qA	646	895	895	1616100300000	canonical
1174	3NLCbN92RTCeWywfMc3svbzXsZ92YR7dsChJdU4yb5NrkLaE1gvs	1173	3NKxtZBymBtGThGrypPcBhfbbFAZgtyXstj7Gjj1GqmbJ748eLQ5	1657	1344	1	1	1162	jxmZdCpKx6VryUeD1pNrPBQpp8Wccnm4pwcZVwg9ubXcWxd7gAM	647	897	897	1616100660000	orphaned
1177	3NLbrv3cPmsXikLeAL2F8nfqtqfX2EGnEcPWMMPDbUi9JKZXKcuv	1176	3NLYgg2qbWSUxxyCzEjCJyh1RpTtPqFA4w5UtXWoefpYLEKjf78D	1552	513	1	1	1165	jx4WnAqfkqJFWzm5q6TbDqrxJ4tKv38MTRoXopqqv8LYRtnMzEL	649	899	899	1616101020000	canonical
1178	3NLQX3NVXiWrqgpm1tr4iC2tvPhip2HvWpwejComHhYoXNqVX2CA	1177	3NLbrv3cPmsXikLeAL2F8nfqtqfX2EGnEcPWMMPDbUi9JKZXKcuv	80	907	1	1	1166	jxwCER41AqJdJ258mCv6qNsCCe8j31qxbDPhzK99UVUa9YiZBEt	650	901	901	1616101380000	orphaned
1181	3NLGLrMbrmY9Hp7YyRYeY8JMWjFaiwUYEvsf7NrZd3inkNdHqZiJ	1180	3NKKYiZHchb9weFbJPMgr486cq1BFiUJxNanZpTvTuad2MjfVGL7	1405	851	1	1	1169	jxPQMgeCdHcDrKDS98yyFNZbT3g1fpsaxswmcVA6YmUzcDDqHu8	652	903	903	1616101740000	canonical
1184	3NKekzkfojZbM2Mh4wsYBAGvzubkr2gDGpeivEdSrjWPZWqfKbcA	1183	3NL6RsrL2hjWtad6shrpbqfmi3YdAfB8Nhr54nTNxkbrRCGN7tpU	1596	1363	1	1	1172	jxBeyLQHMNrPyxCTsnGhgcjkwr769sjm23j6QDLepDZ3Xq1exaz	654	906	906	1616102280000	canonical
1185	3NKFjdiKRTohpZajdH3vnfvrp3mAP3ttuvr6USFdNKdxhKrfJQd9	1184	3NKekzkfojZbM2Mh4wsYBAGvzubkr2gDGpeivEdSrjWPZWqfKbcA	1534	951	1	1	1173	jx8wk9zhWc8yrAfv98mwVS3skdATgo5PuL1PibSWCPCvRYbN4WY	655	908	908	1616102640000	canonical
1191	3NLPAA1AccGmqMF5FBEE5nPuRYT2iUD4sDTi3WoW16apBanpbwNn	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1608	1289	1	1	1179	jwFxsdrD9ef1PbmdzUsntKo2jbcjVz4cVn9w9ak8MAgA974kYjX	658	914	914	1616103720000	orphaned
1197	3NLDD34Uas7K24RANqpmZinGXEmJBQKj2ejSVH7Pe1LHRVA9B5ZC	1195	3NLMMSxR6SyKmNKEoPLFk34EG9bLkvNWjtjJsuXAzSRzeoQJFeEg	1402	862	1	1	1185	jwzXqVMp8gv9XP5ZfRaggG3dfMoYKFwNx2UnVPsHGyPjQQQyKTz	660	916	916	1616104080000	canonical
1200	3NKJ6gPu7cXU5epG6sExjxgThyC12ugmevmYzTtSqoRyjbdnbnb5	1197	3NLDD34Uas7K24RANqpmZinGXEmJBQKj2ejSVH7Pe1LHRVA9B5ZC	80	1147	1	1	1188	jwVVBWJRsZoERczad6RN6613E6ifBR5tbCDES75bT3haCTU2vHf	661	917	917	1616104260000	canonical
1203	3NL9adJrtkg8zUC5248Hc8DCyank7rBEEY8ygo3gCP8XJ7PwnZyf	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1406	1393	1	1	1191	jwgTyK9bVPz8FCpiKFkGYqxvWWnsLnXBg6bY8tWw4CGvk1Sr2wQ	664	920	920	1616104800000	orphaned
1206	3NKgbb9uCNBCbDbRSQ7RbYc94CTtbZHb1956RG844BWKYeweAsEN	1202	3NL42pqLS5uZwDq9hLHvAa6X1ycMTHPFTbTgv8NM1izQdegm2uuc	1573	1318	1	1	1194	jxieSK6DgCaN3XJ6stkmPtJm35FGppQLdSgfLj3h8Ye3GWaNUM3	664	920	920	1616104800000	orphaned
1209	3NKhP2vRVkoTkwB1KRC5nLUQC1nW1kkM14zPxDiFz3Kmdx4yyhTE	1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	1529	1316	1	1	1197	jwXRNELLWgTAea5sNx9ESoTkAjcjSG8RFN91PbhqCwrXKryf8Ck	666	923	923	1616105340000	orphaned
1208	3NKDDJqB1R5rKQ7aeMkEhP6tD5pCzBegvZ9Nqg511A23mmqnymkB	1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	1634	1085	1	1	1196	jwyLyPLWEpyqApiipuumyNDN6kWHtmKbSyZYTGdzzEaZJd6Z2sA	666	923	923	1616105340000	orphaned
7718	3NKLyhiB3FMwF5x429H4w5pDsBRPRERiiK2NC9EG4aH1Cj9RJvvT	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1523	1075	89	1	6301	jweajMMEciWGTEGfddc1azX5LkYrBe4NiBc3nA3mT1peEyjmvsH	3998	5646	5646	1616955480000	orphaned
1211	3NKFAatRdduSGgfPoqeyx7o7krdiQjZ5SftnA1auU3AzuKpxC3YF	1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1439	1279	1	1	1199	jxsdFYyixAL1nVcYUuUQfWPgT1L79XBbMJEKWrnW19MRVsTvV51	667	924	924	1616105520000	canonical
1212	3NLk23xubN8PDPwgbp8sA3fuKHSZgvnm96ZVGhMQn9B9788onfje	1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1447	1345	1	1	1200	jwyUJciWiQyBJRfcneZvoqDHED9drV5X7uiQQ41VQUS9oeJFL2K	667	924	924	1616105520000	orphaned
1214	3NLXgxzNhmvqiY6GT2RXe27WMHWYwfFe5ajf3td8p14iwmJxv5j8	1211	3NKFAatRdduSGgfPoqeyx7o7krdiQjZ5SftnA1auU3AzuKpxC3YF	1407	1395	1	1	1202	jx3bkozobrZXSRbSjpTwV3TRdC8FbpYND9awtLutd5rbC4gsoMo	668	925	925	1616105700000	canonical
1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1214	3NLXgxzNhmvqiY6GT2RXe27WMHWYwfFe5ajf3td8p14iwmJxv5j8	1406	1393	1	1	1203	jxGEtjhx6krmGqKN23TovSfjjLocamQGtBpmUmbnedjJCsyiNiX	669	928	928	1616106240000	canonical
1216	3NLnVedhmMBpXd2R6LGWY4dMJDEworZ4Y3i7T7Hr35WWSN5NXTmz	1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1503	1031	1	1	1204	jwUcbGgaFazwecsN7YRk1GP9PHpBBppNZkCNuL4vCJ175kewxn7	670	929	929	1616106420000	orphaned
1218	3NLnuKnb3mMPCCahgi3fNDzkXNzNSBTTFYBAYq83sCpyQjAtG6Fa	1215	3NKT1Fx7dJnNu6uzE9avyErphj7ri7EQHAZed5JeDg3Zs9Kc2Lkp	1555	1101	1	1	1206	jxa1MQmmSGDkFKKNHcMm82dfRKetZ4BrYTCRtY2nkDidXWuU6af	670	929	929	1616106420000	orphaned
1219	3NLwuHvciBeEWvuEqMsagU828qAvF3jBMxAptNFyvJ2DFRzqRiRn	1217	3NK4Bb83CNaUd3zU9rh238d9oVThm7M7mfX38D86xxbJ3mYciT3Y	1481	790	1	1	1207	jxTA7FJCTALkre8LjJgNnSxZZvUjrma3gZYaeieddGSNDGGM7yD	671	930	930	1616106600000	canonical
1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1220	3NLFQuDeREdH5WnXuegpVBa8KLNMSdLydBfrfiHc8SCBcicwyN8t	1455	1332	1	1	1209	jxCPPifx2LRxzQN8GRBZc9KFjaE3sYzmUUJM5hfmANFKpt7MjFo	673	933	933	1616107140000	canonical
1224	3NKm8BuFVmhBgq1rSFSCLUiwTHnhDQG8bBp7wDmke9QKanoGawLU	1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1471	1020	1	1	1212	jxG3ghVMAR5Sm221gXmz9vMD3pLkpLUfHHW4A3to5ja72yMJ3pd	674	936	936	1616107680000	canonical
1222	3NLZsCyRG24rznibzs92nugszt9EeZGfcF1GbuRRC7MJefz9GutC	1221	3NL49Wqbxpbz2JQLGHHkBXRjsjgEDTjY8VxYvgzghRJccDCvA47m	1407	1395	1	1	1210	jwWZKfnTL3YVTJdBqZJBqjh52stngiHXMsTVJbByyg2wpzK8Sak	674	936	936	1616107680000	orphaned
1225	3NKtctPtvdsJGdcYXh6wNpJwaTAYbVVLTaTjvkLyJGfDpvouqHXi	1224	3NKm8BuFVmhBgq1rSFSCLUiwTHnhDQG8bBp7wDmke9QKanoGawLU	1402	862	1	1	1213	jxeCzF3VNCsHub9QsMunFWjVtYnHPTAtwNJnbK2JKrQBKCQsHAQ	675	937	937	1616107860000	canonical
1227	3NKC99Z7ymewnLbrW7k8e5NNuwqkwbLenQAMZZsZC8pqomD1HPgP	1225	3NKtctPtvdsJGdcYXh6wNpJwaTAYbVVLTaTjvkLyJGfDpvouqHXi	1587	1231	1	1	1215	jxKRB8wCcurbA7d8rEw4HG5gQEffKEme5qRbkjnhyL1AmsEJHwE	676	938	938	1616108040000	canonical
1228	3NLAbccH5GLR1NyeSLCE1pt4KtbK5gp5HDdLdv1vYNSwUpfnnS7p	1227	3NKC99Z7ymewnLbrW7k8e5NNuwqkwbLenQAMZZsZC8pqomD1HPgP	1611	1341	1	1	1216	jwtQhuweA4thqng9P29KXmTrCb32h7Uyhss2s37C9XEftB2MirW	677	939	939	1616108220000	canonical
1231	3NL14RwMouSQenxPqZ9WxTpCC6jsmftVLzFoTfXtAjsHkSwKrMPU	1229	3NLqfvGbzMvahBm8P8osf555Ba3Bmvsqhk7u4KUBpxXN8KiH7KE1	1643	1299	1	1	1219	jx7hsrv6DZyJ9NyeUmK9Z9qjToKKu2DcPmPU9NaycPxeuzTktup	679	942	942	1616108760000	canonical
1230	3NKJSV8a6V35kWXSUa9UzX3qRWy6eL4GySy3VySDmy12sjaF9awc	1229	3NLqfvGbzMvahBm8P8osf555Ba3Bmvsqhk7u4KUBpxXN8KiH7KE1	311	1061	1	1	1218	jxr4FhPNJw745H2eYXEepKUq3YtJmAMZXW5CFYuMVQC23Gm4uB9	679	942	942	1616108760000	orphaned
1233	3NLKBySStPFcaA8SjVzUUN1aTy6WnWZ7PzZExWbmzgjKbN6tXWVa	1232	3NLd4wid7Ptv8zCs6W9zje6eeFR3yBJo4VZkZsaBh9xz8e7QV2jy	1648	918	1	1	1221	jy2L25YTqvQS1wiCj9gvxWLPyi1fa5BLrnP5NgYNrcuHsjQcZgG	681	944	944	1616109120000	canonical
1234	3NKgwunF69gUBVEGD7yYea2RsxSbQGoTwtK8THFGNABk1w8UqReL	1233	3NLKBySStPFcaA8SjVzUUN1aTy6WnWZ7PzZExWbmzgjKbN6tXWVa	1602	1123	1	1	1222	jwCXrPFJTzc6a7WLQbKVdAVo9Y21qaKNcEzc38hTxr1tsSXhCwZ	682	946	946	1616109480000	canonical
1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1235	3NKhNnVf7x8UXFKYampbEJvDRtbHRh2D24XFd6zkd41EskMferVo	1651	1175	1	1	1224	jxhqpyiG7xtJd9cD6fXK5rMhZ8jiNCdcxjV4Atqrs6G4ns9FrUD	684	948	948	1616109840000	canonical
1237	3NLVtJeU4Dj6xjiYmkouVv4X2uWYFCACSXnQsuK2acqYSF1aYgKW	1235	3NKhNnVf7x8UXFKYampbEJvDRtbHRh2D24XFd6zkd41EskMferVo	1651	1175	1	1	1224	jwqe5GnitcV1ezwbRzWDj9ReX75DysVYdEHz1dGS32kBXZPsqsR	684	948	948	1616109840000	orphaned
1240	3NL5Nd5gp9cPduqTSGevfGR8HZmmKmXoGphTxmhzjVov6kkJf9k4	1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1634	1205	1	1	1227	jwMf8Ug2SRvutCHmo5wez27TAdZ2HB476hdZJqJf5DrUr8nCadk	685	949	949	1616110020000	canonical
1239	3NKvCsM2f3eL72hQczQMqD5o2TTMBBxVsKx9etzB1dSET8PUgCtg	1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1406	1393	1	1	1226	jwFQ39zamBh5qufGsH5YPbZ2RocWAP4qfCaH3Sr7fVE9wNx4TxX	685	949	949	1616110020000	orphaned
1241	3NLfEJ7uYN3hTYswDgsSqW8jyb1KXGuexKfpN1voKJMPWGA2L7G6	1240	3NL5Nd5gp9cPduqTSGevfGR8HZmmKmXoGphTxmhzjVov6kkJf9k4	80	1273	1	1	1228	jx9SkwHV3XmWq4u7HPKsHzsQXxxhMLWdEbQH81oAGoGKJ5xb1Qz	686	950	950	1616110200000	canonical
1242	3NL1n7G596bLasjek9DKbNEnsisQGJWBZUqjJF2z8PiqrPHGd93P	1241	3NLfEJ7uYN3hTYswDgsSqW8jyb1KXGuexKfpN1voKJMPWGA2L7G6	1608	923	1	1	1229	jxQEdRekYgS2TPpRnsyoWdNZBRKB33yyxpnbwxbJu7sQo8mJ4u1	687	951	951	1616110380000	canonical
1243	3NKoVv265cQuzTH4XAUHKGpWY3h3KiJC9BLmvTu1byvBSLrPNLqU	1242	3NL1n7G596bLasjek9DKbNEnsisQGJWBZUqjJF2z8PiqrPHGd93P	1406	1393	1	1	1230	jwPJnaVguEGinAFMVw84yLYUYn7w9g9NCJtQjE26tchRaUyB6qg	688	952	952	1616110560000	canonical
1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1243	3NKoVv265cQuzTH4XAUHKGpWY3h3KiJC9BLmvTu1byvBSLrPNLqU	1407	1395	1	1	1231	jx3qxpFTQBDP33LCKHz7vhVw6rbFXJC2mLx4K5CLypWgX83zaZS	689	953	953	1616110740000	canonical
1246	3NLrzHBvxZhmpDQvN59uByc5hw5XHJgfT4VPMh7xgvAqMTpv8sia	1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1402	870	1	1	1233	jwWc3AH6xdYWJYvzGfRjHqb3YejcDE1nY8XK9xPLbYE3X5qrvQ7	690	954	954	1616110920000	canonical
1245	3NL1hyRh2nuQ3avzfTwYhyy98izmB9tvV8nz6dKhS8cPyccFHBVX	1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1577	1327	1	1	1232	jxJXunFYcp2MQuNswqmr3odtGMsyUbnFx7dzFU8U6LtdcfFCA6P	690	954	954	1616110920000	orphaned
1248	3NKH4vFVaAGeYVazXgGm7dz2NkJmZcDvAtSBqzws6vjDWv5M2iH8	1246	3NLrzHBvxZhmpDQvN59uByc5hw5XHJgfT4VPMh7xgvAqMTpv8sia	1534	1317	1	1	1235	jxNCJkshGn7aj6xtETfqBmc7vM8Myn7dg7Jz6C7JkJ3GqxqYTev	691	955	955	1616111100000	orphaned
1253	3NL8zNLWHSx8zCtwS6fbFg7qTAkwJJmtPoT1ktYS8j5iREwh1f7Y	1250	3NL1dJCBBfJ5WtpGKCXJfeWDhaxMHXEuDMuzmKJTNj7k99fwRR5g	1617	1288	1	1	1240	jwqnWyjb1dbrwb8G4B1mQt9hcBka6q4yHLBd8HtHMUS7MF41gNH	693	958	958	1616111640000	orphaned
7959	3NK5g92ipAeFxJmBjBY5nA5Xo6qQmjTTAA55Ldc8UZfq4pc1Jn6e	7932	3NKb6KSv7RmbChdyJ5wAzZcTzt2J23JuzDmCz5sSb7gpCnwfKJfJ	1439	1033	90	1	6301	jwk1exMMsKTGvLMGmzJzAbs8o3MBDoqDScY5vmXuWv3SiChNwvD	3998	5812	5812	1616985360000	orphaned
1265	3NKrhV84T2yA6synxjsjrBe9KRUQJHNKTSp2pNLnamwmfLfDsXEM	1242	3NL1n7G596bLasjek9DKbNEnsisQGJWBZUqjJF2z8PiqrPHGd93P	1553	776	1	1	1252	jxcYjAr9wPAnhKK8wLciR2r7bJPkhqjgcbd8VLt5FesjtVAyzDS	688	970	970	1616113800000	orphaned
1247	3NLW6RX9DrMFW52euKaUz2Hgk4nGusAiMqRjp6qmx7c49Lt8vibp	1244	3NK2zWZoM9WQUHUMULfjejjVaSxXyVsgaEY7dQVpUDqoxZfyh1A2	1611	1095	1	1	1234	jwHUVjEdvCV1tyUfLUEbKJ1cLRd3icw84U8Fk5LiWz6ZRhNnGSk	690	954	954	1616110920000	orphaned
1249	3NLs6gbSRMHJS6uX9kXinFj6DmFq2N8zwSK3RLzPQe99vPm6iUh3	1246	3NLrzHBvxZhmpDQvN59uByc5hw5XHJgfT4VPMh7xgvAqMTpv8sia	1585	1240	1	1	1236	jwRJwdk3FtVrNU9hpRNK21cx5mHVBBVCZ2iF4wFcFCNoaiv4yDn	691	955	955	1616111100000	canonical
1250	3NL1dJCBBfJ5WtpGKCXJfeWDhaxMHXEuDMuzmKJTNj7k99fwRR5g	1249	3NLs6gbSRMHJS6uX9kXinFj6DmFq2N8zwSK3RLzPQe99vPm6iUh3	1536	1313	1	1	1237	jwAi8SxfrbpkvvTZwoRr2AuPgcRqAK1Wz2atGWHMhcvmSifkCQr	692	956	956	1616111280000	canonical
1251	3NLkTGEeXt3pX6TN1DmjdaZjiqGcGrto4KGDupGDVnJKduRHBBN5	1249	3NLs6gbSRMHJS6uX9kXinFj6DmFq2N8zwSK3RLzPQe99vPm6iUh3	1407	1395	1	1	1238	jxSefmGUPdYxeJFNLMjignqCzRhJ3Ao3kMbbwJoHGcK3BeY9Hor	692	956	956	1616111280000	orphaned
1252	3NLntKuhrwwr3APQz9kJR2t2L3Ryn6CXcUwSaNb463pYh6cBpHW7	1250	3NL1dJCBBfJ5WtpGKCXJfeWDhaxMHXEuDMuzmKJTNj7k99fwRR5g	1407	1395	1	1	1239	jxChKfA38nfqXjNM7rG7LSHTWmXLvg7a56BqmwB8QzvYe8p1WqB	693	958	958	1616111640000	canonical
1256	3NK5Z6nRaqYg4211iCKSPXndWtZPv5Tbd9EbvJ9FCmKTbbKGkjWE	1252	3NLntKuhrwwr3APQz9kJR2t2L3Ryn6CXcUwSaNb463pYh6cBpHW7	1643	1053	1	1	1243	jxfBWsJbvDfMtFKGEtR34MzaKD5vGdDWDgVUUJT376LoHJNaqhk	694	959	959	1616111820000	canonical
1255	3NLpQ1BXQFKvFjqJkchT37yKjYz3b4tibJWiEhS4LYgWLiuKf5pj	1252	3NLntKuhrwwr3APQz9kJR2t2L3Ryn6CXcUwSaNb463pYh6cBpHW7	1589	1040	1	1	1242	jw7ywQJqXa9riAoseVmmYx89znzVCJLKTpduVvxR32i1HqqKUVD	694	959	959	1616111820000	orphaned
1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	1257	3NKbU3cMDzCGRidnXarMJiTBUWzQeNjQuBh1DNw1cyFHEzxBNN7x	1460	512	1	1	1245	jwLayhzYnqsivcc2WaXKZv9TSphNtpCi8xvWhQocab5PHKk85J8	696	964	964	1616112720000	canonical
1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	596	1306	1	1	1246	jxZuJoLCwCof4awM8YXHzXS2kycPADUtGPspnFX9UeyWHgtKupd	697	965	965	1616112900000	canonical
1260	3NLy9EReKkw66qLEFydHmdUBc9E1bMKASBqXMb6tgy5zoCz4sX62	1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	1407	1395	1	1	1247	jwsjuRECFs3jZYU99XcSKF1nZJvNZdeHrMiF9mSjodh8gUhJZjx	697	965	965	1616112900000	orphaned
1263	3NKvRNcVms4ydQpGe93x9D8mKHpnhr5Y2kC2QQcxauG94EEJ2nMK	1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	1581	778	1	1	1250	jwHpTmFDeXNkvXiYY3XD6EGXtnbR32aZm2t97t74YVCrQr1qyyk	698	969	969	1616113620000	canonical
1262	3NLrQGEm7bmqCojDTmmhjDormieSnozwhityLZhfouEgP91THKoU	1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	1483	1276	1	1	1249	jwein5VxKfwG5L6EoSJTpLb6j5JkuQDbUswdYqbMQAswUfQ1r8J	698	969	969	1616113620000	orphaned
1264	3NL3LQSsiMojQBKrVsVGywX8JnVBAFxzfpHsUzrYd7Rw4N7CdBiP	1259	3NKTn6vCA65HuoxPVDb9wgyxbg4nwvxd1oQuzNQezvNsw4dFJCDX	667	667	1	1	1251	jwNzF3ukkZ5XgewyzXdEb636eXZF8VaFtqmu1w6aDuZrMEjjv64	698	969	969	1616113620000	orphaned
1267	3NLU755ZSf6FPGSNiMNnmRnvchhVQEL92JoAbqAmX1ZzRReLfD41	1263	3NKvRNcVms4ydQpGe93x9D8mKHpnhr5Y2kC2QQcxauG94EEJ2nMK	1602	1123	1	1	1254	jx4gQHGrZAmAePyUH9SPL5rk9Ekf4Fnk5BGYo9DrP5wtmrxuZFs	699	972	972	1616114160000	canonical
1266	3NLX4CMBzWciygWpBfdJ2WieAhkS7AGiP8rXNVPRy3Uj359TVxsS	1263	3NKvRNcVms4ydQpGe93x9D8mKHpnhr5Y2kC2QQcxauG94EEJ2nMK	1637	816	1	1	1253	jwdFiw5qFBoqMhtrQ8DHjCwF5DfWnbQpEQzdWZnooxxkaCfQYio	699	972	972	1616114160000	orphaned
1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1267	3NLU755ZSf6FPGSNiMNnmRnvchhVQEL92JoAbqAmX1ZzRReLfD41	1578	1296	1	1	1255	jwtD4qSTwe4aBtJDyoQQgaAe3yVz7mMWmNgb7MfMsXg6EceVNgP	700	973	973	1616114340000	canonical
1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1523	955	1	1	1256	jxXWy96vuygDQ3Zy35zD5Px6fHz3AQ7qJdMEfa64DgkL4AXGd1E	701	974	974	1616114520000	canonical
1269	3NLhfNPxSmn2V6eK4ztj3pkh1jLmZNrAKDh4yXZd2SvMTreLaKKi	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1523	955	1	1	1256	jx6JnArSpNx7jfagiKBdHk81rVCGGNRWu3TtwjMKfhfS3xeVjKo	701	974	974	1616114520000	orphaned
1270	3NKqCpVcckTiGCkRfH2h3QFZY5gEeAMSRLhoC2QuDfBcWJCLDRQ2	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1523	955	1	1	1256	jwirERQFJKZuePJFTPHaiaRN6NQRr9UCmPdquoTVy1i29YhpCrJ	701	974	974	1616114520000	orphaned
1272	3NKiFmGkBEpmMtuijix2NMJJf3zriAE1ZtTm8kTSBhz4eKE5Y25r	1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	1654	1094	1	1	1257	jxvpC8VCpSsp1MfdNCHF6ZzNCHbHfvJgNCNyZiSfBvByKECRX26	702	975	975	1616114700000	canonical
1273	3NLDmuktU1PkiGq86doA2nLA3nmjZQV2aWmLRMnu5ujfFbwmVam9	1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	311	1307	1	1	1258	jwU4T5NUCGAbsd23hzXusgrfsJit6neXQfmc3FnZmQK6641Fgx9	702	975	975	1616114700000	orphaned
1274	3NK4BP9y6JTs97dctUJQkXyS7X8xDi6YfyUwiEPkHxnrW29nzpGY	1271	3NKuDgE9mcXqNDuSXzRwhAaWpefM4sHupwsoCFmT9RW4AmrYEsCG	632	1136	1	1	1259	jxSX6QdMENjU8ddpB5vEbH1V6jPocf4Az6LtvNXrqFZ686eTB8n	702	975	975	1616114700000	orphaned
1275	3NLrVkHpvD1WeE56cVpnj1RLWzWHxL18UTSBBdxZLz972X3KVbA4	1272	3NKiFmGkBEpmMtuijix2NMJJf3zriAE1ZtTm8kTSBhz4eKE5Y25r	1599	1041	1	1	1260	jx4BoAVVBfTriA5cbzFEWuXg449z6TLyyfTdj6BzL4xNz8jkurx	703	976	976	1616114880000	canonical
1276	3NKuqjK7D85KdEYv7wrYpLxEJa5f8soAhF3HkepZ82MeJV4c5YxM	1275	3NLrVkHpvD1WeE56cVpnj1RLWzWHxL18UTSBBdxZLz972X3KVbA4	1406	1393	1	1	1261	jx8DfmbcSWWgFwLcmoyUzWcnciXreRQNW9nmrnXsBHKtmPNmnEm	704	977	977	1616115060000	canonical
1279	3NK7icc4C5pJ2ECBTZjEUc1HsRmZzKsrvV1UszFJXMNGLyHYsSiR	1278	3NLSQ6fAepdmBTnkDnG8i8wKocDjm9HGpuLYZhKz7sYB81yrTzXC	1617	1288	1	1	1264	jxKUCErMAvgsAQVvhSVvbTYqzYwCd27XqkqEaA3sWYiriwQZtPk	706	979	979	1616115420000	canonical
1286	3NKTCpD3pf9FwxVHqac7rkvm1AAX1VyhWGa8cFRpcajxnwrvoiuh	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1439	488	1	1	1271	jwHWEJk4MhkyBdshoGPmSaSu8QZH4Ryj3gzr2FHZ7vqH13PSXhw	709	982	982	1616115960000	canonical
1282	3NLXS9xuDuyjJ2ByxgCrChv8u86qu6RVmN7Sh54c7hsxJ59oLQBq	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1407	1395	1	1	1267	jxehgGWkKS6eM4hWsmTzHC27H5JFvmybqktRGNdYbmsbhdxgtrX	709	982	982	1616115960000	orphaned
1285	3NKv3ppWVL4J8c8yMbn7i1CNYS4htpa8tb1vT7sY1EsN34QV1CCz	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1451	926	1	1	1270	jxCWG9hA9nokj2DAw6TFack3pAQdSBNvnmoEKXHJmvQAykEvoFe	709	982	982	1616115960000	orphaned
7999	3NL1y19P8G1dPvGjuJsVu7s6Pq1J75KrMqHpAFNf4gtUjAJ4yMTD	7722	3NLJm1eZzJjd9EzprsinymXRRURnGx95Me2iJAe1L1bK8AcfC89p	1523	1321	89	1	6301	jx2dqMk5MRxfUATS8x6KQYXNQGPzdrdTHGvXpQp1nH3T1ve42xb	4000	5853	5853	1616992740000	orphaned
1334	3NLf9jELRcUTdGxTNCx77HLVPvKVnJ3KZHAeyKp8FLWmLkN5FcYL	1265	3NKrhV84T2yA6synxjsjrBe9KRUQJHNKTSp2pNLnamwmfLfDsXEM	1553	776	1	1	1319	jwEGFsXRep4yaaD3KZm8fQ2UA27YVfVdkh5ct6p63jczjB84o6W	689	1020	1020	1616122800000	orphaned
1307	3NKwn5Bf33aw3Z4jqBHgrBv29mm6cbQVhoRkquZRZUzvBfoxJZtS	1268	3NLCf4WzfVV1iBtNrE463FV52CQSJk2dXP6dRRWDGjKzGSbz6h9B	1406	1393	1	1	1292	jxwLRU3CR3Vr8Q3zzxxjTB865nA4QZQdUZHTiH42aghRtLnyRcM	701	1000	1000	1616119232768	orphaned
1277	3NKH4NLAVTKE59P3ZHutBrgK95otJeLoWqtteBzRWWgnGaD2D9L9	1276	3NKuqjK7D85KdEYv7wrYpLxEJa5f8soAhF3HkepZ82MeJV4c5YxM	1588	1146	1	1	1262	jwgZ5ff3JJWVVAAJKNJNPRRNoaMhVomyi8bpm2uZpJ4iy1ACfTF	705	978	978	1616115240000	orphaned
1280	3NLuT8YFJKyrXWu3Bjz2xgQwQh5DSMeuKP2weGtKWUd9TNhF6Y2f	1279	3NK7icc4C5pJ2ECBTZjEUc1HsRmZzKsrvV1UszFJXMNGLyHYsSiR	1549	1362	1	1	1265	jxEc2nd8ueM9WayBA6rn991jarzt14tikHK9x6b9qPfjhSgvjPJ	707	980	980	1616115600000	canonical
1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1280	3NLuT8YFJKyrXWu3Bjz2xgQwQh5DSMeuKP2weGtKWUd9TNhF6Y2f	1637	816	1	1	1266	jwUJm9BSE49bWdMB1R9WFLVxJGacsbez7u6BHPtaXTXyso5xmYu	708	981	981	1616115780000	canonical
1283	3NLsQp94vmp9YGRnPa6aXdonV16yUdS62KjygT3tJUXNmFgpZD8W	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1403	824	1	1	1268	jwKpazRYsZd2RiSJeyZZwtMoGVyjUnnsX2kkD8g2SNukeLgPTeH	709	982	982	1616115960000	orphaned
1287	3NLcJmkqthwi6mACvbbTKQp6Lc1JAxmxXu85MM9aw3s9nKrbyJWv	1286	3NKTCpD3pf9FwxVHqac7rkvm1AAX1VyhWGa8cFRpcajxnwrvoiuh	1522	1076	1	1	1272	jxhVXvx2dwgWSNVfR9tKn5XEExYzJL28AnALTCmwUG8k3V9DzjS	710	983	983	1616116140000	canonical
1291	3NLFQ2iqNgr8FBnpphaTZKeYgwrfwih9a196i8XfB2B41b674UiU	1289	3NKZRdQMddy3SdNqVC765hurcryRCiD18EJuNqmeVNvxjrjnx7WU	1657	1344	1	1	1276	jy1TLKCDaDX7TUkhaCMFmpxexCCoMvagNxEZSCXwLy2Rxx67BHJ	713	987	987	1616116860000	canonical
1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1293	3NKnEMpydQaRHUy8upuRmVtuZ7es1zKsVoTpv2vLcVL5hzcFgDLQ	1405	851	1	1	1280	jxcnVCvpNNZ779WT64EGYXJFeTBeffcyK5KwkjwxjbydgL8BQdG	715	989	989	1616117220000	canonical
1297	3NLduXMq5fKakNMNKrQ2padHY4CjP3r9c1zMoqJuhT6xYgpy3grn	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1534	951	1	1	1282	jxnrPMtZALWNm2ZVh8C1L971aW3kMYV8TWf2PPeeiyA2yNwxktk	716	993	993	1616117940000	orphaned
1301	3NLd2ugTX8YroUA9LxmuxZzhSpwinhpYm4cVuiMcRUSuNt7AqHcq	1299	3NLxx365SqHPxoz4njgA7V2kgW13HtLX7oQ4BG7BHZ5DMvr3ALbv	1402	862	1	1	1286	jxH1E2oUUEpgwJixpytQCoXGYYEj4b7jKJWypgpQnf5LdsLHP8k	717	994	994	1616118120000	canonical
1304	3NLLLTp8Ffy8djHbcHLmcKWWmB6ZErNHuxisvFe3HnjqYRxhqooj	1303	3NLYdY5g9XxsGdWALiAaVxSiccor8pXKuJUTz1caGA1mWXecxzZs	1534	129	1	1	1289	jwcNqEc1Djs3j66vviaF9SwqtaShjEoKLf7WNj6BByxZkqWpGhr	719	997	997	1616118660000	canonical
1310	3NKQE8wQ41YQiyvuCHfg9ktDK97hFiKNAx39VLWkxkJkNhrryzAv	1306	3NLi6D8kn199rYjBQXi2cEsRszva4kffcGVzSnSArnGn8vNBKQzw	1402	882	1	1	1295	jxSD7MhC7dyE5WVbaPy8C5heMSgyJNeCuuzAFTQayDx8BAsW7uh	722	1001	1001	1616119380000	orphaned
1313	3NKR9ofJLUd1YwWSV9wAoFKa7HaS66po48P9NJtyhGKfZdtbVtB5	1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	470	1063	1	1	1298	jxFcSfwJRvfwqVxN1FeZ9guA6BAUyU9sr6PRXWRqWgDEmJXp37D	724	1003	1003	1616119740000	canonical
1315	3NK8Cm12tNKXzJxaeNEk4payBFpCnXYHR8ZEEEKs7XY3HaEit2uD	1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	1646	1354	1	1	1300	jxuKJxHsGLf2qpsdv9H3At1qXuja45mDiAUyqKKcshMceWkVY3n	724	1003	1003	1616119740000	orphaned
1316	3NKMtreV2aiMudr1uZu4sbpo1UYVDDgpgasLymdFxXTHm2NuegFi	1313	3NKR9ofJLUd1YwWSV9wAoFKa7HaS66po48P9NJtyhGKfZdtbVtB5	1406	1393	1	1	1301	jx9ZRTN8FB3VYseCHjyHs6ftmNbycUK4f7wUwCLdXnx1zbHH6nD	725	1004	1004	1616119920000	orphaned
1321	3NLqXbKFNxAiyoMPhfdW7QQaoZHgvNrtatyHKWUcLjuhnadkmWsG	1319	3NLAXab2hzv1e9JmU2cHohgy2dwS6r3EQxCNti1kiaEFNhyHs3ad	1489	1380	1	1	1306	jxQLiZYYryKyqtySv192ENUZR8bDYzQ54P2Fohri8h8smMa4Zkw	727	1010	1010	1616121000000	orphaned
1325	3NKD4Vaijrpt8Jw7hkxyeivbbPBdnK9n6w43hVro9wA2dhPxnR5d	1320	3NL5FQcuBvVPACd4gFGrg7ejrPQCJqgvHXAVvU5maBv9WJRp9ki3	1581	778	1	1	1310	jwLnRUGSd7LApi83t7h5PkyUMpvFpLwLnmu12kYLrZ1nFGfEzVe	728	1012	1012	1616121360000	orphaned
1328	3NKfLnV1nA65YAADGpqynYXtBfWor41MN73xakLcpQ8BcsSPjF24	1327	3NKYthamwfaaHMq44nM95PGD5kEYbdRBSkvZk2qvSYzvify7Lnz7	1596	1363	1	1	1313	jy3GvcuL86rB8K5ByPAdyJ3qekCUiptysJtPd7SReFifRdVjhh3	731	1017	1017	1616122260000	orphaned
1335	3NKFHSirLSazsH4QxdATsBQP6DPEH4C6dHXW7kYhKQq2uLKiXFVD	1332	3NKRFa4gTmxjBeVSToGfP1MW1EtvicQNmXca6XSYnfSG6ynZuo5X	80	1147	1	1	1320	jwnzXhtDRzLGgEpgXMHx9cNw4VHU59Vzhbf1ZYTAtx4UruE3PKy	734	1021	1021	1616122980000	canonical
1337	3NLLdmDgEXotWAZyeozF3cJxDMzCf8k4xQXRtG5HyJsKDBiw4vXM	1335	3NKFHSirLSazsH4QxdATsBQP6DPEH4C6dHXW7kYhKQq2uLKiXFVD	152	964	1	1	1322	jwVrtRXjw1Po8A75HDfARQcXQfxJRJvcphy3uvNjxNN28hkgxMv	735	1022	1022	1616123160000	orphaned
1340	3NLcwS9NFwzNRobkVuhKkEvgiZFmduuMny9h5pGVhyfrTDEGKKMA	1336	3NKYM9k9tQbD2qHFkEFvLkzwniVkHJktVnRbnkmuHHQArvxq4UNB	1534	1317	1	1	1325	jxt9srdb2RLmvoNRrGMgYbVac11Hy1dvtKdCWKvbVNcajvm1qnT	736	1023	1023	1616123340000	canonical
1338	3NKLgB339kGkearrPTEbavonqiWj5HNrhdnRJDRmshU9UQX5Ed9V	1336	3NKYM9k9tQbD2qHFkEFvLkzwniVkHJktVnRbnkmuHHQArvxq4UNB	1406	1393	1	1	1323	jwgAufgJa3ZwLLp7D4C5wP8yVHFvzhPJTPzZkV2airRq5aqEp4K	736	1023	1023	1616123340000	orphaned
1341	3NKKkniTUwAfiWcbfq4MYZwgVhesabBGtEDoF1TZhxZ9i65uzN62	1340	3NLcwS9NFwzNRobkVuhKkEvgiZFmduuMny9h5pGVhyfrTDEGKKMA	563	1113	1	1	1326	jwKTyLjwtmntKnvZR9qHM64XjHYzhZy1VDVogV1L8k49eQ1uoPi	737	1024	1024	1616123520000	canonical
1342	3NLwnTNdGzBF7kWYfv8tpsyk6ctYMsdozpvKkpcwCr7mizEhsoHg	1341	3NKKkniTUwAfiWcbfq4MYZwgVhesabBGtEDoF1TZhxZ9i65uzN62	1599	1287	1	1	1327	jwVZp3xM2TtjYazZJTa9dLhDHjyE9mg6GtiLF515CbnHB1DGU5W	738	1025	1025	1616123700000	canonical
1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	1342	3NLwnTNdGzBF7kWYfv8tpsyk6ctYMsdozpvKkpcwCr7mizEhsoHg	1581	778	1	1	1330	jxmLKp52XwY1WMTa8QYse6zAUdb4NRxuNcaYFTzckS8vC6ndfjz	739	1026	1026	1616123880000	canonical
1347	3NLUmYLCmSMH4xHgLkfxwc99oBip8CP9tCcL4oz267zKx45a1CjD	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	532	1057	1	1	1332	jxQ3nzKpAnMMNErews15KfLM8eNfj8zN2chcuVKehTSMtUZGsMx	740	1027	1027	1616124060000	orphaned
1351	3NKq5hrhJ9jqBSzsv9n9zLApgormnDic1P5f2CrgCi3T3fqNVz1u	1348	3NKboqB9Jtd3GPnbqHhRS9H5WuL7rk5F7M3AzS3pEDHrtyHvqtmZ	576	989	1	1	1334	jxwiBq5QfHb2UvtGTLNffQCdGTyrG41KNgNZ35YuwegTSnn24ax	741	1028	1028	1616124240000	canonical
1354	3NLuZ6x9bqyFAeTr1dFpsECqnDbN525HaZg543SC2w2neu4UMp8n	1352	3NKMQCD4ZY4BV7MygztJ2UUsaTQeABF9smLLKNNDjJYYg1Zs4wEb	1439	1279	1	1	1337	jwFiNXJrww6K2cuqZrcccLBrfQdNFzmELcMTwHRgDrbHYzpfR4a	743	1031	1031	1616124780000	orphaned
7726	3NLCJtgusq162pidHAnvJAUxySvPNpZjwCVJkDYRFis1DPVdZTHH	7725	3NKv57G44Ao1XY9HazAWDy1fueBecRvkwzv9uCxe7nt4BhMCs1B9	1657	1344	89	1	6301	jxZJgh7pFVGrpscquTsLCYTTJTgFCpVusFxbKMvhVchGozMJ8Ao	4002	5651	5651	1616956380000	canonical
1339	3NKW7mCe6krWJBZjFgxx61KHjNttrMMruA52CvJ4mzVWwwx93XMM	1334	3NLf9jELRcUTdGxTNCx77HLVPvKVnJ3KZHAeyKp8FLWmLkN5FcYL	1553	776	1	1	1324	jxQHaDmrJL9bm1VNm65sAnwvsCwadFtKNcwqdWatFFAXy8aFAjo	690	1023	1023	1616123340000	orphaned
1344	3NKi87Lufs29upngFT9onRfUtC6DWcNHLaTkCeXAMdPUSZE6rh3x	1339	3NKW7mCe6krWJBZjFgxx61KHjNttrMMruA52CvJ4mzVWwwx93XMM	1553	776	1	1	1329	jx24eBdp4NWt8pWpGv2xckUfNckTVhZdos8pvkF1Egf3tF4APD8	691	1026	1026	1616123880000	orphaned
1278	3NLSQ6fAepdmBTnkDnG8i8wKocDjm9HGpuLYZhKz7sYB81yrTzXC	1276	3NKuqjK7D85KdEYv7wrYpLxEJa5f8soAhF3HkepZ82MeJV4c5YxM	1549	1362	1	1	1263	jwKE8zeSPghCQQEw3Gc9BbCFgZBMm6t1vPR87t1CWWKn12QqciS	705	978	978	1616115240000	canonical
1284	3NLAz1pZLhYe2fQUq6Z49n8AAe7NQW8wqebULkjeKyaU7yUGp9j2	1281	3NLhgmTcfro5j29qQBfJkTJaWLnbET7WjVR2urt2c6RqYjfdNz6e	1406	1393	1	1	1269	jxtVABd7C8HW2KmtQAmUKxcGKv9hNwzwn4C3ZHZDnmYHSy4YFmL	709	982	982	1616115960000	orphaned
1288	3NLQio2PzEwtCFKfJ9jnJthDwHgABSPrMWMLsiCndPYbDdFPVbAm	1287	3NLcJmkqthwi6mACvbbTKQp6Lc1JAxmxXu85MM9aw3s9nKrbyJWv	1445	1164	1	1	1273	jwFGRhj7V5wxWSFhRNfE83Y3vjfa8PNajAAGmC9qGSAGYpfkeqg	711	985	985	1616116500000	canonical
1289	3NKZRdQMddy3SdNqVC765hurcryRCiD18EJuNqmeVNvxjrjnx7WU	1288	3NLQio2PzEwtCFKfJ9jnJthDwHgABSPrMWMLsiCndPYbDdFPVbAm	1407	1395	1	1	1274	jxziGdvSHGZv4ta51Gw7arW8wW5pMv7J4h5rS9DAThjFCicQo6G	712	986	986	1616116680000	canonical
1290	3NK9iNSoo5VZMwJLN7szLNMudhEcQmU8RNib8bcvaNAMM9Qb95q8	1288	3NLQio2PzEwtCFKfJ9jnJthDwHgABSPrMWMLsiCndPYbDdFPVbAm	42	1361	1	1	1275	jwzFem5PRStuxZ5AnzBBR2RXubbJTdhAYD3fb5Nwgnk948hWSr8	712	986	986	1616116680000	orphaned
1292	3NLHn4FihCDpEW5Zxzo13cDFHP5M8FSdGA5SMpvGphGd4qpVNRBF	1289	3NKZRdQMddy3SdNqVC765hurcryRCiD18EJuNqmeVNvxjrjnx7WU	1650	1129	1	1	1277	jx44S6msXD5GafkwfpeUz2NFH4daEwTuGoHtom2M3GLKz38aDsp	713	987	987	1616116860000	orphaned
1299	3NLxx365SqHPxoz4njgA7V2kgW13HtLX7oQ4BG7BHZ5DMvr3ALbv	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1407	1395	1	1	1284	jw6mCthnVVRs5zP4bDre1Vmy9ktMM794Jc5yUqJWmXn2tX76uRR	716	993	993	1616117940000	canonical
1296	3NLvVDNh9vqwRZf27gn8smoo7LgyK3BBHCgnAKMjzEmaXCbD63Ze	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	1406	1393	1	1	1281	jxiUVaTPbrAfqi3CmXdZBPfjaFA1WnJxAcUEruGT6Qc9Q5gyCDt	716	993	993	1616117940000	orphaned
1309	3NLCGHKwxZoGPG4w6mTgKcQDipAxoCYNBNibxtSaBt3Jamfxwgjk	1301	3NLd2ugTX8YroUA9LxmuxZzhSpwinhpYm4cVuiMcRUSuNt7AqHcq	1406	1393	1	1	1294	jxyKLJFmDweC5zXqjnWp4vDq41hB4NzzZwn9YMP4pSvtoSHakHj	718	1000	1000	1616119265840	orphaned
1305	3NKci5pqYruc9a11SUkEv8HtEPN8SvofLyiVbtcuoqDVZ6HvJLXP	1304	3NLLLTp8Ffy8djHbcHLmcKWWmB6ZErNHuxisvFe3HnjqYRxhqooj	298	1062	1	1	1290	jxQtmbyNqKizJupUaqBV9shmWRtwjNNUttVSwzs2GhrSgcSVBXX	720	998	998	1616118840000	canonical
1306	3NLi6D8kn199rYjBQXi2cEsRszva4kffcGVzSnSArnGn8vNBKQzw	1305	3NKci5pqYruc9a11SUkEv8HtEPN8SvofLyiVbtcuoqDVZ6HvJLXP	1649	1137	1	1	1291	jwCj1PQEudNKymuKBsdPFWDNE4zrmB1uWfBaSzrW5Waa2fsHRTV	721	1000	1000	1616119200000	canonical
1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	1311	3NLV244uLfHQnuLgU4zt6ZEECJuNJjForu8rNdq8X6cKvET4uxpb	1609	1207	1	1	1297	jwTd6CyNTuHS8bRMBHokpULPnSy4mjZJpYqHUgQVpnU86Scowhj	723	1002	1002	1616119560000	canonical
1314	3NLmoxm4udaGf1F6zqeUh1EFGGqir18e3WGbS4z2osmRJ1yKSrwU	1312	3NK8L3y6PkfZt3FTRiU7mWr1yt5j5JwYTh4BxB3NtXvuS169L1d2	1546	1339	1	1	1299	jxf93wZwftM2LJMdVqj97PiCVPQhB6aWbnhe9aVpG6QrwMDuiz2	724	1003	1003	1616119740000	orphaned
1318	3NLtiizQV5iyhpUtyeYYSHC739QQycudtMQKZn6mzmbWSHacTvKy	1317	3NK5kSUeDr7D9XxTgCh5EVvunvwttpwaeVzfiVaDbLKb4KbDfby5	1627	1385	1	1	1303	jxMYgBKqXjZxtvrLohDpjSLnHZzYNepDAAt8oq6TPCzQEJnKb3s	726	1005	1005	1616120100000	orphaned
1324	3NL81hXC62JZDwod4rE4VikZ1mrcHJKBXzj767kgxzuBGmDZQHsZ	1320	3NL5FQcuBvVPACd4gFGrg7ejrPQCJqgvHXAVvU5maBv9WJRp9ki3	1542	1304	1	1	1309	jwja952tgPw2LLxxgY6X12StfFXBVa6cfbgx2tEVkLTypx8nVbC	728	1012	1012	1616121360000	canonical
1327	3NKYthamwfaaHMq44nM95PGD5kEYbdRBSkvZk2qvSYzvify7Lnz7	1326	3NKjyv4h5wQkgVu1RW1KewzFVLuEbttFc5KyUxHpdECTA5owDuBE	1559	987	1	1	1312	jwEKvi3tkEAj1EFiNtoSTKVBuD9eP4HxyAhkRt4fK98kmC16JbB	730	1016	1016	1616122080000	canonical
1330	3NKFFu4SBzuQu1bBD3Ve6Lcof9YVxgd5H9xX4JbWhGdodsPT3Lm1	1329	3NKuGaPH6iczto8eywfQhwgWtYJZpfwZnCbseX41Jag475mxfMa1	1527	1167	1	1	1315	jxUgR2UoV4M8zfnMjuG38QV5gi3qNc5i6K7aQQvJVgwwfR2Mmpj	732	1018	1018	1616122440000	canonical
1333	3NLpFUAmT35sfJgaqsewpG8u93XhpjK6DTrQVkNBPA7hfocSn2M2	1330	3NKFFu4SBzuQu1bBD3Ve6Lcof9YVxgd5H9xX4JbWhGdodsPT3Lm1	1581	778	1	1	1318	jy2uxDUfCatH4RfyDNhydJ7iNJxhQb4RzhHpQ9isZ5oZvNkYihc	733	1019	1019	1616122620000	orphaned
1336	3NKYM9k9tQbD2qHFkEFvLkzwniVkHJktVnRbnkmuHHQArvxq4UNB	1335	3NKFHSirLSazsH4QxdATsBQP6DPEH4C6dHXW7kYhKQq2uLKiXFVD	1406	1393	1	1	1321	jwsLuzt5Zdk9gia34hNHV4HGk71qajHnBD23ZZzkRJ58S3PJcmS	735	1022	1022	1616123160000	canonical
1349	3NLo96AYY3CnPARwbcxWmtfodSWKtXpWhkCrEHkKGrqZY8w8f6Vy	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	532	1057	1	1	1332	jxQ3nzKpAnMMNErews15KfLM8eNfj8zN2chcuVKehTSMtUZGsMx	740	1027	1027	1616124060000	orphaned
1353	3NLC5HC4DSWfzzRGgksBCPDhhphrpqBmceC5AkosDLTRcZoCW1zj	1351	3NKq5hrhJ9jqBSzsv9n9zLApgormnDic1P5f2CrgCi3T3fqNVz1u	1573	1192	1	1	1336	jxYRpCQnV7kMFgmXrpfKbgdXC6qhkv9ELK4zUMRk1Xiw4MkjPDU	742	1029	1029	1616124420000	orphaned
1355	3NLihEe6Md3nkpgpnoEcGhMon1yPGDHtrPehaaLRLLwe6DtygvMT	1352	3NKMQCD4ZY4BV7MygztJ2UUsaTQeABF9smLLKNNDjJYYg1Zs4wEb	1407	1395	1	1	1338	jwFpPHnRf55DJT8YWQSMq1MaFVdDxoLoX4FTf3n4gdgLncgzrce	743	1031	1031	1616124780000	canonical
1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	1355	3NLihEe6Md3nkpgpnoEcGhMon1yPGDHtrPehaaLRLLwe6DtygvMT	1402	890	1	1	1339	jwB6pZcA7j4NEDZyk3Q8dJEM8QArZT1n8KPZDnRzxBQYT2rjH3w	744	1034	1034	1616125320000	canonical
1357	3NKm6vtFZXrq2XaGVwG1LM1VuDqDVowGGGjHWQ3wvpe7ZBbn67sa	1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	1406	1393	1	1	1340	jxEfurfP1cUuQMmFAdYWoz6QwfbAt8WTpTzd4ShAC4SfaJQzZeK	745	1035	1035	1616125500000	orphaned
1360	3NLPg1TJghuUuUQQctW5BJeafkdgzQVWw3tdhdRVs9QPvdPD8eQK	1358	3NLscym5EpK5qZKpvrEBYcmyw51u7113rkZtN2sxsNY1XBwixdVR	1407	1395	1	1	1343	jwYnXU4iQfHgxr6HcBCJVaStA2KgJvnfAyYvVpZzYXRi3ozu3Dg	746	1036	1036	1616125680000	orphaned
1367	3NLDMFwWWQNTkuZEqxMwFGxPvs2L85zRvT4G874CGjDwTzHML1pC	1365	3NLw1Hn4J1AdRC63JhcemAn9qy2atwHLx7H1iEKaLdhkvhQKDz9v	633	1258	1	1	1350	jwyvM6Tfw6PnpmYjLNzxj5WFhzvzmzFr88BF49EwGwCxqFXphSS	749	1039	1039	1616126220000	orphaned
1368	3NKiNxvbkmudgmwXLP65ghGJ3yVZ8xVDykZsvxiMxnRNaLqrtWMq	1366	3NLJ5qkqgKMznmUjmqTNTUZeonXQKZjqWuoCQGdc8iAH5b2NDnMj	1406	1393	1	1	1351	jxRpu89uTiMWNiqJoCuQcpVxVXhh3kHy4bTRhEBY5nhcWjphS6a	750	1040	1040	1616126400000	orphaned
7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	7741	3NKeFeaLs1qp1n9aoebBLNqst3HpVULix1r5A66HtFc3Dm45NEw3	1407	1395	89	1	6301	jx1obrfdK5zczX6bKZ8YkezJRq1PENhCA6SYbTRCdvpgsaJbSEN	4013	5667	5667	1616959260000	canonical
1380	3NKbvJjvzXUFCeB2qjGNn9VsGhnN8nfjVuGXM81g8QtcVYfnXHVS	1344	3NKi87Lufs29upngFT9onRfUtC6DWcNHLaTkCeXAMdPUSZE6rh3x	1553	776	1	1	1363	jxTWuhC2c7oajufvrSKHHuNWPNKeFEygU6fQMyKx3enrjcumgae	692	1050	1050	1616128200000	orphaned
1300	3NKfhYpfKqREsyTQsmRRoA2yMobKLWu3wrxZLy1tLg3G7evgPSxU	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	532	1057	1	1	1285	jwNvpaEZuU8mmHQ9rGymYs7W2X7RY3evR6fDyxcvFiKinNjWVZm	716	993	993	1616117940000	orphaned
1302	3NLH4wGkMwhXMnqqVdShurGckiTS4x7Me6NUcuwL1t9HHC1QTDQS	1299	3NLxx365SqHPxoz4njgA7V2kgW13HtLX7oQ4BG7BHZ5DMvr3ALbv	1610	948	1	1	1287	jwurctDRio8K1JRwDcEcEbQVMnrYGgSEXhuRSAAcaRaKs8wNzLK	717	994	994	1616118120000	orphaned
1303	3NLYdY5g9XxsGdWALiAaVxSiccor8pXKuJUTz1caGA1mWXecxzZs	1301	3NLd2ugTX8YroUA9LxmuxZzhSpwinhpYm4cVuiMcRUSuNt7AqHcq	596	1060	1	1	1288	jwVc2SbnGfxseY9yysNh6mrcM4xFiqxkHmzmWDbKcnKFKStP18x	718	996	996	1616118480000	canonical
1311	3NLV244uLfHQnuLgU4zt6ZEECJuNJjForu8rNdq8X6cKvET4uxpb	1306	3NLi6D8kn199rYjBQXi2cEsRszva4kffcGVzSnSArnGn8vNBKQzw	1634	1331	1	1	1296	jwPjposmrWH6pRPqiFirpdajcicLWMngmGaXVbx6KB66Nzakty5	722	1001	1001	1616119380000	canonical
1317	3NK5kSUeDr7D9XxTgCh5EVvunvwttpwaeVzfiVaDbLKb4KbDfby5	1313	3NKR9ofJLUd1YwWSV9wAoFKa7HaS66po48P9NJtyhGKfZdtbVtB5	1403	824	1	1	1302	jwPrPFDcwveJw3fPEpqVvo7rANaJcAoisysEpLn4tsb6jMYdQLb	725	1004	1004	1616119920000	canonical
1319	3NLAXab2hzv1e9JmU2cHohgy2dwS6r3EQxCNti1kiaEFNhyHs3ad	1317	3NK5kSUeDr7D9XxTgCh5EVvunvwttpwaeVzfiVaDbLKb4KbDfby5	1637	816	1	1	1304	jwwiphXKKkLsQxpzY2wxPSpUTmaYG8WE2RtfmMac2NxuoeTozBF	726	1005	1005	1616120100000	canonical
1320	3NL5FQcuBvVPACd4gFGrg7ejrPQCJqgvHXAVvU5maBv9WJRp9ki3	1319	3NLAXab2hzv1e9JmU2cHohgy2dwS6r3EQxCNti1kiaEFNhyHs3ad	1516	1294	1	1	1305	jxP8kwbakiQJWsABTPwAe1h51eRKcM192GUUUhjcxjHZmiKNuvx	727	1010	1010	1616121000000	canonical
1329	3NKuGaPH6iczto8eywfQhwgWtYJZpfwZnCbseX41Jag475mxfMa1	1327	3NKYthamwfaaHMq44nM95PGD5kEYbdRBSkvZk2qvSYzvify7Lnz7	1581	778	1	1	1314	jwdC4VpQerBr5EfDXECpCqDshwF7VP2jwvM31qUSMSBpLT5QoNc	731	1017	1017	1616122260000	canonical
1331	3NLmiH1VxiDhHce7iYaEmWUwfgNmY3pjkGma89MhWE8hgDxq9gVs	1329	3NKuGaPH6iczto8eywfQhwgWtYJZpfwZnCbseX41Jag475mxfMa1	1610	1314	1	1	1316	jxwqABw9dAK4Ye96MTso6aABApit75rDqzJ6B4NU5KmxvbSgxuq	732	1018	1018	1616122440000	orphaned
1332	3NKRFa4gTmxjBeVSToGfP1MW1EtvicQNmXca6XSYnfSG6ynZuo5X	1330	3NKFFu4SBzuQu1bBD3Ve6Lcof9YVxgd5H9xX4JbWhGdodsPT3Lm1	1637	816	1	1	1317	jwSBE7RtwqZczST1Avg6JzuBcLe9vUB6edzFamzAQJAD48x3cnc	733	1019	1019	1616122620000	canonical
1343	3NKP6ZKtmbAqmocYUgVQv2VyGopsFLfEZUV2YmNBvjFCg2JrpK8L	1342	3NLwnTNdGzBF7kWYfv8tpsyk6ctYMsdozpvKkpcwCr7mizEhsoHg	1503	1031	1	1	1328	jwrPupFk7TLptwWnPWrbMLzKdDpqBENhyEf9EiqMtpDtxwAnJ5j	739	1026	1026	1616123880000	orphaned
1348	3NKboqB9Jtd3GPnbqHhRS9H5WuL7rk5F7M3AzS3pEDHrtyHvqtmZ	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	1448	1311	1	1	1333	jwbV5s6xxcRTwmQBxsakvvBYsQHB5Tj9ZjCta4kosEA5hJKZPK9	740	1027	1027	1616124060000	canonical
1346	3NKZKYJGjtXZbVbH9WLdBtvhrMDGLs6W2CmWnmC9PbQYAK6dpaUW	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	1422	1337	1	1	1331	jwsEXYKfVWxBPdr1bkePY2jpqS8jSyRHhwti2knW3H3nNfk52uo	740	1027	1027	1616124060000	orphaned
1352	3NKMQCD4ZY4BV7MygztJ2UUsaTQeABF9smLLKNNDjJYYg1Zs4wEb	1351	3NKq5hrhJ9jqBSzsv9n9zLApgormnDic1P5f2CrgCi3T3fqNVz1u	1549	1362	1	1	1335	jwxwT2zqnptW3mnkHc8goQfqCnG924MKZcmUgn8EaDuAKw5cg3G	742	1029	1029	1616124420000	canonical
1358	3NLscym5EpK5qZKpvrEBYcmyw51u7113rkZtN2sxsNY1XBwixdVR	1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	1407	1395	1	1	1341	jwueWVgFowc5jwZ8Z76whQn5KG49fyQfBcrA9zuVt1iPMknP5oP	745	1035	1035	1616125500000	canonical
1359	3NLMySFebRZ6BLYpx7U6dkMqWksGE9S9AVmmo7WvZmwkRMi71SH3	1356	3NLtG1iPHzYYcnwYBqRKw5Fcqw1Nr3cSYBmfFXqB3maTGj8G92YL	58	1281	1	1	1342	jwg6BeeMQxRQUSiw8kBs6YwU23qExv5yghfrPuZnXj4EYwLcBYn	745	1035	1035	1616125500000	orphaned
1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	1358	3NLscym5EpK5qZKpvrEBYcmyw51u7113rkZtN2sxsNY1XBwixdVR	311	1061	1	1	1344	jx9Dh8P9YtzBUpMGZmNeDr81oxhisy4AKzGbdXd2YCWDBwnD3XF	746	1036	1036	1616125680000	canonical
1362	3NKR12UdeLLD3z91B7bDML98Zt31vjhHukQGtgq4pPoqAcF77nNq	1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	1406	1393	1	1	1345	jwKPAJQfcB18L9w1GTjfgyccq6AYq5uYojMFACactzm9S1A9gv7	747	1037	1037	1616125860000	canonical
1363	3NKa7f7eFiw32pkNMpGHuUkYeJs1j3Q4ovLC9eqCR2PEhUJ9u2ir	1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	633	1384	1	1	1346	jx3VvQKqcp3jAq6yfEhMCbQMoDkgTbbWKWCaYL6iWAJik33Bk3A	747	1037	1037	1616125860000	orphaned
1365	3NLw1Hn4J1AdRC63JhcemAn9qy2atwHLx7H1iEKaLdhkvhQKDz9v	1362	3NKR12UdeLLD3z91B7bDML98Zt31vjhHukQGtgq4pPoqAcF77nNq	1407	1395	1	1	1348	jxJspj9FsWsc23AvzywcdfToL2VvhWQ1kwjXysvSa8mh6sYjN3c	748	1038	1038	1616126040000	canonical
1366	3NLJ5qkqgKMznmUjmqTNTUZeonXQKZjqWuoCQGdc8iAH5b2NDnMj	1365	3NLw1Hn4J1AdRC63JhcemAn9qy2atwHLx7H1iEKaLdhkvhQKDz9v	1406	1393	1	1	1349	jx37oaxqp6PoV4ep3tcG5zqsTkhe2BxSiYNMGFi1Uzfb44dAZpN	749	1039	1039	1616126220000	canonical
1369	3NLFkhrNBLRxh8cfCAHEFJSe29MEuT3HGNEcheXBKvexfRuEo9eC	1366	3NLJ5qkqgKMznmUjmqTNTUZeonXQKZjqWuoCQGdc8iAH5b2NDnMj	632	1382	1	1	1352	jxnWxjpwyiA4MPZnzKnHiAoMCmCqDTuMhV9yo13A1VCcBkKatiq	750	1040	1040	1616126400000	canonical
1370	3NLh1Fatqt8yUVD4nXmhp3AVuRktADJzii8WD7TF1biuYQXJthvR	1369	3NLFkhrNBLRxh8cfCAHEFJSe29MEuT3HGNEcheXBKvexfRuEo9eC	1642	1367	1	1	1353	jwwnJAFt3gZ7mu2MYfsR6NrN6j2D84qcv4JpEJW1gQmCSLWAoUL	751	1041	1041	1616126580000	canonical
1373	3NKw2UFTJ7bL9h6p4kdCkjBjgTSJ9b5aB9fhggWjEF129pkcNigy	1370	3NLh1Fatqt8yUVD4nXmhp3AVuRktADJzii8WD7TF1biuYQXJthvR	1617	1288	1	1	1356	jwbUEaiNfrdzwgZdF1aUwcJzJZcLdRmTtZhkV9xnMEehUQfX4db	752	1042	1042	1616126760000	orphaned
1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1372	3NL7V4YucUZ1kmZbyBhZJor5dSvM2eRVLY53pshHwL24BoCpnanY	596	1180	1	1	1357	jx8SM2fXCmABt2gGXUJbmr1GFkPcvr1JYrAYnixEpFfpW7ivZGL	753	1044	1044	1616127120000	canonical
1377	3NKmxESPyJztHZaSustE7PxdJnXZguM6HzhjLrANL12y6L78sus7	1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1609	1333	1	1	1360	jww1yFcja1rHEzKLuDuwKstLvJNHiesTRBbCY9ATLwcifh5Axoy	754	1045	1045	1616127300000	canonical
1376	3NKN4phD29UyWjV1wpePXkcFP49SgEV9wrGP3r4aVeYMFUPywm1b	1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1407	1395	1	1	1359	jxsP3Sz7FXWyqGCwwHdzaHNpwLNkrcZkJx6rRUMUGTkhmgK6voW	754	1045	1045	1616127300000	orphaned
1383	3NKpEyzBpnFuMTG6GyMSe6dX8xuSYHaHXdi8BUUfy43xC9ACYNUU	1382	3NLFWssNFJ8kJtmcy6vxEHuxZLedufuk4LEwpkYXK7fHJR4zCCif	1406	1393	1	1	1366	jwSNy1eYyQ6NxW1kRvb8uTiXkwXQyNYQmVh7VZmAwVTgk5WkEEy	758	1056	1056	1616129280000	canonical
7840	3NLmt5RXVcueE5QXuarYCQsXcG6Gr7w2yGnivP5fk5E9sGXndTnU	7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	532	1303	89	1	6301	jxHTK4iKeNP1EsS2J1uM8BqsxPYQG4d1WkkbiFTGUANJw6aEgQw	4014	5730	5730	1616970600000	orphaned
1372	3NL7V4YucUZ1kmZbyBhZJor5dSvM2eRVLY53pshHwL24BoCpnanY	1370	3NLh1Fatqt8yUVD4nXmhp3AVuRktADJzii8WD7TF1biuYQXJthvR	1406	1393	1	1	1355	jx8HRpndL8dNfEB16ja8JjKC6WDrxSkj2F6YAmxN7MDPQuBYt5D	752	1042	1042	1616126760000	canonical
1375	3NLDiJdESwsRccF3PQUqxRAPrcFBTSPSFJycbD5cS3XKPiWV1ABc	1374	3NLj977rVsSADXtf2orMuLRJjc3JgtfjFhotuouX3hD3s1b1TScA	1654	1094	1	1	1358	jwqAJMyLTpE8juspejPjzDms4fJs6yaL1DWTqKo6Gkr2Fw411rH	754	1045	1045	1616127300000	orphaned
1378	3NKdFPTavjuWmBwAmHuR9fVRZUjNgFPSTirDu55G7SvAsUbL1QQP	1377	3NKmxESPyJztHZaSustE7PxdJnXZguM6HzhjLrANL12y6L78sus7	576	1229	1	1	1361	jwuCcEEYPjYKVdkt4zN6CE9aX5HjeUc3jgP58AAhtJ2huhgDm94	755	1046	1046	1616127480000	canonical
1379	3NKKrdChou9pFLgNkZRkoJDn39pAxgNVDH63ZpAwDeoVug5g9MdJ	1378	3NKdFPTavjuWmBwAmHuR9fVRZUjNgFPSTirDu55G7SvAsUbL1QQP	532	1303	1	1	1362	jy23yQJDmr85EPLNDmxR8TjoBUGqhcA8UDEM6XVCp4zqJmyeDgw	756	1048	1048	1616127840000	canonical
1382	3NLFWssNFJ8kJtmcy6vxEHuxZLedufuk4LEwpkYXK7fHJR4zCCif	1379	3NKKrdChou9pFLgNkZRkoJDn39pAxgNVDH63ZpAwDeoVug5g9MdJ	1590	1300	1	1	1365	jwD3QHAQBQ1rhggmkLX9bMtS1D3hHb37Zga72LHjCQmdFRp7SCM	757	1050	1050	1616128200000	canonical
1381	3NKfpxYoKRLRdvnAbpMY4h8qavPYfGqM5jqMhwFfxJwTpMkqwm72	1379	3NKKrdChou9pFLgNkZRkoJDn39pAxgNVDH63ZpAwDeoVug5g9MdJ	1647	1056	1	1	1364	jxsWQPrEbubhAe38LoDoPSAZVERU31odwY6pa99GiRAmS9bP4bq	757	1050	1050	1616128200000	orphaned
1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1384	3NKtUqPYC3QSsv9nhZWiM5ArsqXDafZeDsrruDDELpfLRDjxt8v8	1675	976	1	1	1368	jxeoor4FopH8cCdUM1JmmmLLLechkzrNeewBopqjDe5Hkajhma1	760	1058	1058	1616129640000	canonical
1386	3NLgj9GjnsyRR9ni8JEqui3h97R3pdbiAbqoemJQEtZoRDBwKeyD	1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1500	1171	1	1	1369	jxgVDt3D43ningHARxc7xEsWcBpyLvvGHj1Dc45R2J72BFnsWUJ	761	1063	1063	1616130540000	orphaned
1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1474	1329	1	1	1373	jwUqjmUaMV4kmvMofhdm5ReFChQyeL5uorp4EdMHEdPYqNVYpsv	762	1064	1064	1616130720000	canonical
1389	3NKFUNovb2hAZW6WaD5BMmpb9oRwRUDFCe9Vy13usngGijwVAvuY	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1426	1364	1	1	1372	jxV649ReBG9wNQX5M1xLzPJNQeqEwxg7kkkDCqmL3955tLoyz8B	762	1064	1064	1616130720000	orphaned
1394	3NLsgfECRUvt3romWRdBFraTHyd4QXEhoeZubgHTxs2bjvqicBLT	1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1406	1393	1	1	1377	jwiJTyv2oHVzRwdsdFvBs9TxXE5sNAVAs5wgebcoPFwQ4o4Nfnj	763	1065	1065	1616130900000	canonical
1395	3NLRun6r3j7q8zAzWDwAGmc7VrQCX2MawJAUnDoLBDCNXWwApoHv	1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1675	976	1	1	1378	jxCh3WM83CbZZVPDVyNFxWVdQrL94SH6TmAiyuzSyDdmcUCv6Nc	763	1065	1065	1616130900000	orphaned
1397	3NKPwQkaXXqC97bVED72hnc6DcTD1J5UtTpFKjYTtPrn2nDwwJBw	1394	3NLsgfECRUvt3romWRdBFraTHyd4QXEhoeZubgHTxs2bjvqicBLT	1657	1344	1	1	1380	jwo5qNrMzTg6ng5YCgoKZdsLQH4ana8Vykq29t8MHmYj1g7QmQy	764	1067	1067	1616131260000	canonical
1399	3NKSEp448XBrgujfQgaPR29KVqLG7My5UToaFcX8Ci6yz661x1N1	1397	3NKPwQkaXXqC97bVED72hnc6DcTD1J5UtTpFKjYTtPrn2nDwwJBw	1527	1167	1	1	1382	jwoNbuw63DZSRFxVCx2NsAXAfUSef5mA53FqawgJzCzJTTnM6EX	765	1072	1072	1616132160000	canonical
1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1399	3NKSEp448XBrgujfQgaPR29KVqLG7My5UToaFcX8Ci6yz661x1N1	470	1309	1	1	1383	jxWpj4542xfMhfr3MJKH9knR8YyrSF2eRuQAwYLZfAdrYLThU9G	766	1073	1073	1616132340000	canonical
1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1455	1332	1	1	1384	jxLdUpVJ4zdvg4mqGRXcR6eQ6yoBMydFoPWQRtyHN1GBiJXVVyU	767	1074	1074	1616132520000	canonical
1402	3NLNtMRE6n5Erv1ow9drPNiR6aZW2tCzVZmQKRJeP8U9kSc63Vet	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1656	1217	1	1	1385	jxrpctMTSfCWf7fxkjVmwUU7L5gAKjnAwoFxcXvDsAt7omfr3bF	767	1074	1074	1616132520000	orphaned
1404	3NKpK2kvyCq6hEH1dRVDX4JZ5QyJi7mspXPM9qeL3Dhitp3a6xxC	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1422	1091	1	1	1387	jxNGj8mkTKZrV1CqW6SHy53FAzBekoMYppqDBnJS4kaBkdJetPC	767	1074	1074	1616132520000	orphaned
1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1406	1393	1	1	1388	jxJDRkuWXDwmP8D28uhrafuHhgrdBHQmVDTz1ESFUC5Mp3mNkr6	768	1075	1075	1616132700000	canonical
1408	3NLtEeALqGXkBmUvEnfs2GoYZFUiEqPKHdsTEPc6zBK6uutA2Z6X	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1623	830	1	1	1391	jwrj3FEWhdUFuD5dxj1P98y8TzZKDbnWZRPsnWc9Pu7xgYJFVKe	768	1075	1075	1616132700000	orphaned
1409	3NLuvqJ3a8iW4oJXWtuJKRf11Qy4zotirMn6fdV7WPBvMgUA7a9D	1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1523	1195	1	1	1392	jwMkngiPc9QFGGLaERCMXPWBXnooSzGtv5VeAK6AweYCV6XoCfV	769	1076	1076	1616132880000	canonical
1412	3NKy6Y1Qm4qBRJHAGUcJc3so5EDjt59Vn7kHhm8VLzosuJEJvv7F	1409	3NLuvqJ3a8iW4oJXWtuJKRf11Qy4zotirMn6fdV7WPBvMgUA7a9D	1657	1098	1	1	1393	jwMsGWG6dPbB4qkYufFCwycJeGnim7SfzWxhQPZHVGq5iLzZG7q	770	1078	1078	1616133240000	orphaned
1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1622	1110	1	1	1395	jwVZneEkgN7T5vQAe1V5sbZeY2KvxWg5giawEfyTQJFZcrEpmwo	771	1079	1079	1616133420000	canonical
1416	3NK7826BbHbySBcvnm854C18ZHwT95H12afpfNyAfBcCkaLwbGuv	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1527	927	1	1	1397	jxkrDSQSJaVNcaS7HytvhAtshYRh7rRDYc8hLdvqKEzAWmgvyun	771	1079	1079	1616133420000	orphaned
1419	3NK863XNzYzwB6Mhu346VZFEFeq2G2byyRKh1MurBH6GuGqQQP1D	1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	470	1309	1	1	1399	jxZ7jm4edmVLRBLU3z1UhZVSH2KGRRkkoBdKoLyxjqXSJUrwWjZ	772	1080	1080	1616133600000	canonical
1423	3NKmTdDFK53fZNEPyLvVje69x5Kfqq7ZyWqrPXbXxYiVy92cJAFH	1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	58	1281	1	1	1403	jwwxh5iuHNastHaM4YWXUPhxbJE7i924zDz7dtdxKkeZ6ysK7C2	774	1083	1083	1616134140000	orphaned
1426	3NK7QNxqySj7N96BVTrVRWYSzqcFJHH5Hn1TGTd3aMBttedtihDo	1422	3NLRWzwQVvCDVGkzzri94xNZ6dDmR9wnsqGond2QwaPNLkMkPLDS	58	58	1	1	1406	jxYJJfMmWPmqWDYz6p2ifCtsWrCSW4m9e4Dqz7nPxxCSjbsch3Y	775	1084	1084	1616134320000	canonical
1428	3NKH28pdnEgEK9t24hQRnhmAvT5Kwug5XdjrEQaDLXT7jAzkzEUj	1426	3NK7QNxqySj7N96BVTrVRWYSzqcFJHH5Hn1TGTd3aMBttedtihDo	1471	1386	1	1	1408	jwYTeDbrQ25h1kWYZwh3ErB7uEZS3W4M1VDhvTEfTi8rDESzC3R	776	1085	1085	1616134500000	orphaned
1429	3NKpSyV9Z1nUJkTuA2WikbBEnAWHcJHP3NDYosnZG2MGoRup6Baq	1427	3NLvSUNs6ZfS1npXucgPBBZpCXG68VWnPmk3rT9bEwLEMo5PELK1	1406	1393	1	1	1409	jwsY5CUtpyonmz9bYjMyDarGMNmWKmdtu3mDorDXZfKkMMTEWr8	777	1086	1086	1616134680000	canonical
7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	7749	3NLKANXuPnn3tRMev7UWy1xAu5XGw6mroeLaoEgZDVeB7cR5xAXQ	42	1361	90	1	6301	jxtE7CsdnCAW2vAFdpn8b3EHKWzo93Xq7NVk91XiWJCLk8Nr26b	4018	5673	5673	1616960340000	canonical
1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1534	1317	1	1	1371	jxvJFWKBR2Je33v12FFv6oDpB1D22tAzDx41UvW2BJQc7R3NdsL	761	1063	1063	1616130540000	canonical
1391	3NLWW5MgKhCNBNqJx5J716eLAS8qTQGbsyqCWZjUadKoKGFpqNJ1	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1471	1260	1	1	1374	jwFsEV8YBYswTZ8RMLTzPChtXcxki9DR68PfMb9h41Sfixg845X	762	1064	1064	1616130720000	orphaned
1396	3NLXRtmZ2MpUD4X51Hs7inwW1LPY6aqv6hBo46ZwzqP7azhxZ95U	1390	3NKpzHvNfF7vp5GdxKExwA5nkSqvMGJKUtUNa6TTKbHebuVHBMcs	1527	1293	1	1	1379	jxddecBtcpPrZpR9Fw2wcqKbWjkRMsqVEDhBSskyk1dExtRL4GU	763	1065	1065	1616130900000	orphaned
1398	3NLQhEsGHKKMpatmgPedUAEXVvkdyDxQgoEmqn3mZA6ksVptbec7	1394	3NLsgfECRUvt3romWRdBFraTHyd4QXEhoeZubgHTxs2bjvqicBLT	1403	792	1	1	1381	jxZNBkRQsP8pvFfLzZf7q3kkeF1hMKNP5tbSzqL9BHQLfpLSwcT	764	1067	1067	1616131260000	orphaned
1403	3NLcHQh5m6PSkZdnR6mb1p945yEuK52xJAgitLDyLvz84t85BooB	1400	3NLT8kqFZj1d9whRMJQ7piAy5VDbVo7cj4LcvNMXWFEnDvQFAXz9	1403	31	1	1	1386	jwimkLAk6ew6wYZBJRcqkhQTM1audcDHsAyzavBZasCPcQ5S9oS	767	1074	1074	1616132520000	orphaned
1406	3NK4LXcLhKxuHH9r8HVyMwW4TFjUiZho88TPGP8au8SCzoeqEFLJ	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	448	1305	1	1	1389	jw8b2nQ3XwLugHbHyMR5fQT3gdXfMZiPUYFuC8mEpx1ZtnnTFqR	768	1075	1075	1616132700000	orphaned
1407	3NLAMnzZSF9Vr1vs3pfE8h2RFDpj2xjQBe1pbgEqmpyQ7qJBhiPS	1401	3NKhXQaYDYe4E4smvb8xHKhoxy17f5eA4mbiu5SQuiF8o19CXxzW	1407	1395	1	1	1390	jxLLxajEry7c7eZgy8wwgD1jwVFGa2RDuMkCDgSQPRC89YjcE6L	768	1075	1075	1616132700000	orphaned
1410	3NKSVTwk6ypQ1NkAgTaSzP9WSsYEUmYYn2iq26ZHL72iuxYScx1b	1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1523	1195	1	1	1392	jwSHfwmDDuRDxD3H28rtr6e9LWMtP2bQkKEDz4uPkGxh3DYWNuo	769	1076	1076	1616132880000	orphaned
1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1409	3NLuvqJ3a8iW4oJXWtuJKRf11Qy4zotirMn6fdV7WPBvMgUA7a9D	171	1374	1	1	1394	jxnoDB4yi8uy6rzzMGRd2XQGvMrefhRSd43m7a4di3djcZ4grtQ	770	1078	1078	1616133240000	canonical
1415	3NKLuunBayq7hx7CHNwHWVU6whgNpnfCmRnGLEjxk84hd3xK1FML	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1402	874	1	1	1396	jxGNudP2mZ8D6coAcbau7znEUF12Az5sMj5pezgk8S18cpdvwA1	771	1079	1079	1616133420000	orphaned
1417	3NKFy5zjMCiQRAjuTCfnbpAD7gCF987SmZRB5AnVxoycBgofXpUD	1413	3NKj7pEVLfwmr3PxQ3MfcU1TCVjom2v1K5sdLoE7zWjjs7bzd1Xp	1506	1373	1	1	1398	jxVZevEoLK1MQbveT61GkRRmft38hvnkGeFQAHv28SVkJDfKqch	771	1079	1079	1616133420000	orphaned
1418	3NLJpUaFdKnk4sAeFHdtrmPhrdtw2dH729wqHqarc1HhyTQoYRZV	1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	470	1309	1	1	1399	jwsrHjSB7M65jVSQ1ZkW4AtmsXt2tKBjnqvZ9JQNKLNsCWeSMEF	772	1080	1080	1616133600000	orphaned
1420	3NK7e5eeB9t4GuYVycemDGLYodGBoXqoSHAUa5AoJH87kb5r3jDP	1414	3NL6YL11LTBKudJkdYZgLtvUUbmxjPyrP4UKrWfd1pRvoGqr6qTE	1419	814	1	1	1400	jwUTfinunnyFFHrs3bFMeQqTWRvh7ejaJt9WAd1eL3wuYRX48dB	772	1080	1080	1616133600000	orphaned
1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	1419	3NK863XNzYzwB6Mhu346VZFEFeq2G2byyRKh1MurBH6GuGqQQP1D	44	959	1	1	1401	jx6KGmck7UpRCW7tWptrQpW46QsYqixB2XugMj2QHouJ6oiCZL4	773	1081	1081	1616133780000	canonical
1422	3NLRWzwQVvCDVGkzzri94xNZ6dDmR9wnsqGond2QwaPNLkMkPLDS	1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	1406	1393	1	1	1402	jxcjo5NuiHsBy7njAr71NvV4dnn4z1RUHEYSkHSQcCaQL4KnnuA	774	1083	1083	1616134140000	canonical
1424	3NKA3Vm3E5xVTMSpzthZBFnujs4yQtLEFRFtKNcJ5hGHBuith7Kh	1421	3NLFNJQrW9eQMu1fNtkmHESQxQZA1k2uBf5fZgDaJ3GYd2LPe7ph	1581	778	1	1	1404	jxvmvEFYjK77bhWJ5sGaQSiRcdoYf8EdjUjtMsSi3Ee4XEsNgdZ	774	1083	1083	1616134140000	orphaned
1425	3NLcRafR1N8tEezjypc84rGDbmrndv7GE7Yqmhj4jLXvMaKvZhYw	1422	3NLRWzwQVvCDVGkzzri94xNZ6dDmR9wnsqGond2QwaPNLkMkPLDS	1467	1376	1	1	1405	jwdPwRXVei9aa4EmBb97BVf29b4Pt6X2XbBogh2X7TpkcTDy6kD	775	1084	1084	1616134320000	orphaned
1427	3NLvSUNs6ZfS1npXucgPBBZpCXG68VWnPmk3rT9bEwLEMo5PELK1	1426	3NK7QNxqySj7N96BVTrVRWYSzqcFJHH5Hn1TGTd3aMBttedtihDo	1402	850	1	1	1407	jxhhX3grh45RCpoJVtHNrZUNcbKav8pSmvnMbRs8QbnxmFvcDBh	776	1085	1085	1616134500000	canonical
1430	3NKxCMovRNxZL2yNDToeR9MxHSvB54tBgiUbRnELYNMJXMcSzjDw	1429	3NKpSyV9Z1nUJkTuA2WikbBEnAWHcJHP3NDYosnZG2MGoRup6Baq	1403	824	1	1	1410	jwUWtL3iZijkPL1nCpmotFrShsSYYvrQNfVdNWQ7BpT3dkd2PtC	778	1089	1089	1616135220000	canonical
1431	3NKTkSg5i5cBGkbs1HibAYeZvxxTZCd3QDuZHY8GpZXKqu8Xj7xM	1430	3NKxCMovRNxZL2yNDToeR9MxHSvB54tBgiUbRnELYNMJXMcSzjDw	1397	838	1	1	1411	jxvpGYXJ4Pb61PBvjHYQMySLpSY6qhV7u83cXdTutSfLVkCep4w	779	1090	1090	1616135400000	canonical
1433	3NKGQdNz9EMRDPbhpXWzyqr77Rcc69czvJrRKRTGUsA9qoc1QPTg	1431	3NKTkSg5i5cBGkbs1HibAYeZvxxTZCd3QDuZHY8GpZXKqu8Xj7xM	1600	1372	1	1	1413	jwKA7TtbryvNcmye6sSP3FPxTrKRkX5cMFajWTUg8zk18JWf9PU	780	1093	1093	1616135940000	canonical
1432	3NKC1S4VptVcKmUBVVFo9YHHqTZCaTWT2RbRBw6gf5G5LHn4tt8B	1431	3NKTkSg5i5cBGkbs1HibAYeZvxxTZCd3QDuZHY8GpZXKqu8Xj7xM	1610	1068	1	1	1412	jxqRqbsy59KAYTf4YwySjMYbKfzmYLkDfqBUm8tXy5z5x4p5Vy3	780	1093	1093	1616135940000	orphaned
1435	3NKqAym4wHm6UQHb1YXmbSY6Y5Zf2NMoA4vFRBfFKJ5B4miZc9Fj	1433	3NKGQdNz9EMRDPbhpXWzyqr77Rcc69czvJrRKRTGUsA9qoc1QPTg	1652	1315	1	1	1415	jwGKMVoorxsiLyVXHscGiBEf5kbN5SCWASPc9d2qjXbgQZAUkBn	781	1094	1094	1616136120000	canonical
1434	3NLJoHWrB69FaL79db15zgZQVPgx6NhUtBuBsa7Npp8GQ8wY8U76	1433	3NKGQdNz9EMRDPbhpXWzyqr77Rcc69czvJrRKRTGUsA9qoc1QPTg	576	1229	1	1	1414	jxCmD5JuZRvS4tAdQZEz1xJf6ZFKS72P4oqdLsuWqtME8rUwa6f	781	1094	1094	1616136120000	orphaned
1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1435	3NKqAym4wHm6UQHb1YXmbSY6Y5Zf2NMoA4vFRBfFKJ5B4miZc9Fj	1407	1395	1	1	1416	jwyHcC166xa6WUsqtJAfXaKkUGqeWPqBwZ5qTpzTkB19wadWaCe	782	1097	1097	1616136660000	canonical
1437	3NKUUgmH8LAEDuuAKy7GJsJH7Yj3eBkzmJioCVHf54nb4uTiKPdt	1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1476	1005	1	1	1417	jx3RhMAFsUk6mZQfaQ3xMhuJQz2A1Ar94ZkfwgDqG1ofYXQ8mVm	783	1099	1099	1616137020000	canonical
1438	3NLHR8zzFMiynCV8owxHF6jtXxsHt4bkZ2RSxXqRQv6WH7ewu9KH	1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1483	245	1	1	1418	jwTiJANe4Kj2vsHwuuhch6kgg47GwtkQ3UbEBou77JuejdFXb89	783	1099	1099	1616137020000	orphaned
1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1437	3NKUUgmH8LAEDuuAKy7GJsJH7Yj3eBkzmJioCVHf54nb4uTiKPdt	448	1179	1	1	1419	jxnbud5tKSMVVcRrgSvyhE8RYXPD2Rbkw9CVzqSo13L9ZPLut4S	784	1100	1100	1616137200000	canonical
1440	3NKLRumTynAeSJHp9AWLP1oTiEwAy8Zd1LKij5MXEWVwfmqgHujE	1437	3NKUUgmH8LAEDuuAKy7GJsJH7Yj3eBkzmJioCVHf54nb4uTiKPdt	80	1273	1	1	1420	jwsyAUfJQCMCXNE7EZxH8XC5JaHzU9LpUxX9L8YXVR2uSJ1FD2i	784	1100	1100	1616137200000	orphaned
7754	3NL9ZiL5dp7LwVmevedcUH9GRxBhWyvYcNXE5eV3twJCbBDsuuDZ	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1651	1301	90	1	6301	jxy3Jc9kJjEXpWYbCbwRhhV8opxT7NtzFjo33dmADVosdyTaTWh	4019	5674	5674	1616960520000	canonical
1442	3NKD6cRJijkNNQKi5et36HdVmpAx1A4uNd9pA4JHoTPGMKNknVin	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1596	1363	1	1	1422	jxHtMD1o8d78m6QTigx2qNWAc8zCrtfN3GKwbwvM9gHfwDXaweJ	785	1102	1102	1616137560000	canonical
1441	3NL9Ha8JBwcZ3UFSs81KpVbYPdrnKRr2WpWyLpVovuqopFSto5pK	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1474	1083	1	1	1421	jwZpmeiUhF6pKKMrdZW84nFGDHL6cdMg5eiZ686x8wzwpvM97me	785	1102	1102	1616137560000	orphaned
1446	3NKi7ZbZUhoDPE6A63Yn7VkybRZXJiNqyKP63ZxVPGdD3VFGpe6n	1442	3NKD6cRJijkNNQKi5et36HdVmpAx1A4uNd9pA4JHoTPGMKNknVin	1402	852	1	1	1426	jxrFU6cRwXfm8UU3B1VVZ8KD5bUbmk2yK3DAekamUt6cS5ghsFc	786	1103	1103	1616137740000	canonical
1447	3NKGkx6mhgobucMoMkypaEp5NZ9yb4Zbj9Mgf4ddQqu5tefJQfH7	1446	3NKi7ZbZUhoDPE6A63Yn7VkybRZXJiNqyKP63ZxVPGdD3VFGpe6n	1403	824	1	1	1427	jxmxa9Lcgdp27qDa6MLkxNCC4ewgRSMWFytfRUWaArHsUdr7Nxf	787	1104	1104	1616137920000	canonical
1450	3NLQuUcXipQFAKhvMH4iPeTYW7jpYZPQB6r3Nzmnvyzob1xTxGS5	1449	3NK6zhM1NYK7b5ydNf9NrW5prjbmFzUb3vm7CMTbRe6kJB3kyzPz	1623	830	1	1	1430	jxhaDBuja4VoJr7poCmCsV56BRje4P1Z7Lv9U6xE4QxBmv1Ts7U	789	1107	1107	1616138460000	canonical
1456	3NKzECLmHxGbUBdnXzES21eVQifi6SwFcqi2xV3RCp8d1ZAvSrgj	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1637	816	1	1	1436	jxFSsjbA8kDQ6VsUq22nvWDbgiwGZvyfGEvV4n9bhLs98iCRyKr	793	1112	1112	1616139360000	orphaned
1458	3NLR4s9FaXLKQraKmfBApzdY1QzXjT9iDWpf6qCX1B64CqEjofkQ	1454	3NLmsuNBkoTQbzd3k6tsfm5TXrQKkQNjyHEzNrAt4mYT26sLE3Gu	1581	778	1	1	1438	jwFouhSq9SPFeeC9vBBaV3X8Mb7kBLNt5ihD6NTnvv4TZtkUsw3	794	1113	1113	1616139540000	canonical
1461	3NKLvXrN6vGoLr3uULAJzV6Waft7DD2BDR5J9146qB7UhwgbFc5S	1460	3NK6yytuUWB2EhQDcqVTM6pSimnrtvqtwGuEkqnuxuaQTqyRRrHF	1402	868	1	1	1441	jxvLXxUYCCgJHmBmfBPSCLAkz38FdnKBTw7HkRmGbLdfmWwHJpd	796	1118	1118	1616140440000	canonical
1464	3NLMFsdKZcWF9DFue4Nw3UENW9kwqdXxEWqVH7pdc8pKQkkHTkzF	1461	3NKLvXrN6vGoLr3uULAJzV6Waft7DD2BDR5J9146qB7UhwgbFc5S	1578	1296	1	1	1444	jw8oRSz11hqhhy7iNwxsLUBZeVoMWaAdrKsSu4bBq8DdkxsyHZ3	797	1119	1119	1616140620000	canonical
1467	3NKtBKsSTK58gjQFvVycv7HPBSi5DWSsDpU4HZAxAsds8csgUQVR	1466	3NLbMv7zsYpzU8vQx4i79wu72diWEnFPtFGufosFHH6te62umTiY	1454	130	1	1	1447	jxYgNjKbr7F6S9UuCFStLCzjqeskWc6oi7HEKuSt5ayQZUEbozt	800	1123	1123	1616141340000	canonical
1470	3NLwQbhaMaLSUspXTPhsCTLKkmpd3w67waGBhybzGFouEVzvX9ZQ	1468	3NL2DXvH5bafnFQSS8FsPQHwEP43M82hbtjP8Lz3YHHTjyhJrYTZ	1407	1395	1	1	1450	jwG3nf1cpkvM6gxdYnhVgT6LVfPsnQp9kJq629iP3UhWwVVw84o	802	1125	1125	1616141700000	canonical
1472	3NKpY15RWfXcYxmQoskAXJSNdzpSFuzumMtSPr3RPFYtyBCQSuJq	1470	3NLwQbhaMaLSUspXTPhsCTLKkmpd3w67waGBhybzGFouEVzvX9ZQ	1506	1127	1	1	1452	jxUD4Qvn8z2SSLPJoLppKqdL2UHb79nqCiMThYr3aJ11yNvhgBj	803	1126	1126	1616141880000	orphaned
1476	3NLGzTBhcVRqVdQHqjehywjE3vAzreBtjL3vLHAmAmJRmZG5WPzQ	1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1529	1070	1	1	1456	jwyiaQahZNnbmADheerMBAMoyhz6Qi6uWkSu4nTi7zHDWr2u7V8	805	1133	1133	1616143140000	orphaned
1478	3NK4F5FYbRpACyrbhHyGYJuPS19EN3ogkB3zECL63SF9eXd2d7Sp	1475	3NKcWSAGKXLmBP5cv3vdFZcsAetKUgmpvcZBNe5hJJXmfcd5PrkQ	1590	1054	1	1	1458	jxZMt6sqGcsdCiE2WskhixQduXcU4MSET3aWzcKkj2VH7xkZX69	806	1134	1134	1616143320000	canonical
1480	3NLhWNT5N958i8Y4bZy1QfK6FQu17pnC9Lwk6yMhSKar429J7JA3	1478	3NK4F5FYbRpACyrbhHyGYJuPS19EN3ogkB3zECL63SF9eXd2d7Sp	1546	1093	1	1	1460	jxgWPjhnQEL9QE5RBBGhS7oQCcVoYLDYaK61AD3zcGHEzs5Pwjk	807	1136	1136	1616143680000	orphaned
1481	3NKsyvhrXYzabGtAyWjpEoptmr7Ph6o229dF7UrqNe2fxxy2TPZA	1479	3NKx85y561ojbWdBGvYad5cqA9PKrHWudFfwM8WDRGfLC5LgATKZ	1407	1395	1	1	1461	jxd751r3Ep9ZMDhnoMg84n2W3zPcjW5Ui3nLQoFRzMJn1pFufhV	808	1138	1138	1616144040000	orphaned
1484	3NLTQyXk1d43fGpEb1ipT4daQC16NA8MuG3nfsdUAuh9fSfnWDXS	1483	3NLqCRaxCStHoGXghNSM4tqbJStR1e7ospznon3pWaSTuPSaWuBL	1571	1335	1	1	1464	jxVUVFZjhVDP21UZvyuEJ1YWRZGW39k4GiQ9nHLCCmjuQnyAqWr	810	1140	1140	1616144400000	canonical
1485	3NLh7RbuNqXX4z8zv7pcMU5XR4vHGPAJcWpX2VPcvS4rSeG7tUZq	1484	3NLTQyXk1d43fGpEb1ipT4daQC16NA8MuG3nfsdUAuh9fSfnWDXS	1407	1395	1	1	1465	jx2NHse7FsRHz3H5iqZ7p9JqpKCEstgMUaurYu1HDtTEDR4JLDt	811	1141	1141	1616144580000	orphaned
1490	3NLbkZSneZteh3PhVLQb39mQ3ctxSuKHaPehuq4yuQuLEziRLUNa	1487	3NKptfB3kTW8S2yBQq5t6uYCEFVRHUskvxPrASJmozAG5DkyYPgP	1650	1375	1	1	1470	jxtLWYB4UZD8LL5Bxqy1Lx47CCGmv3PB5eAbtciB4zJAnBYozvz	813	1144	1144	1616145120000	orphaned
1491	3NLfHaQ7Ubce81eCHMPT5hparDBDeY6bJgYxGGdMu4V9Qnhb3R3Y	1489	3NK349srW8wE9NfMFQYsWc9aazMHt6tt1KheFHCxE6F1oNwTQ8yq	1534	81	1	1	1471	jx6qLFfTRG16cqNnpPGUMDP7eY7117vVBg6RmhRh5u9rh4W7kqV	814	1145	1145	1616145300000	canonical
1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1493	3NLEsPzdfSLBRv8WYKJ3CfaaoTUdwY4wUGXiqP13EwUxNHoeg4FA	1406	1393	1	1	1474	jxb7q5No3fiLBkNJrSnHqqbMfd1ecmR1CrHka7DCjpNPRFjHdGn	817	1148	1148	1616145840000	canonical
1500	3NLRhohgfsqkFQC895q2qCC4VaiECWetrvZyN9f3sNqnLcKGaGSn	1499	3NLL3LKeSWkq5r4Cg87YVEySxGtts7yWGKE76jdpHdmSx37otEjA	1406	1393	1	1	1480	jxngRtk78dDEkEYWSNN1M9BJsDgz7L94ZoK96Z9UYWwsJa3phH6	820	1153	1153	1616146740000	canonical
1503	3NLE2TSYe9xCfVQrKpCSmLArLHmjaFhXJHpHcFq3orRMzknfM1G1	1502	3NLkBvGeHyceuL8zspmJj2DrJr3probZGcoMg6tsxMF7JeyxDrpt	1534	433	1	1	1483	jx56VrdJ9PSrTsTQfB5zs95dqWFWqHTk7JeFiGQdJRZzhTqYvLA	823	1156	1156	1616147280000	canonical
1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1483	89	1	1	1486	jx1N7jfuysrhSRAuZ5QcCGErbUbBAaoVuVPpCEoQUQef768981C	826	1159	1159	1616147820000	canonical
1508	3NKJzSC7jvo9dWo245mmd2PoWx6tDiMRdgWQtQYXiEF9b6F8Q3BD	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1637	816	1	1	1488	jw8XYRdiJwJJX1xrtxy7dHF9hnsf6Q5gZoCRem87SLC8sERGQVh	826	1159	1159	1616147820000	orphaned
1512	3NLZY8BUH2CRrAcKdiMinJDt39wYXPo1Cd8PPrKwqJFe82D1WcEp	1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1445	1164	1	1	1492	jwe4wFo5ACp9THYXb11i9QLxVm3nZEFbcC89LuBdALEYNHAbob1	827	1161	1161	1616148180000	canonical
1511	3NLYQFCrNpf9twJRD93PnpLkNcojSz6nURiVdmSwyVZzdW7cgJyo	1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1560	1291	1	1	1491	jxCHG37y93NNCEXGCHkbTJwVY4cxZyMq5jsFbQ4MRqbk5MaTUxs	827	1161	1161	1616148180000	orphaned
1514	3NKs5FVUdxUNCAhHBzv5gE3zGr81mzxXEVsfYeSZmR2qQkkfpn97	1512	3NLZY8BUH2CRrAcKdiMinJDt39wYXPo1Cd8PPrKwqJFe82D1WcEp	1671	550	1	1	1494	jx2BJidkmMPTYcdw6NexTp5ZxQ6pbC2HQaRnPhedYvDHKghTw3T	828	1163	1163	1616148540000	canonical
1515	3NLvDcwskRqcENA3wU7VLjtuXrr8zaK4eWrUC4ZTGw5S9etiruYF	1514	3NKs5FVUdxUNCAhHBzv5gE3zGr81mzxXEVsfYeSZmR2qQkkfpn97	1578	1296	1	1	1495	jxEnP2wdiuGgGpiAqRyEpDSWRmy5bGmFtezoNdv2A7gQ9pCJuPo	829	1164	1164	1616148720000	canonical
7753	3NLK4vH8YdoJtxbkXp5LqF7tf583Jjh4XRfAD4bNNTsaCLPPpp7j	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1613	1103	90	1	6301	jx3bHkb3zgNMhrHC9QJikHGPyHax86wwWhuYD8rfzvfW2k2w8Ex	4019	5674	5674	1616960520000	orphaned
1448	3NKE1fMAgza7PNeHSLiEi8n6ppHZhf1it6XZ2qB1DUezPdeihqJc	1446	3NKi7ZbZUhoDPE6A63Yn7VkybRZXJiNqyKP63ZxVPGdD3VFGpe6n	633	1384	1	1	1428	jwBh75qDftmYrTaPaZDk1bLrBATG1aRg8uDpMWJMHmni3xSP3YB	787	1104	1104	1616137920000	orphaned
1449	3NK6zhM1NYK7b5ydNf9NrW5prjbmFzUb3vm7CMTbRe6kJB3kyzPz	1447	3NKGkx6mhgobucMoMkypaEp5NZ9yb4Zbj9Mgf4ddQqu5tefJQfH7	1650	1375	1	1	1429	jwrUHmCnAu99LtozAvfJ2H4Z6ufCaru3enboicyd8ynW59RkYFn	788	1105	1105	1616138100000	canonical
1452	3NLD2Sw6GNcBrLG77ninAwAJMKuH5JwEAF6qHZQSmta4Brv7FUPd	1451	3NKQMRwgTr3q5oARzLAHNavQ4sd4EhyUjgitdsyauj6SPQysTmBe	1527	1047	1	1	1432	jwaJpEfqk6orzUQz757pLFn3bifEorznpqMgHzyqTda6K5uKojp	791	1109	1109	1616138820000	canonical
1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1452	3NLD2Sw6GNcBrLG77ninAwAJMKuH5JwEAF6qHZQSmta4Brv7FUPd	1534	1317	1	1	1433	jwzNKLh3xJqCR4x11ytvC6vE5i6SCUjMTXSZKEvTyY2AUZ3pua7	792	1111	1111	1616139180000	canonical
1455	3NLmqfHwadJ3XkbDH9LLJUupbvusGKCMadA5nTE64JRF4GMfzjKi	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1483	551	1	1	1435	jwJUWiweNhGUpkRmbCw2ohpmJ8TYyAdCxePJTbnEwhuWM1GGucP	793	1112	1112	1616139360000	orphaned
1459	3NLNyrppdKLtGyNnNXAYLeM772D913JUj6MwkiWdViseEwc6kaQB	1458	3NLR4s9FaXLKQraKmfBApzdY1QzXjT9iDWpf6qCX1B64CqEjofkQ	1455	1332	1	1	1439	jxFWWmmPss2v5XcehkCbaY4QNQwkAYNWW37J2dC5khY6RgLo3cC	795	1117	1117	1616140260000	orphaned
1462	3NKNGR5dKYN1eWPAPuBkurVXs2UNfmFVRE7WmerEyi3ruaBAMbgu	1460	3NK6yytuUWB2EhQDcqVTM6pSimnrtvqtwGuEkqnuxuaQTqyRRrHF	1650	1375	1	1	1442	jwyVJ5kCzqUidqDHHhPYJgnNP8vpfCubSAeZZmerK6YDNKJauyo	796	1118	1118	1616140440000	orphaned
1465	3NLLdRud8zJwBxttcpv2rdjCK3inpZCrDkxPBLkFwEuaBEFaVr34	1464	3NLMFsdKZcWF9DFue4Nw3UENW9kwqdXxEWqVH7pdc8pKQkkHTkzF	1406	1393	1	1	1445	jwbW8Rr8Y9jcjhPH8ETYjJz27Ys4JoEs9SiiF8fBNw9q3aQsZ87	798	1120	1120	1616140800000	canonical
1471	3NLxhDyZjM8tbPjAqzv8Wv2T2u5wauim9XSDdPRQsKG1bLB8erxA	1470	3NLwQbhaMaLSUspXTPhsCTLKkmpd3w67waGBhybzGFouEVzvX9ZQ	1654	1094	1	1	1451	jx8cuEcKYzEqzPbSJMrHJCA6ki6CU2F1VfxKKDbZ8xXqD67Geym	803	1126	1126	1616141880000	canonical
1475	3NKcWSAGKXLmBP5cv3vdFZcsAetKUgmpvcZBNe5hJJXmfcd5PrkQ	1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1483	1276	1	1	1455	jwQBBBtTRAthR1LUt9baKPiG2ETgjr5ERHAdRdzr8aLF5GjjwcM	805	1133	1133	1616143140000	canonical
1479	3NKx85y561ojbWdBGvYad5cqA9PKrHWudFfwM8WDRGfLC5LgATKZ	1478	3NK4F5FYbRpACyrbhHyGYJuPS19EN3ogkB3zECL63SF9eXd2d7Sp	596	1306	1	1	1459	jwxESQdTsavnwj1poSP6yiNzPM3SRVcg3Wo9F5u4rC3GX9viGZQ	807	1136	1136	1616143680000	canonical
1482	3NLACJmMf7pmh1C35GJei5EzoiDWvq4G6FP5ziRZRKneEknCCtdE	1479	3NKx85y561ojbWdBGvYad5cqA9PKrHWudFfwM8WDRGfLC5LgATKZ	1637	816	1	1	1462	jy2jsDKYiraEJJeakercbk1PPejjW8un3ys94rcJPFwHjHrfdD5	808	1138	1138	1616144040000	canonical
1488	3NLTWQNL2FN7YcJnv4L2C2K3yesYzPemwQgdxst8f116ZGCRFwzG	1486	3NKziodSLp6NrW5unogfsLwBTLHF7M1pB7yJSd1kTt6JNT96tJ5a	1609	1333	1	1	1468	jwog9U9s1uCEiRRiN4wXmykt6XqkMXaozdxz1qkqjo7RopFsXfB	812	1143	1143	1616144940000	orphaned
1489	3NK349srW8wE9NfMFQYsWc9aazMHt6tt1KheFHCxE6F1oNwTQ8yq	1487	3NKptfB3kTW8S2yBQq5t6uYCEFVRHUskvxPrASJmozAG5DkyYPgP	1647	846	1	1	1469	jx3szjgFxZSdSAD46XDCu4qPKp5Yg93vcedtuEYT187uM8tSNz2	813	1144	1144	1616145120000	canonical
1492	3NKss3AVVyw4LiTjFMH7k7z4ViFtudGBbYYKfwpiGhCtztexMhCZ	1491	3NLfHaQ7Ubce81eCHMPT5hparDBDeY6bJgYxGGdMu4V9Qnhb3R3Y	532	1303	1	1	1472	jxNz1kVRZqLrrkn4oJPFvySQEfEZ63TutoKSwfPPiEubzwWNypi	815	1146	1146	1616145480000	canonical
1498	3NK5HYC3gTCmGPhBHfiLZtccDWUcz6w6kN4ZGFH3rjrVsxRb1TbL	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1601	1022	1	1	1478	jwLrNjU1EFdUFSK1PrenF4eK1Lp8J7q4v8XtVgi61Lhq98Ann51	818	1151	1151	1616146380000	canonical
1496	3NL6ynceF5LbRbGF3DPKPmNAum9KJCfuHSZQzu4XqtFwgPEpyugQ	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1619	1275	1	1	1476	jwnPtica3M8F7ne4Rdcqh7Tqh4WhroUtsxbtTmMZpT4nKvtYepm	818	1151	1151	1616146380000	orphaned
1499	3NLL3LKeSWkq5r4Cg87YVEySxGtts7yWGKE76jdpHdmSx37otEjA	1498	3NK5HYC3gTCmGPhBHfiLZtccDWUcz6w6kN4ZGFH3rjrVsxRb1TbL	1406	1393	1	1	1479	jw78iipkWyHxzgYBYD5j4NikLWcbvkompBt2b8sJRbemA5NMAqF	819	1152	1152	1616146560000	canonical
1504	3NKEUpMwm81jqCSHH7Ai82pdbS2eEgoZaskoYBQd63AvCGFUyuKs	1503	3NLE2TSYe9xCfVQrKpCSmLArLHmjaFhXJHpHcFq3orRMzknfM1G1	1407	1395	1	1	1484	jwFdobP7ectPhmCAuaLVh6zDfNRy9zfLwxgjD7ND3Lc6QtEa4xK	824	1157	1157	1616147460000	canonical
1510	3NLcUeL6H7GmMeUYNtpLgzg8zery3DPSNc8Uj7DHxtzjX61UGBkg	1506	3NLULtY2yuFc8soMsKE1twRJtHR1uqENFurzgqoKrKjeBWxcmEfC	1403	780	1	1	1490	jxZBHCbTZAVSi13cY11igCQJUNzEDChnFYHCevLzkWQPfhbRFbN	827	1161	1161	1616148180000	orphaned
1513	3NKJPq9zeubLwnFQoxPs8rAi6WvZwmkZ22Pr4ZUhhfESTboNd3GF	1512	3NLZY8BUH2CRrAcKdiMinJDt39wYXPo1Cd8PPrKwqJFe82D1WcEp	1402	862	1	1	1493	jwXJwVWscffkRjy3EJ1emypYcRpacxLaqJvpQe3edDG5xbAQegi	828	1163	1163	1616148540000	orphaned
1516	3NLPtX24cWsjDafsuUDy7hbDGfjwn2BCasYnF8FNqs7udaXmrRfy	1515	3NLvDcwskRqcENA3wU7VLjtuXrr8zaK4eWrUC4ZTGw5S9etiruYF	1579	1143	1	1	1496	jxmWrbL5H37ZgCSb4iwqjygT6yw99WbkQUQLzfvUjhcj65e1ufR	830	1168	1168	1616149440000	canonical
1518	3NLwELLMrqvAG2zNDXG8buEvj8NM12eB47cv7cZU3CuKudkn3FEx	1516	3NLPtX24cWsjDafsuUDy7hbDGfjwn2BCasYnF8FNqs7udaXmrRfy	1577	1327	1	1	1498	jxmKBAwi5mjQda6X9uWRFyHGzTSQi76xLTGt4d1Em6xjMetS2AJ	831	1169	1169	1616149620000	orphaned
1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	1517	3NK4tKUTRm7g4nSN4BSCJ4vcWexymtaS3JBetnuegedwVxGotTfL	576	989	1	1	1500	jxzBYWSYDUJvrpAMbCpfwk7Nr8b9D41yCbeFyQTyQsawWjBvNUA	832	1171	1171	1616149980000	canonical
1519	3NKQGpUxicNinfNZEmtYo3sNCLggQ78x5nwUPrRKdFJuYddEUvG8	1517	3NK4tKUTRm7g4nSN4BSCJ4vcWexymtaS3JBetnuegedwVxGotTfL	1501	1360	1	1	1499	jxkRKix4VgTdnBhufA8cTHErwGGGdo8cDiD126vMn8W9ALFqbEG	832	1171	1171	1616149980000	orphaned
1521	3NLGpXKpABqGE4K91mRrVfV5UiQbJwp3qzPzs7FoxXuHuhr1kD31	1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	1406	1393	1	1	1501	jxDSchZf3YV7q3LY9FXdU8Ca8YfUchLY2dqFbrX4yDwJW53xao3	833	1173	1173	1616150340000	orphaned
1526	3NLtYom5YxiXoHAa5bqip76oWw8ZsHD8TArFpYipQcMCNxzQ8egz	1524	3NKuyYBaq44ruQBtcJR32n6gcH6vcPNj6CFUc6Dbf6DGchYYHjz4	1559	1353	1	1	1506	jwf6dw5wjtjNPgKJj7LCdZYtESQz9TYGwb3fLQw9zqfSAEHsCeB	835	1178	1178	1616151240000	orphaned
1532	3NLcWTxWgNjFGrEPyURyje3XNBoxbwVRSo1LnEaKbVPzyAFR9TpK	1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	1670	1156	1	1	1512	jwLCWc38EWGgsQBchaBe312JNPdDvAWxfqnbGzSMTF2b2uynNq3	839	1182	1182	1616151960000	orphaned
1535	3NLVAfm3qrR3x7EMsHkWr9RKKwmCXyCX9NhPqiYEqrj7hRw3Mq3Y	1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1406	1393	1	1	1515	jx1KZfLAMKNwx9m6YZhhvsptfn7VingoshL4WD3Xym3XJTacbzn	840	1183	1183	1616152140000	orphaned
7755	3NKtYJWegGo4t93S3Ry8rULXxdLYQYGHhqSw6TjFstfB4K9CbApb	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1651	1301	90	1	6301	jwzbzhfCV3hsorcDPKMHMuw2JbnPkMTF4dSsXCe74GnNokzppSg	4019	5674	5674	1616960520000	orphaned
1451	3NKQMRwgTr3q5oARzLAHNavQ4sd4EhyUjgitdsyauj6SPQysTmBe	1450	3NLQuUcXipQFAKhvMH4iPeTYW7jpYZPQB6r3Nzmnvyzob1xTxGS5	1581	778	1	1	1431	jwgnAhUx5Vqog8rZ1aMLFGzrQDEF7wgp59CKXzjUm5ipc4y9uuK	790	1108	1108	1616138640000	canonical
1454	3NLmsuNBkoTQbzd3k6tsfm5TXrQKkQNjyHEzNrAt4mYT26sLE3Gu	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	152	1330	1	1	1434	jxS2Kk3gwFtMaF55sKbVxAjZbjEXbxL9PbV7eeXeStqoT4QoPNR	793	1112	1112	1616139360000	canonical
1457	3NKRqDz47pT3MZcLuU53NYGkjEnoGabS4XDMLwes9mnsLTq9JsPP	1453	3NKfTzekUAYsJ5HZnEcdZbPnseq83vAAvnsvHjr4Y2wQseaEHPRK	1555	1221	1	1	1437	jxxZugd868wSky8UYK85Ey565KHJkz7bc2rXofhEj4kCo9ATY8F	793	1112	1112	1616139360000	orphaned
1463	3NLssf5upN9HjVHSXAaPieQPGeiysZwFExs11CSuP1pjfYzb3oHk	1454	3NLmsuNBkoTQbzd3k6tsfm5TXrQKkQNjyHEzNrAt4mYT26sLE3Gu	1633	1264	1	1	1443	jwAR5LoKNxja7cS7qDdwwqZnDWb2pzLsciJvk1qRtMnQ6gvxStZ	794	1118	1118	1616140440000	orphaned
1460	3NK6yytuUWB2EhQDcqVTM6pSimnrtvqtwGuEkqnuxuaQTqyRRrHF	1458	3NLR4s9FaXLKQraKmfBApzdY1QzXjT9iDWpf6qCX1B64CqEjofkQ	1637	816	1	1	1440	jwT8RfUgFWhmXfs6iPD1fxznMMwVcERgFYh6ApCKDQF8HrzA47p	795	1117	1117	1616140260000	canonical
1466	3NLbMv7zsYpzU8vQx4i79wu72diWEnFPtFGufosFHH6te62umTiY	1465	3NLLdRud8zJwBxttcpv2rdjCK3inpZCrDkxPBLkFwEuaBEFaVr34	1489	1134	1	1	1446	jx3pHkPThPUnJihCYpskRdzJEtZW5s3SzTjsxpGzSwwD8VZ9D84	799	1122	1122	1616141160000	canonical
1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1471	3NLxhDyZjM8tbPjAqzv8Wv2T2u5wauim9XSDdPRQsKG1bLB8erxA	42	1361	1	1	1453	jxnQt7BxZTs22LSbPwZcZeDEQjGJK9WuLTfviN8g748ktmWYMQ4	804	1128	1128	1616142240000	canonical
1474	3NKTmfGraGuJbF812EvTTi715AMxmwfntfNZnrwP7m7ZWPkvmVnu	1473	3NLtSpqaDWESneJBbZaCotxrgcxgxnjtHeQewugVHy3LVcUCLQFZ	1534	574	1	1	1454	jx2764sxCUAiDSS1biTqYEyZa2rLLRWgTNcJP1QchC1Ny8LARd9	805	1133	1133	1616143140000	orphaned
1483	3NLqCRaxCStHoGXghNSM4tqbJStR1e7ospznon3pWaSTuPSaWuBL	1482	3NLACJmMf7pmh1C35GJei5EzoiDWvq4G6FP5ziRZRKneEknCCtdE	563	1113	1	1	1463	jwdScn1rBn9Vt4PQDWa7XBj46vBx8PaXcPietA4EBt3fTtvR3Y8	809	1139	1139	1616144220000	canonical
1486	3NKziodSLp6NrW5unogfsLwBTLHF7M1pB7yJSd1kTt6JNT96tJ5a	1484	3NLTQyXk1d43fGpEb1ipT4daQC16NA8MuG3nfsdUAuh9fSfnWDXS	1624	1088	1	1	1466	jxi4sx3xQsLNE7cqvnBYtifgYBdPfNzGh2ckgQfHc6444nhgL8Z	811	1141	1141	1616144580000	canonical
1487	3NKptfB3kTW8S2yBQq5t6uYCEFVRHUskvxPrASJmozAG5DkyYPgP	1486	3NKziodSLp6NrW5unogfsLwBTLHF7M1pB7yJSd1kTt6JNT96tJ5a	1407	1395	1	1	1467	jxhCHec7mKGbNm7Qr7sfd43LxkxabUKDaKqqfjNeL1d1kwEMwho	812	1143	1143	1616144940000	canonical
1493	3NLEsPzdfSLBRv8WYKJ3CfaaoTUdwY4wUGXiqP13EwUxNHoeg4FA	1492	3NKss3AVVyw4LiTjFMH7k7z4ViFtudGBbYYKfwpiGhCtztexMhCZ	532	1303	1	1	1473	jy2tneeG39zMtDMPgvzdz79He7kgPf63DroXywLW66WNH3rsXbb	816	1147	1147	1616145660000	canonical
1497	3NKt1HXjgUGVcdKZmhoxRcrnVoBUQTa5Arnz8SmWPTARKh8mfqKo	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1405	869	1	1	1477	jxPYhWF5qAnmZiD8KSgdvqfqoEi8jXPddhCjyyWexhKc6pP2bmA	818	1151	1151	1616146380000	orphaned
1501	3NKh76NZdGJDoeYeMfYi3xmXVyouMz6Sd456uAW4P72rkzqvED6t	1500	3NLRhohgfsqkFQC895q2qCC4VaiECWetrvZyN9f3sNqnLcKGaGSn	1500	1297	1	1	1481	jxUyqLw5yWpQudhF5qraKqYQy3ijcT6cLT6L5GpTgqALLexTbaa	821	1154	1154	1616146920000	canonical
1502	3NLkBvGeHyceuL8zspmJj2DrJr3probZGcoMg6tsxMF7JeyxDrpt	1501	3NKh76NZdGJDoeYeMfYi3xmXVyouMz6Sd456uAW4P72rkzqvED6t	1445	1290	1	1	1482	jxff2Y9jFfp5Upv67pwKooFeKUgKaHRLa21ownvU8ZuDmryg2bV	822	1155	1155	1616147100000	canonical
1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1504	3NKEUpMwm81jqCSHH7Ai82pdbS2eEgoZaskoYBQd63AvCGFUyuKs	1650	1249	1	1	1485	jxqQwPCJYxCFCT4JU7PnGU3uRc7qnMBHwBrsTNfAVCm4iBAkdTc	825	1158	1158	1616147640000	canonical
1507	3NKaror93K4Rm8NwGbobhWfgkmACzyRoFGREgUNn3yW9VxWTtxVE	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	484	1073	1	1	1487	jxtTVPrN9ZWRTsidKf6k7uzxXQ2dwzdMgtEtV1hUwk5vtFNEyrs	826	1159	1159	1616147820000	orphaned
1517	3NK4tKUTRm7g4nSN4BSCJ4vcWexymtaS3JBetnuegedwVxGotTfL	1516	3NLPtX24cWsjDafsuUDy7hbDGfjwn2BCasYnF8FNqs7udaXmrRfy	1648	1284	1	1	1497	jxT5cpT1kA7JA7hBnXnRRkseFJqKVZuYwzAhfEgW3ojJ1RQxuiQ	831	1169	1169	1616149620000	canonical
1522	3NLUFmm5xNfqtnYoBwgqiRuyen67st6WwWw1sbKSKJPXMm47kuW5	1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	1671	1365	1	1	1502	jxchQGEwAq8pzdsWow7TqjV88pnFDiUqqhSnHYvqnDcP4Ba75ow	833	1173	1173	1616150340000	canonical
1523	3NLPCGZ8pvqromu6Kn6495UMiD4zk79vrikeGGePyBHnSQ1RqAFs	1520	3NLgW2fnMJ1JYsp27435jn3KRGDE2MDZSUUEjhV5UXWh8Z4WgvM8	532	1303	1	1	1503	jwcGjACrzA5K4paHaKyafu3QW3Hf5ev2W4ysggFwaCUxamEmzyT	833	1173	1173	1616150340000	orphaned
1524	3NKuyYBaq44ruQBtcJR32n6gcH6vcPNj6CFUc6Dbf6DGchYYHjz4	1522	3NLUFmm5xNfqtnYoBwgqiRuyen67st6WwWw1sbKSKJPXMm47kuW5	1474	1329	1	1	1504	jxufxWX6cRQcEVwgsgdPQJjBmsYpS9UCMWWLs173sykecAoemtW	834	1174	1174	1616150520000	canonical
1525	3NLLR8fT2pwYfCPYShk1D2JZd71u5snsMRncneHCivLXBR6rT93M	1524	3NKuyYBaq44ruQBtcJR32n6gcH6vcPNj6CFUc6Dbf6DGchYYHjz4	1407	1395	1	1	1505	jwE4eH6m5PDPshsQwrQnDtwEkU36aKXqJw2CytHAVXiR4KSQ6J9	835	1178	1178	1616151240000	canonical
1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	1525	3NLLR8fT2pwYfCPYShk1D2JZd71u5snsMRncneHCivLXBR6rT93M	1406	1393	1	1	1507	jxCcpCFPMGj9E7ULGri17ZsKKCZmzMjX83K4bKHK5kYknjjQYNf	836	1179	1179	1616151420000	canonical
1528	3NLJ4X6yV2WzJ8ibBFpme52jzyGrnLXSNc3oyhoHEYAAdzqGqh6C	1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	369	1066	1	1	1508	jwpfPRZD46i2huWiSyyhtuneNMqjpCTic2Rca2X1ukzbBVfk5Qf	837	1180	1180	1616151600000	canonical
1529	3NL6NB2EskXEbG58NfAVZj1BLuDomWnBYEqFz8SkFWZ2efP72idL	1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	1619	1275	1	1	1509	jwo47UNS17yCUfWXmEamYmDSe4ovvU72xbyuRciLn4UDzdmEfWt	837	1180	1180	1616151600000	orphaned
1530	3NLgRYRn7cwSj9gvJD5nn7Z5yWpDHSDU3HdZpUY3Uv9ANJbo9SNT	1527	3NLsrhpRbSmMxVA3k1qFrPabAExUbJNnUHMrcJbP36i8tftcMRSf	1578	1170	1	1	1510	jw96ucSJjqY5zVcoUykx677hs2NbxfKndDoafo3WFFaGAW3eY4w	837	1180	1180	1616151600000	orphaned
1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	1528	3NLJ4X6yV2WzJ8ibBFpme52jzyGrnLXSNc3oyhoHEYAAdzqGqh6C	1406	1393	1	1	1511	jwJzd1mDcmBLPGqtV7oCYu2KgTHDqrYdNMP2TPtbKy3C3QgNaF4	838	1181	1181	1616151780000	canonical
1533	3NKWwwhQ23R7YRSKfvDJpBpZYVcHvkMQZMVagXzQDNXyLhvYNvsR	1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	311	1307	1	1	1513	jwKL3sSyaUh4SnWLCSv6E1YXYwWP228xuT9tdBCtgxmTNXWGm4z	839	1182	1182	1616151960000	orphaned
1536	3NLgnXSKN7gjTvkhFmDeGh3TQavjeihYregFwyFh5Z1o7UupyVFe	1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1651	935	1	1	1516	jwEqUazAMh2rQ24MzEye5qPb1P9Qqgfd9Jv5dQCHnVFqiRFznEs	840	1183	1183	1616152140000	orphaned
7772	3NKkqxPKX4TVKxD2P141KtcEunUQkiRQ6tok6bauyUoBpH9WeuWL	7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	1675	1342	90	1	6301	jwsTw2reZsgd5iPRtEuKNieNPnfTuL1i54qPqFQZuJfzCrkc3cY	4030	5689	5689	1616963220000	orphaned
1594	3NKt7CWiXWUnibW6TqGQeduFWdeyeKGg5LytviGEaCmmjUGjgeng	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1422	971	1	1	1571	jxNvYKhPW7iSPEoQCAvGnyg2CNJyf2mfvqVi4TQsSDSjt5soABr	785	1215	1215	1616157900000	orphaned
1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1531	3NLVo5p8hAB8iVvRjK4iXoBbHJPpW5o9bBZpudh6h3EAoiZkU5qN	1581	778	1	1	1514	jwuX78UtX8v4evN72JQopHaroiRZ6i1J5SxAjSVfU6kmrBe2C59	839	1182	1182	1616151960000	canonical
1537	3NLpiQEC5rgySgfG2LUVxbktEYrCD9gzMe3zUrqmJ14zJauAmxZ9	1534	3NKm4FTvc5Ppbu3ejz8braQVqaiAgJnELe7fEYyrbsckUGVmYer9	1651	935	1	1	1516	jxy1312bjkeX9vjGc11oPWkGcoAAXmxRQa1442i1DLU2kgUfNhE	840	1183	1183	1616152140000	canonical
1541	3NK6YhC2AncGSdPhVatyQ93WjKNUz6o7W7CV438mQQwyBJXPTXJJ	1537	3NLpiQEC5rgySgfG2LUVxbktEYrCD9gzMe3zUrqmJ14zJauAmxZ9	1560	1045	1	1	1520	jxbpnQciBX95z2XQKgT5j1bvVkNsuYYSKieKLPLigPFPSvio6zW	841	1185	1185	1616152500000	orphaned
1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1538	3NL8afoEJTxTGYXAL3HH1PHH2TceyuNQyqbhxnJYddXvRFQ1JzLL	1407	1395	1	1	1521	jwHbySmzTTwfRpTzttCvQ8LPovRphE9ATMPV9kPVhQ4fh6H487D	842	1185	1185	1616152500000	canonical
1539	3NKLVUmZ8jPq7DE6z9fruEUAxrdCXDZcGGBiQ2PjXx542MKLH96e	1538	3NL8afoEJTxTGYXAL3HH1PHH2TceyuNQyqbhxnJYddXvRFQ1JzLL	1406	1393	1	1	1518	jxDfWsuhG7p1UwxqSYCCKVXed6WBqRjVpvnQsjXsfsbU6Xr5SAV	842	1185	1185	1616152500000	orphaned
1546	3NLKwfJVeefVYjAqAU4QSm3SgxgVtB3dFCduF6ByBcVuFvHrFkvP	1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1407	1395	1	1	1525	jxVsMZD4VyL6QwcVC6yaNYaJHwL43rwc1dfY13AGyzMhjnVsNRA	843	1186	1186	1616152680000	canonical
1545	3NKQsWTryzYp9SpjAs1wmLTD5E2M4xpiLyPWe9tgwJV1mDDmDZhV	1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1406	1393	1	1	1524	jwZU4rb4e5XRnmVcaTmUNFgHRtmzGSYWXdLpgv62TnFYCVvJAvW	843	1186	1186	1616152680000	orphaned
1549	3NLom155tPZorNjukV3iBZyBvzxWXDUAeMErKw7mBLBHvF3H8iV6	1546	3NLKwfJVeefVYjAqAU4QSm3SgxgVtB3dFCduF6ByBcVuFvHrFkvP	1559	1353	1	1	1528	jxjihEktiJthiCp5s1o1fQoBx5a7xSYjU6DSoqAZLCr6A4FBsq8	844	1187	1187	1616152860000	orphaned
1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	1548	3NKY9aXSu6nkdX7oJuLP6EbVQwxuLiEBk4LBLjc7Q5iUhrr5qsqQ	1654	1340	1	1	1529	jxqumMumVf1asvN6VizbWZAbDQaKKt6kmpv3wEjZbtikNdQpe7L	845	1189	1189	1616153220000	canonical
1555	3NLUfbe9VRgsicNgczHb82faQ8G86ZxyQPYy8KTNdzP1tzgYMm4Z	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	1501	1360	2	1	1533	jxz1AB9NPhieecYuMQfhSJ4UyfP8Y8CDWwEuHtPXrrXoUuVWWX6	846	1190	1190	1616153400000	canonical
1553	3NL98rqLgx2My4PphGzqRx7dB6VnNa6V8uLX8VQbaoaKXXhfwA8V	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	369	1312	2	1	1531	jwXpD4esoiVsPKZNrxzQYbsQh42hXS5PqiqhbCKJw6Mfm2vJZdm	846	1190	1190	1616153400000	orphaned
1557	3NKiLkbBVHutcbutynSKUTApL33wKxasAWT6royyfXTduaYLHvrV	1555	3NLUfbe9VRgsicNgczHb82faQ8G86ZxyQPYy8KTNdzP1tzgYMm4Z	1590	1174	2	1	1534	jxRWtqij9rtLacD5WzpT935GwEv5uh1bDm43y3Ujt8KD6KUKHrC	847	1191	1191	1616153580000	canonical
1559	3NKfR7AqBTyYWDBKTQkTeUCibSjFp65Psppbm2kn5cfxNb2beTUe	1558	3NL848qYhQcEVYMiJU2zeVBNnCdaJrzKSkV8GZnrxWpPy2LiLA3j	1407	1395	2	1	1536	jwxMRiT8hGKfoy8ZPkRxdggWDJGwM5hKNuDPjQWMKRDZZreSrcu	849	1194	1194	1616154120000	canonical
1564	3NLXD7DkyrC9pvUm8XjJWViKLA3b52J7G8rRTgHFZKBUC9kXLuzZ	1561	3NLNC2QXYVL4SGe5fRDs4hJNrtLx1yBMkRobiJ9kB5gTQn1TuX5P	1673	1368	2	1	1541	jxRgDrCZP4abSf2aRshXZat4Z3iLNDwH3pTDK8RgHtuHYVqgJzh	851	1196	1196	1616154480000	orphaned
1565	3NKg3BXWGuNjjzsvVQnRSRUQTAfegmJerbPqzttKBxpMJidLCwMr	1563	3NLwrDFGBeYz1G7xiK6dfAN6dt64dYDYQLTMhWp1dSJ5DLKpZK2h	1509	1320	2	1	1542	jxCLZR1YNAswafKnq9FSTyEPdv58km9YyAktHaBqsqTdWLR3qau	852	1197	1197	1616154660000	orphaned
1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	1567	3NKw5SMBiJP6HPMpuVgJUBprtqAnL7bX2SuimRX5HBzUKHfHUuLr	1675	1096	2	1	1545	jxi5cpNbKpQ66dUeu2vz3LD23uSNxU16CvjDsZCxUmADutLrhZZ	854	1200	1200	1616155200000	canonical
1571	3NLUFTnAycuXEkiVPKNivJ4vP1HBaJ7fyh8NC1qQb7Zg2Z4R8tEG	1569	3NKGMemSn5zKH7WN5nYbU3v7i9MEcUqCET4zMAZVYChwLdcopvKC	1637	816	2	1	1548	jwP6Sqe3U7AxEuxXEAByBoiYDqVTHoyb89ugpr9paPAre6rt78h	856	1202	1202	1616155560000	canonical
1574	3NKqrDu8w8eyeqzfPNn9skin9D5gLsBmUAnqCC9HsUpKgeHRoWRx	1571	3NLUFTnAycuXEkiVPKNivJ4vP1HBaJ7fyh8NC1qQb7Zg2Z4R8tEG	171	1374	2	1	1551	jxgPHANmvCkGZBCQdR1W7Ld77iXqZW1y4GbWwv7UyxoF5r4R5cJ	857	1203	1203	1616155740000	orphaned
1576	3NKg9jxkfSWv3hLq8dmXcWNL6igC7p4t6ND6QAvbphQiDw88RnTn	1573	3NKKNqAmC7UmCFevyHeavTnWSAmKce5tVcTqDCPwm3gpF5it5wg5	1637	816	2	1	1553	jwDfuR7no4y83oQXvGpoxo4sabBupC878TpsZgF6oVMR8LimDR9	858	1204	1204	1616155920000	orphaned
1577	3NLDBve7E6nKacvFPKMw97wLHUhJGkEwrtVxVHY3YTRQbUYdr8Jc	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1406	1393	2	1	1554	jwx1MADGRQMr13cAW2fZWDsNW6UQEbnbWvmRSGE1Lh751VuqVfM	859	1205	1205	1616156100000	canonical
1580	3NLVu6PLj8qfgde25pUWHz42ps2FD2rWK346Lc3DspQ1d8GCBHDS	1577	3NLDBve7E6nKacvFPKMw97wLHUhJGkEwrtVxVHY3YTRQbUYdr8Jc	1541	1172	2	1	1557	jx3Xkg2bZiKL8dmzd4B3pz9bhpmtMtbDLHUHQu6hyE2Q5BdeKSR	860	1208	1208	1616156640000	orphaned
1586	3NK58tJ3nQ6LP2BVhFviDaV4wf6sa2n9MF78hEgEYGTFeK1DodSr	1584	3NKkLChFu237ig39DctBwrpHtotLXFj4GrcSLgQjXp6ih3P1M33d	1406	1393	2	1	1563	jwpgUxpUX9PYtZn561jUUrvmJTc4o9LXN6SC8Mi7L5jcNxyzDS2	862	1210	1210	1616157000000	canonical
1592	3NLjKVeE1GC4mG6zXYPVUMFkRLQEkgnoCZLuGcW8QMd9rstLF9kJ	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1406	1393	2	1	1569	jwzc45TL5yGYwVPknr4fv6J1AxRZPzAni6tjdCjDiXKrEXLHWEN	866	1215	1215	1616157900000	orphaned
1596	3NKxpTNzMQ6p3sY1TGkyr7U5URgeqwLQcAntVsPn3UsiD1d1Agd4	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1541	1172	2	1	1573	jwUWya5gFAeqKtiZRwtVkuuo5BfDvHQvEvY3sJTHWu6Fa3EWKYx	866	1215	1215	1616157900000	orphaned
1604	3NLoqfQnXNjUkJtboNpkdQgPrjLFUM1MaoEG9AgdvGWf7UBu8ZZB	1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1460	1198	2	1	1581	jwz7GkvNtSQmUMhhMZguGRDexG12GkVMFKMp5z8yf5hPdRiFpR2	867	1217	1217	1616158260000	canonical
1601	3NKARMHo24dYiYqd9wYHjnc35kHMVSDaFbGuHPNaUqZVHcsNZRKa	1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1560	170	2	1	1578	jxLdvgqWqCvhf6zYT17hU8xQ4tcVaVTdM9uMvNaLmX2xnowsZds	867	1217	1217	1616158260000	orphaned
1606	3NKs1T6W6eXEtE8AXFP73yywKSKX4moEhAerYpD5fS5kpDArQBtd	1604	3NLoqfQnXNjUkJtboNpkdQgPrjLFUM1MaoEG9AgdvGWf7UBu8ZZB	448	1305	2	1	1583	jwxrtthephM7WwCKyEa9oWnccNLx3HMv1bzrY6DKYeGXxjhknZu	868	1219	1219	1616158620000	canonical
1607	3NLcg4pi33Vvy9Xkq7Ytizjht9JuLawS72VtV7GVhGPGGKybSsdg	1606	3NKs1T6W6eXEtE8AXFP73yywKSKX4moEhAerYpD5fS5kpDArQBtd	1406	1393	2	1	1584	jxzzCg7UpSW9L2t9ivULS48mDvQSBxADsttaGFNWhgc8nRAoW3c	869	1220	1220	1616158800000	canonical
7773	3NK8XkT5Coqi4BeFs3ySWxGvbK6DMSpeHHa2dSTBXw4P5DfaFVH1	7770	3NLEoKiHEtxLokyo3tsTYoYnisTBnBr6KwS7XuvTvbHFWHjaSf4E	1403	782	90	1	6301	jwqChgaNkj7q1mqysMwhrqhvLLVZrXoyHaPhH276SnN4s1ZAAe3	4031	5690	5690	1616963400000	canonical
1544	3NLxVegm4TVMvpvMZctF5McseACaPVqFgv2UirYgbjKKVM5NQ2zi	1257	3NKbU3cMDzCGRidnXarMJiTBUWzQeNjQuBh1DNw1cyFHEzxBNN7x	1560	1045	1	1	1523	jxU3mZBubsK7qUtrxRud2wPMoPwNuNR9mtLXdWCR4mnzwGTZ4Ub	696	1185	1185	1616152595105	orphaned
1611	3NLaAhEdxUp2muvDvxqvoXbaVXo2koiLtk6Zav79K3vYFnr4SmUc	1594	3NKt7CWiXWUnibW6TqGQeduFWdeyeKGg5LytviGEaCmmjUGjgeng	1422	971	1	1	1588	jwCQqXXWAb5WBW9rfLsS75yPjhrbv3N8SkdPmBxndiMFbUMWtmf	786	1227	1227	1616160060000	orphaned
1551	3NKrGzj6UhCdCRCdHk1x5KVxpcBCUNvYkLJraf8jmUGQi5eFXvES	1548	3NKY9aXSu6nkdX7oJuLP6EbVQwxuLiEBk4LBLjc7Q5iUhrr5qsqQ	1587	1357	1	1	1530	jxdjuEiMoR14E6vEcnqgcDS3ecBwpiLBve5Re14wd8UYA3mDdEk	845	1189	1189	1616153220000	orphaned
1552	3NLpRw9JuWKuD3XXKFoskF5JeMQBvw5XGArpYPV9XavbYgyJEfRS	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	369	1312	1	1	1531	jwzpHDjJdnbbodSeBp83W2nsxWC8A3UYg81wgrsWPWBRcKHp6Fw	846	1190	1190	1616153400000	orphaned
1554	3NLnNAZkb9W9VUz1pDC2hvg74225FGhgV4RKTPvDAwGBfokTFfeU	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	1642	1367	2	1	1532	jxtuGgfmTpVEFhGcb4FAAW2d13mxjWSeAQPCqVsJH5fzfVimqnt	846	1190	1190	1616153400000	orphaned
1558	3NL848qYhQcEVYMiJU2zeVBNnCdaJrzKSkV8GZnrxWpPy2LiLA3j	1557	3NKiLkbBVHutcbutynSKUTApL33wKxasAWT6royyfXTduaYLHvrV	171	1128	2	1	1535	jwzdyLtuTbteeJcSztwe1ZY3xM5cNpyd7U1eAxfUdFoYmGsa5uR	848	1192	1192	1616153760000	canonical
1560	3NKZhuWL7rTQ5pmfxkGUtZfugBTrLV14C6ZhjDB7fS2nEK6nX8EY	1558	3NL848qYhQcEVYMiJU2zeVBNnCdaJrzKSkV8GZnrxWpPy2LiLA3j	1522	1322	2	1	1537	jxxTyQ27NJZzkPkrwfkCuDQq7nc21RYRSJ5VkbuHKw1VPuZnVfV	849	1194	1194	1616154120000	orphaned
1561	3NLNC2QXYVL4SGe5fRDs4hJNrtLx1yBMkRobiJ9kB5gTQn1TuX5P	1559	3NKfR7AqBTyYWDBKTQkTeUCibSjFp65Psppbm2kn5cfxNb2beTUe	1501	1114	2	1	1538	jxVQojsxiFmCmJyPkhApa92yeCrib1Fb6vbxUtBw1oh6agJ3kJM	850	1195	1195	1616154300000	canonical
1562	3NKZ2ELogKzEd7TkcHWhKGUH7gT1yyVBFB3A2qPFba8JwHbg8h1F	1559	3NKfR7AqBTyYWDBKTQkTeUCibSjFp65Psppbm2kn5cfxNb2beTUe	1596	1363	2	1	1539	jxqR3w9yBPGQT4kZeMBYUCkRSt3Pq4PnSC2s7oJdgBvGkhTLbCb	850	1195	1195	1616154300000	orphaned
1563	3NLwrDFGBeYz1G7xiK6dfAN6dt64dYDYQLTMhWp1dSJ5DLKpZK2h	1561	3NLNC2QXYVL4SGe5fRDs4hJNrtLx1yBMkRobiJ9kB5gTQn1TuX5P	1407	1395	2	1	1540	jwkJMoax4hv5vTVPassjgu9UM884tJ9PLvcm4GZ9Yw7BtdbW2tz	851	1196	1196	1616154480000	canonical
1566	3NLsqGoQvUfrattqimnYgbGRGTRd2hLJbUVuLqxEXNYp3fGGtHD1	1563	3NLwrDFGBeYz1G7xiK6dfAN6dt64dYDYQLTMhWp1dSJ5DLKpZK2h	1607	1348	2	1	1543	jwmawk9HWgD6oMrCn9ybpqbZQCyeHnx4ZnihD8Wu8na5oVcFngq	852	1197	1197	1616154660000	canonical
1569	3NKGMemSn5zKH7WN5nYbU3v7i9MEcUqCET4zMAZVYChwLdcopvKC	1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	1637	816	2	1	1546	jxF8tRicuzCb2d5v7d6LJm6Tn4tZDkd9ctHu6ug26WfkvnS9x8h	855	1201	1201	1616155380000	canonical
1572	3NKJ8oVmrwXohEVwMjPiJnr273e3iXaTVg1fuU1RsHJ4FLWh7i36	1569	3NKGMemSn5zKH7WN5nYbU3v7i9MEcUqCET4zMAZVYChwLdcopvKC	1611	1341	2	1	1549	jxF5e41xZ8hVb5mNDDsTGTV8KTGHdVNgwxS97jtZJVd71b6cmFq	856	1202	1202	1616155560000	orphaned
1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1573	3NKKNqAmC7UmCFevyHeavTnWSAmKce5tVcTqDCPwm3gpF5it5wg5	632	1136	2	1	1552	jwGyrdyrQ9Dx4uHMQfTLyUQEhDV3LwTicDgepiJv1NDk7B2oRdL	858	1204	1204	1616155920000	canonical
1603	3NK5Zc6uKKSgnWspM5Nvng5NTEomyZUYQYC5FC57Mr5awteCZeHJ	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1460	1198	2	1	1580	jwWDHA8vKUojaNACEpAW4U2T9f288z5WhvSd9JcWBNBVfioVjpb	859	1217	1217	1616158260000	orphaned
1583	3NKqKfLepectgunwQ4JCZkKLkyazrT6yoQ9exaBv6ZBXhBcdtB1Y	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1642	1367	2	1	1560	jwsFPm9QhHiHzVYqysFZkk77GrQQfQLMi6Wd3R1JXv5SmiJDN43	861	1209	1209	1616156820000	orphaned
1589	3NKQusUP7qC2enj1z26YBJurA2ryDVcuPsrdUnbXE2NBMKkwHBQk	1586	3NK58tJ3nQ6LP2BVhFviDaV4wf6sa2n9MF78hEgEYGTFeK1DodSr	1407	1395	2	1	1566	jw9fBwzwvbrYyEBHr6nhPJqHbhaSt6KgwaE1zKSSA3aMQZgMVxP	863	1211	1211	1616157180000	canonical
1590	3NKsHaB1rz4QW5SMqEE7ZBs43ypFwiJRTS8iYpkbDmG4MA8sZUkB	1589	3NKQusUP7qC2enj1z26YBJurA2ryDVcuPsrdUnbXE2NBMKkwHBQk	369	1312	2	1	1567	jwS6fuSygTxgQNWtgsct9ej2iL5QDPKwyLGmMqVWsnfVkmw7D3M	864	1212	1212	1616157360000	canonical
1599	3NLEe415pFZGH2m95wox3ULbad5YNRCBSPkfKhuPH1u2dpAA1tJY	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1631	793	2	1	1576	jwa1EcGCLJ2xBkW8hHWCjSvMkybFBahBqZ2hFB5QVa8MHCA5bXA	866	1215	1215	1616157900000	orphaned
1605	3NLbRheqrDUuq1UGPJ2sJbtGxgkcrWsrwkS7pz4NqekY59e9HuxB	1604	3NLoqfQnXNjUkJtboNpkdQgPrjLFUM1MaoEG9AgdvGWf7UBu8ZZB	1406	1393	2	1	1582	jwRTq8y5ZwkKt8o6o4cJeQZyxsXDhGeNNuYsN6aVvcuk7RXpEaY	868	1219	1219	1616158620000	orphaned
1609	3NKUvJtHwNdAmYAbcryiqGvKvTHcrzsGbWR1QhFFBvgZkmdsyU7n	1607	3NLcg4pi33Vvy9Xkq7Ytizjht9JuLawS72VtV7GVhGPGGKybSsdg	1649	1137	2	1	1586	jwX8FkSbGdiJ5Bj1XoVy3G7ZCJ6XtJGCNPknzGtrxZv3LhiATBp	870	1222	1222	1616159160000	canonical
1610	3NKfyDu2u7AsBXcgrJ5NsPEVygKbvj8BVYtLo69tbpQzJzdzsbWY	1609	3NKUvJtHwNdAmYAbcryiqGvKvTHcrzsGbWR1QhFFBvgZkmdsyU7n	1407	1395	2	1	1587	jwoSLUhrEt6dps3tgctTNE6JEvm6DxQe6xLJkbGsSks2VxbYDMy	871	1223	1223	1616159340000	canonical
1614	3NKDvbYgMWk7tSCuvJ5c9Htt42WfW5P8hZWqKPNZp9RgDK8FLCXz	1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	448	1059	2	1	1591	jxg8cxvL8h8k9Q6er3rJRtzcs2jXen5Yeqp5SXquLz1v6cYniJe	873	1228	1228	1616160240000	orphaned
1616	3NKjcVXWi39NNtZWMRHjjJw27jXsMkCVHnUcWZjHGH856DFaJmRu	1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	298	1308	2	1	1593	jxRFskpkUfmJNDco9etD4NeG4bxHGjAmT7BMVeptGsXdN9SR9T5	873	1228	1228	1616160240000	orphaned
1617	3NLPcf8GoatZKNeBwoSAsgiSzByyoCFWUm2thxGVsDx767RCEy5M	1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	1503	911	2	1	1594	jxT4VgswBfcU1VpeH6fN7CtdRDmWbc9J8LjhBZ5eeFnJxRi8zs3	874	1229	1229	1616160420000	canonical
1618	3NKo8mmSWd8SfJpbHR9XhyEx1kcnYAqhxVdsZixc131etraUfShu	1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	42	1115	2	1	1595	jxs3cenEab6Bk6k3wY1CtuyQxRUD7SdnXPbV5nu2PtuCbbKEGcQ	874	1229	1229	1616160420000	orphaned
1619	3NK9qeGpJwbXbHTjkHCM3ZUZeuG9V7JFrZaLe4qsaXEaqHzVQnAZ	1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	1631	794	2	1	1596	jxbxkFzG4Kh6q4RtFmb8StYbBEpwKFqhWwhsTpaxLKXhcz7NwQb	874	1229	1229	1616160420000	orphaned
1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1617	3NLPcf8GoatZKNeBwoSAsgiSzByyoCFWUm2thxGVsDx767RCEy5M	1403	824	2	1	1597	jxqBX4UVSnuNYYamifd5qVuQRqnGGAijDqne8df1RrknP2i43hh	875	1230	1230	1616160600000	canonical
1622	3NKy81fqwvu2ycBdZzJb1HEfczHhGcc8zrBi1J7t9bHsCJFtr4yJ	1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1489	1254	2	1	1599	jwky2PaGdJYTM1N8ckvLfSbwccnXpYbC6bPKEBDprNXmiTV4AyY	876	1231	1231	1616160780000	orphaned
7784	3NLag5ywoPaiM85uWKwqWcUE89iUJcL2TufLz634cD3apnpp6Edx	7783	3NKsRnQom2DERuzPUwwLyT9qH1yK7PRe6V8rTSgJDjqrCmP7QAyd	1406	1393	90	1	6301	jwfA5QJLchfiJaR1JSxhTdwFdEV66jhSuT5zoXJ8jFodTqW4ojZ	4036	5696	5696	1616964480000	orphaned
10137	3NKu4zLP4vU6h3x1y3W7FDFxp7qVLPrCfi2176ptVntmbHjDEGwo	9998	3NL2f54NN5uZn34RwwgYJxnu5kbqSGRmQKLdr9yfhHpWnefdS3H8	1643	1299	125	6301	6623	jxWp9eBoZtV4oc2UB5XddqmpYBc2UkDbJSRFWWohfLAxXF3ChBM	5028	7401	7401	1617271380000	orphaned
1608	3NKfV9ERfCSMkWntkM6QetqFsm8wKNc6m4cX6zZ7xYSSff7gv7M4	1436	3NLh6gXuvFZ4pecJQ6gZTY3JM9dDdf8SNvkbh4ohXQWTW6BAc63E	1397	828	1	1	1585	jwLcXVbrQy1F9etXBTHV4bLkd7V9eoFpy7FZi6cPaWTCKqrv6Me	783	1220	1220	1616158800000	orphaned
1600	3NLfPqD9EjdnQViZvBUzaRnjegF41XPMhm9HdLBQuDhNTiBxP8yu	1542	3NKRJBP5BBAqJ2ynQqVWB5imyRjPmNJ6e7FCjkdnNdNrfobLM26C	1560	170	1	1	1577	jx4zESQbSuJ1iX6ZAFwyb9Lx65nMJFv8XedEQroTko68euaNd8r	843	1217	1217	1616158260000	orphaned
1567	3NKw5SMBiJP6HPMpuVgJUBprtqAnL7bX2SuimRX5HBzUKHfHUuLr	1566	3NLsqGoQvUfrattqimnYgbGRGTRd2hLJbUVuLqxEXNYp3fGGtHD1	43	1184	2	1	1544	jx8MQmg3sgdT2GvAiyZwt7eBAyb6ecN6dkHvpRAZQE4UqT1otCg	853	1199	1199	1616155020000	canonical
1570	3NLhyvFS8aAD6qU2tbZVLAFjpgWWQDymh99YUVcdWW46cc2QutiG	1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	171	1374	2	1	1547	jwi1W7R8fQfmhWfjbYzV12HLetnoBqRNjocuQHQHyoZa4VXYyFa	855	1201	1201	1616155380000	orphaned
1573	3NKKNqAmC7UmCFevyHeavTnWSAmKce5tVcTqDCPwm3gpF5it5wg5	1571	3NLUFTnAycuXEkiVPKNivJ4vP1HBaJ7fyh8NC1qQb7Zg2Z4R8tEG	1406	1393	2	1	1550	jwdaYMhAKVzqJoBaDAib5Mscn3A918yg4A3NNU6PwJWtEnH7VTN	857	1203	1203	1616155740000	canonical
1578	3NLhpzmDBhWv8zfuTeaZZiL7RygLY1oRwf7gnxfXWDFL9GE5WgP7	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	519	536	2	1	1555	jxxwaPLCkLAmi1ZK6bbDmNLGot1U9y1FGdTFeXyTKqL9L7LCh5A	859	1205	1205	1616156100000	orphaned
1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1577	3NLDBve7E6nKacvFPKMw97wLHUhJGkEwrtVxVHY3YTRQbUYdr8Jc	1407	1395	2	1	1558	jwPYwLW6Vaq522edrdKAV9fyzKrdmhc8PVKMsm2NhAMzDcMFyZ8	860	1208	1208	1616156640000	canonical
1584	3NKkLChFu237ig39DctBwrpHtotLXFj4GrcSLgQjXp6ih3P1M33d	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1647	846	2	1	1561	jxRb2KreXRMWJyN5y8LyXvV8L3h5WkaLw3nhnW6LbGc2wJqdkq7	861	1209	1209	1616156820000	canonical
1582	3NLUh4Z8pLCruzs5oRFEfbVKnVwnzs1c84BmjD46JBgGQ6dorUq7	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1654	1340	2	1	1559	jx4BAyrjKLxgHgF84JBmiRu4zA5ucB5xYUB7K25AuEoQWBxAxTV	861	1209	1209	1616156820000	orphaned
1587	3NKenyjhCFkCZcvsEguvqP4pwMcyUW68XV5cE4WUwqQ7Tv2VmNW5	1584	3NKkLChFu237ig39DctBwrpHtotLXFj4GrcSLgQjXp6ih3P1M33d	576	1355	2	1	1564	jxzMhinNWaEXfmRQYhbUWNNaKixQwEyXX4J2Nx2zdoR8opXeoNt	862	1210	1210	1616157000000	orphaned
1588	3NL7B2yYytNfVJunoL1D4JiiL9FuD8pTeca7z8NNJrz4JBtAXkQg	1586	3NK58tJ3nQ6LP2BVhFviDaV4wf6sa2n9MF78hEgEYGTFeK1DodSr	470	1063	2	1	1565	jwm2B2Yc5M5PtUUtViLfT4j7o3r59bcq4wo9kWXShNzUTP1egWQ	863	1211	1211	1616157180000	orphaned
1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1590	3NKsHaB1rz4QW5SMqEE7ZBs43ypFwiJRTS8iYpkbDmG4MA8sZUkB	1407	1395	2	1	1568	jwi9FBdzLvqb7hwnhtSC9c82xhRcVVxYuyjYNxeE8MkEudhyTgp	865	1214	1214	1616157720000	canonical
1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1476	1245	2	1	1575	jwpdtYJPcf2QX1TPDxehtJoeFT9DPdz1W2qoJaHVFzSSvrpUb2U	866	1215	1215	1616157900000	canonical
1593	3NLh1HzU6qRXkf98wQzgPACPNQcYHMrcxYAhxi4ypBb5UgSXZ6WG	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1422	971	2	1	1570	jxSvXuZEkGCbe7SBbNnFujTeza6j47xHfEtuUHafjFDRZ8ZeNMh	866	1215	1215	1616157900000	orphaned
1602	3NLqApn8PjYurTfU3D1ZdSmwRFrxKGvt4ST3dV8jiRBAtWiFcGKq	1598	3NKZVMvJWrwQhMpvDPRJzn1zkHaU16vGoX89ovP8EenjCcbNW7mN	1447	1345	2	1	1579	jxvF2w8ZXRBJZYZvkMRxJ4XYVQSyonKx61UJSR8S3QwsxagpJaN	867	1217	1217	1616158260000	orphaned
1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	1610	3NKfyDu2u7AsBXcgrJ5NsPEVygKbvj8BVYtLo69tbpQzJzdzsbWY	1477	984	2	1	1590	jxYBLWZoSzfzKZe3LeYRwPv8823oq1WQ8ndf2qEVs7Ffm9JkACz	872	1227	1227	1616160060000	canonical
1612	3NKSF4pVBBVZm5VtRHFTjcjiMx3z9U1tZzue15Y5CwUbw8saBRPM	1610	3NKfyDu2u7AsBXcgrJ5NsPEVygKbvj8BVYtLo69tbpQzJzdzsbWY	1422	971	2	1	1589	jwXzdWn9Hv5dTD7qCCF15n2WxUjr21wiVW5YdMuvW1ZvxJ3SsxC	872	1227	1227	1616160060000	orphaned
1615	3NL3rj768NVGgVQsbyxatjfhzgtn2ZYWWNExpC6v49uV9e3gCE6q	1613	3NLhgCrsexnSPYnxwNswiHpSaJouQbksbnjditJXEAsxiudL2bge	1490	1274	2	1	1592	jxHLR4X1bEXxGssNx8ZxLzKDgzwwEAj1yuVfCfWhUSdfB1K8c6w	873	1228	1228	1616160240000	canonical
1621	3NLB2GXjVNkcnHy6eUyQRPhCdvtowP1fU1DC6NhvRMnm8A3TMGn4	1617	3NLPcf8GoatZKNeBwoSAsgiSzByyoCFWUm2thxGVsDx767RCEy5M	1407	1395	2	1	1598	jxCcXYFBdipF7oCCucagF4RbZ3RGAnkGJ8A3t3RRry5ykQKpaNr	875	1230	1230	1616160600000	orphaned
1625	3NKwdEXBdxiUhNL9PzhbhJpQgmz5W1bRcKCN74mMRhVfDr4fDEqk	1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1597	274	2	1	1602	jxsANmvrs6MPYkfTfNDrfAzE9UrCwS4B4qySb5expLbvimmKKnj	876	1231	1231	1616160780000	canonical
1623	3NKzuNdjCUB6FnJUX1KimcgPRA2E9vqhrQjdCsm4VvXwgLLHZDyT	1620	3NLM4buWv9ZxBthZ4nousGxWw3UWq8rdhvLo2iZDABqo2uNpCuuF	1501	994	2	1	1600	jwBPaWDdZM4RzM8HhJ1GrGq1HGr5ww3mnHuZuMUSKtVz1NdAq4d	876	1231	1231	1616160780000	orphaned
1626	3NKZinyAGrweyVMxao2ymmZ33JNZbPtsv6euZ3uNoZffGtBm9Xry	1625	3NKwdEXBdxiUhNL9PzhbhJpQgmz5W1bRcKCN74mMRhVfDr4fDEqk	1649	1017	2	1	1603	jxwcbBQkwQroapqu2TBmoJU5gxh8Q3nEKoJGBw5eP5fwNWHgt8Y	877	1232	1232	1616160960000	canonical
1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1626	3NKZinyAGrweyVMxao2ymmZ33JNZbPtsv6euZ3uNoZffGtBm9Xry	641	970	2	1	1604	jxPKma2rVAigQwiTck5tNewJ1REHWzEj2QFvLqKeYZzXnwp1L65	878	1233	1233	1616161140000	canonical
1628	3NKShCH6fAcAXHjGBaTbnyf4GHpbhce5D3yBHtEm4vk1a7T6tw2U	1626	3NKZinyAGrweyVMxao2ymmZ33JNZbPtsv6euZ3uNoZffGtBm9Xry	1590	1300	2	1	1605	jxHZzZQquFjoS8iGpGb92X5HNh1bfShaVWqNCZq9jLJhCkz8Uy5	878	1233	1233	1616161140000	orphaned
1629	3NLK2xK3WEbEv7aHStDeaugvUBqzNNMD7KMVhTK1QQ2eXSduGJSk	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	369	1186	2	1	1606	jwaE2s32qHTs9wceEfNArXRXu8Pq4WVG2LHEPx8YdY1JbKXWeXD	879	1234	1234	1616161320000	orphaned
1630	3NLhCmL1Z4xkRLeLfsPLcSmh2KsZN3YQyRyK1CJFGeiHzA1FKCpS	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1458	1077	2	1	1607	jwSzVEVcQP62LCBrTz8exciAZ8ZXPr2S7Nf1FuVKzJPBV9ikTh6	879	1234	1234	1616161320000	orphaned
1634	3NLBp4p9a8E4KYcyUFQJekNk22nRY7DfzLJEjtB3QugUBU3LVyKZ	1632	3NKtPjw13bPSDFKSvk3Wp426E2qHXPCnMVeHn3S55mBHEDPbxTpS	1631	794	2	1	1611	jwxm18NPW7e4ERdZFE5n7FJECzTzii92zrogu4dfTm9UQXt6VBT	880	1236	1236	1616161680000	canonical
1633	3NKJVAbUJjLp1x6XsqCL5fAwB2JFckWBHZwWNv8KcKbbuJXHGru6	1632	3NKtPjw13bPSDFKSvk3Wp426E2qHXPCnMVeHn3S55mBHEDPbxTpS	1610	1068	2	1	1610	jxRYcgLYejKUUEgKyiM9SYiieyvUvFxTZWkGXmSXUKFxewm7Dt6	880	1236	1236	1616161680000	orphaned
7795	3NK5sNEApJ7x59evokA1zss9oRr1w5wuG6SKDk1aTEpARJodqW1X	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1419	814	90	1	6301	jxTHz7zbnfvXx2K6xEVy5v3DvsbyHimuT1JRtT9W71xC5L6r6yT	4041	5702	5702	1616965560000	orphaned
1691	3NKEwsNnjAxUKQKEHBdWdE5a6uF3DYqHDLF54Q7HBULyEpUFqyhG	1654	3NLc3hXr1rHUggdRc3xqhFvLVMmf64yHaiKnb9JTXEdgopAtuiLm	1553	776	1	1	1666	jxwp9qzJxS6Q7tAiN7HQ3QiQndFCYxtxw2ZMigN7BD1Cf48Thke	700	1278	1278	1616169240000	orphaned
1632	3NKtPjw13bPSDFKSvk3Wp426E2qHXPCnMVeHn3S55mBHEDPbxTpS	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1597	274	2	1	1609	jxkeTJpWRWPxLKLLQc5UNAMDFxCrr44QWskrBASoXAmhhSBd8mC	879	1234	1234	1616161320000	canonical
1631	3NKKJ4jXLLmckvtny2eKJsgY9n6ctWTR2XyPrK6HjpWXQQigdVFs	1627	3NKmePCc1StNYBrXLoiX3Rsq1QhExXSTzJZdjtrsH8EJdfj1gtQN	1509	1320	2	1	1608	jx98RVf72cEcV52aMsEuqGaAZAWRyPehs9yRHwuoYw7tQHb8eQ1	879	1234	1234	1616161320000	orphaned
1635	3NLeJqcaU74rkHuQB2divSN7ptcZ1JeSLkpSJdV29t5oHKSpCdZX	1634	3NLBp4p9a8E4KYcyUFQJekNk22nRY7DfzLJEjtB3QugUBU3LVyKZ	404	404	2	1	1612	jxAQKH3r3sCWCCjvL4dL5WLxawuvdc4hB7VZigaRjkr6iS7nyzY	881	1238	1238	1616162040000	canonical
1637	3NL6XqgaFPf4xKDUrJ2DH7RgFHLvmr7h4WEYJgEZUxFE7PCjbXeh	1635	3NLeJqcaU74rkHuQB2divSN7ptcZ1JeSLkpSJdV29t5oHKSpCdZX	1631	794	2	1	1614	jxbiizr4j6QgFBAn4zQkms2ZqumyFoF8UJ6yV9AyVT9dnWg4kf6	882	1239	1239	1616162220000	orphaned
1638	3NKZ5uJFCSQXMT8peg6sx93LTxHvkVArkUaZwv2mFAGvrL9X37PP	1636	3NKFvTodvxg9x7Ak6emCrQKWo8ZNDAfBZAMPKFsJ4GX8PiywhQqN	1637	815	2	1	1615	jws7Rq3QPZCdryzTS51skgDD84Tw1JvFdwHaSL9487xp3crZbC9	883	1240	1240	1616162400000	canonical
1642	3NKcLpaajLqXUSA2WLWGbgmyep67M2TQVJmrJgAvqU4YMmvjGnM2	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1523	955	3	1	1617	jw9PpNAuJeYEV4opQgzgPHxUvCqb64hn4Nrfo7r7FpkxbryYP1z	885	1242	1242	1616162760000	orphaned
1644	3NKiFDffSZe6oMRgScfBTe2MnmyEaDyLo6w2L2qaJ2yFjNGSPHFx	1643	3NKTCyGdhPKLDcR2b37FNaVEHu5UFGhwdCAuM8GBjHCsaa8jrWX5	1637	816	3	1	1619	jwkbAQA8A6tKBXLEgzHH7gDVQ6fbX4SihHK2fkB5ZKSHdRKnQZp	886	1243	1243	1616162940000	canonical
1652	3NKkafyVm1s3f9byvVJqx2eLG4dSErRnaYmrHUUY2FRxUXwTH5Ms	1651	3NLnguSWzpWTTLavYMnc5aN2GHxKWJWpMRi4gsPeGjgq5aBhqiV5	1594	960	3	1	1627	jwavScbB8GWx33afSx4bA3bds9dVKcrRquCzCcSVu4M6zS25bZv	890	1248	1248	1616163840000	orphaned
1655	3NKwEuJcL8rBRw1f8jHy8se9aL5Cd5Bby2EcMBZ2kAXKSHuHwFXa	1653	3NKWVg8CThhXWuhpEY4ys8dKugujAkciBK5oDXGdLn1LH6Ekb3X6	1601	1388	3	1	1630	jxPbF7PihWYCBRXdctEEGzG9ksGgAxjd3maMvBnNyoo8HMtry79	891	1249	1249	1616164020000	canonical
1658	3NLy2Qa65afwd1BQjMf1agvaApP3Uvr528K5UobUo4zW4DtccvVd	1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1662	218	3	1	1633	jxFMEpQxhvV63pr1uPbXoy4PG73zPH6N3ovXfyaXRQL8HnHWMQ9	893	1252	1252	1616164560000	orphaned
1662	3NKVGCY2UR2e3W9tr6oV8QBkpdE5ds7zcRjL3nCVJmLUHokqjeD3	1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1407	1395	3	1	1637	jxYWR45F1xLd9KsXiNyq29NjFKGNvGxLGpdMKEjKSKQsUWV1gvE	894	1256	1256	1616165280000	orphaned
1665	3NLQZCuWhur1BGo9k7chJ2Y6gfFFVTzJfzsnrV3fPoYnAP1s4R3G	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	532	1177	3	1	1640	jw8T2Y9mHt3u5Un3XW8Mfyn6pZBhFKZzeUZLhrg5DK3axznFmMz	895	1258	1258	1616165640000	orphaned
1670	3NKrwYNGDHM7vePBMNTZXyzG5KJATg7MmGWQmwEj2kngLs82nW9f	1669	3NKFt8xe4KAUPbPxkATbxuw45QUkxvac31QTyxvrJtwjoRjTNaWe	1402	868	3	1	1645	jx9VixeqV3TMPtnMdbPkZp39XtwLAAxks1QXzUM92ogF5tgWFnF	897	1262	1262	1616166360000	canonical
1672	3NLjm4hAqfeCcmoVJzEurYVRMwDdtHqenSCWxoY4NNrvnU1hSHYo	1670	3NKrwYNGDHM7vePBMNTZXyzG5KJATg7MmGWQmwEj2kngLs82nW9f	1406	1393	3	1	1647	jwpeHKch2JMM77A41Rs91UUcNfeCktCX5enoAQQzzomMcyM5vJF	898	1263	1263	1616166540000	orphaned
1673	3NK8d2ZPGLWxuVuNuLJVTMHtXfqzc5kViMbQJWqfQ29FpixswRBh	1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	80	1273	3	1	1648	jxmMYMkvhxNGeN8Y6dN5LishEcTQZvEHZ3LAqLAVJjf7yDGDHnK	899	1267	1267	1616167260000	canonical
1676	3NLHqp2mkmWbf4o69J4hg5cftRAAvZ5Edy7uqvJUUVvZWtD1xRrh	1673	3NK8d2ZPGLWxuVuNuLJVTMHtXfqzc5kViMbQJWqfQ29FpixswRBh	1522	956	3	1	1651	jxGKUtKWxMrEyXwgf3RjrndXHavvydc62hyg9SFJyn112caXaRU	900	1268	1268	1616167440000	canonical
1679	3NLXUEpTFsW9SeiqHcNbKGe4odp6ybGWXLVjEhmGASLZsD3M51ii	1676	3NLHqp2mkmWbf4o69J4hg5cftRAAvZ5Edy7uqvJUUVvZWtD1xRrh	1611	1095	3	1	1654	jwFkdyX435xbuLP3tfWB7kRmy7uqEWhwgfp61VJEVhY1bZDe9yc	901	1269	1269	1616167620000	canonical
1682	3NKenqGLsaQPDHuaGMJEJitUZ5zd4scCtWsaX9iaRTGiHY1hizob	1681	3NKL656HsqFQ1dp3Vkb8FG1QFB42JaMdkL7dtoGZ8M6jmyWHKWvP	1650	1009	3	1	1657	jxnZf1WQ4Fw897ZVgDT9akiWjLz6cetWdrzZseoVQ3Uimv9fEPW	903	1271	1271	1616167980000	orphaned
1685	3NLrvKbgTh6EH5A58PjA32drPCabz8xQzrJLRbrN4GAQPVr31DeR	1684	3NKvg3h1wbnnVHgoVzY5QfrTcdcydu6pWPvh1LTePwRPQ69tgD3t	484	1193	3	1	1660	jwszmSNUA5xMkMNu31ijsEd2NDnL7YdaBkT9H3uQhYGMa5pSLU5	905	1273	1273	1616168340000	canonical
1688	3NLrKUT76NLkMn7ebZpe6zBQh6y8iYaCoyfqiWMWfQMPskyCcJHj	1687	3NLvQfDFewuzJ3RFRGMo3F1Rz441pjZpFNhs3KMyxkBcTFze2ady	1405	851	3	1	1663	jw7um6SaaQSubDicAQjCXrkUC6j4XugRwjcYrkuWpA8VBaU1eJc	907	1275	1275	1616168700000	canonical
1694	3NLFexS1NEznnRe9RUhhLgc8KMdCq1z7d4aC1q31QXznSTAa28ZU	1693	3NKZ9RHXZp6r91AoyZ4pUn6sEKSvx8jVd9t17abxMP5pFoDwP9jK	1451	926	3	1	1669	jxMXDHiYJt9LWxqgdguD4KfUtpLJKzLpNZqoQyY29E4z1voLxDR	911	1281	1281	1616169780000	canonical
1700	3NKxQoqWt4RdAhsHo5szASXkgXv3oUytqsG9b5yNH2xKiPfHNeFh	1695	3NKedE5DPYyKJvErrLcfwzU6jKqvZ3EUKJLmM6LmUoBa9238gC1R	532	1057	3	1	1675	jx1Hw8phM9KFcWSqYgYyZFfhvsMqhfGXzW8VnUFzKWFa1zyNHJx	913	1287	1287	1616170860000	orphaned
1697	3NLmJ2cqECdgKXN7KaWsx1KLFokFB2xZWVK4ZZuFUKVupZsezzxz	1696	3NKxhnDBoeYan2U22HjrQEew7AkY7Tv9R5ETvM3z7z3xJDCo25BC	1581	778	3	1	1672	jxc5HZDgYNqv2Bqc7EGBZWxk7Kw3MtzJ5H3rXn2qSsvK4esuR6Q	914	1285	1285	1616170500000	canonical
1703	3NKpsLmDmLSzTu9ita2h4dWqv2E2kFt9N2Xkgv3DT39Bh5Cs9vDM	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	532	1057	3	1	1678	jwxC2PkpJ9oWyKBjXMTJJAjucH2XZXh8wpgFifdGGrJML5r1zW6	916	1287	1287	1616170860000	orphaned
1706	3NLAYDn2Gdhxx4eaMp14JVAoakJfdMXoXXPHmEPiAGDrWBH9BHwV	1705	3NKJVrnoJ6g8HfMQYpPkKnMd4bieaG4kfFhN5oGFMu8hEjiM7s2K	1534	1317	3	1	1680	jwFnHLjdKcQur1oLLKCnrnXeLWYo7euPEGkBTUCMo1KZNFp4PNh	917	1288	1288	1616171040000	canonical
1709	3NKyAEH4fdAe3zqnm91farzE5ZvfAkaH9rey9nRVqos9b9a2dy2b	1706	3NLAYDn2Gdhxx4eaMp14JVAoakJfdMXoXXPHmEPiAGDrWBH9BHwV	1536	947	3	1	1683	jwTiHwL6L9jZAQCjSDxh3CW3ASLY7kb9Whpm6TJs88RUe1J8bBT	918	1291	1291	1616171580000	canonical
1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1709	3NKyAEH4fdAe3zqnm91farzE5ZvfAkaH9rey9nRVqos9b9a2dy2b	1403	824	3	1	1685	jwwg8RabQqYbffM68nfzvim41SrZa7kBrUjW5n6cLutE8EfrSGM	919	1292	1292	1616171760000	canonical
1714	3NKpt1JUDKzqh152TgFUp8J9ms8uGjbbFs2VWXsabEpKuvVGMTbc	1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1631	794	3	1	1688	jwUshXXGpWYfTtULGmGreKPirLiam1RJuNNBZPVpQozZCcidHtZ	920	1293	1293	1616171940000	orphaned
7800	3NL7Lio8pudJJTVW38m3yRpTtP8nrbLsjvQ9RAxfKziVnwsspm4D	7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	44	1199	90	1	6301	jxWrpttiiNUuem5C13fNK8AVFwDULLUdPbdhmVWo16mX8N9tKFB	4045	5707	5707	1616966460000	orphaned
1646	3NLXSG6sq1Z1Bt6ZfenqiGkSCJCLBsUr3QMbusKwckFmubVEZYYt	1600	3NLfPqD9EjdnQViZvBUzaRnjegF41XPMhm9HdLBQuDhNTiBxP8yu	1560	135	1	1	1621	jw7QxJB3CzzKjx1WsWNQFiAYG2rhiLWXPHibacpRkQxsyvQggbP	844	1244	1244	1616163120000	orphaned
1680	3NKyFj3XFBU3ZMfymF5UoTqNCzqsspfi1PqturoS754PrE7wGvGw	1646	3NLXSG6sq1Z1Bt6ZfenqiGkSCJCLBsUr3QMbusKwckFmubVEZYYt	1560	1291	1	1	1655	jwGiEH6rSPRLSa4gtu4n8ZrZysz6fV4XDdryroBC6bQtVLZjKZS	845	1270	1270	1616167800000	orphaned
1636	3NKFvTodvxg9x7Ak6emCrQKWo8ZNDAfBZAMPKFsJ4GX8PiywhQqN	1635	3NLeJqcaU74rkHuQB2divSN7ptcZ1JeSLkpSJdV29t5oHKSpCdZX	1516	1294	2	1	1613	jwz31hnoRgtpXYbstcEyJiLnWzRTa439WiSGmqmXDRsHER8bSWU	882	1239	1239	1616162220000	canonical
1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1638	3NKZ5uJFCSQXMT8peg6sx93LTxHvkVArkUaZwv2mFAGvrL9X37PP	1516	1294	3	1	1616	jwcUAbFic5KD5hHc2H8Eo13vY7HGRjMrX3VjAN8NhKG4zLVY7e1	884	1241	1241	1616162580000	canonical
1643	3NKTCyGdhPKLDcR2b37FNaVEHu5UFGhwdCAuM8GBjHCsaa8jrWX5	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	80	1027	3	1	1618	jwFPwsjA5EvQAByRZy58MPCRbmR5wA4ye8aqTSVtoD71TSAPotM	885	1242	1242	1616162760000	canonical
1640	3NK7kjDxBJWVxQ4qeJKHfpDQu8A7KYFfj9ZY8aappDSUP3Vw2GYt	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1523	955	3	1	1617	jxshSRdpabSEaCqQGN46ydBh3xy3V7KYdVTztifjraGM7diEA6j	885	1242	1242	1616162760000	orphaned
1645	3NKd3MtxJ4mHeWi6ZCqFsj1Sxia4MXH8eQGuAtVdmKTyt2cbLz4e	1643	3NKTCyGdhPKLDcR2b37FNaVEHu5UFGhwdCAuM8GBjHCsaa8jrWX5	563	1359	3	1	1620	jxkU68nhYpGLM54ZcAaL2HqFWMXesxjEuxTZ3XnaC1LsdQb7jSr	886	1243	1243	1616162940000	orphaned
1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	1644	3NKiFDffSZe6oMRgScfBTe2MnmyEaDyLo6w2L2qaJ2yFjNGSPHFx	1560	135	3	1	1623	jx37QNw7nMqHjSEdKnVgfYwQzdkGCgzu1RRkQq2ZXq5CsLHJZyC	887	1244	1244	1616163120000	canonical
1650	3NKfdq54xiqaSpwm4LhHricTiwnpVuKjRKKoqUoJV3wm8VzgJdoZ	1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	1403	824	3	1	1625	jx2TtQEJEF6BN2g9bH1tuuDEj3CKJvRvCwiVFFk22BoPmhL3Jkr	888	1245	1245	1616163300000	orphaned
1651	3NLnguSWzpWTTLavYMnc5aN2GHxKWJWpMRi4gsPeGjgq5aBhqiV5	1649	3NLubeDznQi8CeMgHLTM1eJpMZB1sqA37AaohsQV9tj3CxbKeyhr	1622	1230	3	1	1626	jw7chKJrSsTEoAx5gWztwxZhrGE82ZD3uLaW6gPqtcsN6jRqinp	889	1246	1246	1616163480000	canonical
1653	3NKWVg8CThhXWuhpEY4ys8dKugujAkciBK5oDXGdLn1LH6Ekb3X6	1651	3NLnguSWzpWTTLavYMnc5aN2GHxKWJWpMRi4gsPeGjgq5aBhqiV5	1581	778	3	1	1628	jwCRKnwC3b26AsvuAfFpnE4cgok5MxbNJCWs6ZqZAVDweYSMgJF	890	1248	1248	1616163840000	canonical
1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1655	3NKwEuJcL8rBRw1f8jHy8se9aL5Cd5Bby2EcMBZ2kAXKSHuHwFXa	1406	1393	3	1	1631	jwSckxpLH2LqkSREAo7StyNSFPQ4MFiunqxuwm7JStNYKfBbvKo	892	1251	1251	1616164380000	canonical
1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1633	1390	3	1	1634	jwyWJK73MZSw3dpv6969yCTBuLUF44jvb4BKB2JCtGPynzt6yar	893	1252	1252	1616164560000	canonical
1657	3NKackbqfxnG4KmwucvjZ6zE7nbQPVfy2AqcYvoo85dLVCeBHYdH	1656	3NK6ep99jW6n9m9DQLDyGZ3pxNfj8dgtfNogdUVpnuuZ8LPEnBeH	1536	1067	3	1	1632	jx1LM5ssZDhXfxpZrUwFkXJtNZ1HKMwVeW5C54QPS3oxCKAKybn	893	1252	1252	1616164560000	orphaned
1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1445	1044	3	1	1635	jxKtrVAkRtFCZzeujmnmh1CLCkuzHDnCZb2thbHDVDL53NUqt34	894	1256	1256	1616165280000	canonical
1661	3NKnSJ9BrqgvTnBrdymQmrsUeKFTDyCxNEbQSrL6jwJyZdNzA15K	1659	3NKGEtXgpYFBSs7yrX1q7DGCmZKsJpHmHdGgjjHmuTLfDXqAu35y	1406	1393	3	1	1636	jwbRp17jXpSEhMc2SMdQmss5k1hiWfeGJFh8ich6FtpVd3pWuA8	894	1256	1256	1616165280000	orphaned
1663	3NKftHRUmJuaW14bZim6hi6noqikmcWY8khe37AGMGCdSXnbu4bi	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1634	1085	3	1	1638	jwcfiGCWDhYMgg5uT11KeFrqmrjJsh6Txq5fdacjoukX4mg7mFH	895	1258	1258	1616165640000	canonical
1666	3NLhUr6VtH9mBKJZ7QF3RfZbU7R8nhea2iY2a4Bd933fGAhwKECh	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1631	794	3	1	1641	jwiNvu7QnQSu5Ggq5V2n9kX3QiBVTqJViLUJ8jNgY4gN4ZH9Sbe	895	1258	1258	1616165640000	orphaned
1669	3NKFt8xe4KAUPbPxkATbxuw45QUkxvac31QTyxvrJtwjoRjTNaWe	1663	3NKftHRUmJuaW14bZim6hi6noqikmcWY8khe37AGMGCdSXnbu4bi	1670	916	3	1	1644	jwvzxSNQpdZhK1AsADFQ6tmtougp4kwHFy1upWULsR7h981rR5j	896	1260	1260	1616166000000	canonical
1668	3NK8CnThKFWukGxq3bnH5Dnr8ZFiGMaJxNTPzFDVQaNqGAynFZLu	1663	3NKftHRUmJuaW14bZim6hi6noqikmcWY8khe37AGMGCdSXnbu4bi	1402	868	3	1	1643	jxrw6uHpBKeKF79TtjC7qGzSEFrZjuM4yz6AVWvwSsBobMnfA47	896	1260	1260	1616166000000	orphaned
1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	1670	3NKrwYNGDHM7vePBMNTZXyzG5KJATg7MmGWQmwEj2kngLs82nW9f	1642	1367	3	1	1646	jx7UUuFqvHZs2Zbm8z5xc7seZcGG3zdwamMJ8yMNjBFnSHGjWve	898	1263	1263	1616166540000	canonical
1674	3NLAmHXmT5Go3Py47EZDEsBeazJHtaobAyFB7UxoMUWoN63LRozv	1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	1656	1217	3	1	1649	jxYgyjGPExeqx5HGk91vVBZtDXgacSnQcj9cqVifZvKKWRoZkDX	899	1267	1267	1616167260000	orphaned
1675	3NKUJ2FmTtVyFT5PPC9dxoHu454eKb9Q4spvWpXTqHLZMo9tMhAd	1671	3NKxexr2FxKZnirYzjp4DJL8uur7QfcvZrxAWHHomaVyzF9QwG3L	1555	1347	3	1	1650	jwhH3DrYE4pP69836rw4MAQm1TXgJCPeUjznyAP9HoYmcAwf64x	899	1267	1267	1616167260000	orphaned
1677	3NLfzGXGFwA9BmCX3sy29njf3av1mjcwgSnzJGQBzZ5Estr4yLkH	1673	3NK8d2ZPGLWxuVuNuLJVTMHtXfqzc5kViMbQJWqfQ29FpixswRBh	1483	658	3	1	1652	jxaBY8K3m2Dhbmna8ow88CPctjEFEdrFZ365H4wXCXonwDJVp3s	900	1268	1268	1616167440000	orphaned
1678	3NKEoyqMX1XeGSzvWNB6zqHVM54Y1nArpjAP9JjWdX5F5M9u7uk1	1676	3NLHqp2mkmWbf4o69J4hg5cftRAAvZ5Edy7uqvJUUVvZWtD1xRrh	1426	1364	3	1	1653	jxJjpMZmqoAJUeS9toCg7J4KCQJ4AoxytsaZD2qdKsMiWza5ymz	901	1269	1269	1616167620000	orphaned
1681	3NKL656HsqFQ1dp3Vkb8FG1QFB42JaMdkL7dtoGZ8M6jmyWHKWvP	1679	3NLXUEpTFsW9SeiqHcNbKGe4odp6ybGWXLVjEhmGASLZsD3M51ii	1560	1291	3	1	1656	jwuiKEZb8f6rgSfMfsStaxZAb4ZH3iH6usfdzJbwmmL1Kz1GzG1	902	1270	1270	1616167800000	canonical
1683	3NKwVLE4tZ6wfGC7GBzEbUmXLj5TNUceQkaqp5e6A9nLFez4aV2D	1681	3NKL656HsqFQ1dp3Vkb8FG1QFB42JaMdkL7dtoGZ8M6jmyWHKWvP	606	1295	3	1	1658	jwTKhv1G8qkc3uqvrm6CdbjVme8gJ8RFKZd3w4bGiu4k6xAuMYQ	903	1271	1271	1616167980000	canonical
1684	3NKvg3h1wbnnVHgoVzY5QfrTcdcydu6pWPvh1LTePwRPQ69tgD3t	1683	3NKwVLE4tZ6wfGC7GBzEbUmXLj5TNUceQkaqp5e6A9nLFez4aV2D	1631	794	3	1	1659	jwSFLE4ZCF6M4wnN4K9SwkN6bARBktdrFZyWYykDvyWFmDsWD4H	904	1272	1272	1616168160000	canonical
1687	3NLvQfDFewuzJ3RFRGMo3F1Rz441pjZpFNhs3KMyxkBcTFze2ady	1685	3NLrvKbgTh6EH5A58PjA32drPCabz8xQzrJLRbrN4GAQPVr31DeR	1483	108	3	1	1662	jxV6D9Q3T1vbd9dLxC1uM2v31cQSX3rHRH3Zdhj2PCmZUQTNDEQ	906	1274	1274	1616168520000	canonical
7802	3NLewAoB6MBJmCL1VRXLZWWXEf2Zta9eHjeihJPnY6WhEJu745R1	7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	1631	793	90	1	6301	jxLQDr5nqhdkxNhjtRBi5RT3FBF5BwBuZqoZgisi42NdRwTEK8J	4045	5707	5707	1616966460000	orphaned
1768	3NLheE3e3XN7iHq6PfSTpZAyuNdajcDJi24nr35M6MPUwLXMspS6	1699	3NKsAEv2WFp7GqCbCFBgm3G3XPxyMjP5qwEP4AJzcbgvKA8j1CC8	1553	776	1	1	1741	jxwp9qzJxS6Q7tAiN7HQ3QiQndFCYxtxw2ZMigN7BD1Cf48Thke	702	1329	1329	1616178420000	orphaned
1708	3NKRoHEtXT17ndoDQyFPvwfaaMiEbgqjkgAv3VkhA6Q2WX3vs52d	1608	3NKfV9ERfCSMkWntkM6QetqFsm8wKNc6m4cX6zZ7xYSSff7gv7M4	1397	838	1	1	1682	jxBscpVTqTT7nxtonqQx2VEVxKuHEQvhkfWtsnioFz17BVNokgE	784	1289	1289	1616171220000	orphaned
1686	3NLBdGMaFeMjz5E8HmiDPRnfnPD4uN5hVnGF2f6L7ca8awX38ro9	1685	3NLrvKbgTh6EH5A58PjA32drPCabz8xQzrJLRbrN4GAQPVr31DeR	1420	403	3	1	1661	jwCtHo7qTDMEkEcywhEh8U92VSQxcRDjQmufa4zjw9gHMDb2cEQ	906	1274	1274	1616168520000	orphaned
1689	3NL7XLJxc8kPHox4hVCGRorAamscvCFG5kk2Nre4CwrvP6FsKkqB	1688	3NLrKUT76NLkMn7ebZpe6zBQh6y8iYaCoyfqiWMWfQMPskyCcJHj	1406	1393	3	1	1664	jwipNm1UC5cmzfvYJPVYSUZ2e8Ef7Peon8oN1fX8sbMaSuGaLf7	908	1276	1276	1616168880000	canonical
1690	3NKNzjMzkpwm16VyH9cokCYtDhrwt2dUJiXVJQB2e5EHf98tM8Pz	1689	3NL7XLJxc8kPHox4hVCGRorAamscvCFG5kk2Nre4CwrvP6FsKkqB	1503	1151	3	1	1665	jx8hus52K4psSM9urfrdzA3NtaVi8aUcEWnAod8cnWXQwrEtQqU	909	1278	1278	1616169240000	canonical
1692	3NKcCjjS3RW6kFVLk2YFxppkptUcvVJUeCLaZkF8a7aPr38ZUutt	1690	3NKNzjMzkpwm16VyH9cokCYtDhrwt2dUJiXVJQB2e5EHf98tM8Pz	1402	852	3	1	1667	jwnPdKnaT79Ebjpn6i6rZJNtNEAhAn1JnwrgfQ7vqkt7izWM2td	910	1280	1280	1616169600000	orphaned
1695	3NKedE5DPYyKJvErrLcfwzU6jKqvZ3EUKJLmM6LmUoBa9238gC1R	1694	3NLFexS1NEznnRe9RUhhLgc8KMdCq1z7d4aC1q31QXznSTAa28ZU	1624	1334	3	1	1670	jwRZriYrhX46teF8uKgrf6PGXrN2sRDDEG1Z4j9nx61RXCoApD3	912	1282	1282	1616169960000	canonical
1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	1697	3NLmJ2cqECdgKXN7KaWsx1KLFokFB2xZWVK4ZZuFUKVupZsezzxz	1403	786	3	1	1673	jxGYLyGNYipxGcxGoFjPRdKdnMDj9Kmte2LBPbYQpSzpajTgZq7	915	1286	1286	1616170680000	canonical
1702	3NLkmyDUoKHegBCuyiYDw8s3hD8Uo5zrqiYbCpmPDhtFrrDocFoJ	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	1613	1223	3	1	1677	jxJdkkBnF6yEom7W1LbwkKjwTvukxCzqNqWgRkvz8x4U67Ua9vA	916	1287	1287	1616170860000	orphaned
1712	3NKDgVveLjMkCpL1hM13eaxTR5uyqhhTNKQ7VLGiLEAfvUQHVKcc	1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1403	786	3	1	1686	jwbkVdgwq49Khjp7DAs5cyE73CnxKhG8tXhseHTjt4kSFYTxBFH	920	1293	1293	1616171940000	orphaned
1715	3NKND5MzAbNYUVPWv8qNj3cj5M5SmfDKh3rz1Ts7i8JzTd3Ew9fT	1713	3NLeE8rXZEwyS63qyJVR8cSxG7qNkHfM43o5GPLhoP15xMFGL3nF	1593	1346	4	1	1689	jxYRRKzM9sAiVrDJWndH5fkVa8qFGDqS1wbjmvtgGzZMhngcNxa	921	1294	1294	1616172120000	canonical
1720	3NKE7FUEUoZDMrM6q4iBpwUkKEs8Tm9KmUwtaAXhoEazSXV7e4ug	1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	1552	513	4	1	1694	jwhxoqPrjCeEK6LMGJoMEXVchL4dsBbFWH2E3VVVgscJpEEamWk	923	1296	1296	1616172480000	canonical
1719	3NK6mdWepvUQXvrygg1RKDdoVwDFGNsTfwbTtsnUoZwGueF2c7zR	1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	532	1177	4	1	1693	jwTT7wP7cyYf33w1t7R9dW9SmkPxPMmSwirwDzT4RbqN9LXUeHx	923	1296	1296	1616172480000	orphaned
1721	3NKf7wVoDLTR4rF3SzB7gECESfDQLbjFrq8yM9xx5hmzARf76JhA	1720	3NKE7FUEUoZDMrM6q4iBpwUkKEs8Tm9KmUwtaAXhoEazSXV7e4ug	1578	1296	4	1	1695	jwD4hYYqtjrwwjecyvFGsda6rki7EQrxpLU7RdxpqNegPFrrWd4	924	1300	1300	1616173200000	canonical
1727	3NLLkJvGJa4h6P2uSK68Cewd9MZQgc52xdFzfjXTZRFjzY5AfCyT	1726	3NKSCrrZ5gXpvmMufmV62HjnkPvEgptSC4KxR8wNvYMV3iSA8pCU	532	1057	4	1	1701	jx4c54WQoPGEtvw2ShQZMu5d1Ae8Unsp3ZQ8XcK7pSAAB8H3tXg	928	1305	1305	1616174100000	canonical
1730	3NL6pED5NJSU4tmFSNo3xWDDHUsmEEawzZCHegy8knKp5KPTitST	1729	3NKyFfKQDALRfixiAo4oau8v4ej8qTLuthm2zdKfGrHh6TF45bSR	1607	1222	4	1	1704	jxEDKZUfh4BprsPsB92kEC6gwkn8z2EbEV4cqTCS6UeXCBnPdbY	930	1308	1308	1616174640000	orphaned
1735	3NLnRcGB1xJk8hqrKeLkyPq46dE7nQCaAipfmeHbAw5hnygCYEMc	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1581	778	4	1	1709	jx2zWdrcfX9esov9xhoZeBWX66PmgUPJc2Pc2n7B7mppECxJTeY	931	1309	1309	1616174820000	canonical
1736	3NLUq2d3rta5HL15WpC5QxAogFp8UkFL77LUYzPJ43d7LgyAGUiq	1735	3NLnRcGB1xJk8hqrKeLkyPq46dE7nQCaAipfmeHbAw5hnygCYEMc	1405	873	4	1	1710	jwP85kd4r33TixvqBmkVqzP1cVCnAkAnpxe3xRWpMx6gBHMycpa	932	1310	1310	1616175000000	orphaned
1741	3NLZAC4f7sxJfStRKC7EMvJAA1RKL5j4LWWvktBmqJ2js3LioZBY	1738	3NKeWNKWKr8cffbzoVh5CCSGHaPTt2MqXcZjjX1YCpAPYNudcQKE	1407	1395	4	1	1714	jxGvkSx69Ltsx6RXwTpgoy31Ca1e3RvgyVoJh2MXSXX4Dbhiogq	934	1312	1312	1616175360000	orphaned
1742	3NLdFaLGhmy8pJh7FCSGbXu4EwgU79DGi49Y4TxKDQ8qgev3tiMC	1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1467	1376	4	1	1715	jxFUpUxZ4L59EXa9QTUen4JJBR9WAJTPyFq5ybfLwB3UJNqvdVL	935	1313	1313	1616175540000	orphaned
1747	3NKhgT1doyPdTBndS2DBSurdR61rJJptFREkAbC7QPsXoNkSuPyo	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1403	824	4	1	1720	jxHScqcT4dXHzPjS7tyrPUn5ny9PFzxaTmobwqu13892h6pX3Y5	937	1316	1316	1616176080000	orphaned
1751	3NKN1LY2DWhkhqzjHAd5iBntmxDwSL7nTXbmMXCA5NjYVReHkWAN	1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	1647	936	4	1	1724	jxXx6FPTggxF8aDshrfs4hn7ohdXJ3MXttrCyMQKxGzeg38aHVJ	938	1317	1317	1616176260000	orphaned
1756	3NKQJj1iNcZAkfTH81NhidnrQGfs3sTGPsYvcAAwRZgAvgMEY38o	1753	3NKwt5H8CofBpv7ZSzVjQLgp5gnZn6t1UfeSihEFwziPQjYfgjto	1627	1385	4	1	1729	jxeRTRtaxsSq2sCe6HdtZAD4s1ZVKZbM6wjRxq9QKtx8Jx8sMx7	940	1319	1319	1616176620000	orphaned
1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	1755	3NLuMdM6PFTDGbHtgEgy6UARCVUDJoMUPa6T8szyWzLKeostTcT3	1439	1033	4	1	1730	jwUNTbaaXxk3waZpo65TD8UDd8kkvHzNP2SLxn2ArXphXuBqNy7	941	1321	1321	1616176980000	canonical
1760	3NK4QwEELG6xnjMnK7Z38J2ANF2y9u2H4DhSDGHe5o96ZNNzNJB3	1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	1407	1395	4	1	1733	jxgYzbTjemGSB68pGpjDoMfcmq2zdK9S4WVTboJmBJTPJomReR3	942	1322	1322	1616177160000	orphaned
1763	3NLD37sjLzUVQc4J9Yaq7ymiETyuV2phsg3ydx3PQegRzd3GwDi7	1762	3NKEJi61vk5P6M4GhgT3idLNmoEMjicbuaxBQu34wRfiHQ7WmBBH	1594	960	4	1	1736	jwpsm8erJNk1YSkWwkQU9kn9CxL1as6k5dDvjFD958Vzsrph2Fy	944	1326	1326	1616177880000	canonical
1766	3NLvQgpE44fLS3VswNSbHxgaeDP8nqzAYcjdDddGXLBSxF6diw2G	1765	3NLnyehXvGGERtWBz2GzvSqjGWTvhjYCoF77RtvtvqMYfAqgCGfD	1596	1117	4	1	1739	jxDKRkh2fv3nzDYa2hMQXsj5i8i4GygnQoA13vSDTTrXM2CWsG8	947	1329	1329	1616178420000	orphaned
1769	3NL1ZxUP6RR9Dp7om7sycW2NascC1a94iYMjrMEyQPLPGdqz8RsG	1767	3NLo58HqvhGrW4jFzoL4x8pYeR9yotZFYa6cQqQ8MJZFNwUUhZe9	1516	1168	4	1	1742	jwy7DDhpH54PM6PP1VXx6Ht8dNBYb2YCMx54DdB1Tgcj9rsWEor	948	1330	1330	1616178600000	canonical
1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1771	3NLaSYedLNCMZzqtP4KGvbyhLChuxsKbZWgLqgo4j5vAzJ6yCydD	1439	1033	4	1	1745	jwRSVQVejyqAxbGrTY9Jo2NnMdvScFMmGLBPHBJKBb9nPkeq4Ed	951	1337	1337	1616179860000	canonical
7852	3NLNnp3JrFa5RF9PEZe54tkgDX84BUkun1k8ZVkNxJYir3vHuYRk	7850	3NKrHdbfeRoa2iNPzYRBEokX83W61kUNLSxZuTZbwnA3iqkehwmH	1406	1393	91	1	6301	jx1VaJJsgvKhseG1kRcoPPiZbzsCJzpP9rcy2sYJDL6D7FXTpqR	4070	5745	5745	1616973300000	canonical
1718	3NKFwYkEWsGnh6DPYDVXPkacgMr4TKt5xsJhpYGxqUCys2e7pywn	1701	3NLRwSPBGPKCqmh4RXaowozy4wbWoKNeY4CuGRARoBoe5rwnYjrc	532	1177	3	1	1692	jwj3y3oBBDCx1yTM67rPvtnp5RZpNxiMxvaEYwafBtYjbPyfGkG	890	1296	1296	1616172480000	orphaned
1693	3NKZ9RHXZp6r91AoyZ4pUn6sEKSvx8jVd9t17abxMP5pFoDwP9jK	1690	3NKNzjMzkpwm16VyH9cokCYtDhrwt2dUJiXVJQB2e5EHf98tM8Pz	1581	777	3	1	1668	jy2rRyLzNZoBdEyKNEvZdtKtesZqjPDWkRkutQzEMHefsYmQiMd	910	1280	1280	1616169600000	canonical
1696	3NKxhnDBoeYan2U22HjrQEew7AkY7Tv9R5ETvM3z7z3xJDCo25BC	1695	3NKedE5DPYyKJvErrLcfwzU6jKqvZ3EUKJLmM6LmUoBa9238gC1R	1637	816	3	1	1671	jy31iAX14MjfV1C7hBREqUuv5GMFEuorBW4HxcLraLWayGdJxLK	913	1283	1283	1616170140000	canonical
1704	3NKwGUjCEMr5GG6j9nXxMcLv8u6Fgz5ae39L1quHtFG5YthCN1iP	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	327	327	3	1	1679	jxMtAicjeKFuX43j3vErec5mQmnZAuJ1nHErKv1NhppKMUXYr4f	916	1287	1287	1616170860000	orphaned
1707	3NKLWwpcBG7xMmYq7GMRXrHwcthe2cateStF34eUWURGYCyyQ4ir	1705	3NKJVrnoJ6g8HfMQYpPkKnMd4bieaG4kfFhN5oGFMu8hEjiM7s2K	1611	1215	3	1	1681	jxuJEqWMy6zryx9ijdWHEKw39KLrQ9RptbyYBwVJot83Rgn7WdZ	917	1288	1288	1616171040000	orphaned
1710	3NKrPzGb6BG9tk6KDwveuUzHksP7MXiZyX3xnVdm5q8Jb5uausBc	1709	3NKyAEH4fdAe3zqnm91farzE5ZvfAkaH9rey9nRVqos9b9a2dy2b	1500	1051	3	1	1684	jxxEwLAp2MUtWZ2wh14TS2vCds4wk6DVYsvxxjr6PiKWaCJZD4q	919	1292	1292	1616171760000	orphaned
1713	3NLeE8rXZEwyS63qyJVR8cSxG7qNkHfM43o5GPLhoP15xMFGL3nF	1711	3NKj7H44kzbTmTU1sWKjZ52EujGjcbRwEBf72aGyBqnRZ28DCBsf	1506	1373	3	1	1687	jwY4oQaPTQW8x9dx5XbAXn6B7LoM87za3m8i3An9aPGdMWgmhT6	920	1293	1293	1616171940000	canonical
1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	1715	3NKND5MzAbNYUVPWv8qNj3cj5M5SmfDKh3rz1Ts7i8JzTd3Ew9fT	298	1182	4	1	1690	jwXZ2p3UNxzN6NP4jQQnfXtFGpSs8GtpcaiAVkTnJJSn4PZ8gJF	922	1295	1295	1616172300000	canonical
1722	3NKDSP5jwmRyqHxx9QLCvuTo3bz618Rguoe4fW6KQGFpBCHwwM64	1720	3NKE7FUEUoZDMrM6q4iBpwUkKEs8Tm9KmUwtaAXhoEazSXV7e4ug	1407	1395	4	1	1696	jxwsGRiWfqKWz5SechizHEQyhJXfv9mXcj48FRLhtmPuZUffMV2	924	1300	1300	1616173200000	orphaned
1723	3NKZjs7UQaTe93LxFLxu5v1dXxSpbrf59UrfuvaNe6H9SH2vcyyf	1721	3NKf7wVoDLTR4rF3SzB7gECESfDQLbjFrq8yM9xx5hmzARf76JhA	1501	1234	4	1	1697	jxce4ea4jv8CqqsRhgmjZeAU8yV85Gw57sBztBaox2ULDEN3swq	925	1302	1302	1616173560000	canonical
1724	3NKf27XeD7u1PaUEHSFM6hFkGfsfXiTSaXKX6pQYc3Put67FSwRM	1721	3NKf7wVoDLTR4rF3SzB7gECESfDQLbjFrq8yM9xx5hmzARf76JhA	1637	816	4	1	1698	jxWDTRX5otePfxCgKWZa2ArkTAG4CnuRscT9LmArjvkrCenATZ5	925	1302	1302	1616173560000	orphaned
1725	3NLq1A7koTtryB4xncx3YWGsvfscpBcGbJ92YX42RVEhuDCweumu	1723	3NKZjs7UQaTe93LxFLxu5v1dXxSpbrf59UrfuvaNe6H9SH2vcyyf	1406	1393	4	1	1699	jxsdvSfyxQM18sb5H9BCQoVXccxifCjFNmQKDVbWwos5sRXhfs6	926	1303	1303	1616173740000	canonical
1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1729	3NKyFfKQDALRfixiAo4oau8v4ej8qTLuthm2zdKfGrHh6TF45bSR	1401	224	4	1	1705	jw8pe5KrCbzBukLwdz58THiP3gtxhsQpYbkidPtxe6dfpkzYGq6	930	1308	1308	1616174640000	canonical
1733	3NKMjxNWbQgS2Cz1MzEbkTp6g8o1wRBGxSsSY1LyUdi4NTETEWH3	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1536	1187	4	1	1707	jxdoHxAVy6ByLvKL1sKBZLKC696dxWzzL6hrHoW8C3fegHTKxVc	931	1309	1309	1616174820000	orphaned
1737	3NKdWAwZrZRg8vmzXJMudLMtPtGHtKijYeowp37hTK2qgptKKnAW	1735	3NLnRcGB1xJk8hqrKeLkyPq46dE7nQCaAipfmeHbAw5hnygCYEMc	1581	777	4	1	1711	jwAnHhw87qHdHLFPW3X8Yc6iLimnXHd9R3fJ1kNDtXKNqVq2SuW	932	1310	1310	1616175000000	canonical
1739	3NLUFTcT1pZQq45xzBRnV7iU31mfPeWNH9F65buBT7jEExxbCRoX	1737	3NKdWAwZrZRg8vmzXJMudLMtPtGHtKijYeowp37hTK2qgptKKnAW	80	1027	4	1	1712	jxqVVR861Mm3j47XTeNgHBTcGNsmkLZAJm8yinzu8EdU8novVTR	933	1311	1311	1616175180000	orphaned
1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1738	3NKeWNKWKr8cffbzoVh5CCSGHaPTt2MqXcZjjX1YCpAPYNudcQKE	1656	1097	4	1	1713	jxDJyQL52ePbzXd8jsBnhEo6gBMgP9aR3roTfZ5HcpfvbjUYkj3	934	1312	1312	1616175360000	canonical
1743	3NLYhPBoy6z6LMNV8GDiQxSAXnW43Mjn1s37seXu3TFoF7JkLxYJ	1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1406	1393	4	1	1716	jxZgsrAeAnbDLYRboaKKYWhEijjyahCjZ8zrFGhcRpfxYANdp8i	935	1313	1313	1616175540000	canonical
1745	3NL8qGk2rLqpsUZVgXxAeRZZpaaTS4CxQBWM1iLndLsKbHPK6Tnn	1743	3NLYhPBoy6z6LMNV8GDiQxSAXnW43Mjn1s37seXu3TFoF7JkLxYJ	1406	1393	4	1	1718	jwPdMmZyd4J4rKxF9PSKuucX1jFFxLNUddAsSXnri17PydgYdWw	936	1314	1314	1616175720000	orphaned
1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1587	1357	4	1	1719	jwFZKMsMfW7hEuW1sRgWiccEidVeYKwmbsHvcugCM9rJS9fBkXe	937	1316	1316	1616176080000	canonical
1748	3NLDvxBSV5u9hBwd7RrAVwJKHrDxXMLNx5bXePHhn5ZGbTyj14XM	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1407	1395	4	1	1721	jxEksrMjbppKWC9Wn5giqsUgRgzfe2aReKwGU1TB1RapDYVkcBx	937	1316	1316	1616176080000	orphaned
1754	3NKynMakVwhTS3TpbJvi7Q5X6oeLY8ECim1QKFkxPt6kBbRBUx99	1752	3NKEPTnSQayey27QiadS9J6D1t1VKTJUhgr2WUQHJbTgPqiMupUp	1476	1245	4	1	1727	jwQdrXotqeDZJpBY5531oHUUtjWcXP34LqUzbUWiLnUPHq1P2eo	939	1318	1318	1616176440000	orphaned
1755	3NLuMdM6PFTDGbHtgEgy6UARCVUDJoMUPa6T8szyWzLKeostTcT3	1753	3NKwt5H8CofBpv7ZSzVjQLgp5gnZn6t1UfeSihEFwziPQjYfgjto	1406	1393	4	1	1728	jxMQ56hf9kqFNZcVrYfkSbxZXGcLvwTnAL7YSykVMC9SpFwVXXq	940	1319	1319	1616176620000	canonical
1761	3NLU1pUo4U7gTjX1pX9oE8sjZLs6VsybQovAXcFrd69m5hpi7zSA	1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	171	1128	4	1	1734	jxkSoqGkQGqj5rfKVpiXxNnUybr8KhJjp1KbHygxTr3JPG8sRQt	942	1322	1322	1616177160000	orphaned
1764	3NKJ64ZCRhxtZ1hYMGD8kJvhvqQJK9YY4JFcqG1ktNFcoZ4YcSUR	1763	3NLD37sjLzUVQc4J9Yaq7ymiETyuV2phsg3ydx3PQegRzd3GwDi7	311	1061	4	1	1737	jxagnaifE86h1rbdbqpURKQd9nkYcuhhnLk4EjUkPzxCN1C5Hk4	945	1327	1327	1616178060000	canonical
1767	3NLo58HqvhGrW4jFzoL4x8pYeR9yotZFYa6cQqQ8MJZFNwUUhZe9	1765	3NLnyehXvGGERtWBz2GzvSqjGWTvhjYCoF77RtvtvqMYfAqgCGfD	1607	372	4	1	1740	jwqebf7Q7CkE1v8sWDtc8rfeN3ks3XEQ3XGjz9V77pXCmRNVgZ1	947	1329	1329	1616178420000	canonical
1770	3NKMzYVC5vvRWmBofe6uLqK7JtFiN5fTsRsU6PeqfSBD4BK4wF4b	1769	3NL1ZxUP6RR9Dp7om7sycW2NascC1a94iYMjrMEyQPLPGdqz8RsG	1637	816	4	1	1743	jx1QCh1KHWg5zxRoU6Q4Ti8Suokm2h5oWCQrgRf3wLTuViMiS7r	949	1333	1333	1616179140000	canonical
1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1631	794	4	1	1749	jxb3biXkH5yyHTPJB7RXX571m57PDGa7Mt5f7nJ42tEExKucbsE	952	1338	1338	1616180040000	canonical
1773	3NKzMNnSa5MmjUjYgsPSA6F8kbew68GCZSSF2ZxiyFwNcJSma7Kg	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1642	1367	4	1	1746	jxQRTGtKLPKxxhDJCrQtdj5aUVfbzziW2spnKdjphtpvGVWtBHn	952	1338	1338	1616180040000	orphaned
7865	3NKjrXoRw7ZVeQoFe8cWWX15Nu2gkkNUNdDtrtmTV1pH1hJBKXmn	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1601	1022	91	1	6301	jw9ETaaTQMhH2CGMbQojW9pJh2hpn6DZSXsxAXza5eaCs86VeAH	4076	5751	5751	1616974380000	orphaned
1726	3NKSCrrZ5gXpvmMufmV62HjnkPvEgptSC4KxR8wNvYMV3iSA8pCU	1725	3NLq1A7koTtryB4xncx3YWGsvfscpBcGbJ92YX42RVEhuDCweumu	1560	925	4	1	1700	jxhY8WEcTqXeP5othmigL8x5sc6qpc5kp7SCiApTEy7Dgr6fK8R	927	1304	1304	1616173920000	canonical
1729	3NKyFfKQDALRfixiAo4oau8v4ej8qTLuthm2zdKfGrHh6TF45bSR	1727	3NLLkJvGJa4h6P2uSK68Cewd9MZQgc52xdFzfjXTZRFjzY5AfCyT	1406	1393	4	1	1703	jxQ8t35g7trTAeR4baBXHCrzJXx9mUtahe1fCH1MoqvKepLcHvs	929	1306	1306	1616174280000	canonical
1732	3NKT6nhTsrf9oAAKZiEkyfUMWBFTBbAHEVeq5jqPmATUaVLXxoph	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1406	1393	4	1	1706	jxChindkp4oDNsQw6hDxJP9ygZ4U9G6Ee4yuHwaNkLMuhfzoR6L	931	1309	1309	1616174820000	orphaned
1738	3NKeWNKWKr8cffbzoVh5CCSGHaPTt2MqXcZjjX1YCpAPYNudcQKE	1737	3NKdWAwZrZRg8vmzXJMudLMtPtGHtKijYeowp37hTK2qgptKKnAW	80	1027	4	1	1712	jxUBsyW7rjakqARht4Qm2fhhpver3Li8uWJu5ciayXzdqpE1mfq	933	1311	1311	1616175180000	canonical
1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1743	3NLYhPBoy6z6LMNV8GDiQxSAXnW43Mjn1s37seXu3TFoF7JkLxYJ	1527	1047	4	1	1717	jxt1MtRQonRuS4zubxziFvYexY48frUj7aRdBoYKu9nz1JVM8rC	936	1314	1314	1616175720000	canonical
1752	3NKEPTnSQayey27QiadS9J6D1t1VKTJUhgr2WUQHJbTgPqiMupUp	1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	44	959	4	1	1725	jxktYvPwK5F4nXVKPePudn6SVdDFxuE3obiWXjeZpZjhhYnpJsu	938	1317	1317	1616176260000	canonical
1750	3NL7e7mwW9oiTkETGCsLCm35s3i1Q5K6CB55ZhvCmpSZxPqpKu1Q	1746	3NKBiFFjUgAjoL7GAzH6qBh8WCiujvJSFVexga1sctwTbzFzKE7f	1500	1171	4	1	1723	jwGXmK1xPFYnwRrEvUezvxYpnv4WsGSWCa9XqzsSPs8dwaTnZrp	938	1317	1317	1616176260000	orphaned
1753	3NKwt5H8CofBpv7ZSzVjQLgp5gnZn6t1UfeSihEFwziPQjYfgjto	1752	3NKEPTnSQayey27QiadS9J6D1t1VKTJUhgr2WUQHJbTgPqiMupUp	519	536	4	1	1726	jxxQtcNxRHhPLf6YhctPQcrag7inGRbbX4MmsWaDonmCHA8YMoQ	939	1318	1318	1616176440000	canonical
1758	3NLLjBgVcQ2Tb94fLyKAKJfZCRVUjPQg9SuSUjAuN6LRoCgqn24g	1755	3NLuMdM6PFTDGbHtgEgy6UARCVUDJoMUPa6T8szyWzLKeostTcT3	1407	1395	4	1	1731	jxF6vJ3r3AaQZ3i6aMMUK8XSwYrvpSucgtXXxyDcxqXgTFPhDih	941	1321	1321	1616176980000	orphaned
1759	3NKHtmXRgeSeLC33dghZSqnjiqoJLhDatya7bgHkmbCzqYZWQQTT	1757	3NKsSNcpJJXKVMe5iMepWmsZztDtZvDQPSHR75EBKSRvr5jZFwUy	1422	1337	4	1	1732	jwjncyEDqGf5vQaUVnnpuVxkXdCizZ3KwNzBYkGtkejeHoaC9Ng	942	1322	1322	1616177160000	canonical
1762	3NKEJi61vk5P6M4GhgT3idLNmoEMjicbuaxBQu34wRfiHQ7WmBBH	1759	3NKHtmXRgeSeLC33dghZSqnjiqoJLhDatya7bgHkmbCzqYZWQQTT	1534	129	4	1	1735	jxC82DUSiAphYGBxxsnTZkDA98scNBovWyUuSSB8ZLV7c1UgeY4	943	1325	1325	1616177700000	canonical
1765	3NLnyehXvGGERtWBz2GzvSqjGWTvhjYCoF77RtvtvqMYfAqgCGfD	1764	3NKJ64ZCRhxtZ1hYMGD8kJvhvqQJK9YY4JFcqG1ktNFcoZ4YcSUR	1534	1317	4	1	1738	jxEWg8he4MWirGf6ezgFAD2GxobtpVTk61QmWF6vrVMFctmVvQp	946	1328	1328	1616178240000	canonical
1771	3NLaSYedLNCMZzqtP4KGvbyhLChuxsKbZWgLqgo4j5vAzJ6yCydD	1770	3NKMzYVC5vvRWmBofe6uLqK7JtFiN5fTsRsU6PeqfSBD4BK4wF4b	1559	1353	4	1	1744	jwpSZHaKygcfqmrAwmPdCYgA8QB2y2M6Tj9eaMjaCjr4BR7ex15	950	1335	1335	1616179500000	canonical
1774	3NLteSiSmM4vcsEY8CWGcjMgT746ctvGs6CgpxUHgxZNZ743QHxi	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1593	1346	4	1	1747	jwf27C51pSL9GFcddaaT8G5aoBSjg6Xc3xCp5Q7LWCHi3U5AqHM	952	1338	1338	1616180040000	orphaned
1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	406	406	4	1	1750	jx9ZQWVFb3B1EqoCXQbVywUGwkJz3n3ZtLY7B9FZsxhMKZok1hY	953	1339	1339	1616180220000	canonical
1780	3NL56HbrG8mav8hxjDenxdo57n7KJDA12oxm2XqezamdG4MLGmyg	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	1652	1315	4	1	1753	jwkHCaCuJ9dKsbw3fLsJoL4oyP4hpZLe5DiVuFEeJJLMprp9Bcn	953	1339	1339	1616180220000	orphaned
1781	3NLL9mNkZmJdnoQSgvFhzLNsxsxWVnQG3vAvM5C148cSF5XuzPkU	1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1426	1118	4	1	1754	jwC4D8mUkh2uL8VoE36GeTVVD5yAA2fhDWd7eto8hsbR5Rb747B	954	1341	1341	1616180580000	canonical
1783	3NK73fJVCnuPnEiskJLAoft3uBDqhj1uDoLoycwtyQZqgbYc6VvT	1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1581	778	4	1	1756	jw6u7YVyYGsCCU6aUHQstxUhGQudccyV3LNJBmt54BxLKqGABEM	954	1341	1341	1616180580000	orphaned
1788	3NLFdZDdcbrRNYpajzQ8QmktW9YLm2nPHh8q4VcQLdDtkVutm4kq	1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1541	1172	4	1	1761	jx5zMaNcLep2D9Fo1n3wVrwvDztYQFeEQLFjxCJzwK43deUrnbC	957	1348	1348	1616181840000	orphaned
1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1790	3NK9Td4TpniKpsa12iV3FHAZCjRNtjb4sQ7GUAWQNapUgMXDKrTw	1406	1393	5	1	1764	jwJQtLSu4VdM8bEjS4bNuDCKA1FqsEnPxqmoRH5mTrFib7WnJyN	958	1350	1350	1616182200000	canonical
1794	3NKoxpX9xxMAVdGSefmGkQ9iRNHaoJ8ME8RwejtgzxeFCMWVxNpc	1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1577	1201	5	1	1767	jwPp8Fcdz9FiiQ9B7cbK8xWU7JcpV4L1SwnDJjGNYH4ArQ72LNS	959	1351	1351	1616182380000	canonical
1797	3NK4E8jWXjUtUNZ1iv2tnXfMw125sunRVLLXhUvLTW5N82WQ1duY	1796	3NK7WGhjNwERCabf1ZoPKxbKzkDdHmT7bJUem9niVbVC9TDriqRs	1483	1030	5	1	1769	jxehjr4PvDEgUGwbNmbw3X7RqtXXcmUF759p9d2XcVqDz2PxAM3	961	1354	1354	1616182920000	canonical
1799	3NK7GzU9D7qrtmJhcCBhvrWjVZb5VyNoda7ByBog2YKj3HUVq5DB	1797	3NK4E8jWXjUtUNZ1iv2tnXfMw125sunRVLLXhUvLTW5N82WQ1duY	58	1035	5	1	1771	jx8XjLWUCoJ7SVBjcFE8iggPbPHwFbsosPZ65Fssz8pgRT6tD6Y	962	1356	1356	1616183280000	orphaned
1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1798	3NLmKYZDeCrypocic9jWhSSFE31gK1WLCQ9vNcq67NZcgsGntsRw	1546	1213	5	1	1772	jx9HZmVpUy8CxrkmPRGLzr1JPGt4H1g6XVAdbbawWA18jkVk7eZ	963	1357	1357	1616183460000	canonical
1805	3NLjqreC4U7pjSLvW5xa81L9rEQ3cFsUbEimKb3itULH8q92oGsu	1802	3NLdazbFtbjJGxPSUvP6HKvgGCg2isSChhT8N8bvQKMgiygYHQko	1631	794	5	1	1777	jwSi9RAiDXHArDtnJ33pHi2hnNmALiCyyggTD1BU3QkPKvcBjeC	965	1360	1360	1616184000000	canonical
1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1806	3NLkRBQ5fMNBaB1ZjDkK2zhC5DubPV6CKunBSi9qJ8xnX6LS2Dpx	1406	1393	5	1	1780	jxCfR1UYo34k7MqmAMqnMiEQ6XbdAXUCoGwZv9q4m81S41vakoA	967	1362	1362	1616184360000	canonical
1809	3NKBMCMavMse8ZPZ4XrWYfevcHZakkAqr6yjFNsv3k3tRjVdQkCW	1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1507	1154	5	1	1781	jwWHVVwmPu7Waeavanbof5BWCACnxxNH6qoFkLfz7kZHoD8WvBn	968	1363	1363	1616184540000	orphaned
1812	3NLihAWrH2HEKb89WHkQfnyasUEMRZLTJ9rb8TJmov2CnJjsdgwt	1811	3NLjREgumxnGVnJZpjiw4o62JEtTaCAArFEoMM9pEhFwQDpebh4V	1672	1285	5	1	1784	jwQEBv2J6Y8FfzdHLnH2tWYRoC6vkJj572o5xXUVWDXKTSXhL5H	969	1365	1365	1616184900000	canonical
1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1812	3NLihAWrH2HEKb89WHkQfnyasUEMRZLTJ9rb8TJmov2CnJjsdgwt	1534	1317	5	1	1786	jxCVdxVbBQFLm7yNkKg3W23ZHzP1HAprJPseBfefng63wGP4Gx1	970	1366	1366	1616185080000	canonical
7879	3NLhHmhHo8nB3WCpWooxkhfj2nPjyGSkRjsmnyehwqth6LxXmzxE	7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	684	1106	91	1	6301	jxM7Q8PBw9GS7Vxh6KuqK91RcaqYv6T6Dn3JnwBjNqsV29cHZWP	4083	5761	5761	1616976180000	canonical
1823	3NLdXPYoFy5zdxc8PTnpHyXgpnjCRc8XZhq6DByQMaPrn7Qw44TY	1793	3NKGZpVdfHM2LXBzzPT5hf9hfq9QDWFuci4R8Kwf16mMvFPQArat	1577	1327	3	1	1794	jxsvXdMkD1Cf19hurUypxc9VJbdH8gFEiCKgdUeMUWg1WLpdKin	915	1374	1374	1616186520000	orphaned
1778	3NKufymvTAPjLU8wpuKbmzufPzWMtQUJSh6zfqgNR7kDwxmBHZL2	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	1406	1393	4	1	1751	jwbj2aa42JByyYGefZNxiUxSQWbTZaNgeYkr4MadYP2DK3Wr6ma	953	1339	1339	1616180220000	orphaned
1782	3NLBV7ZBQpRTD1vAj1pmzRKTB9ghjmgWGdZhagFdrjKcsiNuj1QW	1777	3NKs3Ci7njzxRPeVZTjqy29kKMWiN7eSKSN84CTYdjHuhZf5ssue	1403	824	4	1	1755	jxNenaVQy4pR53jVyUACTHEZsiJQ5aqeqqEoT1YFLfgApLyvpCp	954	1341	1341	1616180580000	orphaned
1785	3NLBFBqCz4XZ5hT2yLohYXRcZjk954HKd5CNrp5gbiW2zvD1TRgh	1781	3NLL9mNkZmJdnoQSgvFhzLNsxsxWVnQG3vAvM5C148cSF5XuzPkU	1607	1222	4	1	1758	jwozN6xdgw1RsqxAFUAPp7R7MFx3Kx3CwkbKKYmGtdnbpezeWCH	955	1342	1342	1616180760000	canonical
1784	3NLnqexVrPX4ZThfANPxXHoa8kGdix86BCtw7p5UNqfEHAk7zk1p	1781	3NLL9mNkZmJdnoQSgvFhzLNsxsxWVnQG3vAvM5C148cSF5XuzPkU	369	1066	4	1	1757	jwg4JXaekLGf5bGHU6ASpwtSg1Mr6nrLMrYkKMCXZYR5NWAf59w	955	1342	1342	1616180760000	orphaned
1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1785	3NLBFBqCz4XZ5hT2yLohYXRcZjk954HKd5CNrp5gbiW2zvD1TRgh	1637	816	4	1	1760	jx74wWJcf1hipfTgunrmevzona8ohQtsMdW3JoVFg6GYF7vLgR7	956	1347	1347	1616181660000	canonical
1786	3NL1HgZYmBqhsMBDgEkVc2TcjrdY5otdz6PEpLDdDuAqZnUNPwmV	1785	3NLBFBqCz4XZ5hT2yLohYXRcZjk954HKd5CNrp5gbiW2zvD1TRgh	1553	775	4	1	1759	jxanUP1nqNoL851uxTJmNHRh4342knezUeiTVSzhQhRHZHdStjj	956	1347	1347	1616181660000	orphaned
1790	3NK9Td4TpniKpsa12iV3FHAZCjRNtjb4sQ7GUAWQNapUgMXDKrTw	1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1637	816	4	1	1763	jxefCkmovMtChET4Y4xSJMLLb32rTXSpzQip7frJTcgqJxVwNxR	957	1348	1348	1616181840000	canonical
1792	3NLBDFt5QUCj8rErsN7ARkESTkdG8Q7xcGQsoD7hfuqBPsyGvZTv	1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1500	1051	5	1	1765	jxgKWisajzoKkujxrWrFao1fwMzQ8Q4H16iUpsPbf7MRjGXb9aQ	959	1351	1351	1616182380000	orphaned
1796	3NK7WGhjNwERCabf1ZoPKxbKzkDdHmT7bJUem9niVbVC9TDriqRs	1794	3NKoxpX9xxMAVdGSefmGkQ9iRNHaoJ8ME8RwejtgzxeFCMWVxNpc	1460	273	5	1	1768	jxufoVq5DqgnHmCCBJ1o2XoCs84wojVkR2mYbXARSpDTERo1bG9	960	1353	1353	1616182740000	canonical
1798	3NLmKYZDeCrypocic9jWhSSFE31gK1WLCQ9vNcq67NZcgsGntsRw	1797	3NK4E8jWXjUtUNZ1iv2tnXfMw125sunRVLLXhUvLTW5N82WQ1duY	1407	1395	5	1	1770	jwmZXhGPBbD5tdVoTQJCxxsT9fbrSLJiQvdn4GUqMmfS664tyHE	962	1356	1356	1616183280000	canonical
1802	3NLdazbFtbjJGxPSUvP6HKvgGCg2isSChhT8N8bvQKMgiygYHQko	1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1529	1316	5	1	1774	jwAo3VwvjLRNfF6BNwgteXgUKcLP7GKwQFqe3hgyKf112bRbEwX	964	1358	1358	1616183640000	canonical
1801	3NL14TS9DXy37XjmGCNPjrawaiZyA19TKCQTDJmyeDdN5ygAx7M7	1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1589	1286	5	1	1773	jwaadoskwQREezWZ9F8QjqU6URAoE2J5Ay2tzewCFDMueZnHUU9	964	1358	1358	1616183640000	orphaned
1803	3NKqkc7DHYhJssvxwTP71cCSDabCjJkjhmp7aZt8JogaM9dPGzMN	1800	3NLUgJqbjLZo2bq8vsMNZ37ekDvsNGM2h9QZvoYCzoqU6Sv1Huxj	1490	908	5	1	1775	jxuQdcpZznTh1fxzzQp1sPb8vryXwcTsF4Nh6q8FTozUhW8bPgK	964	1358	1358	1616183640000	orphaned
1804	3NKGoyqprs6R2fvCMZRk8Q9R77UKQfhkiins6PyJPzc8ksXMW3EF	1802	3NLdazbFtbjJGxPSUvP6HKvgGCg2isSChhT8N8bvQKMgiygYHQko	1406	1393	5	1	1776	jwbX63oausyeQ6oYue5Kn5FsKPRqAWy4sohhxVNNQ7SpSv2v39f	965	1360	1360	1616184000000	orphaned
1806	3NLkRBQ5fMNBaB1ZjDkK2zhC5DubPV6CKunBSi9qJ8xnX6LS2Dpx	1805	3NLjqreC4U7pjSLvW5xa81L9rEQ3cFsUbEimKb3itULH8q92oGsu	1631	794	5	1	1778	jxptx64tadVswKKXS3Fm416viWBb9jBTCiBbasDbrYAeS4BdcAF	966	1361	1361	1616184180000	canonical
1807	3NLyJq2j2QCAjjSkFBWufLK3tYCLDNdy5FrmJoXuH8veitUDFgjB	1806	3NLkRBQ5fMNBaB1ZjDkK2zhC5DubPV6CKunBSi9qJ8xnX6LS2Dpx	1402	874	5	1	1779	jxBLvzPYezi6QzCoh3qRytX6VyhXAyE8hvFBy1LNa5GFyLuU63Q	967	1362	1362	1616184360000	orphaned
1811	3NLjREgumxnGVnJZpjiw4o62JEtTaCAArFEoMM9pEhFwQDpebh4V	1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1419	814	5	1	1783	jw73dC4E5kwbAC9YRGD2Tid7txyX2FoxKsVyVQAXnPkxEWuXJCk	968	1363	1363	1616184540000	canonical
1810	3NLxQ5uX9toDRrncLnDoMtqFhpFkzhL5Vfbi4LqFKjm4CyVwBbzV	1808	3NLibTSyqbCJA1hZ6uev4KY7DAxL92gsNRYWJwZYUZzbuNZAVXcL	1529	1316	5	1	1782	jwL82EZZ2YLuAbo6rpjjj31bntjiUUwGxtScsuxPeaUyjdsprwt	968	1363	1363	1616184540000	orphaned
1813	3NKL2MND72BQwpT6iS7WGL1YGjUYiYSvXS8xyZ6xKY8r1HjtbkgB	1812	3NLihAWrH2HEKb89WHkQfnyasUEMRZLTJ9rb8TJmov2CnJjsdgwt	1527	1293	5	1	1785	jxARZQfXtUur38EimVk6o1LUHmM9q4wLmxq1ke1RyHRheCMmsbL	970	1366	1366	1616185080000	orphaned
1815	3NLi4W7M6Q9pEnXzD5a1948jHRXudVXgc6zar27V6Fr3P2KWxDs4	1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1613	1349	5	1	1787	jw87jksDXTQnoK4pJRX9BMKmBwbAzDfaneAnjNFF5ZSv1KFjypH	971	1368	1368	1616185440000	orphaned
1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1818	3NKhMbBAgByBUTGTQQar3XnXitZFXfyjLp4Km2Wqb8yaUZHgGgWV	1516	1048	5	1	1790	jxocmhAJQgronmRLkg97m8d1CkNmfZjywCabNqe4fCnw7fzTMnj	974	1373	1373	1616186340000	canonical
1821	3NLCZMR3u676Kzmxrb6j1ty3jA77HSYoooWhfwYpLtm5WFVYiG1h	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	618	618	5	1	1792	jwo3uExSbSwiWztc8noxYSurU4H9TNjpV2erSWF26fWyPiKYD4R	975	1374	1374	1616186520000	orphaned
1825	3NKBMhk5Rm1zksZqsrVygCKPa6QVVUBSrbbaVNkxK9MgVyXFrMRZ	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1577	1327	5	1	1793	jwYsZRQrA1wngWA5rRJ6sGqJ2jDUWFXxE2PUCAWHBP6EhvgiTTu	975	1374	1374	1616186520000	orphaned
1828	3NLSyCvhY9tyJcfRwidSHAGVb82VLJTE3yQK5t47xMyxYYdw7AUV	1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1560	925	5	1	1798	jwErR8ScDyn6j3k3B6EedevH329JMLi46q6qy6aptTC1PyNmBZr	978	1377	1377	1616187060000	orphaned
1830	3NK2vPjSevE3wZrnAyrBckGuSZfRHVmVsarDokFoB8qKhkqykhwz	1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1476	1125	5	1	1800	jxfAAdTsmayhV3hQyPELf53cX6uYUvbr6xupxnUyWWvWpbS1WLs	978	1377	1377	1616187060000	orphaned
1831	3NLf1HSUdxKSeoy3J4CPHvj2WoMZMbwTsFz7EzWAF8GGAxS9fkAn	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1516	1294	5	1	1801	jxS6RsMAuPB6JNC7yvs82iPtNNC2p4izSd3vwqLvSuQKAjJocdP	979	1378	1378	1616187240000	orphaned
1833	3NLVaLFHCwysohywBpJ7uoytE8vTUqj3yrNy8z838BJ7KwGdU4mj	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1613	1223	5	1	1803	jxgMJgbDKs5JvmgarqbAtJ91YL53PRnwERWZZvUuFysbwfqZngx	979	1378	1378	1616187240000	orphaned
1837	3NLMKKRXGXUCKmkMCti5aNJ9Vw25Yjy2j68Ss1Zuw5UjZ7Ke6Khb	1835	3NKN3niUMBrFkauHXZUmpmYAFBQ5sz2m25wGs6D9VwxkJJ4MyJXM	733	507	5	1	1806	jwoztV6MfQHYEWmpM2BjJJsBzA3EHNrAD1hzoeFN9L9Jz6Lmn1R	981	1380	1380	1616187600000	orphaned
7893	3NLhcpKQKbZBDSrhc1tH2n6uFnYxZsgwHH7BP6deHxCTtk3g8ctF	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1631	794	91	1	6301	jx3NcgE6bD5sG8Fgi5jT1yAXZFdXgUVEdHf3Kdm421kvHjhuBmY	4090	5769	5769	1616977620000	orphaned
10140	3NLJFix829nM2DFEjpUJNMenoFEhu5e4jujse37gsowB6orfGxnC	9690	3NKGQ2XgieWzNkVfhj9USPHKZqHQNQNWRdX9a4QgpmKEJ9Rssy4b	1578	1296	124	6301	6626	jxEY2u6f5cZF3GX67Sy9Y9ATPVM78LYU4auWQrQHFTdoE9QQNj8	5029	7367	7367	1617265260000	orphaned
1817	3NLsohHWvP5YoUEVbyWASEiQNwj8TFyKjEeow63czxxen419eCwo	1816	3NKZSvbsKBMpFWR8LZZKLhpui2mBhdngxhXdc1Qxi57MQHkGhgq9	1405	873	5	1	1788	jwkmvJ8ismSZB78qpk7CRNvJvMraefvjyVw8gdfNyT2XYuGQRHp	972	1370	1370	1616185800000	canonical
1818	3NKhMbBAgByBUTGTQQar3XnXitZFXfyjLp4Km2Wqb8yaUZHgGgWV	1817	3NLsohHWvP5YoUEVbyWASEiQNwj8TFyKjEeow63czxxen419eCwo	1460	1078	5	1	1789	jxaHbGBH6LhjJP85kpVbVvYaEKQmF1hjHwqQigE5Smb1aaLE4Rm	973	1371	1371	1616185980000	canonical
1820	3NKdGUrK7KzJFhHMpYn495Qqay8zTVm7otv9wT8ExDd225KrjoXt	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1507	1280	5	1	1791	jwqJeywW42siZgjaCmQoaweKZQM8nHCFiUt62spm9y8hgCGprax	975	1374	1374	1616186520000	canonical
1822	3NLuBNFq8m3gYjit5zDpphvc73gRnqcKAaqN1Wh2YzMWZznqFDz7	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1577	1327	5	1	1793	jxtsAwPYyui7awesV8wBK46mAPoGVZZ6YSEcBZ2FkxMmyu96xBo	975	1374	1374	1616186520000	orphaned
1826	3NLqHBqnfxKJh4hTBrYPqS9JKczDNiu8tshA6fVT7xgc7424VyJK	1820	3NKdGUrK7KzJFhHMpYn495Qqay8zTVm7otv9wT8ExDd225KrjoXt	1458	1197	5	1	1796	jxf2UXE4bcJ4pjp9dAdeday3yBeSGLxh5LMaek3uASHJtRWGWTT	976	1375	1375	1616186700000	canonical
1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1826	3NLqHBqnfxKJh4hTBrYPqS9JKczDNiu8tshA6fVT7xgc7424VyJK	1402	852	5	1	1797	jweLtQ8ApyTWUcpKB58M8Zbo3CkHBH72DMFNRujNZGTDSXgF629	977	1376	1376	1616186880000	canonical
1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1827	3NKer3JVo9EFQbqfF6AAKuNtQ7DB3WddKMWWWxZg5MvAtAq6Q5g8	1426	1238	5	1	1799	jxbYuEr7pJ4oFmcorMdcqf8XMmBEAaLedwX4rFTE6vtS7aXxkJ3	978	1377	1377	1616187060000	canonical
1834	3NLGRqSebybEsTmSgnky8HaCJviW9gS2dXVegYJnXqEZxHU1ZVxy	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1613	1223	5	1	1803	jxeJA8bachnH1LQWccRB16v6rBnM2XW42CTMpLdZ5GBc8SZCzys	979	1378	1378	1616187240000	canonical
1832	3NLcda83gzYnZPS82DAK1QUNzhB4QLxU4zA7NEWLX8wEWpzM4A5g	1829	3NLrBXAhEDJvjRhL5j8d8cGUsbhHTfwfeu5Vx4pNPFRbNXmKXW2y	1407	1395	5	1	1802	jxnMgdVk2rxUCQHjeaPh6PtAfWqjHMT7LqHxAtHVyvzLUyNm5gz	979	1378	1378	1616187240000	orphaned
1835	3NKN3niUMBrFkauHXZUmpmYAFBQ5sz2m25wGs6D9VwxkJJ4MyJXM	1834	3NLGRqSebybEsTmSgnky8HaCJviW9gS2dXVegYJnXqEZxHU1ZVxy	1406	1393	5	1	1804	jxTMu8RY8VHfHH91SXmCqavki69Xhriy5ujdkUQhwKhE4aEgkqh	980	1379	1379	1616187420000	canonical
1836	3NKUHp1CAg5qGAHEUDpsHg57KZskhUnf5aPhfuZXpjKb4B3fkW4d	1835	3NKN3niUMBrFkauHXZUmpmYAFBQ5sz2m25wGs6D9VwxkJJ4MyJXM	1654	1340	5	1	1805	jxharMoPQkEThzNSJxMgqLAM3JEttj2EuDCc3v6uaxdAmuJKCyE	981	1380	1380	1616187600000	canonical
1838	3NLweHfi21u8P9TownxaYu8XYhupBH13kqiJqRAB7ShCXsbaQSEv	1836	3NKUHp1CAg5qGAHEUDpsHg57KZskhUnf5aPhfuZXpjKb4B3fkW4d	1587	1357	5	1	1807	jx4jYjBzwrkahtecNjX4f7DcvsQz1T9jLAqG3FnPkpwcPXehfyU	982	1381	1381	1616187780000	canonical
1840	3NLkZD86QX3XhQwQ977fGkqUJVV56ipGjmfw68CtFdWpFgkHfvEY	1838	3NLweHfi21u8P9TownxaYu8XYhupBH13kqiJqRAB7ShCXsbaQSEv	1559	987	5	1	1809	jxjhZMDDJF6CSbJJWFx5bCDFhyMe7CrCeJRLkRuUjB1rgVBCCHv	983	1382	1382	1616187960000	canonical
1839	3NLAFhJb8EDRt9YPRuHEQLHzDHtEyqnSRqKzQdKzsNDQ3vdWYFyd	1838	3NLweHfi21u8P9TownxaYu8XYhupBH13kqiJqRAB7ShCXsbaQSEv	1650	1375	5	1	1808	jwedrPLdyLEqHi6dLZviXw4CTJQE6EogABrtfP4NDYbU9s8MQbm	983	1382	1382	1616187960000	orphaned
1841	3NKK3THaq3bA9tdy1EYWKtkzcEbDHYahd5D6QVK8xMXapLX16qBf	1840	3NLkZD86QX3XhQwQ977fGkqUJVV56ipGjmfw68CtFdWpFgkHfvEY	1670	1282	5	1	1810	jwL5yo9QQjA8zVpsCps7R2cVBRycnzFukdGkDfoJMemvg8WrBut	984	1383	1383	1616188140000	canonical
1842	3NLEE3VyKGnDNrdiUPHefkAJmLY3TTo4XwuzWMntJBHsCg55dQAq	1840	3NLkZD86QX3XhQwQ977fGkqUJVV56ipGjmfw68CtFdWpFgkHfvEY	1671	999	5	1	1811	jwJLW8RaVTteQY3WUK5Ly153GTD99DtM6tdc7JzBsjYKeWzmyZ3	984	1383	1383	1616188140000	orphaned
1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1841	3NKK3THaq3bA9tdy1EYWKtkzcEbDHYahd5D6QVK8xMXapLX16qBf	1403	782	5	1	1813	jwSmxGDGTDafsFDBz6EToaYHMfoE9hAdx3XPqj3e94jUQNSVNrn	985	1384	1384	1616188320000	canonical
1843	3NKn6CbmMXLadHZCpSj38mREVu6Vixc266jmueR64BkajUBbNwFD	1841	3NKK3THaq3bA9tdy1EYWKtkzcEbDHYahd5D6QVK8xMXapLX16qBf	43	1184	5	1	1812	jwBYq7iBczjtRZecSzv2guu4N7xE4A8u8qGuk7AAcx6dwH2AFmi	985	1384	1384	1616188320000	orphaned
1848	3NLrdvW6Fc2VRHcHtpzMdhCvezptuHmeA5a95auf7ry599pFp1Ss	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	641	1210	5	1	1817	jwvaVPrVhvgkXKQpxMLnh81PRFyfb62xF3aRvr9EnuotqtVAdyQ	986	1385	1385	1616188500000	canonical
1846	3NLZSS8AmEVEHo36sC2b7S4HiFKoNeqnLGM5s4u8mwNiaysazUue	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1654	1214	5	1	1815	jxdpY8JvaZnigUpSauttYpXc2G8AVTEYBM4Rfk9gUTkysiz6m1v	986	1385	1385	1616188500000	orphaned
1847	3NKtLWbDSppjH9Y4pUu4BcJjSwNbkGLdqA9MBBJNajCDJfxN7d2Y	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1489	1254	5	1	1816	jxp3paPsSJRCougnedE3um8Z2GEj64FtE54k4Hux39BmCMxn4m6	986	1385	1385	1616188500000	orphaned
1851	3NKh1XhVDQmJp7a53JTgA2mJvVSiKrhxpB117WWu5CCXR2S8ErNm	1848	3NLrdvW6Fc2VRHcHtpzMdhCvezptuHmeA5a95auf7ry599pFp1Ss	1407	1395	5	1	1820	jwekmjpeQEgwxMfuNpF38ZDj5yvnJpEopp6qGZSpfwWwMufbqcx	987	1386	1386	1616188680000	canonical
1850	3NK9SFAM8PMFKb6FP6qQ87voLDqjL3tBm7niJ6TBs5fsDpSa53wx	1849	3NLSBvDadtc8MgnRacFfcQrfxDCjFbKWPkDGjSb47nLof6SqN5Rt	1553	776	5	1	1819	jwdSJhHoet8D1zKhmm6oUyY2NsH749bpVYCHHwixTobqxSyv1JE	987	1386	1386	1616188680000	orphaned
1852	3NLAwE55G1d6oEgAvoZzJSJHMPiakVzcL1PaYw95CogkNmGuBYYq	1849	3NLSBvDadtc8MgnRacFfcQrfxDCjFbKWPkDGjSb47nLof6SqN5Rt	1633	1264	5	1	1821	jwX5LkFsNDm9Cc9B3W42co3zENUcpJ5unXe4uBuDgxsGSxn9GTn	987	1386	1386	1616188680000	orphaned
1854	3NLvJpyxrfiQ9p9AQ1RKTaiC6Y8VBoyH89XH4HLXTBbuKLY1n3H8	1851	3NKh1XhVDQmJp7a53JTgA2mJvVSiKrhxpB117WWu5CCXR2S8ErNm	1489	1380	5	1	1823	jwyF8RYTzWCT4mPw7qxUWNNQH6zr2uxiM1ULbBaPtGDeuUsB5NC	988	1387	1387	1616188860000	canonical
1853	3NK9BEvRC3aWZyDWQccgdXCPv9WWtqAJrwCoGnY7veNHTAgWZpHK	1852	3NLAwE55G1d6oEgAvoZzJSJHMPiakVzcL1PaYw95CogkNmGuBYYq	1489	1380	5	1	1822	jwze4RKqt93quMV4jPbao3xrbibeKErVuV5uAV2AficjVuvFU2T	988	1387	1387	1616188860000	orphaned
1856	3NLcuYbaARwRUvQE6DUgwchUjGbWz9doegL24mX4W1rijXSNxED9	1854	3NLvJpyxrfiQ9p9AQ1RKTaiC6Y8VBoyH89XH4HLXTBbuKLY1n3H8	1529	1316	5	1	1825	jwn8KnaSzLEBfc9cKMq4z5vG11L2VnXA8hHkAQPahGYmqbj4xf5	989	1388	1388	1616189040000	canonical
1855	3NKjzBg2PBjdZr7YRHx28QxKdxMwqS92J6ZPNiZL52HcHgtdNVJQ	1854	3NLvJpyxrfiQ9p9AQ1RKTaiC6Y8VBoyH89XH4HLXTBbuKLY1n3H8	1593	1220	5	1	1824	jxuY8DafoJKVfHBTmYCahn6g3FitezSVGnBCizZsNJjyawDAxAh	989	1388	1388	1616189040000	orphaned
7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	1652	1069	92	1	6301	jwdm5N9iS4Lp3gJTuwQzmEFZMJPdVnwC4quc5zgURkbTjcmXCia	4092	5771	5771	1616977980000	canonical
10223	3NLnh3VsAzyGobo7mRKkEKhHEAHDiJgzT6CP746oEiugHUDFLrSZ	10137	3NKu4zLP4vU6h3x1y3W7FDFxp7qVLPrCfi2176ptVntmbHjDEGwo	1643	1299	126	6301	6700	jxvPqR4qh2fj4cNsBnJ6YRdirxXUCxuKoi9FV3G2dWADRYxLRJA	5029	7446	7446	1617279480000	orphaned
1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1856	3NLcuYbaARwRUvQE6DUgwchUjGbWz9doegL24mX4W1rijXSNxED9	1507	1154	5	1	1826	jxe5REnSb6RmAGVV5VyrkfSXGDaYmEMgvy9ynzGqU1strMki97Z	990	1389	1389	1616189220000	canonical
1858	3NK9DrQ5k5xF9pCEiN6brdGLYpd2JvvNwSJNg2d7Ztz7rmzWbwVp	1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1405	865	5	1	1827	jxcRULHStWe5s4a9mzPMxgzJx3eTtgS8Be6gAhzGnwqKmwTgdUe	991	1391	1391	1616189580000	canonical
1859	3NLNhx7fhY2iRGkYVSnLvDhPPfaMuVgvz8fB9ZFoL2FGxGMdgWpi	1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1646	1354	5	1	1828	jwtfcjmx8CQsiiC3XwSBKkcqXDfQb8FAG8pDZw8t3Dopr2w1MSa	991	1391	1391	1616189580000	orphaned
1862	3NLRf4f7dVWJJZtgivyxmg7hL1m2AvC216C7548H5xQAwTxVv2Br	1858	3NK9DrQ5k5xF9pCEiN6brdGLYpd2JvvNwSJNg2d7Ztz7rmzWbwVp	676	676	5	1	1831	jxJUgoVtE77Zu2i6i9xnTpr6mg5YLa5cwCfsLrnjRbPBeWo5Mqx	992	1392	1392	1616189760000	canonical
1861	3NKWkEYZp2eT1ry8EPT2JuPTWJR4B4fY2ZTSQwTwsRo93kB1aTP1	1858	3NK9DrQ5k5xF9pCEiN6brdGLYpd2JvvNwSJNg2d7Ztz7rmzWbwVp	1599	921	5	1	1830	jxbvevPDxsc2pQ1MF7EXknHG3xWkpBBHPit6XxMDf1LqLZVabMR	992	1392	1392	1616189760000	orphaned
1865	3NKPd8tpXURES9jEKH6NE7vJYCeeFy4YVEiJjfYV6A1qiKhva1mj	1864	3NKhciGbc4k1o7BEyyDKcGHc7U42PhF2C3gLR4CVaBbdcPfbCR3Y	1634	1331	5	1	1834	jwWEipw2djcoZSVC2k7H4ByXR4Hx1ibCCgrUqynLPfwuBN3kKS2	994	1394	1394	1616190120000	canonical
1872	3NKyqirn322qtk9LKK1q9gpV6YgQi39ryeaWwrqjfXbkGzYxVVsi	1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	152	1330	5	1	1841	jxDB9nhCJvVXzqk6cXtkpAwZ4C3ygG5z4HJg7AUKeqypUNhDwGU	997	1398	1398	1616190840000	orphaned
1875	3NLqNKfuFL72ugkwueZQKKHoac73bxptPpmWwysbY8eBJW1djWhx	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1571	1335	6	1	1843	jxBUUnPhuUqfV1KxR2nqs6A8a7dh7Prnydxh697C4wjjzHrfuWE	998	1399	1399	1616191020000	canonical
1878	3NLxAvCJ387hQjioMjyhdnyKTW4scnsv34xgoYDy25RQwwPJJeZU	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	171	1374	6	1	1846	jxReJTGHr2Gx4c15X9TKkmWb3DxBondFuM37P6Gb7LGD8WuEo9J	998	1399	1399	1616191020000	orphaned
1887	3NL9ePJn4P9k6wtaLgGHWwDcYihvgysP7mFjyEC6cpBzhQokyUop	1886	3NKaeHBw1JYiqG1M1JWdLn8dWvdY6Pu6C8g2uGcSzFbMuyh41AGT	1609	1333	6	1	1855	jxSYU33hcz4XYPSge6pbDYVqXssTd7EGY4Cj1JxGWk3Dy8uK6h3	1004	1407	1407	1616192460000	orphaned
1890	3NKwSZbvmtGeXcsLrXuSDoPeEmXXX9mb1jaiy2unF6t1wdBRbyG8	1888	3NKV811MvgeanxnSTjnBXTVnQKj44aU58vWVzJyggdE6fmgCTUA5	1573	1318	6	1	1858	jwKpsWbB6XZho94Z5Ym2TnsxnaQPxq3SmN4ckmoMgwd2SeDYUX3	1005	1408	1408	1616192640000	canonical
1894	3NLC4RGk4UfUGXpmC8WXj8C2CqkWg2vUCssp2BfoU7EMNPgqehHw	1892	3NL7aSqCPKBmqUykZqLvkBtwS6orouf1dkzgkfgLjwTdiU4bUdka	1633	1264	6	1	1862	jxSYnfGqy7MnZmwUHA8BWXNttdgLP72RkwKPvhQ6CArmLJuri8u	1008	1411	1411	1616193180000	canonical
1897	3NKncNTfWVeG4tEANsc8fDUDJKCbaezmsQkwoDtP6ZiexpEK8zFX	1896	3NKjqmvZnUe145gPyjHeDvA9YeJMZnUvnu5mpazsugPdEqBwHkkL	448	1305	6	1	1865	jxR1b51Qu5fWoTribMt4RnHTUQXKSqfxjEFoRCzwWMwgiaqGhGg	1011	1416	1416	1616194080000	orphaned
1900	3NKvXNcfF6LKMjRzFxaKSGh5jQN8dcGkxiq3QRaPquMUVbqhonna	1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1527	1047	6	1	1868	jx4ygoSwuqkhWN2zLV2WTxEwyp9uK49P7kQ93oa84PUG5oYNAL5	1013	1420	1420	1616194800000	canonical
1903	3NKZJFiCPQw9Pe8pco4yTCoh4chQmqSFjvd8oyTCfdEE5u7QPpr4	1900	3NKvXNcfF6LKMjRzFxaKSGh5jQN8dcGkxiq3QRaPquMUVbqhonna	1429	510	6	1	1871	jxC9xY39hWj8dDFSkCoLTrN16d8xXAFu5mMiVQRF8AL9eTMdFHD	1014	1421	1421	1616194980000	orphaned
1910	3NKkzLupsTGgfjuzuaUcFDcpTTBX1LnviJkyBzntFA78HxM3aqDJ	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1581	777	6	1	1877	jxg8N5GpfBMKvBT7kxJXwEGMi1fdcizTEg139SNhJZZRC9jCPLu	1016	1423	1423	1616195340000	canonical
1909	3NLB9pxcsdUgwgqCvejjbUgYe8cCmtRk4wvFjaFPbZerRDxYgz7M	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1541	1172	6	1	1876	jx87shMfmN3gA7onH5hSCsawo27JWNCd15irpKRDELEzErUaBTe	1016	1423	1423	1616195340000	orphaned
1913	3NLbKadvk3jrSL9tWC6sEGWtNm1Ninnj93A9yoYn3rfs6fn3v7Ez	1912	3NKdwdxqXQ27SvxsJya2TTXgD8uxFzTBgURD1iFqfFHuDwU84bmH	1477	1350	6	1	1880	jx1KqDjjn8fHKzmzFvxwsoaWaqrVb9pmjcoRLkVEPxztTi8udoq	1019	1427	1427	1616196060000	canonical
1916	3NKJiyqiJx7hNHe5vZzNiMFpSorVbiAPC6Ebpt813cSMzuw7tmZP	1915	3NLZQb8QbkJEKsE7ap9yp3aiYqyqzqZvyhBZMtU3FZ1g1tao8J6q	1657	1344	6	1	1883	jwsTFZNnWkKdaaj5W7c65GwYLA7sDtgP8EZ2CQvZwNRpePtArpP	1021	1429	1429	1616196420000	canonical
1922	3NLDuymY4o1x2B5gM9kHQZHr9kBddK5oTnmo8XcKgz26cRmxe9Ck	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1609	1207	6	1	1889	jwHEkfFj1QeEaG7QKu19Xe49nUNQKbG2tUmVYt8nBntGWdKZxAT	1024	1432	1432	1616196960000	orphaned
1927	3NLFpnBaGAEo7ES9mwhBQ3nSsDxdfRybE9KRGvUXuBjyxHhyiopX	1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	684	986	6	1	1894	jxptwxqWudWteEutSsb2qyfrTdh2376wmhPA9ce3LzS3TFqfPkD	1025	1435	1435	1616197500000	canonical
1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	1930	3NKfM79W2BYYbuxpXP6ESqTZ4r6NByFZrC9VZkG1vywXc48LCT3H	606	1295	6	1	1898	jx3oJDKv7jDX7R7PhdpaK2ubSP3z6F7f9gtLa1iT8qMnJfsMiKR	1027	1438	1438	1616198040000	canonical
1935	3NKZVBAcVH93NZyGMx2Y3DoF8YdAVkuF436s5zGn7Hn1Sv2fMAWi	1929	3NLw1DyfKf1VKrs3Q3ufX6VnTkPYs2DYY8J322ZJ3YwU8QxTXFVC	1489	1134	6	1	1902	jwqQuR5ZD75puUpX1Ur9FZu6LqY7rdieGp9H1spcE1rdUWAEJuB	1027	1439	1439	1616198220000	orphaned
1933	3NL3mrzFQ8joPYGfQQ7xkodipB3CRqEQVvsiUqu4eqDFj1Jd97XM	1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	1407	1395	6	1	1900	jx14TADyvHciWVPGWv3SXRGZxiWhnaQ4rqcRdAnwNVwaFSehw7Y	1028	1439	1439	1616198220000	orphaned
1941	3NLvKZFjkvFKF9z3GLvJEv6Yr34L83tmr6uYEFr6GzHoU8Vqx5bH	1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1553	776	6	1	1908	jy1jm54WCHtoCx3JRCuhWDyRQfgDeEMMAFQMQ3aZhTbtexrxvzv	1030	1441	1441	1616198580000	orphaned
1945	3NL7NEnqVNHRPFGP1zmgqX4mWoYUNMg2RRJpzByp1dKdwd4CPAkj	1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1406	1393	6	1	1912	jxWdmuea2PiNkkinG9zKCw21t1LeUBqmWxMZmAoe2RMVRY5MhBh	1032	1444	1444	1616199120000	orphaned
1949	3NK3vnxcwtV8yrZ7hTsdRpHxdaMGetmiAjD6qX5CLJdedP3wXYem	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1460	1324	6	1	1916	jwso14Naq3NgXMmyyjvWvgFkYsBXVxpcFB6YDM4GTw4WX61b3yY	1034	1447	1447	1616199660000	canonical
1952	3NK82riDuEbrKtrHmzgzr4g4oYrEcSGV4SJgLMAGJwu2bXGxjYKj	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1631	794	6	1	1919	jxL9vmaAqupLkF8vKgwJAJ4HCC94rmG8FX6P8Kd7wLfAaSugq7u	1034	1447	1447	1616199660000	orphaned
7905	3NKp9zLw7pMbswwAfTtfVpNY5HkthmBWqw9jp8jYL4FZivWUcJmc	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	171	1374	92	1	6301	jxo9GtTRFx3ZPNW84Ka7zj5mKvPfG4mYzpPTe4oBbkgYTHFoHFK	4094	5774	5774	1616978520000	orphaned
1866	3NKKZsWivW4z1uNHsPjAF1NhuU4RMJZaY5uph1BKmghjZNDhBecc	1864	3NKhciGbc4k1o7BEyyDKcGHc7U42PhF2C3gLR4CVaBbdcPfbCR3Y	1407	1395	5	1	1835	jxx8Y1bZiCYSrNh1xAenJTVPTmKAE32tAPPD42jGYzmmF5tTcAt	994	1394	1394	1616190120000	orphaned
1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1419	814	5	1	1840	jwx1XghC5heKL9B8bb2qarASJY9beFVKvPKwbX4hgbBS7JGQ6gr	996	1396	1396	1616190480000	canonical
1874	3NKydw9GiW9vQ5V98UriQoKkvjDHoojrQVVYF29gzGTPHPDNNjqw	1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	152	1330	5	1	1841	jxDB9nhCJvVXzqk6cXtkpAwZ4C3ygG5z4HJg7AUKeqypUNhDwGU	997	1398	1398	1616190840000	orphaned
1876	3NLRK7bV9hg9qc9WfZZPWfBPNCrbyTzHU7L47k6jkzeUPFByzL9D	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	58	1035	6	1	1844	jxkLHpdV2cYj7as72dNFbWTvkHLjHiqrHLvN1uAiattd81NHb6d	998	1399	1399	1616191020000	orphaned
1879	3NKmMdX264FjauyVV84eD5ZMzCyFo7V1CQ6XDhpijutKipdGyj5f	1875	3NLqNKfuFL72ugkwueZQKKHoac73bxptPpmWwysbY8eBJW1djWhx	1403	824	6	1	1847	jxrfp6MfY4nUnRrQmFPiaCXL9FDETXkw98toCHrHsN8SSkfGBcw	999	1401	1401	1616191380000	canonical
1881	3NKaYkX59MdThj5o9c4nhdA4oniBQiQTwvhfvwGMrH2o2Bk6xFjZ	1879	3NKmMdX264FjauyVV84eD5ZMzCyFo7V1CQ6XDhpijutKipdGyj5f	1447	1099	6	1	1849	jwPRHsckDkNkX4VxC9XjNgYxbHXFt2GmAUjYDZFUNeac7M2yqni	1000	1402	1402	1616191560000	orphaned
1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	1880	3NKrnCRmvomXqor8pnqrUsLv4XcofJBu8VWqAsWRirGNPszo1a66	1406	1393	6	1	1850	jw9DRnG4wZoLYDxtVXfkJcVUXkFCNnnuxioeWYfRBRjJ9dz8j7N	1001	1403	1403	1616191740000	canonical
1884	3NLaM85fs9WBDAX8RXCBLDyPKUVMMhEXwkwnymQswzmfsDGLUw1C	1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	1406	1393	6	1	1852	jwXYPqY7za5ZwkLV3Rc1QkXUsX6R6yUSN9PifmDZbBfq97AGgoU	1002	1404	1404	1616191920000	orphaned
1895	3NLQRyK881UevGtNCgpMgTsiWrEqhcbPRANQvdL1DfZSMP11f8pi	1894	3NLC4RGk4UfUGXpmC8WXj8C2CqkWg2vUCssp2BfoU7EMNPgqehHw	1619	1275	6	1	1863	jxFFyUNeq9WCkbhuf7WN9pXNCw4NA1FuCespWJAriEdbSGYPT5w	1009	1412	1412	1616193360000	canonical
1898	3NKcUqrt3oXmkmcQHu6LuKJDPDJniwkZ6KgVzAjf9Zdj4oC3VcMh	1896	3NKjqmvZnUe145gPyjHeDvA9YeJMZnUvnu5mpazsugPdEqBwHkkL	1594	1080	6	1	1866	jwfEELDuW5QSVf5Ymr2AkEd4mb959oPpjs7G1U41CzMM1cM5U1W	1011	1416	1416	1616194080000	canonical
1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1900	3NKvXNcfF6LKMjRzFxaKSGh5jQN8dcGkxiq3QRaPquMUVbqhonna	1429	510	6	1	1871	jxYt63vvCR1fqwwuwriphkrfAbfX5akxkHRjZk4CEiRLzLTzd2A	1014	1421	1421	1616194980000	canonical
1906	3NLhx7Ky2LwDdicDnDwzwTUoJ85bDwDqG1oidj2SSHT1xgSLFvnN	1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1406	1393	6	1	1873	jwTQunYbKGShuY3Gh3wJ4535NwjPkSAgxoaW2QTePQaix7kYTmn	1015	1422	1422	1616195160000	orphaned
1908	3NKjsvu9SRR1rJiWS7jYpKkyJvgzVUfMiKxbmnpmLNHLoRwJKP9P	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1503	911	6	1	1875	jwQhTyuoXBDRMJjGk4p8AmPbzgarGJJEefQj5HTyjwzWfbBeAJ6	1016	1423	1423	1616195340000	orphaned
1911	3NLcgJ6pS7nnVYLoJwHGrTzSc15eggaAGmzzNvGL1DzsQduCvjLS	1910	3NKkzLupsTGgfjuzuaUcFDcpTTBX1LnviJkyBzntFA78HxM3aqDJ	1585	1366	6	1	1878	jwuVTBaMjhPM4WqrEpP4xYGA3MdHD41pQQL3PcZVzFEMsXvCamo	1017	1425	1425	1616195700000	canonical
1914	3NLwJbUvZ4n5ctTXVRPxHPEyrExXFCDZf3zCJDJYoZWztu5td475	1913	3NLbKadvk3jrSL9tWC6sEGWtNm1Ninnj93A9yoYn3rfs6fn3v7Ez	1564	1092	6	1	1881	jwx5pb7EYstatb3d2BDKhhPJaQZzbZMaAZcF6y8P89TeeaapNQ5	1020	1428	1428	1616196240000	orphaned
1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1916	3NKJiyqiJx7hNHe5vZzNiMFpSorVbiAPC6Ebpt813cSMzuw7tmZP	1407	1395	6	1	1884	jxfEa7kw6sVUiKemKojicdD38JJUjLqWdQBG6CAhrhy71uj3NYc	1022	1430	1430	1616196600000	canonical
1919	3NLujkTroXnM1k8wayHBJWTGnLXQmkywCtc7nonN2N4dG31wNGZ4	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1560	279	6	1	1886	jxhgcUPuV2hrdLpta7bQjDgDwqBGT65Ljb8UrrHjQ2AkQYiFShA	1023	1431	1431	1616196780000	orphaned
1921	3NKPMvWEviDKD1mQW8pjNw5kXAGc8gdHakvxX9Q4KPwV6zSFppYV	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1646	1354	6	1	1888	jwCYJEtCu2kh9sdY16Dmx1Rn7SmjBwWAaqrGXo3vgBqfd8DfXw2	1023	1431	1431	1616196780000	orphaned
1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1406	1393	6	1	1890	jwMfkS88eg8FvxCDd8pZXYSgkNHVMkZTpdXwsX7sx79S9eV13JW	1024	1432	1432	1616196960000	canonical
1926	3NKvGrDNyHjX32ik4cchUD9nYu4DUHxjpvRBfZn1ULRJMwxRhy8o	1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	1553	776	6	1	1893	jxGzbkQdJxtpt5tYaFTETQXv9JEtxxQ8VBTgPddgAa42mhJz3Ss	1025	1435	1435	1616197500000	orphaned
1928	3NKFWefKTjqekd2kLBhKWgHUj4tqjayE4AcmPFV3VzfpLPE5kW9M	1923	3NLLnQr1x4T4AjA1djVdVcfBacjGtqhiYK9LqpXgVh8Tk9qTBhKw	58	1281	6	1	1895	jxS4SKeuASwpiBZ51LmizZwcr7XEyF16LzFe6KFhEPBh2gRy8JX	1025	1435	1435	1616197500000	orphaned
1929	3NLw1DyfKf1VKrs3Q3ufX6VnTkPYs2DYY8J322ZJ3YwU8QxTXFVC	1927	3NLFpnBaGAEo7ES9mwhBQ3nSsDxdfRybE9KRGvUXuBjyxHhyiopX	1406	1393	6	1	1896	jxHxXu1eD4RgJp56WKeuKRSrQAzgM3xPw19uKtM2gyUYV6hgAiL	1026	1436	1436	1616197680000	orphaned
1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	484	1319	6	1	1901	jxacvzN6wCXDxuP4hhMvgNd7WVrR48CKqKMJSMAct6bFt7p3RE9	1028	1439	1439	1616198220000	canonical
1932	3NK565aesyTMnN1cBtaZsrsr4AKpTXiMdCgffUcPCTKCogP5Yew2	1931	3NLN2WHAM6BsbHrFq7ZsJph46ZRezmLQwsuyPMFwrGHkSxJQfQ2A	1489	1134	6	1	1899	jxpnDJzL3QqGMYSuXSSFwy4rko8RBau5A5fArircrQhGSVDev3c	1028	1439	1439	1616198220000	orphaned
1955	3NLtQrtUmy1X49ZkkWC3FCrhxjzjqP3fNQZwPbtcjHGPaf45LViR	1954	3NLqkystfrDA3VQkYJGn4R2WWM3kKm7ae236ymmrfgYZW4aGydAh	1534	1317	7	1	1921	jxGmNycKcQMVtMPcguBispGZB2gDFipUnk7Q3yLk6M57egozhuX	1036	1450	1450	1616200200000	orphaned
1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1957	3NKnDkBN1ngJrc99hP7vSx3r3zmNiSMkEPP14NXiaugbYBKqCKKp	1652	1069	7	1	1927	jy2CpmR161ubkfazxQrEjNsWUjxWzeyzr9Q6AuRBBU5h4aNnehJ	1038	1453	1453	1616200740000	canonical
1964	3NKbU6kYjmBzP3h3Kz74Hw9jUZMNJx6xm7QG3bthAxLAxTKRwn8m	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1652	1189	7	1	1930	jxwDVLtikG8KHBrRNmoFinwhCxVgJiSEoQADAfgW1yLwW6wkxiq	1039	1454	1454	1616200920000	canonical
1963	3NKdUQbg6Hjp6yyFojuqzXF2p3LEiUNKpPyFi2v7s5MqC8kqdTdE	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1650	1249	7	1	1929	jwU9uJocS9CwCE2pMdkn2yK6b3rctoQ6adUHYeiGFSEphRoSU4R	1039	1454	1454	1616200920000	orphaned
1967	3NKUQbZyLMcATJ51KoCV9WPP2esmreomQ3kE1UDpYhukafvM52UH	1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1542	1058	7	1	1933	jwXafa2XQBoVEdd9ki2jWCmDz1RWvjbHKxMZivKbyeshsJTBa7G	1041	1462	1462	1616202360000	canonical
7907	3NKxBa9jmFFHQmVCVGcp23oJr478KiTudXN65xmTpUytCcBeH5vD	7906	3NLeivCZcniPFdhywUy4RuHuGLHQFE8nXJ3wMG9mrmPSWyw9pFtG	1407	1395	92	1	6301	jwszkTc3iC1yNktqbnxAcryirEs4QaCqqKGBtBGtRjJsrSrSwV5	4096	5776	5776	1616978880000	canonical
1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1865	3NKPd8tpXURES9jEKH6NE7vJYCeeFy4YVEiJjfYV6A1qiKhva1mj	1407	1395	5	1	1836	jw8tgFSPSUCdiNkkerufRRDFsPXMCz3Jctdg2Kthpd4b4mEer1a	995	1395	1395	1616190300000	canonical
1869	3NLD8giC3YVLzNo1eGP8e625vo6MtFQ5Dtpzd5J8oAMMyso8rRmo	1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1622	1356	5	1	1838	jwWoJfuxzSAXfMGbQon51fePuGhorWmf53HksAETfSDeUaARGew	996	1396	1396	1616190480000	orphaned
1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1871	3NLihW9j2oC3kzrbs9Wc7Q2mfCjKLd8rBSALEf155GUaZECopVHd	1509	1074	5	1	1842	jwP8WvJaheiCtYjRrduKkiQEw6iXAJXzwAaMfVoRuPygzKfgWbe	997	1398	1398	1616190840000	canonical
1877	3NL8eNXbw42f845M4qxmdj8SdU8oot8hKapSJoyeHL916Lamg3qi	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1637	816	6	1	1845	jwHUgJXBAzB867A75TpgnB1pACuQcoUmeNw6EHKo9Ngw3cPsLYN	998	1399	1399	1616191020000	orphaned
1880	3NKrnCRmvomXqor8pnqrUsLv4XcofJBu8VWqAsWRirGNPszo1a66	1879	3NKmMdX264FjauyVV84eD5ZMzCyFo7V1CQ6XDhpijutKipdGyj5f	1403	824	6	1	1848	jwg29vfaZ8FQNwavvaLP76mVgvcs8EVbwDtC2czwLD5DfcQfx1Q	1000	1402	1402	1616191560000	canonical
1885	3NLbY7WQb29isKPmFQMYgQKFqQDvN3SaLBdHYB27Vs8V1DRVDkbj	1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	470	1309	6	1	1853	jxL2gVcstZmdmaF6urZS5GNiREfs5WWcCqxbe9hdMVeVfwALdGP	1002	1404	1404	1616191920000	canonical
1883	3NKuqeTE8TrPB6xadfxV5rpxaJoQBW4N9WFAUn3wcHtBN1Ais8FL	1882	3NLEFXhLwu4yyicJGC9hXx5fjymant2BZKpdXxiNNqBAvTRmCnHA	1503	1277	6	1	1851	jwkvNpNRzs89KLTC8AvPmmuopTpV8o3oHoFN5KxkcR2Vs4h2odp	1002	1404	1404	1616191920000	orphaned
1886	3NKaeHBw1JYiqG1M1JWdLn8dWvdY6Pu6C8g2uGcSzFbMuyh41AGT	1885	3NLbY7WQb29isKPmFQMYgQKFqQDvN3SaLBdHYB27Vs8V1DRVDkbj	1559	1353	6	1	1854	jwYjKkP2QmQYuLkhyge68cP7h5qiTMTAVRN7SHDynQv6ZjCYzgE	1003	1406	1406	1616192280000	canonical
1888	3NKV811MvgeanxnSTjnBXTVnQKj44aU58vWVzJyggdE6fmgCTUA5	1886	3NKaeHBw1JYiqG1M1JWdLn8dWvdY6Pu6C8g2uGcSzFbMuyh41AGT	1440	1377	6	1	1856	jwYaB1hLKuBJAsyjbG1kUZEEWZb8c7hehvisXBbU73NAtbTZFcY	1004	1407	1407	1616192460000	canonical
1889	3NLvbVrfaRZCjP6Su4tjicDBwQXnFNB4YF5VRVkWcDuBaCXLLTJu	1888	3NKV811MvgeanxnSTjnBXTVnQKj44aU58vWVzJyggdE6fmgCTUA5	1619	1275	6	1	1857	jx2dfQh8s9Nonc91Gpd23D8HJoEqCp2DjX1yyUx7y533Uz8QWos	1005	1408	1408	1616192640000	orphaned
1892	3NL7aSqCPKBmqUykZqLvkBtwS6orouf1dkzgkfgLjwTdiU4bUdka	1891	3NKEgoUYPvpjWemBLFJAR6Pae83QBJUftcsF8DhpEs5RGtF4j42f	1445	924	6	1	1860	jwePw2fvdVMHnLxhKDByWYwU5vYpSAVDp6nX7nh7aEcFqNr9AZr	1007	1410	1410	1616193000000	canonical
1893	3NL4GW7Js1eHyjorNmEkb7FnYXxKjSLL91WUr1YTzMF6Ju9sFudw	1892	3NL7aSqCPKBmqUykZqLvkBtwS6orouf1dkzgkfgLjwTdiU4bUdka	1608	1289	6	1	1861	jwcKGqJVtmKmA8mEnmDCwhYzEAUpLBaYUQB1PuXPpRJTxucHKhP	1008	1411	1411	1616193180000	orphaned
1896	3NKjqmvZnUe145gPyjHeDvA9YeJMZnUvnu5mpazsugPdEqBwHkkL	1895	3NLQRyK881UevGtNCgpMgTsiWrEqhcbPRANQvdL1DfZSMP11f8pi	1407	1395	6	1	1864	jwbdqFMtS4b3RvRqJaareUg531gtdJqY83z16DCcXLxmKksAvnw	1010	1415	1415	1616193900000	canonical
1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1898	3NKcUqrt3oXmkmcQHu6LuKJDPDJniwkZ6KgVzAjf9Zdj4oC3VcMh	1627	1385	6	1	1867	jwr1V6KebjHqn2dZhLzn8X4qfDMjf2JXRFkN4pZEccp8xRFGJY5	1012	1419	1419	1616194620000	canonical
1901	3NLncycmyLj8DHHiZK86ra7qZaxhnq2ZLm7JSCVE9HLHLJevjguq	1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1406	1393	6	1	1869	jx9gqsxTt4HFyqtw6GwvPDLLGGXr3mbaDbTjx6AoTc7q6fR3bZE	1013	1420	1420	1616194800000	orphaned
1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1654	974	6	1	1872	jwan5uGixrthTCuR7BXWFQziFudDDGy5pvB2XKoaaej9WovgTrX	1015	1422	1422	1616195160000	canonical
1912	3NKdwdxqXQ27SvxsJya2TTXgD8uxFzTBgURD1iFqfFHuDwU84bmH	1911	3NLcgJ6pS7nnVYLoJwHGrTzSc15eggaAGmzzNvGL1DzsQduCvjLS	1402	870	6	1	1879	jxYtpxrpzHdpSP9iCcXv357NjTKs3dwhyeHgeS6exERzuBUGJLU	1018	1426	1426	1616195880000	canonical
1915	3NLZQb8QbkJEKsE7ap9yp3aiYqyqzqZvyhBZMtU3FZ1g1tao8J6q	1913	3NLbKadvk3jrSL9tWC6sEGWtNm1Ninnj93A9yoYn3rfs6fn3v7Ez	1590	1300	6	1	1882	jwx7Uhk2t8P1ZLuNWNVpmL9hdPFAbYjACXSh45eAXLxNU2t1FaB	1020	1428	1428	1616196240000	canonical
1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1407	1395	6	1	1887	jxJKdWfEeFV63GkSi7kMbMq2qjrXGA8UvfnYmgFarAhpgZ6BcG4	1023	1431	1431	1616196780000	canonical
1918	3NKQctcY6X2swtLxBVTxmNdUBzDkq7PHhHueAcn5q1E3CwRB4x6V	1917	3NKKbm1AwTAUkusfh7cxtavyMJqaJHu1VVcVc5XqowjxcxpRkJqd	1670	916	6	1	1885	jxowqakJnKCq9UEEHF9cy9PJ69RxBdEUJ9meRpd3ATyYRHx91FM	1023	1431	1431	1616196780000	orphaned
1930	3NKfM79W2BYYbuxpXP6ESqTZ4r6NByFZrC9VZkG1vywXc48LCT3H	1927	3NLFpnBaGAEo7ES9mwhBQ3nSsDxdfRybE9KRGvUXuBjyxHhyiopX	1631	794	6	1	1897	jxikBYHfr1p97A3c5GkJyJvRqm1yy7ekD8qVfWJBUTZAKgmfQyy	1026	1436	1436	1616197680000	canonical
1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1501	1114	6	1	1903	jxrDFHjxHgWTBicKSkeiqj1N3scJ9xHPWFdZ2FDRXpQQaV7MH2B	1029	1440	1440	1616198400000	canonical
1937	3NKHqw5CFcoWfb97WhucokTFbQtmkSq7xGxf2oBR2DBwYF1ZimJS	1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1407	1395	6	1	1904	jxEcZ5an7wVNEAXV5KQHFyjjAyekczdE7rrxTyhmMqRNFWqttwu	1029	1440	1440	1616198400000	orphaned
1938	3NL4MGDVq8bULp4t9DbKDg3FkkKWcTpUR2zcVBx7wHxw6Pehi1XV	1934	3NKCCpPMFXXWtpgP28kWX1ycTyvYvMBmhVwMU7zJMAHfAqBgW2TB	1547	1378	6	1	1905	jwM5iSxctHqbPMMXdWYWLSpeFV93JApKsAnYdufdcqjD3QgWcFA	1029	1440	1440	1616198400000	orphaned
1939	3NKbSLGhAFLj89QJw4RMsh7VA2Rea7XX9BtBLVqapC3vZj5XCjFA	1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1588	1026	6	1	1906	jxbBTfZCQeFt2aeFimdLM3wPncKZ7Ducyb8uyAzMW5Ub9LE35YK	1030	1441	1441	1616198580000	canonical
1940	3NKbd33uLNjzU3mR5cq6JwfnfpWqYDqHoWp28AUkFDYq7Bks9yd1	1936	3NLK4GkaQAFCq2nwxS1qEmSYFcgCaJfbF5A8DJAzLHdgFLkwZxDy	1600	1372	6	1	1907	jwaMQ3SoppEkHPtq86rE9Zgs6TLvWoETEz4aKqozfn9K3QnJLgb	1030	1441	1441	1616198580000	orphaned
1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1939	3NKbSLGhAFLj89QJw4RMsh7VA2Rea7XX9BtBLVqapC3vZj5XCjFA	1553	776	6	1	1909	jwG9AvEn9X9DeV6752jsiezofyQ9CgtHRy7EXNgd5uCjdwiAgoT	1031	1443	1443	1616198940000	canonical
1943	3NKk6WFjohXiVRjnayQcumsDEvXsa3BA4KRvjCbbHb42vhBo428k	1939	3NKbSLGhAFLj89QJw4RMsh7VA2Rea7XX9BtBLVqapC3vZj5XCjFA	1587	1111	6	1	1910	jwzSV8jsoNgndZ5KNrNQUiFeQHM2BVxMtwAocLzrDj61PTQFLUd	1031	1443	1443	1616198940000	orphaned
1944	3NLsUV129StmT7pCaBy23ha6CkEBYyWfq8U9bvZtBURNuJZSA9Vq	1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1522	1322	6	1	1911	jxLGyGpqwxQHkpUPuQdYBFuLRBzuu7hwMKisKeYoMAS12HstoHB	1032	1444	1444	1616199120000	orphaned
7925	3NLtNYA7WF2LmYu5Smu99LsAoFJtZRSp55GqjCT4Rk2MC86Xryg3	7923	3NLC2P47mV5QCRZCMFqhQo1xXsGFVXDZFEAZYGa68ZxUwEr1sPYs	1440	1011	92	1	6301	jxCqzBrbkr2RzoAZT7hb2W4dw6EynCnTss8QnFnYAc81Re8ZQGQ	4108	5794	5794	1616982120000	orphaned
1946	3NKK87UKgAtTUJYCM7hZ7e373oCtMSv6786L63QSux2YjPvSyyEz	1873	3NKWDVQ2Ag3PLyKNxfLW7TZbYzhxSKncApuoZjt5jgsJVRNt3H7K	1522	1322	6	1	1913	jxP5SAxJwbrMiyJZiy9YixHHayyiPqC25wwSht7aXAxDLUZr5iQ	998	1444	1444	1616199120000	orphaned
1947	3NKkB9goizbGafdsWXWzDFM3mrK52PZkfdRyf6zqZLLZfEXyDsVx	1942	3NKL6x1zo69j3URH5dUDaZtYfUwUN44QLm6KfPUNBW5RdXcbmv11	1590	1174	6	1	1914	jxZQdGEzZERCV49hSk83WbcKeS36sMtRjgV35LaRn2X18tLK71J	1032	1444	1444	1616199120000	canonical
1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1947	3NKkB9goizbGafdsWXWzDFM3mrK52PZkfdRyf6zqZLLZfEXyDsVx	1421	508	6	1	1915	jwLrXKBoRVfmre7kwGQmWcub1X1eL2G6E9zxdHM3jR67dT1Csc3	1033	1446	1446	1616199480000	canonical
1950	3NLUzQnqPMGyymobZZ4UUq4JAn3R83YqwArLMi5HuRtByhXK4Qnj	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	1406	1393	6	1	1917	jwtqweE3zYxhBdbKFB9xdtbhVd455vkpztaNyrNGgBkmv3ck92d	1034	1447	1447	1616199660000	orphaned
1954	3NLqkystfrDA3VQkYJGn4R2WWM3kKm7ae236ymmrfgYZW4aGydAh	1949	3NK3vnxcwtV8yrZ7hTsdRpHxdaMGetmiAjD6qX5CLJdedP3wXYem	633	1258	7	1	1920	jx7gXmLvDv1oRcDqE5z81iE9bDbuGZ3xU6B8KebmFEBNdPXSjGJ	1035	1448	1448	1616199840000	canonical
1953	3NLeATDzw16JEezG89MqepK4FJkLscfeSpg133tk6AnJxqJ25hSH	1949	3NK3vnxcwtV8yrZ7hTsdRpHxdaMGetmiAjD6qX5CLJdedP3wXYem	633	1258	7	1	1920	jx7gXmLvDv1oRcDqE5z81iE9bDbuGZ3xU6B8KebmFEBNdPXSjGJ	1035	1448	1448	1616199840000	orphaned
1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1954	3NLqkystfrDA3VQkYJGn4R2WWM3kKm7ae236ymmrfgYZW4aGydAh	1476	1125	7	1	1922	jwSqTX3oaDQVjYCpQdLUBZiwh5zwM8DFmrjv6UwZ3JVV6hg4DKk	1036	1450	1450	1616200200000	canonical
1958	3NLgf15cfwjKBYWyf9Zuq5dXc1KNPpsS5GwUf2f47Dq31JkFrhDM	1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1477	1104	7	1	1924	jxsctt1TwVfqnPLBz8EBmeYQDK5Pcv5bN6SZW3qgK5tNPtkifWx	1037	1451	1451	1616200380000	orphaned
1962	3NLe7FDKonX42JfMGKDQo3fupCcQLDTDxiAho4ShHHfcTJj6akzv	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1490	1274	7	1	1928	jxtJeBjQqAoTTN8ywvcyUnEzsQZT5WRGjcMbY2HZ4UcFaB2fdh2	1039	1454	1454	1616200920000	orphaned
1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	1967	3NKUQbZyLMcATJ51KoCV9WPP2esmreomQ3kE1UDpYhukafvM52UH	1457	1265	7	1	1937	jx594NNcGxk2q1otMPQiUh6LQQAsH5oo4X8WAko2MZHm7XfAV6s	1042	1463	1463	1616202540000	canonical
1973	3NKBcBSGhAAjs5Ss8RaeGC69mxMiGy3jfnr2Ckarcx2R65nBJYjd	1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	1405	855	7	1	1939	jx6skCo42BEpbcsPn4qZwFCfXN5gpKnh7S5AZ6xdWzt29rvJmEk	1043	1464	1464	1616202720000	orphaned
1977	3NK9kwioVHGuR96Z9MCkXdRE1z3p7CZiHC99CpkWyzDasfPKVH1o	1976	3NKe9rkmNo322eoFGdouq584XBFBWzvvd3kCor2bAK7p1vK9jdsw	1546	1093	7	1	1943	jxmjqFfh89DURfvwhndHro5P4nJXDm3stSVMuKAwonS6uL3w9UN	1045	1466	1466	1616203080000	orphaned
1982	3NKM8NNQia8TzbvWoxCfFEG62NVLQ9oyGG5Hmquo3y6ZL489Hcdd	1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1560	925	7	1	1948	jxFvQrNJZVtPRH1drYaLUkTnB8NJhHy22te49x88FsbFkFA9zPF	1047	1470	1470	1616203800000	canonical
1980	3NLZALUSEcqTsKNqPGXxCvmtjXs1Ryyy1Y2V5cjzWdxHGu6y1ADb	1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1402	906	7	1	1946	jwe58EXHwz3BZzZbimLk5Qa5qED67kmGWPAbLkYFh1DcJ7jSoh9	1047	1470	1470	1616203800000	orphaned
1983	3NK8w5a8dKKUk6Z2nvMmSsXT7K54m68551pRjbxe7V6TgkEfnRFD	1982	3NKM8NNQia8TzbvWoxCfFEG62NVLQ9oyGG5Hmquo3y6ZL489Hcdd	1406	1393	7	1	1949	jxp5cSnBCDcVoyM6iCMak8hBv66xKpjYZivCjdyYbLqJwtpY912	1048	1471	1471	1616203980000	canonical
1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1985	3NKy3YcXPY1cUeHe5aQifLPYK6iWTPye7nsaGNhhxrAuDsHPVaA9	1668	1370	7	1	1952	jwQhrryzjidoPerhACeCmYh6CYkuf2VqN1Y2aaw7gEmpwaG9Xmv	1050	1474	1474	1616204520000	canonical
1991	3NKRwhXM8uZ27qbtTYdbZ7M7YboHxdp72YigaBVHiADiKYknCQGY	1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	684	1226	7	1	1957	jw8Da1uRv4NyPfyfJdExZM7U1rAUMigT9VeY6eF9wij8dGqav44	1052	1476	1476	1616204880000	canonical
1993	3NKJKjs2atKpDAiWkGWREt2PR8Ee7P6ByfsTacSWCnqso5Z9xYFd	1991	3NKRwhXM8uZ27qbtTYdbZ7M7YboHxdp72YigaBVHiADiKYknCQGY	1407	1395	7	1	1959	jwoADzPUyAm8cJPzQrpDzt1PqZTmPXt2FA5WAM1pkDmqUeC8sox	1053	1477	1477	1616205060000	canonical
1995	3NKbYZRBuNomuSgqCr5ZniLqmvc6K8t2AQxzUBqq5SJhtfF6A1d8	1993	3NKJKjs2atKpDAiWkGWREt2PR8Ee7P6ByfsTacSWCnqso5Z9xYFd	1471	1386	7	1	1961	jwidwtoP9eS1yEmyzcfirDU8WMypokmdSGNmMtyLnkzUdGw7tq6	1054	1478	1478	1616205240000	canonical
1996	3NKkrhoNmBZfsMKRcDZXRUYARGaLY17iSQ3RzaG6uEgbiK32nK1h	1995	3NKbYZRBuNomuSgqCr5ZniLqmvc6K8t2AQxzUBqq5SJhtfF6A1d8	152	964	7	1	1962	jx26YbjX9MVhD33EkYRzrhaTT7Ue4zNWfkK7tg7Q2UbmjkJ8jvs	1055	1480	1480	1616205600000	canonical
1999	3NKmZktyS4E2nv8u8zV7USie8DSPih1WpsHQb5SkwyWeFHqzoHLB	1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	311	1307	7	1	1965	jxFBj26AJ8UgdnpP8N3T8LELAZ1PTCEjNhqsMZcobhFyW8SpU3D	1057	1482	1482	1616205960000	canonical
2001	3NLHPnWXQHtqeqrxATaSw67eSxfkcUVP1QpVwuJGE1uZ89uKNtsV	1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	1581	778	7	1	1967	jxNRurMjcvFgaK9EWEmkBMyQDHtNusj57FqSdkZqi78x54UZXVY	1057	1482	1482	1616205960000	orphaned
2005	3NKKyb8mRhFEjBwBG3opHYtdeXmZrqFYCsQTpv3x2YY1y7Fpo12o	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1546	1339	7	1	1971	jwkJTWKZpcfg8tf3Cr5BbyBAyFJxAoThy8Kd9hJ3jEsrBa3Q6JX	1059	1485	1485	1616206500000	canonical
2007	3NLQR75fjpn4jmNdhSYUG1NejLpwuiirRqy6ZpFWHWcEzBxqeepz	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1405	867	7	1	1973	jwptU2tq3g3WyJowUSjkgducnBKu9Ep64nJfZwn81s7eqBFiPjp	1059	1485	1485	1616206500000	orphaned
2010	3NKmG56s1sSLHp9Wjhfx78mHdfb6TYxrphbiXYr5X53gFqVoN3Fh	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1596	1237	7	1	1976	jx4QoH6s3HhEyDucJF3kAeCLzFhjiRePdFHGfC4wBB9iArsiGsR	1062	1490	1490	1616207400000	canonical
2014	3NKSJ2E86GiFf4JB38MrrhbB7eG5bCVV3fPYDiavyLMLhLJCr4yX	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1643	1173	7	1	1980	jwxgYZ8hn4PyZdRZSgvkNzZLj6BcMUWEBEfRVSuTDvuq7wg9nYP	1062	1490	1490	1616207400000	orphaned
2016	3NKj4UhwptDagfED4RTSFNjjYPJ59H7BswyFdbkC6uftL98ck9RQ	2010	3NKmG56s1sSLHp9Wjhfx78mHdfb6TYxrphbiXYr5X53gFqVoN3Fh	1407	1395	7	1	1982	jxtY4cS4yVYrcg8NWpafr8hf2CNKSry6XpycuW3ArY1344ksy43	1063	1493	1493	1616207940000	orphaned
2022	3NKK6a3uwTC5Pg31EfmptqA8Xsv7A9fsNTDyYk4QMYP6WMoahnfL	2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	1405	873	7	1	1988	jx2sTv1BBy8Yc5FgusqWv96GtXgQ8GURiKN8ogULkHsZ5w7LoCM	1066	1497	1497	1616208660000	orphaned
2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	2028	3NL7cmWfP2fMrdumLS2fb48Md7yeJirHhpoxsDkuLSJ1JT4TvS3h	1637	816	7	1	1996	jw9KKje3F68WjK14P5uB3WNNsbr7xVctPN8GdydsuJ9wL815GSa	1071	1504	1504	1616209920000	canonical
7949	3NKyenyUpePwDJrTfjL6txSnSN1GhfqUKFFQsgApe4rCkn6p2wA9	7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	1516	928	92	1	6301	jxc3nLBLFV87Bs69ESHG9QV2VQorm5aXapdCLc1VyoAehqTk3rN	4118	5805	5805	1616984100000	orphaned
2045	3NKxx4gJBq4MBDbpp1YDN95UDmXX3frJoiKoQiDDqCQLkj6f1wwW	1940	3NKbd33uLNjzU3mR5cq6JwfnfpWqYDqHoWp28AUkFDYq7Bks9yd1	1623	830	6	1	2008	jy24a53gdnXkUMio6XdbgHcVw4Abwmmezxp68B4bBGADdxwKpE4	1031	1522	1522	1616213160000	orphaned
1957	3NKnDkBN1ngJrc99hP7vSx3r3zmNiSMkEPP14NXiaugbYBKqCKKp	1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1406	1393	7	1	1923	jxHjEpvT5CFdgtmZJDrSB6RXonpfCNmucF64moorjdULaEFp1oJ	1037	1451	1451	1616200380000	canonical
1959	3NKeXLRVcgATKUtSP1BijSpjd6KjqCW2GizaFVJjTkEt8Rdrzfe5	1956	3NK6vn133oJAAwrdJmovzrcychCcAmMSzR4CFVgZnmqoUevdyjgV	1581	777	7	1	1925	jxre8f5khyhRbSLVZrGEDVAQYmLx4SHk7b1iDtFtvVrrtmUR3bL	1037	1451	1451	1616200380000	orphaned
1960	3NLeWQAkKKoMvckgNnaKMb24Pk4cPQk8LNmYj55RTXKDSqKj3Yh8	1957	3NKnDkBN1ngJrc99hP7vSx3r3zmNiSMkEPP14NXiaugbYBKqCKKp	1406	1393	7	1	1926	jxWYnG8KMamuby6JCaxX1Nq3KdWnCNaxo83oX2SM9agjykRwLjB	1038	1453	1453	1616200740000	orphaned
1965	3NKvKsYMjVrQyEbcrDwbKWiVSk68FWzGm3uQcZKkR15NfoLAUN4p	1961	3NK8mUzKZvkfRHWRXy7r9tr5X7pcXircKN9PAqktZJDTUbFTp4ub	1581	778	7	1	1931	jwb4hTZXyg6UWQbDktPXLHqUNQD4dHn2sKugNz5aiBbiQ9kjRyQ	1039	1454	1454	1616200920000	orphaned
1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1964	3NKbU6kYjmBzP3h3Kz74Hw9jUZMNJx6xm7QG3bthAxLAxTKRwn8m	470	1309	7	1	1932	jxEKBva7ebEo4D67NjvmUsrivs1UQbuQb4geNdRwVmbJQsnFn2w	1040	1460	1460	1616202000000	canonical
1968	3NKcL52rqD3PEmjvRF9icu17MiYuDjX3LP5VwJMyZs6zccAMcNBg	1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1402	870	7	1	1934	jx8xbeEZ5NK1atbHPPQdZRsiNFj6anoRw4YMSuEQ1i8EX4h6pN1	1041	1462	1462	1616202360000	orphaned
1972	3NLmh1YLQqMfTPk4SFN2E3zKL4wfbe2Py83wMf7YYoSzZjf1azor	1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	1406	1393	7	1	1938	jwEH2mvWG2Lgw5E3d8ev3bxb8VCXPY5H5fegF7s8Bu1i3RrAWsV	1043	1464	1464	1616202720000	canonical
1981	3NKqFMVoFvR4mW41wocamggZDZUQ1Fxfgfb221atprWkVYvw6U5h	1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1407	1395	7	1	1947	jxpQ6LofgejUMuCjb7fzSMGY9dHeRLbh2bF3aHmptefAc5bcY2k	1047	1470	1470	1616203800000	orphaned
1984	3NKzjE4kz4WSNqcE53YJGq55rrNotvfSqQG7YkwyktUDxXHS4ihn	1983	3NK8w5a8dKKUk6Z2nvMmSsXT7K54m68551pRjbxe7V6TgkEfnRFD	1637	816	7	1	1950	jxSmR1sJN3JfMUbe34UVDVPD9y47XLUZiKQi8GqBS3Pv2LtcFJs	1049	1473	1473	1616204340000	orphaned
1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1406	1393	7	1	1954	jwgDXHeHjnCGQ3ENmNbmMpugF1qMx1f126Q3hCvw773tFEmta12	1051	1475	1475	1616204700000	canonical
1990	3NKPZUPWrjqWLFeHjEorTdwbkZsUjdUh2UjrYBnvvAxT5d2xS2bY	1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	1579	1389	7	1	1956	jxtChqs7zSAzrAtH3XVRVCJspqWw6YXuDtundvQ5u6PQHNKwX1g	1052	1476	1476	1616204880000	orphaned
1994	3NKiRmyJS1bULqSENvhss2CVnsnjRi5QCCj6vU9rwvWCRTmxwMCf	1993	3NKJKjs2atKpDAiWkGWREt2PR8Ee7P6ByfsTacSWCnqso5Z9xYFd	1657	1344	7	1	1960	jxgDp9xAgjXQ6EVk86Pf4eHv8YaJSoHVa2bU3Pe8vDXtw315GU9	1054	1478	1478	1616205240000	orphaned
1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	1996	3NKkrhoNmBZfsMKRcDZXRUYARGaLY17iSQ3RzaG6uEgbiK32nK1h	1406	1393	7	1	1964	jxt1fFWdA2LCXwVrk2qaUKu4vEWH4Prytg2YEHEMutj7RRGT32o	1056	1481	1481	1616205780000	canonical
2004	3NK9zzUFmK5KcAbd3DoGXH1affJshFBQZLUsrck43EQaB8WpktM6	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1588	1392	7	1	1970	jwx6XqCXmtaEDtF3sKcEhs2PPnGXDn7wq2uJS9ofngpc1trNKMx	1059	1485	1485	1616206500000	orphaned
2008	3NLvVA8QuFS84E18afR313uxXGp5vMTjZxWyQ2Luh7ZCpD5WeGbY	2005	3NKKyb8mRhFEjBwBG3opHYtdeXmZrqFYCsQTpv3x2YY1y7Fpo12o	1407	1395	7	1	1974	jxCA1s7V6WAMZXGTGb3DkFbE11yds4N1DzCZe4a59w2aXKrvQAR	1060	1488	1488	1616207040000	canonical
2012	3NLgtiJf8tJvfLUw7HqzNA9L1mQXVQrKuQkdE4NmEM4xgjZg5zBr	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1536	1067	7	1	1978	jy2CtAmqLfRvHhvveCTjGYBcbU4kHprLcP3qnwC9oMmxVS8PRE5	1062	1490	1490	1616207400000	orphaned
2015	3NKEo2Aqh5TVPN5wyJo2KKtHxeafhPQzfKXLHgDKTMiuUCGsY9jU	2010	3NKmG56s1sSLHp9Wjhfx78mHdfb6TYxrphbiXYr5X53gFqVoN3Fh	1589	1286	7	1	1981	jwHJWk18G46cvgAzxhVL2g3tcYuNYVVtAqw3amGS92vuMoNJzCf	1063	1493	1493	1616207940000	canonical
2018	3NL9ahKSYmFVyG2uGLxQ93po7DNEeeiEMBGQdXBCovPdPymaDvLj	2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	1588	1146	7	1	1984	jxob8DDfYcJUjTDjD2GL1FWjBrKWdAzzzSLjR7skyxGnYfAwGhy	1065	1495	1495	1616208300000	orphaned
2021	3NK8byEqCv6TJfMzioSEXNJg28YRr7ghvgEbcmW8vib6Twv7VMsq	2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	1654	974	7	1	1987	jxs84bTf4UNnEhiGi19dHUAToaCRnHEMyhmzFBTXTASR4RtWoCn	1066	1497	1497	1616208660000	orphaned
2026	3NL6m6CRSn6d1CTG5srtACbZtxnRtGijck2i4KjJGXTW4ko2qJbk	2024	3NKNwFKrKnkwK2hPSTKdiahVwT8SEbB9BRHdVu9GiKJ76wdFPbTH	1508	1021	7	1	1992	jxPQSZY8SyoS4PYK4FAv1Vthy2PuLoNdoCv6XoxCsChyuhtANCv	1068	1501	1501	1616209380000	orphaned
2034	3NLcHM2CY5UnBFcGAHGWnDgfPLRCgTGBMDpfwgtms93oFCfqb95i	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	311	941	7	1	1998	jxnMvqtM9DCyf57s6J1ZbqYW2H6PdDjrozubyHnFrZ3JsjzpYNS	1072	1506	1506	1616210280000	canonical
2031	3NK5uXBsjuFNmUXbzRnwyBVzi8pndQir7kdFiHkGctWwwfX8FwMc	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	1631	794	8	1	1997	jxTaGVpYAAUnyw8LPfpBpwN5DSFdDCdqng9TdmAzbvtJwuD2B6H	1072	1505	1505	1616210100000	orphaned
2035	3NKmpKhta7gq7DBT8pCwoohRPkwQbvutFJ9Mzd18fmfewyjJcdgp	2034	3NLcHM2CY5UnBFcGAHGWnDgfPLRCgTGBMDpfwgtms93oFCfqb95i	1637	816	7	1	1999	jxLmMVz9kGEiVw1AVHAnuXnNfMzegPcpwjSx7EXzxsFTUdxwhCY	1073	1507	1507	1616210460000	canonical
2036	3NKzBBsJcTvTHBiQbDdM33zocwzqvARHFeLSiKNFQAh3bXruvnqM	2035	3NKmpKhta7gq7DBT8pCwoohRPkwQbvutFJ9Mzd18fmfewyjJcdgp	1445	1290	8	1	2000	jxf1Ff3qMGhcNDK1gYG5WBbZ4fpLiNWaPbt4yRsgHVBvw3j9HFh	1074	1509	1509	1616210820000	orphaned
2038	3NLwx53dXLJYJYRWnEf6944ggz4P9YXC92fJYmuJQrNGbwRHWm2c	2037	3NKSsRtAE2S2hZNMN7UtkLWsUdQQcUE4LbcNQwPXgLyXdEzKSGgu	1407	1395	7	1	2001	jwPAcRH8r2pRmDu4CbWbaLnUFC4Udvt7ASSsmumQ1t2b5i3TJST	1075	1511	1511	1616211180000	canonical
2041	3NKSPG5QD4L22aX7ApnWRNnX8qpCgoPUeBS7prA7hQgvWNwvkeGD	2039	3NLncCzwYwDtw6VtsetULmRLS98QqttXMVH3E7qcjUYEDbxUkQfz	1637	816	8	1	2004	jxgRh9zzRvbox4iqtQwFLD22DwZeFs6N81H9Na336TTQEw4QBWT	1077	1514	1514	1616211720000	orphaned
2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	2046	3NLutJ4baPD9qGB4wjSkxxFPhxbpwetSfGuBUEqbaMSWYgSa7a5D	1652	949	8	1	2010	jxDw4ELqULHSZRjF97Xo6BXbpzGjzxcViMbGEpR98DGNmLVvPy8	1081	1523	1523	1616213340000	canonical
2052	3NLX1fNtCwGKTw364VAS7fa6H4qyT5utGv1mAvNScgWArKjxWCJQ	2050	3NKMZKsWhChR8rCJyFCTpkrApCaqipPjZrQSkdxt37Ht6xnY17eL	1490	1148	8	1	2015	jxneciX54fA1L59hAr7mLhJjLqkNMTrsqXJdwHue8wMwmYxrqQW	1084	1527	1527	1616214060000	orphaned
7969	3NKJkLjkwZwRYEz4QUaUuuSgbF6wBuSoUoZKebGjkKiNPSFv2RFd	7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	1559	1353	93	1	6301	jwpsGwRrhMp7GeBrPJ59xYyQfKALb5qptRvSxakiRvT9LsbrAmc	4129	5823	5823	1616987340000	orphaned
1969	3NLPXFaMtjxz6WuzYjZN4py8RnYtjL4LUoeNBqsjsX9UCQmRv4Yu	1966	3NK7sJrgBEV7NMCqsrvDP8d3ELfYAP2QU3ZwaHzpNCKmC34TX7n1	1405	867	7	1	1935	jwp7H6fXxewW36zsQ7bQCpyADpyvGYr6aC1Bo56W7geeCrhBA3M	1041	1462	1462	1616202360000	orphaned
1970	3NKKAb3VRwjSWGNa32NPgUxgKeTgnUQcKEceYEUx1UrrDunsaGxJ	1967	3NKUQbZyLMcATJ51KoCV9WPP2esmreomQ3kE1UDpYhukafvM52UH	1402	906	7	1	1936	jwZXeohFhZZmKaYnZQgSBXjXM5unMRqTbSKGJGzign94vdtz1bx	1042	1463	1463	1616202540000	orphaned
1974	3NKMNAF8UE3ehUkkq6Lnm3Z9VwVRauysVEPBfBb84Zbtn6tpVYf3	1971	3NKuTm8q7875XcyEYTzhVX2nESUMvXtn4Kia8p37JVWiHtjYCqd1	532	937	7	1	1940	jwdVttHe1rtM8bcZE5dz9JCbRXa3CQq5ce39JKaeLvG6a31n5KJ	1043	1464	1464	1616202720000	orphaned
1976	3NKe9rkmNo322eoFGdouq584XBFBWzvvd3kCor2bAK7p1vK9jdsw	1972	3NLmh1YLQqMfTPk4SFN2E3zKL4wfbe2Py83wMf7YYoSzZjf1azor	596	1060	7	1	1942	jwD9oBtyqM33n6RHGqWRpgiU982oEqWXTyKY7ygYykkWyg7d6gK	1044	1465	1465	1616202900000	canonical
1979	3NLf8CuYY6nzmDJqTGCZJNPzRiPiyn1kjiDENqXJ8HmMSqrDCby3	1978	3NLjy5Sz6ZknRek9GdmY7cuTZjaEfJ5D7UScDmGQsumeyFPJaE9V	1503	911	7	1	1945	jx2gdrqHYkNayN5UzQdFf6nKrKop6vqYUM9nfzH1HQauGwjShcJ	1046	1469	1469	1616203620000	canonical
1985	3NKy3YcXPY1cUeHe5aQifLPYK6iWTPye7nsaGNhhxrAuDsHPVaA9	1983	3NK8w5a8dKKUk6Z2nvMmSsXT7K54m68551pRjbxe7V6TgkEfnRFD	641	1210	7	1	1951	jxYxg1iB1fquYVRJBhbFQ18Txr45p8ibNh6u5eJL7eGuLqgkfyA	1049	1473	1473	1616204340000	canonical
1987	3NLstNA8fFtCHY1Vd7YSmk6arTaFfkWwqHSFvqQah1PtmaZ9EUt9	1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1501	1360	7	1	1953	jxbsRU2p3iTiDcEwC8mzSFqK1WN2FS3hMQZUNWk86dGpcZHfeLW	1051	1475	1475	1616204700000	orphaned
1992	3NKB5TRjogG944xt8YbrggLBVmXangWcEp4LMu1Ei4uLeZspJDV5	1988	3NKjTXpt9G9MXmX6MPbUVRRfr7XQ2j5UsF8QtqY9opVSPRo3iLL5	1406	1393	7	1	1958	jxwycSU8LibXRvdHPsxYuVdV4NYiBDC1nu5nZAi9JSobbzNk6RT	1052	1476	1476	1616204880000	orphaned
1997	3NLkiP9N9xKnV3FPxpZZ4nx9jdJoMUDnPt96n6zQaAKmqzRJ4eWm	1995	3NKbYZRBuNomuSgqCr5ZniLqmvc6K8t2AQxzUBqq5SJhtfF6A1d8	1476	1371	7	1	1963	jx6n1pxvKBLuxv2ZLbstDZbVBdnfxKbfjTVAdAkQ8ZNi2oVVUTm	1055	1480	1480	1616205600000	orphaned
2000	3NKCyRYJGc34VMedXej9qqRm44no41v21DnjGgoqEquRbebcCBf6	1998	3NKWfqFzEJZKEfbSGDuYcPUEh2as5U9rH2vMM5xp8E2mRrj6QAD2	532	1177	7	1	1966	jwokddcbppXhQAbUJJRH83XPmRuVXiPCbdnMgAjnZWkp79sU5D7	1057	1482	1482	1616205960000	orphaned
2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1999	3NKmZktyS4E2nv8u8zV7USie8DSPih1WpsHQb5SkwyWeFHqzoHLB	1407	1395	7	1	1969	jwnD5HrQp8NzHtycfLZj6aV835SGCVnQrvH3HeY8z9qfcDBaZz9	1058	1483	1483	1616206140000	canonical
2006	3NLRhGRh5u8Xde3E9n3oQbS5LZQyqPrA5uT9gK2BoZPGnuEUPVev	2003	3NL5jq23NiZYN7AnJBeVnC4ZdsWZkkhakKoDGruYzChk1Pc3FvoK	1406	1393	7	1	1972	jwkBTSn4e3Lc51eg9ix8LKFd4qN1SqFSsbzuJxh8n63LLyksw9y	1059	1485	1485	1616206500000	orphaned
2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	2008	3NLvVA8QuFS84E18afR313uxXGp5vMTjZxWyQ2Luh7ZCpD5WeGbY	162	162	7	1	1975	jxgHe9A83GHgwbwRgh45TZ1tzDg75kfrpn5xKHVp1ghewJrX7yB	1061	1489	1489	1616207220000	canonical
2013	3NKKipw6psS19KXaaGLjJ8SJEkzYVeftpsz41hafYtujdsFDUXb2	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	1518	788	7	1	1979	jwVrixrvfursPKaBjkJRJyhREqyXh2cHmx2YM3znc1jP2M417EX	1062	1490	1490	1616207400000	orphaned
2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	2015	3NKEo2Aqh5TVPN5wyJo2KKtHxeafhPQzfKXLHgDKTMiuUCGsY9jU	1460	475	7	1	1983	jxK1Bukk5aoZSHbHkNp1dXxVR8cvN5ZwWeFf7pztwTSwXBztf3u	1064	1494	1494	1616208120000	canonical
2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	1624	1334	7	1	1986	jxjsuqivwFM1FVTTyR2yuyibvNwP8dkggN2oH3fhscnE8YWemVw	1065	1495	1495	1616208300000	canonical
2023	3NLXmsy9XfHrDvSvHvjRbmhThd7KFywPdSGwymPEwbiMxMSeP1oa	2020	3NKiBjMj3Nhcq8wyCabAfEw6Q1yanhjZgwaQ81m6AkvhBESh79RP	1549	1362	7	1	1989	jxFiTENbrume1sxYhQbW8QdXaxoHpqbpXPhQGSfXmE2rhaiBWgH	1066	1497	1497	1616208660000	canonical
2024	3NKNwFKrKnkwK2hPSTKdiahVwT8SEbB9BRHdVu9GiKJ76wdFPbTH	2023	3NLXmsy9XfHrDvSvHvjRbmhThd7KFywPdSGwymPEwbiMxMSeP1oa	1483	611	7	1	1990	jxRCRKSb4cEWFvmaZpiB6Q7w1xEEKdWfWtR3wDroeQs9Kfu8zBK	1067	1499	1499	1616209020000	canonical
2025	3NL4E9erXAYRVrLhFWRr5RQ5WSJrND5A988eG8szLKxgb4APea1k	2024	3NKNwFKrKnkwK2hPSTKdiahVwT8SEbB9BRHdVu9GiKJ76wdFPbTH	1406	1393	7	1	1991	jwJkLLzoEYsvsM8g9m3E55fJzVSJcWMtaU6WmeqHPT6B4qxDUm4	1068	1501	1501	1616209380000	canonical
2027	3NKYFu41ofNb7wMp6fUnE3beQM8BABRKMZaj2u9k5FtV1rjVgPk1	2025	3NL4E9erXAYRVrLhFWRr5RQ5WSJrND5A988eG8szLKxgb4APea1k	1581	778	7	1	1993	jxPnRkNzW2gyPvoZfnRZCT9skV8VzepgppWcsvEZhcoSctDebhk	1069	1502	1502	1616209560000	canonical
2028	3NL7cmWfP2fMrdumLS2fb48Md7yeJirHhpoxsDkuLSJ1JT4TvS3h	2027	3NKYFu41ofNb7wMp6fUnE3beQM8BABRKMZaj2u9k5FtV1rjVgPk1	1406	1393	7	1	1994	jwkzvqVj2WCVLfRAd7A3Pmq7d1tUAYGwj4mLjkk99iy4jnWgPzR	1070	1503	1503	1616209740000	canonical
2029	3NLkdJALxLG6Wcicoyd57oEvuV8sjFe19LTj5HP3PEJcQKEEHaE9	2028	3NL7cmWfP2fMrdumLS2fb48Md7yeJirHhpoxsDkuLSJ1JT4TvS3h	1406	1393	8	1	1995	jwxPDeaKedVXGbo8XLLd6JTk6qvPSpJtnUjuB2CWsLvxy6hpswp	1071	1504	1504	1616209920000	orphaned
2033	3NKYjmARt2sGuBafaNDdcj3zohLuRxBHjfmAMRA9kR91YYNMPGj3	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	311	941	7	1	1998	jxAEuxJfA44g2ndYr1oQchkGoMbUE37VKt6ENF5kJRyi5BAfS2U	1072	1506	1506	1616210280000	orphaned
2037	3NKSsRtAE2S2hZNMN7UtkLWsUdQQcUE4LbcNQwPXgLyXdEzKSGgu	2035	3NKmpKhta7gq7DBT8pCwoohRPkwQbvutFJ9Mzd18fmfewyjJcdgp	1445	1290	7	1	2000	jxf1Ff3qMGhcNDK1gYG5WBbZ4fpLiNWaPbt4yRsgHVBvw3j9HFh	1074	1509	1509	1616210820000	canonical
2039	3NLncCzwYwDtw6VtsetULmRLS98QqttXMVH3E7qcjUYEDbxUkQfz	2038	3NLwx53dXLJYJYRWnEf6944ggz4P9YXC92fJYmuJQrNGbwRHWm2c	1451	1046	8	1	2002	jxPvq6by3b6VyeomrUznKo2KBZXaRzVUPfZFvHNJZKJGhQsoJE2	1076	1512	1512	1616211360000	canonical
2044	3NLevkU7Kzwve6CgwHRWzhjoS9KACjnBDE2CH6eGzFjyDrGqjMV4	2042	3NKhLbuxDCkcuhR3sq2aRVxEuun8d7FnGjJfgekakgmZUf3McA4Q	1631	794	8	1	2007	jxex7sGE2G2gAZeGtA1TvUoH7jZhX61bi6FX5VLi69ryjk3SZX4	1079	1516	1516	1616212080000	orphaned
2046	3NLutJ4baPD9qGB4wjSkxxFPhxbpwetSfGuBUEqbaMSWYgSa7a5D	2043	3NKcnRVxSzSKMu6AMywCFDAq5RuTvPFXvRuaRuCwRCKMtvjjFw3T	1506	1373	8	1	2009	jxxrHsc9iWkQRrG3zQuVjWUhkGSgm4kh1QrS869nNmcFHaF3Kq2	1080	1522	1522	1616213160000	canonical
2048	3NLp1CA7Tr5HdPnquVuK3BbnQbgWM4vyNfWrs7VqjbkUoQ78NUrb	2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	1406	1393	8	1	2011	jwjcnStff6BDbS6Yqd2Bj8ZToveHraxmYxucvcdzG2YMiGAXhpZ	1082	1524	1524	1616213520000	canonical
2049	3NKhiVrUx2Lc1Ken8yyUimziKDgwjooxTX81vR5D5HX674iGFcgh	2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	1646	1354	8	1	2012	jxbXLAmuSvyL4zGTNX581LshbyxLx9GmRoYraDcRVFYntqXtx2D	1082	1524	1524	1616213520000	orphaned
7980	3NK5FP6w1gJrhNtuMGCFLpwAAN96aRmRRA6XLjSEznawpCxvzsr3	7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	1407	1395	93	1	6301	jxuwQHC6K3Ev9kjpjeHmc3ni6QXKCtYggDqvXUaooyEfTpzKZe2	4136	5834	5834	1616989320000	orphaned
2042	3NKhLbuxDCkcuhR3sq2aRVxEuun8d7FnGjJfgekakgmZUf3McA4Q	2040	3NLZzwq7E6WAHYctgCgyNf18w1WKpPDkjXQTL6AbCXAM2xtiCAUT	1656	977	8	1	2005	jwXLt3uKZdkmBgXDtD6tw6AAQfRzM2hXVD6jCcMSsLZK6eEnAVH	1078	1515	1515	1616211900000	canonical
2043	3NKcnRVxSzSKMu6AMywCFDAq5RuTvPFXvRuaRuCwRCKMtvjjFw3T	2042	3NKhLbuxDCkcuhR3sq2aRVxEuun8d7FnGjJfgekakgmZUf3McA4Q	1536	1187	8	1	2006	jxRwK4qwBqmt2LX8j92C2mNVGZ1RSTtfpYmsVAXFsLnnFpSuS5C	1079	1516	1516	1616212080000	canonical
2051	3NLWdyYr6cQ2EobWkYEN3EdRqRhfd8AYpDqFAHAme4VAr2GCoS99	2050	3NKMZKsWhChR8rCJyFCTpkrApCaqipPjZrQSkdxt37Ht6xnY17eL	1407	1395	8	1	2014	jwkb85TpoN9QsV24BbhnKB65XNfpCv3FSGSgekUUs8xrcMnYaaD	1084	1527	1527	1616214060000	canonical
2053	3NKkTcFLzwFihSRq3wsuJwSmDecV8FvmCE7PDmNdXzNpi9DVpWaq	2051	3NLWdyYr6cQ2EobWkYEN3EdRqRhfd8AYpDqFAHAme4VAr2GCoS99	1402	852	8	1	2016	jxPiQZdJ6ytYNhTYsdZdKCAYKnkco3mEZFrrYDddg7X7WLbqXmR	1085	1528	1528	1616214240000	canonical
2054	3NL8qoKSM3ZA27XGnP87M2A3sW7nsjbtoGrYD4kpuFszdKGzLSeV	2051	3NLWdyYr6cQ2EobWkYEN3EdRqRhfd8AYpDqFAHAme4VAr2GCoS99	1477	1104	8	1	2017	jxraNdRwLu6Cs4a2WxSt5f474qdAKB2q4Li9sasTYngLWTwpPXH	1085	1528	1528	1616214240000	orphaned
2055	3NLM4tWXjPBWDE8pDDL9FwCUtunrvu7xaQvrpW6tBRr94v3jA1Vu	2053	3NKkTcFLzwFihSRq3wsuJwSmDecV8FvmCE7PDmNdXzNpi9DVpWaq	1406	1393	8	1	2018	jx1wwqjaeswEfP5J7MgLsyHACrfx8aCMeAKiFnujYpnSLvMGQMb	1086	1529	1529	1616214420000	canonical
2056	3NKHFHQHSHz4w756KxYAst8qxYTxLuaJDR5ixgpUmGZVMZcW5iju	2053	3NKkTcFLzwFihSRq3wsuJwSmDecV8FvmCE7PDmNdXzNpi9DVpWaq	393	393	8	1	2019	jwd9XnonbkpWqCG8ZBcVPsjAbeLv7SkSWE39WHASb4rDMRtNhiE	1086	1529	1529	1616214420000	orphaned
2059	3NKsNb4eeTJFSjsCcE79zbJJoTVpCsQ5hM3iwT5r2g1xzNDJnmPy	2055	3NLM4tWXjPBWDE8pDDL9FwCUtunrvu7xaQvrpW6tBRr94v3jA1Vu	633	1384	8	1	2022	jwXDHQwim4jZgJA1knMv1DwUVViZHpMDNhx254N1szjxhxfa4e1	1087	1530	1530	1616214600000	canonical
2060	3NKdHSkWQJHsWaLGzX7Kutp4usU7zwjnm3uPqspSShRVnkD4AgyR	2059	3NKsNb4eeTJFSjsCcE79zbJJoTVpCsQ5hM3iwT5r2g1xzNDJnmPy	1407	1395	8	1	2023	jwopTa6Eb32FzDZc9qoUSJuPeTn8FjEJjGxXmKkP94Z3Wrvsfk6	1088	1531	1531	1616214780000	canonical
2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	2060	3NKdHSkWQJHsWaLGzX7Kutp4usU7zwjnm3uPqspSShRVnkD4AgyR	1444	1381	8	1	2024	jy37cZvW7ne7GCMQTuEuSM1tkxdg1vZXjtzVY86wyQekkcAyt6S	1089	1532	1532	1616214960000	canonical
2063	3NLuqLnNHp2x9Mrxiiy6sJVPWqiAPT5sbw4oBbwGW1fyE1Db9W3x	2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	1608	1043	8	1	2026	jwWDQNX42vAostpoCeedo3j37QHC2pDpDxN6SjM4mSV4H11KtV7	1090	1533	1533	1616215140000	canonical
2064	3NLajkMagz1AsdScj96HTzmr3y61jukWDHhSBvzcdT9vAveWwmJk	2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	1406	1393	8	1	2027	jxuYRNGjDtg4kGCRyAmX55otJ4YjJ1VTK74UHwDDAn3hYz4tKc7	1090	1533	1533	1616215140000	orphaned
2062	3NLeWMofJUUdJA8ifntdNrQEjZ8f4Vgqv2PPgiNsYMKztuYv7WMm	2061	3NLVswZXW7LVDMjVJrUFwAp17LuQtskvGKYQbfRFLrraC8SavGen	1600	1006	8	1	2025	jxxBasdJjiVVx44UXQER4SVZM46DfjRcz1i1NgeoHVzCY6L1wAr	1090	1533	1533	1616215140000	orphaned
2065	3NLpZgHY1VBrA75pVCE4M1XoekZdbq2jk9LvKxk2xsrmqpo5VFJf	2063	3NLuqLnNHp2x9Mrxiiy6sJVPWqiAPT5sbw4oBbwGW1fyE1Db9W3x	1617	1288	8	1	2028	jwW4L23sEfkC1kdat3UVTJ7Mst1P9aJcxmTxqLjeHUoWg4cApQV	1091	1534	1534	1616215320000	canonical
2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	2065	3NLpZgHY1VBrA75pVCE4M1XoekZdbq2jk9LvKxk2xsrmqpo5VFJf	1406	1393	8	1	2030	jxVGYrYz6mVzq4x62xSj3ouyJfrwCQ88UNtNgJY4MLryXBpGpMj	1092	1535	1535	1616215500000	canonical
2066	3NLFwjFG77xTqyE1peHXKQoiBCtumY3SUGjyzpShYfUvT5smxXa5	2065	3NLpZgHY1VBrA75pVCE4M1XoekZdbq2jk9LvKxk2xsrmqpo5VFJf	1624	1334	8	1	2029	jwhegAk99uHKtLSVcAsDogvtv17RhtBfJJi1T6imsvirhAPZT4i	1092	1535	1535	1616215500000	orphaned
2068	3NKWFKv8Ksdw6pK3LFTi5kkxBZMJRvMpWwvThVLpLDFoJVXE8iSz	2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	1403	786	8	1	2031	jwQENWCaY6ADiTBLFwTN16H94dR142rWeXM32qT9tfJ1Bhx6toj	1093	1536	1536	1616215680000	canonical
2069	3NLkqFPhovG9yfkcUvdRSMB1YuZQPQKkkNjaKS8Kwt7JUKptY2gZ	2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	1407	1395	8	1	2032	jxnhhsjzcQcFgBZzHAQh2xAT9g156WMG8SLoKT2ETPa2cPJJf9g	1093	1536	1536	1616215680000	orphaned
2070	3NK3s1rbSBJpojiLKBRN2DYfrjnMHQm8nZ4Y6ZacijSEnJurd5fE	2067	3NKvF8obkKDxk3z2Q7qEKvMM9QMwDKb9oDWBhGRtkbUrshSPvkeu	1406	1393	8	1	2033	jwbtumH57cQiXxmT4zK5rLNsgkJqbnFedt64BpWEUhpYegB7soF	1093	1536	1536	1616215680000	orphaned
2071	3NLYFhUkw5RwKdASRS85i9Z2ErVFSWPCdeftWP6R79oe6b8aJRCG	2068	3NKWFKv8Ksdw6pK3LFTi5kkxBZMJRvMpWwvThVLpLDFoJVXE8iSz	1403	824	8	1	2034	jw6kt4eJA9GSBK7j9eok3a5JDLgm8RSDpz93ZPDMKVLkzx3RahL	1094	1537	1537	1616215860000	canonical
2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	2071	3NLYFhUkw5RwKdASRS85i9Z2ErVFSWPCdeftWP6R79oe6b8aJRCG	1403	786	8	1	2035	jxyU43zo5fuZGTpF24vJzKSHMxtfET71dUVLA1MtETupmGpYeqL	1095	1539	1539	1616216220000	canonical
2073	3NLqEoNyLpCTpKvbJ8V74kw9tu2iD2avE3yK325uQy8wzL7ixd94	2071	3NLYFhUkw5RwKdASRS85i9Z2ErVFSWPCdeftWP6R79oe6b8aJRCG	1637	816	8	1	2036	jxkghFJVyWH5NpUamWjiLj6sqNfPHarqAugqrTmkTZyKMzquwn5	1095	1539	1539	1616216220000	orphaned
2074	3NKPFiKbdgY27wCjwDVuWj8d35JDxiwDFw6s8SLmBNaMoZiZ67S6	2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	1402	808	8	1	2037	jy1xUibzQMBfY8uevUW7kD9uv2Z1SuPZ5xLdvZ9Z4179a34tLKB	1096	1540	1540	1616216400000	canonical
2075	3NL8DuAxm9z1FZ32y4QS1EnpvLtaxNqW4dzpn52Ea6133sD2LDx9	2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	1483	877	8	1	2038	jwWpgEf7J1FjoGSJewd1oKzGKZ7JNtFn6NeveWxhPwDYVfdKNPZ	1096	1540	1540	1616216400000	orphaned
2076	3NLrWmUbawT7KPB6zeTU7zbKZWZp3HJWnKnS5v2DHkDhrrHydzJR	2072	3NL5v7CoW1Sme12RmNFjosoc8CqnJbosm354CdM295Ny21AqgxaM	1529	950	8	1	2039	jwUWVxNncdCYYMKUnpm8x3YDr71SzNEz8RUTAZMaFgrobfEqiRR	1096	1540	1540	1616216400000	orphaned
2078	3NLsSVnMiKy2v4ZhBSqFkVistNVe1B652nUZHNmXh4HSEHVVPNtG	2074	3NKPFiKbdgY27wCjwDVuWj8d35JDxiwDFw6s8SLmBNaMoZiZ67S6	1581	778	8	1	2041	jxWqA9QT1ikQtvq4HGu5N8sJ3GKk45GcN8mU5Hegs5gMFyKNBvA	1097	1541	1541	1616216580000	canonical
2077	3NLsfcuV4wUbrpEk9bEMBm4FF33Z4oGhRLcGJ4PvcqTeWS36jXJv	2074	3NKPFiKbdgY27wCjwDVuWj8d35JDxiwDFw6s8SLmBNaMoZiZ67S6	1578	1170	8	1	2040	jwgzQJgXkLaQKnMk7ss8d9fJyuZVs3AGoaYimwzxgddrDkB3vSp	1097	1541	1541	1616216580000	orphaned
2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	2078	3NLsSVnMiKy2v4ZhBSqFkVistNVe1B652nUZHNmXh4HSEHVVPNtG	336	336	8	1	2043	jx1KuPX1eWV9B6SNFrCQ3fz1mc2cpig2nHxiNuGpN3X3Wb8r7KK	1098	1542	1542	1616216760000	canonical
2079	3NK91BxvWp5f2w6JrRAGKPwrLXt77oAuk5rgdh3ciDtAEv7eEqnr	2078	3NLsSVnMiKy2v4ZhBSqFkVistNVe1B652nUZHNmXh4HSEHVVPNtG	1654	1340	8	1	2042	jwfdMpEdz6Aw6xU8wwpZtLnRRBvy74gpwrsGQtdRLUESQXumt2D	1098	1542	1542	1616216760000	orphaned
7997	3NLcTzXrXzbwvh3uDW5zVdE7Bn7pZ8wZFs7eKeXRB5doRhjz7sb6	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1406	1393	93	1	6301	jxDaceohbbxSWo17UbnQowv7iFTTF34QJxa7ifEFwUBj5WNDFf5	4147	5853	5853	1616992740000	orphaned
8001	3NKCLxvSQUAJQd2UR8FRo4BVBaKzCf9mZfjjbGzJBH6zGYSdAVRF	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1523	1321	93	1	6301	jxHGSEsQWmXRHJzzyYPbWS4cwK1dXyaSar9rC7hsCup8ogGdqwG	4147	5853	5853	1616992740000	orphaned
2083	3NLxCAHQSdzTbFWWjNRP5MQRCWUfKwpZRNKTVt2TudYgbCfCDBno	2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	1646	1354	8	1	2046	jwWBdiCchdti71VHBfHdeFv9ykAVjA5c7Mv3NGFC2f15u9JKRMp	1099	1543	1543	1616216940000	canonical
2081	3NKpewZj2KevysMTrMZ3n6wGZoDh128YHxUnMZQcP22mBXsMxjgh	2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	1440	1377	8	1	2044	jwxQ14bX8E8oSk7X6i3LZr7dc4vs5mpAiteeFwcuU8oXYZB6FAo	1099	1543	1543	1616216940000	orphaned
2084	3NL2wxyjPDzTprp1yb1dPmKYW1NvhrNT3xi7uE1niQmhXTrZF1Hb	2083	3NLxCAHQSdzTbFWWjNRP5MQRCWUfKwpZRNKTVt2TudYgbCfCDBno	1403	782	8	1	2047	jx3ZKtPDuVGasi8GzzXvjY8Yg9kn2Z7HeTbZRvbGb9V1wDKKHCD	1100	1544	1544	1616217120000	canonical
2085	3NKccKUDJE2AE6CAzSnBEh2Hw6aEG1J4oFoumi6aUeK3dy1nVy2t	2083	3NLxCAHQSdzTbFWWjNRP5MQRCWUfKwpZRNKTVt2TudYgbCfCDBno	1490	1274	8	1	2048	jxTyji3izJmn2oSJfZBna495ggypomv63z8e7nfr3Gr5gGJs4gw	1100	1544	1544	1616217120000	orphaned
2086	3NLLpLBgJVzq4AnfZsP2ZkoFJpa1Mz91cjKGZCEqqzkFTVA4LmaV	2084	3NL2wxyjPDzTprp1yb1dPmKYW1NvhrNT3xi7uE1niQmhXTrZF1Hb	1403	824	8	1	2049	jx3STZaBaQ9mMp7WtHeT8MGUQx2mSUvNewkM8WtJUxt2KK3RBc1	1101	1545	1545	1616217300000	canonical
2087	3NLKbj12ebh4ETrjdeZRvNVn3MaBPK2UV2ikwjz2uiYxjSZqM8ZJ	2086	3NLLpLBgJVzq4AnfZsP2ZkoFJpa1Mz91cjKGZCEqqzkFTVA4LmaV	1403	824	8	1	2050	jxxz3XuWcW9JEeiDSxWxPLeqYkCcFekAoSYVV5BfGuSb5CJ6DY8	1102	1548	1548	1616217840000	canonical
2089	3NLgxT6Yt9KR5UPFuXDcin89mjGpDcFpTxHojraA2H3TAo63FvKM	2087	3NLKbj12ebh4ETrjdeZRvNVn3MaBPK2UV2ikwjz2uiYxjSZqM8ZJ	1593	1100	8	1	2052	jxBAXzXtTTuk52kj2Fo3q4k9swpsL1SRtzUEdj8aWQadS5dMELg	1103	1551	1551	1616218380000	canonical
2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	2089	3NLgxT6Yt9KR5UPFuXDcin89mjGpDcFpTxHojraA2H3TAo63FvKM	1529	1316	8	1	2053	jwxJZxgc1EmtdEWDnKwnkN4zqkLiXCRMSSsPZXEQbcTV7oTv5V4	1104	1552	1552	1616218560000	canonical
2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1407	1395	8	1	2056	jwDz5Wy49rmSgpLTMtMyeN6Mb2cosmpKYv1j2QfGDDRyFzCyW8f	1105	1553	1553	1616218740000	canonical
2091	3NLjidijoWjBoequm6Yq4HTpH7greSN24xRG26xteJ36oqtG7Hj4	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1489	1380	8	1	2054	jwMtrMxZxYQW7r3YBUHZrpoyerB4c4gWnx2LDkvZBxmVXSzfqCu	1105	1553	1553	1616218740000	orphaned
2096	3NLonp7fRagpwTaVA4rQFN3wXU4MfYWgwHnhBxE7UWTgDPtN8n8o	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1406	1393	8	1	2059	jwn1gngmkevC219t9PqWk8QAyWrVvVMPYr9pYyirCBhWCGXYCt2	1106	1555	1555	1616219100000	canonical
2095	3NKbiCnid2W8PJsoHNtedqkdoAtb7J1Hcf9utGMUwBwvPeJL8WkL	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1579	1389	8	1	2058	jwfG3VZiCFVHTeBjAMRCNsYTgCsJptKV5comcCPpgdj4NxJtFfW	1106	1555	1555	1616219100000	orphaned
2097	3NKVzZUZ3zPa2N9gXUNWKa3DnTWbdSrQC9MjVzwvrxwAR1F2dqEv	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1456	244	8	1	2060	jxUMoxv1rQ5pown6pNwDsVxmMjipPbqfk5CKUtdzWk1iALm5JKP	1106	1555	1555	1616219100000	orphaned
2098	3NKcFMjQK6qY52Km8HV7MNcpjdWnPRuw6aphq4X4MXaZwTnjCw2L	2096	3NLonp7fRagpwTaVA4rQFN3wXU4MfYWgwHnhBxE7UWTgDPtN8n8o	1634	313	8	1	2061	jxcQb2tMajo84GwkLzmF6sz85XwUGa8VP95epyqEpAiH4mfXbx9	1107	1557	1557	1616219460000	canonical
2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	2098	3NKcFMjQK6qY52Km8HV7MNcpjdWnPRuw6aphq4X4MXaZwTnjCw2L	1406	1393	8	1	2062	jwunG9np8JmphSKYTVX3PECnY7Es1eh4pGbdBjqNCE7qqSEok2R	1108	1558	1558	1616219640000	canonical
2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	1407	1395	8	1	2064	jwcG3YNQivh69NPcGJkiBdgNosFPCBRPqXgPY6pXZ5eV88NCSHj	1109	1559	1559	1616219820000	canonical
2100	3NKRtsH2stvcd5SrphqJ2ZT2nJDv7arwtfAd57xdmGqw9Pfdfzga	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	448	1305	8	1	2063	jwVLLs2axhsqGx1iznABYBckjXdEq5ewrEGLuhPj7tq58rHvcKX	1109	1559	1559	1616219820000	orphaned
2105	3NKmPCgG5qbafuJCW6YtuT1CLwkbeC9XY4xuZhthR9bKCj5HsxSF	2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	1406	1393	8	1	2067	jwCb7Sa8NYsGhaaoaRKybazYbhREbq3cpWizxjQwXnYhFrCrDmL	1110	1560	1560	1616220000000	orphaned
2108	3NK3H2LK364BUw4RkWVZFG1DHbKtj2Yvw8ewy1sndLEq8kvpwF3G	2106	3NKMh2KMK7hPehKmhUyQLLnJupUg9TSsmbZxZ1TE3SFud9x8L1Rx	1637	816	9	1	2069	jwk6fJSnBsycKHFGFohnWuBDzcnDMwbpJRixS4K3DkJovbGsByZ	1111	1561	1561	1616220180000	orphaned
2111	3NLPfpwUJCBYv46Eko8ChBFpBgKoew1PTuc6DVEnxprmEv55uaFn	2109	3NLaPzK5seDqE5MsgC94rBknbJgP9WnK98TgSYM3gpchMo8FTBrJ	1477	1350	9	1	2072	jwGojwCiVy9D1791M9FJ4mneossFRd9yn9i1D3Lf1hist4tVyL9	1112	1562	1562	1616220360000	orphaned
2112	3NKgpSN4wfHeJKKK5qYebrN7TFdY3ssHQo2vSFLWoGjM1tbnFv3y	2110	3NK33TDS12qb6rVTKUwDPYwUJTNE7VRru34w3cibix7RvUoPQVse	1466	502	9	1	2073	jx4euTKc5YBcSbz2KjVmhipdbYWgXNqFJt4oFwYxbxuF2441vRC	1113	1563	1563	1616220540000	canonical
2114	3NLUHCHKwo9W8pjTAaPFwaSdWmf3rJidL5Y5gFtgsGRtojF2bpam	2112	3NKgpSN4wfHeJKKK5qYebrN7TFdY3ssHQo2vSFLWoGjM1tbnFv3y	1529	1070	9	1	2075	jxvXesZagCxuufqWuvjPt76XhHXgf2t8YCTxmPb5ADe66T69FuA	1114	1564	1564	1616220720000	canonical
2115	3NLLpS23AVZLxX6CCTZSFHWgYnngMpmt1qFwB9tn3aXZ9CvJk8AF	2114	3NLUHCHKwo9W8pjTAaPFwaSdWmf3rJidL5Y5gFtgsGRtojF2bpam	1652	1189	9	1	2076	jwPARhCcsXq6tNmmup5CvGHxT55eJDExhmwakBwnmvFc7a4L4zW	1115	1566	1566	1616221080000	canonical
2117	3NKeTxbKFdcFtisM1r6BQ5PBa1vK3qZR3LyDxgtBgaP5Tuzekjav	2115	3NLLpS23AVZLxX6CCTZSFHWgYnngMpmt1qFwB9tn3aXZ9CvJk8AF	1458	1323	9	1	2078	jxydtpVQ3sS4igqjgQvu3jYcKEySuiTBP8D8BdMAZgbsKtvvrxT	1116	1568	1568	1616221440000	canonical
2119	3NL33eeMpB5AYXeBGaQuQ5xVNekd2q8SytEnNA6Eqw5JKzhkfV53	2117	3NKeTxbKFdcFtisM1r6BQ5PBa1vK3qZR3LyDxgtBgaP5Tuzekjav	1547	1132	9	1	2080	jw78HFauQ3H9KKcbV67izr3jcWaPfAPwmghfwg9zXHG8Rb5BqM3	1117	1569	1569	1616221620000	orphaned
2123	3NKtDwCnWFGPz3xUT1EC8ms7zheFFB3EvFGaDo13WyjrGJVkFywr	2120	3NLnkc716zv7qU2QDgpw5XNgenMkpaKP8bqVy9asHeyovTkohn6g	1406	1393	9	1	2084	jxzmPgaA5HhsnrPMNCYFXgUvhf9jPyYETuVahzaGf3S3uhaWGne	1119	1571	1571	1616221980000	canonical
2129	3NKoZCPRyWza9m7UUKqzA8ayxZWYTcVw9LyRLLwkxfft3KVQ77Nn	2128	3NKB4KDjMs287wW5qsdcdvzA1MBTm2vhPu4vGVvTUp4jQp55u5UC	1474	1083	9	1	2090	jxYmXo6aXhKGDFpSQDcmfizntQpmG8kZq1HoQFLCkLxsCCaFUDi	1124	1577	1577	1616223060000	canonical
2134	3NLf7tT2bdxGK8q9WzHDVpRKazH6Cy3R57a38MogWvVWyHiKPxcM	2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	1458	1077	9	1	2095	jwkRfWG6U23Ptt1y3HUjTZ8U1MV29YYgdvgKrJ9CDvG6vFQZxQn	1127	1580	1580	1616223600000	orphaned
8005	3NLaYMDA3jcDr4rmsfaQtZp9YgZwJtBB5e598Q6DUVrTvbMrm27Y	8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	255	255	93	1	6301	jx5KXtGnMfofqGHnreNRw43pbufYpuxYPFwMQR5H9azSrPB4qzG	4148	5855	5855	1616993100000	orphaned
2102	3NLjHvkDmoJ6zJHNfb25qrsEFirEwppg9xr8FEZShngFwrtQZYdj	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	1573	1192	8	1	2065	jxJamJ2iEkNYr3cAkAQGTddYN7E98sNweaAAXHXQJZo3zrsRgBj	1109	1559	1559	1616219820000	orphaned
2104	3NLo5qRCDQcvFekjtd6xu4DEfuUjmRHkLnMJF9irVS6iE79orB2Y	2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	1649	1017	9	1	2066	jx95JWvC776TqKgYKqSrYS1kjFGyQNPyrVneGPj5UG2kJhkTKM9	1110	1560	1560	1616220000000	orphaned
2109	3NLaPzK5seDqE5MsgC94rBknbJgP9WnK98TgSYM3gpchMo8FTBrJ	2106	3NKMh2KMK7hPehKmhUyQLLnJupUg9TSsmbZxZ1TE3SFud9x8L1Rx	563	1233	9	1	2070	jxn3ZNvFYwXEhThxWULjHafXY1XrqJRV2HQ7vBxdPDk1gMAumGt	1111	1561	1561	1616220180000	canonical
2113	3NK8Px5xynh7amdSiqnk9NSJ3R492pjhixAZDrLPRoXa6Jtt3KxT	2110	3NK33TDS12qb6rVTKUwDPYwUJTNE7VRru34w3cibix7RvUoPQVse	1553	776	9	1	2074	jxdyrc718KX4EJBFsrzAjRfkVwC4DbyvgeGHMGm3NHUkP3c5oV5	1113	1563	1563	1616220540000	orphaned
2121	3NLs2ECRjJjTZHtqKXxCq2eTPEvxsHJEgbt5wc9pg1i7LQB2uQp3	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	1553	776	9	1	2082	jwPcg164s7dUxkqQaxqnDwZuQDtG6GhHUBLRaLSHD4zWfzNEbg2	1118	1570	1570	1616221800000	orphaned
2125	3NLHgQd8LWQbHzP6VMMro1tu2tZQ1134F5x6dEmjCfpDizs1MMQ9	2123	3NKtDwCnWFGPz3xUT1EC8ms7zheFFB3EvFGaDo13WyjrGJVkFywr	1403	824	9	1	2086	jxAyBzz918aJdzDSWQovShieUe4T6vu3SELpvbVF76ricqZBQNa	1120	1573	1573	1616222340000	canonical
2126	3NLmriwwa5h8MUoazPq58QZ8f1eZX4KfK1uFox4WjxL6hm8MVVJv	2125	3NLHgQd8LWQbHzP6VMMro1tu2tZQ1134F5x6dEmjCfpDizs1MMQ9	1527	1047	9	1	2087	jxpcCWcEUdk2xKcsqasRDM97E77Ds1SJTzmvuQxx94xYrdZzqnC	1121	1574	1574	1616222520000	canonical
2127	3NKKg59oYf3vzH2G8vzoPpPAxPWarn16DbivtYorA7LRYQ4beDEJ	2126	3NLmriwwa5h8MUoazPq58QZ8f1eZX4KfK1uFox4WjxL6hm8MVVJv	1585	1366	9	1	2088	jwx4jKcyTMui4gxbSzNamVZ5fj65xfBiBuC3pxwYV3Eut1q2jVh	1122	1575	1575	1616222700000	canonical
2136	3NLe9Q73NJWi8hTbJyqmvvq6gKkTrBcSL5aMnqexBVYeenBxLXk4	2129	3NKoZCPRyWza9m7UUKqzA8ayxZWYTcVw9LyRLLwkxfft3KVQ77Nn	1458	1077	9	1	2097	jxNRC2c2wFu4vhP15Rvr3dLw4NeLai8VkEFnEmHD53iq7s9xSxw	1125	1580	1580	1616223600000	orphaned
2138	3NK7FZyohp1Lya7Be4vGW7uTpDUYyBTfG6f3iPMLSKzqhYMGjUBe	2133	3NKfPFU9J9tzd7kJgTZSwmetXQUp19NUy3qzgXcnQg38CzPDFBtZ	1646	1228	9	1	2099	jxspr9zGZ4JDJbhUh1hjqHkLzSSrSpt77xvKagSFmZ3FA7rsi8Z	1128	1581	1581	1616223780000	canonical
2139	3NLMEU8YVrqmJugZmZ7dn1LrBtgVExNfdMkUZW7i3XBYqnZLRTpV	2134	3NLf7tT2bdxGK8q9WzHDVpRKazH6Cy3R57a38MogWvVWyHiKPxcM	1406	1393	9	1	2100	jxDrhf7FBFvfrsUFZ2BnrYGu5wuf6tPq9FRxfKVwkbqcLbTRooZ	1128	1581	1581	1616223780000	orphaned
2141	3NLtZD9rMLwDfqbLDBecDoy2o2wfdNdMHJhBC2bwU9oXw1PQXscQ	2138	3NK7FZyohp1Lya7Be4vGW7uTpDUYyBTfG6f3iPMLSKzqhYMGjUBe	1407	1395	9	1	2102	jwc46VKWk5AFsMMfM1UdpimFYnUrN8ierN7cWsMouJpEKGwqPE6	1129	1582	1582	1616223960000	canonical
2144	3NLTC3MrGiPjydNR4gj6vMVT6uXjt46eM68BX3mHbXiPTrJeScK7	2143	3NKQRGi4ady6H53CtAi2Br1482uYKbrgQ5XJp6mcFzb9pa2KKVzc	1619	1029	9	1	2105	jwDfcnQGsf7Sqnm8F4JrJfDRbrr3yfLXPvuPYwiv7vr5QHX39DU	1131	1584	1584	1616224320000	canonical
2146	3NLXcrk6EnLFkggsCfnJtY5v1Za1xUgkP8ftwVQbnz6wF9cHxfrm	2145	3NKwrsn9bFy7UAMJ5rgruqmnPyWtSZrb5qRW2hs2giHytD8Xh5wL	1553	775	9	1	2107	jy2F1Yc1HG7fH7Ab57JmcGGrijbhUnSEMC21vYSY4mUPhLuboyG	1133	1587	1587	1616224860000	canonical
2149	3NLHK2oMZwpqtePsooNUvEdtAkvuG4UMUTLpP86FpSdSJkZdzWZm	2148	3NKmWY7Tj1nVNb9jZ1DifJjUV8vFdbvoN9v8jwep4ucuXgQMAWqA	1521	173	9	1	2110	jwsodfh6X5uBEvdnwq1Di4LdVSPAk1hwjkzo6UbeuwXscQFrW1S	1136	1591	1591	1616225580000	canonical
2152	3NL56kFxPBhMyvfWCoqapj9oFxr5nuYLtr1BLZs8UQqwNDmC7LD6	2149	3NLHK2oMZwpqtePsooNUvEdtAkvuG4UMUTLpP86FpSdSJkZdzWZm	1637	816	9	1	2113	jwexsiWVZNzLjr4ex942YJ3qfvHBNvVunqMX1fHNSeoshJzqczn	1137	1593	1593	1616225940000	canonical
2150	3NKiytzySdaAx1QkyEqd1Z7f9akHF7mVUs9dVjbXF3XuevhB4ojZ	2149	3NLHK2oMZwpqtePsooNUvEdtAkvuG4UMUTLpP86FpSdSJkZdzWZm	532	937	9	1	2111	jx6WZHApsKdiYmxUNZQqddZcjE2diGxQBEqpgKuxjn5wf4nvzxP	1137	1593	1593	1616225940000	orphaned
2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	2153	3NKGmrMUfY92kpFXrn8jDTsapwJKnEnuzcPdHr3JEceJ3SSRK42e	1419	814	9	1	2115	jxSakDGLw1LAa6pwCDHsBWxXisdMCcUPSGqziT9EPx3Li3mDCQA	1139	1596	1596	1616226480000	canonical
2156	3NKmQhVmG8snd6iNFx9V6b128PfSR1Ay4UiQVEdXiiFjBPVnmexG	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1523	1321	9	1	2117	jweRRfhZa82ogJs3dKqMEQWdSz37ejwD1qbP5QPLKgNZURddqxg	1140	1598	1598	1616226840000	orphaned
2161	3NKTALJJsHaWWq2qSjFbxDFfAWRGJQ3c9EpaN4UiyVHbAetFeYHn	2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	1578	1296	9	1	2120	jwyHGbAsqzT574Eq1ZzEdyTBSZdvA5vEsLYxCryfpJZbGpS82NV	1141	1599	1599	1616227020000	orphaned
2169	3NKiZxxy14CkqPJSnbEHevhQfSyMY69qejgx4Br5hFLjKyeFajYy	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1523	1075	9	1	2126	jxH5taE18TuB1ZKoisfrhZqbcp1McEmR24DfQB51N88PrzeYb9P	1144	1602	1602	1616227560000	orphaned
2171	3NLKXoe7yE9wXxiJffLifz4HKVThXHAZ3asNHXEz9qEP1kdYr5Y9	2168	3NLmNTpWbW966TZDQXywruod6HfxWemGc6F8795tBbiaGc49JbMD	1637	816	9	1	2128	jy1jLTkKRMBAR73aUjMeR5LSxEJCV6qx1Qv5wZH4NNckByKtZbh	1145	1603	1603	1616227740000	canonical
2176	3NLbEv7tDBhM3bQVP98e8wX6ECv8QcYQ3YCVKDY5jLAgFPoB7o2P	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	1581	778	9	1	2131	jwumGntwvfXztcMb1rPRJ7RLL6WVs3JYHhSZJMmdM8ZqpCYp7Y8	1147	1607	1607	1616228460000	orphaned
2177	3NKMtqcTAzs7Vr28VzcqKVPrFtcLthieBy4YbyfwgMFddWxr1XtP	2176	3NLbEv7tDBhM3bQVP98e8wX6ECv8QcYQ3YCVKDY5jLAgFPoB7o2P	1402	876	10	1	2132	jxrhcWDKaSwJReL9r1u2KgbGKscCjkSbJQWy8xGeQ9nQ3UFXwng	1148	1608	1608	1616228640000	orphaned
2180	3NKdVnqSxxZ9ywBXAyHLdx5U1bJcLNoB8XtZ7bZuoSTgBcf4uABD	2179	3NKdEgW1q52VfJYfsfznRX9atR92cvgLyr115U1T9LNJrqXG1x2A	1627	1259	10	1	2135	jwVtm17uMs7qcw8xmAf77dKfvFnkwB6NYkMgcDwrrkfT3bB6WRf	1150	1613	1613	1616229540000	orphaned
2184	3NLRuR4VwjuuobDmEUuEnkfZcth842YRiHfsncwwk6gGNZS6Gfwh	2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	1633	1264	10	1	2139	jwAzoyNNZpWZFajtyVAjFQm6QPduBEtAYTEfxpW2ZX8FnZRjTiu	1151	1614	1614	1616229720000	orphaned
2187	3NLDz6PVD8NSuegTWMHJzJVDHgW1UH6v3yrtTDcxPj1K4jk5wFXM	2182	3NKLNGUVTAygzhzv4u51qwokU91ptNWJBcTY5VqXbDdpdWPmh3cB	1643	1299	10	1	2142	jxFbpb2bqxxWjtR9t4ac69fCZPRsjDF8sfpU9Hm3p9cYFATTWyp	1152	1616	1616	1616230080000	canonical
2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	2188	3NLrMnMZimGspk5EZLUpLRmNp2NE8FLkjWG4ShXVRUN7vrGLscka	1553	776	10	1	2145	jxkngTT2p9JTQSZxMJosj6tUd3C76Q1r7tuudMdXVmn5DkhqnyS	1154	1618	1618	1616230440000	canonical
2192	3NKurUhgbeZxg2iRGAwekNLaPP8DWrTacV7grFv8uqx8mBzkAGLb	2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	641	1336	10	1	2147	jxK2mMXjHvuD7Qb1QMZ5sAvG94NdhShBXH9ujmdCQyJTeCb7yda	1155	1619	1619	1616230620000	canonical
8007	3NKUsNxYdvmFZ4eHAy7rgRA3EaFgsFdb7DnWskmz31wTAcfQMa8t	8006	3NLhYpKiPELj8YArcR3mokiaCYxPGVrfgdqFfPTz3TjM6KjRynFR	1631	794	93	1	6301	jw7Cjk42wrrCemGr3bJ9QwPMtBFbeSmbYotv2zfMgvvUUYHfojx	4149	5857	5857	1616993460000	canonical
2107	3NLMytc1jarVNfKFVdaac3nDUW94W9c2DAHgQfUS2rDrRyhoypoZ	1887	3NL9ePJn4P9k6wtaLgGHWwDcYihvgysP7mFjyEC6cpBzhQokyUop	563	1233	6	1	2068	jwT7P1eHeTDfknvWtSQ627ZoWk2atDjdqR6VG2tFoKJDQsJgPU6	1005	1561	1561	1616220180000	orphaned
2103	3NLR5SfaXqSCRL1ubXXyKonEw2wm5nRzV8iP6RmHhPgpN7RxP5z9	2099	3NKkDrn4A4ircn5Lr9FAVeQoAuLT9qd8DkAJ45q2RZDPdkhBaJkB	448	1305	9	1	2063	jwVLLs2axhsqGx1iznABYBckjXdEq5ewrEGLuhPj7tq58rHvcKX	1109	1559	1559	1616219820000	orphaned
2106	3NKMh2KMK7hPehKmhUyQLLnJupUg9TSsmbZxZ1TE3SFud9x8L1Rx	2101	3NLYjNWfxeBi8rWB6jUXR4vt5cxsmiCtb6EMWRctVUMGD2oNzoSt	1649	1017	9	1	2066	jx95JWvC776TqKgYKqSrYS1kjFGyQNPyrVneGPj5UG2kJhkTKM9	1110	1560	1560	1616220000000	canonical
2110	3NK33TDS12qb6rVTKUwDPYwUJTNE7VRru34w3cibix7RvUoPQVse	2109	3NLaPzK5seDqE5MsgC94rBknbJgP9WnK98TgSYM3gpchMo8FTBrJ	596	1306	9	1	2071	jxFx6yD9VWThL69ebLcpX9kHgZc15jzJBdcQMHggCnGpwmrGyYW	1112	1562	1562	1616220360000	canonical
2116	3NKgzVP4V97H3dcNNDEDkPbxokMeqUiSJyz4cv3a4MyGFbWq7hJ7	2115	3NLLpS23AVZLxX6CCTZSFHWgYnngMpmt1qFwB9tn3aXZ9CvJk8AF	1407	1395	9	1	2077	jwjZueQNp93xWke3kHQXk7ggsSJxynrTLzGKLXAZq3WRcuBA3qx	1116	1568	1568	1616221440000	orphaned
2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	2117	3NKeTxbKFdcFtisM1r6BQ5PBa1vK3qZR3LyDxgtBgaP5Tuzekjav	1403	824	9	1	2079	jw6ewNzu5SCYyBzho9Q9YaZAm1fHH5MnqMdRACRmXXmX6dBrXWp	1117	1569	1569	1616221620000	canonical
2120	3NLnkc716zv7qU2QDgpw5XNgenMkpaKP8bqVy9asHeyovTkohn6g	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	298	1308	9	1	2081	jxJbXxKVCRvwM9MLYhQKJRBGAYzLDuAHWTeCrgf9KUjSsnna2TQ	1118	1570	1570	1616221800000	canonical
2122	3NKNAxbyQqBUarCL6EfdmSpj3Vk4yJ4srSeyZUjquytbZhCQdheo	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	1406	1393	9	1	2083	jxuC47eJTSdE8RmrnEzYFBA7rmbghSwDt99dgWfXvvNxCdY8f2R	1118	1570	1570	1616221800000	orphaned
2128	3NKB4KDjMs287wW5qsdcdvzA1MBTm2vhPu4vGVvTUp4jQp55u5UC	2127	3NKKg59oYf3vzH2G8vzoPpPAxPWarn16DbivtYorA7LRYQ4beDEJ	1609	1333	9	1	2089	jwssmMDYfCcmamtW2qgKwuY1H2cpM5esB6GZWfS4C7ydDFqcmUi	1123	1576	1576	1616222880000	canonical
2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	2130	3NKkLBxBxEGu6LAburpyohshwqNHKZDvQfUGfXbo9i4AiDVHX7rh	1631	794	9	1	2093	jx3bn6AHCVwsAg5V5QAqJ6Knaxk5nTSmTGCAejta7VV5YHYPMPi	1126	1579	1579	1616223420000	canonical
2131	3NLm9JmsPpXc8cEg4i3RcFeydgLmH6UFMTfPmfSK5RYABuMhvRnV	2130	3NKkLBxBxEGu6LAburpyohshwqNHKZDvQfUGfXbo9i4AiDVHX7rh	632	1256	9	1	2092	jwgg4QtHyTFWP5TcVUMvsrktj1hiWSFPsSAvSSV4dzeRHwkvMd1	1126	1579	1579	1616223420000	orphaned
2148	3NKmWY7Tj1nVNb9jZ1DifJjUV8vFdbvoN9v8jwep4ucuXgQMAWqA	2147	3NL23K7fKAMFduGpScvF4aWnbqgJkDLhEpKtu3x9HWHHVRdgymQs	563	993	9	1	2109	jwUykYD3eFe5eykq8GVqL4gae5er3ZoFcxtLR6yXoy3nuVFuedT	1135	1590	1590	1616225400000	canonical
2153	3NKGmrMUfY92kpFXrn8jDTsapwJKnEnuzcPdHr3JEceJ3SSRK42e	2152	3NL56kFxPBhMyvfWCoqapj9oFxr5nuYLtr1BLZs8UQqwNDmC7LD6	1440	1377	9	1	2114	jxjJQk6ctxYn9zePcKfaQqBhf36RGsEDa8VtL1hAAx6XdyUnKtL	1138	1594	1594	1616226120000	canonical
2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1523	1321	9	1	2117	jwiVkcmmoBkjJM2o6NngjWehcdTGSPnTJwyZBuhPx2WMbidDsPY	1140	1598	1598	1616226840000	canonical
2162	3NLkWXc9M63QwV42YBQGPB5XGc4R2VVAmEU9k1knXQSNXAuHmmVz	2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	1403	824	9	1	2121	jxsDDMWpfMpaPj6nucV5oeJxxy6MdJaTorbaTMxriqgbEQvAE4B	1141	1599	1599	1616227020000	orphaned
2164	3NKRLmv6eTeXaWoaKBg2RGGCuc4V3dqvdXbkkaoeDaFjQwj4vrpG	2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	632	1136	9	1	2123	jxzX3mLtQr8x8dpdsoH76DhMTa4vAuycDS6WiZPBLoXDqNb9g7n	1143	1601	1601	1616227380000	orphaned
2167	3NLTQJDxroA2twoRmMKbXkL9kVCy727nNGfDx5vMiURSzzBSVfNi	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1523	1075	9	1	2126	jwWnKxHgjwy55NWeVKYoc2S5n9YA9Zr5M6CmnufroFzLqM7fZ8y	1144	1602	1602	1616227560000	orphaned
2170	3NLrCT7cyexTFeeQmz8eRhxyCyKPPW7YkRjAVGav6q4QiePdiA25	2168	3NLmNTpWbW966TZDQXywruod6HfxWemGc6F8795tBbiaGc49JbMD	1447	701	9	1	2127	jxusquE4969f4NscrmzAry3qEc4r6pFHqRE2qFvqnQYVJVgY6cA	1145	1603	1603	1616227740000	orphaned
2173	3NL3QvcjeqUD5w8VA35iokCPqG8CPDDdWmLsusrgwd3YmP4UetzK	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	44	348	9	1	2130	jxmLNobjK3JGUMLriD1AXWvcQ5UsnT7DwwzUoM1i3YxubQk8QWe	1147	1607	1607	1616228460000	orphaned
2178	3NKXd17tWmYKkqGAqaKNiwTZjCK8FdrHbtantXRHQmjFQgsi5MWi	2175	3NL2tUDSFbfeuGGgUVVWxdZdNXnt4izDM3jgfAWxRfwZgK8Vfajk	1406	1393	10	1	2133	jwzFfh44E9dWGKjjypdkZjV4Pwpo62MndwhyraTBGqudLJTdyW1	1148	1608	1608	1616228640000	canonical
2179	3NKdEgW1q52VfJYfsfznRX9atR92cvgLyr115U1T9LNJrqXG1x2A	2178	3NKXd17tWmYKkqGAqaKNiwTZjCK8FdrHbtantXRHQmjFQgsi5MWi	1578	556	10	1	2134	jxCMbFD9kfh8viYttJAuCMCcSg5J8M3vMPdfu28SD6fcR1H73i3	1149	1611	1611	1616229180000	canonical
2182	3NKLNGUVTAygzhzv4u51qwokU91ptNWJBcTY5VqXbDdpdWPmh3cB	2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	1671	1119	10	1	2137	jwjXiiwdkYjUTvoJZXdPgg3NTCZZenMJ6R5CMcmUz2hCyNaM1uL	1151	1614	1614	1616229720000	canonical
2185	3NKMESLDuajiw1AZBrhE9ne1aCyjfxKvhD2fVxqnjr7mBRQgBTy5	2182	3NKLNGUVTAygzhzv4u51qwokU91ptNWJBcTY5VqXbDdpdWPmh3cB	1483	322	10	1	2140	jxuopnBdGACX6fpsMeD7zU26uxEdc3rUoSYoxGBtYrJhob3kQ3A	1152	1616	1616	1616230080000	orphaned
2189	3NLKbKbn8n3snc11wJiu8Upqp1Zggb2dr8E89LT3AVXVMMmvDdQr	2188	3NLrMnMZimGspk5EZLUpLRmNp2NE8FLkjWG4ShXVRUN7vrGLscka	1483	1276	10	1	2144	jxy1sQMhfnheEZ3c9BYwPuU3XtimRKSrtwmFmLP5fsatsx5FaWq	1154	1618	1618	1616230440000	orphaned
2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	2192	3NKurUhgbeZxg2iRGAwekNLaPP8DWrTacV7grFv8uqx8mBzkAGLb	43	944	10	1	2149	jwyPJp3C5n2etoabcRQS5wZSCW9mf4zQUysAZhEKVAum8xs7oUu	1156	1622	1622	1616231160000	canonical
2196	3NLn1aWv2mnWFeSprVdsrWqSXsxLumqDorU1r5p2NnRZi4rNFABL	2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	42	1115	10	1	2151	jxSg5GZXo7oMGBaoX2BEQRUcfDHRbyPp5L1VtLqg7NxerRPUbZC	1157	1623	1623	1616231340000	orphaned
2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	2197	3NL5o9NvCPMeSj1up17otBhgYtZzh9ajBo3aoVEit8pEN1zq2RdN	1506	1007	10	1	2154	jwa9dgUs5bNeNqkVVaFzvUBhjV1iBBcMoAy8wXd5JfQJfSyXLdr	1158	1626	1626	1616231880000	canonical
2201	3NLZDKL8rsPGMpXjbuysycJLw1WbCzPvZE5Qk4HdVnfipD1GefPm	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	1467	1250	10	1	2156	jwLvYJLCmEciTNQGxDuPBH4Xg3ZSBYuUD8NXWfzXccrSLWjVb3t	1159	1627	1627	1616232060000	orphaned
2203	3NLVeakW7PnPCdNHjU72H7mGdYC8s7ECnximmtTtW3F2SSrCwaeC	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	1637	816	10	1	2158	jx2ZEV3WKeRwT3bfzZk6ZLihBEP5hAmL28Nph7r7rWbuwWxBk3t	1159	1627	1627	1616232060000	orphaned
8009	3NL3GthpbxQCRjUnjYwR1oHfXGGP7NN3KwDKnbyvn1nbpXAK9B2r	8008	3NKBtrPTbndQcBwQZ6qPKyd8wNTpAaq45ySPEGupVsV9PyRmcoFM	1585	1000	93	1	6301	jxR7fwRABW6ANyREXbDbrTh9GXLuokmLyTNAsC8oNZu4EWMxq7m	4151	5859	5859	1616993820000	orphaned
2195	3NK3rU5UV8DXNDX4rHGFsgfWCHw5ocAh3wimW9bnKgzLSyMU7FEv	2108	3NK3H2LK364BUw4RkWVZFG1DHbKtj2Yvw8ewy1sndLEq8kvpwF3G	43	944	9	1	2150	jwxzBWRYqhi8ARhWEeqWknifsbYgkF46SHSe71g7pG2ZgXxWRcD	1112	1622	1622	1616231160000	orphaned
2133	3NKfPFU9J9tzd7kJgTZSwmetXQUp19NUy3qzgXcnQg38CzPDFBtZ	2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	1589	920	9	1	2094	jx7K8GXTctH8TknBJQfmmXYWm8pYzp2nDvPykYjsuRtuz4J247w	1127	1580	1580	1616223600000	canonical
2135	3NLVsrRCg8ZkER5mJxoP3chY5USM3WQq66u2kZ9zSU7JnAaEnxZf	2132	3NK5w4diUbGkjvAFpdX4hZ9V7AfUjwx1Xfhpa88ApgcQ3Dh47myQ	1619	1275	9	1	2096	jxNCW2bVHme4Q8bdzi3pY6fHkkFgEdhHmbuoch2iimV3f7r7xRL	1127	1580	1580	1616223600000	orphaned
2140	3NKXN2fc2evDf7mrk6zv5pzxxdbkxjEkWUfKDHoUhV39bZZp1CY1	2133	3NKfPFU9J9tzd7kJgTZSwmetXQUp19NUy3qzgXcnQg38CzPDFBtZ	1477	1104	9	1	2101	jwjDVRvtUubk2cf4uM9a6G3VjcsVZLvvcyMWvEyq2fhyrJqKa93	1128	1581	1581	1616223780000	orphaned
2142	3NL96o8fSgh6YzeqZZscJd5EuNaosu6hhXg4e9PiZHRcZR56YNgV	2138	3NK7FZyohp1Lya7Be4vGW7uTpDUYyBTfG6f3iPMLSKzqhYMGjUBe	1506	1373	9	1	2103	jxDYC984aP7XpxQ3Bmy3NYRpkvWPyVsJar9SfRFY5pfGmQ1DpKn	1129	1582	1582	1616223960000	orphaned
2143	3NKQRGi4ady6H53CtAi2Br1482uYKbrgQ5XJp6mcFzb9pa2KKVzc	2141	3NLtZD9rMLwDfqbLDBecDoy2o2wfdNdMHJhBC2bwU9oXw1PQXscQ	1553	776	9	1	2104	jxrMW5YJuTyMBRGnM4qoCYH1GrdmiqY7ARyQTtuotnUdyqXCsZr	1130	1583	1583	1616224140000	canonical
2145	3NKwrsn9bFy7UAMJ5rgruqmnPyWtSZrb5qRW2hs2giHytD8Xh5wL	2144	3NLTC3MrGiPjydNR4gj6vMVT6uXjt46eM68BX3mHbXiPTrJeScK7	171	1374	9	1	2106	jxNtC88Ds6yFXracbkC5LxFQtgCZNMxbKprFsHFAMjjZhP6HbAq	1132	1585	1585	1616224500000	canonical
2147	3NL23K7fKAMFduGpScvF4aWnbqgJkDLhEpKtu3x9HWHHVRdgymQs	2146	3NLXcrk6EnLFkggsCfnJtY5v1Za1xUgkP8ftwVQbnz6wF9cHxfrm	1489	1380	9	1	2108	jxjWdMBTM1yLekoem94JdmmND3t3KfUH5wUeAtZKbfXkrym4R3K	1134	1589	1589	1616225220000	canonical
2158	3NKWPfvcQ1TqhxXiAHeg5kgEY2L2Ckqg6Seu57fPrXQpb7Mvmx4J	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1523	1321	9	1	2117	jws8y9fURef8bRS4DSfPie6WV8S5ozJu6VxTNpCCWt61Me2eMRR	1140	1598	1598	1616226840000	orphaned
2160	3NLjcJbwoPGTb7CZUce5U2FfuQ3G9V1jFAkaV9K2C4wZSb9CzQat	2157	3NKeeTPRWkqEi2VcasUZpeCWc9uxdskmFZncsjEmR2kiEJ47PDtd	1406	1393	9	1	2119	jwDSqaWUsAHWxU9FYiqk2pWXNDmbG1hcnDJv2kvdXQ7QprLZuv9	1141	1599	1599	1616227020000	canonical
2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	2160	3NLjcJbwoPGTb7CZUce5U2FfuQ3G9V1jFAkaV9K2C4wZSb9CzQat	1647	1176	9	1	2122	jxZjhiTFdbEekcN7vpNcn63fejkTVGdkeyttnTqVHoMvXYCKXTk	1142	1600	1600	1616227200000	canonical
2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	149	1037	9	1	2125	jxszqeVexzccZNWCVQvXdNsw3yyWsopohW2zD9T9h2JtJdNHbjR	1143	1601	1601	1616227380000	canonical
2165	3NKXRkmkXy6a4nZTPvm1Upxc4o4UfMhe89HXbgb9GjeE45hjrcxd	2163	3NKQ7sZVWeqYTEDcR6Tac1aJ9TP7xB2kPhNjigd5dmvpEjes8gB9	1406	1393	9	1	2124	jxH3LuTH2wsyrYV5sG8HXDzMYPFsScwJHoH3KpY3fuXsBW8REWU	1143	1601	1601	1616227380000	orphaned
2168	3NLmNTpWbW966TZDQXywruod6HfxWemGc6F8795tBbiaGc49JbMD	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1523	1075	9	1	2126	jx2FWPxvTQNTrrH1Q9QS2gVC16nt4dHBLNwkCb7yYHe3DTEosiQ	1144	1602	1602	1616227560000	canonical
2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	2171	3NLKXoe7yE9wXxiJffLifz4HKVThXHAZ3asNHXEz9qEP1kdYr5Y9	1423	559	9	1	2129	jwEMNr44pRjdvdQZRhCbdyk6gyMEpg16FJztEpq1zvvVZNktvcR	1146	1606	1606	1616228280000	canonical
2175	3NL2tUDSFbfeuGGgUVVWxdZdNXnt4izDM3jgfAWxRfwZgK8Vfajk	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	44	348	9	1	2130	jx9uctYARXpTYF1etdRd3gF5Quxy3PXLUjWZotJLo2TdrTBEoXj	1147	1607	1607	1616228460000	canonical
2174	3NKH4L2LJRWhTXsnTLhLxWTnZoWXhFq1mFbcvN9EEFNoq5ETWH3Q	2172	3NKo6ZSFsnHjhxRSoxkxAe9DFUmY8fSVzdTBuaXjFU4vU5b3mm81	44	348	10	1	2130	jxMSqkr9fPgcZcziiKU7F256RWoRhmJMwUpRpT4JJmi5LFGkYC4	1147	1607	1607	1616228460000	orphaned
2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	2179	3NKdEgW1q52VfJYfsfznRX9atR92cvgLyr115U1T9LNJrqXG1x2A	1631	794	10	1	2136	jx5zBGTHYT6FXB1jcd5ge2XsmNP5KooskQ8qUa5j3EEwDa49WMG	1150	1613	1613	1616229540000	canonical
2183	3NLKJnPqw6t3CoZsTCebStvn1tHNH2faZUtjpFpbeeLVHe7hCexD	2181	3NLvJ35u8jJ5GZVXXdeANs1T3LvHGxYYzmny1hCaSoZvb2hadhYN	1451	1292	10	1	2138	jwH5tFKTD8jx7uPjL7WcLh11eWyUNhvma7WBEd6iGdNu9nNed9q	1151	1614	1614	1616229720000	orphaned
2188	3NLrMnMZimGspk5EZLUpLRmNp2NE8FLkjWG4ShXVRUN7vrGLscka	2187	3NLDz6PVD8NSuegTWMHJzJVDHgW1UH6v3yrtTDcxPj1K4jk5wFXM	1406	1393	10	1	2143	jwb8U7AGyuzMaoNBpJU4jAGirhgbVnKCRyNfwW5rQFHLY3oHCxc	1153	1617	1617	1616230260000	canonical
2191	3NLWZ7pFth3B621EN6LUqmoqTaMkHmrRr4syt5H7Kmh7UC9tWmQH	2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	1637	816	10	1	2146	jwh4VPkodrg9NoBAhACUkTXmvidjfdDAemuHo8kRW5o5WLQqo8C	1155	1619	1619	1616230620000	orphaned
2197	3NL5o9NvCPMeSj1up17otBhgYtZzh9ajBo3aoVEit8pEN1zq2RdN	2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	1403	824	10	1	2152	jxq67vfgpNibmz1A24Dwe3v79ApiTjULvFLJkqXYk9mM6GE8aNQ	1157	1623	1623	1616231340000	canonical
2202	3NLMWyk6ANLgMb74iVesqV5L5xpa6AeoXCuBVWoMTnD5JcEzKkMp	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	1406	1393	10	1	2157	jwfp61EJZpqfCXT8Nhhndw1rHBmQSisRTmeFcXbg8LWfR3Nvzx4	1159	1627	1627	1616232060000	canonical
2204	3NKGmukaWhwnEyKLNEVGeQdJWvV3Yw9773ogUMUXqczj8jHvV9ND	2202	3NLMWyk6ANLgMb74iVesqV5L5xpa6AeoXCuBVWoMTnD5JcEzKkMp	1648	1284	10	1	2159	jwhe7YLkxburZDTkiXnyXiNczzbtMwfPiYwtWRZbywzL6RCQCiu	1160	1629	1629	1616232420000	orphaned
2207	3NLMQ2dSpu837dLuNPfvEhp3x5i2xpLZfkkEhbF8tAKuwohYyKHp	2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	1559	1353	10	1	2162	jwhTS6rm3Bj4Z8BFMpXj7F34CapgPRiAt8QgDbj8htTe2vqDAvV	1162	1632	1632	1616232960000	orphaned
2210	3NKwrwn6uNKEo8ucTGJ4xeNwfzEkJwmgoa66zcvLsCENx4TmLeaZ	2209	3NKQ13KxonaamAd8FNWqWrfPcQSUYngpbYTLtQ42xn4Ma3z54nH2	369	1312	10	1	2165	jx2V7kBCHJh4rm8LUmrsSmqWTd4Kddewg7vZioQc2FDt3zz9x6E	1163	1634	1634	1616233320000	canonical
2214	3NLSffSzv8Y7pdNq38zxkVot6PMGPWt9W49HcoUW9AP9JDvW8yBw	2213	3NLggpkhQRJojptjJxQiSNAJKuoWRqvgSEmJYL7mpSguPotXCE4t	1405	853	10	1	2169	jxs8TDCq6PFpNk6CpPZRLsKtE5Bxx2rhV6SQXRLuXAbfK4AV4U8	1166	1637	1637	1616233860000	canonical
2220	3NKxYh5nKiTyyPJQ1tom6k2E3YyQkYSwkV7zQxgGPxfGRnhRSesW	2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	1529	1070	10	1	2175	jwpdyVtbTMbA2honu9f4vb1hbT4RmYCEgW4Gk9PDHEDe2cmxG6b	1169	1640	1640	1616234400000	orphaned
2223	3NKu1dAVX9sFMoc3PhwMDPc6M611uZs7L3936cS4myxxKGHb9zW7	2221	3NKtsQ1k4sRp46W8XMvNTiPc7cHqFcq8WjxcgrudfwsczADUfAif	1581	778	10	1	2178	jxJcBF9R3bcZovoDmr1FmzgtRc5aUHnUguCehcz755iAHWipTBM	1170	1641	1641	1616234580000	canonical
8030	3NKkp1d1WjnbC2y6hp57RuEcV9Syrr7znkyXFfJtPvEm7LifSnSb	8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	1523	1321	94	1	6301	jxMfPEueW87pWiqSFWZx2HPgaibaJcqZ4kTKMnbPN3yhBmfJs1v	4163	5878	5878	1616997240000	orphaned
9700	3NLtWNxvzfWgi6LaNqbwR8AiGbkLjAmtLKCezuGMWxxMiHdjwmJT	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	1406	1393	124	1	6301	jxGYWAVq8VBpAwqXvL8fupvuaXWLtGFXkExiVmdXc6jebyS8Pp9	5031	7080	7080	1617213600000	canonical
9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	9955	3NKoei6KBvyejQT2s52ureKRnhyPWmxRc1gAPNPXwNFokLPRLkov	1581	778	131	6301	6461	jwjXgxJjRqLM7urATqKsj3aR4Pu6fFH7eacgkbPPSXZeVQRksgX	5170	7271	7271	1617247980000	canonical
2193	3NLofcPTDsPQj7As8cB4C9ffFpYsTTxa9VSG9cbL7sWvxv5s1SwK	2190	3NKvnPDJLKNvs9fhZajNyZaqE4pY4dr9iqt8rkqNzpaoQnQYYL1f	43	944	10	1	2148	jxtQvkQg7pGkQjcrQmxjs4hedQTqLZbqJ8u5nef27EkFtrhs83Q	1155	1622	1622	1616231160000	orphaned
2200	3NKFEHjxokefN9pzTfBqED8YLDvdz8xT2P9W4BRZpSa1CYuuB5wU	2199	3NKRtcoTDsZcGNuduAHsfbvv1s6EFAzUzsUEAPb4NcDwiiVvqQDG	311	1181	10	1	2155	jwkuMdGJ6hV7PUpUUc8j55R8nPG8QfNsAyC3aV1UqPRhgfzQ6mX	1159	1627	1627	1616232060000	orphaned
2205	3NKRSyDQ78dUxcaWQxekuPNh2GZxJak6THFUwXFjk3cPGRYSxw7R	2202	3NLMWyk6ANLgMb74iVesqV5L5xpa6AeoXCuBVWoMTnD5JcEzKkMp	1403	824	10	1	2160	jxcc5Ad9dUgqzhstA9kJPrhHE6NXMYytgZiHDKmAJ9ztL8ymze4	1160	1629	1629	1616232420000	canonical
2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	2205	3NKRSyDQ78dUxcaWQxekuPNh2GZxJak6THFUwXFjk3cPGRYSxw7R	149	917	10	1	2161	jxB2UB4JiYcYNBoTZZQc4z73e7wRbtfNsW9ebg4nMtupeapWSgA	1161	1630	1630	1616232600000	canonical
2211	3NKnwjAA8fbJca19azkyRQM1oSrPszbRPFrEcLYitLaMUGF1s2JD	2205	3NKRSyDQ78dUxcaWQxekuPNh2GZxJak6THFUwXFjk3cPGRYSxw7R	369	1312	10	1	2166	jxNsDxjHMJ1jAh5GuFAdhywUQ2RtMMq5ei1jS9VZJtEkCvfYvid	1161	1634	1634	1616233320000	orphaned
2208	3NLNC8EFCn5TUvLQYC4F7agmJeEpjsnvRJjoJw5vForQYNNomg1n	2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	1647	1176	10	1	2163	jxxb65RwThnjv2tEaSJ686ZHU7MmhSrPpq5WBwLoBvfau58zJv7	1162	1632	1632	1616232960000	orphaned
2213	3NLggpkhQRJojptjJxQiSNAJKuoWRqvgSEmJYL7mpSguPotXCE4t	2212	3NL5haHxLL6bTVbRQCJw7rnzev1kgyvyTTNfgxmwRsbabNFLyqMS	1631	794	10	1	2168	jwQfwK5XByVZWqqQuYdJbZCoNghYm1aKTdByBhBooXt9zh4BQSZ	1165	1636	1636	1616233680000	canonical
2216	3NKJgdVoUrLPBGgE8UxY6REquBNG9k6KTe4c6cGGVv6tQp6UzdHv	2212	3NL5haHxLL6bTVbRQCJw7rnzev1kgyvyTTNfgxmwRsbabNFLyqMS	43	1310	10	1	2171	jwNqJPm8TNQg6zw1oE5MBQ9bJvtMtGWTGe8SXRMMeEN6sTzRTeN	1165	1638	1638	1616234040000	orphaned
2218	3NLBpNHhD8kz8KzzPv6hrujsHEHvUsXChqh64YpV5KCc35qagdgh	2214	3NLSffSzv8Y7pdNq38zxkVot6PMGPWt9W49HcoUW9AP9JDvW8yBw	43	1310	10	1	2173	jwehcs7F4J5qqFgTVLbLZqL7iJ1s76MmRQZmBtfvdekj4P6Z3hR	1167	1638	1638	1616234040000	canonical
2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	2218	3NLBpNHhD8kz8KzzPv6hrujsHEHvUsXChqh64YpV5KCc35qagdgh	1458	1197	10	1	2174	jxz73GKpdASyMQgYH2wyLDXDSR9eZ8u8iSrwQmmVCrBiamnKaer	1168	1639	1639	1616234220000	canonical
2221	3NKtsQ1k4sRp46W8XMvNTiPc7cHqFcq8WjxcgrudfwsczADUfAif	2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	1648	1284	10	1	2176	jxRQTeWw84YBvhhGitL65hZV84hujQKTskDGdCHAzZgby1ZTg1e	1169	1640	1640	1616234400000	canonical
2228	3NKVU3SC1X1wBZM71WQQ7XHB3ZbQXNtHDYK37ikbtYh93sTBuYCv	2226	3NL5fRzUBMnyywqA6UfBZwR3c2YSV6Eceg25hcSmX5tKoHn1ME8i	1599	1041	10	1	2183	jxemRM9mSZQajA2xcXbdCk3X4VJE72G16KRyS8yQpnxkKdgyWKE	1174	1649	1649	1616236020000	canonical
2231	3NKbTRH3Z6gr5iP2Nxk6f1pn5DrxCtRdKN5QgjapbxistaSSx8x4	2229	3NKRNc3PsNTC81fuE2xSVrwdddNgUSFi9sgQibRVKCbhwLupRooX	1590	1300	10	1	2186	jwuuYWwrQWC3S5f83KKf9fTvuKGBNuM59Br7sV4TGsPUHCXdtvf	1176	1651	1651	1616236380000	canonical
2233	3NKukLRAXjQmSvUCWSYQC6pbrbNgj4hL8vbeteWWwGoiwGuyDGKL	2231	3NKbTRH3Z6gr5iP2Nxk6f1pn5DrxCtRdKN5QgjapbxistaSSx8x4	1476	538	10	1	2188	jxhFpYcLhAbfbpmVoorhVcZW1Up3xgmDmE2bvRPXLfWx3ULjuXy	1177	1652	1652	1616236560000	canonical
2234	3NLPLJgUvaMMcrdD5Ksjba8YM6XYHrHFifFy1MmRbP7m4Mm5uvXq	2233	3NKukLRAXjQmSvUCWSYQC6pbrbNgj4hL8vbeteWWwGoiwGuyDGKL	1652	1069	10	1	2189	jwGVTbB4bhV38zDC9pNiMy1EYYL2Fd9XMZSXM1pDkx4bhLnF8dn	1178	1653	1653	1616236740000	orphaned
2238	3NLsKz5GE8z8dUR5SHCTJAxdLEXFr1edNfkTypXFshCjeAbRaWUs	2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	1407	1395	10	1	2193	jwucbxSmzh7kVTDD1PnLcbLuEftKLbzsHzKeAsNADqLMH2nGv1g	1179	1654	1654	1616236920000	orphaned
2240	3NKX2aMVAN2ouP1pMFMRV6uybA1BTniNArK8ZpRPGnvTRg3H8pun	2239	3NKQjW2wDnYaoL5WxYrq1cqdoA9hDFLRDsWrcvZhMXSrahthcXQY	1648	1038	10	1	2195	jxsKuwdujtqvfCkM2duymq1hpWEbco8rUFNXPWBYWX7pZr6fkDd	1181	1658	1658	1616237640000	canonical
2245	3NKZrBnRzBabrJsxAzaK59AfZiSFA4YbjuBgSS9EzWTxuej4jASS	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1672	1159	10	1	2200	jxYVNAy2BweN5n6Vof9EWoHMfHW2vf96VjseK71cbvpUZ3ebDjD	1183	1660	1660	1616238000000	orphaned
2253	3NKQ2j4VWAegtXhFbPNcjQsKmQvW6E4vuddj79ZTjVJExwFJvJ3t	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1426	1118	11	1	2207	jwCDnAKantSpX8qtg4G5A9WAdcoK3bk1FXVrz8xqhL3n11sk65n	1184	1662	1662	1616238360000	orphaned
2255	3NL4v85nQLYzdKesCqr7L5AYxkWWMWkSvdgv28YjfuKqJutaTT1h	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1564	1338	10	1	2208	jwGFq8mL9LQY2Ggxw6VC7xcjuSQhinMDkghEajgggCuJbK7U3D1	1184	1662	1662	1616238360000	orphaned
2258	3NKcMkbPXgiuPJGVeHKphofs4GA6dHpFM99wS7bkdgcWPQpx7TdG	2251	3NLbKjCPo4GqxBeyvvzQhNCjzgnwn9E4sEgo4AYEwVwnwPnqRpGS	1647	1302	11	1	2211	jxp4j6Pkre2yvzhVJZ7U7DAQ2W946GJhJZEqNTYsnFxGJbqK3mM	1185	1663	1663	1616238540000	orphaned
2263	3NLF49N5y13MsKHKvCpdWiTqFgdcz5FH6Vt7wMVno4nANXwKcjhg	2260	3NLvXky79agh2M1Qm63wfZd43uNYi5KVrzcBP248npJnSM2VAW2S	1643	1173	11	1	2216	jxTrNqZaemL81syoxZY4wrg5RbMruP9qRvzN9jyAfm9uzS8beRB	1188	1670	1670	1616239800000	orphaned
2264	3NLbqPRp8c8qE788WLC5yQwfvw9cydd4PbzdquUgZMzaQRBoeLw7	2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	1536	260	11	1	2217	jwcyT4wbhkM6UhNnVxJj4M6cY9sVDFdKpMUAxxLKziaxzVWRgbX	1189	1672	1672	1616240160000	orphaned
2267	3NL5Ew9HLJMSU623FRX1sFZRRdhfkAKGB6V2sodEstEftvL4eFvd	2266	3NL4tF5P8ngq8TdmM28Q3byhKi451eVa2qEeUoYPFG1rhaTxUDr3	1439	1279	11	1	2220	jwoWeiqr86zMD9ZDFfzDEbEMYBxiF6epp9746HAFAAiMTDpQYWv	1190	1673	1673	1616240340000	orphaned
2270	3NL6sqhT3qiVMUpe9cqdT3C3TJwLxm27AYFpWvajLZjPUoFDRcfs	2269	3NKRM3AYCYUjgZD8Cpegf5r2bGeBApC3wec8AJFK7T2V3oFR1ihE	1623	839	11	1	2223	jxHkqhYYaVdRDXEGCHP861WxKS1GcCSddFEAC36BVZLvjTQoRcn	1192	1675	1675	1616240700000	orphaned
2274	3NKheZx6xVKHARvYemE8ypY7hovB7a32R5Q4t1fjyxenTa53Hie3	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1403	824	11	1	2227	jwrf2quSjfyRjUshs21ox3tCrSBVQwM6RFVyyiFrqcoVuXoPWy8	1193	1676	1676	1616240880000	canonical
2276	3NLvELUYbrvpGZqbdFkXUoSN9CFwwStgiMozmnLBrjVofrgTMsA7	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1577	1327	11	1	2225	jy3JtAjjQmh6tS7fg95abUYvA7hBHmNQpy8bDbCCEtce3XCocCV	1193	1676	1676	1616240880000	orphaned
8035	3NKFSyrm7FnBgfRwTuZM1F9WMcvb5L2zZ8USyKojMbPaCzZDkgtn	8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	1508	1141	94	1	6301	jxgmDQa1G1cMrpxaEvCheXnKduUdjPZawJUoZUDARNXgc1PcjMQ	4164	5880	5880	1616997600000	orphaned
2241	3NKy5dzBN33pxRky3vxqeA4CcDmz4hThxVkjxQ2ftxpScVry5f3i	1818	3NKhMbBAgByBUTGTQQar3XnXitZFXfyjLp4Km2Wqb8yaUZHgGgWV	554	554	5	1	2196	jxTsauboK7xbWhpGtz466Dpf5cXTnq1gJ2kFvVzQcgUcZHVuybj	974	1658	1658	1616237640000	orphaned
2209	3NKQ13KxonaamAd8FNWqWrfPcQSUYngpbYTLtQ42xn4Ma3z54nH2	2206	3NLeqKPLmTsk8vaJknSTmnfdvzE3Fg5tGoJtqmY28A25SVQjrhDV	1516	1294	10	1	2164	jxWHEMwHTQRh7fWSwtEhnzCi6xD1NKdDxH4PZmHxkdfcSFzkuR4	1162	1632	1632	1616232960000	canonical
2212	3NL5haHxLL6bTVbRQCJw7rnzev1kgyvyTTNfgxmwRsbabNFLyqMS	2210	3NKwrwn6uNKEo8ucTGJ4xeNwfzEkJwmgoa66zcvLsCENx4TmLeaZ	1618	527	10	1	2167	jx4SvT4vCg4A6w23dXAZZ28o6ecvCCuK11WvdAQE72A1wrAMz3n	1164	1635	1635	1616233500000	canonical
2217	3NLsom31H7SA3VTdi5anHWycYQWi28a9DtkxyVFhHXaA8ceC2w98	2214	3NLSffSzv8Y7pdNq38zxkVot6PMGPWt9W49HcoUW9AP9JDvW8yBw	1471	1386	10	1	2172	jwoCNKvT8JQofy6bWcQpo9KNw4gG1j3c4VHurfsu6YPjR3CKuJB	1167	1638	1638	1616234040000	orphaned
2222	3NKF2t5mdRdBfP3UnkraenH82qMDUNNqDKCC13vxKeoZkUMdJNMr	2219	3NLT9hBpYenAxSfEC7VZAWTxFp7jfgbBC7WEZ45bYh3Ywfr9h3aj	1403	824	10	1	2177	jwBj5KW5VPy7Bn8ohbvoLyZpvzvTAGC9tEMS6reRhrvtjAky7UP	1169	1640	1640	1616234400000	orphaned
2224	3NLocL61xH48BrXTfDbq4fiSai4iSREDg1NQGoPxsC3JZh1yb8Ti	2223	3NKu1dAVX9sFMoc3PhwMDPc6M611uZs7L3936cS4myxxKGHb9zW7	1581	778	10	1	2179	jwQ3RWh6ARJZ1Tvsp8QwGo9mv98McbPj92s9emuEQyTAPRSPdR1	1171	1645	1645	1616235300000	canonical
2225	3NKijJdjMPSPygkjkkxTDwNFdgj9xhmpoCdXKNtmeqdSA9dGcsoq	2224	3NLocL61xH48BrXTfDbq4fiSai4iSREDg1NQGoPxsC3JZh1yb8Ti	1600	1246	10	1	2180	jxtR9U8pfp953DQ5Eri9xAJjCLBnKpaskoSW2TmnBd9R7Uhx3BA	1172	1647	1647	1616235660000	canonical
2227	3NKPWy3vDozYm1XapmuxjLhMa27BsnU7isZ872hgwhC9PsRbRFrh	2226	3NL5fRzUBMnyywqA6UfBZwR3c2YSV6Eceg25hcSmX5tKoHn1ME8i	369	1312	10	1	2182	jxfaJq4QsUtenKqxvDaEH5AKEyaHxZrcP6x4P6zHoTaQ83U9QrE	1174	1649	1649	1616236020000	orphaned
2230	3NKMtRHcP3WDFmpeeYhm8zTHUCPcD8PrrX25BqUTQxqAMoWZfUgH	2228	3NKVU3SC1X1wBZM71WQQ7XHB3ZbQXNtHDYK37ikbtYh93sTBuYCv	1513	1379	10	1	2185	jwPr7HTVdy3rYNg3j9B4eHtfdBNku865uqBb5pnb8hjdhhSm2uz	1175	1650	1650	1616236200000	orphaned
2232	3NLpLBGNKRadqH8saMdukzAQEHtEcxDi8DM5tzfh3gYSLH3EDCoi	2231	3NKbTRH3Z6gr5iP2Nxk6f1pn5DrxCtRdKN5QgjapbxistaSSx8x4	1406	1393	10	1	2187	jw6en121bZ71TPWQTptU2SoEic3HAZ6REck8gGmXdiBFtLPc7c2	1177	1652	1652	1616236560000	orphaned
2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	2233	3NKukLRAXjQmSvUCWSYQC6pbrbNgj4hL8vbeteWWwGoiwGuyDGKL	1607	982	10	1	2190	jwUXuEEZJdzy3RThkcCwStKoi5BWYdfKCnnS6MyHChXf23XRk1t	1178	1653	1653	1616236740000	canonical
2237	3NLUn5w1Mo7Y8UViwbRQtne88bJn3caoK8hDoJFQNxvta2E3BYZw	2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	1403	780	10	1	2192	jwbtBrFK38N79oaP3A2YFEQKAriFPzTBUDFCyjJq9HhLLEH9Zmq	1179	1654	1654	1616236920000	canonical
2236	3NK7PhhXj1PFHXAN2WnbiuVbhQmQLTrzQeipEPjEvU84qyNbfgXT	2235	3NKxTyPb5G899cLZpxgxiiqK9qvYSPNduoByBLMMt9rhFatsYZtB	1608	1163	10	1	2191	jxw9kxMwjAGQHVywPt3FZxFd1sv2eTL9QzZZRnEghFuvaSy7pHZ	1179	1654	1654	1616236920000	orphaned
2239	3NKQjW2wDnYaoL5WxYrq1cqdoA9hDFLRDsWrcvZhMXSrahthcXQY	2237	3NLUn5w1Mo7Y8UViwbRQtne88bJn3caoK8hDoJFQNxvta2E3BYZw	1444	1135	10	1	2194	jwuocwKJ1REJvSfTVbWNy47qejQLnQEHzP5eLhFX56fZHU31SQr	1180	1656	1656	1616237280000	canonical
2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	2240	3NKX2aMVAN2ouP1pMFMRV6uybA1BTniNArK8ZpRPGnvTRg3H8pun	1407	1395	10	1	2198	jwArGy8xYgX1p3HEDN6ksMtTb4sADAGdDURG7miDyZVgqZ52iR2	1182	1659	1659	1616237820000	canonical
2242	3NKHtepzcQfatseLyeSC2aPJVazKFjNmoJcdMh3f2H28ezKF1y36	2240	3NKX2aMVAN2ouP1pMFMRV6uybA1BTniNArK8ZpRPGnvTRg3H8pun	1406	1393	10	1	2197	jxaBtUEvJeRG5mV1P66bvUGXNT1vub8w1YmUV6rpmCL4JFnPFSo	1182	1659	1659	1616237820000	orphaned
2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	386	386	10	1	2201	jwUXvtspmR4AWVgKmbDoRsnCs37YtnZAK6bZ1tVdCoTjA2JgErN	1183	1660	1660	1616238000000	canonical
2244	3NLdE3rd6NpjfC6g1x6Wx4dnkeifuq1Nxk6uDr7NjsTk4oz12zzt	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1542	1304	10	1	2199	jxSA13Xyh75uviPAgq3w1XGa4eHjptoGwD1KRSCpbtNxRboT8sT	1183	1660	1660	1616238000000	orphaned
2254	3NLcWXkZUAFP7i37qnLu7DmaKUTWqfWjzBqXYmvcENHcBikkskPx	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1426	1118	10	1	2207	jy2MEHtb5cnaRiYsvbB1NXhXm61PMPXg71AWSB7TYC6jJ62GrnH	1184	1662	1662	1616238360000	orphaned
2259	3NKoG934G9AHdpqP4gMpdLnDx2BDh4qoSbUKn84kGRUB1Zo85QW2	2257	3NLwZeBnUNU1PEDa6bqTffKkG1FKRs5dS9NZ1h76xt3dPNZhW6FP	1675	1096	11	1	2212	jxrV3XCJKEK6Y7yuGHKwKyC5CKp7WwZyF9poFD4HMEF2dkiLCth	1186	1666	1666	1616239080000	canonical
2266	3NL4tF5P8ngq8TdmM28Q3byhKi451eVa2qEeUoYPFG1rhaTxUDr3	2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	1508	1387	11	1	2219	jwdeumoS2auWQw2hJCoZhNNe5VNUTRWens4wevVnhweBsL1URcG	1189	1672	1672	1616240160000	canonical
2268	3NKqEYukJcpX5EV6X5JadAuAGKYmv8Dehhievoo56WqD8BKhKFup	2266	3NL4tF5P8ngq8TdmM28Q3byhKi451eVa2qEeUoYPFG1rhaTxUDr3	606	1169	11	1	2221	jw9cQRTAwjnnfZ3RBDa8ikX2Jo31esZo2rrKfBxbpCUWHxhbe17	1190	1673	1673	1616240340000	canonical
2273	3NLBevui3G93viA3S8mymrFfmXYqBcLsriV2renzY6fdwy1qYSaw	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1501	1114	11	1	2226	jwY1FE2XopvarqcG5KZSHmQpBFaY7wcure6Vkb8PhUuU7pfdg7D	1193	1676	1676	1616240880000	orphaned
2277	3NLQYbL5AYdKBQ2w5VZaoxLoG51Ez7HHAiuaubbGdv42T7J5uHPw	2274	3NKheZx6xVKHARvYemE8ypY7hovB7a32R5Q4t1fjyxenTa53Hie3	1610	1314	11	1	2229	jxtwcaCeokw9wY9THhHAMPZqdE78MFnQrJibHmj1fhQgGtTMrzM	1194	1677	1677	1616241060000	canonical
2283	3NLMxeq1SJ8ApoUTCkbsuGKcmFPeSS7SP5zEsgEnirHu9F9bjCyG	2282	3NLdmCA4S8bvNoL7V1AmfmBZaYyQ6ZyLUp71vxcGrLHxCpGrPL4n	311	1307	11	1	2235	jwv1dsqF9eRM5sp8vE8B58oaV2qUiDeLgRBMbER4UdMHKnkBGU9	1197	1681	1681	1616241780000	orphaned
2286	3NLfRymnBVkPZE2MpejFWoAoLopUcfvw7e7gn6C3qCec2VsqC1Ek	2285	3NLCc9MUcDZktdoAcMxpKC1LCvCHhQWx7ht4DCoTPFw45FbozWYS	1406	1393	11	1	2237	jwy4uj5DwkKWwiEdUbs2ncSnQVr6Rgmo2sAiVbGCjMgYyitnis8	1199	1683	1683	1616242140000	canonical
2288	3NKsJsNcxFsGsWQfbrRPugPBXLqaZbop1gW1G7C5gDwsFaoiNUfu	2286	3NLfRymnBVkPZE2MpejFWoAoLopUcfvw7e7gn6C3qCec2VsqC1Ek	1455	966	11	1	2239	jx7av9pP1yEgHAEhuHgjWNJNPjsRTi3Pg2ZmcyuaQHnfkn3QPET	1200	1684	1684	1616242320000	orphaned
2289	3NLccPT2fspG64AvqRduhh9YnCRtYCRDTKi28NdYtZwvx2D6B8QQ	2287	3NLJUDrW8oguGVK1DmD7PLGVtdSsfYFQ8J7VAWKrCejMqmAxtLxr	1407	1395	11	1	2240	jw9tRbdsnM3n7ZeiFCEXrtiwak8aZ32kv52gLCGsZGKFTuhDTPT	1201	1685	1685	1616242500000	orphaned
2292	3NKttgbqfxiTStub71D5Fsuy4cWUXyXny24v6L2rYzvehcARhBMJ	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	1460	1324	11	1	2243	jw8t7UQakmV33QAvTXw6n6RtTChx4WNYapB7ydzttprfvt3RQDQ	1203	1689	1689	1616243220000	orphaned
8045	3NKRJ2RftUX8yDJQxiD9XspyzUhBPeVHV8oK96BRR2gKd8xFMrM2	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1513	1133	94	1	6301	jxhrL6TuVd9Ei2ZpAYMbALNb7Qy2ankCYX9Zyvkv2Sb4kQSsuJH	4168	5884	5884	1616998320000	orphaned
2301	3NKQNc5qKvp1NbScMWUNmxU47QWkVwnFJyqTs5EFKJ59FQS2Ns3S	2047	3NLVfrvu6Ss9CxRYpEyfaaUhQ4rMLXzR52HZTjCbJ6UpXsfT4ggr	1546	1339	8	1	2252	jx2qGFtARgscgqDsX6baMQHJ83uWaQtvp1kcrEJkbHzVmDMcMGv	1082	1693	1693	1616243940000	orphaned
2305	3NLpTHZ7NXyyP3sdZWLyJnaBrxTxaj4CceVQJKq8Pb2jrRoQde7X	2048	3NLp1CA7Tr5HdPnquVuK3BbnQbgWM4vyNfWrs7VqjbkUoQ78NUrb	1668	1370	8	1	2256	jxWGRVV81ZYDu8ZoGF71jWzVXEdFC4fryt8R9hpv88wzDhJ9P25	1083	1696	1696	1616244480000	orphaned
2307	3NLXTPneJ19mvstQ6NtDNrx6hjiFnmQVUy7PKVVjRr3ZFtdGNgiD	2068	3NKWFKv8Ksdw6pK3LFTi5kkxBZMJRvMpWwvThVLpLDFoJVXE8iSz	1668	1370	8	1	2258	jwZQ1KxZFDJVzdT34Qtx6S5rj7jeAzAkVf9JbVL6DqLoZsPJgJa	1094	1696	1696	1616244518725	orphaned
2309	3NKzLmoYVrKpzwWKQQ9PjfsyJPBSUibjip8UX2wt7vcThhMQYL7e	2093	3NL5q6hzcywVbzkY84wLV556MoUFZZViKBoG7QSGPbBiYursu2FK	1668	1370	8	1	2260	jxWXJVCxGyMEJT2tDqwm6hMt65pMrkMC2CNydLRvXnSGLUNuS1g	1106	1696	1696	1616244558759	orphaned
2248	3NLnNcLMjCmRNsJ2HXhexNuLsrGmnjKei3NvRZjFWuR6wwB52s75	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1553	776	10	1	2203	jxrD1KNta72cC6YLvW4uDNxQmai4SyLBZfSEYM1b7Z8k7Rxqsy8	1183	1660	1660	1616238000000	orphaned
2251	3NLbKjCPo4GqxBeyvvzQhNCjzgnwn9E4sEgo4AYEwVwnwPnqRpGS	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1507	1034	11	1	2205	jx31ji5VdT35ZdPFosSmi1ry6gnLd8xuNebibMhe7JXib2wJt9X	1184	1662	1662	1616238360000	canonical
2256	3NLfgteaeuYdEr78BebRRSd6ym6GJGZMf9JzDFPDLe6CT3fkiTcn	2246	3NLV8yEunpSJcT2QM6qChMXqNwSSyhR7XB8HjRioFUoTJvXKyZoc	1643	933	11	1	2209	jxC4BuG3UsJVMicYpHbMiBHyniRQvYGC1EwQX4umey6ZQMPCbnF	1184	1662	1662	1616238360000	orphaned
2257	3NLwZeBnUNU1PEDa6bqTffKkG1FKRs5dS9NZ1h76xt3dPNZhW6FP	2251	3NLbKjCPo4GqxBeyvvzQhNCjzgnwn9E4sEgo4AYEwVwnwPnqRpGS	1627	1385	11	1	2210	jwogSykwD2B3z3qaAYASCEBKc6ELKGAnUZsan7KYcHB19htNFW5	1185	1663	1663	1616238540000	canonical
2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	2260	3NLvXky79agh2M1Qm63wfZd43uNYi5KVrzcBP248npJnSM2VAW2S	1521	233	11	1	2215	jxdTift9PJVgJSDKBNMJ41u2P5F7CNS6WX6igd4o4rwsFWf3ZNG	1188	1670	1670	1616239800000	canonical
2265	3NL3oKLDiccBdPg4CeceNDQXEGifMpzSNC48mGBbnW6tKtCbRsWp	2262	3NLEN2fYrCtjKJrmpNeyb4dwicRLGnty8VMfX5ct2DS5Uw46XP14	1406	1393	11	1	2218	jw8KGMbKh6M8HsaAebRk5AWbEyVfnvkzEj5rHJHEDH25LhEYu5n	1189	1672	1672	1616240160000	orphaned
2269	3NKRM3AYCYUjgZD8Cpegf5r2bGeBApC3wec8AJFK7T2V3oFR1ihE	2268	3NKqEYukJcpX5EV6X5JadAuAGKYmv8Dehhievoo56WqD8BKhKFup	1600	1372	11	1	2222	jxSTQNoyUpCtkSwCkPG8T6mLX3LYHqUcoTWkzhyQJP8y4E9cgdS	1191	1674	1674	1616240520000	canonical
2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	2269	3NKRM3AYCYUjgZD8Cpegf5r2bGeBApC3wec8AJFK7T2V3oFR1ihE	1403	824	11	1	2224	jw6gcSnWnmTGZZh4uuojJWnLJBZN2NLFXz27xEy9KGH6fPbbX4S	1192	1675	1675	1616240700000	canonical
2272	3NLwaRJhwpyGqvg2cd3aDi6ZgK3dxj5rvsvvfhrPoyyadApCL6N4	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1577	1327	11	1	2225	jx7KeY4Z2uhnUwaFNP95LDRNocX8KriaLDWdm6ewwoMnAktvtPx	1193	1676	1676	1616240880000	orphaned
2278	3NLJA3HXDgn6K7b8PDNsxKDx9mjzuzEp9Vxq5TVbZ77uRdr5EFyo	2274	3NKheZx6xVKHARvYemE8ypY7hovB7a32R5Q4t1fjyxenTa53Hie3	1402	874	11	1	2230	jwuq4JVhjkrwyxdoqYNJiCcCVUFibfDgqxAKADNuupJrCvsTGz6	1194	1677	1677	1616241060000	orphaned
2280	3NLaZ85bsR7YEdyPASMgjiNpCAqjCVyaGYKDEMBfnUiATaW2Mji5	2277	3NLQYbL5AYdKBQ2w5VZaoxLoG51Ez7HHAiuaubbGdv42T7J5uHPw	1506	1373	11	1	2232	jwbB9RrDeTJXHwdAL1sMnqchBim4U5U5WRj473y2KQYx5gW8Jhv	1195	1678	1678	1616241240000	canonical
2279	3NKBrSJxmvvRgR2akaUpn5975EV1oAf8Rc2ovyAujgAp51yi89uM	2277	3NLQYbL5AYdKBQ2w5VZaoxLoG51Ez7HHAiuaubbGdv42T7J5uHPw	1522	1322	11	1	2231	jx127wRHkkwtoSRJH3X6g8wG1PueZwc2CV7ntzfnsEDyXZDE4uQ	1195	1678	1678	1616241240000	orphaned
2282	3NLdmCA4S8bvNoL7V1AmfmBZaYyQ6ZyLUp71vxcGrLHxCpGrPL4n	2280	3NLaZ85bsR7YEdyPASMgjiNpCAqjCVyaGYKDEMBfnUiATaW2Mji5	1631	794	11	1	2234	jxpRbwPU5TRtj764uw1TA4m2fNpJANUDcBx7e2UcC5kvAjh6ypG	1196	1680	1680	1616241600000	canonical
2284	3NK5w1JADvZiNQ3ZhNoRdWCvGsaPQN2E1nzDW3WxSZEDGEq9gCDf	2282	3NLdmCA4S8bvNoL7V1AmfmBZaYyQ6ZyLUp71vxcGrLHxCpGrPL4n	311	1307	11	1	2235	jxkXHdvqbzrPNRPMSEUF9M4TGL6qCShCgEtSNTDS1gpU2NJAE9T	1197	1681	1681	1616241780000	canonical
2285	3NLCc9MUcDZktdoAcMxpKC1LCvCHhQWx7ht4DCoTPFw45FbozWYS	2284	3NK5w1JADvZiNQ3ZhNoRdWCvGsaPQN2E1nzDW3WxSZEDGEq9gCDf	1406	1393	11	1	2236	jx4etXrp9mBaNuXULXnJknkHWAnooAux217XubcprsAs7spgMwR	1198	1682	1682	1616241960000	canonical
2287	3NLJUDrW8oguGVK1DmD7PLGVtdSsfYFQ8J7VAWKrCejMqmAxtLxr	2286	3NLfRymnBVkPZE2MpejFWoAoLopUcfvw7e7gn6C3qCec2VsqC1Ek	1608	1163	11	1	2238	jwrC2aep2VAfiYRz6TX4Mt1z1rnUkU4MLedtZj4Ew7uFKLVistJ	1200	1684	1684	1616242320000	canonical
2290	3NLK4d5yK1wHBKjjZNTLRk8TtRkH8KEZYBWBLqEk8Ciykr87hkJQ	2287	3NLJUDrW8oguGVK1DmD7PLGVtdSsfYFQ8J7VAWKrCejMqmAxtLxr	1553	776	11	1	2241	jwSCPqwYYa4ypSq8s1EADbqxpALt4vxfGMpVBCRH2WzM4PfBXz2	1201	1685	1685	1616242500000	canonical
2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	2290	3NLK4d5yK1wHBKjjZNTLRk8TtRkH8KEZYBWBLqEk8Ciykr87hkJQ	58	1281	11	1	2242	jwxrhMyihfhpK37VeU2LFN2UThZPToxBmS12U5r77rydVYdo7Xo	1202	1686	1686	1616242680000	canonical
2294	3NKSTn3uHhqBAVtMiYG8isyYEtx5ahNfKc4NLUdkoat54gPf8fTW	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	1553	776	11	1	2245	jx5enTqGEabEHhjqwh2v5DHg6gU8eaDRk3SzTs5XmfPeicuVqVX	1203	1689	1689	1616243220000	canonical
2293	3NKHxVvhYq7YhxVWHcN4BXJKcQr4Z7xmmCi6SpohFdJszX8b79P9	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	1406	1393	11	1	2244	jx2xuQkfR8tZpXhDSdjebU3zcdP22v9WMk4fvNxbCKhZMCC38qu	1203	1689	1689	1616243220000	orphaned
2296	3NLuPVxzAb6ZG65gki1Q3fFHSgso7Qf3CLAhRHS3n4VYFXXr4DTY	2294	3NKSTn3uHhqBAVtMiYG8isyYEtx5ahNfKc4NLUdkoat54gPf8fTW	1407	1395	11	1	2247	jwqcSzjXY1zpvocVpkCAoDvttQg6CMaRyPR17w6FkV4bw1WRXJb	1204	1691	1691	1616243580000	canonical
2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	2296	3NLuPVxzAb6ZG65gki1Q3fFHSgso7Qf3CLAhRHS3n4VYFXXr4DTY	1578	1296	11	1	2248	jwWsMm5jWuBKjQ3XbaGmv76MXhEJZYfpC3jNYHcgHZNvjG7GTtt	1205	1692	1692	1616243760000	canonical
2299	3NKTzgHp7dtPuLXZbTAFPk7CVvBiPnXWzGTsBFBJhvoFhHw3BZvr	2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	1546	1339	11	1	2250	jwzJVw3HQP7FUcyDhSNKWtuTXTa9nqH97oNmqiYWKA6zH4VEs2h	1206	1693	1693	1616243940000	orphaned
2302	3NL7JbVXyHz6ueLcZJ1wQmtb6Qn93PBZ8CsfWAMszwH9Zf9PwAdL	2300	3NLSoH3cpv88qtcVCvMNW3cR3mtFfRFmPCkCptiuLkxgi3Exu3Lf	1647	846	11	1	2253	jwVk4WGfcV6XwUYGCkevkNmZheMnPi866jvsoyJLyvSA3mGTiac	1207	1694	1694	1616244120000	orphaned
2306	3NKG4YkGQVssA1F1Mceum7oSMxQ39wEt4qdz93x3ZUiZGfjdeu7Z	2304	3NLjYkvKbK6ozU59DKabzkgJFZmh63Pf3E8Ly7RnECGW8FmDuKJz	1668	1370	11	1	2257	jwh7XW52eYM6gnGPbzcKzFV9fjey6ESXLr5LJD9HqjhNqej6Luz	1209	1696	1696	1616244480000	canonical
8044	3NLCRgTMGidwLE7yoym1Rwe2K63f63z2j5Lo12PAwr21Bc1hmVU1	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	576	1355	94	1	6301	jwKsi1YrH1tBZkk7qwaD8VnEoGKEYUp9Zb9ZCLXiDtAutDGywvJ	4168	5884	5884	1616998320000	orphaned
10251	3NKjsRVcphpQiADVgxRKQpF9B6H1Vhq9ZDjAjq6vkpFDY141cQJm	10141	3NLewUWUjiGRtJB5VWEdjVYqm7qciuAAmRL41mCnKRRYozhssi8t	1578	1296	124	6301	6728	jwWjo8u1GDhvd9t3ZM9nZBqpaAnjcsqitDSoQKK6Ea1AMRnVYju	5031	7467	7467	1617283260000	orphaned
9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	9973	3NKfRw4SyE9b4MB65F1UwnhuXT6j88dpWiutitrtzB5odtHLS2cf	1627	1139	131	6301	6477	jwJfTpaPiXESqoNgR5nqjNwYooJNdvpWa7x5HYHQj2CbfkytfB5	5174	7278	7278	1617249240000	canonical
10089	3NLJLnVLTmV33UKVrhjqVciYkcc4tBy7z3wBNwG4w97fsv2CxEfS	10088	3NL7TMc2w6fSk1dpVjhn2kKK3fVQYz4D3NDEyYUWUEKaDTtaTVbF	1444	1381	134	6301	6583	jxWWSZoSF7t3rPQzU5ehyoXkDj8i5ZHeRGrvuDUSLrTHqFNq4Pm	5234	7367	7367	1617265260000	canonical
2310	3NKu3LR1JgB9RWEDWt8dgQvj6WbLuCjGJKXpFEGQnNnjteASFe76	2118	3NKpXovFmQJZJGhmKFkgQE2mHAkkW5T2LVR252ZU2tRCPqpLi8z7	1668	1370	9	1	2261	jxAJpCFP8yPzkgfCttLjHeL5ifoTuGhEAEq4ft577ssjnhiRNF8	1118	1696	1696	1616244596821	orphaned
2313	3NLfDhWHemrFCiVDUWCxxbWhsgK7o7FwWkydCyqBtmMxMocB1NKa	2291	3NKT2fb7XUuGj534R9Yc5mfUPnij5nLB7RGXBzX2HDKRZ36W5F9g	596	1306	11	1	2264	jwt9ry4hsAL3s8D1QByRa1e3sQEfosWm6SQ9LCTsYFDtVDhHRaa	1203	1699	1699	1616245020000	orphaned
2300	3NLSoH3cpv88qtcVCvMNW3cR3mtFfRFmPCkCptiuLkxgi3Exu3Lf	2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	1670	1036	11	1	2251	jwrF9B4zj2Q6vGdKdJtmTG54V2EFsCf2N57GkZxavmMp42pcock	1206	1693	1693	1616243940000	canonical
2298	3NK6sN7Ym3KHgrgEHwJmG9GBNf9eVeeTrfG8bCbW4jrepj3KRC7R	2297	3NKJqLNWinHaC7rPQYqnnVwoZBuF3xcxMW8d7iqg1VRTPBC8kHxY	1483	1150	11	1	2249	jws2LPd4SNVqSXVUnzBQ2MN2ZGygf1zXrgmU7ozVHmELPzpHAt1	1206	1693	1693	1616243940000	orphaned
2303	3NKjM54fZPSk5PrL8YQfUoZvXivY7No1ui3Dn6zo2MYStRJ4HrHp	2300	3NLSoH3cpv88qtcVCvMNW3cR3mtFfRFmPCkCptiuLkxgi3Exu3Lf	1672	1285	11	1	2254	jxXmKXPS9VgUFjSjjGyeTq1Rz4MTU63FaYFW91PmZaHsmbKVTZx	1207	1694	1694	1616244120000	canonical
2304	3NLjYkvKbK6ozU59DKabzkgJFZmh63Pf3E8Ly7RnECGW8FmDuKJz	2303	3NKjM54fZPSk5PrL8YQfUoZvXivY7No1ui3Dn6zo2MYStRJ4HrHp	1503	1151	11	1	2255	jxUcZbLFo9PHA2oYaAFJUCLzVsJ9eLQqnSfF81KgtDSQMfKmTw2	1208	1695	1695	1616244300000	canonical
2308	3NKWXo9HihwiJkJLnrATMTqjL7FsAgy6skU7zrYfanDxnHU56ddq	2304	3NLjYkvKbK6ozU59DKabzkgJFZmh63Pf3E8Ly7RnECGW8FmDuKJz	1403	824	11	1	2259	jxvRzNsvqxn8ufkgFVM4HxMJu51p7E8vwwZmHtAmLjKfx12U5Wg	1209	1696	1696	1616244480000	orphaned
2312	3NKGEXE5oBYPab9EkSuojCv6zt6PrtbVYwsHL8nAgKH75o7qK7N5	2306	3NKG4YkGQVssA1F1Mceum7oSMxQ39wEt4qdz93x3ZUiZGfjdeu7Z	1596	1363	11	1	2263	jxcHeARgatpnorQMxFv2TmYYZDuE4VTEVeczko61trwAfqPfxJA	1210	1699	1699	1616245020000	canonical
2315	3NL9ZxvgMSPoGKEiGaUEadGsjUV78QRjk57bpWc5hDr3STSbC67g	2312	3NKGEXE5oBYPab9EkSuojCv6zt6PrtbVYwsHL8nAgKH75o7qK7N5	1402	868	11	1	2266	jxUqKnivWiZiShU1y3QxMg9KLEHX57gJD2R7HLsGzrwrDpHaGmM	1211	1700	1700	1616245200000	canonical
2314	3NLpM5Cr4mejriHLW4Z7VUjVa6WJ4yyJoYaEBtrwHbxn28mV5RdR	2312	3NKGEXE5oBYPab9EkSuojCv6zt6PrtbVYwsHL8nAgKH75o7qK7N5	1503	911	11	1	2265	jxatCJ69VP5Fg5h2YkE59MejA7LUQJ5ozXrBCQgjTHJBtkSKSoR	1211	1700	1700	1616245200000	orphaned
2316	3NLYomCQswhWDmb2Fi6p3UoSFtoZjNqDzeM5Gt7z3NQy7TiC6y1k	2315	3NL9ZxvgMSPoGKEiGaUEadGsjUV78QRjk57bpWc5hDr3STSbC67g	1403	823	11	1	2267	jwi12rGh9myJBZGZxGz3GLqQ9mZgRSXdihzk4JFeBxCM8uBMNa6	1212	1702	1702	1616245560000	canonical
2317	3NKri9Wa5nA4dmW1m1ov498WRw5CVWnCqidxvmDKkCWeSDeJ2W4h	2316	3NLYomCQswhWDmb2Fi6p3UoSFtoZjNqDzeM5Gt7z3NQy7TiC6y1k	58	1281	11	1	2268	jxJBp5dfTNnMwYv1koMgNPmsCckD5wTJk1oTHXreXxWw1P8LcEM	1213	1704	1704	1616245920000	canonical
2320	3NLfvtMZpXA57tRVKYmwaDmaeX6uo4Be7UbLHi89GVMLUUaAttpS	2317	3NKri9Wa5nA4dmW1m1ov498WRw5CVWnCqidxvmDKkCWeSDeJ2W4h	1553	775	11	1	2271	jxSgdSUTz6JejELBTyU4DSTPzjjPJgx611kc27npXQNKmYjM4EL	1214	1705	1705	1616246100000	canonical
2319	3NLKZJZNrWKCycF42nM752oLu41yNmw1xAcVUEgedUrc7TxknQLd	2317	3NKri9Wa5nA4dmW1m1ov498WRw5CVWnCqidxvmDKkCWeSDeJ2W4h	1622	1230	11	1	2270	jwDyYnFTaK8KE4XRd9ej1aDBo7v34Yt5SFPgN6CarrVbpsPBQu1	1214	1705	1705	1616246100000	orphaned
2322	3NLVFHFw5rju14AgqZ6cqBnW9g1Gwa9vPEbcS6yKwH2QnTD4BBg3	2320	3NLfvtMZpXA57tRVKYmwaDmaeX6uo4Be7UbLHi89GVMLUUaAttpS	1406	1393	11	1	2273	jxcp4qLyiVMxXbXoQ76L6dXD65QfsVPnuDbGid75W9Hrpz5hUzq	1215	1706	1706	1616246280000	canonical
2321	3NK43ee97c7SRCW5czvmw9vTweVrpVfqZzuJTvnHLasFjoM9Egnb	2320	3NLfvtMZpXA57tRVKYmwaDmaeX6uo4Be7UbLHi89GVMLUUaAttpS	42	1361	11	1	2272	jwDAKnfcPW4Dzz2Qm6caJQ4BR7gYTaCX8TXDYvcfpjKtqws5nQS	1215	1706	1706	1616246280000	orphaned
2323	3NKSwDZa7Fr5ByXjurpoKV1L4nyTkZuqcuZKANSFP91SEAWYmuV6	2322	3NLVFHFw5rju14AgqZ6cqBnW9g1Gwa9vPEbcS6yKwH2QnTD4BBg3	1457	1391	11	1	2274	jxnS7rMKVRt2Lc1WLhdJoKqzFvMwuzdukry3zZKJvfNvavgRqWq	1216	1707	1707	1616246460000	canonical
2324	3NKJhgqNgxRsUUyFXzDGofGq51QczwFQWzpsFnZuARKzUY7VUXFz	2323	3NKSwDZa7Fr5ByXjurpoKV1L4nyTkZuqcuZKANSFP91SEAWYmuV6	1406	1393	11	1	2275	jxGGvoqKhYRfzi8ahFFNnpyEww3xZkmFKsbMd7xC6G6XZwf3UU4	1217	1708	1708	1616246640000	canonical
2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	2324	3NKJhgqNgxRsUUyFXzDGofGq51QczwFQWzpsFnZuARKzUY7VUXFz	1419	814	11	1	2276	jxVjhoL6aPhRXqPhxocy12BvtP7zPNaQN2YtTpF8u3MYPM8SR3M	1218	1709	1709	1616246820000	canonical
2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1407	1395	11	1	2277	jxaV3TLTsytdHtB5rtKwih7tB4hUVdoVxWapTbhRjn5fTezpkWu	1219	1711	1711	1616247180000	canonical
2327	3NLqzFU7uxhTF7gADoieU2rjE343QF4yM86EjGKNXg8WVyt1eiJ4	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1668	1124	11	1	2278	jwESG8HStcj91QD3iiUDSPtCrqgdwrSnNt3BQbxRUkrNA59rEq6	1219	1711	1711	1616247180000	orphaned
2330	3NLbT51frYuvbDrphpSFrTakParBLMFkNfW757pPpGGWzGSBLwH7	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1523	1195	11	1	2281	jwkuV7198YcfXbbCy2GFN9H2jA2uLxZNtjwLZ46LDTf8Kkyx6Ld	1220	1714	1714	1616247720000	canonical
2331	3NKp3TAkeqy8EefTydGsVLpa7B8q9cX4T55ZGwouZ2CrmFXBn4RR	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1523	1195	11	1	2281	jxyRsRVjdXAPas49oBrLZktBFpM7xhrh95puSH6QruwHjgDJhXV	1220	1714	1714	1616247720000	orphaned
2332	3NLXBNjNBjQjuzTzZM5K5TinwGLZoVva1RWPvGhzZmCBbMd7YncX	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1407	1395	11	1	2282	jxAwLknAwkqijnGSVj8CzkQMvukSN6v452sq1QRGwaVMWYCX7yn	1220	1714	1714	1616247720000	orphaned
2333	3NKpJrC4jDGN5sE5xsJTraGRsQbRbDpTiYwFeYejVcesdK2zmEin	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1523	1195	11	1	2281	jxWemhbhMxjH6uNc1m4PgrgruQLrzpTpB6TqymaVFDowDgLzuYW	1220	1714	1714	1616247720000	orphaned
2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	2330	3NLbT51frYuvbDrphpSFrTakParBLMFkNfW757pPpGGWzGSBLwH7	1403	824	11	1	2285	jxUY8ZpZf9eNHnGSjVjhgJ9g3jViS23WKhoQ1rk8cpVAAWNaCWo	1221	1715	1715	1616247900000	canonical
8066	3NKvc19a4gvJKr4vZ7HJc72p2k3Lv9xZxuEeBdG6MobRxLVT5cCj	8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	1642	1367	94	1	6301	jwR67vATuawT4dmXCcnCToYWqYoWPhFRkzEXUGxmA4Z34csPLkd	4180	5900	5900	1617001200000	orphaned
9707	3NLu26DCC8FQ6to1eb9gdWvGGKE6UL4wThNRA78JxyrwhghwtFNh	9703	3NLd2tqBkB2ShqNz16yvsRVxcgayBuMDTYH7qD6V8o1bx3cu1iBE	1444	1381	125	1	6301	jxdWzDGhDx3JRKKTDWyzTwusNkvFABVRsNdKR8r6LvXPiofPk9g	5034	7084	7084	1617214320000	orphaned
2337	3NLCh3Y1V5p9GpnajMvSgditHkeW87hQhYMx8JmaxVdXSKBh2zQh	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	1405	851	11	1	2286	jxqu2DksmzbxpsgZrAdBTeK2UKRuoWCDL92wND3KXEVgx4GhZH6	1222	1716	1716	1616248080000	canonical
2338	3NL2RH22nbsefvHGNZWEpftkHsvHyt8eqgLpu4oYbncUpFGPJ7BN	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	633	1384	12	1	2287	jxzd7LFzi2TxoPEcdGCUbDbbKd9rLfpfieSdamW4UT11pCtC8P9	1222	1716	1716	1616248080000	orphaned
2340	3NKREiDw3UyJwDiPJa59CKhzyeWEfvcS8meMWkWYzVqEcngyWijT	2337	3NLCh3Y1V5p9GpnajMvSgditHkeW87hQhYMx8JmaxVdXSKBh2zQh	1578	1050	12	1	2288	jxBnmHxuYFCRYkW6dWhmDbjES49zqYedGJdWM7RaxSzS3xNArFn	1223	1718	1718	1616248440000	canonical
2341	3NLsfN7MnHkkBeDpN9RKxYdQaFqfGxDPA69phNXrHdCFhbbCAiR5	2337	3NLCh3Y1V5p9GpnajMvSgditHkeW87hQhYMx8JmaxVdXSKBh2zQh	1578	1050	11	1	2288	jxBnmHxuYFCRYkW6dWhmDbjES49zqYedGJdWM7RaxSzS3xNArFn	1223	1718	1718	1616248440000	orphaned
2342	3NKtc9p9hGV7j5wfRQA8PPGk3mURqxtheWeAuHHjxqnkddhLJAJy	2340	3NKREiDw3UyJwDiPJa59CKhzyeWEfvcS8meMWkWYzVqEcngyWijT	337	337	12	1	2289	jxc6xMXSUYk2hMAGQw9eDRzgNf82ee61ZHRNpjDjrWds7FeXrRA	1224	1720	1720	1616248800000	canonical
2343	3NLCHxUrWiptLTNQL1PpNQodUhNwwBBBXJFNjSifaaZzqQnhdBK1	2340	3NKREiDw3UyJwDiPJa59CKhzyeWEfvcS8meMWkWYzVqEcngyWijT	1513	1379	12	1	2290	jwhwvbujFqRknF8XQCPi9oaLsJeBAbi4vhAWFrNgLcd5t3o7fWa	1224	1720	1720	1616248800000	orphaned
2344	3NK5Uanwf5DzvDZWVgEk9NfWpku1FxPNAdqKfUQPLQetQdEe4myv	2342	3NKtc9p9hGV7j5wfRQA8PPGk3mURqxtheWeAuHHjxqnkddhLJAJy	1403	782	12	1	2291	jy2GUg1Jv9G5S64QRgxUm11r4SG24fJ6sa8APTBUc5Lcxm3oh5T	1225	1723	1723	1616249340000	canonical
2345	3NKKZnnihvQmt9bE1PX15D3m32fTz2hT8jptNZFpi6YQfNNEW7H4	2344	3NK5Uanwf5DzvDZWVgEk9NfWpku1FxPNAdqKfUQPLQetQdEe4myv	448	1305	12	1	2292	jx4pUmzJ9DDALrEvJKk9VAMjXDWh9THvLnBXfRoQD9K6iGzV7m5	1226	1724	1724	1616249520000	canonical
2346	3NKPcqMXHRNKi3pCihFZ8o14XdsjdyDuSdA2iP5hb7orai1ohmTY	2344	3NK5Uanwf5DzvDZWVgEk9NfWpku1FxPNAdqKfUQPLQetQdEe4myv	1560	1165	12	1	2293	jxAgKUxB3gDgYB3AV1sYhEGfUKEgPy3PEQ82RhU6oH5fSSK9a3V	1226	1724	1724	1616249520000	orphaned
2347	3NKXFhWCDXoQTbXjbHadgBi1y9pYbB5cm3FYD61tGRCGv89xEo94	2345	3NKKZnnihvQmt9bE1PX15D3m32fTz2hT8jptNZFpi6YQfNNEW7H4	1670	1036	12	1	2294	jxoFf8fkeCbutGFg3c8V7BM9toz1wcqWVdX1mtyAHTyBJronWxr	1227	1725	1725	1616249700000	canonical
2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	2347	3NKXFhWCDXoQTbXjbHadgBi1y9pYbB5cm3FYD61tGRCGv89xEo94	1489	1380	12	1	2295	jwWAWzuhW5kWpWXUVFwtVZdz38vhzauxn64DgwZ3miC9w8RTUxk	1228	1726	1726	1616249880000	canonical
2349	3NL63pX2kKi4pezYnm6MPjsDK9VSvJ1XFiUaed9vxPEa5PuWPLeZ	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	1405	867	12	1	2296	jxDVQTPMRvwUE94shJoo2Li5qj8et4x9zeTAgHRv9sKyAAWkSpj	1229	1728	1728	1616250240000	canonical
2350	3NLgw6854WzMpf5x1FCkpn8U6Xob97nkUDKt6GzWP5SUiQcVk49a	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	448	1179	12	1	2297	jxj27ksY5YrbbiGfeMqNEfcBWTWEzKm8fEuS5xGpZYXBJxWBSTm	1229	1728	1728	1616250240000	orphaned
2353	3NKcSppgUnmuGp9kGQdp7ZXUh5vcf7rm9mhKE4UMvwcuUaB8wb7S	2349	3NL63pX2kKi4pezYnm6MPjsDK9VSvJ1XFiUaed9vxPEa5PuWPLeZ	633	1384	12	1	2300	jxxmhG3gRiQ6umwZw8CSDdNWisGqore5BsrjUhq2gYeBXsNULDy	1230	1729	1729	1616250420000	canonical
2355	3NLN2uxCoRsiB2C4uZHDcY6WxJDz6EEWmoruCFva74E4cgTYgJCQ	2353	3NKcSppgUnmuGp9kGQdp7ZXUh5vcf7rm9mhKE4UMvwcuUaB8wb7S	1445	1044	12	1	2302	jxjTmcrTjmqGWg3aCEEu6KfU4DMGXs5FUFrtmy5mBxwdhDytXc7	1231	1731	1731	1616250780000	orphaned
2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	2357	3NK86abekKmd1YqdWxKVLUgCpozLecksYDWpmHEXfqXoQxz8Xkig	484	1073	12	1	2305	jwCVcccvEQzv8fBeb5pa9eqpZXqBPyfYT5xniN6Wb74m5HpvcpJ	1233	1733	1733	1616251140000	canonical
2360	3NLZK97Jn2h2eZ8tMXdYF7YL4RdNCR6qg9qnd3kWV5Kj7d3SPHBG	2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	1406	1393	12	1	2307	jxPZJWWnbW3umhGEdJbkHBHoUF93q6bnvELu1Z2FaREXCUjACgu	1234	1734	1734	1616251320000	orphaned
2361	3NKUoCo6rbrr7ehvvsaEFca2xi66ZuVWtzgnFJpB5KBko3i4tMge	2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	441	441	12	1	2308	jxPKyjoT8kbiH1nMJjgAvEa5sXPNWZazfwjfTj3f2e9fmzptcFV	1234	1734	1734	1616251320000	orphaned
2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	2363	3NKj8gyQ9XnEE4mEZndz1GqGAjAoNsPcvXe7RGw4EtskDNRLxiUy	1553	776	12	1	2313	jwRqp5zTDuchVJDASK8ZVbhV496JfHPqvPQxVe4XECWSL2gqBNL	1236	1737	1737	1616251860000	canonical
2367	3NLkDbui2U3u1vHMyztWPAuzMXiiADfaoM3rTqVQCNbNrbaBc5qb	2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	1405	849	12	1	2314	jw7bmg1EitkGx8fkxLKVjZ33NwwDWqYH2GKsTYjW9CsQqFrnsh9	1237	1738	1738	1616252040000	orphaned
2369	3NKehaXcNfPoFA62epxxGbwnjisABcW5D54NAeQEbWyaQaaDaPxj	2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	1579	1389	12	1	2316	jxAtk9fUBSoaK4jGC2HvPDna5hZ7TEEYnEremQLERWRdLNoudya	1237	1738	1738	1616252040000	orphaned
2370	3NKRGXqsifh1tbRV1wRknpJbYLhXJihKpxwNF3RtdFSN1PuiXPab	2368	3NLW85Ei8yMj68owaRYbvNLwbAvxP6hfF1JfZKiWVJKcLZSkXKJf	1553	776	12	1	2317	jwW5eUGaAw1AKPDXS4Mq4hxk26WAzY1Qaxb5yCgXABf7pn4h6bq	1238	1740	1740	1616252400000	orphaned
2373	3NK6RY1ekrfEmmrcJyQazhXrJvNJjuTS4VPQZGUGK3xEPaoHQPKY	2372	3NKwKYGxLZhgYVnHW3tLcrTmXMXWsc3YvBFhib7QZCgXH8BxoZZa	1403	786	12	1	2320	jx5MRuERNnr1TusN8hS53PDQPt7Ctyv7mpjSo71jib4ZR3eZJsv	1240	1742	1742	1616252760000	canonical
2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	2378	3NKP6MrKzzDyUuH5XGx5VtxpkRkXvLQzf4zj8qqYeZsQ6Sp5ky3D	1587	1231	12	1	2326	jwR1Q1TE2EFQ9D3rVCpdEJ49WMEtg3K5fyTVFHmceWkxtaHknxS	1245	1747	1747	1616253660000	canonical
2381	3NLDeV1DXXeQ4JkwmcpmDRVXfhFTUejvj2BBbT3nmoV4rHtPMsuS	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1546	973	12	1	2328	jw9p6QPLC77VmMXSJWQLHbK5oXbh4ytJarsd1XKGtpmmjicqzSJ	1246	1748	1748	1616253840000	orphaned
2385	3NKDJJFfAsLm3WySnMATb3DZ2KX3vruh4ewvk7VJkNvyma14bHpv	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1536	1313	12	1	2332	jy1sBpfx37fr8oVFs5p2y79po52BqbWVnZq2w89kYs77JMrPC3g	1247	1749	1749	1616254020000	orphaned
2387	3NLDo9UtwBhWA24AaCxWcKEnmnJDJSEtmc9gg5bA25xiACW1jRvk	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1646	1108	12	1	2334	jw7wEVr2JAYFwiEB8oH8nBqFdp3sDAUHoKwFw33MaVMYp9itjQc	1247	1749	1749	1616254020000	orphaned
2391	3NKEgw5JmSBUTQtfjMTHWHxwacvNyTtE3DUGgN4DwbFXocgkJYCi	2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	1555	1101	12	1	2337	jxQ8ZBeGsLnPLDrbuV2eYVfjoXHMSMd79yhsJg4dsQeL8BCfQ8k	1250	1752	1752	1616254560000	canonical
8094	3NKqmPgE1mMreksdJctH4moSdUCRnaqVm3RFy6MrWYZV4yJA2tPU	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1490	1274	94	1	6301	jxFTabqWYoMnCNfwr5Rn19kz6DsDupSTDnLtUhRoMVnC6fjLZkZ	4196	5920	5920	1617004800000	orphaned
2356	3NLc4kGkfWUSrtaJVUMiaePDnDqLfBJXrLStvoCCG1SPnKz1Zaw2	2353	3NKcSppgUnmuGp9kGQdp7ZXUh5vcf7rm9mhKE4UMvwcuUaB8wb7S	1643	1173	12	1	2303	jwZHsaQuxriCMGVj1nGUepE3LwN7HyesnyiTeVbkkZoUUBCgKZ9	1231	1731	1731	1616250780000	canonical
2359	3NL5bL9hMDtsXtaTKP8ZGoRTxyo27pcGab48oMYGjvEc5kWUxJcu	2358	3NLfXpsfiXJB75jC8mSnqDKE5jnZf3o8ikVRakpBnqBS2oN6vASQ	1670	1282	12	1	2306	jxKr9W8mzzS7JGZLQ79ZD53TS5cVKRmje1eejhAAQRyhyX7k2qg	1234	1734	1734	1616251320000	canonical
2364	3NK9L314QdpWLVTwcoaJfaDFY9EFEnCLYSQShe7uU1dm2mm49jdU	2359	3NL5bL9hMDtsXtaTKP8ZGoRTxyo27pcGab48oMYGjvEc5kWUxJcu	641	1210	12	1	2311	jx2ZX67m5T5qBRze643w6vyP2Wd6ZPtdqVN3n121pZphpQAK1UB	1235	1736	1736	1616251680000	orphaned
2365	3NLBMrfeNnKMxYqrJZNne9fDtmbUHYSsuuWWk4vqE7nQF787H8Ed	2363	3NKj8gyQ9XnEE4mEZndz1GqGAjAoNsPcvXe7RGw4EtskDNRLxiUy	1490	1148	12	1	2312	jxo3c4E7Ao6xFbU5LhmnsJpqU6A7dxSerd8bAMrGehZ9P2riQpW	1236	1737	1737	1616251860000	orphaned
2374	3NKLqxrUy4173xKenmGQyQqzR4Xyx4FQudizDtSvnhmrsyDLx2Dw	2373	3NK6RY1ekrfEmmrcJyQazhXrJvNJjuTS4VPQZGUGK3xEPaoHQPKY	484	1319	12	1	2321	jxc2dB1gD4nfc19vd4gbBDv3ZqEzcd8buJJ6qWLbwS7WQau7Gk4	1241	1743	1743	1616252940000	canonical
2376	3NLGcqcN79SJ3SehVUfrSYDHtR5wXhpBNQcgBto26tz32DHLTHUs	2374	3NKLqxrUy4173xKenmGQyQqzR4Xyx4FQudizDtSvnhmrsyDLx2Dw	1483	910	12	1	2323	jxtmeTEjVyFm4w9t4cGoCqHtBEdi6ZyrErepkc7xWP5Z7qve4eK	1242	1744	1744	1616253120000	canonical
2377	3NLgJ8ZyzRvk25Aey5H1428CVopG9cNS2SbxRg5JEQz2V87gPj8A	2376	3NLGcqcN79SJ3SehVUfrSYDHtR5wXhpBNQcgBto26tz32DHLTHUs	1522	956	12	1	2324	jwKQMWA87DjiqfdMWV8MfTu4WQZVNMHAaGHgbS5yNb1Kou7Mdcf	1243	1745	1745	1616253300000	canonical
2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	369	1066	12	1	2327	jxV5NnpZFUyDFzUjquXAyPPRDg4LX99XbGMZH8HwbkM6JqfVTjg	1246	1748	1748	1616253840000	canonical
2386	3NLcJPZbUEq2d9oJvT6eKWXKvyc84dLpTEvnsrJa3qu3mz3WJdgU	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1651	1175	12	1	2333	jxaXi5noYNc4ePcAQNxsUcJPHHAZjQyMVX4PoawbVM5RVL7KSSv	1247	1749	1749	1616254020000	orphaned
2389	3NKWMXKre38zKQsuc3NKgB5Qo7FZpRfViLTGPScPT7XgLZYFwZ22	2388	3NL7ukHkoYRGx8kfyBTNUoiBV8VLuYwuUAnzuRgGJPxpBbJHP3C6	1406	1393	12	1	2335	jwyaChrz4fEqPYqjsMyqgXingiGJjwSvnGBo7osf9GDh64qk9Bn	1248	1750	1750	1616254200000	canonical
2393	3NLYyUATtG44YrvTF99zyks42QsWVZFN4XhUZRoDfR2cBBNsjA2D	2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	606	1295	12	1	2339	jwurprQ2mjnE8QpiHxSCb7PtxTCNn5GA1U865BrUYZGkp5m3MqV	1250	1752	1752	1616254560000	orphaned
2394	3NLvLfE3Q8mRZQA6qJrJAFxtjVV9bp17n7waw8EHvgB8B7wF2fJF	2391	3NKEgw5JmSBUTQtfjMTHWHxwacvNyTtE3DUGgN4DwbFXocgkJYCi	606	1049	12	1	2340	jwrek1jZmpu6zEJ5dToGyyu9Xyh7RvrUNN1ckBd7YFXhrh8hfvP	1251	1753	1753	1616254740000	canonical
2395	3NLEwmWntnxymPZZEfcAoqDdF5UHVQKStXBEUg1CnBMrLRAwKKbt	2394	3NLvLfE3Q8mRZQA6qJrJAFxtjVV9bp17n7waw8EHvgB8B7wF2fJF	149	1283	12	1	2341	jxKikGPoDsaEyJ6dV6wnwa4oZqkqjBGM2HQJx4J414ZNE4akDm1	1252	1757	1757	1616255460000	canonical
2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	2396	3NKuxDtz5chnP2fidKTMVPsQXw2vuyq3vCcY7ULr63o8Z1N3FRMa	1458	957	12	1	2343	jxFpq2vZ22sHRjtGHbTHpvtkQzbvXGkWyUVtsmRzgHKv9zFAGNr	1254	1760	1760	1616256000000	canonical
2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	1407	1395	12	1	2344	jxmh31EeRnwzu6UE7r2QKY7pG4HbNTsguVZ7Vm51P7dMfKeTZhj	1255	1761	1761	1616256180000	canonical
2399	3NKLgRBMhJi4aRsQYVdELsJ5uRGXV2W468MGuuzaSQ1rkWTF6S96	2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	152	1084	12	1	2345	jxZ2ixAKBtmsGBcJkvxzWfUSi56sKiPEZrXhHR9Higt1etDFwci	1255	1761	1761	1616256180000	orphaned
2402	3NLg3srSk5EpTeMcRqNgHDhf2ka8fxkVPjg8kT4xTZ4QB8zx7bmB	2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	1500	931	12	1	2348	jxVbFPmjdUuHbwYyA6J3iwbUNTSJkJQ5bkcbtN9HvhAyLvMDkic	1256	1762	1762	1616256360000	orphaned
2406	3NK5g2Ho8FJyRPnhCLEcmf4n8LXttDDoApRRqsNo1RtDsnMSVXoX	2404	3NLy3FquFRPv8RWVX1TPBbLS6edcr8xA1osnxcKdh3tGcZpysBqd	1631	794	12	1	2352	jxas4tK8aBG7pRb6ocmcnJ7F4FmqWGTALc2Fqjhgb6yWTMazxAb	1258	1764	1764	1616256720000	orphaned
2411	3NLpT8K8yryr3K2vBZeh1cjRbn3eqxFwpzzTkGydmN5WimyG3Wsf	2408	3NKVonfJehozeGHFwyxTAn7PqHqdGbp6xzseLuq9UkZF8VnoJ9TL	1634	1331	13	1	2357	jwfdTvx2ffVoAveRXXmz4tYysrYeYsdrzbstix9Z5mg19btvytK	1261	1768	1768	1616257440000	canonical
2412	3NKA5zZvqzBAGPHk5182tr5sYZbkdRsUwDSjV8nyJ9cEFwV52Hmb	2411	3NLpT8K8yryr3K2vBZeh1cjRbn3eqxFwpzzTkGydmN5WimyG3Wsf	1673	1368	13	1	2358	jxZxNZEpHtQcTHW5ENqGgyftfgFFFtLxyd3f7rCvMj9RbfB9ELS	1262	1770	1770	1616257800000	canonical
2414	3NLCUGwFJgkDBJPJR3WtnsXFtxLhqTMYgx1nPfJEdAZQ2dp1Mo42	2412	3NKA5zZvqzBAGPHk5182tr5sYZbkdRsUwDSjV8nyJ9cEFwV52Hmb	1406	1393	13	1	2360	jwRCBqLb3Jtnxk7aFjgThvjraiLwuChQcPt7X7NmTpVS599L3gR	1263	1771	1771	1616257980000	canonical
2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	2414	3NLCUGwFJgkDBJPJR3WtnsXFtxLhqTMYgx1nPfJEdAZQ2dp1Mo42	1490	1274	13	1	2361	jxmt56XcWwa7YDQ96dGmnjF3V4XpS2WRcw5mhyYGosFFhdYmaHL	1264	1772	1772	1616258160000	canonical
2417	3NLBdvgbPcr4svJBfwFPH7jdx7xCWq7Ypv8ntsy1H6WmZaqZL2Kq	2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	1490	1028	13	1	2363	jwQGcDBf4AtBwyMVoBBop3qg5fqwTfsgnYLvEFLqN6vWK2qUvL4	1265	1774	1774	1616258520000	orphaned
2420	3NKnyC11b56P4JbUscU96dKevWxzS1nQi56U7a9psLK2FoRc9VKA	2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	1649	1017	13	1	2366	jxN4DBRHvwLMEUwxEXxYePmzUW3wwdcguGuriT3Z253YGS8VnVs	1266	1776	1776	1616258880000	orphaned
2421	3NK8f8w1qzrBPaGs2TZHT3Q9fM222A2gmwZc1e12syWfKGtZxEbp	2419	3NLFAPiMDdxGJptGdwnTTm3fhvUGSuZbcXjUMvnJzQWr944CvexF	1534	574	13	1	2367	jxanfPt3LEXf6Hq4vtBg3exid5JtYGjRoFfFtHrGvDnF5kmiGyb	1267	1777	1777	1616259060000	orphaned
2424	3NKtQA8qch6Ym248uHWR5kjoLZuuQ2cmcV47GnFWPqtmfBumX9WC	2423	3NKz8FZSGQCfKmBVfaE5xexn2z2zXhqw4mgqCujvSMa81gNWXgVo	64	521	13	1	2370	jxfWN3RyL3w7XpPw2x38otwbe5PhQLHeMBsyqkxFQzRhzrDoqTU	1269	1780	1780	1616259600000	canonical
2426	3NLmKN1TRb8iu1J4DGvj8wJE3cTgeAgawjDMrcHWAWriEtkJCNiB	2424	3NKtQA8qch6Ym248uHWR5kjoLZuuQ2cmcV47GnFWPqtmfBumX9WC	1637	816	13	1	2372	jxDL637dwmkf2zGsqhjsTpw4swb4MD8Mgz8K38MASdjbapWn5Qg	1270	1781	1781	1616259780000	canonical
2427	3NLbWvma7S6oJEGi7ZJ9tkErQCZYqAa8WtfGAUyyBqxUNHqDvy5t	2426	3NLmKN1TRb8iu1J4DGvj8wJE3cTgeAgawjDMrcHWAWriEtkJCNiB	1500	1297	13	1	2373	jwPox4sTzfL9wsJdcgNxuRRLeVi6JeJ9aFGgX5RNT7X86cYUCfK	1271	1782	1782	1616259960000	canonical
2432	3NLu29SX6DShG5CvM7snyjvWEMEhCsEE3uwvKanzYLsWH9g2L5Dk	2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	1613	1349	13	1	2378	jxLrsVJMWGbZbiWMUCN4TMPQPkcQozTmz6Zw2E4rEuYWbGrmH97	1273	1784	1784	1616260320000	canonical
8153	3NLh1BmGjs2z1pLHFk9fuPCjoDMwEQFeX9FbHTfSxjoHLY58nSEz	8104	3NKVyZkwc6ZqyZU7q4judUTd4TvkMymewKthakvhADN94FzetG1u	1657	1344	95	1	6301	jw8Hffv84WpvtpsrdSYwz9FSWbLf9hYfDBsRsRTxXMBQJoXemsx	4201	5966	5966	1617013080000	orphaned
2363	3NKj8gyQ9XnEE4mEZndz1GqGAjAoNsPcvXe7RGw4EtskDNRLxiUy	2359	3NL5bL9hMDtsXtaTKP8ZGoRTxyo27pcGab48oMYGjvEc5kWUxJcu	563	1359	12	1	2310	jw71M8kZMM33PRkkGLbZfEAAK1AdJMjeqZEocXdhmKXh7C8GQnJ	1235	1736	1736	1616251680000	canonical
2368	3NLW85Ei8yMj68owaRYbvNLwbAvxP6hfF1JfZKiWVJKcLZSkXKJf	2366	3NKy7kv1ei1pry5K5xXTFvtufvxKUaFchoFqwx5sPZhjxbZZFEu9	1657	1098	12	1	2315	jx4Sm1T5C9NMXu3mNLdrcGfTmg5Rf7AN89wJKspCWrB6ctHL72T	1237	1738	1738	1616252040000	canonical
2371	3NLfSpXGvyQHuPCjceCXJKfWgMVbrz9QxPX1uXnv1FbV9LBoExe2	2368	3NLW85Ei8yMj68owaRYbvNLwbAvxP6hfF1JfZKiWVJKcLZSkXKJf	171	1374	12	1	2318	jw9MQv1B2z62ZCzo5WbQV8Cg7Xgxdq1i1DY8nWCT9KvvoN74wXN	1238	1740	1740	1616252400000	canonical
2372	3NKwKYGxLZhgYVnHW3tLcrTmXMXWsc3YvBFhib7QZCgXH8BxoZZa	2371	3NLfSpXGvyQHuPCjceCXJKfWgMVbrz9QxPX1uXnv1FbV9LBoExe2	1403	824	12	1	2319	jxJ8EF2gJRn5dTqgk7UZbgrGkQuXuVKH4uE2NkuH1aHNYgGZuC4	1239	1741	1741	1616252580000	canonical
2375	3NKBNzQGyrUnuaHd3TP48Vju3ynNjbhMCzNBnorjeagaxXLT9fok	2374	3NKLqxrUy4173xKenmGQyQqzR4Xyx4FQudizDtSvnhmrsyDLx2Dw	1407	1395	12	1	2322	jxGXi54ozY6AM3UAg9DWAkTFc5uBs6HAxAggHmz7hUddz2SMtcW	1242	1744	1744	1616253120000	orphaned
2378	3NKP6MrKzzDyUuH5XGx5VtxpkRkXvLQzf4zj8qqYeZsQ6Sp5ky3D	2377	3NLgJ8ZyzRvk25Aey5H1428CVopG9cNS2SbxRg5JEQz2V87gPj8A	1606	671	12	1	2325	jxBcDDCSiygVxx2qRYSJRZyhiyQN4bD8hvgcX9J5DShoM5CyZE4	1244	1746	1746	1616253480000	canonical
2382	3NKNeQRhuqNeW9pXavUradsdyBuf9WfN1AhwZ3iWCtXmdFtWsCDB	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1673	1242	12	1	2329	jw6iQSn6YAdnEGHQzjYhdiu3iGPvcGhbPiVFzYgG7sHTcXra2Vx	1246	1748	1748	1616253840000	orphaned
2388	3NL7ukHkoYRGx8kfyBTNUoiBV8VLuYwuUAnzuRgGJPxpBbJHP3C6	2380	3NLgsnhN54DHvHrsYNfAR4ZPaMZfqsah7JZGG1jtovUoppsZfGje	1651	1175	12	1	2333	jwkkJdfyBwg5oKwxLQ1UStdSYuXzHF61qwMPNvQj1jY9Yw3x7pt	1247	1749	1749	1616254020000	canonical
2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	2389	3NKWMXKre38zKQsuc3NKgB5Qo7FZpRfViLTGPScPT7XgLZYFwZ22	448	1059	12	1	2336	jwEvhAg2KkkE8nYZq5Hq1rHAW3UHpYgZnQfLb9kgwwDp8f8mR1u	1249	1751	1751	1616254380000	canonical
2392	3NK6LA4j4MNY13WqCnDUPciN3MavM7KFLDy1Y9A57m4bFh2vVUUa	2390	3NLrkN3eTzJchB3zTRypD8pfmQGjYJZb9g9vBzDQYUwBqX3caATU	1403	824	12	1	2338	jwB7qFM8RPBiHzVoR8GfsBFJ4r2KwaVesDm4H6uAjXQ1CdXi5N7	1250	1752	1752	1616254560000	orphaned
2396	3NKuxDtz5chnP2fidKTMVPsQXw2vuyq3vCcY7ULr63o8Z1N3FRMa	2395	3NLEwmWntnxymPZZEfcAoqDdF5UHVQKStXBEUg1CnBMrLRAwKKbt	1407	1395	12	1	2342	jxk73Gj3to167FFH8ANDYdkMzu69sDS2gP1pZViUVrYewacQD9Z	1253	1758	1758	1616255640000	canonical
2400	3NKGJSzgio5XCKZddz8YhsD2LSsFsh9x8hTJ4vMVd39fw3NgtZLb	2397	3NLCUZ5YoVz8v9k5KYCd2JEo16FLqaSjujm3F6JnWhuui1du2ByL	1402	874	12	1	2346	jx1CZ1Wuf5UyvxjtQ5gLeYyPhn6T5J11SDsEvWfm5siLw7YMeVx	1255	1761	1761	1616256180000	orphaned
2403	3NKvfnjfVVgWn6YmAb9qpCwskvELpnm2NqsRMdiSkUXMTn751vC2	2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	1581	778	12	1	2349	jwQyJRFevNr3TNzanWdVQEesU3ovwuTGgCfg8BCkJAbHKbGMprL	1256	1762	1762	1616256360000	canonical
2401	3NLTWtQpr665mWzXALmFzSVQEJ9u4hg81gRiHhdiJ8kRCwQZbDhp	2398	3NKKz9zb8tx3kNbwiuUoAceBERfT6es4zyutdGaiUXKkxa26emPL	1483	112	12	1	2347	jxQeng9Wxf5DkaXzPHSQRT88a9c2117SpxsfeeGYxXNiiFusqTQ	1256	1762	1762	1616256360000	orphaned
2404	3NLy3FquFRPv8RWVX1TPBbLS6edcr8xA1osnxcKdh3tGcZpysBqd	2403	3NKvfnjfVVgWn6YmAb9qpCwskvELpnm2NqsRMdiSkUXMTn751vC2	1656	1217	12	1	2350	jx72egdBn9G1o2a2SVuF5YU2ZtaeP2FTfF2AN3eerAgRmjVxcjD	1257	1763	1763	1616256540000	canonical
2407	3NKodvHZEExygdGKCahBJcsn8mMgv1qZDnguwbfodxtY946biZHk	2405	3NLorEADbNp7MGQnBp66ga7pZh1sa5YGHMibLcxzL3fsV1ofsyJh	1406	1393	12	1	2353	jxLjcXzML6xeS2NFARN4xgpQxzQKqhC24mfozekvaSh3B1GKm2J	1259	1766	1766	1616257080000	canonical
2409	3NLurhRba9kHEshyjtin2AHSryF5T5FAaRyBUwhw5ehrGwQoTUeD	2407	3NKodvHZEExygdGKCahBJcsn8mMgv1qZDnguwbfodxtY946biZHk	1457	1145	13	1	2355	jxbH8PYqupU5LrLEVSj4GjVcn4p7mY1zCGHF6LBJdwYxjeJ19Qq	1260	1767	1767	1616257260000	orphaned
2410	3NKUfGYDe3rSSb3482zyy8pZaMGuZVdrDuEmDgPXcnMMK5PW5zVv	2408	3NKVonfJehozeGHFwyxTAn7PqHqdGbp6xzseLuq9UkZF8VnoJ9TL	1402	874	13	1	2356	jxZc4pkJsEMdMx8NfL8g4LZeojJLzb7iUpv5CFmRf8vSmbLLpsJ	1261	1768	1768	1616257440000	orphaned
2413	3NK9ajtSjMghWTeBKFipTSrDQCYXT7WJPTkesRuCq8rGncKqhndP	2412	3NKA5zZvqzBAGPHk5182tr5sYZbkdRsUwDSjV8nyJ9cEFwV52Hmb	1613	983	13	1	2359	jwtzG7SinhJ931htpMbKh4fMdwdo8TZcGiskWzUEsCTfXu9cDYv	1263	1771	1771	1616257980000	orphaned
2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	1670	1282	13	1	2362	jxihBh6HtQ8oZefS8gT7RZstY2bAAYVFynzmZ3kFQ3CmqfcBDav	1265	1774	1774	1616258520000	canonical
2419	3NLFAPiMDdxGJptGdwnTTm3fhvUGSuZbcXjUMvnJzQWr944CvexF	2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	1560	1291	13	1	2365	jxEQPQfrgRzfUniEN3gCTMnxR7WS9dePtSUrnaP56EXuQDwyDQy	1266	1776	1776	1616258880000	canonical
2425	3NLnqPjoRXBsUymJqXebhys3eo3XkmVX5nfmjQbLFUZY24XVAHus	2424	3NKtQA8qch6Ym248uHWR5kjoLZuuQ2cmcV47GnFWPqtmfBumX9WC	1619	1149	13	1	2371	jweMmKCVVSqwHBdTDayUzuFZ5VSXSNzV4gMQGoJHncKUwTBL76T	1270	1781	1781	1616259780000	orphaned
2430	3NLhW2T2cWXCXqXgRNXjff7yg4FXQ64o6DMdK6MdfV3FpceV5tFD	2427	3NLbWvma7S6oJEGi7ZJ9tkErQCZYqAa8WtfGAUyyBqxUNHqDvy5t	1542	1304	13	1	2376	jwg8CSsyXjhx1uU2eQGsHLB9ny83FFAXrbH4RHe5MJgwS3ZbQbW	1272	1783	1783	1616260140000	orphaned
2431	3NLvCHGjQh2Jsd7Y3LMEWA4UMFGY1pyZFCNcUjQdgUZk1B3mR9en	2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	1406	1393	13	1	2377	jwSxqjFLhpVky4irqRx4YrPyRcKfsHZJYvCVi5hPBz7gF27C8ht	1273	1784	1784	1616260320000	orphaned
2434	3NKac27JAYT48BpqSqWW28CQvi8PSsfoJya5FomrnPCMHaxZRhN1	2432	3NLu29SX6DShG5CvM7snyjvWEMEhCsEE3uwvKanzYLsWH9g2L5Dk	171	1374	13	1	2380	jxsGwpzsuiazAsNatKaowwQDVonyWxzVPb3yZQTxdNoZt68njXR	1274	1786	1786	1616260680000	orphaned
2438	3NKdRmuFVLNBwMioS6p2zzCcankBRwNJvW661mEuM6nKeqn6Ftyt	2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	1406	1393	13	1	2384	jxRNdxnYiUeGnaMTFDmkBsTf7QqAWNm6RK5Bf2THfSc5RpbmV9D	1275	1789	1789	1616261220000	canonical
2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	2438	3NKdRmuFVLNBwMioS6p2zzCcankBRwNJvW661mEuM6nKeqn6Ftyt	1623	830	13	1	2386	jy1gkmrbdEVzb2sSdZTL8aYU7c1SCUKuiSTW8BzMoZRBr4b5y2p	1276	1790	1790	1616261400000	canonical
2443	3NLXh5UM1rwsiqbvvpJoyQTRr78R2uHNS4M6TRUNcQmDiqYkQ8N1	2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	1623	830	13	1	2389	jwVDaErXsnx55AFiEmTd6zCNne3hWf3kxoawxF6sjBxX3LbUqfP	1277	1791	1791	1616261580000	canonical
2447	3NKVh1JcbjyctZdUgdYngJtbw7GmjWxA3FXAPWEe9of58N9kP6Yn	2445	3NKUBcPd6KDMg4CihLWaRVWaDVECpQdfgLztJH2S6gXnYHiTbVTR	1406	1393	13	1	2393	jwMXzUHaSUxtoewgNwhFYE5Ju8TY5VWXxBreGJKX8imSjn342c5	1280	1794	1794	1616262120000	canonical
8149	3NKkgGSGHP3tgDqZrrzsKzhBSAbZTG3kXTf5rgTv4iaUpUJYmoQL	8109	3NLj28YXJFuatzecsZKAntZ8P4aGT3YQXTYdkDNaZ23ALhm8bt5x	162	162	95	1	6301	jwn8wLQHNxtaTNvMaeoXSZhXPQXkscCfQNYz9oQ8x9Q77gkrfj2	4205	5965	5965	1617012900000	orphaned
2408	3NKVonfJehozeGHFwyxTAn7PqHqdGbp6xzseLuq9UkZF8VnoJ9TL	2407	3NKodvHZEExygdGKCahBJcsn8mMgv1qZDnguwbfodxtY946biZHk	1490	1274	13	1	2354	jxzCBaZZkjRUVHJ5MvYTaiBueNxdMNS3qbrSe5tDWZAQdWcuwiS	1260	1767	1767	1616257260000	canonical
2418	3NLxNAUqVWCstNGsLGUMfc6JFtf2aFzJDAjM9RCWkuWYDfZGwH5K	2415	3NLZEracEcdKB7dK5eLTwDYYjnaj418vjN9prfY5GM3R39DX13bz	1654	1340	13	1	2364	jwcLmER116cKq1hRJHAPfxViEA5giv9iKdhB6xNBv5fJ6TLustX	1265	1774	1774	1616258520000	orphaned
2422	3NLFrJkaPK6r9KjuHtBEMqqMVEXSfuKnbnbcxoPXVhPzRVTRkfJG	2419	3NLFAPiMDdxGJptGdwnTTm3fhvUGSuZbcXjUMvnJzQWr944CvexF	1406	1393	13	1	2368	jxe3YUhSQmHpGRP5SDeSqhk8YALMnj5d8kErR8rjrLnMALsZdQG	1267	1777	1777	1616259060000	canonical
2423	3NKz8FZSGQCfKmBVfaE5xexn2z2zXhqw4mgqCujvSMa81gNWXgVo	2422	3NLFrJkaPK6r9KjuHtBEMqqMVEXSfuKnbnbcxoPXVhPzRVTRkfJG	1670	1036	13	1	2369	jwkHufyu8xdHBY4GhwyfGh6krJ9mfYsLJtErQ5EaR6q8hABFPHk	1268	1779	1779	1616259420000	canonical
2428	3NL49pEf9TqbVVyQ29bEaH7fupLUj6foFNTP5ub8XbEByTr9cEHH	2426	3NLmKN1TRb8iu1J4DGvj8wJE3cTgeAgawjDMrcHWAWriEtkJCNiB	1599	921	13	1	2374	jx5bBuS7kmuBtbCxCc3sydRP3BLEid4XrwxXeMSpHZ45PRuym29	1271	1782	1782	1616259960000	orphaned
2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	2427	3NLbWvma7S6oJEGi7ZJ9tkErQCZYqAa8WtfGAUyyBqxUNHqDvy5t	1668	1370	13	1	2375	jxgeDuZMKrzwYfRzz5VsMsjPxNYez8hNxqP2wEyTGy6JozWdC1D	1272	1783	1783	1616260140000	canonical
2433	3NLMiCyiLnTUz5VvQRY1RwUJwcoxL3KU4NrppgNBgbsoQ7z3Wcnw	2429	3NLMrkFnc62sFtf13PiCVC17p51iBRKJkGkV5kpZdi8Xf2v3WBZy	1637	816	13	1	2379	jw6uwKgRkNGgjSawZpxZWBs7if3qdSc22YDXZeQigNfaxiW78Cd	1273	1784	1784	1616260320000	orphaned
2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	2432	3NLu29SX6DShG5CvM7snyjvWEMEhCsEE3uwvKanzYLsWH9g2L5Dk	1611	1215	13	1	2381	jx5FbWHMhg5DS6VBy2ARoA7Rjp12YYo8VPhsVBatBmhHjyeEBg6	1274	1786	1786	1616260680000	canonical
2439	3NLRmzKyYXZpoXt88EKTQmG3KFAMAsiG2nPYWm2QWxt7Pdz5n34s	2438	3NKdRmuFVLNBwMioS6p2zzCcankBRwNJvW661mEuM6nKeqn6Ftyt	1451	1292	13	1	2385	jxQMqM2z7VzV27fSQBvx9PAwnZFPC946Mq5NofxVue9wvzi2cdi	1276	1790	1790	1616261400000	orphaned
2442	3NLhB5h6tprsipnLdC8qYJ57kk6E5SC8nUWVoG9m2FGaW167Ngpi	2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	633	1138	13	1	2388	jwByTAAivrXJf2kqKApgvSWkiqEN3EuoX6BtyxqgP25QpZEYaaW	1277	1791	1791	1616261580000	orphaned
2444	3NLQkFWoHpteWcKjfB2178c92p62a8YKh7UJ24GcsRfGenxkSrpj	2443	3NLXh5UM1rwsiqbvvpJoyQTRr78R2uHNS4M6TRUNcQmDiqYkQ8N1	1406	1393	13	1	2390	jwtq6A62iba9UqBu1KkWzk3qseUKtUy8mg2T81U8MXd7Wd7pwMm	1278	1792	1792	1616261760000	canonical
2445	3NKUBcPd6KDMg4CihLWaRVWaDVECpQdfgLztJH2S6gXnYHiTbVTR	2444	3NLQkFWoHpteWcKjfB2178c92p62a8YKh7UJ24GcsRfGenxkSrpj	1405	851	13	1	2391	jxT6LqTWASBSBr4Q6xMKV2sGih3fuPv1dumuPBSB1PmmCn8sqsW	1279	1793	1793	1616261940000	canonical
2446	3NK3jQWgwBdfA8ziRgjfJ8HWARgn5vwiv7KKVpUyYC9dSTDvESfb	2444	3NLQkFWoHpteWcKjfB2178c92p62a8YKh7UJ24GcsRfGenxkSrpj	1589	1040	13	1	2392	jwUiJr6HCWp8ihVNJAek99a9SP1MGj6urcMMiA3rHgraUkE3k7G	1279	1793	1793	1616261940000	orphaned
2449	3NLp2MqiqBrJi6to6x13tKeKp54j5oJce5DofgG2Av7TcMscpUFZ	2447	3NKVh1JcbjyctZdUgdYngJtbw7GmjWxA3FXAPWEe9of58N9kP6Yn	1651	1055	13	1	2394	jxM7QggEuMHh1i2LmTHq3JHUA8V1N5gPSrH7RjYXBhN3mZuuNf7	1281	1795	1795	1616262300000	canonical
2448	3NKdd9x3kKidszaXHfLVZTF5HmBNmD8yVdcRM2zyLsM9p3gFSyXs	2447	3NKVh1JcbjyctZdUgdYngJtbw7GmjWxA3FXAPWEe9of58N9kP6Yn	1651	1055	13	1	2394	jxBMC9b9ebt8aMnJmJUEaLQS6D5AbUGSZwHJ2pMWHfuQrdS72uN	1281	1795	1795	1616262300000	orphaned
2450	3NKUp6mzHDdsq7R6jjJWHBAF8QafAtbNPSRbCjowwmqDt39gAdq7	2449	3NLp2MqiqBrJi6to6x13tKeKp54j5oJce5DofgG2Av7TcMscpUFZ	596	1180	13	1	2395	jxCafcYY5hZ17UbQkk3KrWruUbYowj4dWLGhxnatRHrFiebjcDJ	1282	1796	1796	1616262480000	canonical
2451	3NLamQ94nuBvFmG6CqL1dXVcoALjoxnRaynpTZzAu4ZtPaTWdUK4	2449	3NLp2MqiqBrJi6to6x13tKeKp54j5oJce5DofgG2Av7TcMscpUFZ	1476	1245	13	1	2396	jwqF8cJWGC5SeP8Ux1i53Jkoohd9G2Ci4YewHnXfF2wzyENXQP8	1282	1796	1796	1616262480000	orphaned
2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	2450	3NKUp6mzHDdsq7R6jjJWHBAF8QafAtbNPSRbCjowwmqDt39gAdq7	1467	1130	13	1	2397	jwEMh1pwF8X3SfXEq9YWVtzstfcThDjiNweDoAqHKFjbhqYXyFd	1283	1798	1798	1616262840000	canonical
2455	3NLujr3uKye2DHdPDWsNMrEDuXzZNLVKUku8orNg4cPpZkmBM5rW	2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	1581	778	13	1	2400	jwgfCcJ9ZaPmJZiSDhDaYwVxBxkZFUkNaeGwhSVYnEHjVscM7BN	1284	1799	1799	1616263020000	canonical
2453	3NLx9G2m5NkGPfLpsA3cHvrBNUZWsbWvtR1UC73fgS3YCwBzvGtp	2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	1654	1094	13	1	2398	jx3K92P8MTf7NgeYYqV6F5nEWir6L1uKhR3NabfnfGXjpfkvMpe	1284	1799	1799	1616263020000	orphaned
2457	3NK6bgjdi1UzvxvDH6MUhxyRNDa4edVzTgYtdDJnYPKMRf5MfiAs	2456	3NKJ5QVikKMHizSHiY9NVpTguHRTHkNr462GUAG1BTUvzwQT8VjG	1623	830	13	1	2402	jxpB8Yt8pQmqcaJBcoTqET5FoMiFzTZU6mH27rT5Ntmp5wH1WRq	1286	1804	1804	1616263920000	canonical
2458	3NLydq6xVbXSzbqHeKdY88tiJyTtXET9VetcGECjoLuEeeXFh881	2457	3NK6bgjdi1UzvxvDH6MUhxyRNDa4edVzTgYtdDJnYPKMRf5MfiAs	484	1319	13	1	2403	jxdLLPdrB7ZAJuPd54Ry2qCV1ZtWdgR2kAbiZn9PLG1Dv2ZdRGz	1287	1805	1805	1616264100000	canonical
2461	3NLTAvzpVrNwz2Cax1j9H95KfDTitdzHJz1v7m91L3qPUXDcApqp	2458	3NLydq6xVbXSzbqHeKdY88tiJyTtXET9VetcGECjoLuEeeXFh881	1508	1261	13	1	2406	jxSk2Dgb6xmi2n4aFQ6Gm9KC2Jr9bo4JtXxbzV4EWWhJHkUBJu2	1288	1806	1806	1616264280000	canonical
2460	3NKtRsKrVw9u3fvLTxNxXxNQCE1DFrqgTGCgP1F2h3s1bpNyuMyw	2458	3NLydq6xVbXSzbqHeKdY88tiJyTtXET9VetcGECjoLuEeeXFh881	1571	1089	13	1	2405	jwGxWV5Bt2kUwosQDuqhmztziQewQuxvJB1hv7i56Gt5F3W8yrK	1288	1806	1806	1616264280000	orphaned
2462	3NKeoGGFTDBAvms8TqRKcc53bhsjs7sieAXh8ndPvoabqhicrDJu	2461	3NLTAvzpVrNwz2Cax1j9H95KfDTitdzHJz1v7m91L3qPUXDcApqp	596	1306	13	1	2407	jxRM9FgSuvdPJV5KeefTVU7Hn6CJE2LFtQBofgToMRuYKvzreTx	1289	1808	1808	1616264640000	canonical
2463	3NKsF3fQjbqovpgcrWfK2T9ngGq1J7RAA5gWeXSETH93apsUDKsL	2460	3NKtRsKrVw9u3fvLTxNxXxNQCE1DFrqgTGCgP1F2h3s1bpNyuMyw	1513	1133	13	1	2408	jwWuYyattttk47tjTFykDEMCmisGt9H1UQb3zPXCJTQQYCMXzcq	1289	1808	1808	1616264640000	orphaned
2464	3NKrhpGhhmDXwHVxYNRHvt4mW19s4Sjhqm5nnrzKK5GohEXahu9H	2462	3NKeoGGFTDBAvms8TqRKcc53bhsjs7sieAXh8ndPvoabqhicrDJu	1407	1395	13	1	2409	jwCb1X4NCuYvL4X36aWp9Z2Sfq7qLYbDwZVzAGfzmEb7mBp9Fh9	1290	1809	1809	1616264820000	canonical
2466	3NKjxJNPYBxRwrSWczYapgoJLbrNCVTjxSvmqWYWSF2hBpZg8AiU	2464	3NKrhpGhhmDXwHVxYNRHvt4mW19s4Sjhqm5nnrzKK5GohEXahu9H	1637	816	13	1	2411	jwK59495eeS75aDhB4743XDWkAwjiwuNsvMTDmPm1U6EYTgDtpH	1291	1810	1810	1616265000000	canonical
2467	3NLGrGXtD4XNHyHUaLACr9tg1dT6x7zDMq4prn1MNc7kDnrjFqHn	2466	3NKjxJNPYBxRwrSWczYapgoJLbrNCVTjxSvmqWYWSF2hBpZg8AiU	1608	1043	13	1	2412	jwM1hj7QnYmfnjStbyVu4aLFGMS9Ui1wXyRwc4AXH7H8Q9h333k	1292	1812	1812	1616265360000	canonical
8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	8111	3NKjsng3xQ6b5HWmiBXBvsirGHWSx6pnz62VT8uq2DSmULwa7dzR	1600	1246	95	1	6301	jxSzjxPzESt8ageQebM6MeCwCHU4KKPGxmfmcv8PYUPuAknrKLP	4207	5938	5938	1617008040000	canonical
2456	3NKJ5QVikKMHizSHiY9NVpTguHRTHkNr462GUAG1BTUvzwQT8VjG	2455	3NLujr3uKye2DHdPDWsNMrEDuXzZNLVKUku8orNg4cPpZkmBM5rW	1541	1052	13	1	2401	jwDs9MTWvofGWkfjUC7n6gnZB6nbzGYVnZRCVmpfq16yv131Z9y	1285	1803	1803	1616263740000	canonical
2459	3NKWiPYnf9Meu9stELnbjrr1scPCaxpShauiyRmLyXTh5XVBn2eB	2457	3NK6bgjdi1UzvxvDH6MUhxyRNDa4edVzTgYtdDJnYPKMRf5MfiAs	1613	1103	13	1	2404	jx89pbqA73BGbGaUCrFPQGGZLCBtK72rDydvb53RyZ5N5ic63k2	1287	1805	1805	1616264100000	orphaned
2465	3NKWVkKHMWhNN5B5wG65RCrQAGpWRWJNd7nm86XyQ7r9s8DyPzFC	2462	3NKeoGGFTDBAvms8TqRKcc53bhsjs7sieAXh8ndPvoabqhicrDJu	1602	1369	13	1	2410	jx3sMmQRCsNM8cDdW7s84X3UvsrBL7mqMzNjRY72NpBWmXFuUto	1290	1809	1809	1616264820000	orphaned
2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	2467	3NLGrGXtD4XNHyHUaLACr9tg1dT6x7zDMq4prn1MNc7kDnrjFqHn	80	1273	13	1	2413	jw8KGJhb8mzWPMqvGAatPGufxkEP6mEpSgSkVpJNe6wfTMLAGBC	1293	1813	1813	1616265540000	canonical
2470	3NKizaPnM6xUrmYewwMkUJDzpnueWHBFGEjGoEHAwC434fuEJa32	2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	1541	1172	13	1	2415	jxCYxds4U4CoX4MG94z7MqCjXoRTaQWR6g2ereJ7yo7VMqbyLxa	1294	1814	1814	1616265720000	orphaned
2473	3NKGUrKqhoPt1U7YToc7wtYhfxgKE8XLNpf4myzQBD8YKx15ZpRJ	2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	1407	1395	13	1	2418	jwQzpW8nQcnpb28jK6GNzWgYMquX4FLbg452qeqQJAtfyc58Se9	1295	1815	1815	1616265900000	orphaned
2475	3NKCkgaFkrDB4UnDdrYMKRsTmjPUEXuQ2qqhdydq8iKaEbZ5YfAU	2474	3NKPVWbMZeo1BrvyCyNSwvMhZA3tFfM5ssYdDuWccWHC9kFR95Ap	1600	1126	13	1	2420	jwsSicFQ9e2AFyciru9gSBUcsENog8jTp9uR6rKqQ4BuFoKibJY	1296	1820	1820	1616266800000	canonical
2478	3NKsG1ziK5XvoALnyWFE7xNsujeTMj5trnQsEuYnTkiZjis7Z4JD	2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	633	1138	14	1	2423	jwQ1Enj3udyNfETSp7vJzWh8r8wNTMZwsfEjqH7LgdiQ4xAozc7	1298	1822	1822	1616267160000	orphaned
2480	3NKhhPR8jqfbbWu9nujz7hoqHhwZ1KK67T1P5HNB1KfrSZoB4KZD	2479	3NLgShuhWj8H51PJEccx4YwpCspDNmwGCoLVvoLHPjW7akupYYBX	1419	813	14	1	2425	jxYWL2GXtkuxassvr4c7f3hZHiaf8AkWGeLU4zq8XJa8GYyKGhv	1299	1824	1824	1616267520000	canonical
2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	2480	3NKhhPR8jqfbbWu9nujz7hoqHhwZ1KK67T1P5HNB1KfrSZoB4KZD	1631	793	14	1	2426	jw8YYAwQ7oRF38Sa3nM5CeAmDTUugz2VVdE8FnJKfCDDg1qVTEo	1300	1825	1825	1616267700000	canonical
2483	3NLoAEc2tJM7tWaZsLXkdzBvfy3cxDrRPWak7BsuKcdcmbcnuHWM	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	1402	888	14	1	2428	jxf7ZtoNK6JstDjM83WxhM2QeZPfpyywW9jxYbMrDj2b1rRe2fh	1301	1826	1826	1616267880000	orphaned
2482	3NLy3RvJ9K6mLFQd4wrX1JVk5jhDdKKJWRerhe8jcujCvrgJUsDw	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	1571	1335	14	1	2427	jx8UC1rEhPnphNgAxbdyTQKwWWnwJAF3PkV4QXsYA8fXzGbEjK5	1301	1826	1826	1616267880000	orphaned
2486	3NLYofcYa3rshjvDycvqMyrqd7wHXiPrzaPTPSg1LGs3Ud5YgFsR	2484	3NLT9kptDXE1Xm8shbQyTvPuniWjU7ezxAQhMXa3D7HJx1qNGSYT	1649	1383	14	1	2431	jwU3mHgYauPGSuigZsjKFdWvi28mNqf6VGWSmvW9YP1NTQk9myS	1302	1827	1827	1616268060000	canonical
2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	2486	3NLYofcYa3rshjvDycvqMyrqd7wHXiPrzaPTPSg1LGs3Ud5YgFsR	1481	790	14	1	2432	jxViHW1fi1WZEtZkBdZRhAuN7JZNnQ6zjVFv5uZSt6GscsNR2GP	1303	1828	1828	1616268240000	canonical
2488	3NKmFmaamRRr7qaMczo5oHsWVU4RyNzpaa4ZbhDCaha866koY2mA	2486	3NLYofcYa3rshjvDycvqMyrqd7wHXiPrzaPTPSg1LGs3Ud5YgFsR	606	1169	14	1	2433	jwq3Eq2zQFdF2W9fUm8TGufdy3BizxkT2FYCDHkwCGQ9Cefi57F	1303	1828	1828	1616268240000	orphaned
2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	484	1319	14	1	2435	jwgvngw4BzYtkpT5vtPEAjprG6DTfHwVTiN82Rq1csA5hbbdHWe	1304	1829	1829	1616268420000	canonical
2489	3NLicLBwfZPGkMEmdJ5UcayXgUfUofHfoKPKee5WYuYKN3xzF4zQ	2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	1577	1327	14	1	2434	jwfUfw4HheLnvPVEHet83NhmzsGCsj45L2fYTxa6zgTqwNbnsZg	1304	1829	1829	1616268420000	orphaned
2494	3NLR7wTxQAqHs8VYsstVg4mxiBmgjoR9XT6vyVsZH1kVXyF4fWdH	2492	3NKGKnv1yTEmDpHd6iWRsyP5Jn2QiAQKS9DxLsS6ArtyhZh4YhhS	1407	1395	14	1	2439	jxevkHFeQZvwcZYHoxoFcDeUk6vpvgLajEDfaP13piPvs8xNzDC	1306	1831	1831	1616268780000	canonical
2498	3NLUUnKTuBXGPSZ93FpFRpmia989oxyF4rEr2USz7L1A69a6hwro	2496	3NLy8dD3zqaXESZ3qpvPSBbWcdmt7ss7N3Lok7mxpMtvEP1uu8sc	1406	1393	14	1	2443	jwLoa1mNf9S8avB8PjtJnAALY2iL1cTXCnLyGCfZ9S5WSd8dxDd	1308	1836	1836	1616269680000	canonical
2499	3NKLpthCLYPQzwjQpn75PWvABiuEWCmL8JiVMWRSVQN52bpRnr8q	2498	3NLUUnKTuBXGPSZ93FpFRpmia989oxyF4rEr2USz7L1A69a6hwro	1553	776	14	1	2444	jwVh3dS5vHJiSGwsFvL7H2FhyBRRzX81BmFJ61PG6MZxbxBpQFq	1309	1837	1837	1616269860000	canonical
2500	3NLs2xLT6eXHhUxbLVgff9wUFCSgUVSqyiVg8ycLVoEj7f8EACtg	2499	3NKLpthCLYPQzwjQpn75PWvABiuEWCmL8JiVMWRSVQN52bpRnr8q	641	1090	14	1	2445	jx54eF2zR7UyyyA1NzY4ra5ASMAJcpjxqgF6JejzrDv5SyAhzby	1310	1841	1841	1616270580000	canonical
2503	3NLwjoWH1pK3VPP3m9AP7rJiVJndLzJesc9Ji1zrBtiRjYMbw9N6	2500	3NLs2xLT6eXHhUxbLVgff9wUFCSgUVSqyiVg8ycLVoEj7f8EACtg	446	446	14	1	2448	jxJhMQLVN7FyCw1ZSUoqBF3993zrvFtkbu3Y929vAD7YpThPrd4	1311	1844	1844	1616271120000	orphaned
2504	3NKRHWJJKztPG2rexXPdQ2RJLmXcUCCMZvGJZZFv9wwTqQ7D3ZYc	2502	3NLwHpUhGrZBG7E4mpZSXYcFXTwmtwpEoDiLxDcRqKfz7uiXAL6s	1671	1365	14	1	2449	jxN8Mf99WUKGK2ZsXiapXc1ShtBmxRvsVc6Ty8qDpbrpu1s2qCh	1312	1845	1845	1616271300000	canonical
2506	3NKuBmL4FjAB9Xa5V2hKw5hLUB2wF1dAGWGfizeUmpwvMLaUv6PG	2505	3NLMRY6y29xjps56P1mz13YAJBk8DzazCQr6BRqHc7p2y4VSZyek	1613	1103	14	1	2451	jwnEbXbn7bwWGmyjRcd1aiSMrpvDYEnnyeyazwjCabgR1E23gm5	1314	1847	1847	1616271660000	canonical
2509	3NKqe3z4USXs32KFsywYDT7tftMjAYnbMmt1xm1ty6EX3ZkTVVoA	2507	3NKJkvHt9UKPSgcMvoZF1JZjrxBtz3hGUb7nRmhjBPPEM9TNhJUN	1601	1388	14	1	2454	jxGLqjQ7EGha5425YB3pfubnmK25EYqTn4G5jV9UeUUz4sU8hBy	1316	1852	1852	1616272560000	canonical
2511	3NKmsekVHhaEfxyWgRVbspo1Cm27KsxizBrV1ZrWaqCFWLi2gPsG	2510	3NLRgbfuixVMtnbrrfAX89jYzZWubog7YX4qb29rJWFFGhoaXUSi	1458	1323	14	1	2456	jwu8a8n9Ffm5qgdhJKB7aCzNadfDpoddKXTeNwBamnmEniJcyZA	1318	1855	1855	1616273100000	orphaned
2513	3NLUkpawyfF3qgnTCHaT7TVSXjj8Fac4tQYbdy7vpgF2t4PXXoXD	2512	3NLbS2PRa3V9jCxCfXwaUQ7hxjgJEV7VHvm5e19qGZ6JskHM8JWr	1407	1395	14	1	2458	jxqyMGQC2hiyu1qexBLZi1tBhiLEbKYQWfJUrAx3hEQkdDbtq8H	1319	1856	1856	1616273280000	canonical
2516	3NLXoZpE7ZGiJK1BbHsXgNtbDBuN843c5oLYDYxf6ceKJdwmy92c	2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	1624	1208	14	1	2461	jxGoigjPaYrL2q9ov6MLkU9CCgNBXyuCrEFVUPW6MZMKB4X5LGo	1321	1858	1858	1616273640000	orphaned
2517	3NLWFbhzunVQmpe1vFnNhCyHNV3ZjPEoJGkC5c187vC2CTV79ZGK	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	1407	1395	14	1	2462	jxsuUHuj3rgERan2jaEcHW6NkJ5cg9SVaHm6WFhtJ9byhG4kDyN	1322	1861	1861	1616274180000	canonical
8129	3NLqyxqbY8KwW56zPjW3oCDFpPDEEsu7jvkyuhNerNw1oLsUm6ML	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	1656	1343	95	1	6301	jxLfjW7R3jLXg8zBtMrP9wHYw1fgCkSCLwcuSxLL9fp7NsoZkHK	4214	5947	5947	1617009660000	orphaned
2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	1534	951	13	1	2414	jwEWAU5zWaZAu5nfDrFZma86mW2cMBwoRmXHJTunQQMt2LtGU7v	1294	1814	1814	1616265720000	canonical
2474	3NKPVWbMZeo1BrvyCyNSwvMhZA3tFfM5ssYdDuWccWHC9kFR95Ap	2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	1642	1367	13	1	2419	jxnJApqEhvAjvBETSuEYirExhe7XvavuPEa5ibNVsphqUr94TDB	1295	1815	1815	1616265900000	canonical
2472	3NLdAnPXZsc1Pn4QpeLhueCvW4W24cVcm5uocEDGb9WKY3C86ACp	2469	3NLwHeycDeVugnYAhKrjUyEcY34yZxmP2dZgiFxtG18zvTBa8GNE	1426	1364	13	1	2417	jxnyMp7AQpHzGEUR3VyPJVBJZHcnn9PsB5pgJGYVJefeRJdYcs7	1295	1815	1815	1616265900000	orphaned
2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	2475	3NKCkgaFkrDB4UnDdrYMKRsTmjPUEXuQ2qqhdydq8iKaEbZ5YfAU	1670	916	14	1	2421	jw9k42e5ifqDmL2xVL3dLPLkcZq15YNYv1LfY5ZpzK7pVYBdjMc	1297	1821	1821	1616266980000	canonical
2479	3NLgShuhWj8H51PJEccx4YwpCspDNmwGCoLVvoLHPjW7akupYYBX	2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	311	941	14	1	2424	jxtB21JCpZrPWCJkBXqLXvUMKi8JhLyZWNxzmLX4oBkyZNjP2KK	1298	1822	1822	1616267160000	canonical
2484	3NLT9kptDXE1Xm8shbQyTvPuniWjU7ezxAQhMXa3D7HJx1qNGSYT	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	1555	1347	14	1	2429	jwizem7uPaEcx9RoLoPnB9u5s8hs4uy9EENwAWeEvKnKsZUbAng	1301	1826	1826	1616267880000	canonical
2492	3NKGKnv1yTEmDpHd6iWRsyP5Jn2QiAQKS9DxLsS6ArtyhZh4YhhS	2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	1631	794	14	1	2437	jxzMMyv5UtG7GQa6WMiNwy9VKKzrfuvGhcnHq7qEZeY8Hvb7mvk	1305	1830	1830	1616268600000	canonical
2493	3NLSPscq26kMxSenjUbztdHKLJTooRYrBTstVLUMFkvC4KmEAj3x	2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	1637	816	14	1	2438	jwfVpiywctg2GHen1mRLNZgmRo9qKBZgR91W9Q253PXZnpfedee	1305	1830	1830	1616268600000	orphaned
2495	3NLvGv5c8j6v2W5j5ceg1SVVDttZkYB38fiZacH5GPRQFAWBTS2e	2492	3NKGKnv1yTEmDpHd6iWRsyP5Jn2QiAQKS9DxLsS6ArtyhZh4YhhS	1571	1209	14	1	2440	jxUBwTbWUKcqcuKdfnKDhHXdRXAvuBsdFqs4gysoY6MGQsHakzk	1306	1831	1831	1616268780000	orphaned
2496	3NLy8dD3zqaXESZ3qpvPSBbWcdmt7ss7N3Lok7mxpMtvEP1uu8sc	2494	3NLR7wTxQAqHs8VYsstVg4mxiBmgjoR9XT6vyVsZH1kVXyF4fWdH	448	1305	14	1	2441	jwyVamnZdKUBgbEgyFCBtNGQsKsZFmHvTtEtQweG5mKtFBfkbGr	1307	1835	1835	1616269500000	canonical
2497	3NLeyTzHsDuT6iuEACaWP3jgLYGSPgDU7AYeLkusVaH9WcoTYVJ9	2496	3NLy8dD3zqaXESZ3qpvPSBbWcdmt7ss7N3Lok7mxpMtvEP1uu8sc	1422	1091	14	1	2442	jwwBcmzgHy4oekAbKx9F1fxPApfQG9X3THvFZjw7fdUUmRXrX1C	1308	1836	1836	1616269680000	orphaned
2502	3NLwHpUhGrZBG7E4mpZSXYcFXTwmtwpEoDiLxDcRqKfz7uiXAL6s	2500	3NLs2xLT6eXHhUxbLVgff9wUFCSgUVSqyiVg8ycLVoEj7f8EACtg	684	1352	14	1	2447	jwQxDepLZJhgo1xjMDhUd3K6kqUogHKjFfJNzByW62TXu1g7EPc	1311	1844	1844	1616271120000	canonical
2505	3NLMRY6y29xjps56P1mz13YAJBk8DzazCQr6BRqHc7p2y4VSZyek	2504	3NKRHWJJKztPG2rexXPdQ2RJLmXcUCCMZvGJZZFv9wwTqQ7D3ZYc	1447	1345	14	1	2450	jw6dsuLixUhNQBEZLY7zQj1VY8uN43UXUVxejp6tW1RTuzeV2q4	1313	1846	1846	1616271480000	canonical
2507	3NKJkvHt9UKPSgcMvoZF1JZjrxBtz3hGUb7nRmhjBPPEM9TNhJUN	2506	3NKuBmL4FjAB9Xa5V2hKw5hLUB2wF1dAGWGfizeUmpwvMLaUv6PG	1541	932	14	1	2452	jwyCDCay63H4HxAH1Z7e3tot3e3s2TPxQ5xHoQUYqCt2WtpbNay	1315	1849	1849	1616272020000	canonical
2508	3NLAQEvm2f17Z21doHv2xZgFcjHR3baA52xZFGBxSyhXaKF7Ldz8	2507	3NKJkvHt9UKPSgcMvoZF1JZjrxBtz3hGUb7nRmhjBPPEM9TNhJUN	1402	888	14	1	2453	jwxTwfJ5QMVQRsAZpsKVsxT9To82SMfKzRf9PjownHFjEbJYSQK	1316	1852	1852	1616272560000	orphaned
2510	3NLRgbfuixVMtnbrrfAX89jYzZWubog7YX4qb29rJWFFGhoaXUSi	2509	3NKqe3z4USXs32KFsywYDT7tftMjAYnbMmt1xm1ty6EX3ZkTVVoA	1668	1370	14	1	2455	jwRxThoSBhTiW7jdNVF4jqzqY6yfJ298zk25JmJHvPWhMp35MBo	1317	1853	1853	1616272740000	canonical
2512	3NLbS2PRa3V9jCxCfXwaUQ7hxjgJEV7VHvm5e19qGZ6JskHM8JWr	2510	3NLRgbfuixVMtnbrrfAX89jYzZWubog7YX4qb29rJWFFGhoaXUSi	1559	987	14	1	2457	jy2BgALdKJXF4ZKHwBCxCfKLXqbkJ3B3xxhax4mXwKVbwwjLEVx	1318	1855	1855	1616273100000	canonical
2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	2513	3NLUkpawyfF3qgnTCHaT7TVSXjj8Fac4tQYbdy7vpgF2t4PXXoXD	1406	1393	14	1	2459	jx1if8QSqjAgYzL4QRgtZmjkKYqkppqRTi6TXrmseSS5dAJUETC	1320	1857	1857	1616273460000	canonical
2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	1546	1213	14	1	2460	jxg345mtvD52s6FAw2d2n4JCypQ1FsB2SaVMi1FdBH6omDFarcg	1321	1858	1858	1616273640000	canonical
2518	3NLQrWov1HbNwmEJxJVau8uDxAX5o5vv85DVNnxiq4i9CRC1XAXv	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	43	944	14	1	2463	jw8pcJxkfCRXocVFPYzTBdiuFU2r75W8SD1so85stxeC3TauS9r	1322	1861	1861	1616274180000	orphaned
2522	3NKQV5TBdmZNS66LUF5dhTZbuU14frKzsPWQnnfVjXF4bPQ4J5qt	2520	3NL3n3tufo1uqD1NXWemNJLHJc318KJqz6JGwULLqHeXKeGf8MGm	1546	1093	14	1	2467	jxvqafXxG5uVdD2qyx6pFZL3bdsuCUHodMUpLLkQuGJqPqyf4Gp	1324	1865	1865	1616274900000	canonical
2524	3NLfQU8DmifBjyMTjVQmwBGhpZFFj9bu6DxHhweqMqZpnPt9DtrM	2523	3NLxi9j4qDPDz4AnGuqRcrSU1oP9tsF5HPy4ApoFxx26ba92sTvV	1631	794	14	1	2469	jxCFyA9CRK9B86gncdpRwMwP6ZjihfLjtgGQyNjc2tgZMvg1Eij	1326	1869	1869	1616275620000	canonical
2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	2524	3NLfQU8DmifBjyMTjVQmwBGhpZFFj9bu6DxHhweqMqZpnPt9DtrM	1590	1054	14	1	2470	jwjEoBB2LjMvb9WxN57wzEa2AmrKeN9B5aw2rM1YsgicR71YGU9	1327	1871	1871	1616275980000	canonical
2527	3NLX1YTdSE5kDxC9mvoWSLn85w9jyxMq91ykizwMYn3KxMX9HnWV	2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	470	1183	14	1	2472	jxzPFwodmZKgpEZE4Gh8vvpUWVQ9cLrRcnp3PpQatFsKBGnCRYn	1328	1872	1872	1616276160000	canonical
2528	3NKm8UMvpuobSPRzmowQDY3UE68C5r2ceufqzE4v8fpCZs8LAtB8	2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	1559	1353	14	1	2473	jwkf43raHt14SjCq9ZDT8kcdGea15be6Ai6q4yeUgRj6Fq4TCxm	1328	1872	1872	1616276160000	orphaned
2526	3NLp1deJBTQw8gYJ9fxK2XH77p9qMZhB6dRtTKfGdhP1Ztm6pYBA	2525	3NKtsUsusE827bnRZztdbWwv2idebrgLQeyYsRi3JrppEaXivKyX	1483	78	14	1	2471	jxBxDyKHbcY9ZSJS1YdAtvCE3ymHCzVub1SGQmr3kgvjZpvzMdH	1328	1872	1872	1616276160000	orphaned
2530	3NKxLEXB8WGNp2ngnuKk7PrUAQhVnKoGmujKx2tZvjjSYgVq3pFD	2529	3NKmRy1wuGbNbURn1e2CmiLRs4RtLAw1yb3DXahVUPtggu5SHFZs	1588	1146	14	1	2475	jxK4RZ4U4mXrJrs8j2WmNL5HrYmpXH4jUUnVRCy3LyBqTbtDUKS	1330	1874	1874	1616276520000	canonical
2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	2536	3NKvhb5kymk4jVVYgx5MyBMeV2yrZVMboxne8GQZyyq7Q2QS8jkT	1651	1175	15	1	2481	jx3NzqhebqTDUQ62z8V6tRzgx6AS7nmMsergAphkiCSXrdGYN3H	1335	1879	1879	1616277420000	canonical
2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	2543	3NLQ9ryh67Gftf5RFu7NuiNopj7o7m6i2vk4rWfJxgWybrpGBdLZ	1406	1393	15	1	2487	jx7wzQpiGCYx4nHvUGCr2Wwhws43U9MCDPE8jTEsWoFFvKqWJr3	1339	1883	1883	1616278140000	canonical
8131	3NKErW8SAk71KrAFccsvsfuBRW9wNTRiBjt96qWY2F42xm6WAZH4	8127	3NKHxTfnZ2iQhx8FhUhca64CniYTVehXWyoh5GmMxgyUhozGzE2K	1600	1372	95	1	6301	jxFC5uKfe4cS8nQAjJPgL6PpGvu4K5KKtgC6Z7rjA3E3bqFm1Nw	4215	5948	5948	1617009840000	canonical
2561	3NKydTvrUos1j5EdPiDWSZkYVzptcCVeCe6bqxu4itNgw744CsWg	2514	3NKUnPeJ33aR2DxKLajnGFqQXG7adWz2ER5WReZKV5osJzqCmbiH	1578	1050	14	1	2503	jxxVz6xwhAC7GFdo2kzBeoZ9FVJHkHX5ToQBQ9sHihDAqwx1J2T	1321	1901	1901	1616281380000	orphaned
2520	3NL3n3tufo1uqD1NXWemNJLHJc318KJqz6JGwULLqHeXKeGf8MGm	2517	3NLWFbhzunVQmpe1vFnNhCyHNV3ZjPEoJGkC5c187vC2CTV79ZGK	1589	1286	14	1	2465	jxLtDDX1k2sgknd4L6fNmQek2BXsz617YkxZwVFZZjdPeLqHsyD	1323	1864	1864	1616274720000	canonical
2521	3NKyHuppukkzCPMQ1UPs6h1PzbLz45JJB14qr8Qbwsf6X13eG67e	2517	3NLWFbhzunVQmpe1vFnNhCyHNV3ZjPEoJGkC5c187vC2CTV79ZGK	1627	1139	14	1	2466	jwnQyf6Rn34rxv8AxspyJHwYWZUKwhfx5EW9Hr3b9KFFUMCve9T	1323	1864	1864	1616274720000	orphaned
2523	3NLxi9j4qDPDz4AnGuqRcrSU1oP9tsF5HPy4ApoFxx26ba92sTvV	2522	3NKQV5TBdmZNS66LUF5dhTZbuU14frKzsPWQnnfVjXF4bPQ4J5qt	1506	1373	14	1	2468	jwsSiTQuco9Qzr244RW7bVmJq5hBtNBFznPSuVoSDUi33TJgD64	1325	1866	1866	1616275080000	canonical
2529	3NKmRy1wuGbNbURn1e2CmiLRs4RtLAw1yb3DXahVUPtggu5SHFZs	2527	3NLX1YTdSE5kDxC9mvoWSLn85w9jyxMq91ykizwMYn3KxMX9HnWV	1637	816	14	1	2474	jxDtfSv55eBSYP9TytJgXfrL8MBiLxLFDDqf57jZWwnVyC6KdUP	1329	1873	1873	1616276340000	canonical
2531	3NLMUCvFywVACTSmbrFzvoY5f3HwfRLDfCdpZcrFiVmuDThFpp4V	2530	3NKxLEXB8WGNp2ngnuKk7PrUAQhVnKoGmujKx2tZvjjSYgVq3pFD	1600	410	14	1	2476	jx8eebiArUN8VGMCpW4485DU2CoLYwMUwT47LqcCRtv28b3iDzv	1331	1875	1875	1616276700000	canonical
2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	2531	3NLMUCvFywVACTSmbrFzvoY5f3HwfRLDfCdpZcrFiVmuDThFpp4V	576	1229	14	1	2478	jwKmGrFC7Yv5N4qoTgqiwT8cFCKmYM2fgnPg88MydRhd6oZb6kw	1332	1876	1876	1616276880000	canonical
2534	3NKjEfCzCZcfoakkg4i2iG9g2X3HLx2YuSiVCtNiNYRfzStTSRWr	2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	1458	957	14	1	2479	jxiWEPJ84XJWmqEeFAHBBwp98N8g7qwMWUXxoVQwxNxNeHZQRZV	1333	1877	1877	1616277060000	canonical
2536	3NKvhb5kymk4jVVYgx5MyBMeV2yrZVMboxne8GQZyyq7Q2QS8jkT	2534	3NKjEfCzCZcfoakkg4i2iG9g2X3HLx2YuSiVCtNiNYRfzStTSRWr	1439	1279	15	1	2480	jxPuS5p23y8C9JvRDPrqkAYqTaX6DevjXoFSa7P4KDFtEjgo9Uf	1334	1878	1878	1616277240000	canonical
2537	3NLXnEZhSGFhGiqrk8gdPX2thH7BWjUu7oSKh8WDLSDFUHUQ2gFC	2536	3NKvhb5kymk4jVVYgx5MyBMeV2yrZVMboxne8GQZyyq7Q2QS8jkT	1651	1175	15	1	2481	jxGtVF5P5KVjmLmKhFHBoQcWqJ9tpcUFiNeQgLot8oP8rEZQa7R	1335	1879	1879	1616277420000	orphaned
2540	3NLsqcCeffMk9VR64VK1kx4RtbiWCJcjAqGN7unhkMtqiGNjKd5s	2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	1599	1287	15	1	2483	jwmrib2ydATB44h7jWzoYRgnAhNtUYiU6qPmRJe9cFdabq7zozQ	1336	1880	1880	1616277600000	canonical
2539	3NLZJM9Pbf1XonL5rdqHXvKYTMgvbREwZnmKnE6JwYU5QAdYRvaW	2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	1405	873	15	1	2482	jx5gaAFojS2jxSV3cFpBcdAmZbqdm53iykQvmSRXAQZDAW32oBw	1336	1880	1880	1616277600000	orphaned
2542	3NKHwaFeFJpBJk4HnapVDRks3KWa6hWTu6vCjK7RbUQuod6bGx88	2540	3NLsqcCeffMk9VR64VK1kx4RtbiWCJcjAqGN7unhkMtqiGNjKd5s	1559	987	15	1	2485	jwzPdpsAPC5ScYMw6H9UwhGTStFAX2KiKnaLfZky4jV9tsCHvEc	1337	1881	1881	1616277780000	canonical
2543	3NLQ9ryh67Gftf5RFu7NuiNopj7o7m6i2vk4rWfJxgWybrpGBdLZ	2542	3NKHwaFeFJpBJk4HnapVDRks3KWa6hWTu6vCjK7RbUQuod6bGx88	1406	1393	15	1	2486	jwXvKjyizUt5btaue8GWA1iDZmv2f9hYoLPCw58X6mdfxDyVzYE	1338	1882	1882	1616277960000	canonical
2545	3NLQpUKgFqMw6pa7hMdRHkdac9yM9ZvWgK6GA8jAPt9CbgwzzGzX	2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	1642	1367	15	1	2488	jxCgq46mBUar49gTt1WBw7HatmngweDjSVtyepkyukq1w1rwRgf	1340	1884	1884	1616278320000	canonical
2547	3NKMsMAfNQmwHtALppaxMZNrm2BY37DymJva3j3nDy4azMmx1cZN	2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	1587	319	15	1	2489	jwcezy5xWykAfaS8znSYy25jvh2dps6HQKCaDNfiAWzSUzLJGPR	1340	1884	1884	1616278320000	orphaned
2549	3NKFAudBwn4edkUFTVLmhQp2mXJRumNDrKwhmgZfgHD7nadBFh3f	2545	3NLQpUKgFqMw6pa7hMdRHkdac9yM9ZvWgK6GA8jAPt9CbgwzzGzX	1402	810	15	1	2491	jxqx4SQegSh98Xj3GGMQFTAAarPxaWUHji67sMJmkhxBCAybPyq	1341	1888	1888	1616279040000	canonical
2548	3NL7NMivd9H2WCtBuMwfwEyT5JZuewEZGq4uwY7kUR9vpNK5vYdm	2545	3NLQpUKgFqMw6pa7hMdRHkdac9yM9ZvWgK6GA8jAPt9CbgwzzGzX	1579	1263	15	1	2490	jwS3M7QFDMrtczRWtNtAXGdUFzDrjhU1MwZphQqBHy5P3EmxA7X	1341	1888	1888	1616279040000	orphaned
2551	3NLVpTxMsshZLoTki2AqwQeLQKjfNoRAeyJqBNcNnCJKxsXa4UX1	2550	3NLmABi44QnET56cC1X81ctrFh39AGjVw4GASiC9mqY7xb8xzVnF	1647	1302	15	1	2493	jwKwfhx1LBPQvEmroDCNFzABqS7QEDS64hfAWsKcTmPDRXC511U	1343	1891	1891	1616279580000	canonical
2552	3NKnVmQMJXq5VGx57RH8qAohLKwC4hhCAZzueMUZMcN5Tv8b711j	2551	3NLVpTxMsshZLoTki2AqwQeLQKjfNoRAeyJqBNcNnCJKxsXa4UX1	1460	1198	15	1	2494	jx6f7QqX9mAV6Nh6539J2R48NRwnWLzAZwDHZYzMBQoRu6Gx7xo	1344	1892	1892	1616279760000	canonical
2555	3NLJHf6SvLqZfexBJBUuxEm8tGGNwbKBrGNo6QKGViodk892o6EZ	2552	3NKnVmQMJXq5VGx57RH8qAohLKwC4hhCAZzueMUZMcN5Tv8b711j	1646	1108	15	1	2497	jxHwStenXSdkLsm4adEoToMYZyzZaKVRtEun7LagjCZS2aNXxM4	1345	1894	1894	1616280120000	orphaned
2556	3NLtbHCHosneoZLPqW5d6EYZVuvgRDx9M8NUqhNH4Am1SpNduf1p	2554	3NKRFXrxum8bWMqgGSRkd62NnDu4vadp4VUb9t9rQN9pwfJPvpK4	80	1273	15	1	2498	jxHykH4SsKJEAGRSaZ8tr7ZsDVCkRyQR8qabPzvzzWLbGRuNKJ6	1346	1895	1895	1616280300000	canonical
2558	3NKfxeVDo2C8yqauVgSuvSAaPQPVt8ssT456aqJ1hyDJz1VeSpXo	2557	3NL45CK4s21MrkvvgYLwv52rdsQx7Wd1yNL3CQsoFzHrNs4Zn3iG	1405	873	15	1	2500	jxw8xMFPhDQscZ7oVPJNudKTTEFmVA5n5XBV7k7LwVopWiNJ5Bx	1348	1898	1898	1616280840000	canonical
2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	2558	3NKfxeVDo2C8yqauVgSuvSAaPQPVt8ssT456aqJ1hyDJz1VeSpXo	1447	1219	15	1	2501	jwbuLEu5onjkjKJQfBEpHfM4wocaVQpCzm18figvN1EFrqNwU3r	1349	1899	1899	1616281020000	canonical
2562	3NKHcq7xArxrUGUJsoe5Nw8tZr7aNhwiazTbbxzmTYHTm9iz413w	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1651	1055	15	1	2504	jxovmy3jBmz9WCTu8vcNBpQYGctAoU2TAXF9AuHwHQocMgCGQo1	1350	1901	1901	1616281380000	orphaned
2564	3NLThK9PPiPBdBBVpmxy4pfrf4mqBGjwyJ1Rbuhkr1xWMN6CeP3Z	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1651	1055	15	1	2504	jxCWzWuXtywYhs2CFmF9XnnLF4ot3tRFD2mf5ZMQSLhNSwHVDnB	1350	1901	1901	1616281380000	orphaned
2570	3NLp2UmJHBhphR4SmPEGdeBS2wDbAxtnjn3WjYdZgkNdW7T3eeK5	2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	1445	1290	15	1	2511	jwwYuaeNWXXJS5NShfkXyYvbaRd2hLgRssgk7MfCz4TXvWqtU3k	1353	1904	1904	1616281920000	orphaned
2571	3NKeadxSNJd24Yw3jPLgRWsX2HWy74qxLQFtExUsfp1ZkGLwbJkH	2567	3NKUsh1Jr3tD92ZnSidZK9VnHpHMpmRkKjYDK54piT7B6q2ebdCJ	1407	1395	15	1	2512	jx96fDoGYkToezmsFkjkyPk5ijsbZbv6rMHxfpQej88G4ombGSs	1354	1906	1906	1616282280000	canonical
2574	3NKyN8RrQ2qsXB13eZToRjXcTr3VNZPacZgVN7q5KPYjngcU1kag	2573	3NLaYB8MHrq1bKfsJScWz5pZY96Bxqrabih3UNNhpUcddYgQf2CS	1555	981	15	1	2515	jxtjkPxf4BVSJxAoQTS9FmLpjAaRkG3YsX8XAfPhsQFiUz1BfNN	1357	1912	1912	1616283360000	canonical
8137	3NKGTKNEZ7RXeAJaMX1XSKQJxuY6LW2YJsGK4zCXLt6C5bSpGraS	8136	3NKeLLjh9aPCnePEJgML5wUhsoMRFGDU7mJGGht4Z25isngekV5N	1402	882	95	1	6301	jxcJJfJtZyuoecPxevQ8Xv2DV4ppRMfuALdboZWusVRKTnHxtD2	4220	5956	5956	1617011280000	canonical
2553	3NK6uWsjghCTMtKVUtG8mKgRtY126hvhSLdwBMS579NFZJQBXk7X	2439	3NLRmzKyYXZpoXt88EKTQmG3KFAMAsiG2nPYWm2QWxt7Pdz5n34s	1403	824	13	1	2495	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1277	1892	1892	1616279760000	orphaned
2578	3NKsyR81VHhYVvvbDESndUhHo6Q9fZFQNJXvRkGhWLesQ2tC1Xck	2553	3NK6uWsjghCTMtKVUtG8mKgRtY126hvhSLdwBMS579NFZJQBXk7X	1403	824	13	1	2519	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1278	1914	1914	1616283720000	orphaned
2602	3NLyVsYufmfrLg6trGisyL116uJEp6Kbkw62NWHTKsvFrPu2Tgx3	2578	3NKsyR81VHhYVvvbDESndUhHo6Q9fZFQNJXvRkGhWLesQ2tC1Xck	1403	824	13	1	2543	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1279	1928	1928	1616286240000	orphaned
2546	3NKT58MmQpmjtjSD4fyEw6JVCQFifiPm17pwN1pRcGq8Kis9wSp4	2544	3NKt8anfqFbCfJXvMvAgJvxaZbZWw8z9cAML7rrQi45Wauvfoi4K	1587	319	15	1	2489	jxvMPkx649ZZhtNCePDdWZw74wsdZMTQGDTdK1KpoPmiqF5pE68	1340	1884	1884	1616278320000	orphaned
2550	3NLmABi44QnET56cC1X81ctrFh39AGjVw4GASiC9mqY7xb8xzVnF	2549	3NKFAudBwn4edkUFTVLmhQp2mXJRumNDrKwhmgZfgHD7nadBFh3f	1407	1395	15	1	2492	jwNY1GHAYL4iRLMvtec1XuQc4LaiZ6tsh5nYxQH4F3cDf8TDc8L	1342	1889	1889	1616279220000	canonical
2554	3NKRFXrxum8bWMqgGSRkd62NnDu4vadp4VUb9t9rQN9pwfJPvpK4	2552	3NKnVmQMJXq5VGx57RH8qAohLKwC4hhCAZzueMUZMcN5Tv8b711j	1402	882	15	1	2496	jwD3BzcJ2Lacu7idj3pQZrhJzo1Z5GRbJWQZViupGRu2pjVjH84	1345	1894	1894	1616280120000	canonical
2557	3NL45CK4s21MrkvvgYLwv52rdsQx7Wd1yNL3CQsoFzHrNs4Zn3iG	2556	3NLtbHCHosneoZLPqW5d6EYZVuvgRDx9M8NUqhNH4Am1SpNduf1p	1555	1347	15	1	2499	jxW1qdDDDVyNL18uELGRZwXp9gN5dy7L9rddLNtZQW7eaBSDDkZ	1347	1897	1897	1616280660000	canonical
2563	3NKb2j7AECPkwD8yirfL519gUEziDhaFefxqCXrnbqzgWrckxfuR	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1578	1050	15	1	2505	jx9jf5wqBGP7EHvn3JkJq7x2B87Nm6UZvcub8chwGRA5MX1t1QF	1350	1901	1901	1616281380000	canonical
2565	3NLXvWZz4y1a5AdLTzNpTf6qJAr99iy56gV2fe2MGyvijHF49pk6	2563	3NKb2j7AECPkwD8yirfL519gUEziDhaFefxqCXrnbqzgWrckxfuR	1405	865	15	1	2506	jx8esXGnf9sSpFQSwL2vZZ831AE3D9SxQURGtUpmPbdkHTauacy	1351	1902	1902	1616281560000	canonical
2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	2565	3NLXvWZz4y1a5AdLTzNpTf6qJAr99iy56gV2fe2MGyvijHF49pk6	1585	1366	15	1	2507	jx71RvQDEuPdJgqMnajg9m44hdADuR3n3kLmA5nkDMhBgWFgrdj	1352	1903	1903	1616281740000	canonical
2567	3NKUsh1Jr3tD92ZnSidZK9VnHpHMpmRkKjYDK54piT7B6q2ebdCJ	2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	1467	1250	15	1	2508	jxxTJfSSwrsdoBfGj2d8wKdqrU1K6zzKhuKVVnsv3rvrEpKpter	1353	1904	1904	1616281920000	canonical
2568	3NLn66ZftSkahBc7n1M7fLuKqYWnH3ehSs6NtEMexuMw3zuE4WoB	2566	3NLhmqTECW3t5zqnz4CF52SifXCGt69WqtHDGNyU487JfZ8gm1MP	1407	1395	15	1	2509	jxFLdzM56gnH3fbWXzmevGyP5W52XfrjgY7bNx199eDSzhst5hL	1353	1904	1904	1616281920000	orphaned
2572	3NKy2kMCNy94VtGCaSoJ3NijKKgz9ve3Ten2QcKK5MqqcN7ZZNu5	2571	3NKeadxSNJd24Yw3jPLgRWsX2HWy74qxLQFtExUsfp1ZkGLwbJkH	1467	1376	15	1	2513	jwCi7hS5uL4kFHaR1gUYsmiGWdrxTbFko7En3ESDziJgnoMv2PF	1355	1908	1908	1616282640000	canonical
2573	3NLaYB8MHrq1bKfsJScWz5pZY96Bxqrabih3UNNhpUcddYgQf2CS	2572	3NKy2kMCNy94VtGCaSoJ3NijKKgz9ve3Ten2QcKK5MqqcN7ZZNu5	1631	794	15	1	2514	jxwcy1gFcCX7tsZh4QPN2Y73Ah6H8tMMz3sXRL856EijgNe7muy	1356	1910	1910	1616283000000	canonical
2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	2574	3NKyN8RrQ2qsXB13eZToRjXcTr3VNZPacZgVN7q5KPYjngcU1kag	1553	776	15	1	2516	jwje6zzViVSM7xX7quzFvpPUT46uPrzxyEaQibzrfyiAUXLun3e	1358	1913	1913	1616283540000	canonical
2576	3NLxdBuhJPU3XJY6YvKs2CSHyHka8QRtZdUYbpUzLVp4bCF8T1tF	2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	1407	1395	15	1	2517	jwvqF3XaH8AS2kKeeKd49PigEWw6RaFvSquPVRTnM5VdoS5DddE	1359	1914	1914	1616283720000	canonical
2579	3NLL3it8whJWQvXz82h7bPCLx2L3spQPoG1NkDs1L5NZxWixYgQM	2576	3NLxdBuhJPU3XJY6YvKs2CSHyHka8QRtZdUYbpUzLVp4bCF8T1tF	1672	1285	15	1	2520	jx5SCCxG4L7CfS144SNa6SFAKdfkvnJmXQ5RALw8219N2foJsyU	1360	1917	1917	1616284260000	orphaned
2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	2580	3NKKGc4F9fKxr7QmsKT5E1VYxXZSro4StRDoL5oZtXmJ7WcYNVfe	1457	1391	15	1	2523	jwoTUez4pVqUJCjP89Bvi4kBFnnbuCgJQKQHk7wfbtPprrKgAzy	1361	1918	1918	1616284440000	canonical
2581	3NLnLKpVqnpdKNgnxWDLVz1Y1BarozA3dEbheA5A1cx7JofSY6oC	2580	3NKKGc4F9fKxr7QmsKT5E1VYxXZSro4StRDoL5oZtXmJ7WcYNVfe	1402	874	15	1	2522	jwiZ86oHha1kiSqa5tf1pu73toKGVHHNEz5W61MUK6df649Dwwm	1361	1918	1918	1616284440000	orphaned
2585	3NKGTkr6Rf5gfcmrV5nmmD28UMwS3T2xZNNY6tje5bLkzbAawhFU	2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	1631	793	15	1	2526	jx3viSazvB9iY1peZDhmJ4jDHXRfbAN4kYzYatTcTRm76ds4qzz	1362	1919	1919	1616284620000	canonical
2584	3NLTq5AvNyDFbVH9BRKQUTpyoitdjAnv663pUsE9NhuMcr1sHBzf	2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	1405	851	15	1	2525	jwwYpwf12xTRqiThRWCwu8toCuBiDJsS95RdnYYD9SFhdtsWdCV	1362	1919	1919	1616284620000	orphaned
2587	3NLb1TpDikZPbUzqEtThuJCJuxVdGtC7PJ9J5gycHAfRePcaL6LW	2585	3NKGTkr6Rf5gfcmrV5nmmD28UMwS3T2xZNNY6tje5bLkzbAawhFU	1527	1167	15	1	2528	jwP11a77mhaEn8v99UCzJNui6xTaR8kLGPYXdeqeWtSJ8R7DPPY	1363	1920	1920	1616284800000	canonical
2589	3NLfidrJru32R47ykCrcpU2YHcipeyWuvPRFDN1xm6rRoX68qDHh	2587	3NLb1TpDikZPbUzqEtThuJCJuxVdGtC7PJ9J5gycHAfRePcaL6LW	1602	1003	15	1	2530	jxPzuQ3C9tnV7Ty1faAfMvzq5a2jopxvztCERQyhQ9C72WSaQd7	1364	1922	1922	1616285160000	canonical
2592	3NKCn9Abb5eTLoqZKrS7QKT7FiRwBekQ7uiXn2U82YTerhQZgoFD	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1509	1320	15	1	2533	jwSvDGyCozQB3LAiABnnF5t9gU11ZidNAdmi13Y828AWBqeusEp	1366	1924	1924	1616285520000	orphaned
2595	3NKYQVXEkBBLbq2QkmVHhsaKT5UtYrmKs9B82BaevHfPwzPiyGT9	2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	1536	1313	15	1	2536	jxcfMS9NZzVPpxudAh9ew8DsJjMrhHunr1JxbmUh2XcAiTbvXfF	1367	1926	1926	1616285880000	canonical
2599	3NKqiRMA4KdWKuZ2UBAf7rUEJnjXDsbgsjRvV5EvTPqEpk3tNfg2	2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	1503	1151	15	1	2540	jwF2mhs9PMBt49yXJGFzx5FB5AVxUs4RSKhemFta1PBRoKbwbXZ	1369	1928	1928	1616286240000	orphaned
2605	3NKpar9YobFV1tH6Gvgcv3RMDEgARTuZZNXQ7y3urTRwBiTW6WkB	2604	3NLVCk5bA1nCQLCqudxY8gq7TfASSxvuvwkgcAz1QCMjcvb5ijLE	1507	1034	16	1	2546	jwGBDqCTmyjXDeMW1mxcqJ6j7kMixv2E6TK3bfVDt3gdKKEJjeY	1371	1931	1931	1616286780000	canonical
2608	3NLNJRgnSxAPG6w5t8aXgF3AhuRGWsSnnWCoaccGKZZDmVeAjfq1	2605	3NKpar9YobFV1tH6Gvgcv3RMDEgARTuZZNXQ7y3urTRwBiTW6WkB	1637	816	16	1	2549	jxyjiwUJpEgZ1CaJMjTPKmRC6NS8ohXEc11s55pAiFZUBrUnCmw	1372	1932	1932	1616286960000	canonical
2610	3NLx49mpdZiUrXAtoC6rrzDLkY1y1G7pyFrcTonKTqsCEGQ14izX	2608	3NLNJRgnSxAPG6w5t8aXgF3AhuRGWsSnnWCoaccGKZZDmVeAjfq1	43	1064	16	1	2551	jxSLVHWQMV7MnDdbfi64JgJc2EtdXKk6bY1cDuQY4tMoGLfqxhe	1373	1934	1934	1616287320000	canonical
8141	3NK72q4pGFASkHZNsmYdm3BKmFnL9bfPxduA8Rggb4KDBMFxfRsG	8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	448	939	95	1	6301	jx4anu91TdjKwTAuwr11MxwtrVLhwJvViAhTPRhREsBeGS1WMko	4222	5959	5959	1617011820000	orphaned
9708	3NLMNpeN76th9armsuf4pMTw9AcLoNAuGHcMCGnxvcJWcfcai7QE	9706	3NLSTPzj4qQ2ueFhonHSJiKTVZJBqF1xVFhRebBNUV4bmfMfaEoj	1585	1366	125	1	6301	jxYZeqGBgbbPK4sd753y3bqKLsM1zySRas1gj3PJNcjzzPyyZKv	5035	7085	7085	1617214500000	canonical
9983	3NKFaWLJZW9pqHPs69CRS9fw9rFz8kNsUS5dNcFUyrtVCBaX376q	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1523	1321	131	6301	6480	jwAeM47XsFHCX8i55HfJG8BihJmW3T2SsGfFPDm8yRwG8SgV8tZ	5176	7281	7281	1617249780000	orphaned
2617	3NK4xcbqzEai4gFyg1gB97Vu5uCjEXh3Qs26rqzzpTtbDffMENyg	2602	3NLyVsYufmfrLg6trGisyL116uJEp6Kbkw62NWHTKsvFrPu2Tgx3	1403	782	13	1	2558	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1280	1943	1943	1616288940000	orphaned
2609	3NLdKvgPC7ZAySm62gCyGJJ4oE6w7zA6pnWkKZi5J1Psxp2VVKA5	2561	3NKydTvrUos1j5EdPiDWSZkYVzptcCVeCe6bqxu4itNgw744CsWg	1578	1296	14	1	2550	jwh4fUhQAzxQzK6RXUFeehoYYv1i9AdJAT5U2qcY7jcwP44BwQU	1322	1934	1934	1616287320000	orphaned
2577	3NLHyU3Xzr6VzMRB9unxSCDvLwnBMZtZVKegci9C6drYM4ssu9Da	2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	1648	192	15	1	2518	jwtvBsb8XYmTWCVjKB95cobRuWYVBHbD3A2BWxKUWPnqaQsnTVa	1359	1914	1914	1616283720000	orphaned
2580	3NKKGc4F9fKxr7QmsKT5E1VYxXZSro4StRDoL5oZtXmJ7WcYNVfe	2576	3NLxdBuhJPU3XJY6YvKs2CSHyHka8QRtZdUYbpUzLVp4bCF8T1tF	1613	1103	15	1	2521	jxyEpg32zBgvqeiPARBgieTuR2Ue5n5B2bLxiLzccRar9cDYSJH	1360	1917	1917	1616284260000	canonical
2583	3NLusbXBtpzMTEcg6bmFnPyJ5AW5ahf9MkXddig944KmdEz4zS7D	2582	3NLB5C6YYi8w5pHtTszbsHSL6roxtamvvKkX4dVRipB3dvr7qxxc	1407	1395	15	1	2524	jwR77cStccr1Z4BeKC6Z8pajPkMMg8C7qLsFwNsYHa66coAoJR4	1362	1919	1919	1616284620000	orphaned
2588	3NLPBPJZodsedRsGQt5wUnDHqqBRT97fpXQvSoVFG8oAuJoKR4Ry	2585	3NKGTkr6Rf5gfcmrV5nmmD28UMwS3T2xZNNY6tje5bLkzbAawhFU	1553	776	15	1	2529	jxpRDKtTDyi3CZBBTZVgyTkj2TNKuHtxY2TXxX51h1naGX9fPRC	1363	1920	1920	1616284800000	orphaned
2590	3NKqTgVq259TMxnEmx15M5RSsvLd5cwWjGQhjjJ3zqaRiPegF2Qi	2587	3NLb1TpDikZPbUzqEtThuJCJuxVdGtC7PJ9J5gycHAfRePcaL6LW	1637	816	15	1	2531	jxAgGjKRaccthFbtJWKH2xECzMy261EynkeMHxK5eky9xcRaJtC	1364	1922	1922	1616285160000	orphaned
2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	2589	3NLfidrJru32R47ykCrcpU2YHcipeyWuvPRFDN1xm6rRoX68qDHh	1402	850	15	1	2532	jwnmEWpPcfQGLGTaNZs644cuPaWbe2n2WCHYvUivFXmVsdaQjkZ	1365	1923	1923	1616285340000	canonical
2594	3NK8RsaDPyBpGyjWPCFdMSuhZbXmPq2qfQqxVdgPgeKiVsqfuXkQ	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1473	185	15	1	2535	jx2otfHtStP5Uz5KwgMAw8bxsi1THL1prc8DByCT3mY9p1TU1kB	1366	1924	1924	1616285520000	orphaned
2596	3NLFFLSwmkHYqoWBtLikmreU3uNcXrk1CrC4Uux3HJHnLewtWUme	2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	1623	830	15	1	2537	jwqkyKAG3tWtyBzQQ9ZRsgq5RyEgZKZn5a57zQ8ya8t6oX6Cjby	1367	1926	1926	1616285880000	orphaned
2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	2595	3NKYQVXEkBBLbq2QkmVHhsaKT5UtYrmKs9B82BaevHfPwzPiyGT9	1483	1276	15	1	2539	jx4bVAeCgd2opy2N52Y8a493pejhKSNpoHaLJbwVt2Ar316w4Lq	1368	1927	1927	1616286060000	canonical
2601	3NLJBiV2RSq25LGNUmr1ReCzMgXoN9u2vJqooJzf9UyhNnSwpu8J	2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	1596	1363	15	1	2542	jwC2GikqzPvAborRYJmYhoFtoXiPeWD93XWxnndh4LF61NkvjQ9	1369	1928	1928	1616286240000	canonical
2600	3NKuzrDkMP87ZLarS5DgJwtx6Rz7Z6y3cnEjgpqYehCfDCdSWdp1	2598	3NK4PEPWmqw3ZeEsJDiYVBbzsRoAktYRjvudVEaydd4asjzfZ8VQ	1654	974	15	1	2541	jxAVJXKPK99XNJg7pJ6yHd8ZanXzuCVo9mbWymj9oDjp5L8vcSR	1369	1928	1928	1616286240000	orphaned
2604	3NLVCk5bA1nCQLCqudxY8gq7TfASSxvuvwkgcAz1QCMjcvb5ijLE	2601	3NLJBiV2RSq25LGNUmr1ReCzMgXoN9u2vJqooJzf9UyhNnSwpu8J	1477	1104	15	1	2545	jxNRdniDCe2zMSaZByH6T37i8FoMs3AZvyodke78hFu7QVpBLbF	1370	1929	1929	1616286420000	canonical
2603	3NKy3LTftVNA5Xx3ffixAf8QHyFiKNiwYo62ftPaDx5MrtS5MTE8	2601	3NLJBiV2RSq25LGNUmr1ReCzMgXoN9u2vJqooJzf9UyhNnSwpu8J	1407	1395	16	1	2544	jwwSPjs865tAmAvVdBLtf3FH1x4TWWEPYxwePhqrBmo7v1CwgvK	1370	1929	1929	1616286420000	orphaned
2606	3NKoLTSLDudyRCYim2xbbcx9Pukj2LDyyvm8RqpfuqnM8Ue3DEq7	2604	3NLVCk5bA1nCQLCqudxY8gq7TfASSxvuvwkgcAz1QCMjcvb5ijLE	1637	816	16	1	2547	jxk8AqNWzeRZXr4AC3pQjct9bTxH9DAjLVbtgruWb2q5CUwtQEg	1371	1931	1931	1616286780000	orphaned
2607	3NLeV9LptSNgsYqxbGxaUUaa9vXq31MKE3JKn5aHgvpjHoXGZcBY	2605	3NKpar9YobFV1tH6Gvgcv3RMDEgARTuZZNXQ7y3urTRwBiTW6WkB	1527	1167	16	1	2548	jx2xhR91Kq4hXz4aDmsn33uWN8UCrHv72NjFvJWQK1ExVXuEkGx	1372	1932	1932	1616286960000	orphaned
2612	3NLg1yN1cQMQuwkRuHR1EFQm6qveZ8wiZX3smnCCJcscKVjp6nns	2610	3NLx49mpdZiUrXAtoC6rrzDLkY1y1G7pyFrcTonKTqsCEGQ14izX	1406	1393	16	1	2553	jwoWQ7cB5RbSUT7YuV5KYYUbVQFeni37H33h8ahGqyrWJqoqH8Y	1374	1935	1935	1616287500000	canonical
2613	3NLTeAXhGfsQpXP4w2f5nLi6TMnoUfVJGcPQBJVsLWp6wwo6CEJU	2612	3NLg1yN1cQMQuwkRuHR1EFQm6qveZ8wiZX3smnCCJcscKVjp6nns	1599	477	16	1	2554	jwnHwjrLoPpAHA8o9HWuD4y3DcnuMD6UEeDseoqnHcWnFwNMrxy	1375	1940	1940	1616288400000	canonical
2614	3NKk7ztxQ4UmLxWJwU1kfPmsi1MdK9ScntFi8HqJjFwCVoHAG8hM	2612	3NLg1yN1cQMQuwkRuHR1EFQm6qveZ8wiZX3smnCCJcscKVjp6nns	44	1325	16	1	2555	jwCgnqF2WNqJPgnwKtJ9R5xYESzJKGTTmBf7Yoj6pGrDpMaXQV8	1375	1940	1940	1616288400000	orphaned
2615	3NKe4kfrP13WRhZPTmU1ZxUgpZscWPNP1ixvR3uAoZd8AHvsEDh8	2613	3NLTeAXhGfsQpXP4w2f5nLi6TMnoUfVJGcPQBJVsLWp6wwo6CEJU	1613	1103	16	1	2556	jwCzQWhy2KYDW6JEpMKgPNLNJFSanHAenwn784akrtpnmuX8cwD	1376	1941	1941	1616288580000	canonical
2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	2615	3NKe4kfrP13WRhZPTmU1ZxUgpZscWPNP1ixvR3uAoZd8AHvsEDh8	1587	1357	16	1	2557	jxMny7BaSCMznkUFRt2PzXRhAkYhAC8EZwYvZ8rQUHo3thoHtKc	1377	1942	1942	1616288760000	canonical
2621	3NL4SsSq8pWeypnc6BGR9jTX7RzN8nUkm4q2FcxUDHTrL61BKFwT	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1581	778	16	1	2561	jxV4zFemw7MHAvqZkmycJxhDcxuQC77LQoPkMW4pbtCTGiyEzT4	1378	1943	1943	1616288940000	canonical
2618	3NLrqH1eKuZamQ49v2F3gj9YwQP8f3uuQBSqVfAXk2BBvwkwbddu	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1652	1315	16	1	2559	jwxoNKhapHxiMfWtJ2Mk1xcVazUNkzWiLT5EYg539iNiQEKvXMQ	1378	1943	1943	1616288940000	orphaned
2619	3NKtv5dT7R1Ubq8x6fuceZWuQUbYWEY2PD1tt9A8uZ9LqKcptzrD	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1406	1393	16	1	2560	jxdNwwEhxuhC2gE9iRn9oZMuFx8GPhnsq8g7Vq5j4UWJ3X7aj5c	1378	1943	1943	1616288940000	orphaned
2623	3NL74u8qM8CikiHZXLYPJeKrf9httJQCCfS8R13ZmxDU1QzoBNqd	2621	3NL4SsSq8pWeypnc6BGR9jTX7RzN8nUkm4q2FcxUDHTrL61BKFwT	1610	1314	16	1	2563	jxyXE6dhDaXoHkL4ycc2JdyPifQzY9Ucd7dpznVUhM7FEqajZgE	1379	1945	1945	1616289300000	canonical
2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	2623	3NL74u8qM8CikiHZXLYPJeKrf9httJQCCfS8R13ZmxDU1QzoBNqd	1527	1047	16	1	2564	jxQzRndt8mo45vsgYDKkSGoFnh98kGkha5JnuYQHa9XZy7gRPAg	1380	1947	1947	1616289660000	canonical
8146	3NKN5utzRRWxMXH6ae718f27YSWpe8iWeE8LAewkbsPtbj6k2Hop	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1631	794	95	1	6301	jxp3cZ4hWM9g5etaASjCTAvtzUqJVzqqYR4p6zKo2PwV5chnBg8	4223	5961	5961	1617012180000	orphaned
2626	3NLGHaaUkWj4oD4WtSTXeudpK1LUcYULsfZKA32E7dymFUrxwAf6	2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	1451	1292	16	1	2566	jwqzJKasEmEuwEtYcfv6mEcbNBQLhK5FVDRCJDKm9nPDV1N8ADW	1381	1948	1948	1616289840000	orphaned
2628	3NKCxJXu15oFHahQJ75pR1R2wkn17Dwq5mpiSyvPXzqshJ2sArbU	2625	3NKGygFghCvHn4YyrAYhS6YhHxAuc37uhnEYjMzSP231nvfyCNi6	1503	1031	16	1	2568	jxbWbgbnpz1X42u7P2HZUZzCaF5VPoeRXh2dNZB62cxxiEFxuXP	1382	1949	1949	1616290020000	canonical
2629	3NLqyRvt71G3pbFiA3NQriv1eQTZYhYjt6Xpocntr7efMm9UAwKb	2628	3NKCxJXu15oFHahQJ75pR1R2wkn17Dwq5mpiSyvPXzqshJ2sArbU	1631	794	16	1	2569	jxdfpVFNZHvKx21BQFpxqY89agLsSEZDPCtDk6xZNx4KkJLDFTa	1383	1950	1950	1616290200000	canonical
2630	3NLYU9QrT6yjaAQoM8QbpWnCW4f2MZDc7xRMCtJ1oV5dCELZqgRe	2629	3NLqyRvt71G3pbFiA3NQriv1eQTZYhYjt6Xpocntr7efMm9UAwKb	1571	1335	16	1	2570	jxZ8SgwHDKsHGabhLoMBZXiHgcSNAuC9F8pLinzgpGUt46EJ4QC	1384	1952	1952	1616290560000	canonical
2633	3NKZfmSLQWAkyxjaBugP2RAVuAr8A4VVra42G5gmUh4JEGitxj3j	2630	3NLYU9QrT6yjaAQoM8QbpWnCW4f2MZDc7xRMCtJ1oV5dCELZqgRe	1406	1393	16	1	2573	jwhFzDBe3aP8ZwwKPmceqT8u8hKurzsknFTftykEhKtWg1WQWdM	1385	1953	1953	1616290740000	orphaned
2635	3NLG5Bby4RBpwohHkaXzT5DxVMHKRk57nHEaF7n6YkgriAeg1QGC	2632	3NLoz5FLpjtQNTNMmxAkSZkFcgkNgMNkNXFoSRGcd7wZvJYZMACi	1652	1189	16	1	2575	jwKdVrZn1mihBjhL2TpVqMGyr9xqmmC6Ph7PYov1PDkadhHgEEA	1386	1954	1954	1616290920000	orphaned
2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	2634	3NLagWk5vkzx76GodF8cXnKDTECV9T89bEB1qXsmKCM4KERo2ocJ	1608	1043	16	1	2576	jxhPnFVs6MA96zSdD67ZqoGnXVxbSi2Z79fMcHLj7t4ZxmQesQQ	1387	1955	1955	1616291100000	canonical
2639	3NK5A3X7JJiJ8rwVg2uGmcEL6iuxsS18DrmrkMZgHktUt3isbnXK	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1527	1047	16	1	2579	jwXhDcdCqSVyzV57GLFxfviqKKZXoBaZQfgPQdkaPjcx3qVfLm2	1388	1956	1956	1616291280000	orphaned
2642	3NLTTwyG2XwG31jvz9VSYycdTCsnSG69vtHixQA9Q9PB4Mi1ECA5	2640	3NKXVMJF8HGcKmEFgC2pLdAj9Kwu57stKJgzUVmCND3s66ZFfA41	1406	1393	16	1	2582	jwqzYDH5CKHeqK2Aan8EXarLF4rNjQVHPmQZPNNRbkVr1hbQJMN	1389	1957	1957	1616291460000	canonical
2645	3NLnG4SBmBBTrGsmZLUS64FYHDQfdpmPTQaEKxGRxRPNwQEw9y3T	2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	1608	1289	16	1	2585	jxN6RshBWTQDEvMtYckANrdVLbFgC4WEg5XNvrVJyBs7T1RiPYC	1392	1961	1961	1616292180000	orphaned
2648	3NLLDCuMdmE3YSQKH5AN2KTjVq8BSjLg65qAEx9d5WdXogGatLQj	2646	3NLRubfPHrLdVLtngYBF49UZztBXy4bZY3p6o3eFRmQAHZ8seSuD	1602	1369	16	1	2588	jwp7fFQXd7RwXeoPvt1ijRWd9WLvjgwy1c8UQTvbpnui4avNysr	1393	1962	1962	1616292360000	orphaned
2650	3NKxNDQndytQ2on39jMF4GMDZf9wmLgCfSH5YuY9EDPhJbJ1XuJZ	2647	3NLC1YdWGPwNPpHuEnxc91S5pAF9X1891J4yjakRh4qJiGSQ6CQj	1471	1140	16	1	2590	jxwf9Lvb5ZLjUihnfW34YMjwHqWq58MGowTrVfgRhzjtXUMSEFE	1394	1963	1963	1616292540000	orphaned
2651	3NKatpL1YhWzXEu4DhMFZAEd95PFtQYrwemwg5WLLqQFPKsBvJtP	2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	1477	1104	16	1	2591	jxrcByfzsh5a5ZgiNji1BvJqFwJ9kLLms6UMwy6BA7wcT9gNESR	1395	1965	1965	1616292900000	canonical
2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	2651	3NKatpL1YhWzXEu4DhMFZAEd95PFtQYrwemwg5WLLqQFPKsBvJtP	641	1336	16	1	2594	jwMesV8Re2HHvYHrXBv5wYtRJSryb5Ej9X2fb8jmxKztRxAf242	1396	1970	1970	1616293800000	canonical
2657	3NKjwR6Tt9zX6VEJPgxAjW5fXNoCD5W835s6VC2PLfj7qRFFKR2X	2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	1675	976	16	1	2597	jx55P7ukY43L586FBSFNaSkYSr3JVRJ7Awxwb16AyvgA26KrjZs	1397	1971	1971	1616293980000	orphaned
2660	3NKKZx9sKzpqa6DdiueghGN2QUb4jfPzEipVycRo83F7XnbSYzef	2658	3NKUv1WxMB1jkgJBSxfg1Je6CKJcbLrd28tEKHEn5F45EQvbfn8i	1542	938	16	1	2600	jxDH81xcTpSRCkPkdLZ9kP16cBW52CMgQzRewCguyYanJeG6Y2y	1398	1972	1972	1616294160000	orphaned
2663	3NKzs9tEFDvdJq7r1mxjFsJT6ErX2r79LhzrBQ3qWqeS5wvVA9cD	2659	3NLhGegcXHWQ84YZgQnCtcm8yG8CWGuFkUQSasTBS6iXuX8E2P1d	1652	949	16	1	2603	jxxEtTDx1mpYkFD54vasv5scG4YDYWJcCyZtCyJRALsrbJoReHA	1399	1974	1974	1616294520000	orphaned
2665	3NKK8wJry7Fv9dVBgg3LEHNLeNjZq55GkfNJW8QMxdPfm3qFJQ84	2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	1455	1206	16	1	2605	jxXmwHkLn2Dqgw5Az15NNMHpYjfQcC5q9KPSCyHNToLFf6fN1FE	1400	1975	1975	1616294700000	orphaned
2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	2666	3NKQef4yQfS73G1XoZHhUM9raPqnb3bw7wxV77hyrBYSXFaprcmP	1506	1247	16	1	2607	jwiBGkbiK9KZbuFGQqhzgi7adju2ZemC94WUcXXTMBm6FwRyTUa	1401	1976	1976	1616294880000	canonical
2670	3NKJDCY1MgctG8PHS6ER3GXdXxoDAbd49KHGu1gqGmQvHBddPGgr	2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	1652	949	16	1	2610	jxNTe8wYud526YMpWByEhGDLhUaSZucnz9ZjwgvCkKJzkvps9P4	1402	1978	1978	1616295240000	orphaned
2675	3NKzC4qiL6C2N41X5pfpNsSWmSv6utUwPCHyRvZ7JEw2GtJ9uP7F	2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	1507	914	17	1	2615	jweQVFVeHPk8xGXX2r3B225sZqYUFGM5mB8BnVNkY8sJ8G95cWR	1406	1985	1985	1616296500000	orphaned
2678	3NLFDZv4mMH9WB2qGi7iHEqUob4PNuBS1YLt5pvMWv87GDsCNrch	2677	3NKJvMnGrdKXWXAFTbBcgveheAxy8VFcH4D7ZPZYN1u5Bbq5fSHS	1671	1239	17	1	2617	jwcyNMV7MJtGhq2LtjUTd9Gv7vw9crFbF6ezdLir3kFFzK6gqAk	1407	1987	1987	1616296860000	canonical
2681	3NKyz9nK42rXTYZkg8cpUtqXmF6smkN9hKggvgUrvfUV52gX4bWq	2679	3NKoFgHxcTazLfhbtskTujV7Y8BzUDtg2jhrgZJATL2Ee1HHYnbu	1675	1096	17	1	2620	jw7atxAs12cPVJb6rqfKYNsCUmw5LnBhvgGUBwCiaJUiVq4eYjH	1409	1989	1989	1616297220000	orphaned
2684	3NLPgsKie8rfwwaCW24PCmMin72ogYWAUmAaWwrqbzC1sJS39dyC	2680	3NKjsPKHf7YQy8LjNK5GJdC7uRjYm1wPev69eBWTtnK4nKiDoiZs	1643	933	17	1	2623	jxXjajeb8R6GvFDt7CwyGrtVm6B62CxUNwgRHaLwieuDo1t2vbT	1410	1990	1990	1616297400000	canonical
2687	3NLLWUojY9LtvEmYqjThs6g76jhebjdugWXMTq9z98YaaYYjxHrk	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1422	1337	17	1	2626	jwnKwqPYYRtmrZ8rfbf31R2JxwStStFvz1fzZ7FY8nrz4gtL7x7	1412	1992	1992	1616297760000	orphaned
2693	3NKiGzX8gWTCtq4wdeKKspJojXB3XJhbpzUxTeBBWAmoaohAhaAL	2691	3NLo8KpLYGgwNayBnXhr1ybdrPde6VwvdL67UfASJyHgZB2ZSuo1	1553	776	17	1	2632	jxvjnTJy5sjHgBTMLWbUMhWfg6eZbJuuH12AVoLAArVH17472Kg	1414	1995	1995	1616298300000	canonical
2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	2695	3NKdNnBPqCqp9cDYBR5jPsn4uY3r6mXAt9MsPbsXny3YUVdMMvWt	1405	867	17	1	2635	jwjZeWWyq36xHX52MWwK3NQ6YSvf6FSghj5UQFTitzEgyu5nPDD	1417	1999	1999	1616299020000	canonical
2699	3NKRUZxsmT9NJ1bvYfcSD7pzrmQfDEe7VGan1idSLJQTwwWhRBLw	2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	1651	1175	17	1	2637	jwv6TREWrB42rVqeLhjuMRTnqEZmvQqG46XcH4fMFXyhMBm2XDc	1418	2000	2000	1616299200000	orphaned
2702	3NKvF2mKccw67eM9shyoqgsXh9UPTPE84dohpkjwJ7CLmCaYAusR	2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	1627	1139	17	1	2640	jwTgMhLDxhuFy5gKYdrJG9j853ESHg9osAMiP9imjjr9ZyUke5p	1419	2001	2001	1616299380000	orphaned
8150	3NKbQ29heBG7pyLftuZ24P3CJ3R7KV5GL6FwBKWyzzFD4nbzSGd4	8148	3NKtyUQzf3bStsMzvqVxnWsYiyLi1tQgkiPNH9t6h1Fy2tAqf9Po	1461	1271	95	1	6301	jwnaWptVnXsKSGh28sfmNiVQQfmTPueGJgGWqZpsJhpE9qZZE8o	4225	5965	5965	1617012900000	canonical
2682	3NKt9CzWSmrdfRdpH8dcaPh2akczcBktP8ExLJguXTnmxNaAVpWh	2423	3NKz8FZSGQCfKmBVfaE5xexn2z2zXhqw4mgqCujvSMa81gNWXgVo	1643	933	13	1	2621	jwBxF1EngeeDc9BN539FC43v1MsUNLfmJbVGy4yNLC6oBqP6Tgd	1269	1990	1990	1616297400000	orphaned
2703	3NLLDJaoAYHdAGnYcmNiKqFBCTDjoBk1rwEcYktmsTRswzGFBXzA	2461	3NLTAvzpVrNwz2Cax1j9H95KfDTitdzHJz1v7m91L3qPUXDcApqp	369	1066	13	1	2641	jwwHRL8YZCGm2zavytrrUdVwJHJUh9nTC3mCEFHypdnJHJBUGQU	1289	2001	2001	1616299380000	orphaned
2631	3NKY7ZwJAmYSnZcrzsZbXKJ4ZELwAyivKn8iUArajPf46qhyMre7	2629	3NLqyRvt71G3pbFiA3NQriv1eQTZYhYjt6Xpocntr7efMm9UAwKb	1474	1329	16	1	2571	jxxNnJbAP4q8HRXpForz2yfB7z5nhwoLt2knWJfgytUosR474pw	1384	1952	1952	1616290560000	orphaned
2634	3NLagWk5vkzx76GodF8cXnKDTECV9T89bEB1qXsmKCM4KERo2ocJ	2632	3NLoz5FLpjtQNTNMmxAkSZkFcgkNgMNkNXFoSRGcd7wZvJYZMACi	1634	1331	16	1	2574	jwsqpcdTdnNBdaJWJK7vJhd9buLjMUjZZu47a6uqKx4Nkps9Nmg	1386	1954	1954	1616290920000	canonical
2637	3NKgRtgTLRkbhS8A5HDa4ZhRt4vJ8UhQbTGNi341ZH5e3nFvSBAe	2634	3NLagWk5vkzx76GodF8cXnKDTECV9T89bEB1qXsmKCM4KERo2ocJ	1637	816	16	1	2577	jxuxdoHaBAzKK9DpjYt4K9v75ooSTGis21EGHt9GAa3TbsR2U3N	1387	1955	1955	1616291100000	orphaned
2643	3NKhPdBraP28GEeocEoQ9EUt6y4aaB5brVjvz7c1iwGMaVRJ8u3S	2642	3NLTTwyG2XwG31jvz9VSYycdTCsnSG69vtHixQA9Q9PB4Mi1ECA5	1534	951	16	1	2583	jxSFeCcFAjCF443Nv2rZEt7xPLPsS8kJaggytYhfATiMDa5Veoz	1390	1959	1959	1616291820000	canonical
2646	3NLRubfPHrLdVLtngYBF49UZztBXy4bZY3p6o3eFRmQAHZ8seSuD	2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	525	525	16	1	2586	jwHEtFR1z8JtkXagsYhWFemzTRKpzbYgxhgj7EpPhofdUxbhAvT	1392	1961	1961	1616292180000	canonical
2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	2647	3NLC1YdWGPwNPpHuEnxc91S5pAF9X1891J4yjakRh4qJiGSQ6CQj	1509	954	16	1	2589	jx7caUoESzkzaH8L12zfN6zacYNXXLjyDbezYjdjPjtn91PMBi1	1394	1963	1963	1616292540000	canonical
2656	3NKCaiSs5KrysHFBRaHAcXmxAHLazytAt5FppytBK6HrADbqFM1N	2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	1483	652	16	1	2596	jy1vRofur5nzgtVeNGjTiVpnA7dU4TmcXAajSRCWcNZYphKH34b	1397	1971	1971	1616293980000	orphaned
2659	3NLhGegcXHWQ84YZgQnCtcm8yG8CWGuFkUQSasTBS6iXuX8E2P1d	2658	3NKUv1WxMB1jkgJBSxfg1Je6CKJcbLrd28tEKHEn5F45EQvbfn8i	1672	1159	16	1	2599	jxQzcBacz4URCKgnEBasj1bnGrX5aPCFJU4Qb2ppy6eh13PAwfZ	1398	1972	1972	1616294160000	canonical
2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	2659	3NLhGegcXHWQ84YZgQnCtcm8yG8CWGuFkUQSasTBS6iXuX8E2P1d	1477	1224	16	1	2602	jwTK7PAu9rQNUYbToMH48zPGvfiHxMvdQYYuir2EhB15aHEymGF	1399	1974	1974	1616294520000	canonical
2664	3NLN7BE4Utbs1NPvnRqXxL99QiMAVQHXmwvGwE2efpqxyjXp7wWn	2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	684	1352	16	1	2604	jwZn6bJkBztu3yhwMiWuzXmPNJn3cD2afKYpGVZd39uJ5GvyfWi	1400	1975	1975	1616294700000	orphaned
2669	3NLSmffZn34kk5bsttzrNDeaDPLM7yxxRtuzNiAHzHuSms7RCqRM	2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	1527	1047	16	1	2609	jx5S5LTvc6uuJEHgPLtM5DXRXL3EBp78RaysEvGcnmjqRKMEpXz	1402	1978	1978	1616295240000	orphaned
2673	3NLchqHkBkpoyuFi3k21v6agy4rrJFFDGxwsDC3YbzxQxjdpfg4i	2671	3NLwmVJqNvegAHWpJ5AJFu5hHivPAiWMmNSq9PaMefbYsaQbp2bN	1406	1393	16	1	2613	jx43UhsTkwzgcnC1rDcbsp37DV2NdzmxXJ4Tn4i3Ka24mJdP4S3	1404	1980	1980	1616295600000	canonical
2676	3NKPkCPmgCmoF9YkQBqqScjvEUs8h8HqvTo1HKKrrFWgndCFLwvA	2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	311	1061	17	1	2616	jwRyfypMXVW7PBhJ6bbFjatRdZJe75RbWonGgZxAZHcNRdikuLP	1406	1985	1985	1616296500000	orphaned
2679	3NKoFgHxcTazLfhbtskTujV7Y8BzUDtg2jhrgZJATL2Ee1HHYnbu	2678	3NLFDZv4mMH9WB2qGi7iHEqUob4PNuBS1YLt5pvMWv87GDsCNrch	1439	1033	17	1	2618	jwCxZ1VHBc1n89JaAmMYWn91SLNSXkAxu8wjzZE4WJ8WLJN6u8H	1408	1988	1988	1616297040000	canonical
2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	2684	3NLPgsKie8rfwwaCW24PCmMin72ogYWAUmAaWwrqbzC1sJS39dyC	1585	1240	17	1	2624	jxtPw6Ju79yDUyC9q4esU2y8b9LRM8kWdxWJV1fvc6AvKAUzTa6	1411	1991	1991	1616297580000	canonical
2688	3NKJkMVwt9FA4mBmMkfRwYDqppvCgmYqcGH2gPbuJxKxjjdzNNe9	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1617	1042	17	1	2627	jxEZJRRA9AhVJrumZBCkT1wzma84tT4BkNYApLpSZ9i2AgijKtL	1412	1992	1992	1616297760000	canonical
2691	3NLo8KpLYGgwNayBnXhr1ybdrPde6VwvdL67UfASJyHgZB2ZSuo1	2688	3NKJkMVwt9FA4mBmMkfRwYDqppvCgmYqcGH2gPbuJxKxjjdzNNe9	1631	794	17	1	2630	jxrXd1PeUAVYqDW6s47zTAcsFPEh73kBrMwYDuqWcMdXCMZF22u	1413	1993	1993	1616297940000	canonical
2694	3NKWhm3i9XLWGvstNdpi9UWcGJ53MMFmUJHZHgUqJk6Z2T927dCM	2693	3NKiGzX8gWTCtq4wdeKKspJojXB3XJhbpzUxTeBBWAmoaohAhaAL	1553	776	17	1	2633	jxqBBhnNLqs7rnxmr4REqw84NLfAsuwD1TqfWNrfwJ451iMfBfF	1415	1996	1996	1616298480000	canonical
2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	1407	1395	17	1	2636	jxmNUccNuacKSMDvpRmfA83TgzfAoSQpaf9cVKbmRNaH9UQJRU3	1418	2000	2000	1616299200000	canonical
2700	3NLdifjpi4AB3LtfswEBoFFytMtW7V3qN21cfqrcYWrJt5eohnvz	2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	1407	1395	17	1	2638	jww16czR6Xy9KifFuBMv2SVWAC8TqCU9R2pfenAvk91EM8ZJK2Q	1419	2001	2001	1616299380000	canonical
2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	2704	3NLg9ki5DZ8p2ggPWMnJd6XBA4gysPafKMKTkydHhdpcSc3RpNQp	1407	1395	17	1	2643	jxRZF5LZ2ydUPyEvxPtDE4aKLLga3rzm7zEEr1udoAr1BLMYuGn	1421	2004	2004	1616299920000	canonical
2708	3NKqTfesXfBhvZqikYK8W5WrTj8QaF2hGcHDTytLXF58bNB4bSaZ	2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	1624	1088	17	1	2646	jxcgiP42msSu38XqnNYJsah3KHGGAwBk5Jij352Zs3epZqRKeyW	1422	2005	2005	1616300100000	canonical
2706	3NKPnd7e9wBLDdyvdpYrpxRKg7JJUwk9qufCpWGoQMn5AdLatqux	2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	700	840	17	1	2644	jx6xDTumqWhmN27sAv5BURZeZg9wvxdATiJQXrm8ZjFMrkw1Hsg	1422	2005	2005	1616300100000	orphaned
2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	2708	3NKqTfesXfBhvZqikYK8W5WrTj8QaF2hGcHDTytLXF58bNB4bSaZ	1600	1246	17	1	2647	jxXmi8rHbS7DiZ941Z7UE8jFZ2GmAd9hsXm9APPx6cTebMhWF8T	1423	2006	2006	1616300280000	canonical
2711	3NKQy1Wdmrd4XLGoEuCAXfYspNCQpVH7ZtHG4vcgTn996e9qo1s5	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1646	1228	17	1	2649	jwzBAxT4Uti3uXh5hatRjyZ7sWAYEPcMyJWTRsAZxaagQw3XA4s	1424	2007	2007	1616300460000	canonical
2712	3NLExBUaXRjPVRPc5eFeBKJ6jEiHNXnXMhTJM26FYACn96pKRpus	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1611	1341	17	1	2650	jwaPHN6vaipvw5ujwLyJJVSU5QWJN8TYQQr2g7J267sa1sdtrHE	1424	2007	2007	1616300460000	orphaned
2714	3NKYMXf6vPAtbVe1KXM2Hb6non52pW6oAvvXgNTWaZ7sLh9HFVZf	2711	3NKQy1Wdmrd4XLGoEuCAXfYspNCQpVH7ZtHG4vcgTn996e9qo1s5	1555	1347	17	1	2651	jwGs7cWr8jB6H2VEjCrgCP6311H7BjasoCUBFcRSdnQkGr2B4Gi	1425	2008	2008	1616300640000	canonical
8310	3NKibXVNawXTNRCY9UfMQWu8qJTp1EtmeZMLvbJQxnrGYwAMGF7G	8157	3NLDmCTjzUVZR8gF8uY58c3WYJhe5cHLfyNnnkBeP3DU9USbnVWQ	80	1273	95	1	6301	jwz5CY7jPdS1XoGrqnx3rbY4gSBsZ8zf1q2X7FBhPiLdfEioaSZ	4229	6067	6067	1617031260000	orphaned
2640	3NKXVMJF8HGcKmEFgC2pLdAj9Kwu57stKJgzUVmCND3s66ZFfA41	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1477	984	16	1	2580	jwysy13LQ4qkp5DtMxXCHiFKiR9AjqxGbkZ5jaLZdDXukyQf9qy	1388	1956	1956	1616291280000	canonical
2638	3NLdgh5tkTdgm5p76Rz5ReJE18pUrko5vaKovquEm7snuGAVXPEQ	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1407	1395	16	1	2578	jxcWAuoD634fkr8TKyEjqGV1Md8c8wDjVmYnNzYdQ9RkD5469kg	1388	1956	1956	1616291280000	orphaned
2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	2643	3NKhPdBraP28GEeocEoQ9EUt6y4aaB5brVjvz7c1iwGMaVRJ8u3S	43	1064	16	1	2584	jwnQtdvf5iDB4QYHMFKMPu2t5yjgbMsXMZNJ4eCygCLM41DRoj4	1391	1960	1960	1616292000000	canonical
2647	3NLC1YdWGPwNPpHuEnxc91S5pAF9X1891J4yjakRh4qJiGSQ6CQj	2646	3NLRubfPHrLdVLtngYBF49UZztBXy4bZY3p6o3eFRmQAHZ8seSuD	632	1136	16	1	2587	jwVUs1ZbYqkTG1bAHYcHnNfYH5XpY1sP9LmyBLUgBWjxBsVJ1Nq	1393	1962	1962	1616292360000	canonical
2653	3NKHoBBtmW5rV2joFq4DdvaqpYW4Zefsoxw4KfaGKAHzkftK39Yp	2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	1637	815	16	1	2593	jw9BzvsgJgpw15F7xSuEazky7SWjEgokojqzdWRumGCnURfgzLE	1395	1965	1965	1616292900000	orphaned
2658	3NKUv1WxMB1jkgJBSxfg1Je6CKJcbLrd28tEKHEn5F45EQvbfn8i	2654	3NKaBJtMFqo3GUd4VvFNKHAmXuaLT5MPyTPibwpqzkqyUrvvudVG	1637	816	16	1	2598	jwrLP3VdYzLnjGJLH1JGY2ZsRipwb3XCAzCJeJvZ3kZpuGWDnsm	1397	1971	1971	1616293980000	canonical
2661	3NKYXGNQxVZNvbsFz7cusZgGeKEXUCYkuNwhZDqCafMSEipbXM9S	2657	3NKjwR6Tt9zX6VEJPgxAjW5fXNoCD5W835s6VC2PLfj7qRFFKR2X	1542	938	16	1	2601	jwXukdQCkmtgKhyZ2rshWwg8MEFd29HAnqgQCo2uQXv91j9BHk3	1398	1972	1972	1616294160000	orphaned
2666	3NKQef4yQfS73G1XoZHhUM9raPqnb3bw7wxV77hyrBYSXFaprcmP	2662	3NLAPVdQkeGbeRHNgCu3uoeN4WQjDhPQ94drJU9bRYocwirc1aGc	1637	816	16	1	2606	jxXVZ893ZNKRFUSJuhyZCnrzTgHieRsZmUeJr7vYKNZPtTaqJQA	1400	1975	1975	1616294700000	canonical
2668	3NK9ibK7MDKjfKxqVmaKgFehu7GVBXt45wC2c43JkiQgk2th6puH	2667	3NKEnbHeDXhYZaihpjFq89H1QHLrJdAAtvDpjJWrKttieFZgi9wJ	1489	1134	16	1	2608	jxrYZtG7e3AppRxMt6CkZveN2KHyKL5k3KzuJBD7F92qXZXGC1B	1402	1978	1978	1616295240000	canonical
2671	3NLwmVJqNvegAHWpJ5AJFu5hHivPAiWMmNSq9PaMefbYsaQbp2bN	2668	3NK9ibK7MDKjfKxqVmaKgFehu7GVBXt45wC2c43JkiQgk2th6puH	1573	1192	16	1	2611	jxARmPiBCof9KA9uhca4GadgbKvHtcWvPhjztkt1VX4JPTFMgph	1403	1979	1979	1616295420000	canonical
2672	3NLYB2wrMR5zmMDi9qqssPGPbNjcfjtbNovmLoRAyCY4xmNygakn	2671	3NLwmVJqNvegAHWpJ5AJFu5hHivPAiWMmNSq9PaMefbYsaQbp2bN	1458	957	16	1	2612	jxQ3HopL4vbd6X2eTZNi6g5cDSoSNvDNXou6ZhiChbAL28FSF9V	1404	1980	1980	1616295600000	orphaned
2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	2673	3NLchqHkBkpoyuFi3k21v6agy4rrJFFDGxwsDC3YbzxQxjdpfg4i	1587	991	16	1	2614	jwQHnJueTcRxQjsnagTzH3hJJBLFd1xD5Sdsh6FpscSJoJ7hjcz	1405	1981	1981	1616295780000	canonical
2677	3NKJvMnGrdKXWXAFTbBcgveheAxy8VFcH4D7ZPZYN1u5Bbq5fSHS	2674	3NKynMigeQ1B82xj1LdkZzzeGZitrhz75izivEHBSTGio5cMLtXG	311	1061	17	1	2616	jwRyfypMXVW7PBhJ6bbFjatRdZJe75RbWonGgZxAZHcNRdikuLP	1406	1985	1985	1616296500000	canonical
2680	3NKjsPKHf7YQy8LjNK5GJdC7uRjYm1wPev69eBWTtnK4nKiDoiZs	2679	3NKoFgHxcTazLfhbtskTujV7Y8BzUDtg2jhrgZJATL2Ee1HHYnbu	1534	1317	17	1	2619	jxAZpdFFXkSpHuzGXz8RzezxB4TuZbvCWVUH2eKHFpNBdyP5shr	1409	1989	1989	1616297220000	canonical
2683	3NKRS8FUDC9GAhpffmDRCGpjxnGQgLGxdpSTYeVcu5T8FaFqryfq	2680	3NKjsPKHf7YQy8LjNK5GJdC7uRjYm1wPev69eBWTtnK4nKiDoiZs	1596	1363	17	1	2622	jwq6ZMBtAFeBtFWPirPPamNKtDtupwq8Lz7g3SjLYng5qq36XvT	1410	1990	1990	1616297400000	orphaned
2686	3NKe5vFr7Sp5ggFWE4Zf9DNUN6z51hH13XdAPDnBMRS29Jnf3VM1	2684	3NLPgsKie8rfwwaCW24PCmMin72ogYWAUmAaWwrqbzC1sJS39dyC	1590	1054	17	1	2625	jwz4kHjEbCwZiQsiqdZvVJmUHCzc15cKvJm7YQprkimNCSAfApq	1411	1991	1991	1616297580000	orphaned
2689	3NKbwkr5UKMzXAYMB6BXfbPWY1L7iDSu4t2CmfiLNtx4JurduSAe	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1406	1393	17	1	2628	jxDc1nXWaPDEvk51NazNsNj5NHcfPwYdH7C6X42ut3ryUA9S88m	1412	1992	1992	1616297760000	orphaned
2692	3NKLWMHDg5ohVYcaULi7eD4KvqVcMcAwm5WAiPQ97vMba8wJ1KR6	2691	3NLo8KpLYGgwNayBnXhr1ybdrPde6VwvdL67UfASJyHgZB2ZSuo1	1407	1395	17	1	2631	jwFVP3kr25qgA9YWgrnBrwejedZHtL8XCup9y1DCgTzjAKnUDQD	1414	1995	1995	1616298300000	orphaned
2695	3NKdNnBPqCqp9cDYBR5jPsn4uY3r6mXAt9MsPbsXny3YUVdMMvWt	2694	3NKWhm3i9XLWGvstNdpi9UWcGJ53MMFmUJHZHgUqJk6Z2T927dCM	1675	1342	17	1	2634	jwyaKFRTGc6RsDh3nWbLxpqm3cRRHBp4f5N5oGZmGiGHR94Furd	1416	1998	1998	1616298840000	canonical
2698	3NKpPtBQ93bBuAcbncgLNxN8We76uMpFDybk8JyowwhyCjn8DPLg	2696	3NL4qMvJ7yiXdiTRq6hAddd4KtTxQp1zmGnqpYzSzi3rGq3qRqUW	1651	1175	17	1	2637	jwmpMnv9EBpMmLjnKyQz146jHMctKNq3LRakqn7G32menucjvsJ	1418	2000	2000	1616299200000	orphaned
2701	3NKH4e8LEAkGxezBh4f44iBNmVWKyHT43sUpSa2pwmroB7qnFVbP	2697	3NKFJcRTk1X7Cq76KThE2Ko6ncvUnLT3qTqikP8MYVSN2zeNE8e8	369	1066	17	1	2639	jwG8L2iYHBgqr8Zay96FHREJbioKLyVELFZrdgRWChtCL32Gofj	1419	2001	2001	1616299380000	orphaned
2704	3NLg9ki5DZ8p2ggPWMnJd6XBA4gysPafKMKTkydHhdpcSc3RpNQp	2700	3NLdifjpi4AB3LtfswEBoFFytMtW7V3qN21cfqrcYWrJt5eohnvz	1509	1074	17	1	2642	jwQUtmSAyKTjHqVAhtU7vT7Cnuz2yP7ZXzLBnc9bNgNbxMiSgfu	1420	2003	2003	1616299740000	canonical
2707	3NLuTLw5f3WR2dWyyZWnCZJh5BdSgv77V5G48cNTKRJatg3LsR9m	2705	3NLrFtfvH4CKxyS2BuV3xnoBS9L2uCxGRZSs7qtsppkuNkyL2wJ3	1585	1366	17	1	2645	jxajBgJD72wSoTqTc27RAXe3kAwhGpaVwXNx1bBAcPm5EZGonrD	1422	2005	2005	1616300100000	orphaned
2710	3NKMPt84BT7cAc6Pyc35Uid19CdDoVbpGyZpuDf2yrGGYPTWT1hB	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1474	1329	17	1	2648	jx5DHKBbCQTeaKWgcNCUscyLZjiCHHLo7qWkiZxppkwYviPQ5h5	1424	2007	2007	1616300460000	orphaned
2715	3NKrUXr7RtxHc6mqRAQh4c52XegKucDpimy7X3yjHLbRXZ1zTyHo	2714	3NKYMXf6vPAtbVe1KXM2Hb6non52pW6oAvvXgNTWaZ7sLh9HFVZf	1407	1395	17	1	2652	jwH631JziTrirksHRhSX7bQ7z392YnHX8hvcMkfGwVKA16Dq7Ns	1426	2011	2011	1616301180000	canonical
2718	3NLUVmY6SHbyu1b6Rs94Rs64FzJvi6PA7hCJXyrVy7854vVqU1tF	2716	3NL1omcoo8b2WYWDZLLXf1mJWk6BBYDZJHsCZX5JvcizXw8P6JVE	1506	1247	17	1	2655	jwGw7mvxbMg8shUiLUjKDKYcXp9k7judjJMN634bf5RMXUUbDms	1428	2014	2014	1616301720000	orphaned
2721	3NKScbihge19DFsyLwFtYp4pv3ZZTcfyP2oCM7VH7vkAvSjTZCgU	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1634	1085	17	1	2658	jx3nM5djNgDc6adq5orYJPYHzWJgL1yfFSxWMd653swv1YoM6VR	1429	2016	2016	1616302080000	orphaned
2727	3NKnoSdVbnrRaVTwP27ujywgwSNEJTrqr9CST2mWyU8w1bSEv2Es	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1406	1393	17	1	2664	jxmjkAh7bN5Dmj2tnxaQYyNwTk5UYxJGdV8u9pXxpPDzURBq9vJ	1431	2020	2020	1616302800000	canonical
2730	3NKwR3RQdWvJGAtM6KCF9dSJiHWgFfJLo3fTxvssEfjpH8iF75HT	2729	3NKbnhThWo2X1CfeXfCRxibSHaus1ah1ynDEyWVGVC74AxgfbfWz	1407	1395	17	1	2667	jwV2Vbr4sgBcdgTWPC2Tq2583oK1WPsVz2qysTHbc3LRwMa6E7w	1433	2022	2022	1616303160000	canonical
8388	3NKjmxcvHv2sp5udikoZEyRvhZUirM8ocR1UKNbsFnVmGa55mHBi	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1613	983	96	1	6301	jwfJ84xRjag8PD4TivLofYQCcHyGC2DPLkViLtQhXP2k9EBDCpK	4232	6132	6132	1617042960000	orphaned
9709	3NKado77Ur724TvgjcP2RmHNuNipL2DYhnZSbQt9PzwVcq5mhyWF	9706	3NLSTPzj4qQ2ueFhonHSJiKTVZJBqF1xVFhRebBNUV4bmfMfaEoj	529	529	125	1	6301	jxm7HQ9STyUFUuzJqqbdmitgCTSFYUPpcUw6Bs49QYuhpXW3ATw	5035	7085	7085	1617214500000	orphaned
2768	3NL9hduJbTdNrHSHV6NkLFskD8kNb3zhcErjvv7Efa3WQ3zJgyu9	2617	3NK4xcbqzEai4gFyg1gB97Vu5uCjEXh3Qs26rqzzpTtbDffMENyg	1403	782	13	1	2701	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1281	2045	2045	1616307300000	orphaned
2782	3NLuDkFGamHFFCpNeTdRGfHdAnHzwLGgzNRWfCEQSU1FK3npRSAb	2768	3NL9hduJbTdNrHSHV6NkLFskD8kNb3zhcErjvv7Efa3WQ3zJgyu9	1403	792	13	1	2715	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1282	2056	2056	1616309280000	orphaned
2716	3NL1omcoo8b2WYWDZLLXf1mJWk6BBYDZJHsCZX5JvcizXw8P6JVE	2715	3NKrUXr7RtxHc6mqRAQh4c52XegKucDpimy7X3yjHLbRXZ1zTyHo	1406	1393	17	1	2653	jxEbVCxGT6qL2DJ2fSfL9c31MqEcNK6mbT5XxvT1nDqWY447oy3	1427	2012	2012	1616301360000	canonical
2720	3NKw4xUp3xSZ3VK3NuS9rSemanQxA2DCqmdfU9KYsnP45Gf71GSf	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	470	1309	17	1	2657	jxH2oyENHVKcxKQBZwWfyo6sN6pNKsjPk9tyCrhn6PENKgLrJKh	1429	2016	2016	1616302080000	canonical
2719	3NLDrKS6VwcVBXi4DSjvx41T5KRFRACdVRKWeBU1pfcuVbtFb41s	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1407	1395	17	1	2656	jxTmQjSQP3CaS3UQLJf3st4D5NWXtp6xX3ATgx4hPo4PZSkWSaV	1429	2016	2016	1616302080000	orphaned
2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	2720	3NKw4xUp3xSZ3VK3NuS9rSemanQxA2DCqmdfU9KYsnP45Gf71GSf	1637	816	17	1	2659	jwPwqYVxDM13Uo5kfgwLeLiurq9cXAdAiCQLZacnFCARjyX1szu	1430	2018	2018	1616302440000	canonical
2724	3NKfFdeTsgPEiKNVBhS2sof71Ad6qcF7CBv6VoaowvXotVvDj4dH	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1407	1395	17	1	2661	jwrhgM8QU8tgMFmGKtSds9r5GRC6SeVwfkDZ5Lzx56CAqu66b2P	1431	2020	2020	1616302800000	orphaned
2729	3NKbnhThWo2X1CfeXfCRxibSHaus1ah1ynDEyWVGVC74AxgfbfWz	2727	3NKnoSdVbnrRaVTwP27ujywgwSNEJTrqr9CST2mWyU8w1bSEv2Es	298	1062	17	1	2666	jxpb7aStrgE7zQQjn7LALE5j3kRd7dGzzhi184G3AqKvigs1m9s	1432	2021	2021	1616302980000	canonical
2732	3NKzy8evU6Urv6GpR3c7xjpU5wtmoPaD47R2aWFYttQZgtraq8qx	2730	3NKwR3RQdWvJGAtM6KCF9dSJiHWgFfJLo3fTxvssEfjpH8iF75HT	1439	1033	17	1	2669	jwYBHCtX3gkPG7akCcoEnF4hTdMjXfHjzZE8psGR3tmuDtYtnBC	1434	2024	2024	1616303520000	orphaned
2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	1639	250	17	1	2672	jwA5kvwyb3zoRZuBAzRr4QHHDbpETM1qjwrLq1Sv11dNUL6mfka	1436	2027	2027	1616304060000	canonical
2738	3NL2zM5qZogQYz3EyoRum28S8mb9h4UfH89exxJCUMXCMF1Ha96H	2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	1637	816	17	1	2675	jxW6C4bfFzk55yZycyb2JopmTfMrYZiXRPt4Yk3dG6KADptLqfr	1437	2028	2028	1616304240000	orphaned
2741	3NLuZe7XDX5vovEi4cUVxETQyZLutkkHYZSN1BrB6d2fgd16217d	2740	3NKu1rqi3oeAoUw4YLX7GyqbFh8fNBGfKx1mrabbr1AEvyWgtyjU	1579	1389	17	1	2677	jwHVZggaNPRQDb9SXP5EAWtBN1gukgxdues3uGhKYcTLfBUoFEh	1439	2031	2031	1616304780000	orphaned
2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1631	794	17	1	2683	jwjRv7XByMfqaVtR64YNeeN3pjKYeoJ76DycaD2ivPL4hk4SPqc	1440	2032	2032	1616304960000	canonical
2744	3NKjC4cGUP8YtL3WijxiJThhf2pSPiEydNPqJ5JGy1pfPRPG547L	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1649	1137	17	1	2680	jxP1gC59iku3R27oAxUvgoMqTMg4HVRoHw2YrS992he7LF2RrHC	1440	2032	2032	1616304960000	orphaned
2750	3NLPfzsfFNBf22ja4mf5wLpnDyvLrtcqcoMTzEZNsf2BCMW2oBAn	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	532	1177	17	1	2686	jxwXKHTerwT9VoGufztLMZwGqtSoTCpgCFAoaUkznAzFKyD8LAe	1441	2033	2033	1616305140000	orphaned
2753	3NLMA5cm9cPywbBSaNixNStrfVfzNG9jRGNd8zge6TPronGkwHYK	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	641	1336	17	1	2688	jwNqhJshYye7qRo2JQVyC4qQVT6anUepPvyyMN2G6bYGMQbAiTt	1441	2033	2033	1616305140000	orphaned
2758	3NKZQUr7HgRP2Fp6KYrLc74HProXPyJQZBmBg8LhVoem1xJATdtH	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1619	1029	17	1	2692	jxJZLJaNUsNiFDVTMTMTryzmQeB9P96u6zZENG69Ks9SEbTKZBE	1442	2034	2034	1616305320000	canonical
2755	3NKRHAvVvjfRNqYoqf6PGgZozghb9kSNmLKWx81QzAErM23MZRQ2	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1407	1395	17	1	2690	jwMEDan1ujFUotHca7XjKt4TqAE98Jf8M7wa7rqRptFEZ6jGv9H	1442	2034	2034	1616305320000	orphaned
2757	3NKMVUyvYWxuFwiMRqJgQau7EgizmNReqL1ywWj3P5fjyHJJadna	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	448	1059	17	1	2691	jwis42q1KFk4HUqs2jHZNip97xTTfBVF8mLDsgx6RZ5z49mRWWq	1442	2034	2034	1616305320000	orphaned
2762	3NLhPdVJiXt6SJwLiCXSq9YCrYJYW2v1Wd7Czk1RkLyAH3fZNw1y	2761	3NLq8hkD26zpEridotsbMnz9rsPEdYUurhFYXpmMyqsKUs9eSmq1	1672	1285	18	1	2696	jxq2Q1fQxth15EfwKv2vpo84Z9vP4yoHSnPQA99hF4fwrAPEg2j	1444	2039	2039	1616306220000	canonical
2765	3NKSJpLM6fv3Fd6QU5ZCTh1EQ7AgwTcfUFi7vwCwFg78oL5zUPrK	2762	3NLhPdVJiXt6SJwLiCXSq9YCrYJYW2v1Wd7Czk1RkLyAH3fZNw1y	1651	1301	18	1	2698	jxtRhyoTXfUtF3aVY6gBBLodhavsEE6mQF48Wm3Vw7CsEULHguF	1445	2040	2040	1616306400000	canonical
2770	3NKC4GLukMhH54TiCey8WqxBdezydEnrcNAn1Aun5jx9mHqRNeSR	2769	3NLojEqaq5j7Rxf6V8LLT37vpHhyzC94y871fKtQ4aaxfW5s18G6	1508	1141	18	1	2703	jwHhQoDpymSF3kQJcgiinD6e8a9w2KwSG3hZfpaFt8LwxoXGVdp	1448	2046	2046	1616307480000	canonical
2773	3NKzD6k2cDDrvJzVzMghKQSVrvM1hxMPk5uWg9HE8jA8vbozSTfH	2772	3NKsSdWY9WH6CEiv28CNg3BVNTPKykqirwZ6a3AYZ4tabwQXJk9B	1627	1139	18	1	2706	jwUPUWgjLkb8UjgztzWpHRHsTzb8Drrxhcv9EniaS1ZcnRHuhaP	1451	2049	2049	1616308020000	canonical
2776	3NKeoPiP33nJ6zKkt8unHUM5mEFfr7TjEkhp2mf3heXvxxMeozmM	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	1445	1164	18	1	2709	jxN361iYTjXoYv2o7szb4gMxgX6kLnmSxqqeRYLT7ieBsqAMKgz	1453	2052	2052	1616308560000	canonical
2778	3NKmSjasAYcyLJTHCUQ4aYZD7hGujc7zCvQYAXZqB1BGzGsCsoQU	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	1553	776	18	1	2711	jw9FMtpov9u2KMTcDRdaAbRECdCt7Vcq1iWyoaKT6rRziLwNvcW	1453	2052	2052	1616308560000	orphaned
2779	3NLLtAowAgDBtA42F71asqRLCfVLbQ5XVpCgtwSoTGBi2Sfb7vzx	2776	3NKeoPiP33nJ6zKkt8unHUM5mEFfr7TjEkhp2mf3heXvxxMeozmM	1406	1393	18	1	2712	jwamYivq9x5wBdDcAwYzwz79egjyv7SzbHhZfcBsfUqyLk9D2Mp	1454	2054	2054	1616308920000	canonical
2785	3NK7w7bQwDamw3rbKr1obArEiXBTteXSosYwHBf9uyQyVp9PfMPT	2784	3NK7Gycc5QjiwBnHDpWT5Nw33Df1sx8J5Zemka1AYVnXfKXT2rfW	1577	961	18	1	2718	jxw93xKmiLeXox6itxVSzNTSStUSCvz3JVK8Bj8kD2EDZCpBkUK	1458	2058	2058	1616309640000	canonical
2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	2789	3NLq2FKkJuwCqqCA3xT41UmqtwsGz4RpphajesUe499uKeimrJ2t	1540	110	18	1	2724	jxbziwHwF5kh74n2D23nvPojj15dKRXTYktGdaLg47Nedb8K5Jd	1461	2061	2061	1616310180000	canonical
8173	3NKiZ1VafM7a8UTKj4V8bkNEyRCQ6CKCTy6T3D3HZQ1uo79QZjgE	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1553	776	96	1	6301	jxQTVQsNshsJ9hSvXnC29TA6rLAUDvRHjbT7WigE17m4H4QRnKe	4234	5976	5976	1617014880000	orphaned
2728	3NLBdFmSBh4Z6V93Z3nc7gxv5ukqbrkaLURGenb4tzqsASprmbWi	2703	3NLLDJaoAYHdAGnYcmNiKqFBCTDjoBk1rwEcYktmsTRswzGFBXzA	369	1312	14	1	2665	jxM7GTE8xYegaXbnQ5EdEckVyHYDrzZrXcagMeS1DK55bb6o5Ky	1290	2020	2020	1616302800000	orphaned
2814	3NLMfQUL68UzGWjx1hvZoEg8ymUkPQPfno8woaGt4KjcAhMKS5fn	2481	3NK66YjpbrbCwVtqUrgXbvpsKk4dajnsYvdDBbW54tJn4GGPjpZX	641	1336	14	1	2747	jwwYp2itz8MNg4V6mDaxneETxPE8hvCUBxaXJg7ZSyRdEQrvkC7	1301	2078	2078	1616313240000	orphaned
2743	3NKrkqeSEbvJnURy5TSF18zUni3oSw3jQfxy7WdzDLBubw5nE1W6	2644	3NLNxJANZgPdNVGXQPZvJZe2HDuxnMfH3b2L2Dye6FgUofgdMRfE	1579	1389	16	1	2679	jxUVbCEvm9KXS5a5CH8aiKeWqFgiU1WeLykTmxoRPgwhYy3AHYU	1392	2031	2031	1616304780000	orphaned
2731	3NKKajQHh4pTaRXvZKPFkJdCeDNnkex3nKXU3CrKoK29ht796MZ7	2730	3NKwR3RQdWvJGAtM6KCF9dSJiHWgFfJLo3fTxvssEfjpH8iF75HT	1448	1065	17	1	2668	jxtzQ7wAv1KebZ4Ems3oLvgG6yW7ZXw7PhpBLVMLyXHXioWvLNQ	1434	2024	2024	1616303520000	canonical
2734	3NLvDieyawwfnDyetz64WV78DYdfoR7oyaZcLp5RzZSKrSoeNfCd	2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	1483	611	17	1	2671	jwwqtiYNrfXLo6PUTHpCUZMLWeS9YZqq2ebPttTK5VVjcbiRWVQ	1436	2027	2027	1616304060000	orphaned
2737	3NKcxjWujLAtCKgxtVHAiUDSUEVXpCqmSfFAEXRQo4CuUKcPumGt	2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	58	1281	17	1	2674	jxWpHeMaDy5aEfRnjRqhWEX4GWdo9L6YWrC2jknLVfLZ3f3h9za	1437	2028	2028	1616304240000	orphaned
2740	3NKu1rqi3oeAoUw4YLX7GyqbFh8fNBGfKx1mrabbr1AEvyWgtyjU	2736	3NKcDnGxcr3WvWbK77GJ2kr8CVpx755dkxr7ZWaiEfLnp3fXyKuc	1652	1189	17	1	2676	jx1HDdeRz5xWhAMJn4JRorc29FkU9RwQSTh9nHPWgpmRFPVufRU	1438	2029	2029	1616304420000	canonical
2746	3NKBPFAkQCCQvBA9EaSRxHCCh9nMmsVxLizbBhtWVJr1m9x3KUWf	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1623	839	17	1	2682	jxNSyT3sSJBS7gcKyg7moBxoUeXNGz6mQgV78Wz2zt6r22KHSFX	1440	2032	2032	1616304960000	orphaned
2749	3NKcEFhafv4BkFUP8JXx17cCu3zXHXAFGnFG9byf6LtRxAMKACzr	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	448	1179	17	1	2685	jxfhMCysXhdQZXty4Ge5dg7TBhUBpDjjkZsutSwoafqaNyWnArK	1441	2033	2033	1616305140000	orphaned
2756	3NKzGAPq5iUrH3dZwHXQMdk42crihFW7ToQYaVzaoz3DAF6xQt3n	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	448	1059	17	1	2691	jxf3DgsQWiicKdFvULdFLKb7DiiygLELkQhjhfoWsxiKQKiNhpy	1442	2034	2034	1616305320000	orphaned
2761	3NLq8hkD26zpEridotsbMnz9rsPEdYUurhFYXpmMyqsKUs9eSmq1	2758	3NKZQUr7HgRP2Fp6KYrLc74HProXPyJQZBmBg8LhVoem1xJATdtH	1460	1198	17	1	2695	jwJPoEjZWLYz7qbjbTgu5UdQBn8HTnwnYLZqBba97YyLgA2hRfM	1443	2038	2038	1616306040000	canonical
2764	3NKyWQZHH1tAL8t7aqFWvKFbjiW2EkJcNuzHPGAv1qYofoG94vCw	2762	3NLhPdVJiXt6SJwLiCXSq9YCrYJYW2v1Wd7Czk1RkLyAH3fZNw1y	1651	1301	18	1	2698	jxW3yZFrzv8wpWsFEp1Ar18UvJ7f1b1CSHvc4A8srt5JnsBYQWn	1445	2040	2040	1616306400000	orphaned
2767	3NLRL5LZRP8Ned9yJ88Lw8x2yJftQQyD4BtKDpTBfG1WxTc6uj2k	2765	3NKSJpLM6fv3Fd6QU5ZCTh1EQ7AgwTcfUFi7vwCwFg78oL5zUPrK	1507	1280	18	1	2700	jwUowYcvm2HfcxyPL3mM3PcoByjEyo8CxzPr5aBYV94XcWxfiB5	1446	2044	2044	1616307120000	canonical
2772	3NKsSdWY9WH6CEiv28CNg3BVNTPKykqirwZ6a3AYZ4tabwQXJk9B	2771	3NLqZgc4PGeqTRAKh5VtdzgbazGCgiivTaZTiHRTjH2Ryr4zoiWw	1407	1395	18	1	2705	jwBiunGekMWUKHQPmEADYUkragbzsCPFtDSedEzaMTfh4CmBgj9	1450	2048	2048	1616307840000	canonical
2775	3NL5coN6x2UUxZW6YAEi5M6HBPoNATrvPYuLgiMZxQT8WUgKVCjy	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	700	840	18	1	2708	jwaASAjYFG58uf3Vuk2QGnTYngmZnv67ovHyh3ZHs43CUwqcR58	1453	2052	2052	1616308560000	orphaned
2781	3NLSt1sbTZH4MrhsSa3o41q9yqNjJojjy2HKvLxoqT31w5sXwzhG	2779	3NLLtAowAgDBtA42F71asqRLCfVLbQ5XVpCgtwSoTGBi2Sfb7vzx	80	907	18	1	2714	jy1eqEAJZSoGfuLR4ZL9kJ3VdcuACAbNmpMLgGHZmHeYPiz1cVx	1455	2055	2055	1616309100000	canonical
2784	3NK7Gycc5QjiwBnHDpWT5Nw33Df1sx8J5Zemka1AYVnXfKXT2rfW	2783	3NKjtGGRkntgCcZi7vZuuGtu1YUEQAZ141SyBifRm2pSxMVZhsGz	1601	1388	18	1	2717	jwVz8MGaVjirgP1ZbusqmhoQcEzJPw4ASz2BvNPCEStXvasYWYk	1457	2057	2057	1616309460000	canonical
2787	3NLkEmU73WhiEXyKvwxTmmBWeFTQGLop2AxDJL7qMznfBfHBGmBM	2785	3NK7w7bQwDamw3rbKr1obArEiXBTteXSosYwHBf9uyQyVp9PfMPT	1623	830	18	1	2720	jxdnuBgnGR4qeZoXvMAE6AmiVdCd1wYsV1YwHCjJ2J1nTjS2gTK	1459	2059	2059	1616309820000	canonical
2790	3NLEwGwjgZypGtHgCSbdVDmhU4Yqk9iBazSxPqWa2YK4gqJnV1ys	2787	3NLkEmU73WhiEXyKvwxTmmBWeFTQGLop2AxDJL7qMznfBfHBGmBM	1647	846	18	1	2723	jwnRkszLgHe5sqayE4fDZudnFrKXD6SWUbUWThoXCzkZTvhyPBP	1460	2060	2060	1616310000000	orphaned
2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	1675	1096	18	1	2726	jxERd27jnXPAWzReBcgsFRe26MtU9cZR3yKruCdv71Wga32ZrEp	1462	2062	2062	1616310360000	canonical
2794	3NKkxVL2rosNvchtAbP2cAmE49ZArzLUjqWpuL2erf8Cc5vAxCg3	2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	1590	934	18	1	2727	jwqwLQHi7VW7PMZBRNre8thXsi3JbTzgbg8EL5UDUJp7TQjVDDu	1462	2062	2062	1616310360000	orphaned
2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	1536	1187	18	1	2730	jwsMGmHqbpghfZaznEpLZrHe5p1FgLQkGyjAg9Em5nfG68Y3ZRN	1463	2063	2063	1616310540000	canonical
2796	3NLHnGWfPqxymjcThmuLjpdic7ZN9C9q9EH3w2hRoUZq5rZASM9m	2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	1619	1275	18	1	2729	jwgHyqjKRgDXikQQYqMaZkw7kyEE7rPju1csGgwasAr2N5RXsQg	1463	2063	2063	1616310540000	orphaned
2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	1407	1395	18	1	2732	jweS4q8HGBBCLi4r3G7s13XAheKL7J1Y4RFr8WfVrvynEoVJmpi	1464	2067	2067	1616311260000	canonical
2800	3NKezouAKHCMBnFfBKTbuJxHwnGf1CCq7HyXVKFC15RQ1ksjsLqg	2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	1581	778	18	1	2733	jxLdNZYiMjn14X9sf3AJkWWQz2QBzScRu8RJ8XjzDV6emZZ1gp4	1464	2067	2067	1616311260000	orphaned
2802	3NLKx27p9nmPNjAG4XMzS5tqoHqqpNheykdVVdAnCGqFQRX71Kas	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	596	1180	18	1	2735	jxUqqHTQ9vn3EhZ4sXtUwex7g6uYqt4XW8TAraEu7LDJjg6VM3W	1465	2070	2070	1616311800000	canonical
2803	3NKtCQj95VqW9oZtbqfL3U9FHB4a3AYYBWTiCyyVf89ANe4DW2XE	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1541	1172	18	1	2736	jw9kR2tviK4e1mS4fguPq9Tr2gSfccBBgmkt6S1gu8yU9anWUtf	1465	2070	2070	1616311800000	orphaned
2808	3NLbTw6CsTsWmc9HJBzFyKU291ZoyYkexB6tnpUhM72pfoseumLa	2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	1648	918	18	1	2741	jwNo2HEGVdmEMAKyreh9zrvDuzxgnB7gVK7a6w996Tq8vK7KdyQ	1467	2073	2073	1616312340000	canonical
2811	3NKj3RnoxSCdaiJBP4Pgp7GQ837cbUXdMZ5Brnn3ZKS3sf5iwiZX	2810	3NLQTF9KTK8AAfuoiCYXr1gdZQB4WvHiKnSMAeQx34n4Se454wkF	1571	969	18	1	2744	jweFZ9kU5ysH4Akh36JoM8WxQs3pBuK4CDFCQ4p2KFr36eXP17W	1470	2076	2076	1616312880000	canonical
8184	3NKMcj9Dq6VHAtMrMNN5gh63ycpr7PiHZnztrc2z435XCSgrc47p	8182	3NLMzSQ8SoYi6oQ18SCcjtFFxH7YcYrK6dKBJcxhATEJiBbQt3xU	1406	1393	96	1	6301	jxcwzH9gi2AkJ2s91iShcX72z4Pk13Px4FDynPs6Ew5g5UmyGxR	4241	5989	5989	1617017220000	canonical
2766	3NLsZTtrjzz45a3De7E5ZYWHXBq9ecvEEpbfCzJePujiQ4irfT5Y	2531	3NLMUCvFywVACTSmbrFzvoY5f3HwfRLDfCdpZcrFiVmuDThFpp4V	1673	1368	14	1	2699	jwWvPhR3UumQt1VA1HPF65QxTP7eWBqdCLCwHTW9Zr7oADJFLBv	1332	2043	2043	1616306940000	orphaned
2788	3NLqK6Ek82h2USzp5XGb7BmukQGERdarRoQ8JTyXEYSUwUe79hST	2766	3NLsZTtrjzz45a3De7E5ZYWHXBq9ecvEEpbfCzJePujiQ4irfT5Y	1673	1122	15	1	2721	jwhSNDU1mgrCETRiv3WrqR2CMJN7huXMBp8PtRXChHbacchsibE	1333	2059	2059	1616309820000	orphaned
2804	3NK2vr9c2cR7PMamHavq9pRoghzLM4eoe2PPYcrjfeamZF9gmduV	2534	3NKjEfCzCZcfoakkg4i2iG9g2X3HLx2YuSiVCtNiNYRfzStTSRWr	1541	1172	15	1	2737	jwArsBfC7TXgDfvD2cXwvE4wgzrobyjD31dAgyVBajyfC1x66BD	1334	2070	2070	1616311800000	orphaned
2820	3NLiLiwtcwykDozB4yyXYmaEJJKcHBbteCVy3ACHm3YqR9uX7WBz	2571	3NKeadxSNJd24Yw3jPLgRWsX2HWy74qxLQFtExUsfp1ZkGLwbJkH	1406	1393	15	1	2753	jx8hWLNtDwon18XNG7PvJ7RPgK597FHznxisFWvaahtHutAAQtR	1355	2080	2080	1616313700806	orphaned
2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	2731	3NKKajQHh4pTaRXvZKPFkJdCeDNnkex3nKXU3CrKoK29ht796MZ7	606	1295	17	1	2670	jwSPa4DePqUeNb224vn1xE1qmjdk3SSRMPGkvU7hUqtQYg8Ssv3	1435	2025	2025	1616303700000	canonical
2748	3NKsZ3HPxzdZKcPWyS6VbHB7in4Gjb8NGUWsEebu7QZ1wiU9FZZ9	2733	3NKQ1wWFDv87Dmqp1fKKSyADqsXAciT9PT6yjTLxYTQAxvS8zJ93	448	1179	17	1	2684	jwMnwaqUBt1LZX8N1ZFsFHA8G4Cu36We9FcfLwSKpi6k4T7ZrNt	1436	2033	2033	1616305140000	orphaned
2736	3NKcDnGxcr3WvWbK77GJ2kr8CVpx755dkxr7ZWaiEfLnp3fXyKuc	2735	3NKzkjdbyECPbMAnh76rqCAG6WKE7NfLUnFmAt5DfmXuTdDRiNkh	1542	1304	17	1	2673	jxnKRqNZny9zZJ1vXJCsskcykDTRU5TUEUs1F6imNPJjWkuDhqg	1437	2028	2028	1616304240000	canonical
2739	3NKJNoiTBVwLYqjsuEmrHtmBVYAibZrisYHTZsvXiZ1zDoZHvxsX	2736	3NKcDnGxcr3WvWbK77GJ2kr8CVpx755dkxr7ZWaiEfLnp3fXyKuc	1652	1189	17	1	2676	jwjX1cAKFa2tUHYkihKGNCS6BEMVDXgNt3WBLyfna5fzda83TWP	1438	2029	2029	1616304420000	orphaned
2745	3NLfBv6kV64uM5MGBXYToVts29Z1vSRei6gpvke4YccBEYc6XE2F	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	1407	1395	17	1	2681	jwR6GjQf4Xb7Sn4QpwFWwXax4ufZKm7VBo7CX8gxvLZdS1AXsZc	1440	2032	2032	1616304960000	orphaned
2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	2747	3NKKMqv1deRVgLrcqMb47SU3ch5Td7et8hR4JgtBnNvxDjBLZ3ku	532	1177	17	1	2686	jxPGyUf3kUmZTRwH7gFuwjPw6YMSh16jEumMuDSf3qj3N1Fw9mg	1441	2033	2033	1616305140000	canonical
2759	3NLbQj3fz5oqyWoMaucoUjvw7zsE3aP7VgQgiedWbYLGvyJqCpgf	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1553	776	17	1	2693	jx8v4JAoxDYmtvRZVL2a2c5idXGMoKVyGWjUi9AGfBmrqNfnjre	1442	2034	2034	1616305320000	orphaned
2763	3NKQDirLjUyNeeToJVakxfEW47y9XvJmYNDJz4gXwjpfCpixmwsA	2761	3NLq8hkD26zpEridotsbMnz9rsPEdYUurhFYXpmMyqsKUs9eSmq1	1406	1393	18	1	2697	jwwdNE6CeQbTANX4i1Ze1NpKEJnJdjW7t8XgeoAEhMpYMJJo312	1444	2039	2039	1616306220000	orphaned
2769	3NLojEqaq5j7Rxf6V8LLT37vpHhyzC94y871fKtQ4aaxfW5s18G6	2767	3NLRL5LZRP8Ned9yJ88Lw8x2yJftQQyD4BtKDpTBfG1WxTc6uj2k	1482	226	18	1	2702	jwwtDuvAq8Hrmdbq12BAN3ePPHUwPsirGqmWz8goxVURDJRphwH	1447	2045	2045	1616307300000	canonical
2771	3NLqZgc4PGeqTRAKh5VtdzgbazGCgiivTaZTiHRTjH2Ryr4zoiWw	2770	3NKC4GLukMhH54TiCey8WqxBdezydEnrcNAn1Aun5jx9mHqRNeSR	1461	1271	18	1	2704	jxAUKqQ8JLUX7JocFXej2frh9eyzM9YusxgFpNgvz6zQcytm1Tc	1449	2047	2047	1616307660000	canonical
2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	2773	3NKzD6k2cDDrvJzVzMghKQSVrvM1hxMPk5uWg9HE8jA8vbozSTfH	1637	816	18	1	2707	jw8QnnToHyftxVBXNBdAjVYhZycgX4Aipn1EMxsJUBbUjkzfCW7	1452	2050	2050	1616308200000	canonical
2780	3NKtzd3mHNsrR1QptRPu5eat4CxcmaiXsVrRPnWntY8rc4ZT25MC	2776	3NKeoPiP33nJ6zKkt8unHUM5mEFfr7TjEkhp2mf3heXvxxMeozmM	1637	816	18	1	2713	jwzhHuYzt8h3tXxDiirSQCW9yXk1r3E2YYsKzq9Ghf1Q2gfbdVP	1454	2054	2054	1616308920000	orphaned
2783	3NKjtGGRkntgCcZi7vZuuGtu1YUEQAZ141SyBifRm2pSxMVZhsGz	2781	3NLSt1sbTZH4MrhsSa3o41q9yqNjJojjy2HKvLxoqT31w5sXwzhG	1596	1237	18	1	2716	jxBXDjA1cQuhhwBUTZaQ6u6NcFoGhZ6iFxbGMeVrrmwBHsdZMg1	1456	2056	2056	1616309280000	canonical
2786	3NLXSoYCtFcgLyaJM3MrMmb1v6UXVi7ZwJ96Zcjmw2sMjYKb5Ban	2784	3NK7Gycc5QjiwBnHDpWT5Nw33Df1sx8J5Zemka1AYVnXfKXT2rfW	1406	1393	18	1	2719	jxeJMsmwH5GqRMMVpSuiM5o7gprrAbauWx54TB7JDEujodxT2u7	1458	2058	2058	1616309640000	orphaned
2789	3NLq2FKkJuwCqqCA3xT41UmqtwsGz4RpphajesUe499uKeimrJ2t	2787	3NLkEmU73WhiEXyKvwxTmmBWeFTQGLop2AxDJL7qMznfBfHBGmBM	1600	1246	18	1	2722	jwbJnhaNuucmjQbsFxno8FYLNpzVH5nZyBtpAXhH2Xp9V5CANhK	1460	2060	2060	1616310000000	canonical
2792	3NL1SKqjELfrLQhoidbe5iw3KykJGFoV9KCv3nzrRcM2aVtHD7ib	2791	3NLR8n78NhJP9RsN3GwME9RfKkcP3YsMSpHeA7Y39FcjcBzK9uM5	1422	1337	18	1	2725	jxsjUSxurZvN3nCdRv42SsD3tnt7wfaRLcb2VTVrRuDAmp7gepf	1462	2062	2062	1616310360000	orphaned
2795	3NKBhdoSRxCkW59W2pghiZeRy5HMQ4nrvtnAgHD1GeMZCgejYNNt	2793	3NKuR3yTP8cieidA5VMeEVqxV1EzLBEX6JhY7iWyqefEd9tfbp29	1407	1395	18	1	2728	jxjsr8bKnhZZAWdi5gY1yWEoFz7iihazV42nRAUF9KXSgsRNkzu	1463	2063	2063	1616310540000	orphaned
2798	3NLh5wMcM7TY74PvKykJyJirXD9LM9RCDhu64sGSJLmBtk4PsT7B	2797	3NKE6BJtmw8Yj1VAEm6yzMCZtD1YUbKEujWayWQwN2USwxrwegpT	1600	1006	18	1	2731	jxBus9KnfUYptG2ub55jYUjSevTqCWKAPV4SqkGJpSEooLfUqYZ	1464	2067	2067	1616311260000	orphaned
2801	3NKjDYd7YNSKEHFfpZ2fjZEKkqU7Qqac1J9SvgS7dHrsGE86mKbY	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1617	922	18	1	2734	jxMkyRpkrMDPrTFFnsqfczgwF5aEDxQWfFC9RqH9NgFpVQuJMgU	1465	2070	2070	1616311800000	orphaned
2807	3NK3Uzp4Rk6hJKHaKWQct8NvWQjyLA52AeYWAyaE8YmXLmGSTLgq	2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	1587	1111	18	1	2740	jy3KhtDfgZJytmKcvo53zH9hm1SCxEwWKAtwvkMLdZ3VYWer7dB	1467	2073	2073	1616312340000	orphaned
2810	3NLQTF9KTK8AAfuoiCYXr1gdZQB4WvHiKnSMAeQx34n4Se454wkF	2809	3NLFmtPGYmsFjxdgchiQ7qgJE6pNd483bk6tKF7njRuEquc6Y8CK	1471	1386	18	1	2743	jxvqj92cCnyudjnzJuVAxvxPUGGPrtVa3f4iz7P7Hh6QJi5xRek	1469	2075	2075	1616312700000	canonical
2813	3NK5Nv7vUo717dfPi9raapvtznvhT6zyxfTmCktrJ81zcdMjp6sH	2811	3NKj3RnoxSCdaiJBP4Pgp7GQ837cbUXdMZ5Brnn3ZKS3sf5iwiZX	1598	543	18	1	2746	jwznWVJKqJVU1uTk1Rtpw3sZsoFDvxaaLdCBpM3Kom8x8xhkcf9	1471	2077	2077	1616313060000	orphaned
2817	3NKmtgAMoPRdHkSL3QxsgZDKcPSmAMXLTWfAQrwgNmTzjLaD86FK	2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	1527	1293	18	1	2750	jxxibTiH7tjVnwX1iBuWSMf4xHfBRTAbgH8SpRa424DcTRWGDz5	1473	2080	2080	1616313600000	canonical
2822	3NKGBGUba8cRYPrfj3uDuqn3MyDkyH8mneLZhCDRKaLYmvAEYhtT	2817	3NKmtgAMoPRdHkSL3QxsgZDKcPSmAMXLTWfAQrwgNmTzjLaD86FK	1631	793	18	1	2755	jwpVKASzDvAZQ8sX2L7sJwCYnWw3ii9nioQqWEMD8r482f4eUZi	1474	2081	2081	1616313780000	canonical
2825	3NLmQkGXKC3SFSPimByDLDanccxgr26Yo5qLSc67JGHaocoe5tj3	2822	3NKGBGUba8cRYPrfj3uDuqn3MyDkyH8mneLZhCDRKaLYmvAEYhtT	1407	1395	18	1	2758	jwF5q38Q5UZSwjdCLguSKVeEfG2C9Y1q8vNZoRXDKN3cNztZfiS	1475	2086	2086	1616314680000	canonical
8231	3NLy3eMoFz4QAEAHoTZgCpffnJobY2FY55Uw5KXj4HtPgBG4skmc	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1634	965	96	1	6301	jw9WiExEZqyPVBEEwwQNLanVATjV66dVgLV75u9cfgHek9Bbuuj	4266	6018	6018	1617022440000	orphaned
2824	3NLN5C4HgQW35UFCud2F8qNz4FHg1XH7MWBvYKd5qvvDZ6W99DH3	2782	3NLuDkFGamHFFCpNeTdRGfHdAnHzwLGgzNRWfCEQSU1FK3npRSAb	1403	824	13	1	2757	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1283	2084	2084	1616314320000	orphaned
2835	3NKu8j3nt4ReUzAQ6vKmbD2stwokKzqRZW1J7YZyw37grXBtxBcu	2824	3NLN5C4HgQW35UFCud2F8qNz4FHg1XH7MWBvYKd5qvvDZ6W99DH3	1403	782	13	1	2768	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1284	2095	2095	1616316300000	orphaned
2818	3NKt2QZPqY2W2qqtRDsNKMeB1MDNAUgiAiqzxyk4AzPDyTjUjgq7	2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	1406	1393	14	1	2751	jwKmGrFC7Yv5N4qoTgqiwT8cFCKmYM2fgnPg88MydRhd6oZb6kw	1333	2080	2080	1616313636361	orphaned
2819	3NLpXmub812jsuR3fKYmBH99wt1jxyPwqGQKTvbknyRtWoYHLsHg	2551	3NLVpTxMsshZLoTki2AqwQeLQKjfNoRAeyJqBNcNnCJKxsXa4UX1	1406	1393	15	1	2752	jxoQSPL7LBcvbDVgMw6KMf8Lukb36sVsriRspbG4fkBSCy28grq	1344	2080	2080	1616313667706	orphaned
2821	3NLC2HHkVbHrjrR1v2aHtki5m7WMfbQpfNNRK1g8dpMTzHPqqWcg	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1406	1393	15	1	2754	jxB5LoS5w6CNHr1tQPJBA3ECsTJ2JzDVmxqzeqcgbhPrz6WbgiL	1366	2080	2080	1616313734683	orphaned
2862	3NKdmUZ9T1eEAQDz8ZbVPixdUvvww9MKyQtoNz7Qgr9wRbmD5Bz7	2672	3NLYB2wrMR5zmMDi9qqssPGPbNjcfjtbNovmLoRAyCY4xmNygakn	1513	1133	16	1	2794	jwFomTwsXqG1cJamGGd8u43SgT1e1qzYx7UN1GkiiyMF52fWdqq	1405	2116	2116	1616320080000	orphaned
2805	3NLSHyQg2J3YMrPNKwsVNG5y1WJHAoVpcNR1464VQXH2VD8fppBi	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1631	794	18	1	2738	jwPhcdXtyLg9zKc7p6KcT1aRZCxs9vsRrHV3PtkbkqZji9jzVQE	1465	2070	2070	1616311800000	orphaned
2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	2802	3NLKx27p9nmPNjAG4XMzS5tqoHqqpNheykdVVdAnCGqFQRX71Kas	298	1062	18	1	2739	jxUWQHAqVedcXHZ9p1nh729aUtHdhPp6cCauUbGxDgUN2TZtyBQ	1466	2071	2071	1616311980000	canonical
2812	3NLDzXVh8HZKeS9Ukwc5f4FyXN9RwHogeJ6AB2eyt3mPMdwkLfK2	2811	3NKj3RnoxSCdaiJBP4Pgp7GQ837cbUXdMZ5Brnn3ZKS3sf5iwiZX	1483	390	18	1	2745	jxgxoPLRcBssXFc9HWiiKpDYgmJeMqeuVavZqyDUJe4UUkeXNpL	1471	2077	2077	1616313060000	canonical
2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	2812	3NLDzXVh8HZKeS9Ukwc5f4FyXN9RwHogeJ6AB2eyt3mPMdwkLfK2	641	1336	18	1	2748	jx8wVWwJfnPJCbZFBUCUmTSWPBFTr5FhrSr4RdnQaEfxnsSSBiD	1472	2078	2078	1616313240000	canonical
2826	3NKhjHydPRSLAXVgxoLBskJQHdLcnQ9WodxcxjYCPpx35g62dMSF	2825	3NLmQkGXKC3SFSPimByDLDanccxgr26Yo5qLSc67JGHaocoe5tj3	1407	1395	18	1	2759	jx9aqynBEPMX4VopGwjAw2J2gzvzdr1ywvYULrFCiNd7A4tzTBU	1476	2087	2087	1616314860000	canonical
2827	3NLDnqgTk3wgKA686HJkTG93MVBDY1uffpqtQN1igKVy4nVs3GZB	2826	3NKhjHydPRSLAXVgxoLBskJQHdLcnQ9WodxcxjYCPpx35g62dMSF	1407	1395	18	1	2760	jwhLB62X6xkRXizV3s2BMuwMBkj2cxjaWn6v7Ps7hoiQmJVERvo	1477	2088	2088	1616315040000	canonical
2829	3NKHUqwc1YhRQVPUfrojewmYdoQzpLSBgra2XwvNVgJeHu9JoPmk	2827	3NLDnqgTk3wgKA686HJkTG93MVBDY1uffpqtQN1igKVy4nVs3GZB	1656	977	18	1	2762	jwvAgE6mGsqDjrnJYxmMFDz3KiwU1WC9pvTZhWugTocQXRM4ccV	1478	2089	2089	1616315220000	canonical
2830	3NLY4SjeXrb5btuU4kgL15ZfVMnRzLq2qbCiHtWRh6NSChRTafeA	2829	3NKHUqwc1YhRQVPUfrojewmYdoQzpLSBgra2XwvNVgJeHu9JoPmk	1607	1102	18	1	2763	jxgYMe4GidTQ699DJ1LC8U9TvhVFGMBQHPLV6xT7nAd7ecuAG9p	1479	2090	2090	1616315400000	orphaned
2832	3NKrYMcNdQvPUn9vTo41JfrQvSP2tvRqerembjA45gLe7tCkpPbQ	2831	3NL25GoxSwjfo1rpGETYgXFZ1ADTWrPnCaDgSrRGQs3cgCDzoRM8	171	1008	19	1	2765	jxj2nF2CWQhd9vFwib7Fq3H3aR5kYH5qjoPPLmRPG3jBPuZZcgQ	1480	2091	2091	1616315580000	canonical
2833	3NKkB4gB4gRpHYWBbLiQDfmUUJfHkuodoKibS4tAzvXFSsD5SwMR	2831	3NL25GoxSwjfo1rpGETYgXFZ1ADTWrPnCaDgSrRGQs3cgCDzoRM8	369	1066	19	1	2766	jx5PmFvj28XTZh4uW7H9hvkpdw6rq1hZjyPyCsJToHCbQwTTsWE	1480	2092	2092	1616315760000	orphaned
2834	3NL5J9MbJK2dh6chsPqKkcCfgpm9RBTfPhLPjezwFzkmUX5V48LC	2832	3NKrYMcNdQvPUn9vTo41JfrQvSP2tvRqerembjA45gLe7tCkpPbQ	369	1066	19	1	2767	jwjttpzDzv6b672sRWe4gRwPfwpKkDWJF2jDgGowiMVNHvNQ5wF	1481	2092	2092	1616315760000	canonical
2838	3NLmkg12KbtnLYygWZyAweb9we6JtuJ7MpWvcaeFQL8U8np9CrXr	2837	3NLHLvh391DxhYVpt7rCE8biUE84CW1tKsYv9h3zPvMaKQDSBoHs	1467	1376	19	1	2771	jwCzAMkLh58jcZbVafj7Q93okmJxrQVWbdYjhaiEkqvkjiEkGvR	1484	2098	2098	1616316840000	canonical
2841	3NKwwkmzHJt6dsebgdEfELf1Swyb4GXvgfPStZqgWXkQ68gXqGvr	2840	3NLFAiz4mx2dryP9jrwb2N4YCjdtGCjvq7uDTUnFeZkYwGK3jcBz	1647	1056	19	1	2774	jxR3UY7MRmiaMXLtw8R6RCQJVtFKYxFLpTitXSSpiCXmNoLw7qT	1486	2101	2101	1616317380000	canonical
2844	3NK5FxdaxnuDR5MXfkisAwSE18mEwKyDDwm5625ZNz38ubc85Deg	2843	3NL6MTyq2jydyFAo1is1eDw8Crv9iWB4yhXgmdpNW8SwiT97XpSD	1477	1350	19	1	2777	jwK972BjabPTFWDbnWgLU8o14FCvWzco9oWCHSeiZiwJ5rBq9Ju	1489	2105	2105	1616318100000	canonical
2847	3NLdBFhAGoBcVXdRwthF4r18AN6Dcy1p8MKWZDqqdvpLBB9hfUJ5	2846	3NKXrMPm7KLbWiH8vZ6mvUV6MdFpHjtYn8TGhNFu2wuU3MQUEM8w	700	832	19	1	2780	jw6sEKnheuYcMLLoVAWBgesH8VpAcKsLtUd8qJAyPHew1h2Huua	1491	2108	2108	1616318640000	canonical
2850	3NLeUcMwdjY6mCNHohbcgBh9nrA86RUoPGvJvfKFXtPp7fpHYyHJ	2849	3NLQ9RAEFJu4ggtvQjbM3RTuoMaDrKSkKgsBRsp9GG8YpETtvYtw	1509	1320	19	1	2783	jxinVaBp1sKpvBieuZcagLP4fQAwUZ5Dx8pV2MExum66QxgoNsQ	1493	2110	2110	1616319000000	canonical
2853	3NLC7qPemgLyio27FXWjqjSxUCHphUtpEEWRVJULcmx3byFqiqGR	2850	3NLeUcMwdjY6mCNHohbcgBh9nrA86RUoPGvJvfKFXtPp7fpHYyHJ	1407	1395	19	1	2786	jxEkvaoc4a4N671ybhzTjNZjSrAxwcb77vyWPMcTdr8hrNHLyEf	1494	2111	2111	1616319180000	canonical
2856	3NLXHpPEkHnyANYwqZmTYAwXs9f4AnKVczEHGEMEmQVk3R5PChfZ	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	1455	966	19	1	2789	jxkzUk263RJXjWSWirmU8jiqPZYUgRHazupzRiksmrMNLtZcHcC	1496	2114	2114	1616319720000	canonical
2858	3NK7UN3LnCjsdoRityDgioiVFUS7g9FGr3x9WLuL3iiqGu1Qzn5u	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	1461	1271	19	1	2791	jwYoFBvTnYM9RowDdxfsxKB5MeagXQMeXv2RJtg87yKvWyNNJuA	1496	2114	2114	1616319720000	orphaned
2863	3NKitKvA7x1utdTG1cS7ynTEuABv7JSe5ZfQiwWDW8gUmn2JZbwd	2861	3NKBfmBD9zeRLtMeaN9Vj4J89ZUCc6QUCog2GHWFzbLk3ReatV9i	596	1180	19	1	2795	jy1EKWCnvAaYaBtGjsKUFcM5KfDwWyL6nKwUk3amCjZHKF7Pv4F	1498	2117	2117	1616320260000	canonical
2866	3NLvaJvtdM1n7za7K9wkzeXsARbHPuLiX373xhWVTYCnWU4V3dJS	2865	3NLKx8d9w13EcweUG4Q3WYiVPm9Mso613wq28Agsh8TV7vtUubaJ	1402	858	19	1	2798	jxxAfuBy2KtPz8hADdKtBWjDvaQiKyheUUUKYKtZ9kfDFhdmYdP	1500	2121	2121	1616320980000	canonical
2869	3NL6t4N6vNqbq1duNWQ92k5rMk2EzochE467vFSqssXJwtdqJ9y2	2866	3NLvaJvtdM1n7za7K9wkzeXsARbHPuLiX373xhWVTYCnWU4V3dJS	1627	1259	19	1	2801	jxArkF5HYTSJxvwkFRbhLgsmvWroSMV63EBz8SLDspqC4mA8vVh	1501	2122	2122	1616321160000	orphaned
2872	3NK4zYaotPVMm1bAnXchT8MFkXjxGKr2EotL4V77DEzz389qL2Hz	2868	3NLaKBpHfHC1e3KRWGso6o3VxYbPm8yu6arrNyQfcQ2jzfwApAXJ	1553	776	19	1	2804	jwV51usng8ZWstxzMTuZXov7hV5oArvZ4ERDYK8JdgqjcZpZdbc	1502	2123	2123	1616321340000	orphaned
8232	3NKLy5ic6LzGHA5qBFyoH84tcaX1fVr6k9Goc5o1nZFBsC8WfQwr	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1523	1321	96	1	6301	jxPV1kzgHrqiodAVNUPP6hqKjNcDtjvKtt4jPfvp1V2S3ccUoc8	4266	6018	6018	1617022440000	orphaned
2836	3NK8U7vr1tgpstyp47SLfrVBvygbY4Bvyqcf3rUU2JppWGLhA3gv	2834	3NL5J9MbJK2dh6chsPqKkcCfgpm9RBTfPhLPjezwFzkmUX5V48LC	1405	873	19	1	2769	jwsEwnHmJ2xM3tvvUUP856ewjWPuSrcvqTzuuT91og5eqLWHTLi	1482	2095	2095	1616316300000	canonical
2837	3NLHLvh391DxhYVpt7rCE8biUE84CW1tKsYv9h3zPvMaKQDSBoHs	2836	3NK8U7vr1tgpstyp47SLfrVBvygbY4Bvyqcf3rUU2JppWGLhA3gv	1407	1395	19	1	2770	jwgwwjsAz9sLReX1UYFMxxk4hFGAjaC2iZUd1nnFvi6XHwqsmjS	1483	2097	2097	1616316660000	canonical
2840	3NLFAiz4mx2dryP9jrwb2N4YCjdtGCjvq7uDTUnFeZkYwGK3jcBz	2838	3NLmkg12KbtnLYygWZyAweb9we6JtuJ7MpWvcaeFQL8U8np9CrXr	1508	1141	19	1	2773	jxp8ak4CjWjMqu8QjeV4XQSp4q1JTSf5G39e9YBeggwESSMv5yk	1485	2099	2099	1616317020000	canonical
2843	3NL6MTyq2jydyFAo1is1eDw8Crv9iWB4yhXgmdpNW8SwiT97XpSD	2842	3NLfnRoqhE6YURVxqzatiBpkHyVRxw8qsLvfa4Pr7CHYMHhWeqMM	1646	487	19	1	2776	jxL2tn5AN4rWVncvtskRTByUTsXQooDW2cJMb6NSqcPjQpx62Vv	1488	2104	2104	1616317920000	canonical
2846	3NKXrMPm7KLbWiH8vZ6mvUV6MdFpHjtYn8TGhNFu2wuU3MQUEM8w	2844	3NK5FxdaxnuDR5MXfkisAwSE18mEwKyDDwm5625ZNz38ubc85Deg	1637	816	19	1	2779	jxkH5uwd6rW8ocVhD5eAPEKi1WEjHP5hM8wyE69MtJbXu7wqjaH	1490	2106	2106	1616318280000	canonical
2849	3NLQ9RAEFJu4ggtvQjbM3RTuoMaDrKSkKgsBRsp9GG8YpETtvYtw	2847	3NLdBFhAGoBcVXdRwthF4r18AN6Dcy1p8MKWZDqqdvpLBB9hfUJ5	1627	1259	19	1	2782	jxbdeee6CF96Sg85LFTgXekeGwFhds2aRN6B7MbF1aik6KUuUYu	1492	2109	2109	1616318820000	canonical
2852	3NLnzRGgE1L5MxJF9fWthg6yiDVXMtSnKeZbVj9Rd7YnMurH9f75	2849	3NLQ9RAEFJu4ggtvQjbM3RTuoMaDrKSkKgsBRsp9GG8YpETtvYtw	641	1336	19	1	2785	jxPeCanCHcuHFWCpVcdobsx51x74DZ7CRm5RmXJs5Sv4ioH1YeG	1493	2110	2110	1616319000000	orphaned
2855	3NLkeViDZjHmuqVcTmoHPoZoBYjmsDtFjgGM2CjBgxqLJxY4LZwQ	2853	3NLC7qPemgLyio27FXWjqjSxUCHphUtpEEWRVJULcmx3byFqiqGR	1631	794	19	1	2788	jwjxaaQMsUhZCxWcy87bAzR27VJtxv64W697bJW9AatbaZ6FhZt	1495	2112	2112	1616319360000	orphaned
2861	3NKBfmBD9zeRLtMeaN9Vj4J89ZUCc6QUCog2GHWFzbLk3ReatV9i	2856	3NLXHpPEkHnyANYwqZmTYAwXs9f4AnKVczEHGEMEmQVk3R5PChfZ	1527	1293	19	1	2793	jxvq6wxCTZqJxZjMApU5Duyd25TpsWsRRZryxG6UeB9km24tY4w	1497	2115	2115	1616319900000	canonical
2865	3NLKx8d9w13EcweUG4Q3WYiVPm9Mso613wq28Agsh8TV7vtUubaJ	2863	3NKitKvA7x1utdTG1cS7ynTEuABv7JSe5ZfQiwWDW8gUmn2JZbwd	1547	1378	19	1	2797	jxFKzRL61VC53PVXmMBFJ5p66ZtbXSTXf84kGHNQuDfRMYhLVLT	1499	2118	2118	1616320440000	canonical
2868	3NLaKBpHfHC1e3KRWGso6o3VxYbPm8yu6arrNyQfcQ2jzfwApAXJ	2866	3NLvaJvtdM1n7za7K9wkzeXsARbHPuLiX373xhWVTYCnWU4V3dJS	1407	1395	19	1	2800	jwLc6rHaiUMpPfReWC4ZQouENXfR1oNFYENAeQxmDSdzMzAEvw3	1501	2122	2122	1616321160000	canonical
2871	3NKYDUc3mKaG7C84NZHmoVV24EYAzP1JdK9m1GeWbvX2YhVVkTsF	2868	3NLaKBpHfHC1e3KRWGso6o3VxYbPm8yu6arrNyQfcQ2jzfwApAXJ	632	1256	19	1	2803	jxUKYR6Xiu2ubt3gDFLbdC3SQ3tyv8ZUKCAtrKMUZtbm2VUAdmT	1502	2123	2123	1616321340000	canonical
2875	3NKK8pWL3Fk3bpfAkHV1MtUYDUvPw8p1McKpye4EZEfhAT1BhZi3	2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	1422	1091	19	1	2807	jwG3kpzBKnN31Dq8cbAFkDUEjUDkHchv7QfpksLzZyA8h8Cgjmz	1504	2125	2125	1616321700000	orphaned
2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1534	951	19	1	2809	jxwkxUUYqFcLobQMzoDZoRdW89jkHzA1iaBsxwXR7mxVZy75UjJ	1505	2126	2126	1616321880000	canonical
2878	3NLQthAesmqPSTQb76uWuDU6Xt9K9xGhj8fNxCmWSjCAALYBXNkJ	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1608	1043	19	1	2810	jwnvEZjduTTm1SMWVxKYkdPZQ3vFZYGc7MCMqpsz7VV36NJzCJu	1505	2126	2126	1616321880000	orphaned
2877	3NKZdgXhjeFV2Lbxrh217EzramH1Pzw9p98XQm4eQ7Ka9kkux59m	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1534	951	19	1	2809	jwBA6qwRvAJYFNL5PKJGzooPmW285FCDfB9kvyWKttMQsCxDftv	1505	2126	2126	1616321880000	orphaned
2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	1405	865	19	1	2812	jxkhCv79ZmoKJwsL3sdjwSWkaLFXScE8XXnSzGvFoP92YZYcHi4	1506	2127	2127	1616322060000	canonical
2883	3NKs2f7RCjZABg3f5dpHPVas7xVMjefxgTFLTZHjf4szFVRMEHiy	2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	1608	1043	19	1	2814	jwqW3nJogbx954SHhrcpPu2Ru2ovWhNhf49ksrcCAZLPBoXN5Tp	1506	2127	2127	1616322060000	orphaned
2889	3NKgL6XdEkteHF9tnbxEaLigU2dS47XLLwnx4Jta9hAJVbGJoBor	2887	3NLd7yGBD76Jewu4yYPbP2KSeVJYygxqyTEkDRDevRVrZoCfzGsC	1637	816	19	1	2818	jwZmAS9HcUKfKH2ECFyNK2rX3cmiA7nPeqojom2AuGn3KCAWQ9X	1509	2130	2130	1616322600000	orphaned
2891	3NLdTxPVACBBgCPaGQjNNVxqAoQKrNEAyJnaUZoks84rPtCcshoR	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1457	1145	19	1	2820	jx9aNiuGfSce7gLH41HR7AmBFYHMdGuBKyGGYLo3MvZKPCA2pGt	1510	2131	2131	1616322780000	orphaned
2893	3NLmD2uMjUBWrTah6VsSkxJSZPqp1ePGBCWJEASeYddEmqQ9Krsy	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1596	1363	19	1	2822	jx3N23CMTC36qiyxVwrEuVJJxaJzA9SmSwg71KfRaevUxx9nxCn	1510	2131	2131	1616322780000	orphaned
2895	3NKL6PtYKjHdL2s1YYcmzKjX5xr6mA9bHE8jWDznR82pq8ZQva1c	2890	3NKTv9SwXyUg5m87CJW6WX4EH6iQgRwGs3WEK2VuJTvBxH4MmfpL	1474	1083	19	1	2824	jxDdiuiyGjiyVZSW4say145DBnUpyizuJ2tK56AVH2JMX3y5nXn	1511	2134	2134	1616323320000	canonical
2898	3NKXo9uK7AJBqWQbJr961jBxT8Hu2B4T9XrdoGVX1dQvmCGp76Pu	2896	3NLHECGVc7jL3Uh3wRJhXJBY5CujoJW3mvUqe4dGUmvvHBEq3Lps	1637	816	19	1	2827	jxENxxjNN9fM21CYTTqcJKtw7okaVkYVKLkgEw7GGzb6zkYWC2a	1513	2137	2137	1616323860000	canonical
2901	3NL9Qd5YDYN2TsUfiVabQJyocdGExyMDjuswGm36caQ71Ycprb8X	2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	1407	1395	19	1	2830	jwAz3XagUPMNF6837RtREqdhV6iVZRQsHutDsj7SpYkcX79g7DD	1515	2139	2139	1616324220000	orphaned
2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	2903	3NKp2MVDmL9ctgZ9LbeNyUpyJ9SBjfH9scQ7G4ngfntT2zEriVT1	1589	1040	19	1	2833	jwP2MYom3dmB1LnMBCmTqzQTpRL98mb7MwajgCXeuYZwFWCN4KJ	1516	2140	2140	1616324400000	canonical
2907	3NKjzN5Eu4T5MRfJpvCiDs76YiaFWzUGTRD5aJEymVZHH8zPQoPQ	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1534	21	19	1	2835	jxMqHvkS82pucs22bLNoGWSVim2zqx8HuByrMfkBrYD1X3BgFhB	1517	2144	2144	1616325120000	orphaned
2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	19	1	2838	jxjmU7QRmV8u9ei2kSEnq4ZjLKhohGJm88WUH1kQwXAaCwY2YXH	1518	2149	2149	1616326020000	canonical
2914	3NLA76kfnz1dNjAS8Y92Twx9ja2evs1vqbVLpQ1HkKugKoWm1bZj	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	20	1	2838	jwWag2DVtDkVotfFo8yEKZ1rT3rMU1GdZij5kgRGyty4gxySEKK	1518	2149	2149	1616326020000	orphaned
2918	3NKMSv5KYCKdxfPEghLKtdm4914MWAvP2FpqBS7LuHWqdCeXDwJj	2916	3NKKozLHhGmqoMiiRGtXWhHo6fiiZrNoUmacGraRMYG7RzSYWwRu	1643	1299	20	1	2843	jwk6hunjzCg3YdqcGkv3e3JVv6nN73Yx5Hwskm1CJkrTidVawMy	1520	2153	2153	1616326740000	canonical
8245	3NLk5t47fGQXnahnL3nmfaWs7poTrRscDobn2eC8MZXyPMNWwvra	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1516	1294	96	1	6301	jwkEAqcNRJs6SZMX8QY57sGK7ECV1cD4DYe1zKQorsAcoCTaHKc	4270	6024	6024	1617023520000	orphaned
2851	3NLM33utr6E18BCza1WBp5qoD3sV9QUeAANnL3nRQjH81hr166kt	2814	3NLMfQUL68UzGWjx1hvZoEg8ymUkPQPfno8woaGt4KjcAhMKS5fn	641	1336	14	1	2784	jxQfNGf12rxZ4pB5kqX2n8NpsiTqgQSRT65vrxW7cC6cDE1w74o	1302	2110	2110	1616319000000	orphaned
2921	3NKHyUMJpyKz847hfEkF4ETDVTFxuRh6B3GWMWdTXyX2GhJHioex	2725	3NKeHNeVp2XaAaJ1MomqnYjWond5oAs8J3aBxqKqsuTkurAxkCaN	1501	1234	17	1	2846	jwaGTsZzHMLMaHrT7tszf1HYSw9k1uzvAx178Ecw7MySD2VESBh	1432	2155	2155	1616327100000	orphaned
2912	3NLGqKng3Auh5VWuaMrECST23p2B2rau2DjpvTb5dScwoonvqjik	2798	3NLh5wMcM7TY74PvKykJyJirXD9LM9RCDhu64sGSJLmBtk4PsT7B	329	329	18	1	2839	jxgZ6iATWJRyZsbzFNeoZQfCCuhqpScunFKh34ywqJmU6uudTwj	1465	2149	2149	1616326020000	orphaned
2839	3NLdjpqAn7rmB3JVp6W7o6HB4t7iVsZA4YvHD31HFzugxK5t9Tvx	2838	3NLmkg12KbtnLYygWZyAweb9we6JtuJ7MpWvcaeFQL8U8np9CrXr	1406	1393	19	1	2772	jxsYLssCscPRxtZ7pfyvtwQUzDcgxDraksnXaPWdjycF86BaptV	1485	2099	2099	1616317020000	orphaned
2842	3NLfnRoqhE6YURVxqzatiBpkHyVRxw8qsLvfa4Pr7CHYMHhWeqMM	2841	3NKwwkmzHJt6dsebgdEfELf1Swyb4GXvgfPStZqgWXkQ68gXqGvr	1623	839	19	1	2775	jwZZfaeJ8LEtEiqXrThy22Yb1V414YdMt2FBo5huoVx44dpxnRZ	1487	2103	2103	1616317740000	canonical
2845	3NLyTDTSyRBZSPksC4izVDqZVnawqm4pYYRSni3pf26mmtxzAPRW	2844	3NK5FxdaxnuDR5MXfkisAwSE18mEwKyDDwm5625ZNz38ubc85Deg	1405	851	19	1	2778	jwZ8cpjmCUfUc1SSFxTuhMx5w86MPPcudyr1u63V5rzgENUTGKC	1490	2106	2106	1616318280000	orphaned
2848	3NLHoAoTo9x1C3cRvh1HqLdZ1SzFCEybqLzTiUEWaPfNpopWb5NP	2847	3NLdBFhAGoBcVXdRwthF4r18AN6Dcy1p8MKWZDqqdvpLBB9hfUJ5	1407	1395	19	1	2781	jxeMJei5FDmyiyVLGKKUVJgyGWioayrECgbca3eJHvPE25KgdNg	1492	2109	2109	1616318820000	orphaned
2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	2853	3NLC7qPemgLyio27FXWjqjSxUCHphUtpEEWRVJULcmx3byFqiqGR	1444	1381	19	1	2787	jwKMN5WhQBpx82nYyuUwd3dKuRR5JMudCSYZx4zN29EuNXd1kwc	1495	2112	2112	1616319360000	canonical
2864	3NL1ZER7NaDYWX5CinuUyKs44HCjKFFY48CR7asbye2dcea8UTsd	2863	3NKitKvA7x1utdTG1cS7ynTEuABv7JSe5ZfQiwWDW8gUmn2JZbwd	532	1303	19	1	2796	jws84ubYbSGSPGbXWEZko8ZGmWSC6Hz8M9Bx6EMAXTXgH7Koo8y	1499	2118	2118	1616320440000	orphaned
2867	3NKwi1rSmcv5e15efmX5qLW6dXk493h4cxPXtm3kwEYTAzf919sw	2865	3NLKx8d9w13EcweUG4Q3WYiVPm9Mso613wq28Agsh8TV7vtUubaJ	1613	1349	19	1	2799	jwP6L9BG8knPP2bp9PbEAHGYY5FJK1vsMpNsR3kjnsdZX39xJhg	1500	2121	2121	1616320980000	orphaned
2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	2871	3NKYDUc3mKaG7C84NZHmoVV24EYAzP1JdK9m1GeWbvX2YhVVkTsF	1649	1257	19	1	2805	jwyUwMnHgBardrkyotDs2UioT4VKDkbX8BK4yf9BXpjcQ2usFeA	1503	2124	2124	1616321520000	canonical
2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	1619	1275	19	1	2808	jwsRsAgc3VQRi9mCJAB4UkV8zbVTGH3we6VRbAHwewmU36AKTsd	1504	2125	2125	1616321700000	canonical
2879	3NL3JrJu9srSXshEmmBgK6QhY8L6NJcgDTZVBTZatWXxG77Qwhfq	2876	3NLviBuWu9kAQuK6CUjTTxYrz5G41Abmyhgo9DcnTeuTYqYZjBrJ	1458	1197	19	1	2811	jxiicVTZ6yXrLBrk43HvLhHjhX9yqTdLSWxh93uzWG69ix5BXPC	1505	2126	2126	1616321880000	orphaned
2882	3NKoWSuMGFMEEbfeDpeTTNxyQe3Mtyw6LyhQGQBNzc2thgWiBXGC	2880	3NLXVPAnt3s8WhEMx3HacBLXcw51GKAJGo92qZe9DNGUTQEc6413	1593	980	19	1	2813	jwFuyZqea4zA5dqZL9ScPCmVFU8PARHtLDFXg7DniAYiNxUkegx	1506	2127	2127	1616322060000	orphaned
2885	3NKiin4NhJ3vG4jsAyPDt1fAVzsqnXfGTANNx356qi1uryaLxpip	2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	1523	1195	19	1	2815	jy1XJdXDEPcDvxnt5VbgvbuFiZrRYS1WM2Cc32XRUsELR5839HL	1507	2128	2128	1616322240000	canonical
2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	2887	3NLd7yGBD76Jewu4yYPbP2KSeVJYygxqyTEkDRDevRVrZoCfzGsC	563	1359	19	1	2817	jwjQAJ4S9kEPJTUuFvKE9efsBXFqRVjoxTZPqXZb6Y1rnyGeKEB	1509	2130	2130	1616322600000	canonical
2894	3NKiUT61ga4iTk5dbXxgLmPHiaG26HzJUgFMKSgkx3FyPGSoPZYC	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1631	794	19	1	2823	jwQRi3mbxMbVXJciwwyiingMhhbuU2cUDnNvCvf2uP98cBBVirh	1510	2131	2131	1616322780000	orphaned
2897	3NKmB8XGfgbZSZkPDY7aAQHJmi5mEecC1F7FiSowegSWkj8DMvwX	2896	3NLHECGVc7jL3Uh3wRJhXJBY5CujoJW3mvUqe4dGUmvvHBEq3Lps	1553	776	19	1	2826	jwavp8kzPuo5Kfnmzxvu6UNUbxwzrEY5wiyJBa6rizBZgTqQUgE	1513	2137	2137	1616323860000	orphaned
2900	3NLr23HozvHq6rjqkezAV44sZzR632xfzpoW7UiRyV1goWjeRndS	2898	3NKXo9uK7AJBqWQbJr961jBxT8Hu2B4T9XrdoGVX1dQvmCGp76Pu	1608	1289	19	1	2829	jxY4vo8T4upgAHo1CDt4yaD7AA3mcM5qXjiG1LSk8QnMr38pD66	1514	2138	2138	1616324040000	orphaned
2903	3NKp2MVDmL9ctgZ9LbeNyUpyJ9SBjfH9scQ7G4ngfntT2zEriVT1	2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	1633	1024	19	1	2832	jxg94o7f66PfSNEJxoKWTF6kAnhAU2nyf5VioNtPLcUQvC4D1eZ	1515	2139	2139	1616324220000	canonical
2905	3NLQttBrGWXWSHkaGTsKWHyJWRVs8RD9P1ewqtsaV8BS6M87aQ2U	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1467	1130	19	1	2834	jxGu3FVxDnYPRrvjW36t3jJ1TMjB784ufsf4hYCbsTbdp4zRtXH	1517	2144	2144	1616325120000	orphaned
2910	3NLx2muhm1H7JLM2JjT9KddAyKtkJo1PJnBuczzLh9MCwJu3e5ha	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	19	1	2838	jwx74RKswWBjz761A6WSzEU8E9DsbcrryNk1TqoBGAxe3rzQ9Gk	1518	2149	2149	1616326020000	orphaned
2911	3NKu7BGgRkkWWpgR8eyt8jCCsXKh6ntJn5yCQYSKtxVWWBHa3G1C	2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	329	329	20	1	2838	jxnVxsuDi3ksWXkMFk1GezLZtvBfDD4EE3fyAqFVNVT4on8jDnC	1518	2149	2149	1616326020000	orphaned
2915	3NLm2rhwtRxtpQ53En5hhrupjP3RWzQu9Eih14HYfPLZhTEHtQr4	2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	1509	1074	20	1	2840	jx1BridaE5jL2BaSv5R56NcPBoqfVWCtZju4Kmci3WGSpjqVNw2	1519	2150	2150	1616326200000	orphaned
2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	2918	3NKMSv5KYCKdxfPEghLKtdm4914MWAvP2FpqBS7LuHWqdCeXDwJj	1642	1367	20	1	2844	jw83g7dsnSsZwwntitUszh5WqzBA3nSk9WfUWpZDhyXPJQ4j88P	1521	2154	2154	1616326920000	canonical
2920	3NLRkdvGFyw4qjBJR9uiTWjucsWBEjj3pKN464FWpe2fbZCFFhsr	2918	3NKMSv5KYCKdxfPEghLKtdm4914MWAvP2FpqBS7LuHWqdCeXDwJj	1406	1393	20	1	2845	jx38yHphqjZq6XgFP7FELSFBffxzxz1xnvK9JvhyjFvqhouYwYm	1521	2154	2154	1616326920000	orphaned
2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	1447	1219	20	1	2848	jw7fbeQ6kh7ahs8496v9WUCKS6iSx3AqUxGzdRxknkmqk8dRyFV	1522	2156	2156	1616327280000	canonical
2922	3NLWDKehAcjdzTXsZ99PYuSRhpb82M88hLqaXRbye46kX3Aepdxr	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	80	1273	20	1	2847	jxsde8YpfbikUbgfvMY1xuUexEMDGhE742JbNWr8zA7CymE5DTr	1522	2156	2156	1616327280000	orphaned
2924	3NLFQgyFLf566gpnLb4nSQ7CYK8zmqZzQehZKx8Qb5thc9FxBpaB	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	1522	1076	20	1	2849	jwBUR8DLtVQbJrKT33Vb3j8tBw5v93oM3Cpmtm5Xyz9LFzxofQt	1522	2156	2156	1616327280000	orphaned
8248	3NKwGsHGwn5uHMMPUddQM9GchAwfFTCbq5zg44NLbE5ZzYNhqiRH	8243	3NKP84FmBDq9ykNPQjswNEx9Ljjwg3fkZfiMZAHFx1kdjcJf2c1o	1623	830	97	1	6301	jxNEUQfStzkg3w2GrMW2LEB9ps7GCJriLK3mSUsv6qmvPyQbeiy	4271	6025	6025	1617023700000	orphaned
2937	3NLaQuj7zpzp6CXPgLoFLynvTWNZW2m58Sy5MxRKS5xmP55YKQSi	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1422	971	17	1	2862	jwPMNKHNyNkZnoBR6sgxhUEtmsu5wXMzXwtjjamXvev9cxRwwWX	1429	2163	2163	1616328540000	orphaned
2938	3NLi4Sv8TxPBSyaGS4tqcH4aDsD6UA29TZL7czxiTDwwrFczEviZ	2765	3NKSJpLM6fv3Fd6QU5ZCTh1EQ7AgwTcfUFi7vwCwFg78oL5zUPrK	1422	971	18	1	2863	jxyqFUA5DigfJCXEV9KAPskQqEhUbSwM7in2rGRmooK8CEMEj26	1446	2163	2163	1616328576713	orphaned
2939	3NKvZi4E7hCLPvmfWsWWXyenvX9mum4nzzmei1gsms9NdLTtptWJ	2799	3NLSWY6afstkERBwTrqH8VpyWeLbY5qjH1H8PPpxGEao56AroKY2	1422	971	18	1	2864	jwWWHBowftbWz4mHbcLHNPZb8eKGFkGjDRXERxjsuTzBNmi2KoN	1465	2163	2163	1616328613326	orphaned
2940	3NKuprfzsAhLnRv2ohaJAuphs7MeWAYxP2gMHuwdStNs2WetHkHn	2832	3NKrYMcNdQvPUn9vTo41JfrQvSP2tvRqerembjA45gLe7tCkpPbQ	1422	971	19	1	2865	jxAsG8BG9eEo3mPreDHVSK2sNM4mXo5NbxRReMX6J5rJzeXTHwD	1481	2163	2163	1616328650033	orphaned
2884	3NLcJWEQPZkp2YdN4erDpMagCZaeLWEUtGzhhfMnitiWjsyeDaag	2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	1523	1195	19	1	2815	jxTdSqJuBX8XGuWCntJv1GXocHHkHp6JdorYQ1nYhQSdvb4dmgC	1507	2128	2128	1616322240000	orphaned
2887	3NLd7yGBD76Jewu4yYPbP2KSeVJYygxqyTEkDRDevRVrZoCfzGsC	2885	3NKiin4NhJ3vG4jsAyPDt1fAVzsqnXfGTANNx356qi1uryaLxpip	1549	1362	19	1	2816	jxHPxC7BdWBn42YBxrHduZ9iq53WhcqibmQeVcgaYG589fJLcVj	1508	2129	2129	1616322420000	canonical
2890	3NKTv9SwXyUg5m87CJW6WX4EH6iQgRwGs3WEK2VuJTvBxH4MmfpL	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	563	1233	19	1	2819	jwgPZT8uuyGt7YQ8biXBoYJWcXxgHLgfUqbY2EZ1cFUjvZGTGui	1510	2131	2131	1616322780000	canonical
2892	3NKKxW8yJjeXEfNLtMcNzs1RyVGETf5Zn4U6YPdvGz16G8r8ziUS	2888	3NKY2mUcnijWKQ8R3cbsvp34VPpq7rWUd3wuJYc6YP3Seh3jBqY4	1617	1288	19	1	2821	jwMymyB1v7Qm1crmSAg9XG788fiZLnhuvJuv85BbFjuF3hfAwKt	1510	2131	2131	1616322780000	orphaned
2896	3NLHECGVc7jL3Uh3wRJhXJBY5CujoJW3mvUqe4dGUmvvHBEq3Lps	2895	3NKL6PtYKjHdL2s1YYcmzKjX5xr6mA9bHE8jWDznR82pq8ZQva1c	1402	868	19	1	2825	jwkDdUTegZs41eCQqisteEsYScHtJKiXV2pMaWR1igWTiTyb6bj	1512	2136	2136	1616323680000	canonical
2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	2898	3NKXo9uK7AJBqWQbJr961jBxT8Hu2B4T9XrdoGVX1dQvmCGp76Pu	298	1308	19	1	2828	jxNFpbkwBmRFv962EDHMwijoEy7u3hYxsVKz8A7mCZHxCmF6h7T	1514	2138	2138	1616324040000	canonical
2902	3NLNCTsN7MCCdaCmUqrg6JJ7Ey7pCjpvwzbz9HwXQC9gXpgwSGTk	2899	3NK6Ee4aoh9b3BWFGsmT4jZvSGgyj6jHGPSLf5S3XKZGuzq6rrCH	448	1305	19	1	2831	jxghdrotJmV7SFhkUJikYm5BgDaaZXgCXdU7Jq9biH5fLfjA91V	1515	2139	2139	1616324220000	orphaned
2906	3NLmPBPSg2e1QkQrKwEJoKtepJTjDpvvVVTzmrqe69dEcc5z9ieB	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1534	21	19	1	2835	jxo7YmJk51HZWtE71b4eoJywbPJiKoEyFvi7bfZiynt6hLsQWMS	1517	2144	2144	1616325120000	canonical
2909	3NKgcYKTCbSMeWGPk3akeMVDk3vEqwFxWVDt4WAQCDm9aa8nULvw	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1647	845	19	1	2837	jwEiPtJFrEXiNdid5mbuYeNmgdrWDxmBgHfr1x4iMJcP8HntRWh	1517	2144	2144	1616325120000	orphaned
2916	3NKKozLHhGmqoMiiRGtXWhHo6fiiZrNoUmacGraRMYG7RzSYWwRu	2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	1444	1381	20	1	2841	jxJx6gB18bJm6LLUtg5EJ3v7CRXkQ2BrZybQkA643UBe9yNY8UW	1519	2150	2150	1616326200000	canonical
2925	3NLcSNnZJ4NLNVoJs34BLFUoJCE6Q8QxZajjiwJgaRvucHVS66S1	2919	3NLCEsRxSRmGgzaJLB8CkPvsEnL8qfu7ZV8H5FhWUbDnxiquZTAo	1439	1033	20	1	2850	jxutQS1LG6UhJWhmaU9yvna2TwKhs9L1isHSntndFcFEXBnCDV1	1522	2156	2156	1616327280000	orphaned
2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	1406	1393	20	1	2851	jwfVSkQYDkiFeyXewErEND7PYxpbdg9UMVriSWGjq1AreNJaxVT	1523	2157	2157	1616327460000	canonical
2927	3NL3ZLA9UskrxxWyVAmoqVmw2nNFQYL9UnRC3p1riu2SP73dJfJL	2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	1670	1156	20	1	2852	jxohhac2Wa4nMtm2JwFbmA8RtZ8LCrmQDakLdLmrRYFDAvHWzWk	1523	2157	2157	1616327460000	orphaned
2930	3NLFKkckVgpBnbZRkDjeyPzr5aRTGEDbMognZjJaBpGGXd1Yv3HF	2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	1599	1161	20	1	2855	jwvCz7jCo7Psh6QggTNtzrJBei9rw465WE3TxPxpX1vKcRD9CtR	1524	2158	2158	1616327640000	canonical
2929	3NL3XszddgE1Hx7uTvNSLA82sZeDekSfCeaSbQaHQ8gZFdQFZkjX	2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	1579	1389	20	1	2854	jxh1XHRg6tqQQhEnUBhpPoDjCMd2TMtMBnvVNcJnPZYiZhKcrKS	1524	2158	2158	1616327640000	orphaned
2931	3NKJTNuUoz5y8TAHWhVMrQCyneiak9j7ff8RPRSSBsCNiLZhaErJ	2926	3NKjz1GmZQ18NvfbQ14hPy2LHouXt7xNZ2X3SZDJS1NuyHvj9vvn	1631	794	20	1	2856	jxVRZB6AMpTnJNNBRu2xE1ZBHaenR9CJW1jSS4ZmrZHJtJXpcLi	1524	2158	2158	1616327640000	orphaned
2932	3NK7VpNsMv8fbBcDu4ZXjGZhVzD8eSF4R5UpiK3HUaB4vrFSKeo6	2930	3NLFKkckVgpBnbZRkDjeyPzr5aRTGEDbMognZjJaBpGGXd1Yv3HF	1553	776	20	1	2857	jwZQu77tpTXhrJ279U7Z3oYBzn1WKX3ik1dXo9qFVS35LXwjVTK	1525	2160	2160	1616328000000	canonical
2933	3NLCq4GxFg5yqFuG3S5iojj9UouWTXqEj3z1ujXmPhYuCQH7KCPT	2932	3NK7VpNsMv8fbBcDu4ZXjGZhVzD8eSF4R5UpiK3HUaB4vrFSKeo6	1406	1393	20	1	2858	jx5EGzDASaAN175ahb35YRkuJMTU579U1tYrTCZxx7272wf6QNv	1526	2161	2161	1616328180000	canonical
2934	3NLfwzSrv6sq6NwfAgvBg31x3RTCktPaYh7PEURw6oyunuQkkerz	2932	3NK7VpNsMv8fbBcDu4ZXjGZhVzD8eSF4R5UpiK3HUaB4vrFSKeo6	1637	816	20	1	2859	jwdNVJ4eFDnu8SFJntyGfZ7LqddhrMSj9NTbzEMZY4pfexuTZDq	1526	2161	2161	1616328180000	orphaned
2935	3NLV1ZKiWA3F8D8Gxx4NZNq25BxToB86z6KDcKdG6GkRvw12ZKnv	2933	3NLCq4GxFg5yqFuG3S5iojj9UouWTXqEj3z1ujXmPhYuCQH7KCPT	470	1063	20	1	2860	jwQAhE2k2iLKKWFLRV9dczTQ54399DnLqRinLFTZk6p7cc4Qt3D	1527	2162	2162	1616328360000	canonical
2936	3NKp9pboikLJ56Z2kBAyMzghADvhhd2dsYnhSGTavwoGhDtVFpSC	2935	3NLV1ZKiWA3F8D8Gxx4NZNq25BxToB86z6KDcKdG6GkRvw12ZKnv	1422	971	20	1	2861	jwDBUPz6jQgrTxP9cvMWEYjRrTQBwjdCo5yQz2cummSrS9SDXPW	1528	2163	2163	1616328540000	canonical
2941	3NL8P9518VWPjExeCMacbLiJXuYxCXGXBfSz1nQLmUPLCqQde2oD	2936	3NKp9pboikLJ56Z2kBAyMzghADvhhd2dsYnhSGTavwoGhDtVFpSC	1577	1327	20	1	2866	jxcLiJio3gjovktBawPnDsf6udCx55MjruYtNP6yMDqv2N9Xoit	1529	2164	2164	1616328720000	canonical
2942	3NKHX5L6T2348RR1QJJjrLdqe4JEfBQwfRxmajqiM2QpzDLyzrh8	2936	3NKp9pboikLJ56Z2kBAyMzghADvhhd2dsYnhSGTavwoGhDtVFpSC	1577	1327	20	1	2866	jwuM35D8VnCJgpz1PhEUuMWbZ6FjaNfNQZwSftFHAcKLN9NwniT	1529	2164	2164	1616328720000	orphaned
2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	2941	3NL8P9518VWPjExeCMacbLiJXuYxCXGXBfSz1nQLmUPLCqQde2oD	1668	1370	20	1	2867	jxAjmFR2yfit98nq9naiKDoz5t4fti3hKir2sT8WNKLbN9fjHHZ	1530	2165	2165	1616328900000	canonical
2944	3NL2qWbwUwDFVMyJtcC3sfn9mhMix5grF71Vmo7CDYDRk6gf22Ro	2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	1406	1393	20	1	2868	jw7qD7UovNEJzA9zAwTZZCFspwaL8BHrCE8chtwpRkjRA3LnFLc	1531	2166	2166	1616329080000	orphaned
8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1509	1194	97	1	6301	jxFrVjcotuHLnC5W8Kiawre6FPc29KRRjDygQybSsV9WYKqh3He	4273	6027	6027	1617024060000	canonical
3004	3NKh73y9jsHgBjqxUrcE7dd8eDjB9PJsBxGuhmHJJ4U8cRMGTYg8	2575	3NKUTeL5sUyoWMWjadUNqreHEfsVeEJAeMGAUd3NqfvQYDpfVXcp	633	1138	15	1	2928	jxdHhm1nzUukHUHQm2LXcQn8tFKJW7cSHWyxGm1EtFAYacmDSCx	1359	2209	2209	1616336820000	orphaned
2951	3NKki19KLbqwvyCKWwiu7d5HSbWVmSYZkDpzq5kk8RRkn1mktHB4	2941	3NL8P9518VWPjExeCMacbLiJXuYxCXGXBfSz1nQLmUPLCqQde2oD	1611	1215	20	1	2875	jwAJNVJFS24D8fAJzAeWauxxiUoCAeMmeqNVmAC18ZBf3SzVhYP	1530	2174	2174	1616330520000	orphaned
2946	3NKzVj7cmpAwSBkAzkL7iRLdRWRijNRd6UXCRzMQaXsj4Ne9J1DU	2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	1637	816	20	1	2870	jxDnbTmX3anoPBLrmkbjeL7gcez8iopzUh2qnJxKXVu1HL22o7z	1531	2166	2166	1616329080000	canonical
2945	3NKrRAyEt27yChHeKaQ3LNTVLaLmqUEDKCuC7xJ3y9cQv4DFgBZC	2943	3NKQPeZhMLc1B648CP5GdoGDHjZKCCejq77MEzT1PZUcchmYX8bj	1627	1385	20	1	2869	jy3J15eR7qokRyx4tPNLjrzHb1uzKwdMLf2LZVze8daGR8MjjcC	1531	2166	2166	1616329080000	orphaned
2948	3NKGXCVcoQgoPW1napsYGdbiEzkskq7t3pYVevPzZGXJ5wbzjcGf	2947	3NKBv8iGwee5PaA1b4Y29Ujxk3J6HuX9JW3dnaiuRqf8wiFZDNXA	1462	471	20	1	2872	jxsPyHcrUmQf2pv8sgzJ2hyytU8EQLW4CoicNQhzdyGxEik78hq	1533	2168	2168	1616329440000	orphaned
2950	3NLdKLRVTLHgyPmib5m7kTTQwS3aWXqHUwDpQ5wfvcM1M3dAtvCP	2949	3NLtDyHRtDh8LmQbG8LBFWr5ot4D5td46yYZBoNNbrXF7CsojHdB	1631	794	20	1	2874	jwiZ8cgBbRT9bL7tmX4qA6AxyjdMxiy68bvbVncehKaSJbQQ826	1534	2172	2172	1616330160000	canonical
2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	2952	3NKZnpuzvPAGnQDXFijDaF4ttHYEqCnzUtwEjFhJejkBd1au8ND6	1553	776	20	1	2877	jwBGt51387Mt2ySYFxCMnfRhJv18cZDRQo2RmXXAquhPVWC6tjN	1536	2177	2177	1616331060000	canonical
2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	311	1307	20	1	2880	jwSxP584Rhp67C9PwAEN9WAWDTLzTxFNRMnBPivcpzEQxrRFE7j	1537	2178	2178	1616331240000	canonical
2958	3NKX5wWMfXFajAQ2z3rw2WSN98tPNrjgKEtumyKVxEBqj2K54yhW	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	1560	1291	20	1	2882	jwekRGTYQA2dKbRCjFgua8FJCu5cWMvf7V2cJi8nGVtB3caTbHU	1538	2179	2179	1616331420000	canonical
2960	3NKa5AfCRors3DL1eR1oZGU9imCUaL2iZuny468MNcYYciCqDXib	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	470	1309	20	1	2884	jxoGJUEu4sox2jjaTR41KbW47oPiVNrdBpYVTG8PMRDtQX7sNFP	1538	2179	2179	1616331420000	orphaned
2964	3NKxhpiHcMCtXdpF7F9hSgsgvbskTZ8xJYCwW7LVmdvoFsYBo5PR	2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	1642	1121	20	1	2888	jxUt9tLCpCBAAgfExwKajxgTYU8UHnATVrRhUbpkkAWspLe7jgC	1540	2181	2181	1616331780000	orphaned
2967	3NLtzeCKURGtn8ecVkfSpVDxUMhur2ZAXiiE1RJ8Wd2hgSn1Knx7	2965	3NKc5t8N9HutkyJKFHoyRqvSP6QceLHBhYpKfKEy7CopoWw2skuf	596	940	20	1	2891	jwXff5U2K6Vqjk1ELmQbsUuBHadhYDY6WEmy1ueVQWQFN3gcNsE	1541	2182	2182	1616331960000	canonical
2970	3NK7hKMhaJc39SCpRKKYc8VP4qqG1xrS9QfkYRkZswGGs6vQYED4	2969	3NLsUvi7y6UwR3ncnYwwDVWyiQPuowjtpwQd36N7unTxqn51scE3	1407	1395	20	1	2894	jwoK1R9USDUgGP88FpJEZiEf2ZeEjKLa8vxy2hkNFfHFJ6RecTv	1544	2187	2187	1616332860000	canonical
2973	3NLnL6tmiCn5n9NFMSDfGcSrMV9ZQ7RBNPoXhReojw8hgdbmQZH6	2971	3NKLNgRw9hEWnvBpgcktPSRY3349cdWBWLFzGhLHtoDou9dsqsMM	470	1063	20	1	2897	jwBtumb6SSPibi8qcP5cAwkfaRQVgfdeQ3mzefo7MhqdHZhra6U	1546	2191	2191	1616333580000	canonical
2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	2975	3NLYcKgLM3jZmYMrMZfdWG5m5mqY6DodhFTaHDYDfnUm3Y1Dt3pf	1585	1366	20	1	2900	jwbQtHLF4qmN8JhyrGaSfu9k9j6PxnFzoekLNPzuYx4fqseYSN4	1548	2194	2194	1616334120000	canonical
2983	3NKePayuKTx3DXFU6fJagTFNvDj3M3LQx6BcEJqyvqzbJcGJFATf	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1407	1395	20	1	2907	jxk6QmL11dUwQJSfv8TcHn1ifvFyFXrXrKeqoFXEkjtA11xKYA3	1552	2198	2198	1616334840000	orphaned
2992	3NLMQSwiYHL19wLtxsLBQu9V2bEipgUq6iYjQspcyDCDNgs1xrLE	2990	3NLDdp2hoBXAigcWvXjofeyJKvGNHshrswXXVvcGnmw4A8rhi6PG	1407	1395	20	1	2916	jwzDtTsuD4wruSukJKfTeqPRifeoTcxzMNovRBNnjZJpmL8H9Tp	1555	2203	2203	1616335740000	canonical
2995	3NLWfK1qpX1sBXDRFPboe5EWiqGiD8Zm1NEuEu3HQWbQe1T5NJ6M	2994	3NLRmLqFTt5dN2tkW4trLUC6jkgdjvioDtGy9L2SFF9SLvVAEwXP	1474	1329	21	1	2919	jwbDNFGxTMWM7oyqwt6AT7UktkLnCEEYVi1qnqCSfTftpSAQfbf	1557	2206	2206	1616336280000	canonical
2998	3NL19Pzea9BkmMGaXcsUui31CRxcXZEzLuSr7vcRwVPYk2n2yseB	2996	3NKYnjgnSX2kNxCSuQhqQXs9LzrJMs29MfaPdJMPHMhTcxuzXVVK	1627	1139	21	1	2922	jx2VCrjTSTrm4FDC6NBDw9XHRFmxCeAHVrrva9x1Vdx1ehcJgQg	1558	2207	2207	1616336460000	orphaned
3001	3NLKhUbvF4aJZwNexEiSaUbeVXU7pe3EHVaWy8d4xWNstgzpmNMV	2999	3NKC6LWcLPpqCRjSXGt1gWd4YNQSEnXHgBHvQiv6ckz1Cn2Bjvn8	1559	456	21	1	2925	jxFz4Fdji3h6E6HPCD3DcyMb4zavY9SJnEapHWjvhAfqfdLkdEd	1559	2208	2208	1616336640000	canonical
3007	3NLwHuFD2xtfxwF7UAVz7okbAPtLPM9WG5hG5jepGYHAx6Fb6MsS	3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	1652	1315	21	1	2930	jwvT1MRja6RWkxfJjznnoXe5YKACgXB9YjdoTFzq3BQw8gnVUuV	1561	2210	2210	1616337000000	orphaned
3009	3NLNRG8E9CXiBPcWdztuv8mz7hwJeLKxvkqedorhfpfEkG5Efpce	3005	3NLTucBqRBmA5QTVpKYfqcAHTnMBgtqH83U6HscqV85uP4PouM2p	1407	1395	21	1	2932	jwZjGHzGTLMX3doJpLgEyXQZjktN97oQuzC5kmRHHtx6CKyrjaf	1562	2211	2211	1616337180000	canonical
3010	3NKghQLNCU3G56E3KHDhAUV9crbqaJ8tHiN1FYaYdHTdEs1SxcQj	3009	3NLNRG8E9CXiBPcWdztuv8mz7hwJeLKxvkqedorhfpfEkG5Efpce	1536	1313	21	1	2933	jwdEBu97KSJsJHgPisFeH41PnkewzxmY6DY5ibJJ6S8ZSU4XVfW	1563	2213	2213	1616337540000	canonical
3013	3NKgzy5Qaom9hwFMZPRFDUeoRYD6vZ9CsSSNoTG9g1G4zYtACz22	3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	1600	1246	21	1	2936	jwFUTn7HGPFfJLrLgtwEEmKwoamMoLRqHZtrN3HAtecCytB8M73	1565	2215	2215	1616337900000	orphaned
3016	3NKbNqe8oeaXN9MFPJf47XJF6WmWCFxe9qckg44DnDJgopaFhGrL	3015	3NKRz27BbCdnarB2w8P59LGPuSb1btJ3Qepxus3Yop4aqq7v2AZz	1455	1332	21	1	2939	jxuuzuprU6mgRA884B1boAM9Sav6YwWK5Ngup965xNSRhAo14NA	1566	2216	2216	1616338080000	canonical
3019	3NLdTACLLUhWh5HGSPYcPR3o5x28MnFev3iJ5oJFTPp2ezgnfCmr	3016	3NKbNqe8oeaXN9MFPJf47XJF6WmWCFxe9qckg44DnDJgopaFhGrL	1508	1141	21	1	2942	jwDsPLnwY1HXKeGz7VCAsddBzkGWjFDv89da7XKnn9rSzk95Loy	1567	2217	2217	1616338260000	orphaned
3022	3NL53RyKy8ZrrGpELjCR8xtqTveJCBoEKgHexx4bwQSesTNdHXm9	3021	3NKhiAJMTSSxtgLgqhVxc1QYuUyG12PULcCXV1v8paKikzoNcnnq	1656	1343	21	1	2945	jxsnqoVjBgKKDc5da5sS9kn2XbBNrmWDeUdZ8SUtQGJLnd1jc8L	1569	2219	2219	1616338620000	canonical
3028	3NKyTQmj5soejQioMSgVEJM21kVpDbtx5i4myFdAjCnFzis2UmR3	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1536	947	21	1	2951	jxbigWtEKWUCcxMbmQaodJhK95PFUnz3nkC3q8qB61si6mpGt7s	1572	2222	2222	1616339160000	canonical
3025	3NLpXtUQVuo7Y2oMHPh288N4KJMd2S3xm67KusDzAKkMFtMYqypy	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1447	1345	21	1	2948	jxrCnWcdLTCCyUcERMRQbtYjhPyWbkm4itEU51gQXThzPQcaNLU	1572	2222	2222	1616339160000	orphaned
8271	3NLBDo1fJUws5ArEHNEtrHCXhCKZjnu5V7EaizHTCN79wQC87GVy	8269	3NLs2L3RQLAimghqN63UTRWmMCtEXtwFXdb93CECWiKnnYnsgYd3	1631	794	97	1	6301	jwvjMGKieZDq8jTvWsj1vTedfNm9MmsXETH2mLKcK3vAEUWqYDE	4283	6044	6044	1617027120000	canonical
2949	3NLtDyHRtDh8LmQbG8LBFWr5ot4D5td46yYZBoNNbrXF7CsojHdB	2947	3NKBv8iGwee5PaA1b4Y29Ujxk3J6HuX9JW3dnaiuRqf8wiFZDNXA	1637	816	20	1	2873	jwcNyRccrp5agW6iZfitsEW6LBH9gFXrDiFg3hzvAWfuTuP52J1	1533	2168	2168	1616329440000	canonical
2952	3NKZnpuzvPAGnQDXFijDaF4ttHYEqCnzUtwEjFhJejkBd1au8ND6	2950	3NLdKLRVTLHgyPmib5m7kTTQwS3aWXqHUwDpQ5wfvcM1M3dAtvCP	1407	1395	20	1	2876	jwZ6syKs9h3MdzN461Xv58qe3EzMv42UTAJiZaUfkaJLbwHcn1A	1535	2176	2176	1616330880000	canonical
2959	3NKrXK1dfugCFcYyqWbaEqazJ5n9MemVFxWraRELeAnR4DsmWq1q	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	1600	1372	20	1	2883	jxfdBLuYWWGGA5SLCavfUVBPJ45k5fLUEJcxtAtXnXXax1SjGoE	1538	2179	2179	1616331420000	orphaned
2963	3NLFDzd38okVvtiV9dsxQWUgucQHPw83mTe7iZg53Bv3fpNQX8Ku	2958	3NKX5wWMfXFajAQ2z3rw2WSN98tPNrjgKEtumyKVxEBqj2K54yhW	415	415	20	1	2887	jwsJzQ5Pth4oLdXXD9MJJbZ46h9PrZ5T8xNPcin9Xrjbrn7vHYv	1539	2180	2180	1616331600000	orphaned
2966	3NKbmMNPzq1imkaE1aFppXWiGKYFsGJX6bAJRPBe7VAoNJusjgMs	2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	1448	945	20	1	2890	jwZ2UuydvuL3zjPzXuViMKfQhv8WSLUEfV2HEZhWa5KhR6WbHWg	1540	2181	2181	1616331780000	orphaned
2969	3NLsUvi7y6UwR3ncnYwwDVWyiQPuowjtpwQd36N7unTxqn51scE3	2968	3NLFjQ3vKThT7s9U3HdT8HtpPCysj9NQrDRUV6uAn1TCXwdDHcEs	1613	1223	20	1	2893	jwTEHYkjFYEe7pbF4kzL9uWTyRUCWeGTbG8KMHTahYCUiKgEUG4	1543	2186	2186	1616332680000	canonical
2972	3NLBQdKt7V66mdVDN7zkM461eoig4YChexZm3SuWuxkeMdvu6iB7	2970	3NK7hKMhaJc39SCpRKKYc8VP4qqG1xrS9QfkYRkZswGGs6vQYED4	1448	1311	20	1	2896	jxovx2AFWp6i4f8yopAjfn7JqDo2gj8Fktti1ajsp9UqzrNPrRb	1545	2190	2190	1616333400000	orphaned
2975	3NLYcKgLM3jZmYMrMZfdWG5m5mqY6DodhFTaHDYDfnUm3Y1Dt3pf	2973	3NLnL6tmiCn5n9NFMSDfGcSrMV9ZQ7RBNPoXhReojw8hgdbmQZH6	1483	569	20	1	2899	jwkLkjdCLLi6D3qDNW9ouad5cF97jXzut7MzCpuLQwE5tD34fZ7	1547	2193	2193	1616333940000	canonical
2979	3NKeGcB8HNzhdoABTBRXM5NLZGzHPPVmtrB6xigUxvk3nPWm6t4k	2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	484	1073	20	1	2903	jwnXY4tnKZkDSnypHJWTLoEitnD2659rJwfJizxG2hpVcvma4Cn	1549	2195	2195	1616334300000	orphaned
2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	2981	3NLZMneZfXNBtC4jPfn1norm8zsPykbjpYnkPugK1bLe46nXCsUL	1631	794	20	1	2906	jwSSFDwUHZRshUuENz5RCV29d6R4QCe26fJsLhNo9SiTR4Z7cYh	1551	2197	2197	1616334660000	canonical
2985	3NLV8SaQcNJkvkEX4U9sHrifdK2i7ky4KG56p1srNKSL5jrGYdyA	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1559	1353	20	1	2909	jwDJgH9KnWhNnVtQiooYv3VVLk1wiCx3CK4yHEWY2uQsK1Wcoqe	1552	2198	2198	1616334840000	orphaned
2988	3NLuF2eeoWDBfmdGNmCMgKJh3Gu9S5pNCuixyD5m6qaz4AjALWax	2984	3NLBjhtH3i6xmheuhd97dvvdkr8HW4eKPbKU4DHSRVy5AsohhP7b	1599	1041	20	1	2912	jwPHrfNZwDgSpAv2kqtzWMrcvevhTvDNFapHxu3aFTP9X7SmD9u	1553	2199	2199	1616335020000	orphaned
2991	3NLYJHuFgYuemQ1QKzDDwVZfMd32vKD7bymvwYTFiXJUwbTFx17R	2987	3NKzpQFrS6MAp8bvQWVgaWbgk1sBTDqQHqnc7Kj4pbS5x4ZsTAnq	1590	1054	20	1	2915	jxCmA5HcEuy6D59zD8H1DGritCHNcA1kLaFLjnXRyNSzewq6yAt	1554	2202	2202	1616335560000	orphaned
2994	3NLRmLqFTt5dN2tkW4trLUC6jkgdjvioDtGy9L2SFF9SLvVAEwXP	2992	3NLMQSwiYHL19wLtxsLBQu9V2bEipgUq6iYjQspcyDCDNgs1xrLE	1668	1244	21	1	2918	jxn41hsoC27hf1jhws7BAv2nkPWtsR9T8ADrinbbJruoYaTCE3W	1556	2204	2204	1616335920000	canonical
2997	3NKo7CiUyKmJAYJzaUxrWEsKdnB7kBnH4VKRbzaw5KV2NYsWxpM5	2996	3NKYnjgnSX2kNxCSuQhqQXs9LzrJMs29MfaPdJMPHMhTcxuzXVVK	1407	1395	21	1	2921	jxhC2hZVc4VQZTQ9khnrHKf93z5BDr9B2FU5h7i6Pxt69DrdFhL	1558	2207	2207	1616336460000	orphaned
3000	3NKiuXtAzi1166JjkZ1X4bmLUyMm9Nuxv1WGpaQgZDGFjoETPMCB	2999	3NKC6LWcLPpqCRjSXGt1gWd4YNQSEnXHgBHvQiv6ckz1Cn2Bjvn8	1622	1356	21	1	2924	jwLhNufHPh59JZ2wCGMSa7HawUjdvxqJHekap6gJc22BJcEM7DY	1559	2208	2208	1616336640000	orphaned
3003	3NLTsYoDNjxskKfaWvG89HCrsjdn3umq3Z6TCtuP9vZS1nbXDP9A	3001	3NLKhUbvF4aJZwNexEiSaUbeVXU7pe3EHVaWy8d4xWNstgzpmNMV	633	1138	21	1	2927	jwGUyPWAhRvGu8NdPRpcbfRUhceLNEsHr2oSJ41Gdu18ue4W7WC	1560	2209	2209	1616336820000	orphaned
3006	3NLghWcS4HrguAWso9EJP3qofKZAMUhZGYfHnivGAkV2hahry78Q	3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	1652	1315	21	1	2930	jwxcQpaVuURr55VnVyQ9iPEsXJ3ku7hUA7CyyhW6xLzvaaGZiHd	1561	2210	2210	1616337000000	orphaned
3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	3010	3NKghQLNCU3G56E3KHDhAUV9crbqaJ8tHiN1FYaYdHTdEs1SxcQj	1581	778	21	1	2935	jxw3LqRgruk6maKij6c9edRahMNMQ1gFZnSQZ3hxrYQtXf1up2X	1564	2214	2214	1616337720000	canonical
3015	3NKRz27BbCdnarB2w8P59LGPuSb1btJ3Qepxus3Yop4aqq7v2AZz	3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	1648	1284	21	1	2938	jwT5dvhNVM63wQSMrmy8oSepCKp8SzkrFHkWx521JXkDG7uxw9V	1565	2215	2215	1616337900000	canonical
3017	3NKHfgjMFsK1r3LrPopMYeL5F517wkaRyvz5p4W4MrysTKdJrSZC	3015	3NKRz27BbCdnarB2w8P59LGPuSb1btJ3Qepxus3Yop4aqq7v2AZz	1419	814	21	1	2940	jwhqiFqNGML8nQ1hitqK6z5oVnd74uAjSjzG7fRCzqpU6Cd7rcw	1566	2216	2216	1616338080000	orphaned
3018	3NKg1MjBt5jNkSHyxvvEaU47udtRjUEKG17gbsMBsnAFNVHNp1qe	3016	3NKbNqe8oeaXN9MFPJf47XJF6WmWCFxe9qckg44DnDJgopaFhGrL	1579	1143	21	1	2941	jwmTpEQdbhzUBBatg68T5vPMgjXaP6L5AAunXMYyYduHvsDzBEC	1567	2217	2217	1616338260000	canonical
3021	3NKhiAJMTSSxtgLgqhVxc1QYuUyG12PULcCXV1v8paKikzoNcnnq	3018	3NKg1MjBt5jNkSHyxvvEaU47udtRjUEKG17gbsMBsnAFNVHNp1qe	1670	1036	21	1	2944	jwJt7LhhZZYEX4Zz3Bnp9Gh5CqWuEdYQQAaNBhtt13DkchRbxnT	1568	2218	2218	1616338440000	canonical
3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	3023	3NLn2Y5b135LF94a9t4jov8xVaTwuQS8MzGhvCPRCbVKQXkrxoUc	1503	1277	21	1	2947	jxpXxkULPuvM6RoPZQW1yG3HHxxrKV1yC2j2aK7U6gsDUvgSrP9	1571	2221	2221	1616338980000	canonical
3026	3NLmq8ukdXDKGjmpnQDBwTcWoCup3sSXJMpfZHUpxNy4j4giuSmR	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1406	1393	21	1	2949	jxpW1fEmYL4VKdra75zqNzis3DRaFDYXqJHcHtudVPLH65qgM4b	1572	2222	2222	1616339160000	orphaned
3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	3029	3NKdh3pRY5Kqj4RoUm2dfuMxqsfw93bsneRLnWmcKveq7ytDHDTZ	1617	1288	21	1	2953	jxZBaRMef3pUepfYa76UTUk4ixjDSfNLoVKcyAZDdthb2e2251y	1574	2224	2224	1616339520000	canonical
3033	3NKeTMP54cnoNbvxLVz2mUgPeEoMKhP3xUcvKPicArmshGY3PcBG	3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	1652	1069	21	1	2954	jxSH6fcQ1Qw381Kxa7K3AQQp55Rh9MT4kLWi549cS8ZXAbEhEFQ	1575	2225	2225	1616339700000	orphaned
3036	3NKB6PwGQPbFNqJgvgC5Q6yp5tKbvZjwTxtsT8zt4wL7LoTcHC6j	3035	3NLQ3KSRdmWjS9k1ZGTrC6vntnSgbru48z5LsyC44ZW7PsXKTLvY	1536	1313	21	1	2958	jxKJZ4L16MsNm8UZSPthe1wqNnbChMHfUDsVwpxtdNX6SziEXLS	1577	2228	2228	1616340240000	canonical
3039	3NLLzGWXWiHNa4f9wCyUb67bq436gMPrfPJ4KamdjxHSnwL92wBf	3038	3NLCXdcjXtKkrjgXKVnHvDDkTwkLQdv3RZjbrXDZbyisRpYMmzTS	1675	1216	21	1	2961	jwMMaMUMQyxRDwK1SNYAVJYLfra8cfiY3M3QBCW9KgiGJevi7z5	1579	2230	2230	1616340600000	orphaned
8280	3NL2A9m1zLsTVUtMbCNp6cy3rGb3xTtrkRhybhET5voQyNEHFXaG	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1637	816	97	1	6301	jwhnZieA1Y3jTWsE7CrKrexjKLqw8pTjvhbNdGu4AjkQ41svyj2	4288	6052	6052	1617028560000	canonical
3041	3NLp8Mf8rrNfzqYpQgyYuguio37sY7wtdar51vcBmsr2FZ3obUD7	2851	3NLM33utr6E18BCza1WBp5qoD3sV9QUeAANnL3nRQjH81hr166kt	641	1336	14	1	2963	jxEDopy8qr4TfCvfdrgWnhQ42Sq3viGxSWTdjmCA5hKPj28nHmZ	1303	2232	2232	1616340960000	orphaned
2957	3NLPEwo3hkfkKNUMVapZ2MkYuuC1zFrXJ26rG3uvUzoGGQmRA5et	2862	3NKdmUZ9T1eEAQDz8ZbVPixdUvvww9MKyQtoNz7Qgr9wRbmD5Bz7	1513	1133	16	1	2881	jwFomTwsXqG1cJamGGd8u43SgT1e1qzYx7UN1GkiiyMF52fWdqq	1406	2178	2178	1616331240000	orphaned
2954	3NKc7hGyJ7o292mGUkjVKBFE8qJCGs48P17uCyb7JeitKGDRoVrL	2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	1593	1100	20	1	2878	jwdkEN6LEixTFHnpL3mGUV4djJa5UbgecsWNN7iswqx6zmbkg7Q	1537	2178	2178	1616331240000	orphaned
2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	2958	3NKX5wWMfXFajAQ2z3rw2WSN98tPNrjgKEtumyKVxEBqj2K54yhW	1607	982	20	1	2886	jwZkz4C4PsLFELMHXy2wyX45wzCLyfitzyd2U92MSxuuZZnkJ6F	1539	2180	2180	1616331600000	canonical
2965	3NKc5t8N9HutkyJKFHoyRqvSP6QceLHBhYpKfKEy7CopoWw2skuf	2962	3NKRhHvRxQrkrKLDE4sDvgqzckY5S8mGBfiGdHVMMAbfhq7p5Nia	1506	598	20	1	2889	jxKNFzw3ANnegrpRrXB1vqmEJhHBUSzpCNS2gpmJxEPTi6PMN5s	1540	2181	2181	1616331780000	canonical
2968	3NLFjQ3vKThT7s9U3HdT8HtpPCysj9NQrDRUV6uAn1TCXwdDHcEs	2967	3NLtzeCKURGtn8ecVkfSpVDxUMhur2ZAXiiE1RJ8Wd2hgSn1Knx7	1407	1395	20	1	2892	jxvbZJDKRLZE8JTvmXpB4kUMUYFzMyyPWNPxfXukF9GwkkMYEkA	1542	2183	2183	1616332140000	canonical
2971	3NKLNgRw9hEWnvBpgcktPSRY3349cdWBWLFzGhLHtoDou9dsqsMM	2970	3NK7hKMhaJc39SCpRKKYc8VP4qqG1xrS9QfkYRkZswGGs6vQYED4	1407	1395	20	1	2895	jwGhFmqjL4BAyJiivoZjxEWniMnR95umqvATRawArJ5A4wjD9Uu	1545	2190	2190	1616333400000	canonical
2974	3NL3gABD3AP4BxqWHiwcnhVn5VGHUPGccznamGUi41aypH4f9siQ	2971	3NKLNgRw9hEWnvBpgcktPSRY3349cdWBWLFzGhLHtoDou9dsqsMM	1555	1101	20	1	2898	jwGDCDdqRjmid9dwSW99vT41PRzJPCKCD6DgQGfBt8BK1AUo6Mk	1546	2191	2191	1616333580000	orphaned
2978	3NLLqMqv2r5o93VpkHGcKMHjnKADRsyPzCT8QZ2vsaByNJbPAh78	2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	1607	982	20	1	2902	jxhNF3ohyW962LGiJ81HGENii5bQpxhrP1725tQe76QpTdd5Lqt	1549	2195	2195	1616334300000	orphaned
2981	3NLZMneZfXNBtC4jPfn1norm8zsPykbjpYnkPugK1bLe46nXCsUL	2980	3NLJeUk2tBmBu8zWcxSnxZbeTWnowH4k8iUzFZazUhPCPyxNoR34	1483	593	20	1	2905	jwcPAmVYrv5m8TCLqRPj1uuaYpc5GaLrHhhD4XGuSZA4pAY6akB	1550	2196	2196	1616334480000	canonical
2984	3NLBjhtH3i6xmheuhd97dvvdkr8HW4eKPbKU4DHSRVy5AsohhP7b	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1501	1114	20	1	2908	jwmeM3nSpJPqgB9iT5ob2n3AzNTM8g2q7drav2XJ46gxH3jM6LF	1552	2198	2198	1616334840000	canonical
3046	3NK8TzRQbaDZZfNhpnSGYiiMJkcWqrZemAxCTxvMCXMEqPJ34RU7	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1651	1055	20	1	2968	jxfG1xKkwwHxG73UTdULdmYXafXaD2SrGbp5JTJw1JJUmRKcthN	1552	2235	2235	1616341500000	orphaned
2987	3NKzpQFrS6MAp8bvQWVgaWbgk1sBTDqQHqnc7Kj4pbS5x4ZsTAnq	2984	3NLBjhtH3i6xmheuhd97dvvdkr8HW4eKPbKU4DHSRVy5AsohhP7b	1406	1393	20	1	2911	jwWGFnWDRQAB5DZRb1zRdeZSRe2vtE7N55tfsmue6KFFDs1mgYd	1553	2199	2199	1616335020000	canonical
2990	3NLDdp2hoBXAigcWvXjofeyJKvGNHshrswXXVvcGnmw4A8rhi6PG	2987	3NKzpQFrS6MAp8bvQWVgaWbgk1sBTDqQHqnc7Kj4pbS5x4ZsTAnq	1656	1343	20	1	2914	jwqSpHSSkWkAN9W1Mv4KYbKucEeENunp8DnUGgaXDyDnjZB8amW	1554	2202	2202	1616335560000	canonical
2993	3NKotHFCj5DF9rAkAcUod6prdxtXThVbZkjzj7Zg9WJzaMtqayUE	2990	3NLDdp2hoBXAigcWvXjofeyJKvGNHshrswXXVvcGnmw4A8rhi6PG	1634	965	21	1	2917	jwQB7TFvEaF1duwPyjT4vytbigRWkewsyfXFyoKGgxQKUdgYQbs	1555	2203	2203	1616335740000	orphaned
2996	3NKYnjgnSX2kNxCSuQhqQXs9LzrJMs29MfaPdJMPHMhTcxuzXVVK	2994	3NLRmLqFTt5dN2tkW4trLUC6jkgdjvioDtGy9L2SFF9SLvVAEwXP	1590	934	21	1	2920	jx49a9oNXd5wN36212XHUVTQ9r1TWCyWnipGncz6cXiEnrpRrok	1557	2206	2206	1616336280000	orphaned
2999	3NKC6LWcLPpqCRjSXGt1gWd4YNQSEnXHgBHvQiv6ckz1Cn2Bjvn8	2995	3NLWfK1qpX1sBXDRFPboe5EWiqGiD8Zm1NEuEu3HQWbQe1T5NJ6M	1646	1228	21	1	2923	jxL4SUhbCLzVWrkZLuut3JaopdktzoRJcb75jMmcTrXn2gdHSNr	1558	2207	2207	1616336460000	canonical
3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	3001	3NLKhUbvF4aJZwNexEiSaUbeVXU7pe3EHVaWy8d4xWNstgzpmNMV	1407	1395	21	1	2926	jxGyaBhpMDjUnjbVbA1nHpquT53P1ogL4Sai2b3PAEMcVBADiC3	1560	2209	2209	1616336820000	canonical
3005	3NLTucBqRBmA5QTVpKYfqcAHTnMBgtqH83U6HscqV85uP4PouM2p	3002	3NKrxbKvnLeiJak4KzJsw2oJFCAR2jUz6z9teXko5L38QHAPr4nz	1406	1393	21	1	2929	jy2FQmmiD4MmWjSuJUFKzME1Kh2NUXxJCs2MpLSxaDeGHJPHHkZ	1561	2210	2210	1616337000000	canonical
3008	3NLu3jA5NHySVxHfNAKnujvSNSCLUDqKVggdtFqaXtAk2uUXGUtp	3005	3NLTucBqRBmA5QTVpKYfqcAHTnMBgtqH83U6HscqV85uP4PouM2p	1509	1320	21	1	2931	jwsjRxGFW8gUy3FMkaiW1UCvCGHoAszbczZaHfjQcN75mxNFGr2	1562	2211	2211	1616337180000	orphaned
3011	3NL8PQrzqbBCRcy9dKW7NdE6s6VWGw1yshuBtJVM7geDcDXNKqnn	3010	3NKghQLNCU3G56E3KHDhAUV9crbqaJ8tHiN1FYaYdHTdEs1SxcQj	1402	796	21	1	2934	jxiqJuHoaB1mzzX5uDcc3ZXKBZB5hepXTmTkgkMESw7CVXYFo5L	1564	2214	2214	1616337720000	orphaned
3014	3NKQt7XP7tQNGkBASATmzSuohvUeGeoitEK3ptwUv6d62F6yc2Sy	3012	3NL3Jk1CgfAJoPUvZSwunsQudDPpSVdsABEHfxsZpH5QnHpfTu8c	1623	839	21	1	2937	jwjaCrik5UjLhBnWdcu9eMf4hjiYmUtSYyLjA8Vwxrmpni1u6KZ	1565	2215	2215	1616337900000	orphaned
3020	3NLnWvZLbann98z4aL69sn2Y9MF4haLiJW99hWth197Uir8dZCCa	3018	3NKg1MjBt5jNkSHyxvvEaU47udtRjUEKG17gbsMBsnAFNVHNp1qe	1407	1395	21	1	2943	jwpERofssmZpxA4QfydP7QfPk533q23vYTWL12bJUtxT6CKrk6e	1568	2218	2218	1616338440000	orphaned
3023	3NLn2Y5b135LF94a9t4jov8xVaTwuQS8MzGhvCPRCbVKQXkrxoUc	3022	3NL53RyKy8ZrrGpELjCR8xtqTveJCBoEKgHexx4bwQSesTNdHXm9	1609	967	21	1	2946	jxbyS1NiV4jQqP3SMamXofR2dW6gDdiZeU3TkfU5fPyQHHLWwbx	1570	2220	2220	1616338800000	canonical
3029	3NKdh3pRY5Kqj4RoUm2dfuMxqsfw93bsneRLnWmcKveq7ytDHDTZ	3028	3NKyTQmj5soejQioMSgVEJM21kVpDbtx5i4myFdAjCnFzis2UmR3	1406	1393	21	1	2952	jw73Mt8wwHXZtxrxrFHU1bsb6SS5PCfbdQtJVrLsC9znfvtnAb1	1573	2223	2223	1616339340000	canonical
3032	3NLZqCX2b3ATY67fs2ABntpJcnNJpfFNaqHwuhT2pFzDnzFxDBK7	3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	1599	921	21	1	2955	jxZPvmZetwr3zmo7ssw5UQSi5hrVkHHADQWz3XsXD4WsJ2YD43m	1575	2225	2225	1616339700000	canonical
3035	3NLQ3KSRdmWjS9k1ZGTrC6vntnSgbru48z5LsyC44ZW7PsXKTLvY	3032	3NLZqCX2b3ATY67fs2ABntpJcnNJpfFNaqHwuhT2pFzDnzFxDBK7	1637	816	21	1	2957	jx9YBvUeuqq38bhVHjQDcU8aWDdAc91addm3qLYDHjeGKbign4G	1576	2226	2226	1616339880000	canonical
3038	3NLCXdcjXtKkrjgXKVnHvDDkTwkLQdv3RZjbrXDZbyisRpYMmzTS	3036	3NKB6PwGQPbFNqJgvgC5Q6yp5tKbvZjwTxtsT8zt4wL7LoTcHC6j	1549	1116	21	1	2960	jxE9jAoCsDmGgGncTFduYrCyptP99P5Dj45gQMgNSs6HtnL2X1x	1578	2229	2229	1616340420000	canonical
3043	3NKjE8KcsbNgiiJBL6VhxUFT6emx6odeT3gsn7efMQjyF4TzXWV4	3042	3NKv5D972kMmaN8CVdioAWMSeEFDeV4ZakTVR5c3dZnBYbXMSTyj	1447	979	21	1	2965	jxeBXFM4arvhQDF7Wz4T7TvPMWYf31AhTwTmdc2fD4dNy2VnorV	1581	2234	2234	1616341320000	orphaned
8284	3NKpFtW1wNTUUddqGro4oXg9cUKL9K6G33j1BX8aBLeomqvQWaQb	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1631	794	97	1	6301	jwtzMGv6Ugt7WEzp2Cbgamn2tiADCiHcZtyCaq4rmEr2CVtJ19g	4290	6054	6054	1617028920000	orphaned
8285	3NKt5Wimwka1AfAXnM5z1M4GcEZBR4ESeDjMEVgDL7kdnwxfC6FN	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1611	1215	97	1	6301	jwbPasSaakbseexTzCXe6hRKMC4VBH2LT5AzQWNsXBpAnMnSosQ	4290	6054	6054	1617028920000	orphaned
3057	3NK47hPXx3A3jt1PZZ8BvrNBNNVKVEqDQGvbnVYhChjZpzbCcMpz	2751	3NKawwNB98iLTxKRQE6wmQXAPCEaphoqgkVvVvwD85dxwe3FFtFG	1403	824	17	1	2979	jxYrLgzxLRFy7q7Lk2fRnLZHu6UHvF5YtdYbeXxpA5Nv7vHC18A	1442	2247	2247	1616343695414	orphaned
3060	3NLnEhHpFXQz9WmNmFAEqUKqhPXHH2PnDa3Ki2U9Byg5eRkLQVri	2806	3NK7drEJd7up8fbY4g5zjQ3ayvHz6caAerXSNep1N88YstUyWQLr	1403	824	18	1	2982	jxWoNJaMC3MFh3LpipxTzUyAPbDRkLkFZ4dWkAzQd8nKDrJuENK	1467	2247	2247	1616343758005	orphaned
3084	3NLhkUtqQKGdvxKyS129RyByxZwQ8rQdVyqAhbgFAuNZ9qtVsPRZ	3046	3NK8TzRQbaDZZfNhpnSGYiiMJkcWqrZemAxCTxvMCXMEqPJ34RU7	1651	1055	21	1	3006	jwCqDeBry8KEDvTeH25T3B2dnPr3Wam8aiWtdqtJiSK2A4FFj9u	1553	2259	2259	1616345820000	orphaned
3031	3NL6jrES1qxMg7gyoEH51KKtq4kiv7cRh2oJyj4GVWWWctYEGtSv	3030	3NLBmYGCFDe1AXfDNScZrqQEuUZtVBVTxhPZWv6XRdh9kqbkMjFK	1652	1069	21	1	2954	jwcTHghaZVXDoFM8RoDeDFewR1QNsxpULXxd7T2qPGfr2ms2A2U	1575	2225	2225	1616339700000	orphaned
3034	3NLdpSLy89HW4kU2ZPTd96Tx1VxzwbXhFWATCgfQ7WWoU4zxWqPu	3032	3NLZqCX2b3ATY67fs2ABntpJcnNJpfFNaqHwuhT2pFzDnzFxDBK7	1474	1329	21	1	2956	jwjo1wztoGMJoBfZjkfrTxnwkEs3hQCavNuCrqxMQsPF56FbFV5	1576	2226	2226	1616339880000	orphaned
3037	3NL93eFVoeKoa6GbCDwNFCPibfernMYNkfaeHsFmPS2uwuhRpAmn	3036	3NKB6PwGQPbFNqJgvgC5Q6yp5tKbvZjwTxtsT8zt4wL7LoTcHC6j	1460	293	21	1	2959	jy12WQ46Ehys2CWPfb5irbBkxXz7wZpKcXTJz5SxBzY3UN4HAtT	1578	2229	2229	1616340420000	orphaned
3040	3NKFC9kdmjajVXkb7xctVkyXDZfikU6LsN8xoVtNszo6FJbLHPwi	3038	3NLCXdcjXtKkrjgXKVnHvDDkTwkLQdv3RZjbrXDZbyisRpYMmzTS	1581	778	21	1	2962	jxJiM74fnhRnbCqiGvJVGHn5CCAuJvGWqXvf3W6rhtaNQtHnEAa	1579	2230	2230	1616340600000	canonical
3042	3NKv5D972kMmaN8CVdioAWMSeEFDeV4ZakTVR5c3dZnBYbXMSTyj	3040	3NKFC9kdmjajVXkb7xctVkyXDZfikU6LsN8xoVtNszo6FJbLHPwi	641	1336	21	1	2964	jwakrTJCo9JEcoCHPH6PKL1VSuaCFSYFzk3UWVRqdC6Jz2DFx8p	1580	2232	2232	1616340960000	canonical
3048	3NKpfevURHHYxPUiY5QSkLKdXUnq6pr3KuwRPJeiDXXqmjemjP3f	3045	3NK8oTAnof7rsAmRhEcC741DYxgcpKzm8Umhhq3afDxnbUYrbp23	1648	1038	21	1	2970	jx6D59Ek2uUEVrKo2NouxYuTc2ks1dRLpmkyciFiPDZCn2DNRVY	1583	2237	2237	1616341860000	orphaned
3051	3NLEPvXEJ3K2p2Qp4EZst8W8DmV4YAPhhsokHe3BgmqZmyrwcqkM	3050	3NL3rsR5J2Gs1STS9on3VjxwsP39i3yHX89dcUu1APrCvb46GM3j	1406	1393	21	1	2973	jxhhEpDuy3EGokxUKDd4pRgwMHLjmNNfvTUMEr8W3LSx1bhJ7rc	1586	2242	2242	1616342760000	canonical
3054	3NKvrqdAChGybeAb1xR36DciC3RPrM5dejXorBrP1m8Mnq9QkAtR	3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	1490	1028	21	1	2976	jxWjLAQwpg22wSqV4CUEACAB6xGM6Fj1VWHbq2YfnL1V9kBBiAk	1588	2245	2245	1616343300000	canonical
3063	3NKdqFLhxUmHJ8eL5JRJpmcUNYfitQHquWfPLhFsLSUY1NxMpR3T	3058	3NKdKLgxAz1Mvhx8pc1LMBxpfDFukSzcfTwTF36R1cd6mkHz85TX	1643	1173	21	1	2985	jwAq6kyHkvofzuYyPrsdj7P5vqx2amvne2guwfBWdj3dqZYF27d	1590	2248	2248	1616343840000	canonical
3069	3NLX2CcAGqjZmR2NjBVUWrGSdjSGXHGCqYyvQdUepCi5L3mtFFc8	3068	3NKh5tFLzGdk89JMd95LKRvVLYxPdWbrKRr5nyZStbgU746uVnxX	1403	824	21	1	2991	jwakXxiefL7kMYAdzoAKUk64KUKhtzJd3gSHEfSDsHqWGLeU1ww	1595	2254	2254	1616344920000	canonical
3072	3NKH3VcezeVBQD926US87PzgVTHeNyP5EdqHkh1sWAGqZUBDTVQJ	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	80	1273	22	1	2994	jxdVTKnFziCfKNqfB41vt5kR6qVh6YBoBJoucKMjsKYefXyPj92	1598	2257	2257	1616345460000	orphaned
3078	3NLmxAmo8c3aKfch7bu1esEbxrDE6vdTb5Y9vTf2CWCvqKeL5fac	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1471	1260	22	1	3000	jwJ7cv1Q8CDWxjQWm7B4MVco7s7K58yPEWojjkpcQr667AHJa6a	1600	2259	2259	1616345820000	orphaned
3080	3NKFz9A7DS4busd4RknaViXtD2naZyCZzAx8rNQ6SJW21GuoFuur	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1406	1393	22	1	3002	jxUBRf3D4Tsw9wqHUhkbzEw5jcLQTfHofjsvRzNPLmBWWShAn75	1600	2259	2259	1616345820000	orphaned
3081	3NLkWF3wUa56b7cnd34HVVrYFhh59t9nK1ak5ZY83S3B3ViTsf2C	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1651	1055	22	1	3003	jxZ2gBtCAoh5iduvxJMz8FkKdRoi51P4TG4ZUKNDxaVhyzNtzRk	1600	2259	2259	1616345820000	orphaned
3087	3NLj1BjN61USoEJS4JCP4STr6woLJZvQKqiMenD9kRSvXBsppW5P	3086	3NKJsngn7o7kLnPLACLjXfow6hSQXyfYNodfcEC4DakAVnTcqY68	1560	1045	22	1	3009	jximqYNJBhRCjeJk7XHQkb4Vos8VKsQZMeTYNxbNsUZ39R4fyXN	1602	2262	2262	1616346360000	canonical
3090	3NKxG7R3FCmKZhkZiar6cXhWxDpwgrR1uVmnFjBzNci3gF7LdcRp	3089	3NK4f7FD59jMfmpBfjKfVgFXHSiBKHfaT8CPLYgSqP9cFYt688kj	1553	776	22	1	3012	jwmu1CxmSKEegpyYCtHJ7ATw59ZtXk8XbExHGd3xpWUXP7gGZ9Z	1604	2264	2264	1616346720000	canonical
3095	3NKZTxNtsAAmKoxYp4TSencDuVXZx5N1avU1PMmrhVFk22XzJaz1	3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	1559	1353	22	1	3017	jxYwhAoYnLWiiGn3nme1KuSgYMb2ARLuFJi2TgJNkEYfnvt2bAF	1606	2272	2272	1616348160000	orphaned
3098	3NKu38nr9mGTPu6ARkSrDxk4Qy3i1mncZ1wT2sKuULFHbeV7FYQT	3096	3NLgJkCz2rbsb2QY4CV5n5QZg74zHqfHhjuKQ7FkBeqx1BLyYcVh	1407	1395	22	1	3020	jwuqyS2eXCi15Tgy6AtpzfVXjwggzeHtHikMkXnWFhmA44E8YQC	1608	2275	2275	1616348700000	orphaned
3101	3NLKc2gHU96VteXwpindiWSoMZgteCJFb6V9YRpE1rRNmt9yabPY	3099	3NKZLvDdgdC2VLgknDKLwBXzkMKsGqBkLFtkLRqF4sH8kPAwZmfV	1647	1302	22	1	3023	jxmV7qWragYrWsaPnbXEynW8fbd5kqJ4jzMbtMbP8xZLcmNxinT	1609	2276	2276	1616348880000	orphaned
3106	3NLTDqgF5oD4FqLHK64GgSrSxFsRPoPLeUAqdBVKCk6SWMqCyfDQ	3103	3NLuCsTf5u8Tqspe2VWNikzTMVAVzxkYepoGYifnbCPqV9ZKJND4	1619	1275	22	1	3028	jwNpd898d6Zh9CJaV7UxFVjFXwZW5mUyZGniUjHsk8iMJHsXknS	1612	2280	2280	1616349600000	canonical
3104	3NKrrSZJvSVYB6hVyqp11k1CTz2JSrzQ3owaxwCUiowWi82Kjhxf	3103	3NLuCsTf5u8Tqspe2VWNikzTMVAVzxkYepoGYifnbCPqV9ZKJND4	633	1384	22	1	3026	jxEtUiKNu5yZJthS86uNgrKdnGGEvXdQP9hzXqXdEwr3JfqXhmA	1612	2280	2280	1616349600000	orphaned
3107	3NKKTDUAg7bThtDQrxcH9JJRsZkDaHdqS7ESZxbVp3RxvHLXL53S	3106	3NLTDqgF5oD4FqLHK64GgSrSxFsRPoPLeUAqdBVKCk6SWMqCyfDQ	1508	1021	22	1	3029	jxPqBfy6naqufb4W3HzQ1rbPk39D6ZJoB3jyHirbTxMcsxkvzoW	1613	2281	2281	1616349780000	canonical
3109	3NKBpHZ7jJFpMWDXKpwQK6oKeuecwYKi6o47smkF1EqdqzuEcPGE	3107	3NKKTDUAg7bThtDQrxcH9JJRsZkDaHdqS7ESZxbVp3RxvHLXL53S	1406	1393	22	1	3031	jwFXx7hqSY3hnAsop8QqxmRRQpGW9Qkr6Fe7JubQ77orvWiiESm	1614	2284	2284	1616350320000	orphaned
3110	3NKUqsnPvDthurRuHma8fk4CP8eKMjtDMVBcRiZ9qtCX7dC2Kpsi	3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	576	1355	22	1	3032	jxdnSPbHGLgK5zZcGRjB9KhKbd8mqKz1KMWUa3eaDpxCMj4YcFc	1615	2286	2286	1616350680000	canonical
3113	3NLCCPTwEDaxfwCbML5Lhu4HCoxLzbE7Yejjv3Mfam7wPo5mszcv	3110	3NKUqsnPvDthurRuHma8fk4CP8eKMjtDMVBcRiZ9qtCX7dC2Kpsi	1599	1287	22	1	3035	jxaFT48UFnSzf3oiZcPh4SZvVJ8JN2nVuSjSE8AwQmA8RfQ1DUP	1616	2287	2287	1616350860000	canonical
8296	3NK75pdRyoA1fyN33cD38AnKJYp9umpmo62ykE4o3huqroBjFXfv	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	684	1106	97	1	6301	jx8gmYypQG2sHKvEmdNbgzR5q3CSy5wU3iUgsHekL2FUDjW7Ld9	4295	6062	6062	1617030360000	orphaned
3056	3NLAnkmw38oxaHZ2uWFtReXLMHmAfZWTEJ2AUKZoCa1LmHKE6oMc	2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	1403	824	17	1	2978	jw8AJiUmuMxLTiicx2cbeLC5oZbk7k2r7zGvNtcSYANEmdGCEr3	1429	2247	2247	1616343660000	orphaned
3059	3NKQZA61GyrWFXtA5ywfxp8FvPS1ycnSca2RkePGRNNDqjkG1NAH	2781	3NLSt1sbTZH4MrhsSa3o41q9yqNjJojjy2HKvLxoqT31w5sXwzhG	1403	824	18	1	2981	jwGDkCcgdBbPqHfpZgxHCMapUG7AyEY3LHoSXzbGshj9L71KaGK	1456	2247	2247	1616343728015	orphaned
3076	3NKk7H7aSbAdXpvgzWsboRyK874EHHP8Uqj5jLRXZWRQwbzagUkB	2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	1654	1094	18	1	2998	jxqF9Ukzuemc9FbZJBs6n4AnXzxBG4for15SwANrRqvAH2UgBEz	1473	2257	2257	1616345460000	orphaned
3062	3NLUrxsfmTUztLvXf36JHHmRkTUwSaxthaJNzn8yZXL2CbFLhHuB	3013	3NKgzy5Qaom9hwFMZPRFDUeoRYD6vZ9CsSSNoTG9g1G4zYtACz22	1643	1173	21	1	2984	jxbd45sKXumqHcwoC8HQkhWBCoauSonviRY8rYTnLGMAeWshmZT	1566	2248	2248	1616343840000	orphaned
3044	3NKKSbGHbZUsPsQEC6cGrVcMeEjcLaRuf9FZuH1RPSrWsWLi17TN	3042	3NKv5D972kMmaN8CVdioAWMSeEFDeV4ZakTVR5c3dZnBYbXMSTyj	596	1306	21	1	2966	jwBrFrcp3Ff1KbuTdtTY2BzFAhkoEMnLWPoytS8RKwbk3rKZF9S	1581	2234	2234	1616341320000	canonical
3047	3NLQAoho3MarwDq32M6ZFMrXBUafKGBsg8Gtv3oSwHP6rJ4nFsk7	3045	3NK8oTAnof7rsAmRhEcC741DYxgcpKzm8Umhhq3afDxnbUYrbp23	1407	1395	21	1	2969	jwEU5wgRLoJEAXA1BfDqZAa5CkNoDy9fYHm7a5PutLaeW1CsKx3	1583	2237	2237	1616341860000	canonical
3050	3NL3rsR5J2Gs1STS9on3VjxwsP39i3yHX89dcUu1APrCvb46GM3j	3049	3NLvBghs4ty9sZyoT8b4bfLZFpakyd7ffvQmYzRvXsjxs98iJPus	1402	850	21	1	2972	jwWgrLXxHBWdWXqfVMxTcuhtbZDR8JghcQCCSkUz7jpVN5otmn6	1585	2241	2241	1616342580000	canonical
3053	3NK5hFidRypHU8ZJDNN97XtEAAhwYgzYLj6dr719u73Mur25fEmN	3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	1419	814	21	1	2975	jwatpyLSTzoJCrTvJNqW439xEoLJxJiRCnVnDbrRbUQxr8CJsjH	1588	2245	2245	1616343300000	orphaned
3068	3NKh5tFLzGdk89JMd95LKRvVLYxPdWbrKRr5nyZStbgU746uVnxX	3067	3NKUQTAspYw9KcbtafVRJKa2DFKQPczSrN7An1ZbxWdaVrTxgcAe	700	840	21	1	2990	jy2FDWyrutPtxDTWF8TG9yxhUnEvFcVzS8X8uwA9QxczQGpiX4y	1594	2253	2253	1616344740000	canonical
3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	3070	3NKD2VLMrkwF1LDKwTD4PJwGUkxX5tpi4kZoWjKfsxtrDUpHyjvK	1406	1393	22	1	2993	jxkN1b8z8ZjLb2k8vTJ3XxKxxW8rKzi4eAwAde2VScj5sRUMsfz	1597	2256	2256	1616345280000	canonical
3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	3073	3NL9WuzRym32sMfAWTojxfaBtjfrdrvzZUNh7iSVnmGhbja1WVfs	1407	1395	22	1	2999	jwh3CheuZYXz2tcEBiz58qo83uSAHnuSXEfe96G8bRcjQQKmysS	1599	2258	2258	1616345640000	canonical
3079	3NLXnMzRXRSEJFGtMd41C7kSUZrV6KyfPtjFtsKPqENXJAdhdeRJ	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1649	1017	22	1	3001	jxYLG2itf9pGSAw8np9HCP2kx5PrA8qu6hQJ4G5qDX3YSfYvTjB	1600	2259	2259	1616345820000	canonical
3082	3NKNHxiKzv8YP21hZSQA56BtZbSUBr22vrJvTPtph2VoPP8Q5PUv	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1594	1326	22	1	3004	jwKr89jZPeUfQGmwPwhSroUepa5x4nwA3Bm4XznP882SrbHKjLE	1600	2259	2259	1616345820000	orphaned
3086	3NKJsngn7o7kLnPLACLjXfow6hSQXyfYNodfcEC4DakAVnTcqY68	3079	3NLXnMzRXRSEJFGtMd41C7kSUZrV6KyfPtjFtsKPqENXJAdhdeRJ	1590	1054	22	1	3008	jxpcsnz3GnoRq4MvdL2N4AMNa8Tgyt3PywpmgUm5NtDEntGYRfW	1601	2260	2260	1616346000000	canonical
3089	3NK4f7FD59jMfmpBfjKfVgFXHSiBKHfaT8CPLYgSqP9cFYt688kj	3087	3NLj1BjN61USoEJS4JCP4STr6woLJZvQKqiMenD9kRSvXBsppW5P	684	1106	22	1	3011	jwaJZSj1wVSU6i7ojfRaVQsxTd4diqBMnydf41A1Ufc5yvCe7Fi	1603	2263	2263	1616346540000	canonical
3094	3NLJHkWxKFcPPZGcztfzN3u86kFwVTfK7q5zbgCqeuhHAbGNcTxD	3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	1467	1376	22	1	3016	jy3M76UcJKnJc9hw7tcoS4dPnjassU7TxvduVHcPvjhVsjNHNVf	1606	2272	2272	1616348160000	canonical
3097	3NLWjapBFnUvuBQLtCjhn8eTN8SFotEvdwq1oANmgMxpuT8SvrmP	3094	3NLJHkWxKFcPPZGcztfzN3u86kFwVTfK7q5zbgCqeuhHAbGNcTxD	1668	1124	22	1	3019	jwwogBG8QxcZyPmmCgzX4YmcN7GLYhbN4BzDKgRMeQH7PDQ1Qxf	1607	2274	2274	1616348520000	orphaned
3100	3NKh2xt3EL8GRDToxmooM5Yt3HyFLHNEoySGePsfbF84odsbuhBu	3099	3NKZLvDdgdC2VLgknDKLwBXzkMKsGqBkLFtkLRqF4sH8kPAwZmfV	1407	1395	22	1	3022	jxmjqLZLABPw6cargtMJuKD9MFNVZpJWmCc814Bm3UkAjE5QXtB	1609	2276	2276	1616348880000	canonical
3103	3NLuCsTf5u8Tqspe2VWNikzTMVAVzxkYepoGYifnbCPqV9ZKJND4	3102	3NL21Vg6Qad5FLZyM99u3BxE4x8MJLVeypFGnZNQ1bdVmGWbBjW5	1609	967	22	1	3025	jxqLpYrkJsxpB4wZo8V8jZXFEypasUa5RZFBLjTB8dnRJpSRBfJ	1611	2279	2279	1616349420000	canonical
3111	3NLjExcgoVHLh5wksgY8uFJQUCK8byyqaDR9t1sNNzxSfbnm5ZHL	3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	298	1308	22	1	3033	jx7HPco3L359ogEjDmNHmhjN6FNoSPXjYJ9HzW52TDzqcbdSZ7D	1615	2286	2286	1616350680000	orphaned
3112	3NLAo1pzEnjdUzXWtvQ9rAzCi47eDfBNmbspfdTKt69mX2APPteo	3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	1568	239	22	1	3034	jwdqQw2Epjd8n4bMCv7hyE6iUfR4Se9jCDogFFSmFrkKg5ZTCge	1615	2286	2286	1616350680000	orphaned
3115	3NLNHGGtpBhUmQSL8tGUoUgS17ziLeSZwCVRYqEJocSNHUsKxrSd	3114	3NLLggne6vSW4szfoCLmbiYMvT6SNM4agis8MWLWLtQzJAPL7z1Z	1407	1395	22	1	3037	jwLq3Gik8eqRxhmsbrDxAvZAtiaKMSkY7S86xNbfqdmUYrKbyqk	1618	2291	2291	1616351580000	orphaned
3118	3NL8dCXLGetDxoBY4J54WP7TQGJsDgsH5DugWi113abNAjtM2Z7T	3117	3NK6ybBBHfjxCdEFVYPwCwga6AGwzVsgVSEFdwGt2Y9TFxM9Enr8	1588	1026	22	1	3040	jxmBh7sw9cRVZHqSoY4qDFWHWR4zFNMHaJK5eveZUnTnHJ2rx7d	1620	2294	2294	1616352120000	canonical
3121	3NLERMoBmfv47xxqGBsz7tPUPAVY9TFK5TUmPffKkMgmyAL12Dob	3119	3NLmX4deoBcccmoxcuxfHsh2H2w5RHPpbaQXpLoY172aLAjLygVp	448	1059	22	1	3043	jwGY5t3zxyqeSiwPDmSMDzUSeeTGA5wqtbsdsSzPBXVKUK51EEg	1622	2297	2297	1616352660000	canonical
3126	3NKBxJxdZ2F3NGR4V7htM5s8szRn4UXSgmM7jVwb7e3gvdTtfUrA	3125	3NKRn2MzCb5GJNLsax85JCv4Qfj1Sroex84Z9Z9pQPkikar6Uuae	1405	851	22	1	3048	jwkh4Wuc9jkJZeeQ6ykrYR6V2xm2oGbM8kgvYQLKfdmyFy2RubG	1626	2309	2309	1616354820000	canonical
3129	3NLbhaX4UjDgf2prxvNxNJfz43sPxdPt4Vu9aix4WU4x9HcA7B9K	3128	3NKhyjSJsBdWPf6Kh5aKNuMrhyoRir2ExzL9vP4bKMko9exHh7cu	1642	1367	23	1	3051	jx4L4FePj3BCdgEqb4PLRDfhRBNbFareJhzoZvBqrKYhUkF39Hs	1628	2311	2311	1616355180000	canonical
3132	3NKQNPhAF9ML1mSLcDGWG4e3Xq3rKP2tkDQsS3j2sv8MpNxfD1C9	3129	3NLbhaX4UjDgf2prxvNxNJfz43sPxdPt4Vu9aix4WU4x9HcA7B9K	1455	1086	23	1	3054	jwaURNhEeCkbTCbfbJ3o1bESCCwRmevrjsEQDpb3yQnAq5ypjsF	1629	2312	2312	1616355360000	canonical
3135	3NKLv82AjiwKbxo2TauLmMgspqx1fNYUd4H8AntXmszrQ7zkjKkg	3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	1608	1289	23	1	3057	jwakXfEpFQ955TmjwVdA5Qio9VWSCRiTni4dbsFiW2qNJqmH9tn	1631	2314	2314	1616355720000	canonical
3138	3NL6Hv2ccHNHVsFqoaxotAYb75B5ricynHPxBbEhPz532CwKzsHp	3135	3NKLv82AjiwKbxo2TauLmMgspqx1fNYUd4H8AntXmszrQ7zkjKkg	1403	824	23	1	3060	jxMiSVhDhcbCcyh7tW9iVNK7Pdcngws5AAeGDBvruea18BMFy51	1632	2318	2318	1616356440000	orphaned
8305	3NLQnc5C6wwvm5Rr627gtFwCGBhpiKmb5fi1ZNa31dtoFsP4DXwK	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	152	964	97	1	6301	jwRV49htphoYAX3Wc7kbUUTh79K2XbHnjY2aFJcd5o3E7NGeQae	4299	6066	6066	1617031080000	orphaned
3061	3NKgP7DzeiC2VewSvgpd86gu5PSNo3AkGPM16vhhpCNUTj8M6kFS	2815	3NLkTY137txrKQZiREsndQFejnGF3iCMDoiSKZ72WBtZptYA9rix	1403	824	18	1	2983	jxqSJvXh8sTox6wEQ93DbrdPKcaQYB6spbu1hfVCc61VVUp9Smq	1473	2247	2247	1616343790510	orphaned
3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	3051	3NLEPvXEJ3K2p2Qp4EZst8W8DmV4YAPhhsokHe3BgmqZmyrwcqkM	1407	1395	21	1	2974	jxp2vAAAe6rB7cxvrLoVa1C5oudcXzoqrNmU6tXeYDoCEHVyc2n	1587	2244	2244	1616343120000	canonical
3055	3NLmSFdMg7nN4xHhcDnkdbaUuz5n4gC6xWraS2WYDxN4ZYBrR4y9	3052	3NKf6WH4TQqv9xkW5A6v3kbULRfenPUccQpvgHU7D6E9Tw2butXU	1476	1005	21	1	2977	jx8je3ZBBER1LWiXjUBJSuqcDxfqubz17HksVQJaSQCFkeW2LtN	1588	2245	2245	1616343300000	orphaned
3058	3NKdKLgxAz1Mvhx8pc1LMBxpfDFukSzcfTwTF36R1cd6mkHz85TX	3054	3NKvrqdAChGybeAb1xR36DciC3RPrM5dejXorBrP1m8Mnq9QkAtR	1594	204	21	1	2980	jxQTSVmT5iZQ7xoXvuweg9m1ZaGmZYEUzZh4CB9gavzQkxMZ9rL	1589	2247	2247	1616343660000	canonical
3064	3NLCk4LPenVMHH67EgMiAaDFQLU5SKmgcm7WU98ViJgGeM5HEDUZ	3063	3NKdqFLhxUmHJ8eL5JRJpmcUNYfitQHquWfPLhFsLSUY1NxMpR3T	1672	1285	21	1	2986	jx5ep1irPjq3vtBpBhvttjTAndGjcdxf8iXMvdRc7TmkCaKoR5B	1591	2249	2249	1616344020000	canonical
3067	3NKUQTAspYw9KcbtafVRJKa2DFKQPczSrN7An1ZbxWdaVrTxgcAe	3065	3NL3WSTDRK8hP9X8REY3e3zJDa7ENbuavSvSqNnfPRBCWhf6iekE	1547	1378	21	1	2989	jy2x59Gbtovgqqc8UgbHditXHmyaMNra3xdNBcBnFWb3WGySjeM	1593	2251	2251	1616344380000	canonical
3070	3NKD2VLMrkwF1LDKwTD4PJwGUkxX5tpi4kZoWjKfsxtrDUpHyjvK	3069	3NLX2CcAGqjZmR2NjBVUWrGSdjSGXHGCqYyvQdUepCi5L3mtFFc8	1650	1375	22	1	2992	jxAa6KwKUsADkpYJ64zGVsPguk2gY7rs3uAubnKWBa6eevjMJwn	1596	2255	2255	1616345100000	canonical
3073	3NL9WuzRym32sMfAWTojxfaBtjfrdrvzZUNh7iSVnmGhbja1WVfs	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	1534	1071	22	1	2995	jxZRofooxucZktGh4VKEZnN68ksbsSjTHJRezrdHw9mTbFD9x4x	1598	2257	2257	1616345460000	canonical
3088	3NLUDV9QHT8AxHBgyXvsgWQBVbUCcEpWhNBxhJEPS3UQsPRQNmA9	3086	3NKJsngn7o7kLnPLACLjXfow6hSQXyfYNodfcEC4DakAVnTcqY68	1647	1302	22	1	3010	jxShEj9yEh6aLMDPND3HZhVLFtRxVBp5zoLMBx9EdpuNDYJxaR2	1602	2262	2262	1616346360000	orphaned
3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	3090	3NKxG7R3FCmKZhkZiar6cXhWxDpwgrR1uVmnFjBzNci3gF7LdcRp	1637	816	22	1	3013	jxc8i1R1FCN8LxfvH6Y8dBnft9ivVhDUZTuEan6ESmPB7P4hvKi	1605	2265	2265	1616346900000	canonical
3093	3NLp1uQ6Z8yWPc8JojvZCqmjs5M74vSVW5ez3DCZskerrpjx1iss	3091	3NKSPQhvEQwzoGLS7SAVghkGyYkofJQjJSTWT2QBGJqu4B8Kd5ZY	1579	1389	22	1	3015	jx6ERtyqTbEvSA4XDMuquyaZtpWr7w27ZPewy8A4jAqfamUGb2P	1606	2272	2272	1616348160000	orphaned
3096	3NLgJkCz2rbsb2QY4CV5n5QZg74zHqfHhjuKQ7FkBeqx1BLyYcVh	3094	3NLJHkWxKFcPPZGcztfzN3u86kFwVTfK7q5zbgCqeuhHAbGNcTxD	1407	1395	22	1	3018	jwsFpo4UCCrxtHzeCpqUNcwaShbPDcVU3GkJF8971BfoAxnHioz	1607	2274	2274	1616348520000	canonical
3099	3NKZLvDdgdC2VLgknDKLwBXzkMKsGqBkLFtkLRqF4sH8kPAwZmfV	3096	3NLgJkCz2rbsb2QY4CV5n5QZg74zHqfHhjuKQ7FkBeqx1BLyYcVh	1623	830	22	1	3021	jweP5rVSckZ5cEy1giGnFrGwQzkLiaaUCdcWgxGboxuZSYiSH9U	1608	2275	2275	1616348700000	canonical
3102	3NL21Vg6Qad5FLZyM99u3BxE4x8MJLVeypFGnZNQ1bdVmGWbBjW5	3100	3NKh2xt3EL8GRDToxmooM5Yt3HyFLHNEoySGePsfbF84odsbuhBu	1471	1140	22	1	3024	jx9EQs69KPbmHAADaHJGHsK75SqH3oJgFYwpb232JQ2otuzLG3V	1610	2277	2277	1616349060000	canonical
3108	3NKgXhfRYxQbqCBiBuUXZFzua5ZpPHg2uxPA2CWfThbfbyeTRfed	3107	3NKKTDUAg7bThtDQrxcH9JJRsZkDaHdqS7ESZxbVp3RxvHLXL53S	1405	873	22	1	3030	jxdSzkRK5k6oN79hUy6sXXvUt66cKX5eVKuKitNotUSGFw9VDsK	1614	2284	2284	1616350320000	canonical
3114	3NLLggne6vSW4szfoCLmbiYMvT6SNM4agis8MWLWLtQzJAPL7z1Z	3113	3NLCCPTwEDaxfwCbML5Lhu4HCoxLzbE7Yejjv3Mfam7wPo5mszcv	1610	1068	22	1	3036	jwsSjrH4v7wQz1LRhzFZiKKw6pioaEib3L6g1vghTpTEXEUSLZo	1617	2288	2288	1616351040000	canonical
3117	3NK6ybBBHfjxCdEFVYPwCwga6AGwzVsgVSEFdwGt2Y9TFxM9Enr8	3116	3NK9v8bjnPZLHRESmw9vs5sDS3afPDN6ywNFNdYgtzCWsJHDEQLj	1500	1297	22	1	3039	jxiBLNGPNQhK77aVMLwhYyT32ezRwqNkj7ETwxFcSDfhbn7dGj2	1619	2293	2293	1616351940000	canonical
3120	3NKki8YjDg1JPpcZnLh4h1tVVpgCpdVTYfq2Rz4B55seHoSU1V6V	3119	3NLmX4deoBcccmoxcuxfHsh2H2w5RHPpbaQXpLoY172aLAjLygVp	1589	1040	22	1	3042	jwUZ2g3hmUHHH4NApXzzgNaYxiZJPz745bBD4C7yyyGwq3SfFx5	1622	2297	2297	1616352660000	orphaned
3123	3NKy8ctt9ivui6P9uYgXfJxi9yUPvrmKpBzg2mxGRfZENTDjtQkV	3121	3NLERMoBmfv47xxqGBsz7tPUPAVY9TFK5TUmPffKkMgmyAL12Dob	1637	816	22	1	3045	jwNk4mYi7d4QDcrgYrv5cqyQsdhHPP2o6LNP2aghm2Kx4ZvCS9b	1623	2300	2300	1616353200000	canonical
3124	3NLX5cbRBzefLut9p3FYis1aayUKUHR4JMuaDXMpTdYFgrSNUZM3	3123	3NKy8ctt9ivui6P9uYgXfJxi9yUPvrmKpBzg2mxGRfZENTDjtQkV	1407	1395	22	1	3046	jwH55YPEPbSwFiFuB6TApDvqV5gErMwYPsg6f3T7eKVmZ7psEE4	1624	2303	2303	1616353740000	canonical
3127	3NKqEGE3kue8jSzmivjbadhAY8zcaw6hr4u5RP1kcTFekwRNfJUV	3125	3NKRn2MzCb5GJNLsax85JCv4Qfj1Sroex84Z9Z9pQPkikar6Uuae	1599	1287	22	1	3049	jwcC7H2DBhhWngKxWjC9Vzr4UVHzjL5CgEzx5CkbHcmPX1crSsS	1626	2309	2309	1616354820000	orphaned
3130	3NLt7XMGDHebk1FMqVLB3fg9ixgJzkik3zqoF6YBh6dgWA7Ys3YC	3128	3NKhyjSJsBdWPf6Kh5aKNuMrhyoRir2ExzL9vP4bKMko9exHh7cu	1529	1316	23	1	3052	jx4V4mTaRGmjGidaeD8PuoCn3ai8yW5FCEDtaVyzDN67Bjoez4P	1628	2311	2311	1616355180000	orphaned
3133	3NLhcBvWEu8dpxqozT3FEUbSa9y6Ei7BkmU2Ka1zGVuMsNZ5xy51	3129	3NLbhaX4UjDgf2prxvNxNJfz43sPxdPt4Vu9aix4WU4x9HcA7B9K	1643	1053	23	1	3055	jwmGtsdp9g72faRfzDFXRfg9jFGGcPphD98qP2hNqn9iVEYNng9	1629	2312	2312	1616355360000	orphaned
3145	3NKSPczgmR2ywT1xjg8PrLHYTLG7tkHVwHc3KxW17fYGXq7kmgHe	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1490	908	23	1	3067	jxhZESyfYVwgbUbpnRtY1NE8NyqtrFDmQC2obhRgr31M6FVJ1gX	1635	2326	2326	1616357880000	canonical
3142	3NKCefCCR3ynGvCBAd5V5tpvj5yeQQZzmnrQfKfqfKCE11r4oY4o	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1542	1304	23	1	3064	jwtuXNS1VNK1hFm7U5LDU1ebLA67ZzPLoCHQVTSTuuRvqnzep6Z	1635	2326	2326	1616357880000	orphaned
3148	3NLr7EMjEgN1rPneYWMh2TyiHbYmyC3G1s6Xroi2MRX1pjFrZbu4	3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	1402	892	23	1	3070	jxurRSVgGuUMMJJncVqNEFy1kNTHsb3rpepLvHhGYyGptCQ59Hb	1637	2329	2329	1616358420000	orphaned
3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	3153	3NL53mfo3Gc7k6TpdbxeANmhtJqLBxCTZoGCmMpHeuHXVczL4M9n	349	349	23	1	3076	jxgH9LBCUAyy8F91DbmP81imJotrkpeuXHKwu9EnjhHvdJBAR43	1640	2332	2332	1616358960000	canonical
3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	1407	1395	23	1	3078	jxWY6LrT5k6S93VieANHLQNsauvvQg2aidQTxoii3oP4smEr31D	1641	2333	2333	1616359140000	canonical
3163	3NKvGnP1jNvfDzJ7sWqAhn7cULf5Yb7iwARMnDRLG9dEgAEywvyX	3160	3NKjQbvu9MyUgYG5VxeBs41HsVNDU1WNQHpqAfdut8hnZMTtY595	1406	1393	23	1	3085	jwufd419XX9gbbeH8UKotKpAm88w4q6S3FhZP8ncQiCB2mG7YPW	1643	2335	2335	1616359500000	canonical
8340	3NLMFzsDiBCW5FFjQRpYKHzKZ7qE5tyQmyYaGyqetFSrcGGLzPcX	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1637	816	98	1	6301	jwuq6ejqrkczcQA2Ht5DxbMaNmH5ALJjzM6Lvq8ybwjxQP1v45Y	4319	6091	6091	1617035580000	orphaned
3131	3NLrPSkAekanw2RWhemJ8BhvtXdkL7d4Bza5nsXoRQ6oHr25Dkuc	3062	3NLUrxsfmTUztLvXf36JHHmRkTUwSaxthaJNzn8yZXL2CbFLhHuB	1643	1053	21	1	3053	jwV8bujanp8rhnrUuzY3vviccfB4evHYfTAbmUqeawZLwUVtM4Q	1567	2312	2312	1616355360000	orphaned
3116	3NK9v8bjnPZLHRESmw9vs5sDS3afPDN6ywNFNdYgtzCWsJHDEQLj	3114	3NLLggne6vSW4szfoCLmbiYMvT6SNM4agis8MWLWLtQzJAPL7z1Z	1406	1393	22	1	3038	jxqrqGWxLncBdsRnafYExe7uwSDm5Cr9b2Heum2j4mosKdmBTci	1618	2291	2291	1616351580000	canonical
3119	3NLmX4deoBcccmoxcuxfHsh2H2w5RHPpbaQXpLoY172aLAjLygVp	3118	3NL8dCXLGetDxoBY4J54WP7TQGJsDgsH5DugWi113abNAjtM2Z7T	1405	897	22	1	3041	jxAr4LfX2ovBWkjXqegkY2RniPnc4Y2BQYtQhEeLRGLTaAbiQtp	1621	2295	2295	1616352300000	canonical
3122	3NKhRjMTwUDdn2FRNrLRDuQf1JNDCryJnyxw2QzFEh6bCEXuB8U1	3121	3NLERMoBmfv47xxqGBsz7tPUPAVY9TFK5TUmPffKkMgmyAL12Dob	1405	873	22	1	3044	jwGyanpg7DbUaFSB9uQ7R3Lr8NiGFn7FsHC5tLwaxiQdbuU9jPo	1623	2300	2300	1616353200000	orphaned
3125	3NKRn2MzCb5GJNLsax85JCv4Qfj1Sroex84Z9Z9pQPkikar6Uuae	3124	3NLX5cbRBzefLut9p3FYis1aayUKUHR4JMuaDXMpTdYFgrSNUZM3	1587	1357	22	1	3047	jwDfiaH4scbg1ETHNga3dJ8eSKeoHzDev8cYF6Fofw9vu3Yvysh	1625	2306	2306	1616354280000	canonical
3128	3NKhyjSJsBdWPf6Kh5aKNuMrhyoRir2ExzL9vP4bKMko9exHh7cu	3126	3NKBxJxdZ2F3NGR4V7htM5s8szRn4UXSgmM7jVwb7e3gvdTtfUrA	1610	1314	23	1	3050	jxEpHBDpDYTGoK7ckHRinrKvExM68f5QjzE5TNnuAZzDYdph81M	1627	2310	2310	1616355000000	canonical
3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	3132	3NKQNPhAF9ML1mSLcDGWG4e3Xq3rKP2tkDQsS3j2sv8MpNxfD1C9	1406	1393	23	1	3056	jwkph73DwsskvJar4uKUJ9PRZtsjc1x8Z7u3P73Ak56nKdtJsov	1630	2313	2313	1616355540000	canonical
3136	3NLgPVuBQiqetLma3PrmgF8FQNgMpWUdjZTSa1LXEo5SpmFk3AXi	3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	44	1079	23	1	3058	jxQmPGntg7J1vD3HM6UNq1udk2p2beKdy6uje7RRjxDWmbNSD9X	1631	2314	2314	1616355720000	orphaned
3139	3NK4qt6xEUtuBpEbXySMZhD3pFQPhyhay4QMRjhTYeKyQMseCCoy	3135	3NKLv82AjiwKbxo2TauLmMgspqx1fNYUd4H8AntXmszrQ7zkjKkg	1406	1393	23	1	3061	jwPwhwzbictF2fkNQZYzxJEjF4FrruRQe7hiqjVv1znYamupzeK	1632	2318	2318	1616356440000	canonical
3140	3NK6MC2vSEXbuwV6osVgrBcgb4sfC55dML8xQv1a98jik7rcqNFC	3139	3NK4qt6xEUtuBpEbXySMZhD3pFQPhyhay4QMRjhTYeKyQMseCCoy	298	1308	23	1	3062	jwtV3PLGWtERU4dKto2CtUM9btpR1KHptyHGZVoRMsFPr4brML8	1633	2320	2320	1616356800000	canonical
3143	3NKoW9HS2A3fVhxFnncteGqZmewwfN17VnpkyJb7pQ5wSQw6f1pk	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1529	1316	23	1	3065	jwgt3ruXCH9w8s2dbRwkagjeQQFQbXPU2oZjzqizeo2KyeJAiWi	1635	2326	2326	1616357880000	orphaned
3146	3NLcC7qMVuwvS5JM3VLpa4mzf3d5qMD8skJeea1BrPaSm7X7Fu4d	3145	3NKSPczgmR2ywT1xjg8PrLHYTLG7tkHVwHc3KxW17fYGXq7kmgHe	1407	1395	23	1	3068	jwehkb4tsLsQZbXN6Uvqjk1S93Df2VoCiTACNSeDKRUp9Ph2YhU	1636	2327	2327	1616358060000	orphaned
3149	3NLstQxLGg1ufNhALi7VsoU57xnp4WFsDk3DzqxMCf1HDvn8wnit	3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	1553	776	23	1	3071	jwwTAfnB7CsQm34Szs8bRBo5AUAED9wNuEWfjJphDTksAyTzAWn	1637	2329	2329	1616358420000	canonical
3152	3NLbFVJ61QAAMnQd88c8go4Knsu7dgKmnAVtQyCD15sdXpf2Kwpg	3149	3NLstQxLGg1ufNhALi7VsoU57xnp4WFsDk3DzqxMCf1HDvn8wnit	1637	816	23	1	3074	jwwZtqpAXDhcgZHwEhJgjZcydwcJVJWgCaEyYqHJq6cfYS5HPae	1638	2330	2330	1616358682147	orphaned
3155	3NKY9bhB4MucmCbthM7i6JhBLBuMdgpSygsAYkiQKZXP6A9nnvkq	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	1673	1368	23	1	3077	jxAPApuRsHS15QUANTuJCMZKyLyrpV9zmWdCaeSGCkaMXrwH1A5	1641	2333	2333	1616359140000	orphaned
3160	3NKjQbvu9MyUgYG5VxeBs41HsVNDU1WNQHpqAfdut8hnZMTtY595	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1403	824	23	1	3082	jwRgYTGKRsq7PEM6x5SiHzrkLZ1yDoJG6PxNpbHwvWK5TjXdUpa	1642	2334	2334	1616359320000	canonical
3161	3NL4XxvivLPNJwnnT5ii9ppM9NRBaxocA8GfQpDuc5gmasWSxPCN	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1553	776	23	1	3083	jwu8FuWRPLr8R89PwGZeMQiJxLhSLyxDVbSBGNXviUvU3dBxQUU	1642	2334	2334	1616359320000	orphaned
3164	3NL3bJ4atXE3L8XSW7BUe52xu8mo8koSoreVCTbd1xx7WDghFjBK	3163	3NKvGnP1jNvfDzJ7sWqAhn7cULf5Yb7iwARMnDRLG9dEgAEywvyX	1559	1353	23	1	3086	jwDQhaTjA66EEfmKsG7p5exUy5RE5gUQMgwUwDRU8KWpj9W3Da5	1644	2336	2336	1616359680000	canonical
3167	3NKP2b9Ct9kEgYNwz9WTwjQ1kmaSLwJ4MqYNFveav4zCeceRwpg2	3165	3NKfMtpZ2sSRgYiinFFDuxdHgeu5vCKbMnKTGGzZjpGsnK78Vywk	1578	930	23	1	3089	jwQLJsJNkZFNUTX2XpQYxP8pNebHy923DC3zPFDFqSbL4UWJzsk	1646	2342	2342	1616360760000	orphaned
3170	3NKqgYrBSzJGMBbEY8GgEUFQfn8K7fpmmcnKmuATLo493V6GmWp5	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1529	950	23	1	3092	jxG7TanopUfXbNdvZPQ2seWMa7ddxvQ1GBiYwuiPKn2YjtMs4U3	1648	2344	2344	1616361120000	canonical
3177	3NKiyiCYdVDrrmychagSMuLH98Zjz2bvetszzQb9qFZ8RdbYiddX	3175	3NKT29cngj4GrEntj42aqC4E3Hm3WDTL6eNVDVEpURvjmBtoVsVw	1407	1395	23	1	3099	jxSkDQpcdKZYftx7RLkR212TYTYgUYU2DoNLA8wge4qqh32AwSh	1650	2347	2347	1616361660000	orphaned
3179	3NLU24SHKU5vgy7cYwDnhj1kP3TByEygEiRXDXKJL1wEep1i54U9	3178	3NLmyVrThoWqj6F49TivoMtbaMpdHRcR11vURUCgWNcDxpuvjnYm	1564	1338	23	1	3101	jxe9x5Bmqtv81BLdkpi69Erzy2UyTSRvLFkF3Y8jSRhn2fnmnyt	1651	2349	2349	1616362020000	orphaned
3182	3NL4meJZMTPNnXYDxwjR3NC6SAwmt54hwBhf1QKKYz1D7VZm5zSb	3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	1407	1395	23	1	3104	jxkzdi7NpjpvK5i4efek1ueZdrTf1YrZMh6SVbRxZaC9bPgRYu1	1652	2350	2350	1616362200000	canonical
3189	3NL5MnDhLoShm1ESVYq3Q1mB3J1r2ABGK5tLgNm26f8ZHWCTgXr4	3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	1652	1189	23	1	3109	jxDoDnwUaXzTM4aSB7dQCGyGvVrG9CX76RaxQYJgcuM9MGxfMQX	1655	2353	2353	1616362740000	canonical
3187	3NLpGm5TVLd7gKZcCf5ZcgKycKJecn7kbiVp6dnxHseAguqZn7Kp	3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	1652	1189	23	1	3109	jw8gvAr9tHvb1FTAYWpzgVsPnqQWwwsMSLyRicJPPoeaD948LjP	1655	2353	2353	1616362740000	orphaned
3194	3NKcBtAxiMYjPjkN3591QQ97Xwyce9R6NyTKMAuSPHakr7YQdDWx	3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	1402	809	23	1	3115	jxejkpnwaXBjvhcrTbCLddKxXhmU53KYG7hidFpXVsS1Xos1dGK	1658	2359	2359	1616363820000	orphaned
3196	3NKanapudvCQ7gdu753SyquZUiWALX9GMxyY7KRNWLtUN7C5G2gy	3193	3NKBExG5npLE8VuKddgqxRb3TXggrsijK3bTPU4mDw15d8aDnMj8	1593	1100	23	1	3117	jx1gYidP89sagSkTQ6B3vFSGzs6hDfWUjD71tWEKumbHdyBAkNJ	1659	2360	2360	1616364000000	canonical
3204	3NLoqvvA6ptM2tcaQ3N3jr8DRgPYGxZX1r7bbqPkk6SLfHTUs6ts	3203	3NKCyFs9MZqxuNznqzG5B98AG1cAiS5NxSDDR3Ukz7ZzeFV6jRUE	1406	1393	24	1	3125	jxeG4p5GYvQpCYYgEWEQU6R8tPNJeRDFeVoECNEZLDJCyfi9hfa	1664	2371	2371	1616365980000	canonical
3207	3NLd8Ax1UwQkk1f9uUd6bM3vJeQ4fUSkpw7HtDd3guL57CEJRW3u	3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	1587	1111	24	1	3128	jxai6cTJU3bexUUyXbWtKbD52i2D8sJJm4fjxzs6pd6xKi1yP4P	1666	2373	2373	1616366340000	orphaned
8353	3NK36kVitYgBLcjte27Ed1iXjdwfBMTXEPmn8DeLGMtHZRsMa29N	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1581	778	98	1	6301	jwoSPv1U8aUKU9ivYj8paAJwLQk5nd4xxQ9MXzJ5R99EgaaLdqA	4325	6099	6099	1617037020000	orphaned
3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	3140	3NK6MC2vSEXbuwV6osVgrBcgb4sfC55dML8xQv1a98jik7rcqNFC	1589	1040	23	1	3063	jwSGCjNjQbexbW9NuT4UjBWJtdU8shXv5ny3dYoRgqYihKyHyo2	1634	2325	2325	1616357700000	canonical
3144	3NLNmnY3P8KSmRvzoZVAfpJaHARUQhEKQViY1kic911NZ6pWCmCV	3141	3NLimvRejzCm79LhgnrPM6u6DsQmmnSYKcNxmn8eKgvbpNKKoFLM	1534	1317	23	1	3066	jxXfyAUpjf74tNRwGq46oMZN295XkoMtXEWBwShANPjHaD6QrNJ	1635	2326	2326	1616357880000	orphaned
3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	3145	3NKSPczgmR2ywT1xjg8PrLHYTLG7tkHVwHc3KxW17fYGXq7kmgHe	1581	778	23	1	3069	jxjP87phqrV85DsPUaV5hD9EXZ76wSr8D71htvkLsuaNWUYxQHT	1636	2327	2327	1616358060000	canonical
3150	3NLNZUb5fPyo3jRcnzzgHf1UQfAVg7PyYBi2nhyCBnWsGTqZNJTj	3149	3NLstQxLGg1ufNhALi7VsoU57xnp4WFsDk3DzqxMCf1HDvn8wnit	1403	824	23	1	3072	jxhULnPywaM9dgZDjesTD7o5d3jd6UHa3kFzcdD8mH1HLwUtKR1	1638	2330	2330	1616358600000	canonical
3153	3NL53mfo3Gc7k6TpdbxeANmhtJqLBxCTZoGCmMpHeuHXVczL4M9n	3150	3NLNZUb5fPyo3jRcnzzgHf1UQfAVg7PyYBi2nhyCBnWsGTqZNJTj	1451	1292	23	1	3075	jwRvY3WVMiTicGkmx9Lp9EfokcFYgUnNFftrmF7xUjzHhN35Yad	1639	2331	2331	1616358780000	canonical
3157	3NLpoYvVoSR6gf24iwKCxhLZkj43r5Jskwfp5xhez7D2SrZHJnHn	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	369	1066	23	1	3079	jxyPTSgQJLVQTuAnU4bNzhQ6iCZ8Q4WGw2m9iD72f1w5a69wBdp	1641	2333	2333	1616359140000	orphaned
3159	3NLukYvoEifZreoohZLoYXHPKmMrgtePQ3iMg6wGCokcrRQ2bx66	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1542	1058	23	1	3081	jxBWWpuAfcDVAy3r3q39iQmhEy22rGmQZATgA3onVNKyFdHReXp	1642	2334	2334	1616359320000	orphaned
3165	3NKfMtpZ2sSRgYiinFFDuxdHgeu5vCKbMnKTGGzZjpGsnK78Vywk	3164	3NL3bJ4atXE3L8XSW7BUe52xu8mo8koSoreVCTbd1xx7WDghFjBK	1406	1393	23	1	3087	jx7tzEdRsUKdSo7z1AEQqUg3jVVH7eQUGBfJ4oVpeYyfCtQZRVQ	1645	2341	2341	1616360580000	canonical
3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	3166	3NLMcPccg5GtPrxuCuZstkvVGD8MVPt8FhsLQ6hDT5qg8AVofmzU	1406	1393	23	1	3090	jxpM3eCt5Snhrgs3j9vC8H8aXynGDMrus8wwVqJf9Nd6Da8AWwH	1647	2343	2343	1616360940000	canonical
3171	3NLShekLpy7q3qziZMw4FYJKT7g8wx4UpgXbpbr62nwYrG8HSMDa	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1579	291	23	1	3093	jwjRa95hfKGto7o9rG5rkdZyXTncV3dvoHKi7WN931TGKLTJAKo	1648	2344	2344	1616361120000	orphaned
3174	3NKNGgJfoNRotyXpqTpptNQDr6cmZGL4GdeeftS1ZDMnXo64rbKg	3170	3NKqgYrBSzJGMBbEY8GgEUFQfn8K7fpmmcnKmuATLo493V6GmWp5	1460	1324	23	1	3096	jxJifBnJ4aQDiLvrUqDSW2pHpeQQrJcn3BqMB5XxbitowW2UvnE	1649	2345	2345	1616361300000	orphaned
3181	3NLvaEmBVoCNPostjZJXDgZ8Ti6dcB3mbqTQetaZy5AS7m5oYj9w	3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	1406	1393	23	1	3103	jxkBYoRDTPZBKjFf6ZyYBCo2xFA2XMegfmJfNmn2vne2BfJH97t	1652	2350	2350	1616362200000	orphaned
3183	3NLXmr8uy8N33YJJiKxQRscoE9z7KAZBbS5XXQunpoixqQurYeCq	3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	1670	1036	23	1	3105	jwoaE6WfwQzcvCsEXmMbr3MBZ3vKvfgvzxRLypHmTSAXAT5Ns3Z	1652	2350	2350	1616362200000	orphaned
3184	3NLxceg3E7g7VUV4DoB2sFsvugnAbbaRDJzUgp4CJjaaWz9d8EFE	3182	3NL4meJZMTPNnXYDxwjR3NC6SAwmt54hwBhf1QKKYz1D7VZm5zSb	1448	1311	23	1	3106	jwkdRyJxdjY6WRWgF4BwU3TZGnSmoS2H6dcxprVaVdJdejMWGHu	1653	2351	2351	1616362380000	canonical
3185	3NLvdX73rDsXXEAPWYcVqnU6qahgUK2qkC3EttPGxyRkMUHYzD3L	3182	3NL4meJZMTPNnXYDxwjR3NC6SAwmt54hwBhf1QKKYz1D7VZm5zSb	405	405	23	1	3107	jxQaDpFBFskYqy5Htm6KPV7USh2AaKcC8EBbm2tgH67Skzo6Lpc	1653	2351	2351	1616362380000	orphaned
3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	3184	3NLxceg3E7g7VUV4DoB2sFsvugnAbbaRDJzUgp4CJjaaWz9d8EFE	1587	1357	23	1	3108	jxjeURUS4Ev8gP1S8pbFjTtVr4ByTFYneHaiT6U2TpeBspZREBb	1654	2352	2352	1616362560000	canonical
3190	3NKVa6pQiqFBASDwU1CxDeMUw7YqqdZUZx6m8fhvnxGi2uqhLxLd	3189	3NL5MnDhLoShm1ESVYq3Q1mB3J1r2ABGK5tLgNm26f8ZHWCTgXr4	1460	429	23	1	3111	jwTcV4gEb9XtVgcHFzPMNUReqZzH2eXg561L89A93di7p4gkZPk	1656	2357	2357	1616363460000	canonical
3192	3NL24BiV9wunNzZssJRo1TEbZqA4bbafxamiMMXuPojQ31kPLEcB	3190	3NKVa6pQiqFBASDwU1CxDeMUw7YqqdZUZx6m8fhvnxGi2uqhLxLd	1637	816	23	1	3113	jxh58CgbdNvJpRF3TGDTm3C7bFX8BL7fXbWGGp3eBkW2EoSnuJL	1657	2358	2358	1616363640000	orphaned
3193	3NKBExG5npLE8VuKddgqxRb3TXggrsijK3bTPU4mDw15d8aDnMj8	3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	1407	1395	23	1	3114	jxGvF4fUb56vuEkPNf3Q1McDJH6Nvk2iaXuqXkaBUXnR2cMJ4pn	1658	2359	2359	1616363820000	canonical
3198	3NKGLnmZ4HrAaJpMvvCV3qqvGmoz4YWCfhm7kmxbUMbsbJTWGoz7	3196	3NKanapudvCQ7gdu753SyquZUiWALX9GMxyY7KRNWLtUN7C5G2gy	1407	1395	23	1	3119	jxeKaV4FK2wg2ijFipfhAXPX3b16HgyWieKxHwREzS4PBThxxCm	1660	2362	2362	1616364360000	canonical
3200	3NKMwNsUfZuU981A8AiSN8waK23jM1vg4UP9LGL85sM4Rj3rhab9	3198	3NKGLnmZ4HrAaJpMvvCV3qqvGmoz4YWCfhm7kmxbUMbsbJTWGoz7	1581	778	23	1	3121	jx48udKByGyfAXxHQZy7BpYLp3Nc26wRbkr6KVza7ay9FgGzjjM	1661	2363	2363	1616364540000	canonical
3201	3NLmDhTN2diqoBiChZyE3SJJ51xVaVFsF9VKDL1oxE1xZAWJYbCh	3200	3NKMwNsUfZuU981A8AiSN8waK23jM1vg4UP9LGL85sM4Rj3rhab9	171	1128	23	1	3122	jy1GPEgXDPFUHXeYkXq3kzB7ftZnH6HsVLzimGK5f2swcSM4aiz	1662	2365	2365	1616364900000	canonical
3203	3NKCyFs9MZqxuNznqzG5B98AG1cAiS5NxSDDR3Ukz7ZzeFV6jRUE	3201	3NLmDhTN2diqoBiChZyE3SJJ51xVaVFsF9VKDL1oxE1xZAWJYbCh	1593	284	24	1	3124	jxkKNmc2zP8H4SUZmPsJy6R1xzdo7jJXMSv223mEpLGnykewBzB	1663	2370	2370	1616365800000	canonical
3206	3NLsTDv9UkjVLjKLcyJHdfCXrXpkrPsmPkNFuYA2uv7LYoSjf7F1	3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	1402	850	24	1	3127	jxUDqw5SNQvJM2xNCk69ttxaNLajZgXLNtBUUrkkSHo9HDS9DV1	1666	2373	2373	1616366340000	orphaned
3211	3NKuCzuGoGTsBUZKZPEbLGidnat92DnkRf8goC4ZstwGSSxhYARE	3210	3NLv4QzJ38N4g3PJArq3ZeCBs3NJ5P3nAP2S6fGCNNZxCakAuMMj	1529	1316	24	1	3132	jwtE6mR4b9B8B3nS5cTMPuwpQkytHSoJpvRobL6B6wXUnzwXBVN	1668	2376	2376	1616366880000	canonical
3212	3NKWhADKXBErNst49aSLUaP2RpA42Wvvbt69vK61vTYV1fUwAxHb	3211	3NKuCzuGoGTsBUZKZPEbLGidnat92DnkRf8goC4ZstwGSSxhYARE	1670	1156	24	1	3133	jxq8zG4sU8PjZFGauGwSpJCWSRgmHYFiZBph2Gd2ofVA9LtWB3V	1669	2377	2377	1616367060000	canonical
3213	3NLhDrGv6nvLRatsiTcDQZeosx63kNauaCWbt6BbMygwxqmg3T7B	3212	3NKWhADKXBErNst49aSLUaP2RpA42Wvvbt69vK61vTYV1fUwAxHb	1593	1346	24	1	3134	jwk8NCmkRoXregzbEFXokRooSoJT8wxQqHfhJAQYcKmJbw5311x	1670	2379	2379	1616367420000	canonical
3217	3NLv96inG3cwNRsiYqwmM1gY6pfWjxQrjEVVYTWX8iEWXWdoqZBF	3214	3NKsowCsMHYqnM72uooBwdPAFSrytCkFAdeTPtgTDri3W6LSmcNE	1407	1395	24	1	3138	jw8hrV9x1qCY33aEyqQfwFqymrZL7PS7eCHvY9hm8YCEgqRwXkp	1672	2382	2382	1616367960000	orphaned
3219	3NKuxcmeJwcFRGHo1Mof49TyWUha1RXgsJAz11m4CroLNSLQzRZN	3216	3NLV5ZC4cSD7rEXNhNVxVqtXYxed22tEmAds75B5okYyoiwk4aSM	1613	1349	24	1	3140	jws1vmiop3XYTD9ezRWMeMHZoRFTJrbDXsM2gsGdRXeaVyFGbAa	1673	2383	2383	1616368140000	orphaned
8610	3NKEkGjh7NYRs2kzc8pNzRyRP6BHRBNnRnk8W8kMxU4VNjgPshPo	8361	3NKt17qBGsTGejUSHFvNWUNVzEGeCT4ZMQucjyk4yqXkkLcs1Kxk	58	1281	98	1	6301	jwyeQ3QhZ6iGnVoNPepiFm3UGMie8Pe99BNrZaC97fhmFZafH14	4332	6285	6285	1617070500000	orphaned
3169	3NLT8Uabz7YW8C5Q3bB1EaMoxfAKVqLDreyPHVz9ea233wZfAfTv	3166	3NLMcPccg5GtPrxuCuZstkvVGD8MVPt8FhsLQ6hDT5qg8AVofmzU	1405	851	23	1	3091	jx2RkGmgmsFTjziHuoKhscpKDf8cjCgM1W6e7LUSaLhGCrgmyTd	1647	2343	2343	1616360940000	orphaned
3172	3NLtFxpdxJdx8DZpQm7Bsg8Dk7kLhHX1Dkw7Cv6NVMKHBRdCJMyf	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1573	1192	23	1	3094	jwxrJ71poV1Pc8eRRRNdPfkBNqpHYBgLFsD8MWF4VeGkjAJrCM9	1648	2344	2344	1616361120000	orphaned
3175	3NKT29cngj4GrEntj42aqC4E3Hm3WDTL6eNVDVEpURvjmBtoVsVw	3170	3NKqgYrBSzJGMBbEY8GgEUFQfn8K7fpmmcnKmuATLo493V6GmWp5	1637	816	23	1	3097	jwvrr62Lvi8kty9GNxRxhcDJKRPKTmXGMzYks344YXwucoZR9bS	1649	2345	2345	1616361300000	canonical
3178	3NLmyVrThoWqj6F49TivoMtbaMpdHRcR11vURUCgWNcDxpuvjnYm	3175	3NKT29cngj4GrEntj42aqC4E3Hm3WDTL6eNVDVEpURvjmBtoVsVw	1599	1287	23	1	3100	jxfAUC4uzsHxKPy1qCJ2K5EYoipMrVRsSgwLnP9SANp6woJMAL8	1650	2347	2347	1616361660000	canonical
3180	3NKXXGXB2iQixMKeG9hFkkofTAV37mQ6ZGnjDbaE3yjadEvDd8Tn	3178	3NLmyVrThoWqj6F49TivoMtbaMpdHRcR11vURUCgWNcDxpuvjnYm	1406	1393	23	1	3102	jxYLvx56oAsDDmYePXEbe7oNpq2vEprBWK9SuMe6GdSmKdbUF6k	1651	2349	2349	1616362020000	canonical
3188	3NLDoRqxmjzF7xB6LM8ZMvS3qWZYGS6nzNJGjBmhgLoHE9M3qgyo	3186	3NKaPaB9JLxeP3XGhwqp5DPkctNSwvrKHRUqGbXVqkMrZK7YSfLu	1599	921	23	1	3110	jwAmSkYSf6xu4Ani7Cxnw4QPRmKXFxBZQzGgysWAoNCsRi1hKjz	1655	2353	2353	1616362740000	orphaned
3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	3190	3NKVa6pQiqFBASDwU1CxDeMUw7YqqdZUZx6m8fhvnxGi2uqhLxLd	1601	1388	23	1	3112	jwsAgRqDwiKLa1LzwrExDzax9t8jXzipi9dYU6NG7ebsFSCojND	1657	2358	2358	1616363640000	canonical
3195	3NKM2VgdN7CvkYafxrdXWPyKYEW4UiQCa3BJVrcRHhjAsvxNwFRh	3191	3NKbHNS52dZBmHWDc4eGwcEHBTYFMDK1no38tqSRdHJmgnh1AnFk	1631	794	23	1	3116	jxbHDYoyJv761CPtrBau9NiqVFzjZggm252uE55VR9LSHcGGHD1	1658	2359	2359	1616363820000	orphaned
3199	3NLBMdLTs7tmEUTKbVu3DWD9ZgKqD1kSLw6tFnd1znogVwCUkR8M	3198	3NKGLnmZ4HrAaJpMvvCV3qqvGmoz4YWCfhm7kmxbUMbsbJTWGoz7	1670	916	23	1	3120	jwNX7pw2BKRzBjq2Weg34HBvJFc5ou6ZtabwsWhvspsww3kKhVd	1661	2363	2363	1616364540000	orphaned
3202	3NLBe97HtMqLHTiaEmQzm2xNpwmAmm1WJs5uafR1CUVXtunt64ES	3201	3NLmDhTN2diqoBiChZyE3SJJ51xVaVFsF9VKDL1oxE1xZAWJYbCh	1534	371	24	1	3123	jwiaBAbsPs6PHQAyUTw5fvj3jRnBypeWM5xsqTXM8BKQDPUbBwT	1663	2370	2370	1616365800000	orphaned
3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	3204	3NLoqvvA6ptM2tcaQ3N3jr8DRgPYGxZX1r7bbqPkk6SLfHTUs6ts	1637	816	24	1	3126	jwsxbqHUzgTbxgkTySWgRAC4zzq7qAo7EKzw1Ncptj8DcoUUDth	1665	2372	2372	1616366160000	canonical
3208	3NKqEvgKarXSoTma4N7w5zr9HDZt7VCCSqmnxYSTncn66fu549bE	3205	3NKKQSdBb8e7wFCh1YnxnuqtfurKK3Rfk34KfavzhJ2AsmBins39	1651	1175	24	1	3129	jxRA5d6x9kfe8ZtT4hVL83DoyS3Rjg4Dyz8fFLunAuke4uwDzMf	1666	2373	2373	1616366340000	canonical
3210	3NLv4QzJ38N4g3PJArq3ZeCBs3NJ5P3nAP2S6fGCNNZxCakAuMMj	3208	3NKqEvgKarXSoTma4N7w5zr9HDZt7VCCSqmnxYSTncn66fu549bE	1490	1274	24	1	3131	jx37oUi5NXdwfwwpgzxRMzozq3xmN9wsSFW6fA6PbJ3ise9bLQE	1667	2375	2375	1616366700000	canonical
3214	3NKsowCsMHYqnM72uooBwdPAFSrytCkFAdeTPtgTDri3W6LSmcNE	3213	3NLhDrGv6nvLRatsiTcDQZeosx63kNauaCWbt6BbMygwxqmg3T7B	1471	1386	24	1	3135	jwH33Q94tUYYY56QMFYd1sPxVRFQTojo4c5HZSPBFBc2NYUe7Wb	1671	2380	2380	1616367600000	canonical
3215	3NLXemG732s3FSYKbGWsAayHgp1sWkWKVAyiUktqVnxjKLBjRodv	3213	3NLhDrGv6nvLRatsiTcDQZeosx63kNauaCWbt6BbMygwxqmg3T7B	1555	1347	24	1	3136	jx8ATt6rKH8DYqzfft2g3TpdgLN57iXLcCyPGjLpfBy4waz7Yu8	1671	2380	2380	1616367600000	orphaned
3216	3NLV5ZC4cSD7rEXNhNVxVqtXYxed22tEmAds75B5okYyoiwk4aSM	3214	3NKsowCsMHYqnM72uooBwdPAFSrytCkFAdeTPtgTDri3W6LSmcNE	1673	1368	24	1	3137	jx2FD8hbd9camGYWKsHWcokQ5QEjfWrEfL4idy7iQAuheUkhMSW	1672	2382	2382	1616367960000	canonical
3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	3216	3NLV5ZC4cSD7rEXNhNVxVqtXYxed22tEmAds75B5okYyoiwk4aSM	1403	824	24	1	3139	jxyy5vNPiWVk9N3sDAPNddjJdMEAzgtGz2ySmwJoqNYxCzhUVyf	1673	2383	2383	1616368140000	canonical
3220	3NKGZXJ9CgiULepCQEqMeDcZZZqeWABjEL8mLS4hnBRrYtWRFC4g	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1407	1395	24	1	3141	jxwwQ3eCraQT8oTehmZHiB9biT4k9bhxGqNF7VgC168c6JRHVvE	1674	2384	2384	1616368320000	orphaned
3247	3NLe27sY13b3f2TQAEUDihUH29HxQfKu2fN1dMGfCqhiBgbjPf91	3220	3NKGZXJ9CgiULepCQEqMeDcZZZqeWABjEL8mLS4hnBRrYtWRFC4g	1500	1297	24	1	3164	jxUMq9Rtp6htNHi5osTLBPinEtVwhrWzgTU8hsrsixzYPQKTseu	1675	2402	2402	1616371560000	orphaned
3230	3NK6t3zXPrWptpxVnKnbKUoDDpr1UhSyirXNy8QrcvnWnRBK3eW7	3226	3NLLMkgCtDKk8jSBaYYU7gMxqP5sWzxRF2VWsQ2hD88CNWfvsvU4	1637	816	24	1	3148	jxYcU4gWX3592UZz1wDjE1JUXvxJFxQpdrXn6tsWZ6Mt4RLDph6	1676	2387	2387	1616368860000	canonical
3237	3NLSg4qTdhHEsAzDKM5jRx88fYCwrA5anB3f7SxpgeB8B7KrB22z	3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	596	1306	24	1	3155	jx8uMRbUDySXB7V4LgbgmAyU69B2sUko9hLrmiWsAiRUd7oz37f	1681	2395	2395	1616370300000	orphaned
3240	3NL8VsntNwZSkWb2HL3ACW5zapCXZ8essfxeLjtZ9rAYGHzXfbnK	3238	3NKSp7HGpYPU52DTm9cmaTpK1C56C8Bpm64APcLJPpZxDkCBNxVB	1637	816	24	1	3158	jwutVCQNazRCBXVVXQzKdMveMJH33C2LJnkSX49ravqBBJMMr6q	1682	2398	2398	1616370840000	orphaned
3242	3NKqEGXukfdH3HtqbLX71reGZWfHBzFsoCp9QbqqQfdb7myh7XaK	3239	3NLt3wBsHXUSEh38BLp5CShGo9rf8MLvjK3kHMMJNCjkrF5ZRN4L	1489	1380	24	1	3160	jwtMjqPwmyB2PvirFEC1cSHrF8AzYGgw5H7ES7413HYajwbV4Zf	1683	2399	2399	1616371020000	orphaned
3243	3NLWK7adyTnfiqs8d1CnAG4S3J3v9jUGx6SddtyPjrqiysXAFDJX	3241	3NLEvU9LZZxUoAkY2WqwZXoPfHoDPX3GPN6TS7Zpn47bwNnySskk	1649	1383	24	1	3161	jy1AofbqJt7PpF38nJkxpKxBYbaADqegskvovLEFVWTNUJP13Xz	1684	2400	2400	1616371200000	canonical
3245	3NKVku4UR6Q7jYyS7WYkwcwdS5gadgmmvxLwx4iNW5P1X8Kt4P59	3243	3NLWK7adyTnfiqs8d1CnAG4S3J3v9jUGx6SddtyPjrqiysXAFDJX	1500	1297	25	1	3162	jxq4unjCPfPeGe56CMyD9r5SYCo4BsxazjBWSjPf6HdgZ8bG7fg	1685	2402	2402	1616371560000	orphaned
3249	3NKim7ySbzJ1v2X9xAfDavPrKNpbijBipP4U8u4ujEFUch2xJcLJ	3248	3NLBQXsWbtPWvzkVNfcEs67ifSmKxxioiNmQ2jsp5soYiXKStjPQ	1406	1393	25	1	3166	jwzYNyHQdMGCgXVK97WQzYsQedCXsVkMQQHMgeA95BYWC9PRGPt	1687	2404	2404	1616371920000	orphaned
3254	3NLQe3fAQ3yJnCyvKAoCyq16ixawjzw26NPpmGKQMBVD5V6XHWue	3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	1406	1393	25	1	3171	jwH5KFPjHWE1xaNfyQUaPBitrmnMCTMcmJb8roNSmUx6jzaW8Jx	1691	2411	2411	1616373180000	orphaned
3259	3NLNPrL1bTTF1LETJuGA8Nku4s3v8czMYKKhZLB2wJ3YtFW2bd6U	3257	3NKTDzRYb9kL75swwoXf2SAv6rKFKbz4ckjCGJFCyLnkmfKWhtFF	1406	1393	25	1	3176	jx3zNfbDbkMSJhsnFyWhBtFYFdhDYwqFi7EKSb15dXgS4sSMVzg	1693	2413	2413	1616373540000	canonical
3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	3261	3NKwjruKS8RZT3He77QThGo1PkrWAfCKPTSLtNmCNTvREAH3SuQ8	1406	1393	25	1	3179	jxNS9ocYWWa9RXSe81M8ZaEskcmqMaT3yELApm1i9FzVduZA21J	1695	2417	2417	1616374260000	canonical
8685	3NKngkJqGAngYLeWXAMbCaDdNB8HSXGqhphiNxmYwobRDh98wU14	8610	3NKEkGjh7NYRs2kzc8pNzRyRP6BHRBNnRnk8W8kMxU4VNjgPshPo	58	1155	98	1	6301	jwyeQ3QhZ6iGnVoNPepiFm3UGMie8Pe99BNrZaC97fhmFZafH14	4333	6340	6340	1617080400000	orphaned
3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1523	1195	24	1	3142	jxFtSG4sXfEfB9Zcn2yQVLoQVVnPS3PsZwWwxwZ4PxpoBE3Bmnd	1674	2384	2384	1616368320000	canonical
3224	3NLPqWvHJejU7WtyWzDb1awDEM88Qy9pghJiQh1G2eo8KjfdHB4f	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1617	1288	24	1	3144	jxHgVt6q8rNGXTZiFGytGUbgXh5mZ68qHBDxdnJAkukfpHgFkBU	1674	2384	2384	1616368320000	orphaned
3226	3NLLMkgCtDKk8jSBaYYU7gMxqP5sWzxRF2VWsQ2hD88CNWfvsvU4	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1481	790	24	1	3145	jxERj6wqXwr56D3u4W6F3e6xyC5ZUK4BmKgj6WnEhEFXWhhzVbr	1675	2386	2386	1616368680000	canonical
3227	3NLmzAUPcFJgsVxMW9BF1s6DdHhLATCDK9nmYz7LwSUtkRFTMrUt	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1634	1205	24	1	3146	jxRqHWnGK7xqSzGq3Y577dy7UYPZmdTkfdsNFGGk4SMbM8T8K65	1675	2386	2386	1616368680000	orphaned
3228	3NKhtRqgXMJ4fTX1whWbx6mQzcvTqUGv5URGwdGCFspZQYeBjSWw	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1646	1108	24	1	3147	jxxGbW91yZEba3hKhsp4BY9ChCQk4RZd27wyL7odpUF4wYSHsEb	1675	2386	2386	1616368680000	orphaned
3229	3NKFbM9StnQGjMNprYsngtzkXBn4AGj7RHpthuqNTqp3ksPGZ4UP	3221	3NK6sZeoaHg3F5q9gkoZDjZ24YeVpPCXiACcR6K5wZDV8qDGrjYe	1634	1205	24	1	3146	jx83T37RPGX6MQ9fTyP8WTpXjwSZzex9vPQKrnmjnLNf3E86X13	1675	2386	2386	1616368680000	orphaned
3231	3NLA9d5fMtupGdo7XxhTjo4hckscD2fKVhFqAx9hjDyvUo4C6AC7	3230	3NK6t3zXPrWptpxVnKnbKUoDDpr1UhSyirXNy8QrcvnWnRBK3eW7	1509	954	24	1	3149	jy25S99TJ7PBsgLF6vnBeaqNvoP1EQYuNNC5HYQSv8KvKLjq22r	1677	2389	2389	1616369220000	canonical
3232	3NKtSVzd6SnqzrDPdhUESk3U7Gw2qp9tUwnz2sRDntfco7aHSoi5	3231	3NLA9d5fMtupGdo7XxhTjo4hckscD2fKVhFqAx9hjDyvUo4C6AC7	1406	1393	24	1	3150	jxn41kyH7DXe7zhMQTeottSryRHyGDjyqR5ru6P5nGYgJQHzKag	1678	2391	2391	1616369580000	canonical
3234	3NKLpGKcraGZLsDDcwxpP5j5SRpx8r1fVEnc6Y1kdxWzG7TbrjFw	3232	3NKtSVzd6SnqzrDPdhUESk3U7Gw2qp9tUwnz2sRDntfco7aHSoi5	1402	796	24	1	3152	jxfXS7WVUiqGoCZbYzgnEATc6Rgt64bubT2rRtmgXwob7mXvZF6	1679	2393	2393	1616369940000	canonical
3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	3234	3NKLpGKcraGZLsDDcwxpP5j5SRpx8r1fVEnc6Y1kdxWzG7TbrjFw	606	1295	24	1	3153	jxcvNGQTVcM4xck8y9S69uVYuKzqVsHHN3EzmMDGT8atSFs6zxY	1680	2394	2394	1616370120000	canonical
3238	3NKSp7HGpYPU52DTm9cmaTpK1C56C8Bpm64APcLJPpZxDkCBNxVB	3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	1578	1296	24	1	3156	jx6wGFpF9t7BRtY4Mj7JJEPq1tQbqVU85GygF2z1vG2tABFu4oc	1681	2395	2395	1616370300000	canonical
3236	3NKupiteyby5j47gMYqr6udtQ3EV1FJewHS4S9qB5x7wtGRtRNjU	3235	3NLTh2XiwyNLZHJcyjiNaDxKmCkfjcw3pJgacyNhNWAgai5GSvdC	1403	824	24	1	3154	jwFpRBvCXvwc1JYEEX9cyMK23QKimWnwJoWTNFTGkoiE3bzbEZd	1681	2395	2395	1616370300000	orphaned
3239	3NLt3wBsHXUSEh38BLp5CShGo9rf8MLvjK3kHMMJNCjkrF5ZRN4L	3238	3NKSp7HGpYPU52DTm9cmaTpK1C56C8Bpm64APcLJPpZxDkCBNxVB	1407	1395	24	1	3157	jwuMEnjB5kiMiJt1oDZr3Rp3iPtjKoWjCFS4uZegoBkwtTRucCB	1682	2398	2398	1616370840000	canonical
3241	3NLEvU9LZZxUoAkY2WqwZXoPfHoDPX3GPN6TS7Zpn47bwNnySskk	3239	3NLt3wBsHXUSEh38BLp5CShGo9rf8MLvjK3kHMMJNCjkrF5ZRN4L	1619	1029	24	1	3159	jxwonFt8YCaYnEtgUmZBGVXWWxYLK3VKvM6PBVovvfqHBT5Wsr4	1683	2399	2399	1616371020000	canonical
3244	3NLa96YFoEV2z14vca6xKGsdjib9kRDQAcPDKoA47aYQuXXqmBrR	3241	3NLEvU9LZZxUoAkY2WqwZXoPfHoDPX3GPN6TS7Zpn47bwNnySskk	1649	1383	24	1	3161	jwZo1CnBbWzvnsnEM8Rbp8DTTwo4Z9xNpjAaRGrRw4ybLmRCWi8	1684	2400	2400	1616371200000	orphaned
3246	3NLbVAN3ZZphXmjXAChKsD5egaZC71mVAW5eCJdj7iRhGg1RGRQL	3243	3NLWK7adyTnfiqs8d1CnAG4S3J3v9jUGx6SddtyPjrqiysXAFDJX	58	915	25	1	3163	jxK8ZDadKvnUow9KMrjiDVSJhL2pwBCbpY3LaqQjtFnCuoLq1jJ	1685	2402	2402	1616371560000	canonical
3248	3NLBQXsWbtPWvzkVNfcEs67ifSmKxxioiNmQ2jsp5soYiXKStjPQ	3246	3NLbVAN3ZZphXmjXAChKsD5egaZC71mVAW5eCJdj7iRhGg1RGRQL	1609	1333	25	1	3165	jxZFb6t6ri9L4t8LtziPbt9dzFfNYPv2197zXGSX5BuXwgFNe8t	1686	2403	2403	1616371740000	canonical
3250	3NLRWC3ntkUCkh8SRzSDwoiF37nE3BVMboNzYz9Rf8rGymUGDPc8	3248	3NLBQXsWbtPWvzkVNfcEs67ifSmKxxioiNmQ2jsp5soYiXKStjPQ	606	1295	25	1	3167	jwX39spLR9q8mUbkPZFeEWLLXTtArhryziyK17HMctwUfoDhw2E	1687	2404	2404	1616371920000	canonical
3251	3NKzy57hjEnTgG7anTKW2jepTyw89ciWRrUsJLvfYNCqw3TPaW8R	3250	3NLRWC3ntkUCkh8SRzSDwoiF37nE3BVMboNzYz9Rf8rGymUGDPc8	1439	1033	25	1	3168	jwfrf3S7hJvjmB4KS6DYNm57ET3Y5F2LZvknLvbp3wDDhW8BnL2	1688	2406	2406	1616372280000	canonical
3252	3NLoqpVzjYRJBHqctsgGnQf1hY3Wcg33v1oMWn2kcpZ9MVctQ3Kg	3251	3NKzy57hjEnTgG7anTKW2jepTyw89ciWRrUsJLvfYNCqw3TPaW8R	1406	1393	25	1	3169	jxfLCJLFtF25aFGFxAWaNKLkUQginhRPmN8SF8JVS4jkmuaKeoV	1689	2408	2408	1616372640000	canonical
3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	3252	3NLoqpVzjYRJBHqctsgGnQf1hY3Wcg33v1oMWn2kcpZ9MVctQ3Kg	1440	1251	25	1	3170	jw7sgtCtTnBgxASKnV7ofaJPGrYCb3WCaJciYnQWTpDdKqgDKHB	1690	2409	2409	1616372820000	canonical
3256	3NKh3Mb4vfT2n2YU2xYffUip96Jino1bv2e47eRoDAeZjnDkqxTs	3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	1534	1071	25	1	3173	jx7eUKU8EuyVhCieFo8CHSrqZNbDg7BCjtvNVwj8n4BvMhVjKCM	1691	2411	2411	1616373180000	canonical
3255	3NLyKMTfRHP6o9wzC7yMromcQm55dk4LcXsLuM5RbWsjXfEcXGkN	3253	3NKHJ7rEfbqcvaNTaZXZdzbZ72kegMvL6qMr7x7jo3wWZBM8MJyM	1489	1380	25	1	3172	jx42crHm9JmxYRhPHvF3Q9gWtukMzCDu7MoPeEoMJwJwCxnxWMZ	1691	2411	2411	1616373180000	orphaned
3257	3NKTDzRYb9kL75swwoXf2SAv6rKFKbz4ckjCGJFCyLnkmfKWhtFF	3256	3NKh3Mb4vfT2n2YU2xYffUip96Jino1bv2e47eRoDAeZjnDkqxTs	1516	1294	25	1	3174	jwUUUJQTCFBDzXAfwcBdoYY5WH5CenGzKR8tVXgyBrXS7VD5moG	1692	2412	2412	1616373360000	canonical
3258	3NKjBau2LCZ6M35L53av68BYREyN8tF3YzKScwFjg1J5npGGA9D7	3256	3NKh3Mb4vfT2n2YU2xYffUip96Jino1bv2e47eRoDAeZjnDkqxTs	1599	1041	25	1	3175	jxH8in4Y8s8RCqzzPDoWftfjoz8avdKhFenLymrD6maEfU6M9K8	1692	2412	2412	1616373360000	orphaned
3261	3NKwjruKS8RZT3He77QThGo1PkrWAfCKPTSLtNmCNTvREAH3SuQ8	3259	3NLNPrL1bTTF1LETJuGA8Nku4s3v8czMYKKhZLB2wJ3YtFW2bd6U	633	1384	25	1	3178	jxRPVquuEzbKiHc3UXarkAJPGX8JXU74v7HKBaJr4iHXiRMbLui	1694	2414	2414	1616373720000	canonical
3260	3NLgkX5HTcDxHb3d221SmjTUseEeQyWpYYnvvyMMMEUdjNJki9Lp	3259	3NLNPrL1bTTF1LETJuGA8Nku4s3v8czMYKKhZLB2wJ3YtFW2bd6U	1403	824	25	1	3177	jxPAs8srzRrZDCC7QAUm87Za6zC1GzFT5P4u1XNhGchSYzB41r7	1694	2414	2414	1616373720000	orphaned
3265	3NKvTfVb92HicFpLE2jaVAb8kH5EiPYQV9avccnc14hSv8Z53DCD	3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	1631	794	25	1	3182	jx1bskdvxiRUfjAadmwfEsnANWiXDqkgjC6rzwFyg7dpPQnBDLg	1696	2418	2418	1616374440000	canonical
3267	3NLt3kvWqV3iyn8upSx1DkTwhAe5MvjYqgHcYhtWg3Ac34eQCD3n	3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	1509	299	25	1	3184	jxzYVsutfpDAURUh5m6S3dubf9EzZar1XFPtLsmPoeZveox39Q4	1698	2420	2420	1616374800000	orphaned
8367	3NK7WSsRZxz8pE6WWWL8hsCYEjcp7hUMqzksnE5mdtLzsg8WVuev	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	1407	1395	98	1	6301	jwPkfCUg7iGSmjtWR6M4jXmsNDFBrcrUhWJqcmHtUuYZb4Rjkhd	4336	6117	6117	1617040260000	orphaned
8626	3NLikgKjgdb6yCWQVFDDuz4pe4JTQBnGfV7U6Zpvn1S4JpFnbcNg	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	349	349	98	1	6301	jxtgaRw453FzgFbD3mRBFLGAxtTFWZFiTnSNRZT22wd99mXbEC6	4336	6294	6294	1617072120000	orphaned
3282	3NLfSuVmuwES2pfEjqL9dY2bxkWE9JuzAjsJEw93p2vYkFM2mXGw	3281	3NLxJDUH9KBewfMJWBjARkT9ZgWUKbqB5u4mQ9xPR9RnA8DhfDey	1560	1045	25	1	3199	jwJdsgTuZjzdGNJLwx2U2rJ4mQVxXKMdm5j58mogzLGKtMgUxTt	1706	2435	2435	1616377500000	pending
3283	3NLmr69S3HqcNSAe66GGs7Cs6UcxWLY9YSPmLYzutvYnfYyQ3Df2	3281	3NLxJDUH9KBewfMJWBjARkT9ZgWUKbqB5u4mQ9xPR9RnA8DhfDey	1650	1129	25	1	3200	jx46aA24eCzTW9xuJpjta8DMAp9uYzyG6xEZVAb3Aufb75nqTK9	1706	2435	2435	1616377500000	pending
3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	3282	3NLfSuVmuwES2pfEjqL9dY2bxkWE9JuzAjsJEw93p2vYkFM2mXGw	1541	1052	25	1	3201	jwHiSqGgas2VrBYGiUtVsq5KFU8FquakMMpswzcsF2kf6ciVXPY	1707	2436	2436	1616377680000	pending
3285	3NLHjDm8hiLbgxtfrpxJca1YnAsYTUFmzmsHRNg6Xx58S88ictob	3282	3NLfSuVmuwES2pfEjqL9dY2bxkWE9JuzAjsJEw93p2vYkFM2mXGw	1647	846	25	1	3202	jwWmbRMGaJ6558NNQHB8rZTrdrmUjUKbRmrBwc7zhXFPsx6GgcW	1707	2436	2436	1616377680000	pending
3286	3NKtCzNjkM7gaibqxd3U7m4hFEvfSnN3ZgLQfanXfkfvTfrLjLne	3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	1642	1367	25	1	3203	jxzcrfpKXqiuhBmmrURd2K1qcqEoHUUC2bLevEATjPpK2he9Xr5	1708	2437	2437	1616377860000	pending
3287	3NLtWcb9GcspBhQhuyKdPPyypUB9ZAodz16bf9Bd2CxYQK6XPBoH	3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	298	316	25	1	3204	jwRTaHatbDdC8oYXcZsCgeW3DGnHG92AzpHA5cDN1PsABQPRjqg	1708	2437	2437	1616377860000	pending
3288	3NKGqk4sEPY7mM9WKxR1LHTxN9EKUJ9bXaM82eq3MU91MNxmWMie	3284	3NKJDcsuS7x4eSt8kGvu7NrFFzAJTvWjWKdhjXe4CPHjahbpMEwx	44	1325	25	1	3205	jxj9PSu5VQRVNEggFa96GoRCBc7EaMYUATpS7xgMSJpDtod5WnC	1708	2437	2437	1616377860000	pending
3291	3NLG3eaMHbvkcFe8Qu6HakGSMFoJZUHfQMnRX8rH3iMW8Zft9WUB	3285	3NLHjDm8hiLbgxtfrpxJca1YnAsYTUFmzmsHRNg6Xx58S88ictob	1555	1347	25	1	3208	jwvr7y7ERkE1vfnD2T9E3DHL2SBUF19nxDM25e933RwG9fKbJvr	1708	2438	2438	1616378040000	pending
3290	3NK4QFs5kzaPin8VMG5M4SPsdVHr7gY6d2dCg6ht7uDF8X5TMVUj	2809	3NLFmtPGYmsFjxdgchiQ7qgJE6pNd483bk6tKF7njRuEquc6Y8CK	1467	1376	18	1	3207	jwnGkkBABGBvZcWNPuYAryp4cfEb3WYESFX2sLHYXCn1HAViVEC	1469	2438	2438	1616378068748	orphaned
3292	3NKC5aVwbUmNLat4mpV2RDzdetk7FBUiVCoSRyH1AttLvbECzAzq	2840	3NLFAiz4mx2dryP9jrwb2N4YCjdtGCjvq7uDTUnFeZkYwGK3jcBz	1467	1376	19	1	3209	jwKVnjUKtvJdUNWc6giZakpPstyowJPUYegoLYd9uyc8MK5DfRU	1486	2438	2438	1616378096416	orphaned
3294	3NK7mJt29QSbayDzYEEPvX1z8QpYutykAxHETaxnABwYeMJt5j3Y	2871	3NKYDUc3mKaG7C84NZHmoVV24EYAzP1JdK9m1GeWbvX2YhVVkTsF	1467	1376	19	1	3211	jxwvBAhoVax4nRbmRp6XuYppf2thfeywKrdpVKkoK33AioL1pmD	1503	2438	2438	1616378123304	orphaned
3295	3NLcEGEUJD6yNrKfCYpXxwxJf7WoGB3ywPaUWeWNZcGiVGGyXtn5	2913	3NKGRMRGZNLeT88RBx5icav6AhLci8b5J7f3Sc9BuiUn5n641qPo	1467	1376	19	1	3212	jx5NyLhWpobKeQycTxGwdmYX9A76Du3fDNdy7xuTTvBVaas27XX	1519	2438	2438	1616378151316	orphaned
3270	3NLLBgVrqYwYLSVzv5LuDtaQuoaYpkPWcKySGm18EGo3a2NQ7mar	3131	3NLrPSkAekanw2RWhemJ8BhvtXdkL7d4Bza5nsXoRQ6oHr25Dkuc	1643	933	21	1	3187	jwmxvL3fD36sVA7MizJhPHANUztD4Dyzti4nqrC35DrHDiPcv1N	1568	2422	2422	1616375160000	orphaned
3263	3NKep4CKTNC9pY497pd49cAYkenTC4wTwR9JLtwTA9JxgNSSC5ZR	3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	1407	1395	25	1	3180	jxVYQNi5yMyyXtqEAm8LXhCdmuDGGdtoq6vT3ZaKV1zobVJE48A	1696	2418	2418	1616374440000	orphaned
3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	3265	3NKvTfVb92HicFpLE2jaVAb8kH5EiPYQV9avccnc14hSv8Z53DCD	1407	1395	25	1	3183	jwr3av7jFeBd5ZNgkZeDMcyACvbYn2TBkzLond6kMD1sJoHCXP3	1697	2419	2419	1616374620000	canonical
3269	3NKCU2QHt8nRsjZJMA1aqSJrPz2SZ3rFKEY5Uh42vw2Z6Jebvtqd	3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	532	937	25	1	3186	jx7AEgf8fs8DrzrqD4jjaYqZznjsWvG7Jdm7JMoYt1PfnxjkXMQ	1698	2420	2420	1616374800000	canonical
3268	3NLEGQW93t6Vu2GfouuwdPKKBJDjwdqYLcBMC9M1Qtshvro5Mtft	3266	3NKTYtL8bKCmgpe5zttT4sg36pS6buPq4XtsWfNpyzEUdoFRTgcM	298	1182	25	1	3185	jw7iF1jNWR84hg3XGq7LFJcn2NyAV9ZMLaMpxv1qty3GF15pn61	1698	2420	2420	1616374800000	orphaned
3272	3NLZC2X9VJ38f4xZrLWHD6HqVJ35Q7bUPxBkdVzgh5b46K7MSckH	3269	3NKCU2QHt8nRsjZJMA1aqSJrPz2SZ3rFKEY5Uh42vw2Z6Jebvtqd	1643	933	25	1	3189	jxXLP8Y3f5DiJzggtWvNT9fFfS2UJ4h1DM1F4kptczGCA6FThHk	1699	2422	2422	1616375160000	canonical
3271	3NLY2tf7XZpyNSRSG4JKqTgmWYKqqBbGHE5oXm3bP4imT47GYt3b	3269	3NKCU2QHt8nRsjZJMA1aqSJrPz2SZ3rFKEY5Uh42vw2Z6Jebvtqd	1627	1139	25	1	3188	jxnzp5r7zNvZbvXSg5P2xEfsDrc4yFb8dwBwEWFikagQxxh2PzH	1699	2422	2422	1616375160000	orphaned
3273	3NLA9zjAug8PbewTyjqTmpB5RRhP8YtQmFFyJmNSNut4MDYHueLU	3272	3NLZC2X9VJ38f4xZrLWHD6HqVJ35Q7bUPxBkdVzgh5b46K7MSckH	1406	1393	25	1	3190	jx8Nr1Ar2NA4bz6MVVcUPiTHYzkrvHUynmrMpuWtgqd7oUxeo96	1700	2424	2424	1616375520000	canonical
3274	3NLmh5YDu87X1Q6WUMguFNzk2uDfGzBb5pVbsHZRN7CKEE9GCmpH	3272	3NLZC2X9VJ38f4xZrLWHD6HqVJ35Q7bUPxBkdVzgh5b46K7MSckH	1600	1126	25	1	3191	jwM51xBuegSE5gVEU4rDmzhGpJEdYbL3MkLCZHGpaRXRsDCW2yf	1700	2424	2424	1616375520000	orphaned
3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	3273	3NLA9zjAug8PbewTyjqTmpB5RRhP8YtQmFFyJmNSNut4MDYHueLU	1589	1286	25	1	3192	jxZsxck7WoXZ2jYdrM6PZKg3LQoLa2PNjk7oLWPYRNT9LHbKdia	1701	2425	2425	1616375700000	canonical
3276	3NLWzeXcqsdimbcordhqmwyVEyWuRfMZTWut8Zpg87zz8XwbSACd	3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	1406	1393	25	1	3193	jxJdVdJCEF9acSr3VpXaqat8gSrAQ5kHmi3tPeNMk2N41Dkspcb	1702	2426	2426	1616375880000	canonical
3277	3NLSecrqxexWfFb1whp9FEa4Ng4yhfyDABoYyHEtw8FQQW4Y79PU	3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	1585	1000	25	1	3194	jwy9jZkzmUUbM1qiDYZTd94u69L4dBNgjzy6kqr6px6eCtpGvQt	1702	2426	2426	1616375880000	orphaned
3279	3NLnQDqUTUfbT8zZ7fUaPfMZTysYX5FqbGCk9RVoRm8cRBPwV9dq	3276	3NLWzeXcqsdimbcordhqmwyVEyWuRfMZTWut8Zpg87zz8XwbSACd	1407	1395	25	1	3196	jwYMjUyS6PPAmMAvrhWf3SKH9bAPWSjmu89SLYbobNDaV264DUC	1703	2428	2428	1616376240000	canonical
3280	3NKtfeVGEibFQyhZE9xfMcMTAsXXH8hmbD22vUJBmWetbCNSRD2u	3279	3NLnQDqUTUfbT8zZ7fUaPfMZTysYX5FqbGCk9RVoRm8cRBPwV9dq	1637	816	25	1	3197	jwmm5iPCwZNz1PZkhsXGwL658pVgYb8aUJtsnNZ2pbQnaf8xmCK	1704	2430	2430	1616376600000	canonical
3281	3NLxJDUH9KBewfMJWBjARkT9ZgWUKbqB5u4mQ9xPR9RnA8DhfDey	3280	3NKtfeVGEibFQyhZE9xfMcMTAsXXH8hmbD22vUJBmWetbCNSRD2u	1607	1222	25	1	3198	jwUAv9MC1dXF1vBtzpVG56JfvekVeB3fpa8s9LsFpp4RzL6TXQX	1705	2432	2432	1616376960000	canonical
3293	3NLVFvJzbAZhiFqD5vJsrE5GvFhRwhYervRUsyGb6Ko2stDpWFQk	3287	3NLtWcb9GcspBhQhuyKdPPyypUB9ZAodz16bf9Bd2CxYQK6XPBoH	1467	1376	25	1	3210	jxWVD1USGmjJ7UkwawyumD9ZGwrsG7X5uMVEsAhpCdCsftyG8wA	1709	2438	2438	1616378040000	canonical
3296	3NLdAqRTFaHWJgxJB8usDWkMPvTXL4xGhiz7BNjkPjGRfG7hVZBB	3293	3NLVFvJzbAZhiFqD5vJsrE5GvFhRwhYervRUsyGb6Ko2stDpWFQk	1490	908	25	1	3213	jxgLx6GyFjkJdLtkUDFVmTN4CesfwvQUnQBFajcjWRHY99N6FLD	1710	2439	2439	1616378220000	canonical
8460	3NLojLcNpymZQAHTb1dqUFd2o2L4jBaxf99eX54PeJqyFZd7E5ic	8367	3NK7WSsRZxz8pE6WWWL8hsCYEjcp7hUMqzksnE5mdtLzsg8WVuev	43	1184	98	1	6301	jwYpYicNyoKBhD9LHoVhHDJNRc3zQGk9GwshxEaJnbEHdjynx6s	4337	6174	6174	1617050520000	orphaned
3369	3NL7UcotRHMJg2kyDffy3PNH2U95JqQU7hvMpRZDqr5oW1Bp7d2W	3276	3NLWzeXcqsdimbcordhqmwyVEyWuRfMZTWut8Zpg87zz8XwbSACd	1476	1245	25	1	3286	jxs64QLJiTLcRTQ4dG3rP2buCjvVAmZs7AbSu7L2TFZRyA5SRzM	1703	2500	2500	1616389200000	orphaned
3297	3NL5ywDVK8UHjbwjzeuNhCHeKtAsYLqfjnoQFHytiEE4MJcQoVGQ	3291	3NLG3eaMHbvkcFe8Qu6HakGSMFoJZUHfQMnRX8rH3iMW8Zft9WUB	1555	981	25	1	3214	jwvqBUV5YZ24ruf8us37FQXpoBuJHC9cY4q4fWfyYxK3nXxBrts	1709	2440	2440	1616378400000	orphaned
3298	3NLpAQciRAaqPB8H9McHUrMEQFB4UmKsZNDewV3xm6YFqq3xq56t	3296	3NLdAqRTFaHWJgxJB8usDWkMPvTXL4xGhiz7BNjkPjGRfG7hVZBB	1634	1085	25	1	3215	jwomTDPYosdD9r1ykfKVZsAH8qYKN3xNcFEcYoJM7G6XQD6Pkgj	1711	2441	2441	1616378580000	canonical
3300	3NKsTnmzAuD41jfrEwWz4iSghHiZ7AhjbeBB7THPwHuyutMBUb5p	3298	3NLpAQciRAaqPB8H9McHUrMEQFB4UmKsZNDewV3xm6YFqq3xq56t	1600	1126	25	1	3217	jxRr1mQEMqsjGRwmXCUEutSYabTo11uBxWfx8v6pTsqeJHqe5VS	1712	2443	2443	1616378940000	canonical
3299	3NLNDVbKnGw4YEQB26VHwEbsRB25bqW5ECe5J7iKwHCkM44pQRNt	3298	3NLpAQciRAaqPB8H9McHUrMEQFB4UmKsZNDewV3xm6YFqq3xq56t	1403	824	25	1	3216	jwNP7JfRAp9jPyJ6HHtbr7ByfoSDwfKo2trR1YhfzF4Ngq6GAAs	1712	2443	2443	1616378940000	orphaned
3303	3NKx9ioXAPid7KwYw1GdeLamhd4d85AkhzftD27ExspSYmowpxRN	3301	3NKwJWUDdHUvYnTPCUigR95GT3fmuGy1pz1oSiheJDkXHCM5nzX3	1460	585	25	1	3220	jxqWVU6LZj4irF4R926RBLoh3QGKnH61hbNvkazCbRHN4fn2uT7	1714	2445	2445	1616379300000	canonical
3306	3NLeikLtrfrTzesuSotjGCazreqUKx9dJRtTC9uK7sEe3kF3mx3V	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	684	986	26	1	3223	jwYGY7FqmiTQ6AoZofYaV8Jirg8wDdwoeZWrE352zS1MZtCkGX5	1717	2448	2448	1616379840000	canonical
3309	3NLQFFoH2pWfonFeeVKuMuQLTpxdwDBW9ksZAJxS4B9QeLGY7Hg6	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	1631	794	26	1	3226	jwyiXfyMiRcjqqvPpe1WJCQs2yt5jHSPXNQsLJGyUT4PhAEyjKx	1717	2448	2448	1616379840000	orphaned
3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	1403	824	26	1	3229	jwAS82TyLP1qEE9q7AQszd7wUPc5qwyubsnqhkgJDFKk8gGTMVN	1719	2450	2450	1616380200000	canonical
3314	3NL7JXyvFe7qZQaMTtguKBRS8gmYSeyv7kWT7XZSbnKxSPdKJ1a4	3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	1587	1357	26	1	3231	jw9GiPWM7MhQY4Ywy5US3EkbcsJydr6Zynwz4ZNNx5Lv5j3yDxa	1719	2450	2450	1616380200000	orphaned
3315	3NLGQEyaUWNexMMnd3xoL9NC6BG6uTGGsx26mzd56Ti68EtyGcoK	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1406	1393	26	1	3232	jxrPcXDwcQYwQBui3AvfxeoYtT6Qy7jE9UVhEGQ7DtED5nCXyg9	1720	2452	2452	1616380560000	orphaned
3321	3NLeNsTViffKUjdzxno32ixW6k9aRW6woasQbN8rfxnqShjDYUwn	3319	3NKZfUeUxW1vzrTLZKmpvjASeurKSCv2KboPvYAGgtZLw3DKHZcM	1407	1395	26	1	3238	jwH9DmbyHk1rLkyxeTZwdPE6TNPFjZC6YgygpMZFUEGw6xh4Vyz	1722	2454	2454	1616380920000	canonical
3324	3NL575Ejwt17ghEAVA2vdDDgTYznpg5bjtSVL4xgDKcL5jvyPwBq	3323	3NLM6KFh1LHt9JNfRRYRTHEYBnnEUzzNiPhTdwsL37xpzFbNhyjn	1403	824	26	1	3241	jxNQSjL1k76WLEsziejXDxewJjXpGjUjnCH2qgAdHX7zSrJ17Ww	1724	2457	2457	1616381460000	orphaned
3327	3NKLkaMNr9RsgSAPsPtnX3WWVX1nQ7wrJGt1hrrbBHMUifsrwbpo	3326	3NKrLY4tFaSi9UnkpEBq87vEhmtoJGUPHidQuHVgRvi4sbGqQwpr	1403	782	26	1	3244	jwpG4AmcrrCXEx2zEPep7baJoJdDMwqTXgHEFXTr5Jqb8CaNAS3	1726	2459	2459	1616381820000	canonical
3330	3NL2revz1vt4RZVK77rbGtQ5F3Nzf937dVDJtLAKRBebhJ9uJpoA	3328	3NLmGPgQfVxv3vfpnMC31GDG5XNQKwwyVnp4S28cbdLUVPEK7bVR	1656	1343	26	1	3247	jxjwApTRpNn39DkzEfZy1vTwdy2vHnvuucgJnV7mRQ7zXEPrxWX	1728	2462	2462	1616382360000	canonical
3334	3NKJvdtN2WrUM83XyL9SBtgYu3uxyG9VkSwm7zb9yLmPG9a9wHBo	3332	3NKozBMWTU9XXTfRsFBHkAXkpWzPiT5PoA5H8e6AJH1imxymLmEV	1402	850	26	1	3251	jxjpdomoKopBMzXPexUFFnJoE9LiHFoMdqgb4trBRgL4XPdvUWQ	1730	2466	2466	1616383080000	canonical
3337	3NKAmqvW8iRLGgv48e75xezp8y13sQyVMnrPQjsr7yNjtAyfEarP	3335	3NKr97zBQ96Y4d7bkkJdvapmFcPAMwiC6bxt4sfKjYKsz9NhMKBG	1460	589	26	1	3254	jwLN6xsrSS6pVXN7Goyx23TdZNTv9pCuNNiWx6qhbS4We3NMZoT	1732	2469	2469	1616383620000	canonical
3340	3NKcNYqgfgfTbendzpadrSrPukemtWite21euFBubKt12Fq6Xs3a	3339	3NLbtWNAKu56ZAhbN3JF7UJgP1nzCmMn5KGozua39cFAwjzxoJju	1571	1335	26	1	3257	jwT3XtZPqXH5oJYrfLxFhucxVLR3kVYvvgzR3AZS9Er9XddcPQ2	1735	2474	2474	1616384520000	orphaned
3343	3NKHEgmnavCGNb1thMpF8WSoCbvQeo4ZkdZCP9hfjfHkf8b4BsYV	3341	3NKxTGqrJMDBQ19W3L9bDq4JbKDBaiZtwQwg9fwD1WyYtwYXgM6c	1637	816	26	1	3260	jwNLtMxaWVEayD2MrUngdDMVzd5L8bWfnh9xtww9cAUpbgoYNws	1736	2476	2476	1616384880000	canonical
3349	3NLC2wJfBydFKYTcFdr3mpUczoAZwvSPMcHDZhQ6uvKjUTzJq4tk	3347	3NKPANhmngCiKZC6CaTbStksy6Lu3qCJRweXmU6F89eBFHNCWtLd	1617	1042	27	1	3266	jwKBxffc3b4Q2dYcbSsEhk5fEihvka5rkLxnwzmHm7vWLUPzh57	1740	2480	2480	1616385600000	canonical
3352	3NK9yr3jJuKEBPEmwnEnBxNCzohnAXQQW2WcrXbCGgnSFVs3kZi9	3349	3NLC2wJfBydFKYTcFdr3mpUczoAZwvSPMcHDZhQ6uvKjUTzJq4tk	1637	816	27	1	3269	jwQA9UJULv737dyv8Yoo5QQiFLbjBVK9w4FtVYKo9RrCuajtfEn	1741	2482	2482	1616385960000	canonical
3351	3NKghhLGwBKDEX2jAxE8j5iPmHkXAd4Nf2iGyJgFVLYkwhaHArwT	3349	3NLC2wJfBydFKYTcFdr3mpUczoAZwvSPMcHDZhQ6uvKjUTzJq4tk	1631	794	27	1	3268	jxRaD1Xafra7qPpv8mK5KdXaVMfY4ZN8deSv9CxxFpQo3e9xvjw	1741	2481	2481	1616385780000	orphaned
3355	3NKAPVG6X9t9FniGcaiP361dsKfcTtrXtaNtXmAHcgSKREQacfvY	3353	3NLEoLbzrRTpYbNxeWad2ztqmNNzn18CXzhgoAiwre3kv5am8Swc	1670	1156	27	1	3272	jwZ1JGPHXKFZePSfKcBDCQXiPM8y5x2bBZwVsYZH2SscntaH4KB	1743	2486	2486	1616386680000	orphaned
3361	3NLt5ivkq2wNkaowSG9Cq6mkHSWMba7DEejJwvNvWF7HiwiUHkEV	3360	3NKoPsCBSzohmL61ty2FxcrHM3D2NhY4BHzQ5Jj2DHz1NodvajTH	1613	1349	27	1	3278	jwfX89RWEP6sY4WxVEt5QcPocTKgKCBUGc9rv3WwFeiszMQ5A74	1747	2492	2492	1616387760000	canonical
3364	3NKXSL2DGbbm4yceC8UPVVHsYdy7MmkEMDqGeZuBomBj1GY6yCXB	3362	3NLB6KXN5dmNvTe6JuJp4ihRn3QFhHiC9m4BrksshBAkCeAT2mrE	1637	815	27	1	3281	jwrFM9XWYfEQA11jFuPXaPA1qvvi7izaBMqpWNTqJYAr9gzGcaH	1749	2494	2494	1616388120000	orphaned
3367	3NKMqxmiEi8XjkWZRHeYBrHRYs5os4m9QPNVLipngwvKqzEE6zYy	3366	3NLPBJfSjfRkdWpt8D3uoe8dK9Bj25Q3brVNfq6TSXRT8q9kuPWV	1653	491	27	1	3284	jwiAFqJrM3GYik1m77JpnodqYecciofU9oqJ8fc2FPCxT62zra6	1752	2498	2498	1616388840000	canonical
3370	3NLpfwxXSR9MEDveJaAMrtYciv7UUB9Rn2oXdbRDV6ZW8Up4R3XG	3367	3NKMqxmiEi8XjkWZRHeYBrHRYs5os4m9QPNVLipngwvKqzEE6zYy	1476	1245	27	1	3287	jwWVtVwQHv9wEq8yVAyugMLeYqE6u6PxBB5sHncnoJXYYUyeqkc	1753	2500	2500	1616389200000	canonical
3373	3NL7WaCV4eN9fe7cvnQKVajmLwHPQbpANhtUY1oxoxWjzn9YABCU	3372	3NKnjDxZ5CHkfGCPWqwN1REPaZk4GMbsj9JfDcRWKatqxbSD9A3u	1405	873	27	1	3290	jwDekESfJuNijrLnqoB4QGqWJ3ydAUbN8yJjj54JfmBF5sWYaz8	1755	2505	2505	1616390100000	canonical
3379	3NKH7dsobFaYHXj4ZceYv5ivvPppzcS9fdToThhE8bwjnUvgLKxp	3378	3NKvYFCR2gPk83ZbxGPKe6zzQYDJvHmVBQfMoRJyrYb4jw4eVfVL	1594	1326	27	1	3296	jwqLSurGNznuEV82WSUWdF2RA6ConaRWH942CytbQZqp4uveiZp	1758	2509	2509	1616390820000	canonical
8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	8391	3NKF78nrvxw9QxVckYfkwatWXyyLMNHFWwD47QXdgkWNexQXc9Sf	55	509	99	1	6301	jwwhYv6ffirDr9ZtsiXRvHYoWQDVgnpQEsi8TbfPYASe8DyqA5N	4349	6135	6135	1617043500000	canonical
3356	3NL93cnZ4QMs4Ypx3A7mngJvSzV9AHTSPAh7vs3bXMt5WoLQUEDP	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1458	1323	23	1	3273	jxbh68qQWM2ciVM3aoc325crm6TSeB7NpRfZDAU45v6MspDczVm	1648	2487	2487	1616386860000	orphaned
3331	3NLXwemPCTXJC3j5JekbRetJJGdY5HuM8fHVXMkDAMREeU1ExqpY	3286	3NKtCzNjkM7gaibqxd3U7m4hFEvfSnN3ZgLQfanXfkfvTfrLjLne	1513	1133	25	1	3248	jxi6mbUH9PCkfwpEN1mDWMM7eqBESMcreHu2TfxiZXDvLANCf2U	1709	2463	2463	1616382540000	orphaned
3301	3NKwJWUDdHUvYnTPCUigR95GT3fmuGy1pz1oSiheJDkXHCM5nzX3	3300	3NKsTnmzAuD41jfrEwWz4iSghHiZ7AhjbeBB7THPwHuyutMBUb5p	1397	838	25	1	3218	jwn6Lpe5i8xvYVNHEmzb37Ng11e1fqR1vMRj4b4DDGnVCXLz6q2	1713	2444	2444	1616379120000	canonical
3304	3NKxRZPxN24sZnoeRerfgcc4LFASSUgfzg7x74ssV6dd1QLQozYY	3303	3NKx9ioXAPid7KwYw1GdeLamhd4d85AkhzftD27ExspSYmowpxRN	1401	4	25	1	3221	jwJx1vrMvfCkMuPnyVVdBvZKMAgPSrWGdUMGpoDxTwwzjQc5pCS	1715	2446	2446	1616379480000	canonical
3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	3306	3NLeikLtrfrTzesuSotjGCazreqUKx9dJRtTC9uK7sEe3kF3mx3V	1407	1395	26	1	3227	jxNTKJ1DPKxKBGhbBswNfPQ1jj9H29SQjDNKpjbD4WrJENtWYFz	1718	2449	2449	1616380020000	canonical
3317	3NLrs1fsvPGNKg83CufuqMoxVEHCnPvqC2uhCeKNyHbG1in8pR3K	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1407	1395	26	1	3234	jxUuqsTSD9NLwmDu6AhKtmhDEb8fcLr5HqKe8wHjtkykD1kFFZT	1720	2452	2452	1616380560000	canonical
3319	3NKZfUeUxW1vzrTLZKmpvjASeurKSCv2KboPvYAGgtZLw3DKHZcM	3317	3NLrs1fsvPGNKg83CufuqMoxVEHCnPvqC2uhCeKNyHbG1in8pR3K	42	1361	26	1	3236	jwzFfa7QpZoLyijwRek9ECWRam79xEHYX4pPK2LcKA5pQUKyhLR	1721	2453	2453	1616380740000	canonical
3322	3NLEdP952T7ZzNEkoazFetfhSxkKh1HXwaUvf4aHYf18i8zc3Nzu	3321	3NLeNsTViffKUjdzxno32ixW6k9aRW6woasQbN8rfxnqShjDYUwn	1578	1296	26	1	3239	jwoPryubvkWfSUXswPseGM7kN7SQWKJYYqzEfK5fHRpGtW2N8WT	1723	2456	2456	1616381280000	orphaned
3328	3NLmGPgQfVxv3vfpnMC31GDG5XNQKwwyVnp4S28cbdLUVPEK7bVR	3327	3NKLkaMNr9RsgSAPsPtnX3WWVX1nQ7wrJGt1hrrbBHMUifsrwbpo	1405	867	26	1	3245	jxHiX1X1w5HytA4r88nFxTCysAW15N8oYHzocvH93Tk4A37Vfxi	1727	2460	2460	1616382000000	canonical
3332	3NKozBMWTU9XXTfRsFBHkAXkpWzPiT5PoA5H8e6AJH1imxymLmEV	3330	3NL2revz1vt4RZVK77rbGtQ5F3Nzf937dVDJtLAKRBebhJ9uJpoA	1642	1367	26	1	3249	jxWiKsRsqe3CxXDsDi1ZyyM1M7K4okg2w7VowWVWGWYZWzRX8BM	1729	2464	2464	1616382720000	canonical
3335	3NKr97zBQ96Y4d7bkkJdvapmFcPAMwiC6bxt4sfKjYKsz9NhMKBG	3334	3NKJvdtN2WrUM83XyL9SBtgYu3uxyG9VkSwm7zb9yLmPG9a9wHBo	1406	1393	26	1	3252	jwPYhZgzViKazFB2Pdwe1WmXVnkQGGQSmyXXsirF5dTSSUyVqqe	1731	2467	2467	1616383260000	canonical
3338	3NKYEqTKGxHRtnDywmJPvdotk7T5DBuDtVBdVM4R7t7XpsShV9gd	3337	3NKAmqvW8iRLGgv48e75xezp8y13sQyVMnrPQjsr7yNjtAyfEarP	1407	1395	26	1	3255	jwoevpkDatFBkQCSZybRwgwRtw1KbhuEXkwGb2cctRCcgUvmtCW	1733	2470	2470	1616383800000	canonical
3341	3NKxTGqrJMDBQ19W3L9bDq4JbKDBaiZtwQwg9fwD1WyYtwYXgM6c	3339	3NLbtWNAKu56ZAhbN3JF7UJgP1nzCmMn5KGozua39cFAwjzxoJju	1553	776	26	1	3258	jxDMXLYnW3atqpm4bsY4NqLA9fahDjrLXKLrLjAgWdrSybiRAaL	1735	2474	2474	1616384520000	canonical
3344	3NKcoJNEi8pzJQjPnZ6bEYfPfWEjB5Z49R1vbmB8q3Qr8tqfJ7co	3343	3NKHEgmnavCGNb1thMpF8WSoCbvQeo4ZkdZCP9hfjfHkf8b4BsYV	1509	1320	26	1	3261	jwpzBi6wZLh5SQ21pbtzmXcBDuXsS7EBp6JYpMakfqghQtg5e19	1737	2477	2477	1616385060000	canonical
3346	3NLGjpvveZhBFgeMTmoUJLZjjoX2Ugq2wmcJWprq4PZ38ZdkHmqx	3344	3NKcoJNEi8pzJQjPnZ6bEYfPfWEjB5Z49R1vbmB8q3Qr8tqfJ7co	1516	928	26	1	3263	jxoj7r2b2o95dv3pdoPRQN98YSGJNdQM25p3wUHHAXd3VBpgrPe	1738	2478	2478	1616385240000	canonical
3347	3NKPANhmngCiKZC6CaTbStksy6Lu3qCJRweXmU6F89eBFHNCWtLd	3346	3NLGjpvveZhBFgeMTmoUJLZjjoX2Ugq2wmcJWprq4PZ38ZdkHmqx	1607	1348	27	1	3264	jxG54GWPaQqnPgUz5jq8fE3kBz3ymaUDYfPnrtPrih1k8Z7M7bh	1739	2479	2479	1616385420000	canonical
3353	3NLEoLbzrRTpYbNxeWad2ztqmNNzn18CXzhgoAiwre3kv5am8Swc	3352	3NK9yr3jJuKEBPEmwnEnBxNCzohnAXQQW2WcrXbCGgnSFVs3kZi9	1504	113	27	1	3270	jxWsCUTjRNsivYjL8WCGw5BBKh35ZXpjrg3nJRkuDukzAhgLtYK	1742	2484	2484	1616386320000	canonical
3358	3NKmjVu3BuCTqZptcy3SHinRuVVvA9AboFNENQ5KAyyK1WbxMGdh	3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	1458	1323	27	1	3275	jxEBQGX5kwCdqaP8AkHLKzEdDxFbVTRVySY6rbkwndfme1P3bw4	1744	2487	2487	1616386860000	orphaned
3359	3NK9cVYCWZoR8NBt7gDsHypUwMc9evmN84dN5LBRgv6NQn2sm4TQ	3357	3NKbvChF886jw9k3NtrNNLrKenaQB5gCm9DCfWhXwq284hMAVg1t	1631	794	27	1	3276	jwNYa3tAT4aDX29abVgdM4KyALXkc65zUyYtcjGCia34DpurskT	1745	2488	2488	1616387040000	canonical
3362	3NLB6KXN5dmNvTe6JuJp4ihRn3QFhHiC9m4BrksshBAkCeAT2mrE	3361	3NLt5ivkq2wNkaowSG9Cq6mkHSWMba7DEejJwvNvWF7HiwiUHkEV	1406	1393	27	1	3279	jwSGrjL9hw8SdtVz8NAxwqr5KmUvM5oF8im5Dkece8dTXPw59Yg	1748	2493	2493	1616387940000	canonical
3365	3NLMVMgPsMD8phz9Qq6JCiC1sAhEFhPZvsPHboDT9CowUE681SVt	3363	3NKZa4AykbtJziwhKSqB7ZJshMV27vYU7FtDTk2XQwdtYKAUhJd1	1656	977	27	1	3282	jwjbThCL4c3UcYwxo7UprqV4oKyTGJL7WMnygh13DTjgZJyGAK2	1750	2496	2496	1616388480000	canonical
3368	3NLUVS3nmeK8XXsY4AtRvuamseqtELNJ1ign9QDuxyw27s98ieD7	3367	3NKMqxmiEi8XjkWZRHeYBrHRYs5os4m9QPNVLipngwvKqzEE6zYy	1581	778	27	1	3285	jxBNrKhMkvJw9Pu1qPWHYtHHhzeSHb63FZFsMqYdz8s2KEK4drv	1753	2500	2500	1616389200000	orphaned
3371	3NLmfkiuWn88haRJo7AKMS5T5Jm9H9QBrTmwZECJDs1qhY5n396j	3370	3NLpfwxXSR9MEDveJaAMrtYciv7UUB9Rn2oXdbRDV6ZW8Up4R3XG	1406	1393	27	1	3288	jxUPrhviN2aJcCEuzwuRw2KFiUomz81pkCb38WWRDLmr3yhnSrH	1754	2501	2501	1616389380000	orphaned
3374	3NLH18Y79dvi5aREpjK2RcUdwiBUJ65p12qPBRPW3ubtF4qQy5gB	3373	3NL7WaCV4eN9fe7cvnQKVajmLwHPQbpANhtUY1oxoxWjzn9YABCU	1471	1140	27	1	3291	jx94KfBRiSnLMQT2vZHmXRVZZMkByVDeCbSRQ7u1qBVJWnXxJoj	1756	2507	2507	1616390460000	canonical
3377	3NKBj4mLpVzar3dME1cYMjz8onv7d5Q2cdyYu8mz6ebu2bz75TiX	3374	3NLH18Y79dvi5aREpjK2RcUdwiBUJ65p12qPBRPW3ubtF4qQy5gB	1527	927	27	1	3294	jwcK3GosJtdv4paLwSEoq1tHXQPUQB7j2DeU86K5oEgXXTF8RjJ	1757	2508	2508	1616390640000	orphaned
3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	3379	3NKH7dsobFaYHXj4ZceYv5ivvPppzcS9fdToThhE8bwjnUvgLKxp	1405	889	27	1	3297	jxNFsdwi724nTPHH3yb2i7V3esjjGDNVMmv7GSFhpeGB2uLfMin	1759	2510	2510	1616391000000	canonical
3382	3NLvyDSMQ64w3YG6tFTtY64Jpkg7aowfzGbFLEL1NrwivX5gw8c8	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1588	1146	27	1	3299	jwkz8YybWus6cBfYo9yAZXqtA11Qn7w4WKyuL7Xcsd9oPNQezhp	1760	2511	2511	1616391180000	orphaned
3386	3NK4jn3eEKu6Qsw4GaD4BSi7fBGLFWVLAhSJMZNeLKQzdBypVAXX	3384	3NLxmWRaw5SoFH277fNbSnFGjSnXjBPZUGTm5VNo7354UzkjXkLp	1406	1393	27	1	3302	jxRSwHSvEm4yV66HEsns2MR1hQ82hDAyXfnzfPcWMAir4sS2PuH	1761	2512	2512	1616391360000	canonical
3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	3387	3NL128JTdSaUVHKzZxNJvBpru4SPk36g85UxsPcqizfcYDuTcNwD	1402	866	27	1	3304	jwgSSE1cvxkiXFdnGxdsjYFH4Zxjtjp93Uayjihz4ACocPncqu7	1763	2514	2514	1616391720000	canonical
8395	3NLfciqZvwRZbF7vJeZaXMK3CdbvSPAkeMz4hT1H5kRmAew4ihPp	8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	1402	796	99	1	6301	jxTSR6TVMJcuwku2WLQNLJAyJFHkQmg49vSD2f8gsgqRjeZiHmx	4350	6136	6136	1617043680000	orphaned
3302	3NL9Q2LPfQ74rwmYavQ3rQKVzABTAG9PZ4iJtunVUV13KwX6Gs6s	3300	3NKsTnmzAuD41jfrEwWz4iSghHiZ7AhjbeBB7THPwHuyutMBUb5p	298	1308	25	1	3219	jxW7tGxPGtQY4VeNFVwePEvK5hKuyFJ85NR3B7Jb9YhTKNDDbZt	1713	2444	2444	1616379120000	orphaned
3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	3304	3NKxRZPxN24sZnoeRerfgcc4LFASSUgfzg7x74ssV6dd1QLQozYY	1406	1393	26	1	3222	jwD3A8pjvsWnCH8MZq6yw6QcBaYJjHNXyBp7qQPXiU68JQyHx9e	1716	2447	2447	1616379660000	canonical
3307	3NK7VKpb2f8RBDA4je9GzquvpGp7ziBaumfhE4enXsLULPgNkjpA	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	1460	637	26	1	3224	jwUZsLvqgvqCdnVLf2DbZoznoz2mwAyqBaMibiSV2F87eaDGM2n	1717	2448	2448	1616379840000	orphaned
3313	3NLNn3HsQmdcPddLxNwiDXDRxBPrEB1w2pVinC55QuNjnvvvCGZd	3310	3NLunqVRbHwQCDdVfgtBRmCpLAPvuMCMeasriMTWjrSuhfiKGcUR	1489	1134	26	1	3230	jxb7zryjAwXfaisKw2AQHWYrq5Xij7Dq4h7ZCss8wHPSq68gL6m	1719	2450	2450	1616380200000	orphaned
3316	3NKXk8yMfZrQ8sbf8NRRmo4rakqQmudu2qWZRrRyqSmzhghjeniz	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1403	782	26	1	3233	jwwSRqRGtDj63GznQ62k7PxZVDVAKzu6KSDNbNSRaP2bSj5o35e	1720	2452	2452	1616380560000	orphaned
3318	3NL4c4H6k819kEnQFjpdz39K7TazTmqGrtenDrwY814vFZnQedjW	3312	3NK3insGNbePK1DR7sN9zAwRYVspjdUWz217dxnFNBnhSsQuaCcJ	1483	910	26	1	3235	jxcD3mwBpookFY3gso7ucRVCxwwfQoGWTjmgLDHRNSrqE8vtBGU	1720	2452	2452	1616380560000	orphaned
3320	3NLfjVistpYvjYaa6waTq3n8GMnxCQTBER7rS7vAVWCF9rdRws7J	3317	3NLrs1fsvPGNKg83CufuqMoxVEHCnPvqC2uhCeKNyHbG1in8pR3K	1599	1287	26	1	3237	jwNFwH8K7jxyLrGEgAoxavdc3QiESPTHzAdGswmCGmz1ae2eqbh	1721	2453	2453	1616380740000	orphaned
3323	3NLM6KFh1LHt9JNfRRYRTHEYBnnEUzzNiPhTdwsL37xpzFbNhyjn	3321	3NLeNsTViffKUjdzxno32ixW6k9aRW6woasQbN8rfxnqShjDYUwn	1637	816	26	1	3240	jwBrHp8kxev5v3ggrQRFfHG9UNt1YnWtvocQVoHSpdAoHcNjdJM	1723	2456	2456	1616381280000	canonical
3329	3NKr2x8PU62w2DzFqQ6AxAWu6TGKWcEqjNfEnhkyAayTxAXjAxPA	3322	3NLEdP952T7ZzNEkoazFetfhSxkKh1HXwaUvf4aHYf18i8zc3Nzu	1440	1377	26	1	3246	jwM3anRnBHkeb6kuicG7HyWcEW1DbGySbJyrKGGbeVssZLm9vA3	1724	2461	2461	1616382180000	orphaned
3326	3NKrLY4tFaSi9UnkpEBq87vEhmtoJGUPHidQuHVgRvi4sbGqQwpr	3325	3NLXMKAtzi99rZa4A6FPY5Qz9VgNphzyFkcqoT1VXyibMZve8rr1	1406	1393	26	1	3243	jxr8P9iN7JHr73LJBZHgDjXfDbNN67T2MyUAYFBH48o8nbotTCh	1725	2458	2458	1616381640000	canonical
3333	3NLSbH5yoSQMmBEMaqBX7GFcwrGd8ASoMXVCSKo6KhxDGLBnx7ME	3330	3NL2revz1vt4RZVK77rbGtQ5F3Nzf937dVDJtLAKRBebhJ9uJpoA	532	1303	26	1	3250	jw8v77ou6Kipjkj5EQajDB43WbNwBZf2cH6TGGBbHdHqDa853xY	1729	2464	2464	1616382720000	orphaned
3336	3NLU8bpYk2cVuBuaY1diMjS1bQtRbcaNkpLek5FaSB2NRLPE1pBy	3335	3NKr97zBQ96Y4d7bkkJdvapmFcPAMwiC6bxt4sfKjYKsz9NhMKBG	1444	1135	26	1	3253	jw7Qi4yhYa73CaLZiNoZ2ZyESmkDsfBZJez5K4MBMwqK4uCkrZY	1732	2469	2469	1616383620000	orphaned
3339	3NLbtWNAKu56ZAhbN3JF7UJgP1nzCmMn5KGozua39cFAwjzxoJju	3338	3NKYEqTKGxHRtnDywmJPvdotk7T5DBuDtVBdVM4R7t7XpsShV9gd	1406	1393	26	1	3256	jxpgM7eAtrfRKyfQmYJeAzpBne6udpLB3MJEr1dphbeH4mxQ8HK	1734	2473	2473	1616384340000	canonical
3342	3NKz3f63KHDWXPUhouTF2VdNitkscdKfFkod627dh1xrSzvspzGz	3341	3NKxTGqrJMDBQ19W3L9bDq4JbKDBaiZtwQwg9fwD1WyYtwYXgM6c	1522	956	26	1	3259	jxrdRVXTjuhTMypxDsF4PFTbAwQmQeShxg6yXarFJa2Snt1NnuG	1736	2476	2476	1616384880000	orphaned
3345	3NLdW5YamTVUSHnVQM6EMB8XMRc48gP3zFfLcUgoPeirmXRpq2hL	3344	3NKcoJNEi8pzJQjPnZ6bEYfPfWEjB5Z49R1vbmB8q3Qr8tqfJ7co	1457	1391	26	1	3262	jx3sbL6my6o8izEngmy7ymp5Y2JitAWpwEU6t6QehLZSkCpfJLy	1738	2478	2478	1616385240000	orphaned
3348	3NLqso4UXxbhNC3sPEThDho45ZeMncTBgHm7i2j3W2HCvCUUbUR2	3347	3NKPANhmngCiKZC6CaTbStksy6Lu3qCJRweXmU6F89eBFHNCWtLd	563	1233	27	1	3265	jwgfZ6HiYuFxSYYbWGAvR8fTX5E5iAfNECbxy2zh342k3BYr22g	1740	2480	2480	1616385600000	orphaned
3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	3353	3NLEoLbzrRTpYbNxeWad2ztqmNNzn18CXzhgoAiwre3kv5am8Swc	1406	1393	27	1	3271	jwnK2M3zUaFtKwUGE6s24YWF6rqAyY1JRwvp3DpVpHQtfDd8G3G	1743	2486	2486	1616386680000	canonical
3357	3NKbvChF886jw9k3NtrNNLrKenaQB5gCm9DCfWhXwq284hMAVg1t	3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	1402	796	27	1	3274	jwtwSE1CP6HerFFHpKroM5H76omHGf8u3TtKmHdFntkLZ3iniU1	1744	2487	2487	1616386860000	canonical
3389	3NKjcKQGL1GjhsRZEMvv1HMYDotAcFopdYf2cg8HNRBANCFrobhe	3354	3NLUjhbr8pHmkpFYTeTqHc4njQxA8hggkBWXKDSfZyH7BxbmRZ5Q	1523	955	27	1	3305	jwZuncW73SfTNTMtXT7EEoKwoV1hQBD2wtonXuM3Bdcoe67ZJBK	1744	2515	2515	1616391900000	orphaned
3360	3NKoPsCBSzohmL61ty2FxcrHM3D2NhY4BHzQ5Jj2DHz1NodvajTH	3359	3NK9cVYCWZoR8NBt7gDsHypUwMc9evmN84dN5LBRgv6NQn2sm4TQ	1419	814	27	1	3277	jwjY27Wx3hk6rDCkkbm2xo6U2JNQ8mW3catpHfDuwzBDimknXPp	1746	2490	2490	1616387400000	canonical
3363	3NKZa4AykbtJziwhKSqB7ZJshMV27vYU7FtDTk2XQwdtYKAUhJd1	3362	3NLB6KXN5dmNvTe6JuJp4ihRn3QFhHiC9m4BrksshBAkCeAT2mrE	1594	1326	27	1	3280	jxC5Nso22W2hGAfqNZEz6sFaNrMqXCbyDqqzNVvKpTH3YVYfwDb	1749	2494	2494	1616388120000	canonical
3366	3NLPBJfSjfRkdWpt8D3uoe8dK9Bj25Q3brVNfq6TSXRT8q9kuPWV	3365	3NLMVMgPsMD8phz9Qq6JCiC1sAhEFhPZvsPHboDT9CowUE681SVt	149	1283	27	1	3283	jwdmXLTZwUXP1fTSZ83nqm16nHgQfc71nUbGjJnMapRX5BBxyNk	1751	2497	2497	1616388660000	canonical
3372	3NKnjDxZ5CHkfGCPWqwN1REPaZk4GMbsj9JfDcRWKatqxbSD9A3u	3370	3NLpfwxXSR9MEDveJaAMrtYciv7UUB9Rn2oXdbRDV6ZW8Up4R3XG	1581	778	27	1	3289	jwmhiuoztFxpHiYDTxddp5H1K5ng2JKopaoJgCVPXRXcMTGZmDn	1754	2501	2501	1616389380000	canonical
3375	3NLd6Gb9dJMAWCmyPokxYRC8zmdy7qHqkLF9GY7C4oYU7wFM5AhA	3373	3NL7WaCV4eN9fe7cvnQKVajmLwHPQbpANhtUY1oxoxWjzn9YABCU	1594	1326	27	1	3292	jx45yky9MP9eq4d3CVpvbx2Fr2WtrKRo4Cma6EE1btYGj5hR5Yd	1756	2507	2507	1616390460000	orphaned
3378	3NKvYFCR2gPk83ZbxGPKe6zzQYDJvHmVBQfMoRJyrYb4jw4eVfVL	3374	3NLH18Y79dvi5aREpjK2RcUdwiBUJ65p12qPBRPW3ubtF4qQy5gB	484	1319	27	1	3295	jxTw9L2acGgiiRVbUgmDcgupuXU7PQVxLfdo6Lt1S9XXK3f81we	1757	2508	2508	1616390640000	canonical
3384	3NLxmWRaw5SoFH277fNbSnFGjSnXjBPZUGTm5VNo7354UzkjXkLp	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1509	1320	27	1	3301	jxXaUWcW8PEufNbEpE16RM11FYnYXopH2HFpQx1V3XsVSYZWZiz	1760	2511	2511	1616391180000	canonical
3383	3NKCgC6o2LRQExXJK7KhN3QKGMFgYw8hQYdpDr7V9nAKL7EkgBNd	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1483	504	27	1	3300	jwUM74YBZzKhn3ojWgoq6NVj84u1LksaEDcvU7G1hYqJN7ctJaL	1760	2511	2511	1616391180000	orphaned
3387	3NL128JTdSaUVHKzZxNJvBpru4SPk36g85UxsPcqizfcYDuTcNwD	3386	3NK4jn3eEKu6Qsw4GaD4BSi7fBGLFWVLAhSJMZNeLKQzdBypVAXX	1670	1282	27	1	3303	jx1mzbaD4Yiar7Wz5JP1gVv8whY8LSQFcUGj9ZMxn9tSULBrNyA	1762	2513	2513	1616391540000	canonical
3392	3NKwnnJDdf1Mhym9MrBxUPFLy28eViE6aER3931gTQZsvDrgmuRg	3390	3NKAE2L8GmMJp7GiJamD1qExvmuTCcudc8n3Pxm1Cxe2AT3wUkcw	1444	1015	27	1	3307	jxBGv3fCF55YLKSGSrwqykDxagGp6TR8pWunntowJ8fZdK99CSZ	1765	2516	2516	1616392080000	canonical
8403	3NKUiksJYi2sZcN2yiwoyQC5LquVuxiUdewWEsuFLqo42C3bFhfj	8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	1624	1334	99	1	6301	jx7B3uFDw6bBEgzbpjR6fq8u3uKrjY8RVD5sf9wexWZrAAgQyDx	4354	6140	6140	1617044400000	orphaned
3390	3NKAE2L8GmMJp7GiJamD1qExvmuTCcudc8n3Pxm1Cxe2AT3wUkcw	3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	1523	955	27	1	3306	jxn4n3Nfykf9Fvo9iwQDm9kZhTv8zVTzkJXq5HL8K5nkHNruNh6	1764	2515	2515	1616391900000	canonical
3391	3NKzJ2XgZKvRcNvMztcFrn34o8Unmig9MPnUwbtxZUzFsFCf1yaA	3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	1523	955	27	1	3306	jxQsPmg9VindpAwcu7FS39nefwTb8xZeTYxFaWwBy1BYCqNQhXG	1764	2515	2515	1616391900000	orphaned
3394	3NLWqWiREt58YNYgqFAPRUdmGcJi3ScLiCv4ihThD6ataX3rN16d	3392	3NKwnnJDdf1Mhym9MrBxUPFLy28eViE6aER3931gTQZsvDrgmuRg	1522	1322	27	1	3309	jxuqMpU3DJ3nEXaT6A26zAmD83dJTBjiozsyMVuZBumAzqV8Ggz	1766	2517	2517	1616392260000	canonical
3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	3394	3NLWqWiREt58YNYgqFAPRUdmGcJi3ScLiCv4ihThD6ataX3rN16d	80	907	27	1	3311	jx8xt3A6T9qJRZs25D7Z6PvaevXp2u4FKmPzZRHhBzxVMsybh9a	1767	2518	2518	1616392440000	canonical
3397	3NKdE4D1J6nfS2po1g9ctykoVXp6UmRK6nL4bZ3okwe7F1GjQXr1	3394	3NLWqWiREt58YNYgqFAPRUdmGcJi3ScLiCv4ihThD6ataX3rN16d	1581	778	27	1	3312	jwxmdKj1ma3f6146tLxoZQXwKwqbubAHQmrcpya1ZFdTV16Ug9k	1767	2518	2518	1616392440000	orphaned
3399	3NL8PJzuGwkfgt5BtT6wvjf8FLPXU3p3vng8ETyWH7djUvhfj5aY	3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	369	1186	27	1	3314	jwxWUqrcpgR3B9zyzoQPWa9odovgX1rPkmB49ub2XHpiw7wTGuF	1768	2519	2519	1616392620000	canonical
3403	3NKzGa6VhSKm6pkV7GJQunTXv5YU431ZZdmEuKzwkQYS8jg3RvQG	3399	3NL8PJzuGwkfgt5BtT6wvjf8FLPXU3p3vng8ETyWH7djUvhfj5aY	1419	814	27	1	3318	jwMnZvUFdFE3XVb42T7xiEsjVpZDoHmdU1N4MFKdfRapdhkS254	1769	2520	2520	1616392800000	canonical
3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	3405	3NLo1T6RAg1PG1LgNue34iQbyBhTQcQAXXFr1L5cq59FgXfef5UX	1483	1150	27	1	3321	jwYiXp1nc4DDk6K95h1MirgGhyEBxSvDcexHJQu9uvZiEHbKbJJ	1772	2523	2523	1616393340000	canonical
3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	3414	3NKmjdgspyi3RHxFmBPS1asXsS1fPXT4x7YNWWT9FopceLtCA4Sx	1406	1393	28	1	3328	jwdCTsopDznAyiUjq5bRFiFWomAXyJDFd5Fh87U7vcSsEC2Ryym	1776	2527	2527	1616394060000	canonical
3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	3419	3NLaydvmYPHxFbZjNWYqrAftT8MWqxahTa9qAnmWAhrERSyKbfLC	1559	1353	28	1	3334	jxhnJMdRQ67u65JCwG7WNhbiG4uSKcWU5vDk5Cdr2kmJPqMYmny	1778	2530	2530	1616394600000	canonical
3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	1483	421	28	1	3335	jwn3EosjvoqQxjyws86c9kpUbwY63m18v13fw1VmtEf695v4CoY	1779	2531	2531	1616394780000	canonical
3426	3NLmkuMxNoBKHSsDtG88QEbkb1Cug25bKFNrxSet18gTsi7QAqug	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1624	1088	28	1	3338	jxPng4vXRajv5pJc7mcVg87scrEkREcYaUzaZDsgNUu3naG6KpJ	1780	2533	2533	1616395140000	orphaned
3429	3NL44beFgMb9cepT2DNNd4aQAXgiJhKuq2r4KX4XRNbuUgbFmQPG	3427	3NKFJFa7EGHXC3e5byi3kkbqxDBM3Lneq82wk1Yz7nEd2JsydgPg	1422	1091	28	1	3340	jwgr9NzEa3ooNZmSmo47BJA4JSdS9mZegbMXFipvUzFfybYW1wQ	1781	2534	2534	1616395320000	orphaned
3433	3NKkFTwrUVotPTNuv78hJXkHJ6CkkMTppr3iZjrzeNatetKyKzcg	3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	1422	1337	28	1	3344	jw9GsJ1Y4ry7fg2ADhuU4UennKsKZAm6dP2DWGwYbMfs5cTZuu5	1783	2536	2536	1616395680000	orphaned
3439	3NKbkioSRhb9UTpwTd896fdquSVXm2ZsfomxKUGTQP3EN61jayM4	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	1403	824	28	1	3350	jxxo71DXHTn7DxCradYk71P6HhStZtHb59atHKsa1a9NnXd6ZXi	1785	2538	2538	1616396040000	canonical
3436	3NLeZbLt66KmCwFB1YLYeCezXKQZbgvD1ebgRw2RKs2RwumBQiMA	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	1622	1356	28	1	3347	jwR45sQ8BbuZemrrM3UQ3EK8r2aJKDoYdJJJPZEWQhwJvWTRujc	1785	2538	2538	1616396040000	orphaned
3440	3NKhNmqXrWjNAjcvQsY3itsnwBfQASnGvTURHjVdT4FseqYpwpEs	3439	3NKbkioSRhb9UTpwTd896fdquSVXm2ZsfomxKUGTQP3EN61jayM4	1407	1395	28	1	3351	jxPXG5exBoTsQnq3XFJ3iG9Au3hdAJu9FBdTgdUrcjtRkM54ayq	1786	2541	2541	1616396580000	canonical
3441	3NKdfWn14kzbwNnF7bJsma9yQcsYmWsfa2xoQhhPaC3sCmhjuDz5	3440	3NKhNmqXrWjNAjcvQsY3itsnwBfQASnGvTURHjVdT4FseqYpwpEs	1407	1395	28	1	3352	jxy8h1eQmT6RUGBhRQ4coMVSPjfaPt7Dsz32k9Boo7bqcF6vat3	1787	2542	2542	1616396760000	canonical
3442	3NLNiUHLXJcXMLNDYHiPRVjLwex8KdQEnEmKJ9S2wyG4VLLrHjZB	3440	3NKhNmqXrWjNAjcvQsY3itsnwBfQASnGvTURHjVdT4FseqYpwpEs	1585	1000	28	1	3353	jwfU6GKMugqvBk9oVVm5WW56zZTikyNBndHHU8hCZTbvJqyqonD	1787	2542	2542	1616396760000	orphaned
3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	3441	3NKdfWn14kzbwNnF7bJsma9yQcsYmWsfa2xoQhhPaC3sCmhjuDz5	1407	1395	28	1	3355	jxGcAt1pzTGZqqtdo1y5ZR2i3idBxaD4s6bgcAzZE85iX7tz8Gu	1788	2544	2544	1616397120000	canonical
3450	3NKmnYBSagsHSEaZm5sKdAQkLbuAh4gW8QS2PEkVBWsbkLoFVFVb	3446	3NKU6ctUVDPdZSz4Y1GhbAEpqt6xCtNqyWCrU4Zkq4zLTduw6DZC	1637	816	28	1	3361	jwW5bELh8D8YfM7arUBMVXZfzHFTQ6ABLL53auJfyKcML1a6qzA	1790	2546	2546	1616397480000	orphaned
3455	3NLHWbWM7aBF8jUE6RjkVw8EFkUQrNxy9rE8Jxc1ZXjTh4ACgfL6	3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	1500	931	28	1	3366	jw7BiG1fkWpwh8LkGWgfBMzN1CZQf7hLUVVTXsK6a37JG6DjE4H	1793	2551	2551	1616398380000	orphaned
3457	3NLJn95Ujtws5z3FrnCshrN4KafwdySVLfC66KCdLzmUKVrQdEKp	3454	3NKPXGgj9XZtG25vEyyjq8wtdM8uiLPNZGbqoA5xAKGFU9vCNaVL	532	1303	28	1	3368	jxuY6rqm4rYqeU178pd9wWptC7bDvRAf2q9JRUYUaPkMJWpYwWb	1794	2552	2552	1616398560000	canonical
3460	3NKf5cLbLCwfH1tndRawak6n4KzHJkFLFT9yiQ9qFZUKW9q5EA8J	3459	3NLMrFMMyA8fGZyt9LdB75vGfdew6DVU4HgM6MXhGgJT54GwwXPw	641	1336	28	1	3371	jwvUd6KHPTpbFm7PY3AMLJB7ZuvUksCwTS1aECsVtkrCY59Fst6	1797	2557	2557	1616399460000	canonical
3463	3NLZdvbc3orgfG3REvMBPFqnJTY2pbd5vX8APZRpVo5asPb6uwPs	3460	3NKf5cLbLCwfH1tndRawak6n4KzHJkFLFT9yiQ9qFZUKW9q5EA8J	1623	830	28	1	3374	jwyMWvC497vqDZhLm4cHgohSowxau1xuHg7d7GseYE52EFJK8PZ	1798	2558	2558	1616399640000	canonical
3465	3NLaUZD6Ti4KkWqJH2qkzKCHCVoLbnS8vA525sRWJcbN5eowDVQH	3463	3NLZdvbc3orgfG3REvMBPFqnJTY2pbd5vX8APZRpVo5asPb6uwPs	1402	868	28	1	3376	jxMk6HLSp22yh8UyDa12dgxh9GBLEpbLEB7F1oSwCTPPoxnCHtj	1799	2560	2560	1616400000000	canonical
3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	3465	3NLaUZD6Ti4KkWqJH2qkzKCHCVoLbnS8vA525sRWJcbN5eowDVQH	1600	50	28	1	3377	jwDkyxPjqMgj3cFe2isMv73j3n7Xa9gJ5qK2812hZ6VWVeDXhNL	1800	2561	2561	1616400180000	canonical
3469	3NKPPdsNbq7ZAD3ce99upzAa3QwptbzaXSXTkZKiqceb4znGjNbZ	3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	1652	1069	28	1	3380	jx43BbammqRxDXudsAd4sENTddehTkRv14AdRNiGo9bE7CYc93N	1801	2562	2562	1616400360000	orphaned
3472	3NLUtEB4cNNqUF5sEw2fx9YG9tvS1E8YtfLxYgvQueQi1wU1jUzV	3471	3NKpiKecC7VKK3qiRnuUFFC9q2gTW3SkidA1VF2oYSEVw1YwXBqm	1609	1207	28	1	3383	jxLgQ5joL91dpXtzfTXd8ej5v7iN7CTrGZSPhkKvrW1kzz43Rti	1803	2565	2565	1616400900000	orphaned
8632	3NLvYvyVLwh4eQMP6Vd9ieX1MHwx2DNPwqXRg3rumLNovvBZSuJP	8401	3NKE5LvoGPpP6n6cBhrRNqskEKEEq8darVAXWUgfR933119xTkMy	1609	1333	99	1	6301	jwJoTyCnLNyoiEhTPVMaZE8wkpPf5aaAjf8W9CbQhQeUUkfJyFm	4355	6298	6298	1617072840000	orphaned
9716	3NKetS3F1qhWckfqdTvVD4rkWmEsNwvLBUcvRc8r4mJ5vgecjfm8	9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	1637	816	125	1	6301	jwHzDdGEUhg8K6fjuSPLTexPim97dZUVGEDjtpF3TtgKSATXxJF	5037	7087	7087	1617214860000	orphaned
3398	3NLvVtLHvjV1fZcJ3EFVyNAviUaj71gMRedbLHzhajcjZkPPgZyi	3388	3NLJKVWxrmtGgpSBZn6md3DKTAb3hNzeSowXoVQChdQezAHLPQ4D	80	907	27	1	3313	jxbeLoaKvACtMZfpvPpD58P7zz42UJTxiVkiaaDGfEPuHDh7pvj	1764	2518	2518	1616392440000	orphaned
3400	3NLZmQQ1dNkxJ4UBGGmLvxbqZY2mANCWJzr2vPRzCyfMjEV9TNyW	3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	1402	850	27	1	3315	jwYxdRYezW9rP1i2aZjDf2CtprdZKEmTvmwWwP1QuyDxE4yG6wR	1768	2519	2519	1616392620000	orphaned
3404	3NLrAmsSJbpfyCWdWCj3ZMbYtYUm1QuWi6mZXApWbwaCRTG2WA7w	3403	3NKzGa6VhSKm6pkV7GJQunTXv5YU431ZZdmEuKzwkQYS8jg3RvQG	1647	1302	27	1	3319	jwZzJCSsv6Vkbzk2PT8RDEZzE44awt4Ex4xWx65GhDuzrKyLcYM	1770	2521	2521	1616392980000	canonical
3407	3NLWWQXPD5iN1Zw3KbsfsDybZ5LoviWvQT8WP35GQsPuegREzDvC	3405	3NLo1T6RAg1PG1LgNue34iQbyBhTQcQAXXFr1L5cq59FgXfef5UX	298	1308	27	1	3322	jw9T2VW6YNZi9CSLc8hJUdg5BGZnEYhofUfJRUaEZ3kEmvQ7Twg	1772	2523	2523	1616393340000	orphaned
3409	3NLX7a618VLjUSExsDycmHNb7W7FFQG7tAA2s7KW4PByuB6jfoaC	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	1523	1321	28	1	3324	jwNHctpWBMdDHa9HJb71nyLiWUFVtEYtdDZQT3SzZNm1Hia11Fw	1773	2524	2524	1616393520000	orphaned
3410	3NLK82Z9og8PpiQHMjvGzEbMfY5UoiqcNQuP6y6rUayU85U3nLfY	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	80	1273	28	1	3325	jx71Rs5313DUgxGNzF9cjhxBmxaZatfzsdFKpanENJYMsELPMv7	1773	2524	2524	1616393520000	orphaned
3413	3NK8TpN1QVL4W3sL4ThDPRAefNSeSQ3cQEvjMKfGNV75g2LmF4HW	3412	3NKbEWvcFrL16aT5YFMKUJA541LMc8d3Fkn9iRiY5kuaFa9Ch5Ge	1407	1395	28	1	3326	jxysfSY2BXsPeaXpFksPag7zaSEP86vfXGfhFv6BXbtx2vte26n	1774	2525	2525	1616393700000	canonical
3416	3NLnjpyvCqCgMYpi1uWyPx5Dvj3TTvXdN5tLPfQLRC8J92KVwyXn	3414	3NKmjdgspyi3RHxFmBPS1asXsS1fPXT4x7YNWWT9FopceLtCA4Sx	1675	1342	28	1	3329	jwkQ12sEVMTLcSEhMfDjDx8XegE8dKAitAY5svf2ksF2CFwz9ai	1776	2527	2527	1616394060000	orphaned
3419	3NLaydvmYPHxFbZjNWYqrAftT8MWqxahTa9qAnmWAhrERSyKbfLC	3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	1599	1161	28	1	3332	jxHSkEnu26poePSKhCARQHxuyRN1xjpC9HnVwJxC5AS918e9phb	1777	2528	2528	1616394240000	canonical
3418	3NKakstZ2GvAh4ox7qad3k4ZgfCkFuWx5vxzuFCKb8i3198Xy91P	3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	43	1064	28	1	3331	jwNQTj9GFnCL1f1whYeXFYnpxCRtgbRf3bNsjTF9A64ctctf7BX	1777	2528	2528	1616394240000	orphaned
3422	3NLMA2bn8fh5vxvCTLdgznb5Zm8QNT4z4K8VVhaFAr2BEzoUvZjx	3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	1483	421	28	1	3335	jxXSbg2kG32XEJDxDptncRaVMsqzDYV986WFwbe9GME2AYhx5VZ	1779	2531	2531	1616394780000	orphaned
3425	3NK6TrjPBquVDaJct8vkerYPS6veJxamwp5cA9jTNgUm4U6tyFxh	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1536	1187	28	1	3337	jwnY3ZqtHYNfwLutECnEJohHzRaakW5aBRh1BUG54a9jw9Wqquy	1780	2533	2533	1616395140000	orphaned
3432	3NLVneRautHDrNQz4axxSNHoVJJLFk25iX9QHKZy6DB8fdNWrXMS	3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	1406	1393	28	1	3343	jy11aimeu2BENodxrQxQsU7qRax3jwdgtRouUDwm7ugoC93vcgr	1783	2536	2536	1616395680000	canonical
3438	3NLiGFJ5jdBZWE3NdG2RRh4a3CoqQjHkpDMJgi7QWiKfgjE3aQo1	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	1490	1028	28	1	3349	jy1NSwby2EUEyMQptJLnSifWLoQSdK9dmX8n2ecD7Z5CoozamuE	1785	2538	2538	1616396040000	orphaned
3445	3NLapzyVDgEzgqv2Z7Tdtq5kLV9TmXNPZm1Z7JPZo56A1ZLu9ZzS	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	1403	824	28	1	3356	jx2PFGeibRdA2ug27yDqWhzChTTKuozy13XF85iYkk1EgsmmqP4	1789	2545	2545	1616397300000	orphaned
3447	3NLV63JbZwbstHdKFs6bPtq9GSMehan6rwK47bdQADa9Jy8ob8j1	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	1587	1111	28	1	3358	jxk5oG9xf96qAStixbMhuMbV5WcY2V2ywJpWWCfWhH2pGjKQpCm	1789	2545	2545	1616397300000	orphaned
3451	3NLLCt85YZ86aYf7ivw4vMx7r4FkoLJPLVHx25iycWzh2djiSuQ2	3449	3NKkMJGh6q588bMTnUkgNkjv2cvp1Ybjyx4tLqHEHdP84q9ZtiPQ	1637	816	28	1	3362	jx2AJwZvc3GEBZ6gixyVhmPirETmWCnZoasmoSUEKE9CKd9YN2u	1791	2548	2548	1616397840000	canonical
3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	3451	3NLLCt85YZ86aYf7ivw4vMx7r4FkoLJPLVHx25iycWzh2djiSuQ2	1647	1302	28	1	3364	jxrPeW2UqA67nZaNw5phMTHhBkck2e8RtEhPsBJ9ugavSusxhri	1792	2550	2550	1616398200000	canonical
3454	3NKPXGgj9XZtG25vEyyjq8wtdM8uiLPNZGbqoA5xAKGFU9vCNaVL	3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	1483	910	28	1	3365	jw6pQjCmuEhu2D6WS2EVHyKyUvvP1owPpkwZskHF7Vzd2uFZrMV	1793	2551	2551	1616398380000	canonical
3458	3NLQkAwwBS2dzsA8xyURkLrSeGcP6WnwHDWvQHkNvftTWE4M1ATS	3457	3NLJn95Ujtws5z3FrnCshrN4KafwdySVLfC66KCdLzmUKVrQdEKp	171	1128	28	1	3369	jwXoi7gpQBj54qkVVdYHwjKc7h2FZfCzBMPWhYkaqfsmC7wkJjM	1795	2553	2553	1616398740000	canonical
3461	3NLy6Z6nCSmaGGJ5U2z7MFM3qivAgGDTQHJZkfdd9zaLK8VpV8rE	3459	3NLMrFMMyA8fGZyt9LdB75vGfdew6DVU4HgM6MXhGgJT54GwwXPw	1637	816	28	1	3372	jxPajeqjzwMgFHrawS3vricZuKYV1ENnChBtq1FPECsWsyN9tJ6	1797	2557	2557	1616399460000	orphaned
3464	3NLemj4RxAoe7xGVfrtezaaLykwRtJYCRt6TcvBk1ZaCpScEAqLm	3463	3NLZdvbc3orgfG3REvMBPFqnJTY2pbd5vX8APZRpVo5asPb6uwPs	632	1136	28	1	3375	jwa5pECy8eMHLMyETMNwPMTFLHnScBwLVXYAsb8imALXxMWZcuD	1799	2560	2560	1616400000000	orphaned
3467	3NKCVyAhtf8x4gWFe91SgNkd6Dv3SuctnZAZ4J2BtNzQuE9tgHDJ	3465	3NLaUZD6Ti4KkWqJH2qkzKCHCVoLbnS8vA525sRWJcbN5eowDVQH	1406	1393	28	1	3378	jwzEgimEEpdasXSfECAPSWDcCT6Pf5vBQTePa8atqh7Cqm5nFGP	1800	2561	2561	1616400180000	orphaned
3470	3NKaK7fFfs6SM7xvw3hv738h8XB1SMaMC5rKTnSL3V56in9KrepF	3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	1648	1284	28	1	3381	jwBUDZcsB263q43e57mpmrJQYoHivxznKEL6cLxwYdV1os3kWJc	1801	2562	2562	1616400360000	orphaned
3473	3NKfURyWbpq27wQ2Z32RLjTYSExjG45QUsWdGNKP1DHg5PAp7oNh	3471	3NKpiKecC7VKK3qiRnuUFFC9q2gTW3SkidA1VF2oYSEVw1YwXBqm	1578	1296	28	1	3384	jxTqsuA5q6Q8bzhhYiRG4Jn87LirNX7Fy2qaeGnSs2c18xNLHfy	1803	2565	2565	1616400900000	canonical
3482	3NLwg9LjPgqk3nCfnKnaNG1csG2yF7vWsBES4CF6TZDwtgJBr9Sq	3481	3NLiZWaf2nbUhfwegu5y87Xp4L7573UtdmMKiCS382FTJU6GRBih	1483	1150	28	1	3393	jy3BEQHJfrPHUgLnyt17YKQKtTCATaR58r7WhXYPKuA6ZPLzMYv	1808	2573	2573	1616402340000	canonical
3485	3NLp2ZnP2G424GQrW7sLfxaqE8nonK8mWYBZVfuWFeGhYGsXivhL	3484	3NLSrrAE3PNYjKHW1zem4cgE1BbX6ndERLak3AsZLMWCyq1Cgw9Y	1633	1390	28	1	3396	jx48PjQKMTWeHkZ7Jr66vvn3NziZXmBzc8Hnhb5wos4NVz1vKvJ	1810	2575	2575	1616402700000	canonical
3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	3487	3NKQd1HUiocSNXN2DbTwecVp5on5HPJabKKEVkDdMeLWK8SspUsq	1646	1108	28	1	3399	jxvWaJh1GcvqMcYxmFxKs7wdqMpQc1uApcQV3rrEW4W8FsyoxnQ	1812	2579	2579	1616403420000	canonical
8418	3NKEHE7nRnCkhfs9QCC5yD2CcHCBPsaZitQGxUhmTpDUCRRdVRBF	8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	171	1008	99	1	6301	jxVhrdNX5ZXsyDqky36kfJB2aqV4ZdBx9xWZYesh7tA2KCVRj5L	4361	6149	6149	1617046020000	canonical
3477	3NKzENY3vvWUtp7CqEr5zwcXq2SXrXu8JhVRtUNiGJr8PxkgauuA	3356	3NL93cnZ4QMs4Ypx3A7mngJvSzV9AHTSPAh7vs3bXMt5WoLQUEDP	1458	1197	23	1	3388	jwSjdeKQTUg56hepffhPeUu6Wv3A6Hw5o8PPasXwTtWzKQW5ssL	1649	2571	2571	1616401980000	orphaned
3408	3NKM7mLerMdUY1MfncUkZ8X4e11SrsMJEBdV1QtcRJA4Ry6icyMn	3389	3NKjcKQGL1GjhsRZEMvv1HMYDotAcFopdYf2cg8HNRBANCFrobhe	1523	1321	27	1	3323	jwaYTtnjk2PCFhRoqt4apkUHpXGfgHmUCLdrqnXiEp3KjJY6LKN	1745	2524	2524	1616393520000	orphaned
3405	3NLo1T6RAg1PG1LgNue34iQbyBhTQcQAXXFr1L5cq59FgXfef5UX	3404	3NLrAmsSJbpfyCWdWCj3ZMbYtYUm1QuWi6mZXApWbwaCRTG2WA7w	1406	1393	27	1	3320	jwAcoSjoL3iYG6uAoawe5FdJrVZG4vY1xUvu1Q99Mwptpb7AesL	1771	2522	2522	1616393160000	canonical
3411	3NLDVjey74yrzrp9Ds9DsAKgv8MijeLdTWsyFBvvEhNcLFGWhbMQ	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	1523	1321	28	1	3324	jwBGKdRNdn8ySFmdj61Ls4ZHJ7QJADuaqJUqBGh7pzWN4kYm8hJ	1773	2524	2524	1616393520000	orphaned
3414	3NKmjdgspyi3RHxFmBPS1asXsS1fPXT4x7YNWWT9FopceLtCA4Sx	3413	3NK8TpN1QVL4W3sL4ThDPRAefNSeSQ3cQEvjMKfGNV75g2LmF4HW	171	1008	28	1	3327	jwg833aTszv5Ujg5ht2CfqZpUHRopLWw63ibz6ANXztmpgdJxH1	1775	2526	2526	1616393880000	canonical
3417	3NK5Lozj6tBDm5E618UaTFPT1uJMWTLs1KdhWnp89qyxFuiRiNv7	3415	3NL3UhtWNw25mKda62UZQuf6o8BoYhiFqSAhuECrgSrUYFEPkCyB	1403	824	28	1	3330	jxB99Yo1xoah5aAAmKFe8WpVaS6R9HQXPGESbmTE2nzyzc4uEE9	1777	2528	2528	1616394240000	orphaned
3420	3NLVGYx2v1q5MGKjM8KFB2U6uS5uyWeGx1KdG4Nzzi3GFdmJnYLJ	3419	3NLaydvmYPHxFbZjNWYqrAftT8MWqxahTa9qAnmWAhrERSyKbfLC	1593	1100	28	1	3333	jy1aSPpCH9dsBGGgoYhDSGEe1rbQ5rCrWBNTXEWSr4wQvKDvAzm	1778	2530	2530	1616394600000	orphaned
3424	3NL4qT167Y9XNsJfyC8gduBApsiqopDAopNFo1xsv4su7NRULouD	3421	3NL8KciDV5o3KjdUv2UozgXocjLj4DBhi4xyoA8tR2SpJU8svUds	1573	1072	28	1	3336	jx4LgqtKRQBTJW7CkD7abNXLmZVdn8kimg9XfrYog7V1Pa5hYup	1779	2531	2531	1616394780000	orphaned
3430	3NKPA5YtUgedJ7Q9Vv1hKeafwES8wYssyCsuDoVp3KMY9UCTGTmJ	3427	3NKFJFa7EGHXC3e5byi3kkbqxDBM3Lneq82wk1Yz7nEd2JsydgPg	1405	873	28	1	3341	jxDrsXi6aL28EFTLowwz6PHTUxt4hdSNE73yxuZL7QeiowE69Yc	1781	2534	2534	1616395320000	canonical
3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	3430	3NKPA5YtUgedJ7Q9Vv1hKeafwES8wYssyCsuDoVp3KMY9UCTGTmJ	1581	778	28	1	3342	jwgkoEBH5E1Yx73MKTdQsH8aTbFBnMeiAYKNTtpADF4dsobXvZG	1782	2535	2535	1616395500000	canonical
3434	3NK8GutijWQw9JJcRBr9XC6YiDtDfRFPneSr9bDoXnmzav5PLP7P	3431	3NKvpDktApg7R17dbcZbtSHLUt7HN3XUBwGBPYCcboSfdhMEPd9Z	1607	577	28	1	3345	jxZAsWJUpaXruG4wRsA5KkUrbDpfn6eRmmjFzMoYoELEQ3tpVCK	1783	2536	2536	1616395680000	orphaned
3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	3432	3NLVneRautHDrNQz4axxSNHoVJJLFk25iX9QHKZy6DB8fdNWrXMS	1477	984	28	1	3346	jwbvwuL5NAUpsy2Sw7pRR3iTs11YRi29YTHtC73XTpvCfmkvagr	1784	2537	2537	1616395860000	canonical
3437	3NLjevtA1nvWUsMWfsbN68XDNWu5G8Q7Ze1BjQuGXX5zyf8xkpCz	3435	3NL1sScP8j7xx2dTTLajoPvR2Tpy9GoT1BPePhNZXPC7MVMLqXqb	44	1325	28	1	3348	jxS66DsPRZUYkjbEt7Efv3aXC9RiCGDRVXH2qT1mcdfgsumQhQf	1785	2538	2538	1616396040000	orphaned
3446	3NKU6ctUVDPdZSz4Y1GhbAEpqt6xCtNqyWCrU4Zkq4zLTduw6DZC	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	1579	1389	28	1	3357	jxZRcoCrMo8dbG517H2DjGqrJ5Eskw13CYouFWezv35ctAX834K	1789	2545	2545	1616397300000	canonical
3449	3NKkMJGh6q588bMTnUkgNkjv2cvp1Ybjyx4tLqHEHdP84q9ZtiPQ	3446	3NKU6ctUVDPdZSz4Y1GhbAEpqt6xCtNqyWCrU4Zkq4zLTduw6DZC	1522	1322	28	1	3360	jwgwfxxtH6Qa3uHqR83mJfrR9Z5x6p15aSRK6L1NKDSg11btAi1	1790	2546	2546	1616397480000	canonical
3452	3NKuoYucf3hVJSNQkmRmyjS8iskNtwdMy1hZabAwFNsQbExP7cFV	3451	3NLLCt85YZ86aYf7ivw4vMx7r4FkoLJPLVHx25iycWzh2djiSuQ2	470	943	28	1	3363	jxrKs6jEhTJniz3fNm3WPngQbPzU3bCUdPMTsuwNhPguz5xRGPq	1792	2550	2550	1616398200000	orphaned
3459	3NLMrFMMyA8fGZyt9LdB75vGfdew6DVU4HgM6MXhGgJT54GwwXPw	3458	3NLQkAwwBS2dzsA8xyURkLrSeGcP6WnwHDWvQHkNvftTWE4M1ATS	1406	1393	28	1	3370	jxAy3b3mC99vM77drAbkGrq7G74THCDkQCWkU6cBCHS6kwU6AwD	1796	2556	2556	1616399280000	canonical
3462	3NLWNt3SKEzx3Xu7aDS1PzWoP2iR14iYBDWgruVdvfczxTSu7Xwx	3460	3NKf5cLbLCwfH1tndRawak6n4KzHJkFLFT9yiQ9qFZUKW9q5EA8J	1609	1333	28	1	3373	jx6DYsPzqutXNSQ3i2pynJighR6BMUjJzRDKh4dVNXagvRhubKJ	1798	2558	2558	1616399640000	orphaned
3468	3NKA8as4uaXyx5VxkPBpYdHSpPjVb68v4Ytnh41HV9LhdeFarJAr	3466	3NKKnEeyHjvzhzmUidLSdcyYrvFJCSmba9Mdi7nBBGHmQ8X3urvF	42	1115	28	1	3379	jxWQkJJkH7ssYCd5FNjo6PWoWLtZgosz1bj55vsCfYWAzHHFcb5	1801	2562	2562	1616400360000	canonical
3471	3NKpiKecC7VKK3qiRnuUFFC9q2gTW3SkidA1VF2oYSEVw1YwXBqm	3468	3NKA8as4uaXyx5VxkPBpYdHSpPjVb68v4Ytnh41HV9LhdeFarJAr	1559	1107	28	1	3382	jws3ZMmfAJpdeB6QWxpSh6E8JEMbaxE42qfZhYqgfD5xP8PCLio	1802	2564	2564	1616400720000	canonical
3474	3NLtdeDXBoV4DDaPSUvb2FXbcpmoqs8gtrhxMZiJrZsCdf3zeFoL	3473	3NKfURyWbpq27wQ2Z32RLjTYSExjG45QUsWdGNKP1DHg5PAp7oNh	1671	1365	28	1	3385	jxbPSdudB9r25JrTa5hvtSfGyUhBKLfR9sSZ7LUvmFfxmpKSkeF	1804	2566	2566	1616401080000	orphaned
3476	3NLJ9dMpyrMiJr6rVi7m7gH3QpqE9Mg1rpF8TFyXvFw2p8chjsqS	3475	3NKdAHVDVDBJVUbuuwBxqDeQovKcdKMHGNqg7oRVMHs8Djtvqmzm	596	940	28	1	3387	jxGV77QgNWBWsJfSSY87GptV3JXBCfUDkvu67rXyYXWARTKJnm1	1805	2570	2570	1616401800000	canonical
3478	3NLmgdB2znTJrKgnmETVN1UJUUnqLVYXK4Zkiv6ZZeeZuTeT8WMD	3476	3NLJ9dMpyrMiJr6rVi7m7gH3QpqE9Mg1rpF8TFyXvFw2p8chjsqS	1458	1197	28	1	3389	jwCpe2mpSXAJVauLt3uxdMijC2ZxtGZSm8Xkxh9bvmp38otHoQ1	1806	2571	2571	1616401980000	canonical
3479	3NLVxjLhZ1xYXmXeW4JGkW3KJSibwTpzDR1AfSaroPNgHwmJpA62	3476	3NLJ9dMpyrMiJr6rVi7m7gH3QpqE9Mg1rpF8TFyXvFw2p8chjsqS	1402	850	28	1	3390	jwNbvgG2ALPxBvNffMQKC2hiV1T815P57mriPcvj6Fvxm1vF7Qs	1806	2571	2571	1616401980000	orphaned
3481	3NLiZWaf2nbUhfwegu5y87Xp4L7573UtdmMKiCS382FTJU6GRBih	3478	3NLmgdB2znTJrKgnmETVN1UJUUnqLVYXK4Zkiv6ZZeeZuTeT8WMD	1460	541	28	1	3392	jxNiYnBXmCiGDioafTtaRm4SFXumnoiNPfUQHTrpEFCQTirEfb3	1807	2572	2572	1616402160000	canonical
3480	3NLZUqxPFoH7osryru2sRap46zV7pPPxnzF7GsuBbVBM4mh3TXes	3478	3NLmgdB2znTJrKgnmETVN1UJUUnqLVYXK4Zkiv6ZZeeZuTeT8WMD	1564	1338	28	1	3391	jxG4mKAURjnWLzLhLjsjBGBTrHgdoaxfSstjoD3tCsmWY5FVF7U	1807	2572	2572	1616402160000	orphaned
3484	3NLSrrAE3PNYjKHW1zem4cgE1BbX6ndERLak3AsZLMWCyq1Cgw9Y	3482	3NLwg9LjPgqk3nCfnKnaNG1csG2yF7vWsBES4CF6TZDwtgJBr9Sq	1671	1119	28	1	3395	jwiK2wpVPanPBf2fiVpgW521uTxCWQSeCRnxu71Yg9jEMNNYyif	1809	2574	2574	1616402520000	canonical
3486	3NL4xRixF2td96c3n3WQJVjXe73gmpNHhCeYJcrQVRBAYjvbPc8B	3484	3NLSrrAE3PNYjKHW1zem4cgE1BbX6ndERLak3AsZLMWCyq1Cgw9Y	1668	1244	28	1	3397	jwQkmEchNYbvui6ZmiFzxEJhEgwnMm3aPk5dYjnkLP5E9bEP1Br	1810	2575	2575	1616402700000	orphaned
3487	3NKQd1HUiocSNXN2DbTwecVp5on5HPJabKKEVkDdMeLWK8SspUsq	3485	3NLp2ZnP2G424GQrW7sLfxaqE8nonK8mWYBZVfuWFeGhYGsXivhL	1516	928	28	1	3398	jwGYZfJbM4vomLQjTscBTMxgFD8kNEq7u6RmM1JyMaSScbXG2y5	1811	2577	2577	1616403060000	canonical
8423	3NLuqvvjZUMzVQAYKr2tiY4YHNL1e3aQtcBYaxnor2Exmvt9fxZm	8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	1407	1395	99	1	6301	jxxhppnhpDQJhkaz9XpejX4DRCoDBtyiUoxsXDUAsLcWiAgBiJ4	4364	6154	6154	1617046920000	orphaned
9719	3NKhpd7pAe4iZ81BE1sfbq5jG4tiLAwGKY9Dsvrst6ApkbeuijEW	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	1559	1353	125	1	6301	jxp7pUmunvq9TvTaPvZN2xJSFRG6ZKp4tiT1o3FfdDvbfyZd5jb	5038	7089	7089	1617215220000	orphaned
9988	3NLtSmrZ3o71bDWeRrvpqph5JbYkdf6gBTLDuRpmjsMYN22FSeH1	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1617	1042	131	6301	6486	jwVNH4sdttUfvLnsU5nBwkAGFH1knXn71oqCDMusgBdT8b7ioZ6	5178	7285	7285	1617250500000	orphaned
3499	3NK4BDLm4qfBo5rvhv2fHvvW69FGbmZFk79BK2yZ2xJzZmJy28jY	3456	3NKSjHU35J1oBzQh6KEaRogxf3ZSMM1v1isCcVNuQirmn2whkvCG	1500	1297	25	1	3410	jxPdvKxQd58ycW5mwcKFefjB1T9mzRRnPxZHRcKfeKCv5Lr2uXV	1677	2586	2586	1616404680000	orphaned
3489	3NL33fwXYJoCkX7g6bAV2UFMSHe9UYP2qPaDC1oxnxHnvG3qddZx	3273	3NLA9zjAug8PbewTyjqTmpB5RRhP8YtQmFFyJmNSNut4MDYHueLU	1646	1108	25	1	3400	jw7Ni9BbaqEvpZ75eCU6PCK1cRBVt9m3XgPr9ivNxxCwBawn7mz	1701	2579	2579	1616403420000	orphaned
3483	3NLfp5FG2ehRAGiD7JZ2ygoNNnYaoR2oswW79yoFMP23YQoAduce	3481	3NLiZWaf2nbUhfwegu5y87Xp4L7573UtdmMKiCS382FTJU6GRBih	1637	816	28	1	3394	jx52RrAn2Lte7tnKLDz9dmFd6RLxkcWPMNxMKqERdHtvDgDnAKW	1808	2573	2573	1616402340000	orphaned
3492	3NLJ2Z3z68s9nqHqC9xqL1tajb11Fko9EH2UyK1Cvm6vGfQvy4PN	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1419	139	28	1	3403	jxMMCepNTJAxS1gqxuPxhf1i6DswBCFndk8S48xeUxsfpua3rYK	1813	2580	2580	1616403600000	orphaned
3495	3NKRg5jFPp7WJK8Avh4NnrcNGEzm4LdwnB4u8bCrLPBmcuRXjqms	3490	3NKHc8HNe4C9tc5vXTNfFupx4V1gy9536xxMdw37dpedPuTLY6Pg	1458	1323	28	1	3406	jwbZ1wJPLEymNhhuKnshnwpGezh8e8TjDCZPjbE9TEE7bKcmuVm	1814	2583	2583	1616404140000	canonical
3496	3NLD1BqWqZXaVzXFu7RXCtXp59FTz4RPaM5HvuKG8uNHKCirSb4o	3490	3NKHc8HNe4C9tc5vXTNfFupx4V1gy9536xxMdw37dpedPuTLY6Pg	1650	1375	28	1	3407	jx5BxFocFV9oEiRhbnqQhvPpbonDQ76N2XzwZ31ZNFc4u6f3dZK	1814	2583	2583	1616404140000	orphaned
3498	3NLdLAMtUe6MdZ5YEmayrfdWysTM5bwSoZQMSPY5vYn75bzcvAg9	3497	3NLjHruLb7P5dxBkwYMEqDv5bW4CVHJNxzfrRXefb6sMLy2vZox5	1500	1297	28	1	3409	jxh8aB6ZnWJHRf8ssgGp3DbC3yuc39izgoxwJs8nu9i73EyDeqS	1816	2586	2586	1616404680000	canonical
3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	3500	3NL3LEUB2Wph4x2n9n4SefU1PgmkChknESgeHfBEWzHek6X4hnU1	1407	1395	28	1	3412	jxVkWARvmq31PQA8h5BS8t55ndBxbfMvd3tHsxVa3nXo9SprZvT	1818	2589	2589	1616405220000	canonical
3504	3NLxpgxQ8NxFJRhFKRBAuJq6xM6W9vnLAD2H2eDCgyGyxPQvmMiK	3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	1607	1222	28	1	3415	jx4yRkYEwY51Y16Saep5qfmwqBzX1avjXc2UWnGceTQJk581ddt	1819	2590	2590	1616405400000	canonical
3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	3504	3NLxpgxQ8NxFJRhFKRBAuJq6xM6W9vnLAD2H2eDCgyGyxPQvmMiK	1547	1378	28	1	3418	jxfXuzpe7X5KvQpoCbxLMAMUMYia5N6S8epoCv6cEnPhJpAMfw5	1820	2591	2591	1616405580000	canonical
3510	3NLmaZQoCoGHo3LmvTjurCtLmzKbeDnRCCVu6Gk6o9Dn5TPAcotu	3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	1581	778	28	1	3421	jx7qeozjke6zygAosfsejtSYgH7KMKNBswiVD6gfauByA7LfrvH	1821	2592	2592	1616405760000	orphaned
3516	3NKfTQPdQY6SjdxwuqnP4w5q9dNq6jXNFJBEUQfZguM3N9gqhbnc	3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	1553	776	28	1	3427	jxcBX4MrQs1wMvZaHmFpuDv11na8kfZC52WZ6mbEFJit6EcWzc9	1824	2595	2595	1616406300000	orphaned
3519	3NKY2A4LTwxPNrp5Hs7JvpqSWkXZucU96otLHQvYfcPmax2Qg8VA	3518	3NLCnLCsMubKgH5ZUDz2AZmgGiuEfoikNhBRmjoHdVv3CEHcAHM9	1553	776	28	1	3430	jy2uhC62NenqTFDWzvA8TxzEw2DGNtRXDs4hQAXHHxETRCePUqE	1827	2599	2599	1616407020000	canonical
3522	3NKMLdE7JK16VU97zCd85U6Tw8s5mFcKuZyjJcXJ7qANyJW4kRDY	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	44	530	28	1	3433	jxC569TLQsQD63Xz1svqjiu7zSBZe9KNPSTx9GLrA2PKGEHaams	1830	2606	2606	1616408280000	orphaned
3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	3523	3NLDSRwh5yLjkyYTGGkNGNvQSBz6LudgzM6BHmzQAwcsHaEaWxAZ	1573	1192	28	1	3438	jxEhCNJfXykjni8spLKRGHLtd6smy9iEZVLwHnxH1TmcVfsdTte	1831	2607	2607	1616408460000	canonical
3529	3NKG8ATTqbZhxN1raVJgnXA8bv2iCW43f5kdnsdeouuKSzLMhTGg	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1407	1395	28	1	3440	jw9NsaEkKvdMQY4U3nS2LbeJkgx7eE9eHzuWXubw3V6AUJ1PPZS	1832	2609	2609	1616408820000	canonical
3533	3NKKLPsYnXJJcj65WLq9XSQHFkVz5kXcpvAYZWYBvjaQrm9tvc6f	3529	3NKG8ATTqbZhxN1raVJgnXA8bv2iCW43f5kdnsdeouuKSzLMhTGg	298	942	28	1	3444	jwPMvqbVEqrmPfPL6avACx4PfteXGk2fjscFCK879fPdyogEd2F	1833	2612	2612	1616409360000	orphaned
3535	3NLSrnk8oipqdjrPPm5gBn9fwGWu9ov4rKEAxZRhZH6MHMtF4wpm	3532	3NKQCxWb89DoNwvcgXsRPc3RrAVHfCCt1uvcx1ngr7AdU35S6RfT	1596	1237	28	1	3446	jxmyraW69acYwNSfV345jt38QV82cKheJ7Q1cyXuyF7URisWuF9	1834	2614	2614	1616409720000	canonical
3536	3NLd516hRw7Y1ASHzNea4pmqnJHSraAgizBbKVVjvYTbXykr53oX	3535	3NLSrnk8oipqdjrPPm5gBn9fwGWu9ov4rKEAxZRhZH6MHMtF4wpm	1647	846	28	1	3447	jxSMnMX6WQCdWg1fk59RFVcD2miaGxmVFsn656soDLdych5mqXx	1835	2615	2615	1616409900000	canonical
3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	3538	3NLuWtCVegKsbgFiQfW4jEV7YVvfF6BL6ZeTYMk3Kj7GNMZgHgVt	1631	794	28	1	3450	jwPEzKvcNUSvnUH6GRehwP6ANy3TE6Pai5MiNe4KQBsZweBap1X	1837	2617	2617	1616410260000	canonical
3541	3NLXZqLecJU4Jvz8LjhNzGWQj2XcXexHThMGFqe36THniW4Cf9fx	3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	1407	1395	28	1	3452	jwyTbqqCtkDKhMbBWnKYJRGS5KyyxJXxm5aiDRJuWhxQayn3877	1838	2618	2618	1616410440000	canonical
3546	3NLdTPtyReGaBHLnu2RUnvddJwJPrHb6k4d7f85YAtzB7XUCYG64	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1405	867	28	1	3457	jxvGF4sWzjTLzp7PK89wEhfY8RsM5HehG1oQEeJ2An5QRtXkfTu	1840	2621	2621	1616410980000	orphaned
3549	3NKEeCkruWG1kVeuF2iH11KXfXauQCcVDKGvZQNg84PzpNaQPpFH	3547	3NLpv3MwgYUwALEqVcDz7g5eZmRwbaTKz5GMH3tgyA61v1yA6uzK	1406	1393	28	1	3460	jxAmPLvNN81gCeNVP6uA3pN2WWwddhswK9N77uBF2MopKJVuVkQ	1841	2622	2622	1616411160000	orphaned
3550	3NLDnfT6YTXPFMjaei6cuVVFGXjqHduf6am4rKsaiggBaTwpgZRh	3548	3NLCF8PB8zHgEDX4y2MqioEff79QsqNiRr7RgzrtbZNoHAEbFSNr	1650	1375	28	1	3461	jx2QXDt972DhFajuhCbUza7EHNijMb77XtaeyniP2oFmVzqVnP7	1842	2624	2624	1616411520000	canonical
3553	3NL9Zhy7cW2xMwoDtqsU44Bucc5Wp6JcFemBnqvsTDVpiiDZMswK	3552	3NLHscGJmokJiXF5Pff67UPgVbW7sGekn96MAiVjWGQQ3fMtjdf1	1406	1393	28	1	3464	jxEFDNSXpN4WJjyRHCBjyFpnn5knA4eWB1w5gYbDaTHJGVmKPCb	1844	2628	2628	1616412240000	orphaned
3559	3NKG4ky6oAEXCban7546a7xE7qyof3KH86mZAZxQ4XmT5FbjQ393	3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	1624	1334	28	1	3470	jwUmKbfjB6va7W449A4W7JJvod95DWZfoPRfQJyXi1gvzqocDb4	1846	2631	2631	1616412780000	canonical
3562	3NLqQzf1KgoBWoyYyWVQYWoKyfSJgqk5HyN6GBwALue7eT7VU6Lc	3560	3NK9JE3C9oLgViffetZ95axcCJRnQw1xHxNiU6LX8BnDsFdrrkNr	1546	1339	28	1	3473	jxxMPSQihh3G2hornBRNJhNgM85z1QdtBMbMZDcVng8qK7DDcnY	1848	2635	2635	1616413500000	canonical
8430	3NKJJgxKBQyrFfvcLFSdvR2xgJZC9zRLzGxQj443bSzxn94meyxw	8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	1637	815	99	1	6301	jwME7qd4tZm1QWSqb2SwwSsZ4T1fkwTV8KL6G4pZ7Qx1WpGhiqk	4369	6159	6159	1617047820000	orphaned
3543	3NKWSAUeoqthPeZenfMTgsN7aYYFJ7eCjxRPyEd7WaCLSRZrKgVb	3331	3NLXwemPCTXJC3j5JekbRetJJGdY5HuM8fHVXMkDAMREeU1ExqpY	1513	1379	25	1	3454	jwR6boNuoKW7SrUiSNQZo5oCGeCMLiHtr8GJpBeNuToiR2KoZVa	1710	2618	2618	1616410440000	orphaned
3491	3NKi836KNixjfNwntgaxSPX5m19sxqoqAdHpkNnEYAAwbpTRd3cK	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1406	1393	28	1	3402	jw8VpRnKYeBqBezgaiMKY7Hov6VESpGKFFDNXkZdSzenbQzvdA5	1813	2580	2580	1616403600000	orphaned
3497	3NLjHruLb7P5dxBkwYMEqDv5bW4CVHJNxzfrRXefb6sMLy2vZox5	3495	3NKRg5jFPp7WJK8Avh4NnrcNGEzm4LdwnB4u8bCrLPBmcuRXjqms	1607	1222	28	1	3408	jxe4XYoZsYd5wAhyZZfAK6Xd75twNeut3iWwr7x7oQgChDpo6kt	1815	2585	2585	1616404500000	canonical
3500	3NL3LEUB2Wph4x2n9n4SefU1PgmkChknESgeHfBEWzHek6X4hnU1	3498	3NLdLAMtUe6MdZ5YEmayrfdWysTM5bwSoZQMSPY5vYn75bzcvAg9	1471	1386	28	1	3411	jwhrBDdW4mavCytz9jLGwWDrFyAoESVENEQXHNgNJQuBkLWhgLW	1817	2587	2587	1616404860000	canonical
3503	3NLZ9c4gozixYsLEe8gHNTZaPEaiSQudPdmNKYweD5Ytsaz3M7xj	3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	1407	1395	28	1	3414	jxCaQDvVxsBMRkRzwHkodDa3vZNtKoutvBLy5mG2G9LMzD7M2RX	1819	2590	2590	1616405400000	orphaned
3506	3NKVCynT2KoxEdR2pZP52GdvT8sGf6CHJxAr551wJEK2Xm9xWNti	3504	3NLxpgxQ8NxFJRhFKRBAuJq6xM6W9vnLAD2H2eDCgyGyxPQvmMiK	1668	1244	28	1	3417	jwD2VcZZgQqANjSxaRN3avLbZo8drhxvDq1CMCUCeuDWQxCXRJn	1820	2591	2591	1616405580000	orphaned
3509	3NL76tANUefiGGd1jgwyUJmwx3xHBjcYwJUegJR7N1p3MriSexXd	3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	1546	1093	28	1	3420	jxusULpxcUU3RsUpwo7qZbvxHLaiSmrGuCimYdYJSWCggtFmXLm	1821	2592	2592	1616405760000	canonical
3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	3511	3NLjR1WLDi7BEgcCSNirJ2TYztYWxtGeu5f89M1zgJNbCT7jZjun	1407	1395	28	1	3423	jxF52XWAVVR9VWGPkYLquNW163J2oqFNxnCKeJEDZ9v2Ut9ytyV	1823	2594	2594	1616406120000	canonical
3518	3NLCnLCsMubKgH5ZUDz2AZmgGiuEfoikNhBRmjoHdVv3CEHcAHM9	3517	3NLeZbFW9Ppv3LMQxevNFj5t4EVaSRL2QS9nFbqecah4z3SxmZFS	1403	824	28	1	3429	jxuYKLvD91eo2PMxxihbEXqhon94eLfAojY66QqEoi7K83pdxx8	1826	2597	2597	1616406660000	canonical
3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	3520	3NL3VeBz3CiAnJS7rfwxZv2w9YmB7XfDKAx2yKxEXf62bdCCztVx	1579	1389	28	1	3432	jxtsr1RAE6ePe962vssY9gHFQQaXauZE4BLE3E2nvV4azS7Me5i	1829	2605	2605	1616408100000	canonical
3523	3NLDSRwh5yLjkyYTGGkNGNvQSBz6LudgzM6BHmzQAwcsHaEaWxAZ	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	1634	1085	28	1	3434	jx2VfTLKyQCckU85dJa3jCdDjJQfZMr8aCVviUxxfVT96X3SKpB	1830	2606	2606	1616408280000	canonical
3524	3NK8Aiguw4DRYrpwRc2dmFkXJuxGrzsH87Ls7GLgB1mRTCJvSh1G	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	1406	1393	28	1	3435	jwZV8ygaKfkNSy5jjG54zo4dHAanb95DgHRTDPpwdoXXLZ7eVw3	1830	2606	2606	1616408280000	orphaned
3532	3NKQCxWb89DoNwvcgXsRPc3RrAVHfCCt1uvcx1ngr7AdU35S6RfT	3529	3NKG8ATTqbZhxN1raVJgnXA8bv2iCW43f5kdnsdeouuKSzLMhTGg	1503	911	28	1	3443	jx4RpiTJcAgQCkncoFvynq1XnPanBQ361GYJMWSKsdwqS8QkidA	1833	2612	2612	1616409360000	canonical
3540	3NLqoLGhMCGQHVvFFKkmmDLmtZRB1QZRpY2NHRx4bEAQfrLnwx6S	3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	1476	1371	28	1	3451	jwHMQTAToaWXkY7R6RxLyDDiMttvYH71stj5XGyAXa4BNN4rZH8	1838	2618	2618	1616410440000	orphaned
3545	3NL4KmdJDC1TS7e3X24tRPjmfUiZ7hiDUCRzTAGvNWtrYDDsuUz1	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1422	1337	28	1	3456	jwdrQRGvdcWwYWYAjXAo2fARTRdwxMai3FRRyQJrUFeEjGBaqwA	1840	2621	2621	1616410980000	orphaned
3548	3NLCF8PB8zHgEDX4y2MqioEff79QsqNiRr7RgzrtbZNoHAEbFSNr	3547	3NLpv3MwgYUwALEqVcDz7g5eZmRwbaTKz5GMH3tgyA61v1yA6uzK	1476	1245	28	1	3459	jxgtx4MGv3j42rKCyT186vBGbLc2TF7b3Aq8j2ZMjFWBFVfy2vL	1841	2622	2622	1616411160000	canonical
3551	3NKdza65qYeSR1dDi18Y5t1hFnjS4aqoGjKvBUsVgQQsZuPAJ3cA	3550	3NLDnfT6YTXPFMjaei6cuVVFGXjqHduf6am4rKsaiggBaTwpgZRh	1406	1393	28	1	3462	jwa8eWrhdV7svujFE3cg9NuDA97JRTfyocJUdy7oS3coLNkywEc	1843	2627	2627	1616412060000	orphaned
3554	3NLZMxFTDeDssb54rywXwGDEmTsbyYtLgkKWCNy8UK7QLDKzLt7J	3552	3NLHscGJmokJiXF5Pff67UPgVbW7sGekn96MAiVjWGQQ3fMtjdf1	1585	1000	28	1	3465	jxB6qVh9TQLuP1MJV2cyRBVewTXRYDSSzpcaYyWS9NZBha9QCAb	1844	2628	2628	1616412240000	canonical
3556	3NLxLADuGJNWiup4Pk95VhePdCkMkUsb8QpHRXQMtg7zqehDHZSD	3554	3NLZMxFTDeDssb54rywXwGDEmTsbyYtLgkKWCNy8UK7QLDKzLt7J	1581	778	28	1	3467	jw9NFhRhr5gPq37jg2wPuoNyot4V4zviSqtvaUW8GnHNSw7QaXb	1845	2629	2629	1616412420000	orphaned
3557	3NL8LGyoGeN3M98xw5xh78BcnXSZhJv2rQZfnH8YZsuMoHi9QsNW	3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	1490	1148	28	1	3468	jxEohhxjojMDE49aVYpP3SMBukfgtgBC2Zk8L7Dx5Cje8sPZEqJ	1846	2631	2631	1616412780000	orphaned
3560	3NK9JE3C9oLgViffetZ95axcCJRnQw1xHxNiU6LX8BnDsFdrrkNr	3559	3NKG4ky6oAEXCban7546a7xE7qyof3KH86mZAZxQ4XmT5FbjQ393	632	1382	28	1	3471	jxb8j99kgqZmwjQSdcF2Jc3MBiYTuNCNH8TErV5mCiiiVQBoi8p	1847	2632	2632	1616412960000	canonical
3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	3562	3NLqQzf1KgoBWoyYyWVQYWoKyfSJgqk5HyN6GBwALue7eT7VU6Lc	1406	1393	28	1	3474	jwMV6o9SH2HAZKh9Qu8B1oEhZEzKR6GhChvAfa9rmV3jVoPwjVo	1849	2637	2637	1616413860000	canonical
3565	3NK3yGECXtiCz4W1PzzhkCV5gYhe3f1dx5o47goUZsJDyHnWPCkY	3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	1406	1393	28	1	3476	jxQnN4CZycmxZAT2m8Xp59vfmA4JjUuQhZgHTAfFL5Z2gCMGpYj	1850	2638	2638	1616414040000	canonical
3566	3NLKATuwTeC71QSiuiYhzsUBb6kXDYT5AnU6MEEJcwxkkBgyJyY2	3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	1633	1390	28	1	3477	jwE2kQiQyuUHfVj855STJbt2V1vDYo7Fv3szuhjyS89qoiUWMvS	1850	2638	2638	1616414040000	orphaned
3568	3NL1xeM318smgd6cvVeMEX24juT1Lfna7v8NxB5b3Z7pLGewnXP1	3565	3NK3yGECXtiCz4W1PzzhkCV5gYhe3f1dx5o47goUZsJDyHnWPCkY	1590	1174	28	1	3479	jxKcsM5exUxRdQGLpNtVomAPziA9d4W62y2VbWvFiHJ853wU3cj	1851	2639	2639	1616414220000	orphaned
3569	3NLjxRdnnea4E4QiHrHMYtthB5vPPLKomQxxvLRCX3ecr1YQDePb	3567	3NKdA8HHXim1shTeSSmf8EoqADm8wkQhy9YMMCcgpJsjaaUjKRZf	1589	1040	28	1	3480	jwcECrWFBN365ahB1yreRdoGnGwiDDHB7oDxCY27LjGE9ZWcDNx	1852	2641	2641	1616414580000	canonical
3571	3NKCFeGSs1veson87HPhApftTzcSuhw6ca1nN72gie2vHe1yJSmU	3569	3NLjxRdnnea4E4QiHrHMYtthB5vPPLKomQxxvLRCX3ecr1YQDePb	1407	1395	28	1	3482	jxEMdGKgJfZwHuCJFUBTyggty8qQ1y7bHhaG2ivL8FK89CqEPgn	1853	2642	2642	1616414760000	canonical
3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	3571	3NKCFeGSs1veson87HPhApftTzcSuhw6ca1nN72gie2vHe1yJSmU	1550	434	29	1	3483	jxvbg7kUqixDvWAH82NVZgM1YiZ4odCtpS67MUJ3UpSSFP8xCGd	1854	2643	2643	1616414940000	canonical
3575	3NKLv9kquvqDv1QiT5PGdK1maaB6L7T8yToA2ucZu434hKnSi1Ph	3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	1631	794	29	1	3486	jwf21gKuJG1F6YddUoW9CD6PHgTK7RYDJyiHSXZC8UkKrjvYGoZ	1855	2644	2644	1616415120000	orphaned
8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	8433	3NKv7s5bDW65BZwNewj5a6SjK41KMiVvwPrZbfGvTs5i3ijM7BsA	1668	1124	99	1	6301	jwR31FaFuQ8c5bq7NWigBNJrPiXcYEStqvZBpCz6y7gFmiRfaYo	4372	6162	6162	1617048360000	canonical
9829	3NLfmtWkXJWa1sRYQbYnmwDdy7gegKRxpYeSDUqVMG7QeDa6Atjp	9724	3NKPmgGPCFjBgMYmXz6fWWjtiCCzr9m3M8cbRL4BccoAZcLcjiJz	532	1303	125	6301	6338	jy1Fdmxibqkz2EwbNifSzeX4kc6FMAMGpEeVUpKd3dLbtQJjh4m	5041	7164	7164	1617228720000	orphaned
3526	3NL2dvvrsoBGikrsLNM5XbAkGCZRDjDk6aEUCkwZzjKNbPbM7tDx	3452	3NKuoYucf3hVJSNQkmRmyjS8iskNtwdMy1hZabAwFNsQbExP7cFV	1634	1085	28	1	3437	jxSgnjbfBW4H5miq949giLwKH71u1dRqGkAqZa7Xa3oEzwaasvH	1793	2606	2606	1616408280000	orphaned
3505	3NKjFMqQiocpJzYAKsmpok7zLeooemEYKxhXHyGoZ5ZxAaxzX6Mk	3501	3NLhUzf286hvg1fk2jSJXZfsiUbkqqoMHh29MsjzS6KnXvAm1691	1637	816	28	1	3416	jxPXk5caoAqnMeD4war8kg5MYofm2xBqXeKRRoukfHZqt8egAvz	1819	2590	2590	1616405400000	orphaned
3508	3NLocUiFmMuS5vJFUu5qyfLggMRK7c7AxdozBiT7xiiXqrJTaitr	3507	3NLxvkHvsdmA4geuyt42RmM7TPM8iZhRGMik4eMHqakxWLMxw3nh	1458	1197	28	1	3419	jxe3WQ9aFUtBb6kv31Lp7EYe2kDXgEEdsxvYt6XNBMwSvCdNmFM	1821	2592	2592	1616405760000	orphaned
3511	3NLjR1WLDi7BEgcCSNirJ2TYztYWxtGeu5f89M1zgJNbCT7jZjun	3509	3NL76tANUefiGGd1jgwyUJmwx3xHBjcYwJUegJR7N1p3MriSexXd	1623	830	28	1	3422	jwZJq5Rk9m9bVwUCBtu2HvC49zPv5gAmPEnwhkyM5phW3h9ka92	1822	2593	2593	1616405940000	canonical
3513	3NL2qvnpnBDXuqVPqk7wePyEHLzvoFUwgbSkzNAgEEFEYGqUPAmW	3511	3NLjR1WLDi7BEgcCSNirJ2TYztYWxtGeu5f89M1zgJNbCT7jZjun	1403	786	28	1	3424	jweHAZX1vm5RDVnTBbsvP8MyakNQBFtYtVMYWxiQpde6vnUQ5iW	1823	2594	2594	1616406120000	orphaned
3514	3NLZN1BPtrB7vifqUTFYG4uCbrogmBDoZHnxb8ELsvhNszV5Mzsd	3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	1444	1381	28	1	3425	jxfE47fyc75nJoFFHufsDdUBtViSQTvPGzcWHSEu4nvPQDv14jE	1824	2595	2595	1616406300000	canonical
3517	3NLeZbFW9Ppv3LMQxevNFj5t4EVaSRL2QS9nFbqecah4z3SxmZFS	3514	3NLZN1BPtrB7vifqUTFYG4uCbrogmBDoZHnxb8ELsvhNszV5Mzsd	1406	1393	28	1	3428	jxgdsqkGGiWK3rcTCJxkebVGZiaPNxVdC5Bk9wQcn8brD9gQDZ1	1825	2596	2596	1616406480000	canonical
3520	3NL3VeBz3CiAnJS7rfwxZv2w9YmB7XfDKAx2yKxEXf62bdCCztVx	3519	3NKY2A4LTwxPNrp5Hs7JvpqSWkXZucU96otLHQvYfcPmax2Qg8VA	1439	1033	28	1	3431	jwFHPbcpCdTht1QSHW71HGKtEa898DzwHMAnue7ySJdDTRyj2QM	1828	2600	2600	1616407200000	canonical
3534	3NLHUmKEByaPQoDjb2JZsXtyAS9ooNt4udy4ATY9THThH5AM4dpY	3532	3NKQCxWb89DoNwvcgXsRPc3RrAVHfCCt1uvcx1ngr7AdU35S6RfT	1406	1393	28	1	3445	jxFt2RxkYXzqgB7iEPrrxk7otsXHzcVndusco7HDo5GVnReBs3X	1834	2614	2614	1616409720000	orphaned
3537	3NLV5Mn2pDqh1LwhgjRQxJ9riDv1Z5117onMMmtZ6vC7PfSPVMb2	3535	3NLSrnk8oipqdjrPPm5gBn9fwGWu9ov4rKEAxZRhZH6MHMtF4wpm	238	238	28	1	3448	jwbX6yqUVkAgKCTFD2krZ2tgh6kiuojGXs1GgHCp87XSjxyNFxK	1835	2615	2615	1616409900000	orphaned
3538	3NLuWtCVegKsbgFiQfW4jEV7YVvfF6BL6ZeTYMk3Kj7GNMZgHgVt	3536	3NLd516hRw7Y1ASHzNea4pmqnJHSraAgizBbKVVjvYTbXykr53oX	1637	816	28	1	3449	jwATffV5Z8fZxTbK21vh2pSpAG36KiLgPvWo27wuw6hXQu6abEs	1836	2616	2616	1616410080000	canonical
3552	3NLHscGJmokJiXF5Pff67UPgVbW7sGekn96MAiVjWGQQ3fMtjdf1	3550	3NLDnfT6YTXPFMjaei6cuVVFGXjqHduf6am4rKsaiggBaTwpgZRh	1553	776	28	1	3463	jwuTMZD3qwKr8oMVTS8LAEojNPCdVbzwWK3gDsNMbUm6rfZfuU8	1843	2627	2627	1616412060000	canonical
3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	3554	3NLZMxFTDeDssb54rywXwGDEmTsbyYtLgkKWCNy8UK7QLDKzLt7J	311	1307	28	1	3466	jxJwWYgLbVHixFmRk2uvSXXsudNiKGGdWet5mh735aLMX7Cy4vy	1845	2629	2629	1616412420000	canonical
3558	3NLkr5iG6hKBvS5ai7sVcFucEgMWU92b4oXRkAAEw2mBsDEu2cHq	3555	3NKw1Mk2A62PWgAYaCmqLDgGgn2HtthsTQXwrqorfGukaajmejWR	1522	1322	28	1	3469	jwUcBKcn6iNH5u7Rz8YdLND1BicN6NYYsoaKtEApQL39UR9zwRc	1846	2631	2631	1616412780000	orphaned
3561	3NLVxrAwwJMEsYtw1iWFU5ZDuxv12jHH5B6M9ZCVyFYE7anaqKDU	3559	3NKG4ky6oAEXCban7546a7xE7qyof3KH86mZAZxQ4XmT5FbjQ393	1650	1375	28	1	3472	jxow642Es21PHbUQ2Zodhi1aQ3fd8hf7DVrqqAy81v18ncs4RNQ	1847	2632	2632	1616412960000	orphaned
3564	3NKKxtUwpVKGMEmdvPcZNcTTwirdhrEwt5fYVMPFZeLTP3sHC2fs	3562	3NLqQzf1KgoBWoyYyWVQYWoKyfSJgqk5HyN6GBwALue7eT7VU6Lc	1419	814	28	1	3475	jwFC1DwjCGM9cUgn9LbydcP48F5XbJqrL1XubDXpxbBp9C36rMy	1849	2637	2637	1616413860000	orphaned
3567	3NKdA8HHXim1shTeSSmf8EoqADm8wkQhy9YMMCcgpJsjaaUjKRZf	3565	3NK3yGECXtiCz4W1PzzhkCV5gYhe3f1dx5o47goUZsJDyHnWPCkY	1546	1213	28	1	3478	jwJLYYj7dB4NE89njFydYR9JjcsbFKTtFSzfNWsSjLCxMYLsirg	1851	2639	2639	1616414220000	canonical
3573	3NKjv5Acns73b9meUUJzw4cdCuK2My3e7QcHj9fk1qe1yxJ1ziwm	3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	1405	851	29	1	3484	jwNNqMLgK9dS8kwgid3vZuRr4rkedtYMayncgGhiW7HxYL6yt5k	1855	2644	2644	1616415120000	canonical
3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	3573	3NKjv5Acns73b9meUUJzw4cdCuK2My3e7QcHj9fk1qe1yxJ1ziwm	1549	1362	29	1	3487	jxV5HivDT2oT5GwWz1zx7eEdWg6zksy7Bz5Un7ZQMDrmnJGxiU8	1856	2645	2645	1616415300000	canonical
3579	3NL9hdstEAhHycQxFxxmgD5pKE7gDrQkgeaKFs1jnM3YBGdoqiy1	3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	1581	778	29	1	3490	jxPy4z1ByhPs11HkpoaSNZMwaffru4r1KLHp8Qx6tkizYg92gCc	1857	2648	2648	1616415840000	canonical
3578	3NLHLXUYtUbqvSsCw9kdovkhs5SkGc9MCxAVGQ7TsJvuEteRWawP	3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	1481	790	29	1	3489	jxcQa6LcMxprtj5UJxvryJa75epcf1xgUa3JiEqheYWayVeNaAo	1857	2648	2648	1616415840000	orphaned
3581	3NLW2JNbZT2Yk6gAwRnHoZNrZLqxmcXkyTgmJhPHmfGLyiQBk36j	3580	3NKZEwrrAVja6xnFVXc9EVLkhzS3js99V1FnN3hC1oYvsoBLS2SH	1406	1393	29	1	3492	jwCyzWLbPirVg9Wj6ikFUtzHfhxWLNoFcogx6Pknkv2SWQbvtnV	1859	2652	2652	1616416560000	canonical
3582	3NLMsdKBTixobFaGu63zncmntEPW53ztpe7UY2Byzvy2yamZf2YZ	3581	3NLW2JNbZT2Yk6gAwRnHoZNrZLqxmcXkyTgmJhPHmfGLyiQBk36j	1529	1316	29	1	3493	jxqvmvfsddnkAYzvYtBvvziandfSLkbkkF9JVJNLNLxPxgnThKT	1860	2653	2653	1616416740000	canonical
3584	3NLPW1uMAYBpARj88g2w3dArpijTAEPPJjgMwBbx6QP4EFf2Mme1	3583	3NLejRLaXp1KPw7HAJsyBUAPKXh2iBt3HHYGQvzU5DA4bj3bevSu	1476	1125	29	1	3495	jxPchXMXbXMLfS2cCNiWj2KCgbmD9woEQnnJcvDhhtsGVM2kgFQ	1862	2655	2655	1616417100000	orphaned
3588	3NLvGT9uVDE8ioXvJYU5UQdiBLC95xPsCZBo9Ry3BnKojACMSxvJ	3586	3NKfy9BpbxPBcSZ8zkk3GJGVjpnaL3Lz7DpZFy4wKWqSAFZcfKwN	1642	1001	29	1	3499	jwWb2YCd5VZMUBt8MqnepJASUhqKDZTdTSKacBUtQ5RJMfhDomN	1864	2659	2659	1616417820000	canonical
3591	3NL9NMHWpodhKU7nxWvkV5YLB7uf6eHpYVxcTcdCo3atVSpzrUSr	3590	3NKgkd1DUnaQ5bU9PqWXRD6BgvyWjvMNz566iQMPSUHMrFTCP97K	1406	1393	29	1	3502	jy316SUxuAWdgPc9vsQwp7gPjhpWAJUUEQcKU6Kp9EP2aZpGUED	1866	2661	2661	1616418180000	canonical
3594	3NLMFmtxSXCAFYKECVyFfmrsZrJxjk7y7ydbSb6t2YPUKxptKP7B	3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	1483	186	29	1	3505	jwLVHDbNK3Aa6XKJw5QaFH3j6a3SgCrvpcxkbm2jZ67AEjHg8Zp	1868	2664	2664	1616418720000	orphaned
3597	3NKEC3hZhKpaMYFPRae9HrCsjm4a1DayfP5iFgvWSMSut1wq2Kbv	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1476	1371	29	1	3508	jwHNYJZmtRsk1WRbeVXMzacskUSAA2aQbP5q7BcW6wge8tsYvFq	1869	2665	2665	1616418900000	orphaned
8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	1656	1343	99	1	6301	jwk4sSXamtz2w7x5YgTWfRKZYA1McpAb8NNivDQu5SVE7dmLZGo	4373	6163	6163	1617048540000	canonical
3574	3NLd5xJF84jHNMTVyesP9adp186wGb8G82fhtHJPpXznfrigpxzE	3572	3NL66oT1SyHVpbiu5Z58Cr85EX7MByRePftRXYsJUqB4k2k6Xv5h	1581	778	29	1	3485	jwiUE4MtkReCdN4dpYximCzvZSenMkH5XXrNjMofG8iFtu8Ff26	1855	2644	2644	1616415120000	orphaned
3577	3NL83xyvXV8DxBWUWLMBWczZnCFnKLxWpU6HFhUnPyQDog9K8q5c	3576	3NLjwDnLMtLuMbxGr5AbFdjCLXptEfu3joFbE467ruzwA4UkUL4X	684	986	29	1	3488	jwx9rjvK8opfg461xkTxCUtFHMvMu7D8EAYdaeZfAWosz4PRM7t	1857	2648	2648	1616415840000	orphaned
3580	3NKZEwrrAVja6xnFVXc9EVLkhzS3js99V1FnN3hC1oYvsoBLS2SH	3579	3NL9hdstEAhHycQxFxxmgD5pKE7gDrQkgeaKFs1jnM3YBGdoqiy1	1593	1346	29	1	3491	jx9GxAxhXPpKzjRd1vxtZ5HmFXbUqXmkWzbZUQDZ9jTjwNfxgEG	1858	2650	2650	1616416200000	canonical
3583	3NLejRLaXp1KPw7HAJsyBUAPKXh2iBt3HHYGQvzU5DA4bj3bevSu	3582	3NLMsdKBTixobFaGu63zncmntEPW53ztpe7UY2Byzvy2yamZf2YZ	1458	1077	29	1	3494	jxwhqBKjC6cWggzKyreEMbCT8UadNBexrSnsnJCbzD58PB12Z5n	1861	2654	2654	1616416920000	canonical
3585	3NLNq6We8yKc8MD1xhbZiVhzazMc8D8vgkK8qf6mTCGYVWFxbuEo	3583	3NLejRLaXp1KPw7HAJsyBUAPKXh2iBt3HHYGQvzU5DA4bj3bevSu	1483	251	29	1	3496	jxjsihCeiYScJ5PgtfyVmQMgWQXfoWGaS68oVY9ns3KEBsv7KCP	1862	2655	2655	1616417100000	canonical
3586	3NKfy9BpbxPBcSZ8zkk3GJGVjpnaL3Lz7DpZFy4wKWqSAFZcfKwN	3585	3NLNq6We8yKc8MD1xhbZiVhzazMc8D8vgkK8qf6mTCGYVWFxbuEo	1406	1393	29	1	3497	jxGzE61Cjq9ojoSwCbsQi16GfzbQYnneJ6uKxWpHDcifMitYKRh	1863	2656	2656	1616417280000	canonical
3587	3NK5CEodec8xmxfXKciygCeVDK1ymxgpetW9tC7LNFgNeidx7BNf	3585	3NLNq6We8yKc8MD1xhbZiVhzazMc8D8vgkK8qf6mTCGYVWFxbuEo	1445	1164	29	1	3498	jwZfFoTjpEeqNDpsiVrkAeJQSbx5Y9z2HXHjkVjwZm5NLZ34tAF	1863	2656	2656	1616417280000	orphaned
3590	3NKgkd1DUnaQ5bU9PqWXRD6BgvyWjvMNz566iQMPSUHMrFTCP97K	3588	3NLvGT9uVDE8ioXvJYU5UQdiBLC95xPsCZBo9Ry3BnKojACMSxvJ	1402	854	29	1	3501	jxta5dnbXqs8ZYjXCHC6zeLCtGiQHSZG6tXrPG6HawHT2R3HDbi	1865	2660	2660	1616418000000	canonical
3592	3NLmtdedpaffDHX5QMvyXLhGsUws6YkfUBUtCcbQuJ1KtfSYYLfy	3590	3NKgkd1DUnaQ5bU9PqWXRD6BgvyWjvMNz566iQMPSUHMrFTCP97K	1536	947	29	1	3503	jxhTiduWYoXdnTeVofn7BJYXLDHJbiLwa4PHsJJXPwtQSZxCEWC	1866	2661	2661	1616418180000	orphaned
3595	3NK5NGRTSMaxkPF3xXgoEymKA8vzDwb79YyVtNfCQMmN3ZBzTRjN	3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	1461	1271	29	1	3506	jxHBhDrkgHzVdxFDDkif16eBt3FUMAjmK1WTWVRG9JgjZkmJsKH	1868	2664	2664	1616418720000	orphaned
3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1407	1395	29	1	3510	jxxdriFgPtKYwXLJRwakQZGQGCTegaHLxEhFemD9YaKMpRDTs6W	1869	2665	2665	1616418900000	canonical
3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	1426	1364	29	1	3513	jx6LbMjDVqZ6gVqjvVRGu77zpyJzYogiXB1Gat7JDbfpV9Chzvv	1870	2668	2668	1616419440000	canonical
3601	3NL4J1KCNfUbHEgUDj9MavGLxUCeyac2TUL4shjHdUCjE71Z7dHc	3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	1670	916	29	1	3512	jwkLpzp3uLdH3YAfVrgn4bdhLonD38aY3hcHVb33cMgUmkNi3xE	1870	2668	2668	1616419440000	orphaned
3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	1596	1237	29	1	3515	jx46ZpmxY5vnafnQ1iU3NmcTxacsmp4pF5PDcYMdDYFreAYnDPY	1871	2670	2670	1616419800000	canonical
3605	3NKkiGWwuYzjz89eq21SgtvbDZUafN7Q1mKswsFFX1AnJiQVK2QY	3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	1407	1395	29	1	3516	jxiURFDKxvKkwP3PpHhbCqaraBrPmRLPmiPNoXSZs5Z2yW6n2Zm	1871	2670	2670	1616419800000	orphaned
3606	3NLGSFdTrYRaVQvdPEmSMwTyqL4UCCKaUVjvzxX2FxRAtoXLVbMA	3602	3NKEo7RTPMhbLxPZkc8tdMw2m12P7VTxXiMCu5sy8TiA8pge9vK8	1637	816	29	1	3517	jxNUGYJ5Xr2Lz9ozCHDrDhypZCeTK2iXFNbpVfJRZ1n5XWrD2uC	1871	2670	2670	1616419800000	orphaned
3607	3NLeXwhoavBqmNmeLGSLAH1QW2PWoRCGerSH6bc57FwrKkEkEPxm	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1578	1296	29	1	3518	jxFJT92B6tdQtad2ixoXiZX8LcjDHCmjUbWdZ3RsAvkgFjEp64C	1872	2671	2671	1616419980000	orphaned
3609	3NKkTGxoeYTdUKg2cFfxVZvSHNUre8CmcGqYDpRnLPyMTc9Pk6B1	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1406	1393	29	1	3520	jws6SRaMT2herKUnEixLjKg4bgNWJzhRcMNB4QeEec5AU5zyJWZ	1872	2671	2671	1616419980000	orphaned
3610	3NLL1m7qai8rw7SSM6pQyBRuQfiku6VWqZ5Vz72Ak8Nzqac9zJb7	3608	3NL9YECG5uisPF7THtEg9TwX78zUDhVPBng7ZSCt6QoYYes84RUK	1483	1030	29	1	3521	jw7HiKaW9k4gmgayepPxv5CiNFzM2BB7DjASyW28FkdxdVLNxXt	1873	2672	2672	1616420160000	canonical
3613	3NLLyzPHedVqBxtwm1HHC2t42AV6nUna5pLJmcmjMh5XKYhUEdTQ	3610	3NLL1m7qai8rw7SSM6pQyBRuQfiku6VWqZ5Vz72Ak8Nzqac9zJb7	1547	1378	29	1	3524	jwGo5j4UqxgSUShZ6ucHCQUnyDAo4jYbSHW71hJVsrJkRLZtea6	1874	2673	2673	1616420340000	canonical
3616	3NKJfWN6re5yaNUptJ96uySw3gCH9UatXBeNz1kHx7bpbD8cEZUR	3614	3NKz3LCxcvwTt2T95vzkBoLj26KRJMhzLeLrC9sM7tFwGTN9XDRM	1422	1337	29	1	3527	jx8tFYBWzofd6J8yMtYHc9ktDbt4ka58asmqvmy5bxf21t9foat	1876	2675	2675	1616420700000	canonical
3622	3NKd2aLEsm3Qg38CbziXnDcbDkXwFBiuDfaH4iP8WW7YnP5J4JUx	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1631	794	29	1	3531	jwL1ZGsrFg8XiSjDUyXyuJ2tUGm6nR7fFo3n3PTuNQNKyHTQgPj	1878	2677	2677	1616421060000	orphaned
3625	3NKLCjsXLzzuaNd2UCRnso216EExugTe6G4cTEF1ax8cg93fg3sC	3623	3NKASTrVr8KZsgaN32uAVWE16N4iyVWKKYYypdiCuwe3VhYs25Y4	1634	965	29	1	3534	jxcrpfiftRUoTsCXNXKbmo1khCFtYqkVJmd9TTHPhuvnTRhkNUv	1880	2680	2680	1616421600000	orphaned
3630	3NLXkLT4ejdZu1SnSkfeqKJsNhyRYTUU96jEHjUMhLah7RTm4zWT	3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	1611	1341	29	1	3539	jww6ePPMqxE9tHqP3cNadyKbQXzZPHgZsT1PyrLPqgeV1vmgKqk	1881	2681	2681	1616421780000	orphaned
3633	3NLf9byFNgnBPLFLrAr2xTVLsqFTpdAhGuSCrJtJArmyySKbMtVZ	3632	3NLpiCkHV5ELFvYXEwv6zaLJRe7n8SrdtsJnLvEKeiuYFPFHhbmZ	1578	1050	29	1	3542	jwAKzPC9h5m9L3q9fxzAjFvsePYoPiiB9o2cEyWuQt5mHo9LkDf	1883	2686	2686	1616422680000	canonical
3637	3NKxgZjaEUgaPELkb7GtccHv6ALtw6jGVQSgMLa6mP7Tb7HexJWB	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1673	1368	29	1	3546	jxTA78UMnj35UwEq4uvJGT9aDzvq2LZMPbvWtunbPm7n9HqKNyL	1885	2691	2691	1616423580000	orphaned
3639	3NKQDEmxDhYvQjRYTp7ZMjCVpZ7RJ46zRMR2WVSgvhRXhsH1F2p7	3638	3NKETgREU7vBFVjJEx8ik1f5bbdcRaW77VkKEC1Qjk3t64Mt1wmZ	1407	1395	29	1	3548	jx291nRmsnNC4umJKQTvKiBz53NVPr7KKvQv2hwbPBhZzXYQHWW	1887	2695	2695	1616424300000	canonical
3642	3NK9T1KLskzGMjV2DTtMZpsWn29hBuNojzPNVdv5Ar24Cju4UDe8	3641	3NLfRK2Y8fcKCHqVzmpmK2vFMZmi9ryVJufBs8x35QumC7Ff26R5	1461	1271	29	1	3551	jwPbE568mEjFePGequ4TJuVRfgdHvSJhg3gJwHEmd3ECY8gJGFo	1889	2697	2697	1616424660000	canonical
3646	3NKzcw1FU7im8rUNsPnPFghmm7fdvKtU3rBRrmLobwHGjmQe7zZM	3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	1578	1296	29	1	3555	jxDqqaXry7Z9bmMX5kZijs6Cf7G94LeTkyqLSf5qtbu4sKRUqe7	1893	2702	2702	1616425560000	orphaned
8446	3NL4WjiSJbm3oTqUpJVHbQPifkNQ6jNGYygmy9DgXRHKxmBfJxog	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	1585	1366	99	1	6301	jxeAaoV7aXDcoXM2k2e5MdQaGz5co8BioYQVtX4mXr3FaHQ6wuE	4375	6165	6165	1617048900000	orphaned
9742	3NLWBX7pwUzFq2PgQetBBzStvXdGUP9MFrH4iqQdbXn9ihrQFZBU	9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	43	1310	125	1	6301	jxdC5xG6eikqrnH2Bq6QWyTPRCXv7n92sD5geXHhA4pwyBnxAFZ	5045	7103	7103	1617217803821	orphaned
3640	3NLT7uFiGFQUkT453FVQfLarpPvaoTbAo5sPGF7NAXjHiUfN4o9Q	3570	3NLKECu63mRYywvccRPXUrHQSzW7vUaS9Qmhg7uJt8wnKYLCvKR5	1513	1379	25	1	3549	jwQZFwNPfKpZjVxfa8hZLZMkstW5XVCfSTx6WGMk12UQcuGeLPB	1712	2696	2696	1616424480000	orphaned
3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	3591	3NL9NMHWpodhKU7nxWvkV5YLB7uf6eHpYVxcTcdCo3atVSpzrUSr	1405	891	29	1	3504	jxwaSFH3jVdnVy9jZu2nkUTpiX1bZJjGUrbJVgQGWWLH6ABCziC	1867	2662	2662	1616418360000	canonical
3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	3593	3NLsCJH2tPMBiLd2Z9zYRmmYPwVYsFBydf2JeeL52s7Mu3ub6vw5	1627	1139	29	1	3507	jwuBqpcEPfN1ug64wVDXKeRQRBYzmE4Nby7KNiFuAiqY9AcyQPQ	1868	2664	2664	1616418720000	canonical
3598	3NKDgRYVMiEcW1tCSESzZRzrGRTMHeG52QVYB8jdbmP8EkghEmBC	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1483	1276	29	1	3509	jwdPHGRrKpN5au2wNeKzfVCGh8mA7ujt7B8wj8VuCdC1JdSHkhZ	1869	2665	2665	1616418900000	orphaned
3608	3NL9YECG5uisPF7THtEg9TwX78zUDhVPBng7ZSCt6QoYYes84RUK	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1403	824	29	1	3519	jw8bpWkGzSQgssM2p5koREtUpgz9u3PAHJMp2K5pXg7WpZ4ZPqw	1872	2671	2671	1616419980000	canonical
3611	3NKB7QWxr9VZ6FZdZgGjMBKfkyZVHHahHbLtZqko42rjqr4Ks8cd	3608	3NL9YECG5uisPF7THtEg9TwX78zUDhVPBng7ZSCt6QoYYes84RUK	1489	1014	29	1	3522	jxZyx9DM7V3qYZr9Uyvrvpm1yv7aHtNapFTu9wauKwD5V6vZXpv	1873	2672	2672	1616420160000	orphaned
3612	3NL3pLUEM1hfugDZzRaEr5SXPrHiYsHJbump8eMCs4HFgGtDTysM	3610	3NLL1m7qai8rw7SSM6pQyBRuQfiku6VWqZ5Vz72Ak8Nzqac9zJb7	1406	1393	29	1	3523	jx6h9TQu4giKVExJ9rTDrD9gB8MhhvEEXow9yMGzfkNQnSBQXzr	1874	2673	2673	1616420340000	orphaned
3614	3NKz3LCxcvwTt2T95vzkBoLj26KRJMhzLeLrC9sM7tFwGTN9XDRM	3613	3NLLyzPHedVqBxtwm1HHC2t42AV6nUna5pLJmcmjMh5XKYhUEdTQ	1527	1167	29	1	3525	jw8Ub5m81JYvtTD9D8qhVXFqaGzmJMZZXradjwgcpdSUs1oK8uc	1875	2674	2674	1616420520000	canonical
3615	3NKAj7MxJskBNThLSYNfdSPKDjnGqwz5fmdwWQ3wr5NEEmD1KrrK	3614	3NKz3LCxcvwTt2T95vzkBoLj26KRJMhzLeLrC9sM7tFwGTN9XDRM	44	530	29	1	3526	jxwqBT5NJ6Zw54wiTrtfio6KbqGdWXWjy6wqt5fif8CFYRgx8uP	1876	2675	2675	1616420700000	orphaned
3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	3616	3NKJfWN6re5yaNUptJ96uySw3gCH9UatXBeNz1kHx7bpbD8cEZUR	298	1308	29	1	3528	jwEVp93NCeuZNRiJBNsAR3Mhf3CzsCmtFTUr5MfxPSNqPjwgnEL	1877	2676	2676	1616420880000	canonical
3619	3NLaKvcZb6fNa2xh72aPdBajfcxaYi7QVWujok7NVDcW2zADQ6VY	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1588	1146	29	1	3530	jx8Ct3ihCk4Ae6Afrxs8aG6MV2oyaitzgr2gh4uoqNd3mrrtH6q	1878	2677	2677	1616421060000	canonical
3618	3NK8JajTHiDJ6qcJ6cevcgpvqyJi1QsvEyxZrm5vtfGBUitXpppt	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1523	1321	29	1	3529	jwg9izkgvhkb1dFomkmwYzWmht9c1gFuahtEVi1A73uLUApEmbg	1878	2677	2677	1616421060000	orphaned
3623	3NKASTrVr8KZsgaN32uAVWE16N4iyVWKKYYypdiCuwe3VhYs25Y4	3619	3NLaKvcZb6fNa2xh72aPdBajfcxaYi7QVWujok7NVDcW2zADQ6VY	1483	146	29	1	3532	jw9VShf4STgrhXqnHFkg8KbjJQRWjTPS1dsRK8dCvUXdyvXomZH	1879	2678	2678	1616421240000	canonical
3624	3NK9rmdzTwnZKQjp5PoUaRYeBkkHogfdB6ceu5zmUrhg6axYLQP1	3619	3NLaKvcZb6fNa2xh72aPdBajfcxaYi7QVWujok7NVDcW2zADQ6VY	1439	913	29	1	3533	jxJHBswffSWqNSUd4UWTzAtxtwjnSBQVF1D7uBYZQNtdrAFsuKX	1879	2678	2678	1616421240000	orphaned
3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	3623	3NKASTrVr8KZsgaN32uAVWE16N4iyVWKKYYypdiCuwe3VhYs25Y4	171	1128	29	1	3535	jwr6iencv4MHcDbrjtXfzN8eePkCRDZunsCZ5NBFbvGGQ7treuR	1880	2680	2680	1616421600000	canonical
3631	3NKpgMZfMkALCXSzvMEge16T172gyHkqzctwEFE8Mp3CLf8ovyQh	3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	1581	778	29	1	3540	jwqDQRRQDo8mQiywcw7tX6RZ9xXiTuCbX5bYLX47hSV7Emo6hu6	1881	2681	2681	1616421780000	canonical
3629	3NLSZZuUqB6v4Mqgr8MPrW5YtnTxJWWLQ7Kf5EzF4aCWVv6vVZfY	3626	3NLrhRsjHtMmLP8pxvCiH8y6fHvpmshWMvSnRPV3gUoLsrifg7hy	1407	1395	29	1	3538	jwkEhXBmvWj3d9RvKi9ujCYaTS8JaicGPTPy2d38uP9Aeas4Xqz	1881	2681	2681	1616421780000	orphaned
3632	3NLpiCkHV5ELFvYXEwv6zaLJRe7n8SrdtsJnLvEKeiuYFPFHhbmZ	3631	3NKpgMZfMkALCXSzvMEge16T172gyHkqzctwEFE8Mp3CLf8ovyQh	1477	1104	29	1	3541	jxnPf8pENTTu4cV3QvseTcrxsSutgU1ptSoomidJhqzrNzmh8wZ	1882	2684	2684	1616422320000	canonical
3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	3633	3NLf9byFNgnBPLFLrAr2xTVLsqFTpdAhGuSCrJtJArmyySKbMtVZ	369	1066	29	1	3543	jwbdUC3STKKCtj74Me63iLCJ6uy5M72x7QNZVTVPgvahMg1iQir	1884	2687	2687	1616422860000	canonical
3635	3NKi9iRuSQ4YBc8FaHadNUJxP1r86NCA1vpbp3EAnWofFLydHKjx	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1564	1092	29	1	3544	jxUnS7aKJjtrrLLodHJDp31As5wAAdpNLXjLgDhAr6TYySSFZvh	1885	2691	2691	1616423580000	canonical
3636	3NKwQqanRASRuJUmVaBcGzwMJvBBgztGsM5HqbrChdR517ChiFkL	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1503	1031	29	1	3545	jwiJtX8sedwS7i7H4con9CfazyMcVM9ub4VwiEnN6xxYucxTBWd	1885	2691	2691	1616423580000	orphaned
3638	3NKETgREU7vBFVjJEx8ik1f5bbdcRaW77VkKEC1Qjk3t64Mt1wmZ	3635	3NKi9iRuSQ4YBc8FaHadNUJxP1r86NCA1vpbp3EAnWofFLydHKjx	1481	790	29	1	3547	jxpmua2gtdhdiUaJVqmFbsXXPhwgCztNQk8m2rcLoVwGUYKXRTf	1886	2694	2694	1616424120000	canonical
3641	3NLfRK2Y8fcKCHqVzmpmK2vFMZmi9ryVJufBs8x35QumC7Ff26R5	3639	3NKQDEmxDhYvQjRYTp7ZMjCVpZ7RJ46zRMR2WVSgvhRXhsH1F2p7	1627	1259	29	1	3550	jx292wne2ELtbDD8yeE9vM4PVbpwpgWpDHJvjkL43QJrKuLHS6W	1888	2696	2696	1616424480000	canonical
3643	3NLCCYJhtxG3YN1o9p1asmfE5dMd8TGB6jYjmZ33HEEPbBbLiLQy	3642	3NK9T1KLskzGMjV2DTtMZpsWn29hBuNojzPNVdv5Ar24Cju4UDe8	1590	1054	29	1	3552	jxARdxu6yvVqEH6Qfu9YckGtocctoKjpMgRqGZXDWu6fPguCzBt	1890	2698	2698	1616424840000	canonical
3644	3NLBGkW64nUaqsi3KiT1iu7zqHgDBBzu7vyqDnZq6hqbSKrR3hhQ	3643	3NLCCYJhtxG3YN1o9p1asmfE5dMd8TGB6jYjmZ33HEEPbBbLiLQy	1668	1370	29	1	3553	jxrUfrihx9dcbw5k7eRbyZsMPD2hmUTjuVE6NdY4GLxjHnGFefB	1891	2700	2700	1616425200000	canonical
3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	3644	3NLBGkW64nUaqsi3KiT1iu7zqHgDBBzu7vyqDnZq6hqbSKrR3hhQ	1596	1237	29	1	3554	jxU2NsBA6vQ3NZRuZt8NPnjdFTvA1CGDckpkM1n4CCSAaqQCsne	1892	2701	2701	1616425380000	canonical
3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	1460	1324	29	1	3556	jwPfmHgHNvbevy8hQDV3NVZ35LJATvFseA4NJxZFoDGpURUFD1i	1893	2702	2702	1616425560000	canonical
3648	3NKdbtcHESiVEAkRfMq86Wk9ysmrrNn4bsSrH6WQx53FAaY4Cxfa	3645	3NLeLCczcyxEsr4u8Ghvrqj1VLZWMHCxhwxWMS6sNsJ7SDM5Sd9t	1546	1339	29	1	3557	jwwFoiNxTD3a3TiLKuThdsZDzevDYpVtFNXwsLX35EkmsxVn1tU	1893	2702	2702	1616425560000	orphaned
8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	8463	3NKoAveXD7UVCPYjxEw4kkiP1DtAfkbnr9RWrxGfHDqy3pSh9qiQ	1600	1126	99	1	6301	jwXKhdwAKYXjb3uUpp53xo5xGgJSvzzJWvq2ZVs8KZgchFVVyPy	4385	6177	6177	1617051060000	canonical
3650	3NKaFpPMRCPAbZZMRJso8qEYYpAbxA2fqCpcMLfrEYzEZwRHojXp	3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	1672	1285	29	1	3559	jx6DwqBMKNNALT5e7F5WYkRoksiRcWvBbfdWCr1briqTdxPq8F8	1894	2703	2703	1616425740000	canonical
3649	3NLyGxCfGor963SLMFPJNQjXaortHCXcY3BSKTDieErRMVzAUTQd	3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	1544	347	29	1	3558	jwSFjFfdG1ZzcH3LNPzoXBw6U9GJ9yxgfRtPeHD2nTcvvTyX7sB	1894	2703	2703	1616425740000	orphaned
3652	3NKcjn1QBrARz9rMsxFnM1vvDonPShtu869NCaWzYCmiS4LCcWEn	3650	3NKaFpPMRCPAbZZMRJso8qEYYpAbxA2fqCpcMLfrEYzEZwRHojXp	1596	997	29	1	3561	jwU6cFabU7qMT6CEm3SuEk4fE8hpCK4WnWqSKdUhuXVFYRJULpU	1895	2704	2704	1616425920000	canonical
3653	3NK4X8ZSPT8jMc7Q5cHYNEu7CwJBUfGkPZKdy2tsugD7qH11Fkc9	3652	3NKcjn1QBrARz9rMsxFnM1vvDonPShtu869NCaWzYCmiS4LCcWEn	1571	1335	29	1	3562	jxggQebJLN4MXsAHvaHU1xAw4fMFuSsNGyMqp62KxFc1HJZ3Jnb	1896	2706	2706	1616426280000	canonical
3655	3NKJPZa8PrzCPap4C6ueTKKMPU2FbfgM2fKaS3sizrH93fWvRLHW	3653	3NK4X8ZSPT8jMc7Q5cHYNEu7CwJBUfGkPZKdy2tsugD7qH11Fkc9	1623	839	29	1	3564	jwsCstiAuCgthAwxJG3C2zPaXc2SJ1iiJRjw4fVqvnzHhyYPBpE	1897	2707	2707	1616426460000	canonical
3654	3NK7QXi5Pz6Ygck9uvi1wbNFexQBogbRjK5aS6yr8VCfpXxhszzj	3653	3NK4X8ZSPT8jMc7Q5cHYNEu7CwJBUfGkPZKdy2tsugD7qH11Fkc9	1489	1380	29	1	3563	jwXCo4jGhWwdPLhHSRxwH17oPDWHJLSjeQSN2T645AbRMVewMeo	1897	2707	2707	1616426460000	orphaned
3656	3NKXWmkqWbAyTzJmCVtFM3jomxxRtuoizNxvhqJtLSxZbKqoTcVJ	3655	3NKJPZa8PrzCPap4C6ueTKKMPU2FbfgM2fKaS3sizrH93fWvRLHW	1577	1327	29	1	3565	jwoswszNy3cczeFeD3nqi3h2nq55nQHuyvGre5TGH5qbfBfyN8A	1898	2709	2709	1616426820000	canonical
3657	3NLrh24R8fBs1EMz6heSJ1DZunqyc6b1jUGYYFC9T7tqoRVRv1iL	3655	3NKJPZa8PrzCPap4C6ueTKKMPU2FbfgM2fKaS3sizrH93fWvRLHW	1577	1327	29	1	3565	jw7NBcBpmg3co5215172goo85pD7Myiv235pRoFYT97bo42eWLP	1898	2709	2709	1616426820000	orphaned
3658	3NKQSXPPBdhziKZ3hzBotiqzp7wGwiGCvCMfZF2gWKHU6bK4RCy3	3656	3NKXWmkqWbAyTzJmCVtFM3jomxxRtuoizNxvhqJtLSxZbKqoTcVJ	1633	1144	29	1	3566	jxAM6AReE1W5yexFTmAF5CAZfPPrgCcvJVd6BQaUJwTEA5TFho7	1899	2711	2711	1616427180000	canonical
3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	3658	3NKQSXPPBdhziKZ3hzBotiqzp7wGwiGCvCMfZF2gWKHU6bK4RCy3	1483	63	29	1	3567	jxJAmTq76Ax6DA5fd3U3VgooLsDhyeTf4MuUFUK9GhkBcnCPfqZ	1900	2712	2712	1616427360000	canonical
3662	3NKrC3u4dFaXLn1AkTuTepmhivWo5GKC4k6GozhrrQ2yfzdCfZeb	3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	1500	1171	29	1	3569	jxAj28ipp1HrLXN8eeeKdAo3fZ3xPQWryNxRtiudZ2QkvyRzxbh	1901	2713	2713	1616427572000	canonical
3661	3NK6gVvX6FRNPFTyvX1cEfwnsiYYhzsWumHBsmJek29LBs3AMbVm	3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	1500	1171	29	1	3569	jxAj28ipp1HrLXN8eeeKdAo3fZ3xPQWryNxRtiudZ2QkvyRzxbh	1901	2713	2713	1616427540000	orphaned
3664	3NL8XF6sjEj8khQXUVzXwv7qxzkRCDoeukvGTssWR4QUijUJh4Lk	3662	3NKrC3u4dFaXLn1AkTuTepmhivWo5GKC4k6GozhrrQ2yfzdCfZeb	1564	1338	29	1	3571	jxX2yEw7mtwJv69akhWgHzfGFrD2iCHR935cae2d78VZU4E4PB4	1902	2714	2714	1616427720000	canonical
3665	3NKW5yignGCxeGEQar5M5F6gS4QXt9WgUgR48LonHepsSrfc57Vv	3664	3NL8XF6sjEj8khQXUVzXwv7qxzkRCDoeukvGTssWR4QUijUJh4Lk	1407	1395	29	1	3572	jxE5vURkhA9nXz6TSsYNPY2ZG7hsNjVTRUGkKEfW2W5B5Mju7wC	1903	2715	2715	1616427900000	orphaned
3667	3NLTixVybdnKHeY58dSmCjt7U3oG4P4N987LruYhrbFMPxqZ3buM	3666	3NKj187Zo38pM4q8Vu2RCDYHPke74aLsg87q9ksLVgNHUfQN4h3C	1406	1393	29	1	3574	jx3Qr5k4fwmuit9VBejsrGttLL79zCqEL4yK5wLRoRwfcWzoBQC	1904	2716	2716	1616428080000	orphaned
3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	3669	3NKpC3UtrpvexbuTb4ehN3r9GmJiGjEzHGue2sBfTXU2Sn7fpU78	1631	794	29	1	3577	jx2Z5igrquxDsop2mxG25LCC6B9xH2BTm6jYvGj7VfyHBTethLL	1906	2719	2719	1616428620000	canonical
3672	3NKKtdRxWUwMEMASPZiwkSYrdK6mc8LkfED2C8VcNj2Wt5yuCUxp	3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	1587	1111	29	1	3579	jwM1HAP75VZ46zJ43BNYH84MrBngBUKfSGJWdDGW5NxUDE9AxXG	1907	2720	2720	1616428800000	orphaned
3677	3NKWhHsWqhhcFAy33bJW6yrY98dcsQ79CmAwvbGASaCbYcu6mz9q	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1611	1215	29	1	3583	jxAVWCTmotLUBZgikUdorP3T8ug2MTW872G1UUfLK7YCpVMf3XF	1908	2721	2721	1616428980000	orphaned
3679	3NKbYLnQy6dydjk7RkBb9EC7VSC78YwYszyrX8iVzk2Fw8LDtaE6	3678	3NL99hnwTykfTLo8JoVpRdwsQXzqHHJXAK3KKvAbcds5NVrzkmvy	1637	816	29	1	3585	jwKWAncHX5hWbkVr6keLUTVnQzEbzN3f7KcYp6Y6djEBZGHCjoj	1910	2723	2723	1616429340000	canonical
3681	3NK3QLNFxybfBtsNa1rXHBjbSndvM1r5VJ3EB5Q9RuQABWJFG5ow	3679	3NKbYLnQy6dydjk7RkBb9EC7VSC78YwYszyrX8iVzk2Fw8LDtaE6	1407	1395	29	1	3587	jx6zc4mWvjq9KCQEDVRTQzV95SYceN1Fw9VpjefjMAsHyiMhy88	1911	2724	2724	1616429520000	canonical
3684	3NK99ydUCz8A2Zt6cMzGrnhxxBZ6ULtrFVWpbn83ucegBaSYTJsj	3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	563	1359	29	1	3590	jxKr63xRGf6zC1y7s9qAKo1FxtyZkgHTvnBi1vAQEgQ3YggPuV5	1914	2728	2728	1616430240000	orphaned
3689	3NKhL4g775ikj4xEaoeFKupp4dXAPjrgy8czoZ53XqcLmdkzJRD7	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	369	1066	29	1	3595	jwnKbDdCrEruoQLV6yHEuAw4mzbGZbecxRG351whTHjY3KuVSGb	1916	2731	2731	1616430780000	canonical
3691	3NKkLsg3pYSK1JiU7rfeEuen6pNzrsMvKZmMciehrioYaPSNDm4J	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	1577	1327	29	1	3597	jwv9FsC5KudxRZNk4qv9WLFHG29wJvTUvkg9tNCPVUPe8D49QJh	1916	2731	2731	1616430780000	orphaned
3693	3NKMafAS318xfhnfhgGRez8U1sqKmMRYK8mKXUbZPgWj5JNo2KPM	3689	3NKhL4g775ikj4xEaoeFKupp4dXAPjrgy8czoZ53XqcLmdkzJRD7	1581	778	29	1	3598	jwYeRuP7pQzkXzEfix1peeBbMkMLzL2gA4bp5rrDTPkxdT2nzK3	1917	2732	2732	1616430960000	canonical
3696	3NKhBAnxGWXmngpeRbduywWZN2xM9dgEeZMyuR3LvG5w8FtyANEQ	3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	1651	1301	29	1	3600	jxrjHZfSLLj6Gi8ts5GBTknaXFMhKwbgieswxDA3vZRv2oWXayU	1919	2735	2735	1616431500000	canonical
3698	3NKfu2bEUkToyrUs1xoTtb8SwLusrSoQbaCoU8XP4xfFcCxPxqg4	3696	3NKhBAnxGWXmngpeRbduywWZN2xM9dgEeZMyuR3LvG5w8FtyANEQ	1553	775	29	1	3602	jwAV34qxrN1PLyPagwxUmgHnb7EpPMjvsLAygPXfRxm6eE8qobm	1920	2736	2736	1616431680000	orphaned
3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	1489	1380	29	1	3606	jxLwBQ8cnDAcCsPJRZJG59Vc4QAPLeTPvZdyGMbinh1UxZjvQnm	1922	2738	2738	1616432040000	canonical
3705	3NLpgBpcKkzaZ1Nz882Urb3ux6qQApxkmRAhty8D6SFwhrGm4W63	3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	1440	1251	30	1	3608	jw8AcftU5yWGWLu14qdwxt2zbHg89LwdXu9GH8DPSUuozcMXsu7	1923	2739	2739	1616432220000	canonical
3707	3NKw25tPgvR6mMznoJ8jBcu7nZbXD8AbCzHZxGM4eQB4qQVk7rQo	3705	3NLpgBpcKkzaZ1Nz882Urb3ux6qQApxkmRAhty8D6SFwhrGm4W63	1419	814	30	1	3609	jwRzyBZCn6m8iHQsvW9ozWHNtA58nzkWWMg7zyNQbCY1zM1Ktpn	1924	2740	2740	1616432400000	canonical
8716	3NKD3c3ToK7LhBjBYFyRPbCydS31s1eMbBvvLtxB3w7qRpEemmDw	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	43	1064	99	1	6301	jwbqDXRF48PKSAUCwJZKwbrrk13vFzJTVreoXB1uYBYHLZeLa67	4386	6372	6372	1617086160000	orphaned
3668	3NKufVD3ChbmQsxtgjxWE9MUvPTfAQPJafwwcq7xcrcYZD4Dukcj	3666	3NKj187Zo38pM4q8Vu2RCDYHPke74aLsg87q9ksLVgNHUfQN4h3C	1407	1395	29	1	3575	jwpHydxynUpB4winx8DREx9tVcnqVoCtEDeAuXHeSoV1roQVNt2	1904	2716	2716	1616428080000	canonical
3675	3NKHwMeDjqHPFypYLkxT25KYYGPHn8jxTNk9whtCaBoyp2TfZcyB	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1455	1332	29	1	3581	jwKLYoi5qrYp2oRMKGcYxFh9ERBAHRoEzer8RHSC7pc6Cq35CCD	1908	2721	2721	1616428980000	orphaned
3682	3NKGufTef2ohMBEnJuGdU1kam9ZUVGhEmWB1gvftF3d8xpMJs8Dd	3681	3NK3QLNFxybfBtsNa1rXHBjbSndvM1r5VJ3EB5Q9RuQABWJFG5ow	1422	971	29	1	3588	jwYqFWDKw5yqRcqsRca3wKX54aKeuBuZdBXh3nPLqNc9SpRJwNw	1912	2725	2725	1616429700000	canonical
3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	1585	1366	29	1	3591	jx4kjgF3boxE76TbaWd6tatN8RS4vwBJt8NPqRvTkfQ7ji7EEie	1914	2728	2728	1616430240000	canonical
3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	1402	874	29	1	3593	jwZ9e9rLYeHgo92NEuG2kD1qMQS5JDWv6oRAYu1hmZj6P6RZEiG	1915	2730	2730	1616430600000	canonical
3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	3693	3NKMafAS318xfhnfhgGRez8U1sqKmMRYK8mKXUbZPgWj5JNo2KPM	1509	1320	29	1	3599	jwDRU3DT1r4HMfZ1E3LsEzh5ojtwPvNd2yko4WJWU4MN3giac2x	1918	2733	2733	1616431140000	canonical
3699	3NK9PtUAzLKZAQsVMKngh2cXyGqdR6ApvNHDG7xCAUViqKdjMsLE	3697	3NLU87bRMxEV7qFuRCuEdCF26gGKripfPAuAZLxGhDjeZv1K1nFb	1407	1395	29	1	3603	jxac8BCpBedsr2rXzz8gsQsTr7M9R48hiheZo5RNmww8m7ArGRA	1921	2737	2737	1616431860000	orphaned
3720	3NKyA6EFL7eZcXsSBmAsF9MUJJUQzdzYGiNh3QCKc6juZftJJHNx	3699	3NK9PtUAzLKZAQsVMKngh2cXyGqdR6ApvNHDG7xCAUViqKdjMsLE	1646	1228	29	1	3621	jx6Yq89eD4ppJ1TkP12ipHuZPUnQN9Tgqk9ftrLcXXHvCkbEnWc	1922	2750	2750	1616434200000	orphaned
3706	3NLfvV2bQtr34n6Cz1gNv6hkQNcqVMdte8UxigTyXJgqen7T9iuX	3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	1458	1323	30	1	3607	jwwMsMtBZ4rnThMQ7a1Vov2BbCvXY6t2bjYBgGh22fkpZbnAheM	1923	2739	2739	1616432220000	orphaned
3708	3NLH62crLDXbpfHGubtYGR4unCNzXwFpNSymQe1ZXxu7qtA1cEfF	3707	3NKw25tPgvR6mMznoJ8jBcu7nZbXD8AbCzHZxGM4eQB4qQVk7rQo	1405	849	30	1	3610	jwHPsJrudektfbFUojr8sMWNZisdQMsBC46zUjB3jRaZUJo1FZt	1925	2741	2741	1616432580000	canonical
3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	3708	3NLH62crLDXbpfHGubtYGR4unCNzXwFpNSymQe1ZXxu7qtA1cEfF	1672	919	30	1	3611	jwWvzLLx2EuKV1cwUhKf3PjeL3nStUaVNUD8ETFgvQ5jR8a4G6g	1926	2745	2745	1616433300000	canonical
3711	3NKBJLxcYLpS8oHx9tNb1yyK45WssoUwsaSvkxjFY1dVTy6UJeN4	3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	532	1303	30	1	3613	jwg9sN5tPK8pyr2Z1RHDUYejyJTidRN9RS3h6EDzhsrNPPGh3WH	1927	2747	2747	1616433660000	canonical
3712	3NLcSUTqb3cKZUSyVG96NB3RdfofnHmKSzYYJkZHxWPXenDMcMn2	3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	1406	1393	30	1	3614	jxPKvTcVcQ2LR39H1FYvmB7phNc6vxozp6aHD3Tf6x8gi9uMih4	1927	2747	2747	1616433660000	orphaned
3713	3NL2QTTDMfsy1AaQEhXSYXGamRfCoXeFBEpPaUSPiSEZaDUcNNgD	3711	3NKBJLxcYLpS8oHx9tNb1yyK45WssoUwsaSvkxjFY1dVTy6UJeN4	1577	1327	30	1	3615	jxNrwLM31hJD696Hydgz65P7rRE9DQjddB5Z1B7StV9HV5rnP27	1928	2748	2748	1616433840000	canonical
3714	3NKxLCEdmM8jbmZSWQEDpWdLN9AFX5W6nYxNtDJVJm1URoYVxPQn	3711	3NKBJLxcYLpS8oHx9tNb1yyK45WssoUwsaSvkxjFY1dVTy6UJeN4	1577	1327	30	1	3615	jwoz7JqCUwamKgis3rseVTLzSNJYh3uvqLEyNvFzqnTPNSEyfHN	1928	2748	2748	1616433840000	orphaned
3716	3NLkSvoBjX4QGPDCbgtQHc6P6c8AWzeabfHQeD1jDyo7mHZvQJTV	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1646	1228	30	1	3617	jwoKeCwk96mXy5Htu6zNwGmJhySHkqRTci23d1vamzw74SrWhfH	1930	2750	2750	1616434200000	canonical
3718	3NKvL6oDf3XCE6Ez4vcMqwweZ1vuNkXJjxCgdMz6THiYbcxCuJxt	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1553	776	30	1	3619	jxwqtudVThbue22aNw4ZigNqQPzPcAjwAv2p5DpSBjA1DbiW12m	1930	2750	2750	1616434200000	orphaned
3722	3NKmtfU2MD1CsZNA1borssZXz335D8naQAG4vA5ymR5zemtepAyW	3716	3NLkSvoBjX4QGPDCbgtQHc6P6c8AWzeabfHQeD1jDyo7mHZvQJTV	1534	1317	30	1	3623	jxX1yx92zWZGxqyTKu8T9UhgmCtWpMvvaUZZxmatZwZbr9TzyzW	1931	2751	2751	1616434380000	canonical
3725	3NKzui4CfCg7iR9jgGVfDpyKK7osD4j4Gr7qVbji6AeSvLiVVFbv	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	1602	1123	30	1	3626	jwWSL1wBA78qvecmotNn47uYCC9tR9PnSVVoUMoP4H1Y1C1EF95	1933	2753	2753	1616434740000	orphaned
3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	3728	3NL5yfUHwciW9Za9z7ypEmzqe4pX87EF1BiEoSrKbYbN7QFpE53k	1406	1393	30	1	3630	jxBFFiRBtaZCJbf15Qn3p28U2YcJv98FTwxuXAidSAG4rP7Ngrd	1935	2755	2755	1616435100000	canonical
3731	3NKWZrcUaNMKhYzLHcCADEua6WWwFfPbYC7WBtpzsMUTsqsaFes3	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1403	824	30	1	3632	jxwZP5m2B8RP1xBdEg6dSSzsQ4uC6CwAEjzYCCWLkQUncH45w4J	1936	2756	2756	1616435280000	orphaned
3733	3NLyEzj9doYizHporp9Y7KS5PQ8YNuVVd87sVyb8pPbUBNjn6Hmo	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1668	1244	30	1	3634	jxMvZeXsgX1ohSBDvyQYBS1mFDCmKEvZQsiJDh5Y26Ba4x1exdq	1936	2756	2756	1616435280000	orphaned
3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	3734	3NKjRN3AzqvUcqLbsbJNdvz3cLK3VvKbyCf2EANSnFSa7GVhF7Vi	1651	1301	30	1	3636	jxWXE4Qpwb6dbS5s6WSLyyCo2yPTXM9whykWPFnDASTgMEG17SQ	1938	2759	2759	1616435820000	canonical
3738	3NL5CyxuHxPntfwYJ9VS2Rapsc1unsyEwpja1cHeiE6s7g7QbDCt	3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	1428	472	30	1	3638	jxoBSibRYKutHNRYBQ5NZJ99tVFBcWszrjo8oPNF3BSPpg4BySa	1939	2760	2760	1616436000000	orphaned
3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1406	1393	30	1	3641	jxh8jMLvKuhdYiydQgxhduvN9CwDU9s2i1MeCQPyVaucv9k3vtF	1940	2761	2761	1616436180000	canonical
3747	3NLXPmFK5fN1u6TYCJvFZ7YF8wV2ceb2Ddv2DTYCfr8fQLt8wbnr	3744	3NLUAuRK6NY8yacBLQYPJ2n8bAKPGNimy7B5TC89dJdnjxiEA2Yb	1599	1161	30	1	3647	jwfEt4pGmVqDf6AWWRFg3XUVKXdDZ7TM2WXxNHhRHggJmTaje5B	1942	2764	2764	1616436720000	canonical
3760	3NKZXF36MyygqyaLuVXrHEYy6W9zKAXcMnSaCYTQB136MgUyhutq	3757	3NKtucaDWDXHDbdRjoyT5ZDzjWJwDV1N389oTHwFC9eWX4dJDLQC	42	1235	30	1	3660	jwJHwpwVRiGd5Q3JrLwjoxcmrvwgcNMz8Eba9nd1Kdo9iJb15AX	1950	2775	2775	1616438700000	canonical
3768	3NKUMo9gkPHMykkWkiCdPZ84BuAoPNm3Yr7TJirQXEA6cj9yzDhh	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1507	1280	30	1	3668	jwM3hWYp5RWgGe8ojSemUp8dqYLuHV9JK73Xii97qBGkEhYy7U1	1954	2781	2781	1616439780000	canonical
3775	3NKbfe6CowwC6VVavk5hMUBFuPj4haFuZsVBTTuf5s9JZux4x1bf	3770	3NLaHZcUFMcDzDPJptV6nVpXuCYXX1pAbGdME1hFW8rsHXk7y5Tm	255	255	30	1	3675	jwijWNrL7bwTHCYRN8pnwixWLGR1P78pPitJZb9cRSvdgapwXgW	1957	2785	2785	1616440500000	canonical
8475	3NK4pq1yk3CRc4yvqqmDX5HZFHmiVZ81bZ9dmDqvmyCmFis5A17v	8473	3NKHczTRCmFDNGvFQbe9xw2JLj472c3JK2xP66ULquVEoyiB2PeZ	1489	1134	100	1	6301	jwRyUgAAkqgLb83Ab2E3nzyYgjhvZ6H6Vm9EfeFGrcic9DPzhXK	4390	6185	6185	1617052500000	canonical
3773	3NKo11ghWozniD2Q5UMurUpSDpxkRtCSLSNdsDy3bGyMYjUudbwz	3453	3NKUp3hXvHr2WcGGaawV1m2DdFEjHWVB217mB2Y5VmSVezsvdF3u	1602	1369	28	1	3673	jy1BE47euQx2HaAbHeMnXBjgQgHN2UWAnLxDQhZJHcc2ChqrFvL	1793	2785	2785	1616440500000	orphaned
3669	3NKpC3UtrpvexbuTb4ehN3r9GmJiGjEzHGue2sBfTXU2Sn7fpU78	3668	3NKufVD3ChbmQsxtgjxWE9MUvPTfAQPJafwwcq7xcrcYZD4Dukcj	1601	1388	29	1	3576	jxp4kf469E3v1Hy4LR4Xsr2QMWJ3TFyXZHFFQVEDQp43WYRnHhy	1905	2718	2718	1616428440000	canonical
3674	3NKaat7N6vDYEGd5oMv26KycTHqedNhXoEK1B2trhJZpxAHPGi9j	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1670	916	29	1	3580	jxabMfhLw4TRwEnMTqgzppfpsub6ZDSUGQbYeoACXD4yyLGtQFe	1908	2721	2721	1616428980000	orphaned
3678	3NL99hnwTykfTLo8JoVpRdwsQXzqHHJXAK3KKvAbcds5NVrzkmvy	3676	3NKnFJCUTrbwo2LrAe1yWYfRg84jLABTtzmCsJWzv388piqeqqdp	1460	1078	29	1	3584	jx4Q1vGne5XJRFF1VJqLgAGmHAGoSqe1s3Seiz9tLZRAQB3Xe31	1909	2722	2722	1616429160000	canonical
3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	3682	3NKGufTef2ohMBEnJuGdU1kam9ZUVGhEmWB1gvftF3d8xpMJs8Dd	1481	790	29	1	3589	jxpYi9P995kbjjVZNTSNPc4a7pVxgwWA9ap6igXe58E7iFJpPnT	1913	2726	2726	1616429880000	canonical
3686	3NKAjHTQP9SZzNNa6b7mZ7QQRUBy1ktrYJ8DssgzqMoxJshsSi8p	3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	1406	1393	29	1	3592	jw8Qtm5hQMt4uoJnPxn36wwd3toXvPyiWz3buXVjnAwvsmzGT4a	1915	2730	2730	1616430600000	orphaned
3752	3NLu7MKti1uymq5CkEvRtb1syPveXgSjKG1wmhXQMFdyHdp6oi5W	3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	1483	309	29	1	3652	jxQaru2My7QDAJnSQEvVTi78huPy9J5SLJSn9h32WS3qFthgJb1	1919	2769	2769	1616437620000	orphaned
3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	3713	3NL2QTTDMfsy1AaQEhXSYXGamRfCoXeFBEpPaUSPiSEZaDUcNNgD	1403	824	30	1	3616	jwm7JdHFiEyfcYdYzBrCTise2ufkwcKaBqJEThQvbNqkSaECByQ	1929	2749	2749	1616434020000	canonical
3727	3NKS92M9MhioTsww4HPJkfFJK7Ntw8duwjHApHQ8WRWTa9PKLWtR	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	1549	1236	30	1	3628	jxibiU3KUrhFpg13eyDWzWJyyazcq9rcQ18kaLneymAStErn32P	1933	2753	2753	1616434740000	orphaned
3728	3NL5yfUHwciW9Za9z7ypEmzqe4pX87EF1BiEoSrKbYbN7QFpE53k	3724	3NLVeeC1KCXaxdaGASoGqAurp5pAf8Cv3P1FaDwb6zLCvtpBa2qk	1601	1262	30	1	3629	jxUjG6VRs7jqJvMnqEvQgJySF5HegHffPaAagTZo2wd2eYtqeG7	1934	2754	2754	1616434920000	canonical
3734	3NKjRN3AzqvUcqLbsbJNdvz3cLK3VvKbyCf2EANSnFSa7GVhF7Vi	3732	3NK7BKVBC3JQehHVd7xDQa4MKivEeFBmgh9KyC9HjR3JbseoEM1L	1455	1332	30	1	3635	jx1VYEHLqxU7ow6ZgbmoMHDecJwksQbw4QsjFSQrTCn6boMbz2o	1937	2757	2757	1616435460000	canonical
3740	3NKfbGaiQpN4uRuCydqhfP8CoxANbyt5R1btN66ok1ghrmkkXX4r	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1457	1025	30	1	3640	jwqntC9CjSvx3NHxjWDPPfBoRDHCJwia2Yhnso4J3BXBQZAk8pX	1940	2761	2761	1616436180000	orphaned
3742	3NKr5J1H3EozQvEX4nnkf96CTt3ery5sgnoX7MEx2DCRScbLBw3g	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1585	1120	30	1	3642	jxgNgLqCcbKgdwVjjHdurvEKfNGX9oiou8VSSMqSR9AiY2FF6oL	1940	2761	2761	1616436180000	orphaned
3743	3NKuwkEcWc3c75p4aQGewue37rtQdaXgbtLfPbLVb6rpvBFMgNY2	3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	1560	1291	30	1	3643	jwmATs27tesfmSirGPD7SF6BhFmgBxxmGjuidzYLkqPH7yuBtbz	1941	2762	2762	1616436360000	orphaned
3745	3NK8jPqa7eTFTEt38n79fYG1NF41fq8UVogaFikW1wV8su3qAQG5	3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	1648	1284	30	1	3645	jxc8MKatGSTYEXNF8L1mQBR8n4pT3pATyZjU3K3aivSGuTTVFma	1941	2762	2762	1616436360000	orphaned
3748	3NL2T1Bk1YbBwanCXatoGFCnAuZUPLVmNoAiGfpMKyKFAg2nn2M4	3747	3NLXPmFK5fN1u6TYCJvFZ7YF8wV2ceb2Ddv2DTYCfr8fQLt8wbnr	1422	1337	30	1	3648	jwXheMq8YAGpsNBihQpmZdgut17phRDazBLcCpyNhJDkxY7nhkC	1943	2765	2765	1616436900000	canonical
3750	3NKbUhDXm1JwniMCQzmg2J7Dg3c6n4fyPQstqr2KhD2mw6kvbi4P	3748	3NL2T1Bk1YbBwanCXatoGFCnAuZUPLVmNoAiGfpMKyKFAg2nn2M4	1407	1395	30	1	3650	jxwWkfSB9bup82h176MMH7ABLSXHVmFdUmsoRMPgfGFpDMge1oK	1944	2767	2767	1616437260000	orphaned
3753	3NLhTDsWT7QrhNqkfJtDeTAqcgFuaxV4txG8AGB2ozWc48ZuQhH8	3751	3NKKUCkyeUCJx2vB5tEHkF8GvwjXPrDJSqKsRdiBZjdYZJe9FQFa	1483	309	30	1	3653	jw7CnDbGJCMsVejWUaeMF9iidGguNGhZhq7gfSZyudLu2cvjYeS	1946	2769	2769	1616437620000	canonical
3754	3NKitqrh5wp7f6m8XgsY1r5gnfVVp2jhk8joCuEQXzbDNSx5ZHLJ	3751	3NKKUCkyeUCJx2vB5tEHkF8GvwjXPrDJSqKsRdiBZjdYZJe9FQFa	1631	794	30	1	3654	jxVaXbwxkjDV9gQ25yszF1zSYuQrVyCq5qmHb7C99JL7nP7HJUJ	1946	2769	2769	1616437620000	orphaned
3755	3NLunyXGBGRJR7854BCjBqxhQHj5V1RU9oMQ1V2JZbNfrtss6tSC	3753	3NLhTDsWT7QrhNqkfJtDeTAqcgFuaxV4txG8AGB2ozWc48ZuQhH8	1403	823	30	1	3655	jwSuLPgaXtMpvBxXR81Kj9LjnuHBN5CJH4NRFAEjUTRRoH6bJoL	1947	2770	2770	1616437800000	canonical
3757	3NKtucaDWDXHDbdRjoyT5ZDzjWJwDV1N389oTHwFC9eWX4dJDLQC	3756	3NL9Qym7zv45xcVrNrdcxxXEPXtZ6hqK8Zepv82e1QR2njFWhvWY	1500	1171	30	1	3657	jx7LziB7GThsgGQUzYNNSP63R9ZeDFvKjjn9pFiieC7R5e7yndk	1949	2774	2774	1616438520000	canonical
3758	3NLXTQpNkpKzZFngsqu1yZxHjVXNYmwZYWstgWbjzdUegpTQHWqY	3756	3NL9Qym7zv45xcVrNrdcxxXEPXtZ6hqK8Zepv82e1QR2njFWhvWY	1650	1129	30	1	3658	jwaeydygJK5pifybJCXyd8T6X1LnafVuFHkgph5KHi4tWM4zD96	1949	2774	2774	1616438520000	orphaned
3763	3NKqjdbUUkJfTfyVJnuNKY55wyF8MpgwAjBx59cjVgaVcxftvqMJ	3761	3NLuAfaeGtwypQmkYP2wv53gEB3fiCK2YkpeNehKQ8Bk2wKwhqVy	1407	1395	30	1	3663	jxcnh4NmyeQrBKq6jXsKk49fKrKtXFRc6PcjoZxZGAjzi6nPEaL	1952	2777	2777	1616439060000	orphaned
3766	3NLLpsQk6JfQoCSKCyB8UUBxc2zWaW5TePDDiNxJ7rxZeavoVvzS	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1458	1323	30	1	3666	jy1dG2ma8EkGsgozQC1XxPT2c4NsYfhB5TLCZrW4C6vxh1zx9Ca	1954	2781	2781	1616439780000	orphaned
3770	3NLaHZcUFMcDzDPJptV6nVpXuCYXX1pAbGdME1hFW8rsHXk7y5Tm	3769	3NKPzrDh5UBw2nhikfYtTskykmTK8xuXE8CzVA3FZF8gEaQu1sJB	1578	930	30	1	3670	jxKFePwunTBAGUfiud2SPZPJeH3Sp1DuLjprhBgi2Rrts37BM6Z	1956	2784	2784	1616440320000	canonical
3779	3NLWMe2dqtmkv3YHRpLpHxQSWWU9sZbLAdgFoNzX3feEenPL8gbj	3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	1633	1144	30	1	3679	jxvxS8gvavVuX3x4bkuXcBY77SK5uRXuDWFbWnAWrPin916JSHz	1959	2787	2787	1616440860000	orphaned
3781	3NLqDLyVe88TC8HnpGBWn2cFixzfZTABjryscwW4WzZVrcu6nFhn	3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	1651	1301	30	1	3680	jwfpi5D64aG9zVzvxz8me8ZnSivoNzhUHxZhoEpmbmfXQBm5HuT	1959	2787	2787	1616440860000	orphaned
3788	3NLjJpVVZZ3sX1DpkoLECwWzeeXY7TNFGUq94QVvrtPRxJJ81KND	3787	3NLpJxSEb3S86yiFNWaWF47WYGS7XjqRKmd6sPFTqiW3AT9cwFVu	1546	1339	31	1	3685	jxBKDpcXAhRbpvvYizW9mxbRA5yE4M9DQy58ix67UAQZgVB2GK6	1962	2792	2792	1616441760000	canonical
3789	3NL96JyxDzrzXxpvSuht6Bsx3LaYnzz4iHf5pD4Q9L1cbdm6TyTH	3788	3NLjJpVVZZ3sX1DpkoLECwWzeeXY7TNFGUq94QVvrtPRxJJ81KND	1444	1381	31	1	3686	jw8aQyVpPQDrz8k2DFjDm5sudk1rzZxHJ9sAXLfEwG5VW2FH78c	1963	2796	2796	1616442480000	canonical
8500	3NKCjs1VpfxvrLBBgfU2aDSPc9cddmoYQATFjHSVSko7ESpjFZFZ	8498	3NLW5mCGtz3qUHVHBiU9n5FKBkmKvcos1Fa7xRhqWb9moTefuSby	1611	1341	100	1	6301	jy1mmk3iqaK2s9ykUrd78j792WGqEGZ6GmyWTPEhoYAGtS2CwJx	4402	6199	6199	1617055020000	orphaned
3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	1445	924	29	1	3578	jwRgSny8NmVvGhxS3HxXSkZk1JdDvpZpepZAhMck98L6DwkZVUZ	1907	2720	2720	1616428800000	canonical
3673	3NKJBZ6zUQJ6hTvB188LGz6kiYya9D7cD3FautqqR7eZ6VyzdYAn	3670	3NKkMBXimhNRdSgXtW6zdRh8GhRbseNyL3XuKexW5FBFwgJceD1X	1587	1111	29	1	3579	jxvaPLA1Fm7pVoVPpWYSiP5nhRE5YCUVLq81QQXoFtVeiTTCGD2	1907	2720	2720	1616428800000	orphaned
3676	3NKnFJCUTrbwo2LrAe1yWYfRg84jLABTtzmCsJWzv388piqeqqdp	3671	3NKhQPUHEHpKCh7Vvv659rkS5nUfEukCBJbMSpxhxYvP4A2rmYwD	1407	1395	29	1	3582	jxnefG9NS2uoautsgkrEcnrtcaf2qT5Wu8jtnLwTw7R7crS8Ytd	1908	2721	2721	1616428980000	canonical
3680	3NL1nSFSsBM6x2aYT9FbYaG3NBXbWfzxkiEzyiwW57nKoV1XET9F	3679	3NKbYLnQy6dydjk7RkBb9EC7VSC78YwYszyrX8iVzk2Fw8LDtaE6	1483	1276	29	1	3586	jxLmmq297bmgdNdvq31VJFRCWB1chhzZDUS9r21jhYcSGDYaHrZ	1911	2724	2724	1616429520000	orphaned
3688	3NLd9D3Z9cGpeeHWPQztqkReVmxhrZAX7dg3kiGXMSuqZxwiGfqE	3685	3NKD6EgEDw5nhKYD2e4u52BNKqkGDFUyTpdKKgXA84P6XYZge46m	1637	816	29	1	3594	jxHqe7NDk22TBkcdEFLYJShFYyFYZYoMSWMFybyqR2rzubb4kLQ	1915	2730	2730	1616430600000	orphaned
3690	3NK5C24wh3eKaaJg12rqgKTScoHK2zap4Whc1qCczr8TZjuTrhoE	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	1642	1121	29	1	3596	jw8ZxkCpTrecM9UY8jXLb8kaQhjKshg4a2VEBUKjgpVfTVzasD8	1916	2731	2731	1616430780000	orphaned
3695	3NL6hYZbGFxHeXQDKNXBBAepGWCE8ta8rwgUK4Msku92gyBuDcLm	3694	3NKunuma8kbfKZpLS4b91ArRXuubxVvxKGHHUUN9SWDeNt7RK2RZ	1651	1301	29	1	3600	jx4tKCni7YKQeZhksFhTCJ6kvqbLcw7bCWe2nVdKLpe55gx7PTz	1919	2735	2735	1616431500000	orphaned
3697	3NLU87bRMxEV7qFuRCuEdCF26gGKripfPAuAZLxGhDjeZv1K1nFb	3696	3NKhBAnxGWXmngpeRbduywWZN2xM9dgEeZMyuR3LvG5w8FtyANEQ	1406	1393	29	1	3601	jwK3MtUtvajPQgcpvpWf5P7tg7wq5xa5wAWhDV7c9fMRXXhY3Pv	1920	2736	2736	1616431680000	canonical
3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	3697	3NLU87bRMxEV7qFuRCuEdCF26gGKripfPAuAZLxGhDjeZv1K1nFb	1406	1393	29	1	3604	jwsjwSiCWNXbKErnK8dcKoTHFPXQpkt43p6uvaMoXxzB5YX1ND7	1921	2737	2737	1616431860000	canonical
3702	3NL8zFUA1eYqUshwNrbmpCs3GyxQrmG9GGb45EeHrbLCR6MCMEcg	3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	1489	1380	29	1	3606	jxLwBQ8cnDAcCsPJRZJG59Vc4QAPLeTPvZdyGMbinh1UxZjvQnm	1922	2738	2738	1616432040000	orphaned
3704	3NKKYrdmScuwFhVu5F2eDxkBHiLW9Ys8CByTBNYED3zkupmZrJ5N	3703	3NK86wawX9PFs5uc4du8BxToLwkWpnzJzGwWEnnPfqm8b582Nza9	1458	1323	30	1	3607	jwWo1PtXk2M5w29QyBL4hH6Rp1bdwyeS4JUea2KooeNz2k7ooV5	1923	2739	2739	1616432220000	orphaned
3710	3NKa2xSaBqLZ3o6vQhDtS3tUauK3CaPx91p7coBa5eV6sJDekyrQ	3709	3NKo9KGRZ55DF4sdV61NCUnsw19jkh7Sd96Mnmbc1wLqyCPCxf4x	1571	1209	30	1	3612	jwBDWNJWAFW88Ht4dYATtCjxG5de9bFy8b1jDZFTQTVLN7puLmH	1927	2747	2747	1616433660000	orphaned
3717	3NLwdAUCeEHTFiPErm7EjzeRKoAQBKFTTSKJEo7HoDvEQxAhqUUo	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1461	1271	30	1	3618	jx4bY8SUfDCLtvws59PA2CktZHd6CN48aKWma5QeTxYYD1bYqj2	1930	2750	2750	1616434200000	orphaned
3721	3NLB1ZwHTzgZvPEF4LBjXHtdsQgbepFjotFToSBdoy4G1QZVhHQu	3716	3NLkSvoBjX4QGPDCbgtQHc6P6c8AWzeabfHQeD1jDyo7mHZvQJTV	1407	1395	30	1	3622	jwcZryqrUfvW3s7hcW4oAf9Go8i29su3vspiVBV1dwpqE6Pm9Sq	1931	2751	2751	1616434380000	orphaned
3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	3722	3NKmtfU2MD1CsZNA1borssZXz335D8naQAG4vA5ymR5zemtepAyW	1402	850	30	1	3624	jwMExbZCbZvH6QyiNudDST9X7X4iTZXDbKDM7M6vvcNAmPqtKny	1932	2752	2752	1616434560000	canonical
3791	3NLggzCox6pp8jmBDjZGQ5XaZBUfkdhJAqykgZgVEjorSY3i1s12	3753	3NLhTDsWT7QrhNqkfJtDeTAqcgFuaxV4txG8AGB2ozWc48ZuQhH8	1640	174	30	1	3688	jxo2iEne3DCCmNbfwmnkf7BqYG8WU3tL5J8DMxBV63xSDRutEJC	1947	2797	2797	1616442660000	orphaned
3762	3NLRNte27CJ4eZXwffJjBXdfmahmomiSN38eQgNCHKJA3rMVpDFE	3761	3NLuAfaeGtwypQmkYP2wv53gEB3fiCK2YkpeNehKQ8Bk2wKwhqVy	1406	1393	30	1	3662	jwxbUBKk4jj54H4f4B8aFV6hfThQvavZQp4absxoHVtXFfJKZcY	1952	2777	2777	1616439060000	canonical
3765	3NKY4J8wkEukJYdMeVHYwQNef3xcv2UJXu7XKVQKzUusgYShEZWx	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1444	1135	30	1	3665	jxn1hJJ81XFPPHzPmUtwhn68WkhrcmMEgTgx5LSiaU4oZ4AegZF	1954	2781	2781	1616439780000	orphaned
3772	3NLmD6DccVF1RXA3PhDp68jLKv779s8T3EvH7Ffhw6v1R1KHaPVX	3770	3NLaHZcUFMcDzDPJptV6nVpXuCYXX1pAbGdME1hFW8rsHXk7y5Tm	1602	1369	30	1	3672	jxgw4jcE2txKuggs7PKkCaUpNMUfCV9k5GYXWMbc91vv6XnHNJW	1957	2785	2785	1616440500000	orphaned
3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	3775	3NKbfe6CowwC6VVavk5hMUBFuPj4haFuZsVBTTuf5s9JZux4x1bf	1406	1393	30	1	3678	jwyJDgGrnESRcqt86gR7UKBKD8kZ2yib8kUakoKie7vR1vMMr8k	1958	2786	2786	1616440680000	canonical
3784	3NKGPZGporDxG3h3Bqm97FRvutobQ5tgyrTw6Gp7ddRSLyoLQRXC	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1403	782	30	1	3682	jwEcAmbcA9rUvDqi38EW8s58Nu4hVgExN1pqeqFJjgxNkWYxZdd	1960	2789	2789	1616441220000	canonical
3787	3NLpJxSEb3S86yiFNWaWF47WYGS7XjqRKmd6sPFTqiW3AT9cwFVu	3784	3NKGPZGporDxG3h3Bqm97FRvutobQ5tgyrTw6Gp7ddRSLyoLQRXC	1407	1395	31	1	3684	jxgfBiAKhZ6Z9mK5r3yUEH5q8tGAEoVxTnYRvMbgmiFtBRJAfPK	1961	2790	2790	1616441400000	canonical
3793	3NL3Wvvzyk5QrYhyLDrphVNqoSHiSPfd5xAPRXQkA5qJx3EYTaV6	3789	3NL96JyxDzrzXxpvSuht6Bsx3LaYnzz4iHf5pD4Q9L1cbdm6TyTH	1581	778	31	1	3690	jwpEwKK3JsZzR3ybagwgGtRVvHu1ywLRqL3dtbWW9sNfYJqqZAM	1964	2797	2797	1616442660000	orphaned
3798	3NKQ2Q6Ys6jBAcCp2xmbDed4Kcn8ny2TD5Z2YTNAWh8iSwPFH5ev	3796	3NLin2XK1SbVdgxiocsdmHXFv78ZseMQ6bjDePApCFQDYnmC5zf2	1407	1395	31	1	3695	jwXrniUGcNhi4hc19ewzYSXNWzDgc7PWo29JWPey3ADfMXCv6m9	1968	2801	2801	1616443380000	canonical
3801	3NKGYPxVLH7cDgo44RJMKoD9pGnopZh7V9VRd9odxyVuFdGRDc5H	3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	532	1303	31	1	3698	jwBvX1doByz52vz6p5bMx6WqP7maPsqkBGqoVa3kfmV51BBP9Ja	1970	2804	2804	1616443920000	canonical
3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	3801	3NKGYPxVLH7cDgo44RJMKoD9pGnopZh7V9VRd9odxyVuFdGRDc5H	1573	1318	31	1	3700	jwSUsT4r6idDvZ77U3bfyEpx6aRcFE32U2aEKfCRh662YPikBn1	1971	2805	2805	1616444100000	canonical
3808	3NKnUxffXV3vKEX9Z7UfvvsEduoZpxfmibQrx4ntrafC2wVP87Bd	3807	3NKshXrALu36Q4bQRVmUcnnwgCo2Te9spHmxTfiCqAe4DKLmniLX	1406	1393	31	1	3705	jxSZFEHYNCgdchTcQ4CAaZg86ZH7qUjvwLRxyQNdw8X8u1yTW99	1974	2810	2810	1616445000000	canonical
3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	3809	3NKkCqw3STrMdBswEEAgzh8eyvQFfDNwiJifgYn9VceTjSH8SRno	1407	1395	31	1	3708	jxfRmBtVxRdbZtrDagpV3z4yCQmVuedFs1eMWWmY2o673pbRDN9	1976	2812	2812	1616445360000	canonical
3813	3NLHhwp6MHcdQy6561VnCQSJVvNpvJn4W6LVRv493qPjYYs9njZN	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1652	1315	31	1	3710	jxhti67xZeNke7XtmT41gjDPBioFCJGDfRvCk7eEwHfDFUJheqD	1977	2814	2814	1616445720000	orphaned
8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	8523	3NKf6tuj27an2SoEN3DjK3Avi9GD9tvZ8dvC4iCG71Z4T38JSkjA	1483	35	100	1	6301	jx21UFspVhsrVqNBYC3agR1Fh64VyVYZiCxv1oMvn1N1LybaEy5	4417	6217	6217	1617058260000	canonical
9752	3NKFuXAR7cNJg4fg9SxXG9gwJBAsigdtbcZznsCo2oCa7HzhcGL9	9750	3NL8hMgEzVHRGqXgrVFkioZcUxicdNx4q9JUPXr1dxB4wLupBZpa	1542	1178	126	1	6301	jwDBKeLZixoLN52MoACwhp7ZhATsJUU6vGbTFwJVbABjjR49bQW	5052	7110	7110	1617219000000	canonical
10302	3NLUkFSz3aupdu4Pk68cigEe1ShS3CFRLmDw69nqbuGwyyrUK8ts	10257	3NKoQhQqo2Bb11CitfWg8MQS6GDLfVHHUT68p3ECunFABf9LbFaN	1637	816	131	6301	6776	jwTTWVrSUyj34Ww7CgNrp4yN8AkWnTvVfEJJkBLqXTPb3zwh3QD	5178	7509	7509	1617290820000	orphaned
3777	3NKz5LoyWfVm1DbFbpLDFDzwnm6W1t1rc2toKhefB3PhPd4trWv2	3563	3NK97pt75o9R8FmDydCDQwRDrjFRbFcUuzZ8vSiVGpQGCaZeikqt	1602	1369	28	1	3677	jwRn1vVi6zupfRHfCEBVrFUdYtZLjXQYMFEyGQBiWrdD8QePoAX	1850	2785	2785	1616440620053	orphaned
3732	3NK7BKVBC3JQehHVd7xDQa4MKivEeFBmgh9KyC9HjR3JbseoEM1L	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1406	1393	30	1	3633	jxru9H5j1hJKHnB3rmJVz3DRSSiVip2ujwmYkK5gCkUibFFzUXV	1936	2756	2756	1616435280000	canonical
3730	3NLFNjF9gJLbrxjERugyBdQDwtwCxuMoqYQLxXbTLVsRkV4yWwoz	3729	3NLQ6SeLbgPHWnmdLTSn7fCHNmEffTt5CKRi4x3J1WPBj45mAWEB	1579	1263	30	1	3631	jwPZbZaGBziqEFfwjttxvk5vDEizo6bUNXLJjA3DV1jCQwEyUtE	1936	2756	2756	1616435280000	orphaned
3735	3NLqfeT9SjT7xSgvQCpVKMgwqxXr4PwQk1nhvmx9QPHhUvBsL4Qx	3734	3NKjRN3AzqvUcqLbsbJNdvz3cLK3VvKbyCf2EANSnFSa7GVhF7Vi	1651	1301	30	1	3636	jxrrQ8FbdaXYV9LrFNsYzTwhaPvDGsJoDh7fhdzjC5a5smpeqYo	1938	2759	2759	1616435820000	orphaned
3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	1573	952	30	1	3639	jxP9PkyM5qDnL4dPy47NpggUvnpdpoK1Hwhnc7ZahnxLPTBYuAG	1939	2760	2760	1616436000000	canonical
3737	3NK9ZRgVcsKEUMHtqfGdbCtSMgkZZNWq8APrb9weUT8QHMG1Vm5n	3736	3NKU45ExMkWeTXkWsgfj7YaPWw2umANuk9uDMrsjPDni82S6qpFd	1654	1340	30	1	3637	jwXwjyZVL4GukruoKEcy2Wxe1MiquRUvomxvWBXssvgZu9m69X2	1939	2760	2760	1616436000000	orphaned
3744	3NLUAuRK6NY8yacBLQYPJ2n8bAKPGNimy7B5TC89dJdnjxiEA2Yb	3741	3NKkKmGkdRHkx1ZFGo8Pyikb42tsMNyHyhx3krZxyrLgvpSfBBZ4	1407	1395	30	1	3644	jxvjAMJceorUnKjxsz4v8iw3LPNFWPvARTdQA7PZvpRZyyckUEH	1941	2762	2762	1616436360000	canonical
3746	3NK5StAxBCKUeEjEPc6UaMikdTVjQr948a2F4cnUoW4bmCxpv52Q	3744	3NLUAuRK6NY8yacBLQYPJ2n8bAKPGNimy7B5TC89dJdnjxiEA2Yb	1534	1191	30	1	3646	jwYUcPPTs18Ubt9dmU65NbktK4L96oSmvB9EHesK2HJqKrHybW1	1942	2764	2764	1616436720000	orphaned
3751	3NKKUCkyeUCJx2vB5tEHkF8GvwjXPrDJSqKsRdiBZjdYZJe9FQFa	3749	3NK76pK3AkYRvuQMuoJgcv48sLLTJDYLkaotJ8v6GuW21jhj7xj3	1403	824	30	1	3651	jwYgsyEWwBJKbfpkoTDqXSRE6gMRonGC8XdTPCZfyChUua6UnRE	1945	2768	2768	1616437440000	canonical
3756	3NL9Qym7zv45xcVrNrdcxxXEPXtZ6hqK8Zepv82e1QR2njFWhvWY	3755	3NLunyXGBGRJR7854BCjBqxhQHj5V1RU9oMQ1V2JZbNfrtss6tSC	563	1359	30	1	3656	jx8G2YyetFW52fPfBmfo7UiRuFTtdYU1HB8YJ83uhsmdH1cLSVZ	1948	2772	2772	1616438160000	canonical
3761	3NLuAfaeGtwypQmkYP2wv53gEB3fiCK2YkpeNehKQ8Bk2wKwhqVy	3760	3NKZXF36MyygqyaLuVXrHEYy6W9zKAXcMnSaCYTQB136MgUyhutq	1578	1296	30	1	3661	jxxzGHaiTYoXsq15wBGMi9ne7pNmBjrnBdUhGZmynb11WRHvixW	1951	2776	2776	1616438880000	canonical
3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	3762	3NLRNte27CJ4eZXwffJjBXdfmahmomiSN38eQgNCHKJA3rMVpDFE	1609	1207	30	1	3664	jxHN4nX1gjdDtWouSd9nY6zczXAik52QU8z34c2DHagzqVDPqmZ	1953	2779	2779	1616439420000	canonical
3769	3NKPzrDh5UBw2nhikfYtTskykmTK8xuXE8CzVA3FZF8gEaQu1sJB	3768	3NKUMo9gkPHMykkWkiCdPZ84BuAoPNm3Yr7TJirQXEA6cj9yzDhh	1593	1346	30	1	3669	jxpgQidtknrG3jot8pDv1SkkmVt8VE5iDZFaftwM81NxUJTRXwn	1955	2783	2783	1616440140000	canonical
3771	3NKHqSxBCdNgQvmqjjWxZ4YYswUqyoHDPorAv621ydH53rF6yFXv	3769	3NKPzrDh5UBw2nhikfYtTskykmTK8xuXE8CzVA3FZF8gEaQu1sJB	1406	1393	30	1	3671	jwCmZDefh8i9NoB4NsqPG1W24yiFs9kG8NUDWT5KJRSBAEEr4X9	1956	2784	2784	1616440320000	orphaned
3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	3778	3NLcdUJ3LhhkmD5gnWksQAw8UvVwxrwZcvoqy86gMhfmtjoZNzXu	1651	1301	30	1	3680	jxwBtCQU2dUPxz3FbsdAGgdsJ5Sj598zqFPx7z3SB4ah8kqadY1	1959	2787	2787	1616440860000	canonical
3783	3NKS4r6SHGsZMv5RvJLvVTfQpYMNKZ5tMD2ib1DdUWPiV9udJJjn	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1460	629	30	1	3681	jxm8BDwRvegHaPhMESJRiKnD2HQke9J5AtRSRYpN8wTsv3YbPir	1960	2789	2789	1616441220000	orphaned
3790	3NLMnzKhYkFLWw5UbS5aRzcDLfVix2q76Nw15659WgfX1EiaFzCS	3788	3NLjJpVVZZ3sX1DpkoLECwWzeeXY7TNFGUq94QVvrtPRxJJ81KND	1440	1251	31	1	3687	jxHV2ydyZWsmzijrBAqHJWaHbLB9aBo2mT4vdqG2ZxqErk6JsBN	1963	2796	2796	1616442480000	orphaned
3792	3NKTipy3tHkTZ6ZwxpqBHh9icvPZKHnuhe3dt1QoxMVqEkpD9Mno	3789	3NL96JyxDzrzXxpvSuht6Bsx3LaYnzz4iHf5pD4Q9L1cbdm6TyTH	1640	174	31	1	3689	jxtRHmY3R6Q4gm8WMVnvCuNVo5UqhJkSGujZ5dnzSqDsvFntfdJ	1964	2797	2797	1616442660000	canonical
3794	3NK3oQRG4Yx8CaXsEzQVT3CLfKD8CsMfAEWAUuTkzuBjzoutARBg	3792	3NKTipy3tHkTZ6ZwxpqBHh9icvPZKHnuhe3dt1QoxMVqEkpD9Mno	1501	148	31	1	3691	jwd2Fv8VcJpRqUQcDGv25fwyp1u4j7eQLmsot98rCSzPtFCZzCV	1965	2798	2798	1616442840000	canonical
3797	3NKNMQVjiEMkiD5GnazPz8hLMNRacrBLXj9L5RbDmooN4TK1Kz87	3796	3NLin2XK1SbVdgxiocsdmHXFv78ZseMQ6bjDePApCFQDYnmC5zf2	484	1073	31	1	3694	jxsmik3GTRbREYSaMT82PJLwqabpZz1WKFkyXPp3Jme6a9Edwjd	1968	2801	2801	1616443380000	orphaned
3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	3798	3NKQ2Q6Ys6jBAcCp2xmbDed4Kcn8ny2TD5Z2YTNAWh8iSwPFH5ev	1617	922	31	1	3696	jxEgowiBck34AYZCEHVc3S9nLJ9XRsMvsgBdCrUjFp8CkKtVowk	1969	2802	2802	1616443560000	canonical
3805	3NKwT2YShrCSjuJRk32wfnF4rw56E2M2TMYdFgh1wtf3bwnKeZFR	3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	1522	1322	31	1	3702	jwK6qhxJ3Vpu7ziLSK9LKvBh2p9q1syrmkCnbea2wNBmRP96vPG	1972	2808	2808	1616444640000	orphaned
3807	3NKshXrALu36Q4bQRVmUcnnwgCo2Te9spHmxTfiCqAe4DKLmniLX	3806	3NKLiwH1EX2aGV3rJxMCEuPTHmMpVx9YG9VQK6UYA15ft7mJuinv	1546	1213	31	1	3704	jwdvH6mfBw755Q846j1gTW1p7bLqHsad29hMhcnPnyyYtcaLrTR	1973	2809	2809	1616444820000	canonical
3812	3NLWZJnjrM7EjamLMwSVnFt4bVJHeXUB31kevCGRYDPzyfXRkU4L	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1407	1395	31	1	3709	jwz4nJBaM1FvyJfnpu2kJtZXKxPkj2jpPCHPh6aeHRXWXQcHoCW	1977	2814	2814	1616445720000	orphaned
3817	3NKzUV4PBp4WfzjeRPSUw19RDTXxcmQkVQHd1sTrL82jEudmBPEe	3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	1406	1393	31	1	3713	jxk8Ywis3MUe6xgdcQLSFTkCAp1Pu2h6AZpNiNjmcwRNCbXeX4n	1978	2815	2815	1616445900000	canonical
3821	3NLosiSiGNRYwKn1szGQEZyn216b8Q3wqpMVh7Sg6vghKY8K3Sbf	3819	3NLgqA4qUdsoeVogrw58uyEx8fwFTXeJKEyr9PJ4ZLbeQnopGF2R	1403	786	31	1	3717	jxsQwgpx5egjGfhEctq9SZnvDbZthrVuRLS8jLf3A48N8MMQ7vA	1980	2817	2817	1616446260000	canonical
3824	3NLjKRM8n23K2rcmpsKMyhix4cN2zWzuxatbHEaawQ7QjVWBQvyP	3823	3NKenvs4qDPoykEMKB6WquAd9ApdAsa7f4pFMxuH4dVjKMcTgVzc	1406	1393	31	1	3720	jxCHJeXHxwwkHV65pN9hAFWLZ3ojFa9tMe8BpmAVHqtWGokL8YG	1983	2821	2821	1616446980000	canonical
8725	3NKZnSphCvvarHEXUGCPv3vm75XXSdYzuYkEEdaPuKU3fqafgiik	8688	3NLsDNXagApFN6XzRjoNpmoHJqNudek3abgitrmEK7S9uE5T8YEk	1553	776	100	1	6301	jx8eg5UXAhCDWreyw6WKsCbgPWLAmcm22gVbG74tfi7r9nUeLmU	4422	6381	6381	1617087780000	orphaned
3795	3NKAJCTrs2qYvXyTjtKdkEWJWRChK5kWQ2ka6ZeW35cAeP5zvoLL	3794	3NK3oQRG4Yx8CaXsEzQVT3CLfKD8CsMfAEWAUuTkzuBjzoutARBg	1403	824	31	1	3692	jxeCMGJBAbRyNvuVrHhdNU2aiyzo5sMX3P7CQoGdnhLWpbmxCyh	1966	2799	2799	1616443020000	canonical
3800	3NLZCSuwnYvSMBkxNqoaVkyuzgmPmfDkMk2mog1KZBj45kGqdxdA	3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	1405	873	31	1	3697	jw8sJ9EzrjwUVmR18UQKVbXHw9tfyZXyVYjDj9jMqr1yL8cit2k	1970	2804	2804	1616443920000	orphaned
3810	3NL7vbLv2zjFViJcRXHZeuUXV8SgcbDz17KQKuuj4EjfjSzg9KYH	3809	3NKkCqw3STrMdBswEEAgzh8eyvQFfDNwiJifgYn9VceTjSH8SRno	1589	920	31	1	3707	jwRwz4T17WQieJLaxkFMj5SB7VKyXogFWFmyGBno22JFXnjaibS	1976	2812	2812	1616445360000	orphaned
3815	3NLi59YrjJQm9o3QscrbsgaK5ULkHMm6J9fNE4GSqEa4fcPggXDA	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1651	1055	31	1	3711	jwv48iSVghcbH82vP6aLot4utsuxnMKaSxozytN91Wmu83wzpbs	1977	2814	2814	1616445720000	orphaned
3819	3NLgqA4qUdsoeVogrw58uyEx8fwFTXeJKEyr9PJ4ZLbeQnopGF2R	3817	3NKzUV4PBp4WfzjeRPSUw19RDTXxcmQkVQHd1sTrL82jEudmBPEe	1630	655	31	1	3715	jy19oC9afxUGBuoKovHcqEwPJcNa5F6tsWFBBh52P8MQ3N5dccW	1979	2816	2816	1616446080000	canonical
3827	3NLg7FdvVDEYM7HrJbxgXHUY3QGzyXXiZUFGHp6imsMVqwwMAwha	3825	3NLiTLEGpoUjYecXesqhFFL58zjecV6fpUiWoCM9tz749jX6BpM8	1516	1294	31	1	3723	jwTLLy52kAdHViqu9SBwKQT7FZuX99qpzj8cjtqE9vWA8SXfBvV	1985	2823	2823	1616447340000	canonical
3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	3828	3NKrrcvrKZhHnvfwQ9mTYU1RzynmnfMPxVhu37LV2Sns4cVvwNPb	43	1184	31	1	3725	jwk6nVPGAHri7xuNPTtJ2NgVJsB6gJUF8SG1x88yv9hr2ytA67N	1987	2825	2825	1616447700000	canonical
3831	3NK9f3kSnvcctEkRTgknX6driFPdc1JiM2kYoRpT468xs33XFo8N	3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	42	1115	31	1	3727	jxMsPN3hTvLAbZ3up4rdWYQ9hJ9aqWWsTmcfaVxEoch2f4eBokP	1988	2826	2826	1616447880000	canonical
3832	3NLV8G2zAkD477WsK2uu9k6kiSv4ey8ef8XksWPbQojQnS6QABsT	3831	3NK9f3kSnvcctEkRTgknX6driFPdc1JiM2kYoRpT468xs33XFo8N	1553	776	31	1	3728	jwz8gjKpDaADh7LB2bA2iyeGMjHeGLf4kov2kbcxnboCF1HZxcT	1989	2829	2829	1616448420000	canonical
3833	3NKyQWAJ9AeA8GGB69A2K4LUSAB2eMz2GNC4X61CZfpn3mvaU7Qt	3832	3NLV8G2zAkD477WsK2uu9k6kiSv4ey8ef8XksWPbQojQnS6QABsT	1652	1069	31	1	3729	jxdKheiQ1LDeofCbKfeF2PGRWhEcuchNE54seCCWRgMfcKpEw8u	1990	2831	2831	1616448780000	canonical
3835	3NKugtjavkmxSZkHM5t7cf1pCCbd16oUPhvBsm9tX52Vn7M5Yg6x	3834	3NKKJgLEsLjqQHqnuM95HtJSq3696Nx7bJW8ehi5DyJYbb92cfNv	1481	790	31	1	3731	jwdU7G8eWGTyoG2rdqyCLNCaCStpo69odrfcK5cdXK5SEjRx1qU	1992	2834	2834	1616449320000	canonical
3836	3NKDSFZN866cAN4eQyVEEGHPjqZrMsFqBq2Rh8LMMcfdEDBjFrH1	3835	3NKugtjavkmxSZkHM5t7cf1pCCbd16oUPhvBsm9tX52Vn7M5Yg6x	1549	1116	31	1	3732	jx1W2JGP375MUkwVuKTyWKQuzBrMWYCiwUdoRC4kkWAUcBfuTkG	1993	2836	2836	1616449680000	canonical
3838	3NKXgb4LdTRoNgaMfSCfMqkcc7JfRDveozv7brcswVzya6ekjoB1	3837	3NKzcqy5YBjsB8bvFJUh1Y1WudnskUFvjew24oabMCVJ9aMwff16	1407	1395	31	1	3734	jwr4g8HACNzPP6uAjYjSCksnDcnjdD6rk5Kj3wCNG1e6aHDZzjd	1995	2838	2838	1616450040000	canonical
3839	3NLyCyhCspwAhm83YRe6NoFJypHctxqbzp8DZxKcrH8GusxgHewk	3837	3NKzcqy5YBjsB8bvFJUh1Y1WudnskUFvjew24oabMCVJ9aMwff16	1643	1299	31	1	3735	jwn2U18a2vFsu6xB6f8PgcgXriBAcXxLnGHY9jABhWrNypqXwfn	1995	2838	2838	1616450040000	orphaned
3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	3838	3NKXgb4LdTRoNgaMfSCfMqkcc7JfRDveozv7brcswVzya6ekjoB1	1407	1395	31	1	3737	jx9pR2KpKnbX598quSwxSKmZw12b5KNaUNPNmecW5dieajBzzyw	1996	2839	2839	1616450220000	canonical
3846	3NLDsfTFahAfqkpZYkToh1E7BSesb2vZBjKTKb5FVSkTq7nYNk1D	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	152	1330	32	1	3740	jw9czh2jWGs6w8TUpSXBQANEQYyQmGBkhQpVi5ifAaz94rmmj5o	1997	2841	2841	1616450580000	canonical
3844	3NKt8N27m3iBuB9WXJQE1tXd29FH9GCrW3PhKHm2JSJCyEKijjMg	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	1406	1393	32	1	3739	jxajMb3NukmtjBPjTbytSTxoGmKHQmTucwEbxUxrLN7DUKB9SJL	1997	2841	2841	1616450580000	orphaned
3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	3846	3NLDsfTFahAfqkpZYkToh1E7BSesb2vZBjKTKb5FVSkTq7nYNk1D	1610	1188	32	1	3741	jwnRNassGZyG4SXbhsGL6MntmJoUYARo6eFBuk9SUSKThtGLzA1	1998	2842	2842	1616450760000	canonical
3850	3NKPoxYaVwpiCGf7FLMAwJByP8bqSDa4Tj2ew7FJFY2Faj3VHGwR	3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	1451	1166	32	1	3744	jwoqczArYT6CNossAzowM9wkXUinGves12VY338o45TQjhgor9y	1999	2844	2844	1616451120000	canonical
3852	3NK4GWQAVN1k9th44ij1xrhDzigMqmXEJhhFvWa5RWKoHv4mR3ga	3850	3NKPoxYaVwpiCGf7FLMAwJByP8bqSDa4Tj2ew7FJFY2Faj3VHGwR	1579	1389	32	1	3746	jwFSM749nQa2AEQGV3cJAw5HhKyUgZ6UzHHdGTpvdeeMFRs8CAA	2000	2845	2845	1616451300000	orphaned
3854	3NLNRnCa9cW8Uz3hZp2eZMWSZ8ETBUi7SYjqUvRD3A3aHusF9nvE	3853	3NK8ukCSK6uqQjquoNdbSQHgaoNDJvbJvbFdW5xNWNBF7rkcQ9RK	1601	1388	32	1	3748	jxceU64ResCjMNdZx8EvBTK3u1w8bxChp2bLQabs2qWUU8NeQCB	2001	2846	2846	1616451480000	canonical
3855	3NLBrohCjHzr72HRYiknNsaiQch2UgQUcAjipwAeVHfKWaQmtbub	3854	3NLNRnCa9cW8Uz3hZp2eZMWSZ8ETBUi7SYjqUvRD3A3aHusF9nvE	152	1204	32	1	3749	jxsSWCqNV5q2obY6PWp8DXLKLRGCTUADcmHCmxzLfUYHDmR1p1t	2002	2850	2850	1616452200000	orphaned
3858	3NKgjpSHLj7U88DQocXqT15J4jcvozF4LBziyhe1uPRocJ4AZ6Cw	3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	1407	1395	32	1	3752	jxpgs5DXuzMqXfayaWZBRrLTMPD13eE9xiNxnU6U89ke65T9ap2	2003	2851	2851	1616452380000	orphaned
3860	3NLT7FBKiCNpUhuqaSPiqnHLfigjnu7DTFqByiFYoRLVwWZUAQ7c	3857	3NK54ZgfDXE7ktCkaJr3JMJYYQj62mGKkAxEWWVZbyruWZ5CrQM1	1647	936	32	1	3754	jy3DQpVKsH3op9gMRxRmjCRS6kUor1jX3gpUg32V6opxek6GCnX	2004	2852	2852	1616452560000	canonical
3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	3860	3NLT7FBKiCNpUhuqaSPiqnHLfigjnu7DTFqByiFYoRLVwWZUAQ7c	1407	1395	32	1	3756	jy3FEUR19r1bPG7ny7572ie7Q9MbsX8mfbhPVLoGLXtRRqcjYwL	2005	2853	2853	1616452740000	canonical
3863	3NLdZX8dgyyxZE5vnmHnkZfMz8nyEd38HyQ4MizxscikD2aLpTTY	3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	1407	1395	32	1	3757	jwnDyh7bLD4GN49SA4a3AvyMK5BuSD3cycPioZDCypJi84S1Q1A	2006	2856	2856	1616453280000	canonical
3870	3NK5baDtoeXNW4PwjTdrpHkGUaaaUZ3YVateYVNGUZp4EdM6ytqL	3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	1467	1130	32	1	3764	jwdFeMr7FDdjkAiVHssCsBtHWXbRDBDLj5NF8bBwEqnYTfqcYzR	2010	2861	2861	1616454180000	canonical
3872	3NKgBfoekfUpL9Byc4qekYTHpfbF36NX8LEGruAAdWoX2aqtWxgT	3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	1585	1366	32	1	3766	jxsqV6bSNrtSn8HTUw3U17UyLa7fXGb9wZyGGPqXiqQYcD8g9pp	2010	2861	2861	1616454180000	orphaned
3877	3NLoRE15kgusmnwnbvRvR2uTzMa36m9RkoNNArw1gAvfWxEmE7V6	3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	1656	1217	32	1	3771	jwdw8A1KuztkoQ5kCcghNHxu22ReUu1ZX51hY1h975mJkqvBkcG	2014	2865	2865	1616454900000	canonical
8790	3NLQBPSRwPHqsDkoQoKD1bJdtxob51K5Fqa223EqsnsA1EH3CJ6D	8789	3NLa1AA5LgJrVMcZcizyvasB36wK2dAvqhhu8fJscSrDYzX6Gqj3	1553	776	100	1	6301	jxPkpjXHTPsnXGJ9EG9oRe4mgUUDJhDtBre7eV83UcGGxsGyiM8	4424	6421	6421	1617094980000	orphaned
3913	3NKFoZBiL9HzHiqCubvaXhPr5ifNRvS8NjkhQHi2ojdodRU1Z8TG	3631	3NKpgMZfMkALCXSzvMEge16T172gyHkqzctwEFE8Mp3CLf8ovyQh	1536	1313	29	1	3807	jwkmYc46Hs2cjJHMwxynWLjHVWRkNukbqpBWRMHDne87LVA6K1L	1882	2888	2888	1616459075705	orphaned
3840	3NLcpV6BejPBSpZMQEfp2kmwj8zQ4QUaVx4CpyeWxRAS7pFUXqgi	3643	3NLCCYJhtxG3YN1o9p1asmfE5dMd8TGB6jYjmZ33HEEPbBbLiLQy	1643	1299	29	1	3736	jwgaFpeycLy6N4cv4BHnnAQidNm2B4S5nPvt1FFdDBgaErgPN7z	1891	2838	2838	1616450040000	orphaned
3796	3NLin2XK1SbVdgxiocsdmHXFv78ZseMQ6bjDePApCFQDYnmC5zf2	3795	3NKAJCTrs2qYvXyTjtKdkEWJWRChK5kWQ2ka6ZeW35cAeP5zvoLL	1407	1395	31	1	3693	jwbaJwfxbShae2BAxvJtjFbgii2Li4jw6EQcYUEYAWGCkxiuwim	1967	2800	2800	1616443200000	canonical
3806	3NKLiwH1EX2aGV3rJxMCEuPTHmMpVx9YG9VQK6UYA15ft7mJuinv	3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	1590	1300	31	1	3703	jwn2rNHh9fwRjBm57tuE9vfCLavCmAj6UkbrLMZYAimXZZerwn8	1972	2808	2808	1616444640000	canonical
3804	3NLRZWqTEYPQJGcwT8WXzEMrA6ju75kvupaWBSJWaQm4nfM4vWo3	3803	3NL2foP9LLwqG2mtQ7NrHD2d1xg95whi5yykVN8C77kHLDgry6WX	1602	1243	31	1	3701	jxvWdmVafPGy3s2CxAg4Xkd9b7Gyy65Qx41p3H2MHDA7NrgLqkN	1972	2808	2808	1616444640000	orphaned
3809	3NKkCqw3STrMdBswEEAgzh8eyvQFfDNwiJifgYn9VceTjSH8SRno	3808	3NKnUxffXV3vKEX9Z7UfvvsEduoZpxfmibQrx4ntrafC2wVP87Bd	1407	1395	31	1	3706	jxUnnk4aiNLzyagZktSfAHrPY632XoHLRv66nhqcSrUQzLTnXMX	1975	2811	2811	1616445180000	canonical
3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	3811	3NK5Mw6kVyweq3saeHY6s8Msc4jJ5pJFTvQEy6iNdGQ3Nvs2WaJt	1651	1055	31	1	3711	jwU6dE13tYDusKj2F1ZNHQnYTSTDb2rinbkUDn5uNz3GXXV9vpF	1977	2814	2814	1616445720000	canonical
3816	3NKYD4rjQSKWuxNvepRzkFMLA7c2Qc4uNc3Zs9vDccjZQtEc9StL	3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	1642	1367	31	1	3712	jxVbU3z8nf5Xws1MQNPELrZgeaPfkDWDyYNWLYY1Pn3v2snE8CK	1978	2815	2815	1616445900000	orphaned
3823	3NKenvs4qDPoykEMKB6WquAd9ApdAsa7f4pFMxuH4dVjKMcTgVzc	3822	3NKsWpRTUostgSQHZc23KuHeKQECJhqqTzvSA1RVAKLfm8KPH2fN	44	959	31	1	3719	jxZjtiMUm75JmZuW26TACCY6dPzx4d6YdeNJUS3GPaRuLit6ftf	1982	2820	2820	1616446800000	canonical
3828	3NKrrcvrKZhHnvfwQ9mTYU1RzynmnfMPxVhu37LV2Sns4cVvwNPb	3827	3NLg7FdvVDEYM7HrJbxgXHUY3QGzyXXiZUFGHp6imsMVqwwMAwha	1529	1070	31	1	3724	jwWqFbrKJ9K8QZTCugoXnz5gHpqvfQiX8N5N2TULtceLsjZ4Eqn	1986	2824	2824	1616447520000	canonical
3843	3NLxn7ztagH7Z5qETgJ2BhrmzXVwXW6tMkphJNThcnYGqmKXws3m	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	1602	1369	32	1	3738	jxPzdA49aSDN84rMVreTcSpXtyob3KSE5YLotZdvrZGo4r8NZic	1997	2841	2841	1616450580000	orphaned
3849	3NLxHb1azxmQ4NZ7fF5U9MWa9G4xQA5HH1TqQe5HXhXArKC1j1ge	3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	369	946	32	1	3743	jxkCDzx82n98JeugunaKyE7XSFWDREgnAj7W7pMBFhHFcmYSF3Z	1999	2844	2844	1616451120000	orphaned
3857	3NK54ZgfDXE7ktCkaJr3JMJYYQj62mGKkAxEWWVZbyruWZ5CrQM1	3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	1447	1345	32	1	3751	jwcJaFVedG6hqdtoBTmXsuVDoH9Bw3EP2NKqWpU4PaAwMaSAJwJ	2003	2851	2851	1616452380000	canonical
3859	3NLD5LHiDmFZkh524doz7DBtG43gYYvkt3EdXfKnGG2ip9MsA11d	3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	1448	1311	32	1	3753	jwtdVrKvuxLYPZAdnEusQi4GgxZk5bRe1yXXgLauAmNqexLt1gN	2003	2851	2851	1616452380000	orphaned
3865	3NLsfgZqsPLFfAHV1uRAufdpxhkXp6TFuHwoN56K2NZRAdhjpBAT	3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	1648	1284	32	1	3759	jwC4ZTAjyUFe7ky1wByCTPHMDb14c32mwUiQJc9mn2zxb1u2CoH	2006	2856	2856	1616453280000	orphaned
3867	3NKVnzZN14fZae6zTvKiaz3oKUYeWQPutLafyj5TEGAZcT1BFesW	3866	3NKh5uvYG4QJjDmvzNd3DRk6xdG1YLAsTba7vrK5PhcYnt9szPed	1406	1393	32	1	3761	jwLLy9HKHn33TmyuCD6xsZ6Qkm51adDZXEMyPjztVy2dUzSjA3X	2008	2859	2859	1616453820000	canonical
3868	3NLd7vVwymGfaBSGr5L2vgftpdnUTLKegbBVb97Ff6VyEbQZJfaY	3866	3NKh5uvYG4QJjDmvzNd3DRk6xdG1YLAsTba7vrK5PhcYnt9szPed	686	686	32	1	3762	jxRT2DCaSVY7burzScM6GaX89vv7ygkfDAzzceNLG295pfUsTc3	2008	2859	2859	1616453820000	orphaned
3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	3874	3NKDm4P277HmWKsyARMQkFQa734pVptyHJenmMQ5sLQgku7XJYFS	1589	920	32	1	3769	jw81bDrYJeZB93c9y4Tk8YeqSg8RqUNFjaNWSQrbtG3DEtHgFez	2013	2864	2864	1616454720000	canonical
3878	3NL2rZfLxe9spwgsZdjsfpQ9J8TMtv1jL9FdK3DyHj9gzqCJrZ2C	3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	632	1382	32	1	3772	jxzBdMVZAnmrTMh83HWqvvTb4brMr9KJWtk47quKeebEU5Fbf4X	2014	2865	2865	1616454900000	orphaned
3882	3NLHR9qqpx6RcYgdBMPa82Vgck64DP5pmNZ58h28GcBgBADbZNQp	3881	3NKye5Wv98FC628RM53LqSr6ZJyCD5wZgPVkaHDxuPGv186W3njk	1460	1324	32	1	3776	jwoiSx6JEgdkiYWQZRbmscZxr9njxJr9jsp8sZm8Ss9uVHZr7hS	2017	2868	2868	1616455440000	canonical
3885	3NKmq8o5dbTR4NKsqYSgpthrMxwfyxcsMGVbBgTjGWSqkfuDZtHS	3883	3NLA4hvy4APeBhaAZuqwrMyfWRCjZ819refy86pGpPECeN2BV7Si	1406	1393	32	1	3779	jxcmpvHkmveAFz55qz2ekvxouzCxe3doZQKSJuWKjYrvTGj63h2	2019	2871	2871	1616455980000	orphaned
3894	3NL76gYCvq7csS5SJCkffyRY38fU4VYgF85DP3YUFPCi1Apd6yZp	3893	3NLavHL4a4oZ3TMLphAKRtsPhZncQZtarrBTFr5wofG3emyxf4sq	1407	1395	32	1	3788	jwuzVk8NBQdkh2aaCxeTcvsyCVP7vsUGxQJRktE8rmTUj73HyMh	2022	2876	2876	1616456880000	orphaned
3897	3NLqxk27mRGL9UjxFvXbhuuvNZ1UaMzLW7dVj8fyjbAiynTGnTKg	3895	3NKeafGa9WESFFUEnotrQmQqTr176xcwNvm39Mt1Zkeytz9E18QT	327	327	32	1	3791	jxeZSYXeqeparebAqGA8BK8Gy46f4Bna1w56o4XUyUmVozJCZPP	2023	2877	2877	1616457060000	orphaned
3899	3NLahoYBqHYHUiNHezht7srSvAcwnJojimQ886UnBxZYAwk4YBzz	3896	3NLGpqsAoLEuD6bKKWBUcgRVeBDw5PN4N8X4anwyEUBGL88WK16G	1407	1395	32	1	3793	jy2Pqv9xZX6TgGU8zfLKbYQRttQzCFuqQNWKyCCxHFcAVJwhSMQ	2024	2878	2878	1616457240000	orphaned
3901	3NKXioc4wDBPkyFX5zZZzaypNqU4msEw8CMRGG5iA9HY5yCXduB6	3900	3NLNqcUH7zRbYWZFohUM7SqqBr6itCjQkkqRMTrWsZLfbga8P3f4	1407	1395	32	1	3795	jxpYpSRTf6qU8dP7pSz8e3V9gVy2UBKPPmRudhLjgkwMq4dtxVH	2026	2880	2880	1616457600000	orphaned
3907	3NKu8c7p5Tgywfhkh4247wBobxEq5M5GvzuzcFVN8BuTkZoYiXab	3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	152	1330	32	1	3801	jxQtatzdpPzf4cjAwrC381tK7FCJGBit85VZxTsrUWS87BW7B1v	2029	2885	2885	1616458500000	orphaned
3911	3NLoUMPTuTFbquNPXA7JsZfYgbKfp4inMzvPWLb5yUFWTwzXEWEP	3909	3NKhFQDcwL6WkcV7aaiXkenyC1uaFdvbCh3mvHPjhvHEQBcKZ94N	1589	1286	32	1	3805	jwXg8VXyLwzX16djmeJuMR1f4gt3ipVuzh6NnsjYek1HAijx5VT	2031	2888	2888	1616459040000	orphaned
3918	3NKSirhNAiwnDf3XEY1p7VS2FrjcBeMBCPR5rQZJqDL22EWxSQ5L	3917	3NKYXFLoW5cDXEmFPVEYtVa4EZQBoby4bP3EhydGtQsDqjdoYTmf	484	1319	32	1	3812	jwW6KAMHPtTkh4ueeH6oC9vzd5n3NTPaffnJr8pvU5EGbn5TLFZ	2033	2890	2890	1616459400000	orphaned
3921	3NLtcb3ckBJXdGU3MUjTp2YrQNses3UYu7QJfRmg8G14GqiUZG7Q	3919	3NLE6zqH7hJtFrG21u4dEeEkzbSGg15TuLffsdn3aKAJeKaAnLb5	1460	616	32	1	3815	jxdbwRgyLiEHDzHT19fGweHLAvZ5K1CVvCPwevtrW3XbKavwVqv	2034	2891	2891	1616459580000	orphaned
8816	3NKrJ2s9cd3Kgsk84yUmmCfi5PgvtFr7FqGC8VDjBJUfTo6G4Hke	8790	3NLQBPSRwPHqsDkoQoKD1bJdtxob51K5Fqa223EqsnsA1EH3CJ6D	1553	776	100	1	6301	jxp4ezGfgBZaZy9Uj2ahpXKGsoAhe3kthZidHqJnBmGC4C1BuJh	4425	6436	6436	1617097680000	orphaned
3914	3NKSMh7xrVwB5ZUn2tWDs8T9AoUUcbKrKeSysXcbiYQmnRXkD1a7	3656	3NKXWmkqWbAyTzJmCVtFM3jomxxRtuoizNxvhqJtLSxZbKqoTcVJ	1536	1313	29	1	3808	jx9cRasxLkAi7SDk6ZdstwknZ7HCNdm3JyqBX88e9Vv8Dikie3Q	1899	2888	2888	1616459110982	orphaned
3820	3NKhTADzgeHRjdFA8XECniPKV8ywycjKhfzaspNBizR71JqMW3xX	3817	3NKzUV4PBp4WfzjeRPSUw19RDTXxcmQkVQHd1sTrL82jEudmBPEe	1406	1393	31	1	3716	jx6xF9TqmbuEN9VoP6aWRBo2afBafZt3nzkxhqwtaTA3n1Bf6pp	1979	2816	2816	1616446080000	orphaned
3822	3NKsWpRTUostgSQHZc23KuHeKQECJhqqTzvSA1RVAKLfm8KPH2fN	3821	3NLosiSiGNRYwKn1szGQEZyn216b8Q3wqpMVh7Sg6vghKY8K3Sbf	1407	1395	31	1	3718	jxbLH6FXefMqfzxqmFBDcnV5SQCkusjnuwUwYZXuenpnNyqZBxo	1981	2818	2818	1616446440000	canonical
3825	3NLiTLEGpoUjYecXesqhFFL58zjecV6fpUiWoCM9tz749jX6BpM8	3824	3NLjKRM8n23K2rcmpsKMyhix4cN2zWzuxatbHEaawQ7QjVWBQvyP	1549	1116	31	1	3721	jxqrnUP7ngYZp9BUbDLuivasQ7Fbm26LLhjPMLdzC1FKmiKhJ4X	1984	2822	2822	1616447160000	canonical
3830	3NKdTHU33PBZUutZMThatd1QAZQNU6TU7pZM7HnJbAQETmMuCCEU	3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	1503	1031	31	1	3726	jxcQV6LJmN4qQMsZu13FUqkhktUEZhd2DapwcZqbKwzoYpt794q	1988	2826	2826	1616447880000	orphaned
3834	3NKKJgLEsLjqQHqnuM95HtJSq3696Nx7bJW8ehi5DyJYbb92cfNv	3833	3NKyQWAJ9AeA8GGB69A2K4LUSAB2eMz2GNC4X61CZfpn3mvaU7Qt	1542	1304	31	1	3730	jwvQhmwecT16V6xTR9U66Q26DTLXfXa6y1294xFBsGaZHtoMsAM	1991	2833	2833	1616449140000	canonical
3837	3NKzcqy5YBjsB8bvFJUh1Y1WudnskUFvjew24oabMCVJ9aMwff16	3836	3NKDSFZN866cAN4eQyVEEGHPjqZrMsFqBq2Rh8LMMcfdEDBjFrH1	1599	1287	31	1	3733	jxUf2HWTPvipj7zJtSaggXFMqodJAJcQM9FcZT3uHr2MoNGPmV2	1994	2837	2837	1616449860000	canonical
3842	3NLBw9UFTCtV3BSucLGfLcn9F7eFheuyd7xZfiEf4FpJBmUcLoGo	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	1602	1369	32	1	3738	jxPzdA49aSDN84rMVreTcSpXtyob3KSE5YLotZdvrZGo4r8NZic	1997	2841	2841	1616450580000	orphaned
3851	3NK4XLN1yZUM1fBsP3J1h3DTkeigT8FEv7C1NgtdCJLfMW3sDj55	3847	3NKps3yUTvW2VqFQ81Bm1FPKiuwQrGExhxWQJesG2YSGt1h66SJH	1587	1111	32	1	3745	jxyvnU2dt8bLDXsZ8oyWuFsWpXyXHs7rs4gSgp9jGgPSBcwz9RA	1999	2844	2844	1616451120000	orphaned
3853	3NK8ukCSK6uqQjquoNdbSQHgaoNDJvbJvbFdW5xNWNBF7rkcQ9RK	3850	3NKPoxYaVwpiCGf7FLMAwJByP8bqSDa4Tj2ew7FJFY2Faj3VHGwR	1402	844	32	1	3747	jxVZQb3vNKE9d257v24LKjeoUXV6o11T4nR9XRLFhjar8VR9vBv	2000	2845	2845	1616451300000	canonical
3856	3NLXiddqeG5Dbwx2heMVir41UChu83G3n5aehdFDq8mQAjTNyciS	3854	3NLNRnCa9cW8Uz3hZp2eZMWSZ8ETBUi7SYjqUvRD3A3aHusF9nvE	1668	1370	32	1	3750	jxL2J7sCtTWWXB8jUu649wHxE7fsD17kVbu3cH1Pq3p3EN1fkZ4	2002	2850	2850	1616452200000	canonical
3861	3NKURpTU2uJXninjGC2gkboVrh3jzydFfTr93yE4ySBw4sLrE9Z7	3860	3NLT7FBKiCNpUhuqaSPiqnHLfigjnu7DTFqByiFYoRLVwWZUAQ7c	1447	1345	32	1	3755	jwLbDyn3x4AZdv2VU8qYVDoJGefMVSB1SYx7jWikjTseNWo3fPK	2005	2853	2853	1616452740000	orphaned
3864	3NL3EDKbTcK9pktvkvgbD3qdDzHy2H8uuZNFs5fRrCXMGztYj8Dd	3862	3NLf1mfyNmhcXqV1yLCRzbQHQYaDubxBYHsHHP175bQEdot3B5xH	1596	1363	32	1	3758	jxYyVf3rBo52g42JsWcz4NnCUXYoMmFoLHWifP3HqVh83qpkHkw	2006	2856	2856	1616453280000	orphaned
3866	3NKh5uvYG4QJjDmvzNd3DRk6xdG1YLAsTba7vrK5PhcYnt9szPed	3863	3NLdZX8dgyyxZE5vnmHnkZfMz8nyEd38HyQ4MizxscikD2aLpTTY	1652	1315	32	1	3760	jx2yD52ED3dK6b6AhSS6pdbih2beVAXcDiUtF7LfVd1iR9GoEQ7	2007	2857	2857	1616453460000	canonical
3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	3867	3NKVnzZN14fZae6zTvKiaz3oKUYeWQPutLafyj5TEGAZcT1BFesW	1403	824	32	1	3763	jwf5eb7TwZSmokfkWenLLw1pWQqS7wGzPRj1dgdhUNqU4f5LATA	2009	2860	2860	1616454000000	canonical
3871	3NL79qRh263EAJHQ1AYYAWrhLQcCMoEcSoWKH7frdwh5PXmZf9oD	3869	3NKuqCKw9nCmUj6w4YfdcCeRde2JUsANdv8bidhqCVvw6fnh6iFv	1407	1395	32	1	3765	jwJ3ocbkdG3e4nUapuj1xGB3Dr3KVzXkc1RKjbkynxQZLvg6g6D	2010	2861	2861	1616454180000	orphaned
3873	3NLuDqaQ8zyfwpWqtJcesK7f4B7QdDZtFWSPmEj5EXQLo3fpa2WX	3870	3NK5baDtoeXNW4PwjTdrpHkGUaaaUZ3YVateYVNGUZp4EdM6ytqL	1536	1067	32	1	3767	jworAMLYebTZne5nxLYgHuYqmEGykwNhvCXCdELfas8QJyNghqd	2011	2862	2862	1616454360000	canonical
3874	3NKDm4P277HmWKsyARMQkFQa734pVptyHJenmMQ5sLQgku7XJYFS	3873	3NLuDqaQ8zyfwpWqtJcesK7f4B7QdDZtFWSPmEj5EXQLo3fpa2WX	1407	1395	32	1	3768	jwWRzFwJbCCuDvuTn8LmM4caZMxF3LNWDn5bNQgGDm8HRQz2DJN	2012	2863	2863	1616454540000	canonical
3881	3NKye5Wv98FC628RM53LqSr6ZJyCD5wZgPVkaHDxuPGv186W3njk	3880	3NLsyNzZfNiTLgWKU9F6Fvb7iZGovS9798Yy3MXdZdumPbf2gDm3	1406	1393	32	1	3775	jwA5ys4T2EdT5gHgtS643gHXGeJoNyCvg8kdAJ6uGuwMFDwvv4E	2016	2867	2867	1616455260000	canonical
3895	3NKeafGa9WESFFUEnotrQmQqTr176xcwNvm39Mt1Zkeytz9E18QT	3893	3NLavHL4a4oZ3TMLphAKRtsPhZncQZtarrBTFr5wofG3emyxf4sq	1406	1393	32	1	3789	jxbAWEsNUPfqrZG7YZPSx7To9WLYwDPxbrfatTmWF88dcayCcUb	2022	2876	2876	1616456880000	canonical
3900	3NLNqcUH7zRbYWZFohUM7SqqBr6itCjQkkqRMTrWsZLfbga8P3f4	3898	3NKFZcUbt4Pzd9CM6aah2Rc9taGWx6reuY5DuxRSfgCkZGDZPjFW	684	1352	32	1	3794	jxF9QxrVpjrZZ3uaC1HnirYb6pY8dUfWBEABsrXqpHC8bJsqqTv	2025	2879	2879	1616457420000	canonical
3902	3NKySYHLVrgVVTa9CLAT5ipugYk6KSGr6rb5XG88uZjj6s6VagNJ	3900	3NLNqcUH7zRbYWZFohUM7SqqBr6itCjQkkqRMTrWsZLfbga8P3f4	1581	778	32	1	3796	jx99sjU56i7N8rE5KJqgfFQhTU8WosxtaGCZYkpydsvNzmKWdvr	2026	2880	2880	1616457600000	canonical
3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	3904	3NLCPLCHa7DGZoRv8p8yooPGF3nzsyZ7DxppXE87FW1u3mrDu5MT	1507	1034	32	1	3799	jwFLdfjBCc7M85PXkH7wsEzXqJ6tuyHzZXxpv8HwUV1dheHfsCC	2028	2883	2883	1616458140000	canonical
3908	3NLVwKxunL7DkjN4oV7XHuAtdkURtXf42vyzarhpTa1nnTQebbAg	3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	1407	1395	32	1	3802	jx8EEs6TZD1LyNMks1yFdDnSJpDZcwJwt6sZ5Pt5fiWnPXig2nz	2029	2885	2885	1616458500000	orphaned
3917	3NKYXFLoW5cDXEmFPVEYtVa4EZQBoby4bP3EhydGtQsDqjdoYTmf	3912	3NKVyXSU3ZiN3eZnLbw3dGjPgQLQBcqu9q8vdSDde6mR9qvthJzN	1672	1285	32	1	3811	jwv7bR69oEp4748u2bWSFq5pjep59qgGJUQU4X199vKkWGkijqk	2032	2889	2889	1616459220000	canonical
3924	3NLhwJNUUawX5ZKiEYEcueX8qCmAw2GKDnhBGQAyHj5R9UMCoTuM	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1643	1053	33	1	3818	jxbj4LctnN4g8MiK9an8PkW3zjgEU9fPUYMhqrXnuQshUUmbQeS	2036	2894	2894	1616460120000	orphaned
3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	3928	3NKMQzEnNJCQz1p4vV75KcGM27gFdCKg912X74W6PfUgHAe6C7Tm	1601	1262	33	1	3823	jx1YVL86KzMfxXAQXuoaNt5A9infDTTU6oJ23vHdX8u33WWLqgY	2038	2897	2897	1616460660000	canonical
3934	3NLNd1MFXQxe4C5XjxK7ddZLXQwxSyv8Y252A7VB6tgEZJjozNmm	3933	3NKDwSCzwrN5zqoxf34UNFCaDRfnQM7ef845Ps3uTpQyUppRaGzh	1509	1320	33	1	3828	jwrVjZUz6wMutzkb9yiRSGWEtwxhiqoBtHnAPY5kTfR9aJMnJRh	2041	2901	2901	1616461380000	canonical
3936	3NLr8f5JSksTMxXrab3dVcwP99nvj81FEZZq7MbK7FqXjUzUnBnV	3934	3NLNd1MFXQxe4C5XjxK7ddZLXQwxSyv8Y252A7VB6tgEZJjozNmm	1406	1393	33	1	3830	jwgG8hxRD7wEXKN56FfBTwVpcKtRboHXNFoCxAwRSVFEFcaHNyH	2042	2902	2902	1616461560000	canonical
8949	3NLgHZBoxMn9YtPu2Xpb6hVS2VfrvHVnCnHuRruutNi1oyZPRwCj	8816	3NKrJ2s9cd3Kgsk84yUmmCfi5PgvtFr7FqGC8VDjBJUfTo6G4Hke	1553	776	100	1	6301	jxp4ezGfgBZaZy9Uj2ahpXKGsoAhe3kthZidHqJnBmGC4C1BuJh	4426	6532	6532	1617114960000	orphaned
3891	3NKsHF86FXu1KHS4TmtfHoQZrEjHmEWLd4R4vy7wwFkQdkk2ATPT	3604	3NLrCgpwigcbMdMhNsJikbXN8nUDM52ozrY2Yf84nEs2HYVNgG5H	1610	1188	29	1	3785	jxTb8THvfVoeqzYtN6EkZGisMfxbEJQZny3E4TC6kWe2GZpE9rc	1872	2873	2873	1616456419311	orphaned
3892	3NLKjcuU84eW9AcWGgpY9uiBGWQnd28xRXsxH69zuqBCr1e82dvi	3641	3NLfRK2Y8fcKCHqVzmpmK2vFMZmi9ryVJufBs8x35QumC7Ff26R5	1610	1188	29	1	3786	jxvHWgQdvxT6jPBbdznVa3YD1pXaSSTFsv7LUGsRGtW8CKXeGaM	1889	2873	2873	1616456457045	orphaned
3927	3NKJKSHUTXu3g7zgWzEKy1XrrjjjXu6H2Yr9fW7gRimNNxF3QBvu	3840	3NLcpV6BejPBSpZMQEfp2kmwj8zQ4QUaVx4CpyeWxRAS7pFUXqgi	1643	1053	30	1	3821	jwUE1w7axR2XFozYcYEFwGW5PKW2xYT4stVvreUuwSW1151EgM4	1892	2894	2894	1616460120000	orphaned
3915	3NL5Xfmcf3FTMntY5RNqHjizHQYWbmtX747BiQsjHc2SMTA2X8Hd	3683	3NKYyRf3WZU55XUTKPP8MNwB3nGsjtssW2MuwQwEkSP58Qk4bHT9	1536	1313	29	1	3809	jwJWyMsXZBaMgCknxHcbVzXjJZcdwu2smPBh4QqNxVeTERjpB4D	1914	2888	2888	1616459145015	orphaned
3916	3NKL39NYt9u1PB1X5gPkSQStreJVbhiwj8JiRQfkbhszPs3a6VsV	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1536	1313	30	1	3810	jwopTAv4uNwDAgGkfrQS2AtWmM2yCWFUfjrz2iDeF6MHmgHnKUs	1930	2888	2888	1616459180476	orphaned
3876	3NKsgFzwXDwaZNhhXnNZBNoNkdM7x7YztkCxLt8Hjmc7jygQxDhY	3874	3NKDm4P277HmWKsyARMQkFQa734pVptyHJenmMQ5sLQgku7XJYFS	1596	1117	32	1	3770	jx1ziypJR9zrSeSRV8zDNC7o6egGdtAaTLbqd7qVgZ9wspcaTzp	2013	2864	2864	1616454720000	orphaned
3880	3NLsyNzZfNiTLgWKU9F6Fvb7iZGovS9798Yy3MXdZdumPbf2gDm3	3877	3NLoRE15kgusmnwnbvRvR2uTzMa36m9RkoNNArw1gAvfWxEmE7V6	1500	1297	32	1	3774	jxfEYYGqAPHAZgwh8Vbxx2djbMnfMGXyvStgnTitUZpTSF3h7kr	2015	2866	2866	1616455080000	canonical
3883	3NLA4hvy4APeBhaAZuqwrMyfWRCjZ819refy86pGpPECeN2BV7Si	3882	3NLHR9qqpx6RcYgdBMPa82Vgck64DP5pmNZ58h28GcBgBADbZNQp	1444	1255	32	1	3777	jwwtBvptrbunowSrfchTEY3wxpkFANgBGqh8P3cERAXVxRMzC7Y	2018	2870	2870	1616455800000	canonical
3886	3NLeSN3Hfi6HFmSB5729sxLDk6EjZfqcnnbidBr7zEZHKestZV3v	3883	3NLA4hvy4APeBhaAZuqwrMyfWRCjZ819refy86pGpPECeN2BV7Si	1407	1395	32	1	3780	jxFZnAUfAPj9CBpTdNNF6uQpteV9VFkr9WYBYv4XfP75WWczDpH	2019	2871	2871	1616455980000	canonical
3889	3NLfBCiwcRihduYLuzjEYxeQfbhL1AgYnzN1Y3LYh1Auo3ekr7yv	3886	3NLeSN3Hfi6HFmSB5729sxLDk6EjZfqcnnbidBr7zEZHKestZV3v	1610	1188	32	1	3783	jwf5uuYrKE45NqMYYcKbFD5Ri6ARPr3dnsbxkqMNkuGD7SwdeBX	2020	2873	2873	1616456340000	canonical
3887	3NK8TwaZNhDEsyfVsSDxnjbdANrTMXvSWdTvMfx6KgjhyDPVXQ4C	3886	3NLeSN3Hfi6HFmSB5729sxLDk6EjZfqcnnbidBr7zEZHKestZV3v	1605	166	32	1	3781	jwL3imd9UXqN9rjjSYKnawx5yRMYezkJ6pytJmbmaL5EaR61xBG	2020	2873	2873	1616456340000	orphaned
3893	3NLavHL4a4oZ3TMLphAKRtsPhZncQZtarrBTFr5wofG3emyxf4sq	3889	3NLfBCiwcRihduYLuzjEYxeQfbhL1AgYnzN1Y3LYh1Auo3ekr7yv	1668	1244	32	1	3787	jwHQyXfJHLQ8e3A1KtWA17URntsXMnACagqjSKBfeAd4qFynYNV	2021	2874	2874	1616456520000	canonical
3896	3NLGpqsAoLEuD6bKKWBUcgRVeBDw5PN4N8X4anwyEUBGL88WK16G	3895	3NKeafGa9WESFFUEnotrQmQqTr176xcwNvm39Mt1Zkeytz9E18QT	1449	385	32	1	3790	jx3eQ6USb4zNye3UvNrke9sLUreqCPgUXZUriUDW6zhb5DbrDLU	2023	2877	2877	1616457060000	canonical
3898	3NKFZcUbt4Pzd9CM6aah2Rc9taGWx6reuY5DuxRSfgCkZGDZPjFW	3896	3NLGpqsAoLEuD6bKKWBUcgRVeBDw5PN4N8X4anwyEUBGL88WK16G	1527	1293	32	1	3792	jxxnhjPg66YPJV595fwsvqf3bz7X6epp7TTejjXAFeRG41uLW6b	2024	2878	2878	1616457240000	canonical
3904	3NLCPLCHa7DGZoRv8p8yooPGF3nzsyZ7DxppXE87FW1u3mrDu5MT	3902	3NKySYHLVrgVVTa9CLAT5ipugYk6KSGr6rb5XG88uZjj6s6VagNJ	1590	1174	32	1	3798	jwN73wNq2dcLY9ifpBur3eBUMv4Ret3yEMxWxaFqfMpLJw5fAj8	2027	2882	2882	1616457960000	canonical
3903	3NKYQNHwvwqhQzEHzTNBHZEUXxC1azZwGaLLtEHsM8VHca3kF6HY	3902	3NKySYHLVrgVVTa9CLAT5ipugYk6KSGr6rb5XG88uZjj6s6VagNJ	298	1308	32	1	3797	jxHDAyWB1hp2Mqk1qhN7uAGZmzCg9nsESiKzgHXMfoHdKkDptAU	2027	2882	2882	1616457960000	orphaned
3906	3NKT8ijB2BTLBorpbfbfHeTDRHYNQ8oNgATU46Kf9apqWK6fuPhP	3905	3NLcCbRrpPUn4kno5Pn1rmk6M2rhgUVyuPp8xX4dQojV7jkK24dK	369	946	32	1	3800	jxKgDSX99fBcBuwYKdgMVPQjqcZQwazeFaQkK9ipgZtvuzek3Bz	2029	2885	2885	1616458500000	canonical
3909	3NKhFQDcwL6WkcV7aaiXkenyC1uaFdvbCh3mvHPjhvHEQBcKZ94N	3906	3NKT8ijB2BTLBorpbfbfHeTDRHYNQ8oNgATU46Kf9apqWK6fuPhP	1403	785	32	1	3803	jxZ3s2g1ynraJW8v6R1YMSt18xtHFGiD97J26VJL4gZYgJKayiK	2030	2886	2886	1616458680000	canonical
3912	3NKVyXSU3ZiN3eZnLbw3dGjPgQLQBcqu9q8vdSDde6mR9qvthJzN	3909	3NKhFQDcwL6WkcV7aaiXkenyC1uaFdvbCh3mvHPjhvHEQBcKZ94N	1536	1313	32	1	3806	jxox2wDmnys4NR3oLGZ1v3AnHcgWte6hbategQphprDTSeFNQqs	2031	2888	2888	1616459040000	canonical
3919	3NLE6zqH7hJtFrG21u4dEeEkzbSGg15TuLffsdn3aKAJeKaAnLb5	3917	3NKYXFLoW5cDXEmFPVEYtVa4EZQBoby4bP3EhydGtQsDqjdoYTmf	1407	1395	32	1	3813	jwy4HYv6DA9R7RURkaB3KEYagXiMPQ8BTcHc8pNC3v4qBabnfu7	2033	2890	2890	1616459400000	canonical
3920	3NLLHzRhaiG25rF1Y3mExCE7DZx7ivkH8ExPaknnjUk3b4QGnXEX	3919	3NLE6zqH7hJtFrG21u4dEeEkzbSGg15TuLffsdn3aKAJeKaAnLb5	1608	923	32	1	3814	jxPSSofxzG9GGUAFVtAtSGhR9H844iB9EsooHhgjCXZVWe5sEAE	2034	2891	2891	1616459580000	canonical
3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	3920	3NLLHzRhaiG25rF1Y3mExCE7DZx7ivkH8ExPaknnjUk3b4QGnXEX	1407	1395	33	1	3816	jwRvG9fig4DCtRXEZhF8pPiGGKuShWH5svSo1FVRZg8aw8ycX3Z	2035	2892	2892	1616459760000	canonical
3925	3NK3oAst5ZL3jRujz6t6HUodHRxUjYPRM8m1HW6Zf4ZJBuak5LtJ	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1611	1341	33	1	3819	jxgv5Fv5DdiD4GE5iBS6FU3ogaCEU9zmjbTzPxfSrh2mPUPtPrR	2036	2894	2894	1616460120000	canonical
3928	3NKMQzEnNJCQz1p4vV75KcGM27gFdCKg912X74W6PfUgHAe6C7Tm	3925	3NK3oAst5ZL3jRujz6t6HUodHRxUjYPRM8m1HW6Zf4ZJBuak5LtJ	1406	1393	33	1	3822	jwCixgg2kjfTdyVZYnGfrMkAtxVLdXvUkFMH71Ji3UFqsbeDNKY	2037	2895	2895	1616460300000	canonical
3932	3NLH5GSGVs4zSB5UxrnvSvPrTxjQCAR2t6nX9fGNMeEwG5rrgwyf	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	1631	794	33	1	3826	jwK1pjtp8kk9kNTpKe4q4Prh9kE4kXfbgh6nEJM9fccXQBAJZ7a	2039	2899	2899	1616461020000	canonical
3931	3NKusKsD3GgCViPy4ePF8eN14rsWwLUMmZJBcVpbb1kAog65Axeo	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	311	1061	33	1	3825	jwudhRLJvSq9Dq68AhgiR6WZQ3Up5Sb61fYSNUcZRicETPnF3pk	2039	2899	2899	1616461020000	orphaned
3933	3NKDwSCzwrN5zqoxf34UNFCaDRfnQM7ef845Ps3uTpQyUppRaGzh	3932	3NLH5GSGVs4zSB5UxrnvSvPrTxjQCAR2t6nX9fGNMeEwG5rrgwyf	1559	1353	33	1	3827	jwjayzorS5gZSy3H8L7hGBUa9GCpUXzPFY2WwBMNGVyPsqugR9e	2040	2900	2900	1616461200000	canonical
3939	3NKSzszEn74ho5waehnmRLYEHiYNHg8PzEgK76M4ksEJhrVCvEBp	3938	3NLENDLX6PKPBDacTNYNxi5uQxnoyhFutnxuk34wyZW2uPENuQDV	1553	776	33	1	3833	jwcixDkNwpxtaqTeR5Xv5zibaNYrj2CoizxYPFQms1q1WX17iZU	2045	2907	2907	1616462460000	canonical
3950	3NL1NhJWKR1KRgkV3ibXo16L9qv3tjyJicHuJdSdp1YLXcdWyFuF	3949	3NKgE9hYcfYw9VRhcMnqNmcfqqhQ37CnbuojMsbPZFM54ZzrQvGs	1460	1198	33	1	3844	jwHuGHdtvXW4Ah67Ek5XML9cg6zSm3yab1ke5JJq4uuyYsLfH2t	2053	2919	2919	1616464620000	canonical
9043	3NLkgMLwwDWfXHZKo71p6TWLzSE1nzEvTkxAXz4mDLrjk8DwdtmL	9008	3NKG9iwc7B6VzgDjmsHdEtooZAQTX9f3soYumitERjBkAg6U81Mo	1553	775	100	1	6301	jwck7u7MTw4BYTZ52oCcAiyTVs4UJPxSoniqELXgyYuyTfu6q72	4428	6600	6600	1617127200000	orphaned
3935	3NLc4fRj8wRfpZEwiQDN95kymj2biyMtWcbMGx6nN46F2Mmzfnt8	3933	3NKDwSCzwrN5zqoxf34UNFCaDRfnQM7ef845Ps3uTpQyUppRaGzh	1477	1104	33	1	3829	jxLJP83yyLKrtn3yHMAX1PSViramBHX5ncXHojFpKJQ6MBpU4Cf	2041	2901	2901	1616461380000	orphaned
3937	3NKy93HL1WQrY4p3DQe9ZU7qfCCi3A9FGwf26gE41oV6b7xfcncT	3936	3NLr8f5JSksTMxXrab3dVcwP99nvj81FEZZq7MbK7FqXjUzUnBnV	1553	776	33	1	3831	jwfRsRUey3JBNvSDEHHb3Hs4ch8qyquEb54DxHrMsTH6jrtzxJj	2043	2903	2903	1616461740000	canonical
3938	3NLENDLX6PKPBDacTNYNxi5uQxnoyhFutnxuk34wyZW2uPENuQDV	3937	3NKy93HL1WQrY4p3DQe9ZU7qfCCi3A9FGwf26gE41oV6b7xfcncT	1590	1300	33	1	3832	jwfVdufkWg683HxrjTfqk7FrhNn2JwhTdirYeiAJ6tcLmoRFMNG	2044	2905	2905	1616462100000	canonical
3940	3NKYXw7rQFWHx7mCrRaewM96pg3bVgiWHJJrBEeiR8Z2tR1wNU9z	3938	3NLENDLX6PKPBDacTNYNxi5uQxnoyhFutnxuk34wyZW2uPENuQDV	1624	1334	33	1	3834	jwJSGTVtTRu29YBMR3GXF9NFN6iQRhduSj2gxFD3CBTnWoSF8Zo	2045	2908	2908	1616462640000	orphaned
3942	3NKUjhibf8oQt24ctFFyBufeES7E2xYJSfdN5RCgaornMnFBfeow	3939	3NKSzszEn74ho5waehnmRLYEHiYNHg8PzEgK76M4ksEJhrVCvEBp	1624	1334	33	1	3836	jwT6Sf1h9REKvCTNBkpBundVRoCGPDyEU7TeF9r4UJEhisrLKen	2046	2908	2908	1616462640000	canonical
3941	3NLMj3se1bSrWh1EaExE7h5rN3rMPLhoBkYJZv75poFx9EYX2qNs	3939	3NKSzszEn74ho5waehnmRLYEHiYNHg8PzEgK76M4ksEJhrVCvEBp	1508	1387	33	1	3835	jwzcu8ULor8nWNfhYS63iQK4fez84NofCfCNmMxZzsmabWZjSk5	2046	2908	2908	1616462640000	orphaned
3943	3NKWWoYis3QQcihoFwa2eoUtYo4NTYvdoENgPXfQUSzAgQt5BkaU	3942	3NKUjhibf8oQt24ctFFyBufeES7E2xYJSfdN5RCgaornMnFBfeow	1402	874	33	1	3837	jwuM8NYoSbpRuTY5mpGfQ3KQkULdXXoU1g8S6T1apzSDJxmZogP	2047	2910	2910	1616463000000	canonical
3945	3NK7Qvar8xVXmEvgeSRAHWhk9QUA4bwwfYZVwox5Z5KEgTqAGSqZ	3943	3NKWWoYis3QQcihoFwa2eoUtYo4NTYvdoENgPXfQUSzAgQt5BkaU	1407	1395	33	1	3839	jxodsrk7hb888sUwwfSE8J7BkgupSbKocioUfDLeF7DrDvQdWKd	2048	2912	2912	1616463360000	canonical
3946	3NLiEebGRJYkpiFuhg8QrVoREFSSmRF1vR73enuiynyxdbj6U9rR	3945	3NK7Qvar8xVXmEvgeSRAHWhk9QUA4bwwfYZVwox5Z5KEgTqAGSqZ	1407	1395	33	1	3840	jwGXWgGvFbvse3BazZcGoH9kUdHzGt4nyMpM4Rc1hNLCYghnLY8	2049	2913	2913	1616463540000	canonical
3948	3NK7MK7sBSMHmDVpeYuTBLiizCkMfxj9HYtqwon2RiGSYdjZtPXv	3947	3NKR2tQ1JM3TPpEtVjiBciJizHz4FPoGcxiZsHJPzE4z2zAtu9ax	1445	1290	33	1	3842	jxM8c6NuJFR6QKXZpJ5i1d8DZ95k1EScBpiqNkG47rHvXqUhEJR	2051	2915	2915	1616463900000	canonical
3949	3NKgE9hYcfYw9VRhcMnqNmcfqqhQ37CnbuojMsbPZFM54ZzrQvGs	3948	3NK7MK7sBSMHmDVpeYuTBLiizCkMfxj9HYtqwon2RiGSYdjZtPXv	1553	776	33	1	3843	jxhjDFUnpHJKi662jtRyA16TEC4DPjfvHTyiVKBR1Aq2TkUX6pc	2052	2918	2918	1616464440000	canonical
3951	3NLEk4KVeByjTfgxrFojMkqfvNDFx1huq9sg65JxARk9SXvUVR3N	3950	3NL1NhJWKR1KRgkV3ibXo16L9qv3tjyJicHuJdSdp1YLXcdWyFuF	1651	1055	33	1	3845	jwA96kqKc8MtaBCaxRFyhgz2tAXmUv7ECCEymMwfiPCyKdR8x18	2054	2920	2920	1616464800000	orphaned
3954	3NLQSVUVSpYRVD4ensSUH8wfgV6i6gDd6KcKs8q9NzHRYWjAAKXL	3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	1578	930	33	1	3847	jxnvEXHSnWmrFUn89f2wXANXPBvX3beMso4HccyyxRuZU8xYMfS	2056	2922	2922	1616465160000	orphaned
3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	3957	3NLjYWqpJYpNryiPSxMLUsG27dhVNP4AxLrwFxBv6toHgmPXKaNs	596	940	33	1	3851	jwiuawbz22rpE14L6362pLQUtL2BBZarQQw1CXw6YjPkRX94phW	2058	2924	2924	1616465520000	canonical
3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	1483	138	33	1	3852	jxVU8G1pgs8V1MBE5cE5YhjxWgT2pxxmRMaNbWg78sp2MwL58Mc	2059	2925	2925	1616465700000	canonical
3961	3NKEXMKcaXiSqVzuHkrTpZnFMzxix9SEYLP577mohQCN2MkRSQes	3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	1611	1341	33	1	3854	jxCD7kTMzJeHbJS6oVhkBsr58QMMEymiGwjioBeyJ1msVPEnF74	2059	2925	2925	1616465700000	orphaned
3963	3NKhrXXQz3BNFLMn7hRDMyisQsaxP34oMuQxpNGDhc3WkHj5ahoN	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	1513	1133	33	1	3856	jwGcB51LVrtYHHhP6SqKHDHsR93PPC8EHJnp4ab4Kp6rKSvghoq	2060	2926	2926	1616465880000	canonical
3965	3NLgQDjkXoNHECZVvEBbjgg9vZWj2ppCcJUFVwYvzLDqGP2FGdWE	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	1631	794	33	1	3858	jxAB3jJ8f1z9JP2PYdVDaJkBb7WV4jUfksx96vprTfjwQmAjjcw	2060	2926	2926	1616465880000	orphaned
3967	3NLhvQ6y8vCcMZKki6M68svB4udHKH58MAMHbMbiPpMQjr4q5yDk	3963	3NKhrXXQz3BNFLMn7hRDMyisQsaxP34oMuQxpNGDhc3WkHj5ahoN	532	1303	33	1	3860	jwV33pr7qaUU51mVb8HnzPEHwREUyyc4pSZWJy6bz8gXwCRbioU	2061	2928	2928	1616466240000	canonical
3968	3NKk2gH7AFotGAMtNvrjy3Uh3GfrTB4J4AUgRMXDWHoygxPB1rUA	3967	3NLhvQ6y8vCcMZKki6M68svB4udHKH58MAMHbMbiPpMQjr4q5yDk	1457	1025	33	1	3861	jwNGkPqDwmHu4TU8pHFL2AoFvxsAAGP5sbxEBSqwAVSTXd9s6cW	2062	2929	2929	1616466420000	orphaned
3970	3NLDj3q1xx2RpcjqeH9CiV8dw7ipMGsGJPZELhejMR3Xg15TzxGg	3969	3NK7BJqK5FkoXVL8n7MbJoktc71ZrR1AzdaDmYd5x1WQew5BN21p	1501	1360	33	1	3863	jxAaWBhEjWPAD6E6WeQXoK5irUL8U2ZH15Zss4ynRQxd39QbTur	2063	2930	2930	1616466600000	orphaned
3972	3NLbm26wFY3NRNJy7uaqztjQYkNTA3Gu6T3wqNb1wHQPq12a5vhb	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1426	1364	33	1	3865	jxR9wTjCYQaqckrpbybYW4NCv2A4jBvYqvMvnHUf4GXD5Qtwy7i	2064	2932	2932	1616466960000	orphaned
3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	3978	3NKBkLp6gdBvS67W9rTSZByoTegpq9WqCezkMXga7FprbEsb9CsK	1406	1393	33	1	3872	jxm73kj7TQduyGTaD74KZ5qTvVhVvrptyQYTQKC2eU2JNAEtuhk	2067	2936	2936	1616467680000	canonical
3984	3NKoRohmoyvCEra5ggaSHBR9puk6UgN25wrw87a3bgRASVQDnXEW	3983	3NLQKGnkUoVs62j3k2T9k9omBeYy4RgMLFU2oY1L9Ye6iR9oNUFy	80	1273	33	1	3877	jwKc7cDiDV1EGmDv3zsCyzBLFF8YzjrwjrybEARfhCZPaxCr2F9	2069	2939	2939	1616468220000	canonical
3986	3NLjcMe511mtRBVxHYappxMebzwyLbxgV9mpREayUbTM8u6VJSsb	3984	3NKoRohmoyvCEra5ggaSHBR9puk6UgN25wrw87a3bgRASVQDnXEW	1601	1388	33	1	3879	jxKYtCm1AaBjSHD64FNd3WjydT1cZXVZw5JCB2zUBPMpcN2gLD2	2070	2940	2940	1616468400000	canonical
3991	3NLJi3zm8noqfZtUuHb7tb1sEqKsnB67pnf2iCTSSaBqn3MGAGkT	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	1529	1316	34	1	3883	jxhrCr4hEyeyNNSdkupsufzjmXW4zQU9E5a8rLCGEH62t5fnGjq	2072	2942	2942	1616468760000	orphaned
3997	3NLKa3LbkNpSXNsfu1K9vKqmU9tSNek7CgtqCTgfArYnmNNXdTQG	3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	1647	845	34	1	3888	jx9cxWShKQZmxsSmkjvQQS1aVpx89MH4uy2PaDmLbCDERzNqvDo	2074	2944	2944	1616469120000	canonical
3995	3NLeLKRZovih5bN6yY8EocEaaV4dUb9HGorjKmb5MTU79UWQbWLz	3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	1406	1393	34	1	3886	jwMVuqjF9h977ZJ6D7yTK691dtvcF2ZcraSnH6pHtesRSJvVBTY	2074	2944	2944	1616469120000	orphaned
3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	3997	3NLKa3LbkNpSXNsfu1K9vKqmU9tSNek7CgtqCTgfArYnmNNXdTQG	1631	794	34	1	3889	jwfRcbjiySWjUJQXbtisEzNKx2N4KUVB7Rs1G3chH84RdNJQ1F5	2075	2946	2946	1616469480000	canonical
9066	3NLK1iom9niuuxtNjNuMRqGhyyTxZPinJrSqgi1EaSzSumQQMW2U	9045	3NLKkzSUi7SmunZezrcwHirFu4b9WUPhzUdxiX5qkMfLjTVYtkae	1553	775	100	1	6301	jxPCfw51zcVBLzgKaD7kJgop3qwchuCMaVfgg91cKsDnxXFm7pJ	4430	6618	6618	1617130440000	orphaned
3947	3NKR2tQ1JM3TPpEtVjiBciJizHz4FPoGcxiZsHJPzE4z2zAtu9ax	3946	3NLiEebGRJYkpiFuhg8QrVoREFSSmRF1vR73enuiynyxdbj6U9rR	1631	793	33	1	3841	jwysbRUXQB1ShDsSBMpmsP8N7HUJETSVsUbWEefoCf5sapYpz3s	2050	2914	2914	1616463720000	canonical
3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	3952	3NKz8WHC6vFjeYq7FYnxHFHSyQfFu1EwzCDhie7G1geMGuvpt6wH	1407	1395	33	1	3846	jxd6cAAG1aZ4nxunDj2JJPrnSm2oyfUtapXFYWP3azQjYkexkAW	2055	2921	2921	1616464980000	canonical
3956	3NKAEkTjfFsN49ncAU1xhMSkDnYdVmAqyiMG2shEKn2UeQB8AjnD	3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	1589	920	33	1	3849	jwg7p7WVHbMpSpwnBx2CVfsckhHVvF3rXatK1eQ8uXVNSqrbbov	2056	2922	2922	1616465160000	canonical
3962	3NLg8jBG6iYFTvBAgryBiyVxabJpsWwcwskvRCE4mo2XD8XbMzfc	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	632	1016	33	1	3855	jx2DNcWzkZQX2gF3y6AXUvKu3s8ZVLgcK55NJfJCe6bRiugZLcc	2060	2926	2926	1616465880000	orphaned
3969	3NK7BJqK5FkoXVL8n7MbJoktc71ZrR1AzdaDmYd5x1WQew5BN21p	3967	3NLhvQ6y8vCcMZKki6M68svB4udHKH58MAMHbMbiPpMQjr4q5yDk	1594	1200	33	1	3862	jwTSkRJ4iRyFEh9XTgGQqXsxcqDLpZRdX2Mt7wYoW5UcoynoKvM	2062	2929	2929	1616466420000	canonical
3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	3969	3NK7BJqK5FkoXVL8n7MbJoktc71ZrR1AzdaDmYd5x1WQew5BN21p	1407	1395	33	1	3864	jxfmgN36gn62ZM8bmpR3DuQNSxuAdRgHMxftAsRmic8tT7czpaZ	2063	2930	2930	1616466600000	canonical
3974	3NL6NHN39UKYTupQDjbDFwHtVVz9s68TA2RfqX7sfouo9H2hUxHS	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1516	928	33	1	3867	jwVp2bnq7SCR5eH1yXi1VY8n8m9kn2GtUjkJiyZSJUobTDafBed	2064	2932	2932	1616466960000	orphaned
3977	3NKSABWcsMKwbhWBRy83CwiyYpkYqpFKVn4VyZEsbj6omCtYUGQk	3975	3NKZ4vnyv7Sn6geWWPzhQASrrMPrpzYky816LyHMs1zsNibSp6NK	1402	882	33	1	3870	jy1vNT3MvtdfYx1VJ8RzSJ3vca21f2x8YzmjCLdHBvfEnef3hY3	2065	2933	2933	1616467140000	canonical
3976	3NLqMsp8hQnyRZutvdz2aZVGHFw5DAc5rAJvqkD785FJRv5Uxi5p	3975	3NKZ4vnyv7Sn6geWWPzhQASrrMPrpzYky816LyHMs1zsNibSp6NK	1406	1393	33	1	3869	jwrcUfgkZYQT9P9XVjFt7kSjZ5B8F3pyLZ2J2JYzuLmsUKUnXwK	2065	2933	2933	1616467140000	orphaned
3983	3NLQKGnkUoVs62j3k2T9k9omBeYy4RgMLFU2oY1L9Ye6iR9oNUFy	3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	1611	1341	33	1	3876	jxuKzepLZEBaYvJCqNwNDGdrFusBjPw1of7sh1AJoSwaCMp7anh	2068	2937	2937	1616467860000	canonical
3982	3NLXtWnU3WbvVbgEhdefQFqMiWhZNoEvPbarexspyNyjrMHZrQCA	3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	1460	1078	33	1	3875	jwJAzsxPtKJJbcDzNWKNoRC6FqFLZztttKmLuxkwJme5kHo5bjV	2068	2937	2937	1616467860000	orphaned
3985	3NKJ53fL5ANyX5BnWGJBwg22Zwiv7vvaMVwLhMCMfZ1Fnit2VmnB	3983	3NLQKGnkUoVs62j3k2T9k9omBeYy4RgMLFU2oY1L9Ye6iR9oNUFy	1579	1023	33	1	3878	jxE3ZqdpZ7KkXu4WLmpZQ51G7Z1eroDPwmceyuWEvrHqa1GuMvt	2069	2939	2939	1616468220000	orphaned
3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	3986	3NLjcMe511mtRBVxHYappxMebzwyLbxgV9mpREayUbTM8u6VJSsb	1477	984	33	1	3881	jxbXw9NW28dwcTmQRXPEGwho5HwWizBh6z7WQmKPkGgaE63K35L	2071	2941	2941	1616468580000	canonical
3987	3NLTL29PtZWRWKR4EbwpuTxoGUW4nTDmvVxW5iE15ZC5UioM2eLi	3986	3NLjcMe511mtRBVxHYappxMebzwyLbxgV9mpREayUbTM8u6VJSsb	1406	1393	33	1	3880	jx9kDjRoSYezEwRSzy3Gj7J3ZNyPK1WPNPEgWwwEgsa9V6XSxLN	2071	2941	2941	1616468580000	orphaned
3989	3NKssxwRomsgsKY5NTxu2Eq2vzNdr5JnjJzbqzTAGH44n6vYsPwC	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	633	1384	34	1	3882	jwx6PaTGrdDZoDxxrT2vpTGo4GKMo8v1aRcixbVSaq1mhgyTg8m	2072	2942	2942	1616468760000	canonical
3993	3NLNe4CEaW37ex5p5BRBYgmyX81PcasV1kUDpve1wTWajqExpH7d	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	633	1384	34	1	3882	jwx6PaTGrdDZoDxxrT2vpTGo4GKMo8v1aRcixbVSaq1mhgyTg8m	2072	2942	2942	1616468760000	orphaned
3996	3NLbdkh79aty1mJnm4HKd6wNMmH9MXmBwrufGCkC5DmCT8xRQyX4	3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	1618	527	34	1	3887	jwauA2BThaPLLHXVDtsfG35ief7d2mDiaLYQa5VKEGL7s5mSeNm	2074	2944	2944	1616469120000	orphaned
4001	3NK9wnPAuMA9yyC5QUHKT6zbxK4dXTMFitNNgwWCWsr2Nf4o67hb	3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	1460	637	34	1	3892	jwn2Hcy8tQkh3vQzuKNtH2ospBRp7g18snyaWM9zXCNFFunmwz8	2076	2947	2947	1616469660000	canonical
4005	3NLhFDML9UyvJ2uexCkHjH6VT6by6K3Akpz4bybgWYrJR7PsF5Ej	4003	3NLhE2tfLea7M2qo9nd5mtr86k6CzPSSJAZ3B4zxwmfUdhTV2dTn	1490	1028	34	1	3896	jwoKUVgy8omvGf8jUfZPNqiDzRPzSRRL3fsyGpZNQHF2LotTVFu	2078	2949	2949	1616470020000	canonical
4004	3NLpzZUot6eV7Y9kYXbj5k7Js4NgU3BdgVVUTfcot5vMDbNvdCAQ	4003	3NLhE2tfLea7M2qo9nd5mtr86k6CzPSSJAZ3B4zxwmfUdhTV2dTn	1646	1354	34	1	3895	jwf8WGrNxD6oxdh5QXRx9PXE1gzeKE6NKqMTR9QbSYi9CwbPBH8	2078	2949	2949	1616470020000	orphaned
4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	4007	3NL3cuERDb4euLu2XZqbxJBM4rhy67Jv4pukUgZrGPGfBuTrvC9Z	1549	1362	34	1	3900	jwkYJLdkWuWbEa8LcKjjoov13XNisUythhPg6DAgXmXSZpAJoVo	2081	2953	2953	1616470740000	canonical
4008	3NLvqBmUj1UuGMxwonhE2pZQjcWnLLwuFAECTUfz46FsEiRKPFAo	4007	3NL3cuERDb4euLu2XZqbxJBM4rhy67Jv4pukUgZrGPGfBuTrvC9Z	1668	1244	34	1	3899	jwAFkdKN2oKM2SKhzEFpk19vtMe4LzrnJnhDq5yiZJz7zjEy9Mz	2081	2953	2953	1616470740000	orphaned
4022	3NKx3jcjLbJQy8YwvRuWXAobhP6BuijNs5E8ojQwLH4bA4yFhK9q	4021	3NLktfrrAfFyzHRqNZKn9Boqiw6mg9WJYXGj2ANu8LSFqcEx5XNS	1602	1243	34	1	3913	jwYbHJNTUhihjYCYcWwdbZXXucGxJ9RAgXVqhjgJ1xj56tsap5r	2087	2962	2962	1616472360000	canonical
4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	4024	3NLqqbRUo7YGeHjVN7aUia3VJhjsaEpAezcpGVxVAqRDWtFjNEk8	1406	1393	34	1	3916	jxTdm6e54Lhg8dgpsdBShLYLd5Qkedk9dK7Bv77Kq4pMEjjJsft	2090	2965	2965	1616472900000	canonical
4027	3NLnJeZxJRi96AFmDpKniM5WbdD4sZE7aecdmrH3x9MyPWMpxgMP	4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	1651	1055	34	1	3918	jwiot1pbMtLQQxFXVxzEZe72P6Diyw1gwhvZ3gmh1v65e9eK4LZ	2091	2966	2966	1616473080000	orphaned
4034	3NLwWw8vHeWY8mLSyAqA3kXGhiFDzNjMfvqW6R1EwX15eYGZanmx	4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	1609	1087	34	1	3924	jwR8gLk3aobrnkQBYiXhzsHqN6zcYfWiRQt16RdNJRbjS24rPXH	2095	2970	2970	1616473800000	orphaned
4042	3NL9EZbSN2cb5WNaG3ULGEgszD2q6ywWVx7DtB7g6t3NTff5cBGM	4040	3NLuxfZ2SZHNe13nXJqzafhpQcEi2nuauCkREcB4eAeRhBhVmgX5	1407	1395	34	1	3932	jwQGkGA5JuDWevgMPQeMSXiL1cecfXqedKEogJaAVQMeettBgWv	2099	2977	2977	1616475060000	canonical
4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	4046	3NK3JdRfMA8tBCXq7hrndu18dx4M9gDKEGCem8F5syEDsArGs1ff	58	1035	34	1	3937	jwiyR6nxLimAwV8kx86SAYcizEAdcfLYVkda2uqcCGuKnKq56LQ	2102	2982	2982	1616475960000	canonical
4053	3NLg6UmCRSRVeXC56kXt1q3z2HCQzM1vvUkTqUWpDkHuGeHawD2f	4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	1610	948	34	1	3943	jxse31naA8qXiyi4J3ems1FKeVsnrHmpoHXyCR1PhUwcWBThnkn	2106	2988	2988	1616477040000	orphaned
8553	3NKKdq1pbawrBz7JavxAdeCHA5pX68XKA7532gNJfc98NNFTo5X2	8550	3NLD344Si4NvPZ8MtBfCcjWtDCRYLFmJCywphNATZT3V8pjihuWu	576	1355	101	1	6301	jwgB9y5yJFovvCCRmLdc3igzTafvWa5NMBiPEDDm6zeFHbLkYwA	4431	6237	6237	1617061860000	canonical
9880	3NKoJCA7UdGMYWgiGaFK1ntzvFjSwnW3gojcaz5ouZpoW9GNXMsp	9755	3NKhSWFmvXbjrYTcDh6odF7QpFshvCXJFWEKEsj4dnFBy8Aa8N7J	1642	1367	126	6301	6386	jwyRvTn2jCSvLZ26fDBFjRkXG1AFnhJBiQfoQrX5yjoWJDPpiHW	5055	7210	7210	1617237043876	orphaned
3955	3NKajMcLpz6Pq8nuQyyFCUhfQ9zvGMgP3GbsxgjF2ZQgVABpjz44	3953	3NLsMoanbtEnHbC15rHYFGFKekXNwQRgu9Ry7YVGCHg14JwxSGjv	1527	1293	33	1	3848	jxC2uWi3Fa8t7sCrn8wv4J9DUf5jRS3YwCxCrh12W64wK8JC1GP	2056	2922	2922	1616465160000	orphaned
3957	3NLjYWqpJYpNryiPSxMLUsG27dhVNP4AxLrwFxBv6toHgmPXKaNs	3956	3NKAEkTjfFsN49ncAU1xhMSkDnYdVmAqyiMG2shEKn2UeQB8AjnD	1447	1345	33	1	3850	jxjfRNMbPesgJDaWiepfvHz9ujodsTcU6Cryf9HaLhTWyoQbB6Y	2057	2923	2923	1616465340000	canonical
3960	3NLNA7Lsf8f3FjjZRvR2462CHhfKzmjCR4SmpeSzdhuw2i3buA8j	3958	3NLjMJiGcJCR6gN8LDBgWjgscg4Vxnfh8eapJBgqh4BuEttWoycy	1666	85	33	1	3853	jxGssWpvEfcipqhVGH4r5XbSqr2PKCZZfSBip2ZrzHK72HwjH6w	2059	2925	2925	1616465700000	orphaned
3975	3NKZ4vnyv7Sn6geWWPzhQASrrMPrpzYky816LyHMs1zsNibSp6NK	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1559	1227	33	1	3868	jxEcRGzzMytqHqeDcKPkJQSEXvNfwqCMMm93nyfJyD2ccMShigQ	2064	2932	2932	1616466960000	canonical
3978	3NKBkLp6gdBvS67W9rTSZByoTegpq9WqCezkMXga7FprbEsb9CsK	3977	3NKSABWcsMKwbhWBRy83CwiyYpkYqpFKVn4VyZEsbj6omCtYUGQk	1476	1371	33	1	3871	jwR89cXqdDY1WQUvYbAi9jUdV4Nm6A4x5HzVusxBzghcsUK6JD3	2066	2935	2935	1616467500000	canonical
3980	3NLEAjacJS21TocuH2q5t2RL7ya2Nr94BwoB3pYp6BR33VcSQh4D	3978	3NKBkLp6gdBvS67W9rTSZByoTegpq9WqCezkMXga7FprbEsb9CsK	1559	1107	33	1	3873	jxiGVu6kxvkH6nR28x6zAS24Pybfe1yK12eDB1koXViWsyVkEzF	2067	2936	2936	1616467680000	orphaned
3990	3NLuHZUYkArRMKrbJQKTqRXgFKF1tVxchgp87Sb7uzDYwQS5se1r	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	1529	1316	34	1	3883	jxhrCr4hEyeyNNSdkupsufzjmXW4zQU9E5a8rLCGEH62t5fnGjq	2072	2942	2942	1616468760000	orphaned
3994	3NL97eRDczKuKfd3ssNYv2HNyuoS5CZ99eaG1JcEsdXwMJvb1aLM	3989	3NKssxwRomsgsKY5NTxu2Eq2vzNdr5JnjJzbqzTAGH44n6vYsPwC	1483	1276	34	1	3885	jy2YBFqBQeNSRXEkPS6cEr7xiq1Jhx65yRA3w5Jq6jzHqoUdMce	2073	2943	2943	1616468940000	canonical
3999	3NLXjonnHEDW2tqtXqCKttc9j6RNxmtSp7KBQwo2PWZmhNrwWjjU	3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	1406	1393	34	1	3890	jx5RjSP9uo4Z4bhJaLtuJksF822QrXdwuWZSqbQpYyMxjmMz1KF	2076	2947	2947	1616469660000	orphaned
4003	3NLhE2tfLea7M2qo9nd5mtr86k6CzPSSJAZ3B4zxwmfUdhTV2dTn	4001	3NK9wnPAuMA9yyC5QUHKT6zbxK4dXTMFitNNgwWCWsr2Nf4o67hb	1601	1388	34	1	3894	jxhXzJ5JbdEzonrKaqfzXLQLoeiReRM9N6Drc2PzYTU9YmvAxi8	2077	2948	2948	1616469840000	canonical
4006	3NKTX1Q4MFbiSUrATMKeQXbvPQA44kYMCvo5UJEPSWJwJiK98yRQ	4005	3NLhFDML9UyvJ2uexCkHjH6VT6by6K3Akpz4bybgWYrJR7PsF5Ej	1406	1393	34	1	3897	jwLtjHUUd5UNWGMQnd6duY9GHncLw8mvhRdVoJ2BsgqBYZVSRrV	2079	2951	2951	1616470380000	canonical
4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1553	776	34	1	3904	jwoGZenZoxCBDYMMG5FJPZPHdNugMh8k1emwX34nxRqNxdDkdyT	2082	2955	2955	1616471100000	canonical
4012	3NKxNsathwodLn3TKufrgovpBq1S2ZgCC2KyQPDyhu7XiuBTK5kc	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1619	1275	34	1	3903	jx4wc1Wxab8uuufjgvF9ArvmF45CbSp6P7YLHwMEFY7HmxWZKkz	2082	2955	2955	1616471100000	orphaned
4015	3NLJT3jkE5QQR3owH8W3K6az92byXhz7hRjHGPAP5jUCd7yZ9Hda	4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	1458	1323	34	1	3906	jwEcPPqnEreCk76vE1yosMkdr5KMCDqC7RmY7LWKyTCpZzo6nMr	2083	2956	2956	1616471280000	canonical
4016	3NKwYndfycshn3tMW5Bo2VMibup4KSqNbxj3tksCwpAW9uSo9f4s	4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	1448	1311	34	1	3907	jx7cPXjE7Kywg3vs1ZbWZDqBFZnjfWsaRmxxhDSuRStWQgceDBa	2083	2956	2956	1616471280000	orphaned
4017	3NKc1YC6RnsZHZi9gGGnBVR5528xQJn2XrrrxDoXSdTb3tc6RkNY	4013	3NLxVHfmLanK4LZ8CSaW3nCGcPNdftMaGcR9ZRV9vWAUAf1jxbfT	1419	813	34	1	3908	jwQzTNSkoDDSWSdbmchH6WEUWmkWWZ4vaCrbFiN5FMcbuuUFfUj	2083	2956	2956	1616471280000	orphaned
4018	3NKsjjN1JEoPZXznQonf2LojEwJkvMQRBoSEG4wH6n73iXpaaLXW	4015	3NLJT3jkE5QQR3owH8W3K6az92byXhz7hRjHGPAP5jUCd7yZ9Hda	1588	1392	34	1	3909	jwpR8dSiet3DcEnHH9mh2q9CZW1QD42kbxHuSVwdW8GwAjSXaD3	2084	2957	2957	1616471460000	canonical
4020	3NLAjp7TZjSRFbr2nL2MBFCN8ddJQgg9uWXetuot4bnFvJ15wx5r	4018	3NKsjjN1JEoPZXznQonf2LojEwJkvMQRBoSEG4wH6n73iXpaaLXW	1642	1241	34	1	3911	jx4Q6Dhmbbfbeih3MQZXhJvxSUnzknuEKBccvH32xrMByN1EjKU	2085	2959	2959	1616471820000	canonical
4021	3NLktfrrAfFyzHRqNZKn9Boqiw6mg9WJYXGj2ANu8LSFqcEx5XNS	4020	3NLAjp7TZjSRFbr2nL2MBFCN8ddJQgg9uWXetuot4bnFvJ15wx5r	369	946	34	1	3912	jwxZqfxoCPcwh2MCLBzC4LAfti5pgoyWTTLQAZbAeiYJ48FDpmu	2086	2961	2961	1616472180000	canonical
4026	3NLsnUKGyCZxdEMjqW8kyK1J7z6MsGdrr5SVE51LCaLD88MwtPmo	4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	1467	1376	34	1	3917	jy1rPNcdC3h3iMSUcU511FPUZAQ5g3i7fbLxbT65aGDGd1zhqet	2091	2966	2966	1616473080000	canonical
4028	3NLx57B78BdyaW3GtD4wKQaXapxutWanRqX3TAZFHP399gZre8ms	4025	3NKcBFLtNy3rGb4eWGzVZNpGNFopaSjDD7bEL1AUBDEqjUPLdjg5	1651	1055	34	1	3918	jxMLc9UQv6yGgNMufWNg5jyy64RzyXznanEGKVwyAu4zLNLyaCo	2091	2966	2966	1616473080000	orphaned
4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	4031	3NKEAjm56ouyM3vY4Lr8Fo939R1VL8ScDtVD5r2Mtb3cirjtxXTP	1501	1360	34	1	3923	jxyvaNMrCX9p4PFHKPdQkPQLvheHCiUc21W7WAvEAREekfBcQQL	2094	2969	2969	1616473620000	canonical
4038	3NLh7PmdoSGXY6jTA8iiGf9t3o5S4SemcA8hQ8owv8yDDc4FudRS	4036	3NLsHf5261hUjRBp6yJUgaiz2mR2VucrfbRdnckDzVxb7iAVy6m9	1458	1323	34	1	3928	jwupAxr3cT51SJ57Q9iFVyCuJ6YKYjmCin5r8n2CmxRv3gvKqDW	2096	2971	2971	1616473980000	canonical
4043	3NKw67j1fedMruZ74M3chTh6tB41fA4hpPNs5Et85Rgz1FLsVZSc	4042	3NL9EZbSN2cb5WNaG3ULGEgszD2q6ywWVx7DtB7g6t3NTff5cBGM	1407	1395	34	1	3933	jxng8MFrCFeVQ8j9FB6pD1VugeD2Ff5MqsmaahD7xJYWtfhECHj	2100	2978	2978	1616475240000	canonical
4049	3NKgf3QLYnLgH6qudCcLW4Gk8P9DBvurPwdAchy6c5bFRd9cSskz	4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	1560	1291	34	1	3939	jwHvLYssxyd4FZJpYPfEc3kVBSBP3imxGn1KjGALutofitJMVY7	2103	2983	2983	1616476140000	orphaned
4056	3NLwh2ac91cf94PWmUYhiarWSafC9CQuBUjskan1SvrbmoDVodfc	4055	3NKCYbC3mZzixmzgZdw7g5eMqgnwqe4ka8FMQApuJNbMUEEub8c1	1483	266	34	1	3946	jx2BPtGMejo729VUqw1QDoKERQL7qrSEtijZGbqPWUS17PWsQx7	2107	2990	2990	1616477400000	canonical
4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	4056	3NLwh2ac91cf94PWmUYhiarWSafC9CQuBUjskan1SvrbmoDVodfc	1602	1123	34	1	3947	jwtA2fcD81CeLQUa8aphLLRPQLHy6yd3M7SNtHj7qe6p2oQHLmH	2108	2991	2991	1616477580000	canonical
4060	3NLvsiJukiofwuCXsxepS6LUtMxuteJh4w2xvmgGXCZUjCNAeUVY	4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	1457	1391	34	1	3950	jxwZhVp8fQdG8psECp6ZjjiedkbmuhEssr9qLErVk1WJsZHCHUF	2109	2992	2992	1616477760000	canonical
8560	3NLtt1QG87CPYGn9Rvg1JnEZ2x6ywqkrW4NGwZmNyrNtnuqZ8tK6	8558	3NKfsGRvTXuaqi7hXTBxXnqDmfq9EVmXEqzexhayDGnmqfHxpbtR	1406	1393	101	1	6301	jwttAyBxeCVsucyQppCJpxpcD8y2q4UuZMT2zRRagPLjXF7ZzVN	4436	6242	6242	1617062760000	canonical
4002	3NKHihBYP7UszUL7b7PReMfUCFP2X313pEmDx6F4wvViN1MiTDJj	4001	3NK9wnPAuMA9yyC5QUHKT6zbxK4dXTMFitNNgwWCWsr2Nf4o67hb	1506	1373	34	1	3893	jxFBzeMdDGxwa775EWfbXscKbksTiXG2poQTNStgz3hVj4P3dHH	2077	2948	2948	1616469840000	orphaned
4007	3NL3cuERDb4euLu2XZqbxJBM4rhy67Jv4pukUgZrGPGfBuTrvC9Z	4006	3NKTX1Q4MFbiSUrATMKeQXbvPQA44kYMCvo5UJEPSWJwJiK98yRQ	1406	1393	34	1	3898	jxiHucUTSGPXdRTARaUyXPkHhwtnRtzTK3DdraS5mbAKHP3FVTr	2080	2952	2952	1616470560000	canonical
4010	3NLbMBcQmqUrka4Xgd1YgwUu6TotjrkKz6sZ87QBUhHNgY5VU8k3	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1407	1395	34	1	3901	jxWsViDJqNaLn2y5MFESmpMH2JdENHkx5B5ZG4udXCYPGyAepTu	2082	2955	2955	1616471100000	orphaned
4019	3NLYGoGt1vhZMTrNwjy39aoRbNDdScng2wNpWVFRTnaMEGDNjWmK	4015	3NLJT3jkE5QQR3owH8W3K6az92byXhz7hRjHGPAP5jUCd7yZ9Hda	1596	1117	34	1	3910	jw7qBrndAajhsnRfLJFerJ9P8usYTagmCCq7EQwyFsc9u8HfNpK	2084	2957	2957	1616471460000	orphaned
4023	3NKMgf1Pnbu6w2c6y5UinotZFspmmcpUYNXxqjTJhJ7xGrhxSLsY	4022	3NKx3jcjLbJQy8YwvRuWXAobhP6BuijNs5E8ojQwLH4bA4yFhK9q	1405	861	34	1	3914	jwwKW7NGZbweKB9z5JFTTeda81UaxmbcAcd4CTfKJfMmfkaG4Ka	2088	2963	2963	1616472540000	canonical
4024	3NLqqbRUo7YGeHjVN7aUia3VJhjsaEpAezcpGVxVAqRDWtFjNEk8	4023	3NKMgf1Pnbu6w2c6y5UinotZFspmmcpUYNXxqjTJhJ7xGrhxSLsY	1596	1363	34	1	3915	jxwriqF9cCQSK2RH6YHwC7D19Ln1SGr9qVpp9b4b3D2rSCesq7r	2089	2964	2964	1616472720000	canonical
4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	4026	3NLsnUKGyCZxdEMjqW8kyK1J7z6MsGdrr5SVE51LCaLD88MwtPmo	1673	1122	34	1	3919	jwzp6b5vtHtX4WpAkhPKeAks1rdLoHQFgfKygQEHZ8uxuvDJfBJ	2092	2967	2967	1616473260000	canonical
4031	3NKEAjm56ouyM3vY4Lr8Fo939R1VL8ScDtVD5r2Mtb3cirjtxXTP	4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	1657	978	34	1	3921	jxaFBWojECJXBmwXUW9mQBX5RqhUMVkBcAGHfVyp2oAMcEaQ7uE	2093	2968	2968	1616473440000	canonical
4036	3NLsHf5261hUjRBp6yJUgaiz2mR2VucrfbRdnckDzVxb7iAVy6m9	4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	1593	1346	34	1	3926	jxuSEhVz8FJdXuzFcLG5ZSzHkuvMjWD8zL85Eefu4g1BYAapww6	2095	2970	2970	1616473800000	canonical
4035	3NLmM47UfbaWy7W6xPLkTcUqXrr9S1KTDqBBiFQTzCTMz8AyAYdc	4033	3NKZUzeDnaNUgqS2HtRpvXEpTXSKf1UqTASPZiX2gKXXeu8TX3Dd	311	1307	34	1	3925	jxNETh5CH6MZgkJgSdiAx68notpnux5JAZveKK3T5HcsrN7Xs59	2095	2970	2970	1616473800000	orphaned
4037	3NKimDFhk2VtJAHwyJ9xj9SWqVN2QjsmAwkDKvKKVDxF4UVoY8st	4036	3NLsHf5261hUjRBp6yJUgaiz2mR2VucrfbRdnckDzVxb7iAVy6m9	1407	1395	34	1	3927	jwKWeAC1d1DmUxAsNYaM3ckK7RnDK8KMCLswVeq8ExQmkboYG52	2096	2971	2971	1616473980000	orphaned
4039	3NKzFxrfgPEpK1xzX4T6us7MeRN4uxVtAHoUvb4SBPn3nabctanH	4038	3NLh7PmdoSGXY6jTA8iiGf9t3o5S4SemcA8hQ8owv8yDDc4FudRS	1553	776	34	1	3929	jxNfttJWRb6doufpGh3hkPyy8Z4WrvGZJBdp3PaYyz8DnaFKYh8	2097	2972	2972	1616474160000	canonical
4040	3NLuxfZ2SZHNe13nXJqzafhpQcEi2nuauCkREcB4eAeRhBhVmgX5	4039	3NKzFxrfgPEpK1xzX4T6us7MeRN4uxVtAHoUvb4SBPn3nabctanH	1503	1151	34	1	3930	jxxaQDXZ1KNL2JwWpibVMbf15Ykb53cxQJK8nPswqfjCL8j85Mc	2098	2975	2975	1616474700000	canonical
4041	3NK4BtFHy1QTNRbiba2HDJddarnqSKYkFjy6gRxUCVpuUwq1P73N	4039	3NKzFxrfgPEpK1xzX4T6us7MeRN4uxVtAHoUvb4SBPn3nabctanH	1631	793	34	1	3931	jwb7fou4KU4sFesZdhdFHRzEUFMyc1zRsAfmYTS26PmmYTZfnzP	2098	2975	2975	1616474700000	orphaned
4044	3NKWc5Dt13gm9KLKAHi68gJ8GS9rsPUC6hUUetBUBFXKFFyw5vDy	4042	3NL9EZbSN2cb5WNaG3ULGEgszD2q6ywWVx7DtB7g6t3NTff5cBGM	1406	1393	34	1	3934	jwaG4HvBBjbLLny8GosztujDo1PTxbaJMKPTUgNsQ1LteLeUGJA	2100	2978	2978	1616475240000	orphaned
4046	3NK3JdRfMA8tBCXq7hrndu18dx4M9gDKEGCem8F5syEDsArGs1ff	4043	3NKw67j1fedMruZ74M3chTh6tB41fA4hpPNs5Et85Rgz1FLsVZSc	1519	863	34	1	3936	jxzoV4C5jTZ3pF6ZBjPzC8T4ER2noMP5HbJDaeh35Lp78Gu4G5v	2101	2979	2979	1616475420000	canonical
4045	3NKcfF1FWaaenkBrjRGAiqdrJhRb8qANrV6nJuxKPgRKTeoXS9u1	4043	3NKw67j1fedMruZ74M3chTh6tB41fA4hpPNs5Et85Rgz1FLsVZSc	1534	432	34	1	3935	jwbYow3Ct3swNyC4884ih4md6oxiDqSco8VSJY3dLxjsyVGge5q	2101	2979	2979	1616475420000	orphaned
4048	3NKeEHZxmCUMhBAeKjA9wiiezhqijv7DBXy7imrUQRf3D2Cnyz7a	4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	1407	1395	34	1	3938	jwUnEC4zp7ZYFcbapcuXHVbsbxVvv3fVomXNeBsm1dQhsTAcMLz	2103	2983	2983	1616476140000	canonical
4050	3NK4bMAuVXhaPWrn55FkzwxGyhMCyn9buzZtqwiiWMC2DLP9jDDS	4047	3NKTqPyHWs1EzcctNUiXtXYLdbURNqmsaAKKVMmKXcLjidromS6K	1585	1366	34	1	3940	jxdTgpJTb41yUZxWJerkskyjymRHah7pjQHLKchczjGupFQsxSe	2103	2983	2983	1616476140000	orphaned
4051	3NLFQPDbmmtCwZ4vmHpak29a7RaaHcc9KXB783Nw2JHEkDDH3fax	4048	3NKeEHZxmCUMhBAeKjA9wiiezhqijv7DBXy7imrUQRf3D2Cnyz7a	1407	1395	34	1	3941	jx6UUgTLCwdv2ez5DMzawTUy6aJdLpSdkbVwCsYcYXhLrAoxUeQ	2104	2984	2984	1616476320000	canonical
4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	4051	3NLFQPDbmmtCwZ4vmHpak29a7RaaHcc9KXB783Nw2JHEkDDH3fax	1560	925	34	1	3942	jwajSkBPuzXZ7BZdtMwMBaad6QgnoZMvyo6ndBFxfDXMYZgefCa	2105	2986	2986	1616476680000	canonical
4055	3NKCYbC3mZzixmzgZdw7g5eMqgnwqe4ka8FMQApuJNbMUEEub8c1	4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	1616	2	34	1	3945	jxUVXtjgpJ4awfHD9jTVkqSCsuPoGXAaMcCktVsCiqzpSsCMf2Q	2106	2988	2988	1616477040000	canonical
4054	3NLW4aJTqPcMHESTmX87C8A9JEWUKhDYir1E44cs7io9NzDTvoet	4052	3NKEVZSNzHH4oSWHtHtaLSAYVkqDaSyzum7T4JH9iMtQtdhf3VFr	686	686	34	1	3944	jxXVZGQLb13UMdmEsLhnDNmjw83gNw3tRwqqCeZRDMU5Hz18tQ6	2106	2988	2988	1616477040000	orphaned
4058	3NLatv8bDWGSFMqb2S2f4KCd8advLmQJb2whfMKh7sdJ5ayMF5nx	4056	3NLwh2ac91cf94PWmUYhiarWSafC9CQuBUjskan1SvrbmoDVodfc	1401	4	34	1	3948	jwuEMgBM8jQp6NcYKZxt97ETfzvvYkrFG9HQw1LpNixKwz6H3kq	2108	2991	2991	1616477580000	orphaned
4059	3NKThWtTiX7nKsgzbttpz496PnjnEwHh5scCaJfY4j6r8kbrkka7	4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	1407	1395	34	1	3949	jxpiFE9vosGxBodG3b1LovqFAGdh9BRYyPbFh9JHJS2QJBstT4R	2109	2992	2992	1616477760000	orphaned
4061	3NL84mYdiAswaCEHPwVRLoStJ3yTjyv6Yaa8FjmCdmZk6vKoKBM2	4060	3NLvsiJukiofwuCXsxepS6LUtMxuteJh4w2xvmgGXCZUjCNAeUVY	1600	1126	35	1	3951	jxHAMJ4HshdjiGaRGncEDthz8DQqoA6gx6Bw89ZhugmnWnaKzw9	2110	2993	2993	1616477940000	canonical
4063	3NLKCeCYoFa9f96RyJQG3h8gALTVPtdWMNhWP55VfRBgUqPmVL81	4061	3NL84mYdiAswaCEHPwVRLoStJ3yTjyv6Yaa8FjmCdmZk6vKoKBM2	1652	1315	35	1	3953	jwqndNJJ5272wWfLfQB3XRCdazo7B1iNxpvMViL7U6hAEUoCnEf	2111	2996	2996	1616478480000	canonical
4062	3NKjSTWWBtsqVfvpqeTre4XjzgM6CsUw2NEu9VbuLURXazHrq9mn	4061	3NL84mYdiAswaCEHPwVRLoStJ3yTjyv6Yaa8FjmCdmZk6vKoKBM2	1406	1393	35	1	3952	jxQfLbQMddmhuiPwZ5HVwZhb2kYGVaJEK56NygWF5aDuLhgsDnr	2111	2996	2996	1616478480000	orphaned
4064	3NLV3GaX1Yq7ffdNn4gBeVLKnnTzDAznxE51VSzzB24acYfRuE6R	4063	3NLKCeCYoFa9f96RyJQG3h8gALTVPtdWMNhWP55VfRBgUqPmVL81	1407	1395	35	1	3954	jxqnXkgHfGMACZRAvhGRQDYVdz3GCp3JBnZ9QHkdTaQF3N9NwgH	2112	2997	2997	1616478660000	canonical
8562	3NLZTZx3BhwqjsdfSigZHxmAkq5PVvwqtGzRn9tLUYpV3E8Rca2x	8561	3NKKUnt9WDBPWRuKjBGx1PtbcQLvRkmsJwfF5iySYqpsaJ311ckR	44	1325	101	1	6301	jxjaiF9P5PTdhAypJuQmb3UVKgE9Xtwj5djbWrW74cMiAub9Gjq	4438	6245	6245	1617063300000	canonical
9769	3NKwhF3C8A5Nzp5B7E7g5aDs5gBN8J9QrG9Bx6K5En8JaaEcJiWL	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1637	816	126	1	6301	jxjoks22JvYs3HxsHGE8T6weim4aNS15b2XnLDzRLu9LP48MjbN	5061	7122	7122	1617221160000	orphaned
4066	3NLJjg337YXPPEsL7qWFrpB8ugqHTQkSH8RWjrFBDFSQZGL4xFXD	4064	3NLV3GaX1Yq7ffdNn4gBeVLKnnTzDAznxE51VSzzB24acYfRuE6R	1406	1393	35	1	3956	jwHrRjXnfyjm3CnJh8aqeFHJfKQYJHKqU9QDmnPMe9KYUFcgkV5	2113	2998	2998	1616478840000	canonical
4067	3NK7nnQtLzKfCxMpxHnE2vmtQ3275pA6biimFQLxSf3vxirYB6GY	4066	3NLJjg337YXPPEsL7qWFrpB8ugqHTQkSH8RWjrFBDFSQZGL4xFXD	1407	1395	35	1	3957	jwPcCnuNWptVccJfSHXD8obAUtu9onutVjceBSawz2ZovqCMkHj	2114	2999	2999	1616479020000	canonical
4068	3NKphQSyZjA9BN2XksBwpxvpTxmUgZ6zWoKvhxF9pxrfcEPFUrjY	4066	3NLJjg337YXPPEsL7qWFrpB8ugqHTQkSH8RWjrFBDFSQZGL4xFXD	1403	824	35	1	3958	jwvoRWuPFgygeHUBosVV7dN5qYTmnogmLxwiMjz32uKhR4nT2fG	2114	2999	2999	1616479020000	orphaned
4069	3NKNUMgY91mLzv699YgmGBqCBnc5QawkejU3QnSeBM8CquXahdBM	4067	3NK7nnQtLzKfCxMpxHnE2vmtQ3275pA6biimFQLxSf3vxirYB6GY	1405	857	35	1	3959	jwSUYbUynV9FscUavo4HoA78AcZTn599v558E2M2xtGdqEAZMqv	2115	3001	3001	1616479380000	canonical
4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	4069	3NKNUMgY91mLzv699YgmGBqCBnc5QawkejU3QnSeBM8CquXahdBM	1564	1092	35	1	3961	jwWysQAoykYpNgSzUdeaXGTbVTBoUCYJjyBSVcvECudfh3eZWPe	2116	3002	3002	1616479560000	canonical
4070	3NKjVp7SoA6TKKTDHD9q5jKeNsBHtGTp8WoRuo2ULyGFfQeKfGuB	4069	3NKNUMgY91mLzv699YgmGBqCBnc5QawkejU3QnSeBM8CquXahdBM	1407	1395	35	1	3960	jweJDJijrBERVWUJcKAiVdZrrKkyb8E6AGHroMLxAmu3Msw3pC4	2116	3002	3002	1616479560000	orphaned
4074	3NKgeUrpGDrTy91fq1rLUfQMw3mwqYWGRJeySXLw9je1tCybRuy3	4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	42	1115	35	1	3964	jxUr9VzXsWpyDBFiGecz9SCZrkFhyrdh1W3cHxq6o1TuHDXNZ4C	2117	3003	3003	1616479740000	canonical
4072	3NKGp4jzgs1wbPHQo6SiyitxA48PXYzxFfgvxNaTwoHv1idRKGaj	4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	1471	1140	35	1	3962	jxNvN7HR22To7Z6WBE9x7YBTccUPQYzV2cCUkUEYs6KMBZrDz6B	2117	3003	3003	1616479740000	orphaned
4076	3NKAr7GvvXzHZvnPBVstp8KVZwCt8tvNvpCXfRzYPcS1QvzW2EsQ	4074	3NKgeUrpGDrTy91fq1rLUfQMw3mwqYWGRJeySXLw9je1tCybRuy3	1624	1208	35	1	3966	jwedEpyML36BSWdoxee879UCdbt8XoynnD3na7ZyWNr4HRXfsEx	2118	3004	3004	1616479920000	canonical
4075	3NLDk8gZVWUDfoFKUo6z887Hn8WoV5TrCNx9jKs5ybUZzsq7yrNc	4074	3NKgeUrpGDrTy91fq1rLUfQMw3mwqYWGRJeySXLw9je1tCybRuy3	1407	1395	35	1	3965	jwRzE9v8bczne1EhQuyb9DEBqt2b9Ar8nLryAGDKG395gfWjcuT	2118	3004	3004	1616479920000	orphaned
4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	4076	3NKAr7GvvXzHZvnPBVstp8KVZwCt8tvNvpCXfRzYPcS1QvzW2EsQ	1476	1245	35	1	3967	jwPVfTNZXLdEchMhuabgUMXmE26uDu2gLcF1ThoDmA9QfLeXmHp	2119	3005	3005	1616480100000	canonical
4081	3NL7aYy5JUE7h8mXUsofeMXKTrrgTZi5QUUqutvcvrkSpE7JvZAq	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	1617	1288	35	1	3971	jx2aPz8XihyGrSySvLy6muwnbrh8xk8beB8XL7Tqt78XY7gQXyi	2120	3007	3007	1616480460000	canonical
4078	3NK4g8vSGN4a6Mm9AhiUXBsbLKyrG9f1f3dpj5KLRSgsb77h7bjs	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	80	1147	35	1	3968	jy1XPdqdQx43xP5E4BY7XBdgKRdUHaFwNSWiMeaLxLbEdAWKTH6	2120	3007	3007	1616480460000	orphaned
4082	3NKEK637eavt8ygGpFZRDqMrbePcMcuPmC3FuhXGb3qSgpapSA1N	4081	3NL7aYy5JUE7h8mXUsofeMXKTrrgTZi5QUUqutvcvrkSpE7JvZAq	1457	1145	35	1	3972	jwU8jGR5uV3hshrwtedssQ47E5n16ctneCp8en6bJKFq2nfxmEm	2121	3008	3008	1616480640000	canonical
4083	3NLDB5Y2hh9sgk8x8dgHbRGJpbMLD6TqpB2iW9P4jF7Kauq1d4MN	4081	3NL7aYy5JUE7h8mXUsofeMXKTrrgTZi5QUUqutvcvrkSpE7JvZAq	298	1308	35	1	3973	jx8zJeUQv928pDCE2xeEgF1tVhXm14RWuwzbD6apEcNWrwrmhYf	2121	3008	3008	1616480640000	orphaned
4084	3NKqqb4wWNHJY5ZuNbW2cCksucPi6mL6e1Kths21UxdtFTFTxvWA	4082	3NKEK637eavt8ygGpFZRDqMrbePcMcuPmC3FuhXGb3qSgpapSA1N	1601	1022	35	1	3974	jxpCAD43jtvy1dfNtzAKhPwqAMHWywHmgrKnM6HLrQRqhSx3Dh6	2122	3009	3009	1616480820000	canonical
4086	3NLMUc3r9E4Wdo2zckDdeEx62HPsV633qTr5GffS7Fy4jKMbHZ86	4084	3NKqqb4wWNHJY5ZuNbW2cCksucPi6mL6e1Kths21UxdtFTFTxvWA	1607	1348	35	1	3976	jwtXvPWqyz4At4kfH6eCCzSM2rLCpp3KYyJq3YUs95osX2rZ82o	2123	3010	3010	1616481000000	canonical
4085	3NLfhjzbzKCHSiBamfvnic1fBPgkQkHk4AsUToGs9emEKYUWTMbH	4084	3NKqqb4wWNHJY5ZuNbW2cCksucPi6mL6e1Kths21UxdtFTFTxvWA	1407	1395	35	1	3975	jwfNroukNaGuYTEfgpdU9TywDDKNDqUvU1Tta3xgDBECi4emyM8	2123	3010	3010	1616481000000	orphaned
4088	3NLmXzvvj9K8pTn26ogFKjvuqRUVP5jXZtdXgX8ddqwyU62oRfh2	4086	3NLMUc3r9E4Wdo2zckDdeEx62HPsV633qTr5GffS7Fy4jKMbHZ86	1601	1388	35	1	3978	jwgvXQthzMGP6WchjsVbhw7cx5gf5nvMdN4iZhvo5AYkgJkjDY6	2124	3011	3011	1616481180000	canonical
4087	3NLPexratndUYk5TJz2EaQmAP8GGCbnURxz9mdrugRhcxaRBvXFZ	4086	3NLMUc3r9E4Wdo2zckDdeEx62HPsV633qTr5GffS7Fy4jKMbHZ86	1610	1188	35	1	3977	jxyHsyrvBFmkDcSJT2hxNNeK74XBEKNAdxxnz9NWmE7N1JwG9Fn	2124	3011	3011	1616481180000	orphaned
4090	3NLUdBTYLPx9wTYS3tCMtQg34bWpv88RRwVnMr7HHYKwDQU1r6j1	4088	3NLmXzvvj9K8pTn26ogFKjvuqRUVP5jXZtdXgX8ddqwyU62oRfh2	1405	849	35	1	3980	jxjVfrBLT92NYLwDdVdxQ9abgq22qrrda5oiwk3pkjvJiEh443Q	2125	3012	3012	1616481360000	canonical
4089	3NKFSdo2aw5mYWvWGNcefjKQKZs1q46gMhGgQhrNauUkpoJPLwdV	4088	3NLmXzvvj9K8pTn26ogFKjvuqRUVP5jXZtdXgX8ddqwyU62oRfh2	44	1325	35	1	3979	jwDJfBJP7MwXi3GuBg5zxvLZPkLwWkXGQsguQS764jnqTnmBpT2	2125	3012	3012	1616481360000	orphaned
4091	3NLaFTi1bKALkFwJP9Bnc2DbovaoCBmC4SHGQFPVj6NazjMjBUMx	4090	3NLUdBTYLPx9wTYS3tCMtQg34bWpv88RRwVnMr7HHYKwDQU1r6j1	1673	1002	35	1	3981	jwUmGUaFmPWBgzU57d92HYQMfHHRYsJgLHMcFpZ6sMLL1mSQWT5	2126	3016	3016	1616482080000	canonical
4092	3NL84VjnmjHBwqYGZR4MZrQx8hJMUmrrSTaNaE8TZgM6ThXwrCHS	4090	3NLUdBTYLPx9wTYS3tCMtQg34bWpv88RRwVnMr7HHYKwDQU1r6j1	1615	459	35	1	3982	jxGuRXkcU3kskvFsSHgZBuAWyH9BgNBesxR7tf9FPt9cSXWp1bh	2126	3016	3016	1616482080000	orphaned
4093	3NL2P4Xo9JTwp735t3jh9SAg7AWn8exD7GZ4GkcNrxs7FaXHmytb	4091	3NLaFTi1bKALkFwJP9Bnc2DbovaoCBmC4SHGQFPVj6NazjMjBUMx	1541	1298	35	1	3983	jxUJHXB4nAWeDxiFAb3Tzy91Tqd2YAjNd3dBQms2fAqvNRc3RjC	2127	3017	3017	1616482260000	canonical
4094	3NKkK3XXt1np2ZZLurqvnEMp8X1QNxSKN5DQPCEtsuFzj3xVD6on	4093	3NL2P4Xo9JTwp735t3jh9SAg7AWn8exD7GZ4GkcNrxs7FaXHmytb	1522	1322	35	1	3984	jwUkzbjvirjz9g4ve5ttjNhA6DkbRkeZK7sDXWSc6i1LU5YJWHD	2128	3018	3018	1616482440000	canonical
4095	3NLbgvAMn96ZRAzJxk17GswnK1d87ejutGFYL7kX5CGXucmYtoQr	4094	3NKkK3XXt1np2ZZLurqvnEMp8X1QNxSKN5DQPCEtsuFzj3xVD6on	1403	824	35	1	3985	jwrKVUp1yAMPpeqD6UdM3FXU3yQ2ETF6JoAtLijTMPc82oDq254	2129	3019	3019	1616482620000	orphaned
4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	4097	3NLScEpsTiH6D9xtRANLTmAbH8nLGSP2QjUw7jQMkCfmF2RuW658	1607	1348	35	1	3988	jwpbzVDQF5WeUoxU4y6XPR1tCqD6BV2KNWaFS9RMy3tx2HhRosZ	2131	3023	3023	1616483340000	canonical
8589	3NLhEH2AoKGY3wLCYo2PT11R4djtc17XUBcLMUrMs7xS8JPTB8Lr	8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	1481	790	101	1	6301	jw7agkmMLdBsFHK6QXoBJ4cTziP2fLFiMtkDwy9knewvQrPq9Pb	4453	6264	6264	1617066720000	canonical
4096	3NKmJX8TYjq1C59CSNY3Rh7phd46RYfoQbzDVUiBKLw7bzJJuRtz	4094	3NKkK3XXt1np2ZZLurqvnEMp8X1QNxSKN5DQPCEtsuFzj3xVD6on	1553	776	35	1	3986	jwvy465Lc7ksJiXqipiBC4vnjHh9h1EYqcqrq2B1k1TQM7ak32J	2129	3019	3019	1616482620000	canonical
4099	3NKvdF547Tp1ZudZRoGEc9azsxM8RpD3xtzaKBQsi1yqkx3UGZcX	4097	3NLScEpsTiH6D9xtRANLTmAbH8nLGSP2QjUw7jQMkCfmF2RuW658	1402	868	35	1	3989	jwZadNUy6cykAsCQqSRrPSx9vmrHiPr1WeQKei8uma3sDRYcwZW	2131	3023	3023	1616483340000	orphaned
4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	1403	782	35	1	3990	jwBemCtbwqLxit6H774KDSUkWQSnAuL15JyG7uLZs4U4oN5UZmm	2132	3024	3024	1616483520000	canonical
4103	3NKvEsTz9WscnNaPTxqp6TuK7NyNSKrq89vDBjDz3ecQZnAHcYYR	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1642	1367	35	1	3993	jxmvyXndgg7yBKnc6yNyPEm8wpWMB4tVKDJkwmjXXrViRY8ZiWs	2133	3025	3025	1616483700000	canonical
4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	4108	3NKaXDMhqAtDzJu7vK4WY3QWKm9ZPGWN1pUTztBNSg1b5kkBaAbs	1406	1393	35	1	3999	jxdrQ6VuwPjgRKuoGCRvNmgRrWkbVpdSTqtLF6n1SUTygcFxpfF	2136	3028	3028	1616484240000	canonical
4116	3NKywdTeuqc5xxst1zPnapD6wvye449eU17DbGjvBcvhkpU5wMWc	4115	3NLGj29tZEjN8miYQ4kLmsKwpmaPW3SyFE6r4X9siV6EpR9zHwLn	632	1136	35	1	4006	jxYkdyUdckQZPPfuvewshNqniaDXKip9fGXF9nZeUvvTAqAubQj	2139	3031	3031	1616484780000	canonical
4119	3NKYYw1zGkCP5qgHDgHk5mceowHxbJ5jPDwUL7aot9hm2m6X7ibL	4118	3NLatm6HagSPS7wVA6Xm8fcWUFduVdgXHJWKNU9nxZ4V5j17vDdg	1536	1313	35	1	4009	jxCSPdv37r4CNMDcFk5zorzB2vmAPEbJsMWpDwAvYDVcKhfiD8e	2141	3035	3035	1616485500000	orphaned
4121	3NL5Smi24YgyUjb4Gwc8FDeyoZMc796tK2aoo97NeDvbuEzcspXn	4120	3NLwmJGNinL5NSmdcMMF8AkoFYcvEi3TN756rBV6iCP7wsT5NYev	1623	839	35	1	4011	jxwecusdSuYRU2ndNNHWMFRGJZUjcskMie9A8ASV1GA8XQjJRAS	2142	3036	3036	1616485680000	canonical
4126	3NKtwxqwz2DhDyYneRZ2ikmmrUQXKvBdn542qi4gjutTXC8Ui6ih	4123	3NLFsX3egPNHqD1hWj1ZuZqmehMWf23a12HoYmy8JYNuRUyZAZq3	1527	702	35	1	4016	jx91crtUGWGvdw27h9n11nTv5JpYT1GbmgBKvrcA7qTLbYnZMZU	2145	3040	3040	1616486400000	canonical
4134	3NKubRvAr79fLpDYJRGSZJjFtuE6Wq5YgRGcGT6dsMjqoQugEhrs	4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	1403	824	36	1	4024	jwTVkZaMhK1832hNbRMJnBwgT3VavJs2antaes3JPVHm1M1HHzz	2151	3047	3047	1616487660000	canonical
4136	3NKDhuZ6u2vRhwpYFfoXAHgfRPL8Vmxh4C7d4JebxFo5SjZqQx1G	4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	1508	1387	36	1	4026	jwNqz4fXCDNEunPRtUc6GnAuQVi1vDf6oozfi2FCPoYsAC3doWQ	2151	3047	3047	1616487660000	orphaned
4143	3NLsTnqg2ENs7Z41JX511Lsq8TditQky9NEge5is9tkHw4Xw7rnD	4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	1403	824	36	1	4033	jwakwggS3FX3ZVh1HJGBGCabKbSSVUGYhpP57NYacBdPwWwzNCH	2155	3054	3054	1616488920000	orphaned
4145	3NLd4p9FGLKEtLoMNst4saDyPuJ95PNhhaQMpbsjndZUVBKisGW3	4142	3NK3dBQ7nzLDAdVJ4mCYi6k1uwPY5R2q6Py7wzQ8fzhVrmaAZ5Ef	596	940	36	1	4035	jwGnnNbsQ1m6JHsJmLJuk1oDrrt5VfPfS4LYsscGtzvJWRnj2k2	2156	3056	3056	1616489280000	canonical
4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	4147	3NLvKLVp3XqV15R8CsoHCgevvLJJNcqWALxpVhpUntZBn7T7Y2yJ	1407	1395	36	1	4038	jwkvZpZJbw6Djr29u8fvxyDHpKjzxkJUUqqGLc4hkKZR8UdKeJL	2159	3060	3060	1616490000000	canonical
4157	3NLKoFwzNjNaGfafnFTVrjx8fAWmzG4i65ZZjp7isr8Ki5pVdiop	4155	3NKNjqCs6NaNwnZkTbJprZUN3AWAGjz37vXTtdPAgtxjnGTEprd5	1489	1380	36	1	4045	jxEA3vq4CsS4hVSJvEK9hajzLfABKJU9fjKkqz11kpcqcuDo8M6	2162	3063	3063	1616490540000	orphaned
4164	3NLDophfT6QvZEuvXmYnMaVmTkaBdGY9vMn4HxjkAvngY5SPrDCJ	4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	1670	1036	36	1	4052	jxj8K38YBDvrkkv9Sfbubsm24dTQPq6zavzkgTufkFVhXYi3iqK	2166	3067	3067	1616491260000	orphaned
4169	3NKoHxJi1xV2GKTXRWnpxhDuzTZKtCAT6BoA1FWaSeB3FgtQMcfT	4168	3NKjK1wZso1nCVdQHWQ4a3cMNHtt48PB5pWrBuAXXmnf15WaepCm	1406	1393	36	1	4057	jwXj4G51q8t1kAF2w99U8pLTicRd4auSo3gGBTT3wWAamhX1TWF	2169	3072	3072	1616492160000	canonical
4182	3NKqGj3U7Tu3gKLThbDRYeUZ8cS4kdqEqToUC9xx5xhoKCMU4wNk	4179	3NLuHmQ72A2QS6s9M1fCYRV6r2GUSkfUCPqKhjyqc2fMVzc5SYDE	1670	1036	36	1	4069	jwixcA6EdzJw85NWQEXJwBRHEkHDqcACm1DJGH3Bm8136arHwin	2177	3082	3082	1616493960000	canonical
4185	3NKFHAQYa4CqyKP3ZYYU4Fip2mHzUBB5He1zWgppFB8wAjBZ6S3t	4183	3NLoBpbzJuTgCyBRk4mPaT5ttLEPiRUzZVVk37EkdZJRKPsUhdSp	484	1319	36	1	4072	jxcafmM9gvAyTXqcgCVQxXtu5c9xQADEr1MrF7fAQS3FxUi5xq1	2179	3085	3085	1616494500000	canonical
4192	3NKNfPuJmMQo1HwJnVSH5wfZwwcqVxnkttvRzpfvzJvfnGdzZrr5	4190	3NKRrb6Z8UTsecDUhYnJoPGwtXUhG3yiw9aAd4DJmEZzYyNFyzqb	1458	1077	37	1	4079	jxcziYqdwaTeG1mQk3fwzscaF64MK47pJk6wzbxGFCDrRK2zqMH	2182	3090	3090	1616495400000	canonical
4193	3NKnWE4CesiNmVpLzT3LmA4SXQPiUCTMuBYwGtMccQprgWjub39G	4192	3NKNfPuJmMQo1HwJnVSH5wfZwwcqVxnkttvRzpfvzJvfnGdzZrr5	1403	824	37	1	4080	jwChb1pKXnP2vQ7Bq4CeXytxRgAwmZ2S5xYQEvDjH5PF3HVTFco	2183	3093	3093	1616495940000	canonical
4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	4197	3NLmQGYqxyr2BRw1BTP8rYZp2NZdyyQSYXdkdZJZL8E7QquvwViG	1403	824	37	1	4086	jx8o7s67RLjWmakFzvPKKFy9hj3jpEvKU5d59gyDMJXFvUsMbFb	2186	3099	3099	1616497020000	canonical
4201	3NLaeJhsiM3GU7AQ7KhocDYpb5mKy8Pf7gDQ88QPkyoLL8PkW6MU	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1619	1029	37	1	4088	jwFGTLp7rhCRF3VX6gD9ffanSUwb7BozwMKy2WzMHcU3ejKELrb	2187	3100	3100	1616497200000	orphaned
4208	3NKD4ajEVo2NxEDjEcCZ6pxMAGbWW3YxcNmSPJkXU3gFHsR4Gag4	4207	3NL596VruvUfMuoj5GMnYnhpkcBwX1mniujqgcs6SCwrUeah1mNW	1407	1395	37	1	4095	jwrH48Wkk6yi4qKjqLow5pf9LAUbnjqgTfLQKXeEMmUTmruyMmZ	2190	3106	3106	1616498280000	orphaned
4217	3NKz4bgoAjxqKnpM6SwgRB4wZYLC42T23JRyMZRwrD31wUsniELW	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1647	936	37	1	4104	jxxarE599s7McLHwwpqR2a3dvn7k5r4uaHgoReo4pYxGwULscaQ	2192	3108	3108	1616498640000	orphaned
4221	3NLp4LT7V55WZGsAS6MNKjRdyKrQeKvBHW4LQyVZJumovZk3YQFw	4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	1406	1393	37	1	4107	jx2L1azxLGWG8WtzUqWVgQ4o7xTuPPKoyVQbePkJ9P2H2DjpXxq	2193	3109	3109	1616498820000	canonical
4219	3NKgMPvr3LcWDGjyadZ78MrTUh44rFMVdApTUAACfSTKuTZWqMyf	4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	1426	1364	37	1	4105	jwPmn8G3mKqpX81JL5TARjJdAtZsHiMU5kEH4S64zyB9yYVn4MM	2193	3109	3109	1616498820000	orphaned
4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	4225	3NLK5pHKNzgU3RxmVBAfPDXaKnX1d81LTPVdHUMPeN9thiyYosEf	1406	1393	37	1	4113	jwByKAnw2jv3Yn87hNVeao75DciJ6W5mnmWnotYc4pKCq4UrHnC	2196	3117	3117	1616500260000	canonical
4233	3NK3b4WBZrPEXNLJhn6VkVrXdAiW6J6x8fz2iAmiQMRZEUyD2FkS	4231	3NKZSmNv3cU8rgQrcW9tkKNNb1b4w4n4HcmD63skKvnPWmqpEpC8	1445	1164	37	1	4119	jxqQBKkxkoshyqC7yyQoDjStSRmHojmRQCACyDnE3SwaoDPmNDk	2199	3125	3125	1616501700000	orphaned
8596	3NLUCkRAGaZ9qcs1BNeBuxe3xt4s4k9prCXVcU62afUJ8n5W2QMP	8595	3NKXKRgJNTcVWwSEXnVNbG9QCT4fu3dCwdK8tc8mttRnXmbvgUFP	1406	1393	101	1	6301	jxJuSBxPHxEDFWGr948MQdmFLkv4KNU2D5TzkVpGF1mfL31756j	4457	6269	6269	1617067620000	orphaned
4097	3NLScEpsTiH6D9xtRANLTmAbH8nLGSP2QjUw7jQMkCfmF2RuW658	4096	3NKmJX8TYjq1C59CSNY3Rh7phd46RYfoQbzDVUiBKLw7bzJJuRtz	1541	1298	35	1	3987	jwEh5yBBwgweRCSLMVPyWGgcgUTM5t2m8Z2Z1nscnph7mdj5icA	2130	3021	3021	1616482980000	canonical
4101	3NKFuS5tywNYM9GaPkKga4xFr7YyVpaH7cfh4ajMa6M9QdZjF7Vm	4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	1406	1393	35	1	3991	jwvXwVHB3QSRvbDUdWujmi5Zhs7JG5kLKapJNLipH4ZQQzPWL6V	2132	3024	3024	1616483520000	orphaned
4104	3NLV53goKw1RTPPvSLDhSTq5wkN9BxeT4DhxXaJqTqmfA4KKtTG2	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1483	308	35	1	3994	jwtxLkxQCHD8qKLC4pC1TMR9gNj67aYvRzT3upmC9LUUwPEHFwi	2133	3025	3025	1616483700000	orphaned
4108	3NKaXDMhqAtDzJu7vK4WY3QWKm9ZPGWN1pUTztBNSg1b5kkBaAbs	4107	3NKBCMwgRnEFJvpiHeUcy1RQiiWma3ZH48QVNzD29txFT4Qbbdn2	1403	824	35	1	3998	jxYET7ypUEyRz2CpKi7GPBzYZJwXHLp5dsNvF9K1FPvE8sLPo94	2135	3027	3027	1616484060000	canonical
4111	3NLEfLH3uecx8ntkvYNd9cWGVdAvLbrdakPhBWb3Vt2V4eTwkWRW	4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	1474	1083	35	1	4001	jwdWCoPacdSAdNs4jvN6v8MoKM6ehcrGp5PRxxyiCVHdc8LDucv	2137	3029	3029	1616484420000	orphaned
4123	3NLFsX3egPNHqD1hWj1ZuZqmehMWf23a12HoYmy8JYNuRUyZAZq3	4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	1608	923	35	1	4013	jxkWtiyzy3TKCsWt3ctiRCALHAszcvtz5StZ1HzkamHGc132Zef	2144	3039	3039	1616486220000	canonical
4125	3NKM4CHUtTSYPk1gcJSC2aAvyaZrWb4hYhdCr8Te1XTXJxXB3pVU	4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	149	917	35	1	4015	jxLKNU3gEspWJRdfMX7hiYR2QvBqXQj9RndShPCXDFFkVFTLC2w	2144	3039	3039	1616486220000	orphaned
4130	3NK8cYR43LexRiKDJp9GCMUbbYKfA2UWNxatzST2kt4ztNQM9DSi	4129	3NKHL4BXg3sBXXZNDkQ4aX38Tu9YD39hhU4EtsxofJvkMa8nhpLv	1579	1263	36	1	4020	jxuPnTKW38MUJHeWVGXm749dcxKCycZCW6vk6DnSDNiep4FViTH	2148	3044	3044	1616487120000	canonical
4137	3NL3Evd5fuJGN8YXNibdUeoMp6v1PKzM77LH9tH42cCjTbHES3TC	4134	3NKubRvAr79fLpDYJRGSZJjFtuE6Wq5YgRGcGT6dsMjqoQugEhrs	1483	910	36	1	4027	jxtUF59bWFKKw7qzwDdyf3BQSoEZTGriDxVb6h6F74nWyZKukob	2152	3048	3048	1616487840000	canonical
4138	3NLorabWezBbG2v28MCwdGhU8cz6GHDMNvRErc5KkHZxXNbyvHmp	4137	3NL3Evd5fuJGN8YXNibdUeoMp6v1PKzM77LH9tH42cCjTbHES3TC	1609	1333	36	1	4028	jx5aPTAkQtAH7uvfZRunKFJ2B4m99UdpMui1yMgEHv3wRAHfibC	2153	3051	3051	1616488380000	orphaned
4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	4139	3NLKFg5o7fRyd6EYhrF84QNyxT3tWT5CRhbdcx8rqFopthBZQR6j	1527	927	36	1	4031	jwcuop6FA4xRjYjMXLFzeCBA3KJJiGdAZ5Q3AVbZSDwrgAL5f5Z	2154	3053	3053	1616488740000	canonical
4146	3NKN2H6YZaSBag45K4oAJuDM9wwcewCkf83TmKTDwUwxykzHr24n	4145	3NLd4p9FGLKEtLoMNst4saDyPuJ95PNhhaQMpbsjndZUVBKisGW3	484	1073	36	1	4036	jweRutNdSnGBoKz39h6wUZNoxzNSCGbQtsU5QgUqwSqktFpYmZH	2157	3057	3057	1616489460000	canonical
4151	3NKzKmHBj9qPQ4KbH3PSWFasPivTF1sE4Uj1KKKRVnM1zWRsCxLA	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	484	1319	36	1	4041	jxbSXxSPzC3mJ6yrkgbNRiNXrBc2Lybhd4TQaUpeAU4EKncAujh	2160	3061	3061	1616490180000	canonical
4149	3NLZRjZv8zKnvdkWeLGWM36PHopkSdaWC4aL2Ye1Pre1pCNYGQG4	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	1423	282	36	1	4039	jxSEFjTB3CAi3ALYoCZYaKNbTfjDx4jD3UA5Dk1zQdEgCoDSrN8	2160	3061	3061	1616490180000	orphaned
4153	3NKeQtnvAyZN4Rp4mLgnfN1GjzgmX9h2iTPTA8FmwwrU61QHJqjJ	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	367	367	36	1	4042	jwky4XwsJtTY25KS4cf1XjRVTUzBn9PHd12m4qSVxxraPXap9dj	2160	3061	3061	1616490180000	orphaned
4155	3NKNjqCs6NaNwnZkTbJprZUN3AWAGjz37vXTtdPAgtxjnGTEprd5	4151	3NKzKmHBj9qPQ4KbH3PSWFasPivTF1sE4Uj1KKKRVnM1zWRsCxLA	1560	1165	36	1	4043	jxhdSi4LQoYAqRNqPr1gxdgiTnWafnYovSYcXXsw7rnM2QtuxK3	2161	3062	3062	1616490360000	canonical
4160	3NLCp9gU1E7kuAjs8n1rijwghkKqcGW9N6yfK9ca1DGwa1XmoweH	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	44	1325	36	1	4048	jxyRaRqw74LqGRLFuc3w2DMPU8wn8DPh6yLLAwvFFMVvmXB4GWC	2163	3064	3064	1616490720000	orphaned
4162	3NKgHGy4JbKfG2HnnUSptCY3VU18jdEckaJ3bzEyhPoVeS5v7w6o	4161	3NKQvpt8BKypJwbuZFvMogiKVDEMu9B4H2nSTmnfgmPrHMh673gE	1477	1350	36	1	4050	jwmnXxoiZghqdXWM6WgoWRLW2MXDNVAE7cu7Afedu3NpWU6NXGE	2165	3066	3066	1616491080000	orphaned
4165	3NKbmF981NyE4rKcdKtiCaLfEzCkYD7Ss1HdVdw7MWcL17cD4V9u	4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	1403	824	36	1	4053	jxgvKcykzCDp7iKXpKtFrJchdQ995YeMqYWJjoUcGDQWvZKjS3T	2166	3067	3067	1616491260000	canonical
4170	3NLBVaE3vzv1ymYsSweG9AoLdfMA96VRgsaLeyum6z8VMced3Arh	4169	3NKoHxJi1xV2GKTXRWnpxhDuzTZKtCAT6BoA1FWaSeB3FgtQMcfT	632	1382	36	1	4058	jxwwf4YGeYPWDDbEF7haMrp4fymFjZLuGNs4Q5JZEWzpvpmC6SQ	2170	3073	3073	1616492340000	canonical
4172	3NL4v5C4KsGp5oTDi2TkE5pf3n7fv6WnQqs1naD8ErANUgu2euUX	4170	3NLBVaE3vzv1ymYsSweG9AoLdfMA96VRgsaLeyum6z8VMced3Arh	1457	1145	36	1	4060	jxwA1Zb4Ft3gXC7GvNrGg3pX5QSMx75r4jAvHtTCBmNcpAbutyP	2171	3074	3074	1616492520000	canonical
4174	3NKVupDg4SUN9Q9AaqLDnusEKPyYMCFaCq1kMqfGZU1bsYFxGgPD	4172	3NL4v5C4KsGp5oTDi2TkE5pf3n7fv6WnQqs1naD8ErANUgu2euUX	1503	1151	36	1	4062	jwV73rXQGhN8aSxdCGTANeBsFLBStjspRNS6B9mo3tjXXhHvzdo	2172	3075	3075	1616492700000	orphaned
4179	3NLuHmQ72A2QS6s9M1fCYRV6r2GUSkfUCPqKhjyqc2fMVzc5SYDE	4178	3NLKZnjw8xdVnUyebCXu2C7N1foGcEggUZwZgmaCUvhn8bGfNHDd	1607	271	36	1	4067	jxMvUtr7mPLEpqCL8fp54iEYLs74VN9GpZxJKKRDKQrQXUCWZgr	2176	3081	3081	1616493780000	canonical
4181	3NLhTzoCr9XHzBUspBN69D8GkDxa7pLvxT2mSgc6km41dBwwNQR5	4179	3NLuHmQ72A2QS6s9M1fCYRV6r2GUSkfUCPqKhjyqc2fMVzc5SYDE	1670	1036	36	1	4069	jxGYTKGCPmgi4begFoVH95KBYYFanVSACEngoV9oJ92pxP21hfE	2177	3082	3082	1616493960000	orphaned
4186	3NK35wBpiLorENw2pbs4ZosSMKyH3DwsJSjKCEsWxENVQixe12Uy	4183	3NLoBpbzJuTgCyBRk4mPaT5ttLEPiRUzZVVk37EkdZJRKPsUhdSp	1553	776	36	1	4073	jwzWtWDnmuxtAYqkmyMQB995hdtT5nqEfe9W7iQ85EZmRsfhmg6	2179	3085	3085	1616494500000	orphaned
4191	3NL5Tj92QEbc917iv1kzE2TXRGC7AzroyYFDoLbgnbENSXdZ32Dq	4190	3NKRrb6Z8UTsecDUhYnJoPGwtXUhG3yiw9aAd4DJmEZzYyNFyzqb	1422	1091	37	1	4078	jxG1aLrFwwZLeKp3KAxk4Cownz74X6RZywGCsPmdzXwZ1sQnHoK	2182	3090	3090	1616495400000	orphaned
4194	3NLRhUs5LNvJFF5PJSkfSzQhWqF58pzyGJnaQ73rZMkwYPuPggHx	4192	3NKNfPuJmMQo1HwJnVSH5wfZwwcqVxnkttvRzpfvzJvfnGdzZrr5	1594	1200	37	1	4081	jxyNn3BLfadPJ9khGQ6QDrxHTepiBKMaGK2xDG6jxu71ezPLMpQ	2183	3093	3093	1616495940000	orphaned
4197	3NLmQGYqxyr2BRw1BTP8rYZp2NZdyyQSYXdkdZJZL8E7QquvwViG	4195	3NK6GCTQVnkYsvwTzsuKYCRtXdFtyPtWxLFAVDNffwEEvjjq3cFf	1594	960	37	1	4084	jxVEATeHJHGsr2iohSJHaBPNxXvFgqa45oS4EwYmDyuLRKkfuhP	2185	3096	3096	1616496480000	canonical
4202	3NLZMjPs6g6JrGS6q3DJVxWuS374p8RSi57PAyPHeRV35yfNffNv	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1534	1071	37	1	4089	jxwiwnrZc1YNz3RtgJ7L9vnxvystkU4pCiS5XDHxcP2wPvqT6Vs	2187	3100	3100	1616497200000	orphaned
8602	3NK9z7CLdi7ptPfHXJaPxUGjxyduUcNkKuTMZ4EREokNtXGV2oZr	8599	3NL7Xm1pMhsRbMAJkSrRWWi5a4Pdjww94KNHQA7VoaKUYsXLE2HN	1623	830	101	1	6301	jwLYqyeGhQs22BrYxKeRu1qiQDNoSKcTsTVhN4x7P7yogpvRjue	4460	6272	6272	1617068160000	orphaned
9821	3NK5QLjv5jkxXhBzo8iMBT7h5nEu2SoV4sLcdFJqj7Tvk5j64aeR	9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	1439	1153	127	6301	6331	jxsB2Uiye7hpwE8RVXnfiaf2Zk3LxZ3J9JKkdKofcXFQiV3JPi9	5090	7156	7156	1617227280000	canonical
4105	3NLLZ6cmyDhudNZwuxCmvdbZqnvkVvxQeXP2JHkSTphweW3Mbb7U	3956	3NKAEkTjfFsN49ncAU1xhMSkDnYdVmAqyiMG2shEKn2UeQB8AjnD	1581	778	33	1	3995	jxnwV9VsabC9C9YPUHm5RMBKVyqRwLFmatKidSeeVQuqtkB7jin	2057	3025	3025	1616483700000	orphaned
4184	3NKMGwPQ11xr8FMXJt13EGF5h9wrkg6Umqdsy6GxdoAHrwd5MrQS	4105	3NLLZ6cmyDhudNZwuxCmvdbZqnvkVvxQeXP2JHkSTphweW3Mbb7U	1581	778	33	1	4071	jxhvRahgYVYiB4gcVuVjhctxX4hrJAjLG8hapoVQwbDbmjnMBKa	2058	3084	3084	1616494320000	orphaned
4107	3NKBCMwgRnEFJvpiHeUcy1RQiiWma3ZH48QVNzD29txFT4Qbbdn2	4103	3NKvEsTz9WscnNaPTxqp6TuK7NyNSKrq89vDBjDz3ecQZnAHcYYR	1403	824	35	1	3997	jxnzPS4jH1J32XHjHaJkuZdnNDNKExq73uyZe9PAnkPKBLjxk4a	2134	3026	3026	1616483880000	canonical
4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	1529	1070	35	1	4000	jw8L4JU7MjykGuxncq1vyGvTSdTo2VWwG11fbpWuTzoWk53QrkL	2137	3029	3029	1616484420000	canonical
4115	3NLGj29tZEjN8miYQ4kLmsKwpmaPW3SyFE6r4X9siV6EpR9zHwLn	4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	1668	1004	35	1	4005	jwsZtpVir9Z96o9YZE7gbGv3irJUeHtaji9SPnTGvTFpvpgmdnn	2138	3030	3030	1616484600000	canonical
4113	3NKjeLbnw5oK3b8LQbSuhmq6jm6cswBxTdjNDupd9nFdF9uxLcvr	4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	1460	681	35	1	4003	jwh2wSeAKQxQeJpGUnu6ExCG411x2DbVL6ZanQGNF7WLD9B5nvc	2138	3030	3030	1616484600000	orphaned
4118	3NLatm6HagSPS7wVA6Xm8fcWUFduVdgXHJWKNU9nxZ4V5j17vDdg	4116	3NKywdTeuqc5xxst1zPnapD6wvye449eU17DbGjvBcvhkpU5wMWc	1607	577	35	1	4008	jwzmJKKD3tvguaGtyiMwtTKq5dWP3Ly3EPBiYNTDErNbS1zinSW	2140	3033	3033	1616485140000	canonical
4120	3NLwmJGNinL5NSmdcMMF8AkoFYcvEi3TN756rBV6iCP7wsT5NYev	4118	3NLatm6HagSPS7wVA6Xm8fcWUFduVdgXHJWKNU9nxZ4V5j17vDdg	1403	823	35	1	4010	jwBocCVrZweNnu2yKrr5pvS92VCoRJg25CJr4gpixw5RC1iCD65	2141	3035	3035	1616485500000	canonical
4127	3NKNq82oBsCZQH949ZyuTELYrLGsq2sSAVHRfXfKBQde1ZSJagyF	4126	3NKtwxqwz2DhDyYneRZ2ikmmrUQXKvBdn542qi4gjutTXC8Ui6ih	1631	794	35	1	4017	jxcwDoWw3KW3MfqDoADqk7MJkQVsyynjTm7dPDwFhKjJCQmNJWr	2146	3041	3041	1616486580000	canonical
4129	3NKHL4BXg3sBXXZNDkQ4aX38Tu9YD39hhU4EtsxofJvkMa8nhpLv	4127	3NKNq82oBsCZQH949ZyuTELYrLGsq2sSAVHRfXfKBQde1ZSJagyF	1553	776	36	1	4019	jwF73pisehWP5mDB5eCTxZ734RyKVCa5PJqjijb7uUZCry29z3G	2147	3042	3042	1616486760000	canonical
4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	4131	3NKzAXtegkC6WMpCMVFpzJCbiop8X3ZjEjYCQvaPf8tbNujpEn2i	1406	1393	36	1	4022	jwgJ1qnq2be6HZ9ekZDHAcuc5jW14pfCmdRHPjHueKZ8xt3UUrf	2150	3046	3046	1616487480000	canonical
4135	3NLbd5p9yEZXqyTvBGrQAYbqLRCyUpRUtgMiFwjEDq2KqPe7xqiN	4132	3NKtYKtPMWW4ggG72e9xqZtSWjhrEAD8bjiwSw93UvysBCxBmbFd	369	1312	36	1	4025	jx5tseKKsSSbkazheNU5SquzwDXdjSck87AA3VCQJurLQAwQMTv	2151	3047	3047	1616487660000	orphaned
4140	3NLQELKJGm4dzFXWS8XU3yKQ8KjC89ch649PaV6QC1pdUJifLNyp	4139	3NLKFg5o7fRyd6EYhrF84QNyxT3tWT5CRhbdcx8rqFopthBZQR6j	1406	1393	36	1	4030	jwusyShMD1pjNFabWoHRqMPdiQcsu3fCvwTDjXRB4cBDYSPtADL	2154	3053	3053	1616488740000	orphaned
4142	3NK3dBQ7nzLDAdVJ4mCYi6k1uwPY5R2q6Py7wzQ8fzhVrmaAZ5Ef	4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	1407	1395	36	1	4032	jwu5WFBzCNz6ELcPXQbZBvpDp9NqSQ8Jy7GhL59QEo1RV2xn5M2	2155	3054	3054	1616488920000	canonical
4144	3NL3USUNVidu8ZjWUxJim3Qg7yQTobNX616vc9FkawQf9wX1699B	4141	3NLRTTMLDhPQ7UCPMg31P8LZPpFyi1ZHHoPQbZ4EYQ3Zyyq4hkyS	1553	776	36	1	4034	jwnai7JMHeQCc3jEkJUjuoAFAJZyrwa6WKyFw2jJNQJSPpCkPM6	2155	3054	3054	1616488920000	orphaned
4150	3NKEURqBJtY7GicAU8cY8qXG8zMLVpCxZAiv1m9DDHQDxGXHTmrd	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	1407	1395	36	1	4040	jwFnSV1nCAsTq9mYcFzNAzYdKWaFiyBEmcJ3m3xHefY7XZcbdrp	2160	3061	3061	1616490180000	orphaned
4159	3NL4RHAasmpDh2tkGsNVXHzU92G6ZbYYimFnQFPweFEkB1q5YAUf	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	1600	1372	36	1	4047	jxPStkSPh7EoVSH4kn9cH6NgYmcsUzYFm4Wtoh7BrdajjfW3vax	2163	3064	3064	1616490720000	orphaned
4161	3NKQvpt8BKypJwbuZFvMogiKVDEMu9B4H2nSTmnfgmPrHMh673gE	4158	3NKNxSLQrCayMHnXLdAcaTxjdpxMScA2fK4Z1pCoybCXRn7cMyX7	1403	824	36	1	4049	jxxRxLSXmru96VWp93SmcEUUVVtoHagc1dTVWPrAMHch6xr1jUC	2164	3065	3065	1616490900000	canonical
4171	3NKD6KVGGzCxy7jCi5Nid1JPiupBnwXY6XBkEZkN6Wz9q7tYNufE	4170	3NLBVaE3vzv1ymYsSweG9AoLdfMA96VRgsaLeyum6z8VMced3Arh	1407	1395	36	1	4059	jwq6mgSLayfzKRscRFjCFnTwurtJfC5mZa8L6t9duGyESSkU1a1	2171	3074	3074	1616492520000	orphaned
4177	3NLwGH4yfaKU1FnmXuPWWpSKdobTdWpHAxyuiwKsxGKnmfsoWvqZ	4175	3NLY78mx5L6oJsJtyxp7G4UKG6MtZjqYqGx4STV5Jz5MYJ2j6k4e	1457	1145	36	1	4065	jwKV3iGhRVbL9iPxfdhDgXo22rqsjVNt99rqrnoWmkAnkThoGhq	2174	3079	3079	1616493420000	orphaned
4187	3NKmRuPhTD3wJ7TVibDFWonhw9y7WJGH67mJnZAw6hjNLEQnYTrf	4185	3NKFHAQYa4CqyKP3ZYYU4Fip2mHzUBB5He1zWgppFB8wAjBZ6S3t	1403	824	36	1	4074	jwzajDhkckaiL4mtQoeWj1qdm3xPJ5dDgXnYxDqKo3BYzPAwfGt	2180	3087	3087	1616494860000	orphaned
4189	3NLgC6GiC3sagmM9zwY7E8W82Wnc2Na5XMEgAKd2M2LVVPMEtVL3	4188	3NKAXUYSh2NNt7KMqLzWXHh44NZyMUKAikXHSV7SAPJWUTxZdnxt	1656	1343	37	1	4076	jw9X48PQg1yxDfM4h9UUoT5RRCS7M4JUmdHJuw8Jb83FjZZC4K4	2181	3088	3088	1616495040000	orphaned
4195	3NK6GCTQVnkYsvwTzsuKYCRtXdFtyPtWxLFAVDNffwEEvjjq3cFf	4193	3NKnWE4CesiNmVpLzT3LmA4SXQPiUCTMuBYwGtMccQprgWjub39G	1623	839	37	1	4082	jxnqdWZyf53ZbwVdX297C5Qr6ha3xDEzgKwJ9ozNM4rvyatGB3r	2184	3094	3094	1616496120000	canonical
4198	3NKw3rEPUAYNgqzJ4ymChwcU8vmtafGy8TEg861meASBMZZMpQNv	4197	3NLmQGYqxyr2BRw1BTP8rYZp2NZdyyQSYXdkdZJZL8E7QquvwViG	1407	1395	37	1	4085	jwDBipZTfWQCv1wAKabMSYCQXQNBCS2RasoGncMfUCTEbsQpY2b	2186	3099	3099	1616497020000	orphaned
4203	3NKm77cDdQuxXonZFokgwFXinkoBvpjfvatybPavAxek2VeADkuA	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1403	824	37	1	4090	jwm3FAZfTpJeCAfRaydQqUHyP7zp7cGraYDgSCmSPehEBQ3Bs4i	2187	3100	3100	1616497200000	canonical
4200	3NKYeeEra6YYUMP34eSjai8dgWSpSxWRhNZpvFNgrwHY83dsbHQT	4199	3NKH2NvtY3qkHey4JhMR3wwzLA6nXWzTdU5x4KdHEvXqMnVrpBbb	1407	1395	37	1	4087	jxVnDw4ApW87BuKXCJFwr25cdSoAkFstpN3Tzpp9k7iYu1wxPjw	2187	3100	3100	1616497200000	orphaned
4205	3NKxtqfwyvcVwtEJVM1MhGastE2YTPmZk6mZg1encd5cZ4pxxS4m	4203	3NKm77cDdQuxXonZFokgwFXinkoBvpjfvatybPavAxek2VeADkuA	448	1059	37	1	4092	jwwFYNfKb6md6S8LvA38vYtb6eZ1Pkhkty7J2oA1TyA6En1vkZb	2188	3104	3104	1616497920000	orphaned
4210	3NLRmbX6ZUdrX6bkWY54Q9j499GBYJFLRARUk5s5CVy1Mh3Lygcf	4209	3NK8aPQ7oVxv6vJ1pnmU6MWBMKqPcCEDRmCcUfMjKJJk8ncU5vXb	1431	98	37	1	4097	jx8CjqFM5br8p3i77dJZo2heyfjVkSqH4WQ45z9qx4JqeiYbPhC	2191	3107	3107	1616498460000	orphaned
8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	8609	3NKqWz3CcXWzji6djY5cPku3yVvUtyZLRGZGckoRZ9fPm1NXQsyW	1407	1395	102	1	6301	jwB8S2zgetwdhMaPQwhLAZpgwJNizWoGpkFqKAitpYHCCMFdoki	4464	6286	6286	1617070680000	canonical
4112	3NKw6wfhENLmLiyqK1DtRTtCKEJ8oEoBgWCUrwuwXCzPm5Vt88fS	4109	3NLChFyPsCwExqE9YMtEQ6FbF62SvE1PWDLRt94n3onjCVuv4p1r	55	178	35	1	4002	jwAM4KMivRzKrhhJaNmjMpEa7JjTQJbmP3cNYdZoNNfYVvFZoAr	2137	3029	3029	1616484420000	orphaned
4114	3NKFGKTmX6J5vgXXKx7pRGyA5UubtwDAveW43bnedzZpd6C639Di	4110	3NKtcdPk2yy2ue45trYyNQeTz3bBgSwkr8QcgWUPaPe3T1MDfqJe	1657	1344	35	1	4004	jx6Le7BjWob4zJwmBf8nW7ieSL1aRYWSjQSVkVXwm14QKUETHq3	2138	3030	3030	1616484600000	orphaned
4128	3NKoasvybE9sjuLbeQfCcGBBRG7poT8WxAk6YoV2Yjsh2Z1aTomD	4127	3NKNq82oBsCZQH949ZyuTELYrLGsq2sSAVHRfXfKBQde1ZSJagyF	1670	1282	36	1	4018	jxpCzdrRt2H7Do9upvEww6ss1ucondKPSaznpczpVqvpy27Kgp1	2147	3042	3042	1616486760000	orphaned
4131	3NKzAXtegkC6WMpCMVFpzJCbiop8X3ZjEjYCQvaPf8tbNujpEn2i	4130	3NK8cYR43LexRiKDJp9GCMUbbYKfA2UWNxatzST2kt4ztNQM9DSi	1403	824	36	1	4021	jxHWoKJHxZ98K3WgDsGZYxiVgrDHR6c8yfLhttF4wgS5N8qR9r2	2149	3045	3045	1616487300000	canonical
4133	3NLZTyu59ScP2q3cKT8ukiHR3XW69BbsTWtNprLxw6hs3RBf2nav	4131	3NKzAXtegkC6WMpCMVFpzJCbiop8X3ZjEjYCQvaPf8tbNujpEn2i	1402	890	36	1	4023	jx5FnJKtdi74LwwAyAonoKR4T1A6PDTABq5N18aJf8VQ7QeHxYE	2150	3046	3046	1616487480000	orphaned
4139	3NLKFg5o7fRyd6EYhrF84QNyxT3tWT5CRhbdcx8rqFopthBZQR6j	4137	3NL3Evd5fuJGN8YXNibdUeoMp6v1PKzM77LH9tH42cCjTbHES3TC	1671	1239	36	1	4029	jxeksai4FaqFQnPauv3S1HJ6iQjxGRj2X7xSPRwUGhkqKxuMFvS	2153	3051	3051	1616488380000	canonical
4147	3NLvKLVp3XqV15R8CsoHCgevvLJJNcqWALxpVhpUntZBn7T7Y2yJ	4146	3NKN2H6YZaSBag45K4oAJuDM9wwcewCkf83TmKTDwUwxykzHr24n	1402	882	36	1	4037	jxfDi4fgBsAq4hiyfjg3ebDhCoKuqS2dBp7AkzWsT7db8SjoWzQ	2158	3059	3059	1616489820000	canonical
4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	4155	3NKNjqCs6NaNwnZkTbJprZUN3AWAGjz37vXTtdPAgtxjnGTEprd5	1522	1322	36	1	4044	jwSJG6KaHacAQpatJgCsXtbuFCVpEde5Epygpm6pfXDarhPv6CQ	2162	3063	3063	1616490540000	canonical
4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	4161	3NKQvpt8BKypJwbuZFvMogiKVDEMu9B4H2nSTmnfgmPrHMh673gE	1590	1300	36	1	4051	jxLavuPeJ9h8wCtWQ2a5kGtmEbyqTBdzk1nDb8zk9WB9bnyBVpd	2165	3066	3066	1616491080000	canonical
4166	3NLoen16FZoSKTPJEcZRtZWkUatGBxUQqymh9LMNAnzYKQUaKV7k	4163	3NKybje3T9yq6dkgvz6bcuehUCCLVAdkJeCb65v5Gj6MXmfQpPCG	1406	1393	36	1	4054	jx6UcSGZ8SV5tY2kVwfRiLGaKzrN8VeGjFvNgkgae3Kq22Hq75o	2166	3067	3067	1616491260000	orphaned
4167	3NKHm5rhTyKEnCtv8fhjzzxK8cycVnhKiPitBnJXHW2bCrzHKsa4	4165	3NKbmF981NyE4rKcdKtiCaLfEzCkYD7Ss1HdVdw7MWcL17cD4V9u	1407	1395	36	1	4055	jxpGW6j6WZdBT1KMd9w5nFHEMHkUq3oNAvCw5KiuNxCTfZwvfVx	2167	3068	3068	1616491440000	canonical
4168	3NKjK1wZso1nCVdQHWQ4a3cMNHtt48PB5pWrBuAXXmnf15WaepCm	4167	3NKHm5rhTyKEnCtv8fhjzzxK8cycVnhKiPitBnJXHW2bCrzHKsa4	1509	1320	36	1	4056	jwLzpMKVfyrumQvmHzExKPsszTPYXq5gqLNpz27FVVnRv4SgZ8i	2168	3071	3071	1616491980000	canonical
4173	3NKHpRUyNZZP3u44v1oA6BeaYFgneBVHyrNYqEQt4oxhPpSLmeeK	4172	3NL4v5C4KsGp5oTDi2TkE5pf3n7fv6WnQqs1naD8ErANUgu2euUX	1403	824	36	1	4061	jwBjyPtxLFU1eU9jEn9afbv6EaZVj6WKTjjwFidAkmrpZYo84vV	2172	3075	3075	1616492700000	canonical
4175	3NLY78mx5L6oJsJtyxp7G4UKG6MtZjqYqGx4STV5Jz5MYJ2j6k4e	4173	3NKHpRUyNZZP3u44v1oA6BeaYFgneBVHyrNYqEQt4oxhPpSLmeeK	1668	1370	36	1	4063	jxqSSYP3yjGEf9w72cZV18HKxoz7GSurJqC78qK4VgjRebEKHVG	2173	3076	3076	1616492880000	canonical
4176	3NLQoRpbh6gpwBhW642CyBhXbbQsdAW6Ud7zRhfHK96NY5qP5hws	4175	3NLY78mx5L6oJsJtyxp7G4UKG6MtZjqYqGx4STV5Jz5MYJ2j6k4e	1406	1393	36	1	4064	jwD5jrFr7vvEmo2ZCfmkSwp9rW8EfvSHPsTi8f9hLCS8VxaGBgq	2174	3079	3079	1616493420000	canonical
4178	3NLKZnjw8xdVnUyebCXu2C7N1foGcEggUZwZgmaCUvhn8bGfNHDd	4176	3NLQoRpbh6gpwBhW642CyBhXbbQsdAW6Ud7zRhfHK96NY5qP5hws	369	1186	36	1	4066	jxQVRgwztZPgAHedYjVDofuYqwT5BoENRQHWUfj2RqgaT3xa4a3	2175	3080	3080	1616493600000	canonical
4183	3NLoBpbzJuTgCyBRk4mPaT5ttLEPiRUzZVVk37EkdZJRKPsUhdSp	4182	3NKqGj3U7Tu3gKLThbDRYeUZ8cS4kdqEqToUC9xx5xhoKCMU4wNk	1617	1042	36	1	4070	jww8PVcKDhBbWyP9bsGN5sMSGYUv6ZJuqBsT5w3jhGP9KDUwD6T	2178	3083	3083	1616494140000	canonical
4188	3NKAXUYSh2NNt7KMqLzWXHh44NZyMUKAikXHSV7SAPJWUTxZdnxt	4185	3NKFHAQYa4CqyKP3ZYYU4Fip2mHzUBB5He1zWgppFB8wAjBZ6S3t	1406	1393	36	1	4075	jxY3xSevWB7KxCR38DpSbU2g5CSXJpgXs28Zmcw9SsAJjhLHT1c	2180	3087	3087	1616494860000	canonical
4190	3NKRrb6Z8UTsecDUhYnJoPGwtXUhG3yiw9aAd4DJmEZzYyNFyzqb	4188	3NKAXUYSh2NNt7KMqLzWXHh44NZyMUKAikXHSV7SAPJWUTxZdnxt	632	1382	37	1	4077	jx5taHMEFvCrrtPinxaqdSJYnXJ6Q4kwnjq5FTGcaQ3S3daGC88	2181	3088	3088	1616495040000	canonical
4196	3NKkKv9ZS9HAmx4TcoczBGu86ux7aYnVxtB2xKgNrzXLgT7Df9R9	4195	3NK6GCTQVnkYsvwTzsuKYCRtXdFtyPtWxLFAVDNffwEEvjjq3cFf	1546	1339	37	1	4083	jxrxLtCcvCHW5dj8AxXUUzRL1HUnGapEajUcEg46gezqZZQxZhn	2185	3096	3096	1616496480000	orphaned
4204	3NKtpuKX8VdD2fN2R7kHfBE5Bs9v3aSTEs8ujy5fs1SWbn1qXX5T	4203	3NKm77cDdQuxXonZFokgwFXinkoBvpjfvatybPavAxek2VeADkuA	1403	824	37	1	4091	jwnWVjDMtZLsHgLpFiZmSEJdSQHJTbxdMoDaoxPa13meuidnFrK	2188	3104	3104	1616497920000	canonical
4206	3NK8MFwRDKzy8Erg5Qt2ysuPmUBWetECFBHkmC9zDocR8xhnMzDR	4200	3NKYeeEra6YYUMP34eSjai8dgWSpSxWRhNZpvFNgrwHY83dsbHQT	448	1059	37	1	4093	jy2G2mZdBdrMtpdYfDqCtH81xtShj3wazFsbUEd6FvQvorCGmkd	2188	3104	3104	1616497920000	orphaned
4207	3NL596VruvUfMuoj5GMnYnhpkcBwX1mniujqgcs6SCwrUeah1mNW	4204	3NKtpuKX8VdD2fN2R7kHfBE5Bs9v3aSTEs8ujy5fs1SWbn1qXX5T	1460	523	37	1	4094	jx3jyxShYfX8UCchJUTjN6uyKa2gUSjvFUVW4XbtbfJL7ZSGW6t	2189	3105	3105	1616498100000	canonical
4209	3NK8aPQ7oVxv6vJ1pnmU6MWBMKqPcCEDRmCcUfMjKJJk8ncU5vXb	4207	3NL596VruvUfMuoj5GMnYnhpkcBwX1mniujqgcs6SCwrUeah1mNW	1610	1068	37	1	4096	jxqTzNnuunvNvsUCmqpaakJB1Us4ecViaAiTzqhdtdMg1rZzRvG	2190	3106	3106	1616498280000	canonical
4211	3NKLC5oR3XC4Tr5mFuRt1HYtKTJPSniVyJJPqHFb8DR8eucTtev3	4208	3NKD4ajEVo2NxEDjEcCZ6pxMAGbWW3YxcNmSPJkXU3gFHsR4Gag4	1549	1116	37	1	4098	jwyKgArsJejkAoFv6av5RizhoLxt9jtq6XsSuzVGa7ohxbptm2P	2191	3107	3107	1616498460000	orphaned
4213	3NKT6Q9o5QoMLimpwHpFeiwTTZS5oSfd5LbBWUm8EnqeDTyByHPL	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1602	1369	37	1	4100	jxG1WWj4Y2H4MFbyN7o2J7GBvuWj8jXW9btBFWscYu95pZbGaWV	2192	3108	3108	1616498640000	orphaned
4224	3NK7VtmTK6Y1Wcfqe8hAdLHZpvankY3H9Wf928YbWqsJ7YBBKmyr	4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	44	1325	37	1	4110	jwCYiVarXtABkfUXb7xYBPTK2nTQTCYFBUjULm1RfsG654j1Cxo	2195	3112	3112	1616499360000	orphaned
4230	3NLuvEuNZjUGAD9N94ZA1A85HHtf1vGF5Y1jNxgjVPhT5tMUWFTi	4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	1451	1166	37	1	4116	jwKPYj9heeGpqe9JrPxPDqGgmCmK64gVNQAnVmyNxgDqyv8csW8	2197	3118	3118	1616500440000	orphaned
4240	3NK6HA43Vo1BoGJEXD2czrvT3i3zttpstztZyoiMbDBRDYU8WaNF	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1623	839	37	1	4126	jwSrjcww7U8Lr5hq57TDrPDS4ucbsrjaceWWePaW2kA67wmzMsr	2201	3127	3127	1616502060000	orphaned
8614	3NKtQ5egZt7e8yaoPZBprstXnUcH8yutJ14yjZMBAqJRSc48sYtG	8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	1403	824	102	1	6301	jxV8Rf2QyCCNAJhu1UkTL5aZVLsN3qTkZbfYFG85qiy9uUhA78U	4465	6288	6288	1617071040000	orphaned
4245	3NKJFoPzgafYZFhRB7n41TS1NibjVoKhLNB2TwD9CpmJZHnayMZF	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	1599	1041	36	1	4131	jwjTifip6Ww2MUfzoDvWp7TEW8bWngEycCadiyNj6oqPXnnmHPu	2163	3130	3130	1616502600000	orphaned
4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	4209	3NK8aPQ7oVxv6vJ1pnmU6MWBMKqPcCEDRmCcUfMjKJJk8ncU5vXb	606	1295	37	1	4099	jwfKjh3NCWkk5pu5CoGTcbJZaWo8TG4AEHfQcDVhnH5jkYcapkG	2191	3107	3107	1616498460000	canonical
4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	80	1147	37	1	4101	jxqejZ7mUb5JkRUXeZ5TCjWKj46cZuy18XqsGuGTnjBosAQbqrL	2192	3108	3108	1616498640000	canonical
4216	3NKLdRJLqXqx5fs5rfwfoH7VzQ41zFvmEqCV3bT5jVQmsqkkP4Jd	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1553	776	37	1	4103	jwGQAeo5kKCN9LG9T8nCJqzD6pLHHo322qgWeEJHPD81o6zMNRY	2192	3108	3108	1616498640000	orphaned
4220	3NL9aUDvoHwu7LyBAiKV9js5Si3TCByQTYi4b7vzn3JFsBFMHv4D	4214	3NKLb2juS8qg6rtrkU4etDNX5CKee17CWv8N1aZDh6JJfZ5Y3ZgC	44	44	37	1	4106	jwcTLzewB67u7s32Zdj3XGoFKpNJ6z1ZiVXAjjv3s4nbUqjQKZp	2193	3109	3109	1616498820000	orphaned
4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	4221	3NLp4LT7V55WZGsAS6MNKjRdyKrQeKvBHW4LQyVZJumovZk3YQFw	1483	1276	37	1	4108	jwss7R9fgj2Mj9kyZDDiwMqoaBdgHGvxrR4uqqQKTysjjPkSbt8	2194	3110	3110	1616499000000	canonical
4228	3NKDoJQBtmL14nH4kCksTkjwauV5HYA165QvBkfgyiP3mpnVPmr2	4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	1426	1118	37	1	4114	jxnTqptAqB7K2NEiT35PpYarmuR6XbgsEb1C1ABvAuVbCahXTJp	2197	3118	3118	1616500440000	orphaned
4231	3NKZSmNv3cU8rgQrcW9tkKNNb1b4w4n4HcmD63skKvnPWmqpEpC8	4229	3NLcPFziA58Gkm2CxS3YY7TjreKrk75bQ4EiXy9wuEr14SLQBodC	1407	1395	37	1	4117	jxfV7QKhd7jM8o53cXcW1pNNUuwE47oDehchuziK2yG9cZFgq1V	2198	3121	3121	1616500980000	canonical
4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	4231	3NKZSmNv3cU8rgQrcW9tkKNNb1b4w4n4HcmD63skKvnPWmqpEpC8	1460	1324	37	1	4118	jxa5PMg45WrDvbtroaqtYLxd19PdW2SEwERbZAV3VQS2MVHdtAJ	2199	3125	3125	1616501700000	canonical
4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	1477	1104	37	1	4122	jxQkqtv8veko1x5QrNVDA4dTQ42XQBuaaT9z4evMWYHBUCFn9Zo	2200	3126	3126	1616501880000	canonical
4234	3NL2zT4LFJqUj3h4ZkHEDFRWCkktAPFz3hJmqPsw88sEbisf7KWP	4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	1587	991	37	1	4120	jwFntnML8N2J6m7mW5hht9LKYZ1zKhPwvWw77gpnCjHh4ygNTFA	2200	3126	3126	1616501880000	orphaned
4243	3NKmHyfgqnwYHCZzeaWHzEQjGcmHKGhvBU4nRvBGvnmaPVPFnydc	4242	3NKE7BSVSNdeF5SH39y1KdWgmDVoj3wBAY1ifmudW9EHFYiS7LwU	1444	1255	37	1	4129	jxBiQRp7vRYyFJpaau3fqGazrS8G9SPyPxuCGuM1x7gLCPcZak4	2203	3129	3129	1616502420000	orphaned
4250	3NLRqEra8kx3yYbBP7s3i79tejwNr8ubYpBEHUwLndfMsjZxydGY	4246	3NLCmDgr9Eewx3kLbqv1QQJRW2KgzBJJrir8EoR2bDFyxLKekVSR	1406	1393	37	1	4136	jxiXroB3WKq7rPPDC5J4MNbKSjxxRzbzxDuhvRFfuaUZYvffb1S	2205	3134	3134	1616503320000	canonical
4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	1633	1264	37	1	4144	jw8kwBMnohpoz9Mqyc2mtFHwBddw5oPv6hJUbycWxJJ7gkgqHNL	2209	3141	3141	1616504580000	canonical
4256	3NKXzjtjgyxziVSGC2LpNtFWRwTz4fcN43iH3y9t2AjZzWZJqm1D	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	1560	331	37	1	4142	jy1ATK6vfoHMnp8Y2QeU8g1qgX9apLzFhSap8aKSxQJsgCV1bw9	2209	3141	3141	1616504580000	orphaned
4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	4271	3NKzGmTn7UqVFdqStfayGD32E4CA38Roqur3z7QfwDAvSBdYhx3s	1536	947	38	1	4157	jxvQJRVaL7ZidRXvXZ4NGF5dLgqnfn9uJmzzgw4QQryBnD4H6w9	2216	3149	3149	1616506020000	canonical
4279	3NKAA6brJ99zPHTZwa4FLkCLQBGJCy635UTZW2ZfMDQ5JfEU18W9	4274	3NKwgmfMHmA7PFasZMKE7yco646EtJzdRMhw9wKSCjm8j4g2Ww5n	1447	1345	38	1	4163	jxmHrsCR4dw8KWbqJUxPXEfFaWpEauYb5vRRiFBJo2miiQT2r7q	2218	3152	3152	1616506560000	orphaned
4281	3NKqBC9NvEGyBXQUGAURQ8qGZoeEey7aD6KKYJkbQQ9zhyV2JbmJ	4280	3NKcQKJDnue7CsQddWyS4e1KedyTzk8nTcvtRUrd68Uy5N8zgeMs	1407	1395	38	1	4165	jxPiBRzszJf5Q4q2bzYR5E4gSZVs1v5poHe7ou6biVH8LwdyFJb	2220	3154	3154	1616506920000	canonical
4284	3NL6oEumNBfeUTQHo5y749GUcRsRh4NsPt7rPv7zYz2vvP8fnQqx	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1668	1124	38	1	4168	jwR6NhhucJbatuXMei22t9UookASACJSWa3qGpBGt5hkRdguq1T	2222	3158	3158	1616507640000	canonical
4286	3NLZUeyEkcq4JLArATZpmytzD6oF8t2vK4gzZX7dTUzoGD3ywZQM	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1419	814	38	1	4170	jxg1AbqDNgq1jikGVsBvSrXZguvbJEndF56Ggorz76ioDNhkjg7	2222	3158	3158	1616507640000	orphaned
4291	3NKqpZQzVRPGyTpyieDi8vad722DD2X8xB3bNhf5U8jeMfDH9Jdj	4290	3NKf4MMtA1LAsFjtd8THhKgsBtmvTJtiahP1UrXDpxErG4j4Kknt	448	1305	38	1	4174	jxbba3eTBqcHKsqTTPMRtgvMvUPnjCVMJ6KsHRgqwqZsVWHNrNN	2225	3161	3161	1616508180000	canonical
4296	3NK4YhRPZ1S4e7D4nchvkQt8Cb9z415CMTZi8owbFaUmQA8VE2R6	4294	3NLyV6mQQCDyzN4Fct53bT5L8MZZ6KcaPUqxjp4RwXoQpJiLgcbC	1407	1395	38	1	4179	jwJ7tQtoBMMMKXJjN58vSbmd6E2JmL7NrG7Fph1c4DcEg3E7aj8	2229	3165	3165	1616508900000	orphaned
4303	3NLprJU7b7VxMddtvNcLRLhoRtYBWWj3VMX776DdpAqHhw7PgWjD	4299	3NKgiXTBLBRagDvHUuTJsTDZ7i3YrJ1MmKWNa6eWroyERpVELkAA	1651	462	38	1	4186	jy1FhavL12r1PExxWc3EGdboBkDhLZ2GXcWy343MCvogw6yegXt	2231	3167	3167	1616509260000	orphaned
4305	3NKor3E3cDFgbqPmnh5NNkd1uzzG4nqdbwCucPwWNXLikhyUw9bX	4304	3NLJ1Up8MvzGK1Uzbp3FDobWroqD8UxEyECWTvwMJqDTk5WRe9Nw	1406	1393	38	1	4187	jxHCicLgrCAbZJq5QiakRx3ivwK2W36misPSU4wFwPpCj8T1Vvs	2232	3168	3168	1616509440000	canonical
4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	1577	1327	38	1	4192	jwnxZfJUR3wpEtr3nk2kY5qXbNbb6XccZuQeqEMGijaEh2gJVYL	2235	3171	3171	1616509980000	canonical
4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	4312	3NLx7pZPXeSSyj7Pe9L3T5yhHuJyb9dkhUKVaZkVKhYMrSPTCU2t	1407	1395	38	1	4196	jwz9iDTZhkY6kH9EVvLv6mywKnLFT5hfBvyeUN2K1v39u2iXFYU	2237	3176	3176	1616510880000	canonical
4322	3NK6AfdGtroZ72fL5eohywSbSF6mS6M4bpJrLswdb43xtCExd7dU	4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	1631	794	38	1	4203	jw7RBUqt5pZW2M77xT6tyVourXGq8SaK37QwasCAYUWya8nELav	2239	3178	3178	1616511240000	canonical
4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	4325	3NLiYg1DxDw7Cau1dfxzX9n3kyURXmVWqs2tvLR2yjdNaVqtHjZh	633	1384	38	1	4208	jwAep2fXs9Ugonz1M4FjC7UeBiAV9Nct24XGarppNGDzDQcn5wX	2242	3183	3183	1616512140000	canonical
4330	3NLtKFv7XQR7zDhbgvxWjntU2nYXBePLSTs62dcL8u4iUk3ntEab	4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	1602	1003	38	1	4211	jxs4X4EMB7W9D3er8Uoaw6Tt9BswithPCP9EKF5P3D8KZs15dad	2243	3184	3184	1616512320000	orphaned
8657	3NLr95ETtRoLPMcxWJSSFW1ao83RCRjU4HrrDwo56qtqduwdLEEp	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	1633	1024	102	1	6301	jwLcRGzpyFyvr3VsDkvyyFFoa6iysdcne9xM5Bgpneb3XP5VsMb	4484	6319	6319	1617076620000	orphaned
4306	3NKAwu5nYQAFBwMBSbZkHW23Mj1xAUSnqGv9RHU575DbBHe1qe2F	3838	3NKXgb4LdTRoNgaMfSCfMqkcc7JfRDveozv7brcswVzya6ekjoB1	171	1128	31	1	4188	jwtrRUZCzfNtYj1LL2V4CbSu6w3iTQ81qUWUoW3vWSGtFancc1n	1996	3168	3168	1616509440000	orphaned
4225	3NLK5pHKNzgU3RxmVBAfPDXaKnX1d81LTPVdHUMPeN9thiyYosEf	4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	1448	1311	37	1	4111	jwmQvxVz8vMU7TjK7D9ivPBKqkGhL2m9asCT5o5zPn41A2jwQv2	2195	3112	3112	1616499360000	canonical
4223	3NK8f6upcNpTaKrLAMK6WPfaZP46bnYy2CsywtQKwyTExsFmYp9m	4222	3NLjkpjjSuKS4t7FG5jwP1LkR5KWgZU6RoREALQopT3zZrKeRy3c	1619	1149	37	1	4109	jxyVW6FGoPZa7yp4icCJg9HjpfK7FRyrY5jkNZrwSrpBV1hd1Bh	2195	3112	3112	1616499360000	orphaned
4229	3NLcPFziA58Gkm2CxS3YY7TjreKrk75bQ4EiXy9wuEr14SLQBodC	4227	3NKvA8KxGuzu21v8jW9mJw4myRWsZzrroZjAn5Jt2QKbn7YnZZUu	1571	1335	37	1	4115	jwZtf7YQRsCEiB2yLxEFh36PGV6LFYeXdhkVnjHXtFc3B3YurL4	2197	3118	3118	1616500440000	canonical
4237	3NKjarbFYSrkxoS3UBfvQZF9rWJiSFVaq3cD3xQq61RpLAmMh38b	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1602	1243	37	1	4123	jwyHJ7CBW4GGh5bbRUDTZEQbXD2U6qw97JCuoiPZTFuEirroqQn	2201	3127	3127	1616502060000	canonical
4239	3NKYkksdiQVJRr1nwyVG1G9SsQU8W18FgFUostv4UPc74nTemP93	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1573	952	37	1	4125	jwZPjXxzcS7CWVkhriFTCDgvATjWoKfB167Z5Q63hSDqbh6trka	2201	3127	3127	1616502060000	orphaned
4242	3NKE7BSVSNdeF5SH39y1KdWgmDVoj3wBAY1ifmudW9EHFYiS7LwU	4237	3NKjarbFYSrkxoS3UBfvQZF9rWJiSFVaq3cD3xQq61RpLAmMh38b	1542	1304	37	1	4128	jxaRmzJesPhqC7bXdt2FZt77tpsxH45gmztzb7u4N8eqbsqJkF1	2202	3128	3128	1616502240000	canonical
4246	3NLCmDgr9Eewx3kLbqv1QQJRW2KgzBJJrir8EoR2bDFyxLKekVSR	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1444	1381	37	1	4132	jwnjFrnWxXAu7hdGHyqdjo4AvD8VRDP2dm4fVCVRtyyYVNMQR4d	2204	3132	3132	1616502960000	canonical
4248	3NKcMVmE6vpRUVrgGRCXSUfDDgC5XHG2zttLkKWdBvbeV4R3Px9Y	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1529	1070	37	1	4134	jwm1Xj9qu9U1J4prWsyh7kpPEHx4sPsLhCXBm1kkfcxX7S93Ccg	2204	3132	3132	1616502960000	orphaned
4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	4250	3NLRqEra8kx3yYbBP7s3i79tejwNr8ubYpBEHUwLndfMsjZxydGY	1573	952	37	1	4137	jwx2tgPjWj4dQjNdC2Ftkgm9DtgRS5DbxfgGVnnJu7PkvqJvusx	2206	3135	3135	1616503500000	canonical
4257	3NL2mp7ftpiMHzfHutXSEjxtaBBR8mfJ5h3pHBQvgfem2nJuhFgV	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	58	1155	37	1	4143	jwwLhR4Esx8TGq8h8PVCvNi1748N35zvvnTyrNBiLEdwZD6UsLB	2209	3141	3141	1616504580000	orphaned
4259	3NKBkrdhQ1FVjTmuHQCuAtt6Fs7VSk6FTeB61oqpBqykjn1M7hZU	4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	298	942	37	1	4145	jxU5VLvGdSb2dNnBcU7rrfZ4rsMDwYhDBHBYwqX8Xhux18V5ZJq	2209	3141	3141	1616504580000	orphaned
4263	3NKvCt8BVrYjJJQ3mGnpXXyrqZj87UC9HMQpkBjfz3SuDPvW75Wy	4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	1559	1353	37	1	4148	jwkNpmzpg5nihxChE7CL1DMShAUHUpSgPTRT5vuTgwsMjY5EJ6y	2210	3143	3143	1616504940000	orphaned
4261	3NKbjcu3TfyJebDgzNebQCqjZrCRWVUBW6y7H74Z5dHA2Erhw4P7	4260	3NLfddXXATULemUcPCBW6mdQrw6DkMS45NDiew9d4bV9Xb7vmZWW	1483	1276	38	1	4147	jx5CJus2akxcoPaRdAAHUhC9FKjxv7WhVPXr117GpyEgMtf7zbG	2211	3143	3143	1616504940000	canonical
4265	3NL4v9VBdMz2w38H41v1Az2EbLVkYtexreaoHkXZvp59bx1xP93y	4262	3NKi6VNp6TxpSZ3KA41hjT7LdJXbhUpnt4DADRPdLVRSBvTgdSpp	152	1330	38	1	4150	jxg5XrSvZwRMk3qUy9TLYNn5sH6D5PVfXhvQwpDYLKkcMPN6vDg	2211	3144	3144	1616505120000	orphaned
4267	3NL5hhLGAU3HNeuerA5uQLSvzahSrpWU7MGovx5tkVhx8ZdXpYLA	4261	3NKbjcu3TfyJebDgzNebQCqjZrCRWVUBW6y7H74Z5dHA2Erhw4P7	152	1330	38	1	4152	jwG4aaLD6Ln69hM8MpCaT5BQEsWPn8vqssUw5KWmdEGGiho3HHw	2212	3144	3144	1616505120000	orphaned
4270	3NLZuPfSertBQc7XunytzZuu3WcGE5dGCbecg8idjLgvaY2z9adT	4268	3NKAVUqkszFQa75zt5BPM5Kdyq79kw1tPnpLnoHg1wBKSD3hR2dc	1460	474	38	1	4155	jwboipB3h1G3jpL3H2ThQeSdaiMzxT2V7QFCHbpvrmM4PKQEBan	2214	3147	3147	1616505660000	canonical
4277	3NL93qJ4cwSb9HYpgsb85mvEQo8uHEXG4jjCD6xsNo5AAtToVdNc	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	470	1309	38	1	4160	jxg7dwhsXchbdGemu485eVFVEaUxNFenpAeABZzV54QQLrErnLu	2217	3150	3150	1616506200000	orphaned
4282	3NLK1baVC2i8w7zN18Wg6tVTtwpWXhsopeb8c1gXKzvdz7uBZvvK	4281	3NKqBC9NvEGyBXQUGAURQ8qGZoeEey7aD6KKYJkbQQ9zhyV2JbmJ	1589	1286	38	1	4166	jx9jPrSST2hrBYkGD1HTX9AuDN7KaJCSqBNeuWzC6MnRF3tWHy5	2221	3155	3155	1616507100000	orphaned
4285	3NL9v7UbE5KSsQhPFQx8px4RpZAHkdPuufoyXmAx2gQ83umidR5N	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1672	1285	38	1	4169	jxAED2J4Rq98cZceFW9DiJUd75dJHgyQrft5tBKGa4RZXmBxvdW	2222	3158	3158	1616507640000	orphaned
4287	3NKr6UCWjSe7LD6GNf6ZwzjUvXosDQq5QbjkYq9bi9apdUaPueea	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1652	1315	38	1	4171	jwee9xMup5wS9qXQ1he25EFhcKbKuDzuJGaBiDgNv7eKzw2a1CX	2222	3158	3158	1616507640000	orphaned
4289	3NLCEPpguFhzCq7JpeeWu2CvYCZeAwYCtouH5odEuPaw9JCfV2s4	4284	3NL6oEumNBfeUTQHo5y749GUcRsRh4NsPt7rPv7zYz2vvP8fnQqx	1402	884	38	1	4172	jwoRu8aqMF6FbSUhGz1yVBuVykTXF8QryTb64oEgt2WJUCLuPwe	2223	3159	3159	1616507820000	canonical
4294	3NLyV6mQQCDyzN4Fct53bT5L8MZZ6KcaPUqxjp4RwXoQpJiLgcbC	4293	3NL9yfhM1sWxF5ZFTNKJqGNCWndgpg3dzs3GpDP2Eda9uHxcRCic	1542	1304	38	1	4177	jxsxKeE8GRhrQ6YXaVDr3HowjzyyFhMddiYf9NaRoUw5kGaT9Jy	2228	3164	3164	1616508720000	canonical
4299	3NKgiXTBLBRagDvHUuTJsTDZ7i3YrJ1MmKWNa6eWroyERpVELkAA	4297	3NKagEtLPyzDApZMz8AZDrinKXPCzQVbTFv7d8bQHjm7gB9dFPse	1407	1395	38	1	4182	jwaZSd4zFQLKUoWGCY9KnkXv581Bd6YZNdi6dJzfhR4zz1SiHxy	2230	3166	3166	1616509080000	canonical
4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	4307	3NKiiyVhc1KTEWCJRQyZEyoBAjkmqjmkWS1yWtvAFBHyDaNvyuYM	1407	1395	38	1	4190	jwtbLuHp5KMcA5b1KTMjETTM7AVjpB6keKWtSuFhh6zYTK4kEqH	2234	3170	3170	1616509800000	canonical
4311	3NLRz1QbdFZ2ZoGTMP2WobDfNnPAMnrJ4dcDAwwcw7XRPQ6Snfp1	4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	1577	1327	38	1	4192	jwybquK45KuX8W6USN9Q6R6v2LqNWejwqimi2aAz1JExskYpqGm	2235	3171	3171	1616509980000	orphaned
4313	3NLDbpC2pLQ8asaJvjwU6YAkLVHUmu7t8Y1aZfZQVfDieU2GYoTz	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1483	103	38	1	4194	jxnnLekDJQpN2ErdCbDCihecvErwwpNTYbAJ6TutiGe3KT9Uqx7	2236	3173	3173	1616510340000	orphaned
4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	1631	794	38	1	4199	jxJunZ7x424CjbV83KwvNyzT5BYfVqQFjXy9LfGUMtgZbX9Ew5U	2238	3177	3177	1616511060000	canonical
4316	3NLaYxeZDAz1AfZFpJxAstNfDXDP8mSeZxcxwhuNuCAvw8EJ55us	4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	1406	1393	38	1	4197	jxDCzjCk3jWbRrZAUYrHNCmQ2YuAd1JpNFCAXPpPuTJXNJLHUaY	2238	3177	3177	1616511060000	orphaned
8664	3NKikhVffnkV6uBhRykViKeETmCvQc7KwqAQaQHACmGngtse4b5h	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	1523	1321	102	1	6301	jwLKJZkVZCLyDwgXWSTp4qfNtmpw5ExA33wzFPyqQTXBYxbTwkU	4485	6320	6320	1617076800000	orphaned
4276	3NLWkagpcuSi9vqNf8e6R6KmZ5mDjHgCDwWv2CAGgzFupEGsj95x	4180	3NKducHU4goKH3X6nNhBC1R9ucrt68QqvdC78wrnukFi8ksSuU8W	1507	1034	34	1	4161	jwc4pTdK5qyDqrV5LSYg2dTKqN595mVi9hibra1kHAkNz1qApzw	2041	3150	3150	1616506200000	orphaned
4324	3NLmBi1P5nhLpSXtKBPqc7WEEYjuhpCMmo1VB5XMoXZaS6Z5nUcz	4238	3NL8Eckegg94T1FgHuhHYjzipVdMp6vsoxwaBNw1kMaNw5w9DjgH	1581	778	33	1	4205	jwzrh1c9P6Qjzv9T69t26uqnUFeCH2Prfs6RFANrDHvbazugPqD	2061	3182	3182	1616511960000	orphaned
4345	3NL3dqirQVCn8T8N5yWA8TywxpXgs26XSckmrQxHWKxNcHK796ND	4064	3NLV3GaX1Yq7ffdNn4gBeVLKnnTzDAznxE51VSzzB24acYfRuE6R	641	1090	35	1	4226	jxpRkV7Vh7Htkf6wuVHRDxacA8RuPLur9ZMxUHuH9M1cWUULidk	2113	3194	3194	1616514120000	orphaned
4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	4242	3NKE7BSVSNdeF5SH39y1KdWgmDVoj3wBAY1ifmudW9EHFYiS7LwU	1522	1196	37	1	4130	jxrVMM2YLSsqXY8CCMx9o2e5JsExQ39BKxdcbarmvUrEVCr9CUN	2203	3129	3129	1616502420000	canonical
4247	3NLvh3GzmKaheqzuhHcaV116UDv2U1gngtJdkY2r6r1oy8krsiPx	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1646	1108	37	1	4133	jwaBEAfQFQCtLCrkPSQBxFaAj1sc3Bsuah8AaXfcQGggdim8NDF	2204	3132	3132	1616502960000	orphaned
4253	3NKKcUFCoWebohxVf2BKdLepNs7GSgEjT3PCsUL6ks9LVWaE8ugv	4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	369	1312	37	1	4139	jxUr1sY7KtYwwZnmVeKN5V4rVTu9AdacpsXeDJ3dCkcrRV7q17G	2207	3137	3137	1616503860000	orphaned
4255	3NLVQGcDA3BQszBazMKc7sxZhdHaDJdikXQ38dCNg4Ar7nsR7PGc	4254	3NLZUTQzXxscEABQSRdwrJb3ohdFEKgX1T8VSKpsoBeZQ6bRggj9	1654	974	37	1	4141	jx9Y82aJpmNsdFUEwnu5rNxtLP78kUkaBLBwT3gcuyRUeipx2zK	2208	3140	3140	1616504400000	canonical
4260	3NLfddXXATULemUcPCBW6mdQrw6DkMS45NDiew9d4bV9Xb7vmZWW	4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	1590	1300	37	1	4146	jwz8cksVMT7aHRZqtNakrGCoaCziTdQHkjvKMTCTRa3pmFbDwPu	2210	3142	3142	1616504760000	canonical
4264	3NKPiLcifYTLn1FyshTbEgVNRjEA5b6XnvmXaXSbj1EARpWCkBjH	4260	3NLfddXXATULemUcPCBW6mdQrw6DkMS45NDiew9d4bV9Xb7vmZWW	1559	1353	38	1	4149	jxxY9ECV9gqJ4HWEi1B8w5p34iV1MMct1ZFwX5uTU6c8Hs5Tstx	2211	3143	3143	1616504997511	orphaned
4266	3NKVS3k9NcPHUazd8jwh28phUfP67vjeHxvGSpbRu2FKYPK86MJ7	4261	3NKbjcu3TfyJebDgzNebQCqjZrCRWVUBW6y7H74Z5dHA2Erhw4P7	1406	1393	38	1	4151	jxfj2ifCFms2k3yg3uKCGVoNgHsu6JRxW39EoUvCZ9v1yj7xqGx	2212	3144	3144	1616505120000	canonical
4269	3NLo2RkcGqDhNEbReeZwJgG9fYpV6Q2Fcgs7mcMY3HZaaRBxJzpm	4266	3NKVS3k9NcPHUazd8jwh28phUfP67vjeHxvGSpbRu2FKYPK86MJ7	1527	927	38	1	4154	jwcwrWKNkgsWKbkY11TAw1pwx5NzLyTrzNjNhegGUXEJU8D8kFD	2213	3145	3145	1616505300000	orphaned
4271	3NKzGmTn7UqVFdqStfayGD32E4CA38Roqur3z7QfwDAvSBdYhx3s	4270	3NLZuPfSertBQc7XunytzZuu3WcGE5dGCbecg8idjLgvaY2z9adT	1407	1395	38	1	4156	jxjyoeQDR1tfQDtFe9XajfqBNWpg4NiqiSh2DncWTeJdaP3KtJU	2215	3148	3148	1616505840000	canonical
4274	3NKwgmfMHmA7PFasZMKE7yco646EtJzdRMhw9wKSCjm8j4g2Ww5n	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	1426	1118	38	1	4159	jwZjBn3Asb257Zc9EtdUbQFgwjuD5YbufqeWcejcsvRdxdPMBtu	2217	3150	3150	1616506200000	canonical
4278	3NKMRLztKJnBHBjZTbts73SiKavn9kmwNp6JycuytZjedvPfHiY4	4274	3NKwgmfMHmA7PFasZMKE7yco646EtJzdRMhw9wKSCjm8j4g2Ww5n	1406	1393	38	1	4162	jxn6JUt5CShY1MpdSZbXN1W11ake1cQDZGzij3W6knY3VKSeGc8	2218	3152	3152	1616506560000	canonical
4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	4281	3NKqBC9NvEGyBXQUGAURQ8qGZoeEey7aD6KKYJkbQQ9zhyV2JbmJ	1553	776	38	1	4167	jwwFRDACALwyGmv2P6pnK6Naz5mExP9R2fALzCPpqUWnFEy3Egp	2221	3155	3155	1616507100000	canonical
4290	3NKf4MMtA1LAsFjtd8THhKgsBtmvTJtiahP1UrXDpxErG4j4Kknt	4289	3NLCEPpguFhzCq7JpeeWu2CvYCZeAwYCtouH5odEuPaw9JCfV2s4	1403	782	38	1	4173	jwx3Hv7AHf2tnRp5vJRXd3LSxeZZnGNDAqgnK7YHHpK2GYNedp4	2224	3160	3160	1616508000000	canonical
4293	3NL9yfhM1sWxF5ZFTNKJqGNCWndgpg3dzs3GpDP2Eda9uHxcRCic	4292	3NL7zht2j4dn9V2bCn1i8Q4FUXwXSQop6pBu3ZgUKs8EZrF4hSKJ	1579	1389	38	1	4176	jwvV3j4YtGn8WqRAgqSfteY4AqKfXogFhE7LMLfNN4ybUGzQ2Cd	2227	3163	3163	1616508540000	canonical
4295	3NKnQ1hbndMBCMtCJVkgkgCYcUWe1bAi2ec4V1FwbQqS88FzBPys	4293	3NL9yfhM1sWxF5ZFTNKJqGNCWndgpg3dzs3GpDP2Eda9uHxcRCic	576	989	38	1	4178	jwC2spnFPJc7yJLqYBHGYqQP7ry4vUAXpTFygCdFTzACTMLXHxA	2228	3164	3164	1616508720000	orphaned
4307	3NKiiyVhc1KTEWCJRQyZEyoBAjkmqjmkWS1yWtvAFBHyDaNvyuYM	4305	3NKor3E3cDFgbqPmnh5NNkd1uzzG4nqdbwCucPwWNXLikhyUw9bX	1654	1214	38	1	4189	jxX2uDY3f56trR3Re1YHW55YUqabbgP6PyULLSJFwaqoi42Vk89	2233	3169	3169	1616509620000	canonical
4312	3NLx7pZPXeSSyj7Pe9L3T5yhHuJyb9dkhUKVaZkVKhYMrSPTCU2t	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1672	1039	38	1	4193	jxwgs6XojgrgvT8FdSRwovTkfT2nXQRMwnKLmyyLxCC9raajtve	2236	3173	3173	1616510340000	canonical
4314	3NL1mMEpXB9P4LKrsmF94BcvnJiPRAmynfrxV33UypKJrvf15EWW	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1481	790	38	1	4195	jxcZjRb1X1zrm38qCWknkAxHteAQdqmcUTbubtyV7p7cN6a3itf	2236	3173	3173	1616510340000	orphaned
4317	3NKveq2Kbxo6i7WYmotj51a5AKJfKuR2Q1HbanZ2GjrcecbMqKHW	4315	3NKPFP6rE5U6nDKXVTx5MjTTTbqqubaBBbndRHGFK8s4jHpbBQGM	1607	1102	38	1	4198	jx2aT8cQjQsmG67DjU4PHB5ZwJ3i7Dh8Tm4a9m6gbSqvPULSZG3	2238	3177	3177	1616511060000	orphaned
4319	3NLwpUbdSXZR3gsuGhx4fdA8aQxRZt5WejFKd789nE1WNbF8Yv1c	4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	1434	642	38	1	4200	jxovHWT9XKrvgWtp3vZnL11MLr8UnE7nB4PGiHeW7vUmBxQk13d	2239	3178	3178	1616511240000	orphaned
4329	3NLy6Ra4zLy2CDaNTsN31Cr7VZ6DQ5Yns6FVTUzv2XrSX9JWTkfA	4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	1406	1393	38	1	4210	jwHyKdMsCkjaXEfhevD23yKNHxnC5R3EDUFhxVqYN6aH2srf8j6	2243	3184	3184	1616512320000	orphaned
4331	3NKHEcq1QQ1eS28FpWxnbWKnryYF7kmNwTasQNVCCFuvT8hFt92q	4328	3NLCU2uzJGtM36nYCSfWaebWveKZoLSaQDmj8RFvBJ9uNhdM3xA7	1474	1083	38	1	4212	jwJbAPZEds8HGE87jQ8jXU1SVB2TCKTfat3QDsint8vgmDDMrdM	2244	3185	3185	1616512500000	orphaned
4333	3NLQxaKk6jLzVAaAcTt6udon9WQ4ckBQ5NB74pUsiCbyCPMuxq1V	4332	3NKB9mpAD5gzV8hZM77nRVWjV1Chh5bYCSvWAPdtF39eK26gDwu1	1444	1135	38	1	4214	jwgq8fcaFdkfnWLq5JFvkmzdsPKxU4vssLB5UeCZ8sX5K1keov9	2245	3186	3186	1616512680000	canonical
4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	1419	814	39	1	4220	jwkBh1beA8XRY3uXfe5AqmNDsQoP2djCXz8Mzj3GYMbVJgcGSaP	2249	3192	3192	1616513760000	canonical
4342	3NLcqYPYTYNx1ufUNpCrXCUYCzALTGpdnprjgegsFdwBUJV6xMJr	4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	1422	1091	39	1	4223	jwKVZubVGsDpQjycFLkeHc6owMHmwPZGY9yxqDru5BrCuDfuf37	2250	3193	3193	1616513940000	orphaned
4343	3NKtFv6QvKvZKxHK36MLn2Jjfz9RjV8jw4zspkkvgwzT9xeakwxt	4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	1403	824	39	1	4224	jwzxL8wHqcUerWpRMrzvYig7UfuXPwueF4jA8teZu4pbLtnx3wR	2251	3194	3194	1616514120000	orphaned
8697	3NLdxYWsuEFdehRS48HtGs586ujjCFkCRdPJkiEfmAuxsyn4xzFM	8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	1617	1288	103	1	6301	jxbqb4kCnTCLAAa39s1hH3kbgu39oi2rKZv8U6W258XudcZ8aHp	4508	6348	6348	1617081840000	orphaned
4350	3NLPVVycL2FmcYBkZTr1A2YQ2TftpNWeXKS85M8ybZYMP35iAhEv	4324	3NLmBi1P5nhLpSXtKBPqc7WEEYjuhpCMmo1VB5XMoXZaS6Z5nUcz	1581	778	33	1	4231	jxt3P3esCwCCELvugyiWHLjRsgHe7CZLSG2oLW5Ah5vk27V9V6e	2062	3200	3200	1616515200000	orphaned
4254	3NLZUTQzXxscEABQSRdwrJb3ohdFEKgX1T8VSKpsoBeZQ6bRggj9	4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	1643	1299	37	1	4140	jwipAE5EQxTBvZdrFiSYALTNkuCBGhthY94xeaQR93PHZ7UzkUs	2207	3137	3137	1616503860000	canonical
4252	3NKE1Q8CdePa5ZPVqNrEPDLeyG8DaMDDQD6kTTHPwV2e9zSrPU2L	4251	3NLj5tsQyBoq6Sa65HGzLAVyi62fVw6GCJHTqh2u1ENfLXyUDKzK	1407	1395	37	1	4138	jxGQPZXBQA2Uw3kzo9gVWU6ET7CdbKhYau4jKsAWjwPRSgvXtxy	2207	3137	3137	1616503860000	orphaned
4268	3NKAVUqkszFQa75zt5BPM5Kdyq79kw1tPnpLnoHg1wBKSD3hR2dc	4266	3NKVS3k9NcPHUazd8jwh28phUfP67vjeHxvGSpbRu2FKYPK86MJ7	1671	1365	38	1	4153	jwNPKnvcFJseHgnNvcsm9u2kLgf4ijFH54mQeMhkW2Tcjs2ABUH	2213	3145	3145	1616505300000	canonical
4273	3NLw4GQdpWVkhBcKfFGLB2LF7hU8phMut2jWQ92FWUJtMRwPLt8J	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	1407	1395	38	1	4158	jwkrZa6QUKC754wXWNatc7uFCvkDYBXtHZ44g3UFRYogxEn3LAB	2217	3150	3150	1616506200000	orphaned
4280	3NKcQKJDnue7CsQddWyS4e1KedyTzk8nTcvtRUrd68Uy5N8zgeMs	4278	3NKMRLztKJnBHBjZTbts73SiKavn9kmwNp6JycuytZjedvPfHiY4	1573	1072	38	1	4164	jxTKACTVQcN91f7wC8QJHdGoEKquTn4Po56W9Bd3f7n8j5q5Zb3	2219	3153	3153	1616506740000	canonical
4292	3NL7zht2j4dn9V2bCn1i8Q4FUXwXSQop6pBu3ZgUKs8EZrF4hSKJ	4291	3NKqpZQzVRPGyTpyieDi8vad722DD2X8xB3bNhf5U8jeMfDH9Jdj	1406	1393	38	1	4175	jxtcPK87iZBEY9595fZMLzK4sRBJsqPR2FexKpkT5Uj4XLw8zky	2226	3162	3162	1616508360000	canonical
4297	3NKagEtLPyzDApZMz8AZDrinKXPCzQVbTFv7d8bQHjm7gB9dFPse	4294	3NLyV6mQQCDyzN4Fct53bT5L8MZZ6KcaPUqxjp4RwXoQpJiLgcbC	1447	1219	38	1	4180	jwxeWWpd558FDzZKE8Yoai3ohbAa3nUHVAZYhiccMhBYPDo9R2W	2229	3165	3165	1616508900000	canonical
4304	3NLJ1Up8MvzGK1Uzbp3FDobWroqD8UxEyECWTvwMJqDTk5WRe9Nw	4299	3NKgiXTBLBRagDvHUuTJsTDZ7i3YrJ1MmKWNa6eWroyERpVELkAA	1651	462	38	1	4186	jwymcYQa91atmGeqszX1uCzR2dEW2zr1ueJfdPRsNLVaWkCkBXX	2231	3167	3167	1616509260000	canonical
4309	3NK84F6NWomMvNtniGboihSGLzkxgGFHrKM5wAcGT3VeFU3HAE9E	4308	3NKeG4WKrEH8bFY9RfFM2Xvw1TegxcLGnzC7AEqJETcmxjGqWseS	1407	1395	38	1	4191	jxASegQAkAfnbXnV64JcZioEuyhtH6o2GWr9yzHa11pzECdqYKq	2235	3171	3171	1616509980000	orphaned
4320	3NK4B7aTK7iCke9VYY26X5UxEAzxcLLSqtX1XDgfxBRJerC2WJb5	4318	3NL64oQwidEhyQTy9DjyzsANDztSZeufPe5PzaQs1Zgm5LQm7vNN	1406	1393	38	1	4201	jwsxJefP3Lm9avKL5WY3TCXsVceeobpvQvdg8gUMGC6X2CqMKiu	2239	3178	3178	1616511240000	orphaned
4323	3NKC3LKqRrzsrXcJLJPuH5ZQp6CTtCdKGGE9sdvQYgnHrFKDX4Hs	4322	3NK6AfdGtroZ72fL5eohywSbSF6mS6M4bpJrLswdb43xtCExd7dU	1483	453	38	1	4204	jwHVN7wD1TdDEtFGg9AxpFrUfR7h6UF7jSTqp3JVGsXjjrj9CCx	2240	3180	3180	1616511600000	canonical
4325	3NLiYg1DxDw7Cau1dfxzX9n3kyURXmVWqs2tvLR2yjdNaVqtHjZh	4323	3NKC3LKqRrzsrXcJLJPuH5ZQp6CTtCdKGGE9sdvQYgnHrFKDX4Hs	1600	1372	38	1	4206	jwi54TQxyQ3xqL13Zxy9nGAXDMyfjfSpga9mCJJL54MHv1S1Ynk	2241	3182	3182	1616511960000	canonical
4326	3NLpqSKJ24tBXCiwhCFEpV9cfWZJhDbJFhGEJ9zPThP4eJtexznM	4325	3NLiYg1DxDw7Cau1dfxzX9n3kyURXmVWqs2tvLR2yjdNaVqtHjZh	1458	1323	38	1	4207	jxkfb18gfZ1vXEjiprormsUWe5DNDbBXJAdrtzCk6aSeth49yCa	2242	3183	3183	1616512140000	orphaned
4328	3NLCU2uzJGtM36nYCSfWaebWveKZoLSaQDmj8RFvBJ9uNhdM3xA7	4327	3NKd9XkgSuxBUnNc5wxzMBtAntZhjAUotyt11Zgw9BjJNG5EasR6	1407	1395	38	1	4209	jwMa8op4XFnB8goNWkpr1JT55KXNtEwXrbQxmZSUU2XjkmPEhBd	2243	3184	3184	1616512320000	canonical
4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	4335	3NLpicUkZvMD4o6gUwnPqrn5RV5qvTP1CM8eoLRBgSEzRC43akeg	1403	824	38	1	4217	jx9jDTCyogscfyBFbjD38ZEdoCkdmzKuWf6m5KueeFmGKHEv7ZR	2248	3191	3191	1616513580000	canonical
4338	3NKzA38yhHpZqVo5WSEmHqUcoQ8i9qWeZWEHjPWF3nQn2wcYYT5P	4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	1654	1340	39	1	4219	jwrVyZd2idV9a9kKv9G6LjyEj8YA423GcoU9H8ZTC8D44kaiMLT	2249	3192	3192	1616513760000	orphaned
4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	1407	1395	39	1	4222	jxNoKyZ6xf7sKs8HYJVXs6n12atP5ip9XM8BRJiN63g24zgH74r	2250	3193	3193	1616513940000	canonical
4358	3NLKLCRXK6eyhK8BjnZGoLmzLG9Xa6QgwZHpJui7AnbrduTGeikB	4356	3NLMwrdJg5z2UvQ1o8pk1vRxFjGh4RpKEjfP7wMtLpGNd6RGbnfp	1406	1393	39	1	4239	jxU3hALAKMDQi7bas95Xa5T88o61c5Vp6p3dA59tqbhC8gDgNpL	2259	3207	3207	1616516460000	canonical
4360	3NKWCT3xeq1TNuwY8T28SCrYjXczz4XfHM5NfTorsrXEtJPnjpRZ	4358	3NLKLCRXK6eyhK8BjnZGoLmzLG9Xa6QgwZHpJui7AnbrduTGeikB	152	1084	39	1	4241	jwRGECMEJiojEC6JDVn83bE5L8LG3Mn7mtayZJRhF5sTcDYP1XU	2260	3208	3208	1616516640000	canonical
4363	3NL4mtjpNBfxSqy87wjrz52W71TAvp2aSJpjUTnBkFVu26aiE1VL	4362	3NLhP2J5Pf5ttsCGZLRTLsq3mg2F9v8qYw1ki6vWrsRHPyncp8fy	1536	947	39	1	4244	jxcza4NvnFghcTT4MtAXvSiEggUMgH1osE2aG7CD9JCSwnp6FU4	2263	3212	3212	1616517360000	orphaned
4368	3NLLY3zacfFPGQiEQpYvCbQvdrP4Ls45tjs7Y9J9f929ivwJNBme	4366	3NLRCM9Y2yG3CJRs4TBLfTVEZmtL5ok6SKCq21FNgbAjsf4VCgXr	1426	1364	39	1	4249	jxNeD7yjamjCUe2K6wKWqLktmhPztdzVZapHyg44KNbypd3KZka	2265	3216	3216	1616518080000	canonical
4377	3NKx9sptAgHrTP2cgwrJqrBQPfqK2wkU5be5MAwfShxMdGdtkCXL	4372	3NKLCrWY44nqcaR293bDGpPkGa4PKEZW1pfL4BjNLkg96ZB93bSA	152	1084	39	1	4258	jy2MsTthwzR8QucPMkw2y3KxoJfpfyDvB3nX9aWmpdfpGU5fct5	2269	3220	3220	1616518800000	canonical
4375	3NLrW6nCXX3PtvYQzjCoYCpFo2A3grBtrUgjs8BM91fM2jm33DyL	4374	3NLpCTXYojRNaayPzeZrQr47GRHDooXoa24UEJVQwy7eLAxgooUd	1407	1395	39	1	4256	jxsYJDY99sTWxwVLRSBWorFLuUz3SxQYxM3fCxQ9weg2DaXUZYe	2269	3220	3220	1616518800000	orphaned
4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	4379	3NL1gv3ENXmsx1Ln66oFPANavA4jHzyKJE81aMuLiDm2F14F8z5f	1419	814	39	1	4261	jxfAJqrztUJbQ7A5m5Z3R2LFCGta1TpkLzKb31L3gZezx2m8WoU	2272	3223	3223	1616519340000	canonical
4384	3NLSACrAtBRBSgsyXXDpbZVCLJG7gLpsaDFLKsTxMuktQGZL2ScC	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1555	1347	39	1	4265	jxHa1EqGjbzgRZx58UZVuh3fnqNPKySEsVvcJqpfUN4HYMK895m	2273	3224	3224	1616519520000	canonical
4382	3NLWfqDKXfK6iK8smP6LF556kgPunsdS51prqrwwCBi62Khwz3wt	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1489	1380	39	1	4263	jw75BbJTRr3KttJYN5R3HkvoiwY597wBsMpFMTANmPQ488XJEjw	2273	3224	3224	1616519520000	orphaned
4389	3NL8e72MDCfERLhLknKWbZRfJx9vHafv8XAmj6YLaNciZwKMS4So	4387	3NKFneNQTnsvLoGhTCFtSpFcHsoEHCbwuogy5z6N7VsvuLsXAnvx	1407	1395	39	1	4270	jwhqzQpueKHxEqy4Bb5wvBQtwsprQVvGTMCsEmsgVp5z9ecdS63	2276	3227	3227	1616520060000	orphaned
4391	3NKQ7My7sCmncRxJeZHhQRGrqAV5E4zQJepNspStReGhPFxvAUe8	4390	3NKfJ6groJJP6CbQZ3HvLX8N9Jz5qZ52yaYNK9pP9dgDpB4EC8cZ	576	1355	39	1	4272	jxsNxZxo3BYPcXede7UbQBjtWa7pgV7VyHokmtGLTCp3mVydocX	2277	3228	3228	1616520240000	canonical
9115	3NLL9t1Z6USMPT9PYAAwYv2YWgVhiYPBBSZEA8iRKZUqEMo8fPVv	8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	1553	776	103	1	6301	jx59BCZSmfwhpdRF7ZZ6TyTktroeDhz6UmYdBxt227xRHThSnYf	4511	6655	6655	1617137100000	orphaned
4373	3NKmS368586rYejXykGgFF44ehPeWK9yy3M3N9Hq8rmq16LLxrQt	4057	3NLWXZE21XrcXvE7a4ds9NKULhrqaNPjsMocC9VN2jSCe47qAiiS	1553	776	34	1	4254	jwXmVZx5toPk6Rude3zYwiE3g9E4hoLM215wkyHQDMirWm1UjAM	2109	3219	3219	1616518620000	orphaned
4461	3NLHVvdAEjTzDkrm7GJhTPXHoE3ZiCBvNQzq73EXkmcQU7aoavmF	4213	3NKT6Q9o5QoMLimpwHpFeiwTTZS5oSfd5LbBWUm8EnqeDTyByHPL	1627	1385	37	1	4337	jxFkfTYi6SD8KYhfY7dEDTQNAUyTRQVvAmNSaEBaspNicnfm13e	2193	3272	3272	1616528160000	orphaned
4424	3NKZSsxaSB6JMpet5KpaEEBMsQagjxQKVpwqntKf1mKL24UGT9E8	4323	3NKC3LKqRrzsrXcJLJPuH5ZQp6CTtCdKGGE9sdvQYgnHrFKDX4Hs	1652	1315	38	1	4300	jwxn3a9yhMDAqojLgsmzkVcEbHwxQ6ovjpTxTWCRhPCWVkUTVKu	2241	3250	3250	1616524200000	orphaned
4332	3NKB9mpAD5gzV8hZM77nRVWjV1Chh5bYCSvWAPdtF39eK26gDwu1	4328	3NLCU2uzJGtM36nYCSfWaebWveKZoLSaQDmj8RFvBJ9uNhdM3xA7	43	1064	38	1	4213	jwcAwZwdXNxrSM2AV7z1CDebmNEtnTkuzW6GWwRpEQ7HLSjgWsa	2244	3185	3185	1616512500000	canonical
4334	3NKNMcnWAAToJEUuXRm3TjUigRDT59JJHp4bkLgaACEVFFsBMxmk	4333	3NLQxaKk6jLzVAaAcTt6udon9WQ4ckBQ5NB74pUsiCbyCPMuxq1V	1633	1390	38	1	4215	jxrzt74rc8iy89hBdHV29tPu17y5w7BbsbJsUQSzsD9jn4pjRRu	2246	3188	3188	1616513040000	canonical
4335	3NLpicUkZvMD4o6gUwnPqrn5RV5qvTP1CM8eoLRBgSEzRC43akeg	4334	3NKNMcnWAAToJEUuXRm3TjUigRDT59JJHp4bkLgaACEVFFsBMxmk	1560	1165	38	1	4216	jxbW8We1W1QQNAb4mS3VBSrWCUwetdo1cG1aCViGi6AZgsR4nNa	2247	3189	3189	1616513220000	canonical
4340	3NKfBZJUiDZhbfyT2XVXcHuzv8Uhvbu1E2CTtNzoyLhfkxFdB8pG	4339	3NLDLUbQfUL77Zw4WszqQswSAX4LkqYPYWDTXxxiYNuiYLpXduf5	1500	1297	39	1	4221	jxHBpFZK7eYK2JFNBanD6Knf6TML2eq9sXtctmeJCXDJx6PrXDc	2250	3193	3193	1616513940000	orphaned
4344	3NLrjsjgqnxggSjx5u5JEq49iAVwzkgqj5G3wLvcUabL4H1w4zy8	4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	1522	1076	39	1	4225	jwjyuCz3spCJJB7qm9cUKQKJk3cwbBe2A3bruGRjc16nwV5WF7u	2251	3194	3194	1616514120000	orphaned
4355	3NLaucpg1y5waZEaDcYiDV2v6ULngBkhk8bGg9DfHVP7EVSDZnyv	4354	3NKrtba5NgQjZh4DBMv34QRdCTNWdqXgUtMpXcBapEfdoMYf9FPS	298	1308	39	1	4236	jy1htSuGZXe9EW8fYSBvB353zGj3AvsPxbuJbjJ4z2RBKvy6T5S	2257	3205	3205	1616516100000	canonical
4362	3NLhP2J5Pf5ttsCGZLRTLsq3mg2F9v8qYw1ki6vWrsRHPyncp8fy	4361	3NKyMbeQfoqtvLnFiHNsWq3AHMBTDub8ia2oyQ1PjgvBJGjWkKht	1406	1393	39	1	4243	jxd6jmTgZ9kQiURpdRXyYix9EQ3NgtpPgAskGw4dS8Zugh2xB4o	2262	3210	3210	1616517000000	canonical
4365	3NLkj42fYHjegaYyJf3ZmgwDv3pVS8yCP2TXvUTNbcTw4NWUVqG4	4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	1444	1015	39	1	4246	jy19fU8J51vvNtm3igtiqeiYu6itTzdAHwa4ATRJYUsFoUfz8Kh	2264	3213	3213	1616517540000	orphaned
4370	3NKsE232ofxSgRip3LgBmVZafED64gNKxvMdvgHdV81F3x9czFpw	4369	3NKLewpbfBvb7d72k493epLW2GrKgq66pKFB8enh2yeUefFfZ9PT	1542	1304	39	1	4251	jwLGRbCKHpVaUDyUyg67DCbt89BBNCHLzGwiXY1PVQbYUrfYpfL	2267	3218	3218	1616518440000	canonical
4379	3NL1gv3ENXmsx1Ln66oFPANavA4jHzyKJE81aMuLiDm2F14F8z5f	4378	3NK6M3C3j8FCaBAQYoLSiH8wrqVAqKjh83vQg3ovJmDAekqkSuVJ	1646	988	39	1	4260	jwURPSQEio3L9VWXHTDTEjhLcLYauhzkbQeKe92ByE4hZSawvUf	2271	3222	3222	1616519160000	canonical
4386	3NLrpersADGioxhSAxq9GbCgMdcY1eTQk4ctV5D7kTEiP8miRkQQ	4384	3NLSACrAtBRBSgsyXXDpbZVCLJG7gLpsaDFLKsTxMuktQGZL2ScC	1559	1107	39	1	4267	jxvCgS4H2qVWQhTfn8sxeZVsrdryxTGuqbSMn8R1JeUXUR3do73	2274	3225	3225	1616519700000	canonical
4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	4391	3NKQ7My7sCmncRxJeZHhQRGrqAV5E4zQJepNspStReGhPFxvAUe8	1553	776	39	1	4274	jxvC92fgXMQ27YKPxxfHa53AdtRAGM6MaTWwKwKAAfMDYF8XFYT	2278	3229	3229	1616520420000	canonical
4400	3NK9P16sNss5BtPD8XWn595Ucu1UMkYgAbf7Jq8p5c6iQrqDRjtz	4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	1471	1386	40	1	4279	jy33GsBewVjYF7YpPqG9Y4RYDbKQA56CMMdpQRK6t1RS1cEaiqx	2281	3232	3232	1616520960000	orphaned
4404	3NKzAwMzBSpAamA6cDFPYZgRzDQAsTDqC6jRWXxmZXk4MqbWPjcy	4399	3NKmAs9zJqxWy3viTzmKqGdN5N9KuMydVkMdsnFGFYtazo1VyGYq	58	1035	40	1	4282	jwYYk8ySpkyaPNDp7UfGi35NzgNr7iVLz8hH6wvMQHWfEDiXSCd	2282	3233	3233	1616521140000	orphaned
4406	3NLjZDPDG6u33DN71sXTZjVzWK626vuCTF68EYgGSjDwHAzc4N9Z	4403	3NKtdsSZgAZdABr9kKhVSdwCLyJN9uYGrhgDohu7XrvrqgrosGjL	369	1066	40	1	4284	jwf7dDPcFboprBdfoHmYFjMRS1FWLGHQb8e6LuDHfowm97NuLcj	2283	3234	3234	1616521320000	canonical
4431	3NKUD75LZXb1G57PoALXtF3rm81ZGxE4NByJ1V1e7hxwWjnNy7MK	4404	3NKzAwMzBSpAamA6cDFPYZgRzDQAsTDqC6jRWXxmZXk4MqbWPjcy	576	1355	40	1	4307	jx4kX6oKVh9QmaPNT8Do2xsyzmbj7GrCxy7mqohyAGd9eixZNeG	2283	3253	3253	1616524740000	orphaned
4411	3NKEAXfNzzBaaAx5DqLrgFdLrkLj4Y11d2aKnCRCdHEAzoSF3v4a	4410	3NLaaK4qMDWV1uspsmn3xDHPurRcsL9oTFRshaz8PT59EcvTJzx5	1406	1393	40	1	4289	jwgqTCUv7Ch1WpQjuiNi2oQRZrzKNhueShP4cXHRoWuGfUM3rvW	2287	3238	3238	1616522040000	orphaned
4415	3NKEfKeStvD6kiixXNpRqVTGmAhLipGncEZsdvAtzZAf3Z4deYDH	4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	1646	1354	40	1	4293	jwh1F9qQvrjSjo4sgzhsEpMC66m9JT4Ze8oMEzneXdqkavAnAcd	2289	3243	3243	1616522940000	orphaned
4417	3NK7z3FJsSNhcPiRGxUfYR8ZgA8ZaUXSbxVyvZv1o3tQJY87vVCR	4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	1407	1395	41	1	4294	jwLRwWKzWhh2MdjT8gKSUm9qtqHLP9JYzLWfnUAky13XXWifQnn	2290	3245	3245	1616523300000	canonical
4429	3NKdaFWNxVydmzqm1umAq6EhYD312wVxKjnKT2FnNkS7sMeJLVbm	4428	3NKjqn1ED1fM92FxGDc1hJxgx8Q6pBq585YnLaiLG6N2CRQ1xESH	1506	1007	41	1	4305	jw9uR8titVMzoNCpRiZ5MGy6y88ZtF4pNeM3j6sjpC74c64aXgj	2297	3253	3253	1616524740000	canonical
4434	3NKjC9reE6V39YpA7ThhHCZN2bmxAEDaHsXJXunae72dXbQz17jj	4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	1634	1205	41	1	4310	jwBCJg38piS9VyY8U6BPGaUWHUnKXbw3wcA9E1fph4TettqpZqZ	2299	3257	3257	1616525460000	orphaned
4436	3NKHQPYzzSNGSMhBprubaGzayCy1i3CSr5zHVUXBXiHvsjckk7wJ	4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	1631	794	41	1	4312	jwzgNnyZ3wc1tT8KNDuXYUGACVEC1yDrLF8rAS78ghvrW3x63CB	2299	3257	3257	1616525460000	orphaned
4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	4439	3NKQGJtHh1uQTLh9KrPHDLwcpnBMGJ8JpLk6by1gsPGqwHBQjmYu	633	1018	41	1	4317	jwGPjQaKFXAu7DFph1awiWNn58E6XPLS27L7DNBjLmjTKQ221Zv	2302	3261	3261	1616526180000	canonical
4452	3NKSsv2dmPrzJwGfFhCrkGmE7V1GgR6oPgf5ULm1xfDPN1cs9ya8	4451	3NLrRDxVZT3whja58Fk8vYUpc3ZzTLXz5J5uUfQ9AtaPvYzsrPru	1407	1395	41	1	4328	jxjXMfKz2FXfwTikvxTbvZsvUvJXzyaqB1YCvoYa3KS4TFPrPGY	2306	3265	3265	1616526900000	canonical
4456	3NLjEhZ3PhwkN3v2LPJCgiGjTFNz3YEf9vjjAKiRuTWtXpNCFCdx	4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	1406	1393	41	1	4332	jxa2RqVg63YB6SKornuX2PHbaGpgG7GdUqqNy1iLPimrnCz1gSP	2309	3268	3268	1616527440000	orphaned
4458	3NK9zDyTF4K5o7xCGLbkK4eHJpNBjsmFDw151G82vVRmmcNAebis	4457	3NKWW956ykqsMa4nkASPWXd8z3gRprJd3n5BXGqPZeXPphUQuc6B	1649	571	41	1	4334	jwf8kYQowYt3NadqfcVuq3BnRZ2Z1vcXkMHmritGZW6pAEeTCYi	2310	3270	3270	1616527800000	canonical
8705	3NLQBzV1XSwTehAYRWcdt1wa2vyfJ1kL5LsWL9BsRTqMBVPFbqyX	8704	3NKN2qYCfLWfytPBggU6gW1DpgdPQb82ojt4pAJjpBDijGsd3K25	1560	1165	103	1	6301	jxvA5ugYoEDPCi4mCzmXHCosueJhgU58b1wU1kfoGRHQAYDsJw5	4513	6357	6357	1617083460000	canonical
9844	3NKW4qhhwLUCPGDXmbNAuGYMx4DRwLpSPgm8PefcoD4nh17c1YqF	9840	3NLYgEACaqaTUqSw3efvcstbj5YuMy4v45M2Ef4MDjv2ERMpPRb6	606	1169	128	6301	6352	jxm3oAkHCzhY2BXz8aSPNv3ZGmxDTQ4jMRNn5Au15L27MdAMGZm	5102	7179	7179	1617231420000	orphaned
4337	3NLDa2rbDEfApZgfWustoGzeBdt8zucRHJaaEefBx5YfbbHeB5D9	4335	3NLpicUkZvMD4o6gUwnPqrn5RV5qvTP1CM8eoLRBgSEzRC43akeg	1559	1353	38	1	4218	jxV3tzdsR8f5MD1xsbF13NLA7uffzAn9zv62hXWfDMSP3L2nXTA	2248	3191	3191	1616513580000	orphaned
4346	3NKi2ypDcVtEnENQvDNhShSWBTVTW9VLQNd6MHN2kV23cNHxj5gZ	4341	3NK7giqEUXCsp6Ns94YXYNmm6o7BJBJrCBxtCUyoHfBVGJnDHWpF	641	1090	39	1	4227	jxvohXhxWRgxJuLxFi1zCpYc9PoabkwqQoUQGotetKXyX6h6rC4	2251	3194	3194	1616514120000	canonical
4348	3NL197huVBXmjQgc4taMBfbvwrKYWSbEL2D3XqbRxzDvvhtteiqp	4346	3NKi2ypDcVtEnENQvDNhShSWBTVTW9VLQNd6MHN2kV23cNHxj5gZ	1537	227	39	1	4229	jwQ4n3tX9NzbL63fH26BDi7gcDjM3jfpDDVyTSztDceWLF93LV7	2252	3197	3197	1616514660000	canonical
4349	3NLKmCNnnyqJbWCdBrmnRXQPDSWg7zbCgjFSf6tHiqEw4iTKSgXd	4348	3NL197huVBXmjQgc4taMBfbvwrKYWSbEL2D3XqbRxzDvvhtteiqp	606	1295	39	1	4230	jx66SpiZedqqKRm7JYz76EDnBHLjGPsxZtiFpB41Rwf8sJvXXBK	2253	3198	3198	1616514840000	canonical
4351	3NL5Z5N8s9CMk8HQjYur2prM6RqowZbpLCVZiizba9Yrq4Bh3AhM	4349	3NLKmCNnnyqJbWCdBrmnRXQPDSWg7zbCgjFSf6tHiqEw4iTKSgXd	311	1061	39	1	4232	jxYGCrZTUS187LkNijknXFEZGC2kGUYxVg3XYmsPYtCi2bj5zA2	2254	3202	3202	1616515560000	canonical
4352	3NLSemdnXUN1yMib8yW1qRT8k6yD76NXDX4vkAtUhj8r9jSQoGsL	4351	3NL5Z5N8s9CMk8HQjYur2prM6RqowZbpLCVZiizba9Yrq4Bh3AhM	1668	1124	39	1	4233	jwUNF6XGioAk2VrWMd2kSNRqCCbYrjZP5Kc6KnoqKYVJ9ADoGB7	2255	3203	3203	1616515740000	canonical
4354	3NKrtba5NgQjZh4DBMv34QRdCTNWdqXgUtMpXcBapEfdoMYf9FPS	4352	3NLSemdnXUN1yMib8yW1qRT8k6yD76NXDX4vkAtUhj8r9jSQoGsL	576	1355	39	1	4235	jxHRbVi4SRKhsaoAduiLY4FfpjXuRRCVrXY29FWGsFan1KWb2W2	2256	3204	3204	1616515920000	canonical
4357	3NLA46sPp1TJm7WoYKDhuoANaqu35BhifDtCbnjdJy31XnDKGHLr	4355	3NLaucpg1y5waZEaDcYiDV2v6ULngBkhk8bGg9DfHVP7EVSDZnyv	1564	1092	39	1	4238	jxtt9UM95jsfmaAv7tsJpQieiHXYXh8cfshfG5xB5HMzE52pWtC	2258	3206	3206	1616516280000	orphaned
4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	4362	3NLhP2J5Pf5ttsCGZLRTLsq3mg2F9v8qYw1ki6vWrsRHPyncp8fy	1560	1045	39	1	4245	jw81k7NqJs77PCQdsAGP9R2KsPKKNDSfvWxxnJsHL9EBrXUEiG9	2263	3212	3212	1616517360000	canonical
4372	3NKLCrWY44nqcaR293bDGpPkGa4PKEZW1pfL4BjNLkg96ZB93bSA	4370	3NKsE232ofxSgRip3LgBmVZafED64gNKxvMdvgHdV81F3x9czFpw	1407	1395	39	1	4253	jwWs3NRspMGKynccwthGcnarbrVwgwQFkH49DoyAGVEBM2LSaHM	2268	3219	3219	1616518620000	canonical
4374	3NLpCTXYojRNaayPzeZrQr47GRHDooXoa24UEJVQwy7eLAxgooUd	4370	3NKsE232ofxSgRip3LgBmVZafED64gNKxvMdvgHdV81F3x9czFpw	606	1295	39	1	4255	jwwmWSaBsyrtqesRR3XC65U36PArksnTdaTDbMZBByxNqDdacR7	2268	3219	3219	1616518620000	orphaned
4376	3NKXC1QsFdQtKDzmCN9EXoZ6nx13YdzkNSFKVecTRorFGYtm45qw	4374	3NLpCTXYojRNaayPzeZrQr47GRHDooXoa24UEJVQwy7eLAxgooUd	152	1084	39	1	4257	jx9m7Y38hzJpf3QERKxAB8zN4RCkf653BygA7p5xxpTRSssBxoE	2269	3220	3220	1616518800000	orphaned
4381	3NLJtzLhNVy3gumTL2d6DzfPNqdQ1MeA5Nt9sWv9P7YK1e3zWsnJ	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1406	1393	39	1	4262	jxiSF1N5ugLmPZ5qAEgz2U4maauxUHpT2sGojjMobzbbuH7oKgc	2273	3224	3224	1616519520000	orphaned
4392	3NLLH4DtBFHBWdEQE3GPwV8n38QdNb4hEZB3Q8U3rhhC4TedsTL7	4385	3NKWeqQcRJsA5TDgMnW7YiZbJzmPkGaTZ19UWRbseSphvDT7Mamf	576	1355	39	1	4273	jwmwFdyfQPyfzWsuCDqhdC3Zy4iRUAa69TL5qSxHKXQWv4hBDzM	2275	3228	3228	1616520240000	orphaned
4390	3NKfJ6groJJP6CbQZ3HvLX8N9Jz5qZ52yaYNK9pP9dgDpB4EC8cZ	4387	3NKFneNQTnsvLoGhTCFtSpFcHsoEHCbwuogy5z6N7VsvuLsXAnvx	1402	850	39	1	4271	jxHhAYqmD8DRTczhBMWx5qp1nXSp2NEeFmSkrNmPif2cue8YBss	2276	3227	3227	1616520060000	canonical
4395	3NK3m3dvytiUvf53ECVPsDt5Zo3bUpcwZHfCjdK1NTsv5trGvc2s	4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	1579	1389	39	1	4276	jwyX9Z543vaL5T6ZUR1i6r6svLXV5RmuGCUVwdgVrCCvw59HLSz	2279	3230	3230	1616520600000	orphaned
4397	3NKoszHyUoSEZzRVAD3NyZuyhda5X5xRJaLtW9exWb76VdHvsuRD	4394	3NLrRZid7niwWzHEpkTJrqYMA3d9X8f6fqzKxdcfZRCP4b1Z6r6Q	632	1256	39	1	4277	jxwL9z6q1kKgCKzA2ukVdZBmCvNso8Ez4WXapvGLsTgV7Cbj9TQ	2280	3231	3231	1616520780000	orphaned
4399	3NKmAs9zJqxWy3viTzmKqGdN5N9KuMydVkMdsnFGFYtazo1VyGYq	4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	1407	1395	40	1	4278	jx7LNrzqWZD7ts48kjNCsp5CEsqnJ9989Az5QUb1eQDi9mgdL1D	2281	3232	3232	1616520960000	canonical
4408	3NK5G51T8CfX89Pja6NbJ1mJxmnbjb9hYtjfWTEY7DQvhbbuq5if	4406	3NLjZDPDG6u33DN71sXTZjVzWK626vuCTF68EYgGSjDwHAzc4N9Z	1407	1395	40	1	4286	jwMxST5oqPV4juSnNbcMHZnoczTeH4PKU7oSKdLzzF6UwXxLX7X	2284	3235	3235	1616521500000	canonical
4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	4412	3NLK3Sx6r783qErHVxALeqHv93kZHf1LvQVvxP9hr6T3PKUjrEXn	1516	1294	40	1	4291	jwgstuibQSotaL4nE5DiTrBp7vsk9itKe7V2eqWrfFvgucqyayU	2288	3239	3239	1616522220000	canonical
4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	1581	778	40	1	4292	jxA5oswqVoBbVWVBz8TtScrisAgpENchusTVQmfZNa9G7WTVsqE	2289	3243	3243	1616522940000	canonical
4416	3NLPcVMk7foVT8xwne7QSu1S7b2t35aABWbYyp2zFmAdq9TjHT6g	4413	3NK4G9YQwq8qG2wvt1xkb9wAbkb5LgpGHBCxD8WWwE8WowYbGyGw	1646	1354	40	1	4293	jwh1F9qQvrjSjo4sgzhsEpMC66m9JT4Ze8oMEzneXdqkavAnAcd	2289	3243	3243	1616522940000	orphaned
4421	3NL4D9tNhX9iBvicf8mouZE97pNStLPnBXTw1U9pwVBT7R2ZpivY	4420	3NKeeza7cCoFyfa3EtE4XAiUUDB725AfUu9WPAKMTbBAbA9ergJn	1407	1395	41	1	4297	jxjmHxxigSETMb2rJyCLBPjnQwuSwutSK8rEYgDE9A4GzxaHkU7	2292	3248	3248	1616523840000	canonical
4426	3NLp4ST31t9KMU38Wzgf1cEXeQGX917hkncJBurVEs4hDxASoeh4	4425	3NKqpRbKKLFCKmySPX1srFrG7yWDvkwAPVkXXKk9CEaRw8qt62M6	1527	1293	41	1	4302	jwtZFo1hSyft7BMtPKG4F99G3AwdcCxAt3hzzYWAciNJPo25Vrm	2295	3251	3251	1616524380000	canonical
4443	3NKLNF1CzW6VpGvdS1qP3ckrMFsufd8EkhAKs4LrSgZrFBQg8LUa	4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	1649	1257	41	1	4319	jxrtR4rZAWHMTQGUSsX65oE9m2B5STbXHttZsbRTp3HjNp26xCH	2303	3262	3262	1616526360000	orphaned
4445	3NLvAaDganveAuzx4ntTtPsN1nGWi8JdixzLgxtr1peqroJ4dWLo	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	1407	1395	41	1	4321	jwq2jFVMk4RhiV2KE5msPmdsmtDTAAGQ2SfXRA7uDmoQTykvV5B	2304	3263	3263	1616526540000	orphaned
4448	3NKxsX7RWQN8qrsa4tXKUcRkPtiA63x4YruqwaVHuLYJf4jLJLSj	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	633	1384	41	1	4324	jxZ91ZtsQWF3KnPqQuztJZ9BsruKYQafgBy1g6XZpcDGzdxqXwF	2304	3263	3263	1616526540000	orphaned
4451	3NLrRDxVZT3whja58Fk8vYUpc3ZzTLXz5J5uUfQ9AtaPvYzsrPru	4447	3NKS6XfoDd4Ra9j79EyAzfdVahTNi2MrbrKJnbHkK8DiQDPWe4Vg	1619	1029	41	1	4327	jwBAkscHGSPWm2tzWMX1aYriKoCEM7DMtVdggEiv2nXeT8KEuGx	2305	3264	3264	1616526720000	canonical
9094	3NLVSC675EExG5udG7cYuZQqrj5kCEGdy2R4WWyRQs3gZpUYx7hg	8706	3NK2wBydYwUhpMc9GjNfSPbgMUoH9mxRhzfJx5qMagSZa7L3rsgK	1654	974	103	1	6301	jw7SZDvxrxNUTTFy65ehEtzd7UUtDUy41tnFUdETtevGW3XBzxu	4515	6641	6641	1617134649942	orphaned
4356	3NLMwrdJg5z2UvQ1o8pk1vRxFjGh4RpKEjfP7wMtLpGNd6RGbnfp	4355	3NLaucpg1y5waZEaDcYiDV2v6ULngBkhk8bGg9DfHVP7EVSDZnyv	1407	1395	39	1	4237	jxdoy8qeApDyK8yjxEMZfNxAnhtWoYfXoyB7a4TzRnRx9UhTK4h	2258	3206	3206	1616516280000	canonical
4361	3NKyMbeQfoqtvLnFiHNsWq3AHMBTDub8ia2oyQ1PjgvBJGjWkKht	4360	3NKWCT3xeq1TNuwY8T28SCrYjXczz4XfHM5NfTorsrXEtJPnjpRZ	1571	1335	39	1	4242	jwBj1gi4u534rqnG1kWXmf6dLJiwdscJCBpA8NBFtpcyrgDu6yC	2261	3209	3209	1616516820000	canonical
4366	3NLRCM9Y2yG3CJRs4TBLfTVEZmtL5ok6SKCq21FNgbAjsf4VCgXr	4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	1406	1393	39	1	4247	jwhnWHqpCctwWkuN4nRTbdENypJrfDfQYXfZWPbmszEBr9B9Vzp	2264	3213	3213	1616517540000	canonical
4369	3NKLewpbfBvb7d72k493epLW2GrKgq66pKFB8enh2yeUefFfZ9PT	4368	3NLLY3zacfFPGQiEQpYvCbQvdrP4Ls45tjs7Y9J9f929ivwJNBme	1509	1320	39	1	4250	jxBSC39CpZSJ9ps8web4X9W61j6KH5kctX23T2FWir7ugYxUF49	2266	3217	3217	1616518260000	canonical
4371	3NL9iRaCY9w1jUVN3jUMFyHFeP48PvxQvUyezARAx6XjV6vwFJeu	4369	3NKLewpbfBvb7d72k493epLW2GrKgq66pKFB8enh2yeUefFfZ9PT	1617	1288	39	1	4252	jxn28x2R5u7CeHzxMfHGPfzmUgUNLD323Z6c5rXjKMkUqKnVKPZ	2267	3218	3218	1616518440000	orphaned
4378	3NK6M3C3j8FCaBAQYoLSiH8wrqVAqKjh83vQg3ovJmDAekqkSuVJ	4377	3NKx9sptAgHrTP2cgwrJqrBQPfqK2wkU5be5MAwfShxMdGdtkCXL	1534	67	39	1	4259	jwEGvQzAq3d2Q88cTLRcP7UiFcw67wu8W9APvwC7bSJbw2cn1d3	2270	3221	3221	1616518980000	canonical
4385	3NKWeqQcRJsA5TDgMnW7YiZbJzmPkGaTZ19UWRbseSphvDT7Mamf	4384	3NLSACrAtBRBSgsyXXDpbZVCLJG7gLpsaDFLKsTxMuktQGZL2ScC	80	1147	39	1	4266	jwAJYTFU9RPyU89XgwjYqh625p5RJ8KY1ZSHrrNzVggvvhhg3qy	2274	3225	3225	1616519700000	orphaned
4387	3NKFneNQTnsvLoGhTCFtSpFcHsoEHCbwuogy5z6N7VsvuLsXAnvx	4386	3NLrpersADGioxhSAxq9GbCgMdcY1eTQk4ctV5D7kTEiP8miRkQQ	1476	1371	39	1	4268	jxurG4Xxy9MXWpBqfNGxu4ByqRirZSyVWArwhUFhgon3ymeV5He	2275	3226	3226	1616519880000	canonical
4396	3NKvMBgXKr5vCDpder1Hr3ymM4o2Ucs6nrZSPRsb2sTgzjUkm2bT	4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	1579	1389	39	1	4276	jxurc3kQ8jVTqd94xNakD2bfvtuAP2jU9fjBrHUfm6SKcFVt9Bi	2279	3230	3230	1616520600000	orphaned
4401	3NKqo9t2rgU23aVxD4vsk9hRXv8qFSrz7hYEeQ5XcJid4t9pMtZd	4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	1406	1393	40	1	4280	jxCdV8uksoKepcqKBw4rYAW5Sa3b1oKzypGfoWgK3ggjGRcchqD	2281	3232	3232	1616520960000	orphaned
4403	3NKtdsSZgAZdABr9kKhVSdwCLyJN9uYGrhgDohu7XrvrqgrosGjL	4399	3NKmAs9zJqxWy3viTzmKqGdN5N9KuMydVkMdsnFGFYtazo1VyGYq	1672	1285	40	1	4281	jwnDyncDBmqHuLMnCYtJRvP3adQJgZqwBbkmPSAvv9qTgptVJ7w	2282	3233	3233	1616521140000	canonical
4405	3NLXgP8v6F4PJrZo46QyfbrBVkduEVkKJRf3Zbe1mvpKXNiEBRb3	4403	3NKtdsSZgAZdABr9kKhVSdwCLyJN9uYGrhgDohu7XrvrqgrosGjL	1407	1395	40	1	4283	jweAesqoXH3AA4FFnHRVLY6559jmBzxcWYtYG3qVhRygd1uonWV	2283	3234	3234	1616521320000	orphaned
4409	3NLncyrqzUWBgeBbWqkuJnubSKRNMYG7TqirRt2vpxGEs1eaXzrp	4408	3NK5G51T8CfX89Pja6NbJ1mJxmnbjb9hYtjfWTEY7DQvhbbuq5if	1403	824	40	1	4287	jwzUQjESHn7FBHJeF4o1bbeQJMDudwjZTE1oknLob4RgVTJv41S	2285	3236	3236	1616521680000	canonical
4410	3NLaaK4qMDWV1uspsmn3xDHPurRcsL9oTFRshaz8PT59EcvTJzx5	4409	3NLncyrqzUWBgeBbWqkuJnubSKRNMYG7TqirRt2vpxGEs1eaXzrp	1406	1393	40	1	4288	jwd7unLeSD9Ao3UcU2FVE3Dh4gCs81rJfxFPCyPkMuPM1pXtPfj	2286	3237	3237	1616521860000	canonical
4419	3NLf88TAE6rAR4DTQZhfW4VfKs1D3fmN3d3ifrwavmwpnDpPxgsV	4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	1560	1045	41	1	4295	jwdSuArUSbeqiWCxMoieUvFgu4JSdeCHV1koFAvEyAfxudG61Fh	2290	3245	3245	1616523300000	orphaned
4420	3NKeeza7cCoFyfa3EtE4XAiUUDB725AfUu9WPAKMTbBAbA9ergJn	4417	3NK7z3FJsSNhcPiRGxUfYR8ZgA8ZaUXSbxVyvZv1o3tQJY87vVCR	1553	776	41	1	4296	jwwGqhWAJMGGUBD2ysp1sRtymwec3wbt29XqyFH5zJgUZaZWwLd	2291	3246	3246	1616523480000	canonical
4423	3NKce7xZVWWVrPKMTENi4PR28sVPnYk6Zp5tKeYBk5G7WgD8fBYF	4421	3NL4D9tNhX9iBvicf8mouZE97pNStLPnBXTw1U9pwVBT7R2ZpivY	1483	225	41	1	4299	jxySJQiHhwhS1FZmkT754GSp7rWt8g77x2CjxwxAY9zK6Bs6vmg	2293	3249	3249	1616524020000	canonical
4428	3NKjqn1ED1fM92FxGDc1hJxgx8Q6pBq585YnLaiLG6N2CRQ1xESH	4426	3NLp4ST31t9KMU38Wzgf1cEXeQGX917hkncJBurVEs4hDxASoeh4	1513	1133	41	1	4304	jwgkGfDnq1oGcsuScXMLJhVi1HhJLTvkmmzSRsfywgJjkyqX8Dq	2296	3252	3252	1616524560000	canonical
4430	3NKEU9VjjqryTQ16zhFUUqNqcSrhJ8my8RGcL3nbgu8rhTJDzbi8	4428	3NKjqn1ED1fM92FxGDc1hJxgx8Q6pBq585YnLaiLG6N2CRQ1xESH	576	1355	41	1	4306	jxJhRLMbH8ijvQmykHSk5wS8qRXHgAoUUxa97bbEMKf9sVZfH1n	2297	3253	3253	1616524740000	orphaned
4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	4429	3NKdaFWNxVydmzqm1umAq6EhYD312wVxKjnKT2FnNkS7sMeJLVbm	633	1384	41	1	4309	jxR6MhGwjLaXB5ALYvnoWNVwqLMcyYUhyMfYzcbSTQdcNPWyeuZ	2298	3255	3255	1616525100000	canonical
4435	3NKq2cKDuXFQKmCB2ivykVJJtBs8yJkn5zsncBvpP8d2Fthb1xWy	4433	3NK7mLJwE9MsEmNzbdpUmBfmp87oBdkQj37MEFkpVM3PNXybFsUn	1455	1332	41	1	4311	jxnGRvXXKJr9YaxxSBMGQSuWLxPwdrZTS86Lj8YRNK5m1f4TdeL	2299	3257	3257	1616525460000	canonical
4438	3NKUdJGd6FqwajmqkdgtnAV2KejZYqmSh4XdANY8rF5aHFt65N2t	4435	3NKq2cKDuXFQKmCB2ivykVJJtBs8yJkn5zsncBvpP8d2Fthb1xWy	1406	1393	41	1	4314	jx8txJyAbmjJb2znpjZRmwtqfWDWPEvfZKpVnV1YwiMXmRt7JFv	2300	3259	3259	1616525820000	orphaned
4440	3NLiH1VqYwX5bjgqrY2cv2QS57aMyra1R4V3qmxQicMyK5RG6JLe	4439	3NKQGJtHh1uQTLh9KrPHDLwcpnBMGJ8JpLk6by1gsPGqwHBQjmYu	1406	1393	41	1	4316	jwpjCgM2vhGCetpJzmBq5LYph6fDf55TWbgDiu1MdR7eW62haHm	2302	3261	3261	1616526180000	orphaned
4442	3NL32wtcPn6UGK3Wz4ZRht7EsnHUSzLEN8eUF5uZqXh51KmtbR71	4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	1407	1395	41	1	4318	jxENSNeD6nZfCGqBMiWUGk9chTmroSW8CThEoFE5MpNpgYGaWar	2303	3262	3262	1616526360000	orphaned
4447	3NKS6XfoDd4Ra9j79EyAzfdVahTNi2MrbrKJnbHkK8DiQDPWe4Vg	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	1403	824	41	1	4323	jxKNwQEJRGV5HzhNfRPnXfYQybvKfsgSrrmWq9NCyXBQyavJBWx	2304	3263	3263	1616526540000	canonical
4453	3NKFyGzvU6pvqSyiJJRe4Eyy8LbdU1zZEcDDQRcobsxmV9KkBjo7	4452	3NKSsv2dmPrzJwGfFhCrkGmE7V1GgR6oPgf5ULm1xfDPN1cs9ya8	1405	867	41	1	4329	jxtihS5RTLp5A8Mgdc2yQzvnYs6JMA93iuXTDZePZXYeawGgujw	2307	3266	3266	1616527080000	canonical
4459	3NL4eWJ9BCfwqGiyLp1yFSauZcR9MbGWkd3FRc7UHNiVHaH4my8N	4458	3NK9zDyTF4K5o7xCGLbkK4eHJpNBjsmFDw151G82vVRmmcNAebis	1656	977	41	1	4335	jxdSfr2aPFeyWsv64tUPioCkFZrwE1hYcMj55vrBmQv6GBmPGSJ	2311	3271	3271	1616527980000	canonical
4464	3NLRthU8akqHH3jLhKGFFPfcjbmHQv5qbEj2FV5aK4K8NFAgRF7N	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	1400	77	41	1	4340	jw7BgXwr3iB5M62kZiM4HpoC6QirWUAhNQ5sFgvfFHGiipcuEgr	2313	3273	3273	1616528340000	orphaned
4471	3NL1gSf8W1BgUJnDedM8iemWFmjX3pKuYeDM8VLJkMjiCV4NqFnh	4470	3NKAPNvhVayYSYKsHzvv9yFLqBFNQ6xTxDo5YL4hQ1GNLQL7aY3j	1483	201	41	1	4346	jxW6jjvMgfBXuMiXrUcu8WdmhwNYuMaYgU3yyrRqjqZ33w5Q96Z	2317	3279	3279	1616529420000	canonical
8719	3NL7S8wgNKSBGavWgAEFoXJskteieFrzbZj34pu7io6co7cAGXo3	8717	3NKXWg5idUuR89gUEEeXsEmR3FPZFUw6AudvbPjKoScegM13YLLu	1585	1366	103	1	6301	jxsGVfMjKaFRo7hDK6k1QJtuiwQSKCHpnNqEdzWusETFtSLzuTf	4521	6374	6374	1617086520000	canonical
4412	3NLK3Sx6r783qErHVxALeqHv93kZHf1LvQVvxP9hr6T3PKUjrEXn	4410	3NLaaK4qMDWV1uspsmn3xDHPurRcsL9oTFRshaz8PT59EcvTJzx5	1631	794	40	1	4290	jwDDbNXMUchuc6YKehMLTk1rbQ8YgaXZFTmbqC7iX6F4g3eJxb6	2287	3238	3238	1616522040000	canonical
4418	3NL37MH48HzYDdPEKUQsatAELHXb96gj3ArE6c5EC9eT5te7vUbF	4414	3NLBerqpS1s5zp2KpDuVPHLo4q4zASGhmDgDQukGN5rejD6YXEqV	1560	1045	40	1	4295	jxA5oswqVoBbVWVBz8TtScrisAgpENchusTVQmfZNa9G7WTVsqE	2290	3245	3245	1616523300000	orphaned
4422	3NLpWesYcZ8rAv94fMK9Gq5AiXYB65D3zTFxV2jESYfQxMazoZwV	4420	3NKeeza7cCoFyfa3EtE4XAiUUDB725AfUu9WPAKMTbBAbA9ergJn	1617	1162	41	1	4298	jxnnbTqHJAa8m2R3QVDBcY6BauthYYj73YS9vqCtmNeHJYAtjnk	2292	3248	3248	1616523840000	orphaned
4425	3NKqpRbKKLFCKmySPX1srFrG7yWDvkwAPVkXXKk9CEaRw8qt62M6	4423	3NKce7xZVWWVrPKMTENi4PR28sVPnYk6Zp5tKeYBk5G7WgD8fBYF	1652	1315	41	1	4301	jwjRGYGWNR6TQPPdxA6ws8QTU7VTQBqnWR98VhzKXpP4zDudxsV	2294	3250	3250	1616524200000	canonical
4427	3NLpJPKHS8rbqoGiuHstLAmffnUT4fXWkbAM8Aq8cK6UU4yn9NtR	4426	3NLp4ST31t9KMU38Wzgf1cEXeQGX917hkncJBurVEs4hDxASoeh4	1406	1393	41	1	4303	jwY6GsZDRbUYngE3mFEfhfoEnnDWFKtjd4vf4ziXi1NBUCpVyKu	2296	3252	3252	1616524560000	orphaned
4432	3NKgvpVZZN7zQPcjsHvn43LNxhSiPfBUoB2QgQ5wbxfguCApHFZg	4429	3NKdaFWNxVydmzqm1umAq6EhYD312wVxKjnKT2FnNkS7sMeJLVbm	1609	1333	41	1	4308	jxSxRm6Vc7YcEAHqthEKS5JCAq1Znjycq8WdsubNoXEvMW5Gwzh	2298	3255	3255	1616525100000	orphaned
4437	3NL2uoE1NXsi67SLK7rp74LphTgP97ui9xKmKpZp7xZrRMxmEKan	4435	3NKq2cKDuXFQKmCB2ivykVJJtBs8yJkn5zsncBvpP8d2Fthb1xWy	1407	1395	41	1	4313	jw6uD5W8CmaD9wTMFpyiuysB6Bw9e8RxzQp595LCv69yjUUxXsV	2300	3259	3259	1616525820000	canonical
4439	3NKQGJtHh1uQTLh9KrPHDLwcpnBMGJ8JpLk6by1gsPGqwHBQjmYu	4437	3NL2uoE1NXsi67SLK7rp74LphTgP97ui9xKmKpZp7xZrRMxmEKan	1522	1322	41	1	4315	jw8QzJb2BVPArRtVGoT8wDijesrMjrcwsHdUDkzBzGjCk3setS9	2301	3260	3260	1616526000000	canonical
4446	3NLXdVhcKCdRxd2iWqSgeuxhU3RR6YX6XZvfFA8Sebu1Mjgnnhdt	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	369	1066	41	1	4322	jwFb3uP2XXmAegWAasax5yUkW5Hsad9Crm7UjJKeHwnJadhXLTW	2304	3263	3263	1616526540000	orphaned
4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	4453	3NKFyGzvU6pvqSyiJJRe4Eyy8LbdU1zZEcDDQRcobsxmV9KkBjo7	1593	1346	41	1	4330	jx4qXL1S28Q55fwd8TH5yiybAcFzSfpCtAxMmTMXjSPeQwjo5nY	2308	3267	3267	1616527260000	canonical
4457	3NKWW956ykqsMa4nkASPWXd8z3gRprJd3n5BXGqPZeXPphUQuc6B	4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	1585	1366	41	1	4333	jxbTmS7ET4YJYWjrHdYWTU2smQjWLdJMWc11vADdwEqZEaxSdfc	2309	3268	3268	1616527440000	canonical
4455	3NKXmSFLqkz93oTKN7fvu8cu5c5ah6MvdG3NVrRLmpQAUGDRW8mK	4454	3NKDzzgSC2qp7n3zYv8UQXWhL6HunJXaUJdb2YhcsCYNPapXSX9X	1541	1172	41	1	4331	jxvbc4uqWdxqe4dy8SK9tnpvoL1ZRdhnHYjosnNjmStvkRiuwus	2309	3268	3268	1616527440000	orphaned
4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	4459	3NL4eWJ9BCfwqGiyLp1yFSauZcR9MbGWkd3FRc7UHNiVHaH4my8N	1440	1377	41	1	4336	jwFcCUSqfmnEJQVqMzAeAZEWmXWWG9txRVvPz1WGi7zVGodq7Qp	2312	3272	3272	1616528160000	canonical
4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	1481	790	41	1	4341	jwPqNN2SpoBXXjAGvkGcqGdVNSpF5oFYWAgxbV7C1WDLb8cX2MQ	2313	3273	3273	1616528340000	canonical
4462	3NKbGZ2fNckZQSRoXVFpFU1R4Lb4Mp4gYrndDDHLH8d9343tDYz6	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	1522	1076	41	1	4338	jy1LneUytEdgg3RkBGqNuNoPxSEcbFFy5b4gas93skiHLMEP4Fo	2313	3273	3273	1616528340000	orphaned
4468	3NL84rCPjWQkKaETM8xnBG8H2TxTMaCc5oryRtSkwbWUtVasobxV	4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	1608	1163	41	1	4342	jxuaABjNhWDivV4mAyJ6SjPYYVQzxCXZCEaUskVZNJXdFZmUMLx	2314	3274	3274	1616528520000	canonical
4466	3NK8RexP5VG7a2fPQ9LAmYWjBzJC57hUmjL2FYUJCxZjdfrwspwY	4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	1608	1163	41	1	4342	jx2XaJT2jfRbohofLVqAM2M71uHQWUcX6snfCk3qNfnJNSaoyo9	2314	3274	3274	1616528520000	orphaned
4472	3NKwCRF3jVC4xJyofD8DEUDbZXLBpQby3tZjGuJCtYbL6jd2Kstm	4470	3NKAPNvhVayYSYKsHzvv9yFLqBFNQ6xTxDo5YL4hQ1GNLQL7aY3j	1599	1287	41	1	4347	jwhu471EYFmsFYMjDdPzhakS2NPG19isxyxXAs8P7AmZEdtbetw	2317	3279	3279	1616529420000	orphaned
4475	3NLbrhJ7ed1sq4ypCvD9fNb3ExvFXjv5yZMtsWpsJpRtJiXdbVTv	4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	1600	1006	41	1	4350	jwxN7SwkUcY825UVT3iFz7ysMjhuo4CYxyjeVe9NKUjER288pey	2319	3285	3285	1616530500000	orphaned
4477	3NKdHMquzpn3SKAL4bBsYbHF3MyYkR9SH8PraroW1GsaxgKe6H7D	4476	3NKkaYNsAQD4Get25h8eZAtWDCC2MJTxLQ7v5L2c9yCZfBV3rWiA	1403	786	41	1	4352	jwxXpacq29KNLcd1cv6ytW6bsJDoChdAXgKazbwuedy7rE1ckGG	2320	3286	3286	1616530680000	orphaned
4480	3NLJXzxpswVSuGoi3CgHgymXNn2FNNwPUY3ZCaBNXf4yqiNRPzoP	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1474	963	41	1	4355	jwF6uWjxazEBNoz1RtPMeZ81rfWgUX5cyeVGoSP741yibweda2n	2321	3287	3287	1616530860000	canonical
4486	3NLgPKuAkwEgYcprvbN22No5kG5xsDzQfwYvbMmqpNcVosYGhpvP	4485	3NKJAukZbbP76kC8QCRxLvceAus9RHKNPfGRkp9KuUz38t3ETUYS	632	1256	42	1	4359	jx2rhJBmXZsqjq5NQ4D9uKqfjFZvEoGb9RUDTj2rJi96JNkEvj9	2324	3290	3290	1616531400000	orphaned
4491	3NLb2SyZFKHayT7U9ReXuqzXk9hejpB5CeLnX32p7EiEMRL4ocT8	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1403	824	42	1	4364	jwoYXoPS4U2MjU92PtGfKSQeMei5nSAXzYwwCQVSuCYQhYBMyGP	2327	3293	3293	1616531940000	orphaned
4500	3NLsRj7tuoYhLjzSgy258WciBedxwMgCg3X7h1gaXPqtLHpL9zkD	4498	3NKGhjzTjtMgyjTUM1vDuwx7kJhEVUZErdmN12LHU61JsgBABeMn	1406	1393	42	1	4373	jwfUxDCr3wFRhyiUkYbF5ai9iZfysgRJtux5s2zrubUjwpqA8qN	2329	3298	3298	1616532840000	canonical
4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	1657	1344	42	1	4378	jwGA66CSADehM2fCxPwom2sfqrDSEN9X54uvBg897otnRqMKzNr	2332	3302	3302	1616533560000	canonical
4508	3NLVKhXroM8MUqEjTjyaciML9uF6nL5TY2FEiVcZhboeRnP3VVvu	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	1458	1323	42	1	4381	jxuuQ485rPop9xrN7FmGVPzA9vjph11rLcoBGhS88MN8aECEzwV	2333	3303	3303	1616533740000	orphaned
4512	3NKkeybXneGuqmhHH9rJL5hbXym3YBh1ghivzL1UkGjXk6AA33N8	4509	3NL39ESNF7NDe9oWZh9XHuq4X9weAKtYqpz6rg27UfDswwKHsXUu	58	1035	42	1	4385	jwrsaoP23NQ7hZmbLDaUSrbhHxjVnaTtkxEsiZ45cEBnUDUTJEn	2334	3305	3305	1616534100000	canonical
4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	4512	3NKkeybXneGuqmhHH9rJL5hbXym3YBh1ghivzL1UkGjXk6AA33N8	1670	1156	42	1	4387	jwToVWachZd9hWRuApMgPuAAGtqKbckRgHJU6JBgHsssCMy1dSJ	2335	3306	3306	1616534280000	canonical
4519	3NKqLrNQF64u4F98QU5WoY4QKibYVevGjYpkAEVmZPoqbt3Nu2Wh	4518	3NLpR41x2oUxUsrxEtSpv5Ti1MPH54CUcuAu4muGZXsxnbmJaUYJ	1481	790	42	1	4392	jwZT3oNH4CYxFDd8dL2xd9o1siw14dDDc7HXg3ydQpdb881d3cy	2337	3309	3309	1616534820000	canonical
8721	3NLcT3bcGTxULW4SsdbUQQ4VFwitLNZfVXphonTYGnUyHvT8Mtvx	8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	1406	1393	103	1	6301	jxjxQmvErcHGmu445d2GCr98nVry7FTmbuCPyzTatLTbKeFKQWi	4523	6377	6377	1617087060000	orphaned
9848	3NKcCqaVJAMSJpZEqZf37cJiEnDY7JdwLTHavxkJp4xYwPEPtQ7J	9847	3NLqgiYgGFSjmSK26pXoYNNHbrgDzepnV42U2LgXeERMD4Cua1ya	1553	776	128	6301	6355	jwSYqAfWL1hMaA3w3AJwabLqdqBmwWtAmNNA1z5CXHdEe4xNV9n	5105	7184	7184	1617232320000	canonical
4463	3NKAZB3pV2UPFUqc7W4EFV8NEPucHSTuUoKv7qfmrnR3DXwutTcH	4460	3NLbefrfgaRRSaSoQtP9VbYFmmbhAf39Sb9VvXrubDpYsB254iuX	532	1057	41	1	4339	jxgMq1vUsC7okfpye4dUsSqJYqA5uD4nJ1dTQ5YxbskBVtUxTqj	2313	3273	3273	1616528340000	orphaned
4467	3NKzcKgy5XnqAZwVDbfKoscHkDRHEnACj2R2hZQJAVaFV1aTfcjZ	4465	3NLgwAVijiQerwWhHqzAf82mWpe25zD6RH4xjXLY1cXnzo3ybVNR	1529	1316	41	1	4343	jw9G4MzpQot3c1zhTpujNpCE8f7EEwfcj1ZJv7DtJ7vd8nZ28iE	2314	3274	3274	1616528520000	orphaned
4469	3NKzJ2bu8PS8zowbm8J3YBkivYkfhscaLcJqUqiw6bNGSEn4o9kj	4468	3NL84rCPjWQkKaETM8xnBG8H2TxTMaCc5oryRtSkwbWUtVasobxV	1407	1395	41	1	4344	jwSeZGUoFvWGdUdAZ4xdQeg4ExaikbpMY1VdZrZmM5xM5FAjR8q	2315	3276	3276	1616528880000	canonical
4470	3NKAPNvhVayYSYKsHzvv9yFLqBFNQ6xTxDo5YL4hQ1GNLQL7aY3j	4469	3NKzJ2bu8PS8zowbm8J3YBkivYkfhscaLcJqUqiw6bNGSEn4o9kj	1406	1393	41	1	4345	jxjmuKBPTQpZWe8XPa2VxChjcu7GeZKQ5zjmMDY9rknriMyez9e	2316	3277	3277	1616529060000	canonical
4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	4471	3NL1gSf8W1BgUJnDedM8iemWFmjX3pKuYeDM8VLJkMjiCV4NqFnh	1460	958	41	1	4348	jwfFCAo3RQWahmpTFYpmh9gJKuFQZUL6M8bhBc5DWz9WDrfiFDz	2318	3284	3284	1616530320000	canonical
4476	3NKkaYNsAQD4Get25h8eZAtWDCC2MJTxLQ7v5L2c9yCZfBV3rWiA	4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	1631	794	41	1	4351	jwgHG2aTKezzETd8BLJK5k3b2Va6JdpX7kEwiiWUAM9TZwve71y	2319	3285	3285	1616530500000	canonical
4474	3NLDTchbL6vMvAgkCp4VqU4KgGAywSZ2HyP9HMdE2gGgwoDDJRhs	4473	3NKV2mD2C1waVjUFs4ES81TwXPVDRkL4P4Bxqm36HfXv2F9aVJLp	1637	816	41	1	4349	jxxfKA6iprpUSSuQvdWZP9kK9AaaFUi7ZkH96NsrDuYsHmwV52D	2319	3285	3285	1616530500000	orphaned
4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	4476	3NKkaYNsAQD4Get25h8eZAtWDCC2MJTxLQ7v5L2c9yCZfBV3rWiA	1590	934	41	1	4353	jwbQqPwJTEDyn5CQVDubrPRbUUkhJzkNRoH56YnoTY7kLGoToYM	2320	3286	3286	1616530680000	canonical
4484	3NLtEGhwN51o4hvif3Svm2ocDY8ynXR9qL5SuRqfsgt8ugcnyQFo	4480	3NLJXzxpswVSuGoi3CgHgymXNn2FNNwPUY3ZCaBNXf4yqiNRPzoP	1588	1146	42	1	4357	jwsengXRfX3Tv3NCwtMVqkFAVuKu2Kv2Eatdriv34MmzWt9e5zA	2322	3288	3288	1616531040000	canonical
4483	3NKiihY6DiJhdTpEMidmeukFrjtN9x22Z9YSNYV8yz1Gt1Yzptmj	4480	3NLJXzxpswVSuGoi3CgHgymXNn2FNNwPUY3ZCaBNXf4yqiNRPzoP	1405	855	42	1	4356	jx6BKvsZJzHZjNJBjXULNZm4TzXkgb3biCyHWQnUzrTMjCvcEWa	2322	3288	3288	1616531040000	orphaned
4485	3NKJAukZbbP76kC8QCRxLvceAus9RHKNPfGRkp9KuUz38t3ETUYS	4484	3NLtEGhwN51o4hvif3Svm2ocDY8ynXR9qL5SuRqfsgt8ugcnyQFo	1673	1368	42	1	4358	jxjwW6iHH4nSDzn2o3fKvPhZcC44kwhKehvYVYDGvnz6SSZ1mKF	2323	3289	3289	1616531220000	canonical
4487	3NLAS6FjefhkL1vCNCMhYeJTjmcfqovvxDWHirfWfFQp6QS4aEsn	4485	3NKJAukZbbP76kC8QCRxLvceAus9RHKNPfGRkp9KuUz38t3ETUYS	1647	1302	42	1	4360	jx6kcXWefyPq9QKKWLVURX9iJu5ctDs51XYnUX9kUYV7Xnh4yKb	2324	3290	3290	1616531400000	canonical
4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	4487	3NLAS6FjefhkL1vCNCMhYeJTjmcfqovvxDWHirfWfFQp6QS4aEsn	1407	1395	42	1	4361	jxZRcAsNR4TcEyCZJpvhhfC7wYV6TTeGD3chmnvQhDT81Fh1hpB	2325	3291	3291	1616531580000	canonical
4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	596	1060	42	1	4362	jwdyw3r6DZVco37j6ThLiaHbPgi2EunGtLoYXyVituza5W9JPvB	2326	3292	3292	1616531760000	canonical
4490	3NLN3UcFeWdWNWwx4pEwD5f9ndyXmWBr99ytg6J1BdhiPqhr2yZN	4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	1631	794	42	1	4363	jxNkn9dS4ZAvHGD9kM4feSFGZzEZjtqr9PGgaSnNExFpW4EKMG7	2326	3292	3292	1616531760000	orphaned
4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1647	845	42	1	4367	jwCNkED9uizr3E9zdka9FtmazJkF6HfquokCRbn524hfYb4DEkQ	2327	3293	3293	1616531940000	canonical
4492	3NKuhsBRCTfp6jy9YVHUkDEcjPRz4SLG4Nt2UNJdCeEYTF9zhwWL	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1406	1393	42	1	4365	jxPm1qEHJ1HfJEB84CoujBYPFKWgwE1gsnKv5p7uswGicE1KmEb	2327	3293	3293	1616531940000	orphaned
4495	3NLv6fh6MXpR167DfMSjJKNMHtdDMbzGqAjWUwg84nDGNyfLcWoX	4489	3NLxw31VNEYyHRqenJ9gQUdBDapiLRQeBJpDM4vcg4tXeb5SDJCn	1652	1069	42	1	4368	jxwJ2qGKUixrbrfDf4yHfFKrL1Nt7vMYgAPXyeFGWkNj2JAGJB1	2327	3293	3293	1616531940000	orphaned
4498	3NKGhjzTjtMgyjTUM1vDuwx7kJhEVUZErdmN12LHU61JsgBABeMn	4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	1675	1216	42	1	4371	jxzsTJj7aw4x36Vzouvv4dcstKQVkPD7qAjnbMahyx5iPqmbCAm	2328	3295	3295	1616532300000	canonical
4496	3NLRq6xz2ubX4QYsLb39VSXD3EyZGJ9AaSQsXVGMCXSpqoJCDbKr	4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	1460	1078	42	1	4369	jxBbTaLcyqFgNKPgwQ7HGD4U8Qs8X96cSyTtdhH2QNFYBYDfNeA	2328	3295	3295	1616532300000	orphaned
4501	3NLum3jonKw3pfuJ3beqtio8vrAJuF5jk6c2GHQ2kytu47hbpuno	4500	3NLsRj7tuoYhLjzSgy258WciBedxwMgCg3X7h1gaXPqtLHpL9zkD	1637	816	42	1	4374	jwCm8fiSxdhB73r5F6QaZi8diUMFtZQDQHgbAQtvyqsBNLEJy4z	2330	3299	3299	1616533020000	canonical
4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	4501	3NLum3jonKw3pfuJ3beqtio8vrAJuF5jk6c2GHQ2kytu47hbpuno	1406	1393	42	1	4375	jxYt5Z3L6uU11R1JgiLxwCqGFx7XPboJUtzPswS4N9M8iPG3F3M	2331	3301	3301	1616533380000	canonical
4506	3NKuRPsaQgX9VLQou18FTxhZ7Qo6R1rEZuBSkH5v148j1ukQHCcm	4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	1631	794	42	1	4379	jwAy16jHUKejYGtyrrrd9VuEg8RPWxoAVoYkaKVnLgbbTEhfkS5	2332	3302	3302	1616533560000	orphaned
4504	3NKREDZtkzxAAFGcJoZMN6htC4ULsWsQYzAXQWB6ujAw7vLuMUf8	4502	3NLBVwawqJ3AqaYymauFRBRLEJ9WQGHmipmf2hUdGGenpd5ACkib	1460	1324	42	1	4377	jxJD5f3C1SfYA2h6YwkwFZWVumyqgwfojCYhanowteEvPFS5PW5	2332	3302	3302	1616533560000	orphaned
4513	3NLhvUUvAwyiU5pMq1jBbtP5SDLvjacroLgDzFjpJP523ynsi9Cm	4509	3NL39ESNF7NDe9oWZh9XHuq4X9weAKtYqpz6rg27UfDswwKHsXUu	606	1049	42	1	4386	jx2RjFLJm1pLtmcWArdVMLswtyVUmf1g6CKhHSHRNoJbbpvpBf4	2334	3305	3305	1616534100000	orphaned
4515	3NLFpM4fUHEWPErT5n85fZMgWVeopo4HhhboSQRDAVQbgVCLAu8X	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1406	1393	42	1	4388	jxZKZxegDh5Y7FQMCyrKQQzd8YK9nn3YSTAmiwgjDfwXR6axFS7	2336	3307	3307	1616534460000	orphaned
4517	3NKwho2JqkW9T7BGXqNBM2fYUNv4rpi6q8gU8RLcFp5HqcPi8aXA	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1529	1316	42	1	4390	jwyE1L1fHu7kmaW42MNFP9AND9aZW159Ap1VD5M3Na1JQHzoukA	2336	3307	3307	1616534460000	orphaned
4520	3NLKeqiJqop65LRP4KeJr3h5fjddoX9RTfF92kmFpjoVL2hsdjZU	4519	3NKqLrNQF64u4F98QU5WoY4QKibYVevGjYpkAEVmZPoqbt3Nu2Wh	1513	1133	42	1	4393	jwf5HNKW3hDMxQirDqV3Lo9vPCFxKPGQFiBd4f84x55nWL6S5xC	2338	3310	3310	1616535000000	canonical
8750	3NLTWpghAPmCoMKJEUJXv4phFCD77EGrd9QhbY5VFkwsqwn1HPQ3	8748	3NL4uf8tyj3HEYYZgmzCXTLNLyYiAfP8aD9tvJrVAXNn7oAr7q4E	1631	794	104	1	6301	jxBArAupZcT33vD9nszEfXkk2MrwCWMDrz3S6vm7HNcjSRyfYB3	4541	6401	6401	1617091380000	orphaned
4511	3NKf5jj4HFuamcUKATC9dqEMLvtdTmKDZYYf8jMgxme34iAvdgBM	4445	3NLvAaDganveAuzx4ntTtPsN1nGWi8JdixzLgxtr1peqroJ4dWLo	1613	1223	41	1	4384	jxBRawLmzrnayZa2ia4wbXQK9rvbxsjJqpxEjYukPjYPRE6GLmn	2305	3303	3303	1616533740000	orphaned
4533	3NKxkH98m8cc8NmZLdpaxTXWTeBinnMJ17o9nSfKsiWp9VBdnQ6h	4511	3NKf5jj4HFuamcUKATC9dqEMLvtdTmKDZYYf8jMgxme34iAvdgBM	1613	1223	41	1	4405	jxpMXGggeLexRmWwF6oZn2S2K6qcMJEHueva2FTwf2ofbFaJKn8	2306	3316	3316	1616536080000	orphaned
4499	3NKSqpixU6qoV9q8g1N2QASsizH3NQBJHbHw5J2vf49BBACiF2np	4488	3NLqZC3dqpqUdedK1niydic9aNixUhqiXijcjWEhxGnWvTBGFSeT	1675	1216	42	1	4372	jxqUx8NUdrJdMsotbp19sHyLkW8Vc1grFX31BZvr6ZJKSZ6f5kZ	2326	3295	3295	1616532300000	orphaned
4497	3NL6G18TUdA8vdshxQU4JQoLM7b2uyh7VG9tkatT3r3ZrJQaEctN	4494	3NLhkXNwj98HEc1BAoWikHykU4E3ZExsKyvgHQbTTbk6SmPWYCA2	1476	1371	42	1	4370	jx5zsjHFmf3ifwCRQLbL3qPBCUss9sppEB1YGJFH6fvF3jNWLx5	2328	3295	3295	1616532300000	orphaned
4503	3NKCnsLhTQ2gha7i6JigSNhYFBN813JavqaXaksK5kFEs79vHwdH	4501	3NLum3jonKw3pfuJ3beqtio8vrAJuF5jk6c2GHQ2kytu47hbpuno	1553	776	42	1	4376	jwEGbi56uHMmqzFgWTt2TEcUtzM9TCjSHrRichcMDrgXiBqxBBr	2331	3301	3301	1616533380000	orphaned
4509	3NL39ESNF7NDe9oWZh9XHuq4X9weAKtYqpz6rg27UfDswwKHsXUu	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	80	1027	42	1	4382	jxcLmUPE3sgivJzP7YrUyzpypMWPyaJkk7ExrbEgLzKXLRFFdxb	2333	3303	3303	1616533740000	canonical
4507	3NL3zLvbCzo2ffuiPo4HwRHAQkANqk6drrvHG1cUMWLkE4jNwnkZ	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	1407	1395	42	1	4380	jx2V6x2bD4Lu6F83PS873kWR4S39o8PavQHssMXv73NczvPWkXG	2333	3303	3303	1616533740000	orphaned
4518	3NLpR41x2oUxUsrxEtSpv5Ti1MPH54CUcuAu4muGZXsxnbmJaUYJ	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1631	794	42	1	4391	jxrrx8gW58zGBQuw4cMJ8KdoHT3WsijAaRA8sXtzrkDghqMWXUM	2336	3307	3307	1616534460000	canonical
4521	3NLJpNsjUEhJTND1eHHwdz3Z71MAL3fMpehNtMbEtJeqWvLQ5vER	4520	3NLKeqiJqop65LRP4KeJr3h5fjddoX9RTfF92kmFpjoVL2hsdjZU	1471	1260	42	1	4394	jxCogx78Y5trydWfMXC9smAKiUtuJ3on4byJbpQgK2JMa6QZ6Pc	2339	3311	3311	1616535180000	canonical
4523	3NLA4nJ5P5f6hWzmxzuFDA2h2kZn5Yx2atgZ22td5W77948XxB1Y	4521	3NLJpNsjUEhJTND1eHHwdz3Z71MAL3fMpehNtMbEtJeqWvLQ5vER	1651	1301	42	1	4395	jwjTbeFQc2Ff4xgx9wxua6YGV5MgHapXuJf44Rp5Pvq1HNzMr3u	2340	3312	3312	1616535360000	canonical
4522	3NKUjMsLToRwkBytVKj5Ev7Cjtm8GvH9FDxHB6SHGLxLubatfSwV	4521	3NLJpNsjUEhJTND1eHHwdz3Z71MAL3fMpehNtMbEtJeqWvLQ5vER	1651	1301	42	1	4395	jwSc5dK5UdrrC7PvrRpYKYBUsaMnDou65fHKsrj68hpUPXg4CbW	2340	3312	3312	1616535360000	orphaned
4524	3NKjbEjGkKJ4yT4GK97iWmKWHem56ZvZGABAhDa8beeySGvvf5YY	4523	3NLA4nJ5P5f6hWzmxzuFDA2h2kZn5Yx2atgZ22td5W77948XxB1Y	470	1309	42	1	4396	jxHjBhmtEphCDiehZ1EpAdW8TD3W9dwDpqeZpngsFsViqu5jQVM	2341	3313	3313	1616535540000	canonical
4525	3NKhM5MH44rRytKYTRERsvgbry9jdcHdXi1BSbrDo3P6ZXc3ihax	4523	3NLA4nJ5P5f6hWzmxzuFDA2h2kZn5Yx2atgZ22td5W77948XxB1Y	1631	794	42	1	4397	jxe3rfLztienoe5S5WS2vyXtUBUwq6rhgu1MpGuBhAzG1w3Lo66	2341	3313	3313	1616535540000	orphaned
4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	4524	3NKjbEjGkKJ4yT4GK97iWmKWHem56ZvZGABAhDa8beeySGvvf5YY	1553	776	42	1	4399	jxpyuW5nfjuo28MdttPLvj41xWnKauWZvPs8HkZB1nWMicifyFM	2342	3314	3314	1616535720000	canonical
4526	3NKFR5C4CL6WT7iAfjc7spfJGXJTLqcfFq4ZuazfSSBMMSiiXdN7	4524	3NKjbEjGkKJ4yT4GK97iWmKWHem56ZvZGABAhDa8beeySGvvf5YY	596	1306	42	1	4398	jxSK6aqJH65SXdPnK4RBzimuC8HRvUdn8Dwr8aPmW88FrnsjvMD	2342	3314	3314	1616535720000	orphaned
4530	3NKz7rQsCVJrJzxRZapDLbDh4qABgWxxVKjgK3VJFf899GXPnCKi	4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	1507	1154	42	1	4402	jxCK8VcNUaeLWQr8AAsHjL8TJ6HDhNfeoyWNYGadf2UA8hLRPTg	2343	3315	3315	1616535900000	canonical
4528	3NKt6av7CZNQ89e9EjGpAozZFvmRnSUrVVag3m6cpTuxDNfJD87C	4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	1534	951	42	1	4400	jwi1c42Lz3FJ6u5cQpT2YDbkWeHdTfCV6sBYZvPu1apww9tqdD1	2343	3315	3315	1616535900000	orphaned
4532	3NKq5jDTC6qTwuj6QH8zfEQak9ytLtXo2FhypspwXmZu5b9tqxdJ	4530	3NKz7rQsCVJrJzxRZapDLbDh4qABgWxxVKjgK3VJFf899GXPnCKi	1613	1223	42	1	4404	jwnmh1PNxNk9v3CruTLx7QH4TYdF9PK1pMGdJrXYDkQ2CAjVF5P	2344	3316	3316	1616536080000	canonical
4531	3NK5Fp3f2iCiL6qorAq2TMninXsZ4bGFVBoA8EZagQV6VnqrgkyM	4530	3NKz7rQsCVJrJzxRZapDLbDh4qABgWxxVKjgK3VJFf899GXPnCKi	1619	1275	42	1	4403	jxnRegrUH6PtyUMUbwKCyvmVWG3ho4N8hJLq2SMtyjaEDFvHjAW	2344	3316	3316	1616536080000	orphaned
4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	4532	3NKq5jDTC6qTwuj6QH8zfEQak9ytLtXo2FhypspwXmZu5b9tqxdJ	1407	1395	42	1	4406	jxUpopTRwwsJe7F4N8PGyDcugHpxoz6qT9NjYo5srxRAMkZNA9L	2345	3317	3317	1616536260000	canonical
4535	3NKENGjtdpZxstcbuBCVwzT2sTD6rbhYLUVV7GBfwjpDKv2dNEUJ	4532	3NKq5jDTC6qTwuj6QH8zfEQak9ytLtXo2FhypspwXmZu5b9tqxdJ	1647	846	42	1	4407	jwdpfBokdQZ8Zes7R8hKHa6wnW74uneYPcAfBHd3MGom3KZuNeT	2345	3317	3317	1616536260000	orphaned
4538	3NK5hGDqfacK91bFogkvZsAwMhXJJWL4iLr1a1ySHTps6bU8KaEY	4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	1406	1393	42	1	4410	jxpyPKAnk7MeaX18WKMtB3zhjzbmmpMYMrbtYGuo5cFuDZ1dS54	2346	3318	3318	1616536440000	canonical
4536	3NKR9gJBMuBheeuzXdmLQj2ijMNNL4uYrcZou6q4Z8oTXcteTxaH	4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	1407	1395	42	1	4408	jxrQYuf4CNzVmxnNnuLJVnBZSzjEehT4Lh2av3CSLM4tnSs7F5o	2346	3318	3318	1616536440000	orphaned
4537	3NKthtNErzzbnHLdChso8hxgVPaZwELtk9y27cw4MLo1masG2imM	4534	3NKZxZofRYtsRbqqUFT3dgugUA5w8PXimhHKFajLMtPtJnyQdQ4H	1448	945	42	1	4409	jw9CKTQmmqGQc4ZskJ1sxgQ4MCA45b2hBsexgYQmS6btKwjBXaa	2346	3318	3318	1616536440000	orphaned
4539	3NLQt7LixoJiKqbsdUnBRG3WGnRteZuMu3tVsVozQXXMXBDwwP9r	4538	3NK5hGDqfacK91bFogkvZsAwMhXJJWL4iLr1a1ySHTps6bU8KaEY	1403	824	42	1	4411	jxHtLL8eBxFkYhS2G8sJdGQeARrZDY3HhRow7bF7VAsMPRcqBkT	2347	3319	3319	1616536620000	canonical
4544	3NKRb25ov1hUKkTZphsj6hezesEXigWiBZ5vJgMCBVdft2eXNiqr	4543	3NKRaZqrL1uAYHAPYui5HvirPMkS8P1qWHsMsEC5f12rfDAnLK3L	1578	1170	42	1	4416	jwxurxWskQZwh5bhz8DsudHmJgVRK5dnuGUsQyfkEdvLhA5VvMo	2351	3324	3324	1616537520000	canonical
4545	3NLxw58848rpaEDk5vrr3vrAS4qp4XyF6SjLNFVsPVgraZGQcJP8	4544	3NKRb25ov1hUKkTZphsj6hezesEXigWiBZ5vJgMCBVdft2eXNiqr	1647	936	42	1	4417	jwnjYT2aXgTMBpQGHMiSbCdcAwPfjNhyRrVp3W9NdqjqXonpfHD	2352	3326	3326	1616537880000	canonical
4547	3NKsCjnwX3hxwk8vd1tqQBLTYSdWKrMfMgJCyyXxWgroMnteYGKM	4545	3NLxw58848rpaEDk5vrr3vrAS4qp4XyF6SjLNFVsPVgraZGQcJP8	1652	1315	42	1	4419	jx9UGLwMvaUkLJAUbmrFFRfXCukCRyKTZfnuiRxc8jV2fCTCW37	2353	3327	3327	1616538060000	canonical
4555	3NLeF3ttvLBYefo1xFG3P8T9eAjxb37aU6rFcYUEPczb84r7W19g	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1587	1357	42	1	4427	jxHqugaqoKgbm5n7XuqAP7Upv41mTf8ZpoKUs7MT2n9mRorSL9z	2356	3333	3333	1616539140000	orphaned
8752	3NKtDKzwALTYgcJ1o3SSCKzf1Qxi8dowEdhg88fhBKGmdSfgXvm6	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	1407	1395	104	1	6301	jxZLMShFsk9WQJJembRXGYnadpHfwbdKAfhV2a79UoBtJyXdiUY	4542	6402	6402	1617091560000	orphaned
4546	3NKbVfzQ9b2kHW2cMnTvPUvfWrBv7VGgtKXEgHUdYmXG6TAvbbVB	4493	3NKpAXkFX3aYCCz1VqfQ7TXkx9K3Di4S9t3odoJV4td4K6wv2XDj	1652	1315	38	1	4418	jwxn3a9yhMDAqojLgsmzkVcEbHwxQ6ovjpTxTWCRhPCWVkUTVKu	2243	3327	3327	1616538060000	orphaned
4540	3NKWEewj3HYvxfdraMMGKtKtKx3juvoXZ2be5SmMPUZ4q8HJqW5q	4539	3NLQt7LixoJiKqbsdUnBRG3WGnRteZuMu3tVsVozQXXMXBDwwP9r	1471	151	42	1	4412	jw9d39CxbnYfF4mxqbpJUEDcBELMMPvRoBSdvjNNNWpRWAekaXi	2348	3320	3320	1616536800000	canonical
4543	3NKRaZqrL1uAYHAPYui5HvirPMkS8P1qWHsMsEC5f12rfDAnLK3L	4541	3NLuYpWmYwGVUwLBH7Ld6U8LXFZ5wAyyZ8ACbKzCcyhYmLc3eoFV	684	1106	42	1	4415	jwL72sGVHMydi3yAAp4sfCobiGiPn2QrJvAjr3JbkUZVAh9uaRo	2350	3323	3323	1616537340000	canonical
4559	3NLnt4zMEA1jkVGpvhCTH9z6noK5LqRT9H1sikkqFZkzEQ1Jecmv	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1587	1357	43	1	4429	jwzRn3khM6gen4NS84B99W9EjJveU7M2aRoBHW4sR7xizUFsLYb	2357	3333	3333	1616539185310	orphaned
4563	3NKNdCksDUAA9Gx9HkiTtWntCzeV32osvfawrMfFzGcrkcYpZJAx	4562	3NLK8RELzD27dFrHeimayKN2gYijQ4fJ6nfWhj4y5D5oBDGGdPj7	1581	778	43	1	4433	jxTRYWF25wMDEnW1CRXqnTVhXSdQxjuY8CepyxzjCCos4BozoA9	2359	3335	3335	1616539500000	canonical
4566	3NLGJsf1mFhQSeQJqn9NTrquJXWR3Wc1jJocgxzUREEa2ixZJ6MY	4564	3NKWPKyE7ptFHjcxSqF9qdLQZGQqymDmroiyvcBu73mT9uqCjDDE	1610	1314	43	1	4435	jxtec4izZ6oSZvKGusgnxhcAVsLjsFTkm5qBUUj9Q66EKuQzdAs	2361	3338	3338	1616540040000	canonical
4568	3NLaWLB8LvjiBWhuQL1hDWzopReESczFdzZZr2EwbsLoevycRApa	4567	3NKoDpMSsj6eDUgXcPcC1QoYK2F1wAEMNji58k5sFiRcNPmpAyEz	1553	776	43	1	4437	jx37TDCJe9ubxcf89S5DyimfsXN2x2MCFnY9eeiQgJodE2v4zaL	2363	3340	3340	1616540400000	canonical
4573	3NLbX5ErG8uh4LU2zYNFDNPPvyfz6jyHKPHJWc1UTFQjCuBExpEo	4572	3NKeqK7twLGBmFug7xzQpjRpNqEFir7SeTnsh73QugqCUfA7dgFX	1407	1395	43	1	4442	jxTscNGGyTRi91YCsRs27fmPH1KyCfs2pyz6vqTr6yH7kkDU1CJ	2366	3344	3344	1616541120000	canonical
4576	3NLPTG9URNaCauTJkz24fx6S1zPMkyv2ThNiYztSYadFfnsznJiY	4574	3NK8o16AcXns2oy8UGggmi8BFHbJn3iyidCmMWxjhzPuNtkfZNMu	1407	1395	43	1	4445	jxrXrGKvovQcxqzsGcYVLZ9sy7cQiJnz6cPwNf67MDaSeb1hqxi	2368	3347	3347	1616541660000	orphaned
4578	3NLYDEreu4RLKLQj1nHYkLoYfjmKbUxVaLybEjzGYmmA9kd4c2Eb	4577	3NKvC2uYQqTyW4C5zmq9uMdqaCiVugwCeX1N8XHiNX2k6LKhWACw	1599	1287	43	1	4447	jxYYzPm3oo41JW2bXixb5uSNnuyQrSkPFHJhCLo2MdZrxwD9BAD	2369	3348	3348	1616541840000	orphaned
4581	3NLJ8NUhHHUPpusmdE7eqFBDqLyJSFxh4twuPWsTCkHm8rSP2uoK	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1406	1393	43	1	4450	jy1YkpuZxDkU2afUip1B8B4SXTLMeq8Nm9Bs4GcFdHWtEo7pG9f	2370	3349	3349	1616542020000	orphaned
4586	3NKdfZxFS2rbptgWxgjKDWgVY6uSahVUbQq3nkDYq33VdBrVdvVm	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	1406	1393	43	1	4455	jxF3UaqRHumvXjfnz4dfsS7gPrCrV7kCnRd5tHwadWgLaWQJyxX	2372	3354	3354	1616542920000	orphaned
4602	3NL73MfuTenugjLC6WVgHNDne8RVZTeezZ4XXvVBb8xMG4FHQaqD	4601	3NLMJR2QHdBAAEe6dN1YciS91BwJkiuK7KBYWq9tacLFsaycncFe	1406	1393	43	1	4471	jwXHtU1UrFyvURZPtaFndbTxHPezFUuCknggWBvF2qr9sSVg8dG	2382	3372	3372	1616546160000	canonical
4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	4609	3NLg4okTYmRJs7mGTvbZkJQpLL5EkjS6ynjT6ohLg1CstNejWn8p	1650	1249	43	1	4479	jwoQyAYeFEcymdp5DS2m86Mf2Jvywuevnrr6rsJQVs43m9nELNY	2387	3378	3378	1616547240000	canonical
4614	3NLRwQx1Edr1iKym5htL7ungFycxDrSExNbPJ7ab85UamYytovfm	4613	3NKC5DjoETeFCmj8mNM2PhddpasXGwgqaV32gwwL8vmXCiB1cgvn	1407	1395	43	1	4483	jxSSpfYN7V2eThTeLqW3r6CTSFGBxnUFfb2hbfiSXZhhMKArX8s	2389	3380	3380	1616547600000	canonical
4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	1601	1022	44	1	4490	jx9TCLJnkSfk6nE1wGRiwryBMYJcmW8PF7yhP9fYdrJSPE3zHy6	2392	3383	3383	1616548140000	orphaned
4623	3NLHiRjngd8X67uPYWnnJf2AiLnzud6T4SEfbzQgc9KdLEmeqmt4	4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	1589	1040	44	1	4492	jwUo8LyXwzpK2K3HuP2ikCMBdHyBAcp9V2znrHZiDo5iyaEkJDB	2393	3384	3384	1616548320000	orphaned
4625	3NLiTaurLaX6CCgrvz8GJZnUTpwKXvdyi4F7hMq7r1b7aWuAdAoF	4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	484	1073	44	1	4494	jxb8LJvuZMaBVdXyFdY2CKKLYgjLGAYyr8u515mAMW5DaLhvFrN	2393	3384	3384	1616548320000	orphaned
4628	3NLqZJnBxgmj4NmmRJibNFZFjqfEB5bfJGNuxWgrmBwM5LbG1uEN	4626	3NKnbvTkCLSuHhfd3b49v7kexs2uQxNjd1Gk9sfFVyWHH7GhL6xV	1407	1395	44	1	4497	jwNtvyEtqr9zMFAy3rqGpWHMg2hpCpv8yeMyzdrEsVDVbyL9WGm	2394	3387	3387	1616548860000	canonical
4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	1671	999	44	1	4502	jwR6YbURT4aubraqRTcQpDdmeze15YNyTFJHNM8VSJGDgwch8ze	2396	3389	3389	1616549220000	canonical
4631	3NLidPZJFRQtRcRvBRkHnQTCqk7s9eoVQcwzpckSpvVoJc3kG5ia	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	1406	1393	44	1	4500	jwf5kpmij77tUnYeykHUMBbuhMYyu3Fp6pwFyJiYzP5KGTjv9KB	2396	3389	3389	1616549220000	orphaned
4635	3NL1TPQpqKPyzhdyc2LBPbetTLk3VdMfGyFzq8NxCaR1pWbuwfr8	4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	596	1060	44	1	4504	jxZMyRs9fTf38xzyGNNhB2cgc57PXPM5JstpwbHZKZbte6N9rPT	2397	3390	3390	1616549400000	orphaned
4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	4634	3NL7HpgkKtN1K1JAhwouyAwK1o3GUiVzcNroHznfRa1JaC4LBWgi	1578	1296	44	1	4506	jwKndUJY9EwuhMJ6cf2dxQeaoERiuLqUEgkSPG2JPLH1fjihxva	2398	3392	3392	1616549760000	canonical
4640	3NL9wtmXst6NuysXGAkdRVBYQMkVVi2G3bRf4bMGuEdhMJLWkchy	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1523	1195	44	1	4507	jxQCzT3pLEij1GTW5YU2D1UTWVdCJFvwVSrcaEd8kFHRFsrTntd	2399	3393	3393	1616549940000	orphaned
4648	3NKSgVs3YL5tcWHvDhTbgCT3s1cvmA8CEW8VA3MJQsPv11fZVqAj	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1419	814	44	1	4515	jxwDumxgmtqQhsG82zfXRwfaHq1zj3uhutFkdkqKCRmRz3K2Xet	2401	3395	3395	1616550300000	orphaned
4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	4650	3NLu5KfGr6phEFrhsTa3fxRkYZXWyqrUfuAziTmPyTVfs7zKePg6	1553	775	44	1	4518	jwkmXVr55Ekoeo6JryHn1sygLzSgfFtAGzDjRcBUNNHah7MkGU2	2403	3399	3399	1616551020000	canonical
4654	3NKwApXTPZi8V4mtbn22ycijFLQyBqnjA6Gh44WPAtqXfg9msbCU	4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	632	1382	44	1	4521	jxwcZwttaM6GpJqnmCTJLn9kLNZEtFR9KrqKJc7NnwVHpDrPAJk	2404	3400	3400	1616551200000	orphaned
4656	3NK8nKxB1iD9FxL8Awg3vHmNb24hxaJ45jefLCDAnmmU5Qzrq6QG	4655	3NLZy6Q4sRvwcuuWwH7Wvrki7Qk5yNVKd3e4KSLvFEnDE8uTqbRB	1501	1114	44	1	4523	jxx6EYn4d8SNcRtHbohmbsqAxsePwB6VKUvJMLnRtMmvPouyJze	2406	3402	3402	1616551560000	canonical
4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	4658	3NLnQAZFV3WM5TVe89YSsrxdFE29Nc7GnFDDxA3Jd8ihcCc8SCp7	1587	1357	44	1	4526	jx6eVuK8PKscKxZ6J2947zgRLgjoyEwZoPmyqxrGMZ7sr2KjXTJ	2409	3405	3405	1616552100000	canonical
8759	3NKaFZtCy39eZuMhtBkS49zveRMTjXw7FKnJRgPfSu7QcjvJkG4p	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1637	816	104	1	6301	jwkixVgQB1tEpyUgtaVp2FKDu7SHXrGBdvmUwfj4YcJYk4ezs4y	4545	6405	6405	1617092100000	orphaned
4674	3NLA9361biNfnYoLrUpDa4nZimUowiB3zPfdbSSVBZw6hB5dqcoZ	4486	3NLgPKuAkwEgYcprvbN22No5kG5xsDzQfwYvbMmqpNcVosYGhpvP	1607	265	42	1	4540	jxSTfMNdF4tZemquqJi7TfqUpMoaAPcSWNAisxqB45KM7Zb42p1	2325	3412	3412	1616553360000	orphaned
4541	3NLuYpWmYwGVUwLBH7Ld6U8LXFZ5wAyyZ8ACbKzCcyhYmLc3eoFV	4540	3NKWEewj3HYvxfdraMMGKtKtKx3juvoXZ2be5SmMPUZ4q8HJqW5q	1564	1338	42	1	4413	jxtCtvB11UzPfwfnSteAW7A1xNXtaT7URpwyB5CZUWaAoKWAvFh	2349	3321	3321	1616536980000	canonical
4549	3NKzKALRn5HYxXS5h42QM5qa3tJMyj1scvQVcMiEMBoxZak19bgW	4548	3NLZTNNtQjETgu9J7KP7DoxbypcRPKe8eo6g4jXc1XhUc7n8C6qH	1642	1121	42	1	4421	jwvyTuGgZwLFg9KxDTpvb6hM15CJUiUqecboAtMsScWjimURmEg	2355	3329	3329	1616538420000	orphaned
4554	3NLGNQhLpvvv7Fiio3kt52KG2qTadfD4qniXiaYSTebq44BCs3V1	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1503	1151	43	1	4426	jwJfPpgt9qLy6EJy5R421KgU5dwXLU7fnnJp5Xu4HUkxARX27qc	2357	3333	3333	1616539140000	orphaned
4562	3NLK8RELzD27dFrHeimayKN2gYijQ4fJ6nfWhj4y5D5oBDGGdPj7	4557	3NLTh698YsM8dg9KAqrYjo9Wbs4i9Jv2nSf8pxJ4VmfaeS1GHs6Q	1493	614	43	1	4432	jwEPBUJjd4tRf2QYzvRbE4gTWtgVUg9dTKBEGDrMY1utMgZxtSL	2358	3334	3334	1616539320000	canonical
4565	3NKL3YQKo5HXjbx5kUavz3faaZp8bZHHa5FQK8CvrYcFwQymmpcA	4564	3NKWPKyE7ptFHjcxSqF9qdLQZGQqymDmroiyvcBu73mT9uqCjDDE	1610	1314	43	1	4435	jwf3eGVD9r4UNb3enmeAQrPGTrDqifAZhCEd2jD2EabyJwmbYQh	2361	3338	3338	1616540040000	orphaned
4567	3NKoDpMSsj6eDUgXcPcC1QoYK2F1wAEMNji58k5sFiRcNPmpAyEz	4566	3NLGJsf1mFhQSeQJqn9NTrquJXWR3Wc1jJocgxzUREEa2ixZJ6MY	1406	1393	43	1	4436	jxE5yEiCRedazyvvQdmaVWj7g84H1VrTXSugJahJ4dwF51yFr1e	2362	3339	3339	1616540220000	canonical
4570	3NKfJDNNmDBm2TfeMTnWeQgcyQyZuYmCyVvWALBv8MjmkxtDth5F	4568	3NLaWLB8LvjiBWhuQL1hDWzopReESczFdzZZr2EwbsLoevycRApa	641	1336	43	1	4439	jwt8Zd3zmPDmrJGB91yKSAX8GogNFK712hZjrRA1BbH2VQtfRib	2364	3341	3341	1616540580000	canonical
4575	3NLtSbJsperrdHyjN11H2V3y6xcbnMhT6bUaLDFkzSkTrpXeKK4z	4573	3NLbX5ErG8uh4LU2zYNFDNPPvyfz6jyHKPHJWc1UTFQjCuBExpEo	1637	816	43	1	4444	jxJ6WRD6eyyzvechs5NcKRvx82DfTmh57EDfyKnBpdzstvMKWAZ	2367	3345	3345	1616541300000	orphaned
4577	3NKvC2uYQqTyW4C5zmq9uMdqaCiVugwCeX1N8XHiNX2k6LKhWACw	4574	3NK8o16AcXns2oy8UGggmi8BFHbJn3iyidCmMWxjhzPuNtkfZNMu	1611	1095	43	1	4446	jxHQwfMGbm775KmJfJWnqyLbcKQy5z6iZ9dEzvNYvqRHbJUUnjM	2368	3347	3347	1616541660000	canonical
4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	4577	3NKvC2uYQqTyW4C5zmq9uMdqaCiVugwCeX1N8XHiNX2k6LKhWACw	532	937	43	1	4448	jx4vTgtrjsLJ3HDn4tLiBFVqxCNSJvTEC5RRWQkVt1LS1T88drm	2369	3348	3348	1616541840000	canonical
4592	3NLxJycCd3PSHH2yJQ69PTWUUPzDEWqk2zRPLKwE3JzcmFwFEbKe	4590	3NL97KgW8kESX3Z3gy1ncqoydQkxMX3yGfX4RW4khoiwgANv4evu	1642	280	43	1	4461	jxYuDS5LE29d9XqTZRj6zFMhou8UXcJAqhKrnd7xs638TMLdEiA	2374	3359	3359	1616543820000	canonical
4595	3NKPoq8m7tKffg1yGKejRa5bpxR7RPq2yzLjSBHnSGgrBPFMh9ee	4594	3NLgKcQQdwwBt8BBTk7Y4RnkLFiUyppL6vWPvmmFne2QigV1F7dH	1407	1395	43	1	4464	jxqqXb2pZMvm5C5qFxp7oXLLp7REJ9sV86nkiiAVTVttmLAvkTY	2377	3364	3364	1616544720000	orphaned
4601	3NLMJR2QHdBAAEe6dN1YciS91BwJkiuK7KBYWq9tacLFsaycncFe	4600	3NKQQp6TTZwCnewH41E816DsrQzApS1zT44djcSqBmoNHqyErCRT	1403	31	43	1	4470	jwhBUXjAYKC7c5npsgPCTerTBidUwc9chqwC57EsAXZvMRSmSwU	2381	3371	3371	1616545980000	canonical
4608	3NLsrDW9F8WzcPnrmryYwMJgzS4AV8Vvive2eVEXaCJkpNQYLbei	4607	3NKD5ZvX3RjtRgv3SisWGiAyztQBTCBJWBhoCLbdZJiRtQTkDP33	1508	1387	43	1	4477	jxuoduiS7JbmEMweCFLbhvu7a8ZYbTP1hcZ2Z75NQP8pwvQdZCb	2385	3375	3375	1616546700000	canonical
4613	3NKC5DjoETeFCmj8mNM2PhddpasXGwgqaV32gwwL8vmXCiB1cgvn	4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	1623	830	43	1	4482	jx6YF2RkAfLLh4bWP3zvgLEfr8nybbFgyAptAJSY2rfYyEriHHo	2388	3379	3379	1616547420000	canonical
4611	3NKUe33rjAWA596XNh26UFpDYHsRFka5BUYav2j5LBhaj2tUMhUt	4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	1503	1277	43	1	4480	jxX27uKMwiDmcGCdMRu6dtGDp33mMQfgnS6PMUGCfAgBNAR62ZJ	2388	3379	3379	1616547420000	orphaned
4620	3NKG6tmuz9VB75txDDfzv97R7CZmzZVxcrdQub6Pwigsz8y9PDX4	4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	1594	1080	44	1	4489	jxCf7utNsMZaYsxoSq1YLWBbkvFhWn53dcXdrDKV4zdcGnxz5BR	2392	3383	3383	1616548140000	canonical
4622	3NKcZwxzaEXcbGjCBa3MsjZBLtZ49qgdm23F4ya1DbhUvB4wtSzm	4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	1633	1390	44	1	4491	jxCHB4CpsF3AVbPZxZfdW4pvwTNz6GrcEUcoKNTTohskLGUUq4P	2392	3383	3383	1616548140000	orphaned
4627	3NKY8XER2fZPbj4VgefsCrhsG1t2icr5KAgW7hdahzw8SpX4QGp5	4626	3NKnbvTkCLSuHhfd3b49v7kexs2uQxNjd1Gk9sfFVyWHH7GhL6xV	1587	1231	44	1	4496	jwbCdQk6Htdr5pxjgjdTT4wNp9bGNs6XvoE7gkeomhf3f3HSBNZ	2394	3387	3387	1616548860000	orphaned
4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	4628	3NLqZJnBxgmj4NmmRJibNFZFjqfEB5bfJGNuxWgrmBwM5LbG1uEN	1406	1393	44	1	4498	jwzzFz96s4o4iscKeE8Nc96dYx35BYDhGFBh5E3A5AVoGo5Hk6q	2395	3388	3388	1616549040000	canonical
4639	3NLPTQ6y8gjHhDCLPfVbsCWHVgFtGS9S29XQoJeAiMhxVUSWfDt8	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1523	1195	44	1	4507	jwX3atc2nZoQLzTy4jkRr5TZLjmdqkWBeY4LS6xGWeMMnjYPjgS	2399	3393	3393	1616549940000	orphaned
4645	3NKbJycLVZyFUUp9toAPqeWffzPyekkkgAkrkNu5ecnt6nzmGRCr	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1407	1395	44	1	4512	jxmSYpJFE9rzxVhW22WU7jLKWR711uNBxfUPbPeQ4gEhTJtizeX	2401	3395	3395	1616550300000	canonical
4647	3NLJ3wb1oMu8XwdJ9M1V3WQRjNV9bYFdLJ1fNLqdQv5J4Xdb2ZzP	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1652	1069	44	1	4514	jwZ4WYvWDzCtbVhvUf4wAWPd2ZtbXZQJVZVRKTUKDH2qDCGv1AS	2401	3395	3395	1616550300000	orphaned
4658	3NLnQAZFV3WM5TVe89YSsrxdFE29Nc7GnFDDxA3Jd8ihcCc8SCp7	4657	3NL9eQ1JzDcZoRuWzWZs6SEdSWtMgykbasgVsPnDtA7v3LjDgu1k	1581	778	44	1	4525	jwcbYtVKBM4sJLzxGz9aNz2Bk8efM1iFWf8Yxd6j3PAcaqZV8fz	2408	3404	3404	1616551920000	canonical
4665	3NKoTixo6GA78GeRuhC7oYBYELUs8JgMPtYwuj3TRhRYPPQa5kpj	4664	3NKScj8XssSsyrB1E5yt5BGtCzNwrjG5Mw7hC5fKvUxvkSrXZrYn	1474	1329	44	1	4531	jxfHsj7QfTLKts947GQ9dwoVUsRrzE1oiGMzKrJqZxN58YK6bbZ	2412	3408	3408	1616552640000	canonical
4670	3NKPWGZxnEwpEHTLGxUpB8qKrjmr2dnLocjBNH5L1fL49D7trUfR	4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	1444	1381	44	1	4536	jwsKpaCQ6eHAscN9HFwriw9eDm5wUBicykBGgN9E7QEGJwFczHL	2415	3411	3411	1616553180000	canonical
4672	3NLo4rB3Z9bWEaT3w83aRMx9G2e1Gv6YCif6jHyP1kjmYaHTJZfp	4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	563	1233	44	1	4538	jxychQreAYHZqwEZbguaD7Sc66whJUM58TuvQSoQw49KRZ7ryKo	2415	3411	3411	1616553180000	orphaned
4683	3NK3VubMh3E5mavgpEuSq1gvh5x6ejXcLCBPDiYbYBA4A2ER6Kvr	4681	3NL9NAUBex6rGkHBHCwfw1xGXGdpX2QFLcJtB5D7ifbBd14FQNCU	1651	1301	44	1	4548	jxYzBTcWVrbd5o6j9VWwZ8ZZvrhvCXZPECZA1uNckrRC6c5bax6	2420	3417	3417	1616554260000	canonical
8765	3NLsmK6rhgZAaBhLTXemTW1JkqoLZWSyiKGqZxiSE2Lh8pADX35p	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1406	1393	104	1	6301	jxesBuKZmz1ihQSHCeCHCsHbPpF7TsQBdnzzAWyjen1u4hv4pMR	4547	6407	6407	1617092460000	orphaned
4542	3NKqAKA76HCqQKziXrAjoCVR9d54ma2Vu6j8YvYMtP9TJcR9E3rV	4540	3NKWEewj3HYvxfdraMMGKtKtKx3juvoXZ2be5SmMPUZ4q8HJqW5q	311	1061	42	1	4414	jxnR9qRoKFeZxFYDbyPgz8FzXitVsgUpQLyjX6HYUMF3cbsevFk	2349	3321	3321	1616536980000	orphaned
4548	3NLZTNNtQjETgu9J7KP7DoxbypcRPKe8eo6g4jXc1XhUc7n8C6qH	4547	3NKsCjnwX3hxwk8vd1tqQBLTYSdWKrMfMgJCyyXxWgroMnteYGKM	1623	839	42	1	4420	jwZK37UCE2tGeBzPuFeu77nWXbFjxQwpp8HVLyuEsCSW34SRpFK	2354	3328	3328	1616538240000	canonical
4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	4548	3NLZTNNtQjETgu9J7KP7DoxbypcRPKe8eo6g4jXc1XhUc7n8C6qH	1522	1322	42	1	4422	jxqDPESnb88BxqtXY2s2zD7Ha6n8Cb1WEw1huBJwADoYhh1aovh	2355	3329	3329	1616538420000	canonical
4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1623	830	42	1	4425	jxCzW2gvxMwmnXHpetrLb36GH62qGAdGDqDhCJSWmP28ZFf3kuC	2356	3332	3332	1616538960000	canonical
4560	3NKhqJodQDp7qPsL4bmnNpz12jBMBbP71JRYb2EE8L858ThaoorZ	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1483	877	42	1	4430	jwbEyGkS9NsR7zLngpQrjbpL36ucErr6Hfrx2ekWvvS3BEkY2mn	2356	3333	3333	1616539140000	orphaned
4557	3NLTh698YsM8dg9KAqrYjo9Wbs4i9Jv2nSf8pxJ4VmfaeS1GHs6Q	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1483	877	43	1	4428	jxFeDHHfoM5kb43NNKg5tg5RFVJeivYgVzQzRRkvgSPL8bPEZ9w	2357	3333	3333	1616539140000	canonical
4580	3NLPVKJUU5ABXgFzEioPHb52fsSVHFByoQiXELqnCNp67eTXeLy4	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1460	541	43	1	4449	jxC7WiScDB9Q6hCgP1b5iSCyjFLofhqoghrrzEkGiug11N8YFEs	2370	3349	3349	1616542020000	orphaned
4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	4583	3NKRuZzhcfCL3JE1LnzguVokvXTnBeJKv4hvzkcqCLVuxfd3H1Ns	632	1382	43	1	4453	jxKRKTMsMcoWhYtRYgbCDPKPmDQChWkTNqN7L8frdhsyuyYsasE	2371	3350	3350	1616542200000	canonical
4585	3NLRyAtDcCnAQ7spCmzj5dR4YrsYdCEKA65gGRziybRgPZt9PEVh	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	1503	1277	43	1	4454	jwc76xB7GMrnBiqRLnvK3jje2sUDWRfvz7BZvPgSBwGNgNjkP2N	2372	3354	3354	1616542920000	canonical
4588	3NLoZC1TkKEkiBSNzGRE69ifxkAD7XMKGkjLMyDMAzefyqh9NfEZ	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	1507	1280	43	1	4457	jwJkWNRM2bAz7nShvsGGpuFQc5DqaSgWXKJcojcZfnLJigpKKie	2372	3354	3354	1616542920000	orphaned
4590	3NL97KgW8kESX3Z3gy1ncqoydQkxMX3yGfX4RW4khoiwgANv4evu	4585	3NLRyAtDcCnAQ7spCmzj5dR4YrsYdCEKA65gGRziybRgPZt9PEVh	1489	1254	43	1	4459	jwJzYRTC6FzyBzTPXjZJtJccacJdRb1NZkASKRwePr9ZyUwUpSK	2373	3358	3358	1616543640000	canonical
4593	3NK8eWrubc6A4JkR35WYsw8unKV4CybZwC9dc4bbx3PqJwYf3RA7	4592	3NLxJycCd3PSHH2yJQ69PTWUUPzDEWqk2zRPLKwE3JzcmFwFEbKe	1598	543	43	1	4462	jx28MVpDB7Hs9YMpPNQJowxGDiXmxh31y8woJicLQVDfoaDuaVD	2375	3361	3361	1616544180000	canonical
4596	3NLG9yLBCBjvjDwkHoLLJ15pZJtRssKQ3T2THVZKKvmaBfe935D7	4594	3NLgKcQQdwwBt8BBTk7Y4RnkLFiUyppL6vWPvmmFne2QigV1F7dH	606	1295	43	1	4465	jwLAmt43En2QpdPoqnQWNuz5UGXhuZRrAHcdcyoP2vFd4SZX9td	2377	3364	3364	1616544720000	canonical
4598	3NL6xomwYzemxBjvo5tAjm97K5uK7vEEMsmwNToG8P7c94TQb373	4596	3NLG9yLBCBjvjDwkHoLLJ15pZJtRssKQ3T2THVZKKvmaBfe935D7	369	1066	43	1	4467	jxsmCS8igfcDUAYnnT7gm4VGP7xzgAPc1bnr5rUoNU9sogVNtwY	2378	3365	3365	1616544900000	canonical
4599	3NKk1aLjygvuxZdy35Qd6auM4FL3Q9iAoSiH8D339iK9v4h3qypQ	4598	3NL6xomwYzemxBjvo5tAjm97K5uK7vEEMsmwNToG8P7c94TQb373	1631	793	43	1	4468	jxQyNjgmyPVu1pN25y7XchVVihewLpUDm2JqEMhbWTcHTYMD47W	2379	3368	3368	1616545440000	canonical
4604	3NLJdEHHHFoQL2PgzdoVyqXgzbZGCVTgPw8MLNe68yYJYgBWbnVo	4602	3NL73MfuTenugjLC6WVgHNDne8RVZTeezZ4XXvVBb8xMG4FHQaqD	1546	1093	43	1	4473	jxuggehCcozStoWW8vHmG9U5HsHAKtk9Lgr9PMRmv71v1Q5XUpo	2383	3373	3373	1616546340000	orphaned
4606	3NLvXbdtakiSfACjpCGDwTfHhBnRWQBqW7LYDoe7VyyzfqBrvSyP	4605	3NLda8JEhCi6B8BNNE3mvSREADRbi7XX2bGXGGoCsz5hQYq2qHcM	1439	1033	43	1	4475	jxie84ozbz2YBufHxiQS12anJ5jC8nYCjCsiZP4CWMFrj5p76xo	2384	3374	3374	1616546520000	orphaned
4609	3NLg4okTYmRJs7mGTvbZkJQpLL5EkjS6ynjT6ohLg1CstNejWn8p	4608	3NLsrDW9F8WzcPnrmryYwMJgzS4AV8Vvive2eVEXaCJkpNQYLbei	1406	1393	43	1	4478	jxKRFewUak4Gwe72DQ4xxCZeAomVsn1NBm5TtpZ5RGEce6nutLG	2386	3377	3377	1616547060000	canonical
4612	3NKsAsGsioY3Stbtn3XwgZ6VqJ4w5fS11j9VqSQMcmQSCVCDhdFh	4610	3NLtMjbRmzHb7qLGMeHT5pkbvmUoMeTM9QvnN1ByQsByVatXswci	1406	1393	43	1	4481	jwJfNcyfntk9qD1MVCLE7UrctcR1fhicMbopmBRMWVmF1Lbf6Dr	2388	3379	3379	1616547420000	orphaned
4616	3NLeHyiZcwEqk1PiXVgp1dhFpJRU2Bm8kyhm8Bh1dmhEP8AHhg5H	4614	3NLRwQx1Edr1iKym5htL7ungFycxDrSExNbPJ7ab85UamYytovfm	576	1355	44	1	4485	jwKnBavcHzS9RLP91u9bNQiefB8YPog2rXwGSTk8FesWrJLaVnf	2390	3381	3381	1616547780000	orphaned
4618	3NLamt4azEqBWZ8oE3BNwmgZtdPEe69NozNj3hGGPQN8np8XcGoE	4615	3NLwH2GvLhPaSQe4kTxGwiFpruUh7vmH4BWPLYDPYSrEJY74vAUt	1665	137	44	1	4487	jw7mfp6wrW5dP75u8JtPsyGo2qv6Cb4ijvmd96DYXjnVzodn89h	2391	3382	3382	1616547960000	canonical
4630	3NLUCJhcpuMFZoENoK6xo7NvK4YD4BCrm7hnXJK223gHgioQc36N	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	1407	1395	44	1	4499	jw7ytMyCq7TbrycSSGs3nm7TxTRANh1NXcuicxMQVKugubWbw3G	2396	3389	3389	1616549220000	orphaned
4634	3NL7HpgkKtN1K1JAhwouyAwK1o3GUiVzcNroHznfRa1JaC4LBWgi	4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	1407	1395	44	1	4503	jwn6FfFYw715CQptd5VY5J4wcsYkRXmFFPnRykNTCktUwtgywsb	2397	3390	3390	1616549400000	canonical
4646	3NLVNkhr9CK78SDMbvdMq5B7D8oCVzmq5KHSGfBak7dYnobiJExt	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1406	1393	44	1	4513	jwfR8Bw1nbxRYFmvYsTc3nAQdJx2RP1CYxmRJQxABQbkNPvUjdt	2401	3395	3395	1616550300000	orphaned
4650	3NLu5KfGr6phEFrhsTa3fxRkYZXWyqrUfuAziTmPyTVfs7zKePg6	4645	3NKbJycLVZyFUUp9toAPqeWffzPyekkkgAkrkNu5ecnt6nzmGRCr	1593	1100	44	1	4517	jwNquh9gR8PeVGEN6a8b5EEev8BS3KK1rMJrHHYWamp44Yyncuw	2402	3396	3396	1616550480000	canonical
4652	3NKDsSds3uUfk9qrYBuJAxYjkqLJ5qwrmzScAEhjhFVP9TKmfEWE	4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	1403	824	44	1	4519	jxfp2ZNY3owXkvjj96C27P7uTxe1vZ9Py8xWTbu4Ei6kpqKuwVq	2404	3400	3400	1616551200000	canonical
4657	3NL9eQ1JzDcZoRuWzWZs6SEdSWtMgykbasgVsPnDtA7v3LjDgu1k	4656	3NK8nKxB1iD9FxL8Awg3vHmNb24hxaJ45jefLCDAnmmU5Qzrq6QG	1407	1395	44	1	4524	jwZHUkXP5M2VnHb6QvdW1nFrGSYhzUZuwT1y2zQFsbvFCqdd99q	2407	3403	3403	1616551740000	canonical
4662	3NLSutyoCW1QsuvYmrV2Bbi7T5B8HWYWBHzC19dLcxKXdQ2AwwsJ	4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	1651	935	44	1	4528	jxKaQAtGs321HNzUQTZrZ4AF9r3YXZ4u8jqUzZtSaYo7DVncz4Z	2410	3406	3406	1616552280000	orphaned
4664	3NKScj8XssSsyrB1E5yt5BGtCzNwrjG5Mw7hC5fKvUxvkSrXZrYn	4661	3NKpbCyHFirGjvhsvbHNdAnAZCReWTqmG5dXqp6AisL1nBD4pE1R	596	1306	44	1	4530	jx1GHv8AeM2pf4xxYo8WfQ5tbovwNuvraBw7avJhoNDhpEkQrjB	2411	3407	3407	1616552460000	canonical
8767	3NKy9cy9uqQKymdK1FHz3CZStRXS68pD5dDD89TE3c7CJo7mVHL5	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1651	935	104	1	6301	jxhFnTH3jKmtnYfDe2FD3vc1RmMUceRyH96A4Gr78ohcLGbemAp	4547	6407	6407	1617092460000	orphaned
4597	3NLrnZUDgKV1jtqUL4SHqGiSV2PVWP77ApmD4hQkpttjy4hL4Bj3	4449	3NLr2qMKesf8CDGYJirbZ9R9vPkGhf5paZ7Xiugobh8z15gREkad	369	1066	38	1	4466	jw7puAsAB6SUkxFPukA6Lrwn2z6BKLZmS2EPc1kxRnUH6mAetXV	2214	3365	3365	1616544900000	orphaned
4571	3NKp3jv7GsV6EsBxoxiYVSr2rJjqmxfQuQGkXdMNCjcDX6CPbjuq	4358	3NLKLCRXK6eyhK8BjnZGoLmzLG9Xa6QgwZHpJui7AnbrduTGeikB	641	1336	39	1	4440	jwzvwhhm9HFx5nJgBK9kHmLyCceqWy2zCYCFj7Qbez7mMGA8GYK	2260	3341	3341	1616540580000	orphaned
4617	3NLnb2ArYfDdEs1dxzoThh2ATDMWWGQ7pcYZ1FwKZuxQgKb5VQxm	4431	3NKUD75LZXb1G57PoALXtF3rm81ZGxE4NByJ1V1e7hxwWjnNy7MK	576	1355	40	1	4486	jx3iWa9GeKwsnn2YBnFPcRozkZuHbBv6aTm1Y5UGV7kgoUgWB4Z	2284	3381	3381	1616547780000	orphaned
4561	3NLEVPJY2gYXjLE9sLtv8qHVVxFRS2We82Lxvn4e9L5e8WMAZDi5	4550	3NLZYPMGQyBUyUqx9Q1oaajusagVUQ4aJWCSKD5A7zXXGxSoYigg	1503	1151	42	1	4431	jx26NidBMaK4QR6EMdNknr66kyzCHpAPvuQK3yAGY5fEkGCVAGS	2356	3333	3333	1616539140000	orphaned
4564	3NKWPKyE7ptFHjcxSqF9qdLQZGQqymDmroiyvcBu73mT9uqCjDDE	4563	3NKNdCksDUAA9Gx9HkiTtWntCzeV32osvfawrMfFzGcrkcYpZJAx	700	840	43	1	4434	jwv77qFwhJd7UibV155ues1Ke5CEiRVFYfhh9MpxFKG8XGphd5M	2360	3337	3337	1616539860000	canonical
4569	3NLPJmgouSCtGnYddt5sXb2UP8ZS4RkUy6bMRkr3hSc2KH6enzPp	4567	3NKoDpMSsj6eDUgXcPcC1QoYK2F1wAEMNji58k5sFiRcNPmpAyEz	1617	1288	43	1	4438	jw9D6TnUGmbqz7zwqrUaKeTFxsVQdyPs3schtXMiU3UgTZ3C4U6	2363	3340	3340	1616540400000	orphaned
4574	3NK8o16AcXns2oy8UGggmi8BFHbJn3iyidCmMWxjhzPuNtkfZNMu	4573	3NLbX5ErG8uh4LU2zYNFDNPPvyfz6jyHKPHJWc1UTFQjCuBExpEo	1483	1030	43	1	4443	jxCm2171zziWK88JmDFxChM5SKcLEF5BBWnn6ZoHjdk9GEoqSAV	2367	3345	3345	1616541300000	canonical
4583	3NKRuZzhcfCL3JE1LnzguVokvXTnBeJKv4hvzkcqCLVuxfd3H1Ns	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1522	1076	43	1	4452	jwTNY4B76sqfw2hoigznqHx7P7kinpJVDjQmNGwSVJbWkLyG4PB	2370	3349	3349	1616542020000	canonical
4594	3NLgKcQQdwwBt8BBTk7Y4RnkLFiUyppL6vWPvmmFne2QigV1F7dH	4593	3NK8eWrubc6A4JkR35WYsw8unKV4CybZwC9dc4bbx3PqJwYf3RA7	1578	1170	43	1	4463	jy2PUAdZfodwtq7UDHsCoqQDpfjuR1Wx8LAi5dMRv7KmJbX1phK	2376	3362	3362	1616544360000	canonical
4600	3NKQQp6TTZwCnewH41E816DsrQzApS1zT44djcSqBmoNHqyErCRT	4599	3NKk1aLjygvuxZdy35Qd6auM4FL3Q9iAoSiH8D339iK9v4h3qypQ	1460	1198	43	1	4469	jwqFTEpPyrknWUAGzhCzC2s7kbBcLAAHaPKP2RBXKFmQ5jAYGpJ	2380	3369	3369	1616545620000	canonical
4603	3NKQYRGxwp4Us4TNktFYTb3iKYR4612eLkvT3thXzQAnajdNKinR	4601	3NLMJR2QHdBAAEe6dN1YciS91BwJkiuK7KBYWq9tacLFsaycncFe	1516	928	43	1	4472	jxs9HF1iviXJdw3EfYi3MFgSDucSRYxc2rUazQfL6pr4vMNwD8B	2382	3372	3372	1616546160000	orphaned
4605	3NLda8JEhCi6B8BNNE3mvSREADRbi7XX2bGXGGoCsz5hQYq2qHcM	4602	3NL73MfuTenugjLC6WVgHNDne8RVZTeezZ4XXvVBb8xMG4FHQaqD	1594	1200	43	1	4474	jwcCXhHALqWdUDA4Uy8D6v99cna6nuVAJCJ2vntnx6iq9pJPquT	2383	3373	3373	1616546340000	canonical
4607	3NKD5ZvX3RjtRgv3SisWGiAyztQBTCBJWBhoCLbdZJiRtQTkDP33	4605	3NLda8JEhCi6B8BNNE3mvSREADRbi7XX2bGXGGoCsz5hQYq2qHcM	1588	1026	43	1	4476	jwshCkuBTRd53ohHJKLT7Qp4TR7HLZYAmwwXkwFrQ1ej6AqmnyK	2384	3374	3374	1616546520000	canonical
4615	3NLwH2GvLhPaSQe4kTxGwiFpruUh7vmH4BWPLYDPYSrEJY74vAUt	4614	3NLRwQx1Edr1iKym5htL7ungFycxDrSExNbPJ7ab85UamYytovfm	1541	1298	44	1	4484	jxqcYmqyDgRsyZDuw6HEeSaTUssnFk2JFhBHcQjQ4CQ15Fr7eaz	2390	3381	3381	1616547780000	canonical
4619	3NLSpcZbdqyEyREtEAEbzWShEMpVV3doTR9H6FkidWcEMEk8jvGo	4615	3NLwH2GvLhPaSQe4kTxGwiFpruUh7vmH4BWPLYDPYSrEJY74vAUt	1624	1088	44	1	4488	jwzaTyZ5c6D2iKZfYSh4SsvASJ2CLZPZxmnGPoXuijKD5HJqQtz	2391	3382	3382	1616547960000	orphaned
4626	3NKnbvTkCLSuHhfd3b49v7kexs2uQxNjd1Gk9sfFVyWHH7GhL6xV	4620	3NKG6tmuz9VB75txDDfzv97R7CZmzZVxcrdQub6Pwigsz8y9PDX4	1590	198	44	1	4495	jwBKXD88PHppgMo6eNw6pNLebKPASJz8kw1i2YXyyUeziqM3gaA	2393	3384	3384	1616548320000	canonical
4624	3NKLko6ZQTqZsqf8pAd5zzYURTv9VgxRZUAfXK7w7DLfK1KQDR5e	4621	3NLXM9awuuAGMsF71xoLfv9QtGnQyevht6ABtikTws856Arjwksg	1422	971	44	1	4493	jxC9QqYfi3yctnZkvk4JLs2jCMtNrQJd9Z2Lf2vzUMA8gfHUS1a	2393	3384	3384	1616548320000	orphaned
4632	3NLmNKTxtU6mEBCyy2BjMpcicdzqYqr8H2qwrxPddxei6SKeUZmF	4629	3NLEsYxZgm1Xj4ZxAHoFC9DVPo1t5NB5MM81UuAmxWrJJA5BWZvw	470	1063	44	1	4501	jxifqztYPV4HNqE1mnQm2UijK81pJCvutJ9nj42DMSTXi1UhUFU	2396	3389	3389	1616549220000	orphaned
4636	3NLgxxgUpC1GmukhNTPiQSTUP5QVa4xhnKsKNbwM5rXybAobuYAT	4633	3NLE2iQPTPEtCGNU9xnc4mJXES6DAgg4xcvkd3pkikLt3aRTyDqJ	1406	1393	44	1	4505	jxPphtmUGftGcBGct8KeGBoCpmN5WtrzqbdMDsj6jWu5TPbzB4v	2397	3390	3390	1616549400000	orphaned
4638	3NKGNSDRvqiA8msa2XQeeNjmJie1fciLcZYBqKDRGGiD3LGAbFAH	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1523	1195	44	1	4507	jwHqWf4CnUtdFazimxTVCjRUAqasuwdCv8chwWkpgUopYoP1Usi	2399	3393	3393	1616549940000	canonical
4641	3NKV7maY892S5mAJDJtbqFMiHekpCpH9sMqeEnfjS3KsQDGDNHny	4637	3NKpkBbvGxQj2hf5UWXNYaqVYu8zxnBcXXhrfN2jhdBnx5Qg7RzD	1581	778	44	1	4508	jxJjp8NCXGSPg6ebDDNcsP9LQp4o8x3BLdEZXZstUXZGVQC9E4G	2399	3393	3393	1616549940000	orphaned
4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	4638	3NKGNSDRvqiA8msa2XQeeNjmJie1fciLcZYBqKDRGGiD3LGAbFAH	43	1064	44	1	4511	jwgVBpRQ3wqFfKbHeZYaxKRWFRDLSEymhVr4qBQXzuqPU3Ng6iV	2400	3394	3394	1616550120000	canonical
4642	3NLBhXqzvJvrmtyBPzV2m18oMarfDb7itZXU9Lw6SZJFFt8md6ax	4638	3NKGNSDRvqiA8msa2XQeeNjmJie1fciLcZYBqKDRGGiD3LGAbFAH	1610	1314	44	1	4509	jwrgSq1gAumh8CpMKTMoX7C6An1hocKH7RZ4KHoBDuBH3GpSCQV	2400	3394	3394	1616550120000	orphaned
4653	3NKYCvT4y6niHHD31LfKZDk23NnccwdEnQZ4ba82R1jkDn18EM2f	4651	3NLMTrpvKKoyDWV3SWqhCDsW7MvoHDyjTRwTijEAvAGxDc6B9nTL	1405	851	44	1	4520	jw8nugwnMezSL96Wwumvwb6H5qq9XfQ3CrxAmLAbXyXYDhCwD67	2404	3400	3400	1616551200000	orphaned
4655	3NLZy6Q4sRvwcuuWwH7Wvrki7Qk5yNVKd3e4KSLvFEnDE8uTqbRB	4652	3NKDsSds3uUfk9qrYBuJAxYjkqLJ5qwrmzScAEhjhFVP9TKmfEWE	1447	1345	44	1	4522	jy1292zb7cEcbwzUrGixa3wASerBcJHp4r8ZUomRof6Dsuy6AYw	2405	3401	3401	1616551380000	canonical
4660	3NKh9QAP6tpyZFJjNCwLYmCLS2Cg5kJYA8gkY5J2JGDnfKx4B7Tz	4658	3NLnQAZFV3WM5TVe89YSsrxdFE29Nc7GnFDDxA3Jd8ihcCc8SCp7	470	1309	44	1	4527	jwrTv9A2VL1rGLhMXKqXhjyi7DdadqDcFjoThNYcyBCmqkucF7J	2409	3405	3405	1616552100000	orphaned
4663	3NK8Fy9eCRAXGaTmWyMTnWtHSoasxw1agCu8FFQyxW9Yw5eFV9Wj	4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	1401	4	44	1	4529	jxrgCCz6NEwhLRhFLhiiAScYWqtBMWcHNH5zCe8u69Fp3upDUz6	2410	3406	3406	1616552280000	orphaned
4667	3NKaC2mzab2wRC1GGSHFY6b99SgtMZp65pYNi5PH5c5iQwj5FJyo	4665	3NKoTixo6GA78GeRuhC7oYBYELUs8JgMPtYwuj3TRhRYPPQa5kpj	1650	1249	44	1	4533	jw9oDMSec35rBz8ZCekootNzcq9dqXb94gSbrL6kteHiZKRPgGW	2413	3409	3409	1616552820000	canonical
4669	3NK95vjPDap3FGtVFRsJGvbasLw7HcfzxyCSDCc5hjbBKm6JHHi9	4667	3NKaC2mzab2wRC1GGSHFY6b99SgtMZp65pYNi5PH5c5iQwj5FJyo	1419	814	44	1	4535	jxcj8dZSJEVTHjofx5289dwovLMxbaFPkbGZuW8wNoGu6P8cwkf	2414	3410	3410	1616553000000	orphaned
8768	3NL9xq1PgP3kA56Zc4JZ4EXoeUdLh7nxmRuZ5mJE2Az8z5vkxJyZ	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1651	935	104	1	6301	jwa5vUBTp7Fuh1th41T4noxMQ6Mg4nVY9yHD2qvHmV1AAt1L9Ty	4547	6407	6407	1617092460000	orphaned
4764	3NKWoc5hC2ZAYuocZxVQPTySXuM4mGUUwYAbiJcnyKdnFqXXcKSK	4391	3NKQ7My7sCmncRxJeZHhQRGrqAV5E4zQJepNspStReGhPFxvAUe8	152	1204	39	1	4627	jwtKFMY95RdxatHMP2VeVpTRYrMFm8aFw5qKSmcjATZbwFogxNz	2278	3469	3469	1616563620000	orphaned
4661	3NKpbCyHFirGjvhsvbHNdAnAZCReWTqmG5dXqp6AisL1nBD4pE1R	4659	3NL7Yo95b9VjNYSotK7d5RUkifsyEQuXdCAgV6tHea2dTZUCBX14	1651	935	44	1	4528	jwqtj3padgN2HZS352aZrqcPfjJmmCRFXAb1goLCLdYSWBFBJ6m	2410	3406	3406	1616552280000	canonical
4666	3NKdbu5AVvWs15DzY2kqdct3vStQzu2iPK8AE2DZor7ryHf9VRRf	4665	3NKoTixo6GA78GeRuhC7oYBYELUs8JgMPtYwuj3TRhRYPPQa5kpj	1547	1132	44	1	4532	jxP6NthNm4D7kH2ALpT9d9RMGgkyUqYMu3J7twYU9EntJkGkkPQ	2413	3409	3409	1616552820000	orphaned
4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	4667	3NKaC2mzab2wRC1GGSHFY6b99SgtMZp65pYNi5PH5c5iQwj5FJyo	1407	1395	44	1	4534	jxnYdPBDjnzKW3k213cHxFaqFdPRXT46s83aXrWVmLbAMvFAc1i	2414	3410	3410	1616553000000	canonical
4671	3NL4SBxYBMhmhHFJ4GjtphnyxiySSJvNRjYN1aBWJ58n9MJbSEdR	4668	3NKR9vMjMVRJno6SU9fg3mGy4fKRCAN2wuPivZFMwaFQWZPKAxET	1637	816	44	1	4537	jwTXxQhUfe38cKDqB64wTukPuWzjkxzJwnZ7vWhBh1atPVvdPnJ	2415	3411	3411	1616553180000	orphaned
4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	4675	3NLNwXtf7Ei2LCQ92Bsar2iNTto3rDcJ3XGZPbR878qvpsSLXwzY	1637	816	44	1	4543	jxSdEGfMN691ZcT9naQJhtTECnRrWdeAE6rfwUR4dshwReEWqMS	2418	3415	3415	1616553900000	canonical
4680	3NKpwLBZx8NduqZXWHvFL49ijSub8kNSDuGDtdzc91LigadDcCnn	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	58	1035	44	1	4546	jwaBcAiYzD5zi2oiEA8smExCHzNjyRbBYnYPJpxboQnBU37sGFS	2419	3416	3416	1616554080000	orphaned
4686	3NKvN73M6sDz9ErRExwkfgTG41LivAcStkVWxVC6nRX1AiRhQV2a	4684	3NLTwoTebPgP7vJ8kpoFf7J6oQLYUUw6hq2K4raf3mYaYi7wtMvG	1564	1338	44	1	4551	jx7LtMddKMy8VjeCptcGefsmosTNA1uuMm9A4UatDrou8gsVDzz	2422	3419	3419	1616554620000	canonical
4688	3NLHLS3Qp2FbawYDNW4YzPua33ESPn9uMWBWNn98noLMWqS4NBWS	4687	3NL4L7YzgaN9KQHqULebstceGdnqMEnWmBkASpnMwMJGzSWKJLK7	632	1136	44	1	4553	jwfCGXjHYcCAisv281DGKFmZhGxQQUnJAUKh1XjBJ4UWxg7opJU	2424	3421	3421	1616554980000	canonical
4691	3NK3JsJSqMdvyyVfofbYAZ1CqgkE9FsVRPPyuF2uujbxfuiqHDrH	4688	3NLHLS3Qp2FbawYDNW4YzPua33ESPn9uMWBWNn98noLMWqS4NBWS	1529	1190	44	1	4556	jwSygVUdZjzByvQ8aFNUEJa2LHdxbfGg7AA3mi4d61DXUAmANdk	2425	3422	3422	1616555160000	canonical
4702	3NLD9JrxZsYeV5VBYh4UMgFdaqZXbAUN9TGK4tgW6Yxk7GfkeiZX	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	1406	1393	45	1	4567	jxMi1tgEeNo9Hbm37XQ5Tyr9sdpausBuR65k87VFekJJwRdKJGW	2431	3428	3428	1616556240000	canonical
4709	3NKZ7aRomk8TRKB8BpoHvFMqo1cEFoQoQ6qxUQ5uHjHWw3T3PbDL	4708	3NLtjfZQqcdBgN5JudGBf6pa9N4CjeBQJCqBk1k78CoLvmCBf3FP	1600	1246	45	1	4574	jxosHjQqMK1EiSsHqMuy576REKPLN2jYKWgMgPXZchFQumLWdmG	2434	3432	3432	1616556960000	canonical
4710	3NKjU2TRzk4PvXKsbFJ2z1mL9Q5qzF18CVCpjkpFb4s7kBZKGzuq	4709	3NKZ7aRomk8TRKB8BpoHvFMqo1cEFoQoQ6qxUQ5uHjHWw3T3PbDL	1646	1108	45	1	4575	jxNgjpVP2QVZCxzuY2BfMQLAeURsCeMMPVHcjvomD3q9Kz1WrKp	2435	3433	3433	1616557140000	canonical
4719	3NKbFW7vHxu655nDJZduYqebQjqFSNVDdiyD69YAmJ7MbeEgTGCD	4718	3NLaQvFP5cfa2C4s5XM3LH8vLBZJscky1dyad2L14fKrBMnCoT7h	1403	824	45	1	4584	jxKNqH5S6nSe2TY7zE4F4kP3p7jamTA1g6e4yKL7pTKogwebT2s	2440	3439	3439	1616558220000	canonical
4721	3NKnH9gUpbt4qznar9PgVdTMsSPAR7moYxwiBL7SqukKNA3Qgu5b	4720	3NLV36JM6RWeQyGKewe9N1PWkyKMKNPwREYmSba78Fu25xVSjPD1	1671	1239	45	1	4586	jwt8SVdMtAq6V6QxQrwwoi2LBotJ8smQcnRGzc9vKyzJvudmgSp	2442	3441	3441	1616558580000	canonical
4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	1523	1321	45	1	4588	jwLHrH14xRVB4trPeZvcdE3tg3xtZd5X7EPGy5p3d8vUVYQh9Jj	2444	3444	3444	1616559120000	canonical
4729	3NKe4H3pqEzjkHTV58p1ZgRyY2BRThZDcCjRkA67y4P228LgFhNG	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1560	1291	45	1	4592	jxe3eJXyFaKYCkQRcmf3pHTtnT9beRpPaA8DY3V523Q91DqCFTW	2445	3445	3445	1616559300000	canonical
4735	3NKnM9w5ASAbBYEmKkG4ToTNKScofxK3iFa2BYGtaHWt8e52ouXm	4733	3NKQ2imyTA1URnMtfoKc4A7mHwzzryWXPC6PfjM6PMWZKAEnF6WZ	1536	947	45	1	4598	jwZYvjpm1LX2nuQBjBWczoKGAFQDsn4ocmwupNGJpriFnxnhFni	2448	3449	3449	1616560020000	orphaned
4737	3NLBGYtPGoM53Y2L5h6Zp9a7zEnVF6C8jBb6wuw9y5YyLUYcbq8M	4736	3NKiuCkwVYzh6hgnv9kVqBA2qxgVG2ZdZvf5aM2WgjUKNwhhJWfD	1601	1262	45	1	4600	jxfzBQXsbYbLaPayaAuxsymU6wnEFUP7moSTNmSXRDiur6tppX7	2449	3450	3450	1616560200000	canonical
4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	4739	3NLLey16BwLtbmEWqmHakpLPyGQcezJQRde5rvzbbqC63PUuqzy2	1440	1251	45	1	4604	jxL7jkn4m1qJCBgxPYz156UxHAfQTxA7aGQdyqeVhHX9Q6uGsv7	2452	3455	3455	1616561100000	canonical
4746	3NKdotfGqT5ZSeLZi2JxY2Gcmj8QgJSEvZJyjmd15uFgkUjr6xsS	4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	576	1355	45	1	4609	jwZ881y8fwgXtej5bVo4f7BoZmqQqBYVV8rAQFzwKdvUR9f4jQW	2453	3457	3457	1616561460000	orphaned
4750	3NKwMHEGKsasUE261BxR858Ukk7EAdGqB7QEzhu1yX8op52mqG49	4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	1455	1332	45	1	4613	jxifEzNGCnbqE2dHCVxLS25ghGDrnYawEAj1r885qQFmgLv718F	2455	3461	3461	1616562180000	canonical
4755	3NL7FKceYPxcaR1T5Z7vrH3d8yjuWY89EsSieubFDjEcE37wMxKv	4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	448	1305	45	1	4618	jy18rHBgBQNK5n1txd3C7xoDbZc5x2JGkJ9iHiaJsXx5x5M45bt	2457	3463	3463	1616562540000	canonical
4757	3NKdxzwF49qGJnubn82CMtKTwVuAjV9Fkdd2U8mR4Hqrg5WCXzhy	4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	606	1295	45	1	4620	jxpQErG3vHRkpDdQ8nvSsxVNc9Nu5qhpJE7bDtQUQ2ixVmYHqWH	2457	3464	3464	1616562720000	orphaned
4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	4756	3NK5wKwCVAPvsDV3QBH9Ez9VRGuNXSaZJnt9v5ohVMjphA3i92Ga	58	1035	45	1	4622	jwLdh7vtyGZDmMCBgb1YtwmxEmMLJm3q3QaxUTxMnEnAstLiGNF	2459	3466	3466	1616563080000	canonical
4766	3NK6SkpQwop8eVAr3DzFFAJRyEpThb7FwnLd3dGPFR8d1mvM3hfG	4763	3NKAFcZAMuLR9Fk5qdvSYiriB1T2aNb4xzzm3UfVKiZRpyo2uqNp	152	1204	45	1	4629	jwwJiX4zMhr5fHjRBDbquCHFPGw8sA5guKQSq1SSKsaF9SEJAUx	2462	3469	3469	1616563620000	canonical
4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	4767	3NLxDc5wUKWtYsBAU7Dpz95FHTHi4QwSgEBXRhsqgJAk62zSFc8J	1555	1347	45	1	4632	jwkhTTokd34ujnLC22sV558zNgzkWSXQPBGCvEX3ifqScpUhqSs	2464	3471	3471	1616563980000	canonical
4774	3NL1hHWAATuybAFoTwqdsSToBhcAYQ2EMYFHE9sABDszqR2T7SzY	4772	3NLfNtf5zxXvax8q8p5yGa1yei6y61rBrMMvRayPsKbZsbqGL2wq	1407	1395	46	1	4637	jxez5mYQ2fyFhQ3bDdYkwARH4QuX8aqrjoazJrsBX4VTNiheZLc	2467	3478	3478	1616565240000	canonical
4781	3NLgp3x9L3YT7BCoZN1ajpmGWYX5VvWuTJkTE1XJsR8zM5kRAs5Q	4779	3NL6HqBYgPi3qwmaGsqRU4e59qys1tzA9J4BzBUcAfWU6REPpK1e	1547	1378	46	1	4644	jxMUg6cgBDyNTDfMCTGcpb3tUuAAAqvdfFxXF9cbPuf9L1pHR3o	2470	3481	3481	1616565780000	canonical
8879	3NLMPPuTMCsY3fz5hEbSFMmv47oEFGfs88nnapjnUkfPKyZyQvBi	8814	3NKGg5C2yb3xuGxYEZJ1pHyLNm4y9PrffqT4uJFV3jd69vxd6L1y	1529	1316	104	1	6301	jwFWHurifjv1iPnq9nqKJFBb4KGDqyHV2nf5W5ytr2oaAWAT7KN	4549	6474	6474	1617104520000	orphaned
4678	3NKKTK3N6nSN1JfZ23No45sHFoqJCSUkA5nX1JSpFd5BAS4CfUjr	4675	3NLNwXtf7Ei2LCQ92Bsar2iNTto3rDcJ3XGZPbR878qvpsSLXwzY	633	1138	44	1	4544	jwTkpKShLCMGUkqtfJ43nVj78CeDMZCBCqVkNbWfK3TapyCFrUA	2418	3415	3415	1616553900000	orphaned
4681	3NL9NAUBex6rGkHBHCwfw1xGXGdpX2QFLcJtB5D7ifbBd14FQNCU	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	1594	1200	44	1	4547	jw8hrCd3GKR3Fs5YZxQewS9V9ysmFJy2RdfVRQwZPgP9EQqT8Es	2419	3416	3416	1616554080000	canonical
4682	3NLiRdHzL6NPPyMm1ESWnbc2sNUUr2oZsZyi1ASexC8uDf7Zu4qu	4681	3NL9NAUBex6rGkHBHCwfw1xGXGdpX2QFLcJtB5D7ifbBd14FQNCU	1651	1301	44	1	4548	jwJXXXA1Dqz26bVB25E9o7h6o5h1UrFPrswyS4yJxHXrnwKdh5E	2420	3417	3417	1616554260000	orphaned
4684	3NLTwoTebPgP7vJ8kpoFf7J6oQLYUUw6hq2K4raf3mYaYi7wtMvG	4683	3NK3VubMh3E5mavgpEuSq1gvh5x6ejXcLCBPDiYbYBA4A2ER6Kvr	1580	423	44	1	4549	jwqZCbsLWahCxRWyUtey8hhutxvMjEg1ehHY6ytL4CzCQ7wriqZ	2421	3418	3418	1616554440000	canonical
4690	3NKSkRVCiLdxiCTqSBropcCxYB4FUZvxbk6FUVzMvtwFxGoVqeR8	4683	3NK3VubMh3E5mavgpEuSq1gvh5x6ejXcLCBPDiYbYBA4A2ER6Kvr	1529	1190	44	1	4555	jxm2bC3aKi2gPWQJ6fMTa89agEdVJhoSLKQ8FAc34mUhrBrP1Pb	2421	3422	3422	1616555160000	orphaned
4685	3NKnV9okgn5rGGmS667g2kp5ikSrHY4yZb8b7tXGqdEmPsTrTq1x	4684	3NLTwoTebPgP7vJ8kpoFf7J6oQLYUUw6hq2K4raf3mYaYi7wtMvG	1406	1393	44	1	4550	jxn4zPbKDB7EDXTbsbTqyLJT89NafZQM4CUjBEjVxNXVhSfdfHb	2422	3419	3419	1616554620000	orphaned
4687	3NL4L7YzgaN9KQHqULebstceGdnqMEnWmBkASpnMwMJGzSWKJLK7	4686	3NKvN73M6sDz9ErRExwkfgTG41LivAcStkVWxVC6nRX1AiRhQV2a	1506	1127	44	1	4552	jxLi5q1D3tzYaPyKWMtGFxZ93Td6bET5PpnCqELjmLjP8madGvj	2423	3420	3420	1616554800000	canonical
4692	3NL7Ho5ywVpXZQbKqnJNVkBMy3com5Nx8viriKUnBSWY7g1RXJPa	4691	3NK3JsJSqMdvyyVfofbYAZ1CqgkE9FsVRPPyuF2uujbxfuiqHDrH	149	917	44	1	4557	jx5KAM43HbwveBddeyJ45JtJpy8oc661jt4wcDDvL4HKEZY95pw	2426	3423	3423	1616555340000	canonical
4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	1536	1187	45	1	4565	jwLLEGnTepjto2Y9qZnBVpWeLG6zciqTtqWTVGF2mtiCfDHcCSj	2430	3427	3427	1616556060000	canonical
4704	3NKBfVn5btWSTVQBn5ujV7h1SwoiPtdTGu5Fr8wJ1VVkX6u6NjTe	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	1624	1088	45	1	4569	jwH8U6EXLHnaPKhWGRdLPeNyRQryxrwj14stZvn5tuNkESay8Fy	2431	3428	3428	1616556240000	orphaned
4706	3NLRxv9RPQWXbP3U8Ln3bubnRv4U79vWDeYKeNUXu3toUK2ha6yQ	4702	3NLD9JrxZsYeV5VBYh4UMgFdaqZXbAUN9TGK4tgW6Yxk7GfkeiZX	1509	1320	45	1	4571	jxrxYGrQ32dPNSRFJFbvZZKWdRHbEph8haUqJ1fBz7sjJ3Mzpmf	2432	3429	3429	1616556420000	canonical
4711	3NKDM8bgxn948dnn1oWZp6fvQBS2Jy2297xUoJ83vdy5mPqmECh9	4710	3NKjU2TRzk4PvXKsbFJ2z1mL9Q5qzF18CVCpjkpFb4s7kBZKGzuq	1656	1097	45	1	4576	jwtimGabsA27CJA17nisN21dauSyH4s8PBFziqJLfoqjJ1mZDgm	2436	3434	3434	1616557320000	canonical
4715	3NK5ZKGiQkVWNimQiDUTw85PKnyikHh1D4bJ61FXZMSTsTErGhGE	4714	3NLb9XhkVS7WQ5Lrfo7E3KDsPN5MJycekjqJEG8mCQqCdJ9HDrLf	42	1115	45	1	4580	jx4i6gqFFDzCfxrbvi5Wbk7gGbXWEtBNgyLrbWeahnf9e4Den6F	2438	3436	3436	1616557680000	orphaned
4718	3NLaQvFP5cfa2C4s5XM3LH8vLBZJscky1dyad2L14fKrBMnCoT7h	4716	3NK4pxSGdA9YK85khAwvrYCNf4MUcVrkEdrWTWKdhtgN1XYZ3DfK	1407	1395	45	1	4583	jxz7SAvAA3cczvyxZwqmRVf2A8u2CL5Eb9TsqsyNuZBVrhnLZmz	2439	3438	3438	1616558040000	canonical
4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	4721	3NKnH9gUpbt4qznar9PgVdTMsSPAR7moYxwiBL7SqukKNA3Qgu5b	1500	1171	45	1	4587	jwRL3af6kL4mb1jmG7kyNt2KoathSRUtEavPzuZbpnikrqWy2MW	2443	3442	3442	1616558760000	canonical
4723	3NLbDCuZMiVvceaWrWmWhmRe3Sr9HvBnmVgsNGxbqkmR4Vu6bGXD	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	1523	1321	45	1	4588	jwvH2eBaVRdJCnytPDzGrGoPkSKLFpmtoJGRump2vLGNnMjCNW4	2444	3444	3444	1616559120000	orphaned
4724	3NLPunYkyfkjGWyatCaGNgezzk3u9k73JZy4hU4k5UP5iK4bvcJg	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	1523	1321	45	1	4588	jwUZQfheBfFNxyXPZPQw8Ku5aFotme4zWUbbvfwsJbGpDcDtCWU	2444	3444	3444	1616559120000	orphaned
4727	3NL4nNx5A38mYYe2fcj1WR6eXCzeXG3fSTkKwvzqcReF5wK48MmY	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1483	127	45	1	4590	jxEtthZZeHJSFDN9gvtTSty4ArUgS4MjgysLSBbH22kW1yedgPv	2445	3445	3445	1616559300000	orphaned
4734	3NLF2ggMCPKsDhjWNVf6Y74eSJsP7HswgNBWb2LaF2yhCD6i8ttB	4731	3NKN4Pqq8Quqk72WS4hxm9th849WAnvSmzkvhVmTuZRjUnP4qaGw	532	1177	45	1	4597	jxSvXVEQM3FrQJDz3Qk6vVTqKgbTKpXzc9oYJFFyb7TYB8mefAR	2447	3448	3448	1616559840000	orphaned
4739	3NLLey16BwLtbmEWqmHakpLPyGQcezJQRde5rvzbbqC63PUuqzy2	4738	3NLv5Af3Apgja5Y7qRydmbxL2xaaKrnHeFuknssnhCCuRoXDZaFp	1481	790	45	1	4602	jxuRmosA5P2wpKCt3sT3J2pm3xpDZV7P7HmTa82ed5ZhzoTJPdL	2451	3453	3453	1616560740000	canonical
4744	3NLR3x7ED8F5VPnuWsWTkZmhHY71MQ8hMXogdNjCNw2BiJFU3ukW	4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	448	1305	45	1	4607	jxCNmPbCjNQKVe2Gk74hTWneryyZ8aS26jcG34KWaBrgzqQEKZq	2453	3457	3457	1616561460000	orphaned
4752	3NKPhYqU3ZmoUGKjtdgc9aCxbRz8QpTVGpZNKFAefMbnzPJkYVTD	4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	1513	1253	45	1	4615	jwpzRCzzRQXKAuJZGBW9SpZi7DSuYFXN7zLHEjVDP6YQHDK9hLs	2455	3461	3461	1616562180000	orphaned
4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	4750	3NKwMHEGKsasUE261BxR858Ukk7EAdGqB7QEzhu1yX8op52mqG49	1458	1077	45	1	4616	jxummvYkUxUZXhb2bMPgKuDKRca7qEdtQM4KheSs1Yy2sMzoegn	2456	3462	3462	1616562360000	canonical
4758	3NLsi3WG4mgsXZ3XriwyeUAhXqwDJEVbQZmvHBfCSFXpnwqa3rUp	4755	3NL7FKceYPxcaR1T5Z7vrH3d8yjuWY89EsSieubFDjEcE37wMxKv	606	1295	45	1	4621	jwruFuFXDBxwyuYXCziuhJ3TgTvUZ1BAwmML2P19pWFuB5LJsU8	2458	3464	3464	1616562720000	orphaned
4761	3NKWdQYNVkC5fcLEvbnkVgBTTAZWD7Aok3F4uvjTyAWuSfNBmrdf	4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	1406	1393	45	1	4624	jxd4aMxVFBJZtSdQ6PtLiY2fwXj9EhGZJZYUYVAAD91duiqxcZy	2460	3467	3467	1616563260000	orphaned
4765	3NKCkZ6tpoVwXizKM3fWukqcHXNeNRVAPnmh7FTmk3Ea8qtpRkwP	4763	3NKAFcZAMuLR9Fk5qdvSYiriB1T2aNb4xzzm3UfVKiZRpyo2uqNp	1406	1393	45	1	4628	jwEWz6XsMf76JVxaUPKexgLZn5TWpsreypBzsoxBUoW32mPbbxn	2462	3469	3469	1616563620000	orphaned
4767	3NLxDc5wUKWtYsBAU7Dpz95FHTHi4QwSgEBXRhsqgJAk62zSFc8J	4766	3NK6SkpQwop8eVAr3DzFFAJRyEpThb7FwnLd3dGPFR8d1mvM3hfG	1631	794	45	1	4630	jxvyRAcXr9ifco2pPoWWQ9zeYWNd5fzHP9dukqbuwooYFJb4HQR	2463	3470	3470	1616563800000	canonical
4776	3NLM4kz1cEVLRAmNmbM35P5UoziSvgEot8zrMa1zEem7mZPxC8Fy	4770	3NKeEiUnDuQ9KYEJACxdJTDMcpz7F5dJ1yHMafugSWuL37BXJWkF	1451	1166	46	1	4639	jwojzkuM2CXwJbT6QrHPdn3hJ7y66G86A4wzLEy7Rqv4yRR7sRc	2466	3478	3478	1616565240000	orphaned
4780	3NKqVuhYd3ipXLZPKUcwoAoPN2NcSjb6UQXvwNNFzF8xqvB7iCng	4778	3NLsmGraotstnFzbnVDNuzCZVdLF9m8KU9uasnk6Jj1bEMAf9y5n	1422	1337	46	1	4643	jxwCPA8BCKNX9gsRiwdeuawcsYKZ1EQxoKk2RBRGzgZ72aFAN3s	2469	3480	3480	1616565600000	orphaned
8775	3NKzecrDRZCUxWsU1cp8QzYH4QGd78PYJprzgSRb1o3kzFVaKRHi	8773	3NLNYrFym27EDRoti4Q4simodruJzQZEeYLAFebrXuTydmccnf5h	1631	794	104	1	6301	jxM3Kci2M14F6cAP8NMKhZn4rMrrcB8VAXB3cy5EfjJU74TKJf2	4551	6413	6413	1617093540000	orphaned
4694	3NKV7BkTV64aTDKAmR47tPVNAFc2qGayBRaGM6LvEUR1wq7WjnzB	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	1622	1110	44	1	4559	jwJQgh1Gqyg1Du5dTHngGw7xHHuNP7qoWYFrTa5GCT6ywtZSKQw	2419	3424	3424	1616555520000	orphaned
4689	3NLDHWVj9kRXDH3B86k3CTbCeTCe6QuZPnnUStTH3244RcTMfvWT	4687	3NL4L7YzgaN9KQHqULebstceGdnqMEnWmBkASpnMwMJGzSWKJLK7	1637	816	44	1	4554	jw8c5cHjWNjtdWj88kmYsHLh1HfVRHW64DXx2B2RTkQbNgc1LHU	2424	3421	3421	1616554980000	orphaned
4695	3NKQVrWEEqVxAQXF9Rd6Qt2nv9cKpyDt1ntvPGhajfPFbSgnSCRB	4692	3NL7Ho5ywVpXZQbKqnJNVkBMy3com5Nx8viriKUnBSWY7g1RXJPa	1622	1110	44	1	4560	jwoF9bduQ3X819veVcqa4SdepTPXqgGctAtY34tNUwXHkX3o7hS	2427	3424	3424	1616555520000	canonical
4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	4696	3NKfrxikUW76xDqvJkGaXngiY2ktbicdtJscqdfFNFbJCnWntxV5	1397	838	45	1	4562	jx2xJ2T3PCm51fzm3qbJqQqbLjeNjXuaELnYq6gUHUnonLCRrvY	2429	3426	3426	1616555880000	canonical
4698	3NKzQ6onHmKR6L5y2U2E7jYBoq6HbeRLmczotwBxWbvFp2quxAmY	4696	3NKfrxikUW76xDqvJkGaXngiY2ktbicdtJscqdfFNFbJCnWntxV5	1649	1383	45	1	4563	jweqmaViW5Hz8szyunUULGNXeFMrvXvLnqvZtje1xjZDZACFb9T	2429	3426	3426	1616555880000	orphaned
4701	3NKuvbgewmHPi879EmEvW6bj94jYuMua8FQ9y11e5ayP6caYbd91	4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	1631	794	45	1	4566	jy2MYaKY3udr9TwcBSobn2SjWwuAedWUAUU6B8dHR1tWEHFcqxz	2430	3427	3427	1616556060000	orphaned
4703	3NKvkqPYVyN9HTcRjaMVL8D2BixvMQu52RTMxBmMPuaLELosXwe1	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	311	1061	45	1	4568	jxstcygNwiRykKERQnn9gthvfboBfuE9hbHS73nryJp6UUsysUU	2431	3428	3428	1616556240000	orphaned
4707	3NLUnLigAfpZDyzqMR3W5kRrbbF6fAf1cTZB3i6BvdjL9eYZFXkF	4702	3NLD9JrxZsYeV5VBYh4UMgFdaqZXbAUN9TGK4tgW6Yxk7GfkeiZX	1672	1159	45	1	4572	jwdKrPJA18dLRiYfjF4j1dPZ4EpBrZTMV2wyvWBCHQBS6aoThTK	2432	3429	3429	1616556420000	orphaned
4708	3NLtjfZQqcdBgN5JudGBf6pa9N4CjeBQJCqBk1k78CoLvmCBf3FP	4706	3NLRxv9RPQWXbP3U8Ln3bubnRv4U79vWDeYKeNUXu3toUK2ha6yQ	1406	1393	45	1	4573	jx47qsQWLRSLqWNmWKTmqqwRcumyZrjDoFUduYaTBfc7UPs4SSt	2433	3430	3430	1616556600000	canonical
4712	3NK5KGeKgMCEjkmhwwtF9sQSzZeteabkM2TWyjZp4GQVZAaKNV1m	4710	3NKjU2TRzk4PvXKsbFJ2z1mL9Q5qzF18CVCpjkpFb4s7kBZKGzuq	1573	1318	45	1	4577	jxoz8qEvWmLD6iyDPdiGu58KTwiwMrQwuKB3bHY5s794FMV9B2n	2436	3434	3434	1616557320000	orphaned
4714	3NLb9XhkVS7WQ5Lrfo7E3KDsPN5MJycekjqJEG8mCQqCdJ9HDrLf	4711	3NKDM8bgxn948dnn1oWZp6fvQBS2Jy2297xUoJ83vdy5mPqmECh9	1654	1340	45	1	4579	jw8XTv49t7JGnv2GyFcekLTSTXngdGeafg2VinD9WTfc5cbwy8h	2437	3435	3435	1616557500000	canonical
4716	3NK4pxSGdA9YK85khAwvrYCNf4MUcVrkEdrWTWKdhtgN1XYZ3DfK	4714	3NLb9XhkVS7WQ5Lrfo7E3KDsPN5MJycekjqJEG8mCQqCdJ9HDrLf	1675	1342	45	1	4581	jx5ieFXj4yhhWh3Qeqh21rtNCLbEKBULB5FrMXBsZmwRBpuJfTJ	2438	3436	3436	1616557680000	canonical
4717	3NLCBrAZ1zMpvbHL5bfPhCHninuvM1W18nGcxFeiftNHs7aEtx8E	4716	3NK4pxSGdA9YK85khAwvrYCNf4MUcVrkEdrWTWKdhtgN1XYZ3DfK	1406	1393	45	1	4582	jxSnFmUgun2rEgF9Tjax9eVcbYJZ6WETq3w4fNjo6tJaXW9zrku	2439	3437	3437	1616557860000	orphaned
4720	3NLV36JM6RWeQyGKewe9N1PWkyKMKNPwREYmSba78Fu25xVSjPD1	4719	3NKbFW7vHxu655nDJZduYqebQjqFSNVDdiyD69YAmJ7MbeEgTGCD	1593	1100	45	1	4585	jwoyr6eVzrcmEx6c9fLRa9nwXX7CBjiEBHXjnyXFfzSP3RWjPTw	2441	3440	3440	1616558400000	canonical
4726	3NKH5SThcLgCQ5U9EN6mjgyHMRqz7PXrfgQaLmYD9JjH8nN95Uw6	4722	3NLFjme8kAa9nTxkK5qLqVgFP9ad8EfsFdoKBwdEai3T7zkEFMdx	532	1303	45	1	4589	jw7wcMsdKQQzR89z5M9KmsVzVQYMHEM5ynqm9w3cWr6JS8bGRgX	2444	3444	3444	1616559120000	orphaned
4728	3NL8WnUnPiVQL35a7AXZ6TsU5Ry1FzM8JnT2VN14F5382DApSxNG	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1406	1393	45	1	4591	jwEWtyMXYq1JgSg63aBABuPx9rLReuPGJjkPFXxnoDym5ti2zbf	2445	3445	3445	1616559300000	orphaned
4732	3NKNvNQTWGaCqx3x6d64ngXrLEXUAnqwvbET47jufVs1NbmhQQhA	4729	3NKe4H3pqEzjkHTV58p1ZgRyY2BRThZDcCjRkA67y4P228LgFhNG	1646	1228	45	1	4595	jxn7PTpVZNut5RhBitxMwkP4LidMyc8T6ficvCqTfe1XwJVevnn	2446	3447	3447	1616559660000	orphaned
4740	3NKGyyTDK1CkToMy9QvvFwBUCHMm1zXagvMe3FaVpYMQzd2PWFBq	4739	3NLLey16BwLtbmEWqmHakpLPyGQcezJQRde5rvzbbqC63PUuqzy2	1489	1134	45	1	4603	jwYkYwwTTTNv3WXG22e5avpsSRJ5CiJKrxh3hsmfd1nAsAxn99M	2452	3455	3455	1616561100000	orphaned
4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	1405	867	45	1	4610	jwD4iHSBQQsYsHicnfJrQ5oD9NwpGdtGxbBqicgMGAPXwFVc6n9	2454	3460	3460	1616562000000	canonical
4749	3NKFeAQhHEoVdbfRRbHr79X5qAeW35fy32aNX3AxnBQh6bpak5uu	4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	1534	1317	45	1	4612	jxiysVqzAcxnEgbrS2TVDDXXQBo3KjZnfPR7kr4W1PeAcbBQoZ9	2454	3460	3460	1616562000000	orphaned
4754	3NLpW4yQF4CbqX2qTBhwpEsvbkCEYyKtafBhXU5q7TWUH8KQbv9y	4753	3NLM1W1Mk2Qdn9ZQbgnMzD3eatLUFptQuZ5YRFP7Eesr6SK3FvT3	1564	1338	45	1	4617	jxtaqpBgB9iNjBZ1SZNqi2qhV9MxwBdBwVjxVczS6Sdzoa9YFDv	2457	3463	3463	1616562540000	orphaned
4756	3NK5wKwCVAPvsDV3QBH9Ez9VRGuNXSaZJnt9v5ohVMjphA3i92Ga	4755	3NL7FKceYPxcaR1T5Z7vrH3d8yjuWY89EsSieubFDjEcE37wMxKv	1624	1334	45	1	4619	jxSubSgHrRcsNX7SaFR4AqF5CW43uwdBjZLCGF4QBk4r19zmyBy	2458	3464	3464	1616562720000	canonical
4762	3NLZ4TNeGaD7GqR8QtcuDhhsRub5mgKQPADDZZWh5uxAMB6cNDyj	4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	632	1382	45	1	4625	jxKoYgFfmo5ANqMNFyeEpN12x4UTQHUiErgVbCnTGGdHXeKfhic	2460	3467	3467	1616563260000	canonical
4763	3NKAFcZAMuLR9Fk5qdvSYiriB1T2aNb4xzzm3UfVKiZRpyo2uqNp	4762	3NLZ4TNeGaD7GqR8QtcuDhhsRub5mgKQPADDZZWh5uxAMB6cNDyj	1673	1368	45	1	4626	jwu17E4RXvD2Lim8aTaaJ89Z5V2evzycXiv6442PCjaEgrsdpPy	2461	3468	3468	1616563440000	canonical
4768	3NL8xd5e7X5qXHkaAt5TYFdDUxJqVd3ipigvXDZpC3aKKMKzMcJ2	4767	3NLxDc5wUKWtYsBAU7Dpz95FHTHi4QwSgEBXRhsqgJAk62zSFc8J	1407	1395	45	1	4631	jwYcc7n1RFjzdT8aK4KYxtFc5qGnLn71iVxmbdHfGBpxHsPsDft	2464	3471	3471	1616563980000	orphaned
4771	3NKXfZzhGHfjBu74EUScTKCXxWr6JHdEuNN7N1zYZtkQe9ZWJMVw	4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	1631	794	46	1	4634	jwWfYEUq5MrnoTrxfs2ZfB3qV3om4MXJQDaFKrsCuUiUoXRrxUT	2465	3475	3475	1616564700000	canonical
4773	3NKkAromGQLVG8PckahQNCo2Afs2wZJhiM2F17NB4SnznawcCaE5	4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	1616	2	45	1	4636	jxe62fR2ZjWDrMncx8zene1FnMajZPGZz4oD2TXByJZdFfBfdLG	2465	3476	3476	1616564880000	orphaned
4778	3NLsmGraotstnFzbnVDNuzCZVdLF9m8KU9uasnk6Jj1bEMAf9y5n	4774	3NL1hHWAATuybAFoTwqdsSToBhcAYQ2EMYFHE9sABDszqR2T7SzY	1426	1118	46	1	4641	jxh5yDZfZPzB9svP8sJjtNNvKvEJJqp5jSRNaNiueUJ2wXPJhhr	2468	3479	3479	1616565420000	canonical
4783	3NLNMu8a4JeCXuEQ5LyPcB4rYcwZnohsmhSPG5EKS6ztLkcFKBys	4782	3NK7dJ4CPHo72UP1NJG3L5RaGosYFYC43Dh8W5CB1TnMGYV2DNKP	1560	1291	46	1	4646	jx4bMvz6TEAGykPAxepvwtZomeirYAfqEYPNdYAtyecBkje38hz	2472	3484	3484	1616566320000	canonical
8810	3NLMAqFdiHhtnxXR9Xn55ARKnyVLMQyriRV6BJbiFaMAheukXEW5	8809	3NLDRsFYiafu2mQPjJUWyVPxJzqsTo4P8P6wUixnwjpYEgi98WUG	1490	1274	105	1	6301	jwM4vJthpJwJVrpeyiCq26E4WmNMN9rRuL7KUUc7WG8zFCtP7HC	4568	6433	6433	1617097140000	orphaned
4811	3NKsEZHapJGZfaHf82eAvyWAPfUJiunNCQxu5kpx2NJPFiQuHMtf	4627	3NKY8XER2fZPbj4VgefsCrhsG1t2icr5KAgW7hdahzw8SpX4QGp5	298	1182	44	1	4674	jxLxxAoBnexmCr9E9NokswG5YemaiXP8V8sBojceD5Qv4PBEM84	2395	3504	3504	1616569920000	orphaned
4713	3NKfxQhuuikDxMAwLY8Z91sqiqvJeG4CPFJsnQV9VWx5gWsnpeS9	4711	3NKDM8bgxn948dnn1oWZp6fvQBS2Jy2297xUoJ83vdy5mPqmECh9	1637	816	45	1	4578	jxYzNXssYxibCimu3Angasj2GLrJqjJhgrzrbUVLuHDSeWiWBGQ	2437	3435	3435	1616557500000	orphaned
4731	3NKN4Pqq8Quqk72WS4hxm9th849WAnvSmzkvhVmTuZRjUnP4qaGw	4729	3NKe4H3pqEzjkHTV58p1ZgRyY2BRThZDcCjRkA67y4P228LgFhNG	1458	1323	45	1	4594	jwfeWkVS2uwn4H2ndgekVgVooMz6AXAy4Notyh9XztBqBRrYeTt	2446	3447	3447	1616559660000	canonical
4733	3NKQ2imyTA1URnMtfoKc4A7mHwzzryWXPC6PfjM6PMWZKAEnF6WZ	4731	3NKN4Pqq8Quqk72WS4hxm9th849WAnvSmzkvhVmTuZRjUnP4qaGw	563	1359	45	1	4596	jwvFzb64Z3yLbmsfS9Zk3Hhz5WVhSUDNJwyjf4MhvfcSJXVLae4	2447	3448	3448	1616559840000	canonical
4736	3NKiuCkwVYzh6hgnv9kVqBA2qxgVG2ZdZvf5aM2WgjUKNwhhJWfD	4733	3NKQ2imyTA1URnMtfoKc4A7mHwzzryWXPC6PfjM6PMWZKAEnF6WZ	1534	1317	45	1	4599	jwt8oCDF5tFAW3TrGHqXZCNnbQ8kzDkNqYHZtrNy6rKgAZP2rL3	2448	3449	3449	1616560020000	canonical
4738	3NLv5Af3Apgja5Y7qRydmbxL2xaaKrnHeFuknssnhCCuRoXDZaFp	4737	3NLBGYtPGoM53Y2L5h6Zp9a7zEnVF6C8jBb6wuw9y5YyLUYcbq8M	1402	852	45	1	4601	jxCEcPAUy3aRUrUGGwQfSUMzgh8ehtmNZKfi27ogvpQqKnWXBnH	2450	3452	3452	1616560560000	canonical
4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	4741	3NKMzYaYQfcqNTRM9MqU7nEMtgszBbFCoSh9Qs9isrABRaGVbM68	1406	1393	45	1	4606	jxiFdyb6KMfgh7MQB1ZSuxC3bfkbNTMcdPGrYkDmLYgvrkCn3YN	2453	3457	3457	1616561460000	canonical
4748	3NKZy4SZMfkLwrw5rghs5ximZSmG1EYM8eYEwrqwjqF1srur4DGK	4743	3NLEMf84Pyj2AMEuMLApJeYaKZBJ53w5jzEYG6EUQ7KtowiwoMyw	1564	1338	45	1	4611	jw9g9ANb95H1wbLq4yTtXtdfVYy8DqFpMBn5Wx4fvsUWtnZmALZ	2454	3460	3460	1616562000000	orphaned
4760	3NKz3vz3Sw3s5TkgPUTBi3C3Pd13HJcux2zMBEw6MGwp4NCKxQKr	4759	3NKHPQjN3PRVj9ooFa6gRSdUumoYm4Thmb9QtvfS8H6G52GGYsJy	1509	954	45	1	4623	jx9Q9wERjAb3V6dGbrb581Ts35stLGB5cWyxyEXmaVMogsc1Nhd	2460	3467	3467	1616563260000	orphaned
4770	3NKeEiUnDuQ9KYEJACxdJTDMcpz7F5dJ1yHMafugSWuL37BXJWkF	4769	3NLFDt3AYyn1QDqBMqTCRj3wWgZvDQzUfEwN9rVk1nBwwPstFGoV	1407	1395	46	1	4633	jwjjiyNyCrYMC4P7727SjUeueXyMefM5etoV7Jxe7VmNNvcxiy1	2465	3475	3475	1616564700000	orphaned
4772	3NLfNtf5zxXvax8q8p5yGa1yei6y61rBrMMvRayPsKbZsbqGL2wq	4771	3NKXfZzhGHfjBu74EUScTKCXxWr6JHdEuNN7N1zYZtkQe9ZWJMVw	1402	862	46	1	4635	jxzwkN1AJDX7v2pPwmsfXfo8S8wt1nsn3E7w9VZtQGQ9nytiMCH	2466	3476	3476	1616564880000	canonical
4775	3NKR1CQxbgwjPUbLTSAiwXCxJ9ji3gDCCWZv8hFBdzFKZdrgbTVi	4772	3NLfNtf5zxXvax8q8p5yGa1yei6y61rBrMMvRayPsKbZsbqGL2wq	1451	1166	46	1	4638	jxmE4cbBLYbXi9ZSqohfcawVuQ41t2Mt8BY8gf2Nid1JiFLfddx	2467	3478	3478	1616565240000	orphaned
4777	3NLVwVYsrjYhRJDjz3gem16tebciC8K61DFMpxmdH9qnEEHLBJxB	4774	3NL1hHWAATuybAFoTwqdsSToBhcAYQ2EMYFHE9sABDszqR2T7SzY	1458	1077	46	1	4640	jwpu2aJk1jrf2yVkcXtUA4dm96Wm3cHUtwJ6dZjUQTUt3b7fKb8	2468	3479	3479	1616565420000	orphaned
4779	3NL6HqBYgPi3qwmaGsqRU4e59qys1tzA9J4BzBUcAfWU6REPpK1e	4778	3NLsmGraotstnFzbnVDNuzCZVdLF9m8KU9uasnk6Jj1bEMAf9y5n	1403	824	46	1	4642	jxAZxvgyFvsyThbDf1t3Ayo2LadH2KrQx3deeKjQDeyY5jkzY7d	2469	3480	3480	1616565600000	canonical
4782	3NK7dJ4CPHo72UP1NJG3L5RaGosYFYC43Dh8W5CB1TnMGYV2DNKP	4781	3NLgp3x9L3YT7BCoZN1ajpmGWYX5VvWuTJkTE1XJsR8zM5kRAs5Q	1439	913	46	1	4645	jwCYW2iHU6LNEjBBsRTsHxDycVweV6RmSHpaMY3TCk6kPzhEmH5	2471	3482	3482	1616565960000	canonical
4785	3NLw1hAxiRbQAFfeoowyRtRFHbso9XBojeXW7rWeeXgGKf2DYp1y	4784	3NLkQaEPEUsgd7BUzEXu7seDpherVizBp5VYph8W5yDtC2JK1USr	1406	1393	46	1	4648	jwMkaTesz7U4YTmRYA9VrCwjpPkyXXqVkR1tTYGmTegrQqvX5nz	2474	3486	3486	1616566680000	orphaned
4787	3NKQ3oYDMYoPR1LCwfoi2abQmLfH3sFL4sHCu2EjXmnVRALc2mxR	4786	3NLA5N1i1R4AyuEHKgD4Uo5c5kAnc8ULjN9LnuuHaXiNj461zB2w	1405	867	46	1	4650	jwhDhPZfDH6x161XZfFYeCwgicrGacozbSQ6sZrybkkZDLBuQ2W	2475	3487	3487	1616566860000	canonical
4788	3NLbgtbTADaYxmcX781xUc5q6XvKk7rQBQ5t6UCEBxfBYecKm3Ep	4787	3NKQ3oYDMYoPR1LCwfoi2abQmLfH3sFL4sHCu2EjXmnVRALc2mxR	1448	1185	46	1	4651	jxDgiiWLaA7CmDoAY3Pwq87cKmCBN6P2EV8VdqwPwfBJjWcBcLB	2476	3489	3489	1616567220000	orphaned
4790	3NKdHzAW2XihZoHKwdnRwmzRGwasrxUtWo6sqJZt6946QZGJEe2P	4789	3NLxaBgDG2LPWwzrcnZQzFe8gx8Rjcg11Qc68bauPb1K7xvP4kx8	1406	1393	46	1	4653	jxT5UWmcBzUnvsJ32x5i61a8MRZq1eAnq9qvWUMdb4g715zuuMh	2477	3491	3491	1616567580000	canonical
4791	3NKmo8Tq1QS2gVLc8y6B84F4XDp7wpUcqJhtyNwq3juiEhdLYjXq	4789	3NLxaBgDG2LPWwzrcnZQzFe8gx8Rjcg11Qc68bauPb1K7xvP4kx8	1617	1288	46	1	4654	jwZXd1ZurUjummkvwVv43rYhtfuaNaCo2BCWFdkt5FamggXUdze	2477	3491	3491	1616567580000	orphaned
4792	3NKL6CMvAghZez2LkiyVy8rVTMnmXpq33kpaSE885n6ThknNmRsF	4790	3NKdHzAW2XihZoHKwdnRwmzRGwasrxUtWo6sqJZt6946QZGJEe2P	1509	1320	46	1	4655	jxT1Ue7rgKS2RfDAjMY2qr4tWYAMAWmDFv3WGLPuxkYpaS8Fa3K	2478	3492	3492	1616567760000	canonical
4793	3NLi1iT4aVC1nJwX13CTV3FBcYYDQ6CxCYNMdpGLFw1rUvFVjAth	4792	3NKL6CMvAghZez2LkiyVy8rVTMnmXpq33kpaSE885n6ThknNmRsF	1407	1395	46	1	4656	jwRpvpsEjv5mxYoJk3JnfZZ2gZSwVTxJhjgEgAmXmn2aVvF7z7T	2479	3493	3493	1616567940000	canonical
4795	3NKKyFA8e1UsPqP23bXgoMk9PmCXk9Dnt7jfy7rthnxahLXaDEth	4794	3NKPsqoKnRDtiBrCLZbEmwW6jsJ3QzzQQu6DGcdKUnTER8YXdK6K	1490	1274	46	1	4658	jxZeq17EkCdN1cW7peve3mgKBrP5F6gVtAsXxZ8bu2tncPofPR3	2481	3495	3495	1616568300000	canonical
4797	3NL9hAAzUUQd2f4yeegLKg9mqGtZHLUc4VmH95ufLBwQCh6rQkNo	4795	3NKKyFA8e1UsPqP23bXgoMk9PmCXk9Dnt7jfy7rthnxahLXaDEth	1631	794	46	1	4660	jwfvNZWPqSXFunBuxPqGSaeya6JTfHnVNeAkP7mKjD3W2YcQbmg	2482	3496	3496	1616568480000	orphaned
4798	3NKAoftdvzEH2qRFGeDx2jspFPXrfepxVSJqYpYGseKMiVmRALLw	4796	3NLSnnPkPtbetxtqerBfQqbFDLgFH8bc1DAuEgwdbYVUdR2r8m8F	1518	788	46	1	4661	jxUNt7Vs7TvpXSE8sxZeGa5GAM1X6rxGkwkViYtdbeuvLTirhug	2483	3497	3497	1616568660000	orphaned
4802	3NLLc38q7u72rKf3c39TKDKym3MbKsUa5WXDho7G99aT9viW1oTa	4800	3NLbmb59b8AEw9opBCEEmuAnGTcyZFP32yak1QyY72EMeUyY1WLk	1650	1129	46	1	4665	jwjchDFWAQvEUuoS57VjtooDmu1Wk6ptMKj7xxDDqctidJAi4ab	2485	3499	3499	1616569020000	canonical
4809	3NKrjsU8V3WrMrP8EJuSKzAj8dkaqTMFRqajNFERdiNCK9rA5SHQ	4808	3NLtJ6YKpbiNLkYZDA8bZVYMnrf9B26HwEHJf11r6fSDeqkD5Fns	298	1182	46	1	4672	jwkqj2f4Z2WEVMHd6VWUAEMfBdXn7h4X7M4EPCbMigDua5r2nzZ	2490	3504	3504	1616569920000	orphaned
4813	3NLZP7ayZ4miY7bAAzPkHrAZhtgcQZyQn5AuKQP117F5akJFLABX	4812	3NKejg5sVq8mjYGfzhDdfADWF8tBX1qbBett3YpUznHDwP2P7ExE	1581	778	46	1	4676	jx9S25t6D5vpnSyzyyUpTHBroNSiBho5D9qQkzHUtwNLtxnyxDV	2492	3506	3506	1616570280000	canonical
4816	3NLa4rH1N21dbpDGrBPfxWrP3NikPyFkGX2JtNHQZ3js65qeHyti	4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	1507	1034	46	1	4679	jx8v927C98SSjLX8N23j7mg9eQDzwJ5iHUruPStdq4nnmZDLKmJ	2495	3509	3509	1616570820000	canonical
8958	3NLxSwKr9J4RLYsprwfnjzZA48L2GwNyuEZhhwyGoT9J5cDmLtdd	8810	3NLMAqFdiHhtnxXR9Xn55ARKnyVLMQyriRV6BJbiFaMAheukXEW5	1500	1051	105	1	6301	jxVE5XRfrF4ALssbkCgFaex3TXP5UTeAkt8hL1MSUmSKTfMLCDM	4569	6538	6538	1617116040000	orphaned
4794	3NKPsqoKnRDtiBrCLZbEmwW6jsJ3QzzQQu6DGcdKUnTER8YXdK6K	4793	3NLi1iT4aVC1nJwX13CTV3FBcYYDQ6CxCYNMdpGLFw1rUvFVjAth	1596	1237	46	1	4657	jwCrNgUA7JZiKbp3vsoDfJnaPBNqE5vSa6eEU2GEDre1B8y8mCR	2480	3494	3494	1616568120000	canonical
4800	3NLbmb59b8AEw9opBCEEmuAnGTcyZFP32yak1QyY72EMeUyY1WLk	4799	3NLuZYRdnbwCspp67iMbxfuFAPqn5FW5z1LNWmueoyvnGzJFWHp2	1403	823	46	1	4663	jwjwPHoia6ReczHZ7iQRtz7g3BgPQpdMpUUUMuYH84Nu8kCLfFm	2484	3498	3498	1616568840000	canonical
4804	3NL11keSnpgVKs7NdUFqispxKmLPL5131hWwrg7j4GTJbMD72esF	4802	3NLLc38q7u72rKf3c39TKDKym3MbKsUa5WXDho7G99aT9viW1oTa	1402	852	46	1	4667	jxRY5y2JV6cwrY9q83sAnbrvGKj9qM2BCRGb4C239zbBrKFK92X	2486	3500	3500	1616569200000	canonical
4805	3NLQn6CaNEfFw9Wg8wULwi25sU8epUBjsyo3YodGTbjWYeWpgbjV	4804	3NL11keSnpgVKs7NdUFqispxKmLPL5131hWwrg7j4GTJbMD72esF	1406	1393	46	1	4668	jxjaSs8jhpogUcWpYW9gvDszYCYA5hJ6LqLh8jVpwZ2rsXrXLXL	2487	3501	3501	1616569380000	orphaned
4807	3NLu3jMu3hfAyaQtkeFHvar9KLDCucuaSyG5G6mTm7MBa67okvGf	4806	3NKKC4KCftjbua1taj6FnyN8sVcEcD1vKwFaT7hozeRuGkVV5QCf	1560	1291	46	1	4670	jxpnDzNFTWHknrW9EQQM8jNFKjkhGRmtkjbD8UF8ZuMdtRerHHR	2488	3502	3502	1616569560000	canonical
4810	3NKARJGPnJZYkpek1iUzMSZA7oWHJmcFxtPZyfh2yP5NaCQQ3xoB	4808	3NLtJ6YKpbiNLkYZDA8bZVYMnrf9B26HwEHJf11r6fSDeqkD5Fns	1407	1395	46	1	4673	jwpBdCwU9GUrvxcYZqpsr5J62fHddRs41F7XoV6TciFjfGW8TUh	2490	3504	3504	1616569920000	canonical
4814	3NL4Qrx9tVaurrwA7f9prukgSkKnrvGigdrW62kvq2amKb1MTdfr	4813	3NLZP7ayZ4miY7bAAzPkHrAZhtgcQZyQn5AuKQP117F5akJFLABX	1571	1209	46	1	4677	jwEV6y5ujucYhfcY676WkPTKMhFxe3QyZH6SEQZ1YYTJSxNLzD4	2493	3507	3507	1616570460000	canonical
4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	4814	3NL4Qrx9tVaurrwA7f9prukgSkKnrvGigdrW62kvq2amKb1MTdfr	1448	1311	46	1	4678	jw75svhBFsRcHN6QdAxHcfJoq8BCGJi3nsExKcDa9SdBTSquuey	2494	3508	3508	1616570640000	canonical
4820	3NKFirq4t8JeTYQvz9vMCJuyLFh6Dk87UPujxzF6FWhjm3iY2H18	4816	3NLa4rH1N21dbpDGrBPfxWrP3NikPyFkGX2JtNHQZ3js65qeHyti	1508	1387	46	1	4683	jx1ZF5q5sWbiQnCKeNbKpuH6VyjGQfPQNbCG3NNfdHidusnsFha	2496	3510	3510	1616571000000	canonical
4821	3NLmseDXwE4XzkGvEynz9bHhB9xnMAb5EY74JZ4GJCDvn28J48KQ	4820	3NKFirq4t8JeTYQvz9vMCJuyLFh6Dk87UPujxzF6FWhjm3iY2H18	1407	1395	46	1	4684	jxKuhgexNkeiDSUmpuAVsa7Kypww7pmXEKYctH5SpvU7eD7Ktv8	2497	3512	3512	1616571360000	canonical
4824	3NKerSp5cadJPCSfpG7GpYZ1Ds67RRcWoS2KDm3LdyDcdj7SRBUG	4822	3NKwmUxnoZMzfCfzAEkZeQhPsJdG5a7PnTNjHhFxErAHjR5NEpwm	1407	1395	46	1	4687	jwsD4JFKviQEXE1XtiMgtwYcv5WdoGvHXKZVRt2CeMQUECq2UtU	2499	3514	3514	1616571720000	canonical
4828	3NLqdTPrVoziR7wnxsP2CWZNUQsfFKbLbggjitbZUTyFjziy8RdL	4826	3NKEg4yJWqq7cnptgKLjiusRSnnoBkTeYjxqJL2gSyNM9cPFJS2d	1406	1393	46	1	4691	jwZCziEqoNfqVzaXYBnXkbBck7xxBUxByU33qz1AtNUrGbp7yW9	2501	3516	3516	1616572080000	canonical
4830	3NLBtPmUtoNyCFatqB1tcrg9D72WWKf8tr89N67zGZkvsvrNL4nZ	4828	3NLqdTPrVoziR7wnxsP2CWZNUQsfFKbLbggjitbZUTyFjziy8RdL	1642	1121	47	1	4692	jxaQxCAnKCL1UXMgW7zPjJ2eVKDB2G6aGChmhFVv14uSc4HjfBP	2502	3517	3517	1616572260000	orphaned
4836	3NKxKGcFH9ni5ii8kDS4xZ44pTJ9Yj1MN6pGWMWSEE9m3SyRUkn8	4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	1534	164	47	1	4698	jwpvve9X8TQMQepUH9h2mEGqzdaYKBUfHouFWbskU5GXhtWdX27	2505	3523	3523	1616573340000	canonical
4840	3NLf9Kbtww4RbeQxAcBS5owJpyavYYjzEi3AFxZ3NNNiXd7Wp6NU	4839	3NL2BWb5hkCYVtnmEHHj2ZsuwPBFzri1hxqhpTrzxcoZqbhinZL9	1555	1347	47	1	4702	jxyhuEQ6XHr6gHhJEgMpA8BYEBFapP6C4mjvtbDJmZZmpxzkpZR	2507	3525	3525	1616573700000	canonical
4845	3NKffFRVt6TeT8bFbZXvTeJtqTfxznGjfeBS1PChRkruhVnviuw5	4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	1564	1212	47	1	4707	jxer2RbR8bkkLBzjCV7HnyitPHuMBg3j7nUGw7siwbHPVF65gYH	2510	3529	3529	1616574420000	orphaned
4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	1642	1241	47	1	4716	jxjWSneHTfLZFNXdAfo8kWS9FVFw8QSN11j6X8gZbKQsBLGL8AX	2515	3534	3534	1616575320000	canonical
4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1608	1163	47	1	4720	jxAPvJP11xgdmBmiQeuwiNBP7HcF8YGikbbLqdJB2YW5NLHvmpT	2516	3535	3535	1616575500000	canonical
4857	3NLPY49a3RuyBE7426Nxept9X2RXktztTG6feTUKEwMVbuhyboET	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1577	1081	47	1	4719	jwmM8k4RJsM7umrzGh1EvULgqB4aXQEyb1iTP6dhHafeWN6P7Ag	2516	3535	3535	1616575500000	orphaned
4861	3NKmTB4MXwNH6iG191rvx5Kig1ZUTmAeHuiSKtwfNvzVcKL4dVqc	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	1403	824	47	1	4722	jwYYHLnJpQNxV8EWZg3LD9b4n6p6HgoX6BfCE1Rh63eSBz9A4e6	2517	3539	3539	1616576220000	orphaned
4868	3NLYJDT4UJLwGC73Z93UJSjfrCUdY5KnojcQ1LeVhwTQxuihjTUQ	4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	1483	127	47	1	4729	jxDJCdYeNDx1N24f8MrQYmd1Cmm8y5y588dvPp9gs4Z2ARqd7AT	2522	3544	3544	1616577120000	orphaned
4876	3NLsYAiih34qazNQEbanG54yNefQE5hQcKYBpwZfUpRe5aHNjYU9	4875	3NKzQKvBe7NZCjWjRdKcnTk1KdXTzgjqxiD1aCt9UA6ivAtYDJV3	563	1359	47	1	4737	jxpJky8nTSyJNhxNwBFbe3yFecCKwDqEyLc6KtkHUbXv3c3so29	2525	3547	3547	1616577660000	canonical
4879	3NLhq4KHw7rstWCWLgS1z7zSwJ3PKURJwYVFS2rg1mwxQ8TGG7ci	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	1406	1393	47	1	4740	jwCfNYgXAmFzfJmdLW1Nn4aWL7S1XQmWjwneqwTv7tnSN3rFF7S	2528	3552	3552	1616578560000	orphaned
4882	3NKB43FvZdzHocdkznfbs3wAGWBfEq9X71FaPSZ7qFLSFRpUdxXS	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	484	1193	47	1	4743	jxZyxKmQhdAfBxhtdyTW5pqBm4J5peBxhwKJW3BX788UWuh7gqx	2528	3552	3552	1616578560000	orphaned
4886	3NLSZphgWqp6MCtjHbvcCK8yeKAGeKpQTbpT6xomXkR2v9VrLeFG	4885	3NLQoR5HRGr5Z49jos6hCgK1PhFjkbrBxEeg2MSDxbnGaHPU4UJq	1657	1344	47	1	4747	jwoZNtDUXxKHYKfSkVGnydeRXc2U7negSpqqFVQ6D1VFt7QgThW	2531	3555	3555	1616579100000	orphaned
4888	3NKobNaWAEY7Yg8MgdKh17xwkNTww5GYDAxsamdUnM8VHenmmPXb	4887	3NLpxGLNTnWaqMuqK7NZm6dkDrStkZBB2u62F1Z2zv2gW9DgdsiC	1589	1286	47	1	4749	jxH3WTtBvpwgaDCyVo8etVC6NPkrC2gHa1tfHnkBUjRGiYQHdTg	2532	3556	3556	1616579280000	canonical
4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	1406	1393	47	1	4752	jxTXz9SwnD5tQvufTtCSH8CZAsJUEBgWtQnykAmSaDaf4gHLEmT	2535	3560	3560	1616580000000	canonical
4893	3NKWaNFeL588H8ogL6XL31h8nbbTJPJcpHueCw7bWz2sBxe9G5xy	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	641	1090	47	1	4754	jxe99L5JJNzgAHDzGzZ1Pc8cMf9rcE15uxqzJryNLMbHJeimzyF	2535	3560	3560	1616580000000	orphaned
4900	3NLdN6syXbCNjuzn5NbFuDe9UsG1EPp6u1WmBTC7gMUKGicWRkEd	4896	3NKDBWu7DZQpsFJhXZ4d352YedxqEi5U3L751ebpiB475teYDAGE	563	993	47	1	4759	jwUHHhW4yBeWnHJaD6bpJdBeQETybSeRCdFAKnpFMHYxcWS5HDg	2537	3562	3562	1616580360000	canonical
9197	3NLMJHZLjuAHnNRJSgqSFFq65i1KkZdWbMksPoG9xgrq5D3H84so	8958	3NLxSwKr9J4RLYsprwfnjzZA48L2GwNyuEZhhwyGoT9J5cDmLtdd	1500	1297	106	1	6301	jxFoAXs5KBBFHtqQi4PHyURz4KJD9Vm4pZDFx7JVc2i4mbN2FSx	4570	6715	6715	1617147900000	orphaned
4789	3NLxaBgDG2LPWwzrcnZQzFe8gx8Rjcg11Qc68bauPb1K7xvP4kx8	4787	3NKQ3oYDMYoPR1LCwfoi2abQmLfH3sFL4sHCu2EjXmnVRALc2mxR	1507	1034	46	1	4652	jwJ8XUmcZ6dXrGDa4DzASXmj6dJtWnYtegXhm55WmepAtV2afju	2476	3489	3489	1616567220000	canonical
4796	3NLSnnPkPtbetxtqerBfQqbFDLgFH8bc1DAuEgwdbYVUdR2r8m8F	4795	3NKKyFA8e1UsPqP23bXgoMk9PmCXk9Dnt7jfy7rthnxahLXaDEth	1406	1393	46	1	4659	jw99ykgnvQc96d8qYN8vkcGgmfcYiuNaQm2mXm4AWniPY1ts8Du	2482	3496	3496	1616568480000	canonical
4799	3NLuZYRdnbwCspp67iMbxfuFAPqn5FW5z1LNWmueoyvnGzJFWHp2	4796	3NLSnnPkPtbetxtqerBfQqbFDLgFH8bc1DAuEgwdbYVUdR2r8m8F	1585	1366	46	1	4662	jwPUSDyFxrQe9qUWnss9TPusCJRcRsJgEjjqoBvVV4DVbrprZEg	2483	3497	3497	1616568660000	canonical
4801	3NKAKvufK3FZccYT4P6Cfh84ksyaeBojYYEsVxgFca7ufRs4JuT1	4799	3NLuZYRdnbwCspp67iMbxfuFAPqn5FW5z1LNWmueoyvnGzJFWHp2	1513	1379	46	1	4664	jx1xDJZ8GLADSUgSgDuoZQoBbQaUjtsz4hEvsTb4ryJaDWG1ySD	2484	3498	3498	1616568840000	orphaned
4803	3NLuhu7DiLFYBNXsUjQGqvgdDocnK4y6vq54qstkydQUS58ujUz1	4802	3NLLc38q7u72rKf3c39TKDKym3MbKsUa5WXDho7G99aT9viW1oTa	1448	1065	46	1	4666	jwjXzqsTJt5PLbh4QAjdPYwU1zsVUVtdcvy5hp8XDH3WjMT4c8t	2486	3500	3500	1616569200000	orphaned
4806	3NKKC4KCftjbua1taj6FnyN8sVcEcD1vKwFaT7hozeRuGkVV5QCf	4804	3NL11keSnpgVKs7NdUFqispxKmLPL5131hWwrg7j4GTJbMD72esF	1596	1363	46	1	4669	jwF1p4MxZ7KHBaHQ5ny5Wm1xHGk8b7ViQFk6BAWZT7cJiGRDN8w	2487	3501	3501	1616569380000	canonical
4829	3NKcF3s21Qdq1A52Ab6jrrNXTuRq834AF1eLEmkT5EkHDygVyZ8R	4828	3NLqdTPrVoziR7wnxsP2CWZNUQsfFKbLbggjitbZUTyFjziy8RdL	1642	1121	47	1	4692	jxaQxCAnKCL1UXMgW7zPjJ2eVKDB2G6aGChmhFVv14uSc4HjfBP	2502	3517	3517	1616572260000	canonical
4831	3NLPrFG4AN9fyCHwsbs54XhtwA9a91N9Ac73DPj4kS96kro54mfb	4829	3NKcF3s21Qdq1A52Ab6jrrNXTuRq834AF1eLEmkT5EkHDygVyZ8R	1668	1370	47	1	4693	jx87dViFnMdkEyyiDbGurjouLw7cG2wJrmsBASuvDVgeJsnFWuw	2503	3518	3518	1616572440000	canonical
4841	3NKT8Ltm9XNjjpyBXkLti6UddpcUdUstgKQPaMD6RZbV9fgXLsxZ	4840	3NLf9Kbtww4RbeQxAcBS5owJpyavYYjzEi3AFxZ3NNNiXd7Wp6NU	1406	1393	47	1	4703	jxMZa4RGHDU5yZvF3wr6XjfeJSR25jUMoHUpSiXAwSyB2XN1Z2h	2508	3526	3526	1616573880000	canonical
4848	3NKePjVofTQpayx6S8PKfBWDTERSzHqr4pwDLjqDt4Qr6D8n3wt8	4847	3NKQ3amkdFFY2cxGz8bALNXySLrYjAQy4CxjMkbpTst7pg7RhDJj	563	993	47	1	4710	jxjFWVsqRkf5TwSN8nppcGTnKRaB4ptbCyD9Vh2VDDSDXuVvg1h	2512	3531	3531	1616574780000	orphaned
4850	3NKFy9QyHwhWQ42E1FSYe6XXLK1CKozLPgGU4AgbZXMiQjCt6YCN	4849	3NKTLMScpnLa6KZKyBhaNyGP3Uu2obC9JS4qMFXCoFQvuuUADAkK	1637	816	47	1	4712	jwwDe2gHEczun3jKG3bi2HArPV1mfo3sSC2hVcuwUcx6YN6KDdo	2513	3532	3532	1616574960000	canonical
4853	3NLLAY4P55TF8kZ35htQvAhDFPVEZBnbYAsgLzu8TtV471QUdrYA	4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	1587	1231	47	1	4715	jwtu8aoze1hqAXHNj8gxiYaGr3dCEFqkH1LmafyzcKNV6EXM618	2515	3534	3534	1616575320000	orphaned
4855	3NLoqb72bWLJtRvokayDyjenjVDHBSjDG7TAHor81PczWpgH8agL	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1403	786	47	1	4717	jwmVFsxWVgkxCHPbQBPTLPLDut1phhYcQFq5XVnHMYoErwcYcsE	2516	3535	3535	1616575500000	orphaned
4864	3NLAB1yV6ymXfpcuz2rW82VC3NXJfpwr9kaL8UdToBY8e3F8ioJK	4862	3NLCbL8LUVFbiXU1FiAp3zuPQH36XY1TeRSZ1tatyx9EeqJxBjkW	1610	1188	47	1	4725	jwgLWVhfzaLjSTpZrmVNSGjMUfh9imwVz7bMwZiCPjbAXLyXSMX	2518	3540	3540	1616576400000	canonical
4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	4866	3NL8sdLNYLC17cXe7jRWiS5sj2Jg9YYtpcDEXkCMPAJhebho7h5Z	1652	1315	47	1	4728	jxx7ZoPCX6K8Gm5keMjT5yKumzJH2NfRkbYbxw9JcbM54rG9sM2	2521	3543	3543	1616576940000	canonical
4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	1403	824	47	1	4731	jwMb11tvEzqcgvmJCwchvH5CTvisFBFJtEiGLH4fPkiF4AeFZNw	2522	3544	3544	1616577120000	canonical
4872	3NKnbvGrDEpV3V6LR7f7xnaAdYTj6vv11c9WA59iXY43w7tto6Ca	4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	1673	1368	47	1	4733	jxYswLZwBSoG8DAMFmmmcfTW7Xrh3oWCS74tCAXK7zozQFJJ7SN	2523	3545	3545	1616577300000	canonical
4877	3NKSN8uM1jDsmCEVC6Y3qrpaHiMXZNWJoSY87DxYMZJvxMwkDfck	4876	3NLsYAiih34qazNQEbanG54yNefQE5hQcKYBpwZfUpRe5aHNjYU9	1406	1393	47	1	4738	jxCwcPCrBNAhr1mnvqoD8o6yBneaFSTSEBAARr3DCpvUZe2AHMv	2526	3548	3548	1616577840000	canonical
4881	3NLVwwvegnmJeGF7obhpxEtacs1YMunwMH1WabewymEj5DcsVgug	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	1549	1362	47	1	4742	jxc46BnC9nx8ZdRfavBKwUQPdrsbXjcu6c4wwYouBvw9pku83Fr	2528	3552	3552	1616578560000	canonical
4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	4889	3NKbLdai3CdrzDJhGZ1Ssmft1DrJLjS1VfJfbnyAJJCEopFgb6Hf	1522	1196	47	1	4751	jwU5HKRtmJz6kvYbjQY7vk8Wtz7J1xGGXUrv5oHXDnpJmBr2eq3	2534	3559	3559	1616579820000	canonical
4894	3NKoySMQFoMSa2HD3eBDPZapoWtjNQqgyiowJyVy9tnnLWcUJrkP	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	1631	794	47	1	4755	jxwXwUQpGkDTDhS7qz1yR8gkkQZSoThsp3s5zMwCMaKBf2H6x3R	2535	3560	3560	1616580000000	orphaned
4897	3NKKLwrhqwin9fYkKmYjcoReLKrBvvZeBHpw5zUx1XYXVmJNfetK	4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	1523	1321	47	1	4757	jwVjMbRMHvLmH645MpcGq1XMT7rV86QtWpmgU2vGQA5df6MAWTe	2536	3561	3561	1616580180000	orphaned
4906	3NLabGWfnVmeVg4LW2hBQ27ST62B4yWqQCLDpskP1sx3CjLyKZrZ	4904	3NKJRGK5umcnNLxtser6MjDym2yGcuzTXFRzVEEMDYcT8TMRwvPn	1402	850	47	1	4765	jx53etQN1WtagkWRMorwWjCZ91gRbjcwoZwY4zQ1LQm1caSaytg	2539	3564	3564	1616580720000	canonical
4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1670	1282	48	1	4767	jwDQiByqyqsnk1zBym5bn2r63Qmc5DyaGBX1oAxBhZe6z5A6peh	2541	3566	3566	1616581080000	canonical
4913	3NKpCjZYxuoTBs3LfAokx8GyQ6F558QFJbKimTyjxXb8oCZQEAKD	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	563	993	48	1	4771	jxUyE654Ekk2yzJzRbsjHUP9AEzV7qwJrawLAQ6zHt5CD9f6oc6	2542	3567	3567	1616581260000	orphaned
4915	3NKCXMkTQhhPouP1AvXPPJLGTaAFvC7BHjycuoyxTmTZm6RMq1JB	4914	3NKFvNvF43qdMxWi7b3hd2LPWTC3EmBDsV9QmDPPKxeUfAdjFYjQ	633	1138	48	1	4773	jx6EVDoo1rwN46nvcFndSry5wWqp4buVguUZSDSFZ9w7FPCqYar	2543	3570	3570	1616581800000	canonical
4918	3NLQasR69yaCLgpSosZ84va9cviL5YPcpGZ9w147kq9PFgtipBSm	4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	1509	1320	48	1	4776	jwLipaMnnRiNdPWfdUiiE9SgktjuXTx9Jq5DiCT3KJkRtok6bPF	2545	3573	3573	1616582340000	canonical
4923	3NKyWrwitpZJGotqQWEZMHij4fgyxghxnUAH3cikyMXXSBQDNsgc	4921	3NLGb98R91LNjW3igEmXnxrpxYLyg7nmT8tWDVBk719uV4AWtaPw	1403	824	48	1	4781	jxGUhjFFQZjCxVefwfF9erJhzLRwbQvrZy5yZiJMPgdHQJmpch2	2547	3575	3575	1616582700000	orphaned
4925	3NKsS7stWgPsC1sfKZ6pJgR8yBCtEakjASXB21bTkr4rUMqBJ69R	4922	3NKLHVY3ZVVBUpy1iH72zUxTUWTJ4c2F2dniQgrp2Fv9vBJxkdKu	1451	1166	48	1	4783	jwAeTSHFprFBkajqap5EGnUMnMx4fRkVfAxu7a4TN7dAsYpM2Ax	2548	3576	3576	1616582880000	orphaned
8830	3NKxXp8pJCEvs2PqgquAAYv9YhiVFscfBkLw9mxm1x4At9qq1qNr	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1623	830	105	1	6301	jxxMh13RdEiyP2aUcwPoA3MhnRXb1PLjicoVXwEbPS6h1bykUfe	4577	6445	6445	1617099300000	orphaned
4833	3NLHGGbkvSjeZtkmmLeDGLNMkHczrg8wJUcr2myChBM2hiy72Gu6	4825	3NKjTJPSnNVz1VaUnSDZ61uy4Xc5ygYK3sWtTqf8wmEEwfL9Sxi4	684	986	45	1	4695	jxmdKLmTkbyR6YwWSLHXEHQ6te1mvq4oFoLLTz4ZhMoFVVAW5aY	2398	3520	3520	1616572800000	orphaned
4860	3NLMxPX4Qw4ABZXn4z1xAWdXtBnrUQiu3sVqe8Hd7hCNXZQeszxn	4700	3NLf2TRagVgkkNZgpXo5JjktpcDsHF8Umuzugm11SznzyWo7nv2y	1608	1163	45	1	4721	jxtgjfMxeuTfroiNjnAnfuVMjYJnoSW1L2mF1CpqgzxJVjsDbrf	2431	3535	3535	1616575500000	orphaned
4808	3NLtJ6YKpbiNLkYZDA8bZVYMnrf9B26HwEHJf11r6fSDeqkD5Fns	4807	3NLu3jMu3hfAyaQtkeFHvar9KLDCucuaSyG5G6mTm7MBa67okvGf	1405	873	46	1	4671	jxzZhvKogRKeux5dhqeX6hPfT3vwkV7L65nkJUit2yXXHStsJsb	2489	3503	3503	1616569740000	canonical
4812	3NKejg5sVq8mjYGfzhDdfADWF8tBX1qbBett3YpUznHDwP2P7ExE	4810	3NKARJGPnJZYkpek1iUzMSZA7oWHJmcFxtPZyfh2yP5NaCQQ3xoB	1587	1231	46	1	4675	jxooefuV5iGmHvQy3JqpreJUoNJo3ChAip4CPyxRAFD4mSzhktd	2491	3505	3505	1616570100000	canonical
4819	3NKi2FXxJHKQnUDEhEAVrmR2Zah755JTFcBnUEfnL3j8EsB91NL8	4816	3NLa4rH1N21dbpDGrBPfxWrP3NikPyFkGX2JtNHQZ3js65qeHyti	149	1283	46	1	4682	jx3Tm3NR8sA5e1sg2BkMfK4muTSPd8vHxnNKvn37wEXs1pqLbgD	2496	3510	3510	1616571000000	orphaned
4822	3NKwmUxnoZMzfCfzAEkZeQhPsJdG5a7PnTNjHhFxErAHjR5NEpwm	4821	3NLmseDXwE4XzkGvEynz9bHhB9xnMAb5EY74JZ4GJCDvn28J48KQ	1624	1088	46	1	4685	jxtmsM4jkuihaDD7MabuBHDTj49gUBefDnEV2L3PSk4PYCLQeHf	2498	3513	3513	1616571540000	canonical
4826	3NKEg4yJWqq7cnptgKLjiusRSnnoBkTeYjxqJL2gSyNM9cPFJS2d	4824	3NKerSp5cadJPCSfpG7GpYZ1Ds67RRcWoS2KDm3LdyDcdj7SRBUG	1632	297	46	1	4689	jwKYpudrgHrMCPm5CDdnjMCTXJu7EFpSUXMTREjMM2N3YVt7PV5	2500	3515	3515	1616571900000	canonical
4827	3NLcC57H22RrUF4JLATXA9zxtjDR3dFvpQRKp3uKxyGuG186De99	4826	3NKEg4yJWqq7cnptgKLjiusRSnnoBkTeYjxqJL2gSyNM9cPFJS2d	58	1155	46	1	4690	jxwgSoMQJvCX3XAT2HrdX53micenrz29gLNaaY8SBDRat24ZmuD	2501	3516	3516	1616572080000	orphaned
4834	3NLHX3WWqEq2Nc7JBnU78e6p3j56q2is4QhxFzrCwTNDfSN7cPxS	4831	3NLPrFG4AN9fyCHwsbs54XhtwA9a91N9Ac73DPj4kS96kro54mfb	1650	535	47	1	4696	jxpNMETZpqBM7vVSZpRkkZR9qV9ik2msoJc4SnfZcRvzV5njsUJ	2504	3520	3520	1616572800000	orphaned
4837	3NKrbE3A5ZH3ir1eoegekv2VWNb3QUdRoHZEcWhHdgJZc68DEKDW	4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	1422	971	47	1	4699	jxDkC5CHXxV2SVxxA83M2niQbXW6toDUj77gMRDbaHrzQ6yFCh9	2505	3523	3523	1616573340000	orphaned
4838	3NKkexjVDvs1ZbXNf7R9t4SU4ymkCYVpU8BRXSkSYzsUEitMBVjH	4836	3NKxKGcFH9ni5ii8kDS4xZ44pTJ9Yj1MN6pGWMWSEE9m3SyRUkn8	1403	31	47	1	4700	jwjbmdYG44vhAY26X416FCj8UYxVzAY7rek94WFeVqhPCKMYDFR	2506	3524	3524	1616573520000	orphaned
4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	4841	3NKT8Ltm9XNjjpyBXkLti6UddpcUdUstgKQPaMD6RZbV9fgXLsxZ	641	1210	47	1	4704	jwmvUT8iVB6Cz4Ft7ydPhUoMp4cEQohhoT9ShmohWHGgpt1b8Xv	2509	3528	3528	1616574240000	canonical
4844	3NLiRcD452WT5BoZme4HpXocMemJEFjx4NXwZKVreLmRsGC31yqg	4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	1403	824	47	1	4706	jxyeH4MhxNavCtwnvUeSJpQuoZ14xvSpxDpucRvikBKFZkXzwP8	2510	3529	3529	1616574420000	canonical
4846	3NLfYbEcEvVxLwgbrEZGWm9XNabASjpDaf7aKkmmq2vNKmEFD1pU	4842	3NLL6wF2VTeVUt8xZY6fpKLjVeBN5rz95pJV2Pjfgju7y5vdM7CN	42	1361	47	1	4708	jx4gMDw3soExKh4qTX5VgUNi5A4ox6aekhHgnVJY4aJyTyTQw8K	2510	3529	3529	1616574420000	orphaned
4847	3NKQ3amkdFFY2cxGz8bALNXySLrYjAQy4CxjMkbpTst7pg7RhDJj	4844	3NLiRcD452WT5BoZme4HpXocMemJEFjx4NXwZKVreLmRsGC31yqg	1581	778	47	1	4709	jxLwSCpYhcfrKSF1WmJp5pETRcYfpgdDSnPkW69P4hcXdsb21qt	2511	3530	3530	1616574600000	canonical
4852	3NLCDtJA17wt658HwX3iBvAa3j7TdFNzHwAppMdF83nLKf8rAfDr	4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	1483	191	47	1	4714	jx3Hfo7EHJSRuF47mFbUQX7J9UxXHUPUWDq63c1JLkucebDe1GN	2515	3534	3534	1616575320000	orphaned
4858	3NK7rwvXAWrrQDrpciAr67eQ1349cCJYaj5CY8rSejmwDveZnjCD	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1577	1081	47	1	4719	jwKpYDnTdpYFk1CkdSvnwhjinWS7CYcRY2cSLAot8QnWHnrFSB9	2516	3535	3535	1616575500000	orphaned
4862	3NLCbL8LUVFbiXU1FiAp3zuPQH36XY1TeRSZ1tatyx9EeqJxBjkW	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	43	1064	47	1	4723	jxH8Sor5W5qFrEPKN6YnSnyF6dfMz3xhQMMuinwXLL2q7EMXinP	2517	3539	3539	1616576220000	canonical
4866	3NL8sdLNYLC17cXe7jRWiS5sj2Jg9YYtpcDEXkCMPAJhebho7h5Z	4865	3NKJ6ma9wBihN2yxGsvpdvXLLCVPKNbQKic7eHJifg1tSFXXPwJY	1406	1393	47	1	4727	jwrhanAyi4AN28g6a9WfrnhV8QKJR3Ym7bUTPDmkE9e3B817SaY	2520	3542	3542	1616576760000	canonical
4869	3NKi6XweB9S1vxSH8hh48acHgdNaM8gMGvDRJtGQt9Uerz5LSSdU	4867	3NL7KodiZxyoZnx44CKzkHzhvm5LAbruzxG582wzw6nftz63XgZb	1507	1280	47	1	4730	jxyLxdd4jdWUriW4sqULeRiveCTTzGUEpjXJnoS8mYHU5VLKbdQ	2522	3544	3544	1616577120000	orphaned
4871	3NLtSYwEkdTBx8zTtTEmAFHYDgrR5tTtZ5CvXB6MUWLKdNGqScs1	4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	1471	1020	47	1	4732	jwdhtWFu8aqE9RcbnE2aHho6PX17YZmPdq2nb4GuwaaVjPvM19G	2523	3545	3545	1616577300000	orphaned
4880	3NLEF5EQaAY7hrFSugiufEiBMcpCp2G2kHXDowtzedP2ynQ9yKR3	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	448	939	47	1	4741	jwZufpRFVtMrykBfGUFnQDYdE6tvPBop9PLhS16QqVKcpAM4rPw	2528	3552	3552	1616578560000	orphaned
4884	3NKv79T9bAuu2LenoroREYkXCRVt58mb1tB5GoY9BCUnaGVBvKd3	4881	3NLVwwvegnmJeGF7obhpxEtacs1YMunwMH1WabewymEj5DcsVgug	44	1325	47	1	4745	jw9qt3KVQjpAxATkV3PPJ1jU8Sws9UHxXA58Jh6G9YFYK2jGnpm	2529	3553	3553	1616578740000	canonical
4887	3NLpxGLNTnWaqMuqK7NZm6dkDrStkZBB2u62F1Z2zv2gW9DgdsiC	4885	3NLQoR5HRGr5Z49jos6hCgK1PhFjkbrBxEeg2MSDxbnGaHPU4UJq	1457	1265	47	1	4748	jwFvYw3s7Lx3dryMgS3UiE6YymxpCE5GKwUmxwXgCGMdsJHShn2	2531	3555	3555	1616579100000	canonical
4889	3NKbLdai3CdrzDJhGZ1Ssmft1DrJLjS1VfJfbnyAJJCEopFgb6Hf	4888	3NKobNaWAEY7Yg8MgdKh17xwkNTww5GYDAxsamdUnM8VHenmmPXb	484	1319	47	1	4750	jwxajWs3hmDMho5Mjo6RQ6mUDL46rXqCpKztDWmfhex3ycVHeCr	2533	3558	3558	1616579640000	canonical
4892	3NKKnmxu9GT7Qs5SQyuPwa4Pvcr3LwrKHnDWabrzwvVHUpi7uCbL	4890	3NKeFxLtyffAcE7tUYph9LEf8Moyfj6M8pqZ9HVDKRuq71T6g4XF	1637	816	47	1	4753	jwiGyxtk7cMRdvWAPnDcNRJLTSucDUYezbH1LoXiD14fFGuCngq	2535	3560	3560	1616580000000	orphaned
4896	3NKDBWu7DZQpsFJhXZ4d352YedxqEi5U3L751ebpiB475teYDAGE	4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	1523	1321	47	1	4757	jxXHmFNfRmvgn9MM6AefkxugQRTvJ86f2GhJirTiruFZJPzNaSy	2536	3561	3561	1616580180000	canonical
4901	3NKnQjdwNKW1EFAo7NC2NhidXMjDZiKV4U1RheGooNPEZWWMa95g	4896	3NKDBWu7DZQpsFJhXZ4d352YedxqEi5U3L751ebpiB475teYDAGE	1581	778	47	1	4760	jw7TDD9mHh8mphkNitytDiP9SnbpY8HdFQL9guL1dWVL9xNhPXR	2537	3562	3562	1616580360000	orphaned
4903	3NL9DR4ZxkkeajMiBFKLfV48d3pEUJFxbGbSeJhpBRYK8zr489Ad	4900	3NLdN6syXbCNjuzn5NbFuDe9UsG1EPp6u1WmBTC7gMUKGicWRkEd	1402	868	47	1	4762	jx7PWD4Z5EK5gCFgdVBwDV6VcXQdS6Yd4eTNXhLTJrJNdqGyNdE	2538	3563	3563	1616580540000	orphaned
8838	3NKUChGwmcaHu4Tx3sfh4UbF8LU8bn7cgUn1D78kMngKYiVd2vnK	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	641	1090	106	1	6301	jwtr8BDpSYddb74LAttSTAUHsdhJMoweyYwRC5AVKXHWUpDN3Mx	4582	6452	6452	1617100560000	orphaned
4902	3NLWb4aGXaigi9uPgZcN35crAS5Rt28sTbNj9Kq5e4BvkodesEBr	4336	3NK8f1oGSnYYYtzwfvXkCSr5obpPDPWx95mcMeF1sLZmqVFuopGg	563	993	38	1	4761	jxfBnXGHpY4UqfYR8hjR9UHaxJqJeib9vzD75aioLrwD7pXGdqX	2249	3562	3562	1616580430909	orphaned
4895	3NLFtuaaKTjkYogsQCicf3jWf2nxavoRkZb8fa5YcRcFjUXx7RTj	4843	3NLJt7qodiFFwRVazaib19EmhF3LyAAj6nRkKUBiAmB8HRiZc889	641	1090	41	1	4756	jxQuFNiYsjeHNahZnvRtnp8uMmbS8qm8VXBZv3GR8BdANp6bPSk	2262	3560	3560	1616580000000	orphaned
4874	3NKHtHDKsVkbi47XgcdtMM7JtALcx7pVw6t1FAakRHVHNRpQyWdc	4674	3NLA9361biNfnYoLrUpDa4nZimUowiB3zPfdbSSVBZw6hB5dqcoZ	1607	1348	43	1	4735	jwH8qscEBSsa95miSdfCQqgWGSjuSxJvB8EArMJ8jaSzo6hxjV9	2326	3545	3545	1616577300000	orphaned
4939	3NK46MB9fUcutoikMkWwFV8ZkcubkutnJfkU8ko491jKVRBUcf5H	4694	3NKV7BkTV64aTDKAmR47tPVNAFc2qGayBRaGM6LvEUR1wq7WjnzB	1622	1356	44	1	4797	jxPXPAMZSA3pyeP1b5bFofghEBpCUzbWHUrm8do6rSU5yxGoAnm	2420	3591	3591	1616585580000	orphaned
4849	3NKTLMScpnLa6KZKyBhaNyGP3Uu2obC9JS4qMFXCoFQvuuUADAkK	4847	3NKQ3amkdFFY2cxGz8bALNXySLrYjAQy4CxjMkbpTst7pg7RhDJj	1481	790	47	1	4711	jxdoj5ABS92fBHXFSsdo8yP8kFpaGsoWDfUWsQ8hkDyPMcYNMpT	2512	3531	3531	1616574780000	canonical
4851	3NKwX7Bpzr2ZunRcdzSKuax8u67PuusNrq629LccyE1eXdS3eorJ	4850	3NKFy9QyHwhWQ42E1FSYe6XXLK1CKozLPgGU4AgbZXMiQjCt6YCN	1406	1393	47	1	4713	jw8NVcCiG37qJAqzpp1scPgG3LK6hdMWw3h7rSbYZmNh5iBdPLJ	2514	3533	3533	1616575140000	canonical
4856	3NKCYVaDWoV1g4eSfJSvQJY5uCcS4pe17JQp6rb9gVWSK5xN3DmN	4854	3NLotmeEj5ygMPXBw5c37HngTNoLJzezKfjWdUjmnxDgAfFqkviw	1457	1265	47	1	4718	jxwauujoLQfgcJ6iAsm5G1K24G97w1iBk1DWuN9cYcXk7i6AWVn	2516	3535	3535	1616575500000	orphaned
4863	3NLi2aFWCPg7PAYHDN23M7q7zuM9B2yfCM6mq3BxMBhHu8EMj1ez	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	1553	776	47	1	4724	jwDXDEt9M7qvLnCMEKL8mX4DVEKQXgnP1joB7V9SgDxqFBdWEu8	2517	3539	3539	1616576220000	orphaned
4873	3NLK1YqNzvJM5RkYt1zkevxuUnEataNf6LuRBLMDBtVd4ZXMhjAP	4870	3NL3Qjs72s4fSHavkJeJHvm6qJ4LJ66UWaRooWXe8TaA8vhsZwZX	1607	1348	47	1	4734	jwzUi8PofFgxnuvtfLp3yeC9vHHzumFvxVQx4qfQtg4L366P34U	2523	3545	3545	1616577300000	orphaned
4875	3NKzQKvBe7NZCjWjRdKcnTk1KdXTzgjqxiD1aCt9UA6ivAtYDJV3	4872	3NKnbvGrDEpV3V6LR7f7xnaAdYTj6vv11c9WA59iXY43w7tto6Ca	1406	1393	47	1	4736	jxDmA7QNoohDs2jpdRtDEhDNivVf5roL7KW88BWxMniDjhG8Z6C	2524	3546	3546	1616577480000	canonical
4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	4877	3NKSN8uM1jDsmCEVC6Y3qrpaHiMXZNWJoSY87DxYMZJvxMwkDfck	1457	1391	47	1	4739	jwzr31rXg7AV2Udbyd6Q7SwWjEEyavuyiDPvVp6m71totfyQC4w	2527	3549	3549	1616578020000	canonical
4883	3NKj6r6spAeWEKuWACr4gxEAaC5ZQkMXcSo7T1STssFa62Djc6y9	4878	3NLHRhxjxZiao5DPZMgZp9zBGFuhenVnh5Fi33T5mJGrvDKns9rh	1671	999	47	1	4744	jx3gWHsopoovPfgAsDoMzrdzwenTbMgYpqum7uv9oDTZDdJsW46	2528	3552	3552	1616578560000	orphaned
4885	3NLQoR5HRGr5Z49jos6hCgK1PhFjkbrBxEeg2MSDxbnGaHPU4UJq	4884	3NKv79T9bAuu2LenoroREYkXCRVt58mb1tB5GoY9BCUnaGVBvKd3	1578	1296	47	1	4746	jxttWvDym7KkewHwDmqL88sUimChk6L8CqM464n5ayZhYCjxm9A	2530	3554	3554	1616578920000	canonical
4898	3NKKoc57qVMCKtvuaoMYfcFf5sTZpapb4yGvxB4BYSmZGigE3jrw	4891	3NLPWDydv5HQtV5wyHGGvHbf99ybJuZ7dTiUCMdbcU4QJqJThbjD	1523	1321	47	1	4757	jwgC9b363a1YGarj3EkZeNN8jRmjMMHn5SH6JoEhpCCAGV27ekq	2536	3561	3561	1616580180000	orphaned
4904	3NKJRGK5umcnNLxtser6MjDym2yGcuzTXFRzVEEMDYcT8TMRwvPn	4900	3NLdN6syXbCNjuzn5NbFuDe9UsG1EPp6u1WmBTC7gMUKGicWRkEd	1579	1389	47	1	4763	jwj7JoY7SV3aSHGEgWKxsHJL7RD7HuNLgp5B94eGxRRUYkGj4sB	2538	3563	3563	1616580540000	canonical
4905	3NLDigRFAgJ596ydVRrgAyQHGBp7NypbJEVq7BbQppCw4Ebqg3Ta	4904	3NKJRGK5umcnNLxtser6MjDym2yGcuzTXFRzVEEMDYcT8TMRwvPn	1585	1366	47	1	4764	jwqvqNLCb94BcSqhDAVCLmHmCGH98tyUvKjSR7iqbNrEvtC6844	2539	3564	3564	1616580720000	orphaned
4909	3NLTKEpXpMTVAJ3cVqmqCFM3YvQhsGS8qmdzca6c4fNSN7XBg79j	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1439	1033	48	1	4768	jwxtaivCuXSMM3FMoZdWEBZhRvqKZ96AcVrVNVEnRgvJoK1PyD7	2541	3566	3566	1616581080000	orphaned
4914	3NKFvNvF43qdMxWi7b3hd2LPWTC3EmBDsV9QmDPPKxeUfAdjFYjQ	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	1461	1271	48	1	4772	jx4iCXd5eizRmGSHQMnEqdB9r9kywQyQweFYkY5yhkBvy6ieM2y	2542	3567	3567	1616581260000	canonical
4912	3NKZtcMDKtHKZzdEhph4EZVdX5p4RKbErxM3oRAgpKto2L39huDn	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	1406	1393	48	1	4770	jy2vhwfwJeRLnTqg9C7GoRfzqZSBdMECgwnTbtu2hLB43ovFHu3	2542	3567	3567	1616581260000	orphaned
4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	4915	3NKCXMkTQhhPouP1AvXPPJLGTaAFvC7BHjycuoyxTmTZm6RMq1JB	1407	1395	48	1	4774	jxxejvB7won8L2zRnHvbQa7fqciVgoW4YFUyWHoKGmuqxFq9gju	2544	3572	3572	1616582160000	canonical
4919	3NKzfk5YAX2E5mj8DuskzBXWNHbLxnTL5xwA9pnCgDLhQh3Corz4	4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	1555	1347	48	1	4777	jxjgvG7CezBa6fQohN2nd6yQuM1962vPWSK4X27hCv7WfE83aG4	2545	3573	3573	1616582340000	orphaned
4922	3NKLHVY3ZVVBUpy1iH72zUxTUWTJ4c2F2dniQgrp2Fv9vBJxkdKu	4921	3NLGb98R91LNjW3igEmXnxrpxYLyg7nmT8tWDVBk719uV4AWtaPw	1407	1395	48	1	4780	jwyLLRDgzSNSvCTQmmMEShxvrjMga7xXpUnr77gV4Lwq8Xd7TJf	2547	3575	3575	1616582700000	canonical
4924	3NKsy2TrPPrW8hhqSzaAkbfgGtfr2kTEnhuFKLYGc8mjyH2QMeGD	4922	3NKLHVY3ZVVBUpy1iH72zUxTUWTJ4c2F2dniQgrp2Fv9vBJxkdKu	1403	786	48	1	4782	jxxwtfAuFZPUgyyrrEsMnXrNxLEdJ3DQHAUqazPsquTELq68HZE	2548	3576	3576	1616582880000	canonical
4928	3NKZU75aLBJVBZNsx1dh15epS4hdHgC38rf1GyY6feDM1BT5oxTc	4926	3NKGmTKZd4w6jJUwfypfqPiKTUCAVW8x1jZ2LLVRxqSfoxNXcYpi	1646	1354	48	1	4786	jy2YWvrHxwRfrLCjH32XXZADkFaSmAZxgjYWEWNu9FBqfMbdNEs	2550	3578	3578	1616583240000	canonical
4931	3NKUJtNRS8WHxyCEr9XFwgV8FViWvWSFWsHhNss5sEsiziqaCX3a	4929	3NKAYE4sRv35Jwy8mLg4whdqxxKa3qVp7bDUEsenYBVP2gsT6bER	1534	57	48	1	4789	jxvPSirVhncMKjoNvNivx8G8hma8xsFczSMPtppdSJXJq3fvwhQ	2552	3583	3583	1616584140000	canonical
4932	3NLwjkLroAUXDZddpF9UQ8yyZPRWGQQc9pfK7axqfNG7AKv7aHn8	4931	3NKUJtNRS8WHxyCEr9XFwgV8FViWvWSFWsHhNss5sEsiziqaCX3a	1600	1372	48	1	4790	jw7CFGTKwFXrqci9uJnJUJkHBQJjTEGnaTza3Temh8u3PxxjuPt	2553	3586	3586	1616584680000	canonical
4934	3NKLkF1X2X1DYdkmJJvSVtsascEN9Ld6tuhnweFFiaBcK3U89f3m	4933	3NLjb7acHe7Cupqir896y4ddvBcyVZF236ehB2gNEKMYVob5UNWy	298	1308	48	1	4792	jy1DLQqX7xnfxXftJEXtbCz51GFdbDQR7RcUc9cs4JJH7ZSpF46	2555	3588	3588	1616585040000	canonical
4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	4942	3NLo2dUiyNhKVJRoCD87itAj7scP3DpV7n95Ww8NNsLYeuMsUX2R	1489	1014	48	1	4801	jwrq83UDLje5b8bj3Jr6JS8JaLXBvyjmLJ8zVLYzwmz9hwzn621	2560	3593	3593	1616585940000	canonical
4945	3NLL2C4cADqRU5dfiiVVytryVMvkmp4Vb4DUfqAVTZNqUMeeJtSh	4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	1460	1078	48	1	4803	jx73qs1QXnoKKqKQZUafCahgfyQVEeYRPWtDj5iBPQTapE4sQbW	2561	3594	3594	1616586120000	orphaned
8847	3NLCTZZgbJ8y854VBacG3sonCQtPgH53obThkzhYcaLpWoafAN5Y	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	643	643	106	1	6301	jxg3CETLnZ8mqYHRBiaEu5JVk22dceiTaqBRVn1A4FR9zuLr9MF	4584	6456	6456	1617101280000	orphaned
4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	4906	3NLabGWfnVmeVg4LW2hBQ27ST62B4yWqQCLDpskP1sx3CjLyKZrZ	576	1355	47	1	4766	jxbW7v4U1WAcXUixddYex7AfrfPhdkaT8nVbLrCW1xZVkPsqP6U	2540	3565	3565	1616580900000	canonical
4910	3NL4JcbCypAG1QjN1cSeRkxBxH7QN3MwA248xrHSQGiGZrQMwcbg	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1578	1296	48	1	4769	jwYbbqFYMUdoLUMMjURUshcHJAzemrjYCghBiYhvP4pNxqFFGrf	2541	3566	3566	1616581080000	orphaned
4917	3NKNPEAsKhC7vffAaH98Drnb4x1FfKg4HPC4WwtSJ8kh5EP2w76Z	4915	3NKCXMkTQhhPouP1AvXPPJLGTaAFvC7BHjycuoyxTmTZm6RMq1JB	1403	780	48	1	4775	jwDDaocH6rubZe7Ckc9YfgRVPHuZg8BZQL6hmPjbshqa3UbyVkR	2544	3572	3572	1616582160000	orphaned
4920	3NKn1VpCmFE3MCworLzsv1KfRNFbrn8sS2utAYASqUeRMzU8hUAK	4916	3NLJvNcc7SKkyK5oRtdnFUjns8BYA19CwKKT2LCsjoEQUsbBbTTK	1564	1092	48	1	4778	jwYCCXQxkmsPUUjg1tgNXiTv1t2b7B8otHWqQkFX3ojgojg7xVq	2545	3573	3573	1616582340000	orphaned
4921	3NLGb98R91LNjW3igEmXnxrpxYLyg7nmT8tWDVBk719uV4AWtaPw	4918	3NLQasR69yaCLgpSosZ84va9cviL5YPcpGZ9w147kq9PFgtipBSm	1627	1385	48	1	4779	jy1yUh1pTALqZ59DB43EdKyWarfnmt32x2D3S6yxp364dhsGZTB	2546	3574	3574	1616582520000	canonical
4926	3NKGmTKZd4w6jJUwfypfqPiKTUCAVW8x1jZ2LLVRxqSfoxNXcYpi	4924	3NKsy2TrPPrW8hhqSzaAkbfgGtfr2kTEnhuFKLYGc8mjyH2QMeGD	1423	561	48	1	4784	jxbyAGfhxdnQ6D2AY6rBaj4yWWfS6czbeK8kEY5CqaZGY89CPby	2549	3577	3577	1616583060000	canonical
4929	3NKAYE4sRv35Jwy8mLg4whdqxxKa3qVp7bDUEsenYBVP2gsT6bER	4928	3NKZU75aLBJVBZNsx1dh15epS4hdHgC38rf1GyY6feDM1BT5oxTc	1613	1223	48	1	4787	jwFoeecwNDYMFNTLnJmpgxmJQkjkP9Tx7PSfHZJQm5d8FQwPcA1	2551	3581	3581	1616583780000	canonical
4930	3NLeu4w5eH1F5MwsiEC1rk5KjK7weqE766FQzPTcR2BUoadUfRPF	4929	3NKAYE4sRv35Jwy8mLg4whdqxxKa3qVp7bDUEsenYBVP2gsT6bER	1579	1389	48	1	4788	jw873zYpzmjtQS3dGmDvBu2yvrf94N5UJaLs7Lp1SB39v2m1omg	2552	3583	3583	1616584140000	orphaned
4938	3NLnmrPbLwcRg5KVr7qAHxvUPAQL9KsECqMVHaM8zJ46bH7pUAvC	4936	3NLjVjmFXyYW1Tr9C7qkKZXrpwCcAZg7gWg4A6mNkjww8owJiZoP	1637	816	48	1	4796	jwaeCcfnmB9TbdcGDSPjXMJQWB2sbegNmBWyQCP4HbGPu1mj82r	2557	3590	3590	1616585400000	canonical
4937	3NLm7Hho5VTxkZz4UpRBQm3NYLkvPhfCnF75khk6P9zMdqPxDeu7	4936	3NLjVjmFXyYW1Tr9C7qkKZXrpwCcAZg7gWg4A6mNkjww8owJiZoP	1407	1395	48	1	4795	jwTGU7VVcdA7dfxcFo2fuFURJ2Scae8UR2gS5Jgaj6sgxeaQhNs	2557	3590	3590	1616585400000	orphaned
4940	3NL8WCh6kp7D97XV56i2svrUzQvY3tMuH8DM25mnUdjapQUNN5E2	4938	3NLnmrPbLwcRg5KVr7qAHxvUPAQL9KsECqMVHaM8zJ46bH7pUAvC	1622	1356	48	1	4798	jwReFsEtvW9JKNJRNX12ndgk8wUY61gM8wb8VGKxaApAzNu4ztb	2558	3591	3591	1616585580000	canonical
4942	3NLo2dUiyNhKVJRoCD87itAj7scP3DpV7n95Ww8NNsLYeuMsUX2R	4940	3NL8WCh6kp7D97XV56i2svrUzQvY3tMuH8DM25mnUdjapQUNN5E2	1460	681	48	1	4800	jxWFT1nuTiYVJQNgVahU7pcWpoytZVzDZiGjFtVSU2GQMSE2gHm	2559	3592	3592	1616585760000	canonical
4949	3NLFDq1QAXE66dHSNGajAYL6gqWVurGkWifqh6cgLheTAoCHXFXi	4947	3NKE2GUweB9nP5fGZ37iswm26k5QgpcBwJYLnJ5U7wpodXcDLgBQ	1587	1111	48	1	4807	jxDC8uZzh3nvcbN6UYatJJRRHUrTPLW91d7mNPM64hioHEEkt2S	2562	3595	3595	1616586300000	canonical
4952	3NLWiMaKMiSYuZ9ZsGzjhwpXECourWjykUBcPHQtXBrBtgDghiXh	4951	3NKdTWWZhZaXHtgqkFPP3hxmRnQNdJARy7AzfzV5Hzx3uBqHUsaC	369	1312	48	1	4810	jwPBe2HbwtzMnK6u9CTGLi23kE6EfDcVNvjt91mReXrWMbM463K	2565	3602	3602	1616587560000	canonical
4955	3NK4jPTPeV8dZoWFvK4jtC2zWBTmruNicWidNoNwAyo1HWGj6fxP	4953	3NKDzBGnzpXnJiFgtBTZ9d5VytATmv9AJmh3L3SeMohrQfg6U8zC	1405	849	48	1	4813	jwrN5JR6aHhoUqeJVjPE2Ybif7UvoY9rRtJFJAFdFAXnRRdtZSb	2567	3604	3604	1616587920000	canonical
4957	3NL5itqDZfuT8DZA2ceitRhJDiAtb5bGrYPf7Z9cQU5mZXY68Mnc	4956	3NL5F8qFwbo8MViZGqhdpTkbapf1VrPNuHEbNL7Sv1T7rNccLaQ8	1519	864	48	1	4815	jwenUpWi1BGwYP1Kf5R5u4MHuPduTYXY2V4KGsAXM7hFHKvyUSh	2569	3606	3606	1616588280000	canonical
4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	4959	3NLimEzavz2BkPa5wX2sooMgymjG4pweT2ofSi3LP1QsWp5bMtYq	44	1325	48	1	4818	jwFCPpnM4UuQVpWnhTbvdYPBW6xMXyeViPzEShshqsm45fZSSyx	2571	3609	3609	1616588820000	canonical
4965	3NLhszoVv63km68eZtUdKBo16WuzsbiZFqwWxyDkWjPZ7JGUM8gL	4964	3NKLZJ6KHXxC85kRLWJM4weebbp5ZeKZj5fJdq9gXsFpDMvhdzSK	1407	1395	48	1	4823	jwT6Ay2iMzhiTqJ4WrSHztQUffwRjvqtuCkoZN67VvMR5aqnxGf	2574	3614	3614	1616589720000	canonical
4968	3NL7m2KrjSZGWXeyyKQWa1PHdvsfP1cktt8xVk3MEVD9JKXoGXGT	4967	3NLrJYK5ngEvVGcHUET9efMeQxrt1WdbqytYzH2vGfEAbbpD4t4m	152	1084	48	1	4826	jxfFTNtzYNxpr4VJxZYfiaFtr5apa1eYS4oK8QSF4uZaE69LTYx	2576	3616	3616	1616590080000	canonical
4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	4968	3NL7m2KrjSZGWXeyyKQWa1PHdvsfP1cktt8xVk3MEVD9JKXoGXGT	1675	1342	49	1	4828	jx2vzNPYPcA2uKkMDjxiyJ13svSs1wnuJTRPxdoE9KnDmdK9Fm7	2577	3618	3618	1616590440000	canonical
4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	4974	3NK8UQdcazc8AY6XtMQAU1fCvwAEUbqFvzVJrryVKpYHKHhTWFoJ	1629	157	49	1	4833	jxgFMykz25y7fwexJJ7u827ByWBnwLs8ykLQ7T58bu65HyorVvd	2580	3621	3621	1616590980000	canonical
4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	1647	845	49	1	4835	jw7vUahU2G4btVr4rz3MtyUExXdkDWiRGLw7aa4H1B5FhD8zLec	2581	3624	3624	1616591520000	canonical
4980	3NKanhs5ABM3MZNPDSsQa1TcYUEigiJwaomp76YsMM9DkgT9G1aT	4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	1460	1078	49	1	4838	jxcFP9MJCY1pSdB2m9XHjMGKHJj4BdcA7B2jD8EGtF84Fd1H87b	2582	3627	3627	1616592060000	canonical
4991	3NKUjdFgjoLNhA66KzTss6TFFPLBtXyGyopNueGgPaU6VcqDztw6	4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	1571	1089	49	1	4849	jwAqdQkES4HxXmXb4guhyRBJpbHaSF879p93LJKibCXR2qM1u2h	2587	3635	3635	1616593500000	canonical
4999	3NKbcFFUZ9K33PTnpuCWKrDDgMKutHxhZ2fG9ZLraK9BzzwtjUnD	4997	3NKPb9XtexD1m5xt8EzuvV2Rfgeboq6wGhbwfFZvRDTSeZf2hXGZ	1588	1146	49	1	4857	jxHVirkar1ny2LS5MDGwAneVbpPUXuiVXqeJE8SJL6MPakiJCRE	2592	3643	3643	1616594940000	canonical
5001	3NKSumsEKuKfbKff4FA73qaWLrsXnLRfwDDHEehr8GwFM4eawPHP	4999	3NKbcFFUZ9K33PTnpuCWKrDDgMKutHxhZ2fG9ZLraK9BzzwtjUnD	1610	1314	49	1	4859	jwayx4SCEDz1oWcguJ5afGMt7jzmNUxqK6JExG9XFdpYcBvEwjf	2593	3644	3644	1616595120000	orphaned
5002	3NKCXUKxg8v68yo2PvaUN252xDYjD747CfEQaxrBzGuteuHx9HAA	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1444	1381	49	1	4860	jxBwg6c3Rc7pShiNN5QeQTSxqS3XMfGsejtbGWJLewffk9CQgn2	2594	3645	3645	1616595300000	orphaned
5014	3NLhGJEZzN1B7TE25ywQtHS4owE9ubVgjqAKmbGsum3qxQcKQoLY	5013	3NKbAZevFscGJGKJMGs21zhEE7AK9EZca1Z4MiCpobNQfBMeeRGZ	1406	1393	49	1	4872	jwmxqZFWuo589TT95ZV2jy2nB9PiuHqhetEQRr2J4vrMUyDE9ap	2600	3651	3651	1616596380000	canonical
5018	3NLc4rbuR2s8dszfj1wwsrSQyUNKfKJGTmFYoth3iGEf76atLaMh	5017	3NKqWQ5n5Cz4PXGtM1azxibLmZynyQ9KL29QooSSFNy7J3xNwcAj	1627	1385	49	1	4876	jwMcwVVoTTK1TG3qAoSL61SD4Upm1h8nDUTzcRaPgKxaQyDnJa4	2604	3656	3656	1616597280000	canonical
8850	3NLTaTv6CAR7fLBFDQJ5ciEn5UdFkm6CepuA7APKmr8KLKBMU8Mj	8848	3NLQ6Hkk1RTVzU5m6WVTpTvUTF5JzXBapYkcByUNDH1hXMnDhxDQ	606	1049	106	1	6301	jwnVLkDdsWcUe6LVR3GddVV7hfWjMejSvs6AZgHSTCSVEvEfuR7	4586	6458	6458	1617101640000	orphaned
4941	3NLgCKEdZM4TiyDE4tPwLz1ewYVv7D2B4zdK6M5TQkVKfankFFwY	4940	3NL8WCh6kp7D97XV56i2svrUzQvY3tMuH8DM25mnUdjapQUNN5E2	1407	1395	48	1	4799	jxuAmWFcRP4xdB6xwp6ifjiFkgP8PM4GHwedyQxnh3Sxh9GfmVM	2559	3592	3592	1616585760000	orphaned
4944	3NKguuPdt4mj18DCANBb5MLBs8FAykiGkMW1tLJ8AJwS7vBFCJ14	4942	3NLo2dUiyNhKVJRoCD87itAj7scP3DpV7n95Ww8NNsLYeuMsUX2R	1445	1044	48	1	4802	jxo8sxmuMBsCdWnfm4HtVmG2dqDVNLvwfdvwKVCCRDx2cNmxZWo	2560	3593	3593	1616585940000	orphaned
4947	3NKE2GUweB9nP5fGZ37iswm26k5QgpcBwJYLnJ5U7wpodXcDLgBQ	4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	1602	1123	48	1	4805	jxnzWQx8ZzDkgGD4EaqRzavqeCfgkw8aBrmQogJ2DHMEYbjdNpw	2561	3594	3594	1616586120000	canonical
4946	3NLsu81QgpjcQFP4BsJLoY6jBMDRvritUrBhUZ1T9eMZZfXM4iCT	4943	3NKNL7WzKXPspVfUgYtWpQ7wFvzmevxpyJopnvCEHJzn6JStB4hd	1403	786	48	1	4804	jw9kbmjvSFtX7TEDpgyZNRqeQz5WKEyMTrCBGQK4gSQ5YgcxTGF	2561	3594	3594	1616586120000	orphaned
4948	3NLDKcFNmejsaXus6AfuSfgRJNao5rz7WDsxvrTjNKT4pK4R8wNK	4947	3NKE2GUweB9nP5fGZ37iswm26k5QgpcBwJYLnJ5U7wpodXcDLgBQ	1649	1383	48	1	4806	jxKhPdTnXqrffHdGVRKvVy4o8QpkaDnAoiDuoiewP9xfUHWWSiJ	2562	3595	3595	1616586300000	orphaned
4950	3NKDeJM2MWHUoP7gfvBBiRmFHVTSsx8TaJXzCLpRpr4mCePHg5QU	4949	3NLFDq1QAXE66dHSNGajAYL6gqWVurGkWifqh6cgLheTAoCHXFXi	1447	1345	48	1	4808	jwhaCUZuS1GCRBdkCAS11hQNRaVn4WTdgbGoPLP3VHQ6X6p6Lj2	2563	3600	3600	1616587200000	canonical
4953	3NKDzBGnzpXnJiFgtBTZ9d5VytATmv9AJmh3L3SeMohrQfg6U8zC	4952	3NLWiMaKMiSYuZ9ZsGzjhwpXECourWjykUBcPHQtXBrBtgDghiXh	1553	775	48	1	4811	jwkGcfx2bB2FvEAfmNL2LZ4U7SbmbcLSmaogx93Vj1e5x5JoqDg	2566	3603	3603	1616587740000	canonical
4954	3NL4WZZgcK2vAWEJ1Yibj4n2UJN9TzSytrxdYa9Ld4JZoB5KXkia	4953	3NKDzBGnzpXnJiFgtBTZ9d5VytATmv9AJmh3L3SeMohrQfg6U8zC	1407	1395	48	1	4812	jwWu2MVizhfGfoXFxmiehTWEcN6YoS2YskaUEhP26D6QoXNXPtV	2567	3604	3604	1616587920000	orphaned
4963	3NKENzZAbdjRRSnYKPGEruJ9asNcmCMVc9KCDbPmMexuaFkWrrcc	4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	1463	464	48	1	4821	jxQhmPNszoTZbHsHvKtvNsN8dUBJDFP2BN4axNR2Lbs5kDowNDp	2572	3611	3611	1616589180000	orphaned
4964	3NKLZJ6KHXxC85kRLWJM4weebbp5ZeKZj5fJdq9gXsFpDMvhdzSK	4962	3NL5n3UEg6ikU2CMvd6GEfQEWCZKQ65p35zVLMkx1WnMi4QntqR8	1406	1393	48	1	4822	jwuFnmTYB3bAN6AxKi6sDnc6EhAKejLDVpRETaRisVzxWcr9P3R	2573	3612	3612	1616589360000	canonical
4966	3NKZaoHUrBQ82LCEvv9ApHj5yNT8kFEaEaAgYZUk61owt5c2CKJT	4964	3NKLZJ6KHXxC85kRLWJM4weebbp5ZeKZj5fJdq9gXsFpDMvhdzSK	1513	1253	48	1	4824	jwYU8woPNwnyBFwCF5f3wL3bXt2M6ydhZ6e3Zva3RY2actPBhGJ	2574	3614	3614	1616589720000	orphaned
4967	3NLrJYK5ngEvVGcHUET9efMeQxrt1WdbqytYzH2vGfEAbbpD4t4m	4965	3NLhszoVv63km68eZtUdKBo16WuzsbiZFqwWxyDkWjPZ7JGUM8gL	1440	1377	48	1	4825	jxytTkJ6jzi5RAN5g6bVYSbjnvykSJMsTVsVLJdZBX9f5ox8tPg	2575	3615	3615	1616589900000	canonical
4973	3NKBRtWy5mRxsqtn7uavoheX1RiKior4eD1Ff6n79p8BHof9PMTn	4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	1654	1094	49	1	4831	jx6aA8K558anGeTDfoej6LAGnVrUhRkNqvRs67sXVBGhxrBjRsz	2578	3619	3619	1616590620000	canonical
4971	3NLLHXk2hsucRK8VjMTqX1F1336WiqYonsL7zd8Urd1WZXiw4YSM	4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	1406	1393	49	1	4829	jwFDQBCJkdqiaaSyssnES4oq5BV63pbiLB4zigs7QK63dhdrErx	2578	3619	3619	1616590620000	orphaned
4974	3NK8UQdcazc8AY6XtMQAU1fCvwAEUbqFvzVJrryVKpYHKHhTWFoJ	4973	3NKBRtWy5mRxsqtn7uavoheX1RiKior4eD1Ff6n79p8BHof9PMTn	1406	1393	49	1	4832	jxYrMsy2BR2pCz1bfXPPwXcqMTNdK1fHCLxJtyABxh3XFwGfRBm	2579	3620	3620	1616590800000	canonical
4976	3NLqpRBejUXhiqKQkYGfYVB41yHw6UDfFzBGQN23wUEwi9DFtiYk	4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	1407	1395	49	1	4834	jx6ikjjuF5kZ7zE94dxw1Nq2cLrr1yJGvVCSAdbwYwKsTfZ3enU	2581	3624	3624	1616591520000	orphaned
4979	3NKhRJyZCNbFtxwiGUmptvC5pUYbZppJskBprimHjkHiTtxciGK7	4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	1500	1171	49	1	4837	jwuJGjyDQi3Ye3EvpiHJkfNrAsbDtKeMTQnFJSwP3t2C6aNhrQG	2582	3627	3627	1616592060000	orphaned
4983	3NKJd4GQsq5kwCT3WwfNwAy1xkugcFZ8KdZwmWyNFbbhUh5QZE5m	4980	3NKanhs5ABM3MZNPDSsQa1TcYUEigiJwaomp76YsMM9DkgT9G1aT	1406	1393	49	1	4841	jwNyzva65bJWWZm9n2dY2ND5YBz1NXSjvcogxVkFMrCbb2VJEaN	2583	3628	3628	1616592240000	orphaned
4984	3NKsb82hQ8T9iwHj4rf5DExJoJB4r7cxPcqptq8qhqfdPJvM5yEk	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1406	1393	49	1	4842	jxKd1VMPLQ8LvtkYkzEtsqGxEcXmodntoAt6bRmdLYC39ngSzxp	2584	3631	3631	1616592780000	canonical
4986	3NLiuTjY9juwtnKWzkGwsbsu6MK4zrm3teZnm1ZdKYvbstkz2QZy	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1668	1370	49	1	4844	jxnH49g54av12KJnq8ybhRTv5oBrPme6LScX2DNLuiL6Lk4u5Pd	2584	3631	3631	1616592780000	orphaned
4990	3NKUXqG8jDoKmY7ovaaoUELQZAyrzx5n5MgoJZoiVtb8Zhq1MC99	4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	1407	1395	49	1	4848	jxQU1NeeckfzyEjbrBXyfnrAN8NMXg3Kjxix7y2QSyvZZ3WDAXz	2587	3635	3635	1616593500000	orphaned
4998	3NLjsTbEJU6HxPax9YSqJy7zrFXjuiAmPis6iqror6EGGLYP2AyC	4997	3NKPb9XtexD1m5xt8EzuvV2Rfgeboq6wGhbwfFZvRDTSeZf2hXGZ	1403	812	49	1	4856	jwiH7ZUr9gBSkBVWFqUNaLccur7D86MeWexHZeh8jKgTGerFxeM	2592	3643	3643	1616594940000	orphaned
5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	4999	3NKbcFFUZ9K33PTnpuCWKrDDgMKutHxhZ2fG9ZLraK9BzzwtjUnD	44	1325	49	1	4858	jxkcYkCatBpYWbBsgbiqY86xhRRWULR1WAmfNbGwXEont48yQdf	2593	3644	3644	1616595120000	canonical
5005	3NL5gnuoY9yTPsVp8f234dHaSkLNX3GXm8puu7gBBKZiujddk3wY	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1490	1274	49	1	4863	jwdLqDx3NTkzPCANMuv6wGpGJzsjmo9fLTzw8ia8wQbKRnXUHTd	2594	3645	3645	1616595300000	orphaned
5009	3NLsgH335WcoQYppnxURjh9XjnxNuhZqyCCRFTzqPja7JLRDpvQD	5007	3NLhs5gRTks19PzWr6Sgn7pso5H29J7sLKaxcCLwYcizKQszTZd8	1647	1056	49	1	4867	jxqXqW4m1ADvpPRQ7fcZmYs2g9d77LXo7EEPFx8VjNWZzSdsLHX	2596	3647	3647	1616595660000	canonical
5012	3NKFekxKxWgUehhtKi4m3PQoU6cjnGmy15tAsjLm3bQF1sM1dtaY	5010	3NKNpS3Yi6n437M9doPDbm57hEfHXXyFDYV8HRK1QKfqtbiRK7we	1406	1393	49	1	4870	jx2YczyzTTgbxV4HLhFWWpuKy2UEfZ3YVzJvJmynuwpmFBYyHuy	2598	3649	3649	1616596020000	canonical
5011	3NLdFrnPKnhWT3WJd3QP9BCXTNdcmBTqmdLMoroVK4A6TCjz7qYj	5010	3NKNpS3Yi6n437M9doPDbm57hEfHXXyFDYV8HRK1QKfqtbiRK7we	1509	1074	49	1	4869	jwFdh3twkbkcCYFJpToGk5N7mUBtRUtYR9yMidXVoYTZwzvJkhp	2598	3649	3649	1616596020000	orphaned
5013	3NKbAZevFscGJGKJMGs21zhEE7AK9EZca1Z4MiCpobNQfBMeeRGZ	5012	3NKFekxKxWgUehhtKi4m3PQoU6cjnGmy15tAsjLm3bQF1sM1dtaY	1637	815	49	1	4871	jwowFMyDUna2WbDPKPtgPX4z7jJyVx2Qe7VuTBVRvFu9zucqYQ5	2599	3650	3650	1616596200000	canonical
5022	3NK6eFRsJhbqfXSDyALugY9tGv8xrW1dtSeehhwHzTzArdDjrFrF	5021	3NK5FHXWmy238nEfpDYjqZHY56WGBK4VYrvVkZ6QNRaFMzwhFJiM	1657	1344	49	1	4880	jx5S5Pk14izQVXnkyCKhvhSduztiHUZEFqZrXg7Cy2Pwqaq9PhB	2608	3662	3662	1616598360000	orphaned
8860	3NKTrBjC5K17wZK2nBVUCneaeP56TsURB2WXapa7nJv6MotavcYZ	8859	3NKvDCR2Ee9hydssxVJPDLhXgeavHgzoAjzfCtL8Uc6qqGVDHpVH	415	415	106	1	6301	jxpRG9dq4E9J9t9saN9wzs9Z9e7USd9X3zAyWfhjn2JxmS8TH2F	4592	6464	6464	1617102720000	orphaned
4956	3NL5F8qFwbo8MViZGqhdpTkbapf1VrPNuHEbNL7Sv1T7rNccLaQ8	4955	3NK4jPTPeV8dZoWFvK4jtC2zWBTmruNicWidNoNwAyo1HWGj6fxP	1405	843	48	1	4814	jxkexorChCh7xow5MCvC2apuFfpqj1mC1QeyqZ54xFSKtpCatid	2568	3605	3605	1616588100000	canonical
4959	3NLimEzavz2BkPa5wX2sooMgymjG4pweT2ofSi3LP1QsWp5bMtYq	4957	3NL5itqDZfuT8DZA2ceitRhJDiAtb5bGrYPf7Z9cQU5mZXY68Mnc	1407	1395	48	1	4817	jxGWe8AgVVzCv1LBxTmZiV96GzS49ryoU9jBRxwkuJwXMw4PAQg	2570	3607	3607	1616588460000	canonical
4962	3NL5n3UEg6ikU2CMvd6GEfQEWCZKQ65p35zVLMkx1WnMi4QntqR8	4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	1609	1333	48	1	4820	jxEVGsTL77mzLBW6BVoVuDsBFUQ7Cj5Vch7zDigQvoTugkfkBjG	2572	3611	3611	1616589180000	canonical
4969	3NKEJhZc67LmxhKC9g6vYC35AXPgSrdfH82G9TCAwGx9e1bvN1RF	4968	3NL7m2KrjSZGWXeyyKQWa1PHdvsfP1cktt8xVk3MEVD9JKXoGXGT	1406	1393	49	1	4827	jxT3B6rZTbCnHEzU1mb7dh7Hqq8o71gAXsYWPHXPbMk86nWC3wV	2577	3618	3618	1616590440000	orphaned
4972	3NKn44WJFdFkmuZd63P3ExAEBuCaXM45G4uN8i6rt4oh7PFN2yYT	4970	3NKcxo5yzq5Echb4nD49j7tvUHFxRwwammNyQUbh7QdeurLHBPL7	1460	22	49	1	4830	jwauWDCYyUNLoQsSLoBnR21tGGdizU7448giD3knndwSc14To3W	2578	3619	3619	1616590620000	orphaned
4978	3NLCBRFWCboaAe21GqnW1tKrEyTj785Xy68B9v37vza4pDcDA1b8	4975	3NKPzwZq4FEWmAKaSqctHtZW6NvhgHQV94Xedg2HMqfQ9NhYr53T	1403	824	49	1	4836	jwh799zit2nwnWeg2feA5vXVnWSfneSa1YuFNYcizEbfhnDgNrE	2581	3624	3624	1616591520000	orphaned
4981	3NKgLnhcyGSF9htD63ckkevNfsNkAoJdrs4HfQjfuFGEv7gJh76t	4977	3NKVg3AGrxehSqHaLEAeec8PFUcLmyHZaRpwcyLX19ZhPkAnM1NC	1457	1391	49	1	4839	jxQpcAw5gNDbhByp2ZMiE38hNiNgRT19G7MjPnaBZjE25eyzS9d	2582	3627	3627	1616592060000	orphaned
4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	4980	3NKanhs5ABM3MZNPDSsQa1TcYUEigiJwaomp76YsMM9DkgT9G1aT	1471	1140	49	1	4840	jwqq74TquLJG3cazqHiQ2DvEQkmEgv1pZgE8E7SuBKeDb9Jdwv4	2583	3628	3628	1616592240000	canonical
4988	3NKwoA455kAsZ2agJG6ZhThtffNDmq2UY9QcmJi6VZKJx5AUyig6	4984	3NKsb82hQ8T9iwHj4rf5DExJoJB4r7cxPcqptq8qhqfdPJvM5yEk	1447	1345	49	1	4846	jxnG5yY8zqcx91Kqa4cM7vXyv1y1MJZw832rqCHjmht8xS5RoqN	2585	3632	3632	1616592960000	canonical
4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	4988	3NKwoA455kAsZ2agJG6ZhThtffNDmq2UY9QcmJi6VZKJx5AUyig6	1631	794	49	1	4847	jxLY5ZyXsWTh4DLzfwb4giQ8jJZf8NNM6uy2tuBby3XRAa1FWYk	2586	3634	3634	1616593320000	canonical
4992	3NKWuVzJupPAQ9Td9PoFE7xx2ndBT3DzNhrtMLGhvnMrWe5kqw9g	4989	3NL2g7APjg5jxCt3HKPipw5zFbhXSVdjtmZc6GysVLRsuBJ1ebd3	1501	994	49	1	4850	jwkS1xXeBXH7kuY9EyVFTEBnd2fUNU6Y6aAMhZZf4P9VsjpygWY	2587	3635	3635	1616593500000	orphaned
4993	3NKcFy4o3zhnGsB9GdRA8kRqS88BgoJJ5ReQxtuWBNj1HKYPs3Q4	4991	3NKUjdFgjoLNhA66KzTss6TFFPLBtXyGyopNueGgPaU6VcqDztw6	1422	1337	49	1	4851	jxw8RRSra3WMdgSJbnKvZYNSXvAqt8h242sWucUFjrhMTKEt5CA	2588	3636	3636	1616593680000	canonical
4994	3NKgNbxDT8iWuTNHusKn84XG3i4ULWKmAEpXjKf2gZGAE8QcQrJY	4993	3NKcFy4o3zhnGsB9GdRA8kRqS88BgoJJ5ReQxtuWBNj1HKYPs3Q4	1608	1289	49	1	4852	jx8H8qAscpURUPSzFyu4sfDFrKskZ3G2Gwc7V3c4AmuMR4Pmpmu	2589	3639	3639	1616594220000	canonical
4995	3NLU9xW55t28sgnxvac23CD48M3Xt9fu8xKCBU6xVQgS5pAaekKu	4993	3NKcFy4o3zhnGsB9GdRA8kRqS88BgoJJ5ReQxtuWBNj1HKYPs3Q4	1460	533	49	1	4853	jxggn7zwe66pd1NKTohrnFXhfgBdYQ3DBKv4UxbURUyzTT5Lnoe	2589	3639	3639	1616594220000	orphaned
4996	3NKnFdzDevLXSfTSVY8qfLwzeD6bwopS3V5icFryKXeKj5h7fieV	4994	3NKgNbxDT8iWuTNHusKn84XG3i4ULWKmAEpXjKf2gZGAE8QcQrJY	641	1210	49	1	4854	jxLTbqtWxNphSRFzjaeqXcRoDSgDbV5zMV6iig9LwnfjX8XwL1D	2590	3640	3640	1616594400000	canonical
4997	3NKPb9XtexD1m5xt8EzuvV2Rfgeboq6wGhbwfFZvRDTSeZf2hXGZ	4996	3NKnFdzDevLXSfTSVY8qfLwzeD6bwopS3V5icFryKXeKj5h7fieV	1403	824	49	1	4855	jwHShbp6e5Q1iyJnG9YSTQv52AqJCcEH4YUzJv7xeJgKFtYQhBh	2591	3642	3642	1616594760000	canonical
5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1405	873	49	1	4861	jxspUiYwow6rSJgyto7ZWqduULvhpTW2hvAE9aBoy8VLSpEXNFX	2594	3645	3645	1616595300000	canonical
5004	3NLhg9QWFBKjibvtUqPigveUBSERez2v4uWNYxHxwX9AGgrkui68	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	484	1073	49	1	4862	jwohZHcKZXsxkmpoMhwDMQkS75jQ4Pz5D8hJtQyUMkQbECiFPXv	2594	3645	3645	1616595300000	orphaned
5007	3NLhs5gRTks19PzWr6Sgn7pso5H29J7sLKaxcCLwYcizKQszTZd8	5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	1406	1393	49	1	4865	jwHHDiGgRwkvwEgdhYrUt3vLFafr3mpnL1XsBNMmJSomkb1U5Ak	2595	3646	3646	1616595480000	canonical
5008	3NLmViWxgTXHAZm18Bicb4JywMn5E2WMutbUghnnSfn1idFnF4u4	5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	1637	816	49	1	4866	jx2UUyj1C7VbYHVHsRYEsFeTiek4P1kGQtKdYu8JBzAquQ8QcB4	2595	3646	3646	1616595480000	orphaned
5010	3NKNpS3Yi6n437M9doPDbm57hEfHXXyFDYV8HRK1QKfqtbiRK7we	5009	3NLsgH335WcoQYppnxURjh9XjnxNuhZqyCCRFTzqPja7JLRDpvQD	1623	830	49	1	4868	jx7izLazs4vV3px89zeVS7Mbac38gQPa5QpeHR7nNk6YQFXeJCL	2597	3648	3648	1616595840000	canonical
5015	3NL72sy36tt1yeKSJwgy9yAZDRTRSvmXLfvfkrK85zfXssGhebuF	5014	3NLhGJEZzN1B7TE25ywQtHS4owE9ubVgjqAKmbGsum3qxQcKQoLY	1573	1318	49	1	4873	jxW61BZZ3Fqtew9URnihUkMUG88vCJE4E185JWwXQFBQ3zPPVKM	2601	3652	3652	1616596560000	canonical
5016	3NL25KChQ61nakaneZWHTB46xqduESbMCSDLPgZtkPRFikUBcqiK	5015	3NL72sy36tt1yeKSJwgy9yAZDRTRSvmXLfvfkrK85zfXssGhebuF	1403	824	49	1	4874	jxZHkaeuuiQH5J7DQDGGMW7HjYTsySFd8Wq3UCb9at8V7NVQAJT	2602	3653	3653	1616596740000	canonical
5017	3NKqWQ5n5Cz4PXGtM1azxibLmZynyQ9KL29QooSSFNy7J3xNwcAj	5016	3NL25KChQ61nakaneZWHTB46xqduESbMCSDLPgZtkPRFikUBcqiK	1631	794	49	1	4875	jww6xuyxERfZc1oTzDbvBqiYz8gATkXqqy5o4JayvSXdVwk15Uh	2603	3655	3655	1616597100000	canonical
5019	3NKeSydierL3XgPcjE4gCGqe59nt6BxG2eXqaLhuxkE1ETUhFWyo	5018	3NLc4rbuR2s8dszfj1wwsrSQyUNKfKJGTmFYoth3iGEf76atLaMh	1406	1393	49	1	4877	jxk9k66MFeDvLUkKJcbnYKUpr1h2MPKiww9bVHTdq5eZScR53nr	2605	3658	3658	1616597640000	canonical
5020	3NLrihRwyc5LTrecU8betsM9T3WvyWEZimHosPLn9av8FyUJ9j3W	5019	3NKeSydierL3XgPcjE4gCGqe59nt6BxG2eXqaLhuxkE1ETUhFWyo	1670	1036	49	1	4878	jxUJ65PDR3Bnwf5evBm932AWYWRPKsCGUgxnZNWh2SBPcBnPN4N	2606	3659	3659	1616597820000	canonical
5021	3NK5FHXWmy238nEfpDYjqZHY56WGBK4VYrvVkZ6QNRaFMzwhFJiM	5020	3NLrihRwyc5LTrecU8betsM9T3WvyWEZimHosPLn9av8FyUJ9j3W	1406	1393	49	1	4879	jxN255e9uhXvHXczbXYYQQPBZzTWodLuyNwzqwZJShtc5sL584M	2607	3661	3661	1616598180000	canonical
5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	5021	3NK5FHXWmy238nEfpDYjqZHY56WGBK4VYrvVkZ6QNRaFMzwhFJiM	1402	852	49	1	4881	jxYEaaGd6369MYvp5xmxnC2b9MZ6vQyWd5PWJ6oRMjHt7eqFmTw	2608	3662	3662	1616598360000	canonical
5024	3NKCBn6cqQuDTmdGJUJwxzkf3GKrfjH9485XBdST6ocnPeuCE8we	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1455	1206	49	1	4882	jxrY9UqTvJBEcVMiNKQzV861vwMn6QWaPwACeKjs4tKNCs7u4jW	2609	3663	3663	1616598540000	canonical
8966	3NKFJc1RVLZbm1H7HAjX6qU38y1wAaFZSttSmeukzGPwyxS7WtuA	8955	3NLP4mKSBojXaRdM1i5rSdXaHx7E6gbyeJ28bD2Evkf4eeQ3GNbT	1623	830	106	1	6301	jxFKi9bgqYiFWYoD7B5GPzJbeiN5fkpLmqw1YRSPqZhpFwLuHEr	4599	6546	6546	1617117480000	orphaned
9850	3NLwjgFXHjbn6RMAR6anwBbrKQYpFCfhzCq1DBG9YqDQdyn1bfVe	9848	3NKcCqaVJAMSJpZEqZf37cJiEnDY7JdwLTHavxkJp4xYwPEPtQ7J	1458	957	128	6301	6357	jwqgpYc9QUtXN8CKCaZvehqarG7FC4KVeg6Kuwp2a9WrjKcEByS	5106	7185	7185	1617232500000	canonical
5025	3NKcaUSRJJEHTFhTshoL5B2vegf2CVHzTG6nFUvBhq1kjvAcZFFc	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1405	843	49	1	4883	jxySFFoG9ow4KHjEYcWmjgnmSvmjqtFqyS9rq2vsyqEpzCugiya	2609	3663	3663	1616598540000	orphaned
5029	3NLLTUmWn7bwF5VH9UyEAYK6yRnkwvEFo2PoQcLYz9H7e2qsKcPe	5024	3NKCBn6cqQuDTmdGJUJwxzkf3GKrfjH9485XBdST6ocnPeuCE8we	1489	1380	49	1	4886	jxVEN7RJfADXJ97JviZd4HQFD7zUtVfPYebXLKDoPM592oDFqPK	2610	3664	3664	1616598720000	canonical
5030	3NK2xSik9J6ViF3axcL7hRTQGLAUCmz8qcAZGNLyWaV1rofYRULr	5024	3NKCBn6cqQuDTmdGJUJwxzkf3GKrfjH9485XBdST6ocnPeuCE8we	1406	1393	49	1	4887	jxgmVnqkUYcZ7JQsLYFKiukbdhpzMS5rGiCxqsR4XtKKs9svdmh	2610	3664	3664	1616598720000	orphaned
5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	5029	3NLLTUmWn7bwF5VH9UyEAYK6yRnkwvEFo2PoQcLYz9H7e2qsKcPe	1608	1289	49	1	4888	jwgZzij9uLwUDQKGnrer4SCp67AZURFjBGMQGeJFV9B7zsLt88F	2611	3665	3665	1616598900000	canonical
5032	3NKDwrLGzygbA31hyMYMiSMV3E2exo3nGUJfwR2hp6j81nQquchy	5029	3NLLTUmWn7bwF5VH9UyEAYK6yRnkwvEFo2PoQcLYz9H7e2qsKcPe	1405	873	49	1	4889	jw8fYW5sofAj1g839b32Sn5MbQ7nRudSC5ChmWB5q6jz84Fkdkv	2611	3665	3665	1616598900000	orphaned
5033	3NKQQZjBPgHpcNaPrga9zCsV2fxJty4sHpTWh9WHmmfvpXosKhuh	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1622	1356	49	1	4890	jwoAkDVM95dFuBUFcUN9MPbsJ7rx7NFWK25u5jjX5tM8e5JYf6E	2612	3666	3666	1616599080000	canonical
5034	3NKnwSd8z3CtHZrS6sDdP1Hxja94oDqtUf1cZGmhBJaA83XkDC55	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1474	1329	49	1	4891	jwaYzobS2ftMVopW4kL8HCY3VQmehueJKW2fNBCQQDe5hn6z8HX	2612	3666	3666	1616599080000	orphaned
5035	3NKAXFaMFu8Pbzbxm8v8LToc8mthFshaC1eNoDGpQXswNmcrGBuM	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1622	1356	49	1	4890	jxsxQd8Byd5uvogdj73gT577w9Bru8gR2wXkWGynJyW1EhWtVuz	2612	3666	3666	1616599080000	orphaned
5036	3NLXrkxjVX8xoFNB7mUy7CrzjkQgxfimr93WpEBCeoPDz82LDZNe	5031	3NL2skBSM54qwTjtzofGpyMZVUYXv3z3VMeBYSTNTcQMyMQZGbAA	1474	1329	49	1	4891	jwaYzobS2ftMVopW4kL8HCY3VQmehueJKW2fNBCQQDe5hn6z8HX	2612	3666	3666	1616599080000	orphaned
5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	5033	3NKQQZjBPgHpcNaPrga9zCsV2fxJty4sHpTWh9WHmmfvpXosKhuh	1642	1241	49	1	4892	jwWcf8K2oA3pdiKXaChz5EyvjNSF5qtsWyYCLJMS2NtDGCGL5aa	2613	3668	3668	1616599440000	canonical
5037	3NLomjkyGBHLDuNbthwUQ7SEPPXVa2rx3e2YcXkB2ATLrWpnqnb1	5033	3NKQQZjBPgHpcNaPrga9zCsV2fxJty4sHpTWh9WHmmfvpXosKhuh	1642	1241	50	1	4892	jwWcf8K2oA3pdiKXaChz5EyvjNSF5qtsWyYCLJMS2NtDGCGL5aa	2613	3668	3668	1616599440000	orphaned
5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	1642	1367	49	1	4893	jxNiCjsWSVXT8YR4y5c4eet5GDyFs4HwZHDxxWGLyWx1xzBitCe	2614	3670	3670	1616599800000	canonical
5039	3NKioXB3KH8AdbiNXNWs2nnVk87YUDhgpwSjjQJz6sypoEXWvjeH	5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	1642	1367	50	1	4893	jx3XRAFYGykVpdtNeR3L5gYqTQhhmAUi5rqJNX7NnEoJ4r38DHq	2614	3670	3670	1616599800000	orphaned
5045	3NLiA5HcEZyy1cSAi1Bnoif9mGfYR3YCUfohksgv8UG1yvT3RLTc	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1508	1021	50	1	4897	jxfSaBy4LpQ2A1zLsMkbXJWy5NHAN7Pkvuee3iWUQpx8XqoYvGX	2615	3671	3671	1616599980000	canonical
5052	3NLb8CpxmTExqeE3X6Ehkj1yECkLq7dw3UycprUZPK1z29ynoVrm	5051	3NLG5CT64f1zrckxV114Tvh8Xi4x2ZNhPBeyKuk8FyMyJbQLFSG7	1419	814	50	1	4904	jx56jCZAT4yz1w1azCn2jxAU9GDaBF72Bgj5X65GmUoceq8tPGj	2622	3682	3682	1616601960000	canonical
5059	3NKN3fK25aVHGstPHjXSVZc3KS2YzsfgtwfRZB1dWxZoHFBo1ewH	5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	1643	1053	50	1	4911	jwYbWVAVVYR9j6m8fL56cSi9e7qAoqXB8n6JrqHSjE9LrrKswKa	2625	3685	3685	1616602500000	orphaned
5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	5060	3NKzo6C1PbX2tmRjNYyQp5CVfMPKTDQBXoau5pCmxfmS6ncN9oxs	1588	1146	50	1	4913	jw9UTdY58hWoYJrB8xbmhDmuNZHcUrNjrf8BFEEnRgQLcTbRUND	2626	3686	3686	1616602680000	canonical
5062	3NK8tEAYD1bf9qn1NkJJoPqwEoeKtFqBZzS7MkRqyPk6xa1sjVGi	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	1547	1012	50	1	4914	jwJL5pepA4vTshkKN8HJZAvQQ4iXg3wpP3zW3pGkJLiYEn6cDRL	2627	3687	3687	1616602860000	orphaned
5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	5064	3NLHpFVBtRSV8xTju2pwdupqXqWXfLm8YctaLncUQpqLheRmGLeF	1500	1171	50	1	4918	jwcUcpTt1YnTy6S8hN2YLCMbGs1vjEChZEMgNRnbxrVmtqzgLAH	2628	3689	3689	1616603220000	canonical
5069	3NLMddQbWkFYV8a7c1XXMuURU51KptwMjdqMjGihwn5vWSq2nUd2	5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	1601	1388	50	1	4921	jxEVi6W1UubTsxZrZgTLX8mDt46BvShwZ3dsk5sx2Zd8ggCjevH	2629	3690	3690	1616603400000	orphaned
5076	3NKoQeeLBYB3przccTe7wpKkGMPDLiuxqvCQ2RLgRQ97aep3wyua	5075	3NLTMigB5744VHtHdqQ89o13d6XcGuS2j4931deVeg7xet3RmXLk	1406	1393	50	1	4928	jxg9gK2cWk7hZxFBj6DLWKqbG3CbNhk6WR4E1aXffXq1WPi6Jrr	2634	3698	3698	1616604840000	canonical
5081	3NKQmRkUy3ZU9M832YarrV6wKK6Y9bFKrfRciqd1z8fKLEzs1ncT	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1601	1262	50	1	4933	jxcZrg5ewUvJZYBdtksAY7LJuzEBLudxBeeCpuG9KCJejaYn12f	2636	3700	3700	1616605200000	canonical
5082	3NLZo7xqegmkcSYymHeRTTawU1bWH4hCPQ8hRvmH8HMwWbMof71Q	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1403	824	50	1	4934	jxNNKdgQ2F6wYPZFFb3meHy2oCr3Empdgt85KpLBjJAqHTnkfti	2636	3700	3700	1616605200000	orphaned
5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	5083	3NKEfHxW3zrkx54Jhe5uPMK4arWSPJJdFij1PsXneN8Z4ANHgd9X	1646	988	50	1	4936	jxAWUtUJrCY2YLDL5K5y27RPBNrBeu9qZbUWxdupNLSfaPdQFz7	2638	3702	3702	1616605560000	canonical
5087	3NK4ke4ZQfUczFBYgYxg7TDKohSNdHWXkQJEPHiixAXEXJfEht4Q	5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	1600	1372	50	1	4939	jwF31AiW6uVjJ6t9r3J5ug3rAk8QBgUo41YaZr7TeycRccHpTkU	2639	3704	3704	1616605920000	canonical
5090	3NKBa6fZMBVdAPxXf7z1gkYHikW2MNRRgsAzqwF3Ag3TAsERNCp8	5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	1534	1317	50	1	4942	jwYC65T1Q5PPANdPyDpmqK24mn8WgR5NsDngoe5J1e6b2FX63pb	2641	3707	3707	1616606460000	orphaned
5095	3NK7ZEo6QVMaBTZadxMoQG8NPSmLEcXrYcyuvdg57iKXapkRzdY1	5094	3NL6Z3CmX8yPLEbgzhha8nDCAdSG9qvqQdHefZ5puRc8xDeu5fDa	298	298	50	1	4947	jwUULSRHFQhfEUR29mBr2NokA4p7V9y47E1h5zi2k3ETG7NkmMa	2645	3713	3713	1616607540000	orphaned
5098	3NLru1xT7rFh3PPZnVPGv2De7Qpa4o9QTUDf7hMsKiHxxSyBrXdX	5096	3NKNCmzZAXFhix51LjgdPXkv1NoqirN1ce48fdGsiRPLK7UCARiV	532	1303	50	1	4950	jxEKRbrVjCUGCAtZRmnq5uR11fKEVu4f5EkebfxE5gvYLofXovz	2646	3716	3716	1616608080000	canonical
9192	3NLBt4Yhr7geg9LviYGCg1ed2qKhMFArWF2Jn1wPSY6cGLG5KQ1a	9128	3NK4gQEVaEFBP8HLgf7GgiFDEvccnLQm7HiN1R2vDMNAZj8DE5jY	1623	830	106	1	6301	jy1dCeJ49qSHGfzT1BVwTq2kThPonh76m7LafTE1CNHYuBXCi3Z	4601	6712	6712	1617147360000	orphaned
5046	3NK94LDBYnoLDbHKEnBASWyo6nhAtw8bby85QHGYeyF5cuXQWNvg	5045	3NLiA5HcEZyy1cSAi1Bnoif9mGfYR3YCUfohksgv8UG1yvT3RLTc	1553	776	50	1	4898	jxf7adUv2mh4Wz8yLGGQCBtarH4vpvTP16tSzxjyx1WwCK6sudw	2616	3672	3672	1616600160000	canonical
5047	3NLL8DiVHorec35toPbV8cvAbAuVC4MCdQVh4jjbbAMeePfkK8o5	5046	3NK94LDBYnoLDbHKEnBASWyo6nhAtw8bby85QHGYeyF5cuXQWNvg	1588	1146	50	1	4899	jxmDceaw5eDtsrzcpEtDsYWYk2Qtq6BdiRpR8qQD4bmLwwi5mAN	2617	3673	3673	1616600340000	canonical
5051	3NLG5CT64f1zrckxV114Tvh8Xi4x2ZNhPBeyKuk8FyMyJbQLFSG7	5050	3NKQFv9Ds83jNF2o8cmbc9X7rz2KEkvHonw7iQQpjyjrAdpxze5k	1624	1334	50	1	4903	jxYTbrmHCHqYRvr2qmKERt6eXgfa1gzfFa95NXUCncimxwKA2TF	2621	3681	3681	1616601780000	canonical
5053	3NKGXXgXkQxzvznZBRrKV8yNwpvRf2fqtyaYB5XYtXRo7Eruz3T8	5052	3NLb8CpxmTExqeE3X6Ehkj1yECkLq7dw3UycprUZPK1z29ynoVrm	1511	904	50	1	4905	jxh5xgoaJtVXh89mSE2WqnaAwQet9vvFcx4JnFGWtkoYtLt5TCv	2623	3683	3683	1616602140000	orphaned
5060	3NKzo6C1PbX2tmRjNYyQp5CVfMPKTDQBXoau5pCmxfmS6ncN9oxs	5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	641	1336	50	1	4912	jx1PxENRL8f2Wqs4cYyiWLmuETV9U4ZuvYzna3nVLuTm3RvgbHf	2625	3685	3685	1616602500000	canonical
5063	3NKkWmJ5TURxmXxhdFw6wkMaXYeWrrco1C4C6uFQ9tHtEoCVwYYV	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	1637	816	50	1	4915	jwUnx23PUQaU1MWC16GtBLEUzNEPmChmXsk4qkFcY5dRwB7zhvE	2627	3687	3687	1616602860000	orphaned
5070	3NLHYuyudtKktcxJ5uajEsXo1HzLZfTzaxJjr8QjT5Jfw9oyB9rC	5065	3NLApzWAgWKNBJWzoWPZxfT368FZFvfykzcEX4pKdAt35MnxD61G	1601	1388	50	1	4922	jxsrQDrxXEmb8EDnJAbNG6f9HFNsZnaKXd6rSYj2Vz4GgLZjDCt	2628	3690	3690	1616603400000	orphaned
5067	3NLsQVo9Ws3VJFwLd2S6V4iBdqs88Wv82Ei2KVxhoNaMEZyGkki1	5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	1500	1051	50	1	4919	jwhFH7hN1QHt1CJxEk2MQpgkSb96hFXGyeegATftorag9hEqR8H	2629	3690	3690	1616603400000	orphaned
5074	3NK6Lcv9pKPvdiYusR5EsVmsDsDLKahQRSmWbnDWfZtWQbtczmNW	5072	3NKZMtYWEs5gENeMb2bnbMCFiWLBmM4nzCd6dDqk5Josa3kBDWCq	1440	1251	50	1	4926	jxg5cpYf6ACZ89paKcJUSNnzKUwZGyryGGHCoNezPKKRKzYFuBV	2632	3693	3693	1616603940000	canonical
5078	3NKgeeLjR8NyFhK2DM77b2kNu5k4kMXTRq542Q7hxeATbKLSvTtJ	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1593	1220	50	1	4930	jwpPpD4fq44RjP87ubjJb87c4bTpCaBkCNqqqhefGfYEniUv9rt	2636	3700	3700	1616605200000	orphaned
5091	3NKS3UGXKuRWcF8QvbGgr4iqZxkw4oyLyrWWBUW6EzyG9NrECj8d	5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	1501	994	50	1	4943	jx5DL7kCKrs1kwY1ML6f9eEnkPNDci14hGZpYbZfkKoRUivDStE	2641	3707	3707	1616606460000	canonical
5092	3NKLoj2yxFfgzaM4Fh6PtFoeEwLrSSAY4dcCWwyFe3ZGRc7uiD9h	5091	3NKS3UGXKuRWcF8QvbGgr4iqZxkw4oyLyrWWBUW6EzyG9NrECj8d	1406	1393	50	1	4944	jxg5rTJ3RvNPG2EytiUPDYFMgLqbkchjby19xVwbAYyWDujj9So	2642	3708	3708	1616606640000	canonical
5093	3NL24WtGzK9ArBAcYuhHDewn6DRVD2oPBp3bFQBwgX11YmovNLZh	5092	3NKLoj2yxFfgzaM4Fh6PtFoeEwLrSSAY4dcCWwyFe3ZGRc7uiD9h	1405	851	50	1	4945	jxLaW5E8imfGggPWRYzjUTxsvMpKbNwqCHtJ751UfWqBsXE4X8b	2643	3709	3709	1616606820000	canonical
5096	3NKNCmzZAXFhix51LjgdPXkv1NoqirN1ce48fdGsiRPLK7UCARiV	5094	3NL6Z3CmX8yPLEbgzhha8nDCAdSG9qvqQdHefZ5puRc8xDeu5fDa	1444	1381	50	1	4948	jwATKtTjB9xBu7e6RLTnYSoin5JXZffNFhqyUkXEToiRUXVohD1	2645	3713	3713	1616607540000	canonical
5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	5099	3NLwkhR6QdzR5HNL3gRacahmQWxFo6X6g6hVaZePPbrm69t2kGqN	1534	1317	50	1	4952	jwyiE3BwB7PDuZ6JhcmkP9W39bM6wtJDBVrNeQAdTjARQZiZ6An	2648	3718	3718	1616608440000	canonical
5103	3NKzpbLYF7XLtbB56GjDz1RUx11z6Z8teNKxgVEkGfgS39PZAx34	5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	1631	794	50	1	4955	jwzSjcroxgsoUWnzNanXVSDmpyTBn13tQYJzK1mFdyzWMyVW5nT	2649	3719	3719	1616608620000	orphaned
5104	3NKswaFkuW9QrtqTGy5zyefUEHvND3UED1WvMYgHvLsCEdTqugc8	5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	1571	1335	51	1	4956	jwAKWoy64yFkNHSWucw4Hjk5bTfpaK45cavRQUrCe9NVXXkBAgJ	2650	3720	3720	1616608800000	orphaned
5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	5107	3NLweXTR5JbM8BvSBfrKgu4xw9sSEaZf1M9SiVW3c9scYAXHbaMC	1581	778	51	1	4960	jwm7QYbjQZrYiNNSXB1LPH2Mb5QTnr3VXhSFi8v8ePhU2htASoo	2652	3722	3722	1616609160000	canonical
5109	3NLWEi5tgvsU57yaWEJ66HUcfNinmW3W4ms5My9FW5caqPpNWY3R	5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	1406	1393	51	1	4961	jwwcNzK4MgpAXtXxy8CNJCofxPca3XV4dgqnhLMDhkSDDxnRyAb	2653	3723	3723	1616609340000	orphaned
5112	3NK5X89a5GDBG1PsYYCUAZGGataDZCV7jNJkAfNgXGBinP7TNKmC	5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	1607	1222	51	1	4964	jwnkvD83LnaGWftuH5aZWffwftSU3bDuEttRpouRX6FGAyQzu5W	2654	3724	3724	1616609520000	orphaned
5117	3NLPLQwSRp5jaLBy1or7JXgix5eJzeNtX6kGG68kJ2srtAMpeue6	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1577	1081	51	1	4969	jxK7Q6q5x6oamEAXQ4s3ZmQvqkvCypm7CuzxQ5W4quNfcHHwqgy	2655	3725	3725	1616609700000	orphaned
5121	3NLPdndzmjHh27tPSYFESb5LSZYNJxCEyyTDJT86nDjwoMePkdga	5118	3NKvH3ZwwxHb62qnMBqA4pSqn9SG2HpTfr6eBkrZNX4FR9nbQUfZ	1406	1393	51	1	4971	jxorXzJL2JCCHiTP62aiPreodT4wBxowcABBARHbhDMR8dTyBnM	2656	3726	3726	1616609880000	canonical
5123	3NLswauRaCDkJ3ZgDKSNSjUfkvAn79ZdTn2GmmXtMHm8FL18RHkr	5121	3NLPdndzmjHh27tPSYFESb5LSZYNJxCEyyTDJT86nDjwoMePkdga	1627	1385	51	1	4973	jwYha44qGfMpYZWZp1tCR5Y21YWSXraNS4hUNUX4Mx6WsiJfSEy	2657	3728	3728	1616610240000	canonical
5126	3NKrvVpjh7wpAZHGvhoJACTddF6SmrPKRnpzpRxWKtJT2JJ6JoLp	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1523	1321	51	1	4975	jwopQn3J7bsMkT9HwPE4UEJmXUgGwmD9AUBwf3H9fSxnp91Fkgx	2659	3733	3733	1616611140000	orphaned
5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	5130	3NKsjNMU7JpkyhARvdoN4nntzQtL6eevcSPhigo2UNwQ1mKkFBEB	149	1283	51	1	4979	jxvF6Zj3nd5RhpsZPozcgnnH71subG5uZyVTWSzXuzvnZFYwN7r	2660	3734	3734	1616611320000	canonical
5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	5134	3NKQNHH2q2JiZr1BbQanYtV4pEduApnhZpuESwpBTNK2EvteTNT2	470	1183	51	1	4983	jwEnCBSjGDGYqNXDYdwwCLDwgkChJYZd9bCV1Y5fzrwsYdUWjVx	2662	3739	3739	1616612220000	canonical
5139	3NLUesjyuLMA6zz8m1joGGrFNsqb2xEGrbPdhmmrvtyytqrCabwA	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1406	1393	51	1	4986	jw7qhxaKYHUi2auRk8gb6vMdbP71uYWdcLBnARYQnTfakd2Vqsm	2663	3741	3741	1616612580000	orphaned
5146	3NLdnspXNM2TdEWQYgAWKyxsWuCxjfAKQ4di4BfEW6ZWKDG7ohJE	5145	3NKpMDbuUCpDD2vMRAjLdYbFcgRUcqbt5ENpPKYQDuEMS73wccCm	1546	973	51	1	4993	jwUAJH8xWD2NQcCgBAW2MpRqCJnkFz4bY3tGQESmVPnUNY4ZyN9	2668	3748	3748	1616613840000	canonical
5148	3NLZ2PZg2FiVScwwrVSAfQhde4JVMg6LpbMwH7i19iUp72Vde3Zn	5146	3NLdnspXNM2TdEWQYgAWKyxsWuCxjfAKQ4di4BfEW6ZWKDG7ohJE	1573	1318	51	1	4995	jwqnXHWMWUXDnJzkvvTL686EkWtyVkUmZuoQz43a8kZUuYUMgcq	2669	3749	3749	1616614020000	canonical
8893	3NKQXSu1TRUocWuSoFS8zqf1RZ1xnquPYaMQjNcb28FYvzsNF9wE	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	1631	794	106	1	6301	jx9rHZr7ZTRaoFuNgEa1ShCKQuLXpaaG4ReKYmVwLWYPZgpXPqd	4607	6488	6488	1617107040000	canonical
5042	3NKNZkCQJYsQftFtmakSQPiD4xzr3ARFVrFJy9F4r4b2h65oTx61	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1406	1393	50	1	4895	jwqQm8Fjk831CKaz48uGwKAkN3y3pNLM9MsbNGboR8Wsqzf8Ye5	2615	3671	3671	1616599980000	orphaned
5048	3NLde94SHjVsssRTN8UdLEyRQxxhSs8mbfBB5Bo29JLUjqCWrm5E	5047	3NLL8DiVHorec35toPbV8cvAbAuVC4MCdQVh4jjbbAMeePfkK8o5	1483	1030	50	1	4900	jwBpZGTCz272ZuScUjVxfsaTYBqJicqNtAfCtkyLCMcEabGxWUa	2618	3677	3677	1616601060000	canonical
5057	3NLYkG5NVBNWwHhTTsm3wuEFEwzQSrH2vWPBNFpK4MdRiksfreJ2	5049	3NKzYnL6jypabSNYgpd3xgc85HN93mDGRRrC2GFHzXsuTfF3fg1C	1451	1292	50	1	4909	jwxiiCoH23BHDJME6xbUxpULoTWQVkDkAKCpxMYPoSqDctsMpnr	2620	3685	3685	1616602500000	orphaned
5054	3NKBsNRTQTxfNKrj8yhSzjdeWnFKwPkS91j15BQXo7nFoT32ZoKa	5052	3NLb8CpxmTExqeE3X6Ehkj1yECkLq7dw3UycprUZPK1z29ynoVrm	1426	1118	50	1	4906	jxE2rPDMQG2tHELCW8mBfET2b6gVPAmv56g1NwpmQmu2rhiBu42	2623	3683	3683	1616602140000	canonical
5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	5054	3NKBsNRTQTxfNKrj8yhSzjdeWnFKwPkS91j15BQXo7nFoT32ZoKa	1406	1393	50	1	4908	jxzuVNuQts69dyiFkrq6vT5RqUJdntXC1cZXw5keyCtgGiTqbsV	2624	3684	3684	1616602320000	canonical
5064	3NLHpFVBtRSV8xTju2pwdupqXqWXfLm8YctaLncUQpqLheRmGLeF	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	641	970	50	1	4916	jxM9BxUCkZa3rNQ1eS8vsjzWFHtp4YcwqcKuog9PUY3vKokvPH4	2627	3687	3687	1616602860000	canonical
5072	3NKZMtYWEs5gENeMb2bnbMCFiWLBmM4nzCd6dDqk5Josa3kBDWCq	5071	3NLeVJkKJZtZwfxrgU4Dh1EpN4KqYHEJjtrXwqyKEZN65LY8scAr	1444	1381	50	1	4924	jwiaRQpQPJBC1UsKKLH2FSnHn3JepNFS6q33M9XDQBXqbJpHEXq	2631	3692	3692	1616603760000	canonical
5079	3NKieie77tgjWDa4NoysCirhn5SZinCqBByiZRUQRjsLYLjBK4LG	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1646	1354	50	1	4931	jxfDuPxnJJyvrKf2JQdkYegrZP9w3uDkD1CPHyHRkjkYkwCiRYj	2636	3700	3700	1616605200000	orphaned
5085	3NK7oGybTKFtYFoi98LSep7e2Rad35q9GtgxX9igB5xJDWB3GXbH	5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	1406	1393	50	1	4937	jxJJxGREsh3cNENhcbttcCWyR1XurVJrKydUyMThsd56CVN9DXk	2639	3704	3704	1616605920000	orphaned
5099	3NLwkhR6QdzR5HNL3gRacahmQWxFo6X6g6hVaZePPbrm69t2kGqN	5098	3NLru1xT7rFh3PPZnVPGv2De7Qpa4o9QTUDf7hMsKiHxxSyBrXdX	1542	1058	50	1	4951	jwLtaAFP188T8X1WXk4VEza6uPxhKMFM8ZDjMHJ8MaDqyjKAZzR	2647	3717	3717	1616608260000	canonical
5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	484	1073	51	1	4953	jwA4fFkyo5yQgvXa69WKAoTKi45toemq4nEfmKrq2jMdGjsDVKn	2649	3719	3719	1616608620000	canonical
5106	3NLZyXKsnUZHMoog9HFmQ4wunb1yRGGByECMmsrWG8ryKnektRR7	5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	1461	1271	51	1	4958	jwFxsLQNSqUjCvog698m6TZXEHimSr424KbEPrLRNmuCB9E8ZW3	2650	3720	3720	1616608800000	canonical
5105	3NLkyKNQuU6e3F1kPQ3HNhjtPb8dNUJENWKhZ4Vvcu2m4y4Vo44Y	5101	3NLs9A3TNWFbBPhhsXshhgPuUzK4cV1TYND8Q3scUHjzUiMmDPJP	1617	1042	51	1	4957	jwrBwMHGeT5rv7Yp2L6ZaDSohayVoFyPMbgQ4zWZqTpQLZUr6Pe	2650	3720	3720	1616608800000	orphaned
5107	3NLweXTR5JbM8BvSBfrKgu4xw9sSEaZf1M9SiVW3c9scYAXHbaMC	5106	3NLZyXKsnUZHMoog9HFmQ4wunb1yRGGByECMmsrWG8ryKnektRR7	1560	1291	51	1	4959	jwZBMPeVgtQd9eE3DQ1yHk7qLMzf5cCnxAMUhaS19FEFBbFo1Zv	2651	3721	3721	1616608980000	canonical
5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	532	1303	51	1	4963	jwCBcjSLdRmMDi1FeWq1ejg5ZYKJjZFQbvj6GKosaxhvKU7qzPm	2653	3723	3723	1616609340000	canonical
5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	1536	1313	51	1	4965	jy11wQhWu55Yb5BT9RX1CWEAQsthQNkctLaY79WvbFi5eYB6mGJ	2654	3724	3724	1616609520000	canonical
5114	3NLGgjPpNiqjmhguECzetyyGaHWR7VghzBjtMwMTVew256P95zGS	5110	3NLSaHUMHsXvzMNtdLkGXqa2p6vmXwAgnMdWELH2gUzEdYUf6tjp	1607	1222	51	1	4966	jwkWnHYMR884pWcBytBfkRxyrFWcK84RV1tkgYDiarxKWEuq7pj	2654	3724	3724	1616609520000	orphaned
5118	3NKvH3ZwwxHb62qnMBqA4pSqn9SG2HpTfr6eBkrZNX4FR9nbQUfZ	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1577	1081	51	1	4969	jxQvjtmZk9gGFYzYamwedpoJdjzbmjqwrcQEAeWwkZ7iuQgQr2j	2655	3725	3725	1616609700000	canonical
5120	3NK7cQrReJgqU6SN3qemSrEiWyAwrFEC16geBFXppZ8tPD1AFrxB	5118	3NKvH3ZwwxHb62qnMBqA4pSqn9SG2HpTfr6eBkrZNX4FR9nbQUfZ	1529	1070	51	1	4970	jwrbj5yhC4PLmhTTxtzXJpq4omwN7nj2PN53z4jv1nw1RsRQ5T6	2656	3726	3726	1616609880000	orphaned
5130	3NKsjNMU7JpkyhARvdoN4nntzQtL6eevcSPhigo2UNwQ1mKkFBEB	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1631	794	51	1	4978	jxwWiTBswAD8LxDgDHVDva7THRDZbRzmFMsXVd8NupBZ6BDE2bq	2659	3733	3733	1616611140000	canonical
5127	3NLrbLn9GHmuMr4q3KkJrT8ri6hEEuwYxcHUZHAmscguWDr5vwZv	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1406	1393	51	1	4976	jxAdzzMCZndEAh9RHYvhRiUmCK5kdUnAQsVzGDTkK71AbgwuBmn	2659	3733	3733	1616611140000	orphaned
5132	3NKDpZYy7aeKdJqssGp8SowBaG6TxxBCvV6T69qPEbcLXy9v1Xs7	5129	3NLPXSzDyHhQEge54XQTHavm6RqthcaXpDSr43VcXtv4hVA5NYsb	1403	824	51	1	4980	jx1TwYntdXP1VjYjR4AiocoNe5PvjmtJFnyZDmBx6xmFhgF7q5G	2660	3736	3736	1616611680000	orphaned
5138	3NKnftAmJsBLSZZDprWSSLCGeDLaH4dXHsifUHQn4MBEX639jziz	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1457	1391	51	1	4985	jwGGRhpf79XcqtmRyDNB3axQpSMntrfZgFerymJowUBh39DdB9x	2663	3741	3741	1616612580000	orphaned
5144	3NKW7x8GQ16ZUMrxtpvMvAvNgomeqkMKUoNearqPgjmsktY4Xghx	5143	3NLHKvSpFXjqqQm37MAD6xx2K2YVJwkmYQZY1kzvLA2DjsCXRgY3	1403	800	51	1	4991	jxSQCcnghEG5UWA6fRNALguFjqHh5Qkr63NrDM5Ew2DjeMNWSMm	2666	3746	3746	1616613480000	canonical
5145	3NKpMDbuUCpDD2vMRAjLdYbFcgRUcqbt5ENpPKYQDuEMS73wccCm	5144	3NKW7x8GQ16ZUMrxtpvMvAvNgomeqkMKUoNearqPgjmsktY4Xghx	1405	1	51	1	4992	jwPUbyWvCGJJhqmUS7YRv3Fa6DA1eVZr5LqrZs1YwE3rPYzBx27	2667	3747	3747	1616613660000	canonical
5147	3NKmW3BLyWXkntFt77bsEWpwSTjGQoX4BqLk2pmMgGu6dQPPvfih	5146	3NLdnspXNM2TdEWQYgAWKyxsWuCxjfAKQ4di4BfEW6ZWKDG7ohJE	1541	1052	51	1	4994	jwRvR4kzQXwadVBrn5EC42RicK4Hnz4yupT9Vpmmi7CpS8JxqoB	2669	3749	3749	1616614020000	orphaned
5149	3NLFa9M158i9s6oggr9DTxP4UyBHuJg6UmV9SNFvhcuoSmcD9mUQ	5148	3NLZ2PZg2FiVScwwrVSAfQhde4JVMg6LpbMwH7i19iUp72Vde3Zn	618	618	51	1	4996	jwLdBbHKv6kFuT1t98rkgpa7zWuqUdyZA2g92TpGxNK2KAqbiCV	2670	3751	3751	1616614380000	orphaned
5154	3NKQWjyi4ZeCu6p1y1HJn5crwtqtzfzYnC6kN3MqpXu4vjf6ooDu	5153	3NKSdqHqJSzoVXuANQ4cq6MHxKHdEUTEm4VnrF6Kb1vJR5KJLH3A	1637	816	51	1	5001	jxa84KnZU8VpHvWn1axTFC1P5XXF1WphXzhWBsZzbR3qqr2hPNg	2673	3754	3754	1616614920000	canonical
5155	3NLGAd1VGzPReWXy9FDn6ucfoUjuQCawcnd5moMKqHx7H93sWU41	5154	3NKQWjyi4ZeCu6p1y1HJn5crwtqtzfzYnC6kN3MqpXu4vjf6ooDu	448	1059	51	1	5002	jx3bBEog7ttqvvVoywUzLDZM2YyrAP1XSdJb2SQVwTKK1T45E61	2674	3755	3755	1616615100000	canonical
8892	3NKWhtb99sPpQhZpX22ounhN5AiaBWCZzyfQCY8YKQwRtbqL4XQf	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	563	1359	106	1	6301	jwJ2oisnU7JYNvnmuVR5t6RhNL2ctW5vJgD1wRdcRU65oTHWFqp	4607	6488	6488	1617107040000	orphaned
5049	3NKzYnL6jypabSNYgpd3xgc85HN93mDGRRrC2GFHzXsuTfF3fg1C	5048	3NLde94SHjVsssRTN8UdLEyRQxxhSs8mbfBB5Bo29JLUjqCWrm5E	1581	778	50	1	4901	jwB4yCxXBBL4i3bNcrML3VzrXD8tNgVWYNZrbzq5DFC76zT72Pk	2619	3678	3678	1616601240000	canonical
5050	3NKQFv9Ds83jNF2o8cmbc9X7rz2KEkvHonw7iQQpjyjrAdpxze5k	5049	3NKzYnL6jypabSNYgpd3xgc85HN93mDGRRrC2GFHzXsuTfF3fg1C	1588	1392	50	1	4902	jx5HmTqAfUArnQ4TqWzus3qcZ8spo5fkJqtg2VrqYYX1LXy88zT	2620	3679	3679	1616601420000	canonical
5055	3NLxV3DRuApDuHjYevszk4v6RYFTwqeayp7kBQE8wDFhc4bKieqL	5051	3NLG5CT64f1zrckxV114Tvh8Xi4x2ZNhPBeyKuk8FyMyJbQLFSG7	1426	1118	50	1	4907	jwARpJMfd1QQ2Mu9pfrnCVkSCA3yLY4tvQwspr9YmzvX8vPaKgD	2622	3683	3683	1616602140000	orphaned
5058	3NL3HPtjAy6KXr3AQamYExJnW4TUpXGYS3ESPrd1QJncVtTsQZyP	5056	3NK3farQFJaCvWGYJ7cbvb2pGi16RVdrKxcS1Fqc56KMxfwpfjBf	1451	1292	50	1	4910	jxHFJ6hzJqQ9rQNZtDxtx24dAcZSCLe1JUWbdzNcUeGgx8qw6zU	2625	3685	3685	1616602500000	orphaned
5065	3NLApzWAgWKNBJWzoWPZxfT368FZFvfykzcEX4pKdAt35MnxD61G	5061	3NK7XMw3qcqPvo2XnWF86j5EQkAAioQGw2wDB8sx5YXNqxr2UDjC	1549	1362	50	1	4917	jxFtePPNUfn6dFT9JFySqEbDQPzkmY2aErWoTNE1mFEjPJYz6zG	2627	3687	3687	1616602860000	orphaned
5068	3NK6sNd4JsPy65rtw6LAyW97Qt5Fjvo7khk3dsfg5SmebAoYiqtR	5066	3NLn16moJemDiqSdCP5KNuLGQQbkmA4ZHFTCfe4X2hbwJWvTsMDb	1522	1322	50	1	4920	jx1nJqZNqriCEBQesP49t5CW5fM8sSS27qWkh9dk3jugvGGkDpF	2629	3690	3690	1616603400000	canonical
5073	3NLuUeq4L4brUB71E7rNQG7cAkgeLSAePZU3gcp7gRighBLSQGGQ	5071	3NLeVJkKJZtZwfxrgU4Dh1EpN4KqYHEJjtrXwqyKEZN65LY8scAr	532	1303	50	1	4925	jwXhmQ9mDAFkcWr7xGKum4To3YVLnGN39H9brsE2yCaxCePCE44	2631	3692	3692	1616603760000	orphaned
5075	3NLTMigB5744VHtHdqQ89o13d6XcGuS2j4931deVeg7xet3RmXLk	5074	3NK6Lcv9pKPvdiYusR5EsVmsDsDLKahQRSmWbnDWfZtWQbtczmNW	1451	1046	50	1	4927	jwBqq6V4GWcMuYHpN2zZvsj3EXUHeH2sgLGCdp6uN4ypVkdXyc1	2633	3696	3696	1616604480000	canonical
5080	3NLoTxZm8fLEzeUmgmsBVeuJTyfLnvRtgevvitWRdE35Q6EMmG6y	5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	1402	874	50	1	4932	jxiUi2Jt4JE6kxu3BLx89ANgFWMvaseMoUcSJG4cRAoU3FbtREt	2636	3700	3700	1616605200000	orphaned
5086	3NKVfW8AGgNA2guWz8yeUg9EaX7vqrd7RBQwy6GyNEYA5zzwxyMM	5084	3NKAhv8TkGaNbY67nkC2KRTSNY1DPeewPQhv4zg9bSvBHERAY5uq	1634	1331	50	1	4938	jw9Y3bAxgdu5FQkisgkHg9vUcb7eJmM4BgHxNKL16Fs2u3wkaWi	2639	3704	3704	1616605920000	orphaned
5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	5087	3NK4ke4ZQfUczFBYgYxg7TDKohSNdHWXkQJEPHiixAXEXJfEht4Q	1406	1393	50	1	4940	jxuEVjphtReFAiEQf1kuwfxr5A1rij77qmQgCeQm617xstP7a8C	2640	3705	3705	1616606100000	canonical
5089	3NKnnzTsdrJdKe26ZwP3LTjZWCxkJG7tM4UpzoYgpzczoyvsfnTf	5088	3NKowtggkpZ68kQ7WGiS47FNi7Br8kBbx16jQswyUnYRvgsCtWdK	1406	1393	50	1	4941	jwKG7f1tncReSE8xB6YRfYkj2qrNXBScEUr1oq3Zht9asL9fVkx	2641	3707	3707	1616606460000	orphaned
5094	3NL6Z3CmX8yPLEbgzhha8nDCAdSG9qvqQdHefZ5puRc8xDeu5fDa	5093	3NL24WtGzK9ArBAcYuhHDewn6DRVD2oPBp3bFQBwgX11YmovNLZh	1634	1331	50	1	4946	jx5dTAZzxNiPuBXaXUbyKkH769CDLR4wDVyyYdt39NdqS1m3Pfe	2644	3711	3711	1616607180000	canonical
5102	3NL3z3gZJvn14L4z5zwWRGLGpW1hrJ3jjZwp6YhGwM7TRgLp8kfi	5100	3NLY6gbPgCfhZaHUVeonXg1YL1yCKfnwgWsduwxq7QhLHGGQsucr	1403	824	51	1	4954	jwZqKTMMZrAS6HAkjxGe6LTVSfnTo3YEQrYFSPbWnU4GZpSHbCC	2649	3719	3719	1616608620000	orphaned
5110	3NLSaHUMHsXvzMNtdLkGXqa2p6vmXwAgnMdWELH2gUzEdYUf6tjp	5108	3NK3zuJNPTaPAfmpwZp8tQLPog3YPbVSARFTmjmWrn2PguL7uyZ3	1564	1338	51	1	4962	jwYzuWxNcvjGeckxxChviiDgQyscaTyEvtqtiWxR4vx54RjLLUB	2653	3723	3723	1616609340000	orphaned
5119	3NL7vuWQ7WivP8y3LU8aTW8hnP339nHrUBbyFWo8t3WYJnGbzzSF	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1654	1094	51	1	4968	jwEYbC1RKibVg89RXpymi7STHHrGurGNnPW8JobbjTVQHdfDqMT	2655	3725	3725	1616609744270	orphaned
5122	3NKY19eZwY1kwzQEuKmeMQ5iQwSADy9PQ1eqTNqpLBAChiDqhnYi	5121	3NLPdndzmjHh27tPSYFESb5LSZYNJxCEyyTDJT86nDjwoMePkdga	1406	1393	51	1	4972	jxNwXcEYVGiF6CnPu8P2VcS7uWV7VnuYEnZhiALa7k28pvC6uG5	2657	3728	3728	1616610240000	orphaned
5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	5123	3NLswauRaCDkJ3ZgDKSNSjUfkvAn79ZdTn2GmmXtMHm8FL18RHkr	1542	938	51	1	4974	jwZscPCgL93VxLTJe18ykXikqaN5xS4jYVL1vgpHMVXTvJ9UA64	2658	3731	3731	1616610780000	canonical
5125	3NKiv3g7m124SSW1sRE6oXJaiYM6ksaGj3bF4zpM5iKBqFbVkf7p	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1523	1321	51	1	4975	jxpPjfevYhc6DfRVGepSUtqV8He19aQy89EyYKosXftmipRQUDj	2659	3733	3733	1616611140000	orphaned
5128	3NL98HQVpgTrkmzewN1oZwj4YtdzqSh79kWQAiiBd5MV1kn4opeV	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1523	1321	51	1	4975	jwZdRjS8ZZS9vEAW5aziWqaiTdvgAfLH59hJDcMhSqS8KMHuD6d	2659	3733	3733	1616611140000	orphaned
5134	3NKQNHH2q2JiZr1BbQanYtV4pEduApnhZpuESwpBTNK2EvteTNT2	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1577	1081	51	1	4982	jxQ6F3tHuBEMXeEg49PuHWqo8AN6TZjiKJGGejRdVuyjdUCioZW	2661	3738	3738	1616612040000	canonical
5133	3NKGz7mYCazrmfMJUksXGnQ2YAEJfyhZf4cUXGuj9SRmLGeQ91xt	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1402	796	51	1	4981	jwFyxcoyfNf81GmUryMxJHYVtT8xeTUfvghRPU5KSt7u1w1J9D9	2661	3738	3738	1616612040000	orphaned
5137	3NKHGXazAgXdhwPgnvhGuUN3vf7hYxrxX79imDCxTVALp9Aw2ucG	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1542	1304	51	1	4984	jxymLtNx9wACkfdT29nYcKLVEcuyagmSWxe2WXP7kpYxv4a8JT6	2663	3741	3741	1616612580000	canonical
5141	3NKr2cYSBN17meCfCka4wVNrhYkh4VJYFiJprjswMVzwxachgnLN	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	641	1336	51	1	4988	jwDeU3MRipjqVnVaP35gdPdub7awz1QcdXHFFHuU6atYZxVgW8z	2663	3741	3741	1616612580000	orphaned
5142	3NKzhkJdECA55VcBKRFo4K4pV19KX1fr5tzSpbFwYG5MTKourG2k	5137	3NKHGXazAgXdhwPgnvhGuUN3vf7hYxrxX79imDCxTVALp9Aw2ucG	1602	1003	51	1	4989	jxKjrdkqh3aAUhMePToTk7CdD1zP18mzcfNiLadVBZqn9y1WSok	2664	3743	3743	1616612940000	canonical
5143	3NLHKvSpFXjqqQm37MAD6xx2K2YVJwkmYQZY1kzvLA2DjsCXRgY3	5142	3NKzhkJdECA55VcBKRFo4K4pV19KX1fr5tzSpbFwYG5MTKourG2k	1623	830	51	1	4990	jwnBFvCrsf9AiTGNrArBwTHYPH7kygVyxSR63jmkXJjgdF39Nsz	2665	3745	3745	1616613300000	canonical
5153	3NKSdqHqJSzoVXuANQ4cq6MHxKHdEUTEm4VnrF6Kb1vJR5KJLH3A	5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	1403	824	51	1	5000	jxFQcAnKCmHS6VZgkEi7fqbKcQvyyhimAJ8w2gDFTTpLYvH3TPV	2672	3753	3753	1616614740000	canonical
5159	3NKmaXJtYFA8FgXw6Mum5At5bVNHTu2KuYhonSNbrE2UYX23q6TC	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1541	932	51	1	5006	jwN1DaX79JpD2e4gKRe7wQYXWzmwZZ2R7Wz8JN7xJjfV67gT6XK	2678	3760	3760	1616616000000	orphaned
5164	3NKY9gNp1G55K9DpP3SnSPgtpvZZa9QYxy3DzcBwsmQtePGujjAA	5162	3NL6q5HZ1qtZ8d15oTvxznSC7YfBZtvCfYG6EfETx4ddzGkkexAD	1637	815	51	1	5011	jxLuVZbCMhADykgmavrXvLn49Thy1XxYSryjdmro2XUGaJDUqPi	2679	3761	3761	1616616180000	orphaned
8891	3NL1ZifYLWdrfxFrvY4dnNL7FBzEx9vAEdtd4sErUksY42AYiPDQ	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	1516	1294	106	1	6301	jx3ytfvpg1XqTHwpNvPmiNbmhJoKkgZd21kvRG27GfY1mRe9nmF	4607	6488	6488	1617107040000	orphaned
5129	3NLPXSzDyHhQEge54XQTHavm6RqthcaXpDSr43VcXtv4hVA5NYsb	5124	3NKUDgRfqYLUNXm6chNokgDJ5uGqgWpsNHMHNYWbSM2SiwPWjcBu	1403	824	51	1	4977	jxK6sFkGYEAcqtQdNdFyWkWzBaY8iWXARYVbjJE6qaZ7uQekz41	2659	3733	3733	1616611140000	orphaned
5136	3NKPeSgSTHxcfogkWWsvuBaehULhFg289udFKU2GsRWnB6BT1LCs	5134	3NKQNHH2q2JiZr1BbQanYtV4pEduApnhZpuESwpBTNK2EvteTNT2	470	1183	51	1	4983	jwWDKqLPKSb7Df1jow5PUG72UfAzp6VdPMTj9wccTKcm5KYB1my	2662	3739	3739	1616612220000	orphaned
5140	3NLNUe2u7BvQhdgtgv6mHyWPEkFunW7DE1ftfXsB4vomtmLGq1Li	5135	3NLUpkzJfGuudqdA76P93AtAf7wsgSpz2Aiev2RxXeMSM2C3hDCw	1668	1244	51	1	4987	jx6zAG4w6PxurGM9W517PQFb3oVYbEpDJ13tMAFcYN3sm7om8Mz	2663	3741	3741	1616612580000	orphaned
5150	3NLMZQ5Q6MmSNoVbTxnFU2wPbkUMqMiXidkWprMtJV3uTP7cHJat	5148	3NLZ2PZg2FiVScwwrVSAfQhde4JVMg6LpbMwH7i19iUp72Vde3Zn	1560	1291	51	1	4997	jxb6jYm9DJKHFXEPcrhnywjgRS47f3v2aUm1nyMNWGPhcVkaWLr	2670	3751	3751	1616614380000	canonical
5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	5150	3NLMZQ5Q6MmSNoVbTxnFU2wPbkUMqMiXidkWprMtJV3uTP7cHJat	1476	1125	51	1	4998	jxxFgiRZQDxiKnjrKX7i6mkm2SyrT6w2bXVrvJCDfU8UZaDwD3K	2671	3752	3752	1616614560000	canonical
5152	3NLVrxyXBHcsVxQPnbqme9yKrd1rpXK6Tc5E3ruDdoLQ7VFd3kSJ	5150	3NLMZQ5Q6MmSNoVbTxnFU2wPbkUMqMiXidkWprMtJV3uTP7cHJat	1457	1265	51	1	4999	jwPhv9NmAqmZBvq67zXhFnn9CmzGY1Y95JdUhVwjEhQDJjt5cJi	2671	3752	3752	1616614560000	orphaned
5156	3NK9C5gn3ZmHHdXd2ToxpKa5znqBRJEv12c591166VQj6YLn9Fvw	5155	3NLGAd1VGzPReWXy9FDn6ucfoUjuQCawcnd5moMKqHx7H93sWU41	69	69	51	1	5003	jwZzpi2NVHvjcGBb2P4PngUcLekWH9svMygEfSJf6wdfFNy8FJw	2675	3756	3756	1616615280000	canonical
5157	3NKuRgNQqnXt76ghrUcUBpujLnrRMmPW6yzW61Hkrj7GFkykNULw	5156	3NK9C5gn3ZmHHdXd2ToxpKa5znqBRJEv12c591166VQj6YLn9Fvw	1406	1393	51	1	5004	jx7GKNtes3Ji5AgxtNRYPHFEpJrhBmVWj1gqkN4xfGFebqNZmoA	2676	3758	3758	1616615640000	canonical
5162	3NL6q5HZ1qtZ8d15oTvxznSC7YfBZtvCfYG6EfETx4ddzGkkexAD	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1578	1050	51	1	5009	jxJMi7GMrf4xNQwvjYaHGVEqm5USFkYhLiJCX9AsThzpCZbZb1K	2678	3760	3760	1616616000000	canonical
5160	3NKyCdkbRAXJcQ1TXyauW8QU9cnAfbucCLsJ8KKR4PYZAsFUWeu4	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1516	1294	51	1	5007	jxyDSH4HjcnDoUWTXybinibgvePJ5teDjoPVb3tJEGYgjXX4Fxd	2678	3760	3760	1616616000000	orphaned
5163	3NLvRSpDSykJ6qtdeQrmVxuyMLCG8vwLiq42e6k6VHGC7b6YdJh2	5162	3NL6q5HZ1qtZ8d15oTvxznSC7YfBZtvCfYG6EfETx4ddzGkkexAD	1483	663	51	1	5010	jwat8qCP7omJ8qbheh8SmevsLANZ9AnHPDJRvavEBKF7hHWiHNT	2679	3761	3761	1616616180000	canonical
5165	3NLoPg7KAuaG1E8gChmLHLJxkY8538FgfDx1svFBqR5KYaehJBV6	5163	3NLvRSpDSykJ6qtdeQrmVxuyMLCG8vwLiq42e6k6VHGC7b6YdJh2	1461	1271	51	1	5012	jw9BXvFi9JTtycaSSnFbgoHd2PaPAiFYr7gZEdfRiptRyLvor3d	2680	3762	3762	1616616360000	canonical
5167	3NLL3b47cMCXyGng7UxwxaBGghh7iJu2b3ewH1CcDuhjCFTFjehd	5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	1671	1365	51	1	5014	jxV1pUMKfW97dLoaTdGNN5ML3xbGS7DqwEc6aKJy7ae66inYUE1	2682	3765	3765	1616616900000	canonical
5169	3NKwqgeE9QStXba2iAENQh7bxSgwb7R78TKsaYc3ThxD7BAVvQam	5167	3NLL3b47cMCXyGng7UxwxaBGghh7iJu2b3ewH1CcDuhjCFTFjehd	1581	778	51	1	5016	jxbyF7gsaQx3iNvX9L2gW5mWeiC59zmTxEK7Zg5oPmmZo6JY8zQ	2683	3766	3766	1616617080000	orphaned
5170	3NLg6hZNzhGaEHKftxCufogFFMZDxDFZAC5oBUymL7fqbsSt4htN	5168	3NKSwUY5z26UcasD3iFCkRHMMrrvWMfY46kUeZW7XH2kGT6VTqG6	532	1057	51	1	5017	jxtJxFpbQMHhjzuuqPXSpnfcwcftwcdYeiThcAeBNaPmXwDFRHz	2684	3769	3769	1616617620000	canonical
5171	3NLHG1u36rdTTfErQkDLkc3JFW3AUZeZsLmTHYbCPmHEL3BH9L6s	5170	3NLg6hZNzhGaEHKftxCufogFFMZDxDFZAC5oBUymL7fqbsSt4htN	1406	1393	51	1	5018	jxf5aEZzQLXuxtg491aAXhhCdrEFgBZ4mRJ8m2eMc9PjyrVADTf	2685	3770	3770	1616617800000	canonical
5175	3NK7V74MwZFHGZP7uhKNLjvtTyUC7TaJUjTmMtjFYs52Ms5Yn3d5	5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	1646	988	52	1	5021	jxqr5BmrTx2UHwwPFhdv24h5AtP7PmjFr1rxtQfgQMzmh2VJ1zF	2687	3772	3772	1616618160000	orphaned
5183	3NKGehcLpk5V9dASRs9stiT26vBtW3Bo8eHqzV1wrvdWwKysZwAQ	5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	1652	1189	52	1	5027	jxEE6AfjvxfWWiafHxAYMdB71kgV9G9Wo76cTwcR6B3xPg9tw2A	2692	3779	3779	1616619420000	canonical
5213	3NKwyozuPkWJqW5JgLKb7rjMeDkYAedMMYGohCUE5zqiGEbRGvBH	5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	1656	1097	52	1	5057	jxfKwHE26yy59FrvnhvehsikY6XJndRm6MfEboCPj3nyAfKVNxv	2692	3802	3802	1616623660696	orphaned
5188	3NLCRFrBfZCkKwuLrFHqPKbxA8cEWrsEBFhqbEkVUZ1nZFJURqwx	5186	3NKgrfKLVqayQLbALoVkYsWEzB62XjKshHrQJW87PAW72qjMsunz	1637	816	52	1	5032	jw7ScoJqL1v7KUP4iM9aoG6LSp8Wrqzx4n8nJzBUsPHF9ZGptQx	2696	3784	3784	1616620320000	canonical
5191	3NLpSUpKCxMgP9DtKyTLuB8zj6CaCNhVxsJSuXosemQUn5Xm5zL9	5190	3NKSg2xfSitEH85VcNeSgZ2PwKnpQomJNzm5yJuPXWSMAUNvcWWU	1534	1317	52	1	5035	jxcdts3ad836k4Z2iQwZBPV2yP2h2deuoGBGqx5iaM3ck2wBaL9	2699	3788	3788	1616621040000	orphaned
5196	3NL9Eagx9xrFiKADB5sJDE7KyiDnXdJ2byrBLJs29btc341TABeG	5194	3NLhwX7Puw1TfsHjGDBLz2XX3ryeTMGFmQ1jRRYusgAXygp2upLQ	1613	1349	52	1	5040	jy3CYZhG1z7zCcdJwFteZhWbMPGbhVUmiEAWA16XV8eN3Kdjxry	2702	3791	3791	1616621580000	canonical
5198	3NLtwmsPxhzD2MQ8wVsJ8vh91YNfG1dWhxf9fLL6qWxAheGjWdai	5196	3NL9Eagx9xrFiKADB5sJDE7KyiDnXdJ2byrBLJs29btc341TABeG	1405	867	52	1	5042	jwsVoP4zmHYDsxbHrbEvs929VTNZGCwH8Bb2aNtxexWG9HDvQkL	2703	3792	3792	1616621760000	canonical
5203	3NLfEjHCPM6rA2aYhMrSJ38kxmpmMZTiEjHvYSgMTfRQaXUCHC6u	5200	3NKqHjYBF5j4t6ZeGfQPz7hChXcTKNnNwiry2srfwM36i2hnSj5N	1403	786	52	1	5047	jx9u9oHgGW6E7A9E35dMG1hqGyM958Ze7PBpuAhXGWxo2cWxWsG	2706	3796	3796	1616622480000	canonical
5208	3NLeKpaztp6HmjMnsqegKGnp7YNt97kZpVyNkG8yzJ4HjRD1c24e	5207	3NKEWqhK9NBr1Jghs1CK7zCCNGDmH8qyGdyE87Wqf3GKssoENRC7	470	1309	52	1	5052	jy3EU7AqHe6qcqAV1zEELvnpnjx27iPh7wUsoM1mwpdo8W2Mq3g	2709	3799	3799	1616623020000	canonical
5215	3NKzdaXyqsKkXELiXrMZH3bT9vDxDNyiy9QTeEqQWVs5KNf9ZHXn	5209	3NLDQhtvPvZqnnWcZN6e13vtvY2BzMQDPt82tGitP8Wo8ovg4gjp	1560	1291	52	1	5059	jwEXb1nSJ82y2yatkH62kzmVbFvL6dJznfPjY9JZLMPDswqSzsy	2711	3803	3803	1616623740000	canonical
5218	3NLsKgiAZuqhXQnL8w4s6VvhAjfz2JL2GGK62BVvAbfUs7fmkFFB	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	1509	1320	52	1	5062	jxJiRgvY5SSRXZgzmcpXm73z5PdRnYnFQYg7T1iN9zZMfKi1Zci	2714	3807	3807	1616624460000	orphaned
5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	5221	3NK5L4mMus3RkTdQStuDqmuxKHrFMYjhk3NRcJaG31DGyTaLZnRG	1594	1326	52	1	5066	jxM7tYLswbP1VJqU1Sd9yrL8cLf4RRmG72g3W48jvQWggt2Vbst	2715	3808	3808	1616624640000	canonical
5225	3NKpyjqjzMrHT5TzZ6XXqxVB9nRDpuX6bGjuz2zN7MnXEoaBdUja	5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	576	1229	52	1	5069	jxdn3VcxyzYiaKPBfrWD1My6UZP8MC185w3gs6G5KQ1huxW83tY	2716	3809	3809	1616624820000	canonical
8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	8924	3NL1s68Qqha5DPf5oR8JCETUcc4p5SMFPikRoAJhgP7mf2kEt2tb	1549	1362	107	1	6301	jxVje1M7sqmkyNm7x5YU291wEoeCFUCTnAcaEGRK1WR9nyyMcCp	4626	6513	6513	1617111540000	canonical
5235	3NKvdjWNfC9jKhLFsNdMbnuKMnF43uEEc7vwBn4YKuqzkdpEGPX5	4934	3NKLkF1X2X1DYdkmJJvSVtsascEN9Ld6tuhnweFFiaBcK3U89f3m	1406	1393	48	1	5079	jwWW4dYzbsLE66LAjk4ZrxeeCghRW1sqY7nVdXKrSgEzrfSoHU3	2556	3814	3814	1616625819999	orphaned
5236	3NLBWj4dBMt61s47gJGyQhW95Tu4HygT3JJv3iDc6c7GeUktPpBA	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1406	1393	51	1	5080	jxrtu8YEJ8r6G39LkEPbmEfv2KsP5t3CRHjg4w6UDrjGP2XNkNe	2661	3816	3816	1616626080000	orphaned
5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	5165	3NLoPg7KAuaG1E8gChmLHLJxkY8538FgfDx1svFBqR5KYaehJBV6	576	989	51	1	5013	jxmrM8buaK8Ak1pfPwqVuysSt6SLdHuvxvrpiRPs5PrwaiXYfza	2681	3764	3764	1616616720000	canonical
5242	3NKgVms7zJPXEDDovtk1UkkLNTe3aQngqTNarfxChhUEcPV4SkTZ	5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	1406	1393	51	1	5084	jx1xAnFAsoNdB5T73AQ1zrxycbHqCiNUoHm7MuvTBfqrL5XWGEh	2682	3816	3816	1616626151452	orphaned
5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	5171	3NLHG1u36rdTTfErQkDLkc3JFW3AUZeZsLmTHYbCPmHEL3BH9L6s	1656	1343	51	1	5019	jxudVBPMncioMK3jxkzfRgsAbCXMbxxgvMKbaaBqviiLcFz4GXX	2686	3771	3771	1616617980000	canonical
5174	3NKKSNykuANoopEQHxc85BE3cqDFHCxxntCg4jRMtauPiAT8wPQW	5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	1646	988	51	1	5021	jxudVBPMncioMK3jxkzfRgsAbCXMbxxgvMKbaaBqviiLcFz4GXX	2687	3772	3772	1616618160000	canonical
5179	3NKD2BijBvBEx8yYkMcykvnzKf5FbUQkE3du8YwmvNx4panTbCYC	5177	3NLpongeGqTHLAgbTVHoT2hswyjUKQcnigCJtEq1YGfqVZdTpw33	1675	1216	52	1	5024	jxGvoQhW9SQZztPutEpv3fcWBVcBjxkGmkoMzjfKAFmRoe9DjBg	2689	3775	3775	1616618700000	orphaned
5181	3NK5DoQtbbmrL5qEV9vLennFidJjsmX2a7xwRE7KmwMbuBsxEL2R	5180	3NLJPo9fcJvmtYBhDS3bJNnvLkPokj8thU6bcAL36isADYtaHi3m	1649	1257	52	1	5025	jwo3N4k5UV5kh4qWLb8aTKKbPqk1sGJ4n6egZvNycfpXXX67EEX	2690	3776	3776	1616618880000	canonical
5190	3NKSg2xfSitEH85VcNeSgZ2PwKnpQomJNzm5yJuPXWSMAUNvcWWU	5189	3NK4CJupjhsVWSGYb2qrHF433LhhuGiuKWwLQ9W4Eh48LgSxrRYk	1477	1104	52	1	5034	jxbgSmQmJAto8WPUgTbEh1vHgYawEqB5gvb42H5k85hRSmJqcQP	2698	3787	3787	1616620860000	canonical
5214	3NKBeD2rRWyHjL9nxpHJPPgW9kitBY6zeax5bQEaJZCT354APmpC	5196	3NL9Eagx9xrFiKADB5sJDE7KyiDnXdJ2byrBLJs29btc341TABeG	1656	1097	52	1	5058	jxcAhD22pAqpKxq2FjDpGDkXfHac6origxsVgBdRMvU4k682Nwm	2703	3802	3802	1616623693558	orphaned
5200	3NKqHjYBF5j4t6ZeGfQPz7hChXcTKNnNwiry2srfwM36i2hnSj5N	5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	1406	1393	52	1	5044	jxUYj9Z1xQe3QKKces1MoxAqMnDxJWZUohdH2KY3MnNs6ajPAwf	2705	3795	3795	1616622300000	canonical
5202	3NKFgx9kXnxjPfC2emkUNmtPQaVRr4s7hH9t4jTjZ99X1pCfkWK7	5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	1481	790	52	1	5046	jwm8EL1Q5QrStb419injeoafpqUDuU5rXKmKrc4kCfjkjQYuuZR	2705	3795	3795	1616622300000	orphaned
5205	3NKGujEgVz1yqbJApmKzj5EguErtBeGp3BpoXJAkkrxvG56HSzj7	5203	3NLfEjHCPM6rA2aYhMrSJ38kxmpmMZTiEjHvYSgMTfRQaXUCHC6u	311	1061	52	1	5049	jxcLR2SyEaE2VV2hMUAUmvKopdAPnZM6WaB1ykvWgEid245cAc2	2707	3797	3797	1616622660000	canonical
5216	3NLRw6P3LXHvhohLtMa8yA3ccyEC3V8scaVDDXwQrEFFJK3nqJQF	5215	3NKzdaXyqsKkXELiXrMZH3bT9vDxDNyiy9QTeEqQWVs5KNf9ZHXn	1672	1039	52	1	5060	jx9GfVU7SrJ4EHXG2Li1iGyQ2zennhU4iV3QYH4HgDuXvwGmTHN	2712	3804	3804	1616623920000	canonical
5220	3NLFp1KtvFV2FpKaQBhWV8VgUbE8aNzDyVYKgx7NZjyrqQhnes1F	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	563	1359	52	1	5064	jxFZUWhxpdWqEMYLvDPaLamzBGaxoFCXrxHfLZ7E6WD7ArXrMtT	2714	3807	3807	1616624460000	orphaned
5226	3NKpcPhWtxiosJvr8zDSkvA4FYAgn96zCn5dT3gYbYPa8Ux3tW97	5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	1637	816	52	1	5070	jwqhk17wCGBVQ4SJqCsJy931LT16wWoL28ic963oW6CyaGzKqBk	2716	3809	3809	1616624820000	orphaned
5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	5227	3NLUB7WXDqFfoJLq58r8wgAn2an6YpvxEsLy2yrTbGgs9XQNKjGi	1403	782	52	1	5072	jw78MLMaXbma5xDVfi5dKf9uXrMdEDmQpYALMoqCG1kA3bsCu8s	2718	3811	3811	1616625180000	canonical
5239	3NK5MqJgs8zjn6e9urcM2rCNWSojaMhipuEuJzarNvUnyRd3wxj1	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1610	1068	52	1	5082	jxvcTW4DQMJkawZKc8mFHaeNaieEzttxX1xVkprruggaH7Q94Wp	2720	3816	3816	1616626080000	canonical
5237	3NLfpB1esyXHqz6DboHThfuporTNSiC62GGS6Geunva5pEp4zGPg	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1523	581	52	1	5081	jx7LWP4CG2hp9Um95C21BWntXnVzBjcwEByEa8DPus86cNNAqGk	2720	3816	3816	1616626080000	orphaned
5246	3NKUVg7X7djHhT1gGJjtutjUKJRpfao9PGoQ4rFKuCRrNDAGSq5w	5244	3NKCCGt5p4rc36kAQUbZE8jziEBYGe5CH2ANbXB7sKUbDk6Tkvqm	1516	1048	52	1	5088	jxUnPEVAM3w6dxWXadRWkvcDZDSdixP4oH5r8QFi5gFseEtiUgA	2722	3818	3818	1616626440000	orphaned
5247	3NKpZgo6D4Dbo6VVJ86Lw5PqEND3NPihBab1RVdAPbZcQmJvkMmN	5245	3NLYe3asF5pBRMSjxw7fg9nZeJksouWXrTyYWrtz5sgWPFNpB4dL	1406	1393	52	1	5089	jwSkQJJDnMuTUHCEdYP98j3AS5FDPu2FBT5ExNByQcuRLTCvrAm	2723	3819	3819	1616626620000	canonical
5250	3NKbXgqeWYn7p7vyfqHTykiUWYsxApUsUX3kggwUdpQfyJtz8bDi	5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	1523	1075	52	1	5091	jx7viv7xZ5Snc9tpAayyEDe8YPoN2XTgPZT56xYK9ZQRbusoorW	2725	3821	3821	1616626980000	canonical
5259	3NLQ6fLJ1NtcbXPPqbkFyG5Nuqs6CuqGTZ6CyMT5vGJVaGSBoxTM	5255	3NLQH69PPEtGfKLWbWUnY1XKxwGqSXXR5K1LqVcr29so68uDk6Dz	43	1310	52	1	5098	jx9eAG2DCQQXboKwEDnzz74PzmsK6BBDucyqYok5GCD3XwT5uoX	2728	3825	3825	1616627700000	orphaned
5261	3NKSETweEipc3qCnS5K3TT43sNUhAb7nHP2z6esBpYGTV59fTmiq	5258	3NKyFUNpbvoSxLiTdvUKPEJDzPd3jeGFJK1VSx6ERg3ekGrqWomD	1633	1390	53	1	5100	jxz8JVHR7UPjndefrKPsVXXcQHFVg4iozvDXX7D2cEZQWtda6HS	2730	3826	3826	1616627880000	orphaned
5264	3NKEHAZRVGHkgjGtRuGMZGAWwFd5Dacd2gkHaf6VTiBYTU269ypz	5263	3NLYznPXZmKF9LSWv6XgBLtoMUSFMhu77NfwMTamupUVSA1BCBJS	42	1115	53	1	5103	jxys4RqfXRAk46ZQjvUAfQM9uLnvdiN2wXFUPuN4oqTHRC3v8CC	2733	3831	3831	1616628780000	canonical
5266	3NLW4WtKF9xtW2NbNkBsBMyBcEbDb1Y8V4KqhuUEGkEajTiEjiMk	5264	3NKEHAZRVGHkgjGtRuGMZGAWwFd5Dacd2gkHaf6VTiBYTU269ypz	1601	1142	53	1	5105	jxPithZcuTYqTvLqMxrfDz7gQ8WZHWNMSkP8cHTxLFZqJF4RXHP	2734	3832	3832	1616628960000	canonical
5269	3NLGquz5LDoLQQE85z6FCxaTQnMj3swscHuFMUNJWePw1ydV5bjS	5267	3NKoaasr4W1j1bT1ZCAZiDYdXcftEetoSsStWzBv64QGxABGLrBJ	1529	1070	53	1	5108	jwTmqSem5JkEDXy735Wk5B7ViBgoSVhppMM7aDCe86N8FGdHrCP	2736	3835	3835	1616629500000	canonical
5271	3NLK1PgysLqVUKczeiZfNcfDvprEXn9S8NWUUW6DANpCSMSknpmH	5269	3NLGquz5LDoLQQE85z6FCxaTQnMj3swscHuFMUNJWePw1ydV5bjS	1643	1299	53	1	5110	jxy4kqXE1R5TCSLkNNRQ3dGKT9XB4dyGJ6zEX2CTRfaWKchStof	2737	3836	3836	1616629680000	canonical
5278	3NLsamoGAFg2xapbs5gNhTArb2zH4SmrZR3YGoLf16swU1RiB3UA	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1508	1141	53	1	5117	jwv1CrS2TBTnRsLCs1rDah2iS6wRUz9oPSu7u98JkWK54n1KKDV	2742	3844	3844	1616631120000	orphaned
8932	3NLKqsJT8KWqWsTmmRVGSjJHv5PwVhFhjVRKbDbV5xvZW842sGLF	8931	3NKfgSktufykC5FKbcqTmZhCLEu4DLPWq6TSdyeEBU6kMfGDXrra	596	1306	107	1	6301	jx1hgEGr6dbu2ffg8uBBHFPbLN9GrhD2swyLSso7U5PoNsgDvtR	4631	6519	6519	1617112620000	canonical
5240	3NLf3ePov32AZLo8wJmEPGaBka2w6NRoxkCx4j2dg1aEpDU59BW9	5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	1406	1393	51	1	5083	jwKu4HocE4NawzbUpKW1R5Ba4UYgpqjtioGdzf8QBNrm2eXBfH7	2672	3816	3816	1616626116997	orphaned
5212	3NLsD5fFhukZ18wc6HTpxfksRXmLoxyMP34Cvf9qMgu9bhAvva78	5166	3NLfXG6pzQPXghwUwkdzL8XSQNeTH2oQjL9QkAqwVoXS3CRYUL9t	1656	1097	51	1	5056	jxKqsMoEFkuMS7RadeGCVtbm2hdfP91mNrLW7zgd7eghdNZz2G4	2682	3802	3802	1616623626911	orphaned
5173	3NKkimQoFFMTFZ9aRjySkPmWiCUGzZkCsvQN2iBmRRUzag7WsVS3	5171	3NLHG1u36rdTTfErQkDLkc3JFW3AUZeZsLmTHYbCPmHEL3BH9L6s	1587	1357	51	1	5020	jy1yoTEQtxuL78vAKhPzivhg1ArjDZyF1f5Cnw28A4NoTRxyVhF	2686	3771	3771	1616617980000	orphaned
5177	3NLpongeGqTHLAgbTVHoT2hswyjUKQcnigCJtEq1YGfqVZdTpw33	5174	3NKKSNykuANoopEQHxc85BE3cqDFHCxxntCg4jRMtauPiAT8wPQW	1427	583	51	1	5022	jwTwV3pUeGCfwqU8a7ZEmr7dw6S1jbmbZxHZguGjSEYVknpMB2v	2688	3773	3773	1616618340000	canonical
5180	3NLJPo9fcJvmtYBhDS3bJNnvLkPokj8thU6bcAL36isADYtaHi3m	5177	3NLpongeGqTHLAgbTVHoT2hswyjUKQcnigCJtEq1YGfqVZdTpw33	1675	1216	52	1	5024	jxdLFnYd3z2UQc7j9Np8Wa8xsLCKKPCkPY6iFGcztD6qH9PkpYM	2689	3775	3775	1616618700000	canonical
5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	5181	3NK5DoQtbbmrL5qEV9vLennFidJjsmX2a7xwRE7KmwMbuBsxEL2R	1460	1078	52	1	5026	jxmNxXMnRaDagujo48qQbQsyL5m9D2ZbpQobwfH9ogBMYz7WXg8	2691	3777	3777	1616619060000	canonical
5185	3NLncLtKmzrrBMj9LKpRW2dPMAy7fWoqRqq8h3XGCEVmkyg9p8Zb	5184	3NLXJtRoSGC9re2whWv4UCHa4kLgnLWzN9JVihoedDSwF495D1UV	1483	322	52	1	5029	jwMbNf82uVR3Rxzhnawk6PMsLaQqbDEYoJRxgYFBdgW1U1VniWr	2694	3781	3781	1616619780000	canonical
5187	3NLYFZhcZkbvkcjpjX2rgMfALDutvNE87TzL2Z6Ar3yQeigaq834	5185	3NLncLtKmzrrBMj9LKpRW2dPMAy7fWoqRqq8h3XGCEVmkyg9p8Zb	1637	816	52	1	5031	jx37jLJ8LveeDkmPY7XyuL9tMfRMN77eeUQukBjwE2SJsk7rZvK	2695	3782	3782	1616619960000	orphaned
5195	3NK8ezgvfQA6QAtuPWHFbCckacZV3qaLE7Ct19AsWXfaCdgWAh79	5193	3NLXShrUfGzxKALg7TMPY7XPgCTDEnjfqyHcoADX4sXBKcawxyhm	1490	1148	52	1	5039	jwhdrksnjAnf1bLHJwDKPEbddqFxtSmWwMVPE6TdGb1fK3umF9p	2701	3790	3790	1616621400000	orphaned
5201	3NKXt8nXExtboZD6XzVheiA9Gc2fcJTNjYLmH6fQ9YnRoLiX4yLz	5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	1405	905	52	1	5045	jxpSxyoTciGCUHLzhzYP9UM8jerfjEjrwt4ABGk11oVtCcM4amS	2705	3795	3795	1616622300000	orphaned
5207	3NKEWqhK9NBr1Jghs1CK7zCCNGDmH8qyGdyE87Wqf3GKssoENRC7	5205	3NKGujEgVz1yqbJApmKzj5EguErtBeGp3BpoXJAkkrxvG56HSzj7	1403	786	52	1	5051	jwyiCUbdBDkmNQ3uLV4LmdQDPdPG3Zh3xRF2VoD2HWjk39Vkd2V	2708	3798	3798	1616622840000	canonical
5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	5216	3NLRw6P3LXHvhohLtMa8yA3ccyEC3V8scaVDDXwQrEFFJK3nqJQF	1611	1341	52	1	5061	jxjdtD8GBtqJymhVDKvyfVYTpp4oHjVNs7XjnhvN76WDKSiSYWS	2713	3805	3805	1616624100000	canonical
5224	3NLme9rD42AsEJ7gPnQYNWUs8pBwrUtQVVMUrhPmWcdx1CNTEUz3	5222	3NKSKTcRuHzFyiPFhygVwAbXVP2DcVXLjmuzMv8QKDjU3tvUuoUq	1406	1393	52	1	5068	jwxBdck7r776Q3WBYUZr3oGSdUNjmQDiCTbmSA7tu9K3sgchyFm	2716	3809	3809	1616624820000	orphaned
5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	1624	1334	52	1	5075	jwutMrCVsYLASeBxqSAwNcS1McGPw514nUQ8bpnjSAgEH4cWQVN	2719	3813	3813	1616625540000	canonical
5229	3NL9TnmWK1X13HnfJTvGTUt4cu8TF6SfPaN9hMq7JGra8u9FGE2e	5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	1451	1292	52	1	5073	jxWpq8sf4z1sRaYTKcuPAtspDhVjpUTaC4RcLYyfcRLdaYb29QH	2719	3813	3813	1616625540000	orphaned
5238	3NLJXhdEGt4xiSPUwf5mfwpVmYTJyLBeJ7coiQAFt7WMT4k3qUnf	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1523	581	52	1	5081	jwtWYg4e16bWFdEiQgHM4z8BhU5kpgy3T9mUJVuKPKwCKedBMSV	2720	3816	3816	1616626080000	orphaned
5244	3NKCCGt5p4rc36kAQUbZE8jziEBYGe5CH2ANbXB7sKUbDk6Tkvqm	5239	3NK5MqJgs8zjn6e9urcM2rCNWSojaMhipuEuJzarNvUnyRd3wxj1	1483	1276	52	1	5086	jxdPDwB26LDBT8Vmp3wRujZ9CVYv4moyuUjDcaZrb34RxztjbF9	2721	3817	3817	1616626260000	canonical
5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	5247	3NKpZgo6D4Dbo6VVJ86Lw5PqEND3NPihBab1RVdAPbZcQmJvkMmN	1406	1393	52	1	5090	jwLfMmCESAAjsJJb586y4mxp74kqfWqKW5EAg9szhDT9LDDEMAj	2724	3820	3820	1616626800000	canonical
5251	3NL5wxaEZrdpeWeqnS71R4Dke5cs7TFj9FPLFetLiuDLKiZnDuyc	5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	1523	1075	52	1	5091	jwdeVE87BUqsJhC2YCCWWRvsbJMjQBJMt11KRFKs23uYRaTXUan	2725	3821	3821	1616626980000	orphaned
5253	3NKSXjinmeVEGMRGYz1S9UkmQAFD58awZgA2nZUm1moSsxkn4Txw	5250	3NKbXgqeWYn7p7vyfqHTykiUWYsxApUsUX3kggwUdpQfyJtz8bDi	1634	1331	53	1	5092	jxZFX5jey3Wze7QyULK38SPMJjxyadNvNzEjTPpWVz3K8Q4gcaj	2726	3822	3822	1616627160000	canonical
5255	3NLQH69PPEtGfKLWbWUnY1XKxwGqSXXR5K1LqVcr29so68uDk6Dz	5252	3NK8mnaKKkXjfyB3WT1q9sZMghkw1WsD5vf47Evr4mqQeY43d1AH	43	1310	52	1	5094	jxtpLBM5MQpy7haMpS7rkPeMMY1LgP491tNYG4rkRGLvRW4RY1M	2727	3824	3824	1616627520000	orphaned
5258	3NKyFUNpbvoSxLiTdvUKPEJDzPd3jeGFJK1VSx6ERg3ekGrqWomD	5256	3NLm4Huqi1vZZGHE9dLdHHNCidvRGiXSpE1bvAZCAWy6pNLEm43t	1513	1379	53	1	5097	jwnaBpzgMbSDtaex7e5EEAjSDHpYNNiE76cHDucyc3pKye8dTJY	2729	3825	3825	1616627700000	canonical
5262	3NL5RJUW7MzpSY1X2iJQK3MGxEns5VkH5JzkUTMocotkg2rKZcyK	5260	3NLawcc73B9cz1pZz2B5kJcvF2oLPrK3YY6D31fN1a6JqCq78fLA	1501	1360	53	1	5101	jxfF6HmdDZw6XEBA9o8iPaNtqG7Vqcu7kHCQuF4rq3rcvpj6N1e	2731	3828	3828	1616628240000	canonical
5265	3NKFp3G2oeetagK3WnuNY1ki2JmN3GBw9wCVuF2VatPhg3iSTKU9	5264	3NKEHAZRVGHkgjGtRuGMZGAWwFd5Dacd2gkHaf6VTiBYTU269ypz	1654	1214	53	1	5104	jxuAetGA1sPvZEHxgXu5ipKyxaxUZun5k9q9CEVNLyWBQY3XNXr	2734	3832	3832	1616628960000	orphaned
5268	3NLL3eCZYw5F6TvTMNarTaeVN4MMpixMHNy4V2f58RKLR4FY1S4M	5266	3NLW4WtKF9xtW2NbNkBsBMyBcEbDb1Y8V4KqhuUEGkEajTiEjiMk	1513	1379	53	1	5107	jwGyVXFxavC3fpBqv7BdMWYYirXGcBEUwfQBAJbt8dqavrt1Dsn	2735	3833	3833	1616629140000	orphaned
5273	3NKrNUiSCZCGErVMM6ruGnTvWaxFTNk1HjfS5PqMWzEyL9kW46E8	5272	3NLUX4v48rXUnNjiE51uZ8Cie7qLKdh7zLeG9qpABufZSLYtGt3J	1471	1260	53	1	5112	jxHv5BuWvePDdXPACaQhSJCtsXa2BpLNZ7zxUx7hnhCFicS7zhY	2739	3840	3840	1616630400000	canonical
5276	3NK8M7AP8DVhUTVJkpnWXeC4yvLmfdkoU8knTWQd4xCwB6u8WEpc	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1406	1393	53	1	5115	jwRLFpz5V1cgyZo2QtYZkzKS4JWNU1kPtAZfVzFgkhrouLAoWhX	2742	3844	3844	1616631120000	orphaned
5279	3NLLpPvZfCfQKRrSQtepgAdGGfmU1ivYqHNiQVEeopXAUE7jLAWP	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1516	1048	53	1	5118	jx6dnWHH2tiK7AHr5VG5VNxgM16GM5tCwRLuz6wYgmgVtNzFHDa	2742	3844	3844	1616631120000	orphaned
5281	3NKZpt9ZwtGTVH8DYbga5RaUWSayGNGBLERAnVHukrDrENwZ7WZT	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	684	1106	53	1	5120	jxxVobbVZpzoBG9G77CSzUGQJX5UjxV18Vza4WP3v7tniJJp8eV	2743	3845	3845	1616631300000	canonical
8948	3NKTdggLxpY1NmGV3UZiT61chYADQna5wxYj2F7i2WrswickZaYz	8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	1631	794	108	1	6301	jxGuv7amHu3YU1sgnEf5iVYpQMDuswuE5dE8sFC3k9gjiszQrf1	4640	6531	6531	1617114780000	orphaned
5234	3NLY68wvpPsMhhBDFYGtfUQjCN3XqKBqJgzyFFxHKHCMkpqQtgYW	4908	3NKeQRmbNKB3p3Srptqcaqr7kdosp73vBwTRnWTAyFBN5mZkQcfP	1406	1393	48	1	5078	jxbPnkAYHjB2noy9PRbx1EA1DPBohx91tmUTDsWFv16kBefvhRt	2542	3814	3814	1616625786342	orphaned
5211	3NKXTFTcWUBydLB93djvR1VE1SrEnEWF6Sa7dR4mWMEuWRcavnBU	5151	3NKGVfVKEMoWXhZWxKh3gNc9NPZfokHe2bcYVykGyXY7kdfxzCeg	1656	1097	51	1	5055	jxVQMpqeCS6haxn19JXfMHQyrztnugpaQkJ8Re48AStZF1c78bH	2672	3802	3802	1616623594118	orphaned
5176	3NK7hRiuPeEyt2SVGsBE7g1UMwdQGqtZ5xsgRhJLXuyVZy7ZQnci	5172	3NLCcMK9XjqGTRMRcK5nakJBNQBWrFRu178cxVG3i4cDP8sMYViH	1646	988	51	1	5021	jwHgU9wyUDPEhiPEbJYYZ9fe7HjwY1MSmf6sxFSsDHnoWqqxdXG	2687	3772	3772	1616618160000	orphaned
5178	3NLSBtYG39pNjonM5C8MTHzgFCVWACAU5EMHPCxbRTjdY6qH4NFf	5174	3NKKSNykuANoopEQHxc85BE3cqDFHCxxntCg4jRMtauPiAT8wPQW	1673	1368	52	1	5023	jwmj17BmqZgABgWCY9BvtU7FesHRoG8jwbd5w4jV3YLBz1h5fMz	2688	3773	3773	1616618340000	orphaned
5243	3NLw8kbke5wzFxFeMxADX6hhK4AHoBxHp5vztFTxrhHrwoZoaVjQ	5182	3NLZvdRE1TEstpZUG2DWYvFShF1Y5TjCdPSWuic5BhYnCpgJj5YD	1406	1393	52	1	5085	jy37frEUeanyxhRkEeakKcBj84TEr3qhAoXsCcjgKQsUQdWVf7H	2692	3816	3816	1616626185793	orphaned
5186	3NKgrfKLVqayQLbALoVkYsWEzB62XjKshHrQJW87PAW72qjMsunz	5185	3NLncLtKmzrrBMj9LKpRW2dPMAy7fWoqRqq8h3XGCEVmkyg9p8Zb	1477	984	52	1	5030	jwxvLWTJWLyc9gAxrxZAGQQh3nqvHad2pWQk1xMA8J1Lqnuaiad	2695	3782	3782	1616619960000	canonical
5189	3NK4CJupjhsVWSGYb2qrHF433LhhuGiuKWwLQ9W4Eh48LgSxrRYk	5188	3NLCRFrBfZCkKwuLrFHqPKbxA8cEWrsEBFhqbEkVUZ1nZFJURqwx	641	1090	52	1	5033	jxDo2r8EjByry7js9LMDWGdU6dDhLh51aX5JAJbueEYK56h7GKU	2697	3785	3785	1616620500000	canonical
5192	3NLEyFSRxrEJdSfaViNJXEQxzr8mzcux9jR39uoVRtmUxkvu3qZh	5190	3NKSg2xfSitEH85VcNeSgZ2PwKnpQomJNzm5yJuPXWSMAUNvcWWU	1631	794	52	1	5036	jxXrTNe5ccGJ3Uh3YhXd94FHbfALG5vqFuAgYB12J9F3teGV4gy	2699	3788	3788	1616621040000	canonical
5197	3NKtKRSgQnyMXr1YUMVR3dhDZSCMzY4FwQSr35ZmiZatDJZeSNva	5194	3NLhwX7Puw1TfsHjGDBLz2XX3ryeTMGFmQ1jRRYusgAXygp2upLQ	532	1303	52	1	5041	jwXfQwPH5nTsyo7hQhzKAkAjp3mfqHdVMNfCR7eGTZVb9ka1aG5	2702	3791	3791	1616621580000	orphaned
5199	3NLgCqncc6Ct4dcuhaG3ANQbfWwQCxMXu4MJjwGgRKxs6p8vQsZf	5198	3NLtwmsPxhzD2MQ8wVsJ8vh91YNfG1dWhxf9fLL6qWxAheGjWdai	576	1355	52	1	5043	jxqKdYxqwnpKBirfjXQiWkP2cs6hGmPfdXRemY57vokF9UFGomj	2704	3793	3793	1616621940000	canonical
5204	3NLwHtLk4DyWg2pa2ascsn1KAWwYypiWW75iQo3ZddDd9fDcLEfk	5203	3NLfEjHCPM6rA2aYhMrSJ38kxmpmMZTiEjHvYSgMTfRQaXUCHC6u	1406	1393	52	1	5048	jwTmyaR1YYw8eh7qwaostykQvxgWyXSvexCjYDE2Zf6wg4XnvSH	2707	3797	3797	1616622660000	orphaned
5209	3NLDQhtvPvZqnnWcZN6e13vtvY2BzMQDPt82tGitP8Wo8ovg4gjp	5208	3NLeKpaztp6HmjMnsqegKGnp7YNt97kZpVyNkG8yzJ4HjRD1c24e	1622	1356	52	1	5053	jxsUP5PiGEHdjwbSfudDZEKWV6hYLiVi7nvwPCnX6Zn73uEBTyg	2710	3801	3801	1616623380000	canonical
5221	3NK5L4mMus3RkTdQStuDqmuxKHrFMYjhk3NRcJaG31DGyTaLZnRG	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	1406	1393	52	1	5065	jxkXqbxSz45NbqqaAZZsmywmRexZinsR54PfXiY2HFtp6MBHnSW	2714	3807	3807	1616624460000	canonical
5219	3NLrsrekBGegZctGwSixhDcmTmBzoSeRSBeeai6bqMPmbMHgqn3b	5217	3NLS7aYqqS8RhEfh5CeNcgomt1tBhZ9htPEiaRU2obuuknMBsmzJ	1474	1083	52	1	5063	jxkJB3JTn2mbdPPNXydEfArYe7Yk7adeRobvREG7izvFfRRLcro	2714	3807	3807	1616624460000	orphaned
5223	3NLVPJDUpfrw2RoSXAT1y4X66SjFbDjh5r6xdJqM24Er9pzb7L9r	5221	3NK5L4mMus3RkTdQStuDqmuxKHrFMYjhk3NRcJaG31DGyTaLZnRG	1637	816	52	1	5067	jxAJ5bFwtEM9McBFT7i3s3fANrUSo6EtCGkSehmb2VsZ95Kvvf5	2715	3808	3808	1616624640000	orphaned
5227	3NLUB7WXDqFfoJLq58r8wgAn2an6YpvxEsLy2yrTbGgs9XQNKjGi	5225	3NKpyjqjzMrHT5TzZ6XXqxVB9nRDpuX6bGjuz2zN7MnXEoaBdUja	1444	1135	52	1	5071	jwHXmZssN9qcmtc5d6YWS2yfpv7ziy7YcUdiPUGUgeMyZhYh3rC	2717	3810	3810	1616625000000	canonical
5230	3NLiVfsNhB13CFC1ehpWMEjUvtBR3VDk9qTebKcNSPZcvdGQh3rn	5228	3NLXCaTLFBhPKeLXBysrfBvSQ4mcmAob71aMguMt1yuPR13By8sH	1646	1354	52	1	5074	jwQ721ihRrRTXezZMkpRqVMiZdf82FMRbN2CYnvES3QQDv5L2Xz	2719	3813	3813	1616625540000	orphaned
5241	3NLK5iDVfHYaWPkvDB8FjVLTZQL63GcP5Juteamg2JLnyzZkoY44	5231	3NL6VfqNvAZ5Fez1SAuKwr2tYkmzL1bybdKAsfUioYHzaZSEbu2m	1523	581	52	1	5081	jxe48eJ5Zokdopu7rWsYw8DhacPerqB6BH1GJu32JVUv2L8a82k	2720	3816	3816	1616626080000	orphaned
5254	3NLx5WDS97muiDx498i3HGVyYUJpokRtF2ULuxePHAKrQqrvJ7mA	5253	3NKSXjinmeVEGMRGYz1S9UkmQAFD58awZgA2nZUm1moSsxkn4Txw	1477	984	53	1	5093	jxH3YxgAjiRbW7Ytc6hPxcHPWB4HErhFnuUrF57XtA5YHPTdLnQ	2727	3823	3823	1616627340000	canonical
5256	3NLm4Huqi1vZZGHE9dLdHHNCidvRGiXSpE1bvAZCAWy6pNLEm43t	5254	3NLx5WDS97muiDx498i3HGVyYUJpokRtF2ULuxePHAKrQqrvJ7mA	43	1310	53	1	5095	jwaT3fLEUDpzKysYSomU9nbSd9oL6jCdzV6vLunSpx8xgJeEgsN	2728	3824	3824	1616627520000	canonical
5260	3NLawcc73B9cz1pZz2B5kJcvF2oLPrK3YY6D31fN1a6JqCq78fLA	5258	3NKyFUNpbvoSxLiTdvUKPEJDzPd3jeGFJK1VSx6ERg3ekGrqWomD	1405	851	53	1	5099	jxNkFH7rPXJBqjKhvGKNwGQ4T2p8TEMA7bqTnAgUiDfx3pwAsbT	2730	3826	3826	1616627880000	canonical
5263	3NLYznPXZmKF9LSWv6XgBLtoMUSFMhu77NfwMTamupUVSA1BCBJS	5262	3NL5RJUW7MzpSY1X2iJQK3MGxEns5VkH5JzkUTMocotkg2rKZcyK	1476	1005	53	1	5102	jwJi3biKcUHawmGUe7YunzMTSagqD3JDQnEu4CJh3BbVN3gKn8f	2732	3830	3830	1616628600000	canonical
5274	3NKsvc5CvBBG1jSKx1WzQVdgvV2tUczV9iBbYEBDqJaHgVCQET32	5273	3NKrNUiSCZCGErVMM6ruGnTvWaxFTNk1HjfS5PqMWzEyL9kW46E8	1564	1338	53	1	5113	jx7exE5XqSTStF7VMDWVaSNHqpSc9Unxs4Z9SSC25U9MG3Avu3y	2740	3841	3841	1616630580000	canonical
5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	1560	1291	53	1	5116	jwu5WDMDprTTbKqfZ4Gg9BZKt3sjxnbwcPdQxZ24bJwct2whPgv	2742	3844	3844	1616631120000	canonical
5282	3NKtgfWVJEchC9Gvfxq1xwGaQtZWhzvY2waRP876fnnqcmCc1svc	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	563	993	53	1	5121	jx7ZKhc4ycLcE8uzr6PxJ9c1N8yg1orMCkcGxontmK3dRKmVTdp	2743	3845	3845	1616631300000	orphaned
5293	3NKMPHbMUzJyv5bZe2k5u9uLbysgasgdiHyGDbDn2Cb94QJW7Tax	5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	1513	1253	53	1	5132	jxkvQGhmhptnYUCTEACxGFjmLDSaav55k8ooav73yquJBUNe8tM	2749	3852	3852	1616632560000	canonical
5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	5294	3NL6tPD11NAL1QaXwsSo7U87iUFfECSY6YHndB1muFkmX46pZPfF	1654	1340	53	1	5134	jwfhLMPgH2j6PQay5yusFYAXCQEv147ym1kUtnUuXbtb4YS9qWQ	2751	3854	3854	1616632920000	canonical
5298	3NK6XEi8ajPYuN8xfcHSgHPYSvpttZUq3oHEwppij7uYNA11Jt75	5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	1670	1036	53	1	5137	jxaGd1MPV3jHfkxeVgXgR48dqdrxUHshTdZNu2nP4y4qcMuDxMR	2752	3855	3855	1616633100000	orphaned
5305	3NKEthSwkTHuxzAhJt14UkzghpQJEr8YHCBJRcL3KvcBjKfL9c6n	5304	3NKCytV65Kh6GU73Xpg7XbYj8ucmJDXqkD5BMkGdStSbJ1QgMMTZ	1577	1327	53	1	5144	jwYLgka3FrqQ2VrCtWMLit8HMmWwJjcMx88Jgitg3pirKynL5Ab	2757	3862	3862	1616634360000	canonical
9357	3NLqqZUrqgyTBRB2AgnQxSd7NTY95xX47jebnHWVpjesaRFHX5py	8970	3NKpjGJ9Bt68n6EmbLTUs3shRSHtfuU7DRHKVntexL4MerR7Tqy3	1403	824	108	1	6301	jw7DEqd2hSLA1V7CgUvswj6tHbrtdDYCLLkSGV8DnwKuhEjhYk6	4653	6839	6839	1617170220000	orphaned
5245	3NLYe3asF5pBRMSjxw7fg9nZeJksouWXrTyYWrtz5sgWPFNpB4dL	5244	3NKCCGt5p4rc36kAQUbZE8jziEBYGe5CH2ANbXB7sKUbDk6Tkvqm	1559	1353	52	1	5087	jxHEAfHKyar8fCGmXp69DfXULTsibV8bUVVwig4wKjQn77EiPZe	2722	3818	3818	1616626440000	canonical
5252	3NK8mnaKKkXjfyB3WT1q9sZMghkw1WsD5vf47Evr4mqQeY43d1AH	5250	3NKbXgqeWYn7p7vyfqHTykiUWYsxApUsUX3kggwUdpQfyJtz8bDi	1634	1331	52	1	5092	jxCi3NqSEHVvmEn4csbopknZHsWB1FcNNyhQ3bPCjB9oV31CMb6	2726	3822	3822	1616627160000	orphaned
5257	3NKbXGkZaiSkgEPSMNMD6cY69sweenvDDAKgqePbS6Ps9ePFwdzn	5256	3NLm4Huqi1vZZGHE9dLdHHNCidvRGiXSpE1bvAZCAWy6pNLEm43t	43	1310	53	1	5096	jwu6UpxK6wrVTDXXRM5moUR9P4g7hpLxbfw14ta3wvPmTXAbGBd	2729	3825	3825	1616627700000	orphaned
5267	3NKoaasr4W1j1bT1ZCAZiDYdXcftEetoSsStWzBv64QGxABGLrBJ	5266	3NLW4WtKF9xtW2NbNkBsBMyBcEbDb1Y8V4KqhuUEGkEajTiEjiMk	1633	1264	53	1	5106	jwuGBHEBzziYtE8C6TLbo7a43UPo6ngfndfearLPCBnoZcu4LDJ	2735	3833	3833	1616629140000	canonical
5270	3NLTamePjk6RSzc8cJHfbg3pSMqKrmBeomxT3h9t7foNHeCN3LTE	5267	3NKoaasr4W1j1bT1ZCAZiDYdXcftEetoSsStWzBv64QGxABGLrBJ	1445	1164	53	1	5109	jxdRw7yT5hD6Bv8TL4nRiZnvSby4HsH5KZ4BZ8ZZhWPTvPCjYdK	2736	3835	3835	1616629500000	orphaned
5272	3NLUX4v48rXUnNjiE51uZ8Cie7qLKdh7zLeG9qpABufZSLYtGt3J	5271	3NLK1PgysLqVUKczeiZfNcfDvprEXn9S8NWUUW6DANpCSMSknpmH	1521	173	53	1	5111	jxXvUjezk1tNr5QwVH23NSZVd7xwsjmf6RoPrwnw38prKTLi9TX	2738	3838	3838	1616630040000	canonical
5275	3NK9oSb6N8YWPwR7dtF75drcKzSjcS14UUgbiPGD91gXEVsR2YX2	5274	3NKsvc5CvBBG1jSKx1WzQVdgvV2tUczV9iBbYEBDqJaHgVCQET32	563	1113	53	1	5114	jx7BU4fufBkewJt3uvh1PoaZKgmsg4Eb1T2CabM3Rfwf7magTjP	2741	3842	3842	1616630760000	canonical
5280	3NKEhaBjVccwPUGgw16FMLmVK9WUvVhwGsZY5gTNpTWBTv71d1Fa	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	1406	1393	53	1	5119	jwBFDoG4uZUYGGpPrFTcxBzHiDrJRCfJduDvdjUXQNXiyY7fEkQ	2743	3845	3845	1616631300000	orphaned
5285	3NKuZE6AxjKYp7hmesaHcmGs3cKGHHwJDz5MhHrLQCceNhwHmULz	5284	3NKuMVz8TP6wUKWNVU3aUEwkJw6YAkgYXAi5wTPPcRfzAKadNJnL	1406	1393	53	1	5124	jxLBxveoq7iJLm71kAsTKJFfwqqjiLysxT5wFzaBQkcLnGemtUn	2745	3847	3847	1616631660000	canonical
5288	3NLhgA5nJXv7Jjyjfji71dZ49FvEekr61iEQ1eZTpMGMaWtovyco	5286	3NKWRFu2CBVQZQN5TVLt5Zzcea335NAJwgRbtUE8CRgwNQ6UYFBP	1406	1393	53	1	5127	jwMEJVRNoyLkL4a6d32sKFhzdSnqQy1AUGR3GPjqp7nadBAvPPW	2747	3850	3850	1616632200000	canonical
5287	3NLTwyCAMypN3q17TmkTHc3shgS356HLpjWSbSjNpssxNHF6jZ9R	5286	3NKWRFu2CBVQZQN5TVLt5Zzcea335NAJwgRbtUE8CRgwNQ6UYFBP	1622	1356	53	1	5126	jwaY5CWC4UMRAK9S5NTbHUbY3Uo1ts6BxKJe4bamoHSKAxZkvT9	2747	3850	3850	1616632200000	orphaned
5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	5288	3NLhgA5nJXv7Jjyjfji71dZ49FvEekr61iEQ1eZTpMGMaWtovyco	484	1319	53	1	5129	jxeHY8CPiuQ3xtyi67pVXZNCF5SXA6skTHp8jF89UGwyJSRVJC6	2748	3851	3851	1616632380000	canonical
5292	3NK767BxXnAWc6wDa4fjfYoZUn9e6Q7RkzLrhaYgBBYgagxuNcSg	5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	1619	1275	53	1	5131	jxPsWyrhbyDhTx3vevupf4CfT2L7whif4M4iKAvCqRi4YLVJMtY	2749	3852	3852	1616632560000	orphaned
5294	3NL6tPD11NAL1QaXwsSo7U87iUFfECSY6YHndB1muFkmX46pZPfF	5293	3NKMPHbMUzJyv5bZe2k5u9uLbysgasgdiHyGDbDn2Cb94QJW7Tax	1590	1174	53	1	5133	jxa1n5wSDbJFYenU195ovyhEEVaEV9zjP2TYNFQk2koWxnpmHVj	2750	3853	3853	1616632740000	canonical
5300	3NLMcghGoPXCVkjckstzmLdjXYomejxrR49pH7TPzSiav2hRD4b5	5297	3NKcvsBgREz4CLzRmEkvD5JQPAo6p99CsSP4PbT41vdXh9ZT56Kc	641	1336	53	1	5139	jwoDoJJrP7Vdp85PGY3GfNmzVnJjvr7ou7oWsKKNSpVeXmYhvsa	2753	3857	3857	1616633460000	canonical
5302	3NL5nqybbVrBnn765Db9U5AbrQgVbJwzmLy987ETVM8DPZLG8L4g	5301	3NLPspBL1FDgpFVNeMFKmwQjL15mBsysZJzZNDQAkExjbx5HTZmL	1476	1125	53	1	5141	jwo5WQEWsQFY8XgCsmDB321oP6un8XehKkCss6NU9mDDkdB1p6i	2755	3859	3859	1616633820000	orphaned
5304	3NKCytV65Kh6GU73Xpg7XbYj8ucmJDXqkD5BMkGdStSbJ1QgMMTZ	5303	3NK76hNHsDh8Q9AFaNj6W9aERKHce4gxTKVou6GEeWtBMJQEuM94	1637	816	53	1	5143	jxQKYHnPUCzKd8bX3SXxsAgPkiMX8s6ngex6m5ATqJwGhoNkM3D	2756	3860	3860	1616634000000	canonical
5307	3NKuVzPJmdDZFvsWvScaVbpU17i4VNFdZwYBpgCnovCfe52hjo8n	5306	3NKPMVGzT9XCXHr2U4sSJmBXq5p2vz9ZSBZxZhFn5yLu9zfZXFk1	1672	1039	53	1	5146	jxwnnkMQAghwijz9kGL5usPTVMgNDwDxafhRJjqJZS8nVBTrATn	2759	3864	3864	1616634720000	orphaned
5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	5309	3NL9DM3XYojon7PbpRvSCnhHnHTFmD8JN4G9yZAv7SgcubeJFQ9p	1634	1205	53	1	5149	jwtUvAfjwVfKhkjbv9txutifVt1j2ogZP5wVCcUqCnydttn9iHj	2761	3867	3867	1616635260000	canonical
5315	3NKrwNDz2jpxEZWUTDjh88ksfkKKhCAJCfcC7ftyaCP3AEHfkh9M	5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	1622	1110	53	1	5154	jwbiCVrYWetMjmpJ6BvpSr17bLNM3Kukb7khMLvsHLzvfAox5c1	2763	3869	3869	1616635620000	orphaned
5324	3NKvRda4VS8ZNBcGaSNdteuAJAzYvnJmadY8Qug1H7pwmUjmDxED	5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	1564	972	54	1	5161	jy2EoXCYcu4YQRYAPVrA26HEeW1oma6meks5KDym9kQ9CHnMHKy	2765	3871	3871	1616635980000	orphaned
5327	3NKUcCeKSsNSh3vcCtzNMypaYtjBDgKF9L2iGpmnqm5psQ8KKiVb	5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	1542	1304	54	1	5164	jwPzy9wG2ueaTXm9Rh4v5tx18J1kPFbapYfffPprQjxGeMNFo3H	2766	3872	3872	1616636160000	orphaned
5329	3NK7VQ79TAV3QyvGATbhJ22FCPQK282AKWUChuwo9C98sTQ1wbWC	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1406	1393	54	1	5166	jwKyZgu8mGbTZ6cni1FVxEuHDTueGbSFAvXjgQMTMp4hBKiaa2s	2767	3873	3873	1616636340000	orphaned
5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	5332	3NKtphbEgyDMVJiJcpCn5yGkkZ7733v8NXoWTWQvmiJktfz1HEaN	1585	1240	54	1	5170	jxt1s9yk3Z6Xq4CkrdEcz2paoCkYCFs38hgBVRWdVBxjqPPgjYB	2768	3874	3874	1616636520000	canonical
5338	3NKiPreKmXZ9BXkzFh87EAzpFTGDdnqt4abqGNi1ecBsjgSud8hn	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1637	816	54	1	5175	jxgobVbvG7UCoMFwsprM6Siu71tPna4pXGc9uhcGAhxkVeW22bc	2769	3875	3875	1616636700000	orphaned
5340	3NLfn1e4t2kdctUwUijYxz4odLuXzfq6jUbuyrP8UK6pXRtAWV2b	5336	3NLtu59xSkx15DGuHLdgZ4mtkpVbb8o4f5mE8PDrGTf7jS3cU8qh	1573	1318	54	1	5177	jxpbv6sEPqAbEG5kn5Lj2Q1625oy2UDKvnLm2uouxVwXHwMpqUp	2770	3877	3877	1616637060000	orphaned
5342	3NKxKDBeuEw9TQees9sxUMmxmULLzgQxuY6YruyZvqkKUZouthzn	5341	3NKueNYRFNkdEreeko5CxLvGvZEwqpmC9mDzbKtJbuBUAWADJQgd	1406	1393	54	1	5179	jxNtYxkSkCXYxDh6ou1653YuSMWMfdW4142sf6yukkCTfJtpNVF	2772	3878	3878	1616637240000	canonical
5345	3NKfn98wHEjPePrzkCQ2ZdXbpF7FAHu2GjzxnZZiubgieF6hSb3H	5344	3NLCAJttycBC83mnu9DU8Q7RLASo5LPDgz6W7twMUFGWVi8JhNmJ	1406	1393	54	1	5182	jx4rjNmyjHS4Zz5RVNHtRdLMn8Ls3eYwtbZpZR8GcLVVmu2bkWZ	2774	3882	3882	1616637960000	canonical
5350	3NKMbsJLTcGxJzTGWx8NAwSewNtjzG4q1uV6WquL3W4xpPiRCbGe	5348	3NLYm91AceGEEezmL8m1t84dYPfpDVX6TnGQ21kqWEx1VJPPmJUz	470	1309	54	1	5187	jx7JsDQZixPvS9jGJ29k5V7dHiJp2AHKmvEy5R9aEzEAsZ91nKD	2777	3885	3885	1616638500000	orphaned
9438	3NKzg8aq8hH1Hi7KDn1SKVfxsWbhLSLKpAcAphz7pbigtuYgmvoM	8974	3NKCmhFkzQtxHt8UPXEn2jbXmz6N8N4m53YuJsvMCh6cNGrKmrW9	528	528	108	1	6301	jxVKXcCSiNJZ4JHYd1vRn8Mr4TxGQQosHH8y1aEuug1Q1p7kQV7	4656	6894	6894	1617180120000	orphaned
5291	3NLhc55hnKG4GJnTUUS9Ux5fiRGpu1NLiKULhgDxzJ8JArJ7Q9pS	5290	3NKYpFurZUou9HYHzXEhTDE3S4KWyG5AoRDEHQnuhipuonnRWpqQ	1460	1324	53	1	5130	jxeYSGqqb44Bophmi7ytWGaktVE9qf3KJZ6MP94Fci6KYzrwpRR	2749	3852	3852	1616632560000	orphaned
5296	3NLigRQNHFsv9NauKuyW8XM3g2RVMwgUKP5cJE3e2o7VcDcDLaEA	5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	448	1059	53	1	5135	jxMC4YQiiBGu18DgxDT2bKHhNPndtJBmLyW5jfQT3tKLjYE8BYr	2752	3855	3855	1616633100000	orphaned
5301	3NLPspBL1FDgpFVNeMFKmwQjL15mBsysZJzZNDQAkExjbx5HTZmL	5300	3NLMcghGoPXCVkjckstzmLdjXYomejxrR49pH7TPzSiav2hRD4b5	1573	1318	53	1	5140	jwcwDkKa6wGX5y8p9StoooqGu1CUGnxTrTF8BVLYQUdmLXTbVNk	2754	3858	3858	1616633640000	canonical
5303	3NK76hNHsDh8Q9AFaNj6W9aERKHce4gxTKVou6GEeWtBMJQEuM94	5301	3NLPspBL1FDgpFVNeMFKmwQjL15mBsysZJzZNDQAkExjbx5HTZmL	1637	816	53	1	5142	jxupLFs22WyAus1DmRFnJFpkw3dF1k9PLtzdqSi7m6FCS4rneXx	2755	3859	3859	1616633820000	canonical
5306	3NKPMVGzT9XCXHr2U4sSJmBXq5p2vz9ZSBZxZhFn5yLu9zfZXFk1	5305	3NKEthSwkTHuxzAhJt14UkzghpQJEr8YHCBJRcL3KvcBjKfL9c6n	1589	1040	53	1	5145	jxrDTJFKY4bLdyFtfhpSxJ1LLyTz89E35UsY4aXaJGEjmZbypR7	2758	3863	3863	1616634540000	canonical
5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	641	970	53	1	5152	jwozbAY9hNB6AwsZn4FSddrh8BcDJwBgGytrst7VChBZB7diVtb	2762	3868	3868	1616635440000	canonical
5311	3NKEaMfU47WbPXm8H9PnhP8LPmCgiugoBG42urNKyxcrFugyGYi1	5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	1447	1345	53	1	5150	jxx5ZsdtXbkz1G7hjdvwAKcEv8uy7RyNibkLkjNrCwAUeAs3TFd	2762	3868	3868	1616635440000	orphaned
5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	1648	918	54	1	5159	jx6gKVrCcw3T5nwUydfMkUQmmS4U6YP6VHXmK7f2d18mHwkenpp	2765	3871	3871	1616635980000	canonical
5335	3NKAUUcAx7R9Qcm87YdyYWCdUDMqTqgkDdqMMPnGLTaqovUGwRh5	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1527	1047	54	1	5172	jwv9ofRwvNNkJXyyKHrJXDXneHRPvK9cmuYBywP1bNXynZ2jR24	2769	3875	3875	1616636700000	orphaned
5344	3NLCAJttycBC83mnu9DU8Q7RLASo5LPDgz6W7twMUFGWVi8JhNmJ	5342	3NKxKDBeuEw9TQees9sxUMmxmULLzgQxuY6YruyZvqkKUZouthzn	1483	691	54	1	5181	jwvYbVnuGzN257qnJubygVv3ai6Hw4TBqVmmMj5EMMZwqqgLMFj	2773	3881	3881	1616637780000	canonical
5346	3NLb5nrexXkJjkgm8xkM67WAXqZzDgedhG12Qshc4MgeL2X8qcrn	5344	3NLCAJttycBC83mnu9DU8Q7RLASo5LPDgz6W7twMUFGWVi8JhNmJ	1637	815	54	1	5183	jwiCaaBHpTTyKX5L5gkENb2cNTwiEgP7yG6sXrUE5zdFN6jEugH	2774	3882	3882	1616637960000	orphaned
5355	3NK6eMdZd3ogSerJKBcgTMyYSbri24rHqG7qdrnpdJgQaJLEH7nB	5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	1547	1378	54	1	5192	jwmVxRK5vwXY9UH2HL7XLrW9PT8kju97fZq4ZidV9ao56WGAgm8	2780	3888	3888	1616639040000	orphaned
5357	3NKxUDogmaDKa4Ckkrnwz11AtE3iLYUBURbLC93WLB31qtv4rH6c	5356	3NKPsnC1prwP9ATv6zkmeyKq6hZqcquwxi23AoKg3PXiqNKFnay6	1587	991	54	1	5194	jxcR7xvGgWArn9oSSgZAkrzbfDh5xjprQKYTynxe3S6mxvt2rBS	2781	3890	3890	1616639400000	canonical
5360	3NKeYrWciKDUY4AgQT1JD9KFsbfL63S1ULWJT6LNArH8GT6qyoyK	5359	3NKZocHkGDpGWAfUFfNBubfcNuLJ4dAD2F9mog6cSEKP6zvj9jCG	1534	1317	54	1	5197	jwCBwtLJp8Q4bg5ky5LmergkgnbpaurXmqnXZtFwwZmHvMKFZDn	2783	3893	3893	1616639940000	canonical
5364	3NKLMPaDFqctFnbF4U5ZetnAjdymHiZL1DgAxQY2E1mNgWGWcdEU	5363	3NLjSXRn7yHe4UxXTVAjQNLxfEbK5TEw3Psv75bGX9PQrePGwcct	596	1306	54	1	5201	jxNJNry1mExp4JH4omLnreDrLD25gCkSRUtukwHWFm337JsGyRn	2786	3898	3898	1616640840000	canonical
5367	3NLSnY4ZjcBEiiCMRE2P3BwxmzCt2Fns982ZVR9aadp4i5hxvjij	5366	3NK6H8kuDohAhNNFzRTPRNhpGzZyk7QtbC5duFopPuPF8amR1vaS	1402	880	54	1	5204	jwsHUFBKZqxpe4ugTVAd5dsMrQnE8dnkbkVjqgMss6Y2RyXsR3z	2788	3901	3901	1616641380000	canonical
5368	3NLnMx5yAhfpsJKiCtdcPXrGgAxqt7ksRJ4jvTr7tTBXJ412KbBG	5367	3NLSnY4ZjcBEiiCMRE2P3BwxmzCt2Fns982ZVR9aadp4i5hxvjij	1406	1393	54	1	5205	jw9N91WseNBQVV9qHmr52vdMo5s3HkcJSwxsSr86YvCNuU3gmu4	2789	3902	3902	1616641560000	canonical
5369	3NLkNqadps92hEDZvJxHY8T892TvA63HY7BCdieccukbFpxrBjgZ	5368	3NLnMx5yAhfpsJKiCtdcPXrGgAxqt7ksRJ4jvTr7tTBXJ412KbBG	1553	776	54	1	5206	jx2JnJs23tjs9foJfeb9EtAQBnf52NabYN6JsXQENYdoEQm9jt7	2790	3904	3904	1616641920000	canonical
5370	3NKKeyMFkrRVWrLonotARr6tXXxfqewzb8eovrP5vGTPx519x2hN	5369	3NLkNqadps92hEDZvJxHY8T892TvA63HY7BCdieccukbFpxrBjgZ	1581	778	54	1	5207	jxidAjtBByHFLFoC6rt5WiBkq88ZxNqxkvFr1Riv4W5Rvps6YzV	2791	3905	3905	1616642100000	canonical
5371	3NKSwwmMh8jg6dAJ9iEtt2QDsuQRnsLqre8uUCPzL4ei8WmFyQBr	5370	3NKKeyMFkrRVWrLonotARr6tXXxfqewzb8eovrP5vGTPx519x2hN	1633	1144	54	1	5208	jxhRWepjvBbwPvffffypDXM3K8oZWQFufYH1gQWf4Rk6DF4CTtZ	2792	3906	3906	1616642280000	canonical
5373	3NLoZUP5JvPmnqCF8YVnQn7iaxKy7Sjn5z5AGgjA2YZpBcY7htVw	5372	3NLWjnZi56HSguMcCromLQpiQQULd1r3V2kiDu7ksPkuQg8knknh	1637	816	54	1	5210	jwZdcushnRAmXYnttW823CnKZmTtPJMzWGrC3kqVjG7ticB8Lxc	2794	3909	3909	1616642820000	canonical
5374	3NKFRXSq8FqGm1Ewi5dCbnW76C9dApaBysY2MvAf2TUw7UnmwWCr	5373	3NLoZUP5JvPmnqCF8YVnQn7iaxKy7Sjn5z5AGgjA2YZpBcY7htVw	1633	1144	54	1	5211	jxmiuS8sNDpbDdD8Jq33UiDYHNog1yZpZRf1Xqqg73BhbKL5vDD	2795	3910	3910	1616643000000	canonical
5377	3NKkgm1G1qgLAm1fhUsMjXamjAMQ95ggKc13PG1xd3KmXuAyejfs	5375	3NK57N8Zm1dbJzZsVeU8SXDmtzvRLzerQsW5sGievbw1wTTTPx5s	1536	1067	54	1	5214	jxZUSZWGV4rE22MRvWStSA5p7ayhxacDsYv3TasBuW4YFbrMtko	2797	3913	3913	1616643540000	canonical
5378	3NLRPadJ9LTSrmFsyHuE2GezJGRNeVj5ySR1GA6RJV1iVeHGf5k5	5377	3NKkgm1G1qgLAm1fhUsMjXamjAMQ95ggKc13PG1xd3KmXuAyejfs	58	1281	54	1	5215	jx1RFRJqKzXHNHk7jwts1XC3kp7MFvVCozZYoPvFN6ysXCXQGiU	2798	3914	3914	1616643720000	canonical
5382	3NKFgumEn2yNiQgtBbBqfkgsr5ascWEjMeTgwMdVNErc3KC1TidL	5381	3NKkQ5bMb1YdsGHs5BUJo3cdZHBMca7UAsMeX9Rmt6ndj97TVf2Y	1445	1290	54	1	5219	jwqrbKnDAZpArQRmUYrpTemGW7EoPj3pqgeYDCGH84tHHkp3HWw	2801	3917	3917	1616644260000	canonical
5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	5382	3NKFgumEn2yNiQgtBbBqfkgsr5ascWEjMeTgwMdVNErc3KC1TidL	1541	1298	54	1	5220	jwn4gLgbvSaZTsBZydRkDF76G8vsQNtxH7mckATTSZABrTzw9bn	2802	3918	3918	1616644440000	canonical
5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	1406	1393	54	1	5222	jwRaWR9z19935vFTUEHoB8aqEfugpgzuFWiRys7HCtJZnV25mSp	2803	3919	3919	1616644620000	canonical
5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	5390	3NLaA4GwwEnqFLEukitCj3tsH67oobq3Hp8UZgprAz6sZPFRcWSJ	1406	1393	54	1	5228	jwoTUN5gvqS194PZ4T55vGVCBmVxiPXESYTFKg6RR2H7zisdQki	2806	3922	3922	1616645160000	canonical
5398	3NLiWeMnR5Q5TUwrp7rY9N1A3jtB8UbPPqU5RvTXExfGED25ZLiQ	5396	3NLi1pW41bG9fZaBnKmtcsNSsFm7VNDr3myRit7GP1W8mjpZt224	1637	816	54	1	5235	jwXZxAnMkqtMZ3B33arVJXiUDaLSmhNJWQbUAENPJwBGmsZyPEu	2809	3925	3925	1616645700000	orphaned
8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	8982	3NKVnaNTeZ4nheySMdvCt2Pc3jk3eyPndpjysBGaXJeLWED7ABzQ	1405	883	108	1	6301	jxYUPpbAfJ1yfBCbucRvP1HNMgDM73bXy4nuS9dEuNvz81T9CaU	4660	6559	6559	1617119820000	canonical
5299	3NKS26oonyS5EGf9Yd2V7NWZo9QC3miKZJJyUwYoALKE3Za7uZKA	5297	3NKcvsBgREz4CLzRmEkvD5JQPAo6p99CsSP4PbT41vdXh9ZT56Kc	1403	792	53	1	5138	jxBqkBXshjNAFE1WuKy54fUw8BRcA9xVcDo2E6s8pckYR6ofdez	2753	3857	3857	1616633460000	orphaned
5309	3NL9DM3XYojon7PbpRvSCnhHnHTFmD8JN4G9yZAv7SgcubeJFQ9p	5308	3NLisrdFZ2ZztSLbjVhrgemoP8DWGPbdddRFbTKNLDso7HtWoKMg	1637	816	53	1	5148	jwpDCFTbfLKSeH1u4p1rsSuXfNmaAMxARggPofrmk2BGVCY2B89	2760	3865	3865	1616634900000	canonical
5312	3NLMEJGJMmmwRpgwJ5z342jBtgQvy4JTXrhPLMHrELyRQndpDAtU	5310	3NKrYFqNTuhseqg5MBkgLM3BEgzBumJC1mmmRZ5ENJ9TMHvYhPmQ	1402	874	53	1	5151	jwexzLafdRaYbzAEUfbatV6XSyXTgDcbAR6BY6Z1EqjD3fazGmL	2762	3868	3868	1616635440000	orphaned
5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	1623	830	53	1	5155	jxDV2vp21jRJQUn4QcExXPoAuN5JHLwiKH9MggiuMdxsbc1vLTv	2763	3869	3869	1616635620000	canonical
5314	3NKf28MjRjHGEZm2irWzbd873obDpu8pCMb3UaGdiReQWJT92oLC	5313	3NKJaE9vXe1jG8EzGqECrSoSJuBMvjHiDT4yfnZKSqHdR7j95paG	1593	1346	53	1	5153	jwV2Zah7hK8ggZuxtSGYPPQCKCwL4dp3V8iwd2rXrpfu8D7P4gz	2763	3869	3869	1616635620000	orphaned
5318	3NLCVirawa5hG6sVYUhXa2BSUjBkTMBNof5HnCeZdo9kMH61ENxx	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	1590	934	53	1	5157	jwPrJNLR6hRnYukH7fiGKVGkAi72U3gLwFE21PTKQZe7kmPp6GD	2764	3870	3870	1616635800000	orphaned
5323	3NK9FaNf7zQ3G814TRTj4TPokvs2gJkvWSSXeHDdqLbhCswqtd14	5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	1518	788	54	1	5160	jweS4vG6Qf6JQGNEQP7EerrP1zE4C1Ce1Nc2bBbT7uitdsteRLd	2765	3871	3871	1616635980000	orphaned
5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	1406	1393	54	1	5163	jxPyrh4VBTtwvWtjjmVaRrEPR9fHvsCuqiAEZrcBXpoffpXPq5V	2766	3872	3872	1616636160000	canonical
5328	3NKhaFJCm1Swwr86KYpFmUhsTkitaXTFhfQx8Rm9wD2P7Y6SVu43	5322	3NLdRBT4ranLVbA8rrJnTCYwECMUxdL9p5Uj5Y9KyZDZQr1zg7Nk	1601	1388	54	1	5165	jxKuPuJnyHSFqHAyA195LWpg5QobJQPrPru9zKnKtwYckjVys8q	2766	3872	3872	1616636160000	orphaned
5331	3NKC7bihvP2aKa4BhF2Tvrevw3ogyVhaNdvTvcn9FdrJ5HVWoRCR	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1402	796	54	1	5168	jxLCALkN87w9NfTrQjv5KdkNSP9yBw7a9khM9FGUMAn87qd8jaB	2767	3873	3873	1616636340000	orphaned
5339	3NLjjZ8Ud5qao7eugFuAMjaMnLTQ1WjMXvetED5v3hkprKgy2MxM	5336	3NLtu59xSkx15DGuHLdgZ4mtkpVbb8o4f5mE8PDrGTf7jS3cU8qh	1607	372	54	1	5176	jwTNeb1S7qPd1rZ1Rs77sqVZjLTggnnyChn8zyegMpE4qSk8ZY6	2770	3876	3876	1616636880000	canonical
5349	3NKaiV1iQ3i1NQqKTah8ije8QbKE26A7tTkdiRkViX8kPgUYVUgQ	5340	3NLfn1e4t2kdctUwUijYxz4odLuXzfq6jUbuyrP8UK6pXRtAWV2b	1573	1318	54	1	5186	jwGKQkspkMo6wu8BccUEMHbHTXr5PF9PbY7JXdVwHRGXUEy6vPt	2771	3884	3884	1616638320000	orphaned
5347	3NLn19MXXnPzMGDCro6f7ErQ8MQ438DZeHKKyFbW6MJWWqdjYPRy	5345	3NKfn98wHEjPePrzkCQ2ZdXbpF7FAHu2GjzxnZZiubgieF6hSb3H	1652	1189	54	1	5184	jxFHSDhWp1uSkmm5P6AHhJnq5p4qDwn8TnRKWw5J4uEj8SujD4d	2775	3883	3883	1616638140000	canonical
5356	3NKPsnC1prwP9ATv6zkmeyKq6hZqcquwxi23AoKg3PXiqNKFnay6	5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	1489	1014	54	1	5193	jxbPneB7GzeD4ixJR9cTT4iUGcL4fDtrqjRqz6ZGQxUusb8z4Rb	2780	3888	3888	1616639040000	canonical
5354	3NKXTGABaRmQrLCy99iBSzDZjt4cBi6UMaioZkuDUHaXacafBbDh	5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	1671	1239	54	1	5191	jwbXuLw67tbK1aGrB6YPNSBS9UaB7iT8r4hRmPZVpEMMs79tsQx	2780	3888	3888	1616639040000	orphaned
5359	3NKZocHkGDpGWAfUFfNBubfcNuLJ4dAD2F9mog6cSEKP6zvj9jCG	5357	3NKxUDogmaDKa4Ckkrnwz11AtE3iLYUBURbLC93WLB31qtv4rH6c	1609	967	54	1	5196	jxc594vaXRwjaxCx7uS9Dm1NTVPDfqZRYn3RH1X3dxXW6tQ631R	2782	3891	3891	1616639580000	canonical
5362	3NL6G1sLuU6Ua2t5xTTVd4U1CraM5sHxsqcvWYBZuZoL7j3FXbwE	5360	3NKeYrWciKDUY4AgQT1JD9KFsbfL63S1ULWJT6LNArH8GT6qyoyK	448	1305	54	1	5199	jx4A8FB1aHxfrwyHxE9FCBVJ1cC9wDzhnSq4vvJ7pYCw5qg67Lw	2784	3895	3895	1616640300000	canonical
5365	3NK84kj7yFZdthd4crb7WJi3vDJbTMkY81Sjs3aUuBdYJYvV9oE6	5364	3NKLMPaDFqctFnbF4U5ZetnAjdymHiZL1DgAxQY2E1mNgWGWcdEU	1406	1393	54	1	5202	jwonpbHTRsKJGHEq5b7JcGt4cZCKYRAE31uVA1Wk3MFQyn2XVia	2787	3899	3899	1616641020000	orphaned
5388	3NKV11eLomUULL7W7JVLBRjVGXKfLDSB8tGdga1fSoXMCp48G3ah	5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	1599	921	54	1	5225	jy2YikA5jTkWP5fog1G658hscCnBQYmxGSyg7aXWGRnjoLKNMey	2804	3920	3920	1616644800000	canonical
5390	3NLaA4GwwEnqFLEukitCj3tsH67oobq3Hp8UZgprAz6sZPFRcWSJ	5388	3NKV11eLomUULL7W7JVLBRjVGXKfLDSB8tGdga1fSoXMCp48G3ah	1447	1099	54	1	5227	jwiLZ3HykgLanND63vDL3AXR4hzS7bw7MWvu9pVpBT23Br9bWKA	2805	3921	3921	1616644980000	canonical
5397	3NKg9cHtYP1u1zGhr4xifYirhVvRgiVsZedYTrWiyug1zWNyvusx	5395	3NKw69YYwYyqmkpDniScAPEQoncLGtBrbDJApSBCAwqM92XRWdbX	1623	839	54	1	5234	jwsiyMKDBcf5PXiRFKE6e89LtHgP9hqewYbojEWLmSwb7LsTJFU	2808	3924	3924	1616645520000	orphaned
5399	3NKGngJv5vXndpKqQBMv6wRipJVbvHmxSfuam8aUGVhWrt5MwKXo	5396	3NLi1pW41bG9fZaBnKmtcsNSsFm7VNDr3myRit7GP1W8mjpZt224	1634	1331	54	1	5236	jxi7cXhvmxzni1We5TBfUzXniCd6vPe3x1t6VwfskaUANeaVq4G	2809	3925	3925	1616645700000	canonical
5402	3NKzVpJYK7M8Ydf6SCN2bLP348v2ZbEBufvS8Sr9Dwbk93rMcmXj	5401	3NKGGk38kmyTdoBqDUSKECoQTViGpxbsc1FfohLmHzesozbQTsjA	1581	778	54	1	5239	jxoyTMf3HcDzfgthXju4Sq64TAB8NzUc6SQKioQ7EeVVukk6cPQ	2812	3929	3929	1616646420000	canonical
5405	3NKba7XxW5kwy6weg4WAGU8tPczmauwdxvCQNG4BRH3amAHRTkN8	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	80	1147	54	1	5242	jxAdKb9Lvjb3XB8LEczX88pweyiJQMFnY2My3y2WkABGYZUT36F	2814	3931	3931	1616646780000	canonical
5409	3NLLbPitDFencJqs2621bcvZCDGbnvUJzYw7rp5jtq4y2Vd6jFam	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1549	1116	54	1	5246	jwyo5Hf6cNBS7FDkdC9bjhwEwAJuuW7qyi3q1Cw7UfQyYxgfGzD	2814	3931	3931	1616646780000	orphaned
5413	3NKaSsWxzKf9psFX8oG8QdQ4TLmmmrQRzTNr7EMwNmVRzFuWWj2g	5411	3NK2vHBno3X98YyXNycH7S9JKeCVn6SxmxEo3svQQtJmBaLsykmt	43	1184	54	1	5250	jwdqcmDNL7QTSWsRDtfmHGWWdqjoB73aMqB2SM8T9btHjmKqhM3	2817	3937	3937	1616647860000	orphaned
5417	3NLgRiQ7NU25HNsVgxatGx9JpAQbtJh9s2W7Y4EcdVSj2tEybtQ6	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	1460	1324	54	1	5254	jx3735yUyrjKeWC1JUWDQbHz7ewNQnsoc1hh9y5piQJKB68wCzv	2819	3939	3939	1616648220000	canonical
5420	3NLJMMXrT2WQKTdaJPKxE37exdbKm2QBTtywfGJEHhEBUvHZsKQD	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	606	1049	54	1	5257	jxb7E31bCAXApsy5C14HojvMh2ebiw3xwoQ7YxNpxN6qvxMzpMh	2819	3939	3939	1616648220000	orphaned
5428	3NKHXJ7aR11VWUZnditbBF1GZDwEQxfYiRvgVA8y22fM9VUqWog4	5427	3NKwJsPNRT4NnJqUkGyKApebdQjJ1WiFjAftCwv6zWp8o66DUMev	1406	1393	55	1	5264	jwQVRzUL4RXNKqzVj3ieo47T43d19ZrNWjMXXXjbnSD5mvXdFRc	2824	3952	3952	1616650560000	canonical
8988	3NKwLxmMma8pEFasWhWMPqDAdN3QLNdJmVxDdn8uvXKzVxD1KPnU	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1647	1302	108	1	6301	jxAxpSQXwSvQXCPmELynucjqsK57YnKcaXvkQw4ijsPFf8Y3BwQ	4661	6561	6561	1617120180000	orphaned
5319	3NKUJeR9HuqN9m9hLK5Gjmiarf7zYiBStsSh7iecMWPqX6kuTuoG	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	563	1359	53	1	5158	jxfJv5mqbCtSSnG8VYEUrUdseHGqXZJmESDK5J5WdPjtjketj9L	2764	3870	3870	1616635800000	canonical
5317	3NLN796gZAG1U1vL2ZSkgXnFGSraNsxgQe6AwygvnLfpHj21bYTK	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	1406	1393	53	1	5156	jwrh26Av7XRrepHnLEAj9QLA61ro4SKWRs9jwnrnm9BAzd7MwuT	2764	3870	3870	1616635800000	orphaned
5332	3NKtphbEgyDMVJiJcpCn5yGkkZ7733v8NXoWTWQvmiJktfz1HEaN	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1455	1332	54	1	5169	jwdVVZjXmaXGiP6eEV8mCCDdDcMrfXogqwXCW8sPavmTk828usb	2767	3873	3873	1616636340000	canonical
5330	3NLhUV9xCoEQwAm6h3tXag9EphnLS2s3mUB4GGrPuaaYCbhTeZPV	5326	3NLkk7GEiHbx2MphnrabCaF87VSXZuwZ8LTqwYqT2ZMY2YivSGHi	1467	1376	54	1	5167	jwk77FFXy7KQiH2eNFknRTVkhLM1tuMgCkbxPvK52d3Xe4B2Xtp	2767	3873	3873	1616636340000	orphaned
5336	3NLtu59xSkx15DGuHLdgZ4mtkpVbb8o4f5mE8PDrGTf7jS3cU8qh	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1501	1360	54	1	5173	jxnNL6wfAorwtGmP6FcniHrkLMozqLUger9tAaifHf2D9f1U6yG	2769	3875	3875	1616636700000	canonical
5334	3NKx9aXBUpVfCotLDqoxjbAVNm7oJhESR6S2pdRi5FD3fmS9ks7S	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1649	1257	54	1	5171	jwDQRa8u96461GG4o9iqBujUcyZ4k6UkFHGidhHcczTtyG3T1iy	2769	3875	3875	1616636700000	orphaned
5341	3NKueNYRFNkdEreeko5CxLvGvZEwqpmC9mDzbKtJbuBUAWADJQgd	5339	3NLjjZ8Ud5qao7eugFuAMjaMnLTQ1WjMXvetED5v3hkprKgy2MxM	1650	1375	54	1	5178	jxJ4Vi1iqgAght4NdHkbSL3JWZmRXkt9ZjqjMFbASvkzdiaFWXE	2771	3877	3877	1616637060000	canonical
5343	3NK6viyiCTsR1C71DJg3Qm32A2qePjMxoytnTGMtf9htTPjMYA1K	5340	3NLfn1e4t2kdctUwUijYxz4odLuXzfq6jUbuyrP8UK6pXRtAWV2b	1403	824	54	1	5180	jwhLvVPFKuw1Hy49nnmm928UsYFrUPxecWM9wS3Mf28wY8xGS8T	2771	3880	3880	1616637600000	orphaned
5348	3NLYm91AceGEEezmL8m1t84dYPfpDVX6TnGQ21kqWEx1VJPPmJUz	5347	3NLn19MXXnPzMGDCro6f7ErQ8MQ438DZeHKKyFbW6MJWWqdjYPRy	311	1307	54	1	5185	jxrhTwtKsDUTeh54hzN2SGrt7SsCSG24XFkavC6XojUHQkKfGBw	2776	3884	3884	1616638320000	canonical
5351	3NKLS2csviHuuq3uQENNctmjvbUHQv6DsnTxXL9mmzz3teBW6biV	5348	3NLYm91AceGEEezmL8m1t84dYPfpDVX6TnGQ21kqWEx1VJPPmJUz	700	832	54	1	5188	jwxBDBL2QLYsvFMbA4acZjZsmUEL3JbViBofsDqN4WisQzYagxv	2777	3885	3885	1616638500000	canonical
5353	3NLsyNkndjkTVPKDVFeTQYuFDQY5CneWGU51CbGJDxiXsyb2WYN8	5352	3NLQvPaJ8F2UEVtKfXtnF5MXpYkr1x4eeJY6q4xm2TAfNFBbSuTC	44	959	54	1	5190	jxz5R83uoXx7e7xR2ENaevkR7NCov5xyBsHbNKukKddN2YE1Jxh	2779	3887	3887	1616638860000	canonical
5358	3NKeez4CxYkCBpJc7dxxYnmNFFh4RagphdqMJxFVxmJAnT8fJ8fN	5357	3NKxUDogmaDKa4Ckkrnwz11AtE3iLYUBURbLC93WLB31qtv4rH6c	1406	1393	54	1	5195	jxJo3jaGfmzL7wY6v55pR2zcVzUQEy4nP479peKB81o8XQ4PjwW	2782	3891	3891	1616639580000	orphaned
5363	3NLjSXRn7yHe4UxXTVAjQNLxfEbK5TEw3Psv75bGX9PQrePGwcct	5362	3NL6G1sLuU6Ua2t5xTTVd4U1CraM5sHxsqcvWYBZuZoL7j3FXbwE	1617	1042	54	1	5200	jxVbeq8HLdSwB6XvQQbJdmb85tFLQPoqdtgUuoYjGYzDdmth7gn	2785	3896	3896	1616640480000	canonical
5366	3NK6H8kuDohAhNNFzRTPRNhpGzZyk7QtbC5duFopPuPF8amR1vaS	5364	3NKLMPaDFqctFnbF4U5ZetnAjdymHiZL1DgAxQY2E1mNgWGWcdEU	1643	1053	54	1	5203	jwdc3B4XdFBvpYn8k22XymwYybHbHyM6HAvWWPFfivSveVjhiN1	2787	3899	3899	1616641020000	canonical
5372	3NLWjnZi56HSguMcCromLQpiQQULd1r3V2kiDu7ksPkuQg8knknh	5371	3NKSwwmMh8jg6dAJ9iEtt2QDsuQRnsLqre8uUCPzL4ei8WmFyQBr	1672	919	54	1	5209	jxxz7NJJDfpVYwmXzdCFr3mVdGPELSko1D2m9TPfU1GjpDu1jnF	2793	3908	3908	1616642640000	canonical
5375	3NK57N8Zm1dbJzZsVeU8SXDmtzvRLzerQsW5sGievbw1wTTTPx5s	5374	3NKFRXSq8FqGm1Ewi5dCbnW76C9dApaBysY2MvAf2TUw7UnmwWCr	563	993	54	1	5212	jx9xA1W77m7H4Y45uAUjAdG5ycZ7GZYxtZocq5GiokgJheoxZgG	2796	3911	3911	1616643180000	canonical
5376	3NKgHAdqJ1htixnYuXTeW6VxkS5zYAjusqeRRgyQhEcSqEDnJZMt	5374	3NKFRXSq8FqGm1Ewi5dCbnW76C9dApaBysY2MvAf2TUw7UnmwWCr	1631	794	54	1	5213	jx2Qy4JNEDUUXUVhfdGHZi8aowbgNE4cYSYL4GWYP9L982xgHrE	2796	3911	3911	1616643180000	orphaned
5379	3NLFPMHRNiBLFvYK4VmtGnKw4JWXA1iGYwrHrR2dtDU6VBRjNJ8B	5378	3NLRPadJ9LTSrmFsyHuE2GezJGRNeVj5ySR1GA6RJV1iVeHGf5k5	1406	1393	54	1	5216	jwfFonTtVJPWU5MdjyqwXMwz3HE6p3YxX66fxv3wfxYqehEUqDA	2799	3915	3915	1616643900000	canonical
5380	3NLFNWLmV7skFJsaYRvh3gLYWKKDSGwuCuBnWn5iND9hfkb7xhxP	5378	3NLRPadJ9LTSrmFsyHuE2GezJGRNeVj5ySR1GA6RJV1iVeHGf5k5	1637	816	54	1	5217	jwnGxQW4s8zFaMjUw9Z1CWNm33vi19YniS1sp7EeC9iEuzxk1Fk	2799	3915	3915	1616643900000	orphaned
5381	3NKkQ5bMb1YdsGHs5BUJo3cdZHBMca7UAsMeX9Rmt6ndj97TVf2Y	5379	3NLFPMHRNiBLFvYK4VmtGnKw4JWXA1iGYwrHrR2dtDU6VBRjNJ8B	1609	967	54	1	5218	jwggKDdHGwmSLaxfbVG5ZTSX8WpejtvaAc3gXsTHirCXWf86TsR	2800	3916	3916	1616644080000	canonical
5384	3NKhJjZsQvHTA8Csux3YCLKFuTUeBC55u7ejgmDguyYhnvotixwC	5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	1483	910	54	1	5221	jwzQ3QErE1mABCzJHf5Ef8F9Y22mfa359vpq9sCZybNoUCqrZh3	2803	3919	3919	1616644620000	orphaned
5418	3NL4gbgcRViFY8p6oPpAfTHCqnWQqUQCTJpcZSqs6wVBA4BRyhzX	5387	3NLgEiycytKZSwtJijbt6ZeEdge7wZW264F8bEf8s7QFwNTEMoeG	1460	1324	54	1	5255	jwr64THV35zzHwwJsRqv8gmtzcT5iSgSmx7PkhRcT3YUqmJHuVW	2805	3939	3939	1616648220000	orphaned
5395	3NKw69YYwYyqmkpDniScAPEQoncLGtBrbDJApSBCAwqM92XRWdbX	5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	1643	1299	54	1	5232	jx2zq8gSm8XHxghhcQK2cDyTMeHmf2H8SYQZYHRGwtipGuzKRBQ	2807	3923	3923	1616645340000	canonical
5393	3NL2iGUtDVdeewHUnz1ocN1ENAWLZoeSSDwXX1HJifigqm64NKGH	5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	1608	1163	54	1	5230	jxUmUWgjrSUWDws3daniUS9sw26pBwP5HCebRfbn9u9htFjKHuq	2807	3923	3923	1616645340000	orphaned
5406	3NKqQc5tHHReEf4FcKEBaLSHGZLPk6vizNH4TGL7kQzFLgQ9s4Ts	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1649	1017	54	1	5243	jw9RzS85QoebrUuTxuFUQmQ1LgJA71TWcQZgFNGuiGznRQZ1PqK	2814	3931	3931	1616646780000	orphaned
5410	3NKiL14baAWii8MG43qFJiZUivfmk8VHYaqkk59m6vhskKpLwGjb	5405	3NKba7XxW5kwy6weg4WAGU8tPczmauwdxvCQNG4BRH3amAHRTkN8	1448	1311	54	1	5247	jxqqQxDT1TpUBxbQ7dLykApuRzUpmGjPfzHcqdd5W1Yrg2amiBc	2815	3934	3934	1616647320000	canonical
5415	3NLF8uU5AzQUdGLP6oZcuLegLVzuZ9DkaCR7gwCbTgfW44r2Vnxc	5412	3NKHE28bFQPmksdAXoqZ283ZcyTzXMN4iR7Xg6WHhZtDHGQpBvJr	1402	892	54	1	5252	jwqZCbj6t59wHhXiMqJrwiXTjLt8oGKBMoUYCjKrGuRZqDnosgA	2818	3938	3938	1616648040000	orphaned
5422	3NKV92j5WbuprD5tQeQHaLaoJoAg1VobC7UXCJ5reZodVu7XrDPf	5417	3NLgRiQ7NU25HNsVgxatGx9JpAQbtJh9s2W7Y4EcdVSj2tEybtQ6	1529	1316	54	1	5259	jxatpB8MVkuWQdwf5cG5gLT14NyhNELLC7zYRYRXC3B3uP9SWHC	2820	3942	3942	1616648760000	canonical
5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	5422	3NKV92j5WbuprD5tQeQHaLaoJoAg1VobC7UXCJ5reZodVu7XrDPf	1631	794	54	1	5260	jxbxog1yv7QMCG7z4dxiz7rP3o1KJQNGB2o1GanBDw15SpkhfJc	2821	3945	3945	1616649300000	canonical
8989	3NKWjmgtY1fErLpWrL5HnTWYiU8HefLWM25B5eu8xvJSv4Tm4C4g	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1581	778	108	1	6301	jwdE6gLvGeoBNxZNskkgh8hbzybf7oozU9QnnDjsUrciNaZ2FxV	4661	6561	6561	1617120180000	orphaned
5387	3NLgEiycytKZSwtJijbt6ZeEdge7wZW264F8bEf8s7QFwNTEMoeG	5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	1627	1139	54	1	5224	jwPZcHXhsnpJXYfsYNfzJyf974rfUcqGiwn9ivTujteb629Fsdw	2804	3920	3920	1616644800000	orphaned
5392	3NKyp9FC8Lzq6DbxJirXf3mqQTG36b6gNt2F68FiumvN115isqQX	5390	3NLaA4GwwEnqFLEukitCj3tsH67oobq3Hp8UZgprAz6sZPFRcWSJ	484	1319	54	1	5229	jxwPWgji9xHU8pFi36RZb2N9BiJNwefrMez2vmhoTsnS9g6xRT3	2806	3922	3922	1616645160000	orphaned
5394	3NLRvRXdSo6oKn5AqQG1pQ1VXCU1n367XfAohEoaFhYZgxKMjj4E	5391	3NLu8cz28jvJ58t2hSDFJLuvA4NoVm8U8Q5Z2Nvdx8ngDJxWeDQN	1403	824	54	1	5231	jwgD9uS7ss5tfd77F4aetcNPzLAwTH7fKV5HnKQPDvxMefBxmtv	2807	3923	3923	1616645340000	orphaned
5396	3NLi1pW41bG9fZaBnKmtcsNSsFm7VNDr3myRit7GP1W8mjpZt224	5395	3NKw69YYwYyqmkpDniScAPEQoncLGtBrbDJApSBCAwqM92XRWdbX	1590	1054	54	1	5233	jwqqTzxvydpUjyboFcjBo8eQfxwLno9AHHyfStthBEDjt5LUGto	2808	3924	3924	1616645520000	canonical
5400	3NLH4tHxjtyCE3mBD4erTMzUHrYyGFJwdkWbabSGaHh5rQaeCQur	5399	3NKGngJv5vXndpKqQBMv6wRipJVbvHmxSfuam8aUGVhWrt5MwKXo	1590	1054	54	1	5237	jwuZqFvbtDuE2CAAQE4EiDs75ySSDh3Q6ZYLsNYHEGTCUTPV2Pi	2810	3926	3926	1616645880000	canonical
5401	3NKGGk38kmyTdoBqDUSKECoQTViGpxbsc1FfohLmHzesozbQTsjA	5400	3NLH4tHxjtyCE3mBD4erTMzUHrYyGFJwdkWbabSGaHh5rQaeCQur	1406	1393	54	1	5238	jxnhtuf7Esj9VX5AUcFiDv9FRbKPHwL3s3PsTpQmbAj8b2cR1BZ	2811	3927	3927	1616646060000	canonical
5403	3NKN4b17FarqrviBNeMTw4xGuQossD9yWQNGisHjJBu4wNFHFZL1	5401	3NKGGk38kmyTdoBqDUSKECoQTViGpxbsc1FfohLmHzesozbQTsjA	1403	824	54	1	5240	jxGk2PDdQc5NuWNzP1UjmyjqjM3vJifJPfyThSyYTmJTQe9qAEn	2812	3929	3929	1616646420000	orphaned
5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	5402	3NKzVpJYK7M8Ydf6SCN2bLP348v2ZbEBufvS8Sr9Dwbk93rMcmXj	1589	1040	54	1	5241	jwUGr5npXUu1Dac1HBGV3j4Qhh8YdnHuiwyGzKfVvKbBZ7a2fcw	2813	3930	3930	1616646600000	canonical
5408	3NKCT1upPFLyaraEY1Lj23YBT1hJBwpT59NCF8dnuU6ZMuuuUA9U	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1501	1360	54	1	5245	jxidVoHVpG5SGewgugwP7qLMHJ37GKrA2UAEZqdjM8q8fdRibe7	2814	3931	3931	1616646780000	orphaned
5411	3NK2vHBno3X98YyXNycH7S9JKeCVn6SxmxEo3svQQtJmBaLsykmt	5410	3NKiL14baAWii8MG43qFJiZUivfmk8VHYaqkk59m6vhskKpLwGjb	1406	1393	54	1	5248	jwAy9wB7hBS6dXryLZm6hA4v6WMsfQ8hv9wZ3gBHmZHVqUVHxRy	2816	3935	3935	1616647500000	canonical
5412	3NKHE28bFQPmksdAXoqZ283ZcyTzXMN4iR7Xg6WHhZtDHGQpBvJr	5411	3NK2vHBno3X98YyXNycH7S9JKeCVn6SxmxEo3svQQtJmBaLsykmt	1534	628	54	1	5249	jwmtSoJGjcGihijC31onqLADEHKQVzYYermbE6MDFGwDAo2hwhT	2817	3937	3937	1616647860000	canonical
5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	5412	3NKHE28bFQPmksdAXoqZ283ZcyTzXMN4iR7Xg6WHhZtDHGQpBvJr	1405	881	54	1	5253	jw7V8kW9ATDfSqTQViiAYd3VwxgLYtoduXFEk5dCXvzxsK43b3o	2818	3938	3938	1616648040000	canonical
5419	3NKCdKTJX3P3zX5zYyvDMou8TmXepxDSNQLaEasZqUGcQSRJ7EPg	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	1613	1103	54	1	5256	jxYhM5AHtdJGUGzCXJbYWtQuHw7iumyjaaeLnCwFyAeh3stZdqF	2819	3939	3939	1616648220000	orphaned
5421	3NKL95t3VvzXYWBQxKbj8J3uJpzZfFSRXQ7hKPqaRQqQP24oUW2R	5416	3NLdGXwDVaijr6KDB3ophrqqeZrKKGKxc1wWscQNs3hkKY6LZDce	1549	1116	54	1	5258	jxTu8nb9R5squBsGkokGw57acUrrhpez6PLgJuuumjVQqFPDxx3	2819	3939	3939	1616648220000	orphaned
5425	3NLjEqY7rgJ5bhXpMjyDvCCZCt54SAcQyjGsGeU97Qsqo6URmUgo	5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	43	1064	54	1	5262	jx7hNiSUWwhgnazBXnCLxcG9ZfSmUr2Uewq4csHVx778shfpJHR	2822	3950	3950	1616650200000	orphaned
5427	3NKwJsPNRT4NnJqUkGyKApebdQjJ1WiFjAftCwv6zWp8o66DUMev	5426	3NKJ5ZFGCxvFPrap3s5DCNJoJh7RX2LVN2MJgvp1ADmKFhvdu9X3	1445	1290	55	1	5263	jxanRak1dAg66Kd6ECXMBEpii16xngqfQLbUK2BRJVkEBkE2tNw	2823	3951	3951	1616650380000	canonical
5430	3NK5PXCwU1eDdSSRsyh5SC97Tto58SDDahjiAZ6gryDbpMicxwEM	5428	3NKHXJ7aR11VWUZnditbBF1GZDwEQxfYiRvgVA8y22fM9VUqWog4	1403	812	55	1	5266	jxChERuni7RXSuRtdJ5VNK19kezgWFNgZCYikjP1PT3B9z6RSS5	2825	3956	3956	1616651280000	orphaned
5436	3NK5ctPLxbsgVRg932zfPLxn7iM4vHbsJtZNkAwnfGmaios2JQPC	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1422	1337	55	1	5272	jwcgLCPuJP5YhoxkCwmojuC5YJAdWGBGHsj5xAFs7eKhm7k37qi	2828	3961	3961	1616652180000	orphaned
5437	3NL915JihActZ8ddHbd81mGXK4DXTqCuWqEMiqJx6fcEfbc3BxGg	5435	3NKNuZbseHvH4D1KmmfYm9pTZJZMSKF1jCtR7gDzbGoqfvJjCDFt	1406	1393	55	1	5273	jwvk9T6FNYLJyGLzNs5ucDEw6sYkNt57HaxSym6HR6a6phd4vXq	2829	3962	3962	1616652360000	canonical
5441	3NLNN43wzaNZzKvs59rJdDLPbmt8vSS1ceDruuBXc7HZ9NHNoCC9	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	1581	778	55	1	5277	jxW4FJHrerne6CBzPHw9zAKc5eGBGKxc2QsyLXmFGEfCP3Z6hrn	2831	3966	3966	1616653080000	orphaned
5445	3NKb64U27vSivDnrhHDsKugSf8g3uhn7GUrKLFnCJWt6zjg41cVz	5443	3NLXxNEaYU5jip6aMtgLEA9SPdpViK45RVJuzBVardCAh9QRFWKQ	369	946	55	1	5281	jx8L2DfYRTgtsrqqKyvwnkrytKr6FELqB6ogX7dp74MTT7gBtWv	2833	3969	3969	1616653620000	canonical
5447	3NLNHirkXay7JoH1JLaUH45FztDDd77EqPfbKUdsCrVeVZBBPrkP	5445	3NKb64U27vSivDnrhHDsKugSf8g3uhn7GUrKLFnCJWt6zjg41cVz	1613	1349	55	1	5283	jwUfD3wnY5Y4ME6Sk5dJNrbCauPCyJRd5S86C8Zh4CH4e5swdMK	2834	3970	3970	1616653800000	canonical
5451	3NKAf7BAT87eRsmWPjR9DoNfajoym2rvQAY1ck62CTu8LLFpyxaH	5449	3NLYDuuTPU3Tvsaz67Ruhk1kf4dXSFETf1LAJG8WH5naeCoUjm8t	1406	1393	55	1	5287	jxWyVT2DXBrEvYixcMSEqzEwJNojktP9LTo4j1pSRSkaACUcDaP	2837	3977	3977	1616655060000	canonical
5456	3NL3VhHTe7drWfdrSZeciWSCAPgzTbh51hgq9sk9ToWgjxvdB8tb	5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	1516	1048	55	1	5292	jxBMA2EoYFGacficagtF2cuYQWrb3sJMsbxZhkwMQwwE7uLUb2o	2839	3979	3979	1616655420000	orphaned
5461	3NLXYCXs9BbNhKbsMcTS9KYU6p3BBHT1X1md1dBttqncy7DFZzBn	5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	1590	934	55	1	5297	jwCKo87xV8ZK6jdyYYWXwEASADZC77VwUs9ETs9uUwLmLC2mSfT	2842	3985	3985	1616656500000	orphaned
5467	3NK3khRnLvdXh9GK2z1Bf7fdYCDstqg1Gy7HSBKfne1Vgngqahkh	5466	3NLgG2LQTe7ipLy1cXTk6U47qR3hBkpGnhbvAhWfVvQ1fbHkVgz2	1402	810	55	1	5303	jxrYsLNaUV1XDxEU2fe83GMii3FrqHjzqqc6zUYD1j7N2kToD33	2847	3993	3993	1616657940000	canonical
5470	3NKESc3UJAKBcWi4NKjtgvEsEzh9iR6LjN5Les5buncKmhM5U7s8	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1637	816	55	1	5306	jxBW6RJfn2BXUhapHqGVUBFaUogBU1RTozVWWpwqUQz7P3T5VR7	2849	3996	3996	1616658480000	orphaned
5475	3NLkqC5NAs5qpY2pyAzvBySrxTrdD3gjL7avNwFbsS8JZfQAEs1S	5474	3NKCzKgZHiKFwUi4e526puaMunfKiD6hcPbYKTuu99Lijhibyuhe	1605	305	55	1	5311	jw9nTGHyjJYQ6w4c2Znniy1mBZBxyi6PQiXiRQmh7nHfC3rfmaQ	2851	4001	4001	1616659380000	orphaned
5477	3NKYrA2N4QQSQaVLx2mgZYwtTLX6Ns9hxX599jw7SBP2ZFcmXs7A	5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	369	1312	55	1	5313	jxjxkzxqnhV3tRW8v44HJZzuTqvAarZJAc3357sTxsJuCuaFgKY	2852	4002	4002	1616659560000	orphaned
8991	3NKJbqKdPdta8oGM9HGnHEfVua4uh5sNe3ptjuXDMoUdpSrjKySW	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1503	1277	108	1	6301	jxmKsrpnj3cAqvEETgjHdYU94jMiMHVeTGTHqUMzEFhPDFUddEH	4661	6561	6561	1617120180000	orphaned
5432	3NKyUnZzRaubMhoGE2XMS9qHBfuoXm7eQvuxcbZ4B1H6TLdsbMJF	5403	3NKN4b17FarqrviBNeMTw4xGuQossD9yWQNGisHjJBu4wNFHFZL1	1419	814	54	1	5268	jxzJxSQbEN8MGmdbfHAFtTEZTJKE6yC4mVXS5T54mQfwXZE9TJR	2813	3958	3958	1616651640000	orphaned
5426	3NKJ5ZFGCxvFPrap3s5DCNJoJh7RX2LVN2MJgvp1ADmKFhvdu9X3	5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	43	1064	55	1	5262	jx7hNiSUWwhgnazBXnCLxcG9ZfSmUr2Uewq4csHVx778shfpJHR	2822	3950	3950	1616650200000	canonical
5424	3NL5nRS5JPhLUCb2kT8DUVvxQeHowoGqFgCNsSuczzGSL1VjrBdK	5423	3NKEXEy55QGJJDfUMpjGK7E8stXq3kxL8QRGZBGbZ5rH4YebrE4h	1406	1393	54	1	5261	jwudi3svrEAKpGVKntQJPaRhJf7B6oYoEMpY3bujHnXEAXqgy7p	2822	3950	3950	1616650200000	orphaned
5429	3NKeiz7wXC3xAtx1Fc9xpUGBwme8oc4kfnEAMMuTcqaASmMLBVsd	5428	3NKHXJ7aR11VWUZnditbBF1GZDwEQxfYiRvgVA8y22fM9VUqWog4	1458	1197	55	1	5265	jxL9ArhnYabTbbMVJALhtt8vF1rQ3Kx1SGgQJqvKDF69CtYxPMw	2825	3954	3954	1616650920000	canonical
5435	3NKNuZbseHvH4D1KmmfYm9pTZJZMSKF1jCtR7gDzbGoqfvJjCDFt	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1406	1393	55	1	5271	jxQc3usacSGhQEAZeZQ75CN9pLbhUE8TosghHeHMbcZ9J42wcaw	2828	3961	3961	1616652180000	canonical
5442	3NLK6ZGa7ZiZoyGzTXHkCM3uDLL2ieH8jf731gbjYVgpuP5S7hzL	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	1631	794	55	1	5278	jwnSsxCeiAtKv6E8Xzc9yEGd876wsPrH54ANTouhwba2QSiwM57	2831	3966	3966	1616653080000	canonical
5440	3NKSDgjn8ujnL88mFM88iXVK1SLqETSu7Z3qAD3SGBLdNqCjeMZ1	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	596	1306	55	1	5276	jwyW2GaPx3jdq4bNWxsv7xsyhBUjngV7YPkdHSMnAcGEziFwD3F	2831	3966	3966	1616653080000	orphaned
5458	3NL81aaoReiqgV6yMK4RnzZkeA26mHy2gHc9FqtNvKxmFncViXnt	5454	3NKhUj9A7fFvHGkqvFCvJXZrMwhoptJP7JPbQjoT5Ju6MuwLUULj	1600	1372	55	1	5294	jx5bUPPuHxtzKnJ1h64c84j8fDNM3tGsNp4NRneENqL9Q892YRc	2840	3981	3981	1616655780000	canonical
5466	3NLgG2LQTe7ipLy1cXTk6U47qR3hBkpGnhbvAhWfVvQ1fbHkVgz2	5465	3NLv5B2QCLLSCXUokwURDdVXvkV33HWd8PTftN9hbcWQcXMeBSBU	1405	873	55	1	5302	jx1f8GgH5tKbKLUzNas2P7Lydjy8KzWeZDGoiLS6VYhoDwPWmXA	2846	3991	3991	1616657580000	canonical
5469	3NKdDcPALbfYf5tuUHWCgJ58JamkAJsYYmJXFYuKSZ55GBQgDHK1	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1451	1046	55	1	5305	jy1uypDXw1hHiEVbAA9YNWDZQLJ7aUYSo6ovQHj89DMpxRAyV4q	2849	3996	3996	1616658480000	canonical
5474	3NKCzKgZHiKFwUi4e526puaMunfKiD6hcPbYKTuu99Lijhibyuhe	5469	3NKdDcPALbfYf5tuUHWCgJ58JamkAJsYYmJXFYuKSZ55GBQgDHK1	1403	812	55	1	5310	jwnXVcQewUa6Ftwut3CLS3J3NFWQfSyWKoBW82tLbVUv5L1gWZv	2850	4000	4000	1616659200000	canonical
5472	3NKYGomfLDaXjzTPNbB23kE7aHtJ5VtCs4jmPYSw6RTxVH3qtAnW	5471	3NLWetVJXFCkjQD5FK3G8ek6u72pz1vDFd4ndYbBe5CAZMA2egN8	1643	1053	55	1	5308	jxq4TWTG3pzmaZXtHP8eYm361iyQBANzhhZNRZkFifxbQm3z8Ug	2850	3998	3998	1616658840000	orphaned
5479	3NKWLD2YaUPzXiWpphMzd264FajuC6fQMwBq3dR7cnJ5bue3Fb3N	5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	1508	1021	55	1	5315	jwKwfFhGMmP4LqAwvk71RgukzeZn4HiXPjaZoqQbNYVeVp7YPqA	2852	4002	4002	1616659560000	canonical
5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	5479	3NKWLD2YaUPzXiWpphMzd264FajuC6fQMwBq3dR7cnJ5bue3Fb3N	1549	1362	55	1	5317	jxmMJPcCP9eBkQocRRMYCQgPuHkFmwiS84LJLo3r9goM97wWipC	2853	4003	4003	1616659740000	canonical
5484	3NLfFdwWLrj7ZDjW6369zCa465JXxdqDtNTcqun7x91AQojGsNS9	5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	1506	1247	55	1	5320	jwRexCeN4uBEwr6f5jX6whJDvPnsk2e4P9fZVb7xQLLobnotBSQ	2854	4005	4005	1616660100000	canonical
5482	3NLPeDAmA9co2NjZmPv5rAg6TKp6W7ioygboJosUX4msQJn1RudT	5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	95	95	55	1	5318	jwBZDsGVkPQs5ewhR2gvBbTbbuZX3ueNxoVvh623Eh7o6hLf2Vj	2854	4005	4005	1616660100000	orphaned
5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	5484	3NLfFdwWLrj7ZDjW6369zCa465JXxdqDtNTcqun7x91AQojGsNS9	1611	975	55	1	5322	jwHX7eofJ2iwFTqQemxLPQ1Ejvvfkxu3QigMdR1ay4mJmNWZazc	2855	4006	4006	1616660280000	canonical
5489	3NLbEVGnBCaefhY8yz4RMG9zWbFT5TUgVF6kTEiPiLyr8r7pgx8S	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1675	1216	55	1	5325	jwCbEEcmeyovaUyha1n65yJQvRjDBT8KHoRiwKDbN1HiY9XbzNf	2856	4007	4007	1616660460000	orphaned
5493	3NKYp9wo3HaB49DWWpea4PZJyk7xe9z4obL4U4Cozkd4rRtYuAxa	5487	3NKk3CcthJWnUfsTwnochDqrvwxBvEKFoaG9DHtx7ULUxpe72bSi	1553	776	55	1	5329	jwnhx5mmPfRVyLycCbV6rnXi7RQZiPaxS9ear9bbmcbiRURsU8m	2857	4008	4008	1616660640000	canonical
5492	3NKNevkTmx4XG7r4dL76HFuP1YARhqGR2zGo9PxDJc1FAsAQaRYq	5487	3NKk3CcthJWnUfsTwnochDqrvwxBvEKFoaG9DHtx7ULUxpe72bSi	1402	868	55	1	5328	jxeWBRTqVzhke87cNnqHsiPXEteLBLDyRsND8R3Ax8uwtWB6eyM	2857	4008	4008	1616660640000	orphaned
5495	3NLsb4j7T3RuvaZwP4J93bf9VSD2SstQYUkQPPVBTA33H4SFsfYu	5493	3NKYp9wo3HaB49DWWpea4PZJyk7xe9z4obL4U4Cozkd4rRtYuAxa	1637	816	55	1	5331	jx7qhUb3DDwU9CpKbRZuThky9FB9aMWHsACaB8Ef8eHeYrjGk6w	2858	4009	4009	1616660820000	orphaned
5497	3NKVumK3Nu46hjC5mr1ZDwLNrWuKA6ioP6wx8L6VPkTZbLrNSrTq	5494	3NKAsx9jGHa1bTKBmyDNv7TZ96JMGkFHGQLjtpEA7Ue19YhtBT4Z	1617	1288	55	1	5333	jwFbbT1TVrkgwv1zoVtMPH2iGuUtAf8Wdd1paijsF3NeMwbGoiU	2859	4010	4010	1616661000000	canonical
5499	3NLFy3WY44GrUspede4jAD97BGLGE6fV4bvKHftL4Ju5RYSxZ8HN	5497	3NKVumK3Nu46hjC5mr1ZDwLNrWuKA6ioP6wx8L6VPkTZbLrNSrTq	1581	778	55	1	5335	jxrRFfNtGxnqj7TJVLJDAsackHBoHLdCwADTi5goA9v9ZQz2NNB	2860	4012	4012	1616661360000	canonical
5500	3NKwc3KAvq4QAoNF6A7ygN3HDRMeYWRjiJGvT3tjKdBwR7LeMsFb	5497	3NKVumK3Nu46hjC5mr1ZDwLNrWuKA6ioP6wx8L6VPkTZbLrNSrTq	1403	824	55	1	5336	jxbsb13svqp4qvhsvRYMbYo7JQcrYhJZ5qmC9AaCXSHqVpyXYj3	2860	4012	4012	1616661360000	orphaned
5502	3NKpFjr9aN7HE6UJ7kedAa31Vqi3UYMHzuqEKseoXPVfuvNkWBh5	5499	3NLFy3WY44GrUspede4jAD97BGLGE6fV4bvKHftL4Ju5RYSxZ8HN	1406	1393	55	1	5338	jwXpZEoKPD4UNUCa6e7RrivWzbqoHneTuhwbCTJgEp2QoNXsf4J	2861	4013	4013	1616661540000	canonical
5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	5506	3NLTEBN9hBMd96dyiWYwNU1QfwuFLwTUvxJjG1ch89XFxvY1PtHm	1406	1393	55	1	5343	jwq5LG4JpiBfRRCk1xVBdYsZawcgtTEygAMUQ73AHvjLQoPnnct	2866	4018	4018	1616662440000	canonical
5510	3NKG4W8CkaPJ7D47nEMLodMVfceXHVUYSpP2Gmaz37UTS56nwqWB	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1600	1246	55	1	5346	jxv1vPvBKNNQC83ofvuuGWVZfEDyaRZbmRsDmUCpvepfMtTPz6u	2867	4019	4019	1616662620000	orphaned
5512	3NLjregJ5FzAtStLPoYHzAqkCbG7jzQucce73fQ5FaNZ9mkHLkZe	5509	3NLrcwENzBSmgZ6u6BAxDQMdsB71d8vcnM4caeZ3n5GGDuLCHBdL	1426	998	55	1	5348	jxJU5QQuxw7ch7APR2cC2ARmyw7UoG33x1F7jSygxAnBtGzo8Rz	2868	4021	4021	1616662980000	orphaned
5516	3NLsoYy4XatHJJfhJhG7x7EvgKkzjJA4pockBxDXPEoE6mR4nR5T	5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	1651	1055	55	1	5352	jwe7EnZk2cv5a7kgcFkUJBxz1AnaKuzBCHkRDcbXdVBxNU4msgb	2869	4022	4022	1616663160000	canonical
8992	3NLCEv7V6s6rgzwuqDYrdR7nWj1PXVc8sVMbLV6H9jBrcdMxsErM	8990	3NLGL4a3sN1tnFXV1GUxCSwpGNHuH7WXhvxam9y8uoLHWPoiuavh	1637	815	109	1	6301	jxHgstmnMew7kFoyPbSDZVnmxcwEFKWp3QZv84E8qBTvaubG1pm	4662	6562	6562	1617120360000	canonical
5473	3NL6BkFU6Rixp2U5ytKcQ2X8hMyz6atUsZb2LWxvjyJLxDkYyreL	5453	3NLu6mB9h3gNDRpCAzNXTUNRcBRgiSsFyGqDCg1aumyBuEyvrDpf	1407	1395	52	1	5309	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2714	3999	3999	1616659020000	orphaned
5491	3NLXoqqPsgPe2DuC6VyhUmEfREjViuDDR6QTzswcjYGMouzzJkf5	5473	3NL6BkFU6Rixp2U5ytKcQ2X8hMyz6atUsZb2LWxvjyJLxDkYyreL	1407	1395	52	1	5327	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2715	4008	4008	1616660640000	orphaned
5498	3NKpXyZ3zo4GnTgCP84ZUZ9LETrjipeLKdY8PL8eCPWHiyJ4jdWk	5491	3NLXoqqPsgPe2DuC6VyhUmEfREjViuDDR6QTzswcjYGMouzzJkf5	1407	1395	52	1	5334	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2716	4011	4011	1616661180000	orphaned
5431	3NL1wELyw8jWskzwnvXvxfyWzGDszrtWpKqeqm8ueDhGDnxjP9v9	5429	3NKeiz7wXC3xAtx1Fc9xpUGBwme8oc4kfnEAMMuTcqaASmMLBVsd	1581	778	55	1	5267	jwUdU2GScMnZJ7zWurRp7j9EpTddNUE5x1r8SEm9Kvjt2ZPrYQg	2826	3957	3957	1616651460000	canonical
5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	5431	3NL1wELyw8jWskzwnvXvxfyWzGDszrtWpKqeqm8ueDhGDnxjP9v9	1455	1086	55	1	5269	jwFuyV9Yxfg1WrLyuTAU6B6u1U2RKobeH18Cb5VA7CACQMsy8aC	2827	3959	3959	1616651820000	canonical
5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	5437	3NL915JihActZ8ddHbd81mGXK4DXTqCuWqEMiqJx6fcEfbc3BxGg	1406	1393	55	1	5274	jxvaeAgf4sUxXVmzKAGtshJgKT9rPjABMCvrppFhoeS6yaKB9oA	2830	3963	3963	1616652540000	canonical
5443	3NLXxNEaYU5jip6aMtgLEA9SPdpViK45RVJuzBVardCAh9QRFWKQ	5442	3NLK6ZGa7ZiZoyGzTXHkCM3uDLL2ieH8jf731gbjYVgpuP5S7hzL	1671	1365	55	1	5279	jwzSomp8ZBxikFDyXFyy7pyfWHhub8bjHYPY7fF4NfoN1qBCj2j	2832	3968	3968	1616653440000	canonical
5448	3NKduCCSQDVzgwMyrGS5eG22WZufxYJbvXMYxgaAdoYtGtTTjHJr	5447	3NLNHirkXay7JoH1JLaUH45FztDDd77EqPfbKUdsCrVeVZBBPrkP	1631	794	55	1	5284	jxox655TdX3SpyoRnLgH2rt48ptQyCTQi39MS1cKd6aXU39z14Q	2835	3971	3971	1616653980000	canonical
5454	3NKhUj9A7fFvHGkqvFCvJXZrMwhoptJP7JPbQjoT5Ju6MuwLUULj	5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	1406	1393	55	1	5290	jxCk5zvezqxz9SaANFKp4nXc7LzZYyiVhwAbFZvyxeGKNPg2Egr	2839	3979	3979	1616655420000	canonical
5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	5458	3NL81aaoReiqgV6yMK4RnzZkeA26mHy2gHc9FqtNvKxmFncViXnt	484	1319	55	1	5295	jwfQcNDRTZsorJJU79qjwsKTpVoWJBhzC8kZZRYjcLPdSEKYiHd	2841	3983	3983	1616656140000	canonical
5462	3NLDs5u67eVE11CKvaLo5GeJQpVZd8TjgnJuSzFyRoCemrfSh83i	5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	1611	975	55	1	5298	jx344ZtGa54o8drB11eQgt9mdo9xAquLvNhMZLpCXo38MmnFUSX	2842	3985	3985	1616656500000	canonical
5464	3NKAkn8jBWsDyMErv4Y3w4sTfwzJJxn7ED4byjXvgz6JQxVfGCd9	5463	3NLY3W8euKPEveHRTDUdFXSM1yxv2nh9LkevqrHAf2WdQmwxWjuR	1553	776	55	1	5300	jxEjPZ7eTXkfFwjuAJMFeuwmMPHoMAhKJ3ASPVTAG42NXyVtPrb	2844	3987	3987	1616656860000	canonical
5478	3NKD2MvR1WVbjt3SN4orsky6ogDohvSVJLg1GZ6oFcTZtqePs7hc	5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	1406	1393	55	1	5314	jwy5c3nYgrrDga6CzLtokXJrJotBmYyEkajTBr25UggRUVgx6nh	2852	4002	4002	1616659560000	orphaned
5480	3NL9SJG6dmbmmKVubUvRRvg7NUtgUva7JHEBaQcAvUDY996ymP4A	5479	3NKWLD2YaUPzXiWpphMzd264FajuC6fQMwBq3dR7cnJ5bue3Fb3N	1648	1284	55	1	5316	jxsv3M87TWwe35A3yoUAjMzUUFUpL4Xj7JtCrr361HCJj2bijYm	2853	4003	4003	1616659740000	orphaned
5483	3NKoPPRfDhuLGGpGNxZw4kypKQsoaajhMUPrU5PJUk4MmhxhtVpq	5481	3NKmuDLRysi2zDAvUmYcgiecu7EC6jcEDLoDfmF5JbzaAL2HwvWB	1403	823	55	1	5319	jxF7DtxJZrU1tXbfJCw5RV5P1pmnfhuoMzR2YWK3PZNSUn6GnB6	2854	4005	4005	1616660100000	orphaned
5487	3NKk3CcthJWnUfsTwnochDqrvwxBvEKFoaG9DHtx7ULUxpe72bSi	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1406	1393	55	1	5323	jxVNoHCqAH66zJR39EzZTGAt7QJ7oYuMqAwKNfakX5NsRJpgPJM	2856	4007	4007	1616660460000	canonical
5490	3NKyUYzSrSAEgrhDG1Wd9c5HvakaZCL2JLZJTNWbzefZDFf3sjA8	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1619	1275	55	1	5326	jxBECm3HXj1JsHx5G9QfT1RGKpV7YvkXXTgGSDhnyVYSE9CNa4b	2856	4007	4007	1616660460000	orphaned
5504	3NLhhfQLbuPTRwaNPai2N1N37rN699QmnMCzcemYgxucYe33w3yC	5503	3NL71uLQMeoJWAuD62EVa9HVkNsuB1GnEnDmK8E54XMZnsin7FuW	1483	611	55	1	5340	jxVyeg34mHYd8iRsMkgpuPu2PwaGysq8W6qefW7mt3j7SZArj4Y	2863	4015	4015	1616661900000	canonical
5505	3NLAKWE1Vm6ZHAtAfnsgto2ASaRjroTag37Jfpts8dFgAuXvTTSV	5504	3NLhhfQLbuPTRwaNPai2N1N37rN699QmnMCzcemYgxucYe33w3yC	1546	1339	55	1	5341	jwJ3QZzshbJXCyDjNKR6bQdruMikaCCrGCwQtx5x6Ba7LLuNWfQ	2864	4016	4016	1616662080000	canonical
5508	3NLURbzbt6itNqVepbVvmBWZC2KeeLrPnRHi6R2TzB2AGA3E3boK	5506	3NLTEBN9hBMd96dyiWYwNU1QfwuFLwTUvxJjG1ch89XFxvY1PtHm	1571	1089	55	1	5344	jximk9495KSsBW3H3XNiCD3xZXBrMDaFv9X9k6AkhW2jyGW8dbY	2866	4018	4018	1616662440000	orphaned
5509	3NLrcwENzBSmgZ6u6BAxDQMdsB71d8vcnM4caeZ3n5GGDuLCHBdL	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1672	1039	55	1	5345	jwgMJqjRgap8HAjhftZbhFVh8cD2dxH1a9YKS8u7upPvnm9ztgF	2867	4019	4019	1616662620000	canonical
5519	3NLrktb9bBjQKHjJvzC4x7zwdWo5H4L37P51J5bCWRZGRc2gcayg	5518	3NLen8L5FnAbGay8cCPyGAFzCQwxvmkzQHEDChYh514y7sBFybb7	1623	830	55	1	5354	jwRaAo4CRJwR66wsvujvZTjuntEnR7zJNqkzi8pmaQcdN1CKz82	2871	4028	4028	1616664240000	canonical
5526	3NLm9wFmuSk6WX9mtVS1RFX5o2R3DhUvqZjLZsAnnukAXPTgnVS8	5525	3NKqRzRU1WH9n9fYXBWvuej8wz7prD4an7fgiyhG9VddtgCKm6sw	1406	1393	55	1	5361	jwSXCM6X6VrKJAwGHL9yRBea8KtYghYqohCcEFfBUFLxp2Nktvq	2874	4032	4032	1616664960000	canonical
5533	3NLKpCweKqCeCCCbHuu5Ssx3z7MaeUWX3e24cDfUew7Basx6q7Vu	5532	3NKfF2xZwwryZQgxwCJcn7yN26qdo9chphNke5qaQNnUMTRcaRfu	1402	868	55	1	5368	jxH6uv5wtJyjVg832FMeeua7DvTc2rjSS68msLum57tZZXjk2S1	2877	4035	4035	1616665500000	canonical
5535	3NLAjocioH7MXPPgcEyTkQyphmiLEKSezQXoX2FHWaQwWB45hZeq	5533	3NLKpCweKqCeCCCbHuu5Ssx3z7MaeUWX3e24cDfUew7Basx6q7Vu	1405	873	55	1	5370	jwudCnTH4Y5tsrE3vGLNyedxCCG9BEi6iJcQb2BthAgQtPYZrGU	2878	4036	4036	1616665680000	canonical
5540	3NLH9dJgFi9nsTpV7jDhZbaDKW7UkwME4uoLLkmzQEDiA7reDbPf	5537	3NKNJ8yBKitgdSkTR1a8RWChGdByqgYeAW9pYLfJZAUH9XxFzzP5	1637	816	55	1	5375	jxtvQdxo6ot9tCQgMmRKmbAXJkSNymBy38VD78GQHqyCFf7qsWF	2880	4039	4039	1616666220000	orphaned
5542	3NKPVHBF9Lpy1YoFyYF14MhWqZgryhacnkCbDV74Gy8XG23v8qjG	5539	3NLMbAW1iaSS81Q5aCoX7GpDMAWiE4QsoWLxbqCFnEB8Jm7oAGhA	1519	860	55	1	5377	jxdDr2VPpX9b6ToPWP8uVdR1F4KshezzNyvpoHu9vxJUaj2RoiK	2881	4040	4040	1616666400000	orphaned
5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	5541	3NKwPk4kHkbVkHGLQooxBGG679uBr9qTck94nvbw3tdfCU95xGgP	1590	1300	55	1	5378	jxJZJLXH4k2stF6BerhoPJzWBDwUQko3kFAxpTr6Xxf3U2RbGkF	2882	4044	4044	1616667120000	canonical
5548	3NLmpYyKmcoTzdkuo55xAiD3rpLWUb7cSiA9tm7UVErxgRJyeP9h	5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	1534	1071	55	1	5383	jxiiALWHEHm6HyWEopbdtX9DHV766p19G45eUYDtdyhDhN9YZUj	2885	4048	4048	1616667840000	canonical
9359	3NK9KAR8Nsctj15B6JjCG1jCgqd9dppJvw1rk1CadYgPasGGPs79	8997	3NKeC9N36fW7x8rUur8MAaREgm4Kc673KpRCGkECZ9qHJZjkRCju	1403	824	109	1	6301	jxtLD4cCncbeFaY1rDffVbdb3mVQUNkCDM2TeQm4YSvRWoVbtXH	4666	6839	6839	1617170256864	orphaned
5444	3NKTwJ8ByQuMEVd15vvtqBobVxyG4a7KJnH5uqURkMayQ83GmqAa	5442	3NLK6ZGa7ZiZoyGzTXHkCM3uDLL2ieH8jf731gbjYVgpuP5S7hzL	1474	1329	55	1	5280	jx4ADhvKvHkZW1kcbNDrveyntcR4RvHXMSo6xzxTvi4m9mUfrLq	2832	3968	3968	1616653440000	orphaned
5446	3NLv246a1LTXhU9FKmGsRqb6GwqWNwyvCGxYjs6Ua7aBG19JhGGw	5445	3NKb64U27vSivDnrhHDsKugSf8g3uhn7GUrKLFnCJWt6zjg41cVz	1588	1266	55	1	5282	jxkorz1TfzLNwY4VMBKGfA81KfPwA8mFPgpjMGda8zytJCHjAHj	2834	3970	3970	1616653800000	orphaned
5450	3NL6Fs25KkrgBSorT1zLFf3AVC996Ax42zB8pkQvsXu78V7rsvQa	5448	3NKduCCSQDVzgwMyrGS5eG22WZufxYJbvXMYxgaAdoYtGtTTjHJr	1559	1353	55	1	5286	jwsJdgeaftJUJG8JxztEKS2Bcz6nZqNfMKomAxAgq5YUTTxYQDm	2836	3975	3975	1616654700000	orphaned
5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	5451	3NKAf7BAT87eRsmWPjR9DoNfajoym2rvQAY1ck62CTu8LLFpyxaH	1619	1275	55	1	5288	jxcCKDHyfzqr4rhdUGbUHu5u6Ebd5Gb1pVheZHzVk8XkD44Jhjn	2838	3978	3978	1616655240000	canonical
5455	3NLYg6NFqRjYzjhPJnEGJD7A4cEXdApFFpUe1VK31AUJzSUmR6ew	5452	3NKz2XXg7jWBba1bv22mcvSdTeK8HvgcRXoM6ZEJcMJ1UYyZs8Yd	1588	1392	55	1	5291	jwPjjcpJBWHh2ChvQyCtqzWo19RMhcPSXrkSZJ88ekcBREKsGMu	2839	3979	3979	1616655420000	orphaned
5457	3NK7byjnuNmd1DAaGkN32yV6bC3SNKjUcRHcPaaYU7tEqBu5yU7D	5454	3NKhUj9A7fFvHGkqvFCvJXZrMwhoptJP7JPbQjoT5Ju6MuwLUULj	1607	1222	55	1	5293	jxAES6dxjUPemNdXtKPPWh1vwDAwYRJXgdfbmyBoHjopoQfjhBM	2840	3981	3981	1616655780000	orphaned
5460	3NLa4ZH6Uhmtp9nX1Mu9GUnhcgwsxtqpfXE8SHEPmrQG9Foyh8cU	5459	3NKB24efDxYviNgJfwht5iDQMQHoXoXCGN5KfVc9wbXPSxSVoFMQ	1448	1311	55	1	5296	jxFKKN3gVXcD8WYNRMcWGBZKK5Zve2AY3e9i6tdLJDRweX6ATQG	2842	3985	3985	1616656500000	orphaned
5465	3NLv5B2QCLLSCXUokwURDdVXvkV33HWd8PTftN9hbcWQcXMeBSBU	5464	3NKAkn8jBWsDyMErv4Y3w4sTfwzJJxn7ED4byjXvgz6JQxVfGCd9	1611	1215	55	1	5301	jxfb2MonKAjRqEm6SjJT71bTt9ZYnBnYJQDjDc3P9iLa5AicN6C	2845	3990	3990	1616657400000	canonical
5471	3NLWetVJXFCkjQD5FK3G8ek6u72pz1vDFd4ndYbBe5CAZMA2egN8	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1631	794	55	1	5307	jxJM22xePWAUCZ1WHZmMuHc11FWwSi7jXVxpWFqnwaa9AgxQvN5	2849	3996	3996	1616658480000	orphaned
5476	3NLtUzFEryDfAxbX37gXTyzhpAQDxU2SfuNVVpAuW8f3TBYnq2K8	5474	3NKCzKgZHiKFwUi4e526puaMunfKiD6hcPbYKTuu99Lijhibyuhe	1571	1335	55	1	5312	jx9FeAZbBPAuUfD2g4LKHVDw5pyLu5sHBzgGjrzi9XL89inYHgC	2851	4001	4001	1616659380000	canonical
5485	3NKvjeUxQhTVJbhn5R3tWQ52BHyN9Cgei7AhHpu3joLeMVnn7Xi4	5484	3NLfFdwWLrj7ZDjW6369zCa465JXxdqDtNTcqun7x91AQojGsNS9	1536	1313	55	1	5321	jw7cukZkkkcLuJ6h2vFvuEdsQe6URD2FnLz4B6L8PWhZHaLeGQq	2855	4006	4006	1616660280000	orphaned
5488	3NLS4QBRsCw6vbDRU9KoZcB9zDJ6J1ncjLTjZT6244onADmRqb1j	5486	3NLR9Dj3imv3q3UwFnt1LN3b9zt2FkVqUo3ajSU9brU4t11vdJTA	1500	1171	55	1	5324	jy3GfBCBqq2qF5FMsNLFuQgiep9osbW7Woxjb5YYKPXwWFU1JKP	2856	4007	4007	1616660460000	orphaned
5494	3NKAsx9jGHa1bTKBmyDNv7TZ96JMGkFHGQLjtpEA7Ue19YhtBT4Z	5493	3NKYp9wo3HaB49DWWpea4PZJyk7xe9z4obL4U4Cozkd4rRtYuAxa	1406	1393	55	1	5330	jwBvseSbFMRJG66Qkus5sSARELJMzCsiapBFpMdCTCrr9Er2d3L	2858	4009	4009	1616660820000	canonical
5496	3NLtxE5Fjfg2JAt3ZifMRhmTtm9pTLwHmkCwVxLx5LF4CQ1Jd8nN	5494	3NKAsx9jGHa1bTKBmyDNv7TZ96JMGkFHGQLjtpEA7Ue19YhtBT4Z	1406	1393	55	1	5332	jxLfDgSKauEbkFsnGP75ETPvC1fkQdjykh7GmXEEoZNc8NF3enq	2859	4010	4010	1616661000000	orphaned
5501	3NLH9c3nSZ2xrnA5izuwN89ovC2wXq71VpJfzGgqpCe1XcFxrMYF	5499	3NLFy3WY44GrUspede4jAD97BGLGE6fV4bvKHftL4Ju5RYSxZ8HN	1471	1386	55	1	5337	jx4AHEKXXpfWDvYh1myTHDstfGJdc7U1TVrCzhrz8meggGEPEYd	2861	4013	4013	1616661540000	orphaned
5503	3NL71uLQMeoJWAuD62EVa9HVkNsuB1GnEnDmK8E54XMZnsin7FuW	5502	3NKpFjr9aN7HE6UJ7kedAa31Vqi3UYMHzuqEKseoXPVfuvNkWBh5	1643	1053	55	1	5339	jx68CjouVhxMqKVfnw668HpubKqFMHUU3mnDUeUufrywjTB2UWo	2862	4014	4014	1616661720000	canonical
5506	3NLTEBN9hBMd96dyiWYwNU1QfwuFLwTUvxJjG1ch89XFxvY1PtHm	5505	3NLAKWE1Vm6ZHAtAfnsgto2ASaRjroTag37Jfpts8dFgAuXvTTSV	42	1115	55	1	5342	jx19C4TGutDy8z2haZKvUKMXFjda7gmpmd9TWo8p2Rc9HBhFVEA	2865	4017	4017	1616662260000	canonical
5511	3NLJTC8jF3FU72dYGzGUbQ7DrKw6ycmJakxS5jmNb5mTdSCKMxEr	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1406	1393	55	1	5347	jxnfb38Nnwe69NrUCZ6YwtFzoVbjBupYFqaPsKfdPEsGbhSz79i	2867	4019	4019	1616662620000	orphaned
5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	5509	3NLrcwENzBSmgZ6u6BAxDQMdsB71d8vcnM4caeZ3n5GGDuLCHBdL	1590	1174	55	1	5349	jxS66vRUpk4kAbwdqJ35dVKbL49PoYM3tuUv57jYdVVWPAtECL4	2868	4021	4021	1616662980000	canonical
5517	3NLWHHYGauhyS1Pnw5XZFzcL2c4VsYdPosWKNMWig1utu8CDeZsh	5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	1651	1055	55	1	5352	jxDp2FSQjkrbZa8nzPjppNDJZx17GrDEJztK8abTFeTmwGCAYDJ	2869	4022	4022	1616663160000	orphaned
5518	3NLen8L5FnAbGay8cCPyGAFzCQwxvmkzQHEDChYh514y7sBFybb7	5516	3NLsoYy4XatHJJfhJhG7x7EvgKkzjJA4pockBxDXPEoE6mR4nR5T	1402	796	55	1	5353	jxUpSfjfcXEFUqcFji7i48mmWb5nE3Zmyq2RPpMo5uzkPGnJY8E	2870	4027	4027	1616664060000	canonical
5525	3NKqRzRU1WH9n9fYXBWvuej8wz7prD4an7fgiyhG9VddtgCKm6sw	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1643	1053	55	1	5360	jxRgjn3NDvgbw4x5bTh8hMHMXoGHUR4eSmz6XcHqDS8MxfPaka4	2873	4030	4030	1616664600000	canonical
5530	3NKZCiM6J1niMmGuEfFeuoVmWWmULbetTrgo9cYBUbpeEDx49Fuf	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	1402	862	55	1	5365	jxfqRwcsGknD4dKvZKwZttZStSPAz3r6sCsr3KKhS236Q7RRVM3	2876	4034	4034	1616665320000	orphaned
5539	3NLMbAW1iaSS81Q5aCoX7GpDMAWiE4QsoWLxbqCFnEB8Jm7oAGhA	5537	3NKNJ8yBKitgdSkTR1a8RWChGdByqgYeAW9pYLfJZAUH9XxFzzP5	1406	1393	55	1	5374	jwtEMo6Tqoz3CbEmjkmJxTzVt8ZFf3WofpJZvhbzgipxXVVbGmq	2880	4039	4039	1616666220000	canonical
5541	3NKwPk4kHkbVkHGLQooxBGG679uBr9qTck94nvbw3tdfCU95xGgP	5539	3NLMbAW1iaSS81Q5aCoX7GpDMAWiE4QsoWLxbqCFnEB8Jm7oAGhA	1534	1071	55	1	5376	jwHHRGHcBdGXdoSu1UXb7x4pGBmhdPE6YAxr8ZE54JrS92V9h4b	2881	4040	4040	1616666400000	canonical
5545	3NLEkcqo8sK9Mdd8jEFhTPVdqi2Gxo32ET8nysN696xJ4V8JFrge	5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	1673	1002	55	1	5380	jx9JBwiMzHCEk7m8wqAri5HWN2xhnE1ozbEjZPuFs7ZNjp7Bbmt	2883	4046	4046	1616667480000	orphaned
5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	5546	3NKJgSFtANFfYgHroGJpRvwrR86feJSYUEiGrtSAH6Rc8GHkanJf	1422	1091	55	1	5382	jxA3hJ4csZYYLfQ4tLyKZRyoS7fy1nF4a6wi2XR53bi5aXe9Ga2	2884	4047	4047	1616667660000	canonical
5554	3NLLo14i51Hj5xLHQdpU4uBrFmWYQVawQvuP66XZ9mkaFL5kHLE4	5552	3NLqwgW4U8M2YfVsZiMSELLHXBh9dbJMCkZbdwhwmftqxk4hcvQ4	1541	1052	55	1	5389	jwYE4agLd3bEhhK7Nr9wEKzPfqv8AsziZqTYW6RLdwsBYejmtp6	2888	4052	4052	1616668560000	canonical
5561	3NLCdBPXjruD7RzoUiJGurk4EJwDwCFwnyHuiXSc2afN29BFVpPu	5557	3NLYf3ZHdKKKaxjWoosei6u4UQsoYw1yXPyvciMKqZxCHaq5s6V7	1611	1341	55	1	5396	jwfVoka2RxKtLnhqw4iFFsKXeJxvaPctWfxTBC7int9YEZg2knj	2891	4055	4055	1616669100000	canonical
9003	3NKJxDpZPUzWtJ3rGSjPMHytgqjCwCS1BroAegEFMguC7UUuWqRY	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1405	873	109	1	6301	jwsY8Vxy8W5YrCF8ZEqJWLqknDyj2GR75sBBPXxAF6oueHejJM1	4667	6571	6571	1617121980000	orphaned
5515	3NKcUiyzhespCz5nzBHWpu8cmYv9Gbyf3P1SkcARe3pFVmwQAqwq	5513	3NLBmepF2FfPbPpDvcaKg2fuFVHhDFERydiWcMwxFQCxKey2Mks3	1477	1224	55	1	5351	jxyeCSgs6MbGMkoKWpkWwTNSKxZDR3piaveQEcy6vp39sfALsca	2869	4022	4022	1616663160000	orphaned
5521	3NLf21AwQcS2vKNh7WgTdCfaqbbD2xFBk2VmeCGnEQzZ6b6dfsmR	5519	3NLrktb9bBjQKHjJvzC4x7zwdWo5H4L37P51J5bCWRZGRc2gcayg	1657	1344	55	1	5356	jxMshZ1ZdQxKc94yFCc5L7WgH75VbzrLZJ1A6oYPgs3Gh3HgKN4	2872	4029	4029	1616664420000	orphaned
5523	3NKg1knrZiypaqPR4iakHkNydxvGhUpFrsip2yinr9VdBcJEn8cv	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1631	794	55	1	5358	jwc2KKca7wdjiLhbGYWQABTRie6cMKKiA6RNQMZmTxkiFTfmPen	2873	4030	4030	1616664600000	orphaned
5522	3NKnWexJgqaJ4rzAfsXyEZo37A6NGxwbzTPYXzdVfZHsX1XvHxeB	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1406	1393	55	1	5357	jwodi14Y3ekBf3QSEzHqEzxSpbssjxgNsMzjcjVjk9mnFEkELgz	2873	4030	4030	1616664600000	orphaned
5527	3NLa15t7ZXmuWDxibpenYcYtqeozdE6jtutNyviVvkqQHDGTgkUh	5522	3NKnWexJgqaJ4rzAfsXyEZo37A6NGxwbzTPYXzdVfZHsX1XvHxeB	1403	824	55	1	5362	jxVzdpGFSehn12vyrFiafLCqbborfAx9UVWohe8sQqj9bEUvgbn	2874	4033	4033	1616665140000	orphaned
5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	5526	3NLm9wFmuSk6WX9mtVS1RFX5o2R3DhUvqZjLZsAnnukAXPTgnVS8	1637	816	55	1	5363	jxfEzjzZQubYPBaerHQYEtdJQmX2zpfuWEX7qxAHVyVzy2hjB8k	2875	4033	4033	1616665140000	canonical
5532	3NKfF2xZwwryZQgxwCJcn7yN26qdo9chphNke5qaQNnUMTRcaRfu	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	1590	1054	55	1	5367	jwkpVCviFTj8mTRq62Fs2kw8FDB3h44RBdCoXV3SXb5yHKd8nHQ	2876	4034	4034	1616665320000	canonical
5531	3NKHKVoV9CDM6hsXjzErD4cViN5A7aL5HZ3kG5MzcFmLbKzEot6c	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	563	1359	55	1	5366	jxtPncuwgHwgq2to3PNiyxP92KcyimWuDBUyUxFe6dAPmUhfpct	2876	4034	4034	1616665320000	orphaned
5529	3NLhzDUMnZvietREQ9rCYfEpCytFEZRTuZEwKfr7cJyhCbtBFnSM	5528	3NLBkpxVkm1qXHNhafoqhyEWZiRXDfNERwieBh2xjPPpghMQb2pd	1483	1150	55	1	5364	jwqMSBHqGoeCSQWx3dzcVFKCqYQAJQh1dt1RX2r2hBBUmQnFWBE	2876	4034	4034	1616665320000	orphaned
5534	3NL26wZniLDNuJQtPdERyL7UzcgY6NHFBWgAz4zSU4UEaVEtn4tb	5532	3NKfF2xZwwryZQgxwCJcn7yN26qdo9chphNke5qaQNnUMTRcaRfu	1529	1316	55	1	5369	jxbrDES4ibupfyANeFDtuJfRLcitKCLrNFLStehGTZQPiL5xWXf	2877	4035	4035	1616665500000	orphaned
5570	3NKZNFNJPzvX26akJz6pxJTxm4wD9NLUcZU5BEykwJbEqMR3jwMW	5530	3NKZCiM6J1niMmGuEfFeuoVmWWmULbetTrgo9cYBUbpeEDx49Fuf	1403	823	55	1	5403	jxnk2pwgUMmRUsF9rakM9bs6tQxcRjqLcKaLngZ1LSVKZiB4bGF	2877	4060	4060	1616670000000	orphaned
5536	3NKSLJgVXD9pF6mygYWrBijtK4JwsbENWWuhbYLrELSY3TyWXPYa	5533	3NLKpCweKqCeCCCbHuu5Ssx3z7MaeUWX3e24cDfUew7Basx6q7Vu	1577	1327	55	1	5371	jxRhjDr2yuLTbjypBTckz2BksgpSzdM6pcE8wuThUwboQB2HN4L	2878	4036	4036	1616665680000	orphaned
5537	3NKNJ8yBKitgdSkTR1a8RWChGdByqgYeAW9pYLfJZAUH9XxFzzP5	5535	3NLAjocioH7MXPPgcEyTkQyphmiLEKSezQXoX2FHWaQwWB45hZeq	1587	1111	55	1	5372	jx5C6jK5ybNLEUKt2AE9hYRgoFWzmsMskhKCrMMTu2m81WN3qSU	2879	4037	4037	1616665860000	canonical
5538	3NLj4zZGYMXRXCVap8vXg6Vt3z6YD5BDiTeCLYrf3CknRCQeHj8p	5535	3NLAjocioH7MXPPgcEyTkQyphmiLEKSezQXoX2FHWaQwWB45hZeq	1631	794	55	1	5373	jwHC2hAcq27qNAx7PuhWygcWapmF5f6kES7aXZ2WUNsspaAjNbp	2879	4037	4037	1616665860000	orphaned
5546	3NKJgSFtANFfYgHroGJpRvwrR86feJSYUEiGrtSAH6Rc8GHkanJf	5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	42	1361	55	1	5381	jxdyzdokMgRfqDtyPQtY6MGbfxt5xAiJzdZzJMptxSouYUZBZq5	2883	4046	4046	1616667480000	canonical
5544	3NKYsKpMSW6d8cEphKxq7cAbxCzNy1YhtXNad7F9QicMfCRP1SrZ	5543	3NLRjX8sXjpzb7MvPrFVBoYHisHn3ZhD6SajYczsQVp6C7HLhWzy	1406	1393	55	1	5379	jx8ZtUDEDpZS3ARPmLkUytAuBm1RLrFh4DK9RUs6BcmfyHghbdg	2883	4046	4046	1616667480000	orphaned
5549	3NLMEXmxtbKsYorMjmQKe2HutVLZjXM3BjJ9DM4hbTi9seZ5h3Rk	5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	1402	850	55	1	5384	jwPXrD2gdaUcKDe6KNEctpcVL2RmJYV3fDGj3zAypVPvNmnYKJk	2885	4048	4048	1616667840000	orphaned
5550	3NKyEr9JbycR8cgcFnMG1scfkPVEC8Hkcc2fceF7tAvuVDr1KUZU	5548	3NLmpYyKmcoTzdkuo55xAiD3rpLWUb7cSiA9tm7UVErxgRJyeP9h	1581	777	55	1	5385	jwLUyNuTsNecXgSEKrQahhVeHFNH558WebFqi3NN3CWRpb4Es33	2886	4050	4050	1616668200000	canonical
5552	3NLqwgW4U8M2YfVsZiMSELLHXBh9dbJMCkZbdwhwmftqxk4hcvQ4	5550	3NKyEr9JbycR8cgcFnMG1scfkPVEC8Hkcc2fceF7tAvuVDr1KUZU	1553	776	55	1	5387	jwgQFmB85qFcjbwoiaZehRhCJR4PqUQfojFBY5KB5p74KNdQYkg	2887	4051	4051	1616668380000	canonical
5556	3NLsHd2m5g6S7zMm2SJZMRrPYZcJ2vxfxk2zAkXW1zX5VEWfcN5p	5554	3NLLo14i51Hj5xLHQdpU4uBrFmWYQVawQvuP66XZ9mkaFL5kHLE4	1553	776	55	1	5391	jw9QTf8qRQW6rQQymWHHG2x4G15Xei1W4hhMddTa9y646nrprck	2889	4053	4053	1616668740000	canonical
5555	3NKxe5v4A9z6EbKoMxXrD6nfvyaDMXszNK1kN6cZdpjQAhYfJmSj	5554	3NLLo14i51Hj5xLHQdpU4uBrFmWYQVawQvuP66XZ9mkaFL5kHLE4	149	1283	55	1	5390	jxxpZVZtttAN9fGkL9qzfxZqAVos7K3bsmEzmGxBd6RuDVQCJk5	2889	4053	4053	1616668740000	orphaned
5557	3NLYf3ZHdKKKaxjWoosei6u4UQsoYw1yXPyvciMKqZxCHaq5s6V7	5556	3NLsHd2m5g6S7zMm2SJZMRrPYZcJ2vxfxk2zAkXW1zX5VEWfcN5p	684	1352	55	1	5392	jww4X2zSMVH3vhdc9AdX5BQRLfGfcnSJLbARFiLm964QkaoXbFz	2890	4054	4054	1616668920000	canonical
5558	3NLy2ZkiPqRNRzXtm4vcabqkazMzJUVKJNvCpWhQfWcBT668mr5j	5556	3NLsHd2m5g6S7zMm2SJZMRrPYZcJ2vxfxk2zAkXW1zX5VEWfcN5p	1631	794	55	1	5393	jwcf13AEQGeHfweAZExQ5gBwVf8MDsuGk5iJpDfkKX8Q6N9VX8K	2890	4054	4054	1616668920000	orphaned
5562	3NKhhFbL9KvJza3BshhipMGiNJnhVxyVZr8qXZh9YWduKSfa42WG	5561	3NLCdBPXjruD7RzoUiJGurk4EJwDwCFwnyHuiXSc2afN29BFVpPu	1467	1376	55	1	5397	jxHijewwfsNFPee56y1U4un8SLPLPnx3NF6EHgZpxhyjbvzaSrw	2892	4057	4057	1616669460000	canonical
5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	5562	3NKhhFbL9KvJza3BshhipMGiNJnhVxyVZr8qXZh9YWduKSfa42WG	1627	1139	55	1	5398	jxstrTMSQJWsmXU148sMbzXHHiLMD65y2AkCocxyqiPvq2vCGXV	2893	4058	4058	1616669640000	canonical
5566	3NKiujfd9h8XTA1seGDJszQjGAN3KkavH3tGsRWpjWX3337mjiu8	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1536	1187	55	1	5401	jwrTixRZERDavTcTUiQ5wSwiyP12SHJift148GwbwEV3ySEhuER	2894	4059	4059	1616669820000	canonical
5565	3NKxHMou8QKjpLtuJfcszMd3AC3cMaUh4uXbRiR1LyPoQ5HzWLVf	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	684	1352	55	1	5400	jx2PMwgxyMRY8qEDgfW1HeTc1F2QPbVkMbzym63DaNiGkTJfb3v	2894	4059	4059	1616669820000	orphaned
5569	3NKVKTWhTCAjP13RptzHEbsYGNV5pmGwQU5LPZNHLEX9mgox3uW4	5566	3NKiujfd9h8XTA1seGDJszQjGAN3KkavH3tGsRWpjWX3337mjiu8	1406	1393	55	1	5402	jxzEekHsuBZxq6xxDVdzrYk17WBGEi3jVYaiChhmkECcM4JkSUP	2895	4060	4060	1616670000000	canonical
5572	3NLU1FRtYbhytB57dcCqjT3DcKUFdNDMXBdHUwsuMZDy2Bka89mc	5569	3NKVKTWhTCAjP13RptzHEbsYGNV5pmGwQU5LPZNHLEX9mgox3uW4	1553	776	55	1	5405	jwmMNa8AWEVuP3S1LW2NYN535HTxDqasiVVyRXmco4YPmzw5CoQ	2896	4061	4061	1616670180000	canonical
9360	3NKYLVTxLTo3JyMfWgfEcb4HpzHrX6r3hyhkJXF9yMt5brdrFZnT	9020	3NLJ3hE2DyrvZUZqyCF4HAWMYwqsD2Jax8wuyFkUEupGozS2Sw44	1403	824	109	1	6301	jxv5bxyoQV48scxFk3V1o81VDzuCXKbx4gftX6mhL5uZ4VbSU9L	4678	6839	6839	1617170290935	orphaned
9854	3NK7Grzc2K8bWuMf3k1twak5qf4kx1s7VUb75DMtQDn651Xi59Vt	9852	3NLWnFYtNpmXy8uKCLRGnnDJBo4fBfo2qXjBuGNb9ZPwjev9YeHQ	1622	1110	128	6301	6361	jwdtq8bUfnfxNig2n44F7kisrZmLpAUroaogoHdGKv3aYZXedw7	5109	7189	7189	1617233220000	canonical
10000	3NK7eyyaoxycWJ7CR8e9d2Jsjq8SQ4FGPTuCzkbuhXbHXZLmDYE7	9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	55	59	131	6301	6498	jxtyZnQizpAmJe7cXXkNvQabsx6XuM52oP2ZXZJsy34GH6ifSmo	5184	7292	7292	1617251760000	orphaned
10095	3NKijV3Xmetv2Re2a32xL36HdkWsYrGMBKWQ98onfw2W5D8YJYMh	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtLJ6RaMXQHZKEBQTujwyfn8rAatVdDu7bjRXPRJvKa8YGN4DR	5236	7370	7370	1617265800000	orphaned
10126	3NL1FYHiKgR7WKLf9k4WSGbMvVaiPqzKPwcjYpdApD2Ahkagre6n	10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	1467	1376	136	6301	6614	jwHqrkewHaa5KFafQqoTkh6G6SVDufkf6fgYbvApV3cnQxxsdvX	5252	7395	7395	1617270300000	orphaned
10183	3NLXVh1dP2mhTW7neiQbDAzsRANQUPN9bdCVuWz2P43v9hDmoVR5	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1608	1043	137	6301	6663	jxZPPKAHripoqtMqceoVx3zQW9Jdw5sAUS5rgfwJDxpu7xLnjao	5275	7422	7422	1617275160000	orphaned
10180	3NLdY4CuYMGXrnrPTJxTo7z8h81rvB5wUnLd95rgXgKXJDpNKfkv	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1508	1141	137	6301	6662	jxG2jEcHHBtZPaec3fa2Gge2DRqYUUzrAFc1cWsTKpn6j5ZBfXo	5275	7422	7422	1617275160000	orphaned
5564	3NKsarLmXyWGtV2LwCFM61ngDmeyJGGsHsSXfccrYpAWcWdMM3N1	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1523	1321	55	1	5399	jxxSDrpQ7qVee4djNq23YR2JYtbSkkMXTYSmejsZHkUNfvWh5Da	2894	4059	4059	1616669820000	orphaned
5571	3NLQN83qA8TTSGvvP1BA22NfAUBdzhK1PQgWRgWx2HsrpVGfHusR	5566	3NKiujfd9h8XTA1seGDJszQjGAN3KkavH3tGsRWpjWX3337mjiu8	1581	778	55	1	5404	jxVQEg93MQXXFHaXe7fNpcjnTx8LtaPymQj489h946uooCt9Mnr	2895	4060	4060	1616670000000	orphaned
5573	3NLWXLahaPB3hGjicU45wSrqdS9HVFKvTYnAD7H4rezBBUntFBY2	5572	3NLU1FRtYbhytB57dcCqjT3DcKUFdNDMXBdHUwsuMZDy2Bka89mc	42	1235	55	1	5406	jwijDvy7aUMpimaAPy31V9X5rs7Ztqr5dh4wXGewHCD966ot5tv	2897	4062	4062	1616670360000	canonical
5574	3NLHPmX27Aix8JQzpKyiconxZuaprTgRCHVRR7P8nCRkS98JoJLw	5573	3NLWXLahaPB3hGjicU45wSrqdS9HVFKvTYnAD7H4rezBBUntFBY2	1471	1386	55	1	5407	jxmvMZyYjFHANjk7VF9tcQk1rUVZWPSCcyDRRWoHj8VTKcT7AeC	2898	4063	4063	1616670540000	canonical
5575	3NLQeNrEMKe2epoWNcGyjw9agmtU7bQzG8hMd76u3TRSYJxcTKJj	5574	3NLHPmX27Aix8JQzpKyiconxZuaprTgRCHVRR7P8nCRkS98JoJLw	1611	1095	55	1	5408	jwGNdEAnfR2b51wsNqXNXvGaHxoxneqAh4kHpjtegtpmYtkTTBX	2899	4064	4064	1616670720000	canonical
5576	3NKZgjNyAdcxh9aCc6BYCoafeFuBLtc9kfHFXVrvifAKCD9zx5dN	5575	3NLQeNrEMKe2epoWNcGyjw9agmtU7bQzG8hMd76u3TRSYJxcTKJj	1455	1206	55	1	5409	jwtpPs6DGkp89WSUgazZLsb9PDfXfH2XQdbbi7TiErzQ2JCouUe	2900	4067	4067	1616671260000	canonical
5577	3NK6bQzfeAKMmHGB4VFdi2UjfJaQKCaJNyQnHps567F6ytAfHX1z	5575	3NLQeNrEMKe2epoWNcGyjw9agmtU7bQzG8hMd76u3TRSYJxcTKJj	1489	1014	55	1	5410	jwGoaHAzBzcZyRovGqsHWqTzw4jm6zp4meK9mx38u9X2dBaSVEd	2900	4067	4067	1616671260000	orphaned
5578	3NLdpFn9R2j5SoKo644rBK8dERC2jJEFrr669PxMARrfw5FKFdr7	5576	3NKZgjNyAdcxh9aCc6BYCoafeFuBLtc9kfHFXVrvifAKCD9zx5dN	1624	1334	55	1	5411	jx95dqwxT9xAvh2eTvbYEnoYeEhr4ZfxbbiTqKtA8FtR1KSDX4J	2901	4068	4068	1616671440000	canonical
5579	3NLJKshRoZEbjzHLjk3KZbfbh1yjiZYEGrj5fKudBCQcD5ah6nDB	5578	3NLdpFn9R2j5SoKo644rBK8dERC2jJEFrr669PxMARrfw5FKFdr7	1406	1393	55	1	5412	jwAGudB4usjaMoBHbD7d4aQBjSvWUJrYYRNyWcp86g2Fk9MGswW	2902	4070	4070	1616671800000	canonical
5580	3NLfXDxkuhWhtfzp7nQBv5EZv2t1fhUPcHit5kC3WmRymiKu8aBZ	5578	3NLdpFn9R2j5SoKo644rBK8dERC2jJEFrr669PxMARrfw5FKFdr7	1622	1356	55	1	5413	jxJhDCGH5WjNJgKyfkywgeYtwQuPniraGaWK6azQtMSAmowg3qj	2902	4070	4070	1616671800000	orphaned
5581	3NKhbdWi2bZVKNSir4KZ9YDHVuTdaLhRCMieS9GUndu512u7qftY	5579	3NLJKshRoZEbjzHLjk3KZbfbh1yjiZYEGrj5fKudBCQcD5ah6nDB	1483	1276	55	1	5414	jwuPDibWx1HYAmHhvHUKCm4AxxDUz6AJs7uDY8on5D5M21wJvyf	2903	4072	4072	1616672160000	canonical
5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	5581	3NKhbdWi2bZVKNSir4KZ9YDHVuTdaLhRCMieS9GUndu512u7qftY	1588	1392	55	1	5416	jxoJeppz9LjxrJJ4LPS6tUn21vxNmufWanHUVwYzu7inULzZw3n	2904	4074	4074	1616672520000	canonical
5582	3NKu4GEtpEZyiKiS2BXYGTEjc4XNHnAc7iaoL3C5aCut4QuNrKuk	5581	3NKhbdWi2bZVKNSir4KZ9YDHVuTdaLhRCMieS9GUndu512u7qftY	1406	1393	55	1	5415	jwAkAu7TGuFSRhVLgdgkMwppBic5SABSFsGXNWfKbn7AFhPwMN3	2904	4074	4074	1616672520000	orphaned
5586	3NKgvLDWGyAGQg1r5sGPzhy8W3nzzDk2Dy4HbRZS2Yd1JMDXwUFR	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1562	492	55	1	5419	jwARkRF8gWAfW3Udzhv8PDZveCms7co1r8JhzhreMgiPSpqBPvH	2905	4075	4075	1616672700000	canonical
5584	3NL8jDnbPPmoNYEMNH2L8poRwQUtiyewidYqdcztsQbUxxWexPBp	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1523	1321	55	1	5417	jxDc76TMwdEuz1EVgqKyTYVnBaVbwwwsJLFKZ3VEUsrnymE4Nra	2905	4075	4075	1616672700000	orphaned
5585	3NLgaCPszCCi5axzJcopQHA9YBJv9nT6araanALdyjdsBTTWBZbr	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1402	810	55	1	5418	jx2dyZBvXEK1jM3Ww67AzE4iE2FTipynH9HTvv3uQApc9etKj47	2905	4075	4075	1616672700000	orphaned
5592	3NLmHi7nHfrWWJxy9NqQFGKVxHnhzRfxGcUDVwxTUUFuZwECxVnP	5586	3NKgvLDWGyAGQg1r5sGPzhy8W3nzzDk2Dy4HbRZS2Yd1JMDXwUFR	1428	472	55	1	5423	jxVoAT9FpRnLrxo5gdTGiQj7JQL8bhH63FWLQX7c3jxsQhrkiCK	2906	4076	4076	1616672880000	canonical
5593	3NKZ45XhJd4TU5f3fSYLHNAoCHnxZQLbbur5kZ9zpzgpBhJBuDWN	5592	3NLmHi7nHfrWWJxy9NqQFGKVxHnhzRfxGcUDVwxTUUFuZwECxVnP	1406	1393	55	1	5424	jxAv6iDbffJKYetiK96ur7iY2nsrRv6PHWPzNybBD4qN68wQycF	2907	4077	4077	1616673060000	canonical
5594	3NKXHm2T3N5kvZXHPSZ87YhT7hKrwshkwrMVpsqwnaD4gnCaqS7c	5592	3NLmHi7nHfrWWJxy9NqQFGKVxHnhzRfxGcUDVwxTUUFuZwECxVnP	1602	1003	55	1	5425	jxAzhFm13eRzckyv8cDjS5YQixVPVffwSz952P6cRk8PbBdXcsw	2907	4077	4077	1616673060000	orphaned
5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	5593	3NKZ45XhJd4TU5f3fSYLHNAoCHnxZQLbbur5kZ9zpzgpBhJBuDWN	1490	1274	55	1	5426	jwhELnCq9Jpciefuzm12joRaCFXMixRRuKShoLMKCAQAGCCAZrC	2908	4078	4078	1616673240000	canonical
5597	3NKjg1FuhuRMFcqSjeYzfQcnEdhvoeG6iwkHnpn2CvncXV5DViKr	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	1547	1378	55	1	5428	jx6CFKSqm6dPohvyD4ULTpGjxopA46Y6J4wtnWZDLqJLk7j8LWf	2909	4079	4079	1616673420000	canonical
5598	3NKbbdmud51eNTrzefcRBi8319kq27wHURCoEK8WLbqnjPdbR1py	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	684	1352	55	1	5429	jwaiSw2UKp6ajTjRVTyebLkqufX1YGJ77VUiZ79WYbKUJqdPwgQ	2909	4079	4079	1616673420000	orphaned
5599	3NKGDGnNTfP7hrWKsXQP8o8afuhsspk1LhGxCjXitTbsZUw3zuQN	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	1651	1055	55	1	5430	jxxWhUJCGLiZMoTbxJLFKyFnzv97Ki6KVxEJKnUnzwNk8WUyB4X	2909	4079	4079	1616673420000	orphaned
5600	3NLLyqri54FUE7LdwbGq1jCgx4ZVdEG4BVJchL5uX19AcPTohVJk	5595	3NK8ZsZY3h1NqKmTPHRyZoTuoBb2V7GaoV27WyGLirX1BM1CCvPK	1651	1055	55	1	5430	jwqA5KJoGpikGRzQiModyz8jTE356fGuQnavqvTwYwo46RqVEqo	2909	4079	4079	1616673420000	orphaned
9291	3NLw3EMxXgy1RahZ17N88MQmH1wRYLNQbkPgAzmZjUJ98ukRDsM6	9030	3NLJSR7fH3zfJTQY6qZ89yzuungkr83ZitoooRYjXwM2bzxH62FS	238	238	109	1	6301	jwdsXHn6cxvynHR4jcu8EbETH9dvxFAmxsqrTMZ4K2KDGh7VaLA	4683	6784	6784	1617160320000	orphaned
5641	3NLfT14A2iEGzJnWLNuT2wkkXZNgvYwh8HwUtJCyqL6AzXUaRoYK	5626	3NKxxW2eWBmCQSbNcoeCB6VxxVF5ELye28DzGhheYQQenatNDsrd	1407	1395	52	1	5467	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2723	4107	4107	1616678460000	orphaned
5601	3NLQUgVL46irAnfzr5tJDmwhj4g3EWFLrniDAFkcQzbDYh4YFevv	5597	3NKjg1FuhuRMFcqSjeYzfQcnEdhvoeG6iwkHnpn2CvncXV5DViKr	1402	868	55	1	5431	jwixBXNFZuUzZaiVT6T1uqyxxPtkngKVA1LAPZ3Zq2dvwg4gbrh	2910	4080	4080	1616673600000	canonical
5602	3NKUfrgdcX96Q3xDEQWsHwDAnoNm9SqVuKb8EQrrCcfHFQi3NhY5	5597	3NKjg1FuhuRMFcqSjeYzfQcnEdhvoeG6iwkHnpn2CvncXV5DViKr	1637	816	55	1	5432	jxDVPRzeY7G9JRT6A4gkFeyserYZgHBrXUpJ6MR6pn9BTcXAGEW	2910	4080	4080	1616673600000	orphaned
5604	3NLSQox8VrnkVPAZmBdTTrGRwZKSJLjEedzmzeSysj83A2nAAsET	5601	3NLQUgVL46irAnfzr5tJDmwhj4g3EWFLrniDAFkcQzbDYh4YFevv	633	1384	55	1	5434	jxFZAYj1ea19zCBDReTgfSX1kas6tpHTpj3BtsMweoq2mFfAMUH	2911	4081	4081	1616673780000	canonical
5603	3NKy5wu4cAhXRxbzrL5yW7cfCFaityD79M3hqDvzNHxPH76DnSeE	5601	3NLQUgVL46irAnfzr5tJDmwhj4g3EWFLrniDAFkcQzbDYh4YFevv	1503	1277	55	1	5433	jxN1FLj735PAGVgrwuSEm8ZBQbexxZvgM5wvT971mTqcTab1aHR	2911	4081	4081	1616673780000	orphaned
5605	3NLSXQjtPLVhGrqgbqdTQhDvmz8iM9yPfKp8tLXPki1pZgx2r9P5	5604	3NLSQox8VrnkVPAZmBdTTrGRwZKSJLjEedzmzeSysj83A2nAAsET	1541	1052	55	1	5435	jxDEbkThbYQJW2QUySGUhVjbPMUvmMrmAaVgU61D4donyPDAzin	2912	4082	4082	1616673960000	canonical
5607	3NLDhzyQUuUAAvr5VgdHJAp9cwQUW6FXHxxfXxB3FoQTvow8pfii	5605	3NLSXQjtPLVhGrqgbqdTQhDvmz8iM9yPfKp8tLXPki1pZgx2r9P5	1448	1065	55	1	5437	jw9wMyyxHc1aqfWytE27ysg4WKMdBTZXAUR3RQYZk1ZkER9xH3Z	2913	4083	4083	1616674140000	canonical
5614	3NKS4EWdXVXrtzyWa4386WUL2Epnjj7wwiR2udGmZ6unZVutkTLd	5613	3NLRxEWED1GrAzzSvHLysoWkGdMTwwHxJ9yGDLkoUmgz6NVBFp2z	171	1374	55	1	5444	jxoUWdL3fwYhoS7zydzCTj2PCVBEMXunnrwhj461yqGhYSDJTME	2916	4088	4088	1616675040000	canonical
5620	3NKSLUtZ6g189GzDoc1bmi1v5HHXkjRNTX2SBqnNgiL7Mt1sYWch	5618	3NLp3UZNS3HrcAa7HBzmLkqKHPf73vRwPGHiQj7uV85J3iLENxU1	1553	775	55	1	5450	jwTH3PnfdcAmo9tsNYjjUKQfVhQHQABVoq6hQ1cPbwFdhT3Sps2	2919	4093	4093	1616675940000	canonical
5622	3NLK4YWuAWkkfhUe68iTWdRLBy2VacACDeYZCZD9jL5Pfmj235DT	5620	3NKSLUtZ6g189GzDoc1bmi1v5HHXkjRNTX2SBqnNgiL7Mt1sYWch	1534	1191	55	1	5452	jxXCzX5oJHqx5XxFqcm4BaMTtQ29azqWJmRfRAAFyBNqV9vD7hZ	2920	4095	4095	1616676300000	canonical
5625	3NKkyeYum8Hj6SAJm1gYamLuDuim5jjMJ29UjB1fdjPY6oTebusf	5622	3NLK4YWuAWkkfhUe68iTWdRLBy2VacACDeYZCZD9jL5Pfmj235DT	1571	1089	55	1	5455	jxUNdsZjCMKd2CCv6peHvrZLtAMBufFGCyUJBZaRwVdpvv3Zo6y	2921	4097	4097	1616676660000	canonical
5629	3NKKEwdziRdojutCPLNTkXtKA9i3qAUQw1fBgSzHo3e4Yi4tb8SL	5628	3NKFHng472qWdCHwihKj5JKLqof6chsSmAst5RG9Whxi5gahA5k1	1637	816	55	1	5459	jxDY5KpvSv5YqDw6e5Xx9xRruRR9au2EnA54rZi32ZoFEbR72WJ	2924	4100	4100	1616677200000	canonical
5630	3NKRp1RyPbM3dv8BuiwvcgWGt823rm2ue3uv8HAHMDsuHX7oGmpu	5629	3NKKEwdziRdojutCPLNTkXtKA9i3qAUQw1fBgSzHo3e4Yi4tb8SL	1593	1346	55	1	5460	jwWjFvLmipFYxHiM6JaTp1YHgqh4DawTLpqSYAwbsPFHLrcguxD	2925	4103	4103	1616677740000	orphaned
5632	3NKhvdBJsH3PQ5kF6r8bMfF8KnWyEQwjWTgrCg5BJHSvWg8nDLVr	5631	3NK78RAwyZpRkFEC9Jf7HSV678K9vs3xEc3kJ3XG95caBgLStdeG	42	1361	55	1	5462	jwy2xmeuhGNfZ8FdfSMQkEGV1RoJfBcMHM9PaoDfLSoPNKqfTCS	2926	4104	4104	1616677920000	orphaned
5638	3NKq6xtzXGZKoGCHJEsk1HSxy88p9n45fw29WigPFEsDYJUGnpaf	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000	orphaned
5650	3NLyLBrccqAUUmB2Zk5A6hbocpj4E3wHLJ71YrEUd6GBLG39pLgM	5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	298	1182	56	1	5475	jxzRxp9Ez6548E1iKeTdNyc6NaatgxkkHJakK1bbmAY4u54m7jv	2932	4112	4112	1616679360000	orphaned
5660	3NKG5i3m8Efe7BL5vGAnTWdJnxDDUEtYYFTkxDfd33pEucnbxn7E	5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	532	1303	56	1	5484	jxsNSthWdtrPMbZTiJGo4YqmWBpmt6tdA6wd3jEveK41b1LutKE	2935	4118	4118	1616680440000	orphaned
5662	3NKUMKsvC4SXsZakdQxBNU4NRG4rdvxkMyktzMMKuYkDkWMBuiUp	5659	3NKiA2LHmkUYMyBQ3R57c1gEryURV4kPYejPsEwXtaFz3ngGHBKy	1593	980	56	1	5486	jxWRg9nN35bJv52W4JaKeHAkcej1pCBbpokDudrXssypKcN1nJg	2936	4119	4119	1616680620000	canonical
5664	3NLM3bF7d9g12qB4PRvkxTfxX1cuHtz3T3ATnTwbezLybQrQk2Ts	5662	3NKUMKsvC4SXsZakdQxBNU4NRG4rdvxkMyktzMMKuYkDkWMBuiUp	1601	1022	56	1	5488	jwLU52w1Lp5wCY5T48YDakRhUoJTrkPDkxY5BetgioK71yCAwpj	2937	4120	4120	1616680800000	orphaned
5667	3NKBgzbAJbNG9tJvkrE4KWEj3SPHzssuVW6uTCnrMFQzfmCd63RK	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1581	778	56	1	5491	jxvFCNiLMU2BMt37eYdv1pCHT2F23FQDms4PRA9V6o3hTUAArXN	2939	4123	4123	1616681340000	canonical
5671	3NKWYmp6EL8TxCqX7ebjVRqsR1pxbCGZgXwzpz4g2i6XT4YxNCWJ	5667	3NKBgzbAJbNG9tJvkrE4KWEj3SPHzssuVW6uTCnrMFQzfmCd63RK	1602	1243	56	1	5495	jwSDULztAnw7985rGqbSYXqxa84WgRnyQpqyVZWoCvMy7wXhSN5	2940	4124	4124	1616681520000	canonical
5682	3NLqhiYKFp3iQNk7fUsd2nGyDxYQwwfjAphYao9oMFd2Zy2aDxvw	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1549	1116	56	1	5506	jy2zL6dkkEPquemvM9ApUHyASWdXwyPbUVUG1oNgipWzFxunGg8	2945	4131	4131	1616682780000	orphaned
5686	3NKtqmjCj5xvSsSDXKynmoMEzGN19XfUbrwn3qJgGePSkpGssc6C	5685	3NKRMwQzTuUE5VSsXMS27tCLUXMNupyPh58dfX8WxCcaDTs9Vfn2	1406	1393	56	1	5510	jwh9LaCnG8PR1akBLobgrSyR1eL6Zsi9XXWk75thMbpqDLyF2ob	2947	4136	4136	1616683680000	canonical
5689	3NKxXQTsg57Cy12Eo4CVeV13tRdLAc11gagGCvLcEhD7a3CAu8Zu	5688	3NLPv51x3PaLjj6M4Cd8Sgy4EaQ77TYqzcw2vPAdf9dhBJaM2zjN	1581	778	56	1	5513	jx11dYBYh2RuZJJVXksT1yy6z34C4T8Xv8tm5ybn5AhtHJ1YeBw	2949	4139	4139	1616684220000	canonical
5694	3NK3WxXA5jMggKtv878xNgCiaozT54aGvrkYVFwGtNDEFpsUBnub	5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	1564	1212	56	1	5518	jxhTTnbfFWE8qiryLwgVPsGSUtcdE4YscpxoLe7951v8FKAd5hy	2952	4142	4142	1616684760000	orphaned
5696	3NLvZGCEWPfDwwGETU1xBT5LfeumUoRMoecUukt13D6NAK8Vm8eN	5695	3NLhETpWyRc74KJh2apxcyB674Msa6DQ9xnjMVQvGjsRAj2MjdLD	1534	1071	56	1	5520	jwNnBPpwN23fP5c6oQR1dFVbqmf9Ds4mRJ1Pg8BRFb5LSRvXgmH	2953	4143	4143	1616684940000	canonical
5699	3NKoeGngWTqSFKeiFpfm3yQAkzN8Vr81ijqenenmi5Qjgw7Xuqd1	5698	3NKKdSTTMSkXUjK9DeM27CexWLib4f3VdP24sUhcWEZKHqsrkymV	1600	1126	56	1	5523	jx2dHNhH8CiWziqhZBVyPWcaaB4cGDsu9YdRCva4MoUuC9J7WFh	2955	4147	4147	1616685660000	canonical
5701	3NLpUCWsyJtkZjarbj6JxjPBfNuqPaaYtLKvCxQFUKb1kzC2i17Q	5699	3NKoeGngWTqSFKeiFpfm3yQAkzN8Vr81ijqenenmi5Qjgw7Xuqd1	1439	1279	56	1	5525	jy1VQWLcZTesetaWGhGjt7AKH449VhR5651BQyFh9oN4v9MwscA	2956	4148	4148	1616685840000	canonical
5704	3NKA2m2n9Ms2Zjnqqzrr6oPhH8yxCm3r1znSFgjFt1mFpzvD7LGC	5702	3NLVRhS6294KFXCxC24vGu3TJSsAGpeZa4eLuBucXe1fJRqBgVJH	1601	1388	56	1	5528	jwTu9GZWLSr4oaw4rGaySU3aSZ4bC9Tz5wSXNLiyKXfrAeQsYme	2958	4151	4151	1616686380000	canonical
9046	3NLgC5Narzcb1gj5FmLSbX244jw8s5VqmivEhuz1K1s2XtPciC8o	9044	3NLTT25hAbPy5Q9VvpeZ3yXMQNq95sZrm8gPCa7doxNL4sxzQx9G	1406	1393	110	1	6301	jxo8V4b81MkXbXTptrNzgBLMPfrgHPHLiBs6tcmsMFwMEs7qdzF	4690	6602	6602	1617127560000	orphaned
5644	3NKnGnbNHoASDCwp6DSJEPLudJqXK38AY3vtX57wSZgG2DfQ3YkK	5641	3NLfT14A2iEGzJnWLNuT2wkkXZNgvYwh8HwUtJCyqL6AzXUaRoYK	1407	1395	52	1	5469	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2724	4109	4109	1616678820000	orphaned
5721	3NLafBqsf63d1SvjuTftGBcutY8BZq9V9YG6oCa7fH4NwPxKpMk8	5703	3NLgiPedotXbjLfBVF57ke5w1MyHcLWrN6SGtWZEqLQzKxNdv9fx	1407	1395	52	1	5545	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2728	4163	4163	1616688540000	orphaned
5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	5607	3NLDhzyQUuUAAvr5VgdHJAp9cwQUW6FXHxxfXxB3FoQTvow8pfii	1637	816	55	1	5438	jy2CBWQiAJiUx5SM74K62EVTR3vefP9S5DLXqYkjznZTUMGc2kC	2914	4086	4086	1616674680000	canonical
5611	3NLPVoRf4gmzHxf9KS5fXJSabzusfVNwYsEKbsWGywi95oGXEYYz	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1406	1393	55	1	5441	jxTSpXGdnsNREG4hNMv55gvztpvTuhmpTuaM6qbTqJB7JNRqkrr	2915	4087	4087	1616674860000	orphaned
5615	3NL9GktPNJmmn8NnKiuzQSZyNkG8aNbT2PmyoyURyZmkxws6TCEh	5614	3NKS4EWdXVXrtzyWa4386WUL2Epnjj7wwiR2udGmZ6unZVutkTLd	1564	1338	55	1	5445	jxhCJhEP6fD7ajL356LjYXWxn2T7E4kDGNSRBusRTDRD4MzbE7B	2917	4089	4089	1616675220000	canonical
5618	3NLp3UZNS3HrcAa7HBzmLkqKHPf73vRwPGHiQj7uV85J3iLENxU1	5615	3NL9GktPNJmmn8NnKiuzQSZyNkG8aNbT2PmyoyURyZmkxws6TCEh	1553	776	55	1	5448	jwZbGbAU553butcXfsWmWe8Htva5Ht1R6aH3TDEZQavczYCn6qE	2918	4092	4092	1616675760000	canonical
5627	3NKtCgYKaC5Y5fPLxmuvTCA737bDXubRDkdnP4xdeQ3BYu5NbqJ9	5625	3NKkyeYum8Hj6SAJm1gYamLuDuim5jjMJ29UjB1fdjPY6oTebusf	1527	927	55	1	5457	jxWfWttQQSEHKZkS2XXQw7FNKCU3BqGiT4HmVHfo3ha7wm59fPW	2922	4098	4098	1616676840000	canonical
5633	3NLcgLKR8RTsp5FPXhPKkZeM8p6u4NHHn56YzhVbkpHAocCJPPn8	5631	3NK78RAwyZpRkFEC9Jf7HSV678K9vs3xEc3kJ3XG95caBgLStdeG	1406	1393	55	1	5463	jxH97xNkGbvoEj1KonZ7uURmYjbvinFv9dYkTC55B6J1rNvWWqt	2926	4104	4104	1616677920000	canonical
5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	5643	3NLTB91xUxmdip9vY16ncQzXjgxKnW4mv1f5nsMCxTHvGJndFstr	484	1319	56	1	5471	jxRQWkQpbHgZjaCPH3EAmmig56HhSMvxvQ1xvu1TtG6x5v2hbPd	2930	4109	4109	1616678820000	canonical
5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	1455	1332	56	1	5473	jwM8wvBP2tAm5sV17Q2Zz6EEJt5t3GFjtavU9AQkgMhV5mCUBAr	2931	4110	4110	1616679000000	canonical
5651	3NK5cqjn5fxFCjjL3ZLADP6oineJnkXqctpjdbJdvSCsJASKtqKP	5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	484	1319	56	1	5476	jwJrVxYhtspM3uLhpNvUmpdnKrRK42WHGFQSnRPQ9GaLPcTB7kF	2932	4112	4112	1616679360000	orphaned
5653	3NKrFEFPE84auW8iU7hWinSdMPHWsMYJAECA2Uz9UcJeqvjKsRJb	5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	1651	1301	56	1	5478	jwQD7V3XpkhHUnaLxRcdoA79tGFPMBphjCWz4bLZAYWKAfFrHS2	2933	4114	4114	1616679720000	orphaned
5658	3NKofkwR6b5vtn76uxg4n7wtVvXHU3PUbyuGaaqQPAaa9fYsikdZ	5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	1670	1282	56	1	5482	jxETq66g5KLhvxLCAckCAmWZdAYsG41vago87DmpbZZXd4hWafh	2935	4118	4118	1616680440000	orphaned
5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	5663	3NLig7x7X2MVhL3cnsRyPLZg8W4H12BuaQ7YBDR1xvip96CHaXvX	1483	1276	56	1	5489	jxBTJH7BZgXNGHYkLSmD17hXDnJLC7izZZsJ3TrV6fhyV9g1qkH	2938	4121	4121	1616680980000	canonical
5668	3NKndZ3AK8isADPacEogccfaKzGX1kQacFQLvYTZwWU7FoY4Jv7x	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1616	2	56	1	5492	jwuLGAuDQT8w69LFuavF68BdmP5C9xFCSiGe84ZzbyLQuBzgR4c	2939	4123	4123	1616681340000	orphaned
5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	5671	3NKWYmp6EL8TxCqX7ebjVRqsR1pxbCGZgXwzpz4g2i6XT4YxNCWJ	152	1204	56	1	5496	jxHo6ixovJ5w3em7cCVc35zrCpDo8SDCvEZqY4PbcDzVfoS3GJE	2941	4125	4125	1616681700000	canonical
5674	3NKcSufrh4nAMdTxECqJPXqqa1q2YvPKaLFtBzsuRoXzuJKYTfUo	5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	1652	1315	56	1	5498	jwKoWoj2m8j9V2Y5VJKR26U7auLBTabRaWudPHh8hx1ka97a9nF	2942	4126	4126	1616681880000	orphaned
5677	3NL7qtDxtZuciQY1fhyDxtHcpiPXxqCRCSnNnmsS7EX1F1q5Vu4j	5675	3NK3CHd2XLjo94BFkppFuNv8NJxjUXvFuKXVLt1vDkoK3f1puvW9	1549	996	56	1	5501	jwGUhJNLa87fMY9XsoU2vFoTGKeLeTsa3UPvPrbrNMHEek8jkJ9	2943	4129	4129	1616682420000	canonical
5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	5677	3NL7qtDxtZuciQY1fhyDxtHcpiPXxqCRCSnNnmsS7EX1F1q5Vu4j	1529	1316	56	1	5503	jxgegH3QyN1XyjCJ7YASmEpBzeC7tP3waLegaDxTZWdvQYrW5qn	2944	4130	4130	1616682600000	canonical
5683	3NLZwHAEkjY5CFzJA3XNJzB6a11YD4gqDCDRv5DCWHk7m7ZTZ19S	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1623	839	56	1	5507	jwicFXnTtdJk3sDUuLWnziWdhmFJef8TwxScKD7qnadQoDapLZT	2945	4131	4131	1616682780000	orphaned
5687	3NLTU4gAHKvPRt95nBXUdgoDtEPQ5zcFmNyjthJjKSFrhL7rRR2p	5686	3NKtqmjCj5xvSsSDXKynmoMEzGN19XfUbrwn3qJgGePSkpGssc6C	1553	776	56	1	5511	jx6YXiMt4nYCr5Xsn4w35xB47tkDDBjsngNRRhNxjPPpvgTVyq7	2948	4138	4138	1616684040000	orphaned
5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	5690	3NLXYFxMrd81bgHGHxTBWHJADvE8j54icJpsQzR1EsCPYvqJYxJz	1559	1353	56	1	5516	jwCuFtu1GpCvbJKjHbtiaeU1VmS4NpUyA1kTiVvV186ggS33y65	2951	4141	4141	1616684580000	canonical
5695	3NLhETpWyRc74KJh2apxcyB674Msa6DQ9xnjMVQvGjsRAj2MjdLD	5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	1440	1377	56	1	5519	jx3MjstxJubTXLxHT5ZSTR9cQ6udXmMM7nPcUi9Z6164F61ALSr	2952	4142	4142	1616684760000	canonical
5697	3NLHEgqWA6HHP64u9PmL49KbFpnuVr73s2fKc1GWU4VqUg487PP8	5695	3NLhETpWyRc74KJh2apxcyB674Msa6DQ9xnjMVQvGjsRAj2MjdLD	1673	1122	56	1	5521	jwYSjvgjFRfDUxRTqULyLA1468DsKXa52X2Du43j9UctGSdnGLs	2953	4143	4143	1616684940000	orphaned
5700	3NLLftA3Ue3tT9pfVtY5tABUX2Qtf1DoqG12tV1qM26iPPiuzQMB	5698	3NKKdSTTMSkXUjK9DeM27CexWLib4f3VdP24sUhcWEZKHqsrkymV	1585	1000	56	1	5524	jx1JA5cJdk1dLQTgVzdES44SMMqanpBxUxGPZFdS4AAKo9LeMa9	2955	4147	4147	1616685660000	orphaned
5707	3NLBh7QaziKKnzoe29i8yzihhvqtrBoq1efZ4av3n9V3LMVcpCag	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	1448	1311	56	1	5531	jx3v2eMT27J2jtF9VkhrcXpyVXszhxHsaAtFDHxf4LvdGN8PseW	2960	4154	4154	1616686920000	orphaned
5712	3NLB7gDoKFPcNUVcGtCJotqKo1pqjydwg8Fpv5yYfykF8cBAi3AM	5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	1648	918	56	1	5536	jwittKgLRymmzPZSkTh2Lte5RPjUWccxoQHfek6AZqvtxymYQCB	2962	4157	4157	1616687460000	orphaned
5716	3NLpCNmqDi2HQ2UWLDwbLoijfxXBWsCQWEWDDc5wdGvU7veiJngm	5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	369	1186	56	1	5540	jwjsJYgREUD1NjLDbQ3kMbsjDs4YMQns9awB9EQ1aHWXRZ92P5h	2964	4160	4160	1616688000000	orphaned
5724	3NKmxd1nkPZaZ9Xpuz4i5sj6CWj8jYg7ETUaDCfnRivbMA9t12Mb	5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	171	1374	56	1	5548	jwsJYurYDqkZZPt3bZkZqAj5U9pYAczptLm6nacZ2kH9uUipgTY	2966	4163	4163	1616688540000	orphaned
9056	3NL7EWfKzifFrNq3Lazcb3B6X7VPinwD2vFuKhwTAmpMDKwDDsgb	9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	1559	1107	110	1	6301	jx5XukvPamyAoh1x1Ro6HCmyyWvB6Xx1eW1VTgiVYcBKGpgu91a	4694	6611	6611	1617129180000	orphaned
5661	3NKwxh3mEsg54UYRRJ3NdE1XebGXCuQ8LqquW984bP2uoQaM2ZKf	5644	3NKnGnbNHoASDCwp6DSJEPLudJqXK38AY3vtX57wSZgG2DfQ3YkK	1407	1395	52	1	5485	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2725	4119	4119	1616680620000	orphaned
5670	3NLSp8M71A8MsD42tqawBbYn9xGzaqWQFXYgtGtxf1bGbih7Dst9	5661	3NKwxh3mEsg54UYRRJ3NdE1XebGXCuQ8LqquW984bP2uoQaM2ZKf	1407	1395	52	1	5494	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2726	4124	4124	1616681520000	orphaned
5656	3NKhcsRjRfsqKmdtwuXUThtiY87ENRapzJ9DvxutDkJkYW9BMDy4	5432	3NKyUnZzRaubMhoGE2XMS9qHBfuoXm7eQvuxcbZ4B1H6TLdsbMJF	1419	814	54	1	5480	jwDMsobo5StnPM2qzjMWD2hxArETZ8ZL6SPLCcmszinA7g6xZWb	2814	4115	4115	1616679900000	orphaned
5725	3NKJ7yxUF368DihPkdUwqkk78N54j8eAxTUpkqTwoMrLcHXgquaJ	5656	3NKhcsRjRfsqKmdtwuXUThtiY87ENRapzJ9DvxutDkJkYW9BMDy4	1419	814	54	1	5549	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2815	4163	4163	1616688540000	orphaned
5678	3NL8qySBD5VDwT6yroGeXDb2RiRsWf1mAy8WgFsnV4V229fFXGE1	5437	3NL915JihActZ8ddHbd81mGXK4DXTqCuWqEMiqJx6fcEfbc3BxGg	1401	231	55	1	5502	jxq8Kw92mKtgeyfdEzoN9tsCkgjFmn4e6z8V8tafhq4edJRzAij	2830	4129	4129	1616682420000	orphaned
5609	3NKZgMz5xnPEvrqFzyseZvmNo5VfikC8AQzRczotnEw6kL8w8PVE	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1567	567	55	1	5439	jwiAFw8cuKgEAQpBw9KjKS7WhMRhfU7GrSu8v5jNq4YJrB3w8Ce	2915	4087	4087	1616674860000	orphaned
5628	3NKFHng472qWdCHwihKj5JKLqof6chsSmAst5RG9Whxi5gahA5k1	5627	3NKtCgYKaC5Y5fPLxmuvTCA737bDXubRDkdnP4xdeQ3BYu5NbqJ9	1406	1393	55	1	5458	jxoVaVVM96B17VAp7zftHwmWjQnVAnE1tS4zwUT4EeeYYRJQFqU	2923	4099	4099	1616677020000	canonical
5631	3NK78RAwyZpRkFEC9Jf7HSV678K9vs3xEc3kJ3XG95caBgLStdeG	5629	3NKKEwdziRdojutCPLNTkXtKA9i3qAUQw1fBgSzHo3e4Yi4tb8SL	1508	1387	55	1	5461	jwaMpSFNaeVf4myXPi2cKoL6VD7kwzXZ6M6u2ZoMGHgW4yPVzJd	2925	4103	4103	1616677740000	canonical
5636	3NKjjLdcV7jTsLkV2gknxZ5Xir9u69HyZcmLfVNZvyBTEM4KVaGj	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000	orphaned
5643	3NLTB91xUxmdip9vY16ncQzXjgxKnW4mv1f5nsMCxTHvGJndFstr	5635	3NL7grRDyy5D8REzHktayndAsodAqx5sSczB9nVN1QWxy9wTnSLv	684	1352	56	1	5468	jxXJdhpgZAKfCMnYZT13LiMDwHzKtaxdjCEu8mEkbQRZNKH3iN9	2929	4108	4108	1616678640000	canonical
5642	3NKaPnQRDUMejVTRHgZRCHowZzhNeHEe7pZswWQgGWnRUCcmxJzx	5635	3NL7grRDyy5D8REzHktayndAsodAqx5sSczB9nVN1QWxy9wTnSLv	684	1352	56	1	5468	jxXJdhpgZAKfCMnYZT13LiMDwHzKtaxdjCEu8mEkbQRZNKH3iN9	2929	4108	4108	1616678640000	orphaned
5649	3NLU3KshZgw5NJkRhtxMDpcNLEs4rJ3Rp71GyGsme64zm6iYPJv9	5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	1516	1294	56	1	5474	jxnZ97MMXkA3ytbVV1QhJ51bxMqrhGDEHSjyDqYYw5q1otnYbGc	2931	4110	4110	1616679000000	orphaned
5654	3NKbFPK4uNFTAyJss1RRcBnNitfnPibaQ3d4t7nsjLXXSSBMzHbt	5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	1633	1390	56	1	5479	jxgEzBZuAchHsna3gxPdg6TQKCupHX8Y4Y9LorjvzaAAsqXZVTk	2933	4114	4114	1616679720000	canonical
5659	3NKiA2LHmkUYMyBQ3R57c1gEryURV4kPYejPsEwXtaFz3ngGHBKy	5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	1457	1391	56	1	5483	jwKj8o3zzgth65RFCU3Ntj9khGLEhxAS6g2XrTGYAFRzgdAyo2w	2935	4118	4118	1616680440000	canonical
5663	3NLig7x7X2MVhL3cnsRyPLZg8W4H12BuaQ7YBDR1xvip96CHaXvX	5662	3NKUMKsvC4SXsZakdQxBNU4NRG4rdvxkMyktzMMKuYkDkWMBuiUp	1406	1393	56	1	5487	jxy2ckjDY51UcSkoX7A8pt32z36mfCppDCQKMsgpJEvxJk5vL6g	2937	4120	4120	1616680800000	canonical
5666	3NLS3ZdFh1SvaU1QH9YgjkV3DBFEXzr7CBMyDQ17JLKUyMTs3ctJ	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1587	1231	56	1	5490	jwjuX1JPkmgrznTz4XAGPmsjNFDnhuFXfVZikJkHLoAiTD2soi7	2939	4123	4123	1616681340000	orphaned
5669	3NLEB7AqdbfPB73dfmRaR33GBYNzu5GhNFP56aBnxQU7e4WAmoWs	5665	3NL6GswV7bMvXt4bFaENb7JYgTJBDBGxDRE8wusWTkBtBJYHPLKT	1477	1350	56	1	5493	jxfcJSnv49KyWErqkWYV614gb1ro3v16oRSVDTKMwpWAeRgC1LW	2939	4123	4123	1616681340000	orphaned
5675	3NK3CHd2XLjo94BFkppFuNv8NJxjUXvFuKXVLt1vDkoK3f1puvW9	5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	1637	816	56	1	5499	jwCpmcVNutbEiJDsvAB3bs5Z1KUinA4iEZLKf8zEzcHkNSSncER	2942	4126	4126	1616681880000	canonical
5680	3NKrdEBQCcq97C2nAAUzETy6oC7mEFppnRezeCQQt3LsMpDNJYa4	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1403	31	56	1	5504	jxiC6x92L28SuLHQMHRvxVAyVmrGV8WTNehi2iVRAQ1DowwYZfe	2945	4131	4131	1616682780000	canonical
5684	3NLrVA5LqDHUPPGVqKYMgJZLfePtA23h5HgBk8xvKimHisDgMpvs	5680	3NKrdEBQCcq97C2nAAUzETy6oC7mEFppnRezeCQQt3LsMpDNJYa4	448	939	56	1	5508	jxk96HTDzkyNqdDT4HZmTUrobkgDBzv9swXSY85L4QyB6AeGCrS	2946	4132	4132	1616682960000	orphaned
5688	3NLPv51x3PaLjj6M4Cd8Sgy4EaQ77TYqzcw2vPAdf9dhBJaM2zjN	5686	3NKtqmjCj5xvSsSDXKynmoMEzGN19XfUbrwn3qJgGePSkpGssc6C	1633	1390	56	1	5512	jwdHZMH4dQLtQRjLnG8fgGi83AtFDaMVjBk8DXzhpzk3tGsE4pL	2948	4138	4138	1616684040000	canonical
5690	3NLXYFxMrd81bgHGHxTBWHJADvE8j54icJpsQzR1EsCPYvqJYxJz	5689	3NKxXQTsg57Cy12Eo4CVeV13tRdLAc11gagGCvLcEhD7a3CAu8Zu	1589	920	56	1	5514	jwqKSojxLQBBpSGHEeEMkVKB4bqYEHp7KejPUWsM3wqkW8gwY2D	2950	4140	4140	1616684400000	canonical
5702	3NLVRhS6294KFXCxC24vGu3TJSsAGpeZa4eLuBucXe1fJRqBgVJH	5701	3NLpUCWsyJtkZjarbj6JxjPBfNuqPaaYtLKvCxQFUKb1kzC2i17Q	1406	1393	56	1	5526	jwzV8Qg5Db4gW9QtnECeiL5DcMG1jzPL3jaDStUUiu5nuESSpE1	2957	4149	4149	1616686020000	canonical
5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	5704	3NKA2m2n9Ms2Zjnqqzrr6oPhH8yxCm3r1znSFgjFt1mFpzvD7LGC	1405	873	56	1	5529	jxWofiuPoKxr74raaDzumPattEtMHEHFcjdUsPzRAicbawE5Crh	2959	4152	4152	1616686560000	canonical
5708	3NK6u8EsfYWcZJYZnxiJSv9WMu5J1TZqJ5bBUr3FbD2FAA1Re8FM	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	1607	1348	56	1	5532	jwk2Qw8Wu7cbDGxEGPY1rJvNv1ZWmcVxRgpCdCGiJwccsZrMoV3	2960	4154	4154	1616686920000	canonical
5709	3NLdmxjZmM85ACtkLC5cUp86KFw1SNutqeixi27n7yUrWT4TxP5W	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	43	944	56	1	5533	jxEjEex2EDaxzqbABSsJE8fuDt8mbHdWfaEUwXweydCL8tFvZCd	2960	4154	4154	1616686920000	orphaned
5713	3NKoPLkYSJg5jJj7Q2HF6SZkE5szPEPajwdoDhzFLyHjsdZ4Door	5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	1600	1246	56	1	5537	jwmTFKvgaWTNMgEfV1BCnfwzheUdwSBJSMTKGq2jx7EVn5zGTi9	2962	4157	4157	1616687460000	orphaned
5719	3NLdQLExUnfoGZoyYq68cRd84VvM3BgroQiS1DEyvqafMvx9odBZ	5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	44	1199	56	1	5543	jxtXyWfMXUvG7dMhDvepfq5cbx2xdhXkk5aMGZG6jtzowdPxH66	2965	4161	4161	1616688180000	orphaned
5722	3NLSXjZBRfjgLBqn4SguXswGuGsBbZawkzMeGWgrbcrd26rSNboL	5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	1471	1140	56	1	5546	jxFsSDfa2KQupCP9b9NUd5Ko9Nh1sXJe3WHPFQt7yVXBL8oJGZJ	2966	4163	4163	1616688540000	canonical
9078	3NLSYdaaF5Psxk1mam22xUaXgHP5XoLEQGpontf6gMP9jo31Gdkr	9076	3NLkP7Wu2JovZj8MFch9ugfY6hGWwVe5Uy8J8qkeVVi16ay96dac	1406	1393	111	1	6301	jwJVfDqpU3e8rYUYUTH3zjTyHyj9yoCfbzqGtorgpok5LJG3wbR	4709	6634	6634	1617133320000	orphaned
5626	3NKxxW2eWBmCQSbNcoeCB6VxxVF5ELye28DzGhheYQQenatNDsrd	5623	3NL5gXsYQDmCyKzeEjTSXYfrgKHUFFJnRdZpKReRqyaa7oAGaPqw	1407	1395	52	1	5456	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2722	4098	4098	1616676840000	orphaned
5703	3NLgiPedotXbjLfBVF57ke5w1MyHcLWrN6SGtWZEqLQzKxNdv9fx	5670	3NLSp8M71A8MsD42tqawBbYn9xGzaqWQFXYgtGtxf1bGbih7Dst9	1407	1395	52	1	5527	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2727	4150	4150	1616686200000	orphaned
5714	3NKfpXeWgKb78D6FrwRY8sohUkxBWLv3DnfukgWuNffdqWoKPrAV	5596	3NKJTKonrq4UAT5Nh4VDPbfxvGPgJwCmv7e7b4jMRVfwvNisws4D	1490	1028	55	1	5538	jwjU2gDkyiFsRdKrkdxHujWeqeE2XDTTkmCss2cEEqDcPamsf7E	2838	4157	4157	1616687460000	orphaned
5613	3NLRxEWED1GrAzzSvHLysoWkGdMTwwHxJ9yGDLkoUmgz6NVBFp2z	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1477	1104	55	1	5443	jw9Yfs7DtsFbTg8AJXYFA3qWnV9daFbNUwsXN4KXUxmu2Xnh2R5	2915	4087	4087	1616674860000	canonical
5610	3NKihgNdFa7ZZst8Z2to8RCLaD512wgEpGsQd2aGPkdmWmoxwtdJ	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1403	824	55	1	5440	jwZjSmw2fDefFaFPNWjpMbrd8HVBvUPbv5FgCH1ttjJUnuGXHqb	2915	4087	4087	1616674860000	orphaned
5619	3NLfeEFhdsk6wR1XcAXaDanzS5AjqUBu58GpkpDUKXBcx87XgPX9	5618	3NLp3UZNS3HrcAa7HBzmLkqKHPf73vRwPGHiQj7uV85J3iLENxU1	1440	1131	55	1	5449	jxF7z27gvyx8pQwG8iuYgTqdFwB5AzqHGHimW7D8eMubZ4aG1DX	2919	4093	4093	1616675940000	orphaned
5624	3NKkBELERC9AaPZasFbwjmGy4Tnh1kd4iHnVMh8Wy7QtZT5YCJhc	5622	3NLK4YWuAWkkfhUe68iTWdRLBy2VacACDeYZCZD9jL5Pfmj235DT	1547	1012	55	1	5454	jy2iXjQburSZPf3ASNQk6SPNCopNbux89uz39AnTktEbLnZXq4q	2921	4097	4097	1616676660000	orphaned
5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	5633	3NLcgLKR8RTsp5FPXhPKkZeM8p6u4NHHn56YzhVbkpHAocCJPPn8	1406	1393	55	1	5464	jwUYtANhTgoDfSzajLQFL4ZTMrms2bLtVTRH73bsUGdi6XWsRkJ	2927	4105	4105	1616678100000	canonical
5645	3NKhtgmbLYdjJQVypwe8wKw2B4X4ZLN3spCCjV1Qe5giDyo6t8a7	5643	3NLTB91xUxmdip9vY16ncQzXjgxKnW4mv1f5nsMCxTHvGJndFstr	1672	1285	56	1	5470	jwKby7i5PaVqrty6ALU5Jihv5REhD1zZE7bJSTEHp3B9JUehTym	2930	4109	4109	1616678820000	orphaned
5647	3NLxUqXQ8jjDX4qqcs9pc2vh1hU3F7k2yKqQnh8oBDvNi7vFALWm	5646	3NLF2No5ttrzAmaXdp5hxnCP7Ad479DTGTh3VJPkdW2dK6rbirXF	1564	1338	56	1	5472	jwZSdjEEVXLqNqekRvVFLuz4nGAmyBMuwPrTMMdR1YLKtPMVs3j	2931	4110	4110	1616679000000	orphaned
5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	5648	3NKQbWJFcuQY2Abtkk8W7HSFdwW9EH7fhnqBgtiDdzQcqzKKuo9H	1455	1086	56	1	5477	jxH5E3dRmUA6oG8qw446eVHXUDjbYbfsoU1S4DU5qTvhvFTjZ86	2932	4112	4112	1616679360000	canonical
5655	3NKUHgWR6ztg3jc9LkLqjDvpSWY78zJjEDmpvUrne9uhy6TRJ7Fa	5652	3NKavwMXsm9SJ2N2TAxgv6eNQyTWqWQQe8uv65P8idSb3JM6SAr9	1651	1301	56	1	5478	jwND723CbneHETYN6WaDqneiQ3WKjaPXivWKcZJRqtwAYhb35y9	2933	4114	4114	1616679720000	orphaned
5657	3NKP2HCr5JoQHHFrk4fFYLoiVTVuKe7zJb69nPNrMeaEMA6MGx8o	5654	3NKbFPK4uNFTAyJss1RRcBnNitfnPibaQ3d4t7nsjLXXSSBMzHbt	1637	816	56	1	5481	jxg7uezT36nsce667geHaDt7josU5BkAps2WFVjuVpnmrbmoNCN	2934	4117	4117	1616680260000	canonical
5673	3NLSqsdnsb4ycCviemp6UTaYY6btGMtgQaeuPp8Nd8XA5LMraTj7	5672	3NKLX6X96Uzwru8qARDjnM5uibUZsE9ZsHCp3sqmJMvzafujRDc8	1608	1043	56	1	5497	jx2yY6c9nJvaPFMN5SMpNRsYgSmogqJgENnzZiMtHUPe9ntrUos	2942	4126	4126	1616681880000	orphaned
5676	3NLMpT2uuH2pYsFBjZt7xLzGLxoJHo2eRz6D5SGVA1JaLf5TsrAg	5675	3NK3CHd2XLjo94BFkppFuNv8NJxjUXvFuKXVLt1vDkoK3f1puvW9	1422	1211	56	1	5500	jwNQhBzWPGMMrCJFcAjJuLwxUtnK5jhC9kqpTFPByD87weLT6Sy	2943	4129	4129	1616682420000	orphaned
5681	3NLLn6i8EDFCg3gMeUgniwZT2mDLT2rdNHXoU1yVbRPP3RHN8w3d	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1564	1338	56	1	5505	jxVLb3zXZxNeo9h3K8qk1LdBFYfCY5bkzwwVuVRxJL32orsQfiQ	2945	4131	4131	1616682780000	orphaned
5685	3NKRMwQzTuUE5VSsXMS27tCLUXMNupyPh58dfX8WxCcaDTs9Vfn2	5680	3NKrdEBQCcq97C2nAAUzETy6oC7mEFppnRezeCQQt3LsMpDNJYa4	1447	1099	56	1	5509	jxBhCPF4E8izvjGMerHES1aKh4JM9LJnscP8ofAVmVDJPQqaCMV	2946	4132	4132	1616682960000	canonical
5691	3NKdeAvzqUxpGUidQqeFXXFZZGcB7Qhzng1acD3xJKT8iSRqys4d	5689	3NKxXQTsg57Cy12Eo4CVeV13tRdLAc11gagGCvLcEhD7a3CAu8Zu	1451	1046	56	1	5515	jxMPdEfb9QqHJ3P59jMhCZj5MFtBYWGj2FSLZh9gjXdFHK3AGxy	2950	4140	4140	1616684400000	orphaned
5693	3NLEai6yhBNF62UCTgNzutt9LG7qxsA5r2L162YZsy8Grs2CjVuu	5692	3NL9MwWFYgvaJ3Ka1i1Yyyiso74wTxpuriwhDx2gPVeVrjYZeC8r	1547	1378	56	1	5517	jxLf2csnApuDTJjfXaRdKWsXteoaavjQRAE49hzjE3du57FsVP2	2952	4142	4142	1616684760000	orphaned
5698	3NKKdSTTMSkXUjK9DeM27CexWLib4f3VdP24sUhcWEZKHqsrkymV	5696	3NLvZGCEWPfDwwGETU1xBT5LfeumUoRMoecUukt13D6NAK8Vm8eN	1631	794	56	1	5522	jy1ZSioaPRJE3Kpi1LnGZDra57kWkv6dT3W82U5wuEvALZsukLT	2954	4144	4144	1616685120000	canonical
5706	3NL94DcqqerrTd4PSB1BYemMkJoob6tUTWweJjUo3mK7PkCmx4yo	5705	3NKBnG5qPyJZwnNv12T9mVwFgsZv9XMR8cvVdgJcKJrw1nqZJ3F4	1426	998	56	1	5530	jxn5RZMr3ygKuvQen6dCJPydFJ2bx73CXHo5TktRcXpEf6UzRTt	2960	4154	4154	1616686920000	orphaned
5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	5708	3NK6u8EsfYWcZJYZnxiJSv9WMu5J1TZqJ5bBUr3FbD2FAA1Re8FM	1509	1074	56	1	5534	jxHRbZ98WNJh7TGsvqYvwraHN1pQeKQ4V3TKPB9C91Z9P9yo8Jd	2961	4156	4156	1616687280000	canonical
5711	3NLNPXUhKm55jFSMZR23Vm4tvx95bH1t4XWj1wUxD4gnSLd5cTty	5710	3NL5Qg6wofQFxe18Vmnp3DBuZsv8Wm8mNxe6tpcHmJp7yEXHuPbz	1490	1028	56	1	5535	jwJ2T5u5zhoBmrBjCTaxsksHb19vsY5aKw4FYZykvzPzcaii4GM	2962	4157	4157	1616687460000	canonical
5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	5711	3NLNPXUhKm55jFSMZR23Vm4tvx95bH1t4XWj1wUxD4gnSLd5cTty	1673	1368	56	1	5539	jwxQz1AMbbhFHifXWwhecw11JrzrCCxSMLkHbr8iJrCk1oW7gym	2963	4158	4158	1616687640000	canonical
5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	1637	816	56	1	5541	jwYgdgmWm7E5eKcAKd29PE17NCm6LT4xhoV6f159hTnC9Qj2W2i	2964	4160	4160	1616688000000	canonical
5718	3NKiFcKZRWFuG3LuiQSgCXApiSLHuBfwbtKLQPX2YAB5zE5751yr	5715	3NKh9iSDjnkiSmAFUUrgSDK39g15dXLEkMH1VEBnP9Ak8D4p36S5	1528	692	56	1	5542	jxgcMAqUfVjuATyJ4TL76NZoyFkfHKx8uXSjdVyGNDbSzaZMXRe	2964	4160	4160	1616688000000	orphaned
5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	1613	1223	56	1	5544	jxnwymjPFszdpYB8YwJwkGc35pJxXsD1bYMSrZxNAx2J4F3LSic	2965	4161	4161	1616688180000	canonical
5723	3NKozSx5jZNHVw71TVtE2yJAuzi51Honud2mQUR2uJ9DQ8h9P5Xa	5720	3NKFSpsCrWKc86aoMVk1gHFNmVe8RcSxbDS2PgJ5KJcVckuNB4C5	1501	994	56	1	5547	jx4ZyaYU8whTsqEoUZL1Nr3exK8hSfDaUr44YzHAtesb4MfTdaR	2966	4163	4163	1616688540000	orphaned
5732	3NLLTA5oFS4vMNY9zihayRzhUWAdnQf2uGAdceUoatz3FJM9dpSe	5730	3NLUpMvHb79GsG9DCznFEmPzkD19jgUCkR7FqQKiUrthJJr3U7JW	1571	1209	56	1	5556	jxm4BYCnRqKXRUBCkGoi5iVJpx7cfFPudwdVz7fvTefWHhqfFhE	2970	4170	4170	1616689800000	orphaned
9083	3NKBcwf5QA7MsSBa3xBYuWJCkXAqnF1ydGLf2LftdW9vMp9nvdoR	9078	3NLSYdaaF5Psxk1mam22xUaXgHP5XoLEQGpontf6gMP9jo31Gdkr	1617	1042	111	1	6301	jxJXz37EkyuysB2qHN9kikuuaLWgiUfjQeWmQZUXTTENbKTkRjk	4710	6635	6635	1617133500000	orphaned
5727	3NLJFwtGtuQ6st1P321xKcNcn8hqhXHZacXx3qT1NSdG8c88A4gY	5722	3NLSXjZBRfjgLBqn4SguXswGuGsBbZawkzMeGWgrbcrd26rSNboL	1675	1096	56	1	5551	jwBqwo7zCD9syaax5MSmP8auZytuZanL23Zcx9EWLwZVyx2Gu7E	2967	4165	4165	1616688900000	canonical
5726	3NL8Q4uZEJEJKCZYokmHrKKkbSbsCEMVyC9sqpMytnSdVJNaC81r	5722	3NLSXjZBRfjgLBqn4SguXswGuGsBbZawkzMeGWgrbcrd26rSNboL	1546	1093	56	1	5550	jxu1Y7JPpj68CAVKEziqJNV5TryFmW4CYhk7cc8Qf7T888umyNL	2967	4165	4165	1616688900000	orphaned
5729	3NLXCnmjBEJBENuSR2zCSWni174ijHuAXaqv1BFNsptaYbK6haKF	5727	3NLJFwtGtuQ6st1P321xKcNcn8hqhXHZacXx3qT1NSdG8c88A4gY	1402	868	56	1	5553	jxYwWFaF3yidsob82PDnr6DegWN2iWkzaosAoQFLQkQz9Q3BRFe	2968	4167	4167	1616689260000	orphaned
5731	3NKDQN6iZvXA3uf4R2THNEk2XnU2AUdmcaUN1sSbg531dJ9Sj2XL	5730	3NLUpMvHb79GsG9DCznFEmPzkD19jgUCkR7FqQKiUrthJJr3U7JW	1403	824	56	1	5555	jwvd5PKUnc3fnu85pxyiBSyP3bwNFHU9qyGRev22qXW3f4zV2Ek	2970	4170	4170	1616689800000	canonical
5734	3NLYzxBjzqztZEQdRNantYw63V5e4umoZLa7A4nbK2DtCEjqGesj	5731	3NKDQN6iZvXA3uf4R2THNEk2XnU2AUdmcaUN1sSbg531dJ9Sj2XL	1403	812	56	1	5558	jxZiLQCETkFjsriM6gNzR8BGYmr397N4tms6Zfg7UFvUGBpKzpE	2971	4173	4173	1616690340000	canonical
5739	3NLGiyox4UZy6PzJntCWLLz3T8WS8UWHD95NshH2SMQYrAP7CHpV	5738	3NL8YPoyk2Fhg1JBgUZS2gf2F2TA6yQvE9gofQ6eae3XY26WHNC8	1637	816	56	1	5563	jxwEZxJipv2d1vBWw2CsHQbtd6P7SMJExCLhQyvYZbDdVnoWCEm	2974	4178	4178	1616691240000	orphaned
5742	3NL4G4G5sYB2TYXeMBF7SMpKNgpe6FMekXU4ubs29Zao6wbwdDhQ	5739	3NLGiyox4UZy6PzJntCWLLz3T8WS8UWHD95NshH2SMQYrAP7CHpV	1670	1156	56	1	5566	jx698vnSDmjz5nGWre3cZmiiss8ZQARvbW1RP2wMp5PpvShfnVG	2975	4179	4179	1616691420000	orphaned
5744	3NKGvuQTkxGDLJqNVCrapq1VZh9T7Ersvgm2zVzYz8qFUUy4L7cG	5741	3NLseHynzg4givDNtwKoBsw92T7upPgJGqrY5qNwf5ars55ffrJP	448	1305	56	1	5568	jx2PkkwEetVrYqNwzRN9jRnjbrbhYws17aNqPSUgUEfwb3ov8iw	2976	4181	4181	1616691780000	canonical
5748	3NLttuJRm4uAM8uynjoRDMvmuak4iH9ewPQ1Zp5iG6uWswHbrLqy	5747	3NKck99AQ8x97Wih5x83BTjcgv5QcwWYvy5K9qdXN3DsUuQbUgYv	1587	1111	56	1	5572	jx7hRKPB3aQidWfvJSViM68zrXaXHD1Q3hBvT1kYZNXgbUTDBPP	2980	4185	4185	1616692500000	canonical
5750	3NLY4qa9ByX5JSgsQPanoG3sWDBJaTJNWQQpj2YiGbiDS8QXHiBD	5748	3NLttuJRm4uAM8uynjoRDMvmuak4iH9ewPQ1Zp5iG6uWswHbrLqy	80	1027	56	1	5574	jxWx1T8kG4RZFnfRXckg7twMZCASVJoAyfuHKwHT5cV9JJ174Dm	2981	4186	4186	1616692680000	orphaned
5753	3NLmbi2aVePxcEDpP4K9NCk9k3ejrbwuHYBoab4d1rPU2Fei7G5s	5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	1406	1393	56	1	5577	jxj1RVXB4KHUHYa7qppm7xT7nD9SxGATo3av7fpVcJ6WrtmKPED	2983	4190	4190	1616693400000	orphaned
5758	3NLGsGUtZPtjmYf5XtKrJ1bwuoV5Trqim7Apv9YGiH75DeYX7h84	5756	3NKv1uioRD3nrjCWZE7vT5Ao2T2Khp3eiQ6y5k6q9ULbg9AQH1Su	1439	1279	56	1	5582	jxBYgCJJeyzqjpY2NH7KQHHxQUoeqZC2Gf8bhYPchh6KQ9rqzah	2985	4192	4192	1616693760000	orphaned
5759	3NLFLD34FDDpE4EqENCmdkRsC4PSiwiLfKtEvtGRFGZSCHpHv1wa	5757	3NK3GcGYtMsb4RUevueaQBpMUs6b6WUAigCKsRAYTqJitPaGKs5e	1671	1119	56	1	5583	jx364vqfozmvy6bg2PG5EtMYPXndFQ4BwiD6EGjopx4XE8RS9QF	2986	4194	4194	1616694120000	canonical
5762	3NKUkJPeNHKYni8JeS1NFtsPqzBjgLjxvMvPkwpSWtv9mNMAGTkN	5761	3NKMVeFdHaojYpKxBhHrp87sJdUZyYQuYJjDuJpMPorkjByWLVMZ	1516	928	56	1	5586	jwTpYpgnZKfoNrkta3CJZqHc1ujMdQdzRWEALkYYcihevBawAhv	2988	4197	4197	1616694660000	canonical
5766	3NKR65QEX32t515x2J1Ju7XT1meptjwvmuTFL3FLWWFwdvBrmdhp	5765	3NLTx83UNE3zYKATnqCt4HMPFhWDo2SNsvs9A2pVqradwvsNEjpa	1560	1165	56	1	5590	jwsWGHvZxv6SYxUbegRKa3GJccrrBrW2DJmeGQLtEccRrhtxuzS	2991	4205	4205	1616696100000	canonical
5768	3NK9txVVbXKH7GaqK9MTM1USzstx9THdNYtqi6f5SQrHsS28nrVS	5766	3NKR65QEX32t515x2J1Ju7XT1meptjwvmuTFL3FLWWFwdvBrmdhp	1624	1088	56	1	5592	jwNZQDb7KFDsbaB14yyZ3mCWTyUP71E9VPdREbJaNR71YKEBeKs	2992	4206	4206	1616696280000	canonical
5771	3NKzMGUSK6WQiEW9Nq2BgePhiyasvaDco2ZtCt4jtxovpzgMFRyN	5768	3NK9txVVbXKH7GaqK9MTM1USzstx9THdNYtqi6f5SQrHsS28nrVS	1481	790	56	1	5595	jwUso5khDrSityvKCC8BPf2s2jkxKmi6FC3NjdbrbxpuNZx4EEz	2993	4207	4207	1616696460000	canonical
5779	3NKNcxRPf7UGiz4L5EEKPiziDB67ihXhi89i9ESLrAP9RRZGt2nC	5778	3NLsmMKXfF3AoETrSXMH2tJH5HKTVwzHPmspVU8CcDTfavSm5vLA	596	940	57	1	5603	jwxEP7Uu4rnPvXyDHGftYxCG4RhDLnm52JtK2eZrvYSQ89LLQ7M	2998	4218	4218	1616698440000	canonical
5785	3NLLHeJcBkcwfNRU99oM1hfrZWDXjCGFzqm621ATkESBc8SWWjQ6	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1405	873	57	1	5609	jxtuCuQBR61fK7YrRHVTJz1JJpPuEFAZ6ftEHkLiPojsEG1E1RM	3003	4226	4226	1616699880000	orphaned
5790	3NLePbCmFQSJTH8EoC7aFpEP9i1U3Ph6YEzZo12bwnTTZHL3jbzS	5788	3NKj99j7Gzt5sTtu9eRMt7rfmoC3c4KSgBGCULdNDMfVSnF9Ccer	1622	1356	57	1	5614	jwNDaaWvYN7MqPyLDqUHCx2CT218VZHUa7sgDDQdow1HneQiXvE	3004	4227	4227	1616700060000	orphaned
5795	3NKBhuzj35KHHvo6XR7Q8rmcAPuzuExwfALc94uMqSV659JZGnng	5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	1651	1175	57	1	5619	jwkqf9PmoEBcBUJebp7zruEtAFYwUfijRvvoFNBYsuT3HCApYrU	3006	4230	4230	1616700600000	orphaned
5797	3NKUxQD9gTPWpHpxvsnpfT3zYT5NTtnLNVwyVgsU4t9fTZsLxbr2	5794	3NKRjQ6DEqcrJbCBm7VR5kV16QYBdDoHAVEMZAWFcbtYvQ868JKw	1588	1392	57	1	5620	jxscUW3FuiknkrVk48RsqkkYJqUccLKiHUChfxdUu3W8t27hJBj	3007	4231	4231	1616700780000	canonical
5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	5799	3NKL1gbCkiP74uk3WTg4uZoZNNc7PUuux8w9tveSxhQMzpD2geFz	1506	1247	57	1	5623	jwhNLTnaYLAEbL2JsNZW2ZzcrDBZg5n5szW2HfgJvqwNWfZJV4X	3009	4235	4235	1616701500000	canonical
5805	3NL4n1h9cuhzVK5Sjr9NuqTTzsYQgR26JiLShALHzMsvD8r2VaVV	5803	3NLvG89UqMhUwBEWxMvZgGfbiVVbKCoPETYb59dFKZVeAQAwx1TS	1445	1164	57	1	5628	jxjEN56DaBsgSKrzFK5vQuFPCudpEQboVUfEK1y3ZDh9BZFM3DY	3012	4239	4239	1616702220000	canonical
5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	5805	3NL4n1h9cuhzVK5Sjr9NuqTTzsYQgR26JiLShALHzMsvD8r2VaVV	1483	1276	57	1	5630	jxkoVWGTuZx96WHobQHzVyRP4QgUuxE12sh1xvwz2DF8oR9vsrG	3013	4240	4240	1616702400000	canonical
5815	3NKeV7wkXCBGb8MErrYEggRwarsobS7yFZzD2NxkgzZ3WU9QiWUx	5814	3NKcxtvSRCFnxaKYxHZZLvAs1HvSRobPYMV9Tnfkv8VGEJo8Buhp	1405	851	57	1	5638	jwLf6bZKbFQ5iqGcFDEbAbPDcnCV1uMqSahaXiqJSSYPW94eSks	3018	4247	4247	1616703660000	canonical
5820	3NKBz5sq7Chz5fsqDL3PbhHxZ15Jp6JRToNsWZUp46rPEbUbFiLA	5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	1546	1213	57	1	5643	jy3AngZzT3H3JPAgHUtZpJZ2ofiUZFbhseZuVWbbXdTNkkxZP1i	3021	4251	4251	1616704380000	orphaned
5825	3NKX8RJMBLX72SXsqBTACg2aa7yDEvupkzJZZPoyLVB1SjiAxUPg	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1522	1322	57	1	5647	jwUtn9ncCL6hARcnNhxh6LwcFiccYP5rMNLF6Yr4iWY2qFY3KLT	3022	4252	4252	1616704560000	canonical
5829	3NKDaAijpAQEraNQBHrXVaJR37t5Hc5Ad9NaHHNDkvEsm7kAZBpH	5828	3NK9xoe3vEZuBYZskJ9ErLEitE3qk8yk3o35WW7Fjo7MjVNPaS2x	1406	1393	57	1	5650	jwkwomh8Vjpue6UecKEQ87iryMz8zxTBijHQSwfGiahLHXChS1i	3024	4255	4255	1616705100000	canonical
9092	3NKaSkMKfVncDhPKj5b1AW5mHJm4uUYkn8ohVfQL9Q84kSgKjHk3	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1637	816	111	1	6301	jwjHnKL9ojDDUMA8z2w9EAJXVaVZoX8i2wrvvUtUsBWNPMhiDiB	4713	6641	6641	1617134580000	orphaned
5743	3NKQ3HETibhLzpvWiHWrLozKQAyKmKKPcXECgun35AyELYcnSHCE	5737	3NKayafyVEocn4z1xZQPfFuN77qxeeDab1vpEK1mk572MSvU2849	1407	1395	52	1	5567	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2731	4180	4180	1616691600000	orphaned
5772	3NLBR6DRL9pDcE7MgsRoBrxxnoHTMqYHDVi7H7Hs63PwNgAtFXnX	5755	3NKMxWo145vyGSTjMSZTBBasBtHtZD8p3fjywnJQXM9vV7NgZyhW	1407	1395	52	1	5596	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2733	4208	4208	1616696640000	orphaned
5856	3NKo2irPCiob6Xq4FGZj5gQjogTQ7ek96Niygd54C4WKMNcZzbi3	5399	3NKGngJv5vXndpKqQBMv6wRipJVbvHmxSfuam8aUGVhWrt5MwKXo	1407	1395	54	1	5675	jxPVak58f3jjEQJmhWsc7prJbY4QSpA3SUvWe5gNHQtecavKWYk	2810	4275	4275	1616708700000	orphaned
5792	3NLo3PZUFtAj2vBN2LhUAsEaiyXQorxT5Tea61kC8uh8ZoMf7ef7	5776	3NKXDgUBbesUevaebiMhngiTQBCWS5qx9fKYDzX7dgDHorXRctRC	1419	814	54	1	5616	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2819	4227	4227	1616700060000	orphaned
5819	3NL2QwGmqCWNVxMepua4tknwNjmsuFbxeZMomXH9oeovRhdkNZwr	5806	3NKbBiQ7q5pzpj5MnFE6hPVfNn45DDnFWUWf7kuwGUKr3rL9JGT7	1419	814	54	1	5642	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2822	4250	4250	1616704200000	orphaned
5730	3NLUpMvHb79GsG9DCznFEmPzkD19jgUCkR7FqQKiUrthJJr3U7JW	5728	3NKFUY9SuMGbykqLrdYQX4uMV1hFnAiQXNbHv4pbX9F8xb3QbQrM	1509	1074	56	1	5554	jwVLfE5RsJG16MF3M91qunsY7FcZ9dQQHHTDtagP28mGPqWHx6p	2969	4168	4168	1616689440000	canonical
5736	3NL4EjL21Z3adAqg5G1wMn5yYfZwxWWmhHMUvJSt6AWhDbqLE8Ye	5734	3NLYzxBjzqztZEQdRNantYw63V5e4umoZLa7A4nbK2DtCEjqGesj	1617	1042	56	1	5560	jwgop3PXhEbaRafnS1QknzEb2pz8pAAUHTT8kYnWbafnsaAEiTS	2972	4174	4174	1616690520000	canonical
5738	3NL8YPoyk2Fhg1JBgUZS2gf2F2TA6yQvE9gofQ6eae3XY26WHNC8	5736	3NL4EjL21Z3adAqg5G1wMn5yYfZwxWWmhHMUvJSt6AWhDbqLE8Ye	1464	591	56	1	5562	jxDhFqppEkCi6mE6JM846d9poiDBG771LutbsGaZuBPFbXLUJsX	2973	4176	4176	1616690880000	canonical
5746	3NKxj3aHNT2Eos78KLMDVx7RPxpgNcdi6xTUpgLkSLZPjhFs7s5Q	5745	3NKEn9K5PYTxKGdFB9DQ8sQciA6FxK6wxVBg7HPFpPRBhM4FDxLH	1398	435	56	1	5570	jworP9ReknYVdMHoM5hphxg1i2YzhbbB4KQXfDJRyS3yKThXutS	2978	4183	4183	1616692140000	canonical
5749	3NL3HAPuaa1QnWSvBePrbDTNn8ECJFpSjZcAFdJ8LBVmt5JNKSnK	5747	3NKck99AQ8x97Wih5x83BTjcgv5QcwWYvy5K9qdXN3DsUuQbUgYv	1623	830	56	1	5573	jwvmEQoT1vxatzDiva4Gnk9XioXMoYwnHnE2waiadAtdZgXeWj7	2980	4185	4185	1616692500000	orphaned
5751	3NLuz8jZh9btjqyG9sXi5Akz1qfkD5an74ZmpAeDgdQQZRrD9CLy	5748	3NLttuJRm4uAM8uynjoRDMvmuak4iH9ewPQ1Zp5iG6uWswHbrLqy	1670	1036	56	1	5575	jx1a4vWEv54K5pQf7xUCvwZi2M4nK6de6JgHtFcuUwvzbgmCaso	2981	4186	4186	1616692680000	canonical
5754	3NLpQoJjSrTzktuEyT2qeigCHUhGQqQeV5qgHfgqt3TS9RjJpRo3	5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	1631	794	56	1	5578	jxVTF1y6NjBAQv8WVUaDdohrrw5yAkG1AYSTLoBE2FsDBy8Y59c	2983	4190	4190	1616693400000	canonical
5756	3NKv1uioRD3nrjCWZE7vT5Ao2T2Khp3eiQ6y5k6q9ULbg9AQH1Su	5754	3NLpQoJjSrTzktuEyT2qeigCHUhGQqQeV5qgHfgqt3TS9RjJpRo3	1507	345	56	1	5580	jxFunY3byfsWEXnA4HJTcgsAb64urbyD25m2yW53HgaS7A6EopK	2984	4191	4191	1616693580000	canonical
5761	3NKMVeFdHaojYpKxBhHrp87sJdUZyYQuYJjDuJpMPorkjByWLVMZ	5759	3NLFLD34FDDpE4EqENCmdkRsC4PSiwiLfKtEvtGRFGZSCHpHv1wa	1553	776	56	1	5585	jxpmtg1Szt42yUkyBPxBgoSh5WLjkDb9LBbbmVa8MzbGCp5ujgw	2987	4195	4195	1616694300000	canonical
5765	3NLTx83UNE3zYKATnqCt4HMPFhWDo2SNsvs9A2pVqradwvsNEjpa	5764	3NKs5TksyX1eSQQ5uiqptXT3fd6kTsQLDfrmU5koPmn4HfWW9ixq	1593	1220	56	1	5589	jwENdC8bgk543XTBPK4wS38cEigJz4Z7vXbyxkX76QBvsWZvpMv	2990	4203	4203	1616695740000	canonical
5770	3NLRzW7Cu2eAAmZC3dHcrQZ1aMie26UZDA5Naai1hGkFyi7L6Hgc	5768	3NK9txVVbXKH7GaqK9MTM1USzstx9THdNYtqi6f5SQrHsS28nrVS	1403	823	56	1	5594	jwb9v1oG4act3KHhPQM7GYEe7suhGnEcDmJ9bsFuF7sQ8ygw4qG	2993	4207	4207	1616696460000	orphaned
5775	3NK7jxauQjFMY5UKUTJ212jfQK73WprBozPRubKQUMHT1gF1u9VC	5774	3NKxVcd8DixEjjmuBb2k5xW5RTSMwhNSpRJNJ7KcKL7RW7jAVY2t	1619	1029	57	1	5599	jxEKwNPvCyq29Ny6aVXgvgeCpGVBR379cojBjX7999fZ6xKcWXH	2995	4211	4211	1616697180000	canonical
5782	3NLDwWvRszZVWdzpKwbgYogu4dpeHEfez8nXLorogGmvxTmuU5h6	5781	3NLK9CQUuZEkb8YTjE4fr5Mn513TpumRaogY5xcShiWGSKD1nvX6	1483	103	57	1	5606	jwoZwhbNm94HqLMta2R8HpvicMefqRDd37t7HyJc8F8uEM4wxW4	3001	4223	4223	1616699340000	canonical
5788	3NKj99j7Gzt5sTtu9eRMt7rfmoC3c4KSgBGCULdNDMfVSnF9Ccer	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1402	892	57	1	5612	jxGnzD6KMWXzCxDf3YaarHp3MTBtmSsFQZB7gbBAeybaN1UG4Dx	3003	4226	4226	1616699880000	canonical
5794	3NKRjQ6DEqcrJbCBm7VR5kV16QYBdDoHAVEMZAWFcbtYvQ868JKw	5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	1581	778	57	1	5618	jxiEjuAZZEgofsDT1N3EP91xNoNaYjUYtqjiG1GMLkhbbSpxb8b	3006	4230	4230	1616700600000	canonical
5802	3NK56QtPUiFSh1fnET8REVmEBdn9nDxMADRJwtTcQ1NuRWxQMQaD	5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	1657	1098	57	1	5625	jxpmEgifjmb2CFyeAk25q7w7brCHAcVn744AFKkC9QXwq3zFE8k	3010	4236	4236	1616701680000	canonical
5810	3NKqAJ76eLafgSV49G7UwmQjcYyYnwEBYHUabUiua4swe3SWoivv	5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	1593	1346	57	1	5633	jwSEvzZnugoKMZjBG2zVKwNedkpJnzFikfKX4Qr7MhmGhRM119y	3014	4241	4241	1616702580000	orphaned
5812	3NK8x2GJASg4kMo1t1GCiZ1VxgJheksTeMyFZteiyVx6oanQPg1C	5809	3NLGRLWDoGDEHMGVVB1zchnaQrNaZy7Bvidqm63nvgyV3Zu3UaXC	470	1309	57	1	5635	jxipqYVH8HMhnDsDVEudVJJquNpbPJrJqtM6pm9eqgpqCtnD9kb	3015	4243	4243	1616702940000	canonical
5814	3NKcxtvSRCFnxaKYxHZZLvAs1HvSRobPYMV9Tnfkv8VGEJo8Buhp	5813	3NLvHtp1omFjsVyKTUChGMtSFfWDt6yeqAayzMbpTG9h3W1qmihG	1477	1350	57	1	5637	jw6pNtz5nMtjahZRssNDi3u2cxFKMN9TGMMnEcCg3MvsrQiDQ9Q	3017	4245	4245	1616703300000	canonical
5824	3NLDS7DWCusXj9yyocVsfeTXkcKnLAuwXM8P1mSBqZf46qHyLQzv	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1523	1321	57	1	5646	jx8Ko4HKawSz6vP7YT8vaotxarhq5ChUkVdtJqTxCLQwgaHD2dp	3022	4252	4252	1616704560000	orphaned
5834	3NLbKYpnUmZSrcm8ANaG2AxQ4StuJgz5yLpWhbbuNfYSb66FKaWy	5833	3NKmYaFMgbcBvR4bCQeSpB9Tc77r75b8PziimyBGT2zqjuJKosxm	596	1306	57	1	5655	jwoAoab1r3sVhJint1qyGPMUE5vmMUeGqbKVxS3HyTZMEXfupYN	3028	4259	4259	1616705820000	orphaned
5837	3NKKeU5kRXxYiFDjnbAbhEHjDPqzsYZnDyZ1aCZazBXRC3bRgC9U	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1474	1083	57	1	5658	jw7CEhvTpKiEyx1EwbF6BSQNCc9F2AjTUjFvcnouTiurca5vsUR	3029	4261	4261	1616706180000	orphaned
5846	3NLPu6bQhJU77duc1PQpWcGG8hhANKKkn1U6NNP9oNU7uxmh6SLN	5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	1536	1187	58	1	5665	jxU5PVop18LxaikyA78JxZGvJReSVGwbZqzxrstihCrkXQh27e3	3033	4267	4267	1616707260000	orphaned
5851	3NLPoSuq3qk37a8KM8Sj9dnU16MKQ4VYx6bxQAbaZDvX5DBEHsfA	5849	3NKLKHpqh2S2J7EawToMS8eZrQ6RWjD5humCSBPr8G99SSN7RzF5	1402	810	58	1	5670	jx5G1Rci9fUKSEmXMQwYp4VS2HUrQy51ZQJxpSwbExbhRSYSwSN	3035	4269	4269	1616707620000	orphaned
9104	3NLMD3Mu4uENLuwrn9CgtePMbbdBDt4LGYaXd1wVnr7MmvVbNVQX	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	532	1303	111	1	6301	jwRxQdDhrUtdbMv1pmPqJCide3ZaJ9Wvf5nLSh2cQuYPLtU4x8n	4717	6645	6645	1617135300000	orphaned
5755	3NKMxWo145vyGSTjMSZTBBasBtHtZD8p3fjywnJQXM9vV7NgZyhW	5743	3NKQ3HETibhLzpvWiHWrLozKQAyKmKKPcXECgun35AyELYcnSHCE	1407	1395	52	1	5579	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2732	4191	4191	1616693580000	orphaned
5786	3NLtaLTJW2xj9bJrsKGyf2a5paHKjLQ4YHsR1GvUt8T6qE2zfGLU	5772	3NLBR6DRL9pDcE7MgsRoBrxxnoHTMqYHDVi7H7Hs63PwNgAtFXnX	1407	1395	52	1	5610	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2734	4226	4226	1616699880000	orphaned
5767	3NLXFM5p5DeaMTg2xQttfXXUZWHorrk5LBTxKEVPZBPRW6FxiMT7	5725	3NKJ7yxUF368DihPkdUwqkk78N54j8eAxTUpkqTwoMrLcHXgquaJ	1419	813	54	1	5591	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2816	4205	4205	1616696100000	orphaned
5773	3NLjf3MAcvFZ4cMqnxe9fksZed336dHkBwtboFmDsK5aKhXb5fso	5767	3NLXFM5p5DeaMTg2xQttfXXUZWHorrk5LBTxKEVPZBPRW6FxiMT7	1419	814	54	1	5597	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2817	4208	4208	1616696640000	orphaned
5776	3NKXDgUBbesUevaebiMhngiTQBCWS5qx9fKYDzX7dgDHorXRctRC	5773	3NLjf3MAcvFZ4cMqnxe9fksZed336dHkBwtboFmDsK5aKhXb5fso	1419	814	54	1	5600	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2818	4212	4212	1616697360000	orphaned
5806	3NKbBiQ7q5pzpj5MnFE6hPVfNn45DDnFWUWf7kuwGUKr3rL9JGT7	5804	3NK6Km3JfBXp49YDGt7oGETASY3iQuPaWwXbjbZu86KZ8CzQhykg	1419	814	54	1	5629	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2821	4239	4239	1616702220000	orphaned
5740	3NL4oYPDn6UkdZGpMe6ADyaB9iTCepDEzbLPc1s7A8obkN8ReQMz	5738	3NL8YPoyk2Fhg1JBgUZS2gf2F2TA6yQvE9gofQ6eae3XY26WHNC8	1631	794	56	1	5564	jwoXwuxvB5FMZSVNDCmtGePg5RhsBkQam4U3TdmYMwn8pPJnZPv	2974	4178	4178	1616691240000	canonical
5747	3NKck99AQ8x97Wih5x83BTjcgv5QcwWYvy5K9qdXN3DsUuQbUgYv	5746	3NKxj3aHNT2Eos78KLMDVx7RPxpgNcdi6xTUpgLkSLZPjhFs7s5Q	1406	1393	56	1	5571	jxUvNd9F4NRXqHRw5t3UtSti4hAykTFXF3Uo4HyDCGy932xjwmG	2979	4184	4184	1616692320000	canonical
5757	3NK3GcGYtMsb4RUevueaQBpMUs6b6WUAigCKsRAYTqJitPaGKs5e	5756	3NKv1uioRD3nrjCWZE7vT5Ao2T2Khp3eiQ6y5k6q9ULbg9AQH1Su	1406	1393	56	1	5581	jxWX4m8FSA1F58bHHBaXH57cbLppVx21JuSBjpszghZvUXZNUos	2985	4192	4192	1616693760000	canonical
5760	3NKvEqc12AdhwvGX3tiNJjqoziZWYshxu8u6PghLQHnQQvYcNCMq	5757	3NK3GcGYtMsb4RUevueaQBpMUs6b6WUAigCKsRAYTqJitPaGKs5e	298	1182	56	1	5584	jxkvKLC9t1xtftMRjDrwkKGQSemgrLGpQpuAAZT82KqgPC65ryX	2986	4194	4194	1616694120000	orphaned
5763	3NL9ehEDrpPdpKbV2WpTqdoZtWoWB2jevDrYQrutzP46UAeVg648	5762	3NKUkJPeNHKYni8JeS1NFtsPqzBjgLjxvMvPkwpSWtv9mNMAGTkN	1406	1393	56	1	5587	jxhPDLmYKnH9JHX2LeE4NFqG2NNQywEK4n7KtnHkWsXQ6MArhRM	2989	4200	4200	1616695200000	orphaned
5769	3NLCwq9HZc3TTXZ98L7vy5wvNDmgiFiatcEL9HmPDqLUF4YerxVf	5766	3NKR65QEX32t515x2J1Ju7XT1meptjwvmuTFL3FLWWFwdvBrmdhp	1585	1366	56	1	5593	jxMYfhskexKK7YWn2ibWGx6YCjcbmq2TZ1oF9A1KjwHwJnyx8os	2992	4206	4206	1616696280000	orphaned
5777	3NLErCCE1J7Rgww1EcvoMTdLhCrZcMfakt3iDQ29JUCNR6nDPNhi	5775	3NK7jxauQjFMY5UKUTJ212jfQK73WprBozPRubKQUMHT1gF1u9VC	623	623	57	1	5601	jxeUsw2bcQzupowH85SXbTR6HnqGEFuPfpfXHG7MisTgrcTX1pi	2996	4215	4215	1616697900000	canonical
5780	3NLvbgxVtrcH1VoWcxQpMyBERHmrnJzJ4sb26StczLzDeLtFVX6X	5779	3NKNcxRPf7UGiz4L5EEKPiziDB67ihXhi89i9ESLrAP9RRZGt2nC	1594	1080	57	1	5604	jxke3i6JrVcwUG48xYERDAoXdfJvnYPr8eiwMQaXgo3XRG56DN1	2999	4220	4220	1616698800000	canonical
5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	5791	3NLni7PWFZXrMsY1NckFUVBYzXNhf5UZDpvTzNi1AK4tR6JdLzQD	1650	1375	57	1	5617	jwkczArng7oTRZACG1QbMsgg67amxSEA1rSa9kMNu9Ew2XSkMnE	3005	4228	4228	1616700240000	canonical
5796	3NLQqSMaHuTtt1U3T4A3wo8daPo6tpXiGwNRcTPTQDRkJuroptbD	5793	3NLBN9E8QpZJ6c9msgHQHz7HuQK3hu5jvs8V3b5k8Jn66wM6pP2u	1651	1175	57	1	5619	jxaDfXpqbSL2FdZDKikg2ihM7f54ocL5ZvoMT3N9PGa72omU9Tw	3006	4230	4230	1616700600000	orphaned
5798	3NKnYX4zx76oeJnChwZW7zujUnPC5a38LG2sSGePmD1Z88EKndcS	5797	3NKUxQD9gTPWpHpxvsnpfT3zYT5NTtnLNVwyVgsU4t9fTZsLxbr2	298	1182	57	1	5621	jw6u259kChLveP2fum9g7xia5GdJrahaRVjUjPXVSq29rrSWaov	3008	4233	4233	1616701140000	orphaned
5803	3NLvG89UqMhUwBEWxMvZgGfbiVVbKCoPETYb59dFKZVeAQAwx1TS	5802	3NK56QtPUiFSh1fnET8REVmEBdn9nDxMADRJwtTcQ1NuRWxQMQaD	43	1064	57	1	5626	jxsr2rChcCXUf7TxwFkfQpExRshph4rXJWk1Ck5gKj88aap4F8J	3011	4237	4237	1616701860000	canonical
5808	3NLxxqiR9qvyccKU6Sk1usTAuatTSxxYtukBT5G4VdAndsDD1gih	5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	1642	1367	57	1	5631	jwbrSqM1vSkfos5zTyv9UxyeCsrzUBrDtgReWmZWFSek66e4M29	3014	4241	4241	1616702580000	orphaned
5816	3NKAv6yp5q3NCLSAT9iU7f7vThNjJtnpjLaBHrcTgNMSm9gfzwMA	5815	3NKeV7wkXCBGb8MErrYEggRwarsobS7yFZzD2NxkgzZ3WU9QiWUx	1460	616	57	1	5639	jxwgq4JDhvuXMXe58iVEcKpnE9wVFaTJvtJVXNF7xtnsR6EEb5R	3019	4249	4249	1616704020000	orphaned
5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	5817	3NKgKQWW2ZsGdRpcmgeTxmFiHTv1th5PgYaAFQtKpPEGZwbDK3yV	1634	1331	57	1	5641	jxAVQCtmyG5WjYQFKk9uVb6NSC4Kr3pYcH1pF1QFz6u5YCSv3qp	3020	4250	4250	1616704200000	canonical
5821	3NLfBAkhAM8pGbkpPuAi7WFmiFmoWxf6WZad7cPqa6ghY4mbztff	5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	1460	656	57	1	5644	jwLJotUjDYmjQPGnuQuGn5s4eokZaMCgwjjXRF5RxH3ty2pjcpf	3021	4251	4251	1616704380000	orphaned
5826	3NLVtpT6CHU5vKkPN4Qi5V4SNW6M2TPSPVq595KRShFSJkPf6bX7	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1523	1321	57	1	5646	jy1vcrnDhR4fbhVPPCu7AVMyYe8nai3CvSDvhZ8Serk8CtXB2zD	3022	4252	4252	1616704560000	orphaned
5827	3NKmFLcB6qcRBzrajizaQfaGJCqavFhvrLn39HYm4iU8ZakhrTJB	5825	3NKX8RJMBLX72SXsqBTACg2aa7yDEvupkzJZZPoyLVB1SjiAxUPg	1642	1121	57	1	5648	jwdwwWXHdoYqKAuRCuwbrHAKR7CD7jG67bPVDCmsEN9aGtiAWqd	3023	4253	4253	1616704740000	orphaned
5831	3NKWP6GUHRwD525NiviAoSJWvo2xUiNvPR3FVFPUDHHeYahTE9Dv	5830	3NLX2YUQJLyL9s61kMkQwRe2vZUhdLxBM7XK7yRm7gZGVzRvtsmH	1451	1046	57	1	5652	jwU1Acw7SCgzv2bRMRXyeySryzhgefGusaVt8gHTJgbz1bHZnx6	3026	4257	4257	1616705460000	canonical
5833	3NKmYaFMgbcBvR4bCQeSpB9Tc77r75b8PziimyBGT2zqjuJKosxm	5831	3NKWP6GUHRwD525NiviAoSJWvo2xUiNvPR3FVFPUDHHeYahTE9Dv	1406	1393	57	1	5654	jwmnCUccHyn5fYazAR1kSK2gGCKVfynxJpokJRReuH85gRQy3FA	3027	4258	4258	1616705640000	canonical
5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	5833	3NKmYaFMgbcBvR4bCQeSpB9Tc77r75b8PziimyBGT2zqjuJKosxm	606	1049	57	1	5656	jxjDu1WkbRjKcc6arhaxSg1FuKkgEvkbnxnDx2S88RZSiu2GNZa	3028	4259	4259	1616705820000	canonical
5836	3NKiAnUVFFGdFRUv1r7vdWZgAM4rQTq8epCzDWTEj56UiPJSJxHU	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1403	31	57	1	5657	jwMo9Zh54viGGtthRLwjbaav1c5FfQiTMcsJV2EPTwx5oeMpD7f	3029	4261	4261	1616706180000	orphaned
5850	3NLVp7PdDf9ubyBoBMMhgWz1TqzsRDijhD2HKYKiJvw5Ntziozwj	5849	3NKLKHpqh2S2J7EawToMS8eZrQ6RWjD5humCSBPr8G99SSN7RzF5	1483	217	58	1	5669	jxxE9cxyN8Rgg9SSZSHeHBGS1hc9VwSwXj49uErmT9DnheepXzC	3035	4269	4269	1616707620000	canonical
9113	3NKNwGt3qTojZWkTGWd5PrKHa73GNyV6jyVHJERfeLe9BC8WLL8E	9111	3NLE74twfpogDNmvovyGdVmeqJjhYKovbHm6ztgqXWjvuj2qnCF8	1637	816	111	1	6301	jwRe7GGMC76xjNchuPYvakDN6ZEMMjCfQVgiYG9KE9aorMfjFdY	4722	6651	6651	1617136380000	orphaned
5764	3NKs5TksyX1eSQQ5uiqptXT3fd6kTsQLDfrmU5koPmn4HfWW9ixq	5762	3NKUkJPeNHKYni8JeS1NFtsPqzBjgLjxvMvPkwpSWtv9mNMAGTkN	1481	790	56	1	5588	jwjUaSdZzvBgWECyXuZj55DUpM7owtcyzpEujEwAa68FBm1Zhcb	2989	4200	4200	1616695200000	canonical
5774	3NKxVcd8DixEjjmuBb2k5xW5RTSMwhNSpRJNJ7KcKL7RW7jAVY2t	5771	3NKzMGUSK6WQiEW9Nq2BgePhiyasvaDco2ZtCt4jtxovpzgMFRyN	1637	816	57	1	5598	jxso1KNg9mE3eu36BxwvpnxygrJ4foSPw4APmV4Gyz4kprgpXu7	2994	4209	4209	1616696820000	canonical
5778	3NLsmMKXfF3AoETrSXMH2tJH5HKTVwzHPmspVU8CcDTfavSm5vLA	5777	3NLErCCE1J7Rgww1EcvoMTdLhCrZcMfakt3iDQ29JUCNR6nDPNhi	1403	780	57	1	5602	jxjUJ8bkk8yYsGsqk5rDqnBoGR2XvmPnNzXx7zfaVgXGB9cZATZ	2997	4217	4217	1616698260000	canonical
5781	3NLK9CQUuZEkb8YTjE4fr5Mn513TpumRaogY5xcShiWGSKD1nvX6	5780	3NLvbgxVtrcH1VoWcxQpMyBERHmrnJzJ4sb26StczLzDeLtFVX6X	1610	1314	57	1	5605	jwXRiPbrMTuEDAhJ7u2E1ZNpyH1ejJp59e76piif7Ksq5YpHWLj	3000	4221	4221	1616698980000	canonical
5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	5782	3NLDwWvRszZVWdzpKwbgYogu4dpeHEfez8nXLorogGmvxTmuU5h6	532	1303	57	1	5608	jxMsHGt3B4T76eGVKh5sTwEEwGpTF8CZHPKkABpMNtvC7gyiGSd	3002	4225	4225	1616699700000	canonical
5787	3NL2QU9nHxkFeJ2onbDceqgMPMfkf1Ywe2N1emWEwtNNLhR8caZR	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1403	824	57	1	5611	jxr9wvhGU8QqqxsqVBBj5khwfZQHbebJKQsgcrDUpzzZ2F9txnw	3003	4226	4226	1616699880000	orphaned
5791	3NLni7PWFZXrMsY1NckFUVBYzXNhf5UZDpvTzNi1AK4tR6JdLzQD	5788	3NKj99j7Gzt5sTtu9eRMt7rfmoC3c4KSgBGCULdNDMfVSnF9Ccer	1507	1280	57	1	5615	jw9vY7B6LSKqiV9NRiMMwgMvQDEZR5vSXSCW8XbzFArjVwKYq68	3004	4227	4227	1616700060000	canonical
5799	3NKL1gbCkiP74uk3WTg4uZoZNNc7PUuux8w9tveSxhQMzpD2geFz	5797	3NKUxQD9gTPWpHpxvsnpfT3zYT5NTtnLNVwyVgsU4t9fTZsLxbr2	1406	1393	57	1	5622	jwbh2eS1LKU3Dj4qTZKSiPo5hfYijqprLjHfUbTZa1biTUA3do4	3008	4233	4233	1616701140000	canonical
5801	3NKJgvNxejf6VAxkjcB9kptveLRBSMYtiW1A6S3yo8ritFJaiC5d	5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	1403	824	57	1	5624	jxuY8ySspfdjEB4uySqnZJEXPttuEJkfB39CQyWaJaEvoAeDpP2	3010	4236	4236	1616701680000	orphaned
5809	3NLGRLWDoGDEHMGVVB1zchnaQrNaZy7Bvidqm63nvgyV3Zu3UaXC	5807	3NKNWiadtQw3jgVmCKHtG1E5H97Q9vsVNPq2t3cRnwGsYMjuuXjd	298	1062	57	1	5632	jxjc2mkSuoW19XEAGkT55vbUCRcBpDwZRvcWMjgBVNbVciFX8go	3014	4241	4241	1616702580000	canonical
5811	3NKHdTkv41VrnJy7EddFrZThnWuRgx19hRF5UsujpYY1vZzcUXUj	5809	3NLGRLWDoGDEHMGVVB1zchnaQrNaZy7Bvidqm63nvgyV3Zu3UaXC	1406	1393	57	1	5634	jx3WWK7vk4w1j661QrgFdrP9seytGgfwfPdtufovk23uNC5bJA7	3015	4243	4243	1616702940000	orphaned
5813	3NLvHtp1omFjsVyKTUChGMtSFfWDt6yeqAayzMbpTG9h3W1qmihG	5812	3NK8x2GJASg4kMo1t1GCiZ1VxgJheksTeMyFZteiyVx6oanQPg1C	1503	1151	57	1	5636	jwJQ6EMD1WBmeGpjksPjgWH2ZdQK5TtTXjGRC9cpHkoeAVxiXrq	3016	4244	4244	1616703120000	canonical
5817	3NKgKQWW2ZsGdRpcmgeTxmFiHTv1th5PgYaAFQtKpPEGZwbDK3yV	5815	3NKeV7wkXCBGb8MErrYEggRwarsobS7yFZzD2NxkgzZ3WU9QiWUx	1501	1114	57	1	5640	jxJRpmYU65LMvbFXVAg3cT8LngqzXL4MXXaPZqbMEEqfC6K9xbk	3019	4249	4249	1616704020000	canonical
5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	5818	3NKfkGSFBrxALqPpXw79BqSRdExC2YHHKGXZvzwJkPcCoVMnhYwX	1423	234	57	1	5645	jxyySQ5KA9ZmrtAdouZFe8VF13B4jkTj2ewQhDRE4LH7AbjSkw1	3021	4251	4251	1616704380000	canonical
5823	3NKf7JM7nkaEzKmtrxGuKvBXiQj3BqHb4kgbcc52chzMjTi1x7nc	5822	3NLB627B7mbtZxmYDdAafunFeX1cmH9Z45oDHSLMMrLXD7kCoPCf	1523	1321	57	1	5646	jxEEoMo1Ji6S6BFPLVcxRJqAYjzsotQRr2zN3HEPX9t5kqUr484	3022	4252	4252	1616704560000	orphaned
5828	3NK9xoe3vEZuBYZskJ9ErLEitE3qk8yk3o35WW7Fjo7MjVNPaS2x	5825	3NKX8RJMBLX72SXsqBTACg2aa7yDEvupkzJZZPoyLVB1SjiAxUPg	1656	1343	57	1	5649	jxhpaZUau2cRhfdoJvb9b3sgNjatc1prfSJk7xThLYDUC8kkDs4	3023	4253	4253	1616704740000	canonical
5830	3NLX2YUQJLyL9s61kMkQwRe2vZUhdLxBM7XK7yRm7gZGVzRvtsmH	5829	3NKDaAijpAQEraNQBHrXVaJR37t5Hc5Ad9NaHHNDkvEsm7kAZBpH	80	1027	57	1	5651	jxtvcRS362bYrMSVx6Bhv6o2u3q8eo2eXoQC2LsftQdrHxkjQhX	3025	4256	4256	1616705280000	canonical
5838	3NLP32vYZmu4zEJ7r2YLcwJ9LuXwrnFvq78Ph7mDS7erJ7tE3u8c	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1406	1393	57	1	5659	jwgPV6se7aeVres1Sg4mLChivNE7NgZjmDRXs9PzBhKxM9NghBq	3029	4261	4261	1616706180000	canonical
5839	3NLTq9McW85so8kWR7m2iadmiqyQDXpG8KYvvvvYYnHf28eNXrEF	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1474	1083	57	1	5658	jwPCtLMx3tnpGc3kKQanHPwScBxmraE29zwE7CZKHn5mPZN8nkA	3029	4261	4261	1616706180000	orphaned
5841	3NLMECpEn1s7E7eRGmr95wx16cdz9tqSST2jvaUSKYpauYSCDfTd	5838	3NLP32vYZmu4zEJ7r2YLcwJ9LuXwrnFvq78Ph7mDS7erJ7tE3u8c	1422	1091	58	1	5660	jxLKew4LFkXA6rKrESqJ68mpaujARXVh38CDYbNkGEuz1u9iw77	3030	4262	4262	1616706360000	canonical
5842	3NKugjYmMXyP2nCmDaWr7JSt3rCW5FKuuZKgdnx17o2F5yhoH8Cu	5841	3NLMECpEn1s7E7eRGmr95wx16cdz9tqSST2jvaUSKYpauYSCDfTd	1649	1257	58	1	5661	jx6n1opiTcTLvvWTPFBL55nAS7ywF8xsEyWxDDb6x9rMs73HbGJ	3031	4265	4265	1616706900000	canonical
5843	3NKrHYJ4SeZvWeBTzB3US62vmKNQSDFj7T7wbG7YFVMPEEqNbDVS	5841	3NLMECpEn1s7E7eRGmr95wx16cdz9tqSST2jvaUSKYpauYSCDfTd	149	1283	58	1	5662	jwg4jsHrRcqrggNftYouGmCgD4mH5G6e5bJYJUj5Kck11Gd51nK	3031	4265	4265	1616706900000	orphaned
5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	5842	3NKugjYmMXyP2nCmDaWr7JSt3rCW5FKuuZKgdnx17o2F5yhoH8Cu	1547	1132	58	1	5663	jxe9qwFBo5df9Dj5Ko89ybxDz8WkBAsTcN1pdTNK26PjnQxtymY	3032	4266	4266	1616707080000	canonical
5845	3NLdL9JTo5nPAXXjxdcH7Gfcm28ZFSeAiu7b5YEXRiNFv3Y2HFRH	5842	3NKugjYmMXyP2nCmDaWr7JSt3rCW5FKuuZKgdnx17o2F5yhoH8Cu	1403	824	58	1	5664	jwBFhayzNzBE9HyFPWN4qjM5jH6xjFZkkgKubnkM8YoJoDWwJoj	3032	4266	4266	1616707080000	orphaned
5847	3NKRwRNGFLgee5CrZg7N5eTrvZbataKxDY82VYVX7otampKcnumi	5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	1555	1347	58	1	5666	jxhSo2fi7VZ7iqjpB5prwXjdFBoMumGk6ihj53g8yCuhghEPhnW	3033	4267	4267	1616707260000	canonical
5848	3NKacYD6LHuMXKd1GbogPPdoNK8HCGjq3DghEP3ua1D3NFHMELDy	5844	3NLQ4sSe2kzA9YNh5p2sNkHEUfPVg43X4nnXfpg433UM4Xrtzv3i	1633	1390	58	1	5667	jwbybwkHLM1t4uUpKNXnaF62q38W92m6i99mFEdAMLjfbcxLyRd	3033	4267	4267	1616707260000	orphaned
5849	3NKLKHpqh2S2J7EawToMS8eZrQ6RWjD5humCSBPr8G99SSN7RzF5	5847	3NKRwRNGFLgee5CrZg7N5eTrvZbataKxDY82VYVX7otampKcnumi	1571	1209	58	1	5668	jwn4GvC8xAgMbn2vzEWgi9FqNpDdJSzBYy4JAXVnfR9MtGNTES1	3034	4268	4268	1616707440000	canonical
5854	3NLH5cwF5RoPGSmwLx3kbRUoULverU2WRGZVSSWZv5QCT2KnzFWj	5853	3NKCHn1vX2jc1kmNHTuGP5eZ2LHcDs8Godx73QYDrNqW6KjCwzFw	298	1308	58	1	5673	jxPhGzFvECzvm2VFyZoSCnodzQs6xTizetKy3kpdBA4DVDKsbSz	3038	4273	4273	1616708340000	canonical
5855	3NL7tBDHTKEejitT19e69waZwqQjUr4wPZCPnPqA4azn3tyaJYv6	5853	3NKCHn1vX2jc1kmNHTuGP5eZ2LHcDs8Godx73QYDrNqW6KjCwzFw	1403	824	58	1	5674	jx94CxaBK8hzZZzSYw345XcX1KJg7SZmFd8YACTtdgioaJbL4zh	3038	4273	4273	1616708340000	orphaned
9119	3NLPgFaPEwwMVeZrmHwsDhQsR95NGmnXJBxn83eyCi6cYk4Usc8y	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1601	1142	111	1	6301	jxs4CDFCtR8Brp1tM45yMAVhXhef7oXW3xHNQ6SvDxqrN8nXtvq	4724	6655	6655	1617137100000	orphaned
5859	3NKkcJY2ZxoXfuUDM9ag3zCZtzndMnYv9vGtXUXFJMcvZa3E464n	5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	1407	1395	55	1	5678	jxSJB9exrsWwpyKkGuoqwR5N3z5z19nXxnXVjxbjMdkL66sXbfq	2849	4275	4275	1616708766841	orphaned
5861	3NL5AtamHbfXhKL4m3jBu7r5BV1YYzZfYt4cHB5iP5YrvxXxnTDc	5547	3NLfTJiH1agfkXoXCFSB6MCheL5pcc3rpJAAErAH7WfjjbLh8EgM	1407	1395	55	1	5680	jx8hbXaLXePSqEUQc4V3hzCgtGRnanezCwo3v8FpnS42RBVpuzo	2885	4275	4275	1616708830580	orphaned
5906	3NLFLPa3tFBv4AZ5w5CeXjnyF6V7SSo5ymNUjeDXMzb36pHJMmgt	5803	3NLvG89UqMhUwBEWxMvZgGfbiVVbKCoPETYb59dFKZVeAQAwx1TS	1646	1108	57	1	5724	jxV1oF3P5hHA1XZAFUkk4xBCAWKSAjA4Y984ScLFFKmZCkkDLMm	3012	4314	4314	1616715720000	orphaned
5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	5854	3NLH5cwF5RoPGSmwLx3kbRUoULverU2WRGZVSSWZv5QCT2KnzFWj	1406	1393	58	1	5676	jxP1yj42FUGenX2W6TdBdcS17ovALdCUKVm2TUEYC877WrZpFtD	3039	4275	4275	1616708700000	canonical
5865	3NKQB5CJPyiRNK8mjeHxLDMTbB4xVKvRBHyPLN5RJv78v37GCGjX	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1501	1360	58	1	5684	jw7g3aa9GuZYC4smxsnr8zCp4Eg3NqkQmUcp3r5SNjurUxHhnk8	3040	4277	4277	1616709060000	canonical
5864	3NLCEW8dUnDQNZUp1DqdybcVsD4UerN4pRfJBEm3SprSFoPj6Nou	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1406	1393	58	1	5683	jwz32cFw9NRoa6kSrvxt2bY7gDhw1mDMznJAGb5JBqC3uWVihdq	3040	4277	4277	1616709060000	orphaned
5869	3NLXM3TfbntYMYpugBqGfM53kmdRMZHZUsASK6FgYmDMkiRWQtUj	5865	3NKQB5CJPyiRNK8mjeHxLDMTbB4xVKvRBHyPLN5RJv78v37GCGjX	1560	388	58	1	5688	jxSWubbZgV1FAPSfgLKaAU6ggUfxcx9Cr9wF5xWDgNQKqixa6Vf	3041	4280	4280	1616709600000	canonical
5868	3NL2EoCER1FQ7yGvZtZ7fD1RnAQ16bqZ59M9TccvXKEfGt1s9iPc	5865	3NKQB5CJPyiRNK8mjeHxLDMTbB4xVKvRBHyPLN5RJv78v37GCGjX	1422	1211	58	1	5687	jwiYtq9HRHLMaRu38KVYy9Swnynqs7mMHcUip2KnUG4fpEYhWvY	3041	4280	4280	1616709600000	orphaned
5872	3NK5dhgrBjswLoRWy2JCnjLf7Ctap6EWom5i6Uzjfjk6fDThBM36	5871	3NLtErv9ttGYTqJXByEy9Wid3k8nfgZQtGfhDTkrxvKS1E6bFLyM	1609	1087	58	1	5691	jwQKxWtLWWr23kxWq1DE1WYQxSttVhcBjhkFFpXvB9oo2dBXjmE	3044	4285	4285	1616710500000	canonical
5880	3NKt7WGcRhMPYywF1hyWVgkzhsEoDptTkz9QYnfNyfsYuTci9Gna	5878	3NK5CXNiV2gjwDt9Yb6oKoHH9gn478p1CCPEvjgvNxD4pqjpwMZQ	618	618	58	1	5699	jxzCCtKdAJNuEQeMMaZq2iqKcVQ79XdPF3kbFkU6GipFwQSaHtQ	3048	4291	4291	1616711580000	orphaned
5882	3NLb7iDcek569ohPHdFN31661vagq369FmoUgZsiWWSFKtFHKfyb	5881	3NL17s9PXHYRuhxWwCU6PAqE34vR3C1UorJoqfLeQf2s7KJAzk4J	633	1138	58	1	5701	jxt4jAa94q6frtX3qzBXT2h7tZ5RdkbfZM7PaFoWr7WKeqe5QYw	3050	4293	4293	1616711940000	canonical
5933	3NKJFWBKmYSUf92uwMrMeqVsuQQ4T6wLm2e1iuNnbcnmLR9aPQer	5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	1451	1166	58	1	5751	jwSGGxfL7aKeXYz2PdXN6m3Zw5qZZ5KfCWUBxBDL8sPhWzTUUhe	3055	4331	4331	1616718780000	orphaned
5896	3NL8hQ6qvHVC33H1P6RUVnQGxmG3cg7rgubjPhYF82Sc3gK5fypJ	5895	3NLWLvFBthg4Vah4SfD5oB6BCTka5ALG3Lp9S1e54JFafE3Gjrs5	1397	828	58	1	5714	jwMdkpxJ5YZfwSSFAP4hGJhUZGUvDSMVAeYtfmtDGLA5D3hF8R1	3056	4309	4309	1616714820000	canonical
5899	3NLYwLVXQTx6zA762KWS1QzNcpEsUq7wPPEmJNYwYnETnXJZ8wUi	5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	1513	1133	58	1	5717	jy1Vz3wtB69BsMZbxcxTqzto2PSfdy3hozBUpdg1RZbFzSrxYiV	3058	4311	4311	1616715180000	orphaned
5910	3NL74WyKrrQb8t6cJGzU2a8XmE29GL6nMQw1XQzjm6HG9h1GYZxQ	5909	3NKRgHcsgrRvYYSFsQc3oLRnv4iSrWJR9U3PwgkWNsT9a9iNWxhG	1634	1331	58	1	5728	jx5xcPxbAauH2fUcwCtU5KfnKiaW3XrLu1BfjSmp81F36wYFw6G	3064	4318	4318	1616716440000	orphaned
5918	3NLCeEocBgMLUyyHBHGR4Bq5orFQuWTTVrXpedomFmiw7s2cDzTZ	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1611	1341	59	1	5736	jwc6x4VTyF6WaWerY2TzHAiLXxpBjdtkHZnSjVqDypZ4L2EGoup	3067	4323	4323	1616717340000	orphaned
5922	3NL4JpizrAMq6mn8PkUU4DLJjLZGsta2Bp8SnzfM2nBkJKrLzJrw	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	576	1109	59	1	5740	jxAURUxZxbJs1jwVqtFTnHhZSqZVRkhoJqbSEWu5SNJ9Bn3xS26	3068	4324	4324	1616717520000	orphaned
5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	5920	3NLj4K9nzbYbmm6qEd4jihFo27FQQh2h6BzZwqc9JE48kkYCTanA	1654	974	59	1	5742	jxbvAng6Xh167PEeSreRAavGNwhBXD1ci29qZUhJ2tpaJ8iJaRY	3069	4325	4325	1616717700000	canonical
5930	3NL8YrCcR6jUitqL5jfRo8KPJTZCzrbCrv2ZHmwDqPudyZwywa5n	5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	1448	1065	59	1	5748	jwvcZRNbYwXzokECscEX4cyE4gMtGYLroxs6WrsvyRwUV2ZzmXZ	3071	4328	4328	1616718240000	canonical
5937	3NLSpF7HzHKhn61C7miP6we4etLR2cWkbxbMB1qUwDPPKa7Pkwjs	5936	3NLhYY3V9wbfpMMEh4UCviPzTGyXqcd8uRxsnic6vRCe5v9jZSUS	1406	1393	59	1	5755	jwrSvHj2A4saz7uvtKBUYiSNcD5bUe8APxgnrNt7gVVjGG9XWSo	3075	4333	4333	1616719140000	canonical
5941	3NLuDtsZgndLRrs8VoaS2JVgQSTkJmUJCa6vs88okPyTvbnLKjRt	5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	1509	1320	59	1	5759	jwdupitUQQXQnYwYiJvxR1duqmWBi8qwTQXCea5YaZ8AsuwP2UG	3078	4338	4338	1616720040000	orphaned
5945	3NKffMoRZTWJfVVWczEN8FiFoNKy4k7qqHCN7Wgk9MRikqynqsk8	5944	3NLN5ju3kpR4aBFvT7KejjEqHLWGB3AsojwjZkSS52YqNMp7ehKq	1483	894	59	1	5763	jxdcqQiMyP3g1UXdfSmHyT6eVtMWDxWhMAiTGkthDnFZ2HsnReM	3081	4342	4342	1616720760000	canonical
5948	3NK6habxNUijmNTKFCwUDpZwC7Wryxbc9f2CmbUT9bgvHTqTAmAA	5947	3NLrXSwzdJdwQN3bf1sTD9SDeFmd5Qba4WVUmrUmdbB9T1ZwZuXU	1589	920	59	1	5766	jwe7M9jadX5Tb6tUJ6oV9bdBCTyXEzkxqsjsMMmpXrTwFpvPKfu	3083	4345	4345	1616721300000	orphaned
5950	3NLDqbvArSRp5Nt9tT3TLF2kKuG9VV492kbrkankArapdawsb35i	5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	1607	982	59	1	5768	jxMLUoRn5gYEBDaiHSyCK9WNBGpxE4wVXrx9pHJ1t1VH6MFsXBz	3084	4346	4346	1616721480000	canonical
5952	3NLPtLHeAmRy5KSReNjcurCAEzNcWh8jw2MU9jaquJwYymMu2oTQ	5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	1590	1054	59	1	5770	jwyCxsi5EBR5imG74RDnt5yyqqdtq2sN8M3jSsARkpVARN6rNnV	3084	4346	4346	1616721480000	orphaned
5955	3NLCbE3Gjok6e25avNHJS9muKeGBZvwoTiGMr4EZHwxuZW2TgnhM	5954	3NK3F48Rg5pXQC6JjRcTuE2zuELD3K6hN2Aduq7pt7iczgzXA3Jr	1623	839	59	1	5773	jwshenG7yQYzXtjfaTJdHH2JTncxDTLnjkU3E6u7gC7RwySHqQm	3087	4350	4350	1616722200000	canonical
5958	3NLib11hVTmZ1FCy2zaiQwzpx527kAo5rF81ADUjpYZq7DUvbLjw	5956	3NKQDyDhco9Znyznt9V34r32nAKU9QVn2aQb96XSA7VSvHurB6aN	1573	1072	59	1	5776	jwpnHTAzGHznWKa6ca9gjtt6gwLby3wAKeekkXu5zTkUQU3sMQA	3089	4353	4353	1616722740000	canonical
5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	5960	3NKv3Q1aCmYDeExC5Q2tNqTEx4JavqHPaoH1CRS1v82wNHAg7E3n	1670	1282	59	1	5779	jxjRt4As839429BhBZwBvD48XMuRJCwyMYZ9sW8yRkz632LXTGh	3092	4357	4357	1616723460000	canonical
5964	3NKzPfAHdo8tSmFnveT6FX4VSsrGgmtSbEvFJ3W7RbC4MFPMFLhc	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1609	1333	59	1	5782	jx4pTNyT7wpc6CgQz5V6QyrEBdUw6cFkFtAeVr2AL88su5FDz8J	3093	4358	4358	1616723640000	orphaned
9145	3NL4DvJi4AaJpzfrkUqhhKowxjaDdB78EmTyppxnKX3CLTrXLmw7	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1407	1395	112	1	6301	jwceirZZphKCgGvXwSPN1QLUetBheKgdYHTDrqtmfui5bwfFibA	4739	6676	6676	1617140880000	orphaned
5863	3NLiqe5aRDTwBoZAzjHKD5dPz9Qb2hLZnqx2VsNB7Zq6Lr6a8Tuy	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1553	776	58	1	5682	jx8yVkWpQNfrcfY3QF3iKyta26d9hmHqFU2rpP77BNfYBjzhMtK	3040	4277	4277	1616709060000	orphaned
5873	3NK65DXMykeUvJ238pwdQEqZPuBs4wTFLJU8bX3ptHgnpYfyneX4	5872	3NK5dhgrBjswLoRWy2JCnjLf7Ctap6EWom5i6Uzjfjk6fDThBM36	1571	1209	58	1	5692	jwAcWyxNXWDJK3DvEgU2Zn9Nv5SeVXXRVUBi7kPuKLFUGueg3pZ	3045	4287	4287	1616710860000	orphaned
5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	5874	3NKHrYRH982pVgZB3jUNpdqrZtm49HyaTmNriLSNFauFUgNMtQYE	1623	830	58	1	5694	jwSkxzPjBQ3iCsWYdMgTmdAiSu3h5g7LKeGUYa3PfNmXX9TgT5t	3046	4288	4288	1616711040000	canonical
5883	3NL1TtHsTHHjq3xaro1EVn2MwV4qY4QqEDYZq8Nj8onUqRdvVryN	5881	3NL17s9PXHYRuhxWwCU6PAqE34vR3C1UorJoqfLeQf2s7KJAzk4J	1407	1395	58	1	5702	jxRTmkjMPdujJ4Wa1hhZbdAcwocauvuHv53x86jjaHpJSpLaqs2	3050	4293	4293	1616711940000	orphaned
5885	3NLtT55J7QvNEm8uVTqwtU6VUN21Eyg477zF3nKY7uhgawoe9Bdn	5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	1622	990	58	1	5704	jxwECAJP5WXDVwdMWwDQDBm2YLv3PrpHKWvFngBYPbTnY7wJKcr	3052	4296	4296	1616712480000	canonical
5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1627	1139	58	1	5710	jxq8RYFhVC3bwfccYyDu8HdYxvBM78hh1EicvU4cou2uUMKfMQc	3054	4303	4303	1616713740000	canonical
5895	3NLWLvFBthg4Vah4SfD5oB6BCTka5ALG3Lp9S1e54JFafE3Gjrs5	5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	1637	816	58	1	5713	jxqaHFf3xEF4adktTvpk8yXQPYUncmh3Se1fRGeTTpnaWNzsJE3	3055	4304	4304	1616713920000	canonical
5900	3NL2JU2yhwqRBibvqmEeyZcD6X57GRW53MJDe4yMYcFNzVkvMhgd	5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	1559	1353	58	1	5718	jxHiP2PSB919ByGqfx6oZHxKZi1uJoEKX771ZaaNaXFsuFRyvdF	3058	4311	4311	1616715180000	canonical
5908	3NKY9nCYK99qjBxYnL2bXq2zjgU6MCT42sjr4HiYeeFw3pPSKxVp	5905	3NKt77k8ye1bFTTWkuDiaum3GEUh2Bv6Zf2zsMFPjWutj6ppP6ZG	1589	1160	58	1	5726	jxULQ4CbQK9sHxrgG2SY1NbHYA8RtgCbYRnswCgn2K1NVTzNBsh	3062	4316	4316	1616716080000	canonical
5911	3NLKSewpvmv1poV2EjmPG1eijjGS78J2U3eSP9mCiTaSRfjGox91	5909	3NKRgHcsgrRvYYSFsQc3oLRnv4iSrWJR9U3PwgkWNsT9a9iNWxhG	596	1306	58	1	5729	jwbz2ZJEqUmsLtcFaPLTpo9RzFf16puhmiJpP4x4vTsSKJTrzJZ	3064	4318	4318	1616716440000	canonical
5915	3NLuohAeuvTbFrwknku46D6bNJ27qQsWWjQqGHVcc2fSjzMMN17o	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1445	1044	59	1	5733	jwMMJZjCPdB8zYkbGgqWCXuS5a8fGciapiqp7xkoxpJYTwn4Jc7	3067	4323	4323	1616717340000	orphaned
5923	3NLFXUYMYSUKNcWntRr5FZjnwt5W2zfeANPkktW7j6md6ULCPVF4	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	1590	1174	59	1	5741	jxZjVCVNQLRDC6LRePwp6G9dRc4vvQUrUm9oQYZfc5Ap1bACidQ	3068	4324	4324	1616717520000	orphaned
5935	3NL2APngextnQ3q6P1vPUGJehMfyYMFy6HurrphxBtEfThNXR1cE	5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	1483	658	59	1	5753	jxAGY59SYtopujSxxPXTewvMKShz1JBLN4paqXYJFfNmVGSp5AU	3074	4332	4332	1616718960000	orphaned
5938	3NKRitRWe2FnKCF2MUroZxhf9RF9TWtJW6C7F5qBvhvib87vUgUa	5937	3NLSpF7HzHKhn61C7miP6we4etLR2cWkbxbMB1qUwDPPKa7Pkwjs	1403	31	59	1	5756	jxg7PXTxSy7F4rZwXg6YS4LfnxM8MozJe5VBcNFpnWHJ3ThXftX	3076	4334	4334	1616719320000	canonical
5940	3NLxYDmLvTyofUHMFggqcFNEYpNmDZog8Dn97dMGPpmV15SMLWT5	5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	1546	1339	59	1	5758	jwcAoXnuxMYuZHnidVzHxTsUNp9tVEwVcc5XMS7orBjEiGgEsa6	3078	4338	4338	1616720040000	canonical
5943	3NLkj9eGXut38aMEn4sGvNVZ4qyYSNZQ9fZ3SXYWmJUAcpGpSiVd	5940	3NLxYDmLvTyofUHMFggqcFNEYpNmDZog8Dn97dMGPpmV15SMLWT5	1460	565	59	1	5761	jwtoma3iggbjmkZsuaxu38UP3BiG6zvatfrBkyy3QPZTseT1Wbw	3079	4339	4339	1616720220000	canonical
5946	3NLsUTdwhfaK5bpQQSpFVyaUiUjJg4bPoWRPm7wVTfsBQTy8GFZ3	5945	3NKffMoRZTWJfVVWczEN8FiFoNKy4k7qqHCN7Wgk9MRikqynqsk8	1647	1302	59	1	5764	jxUDhLdUSD9mfXeuaZpFDEQFDjnx5RG7G5d312CXSKkdkdJQdHD	3082	4344	4344	1616721120000	orphaned
5951	3NL4NwK4cWvrfS8xa1D9GkBFG3ezXTiM4jHgEjJQLiqEoabbo1R8	5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	448	1305	59	1	5769	jw9qt8KuaqDULkvn81Um7a3mmdNjS31GJgHDFvnHuNidUEWM9pu	3084	4346	4346	1616721480000	orphaned
5953	3NLhVFVjFqrYP2tGojQnn8eYuyMCJUReoat4xX2jC8Ybv2MY9XTW	5950	3NLDqbvArSRp5Nt9tT3TLF2kKuG9VV492kbrkankArapdawsb35i	1637	816	59	1	5771	jxwSrrieNQV8q1hegU9KsyYskXVQzTSfwWDtANLvjoBH4naaKtr	3085	4347	4347	1616721660000	canonical
5956	3NKQDyDhco9Znyznt9V34r32nAKU9QVn2aQb96XSA7VSvHurB6aN	5955	3NLCbE3Gjok6e25avNHJS9muKeGBZvwoTiGMr4EZHwxuZW2TgnhM	1578	1296	59	1	5774	jwqnM7CbhtVQwQa4WTPdhXtVdoUdtY5DcCgF4SiXgdfraKskGei	3088	4351	4351	1616722380000	canonical
5959	3NKXzZowXt9wEPFkYCGk1QTS2WS5CuW2cTVwepm68N9q4wv5ZQPN	5958	3NLib11hVTmZ1FCy2zaiQwzpx527kAo5rF81ADUjpYZq7DUvbLjw	1407	1395	59	1	5777	jwp2scdZQh52Kyvn25SmMfGkMoUqkasEnS6kHoRcEkRLFtBSV1H	3090	4355	4355	1616723100000	canonical
5966	3NKwzTeUHkSG8ocoiMxcArNbittv1BjcG3YzxpRzgBHzkqeEmKmy	5962	3NLgB2Uyhn9cLzBHwsqeqHmddKr9Gg5kZySBNv8SVJzGHFGieps9	1560	1165	59	1	5784	jwZhxagfkepC14d7xQ9qb9WzmqTWdJ1XYk9GywVxf9oDSAT7nfk	3094	4359	4359	1616723820000	canonical
5969	3NL7565dvmSA5qUN4ekRZvF7oVEUyK1d1CYyAjFrzG8fYumK2FV8	5967	3NKuPQHqZWLH6JcTerrZyvBdcMDxZM4aAMht3D93KwcMimxZhxvA	1403	824	59	1	5787	jxnuxoTphtRYVcNuJUQ6GMvhFZr6qZabE8P5V5xvedJtUsTRJJP	3096	4363	4363	1616724540000	canonical
5971	3NLAJgRwMTnAoEpGxrb4yZHWgBUnyHT4ear5qvVg6giaghosw3bj	5969	3NL7565dvmSA5qUN4ekRZvF7oVEUyK1d1CYyAjFrzG8fYumK2FV8	1448	1065	59	1	5789	jxoj6VpxgUHkDRyJZ4rLvZ8PU9gp6xaqBDgu1efwrtVnnJJfLSq	3097	4365	4365	1616724900000	canonical
5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	5975	3NLkfkPwYeeYwu4k8fa74UYQZ8m1qTjCf6wc1wTsiHhUWt9Q8epk	1609	1333	59	1	5794	jwSF9HBaw9FJvN78Vv8NhXgStaRkbkEJcapSTKmtxHv7YuegUw8	3101	4369	4369	1616725620000	canonical
5978	3NLe3APFs7QQFFSWBeCky9f9Ygxsos8FmAAQkczmUvz8mMxNbvWJ	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	643	643	59	1	5796	jxcz2ugsijdeaFP1hYFmjh7xHLL3o5KhxgYzJvGykyvTPLVT4wq	3102	4370	4370	1616725800000	orphaned
5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	5981	3NKMa1enWLUCQAuecFxpfdcgkQ8bhm5LMi8aNWzZY1LvF7RSyMdn	1578	1296	60	1	5799	jwZhS4WiMBWHo2SRCkozp1DF1WKucFsmtJjXXUjosGgwyW4zzKn	3104	4373	4373	1616726340000	canonical
5988	3NLeRHbQa6KyWAyST2fQge49NsvWavV6AJQrU2WsDcwtfyii3V57	5985	3NKZirv6rXxYRXY7sqpspfbYGZpGGdcgMZThg8pHb3Y39RMinfhq	1585	1000	60	1	5804	jwYJ79HoiaabDuqDLKR7FECJvfCZGv9ez3HGKiTQse99pdRQL8S	3106	4376	4376	1616726880000	orphaned
5990	3NKX1SWfQ5AaDT8cPNHkh2BjP98tj4SkoXiPsv2LwaQkFe5TrfaA	5987	3NKZBiMmaz61C3RUf4yUJs32DeVAkG7ZPqEtjUeHovP3sVSoSoQz	1406	1393	60	1	5806	jw9Vba5SzJWthJprczv1kbLdrAAuDqfKZ1ZMJDJAe3zBbhdSNf1	3107	4377	4377	1616727060000	canonical
9252	3NK5XU8tTEX3gHufSQ1dXcjtf17hTJA3Sd4weoAvpbgANkiiQGZ3	9163	3NLZo8TzjFtNi29N7f1p652WEPpkkbGLdYLi3LCmf5mTH44EuKP1	684	986	112	1	6301	jwPcPrUFTRHgGvo9taVFZoLa2acdduQCraqVjwwEZXXvgZVGVKD	4749	6762	6762	1617156360000	orphaned
5870	3NKDsRVh7gdFGBNLgG2H4LN4AnbNmYtx6QyBM1E7iHX44eMvLZF5	5869	3NLXM3TfbntYMYpugBqGfM53kmdRMZHZUsASK6FgYmDMkiRWQtUj	1467	1250	58	1	5689	jxUYbcnGAzPsWSpGkj5gy2vn1qMbfq4Ky3aqaSk4jg9SAgifAhC	3042	4282	4282	1616709960000	canonical
5874	3NKHrYRH982pVgZB3jUNpdqrZtm49HyaTmNriLSNFauFUgNMtQYE	5872	3NK5dhgrBjswLoRWy2JCnjLf7Ctap6EWom5i6Uzjfjk6fDThBM36	484	1193	58	1	5693	jx9mMyYziHqoAhF9WVu2X6yBn1D9RV1hQmaM9XLvFLaovfWqX2Y	3045	4287	4287	1616710860000	canonical
5878	3NK5CXNiV2gjwDt9Yb6oKoHH9gn478p1CCPEvjgvNxD4pqjpwMZQ	5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	1506	1373	58	1	5697	jwSbVuT73GrBNJw4ccgXgSVe7acLDWZfEcMkJspYoGBcshvoBHj	3047	4289	4289	1616711220000	canonical
5876	3NLRwcHjQK75mTPMJ1FL4hNymVpVSYxVwqPYnfQZ4TzBS6Ktzyqh	5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	1407	1395	58	1	5695	jwvQZDq8TQYy8Egh6QoGwmhbZceiEwUnGsKr6pqA8Q1pUgFQKJj	3047	4289	4289	1616711220000	orphaned
5886	3NLopjKmKtQL3BnK3F4nLfm1FGzS7FvbKvKXcgm1x5YdYjbnbhrm	5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	1403	823	58	1	5705	jxSbzBg2LWTXtUDic7dMXdnPGafHWEaWrk2heFa1qpcqcvgfFu6	3052	4296	4296	1616712480000	orphaned
5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	5885	3NLtT55J7QvNEm8uVTqwtU6VUN21Eyg477zF3nKY7uhgawoe9Bdn	1672	1285	58	1	5707	jxpDVJCvsNbG9uRnCRDeDeNe3cEY8WtnxgJ4yD7TPHr7gfxx2pi	3053	4297	4297	1616712660000	canonical
5892	3NLgmPc2o4Jk8gGGLUAtdpaZWPDmPt5uqVPkgeZs2AmS4ZNiqx3D	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1560	925	58	1	5709	jwVNwZq76henfFJTo2MpERtNvUyePMtxtAqsQXHGXtCxMaZt4Rf	3054	4303	4303	1616713740000	orphaned
5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	5896	3NL8hQ6qvHVC33H1P6RUVnQGxmG3cg7rgubjPhYF82Sc3gK5fypJ	1447	1345	58	1	5715	jxgMKdi3Ry4vAn5tKm9QrBPf2wJhBndbHRk1BoGbJ4nZwtZ6ZwS	3057	4310	4310	1616715000000	canonical
5904	3NLq8eDk13qvKSQxwH6JaoVudVudLvrbJqMUSyHu7UnhGaX6KDwi	5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	1407	1395	58	1	5722	jxPMcyXtybi2v6jg6sMuo9WLprz7W2nn6qGKFA5MnDQJnv2a2Gw	3061	4314	4314	1616715720000	orphaned
5909	3NKRgHcsgrRvYYSFsQc3oLRnv4iSrWJR9U3PwgkWNsT9a9iNWxhG	5908	3NKY9nCYK99qjBxYnL2bXq2zjgU6MCT42sjr4HiYeeFw3pPSKxVp	1648	1284	58	1	5727	jx2rmASXMaWh1oYJCR2zLmmn7WEwQpJBr1mfSS2JiE9ZGjhtBqK	3063	4317	4317	1616716260000	canonical
5913	3NLnaw6r1Xyr6HAyDyfAWf9X2f5EkS3fUpJwgpk4Eky1d5fpfFYY	5911	3NLKSewpvmv1poV2EjmPG1eijjGS78J2U3eSP9mCiTaSRfjGox91	1673	144	58	1	5731	jy2qDcvc6XtUWGeaYtQnY7pyAnwSFio7PjK8GgzcSxap12H21tJ	3065	4319	4319	1616716620000	canonical
5912	3NLHNmkjkNMZ8P9UrDht89mvcWqeSkoAKz6L3XpNhbRTMXdv1FPE	5911	3NLKSewpvmv1poV2EjmPG1eijjGS78J2U3eSP9mCiTaSRfjGox91	1448	1311	58	1	5730	jwkqCNHBxWr94mihRKVthrc9DXhfBkYZG3XARyD5hbZzKpQXRPm	3065	4319	4319	1616716620000	orphaned
5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	5913	3NLnaw6r1Xyr6HAyDyfAWf9X2f5EkS3fUpJwgpk4Eky1d5fpfFYY	1477	1104	59	1	5732	jwBTExQygjWJjVnLtBA4V23vJBrhdyG7S1GBzNbm4EcA3BAZcgf	3066	4320	4320	1616716800000	canonical
5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1601	1388	59	1	5734	jwQd42gMcCmrnSjghbMajbxUmDpYD3V8iHbkGNxkRSgHaManWny	3067	4323	4323	1616717340000	canonical
5920	3NLj4K9nzbYbmm6qEd4jihFo27FQQh2h6BzZwqc9JE48kkYCTanA	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	1426	1364	59	1	5738	jwgruy5ZtdLHqtYKAqFV7ZwV1DGYLn4kwMgkGiVh9QssoNNMFXG	3068	4324	4324	1616717520000	canonical
5927	3NLgXJ1pVu4HWSCF2bfWHLgnwHXWF9yYQXyVxJF1Mh5vKYKpFkQd	5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	1581	778	59	1	5745	jxU9ZLGnaYtYJsYCUVYgYMJx7g4CsnsTncaZfTjD9FQ3mXdUa2x	3070	4326	4326	1616717880000	orphaned
5928	3NLczX6M6JFiJM9XnRnsSEd8eQgMx73nDPNXbNpLMEqdpFDYTDD6	5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	1522	1322	59	1	5746	jxUq9Ckfjsw1Gv8MeVzK2njihUiUtg1dkbMGRvzhg5nkHQrFZmJ	3071	4328	4328	1616718240000	orphaned
5931	3NKSKuWzVGrxKt9Udw45tt4mMcxy6y7r73Buhy4xheEaziw6t29S	5930	3NL8YrCcR6jUitqL5jfRo8KPJTZCzrbCrv2ZHmwDqPudyZwywa5n	1406	1393	59	1	5749	jwGhJUDZ1MJSUdx9hT7pV362w44q6NXMLVHnk24ijTnkbWtNrNo	3072	4330	4330	1616718600000	canonical
5949	3NLwm4z25uLxbLK1KQhC2moD55rp7TAaiGzxtVA9rRQzuZCsX43b	5947	3NLrXSwzdJdwQN3bf1sTD9SDeFmd5Qba4WVUmrUmdbB9T1ZwZuXU	1581	777	59	1	5767	jwE9s2dPeq7ejDkCQekrAVNjwQbvyiq23KwaCuoxTtCY5yRvjMa	3083	4345	4345	1616721300000	canonical
5954	3NK3F48Rg5pXQC6JjRcTuE2zuELD3K6hN2Aduq7pt7iczgzXA3Jr	5953	3NLhVFVjFqrYP2tGojQnn8eYuyMCJUReoat4xX2jC8Ybv2MY9XTW	1471	1386	59	1	5772	jxMVQ7uT9yhz1LazVRRPvTfwpyXaM1NhtD758p25BZT78x8cwmo	3086	4349	4349	1616722020000	canonical
5962	3NLgB2Uyhn9cLzBHwsqeqHmddKr9Gg5kZySBNv8SVJzGHFGieps9	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1407	1395	59	1	5780	jxzWP4DB7MvpLSH3GbpmWjFLKWggCokiCUZD2xoDYUmNixiZzrT	3093	4358	4358	1616723640000	canonical
5967	3NKuPQHqZWLH6JcTerrZyvBdcMDxZM4aAMht3D93KwcMimxZhxvA	5966	3NKwzTeUHkSG8ocoiMxcArNbittv1BjcG3YzxpRzgBHzkqeEmKmy	1483	893	59	1	5785	jwvTRaypfyngyhGQG5BDKpjkySaB9nhfoLscJjTHyFgYoqVtY1k	3095	4361	4361	1616724180000	canonical
5970	3NKNpNVhQ3ZaKfRDv5LQZvL6N7qePXDkB6KZKHN2SYvPFFACifAb	5969	3NL7565dvmSA5qUN4ekRZvF7oVEUyK1d1CYyAjFrzG8fYumK2FV8	1673	1122	59	1	5788	jwNEGMXhech6JKbgy32LTYcpq15hW712sFxSEwk7QPiDrhhuafc	3097	4365	4365	1616724900000	orphaned
5974	3NLHpEgCa1tMBZWRv3T3eCewMHj7P2WhBWsyCKH3B9SbRiuvfe6Z	5972	3NKZZrztarF3QPdkgi4idE7dLMvvJRC6Jr9kMFjpLwtSYLhRx4xE	1601	1142	59	1	5792	jwq9zXentLuvtB4zUJFzXkvfMzxBNA5p2WahirbJqkUrZzyYuH3	3099	4367	4367	1616725260000	canonical
5979	3NKamnrCmoPRsqzGu7cAsdLCwFtYvcqGr19yaAKV8hjKatv1vT2Z	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	643	643	59	1	5796	jxcz2ugsijdeaFP1hYFmjh7xHLL3o5KhxgYzJvGykyvTPLVT4wq	3102	4370	4370	1616725800000	canonical
5981	3NKMa1enWLUCQAuecFxpfdcgkQ8bhm5LMi8aNWzZY1LvF7RSyMdn	5979	3NKamnrCmoPRsqzGu7cAsdLCwFtYvcqGr19yaAKV8hjKatv1vT2Z	1439	1153	60	1	5798	jwtMH224dSjHejn1uoZSvmD136VsQGuhHB5CBwEs52t8G3WLcKq	3103	4372	4372	1616726160000	canonical
5984	3NKmLSZW7mquSoAx3MS8Q1biGNKcTHNJUiZJB9jG87nLEiMW2SwT	5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	1467	1250	60	1	5800	jxyFL2kMZkQp3s5ZSFsK4T1mnXqUQh4JaDABx8iohTLRtFCHMzC	3105	4375	4375	1616726700000	orphaned
5986	3NLYmyYd9DZH95ebRnvmtqGeZeFgwqJq9eom5rr9vVWKizCKLsPX	5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	1617	922	60	1	5802	jwyCkCrwMxQpf8B9RWqf4kJtbLDamuxWXfUEJHZBuDoeYpTRn3p	3105	4375	4375	1616726700000	orphaned
5994	3NKbit629GLbstPmgXy3Ccf9bbnwcudQEqhHJNm1w2NeoaeDQmPa	5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	1602	1123	60	1	5810	jxnTL5cQaZoursTNp4vg4u1H4qcNH2hcqXQnmctrSvweU18rWus	3110	4381	4381	1616727780000	orphaned
9178	3NLE3T63HqzLHxLm5ni4MN31qjU8utbkDAbPvASS6nRsr5w6pgwZ	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1581	778	112	1	6301	jxBTxQXLiLUvn5kYedNaeXx31Tvf4UVzxjUKPbxd4Jf1CFtvxGE	4756	6699	6699	1617145020000	orphaned
5877	3NKViWb9mHyjxJKiDjCAAdjfo6wpe2R7NQ5ZKUZC1mCxiH5cuCZ8	5875	3NKXnXAzNtyEJBukwdYuUJGnARYnvj85ATxjoWZVZrFRRyQaaniF	1675	1342	58	1	5696	jwyQdAyGR6k3Qfn54mKmV5wEWRo4pGT7tR9QBdrbyNN5vnFayia	3047	4289	4289	1616711220000	orphaned
5879	3NLasypQJm7qzAR11q7BXvzzZWzEUSmjuYrs4uuu5kC6pC8mSkN8	5878	3NK5CXNiV2gjwDt9Yb6oKoHH9gn478p1CCPEvjgvNxD4pqjpwMZQ	1637	816	58	1	5698	jwFz2RpfomfFrZk6YAe4LDLbfZG5FzEDJUL1q34SAfsXB66XkY7	3048	4291	4291	1616711580000	canonical
5881	3NL17s9PXHYRuhxWwCU6PAqE34vR3C1UorJoqfLeQf2s7KJAzk4J	5879	3NLasypQJm7qzAR11q7BXvzzZWzEUSmjuYrs4uuu5kC6pC8mSkN8	1460	1078	58	1	5700	jx9C5zZR4xBfbtK3hVCu4yARAuGenrWoEarZrJbboNwBbFo47Tk	3049	4292	4292	1616711760000	canonical
5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	5882	3NLb7iDcek569ohPHdFN31661vagq369FmoUgZsiWWSFKtFHKfyb	1407	1395	58	1	5703	jww8d7TcZUZhA39GsfCH1g7rJ8VGauYJv9AxhswZ9zjTrW873kH	3051	4295	4295	1616712300000	canonical
5887	3NLxLjs5AcwxLz1ufAABQQYG3VF5h13XENudPHFTkS4wVErxQ2V8	5884	3NKJ3PcHiGa1bRYK5FtN3tHbyqLcprX74j6waZZ26rpfDrmxYB3Z	1476	1245	58	1	5706	jwKkXTqjEwGRQG4HMAbBeWGMciu4nRBxUCe51VCV54pJAbfiafF	3052	4296	4296	1616712480000	orphaned
5889	3NKJBRMiYsSpuXioZ7zYK5JfEGLhBc1iXrLoSy3FvYSRchm8fxeg	5885	3NLtT55J7QvNEm8uVTqwtU6VUN21Eyg477zF3nKY7uhgawoe9Bdn	1406	1393	58	1	5708	jxCjadRre2kguP92DmsxwE2Jj8EXCdNfTaopyZB3f3WpWGknqNs	3053	4297	4297	1616712660000	orphaned
5890	3NKSJhGrbdLVfPyZix6p8853mhyhXamjKgFMSDW8GvLfXHFLQNrg	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1560	925	58	1	5709	jx9PDCAiXrYk6CctQCrBkXKeNj2vKWVfpVRCsVrcQJdiTosqh4A	3054	4303	4303	1616713740000	orphaned
5894	3NKotWuhHQQgxRmcMFxUwcnazcvyqH1Lzr4LKG6hbF5iW9DWBJSr	5891	3NKmsbs9YzcHAQte6E7kELbANzkCwFtDGguE3zcKMhyTcz5cxqtf	1509	1194	58	1	5712	jxZwFsQAFo3FA2PKXh29baJWU3z6qu369pEWAntwWkdjWhQoPJv	3055	4304	4304	1616713920000	orphaned
5898	3NK8pCzm4ZEXJdEgtQfpza5gn1QXPfM9UwhCkYDbbHPtDmdEwbyq	5897	3NLtSX3zjtDpwHAbgXysq7DXtr5BLDEDxRxszCh5sVCBdECNLLRg	1637	816	58	1	5716	jxUcvMmYng5tLTvodUNebXNz7K3n47qSPRJxgfvWH3RJfJRKP8U	3058	4311	4311	1616715180000	orphaned
5903	3NL1DmsLfBSSDwXMwnyR1DExS8BcdgqiaxQ255BNvBFMErDc1Bqh	5901	3NLuLUTE5WX4TSShkGhFK9Vs5mjAVwJkcisoYy2e6qWf3UeRs3Lb	1513	1379	58	1	5721	jwNNHajvx7N4a2JUYs8p8oJv2mHr2PnyBRUYDhTTZySGGUcSUra	3060	4313	4313	1616715540000	orphaned
5905	3NKt77k8ye1bFTTWkuDiaum3GEUh2Bv6Zf2zsMFPjWutj6ppP6ZG	5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	1646	1108	58	1	5723	jxT5E6HfD4Zof2jaWrFqxLo4FhQ8h89rGFchtma2mdPhtrPVE4v	3061	4314	4314	1616715720000	canonical
5917	3NLQoJzg1Csm9TBJTxAZQZaimVvPC9gffkSEUaRBfb3EYKo2caYy	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	1573	952	59	1	5735	jwrv9rV7PzfijxXBuo9rvq5kyLAR5DnBUUrMhe8BFn7uEikycPQ	3067	4323	4323	1616717340000	orphaned
5921	3NLbYsmvQskKhsHtqBwwQyALGmicAsT4Rw2hHScqnPdn9JSzzZ5U	5916	3NKMnGE3Hw71FnGKPg9TG65Fj7bwEKAb9xsoLc54Tm8iz6TR7B3X	1657	1098	59	1	5739	jwVK1VuTizPHQRwFnJ75XjaYQyqG5x4ZxVdRaq5q1wAG4aLnTvK	3068	4324	4324	1616717520000	orphaned
5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	1406	1393	59	1	5743	jxrWjB6BZqMwywpuKGgkF2MSBjLep2LZr5K7pwJWG4B2BhqKAek	3070	4326	4326	1616717880000	canonical
5926	3NKQH8X8thWsXypMQTqP9RZq8QZYPMEyxs2JrHJ9sHfguQJLwcxU	5924	3NLPG75zqeSi2ubPnz8mQnDHUsiT83Gx7NM4Sd2AeppR6stZKHpr	1637	816	59	1	5744	jxeyCefgMbzyHtFdadLRcFQNeQnsEJwbkvfr3beMdz7V8bNCmtR	3070	4326	4326	1616717880000	orphaned
5929	3NKJ7QSW7oReXfdCWw5HsYQDfHPSDtgQjQGUzXKTNGuVsbCRSNXD	5925	3NKZ2oKC9T8bhyD2WandxGkHWb8nKrcefW6hgThmZUoQ5hHhPf6w	1564	972	59	1	5747	jwxm4jdfDmyVtVCg5PK7DEAmS46N29wSzJcqjfdcEMh8QnUSZ5k	3071	4328	4328	1616718240000	orphaned
5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	5931	3NKSKuWzVGrxKt9Udw45tt4mMcxy6y7r73Buhy4xheEaziw6t29S	1451	1166	59	1	5750	jw7BsEuK2eArwWuF5J9wFm86QNnDvzdYmn4LnRNtzMZxtWMCiW2	3073	4331	4331	1616718780000	canonical
5936	3NLhYY3V9wbfpMMEh4UCviPzTGyXqcd8uRxsnic6vRCe5v9jZSUS	5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	1529	1316	59	1	5754	jxKuFwYzv3HqzJPPDNwYFsu1ivbCXPBkuLrHfXrgLLchkwtDVbt	3074	4332	4332	1616718960000	canonical
5934	3NKnvtaNWwhNDHrAwAYqPmjWN6q7h7XpaqJ47yF4TWWRr7j2gyJe	5932	3NL6Qda579h2VG8RyLEKQzhJdM8PUeQ8CpjrkZd9pC8s3qgT2Qkj	633	1384	59	1	5752	jwQp7idtYy7EViNkg6RRktfnUVGe8DdRRHKtrpY2Xnpsk2SSC93	3074	4332	4332	1616718960000	orphaned
5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	5938	3NKRitRWe2FnKCF2MUroZxhf9RF9TWtJW6C7F5qBvhvib87vUgUa	1668	1004	59	1	5757	jxMAsuB7gGGVRDCvF39HSzX2fKsvmP1NN8Tfx94Ffkx7SS51Urh	3077	4335	4335	1616719500000	canonical
5942	3NLJoaLZWHXLAXabkhAEAD6ZPtgAyKBeTL49nMAP3yPLPd8D7Cra	5939	3NKQksE3VWey7buKpwNw1UmreYkSXE4SZFuavWjHPm6jf3mN1SxY	1624	968	59	1	5760	jxQDiZZwVQudRkCZydnDtp8kxSwDxDEtmzpAMs6NjBMR179cPc8	3078	4338	4338	1616720040000	orphaned
5944	3NLN5ju3kpR4aBFvT7KejjEqHLWGB3AsojwjZkSS52YqNMp7ehKq	5943	3NLkj9eGXut38aMEn4sGvNVZ4qyYSNZQ9fZ3SXYWmJUAcpGpSiVd	684	1352	59	1	5762	jwoqAGGNdXnFpzGYFUayHBHJV8NUPF3YCCLrRA8RCRQoWwDYRH4	3080	4340	4340	1616720400000	canonical
5947	3NLrXSwzdJdwQN3bf1sTD9SDeFmd5Qba4WVUmrUmdbB9T1ZwZuXU	5945	3NKffMoRZTWJfVVWczEN8FiFoNKy4k7qqHCN7Wgk9MRikqynqsk8	243	243	59	1	5765	jwpW861qEs3ejGHFDRrvUtMffenKCwta2kj5q4rhaQfd18YBJmu	3082	4344	4344	1616721120000	canonical
5957	3NLLwnm6zjwEAeJkkDybq2jNWTp2UkvaRzhDjE6xACU2Gq2dPtsB	5955	3NLCbE3Gjok6e25avNHJS9muKeGBZvwoTiGMr4EZHwxuZW2TgnhM	1624	1208	59	1	5775	jw8hTUGu35PB4fxYrcDt3uVjwD7tmnTizSKUTztY3KXJWvCexAL	3088	4351	4351	1616722380000	orphaned
5972	3NKZZrztarF3QPdkgi4idE7dLMvvJRC6Jr9kMFjpLwtSYLhRx4xE	5971	3NLAJgRwMTnAoEpGxrb4yZHWgBUnyHT4ear5qvVg6giaghosw3bj	311	1181	59	1	5790	jxaY5CQbCTotAncKGyjJacjBQ7Bj8K9AqE5FX4GvocCQmDdxo7R	3098	4366	4366	1616725080000	canonical
5977	3NLwEUkJDsmPDexvcnXkDhaH5Z83EwejF59aPRc1SirUcULH6rob	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	1564	1212	59	1	5795	jwyyUi71rqqHNGDzZm6foRKrtzhu3HZmwCfU4Qz1MAMYe25MGs2	3102	4370	4370	1616725800000	orphaned
5982	3NKzEK2WnNHE4QGAQxamyaGQAdVqDsvo7LNehMBy9sMfURCqxaki	5979	3NKamnrCmoPRsqzGu7cAsdLCwFtYvcqGr19yaAKV8hjKatv1vT2Z	1439	1153	60	1	5798	jwtMH224dSjHejn1uoZSvmD136VsQGuhHB5CBwEs52t8G3WLcKq	3103	4372	4372	1616726160000	orphaned
5985	3NKZirv6rXxYRXY7sqpspfbYGZpGGdcgMZThg8pHb3Y39RMinfhq	5983	3NKcfwkZKBtAXaZ8d9GY9hK1yjN8rDbzQtpWiBrP2hRDDQi68xFG	1406	1393	60	1	5801	jwSVK98g3SoUXKJio2tppRoU2XGbXMp31AB26mro8S6CGS1F6UF	3105	4375	4375	1616726700000	canonical
5987	3NKZBiMmaz61C3RUf4yUJs32DeVAkG7ZPqEtjUeHovP3sVSoSoQz	5985	3NKZirv6rXxYRXY7sqpspfbYGZpGGdcgMZThg8pHb3Y39RMinfhq	1634	203	60	1	5803	jxhhwDDSinTFbYckhZaN8nsNFKRGSYSevhg1QrSXNuR3D4wK3vT	3106	4376	4376	1616726880000	canonical
9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	1648	918	113	1	6301	jx4YfK3VVmNEcRr1tgbzUmXpnuABKQPhQvkxj7BjH7fwF1WxZch	4762	6710	6710	1617147000000	canonical
5963	3NLMXSXiZQDKNMhFjcKSV9GteiDqnGaf3YDQPVHbapNqoKmBbeWd	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1585	1366	59	1	5781	jwipTKibmAmd271U7huSwhtMP9nmNnZPu2QTkKTNWFNHXZcFTZN	3093	4358	4358	1616723640000	orphaned
5968	3NKtaCWRSrcVkaNvVBQsPCM2EYGn3BSc3SqvkWN8ZxNu8fX537LY	5966	3NKwzTeUHkSG8ocoiMxcArNbittv1BjcG3YzxpRzgBHzkqeEmKmy	1402	810	59	1	5786	jxnhihHHgZXatjvR1dtz3XVMTTZUDHqVgKrGZ4EhiqwTm2uhDmw	3095	4361	4361	1616724180000	orphaned
5973	3NL7hgaNxuShKHCMCCnDSRSJVateMEmsizDC9ZSSo53JgprehVny	5972	3NKZZrztarF3QPdkgi4idE7dLMvvJRC6Jr9kMFjpLwtSYLhRx4xE	1406	1393	59	1	5791	jxi8rfMpd24cvnD6Rr5NNF3i9o3LAjMLL6mccAT7MAuuH2KiYnd	3099	4367	4367	1616725260000	orphaned
5975	3NLkfkPwYeeYwu4k8fa74UYQZ8m1qTjCf6wc1wTsiHhUWt9Q8epk	5974	3NLHpEgCa1tMBZWRv3T3eCewMHj7P2WhBWsyCKH3B9SbRiuvfe6Z	1406	1393	59	1	5793	jxXhKQe3rpJZt5ParX3vByxLxMVTAzvSfnhsxGDTTkQdL5ihdim	3100	4368	4368	1616725440000	canonical
5980	3NLDg39sLStrW7PeuaL1e3w4Yb9oX83i2XbyQWtayzd3gHPFZmJy	5976	3NK4Zs35fdzrTwSu7ybrZLSoEpN21HZdLXDfyQsFptzEUg5QVUpg	1457	1025	59	1	5797	jxNtX6o7vvkFtHj1RcDPiDQqvu7yMcBNQzgMQ9p625mYuzrgLF5	3102	4370	4370	1616725800000	orphaned
5989	3NLJcoChUiQAKfCC1px7vUsRDR6JPQsKxiJiSsKNSDJXq6RrqZK5	5987	3NKZBiMmaz61C3RUf4yUJs32DeVAkG7ZPqEtjUeHovP3sVSoSoQz	1403	824	60	1	5805	jwQ4fndY3FgQwX2fnbCXZEx9ScTyapn6p2VVVz8CAj86c83oPi1	3107	4377	4377	1616727060000	orphaned
5991	3NK2zkbQa3PnSw2Ea7ZJwX5C23jo2VMpqDjQZMDq21pH7ApB8BY6	5990	3NKX1SWfQ5AaDT8cPNHkh2BjP98tj4SkoXiPsv2LwaQkFe5TrfaA	532	937	60	1	5807	jwuH2rPefHK39LnWarNqUu2iCWZuK6mThLjqesSuB1qiCm1wXDC	3108	4378	4378	1616727240000	canonical
5995	3NLeWcqrsQTocr13XrZNDNRYN5v8gwSohWeFrhZ7y86v2SjHLszi	5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	1563	66	60	1	5811	jwne2tBLpAssduW1gNUtuYbn1SSmUY88St8SVM1525Cog2GJqnE	3110	4381	4381	1616727780000	canonical
5997	3NLBt6wmE9AC2cbCavXez4Z1TbS5UoHGEcDcj1caenrHDLYyMPET	5995	3NLeWcqrsQTocr13XrZNDNRYN5v8gwSohWeFrhZ7y86v2SjHLszi	1541	1298	60	1	5813	jxULAa2AqbEqWNKBLCzDkdES48wETDkccSpBzSzhWVXBd8yPLZg	3111	4386	4386	1616728680000	orphaned
6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	5998	3NK6dyPCcVWseyh5Eu893Xyh5jyePd1rKbnYXoBjqEbJaSHqyGe9	1553	776	60	1	5816	jwwyBJPcnqpsf7NCRD9NPcKZ6WTHD95GCFkBn4kmZDyn9cWYuHp	3113	4389	4389	1616729220000	canonical
6002	3NLLPkZtDNGuHkk5Knp43R671GS69QUeXJfQGwEyQos4gcuBmRiu	6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	1406	1393	60	1	5818	jxfboFAumXRwPoHx18MTpAdb76LvRivLsJd2fsmSamQZyV2HMYN	3114	4390	4390	1616729400000	orphaned
6007	3NKUhHq4rhXnhusv3uDXBGkM9kVdrv2qV4dcNkDzmDcNTsRr6ZSQ	6006	3NKc882PRKW873MbdJ1vukx1wrm4ENtMyD5diXNoN95AecYh8hbG	1407	1395	60	1	5823	jxbe29UEFbZ8mwtZngHuSaDapNSxR2T35MXq965qMV1YWoLePMr	3117	4394	4394	1616730120000	canonical
6016	3NK6Xs3pQkAjVhv7KoVsbN3xrWA7WGxvMFwGDcsCWh615dLbo2hk	6015	3NKZaKP2iNJYtquejexNpJvZ1WsmVFr5aPgvH1jmf1TF8ZxzwdY4	1444	1255	60	1	5832	jw9qoQHVdmHqe8zvBUVmohK1ZQdaDQd471VQbX5oSHosWi4Mj6p	3121	4398	4398	1616730840000	orphaned
6019	3NKbr2Q4yanVdQAud1jGtF6RNXmHDERav2f9C2hsg3ETSHc939xV	6017	3NKpqGnMJhiQfhJjoETCj4XERDUVFfXMw3RoNhcwvhBSe2n7pbyB	1458	1323	60	1	5835	jx6chVMmKWV2EYNASVdS7xmfo5ES2au9RNasufrPEpF18wnje6b	3122	4399	4399	1616731020000	orphaned
6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	6020	3NLUi98dnPAXMy4DZZF3tyzxxYYkruYkcDzJAiRoJdwACkL6mns9	632	1136	60	1	5837	jxmM5R6pFJS62FDaVJ8Ty8qDhUEQiAgrnBkSqVDaKXGaNxwTnYB	3124	4402	4402	1616731560000	canonical
6024	3NLXxFYvsofubBQRF8pscgRA622kAGbVyugZPsQXVFMQGHkSE45S	6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	1613	503	60	1	5840	jwEPw6nxNoqm3BS6U5o2WVFkN8j42AGZewaVerqxhpN6UdFxsZd	3125	4404	4404	1616731920000	orphaned
6027	3NK45YBorQXBdopysZrb2irvrx4Xk846TguHyzfsvJscLDHEBtM5	6025	3NLbmqaqToMWKs5kEDtUs1hpikNfEn7Hegtsg4MFbpJx8Vy9Fi6s	484	1319	60	1	5843	jxAgdsbiZGWAoLSY7EiSpy97No3Tpe2QL1xC9AaDJZUnTuNjNaT	3127	4409	4409	1616732820000	orphaned
6032	3NLqmzi8p1pmXw6kLpzsgHXKrtorE5wBa8mfznch9JREf7pMmcn2	6031	3NLrRJJLHmJtgaaqHCRFNxTEzXPAdRonRWMRhJWzg8q5sSBvhqQU	1589	1286	60	1	5848	jwsT8XXAywXFpWErDc3B81wNFvPmnPVNsa4YT21qKCiGX74ANfy	3130	4414	4414	1616733720000	canonical
6037	3NKEWA8xEgowxpUBh97R8C5VEwYzdJZbKohu8HdSGuY979guKLFo	6036	3NLmysbjgBpW4f9WdiNqdrjcQeJY7TVHChvGNnMVpAmQwuRx2vrT	1564	1092	60	1	5853	jwmheRvqYJDRnPgGRHD73tjVCm2JD3EgLCUWDDwa5Gguj6tBCag	3134	4418	4418	1616734440000	canonical
6040	3NLDmbSBdkJWVMYhXKNfWovW8UTzr9mMg6AsqR32fTpRS64867Jo	6038	3NLio5Eh7tKEBCQnkwjpZdEjG6hxnPS9cviQX8So42KrWh4sXWXz	58	1281	60	1	5855	jxDZEtkAaiDr959oqhMUfDida8zknfLjVjL3kc9iv2i4SP1athr	3136	4420	4420	1616734800000	orphaned
6045	3NKQQ3eGXPx1AR1sdwLcTmtSKraEZSbPUWWT7tEZpj6sxFNN9NBF	6044	3NKhp6P6FoE9Lpa6PBKAqdo6kZDdjTCUn52aWCoHyeTpQAQZmFip	1406	1393	61	1	5860	jwTSgvY6hYVudebSaFSU2RuxQAYqRytCt2ByYkRuxUYzwzehHN3	3141	4426	4426	1616735880000	orphaned
6050	3NKUfm4p7BgXnmHmgrcXk3w2FbQ1M67Cus69PpVTKPTfcnd4doMT	6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	1647	1302	61	1	5865	jxr9ggxz4GPm1mruBn9331d5t3rSoLqAe8WsHxN8TnYyyLVMsyn	3143	4429	4429	1616736420000	orphaned
6052	3NLAkLsXtdu1j5DQVuHNJgUMjwAyPSxrYuEn6njjBhLYMVFBVwYU	6049	3NLRbMHYqnuTrCRvEsme2uhQeLTbugv1mpK4QXjntR6y2bVFrsKN	1637	816	61	1	5867	jwTch8H3WPiPXkCVt999HyjgUGbdeva6TetaYqpKxQfyT6jQXZx	3144	4430	4430	1616736600000	canonical
6057	3NKS5amVYFwryRb1cPk3yHDDZUWa8Qm9MqJtPxvV6bpZtZZsR4NM	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1553	776	61	1	5872	jxN4Y87vRDnvgVuqKFLxpLe7MDVHm7kYf4SFSvLY53HxKGZDoC2	3146	4432	4432	1616736960000	orphaned
6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	6055	3NKnkZ3MUuUfZa83ji1oy7tpLnh6cyqi1yYis5Qwy6qbB2rAoUue	1652	1315	61	1	5874	jw6xhqTPsJWcXr5SVB2BVHajavCGsEnHSq4RaL12afxx8RRR64j	3147	4434	4434	1616737320000	canonical
6062	3NLBaLnTseiaNrK9SGNq9xwQ3QGFYoXJVyxWWdZrYz3ASn2K4VHt	6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	1477	1224	61	1	5877	jwEW9C6raX8MVZNkW8jgLjy86n8fN41pf6VEzPXPAHKNs3ze8K6	3148	4436	4436	1616737680000	orphaned
6064	3NLSPVbjTnYPocQGLTJwV7Zjwj7Aj2WX7UyeJcvRR3CtUURxoErg	6060	3NLhfncS9AeExCYM4SGwBap7viSRWaeka5CSGPT99LBjHGkoeiLc	1471	1260	61	1	5879	jwHKcKPc3rdLpSEmAVKC7P2i12dyzYxNeZbEhDGvXYVpA3dKNAq	3149	4437	4437	1616737860000	canonical
6070	3NKfKdTEDt12eAAuZtjrYuAzdG4o6LboziGAvxx2Lzh7WTAEyd7s	6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	1455	1332	61	1	5885	jxhtq4dqwbcmf2xf7YB5MWHRpXEuuNmpyWGcvwwdTwEkca7w3UM	3153	4444	4444	1616739120000	orphaned
6072	3NLDGZ946xgmF9D17qYrAB4aHg3feRLhdXTEk8VMq41Hfgk1vZ5Z	6069	3NKWkfvCgJEDgu7Ww51pag6zNaZsHkjFasNRwW3cyw7afP3pBG65	1407	1395	61	1	5887	jwf2eamt3cHqSMFwMPmor2ZnURVweMQAvJiS52XTw3nqZRajbYr	3154	4445	4445	1616739300000	canonical
9195	3NLdTVyzLT5VeatmM5Wv7oyGjgyEb21hR4ZWvEjkN76xSkHWU8px	9194	3NL846bGraTgCKj3RfexJUQ4GjV8Ri5eT6xDnR2gNfjqRh6XiNeT	1451	1292	113	1	6301	jwTkGbMuTNGQgNtK6TNa9DijtG6wJWbqraJa1A6H4LgRLxYpS74	4766	6715	6715	1617147900000	canonical
5993	3NL6JgyHbn8JQeLPp1H1FKRGKvzVkyi9Qi9yeQMqfVAkLWrFHevn	5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	1407	1395	60	1	5809	jwGDta9dcYjbg2GqAT2g1A6b975T25cWR5JLEakgxcuEbfLjUPN	3110	4381	4381	1616727780000	orphaned
5996	3NLS4T1wLqicyJpxMeMMsL6PLiVcNuffEdBSJw2HSQSSgrR8Pox9	5995	3NLeWcqrsQTocr13XrZNDNRYN5v8gwSohWeFrhZ7y86v2SjHLszi	1403	824	60	1	5812	jx8F7mFsuFM9STJkMseeKnGhnAJE2PMfHXXS7BRxN8UVC4zQWqh	3111	4386	4386	1616728680000	canonical
5999	3NKyjasWkdkRuj7yxdacqitEcQbPKfiFdHEQJUnLy3pLZ2iveWHf	5998	3NK6dyPCcVWseyh5Eu893Xyh5jyePd1rKbnYXoBjqEbJaSHqyGe9	1670	1282	60	1	5815	jxRriUmtYPKFRvn6p8kGfSbiYKtScvbqapLXE8jrrWXsQp6QS7k	3113	4389	4389	1616729220000	orphaned
6003	3NL5okjVePediTJ9xTipAuoQfRUabutXB9ui32tnoQsYhyZ2GRfE	6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	484	1319	60	1	5819	jxai7Wpw1TeActUhH9SzyckDH9QX4ktLKRWE2sXVxqC8sRRREdQ	3114	4390	4390	1616729400000	canonical
6001	3NLf4au6pUspSmXuY8bEPvtXNJGu3qRKmPgEujfeh2FiPjtn1TB4	6000	3NKQFtBXvV1tEYVMxy1Kchy43AYiTU24hVw7TCXyvCB2K1eksn5p	1422	1091	60	1	5817	jwg7b8gsmndWR44fyHCkKaNGNvm4NF1u7SdKkhV9rvoJZsWKc9x	3114	4390	4390	1616729400000	orphaned
6013	3NKSpvNLMh6J85MNp4xYfjGiBV4GqrecHgg6sJzo5b3aRmZj498C	6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	1407	1395	60	1	5829	jy2PiUXGmdWe2YHqXpGV5fwT2taon841ypeZBj3DaYhCbNL7iDY	3120	4397	4397	1616730660000	orphaned
6017	3NKpqGnMJhiQfhJjoETCj4XERDUVFfXMw3RoNhcwvhBSe2n7pbyB	6015	3NKZaKP2iNJYtquejexNpJvZ1WsmVFr5aPgvH1jmf1TF8ZxzwdY4	1651	1301	60	1	5833	jxPj3RRPNZMSfLf2bRqKV4Gp5Bvj6bWqxbwVDr2BfetnYiFQUw1	3121	4398	4398	1616730840000	canonical
6023	3NLJ1gWD8zR1tByrfL4rL4qcBYpUvn4zWgJ1vuyXcUWC1BwxoR2T	6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	1474	1203	60	1	5839	jwuvkChBUJiRYZ3rmmHfBYs1Z14jeyPR5Qqwmmj56Z5BVfJWQVh	3125	4404	4404	1616731920000	canonical
6031	3NLrRJJLHmJtgaaqHCRFNxTEzXPAdRonRWMRhJWzg8q5sSBvhqQU	6030	3NKjVDpkjWWycf9bFzGZ76MAouD5Kb9BBCXuFbbyJ1Fs7LoPMjvg	1581	778	60	1	5847	jxTNhvPmMFzpDfwJWeUueTUDZn2kQDjXs4ATsgK5zSKwQzt3oJ3	3129	4413	4413	1616733540000	canonical
6034	3NLebx9k6cuQ6u7kuaWExZFxyAws7zkd6qfAemo2N5K3xjsvjCbb	6032	3NLqmzi8p1pmXw6kLpzsgHXKrtorE5wBa8mfznch9JREf7pMmcn2	1564	1212	60	1	5850	jwf717oRmiq4jVRffCwH3ceV4K8fMXRxYMCgRuoy6jJGS8JGWGQ	3131	4415	4415	1616733900000	canonical
6036	3NLmysbjgBpW4f9WdiNqdrjcQeJY7TVHChvGNnMVpAmQwuRx2vrT	6035	3NLcowSgMRg9eGF2ksjUQESm1YvJKxJKb3SE7AVKhExZsedmcdHn	1444	1381	60	1	5852	jxvWdjGQQ2VKDGAaZDKvwwnHUzzPeGPPd5RgNww4EnXcTxs3vHB	3133	4417	4417	1616734260000	canonical
6041	3NLBxma2KrFtmNKqBm7Xzins5Xii11y7HtiQVbgS2x3nqtVNAYrY	6039	3NLMNtJCyQGS89BEKhuesTCiRGKx8co7EfbeWjYyuojUPZTsGetk	1579	1389	61	1	5856	jwubg1dVDL1U216ymDN9WUNAGGGJAiBnEL86GFFB5PncYeRAgCc	3137	4421	4421	1616734980000	canonical
6044	3NKhp6P6FoE9Lpa6PBKAqdo6kZDdjTCUn52aWCoHyeTpQAQZmFip	6043	3NKRtEYjkVySbLYBPFoiKT4r4px9LbsGbP2GTrqcf91SuKoSzoUQ	1406	1393	61	1	5859	jxNEHcurzwMe6DV1MrWGjxf5xJZBhDrqVfaEzdfzjFcHFVaiBrA	3140	4425	4425	1616735700000	canonical
6046	3NKjgnBynmCMJu51Kb1Lec7EyTcsJys2bEvXmZYb3jyBrFbrQqr8	6044	3NKhp6P6FoE9Lpa6PBKAqdo6kZDdjTCUn52aWCoHyeTpQAQZmFip	1581	778	61	1	5861	jxjpUXtBGMiJdbLWuyWJzSGxeXAgPsdCQX4nncJH41bFivtEv54	3141	4426	4426	1616735880000	canonical
6049	3NLRbMHYqnuTrCRvEsme2uhQeLTbugv1mpK4QXjntR6y2bVFrsKN	6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	1662	218	61	1	5864	jxUDLoFscbBiapPzwS2BdV7f6zgem3hNjM46osMwvhiqMdAzM6U	3143	4429	4429	1616736420000	canonical
6056	3NL6kRDnTEb1TFrifCSFaPvHhHwqNMXFwjhBJPnNc4wBCc82Vnou	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1600	1126	61	1	5871	jwNoLkjkeWPNuV3cJizDJpDiKVx45mmQsVFEo135Lu3W6rS5efy	3146	4432	4432	1616736960000	orphaned
6061	3NLfuxbYLrzqZiMgtgQLKQYrcMRpgtbEKpb8FQaSwjDKFSFXuDWw	6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	80	907	61	1	5876	jweKvBup833CVxeTKP3T76fjSPQoo9qdCR95HFGVncK2aeHVTFQ	3148	4436	4436	1616737680000	orphaned
6063	3NKn2dCSNEC9tKkiM39BfjnUidxjCQQ4ms4a6r1jpdQrUbiLEYxX	6060	3NLhfncS9AeExCYM4SGwBap7viSRWaeka5CSGPT99LBjHGkoeiLc	1406	1393	61	1	5878	jwscnspnsoYxhVpyk7U1CWtPcB82ynM7RVWcTn2D8fiL3G7E4g8	3149	4437	4437	1616737860000	orphaned
6065	3NLskvuHVgVFXyxMGUN3ockaGnEh84Gi9BGxd3xCGBR8RdEWGvkp	6064	3NLSPVbjTnYPocQGLTJwV7Zjwj7Aj2WX7UyeJcvRR3CtUURxoErg	152	1330	61	1	5880	jwfxv3ireUQRd6tcDcpWzqHy4BSujBnZWqNKfoUh3YivwAwRCYk	3150	4438	4438	1616738040000	canonical
6066	3NKfyRNg12g3kq2ViT4e9UZkmFfWhx2ddrAFMaY288iar4bS15uD	6065	3NLskvuHVgVFXyxMGUN3ockaGnEh84Gi9BGxd3xCGBR8RdEWGvkp	1406	1393	61	1	5881	jwqY2FnZgzTrALKjCiQGPqS3qV5g9jjyn9ku6MXkeB2deqYbASV	3151	4441	4441	1616738580000	canonical
6073	3NKds9uQc69oM4oK5JDjoh7nqc8iDkfmaggtLoQBBaeuPqsi6Ruk	6069	3NKWkfvCgJEDgu7Ww51pag6zNaZsHkjFasNRwW3cyw7afP3pBG65	1648	1038	61	1	5888	jwC4T53k4S4GME4yukdXXgEY3ZnqSqBCBFWLGMTxfTGYJLSitB1	3154	4445	4445	1616739300000	orphaned
6076	3NL9whgEYHn8G9C9Hj4Q7z9rKS3k9THvDxzCQD315pBy7KCtMUHf	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	633	1384	61	1	5891	jxcgFhnKgbdRm28fYBraJDqaQ5S14HMMcq4NTRp848n6h91W1vi	3156	4448	4448	1616739840000	orphaned
6079	3NL2bhDLzY5M1QwfcrKa5wYppm5MpeeLY7sxBBPDyVcZaUhDTswZ	6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	1602	1003	61	1	5894	jwp2CgXQHb9uCXr5TpVMrQtKDBvYMAPLDxd6X9twotshN1jG6hb	3157	4450	4450	1616740200000	orphaned
6080	3NKMo2yF15mzh1D52d86Vfi3KphzdVpY8iwHS73qS5JF6VAHZWws	6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	1623	830	61	1	5895	jx3MDcgTgCUZjn2gW7D34WvWntL5vujAV8hfD61Bf8JjvSwKr2L	3157	4450	4450	1616740200000	orphaned
6086	3NLYy8odcGRkTVWGfez4sBhRmtyroTx6M2A5LeDztEHpsXmM2NEo	6084	3NL4HoEnvv4Nbgq2qccgDJYZdVMv7U9j5V5nH71iuL4yWkys95t3	1642	1367	61	1	5901	jwbz3qXpAxRHeMv1UDSio1NmPruTQfBo61zpgKXKsoNZY8eHPyb	3159	4452	4452	1616740560000	orphaned
6090	3NLiMTVvkBP4i3Dt9ZydDJxDWnyFEHmG2AKKy7UzFu2xPrT64nrf	6088	3NLBxBfby37gjgsagAFDL1GVhKFH5JerNC8eGe6J6smeJgnZBXMD	470	1309	61	1	5905	jwjC1gPhJQjTTU5etbsh6WRoB1g51yo5azLCQF6TrqkC7zBeWxX	3161	4454	4454	1616740920000	orphaned
6091	3NKZ9MeiFugUHRfRqkyuopFiVP7Kq8YguHi5EGvXbkUVhAmvQEMZ	6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	1671	1365	61	1	5906	jxs9bBHubacCkV2NvFh9nRxepCoNWFCE4DkCuGcCVzrsMFAgTSQ	3162	4457	4457	1616741460000	canonical
6093	3NLetrZK9Ce9eNrfRBiyjPAvNcidE67Z8SaxAp2KJTRXQiersfqw	6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	1581	778	61	1	5908	jwmiMBGdxg3Kdjm39ouTthztxUpPVdhQ79X82NHWu7KQHzxg48F	3162	4457	4457	1616741460000	orphaned
6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	6094	3NLpMhzxy7MR1MzeCDtvN9vxeTK8jYrxxNo7H9npvsVUGUJCNzT1	1646	1228	61	1	5911	jxUbWJnJc62pdCYV2wG55DGsVWH3DUepUpZLhpBjmqJfPsgPWKW	3164	4462	4462	1616742360000	canonical
9213	3NKQDs4nqYkgG4FsiQYrNzW8bPftv6DJ7geSZurFuqJBk6kUQH59	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1600	1126	113	1	6301	jwirV1eArc5beGnQe3UwjP1VcS9Z9oX4gY6vSvxPDeUjFwptTCG	4778	6731	6731	1617150780000	orphaned
5998	3NK6dyPCcVWseyh5Eu893Xyh5jyePd1rKbnYXoBjqEbJaSHqyGe9	5996	3NLS4T1wLqicyJpxMeMMsL6PLiVcNuffEdBSJw2HSQSSgrR8Pox9	1573	1072	60	1	5814	jx4tn6WHmqeXvv29Uw1oStj4MNDHkMgtvbRbf2DcfE4C7PGefZJ	3112	4387	4387	1616728860000	canonical
6005	3NKRVBMjmvpYDRGKPPX3MPoa3LH7n8mNDJDYS2fCXoK3M7NMGFx9	6004	3NKKPbubVWurfJd18vm2n2388emRcVWS7uB9j5agbRVDFyXwTvMf	1553	776	60	1	5821	jwGSQXJvNH2ewCB3q6qJv9dPKXidYWy3Eyba38SDK84H1qXfUBL	3116	4392	4392	1616729760000	orphaned
6008	3NLmJgtyA15CGvYGa8RFjCdyVhzdLPBBHwYcm3UZ4injCDMnSN3Q	6007	3NKUhHq4rhXnhusv3uDXBGkM9kVdrv2qV4dcNkDzmDcNTsRr6ZSQ	1673	1122	60	1	5824	jwkqWDDzgU21VLzeSqJ1EnpogpjmtoiGZZCteDsh2m1U9hemBUz	3118	4395	4395	1616730300000	canonical
6012	3NK7o2hSgzV8eFkfZLQ9Q1gecA5DFZF3F5dMHuH2M958rkZZXWNQ	6008	3NLmJgtyA15CGvYGa8RFjCdyVhzdLPBBHwYcm3UZ4injCDMnSN3Q	1631	794	60	1	5828	jxt8Hh7SpTg88RDaHjiyNwfVBKocUD6tQbojsv9yTzY8ig4Zdyy	3119	4396	4396	1616730480000	orphaned
6015	3NKZaKP2iNJYtquejexNpJvZ1WsmVFr5aPgvH1jmf1TF8ZxzwdY4	6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	1648	918	60	1	5831	jwYVfPr17CA7E8ErMB8AUW5aFGotd6PQwDp49UykybNfx8Si5dC	3120	4397	4397	1616730660000	canonical
6022	3NLy6Yc3ZKbPcRACX1rxYfjUSP9Y8PqxPZRb1rABWiwpLAMiZSU2	6021	3NLHKwMmUdb44oQbxrrGjF2d5MDGXgRgTF1XMNekMa66j9WppXWp	1578	1050	60	1	5838	jwXFaLHtjaXFTa2WeH6TQA6BYNesNLnPiorv6T41mZrRYJuVf1k	3125	4404	4404	1616731920000	orphaned
6025	3NLbmqaqToMWKs5kEDtUs1hpikNfEn7Hegtsg4MFbpJx8Vy9Fi6s	6023	3NLJ1gWD8zR1tByrfL4rL4qcBYpUvn4zWgJ1vuyXcUWC1BwxoR2T	1407	1395	60	1	5841	jwtNPCdgb67pEemGF83caoRxocy6fk2BGX7kv4jYwbXRTdgzJrh	3126	4408	4408	1616732640000	canonical
6030	3NKjVDpkjWWycf9bFzGZ76MAouD5Kb9BBCXuFbbyJ1Fs7LoPMjvg	6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	1419	814	60	1	5846	jxCHv9Mu6MYeFjHThfzVBAPW18uqtgoNEKUH1RaAc5tA8u4rtix	3128	4412	4412	1616733360000	canonical
6033	3NKdYCxCDcd5nFVZBcW8ToxC8HYs62FbiwPgr5JiT8f3A4q3E3LM	6032	3NLqmzi8p1pmXw6kLpzsgHXKrtorE5wBa8mfznch9JREf7pMmcn2	596	1306	60	1	5849	jwWiYKZLUH9kzJyLYScagmS4DSCi3Twfx1s5tJqFdFtVVdxi42J	3131	4415	4415	1616733900000	orphaned
6035	3NLcowSgMRg9eGF2ksjUQESm1YvJKxJKb3SE7AVKhExZsedmcdHn	6034	3NLebx9k6cuQ6u7kuaWExZFxyAws7zkd6qfAemo2N5K3xjsvjCbb	1440	1131	60	1	5851	jwDwKyCqRR4qkR6GrepZQ6KwvxvqC4uS226iVX1j8NEZwXjMnKf	3132	4416	4416	1616734080000	canonical
6038	3NLio5Eh7tKEBCQnkwjpZdEjG6hxnPS9cviQX8So42KrWh4sXWXz	6037	3NKEWA8xEgowxpUBh97R8C5VEwYzdJZbKohu8HdSGuY979guKLFo	1447	1099	60	1	5854	jwpsLNkevp8aFPJz36ztDFkY9J4d9WBq6zJ3Ez2HP749xkHMGrZ	3135	4419	4419	1616734620000	canonical
6043	3NKRtEYjkVySbLYBPFoiKT4r4px9LbsGbP2GTrqcf91SuKoSzoUQ	6042	3NLNvGToVPiH2ZZo6wC5S3WFGvEXK5tuchnxigSXzQomnCMLQsEG	1596	1363	61	1	5858	jwdsTDYbv92BH8wRkAYPSkV1R1XsAAvYpwv1g3zUHq4PM3MCUJC	3139	4424	4424	1616735520000	canonical
6048	3NLtEqF5EGbTne2SBmLqGNJvZPoTf9qsQSfEJpzNekqhRTH7Us5t	6046	3NKjgnBynmCMJu51Kb1Lec7EyTcsJys2bEvXmZYb3jyBrFbrQqr8	685	685	61	1	5863	jxPK4xf4wfPratrtnJ9zJQyCerAYNr1kikcXBfhEuJ1f45Psro8	3142	4427	4427	1616736060000	orphaned
6053	3NLuyK2R2cojvJpETyeeZ68x92PrHv7E6Um7owqqitSgVM57VCHH	6049	3NLRbMHYqnuTrCRvEsme2uhQeLTbugv1mpK4QXjntR6y2bVFrsKN	1553	776	61	1	5868	jwFYsseFPZE6JAYEhdd2r9jrKmmxEg7X8eTTkFYX8Ko3UZfY5h2	3144	4430	4430	1616736600000	orphaned
6055	3NKnkZ3MUuUfZa83ji1oy7tpLnh6cyqi1yYis5Qwy6qbB2rAoUue	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1671	1119	61	1	5870	jwSoCoEacdaWYA9ne9Wq8BbEm9Ci9pBebVDuyyboRp9NoQfXwQ2	3146	4432	4432	1616736960000	canonical
6060	3NLhfncS9AeExCYM4SGwBap7viSRWaeka5CSGPT99LBjHGkoeiLc	6059	3NKQPsJhr4SohSeZkPVnhDwD8ftWAAMr99pB8TjHwJ5fXC1hCQxM	44	1325	61	1	5875	jxLAdp4Gu1mwRFt2MyXQ6tHYrDDYhgPrK7qj3amdqftcjRbezzK	3148	4436	4436	1616737680000	canonical
6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	6066	3NKfyRNg12g3kq2ViT4e9UZkmFfWhx2ddrAFMaY288iar4bS15uD	1461	1271	61	1	5883	jwdSQcbqhW4kBYiSjdWN5ELv4hYbevsuH5qWRBdqksHT8hrBzAr	3152	4443	4443	1616738940000	canonical
6071	3NLv9bGPrsbHqVhVF6am79g6mZL1GXNgpoNQtXGG1FRiyeDfTjDE	6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	1648	1284	61	1	5886	jxPbpgcjLqBaoE8fguR66oZU54zUSN9ohaemL31xWmoiZVNwauk	3153	4444	4444	1616739120000	orphaned
6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	1610	948	61	1	5892	jxuqNEkiFGccxY6JNyriXc5t3TGwi6Z42PRG8uGCAJdGzjuSbMq	3156	4448	4448	1616739840000	canonical
6075	3NKbvNn7Dzc2mKF9c9timUFtJdJJ1p8N2U4z8L2fEM3Qfuy5eSaf	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	1426	1364	61	1	5890	jwKY8a6ig7P2AC8JZSf2TaAjAAquHqUJZ9CzyfV9QHKesiJKSXy	3156	4448	4448	1616739840000	orphaned
6082	3NKMQ4PqUxfKHHetHErQL9uk6gVoPEa2j14CaL1coxBDztENcKCY	6078	3NKQzrG922eo9qmHDLNCtvmDdZa65xKFjj9FHABMbmmG4znwqsYb	1542	1058	61	1	5897	jxhCjCDE2uXwUvney6EHBTPQZ6nooT7GzKoXHQxMR18gcG526Gd	3157	4451	4451	1616740380000	orphaned
6084	3NL4HoEnvv4Nbgq2qccgDJYZdVMv7U9j5V5nH71iuL4yWkys95t3	6081	3NLHMSvy9ztrbK5csJexQpcchnYZjecfgSyNAhNi51X5Q1D359ZT	1542	1058	61	1	5899	jwRLPuakfJEdi7fseRinUzieMcCzAtptsPCoyC4dAoPfHn7mhTg	3158	4451	4451	1616740380000	canonical
6087	3NKW6UBzVdkyuqzvyh8nWunsmAQ49MMKNehSvYufCkuSzp64wN6B	6085	3NLwtZtdun7ZFVqrUEM7pTpCfNFhSujrva2ViFUb23LuCxK2bGkx	1402	868	61	1	5902	jwjgJpdDnpVHUnk9voJtbLGg9syndqmmQGHrnwRK5HoSgQyGHzF	3160	4453	4453	1616740740000	orphaned
6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	6088	3NLBxBfby37gjgsagAFDL1GVhKFH5JerNC8eGe6J6smeJgnZBXMD	1406	1393	61	1	5904	jxcD2dfuadJrMruEumhp49vgBmZPaFe9L5QSvLLsatB2KvwRP8j	3161	4454	4454	1616740920000	canonical
6092	3NKriaWDNQQYu6ghGzA6scQnha527Aiv7dii9pXnM3iCBVDm98eQ	6089	3NK92SSFP17mcy8B8AhVkkSHDVSGYW18WfKZLAEgBKze7dCmMDDv	1657	1098	61	1	5907	jxXgQY9WTLgJNjVte3tVQzPzS28SrCmt94uL9Xig6SKzvGpCwqn	3162	4457	4457	1616741460000	orphaned
6094	3NLpMhzxy7MR1MzeCDtvN9vxeTK8jYrxxNo7H9npvsVUGUJCNzT1	6091	3NKZ9MeiFugUHRfRqkyuopFiVP7Kq8YguHi5EGvXbkUVhAmvQEMZ	1458	1323	61	1	5909	jwq1HFNHSecpbbsmvDXpo9ps9NrMCbPKUfTFYwW6LU5cm2CHCUd	3163	4460	4460	1616742000000	canonical
6095	3NL8QZb671JfRMVwX6o3LMJYPqAh7UymXTd4t2GhN4N6EeuY3jnt	6091	3NKZ9MeiFugUHRfRqkyuopFiVP7Kq8YguHi5EGvXbkUVhAmvQEMZ	1654	1214	61	1	5910	jxY3rijxukKdAXqVCDPaYz5oNiRX3YKyo2MjcRshFYWzKeR9gbb	3163	4460	4460	1616742000000	orphaned
6098	3NLLhCReZzznqZfJ2TWgf1J61i8nJLGUfNrXRM6zV8Ti3XqrukFV	6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	1406	1393	61	1	5913	jxETtNVaoWy1qxVzWhDAte4ZkLqCtAs5PTc36MVNYQ8WtCZWeuU	3165	4464	4464	1616742720000	orphaned
6100	3NLvXvAhojXbkEx9DfBfEmtYAhSDc5N4PYrEppWg4ypwdvA62gSr	6097	3NLCWBZvFjHVJHEhqZVWYmFEnmNb6aYEuuENFXU8M8gRd1kzvLt2	1406	1393	61	1	5915	jwkUbbCqYGFaqwLNr1B77Bo4QnnFQn42yFBmfkpPHNwFwbvTmJe	3166	4465	4465	1616742900000	orphaned
9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	1675	1342	114	1	6301	jxGfpcgqn1KS7vVsXPW5sbzX3iaU7Sgd3jZCkAUcVvQezj4goYc	4782	6738	6738	1617152040000	canonical
6004	3NKKPbubVWurfJd18vm2n2388emRcVWS7uB9j5agbRVDFyXwTvMf	6003	3NL5okjVePediTJ9xTipAuoQfRUabutXB9ui32tnoQsYhyZ2GRfE	1458	957	60	1	5820	jwahhZagbQJf6zS7PaXyeuKCGDkB685tGRbLqBPQkPwHKga8pJT	3115	4391	4391	1616729580000	canonical
6006	3NKc882PRKW873MbdJ1vukx1wrm4ENtMyD5diXNoN95AecYh8hbG	6004	3NKKPbubVWurfJd18vm2n2388emRcVWS7uB9j5agbRVDFyXwTvMf	1633	1390	60	1	5822	jwD2eAKyKCcuFD3S7Q5Sqcx1Ej54xnsHT6mFknP1qfdzKJqnENJ	3116	4392	4392	1616729760000	canonical
6009	3NLfZ6kUwQ9n9pJC8F9DX15g5ZXa6XuRhrGo48NAq13APANr224a	6007	3NKUhHq4rhXnhusv3uDXBGkM9kVdrv2qV4dcNkDzmDcNTsRr6ZSQ	1508	1021	60	1	5825	jxeDMdvDwn8gMhV3U6SANDXxWsAExA6u8tBiKJeURa6spgFUmhJ	3118	4395	4395	1616730300000	orphaned
6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	6008	3NLmJgtyA15CGvYGa8RFjCdyVhzdLPBBHwYcm3UZ4injCDMnSN3Q	1406	1393	60	1	5827	jxTGCHKTVHipNRedn6SgYd3s6uv4uD24HCWVpRZzLJ3eXaaZtTf	3119	4396	4396	1616730480000	canonical
6014	3NL8UzJnuQ2NWA9DesXZkYzv5E3jzfJmSUyvwdEbMa3DBen3US8x	6011	3NKiyzPvFHFgpqGA7jJFc6Z599TJsdW2jkyQmofiauyiwerTor8k	1546	1093	60	1	5830	jxfbk3SiULabMC9NzxBQWo7XQC2qJ8QEV33v5TBSBcdfJ97ZyD2	3120	4397	4397	1616730660000	orphaned
6018	3NLpPffBW4BZ6LsmJYDGUUhQmygPzj8tGBV27Ag19mo64JTWrVsc	6017	3NKpqGnMJhiQfhJjoETCj4XERDUVFfXMw3RoNhcwvhBSe2n7pbyB	1602	1369	60	1	5834	jxf2zKBj448BiP5XDSRUD4ZTmRQ5ZWWgin1pykomB8xUDW1hxhj	3122	4399	4399	1616731020000	canonical
6020	3NLUi98dnPAXMy4DZZF3tyzxxYYkruYkcDzJAiRoJdwACkL6mns9	6018	3NLpPffBW4BZ6LsmJYDGUUhQmygPzj8tGBV27Ag19mo64JTWrVsc	1648	918	60	1	5836	jwjEBYQq5vUjwbfZtGqfRHDqwcdCPAe3xcpANHGdomoAE8mEPws	3123	4400	4400	1616731200000	canonical
6029	3NLKXfqJBSGn6oeEUWxw9Vv4bs7Q7TTYsLzH3AHu8HaQqp5exrfB	6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	1652	1315	60	1	5845	jwG4xbJYeLRAK5b9UdsSahs4Rjezq247NF6WFn7QEh7BjkErgB3	3128	4412	4412	1616733360000	orphaned
6042	3NLNvGToVPiH2ZZo6wC5S3WFGvEXK5tuchnxigSXzQomnCMLQsEG	6041	3NLBxma2KrFtmNKqBm7Xzins5Xii11y7HtiQVbgS2x3nqtVNAYrY	1481	790	61	1	5857	jwACqmSSKjGwo48etu8RVLWdNosdYhYUkrfSEXheofCqttMtNEG	3138	4423	4423	1616735340000	canonical
6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	6046	3NKjgnBynmCMJu51Kb1Lec7EyTcsJys2bEvXmZYb3jyBrFbrQqr8	1458	1197	61	1	5862	jx113vfpatzquUMsLW8dhRBuTNj4pZrX7qkSLQBhaCrDBRAJq8u	3142	4427	4427	1616736060000	canonical
6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	6052	3NLAkLsXtdu1j5DQVuHNJgUMjwAyPSxrYuEn6njjBhLYMVFBVwYU	1637	815	61	1	5869	jxrfZW7dJxjS44NSbWX1km3yrLPqskSfDCgtCrnLVne5tYrLcDv	3145	4431	4431	1616736780000	canonical
6058	3NKNArAxCh8Fft52UEjbaJqsMst6HxfYQ95cJwJxXFDz131o6caZ	6054	3NLydC96Zc8kPYccY1sMgq5CHMFJx8UQ328C8qcquiD9LcuNTcdv	1617	922	61	1	5873	jwgWmqh6HHv955zL6VBudDz5WAN2rb93huqCMgLpZhrrh7zMsNa	3146	4432	4432	1616736960000	orphaned
6067	3NLiRDynWu439Nk8a8D5snhvXaxe5UeMgZhKfiDQRpdNd8SMct2T	6065	3NLskvuHVgVFXyxMGUN3ockaGnEh84Gi9BGxd3xCGBR8RdEWGvkp	1675	1216	61	1	5882	jwhosfN4qddvnn3qnspnvMGut87zn33YaBfasQTJ9rjthdpFxWE	3151	4441	4441	1616738580000	orphaned
6069	3NKWkfvCgJEDgu7Ww51pag6zNaZsHkjFasNRwW3cyw7afP3pBG65	6068	3NLE6QtCksS4jTJDsacyprRj5TUAcxoCgjgC64LxnDELmspZUZZv	1451	1292	61	1	5884	jwBag4J1NEaMqYYC5pM7aAsQgmRygKaScTNaR2MWcVZqJ1hYtsH	3153	4444	4444	1616739120000	canonical
6081	3NLHMSvy9ztrbK5csJexQpcchnYZjecfgSyNAhNi51X5Q1D359ZT	6077	3NLsB5SiEZ7u9DS3aReEMTe6N9z23CrRhHmG5hEUy1EhXk2NQYKn	1631	794	61	1	5896	jxCMzhBowi7EeQhkuJh5EmRU1zViVA6Wb2RSy7XD3jrRqfroMbU	3157	4450	4450	1616740200000	canonical
6083	3NKhjP4ofMLutfyBSKuJBYgdhueHFtLeDDABaetjE8NaBYKZRLq1	6081	3NLHMSvy9ztrbK5csJexQpcchnYZjecfgSyNAhNi51X5Q1D359ZT	1483	201	61	1	5898	jw9rbgA2ttWt7aYZ9qejoVUgT5FHaeh2cZACqW1Y33AQ9mYV5oB	3158	4451	4451	1616740380000	orphaned
6085	3NLwtZtdun7ZFVqrUEM7pTpCfNFhSujrva2ViFUb23LuCxK2bGkx	6084	3NL4HoEnvv4Nbgq2qccgDJYZdVMv7U9j5V5nH71iuL4yWkys95t3	1507	914	61	1	5900	jy1C86jP5DuFEhBgoVmjHeeMryyiXPLFut5bmViLjgKpoNFQa3x	3159	4452	4452	1616740560000	canonical
6088	3NLBxBfby37gjgsagAFDL1GVhKFH5JerNC8eGe6J6smeJgnZBXMD	6085	3NLwtZtdun7ZFVqrUEM7pTpCfNFhSujrva2ViFUb23LuCxK2bGkx	1407	1395	61	1	5903	jxc4ahiPyoTdrpU4ZaXpJdFcS2acVkWbvWLJfYx9bt2NkztzAiL	3160	4453	4453	1616740740000	canonical
6097	3NLCWBZvFjHVJHEhqZVWYmFEnmNb6aYEuuENFXU8M8gRd1kzvLt2	6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	1403	824	61	1	5912	jwiYHk52ZRGpyBf819yt2689QdouaacHmjccC2ejocSdtzLyGzU	3165	4464	4464	1616742720000	canonical
6099	3NKQdetShWJ8zn1yWyHkmTE1Qkxho54nXpwRLxH4bk84bp5BdRFR	6096	3NK75R3RP7xy9n6YsaMQr1r8n3MqduQMKcF8KxKprJVypPMAjEB1	1600	1372	61	1	5914	jwrvyA36JVwkxkzkJN5xKDYJzRz2CAiGc85G16eTdtYv68rF4xe	3165	4464	4464	1616742720000	orphaned
6103	3NLCYoePYeHwyKRve6sFC1Cj7MnmGdB9qaaenuv7YQYBdPrGa7j7	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1445	924	61	1	5918	jxNKm1kK6Zhz89Au7fHeUrgtSxUFygoJxFgns5SnKu5nDsSADb9	3167	4466	4466	1616743080000	orphaned
6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	1471	151	61	1	5922	jxiVBykKDQHL4w5Gj9MHs74orBHUCG2guqcMaMkJ5jFWMPywcgt	3168	4468	4468	1616743440000	canonical
6112	3NKN1jdG4AoyMoc3K55Whg97wWayeNaQueZbWwA6p8LXNqdhL5ad	6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	43	43	61	1	5927	jwfyYZJVj4mDopu2MRe5N1TaaAbCrVeMJtNxgqTjCGZC17nUqvL	3169	4469	4469	1616743620000	canonical
6114	3NLgzPzbAfU9QJJch2szndFemmqzXVNyeAmoxXUjEtM4KqtHP6L3	6112	3NKN1jdG4AoyMoc3K55Whg97wWayeNaQueZbWwA6p8LXNqdhL5ad	1406	1393	61	1	5929	jwF3iaX1Dh6G78b8jcFvTJP6tXoERqdMMnJWc14GDGx5LBMhfEK	3170	4470	4470	1616743800000	orphaned
6115	3NKwLdS5RcoibASs6dvxxuq889MyUHyqzwVJcSsf1eXhp3Rz7obV	6113	3NL9XeNqSus2StAdYMWeVGcyzvnNdsF7XhaYJ7TZ5M4jf7yF2A7Z	1406	1393	61	1	5930	jwMmKZbEciYuquYZsKkEzkTuyo2RuxJPqzBQVVyvsT3kRWK6E2B	3171	4471	4471	1616743980000	canonical
6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	6115	3NKwLdS5RcoibASs6dvxxuq889MyUHyqzwVJcSsf1eXhp3Rz7obV	1529	950	61	1	5932	jwgTZYqseFBqMwN8o8bXNeJYtHmRR64hhMPQvVmRutkndM8J5VS	3172	4474	4474	1616744520000	canonical
6119	3NLLoj3sGpPMDyWomWXt3vyJLP94doLPzcEJvzuUTuwFwBCvH7CU	6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	369	1066	62	1	5933	jwYiNp3evFEy8TSrZcYDb12XDe72RVCPTAHY2EKVfkDFoLT72u3	3173	4475	4475	1616744700000	canonical
6122	3NLPgiwcx3uAre2QzAsDFHZx4CgdqGzyP1nXKVbgNhxfbCdpT7JH	6119	3NLLoj3sGpPMDyWomWXt3vyJLP94doLPzcEJvzuUTuwFwBCvH7CU	1406	1393	62	1	5934	jxALEnaJKKpB8DdbUZMwCpLUV2jizCs8sULyp9fDoTedhGUGFn6	3174	4476	4476	1616744880000	canonical
6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	6124	3NKVjAKrK3SaxmZfZM3RUf8Lg3rg7mMmMpP7jSd1chhK1vU76UBq	1623	830	62	1	5937	jy1Fh8VJRFXkmvkmnaMvrdk7f17zYDpwsKQDrmYSgBqdA59YiPM	3177	4480	4480	1616745600000	canonical
9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	9248	3NKwCoim4e4ELhGpEAoXF8w6imBvJcBoQ46mWHuss8mZr2Rk7xpv	1609	1333	114	1	6301	jwRn4owRr5W8apqa7YH1NKGDKDEMvR3k7dhyZ63Qta1biHVvmk3	4798	6759	6759	1617155820000	canonical
6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	6097	3NLCWBZvFjHVJHEhqZVWYmFEnmNb6aYEuuENFXU8M8gRd1kzvLt2	1477	1224	61	1	5916	jxCJUpLafVwC3t2za5iua1t7bzwQLPfPW3SJszajDPEpwX6wwT1	3166	4465	4465	1616742900000	canonical
6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1508	1021	61	1	5919	jwEUwrV2kKUjNS362YV4apAgnTLYsUHb8LNwgu45thFBEQGwUGS	3167	4466	4466	1616743080000	canonical
6106	3NLiLUWmSCyfmV8XPnx46DjsxUecpQHbcx8W4tuW7usRWNEcPjj2	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1631	793	61	1	5921	jwAiuUopWnWA1Q6PybCFW8SbATg9WDCp3GgNmniwtCMT4E58Lk9	3167	4466	4466	1616743080000	orphaned
6108	3NLjfZ8kChD3W8Y8GBu16aCxXEd2Y4VhbTHiKERM9Q9J4mb1jz6q	6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	1407	1395	61	1	5923	jxJLwje5r7LDQQprnKwRdz85FXcGNE66Zap691WbGLUtsCh6GzW	3168	4468	4468	1616743440000	orphaned
6110	3NLc1jcH5JRv2wzWshkQYTfZN1jxjEM2ypa19MCa3ycoJzUNyGrj	6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	1406	1393	61	1	5925	jwGpupNCL7bixheEdDu8R7FEBkuqGcD44mVAMspWzHcEoKijCtr	3169	4469	4469	1616743620000	orphaned
6111	3NK5w2CcxPWBRyTMxRVqkZvJerdEDbXjRDuWN43iUZAcFsZtkJjS	6107	3NKuPLPrYCncqHKYiBpTF4X4jP8Sxcf7CL8HEAbWdoaATuwThxVf	484	1073	61	1	5926	jwSHebcECvZWNdfsyvw6sjCBvYAJL1GGPP9o8FHznuykuEM82i9	3169	4469	4469	1616743620000	orphaned
6113	3NL9XeNqSus2StAdYMWeVGcyzvnNdsF7XhaYJ7TZ5M4jf7yF2A7Z	6112	3NKN1jdG4AoyMoc3K55Whg97wWayeNaQueZbWwA6p8LXNqdhL5ad	1405	851	61	1	5928	jy2ExYizGHRg7EiziaQQ1tn5ShyLXzGLEZ9uj7ji8DkJicsPXaw	3170	4470	4470	1616743800000	canonical
6116	3NLZWWvhtfXhUCCZZ4m5v36hGhWG7K1suH7jLCt1iXmaszfB8Ezc	6113	3NL9XeNqSus2StAdYMWeVGcyzvnNdsF7XhaYJ7TZ5M4jf7yF2A7Z	1407	1395	61	1	5931	jx1b8SXT4PtDFoHDJZcktSTf97J3bN2gLASfLo4NwGqGE7UVZA9	3171	4471	4471	1616743980000	orphaned
6117	3NLEbdUMDr3iX5MJJz7ctBo5yijr2BhxmegsEPuupdzTq94Q653u	6115	3NKwLdS5RcoibASs6dvxxuq889MyUHyqzwVJcSsf1eXhp3Rz7obV	1529	950	61	1	5932	jxkXWhiaJ3PRHnPKPRynzmTaWaPN561iuwRuiBPNEpvghYNHJMM	3172	4474	4474	1616744520000	orphaned
6121	3NKr9wFrBrWsiRzSSeubPiuLGyYQtbutVvjE9gbQsv21HJAbe4VB	6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	369	1066	62	1	5933	jwYiNp3evFEy8TSrZcYDb12XDe72RVCPTAHY2EKVfkDFoLT72u3	3173	4475	4475	1616744700000	orphaned
6124	3NKVjAKrK3SaxmZfZM3RUf8Lg3rg7mMmMpP7jSd1chhK1vU76UBq	6123	3NLuoxcayj7L1So1WSY23mr8t3UjEKnUNFb2yUhQeaw59ynZnRvW	1529	1316	62	1	5936	jwDRo6kgeVAKMyh8Nc5hDb6Acr66dxrAYTy3PYtqRzswk4RLYK3	3176	4479	4479	1616745420000	canonical
6127	3NKicyLG3fCyAXdqjM5S7HxTbARkK9Wjty5fH6eZZveD95ZYDSFw	6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	1477	984	62	1	5939	jxEFLNC7KEv4ANMQMWmPoTcVYFJnSkX7R6dc1SH7SHPVf7msMrh	3178	4481	4481	1616745780000	orphaned
6129	3NKGNS2Wre14FYkF8YUtcAKaHiuZDAE3cXWc7KGuRsLrgAnjjK8M	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	152	1330	62	1	5941	jxuBXRjrC8nbNSai7RpVEvdijktevRz3dHkeUDfJj1tRVW9WJdG	3179	4482	4482	1616745960000	orphaned
6131	3NKwiXKwMMKWkZYyUWZ8y1hHEkdVbCd4ZxrT9s2589ZfayBfaZri	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	470	1309	62	1	5943	jxfwCRe5io9v6aFb1XzNna1k13KTCtunT6EU1DXyW7CZrjtoF6Y	3179	4482	4482	1616745960000	orphaned
6133	3NL7KwH3hvvWv1G2fAXwcgqA7hcmWAhDU3RxnYEoFKKokpnqTp5r	6130	3NLLye56j6PyZQ9UzRAsYmLAtYnVNhKeETyqHEUeCBPoLb5kWRrD	1422	1211	62	1	5944	jwe2bq8BaocGwkBVAuaTmJE2Es2FNrFojbcFhqAztc4qJa5Z3tZ	3180	4483	4483	1616746140000	canonical
6134	3NKF7bqBfoPjDfs7amC5az1NqyVHcB2iLxJvmaJnYZ6gVrkCBxpL	6130	3NLLye56j6PyZQ9UzRAsYmLAtYnVNhKeETyqHEUeCBPoLb5kWRrD	1541	932	62	1	5945	jxcuZJuxX21uBCbvAiqm6WhD3shFRM6aEV6hqK5FJ6ze4RXBtSZ	3180	4483	4483	1616746140000	orphaned
6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	6133	3NL7KwH3hvvWv1G2fAXwcgqA7hcmWAhDU3RxnYEoFKKokpnqTp5r	1509	1074	62	1	5946	jws4345qP9KhqFnMFr8dE28Cf1tFwqV5SEAvt3XC8mGRRB1Qda4	3181	4484	4484	1616746320000	canonical
6136	3NKdiJuMwgUNwXW5z7sbz9oXHCerMn8VqLrSJgZoTE1vX2R8CDXE	6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	1405	873	62	1	5947	jwCLgJT5T1WAQKvxDFcCTvUmacMWvJ4auS2szyLS5aRwVkuwPGd	3182	4485	4485	1616746500000	orphaned
6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	1407	1395	62	1	5951	jxFMwCgyGKCa26hAFooPPHtA8LQrNTKdojArvWADEBoiP1r4hPu	3184	4487	4487	1616746860000	canonical
6144	3NL3dDB7KtQwCvYzWk8kZ3RFdtCA3S9cVjd5hxjKFXwpFfsiEJ69	6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	1421	508	62	1	5955	jwKc5zMWEwZDWrV2cUEiQT8TzUgMRpnLDVrvNnNisf4mW5FXV9f	3185	4488	4488	1616747040000	canonical
6156	3NLmnUHGnUGqPmMmpdQwPR8fHM74n1QLhWmXm7QdEw4kEEmymamL	6154	3NKvUykrmgkZGMB7TLJWNUic9AAdYUR8RQA3LsdakbzVTcy4qQQi	1633	1024	62	1	5967	jwsrB3Uhoab1okFbXGoEoxohQV6eXQCVAu2FiSGGPCEWb6bDS6V	3189	4493	4493	1616747940000	orphaned
6158	3NLfG1xMko7Gf5tmJk2zGyotcseD5VDVCrJYR48ennReQPKioj6b	6157	3NKQmVdUG41UcNAczukC2fwWTcgWnPWgpoo5Tg9ELBHYrrip7YNh	1587	991	62	1	5969	jxF3sEUGDPyfn2wfzZpqTPAYqfj8JUKkMJcLeSLuzznhqkwSkqA	3190	4494	4494	1616748120000	orphaned
6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	6162	3NLF5kcYpo3pP1BjPBpz9Uz3Uxuz5vLYTkxf1ZxEA7aqXHBo7GVJ	633	1138	62	1	5974	jxiJNpS3nL3iVoAs8Wx9yR3UMeRp7JS2dzjw3gbLTe5jY4Krn8Z	3192	4498	4498	1616748840000	canonical
6168	3NKFs73CxYYpZvVKCzW7f4CnuLZZb8WoWAdXpatjFUPVioWm4nZa	6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	1656	1343	62	1	5979	jwuAmrtHP3qRLxFbVq6wsucuqxo98fHBJTXTEuiFMtf36jPvwbn	3194	4500	4500	1616749200000	canonical
6170	3NKr6QrXJ4dVXj8UrNTcEEST6UVrgsuj2VpoJsZdqcF81b3io7PC	6168	3NKFs73CxYYpZvVKCzW7f4CnuLZZb8WoWAdXpatjFUPVioWm4nZa	1403	823	62	1	5981	jxGjHdNqzRzgiuhq11fRNGV6tuCYaujBnxZKv9wQU74srEGi3YK	3195	4501	4501	1616749380000	orphaned
6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	6171	3NLqoYtU7MoVbfvYHgyCyfeciNeKcujE3JVrWqWMe9t6AHCpDHV6	532	937	62	1	5983	jxZavoc1aqcfsHihu1X8bTas37ZfKttvPS3KH13xMpoHMpChdPR	3196	4502	4502	1616749560000	canonical
6173	3NL65NGc3o497zcyaerPCkB5Mu5EkEmD1kqkQwF4jvdu4zR4DLR6	6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	1406	1393	62	1	5984	jxwbbjPhn8sxp2PMr5VMNaYAdgdbG7W5T8N2cXYwX1JPFVGHtgo	3197	4506	4506	1616750280000	canonical
6179	3NLMR3cyKVBTMNCVLnNBE6zVjrc3ppjZiTTg2qNzP2dmHFAWfwGM	6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	1581	778	62	1	5990	jwp3qF8ZxXNfUnfq1XChrF8EsWKhHzsrQHuhVykGWD62nGPtpzt	3199	4512	4512	1616751360000	canonical
6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	6179	3NLMR3cyKVBTMNCVLnNBE6zVjrc3ppjZiTTg2qNzP2dmHFAWfwGM	1513	1013	62	1	5992	jxgkUsVtvYGp85dguXfFRyGYomESXZJxuG9LYPaAUWET6cKqenE	3200	4513	4513	1616751540000	canonical
9256	3NLy2YrsojsZfUdDLGdqU1K34yb9XEt1GVTWDEXW8xvioGX47cBj	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	1405	867	115	1	6301	jxHG416JzWP2FzaY6bfb2vXjXZCysPhwFLd6XxFtfV52b4yTcyG	4801	6764	6764	1617156720000	orphaned
6147	3NKQW4aJfhcyz1G63oCniLV11uAtHZ3a8p7MJ37P9rt6yhsGATGw	5717	3NLQopna1gJ1DfbXfDCHnCpCKpnfZn6zHS5Lbefh94aQA1x9nf6Y	1649	1383	56	1	5958	jwgFgFQPJupZG3zhZff1wHBf5Twjh2Bx9d2mbPAeGxzHLvo7odW	2965	4488	4488	1616747105506	orphaned
6148	3NLrV6Wqww94g5MMYfxL2X5fvXaVdN5xNMvA7Ab45EJAEEAFczEP	5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	1649	1383	56	1	5959	jwScSMAR6SjHPt3Nfq9LyugU8a2eUUvLDGMpdKHNFBPAxp5YC7r	2983	4488	4488	1616747137432	orphaned
6123	3NLuoxcayj7L1So1WSY23mr8t3UjEKnUNFb2yUhQeaw59ynZnRvW	6122	3NLPgiwcx3uAre2QzAsDFHZx4CgdqGzyP1nXKVbgNhxfbCdpT7JH	1406	1393	62	1	5935	jwHs3fjxZYc7rPgwT5KVNM7zKZ2nUK5hpv4v3ThdgD2UoQUf8QF	3175	4477	4477	1616745060000	canonical
6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	1407	1395	62	1	5938	jwLaaow7LtvqirfoVQLn52isd5NsRSPZDKdbVRctZTuEMTSsH1M	3178	4481	4481	1616745780000	canonical
6130	3NLLye56j6PyZQ9UzRAsYmLAtYnVNhKeETyqHEUeCBPoLb5kWRrD	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	633	1138	62	1	5942	jxXsAXvg3JgNiWoGVqcRrPRuiYhKZ9Swm25E72w1qi4r8eG38rj	3179	4482	4482	1616745960000	canonical
6132	3NLq2J3Z1WVcNaZWg9fveyzDYVBk9mEyqFKyzEM2L4taEmdGgwcp	6126	3NKWW4FiDYgqPr2PqX7PCUH4uBbDVuLA7ehsAYySJUgR1yGmVZkb	470	1309	62	1	5943	jxJqNgue1krrwoGkLbvzYit9MVj7LYDfTRvpCA3MWJTdFGnuprh	3179	4482	4482	1616745960000	orphaned
6138	3NLsyNydR7u45FqUk5E4zSwgJyrsSwenfgoY7PGnsF47JWgTkSH9	6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	1460	430	62	1	5949	jwYidiepCgMQAgraZLcCKV2mDVoFDYns8p7PoUuyor2MAMtNvcm	3182	4485	4485	1616746500000	canonical
6137	3NKaryGAYrxBqs7jjGMtpA9sJTUFxue3jREpU7e5aftVruLrA2hi	6135	3NLsiCN3phGZFRfW2cfvNFNJ5yYHqpaTXBaeEPfgE12oHPBXMztn	1406	1393	62	1	5948	jwPtT9VprT2iGMNwEpTUFt2rhZWFQS7e3kbXSNN9xwopU1UZ843	3182	4485	4485	1616746500000	orphaned
6142	3NKSMtyM1WwKR87juXriyLwKencZf6qy5yXmSn5j7dBGuiqfaRkJ	6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	1654	1214	62	1	5953	jwbXBR4Bj3t5VG8Cr9bNTMmrC7f2PKKiVsHGyYbiqgSP2QSZMTT	3184	4487	4487	1616746860000	orphaned
6145	3NLVzp34jKYpQkjsECHdtE2NUnumhnnWqpYnxcSJgXYVEpQ8A9K8	6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	1649	1383	62	1	5956	jwn6e8vRazkdXxwxpi3x7bpBnEAm54KjeGXfyGx2gVEiorCtsrT	3185	4488	4488	1616747040000	orphaned
6150	3NLFktAtUku7kKTxEMawqpbRUuSGriEVkLCfp7PBb5jx6jnXrEwd	6144	3NL3dDB7KtQwCvYzWk8kZ3RFdtCA3S9cVjd5hxjKFXwpFfsiEJ69	1406	1393	62	1	5961	jxfjFRFpWzwwqaaWdQTbx53f8GddcNut9D6a3uPYi7dxgobveCr	3186	4490	4490	1616747400000	canonical
6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	6150	3NLFktAtUku7kKTxEMawqpbRUuSGriEVkLCfp7PBb5jx6jnXrEwd	1457	1025	62	1	5963	jwWfK6h4oApNgG62yyh1B4EcDaNMJoHwyMdKX1dabHidQ9rVeZx	3187	4491	4491	1616747580000	canonical
6154	3NKvUykrmgkZGMB7TLJWNUic9AAdYUR8RQA3LsdakbzVTcy4qQQi	6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	1402	874	62	1	5965	jxaWbTy5QFehvfFQC1Mq4uefWgRyKirvQMdeVYH5vNKqtVsV4tK	3188	4492	4492	1616747760000	canonical
6155	3NLnxXckpkoRHeUg12AWdFUSDih8QuHwe6EN5DY9ihnE7uaGUAxe	6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	1601	1388	62	1	5966	jxP9uXKZLXF7U5sNKK13HULUhiqwtutVBvp8CsoxVqg61ohzovS	3188	4492	4492	1616747760000	orphaned
6157	3NKQmVdUG41UcNAczukC2fwWTcgWnPWgpoo5Tg9ELBHYrrip7YNh	6154	3NKvUykrmgkZGMB7TLJWNUic9AAdYUR8RQA3LsdakbzVTcy4qQQi	470	1063	62	1	5968	jxnKHT1M2GC3pkF3ysXzY1hsf3Q2bE2TcDr9Y8GpDxtZUPicLZS	3189	4493	4493	1616747940000	canonical
6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	6157	3NKQmVdUG41UcNAczukC2fwWTcgWnPWgpoo5Tg9ELBHYrrip7YNh	1445	1290	62	1	5970	jxNWTLTvj1Fz91MGTQ3hQmiwv8AZr85YaVSWS6WDjvtpe7kqwTY	3190	4494	4494	1616748120000	canonical
6162	3NLF5kcYpo3pP1BjPBpz9Uz3Uxuz5vLYTkxf1ZxEA7aqXHBo7GVJ	6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	1637	816	62	1	5973	jwD4uUKpGmyZMkxruV76u3w1VBkncepU55kWBmALACYgMjaejXZ	3191	4495	4495	1616748300000	canonical
6161	3NLUYo9vkQLk9TYdcKX4J66V5AuqxjLtQAu1cDJMTjfqtP3a4PSd	6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	298	1308	62	1	5972	jxCHWREsUqC7dkAWdgsAgQs3585qPh1KxwdQVqLTeU4GWmXDfXn	3191	4495	4495	1616748300000	orphaned
6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	1457	1145	62	1	5977	jwi4a9GuyT5Lto6VACwEhGEdDaibibyDAE3nv19Jfk9QVTAH1jo	3193	4499	4499	1616749020000	canonical
6164	3NKVqtetqjmc3giXAudRUECa4wrh89gLkgWe28csLvoCwSncdKqu	6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	1634	1331	62	1	5975	jxNskcyAguvEMH9eqbZFXeX8V1bHzBhsmEKJKvUFLw47xMKsKRv	3193	4499	4499	1616749020000	orphaned
6165	3NKdVMZpLiRY5msJso3kY2tWfgNXXiE9XvkTxzudHRjZZcvB265P	6163	3NKwibDVbnN9MEMzPds3uwzA2XeHmV62Beu4WV7ETRtYcECdxubZ	1529	1070	62	1	5976	jxG7TEQxyVxEh12EKXWKyNiF6R6YyCrM6YBnoWeYEbKtszpRNa5	3193	4499	4499	1616749020000	orphaned
6169	3NKQmV5xE6DVPkUhFfe1ZNLsF814i9z1JCPXUdRytXoD5KNBGw2D	6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	1593	284	62	1	5980	jxJZ1km4xRsTuftMi45eLFJg5ZXowAooudKSLkSywhFBjP7Z9tN	3194	4500	4500	1616749200000	orphaned
6171	3NLqoYtU7MoVbfvYHgyCyfeciNeKcujE3JVrWqWMe9t6AHCpDHV6	6168	3NKFs73CxYYpZvVKCzW7f4CnuLZZb8WoWAdXpatjFUPVioWm4nZa	1581	778	62	1	5982	jy1ebRFxdAnMF7qSB6kuoXuwibJDy72bjTsAEARm5QuSJXN3Rn5	3195	4501	4501	1616749380000	canonical
6174	3NKsQKM1iy5FsTBT8Wufjb3UE3KyZwkfG9bLqEfzvPmJNKhAMwp2	6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	1402	874	62	1	5985	jwkSqrNshUs5FcfgCAgZNMEghyLUYrYWtVgi7ZFwAn27Uz2PMES	3197	4506	4506	1616750280000	orphaned
6175	3NKw8vB1BDLCj3gg2L9pccJyU1o54STgu9dgwzSJhiqhjgoqGRsH	6172	3NKD7z18nJCgiUZ7BcMpbuxyYGcuQTSBouRAk15qh8HTbarhzAAE	1657	1098	62	1	5986	jwCDcDZXD3XMQzKrRU3Ye9r5QLjqWXVUuqBvnQJpKewNU7sHpqV	3197	4506	4506	1616750280000	orphaned
6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	6173	3NL65NGc3o497zcyaerPCkB5Mu5EkEmD1kqkQwF4jvdu4zR4DLR6	1406	1393	62	1	5987	jwcbHfgs9em8MqQ2TFwkJcYezsQfB5E1Qzpmynjq5EwYVXFcKX8	3198	4507	4507	1616750460000	canonical
6177	3NLhi6icuKoSkZgY4LKt4CVYnTLiFQErARW1t5bjrWpcLn35FFpU	6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	1402	796	62	1	5988	jx478PisjzPiAm2Mc5X7EB5UnBXSGJpKRTjjgGGZ9yTKoEfDgoc	3199	4512	4512	1616751360000	orphaned
6182	3NKbdbQPjC5XKTnsotKyXWzXvwJrArEHp4kp1W8kEke5bkYCvq25	6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	1403	824	62	1	5993	jxBHC8UQQPTr1zaM2Q6KmnMxHsMKcANYqi9jBbMb4bx23ep5dD9	3201	4515	4515	1616751900000	orphaned
6184	3NKh3z3yZRPRXcxd6JhD3CuAQG2GyAkbpwT3bndUKSXiFCJDNCAu	6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	1631	794	62	1	5995	jxLimnig7keYzHhc9hhEGW8vWyoKE3y6HNknXnuZ1Uk8QxCLmNQ	3201	4515	4515	1616751900000	orphaned
9285	3NLQvq3nJnEsCgD4zxbPAzyoaSfSR8awa6edQSJWs7bpNCNQZvh9	9283	3NK496P6nDwe2HHUAXPd79swag7qXQhQGKjnGBhRWYfHwZkwyrPN	1477	1350	116	1	6301	jy2EG7p8XPoUZmBManw7c3dqZHx5B2UaALjWNYF5nBhmUdrMfFQ	4814	6780	6780	1617159600000	orphaned
9878	3NLyZ6ye4wcBkBrmp2ZUB5KN1FeosMHFLuVJ6XVu1E4GRYirX5eC	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1402	892	129	6301	6384	jxBXxGJPY4XbCR4eAJ2YzypswwyGq7UydL7x5YttsRaJJ1bGLYr	5124	7210	7210	1617237000000	orphaned
9881	3NKNgmkyK15QjiVY1791gB3pisAiCyyWE7NNECuYzmoTGSvGPxZ1	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1642	1367	129	6301	6387	jxXSVsHXzVzCaZGYgQC1tHyM8bLZjeszqN2efAxPtuHHSUF9wap	5124	7210	7210	1617237000000	orphaned
10003	3NKrcaLq5nBS9iZDbHrqsyKSSJ9RauEhXkSkUaUhV8yxiJGR12k4	10002	3NKhaafr79XQ8Yjg4MMfCSx6RaX9cBv1nt7NKwhZxB1wpP453Qbi	1402	884	131	6301	6501	jxWQXb5ZVEptRmNixEWSx6htRYbEHUZ11wGnPFamoTUaLReD8wm	5186	7294	7294	1617252120000	orphaned
6151	3NK5kacx2eh1C6gnTcMvbq78jDmQvM9Wbw3E3w9DGAa26cc2zjom	6150	3NLFktAtUku7kKTxEMawqpbRUuSGriEVkLCfp7PBb5jx6jnXrEwd	1406	1393	62	1	5962	jwfaTjuLv34JCiNVwVbgT4MAVbkZT9xFMjXSUnDXiSwiBSu9SDm	3187	4491	4491	1616747580000	orphaned
6153	3NKZu7e7upwUyjYG9aKi3guWXC2HuHi1NvLcrNzsr3yno7cm2zKG	6152	3NLofY4jHLAsaiWm8VHpvkbsK8fF8bzXJnTTyxGeauJZgMcWwoq4	1407	1395	62	1	5964	jx5Jnju1MGerhdnwT5EV5bw3zGoWtpUZSXf1SRga21Yu46cn8YS	3188	4492	4492	1616747760000	orphaned
6160	3NKJFLZfW3cdyJXbf9auhC73JgtaoFcnSP7SXMWRtLMMKvtZHfcj	6159	3NLBQ4fRDkAxRVeSrTCt11UcsJVxBifXUKmsPFidfViEEMVPBxw5	311	1061	62	1	5971	jxATQjFQAyEMnyfzGHknqsafVsc3tP3dHZEmpGmxCGHoW651oCK	3191	4495	4495	1616748300000	orphaned
6167	3NLZq2Gn9raNU6kS2jsLWYKsYKcoEv1sRNUwCsUwREB8SSAZGMB5	6166	3NLB6YLJb4Ad8fgybeMaZiH4XKbkDUcpKHy6sogY8sMBY7qbdcS1	1448	1311	62	1	5978	jwJPEg7tLNmWQsVY8fDYCvyfYLhBVW7ZKCDWr3nyV1m1TfdLpmL	3194	4500	4500	1616749200000	orphaned
6178	3NLycKT3G2ihshRcLYJjp95cxwEzW2u4JATWTHVDKA4QNZZQomV9	6176	3NKfkRbwHM4bCNytFDUvjhSjawN3k42c6vUoYf6gcRV8q6N6rZAK	1656	1343	62	1	5989	jxGFEYSebiHFPorJbsA1Mu7pgwJaGLdKtbNAH2YG7wH81FhjpG1	3199	4512	4512	1616751360000	orphaned
6180	3NLnt7UevN7nnK8u9As5tdb5ZtLZUYu8VdSYZP7FFRhguNj42ajx	6179	3NLMR3cyKVBTMNCVLnNBE6zVjrc3ppjZiTTg2qNzP2dmHFAWfwGM	1637	816	62	1	5991	jxpb4pgKWxzgeFrCDV8uHYNDBjJZsyowuBdumNeoBTV69GSDzi1	3200	4513	4513	1616751540000	orphaned
6183	3NKqj26xUC9u1HtGkJrC8f1vc2Zt42B2HFjvPJyfoKp9c2kGYnix	6181	3NLAgMJE4hxyCcYS8VRBhB9dKpwySsC8CWojHgChaGB8e1y4oPSH	1406	1393	62	1	5994	jxthSw8feaKBTLRurfnegcn5BUt6umgmYQzc1mmUSfjJGSU2UwU	3201	4515	4515	1616751900000	canonical
6185	3NKsTiXcuyQcwxYRHkwUtcSzUpnmTyhXyk6XPuyUFuWyvY4ZtgpH	6183	3NKqj26xUC9u1HtGkJrC8f1vc2Zt42B2HFjvPJyfoKp9c2kGYnix	1406	1393	62	1	5996	jxH3QtnAFWvDP6JMCoGvxha1Tkfr8hqcNyn1qWbrVyt2f1R3Coi	3202	4517	4517	1616752260000	canonical
6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	6186	3NKZoVsTttDjnWbwe4yeVaW1rPHhcsxQ1eUVUfdp3D49pv3hTqmJ	1651	1301	62	1	5998	jxj7tCrMTwspnf6nWVa7K6Atd9tWCXFW2vvQ72mRyWqcKHRxD3J	3204	4519	4519	1616752620000	canonical
6188	3NLMoLSWXGGeEq1nAti8JftZ7SoRUL8adv2qesfNAw6BfZJrmrTq	6186	3NKZoVsTttDjnWbwe4yeVaW1rPHhcsxQ1eUVUfdp3D49pv3hTqmJ	1651	1301	62	1	5998	jxEqoffz1efDmA4S6fSFMcJwFhrVVDmN6ydVpmreEtz5qieU8SC	3204	4519	4519	1616752620000	orphaned
6189	3NLHmQn4Dv7id1WrC5Sy27qu7pgPcvDtRLn2pZbdXGXXjGiAm9PT	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	1403	824	62	1	5999	jwhiXXtqm4aT56SvHetZ1rgTijiPtXFkAWnAbcbqDRrBBSFbtAz	3205	4520	4520	1616752800000	canonical
6190	3NK3EQCtEgnJ73C2a2iuqRqJxANBLsWBWR8h3ophTjeZkrHrEnRV	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	42	1115	62	1	6000	jwLDbFT6YqRowLhj3hTBTULHfpFfXeE5apcRozL2Nv8iqwDjjHS	3205	4520	4520	1616752800000	orphaned
6193	3NKupsT77bfHR4JE6RCJSTpmW966g4yqqJzpHEvWHaQn3KsD6aa6	6189	3NLHmQn4Dv7id1WrC5Sy27qu7pgPcvDtRLn2pZbdXGXXjGiAm9PT	1573	1192	62	1	6003	jxXGGMzBGWgvpCS4UMSRZGeWWBKKd5TCNzUMPbjQ3wAchx6fVrg	3206	4522	4522	1616753160000	canonical
6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	6193	3NKupsT77bfHR4JE6RCJSTpmW966g4yqqJzpHEvWHaQn3KsD6aa6	1402	868	62	1	6004	jwL4xFNp13SPc1i6d21apujiD4LMpLKdcpCujZtCj18H96B19Qo	3207	4523	4523	1616753340000	canonical
6195	3NKpzmi7ZoZ9B9h9ESp66gup9nGk2MXSfGXwe4L3x6oVDpht6q5n	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1634	1331	62	1	6005	jxDyxkTwz2f8Fb7C8paPVQgo9wkJhTbmxQ8NMPDXyAXLLQTud2s	3208	4524	4524	1616753520000	canonical
6196	3NLpWBDeB8p6sFBWEejktj76MVQunCUwCP9D2rzd2939FpTXhoAe	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1523	1321	62	1	6006	jxZMjTzMNrXk2tsK4x9reBG7WvBpzt9wVAjwtH2B3vu9YSZCPfv	3208	4524	4524	1616753520000	orphaned
6197	3NLBtBrCt4Xun2KXDz5gQNRsH2mKZiUV2Fp3jBveudGXMWgQPA9W	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1421	111	62	1	6007	jx5yKxPdC6ghcB5gz3i1wzuyJGfRoDdf2ueyaPa6tMdGD2eBTKi	3208	4524	4524	1616753520000	orphaned
6198	3NLd3MXjmWVBBZ3kdK2RpgGMmPbywLPFabYWo7habzA8xdVd9fC7	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1523	1321	62	1	6006	jxQwJRAbo69nAgUR48AZkD61BooqN4vmX4t6kWxcK83NS9LeECf	3208	4524	4524	1616753520000	orphaned
6201	3NLqQcedJ8eZKEHpK3RVyx4DMLEZTDt3EvBza2D66F3BXjdSU3sh	6195	3NKpzmi7ZoZ9B9h9ESp66gup9nGk2MXSfGXwe4L3x6oVDpht6q5n	1637	816	62	1	6009	jwrfh1wkfErTDCNvdczrrbNYWMcjQkxKNP1KrBgMyg3hjZWid3n	3209	4525	4525	1616753700000	canonical
6203	3NLgKvaScdF6jXXk5mqNgmm14yRkT9N473CEhjWR7QMXqvzD7osV	6201	3NLqQcedJ8eZKEHpK3RVyx4DMLEZTDt3EvBza2D66F3BXjdSU3sh	1522	1196	63	1	6011	jxJX5Pb43i7R3p9vLmFrrSPN3rFR5sYLuUKsLKemvuDLUbJBWBZ	3210	4526	4526	1616753880000	canonical
6202	3NLihPoZnKhpzETxbt9e93Ssta1698uNSw9ASXz8LxmnPZc7PPq2	6201	3NLqQcedJ8eZKEHpK3RVyx4DMLEZTDt3EvBza2D66F3BXjdSU3sh	1406	1393	63	1	6010	jxKToN5VrPwn5k9MJZR1ko5UzbJwNR7aRBb6FpSBMk3nBH52FJi	3210	4526	4526	1616753880000	orphaned
6204	3NLsoft7D9B6K4KWXudGTtMYw5nyCkHCNK7YdPXUqDbJdPCpzYvj	6203	3NLgKvaScdF6jXXk5mqNgmm14yRkT9N473CEhjWR7QMXqvzD7osV	1631	794	63	1	6012	jwfEk185zyp3SKJTTzeD5BYNfzYF6Wmw9LaqFUyWDjFoMZu1Kvv	3211	4527	4527	1616754060000	canonical
6205	3NLu2rBtb7MjDHT6Gq7X2LJwszWYffSDPDskW57GpNhkLkEpuTRo	6203	3NLgKvaScdF6jXXk5mqNgmm14yRkT9N473CEhjWR7QMXqvzD7osV	1671	1365	63	1	6013	jw9psr9g1daKipjSWBThvy3JVFNqXSVuxUJVY3dc8T3J7XR1RrS	3211	4529	4529	1616754420000	orphaned
6206	3NLLPYXtqgWV4EsPZkPZs1Fs2kbUaJ8BEehKCosU66Y7V9GHepbZ	6204	3NLsoft7D9B6K4KWXudGTtMYw5nyCkHCNK7YdPXUqDbJdPCpzYvj	1406	1393	63	1	6014	jwiA9bqTsgiKVPVwMvtfaP5T5cURMwbGKbtaiiVwiKGXC69HbiS	3212	4529	4529	1616754420000	canonical
6207	3NLT1VAQoqDe2pLLrD7P9Hi7Aq75kgYAEy4VtgLNE5tFQEw4thwK	6204	3NLsoft7D9B6K4KWXudGTtMYw5nyCkHCNK7YdPXUqDbJdPCpzYvj	1671	1365	63	1	6015	jwM3KwAxQFbxXkUFt97ATN99k6UcXooVtEi9QmmGqwkQg5DDQtb	3212	4529	4529	1616754420000	orphaned
6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	6206	3NLLPYXtqgWV4EsPZkPZs1Fs2kbUaJ8BEehKCosU66Y7V9GHepbZ	1403	780	63	1	6016	jxr58e7Tg1uX3xu6LQ65EgAfRmnNQSqtuvi8PW61yEbY2o9QrX6	3213	4530	4530	1616754600000	canonical
9290	3NKMRBd3GwniA3RyKXTo8ZPpXBfBdBi9CNvhYkM5yJGZyaixdBUs	9288	3NKhbriFG9DAcNLzeQ5iNz79yxVkSpffT12YumfPrj5ADuR7gdEo	238	238	116	1	6301	jwr1hvonvN4k6qaAEGS3NJDn3oPopGxXSC5hKtmm3oUvS2YuFAK	4818	6784	6784	1617160320000	canonical
6209	3NLWYXZtjXT7Yz7RmJpxtp5NHkzYqAb87gwXMzY6TBgdGJsDSw5V	6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	1502	128	63	1	6017	jwAZW12mhrGLerbGxNH9erA3yhR3NrKKeukVDrFJwoiyi5Ljkt1	3214	4531	4531	1616754780000	orphaned
6212	3NL4h6cbS1ssVV4DzZvHfJFRdHbHzf7cY3a5Tf8SeB4cTYSuznod	6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	1407	1395	63	1	6020	jwpVGSMWmK6kL8Wm7BNpfjeFXaMuxe8iAWwreynnDQxYppPe4ck	3215	4534	4534	1616755320000	orphaned
6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	6215	3NKuEKA8vitbqU5GMgkMGkJ2pQAiiTrr8Qt1hCsGickAmCY5GeiY	1406	1393	63	1	6025	jwK2oXbTv1iniQ73u8btrNqSR7WqU7ZLicAjvnnzZvY6Ls2p5n2	3217	4536	4536	1616755680000	canonical
6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	6221	3NLUYA2THAWr5PXPVRW2kBzW4FmjDqvQRvC8PR7WYjeXMWR8bonm	1573	952	63	1	6030	jxwhnaFitcnmy6NcNybPAZEUTpwM82eoY8DPL12tWKmtSv3pHag	3220	4542	4542	1616756760000	canonical
6227	3NKobJQ5grPA2UVNjj3N9HaEAe8gmVRHECQqzJHrbi7HcrHNyjkv	6226	3NLa6YwEu7rqZ7XJLhQfJktQpzMLaYPWXY7RpmGhp6jCq6TibnWG	1476	1125	63	1	6035	jwNQ1c2cBuyN6rmJ8DYoQCbjUJP1h72mPqUNy4yxt7jW9opsALG	3222	4545	4545	1616757300000	canonical
6229	3NLrtFexyVX9R6kd1JKG5k1S8ZYxBLmwEui1bjsbytxxzXKR4LFF	6227	3NKobJQ5grPA2UVNjj3N9HaEAe8gmVRHECQqzJHrbi7HcrHNyjkv	1406	1393	63	1	6037	jxhydKsFNqVrqR716G3ZHdS1aNkpxey1EhAukt4URJCJ1nW7o2k	3223	4546	4546	1616757480000	canonical
6230	3NL2G8EYgZ6tULJGCpu8hKXsd1pGqAN9LE6h5p58t1JDPwm7bFph	6229	3NLrtFexyVX9R6kd1JKG5k1S8ZYxBLmwEui1bjsbytxxzXKR4LFF	1490	1274	63	1	6038	jwm1Nw3h4TGoK4F6VEAyWCB4jdPoyTnkhncmSVPwgyEoV9GbAGa	3224	4549	4549	1616758020000	orphaned
6235	3NKP9FHcuirCSVVQScd1uvy1zEgncjucQYpxrRgphdT8PiV6tYJb	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	152	1330	63	1	6043	jxo2SpaiPCyacJYmdT1QVGavdEp88uTjsnk2bZihqoRLEGWJNJw	3226	4552	4552	1616758560000	canonical
6238	3NKhE8XhYtQmDWcEcbUYUWF8okxQPFo8Tr1ycCSfys8xZNv1GZFk	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	1461	1271	63	1	6046	jwmjFEu8C4CiTDwsXHWb7iHAieRHvtER6fjnD1tpiK4HKdTwGNv	3226	4552	4552	1616758560000	orphaned
6239	3NLbpifbAikAPt4iWWRhef1i8wMxR2kEB9xYtk6oCar736Zg2GrH	6235	3NKP9FHcuirCSVVQScd1uvy1zEgncjucQYpxrRgphdT8PiV6tYJb	1522	1076	63	1	6047	jxH1apkq4z3jRq4wVY2Mr1kVvBiyzpFjdhLxGBjSkZ62v2yY1f5	3227	4554	4554	1616758920000	canonical
6242	3NKjh9Nb4oWijuhGhPSzQ3SBVkMYxamFcgzYfKNvurPTr3nmWVAD	6241	3NLbtYtmd4FM5qHycBPoCd3s27H7J9Qb2ugijMUdVwMTKs1WYh67	1406	1393	63	1	6050	jwg71MG6Vx6W6t6pS8CepyHy531kysd7WN4Cb59C23U5HpGRDfk	3229	4557	4557	1616759460000	canonical
6244	3NLqGqRDLireLBAoFa67PV7SFeHJzo7MvQ9tVSLLUvhkWRkW8j7K	6242	3NKjh9Nb4oWijuhGhPSzQ3SBVkMYxamFcgzYfKNvurPTr3nmWVAD	1403	824	63	1	6052	jwnB42bwGKsRGoTKxD6LpiJigzdZXobiEkhiEPrqebk22Y3Q68j	3230	4558	4558	1616759640000	canonical
6249	3NKHEaELvhymPBWg8nXLewcjrmucBKDt8Zm2ZzPujF2rVSREUB3v	6247	3NKBfRZ892iFD9T8AXKACkj9Fem2C8d9sSR7HYRv2qDbvbYsEqZo	1534	951	63	1	6057	jwQNAgQccDmEitXFXSLAPi7fNB3tkSw4dVdAQP1WpEJp1H1RJPk	3233	4562	4562	1616760360000	orphaned
6252	3NK8V2QJ2Pjt14xYuDsWLFQoxinArkgsu1AoXRZHcsKyPixjwKKa	6251	3NKZUaAYFzrPTZiumYGY84dVX4jsVA61G8qmXCAeHDJcZ8UpxHmv	1637	816	63	1	6060	jwwYReVmd64WK8JDX5YkeK2V3VyXvucEwUThSGvPAscnPLVADLK	3235	4566	4566	1616761080000	canonical
6258	3NLtLEb8Pceehao3YJeCjP4zk7D92k7N3nptGPGU1pu6Hqp9y1EH	6257	3NKugA8UpQbA87FxjYAqk5jfESQMneDzmLZbzP3ptqR7Fiyhrgki	1407	1395	63	1	6066	jwgBYhVMYQTCCi17mH2DUfCB16BGXD8pjXAY5wNsee88d2RrKde	3240	4573	4573	1616762340000	canonical
6261	3NKk5qK8beYJfCS6ZCmJLXaUtDNNiYnVEc2Vd3cMSZ4WFss21qD1	6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	1460	616	64	1	6069	jx6fAUbhs7xbxU5QDXXKCok1f2UoP2i1R3Gh1DyDJiTSNHy1KDJ	3243	4577	4577	1616763060000	canonical
6274	3NKURPbvGFTT9gbCjgLToAq8fBmU7GN2VE1fBc4tajNg1te9734Z	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1523	1075	64	1	6080	jxYeSwgiQMHaCNxRTXeJWJd4PiLHJQ6Bbr35Qbt1Q29pWwSqoSJ	3250	4591	4591	1616765580000	orphaned
6277	3NKm7ekEPMvxQRNm7CU5Tc9jm8Zo8GBeRQTWKjQepX6Ew8uRXFCV	6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	1596	1117	64	1	6083	jxAxukbJZFifKFzqFQfWYfvAVYnMKuEgyewR1xyy8nzMKRy1nZE	3251	4592	4592	1616765760000	orphaned
6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	6278	3NLJ81bn2B9hXeTm8TGJhRVCtrHLrRDQCSbnsLCyr4XZ58iNm9XV	1513	1133	64	1	6085	jy1kjdHmoYDacFmLnzMGwjJquYdxdea6k1zUSAHYeexwaC7gUCU	3252	4593	4593	1616765940000	canonical
6286	3NLgibwvd59d5aSRn3kneKLdgaSoApzkCyJX3F7kecd6Y7LiZoED	6285	3NKPXUrmgfjxAiYGV6VoCrawPAFV768EfnaoGm2682mz3GGrps1E	1489	1134	64	1	6092	jwbNFeUnGXAFgagkATZZwfvndqZytbFsKx6aR8ZuxXY9yqyGAAA	3256	4597	4597	1616766660000	canonical
6288	3NL2e3MCc9oJxxJsqwxDJuL5arV2PzwJufhVMvdeKH4HMhN8iuAo	6286	3NLgibwvd59d5aSRn3kneKLdgaSoApzkCyJX3F7kecd6Y7LiZoED	563	1113	64	1	6094	jxz3jmVnLPGSskQWSEKJqcHzogHDfGPehrxCEPGpfpVjTkNi7Lv	3257	4598	4598	1616766840000	canonical
6291	3NL9cHfehf37ooDABXdyb7GwoiUfmgqazGPMkoc1hp2DiiHsxHya	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1406	1393	64	1	6097	jwz732YGhQHvGzMas5fqy5GKFN6vsctWejGxQezEpfv3ysNVvV8	3260	4602	4602	1616767560000	orphaned
6298	3NKESUn7TendyB5LA9S9qif8MTcrFFTEJyGhcFBAvNTtiwFYrxmk	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	532	1057	64	1	6104	jwhcfq46M9GE3AEEc4Efndrzrhaez9g3hJYLVKToThiAPvJHw27	3261	4603	4603	1616767740000	orphaned
6302	3NLUanEiPca63XW1UvFK3eB45nZvujhyGUZFvdqnE8mecP3Y7mnV	6297	3NKZSrbii6sDv8bNCPrrTEd5FrggXK2f5dhk1pHZ1NAq4WuQC6nm	1508	1261	64	1	6107	jwtvWGvLjacGYxLWLZYgXmCWs5LiJsFQ9ZicfyCzgWwhHTSRbW3	3262	4604	4604	1616767920000	orphaned
6304	3NLdmGtD6TyAQcunETS94mRMEvjVVCWoQqGFhe1mJ36k4JVNywLY	6301	3NL9w1fhcCx8FeKTbZzDyAVAwrdtyHHN6Q7uyU5cfjUazVJwbgRB	1483	893	64	1	6109	jxQFRE11XxgaiFuJU9mxRRbJi57F5VX5xEmhXGCg9knr3xigTzC	3263	4606	4606	1616768280000	canonical
6307	3NKqRLNyMWmYfzUQeh1MkbCyBjhumHJn4j8np1rb82mvndroSaoq	6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	1610	1314	64	1	6112	jxoHED9MZstRJh6WANNz7YQujYrRCt7CjxV4MyFJ66hxLu7SK2u	3265	4610	4610	1616769000000	orphaned
6312	3NKEsSf3aH438t9ZAPYWLbHt3aKTZykyEJ7cws8HZru4VJG65Xij	6311	3NKfMNFADvHckYZQZG1AiFeTFF2hp5u2g39CY8T4A2uddScPNccY	1637	816	64	1	6117	jy3BWmLFBV9fkRBGb3TZ2AYxP7wzMyskuPZ2VZPertXL6tt2zPf	3268	4614	4614	1616769720000	canonical
6315	3NLKPNfd6Y4afc4ix1xLmTHL7PfNFDCxA6rF7JDGMkTXoJR8e1x6	6312	3NKEsSf3aH438t9ZAPYWLbHt3aKTZykyEJ7cws8HZru4VJG65Xij	1559	1353	64	1	6120	jwbwUrFNjg2uvqzVFXVuYRDqQSbzJbaa3bXazvBqa1vFicDawpH	3269	4617	4617	1616770260000	canonical
6324	3NKr4YZuzZAiiRHcCSh9MzXJptKDMNGdA8cftsxCagaztnDUc1HN	6322	3NKrJf8TkLay49mcGbTYf5RtnNYVk1kgMRDfaXMonMQW92aWMjeU	1407	1395	64	1	6129	jwvQt6oxDDSz4XdWh68c6rqQENR3Rd7YHdDFUZRz4YQr2mm4D5v	3273	4621	4621	1616770980000	canonical
9311	3NLqr8Nhouh3kCoJYKnGRtPc9BXU6Gvy4RESnXJ9i8hvdGHx6E9j	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1402	852	116	1	6301	jxwav2yKniS7ocJmXFRagqMVvVbM3RT9gyJLdUyJXyW7fmm45go	4831	6805	6805	1617164100000	orphaned
6213	3NLq2UXzsEF1ZXFbDW5rb3B9ES85T97rYV5NU1t9xWupsYkmEUZf	6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	44	1325	63	1	6021	jxw8e6ySK5t9w5kuCWsuSAGKbUextpKdPYGVs3RK4HBuchPzXAn	3215	4534	4534	1616755320000	canonical
6215	3NKuEKA8vitbqU5GMgkMGkJ2pQAiiTrr8Qt1hCsGickAmCY5GeiY	6213	3NLq2UXzsEF1ZXFbDW5rb3B9ES85T97rYV5NU1t9xWupsYkmEUZf	1402	868	63	1	6023	jxcjLZcVJQsZx2f867C9JfJKTaRMEfowQV9ahMS5honzSurfy4S	3216	4535	4535	1616755500000	canonical
6220	3NKj1FHzhNyrjqSNewSGV3Ppax17367FLuHuLj31wViYkBfFiqt7	6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	1647	1302	63	1	6028	jwFWT7hyPQGAohyjXPTDrmCcnFmSieT78RS1pxrgU3Wg5HaoVqW	3218	4537	4537	1616755860000	canonical
6226	3NLa6YwEu7rqZ7XJLhQfJktQpzMLaYPWXY7RpmGhp6jCq6TibnWG	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	532	1303	63	1	6034	jwRb1nJNg2xtQhWTyFrX5ctGDKHsEMGrDcgJyb6HRQZvC7PHVHz	3221	4543	4543	1616756940000	canonical
6223	3NKowfJcLW1gwKD5YYvJipRWHgqkdvjZg9FJKjcME4sHZgw4X9tb	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	1451	1046	63	1	6031	jxtrZ2NH43z2dnQ5FyoXR4CWdCpSR9NkE7aTHpf6QyB1ojKGqGQ	3221	4543	4543	1616756940000	orphaned
6236	3NLGy5chJT3ycnUKqDzZokxAKWkQnKRX7X1wh26EpyNmQkSDu8jL	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	1407	1395	63	1	6044	jxjcabiNVM6bhkg2Cqk7Ea3NawRX5nw7LvJsrXA9TEkm5jChzxh	3226	4552	4552	1616758560000	orphaned
6240	3NKdpf6ZLSAhHMvGVYjUYt9KNpWuBi6fxG5wmzGt3iN1pEBXbVwS	6235	3NKP9FHcuirCSVVQScd1uvy1zEgncjucQYpxrRgphdT8PiV6tYJb	1547	1378	63	1	6048	jx3cg1g4KLwc1qjiseWTSbtCitXTADrrHPQmyeoJ5B8tMybJdV2	3227	4554	4554	1616758920000	orphaned
6243	3NLFyxjdWM6KCVci55dFxGQhXQL4692qsMBfdfutaLtzEewymLdW	6241	3NLbtYtmd4FM5qHycBPoCd3s27H7J9Qb2ugijMUdVwMTKs1WYh67	1407	1395	63	1	6051	jwkqEJejAXpQFi7upw3h4rT61pnzbW39BCv5EUj7ULxGibR6jQi	3229	4557	4557	1616759460000	orphaned
6247	3NKBfRZ892iFD9T8AXKACkj9Fem2C8d9sSR7HYRv2qDbvbYsEqZo	6246	3NKF1szykHNjdyAtuorhSuwMg8L7yHoxj5Y6RzJpyAg8RAQZFzu7	1402	796	63	1	6055	jx6PgeSVgue7uvSPMvXNBK5METisPiaBjRY8oLAnVtP6wzNPvpz	3232	4560	4560	1616760000000	canonical
6253	3NLAje527kSF7Z9oSt7faiUKJ53mKZQev2uTwc4aNYjqYzEwSfo9	6252	3NK8V2QJ2Pjt14xYuDsWLFQoxinArkgsu1AoXRZHcsKyPixjwKKa	1588	1026	63	1	6061	jwornGbWD8jPbDoYJDPwUFK3pq37XwUBAYKawC16YqrS16jhT6k	3236	4567	4567	1616761260000	canonical
6255	3NLBJU5XRGvCkRKTdRw8MZ4Xat8Q2BoiUW5hS4REXiyuvudWkHhZ	6253	3NLAje527kSF7Z9oSt7faiUKJ53mKZQev2uTwc4aNYjqYzEwSfo9	1637	816	63	1	6063	jwn3kjo5kF1AQQVQNdyRU4KzPK51sg47NJpafXrMUmRK95h6eJw	3237	4568	4568	1616761440000	orphaned
6256	3NKiH5YiyuvanxyGLRTvdGTptSeUHXWU4PQ4KFFHkwFr1vyysw92	6254	3NKipoLQwtimM1T2a6f4bw5o6JjmRK5jYEodXxrpc1F3wUDJRVYj	1647	1302	63	1	6064	jxUR51wPFEA6Hs1zV6ZTzbexHGYHasgzVFLWHPwGqh8hHQ3Dekp	3238	4571	4571	1616761980000	canonical
6266	3NLyJrDMgRWccszTzmhmTzsAhjG8zw4C3xZWZcFgG1ehFtW7w5w6	6264	3NKJbzEekuv11YYDHJD59XZwCj9uiVkHuoQqhmVT4qRvtVmopXd3	1600	1126	64	1	6074	jxGKZ7BywpwmgqrnoxbeVF9o4Cq2kfyzEKGgYjNQRyzkQjyc382	3245	4580	4580	1616763600000	canonical
6269	3NKH2GxSoDe7up3DyDNbKWgV3s8vuLzqmuzgZwNM2ZRvmGn67WXa	6268	3NLqrs4qBxgXm6UKxvjFz3yQd6sf4WKY5BxmvG4yYdN8dsgUqgob	606	1295	64	1	6077	jxZ8e7HKqa6Wi6UHTFqTRGgRpvfQP4Sry41x1BhSTmzYnPWVcs2	3248	4584	4584	1616764320000	canonical
6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	6269	3NKH2GxSoDe7up3DyDNbKWgV3s8vuLzqmuzgZwNM2ZRvmGn67WXa	1600	1372	64	1	6078	jxiknmnYppECvpY5AwhptqFGYX2xiAHBzH3hspzrJqYsUCegcoy	3249	4587	4587	1616764860000	canonical
6271	3NKFRUjpWFhbEughT3ELfyDvHYeSJ91nRuLUbbSDdYTE3CS2Tvo5	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1403	824	64	1	6079	jxsCAo5Tpe7BnNzLo714vnXbGh6xcwfxSS42VfeT7cDDzeaZQG9	3250	4591	4591	1616765580000	orphaned
6278	3NLJ81bn2B9hXeTm8TGJhRVCtrHLrRDQCSbnsLCyr4XZ58iNm9XV	6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	1613	1103	64	1	6084	jxyPAURcZ2fax1tMREL3dDLsevKj48oHwj3DUKuDfDeLMnfiXw5	3251	4592	4592	1616765760000	canonical
6284	3NKQQ9a6uitRd3UzW54EXyUDwebsAY8A4dvnmbTgS426PMMe3dre	6282	3NKMiiaTuGrXgPAz9x7xcdFYYMNqB7QiKf7wAZcSNW657uqhyQ19	1581	778	64	1	6090	jwUpKtAoGvgQssgcExKmNcU2iBdddYoS5rzYHsGPgCg1Xpgtd6h	3254	4595	4595	1616766300000	canonical
6289	3NLgoT7oLHR2FeRP8ocBzdNDPjqeSfdA5odMax52Cw84Jkifz11r	6288	3NL2e3MCc9oJxxJsqwxDJuL5arV2PzwJufhVMvdeKH4HMhN8iuAo	1527	1167	64	1	6095	jwonAB2dThastGQ1pkxLrERXJrMmL9jgervgTQZprDABexwXz3o	3258	4600	4600	1616767200000	canonical
6295	3NLfPm9y4SAf6GBFAebexhjeY3KESZCjNZCdRGxDgVmwNrhzmojg	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1481	790	64	1	6101	jx3goTgwRExkahyb8FNScmJcUoTCGUuu6CcdnFZxUjmcKqpZFPR	3260	4602	4602	1616767560000	orphaned
6296	3NLRnwSvNdzjAiSVuKUvUaZK8eTaQEDy3wDj4QmtzbFZFmY4FbSz	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	1672	1285	64	1	6102	jxCk9PpN855GjnfYisycRBZz5MHs2jKXSDGQWRynxsFKzocHkYC	3261	4603	4603	1616767740000	orphaned
6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	6304	3NLdmGtD6TyAQcunETS94mRMEvjVVCWoQqGFhe1mJ36k4JVNywLY	1501	1234	64	1	6110	jx1r6BbnXaZdP2Y2zGG5pCCP59ftBkQ4t5YasfW9eh6bGGsLiwU	3264	4607	4607	1616768460000	canonical
6310	3NLMTrfPoMwT7t9wH1qPG94oJYtBS2EAj2UvLngRhBryuxmPrqiB	6308	3NKbQG3H7Q9eHep9udV5EnCGrihzALh1AVb14rVEQ9RrUuE3twYr	1421	508	64	1	6115	jxz9QryRphTtbGd2pDffskqBjbbsxEYDLbRSJWVbUsgQKHVKfXC	3266	4611	4611	1616769180000	canonical
6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	1647	1056	64	1	6125	jwJ8YinRnThTsYNtbvjFNNvDRUPMg3A56r1VbT6Yd5PaeVGzyPf	3271	4619	4619	1616770620000	canonical
6318	3NKNA2Mw8yL8HRThYSYa8PoCZaMLp3FDsEwEqT7EZ5nLTySgN18n	6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	1402	866	64	1	6123	jxyUwhfpkfUq7d14Qs5Aw3sCGw4X9BCRXexxMDR39uLm43nuohS	3271	4619	4619	1616770620000	orphaned
6322	3NKrJf8TkLay49mcGbTYf5RtnNYVk1kgMRDfaXMonMQW92aWMjeU	6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	606	1295	64	1	6127	jwegxMF5omFizfjwNzsVDsnrYgSKuS8GrM4uC3P2ub5joDiK6ZW	3272	4620	4620	1616770800000	canonical
6325	3NLFjAX38qaT1CkTx2fTT4QDpaGinDfDpmcK8Ga7r5QMd1H6KMLX	6322	3NKrJf8TkLay49mcGbTYf5RtnNYVk1kgMRDfaXMonMQW92aWMjeU	1599	1041	64	1	6130	jwkQaCXwjMAuTcobZGnz1HkaxWtw7XHkFdy2KncH1WhdSPrhnKW	3273	4621	4621	1616770980000	orphaned
6326	3NLfCrKYRjG5FhQLwokHACRoygKYHR1BWEC8ddP9HzuQgnoYzzbp	6324	3NKr4YZuzZAiiRHcCSh9MzXJptKDMNGdA8cftsxCagaztnDUc1HN	1581	778	64	1	6131	jy1tg2QyzwXSszd3hfiYJSTyrJ3c4migJWaDfzGpLWmvzCvuVye	3274	4622	4622	1616771160000	canonical
6332	3NKw6Xsg4FnpQjhzvrDe59EYi2YXJTLVN3Fu6DzweLmQCYTSr4Tu	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1451	1292	65	1	6136	jwX3UPXZ6E8xn98KKMksT9mA3vBKj4mfJnrozdeQyaRtcDuFThG	3278	4628	4628	1616772240000	orphaned
9312	3NKcsya33uAduYYDbWT1Km87S9hQosQBebvm8NNTL6NtrVJCaUz1	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1440	1131	116	1	6301	jxHJPTgqToNN3tMesZEfTW4Ein3Z5RtDZAcHg79ttzqvrT3XVTF	4831	6805	6805	1617164100000	orphaned
6303	3NL7o18c4EEHYNgJRF6weVqZqjmLvdokPu4sZ3t2mQX2hPTStQyj	6232	3NKUMxiy6WnQ7nAsv6NUxELnQn4DHwZC43ZvsUc6KU65kD9SGkus	1508	1261	57	1	6108	jwr2y4G8bS1EeP42DMgsnxC8yVrKy3pXgZeLsCHEsYDdr9RA28N	3013	4604	4604	1616767920000	orphaned
6214	3NL42K8WFJwChs38ZJJpyzsFy7bmAe2BCxdddMugw6Vm5otxeiWf	6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	1406	1393	63	1	6022	jwhpjdpfaj9qBXoGCLtuyfKBBWUjXduwqocE1s9fiWwBsmoLnf4	3215	4534	4534	1616755320000	orphaned
6216	3NLvFvriweHZ5aNW4rWJCX4QVHSwzDqTWgZ2K4uVyDWzuruQpvaT	6215	3NKuEKA8vitbqU5GMgkMGkJ2pQAiiTrr8Qt1hCsGickAmCY5GeiY	1588	1392	63	1	6024	jwtukdttSxVoHPGxCHhV6EpT8NqF6nkWLLbkovLZ4aqJ8sM59Qq	3217	4536	4536	1616755680000	orphaned
6219	3NK76z6dLKojDfhCMLDxyw2HBq8WU9Xk9i4DbgEdn7RyTp4q2SG2	6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	1637	816	63	1	6027	jwZ58hQBHxqmUY5Ru1MeLHwwRxUARshMFy7Z3GYhHbsGaZKctJJ	3218	4537	4537	1616755860000	orphaned
6221	3NLUYA2THAWr5PXPVRW2kBzW4FmjDqvQRvC8PR7WYjeXMWR8bonm	6220	3NKj1FHzhNyrjqSNewSGV3Ppax17367FLuHuLj31wViYkBfFiqt7	152	1330	63	1	6029	jw7bnL4gPAACQyjEPPpUguhAUS6Nx4QrsGoyWpP3kngX9Lx55od	3219	4540	4540	1616756400000	canonical
6225	3NKKcRAP1MFUgZnYPnEW2E3m9GrtMeiMnAH6fhoA3Bfk3iw2JfBK	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	1553	776	63	1	6033	jwEtPQHwjWHwRj7KoF4tqcGd19p9rYmC4fKWoaKQjfoPCiyLjob	3221	4543	4543	1616756940000	orphaned
6234	3NLnE5GivKiY2jHxiGyYg8YmmSij7o4n5PrgpBb2hLiSob6fQrMv	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	1426	998	63	1	6042	jxvejZUZyEdEvJ1538NGnNw2YsvMhChxtnWCL9cfncASgSZ5ZbZ	3226	4552	4552	1616758560000	orphaned
6241	3NLbtYtmd4FM5qHycBPoCd3s27H7J9Qb2ugijMUdVwMTKs1WYh67	6239	3NLbpifbAikAPt4iWWRhef1i8wMxR2kEB9xYtk6oCar736Zg2GrH	1675	1096	63	1	6049	jwX17joEsPq9GEvEcSvqWj3yfEZwa1BiaNambkNsjUhU35DsNCH	3228	4555	4555	1616759100000	canonical
6246	3NKF1szykHNjdyAtuorhSuwMg8L7yHoxj5Y6RzJpyAg8RAQZFzu7	6244	3NLqGqRDLireLBAoFa67PV7SFeHJzo7MvQ9tVSLLUvhkWRkW8j7K	1439	1033	63	1	6054	jwUmLbFgCB3wwXY6MGVfSTSWhyC2866kJEtb9a74LfzGRsKgxNp	3231	4559	4559	1616759820000	canonical
6251	3NKZUaAYFzrPTZiumYGY84dVX4jsVA61G8qmXCAeHDJcZ8UpxHmv	6250	3NLxLnVmPRve3aUVyoNswC9DUoy7dKk4o2HthY4AuKGpntQekL89	1467	1376	63	1	6059	jxT8e4WeUBvV9EGb7SeULwvWKJD6t8VdgNsHxZSNe5gDQnH7t4v	3234	4563	4563	1616760540000	canonical
6254	3NKipoLQwtimM1T2a6f4bw5o6JjmRK5jYEodXxrpc1F3wUDJRVYj	6253	3NLAje527kSF7Z9oSt7faiUKJ53mKZQev2uTwc4aNYjqYzEwSfo9	1407	1395	63	1	6062	jx57ZPt2dK8Yj9pZe4HiTSzPCkaRni4QuC917h1KfRet7DV5h3N	3237	4568	4568	1616761440000	canonical
6257	3NKugA8UpQbA87FxjYAqk5jfESQMneDzmLZbzP3ptqR7Fiyhrgki	6256	3NKiH5YiyuvanxyGLRTvdGTptSeUHXWU4PQ4KFFHkwFr1vyysw92	1610	1314	63	1	6065	jxqP1j5ZhcqKzraYg9ZBMHoYWjryRPvSquucLAn8JQRv8gPsNmL	3239	4572	4572	1616762160000	canonical
6263	3NLtuBKXvorwEXai8wszm7zYzNZyUwdd17PFALEns5qn11zqiMac	6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	1624	1208	64	1	6071	jwuDTj9KvqzumyFA8i4i5stq9qX7u6XfbTVZ4Uvh2QUGMEf9ytz	3243	4577	4577	1616763060000	orphaned
6265	3NLE8Ntro9GXDioo8pZcKuZCDNM7fPx3RunzPVWFiBLAkaVaY4kD	6264	3NKJbzEekuv11YYDHJD59XZwCj9uiVkHuoQqhmVT4qRvtVmopXd3	1406	1393	64	1	6073	jwHyiF49pAwEddiTp18D46K4eCGajCaDwNy58b5eFzeFopjSVa5	3245	4580	4580	1616763600000	orphaned
6268	3NLqrs4qBxgXm6UKxvjFz3yQd6sf4WKY5BxmvG4yYdN8dsgUqgob	6267	3NKMAgr6cpWujYXSi2ym643LCjd54qT1eFj3r4ZgvA6SPpwh4cAq	1650	1129	64	1	6076	jxwmLSsbickHhbb7d1YJQJD2291fuuMLx7CckndBGbm5MdbfX1d	3247	4583	4583	1616764140000	canonical
6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1405	851	64	1	6081	jwZ1a6qr4j4bwSajQsu5qSZKEAcfe6AxBZBY6h4qxTctNfzZa3y	3250	4591	4591	1616765580000	canonical
6275	3NKKzMaKgmJsuv1ZjviE142LzDTrqEdKSbxrH32h3w8by4jcX7s4	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1523	1075	64	1	6080	jx14Yv34YEGJJSMxpPguD9b3c6Uyk6unE9HGh5s6bCVHSGe4n5k	3250	4591	4591	1616765580000	orphaned
6276	3NKqm1YFbn927iZhy7ungobJhp2KoK3z63devVVAdJpLsxpnohBd	6273	3NL7QSofAuYgPUP45feoiWyUTu2FZqBfVyAVJTtgQCAGAcB8wst4	1637	816	64	1	6082	jwobXsNSmNK7pCSJK7nXwMf18dhNoGbVLTjwWX7kcGkqYSRYSXK	3251	4592	4592	1616765760000	orphaned
6281	3NLHqAunKHx876n2qquFpLCgny7vqUKBccSBpGuvMKqgaAVgyqVa	6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	1408	72	64	1	6087	jxxR7fof8ZdXgKKuvFNn8rzMfgLr9JEF2u31rkU6goCDoKaEdwT	3253	4594	4594	1616766120000	orphaned
6283	3NLtzX33uHP1sWtbfdAu5abe4TonvjcK8ZzrF4ewTNzYu3X1gtpp	6282	3NKMiiaTuGrXgPAz9x7xcdFYYMNqB7QiKf7wAZcSNW657uqhyQ19	1623	830	64	1	6089	jwH66Vhh9poqY3mAywt8RarS7LRRvEUg7ppTvKHJKdEDovvDgCN	3254	4595	4595	1616766300000	orphaned
6285	3NKPXUrmgfjxAiYGV6VoCrawPAFV768EfnaoGm2682mz3GGrps1E	6284	3NKQQ9a6uitRd3UzW54EXyUDwebsAY8A4dvnmbTgS426PMMe3dre	1581	778	64	1	6091	jwE3QmadkqsMP1LwfBPh3GqKwyWZhMcGU4BUDNRsoTseZgcVCKz	3255	4596	4596	1616766480000	canonical
6293	3NLfWFATazJEgTVjfQHCCvxXVEW1wAhquxu9skxzNFgVMT1QnYx9	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1549	1362	64	1	6099	jwNT31nzJj1WZad3rYha8Tt5njCUWcFTGznXmJoNFNKFZ8CSUGx	3260	4602	4602	1616767560000	orphaned
6297	3NKZSrbii6sDv8bNCPrrTEd5FrggXK2f5dhk1pHZ1NAq4WuQC6nm	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	311	1307	64	1	6103	jxagwfh35uFgWc1onB5QTeMF7PE3nFXVa7a4Se7ChTXTS1NjD5p	3261	4603	4603	1616767740000	canonical
6301	3NL9w1fhcCx8FeKTbZzDyAVAwrdtyHHN6Q7uyU5cfjUazVJwbgRB	6297	3NKZSrbii6sDv8bNCPrrTEd5FrggXK2f5dhk1pHZ1NAq4WuQC6nm	684	1226	64	1	6106	jwmkhG4w4TLpR3qWQGtmP53cTK5H93gFGnnLw1U6EPe6B8LnXjq	3262	4604	4604	1616767920000	canonical
6309	3NK32NmdQyi5NLuqnpgph2yuEAJVHxwyhCCiyLj4AehTrUZi5qap	6308	3NKbQG3H7Q9eHep9udV5EnCGrihzALh1AVb14rVEQ9RrUuE3twYr	152	1084	64	1	6114	jxt3mt8YvuaSx5cnQjDbiCdGuJwmwzqVUThEd2cHBybjNGwjTyw	3266	4611	4611	1616769180000	orphaned
6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	6315	3NLKPNfd6Y4afc4ix1xLmTHL7PfNFDCxA6rF7JDGMkTXoJR8e1x6	1407	1395	64	1	6122	jxjvF4iBE9R94rqUHYooXmGgZG8UENFCGXDYGdn5ebDCPbSVP3b	3270	4618	4618	1616770440000	canonical
6321	3NLVqEFpG7LjdZbcCtCiaH9vJpXVviAVy2eoRsW5E6NwyeZDxxfQ	6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	1455	1332	64	1	6126	jxFLDg5D7YWXgP1r7cz7F4stYvrgWLz4Yr7GNuDM77rN3L7Ht8G	3272	4620	4620	1616770800000	orphaned
6327	3NKCHwB2g8cZjBzVR8S4YYrzGxoC57ZWW1aBTobE6yKhN8nvmmcR	6326	3NLfCrKYRjG5FhQLwokHACRoygKYHR1BWEC8ddP9HzuQgnoYzzbp	1406	1393	64	1	6132	jw8wHu9a7MRFVJmkU35zSdTD6HqKaL34wUX9oJHq8HBsg6wAT9E	3275	4623	4623	1616771340000	orphaned
6329	3NKUn8XQ8tikT5wMr2Vy9yWhUnDwfXjmNMpzxgnbDrkqS5YjLffV	6328	3NKZfnnPHnaT89mYxJcbZwk8G7z3ebNYnypSdPWrE6fE9b8nfabq	1471	1386	64	1	6134	jwm6F3xevxTTk7ckHhRqV9d3x3pwP5j5kEQRUJ76JvrPwDRGvti	3276	4624	4624	1616771520000	canonical
9320	3NLFBTPQwvo1cRKzRtfJvafzoEgRJobDXFRYwWURJtENpW7AVgxy	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1649	1383	116	1	6301	jwZmPPQEfkDvv6cdbFYSZ6Vcm74W34AntCkFKTW1xvLxuBTEG1z	4833	6807	6807	1617164460000	orphaned
6218	3NLTsf7MBcRjKun66RYR7ufhgnCDxDdMgmAAnMB1Y6b9UKx7BXcg	6217	3NLrgS6sbfcCJfNQgmreG2iPGq55iQT8E7iNn3fdBkXcrSyZAAPv	1490	908	63	1	6026	jxKC9gBj6jMVWQ9ipzd3H3z5sr7FSP3ygGPeU1UoVZscZtN55tw	3218	4537	4537	1616755860000	orphaned
6224	3NLdoAKoa4NsYaDMVtrvcihyg9w77s2o9FBTpWnwjqyBhkkGBaDB	6222	3NKVLoctgRNeaoboVrxXKYYwqT62gfrGHijjjhxC3epPNNSZtMND	1471	1386	63	1	6032	jxMp5ZAQdTDFNbBs7XSZ1Vkf9veF8bP6p3Ue1EKrmyVGb75nQ8K	3221	4543	4543	1616756940000	orphaned
6231	3NKT53dW5EnfEzKyKU6hEtuTivm62BRsihAxZtSAPWGftJyYngGC	6229	3NLrtFexyVX9R6kd1JKG5k1S8ZYxBLmwEui1bjsbytxxzXKR4LFF	1508	1141	63	1	6039	jwju4JnLz8NQfXzn1i1Heie2A9sz9YMiogLcpt9jTDV1fyitrFo	3224	4549	4549	1616758020000	canonical
6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	6231	3NKT53dW5EnfEzKyKU6hEtuTivm62BRsihAxZtSAPWGftJyYngGC	1657	1344	63	1	6041	jx51HBUg5jASETMbrUiBdTeja6pWJ8Hq1wSK3rU6FZ8X3rZMEx9	3225	4550	4550	1616758200000	canonical
6248	3NKQmbFGAARvVEx82wp8AYd83hyJMPriAtWMf7PfH1LqDxxd4yhn	6246	3NKF1szykHNjdyAtuorhSuwMg8L7yHoxj5Y6RzJpyAg8RAQZFzu7	1553	776	63	1	6056	jxA8kqKKkvRow2q2LxLGDJk397QYF9zXPQy3SmEGNsphGZuWEf5	3232	4560	4560	1616760000000	orphaned
6250	3NLxLnVmPRve3aUVyoNswC9DUoy7dKk4o2HthY4AuKGpntQekL89	6247	3NKBfRZ892iFD9T8AXKACkj9Fem2C8d9sSR7HYRv2qDbvbYsEqZo	1657	1344	63	1	6058	jxio5C129tFg1vh6sPM6CJJCBiTKFtsRF3Be2nBmiUnQBE8xBV9	3233	4562	4562	1616760360000	canonical
6259	3NKNkU11pDfa89uDikkbyUke4uWnFgMsYU1MENHHWheYsSKNxF3c	6258	3NLtLEb8Pceehao3YJeCjP4zk7D92k7N3nptGPGU1pu6Hqp9y1EH	1457	1391	63	1	6067	jwx6Y6HDHEauayx1NHw2zL3ZSMXgVLTd2xjrDfLVrPYK57C7H56	3241	4574	4574	1616762520000	canonical
6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	6259	3NKNkU11pDfa89uDikkbyUke4uWnFgMsYU1MENHHWheYsSKNxF3c	1631	794	64	1	6068	jxrEW7R6bBcHm9F3peLqNZAeQt5P6SXHWXmuyUeTqMwsDt8Bfsb	3242	4576	4576	1616762880000	canonical
6264	3NKJbzEekuv11YYDHJD59XZwCj9uiVkHuoQqhmVT4qRvtVmopXd3	6261	3NKk5qK8beYJfCS6ZCmJLXaUtDNNiYnVEc2Vd3cMSZ4WFss21qD1	1596	1117	64	1	6072	jx8J132pwD4jxQSGDYgF5iedLgy5kNSZq94iJH7bxvdf2VUtphF	3244	4578	4578	1616763240000	canonical
6267	3NKMAgr6cpWujYXSi2ym643LCjd54qT1eFj3r4ZgvA6SPpwh4cAq	6266	3NLyJrDMgRWccszTzmhmTzsAhjG8zw4C3xZWZcFgG1ehFtW7w5w6	1407	1395	64	1	6075	jxdD3H6VZp3SLpZ5rSy8oCcZnSK2Yp9jbwZS2nE4sfE4VmRWyKH	3246	4581	4581	1616763780000	canonical
6272	3NL2HmjtpaJY7UEzNHz87MfcmU1nTwHhTkxPD6e4z8TPZbu52rPF	6270	3NLE3qUxFDSxWmf48y7dqcKFN5cNLPTbL2qrbp91antdsyLo4M9T	1523	1075	64	1	6080	jx5YHorGuzqykzBM8ByXrrgZrwMDuX7oT4GGbtNGyStZQgH9cAY	3250	4591	4591	1616765580000	orphaned
6282	3NKMiiaTuGrXgPAz9x7xcdFYYMNqB7QiKf7wAZcSNW657uqhyQ19	6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	171	1008	64	1	6088	jxTjADw2FueGhEaufVap8zDX4K1egaGUobY3MfvKGuvaDjfDSD2	3253	4594	4594	1616766120000	canonical
6280	3NLkqoMgguYpkTK5hpUk4RfzVoQsVUyGiaRCgSVrq5EuXqLg36qD	6279	3NKW5yLhVZ8QND9JD4LkYare5X2M9a6Xn9yYqrv51QZ8MA13GqaJ	58	1155	64	1	6086	jwT71e2VTRxxgcbU5D81B54do2Yu88eqiuQ2np9ehxb3yNN1zUS	3253	4594	4594	1616766120000	orphaned
6287	3NLDAk6KpPiGLqWgyqbticFheVtJqFK6pqWtz59zhipQDfTbpN1K	6286	3NLgibwvd59d5aSRn3kneKLdgaSoApzkCyJX3F7kecd6Y7LiZoED	1536	1067	64	1	6093	jw6dyQqay1JcHv5M55kYRvzVtso9o8VBPsFDmK4BiK3YtDpD1WD	3257	4598	4598	1616766840000	orphaned
6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	6289	3NLgoT7oLHR2FeRP8ocBzdNDPjqeSfdA5odMax52Cw84Jkifz11r	1671	1119	64	1	6096	jwu8fW52oRwGVJAC6ZGDBEXp57gjCKAuMeYfDu6rpgTSFdXEi4u	3259	4601	4601	1616767380000	canonical
6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1657	1344	64	1	6098	jwkhiwN6z8r1oUvxq7xPYcDMkpgbGq6KMupGpp6KRhdmbRNrYBD	3260	4602	4602	1616767560000	canonical
6300	3NL6rAuNydge9isFNSAWWsJJeWnhGXJh8pTnLQA9hobn2pphveNF	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	1651	462	64	1	6105	jx3dnjoCgiFWqya3jzDs911SGhBUmgnaaonPhoCHPQR8LwXPqpE	3261	4603	4603	1616767740000	orphaned
6308	3NKbQG3H7Q9eHep9udV5EnCGrihzALh1AVb14rVEQ9RrUuE3twYr	6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	1601	1388	64	1	6113	jxMKGPmmo51t2CKaQb6Z2hPVur17WeRCvBsHMverjjgqdDDA9bV	3265	4610	4610	1616769000000	canonical
6306	3NK4nGJUXe4aJoNgEqDqWJvaPr9gKSSo1Rx8PRKnwJJprVzH7hfs	6305	3NLdbqXCRTBRxyi9Hv66VeHQoxdH3q75j84trufEiJbudWCuLg36	1649	1137	64	1	6111	jxKFSdRARpfiMLNaGgcSb4VRTYHBGgYSWcYZvdg1JCVzTsfVCy5	3265	4610	4610	1616769000000	orphaned
6311	3NKfMNFADvHckYZQZG1AiFeTFF2hp5u2g39CY8T4A2uddScPNccY	6310	3NLMTrfPoMwT7t9wH1qPG94oJYtBS2EAj2UvLngRhBryuxmPrqiB	1555	981	64	1	6116	jxKXDNHzHWwyd6J6YoJncELZVm2Vg9CxVCCV8pRNGk4QEKL8g6K	3267	4613	4613	1616769540000	canonical
6313	3NLf7wvJNKoYAMTV7wXDi8Kd5EtKenQWhJ4uf51cuoEvTQeqEBsG	6311	3NKfMNFADvHckYZQZG1AiFeTFF2hp5u2g39CY8T4A2uddScPNccY	1457	1265	64	1	6118	jwftoDDhyH3pFNeCQ8dTdstqvQ3K1ZJFzSKWqbiJHoZ2E1N5psH	3268	4614	4614	1616769720000	orphaned
6314	3NLDfiNM1pZ3Mq1jDJr9tH4HLHxaLoz6fvxSfH3myti29cQBhR6m	6312	3NKEsSf3aH438t9ZAPYWLbHt3aKTZykyEJ7cws8HZru4VJG65Xij	80	1147	64	1	6119	jxN4M4qzHfwWhm6d2T77GP62N4DCiZedqg1RN8ARXdwhFPv9iZc	3269	4617	4617	1616770260000	orphaned
6316	3NL2zjmwdaGWsyTxzP5FCMcnPaVoeozV1e6Kozef24VK74XwYEgL	6315	3NLKPNfd6Y4afc4ix1xLmTHL7PfNFDCxA6rF7JDGMkTXoJR8e1x6	58	915	64	1	6121	jxCiHvBGkaRTvgk5dTch5g9Sw8BSqU75BsQDAE1XTuHEchC7wCp	3270	4618	4618	1616770440000	orphaned
6319	3NKuaodK7zqCuYvCcsb5Sz1DcFsS7z5CRN1nzxpJhG1jgjpgb36H	6317	3NKKdM5181TtgaBbcSiGYXAXANjkjfPFgXD3FWYL7Ha8FZ62i9Zu	1407	1395	64	1	6124	jwyvW49uaADYbac8shbw37My5HRZnKMLRcUCSL3jJZCBnkNZ4up	3271	4619	4619	1616770620000	orphaned
6323	3NLLajeEaRLKEVcCJQQULpUizYRSFwhEBru2HceyPgphit6KRxR4	6320	3NLBM7hxz4HFcW6KGKScfHAtPHQ8USmM3ep22LiyEfYZUGEbGFSp	1631	794	64	1	6128	jwCHdnaTBEvikpJrmSTTKCdv5cQb56LwDN3YJg8MFBux6sdhNB4	3272	4620	4620	1616770800000	orphaned
6328	3NKZfnnPHnaT89mYxJcbZwk8G7z3ebNYnypSdPWrE6fE9b8nfabq	6326	3NLfCrKYRjG5FhQLwokHACRoygKYHR1BWEC8ddP9HzuQgnoYzzbp	532	937	64	1	6133	jwMAjXRRWxVsH65eyeMnDq5NmZfpvEdXMARdbrtwxEXgkyqAAo7	3275	4623	4623	1616771340000	canonical
6331	3NL9bPiACE2SUjsmX6BPR5C9L3ZNRf3R1LDGA8jCb7r6SNex5X8y	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1451	1292	65	1	6136	jwX3UPXZ6E8xn98KKMksT9mA3vBKj4mfJnrozdeQyaRtcDuFThG	3278	4628	4628	1616772240000	canonical
6333	3NLmEajeDYvZGu8DDzLRjFtJsuJNMhLeVNM7p2Sg3uWRyYjQNDxa	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1451	1292	65	1	6136	jwX3UPXZ6E8xn98KKMksT9mA3vBKj4mfJnrozdeQyaRtcDuFThG	3278	4628	4628	1616772240000	orphaned
6336	3NLKiV6LiXhtZnn8tiYM2sB4rGUwnrRChWCCABYjAXWbqXhbaTSe	6331	3NL9bPiACE2SUjsmX6BPR5C9L3ZNRf3R1LDGA8jCb7r6SNex5X8y	1508	1021	65	1	6139	jwPX9PHfZa4cWt2z5yecwqXKLTxBjsC6o7x2495soje3JhbxwwB	3279	4629	4629	1616772420000	canonical
9318	3NLfJzzFbpScHf34wQmrCMqsfWSTvDPKq9iQjaB2dnXkz7b2guTJ	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1460	333	116	1	6301	jxkur7DVGmLgHRLaVDkWPsEMedtmF4kUdHwjLp4w1doGfq8b6FY	4833	6807	6807	1617164460000	orphaned
6346	3NLf65X5WP51esqP2BythGUQgJm7WQiq4n6vo5SoiXYNNjgqpgvP	6339	3NLr2JZAPqhFMV9NG6oJafBPTa5ZJmp4k2kiRWA5ZpoSyJQRB6yQ	1571	1089	59	1	6149	jx7D9BYBM23WF2r4txdMmz9n3cm97BR65iTHDELiuvYuj8Xaf4V	3049	4635	4635	1616773500000	orphaned
6335	3NKSojAEeb3S8oH2tHP3ohA1G513uUgGH6vtfGpEdueQa1w2pEbM	6331	3NL9bPiACE2SUjsmX6BPR5C9L3ZNRf3R1LDGA8jCb7r6SNex5X8y	1594	1326	65	1	6138	jxYmMYhkZ945FUidNnB1oQffqXU9y48m8fXAbR5VWVbpELLdjt2	3279	4629	4629	1616772420000	orphaned
6341	3NLUwUCu9jA9ASNY2RutucRNHZyjXMpGLLi5AqfGW4kiUJbznMS5	6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	152	964	65	1	6144	jwFE1hmutTaHK19oXJKxscARnCqQs7wju4NZQVbipcYvqsmpE2C	3282	4633	4633	1616773140000	canonical
6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	6341	3NLUwUCu9jA9ASNY2RutucRNHZyjXMpGLLi5AqfGW4kiUJbznMS5	1553	776	65	1	6146	jxwSjUFGnhXU3zNwvRuJuhsFjHvFViJWtgt98p7BCHNJdUyRsMw	3283	4634	4634	1616773320000	canonical
6347	3NKfjw73ZcWLpLyaoVCdqhst3JrVaPcRgGpCNQcPLSfAmW2xGiD5	6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	1527	1293	65	1	6150	jwdnJbT7h8yxdhrwhFe7CG1oHu9e13UGshjmdVgaEGrk4g1zybo	3284	4635	4635	1616773500000	canonical
6344	3NLHQaz9B9Zy81YbcVkZLiGQ7JtwMiewdVfF83za4DHuyKSkqi6B	6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	1599	1161	65	1	6147	jxwBBNQkHzDGwTLPn6iL1Zm1nHbZy1XfBVyyDHXTfYFw3uZv3iP	3284	4635	4635	1616773500000	orphaned
6348	3NKHAPozXQXFkzKF5t32vUAmwjDckE5w155PJ9nPNWS6gFHWRjLr	6347	3NKfjw73ZcWLpLyaoVCdqhst3JrVaPcRgGpCNQcPLSfAmW2xGiD5	1649	1017	65	1	6151	jwdBbgbQYDYKnhDzxKA8h9H8MjQtiTPtGEjmz6NHxrGLWjVVppe	3285	4636	4636	1616773680000	canonical
6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	6348	3NKHAPozXQXFkzKF5t32vUAmwjDckE5w155PJ9nPNWS6gFHWRjLr	1406	1393	65	1	6153	jxnABpeWf55w37ZKvXw3EsXgnnZfbeUTKkcbRdnphtqeyv3CejX	3286	4637	4637	1616773860000	canonical
6368	3NKzGiDHFi1b1hiAaAQPrwXujiLGppQagRW5bXBQgxQxkmsnQCD7	6366	3NKPLiXsA64dEdg23gevs9k9JpBGXgxQ2GFcayiRQZdRMwrKBAVi	1585	1366	65	1	6171	jwZeZjrSiqBiqtC1TtNvXhX2KpRhKTYyJQeCMYpFGDN1L6LCECr	3297	4654	4654	1616776920000	canonical
6372	3NKVwodYDAMxaVH1df7iTchwkis6joEAJ2Bg6DrE95jdQLLnryCm	6371	3NLfneSiSF3FumR6jNsfQKt2DTh74hARtMtmSxqDPiXTJTZGaxLL	44	959	65	1	6175	jxr3jB54pv3LDVgfdoCSkS1FVTUqm6joqUVsXjYpox1gk2HgKdX	3301	4662	4662	1616778360000	orphaned
6375	3NKbwQGyne9F1w8efMy1Nu44EhmwALuu2tBszDMwoB7yZgZEGSCk	6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	1407	1395	65	1	6178	jwqpp1ow9QMxCq7gmeeAZD5n163H88BDj73GidEMWmbzCFfhJYL	3302	4663	4663	1616778540000	orphaned
6379	3NLfNtEVDx7iuJ9YaWdaKNp1vwhXisC2Cj4rTo2meXpTkAgL3D1F	6378	3NLgFMh2KVL9gDnrUs7aM65oFhMSv69P5KmuMuC3dZe447DJ1A5V	1547	1132	65	1	6182	jx3WAXd7vdNPpAMannGNNNVf4ynijMjRJpbqZ1XJBRXAAXsGWR4	3304	4665	4665	1616778900000	canonical
6382	3NK7EumQGkB1bRDVG52NaFr2515qQkYcYz1tqQj7aMoR2y5zEzQK	6381	3NK5V6tcudPGspWFY8pBGfH5TAKTz1hRsKJ8VKAZagftJpNytDS3	1406	1393	65	1	6185	jxMZLVDiXFTt8pAjeWboKsBeFVd3xEhGY2W1v6ER98HUHueidKv	3307	4669	4669	1616779620000	orphaned
6384	3NL2ENq5HELiQVVM4Kv3QKu7THgPKCp2RHJqeHRnFQEk2pTzoRyZ	6383	3NL6cx1nTxPBEnoCciFXmDgfQQZdHsXqnmcXhrEkUrzzi5ACRFvB	1406	1393	65	1	6187	jwUGhAVj3sZVM9szvmL1RdwTPLo5qnRMkQsJTi2if1GBMVa1JPM	3308	4670	4670	1616779800000	canonical
6387	3NKsj15GhafVbCGAFpzzAMEkbWxW8oKS3G7AJE2dNemT579SAMPR	6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	1481	790	65	1	6190	jxm9ncDK6x64dDwn6Yh4Erk4iqJbFsT9G4PMwfjDYxSLk2VK3Y4	3310	4672	4672	1616780160000	orphaned
6392	3NLVAd5CZcLVjdGPMdgyqzRW9U49DQgEHkeNDasi1KdNbrLpLGeW	6390	3NL7kpZ6FLBKP5rWxjThhsnKFr6p3mzKvr5HdUWZXg2ikmnVQajK	1513	1253	65	1	6195	jwMGMccqmYEre13sZwxZqDY7UYtEzgPQe5DR3KyQd3j39bcGwfC	3313	4676	4676	1616780880000	orphaned
6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	6391	3NLUKcqLfyJs6MCeFS7FTALqSRkq8rgyNTGWeDGd1VwTgWbAwZrZ	1553	775	65	1	6197	jxzUuDpsXu6gSn9M59YAmKGLvSfcT33aKSPy3dH1Ef6bxXdoY4U	3314	4678	4678	1616781240000	canonical
6397	3NLhExvvzPizB6Eqk5jmQYH71uidc4PSSNwkRHv5jd87ByXJE88V	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	42	1361	65	1	6200	jxDxnH4FwPDYfDcvScAuf86GjAe6K45zskmhV9VcKaa2VmsudYm	3315	4680	4680	1616781600000	orphaned
6401	3NLXG82GPkhHUiEM4GGrfcyqsUMvghPN2jK4swDrkDgAmK4xYdWn	6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	1631	793	65	1	6203	jwsLZRThav7AEPJkgRLfqEVAgHxPespbbr7xPmusLHF9cpgZLnR	3316	4681	4681	1616781780000	canonical
6399	3NK4jMx1DVjpbgp4n5ekfxRYZkWZ4tLUz4Djy9WJmS529iyzSJTV	6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	606	1295	66	1	6202	jwWz6WZYAnNFF88qAR64r23zGYGZcPD7F884yGooH8WfeBQbgHn	3316	4681	4681	1616781780000	orphaned
6408	3NK7e1HGsBahfhLhdKLQ7CGzxbfZjYETm8xRVQ2zv79MPY8v44zZ	6407	3NK4KQrz4GSvPAQVDiekkvqjuiPqEnc7UgrU6agVgsHP35xsKeCs	1405	851	66	1	6210	jwSV8AFdT1zfMVsAFG6cMzknynN144ghGnLoxnGzwKCwUYuBvxw	3320	4693	4693	1616783940000	canonical
6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	6410	3NLB9cgWkuEuumTq4NMkqsP2xhGqVgdZGYEeUgSs5PfuRpt3LJqL	1500	1297	66	1	6213	jwXpnC4RiybRL67xJabvksxn8MB3Ra5JcRMQZV8XrS7qFT7oQHZ	3323	4698	4698	1616784840000	canonical
6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1523	955	66	1	6215	jwicu91aW8UBt7umQN3WYmCa745srJ5Kga7ou7oVDJ3vDMkUPvV	3324	4701	4701	1616785380000	canonical
6418	3NLQ1BgsVDvThLDNjerSaDahXicoE1goSxznpF6cmQgazmFtikJq	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1407	1395	66	1	6218	jx65heeoDg9WXLy11ptGz5rRzjTJSbM1nWfMiQtEuzmP6VDS5HT	3325	4702	4702	1616785560000	orphaned
6430	3NLrRjtUiQLSXz9ur1ZcmCmexgyXPGMoTpGE6DaJ2rHUx219oEh5	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1555	1347	66	1	6230	jx4YexZ5bRtpPLbfghnzPvgKyewDpeDDiKNBKNhUrvE8oGDcbEN	3328	4706	4706	1616786280000	canonical
6427	3NKcqEiLCPLsJbrsJyX61icTcpMhsV7yRjvG4T6ngVb1GyMAyLga	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1403	824	66	1	6227	jwNBx7itpvXdyQMGLP4JsEWN2kopKmujvfSbUCJCFJrwbJ6NehJ	3328	4706	4706	1616786280000	orphaned
6436	3NL8biycUsRsegVGiyMH34BkjrkQrT9Ckjh3Ax4K1LiJ44WkKjUf	6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	596	1306	66	1	6236	jx9Rm8Kf7GFriGwnBdWrwoHLnexyAWN3c1VdYmuZMWBgktqGQCz	3331	4709	4709	1616786820000	canonical
6442	3NLw2cuKR6f4V2VaaZR35Lsqv8TXTEApz8H9p2SQdR8NmEAJq6qm	6440	3NLBwsVLTU7XWxnPbFPiAfyh1odXxSNiBWGPnqgwqS4krBeD8nVa	1637	816	66	1	6242	jxCUCCSL4Sgg1UtE4R6W8GTZpR3uDuNF8Mzx46uPpuBEb28Pefs	3334	4716	4716	1616788080000	orphaned
6444	3NLxCMTBhDsww6PD8AjFo5LxFp1uZJqycM691YYzy3SniSf1qguk	6441	3NKHqX5KyzHp49xKQtCmEENx5nPe7pZZBqvDbp6THjZi4U48UbQT	1406	1393	66	1	6244	jxKB2QwUbKqW3pmzQBgargMqhAq9h3haXFrKXg3GSfXMztYkmAu	3335	4717	4717	1616788260000	canonical
9321	3NKfxp4Xa3m1nY7nxcTEYhnPJe6gpXeo18WjT1VSzmNViGqE6rjJ	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1649	1383	116	1	6301	jxSi6ZTbE7ER17wjjSbBQGUvzQwhazx1jxn3e5d2GBJpEWhw7pG	4833	6807	6807	1617164460000	orphaned
6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	6337	3NKxiMi3pLxtVBUYiqB5j8d2AmBCLv9pVUGacxiXemTUC5fucqgm	1406	1393	65	1	6141	jxTqGHrD48dnfaocW8fdpYJLnFoDtvUmEGtbvn78krDoD68JHR3	3281	4632	4632	1616772960000	canonical
6340	3NLHDAdUKj5wNmXGruPpRxAwTbdjMvTVJwupFogeYzPCuPSFkX3A	6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	1654	974	65	1	6143	jwobhtifbVEUHy2zsaVMsWLSPr5dhHL9hEMRztXo3E8bPzs7Z1i	3282	4633	4633	1616773140000	orphaned
6349	3NLN932n5Jy3a63wJUm6tB4MvBB5ncSCfvprkUGRRGChMNJqGXdw	6347	3NKfjw73ZcWLpLyaoVCdqhst3JrVaPcRgGpCNQcPLSfAmW2xGiD5	1403	824	65	1	6152	jxnAVWsSik9vPZmN5v3F4BsqWck7Uk7wX4E2KwtZxMEZk9DzFuW	3285	4636	4636	1616773680000	orphaned
6354	3NKMQ3br4rDMGSevqrB6bDt5EzPxXjihKFzVxDy9YK2Lk22TCbQP	6351	3NKSnn6iLbcmvxPvg49VNSMzZg8DK6FoFRAHgsRWGdGsCkATkqqw	1516	1048	65	1	6157	jwBLbTsbyKU9cJcNPuVCRJFFv66XTgLzcnmrnfHgnrCFeBZnHsK	3288	4642	4642	1616774760000	canonical
6357	3NLTxYGZxrzen5GHAqHmo3ao656GS7XdCCiZBv6kzaGcz7TKGNqn	6356	3NKVxKJ1exsW6prJKp3GyKSTPWExMVCUF8Boy69HzEb6m2h5HYmK	1406	1393	65	1	6160	jx6bWrqvaa4wcJsfzjWPR8Zf8qbd3M4bC28z24gDomC3jyz3Q4n	3290	4645	4645	1616775300000	canonical
6365	3NL8s46fo2ERGk2PVJMxSjdHSa6QMJaSBUQzax6Uyv3M7EY91HNa	6364	3NLA7dUfcjJDnYPYvBJVRbnhkeHiqz1MKX9gNnBPyNhxnfXJyQr1	1426	1118	65	1	6168	jw7DF1PQE8uGsGN7q7W4PTNunLqzBuwdjFMXhDuhWL8ZRVGKPfC	3296	4653	4653	1616776740000	orphaned
6367	3NKFEpkB1QAL4p1HxkFmVHBB673mMdD3qeDQSUKwnnpaCFbZcm6i	6366	3NKPLiXsA64dEdg23gevs9k9JpBGXgxQ2GFcayiRQZdRMwrKBAVi	1501	1114	65	1	6170	jxuPNEMsbuDygUSdgYgV396PJGR47FXqu1q1zhXn5ZNvcVqcxph	3297	4654	4654	1616776920000	orphaned
6370	3NKUaJkcN94jF1EPNovfriCYHfof6sRV9WDp8ZDY4zkQ74e7eFdN	6369	3NLLHq2AUaSbv91ZEqgSmu8Jmp1exjfy8SkCjRJHNQJH1bz9xcNu	1406	1393	65	1	6173	jxhwMxjiCvPqsWSfx6ZzpQ5ViVoUrrBZPrUHYnW4c1tP9E5ieGU	3299	4658	4658	1616777640000	canonical
6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	6371	3NLfneSiSF3FumR6jNsfQKt2DTh74hARtMtmSxqDPiXTJTZGaxLL	1534	1317	65	1	6176	jwhYzwRaVW9tpBS7r2ugvfTMxWbie2y4vtk6wQCEBWVMZKJCmfh	3301	4662	4662	1616778360000	canonical
6383	3NL6cx1nTxPBEnoCciFXmDgfQQZdHsXqnmcXhrEkUrzzi5ACRFvB	6381	3NK5V6tcudPGspWFY8pBGfH5TAKTz1hRsKJ8VKAZagftJpNytDS3	96	96	65	1	6186	jwnTXyFwojbiM4sckwJKbKAkYNtmcR5MDGEzXKMkZnYySWFEjHK	3307	4669	4669	1616779620000	canonical
6388	3NLRAuRz2CLxFdVH5Ck4g2tYivvHhsykuAMMSUnsgVWk8FzDp3iD	6386	3NLd9XHJutdfuEVtMZRZfQ4PND6JzniTwSUD4XYUhXBmJPegshsF	1447	1345	65	1	6191	jwtLpXAdgotKg8kXob873dSjRsDsjFz9rVp33M4pcAhtmgXsNFc	3311	4674	4674	1616780520000	canonical
6393	3NKjCUB7DasgEJ3bhVjm2FzVs8bx61NpFCgcbby3mExNrFPS8yDA	6391	3NLUKcqLfyJs6MCeFS7FTALqSRkq8rgyNTGWeDGd1VwTgWbAwZrZ	1406	1393	65	1	6196	jwjBXVuvCk22b5G2gF8J8BwT3mhNXov1gn8a3ozBfijY2tzKuhi	3314	4678	4678	1616781240000	orphaned
6396	3NK3UT4FEBbYCr24pqRgTVbHqNv2DUMUr1zc4ay9KRg1Pnq83quM	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	1673	1368	65	1	6199	jwEn2UzRq2QkSLjA7tGYhcbLFdkzqZEpYCRhoMoKq9LgwDiebDc	3315	4680	4680	1616781600000	orphaned
6402	3NL4nUrVR6Njs59HFMwDK38yvQuJcp23qmaCZu1stnL9hdhenxMP	6401	3NLXG82GPkhHUiEM4GGrfcyqsUMvghPN2jK4swDrkDgAmK4xYdWn	1407	1395	66	1	6204	jxp2jQCJ4ZCk7iAhVTpfvQimYjQDryoL8SRLVsGCWkHTcMfWUyu	3317	4682	4682	1616781960000	canonical
6403	3NK3aE335M6PusBV89k5hqPvfuvjhHdzkBwQVxnKWnmfbLwjdjWV	6402	3NL4nUrVR6Njs59HFMwDK38yvQuJcp23qmaCZu1stnL9hdhenxMP	1406	1393	66	1	6205	jwSeSWCiV3akayddR7MkxFtD2d3Xu7EVEx49NT2FksB1ti49brN	3318	4686	4686	1616782680000	orphaned
6406	3NLpzR6iXKeEQ7djrof973yb1BvGv4WXQizTMvxquC2CtNSA2a9d	6404	3NKFdHaNK1ikqUMw7gtbRs7qKRNGE4wLdrWSjnJZ4iET8fmZNSAU	1403	824	66	1	6208	jwQtrYJzy9upPV3NoXRxTokodDmnbtNe2JdbQzxoH13PG9wDf8K	3319	4689	4689	1616783220000	orphaned
6410	3NLB9cgWkuEuumTq4NMkqsP2xhGqVgdZGYEeUgSs5PfuRpt3LJqL	6409	3NL6prPAFwZWBhSaAxSBVtna1xGjrK6GyX4KvEqrGXMvFCofz7jh	1403	824	66	1	6212	jwcCjnqr5BfMXb54upavQ4FuLadKKEqpZU2PSM4NV7MUwb517wz	3322	4697	4697	1616784660000	canonical
6413	3NKicyqi4nsgbmiDjLGxk8ZjkeugbiuSYUyQei4TVwpU3oVKyxgJ	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1523	955	66	1	6215	jwqT6AVLNLAcrdzjXBknvZkKRWz8sZm68rCY9hhr9NEtry3Xx1r	3324	4701	4701	1616785380000	orphaned
6417	3NLNV8rJGFdyrqustBE8XJC7Bw8JgQGAtnsNoq8iz9P1pYXn6fvd	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1619	1149	66	1	6217	jwwERNzktLq8ZqAYQPjevfXAL1zVbUe7n7dc5Uf1sdwB6cHj4Re	3325	4702	4702	1616785560000	orphaned
6424	3NKiBRjw7454pd7kRe8f3YiQouMG7LNt3pDfYBj2dbHce3ZTsAgV	6421	3NKFrcsnJhTWEpsvhKDHrwpuzxATqx4qvGd727UUFGtqLi94T96J	1406	1393	66	1	6224	jwzYAANH5Q2QJKFMkL8cRNEYGFqUUZhWRyEwYWXtxeoB5bC5Lxq	3326	4703	4703	1616785740000	orphaned
6429	3NLby4XZjRAfa5P6pddydtuAWHnRKvDzaZhWD2zeeKTzbUFtMFcr	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	700	832	66	1	6229	jxr5u1AhHKpPgr7Z9m6GtGwx9pn8i8YDbF7Gxt5JynTgoRRps2p	3328	4706	4706	1616786280000	orphaned
6438	3NKUbCCkGUoJu7hERWcxpf3YyD9pNRrovFN56ZWwtW7S9bLzSidL	6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	700	840	66	1	6238	jxNUmJZd2ga3ruP3QvxvoqPGGWhkgnNWRTLpdGqFnArUByiXjFi	3331	4709	4709	1616786820000	orphaned
6449	3NLjoypzBkM1qVPMCrJRy54AqmCzt4Q3qTQmcWzU2GhVdjR3q63Q	6447	3NLqHiUEhLMDy1ZFodTk3PdYE413bvVdX2thDyE4gqvbfXoj2zNf	1406	1393	66	1	6249	jxhN9xLWVNqBNgynQB1gmGF3Qc9pxnnYChMVc5iiDDed1VZDSNx	3338	4720	4720	1616788800000	orphaned
6450	3NL3uksTUWALckWZFUtvfhhY4To8HXVrS6TYpf23GhBD2X9vdqD7	6448	3NKjGB4JbV6StiYs6YNSGr3vcTEfmubkZBjQfqeAJzUPtVk69zdG	1477	1350	66	1	6250	jxkiiTuWLy1fEKe6rnj3rkqnbZM7KLnSSr33UXeH53YiZ8M2TKe	3339	4721	4721	1616788980000	canonical
6451	3NKxFoQZRAxax2hQFQcdJvUJ4nr53tjyE5n9adpTCWpW9U8nH9n9	6450	3NL3uksTUWALckWZFUtvfhhY4To8HXVrS6TYpf23GhBD2X9vdqD7	1631	794	66	1	6251	jxjT8iaeiXXDVGHDqN35r6aBpjwmwtqrW8jPciyKm7HW13mQ1yp	3340	4722	4722	1616789160000	canonical
6453	3NKn9iE1iMHGcgNuawqhUjKJ14JEzrik8HABCS6LxGPi48sX38jb	6451	3NKxFoQZRAxax2hQFQcdJvUJ4nr53tjyE5n9adpTCWpW9U8nH9n9	1624	1088	66	1	6253	jxHevuAQetP9Rit16PJWCPBpQXpWnAaERWXTgCXshT79Uer9oAJ	3341	4723	4723	1616789340000	orphaned
6455	3NLZ3p2nYjGkqP8sGTbX3w9fF2EGW84rmx8SU5ha2Fw3h1vrRS6V	6454	3NLRBSx4dKK4eXRTneU67ZxV2ziwMjFdH1tTVEXdyW2mTYbBe1X5	1637	816	66	1	6255	jxML9o22Asm7s7UtoNYtrfLxku3nMsPbKUa4XNqoUuqjK1dEw1h	3343	4725	4725	1616789700000	canonical
6456	3NK5FSZHUwoqdCMnPr4fyguQsrqHnFwHpo94jfFYuF8dNMgoNUtu	6455	3NLZ3p2nYjGkqP8sGTbX3w9fF2EGW84rmx8SU5ha2Fw3h1vrRS6V	1600	1126	67	1	6256	jwzChjtirvLunPE2HFk7LRvB1kEmKpaSV2upWFQTyFnn93PXgXD	3344	4726	4726	1616789880000	canonical
6458	3NLp3EuXrXa9eqDtAcsjE7ddGaxesfVkzJnCt141VUwPKkYikCob	6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	1483	421	67	1	6258	jxtCJmNzMBFeGYqb2MEftXrPfNSPTnYd9JP77WzkAgerZqN6FiM	3346	4730	4730	1616790600000	canonical
9421	3NK3YQ5bQ99oKRU79VsAahfmTwWiN4w8p3DLnvHqpYhfqWnEa1DM	9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	1536	1067	117	1	6301	jwVuhUmyU8WmpMkpDpiJJYdAEi2zud5s3JNA2k4Ceg1jQPhQ5Sy	4843	6886	6886	1617178721307	orphaned
6443	3NLgh8WtFr6ovshrG4BMsxdrxN9UQkBR2g8KtsmVA86L7NHCyGT3	6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	1631	794	64	1	6243	jxHhKaBAj8NcqnUhoqYPXS6g5bnLpQHGTLYtr77SUaJ6978UcEX	3278	4716	4716	1616788080000	orphaned
6345	3NKP6Z5j3jBZoixePzXXMXCu21evf4dni3NSJHPGepzmrVjs85GW	6343	3NLkAaiHEgDfyzhJVjJVTyrzW5Y2QP7vXyqMDVvPLFgyuBfye8uN	1534	951	65	1	6148	jwPaRaJBJt7Yg1jYiTLjZxAsNFoX4DN3YWwE4EwnHtVQvdnV61V	3284	4635	4635	1616773500000	orphaned
6352	3NLAFMY4w5Dss5JrXTLR7Zce8GnFxLRFAychmVFgvWpgBG4wWbFS	6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	1458	1077	65	1	6155	jwsyLFDWKLgMqd3pvwGj6JJDJP4kPwmRdhyY38ouYpcoqG2c5gw	3287	4639	4639	1616774220000	orphaned
6355	3NLhYCrdPRgH4nj7mVDw1L55XSgzqvRGyBY8bNZgAHechruTGf1w	6351	3NKSnn6iLbcmvxPvg49VNSMzZg8DK6FoFRAHgsRWGdGsCkATkqqw	1406	1393	65	1	6158	jx2AFotvvJC9EAtRK9eJ7TpoFHhLrifiNVauWjZVChHaS8GG3Ye	3288	4642	4642	1616774760000	orphaned
6358	3NLoxcz4NyMHo69yjLmU3F3Fh1EXCKT2r2w3U3RHBrEPYzNbaavt	6357	3NLTxYGZxrzen5GHAqHmo3ao656GS7XdCCiZBv6kzaGcz7TKGNqn	1542	1304	65	1	6161	jy2c4REujvupaYUD5B3Y8mvC9UuacNTngE18ha7quBZBFroGhD9	3291	4647	4647	1616775660000	canonical
6361	3NKDP9y25HzzJGKEpmB33qfzxaWhsDrCNUczkzUHEfL3pKaMiEce	6359	3NLmh1gveJ12YFym27LLpugondhLuY6djwqGxGKFBPR9KPuFCnC6	1631	794	65	1	6164	jxntQ8R4dFqba18586uMWv9neQXBkgmswN7YswERGMtAjLxd34z	3293	4650	4650	1616776200000	canonical
6363	3NK9KcS55AkNSkiU1AVCWvmV7zo2ypE1DYBYRrU3pJ6M7FXd4uMo	6362	3NLNNJwshfRG4NToQvge6mtfCKZXPEeJXRJTfMA1saSet5PBW42q	1403	824	65	1	6166	jwfuai1mCbZLZPLCZ5Q65dJL5qNogsF86LKFkuyRmPZdyKsCfaJ	3295	4652	4652	1616776560000	orphaned
6366	3NKPLiXsA64dEdg23gevs9k9JpBGXgxQ2GFcayiRQZdRMwrKBAVi	6364	3NLA7dUfcjJDnYPYvBJVRbnhkeHiqz1MKX9gNnBPyNhxnfXJyQr1	1407	1395	65	1	6169	jwj7iQ4yBRAUaL87dEdzmW4KohEfgCytF2msuqobEmE78RE8VJr	3296	4653	4653	1616776740000	canonical
6374	3NK5aJqZKdDR9P7o6JfGxAYAirfG8KP4eGyLqyhU6Vg5h6KXv9du	6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	1646	988	65	1	6177	jwtiWDGnbMuPsww3LiUDxnQJBqTsyx7iq547DCew9n7djKomXg2	3302	4663	4663	1616778540000	orphaned
6378	3NLgFMh2KVL9gDnrUs7aM65oFhMSv69P5KmuMuC3dZe447DJ1A5V	6376	3NLPA3Lu1t2SEqEhdb8hWfLCqpwNy9WnTEc6v5VLYynhGomsPwRp	1457	1391	65	1	6181	jxENcp1cjb4NieXN3L1MfGo21qGqyNmw3LrD54PnHVrCPvoUE1B	3303	4664	4664	1616778720000	canonical
6381	3NK5V6tcudPGspWFY8pBGfH5TAKTz1hRsKJ8VKAZagftJpNytDS3	6380	3NLJxQ84rVUaN6a7XNpVo6xv8MGihWnMCu9BUb2bFK5f4tdx1UNw	1403	824	65	1	6184	jxtCsMDCH5Z1MuvXMkD4bspZW1C5aE2uD83Cg7SfBbTMDA8PJys	3306	4668	4668	1616779440000	canonical
6386	3NLd9XHJutdfuEVtMZRZfQ4PND6JzniTwSUD4XYUhXBmJPegshsF	6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	1403	824	65	1	6189	jwdxobgyZhsK51sa7YEhxmTttosS2murwocsAybDkyyVKXq9uKg	3310	4672	4672	1616780160000	canonical
6389	3NKJNpQxfUbCTs3XbFHjQe9PbYmeGTi5YmK58cQzMMH8wTqDM6e5	6386	3NLd9XHJutdfuEVtMZRZfQ4PND6JzniTwSUD4XYUhXBmJPegshsF	1448	1311	65	1	6192	jxdGbPBbwRhgs2vNAbJkszoqVFCbPXuVAMQPr6Quq7b91GWysXP	3311	4674	4674	1616780520000	orphaned
6391	3NLUKcqLfyJs6MCeFS7FTALqSRkq8rgyNTGWeDGd1VwTgWbAwZrZ	6390	3NL7kpZ6FLBKP5rWxjThhsnKFr6p3mzKvr5HdUWZXg2ikmnVQajK	1419	814	65	1	6194	jwRrPtKgtqF61R8qmrYLVLo92yCdDGj3NMtsAi6zLRTdNRAdPJL	3313	4676	4676	1616780880000	canonical
6398	3NKYJsLL9Gzy4iPCWHX99VH33vGhqMmkUvbDCatT8bRYsjEMkaY8	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	1652	949	65	1	6201	jwu5X8zqHN99itgbbekVu7eKCpeVFPsRWjLKaYdwC7zcRLTHCgu	3315	4680	4680	1616781600000	orphaned
6404	3NKFdHaNK1ikqUMw7gtbRs7qKRNGE4wLdrWSjnJZ4iET8fmZNSAU	6402	3NL4nUrVR6Njs59HFMwDK38yvQuJcp23qmaCZu1stnL9hdhenxMP	1407	1395	66	1	6206	jxMuWZH23omERNAnMPyFHLWgUoF8mf21UAvER4Y58hYrCcBQfWw	3318	4686	4686	1616782680000	canonical
6407	3NK4KQrz4GSvPAQVDiekkvqjuiPqEnc7UgrU6agVgsHP35xsKeCs	6404	3NKFdHaNK1ikqUMw7gtbRs7qKRNGE4wLdrWSjnJZ4iET8fmZNSAU	1407	1395	66	1	6209	jxYgBfzGU1b8YEdQQwDwyMqVSihRrKu3ESK5TV8m5cXygtpVnsH	3319	4689	4689	1616783220000	canonical
6416	3NLGCCphY4SuqNJ9ZAQ7fqg7HtPHs1ETJdoTywpF28H67fTyFX2Q	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1523	955	66	1	6215	jxmQtAqKdLdYGy9WaHA8QQq313dFJsJHAco5C8bPJaRE9yxcnp7	3324	4701	4701	1616785380000	orphaned
6420	3NLKnPb6TEXtpUk25p5tfTfGCf36KTAihor7rYF4q7PaiqBcfFBC	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1627	1019	66	1	6220	jxjUVDyMk17rLLtMrTgKWk9cNsJJzHvDFrWfL4mFYpUUro6jLBu	3325	4702	4702	1616785560000	orphaned
6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	6430	3NLrRjtUiQLSXz9ur1ZcmCmexgyXPGMoTpGE6DaJ2rHUx219oEh5	448	1179	66	1	6231	jwBTLVuphZFt3vNUQWJ3Tsgt71ds6LvsCkLwakzoge2PnSPLJ1p	3329	4707	4707	1616786460000	canonical
6433	3NLubpB3Lf4Rsw22unATfP5rJ4qRfNBWJspjQmk6htcmA8BjNaSy	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1406	1393	66	1	6233	jwitYnmnY929HuyXPqYa2wKzkAfv1UAHFoYe4ksncKXboPLDAks	3330	4708	4708	1616786640000	orphaned
6441	3NKHqX5KyzHp49xKQtCmEENx5nPe7pZZBqvDbp6THjZi4U48UbQT	6440	3NLBwsVLTU7XWxnPbFPiAfyh1odXxSNiBWGPnqgwqS4krBeD8nVa	1406	1393	66	1	6241	jxPR82sLJEbGABpQiCKw7iBvHU7697wBbmogVF4xJDRAbY24wa5	3334	4716	4716	1616788080000	canonical
6448	3NKjGB4JbV6StiYs6YNSGr3vcTEfmubkZBjQfqeAJzUPtVk69zdG	6447	3NLqHiUEhLMDy1ZFodTk3PdYE413bvVdX2thDyE4gqvbfXoj2zNf	1671	550	66	1	6248	jwF7sV6EvvZkZ8jf9chZJ3H29HcgENPuEeUnpMyaJf8pdVQo9U3	3338	4720	4720	1616788800000	canonical
6459	3NLk15rwvNYLRaDWvNwdLyUz1jut9xCANSorqDkckBxTcHhdzRz5	6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	596	1180	67	1	6259	jwQ6Cum1wUXVZSoqugQsmb7RpSa8ZQZK4PsoASUsovLFrUecMaq	3346	4730	4730	1616790600000	orphaned
6461	3NKNmdM4HukdHAxrVh4NfxhwtpsydhJ81T4mHw6um2vs2Jn19mYb	6458	3NLp3EuXrXa9eqDtAcsjE7ddGaxesfVkzJnCt141VUwPKkYikCob	1579	195	67	1	6261	jwMXJoDhu4uv5dzyFaEMuKeqxe7akztL6K8VkFq7r3oC5255DCu	3347	4732	4732	1616790960000	canonical
6463	3NL4YWoLW4gHo2wXkNxAqV6LdLBfi1QuDvmmtMpZfCarihR1w2Kf	6461	3NKNmdM4HukdHAxrVh4NfxhwtpsydhJ81T4mHw6um2vs2Jn19mYb	1503	1031	67	1	6263	jxjKHVcK2bYjXbeaqLEUVxE7U7cviKCtuimesxzuWbJEjRfjCnR	3348	4733	4733	1616791140000	canonical
6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	6463	3NL4YWoLW4gHo2wXkNxAqV6LdLBfi1QuDvmmtMpZfCarihR1w2Kf	563	993	67	1	6264	jx7WXrXQ8Bwamkj7uP6Q7Yygc4iWpDSctJ3TS5MeWzvDYpgAY8H	3349	4735	4735	1616791500000	canonical
6466	3NLPfvebAc4CxnedvLgp6nHbcEkgLFhr4e971GVA6StaWYKs3cBU	6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	1549	1362	67	1	6266	jwDwbYjzbok6Tg96FKa6PtwJt6GxUuFYDtxbKk3pB5uWzjpDmDR	3350	4736	4736	1616791680000	orphaned
6468	3NLfLSJD3c2N897x1u9ygzX7Er1rCja8QYPYgUayAe8izt3yG5Mh	6465	3NLoSaDCrqkwh7vh6SA9EmB5WDmMNdxL4ngFRAwPNXn8LVFt6n8b	448	1179	67	1	6268	jwWbrgui13cPqgZXd881YadLMjkTr7t7yhF56NEUSMxm32vrsWa	3351	4737	4737	1616791860000	canonical
9346	3NKQEeUNdJZjJdSMcsnsUJUaFpvtRp7jLRwwDooAAS5U2RoroMU8	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1671	1239	117	1	6301	jxKgMNScsZ6RKGrXMobCDUvAcPBo4rdnBqrwoD8ydWGsc5U9ek7	4850	6831	6831	1617168780000	orphaned
6351	3NKSnn6iLbcmvxPvg49VNSMzZg8DK6FoFRAHgsRWGdGsCkATkqqw	6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	1483	37	65	1	6154	jxhYcfxSvMqYvU5VeXYs2NQBjBaMJetctbs8jaZH7vZwxWKNipF	3287	4639	4639	1616774220000	canonical
6353	3NKm7T2Hvqc1QM38WeW8GWR7zpJAevALDLqGhZwfGSfNn6jRny9S	6350	3NKLMnuX1VyDDYUi2oLK4U2vLbEKUUu6bRAPhfqUmP3GRAQyfkNh	1637	816	65	1	6156	jwDKHxbrd8MEpJ35nUqnHiS2rVKgfCguyrYD9AHVpiZZNN9ARQa	3287	4639	4639	1616774220000	orphaned
6356	3NKVxKJ1exsW6prJKp3GyKSTPWExMVCUF8Boy69HzEb6m2h5HYmK	6354	3NKMQ3br4rDMGSevqrB6bDt5EzPxXjihKFzVxDy9YK2Lk22TCbQP	1476	1125	65	1	6159	jwraCPfC13jmS3i7AbD9V3xrmGjf2FUwPpRkjQHUwWdPKS7oWe4	3289	4644	4644	1616775120000	canonical
6359	3NLmh1gveJ12YFym27LLpugondhLuY6djwqGxGKFBPR9KPuFCnC6	6358	3NLoxcz4NyMHo69yjLmU3F3Fh1EXCKT2r2w3U3RHBrEPYzNbaavt	1406	1393	65	1	6162	jxJAiZDjdvJQpeEzssJk5evFxucQm4TTw5v8NgHNdAnGJv2K539	3292	4648	4648	1616775840000	canonical
6362	3NLNNJwshfRG4NToQvge6mtfCKZXPEeJXRJTfMA1saSet5PBW42q	6361	3NKDP9y25HzzJGKEpmB33qfzxaWhsDrCNUczkzUHEfL3pKaMiEce	1407	1395	65	1	6165	jwgs2fNT9yAiJDCHRaXNBrHZHQshdEJmub8UKRZfRS7xyc8kZjo	3294	4651	4651	1616776380000	canonical
6369	3NLLHq2AUaSbv91ZEqgSmu8Jmp1exjfy8SkCjRJHNQJH1bz9xcNu	6368	3NKzGiDHFi1b1hiAaAQPrwXujiLGppQagRW5bXBQgxQxkmsnQCD7	1483	653	65	1	6172	jwgUGMBfoFmacjFmyvdihpfMYTixCbBP5FHhQxY9NHVigkEZqUy	3298	4655	4655	1616777100000	canonical
6376	3NLPA3Lu1t2SEqEhdb8hWfLCqpwNy9WnTEc6v5VLYynhGomsPwRp	6373	3NLKMhCfawLcxHroiYiUnMTWCFLM9FbrDSPuAb3B5vbNBihSYP65	1476	1371	65	1	6179	jxTwAtEr1SXA2Nxgq5heijxKxGStC4iNwj5wjMnynSpbGWcaFu8	3302	4663	4663	1616778540000	canonical
6377	3NLAbskzfqheCR45BZ3LPkVw4LM8SgrgzqvJx4xaFZUYBE5J7iMJ	6376	3NLPA3Lu1t2SEqEhdb8hWfLCqpwNy9WnTEc6v5VLYynhGomsPwRp	1444	1255	65	1	6180	jwsTATRBrGCv8qdsrn3NcrpCGnD5rnhP3AGDHmcYHpBE6wMtGfH	3303	4664	4664	1616778720000	orphaned
6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	6384	3NL2ENq5HELiQVVM4Kv3QKu7THgPKCp2RHJqeHRnFQEk2pTzoRyZ	1619	1275	65	1	6188	jwDW1hMNpsE8J1bTtfVPqxafdERfKH5hz6eAMQxMa86q4FiEqiP	3309	4671	4671	1616779980000	canonical
6390	3NL7kpZ6FLBKP5rWxjThhsnKFr6p3mzKvr5HdUWZXg2ikmnVQajK	6388	3NLRAuRz2CLxFdVH5Ck4g2tYivvHhsykuAMMSUnsgVWk8FzDp3iD	1439	1153	65	1	6193	jw6umCaH66hWM2sMQ3FkiYFh6J8eNS2reAwTXQ2qHhXk8HWgDXZ	3312	4675	4675	1616780700000	canonical
6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	6394	3NL3VMZmK32VovJZPpgMpgm4k4pV64arnexU92JzaReN4ndD4nw6	1402	796	65	1	6198	jxdr4QW3GgMq9JuvrGyauMusz3SDYDkMrKvU7wjkEkanVAiPo6r	3315	4680	4680	1616781600000	canonical
6400	3NKtzuXxPGsXaKGEXC6RtcKqJrZkGwSAKVPsJMzsJr6vsZaLbAGK	6395	3NLFSLykak8jL5DtgL4Q9XynWQKvTEYaj7U6d8MwHyJQbKwE3GP6	606	1295	66	1	6202	jwE5TJdQB4YoZ7XTJXvQQGePNp2oRR1TE2S8fRRuueiCZsGzcQZ	3316	4681	4681	1616781780000	orphaned
6409	3NL6prPAFwZWBhSaAxSBVtna1xGjrK6GyX4KvEqrGXMvFCofz7jh	6408	3NK7e1HGsBahfhLhdKLQ7CGzxbfZjYETm8xRVQ2zv79MPY8v44zZ	532	937	66	1	6211	jw7REA5BXkC3x6RvJ9Xt6SWWRSAV96gix4iNb9eU3JpAuA7rDCR	3321	4695	4695	1616784300000	canonical
6412	3NK8RP6tJcjxQQVi7yKsJSrA1sDtzcSjT9QgT5yWWaKsdd7eZm51	6410	3NLB9cgWkuEuumTq4NMkqsP2xhGqVgdZGYEeUgSs5PfuRpt3LJqL	1419	814	66	1	6214	jxgne5xg73peJaeSGAjbPVpuSV35jVHSxR2Zojn59GudtypRorc	3323	4698	4698	1616784840000	orphaned
6415	3NKhm4DjB85pooTqY3CsBDNgqGSrcuCns7aNsW544my3EfQwEMQZ	6411	3NKdRegQQvjyuKjWUVJGjTnqtK9jA2vXykQWd4a8jFT5EBg2CEFA	1516	928	66	1	6216	jxRJDKasJkTyrM9b9BjNVkrTFznCenUBE71E7kg7trB7Kn8gZTc	3324	4701	4701	1616785380000	orphaned
6421	3NKFrcsnJhTWEpsvhKDHrwpuzxATqx4qvGd727UUFGtqLi94T96J	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1440	1131	66	1	6221	jxzkPVc8RDYaqKMVEsW5SfypyoJiEFugiSPSyBsqHpCBzeoqHus	3325	4702	4702	1616785560000	canonical
6419	3NKVY7SkQ7X1os1c5bampo84Zzb41HPniTXajT7MPnK6uHJ7GNzf	6414	3NLLwcyhFHsre65Q7mxiAibLzNvM5BGipJTQ9VpecCUm1TkJbxAp	1646	988	66	1	6219	jxXohShk9SLL8vAScdQ9ipQZg7D9hRK5fZxiVac9183eF2NdziU	3325	4702	4702	1616785560000	orphaned
6423	3NKkrfRFw5FrtUarLvbFEtAaMUpHRLZnakTJydGFSMbqYL2dyeiT	6421	3NKFrcsnJhTWEpsvhKDHrwpuzxATqx4qvGd727UUFGtqLi94T96J	1501	1234	66	1	6223	jxt8e5FjhNpR4Yvr7kTcu88o2hoGxQaHqMr5AzkcLQS83UdxqYe	3326	4703	4703	1616785740000	canonical
6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	6423	3NKkrfRFw5FrtUarLvbFEtAaMUpHRLZnakTJydGFSMbqYL2dyeiT	1406	1393	66	1	6225	jwhwSPU5D5V9it6SWjXyLDEcg6rnNYWSgFVEsd2eJeoFZHS1TUE	3327	4704	4704	1616785920000	canonical
6428	3NKcXNHzv1D2uGwjVbCbjSkCyy1VP1eLZb8KnKecqqPmAj3ujdYN	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1646	1354	66	1	6228	jwqS6hboNKsN2yEUnCCGkaNRRf3sVgSYR9wPyFbZt4k9LX4SGdo	3328	4706	4706	1616786280000	orphaned
6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1619	1149	66	1	6234	jxtjT96ayDFF7SBiv1Fq8ym9SQuasMwsEQLUU41Ej4HcKtoCYq5	3330	4708	4708	1616786640000	canonical
6432	3NKk6DXk2vHE1ssToe14ta2841iGNL9XpBvSah4e6Z42RNQ5X3ec	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1503	1031	66	1	6232	jxDeBki3chwqJN2EDUyL3LSVJfp18ejdqTQXFvZFyotsS7weHcS	3330	4708	4708	1616786640000	orphaned
6437	3NKwcdYrsANUdWaATtXB94eJLsNKGSQQ9fmk2mKPL3YKxQvmjVp1	6434	3NL2MWB16JHsfyQgs9AFwSCrD2KS87bmGDoGnzB5e3jRPbDy9CNb	1405	851	66	1	6237	jwMQpxNBTkkpiTnownQNK1b57hr6VXVQ3kVNQcB8qeaozvmveMH	3331	4709	4709	1616786820000	orphaned
6439	3NL8bDW6SzxW5FYam8EnXuxDfQ1qBLPfwG3qVcEEEhTN6ALB52AH	6436	3NL8biycUsRsegVGiyMH34BkjrkQrT9Ckjh3Ax4K1LiJ44WkKjUf	1405	881	66	1	6239	jxFdQwrkDx6Ct9xACx8Gt678yTTdGJL9Q89Wkc98JKzzVjqBKyJ	3332	4712	4712	1616787360000	canonical
6440	3NLBwsVLTU7XWxnPbFPiAfyh1odXxSNiBWGPnqgwqS4krBeD8nVa	6439	3NL8bDW6SzxW5FYam8EnXuxDfQ1qBLPfwG3qVcEEEhTN6ALB52AH	576	1355	66	1	6240	jwNn6xpjHD65wYsj9jV4bW7VDUvU8AkJoLhDMUot878owqoT27D	3333	4715	4715	1616787900000	canonical
6445	3NLRNdpLzfipRZ8PEtxrkB6X2h5J5oeY4nY5zUWZxjsAKgFKrS6s	6441	3NKHqX5KyzHp49xKQtCmEENx5nPe7pZZBqvDbp6THjZi4U48UbQT	1483	150	66	1	6245	jxzoFRV2yLQr8t8E9PDSN8CqMLqmTFrhKhaVXUaRRgw65SbsDAA	3335	4717	4717	1616788260000	orphaned
6447	3NLqHiUEhLMDy1ZFodTk3PdYE413bvVdX2thDyE4gqvbfXoj2zNf	6446	3NK9Fjao522VceumzpUM4hKgKSdgzeKGaVvFnh7ccxDFeX83iQWG	1637	816	66	1	6247	jwDccofaB1oW8KdZFRufBS2zHEbGaBf2Q3Wvz4z9H6baFYTx85G	3337	4719	4719	1616788620000	canonical
6475	3NLwBjYrTNBH5SeSrTUCvdCCLarWyk6AUfj3RWgqGv6AsHc7rCbo	6473	3NLSR2iLjtNvNHKqtjv5KYGLMvCUntV87uguhKjaAbLviotwoNTx	298	942	67	1	6275	jxoVzn3c8UDuh9w45Z2AmmzHM3pUeseUX29K1Ynjrj6wxMBBUEk	3356	4743	4743	1616792940000	orphaned
6477	3NLgTi25PXWLEV33jqeUu1TkuRa8jZZvTYzdpJSfqH5hv9PMFVRt	6474	3NKF6L4QifYqxPqFPt6V63XYZ8jU1EhJJGK4s2MpCz3M2QJuhkpG	1549	1362	67	1	6277	jxhgeBWoq9hs7FGpAS2TtugYKgeiqjSPJqE63Aym3MstZqTsokP	3357	4744	4744	1616793120000	canonical
9552	3NKPe7FAmagxNPmWemsPUHAQMtj89GvTf2dLSsS8atrVoVdTNj7Z	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1654	1340	117	1	6301	jxem4kEyp8DnjjnTiEf9xQU6fUFNbvyoK8yEh5n7y8ZAFpgn464	4850	6972	6972	1617194160000	orphaned
6452	3NLscoxQJkGzQuk1VokMuGAX67aHchztiFna2PxVBGWzWU36tsRK	6451	3NKxFoQZRAxax2hQFQcdJvUJ4nr53tjyE5n9adpTCWpW9U8nH9n9	1637	816	66	1	6252	jxh2U52voharpt7MsAM9NmTkv1bATY5m948d1mP7ayyBqoTDpTF	3341	4723	4723	1616789340000	canonical
6454	3NLRBSx4dKK4eXRTneU67ZxV2ziwMjFdH1tTVEXdyW2mTYbBe1X5	6452	3NLscoxQJkGzQuk1VokMuGAX67aHchztiFna2PxVBGWzWU36tsRK	1637	816	66	1	6254	jw8yTSZ7AQ4pzbC5MHqzCrF3s3vCvV7CLSVtexnaWEFbymU1mFV	3342	4724	4724	1616789520000	canonical
6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	6456	3NK5FSZHUwoqdCMnPr4fyguQsrqHnFwHpo94jfFYuF8dNMgoNUtu	1506	1373	67	1	6257	jwXhyc9CfeHJXGx7qsxiqH221oLVAoFUCS48ijUMvFr8LM3DDM1	3345	4728	4728	1616790240000	canonical
6460	3NKoQGo3oc8rdqdAzYSmu4PwYqiWJ2pTeNpJYY95QLhmk1kRDhQo	6457	3NL7k8fZ7pKoVmkTVmusSoEH8C5QeeXp9KSr6Tm12TrNqEB2bRvE	1490	1148	67	1	6260	jxh5BFxgLihYaYMGbjWPKjucuGwBmuYagnkw5SVA9DZGTCmDU4Z	3346	4730	4730	1616790600000	orphaned
6465	3NLoSaDCrqkwh7vh6SA9EmB5WDmMNdxL4ngFRAwPNXn8LVFt6n8b	6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	369	1312	67	1	6265	jxh9GnQWsG2GkGvKzjHqXC6tA6fq25gBzZjexFXTXgQgNNvoJfp	3350	4736	4736	1616791680000	canonical
6470	3NKQAeMRDvMcNDC58mB7onQYB6y8hboTCzkcgGm6QgJuPzfPmGwL	6469	3NLRAdACqbBTdZHKSpEKYF2rb7cdVZkx7UefRLBpSH8HTQacdiz4	171	1374	67	1	6270	jxLuCDv9UaJAp7jeVsw7eJbjhxBCifYvN1etiPx4zmx8eXkWVv7	3353	4739	4739	1616792220000	canonical
6474	3NKF6L4QifYqxPqFPt6V63XYZ8jU1EhJJGK4s2MpCz3M2QJuhkpG	6473	3NLSR2iLjtNvNHKqtjv5KYGLMvCUntV87uguhKjaAbLviotwoNTx	1407	1395	67	1	6274	jwZX6jDNnYtQefhJSYWdiJrnn42Jc9wZgqQNn1AuCayEtQ68NB6	3356	4743	4743	1616792940000	canonical
6476	3NLMGEDKoV4Rfhmk8PE5o9g9zmjBJVRvZ4ZWkJfnwyvhwQwJcQQo	6474	3NKF6L4QifYqxPqFPt6V63XYZ8jU1EhJJGK4s2MpCz3M2QJuhkpG	1503	1031	67	1	6276	jxJdatp7enkCUpnD3dpGzBstNLGMmYPK4bz9Xyqoo7ugMhqYun4	3357	4744	4744	1616793120000	orphaned
6483	3NKkLahoxyLrzkSP6uLXGLVH4zKbnB17XFTqdu59uNpx6LHiN3UD	6482	3NLuyNKzeSM6nSjEoSn9cqrPyi91TBRfnSBAZS4iAfijNricxph8	1444	1381	67	1	6283	jwVQ8VQCiG9se36hwReBvuFoQQkevg9eq7Q9KRBLpR66ps6JX3n	3360	4748	4748	1616793840000	orphaned
6490	3NLUbfLuHm8yFxJLrxKnwokKH8DVJjzzJuEs8xw2yqsnbKRvyD2e	6487	3NLuxo4ERQiPSLcUZT5Cf7bxRtpi9W2mTksSHJAAfCrfE9qt8mE1	1405	851	67	1	6290	jx2KMQyqxNB1ZPF5r1KjGUycYC5WW2DEAiNgwZaDTBzpjyrYgNV	3363	4752	4752	1616794560000	canonical
6556	3NL7gTrtNyXn6XG2NGmxorubHadufF6uduEqZj4BL2dYVdBfjtWX	6490	3NLUbfLuHm8yFxJLrxKnwokKH8DVJjzzJuEs8xw2yqsnbKRvyD2e	1527	927	67	1	6290	jwh7udd8nRibaxF8exGz4CYWSXtpt7jtfTgYZuUkM3s68a2N2Yu	3364	4791	4791	1616801580000	orphaned
6493	3NLryhwpwJQA7K7qUzuZqQTPxkBKsgYwZaBnBdxZL8nRd2r9ZZwk	6491	3NKhJvoEXs1Q582gpxgkywdVY25nCzMWRQ8agFHt3v6ta4LfArd1	311	1307	67	1	6293	jx4DurY5iig3msDMDC39qgCfBvkCTmwcbD8f8cgzRDiBmSyaF9b	3365	4754	4754	1616794920000	orphaned
6495	3NKyyGKUjz5SaTpNMeBmaiE5R3CQMqueMYfD3mHy4e6C9w52dgD5	6492	3NLaK1H5G8gEdHpAHYKZAFb9LCC8CdUD6y9EFt4KEyAzzUmVaZ2u	576	1355	67	1	6295	jwVYAP8xhaoVkFHCVNZ8qUvuckUE3oJuaznx3guyAF6RDoE6f7T	3366	4755	4755	1616795100000	canonical
6500	3NLWRuFB7G8CPkizXnRwpAUcQu5cAS5RTWE5vhWL1XBE47oEJ2kn	6497	3NKTj3WsEsMZBmKA4UPn4Q4VkMqu7VJ7hV3tdvHteR2BfsEiso3C	1527	1047	67	1	6300	jx9dnFK2jcGhH8RyemzudCPfPQVCLhcZbq4XEgpAvqqLaN4rqnE	3368	4758	4758	1616795640000	canonical
6502	3NLNDA6XwJKM4dA4QC1qSNunrxgxE5F5Ah5eq1ihSLtqw2LCbJc5	6501	3NKcHs6cXJM1BMLPKNpJbEa19VgTAzTnQG23sFdjRUJEULQ3Jc3h	484	1319	67	1	6301	jxQzJN2AEMhXsF62uAHx7zd9wtP2rZrEZWRoqJ6AaVUZEuN7auq	3370	4760	4760	1616796000000	canonical
6508	3NKjs8FPhBpBcdrqaZHsLR5cwdD8hPpPrtgruBZbYHKbu18jmsaa	6506	3NKcSQ78EpBc4PtaWp7qfQ3Cyq5Z1HAoFvshWVbFNhSey6awUbMt	1440	1377	68	1	6301	jxd2vr1J3cRCDz199oUFr8XqjWUGms5hXjASfyYT3WfzmB1epNR	3374	4765	4765	1616796900000	orphaned
6510	3NLvgYaNaD7tH1y9CXMMkJ2cPH8xNLWud19pn63KkyDDtkZfCh8r	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1451	1166	68	1	6301	jwPwegz32W1WCuELf27F2xkPYRn6d1ZVHZkTgGgtPyfjpTeEsf8	3375	4766	4766	1616797080000	orphaned
6515	3NLDj7rygXmScBUxEd3joDKKLNUEHJPmsYRD9EHafP8VasV8oCNM	6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	1553	776	68	1	6301	jwqkdY3Y9xfarcDGzzLh8AUgdqtFdLE91tmckg7oX1QxeLbwZbA	3377	4769	4769	1616797620000	orphaned
6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	641	1336	68	1	6301	jwzz9TN4eYC3ELzUJgyw9DEF9GsNPsigGzh8gdRBUq6RRH9Xtjf	3379	4771	4771	1616797980000	canonical
6519	3NLuSCMK996xzop8dEtMzadFq4XvDJfgKzybXrpRr8neb7Y9cQke	6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	1476	1245	68	1	6301	jxpr7K5sJYMJ8pvS98TeSYFZJmyAbf7EW3BaqLueU5QBq4pZAM1	3379	4771	4771	1616797980000	orphaned
6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	1587	1357	68	1	6301	jwcW6MykbeWbHprYbcXHnReiCQXeqsMv52mQrkPLyWW2ue4Rz6X	3384	4776	4776	1616798880000	canonical
6533	3NLjY46MidA4gYmZmYHZSckkG39wTbwzDwAuZZT21Y3dRyvfFw9h	6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	1631	794	68	1	6301	jwEu6rg3hcRVvgrRAE6DhwUihrymiVAeVbajz6T42RviAhuC8bt	3385	4777	4777	1616799060000	orphaned
6537	3NL5Ecc6VowHa5JtKi2wNLCFnudAurEjBrziYddDAk7xyYJLuTBN	6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	1508	1387	68	1	6301	jwzvjPx16dgCyvSG9XZueEm8ozxKvUVozeQBCL2qKhyaonMZCL7	3387	4779	4779	1616799420000	canonical
6535	3NLKp3fMzGgutzxjCmHduGkcoN8sQpU4YjkRgq859iWjHw66X6Re	6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	1406	1393	68	1	6301	jwLSKJJ6WJRT2dSsmzbYHvzYKYtqV5AS1kkPQ6DkAUDAY9gSd2m	3387	4779	4779	1616799420000	orphaned
6539	3NKZNYJNrWsMiVtPt3xEQ19FMBbDExM7suDRdrwLTUQeSF3jTXwK	6537	3NL5Ecc6VowHa5JtKi2wNLCFnudAurEjBrziYddDAk7xyYJLuTBN	1422	1091	68	1	6301	jxup6zLDuuGgzkR83nesEzG8afJWVaz78zcjrThYYV9szQJ3Xuq	3388	4780	4780	1616799600000	canonical
6544	3NL68m5yXw12h5zXenskDCxQUbxpwW8D2GuAw1n8AsSAafyZdZij	6543	3NLXfcwuQ7R1mmeU8StXhoBeTEESmtac3T2og4dTq1N7JehVfSk3	1513	1379	68	1	6301	jwVtbwKfEwXDMRVCtBQr3VCApNiGsmwdrLzVLHzirQE3YbHSKvf	3391	4783	4783	1616800140000	canonical
6547	3NKkfsAHNditsNjC1gnU1xZKsHuzixwqkUEdZybFZAUg7hmLJWwD	6546	3NLJqCQSWxx5AXCinnpmfYZYeiDDYFNWLVgqyizGjyTyvANQMgo5	1668	1004	68	1	6301	jwdBBrGBbALVLbnvUFqSMqfiuTmGgJtMxPGB1VkdbPYJNkLQCn4	3393	4787	4787	1616800860000	canonical
6554	3NKdUZ8cwV5MEwU9LTfvZVhUFRaTEoqBJtruukybq1yhXde7zBH7	6550	3NLFHoWifRsAqEkdGbebuRtrh44GhXgwuLmKbA2hunRUB9TmzEt7	606	929	68	1	6301	jwjgs7zxQP9ZMKnYbbBKirqmsgtuuqpHFCmMzD3mfaz26GKz6sJ	3396	4790	4790	1616801400000	orphaned
6561	3NLXQi7hqVgmsgTN5DNJ6oyvfNg2ggFC86pDz3ik3EuRMaq7tiqJ	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1656	1097	68	1	6301	jxdSdzTaNxxxKjWNm6ttuiaWCh8e4zj7ghdvwA5ZstMUwxT6BUh	3399	4793	4793	1616801940000	orphaned
9554	3NKJuVBRTJ4LDg35HMifidaH3sXDnNyP2rEqFUiVZTJeKxjA1jty	9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	1654	1340	117	1	6301	jwwXScBPskrQ24LGU9SZhxYNGXQw5QhMbsv4yT23HjvTt7Q48Kb	4863	6972	6972	1617194200048	orphaned
6498	3NLKMk3VvoA89qr7R2hSFyMriduQg2ojCWEqB6DAALcyrxy1nBmB	6463	3NL4YWoLW4gHo2wXkNxAqV6LdLBfi1QuDvmmtMpZfCarihR1w2Kf	1527	1047	67	1	6298	jwYZ9cDraxVdzcgANNkueBvkKR6NbfSZBmq8EV3HTgKKG3NMTPn	3349	4758	4758	1616795640000	orphaned
6467	3NLbLSSezU4RvZbzVitQpugvfscvw4zVckkkHsRFHq7jY4B36g2W	6465	3NLoSaDCrqkwh7vh6SA9EmB5WDmMNdxL4ngFRAwPNXn8LVFt6n8b	1405	861	67	1	6267	jxpGdFrio47TF9uWHLGGEfc4HTefwicHE8rKLHPQUJq2rWiUUsd	3351	4737	4737	1616791860000	orphaned
6469	3NLRAdACqbBTdZHKSpEKYF2rb7cdVZkx7UefRLBpSH8HTQacdiz4	6468	3NLfLSJD3c2N897x1u9ygzX7Er1rCja8QYPYgUayAe8izt3yG5Mh	1481	790	67	1	6269	jwKMMKKhf41xEejSxKszU1BhNZQqwDUJwHXAUTwwBxKGHxWzgcw	3352	4738	4738	1616792040000	canonical
6472	3NLj5U9CvWDUgw6k6B9wYEabeExrozaoR7h7AyXwwQLDnkiBfGHw	6471	3NKtK4ksUVuxWMonq68sy8XtZLk3C7yReDA34XJdjbjhNEuBZ4fP	1657	1098	67	1	6272	jwLnszbnW5zWwLLJyjiVfLhf2cSEk4BZ9US8NaKYXUcmUHU1CSL	3355	4742	4742	1616792760000	orphaned
6482	3NLuyNKzeSM6nSjEoSn9cqrPyi91TBRfnSBAZS4iAfijNricxph8	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	1637	816	67	1	6282	jxGnywfEUxL2KFTBxabe9pg55AEk58ETrRGX4Bno9abRrdo1b74	3359	4747	4747	1616793660000	canonical
6486	3NKyVxSkhwZqu1NpBpZSJ6GL2pvo3LzhR51jDTUUczhrnLLZHgyr	6484	3NKkXBNCE8v9FR1BbJAdMo3rU5QXfurziHdeZSsg9mFKKYkScGan	1594	960	67	1	6286	jweqW8gL8dNNZXiedv5MZtyy7G1cCjB5AaxUbe6kH5mBi9PjC17	3361	4749	4749	1616794020000	orphaned
6491	3NKhJvoEXs1Q582gpxgkywdVY25nCzMWRQ8agFHt3v6ta4LfArd1	6490	3NLUbfLuHm8yFxJLrxKnwokKH8DVJjzzJuEs8xw2yqsnbKRvyD2e	1587	1357	67	1	6291	jxgoji2xv8h6qujtBNbkMM6PwuMV1aZXTbgqwfpkqyeJ7VC9Jia	3364	4753	4753	1616794740000	canonical
6496	3NLjggUxaMgJs55BeTgp1XvvKafFBMPcviEqM7NYYXBcgZk9gHV9	6495	3NKyyGKUjz5SaTpNMeBmaiE5R3CQMqueMYfD3mHy4e6C9w52dgD5	1637	816	67	1	6296	jxFRLaySixAWsABBABwKdvGHBe5zoQKUTipFTMwk5P1bNnQs6fR	3367	4757	4757	1616795460000	orphaned
6505	3NKWxDHicDNvTN8SapHikwNbjKcn3ihy8ZZ9KVENtABeaykYCXpi	6504	3NLtWzp6fGrxgYicmwa23Vn4dRVobmb9J3E7MeaTyfBvGDsdwEDS	1403	824	67	1	6301	jx7PToA7h9n4RxMgQm4q8appiA8EcqwthLwF1ppkpxgDDo5muVo	3372	4762	4762	1616796360000	canonical
6512	3NLpjuZ74pjdN9NSNKVy1Vn9BWd7qzhrn12kBLVeh2MXyVZ3TmPp	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1651	935	68	1	6301	jwW4fyGvczAgphQKW1mdTesfWZ5faBK7xgMrBaRsm63JiNRNEz6	3375	4766	4766	1616797080000	orphaned
6517	3NKUPTtNzK3p67JWNoqFyQ1WtorivZRJ9qSCJiuP7t6yhK1bhyzR	6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	1647	1056	68	1	6301	jwavyoSZDHSwULWusrtVvUW1KoewdPPScyZpYw2dmNDyK3JN41o	3377	4769	4769	1616797620000	orphaned
6520	3NKKbF9ToZjakz8hVhAGwiF674vmY3h7aVsbKzrrbFXAstFmh4ee	6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	1407	1395	68	1	6301	jwHx6Zj4shvFoP3g3624kPYF3bvN2R4av9sa5QDHrN6t67nrVFc	3379	4771	4771	1616797980000	orphaned
6524	3NKVgvz16j9NHiXvDSyVTzM6gcJamH2oQnKMqwSAYBe4cxCfUdPq	6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	1601	1142	68	1	6301	jwiN35ipuvUq5UNufGT3RoDTAg3EWxFA4zHnjrqYMzCnFe3NeXm	3380	4772	4772	1616798160000	orphaned
6526	3NKUkJj3HJphJWQCg5ANRwTc1umPi4yDAeBDj3dJYPB1tWBFmoMo	6525	3NKhFaaixn5XVksMcpPVxwVqaTXPXoKzfmq84XtUypKNbFzfCfKa	1619	1149	68	1	6301	jwjfCUXfTdrjmtY8ZMMVfhZmixxYDcqkv71qanN9rE8FdLhiTGR	3382	4774	4774	1616798520000	canonical
6529	3NK6kWahdHekNcL92gWnB6LGfiGrp5YrgtJnnsxQCVUoau8iSmzN	6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	1407	1395	68	1	6301	jxGHqf479ucPC2spaH15sJyU6dzqSMjxNXX9gRVN3KsrpM5oR21	3384	4776	4776	1616798880000	orphaned
6531	3NKASUV8YCzrJAK9mZAY5nF8yGRbTQRhjU7ZJEXqGRYUNZMZjyhD	6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	317	317	68	1	6301	jy2Wou29gZEsNw8vhEpxdFGgTKtqGQaL6xTWxJ4E58u1EWNd7yk	3385	4777	4777	1616799060000	orphaned
6564	3NLUCbRvW9VgdEBqUHjviMHRp7DFydLQS6qbok66r5MTuLoSiWAF	6545	3NLk2rAyR1NLANWPvnpcL7JdQMdpAeypmFDDyycdppTGotRRbw2a	1481	790	68	1	6301	jwqCWe1cZuNh5HH7L9gKij5qYCRZ6sUVx1SUfSK7535tGaS6mi7	3389	4793	4793	1616801940000	orphaned
6542	3NLCX7mxvBoUjNk5YV5kxspjKK52UHockmwSPaPoxhPHGjXbkH34	6541	3NKNUD1mv4oSFMpp8JEJRBCEhHXerxqwULyVqskUUyuDqWGEkB5R	1403	824	68	1	6301	jwVS5hEKiHnDHup8D9w2iiSJifu4KSHS3h1Do3WLPLpQXYvjYsV	3390	4782	4782	1616799960000	orphaned
6550	3NLFHoWifRsAqEkdGbebuRtrh44GhXgwuLmKbA2hunRUB9TmzEt7	6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	1444	1015	68	1	6301	jxp8QyYaqKkqtFwZgoL8yDys9VfR19bc7QJ8atQrM1LC9V5cZg8	3395	4789	4789	1616801220000	canonical
6567	3NLx3bqz5wS9fvnMeFjGENvKC4bkr4tmhfzwFRcvDDKzmgFCyPF8	6566	3NLmpigAPaCzBGRg3rnVunRGUm66PDhXSQ3Vm4GWa6teiQkszaUa	363	363	68	1	6301	jwAA8oo5PBRmjrpqbSi5SLiXCQ2Xx26uHu4Y4G3WYPtJveHWvFL	3400	4794	4794	1616802120000	canonical
6569	3NKi4NVT5xWUTgZfz7MguJqKandtVF94V3HZggHEzHU552JEJ18u	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	1451	1046	68	1	6301	jwWADoENZVtho3gcbDPLdkFkM6UCY4Un5S1UCa9ykURFrpVhD5Z	3402	4796	4796	1616802480000	orphaned
6572	3NLJ1DDJAAztidm75G6pwCe8gzqkLXzxsQGxu3rgvbghsM7KCqNy	6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	1406	1393	69	1	6301	jwpjgMLTLANrRXGzNECsAD2panAbGjoMJSNmwESCU7XcfhDm3e9	3403	4798	4798	1616802840000	canonical
6574	3NKT5UmJ4o23o86Fymm5Ce2DXRH7kN49DPvjbew6HKCrj5gj57T2	6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	1631	794	69	1	6301	jwYjYhYGbQPAn23rtWa16nURSjVombFubrhxZZJ7snsyg4NhngW	3403	4798	4798	1616802840000	orphaned
6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	6572	3NLJ1DDJAAztidm75G6pwCe8gzqkLXzxsQGxu3rgvbghsM7KCqNy	1403	824	69	1	6301	jwHorQiY49mWaJuxM75VUhTGkLSeuZAoofpTjwz6QJ1NXTJwU8k	3404	4799	4799	1616803020000	canonical
6586	3NLG7WLem8X2wGd6FSi9exr8FtDjSqp4HEKVh5F1ZxfXR8RmZ1yj	6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	1407	1395	69	1	6301	jwkrMDUCoSPcNo3LWf3Gjn98YRTJDmR16p6xHbqV8z8JmJFwFa5	3407	4803	4803	1616803740000	orphaned
6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	6590	3NLB41P4cSxWCEnKp8ZsogmsLEhZ65MxZCS4cqetADfyzj7pwowm	1649	1383	69	1	6301	jwxhwXmrkNAB2wMwwZraVDA2WXu7LfCbHEzQUN4byE6meqcxSSs	3410	4809	4809	1616804820000	canonical
6594	3NKWa9WbyuMfQnrcXLzVE1GG3nLN3VHK64LyE1MNaaCrJKfQC6tY	6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	1541	1298	69	1	6301	jxwtJj7rQMUazNaiVGpRqnxUZ13mMmier6TrpW6xBt4beRCAuLC	3411	4810	4810	1616805000000	orphaned
6596	3NKeshr91vW5t76BqtMzy57AHjNPaAXkbaDMW8ki6onGcB2e5pCw	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1622	1356	69	1	6301	jxdtFM95ijuxW4RvpczBhhv4KyoBw3ihAgFZTk3G6hcJ9hiUCQu	3413	4813	4813	1616805540000	canonical
6598	3NLqAQZdGHpH9Chx2nr4BduppF37XH8qhzwJaoWTUNyrvFEHTES3	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1489	1254	69	1	6301	jwcAuYnjU1GgZ7GZe8aZLnYcMMsWjWwAnSSvTnwGgk6SCRG5a7Y	3413	4813	4813	1616805540000	orphaned
9723	3NLmyn6RksdUSkKfv9busnKfkg7L5YMoDYHRWNEnirTgvK6hfzJf	9464	3NL3qciic4FPkBj43WqFSXwUfsbREvxrfWY8r4ovP6TfycpAkokM	1467	1250	118	1	6301	jxirmKcDMwE7caNuYgxQEhRrikzMQ9oYxpQ7cj6jPz5aKCJt6FN	4882	7092	7092	1617215760000	orphaned
6473	3NLSR2iLjtNvNHKqtjv5KYGLMvCUntV87uguhKjaAbLviotwoNTx	6471	3NKtK4ksUVuxWMonq68sy8XtZLk3C7yReDA34XJdjbjhNEuBZ4fP	1637	816	67	1	6273	jwKjPvcrM1aVkvT8ATJ63FSn12E24oqNTPfXo5MD5NAvDQQLZkG	3355	4742	4742	1616792760000	canonical
6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	6477	3NLgTi25PXWLEV33jqeUu1TkuRa8jZZvTYzdpJSfqH5hv9PMFVRt	1483	1276	67	1	6278	jxsYiwf7r6Hfivbjks5fvAnFbNkdkPefepKfrTmmXJJWnsoqNwD	3358	4746	4746	1616793480000	canonical
6485	3NKmLWP64xnTsjuTsGUvx9yubGV6hZg92jqc2XVyLW8BuHydZkFZ	6484	3NKkXBNCE8v9FR1BbJAdMo3rU5QXfurziHdeZSsg9mFKKYkScGan	1407	1395	67	1	6285	jxNpZ7TsjRh7i61jQtze3fBGXoXjTEEL7PwZi4b8SKY6wTsPUmL	3361	4749	4749	1616794020000	canonical
6487	3NLuxo4ERQiPSLcUZT5Cf7bxRtpi9W2mTksSHJAAfCrfE9qt8mE1	6485	3NKmLWP64xnTsjuTsGUvx9yubGV6hZg92jqc2XVyLW8BuHydZkFZ	1672	1285	67	1	6287	jwAkctbkvPPvMyfqKvRj4ykQ92ARbFjqR55pnqWUUbUXXMFZofR	3362	4750	4750	1616794200000	canonical
6492	3NLaK1H5G8gEdHpAHYKZAFb9LCC8CdUD6y9EFt4KEyAzzUmVaZ2u	6491	3NKhJvoEXs1Q582gpxgkywdVY25nCzMWRQ8agFHt3v6ta4LfArd1	1406	1393	67	1	6292	jwaRS4UwcoH9gWgFRy9tW4E95QAAGgkJR9PC8VrJuEayfVDc4Ki	3365	4754	4754	1616794920000	canonical
6582	3NLGL3xZcSwhv8QXe22j424nhPK54gMwPy5Mz4pq1N3LEVLbf1Mg	6556	3NL7gTrtNyXn6XG2NGmxorubHadufF6uduEqZj4BL2dYVdBfjtWX	1581	778	67	1	6290	jwZd8EUZoWqQ3sRQjMPiyUXubqEQVLGMgRq6Kcg7wkYAAMDpJSr	3365	4801	4801	1616803380000	orphaned
6497	3NKTj3WsEsMZBmKA4UPn4Q4VkMqu7VJ7hV3tdvHteR2BfsEiso3C	6495	3NKyyGKUjz5SaTpNMeBmaiE5R3CQMqueMYfD3mHy4e6C9w52dgD5	1650	1375	67	1	6297	jx1MgJpZLwyhe8c81KPMFyvoevq1ug11HSNaQ8z2eRJojWEaUM6	3367	4757	4757	1616795460000	canonical
6499	3NKKjFcE3NHw4z8gjnFQWeAC8RjopdcCBSs32uwsuTQSM4TePr42	6497	3NKTj3WsEsMZBmKA4UPn4Q4VkMqu7VJ7hV3tdvHteR2BfsEiso3C	1624	1334	67	1	6299	jxPUrWsNzta1Y97hT3QKhRZWAuAoWvkFoxnVXagez1Tgr27fuzP	3368	4758	4758	1616795640000	orphaned
6509	3NKQhv6TMwFju9PD78Jt8RU6538Q4xbRiUYrZ1c7n7EBtWz4jCS7	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1407	1395	68	1	6301	jx5Wv3wmdoRjEXJRjbVW7wpXRCvruGyK22Wvo5Vd5m3wV8tHTzF	3375	4766	4766	1616797080000	canonical
6514	3NKmWH6boXyuQ5QpCNwKNvq9RbmdKmUY1GuZTf8U8HnbyfBV7Y4D	6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	1507	914	68	1	6301	jwG6axBkRQqmiytXfDAVaoC3dTRqmaR8Wdq8jmXBsmMPQhFnZhA	3377	4769	4769	1616797620000	canonical
6518	3NKJELYDZZDTi6axpLoKNuMaCBW4pNj4iUXS5fBqgsy96qH4KF7Z	6514	3NKmWH6boXyuQ5QpCNwKNvq9RbmdKmUY1GuZTf8U8HnbyfBV7Y4D	1633	1264	68	1	6301	jwLGpvPLYdCikjdQjTgrcPo4NSpWHWkt7wim77LSNeHS2Ahpeu8	3378	4770	4770	1616797800000	canonical
6523	3NKQonVif8rp543zbvVAtSYDtdvxNHxgjpVZ24NMyrNTLLJDQz2L	6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	1668	1004	68	1	6301	jwJUMfbxx7QntWn2oBDuUxkDVpsE2imViqATACerieJazzpy5yg	3380	4772	4772	1616798160000	orphaned
6525	3NKhFaaixn5XVksMcpPVxwVqaTXPXoKzfmq84XtUypKNbFzfCfKa	6522	3NLadJxWPH3tuyEZ2cqBpCo12jVSPq2vNyqjhjmN9Q47hoJ315Gu	1405	867	68	1	6301	jxpnYYA1GT3PPPh85VNT8DyKh2hNxYGAHoJvGNpFvBdstCVM3UQ	3381	4773	4773	1616798340000	canonical
6532	3NL4fWpNX2xX9eUYhD2DZVwFyWJirH7RDvJGTB2vwHFjosFSHxdV	6528	3NLWo7wWpTCsdjeQPqb18tdVbU5P2iR6iroM1RWQQefcDFJT93na	1407	1395	68	1	6301	jxCj745S1mzDzaR8czL1uXyP1aL4QSpHyx5NT55aMUv8u8g1on2	3385	4777	4777	1616799060000	canonical
6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	6532	3NL4fWpNX2xX9eUYhD2DZVwFyWJirH7RDvJGTB2vwHFjosFSHxdV	1613	1103	68	1	6301	jwcwQcHkki5XovXpNeuMRTXqj2pbDa5F8acDW46DpJeUJyxpT7A	3386	4778	4778	1616799240000	canonical
6541	3NKNUD1mv4oSFMpp8JEJRBCEhHXerxqwULyVqskUUyuDqWGEkB5R	6539	3NKZNYJNrWsMiVtPt3xEQ19FMBbDExM7suDRdrwLTUQeSF3jTXwK	298	1308	68	1	6301	jwfZLK17vRiCSeR74UKggJDYEUh6abU6DxTbeAYnYQGw6RiCEBB	3389	4781	4781	1616799780000	canonical
6546	3NLJqCQSWxx5AXCinnpmfYZYeiDDYFNWLVgqyizGjyTyvANQMgo5	6544	3NL68m5yXw12h5zXenskDCxQUbxpwW8D2GuAw1n8AsSAafyZdZij	43	1064	68	1	6301	jx5YvHKBB8RKYrQZSnxqGuruNMKpvN8Q5VAah7G6maXKEEykJjh	3392	4786	4786	1616800680000	canonical
6549	3NLLeagLQsxUH4TviC8T4eQdyh7sKGXwp6aj8BSCvequG2Zgymyv	6547	3NKkfsAHNditsNjC1gnU1xZKsHuzixwqkUEdZybFZAUg7hmLJWwD	1444	1015	68	1	6301	jwn79eCzFbKcLEiaUuWAUwfu3JybkY71M45VsjY3y48xZGV68tv	3394	4789	4789	1616801220000	orphaned
6552	3NK9HqdidkLQRFrWiQumjX3QGYuNCdsJ4dMTB37stb26dh1m6ZDc	6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	1474	1329	68	1	6301	jxH2wXrCxdYhAXSUYq6PcRZR9PpvAkD7gT7neUerUrcyofPZRDd	3395	4789	4789	1616801220000	orphaned
6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	6550	3NLFHoWifRsAqEkdGbebuRtrh44GhXgwuLmKbA2hunRUB9TmzEt7	1458	1077	68	1	6301	jwMP7VDtuUzgK1tpPVLuQok8K6JuBVvmHESxZNzCU8VzXRiDHkW	3396	4790	4790	1616801400000	canonical
6558	3NKEgCfenSfvCQyNFrkBm4vDdiwJERkjyy9sMR13gJNoi2yGwN3H	6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	1513	1253	68	1	6301	jwi8FTgWX29BjsJ4LYjo7ZhnTPnzwGHsa9q7Wg9argZ9hNMGCiX	3397	4791	4791	1616801580000	orphaned
6566	3NLmpigAPaCzBGRg3rnVunRGUm66PDhXSQ3Vm4GWa6teiQkszaUa	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1593	1346	68	1	6301	jwNcUsVJtdineGxoxdAFg66qNBN22XsM23wUyASFbbE9pgd1ucr	3399	4793	4793	1616801940000	canonical
6560	3NKbTBZe37fgBrTHUJ18z5u9gqtdsVxX6mUJyyjUvEomSLM9qJHb	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1406	1393	68	1	6301	jxCx6uxPYkK8hSkeWRAgA5VQajZQkS7gqDNV7jBuJ2P91XzHtkq	3399	4793	4793	1616801940000	orphaned
6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	1451	1046	68	1	6301	jwWADoENZVtho3gcbDPLdkFkM6UCY4Un5S1UCa9ykURFrpVhD5Z	3402	4796	4796	1616802480000	canonical
6578	3NKo3AJiZLvR7BP5Mx1KfPtKzUaGNmtwfm8nBMAw3nuCkCSRYumZ	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	1406	1393	69	1	6301	jx1V2wPPzFXYvHgmAjDRChbAFiwsi49nzTFv2Bdw91cogYR9paT	3405	4800	4800	1616803200000	orphaned
6585	3NKTgemcsJo8SAYrUoM22Wdhhkg91b92APgQxaFvcodLpoLcAXgZ	6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	1448	1311	69	1	6301	jwn7pG1WvbZ9UmdcERofEN3ryh6PUNP1g57FCWAjn7Jw3kGdcbm	3407	4803	4803	1616803740000	canonical
6602	3NLGFPkx66Szy6MomuL2FkY67THuZ4T96cNwKeAfs1TYV6UQgn7q	6596	3NKeshr91vW5t76BqtMzy57AHjNPaAXkbaDMW8ki6onGcB2e5pCw	311	1061	69	1	6301	jxy1QxpX5dWPxgPW3U2boJtdQKZdbDznSQF6zmAPCCn7dxs5Sff	3414	4814	4814	1616805720000	canonical
6605	3NLuoeetHGdXNUiYMxWJS1Lnz3ybo1NsndfFTFNuqtX7i68WojUV	6603	3NLyQcqnWkSUWho7gUnKEUvjabDMqBtwD3LRL2vpeVQhDRYGKAHc	1513	1379	69	1	6301	jxWgpV9oXx8Auv756Qrof3m2hkC14Fefx8EEcVSaxzNk63MPSpP	3416	4817	4817	1616806260000	canonical
6606	3NLrzV4qjtziLGYrhZ7surzrEefcfhpdUv5RTB8BXxBtLR37sz61	6605	3NLuoeetHGdXNUiYMxWJS1Lnz3ybo1NsndfFTFNuqtX7i68WojUV	1579	1389	69	1	6301	jxJuHGRUpRLW8ufPGiMkxY7z2rLTwSWnV92hCPHw2eTbnHYJwuB	3417	4821	4821	1616806980000	orphaned
9774	3NKxphR7u8KtHXuGDJgBFtvGXqA5qWY7BssaQAjEgtkfUBANTBFp	9723	3NLmyn6RksdUSkKfv9busnKfkg7L5YMoDYHRWNEnirTgvK6hfzJf	1467	1130	118	1	6301	jxpiASVg8W3bxvNwqpkuhRtRdxAHhNaCvkvkXr1uUKoxHeEBs9m	4883	7126	7126	1617221880000	orphaned
6601	3NLZsduatgB2xqXd3eL1YXZoBAY9AUDj7wYgSBuBoquZYKNJtsSt	6425	3NLNz3eNSVjARMGuUeEzVJeuaCSCCWiHnK9JPG5me2jov1SVtYAA	1489	1254	66	1	6225	jwvwBkGwfcWRL55JANR5SASj3EsyRYEnPD8BxaEuWYyag6brEN7	3328	4813	4813	1616805540000	orphaned
6536	3NKLM1XXYAJk3M4Wrniad7r9N7B9DFsUGtFowbhnRpn18zyES4zD	6464	3NLTLnKL3wEprXEeCvV1UTgUkhM7MxSLgCkPEgdkPf6wBsBFof71	1527	1293	67	1	6264	jxE4Emt1DBgedL3a9NPREx4D54fBods5cUqfB3F7okQjhBMGRDj	3350	4779	4779	1616799420000	orphaned
6484	3NKkXBNCE8v9FR1BbJAdMo3rU5QXfurziHdeZSsg9mFKKYkScGan	6482	3NLuyNKzeSM6nSjEoSn9cqrPyi91TBRfnSBAZS4iAfijNricxph8	1656	1343	67	1	6284	jwfk4dXWgnYFrSXFQT6EG3U3dmqr5GjAfLC57nU3dBm6iSRSwTs	3360	4748	4748	1616793840000	canonical
6489	3NLqVdo5WrspVi9vYCRahXWpETeCkhUHGUDSPeDkg9F45Hztcshm	6487	3NLuxo4ERQiPSLcUZT5Cf7bxRtpi9W2mTksSHJAAfCrfE9qt8mE1	1406	1393	67	1	6289	jwCoBKUPP454TNebY1hVrid4w7u4DgjE2NK9m4riucgziARmN2S	3363	4752	4752	1616794560000	orphaned
6494	3NKxgRaJcCaMg9ZbHiUBqxgLps8b8Ym6NNS4fzjNezgLiN1jE6ji	6492	3NLaK1H5G8gEdHpAHYKZAFb9LCC8CdUD6y9EFt4KEyAzzUmVaZ2u	1406	1393	67	1	6294	jw7PPDm8NzawUWuPvyyKL3YHddGQUPvrokUi7Qzqex65J7Z7ebn	3366	4755	4755	1616795100000	orphaned
6501	3NKcHs6cXJM1BMLPKNpJbEa19VgTAzTnQG23sFdjRUJEULQ3Jc3h	6500	3NLWRuFB7G8CPkizXnRwpAUcQu5cAS5RTWE5vhWL1XBE47oEJ2kn	1637	816	67	1	6301	jxobKr3DJzAZm8F2cS3wgKhiUP4RD2Hgz3iakFDx9c5qgCsbMWM	3369	4759	4759	1616795820000	canonical
6504	3NLtWzp6fGrxgYicmwa23Vn4dRVobmb9J3E7MeaTyfBvGDsdwEDS	6502	3NLNDA6XwJKM4dA4QC1qSNunrxgxE5F5Ah5eq1ihSLtqw2LCbJc5	1471	1386	67	1	6301	jwj23MkrqQYkq47L6pt66VdgZNhJ9pwunvvonxLjniTbKjapug9	3371	4761	4761	1616796180000	canonical
6506	3NKcSQ78EpBc4PtaWp7qfQ3Cyq5Z1HAoFvshWVbFNhSey6awUbMt	6505	3NKWxDHicDNvTN8SapHikwNbjKcn3ihy8ZZ9KVENtABeaykYCXpi	1406	1393	68	1	6301	jwDVoLRYRRUtuH4iVpBrvaSCxtzQYCNQttgvuXmkiYgkxtk8ejf	3373	4764	4764	1616796720000	canonical
6513	3NKXuUPFApBXmzR73v55MDmpYushqT4Y2FKUxA2MEfGufQGZVfK2	6509	3NKQhv6TMwFju9PD78Jt8RU6538Q4xbRiUYrZ1c7n7EBtWz4jCS7	1455	1332	68	1	6301	jxEH5JvBT7VbosW3neu3zQFyQYkn6y5C4f8VFXDNDgocVmmuhvq	3376	4767	4767	1616797260000	canonical
6522	3NLadJxWPH3tuyEZ2cqBpCo12jVSPq2vNyqjhjmN9Q47hoJ315Gu	6521	3NKz3fGkckNqnWdFwVPFsKd1BdxLzFLBqmWRaQeFDbPiRJBgttfj	1422	1211	68	1	6301	jwDXKMGcKXWZERnAaZbTLyyf1htDKwox7dAJuPH5kSZNz8SmDp5	3380	4772	4772	1616798160000	canonical
6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	6526	3NKUkJj3HJphJWQCg5ANRwTc1umPi4yDAeBDj3dJYPB1tWBFmoMo	1516	928	68	1	6301	jxpgkKiR7APnPNUq5RoqrL5dABKGJDkP544Xdm4mc72bSuERZxu	3383	4775	4775	1616798700000	canonical
6530	3NKkCWHojr3utJvj2QHEfDfMMJWi6qUFzaTF8GquRBUK3k6KbKmX	6527	3NLqoKcBv2nNtFRuFRnRXcx7ecEy7xUnNQwaMcsPYcQyCbz5Rcky	1553	776	68	1	6301	jwJA5Wau2kUkkQZBpKmumREVuXHQYcFotMa9YnjfQYvgrSBMb8y	3384	4776	4776	1616798880000	orphaned
6538	3NLNp3VCcy2dCtU9pkH8rLuGXyEmXh5wR2VxVSafJSrXpsHKdFCM	6534	3NLKd2zvnXbDzkVPjdpxWLv4nFKc6m1azeMZJfrSkY2ZQ9ArnwM1	1527	1293	68	1	6301	jwTHLAnNDhHSkzLnACQ9zdavKPCN4LbNui68AMKPDcuM7aiFC2q	3387	4779	4779	1616799420000	orphaned
6540	3NLcFjVvCrd3YS3z99VGxfMtbdhnemJfaQtHZxKuYxMkPRBF4DG6	6537	3NL5Ecc6VowHa5JtKi2wNLCFnudAurEjBrziYddDAk7xyYJLuTBN	1590	934	68	1	6301	jwW7De4L36MrNb8U2WoifuCzuobRL9xJ2xvXYEhS5vVUej3wgS1	3388	4780	4780	1616799600000	orphaned
6543	3NLXfcwuQ7R1mmeU8StXhoBeTEESmtac3T2og4dTq1N7JehVfSk3	6541	3NKNUD1mv4oSFMpp8JEJRBCEhHXerxqwULyVqskUUyuDqWGEkB5R	369	1186	68	1	6301	jxsu77VBENNnadj1toPmRT7inUk3zAXEr39jjrRxhHath5eZKZT	3390	4782	4782	1616799960000	canonical
6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	6547	3NKkfsAHNditsNjC1gnU1xZKsHuzixwqkUEdZybFZAUg7hmLJWwD	1406	1393	68	1	6301	jxkKaCFa5QCFLCySTd57p7cpDhgk6CNF6Lec5qJpf3zc8qRikdn	3394	4788	4788	1616801040000	canonical
6551	3NKqkFpDyUFYr5hiaRYjDnj6eZRih7B7Ciz1C4bYCLEwTCY1BvYg	6548	3NKHjvNyxWZrvcjiSnwXRCrktCkZjTCfGT5nuGxpNN1BxJoofFou	1647	846	68	1	6301	jwbiUQqLWmtYBMK4pnWfqRNxZM2ynUhTcgQdG6pKyfdjVH1oTr7	3395	4789	4789	1616801220000	orphaned
6557	3NKVNTqYEu6P3wGHrH3SSAKEPajQRh8WVnGsUT7F4DD83zNPyQ8V	6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	1527	927	68	1	6301	jxP1pi6LU815nLKZTeGL71GiDRthx845mtVXBAFRgWXikRZwTYT	3397	4791	4791	1616801580000	canonical
6555	3NKmMNzY4ErnwDc6Fr2xDT7p1bwQhUbzFnEAeGExBAD97KST8b6e	6553	3NLahqQSHDc5DRtd4HYCyFTye93L8M1a1nfCRFbRnM1QwRFmgRiz	1448	945	68	1	6301	jxAcUVk7KcTxGg17FVSvmZvxvVtkdCeXZ1QbBw798BGi9QsD49u	3397	4791	4791	1616801580000	orphaned
6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	6557	3NKVNTqYEu6P3wGHrH3SSAKEPajQRh8WVnGsUT7F4DD83zNPyQ8V	1622	1356	68	1	6301	jwgrxLvjhThkcYJEoYBeiCShos7VD4nLcoTgQpyj4gytRA5sthM	3398	4792	4792	1616801760000	canonical
6562	3NKV7Sw5Cp8s5SjHD2K7CTi6esqMS5XheftrUxqri5cgpaEZd1cN	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1657	1344	68	1	6301	jxpec9YKaKwp9qJqcrgRANb8ZL115XMofLCzwPHJ6jrfEowH331	3399	4793	4793	1616801940000	orphaned
6565	3NKqfGwK1rgjKMy8B38pD2oA2vVNAgEZfdt8CfHQsNM9DC7cvsYY	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1631	794	68	1	6301	jxokUXwUrovFXnBHk6pjhmkDkkiDzeLMrsjbuqTKkAkJqMDmuSQ	3399	4793	4793	1616801940000	orphaned
6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	6567	3NLx3bqz5wS9fvnMeFjGENvKC4bkr4tmhfzwFRcvDDKzmgFCyPF8	1668	1370	68	1	6301	jwxGibwKDSga5qdbzKfRvgDVDZXU5kFs3wbKdztSYX6jAudQ8zw	3401	4795	4795	1616802300000	canonical
6570	3NLhiTd56bS6BA8KrdWmq3iNgSStg6SrksZMPzEZj1EnVyf3XUr6	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	1451	1046	68	1	6301	jwWADoENZVtho3gcbDPLdkFkM6UCY4Un5S1UCa9ykURFrpVhD5Z	3402	4796	4796	1616802480000	orphaned
6573	3NLbrZAjnakrFd96tXttGssXxCHtQApkjJKF4XQYnJuFRt7eyJjy	6571	3NKYPJ9dttRYezSYpSFpwvrEDT9rsQdC5qPkYKqYtR58XcqqTyKv	1560	1045	69	1	6301	jwSAKymRgZpcdSpzL26jwGa99rfoKcvLvhhKgSQDEdDn8uz5aaK	3403	4798	4798	1616802840000	orphaned
6575	3NKpspF2Ca8FxqJuDjeqd8uDsywbUb3DZQivVoDG279thbTjMxxv	6572	3NLJ1DDJAAztidm75G6pwCe8gzqkLXzxsQGxu3rgvbghsM7KCqNy	1442	288	69	1	6301	jw9WgHBTQK2pnqi5X8Zb1ZqCjheJMDgPP79hgzkLZQCMJ91BX4o	3404	4799	4799	1616803020000	orphaned
6577	3NLkisisxDNWAwQRMYcDu64TFG3mJLxrB8Li9hVCKwLJ7doR3eA5	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	1467	1376	69	1	6301	jwu3cmoTKs7jxjEVjqe8cPdBkFQKeUo4uLHEvay4ZpAKRN5WtMj	3405	4800	4800	1616803200000	canonical
6592	3NLWGct5UR4nm8bne17RBFmghhN9Zrrm8hPRXQoVt63C9Cat8C53	6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	1406	1393	69	1	6301	jwjByxrc7kh36scrPLFQ9on2X4yXUDoPtyt4d1cBA1KW2877VPU	3411	4810	4810	1616805000000	canonical
6597	3NKDJvvv5ZXnnCacg8yxZsm3Juu7yAjGeLm5yRgknC7oAVu3MqoB	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1406	1393	69	1	6301	jxreR3ya3ndNNTHzv5rvmG7ZaJYWKJkFR5qWrbaL4gP8LTTBpDM	3413	4813	4813	1616805540000	orphaned
9412	3NL4UgPEKe1iPgs6Y9JBa9WtfjzNUto5ubgiuqx3dqbN6UtPoEyM	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	1613	1349	118	1	6301	jwvJJ5LKgjxysGJFXJMfw9ygNJLYU4azmzwQLQ7Mm6Y131PK8gh	4884	6880	6880	1617177600000	orphaned
6587	3NLLkT4sJxQhmh2n7dysPTuRthb2HjvwsL8SktYG6PtueUAXyR3S	6582	3NLGL3xZcSwhv8QXe22j424nhPK54gMwPy5Mz4pq1N3LEVLbf1Mg	1581	777	67	1	6290	jwXJVDdi6MeR4doNGfZUfgo6SGa4wTBnZYe7GFYULhTceJtaF2X	3366	4804	4804	1616803920000	orphaned
6675	3NKo9xyYv7Qb6mV2ueE1g8oyTwLhUFN9LWMtft19ruSyFZFbBoLX	6587	3NLLkT4sJxQhmh2n7dysPTuRthb2HjvwsL8SktYG6PtueUAXyR3S	1581	778	67	1	6290	jwxs6XDDXo1Pnc6WFufEaWA13VR1pCyrMMRP72cwt2rXg1so2aF	3367	4868	4868	1616815440000	orphaned
6580	3NLM5GS5vtByLZb35FcVRRrEVrNMKEJnCTSWJNtnVoqRiM2RyBe2	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	1546	1093	69	1	6301	jwtqGqhYWhnyxVxU5kfCfg6s5osJ5PuCgzgiDo3Fji4o6GazrKq	3405	4800	4800	1616803200000	orphaned
6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	6577	3NLkisisxDNWAwQRMYcDu64TFG3mJLxrB8Li9hVCKwLJ7doR3eA5	1506	1127	69	1	6301	jwgKa2E4eJZp666kn4V3hBr7BmycemtJ2AcpYzPm3vairBriCu8	3406	4801	4801	1616803380000	canonical
6584	3NLGRY5jfqm5qvsRzH5yw2CiEBxh2nARBo8gZcyURgARz5m9a8Wj	6583	3NKrtzkrdDsZWtE38w9AZkQ2EdUuWo5Fak3H7sttgW5JhveXqj8V	1403	824	69	1	6301	jxeRt9eV32nzHvf4AbiNp9sPxeaRBM93uaaoshRQjSzTUkPgsdy	3407	4803	4803	1616803740000	orphaned
6589	3NKQbmhjJF5EZqB7PvpsBK3PiDTK6UrVfRoFsBLMq3VTYnWCtZnm	6585	3NKTgemcsJo8SAYrUoM22Wdhhkg91b92APgQxaFvcodLpoLcAXgZ	1652	1315	69	1	6301	jwqrLDKsLwX3HPVLa2QYBaNqGt5tvXaUKzU1A6TijrPcToT3efQ	3408	4807	4807	1616804460000	canonical
6588	3NLgbXtcv1VuaxneYrcVQ1uFW5pJg6tYqnGuxeJNCuvhxahhfeox	6585	3NKTgemcsJo8SAYrUoM22Wdhhkg91b92APgQxaFvcodLpoLcAXgZ	1506	1127	69	1	6301	jxvdKmkb16Z4f9EbGhziB3iPe1KVCHiYpox6kyokdpRunHjmUQz	3408	4807	4807	1616804460000	orphaned
6590	3NLB41P4cSxWCEnKp8ZsogmsLEhZ65MxZCS4cqetADfyzj7pwowm	6589	3NKQbmhjJF5EZqB7PvpsBK3PiDTK6UrVfRoFsBLMq3VTYnWCtZnm	1406	1393	69	1	6301	jxQZWGvgn9jSRQLsNiNeMtQy495XwH4r9nxMW2YcPxc47poSe96	3409	4808	4808	1616804640000	canonical
6593	3NKVLq1rNjmF3KRpVdHxr6CPUstuzV2TLPWRf11sQzeQ6DSsLHLv	6591	3NK69GQHWr5d4dpZmcGYCtAz22nQfy8Grs8EGKuja7f9zXJibWwk	1407	1395	69	1	6301	jxgFzyrqmrCJsGa2t9gKA8723sZkaeSitPQixL8oK7ThbijDYwX	3411	4810	4810	1616805000000	orphaned
6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	6592	3NLWGct5UR4nm8bne17RBFmghhN9Zrrm8hPRXQoVt63C9Cat8C53	1560	1045	69	1	6301	jxQXCqsJ477B6tEngQPwb7JQCuDJuX4jhEMQy919vhFqLGjrB3L	3412	4811	4811	1616805180000	canonical
6614	3NLwPecg4h8X3PJRwQNZZM24CYbwURWUcmgDsPk8DXfzYkawPycU	6596	3NKeshr91vW5t76BqtMzy57AHjNPaAXkbaDMW8ki6onGcB2e5pCw	1579	1263	69	1	6301	jwfpYnPyfN3mzfchsfde1n4z6M4bakqzLYbsu9ds2SraEaWx4rw	3414	4823	4823	1616807391883	orphaned
6610	3NLxLBW7Kvts6FeCfZ7SEnUGJkrM4ZGyRrnbbLyRZo1ozoYj46VR	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1489	1380	69	1	6301	jwzPA2edhpjGXfAuTf5SnjZnnWiXmaJHGioVEWpycsf6HmerWok	3419	4823	4823	1616807340000	canonical
6616	3NL9AEGWkqNT7euGTZu2cokH9KmFYsBT97NXwRa2n5fw1RopNV8n	6610	3NLxLBW7Kvts6FeCfZ7SEnUGJkrM4ZGyRrnbbLyRZo1ozoYj46VR	1406	1393	69	1	6301	jx7dyVmF2qvP59y1f3oe7iKNVtoupWBK15pLHoBjLPeRZ3v7Dj4	3420	4824	4824	1616807520000	canonical
6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	6618	3NKhPkXgN8fZNqEp13Cu26zHvdtixiZyadf5oejKLaqYZFF5wubS	1483	1276	69	1	6301	jwH9yNkvdZY8rGpYdQTMaqRBiBtPNayTXe1o9xbHyFfYT7Yk5MH	3423	4827	4827	1616808060000	canonical
6621	3NLuJck3vnHV46PEtXLgUCApS7dVcTv5uiAnxPNXF8Y6keRatkgJ	6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	1617	1288	69	1	6301	jxDTEtMb1gHHADzMgLC2QBxUdUo3ePYb28KoBtYgmWmPZJQby7j	3424	4828	4828	1616808240000	canonical
6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	1588	1146	69	1	6301	jxFTYoHib3njv2YAcQXKxvJEeQiH4jm1NVpXqYVDWER2RTLAbQH	3427	4835	4835	1616809500000	canonical
6633	3NL9bxWW5r8HzaAatEF67Q79dwbiTqTV8YkK3wuKFbtvJacy3zP2	6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	1542	1304	70	1	6301	jxi3NrhpL1UgjM1juGnXu84n8NR7239mhFb27SWVSmpqgHyzBBV	3428	4836	4836	1616809680000	orphaned
6638	3NLMrgLJXWtva7mF13enUVUfizqquBjsNK2wSa1fm8zhXHZiEnHz	6636	3NLGceYz8UqDKkVm5mWQ44go39JFZHZbxLZqtFzaTCKKtZwdpaKe	1564	1338	70	1	6301	jxUsAwTemkdvtMYb1hs9YBTP3YxS2VzVepY4ByWwqRHQSKqFs8h	3430	4840	4840	1616810400000	canonical
6642	3NLQtUHtNKsy9b1v71kV33zLrLSaZPsz2yw8H45X3eUcVwhmCdnD	6641	3NK8Be3vwTrjnTpHYA9zqtdWJW3etwzjDwnTJoEJCzhkANkTtdof	1527	1293	70	1	6301	jwBWo5EAFRjTA3gtu8KqLzaNgo4sZHksUTJuhDXqAAgbD66xzYr	3434	4847	4847	1616811660000	canonical
6645	3NKDWdR6sPYT5t45yXfL4ALXDdR1ow62mtzeQpNS3J7CvvocCrw9	6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	1637	816	70	1	6301	jxriEkYGcy7W8yQn8DsYgcsVuXdqXmqwE3FpgjhP4qHagQJG6a1	3436	4849	4849	1616812020000	orphaned
6649	3NKZgdYfQSXHzDH83L8S9BTadJzB77ohVLoUsmBXZEPcS4QEm3Hr	6647	3NL1Cb3Edwy9JjW7i4VLYhVQgHcP58fHoq5RSMdtcqc54xe3pxAQ	1654	70	70	1	6301	jxEZLUJnzzFjaYcdz1LKmepi8R938ZKHMwBz4zdcC8Ud67UHaac	3438	4852	4852	1616812560000	canonical
6657	3NL5EDEaNRJfbmBFSfS88Xa9V5CFo9pjMinA8s1A1WNY2UvaGQcA	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1523	955	70	1	6301	jxq49Va47smD9JFRJ3mqC8XeF5D1uncEGRr5e9GwmKnTC2naxy2	3442	4858	4858	1616813640000	orphaned
6659	3NKQvJt2eyAHrgtCgBXW1XSgSt69R3KDBvoCVCxVNq53K6oyvJaF	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1397	828	70	1	6301	jwEYqyeYXdCdFgRgpeLMVBDvrXphLUjuENHoAdVSXwXDreZvJy6	3443	4859	4859	1616813820000	orphaned
6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	6660	3NKDhdSTD2YhYtGKAc1NB1MGvHKyqZoxJwPqWMyryZmUT3hqw1fC	1647	1302	70	1	6301	jwCjwuWdNMTrfxEZ9xyjvk6a4uoBQY8DjnkntiWb1S4D6R3hYJZ	3444	4860	4860	1616814000000	canonical
6666	3NLSu9FEWErrjsaMnokHYYNc9pKMZhvtKzTfPHsMjLVYPdfLn43e	6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	1406	1393	70	1	6301	jwM6Wg3hb8yrVAEVz4qn1Ri9cDW3gRPNCi9WagFXSS2RyG2kBYq	3445	4861	4861	1616814180000	orphaned
6671	3NLptqoXc4UgyzwNcHkopz1aJb8wTfoyajqhb5FN4G66TCC7cKPS	6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	1613	1223	70	1	6301	jxQ1WBJGDChgvyTLB2Knpubd7gHRZL82BuNvG14kNNvRJMk1dcj	3447	4864	4864	1616814720000	orphaned
6683	3NLkBRHqRKnnwMBsSx2fPxjZjmauX2JwbufVqcMiGMRio5ar8zvf	6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	1673	1368	71	1	6301	jxTiGdhiYVr6BhAA3FgUEraYtCEqquRMGsjRoPWdkwKkYU5hnkT	3455	4875	4875	1616816700000	orphaned
6688	3NKywZHABK1GKnWupUBXi5EiuWtFixKVJG5R3vDgLcEKTd52bcTe	6687	3NKYUhANis3S4PRNKt7SQsu8ViBnMZAJCu7sxAfNaNKPxSjCoQpf	58	1035	71	1	6301	jx36GyjevCYCKdFwYe4i66nqZ3VVWJ8ssb2v158cfDmffyGT9vk	3457	4880	4880	1616817600000	canonical
6693	3NLtfUuJGg2qBXxZ2Yimh51vCMpSiUKJpHpC4cXrtLEu6nz6LQ2L	6692	3NLsRnJfcD76aHg9VTFH9oKJegZkpHB665A95dyVCF8sortfg21D	1503	1031	71	1	6301	jwtD9JGnx8zFeiWah1RUtXocieDFezAkpDryAGfrYRWieZADmr2	3459	4883	4883	1616818140000	canonical
9434	3NKCSoVZopom2Fwg4gDKAF4sbLmieGeDhbNuZW3MFST9EDrVrKbf	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1447	1219	119	1	6301	jwwGdbHoYqCdSwwRYjUudDwrhs9TAhJonEVBsNeh9SRVdzLMAuS	4893	6893	6893	1617179940000	orphaned
6674	3NKZbNX2UjpppoYekSA66WNPCUzSXUPzdWMCJBn53JMkEQ5CJyoW	6385	3NKS1dwWcYaQBdw1ipnqeTcJa1AxRp1WBCmVPsAkgRasWr95cyNr	1667	445	65	1	6188	jxQ8WzKk92aSbnDdnSMZkKw9mc6cajECTnQDAvrJ6Mq7duM41JF	3310	4867	4867	1616815260000	orphaned
6706	3NKBDXqYpdvanNdBj3zqEGKqJyCLGrNeJAbmaaACGLqHjfCer7w4	6686	3NKd48XonyZmJjhNvRtwxg6AGA4YETAju3xVMEonj3vRw7r3ciq4	1581	778	67	1	6290	jxRBi32cpWhpafVMkwe5zSJ4ZQgdeZHgojwjZPZWDzBb3RQzV39	3369	4899	4899	1616821020000	orphaned
6599	3NLopB9G8Lrbmf1Y4tug8jMQdysJ5mDcQ1ozYMytmtpTBQJ1KtSp	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	1622	1356	69	1	6301	jx7eopgx2D28JoN17L8ADaAcDdKg7SF67wBgar7zvDAkbxzTtRt	3413	4813	4813	1616805540000	orphaned
6603	3NLyQcqnWkSUWho7gUnKEUvjabDMqBtwD3LRL2vpeVQhDRYGKAHc	6602	3NLGFPkx66Szy6MomuL2FkY67THuZ4T96cNwKeAfs1TYV6UQgn7q	1406	1393	69	1	6301	jwjTrTKznLtGSCGAW78Az2YgbdsMmLYq7Gj2cdcsqPBxuvDRfUG	3415	4816	4816	1616806080000	canonical
6615	3NLszp1sjHMsVnmKW2DiyvFAyQ2XYcR9nPoEo7KkurRQHHF2ThoT	6607	3NKwnEsQPzssfq15bJynDiBjwXbKiFUrUU7TDgc31ianvtPuDxMn	1579	1263	69	1	6301	jx5CGgtPhjDWGMJAt2bNgqfVn4rWfeewFWecZnGw9B6pkS8gK2j	3418	4823	4823	1616807456519	orphaned
6609	3NK9fDhRWCMqsW9Lyiw2HUsZBk9VyrCasu1BNSHiKn8s62bNBPot	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1579	1263	69	1	6301	jwjpEPZy3b5zoLqV96SPSmPKpn5TkpHD76yAyvydADAieBKujYA	3419	4823	4823	1616807340000	orphaned
6620	3NLbDGYUETJv2XbWwK5U4vioKa2KucvromSJ7gi8D81gLmD1QQgh	6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	1553	776	69	1	6301	jxc27Mez7gtBbp2A2srBKxEcATaMFDwCZm9aFCjAfWRZ53YeVVr	3424	4828	4828	1616808240000	orphaned
6622	3NKhRxtQTsww8pZjAA7M4aPQXRhDjVKnpo5WBmneAc3HZJDzybtP	6619	3NLkKxyWb2qL9DPbPxphN8iXXtdgkJN5tTMEGvfxSbE59rc9a7uT	1637	816	69	1	6301	jxZqzEBPfsSxESazGC5zGSYckXex5pfkUB7pCbQm97SjWh6stUK	3424	4828	4828	1616808240000	orphaned
6630	3NKdNiQ2asZXQHt7UKEbkQWEnvAdRmygaWAcfbuWnB3DSDwRMW6X	6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	58	1281	69	1	6301	jwvJETNaiP5HHgGvf6tYBvwikNJJHuLSwjHXauv8LPdgSLpwLET	3427	4835	4835	1616809500000	orphaned
6634	3NKCi8KNSWw1kEKyankGGVtQj3Qfg4FqFRkWNeGsdRdN3gMRyFW9	6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	697	697	70	1	6301	jxkVhEPLNk51EaZETes7R89q5aXrqar1Jqxj6WKngx5UuiHCeEP	3428	4836	4836	1616809680000	orphaned
6637	3NLfewWPgbd2gC37RrHFQVBmu7ag9VCUqZxTGTkuUkjVEaw5zUme	6635	3NLe7qqUbuKsUxYqzab1HmQYSuVxkdAgEvZE3XBHmPtKvN8tkdVU	1553	776	70	1	6301	jx5YpGgyiKQpSnTkkAKWNKWievTt86i5HaFMrwh8UdT9FQz97HV	3429	4837	4837	1616809860000	orphaned
6640	3NKKAGumZBtbd8jXdR6XFEYXEAJ6k3SqG1D9jsuTapHGxCLzUpT5	6639	3NKGXzY8Ei8ZLwLjE3Mz49TCEv8teAjdMPGzbrUvJUTzcTKLqPyN	1675	1096	70	1	6301	jwB1UWk2ex7sdjKMscwuwdAuLT92NJnqfsRMnTiSYC7QjGURby5	3432	4843	4843	1616810940000	canonical
6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	6642	3NLQtUHtNKsy9b1v71kV33zLrLSaZPsz2yw8H45X3eUcVwhmCdnD	1406	1393	70	1	6301	jxmvz7cJNFuQ71VK3kqV73qeyLiQQ4KViNea9Agc2MocS6hVFRX	3435	4848	4848	1616811840000	canonical
6646	3NKT54iidRQPHTTvTyxbe4c7WC8hWRJPfirKktUnzudEfhsFmD8N	6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	1558	342	70	1	6301	jwEmzy7j9baPRmDxf5ZK2QyU4TsDVjCJ5WvAepYH46EtUiVL8PF	3436	4849	4849	1616812020000	orphaned
6648	3NKFoVSiC66urALqzh1pYNPxSZS5vgRoy3tYxGTL2mGo1yxVugp5	6644	3NLyb1UwdQEwnejn52UY6jJBefm7BBKBgrd11wKFPqp77JjgasHm	1577	961	70	1	6301	jxJKGhR1xEBAa5uGPewKCEnc488SnktH1gwtTtx8XoeZ5jfgPZM	3437	4850	4850	1616812200000	orphaned
6653	3NKdCa1Xx86QvCqUXqM6qHvVGGBdktXBy4gbE5b6mhPG5CUoykhi	6651	3NL64LRoeRhDZ8Q3KyT5bAWhvpWC3Ew4QeCepRKVtgA4s875UgVW	1600	1372	70	1	6301	jwZRkNQyAooi5jondX4o2enakjvr1CKr9VyCTa5MjynUfEqX8DB	3440	4854	4854	1616812920000	orphaned
6660	3NKDhdSTD2YhYtGKAc1NB1MGvHKyqZoxJwPqWMyryZmUT3hqw1fC	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1455	1206	70	1	6301	jwXbjSuRQBV8AaXarP8wURtaBMQc97XJZXrmQtpwTY2PbQUw6NL	3443	4859	4859	1616813820000	canonical
6662	3NLcUvrqtXNfxqPEi8KYc4qu2YqfwjNqVkvpxiT7CGC44Vm9abQB	6660	3NKDhdSTD2YhYtGKAc1NB1MGvHKyqZoxJwPqWMyryZmUT3hqw1fC	1467	1130	70	1	6301	jxo5YgqzzKVadx9et9ggkrqLMsQAujtH2HTxXXWmH2utPHj2z5i	3444	4860	4860	1616814000000	orphaned
6669	3NKqoyN66Z7dDHDVo3aPHZaCBLZ7E2cEpBWuihz3qEGYii3o3YmR	6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	1403	824	70	1	6301	jxCnmAEow2YtdHR98RZKEMdLrcwcea2MwFsr9B3LShpVZ2DiHx8	3447	4864	4864	1616814720000	orphaned
6676	3NLFyVTcARDN2yjWyrviFp511ka6LiGdMaLzTnKHbQvzmAYFWhn2	6673	3NLJvhcPMwFG4MQ9tcjasYHTXp3oQTm6X3TPR3zXL4MRTH5TPQ8M	171	1374	70	1	6301	jwMnKsmdSaVUw3i7uK7z4JjFFxZgLHTwkL48kt2Mmpeed6L9b8p	3450	4868	4868	1616815440000	canonical
6679	3NLA6ry8j3Ao2Gz3AgMf88PZkE5aW23D5fuG36hVS8pKuTakEjeV	6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	1647	1056	70	1	6301	jwbsXp7T8AhFJSpTwDKEuKqkeMPZpE2E5rYUnAz5uwBdU7mM8G7	3453	4872	4872	1616816160000	orphaned
6684	3NKDQ8mgQgMZdxc4WPQ7LR3EkkXEqydGXMizvhoqZTQQ6EBCRXmB	6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	1451	1046	71	1	6301	jwvW4dBsGTHLvXny9gqFmQ12KwiCAV3EGy1x5m4RPLzxVT7Fj1Y	3455	4875	4875	1616816700000	orphaned
6687	3NKYUhANis3S4PRNKt7SQsu8ViBnMZAJCu7sxAfNaNKPxSjCoQpf	6685	3NLwoZhgoqWvXood2QGsvAP7Xo4ymWqyAux8VFnH9QeF1b52gt4G	1406	1393	71	1	6301	jwmKE6X1D9v6UoN6KhDKJfhZPauzpvPq4doXQHtgvHXUB5MicZ1	3456	4878	4878	1616817240000	canonical
6692	3NLsRnJfcD76aHg9VTFH9oKJegZkpHB665A95dyVCF8sortfg21D	6688	3NKywZHABK1GKnWupUBXi5EiuWtFixKVJG5R3vDgLcEKTd52bcTe	1565	142	71	1	6301	jw9BCCEcAxeBzvjch9XLRUYnBJq4JkbLCMAcvbeMuKnyhEm3vPw	3458	4882	4882	1616817960000	canonical
6694	3NLg4cG6wSi35YT6GZuTBajRPgrv7kyJJ4ccroAry9kdkDSckrJm	6693	3NLtfUuJGg2qBXxZ2Yimh51vCMpSiUKJpHpC4cXrtLEu6nz6LQ2L	1590	1174	71	1	6301	jxzyAm2PLMMF8MhhhhkdkBSrjXCFqYaKsMhK76fLMJ6oXTyncde	3460	4886	4886	1616818680000	canonical
6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	6694	3NLg4cG6wSi35YT6GZuTBajRPgrv7kyJJ4ccroAry9kdkDSckrJm	1406	1393	71	1	6301	jwpQbrngcdvRKRQwo7p8w295DzYYCydgaLpBRjWnMXE6fCt1adK	3461	4888	4888	1616819040000	canonical
6695	3NKEui4nrJUGCaJQ7EruQz2Ebr1ZhRtSuvGY6QKcNM9bHJLyLb7m	6694	3NLg4cG6wSi35YT6GZuTBajRPgrv7kyJJ4ccroAry9kdkDSckrJm	484	1073	71	1	6301	jxteGRwVDGuWN2WMkna8XcssH1CYv6uqkxkrbb5cSsWN442nf7R	3461	4888	4888	1616819040000	orphaned
6699	3NLuLxZvThmzUAPwXWmtLKW6d9erzTr1jW2YKP4PSf9d9P9mjJhj	6697	3NKj3cNkju6TYnnDAiMMUg6mJbZ7Ykt2FrGCvC7iSDLWGAZY5BK6	1508	1387	71	1	6301	jwtuzA4u9YHXNHvxfd4DUJvyJyYpkQmTSEsvw2j8EtckLpMdMWk	3463	4891	4891	1616819580000	canonical
6700	3NKNa7ByBUfqSqEarqMzAwBSg5ivwAZAafynu78GirSKzsiXzcMd	6699	3NLuLxZvThmzUAPwXWmtLKW6d9erzTr1jW2YKP4PSf9d9P9mjJhj	1426	586	71	1	6301	jxkuSRNzCDoTujFNftedJoHgbHW4vpQSNCJgaUPNZjX1R6NsGXU	3464	4892	4892	1616819760000	orphaned
9435	3NLHQDgCQvFouSSTtb4uKvLFTrDxMFAFHqcqkgLjatgkZMaMLe3y	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1600	1246	119	1	6301	jxbmViHyPHhGasdi41TaBT7ow2DJnDkpwTMnbs5xwAfW6U6mzD7	4893	6893	6893	1617179940000	orphaned
6604	3NKDYyxiv1xo4f3qH6qUmdTfsYEtyPH57LyTskf5CokENMCzaKwp	6602	3NLGFPkx66Szy6MomuL2FkY67THuZ4T96cNwKeAfs1TYV6UQgn7q	1607	982	69	1	6301	jw8LjGH3GLVQDLXeaGLDNUrCf8o482HzpLvZ8geQGBWhj7gK9Do	3415	4816	4816	1616806080000	orphaned
6607	3NKwnEsQPzssfq15bJynDiBjwXbKiFUrUU7TDgc31ianvtPuDxMn	6605	3NLuoeetHGdXNUiYMxWJS1Lnz3ybo1NsndfFTFNuqtX7i68WojUV	641	1336	69	1	6301	jxfq3g5xDHiaRNGYSekXquuvQGFUR9DB4cUR4PdxZup7cUba2LN	3417	4821	4821	1616806980000	canonical
6690	3NKPJG9erNFMqWiVPHCpV92zJcfwoUDPPqNRg5rYwnt3iLqDjbzu	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1650	1375	69	1	6301	jxDDuJJPJdDBAnR9YcrvgWjU5jbNwB92BygMw42AWz6KJzMnQQi	3419	4881	4881	1616817780000	orphaned
6618	3NKhPkXgN8fZNqEp13Cu26zHvdtixiZyadf5oejKLaqYZFF5wubS	6617	3NKWnCuoQpKsqVMwW88ncm184X19gowgRAXUR7ctDKJ7jyWUhThG	1406	1393	69	1	6301	jxd26q33VknwQpvT5boDxRWkD8aa8KDbTs6HMNLcUi1tgt6p5dw	3422	4826	4826	1616807880000	canonical
6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	6621	3NLuJck3vnHV46PEtXLgUCApS7dVcTv5uiAnxPNXF8Y6keRatkgJ	1483	108	69	1	6301	jxRCm3jGx7RcPACTRy8UyWs5Hy4khgv5XreZJoTUURRVLcjCQLb	3425	4830	4830	1616808600000	canonical
6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	1611	1095	69	1	6301	jxaCqCPnusP3R6LvjL5qJTkataLPDvVh6A4xaWPvVNXWKd58aZx	3426	4833	4833	1616809140000	canonical
6624	3NLg1QhxeVd5KS64NCCcxj5fje7ZMm6DHWg52746Yt42yyTioKdp	6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	1444	1381	69	1	6301	jxEGYVm81tigFC8n1NmSSHGHqPfrju9TaDKNE4b4nLZyzxTnGcW	3426	4833	4833	1616809140000	orphaned
6635	3NLe7qqUbuKsUxYqzab1HmQYSuVxkdAgEvZE3XBHmPtKvN8tkdVU	6631	3NKW4DRVHgjgbTRkR9Qk1mAZXg3rAErA6Agv42xpetcPvc1ugEje	1633	1390	70	1	6301	jxmrtPqAM1JhscaY2i6fQNpw3VEqF9h4eXtjsQm8xqm2FsBTuVL	3428	4836	4836	1616809680000	canonical
6644	3NLyb1UwdQEwnejn52UY6jJBefm7BBKBgrd11wKFPqp77JjgasHm	6643	3NKSFgWJKZvrDvNMSdHhY9SRPpqwweJH8Fu32ZRjpMfa3CdoynMf	1403	824	70	1	6301	jx8UZpDKs8qNLDqkkPPxDzRJxn7M79RCEx28LLKeMrJZMhfXuRB	3436	4849	4849	1616812020000	canonical
6651	3NL64LRoeRhDZ8Q3KyT5bAWhvpWC3Ew4QeCepRKVtgA4s875UgVW	6649	3NKZgdYfQSXHzDH83L8S9BTadJzB77ohVLoUsmBXZEPcS4QEm3Hr	1490	1148	70	1	6301	jwdVbSTDHJ2qc5ZuATWkHBt6mYgSjnFQFEX6w3RWjEzA3UdkQw2	3439	4853	4853	1616812740000	canonical
6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	6652	3NKCF6TThgrKtsMyHcQ3vbfb9oGBw9aJ9PSJ2bMTG79u2aaaet6W	1457	1265	70	1	6301	jx9qBLgPg8JzLx9y38RuxdZJoiZ3fgd34QKXoVUkLDTvp7AWZSc	3441	4857	4857	1616813460000	canonical
6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1419	814	70	1	6301	jwnxk2MLYyg4s9S5NinEg4JKK7TFVKTc7xeNEZbDofSpk5zhRk8	3442	4858	4858	1616813640000	canonical
6656	3NKMAAMrz3ggdgiQF7zyF9LYbErW8EsJvnXhMK4w9Kpdgd3miSHJ	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1523	955	70	1	6301	jwVS5TBTwwbGCZHXRRv1dTQq49VYVKLccPgMT3BuNGHhTK63KER	3442	4858	4858	1616813640000	orphaned
6661	3NKSLAAJrRF8d1bBYAemtQo8RCCBpmcYVFKHiTKdkqkCkAidTn2b	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1407	1395	70	1	6301	jwTwhMpw6oteot46SfdTUZytDYeYr8yXNfp1Q6N3gRWuejchrWk	3443	4859	4859	1616813820000	orphaned
6665	3NKGuC8aH9pNWn3f5jTKCTaGe2MMx35LaapjmyFrg94JL4g3HuwB	6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	1403	823	70	1	6301	jxPW25GwXmUna8aDL7PzDkFAxZTHWVNbMRt6oK6uNRiQyaATGK6	3445	4861	4861	1616814180000	orphaned
6670	3NKAVDvWSg5tESXfXBV7JEEXSyCT8o8Mrs1uTTGYY7HD5GhjGjXV	6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	1547	1378	70	1	6301	jxm5hAUXrZYLW1zbQXg6jyixm5gWPLxFFZWqiy2vtnKz2qiaeXz	3447	4864	4864	1616814720000	canonical
6672	3NKQdv1zgaTrSoQhcyVwW1gq81nYdEC4gHZ1g4DcU4hWe5xQ1qE5	6670	3NKAVDvWSg5tESXfXBV7JEEXSyCT8o8Mrs1uTTGYY7HD5GhjGjXV	1470	542	70	1	6301	jxFx4GYV1qBkkXWpoQE2R7PGe8vDH4ovAusUPh9juYWpGgHcjW7	3448	4865	4865	1616814900000	canonical
6677	3NK7k5YsfKtjXT3CvEEvEFZBaLSVTaKspNEkkQEYJ3m49eFGsLKc	6676	3NLFyVTcARDN2yjWyrviFp511ka6LiGdMaLzTnKHbQvzmAYFWhn2	1406	1393	70	1	6301	jx7jpq6X8KKiPbA6jJZEt24n4pnWdQkjWTsfhTSy51KMT3MQthg	3451	4869	4869	1616815620000	canonical
6680	3NLcH53ATvMZafoFuK5zx1ocx4FkjATFj4S39occVW51Y4Phu42X	6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	1513	1379	70	1	6301	jxRLB87kUxrqqNirDP1iuGQe5YLxd8BbkBMkRiWqb1qz9mcDDN8	3453	4872	4872	1616816160000	canonical
6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	6680	3NLcH53ATvMZafoFuK5zx1ocx4FkjATFj4S39occVW51Y4Phu42X	1613	1349	71	1	6301	jxYiLRSyXUzxwVU6MVKRgf1hpg35hRGdGfx27rWSiWJ6j2ZnhHh	3454	4873	4873	1616816340000	canonical
6685	3NLwoZhgoqWvXood2QGsvAP7Xo4ymWqyAux8VFnH9QeF1b52gt4G	6682	3NKSdQ3qVY8zAfj43cu2zwu7HhW7dHaW5KV1QMdN4VxwfkwYqVBs	1670	1282	71	1	6301	jx91boZ9FUYdThz1RuQcgp1uJLhTwotKnqYDnj1SBdTsQwNMFAK	3455	4875	4875	1616816700000	canonical
6698	3NKL5QDHb9fUWfTMNfBuDHsWzwRK6UEYVXWEGhqFmQQdP3dS2xAt	6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	1637	816	71	1	6301	jwbF8dLopyNTArhmsgDr2gHoMKYjZ3crqD2a2MQXS2ySNwwZVgN	3462	4890	4890	1616819400000	orphaned
6703	3NL2CxK5C2dc4smwSgnzSHQymx59Xc92eHpdEkpQ4CYrpW4ZZNQD	6701	3NL3zkj85sGdh1m8KHeC33XJY6LwWMywqPPBSdBwDTZmSsDamwiJ	1455	1086	71	1	6301	jxTmwQXpadsgNErEZ3NaWxVHcCxunDcxKQ3zYopwXrtLSB6aTCR	3465	4894	4894	1616820120000	canonical
6704	3NLZtMnW4fXx5DbaxCTyQhASB41Y5Uzo6N9onww5VgaW1fJRV4DG	6703	3NL2CxK5C2dc4smwSgnzSHQymx59Xc92eHpdEkpQ4CYrpW4ZZNQD	1673	1122	71	1	6301	jxwZD7TtAWjzTMrJL7jxGDG1DUMDHNqFkpAgW28eh19zM4wE3Az	3466	4897	4897	1616820660000	canonical
6707	3NL2iQnB7pNwxEwNd8KwyiBtwKGFkQRoFaAhbkGYKMQQ5gAJrbNK	6705	3NKJTMAhMQGc4mpR8uJR4HkzgVFBFXwHCo1ADrBTG9X15cM9Fdjv	1407	1395	71	1	6301	jxP8mL2Ft9thsVDXpF8fGrr5JRaLPNBaNdEHDbM9ZPkAmYR4UsV	3468	4901	4901	1616821380000	canonical
6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	6708	3NKoACCzuwu4B8WnsLFQWgFYuAFHkMYeiHyB9w9Cuo9kdYsjD3K5	1599	1287	71	1	6301	jxAPGhWE3ShQXfhVAu1zoSnX1PMu8Eoyxvat3TeRh9hSminKakk	3470	4903	4903	1616821740000	canonical
6711	3NLbkrH574SUd1mtKymbBhop657qq8AXRfSoYV2CrndtW7eTahd7	6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	1406	1393	71	1	6301	jxsiSPERgBpofHHcAFMtW1vDKoA9U29qexc6X6kR9xYFRc5SwVJ	3471	4904	4904	1616821920000	orphaned
6714	3NLqXiCRJL2eVnAAKHa6CDB1nTDN6ur2uGD9CTvt8mcPtAhyU5du	6713	3NLY49TGeKc2BgahM9TQmGBZQrGKeAK512tCD7LtCcmeJ88FAuuX	1588	1392	71	1	6301	jwvYNUD6wdSQWmHDzQb8Xaxv4WoK4TnCuBjoLPWjGUL2xjEdNKa	3473	4906	4906	1616822280000	canonical
6716	3NLvyur6iriFfLeEP6vMMh7SRSJEkSGjpMX9NN5pWHrccBJG62SD	6714	3NLqXiCRJL2eVnAAKHa6CDB1nTDN6ur2uGD9CTvt8mcPtAhyU5du	1637	816	71	1	6301	jxwxDhqvHTfP67CsN1mD9TNptbAG259LUW5FZ8nuAMGBXN1hDnK	3474	4908	4908	1616822640000	canonical
9444	3NKR3qcAcZdtW2rjX3HE8bD3FomKPYqBkAc549sAmgUKjM4weYDR	9442	3NLY4nPLvCCBRVWLK4KBbxqW7yco3oXZ7WkFWfouBe3S4mrSRYwA	1460	609	119	1	6301	jxLqdLg9aHkTrecrAmT4aKqir4Z7Q4RpHNhXwEDFy42912mSyxX	4898	6900	6900	1617181200000	orphaned
6689	3NKrJoEnaVvkoiyk4SMjjH8MRputkwEThybfUZYHTYsVxQsvteUb	6426	3NLk2a63Z3WnfxKaL92EZqt6xxyr5KDjrVHuLAhcSSGfRsQrsdxj	1623	830	65	1	6226	jwFj4BhQaHmDLHfCMkqbfi4fwSPafe36EvALk24kFibViTjFJtx	3283	4881	4881	1616817780000	orphaned
6613	3NLGfDuLsTXTsvu6JB1dbGr5UJahkbaAgrquUicaL9VkMztE2h2P	6601	3NLZsduatgB2xqXd3eL1YXZoBAY9AUDj7wYgSBuBoquZYKNJtsSt	1489	1380	66	1	6225	jwv1tzPdSoYt3FuuiwqHLe1GvK5kkXEehTZ4dbK89Qfbf8ZeUYx	3329	4823	4823	1616807340000	orphaned
6686	3NKd48XonyZmJjhNvRtwxg6AGA4YETAju3xVMEonj3vRw7r3ciq4	6675	3NKo9xyYv7Qb6mV2ueE1g8oyTwLhUFN9LWMtft19ruSyFZFbBoLX	1581	778	67	1	6290	jwxCQ4j8n4Ady1PqBy4MU7aHByB69S6zB6PECAPBkzoWTjdpaP2	3368	4878	4878	1616817240000	orphaned
6702	3NKqxA7uWidJb3jhrS9CWzTVyj2tdvySa6uZQqnffoC5VwH7kToi	6568	3NKgftHLvR982GE5rp2NUBSBXGisX6obXqJpogNY6q4FZpxz6kBJ	532	1303	68	1	6301	jxUU6cGB4utq7EqA3VkxUbZa16oFVvP5VhBY6KNCXPr1aJoYbXA	3402	4892	4892	1616819760000	orphaned
6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	6607	3NKwnEsQPzssfq15bJynDiBjwXbKiFUrUU7TDgc31ianvtPuDxMn	1405	873	69	1	6301	jwU3XRPqnDe29G26xdfrcWAZm8Wjh1M5nVqNoEf3kMkc94ow4pZ	3418	4822	4822	1616807160000	canonical
6611	3NLUoGKutawbW1ujGKwjKSN5GQm91zWSmzwKn4hvxstQnXhfbbDR	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1589	920	69	1	6301	jwd3v2vGgwCvsujAyU59bjKhfQVuvbz49efefcnkTzCBE6cLmpe	3419	4823	4823	1616807340000	orphaned
6617	3NKWnCuoQpKsqVMwW88ncm184X19gowgRAXUR7ctDKJ7jyWUhThG	6616	3NL9AEGWkqNT7euGTZu2cokH9KmFYsBT97NXwRa2n5fw1RopNV8n	1637	816	69	1	6301	jwJdC6MbNbG36NbnhMZJJh4jVgWMbwuXEoPas17YpHojfyfaVsp	3421	4825	4825	1616807700000	canonical
6625	3NKqyCohq7sNJa39LrKHu9FHJbpuSNjjgDVeMJaWEU2GE6FuC71c	6623	3NL1qauyTKbKDQFysPQ9LQwpaLB85TJNvNANzv42e8UhFayE5MYF	1444	1381	69	1	6301	jxyHz2VzeRJFSERzHT7BZTGQSNV2kArdJHGXMMnRTedUiK6io1f	3426	4833	4833	1616809140000	orphaned
6639	3NKGXzY8Ei8ZLwLjE3Mz49TCEv8teAjdMPGzbrUvJUTzcTKLqPyN	6638	3NLMrgLJXWtva7mF13enUVUfizqquBjsNK2wSa1fm8zhXHZiEnHz	1477	1224	70	1	6301	jwP2SZxeK2G7D3TJb2Ur4BFiBAnXUf8yvkG81emgGpcgEEbNtmJ	3431	4842	4842	1616810760000	canonical
6647	3NL1Cb3Edwy9JjW7i4VLYhVQgHcP58fHoq5RSMdtcqc54xe3pxAQ	6644	3NLyb1UwdQEwnejn52UY6jJBefm7BBKBgrd11wKFPqp77JjgasHm	1403	792	70	1	6301	jx1ijjH8iVNJt3kXVriYMnZgZzs3i4osTHTyzi7UgnR69mzH6iU	3437	4850	4850	1616812200000	canonical
6650	3NKpbwBUYf64EkT6ZJL9rGGupmfVxc1yZQiPoQ15TJA2J4EBqMUv	6649	3NKZgdYfQSXHzDH83L8S9BTadJzB77ohVLoUsmBXZEPcS4QEm3Hr	1553	776	70	1	6301	jwPnU3on7w2CZQBbt8psunDGMTTLGzhXRjSKDUSfogesXKkt5Dy	3439	4853	4853	1616812740000	orphaned
6652	3NKCF6TThgrKtsMyHcQ3vbfb9oGBw9aJ9PSJ2bMTG79u2aaaet6W	6651	3NL64LRoeRhDZ8Q3KyT5bAWhvpWC3Ew4QeCepRKVtgA4s875UgVW	1403	31	70	1	6301	jwxDJQYQeQmvZdJMECfdBjDoVp6aC6iHTMst6gZBsjYBWtrLv6Q	3440	4854	4854	1616812920000	canonical
6655	3NLV57f9mSb5tJCRTTZbnZ3Ekh74R4H8u2S1rnertF7Tsj8X1BLN	6654	3NL7FAK9L2rxpwvJNd3z2uwYMCuCBNGf3QWk8VARBXRoMDRFkTN5	1523	955	70	1	6301	jx6RKjMTsbvN3pGnYiL66rGw7jmPJWQzfeDLqrwKZhMTwfmEn6T	3442	4858	4858	1616813640000	orphaned
6664	3NLZzJk7sSkytaXTy4gvjW8iWMbSGNtm79EYJYB35xL2SpBjiK3f	6658	3NLhVj7QzzH1NVKozBy9xSVQF2R8sFBTqvMQiN3tShrG3LckzLoB	1647	1302	70	1	6301	jwyJkfPoX3bKy1rKLs93k5FVLic5QoL8qDJy3o87Yuz1QanUJrd	3443	4860	4860	1616814000000	orphaned
6667	3NLrok9T9AJN5pHokSnQ8BL3LNQeG8P5wUbSDpt41T1W8k8Xcpqg	6663	3NKbq7Cpt8yP82qb5z8E9GHeFcW7rvX4yQEPQYeheG5qkhvVJ6C5	1407	1395	70	1	6301	jxzap5L4jHJED64MwoG32o7npnWfNp2JCzhDzSucg3vUEAguiae	3445	4861	4861	1616814180000	canonical
6668	3NLhcJx2g3x9zS3TD54NdWaQomMothNACbCJt2aFmzbyq8r3yhtg	6667	3NLrok9T9AJN5pHokSnQ8BL3LNQeG8P5wUbSDpt41T1W8k8Xcpqg	1656	977	70	1	6301	jwModEC6z4DawFZNTXUNtF3FzcAuaf8PtSBHSDPKL2qgdCGRZZv	3446	4862	4862	1616814360000	canonical
6673	3NLJvhcPMwFG4MQ9tcjasYHTXp3oQTm6X3TPR3zXL4MRTH5TPQ8M	6672	3NKQdv1zgaTrSoQhcyVwW1gq81nYdEC4gHZ1g4DcU4hWe5xQ1qE5	1405	1	70	1	6301	jw8JRdFBSKjHAuV3aGo8CJvu51UuUAZ5FUCxso5bapYs83ymaD5	3449	4866	4866	1616815080000	canonical
6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	6677	3NK7k5YsfKtjXT3CvEEvEFZBaLSVTaKspNEkkQEYJ3m49eFGsLKc	1529	1070	70	1	6301	jxKVeH1JfBXJkFr4zD2GDuVeWmrXryQ7ppabCVEmKAKk5dy5bpZ	3452	4870	4870	1616815800000	canonical
6681	3NLuxp7Hf5tunaZ7FFxFpwUa8pAbbTgwat5VisQZGMroLEmEmNuX	6678	3NLvj9oZoTifkyPGdrxoDg71vMczv1K27FBQQf2uNnib52goMmu1	1647	1056	70	1	6301	jxqgJNZ2voBmcQKAZP5EijdWtNxdS58tPhPyn2HQTALDKowtGC3	3453	4872	4872	1616816160000	orphaned
6691	3NKZosPGtZ3zqzj3zWyqVGEBnZuEfjANiZwcEfwsx2J8VRSo4tCi	6688	3NKywZHABK1GKnWupUBXi5EiuWtFixKVJG5R3vDgLcEKTd52bcTe	1560	1291	71	1	6301	jwDBugjd2S97GC7xFoTzGMyXV4Tun4A7PZoAWPoX67oxv7UTFks	3458	4882	4882	1616817960000	orphaned
6697	3NKj3cNkju6TYnnDAiMMUg6mJbZ7Ykt2FrGCvC7iSDLWGAZY5BK6	6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	1407	1395	71	1	6301	jwUBCwJncpz7hj1iZiPxPGypzJ4YMNwxQKggzHqsFduNPqi7jDb	3462	4890	4890	1616819400000	canonical
6705	3NKJTMAhMQGc4mpR8uJR4HkzgVFBFXwHCo1ADrBTG9X15cM9Fdjv	6704	3NLZtMnW4fXx5DbaxCTyQhASB41Y5Uzo6N9onww5VgaW1fJRV4DG	1406	1393	71	1	6301	jwPKjeBCJtv98ZrnuobrUvwdHng1KrWe47hv8BUrhSrh8B98M71	3467	4898	4898	1616820840000	canonical
6708	3NKoACCzuwu4B8WnsLFQWgFYuAFHkMYeiHyB9w9Cuo9kdYsjD3K5	6707	3NL2iQnB7pNwxEwNd8KwyiBtwKGFkQRoFaAhbkGYKMQQ5gAJrbNK	1403	824	71	1	6301	jxHa1CD7Zyz7ggS6NJcF8VPnw6bNz9XDcP6gdq4t2wdqUga5qCB	3469	4902	4902	1616821560000	canonical
6713	3NLY49TGeKc2BgahM9TQmGBZQrGKeAK512tCD7LtCcmeJ88FAuuX	6710	3NLSpxVWz6sHpfKfoQUiWY9S8zLyep3YwGSVDxBY9xKxn3iTDncm	42	1235	71	1	6301	jwwSYHabs6oTrmk92ehiuaMC5icA1vVbk9GXL6oTywGRUvAqdZC	3472	4905	4905	1616822100000	canonical
6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	6718	3NLMeAX5Xepb4dJEf5PEZUF5BMs1tFZgFkFD7FWV6ze9e9n1849y	1422	1337	72	1	6301	jxTmQ5AaGVcnBmnXGJwf7Piz71yVVr3sPH7KVGPmrwqqAyJWeJd	3477	4913	4913	1616823540000	canonical
6725	3NLBwdokKukC1ygyv2HmhDhGGehzPXmsrihDKiPRyAo8qjSh1GEH	6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	1523	581	72	1	6301	jwJNocPEHTCn92eCpLpkuRaP3P4C2CcTjGVckxbuwWSaWTS9hWc	3479	4916	4916	1616824080000	orphaned
6726	3NLVA3E9pGgavEvpLSet6ZyJZvcVUpXB1GeEoQ4YjK5Pf4ZwJFJz	6724	3NLSBFxTFxm7EfrER33kKaWuu5qqg75Akpz6YS6xEuZjAtwzNXKB	1403	824	72	1	6301	jxwKroT6bTxYAKnfa6vm29a5DVg9pygarynS5pvuatvGTwkxomE	3480	4917	4917	1616824260000	canonical
6727	3NLAyCVXE7PPXzXxn5M3aPecmHfNkToK6Qz9kr3zy6qtkN2Xsf3d	6726	3NLVA3E9pGgavEvpLSet6ZyJZvcVUpXB1GeEoQ4YjK5Pf4ZwJFJz	1671	1239	72	1	6301	jxrk488duMJgXCYLymuVLduwqGBtCgM6dC24XAJoa8pgfp3oKQw	3481	4918	4918	1616824440000	canonical
6731	3NLaXfHD7TMRF9N9Q77HrDaTjzu4Hhtsyg4jjy1R8GckRjCXaUuc	6729	3NLU3xbRqB1JtP1o4ZQ2Vs3X4o9JrGMqv5ZjvMvSJRhA5P9JH1z6	1439	1033	72	1	6301	jxGtTve1ChbZfTUaWmcB58XN729jWzw3ypmkWtHnHhMHfhPjtxA	3483	4920	4920	1616824800000	canonical
9448	3NKndyk9oEw3Ai7VQ3YjksCvyrYF4VNTR3EwbfrqKDXdxanmmYVx	9447	3NK4rGXtMjgSBrLkBfkHETJ7Ju5jurMFKHe9itJVV9XC6mTf9AjT	1422	1337	119	1	6301	jx9KzLRNsmmfQ9CbGi6YBzJZPGhnyrvq8h6W1qoqtmhzxoRLpw1	4900	6902	6902	1617181560000	canonical
6803	3NLpJ65Xh8JKK9p8sZG3R2WPdducUkonyYrp4eA7zRicWcEvPToV	6696	3NL7haGeNyacPAtzt7iTRRQAHeM2EhL4gfJK9HmVm3BhbxzPfuuN	532	1057	71	1	6301	jwWsPa7ZPKZ5Jmkuc4i5XYPXkUAtF6XGbN8yLNgj9M3MEaQQ45N	3462	4968	4968	1616833440000	orphaned
6701	3NL3zkj85sGdh1m8KHeC33XJY6LwWMywqPPBSdBwDTZmSsDamwiJ	6699	3NLuLxZvThmzUAPwXWmtLKW6d9erzTr1jW2YKP4PSf9d9P9mjJhj	532	1303	71	1	6301	jx8roDaQqzHB9vvNBd3irRBqVBrM7dd6sLS9P2MPLyPLMnwQ4yQ	3464	4892	4892	1616819760000	canonical
6710	3NLSpxVWz6sHpfKfoQUiWY9S8zLyep3YwGSVDxBY9xKxn3iTDncm	6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	1657	1218	71	1	6301	jxe785cf89Dn84eYEoFMej6E1YPLWBfN2axhKT9s98AZUPiNv6j	3471	4904	4904	1616821920000	canonical
6712	3NLLHSsPTcCPKcEndf9mugqYCqsQvJVuJNvYsnSBKcgUeh4mpeiC	6709	3NL4Q4puEdKFrTJEgTFYmkPeDREx7D5vLey4CyM4Hb8Ck2JZ5URf	1490	1274	71	1	6301	jwpW8wnkhM5dVgEc6eYfEacL6QUZX2SY3qoXUzNdWfXX4JeevKa	3471	4904	4904	1616821920000	orphaned
6715	3NKRaWNhhp55LofGBPJTRyRFrPUw8dcP6TwWfKByWFVQQwhPxEte	6713	3NLY49TGeKc2BgahM9TQmGBZQrGKeAK512tCD7LtCcmeJ88FAuuX	1546	1093	71	1	6301	jwgG3NTN5WxNjXMaZYYjt1GsvdSQKH5xxVKyhDGhf8TDgELxAJW	3473	4906	4906	1616822280000	orphaned
6718	3NLMeAX5Xepb4dJEf5PEZUF5BMs1tFZgFkFD7FWV6ze9e9n1849y	6717	3NLpzFn9W11fxkjrAtEMqJHNVqhnaQKarzJQCdyTDmFXH45DYD1e	1407	1395	72	1	6301	jy2Mb5hxU8kk61aPR4TAR3oTfFcYL37ud51YbAHoSTis5xAFL28	3476	4911	4911	1616823180000	canonical
6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	1407	1395	72	1	6301	jwyEVUhmtn7XXcbFKQUHsj1Tx4bazuSs7NeGkworcfh8G5qwQuW	3478	4915	4915	1616823900000	canonical
6723	3NK4vd3RpDsJgxM7B8KXJvcTDCNNNGZnFqPcFCEdHQbyaVe6qgnq	6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	1523	581	72	1	6301	jxetvDu5TJMWFwttxRMoWfDxSnbWna7dPBetuhuXsHBGW9PNrST	3479	4916	4916	1616824080000	orphaned
6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	6731	3NLaXfHD7TMRF9N9Q77HrDaTjzu4Hhtsyg4jjy1R8GckRjCXaUuc	1631	794	72	1	6301	jxXfH6PyZm8hM9kLBjZAsg5ckStiMaMrX58urB6DNX7t2LqPTeY	3484	4922	4922	1616825160000	canonical
6738	3NLbkxiDmx6iEt5LkiFxk6cVt1kQhfUzPgdwJthQD5Ua9h56qiu7	6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	1506	1373	72	1	6301	jwt97QgiUPJhqy2AwiJiG9DYE6CFjqaSmzZqBFm2VwCbSzHdafN	3486	4924	4924	1616825520000	canonical
6740	3NL9XF1qKZDtWPVbpZixYdfLXA4xn1dCk8usxTSmdbs58VPtkup5	6738	3NLbkxiDmx6iEt5LkiFxk6cVt1kQhfUzPgdwJthQD5Ua9h56qiu7	1651	1301	72	1	6301	jxnpcHxHTxNFT427meLTdCfMqZ79mVFSgZxKiZ4yz19eufaUzrp	3487	4925	4925	1616825700000	canonical
6743	3NK6t2d44NJeV6atr3gCTiF1mE7WxPeShqgeSbuhmd9MU8viUtBy	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	298	1062	72	1	6301	jwEbzHLZpa2PhWx2ufXhuUPWuikNtia1xqTQ22YgDPLB4phSHLA	3489	4927	4927	1616826060000	canonical
6742	3NLht1sWwSVUFKii8v6fCcchkhrdwFfxgjjPeJP11KKrXUeCMT7B	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	1406	1393	72	1	6301	jx4uXPU3bQoNSV2UoKaiWJFxN8YtFRA9uZPDZLkKV5HuiR7ZNuy	3489	4927	4927	1616826060000	orphaned
6752	3NLTyk7taDq2xzfRtkboHVVi2cRUvrgwrMjnf5Dm2iL2LQdMscLM	6750	3NLkwUr94YJpYPf84jzW2Ve3bQorFKHhu544CvrA7uizweQn4QhG	1405	867	72	1	6301	jx85jcQEy7kjBq347uVtqYj7Yu5vvRjHXLqNiFeGcaFjMh8Yw5A	3495	4934	4934	1616827320000	orphaned
6764	3NLURjpSmPxvYnvqfrs8gHpQPrevdjotDNdys9ZWTHUznNpRTB2C	6763	3NLZA9cYW8PAgoC54JR9Pf6TTJ68N6oYGDq8MAuVFstNXuPQ2VgU	1406	1393	72	1	6301	jw73pnqAigpfUxATSq28jX7x8RmdwKFnRJwBi6ESWm5eRcwCjRS	3501	4943	4943	1616828940000	orphaned
6766	3NLfLnBSCJsuyPZjyHtE6SJZeuYExwkS2YndQddQ2s54LQjuzy1L	6765	3NKNA9uFwyxoyTwKkVT4x3EhyvRbC4nd4hdEaRjnpurF6Gx2thdd	1507	1034	72	1	6301	jwfS4p8MHncCtFaSZQ6dHsUW72UVcMfdvXiejrAqapCEKGrS9Mf	3502	4944	4944	1616829120000	canonical
6769	3NLNc5XQYUpWx7KbzfwRaUADA33c4xitxsFjKq3UwSgkoxDtjwgC	6767	3NKd3pLVrgT9iJqE8wqsspFwEQpjDpwKNF73Z3naQWuBSrDGghkp	1406	1393	73	1	6301	jwV24R9QPsj4MHVqH7bgJRjT8spyY9WNE9cBSYLba6Vm7yeNJ9t	3504	4946	4946	1616829480000	canonical
6774	3NL4FtnPPguuDaBFN9QcBWSas38nrr1j23gjcUx8fv81FjXAZ4bC	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	115	115	73	1	6301	jxq7GAnpGZnvZ7ZXzMN5FjnmxrnsRnBGadXNHoArQFnjpC46gmZ	3506	4948	4948	1616829840000	orphaned
6778	3NLMK8wgSSPovGtA5VArL3AWPQTCcCGTH1vcLNzqufdnUw8vK9NE	6777	3NLkoMuMvzqp7uxMtyupqocRQcs9aLTghj25hV44aCJJjgGCCrKp	1578	1170	73	1	6301	jw9Ad7cmscTEH2SdYbxZF4UuSsmAwDyGthiFGd62N6bALzHoV56	3509	4951	4951	1616830380000	canonical
6783	3NKnVun43o2AZP6fCmTUrnHb98MZ7YScPD7Qdgw7UAMDnt7eqWNr	6781	3NKpjK4TSUF4bgctJFgNvLVyfYDz8bk3rhcDRQm4HjSG4MeSawgq	58	1281	73	1	6301	jwDwwewDYsiDw7QYsuH59gUv2gn2WyHPwvC1u7oTdem8aHz1aJg	3512	4954	4954	1616830920000	canonical
6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	1447	1345	73	1	6301	jy28LprbEA9xErd79fkmN5hw8ShRBRdwenhnn2FGKrMP3TCLhDm	3514	4957	4957	1616831460000	canonical
6792	3NKMcxHytidkaFRA59GxD6d9em3k3ZmCwHZycM3KYaKxiEUpr2Hn	6788	3NKgTXsWadewBgtCqESCtyFAQca1FrDNWwoua9GjhCNBdDmSDR81	1590	1300	73	1	6301	jxKKj4BvqCjdzkQ2TfBtoHLnM7BHyM6Wx5gsowaCETQVLPfpufq	3516	4960	4960	1616832000000	orphaned
6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	1634	1205	73	1	6301	jxrspKFtkgq3gGA3D7SQ53qtn16JK71TPFaumcoX9N8TKHsyXaf	3522	4968	4968	1616833440000	canonical
6810	3NKgLhrS56hD7yTAYPSRSyNSBy8PUiUmGzGWNc1gn29Teb3APyLc	6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	1553	776	73	1	6301	jxKjg5HkBmnHiKYoxqJtyqwDQBJuTqZyNTupZYcyB9NHwCSpisT	3524	4971	4971	1616833980000	orphaned
6811	3NL5CffW1QhnjzA26vTucwNjLPSbD7YhqXPxbxZihVZH7VTZTkTQ	6808	3NLg1cSNtpG1HysDbiruF2xasNmEeFrsDvw9MJ3WfnujiHXwQtUf	1529	1316	73	1	6301	jwEoasYkT8mpFXRqR3ReePNH75fdEioiuvio14d8qXiGAQx5pn6	3525	4972	4972	1616834160000	canonical
6814	3NLw1zy9pwDR1mfQymPExF5Eq1GtmZmJUm1sHLcQB6YCeMN8yVzY	6812	3NLLDNRCzhM4xFLiZTgr7VJiVcgL6bTzuxeiNwB8r2nvnzi6rKYc	1513	1253	73	1	6301	jxA9Ec7z945Xpvh2BuVxrEij3U3ZigTByTUjfCu3q1fi1NRq6nH	3527	4974	4974	1616834520000	orphaned
6816	3NKbshwMTpVPmvGXRNUqYMF86HqhfxkgjY4P4bP6b8uHa23cMqKg	6813	3NKSNHfFcqLKTdixnVj82CTMBgbkwecN4JTbQ4vemNSUTE9aCHkc	1405	849	73	1	6301	jxjrxsr4Too6AadteX6NdsXmDXTn3unRkuwTtGEDc8XYjW3uScF	3528	4976	4976	1616834880000	canonical
6824	3NKAdpfW3sXZTNff7fnrmMWNkEb3Tehbn2ifQzSLVQZommff7zMN	6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	1668	1370	74	1	6301	jxrChM783uBe1wxdMC6cfne53xhPV3AHTd2bqKm9G1CwkDJSrV7	3533	4983	4983	1616836140000	canonical
6822	3NLhHKeMJeJiD1YPq6SjyvpAHvThz2Ufwtt4fTby1dSbeF9r5KCQ	6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	1501	1234	74	1	6301	jwZyYREbupTGpp9qyGWorYKLmAwjjwm7KzXxfuUHFSMNHJtNpQj	3533	4983	4983	1616836140000	orphaned
9456	3NLT7R18w8yjNb3ZdK1aWtgwm4dLyEFM6oPc8TuVe5BWqQaYvdPj	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	43	1064	119	1	6301	jxCBwDbrwTpaAVX2kq5sTuh44Hk4n3WRcADSDE8ckhzX2TCJbmR	4902	6906	6906	1617182280000	orphaned
6724	3NLSBFxTFxm7EfrER33kKaWuu5qqg75Akpz6YS6xEuZjAtwzNXKB	6721	3NKDdUkEJGLhBoUy7sKs7yKsdUEkrBm9jMayFeGEAEP4kDtQZNPz	1523	581	72	1	6301	jxKbLjPBWj1N2HS173iUKVLhcHEQFjKgxdKuiKi8MrJTQSxijCG	3479	4916	4916	1616824080000	canonical
6729	3NLU3xbRqB1JtP1o4ZQ2Vs3X4o9JrGMqv5ZjvMvSJRhA5P9JH1z6	6727	3NLAyCVXE7PPXzXxn5M3aPecmHfNkToK6Qz9kr3zy6qtkN2Xsf3d	1553	776	72	1	6301	jxyEYzCrCuCHEBuLZjEje7BcbH5LPxpDLydDVKSC9mr8VSnDZaX	3482	4919	4919	1616824620000	canonical
6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	1646	988	72	1	6301	jwbAeRDRpXP6vMFteznMzefQNY3KbEK23gJHs9vdK5dBQ6NvtSQ	3485	4923	4923	1616825340000	canonical
6736	3NKgSGua5ue2xP6GoFrspPa6V2NtiH3tHkiNiJGSXoMAcvgPqCz3	6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	1549	1362	72	1	6301	jwBNKKdAXm8n2F8XBBNYa1FEwPQTRWK7b4zRkTKeVmLbpMshyiQ	3486	4924	4924	1616825520000	orphaned
6745	3NLxrJyRhKBp4eUU3Qw1DoyMBjAnhzNeRdGbvYC6Nv3zpEmMvn5p	6743	3NK6t2d44NJeV6atr3gCTiF1mE7WxPeShqgeSbuhmd9MU8viUtBy	1536	1313	72	1	6301	jxysbFVWMMNXGtRne4tzBropwfggtzdFDhqdSSXptMhwRCEjFLx	3490	4928	4928	1616826240000	canonical
6748	3NKRAeDs8m2KHx2ZLx2PLDYJWQLrF3HwHxAuMRUAY9AU35Yxrpht	6747	3NKBvHRRrLfrit16rEFtS3otXTNuoi8sUvab5mCchef8gx5uCMMg	1508	1387	72	1	6301	jx7MapMvVP1bFiYRWNiWf2NzWUyoXyFqRCrH9LsMFpcPTKfz2rd	3493	4932	4932	1616826960000	canonical
6753	3NKEt6bdboj4iXSk26oihXXdz67JiEygGd7NcHUbUgd12CVcidm3	6751	3NKfrQ9xdtkp6AXbE1UEkmZhdRprqqCNwHJuJcoPXsENFGHajCqy	1403	824	72	1	6301	jwpmWmz8dTtVMLzzy6HKwr5PTwooW4kKAjSf31mEXcy8JamX3KL	3496	4935	4935	1616827500000	canonical
6755	3NKun55Vmv3VLwaqqR3mt8qcEscWvnP2MyXsMbnLJuasbBpXghY9	6753	3NKEt6bdboj4iXSk26oihXXdz67JiEygGd7NcHUbUgd12CVcidm3	1403	824	72	1	6301	jxGmgm9Lzcov4L8CVEewESnZbmWLd728QKNS2wqJ858BaGM3Peq	3497	4936	4936	1616827680000	orphaned
6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	6769	3NLNc5XQYUpWx7KbzfwRaUADA33c4xitxsFjKq3UwSgkoxDtjwgC	1489	1254	73	1	6301	jxQGr5wRL6SDZEoQvsPddYabPPyrVxDEEEyYamgTbFMvjTyHb9g	3505	4947	4947	1616829660000	canonical
6772	3NKUxybSQQYzAzKJN64FUahEgEYpTvAJNzJM9MsjX11hDJmhhGZV	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	1609	1333	73	1	6301	jwT9sdCKzDbt814ie9Cwwg1DmYGoZaYNVxcNRmEDLHxsu6qESrD	3506	4948	4948	1616829840000	orphaned
6779	3NKhF5siCyYbewognVco9ugPaXAThWPE1MzuXqcJgSm2hWmxMGKT	6778	3NLMK8wgSSPovGtA5VArL3AWPQTCcCGTH1vcLNzqufdnUw8vK9NE	1549	1362	73	1	6301	jxFSGzdokkBTiGtNVo9VUYimpLGMuH4sieJt97VyNwj45HY6RY9	3510	4952	4952	1616830560000	canonical
6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	6783	3NKnVun43o2AZP6fCmTUrnHb98MZ7YScPD7Qdgw7UAMDnt7eqWNr	1455	1086	73	1	6301	jw9Cmf9hhTMCZRzE6T4JJXxNf1k5aKtbUcdWUB8wyWYyaL35q44	3513	4955	4955	1616831100000	canonical
6789	3NKpwyokanRuCnaLacz8RSk27vz5gna1GYAWQ6xDE6JaCTbawFUA	6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	1541	1172	73	1	6301	jwGqP1fdU4gGy28yqkVeBEhY7ir2uFHou5cRdXphFMDxpxcYPCe	3515	4958	4958	1616831640000	orphaned
6791	3NKp2ZwMJEesYaa3B4wfrCB3Hh1mS68Xky5YsVbSuG6QQfLP2noF	6788	3NKgTXsWadewBgtCqESCtyFAQca1FrDNWwoua9GjhCNBdDmSDR81	58	1281	73	1	6301	jwReV5i4ABT3C9JHDzu51sYQFgSRTZZdr41ztvz4wVMGhv9r1B1	3516	4960	4960	1616832000000	canonical
6796	3NK81jNbWX1wmMN9g7tmeNLUuG8GyNPW4ktvVWpvBXXvxk1XJAdj	6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	171	1128	73	1	6301	jwt35ZRvAG3hu2ZnJT7qebvKdo527g2zarVoe5XYAiJFdeYZh9M	3518	4962	4962	1616832360000	orphaned
6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	6798	3NKbuFUhMtVYbKoxyVGWeYtFk6EVUd4Dd9KeY4te9bKZKk9NXVKX	1471	151	73	1	6301	jxnLsPuSKF42C34j9dW8o2QeMh23qwASYjR1JD7x2eRzK5K5mej	3521	4967	4967	1616833260000	canonical
6802	3NLjMEgeSGBDcvbjrKSJV5HvvekcRic8iCot9YxafuJeJh6EsLqi	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	532	1057	73	1	6301	jwKV89DLfytzciPhxD8gHxpdsn8FBZ1evsiEj8HZH9xnfe495y6	3522	4968	4968	1616833440000	orphaned
6806	3NL6v2MV9Qcx7qCcp5gfFGoV8PRQxeD8U8Fzp57LrLMJbKGobSc1	6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	1553	776	73	1	6301	jxri4Wtw8nYJBt1cQgz3KpRAY6fF1V1Cr8YQhHrmV2vPcRGkB85	3523	4969	4969	1616833620000	orphaned
6808	3NLg1cSNtpG1HysDbiruF2xasNmEeFrsDvw9MJ3WfnujiHXwQtUf	6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	1593	1100	73	1	6301	jx5NAKXr3CKwz24YCufA8Bt3bJfw5ES2YqzJo9te7JBMS2QY6cg	3524	4971	4971	1616833980000	canonical
6815	3NLtUPGo9bJax9BQfkP9h49zpK4tFBXSYMP1owMFFHtzxxFLATZz	6813	3NKSNHfFcqLKTdixnVj82CTMBgbkwecN4JTbQ4vemNSUTE9aCHkc	1403	786	73	1	6301	jw9jQKQtAWA9YL98ab5nxT4R1JZ2y5A2q1ediubyU47n6JoFUB7	3528	4976	4976	1616834880000	orphaned
6820	3NLUsMXEtcoXmDDVbtUq3tctEDEKA8jRXphjZ3wcAtRs12RxCMgm	6818	3NKCp91cm4fUuxq9dqAtzJczkLaqnLE1XqLSqBiUkitWWcfe8gam	1406	1393	73	1	6301	jwH7JjzJR46WgomYNrfoUTqCU3rWFcT1p3MkyP3rvbWUABoTrSV	3531	4979	4979	1616835420000	canonical
6823	3NLbm6F3VnnXw1bTdkfDwxfjSg5t3FNSzpe96rfmpy2cdq8iypuQ	6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	1549	1116	74	1	6301	jwCeSA9AavDGcqgi5DnjR1HbQ8m95izN9AmffRaqbhBnDHrrLw4	3533	4983	4983	1616836140000	orphaned
6825	3NKSFdEAib5qXRbyCmJ1PNcnXSjn9kRUvtFBJPEzx2vRRM6rDgcf	6824	3NKAdpfW3sXZTNff7fnrmMWNkEb3Tehbn2ifQzSLVQZommff7zMN	700	840	74	1	6301	jxamNyhEymLHuhFEUjCQtLxWvCdFAxeLkVU3tJupDCYxfTECvrM	3534	4984	4984	1616836320000	orphaned
6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	6826	3NL8P9CStP7x7hBFaEi1mvqRFy1oynfjvoVEeW8aaMiYEQc3kzcD	1542	1304	74	1	6301	jwLrKGvcB29min5TeUV4z9iYSRCeHzSjXrxuybFCr9dcSACoaa5	3535	4988	4988	1616837040000	canonical
6830	3NLui6YnNTDvAS8tQQxFvrFgqSJJ3JMr3U7MziHxftcLVjeHpfbB	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1578	930	74	1	6301	jxLUj658kMPu9kF6uYhem7ovqVGyQzUWQwt3PErcPLZeYxw3PSr	3536	4989	4989	1616837220000	orphaned
6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	6831	3NKcp9CAhajYR3X6aJaNSds7j2mRyZwYhRKerWX1gztdRVthrtbn	1611	1095	74	1	6301	jwWTCpG7KuvTcrXMiQbuceAnf5USWSPnZivs6Hd4jWqAPGKKmeo	3537	4990	4990	1616837400000	canonical
6835	3NKb7WhLYGHewQGZfwBWWkn8d9QwH5dEHucT6zvdoitQvRFxPZ26	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1402	906	74	1	6301	jxTRRVLViHV1XnH8b52aM487Jp9y7hThsBPn5TsXsTK7ydMrENi	3538	4991	4991	1616837580000	orphaned
6842	3NLhbtLQHmUwGaqjiRM3t8YgcVAwqf2CvN8vDN9woeT9bTPq7AH2	6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	1405	867	74	1	6301	jwaNvu6guACKuNAkCSdgcBzSW552oUBDmMWaM7XRZr7xSojWfdF	3540	4994	4994	1616838120000	orphaned
6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	6843	3NLoyNRsLdumszjhMRHNFjx6zLPbchsHsiS7oUkZkFmuHQY6fQ4t	1406	1393	74	1	6301	jxBZUFCpX6whoLanuSvif25yeqetLic3qmP9XPjJZT9s4yLTcrD	3541	4995	4995	1616838300000	canonical
9459	3NLaNYd7kL4QXSL5QUhED9uARb6C1B5xDfxLAs2RpKJYpirrSFDM	9455	3NKqcT1vHr4V22JvwZbm1Q7nrYZrqZuT8fjypjscLwHQCKrWCjQp	1637	816	119	1	6301	jwXx2Cg7CkwdVVUPhiauC4SENuHX9yuhVoXVpwCLnv21kiCEDPg	4904	6907	6907	1617182460000	canonical
6780	3NKjyWymBLm4rmDKyEHaELE8k6pGDgk17kA2G62Z1cn71qqjgLFC	6720	3NK5pERoyog1nZZaKGyFCVok64W4iMsE2jej1NmcHQJqMmX5DAVS	1481	789	68	1	6301	jx1aqDD8Rnq5F4eNzENedivvBquZEiH1U4w93QkZvxgTVZbyZax	3391	4953	4953	1616830740000	orphaned
6735	3NL8J8Nd24YQvJdS8ovDXhYunjyzVH5pMeW76BzKsoXxC6r3DkZb	6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	1406	1393	72	1	6301	jwJj99Yj47UVw3VoLK7YPJ5jpgghP7Df1t3Rkx7EZsfZhYTJSQm	3485	4923	4923	1616825340000	orphaned
6737	3NKzmNYHArqLxygDgBAv6XBNsW336tCYsxu1TS1dyi8egEW8jFFa	6734	3NKpYKXpdYuW7RKZedcYkxWFAyR7cV9qyPFL8xCvaWPy9p4Hk7U5	1406	1393	72	1	6301	jx8fMmGGsTvng7tG78rspMYu7wtKFJQR3BRFoKBfatnnBGdJFkz	3486	4924	4924	1616825520000	orphaned
6739	3NKUQhUfmTuf6mZCaQKo9mRNnKhQCozgLbqfuNHHbjTZ8isu6fwq	6738	3NLbkxiDmx6iEt5LkiFxk6cVt1kQhfUzPgdwJthQD5Ua9h56qiu7	1651	1301	72	1	6301	jxLS3MwoSQY9y2fbz1vhBRt6xpuFCizUtk3j1itdn6BCdJycx3T	3487	4925	4925	1616825700000	orphaned
6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	6740	3NL9XF1qKZDtWPVbpZixYdfLXA4xn1dCk8usxTSmdbs58VPtkup5	1407	1395	72	1	6301	jxLvoyyaAn6FymqXLTmphTRo16bFTQEDsE46N4xBeDXofjE5Ydx	3488	4926	4926	1616825880000	canonical
6744	3NKbsc96d65ge3Vweq4kE2FLrz5BiTLYVioajK4Wr8qyKhcjuUcu	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	526	648	72	1	6301	jwtcAoquWWdeLLcw7tDYDVjqsYKkkoead7SJdHGQRjiFbxokBEU	3489	4927	4927	1616826060000	orphaned
6746	3NLRo2dirWiNCEz7bA24sGsrKyw9p9iiXcH4jAYRQ9C12L2VKEW8	6745	3NLxrJyRhKBp4eUU3Qw1DoyMBjAnhzNeRdGbvYC6Nv3zpEmMvn5p	1406	1393	72	1	6301	jxN4Xu7yfVrHmZfSk3XgSeVLeojtE3Lc64pVNEsBrotHEPtF3Ee	3491	4929	4929	1616826420000	canonical
6749	3NKDfEjBnBsyAjZV2ENucfA8DxjH2KcCPxgTzuFAjPNPYbPL2tUz	6747	3NKBvHRRrLfrit16rEFtS3otXTNuoi8sUvab5mCchef8gx5uCMMg	344	344	72	1	6301	jwMnMPP5C4KfZWVCob6wXjq9pYg6MfPkdHBgDtDvFstpTjd1y83	3493	4932	4932	1616826960000	orphaned
6751	3NKfrQ9xdtkp6AXbE1UEkmZhdRprqqCNwHJuJcoPXsENFGHajCqy	6750	3NLkwUr94YJpYPf84jzW2Ve3bQorFKHhu544CvrA7uizweQn4QhG	1644	544	72	1	6301	jxrxXPr37cwfSCfNTDh5oW9jGSTxm6NfW62JMg2238vUTtZgyrU	3495	4934	4934	1616827320000	canonical
6754	3NKWDoQK1wPGSfem2fHQsxra4jHwa2i9TnJSpjGvmwpEZuCzKb6R	6751	3NKfrQ9xdtkp6AXbE1UEkmZhdRprqqCNwHJuJcoPXsENFGHajCqy	152	1084	72	1	6301	jwkzDVCcgsC9ZEX7CnAEvyeHRYZZfbMBnzV75458c5d49pvaT1N	3496	4935	4935	1616827500000	orphaned
6756	3NKvYEK3ksoHkH6mW1wd9EhDyP1CgbbDtVyWnjjq19JWxXa78Fh2	6753	3NKEt6bdboj4iXSk26oihXXdz67JiEygGd7NcHUbUgd12CVcidm3	1406	1393	72	1	6301	jxFLPeaToixthzNyjdyxTHPsMVtwjgTnPkHDa9s9JcEwYdwHfsm	3497	4936	4936	1616827680000	canonical
6758	3NLgHn2bAyf18QVLEhdxmjZSv9zVGVtpARQCAhJWqzRXHho8pbkj	6756	3NKvYEK3ksoHkH6mW1wd9EhDyP1CgbbDtVyWnjjq19JWxXa78Fh2	1405	869	72	1	6301	jwDV5fBc48AwDtj6nVUZs7eUAHdZtuiTLyJtTRMWySHs12MqEWH	3498	4937	4937	1616827860000	orphaned
6759	3NKkjQhz7L59w6gpvmykhMUeAPcufr8FQf3Y88ZKbqgY4iVpXaMn	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	484	953	72	1	6301	jxxgEnvvciJw57yFzHAz1fbgzXzCB7Xc2ogZSfs5uL6XWxuMEzk	3499	4941	4941	1616828580000	canonical
6761	3NLkN6mrs8v2JxPFJNwuPAPccdWndF6GHBwS3UXEzmEfecbTiEnD	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	1624	968	72	1	6301	jwdLhUYr3G9m3ebcqXBsT1mKRfhVmEHDWdFuQ2YE5Dhzr7PqMgM	3499	4941	4941	1616828580000	orphaned
6763	3NLZA9cYW8PAgoC54JR9Pf6TTJ68N6oYGDq8MAuVFstNXuPQ2VgU	6759	3NKkjQhz7L59w6gpvmykhMUeAPcufr8FQf3Y88ZKbqgY4iVpXaMn	44	1325	72	1	6301	jwbZLSAbhafPAuTHBaP1ZpVpFH3yGUtBYAxDkHVJLr7XNS1F3VY	3500	4942	4942	1616828760000	canonical
6768	3NLiFAZg5B5zQa4j89nybjsFHo6HVwjUxyvz41CQ1xcptFamMmJD	6767	3NKd3pLVrgT9iJqE8wqsspFwEQpjDpwKNF73Z3naQWuBSrDGghkp	1455	1206	72	1	6301	jwDq6GR7ZtJqVmSwbqyZbjH9MfYTKLjcjf6qNNzRy5Y8pJMsr3t	3504	4946	4946	1616829480000	orphaned
6773	3NKBYSGWoF3zCWBLgEpvagFRLDTGsVh65L5cLwMMXkmRgr14vJz6	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	1407	1395	73	1	6301	jxP3psB4nUw73KMBbfLCnwrcwcavtev5pXo4pAw5gHdKKvH7Nf4	3506	4948	4948	1616829840000	canonical
6775	3NKTEduFQ1JXxfwYhfZ5kgGGJrRvvqyHJJrd4wVPYMZz5eukY8Jy	6770	3NLZXbtUt7yvqKJXwEeuNY8QC6vfSNK8ijbrRUSCLRg85dhaJ1eC	1573	952	73	1	6301	jwGu3aaMpj5chJExAAjzyc8yCiiWqkXjNrmLBhHUqtewRYtfw4C	3506	4948	4948	1616829840000	orphaned
6777	3NLkoMuMvzqp7uxMtyupqocRQcs9aLTghj25hV44aCJJjgGCCrKp	6776	3NLkp7nLTDNVcFyUNNcv4xCN8R3jMiegnKXbgsqHxs32VWHVQRJS	1406	1393	73	1	6301	jwz9Lx718R5bNVy6Vep9VZRhnWzq2jJKGzZNBhvSJCvK6qRqrbY	3508	4950	4950	1616830200000	canonical
6782	3NL32DJeuL5Fyo4K8wyDjH9CB2Rf8mBqJK2WmRrNqSwNr4ciLCXp	6781	3NKpjK4TSUF4bgctJFgNvLVyfYDz8bk3rhcDRQm4HjSG4MeSawgq	1403	782	73	1	6301	jwSoUpSdf2ok3GqyYD5NBfkLijiHArhS9y6j6e2baeinQTW1s12	3512	4954	4954	1616830920000	orphaned
6794	3NLnbxzFCCwyy6WGJtyTkSFtnq3tKC1qVaAjh1bFhTrqMk61aBy8	6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	1609	1333	73	1	6301	jxv2R4j8wChK7wENM82UsQtocqbN3V9inhd7kawaVFXN3YYgSGW	3518	4962	4962	1616832360000	orphaned
6797	3NKCbPkkWscVt8Qbyaj7KJuqJBxMXwbw4gnDRVgbbnFM2bgZMVGU	6795	3NLu9oADixjutZtYKdteBr6tBpzs5Z5N4PS3HYnFCNXGc1iF4KFw	1637	816	73	1	6301	jwCZ1pp8T4vXBegUyRRmsFT3JWgcTeBhWYgT5tPNkPEhDpiK97Y	3519	4965	4965	1616832900000	canonical
6804	3NKCtAZVoLE92ZWHgKR3keE5LxJJN3kNfwGdxGJLTNmExeDwevps	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	1634	1205	73	1	6301	jwZMW6hZLrKpibzwDyhWvnqiPKW8apJ55b5tHQ2jCzVDkWoJUWy	3522	4968	4968	1616833440000	orphaned
6809	3NKVvPbXuFyYzXpjuXc1JL94iMiSQ6pciUZ2yqUH45PTr5x752Ty	6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	1608	1163	73	1	6301	jxoNkah1XWBT6qeADjzaJ4Y5MrsywDUN799wqDjmEZjnJPJbAiQ	3524	4971	4971	1616833980000	orphaned
6813	3NKSNHfFcqLKTdixnVj82CTMBgbkwecN4JTbQ4vemNSUTE9aCHkc	6812	3NLLDNRCzhM4xFLiZTgr7VJiVcgL6bTzuxeiNwB8r2nvnzi6rKYc	1585	1000	73	1	6301	jwzHWzGL4LvyHh2K8di6kccwP2HwQ8EeJeXE46VPuYV7a5BfWxg	3527	4974	4974	1616834520000	canonical
6818	3NKCp91cm4fUuxq9dqAtzJczkLaqnLE1XqLSqBiUkitWWcfe8gam	6817	3NLCYrbjBUDWoyuqPZAsBogUaxBcQkpjUpVyBTxdpFjhtGSa2Z69	1675	1342	73	1	6301	jxkPXJmgn7vNbZ2R3z5bvvVgsMvx2BjJFAUfyakkX4QBEwrBJJh	3530	4978	4978	1616835240000	canonical
6821	3NKW56c8MYdHycwCizogMdNpLFHP377txtpwa23AsZZzWX3eyaze	6820	3NLUsMXEtcoXmDDVbtUq3tctEDEKA8jRXphjZ3wcAtRs12RxCMgm	1673	1002	74	1	6301	jxHvSnmoWxjXK9CeQHmuhWB3HVxjLKHkw1vHTmc8rDuZAkTKG36	3532	4982	4982	1616835960000	canonical
6829	3NKyqAmaXFzC5yad1ZFwFKz6K3ebwBTDpL9Y5EowV5AMiPLkQPaB	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1649	1383	74	1	6301	jxPwggyUiFzrcfybUzkcE1Qic8LX2dZDhQVg5NY957qbWVrCXnY	3536	4989	4989	1616837220000	orphaned
6851	3NLC5GRckhpEWBoZtCjpRdX9gjUoEji3MGNr6wK95cBvBXuRMMam	6847	3NKcqZD2sU7fnWb5pdHLj1Nn4AZxwYURR5ZM9THdPciEM3UwBQu4	470	1183	74	1	6301	jxf1dGewLMe9TG9JqdMmpkLbeEw3ARWVhsVAXz7UmePgDDTwZr4	3543	4999	4999	1616839020000	canonical
9466	3NLZLvKTE3DXkL6vQ1iKcJXccYeTuqhGhXJ6mjUSC4CVdf1cGFcx	9465	3NK7rMehm2oFF9ijK85XspS5T6PH8LXfGLUHYA8BeWM25hbzdVeq	1406	1393	119	1	6301	jwF8NVfFMhDe4mPJWY4vPVi36jpSGx4qfscNMcVfwnckxiiSeDg	4908	6912	6912	1617183360000	canonical
9927	3NLY3LbrSsNCUF7b8Rzn2UW4iJxrjbUws5b4KjeoD89A8PnKJFH9	9925	3NK4wiefJojFtNS7G7pTuoQ9Tv49QDyYXWiNd3iDPuguQZvg1aGN	1594	1200	130	6301	6430	jx7YMkepuXxvECd5umb1KvmrzXbwe6vZ6wNez2LYgCj9vPHrP4J	5152	7246	7246	1617243480000	canonical
6750	3NLkwUr94YJpYPf84jzW2Ve3bQorFKHhu544CvrA7uizweQn4QhG	6748	3NKRAeDs8m2KHx2ZLx2PLDYJWQLrF3HwHxAuMRUAY9AU35Yxrpht	1402	868	72	1	6301	jx5f6TzymaEhTuwLzycNgxzj2AVS5aWqcuRJQryqrA6m28GiXJW	3494	4933	4933	1616827140000	canonical
6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	6756	3NKvYEK3ksoHkH6mW1wd9EhDyP1CgbbDtVyWnjjq19JWxXa78Fh2	1503	1277	72	1	6301	jwPDoXJDDVeaAStFyvXsgYqeJnLrGxc8ScX5HqDbc3eX3o4iYn7	3498	4937	4937	1616827860000	canonical
6760	3NKLcxpk5X7ExtQLubyGRLMY3ieSK228Fa1Dys9wjqVgCUSEdbv4	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	1672	1159	72	1	6301	jxc5YewaLvuznhLV5Md6mgbCKPXHD9WZ3brt1LyGUNVKtDzmk4D	3499	4941	4941	1616828580000	orphaned
6762	3NKo11apRgwGH4yQkUr99p9NBn1PUF1RRnHJSeBBpWbQVcTbUnNz	6759	3NKkjQhz7L59w6gpvmykhMUeAPcufr8FQf3Y88ZKbqgY4iVpXaMn	1406	1393	72	1	6301	jwDiPb4stwbtuC2BdkXVHXxAuY6qr1Dri6F7tYoJ8NQyvKCxQuT	3500	4942	4942	1616828760000	orphaned
6767	3NKd3pLVrgT9iJqE8wqsspFwEQpjDpwKNF73Z3naQWuBSrDGghkp	6766	3NLfLnBSCJsuyPZjyHtE6SJZeuYExwkS2YndQddQ2s54LQjuzy1L	1403	824	72	1	6301	jwqPAqEWsFoy19FHG522MQV6Em4Lz4Sfy2JWonaLk9qwqkSmuvE	3503	4945	4945	1616829300000	canonical
6776	3NLkp7nLTDNVcFyUNNcv4xCN8R3jMiegnKXbgsqHxs32VWHVQRJS	6773	3NKBYSGWoF3zCWBLgEpvagFRLDTGsVh65L5cLwMMXkmRgr14vJz6	1499	515	73	1	6301	jwwevAw5pyfQwCs55QYKcPUJrXyH2Cx4aiqme8LNdfnRpqG9sYU	3507	4949	4949	1616830020000	canonical
6781	3NKpjK4TSUF4bgctJFgNvLVyfYDz8bk3rhcDRQm4HjSG4MeSawgq	6779	3NKhF5siCyYbewognVco9ugPaXAThWPE1MzuXqcJgSm2hWmxMGKT	1483	146	73	1	6301	jwxE9QSBsZmFf4uyzjAgg2wu1enZAL5f1uuJxYsoTaLm6mGPVTQ	3511	4953	4953	1616830740000	canonical
6787	3NKFfkCidmBZ7rcH9izWAAADE8UM9CXrFZzJmjhWaoVnFZABM4h3	6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	1599	1287	73	1	6301	jwRZUMsdWTWjbsVNSfz3LFprKZHtoLSNC67WJPGtBGCRBHX3ocU	3514	4957	4957	1616831460000	orphaned
6790	3NLxrDmCaGhTmfwPkFKfWNYWuvWLoRC8Bg38GLhUdndTqWqfHMwd	6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	1631	794	73	1	6301	jxeBWfaS2HgQWS8LL6Ypyu9XA1FkrBVED39Foe2KbbnophQ6NR1	3515	4958	4958	1616831640000	orphaned
6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	6791	3NKp2ZwMJEesYaa3B4wfrCB3Hh1mS68Xky5YsVbSuG6QQfLP2noF	1483	452	73	1	6301	jx8dHNWunzijsLHZMe2w5usyWwxt5U1fqpU8Vk8RjQoJq88AStD	3517	4961	4961	1616832180000	canonical
6795	3NLu9oADixjutZtYKdteBr6tBpzs5Z5N4PS3HYnFCNXGc1iF4KFw	6793	3NLgUC1kgU4S1bfL3UhatFshja9Lr4rK1xj2E6t86NJHfqpdkMCx	1553	776	73	1	6301	jxxBFXKMdPZ6Jv9VbKUnjpCDzPaNcA2VEoSy1k2izhtjLRBpo9m	3518	4962	4962	1616832360000	canonical
6798	3NKbuFUhMtVYbKoxyVGWeYtFk6EVUd4Dd9KeY4te9bKZKk9NXVKX	6797	3NKCbPkkWscVt8Qbyaj7KJuqJBxMXwbw4gnDRVgbbnFM2bgZMVGU	1406	1393	73	1	6301	jx9qVbv3UReL5Wp19GGKwtkLEYJCtBdUzD9NsNTFdjcsrQZh6Cf	3520	4966	4966	1616833080000	canonical
6801	3NLPzbU9HYAbXT8LpR7kQXudEcDTbU9ugNiv1gSXxPsGFadfgSHy	6799	3NKfdatDVM2ZmGiqTEHSFobZPcYqt65hdcCXMVydDpbjntgWbsaV	532	1057	73	1	6301	jwFaUHtV3z3PWwCMN5qXMShAMLr3bfzmEnsZDiD5GR9veZCX33p	3522	4968	4968	1616833440000	orphaned
6807	3NLHzqxtxPCxzeVvytkacojLddUTSXiKRqYTRd8os7JdyPuKxmF9	6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	1508	1141	73	1	6301	jwkSvdhpEygmpLkfFhts9S77nBojDngGKvhuxcq3WVdvuqwXi2F	3523	4969	4969	1616833620000	canonical
6805	3NKk5M3z5qFxXMW72tbkfDVwQgaw9z1FagD79Acg4x7y1VdQbDSh	6800	3NKLqW4p6V59cipbNWdRtjXn2iyV2YXQebiUne7uYUUkHg66GCGH	1637	816	73	1	6301	jxWLccTneM7jT8fQUAjsZm7XVMWd6eLvBSwPJRsaiRCX6G1jh7T	3523	4969	4969	1616833620000	orphaned
6812	3NLLDNRCzhM4xFLiZTgr7VJiVcgL6bTzuxeiNwB8r2nvnzi6rKYc	6811	3NL5CffW1QhnjzA26vTucwNjLPSbD7YhqXPxbxZihVZH7VTZTkTQ	1553	776	73	1	6301	jxKahAkMjsEcNWoVn2KPTMjLUvuzn3UguXWbApNHfM1BYhRXjRM	3526	4973	4973	1616834340000	canonical
6817	3NLCYrbjBUDWoyuqPZAsBogUaxBcQkpjUpVyBTxdpFjhtGSa2Z69	6816	3NKbshwMTpVPmvGXRNUqYMF86HqhfxkgjY4P4bP6b8uHa23cMqKg	1590	1300	73	1	6301	jwK2VvKpfJBK98J9QCtMt3wHfbtyBB4vHru8RBg8o64fAkqCCnq	3529	4977	4977	1616835060000	canonical
6819	3NKVtRGvjmh2vV5fuwWvGgEvyG54jep36LkgUXzqiDcDPnfpz41k	6817	3NLCYrbjBUDWoyuqPZAsBogUaxBcQkpjUpVyBTxdpFjhtGSa2Z69	1633	1390	73	1	6301	jxfbw2x3arg8FvhWXSjK1RWwiMepcjhyG65UV9e6Wzp5AApPsMF	3530	4978	4978	1616835240000	orphaned
6828	3NKXgM8oTMBD9mGo4Y2nf6462MQzCGVa7Nuh7TfbsUiaMDovthDR	6826	3NL8P9CStP7x7hBFaEi1mvqRFy1oynfjvoVEeW8aaMiYEQc3kzcD	1419	814	74	1	6301	jwVeUmndzaeQ96NGramNoP4Tn8ZtRiuFXs1vtATFnut5eusSbnH	3535	4988	4988	1616837040000	orphaned
6831	3NKcp9CAhajYR3X6aJaNSds7j2mRyZwYhRKerWX1gztdRVthrtbn	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1407	1395	74	1	6301	jwazL1hq9iAtb1uzUmr8cno6utcwYyCy2sX8jn7VFmXMr57a5kH	3536	4989	4989	1616837220000	canonical
6832	3NKyzwwgcYKxYAow4iXd5nrbantNq4SdaxMf6E1sdJxZboZoJrmh	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1541	1298	74	1	6301	jxspR5XdkC7zoa3zSbj4rrrRAujLib9aqv6Aqt9mwhuXRpThfse	3536	4989	4989	1616837220000	orphaned
6837	3NKMffZ1QmwEEZz7uW4bHh1fZ1gjN1Dgmrwd5aCdwRX3khGj9Vu7	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1622	1110	74	1	6301	jxdLN3xg2NHrv7DjDMc4oYbf3EHycE8FqyH2RrwAdsuAEDFoqgL	3538	4991	4991	1616837580000	canonical
6836	3NKPfqUGfH9a19xaUWjUynXxDVxrv5GeCCGeK5cTWjmNRf3sAZge	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1602	1123	74	1	6301	jx2buVZiEsMWDmZ6YU9BpCkAtTNM55bX2pgtYy2z152Lm4KfT5j	3538	4991	4991	1616837580000	orphaned
6839	3NLTSRunxAMRAhDo89g3C7H8yMEetdE5FDA5LTHjXWepjEmMnt5F	6837	3NKMffZ1QmwEEZz7uW4bHh1fZ1gjN1Dgmrwd5aCdwRX3khGj9Vu7	1403	824	74	1	6301	jwxp5duZ45iZmM3sK6GMiSR1zjgJN36d1DCJCyhZT43qtbSBU6h	3539	4993	4993	1616837940000	orphaned
6843	3NLoyNRsLdumszjhMRHNFjx6zLPbchsHsiS7oUkZkFmuHQY6fQ4t	6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	1483	660	74	1	6301	jxxjqFvAktuKZZ5SUuhK9ARpqPc3w4zivdmEnSe8EHTqPfQt4QT	3540	4994	4994	1616838120000	canonical
6841	3NLSQLeie7ZGgw7g6s2cN17XPrgrsyrqBwRzqVLhREgDpw8TTJ4w	6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	1483	660	74	1	6301	jwii5u1Z8TfsuY9GEAfJYPt67tDNGzzww9oJSrRzfQANkVgD5YR	3540	4994	4994	1616838120000	orphaned
6846	3NLbVufR6wvnV5GXFB21w6oDWvefLE6bESHuZ2toZ3i8xyJi6Ev7	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	43	1310	74	1	6301	jwqMrbdEfRSBMjt671r9fRWrjaD7qxcWGNTpLuuYiNFy5vZxmBi	3542	4998	4998	1616838840000	orphaned
6855	3NKj56QwjgvHZGnd8sTuiaEgxdHMhUocJrQ22tbkzzarB7TGcZrR	6853	3NLW7qDtCum1caMxc2SC9uFnEpi7cPmrG7MGmSuDedfLxZzSKo2b	1553	776	74	1	6301	jxzVxuv5gKi6uFcLVoARFFqsnfuvGEkWjV2qLdykhLuPTE2wmax	3545	5002	5002	1616839560000	orphaned
9471	3NLCbHZvackZkr3V3iSr2PgNpx3mbGdSk27Gzj5wEKXpphRj64am	9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	1624	1334	119	1	6301	jwzUkZRdMymWoUSpsq18RSr3P6SUs5MnWrNd6dvtAe4gJkns2LD	4911	6917	6917	1617184260000	canonical
9941	3NLKDvQJ5dh7dPmr7Xm5XbFV3iF7afK3w7rfmmdZXkr3NcKf8LKQ	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1407	1395	130	6301	6443	jwXuutjsaeEFcXLe1QJH7bgquz4N6tprWFXQAJ3JBgkKWodh6FV	5159	7254	7254	1617244920000	orphaned
10112	3NKnm3CCxzUn4eSoVet4wBGaYqdJnYnm41ZRFwVDFkQYNXrR94hv	10038	3NLNPHyFQjEwD1RfrnkXqczRwyw1o1ZwRFDPQ2oiqNowTjXc1C26	1646	1354	133	6301	6602	jwpizkyhfcuNRpAT7eYbRyZUPvrDzoeoY3Hb5ZXYtAUj9NupNbA	5209	7384	7384	1617268320000	orphaned
10102	3NKTbP1n21KZtji1AL2a1zE8iHqNWzyERYFnwaYNjST4EVimSsaU	10101	3NKvSpqHwT5EfhjdQSBLfwZ9eBEUPKvzbZZTnn6eyRU5B2CnbrMt	1406	1393	135	6301	6592	jy2MZdJhcQoB6E7aLQHzoFPYJTxmrAcPkjPUeuW4szYZHUSqiRp	5241	7378	7378	1617267240000	canonical
10149	3NK5xKhGcvJzdhtzr38isFzqYXcn6fB4FTeRTt2xtDjx1F5Q2kQs	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1553	776	136	6301	6635	jxUw9KEDeu5Ys8BmERZ6YsyCSRAxLrcvBYXHSD1dRG9GqoWi8BE	5261	7407	7407	1617272460000	orphaned
10184	3NKevPNmiysDqrT1Lqkw7AUGzd5vY3BMDAqAFxTVBUwLkgguifsL	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1508	1141	136	6301	6662	jxZgN3W9DF9kuWcZTjKSG9HazZwhFagzjFwLRdamD1gtziSZGYE	5275	7422	7422	1617275160000	orphaned
6838	3NKYtp13WEZkqQCZmUSnEE9L6DgSZGbvW8RyA3m81qNH9VwDqzfo	6834	3NLqxScFSF9JFeWDRRKsDiJ1vJkpv2y1sown2f5hBo39asft8iB9	1549	1236	74	1	6301	jy2C3QJZYd4oLrobMCeGdqQ5UUtTrrmy2shiZjpGk2yKG75RjX5	3538	4991	4991	1616837580000	orphaned
6840	3NKLybXwUaBXknkZwFC3MP4UsMiBQJWCgWCFidcYNXcaUuPf4BNi	6837	3NKMffZ1QmwEEZz7uW4bHh1fZ1gjN1Dgmrwd5aCdwRX3khGj9Vu7	1419	814	74	1	6301	jxmgTXVKgLzrzn2ywAi4uFDdQhpkp4RKpX1788zAhRrMfot1RhQ	3539	4993	4993	1616837940000	canonical
6847	3NKcqZD2sU7fnWb5pdHLj1Nn4AZxwYURR5ZM9THdPciEM3UwBQu4	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	1407	1395	74	1	6301	jwCNkr7sWzEWXZ73VXJCiJHkZz8w4SZ5xURugC9oKdfuDaHrgpq	3542	4998	4998	1616838840000	canonical
6845	3NKC97pMaURQQPzdgXksDCWhCLJVH6UdQj1ut5oo2uLyBbsXTRMS	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	1671	999	74	1	6301	jwv4uBq6wHp8YhJmkjN5mfuoRxW4ktfA16mxmih7H6xzEQxSxUA	3542	4998	4998	1616838840000	orphaned
6852	3NKhCrXFKHgXeADuBNzb1CxGJpxQXh58Nqmvi3MddBdZ2G5sFjcx	6847	3NKcqZD2sU7fnWb5pdHLj1Nn4AZxwYURR5ZM9THdPciEM3UwBQu4	470	1183	74	1	6301	jxepDfFhVmCrMfCxmfy8AbozP8c8xSMpQD5jT9rus7F5maPnJEb	3543	4999	4999	1616839020000	orphaned
6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	6853	3NLW7qDtCum1caMxc2SC9uFnEpi7cPmrG7MGmSuDedfLxZzSKo2b	58	1035	74	1	6301	jxVGoy5RHc2jELMhkqrJ4UWUPnfkzWcyADUt3LS6byPK9X37WKL	3545	5002	5002	1616839560000	canonical
6856	3NLq4YHiyu3r2TPZGyj7phzHRgx9F35wwg5kgkxP5B2wf3GaCJqh	6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	1649	1383	74	1	6301	jx6TauY7QzvXbEnBmm4uLKGBq5A6oVVVVuaWpEpKYFoMfkUk1Zk	3546	5006	5006	1616840280000	canonical
6857	3NKjeBdhewY58TDHGzJKYXHtNAAgfVQYVX81okK3nGkryfUkp3r1	6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	1405	861	74	1	6301	jwYtsiYyzWVUKya2VUmCkv8bZGvptWqnX59QJEXZqMmEnSkrEfR	3546	5006	5006	1616840280000	orphaned
6858	3NKbb7i41e7BnhudTbAgX1ZuZjzvJUcorgdZ14jWWDaT2Uetny6h	6856	3NLq4YHiyu3r2TPZGyj7phzHRgx9F35wwg5kgkxP5B2wf3GaCJqh	58	1281	74	1	6301	jxSg2vvppyQxAiZcCYpha7nuHfytdoWTVtoVBErgrpWnoDtWoU1	3547	5007	5007	1616840460000	canonical
6859	3NKNoyFpqvGGS2iS6KxxLSWJERXdEXS7aMLmpyoVjgH4qgnTEmW4	6856	3NLq4YHiyu3r2TPZGyj7phzHRgx9F35wwg5kgkxP5B2wf3GaCJqh	1668	1244	74	1	6301	jx5QyUuPyty7TmdSuKacqHxsyK1bvEUkfueLTXME64DdND4eg2A	3547	5007	5007	1616840460000	orphaned
6860	3NKKTFjpmAdczJV2Rv3vMsYWDLGvzmKrCyT3k52dkZytrUPgbyzX	6858	3NKbb7i41e7BnhudTbAgX1ZuZjzvJUcorgdZ14jWWDaT2Uetny6h	1500	1051	74	1	6301	jxq1S3UgS8tAJBkNNVHv9mZKtXcxFNBLjX5HDbxeJRXjYVxouPD	3548	5008	5008	1616840640000	canonical
6861	3NKVBSip9LeYqeiioA8Viab8bjhtXdjjvwQWKmTKKddtVnXSjSmr	6858	3NKbb7i41e7BnhudTbAgX1ZuZjzvJUcorgdZ14jWWDaT2Uetny6h	1407	1395	74	1	6301	jxi4wbqSySUrKYdYfNTBMPn5hturWAf6yy1qpFFw5J1PJQwPmyw	3548	5008	5008	1616840640000	orphaned
6862	3NKD1VHPSk3FJDkaakSrLoZxcRqXGVWYcRLSkjhyRk8PWyM5bQVt	6860	3NKKTFjpmAdczJV2Rv3vMsYWDLGvzmKrCyT3k52dkZytrUPgbyzX	1406	1393	74	1	6301	jwXrmAvZSGz95TmVpQUSLkr22PqjvxuNwk8n8Zr89PFcK8qa7M2	3549	5010	5010	1616841000000	canonical
6863	3NKPHeGXPb7Puqy9gZgV8sgLJVWVYFN59a9E7V8ptLM9Gc8UYaLk	6862	3NKD1VHPSk3FJDkaakSrLoZxcRqXGVWYcRLSkjhyRk8PWyM5bQVt	1403	824	74	1	6301	jwbBqgpMBFpy4yWaSHkDbLdNZP3b55Qu6Gf3FWvEQmHip8Nn9bt	3550	5011	5011	1616841180000	canonical
6864	3NKKkd7vaYeGAdiTzMEX5mGCazTDuN7RhhkDESsdsqsUKxktQAfk	6863	3NKPHeGXPb7Puqy9gZgV8sgLJVWVYFN59a9E7V8ptLM9Gc8UYaLk	1675	1096	74	1	6301	jwWCp2jKXc8NpaBUWcnZrdshs3H9X7wskjRYEuTyN7kqWGqRv4D	3551	5013	5013	1616841540000	canonical
6865	3NL91bgZFhEcza1zPkLKThSj34mjqojpzfggUjLsb1Y9sEeEVkUb	6863	3NKPHeGXPb7Puqy9gZgV8sgLJVWVYFN59a9E7V8ptLM9Gc8UYaLk	1406	1393	74	1	6301	jxrNxhvTJRZREacSfujYzAiicNhQC3UXjjPCeifxXd1pYQPPe3C	3551	5013	5013	1616841540000	orphaned
6867	3NLejBKqKCYnDfE9yhaYor6dhtCipSWwG1k2AgTgxyJYcdyNj5nf	6864	3NKKkd7vaYeGAdiTzMEX5mGCazTDuN7RhhkDESsdsqsUKxktQAfk	1406	1393	74	1	6301	jwTjZHnrS28CxrTSkZ9P8SktZHg927bh6g31J4ajG8zMTomQjpq	3552	5014	5014	1616841720000	canonical
6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	6867	3NLejBKqKCYnDfE9yhaYor6dhtCipSWwG1k2AgTgxyJYcdyNj5nf	1405	875	74	1	6301	jwjvtGZ2PmxD2B6vgpxEYs3q5pngmMw1sMGxt32G7QYx8AQi4pn	3553	5017	5017	1616842260000	canonical
6872	3NK6XzqsYgYx9o7qCWpesvnKxBAX3vF7vdUfWf4s7es4cVqns4po	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1523	955	74	1	6301	jx9Qr77USa78JJr69Q7w3tQAHAf21uqEe9dV1pETfeH8dp2jPH9	3554	5018	5018	1616842440000	canonical
6869	3NKRnfKCKuyEGHLP31aUrPgLThqQhy1aVqR3yVVtGQ2CD8B1m3Cw	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1523	955	74	1	6301	jxJHQ3w5odhQ6HRnGEhN1bjV7F2jmjRXYupxJTuKGqNF5f2ZFam	3554	5018	5018	1616842440000	orphaned
6870	3NKpsapfeUqArezhgyeyZHhNNNwJGjjPe37d8HK3rP7dz8X62dSC	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1397	828	74	1	6301	jx1h7kAuDcQCmjCFU4fKTJ6hhp4LL6iV2npA7ehYqhiXWTHsDdN	3554	5018	5018	1616842440000	orphaned
6876	3NLeohMy1sKCvpxRjn8f1eGKMDmQoyxbDZGAKWVep7PTQdyHgWHt	6872	3NK6XzqsYgYx9o7qCWpesvnKxBAX3vF7vdUfWf4s7es4cVqns4po	1460	476	75	1	6301	jwCRpgwkBFwdeejvvxk7Dj5t529JSrGW4s2wmMAfuBNeuYgGmZF	3555	5019	5019	1616842620000	canonical
6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	6876	3NLeohMy1sKCvpxRjn8f1eGKMDmQoyxbDZGAKWVep7PTQdyHgWHt	1406	1393	75	1	6301	jwncLTKkdBADcUAZVxovD5bsBfT3enXfE7d8yf7GqznELcZk5Pd	3556	5020	5020	1616842800000	canonical
6879	3NLwrPE5CyU4YWJXMzv7Zh9MWYv83RR5qWhDrGmsRkQAzmY7Kdyg	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1654	1340	75	1	6301	jwH1nMQScfDr6e6M5D5hNRuZsSEbVB9ajWDeEAmAPRUErqxJdTf	3557	5022	5022	1616843160000	orphaned
6880	3NLYxMPmsNjdarpjnoFuNAihFftE2dNTyPZnF3DAde9AAsREf8sQ	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1654	1340	75	1	6301	jxZegcj5ubgG3bzT9w46Vw5Y2wMGrfXTjGTQB1ddx5jVG8SVB7j	3557	5022	5022	1616843160000	orphaned
9498	3NKwmRr4bvAFxh6E5qSZjX5knotmXCmWnMQwMk5VGNzUG5yLUKqA	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1581	778	120	1	6301	jx7UMd4BCDVaFczPKc8gBEy2UbXh2gMomX6tJiX3dc999JTxpW1	4926	6936	6936	1617187680000	orphaned
6881	3NK8bZZiF1NwuDV5YEYaUsdL3NhPiGDcA2N7jnh5EwsTC5ZjWuqq	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1523	1075	75	1	6301	jwgimPtkpc5WAXbY7eUT3xGmkLx9Wkgg3oSLU4L9ZPDBdpWLMjY	3557	5022	5022	1616843160000	orphaned
6888	3NKMMdJ5khaKVq8gsWSHazqhSDBkrmNNnUcM9GA6gQWwNs4ERgtU	6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	1585	1366	75	1	6301	jwa3q2Rkb8rcy9B1q4JX13XcZV4jsADeSMbffvDS1RRhvEtW4e2	3558	5023	5023	1616843340000	orphaned
6893	3NKnfEVGVmbB45BPwc6JhFSJzp8qmf74FBf39LKNg5DchpEmdtn1	6891	3NLeYi8TmUz8nW6kgRE3fM3jBNbvrZt9d6g4d1mtofzrBUypuEyZ	1564	1212	75	1	6301	jwfk2Sy184idmv4UbcviWZN6TukYsgA42f1q3fPe67NLSD6edw4	3561	5027	5027	1616844060000	orphaned
6895	3NL5t5DZdaY3xVvvTjAHwXWVzU95R3xQpxB91azLubuAJUrphvM3	6892	3NLumyPEsC2cxX88E3Kw69FciHAz9WSDNYfPZ7u7eLRV4AfbNQLY	1457	1145	75	1	6301	jwxjqnbwrwkrgtVxTv8vzYV1YJwdfwpRrgLRznrrPsDoVwWpiZJ	3562	5029	5029	1616844420000	canonical
6900	3NKwyyKfbRxFuMB8iryBqAuo9mPofjw3cLuGEQ3V8QGD2ib7mdMv	6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	1637	816	75	1	6301	jxh7PjnFodJPWAzyAH8dteVZEGK2biG5Wd2WZm5s13qfvtJeQQg	3565	5032	5032	1616844960000	orphaned
6902	3NLqxvGpWNuRdcze6QN9yEWc8mygPPSD3eApGwiCkB2zRT9Sr8tq	6901	3NLAboqyq64uDwKXsdGYZJ72FaEnywvH7ELTpDoovckLfmLv1Dza	700	700	75	1	6301	jxYNzvcA31bt3smfmvx8myrxQpYMZeaUnFiYQ8kuoXXk5ds7fS6	3566	5033	5033	1616845140000	orphaned
6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	6905	3NKxWaD6dYGTitCz9XF4DB5zLbDw3GZa4KaxMigsLHiYh6cp1HRx	1461	1271	75	1	6301	jwrQAXj73bhwZCmUoA4mb35SRyFmzsGH2mbcfGJEppT2A4cV5Ff	3569	5037	5037	1616845860000	canonical
6912	3NLizAF6EykRkyqXbvscvFsVsEjwxG2VsMx85DYbyYm5d8V2kxx5	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	369	1312	75	1	6301	jwQM5ieePL7yvKSJHv34AGs6FUiqXi3avreFmEWHyeN4H5DjxUy	3570	5038	5038	1616846040000	canonical
6909	3NKp8mAnXuSaTguNKAaf8yNubxPgQLDeM7jveozUcwfdT3GJorVi	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	369	1312	75	1	6301	jwBMpK3mrLKNeyDu8x5ciQ3BPmXJKsVHJatWvf4trsmJWH5DyuT	3570	5038	5038	1616846040000	orphaned
6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1624	1334	75	1	6301	jwSVnZ4q8bJSox9P9MPdXEqHnWQPfWeHeaWNgiEfMPQ8Zy9rTG2	3572	5040	5040	1616846400000	canonical
6918	3NK8sVB3F7pKGkhBDi5qvSGHhY7HujyUrVyGWoTyvLKSBcV3AMr8	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1579	1143	75	1	6301	jwgSYdGefmAYJqbSr8Uy4AYVxZaNd2FxCVwavY62LUJA6EdqDyU	3572	5040	5040	1616846400000	orphaned
6922	3NLZpgiKzimqY2UR3EC6hNdVAXNrecqsrvNe36ddVn4ToRcry5Ts	6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	1637	816	75	1	6301	jwDBMzSiFL1HUWqHWomJ5Dg6rUQhKorHUendjaNg4mwGNffBmFY	3573	5042	5042	1616846760000	canonical
6941	3NL6DMjitK44s9XEkU7L998PdUmaANTVLnNTSdnHoyf9ZTgYTmgJ	6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	43	1310	76	1	6301	jwvjrJ8xXxzbrVCZEo6wQEfXvetEwpRftCH4h1QBEgjd7iKZm5x	3583	5054	5054	1616848920000	canonical
6946	3NKXnLt8qsppsFjFPP6dch9bbSnbG8udGuCwLNf8NXSPTuBvY9m4	6945	3NLnsZKRHULF8FWVNaJrbhND83MvGrcH9WsDTmvrUkEVy5R9uo4Y	1637	816	76	1	6301	jwf6CoJz4uMQ6krCr91RdTR8NUwH1wVYoLybLyNvQMHXLR8ewYa	3585	5057	5057	1616849460000	orphaned
6951	3NLD5XFvnu9pjYsDRmNiY485tYYtLjP6SZYFZBvVXf4a5YCGe6jb	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	643	643	76	1	6301	jwdRDfUCrSURUKBmrPX6kJUW6HL6SMPpH6tS8JpSVbPLshRQXpX	3587	5061	5061	1616850180000	canonical
6955	3NKW4whSt2qKDqzm9vey14SeyeZBbUmXC35EHTb2Uuko1xpV8D53	6951	3NLD5XFvnu9pjYsDRmNiY485tYYtLjP6SZYFZBvVXf4a5YCGe6jb	1407	1395	76	1	6301	jxbfnLg4sSCAhyW9TxYMqpLXydLPYPrF2pdRQ15E3uNp7javZCs	3588	5062	5062	1616850360000	canonical
6962	3NLmUjRMCRoNPxdAHSAhUbgfGH7dp4NK4VbjYJZyjdFcPGZEmbPB	6958	3NLmvmRxEz9NgBLpM3aoPuz1zCDvQqXj7EMP5d8MhA9hcDc5Q2YY	1670	916	76	1	6301	jxfm77myKy3ixPcSjFHb4YbJwjyEmT12uG32ASxoUr2nBhf9XTm	3591	5065	5065	1616850900000	canonical
6967	3NKh3XGiLbU6CAzuWwKt7VtWfm9GvUq1zwXThKuyRJ8j6buUAA51	6965	3NL8opFeidy2LutgRVNRLDfQ8CfnHTcZJRmzNq8tSmy2Gzfeo1ig	1637	816	76	1	6301	jwJzsadoprhj23HnwBBeH3MztZ5RMyTEMVkvFKP5tEeLRHTZjK2	3594	5068	5068	1616851440000	orphaned
6969	3NK4vTGdNzsFSEeCPHrYFQD8ijDHQyS3cVh6urHnfVBH1ZwbC2ze	6968	3NLLv7ffjTCksVQetgxaqdyq4stH7B7ytpGfdEaXR6Yzcb9CtiNW	1406	1393	76	1	6301	jx3TcNFpbqKzZgq2nMDQnwrhNHNU46sxErUdQdAwABH8fb5fste	3596	5070	5070	1616851800000	canonical
6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	6969	3NK4vTGdNzsFSEeCPHrYFQD8ijDHQyS3cVh6urHnfVBH1ZwbC2ze	80	1027	76	1	6301	jxh3VynugdsAECRZ2kZ7KghG4LQUS5i22t1g8xEETdHPjcYpvSn	3597	5074	5074	1616852520000	canonical
6974	3NL1zDfSrZ7fgdcNtWT9zVDxuZMhz9vwMk4xXKL8LKo4pSFsM4p9	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1407	1395	76	1	6301	jx63Ju5NUgcyoa4zZG56EJGeo3A2XpdNkvE3pT6C5kPF8eEtBvM	3598	5075	5075	1616852700000	orphaned
6977	3NLySt69yKvQRWVYeZgbGLxhw13iUUCtSiDWYKo5ZV8TkeEUoGM4	6971	3NLfZWkGwCwD5kYMU6kFTgN9ZLoWehBeV8iDXLbDwuoojnAGZmsp	1639	250	76	1	6301	jxPNcNyLgGemy8kcfCj2pzg87aBENk8YfitLeNepFQXYsfZPDw5	3599	5076	5076	1616852880000	orphaned
6979	3NKAnjzFYQGyWSCUegZvgsWYF87CbdEqG5Ug8c8sXGbfSG7RLBGc	6978	3NLGQsFLvESFLtBeTjpBnf2izhmjhMkPWbnpQjSgRT23hfxFrwyw	1506	598	76	1	6301	jwzuw9XN9p8BjZbccxDAmZ97QybAXfS4fS5KaqNRBrb8KaofiDh	3601	5078	5078	1616853240000	orphaned
6987	3NKdyugaSZXthNaSfweQJzy3PtiGJnwu8UmbPhbwa6MsbUwpLXf9	6986	3NL7KoXUutPAcuPQ2HKtDkGuYZDMCutppKTKXmkn2Y2tZCvhF65Q	1406	1393	76	1	6301	jwvJomFpPmJWgKncYWV8rqmEJ68toKCntAdZguwmhLnDGBUKCD7	3607	5086	5086	1616854680000	canonical
6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	6989	3NLwovkvSCHDDaNhPBErmdwLMJiCxPVhsyH62BUTymkYvYL2D9XK	1673	1368	76	1	6301	jy1SMr7sy9QAsforJoPzNJaUdZRbFEXfgyGMdYqVe9fXxaXBo6w	3609	5089	5089	1616855220000	canonical
6994	3NLAAxReS4jXuz2CxiXsUsf58ZGeyjNyhBxZff57eD4uMwno6wBa	6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	1644	544	77	1	6301	jx4fBBUxNuoGzANSe7zxXNReWsPjfCcT5Jj89ATxrB3hj8rBQck	3610	5093	5093	1616855940000	canonical
6995	3NK39xn3mdtHTNtSSdu74fLWF8VvNfEK4ANxabStbYb7ZLzwV2Mf	6994	3NLAAxReS4jXuz2CxiXsUsf58ZGeyjNyhBxZff57eD4uMwno6wBa	1403	824	77	1	6301	jx7red1XuiRjyEGvgpN9rCYpD54tca8zN1mHGKrgMNdBpLXxiRH	3611	5094	5094	1616856120000	orphaned
7000	3NLHiLvk32jDEmdVC5Xv4JNUQuPBfFbha4fhVRefwsgM4qhAWTXq	6997	3NLcB4oEVh7aLgFkvESqLpzxt7UggBSJKGGbEWArPbJnGk4wBNxM	311	1307	77	1	6301	jwdP8ZfkUZmav86RWUa9ZF8K8FTHxC2HCoSscXCLeLHFSKcMAha	3613	5096	5096	1616856480000	orphaned
7006	3NKNqBRcXUz7PQZqWjKAiT4r87ECkUs2oNAAxnpQHtGymQBwvRHv	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	596	1306	77	1	6301	jwFcpxrp3xWrZR69XuG7bH46oM9KT4A5oMVrd5Ev89f3nyafRdT	3614	5097	5097	1616856660000	orphaned
9504	3NKbsuSVHhg1Y2UrsrDG9RPFzkE6XqsGPeVtsbPuxYsBsazaNQjg	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1407	1395	120	1	6301	jwjjdZSbkwSC8BUx8fAjX9Vgihm6H7E2cQoc8rxeNA5ZV5pJBhS	4929	6940	6940	1617188400000	orphaned
6932	3NKfRkJD3JkRmX4YUGD7kbicssAxCorPUk4JaXekbbk7WLwHJEon	6705	3NKJTMAhMQGc4mpR8uJR4HkzgVFBFXwHCo1ADrBTG9X15cM9Fdjv	1406	1393	71	1	6301	jwodXhxB1UfDos9JdiXw7fULfDnFxUF9trXWpsk7i3aAi3v1dHv	3468	5048	5048	1616847840000	orphaned
6882	3NKerzmAf9LQQET1dt7BrzNdzRcBLdFs3EMvpyGAJEL1ZDm29QXK	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1523	1075	75	1	6301	jxn7fLL7NGGhjdf8xxEjSKPXHFEAYCV1b498EJ1FRy3rU2Lwa1G	3557	5022	5022	1616843160000	orphaned
6886	3NLc3y43Vztzzh3zJJrdJxvYnt7WgaMgfaYrhup1fpQyc9EbGtD4	6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	1403	824	75	1	6301	jxHpLVzBmoaNyFzgrZm3f4rcx6rzCnVXZYa6d5FqJfUp2ZCX7qg	3558	5023	5023	1616843340000	orphaned
6890	3NLMGrHJ789hai5p2f4R7zocXEWHBGjWbyN6XN1qgyzVFkdC5Cqr	6887	3NKU44rd9gTnZieBjwDjCCkh4EV3CtD1ZBW2rPCozwb8zLaP83t3	1406	1393	75	1	6301	jxaimxZCwTecQa7Y2yYWMbjUqbicMnwYLxGAdwzfe1yuUtg15HG	3559	5024	5024	1616843520000	canonical
6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	6896	3NKKqN1X9awF8vuvvCgXHdKFeM2ZtAjNYSnKYkJErR1SteD8A9BJ	44	959	75	1	6301	jwrWM3ukSRRq1BL3jgVQ7MZZ4uQ1uVf4uQcCECvboyyCeg4chDH	3564	5031	5031	1616844780000	canonical
6905	3NKxWaD6dYGTitCz9XF4DB5zLbDw3GZa4KaxMigsLHiYh6cp1HRx	6904	3NKYx2eU7niHyAuMuCKSjpro9y2SjtVAMqKif74tXLuyq2wCaQf3	1402	882	75	1	6301	jxpXReebAQdcsZNSLdivwSMUYniVqSaEizqMaziqYjVmcLB5BpE	3568	5036	5036	1616845680000	canonical
6910	3NKPE1VDet954Nj678k1Keb75Ctxr7Erp6AZGQqipcpdVMY4e77A	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	1403	31	75	1	6301	jwL3fHd9V2ySs13KghrJBtkzBxGEGCz4aG8uSqqPStfaY6FkgPv	3570	5038	5038	1616846040000	orphaned
6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	6912	3NLizAF6EykRkyqXbvscvFsVsEjwxG2VsMx85DYbyYm5d8V2kxx5	1406	1393	75	1	6301	jxMMD1spZCMAsQHjjrtr3k1hn1XmSta4D2kCyrDSzkgjT7FMp7k	3571	5039	5039	1616846220000	canonical
6916	3NLbd1i6AbQvJm4qsqkW3Wk4pQXbbVyMbW6bxpvHF7cpd1g6JDhH	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1523	1321	75	1	6301	jx1dAPcDkkRqr4Ns8R8oPVncJQZLZi6WWWxPV2sZLkXqW9VCBFg	3572	5040	5040	1616846400000	orphaned
6923	3NKbnGHpTcUxauGfuBx71f5RecbakivaBrUk8wXgihdfFWaeZ9Ph	6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	1483	893	75	1	6301	jxzFUbNT95nhBzgWGnHzJsGhgsNMVzDCKdFLQ46z9ipbSDsxhRQ	3573	5042	5042	1616846760000	orphaned
6925	3NLu7tw2K9YEB2ajrM8D63aKDgbS8Cn5JwrMf4eMSSkC9z5JvAFC	6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	1542	1304	75	1	6301	jxg1MCFoHWcVwPUejvfEHut2zZquQxx2goX8adEzVvr3a48kouV	3575	5044	5044	1616847120000	canonical
6927	3NK8mbWPv9v5wNYHDokGshuh1eYs7zreuy7ertFVy23jdHzzgWQX	6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	1652	1189	75	1	6301	jxKj127pxfpUVHtnFAdgYKssKmjS9zLjRzkaRV6T4UQrifLDfVN	3575	5044	5044	1616847120000	orphaned
6930	3NK4Veyk6b3JKCiboFZzSSMQrpETH6Y7AmdN5qDS7uNitDzd3W4U	6928	3NKYq22K6L4U2NSdRzHwzToLadGMk1XNohvverjR21YQVh4yjGGd	1403	812	75	1	6301	jx6o6kuUYPFkbjQtM2n1x7YTp43wYV5Mp7hnSVgRcD3d5aWwrUa	3577	5047	5047	1616847660000	orphaned
6934	3NLfVj9gq9p6my3CcYY4zWd7rNHSTqHiV7sEaspXSokjP67PoXsA	6931	3NL49iEm62rVwrL9hJ89A61vS6i5egyuviZxR7beDT2yg9Tf62tc	1419	814	75	1	6301	jxAzS7hiyVGxfbFG3GNgGvKXMCkGZX5t97TPHLRT7TAtkEjwGFy	3578	5048	5048	1616847840000	canonical
6939	3NLmPT19h4vnLe5acZVYYpaWNzYSTNg1ahJ4Wk5jHqdHtUiYNBeJ	6938	3NL2b6HQn5BKWaBk3mCrPehfsEwg4pbzgik6mN6vLw87WBmMe7Bi	1622	1356	75	1	6301	jxocL8g9gLgNc2pHXrSkw9Q8WUTvR5Xmc1PDxpJQbQWYUym3MW2	3581	5052	5052	1616848560000	canonical
6942	3NKAA7x4jSDQMsgMDpLoJnY7X7WRvQnnpQAcdvJjzFAq3henDsYr	6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	1541	1298	76	1	6301	jxtXGV9LcUwitBT8TUb7m1d25Yo1rY3czEuniVA313dTNhHq5yP	3583	5054	5054	1616848920000	orphaned
6947	3NLY4ECy1ngRMGpyHFtwH34dpHnMrkVuxtBnFdwP5zJ6UErTp4Ps	6945	3NLnsZKRHULF8FWVNaJrbhND83MvGrcH9WsDTmvrUkEVy5R9uo4Y	1402	874	76	1	6301	jxaanDWGgoe2RFuv5rWaVa2yNftEQRn2PAujx3dQPqoTbPnRTcw	3585	5057	5057	1616849460000	canonical
6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	6947	3NLY4ECy1ngRMGpyHFtwH34dpHnMrkVuxtBnFdwP5zJ6UErTp4Ps	1623	839	76	1	6301	jxtud6c86hadic2aWJmNDcwKYw6DaWyzcTjv9ianJjxdWLoKoSr	3586	5058	5058	1616849640000	canonical
6952	3NKfFU1nZKBgmNZbR1pV7taaWcD1ZFFcDvJEmkEHUhxZsVe7jE7o	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	1407	1395	76	1	6301	jx8sxZ5as9WDnoPEx99URCzusK3mxXCZa5AQhej7NCcKEHS5pe2	3587	5061	5061	1616850180000	orphaned
6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	6955	3NKW4whSt2qKDqzm9vey14SeyeZBbUmXC35EHTb2Uuko1xpV8D53	58	1281	76	1	6301	jxbF8TKxaNZeVcg8oQopqyVUucj2wx8CKfjMeRL9he1hZtYY2Lg	3589	5063	5063	1616850540000	canonical
6958	3NLmvmRxEz9NgBLpM3aoPuz1zCDvQqXj7EMP5d8MhA9hcDc5Q2YY	6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	42	1361	76	1	6301	jwMdt9ReDSZJRHUpLZ5MikXp1XUJsvGWBM8bAEJ9ryPLiQjqtHR	3590	5064	5064	1616850720000	canonical
6963	3NK9WfiJBqozSVF6XdzpJqrRUFez1iGjcU7DYwY8rqVrERJLo3fB	6962	3NLmUjRMCRoNPxdAHSAhUbgfGH7dp4NK4VbjYJZyjdFcPGZEmbPB	1590	1174	76	1	6301	jxKTYJYjDCT1ucdyEFBY569XHtV4rp8nMvFqXgwAxRLSwxqeiud	3592	5066	5066	1616851080000	orphaned
6965	3NL8opFeidy2LutgRVNRLDfQ8CfnHTcZJRmzNq8tSmy2Gzfeo1ig	6964	3NL3hLYgS9J7e3Y7f6y1vW4DrTjNa1C7ESYjCYJwJuvvPCYAWDYe	1642	1367	76	1	6301	jxmWjarhc68ZsSAaBja22ogJh1GBrf8tmp6wjkxzpvYpHVcDyCn	3593	5067	5067	1616851260000	canonical
6971	3NLfZWkGwCwD5kYMU6kFTgN9ZLoWehBeV8iDXLbDwuoojnAGZmsp	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1406	1393	76	1	6301	jwSyPj573Jn83BX3MYym1KjZfSvYv9zgKTgWNbkayVTC7Hk98Jh	3598	5075	5075	1616852700000	canonical
6975	3NLx1Sy7N4XFbU6aadj1K5wXeNwphmthPMGLnHk9hx6Aw3Pbgu9t	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1617	1288	76	1	6301	jxoUrbCKsP1k64nLK99XWnHepkCj2rnkBnbhaXQ5VFdiKPQ7J4f	3598	5075	5075	1616852700000	orphaned
6982	3NL78UnkftL7gxQtNR2L4FJLrTTU5XzE21DWXL9wT8wH4FAbTYUn	6980	3NKYHEYJhAwGpi7XHFCzgmwQxhEGRYTFVk9RvDjakH3bfR8LbasA	1631	794	76	1	6301	jx4tBNWtjRRVf2XE5gi5ZZwfanYvQ5c36iFV97TVHopVxdMfvBq	3602	5080	5080	1616853600000	orphaned
6985	3NKyopB1QmtDDVtAp8sVXnmwitjQdzULMnp3Aka9aHgo7bn2Rxsz	6984	3NLJ3EaJo8BcKQkF6a6b1yHDeKL4fkGmoFZ1yWfYYscSZcwLJeE7	470	1309	76	1	6301	jx78JFd8kPCcahSHaCwDzjNHEaRVtyNxe9rc4HorS3UNJwTDrt3	3605	5084	5084	1616854320000	canonical
6988	3NKmuZQpZLFNYAvfyqeoZBU6CXhmbaNqsh6yPfiQq9sy2hZ2iCeH	6986	3NL7KoXUutPAcuPQ2HKtDkGuYZDMCutppKTKXmkn2Y2tZCvhF65Q	1553	776	76	1	6301	jxkJ4Ymmv6GP5k3NpRjePpVgjRAoQB1AG59zL2WL5TxufmsxoBN	3607	5086	5086	1616854680000	orphaned
6991	3NLcv6MudpiHZM1B3B7uns5Atm52ttRHKx3Qnjh1s3uhGychdYmb	6989	3NLwovkvSCHDDaNhPBErmdwLMJiCxPVhsyH62BUTymkYvYL2D9XK	1675	1096	76	1	6301	jxvTKfSwcedFGedSQgs2EcH9pHsH6TUDRSh6b9p5Axx7NsDumRK	3609	5089	5089	1616855220000	orphaned
9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	9530	3NLF9mJqXX52EHkyyTBSVDFdfpv8i82jedxB6WY51eAyFYgK2JUM	1447	1219	121	1	6301	jxGM8AbchZgyt76BcV5KgLMCfEaaR4oGNsULxqYNjoAAs5ZyV4D	4943	6958	6958	1617191640000	canonical
6897	3NLhPoNsa8aPC2UVzM6juqhrFkNwr1oCgdUgaJxuwVpj6S75iT35	6894	3NLswoPtQQAheysxfnTzHAuXh1BVcqFJmLtf4VKHVCVCgUjtYX31	1581	778	67	1	6290	jxZX84uFCFAvyFtRfLJ25gcPx5M6vsrHd2UBbSk6pBWy3YYyMT2	3372	5030	5030	1616844600000	orphaned
6933	3NKFiFkuabU7zc3DXAEy29c4cDfLBM8gGcYNFQD2Hnhaz9r5wVuj	6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	1406	1393	72	1	6301	jx5SWSNHKMUuavhpY8EQ27wZ7UEMVJX17775uPcvwN3kBchpjrv	3478	5048	5048	1616847875135	orphaned
6936	3NLrTHiovaXLCHELPpY5E5PsPhmzUkaHrSFEE6Cme3jNPDfXFA6T	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	1406	1393	72	1	6301	jwPPkcKwACWcjV1PoUQDoiGxBakMCxrZ2Ws24DcsL6AZSbdjXJn	3499	5048	5048	1616847945468	orphaned
6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1523	1075	75	1	6301	jx7ao3JnoGopTz5Ve5L3HDg4dF4TCW1imgtRCCw9nmCabsyMkCY	3557	5022	5022	1616843160000	canonical
6884	3NKEcKiSxiZoP5pMyE9RhPjtEYiL8Fh3BkGwKj1i2jGtfgMiPKb4	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1577	1081	75	1	6301	jxQxUn21V3o4Sretu2N8acK27yptokkdN9f6TbP7QWT5D7Svdhm	3557	5022	5022	1616843160000	orphaned
6892	3NLumyPEsC2cxX88E3Kw69FciHAz9WSDNYfPZ7u7eLRV4AfbNQLY	6891	3NLeYi8TmUz8nW6kgRE3fM3jBNbvrZt9d6g4d1mtofzrBUypuEyZ	1405	851	75	1	6301	jxBBj6KZbxMzuLRXNT58TEqkRdcXw4Yp8JSYwKGcLTkV8FnCjDy	3561	5027	5027	1616844060000	canonical
6899	3NLYFA4nUy2c1pG1WohzwjWCR5p6Gu2qEBVHPXBkgrDeEq1Exy5Q	6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	1402	858	75	1	6301	jxZeKF46gHSWGZXHS5kfiFn4EBMVdiaH9xiGzFDaK4rWw4Ybmnz	3565	5032	5032	1616844960000	orphaned
6904	3NKYx2eU7niHyAuMuCKSjpro9y2SjtVAMqKif74tXLuyq2wCaQf3	6903	3NKU5fGmVcVV9HKNQRQ8tAvkXAQAtnvChPWQ1LqqLN1zGgk2hrKD	1546	1339	75	1	6301	jwwytWnQtUWWDf4BjKRiQQACsZX3PAjSZR3uKDm74w1TRrnVvzG	3567	5035	5035	1616845500000	canonical
6919	3NKNtcuBWQ1FYJgdDSJRaczsF2N8dyi47jNj2RGFZJ3gpZk2iqJ9	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1523	1321	75	1	6301	jwhm4AeBCAZvn1qoNJaKjndUDPfcEKGL5RN3xgR3G8a9vogjR3o	3572	5040	5040	1616846400000	orphaned
6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	6922	3NLZpgiKzimqY2UR3EC6hNdVAXNrecqsrvNe36ddVn4ToRcry5Ts	1406	1393	75	1	6301	jwaLgsKSdMJiDfEugyx4rdpAhAZQzAFqy4SzecxUL9QJfLtJNo8	3574	5043	5043	1616846940000	canonical
6929	3NKgaEdzHANkTRLZR88GVbRxneuF1VEU46iRggqonQFCTt7iGQaD	6925	3NLu7tw2K9YEB2ajrM8D63aKDgbS8Cn5JwrMf4eMSSkC9z5JvAFC	1503	1151	75	1	6301	jxVDb4VeA2w79mTMutYaWGm5ATu9jQXQkZBvgPww9igonC1dYQt	3576	5045	5045	1616847300000	orphaned
6931	3NL49iEm62rVwrL9hJ89A61vS6i5egyuviZxR7beDT2yg9Tf62tc	6928	3NKYq22K6L4U2NSdRzHwzToLadGMk1XNohvverjR21YQVh4yjGGd	576	1109	75	1	6301	jxdKbdFNQ8tnERjiyFVpBKQNiFNsmMPKgWj9BYFhuEueLWfCjAQ	3577	5047	5047	1616847660000	canonical
6938	3NL2b6HQn5BKWaBk3mCrPehfsEwg4pbzgik6mN6vLw87WBmMe7Bi	6937	3NKdfjTYH4LxLwzramrVvHZmTmUmPaMoXg9P7DBiAJpfY6f34sea	1637	816	75	1	6301	jx2k2HS81dzn4p2JrbQGLQ6qKaKUMAN9sTJyK4m22L41Un8oH2E	3580	5051	5051	1616848380000	canonical
6943	3NKYqRLg5kpjjab7AhbRh7x98K6dkTVaipHbGJGQc9CmHRp6U1uM	6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	43	1310	76	1	6301	jxVE5pExEPfgcf9EoiCG4jMa9agPMTjixFQkwvHX1LoJW6A3uP5	3583	5054	5054	1616848920000	orphaned
6945	3NLnsZKRHULF8FWVNaJrbhND83MvGrcH9WsDTmvrUkEVy5R9uo4Y	6941	3NL6DMjitK44s9XEkU7L998PdUmaANTVLnNTSdnHoyf9ZTgYTmgJ	1448	945	76	1	6301	jxTLHXVAy8SUdgUbpfrxhgjNPC97mqasTRv7vjMmwHyKWanczFK	3584	5056	5056	1616849280000	canonical
6957	3NK76B7PTzeYWunYQ8g5kRyoMDuHp7YSG4MjtChFeznSGpxw84n9	6955	3NKW4whSt2qKDqzm9vey14SeyeZBbUmXC35EHTb2Uuko1xpV8D53	1598	543	76	1	6301	jxShPt43ewsyj1ZSdxCE21drfX6NU6S8xKCTiyhFy8Ha1jS6ptK	3589	5063	5063	1616850540000	orphaned
6960	3NLo5rw8grCNKWZGkApaH1fv4vHMawFFyjD9B6Uy81mDqqrBvtGW	6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	606	1295	76	1	6301	jxh5jCqB3m1mioJHBSRJMmoLehdhizRYUTeumeBHUxWoGu7UV84	3590	5064	5064	1616850720000	orphaned
6964	3NL3hLYgS9J7e3Y7f6y1vW4DrTjNa1C7ESYjCYJwJuvvPCYAWDYe	6962	3NLmUjRMCRoNPxdAHSAhUbgfGH7dp4NK4VbjYJZyjdFcPGZEmbPB	641	1336	76	1	6301	jwAZjPLHVPJ6LLkjHKowVfBnc2fdW83cXgzANMovVdkfx4W1fYR	3592	5066	5066	1616851080000	canonical
6966	3NLwtwSMxqgk8FU9HP8stKUC317p4APwGaLdsHtwtV1GnKeDsLr2	6965	3NL8opFeidy2LutgRVNRLDfQ8CfnHTcZJRmzNq8tSmy2Gzfeo1ig	684	1352	76	1	6301	jxiRVAgP7ZYZM1yLqB9j2mihiVU22jSQrAw3VWEBbkgyAjMEVJT	3594	5068	5068	1616851440000	canonical
6973	3NLvHTn4KGdix2hs1mzi2SyHm767uPQA77xx7CwH4iEzkhZbBuT3	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	58	1281	76	1	6301	jwQR2UoxFTxiF7L2Q7ZemPCjksnByJ3MVVEMAPybh2BpKtVJequ	3598	5075	5075	1616852700000	orphaned
6976	3NKRPbRm699y1rhosjAfB8zBk2jPe76ipJRqW6ke1gM1dSF2Sd2o	6971	3NLfZWkGwCwD5kYMU6kFTgN9ZLoWehBeV8iDXLbDwuoojnAGZmsp	1529	1190	76	1	6301	jwG1PxmCCdvhhRMTWjsFReeSjDyJstTjRvqr5kTgtgcZqcsU4uE	3599	5076	5076	1616852880000	canonical
6981	3NLnGyqn8wjhVi3Mn2TDCe2ATSHRPCVuMnpxazW42Jyz951gBKaF	6980	3NKYHEYJhAwGpi7XHFCzgmwQxhEGRYTFVk9RvDjakH3bfR8LbasA	1587	1111	76	1	6301	jxDjvxHgc7uV58xrDCaZk2brJ4BHMHVFYG5bkKtmVHt53jVs6Dk	3602	5080	5080	1616853600000	canonical
6984	3NLJ3EaJo8BcKQkF6a6b1yHDeKL4fkGmoFZ1yWfYYscSZcwLJeE7	6983	3NK5bRzxSKrwQ8LkcqQNcE3xbinCxTotr6iGhLzkZogHWTqbok6p	1507	914	76	1	6301	jxbVjiJHQizeRKpZd1h4y4LABcn3YSDqtcVJE4jsnJnYXJ5k4WC	3604	5083	5083	1616854140000	canonical
6989	3NLwovkvSCHDDaNhPBErmdwLMJiCxPVhsyH62BUTymkYvYL2D9XK	6987	3NKdyugaSZXthNaSfweQJzy3PtiGJnwu8UmbPhbwa6MsbUwpLXf9	1407	1395	76	1	6301	jwJF9cSkrL27gpkbjX389SA2heZA83gyNTmw2B2HTomPg8fsDH1	3608	5087	5087	1616854860000	canonical
6993	3NLgEminBPYqHa9nrgNXtpPx3asAwjN8zkVSrVKE7F8gC4EwFikf	6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	1644	544	77	1	6301	jx4fBBUxNuoGzANSe7zxXNReWsPjfCcT5Jj89ATxrB3hj8rBQck	3610	5093	5093	1616855940000	orphaned
6997	3NLcB4oEVh7aLgFkvESqLpzxt7UggBSJKGGbEWArPbJnGk4wBNxM	6996	3NLbpbXv2gRyuEWewpE3ws41FYEtj4cTsjV6HrPNNpv7Und9MCus	1670	1282	77	1	6301	jxdYM199qbhmWBxGAge1JdFjGLdhxP5NkmCu3rKGNhZ6jH4S7q8	3612	5095	5095	1616856300000	canonical
6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	6997	3NLcB4oEVh7aLgFkvESqLpzxt7UggBSJKGGbEWArPbJnGk4wBNxM	1637	816	77	1	6301	jwMcmkSLgg3yNdpBL5P4vAksbq1SQXYTUiKqTNKatB2mhbFpvUz	3613	5096	5096	1616856480000	canonical
7008	3NKk2qUZpWHwajeDohxnnu6zrvt5dYjue5UCACiN4oX7PaR7t9kt	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1649	1383	77	1	6301	jxUoHZGGuhyhFPf86vnW1JhCtRopCzHfvM7BXqZjSm1mjiqDrmh	3615	5099	5099	1616857020000	orphaned
7012	3NKqdBWgd3TNVyrM6QLRh3rLSBejv5S12ofkeX1Hoby3jDQy11qf	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1447	1345	77	1	6301	jxXpQGDVFp1ZXvrB2rfQ4RTefs86cAjNDQPNNyUKAzwZQDRfGv9	3616	5100	5100	1616857200000	orphaned
9546	3NLxGSSJQAr2orgbXixeEQnUc2P6oD4Sai5VtwbwXXjzRmJdBnbz	9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	1560	382	121	1	6301	jxd29WsbBuAYsamYixq2LzXmTbx5joPmWACSBe8tryfWbGatNCS	4950	6967	6967	1617193260000	orphaned
6948	3NLk7B3qroqqPJ1r9gdrqBEZ5g7DRwaeotNisWju65cp2F1XstNE	6944	3NKUmqbHoAcbe6bw32RfUk2WLfNd7wsHqcjbMDTbngzE2d4RoyYB	1581	777	67	1	6290	jxCQGbztscYAK67Rh84yK8bXNBRXSY5RJMxYRKBGWLVXtiJZkkt	3374	5057	5057	1616849460000	orphaned
7002	3NKkBm5RKAz91dTd8sWTa8HWf6drtH4VA5d8NrwMHaMhUmRDkctm	6733	3NLQnPeLHy7Qku5fcmydvev9jfBGeUcTLyFrDq7NaWLW1axi2dLc	311	1307	72	1	6301	jxrzjy4VNNs1yCnZXp681jm4ntnAxyWVRfSjgYgwKwn2XSooJ2Q	3485	5096	5096	1616856548677	orphaned
6935	3NLm8YgGn8T6Bgt8F9YVCdo2PNNugM4B6nzpdMN7eqHtCxu97GtW	6741	3NKnuBo9HPa7j6u7j8YaA9KhLW2hJG82uQnWehEnh2ixDa9RSeXV	1406	1393	72	1	6301	jxqvLc8FVVtveCqmY7e9QXi6hazBsEKLXupkoXoaDVxZsEFuUzX	3489	5048	5048	1616847910091	orphaned
7003	3NKy6YiNtcyzbb6EVp11CqTU63qUkA71irbXPGB7qEuMuwMCgBHR	6757	3NKUsTdRrJYjRyzuy5714VEWc4WHZfzBDFpz9EpCNGpwQRvWcFrn	311	1307	72	1	6301	jwGAeZrA6ZVFRXevfYEHjqhXN1GMwJBx7PqKBjPpWV2PicMsbfX	3499	5096	5096	1616856582178	orphaned
6887	3NKU44rd9gTnZieBjwDjCCkh4EV3CtD1ZBW2rPCozwb8zLaP83t3	6883	3NKvzdkoRNrbrcf3ZBTJ1HCP8nhn6ZEsEGEoAyQdv1vLQhE9div3	1402	870	75	1	6301	jxs1QG56ME2AHXsx2SAA56QHjkWZMsetEdP1HprEJW4zKx1hgvc	3558	5023	5023	1616843340000	canonical
6891	3NLeYi8TmUz8nW6kgRE3fM3jBNbvrZt9d6g4d1mtofzrBUypuEyZ	6890	3NLMGrHJ789hai5p2f4R7zocXEWHBGjWbyN6XN1qgyzVFkdC5Cqr	1406	1393	75	1	6301	jwYV59Ro7gKnc52vaigFTptt8YmSWUjwdoPkayaXbSYdk9Hprow	3560	5025	5025	1616843700000	canonical
6954	3NLHxnbxZzW5MbpisHSE1MSTDeS8WUgVqeJ4KfwqNy8CwzHtti2a	6890	3NLMGrHJ789hai5p2f4R7zocXEWHBGjWbyN6XN1qgyzVFkdC5Cqr	484	1319	75	1	6301	jwM82qWrm51mqUYV1JE4aHgevVyUehsJK1YX5fzRddNSU25ahLp	3560	5062	5062	1616850360000	orphaned
6896	3NKKqN1X9awF8vuvvCgXHdKFeM2ZtAjNYSnKYkJErR1SteD8A9BJ	6895	3NL5t5DZdaY3xVvvTjAHwXWVzU95R3xQpxB91azLubuAJUrphvM3	1646	1108	75	1	6301	jxFutnZCBm8Ae5Vn3yNv1teRZVNBvsMDuoejr4otZ9uzRiZuuuS	3563	5030	5030	1616844600000	canonical
6903	3NKU5fGmVcVV9HKNQRQ8tAvkXAQAtnvChPWQ1LqqLN1zGgk2hrKD	6901	3NLAboqyq64uDwKXsdGYZJ72FaEnywvH7ELTpDoovckLfmLv1Dza	1405	867	75	1	6301	jxpZSPGTwrf4m6dytfEWMWrKuhW33yHJKtMtJDCTWZPe4vazyeo	3566	5033	5033	1616845140000	canonical
6906	3NKFYUSE8q8NYgGfgAKsZXpK8CDS4DHBJ2Q8sYiPWtPYrbireGUN	6904	3NKYx2eU7niHyAuMuCKSjpro9y2SjtVAMqKif74tXLuyq2wCaQf3	1672	1285	75	1	6301	jx7nxehXnse868nH5ubm3xEx3MRQ9MvLdw1KRuE2EXeVaPnSxKr	3568	5036	5036	1616845680000	orphaned
6908	3NLJJJEGNYrebdrrtprdhK8gfz6HpkqA6QPPvcj4AWNDX8j8KNhj	6905	3NKxWaD6dYGTitCz9XF4DB5zLbDw3GZa4KaxMigsLHiYh6cp1HRx	1637	816	75	1	6301	jwfh3sqPd2Pvw2w314im6wNNYTyUJfXKwr9ndQFiJDFkRveVRzw	3569	5037	5037	1616845860000	orphaned
6911	3NLxBjpU7Q2z2h785473QkLubYEJ9fspLqq4EbfQvWcvcBSf475T	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	311	941	75	1	6301	jxpCwk219XRPqkFWRrZuzjryRFwQBakNqtXq6r4r7RE2xWDC5iL	3570	5038	5038	1616846040000	orphaned
6917	3NKHS2HgsnUafhX1sRvmGVYHCd7ss5LEpX1S4CRtjCoq6BFVKiDd	6914	3NK9C7emNL9VC8pdAd3YDiPXRNpGCMwqyccSuSr7zVsv5A5MMmjx	1523	1321	75	1	6301	jwwBszzrxrsUizyXdWuhdyoUZX7v8j6Bez24Vu6XKr95fpHvoyo	3572	5040	5040	1616846400000	orphaned
6921	3NKLtkkFJyv2VjwRXVJJaEyMgH85NTQjj4UKL8TSVkKoxYnXukBM	6920	3NLRMgVY6HeqnSHCCMG92sGwYdX8rx2rqWusZWCT8NWZsVMD18A2	1483	893	75	1	6301	jwREXJb2eM4gABm8bAkXhP2K7QX8ymUBVyvyAeVmZsgZDSyw83j	3573	5042	5042	1616846760000	orphaned
6926	3NKRn2cUWZ9FjD2XFbv2ce2npACYqexSbJFDtmuwTscnyxnoZCYv	6924	3NKJBKTgC71MWQRG21pfXSBpGXx3kxP15fYfWAEu5U3FdsHk7XzH	1652	1189	75	1	6301	jwBinf51HYGjx5A9ojbn8wApoCNoUtYE7oqp7soyuS1abgd2K4A	3575	5044	5044	1616847120000	orphaned
6928	3NKYq22K6L4U2NSdRzHwzToLadGMk1XNohvverjR21YQVh4yjGGd	6925	3NLu7tw2K9YEB2ajrM8D63aKDgbS8Cn5JwrMf4eMSSkC9z5JvAFC	1403	823	75	1	6301	jwv2kQJDEzn4DvYDZJ5wsvSN5XbbBxPAd9eWRHP2G8i4TLPUeuf	3576	5045	5045	1616847300000	canonical
6937	3NKdfjTYH4LxLwzramrVvHZmTmUmPaMoXg9P7DBiAJpfY6f34sea	6934	3NLfVj9gq9p6my3CcYY4zWd7rNHSTqHiV7sEaspXSokjP67PoXsA	1609	1207	75	1	6301	jxDMDQKnkBZfQwd1asiHx5tpoz7Z2UFx4x5rywRyRzroRGGrrAW	3579	5050	5050	1616848200000	canonical
6940	3NLCa4DwRx33JF4keQikLhwDCxytzC9ANwGJBao66n6K82sotSiP	6939	3NLmPT19h4vnLe5acZVYYpaWNzYSTNg1ahJ4Wk5jHqdHtUiYNBeJ	1407	1395	75	1	6301	jwaTZ2jVtV5pJXrrxas1QoN7PZhEcHjm752EGuTo288Fy6CrSbQ	3582	5053	5053	1616848740000	canonical
6950	3NK5H1oiySiFxtL9MWFpR9eUnt4W4TjmUH2fUrcF3cbMnjfeu9zC	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	1406	1393	76	1	6301	jxkHxpGSDVuSczhSAeghrY6vYLsdX8egLUrE4w4gterL8Me7X8P	3587	5061	5061	1616850180000	orphaned
6959	3NLxFjnk8kSSWycgM22tjiZPWLRnQqpqZEKGEK5UsSQUNms9eZg3	6956	3NKwfX8PHkttgbuYNngh4vBYKa2vjjjDuGs6YPGj53WTaXcD6oEs	448	1059	76	1	6301	jxphrVWzpnbyywdkoZw9WJSchSDoHJj9jyzwLZAFZLYwqZF9TfW	3590	5064	5064	1616850720000	orphaned
6961	3NKknuDxY44JSn7Asod7jtjKLcgWFCyrbagGw7VwRZvoXdVTfcBM	6958	3NLmvmRxEz9NgBLpM3aoPuz1zCDvQqXj7EMP5d8MhA9hcDc5Q2YY	1670	916	76	1	6301	jxrGxujrWEjM7V2LobeFrsu7Qd7iUc56ygxvhyGriJ4BfmfcERe	3591	5065	5065	1616850900000	orphaned
6968	3NLLv7ffjTCksVQetgxaqdyq4stH7B7ytpGfdEaXR6Yzcb9CtiNW	6966	3NLwtwSMxqgk8FU9HP8stKUC317p4APwGaLdsHtwtV1GnKeDsLr2	1553	776	76	1	6301	jxX875mpYsG4oU6jR2cGrYV6N8UNgAtWD5pcN4TyiPq6tKPKvMv	3595	5069	5069	1616851620000	canonical
6972	3NKjR87tFZShzAC9BGio3L5Ac7Cqkj65Rrpo4k9yB7abD6h61xbJ	6970	3NKQwFP5kej53Xec8BFqcN3moybZp6xqphi2xc1qPSba1woyPCwi	1529	1316	76	1	6301	jxDPWQEsKHJ1hGUH6bbRw6RErE7HAutYYJraHBaNzxs9aPc7BME	3598	5075	5075	1616852700000	orphaned
6978	3NLGQsFLvESFLtBeTjpBnf2izhmjhMkPWbnpQjSgRT23hfxFrwyw	6976	3NKRPbRm699y1rhosjAfB8zBk2jPe76ipJRqW6ke1gM1dSF2Sd2o	1637	816	76	1	6301	jxceKFcbGHHFYdCVgyeVqY9gxUrucrBotSErqYcfv2GdysHfjo3	3600	5077	5077	1616853060000	canonical
6980	3NKYHEYJhAwGpi7XHFCzgmwQxhEGRYTFVk9RvDjakH3bfR8LbasA	6978	3NLGQsFLvESFLtBeTjpBnf2izhmjhMkPWbnpQjSgRT23hfxFrwyw	1490	908	76	1	6301	jxcv35VBSmc8AERq4RGGKC4jLeqiMBvF7ytf2D8hkRRKguUFYAo	3601	5078	5078	1616853240000	canonical
6983	3NK5bRzxSKrwQ8LkcqQNcE3xbinCxTotr6iGhLzkZogHWTqbok6p	6981	3NLnGyqn8wjhVi3Mn2TDCe2ATSHRPCVuMnpxazW42Jyz951gBKaF	1607	1348	76	1	6301	jwQnsS5Ru6yvxu5zQVnEJje2SdKVSVbKJjdPZebxD4RFddbsyC1	3603	5081	5081	1616853780000	canonical
6986	3NL7KoXUutPAcuPQ2HKtDkGuYZDMCutppKTKXmkn2Y2tZCvhF65Q	6985	3NKyopB1QmtDDVtAp8sVXnmwitjQdzULMnp3Aka9aHgo7bn2Rxsz	1403	824	76	1	6301	jwBkGU2Gxfdc8jRV9u2yNP5AecN48Do23fozed1Teq94Wh2XiWL	3606	5085	5085	1616854500000	canonical
6992	3NKVrSAbBfqsdQp27EDpkAWz6giW8LFX7TMpZ7cpby1fkFxwqPAi	6990	3NL2hthPAUygehh9jRPYNkoui5XGWBQg5H3K1stP5aYpy6X8fto1	1644	544	77	1	6301	jxuzZ9pKr6NtZQA9KVN3XSG2UAZW7b9Shx2AdiuULYcAfoAz7C8	3610	5093	5093	1616855940000	orphaned
7005	3NL6kdhy8YgXpHfsnv9KuE4N3RJ1j2i5toKsB6eX8KCPoMEsv6DG	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	1447	1345	77	1	6301	jx6HNaEe3pLkpGUHYWjpT4nKTYVHhfYhZWMXpWmEvD8i46FnCVm	3614	5097	5097	1616856660000	orphaned
9957	3NK3z8mrme3pc522CGp1gof56JGnGi6vegc4GxjVGAPJ81tPtvVg	9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	1407	1395	121	6301	6459	jxeqQRmHY8vwSTW4B7mu3zw6iTJuLuciEVfJNsMAdGq4GJjXi3b	4950	7271	7271	1617247980000	orphaned
7001	3NKc5yjfrAxi75fktaNaAoXRKZ8hwaCqVj1KvDLYi35cdQijv3sD	6708	3NKoACCzuwu4B8WnsLFQWgFYuAFHkMYeiHyB9w9Cuo9kdYsjD3K5	311	1307	71	1	6301	jwS1W4RFhJVN3ST33adhXhqHWrKWSarasm6Uj18u2gQVB4ZxU6p	3470	5096	5096	1616856515502	orphaned
7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1672	1039	77	1	6301	jx3nnd9AvC5gC2Jjhq193Rrt2ofo6D2tw1RSSqpyy3qhg6eFsoJ	3615	5099	5099	1616857020000	canonical
7013	3NLW6PBE8JRn6ARPrL7rGSkiZSdsRTCcBf5Jf2QDSQ5EqNwbW27w	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1489	1014	77	1	6301	jxCymDcQzvW3JY5RrbNoo24UnAuPgC5BhkAu6ULvGk64kvqp3Lw	3616	5100	5100	1616857200000	canonical
7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	7015	3NLXfMwjVyDX6rzFVdXNGhbwrPRv1icWh4gfG1Gswy3Uu81o3wCM	1406	1393	77	1	6301	jxZrT6KgndHFB497vmCjKBwoT3q2ic64XG4Dm9hJ5DF4xrrnAgg	3618	5103	5103	1616857740000	canonical
7021	3NKuucBrkaNvSfBcnm3L3oDgYY3opxeM6rteMhifkPLqVkJxjM73	7018	3NLYoQU1G2rRQcCxu4ThvcRC2oUKtrzVwFxr9j3qNgpqvjbvs6qw	1608	1163	77	1	6301	jxghRmroYgGCjxk9bvW1ECpUr21xBD2BDaXHFjGTqJMKGQqnFQV	3620	5107	5107	1616858460000	canonical
7024	3NKCbH4qza87pJgFQyvmkvTwdhqsumbrbBSCcS1Tvk64KktqmzfH	7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	1406	1393	77	1	6301	jy1Wdvf8LYwo5cBaEUNG8oGwqrycvuZqt9UJEG1X8tVD7nQTupu	3622	5112	5112	1616859360000	orphaned
7029	3NL3noQkqh9Wfc6fSqdWur1DxJGc99P6z7rP8cSoKCEjsVckfiUM	7028	3NKd2kfEDN2Quzgh1VxL4vrNgDzKzBbidWVnGJ9FFCLcpad9atsp	1403	824	77	1	6301	jxFfN9Zv92zJg8nf5smiwYNV4KJUrRGseU97PGDQPUcXeXnR9zY	3624	5115	5115	1616859900000	canonical
7031	3NLhvvEEKBMX4dqvZNZjYwwawozMAxsmph6h8D36uZrt4x1DQ1wt	7029	3NL3noQkqh9Wfc6fSqdWur1DxJGc99P6z7rP8cSoKCEjsVckfiUM	1594	1326	77	1	6301	jxM2WvDbjpGC6XtqUWt6yG8u9UucqyC9Ugnd9z6C1MxdGQx6oVo	3625	5116	5116	1616860080000	canonical
7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	7036	3NKoQmmZRuyGWktmitFApKqra9pcrHY63ebtpNnDLDxmoMZCukGd	1455	1086	77	1	6301	jwXvuxk7sxSNxMQy6n4CEynCXiEX9bvP4z55U9LDaCwQ2B4hQk9	3631	5124	5124	1616861520000	canonical
7042	3NLd8XuhJ93sFWpmsGifvF3rTCiytSMZVQ9sfnZYsTV6qV9Boe7X	7041	3NLPSzroKTWRUK6bDdc3UwjhZ8xzGbxP2noWViPgUUu5upvg4QZF	1402	852	77	1	6301	jww13Vw7whnMaissgDJxp1wqU8E76jfuYYiuDTQGA56ecPuwbfg	3634	5128	5128	1616862240000	canonical
7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	7044	3NKo5Mcjzdpp2o3phj1AjD3cMNMw9L748fT91PwVwwqVGnBQ4ZTN	58	915	78	1	6301	jy1EZj474x9rGdKSMWYUrovm143kwShCpDEVFRJPTZd1n94mnH5	3636	5131	5131	1616862780000	canonical
7048	3NKuu8zmQfxsBef6Dc3Gr5ZqamosMtasLDnqRz3jaw3vrfQBZM2J	7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	1613	661	78	1	6301	jxX7xcNj9HiC6ZDhyJPdNCMXGNN2ssR2h5vFMd1N7KJc3g8oWjz	3637	5133	5133	1616863140000	orphaned
7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	7049	3NKPKAmWhyoDRcy5e2NENcpEnR2fvPoSC3a971zwYzZhvExrdxfj	149	917	78	1	6301	jxvy5QJkwkCUoiS5tXgGs1E5918iTot16eWGHEwGhbcix4Gumcb	3639	5135	5135	1616863500000	canonical
7055	3NLmub3w14AH9MB69k7pKt3G7P1w9pat7f8XDCjCddzkUgpLJvwv	7053	3NKXrdAqqHiGJk4kJ8fiTw1kyrDNMMs9sq3egmMCw5QNoVmyZpXU	1577	1081	78	1	6301	jwf58njkYkMiZYg72oX49pksMmXGpZY2VLmHRwxjQRCkXDPKZh8	3641	5138	5138	1616864040000	canonical
7057	3NKwMF1seewzhXZsSkFiN8SbM3RGr61vPXEnQHShakb6nBxZQ5i1	7056	3NK3x9MoxZB5ii35zCuoDA4YeCT2AawsUAEQ4akvNGCvFTfZvedX	1534	1317	78	1	6301	jxoVTPqCUHKZZk3xf5d2AQr9rDfms2uRf9MeLRESS95n9FRNXAT	3643	5140	5140	1616864400000	canonical
7060	3NKLtKgQZHaL3EEc2diQpso2pc8SmDih8ZLE3nZJR6agFAqiHfgW	7059	3NKqeugPzCdgCuNpc559bfFp6meKqt2F7u5KPnWNWCi5ZX6Jvxch	1631	794	78	1	6301	jwyywvzaaYAVauEJ5hbM4f3KdCKverZQjnKW8FiCb6GmnMGDkgY	3645	5143	5143	1616864940000	canonical
7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	7062	3NKyGukqb6NrJN37k7UJWSSKynnthkwk7Fiym62169oz6yb1MmCf	1553	775	78	1	6301	jxuKwDWFghHuCJz8b5qb2R36fMA8PMYT7JjYg9fA3sxKHvaybDY	3647	5146	5146	1616865480000	canonical
7069	3NKy3jHRTjSdhgXpCCDNTZ9Sp2k1kSy67FyMwJv4BAtJqrXgTf1T	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	1590	1054	78	1	6301	jx1cF5S1ERuiHVUA3XpeL5xtQZfJuF5EDCGziuN4qDTbm8ToLgj	3648	5147	5147	1616865660000	canonical
7071	3NKX8nWfoiYj8fjc6Pt5dKD8knKu6xg9WVuk4fkzEsNsWmVuMBag	7069	3NKy3jHRTjSdhgXpCCDNTZ9Sp2k1kSy67FyMwJv4BAtJqrXgTf1T	1553	776	78	1	6301	jxuA8L92KevAPyKTBi7JDgQv9zR5nep9xHr38wTuS7Hx4e4p1nk	3649	5148	5148	1616865840000	canonical
7077	3NKhi44P9njEsVaF3vZxWUpTH1GGwTvFGU6LddBLgi7JtVdm6rnk	7075	3NLJc77QVnsiYjS96Kd8qF82pBfQ3CYmaaHCJfbvsyujBupc762V	1474	1329	78	1	6301	jxjHRpvQ7gDR8Qp3eoDNk6xCBN2x4WTP7pFLPouyT1qjwjAHMsW	3652	5155	5155	1616867100000	orphaned
7087	3NKr1VbSpWnHu43ybyZQ8mNBEvRF12FCFPkQFdzmsPSfxUm28DAx	7085	3NLLoyAcoWbFX2FRYUEeeetmM5BCviKwQkQgh15DvSzNQ4naGPR7	1483	1276	78	1	6301	jw7jJHfZHUAXe1CKNHdVALJF6RjUCfr2qVqdM4TA7bHDpqgFYrP	3657	5163	5163	1616868540000	canonical
7090	3NK391NaWMbvbsiptZvWtYEErucNv95z6vSHLJaBchAjGMcTH1QS	7089	3NLuaE6zuhp1sy3yjvdo64wrbMqVgsVhBP1sBFZcnKY2dWu2mRMk	1631	794	79	1	6301	jxPHeuYpboXMXb18RHwTzCJBK9xzftn4AJ9TMrMXVmqHGh9DnLT	3660	5166	5166	1616869080000	canonical
7092	3NL4qC9Pi7vh4UfbunkTTKUS3paWEKsBwTw4MyAaFKUqCRgEuSBH	7091	3NLY8FEN5Me5cGkzGYcnV94xXUfdWnF7Pgj5qCvV19NyXroYay4r	1670	916	79	1	6301	jxz5KALCaTXwh5z79ikCU6LL8ubVWft3XseA3WGSX9npb476bWr	3662	5168	5168	1616869440000	orphaned
7099	3NKdR8WgU6is6iHstR53AJsDbqC6zQHQGC4vCeyJMZ9tMerSo5ig	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	1402	874	79	1	6301	jxTvxinAFLi1xZ6Pa8Ao1XPg7imMSGZvbwHDBTWmyejWqihEu1e	3665	5171	5171	1616869980000	orphaned
7103	3NLupQb9oj9Qaz8tzi9HQTo3GaSgap1LY9T3i9kXY31mnwTt9F9i	7101	3NK3SiZyvZe5vPMwYU7ZomZW89GS2gFgUiTBfTN5eN63CaYoHR6J	1407	1395	79	1	6301	jwtWcRminmWG3b7R2JhvJcnacJzsk78EivxLFim1mcoC6qtEWxY	3666	5172	5172	1616870160000	canonical
7104	3NLqzxMfWAnpEntVH5Sj3KcX5Ydt7xETYtGMYEUmuNzbkExkjJWt	7103	3NLupQb9oj9Qaz8tzi9HQTo3GaSgap1LY9T3i9kXY31mnwTt9F9i	406	406	79	1	6301	jxSSWJ8GkLUcbz2RKgzoAHiDma2ri8izenu32xbx5YwxnSvUKKe	3667	5174	5174	1616870520000	canonical
7105	3NKQnYXcujzi2mKrujXp2CCx9zWgPYQbiQvKhmGHt3CU2W5Djumt	7104	3NLqzxMfWAnpEntVH5Sj3KcX5Ydt7xETYtGMYEUmuNzbkExkjJWt	1407	1395	79	1	6301	jxDWSmzrM6E7Ux9v2BfzEYqZMRnUYAT8hHiwzsUXh35gys6giT3	3668	5175	5175	1616870700000	orphaned
7110	3NLNhFusbPndFbDjDZN6ptHX5qotUXpN35YYXxUXkDGKW4cHv7BV	7109	3NKfaKUFVrzjqhqNKPgw4r97cCsf3iQLMuUHBCPYvDSSDk8tDair	1619	1275	79	1	6301	jwtq5e8XZBskBFDySw2jPX1XgLkQKvrVViPYcTzLVrwkkXTL6ji	3671	5180	5180	1616871600000	canonical
7126	3NKXaVfZkrUQLqwqwicmNYPM9ctaKPn7KKHjhpRt4X3F4DqP8Qxc	7125	3NKgnTomvHuxxyjp9hVBHj45Lzg6HVwHnNsCmXdP8E9xtzgyWun6	532	1303	79	1	6301	jxVvFzJrw35ftiZBzraS8qafJnDLp3BvAwacv7TczWw5EJSWjK4	3682	5203	5203	1616875740000	canonical
9570	3NLBZjCasuoz9QTNm8K9YLSHpBa2V4dPzQdRJNGRXSbbdoQVw2tQ	9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	1611	1341	121	1	6301	jxiPxnULchSfjPSxiZiFrG4nftvqjzH7JKmUDyYECEEAqzWXDqt	4962	6986	6986	1617196680000	orphaned
7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	1518	788	77	1	6301	jxhPLpeH6wtLj7tyCdAwfcQ2V1XuSCuRJqGAiw9sTdq6NBWQz5j	3614	5097	5097	1616856660000	canonical
7014	3NLAZUW6eqnTY5A2DjfHguhe8WS177EAvS3igTuzK7xZu4jiRJps	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1610	1314	77	1	6301	jw7iAbaufx7oj5UC4EjFjMmtMawfJD6zQzG1wGAuGgw1y8KRjF4	3616	5100	5100	1616857200000	orphaned
7017	3NKAxqw9Zjqn6zLfs4nyNceSq12sU5CtR9qiFSrgfabyccnvaCey	7015	3NLXfMwjVyDX6rzFVdXNGhbwrPRv1icWh4gfG1Gswy3Uu81o3wCM	1671	999	77	1	6301	jwKgUJ4knnHjzowoRBc47PbQLwJ5AP36nUh7aFeGNBhxTz6qChr	3618	5103	5103	1616857740000	orphaned
7019	3NKHR2Ueq6uGTKETCf5bFgKebCJ6HLVtqTEpgApu3nfqwfTczXGp	7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	1623	839	77	1	6301	jxCWhgD1vzeJgEW6FNNrfoztwe18hDPsaK4nyq1mJVmCJfbA5Fp	3619	5105	5105	1616858100000	orphaned
7022	3NKpUd8ukrUk1dgamdGvQZWDmJ7pTh7zsEqbA8MpKxg6AY2EWB3c	7021	3NKuucBrkaNvSfBcnm3L3oDgYY3opxeM6rteMhifkPLqVkJxjM73	1560	1291	77	1	6301	jwV97SCd14opw1jDwfchH8X3tVJPLrqbudDf9PWmMzpkHJHdUEo	3621	5110	5110	1616859000000	orphaned
7027	3NKZNjT7F1LanaFYdU9tJcbkWJ3hGYkTCNDPH6XhSHo1Egj3DxjK	7025	3NLqUqiMYseXTNutguJhx61gNf1xgC3EeboqvDNaZvqk8eF415j3	1457	1391	77	1	6301	jx2gFs3BFY7Y7SBavq8KcPPVZrJMmshG3N62yWfrh6HSNy8rHd2	3623	5113	5113	1616859540000	orphaned
7032	3NK8wDQ2rBqZkGVoBn1SaB9w8DmAc3oJ3Vz3nwhkwX1TkxjuvksY	7031	3NLhvvEEKBMX4dqvZNZjYwwawozMAxsmph6h8D36uZrt4x1DQ1wt	1407	1395	77	1	6301	jwdSyyBnayWt5SYAwsrtooazGUcvakSveXzhMGEjTUZKfvSFEe7	3626	5118	5118	1616860440000	canonical
7035	3NLKAV2zwWAJ6pekizPdbXt4aVhM12TSiytmVtGQGjjjXeahRuS9	7034	3NKcgQvP2xXvmP5Pi4fwdtX9TcneY9Sg4g8ZF6LVctoZQtRbPSan	1405	873	77	1	6301	jwrAdMgxuoZFZAUtJiBAXX6fLKc8kQWSbVp4Dgo8s6kfAS8YPER	3629	5122	5122	1616861160000	canonical
7040	3NLgv7LX3JLwKBm2dbZU7BPNHVPnazuuQkP5yg7kixzUc7afAdYM	7038	3NKsyQyihxAVHpSu76Nza2LsrUZsvMqJJwQ4DTEgCgtNSjdUKwu1	1654	1340	77	1	6301	jxmdvigR7LJSTLon7hfFuSEeYBy7qSBhVhmFLWRPGkFhZsypAsm	3633	5126	5126	1616861880000	orphaned
7043	3NKMq7Ti8BzYPJ6xicY8RhfJb7di7Mnq1w5jXi9TeEod5LY9ZDeR	7042	3NLd8XuhJ93sFWpmsGifvF3rTCiytSMZVQ9sfnZYsTV6qV9Boe7X	684	1106	78	1	6301	jx6QRkLPaeZMSSuH3Cb8kShFyApEMbMjMrgacpdtNdHKiDxUhJg	3635	5130	5130	1616862600000	orphaned
7046	3NLMeZBGRqwNthSGtVhtsJGS7q5QGihKoMnVdNxRn4mCyiUgaW8q	7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	1402	888	78	1	6301	jx5krx881SqwRVs1psMYDxzGQEgVAJeGGqDwQHgkpGE2qg7tKhX	3637	5133	5133	1616863140000	canonical
7058	3NKN74p9fTDaRLiExWRstnjgvMD1g3n8LKc8MJRhW245UXAfY7xm	7057	3NKwMF1seewzhXZsSkFiN8SbM3RGr61vPXEnQHShakb6nBxZQ5i1	1483	1150	78	1	6301	jxksXei2V16mModxNR8VjAVuhkxy6CrVr5qkFTUVeu33ENVvJEg	3644	5141	5141	1616864580000	orphaned
7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	7071	3NKX8nWfoiYj8fjc6Pt5dKD8knKu6xg9WVuk4fkzEsNsWmVuMBag	1553	776	78	1	6301	jwT4hJZBgFKRPthgcKU4YiHxx6WPW9cUXGvgxcmtPVL9rGsQVaX	3650	5149	5149	1616866020000	canonical
7074	3NLer8W2TjnDHxZjcpDt5U6k9mLN52cYzCCyG8R1nH2NTD5NjnCv	7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	1647	936	78	1	6301	jwau6a8Pc82oErWctJgazxTn1UNEBcua2e5tN4MpQ5yoQtT9x5z	3651	5150	5150	1616866200000	orphaned
7080	3NKpnKemKiiGofpr4GQ2cAoAHVLvcCexhsXVv3ge8ky8hVVWiXa3	7076	3NLFHoejTZ1CfcZipp3mbyBerZVDUM1bpiKQvtdxfhcU6qX72Kxx	1553	776	78	1	6301	jwvKDAiaqWZB79fN7MzoJQzU8QDz3MV2ZBqQkeUH3VVKjCWgigc	3653	5157	5157	1616867460000	canonical
7083	3NKks5VXQFmbjEB2mPyLQxZrfgzXBdhX4WbUgbBVU6GVPkdj7Qxo	7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	1602	1369	78	1	6301	jwC4Swo5ek2uhHDV31PZCsn6TQspT9nbMJwZfpdUobY2LoYDLUL	3655	5161	5161	1616868180000	canonical
7085	3NLLoyAcoWbFX2FRYUEeeetmM5BCviKwQkQgh15DvSzNQ4naGPR7	7083	3NKks5VXQFmbjEB2mPyLQxZrfgzXBdhX4WbUgbBVU6GVPkdj7Qxo	1444	1381	78	1	6301	jxMTfhLw3ZK8zFYcQ5nbRDk8CrsNakattGR846mUqLa8G8jXibT	3656	5162	5162	1616868360000	canonical
7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	7093	3NKAoteJLPcbhSKtshoUd3QLQFL3BgE5uZqarjfwUgWincxxZFbt	1448	1311	79	1	6301	jxpGomiRRVgzhuWMVwqcwMNrWGCrGqzNZod5pqYNnCeNH1tsZcQ	3663	5169	5169	1616869620000	canonical
7097	3NLv5WZupGB5pa3mx64CvYbRRUZgqnQQZn6vVndMqXQ4BxX75gQJ	7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	1529	635	79	1	6301	jxZLpg6r83HfSTBKSU8Qr1sDvso7fEGscK5vghdAAn1WrLwCik9	3664	5170	5170	1616869800000	orphaned
7100	3NL5G4JtoYqVYer9dvrNjvwiiNhhWDMfxNHR46T7dc5pwUYfXiz9	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	596	940	79	1	6301	jxjhEaLh7GAXfNeRQcnVvKowrUQjZQ6gg2WAhW4TzyiDgZ279td	3665	5171	5171	1616869980000	orphaned
7106	3NL6f9JuYFpQXSSD4AhKJuoEzsNBLSQA8jAoqguUP3B6ksWD7Lg2	7104	3NLqzxMfWAnpEntVH5Sj3KcX5Ydt7xETYtGMYEUmuNzbkExkjJWt	1577	1081	79	1	6301	jxEebHdxLC8Fe86Mm9B6iZTWWjLQuJKiSvUU1AJk3WnbEJCujfY	3668	5175	5175	1616870700000	canonical
7111	3NLjKm4DGBbXFDwvhQtUg3NxpDvFLQC9N73rfCt5euMkfroMKYJH	7110	3NLNhFusbPndFbDjDZN6ptHX5qotUXpN35YYXxUXkDGKW4cHv7BV	1647	845	79	1	6301	jx4sKbTto5jEWnxuQpcetXSizzzEVNWo2f3XEd6vwFEw486Lwxn	3672	5182	5182	1616871960000	orphaned
7114	3NLJgHmT2eMZY2J6LvtZcDxiMiZGzhkRQyDGVaoqYVpThVLfRETB	7113	3NKxiQUEAGW4VeKmwmXRFSKijXU87R3Vm48n4ifRyWXHtfNVH6Am	700	700	79	1	6301	jxvbxqE3Vjus7v3CTe7U1eot7Py9fxNfairk7HonEvMnybCvqM4	3674	5186	5186	1616872680000	canonical
7121	3NL2dxtE6iqbYzfc871M7L6o3nF5QAx3GoeGjgKxu4mavibSqpHi	7120	3NKrCXG5sristNhDMHEWzMgBpvkFd4DjNjLVYjRDSKbUB3KrVSXE	1513	1133	79	1	6301	jwhicpqonHjhaM1kQHQt9h9obYEAYtrVJcnpzq1xqMN5z1uKx2A	3679	5198	5198	1616874840000	canonical
7122	3NKBN94xgTtuMBiL3qWEJXZuswNHchiAMxJ7cnEKHEWeuvWyKK1L	7121	3NL2dxtE6iqbYzfc871M7L6o3nF5QAx3GoeGjgKxu4mavibSqpHi	1599	921	79	1	6301	jxGvQwe1vW5F67sXRVUoyDX4p5EYnzxs6BUaQFs4M9QFWU5vySL	3680	5201	5201	1616875380000	orphaned
7124	3NKPpSjnZy9uaq4FtKZF5ZfKeEnDcLLrLceDhbE2DzBPfwjqKLph	7123	3NLW9EQw9CkfGr8JXPfZe5anD4bf5Sqsakaiq4rtSsfvU9hJoX9Y	1403	824	79	1	6301	jxxZdNaePrvCz3Tv2gUntdB2gyUiKQn6TiyuhfSF3tcve9wUqWi	3681	5202	5202	1616875560000	orphaned
7129	3NLBkRkasdZueNNEdnbGeRJpQkvZYPzqsZgSM3KY3QXaKkqjeH8d	7127	3NK4rzqVKFPCM2oejpRRrti6JPPz5ffHeqmFREwWDRwJr5FTaPYe	1663	650	80	1	6301	jxEv2mjFyEmHNhck9SsufDUz1nSAixwxY9tpg6LdRpgPPAFCDCA	3684	5205	5205	1616876100000	orphaned
7133	3NL71dPEvq5fggASdskQanGG9N2QYaTsAKmxakExT6PCamuoZwxN	7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	1503	447	80	1	6301	jwa4FEtVMw8HKibo7dq6abhbQWLHPayhqik9kqNyomwmv2R2vVa	3687	5209	5209	1616876820000	orphaned
7138	3NLgpicmYtuxnTmRefYH3Q2wPCdi9mfMsB9vvwqJDCjkDJ2Caf8q	7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	576	1355	80	1	6301	jwHVAVoLY6C54qXznBqJMmmgaMzzrpXhSVfoEx91MXTVzgh39Uj	3688	5211	5211	1616877180000	canonical
9958	3NLZYD6zsNCNsnKXtrRMwNjK8cXT4XgJ92HPrUddd4eC829j8Nu7	9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	1407	1395	121	6301	6459	jxDZWjn8saVmH76rfYpoR6xhdwHQ3XFD7Z9CuTfu1UGCYD42aWp	4962	7271	7271	1617248013957	orphaned
7018	3NLYoQU1G2rRQcCxu4ThvcRC2oUKtrzVwFxr9j3qNgpqvjbvs6qw	7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	1534	638	77	1	6301	jwZJWaTCG5iagGwJZfJgZAyDWjVZEhKtkGWBZDySwSPQMXwKUYN	3619	5105	5105	1616858100000	canonical
7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	7021	3NKuucBrkaNvSfBcnm3L3oDgYY3opxeM6rteMhifkPLqVkJxjM73	1610	1188	77	1	6301	jwhneVfMziFk1uAVJhYwuci2m9kooopEXawp5cixfuwQVg1wgVd	3621	5110	5110	1616859000000	canonical
7026	3NK4xQwCP5t2AoChR9uauzPJKv6RgYwNY5cm48qgREuhbtqzihJR	7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	470	943	77	1	6301	jxqMGj7admHjr6zfPjohgFhxv9nbjW6wwSwxYrdBXd3dqfLDWRe	3622	5112	5112	1616859360000	orphaned
7028	3NKd2kfEDN2Quzgh1VxL4vrNgDzKzBbidWVnGJ9FFCLcpad9atsp	7025	3NLqUqiMYseXTNutguJhx61gNf1xgC3EeboqvDNaZvqk8eF415j3	1534	1191	77	1	6301	jx6AYyeo3cAu5a1JnRqSEGKEx99YdrHEuJSy4AwSRjeamHd6GRQ	3623	5113	5113	1616859540000	canonical
7150	3NKpwHc3MfLTPFdQiv4ESvfiq5YaoAUkbybVL7FuepYL6wh47YHP	7070	3NKVomCLhoHZ63sShu2A1zLxG87jyT3cS3fq5oUQv1AVwddzQGCp	641	1090	78	1	6301	jwtzAED7yHm3ZMm4esb7f11Kv6S7EHCM6arsNrAPBdCdLomWUnB	3624	5218	5218	1616878440000	orphaned
7049	3NKPKAmWhyoDRcy5e2NENcpEnR2fvPoSC3a971zwYzZhvExrdxfj	7046	3NLMeZBGRqwNthSGtVhtsJGS7q5QGihKoMnVdNxRn4mCyiUgaW8q	1623	830	78	1	6301	jwgx51tL2HGfnJvaaCCxQsiqjqF8f1aF5p58DPBDtWAjE8TEkTk	3638	5134	5134	1616863320000	canonical
7052	3NLUrSPFkksHjFgLF4SBoWKVQNMb8DPKE5wvuQYxbATj9j29u9Eo	7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	1439	1279	78	1	6301	jwW3SxrRyzftVh3n6ZdcQW7ULsPUA6wjHEx4VHSS45HgtiZFGfP	3640	5136	5136	1616863680000	orphaned
7054	3NL2rEf5VDS7gBoYHLBGWQu4uQyuuVQLmgsZ4aqTtqXY3okG1AED	7053	3NKXrdAqqHiGJk4kJ8fiTw1kyrDNMMs9sq3egmMCw5QNoVmyZpXU	298	1182	78	1	6301	jx8ZTpJ7jythXov3rzS4934T1JNVp4Yi19vCsrismNdEHG6SfFb	3641	5138	5138	1616864040000	orphaned
7062	3NKyGukqb6NrJN37k7UJWSSKynnthkwk7Fiym62169oz6yb1MmCf	7060	3NKLtKgQZHaL3EEc2diQpso2pc8SmDih8ZLE3nZJR6agFAqiHfgW	1489	1380	78	1	6301	jwax7DUPnrch5e9LTrpapFmRaHsZ6BzMWD7Paaj3UmY4WkXq9zp	3646	5144	5144	1616865120000	canonical
7064	3NL7HVyGvV1c6gbjKXJxg3ah5VyfcXggv9WAbe6N8MVFK9QT2Teh	7062	3NKyGukqb6NrJN37k7UJWSSKynnthkwk7Fiym62169oz6yb1MmCf	1426	1364	78	1	6301	jxDd5E8UdQn9AtyerwgEt1shnMpXu7ARuPDP84YQGpAZ83zJb89	3647	5146	5146	1616865480000	orphaned
7067	3NKeX26zdKe7kemwCBPuxL2eLX79rbEhULmuj3T1k8MhCLk36SUS	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	1403	824	78	1	6301	jwiLwNex3pELbXDBmbf97DoPwiryj6TDB2Cob5SCca1NJxdwjtW	3648	5147	5147	1616865660000	orphaned
7073	3NLUTKNWzQV1kSRMgdW2i3tvVXVNnZ8Qm45Ta2S3JBkEcWD9ZbSj	7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	1402	874	78	1	6301	jwfToGKbu6pfwTgoCAVHWx5zGD3d27Cba5F3ZGzdsngpbR7MChr	3651	5150	5150	1616866200000	orphaned
7079	3NLTGEvHvN4SLVGpuXotjUfeXgdynHn3gFEcbBMQgj72N4rTiq5u	7076	3NLFHoejTZ1CfcZipp3mbyBerZVDUM1bpiKQvtdxfhcU6qX72Kxx	1516	1048	78	1	6301	jxpUfr6pEfK8F5vb1QVX24BDPLTLS17C1p1xqc9RYhS2VdWyoha	3653	5157	5157	1616867460000	orphaned
7082	3NLb3W5rDLKXWYuczzW49PnRhfsubuh1UZo5VPWKkCTVu29ch6qn	7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	1406	1393	78	1	6301	jxFQqPhmbgGpm7pQZ1RVrfKbk9bBuaYkwqcKZZWrVJM8YRJMBgf	3655	5161	5161	1616868180000	orphaned
7089	3NLuaE6zuhp1sy3yjvdo64wrbMqVgsVhBP1sBFZcnKY2dWu2mRMk	7088	3NLQi8j7MLugHyGX6xGo1kAyHHQuD2CCWBWV8rVMMc1Zhf4MtCy1	389	389	78	1	6301	jxSxSW2UHURGoeWfD4qwTupPAR2osVKxLXG8R5hHK7RDNQf3Nc8	3659	5165	5165	1616868900000	canonical
7094	3NLnbw6EGNtxi91vZ5JPJCdDMC4pBa4HqNMmjad4RTv8LvAovBhf	7093	3NKAoteJLPcbhSKtshoUd3QLQFL3BgE5uZqarjfwUgWincxxZFbt	1448	1311	79	1	6301	jxAgWAwqchFWGVH4EZGcno3ykAUvFboTmtDBCWEGmBZp8rBcSoS	3663	5169	5169	1616869620000	orphaned
7096	3NKHrpTW4LFGwvLYLx8YBJdKpGEuYA8agMYniWo3EafUuLae65dn	7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	1406	1393	79	1	6301	jwf3TdZ14E3UQ42KovVTKsvkbnRidBGe8tPVmTGamYiJMpyQ8Dp	3664	5170	5170	1616869800000	orphaned
7102	3NKSYQEzS6bKmsQuMaf9ofpVYFpKstdM7iFbMaARZ1C93Mcx3KgA	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	596	940	79	1	6301	jx57Pb19z3eEfjnLDhFesq1yYyp5TwYqtM8LmkCmnQPMx8o35y6	3665	5171	5171	1616869980000	orphaned
7113	3NKxiQUEAGW4VeKmwmXRFSKijXU87R3Vm48n4ifRyWXHtfNVH6Am	7112	3NKA6xz12Hg9UhxN9QKjsymbddf7GTipTBGWuwkbHYaxkKTJhE91	1407	1395	79	1	6301	jxXVw6VLpHAWHd2XZnY2fDGt1HRmnA2qnqtkc7GBaFkUi4V7mTT	3673	5185	5185	1616872500000	canonical
7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	7115	3NKSFNMjgGxZoJY15DBZ5Zpvxu6NuVUyHfxmoJYm6JtBhdNU9FSk	1624	1208	79	1	6301	jwjUforYZKayLJerCDcLvEvN6BEFdq9J71SMt9SSQXv3kS3kGt1	3676	5190	5190	1616873400000	canonical
7118	3NLQDKRVqvvw1qmmY8ooDc8uo1xaEoYrT6aYAGXjyR2tBeabJbrw	7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	298	942	79	1	6301	jxztpQNoKr6U1WKgjWz1nXZtPUkQ8nG77dtaBtgC762cphbNbdf	3677	5195	5195	1616874300000	canonical
7120	3NKrCXG5sristNhDMHEWzMgBpvkFd4DjNjLVYjRDSKbUB3KrVSXE	7118	3NLQDKRVqvvw1qmmY8ooDc8uo1xaEoYrT6aYAGXjyR2tBeabJbrw	1673	1368	79	1	6301	jwehUXoceCC76h3CPKgzxefZiJTqJjpKrYHBQ4vRKBNNCtLkkFM	3678	5196	5196	1616874480000	canonical
7123	3NLW9EQw9CkfGr8JXPfZe5anD4bf5Sqsakaiq4rtSsfvU9hJoX9Y	7121	3NL2dxtE6iqbYzfc871M7L6o3nF5QAx3GoeGjgKxu4mavibSqpHi	1500	931	79	1	6301	jxuVZLqR98BpQR1MsNsfMxmEzUDySZbvZ2rZtkyfjNSSe2EMb5x	3680	5201	5201	1616875380000	canonical
7128	3NKXMGaj7mTnpviJJEnyDaBy2DhkVC2jnbSD8ER5cPF2vax22VQH	7127	3NK4rzqVKFPCM2oejpRRrti6JPPz5ffHeqmFREwWDRwJr5FTaPYe	1663	650	80	1	6301	jxEv2mjFyEmHNhck9SsufDUz1nSAixwxY9tpg6LdRpgPPAFCDCA	3684	5205	5205	1616876100000	canonical
7130	3NLRFTR69JAoBUWqbBxRx4goTscHsmSBF8X1Q7L2sgLwUyJQ9ZQi	7128	3NKXMGaj7mTnpviJJEnyDaBy2DhkVC2jnbSD8ER5cPF2vax22VQH	1607	1348	80	1	6301	jxKqUFuHSPWCqotwf9Yzhn4EnPpdTe3VZ8uqvWrn5BaTq73jrhB	3685	5206	5206	1616876280000	canonical
7135	3NKJUkd37a3ZQboWx5U4W2uieN6wwTDdnrumc15Hdmnwz9i4yb5R	7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	1637	816	80	1	6301	jwrWr6QnbB4KwNE2jnw8NqV9ZE8R6RivK4n9DXsnxFtfAXBKW4f	3687	5209	5209	1616876820000	orphaned
7137	3NKN6qhDiGj5tpgTCwUeJMmKFLVWUbxjpu98zvBfqErGCNXzuH3b	7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	1654	1214	80	1	6301	jxPZHgMGDzreMHiKqMivbAEG9qTqfbXdkkvPnm5pqnUAFkzbDSN	3688	5211	5211	1616877180000	orphaned
7148	3NK44qNPyHD73DPCTR4UeSDqiKUravJWnr2FSpYCRsmdP78spXav	7145	3NKBehz5XWsX8hf4bdMBAuFpZGUE8ktRuGhSWc1MvxBGKg7WS51E	1656	1217	80	1	6301	jweTcY9EaayMy2Z38X4KcsYG2DQ8V4fdrTx4oBXQe4x2EF4UAgk	3694	5218	5218	1616878440000	orphaned
7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	7151	3NLnXe2o6PtYfwjJWj9EcsFv7HH5JLL2Rf2bJnnvQjWpbgHB9L7D	1406	1393	80	1	6301	jwgo1uKqpVgHAuSHbma5GLLPG1grrA6PA1v5EcV5pLsN2rwrmKz	3696	5222	5222	1616879160000	canonical
9577	3NKen2Hd6MX2wnvt9ftVoVniShed3f9L6ui8BFLj7tDusWPxSCXC	9576	3NKNFgKuFn6PEYqvZY9iy5b17wAwmfJnGfY4MgtMjVgScjHycjqF	1559	987	122	1	6301	jx9oTCw3mUsajZmPsauM2sBqmdTaSTtA76Kk49d7JPi5anFX7uF	4968	6992	6992	1617197760000	canonical
7020	3NKp6kucwMpfhTPpJDxqmm35z8srrrCwjf4Pd2WV6iFuRP536954	7016	3NLSBUWaPA2Y8XQuBP55N27qYo6u4iFaXv8FAzjtKVrnerJS63zR	1585	1366	77	1	6301	jwwwdhwpWroj5hNGvU9Eb5hDhemHNYdTAFvhdi44XPEhgSRMNR2	3619	5105	5105	1616858100000	orphaned
7025	3NLqUqiMYseXTNutguJhx61gNf1xgC3EeboqvDNaZvqk8eF415j3	7023	3NKdC83EDMhvGkQG5XGRrdyjqmEre4ahVnyfsZLcQWFrmrVMGjN6	152	1330	77	1	6301	jwKPSufvRfVo5LeDc4z9tPJciGF6fj7tmxEBAARcZUnn3dEJTa1	3622	5112	5112	1616859360000	canonical
7070	3NKVomCLhoHZ63sShu2A1zLxG87jyT3cS3fq5oUQv1AVwddzQGCp	7024	3NKCbH4qza87pJgFQyvmkvTwdhqsumbrbBSCcS1Tvk64KktqmzfH	641	1336	77	1	6301	jxrNVMc8h9zV7wCHVkBTEfgo89vaVpKwyT5Kraagfu5wAdzivyx	3623	5147	5147	1616865660000	orphaned
7030	3NKedDpThzwErBv3wFQLumKs2QR3ekWa4BQYqsvtWBy7WoexWAZB	7028	3NKd2kfEDN2Quzgh1VxL4vrNgDzKzBbidWVnGJ9FFCLcpad9atsp	1407	1395	77	1	6301	jxR8gENWWX1NefkvGiCAGavStxiagMxgaaEP1cM3CYRMTerd1zY	3624	5115	5115	1616859900000	orphaned
7033	3NLvTHzuTdi7K45ry49EPvEBoevUKAiZJbrpwhcNkCRkwhxy3KYa	7032	3NK8wDQ2rBqZkGVoBn1SaB9w8DmAc3oJ3Vz3nwhkwX1TkxjuvksY	1631	794	77	1	6301	jwMGuyhuw9Yx9144QjBXiRXMJqc1akGBw3Nk92diVFNynEr3yvD	3627	5119	5119	1616860620000	canonical
7036	3NKoQmmZRuyGWktmitFApKqra9pcrHY63ebtpNnDLDxmoMZCukGd	7035	3NLKAV2zwWAJ6pekizPdbXt4aVhM12TSiytmVtGQGjjjXeahRuS9	1673	1242	77	1	6301	jy1kYosRpBJUK2TNTfznYtXWZh5q7nA5zcAVPrpAP75VZjJ8R9M	3630	5123	5123	1616861340000	canonical
7039	3NKJNa4QBBhDkHJLwD3Xocfyz6yqHWnGY3msfYwo8qctJT56oEGr	7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	1407	1395	77	1	6301	jw9ibudgc8mN4uk1ECikq8krknNxAAGeC2tsvfCBKtDnhKfTYkr	3632	5125	5125	1616861700000	orphaned
7041	3NLPSzroKTWRUK6bDdc3UwjhZ8xzGbxP2noWViPgUUu5upvg4QZF	7038	3NKsyQyihxAVHpSu76Nza2LsrUZsvMqJJwQ4DTEgCgtNSjdUKwu1	1573	1318	77	1	6301	jx394rKVfaQUgmsmEXJAZYrUuH5LR9vvhK1dNr6G9vH4T8jZE5q	3633	5126	5126	1616861880000	canonical
7047	3NLuequ6K895FS9cCSbKP8Jsxd7ixaoqCFAFZ5oVurRiaudWXw7H	7045	3NLxac3VD8sQLYQjPJbyUaZTJUKGNkYiMjQyF1qoidY1BHujBTLC	1407	1395	78	1	6301	jwtQKiMk4fKcuy9qkCTbD6b6jhzpZ5sebR4BgHa3twjsaYcqPwY	3637	5133	5133	1616863140000	orphaned
7053	3NKXrdAqqHiGJk4kJ8fiTw1kyrDNMMs9sq3egmMCw5QNoVmyZpXU	7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	1637	816	78	1	6301	jx4PiZCc3dkiEWTkvU151R3fWLqRAy9k93SkLzE2fS4UAFbjdQg	3640	5136	5136	1616863680000	canonical
7051	3NKbFAhWQ61yWNvvEMgR6eX71D22UbPGjgV6Djf69kWh5LzcnHHm	7050	3NLiykmh61kbZHiiojKxwdE9ReZAAsiXhBvtn8wb1MXkdQvziJt2	1406	1393	78	1	6301	jwJghKYYWGfj9emuMNe8SD8cqaaSUx2ZwTDhHA5GPZEcSLsdCz3	3640	5136	5136	1616863680000	orphaned
7056	3NK3x9MoxZB5ii35zCuoDA4YeCT2AawsUAEQ4akvNGCvFTfZvedX	7055	3NLmub3w14AH9MB69k7pKt3G7P1w9pat7f8XDCjCddzkUgpLJvwv	1483	894	78	1	6301	jwEPbbLQ4d2PHRv5fJ8R1aygNgLauF6Cp4H7AbaTqx2GEk1SSQ2	3642	5139	5139	1616864220000	canonical
7061	3NLwBTNonj5m6H5rPWrwZVfZn8ZXo7SozoAUPzWiwk6wDwRh2N6L	7060	3NKLtKgQZHaL3EEc2diQpso2pc8SmDih8ZLE3nZJR6agFAqiHfgW	1489	1380	78	1	6301	jxxdrd8wXTQyRCkX9MPfwKKwqR81iFo7AUxNhHrYiHTmAJV2WVo	3646	5144	5144	1616865120000	orphaned
7066	3NKqaJd6jnZtCBXGJ29meWFZQKp1amfjz1nb45kLsMpH2F6dVQyn	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	1402	852	78	1	6301	jwTxXv92X9vJztfzYEMgTpttBFucX7KqB6NMw4eNuPHWs5apS3r	3648	5147	5147	1616865660000	orphaned
7075	3NLJc77QVnsiYjS96Kd8qF82pBfQ3CYmaaHCJfbvsyujBupc762V	7072	3NK8KjSrsUcRmz2tF2pNEqW2bhpUuqBxy1j2tGpv8FLxeHvz7Q71	1598	398	78	1	6301	jwkYF2hSmNbKh46fRH12Qvf8FWaGEtM2aMpHcCVMAWhR1esDFfe	3651	5151	5151	1616866380000	canonical
7076	3NLFHoejTZ1CfcZipp3mbyBerZVDUM1bpiKQvtdxfhcU6qX72Kxx	7075	3NLJc77QVnsiYjS96Kd8qF82pBfQ3CYmaaHCJfbvsyujBupc762V	1447	1345	78	1	6301	jxkKkEKQx5T2VFXUk4wBbK9S9fVzGoY12VPwEWvBzFjZiXxR4k7	3652	5155	5155	1616867100000	canonical
7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	7080	3NKpnKemKiiGofpr4GQ2cAoAHVLvcCexhsXVv3ge8ky8hVVWiXa3	1623	830	78	1	6301	jwL3eKxrt3z5DxSqxY3YegZScz1uP9cYDZ9uxaWcrP2ajoXzSTM	3654	5159	5159	1616867820000	canonical
7086	3NLrktH5MALUxCpzkVdRyUYCLvm34M5siD2xXQR4svWuB2rnqvxD	7083	3NKks5VXQFmbjEB2mPyLQxZrfgzXBdhX4WbUgbBVU6GVPkdj7Qxo	1407	1395	78	1	6301	jxdH62AYFDiCtUjrhS6mgw1kyT36jgEBZX4TUFmsN3rPUVT7g57	3656	5162	5162	1616868360000	orphaned
7088	3NLQi8j7MLugHyGX6xGo1kAyHHQuD2CCWBWV8rVMMc1Zhf4MtCy1	7087	3NKr1VbSpWnHu43ybyZQ8mNBEvRF12FCFPkQFdzmsPSfxUm28DAx	1622	990	78	1	6301	jwH5SCcWu1SUtA1epnf8XZKZcqQ6EGdrDW2gFoEhoHpupzEAbCE	3658	5164	5164	1616868720000	canonical
7091	3NLY8FEN5Me5cGkzGYcnV94xXUfdWnF7Pgj5qCvV19NyXroYay4r	7090	3NK391NaWMbvbsiptZvWtYEErucNv95z6vSHLJaBchAjGMcTH1QS	1578	1296	79	1	6301	jxkgC4dtGDcG7ECPRXXoCe84iw45jrwPBi5sJSDmxpAijXifoAT	3661	5167	5167	1616869260000	canonical
7093	3NKAoteJLPcbhSKtshoUd3QLQFL3BgE5uZqarjfwUgWincxxZFbt	7091	3NLY8FEN5Me5cGkzGYcnV94xXUfdWnF7Pgj5qCvV19NyXroYay4r	1579	291	79	1	6301	jxQDHDP6SBev7Z9Fqyud4c5dmVMhP5vdwCYnzEHVRjoJqqWmPJH	3662	5168	5168	1616869440000	canonical
7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	7095	3NKk3CmLymGTwmmotzH2v5ZZ8KPaNDhqwBQUeiiTFJYXsYqednDv	298	942	79	1	6301	jwUyYbyjsKB8P8kKtBUEhRHK2bJ23ygZgP2F3SpsyfcEhEkpquc	3664	5170	5170	1616869800000	canonical
7101	3NK3SiZyvZe5vPMwYU7ZomZW89GS2gFgUiTBfTN5eN63CaYoHR6J	7098	3NKUzNQfMNiChKPqHbPK9bakJSdReBKwyV92TPVuYD9ht7wiPpZk	1407	1395	79	1	6301	jwa7DwTZSwZN5nJHhxjKGCN12WfoC1pQnzV65mfELDrNZsGdmeb	3665	5171	5171	1616869980000	canonical
7107	3NLaYP7yu9wrots9oynEB6JJ6mAzuW5Etz5xbW4wLynj97AMBVQs	7106	3NL6f9JuYFpQXSSD4AhKJuoEzsNBLSQA8jAoqguUP3B6ksWD7Lg2	633	1384	79	1	6301	jwBvScXDEVRoaqrPcnKim5JL56AncNmQYNGNWk9wCkVeewDaAAL	3669	5176	5176	1616870880000	canonical
7109	3NKfaKUFVrzjqhqNKPgw4r97cCsf3iQLMuUHBCPYvDSSDk8tDair	7107	3NLaYP7yu9wrots9oynEB6JJ6mAzuW5Etz5xbW4wLynj97AMBVQs	633	1138	79	1	6301	jwexRvxjdvmj7u2br4UGuHBQRQzP3ioVqQgZWVyHKT46Ri8Zqtn	3670	5178	5178	1616871240000	canonical
7108	3NLQkFdD4wePo8LVTYWG8PLWSgxKHynTCynXqpX21x2MPLJT1GQo	7107	3NLaYP7yu9wrots9oynEB6JJ6mAzuW5Etz5xbW4wLynj97AMBVQs	1457	1391	79	1	6301	jxNYZ1pNZDwp24Kfc88z7ZB7FnceReM3NKrQ3b1eVV1bqbUWAbE	3670	5178	5178	1616871240000	orphaned
7112	3NKA6xz12Hg9UhxN9QKjsymbddf7GTipTBGWuwkbHYaxkKTJhE91	7110	3NLNhFusbPndFbDjDZN6ptHX5qotUXpN35YYXxUXkDGKW4cHv7BV	1477	1350	79	1	6301	jx5vtmU1W8o3pZrJnad9UXvvN6eaPFCF93BFNcXYb9JbTem7uyi	3672	5182	5182	1616871960000	canonical
7115	3NKSFNMjgGxZoJY15DBZ5Zpvxu6NuVUyHfxmoJYm6JtBhdNU9FSk	7114	3NLJgHmT2eMZY2J6LvtZcDxiMiZGzhkRQyDGVaoqYVpThVLfRETB	1406	1393	79	1	6301	jwRK4zxkRLzSAdmQi29LtHQ5SSjkzhCReAtkboFSPLnBTAtukzs	3675	5188	5188	1616873040000	canonical
7117	3NK6nUAaXth23gWXWN4F8jtf1GXKfSB1nXwfXzSgqXUmbyxZmYo3	7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	1444	1135	79	1	6301	jwEcBdkkNAaLf9NLiyYMT19Gj1txJWMv5862e5UbnjMZLouqw4q	3677	5195	5195	1616874300000	orphaned
7257	3NKAe9Ue7rWmUbAVGdUnf11XHE87YVTMNWN4kTvoJSegHWmVMyis	7255	3NLaUcKmsFWuteyyr7XPGJfzY3g2dwNMDbzbhw7efMW4QvQMweP1	1627	1139	81	1	6301	jxgDTk8APXeCXwZRdNhsiWadhiwy56Sz9PnVLNJjswDENK1z4KR	3753	5301	5301	1616893380000	orphaned
7259	3NKX4grV9F8518duQ7FoeGdDsrF1hDXcX8emxydLhqa389XSkc5n	7258	3NL66uHLjcxpVwopNFinbqHbYRgoejS7q9fAvbvfjGCSwnbP3UsQ	149	1283	81	1	6301	jxvJWhYrZXyzf8fgmw3nJUAj8YSu3ydPChXDR9QL1HXTAamdwsV	3755	5303	5303	1616893740000	canonical
7262	3NLkjrBP9SUS7cvy6sYBoufgrnfgTBY2q4wiizR39wUTzSDXdYpp	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1460	1078	82	1	6301	jwDsRmpcjnZjWbXjmjcUxuDo7Srero7MUwPXXS1UhoM6BbASrcU	3757	5307	5307	1616894460000	orphaned
7125	3NKgnTomvHuxxyjp9hVBHj45Lzg6HVwHnNsCmXdP8E9xtzgyWun6	7123	3NLW9EQw9CkfGr8JXPfZe5anD4bf5Sqsakaiq4rtSsfvU9hJoX9Y	1405	867	79	1	6301	jwdHd17aT7F1ThSNb2UGJegvBFeG8ERaJBoSTUpiVHkdgBW5trr	3681	5202	5202	1616875560000	canonical
7127	3NK4rzqVKFPCM2oejpRRrti6JPPz5ffHeqmFREwWDRwJr5FTaPYe	7126	3NKXaVfZkrUQLqwqwicmNYPM9ctaKPn7KKHjhpRt4X3F4DqP8Qxc	1637	816	79	1	6301	jxCYQJdNHNPvXpeUiSu5Y7DTh5A5umSTHsPs3RCFbtGcuxVSjvA	3683	5204	5204	1616875920000	canonical
7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	7130	3NLRFTR69JAoBUWqbBxRx4goTscHsmSBF8X1Q7L2sgLwUyJQ9ZQi	1673	1368	80	1	6301	jwUxfRnpfojKpP5Lx1J2uvhLM2WhmWxUCK5Dv1j2Lhwbssx6Xf9	3686	5207	5207	1616876460000	canonical
7139	3NLLck9Gq8ehdXY5ReiP2Nhd1aUUGHJcEt2BjAeUGEC4V4DT5xjD	7138	3NLgpicmYtuxnTmRefYH3Q2wPCdi9mfMsB9vvwqJDCjkDJ2Caf8q	1610	1068	80	1	6301	jwxqRdpnJcnbq2K2iY5MTeEnzQgA83kjDc2QBc8a4URnjAchNRV	3689	5212	5212	1616877360000	canonical
7142	3NLBGv5cv6nebzXcTzg3pZTCvtiimyVX9fbYjwmCsEdM3mThvXKt	7141	3NKjWzcn86Q4HjgbcTwQGaQup3WQ3zqicc6MKjgR5sAY9K6a1As4	1402	808	80	1	6301	jwxRStfJn2YxpyeBkUyrsCDSUJ5VJmBoYQZBX9yjCdAi6q5WvsA	3691	5215	5215	1616877900000	orphaned
7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	7143	3NKDAvax944Tp8KpduNrfBWa4wDivCxzpAkUfJkUwJmWfJ5Zkg1a	1596	1363	80	1	6301	jweB5pxuSKVEFhv3rfC4SbniXn5ZW6mruyjVpuQCwmSVpSNWr7b	3692	5216	5216	1616878080000	canonical
7147	3NKZXYTk7Sx7BwpevyEjGSHS6qjSc8yhjt6BhcatrXCQAbM2gDup	7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	1611	1095	80	1	6301	jxMq2GJynQXureeFi6EhY2Aep7DfHxSYhfZt82Kqefd6LCzu8Q6	3693	5217	5217	1616878260000	orphaned
7149	3NLE1KQMUNkK6m98DAvjUwJ9rBNK9xJgEPgk3NjiNWnVCFb594Uf	7145	3NKBehz5XWsX8hf4bdMBAuFpZGUE8ktRuGhSWc1MvxBGKg7WS51E	641	1090	80	1	6301	jxnvQzTUPYhAbGUMTXu9SNh6GMwPG9Age9N14jZDaiSCexrzxMo	3694	5218	5218	1616878440000	canonical
7156	3NLaXWtz4bnqgqSD6Jg8LwNBpD1HW3ZJfD6dfJy22DDzbRTyQNNH	7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	350	350	80	1	6301	jxaDHpQoc2T8hLfnYK4SnVaqLLSXzmraX9gmHKDVxXvKSzS8Zn6	3697	5223	5223	1616879340000	orphaned
7158	3NKC61fbEHCAjk1QVbdB2sZ4LGHBF5u2Apkv84NrJrZHnzY4qEFR	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1407	1395	80	1	6301	jxxS6PYzyibVqxDi7B3HTxZg9jzPHju2trQ6px7mn7Hd14o54Xg	3698	5225	5225	1616879700000	orphaned
7164	3NKq8B6s3zMpZcFCZJ8wAgRiB6BdjPn3gvsDWQ3TRtmgd7vkmDh8	7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	470	943	80	1	6301	jxUM8KA4tMFfjq9WjBm9pJZE4PM21SyfvW3VvNfy8isaY3YbWZw	3700	5227	5227	1616880060000	orphaned
7167	3NLM5AQAP4bVqDnQYNjZZxxQvDhgTZQ3fBmTnsBSWxXpXS6abahH	7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	448	1059	80	1	6301	jwNAtgZppdj1JgCPEEBtxYMav2qkH5WCpvnWuk1K5jHE3chX9BM	3701	5228	5228	1616880240000	orphaned
7169	3NKyq4RpgPk3Dx6DJr2hRSGi3EuJca7UzimHz2qZwZc1CkgLwyWR	7165	3NKB15UU7mA9Cr9Qm1WvBHysFX5FtEy4ghC5yCW7eqCmUaqVffPR	1553	776	80	1	6301	jwyDCDCL6XsysCu7dSj6jbTR2GPqDDsWHEpXxaNhFGr2Ay9UB7y	3702	5229	5229	1616880420000	orphaned
7171	3NL5stnaRCCoyDavkCHUX9YY226xosH5vWS9CqmoMWQBRPZqhsNX	7168	3NL9yHvXAZD1VMHNKc3dPr5V6JccdmwTrDYSF7JErBVuGsKFAddF	684	1226	80	1	6301	jxFjxa1DcW6AGFRengJgTPGov37hrAp3DZczd2nrQuvVQLGdYWJ	3703	5230	5230	1616880600000	canonical
7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	7173	3NK3zUNd2Tyuqm44N4QPs58MDxctAusa4g5FCcDsSeYEw9ednFn7	1607	1348	80	1	6301	jxh17XeZwepHz2ncAP4HTBVfgX1mTAJKC5dyW9fuJ4koY8yh1Cs	3706	5239	5239	1616882220000	canonical
7178	3NL12ojuvGyk4ZRHkv75Xtyt52nTPia3YQKEtxaCZvNHo97ywqCj	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1553	776	80	1	6301	jxjsTpTDRVH2mRuUCXuj8ehuqj1psuhHH99H5gYUNBXtEDsfo2X	3707	5240	5240	1616882400000	orphaned
7182	3NKc59PAMWuwXoHPazzVZV8gStxdp1rGEXfEtSe16XXXKoDb2FDU	7181	3NLPMPFBN235ocvVMPK4PvFN7HACLZjXSfF6Paz3dKatGwjv9R48	1422	1337	80	1	6301	jwM4m9brWXzM3WfHSopGUDuw2CfoYbV7UPrNhuJG111AP1VA7X6	3710	5243	5243	1616882940000	canonical
7187	3NLbAyLKcFdk67D7S5CXBZqJKPdFnVxMTPZpHUozG1vmetkLd91Y	7186	3NKBKnm3GvhBVcQtEZwvvDTsVnshao9GLgmVhG1jDd4pZhWkjwUU	1406	1393	80	1	6301	jxPVqvhPfDm4n6jDcxrNiigzYYK1cnrBC3vRaYPjVsmx1dfUuvS	3715	5248	5248	1616883840000	canonical
7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	1549	1116	81	1	6301	jwqhacdiJfB5iBcEC8wLGXUf1DUMCEhCWEGwDRWsSDw6uS1Eh1e	3722	5259	5259	1616885820000	canonical
7203	3NLZ2SAu4VZzWorQpJBh3iFQZvme33AhQ1bWxXoJVuupANcdrJot	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1406	1393	81	1	6301	jwkeUvQ1YURgmz8Murb3C15QMnmMf91uY5huCkBfUKbtRA6ad6j	3723	5261	5261	1616886180000	orphaned
7210	3NKHjU9MQnrfeLUJhbuZRCbJTwqFZWWVKWhiFyMKNexifc7Fd7Hw	7208	3NK3WfS4cUyvLZeceYdSdJfdgLP29zXjbPxA6H3ffNHjJyUwniJT	44	1199	81	1	6301	jxtpiAhCb6Ax7G5se6iQMdfwsA9TFMX2rFKVvgQ1PK6Yso6AYz4	3727	5267	5267	1616887260000	canonical
7216	3NKDwqmHK3PoQe8TMoyHBB87JjhUP1U8a41CtnGAqMnUEJHi7NoQ	7214	3NLhQAPGFKm2pxhbfTzfu4FLA1iXomv1b5xhh87Xp66mqK5khcQE	1422	1337	81	1	6301	jwTiM5J95iCmxqK64YFPvoK7kZqEvHA29Jk5rvhe74hWTJk7yDh	3731	5273	5273	1616888340000	canonical
7218	3NLcm6uoJsFHnKaQdAMfbDa6nPWJLPW9B4mznKd2B7A9wk4e9wNF	7216	3NKDwqmHK3PoQe8TMoyHBB87JjhUP1U8a41CtnGAqMnUEJHi7NoQ	1407	1395	81	1	6301	jwWdhinUJpNSggoa1feZsoMKbX6HJXZbYvJf1PvjU7NdKk4ZPAC	3732	5274	5274	1616888520000	orphaned
7221	3NLWnwV2yexgHu7rvcFUcGg2qrt5SPpE35qosfuHksxUbc577FPW	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1405	855	81	1	6301	jxtcSG2e6uqRuVNh8e1euwCkDdn2EXebkYp8PTKm8Basp4pxd5o	3733	5275	5275	1616888700000	orphaned
7229	3NL1JNCkpDDCsaPNk5kdpmKzQfGjQGaXQk5TdU2mK2kacG5qcdLu	7227	3NLoN6RrTLTn7AVmxjheZKqRpaoTodMPzWfai3qB5FY7gd91Frx1	1474	1203	81	1	6301	jwcxedxBsGP4hRWUGfMXiBPcA3TnCGVjFe7BtDXkCvpR4NL9LST	3737	5279	5279	1616889420000	canonical
7232	3NKz4xtf2V9sg2J99ucPpNEKc34Gw91Wbp9vLKABN3MoQME6QNeM	7229	3NL1JNCkpDDCsaPNk5kdpmKzQfGjQGaXQk5TdU2mK2kacG5qcdLu	1581	778	81	1	6301	jxjxLMs1L1wELXBu2mrPfX7ngVY5wRXDUZaDt7CN6UDTRpSTPsc	3738	5281	5281	1616889780000	canonical
7241	3NKMyjNhe74QjJwXwNCPnVub4LjcygQp8grj3s7Wjy9GHSmELXJf	7239	3NKN8b9SM8tNZUFwkrqCKfSouUfTyroAP3VPbPEeCLwE1NGwWYNf	470	943	81	1	6301	jwZ84TibE1YFkx8on1awDtX9QMxUWVGpsgTh1zDRQhtmTBFzvcz	3742	5286	5286	1616890680000	orphaned
7248	3NLF5rquB6W2hNr8uwSXbD6rPju1FCqWsZQJfjrF3w1FHAND214a	7247	3NKSuj4ZNPMfHkQZkbpkysgY81v9R3UuYvVDoSZbKm4wUwbpYv27	1534	164	81	1	6301	jwxAU2irKFsP9AJtgA6hXC1yQzBQ957Toq3U1U7Yb4hgLVuBLf3	3748	5296	5296	1616892480000	orphaned
7253	3NKig7UCMiVjqo5TJGdtPM8mjZefZfyBTMw2EFyaiGnWyVvMVxyY	7252	3NKMgQ9Edyry53TFBU1YtZiV1b9SxKTF5nzuvCCteRCpYynzqMir	1406	1393	81	1	6301	jxTkstEmobDT3tig15uZQeKC6cvk2GmFDKqLyB2FHvL3C5ieJkX	3751	5299	5299	1616893020000	orphaned
7255	3NLaUcKmsFWuteyyr7XPGJfzY3g2dwNMDbzbhw7efMW4QvQMweP1	7254	3NL8S4Ef4BUEujzRzPh5Q4mjEiwEJKCpHyYN6qSXJgyNiHexmwF9	1542	1178	81	1	6301	jwMqEAJCvnWRcCxjWezUxUHuVASegdszjqSF22coHbPUo2pshhJ	3752	5300	5300	1616893200000	canonical
9579	3NLHgchu4dMcZfviRufhAFHbXmAc4Re3pSfXwUDzkx8re9BCf7Qw	9577	3NKen2Hd6MX2wnvt9ftVoVniShed3f9L6ui8BFLj7tDusWPxSCXC	1406	1393	122	1	6301	jwXCAoaRAzS5xKH8B9rGQAgnWYnrrneixGzhnMEEm44zV9QJYYP	4969	6993	6993	1617197940000	canonical
7136	3NK5JveZCh8NanxDufGhofEPFMpxQ6KU8XzS8iEAgiuPohxmX1iM	7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	1467	1376	80	1	6301	jxyV6eRCa4YUf2paFmduK1zCCEBC8X4oGFddp8MzYBpWAF1qWbT	3688	5211	5211	1616877180000	orphaned
7141	3NKjWzcn86Q4HjgbcTwQGaQup3WQ3zqicc6MKjgR5sAY9K6a1As4	7139	3NLLck9Gq8ehdXY5ReiP2Nhd1aUUGHJcEt2BjAeUGEC4V4DT5xjD	1483	877	80	1	6301	jx1FyAawoAb7joTzL2UA4TS2SM7MdefMtPphvHU3QjkyPquvi1e	3690	5213	5213	1616877540000	canonical
7146	3NL1x77hgNKLLnrcAqt4pKUQrkmhP26aCwvVw9suXBnj8SUZnkGV	7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	1549	1362	80	1	6301	jxbybdXSw7X2Yqd1tcgWW2FDos2v4E27XYSnibmaYm91DV7XrnD	3693	5217	5217	1616878260000	orphaned
7151	3NLnXe2o6PtYfwjJWj9EcsFv7HH5JLL2Rf2bJnnvQjWpbgHB9L7D	7149	3NLE1KQMUNkK6m98DAvjUwJ9rBNK9xJgEPgk3NjiNWnVCFb594Uf	1600	1372	80	1	6301	jwASwvpCRRBn9XEFDkeeZY8KjxDVDDLoSv6Km6mzHz6WSjJEYU2	3695	5220	5220	1616878800000	canonical
7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	1607	1348	80	1	6301	jxvAtHGZapSMcSEUgrEvYYzdEMafeqfn4pCownZviofhEGvM6bW	3697	5223	5223	1616879340000	canonical
7160	3NLs5x41abTS6B2xmi2onvyFyH6kexwvmmeNN8TtvsmLLm3jwzQm	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1593	1100	80	1	6301	jxbfwsvVqQz7h6SnJezsAGo5Y3KixS77Z3npsAuVpZ1C46F7LVm	3698	5225	5225	1616879700000	canonical
7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	1406	1393	80	1	6301	jwHbJ1fpsg6nFPgz6zaLCFxDvfYeeNhsVaAPSStfbbzssQU2eCN	3700	5227	5227	1616880060000	canonical
7165	3NKB15UU7mA9Cr9Qm1WvBHysFX5FtEy4ghC5yCW7eqCmUaqVffPR	7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	1406	1393	80	1	6301	jxYTMwKiTUDTonQHpxYoLvjyWevpgRksCSHcQzZLqwNbr6Sj2H4	3701	5228	5228	1616880240000	canonical
7176	3NLdW6kJnbvaFDnvzJW2Z9sYq7XRyHcmZWntULM2APa1QV8HT8ZD	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1426	1364	80	1	6301	jxjGuLbUSr9HgyC7YPqtHEdz2pqCTz7X4Gok8yb6v5tqoF7o9CT	3707	5240	5240	1616882400000	orphaned
7183	3NKKWQjG5WKkRP5uFJvGaMbQzEksdMbwm8V8jcJxGy7CRAG7oc6n	7182	3NKc59PAMWuwXoHPazzVZV8gStxdp1rGEXfEtSe16XXXKoDb2FDU	1637	816	80	1	6301	jw7zQGE1WZajig9pXs8kE3Djq2nY2YDTALBdZZFDk1d1FBWGkzj	3711	5244	5244	1616883120000	canonical
7186	3NKBKnm3GvhBVcQtEZwvvDTsVnshao9GLgmVhG1jDd4pZhWkjwUU	7185	3NKnLAB48QvSiP2XMG4NJFwz41q4cqiJd8qSESeLZjhdrRm7bTkc	1403	824	80	1	6301	jwrB7oEM4GxrHj1CCPWVn5gmQvYihKMS2zHktuTLjm7HJMF4h32	3714	5247	5247	1616883660000	canonical
7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	7190	3NLhhraxPYQnZmSKn6DD4nR15wvcv1VjLir7mP1WBqcasAYEMegL	58	1281	80	1	6301	jwqynKd5CciPpukGqLyyWjR2NF5fUccedL2R1Ec5pcSrfYFDJt2	3718	5252	5252	1616884560000	canonical
7194	3NLvzQoQ4rE51YxW5fXNwHtaJC6sU39K8rFgt44reM46vnMTf928	7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	1407	1395	80	1	6301	jwrf4i2iBUZkiFo2YVYRDBkLutvsGL2vgLNu49gYzn1Q3c4m1rC	3719	5254	5254	1616884920000	canonical
7197	3NLHFDMxLuuq8dtt1y3HL69K1vSRYFoqYh77LbGoyKaMBSCQQ8VR	7195	3NLoZWbcgHgNFA4yt1mhNAbgKAT6tKb1dEsQeJ2NhH6dZFrUtyJk	1451	1046	81	1	6301	jx7a8ZqB9hzYxa8T494AfAV7wK5Qce2zXrcJyE7sTgQyFtF2Zfg	3721	5258	5258	1616885640000	orphaned
7199	3NKpN3ncYHRXHWhGEuiW3A48szv3ohuSMPZd3z3t4GpRykPsSSfP	7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	1588	1026	81	1	6301	jwT81eVy6VkYyDbhv63TPBiorRoGqer35UmqJmoKDKCdChsfLVT	3722	5259	5259	1616885820000	orphaned
7204	3NKvscDufkYwvnbqJy2F118wGZM2ZYQbQ2ENU2cwZhMbncytADct	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1407	1395	81	1	6301	jxdLrgefVyVoUVgcDcZtq67joeFdic9eCo78JEV5RpXMxPPDPVK	3723	5261	5261	1616886180000	orphaned
7209	3NKMmueZc75qW6Y1Dn2kgKM8B5BePVo8JxNhwhTTcAoHKF5mrQjc	7207	3NL6wuezwMRntgvceLZhL4vLTfvYvQ6ZXLTdfBe5N2CdTTg5acuX	1594	204	81	1	6301	jxrT6CbGwBg1xLt69AQEuALJZaxQGkotSxgBvzZ4vFD2PXceP5p	3726	5266	5266	1616887080000	orphaned
7211	3NKjMyd1jfWCQnqXqZ2vWmKJQYHqrVLeHYotGxyKqzAw7sf2dijc	7210	3NKHjU9MQnrfeLUJhbuZRCbJTwqFZWWVKWhiFyMKNexifc7Fd7Hw	1619	1029	81	1	6301	jw95A8JV5sbKQxfFCj2CnjtLvDv1LVCXpULNR3hB96nSYf7knXg	3728	5268	5268	1616887440000	canonical
7219	3NLjT1pa2q9ebLBuUcH6AvBQbjXxLfeNEHkX14spUuqEP95Su9NN	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1406	1393	81	1	6301	jwvPPYonqKnetYqQdydt2nan4yTqTUeCiR2WNdaseoAtoDMdPwS	3733	5275	5275	1616888700000	orphaned
7225	3NLY4Es7atoVAToLnez7xUyC1zgq8Eubu53j33jr2YLnMiE9nQoD	7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	1407	1395	81	1	6301	jwzwEGZG94iGUtKkxoTqar2xX6fmbt4hkR7FdJNbXu57UYhp7hr	3734	5276	5276	1616888880000	canonical
7223	3NLNgdArvXT7xBnr3WyxR5XTvjz42RHVrE63Y87nwYxgK45dAGog	7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	1607	269	81	1	6301	jxNtZ9EskaFzdhBmfRCtX2Y8NQiesyvkS8jE9AjVfxwfJH2ZM83	3734	5276	5276	1616888880000	orphaned
7228	3NLf8cHsfjN9wXW4adPPaZjLh89vzS4TQMZaZt4vW3DDtB4NtzEq	7227	3NLoN6RrTLTn7AVmxjheZKqRpaoTodMPzWfai3qB5FY7gd91Frx1	1405	865	81	1	6301	jwS8mBseTy8eUcxrjzmso6f7j4eAJtaxCZcd3Fi6YLMphyChWSg	3737	5279	5279	1616889420000	orphaned
7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	7234	3NLA3s9zsuchdqdFA9hH8TVsxdcirg4TjHyX4TNKwZ9QjaUdQiP2	58	1281	81	1	6301	jwd149Yt86TfD4ukw3kXcg3KxF6smEJLEJ2FQ9BvDrYBzq7fcrb	3740	5284	5284	1616890320000	canonical
7238	3NKWCyC6A6eJbDvrSwgRwXUDdHTToW9DVZ3ofKS5L8QnZ3U4RKf5	7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	1518	787	81	1	6301	jxCRGg5niwMUNTGnn76uFcAiHbAjLTQAVZWYS4nZK7stwVAyX5H	3741	5285	5285	1616890500000	orphaned
7242	3NKSYhax8KN9Q46U54Dixge42u9Hw2sQzMxoJNdxspSEZ8uZKodG	7240	3NLtYLcH2BG1zppRWHbsR7V1TGH4vCou3QfW74pwY5khgNE6Vx9f	1581	778	81	1	6301	jwNZxr6KEVfttTEksyaJJASMYg36VRW5e1yuUnz4DFYqu81T5iP	3743	5287	5287	1616890860000	canonical
7245	3NLi3kZzVjircojePqL19YHMiYP69wqQXtSX5PYQPwPYzDFvQKpA	7244	3NL5bSh1Xr5BEwUkq9N4JEAMfxobRzksq2ekUJa6EtAMX4fczKVy	618	618	81	1	6301	jxpxtfwpChd86WDW6a3pZ9mnxjN372bCRARu3UQeUdqCcv3UQ7w	3745	5292	5292	1616891760000	canonical
7250	3NKawYmpWVyoZKkFsYBDuGSNq43gMkxHTsQk3RrSRRdZvuYdJ3mZ	7249	3NKm3TyAuPxm1FJXfnXuu84nU4Qsg3DrbJynaur1f2fUVXHmapay	1559	1353	81	1	6301	jwsGLuW1u1kSrSGXdKBiUdZgh9X6hvmHixnnfChNDBPDSCVVQKZ	3749	5297	5297	1616892660000	orphaned
7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1588	1392	82	1	6301	jw96Jengxe5gPJff7J7fzJMnPmcN2PrBZd8nWDZvgPFEo261CTo	3757	5307	5307	1616894460000	canonical
7269	3NKJhRdNLYDKFhvF46m2TREEhJ9qMz1FaxDc3k9npr2FmMpHWyFi	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1656	1343	82	1	6301	jy24GhxgWeCPbb12vYT1WM85tQ7mPjthznP2SpnM4nroPUxqVsj	3758	5308	5308	1616894640000	orphaned
7271	3NLu4vzGqsgvTN1UXFA4Q65L92UJEnCnVVeDAtSd7NmVbEBenU9p	7270	3NLgQjtag6vTdVJPsHrheDQzgQFMoy8LsdoDhnXmA1qPwEPzUdbM	1671	1365	82	1	6301	jwAWRa6txXUtriTHZkB9CDETxayLQ5qwiRHkKeZDEV2WxiftxUf	3759	5310	5310	1616895000000	canonical
7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	7273	3NLebos3er8dhcu2wR9UqPp6bsiTeRTNFse1kibw2xnTFADFzF3r	1407	1395	82	1	6301	jxvxCbfj1vhMqxS7AZFYQuz3vWNf8NDhF4BFsevPupHhWmBkB8r	3761	5313	5313	1616895540000	canonical
7277	3NKG9ndUmB4xHSmUb6BwsaoaWzYDxJCfw4F7ssGhFGzTrzGdj3tC	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	1578	1050	82	1	6301	jx4i9VoZwWKk6U2sVuNZJRbWQSJM5X1dr3VkuvL1zK6UdtLGs4u	3762	5314	5314	1616895720000	orphaned
13881	3NKTgscXfCjHxyd78fFxGRD5y4uqhDtwGG3d8XMoyQ2UJHUA2cZM	13452	3NLoZBJkpksBmou3Dzszw1j8D77Uuq3Lny4aZ8GTMagNRAyyTcYh	632	1136	201	6301	10064	jxv9E8sgic1KtcJ3ZNzxS4u4kqKyHBirzMHARJekRT45JujY6ge	6931	10083	10083	1617754198770	orphaned
15948	3NLn92MctcjWD4W2diyZa6YRB9fT9JzgBEspw17hzQyrDMqvFmw8	15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	1481	790	248	6301	11939	jwxYc9WPwaa1nEr1wq9BJKzoPykP5t56ijWSZbwG6amUuzhH5ja	7890	11485	11485	1618006500000	orphaned
7260	3NLqDHQNnw4C7hAE7F5Luan2VKbQgD8fauEumDsADQu4hAR51qo2	7116	3NKUEF4tSZ8ZEkY21JKb1A9iw5jHQaxnqimJqmDQ5FbAr8gC2Mv9	1633	1390	79	1	6301	jwSbB4bTM5FM93hmiMCH5XjrBTLu3fFaEtaKw4WWHKDUzHvu3Xz	3677	5304	5304	1616893920000	orphaned
7143	3NKDAvax944Tp8KpduNrfBWa4wDivCxzpAkUfJkUwJmWfJ5Zkg1a	7141	3NKjWzcn86Q4HjgbcTwQGaQup3WQ3zqicc6MKjgR5sAY9K6a1As4	1637	816	80	1	6301	jxMgWxUYm6LSaYkDP6oTvvhvhzY4ubcYPeJUsqGYNZ7bTAgpiBz	3691	5215	5215	1616877900000	canonical
7145	3NKBehz5XWsX8hf4bdMBAuFpZGUE8ktRuGhSWc1MvxBGKg7WS51E	7144	3NLNgSFeYHjQGk63gP2WtNhMQXP2jHacSuszNz5UFvFFFXXDT7Hd	311	1061	80	1	6301	jxnem5mKU5TF37ca14QLCa4BmizfTVfWztdEpuUDCZJRDeMZiRH	3693	5217	5217	1616878260000	canonical
7159	3NLUJxaLgvzmRCtVMjgPHtcTMEdLLhEnGAMvWCjZpYxBapnJZSmP	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1617	1288	80	1	6301	jxGzZBEBJeC8uvhtaSRkCyV34DPgTbCi1C1RvTrNNmePAV3f3tg	3698	5225	5225	1616879700000	orphaned
7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	7160	3NLs5x41abTS6B2xmi2onvyFyH6kexwvmmeNN8TtvsmLLm3jwzQm	1403	824	80	1	6301	jwADA2MGdpTN4tvxQT9jjSqj9Y6j4b5BpGfrW9MK8Z5Mb36YrxR	3699	5226	5226	1616879880000	canonical
7172	3NLozf5se65JGt17LJ6u8oEeqkQ23WhhNWQ6D9TqrZE1Z4sN4sYG	7171	3NL5stnaRCCoyDavkCHUX9YY226xosH5vWS9CqmoMWQBRPZqhsNX	1581	778	80	1	6301	jwb77UaCD276QCfVbpSumBCFfUxMQNZ2BEfo27oUijUFnGgG111	3704	5234	5234	1616881320000	canonical
7179	3NKthqcN2eaFFmJ4j16QKodewJzX7XXBWj4vuNU4bDFnYcL9up5n	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1577	1081	80	1	6301	jxtykWkSiFefXzoTjCv5crc2dKrMjinYdKd2R9duDwJ3EV8JrzK	3707	5240	5240	1616882400000	orphaned
7180	3NLc73vXNqoFpAbsZVYhoRC9SYxiLoGRdDcanNrasEXPBBGFLSJb	7177	3NL9tubbZjq2cnSMwk6DZpEjcEFZAGfDneCFfgctxkKRubDXfjuL	1406	1393	80	1	6301	jxKuso75YYxtgURXMhS2P5LDtCXnvxJSiifWEhinMrVddJZXxrf	3708	5241	5241	1616882580000	canonical
7185	3NKnLAB48QvSiP2XMG4NJFwz41q4cqiJd8qSESeLZjhdrRm7bTkc	7184	3NKyHpZwPqsaSaBHq835wBKGMAJNCnRrerZABptWjGbWPy4YtK9G	1522	1076	80	1	6301	jxkzTVLewfxLdpVpDmyE79MYp9gpezdLZeTE9zfVpxGdQnjv9Yi	3713	5246	5246	1616883480000	canonical
7188	3NKwg1Q3c9qBNCJnPe7fi4AmYtMGCypM8ELM3jGdXgWtij6oAXob	7186	3NKBKnm3GvhBVcQtEZwvvDTsVnshao9GLgmVhG1jDd4pZhWkjwUU	58	1281	80	1	6301	jwXaKRDijet1cE5R9Rha8yFptpzxxtg9YCwjv9QmgN1y3ME1obw	3715	5248	5248	1616883840000	orphaned
7190	3NLhhraxPYQnZmSKn6DD4nR15wvcv1VjLir7mP1WBqcasAYEMegL	7189	3NLvNnVbWBMtsfVtdNFneNzEN1g2AkNmNRhxT48U3iWgczNA9Nqo	1460	1324	80	1	6301	jxmT9g6PDagy7W22Wdui7u15Yj1U3c7ZByndovRK9D1Pieu4ju6	3717	5250	5250	1616884200000	canonical
7193	3NLttd4aBusgCSb2SKUPyBSKiFbnygB4oNCw4b6HehhspniKV139	7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	1670	1156	80	1	6301	jwA3npuizP1yGxySFddCQfdU8Njo4WZPo9n6eatR4eSKmiRGaQ6	3719	5254	5254	1616884920000	orphaned
7198	3NLfvgaNP4JMsj5nB8qM4GuxCFpKf4voqTBVeEco5P11CbogqqPK	7194	3NLvzQoQ4rE51YxW5fXNwHtaJC6sU39K8rFgt44reM46vnMTf928	1451	1046	81	1	6301	jwFLctdBND7GmscHhpFMJMhYkK713q34mFGJDcfjjkt8Xg8Fg6t	3720	5258	5258	1616885640000	orphaned
7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	7195	3NLoZWbcgHgNFA4yt1mhNAbgKAT6tKb1dEsQeJ2NhH6dZFrUtyJk	1403	824	81	1	6301	jxnw7imt9AH15PfKuyLv564s8BakeJhrTEwn1w1nDjqNMvgfejn	3721	5258	5258	1616885640000	canonical
7208	3NK3WfS4cUyvLZeceYdSdJfdgLP29zXjbPxA6H3ffNHjJyUwniJT	7207	3NL6wuezwMRntgvceLZhL4vLTfvYvQ6ZXLTdfBe5N2CdTTg5acuX	1507	1280	81	1	6301	jx8P3cC2L67h4a4iKo9iBP27y6TjdEPWSzmMbz3hzUsBjWwazsQ	3726	5266	5266	1616887080000	canonical
7213	3NLsfJmLRDr5XNqr18VnVCRVjbJZCATWh8fgt7AcvfSFQuquDkR1	7211	3NKjMyd1jfWCQnqXqZ2vWmKJQYHqrVLeHYotGxyKqzAw7sf2dijc	1483	878	81	1	6301	jxF5TVy7esVgPRUFBzvzAKg2Q5cTUc6kt5RytaEzvpRjpjeNxVQ	3729	5269	5269	1616887620000	canonical
7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1560	1165	81	1	6301	jwGqUARkynEUBvxnwM8ie97YjJvwjE54qcRjkxQHBXeDQSP3h4v	3733	5275	5275	1616888700000	canonical
7227	3NLoN6RrTLTn7AVmxjheZKqRpaoTodMPzWfai3qB5FY7gd91Frx1	7226	3NLPLbyht5aDpytSVgahFDNUCzrDAPe8w9VxMj3KBk9nMG7MPbiL	633	1258	81	1	6301	jxR3ZTkwEQyp71a782mDB96NX3uzCUXP4kkFyieLKGycEJoyeoP	3736	5278	5278	1616889240000	canonical
7234	3NLA3s9zsuchdqdFA9hH8TVsxdcirg4TjHyX4TNKwZ9QjaUdQiP2	7232	3NKz4xtf2V9sg2J99ucPpNEKc34Gw91Wbp9vLKABN3MoQME6QNeM	1476	1371	81	1	6301	jxiX1LYiKti1fxARiYMSWjq9dN5mLBszpFa5ERpags3BdpqPra5	3739	5282	5282	1616889960000	canonical
7239	3NKN8b9SM8tNZUFwkrqCKfSouUfTyroAP3VPbPEeCLwE1NGwWYNf	7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	1513	1133	81	1	6301	jxUoQK3z2kH2DF29i9uEZfXd9T67nEL9PKaoPxzeZwnQhzVyw8M	3741	5285	5285	1616890500000	canonical
7237	3NKNX9pWV5BE7cddqAJuy12uqyDhrdgkh9sszR9XuyiA4xjSn9kf	7235	3NLEHTHR7LEL9eJgF7AiB7xXPGwoHjrYPVbK9F1Cjrp1C5dwkGgu	175	175	81	1	6301	jxQAYZs4uPKcZmLyd2rBgwjQxUFVhSThCPkCt9KDbnKX7RFVe94	3741	5285	5285	1616890500000	orphaned
7244	3NL5bSh1Xr5BEwUkq9N4JEAMfxobRzksq2ekUJa6EtAMX4fczKVy	7242	3NKSYhax8KN9Q46U54Dixge42u9Hw2sQzMxoJNdxspSEZ8uZKodG	1577	961	81	1	6301	jxbi1o3rfrtefTTHQFxzwjsxqziXTLzTMfDF38uRNkgrB1tcMhf	3744	5290	5290	1616891400000	canonical
7247	3NKSuj4ZNPMfHkQZkbpkysgY81v9R3UuYvVDoSZbKm4wUwbpYv27	7246	3NLGze4bzyX7Ev6vKApGmkDQkT4rutQkqihHSUvoMQCTjkFNJ9Dy	1631	794	81	1	6301	jwZTuaG5ptr1a5VsR8M2LNvsB3oVAT9u3aDrRRXQMB67AyUcEgo	3747	5294	5294	1616892120000	canonical
7249	3NKm3TyAuPxm1FJXfnXuu84nU4Qsg3DrbJynaur1f2fUVXHmapay	7247	3NKSuj4ZNPMfHkQZkbpkysgY81v9R3UuYvVDoSZbKm4wUwbpYv27	1476	1005	81	1	6301	jy1iCBYhBXPRS4Ag1RxKp4U77chWdg2Uzfed69EXJhyBbRgKrC2	3748	5296	5296	1616892480000	canonical
9715	3NLEz7AbWmguV7pcsKvFXv1as9AMtx85TQqg1jifYND2eMF2Q9fp	9578	3NKbcKDf1uYEnosFVmQEuaevEJkvVQMydoDbuCj27CHdsxrHw6dY	1487	53	122	1	6301	jw7LNqmdj5b4MoM4cgz75cZELbGfankur29xrv81ptKfVKnUfd2	4969	7087	7087	1617214860000	orphaned
7157	3NK68hW9oGQHoDn89Qn2TtRg2DGUKGyJWP3KXR4RQ8DXYgGcsA5r	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	1587	1357	80	1	6301	jxT4fxKPkmMsR11z5CVaFKrHGM2kQHBQvwBGAQkpbPnjuqvzxGs	3698	5225	5225	1616879700000	orphaned
7166	3NLSdHSp6Li78GiaSEQkAXBBBjakP9E93HF7cmm7G1rMuSMz1XDb	7163	3NLTQ4BCSgm17AVAmRaH1cCJ4GMxofpQGYpT43x9XCCCGoQYqbzC	596	1306	80	1	6301	jxCR9EwQxDf8o4XtBLQoVZK9qSf3neruFcNzwqDB2faD6dytbe7	3701	5228	5228	1616880240000	orphaned
7168	3NL9yHvXAZD1VMHNKc3dPr5V6JccdmwTrDYSF7JErBVuGsKFAddF	7165	3NKB15UU7mA9Cr9Qm1WvBHysFX5FtEy4ghC5yCW7eqCmUaqVffPR	633	1384	80	1	6301	jwiNWUqG1hJ5EigWJGda2TfEWLxzSi35itkmWoS7TX9Bwvhhtv7	3702	5229	5229	1616880420000	canonical
7170	3NK6ZaSueMqvraZZJfWphiqqkqpYcN7Ebko7Uc9RmuwvF2aZ3SvK	7168	3NL9yHvXAZD1VMHNKc3dPr5V6JccdmwTrDYSF7JErBVuGsKFAddF	1546	973	80	1	6301	jwJr1ZVxcGcsoDWPJPvj4ccNgkN9r5JUKrgPtMwbeeRKuXAjJ6A	3703	5230	5230	1616880600000	orphaned
7174	3NLJg97gSBsaz8dgXxW1ghNrk1MpwVMgaDU24yuMdmHATZ9Qdbx6	7172	3NLozf5se65JGt17LJ6u8oEeqkQ23WhhNWQ6D9TqrZE1Z4sN4sYG	563	1233	80	1	6301	jxAAXSdkcdLk4sbmWbUFGpGcq3wQsC6rqaj85uQL48ZYfeY199Z	3705	5236	5236	1616881680000	orphaned
7177	3NL9tubbZjq2cnSMwk6DZpEjcEFZAGfDneCFfgctxkKRubDXfjuL	7175	3NLctEFjkRs9QhAmZF8kDvGKbTd5gCNbZsDpUPBWTGQnWs1tmLxb	1407	1395	80	1	6301	jwNBMKbmULqDQyUE9Pab4ujqhBLbrxJpKwNt8eEALfTapweuXYU	3707	5240	5240	1616882400000	canonical
7181	3NLPMPFBN235ocvVMPK4PvFN7HACLZjXSfF6Paz3dKatGwjv9R48	7180	3NLc73vXNqoFpAbsZVYhoRC9SYxiLoGRdDcanNrasEXPBBGFLSJb	1637	816	80	1	6301	jxSKQQNK49CvejkoQCyJ387GnrWoiekAZiaFzqTMyE9wPGxbSrA	3709	5242	5242	1616882760000	canonical
7184	3NKyHpZwPqsaSaBHq835wBKGMAJNCnRrerZABptWjGbWPy4YtK9G	7183	3NKKWQjG5WKkRP5uFJvGaMbQzEksdMbwm8V8jcJxGy7CRAG7oc6n	684	1352	80	1	6301	jxFMWD2cFoPNxaAo9xHyAVDGuSHrtVrsmCocc15BGrtETz1Y6PX	3712	5245	5245	1616883300000	canonical
7192	3NLQzbaAi6cfJ9728BF253nA9T4nQhwxJmsHUdU3oVt6LGAQAii2	7191	3NLmANxvgJXmkkmmKJHKNgwpScek4Pv5tbbbe7bNwME3yvCeGzn2	1670	1156	80	1	6301	jwA3npuizP1yGxySFddCQfdU8Njo4WZPo9n6eatR4eSKmiRGaQ6	3719	5254	5254	1616884920000	orphaned
7195	3NLoZWbcgHgNFA4yt1mhNAbgKAT6tKb1dEsQeJ2NhH6dZFrUtyJk	7194	3NLvzQoQ4rE51YxW5fXNwHtaJC6sU39K8rFgt44reM46vnMTf928	1631	794	81	1	6301	jxTqDGwJcHky6poPZLBjRq6ircmN8XVo8MbsmmbZ1RSzsodeT88	3720	5256	5256	1616885280000	canonical
7200	3NKtF8DG1jgsromkCAb2m3RxK5HxGuw25CmyDf7U28EFp3UxK5gz	7196	3NKVAdtpaN7tPUfZv3xsbhQxDietFsmAwtZesccb1SoSigGjGkjH	1407	1395	81	1	6301	jxPpvv6TiUuH7tRcbAf8kAPHapvJfPDRQbLPw9rWQzKYUoJ1njk	3722	5259	5259	1616885820000	orphaned
7205	3NLBuunRVxpqoYdpnVUBakvCed73BepX1bAQYJeedVGYvYM11xuo	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1440	1131	81	1	6301	jxwP9DrRK1fDG2JSCFjddA3xpy3gmyhYK1GN2MDSGngeBPYUQNe	3723	5261	5261	1616886180000	canonical
7202	3NKKAnBHrsxKd3QHmdQaiY2jEbSBD4jvu6PaB4iExHtabQ2Yric2	7201	3NK6orLTxumrjmqGkZUcWYvSF6KxcSGEEEGsZWLZyYcQwhdSqS8p	1503	1031	81	1	6301	jwJBsxGLTHTBfZDvLsTDfiY8pUr8LHCX4BnGFaqxsR127hPkgqt	3723	5261	5261	1616886180000	orphaned
7206	3NLRocEgtYUf2zS8shjwhAai8okUviPP7jBpoPUTU3w5XXavqUG3	7205	3NLBuunRVxpqoYdpnVUBakvCed73BepX1bAQYJeedVGYvYM11xuo	1407	1395	81	1	6301	jxDQmyUqigCfCTAJ6MToXjh43punA9D5V982zoaWkCqdNqf4zC9	3724	5262	5262	1616886360000	canonical
7207	3NL6wuezwMRntgvceLZhL4vLTfvYvQ6ZXLTdfBe5N2CdTTg5acuX	7206	3NLRocEgtYUf2zS8shjwhAai8okUviPP7jBpoPUTU3w5XXavqUG3	1675	1342	81	1	6301	jxpwHQAPqQgk3fd3PCnUdaJqn5EetHz7ZFXa8riztKwbYyzzgvL	3725	5265	5265	1616886900000	canonical
7212	3NKmNTC4HiJ7MMSdo677PX96KXsTTRQDQ48U6aP5fBwi73MJrYYG	7210	3NKHjU9MQnrfeLUJhbuZRCbJTwqFZWWVKWhiFyMKNexifc7Fd7Hw	1642	1121	81	1	6301	jxY8vvg2donTSMt7jGZBW4Wk6HLfbcQ3kgeJZ4rVMzsfkefNtiL	3728	5268	5268	1616887440000	orphaned
7214	3NLhQAPGFKm2pxhbfTzfu4FLA1iXomv1b5xhh87Xp66mqK5khcQE	7213	3NLsfJmLRDr5XNqr18VnVCRVjbJZCATWh8fgt7AcvfSFQuquDkR1	58	1155	81	1	6301	jwHFVRm1TjqDiVe9Xa7PdS2khg6XDLDBvPZQcVJm5TYedQopyrg	3730	5270	5270	1616887800000	canonical
7215	3NKbNqRCSBGJWB19GJy6TnStNdBUWutKHhPUfWvVeaNAucMvPU8Y	7214	3NLhQAPGFKm2pxhbfTzfu4FLA1iXomv1b5xhh87Xp66mqK5khcQE	1649	1017	81	1	6301	jwHCXjFJiUyzCvzD3jxDc2FvzViqFCbKHBj7jieVStLk11GPcCz	3731	5273	5273	1616888340000	orphaned
7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	7216	3NKDwqmHK3PoQe8TMoyHBB87JjhUP1U8a41CtnGAqMnUEJHi7NoQ	1581	778	81	1	6301	jwkiF9X6T2Z3omJ4SpqxKis1sHnK8dc2zK7fhvqJqUjAh5EF6tQ	3732	5274	5274	1616888520000	canonical
7220	3NKxL8E8d2T1wKbBPweVekGFpqhZBuZ2whtiWjBaLMMzCGBcbHER	7217	3NKFzRTM62qcxWpyb6srf9tcdyF8EDRPwMc92iAHHPWhP9bqPztR	1567	567	81	1	6301	jxayVkTdyzwm2dWmNnR5tF4TepyFx444BAiNfWkXN5eWD6FJp7V	3733	5275	5275	1616888700000	orphaned
7224	3NL6zuRhQzVUyPT2xUFG8n7x9kWDsLYHwqvcA4HG6maGnh8mo2sg	7222	3NLnLj4HB5cR247tfzNbokuMentWCaCA6CSzb1ikiTzwkuf6FNg4	1593	1346	81	1	6301	jx3ymWBnXW2BuGAdkFRynpHFg7SFWHgReiExg7C1vV4L9yuXBHt	3734	5276	5276	1616888880000	orphaned
7226	3NLPLbyht5aDpytSVgahFDNUCzrDAPe8w9VxMj3KBk9nMG7MPbiL	7225	3NLY4Es7atoVAToLnez7xUyC1zgq8Eubu53j33jr2YLnMiE9nQoD	1406	1393	81	1	6301	jwetptE33bS5jofFTFUyxHB3DniHT2dcpn3eK61h1zQPGpa9mjc	3735	5277	5277	1616889060000	canonical
7231	3NLC88ydWvkF74sbWZ8iG7chko6SpsqzmwqT1TA5SRg5nGgfJe5M	7229	3NL1JNCkpDDCsaPNk5kdpmKzQfGjQGaXQk5TdU2mK2kacG5qcdLu	1422	1337	81	1	6301	jx1NQbRvyTfpBNDrAURfNH6yGbh5hXuAPiTQ8nXStQgtGRvh9jw	3738	5281	5281	1616889780000	orphaned
7233	3NLhqdCcubwaJ3UvnWGuxLyBawaJLzfdNZEpmBzXWC3pAjbzH3t6	7232	3NKz4xtf2V9sg2J99ucPpNEKc34Gw91Wbp9vLKABN3MoQME6QNeM	1406	1393	81	1	6301	jxb3qoDkiapfhsF32ScMTokjRj3H6HTaJqW33BAANX6Kd7meEiq	3739	5282	5282	1616889960000	orphaned
7236	3NLJWEv8JK6q3rKA3Qk38aSYycm4LQ6mzmR46ZfsAf1YMqiSP3Rf	7234	3NLA3s9zsuchdqdFA9hH8TVsxdcirg4TjHyX4TNKwZ9QjaUdQiP2	1508	1387	81	1	6301	jxx3VFZkenp5YP5f1ZZwAvJhSYxKDcuD1rzuNATNwNeEGBicPnN	3740	5284	5284	1616890320000	orphaned
7240	3NLtYLcH2BG1zppRWHbsR7V1TGH4vCou3QfW74pwY5khgNE6Vx9f	7239	3NKN8b9SM8tNZUFwkrqCKfSouUfTyroAP3VPbPEeCLwE1NGwWYNf	1426	1118	81	1	6301	jxSujXKhft2dV5hpe9LLepsMYWnsq8KNpo3LYbd5r18t8xo4kcj	3742	5286	5286	1616890680000	canonical
7243	3NKyZrr3QpaHyX52dvqySVyYPGGNgJcLsYNNMQ33zhx1MkKYuPdW	7242	3NKSYhax8KN9Q46U54Dixge42u9Hw2sQzMxoJNdxspSEZ8uZKodG	1407	1395	81	1	6301	jwjauwUiL2WmhrH69FbicdGommGu4MeHvYm3ZUamknoDWDyTG1c	3744	5290	5290	1616891400000	orphaned
7246	3NLGze4bzyX7Ev6vKApGmkDQkT4rutQkqihHSUvoMQCTjkFNJ9Dy	7245	3NLi3kZzVjircojePqL19YHMiYP69wqQXtSX5PYQPwPYzDFvQKpA	1402	888	81	1	6301	jxCBb9BofS9e44eQoCPSMmSq6dPYky3LKMTfK6k8WjJaY5nemAQ	3746	5293	5293	1616891940000	canonical
13464	3NK7tce8ujnKPUq9xg66xuwARgpPH6Z9g9QuDTiz2yuxvdbAMbTB	13462	3NLq4MAVV7f4wB5L86WNZK7uwaWQw4XMxRL3Grsgru5or5CieX2Z	1406	1393	201	6301	9703	jwSL1mWowdB86pi6GBZqUpqAB1ApSz7EJpcrU54DzKANvctEiJA	6936	9802	9802	1617703560000	canonical
7256	3NK3GRnjVvjvtCeCKoB3ti96jfGqKK5x71dKjQbnCknp1XJQTbfd	7255	3NLaUcKmsFWuteyyr7XPGJfzY3g2dwNMDbzbhw7efMW4QvQMweP1	1403	812	81	1	6301	jxBqhucC1sd2BKf2SHhioEVtKjYfykU1w8u2DMAnQ6V468Kztqu	3753	5301	5301	1616893380000	canonical
7258	3NL66uHLjcxpVwopNFinbqHbYRgoejS7q9fAvbvfjGCSwnbP3UsQ	7256	3NK3GRnjVvjvtCeCKoB3ti96jfGqKK5x71dKjQbnCknp1XJQTbfd	1627	1259	81	1	6301	jwvGVp4eo6fjGK8LwSBBQHNPUVjqv4xoE1MuskEDTRXya5m5z3V	3754	5302	5302	1616893560000	canonical
7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	7259	3NKX4grV9F8518duQ7FoeGdDsrF1hDXcX8emxydLhqa389XSkc5n	1402	854	81	1	6301	jwJgynKJFa2185bk8qYyvjdZoMjevM5ndknEJcGSCeMHYUASc91	3756	5306	5306	1616894280000	canonical
7270	3NLgQjtag6vTdVJPsHrheDQzgQFMoy8LsdoDhnXmA1qPwEPzUdbM	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1407	1395	82	1	6301	jxVQzi87LxhfNpnureFe7PEXDWgpUnknvR8hDyY2uvTmc9LxNGw	3758	5308	5308	1616894640000	canonical
7273	3NLebos3er8dhcu2wR9UqPp6bsiTeRTNFse1kibw2xnTFADFzF3r	7271	3NLu4vzGqsgvTN1UXFA4Q65L92UJEnCnVVeDAtSd7NmVbEBenU9p	1555	1101	82	1	6301	jxQ9EYmdVPSEGsCNBzk6XiMGrEWJv7PYeBiULG89VkcQozwmYbD	3760	5311	5311	1616895180000	canonical
7278	3NL6xVFVUXFoiCg12f1mFowogRctw6bGRZQujpduLb7LzmTKXBdd	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	1578	1050	82	1	6301	jwL9TLbd9KbR6M9A3Awx5xK7jVDqHPSUXWraRdK3gwxgRKWjfQE	3762	5314	5314	1616895720000	canonical
7275	3NL5bPr2R7Qg8GBVDbZBf3aGDAoC655oBheXAqkxiu2HwUbSgBgh	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	152	1084	82	1	6301	jwztCSBYr9h1v8zosaQjqBCNRP7STpdCG7sGQwhR1ooo6BMwdbG	3762	5314	5314	1616895720000	orphaned
7284	3NKdQrEKYjE2k3n5cpVDjP1KZXZ9Mvms2Wx16KRtHDbP78VD21Dn	7283	3NKta2dhe6Tj3MYctv23BzaT94ZMWB9ntUGY9Ec34SfeA6tmgBwp	1406	1393	82	1	6301	jwjN227raKoTUMaT3o7RbfqHbF4zNzrGp2BMzpYj5VmYLSkEqQB	3765	5318	5318	1616896440000	canonical
7287	3NLbBT9sN98S7BfDTTGFCuMUa875MmP1mYmkFEUuryYA9Xekpk2M	7286	3NKoqKHsmE89YA9KRQkRuqpKMwcz5mSNat7tJ1FbRmd56Muxkzn6	1656	580	82	1	6301	jwFGwgyck9j4L9YiiQp5PyZ1j2UsLp9J2suyM6SfVWcNknBpy6Z	3767	5321	5321	1616896980000	canonical
7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	7290	3NKqUqRNBANAuuxZap1HnUZznWTv7xB9bEwwizHsKkLo8LpQQAiG	1422	1091	82	1	6301	jwZQMNLbnCpPrTJJbJ6bXpSxAEEspXhc7qeGqNYts9bybZ8YM6h	3769	5323	5323	1616897340000	canonical
7295	3NKdFR4hQZfWA8nLELdpFvbsKHXfYKQfYkTRvPqAxpXQr29XTD4o	7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	1513	1133	82	1	6301	jwTc6cGXVhEs7dLUGmrsaYyngK11gAdzKfFcSnFAA6h2Tepws7j	3770	5325	5325	1616897700000	orphaned
7299	3NL1DjKSskUdJdMQN9YiEF9kKx3bWJoRpzqftrFDHkFDoK1Sz3JP	7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	1594	1326	82	1	6301	jxEfB7GkaAEZCWFCBgjXZbnLginMtmNargXGub4mCNCNRZpMJhN	3771	5328	5328	1616898240000	orphaned
7301	3NLAHBrwMcQRQxrcAySz1ACSijGKj9UD4rNVHWMTS79zBxwfc8PW	7298	3NKsU2UfzxtWAzj2akTqt3Ji1JhwLsYAF9SMxmJnCRsPzRYDSbAx	1457	1145	82	1	6301	jxYYkxgFHf8SGFSjNCFxL2Een2efbLUs2AjgnDNrR1zPzGMdgsu	3772	5329	5329	1616898420000	canonical
7302	3NKf4gwW5vwgjVLQYd2suvYXweppKmxMRSRGhXyrLsm7ZnkiN1iX	7301	3NLAHBrwMcQRQxrcAySz1ACSijGKj9UD4rNVHWMTS79zBxwfc8PW	1542	1304	82	1	6301	jwiVFps9gcpnYqh9MuzuBpU8Cfr9yoKWVJsD6JaCdqtYCJj8P5o	3773	5334	5334	1616899320000	orphaned
7307	3NLRzooQAHX5a5N6V5uZ5rP9J4L8qxCtZXVbmwBKomzXPnHE3HnZ	7305	3NLQvLMJGYyekTLJ19yN3kDFhy9UbrgEqH42Vz4gf9cMqsfcAKEq	1406	1393	82	1	6301	jwtdVfAPJ5bvttQTGLo7LE72YaVG7nNWqCsESncpXqyy6XgSo7p	3775	5336	5336	1616899680000	canonical
7311	3NLAHJYqEaR5fXLTDXphQycTT9regMD2LQBDBzRqFcZ8hWKdF5YF	7309	3NKnVz6iSXFb3GhDvwMRkRJEnzpJd3TvuCybDrMXw3ADXGpiAB8H	1651	1175	82	1	6301	jxzbNPuB3Fj3hsbo6Y6KM16S4YdfgYNPNijizMu47S1v4tVg4Lo	3778	5343	5343	1616900940000	orphaned
7313	3NLmU6boiafJqivFDYTiNziL6iUinYfhjCW4aVQ7emGw4bamDmHW	7310	3NL9wYJnVBxFFMMe5SLVaW7EPUxu1emPWamtTLXPPLi11XyVYS5k	1506	1373	82	1	6301	jxib4LXbi5VjsiiH4vzgyLi1Y6ae7oaTKE5VZcM7h4QCHTRFgn1	3779	5344	5344	1616901120000	canonical
7316	3NLTqZ4TTwGTr4WHrvYkYhkimVrwKZJEBGiGfnyGmnd5RxJAALtr	7314	3NKzn1Pg8gy4sR8E3wgrH69RKSgcNcoZuyyFukxnDJRA7oJB2eog	1467	1010	82	1	6301	jwbGqz6eci6MADoBm85vL2Ntz5FRBuNwiBYbmkRVN81yv7TK8UQ	3781	5347	5347	1616901660000	canonical
7324	3NLanDUq1B1NNPBTadv8Nt7Wx5hQm5xXTmAg5DWdYVRZeG6JJPq2	7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	1407	1395	82	1	6301	jxrBKStSWeuAN15ffsmq96qXNycWALkJVYEYpUBgKL884MsycMw	3785	5353	5353	1616902740000	orphaned
7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	7322	3NLX8KDpZqtGnoyZrLAKiMtU2qTPPovCmjju55E2QyrDxBSfpVMG	1581	778	82	1	6301	jxBPE9hnmYx8ATWfErvvCYnnjbUhrH9RTurmJsuQ2n8SVMBGdqb	3786	5354	5354	1616902920000	canonical
7332	3NKUhDVBkk6fkj8NayrtTJUZioKejkduuZ4eyVWf5C51QDbzgicC	7329	3NKWsyimGuRwrWVnbFFKJpTrHdzZx1mtxacADpwwgnCq15rN5aTp	1637	816	82	1	6301	jx2W3DQHFBJeDsoakANgBHAsXW7FjrZASCZ1kt21nctbAgy9nKo	3789	5357	5357	1616903460000	canonical
7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	7332	3NKUhDVBkk6fkj8NayrtTJUZioKejkduuZ4eyVWf5C51QDbzgicC	1503	1277	82	1	6301	jxDBT62LSTGhrk2oJTKWMVSy8F3mZUBdcwcak9WExiuyK3Ps74c	3790	5358	5358	1616903640000	canonical
7342	3NKHrtbDhZsCEoDFwxtsuR2w5oWWi2f9aP9vSmodNgdoJpmE2WPm	7339	3NKszrWR2oCP3p5d6eo7WZpc1nSdWT2oCaZMWzQmnBU1Engq8EeY	1406	1393	83	1	6301	jxyusaphgE61P6Mw496JUNVJiGeDiF4LsTbWM2UjwkraeW8zvbr	3794	5366	5366	1616905080000	canonical
7345	3NLZA55siB5iRKfgzNmvCcD8ktqqXjQC1aghAGjqGCxaegMSrYQk	7343	3NLSHPAAwhsjahYHaoKjG2Bvdrrwh5u9JivnzuWkJfjHitUV1WiW	1631	794	83	1	6301	jxKUkUA395u4EMk5KDPwzxgv8AoVFp6TuGeamLgBmh7MaezmNiA	3796	5368	5368	1616905440000	canonical
7350	3NKdjyUfkoeuqFwHvdcZqdggxVFYm11i5z5NYBsEDubRd3NtHz7Q	7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	1481	790	83	1	6301	jws16WTankM3Li3wdujZrmgasHqTwWcAVpu2FrggfUkrrY7eU8Y	3799	5371	5371	1616905980000	canonical
7358	3NK4nioh4fh7gP93DxH9BLxioJf8z489izPj8o52fm9w5XUCJ4rQ	7355	3NKGp1J2kSXUmahUN2eqrAKxYy2rFu17Y8HifTFwkVu1dMjoTb3t	1481	790	83	1	6301	jxfEBrJEMmJ8YvX7gpx1rEQ2otjHeMRDwJjz2caAsBXKwcg8E8C	3802	5375	5375	1616906700000	orphaned
7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	1536	1313	83	1	6301	jwaaQ7NgJTQjyxZfqXvqZ38rQs3NKq8ZsYTL6EHbxiVXjvG21hM	3803	5376	5376	1616906880000	canonical
7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	1559	1227	83	1	6301	jwpCGsL8GNfbA9NGSNJY1UipKwkCM2ApYAUifzaZ2dFHd9Wc626	3804	5377	5377	1616907060000	canonical
7362	3NKMDR4PdfmJEQwQHdjxgui4edWq6MRt2Z1wguLSuyHou8yfuXTQ	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	298	942	83	1	6301	jwgcCu6FPxckCbM5XyuaPQLp6sYA8UrmcMZSVMUnVTGno7AYAWS	3804	5377	5377	1616907060000	orphaned
7264	3NK5nnmEfdC6HineGXcbEwh6KNScPFvAMYwyGxE4WtqzAkLXFdiH	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1460	1078	82	1	6301	jwDsRmpcjnZjWbXjmjcUxuDo7Srero7MUwPXXS1UhoM6BbASrcU	3757	5307	5307	1616894460000	orphaned
7279	3NLefJAXZSdmsD8FfjQiRZ9pe5ti4zHCXj5kLCvL3ENSQkbErfcr	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1500	1297	82	1	6301	jwUFhkaiwFu73M93KnwV9UHoHr6sFemqtn48MGRVvdbPEtaSQ3U	3758	5315	5315	1616895900000	orphaned
7341	3NKB7XBfRvaCSVru7xcXHLkgmFxjBeEYFsm7WTrUZGbVAjHHo7ot	7149	3NLE1KQMUNkK6m98DAvjUwJ9rBNK9xJgEPgk3NjiNWnVCFb594Uf	641	1336	80	1	6301	jxjcQjyYwjMQaEaBJCUd3cJ7XvaWRCtxhu7KDEFkpcohzUyyaYn	3695	5363	5363	1616904540000	orphaned
7272	3NLQAKXyJD8gZb7KzyCuACM1PY8RJ7AjdXZz2HocB6j4qftr5ErT	7271	3NLu4vzGqsgvTN1UXFA4Q65L92UJEnCnVVeDAtSd7NmVbEBenU9p	1407	1395	82	1	6301	jxN6fYdrtZZ3yxw9EyGSbc1syAd3azPGiuo1ga9YyJTSioXmDPQ	3760	5311	5311	1616895180000	orphaned
7291	3NKVFVGX2oV1Lnexxd75fnCw1PS2czGfXScGZTcwkC4NFG8yyXsA	7290	3NKqUqRNBANAuuxZap1HnUZznWTv7xB9bEwwizHsKkLo8LpQQAiG	1668	1124	82	1	6301	jwMMUxUk2BiW6hAt8bLu6CbZGRAjKwUS8BKT9T2Ji9NVLcrnjqd	3769	5323	5323	1616897340000	orphaned
7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	1406	1393	82	1	6301	jwBrX6v2E4AV6nF3HqnPQFTQKD9jEgcdfjc5jFRVXvR8DYMpFXC	3770	5325	5325	1616897700000	canonical
7298	3NKsU2UfzxtWAzj2akTqt3Ji1JhwLsYAF9SMxmJnCRsPzRYDSbAx	7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	1516	1294	82	1	6301	jwThwih8gKQLcg6PpJYhcUCMue3rbFAmoNohbVBPUfR1G6gVnjq	3771	5328	5328	1616898240000	canonical
7304	3NLXzFaA12Cnr5nWwznA5uWMA2xz9stMeX54UzR92DVgph8hVHYG	7303	3NKU5qXuUJxjJPWq2x1ra2oCWrbQTaPu8jZzzQQiFBjQbj8n9E1S	1406	1393	82	1	6301	jxznidkzGDs2aTvRYYCS432CygbpqDg6jqfNDCgSf4mhqp5KAhL	3774	5335	5335	1616899500000	orphaned
7306	3NK5xTTQqfeaXTagMcniLuSvg25L16khDNs5ff7G8RWmxEwi2JQb	7305	3NLQvLMJGYyekTLJ19yN3kDFhy9UbrgEqH42Vz4gf9cMqsfcAKEq	1451	1292	82	1	6301	jwNHPA6TFBmwo8uh8qf7L48t4NAxUwne6G8x2RfGB5hdg9Zhcej	3775	5336	5336	1616899680000	orphaned
7309	3NKnVz6iSXFb3GhDvwMRkRJEnzpJd3TvuCybDrMXw3ADXGpiAB8H	7308	3NKUDie7xSndzsUqbKKmCJhkXGmVkFkm6JyBMvNYWrXoCycjSWB7	1397	838	82	1	6301	jwWjiecfWTKdbsmBAzU8QR2WPdo8PuQVGxSoNbQSPgmqhWy7XGd	3777	5340	5340	1616900400000	canonical
7310	3NL9wYJnVBxFFMMe5SLVaW7EPUxu1emPWamtTLXPPLi11XyVYS5k	7309	3NKnVz6iSXFb3GhDvwMRkRJEnzpJd3TvuCybDrMXw3ADXGpiAB8H	700	840	82	1	6301	jwS9FuQKzttty5BpgE94atiZzCp6hh9QHTu6hJ97KAEYkNgTZVe	3778	5343	5343	1616900940000	canonical
7312	3NLoaPPse9yHRG2pdh1XRCmWyM3QkMBvFB5TSW5t25YMCoyEfzqs	7310	3NL9wYJnVBxFFMMe5SLVaW7EPUxu1emPWamtTLXPPLi11XyVYS5k	1542	938	82	1	6301	jx9mf7u8xKZ8FiwiM8N1R5C3V659ZHc6ktWw1kXR4FNitECBkFK	3779	5344	5344	1616901120000	orphaned
7354	3NKg2FnBnjtKzydQhn4vajVDiE96S4433ZanSJc3Qvw3RptQ5AgX	7313	3NLmU6boiafJqivFDYTiNziL6iUinYfhjCW4aVQ7emGw4bamDmHW	1426	1364	82	1	6301	jwjZ4gDsz9WfzTAukzeJM2RnV5jpvqefa4mYBx3v3xmMRZrfKvM	3780	5372	5372	1616906160000	orphaned
7315	3NKoxnp6cJdqLpNXeiQAUT8XzUZ1tYSy6kHPxjwLdiQyk6GpcEA3	7314	3NKzn1Pg8gy4sR8E3wgrH69RKSgcNcoZuyyFukxnDJRA7oJB2eog	1444	1255	82	1	6301	jwaGt3qon7LfLTYW8yBoxs7Ss52BGgzTWR4h4YhqSGPqb9zWxGf	3781	5347	5347	1616901660000	orphaned
7318	3NLNAAuCQMpyyuy3z5nVtk1KnEtj6jt8UsUN4r7zRisbLezHXHog	7316	3NLTqZ4TTwGTr4WHrvYkYhkimVrwKZJEBGiGfnyGmnd5RxJAALtr	1647	1056	82	1	6301	jxK2EYqT56H9QejL96WfMCUxtM9dkBfsdzerUT5MCCmczDvHfG8	3782	5350	5350	1616902200000	orphaned
7323	3NLxDUJ5D1BmzSp1RUM5z6fx6BxjWtD5Gq5CCsGF1rLuhzgY4rKF	7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	1508	1141	82	1	6301	jwyAnYFj5WcmHRWE9BRWbetJV4pvcxgQmLKs9q1dLVNCXmw68mV	3785	5353	5353	1616902740000	orphaned
7330	3NL23SS3EYNWyj93W31AiGpzwgP8BUgkCBX6h1BHYxFg9Nx5oKPN	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1647	1056	82	1	6301	jwKSqWemB25s8eAaxwqzccgF9ZKyueEtoQYUtLXYgKqkLW3oZNd	3788	5356	5356	1616903280000	orphaned
7337	3NKHraVRpo3DKR3DRRH5eANt8reJYbFBvbEXnADXFh4GJkCB6R6N	7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	1407	1395	82	1	6301	jwqXJUoRUsSc2tL4NnHDc4uRhzwdujr9HrmxzsLUrEn8ZBxAbAr	3791	5359	5359	1616903820000	orphaned
7339	3NKszrWR2oCP3p5d6eo7WZpc1nSdWT2oCaZMWzQmnBU1Engq8EeY	7338	3NKvaa18vd7t6YobauH6437FnzNZa91QfCbXoyZgYuejf61NEBmU	1560	1291	83	1	6301	jx4uxwAHatHqUJtaBEPoMuG8qwCjHTzUrdhMQppwJNRaqdojgTj	3793	5363	5363	1616904540000	canonical
7344	3NKT6u9ribsEQafSicDxGAtp8YdENp5TRFaTQWJs8LVFQYumcMYm	7343	3NLSHPAAwhsjahYHaoKjG2Bvdrrwh5u9JivnzuWkJfjHitUV1WiW	1447	524	83	1	6301	jwvhX6XwkW6KbntXWoMTCAdAhkZ9ALLSUTa7CpK2PguJbQ4Dkaz	3796	5368	5368	1616905440000	orphaned
7347	3NLnmjBe1QNzs82g8UUJNT1L7gjQYjxstc3PAs7WMt6qLtLrQwym	7345	3NLZA55siB5iRKfgzNmvCcD8ktqqXjQC1aghAGjqGCxaegMSrYQk	1457	1391	83	1	6301	jwvLBgDSa8yQQfnEBkc1yBTZS9auZbMtdP3AUdnHFe1XM5mSfRW	3797	5369	5369	1616905620000	orphaned
7349	3NKpC6MMo8Rdi4op16eFwhNq7LwFXhkWqvSMenRM6gpqgTMynRse	7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	1500	1171	83	1	6301	jxzh18vamUJTSTWRhpkpSQbbeJkVcTUGU5wA9wXPvUTxjHSYc1m	3799	5371	5371	1616905980000	orphaned
7356	3NLGmrQHZQB2Btn6ZdquZ68pKVVb1R7cfiDPEqXX3xnzpoYZhmC9	7352	3NKVcrb7NxkmstNFzkSxczt2tYLf1Y7SZpQsPppw1Hd43zyyzwhY	58	915	83	1	6301	jxPPxzNk1Lxy1Qn1cCKqU2JmQrxumorq7mJ9y53FHCSrWZTguJW	3801	5373	5373	1616906340000	orphaned
7364	3NLVEeh7bzGevace3yk7BYA2LXcuZw4VtTZBAFbTz2P4XPwnp3bY	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	1647	1302	83	1	6301	jwRFZwWmYhfk5bg9MXXx62EhhTxtvYW1TSyLuXUjzMFPArRowsz	3804	5377	5377	1616907060000	orphaned
7372	3NLMJV12Ny88ejNeETwZrWcq8eK42Xsi1zeyKHXnFpvbvc7VySWo	7371	3NLXmo8cSieWeETkYtdrdc9jpZTQ5DEx78ReqgCwQ5XCe1r7E6Uf	58	1281	84	1	6301	jwTXJEyu2Vxk1Au3j2HdWuAjF1A8kSoJK1DiMEfvHe5m3RiCN82	3807	5382	5382	1616907960000	canonical
7375	3NKpHGDQoN4e75mGcum7TubPZiudQi2TUJj36gxAA2To3tpVj5Zk	7373	3NLFrtMMXisJxWyVvFJrVodsC63GZvnLGHwgsq8cDyLjvpc18Qeh	58	1035	84	1	6301	jwYwo93JZkhxidut5aCgs15ZTjpzHteK5hHqSS6qATgaVtKorbg	3808	5383	5383	1616908140000	orphaned
7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	7380	3NLWihzf4gS3LgzrLL2VjxxfrtKEA6beArgcuHzezJCm3LimZJtc	1637	816	84	1	6301	jwydc69ApGPkH7TM1wopbenqjfHHrtdFkiKGgQFCshEkjjXZMHg	3811	5386	5386	1616908680000	canonical
7389	3NLU4YcWvNJ6jhpVHYoedWL5PRf9CvV3u9hNvYiuyaQfHWz99GaA	7387	3NLppw9FDAkh41x9DypGsKSiV8RKJnwYZt7z89ZyougYnVmx9rpj	1578	556	84	1	6301	jy3Gq2ajkLfbm8PNC1cA2LeZseiQ5wb35kxHzi7RH1xcSDvFNww	3816	5394	5394	1616910120000	canonical
7394	3NL6vNtuZutDAsTDU9hdJSu7cZnNFMbiYP5PsFqT4kodwKXerURM	7392	3NKCtCmntVqqYikLjgiYL2rJYaBr9sWZcudrWydoF1LZbV9ru9Ak	1407	1395	84	1	6301	jws3E8UgYk6ZtbKVxWZVLV4CBG4jdJxD8qHdbf1zLZbdyjvtm52	3819	5397	5397	1616910660000	canonical
9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	9584	3NLmhjYEuzfQGhr1czfhuJmgspQPM7PhoHy3FQ6NLzrPTh7L1FBr	1547	1252	122	1	6301	jxAvRgr3PkecHiViys5v4utpDw4HL5WHXYMafQ2bXTPQHD7ZFnm	4973	6998	6998	1617198840000	canonical
7265	3NKbdae5LxQ8XsoAqxZYrrpojsMf9eiWMKhBx9nsBRFcF59dQJ7z	7261	3NL1xvjUcsvDuTbuF76tB526AaCxvHkg1U5gVQJbVqmP8Hbk3V9a	1407	1395	82	1	6301	jwPjoygPkNo8kcmUgKvkCmtxXsSR5u6h9jB98haw6F2k9AzWLJ6	3757	5307	5307	1616894460000	orphaned
7268	3NLr4Rj1BiohJohWA5UafFfQhJk17Bx9VE617mkbNBXQN6Bx3mzp	7263	3NKbwzYdQsVgwMfMiuTFWWmULEMbj4XoKJmYG78YUGnZy2DPoqFZ	1467	1010	82	1	6301	jy215CiAMMWhN4cnx5CMceQr8Zae3HKF2pRZEoB4dE962bBEMK2	3758	5308	5308	1616894640000	orphaned
7276	3NKCxzZRqSESTgwgwLGriouiqnWyAUwsrjRM5FNz9mwaYH7aaf5W	7274	3NKAo5nB6qA5YPSo91sHNm3BNuJFQ4r2iiwYXSQZLiZYRDxAMkZY	1406	1393	82	1	6301	jxwYGhRS8FmatVspLmnRPzP7sqdkrANRWx2FYiqxgfo2fEmWtN8	3762	5314	5314	1616895720000	orphaned
7280	3NKqRjAEq95sbHaJFzCKCqdkem4dgXFs4s2GJZiotfUX84rq21FY	7278	3NL6xVFVUXFoiCg12f1mFowogRctw6bGRZQujpduLb7LzmTKXBdd	700	832	82	1	6301	jwMdHzTYcvHy5jiEeqNoaAiwmLvLUi4k5TvSjp6w93ZXvPchJtq	3763	5315	5315	1616895900000	orphaned
7282	3NKWT724RXu3yBXDTmuQ5NbbjZc8JBKwDEKhJKmYYha8s8hSRy41	7281	3NL9YcdaEKRdH16cH6wUSX9o58csz38d57BMXdGAQWMDrfMkZru5	311	941	82	1	6301	jxeuGnLpprrjQVbeVUrGp4GeHp4EaCRhN6ZtJyMAoKMavxFf58k	3764	5316	5316	1616896080000	orphaned
7285	3NKJ3nGjwumEw17P3rVL9cYRxaV5h2e9q237XcgQnSsY2yNMgygj	7284	3NKdQrEKYjE2k3n5cpVDjP1KZXZ9Mvms2Wx16KRtHDbP78VD21Dn	1407	1395	82	1	6301	jxSiSNfbz9xhNZ2XqqAK3sgJ7WZKKC3fdW1xALTtmM1CxjaFZR5	3766	5319	5319	1616896620000	orphaned
7288	3NLcVTkAL4RbPF5YGgNn4nKJ9duBQVzgjWDXZHbuUKoSbgaSyMwj	7286	3NKoqKHsmE89YA9KRQkRuqpKMwcz5mSNat7tJ1FbRmd56Muxkzn6	1637	816	82	1	6301	jxcXSHQVKcq2xvSwVJqAdu4MAA9iByGDq7iwCiKe95pzWfgFp9f	3767	5321	5321	1616896980000	orphaned
7290	3NKqUqRNBANAuuxZap1HnUZznWTv7xB9bEwwizHsKkLo8LpQQAiG	7287	3NLbBT9sN98S7BfDTTGFCuMUa875MmP1mYmkFEUuryYA9Xekpk2M	1634	1331	82	1	6301	jwVQNjMAZcMpmAPRVK5srWJvufcaotxChhZFWMNGgZcy84yF5uG	3768	5322	5322	1616897160000	canonical
7300	3NKSTmCU4SUyqkQssUqQ4yUa7hSqiQaq4LWAX1H93sHgtHWv6iSh	7294	3NKE287rswfcPf7RNxM5V7aTLtm9DLXvXW9EGezZmcbL8EgH76qe	1594	1326	82	1	6301	jwmH8Zz4omNA25iE3QKQUz6E6KWrAEj3b8aj3Jp3ikESYGcCiMD	3771	5328	5328	1616898240000	orphaned
7303	3NKU5qXuUJxjJPWq2x1ra2oCWrbQTaPu8jZzzQQiFBjQbj8n9E1S	7301	3NLAHBrwMcQRQxrcAySz1ACSijGKj9UD4rNVHWMTS79zBxwfc8PW	1623	839	82	1	6301	jxNmvnY2WjR22T88tbZwAk5WavHsXETMHuuReVvbn9BJ7PmSzog	3773	5334	5334	1616899320000	canonical
7305	3NLQvLMJGYyekTLJ19yN3kDFhy9UbrgEqH42Vz4gf9cMqsfcAKEq	7303	3NKU5qXuUJxjJPWq2x1ra2oCWrbQTaPu8jZzzQQiFBjQbj8n9E1S	1631	794	82	1	6301	jy3BynzYRueazgTVEt9Gar1xsFvCPg4wss3R622zhJPJYfeu6o9	3774	5335	5335	1616899500000	canonical
7319	3NL2kTHWyZ7D8BAbuxKjPwDs6ZdGTSKkwB5nSf4gKGfKQvUbYpzN	7317	3NKS9qjrdXpa1fWX8RwwAEC7hzTKyYHfGuDAJPyWqJvmqSAHpWeT	1474	1203	82	1	6301	jxzVdYDthTSE4wUdcvWMMiowUgyymma6jCpghcGuU7uCPZncprS	3783	5351	5351	1616902380000	canonical
7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	7319	3NL2kTHWyZ7D8BAbuxKjPwDs6ZdGTSKkwB5nSf4gKGfKQvUbYpzN	1402	850	82	1	6301	jxd5couwakHLWffbfeSpgetcsbz9aKitMhPujbt64zqnqyadL6x	3784	5352	5352	1616902560000	canonical
7326	3NL28NM7MLEdbEdeD87DprRFuGuAY5Zqmv5EYHqqLg6gAYB2HKCs	7325	3NK4eQj2WVif2ByKuyZuFychZE8uuFhTUqu4TwPLnTyUxy8gjcEV	1407	1395	82	1	6301	jxQSZBUx2WEwoZ9gfNeSA3y8GymKmawMeWd15siGXvuw8JXoQhM	3787	5355	5355	1616903100000	orphaned
7328	3NLFUfPoUiJrJuYo9LjB15MAD9mbRBT41YkGHBDmzhNr2BFYxJkb	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1657	1218	82	1	6301	jwkep6rHK1h8vxb5NUbwagbkfQbAnEdThvyZ55AcsM9eEaj7aHS	3788	5356	5356	1616903280000	orphaned
7333	3NKdiLNwNP3kemEUfpzTem1PsS3FUNqfanuLbE4D5m8bYu7r3FSB	7329	3NKWsyimGuRwrWVnbFFKJpTrHdzZx1mtxacADpwwgnCq15rN5aTp	1553	776	82	1	6301	jwpM5vtF52eSgSCaiGtgWebnwY8MVU3a358YBx6oCghGKEsi5XZ	3789	5357	5357	1616903460000	orphaned
7335	3NLaFgBUR1LM1CcdS4anoEisHVxjGMb56hGjHC67V1XxG5tNv3EX	7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	1671	1239	82	1	6301	jxdfWtxMbSTtfBP4KKpMk5bfuiJV4VgUCBjtVMVX7jXDCCHm72k	3791	5359	5359	1616903820000	orphaned
7343	3NLSHPAAwhsjahYHaoKjG2Bvdrrwh5u9JivnzuWkJfjHitUV1WiW	7342	3NKHrtbDhZsCEoDFwxtsuR2w5oWWi2f9aP9vSmodNgdoJpmE2WPm	1483	500	83	1	6301	jwRxa4S5U1RB8swyxEc1prmV6CNEtCSB65F4JNgkvg5mLJzaz9J	3795	5367	5367	1616905260000	canonical
7352	3NKVcrb7NxkmstNFzkSxczt2tYLf1Y7SZpQsPppw1Hd43zyyzwhY	7350	3NKdjyUfkoeuqFwHvdcZqdggxVFYm11i5z5NYBsEDubRd3NtHz7Q	1426	1364	83	1	6301	jxqpDKr1kF7QRY8ZWtVbchvZBaMHPeAMRrNJT5eJHUnQpQrcra1	3800	5372	5372	1616906160000	canonical
7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	7355	3NKGp1J2kSXUmahUN2eqrAKxYy2rFu17Y8HifTFwkVu1dMjoTb3t	1627	1019	83	1	6301	jwpL1BmdAvxUopdb3FZdnLdmYnQtswqQHyWcnJj1Nhnw2nQaRGA	3802	5375	5375	1616906700000	canonical
7359	3NKJ5LmX5USkuQz5bcPn68zsqgafuXnPHxrbHNW21HJKN8gRqNLJ	7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	1460	1078	83	1	6301	jxPUhcfnTQGnCT6hgXmsrrs4d7GbUgxqnKNozKMGPdL3Syj3moc	3803	5376	5376	1616906880000	orphaned
7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	1573	1318	83	1	6301	jxtGxy33RZ28EYefZmkNqQsHvSt3JMNRuFBA77jU3BXavm6g4vr	3805	5378	5378	1616907240000	canonical
7370	3NKsukjYeuidr6TDRp19P5BLY1ebZHKzFf6BHVmhJjAYgFbXmwyk	7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	606	1049	83	1	6301	jwJasVU6fUMgXzwFckFmCvPRYeBkphUN8tGeTk2TecuNvXn28mc	3806	5379	5379	1616907420000	orphaned
7373	3NLFrtMMXisJxWyVvFJrVodsC63GZvnLGHwgsq8cDyLjvpc18Qeh	7370	3NKsukjYeuidr6TDRp19P5BLY1ebZHKzFf6BHVmhJjAYgFbXmwyk	58	1281	84	1	6301	jwy33AmuD35F1SwkkcspBPzYmam73Lvg9KbmArQFC7zQmZNqTU8	3807	5382	5382	1616907960000	orphaned
7376	3NLrKtDq7GFcpMLuQKyphQ5YnkFrY9miaSCosVh6jiqrhHuwQ4Ek	7373	3NLFrtMMXisJxWyVvFJrVodsC63GZvnLGHwgsq8cDyLjvpc18Qeh	1536	260	84	1	6301	jxyiBT15DVV8DSL5AvtwtYpdMS5678UWpdjrZbwRJNjfg4xxQnf	3808	5383	5383	1616908140000	orphaned
7377	3NLqqAT2Cyb1HWV743wzkMkBvT4NFDQ3bj4G3NBSvoXE7wyqg9ZC	7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	1657	978	84	1	6301	jwycaqWX3qaW6Va51HCkpAyVDUZwTWWBABKfa6nvDL7ygc8mAWD	3809	5384	5384	1616908320000	canonical
7382	3NKthNXpahpm4ie1v4iaZAGopyG7q7z3xQX3jU7pDPU8YNAnPqWn	7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	1523	1321	84	1	6301	jxUkqDNujdRkkdeRbn49BacmeC7CFg28i5xKa52JB3eHNJiWxJQ	3812	5387	5387	1616908860000	orphaned
7387	3NLppw9FDAkh41x9DypGsKSiV8RKJnwYZt7z89ZyougYnVmx9rpj	7386	3NKgzezu9eQgsYqS9wspCSvrPicEC6zKgLvzgSNsYDur4mA7hL91	1406	1393	84	1	6301	jxq51Dfp1Yq6or31EJgqirwkbVDQbcMWyJVKxKmZ7SzdU9QDzNC	3815	5392	5392	1616909760000	canonical
7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	7389	3NLU4YcWvNJ6jhpVHYoedWL5PRf9CvV3u9hNvYiuyaQfHWz99GaA	1607	1102	84	1	6301	jxzVwxQmkuJ5qHiuhmF2h3Rh1MTjv65zNc3tBqZH8bqAemHYDjk	3817	5395	5395	1616910300000	canonical
9595	3NLktfVoWnDxt56kGdo4HNW9NaCXMoqcYS2XSnN5a8EzE53r6YyB	9594	3NKAUL8GYCWGojqrAP7TTBWunxcYEGSj7F5qoYNSSi1RGCiqpqQW	684	1106	122	1	6301	jwn4B1rfba6xWwnER2bcUY2BZ4amD1iAsGmdHt3fP94PjFMWk99	4977	7003	7003	1617199740000	canonical
13470	3NLrt3iE2bK2Rp1Tdt9ihPurzzkfGVtjN7XiAcsRDy2FKmGV95Nh	13467	3NLKjy7Yv4Pz86VjDaZyDhBeiR3xzZ5nLU1dGN8RYvn7xA3ri6yG	1581	778	201	6301	9709	jwgQU64wpdGuAmgMYRYUrRVS1WwdL2cSvUx7rgXy3h6nh8vfJcc	6938	9804	9804	1617703920000	orphaned
7283	3NKta2dhe6Tj3MYctv23BzaT94ZMWB9ntUGY9Ec34SfeA6tmgBwp	7281	3NL9YcdaEKRdH16cH6wUSX9o58csz38d57BMXdGAQWMDrfMkZru5	1405	865	82	1	6301	jwmnVDtbaemzLveQyYhkd9BmW43xoepA7pd9fbJvHMwjD5Aq1Pe	3764	5316	5316	1616896080000	canonical
7286	3NKoqKHsmE89YA9KRQkRuqpKMwcz5mSNat7tJ1FbRmd56Muxkzn6	7284	3NKdQrEKYjE2k3n5cpVDjP1KZXZ9Mvms2Wx16KRtHDbP78VD21Dn	42	1361	82	1	6301	jxPgtJg8u1ebMr9kTxU9Z8UpdDNtrqxQSSaBmwQcFv7AYcceXh1	3766	5319	5319	1616896620000	canonical
7293	3NLmLnfHBULDQfp71Cvsa7XNRBEpfR73scg7ay24h83RxPM7hYDo	7292	3NKhB6PXtbNUraiQQeFjuQxo1ATFY1NxfHkCsBfgEZ36g27dJ25g	1675	1342	82	1	6301	jxr1nx5TGunEtHUYuUjU52Go94XUKFQg7Gqz5uKnZ1ctt5vRKoZ	3770	5325	5325	1616897700000	orphaned
7308	3NKUDie7xSndzsUqbKKmCJhkXGmVkFkm6JyBMvNYWrXoCycjSWB7	7307	3NLRzooQAHX5a5N6V5uZ5rP9J4L8qxCtZXVbmwBKomzXPnHE3HnZ	1534	1191	82	1	6301	jx591v1U9awa8iNzfau1h3ospAVkxZf6w4kote4o3vpZ4kwGnEV	3776	5337	5337	1616899860000	canonical
7314	3NKzn1Pg8gy4sR8E3wgrH69RKSgcNcoZuyyFukxnDJRA7oJB2eog	7313	3NLmU6boiafJqivFDYTiNziL6iUinYfhjCW4aVQ7emGw4bamDmHW	700	832	82	1	6301	jxTaR4VbgsyVZKkXxjX6gizuM7RMftsDnJ5wNa8hTV2vtrU41uX	3780	5345	5345	1616901300000	canonical
7317	3NKS9qjrdXpa1fWX8RwwAEC7hzTKyYHfGuDAJPyWqJvmqSAHpWeT	7316	3NLTqZ4TTwGTr4WHrvYkYhkimVrwKZJEBGiGfnyGmnd5RxJAALtr	1405	851	82	1	6301	jxYNGR7oyKfixwSTPp7XGkQ2xnFnePYt6hZ7HvMU1AqjxPkyWcU	3782	5350	5350	1616902200000	canonical
7320	3NKxr4zN3B67qSyFEwnNjaTm5uVtp19wHNWNW5LX691JdWKEMLKu	7317	3NKS9qjrdXpa1fWX8RwwAEC7hzTKyYHfGuDAJPyWqJvmqSAHpWeT	1407	1395	82	1	6301	jxEzvVxVLCk4Fj6PNbQnCSM5dckTnHFcN47ad4vov8ZeCWqbSeR	3783	5351	5351	1616902380000	orphaned
7322	3NLX8KDpZqtGnoyZrLAKiMtU2qTPPovCmjju55E2QyrDxBSfpVMG	7321	3NLXo9PVNhA9ktjRJDtYQ8ntRaPuoUMus8rAdAZ3U26LcX7YzzN7	1559	1227	82	1	6301	jxVRFHk2ts5xiZDUnb365MrPnJJBWwwTED85aFLaCmJfr1eEGW8	3785	5353	5353	1616902740000	canonical
7329	3NKWsyimGuRwrWVnbFFKJpTrHdzZx1mtxacADpwwgnCq15rN5aTp	7327	3NKPP9BpkenEPLySyEMH5peEePZE151xb8HquJ9oCiJjHndV2t3Z	1675	1342	82	1	6301	jwivPfbBKB7izszALAKo46acXAxAU9qJddLJJvbMJUcaRuW3zy8	3788	5356	5356	1616903280000	canonical
7336	3NLdqpV96dbCspKEnTn2RiTiFY1E3XRA6nYZ6Uo3kP7ZgGBrKG3v	7334	3NKtHhr6JEDMQe2nzqyM3XCmXdoXZB12ksxr4ujbENLrtA2jkorN	1405	873	82	1	6301	jwiPHHVxzAnPuMhPhArdUh6PHbUtPQtjppcU6qXn4kBa1WHPYaT	3791	5359	5359	1616903820000	canonical
7338	3NKvaa18vd7t6YobauH6437FnzNZa91QfCbXoyZgYuejf61NEBmU	7336	3NLdqpV96dbCspKEnTn2RiTiFY1E3XRA6nYZ6Uo3kP7ZgGBrKG3v	1406	1393	82	1	6301	jxVX2Hq55QSqUSNMCdckxD9K9T8pUePeJsY3pNQq8LjejABHXfF	3792	5362	5362	1616904360000	canonical
7346	3NLZfdsc3xP2quhmfvaCVCvbaPyPsJS895HitRFBacy576jVB7q7	7345	3NLZA55siB5iRKfgzNmvCcD8ktqqXjQC1aghAGjqGCxaegMSrYQk	1672	1039	83	1	6301	jwPoZzXSYpukWFq4aqvnA9hshSTvRcangG6LvXUzdxH1YjbEM2D	3797	5369	5369	1616905620000	canonical
7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	7346	3NLZfdsc3xP2quhmfvaCVCvbaPyPsJS895HitRFBacy576jVB7q7	1534	371	83	1	6301	jx4jj9x3VKyATh7nLGX2o4dtsqVnStzDmQ58byAdt26MwushTRA	3798	5370	5370	1616905800000	canonical
7351	3NLbroFWPVRyt8BGd9TLNM7f2JZen1FhQEZjEqT2Kcui7nzrXYEi	7348	3NL3qXtTx5DE5FxndcyetczEnXeneMWsFZJtEa52eYVyBe6pmfEa	1577	1081	83	1	6301	jwGcHEBXi5MXGXwUu2CH9X3XGmxrcoUqvmAGU517sdtom4rCF77	3799	5371	5371	1616905980000	orphaned
7353	3NLdXhqB2z4pk5czxVKVBY5wcNNC5UNCASJTifYjxMCDJVqUVDEt	7350	3NKdjyUfkoeuqFwHvdcZqdggxVFYm11i5z5NYBsEDubRd3NtHz7Q	1642	1121	83	1	6301	jwX41vPxFR8hn3ZBE5qv4NLVcyQ3sguyKvB6CFkMYSJPnBB4nUQ	3800	5372	5372	1616906160000	orphaned
7355	3NKGp1J2kSXUmahUN2eqrAKxYy2rFu17Y8HifTFwkVu1dMjoTb3t	7352	3NKVcrb7NxkmstNFzkSxczt2tYLf1Y7SZpQsPppw1Hd43zyyzwhY	1402	902	83	1	6301	jwa6mAGvr6joCv6svvzxZPq38Qn1SN5RhH7HiXML5LoWRuEwv42	3801	5373	5373	1616906340000	canonical
7361	3NLZ2YMMbfZ877BNyZ4YuTeXc9Ni9d4a1uabGicNkdhYyDn1nNzF	7357	3NKJQWyUEWp8eq2facnCjHfyXyjjhXGxJUSnEybrSCawNdNmcGY4	1642	1001	83	1	6301	jwawRRgfrGA5WBMj1y5tghcJcvM2qvLHkrrskKNf3kmzEAPKfWh	3803	5376	5376	1616906880000	orphaned
7363	3NL4sf1hyXW41R1WnRu1tF5wMN1ie8rBRtLYFwrhMLQV4aV5oCBt	7360	3NKa9uDJtkjz8tab3icPf9WTr3j9wt845fp2MkjAgXRpnB3wkPbN	1406	1393	83	1	6301	jwNRfqcJc1vbx2YWtMQBJZAA8qgqj1tdUSVrwFruvuHctiseW6Q	3804	5377	5377	1616907060000	orphaned
7367	3NLJr217Jvi77ArbHHAfAsBTjuLEEKMwyzmyPQu6aYS7MjHG53TP	7365	3NK9NKtWjBFuGe2aFURTAcKYrUqtuWHdNum34ZmKmDuaioy46xSQ	1405	851	83	1	6301	jxuzQnoiXu8vQrhrL2qXTzsbP8TBF599uAZgBRmvfDX7xKcZthU	3805	5378	5378	1616907240000	orphaned
7369	3NKHFdHymtdDD9eaqPyevGfmHmywmvEZmJZ4oYEJNu8sMaKGD7Dv	7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	1406	1393	83	1	6301	jxi3GDrsKH7aJf3NMsGhCo9GTrBdZnkVf1yauizvZznADzDVQfn	3806	5379	5379	1616907420000	orphaned
7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	7372	3NLMJV12Ny88ejNeETwZrWcq8eK42Xsi1zeyKHXnFpvbvc7VySWo	1536	260	84	1	6301	jxDVYYFYtP8BGP1V9QMwfzkPaFgPwB3YpJH9Nu49mhxxf2zPvdV	3808	5383	5383	1616908140000	canonical
7379	3NKEWtWoZkmThcv22korFjKYBHme8bAdgp3yKonhZgufXxxsqhhs	7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	606	929	84	1	6301	jwmWk1rALkf1cPu2R8KfWXkUKJ2cFuad3ifgPmBrwXDAcib6hFE	3809	5384	5384	1616908320000	orphaned
7384	3NKVPrHjhLBfeHbryeg8c4rmjrhUN8EdQDsFHqMKWnfLeTCsXQjJ	7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	1523	1321	84	1	6301	jwWWGvFkvhhhrX9taGNANcFqLXEPTuRgDsqDFHydC5WumF5DtoP	3812	5387	5387	1616908860000	orphaned
7386	3NKgzezu9eQgsYqS9wspCSvrPicEC6zKgLvzgSNsYDur4mA7hL91	7385	3NKZwrAJ2kAfsTLas7FmmiXgXd3oqahVLJaynd51Aty4UtLYbfpw	1619	909	84	1	6301	jxaTBy5THhnjZQNpZH6nr2TGqhthaLjGpadre4njfiqqv2yUsYq	3814	5391	5391	1616909580000	canonical
7400	3NLes8Zw36MM5AvQNtpcSZ5nBrDMjw1KndMNra9ueT7ukW2C4t1M	7399	3NLJnYm5NPjYNfMvuDhYHkgZoJNLiiNNNfwpviTwsXDuAxJYYhWr	1588	1146	84	1	6301	jwH6NX6da3jintZGuQ515Z7GQriuSpxZNPUdVMRUhomWq8VnGvF	3823	5407	5407	1616912460000	canonical
7403	3NKEkYRgXX6BBGomEGMD7c4zmq5bR1TZSTpXF3kRgftc5HA7cBV6	7401	3NLEQd9HasbgxjNMuLXbAgKPyNM4zYa8B3DSYJovkdKVCkFcRhNx	1560	1291	84	1	6301	jxgpdhFCn57BbnRzE94hKv7xwK2moE7jckKZ4FxojacqZPDj4LQ	3825	5410	5410	1616913000000	canonical
7408	3NKa9c8nTUTnxS1ffy8JajzZt1B5mMSUkiLGaTaxwSwXjqpfo6iM	7407	3NKZJMytD1HBpHofqL47BqfqcDsAMsx97kXBmmBGEZAyhbi1xyib	1407	1395	84	1	6301	jxZC71ww34ysXWoWXNSePyi77mVLyhjL1TsEq5R5BYtSznPRJ8X	3829	5415	5415	1616913900000	canonical
7416	3NK4qC925ztdFGZqYzv5w8oRMVowxgLFjYk6igDmW2EMFvWFQMND	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1534	220	84	1	6301	jxNLyHWd1JKo7W87newH787oVh7K2q9eSPfqh69XC8QGnw7qiXJ	3832	5419	5419	1616914620000	orphaned
7422	3NKRe5JKSQVxZDALtr65SmmXCw4p5h8mBYRzJrdyjhaTJ1UmGshD	7421	3NKtBm2QwFti1WEY71opoSdDH2b7eJ2D6MP7PDUPNW5eCQV8pYG4	1406	1393	85	1	6301	jw6gwwWzgFSgjVms6gGxFgxhrjiR4mBSTDXGraXbANMofs4TqCm	3835	5423	5423	1616915340000	canonical
14177	3NLWehuDvNo9g9u79xTUq59mFEymxA11sbrLs1iY53oAF3ZH1Tv8	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	1471	1140	202	6301	10309	jwe5VhALRpqPDc9jS1gMbzoARZ1jDHZt3EhA5snEJuMum34woCa	6948	10247	10247	1617783660000	orphaned
7371	3NLXmo8cSieWeETkYtdrdc9jpZTQ5DEx78ReqgCwQ5XCe1r7E6Uf	7368	3NKWwVTGruFoF8AvFpo1Ayp4qsxDLXzbuMD6145NMfGJWGhvEbmj	606	1049	83	1	6301	jxMvVWifAiEAFrwQuFac3x8ThQ6yeUvdYyczpmmwkRCZEVYMykM	3806	5379	5379	1616907420000	canonical
7378	3NKuVzbbH61hvfNmQAJzo6g4yi861j6oB4WeCPU6W7dZZmvnxFfR	7374	3NLQ68Bw1Nq48WfARHaXwvqBz73zobzSw5xRbTcEXmsRCUadmfpB	1406	1393	84	1	6301	jxWMB5GL6f4tgRzhhStRC8JWZxWoVioyJ2xiRDZB16voASJPRcF	3809	5384	5384	1616908320000	orphaned
7380	3NLWihzf4gS3LgzrLL2VjxxfrtKEA6beArgcuHzezJCm3LimZJtc	7377	3NLqqAT2Cyb1HWV743wzkMkBvT4NFDQ3bj4G3NBSvoXE7wyqg9ZC	1581	777	84	1	6301	jxcM3oGQ5MTvLQ6Kwe9VnxQBwtyNZCVciwCYrAHc7L5PDZ63bFq	3810	5385	5385	1616908500000	canonical
7383	3NKBiZ5sx7j4XBRwWjNdhEMvRaFcrVDbUGayr9EnAoVQAEdRdZi2	7381	3NKjNv5KcKig121dL6ZeZ7QTJxXpMdRpYRhM9VmR8nFSS1DAr7bx	1523	1321	84	1	6301	jxmUvwsmqDzwX48J6JbYjVZTatfy66bsBMSZY553SegdCQrjJJ4	3812	5387	5387	1616908860000	canonical
7385	3NKZwrAJ2kAfsTLas7FmmiXgXd3oqahVLJaynd51Aty4UtLYbfpw	7383	3NKBiZ5sx7j4XBRwWjNdhEMvRaFcrVDbUGayr9EnAoVQAEdRdZi2	1407	1395	84	1	6301	jxPsTTp94FKraZzLNcnACcf3QraEudeWXubvkHU35advazMpEvz	3813	5389	5389	1616909220000	canonical
7388	3NLBBsdhq57pWe391AapA216cAbSy6x3it6jBjkJJUgQP954nYSm	7386	3NKgzezu9eQgsYqS9wspCSvrPicEC6zKgLvzgSNsYDur4mA7hL91	1578	1296	84	1	6301	jwHAUdkAUprpqYPNDWHkDtrqLy8w7f9HKfb71W7uYxer8ZSyZhU	3815	5392	5392	1616909760000	orphaned
7391	3NKKDJLRB7SxkApKCtap9bg8nqPH1iJ2cPXYUnDM6zoXvGbK9R35	7389	3NLU4YcWvNJ6jhpVHYoedWL5PRf9CvV3u9hNvYiuyaQfHWz99GaA	1407	1395	84	1	6301	jwPvHEvng13kyU57BACEeYPmTbTSHSPWm95214Wcg3KdQqvLVY1	3817	5395	5395	1616910300000	orphaned
7393	3NLXgr33LPj85DM9VAcPj4YNZX7GzouXRe9LRUE63jTypmWbKAs6	7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	1555	1221	84	1	6301	jwBZe512u9xNxgLLkXM33LgNC2S3tR342XfTnwv5m3DuR8BWKgC	3818	5396	5396	1616910480000	orphaned
7396	3NLvj2DjVTbmxKJiwY6brtGcwe3TPEUSDrap99meYBJGKn5e9Tyu	7394	3NL6vNtuZutDAsTDU9hdJSu7cZnNFMbiYP5PsFqT4kodwKXerURM	1406	1393	84	1	6301	jwUWcTSepkjMqbqnG2NwK2T3JMBYrVRzSYgVcqzKXeQkkHFPZ34	3820	5399	5399	1616911020000	canonical
7402	3NKHrUF8YqcW3DBhGMzcawcUeuNH9PTEyhnehEGHRSVG1gSAkDZw	7401	3NLEQd9HasbgxjNMuLXbAgKPyNM4zYa8B3DSYJovkdKVCkFcRhNx	1406	1393	84	1	6301	jxkk3BA5aSPy7TNDjrg41TvDjTJPd5H63kFeWBdBswHZmaMAK7k	3825	5410	5410	1616913000000	orphaned
7405	3NK64xVtm8wtTLWKZKBACsQQMuFaN3VWPqQPqKYUQL8174TvMHkN	7403	3NKEkYRgXX6BBGomEGMD7c4zmq5bR1TZSTpXF3kRgftc5HA7cBV6	1407	1395	84	1	6301	jxuDzmWziY6JXAGJWLwoHwf4sAevt51db4PqPSyGLR7rkoyttqk	3826	5411	5411	1616913180000	orphaned
7407	3NKZJMytD1HBpHofqL47BqfqcDsAMsx97kXBmmBGEZAyhbi1xyib	7406	3NKN1a1V9rWCEfiTSC8axjC5zGQvixxWxjcup4xVfb36EUdVUUfM	1637	816	84	1	6301	jxmYHnwW1tPqP9yGnircQEUW6FiDy9Msew9yuEVqqyoxrzzAmz1	3828	5413	5413	1616913540000	canonical
7413	3NLe2exbopR9TYhFUyQamP8E5cwRMT7LK8wcquV4n6GAJpax51cn	7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	470	1309	84	1	6301	jwTyZrZHMxCMGFTotondodNv2GX4B7kKSML6xZ32zAJJdDbBCmp	3831	5418	5418	1616914440000	orphaned
7415	3NKuz3kCa4QLeL7pMxFEkgyT3NzzZ41MokUttefhYB8NYxAX234y	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1589	1040	84	1	6301	jwQgvjKFAWkSmDEB357RWjZvwdiT2GakkFnvjyGtFxX3xch3fns	3832	5419	5419	1616914620000	orphaned
7421	3NKtBm2QwFti1WEY71opoSdDH2b7eJ2D6MP7PDUPNW5eCQV8pYG4	7419	3NLUo5FbZpT9Pn9U8FWhTdLu2WQpzaGuMMk3ZHBCW1NytEjza6ja	1506	1373	85	1	6301	jwJbnUSzVLUsut5cUCtzEctp9oopSUW7FgGknEvyzBeZvr9yGcg	3834	5422	5422	1616915160000	canonical
7426	3NKYPuWKUVpV9s3pV745Y25BifqEPXC8zrKQxoXyxpbRraZz9LP4	7423	3NLQNjZt1X1mZmzqBNNynSqxDZufYvjyAJqKjLid5zgJiZSt8yzT	1581	778	85	1	6301	jwVc8vQVV6oPYhC69qPRr9VZY1rgcs1rR1Yb3yhbUAKQoRvQwgU	3837	5427	5427	1616916060000	canonical
7436	3NKZT6zWow6vnhZwdsq1R5HR3NXmBHtUozXqGQTH3UmfyXYTTzfF	7435	3NLjrcBFRUueNuzvoqakMfGydhPS1RMzVCcsDqaEqZQRtPNakMiN	1637	816	85	1	6301	jxT9ZYyL37zGoL8nNjQLWJDRvNroXwqZjMp9WeszUEzqjw1pBiK	3843	5435	5435	1616917500000	canonical
7439	3NKNd3PByZQw5ta8HS4vDEnSCKnVufRBJrApZKqnugD8a4W64CSG	7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	80	1273	85	1	6301	jwx52oixC5STj1k9kGC3PcqZ8qKWiu8C6tSCe2thns2RzpHLQ3P	3845	5437	5437	1616917860000	canonical
7443	3NL8sKwy1VrXMJNmmwJpc72Aq6jgBKJR8uz8tuKEQBLkyJ8WwCmm	7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	448	939	85	1	6301	jwbT1ApJABepRAyedzQkHS7Xv8WQJwvJMw3Tdnj1GUN1qdrTEpH	3848	5440	5440	1616918400000	orphaned
7448	3NLQW76dHuxxz2FwY5RWRv1vkY45jBesTRk4EhLcTCcCG8aYLyhk	7447	3NKTpcwkxt5Zq3PTpLbtycgUXcLaXBsp8P7StQ49mtJ4ooxgGq13	470	943	85	1	6301	jwM39vzstdVn5v3yYjvnoJ9hCcjCKGqGqa8rFiVypJUCCug3TAp	3851	5443	5443	1616918940000	canonical
7454	3NLnRYtT8B5oZv1ECQuuW3QhT1dM8rQ1Ps386MVeFP7zvnsWHBRi	7453	3NLojGmC5Ye1CCkAM3wVtH6RtR49uocFHnnbHXQn9oGE7dmDoKmn	1455	1332	85	1	6301	jwPZbMAjj2TsRmPSnz1fPok5uDoarmVNTkoHNFNeM9GNXzSUW2W	3856	5452	5452	1616920560000	orphaned
7457	3NKzr3KQ7DG5e3yX4czvCyERDspLj29FvDu5tkHv5MF5hDs3sGTg	7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	43	1310	85	1	6301	jwHgfcCRZAK76VPhRLr5wx23irPorXkvi6zn6dQZow5pGT7gmyy	3857	5453	5453	1616920740000	canonical
7462	3NLVCNYa7LMaPinZW4HJxmXjxRvYE8x52sZYAzbqzv4buYHNHMJC	7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	1407	1395	85	1	6301	jwCyjPwEt8Pp3YWXGUFzxxY4N1ueXaEmoju8AjT3cn1ui6MTm9c	3859	5457	5457	1616921460000	canonical
7464	3NKMeLJqVLBW1UUMv5J8UEEfTdcr1yFJwYWyAdxYXNiAYVwPsanJ	7463	3NKQmCJK9Tqh1YXbvH7cUHdBxraAwZatVnSTekxWLUcBq4RXwJfc	1483	322	85	1	6301	jx5dWpyZqBRYCqj6yaBEjLaZaL3s7ckWNJ59E1Z87cf3eHRdSfD	3861	5459	5459	1616921820000	canonical
7467	3NLaWzL79oLzmwuontLysWU3ikfwAxe98EM4pYFgHjKMHTP2d2AG	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	679	679	85	1	6301	jwrS2qhY3TPhWBUSi8hJtR9bChedV1akg6Ym9jjp8BWLHYukeRt	3863	5461	5461	1616922180000	orphaned
7471	3NKCuQFQ6FTzJcJipmeJiZLeao8GrZCztrTvV3QDi4o9xMHbat9C	7470	3NKVbtaoywVPSCfd2crYkRbyFjDozYDYYapKr9SvANWoc2oEm7Fc	1672	919	85	1	6301	jxQy5bN6vZgReZa8cyE2WVa2WYNryb6wBwWcWDiC7LCYdHzH1eT	3865	5464	5464	1616922720000	canonical
7478	3NLwUsMt7XLfom5Mn6MjBxDzMheymMaVfKZP23Sihb6G8UpS37Pi	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1631	794	85	1	6301	jwNt4Uy8TPrzsj9WaiBK9csSt556LKbth1H4fAs8XcdZ11b7Eth	3867	5467	5467	1616923260000	canonical
7477	3NL8wncML6yeFscCjjP2sfAwmhLitcUxJ1RWn4JcLg3LiYsfZAfy	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1407	1395	85	1	6301	jxr6qeH7rV17fh4V3XJYTUbKDzUcDwmj7pAHB2PnRdzriJGjZTY	3867	5467	5467	1616923260000	orphaned
7483	3NK3RpJ2utGhr6kzVKEXkzEjKrjFNxjV4Fxg4f6VfwTYkPNzSEEh	7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	532	937	86	1	6301	jxbQaMoP3hyuotKWm3xpFXA7Z7gw7UmKJckFzQoozWzk7uP4bmu	3870	5470	5470	1616923800000	orphaned
13501	3NKryqkjMxkwMPrgUNo7h3xx7aV1BXX7TuPBEusq2M4vLvKs9Lt9	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	1403	782	202	6301	9733	jxFRSnsT4goUSPW9jQZWH7FJr1XvXbk6rsaLVivhRiTCqih1K79	6951	9831	9831	1617708780000	orphaned
7395	3NKiHJLXUFGbbDGFssQVWaApb1srZS4JJ9EccoAqwuXdFKBeD8cK	7394	3NL6vNtuZutDAsTDU9hdJSu7cZnNFMbiYP5PsFqT4kodwKXerURM	1587	1357	84	1	6301	jxjCDhKWkxnsf8T84FZL91mMDJobHL3Yh8UCctBDFRdg81cvDBc	3820	5399	5399	1616911020000	orphaned
7397	3NKBewsRDZSkd9SxogHbMJL6XG6FKecv62UAz6aHhHMbzXCn5NmF	7396	3NLvj2DjVTbmxKJiwY6brtGcwe3TPEUSDrap99meYBJGKn5e9Tyu	684	1226	84	1	6301	jx3jTg6kc246VUi962C4z4v7QASPjLEzQ8LMLDmpNFSju9s6vV6	3821	5400	5400	1616911200000	orphaned
7401	3NLEQd9HasbgxjNMuLXbAgKPyNM4zYa8B3DSYJovkdKVCkFcRhNx	7400	3NLes8Zw36MM5AvQNtpcSZ5nBrDMjw1KndMNra9ueT7ukW2C4t1M	1500	1051	84	1	6301	jxD4AHwaWBqSVNbzwwRJBSfWRGH1fEzGkkpo2HVcsADgsJZCBxJ	3824	5408	5408	1616912640000	canonical
7404	3NK9Va2Xhcseq9byrYYoszHBmyTkUXccizDWxrw55xiiFzKEWdZS	7403	3NKEkYRgXX6BBGomEGMD7c4zmq5bR1TZSTpXF3kRgftc5HA7cBV6	1637	816	84	1	6301	jxajJT61Ru4UaJ1Yp2cunsqZKH9uWpp8USMw7N712kBu7tpZf2e	3826	5411	5411	1616913180000	canonical
7406	3NKN1a1V9rWCEfiTSC8axjC5zGQvixxWxjcup4xVfb36EUdVUUfM	7404	3NK9Va2Xhcseq9byrYYoszHBmyTkUXccizDWxrw55xiiFzKEWdZS	1578	1170	84	1	6301	jwhDy4U3H61qefzyiF2FCqfevSQmB7BqpfG2Muy3BM8aLUCoB3v	3827	5412	5412	1616913360000	canonical
7410	3NKBDxGSRA92w26krgtzznGSFvueXmG8DdD7ZyPFgsQYtq3TtWpj	7408	3NKa9c8nTUTnxS1ffy8JajzZt1B5mMSUkiLGaTaxwSwXjqpfo6iM	363	363	84	1	6301	jwe3XE9yGKzdcVfZ4DhBxN8ia33icD4ttJAip6VXU7jveQXumcf	3830	5417	5417	1616914260000	orphaned
7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	470	1309	84	1	6301	jwxz48hpnac4aFvae8eSks35Jy4BxvWsMmdHQUBQauBZzUgMGx3	3831	5418	5418	1616914440000	canonical
7414	3NL5mGbd59AUWpgdJ6omVr7PuW1xNJdRm3pzepd1oTvv1k1P3Dzu	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1534	220	84	1	6301	jxNLyHWd1JKo7W87newH787oVh7K2q9eSPfqh69XC8QGnw7qiXJ	3832	5419	5419	1616914620000	orphaned
7418	3NKR3v2AMQz9PmMVV77pst1fjW766X2X9FaHTLczM4TosPHCFUmW	7416	3NK4qC925ztdFGZqYzv5w8oRMVowxgLFjYk6igDmW2EMFvWFQMND	1460	430	85	1	6301	jxtwDdniRpSaziBbzQTWKFp92s6fw1DVwjpgNifk5UrFis7DoBo	3833	5420	5420	1616914800000	orphaned
7423	3NLQNjZt1X1mZmzqBNNynSqxDZufYvjyAJqKjLid5zgJiZSt8yzT	7422	3NKRe5JKSQVxZDALtr65SmmXCw4p5h8mBYRzJrdyjhaTJ1UmGshD	1407	1395	85	1	6301	jxVsjRw4LPjnEKKjLLN8LzqqhAQPMXcEQ8J2BuxwnbZ8co5g6uz	3836	5424	5424	1616915520000	canonical
7431	3NKjiqcRVUGBU6eG8jqvpwy4kj7FsmLaHXBioY1TyrywCaskvb9y	7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	470	943	85	1	6301	jwrJW6bmfmB9geY3NpGCxTrAPo9NtQHaeCsjwwGHQQ47e88fSaf	3839	5430	5430	1616916600000	orphaned
7433	3NLBENDzteMPfQQKQHNFW4APnkJam7euy4RqYE8hx473YGk78NBT	7430	3NKApBoKvss6fgaeCCFTdgxWyhJcCgzsggxcbgR2hA9DpnXu76UY	1529	1316	85	1	6301	jwHy9rrdNhgJo5qj6yYGCfYi4UKJStD6641Ncf1eNec6Q2SmWTu	3840	5431	5431	1616916780000	canonical
7435	3NLjrcBFRUueNuzvoqakMfGydhPS1RMzVCcsDqaEqZQRtPNakMiN	7434	3NLDq7vESa4T27eEJ8eZ73zEetHBzazpexvfvMtmfr1bK4ojieYM	1516	928	85	1	6301	jx8NrhAqiYYKf9wB2CzVU3GRzmZ8w2H6U4Uuj5ZWpayNU6CAWJH	3842	5434	5434	1616917320000	canonical
7438	3NLRkBbZZ6Cv4LVPYFGtgBoWk3dLALfGhWwyXrVyBYBpJxg6GKMi	7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	1529	1316	85	1	6301	jxj1ErFngeJwzsomyCa9Yjo5cbbCEvf4m1bignRMPEAUDVjteRL	3845	5437	5437	1616917860000	orphaned
7445	3NLG8La83ECUXjnbhjHrCN6K4vqbpZRAdxdVYBcSmY5urQ7AsXyH	7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	1445	1044	85	1	6301	jxLqHqDi7AzoZFg5Hz5beAmze3FK7CUrmWabqBamryGBihwEe31	3848	5440	5440	1616918400000	canonical
7447	3NKTpcwkxt5Zq3PTpLbtycgUXcLaXBsp8P7StQ49mtJ4ooxgGq13	7446	3NLQVBgRqwx8MMvyGLRuZgEouD2orhpGE9yg31jcAXrD9A3UuVhv	1527	927	85	1	6301	jwSfLSsgWopPjzJKjUHNbcNvnH5tKr8SWJzsigtQdo2HZ3J6cT9	3850	5442	5442	1616918760000	canonical
7451	3NKeb5NTpXiViNXDDFAfmBzHZaE7YPc9QpWy4uVgb6nxn7qHVUSJ	7449	3NLDNyjiEKvnREZKQjgAHFhcYN1xb5XWEDcFmZANETdvrJd1UGQr	1407	1395	85	1	6301	jxbRpGBnkaopVTLPk5Uf3xJps4iwV3D77XysLkDrhwdp9TKbLDu	3853	5447	5447	1616919660000	orphaned
7456	3NKwDpiZazmh6tddqPbZPPfthjZpwt6HHkf2MnsHG6ohK8c2KZTo	7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	1406	1393	85	1	6301	jxaBvnEXVXk1ohASabzau3Vgh1ipLPhZ5NhYEC4RTj962zwhsBT	3857	5453	5453	1616920740000	orphaned
7463	3NKQmCJK9Tqh1YXbvH7cUHdBxraAwZatVnSTekxWLUcBq4RXwJfc	7462	3NLVCNYa7LMaPinZW4HJxmXjxRvYE8x52sZYAzbqzv4buYHNHMJC	1637	816	85	1	6301	jwe5MV2NPJSoBbRxBUASrNUFhXL9cmuK6JTH2jx8F3eiBJAMgkc	3860	5458	5458	1616921640000	canonical
7466	3NLxPfqnHdu1PHYuzg265qoD8AtDGaQdQey8NPvxmDz2VFyusFVi	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	1466	502	85	1	6301	jwNJyfMGwMFyB3ScQKda3FmRKXX4rG4iifdp7H3x3XVyBCG3Eef	3863	5461	5461	1616922180000	canonical
7476	3NKwMz9QofxAxhEviWDcXnDihvo3jVENgNACzHPizj6MkupRZGYt	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1507	1280	85	1	6301	jwTf393PdJT7HR5ZyssqewLrR9ntckLdkjHWD1owmjJEktAnAdb	3867	5467	5467	1616923260000	orphaned
7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	7479	3NKocw5pPntLXbuzK7UmSHXYbzr9vrDJxACzbiMA4cNuyDoWv7oy	1480	659	85	1	6301	jwvvd6xMoYsh3YCu89hB3Yrn66Yjp6FN4pSdVy2FjJHic4T77QV	3869	5469	5469	1616923620000	canonical
7482	3NKFwdhjZ35tUvZgdhAfxzLtum8ymD9Zt4VQQ2Cop9cWh5WKLken	7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	532	937	86	1	6301	jxbQaMoP3hyuotKWm3xpFXA7Z7gw7UmKJckFzQoozWzk7uP4bmu	3870	5470	5470	1616923800000	orphaned
7485	3NKQGihGqwaHnfK17NRWm5dCkNckhYLWBRR1SzqPrNDgA5rwZpH8	7481	3NKvT2gcuCvWf7hy6kUx4dEzp2U9Ex3JyZG441ZX8LG6L6i2c3hX	1490	1274	86	1	6301	jxRTyhCB8UbVK8vSzNhD83fFNrJs8j4mTBVgEL83FsjMya6ASGP	3871	5471	5471	1616923980000	orphaned
7487	3NK565ZadQo2BcqEtVucjhw3iiU2SPWmG1beoTwHCSzVD8Z3y7hV	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1406	1393	86	1	6301	jwjSTVsMqkyjhESyjpmrLVHFnyp98o5R5kM5LzNY2AYJ7ez7h4N	3873	5474	5474	1616924520000	canonical
7492	3NLDSun86bLduWB4nXMbfDnHv2xoZ5ooSjYVmqZ3DpChfDXN86qN	7487	3NK565ZadQo2BcqEtVucjhw3iiU2SPWmG1beoTwHCSzVD8Z3y7hV	1593	1346	86	1	6301	jxNtHX37wm6TQvvPoZzLwc7Y8HFgYwuc2Z8Y6jhFwr8ZQcuQ5Dh	3874	5475	5475	1616924700000	orphaned
7494	3NKcBvtn6tv1BbXjnzBSwjni9PGcW11M15jVKAmhXRyerruuDJ1y	7493	3NKs5trPKGknFtD58PeytzHpPGT71uG8wkuedYUBDCQTmahUcL1o	1623	830	86	1	6301	jwVK56etpkayVBurdQvk5ujiyCa2S65Hcgcv2gxMpprYPuwtW9E	3876	5477	5477	1616925060000	canonical
7497	3NKXBuZSUP6AbhLrMqzdyCLqWdqfZjEujHecRK89nmTYrgEThm72	7496	3NLeXn2MYXX1YqPCmWfgchkyzsxZzYtvXZeQyqnyfT26FwQ2RpTA	1407	1395	86	1	6301	jxao2fQdbmsnZWDNFe75KhvYMzG7GXy7zcorzfjaJ9KKXoVWdBo	3879	5481	5481	1616925780000	canonical
7500	3NLFJWuKEU6vATLi9ncHS5pdFf1GafcnYxUPFRi2GDdLKd5ibNSy	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	596	940	86	1	6301	jwZ3GFD8ap5gfzLrL6dopCC3JoNxFA4Th2KX1nuExUohDYxt2uU	3881	5485	5485	1616926500000	orphaned
13694	3NK75QdjQtbK2JZ6TDCgu7H5NKjHETjJ2nRQc6a9xFZ1LEApL6A9	13568	3NL3wCa6m342LdMrW9oBF6pmraxiM9w48yCBpJSq5gQVg3WLeGJC	1564	972	202	6301	9902	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6952	9950	9950	1617730200000	orphaned
7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	7408	3NKa9c8nTUTnxS1ffy8JajzZt1B5mMSUkiLGaTaxwSwXjqpfo6iM	1654	70	84	1	6301	jx8fsGX6atf4buwoAV3JkVJvqdu6MtnhR7MGLAtk1RF8ABYyWsX	3830	5417	5417	1616914260000	canonical
7411	3NLWxBN9XKvCiDPvHdUeuboBGgPsTAFNZ39imTEJHHAxYVac43LP	7409	3NKCB4zWLSSaav7GMsN6awynroyuw9ZoetMetHtBRmhrSqdVA13o	1637	816	84	1	6301	jwu2HK2aoUQGbhYzisF6DE9K4vEjc6WdhBR4846Gbs2MKV7uBUj	3831	5418	5418	1616914440000	orphaned
7417	3NLfodMP46EP2Y1pZdrwHd7wYMiB87sne73ADoy4xYBHCSKGJUCo	7412	3NLsJGcpTSdf1oD79Gos2DrZRaBRdx9ULEeUxPxWyD2YyHeuhExx	1534	220	84	1	6301	jxEtCgukXAF9HfbYdRpuZAUVP4AuV5wbTTLBTnm9PgiuDg9sLrD	3832	5419	5419	1616914620000	canonical
7420	3NLvSkhqJYA3rVVmC6xnFAmCaVU6CHjzeUqQrc9kvLZWb7BXbess	7419	3NLUo5FbZpT9Pn9U8FWhTdLu2WQpzaGuMMk3ZHBCW1NytEjza6ja	1402	868	85	1	6301	jweWY9MDCfsdT3CsLbLU59wGk1L2ghbtiJEUmpHH5DB4iRibfi8	3834	5422	5422	1616915160000	orphaned
7425	3NLB2fnfJWbtUHeCrF1XT4xUTeDe4KRfCQooVUH8ygE8dM1pgRRT	7423	3NLQNjZt1X1mZmzqBNNynSqxDZufYvjyAJqKjLid5zgJiZSt8yzT	1403	824	85	1	6301	jx6irNbGhHdSJ32QPGAaxsLzwT9Yvpmo7TugtWnuZwiu2EFU6ZU	3837	5427	5427	1616916060000	orphaned
7428	3NKVYoPpGeCD4dazdhd23inL4uZxDJk5KJrNx72voZQwCoPxEQWJ	7426	3NKYPuWKUVpV9s3pV745Y25BifqEPXC8zrKQxoXyxpbRraZz9LP4	1577	1327	85	1	6301	jwG86EvQX2H6oPj3T4b5gTpbfuUgoUkQ3zbQ5GuWYk5HdrP8LKJ	3838	5429	5429	1616916420000	orphaned
7430	3NKApBoKvss6fgaeCCFTdgxWyhJcCgzsggxcbgR2hA9DpnXu76UY	7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	470	943	85	1	6301	jxJmVXHWgDckqrtHQxmzqHvUwM3h6hwDn9xmaXdf6RSwXst8RLP	3839	5430	5430	1616916600000	canonical
7432	3NLh4sY5o2U2zpL6mSACxZosFjZ3asKrDrxt332BRmDkuDvMQ2mB	7430	3NKApBoKvss6fgaeCCFTdgxWyhJcCgzsggxcbgR2hA9DpnXu76UY	1483	663	85	1	6301	jwqGdo3pigLCmLvNqdhdZitJ4EHoq45v3GiMTXNmK5sM9aULAe3	3840	5431	5431	1616916780000	orphaned
7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	7436	3NKZT6zWow6vnhZwdsq1R5HR3NXmBHtUozXqGQTH3UmfyXYTTzfF	1631	793	85	1	6301	jwFH5YbAjk6HxBfwWJ3r2m4q7md8KYcdc9Nf5cpvRi5u49UJBkE	3844	5436	5436	1616917680000	canonical
7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	7441	3NLmyv1ry8DfmCkuYpY5sR4rZxgUoRswL6TdHQXtwDuTu37v6VZz	1631	794	85	1	6301	jxk9SDenvmMg9Zie5SNhD44mcMsbYEpmbVkYfuLZZy817MEb8JG	3847	5439	5439	1616918220000	canonical
7450	3NLgW3azFjS9QzBPGpenvktShjWTBaTAkXNZUEdFJUYjWvsJJGrY	7449	3NLDNyjiEKvnREZKQjgAHFhcYN1xb5XWEDcFmZANETdvrJd1UGQr	1500	931	85	1	6301	jwbrEVvjKgc4VDvyDqvYB7F8Z7cutmgQ3w7v1iU8dHEXJUALGub	3853	5447	5447	1616919660000	canonical
7453	3NLojGmC5Ye1CCkAM3wVtH6RtR49uocFHnnbHXQn9oGE7dmDoKmn	7452	3NLyY7K9p7N9N3W47qs2GcJXekr2sVEFjiES1z8WedNYS4TLrMRS	1617	1162	85	1	6301	jxiL4BceDH8Aqg1DfLPYw1dAYcQXcwSwzoHHDTqYv8zNZ3KLH8s	3855	5451	5451	1616920380000	canonical
7461	3NLu42JaN29M16LQc6VhLWdBMo47yme2KgJraNJGJv2ChyzvHYxw	7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	1578	930	85	1	6301	jxNPJYmwaLNskmHtjR22YKHEBmiHMJFhm2uVggELiJKxUvz9H75	3859	5457	5457	1616921460000	orphaned
7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	7464	3NKMeLJqVLBW1UUMv5J8UEEfTdcr1yFJwYWyAdxYXNiAYVwPsanJ	1646	1108	85	1	6301	jxM6XAG3pwpS34TmTuUyUHGQBdm4GeAEMHhb8QySBXLkgUHQsYR	3862	5460	5460	1616922000000	canonical
7469	3NLXAwJFtheB9n2ED2tfmpGe5h6zeL9ugH1cTCpdyUvqMoQCncgU	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	1407	1395	85	1	6301	jxESPY9HP6xdHK8RtQyFb8bynDLM6MFKyJtKihbAE1Tj1PdWrMr	3863	5461	5461	1616922180000	orphaned
7470	3NKVbtaoywVPSCfd2crYkRbyFjDozYDYYapKr9SvANWoc2oEm7Fc	7466	3NLxPfqnHdu1PHYuzg265qoD8AtDGaQdQey8NPvxmDz2VFyusFVi	448	1059	85	1	6301	jx86iZdcNCiweaKzp3LQKKvBWzjFFppRPEaYBkaStK9M33b2ZyD	3864	5463	5463	1616922540000	canonical
7472	3NKE3kGJCoBWD7R4gpC2koRTVJUVUqDr1BwZPLJFi1hL5HjCJhMZ	7470	3NKVbtaoywVPSCfd2crYkRbyFjDozYDYYapKr9SvANWoc2oEm7Fc	1446	518	85	1	6301	jxXeLn5TkybdnMZxGw2zoHN8qKjGztctroHZELmVsozJD5ZsFVU	3865	5464	5464	1616922720000	orphaned
7475	3NKUqKDh3wsLdmzvFwBhAaeXENXRg3mVTiTBfN2QVF59oLTKAwit	7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	1406	1393	85	1	6301	jwpxi9vGdDMWWf4PsSJiTzwzPzHQzx6ArFXt7sZGqLTy3r7ZWZZ	3867	5467	5467	1616923260000	orphaned
7479	3NKocw5pPntLXbuzK7UmSHXYbzr9vrDJxACzbiMA4cNuyDoWv7oy	7478	3NLwUsMt7XLfom5Mn6MjBxDzMheymMaVfKZP23Sihb6G8UpS37Pi	1656	1217	85	1	6301	jxx5KX1S44e4bXfNhkzEa6cVQxiuqRzPBeXarRMkv6Lmd2MuAyM	3868	5468	5468	1616923440000	canonical
7484	3NLvPghhj9QxtEM9o9oMKumgokGh6Lv7qdoARcaCDiX7PJn6zgxy	7481	3NKvT2gcuCvWf7hy6kUx4dEzp2U9Ex3JyZG441ZX8LG6L6i2c3hX	1627	1259	86	1	6301	jxSrSdoshMEnbF2Pnq1Ma9jmvZvvGSAEjtUgYA5hJFdiQy3siUi	3871	5471	5471	1616923980000	canonical
7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	7484	3NLvPghhj9QxtEM9o9oMKumgokGh6Lv7qdoARcaCDiX7PJn6zgxy	1440	1377	86	1	6301	jxqPw59kVsZVB9bV4PjDC6JqrSiwrVg1zoTTAQxy27vK1koA6vT	3872	5472	5472	1616924160000	canonical
7490	3NKsBGBmWLg8GgdQM9F8u3xARJ3fsvLpjUT3DSf9xbfuJUfoJwRY	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1581	778	86	1	6301	jxX5E4QotKKutSQ1FTZFnXQ9gYES7ya2a6nwz4hmvjenTALJNf8	3873	5474	5474	1616924520000	orphaned
7491	3NKhhiqY6NFpo2FRibraNefHgbwSJKHVKhGHjH39UExCxykXWmbx	7487	3NK565ZadQo2BcqEtVucjhw3iiU2SPWmG1beoTwHCSzVD8Z3y7hV	1647	1056	86	1	6301	jxEhSJnECMJxKggpVGjEq2buW4RR9gtt6qoXdxpg8oeM666xLM6	3874	5475	5475	1616924700000	canonical
7493	3NKs5trPKGknFtD58PeytzHpPGT71uG8wkuedYUBDCQTmahUcL1o	7491	3NKhhiqY6NFpo2FRibraNefHgbwSJKHVKhGHjH39UExCxykXWmbx	1553	776	86	1	6301	jwZu9FYYQZsNKWnriszVirs54JBmtEaZrr7xBQaV56CNQU7ts7q	3875	5476	5476	1616924880000	canonical
7496	3NLeXn2MYXX1YqPCmWfgchkyzsxZzYtvXZeQyqnyfT26FwQ2RpTA	7495	3NKxE8fUnfd6ezqyy2vzpaXLWwtVpmfAuTnAVQeL14MDTgDU7Suy	44	1199	86	1	6301	jwjynahXAjFheiesw6r4cmnpBZeiUqaVk5iNzR1hnHaxW4cp9tq	3878	5480	5480	1616925600000	canonical
7507	3NLXYLrNuq3mzqxcWTN4D7bWz2ggn5uRJdzi3QVT5vgUoaP3Nj5U	7506	3NLai2DXdPDeYRUvtuo6gXTfosdedjXpKRwqUz56MqJqFopTkCaL	1611	1095	86	1	6301	jwdeekjwauQn2WiWpqqQfmaobUBLNTdDvrzvZuKfeJpbMs9XjNy	3886	5492	5492	1616927760000	canonical
7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	7516	3NLRUgx6D1yE3vqWqfLTU95kPX5kxN7FAgqHyggJU9AwbvS1ryh5	1397	828	86	1	6301	jxY4ELe1FJaWUXgRApU2fFZofSb4zgi7q3KA69CXzSBX2tm2mmT	3892	5500	5500	1616929200000	canonical
7522	3NKfS5iGu3HdTD5Vf46Ge6Wz79MPHB1HWcxenYZmttnH3bPhHqss	7520	3NKaCDCmx1tXyZazKfWDgVhoNimiHQoLWiBBaeHRn2Cyt8y9W7SX	1553	776	86	1	6301	jx6oJYgx1adcQ3sGapvHWEvzgVvw1BXXa1g3UtYsiVL6QxUeQDC	3894	5504	5504	1616929920000	canonical
7525	3NKouQunC6SPyKof1K6pc72Twa4btBBSFbNwMZtknEkHn5UktmdZ	7523	3NLM5rXCt7VkNzmmLqRro7mFkfgVvZ1g2YXu5DZaKQGJyigBKKn4	1500	1297	86	1	6301	jy2nKHn26cQzgLPh5SUUYzFmzJPzK95sTEpJp7KSJGTn9bsERxf	3896	5506	5506	1616930280000	orphaned
13506	3NLn22ebxUAAqzTBeUWszLzKxQhUPN3HN5JJPmrhzYUnjJfpDMvL	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1403	824	202	6301	9738	jwzkH4VVbaDiS7KYtYcVX8G5wBjhpbTQfVuGeuBjRsx8tggLsZb	6953	9833	9833	1617709140000	orphaned
7429	3NLtsKX9rLspYFyV8R3cgtmkKB6ShsWv5FEpLawNWyFU2wYcX84N	7427	3NK7avmRw41uwac9d5UHmTYSBqfYjCex5YZJ3K6L3udEFAmPvpup	1536	1313	85	1	6301	jxuJqvB5ydxjtPajG9K6yrkZ8oB564E2CmofSETukYK1QU68r1c	3839	5430	5430	1616916600000	orphaned
7440	3NKKyjYG5NqNnaNhUNTsmCXCNwjZTtfspKnDUY7v7GC6xCj5h9it	7437	3NKmv6HDUGhWtcEqdE4vLKqHdavbhpBkTFqE5TweQUyhcYrsY7fo	1593	1100	85	1	6301	jxHFn2cS1NCdQZedehmZyUnbpPDRGwtVhgsi2k8z3HjmWQnCTfE	3845	5437	5437	1616917860000	orphaned
7441	3NLmyv1ry8DfmCkuYpY5sR4rZxgUoRswL6TdHQXtwDuTu37v6VZz	7439	3NKNd3PByZQw5ta8HS4vDEnSCKnVufRBJrApZKqnugD8a4W64CSG	1406	1393	85	1	6301	jwazB1kckZkqPszatQxfJ9taLLAnkRVRJKWoALCd22Ap97qMyVN	3846	5438	5438	1616918040000	canonical
7444	3NLr5hqUHPB38BogTHP5KTypBHbC5xjMvjpSkQvkhDNLU4iEvR7Z	7442	3NLCrdFRrydofV7S7LhguEBaMweDZTryETQjZDHRnL94Fw5tkBhX	1536	1067	85	1	6301	jwbw9NEwhhFfHz4j5ahvPXGw32Dz63YddErSP63u7RvwDEuGaS7	3848	5440	5440	1616918400000	orphaned
7446	3NLQVBgRqwx8MMvyGLRuZgEouD2orhpGE9yg31jcAXrD9A3UuVhv	7445	3NLG8La83ECUXjnbhjHrCN6K4vqbpZRAdxdVYBcSmY5urQ7AsXyH	1648	1038	85	1	6301	jweA2mLtU2sK2S2GhLCGAqey7rdQxwPdzKRR3nNgG54RopZpuZE	3849	5441	5441	1616918580000	canonical
7449	3NLDNyjiEKvnREZKQjgAHFhcYN1xb5XWEDcFmZANETdvrJd1UGQr	7448	3NLQW76dHuxxz2FwY5RWRv1vkY45jBesTRk4EhLcTCcCG8aYLyhk	1509	1074	85	1	6301	jwJK7XQ7RRpEagS7rBhfapSLc7LoVdf7eWP4qnz28KhKGRtuQHg	3852	5445	5445	1616919300000	canonical
7452	3NLyY7K9p7N9N3W47qs2GcJXekr2sVEFjiES1z8WedNYS4TLrMRS	7450	3NLgW3azFjS9QzBPGpenvktShjWTBaTAkXNZUEdFJUYjWvsJJGrY	1637	816	85	1	6301	jxBwQ6b8zKdX1XKaZhoM9dgj5AtURGQUYqfZ4E6uSmsAZn4GQNW	3854	5449	5449	1616920020000	canonical
7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	7453	3NLojGmC5Ye1CCkAM3wVtH6RtR49uocFHnnbHXQn9oGE7dmDoKmn	298	1308	85	1	6301	jxbLJX3zWSjni5i577knZV2zMtrtitdba5MKDN2bm7jpJYjSPM4	3856	5452	5452	1616920560000	canonical
7458	3NLboADoQ2Ufvepeh1C1myNXjNYKLzjUv6YRzKBiGHrq64C3womz	7455	3NLb8NQ4Mimf9GvUZGjjTVbcmWZ7pZjULQpPmKS9nEcicJmxW8Fs	1637	816	85	1	6301	jwfRSNkKYXAdA1btexXAZXj3sE4A9PQh4aZkgLiM9FpDeWxJ5Zo	3857	5453	5453	1616920740000	orphaned
7460	3NLXuVzqugUR3UZvvwnR251vaaBiy39jjtJJjWYtyE4m96wvxYvb	7459	3NKDThc2CFSc2PB9eCZ3U18S8zpNxUncXjfuzmJpjQJ7U77pbkXG	1406	1393	85	1	6301	jwU2kMBhRhqXNXJjMF6UncmNZhQJmnjno4EFBmSLgKgmif7rc1S	3859	5457	5457	1616921460000	orphaned
7468	3NKHq5opSvPgkjvfSy7sNBoQF5eUzbu3rWTBmGcnS79h7hmX2vqA	7465	3NLiuv9MSmtkWWfJNfm9EKLbVUMXjhxHFszt6EMHxbVHANVHVKtR	563	1233	85	1	6301	jwti16ZASbV1nzHt1hHcFpQEh76hatGTeJRY3WNp5jA7wxsnnzD	3863	5461	5461	1616922180000	orphaned
7474	3NLjZREBbda1BBtiqHTaKURJmwNtCoUiaebpZuBtXiHSn4dYhtbb	7471	3NKCuQFQ6FTzJcJipmeJiZLeao8GrZCztrTvV3QDi4o9xMHbat9C	1406	1393	85	1	6301	jxSg42PPz6qCc4Ykr47yU4hf6386L3EjrcapLcV6AqS36t8ZUq4	3866	5466	5466	1616923080000	canonical
7481	3NKvT2gcuCvWf7hy6kUx4dEzp2U9Ex3JyZG441ZX8LG6L6i2c3hX	7480	3NLn4hBsXRbfx1MoeMdQdv9MJP2EaQbBytdESg7YYfQapZRcp58o	1406	1393	86	1	6301	jxVfjHq9kc3EEC66KpfF69j5Ao4jamYqzAapWmposiKeWQ9K8T9	3870	5470	5470	1616923800000	canonical
7489	3NLY6dLyxeYBxGyanCMeMwVJUdV2kdid4d3xyukSYxbbzGjcJt25	7486	3NKQkjtHScnycV7EWdNFZ1z2RKcjhcpwWszM2YkAALC5v78y8vVf	1407	1395	86	1	6301	jxo6tkNYPLpy2VskCfj4DR3JBo84yrYdbzscoDEdgHETdTisHS3	3873	5474	5474	1616924520000	orphaned
7499	3NLf9K1zLj6QSDz5eHSxzzENZCr8zbayVYkjeQj13sTRJ9ayQJco	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	457	457	86	1	6301	jxoVJRbwdciggJW2bLdJPX9JUGMzDAxWBQCrdFPbuumbNtuAZy4	3881	5485	5485	1616926500000	orphaned
7504	3NLNEjHx4S82KTEXDkbWmkmERhjapCvgWWeYXYTwQDgwwMXvB7ae	7502	3NLAc6VRM9qtoDocuEFszen7tyC5Dq32Ej5iHsa5PujnXiSfmonr	1407	1395	86	1	6301	jxJo1qdwjqRqyHakxWMvL5yf65zScjFwnv86hwHCSLFx2BYF2R9	3883	5488	5488	1616927040000	orphaned
7512	3NLaNDx6rDxY7ut2KK7NmEyr6gq2VhrGp34HXySw2TiRUeqn67V4	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1407	1395	86	1	6301	jxmQUsYytnKEovufohfME35V5JQEZkACzq4CeaTs9UTqWqGfUNF	3888	5496	5496	1616928480000	canonical
7509	3NKMQ8ZejP96j8FZW8ufVhykBTcFbnDCNSTiZfF9hmPLbnMEmf3M	7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	1607	1222	86	1	6301	jwNZgQtbGUvDG6zBd4jbKT3GyCRv7K8WNEazMGV3z6s1Km6fWFs	3888	5496	5496	1616928480000	orphaned
7516	3NLRUgx6D1yE3vqWqfLTU95kPX5kxN7FAgqHyggJU9AwbvS1ryh5	7515	3NLcpNtTVVo7vEGPFcgvs5sqKYhuNU2y8saKrTxzobeAr9veNB28	1419	814	86	1	6301	jw9XsvP8D44Jdzr28kMGyZiqN6pc9WrAjVmLkhzQSwPwSP5CU3Y	3891	5499	5499	1616929020000	canonical
7519	3NLxuq71NV8PiVJBVoUdeAZgbB2BtM2e78mCPwF2Yi1s4ek4Ec7G	7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	1483	658	86	1	6301	jx4nMH7uPns6EGF9S73DDtgVKaUd3o8bGGPSQGpmMAJx2bfcCdu	3893	5503	5503	1616929740000	orphaned
7533	3NK6bFKsrHRH8bU4b128uQHFSmywyo2xKUuxacT6qHS4H9xq72Ae	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1560	400	86	1	6301	jwTwQdgBRbJLEXqStb5nhdXZZuPEvEpLYbGEWBYwedxgJZEcGxf	3898	5510	5510	1616931000000	orphaned
7535	3NKXFTZqxau3st8qmdYAjug4V6vxPgCdE6YEky7ffowNPyLyHTSQ	7532	3NLMfkkWG9TLK6qDbJsWtE6g6JD1vaVsVJEWfjHYrohi8Aniv6Du	1402	868	86	1	6301	jwZ57A7FcGSUweeBo9ESRt3ZUkQeQd5S9SJMsS8eaPoodDWf1Zj	3900	5511	5511	1616931180000	canonical
7538	3NLMu6EWzR1tr2nM2qHTFgUwjtVoEhCKQUG6iAYm7P7NRDhcaQV5	7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	1609	967	86	1	6301	jxzkta8rfH5pGEkurpjinCcfnLJLZu7vLNcrYsQ74C5Pps23sqJ	3902	5513	5513	1616931540000	canonical
7550	3NLcRCmsYFrtpm6fvACHQB4xjCc8qpekziMDiwWQZRKHUjcWXm2V	7549	3NKQZCiwfMEebSfCtd9p7Yh4TUmKaho1Fb6mfNrCQhVDYHihGQ9T	1406	1393	87	1	6301	jxffZYi7Vy9pBCeid72PrE2Dc1Di252prP9JD7CdHnpvSJ4xY8x	3910	5523	5523	1616933340000	canonical
7555	3NKGBsjtZjdg1yi5qB3xDoxDDEGfGkho8UBWJa8NhaepUSFkj11u	7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	1458	1077	87	1	6301	jxXAUk9zNxxnsnudqwVsTv9T1d9KRTfovaMaT98z6dQGe4Daw3K	3912	5526	5526	1616933880000	canonical
7557	3NKDVBiUcu1s4mVJJ4FJjkVjTXSgryLWJrxHM7vyvrWH28der6Vc	7555	3NKGBsjtZjdg1yi5qB3xDoxDDEGfGkho8UBWJa8NhaepUSFkj11u	1590	1174	87	1	6301	jwy5B8ptaVUe4LqcJoyfdMUkAzn3o7i22zE8ZkbVk8Fq8s96Neg	3913	5527	5527	1616934060000	canonical
7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	7565	3NLUX89VFpPFDjPyb1yB66e7F6dh3deenXK6APwwmDddtwq6xqLm	1516	1168	87	1	6301	jxNYU1iUGccqLSxWDFxVM3JZSb16NKeFoewoW8WM4m2terFeJZS	3918	5532	5532	1616934960000	canonical
7571	3NK7ipTCm5H45tmHhUhzfhD6znpKoMXCH85885aeYitaM4QVb6Lt	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	596	1060	87	1	6301	jxvbDbU4FNTzss7JCdBxCeH3TQXS7jjhjARxZ4zXp94FYvyMmvD	3919	5533	5533	1616935140000	orphaned
7582	3NL7yFvUnBx2WydPaRXF5jiNifwgE6rwv8EecE8KCF2DGsF7Bg4X	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	1594	1200	87	1	6301	jxEhY3qk9eqMzAGuttAGW7vH7DTzQevAUmTRmKHuHbivT87fWZQ	3921	5535	5535	1616935500000	canonical
13829	3NLnp5pKnGsoqL5VUF7Foz45QpY5s6Jrt7txAVZeRkNUpFyvcun9	13694	3NK75QdjQtbK2JZ6TDCgu7H5NKjHETjJ2nRQc6a9xFZ1LEApL6A9	1564	1092	202	6301	10020	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6953	10047	10047	1617747660000	orphaned
7511	3NKDHNLXn1tch9ZAhNDaeJyGy27SQfLYr76icPZ8bPjzGamd4n7S	7390	3NKjAxJ4gXftyJ6pQ6dbs2B7ANSmN9LCtzSRtnwDYYzkekk63G9w	1607	1222	84	1	6301	jwWMMTk6BQpMFRdDDkLGdA71ogihAtbkQwu348tFpe74hEJdECg	3818	5496	5496	1616928480000	orphaned
7495	3NKxE8fUnfd6ezqyy2vzpaXLWwtVpmfAuTnAVQeL14MDTgDU7Suy	7494	3NKcBvtn6tv1BbXjnzBSwjni9PGcW11M15jVKAmhXRyerruuDJ1y	1402	852	86	1	6301	jwcDWKyybG8idC523JbF91rdvk9WMKeub3FANkDkbpY7zivJDex	3877	5479	5479	1616925420000	canonical
7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	7497	3NKXBuZSUP6AbhLrMqzdyCLqWdqfZjEujHecRK89nmTYrgEThm72	1406	1393	86	1	6301	jwZ3H1Uxt88u99YzyLnhVJjQ2LgEcMMC59NSymD1CfHqFLzDxNH	3880	5484	5484	1616926320000	canonical
7501	3NLfVmN6RURGxBMbFZzqqJxpyFupZ8oZRcpwNxBUVJ7E6R1o8vG6	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	686	686	86	1	6301	jxGj9XHJKpRuP6c2UrWcfAKEi1Y5va7cmDWWe2jPP2WbGs9SNJP	3881	5485	5485	1616926500000	canonical
7579	3NLaEaPBL4Wb3ZfbFfPREvCZZXoMDnwzVGiRCLZHBSgbJW4XzNT2	7498	3NLnmd3rrmdfNPRYxtVgTdu1QK864AFLvqqG4Ds27jB1vU6xTJxC	1654	1340	86	1	6301	jy2ohpG4cSZAk4tVNmGY9BEKxVA3PgS7tetYuQNT4MDgDAp7Rgo	3881	5535	5535	1616935500000	orphaned
7503	3NKUdPuYdfe2KdeY9aLCRFooabGM29pUdESVJmv5suCQkD3etyci	7502	3NLAc6VRM9qtoDocuEFszen7tyC5Dq32Ej5iHsa5PujnXiSfmonr	1637	816	86	1	6301	jw8zfgVyX4gUq3n1hFa9bC1Xxnmzp2N7n3L4GJ2Tq4gLa5XjFyR	3883	5488	5488	1616927040000	canonical
7505	3NL9xXqdobL8iTa5aduBCg6ZJ19VKgGnv9Fx1cFqwGMnHGRLRm4o	7503	3NKUdPuYdfe2KdeY9aLCRFooabGM29pUdESVJmv5suCQkD3etyci	1573	1318	86	1	6301	jwEqPVuWPx8r2AQixDRfW3ED1J5XG4uCDDKiXRXE7nMd2o7rEc1	3884	5490	5490	1616927400000	canonical
7506	3NLai2DXdPDeYRUvtuo6gXTfosdedjXpKRwqUz56MqJqFopTkCaL	7505	3NL9xXqdobL8iTa5aduBCg6ZJ19VKgGnv9Fx1cFqwGMnHGRLRm4o	1423	343	86	1	6301	jxhiK3Hz3NRMNf5AJ7H31NwKdpWnC1gGeA9rMxjqSKqfQuLBqSV	3885	5491	5491	1616927580000	canonical
7508	3NLsBp8cGgDuM6FXtA875keT2zuKBnCCSjqHSi7srLWF5HSoyswh	7507	3NLXYLrNuq3mzqxcWTN4D7bWz2ggn5uRJdzi3QVT5vgUoaP3Nj5U	1637	816	86	1	6301	jwvV4pS6NNtUkyvbw9eiRPm5upaUBXyabXBrDFmsrDhdMTHWQqN	3887	5493	5493	1616927940000	canonical
7514	3NL6EDuCFpAsrA13qSLa5efc2UhDxVwNUSRnLf8PZo5E1YbBJgnj	7512	3NLaNDx6rDxY7ut2KK7NmEyr6gq2VhrGp34HXySw2TiRUeqn67V4	1407	1395	86	1	6301	jxG1pAX5hNUW9rekVyNvdha7kgNF5xionnc5XZrXEyJp4T5ZrLL	3889	5497	5497	1616928660000	canonical
7515	3NLcpNtTVVo7vEGPFcgvs5sqKYhuNU2y8saKrTxzobeAr9veNB28	7514	3NL6EDuCFpAsrA13qSLa5efc2UhDxVwNUSRnLf8PZo5E1YbBJgnj	1483	600	86	1	6301	jwUxHRv2bd6E7mkYDE35n7eUhPCpZ947ExDBhzAcrdE3kazWHtY	3890	5498	5498	1616928840000	canonical
7518	3NLQCndSiyTF1SFgLSNFSRY3JPfd2QL8szUEh7vKtmmPMHhLBetw	7516	3NLRUgx6D1yE3vqWqfLTU95kPX5kxN7FAgqHyggJU9AwbvS1ryh5	1573	1318	86	1	6301	jwGuxjguoZpFtB9cz6s1HGWzdbhqnS7TJ3vRyty4qtqpmak4AfS	3892	5500	5500	1616929200000	orphaned
7520	3NKaCDCmx1tXyZazKfWDgVhoNimiHQoLWiBBaeHRn2Cyt8y9W7SX	7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	1501	1360	86	1	6301	jwZYihbrRzDXzZ4N7HY9FyYxVnVgw447gJ6yQeVVE8SAwXcf9jV	3893	5503	5503	1616929740000	canonical
7521	3NLeoqY8vuPCnEk4o9JKGedJxGKnynNhZnGQzv7DQKGtYtmLdixM	7517	3NKir75fg8zn4fwJKyEs9A3MwbCawhpQdH68xEAHvsua4GxxRohZ	1577	1327	86	1	6301	jwQfEicsFkvEksYKZmNCVu6XtsifV7RwbHYgHkK5H8BjLgLRmae	3893	5503	5503	1616929740000	orphaned
7523	3NLM5rXCt7VkNzmmLqRro7mFkfgVvZ1g2YXu5DZaKQGJyigBKKn4	7522	3NKfS5iGu3HdTD5Vf46Ge6Wz79MPHB1HWcxenYZmttnH3bPhHqss	1458	957	86	1	6301	jxRUcUmmxtrS7SSoPAopZko5itttfaQMGokniCEYGKypkn2Ez7Y	3895	5505	5505	1616930100000	canonical
7530	3NKzdVPrYdfCCHu1277VTrqtNLxE3BDfhj3QE1e28Nhe92GfQvbF	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1445	1044	86	1	6301	jwW99Wz2Wi6Ekcwfg87CsdxLaUYHrL8FpMYUazvRvR37pnvj6sn	3898	5509	5509	1616930820000	orphaned
7532	3NLMfkkWG9TLK6qDbJsWtE6g6JD1vaVsVJEWfjHYrohi8Aniv6Du	7531	3NLjzCy2FKEnF6aSoiCHdEsfbww8sa6j9rTXaZhAd6oYENxeP49s	1560	400	86	1	6301	jwrvf6hRfWuE6QzddU9nyHiFBVnXYHiwJmMsMnqobRkeY53Ng8L	3899	5510	5510	1616931000000	canonical
7537	3NKS4qiLMejVt85824HXJijLToeCKiE9cpt1VBNZ8ZTdwJwrWiMc	7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	1529	950	86	1	6301	jxnyYPYg8yakyqcQuivjV69ZK7k5EApcyRQ2XdVhKkyrNg1Vr8P	3902	5513	5513	1616931540000	orphaned
7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	7540	3NLqenGVvBXeH78veit8GPpwvRgssWn2GJzcwAscyE9awCvke8vq	1406	1393	86	1	6301	jwPTsxzswgwECixwDEMSp2NrH7VbfFHzgNsBJDqptbKXgd5U7kr	3904	5515	5515	1616931900000	canonical
7545	3NKkMhRWYQWahDbzUwEAH2jANijiJ5zm4DNjv42Lg5CVpckx79kw	7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	1406	1393	86	1	6301	jw8RLLnHaabjjPdprUDnDLzmidYBcbCvyDC94qfq7LdTph6KJBW	3905	5517	5517	1616932260000	orphaned
7547	3NKBdd3kpQvCJwv9tfsfSgaBevYAfTximigRakSriTibsDLgG5fv	7546	3NKrNHa5wvaSLbaLTTRE7zumUkHRHTC1fksyAhxVVugwYV25B8ij	1419	814	87	1	6301	jwPynvf9wNbvTvDFp2MDhDVXp8U2Ump7YnrifAaBk2Rq3P8tKBc	3907	5520	5520	1616932800000	canonical
7549	3NKQZCiwfMEebSfCtd9p7Yh4TUmKaho1Fb6mfNrCQhVDYHihGQ9T	7548	3NKMBAhLvj5rSF8xi3YBEA7QWGc6fKvMmzGpwSAyxhDHoHydQsGN	1403	782	87	1	6301	jxvBm91PyM1bZYdg2wq4Dy8GNH27iUW2WypyyULxhHnGzwxiw89	3909	5522	5522	1616933160000	canonical
7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	7550	3NLcRCmsYFrtpm6fvACHQB4xjCc8qpekziMDiwWQZRKHUjcWXm2V	1406	1393	87	1	6301	jxVA3Nahw8ftrgpMH1ubmYimTrD2bTWKQQWEnYJ65YvS5amxRyP	3911	5525	5525	1616933700000	canonical
7554	3NKn8WGu7GMK5wwfYNuEEFPSVLEJEdLi8Gkp5BCREtYhjp2ZivwU	7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	43	1064	87	1	6301	jxHfU3fBgwqJmj5axbqJiSwyYEk8ZNpEbCBt3hWdp51Dn5RZvGC	3912	5526	5526	1616933880000	orphaned
7559	3NKxggrMu4XdCaZrDMbv8DBXM714zwc6ti9YTsNuGLCgpc42SNh2	7557	3NKDVBiUcu1s4mVJJ4FJjkVjTXSgryLWJrxHM7vyvrWH28der6Vc	1593	1220	87	1	6301	jxnb41EPpxwH5BsdrgLPhn4zJWDy5Nbq6Dp8LNjjE599CQg4Z1e	3914	5528	5528	1616934240000	orphaned
7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	7558	3NKo87pyUyoEmCSQk9q7y58FcmxkCDSdJeNReavsfNQ7ZvcexkWz	1573	1318	87	1	6301	jwVmxuk9fENDPSzQyXBpkggcTDHYgSmpEpWzY7zNC9bk1BPfbSA	3915	5529	5529	1616934420000	canonical
7566	3NLHgjRe2F6VMbTVajAsRKPPMXZcxG6WjCmeAfjLVYAF4vJPGmAz	7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	1601	1142	87	1	6301	jxmJvxCPqfUXTQbUBj4d58sTCCyyrGGsxjKTMSkGpSieikPjEVJ	3917	5531	5531	1616934780000	orphaned
7570	3NLZJSZMafS2VETDSXQVTzp58BnjjkrrvwBnt1FRvAY421KPZE7V	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	1403	824	87	1	6301	jwZJ5vBi7nkTRtmXCySghfzU6FaNZnhyrUkFUckXmZw6ineumci	3919	5533	5533	1616935140000	orphaned
7573	3NKx54S7TnSDhLhYLafZdTzEdgM6Cw8HBeXGgQ27jRJu5vsjqnJH	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	1553	776	87	1	6301	jx37hCtAaX3cKxhor93n1ThzN9DVcWcBcn5h29AhvwV1wFbTfuN	3919	5533	5533	1616935140000	orphaned
7572	3NKkxyPoJJgmbj47eSHPSyvBbp4VPZc9ub8m55AQRbo5ujruUuiz	7506	3NLai2DXdPDeYRUvtuo6gXTfosdedjXpKRwqUz56MqJqFopTkCaL	596	1060	86	1	6301	jxp1no9DLhNRdBByaDjnD2brGSyVqpmD2k9uLkcmWV1bVzqLhEy	3886	5533	5533	1616935140000	orphaned
7524	3NKjUMSS5s4mchc8VGjcnubgmCYSBQio4DStGFN6zzsaQ5enyyTV	7523	3NLM5rXCt7VkNzmmLqRro7mFkfgVvZ1g2YXu5DZaKQGJyigBKKn4	1403	824	86	1	6301	jxBSastAoWBKtckqc8SzUBAS6tYhmqtrZjkioGkEhdReeHFhAFE	3896	5506	5506	1616930280000	canonical
7531	3NLjzCy2FKEnF6aSoiCHdEsfbww8sa6j9rTXaZhAd6oYENxeP49s	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1406	1393	86	1	6301	jwdpBJzayMkC3Jyvn9rKT9Ew2U9ERPeAAbeGaf8cspFbajmj8xR	3898	5509	5509	1616930820000	canonical
7534	3NK6fCJnynXY3DWxxhPMFmfaYr4iwbS9MRqAZS8sZpX3WBcMgjCT	7527	3NLQxW5Ymo2734mGDfQr2bM561Lk2RVYetxZxkRjCaPPYotKLUeM	1560	400	86	1	6301	jwbmELtqYY9EGHQcdde78wy89A8BJTmNQNag6krWoCA9ZnKh5wq	3898	5510	5510	1616931073917	orphaned
7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	7535	3NKXFTZqxau3st8qmdYAjug4V6vxPgCdE6YEky7ffowNPyLyHTSQ	1406	1393	86	1	6301	jwypHD4zQvFgTyc8ZJrjzMVZCDJuBnk51EiJqpgYccUxep1GCPy	3901	5512	5512	1616931360000	canonical
7539	3NLBTbh3GFcNXEc5rEoWGBs84D4oeprPGL2kP5wq9gi8gZ4Crnoq	7536	3NLbo2y59gQkJqciWrRXoJLYfaKBHY2n6dqo4H6GmFECFZbmHFpA	1631	794	86	1	6301	jwNF997x2QQXrcWPMh2i7HvXyyTZbcvLpDv37TeNrbWPsX6Ywfy	3902	5513	5513	1616931540000	orphaned
7540	3NLqenGVvBXeH78veit8GPpwvRgssWn2GJzcwAscyE9awCvke8vq	7538	3NLMu6EWzR1tr2nM2qHTFgUwjtVoEhCKQUG6iAYm7P7NRDhcaQV5	1445	1290	86	1	6301	jxrqD3vdNN5fNBg6HUAxLsZGGfjbZA3p8FBzfhURdsa8VcXDBNY	3903	5514	5514	1616931720000	canonical
7541	3NKzutJ7PqGv5tAasffEAZwbYQpyV75Lxpnz1RELA7wH7g8fTw5R	7540	3NLqenGVvBXeH78veit8GPpwvRgssWn2GJzcwAscyE9awCvke8vq	1457	1391	86	1	6301	jxMX7L3GqNiVBtx9hPz9YdAcMxcLALbfYXn8LZ8qhsNEKRQM6JF	3904	5515	5515	1616931900000	orphaned
7543	3NKamgavRCU1SERKrYd2HG6Y1246i5AZ2QNfUaJW1TmESKtAQBQg	7542	3NLethHy6UBe4s54m9MumERz4cc9rwSTy59yeY2sdPGtv3DmuDBN	1589	1286	86	1	6301	jwFq9hRwBKxpsL4DduchMFXkkZiLp4xmW8fwGqPDRZcBnt4YfRk	3905	5517	5517	1616932260000	canonical
7546	3NKrNHa5wvaSLbaLTTRE7zumUkHRHTC1fksyAhxVVugwYV25B8ij	7543	3NKamgavRCU1SERKrYd2HG6Y1246i5AZ2QNfUaJW1TmESKtAQBQg	1553	776	87	1	6301	jwePLtQAcV6DM4JTJ6iAFdqhECa4h3wWf6gCnuGA26unFDvBjdF	3906	5518	5518	1616932440000	canonical
7548	3NKMBAhLvj5rSF8xi3YBEA7QWGc6fKvMmzGpwSAyxhDHoHydQsGN	7547	3NKBdd3kpQvCJwv9tfsfSgaBevYAfTximigRakSriTibsDLgG5fv	1649	1137	87	1	6301	jwYnX9Ui7ypCC84hKW98NJi1LFPNwiewXhybnyGgMjrVXPJRVva	3908	5521	5521	1616932980000	canonical
7551	3NKkSnY9zB5d8AcCGLSAND98WgNFxBy1DNVBPoixMkDVdcfhkHWm	7549	3NKQZCiwfMEebSfCtd9p7Yh4TUmKaho1Fb6mfNrCQhVDYHihGQ9T	1440	1251	87	1	6301	jwhABJG8cVUYKFHcuopXbRmViXHcb3UJWvZjq8gd1p35vQK9Agb	3910	5523	5523	1616933340000	orphaned
7553	3NKRXr2VKNEEWUPEZmcLXC9Dwyd9bzw3eoaPpy7EMAysfJvs6ccZ	7552	3NLhwhg5zXDLFj9LffTB26fgymgi1nP9mSRPeF7BkNADHHdsRbbC	1406	1393	87	1	6301	jxBAePuA3VjUwxXNzbMmjyc2ZjZdv6tkQJ17u4GTa8XtNwBtQUK	3912	5526	5526	1616933880000	orphaned
7556	3NKPj5rJVDfFtZ6PTVAXPH7S6huDxWK2Fo7PCti4h5x7K99u9uX7	7555	3NKGBsjtZjdg1yi5qB3xDoxDDEGfGkho8UBWJa8NhaepUSFkj11u	1406	1393	87	1	6301	jxwMpJvRFWjMmBWL3wjuWhK1ZsmHas6um49i9HkNWmAW13iaPhY	3913	5527	5527	1616934060000	orphaned
7558	3NKo87pyUyoEmCSQk9q7y58FcmxkCDSdJeNReavsfNQ7ZvcexkWz	7557	3NKDVBiUcu1s4mVJJ4FJjkVjTXSgryLWJrxHM7vyvrWH28der6Vc	1637	816	87	1	6301	jwYnjiG6P23s1GQjNFoXNqB9w15Tq5qCNurN582VMcZacJE4oQF	3914	5528	5528	1616934240000	canonical
7560	3NKNQ6butfZChq5KBdPmEedGJ4hQpBiWhcS1RYtFdbakBwKz8AWQ	7558	3NKo87pyUyoEmCSQk9q7y58FcmxkCDSdJeNReavsfNQ7ZvcexkWz	1460	670	87	1	6301	jy2Jp5zLafJgFdyEnH4J8VT1MkpLVryJcwiGtLwRfcchmSwbtDX	3915	5529	5529	1616934420000	orphaned
7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	1581	778	87	1	6301	jxpswaoUEYir2uVMM4RezRKqRauERyXSymBbJdtMvYY37SZzZnu	3916	5530	5530	1616934600000	canonical
7562	3NKmJY9HF5ENpDXYHawQ2YpRWBQdzgnwx1PTaGcDGVztDSHXZEmh	7561	3NKCxdjdwCbcu5E1wCZcoUjjrk81rc5M7u3TCYtm78ETYEPNWyU2	44	1199	87	1	6301	jwgUikgXSu9JfcQKmCYirrpFSdUQufEYZy5bfhXE63Cev279pG7	3916	5530	5530	1616934600000	orphaned
7565	3NLUX89VFpPFDjPyb1yB66e7F6dh3deenXK6APwwmDddtwq6xqLm	7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	1516	1168	87	1	6301	jwoHpkG5hMN3CGjXejs2q34sTAbKW3WAfac9ywmYU7RywPBn8kr	3917	5531	5531	1616934780000	canonical
7567	3NL8xTpuT6yPwkdkCkYcdje4d3hL4Noeo1KuvubJ9D4QwmVmB5F8	7564	3NKTwWpMpqxEfbFhmgzhrfyAsM1imbaRKAuJRYVxqRKAs42e5wcw	1513	1013	87	1	6301	jxkFy1X6pPdA32L64ab72FxvmuSBkv9KxZQ8SH3CtC4ARLd3976	3917	5531	5531	1616934780000	orphaned
7569	3NKtCF72V3HVLEjSFmkUY9PVHTUzockwkYyKDTgn4H48vhwZjGFX	7565	3NLUX89VFpPFDjPyb1yB66e7F6dh3deenXK6APwwmDddtwq6xqLm	1555	1347	87	1	6301	jxtx5pme77v2AefDZtFsmDQNGckWNMJZ3ydASeTjhi75cvSogpM	3918	5532	5532	1616934960000	orphaned
7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	7568	3NLUZXLgjizqhrBCc4Z6vj1mXK48t4DwrVAnhtsGa5swpgAF9qzU	1407	1395	87	1	6301	jxAVTAA9UDpTFXYkkJeuH1Y3iaPtFgNHTELBvpaxRYa6iJTn5fa	3919	5533	5533	1616935140000	canonical
7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	1553	776	87	1	6301	jwxBgNyHEzn1YmF2RpF4JWKtc1d85YWapdTp9PpqZdTFqUn2amj	3920	5534	5534	1616935320000	canonical
7575	3NKUpwoMXBbawdbAM6iWQLd1dG1Zm9jNxhX7kA9ytQKn99iu1mvF	7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	1445	1164	87	1	6301	jw7Jug2oufio7F6yfvCW4RvHAKNzQ2NHiwqXjsZE71N7KGwkZ9F	3920	5534	5534	1616935320000	orphaned
7584	3NKAx9UFJtFCVaCsNfSt3w9QPxFCjfScZb7gcZdYwwqQYJve2dDN	7583	3NKoeqhc3UWBbFk1wX45V3q2Yf9hfErwf21GPKeRSwPdXyVtiyzJ	1637	816	87	1	6301	jxSwDwPfGhxHVaRj4amfASiDVw9WLUicu9eFyZzcnaorWbRbTWz	3923	5537	5537	1616935860000	canonical
7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	7584	3NKAx9UFJtFCVaCsNfSt3w9QPxFCjfScZb7gcZdYwwqQYJve2dDN	1405	865	87	1	6301	jwJ45fWacjmmcRcWyTTkGNgkepfWiRs3XemGUVVkJjkc76SvLoX	3924	5541	5541	1616936580000	canonical
7589	3NKpP9FsV4GtPuVqtiPQNjRg9mhDHnqtsQ4dd6AH2moc9BHYdajy	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	470	1063	87	1	6301	jxyCTfZxjagk4G6ePxFiM73EfPjUuLwsAkQ5vgHxp1SVTvcwACD	3925	5542	5542	1616936760000	canonical
7587	3NKdwjafkTDU82zwB9FsJAQB6Yya1PJSKCHMUpjABrYyHiwSGZ7D	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	1578	1296	87	1	6301	jweiFhW4xzvN7PntMu7deE5W9rDxAWWMhmC6bzjHfj9TvoAv6Lp	3925	5542	5542	1616936760000	orphaned
7592	3NLrU2ARh8rG9kaB3YFF7iJV2smKE5we3xYexpCpZ9YzY7D9JTq2	7589	3NKpP9FsV4GtPuVqtiPQNjRg9mhDHnqtsQ4dd6AH2moc9BHYdajy	1507	1034	87	1	6301	jx33pcnXhTtLjU7oSv51LrghtqdDev7UutBW7gj8ZDeAFKJqgip	3926	5543	5543	1616936940000	canonical
9601	3NLU52xhGdWqAB8J6wcAawAeg9gU7VPHHb6wx8QBfDLDF8sCkaDF	9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	1637	816	122	1	6301	jwboXrPtyySM6rQx2dyHEto8b3YHjtghY7PN8Z5WyWUjg2tsTRX	4980	7007	7007	1617200460000	orphaned
14063	3NKEkuPqhKmot8hPEMJwYwLLuPQ9u1eBVrBcKTu7jpGP3EKLrQuh	13829	3NLnp5pKnGsoqL5VUF7Foz45QpY5s6Jrt7txAVZeRkNUpFyvcun9	1564	1338	202	6301	10211	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6954	10195	10195	1617774300000	orphaned
7576	3NKQNigefmY7tEKExbBpE4DdbTVVcPdsCrbRc3HNa6JNersZUYAW	7574	3NLqQQnxq1uWeugk82iEwG3dxfLMgnXuNpKxsrkXsqGGBRaVphKH	1440	1377	87	1	6301	jwBPH4k7Sq7HonJH7ohS1cFesTaYnx7BsjqYoCnPUxoBRgZ5Ppf	3920	5534	5534	1616935320000	orphaned
7578	3NKeKKhowHworcRAYN4DTShp2D3teLxkDtf5vKpkHAXANB2jUwD2	7577	3NKdfqLVHUDk63DpcQ6Q7rRtM6PtFNEv6jSKTgnpmCS9x8LTmhjZ	298	1308	87	1	6301	jwSnD1ZbMbR5x3wdgGvBQ9iHGk8ZLt5nMMWWEYUofX7RFs5WdtP	3921	5535	5535	1616935500000	orphaned
7583	3NKoeqhc3UWBbFk1wX45V3q2Yf9hfErwf21GPKeRSwPdXyVtiyzJ	7582	3NL7yFvUnBx2WydPaRXF5jiNifwgE6rwv8EecE8KCF2DGsF7Bg4X	1406	1393	87	1	6301	jx42j2DH2tYsLiW2QMpE4CGgoRn55zZ9t714J1NgMgPZDsMVDVo	3922	5536	5536	1616935680000	canonical
7586	3NLfwEFxaATQsVgRtmrpFDMNqWSTWX116b4tYHe4uuvYtCQP2nok	7584	3NKAx9UFJtFCVaCsNfSt3w9QPxFCjfScZb7gcZdYwwqQYJve2dDN	1406	1393	87	1	6301	jwSFEmf3W7LeUynh2S8DvEKit3vYyRi1pn2iRei4rk7A9ZdSBrq	3924	5541	5541	1616936580000	orphaned
7588	3NLuBR19TMHm9zUPNDDKPPvcMNYW7t6BpSfkGd9qCKZzU4wLSQMV	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	1406	1393	87	1	6301	jxBvEBPuCCG2MUWbjorJMUJJ6u7tCqXKqngjRActEZ4A3Ax6ZHH	3925	5542	5542	1616936760000	orphaned
7590	3NLw9NZ798ZbFeQ1rphKsPx5LmJMPNHrLgcDCcLxAn5ufEZ5j61D	7585	3NLUnyrSS3aB9JJzBtmJb8gp5rNS8FnqxsHNYXpSFNpPaqjqwjdr	470	1063	87	1	6301	jwJagetucSbfGFzoxiacJEEvc3d2zhnuvMSj3dgBpbbtjP4ohmu	3925	5542	5542	1616936760000	orphaned
7591	3NLUJZM6NSXz1tECLqXdqvSjTnviQSAqiFxM8VvBa5aLaV9C5wZG	7589	3NKpP9FsV4GtPuVqtiPQNjRg9mhDHnqtsQ4dd6AH2moc9BHYdajy	1672	1285	87	1	6301	jwVwJKgFMPkdmkhJjXsBTzxQL6mXHzLZrxdfJWSrFfcnfvC1hay	3926	5543	5543	1616936940000	orphaned
7593	3NL8EzVHyer9ENQ33df7gLUcZsxxxaySy5TV4qzSqVtffWh866dU	7592	3NLrU2ARh8rG9kaB3YFF7iJV2smKE5we3xYexpCpZ9YzY7D9JTq2	1489	1014	87	1	6301	jwAPxxp22TZppFt9J9pJQEEmv3fXounvfcbByHRfPCRR5DCWQk9	3927	5547	5547	1616937660000	canonical
7594	3NLaF6rJWZyqvHsFpsZSzdUkZNqkAfyKij6tfmw4GCEELjKNB5w7	7592	3NLrU2ARh8rG9kaB3YFF7iJV2smKE5we3xYexpCpZ9YzY7D9JTq2	1529	1190	87	1	6301	jwjwSUb3y2mWDQruWTVLnEhiS2qPuxMqiNB8acwxZwe45PDTKac	3927	5547	5547	1616937660000	orphaned
7595	3NLiDYUCYzcp5qT8c1ty2HJ7rWcr99zoRWc958vF4yDp9GGj5ixL	7593	3NL8EzVHyer9ENQ33df7gLUcZsxxxaySy5TV4qzSqVtffWh866dU	1589	1160	87	1	6301	jxf1LSqYgKVYKtAGSTHeTxQn2GW6vCxRJwWSUKAsQBVoFG913Kn	3928	5548	5548	1616937840000	canonical
7597	3NKhwtQtwL8VUNNuyYfSD2QwCphmTw7EXkSxSX2kbYXF9UnTAfnJ	7595	3NLiDYUCYzcp5qT8c1ty2HJ7rWcr99zoRWc958vF4yDp9GGj5ixL	1607	1222	87	1	6301	jxe8QWGpA5QW3pDYjvg6UN5SPpsFSqXyfnLCDMMu7dXftdc2zWd	3929	5549	5549	1616938020000	canonical
7596	3NK7jRcDib4sFLCYTk5E6JekWyWHXVFFpPJGuZXXy4wWY8HzmQMU	7595	3NLiDYUCYzcp5qT8c1ty2HJ7rWcr99zoRWc958vF4yDp9GGj5ixL	1622	1356	87	1	6301	jxBiQ7QcAnzEBzkZnhRoyYgu6DYufZ62e7NbQNYJoDFSSGYzKPJ	3929	5549	5549	1616938020000	orphaned
7599	3NKdXRjajopkuRsW78FvvdX4SsZAWJtZtETDKFQmt3AFM3teqoMY	7597	3NKhwtQtwL8VUNNuyYfSD2QwCphmTw7EXkSxSX2kbYXF9UnTAfnJ	1407	1395	87	1	6301	jxb6sJeTK2xgnE6hxoKCwftYkFKcEbUpAFuQQ54FyxC3BQSoWTS	3930	5550	5550	1616938200000	canonical
7600	3NLTHDKE8C9PB2qvRG6WvvebpLeX9KhmvLtXn3SaSkZhDmkYCrqT	7599	3NKdXRjajopkuRsW78FvvdX4SsZAWJtZtETDKFQmt3AFM3teqoMY	1593	980	87	1	6301	jxy9isywc7cpEwuxF7KvUqNCXTD7aCoQnUZwJL7zNCwav7bEBYq	3931	5552	5552	1616938560000	canonical
7601	3NKZhrPeC2sPu6B2mJjayLdMzXkpzyBnR75f5vYLUnCBbguXfc6r	7600	3NLTHDKE8C9PB2qvRG6WvvebpLeX9KhmvLtXn3SaSkZhDmkYCrqT	1406	1393	87	1	6301	jx6Xk2guweBBiS58a8SFdFyhTkfpsx15YUp54r5Ktodh6sUoJs5	3932	5555	5555	1616939100000	canonical
7609	3NK7HmJRsVpJdnLJPCvTmQwQ5sDhqFwNRahZBKqti6piKbKKkcKx	7600	3NLTHDKE8C9PB2qvRG6WvvebpLeX9KhmvLtXn3SaSkZhDmkYCrqT	44	1079	87	1	6301	jwyJZbsPeKSjBKJBZQEBS5JwBsWhNs4Rj9qGtYSLo77EwqSgXqS	3932	5562	5562	1616940360000	orphaned
7602	3NKkqHDyt6jG8z2ufxioVd9Wi5vAWsYRNUPTsiz5jYQqU92o7LE6	7601	3NKZhrPeC2sPu6B2mJjayLdMzXkpzyBnR75f5vYLUnCBbguXfc6r	1646	1108	87	1	6301	jwmqBw65cLUNnq1MMD7BQNt7upBsBPjxgxqFYbZqxJtGwNhZioC	3933	5556	5556	1616939280000	canonical
7603	3NKD9pK8FtjMakxJHjDbKaHaKnM6SpAE71NAz7MJkzrR7vUtFv4x	7602	3NKkqHDyt6jG8z2ufxioVd9Wi5vAWsYRNUPTsiz5jYQqU92o7LE6	1543	695	87	1	6301	jwpS6XXrm7Ef6Pmb7N8A8z7nkCgnjgRTnAwEzuN8fZbusVUqEqo	3934	5557	5557	1616939460000	canonical
7604	3NLD5b32t7Yb4DhjHA7pKcsruA6x5AqqDMzzHFjYrAux26kPcAc2	7603	3NKD9pK8FtjMakxJHjDbKaHaKnM6SpAE71NAz7MJkzrR7vUtFv4x	1602	1369	87	1	6301	jxEQxt5xRZYnapo33K6rGnDeKc82uhNQ8KA2Cw9FX55tgNgA46v	3935	5558	5558	1616939640000	canonical
7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	7604	3NLD5b32t7Yb4DhjHA7pKcsruA6x5AqqDMzzHFjYrAux26kPcAc2	1419	814	87	1	6301	jxz9buig7Pvrm6jXAbruAfzMaKZ2WqLjnEq4nD8qvpRGYgrPXp1	3936	5559	5559	1616939820000	canonical
7608	3NKGbTM55Jn6F7p2ANFtprAP9o2em1P1vKWVEhdn1dkoXFDuuSjb	7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	1426	998	87	1	6301	jwysh6jU1GjUDn4sjZoJ93Qj3CZFeCndwmEgAjUqNRtexghfAyY	3937	5560	5560	1616940000000	canonical
7606	3NKFwmfjPsXpEWS9Cjf9sL4nxjzj5ion3gbtidR3A5TDSmM6vC2e	7605	3NKF8couPc59KjHpr9mWcgRZxqSafRivBGNquBKBC5zj8LdggBNP	1405	867	87	1	6301	jxcWvPJxNX3pyY4uSFzMT9fMGAT1Zv9betEYCwQZMFYWNoER2Aa	3937	5560	5560	1616940000000	orphaned
7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	7608	3NKGbTM55Jn6F7p2ANFtprAP9o2em1P1vKWVEhdn1dkoXFDuuSjb	44	1079	87	1	6301	jxhmAuidgrh9hxvpaKCCaEN1QKe3RRJ18G8Dk4m6LAkboGgPzS6	3938	5562	5562	1616940396498	canonical
7611	3NK9B2g7iDAy71s2BYacxeXhQE6JqYpL5KjidAAN7M1GDeYFsUUt	7608	3NKGbTM55Jn6F7p2ANFtprAP9o2em1P1vKWVEhdn1dkoXFDuuSjb	44	1079	87	1	6301	jy1BUJUi7vev6iHsEJUNDGrzt7DVZi3vnp5zTLLTTHLgZJStFyE	3938	5562	5562	1616940360000	orphaned
7613	3NLY4YRkP4UqqUtDYacpKCpWJYPvwtRpcE9GtSArzTck7bLGxzBp	7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	1651	1055	87	1	6301	jwPQBJHaW8NJpqz3eXpkGhjQSbpkmus9fsEQ5tkqzTXpwihtF2t	3939	5563	5563	1616940540000	canonical
7612	3NLN8nLwvM2sKtPhK68Ag3q1WUYWpRrVtEzQLg7HTkFvEorSj7NC	7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	1579	1143	87	1	6301	jwhwWpkYBQjGeECMDnRwHd169jefGyf2LfT8ZkRRipg7UbU4Gft	3939	5563	5563	1616940540000	orphaned
7614	3NLLETM1LnUUeLJ6r4kx5bJFo7nTqeNWGpK1YgUQJQ7rZApBwKzN	7610	3NLGZHVUer2rqy2eMMkNKyQG76ZRkdRYyzNBDzFZsrcp2eQ4J4ka	1651	1055	87	1	6301	jxucxaQa6kChGdXecRf131dVJMRxSfDQm1ndZ7Lgy4daDYvYv5s	3939	5563	5563	1616940540000	orphaned
7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	7613	3NLY4YRkP4UqqUtDYacpKCpWJYPvwtRpcE9GtSArzTck7bLGxzBp	1407	1395	87	1	6301	jxY2xGLNQvRRAnF32H5qvqgXt92BJj5gPLPc8biL4c2Q8K5Hjqt	3940	5565	5565	1616940900000	canonical
7615	3NKb2djVTa9x74jPEB6jiCABuxtqW874tafJcHqSMJ9csbfHeL86	7613	3NLY4YRkP4UqqUtDYacpKCpWJYPvwtRpcE9GtSArzTck7bLGxzBp	1637	816	87	1	6301	jwdBuLR1f2tii6cBCeJp4AQyscDiyvrbxP4SUFm6iAtatxEwtqt	3940	5565	5565	1616940900000	orphaned
14114	3NKkx8wruPCgHyWrBZKCWVHATmk4RYpDweF2W8yT3kcYRyjAuAsd	13517	3NKC3dn19fKUn575JSXjQGDQ4EqrUdT6XPCJ6f3sx7BkbLJANibc	1559	1107	202	6301	10255	jxHTrz3kjZ3LSfGFCp891NQuiy6oVfLowQG72aVrr6tvQcAB7r7	6960	10214	10214	1617777720000	orphaned
7617	3NLvL1b8Y4929wY6k5zAsppfCbxBrc7DA2BU4rCW9sDcLwe8ZumQ	7616	3NKGfDrJA1CQQ2zs394sX76Uc4mPsZCeedPFtzuUQjSD9WR7NRVU	1489	1134	87	1	6301	jwaDcpJdag4aVhhFejjUJmPu9B8awHzH5g3v2CwD8yKaehybcLE	3941	5566	5566	1616941080000	orphaned
7620	3NKNMRrGQUaBbwP2QRB7Y5YKK4GQCLY6nfGm6ntKLr3dXcSLZzjF	7618	3NKE8qLm2jzf31DCrCzsqshBZTuf8vFhW9tKzTLRFoSfuES1RyTp	1589	1040	87	1	6301	jxRB9pJMvJmgj9xCeZv9oQohdKc7MPdRJwZEKiHD3gn3pBQGYE3	3942	5567	5567	1616941260000	canonical
7622	3NKAkPvLuNduNgxB4gNqaCYP5oEkHKuV5hf8PpFxm22bJM5dMP7u	7620	3NKNMRrGQUaBbwP2QRB7Y5YKK4GQCLY6nfGm6ntKLr3dXcSLZzjF	1518	833	87	1	6301	jxEnQe6eFgYxpjQ6eFRZfQdt8scirXSe1qxtgCkPMECczpurBz6	3943	5568	5568	1616941440000	canonical
7621	3NKh36DwGzNQF8GKZF9jkq6Pr7HJKEaEZqkYW6j3HR77vk3dhM2d	7620	3NKNMRrGQUaBbwP2QRB7Y5YKK4GQCLY6nfGm6ntKLr3dXcSLZzjF	1518	833	87	1	6301	jxEnQe6eFgYxpjQ6eFRZfQdt8scirXSe1qxtgCkPMECczpurBz6	3943	5568	5568	1616941440000	orphaned
7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	7622	3NKAkPvLuNduNgxB4gNqaCYP5oEkHKuV5hf8PpFxm22bJM5dMP7u	1406	1393	88	1	6301	jxH5uZQmeCFhxw357t2hnD1jbJB85bwmSU148LmrKJUQ8qUtKif	3944	5572	5572	1616942160000	canonical
7626	3NLc59DV4p8qR7dj3qoD69Bf3q9kxavgqEeojQvsV9RtbjczWinc	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1610	948	88	1	6301	jxqrCA6Rw58gYNfmMVLSSddQu1u1CoRoeaLXWvCN6ZaEhudLBY8	3945	5574	5574	1616942520000	canonical
7629	3NL4dzjdAAMXNnyErnFDnrFFWDRpV4f29J8YiUQquCzzGjp8RZg7	7626	3NLc59DV4p8qR7dj3qoD69Bf3q9kxavgqEeojQvsV9RtbjczWinc	1403	823	88	1	6301	jwoZYwo5ac6xY5EtFddhdk9RVkjR98j9NpwgyFX7XXtTV3TTy2b	3946	5579	5579	1616943420000	canonical
7632	3NKRk4kU8SUATocmksPiUbSaXFyoCLQAWiFoYxtaDPUJTPLHUpj8	7631	3NLKyf4mNA9YsCbSFRbbyAcvMeFc1M857LWWi6h9LZ3PBaNZDNDb	1573	1318	88	1	6301	jxAfydhBSzfSBYmk8e894rn5jd1LDfSfMVccYyrEACkticwuFRv	3949	5583	5583	1616944140000	canonical
7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1483	1276	88	1	6301	jxQYWG3JjAT6guxoyxezirkXp6Qbb3zPQ9LU3tTHf5Vd4RwBv87	3953	5587	5587	1616944860000	canonical
7643	3NKhqQGLChftY1Wxe8fk3rJW26axeK2GGY8uXh16jeyPfXpJWAap	7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	1476	1245	88	1	6301	jx8thoHPMbAC13VMStRdEzn8b6kH3BihArXcHP9DmMaHtCGku8K	3954	5589	5589	1616945220000	orphaned
7646	3NKLk9GvMe4LwsN7Css7Ta4T1vX4mK2sQtDWg2f2Hw81hLSULYCt	7645	3NKn99YKQadDG1j9M2L9GwXm751oSFnjVQDkNk4ppLh52MxY8Z58	1608	1289	88	1	6301	jxQa1zhEyEU6ihGxpseEefP7tkMwkVevvfS9TXjQZuK96JRVajs	3956	5592	5592	1616945760000	canonical
7649	3NKzDZ6RUVwP8r1XP9waL9PGsGjfCNgCrCLKu4sxPkMUycSJmnbU	7647	3NKGgXvNZkqjwvzsd5ofP73eie2yoXWSJVATvVCQTnpocwz3FuJM	1631	794	88	1	6301	jxaiAi6wBqRhX6TMgaiAW44i7pE8Ce3RKd6WuL3y2zjKu2XUzcP	3958	5595	5595	1616946300000	canonical
7652	3NLyHVXEYy8RE9tiDK7LMBqpmnewd2wJF87uMBhLgJBX1XbMQSmB	7650	3NK3YYuBZocqcU7GSEqDWRsoXbQSVEBbZ9oxUszW6GWVAjyvwyde	1607	1348	88	1	6301	jwKNt7rbXmfQ5E98yoL4JwqysFp7JFiqtD2CKd5iRZN6jijwtDc	3960	5598	5598	1616946840000	canonical
7659	3NL4eycTYsQ98gSNNrjvGGb3E9aSqTUEyJ1tqfEANtjBpBrwkCGJ	7656	3NLaowzww3D3q9NQ2hmUbVGtM4rwWrr6pdEqv32p2aLAfd6GokHp	1654	1094	88	1	6301	jwUyKPbQKVre8hTC8ZbYRozBZ8DsM5P5JdU1fyRRxzZsXV76QaU	3964	5604	5604	1616947920000	canonical
7664	3NLpZsX4sAYoCoiZwJ3itX2spaAW4etdSH6Qpnmvk76RnKjooqkv	7662	3NLCrqv19naxw74MueonYq2TkBByvTGJeDVh4XHnKhW4BiDXHxHo	1406	1393	88	1	6301	jxXpHTpKCyQkhSB9YuJsupFTghNqrinqtJFu8DtZJwqHHTupMsp	3967	5608	5608	1616948640000	canonical
7667	3NLcT2Ek53aP1mh43k1QfHyKPkXtgzQ33QXsjsVwTJgArui9mQEN	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1523	1075	88	1	6301	jwdtMjjZq4Mv3QJg6zbKqr6KwZrAb7XhG7wdYPdd5qP27YCfkoM	3969	5610	5610	1616949000000	orphaned
7671	3NLdy4gfCVaNffUA7JeSJoMYSGqRT6oU4wcAwGcoKJqGj8uHjNYz	7669	3NLhN76maJ7dNNgqwQ5iB6edJ31K4sUdnMMko7N93wd1REcsXCVr	1406	1393	88	1	6301	jwVgwoouWpCJ6zZpoEPEyoJ8HMGPUhY5adFLryXtVz8P9uLASLH	3970	5611	5611	1616949180000	canonical
7680	3NKiszXdRtK2xaz4Sot4JDN9AhzWPRgLk9fWCBrsrFJ7aLFqYGp2	7678	3NL7GysVjccTsZ3hQuFHyJFAhKZ4u6nDAQmq2AQwLD7YC6vfX42A	1624	1334	89	1	6301	jw89mniZRskTNug99Zve4PbUGGUtVdiaZcyhdMYWQcSEm9kw4v7	3977	5620	5620	1616950800000	canonical
7682	3NKLVT1twEobpHnp9zQpG6qYBcTnC5tXNXnourfXYHK3ZpQN6SgS	7680	3NKiszXdRtK2xaz4Sot4JDN9AhzWPRgLk9fWCBrsrFJ7aLFqYGp2	1406	1393	89	1	6301	jwtqkVoJ7EHoqD9u5ayBDuTufVevj1k7rL9ffggq3VnE1JbZ3CC	3978	5621	5621	1616950980000	orphaned
7687	3NLmeGwng1pGKbNjjoEW6cViWQ6XvStkpgxSA9ytH7EPtfWvmbai	7686	3NKgKRS4FgjQVgtZEPLFkNi2mhZdLeR9HZQwuKmSq566MCHbDChN	1657	1098	89	1	6301	jw9NNZobMgaokePdPKEdqRcceZfndv11kp7kj7HPsB8FTtvZWqU	3982	5627	5627	1616952060000	canonical
7690	3NKABg74eShZ6JWZ1xLxZNpDccNnncoFYYjqgsdpWB11CztkUNFK	7689	3NLj1FPQhMB5mF9ufzLEiHQ7GX8QrR4UU4VQQEiFRzvHvb5hDx7e	311	1181	89	1	6301	jw6peFrW7k6R31aCK64nEZcALKm1ydTpxFfQBbTdGwECmeQpAem	3984	5631	5631	1616952780000	canonical
7695	3NLJZydDYvY9QazzEBGh8eK7JYUXAujWLwLW5WEh3n8hmgaAb1uZ	7693	3NLiorWkgNEKH5N8e9L3qeyWpp2PK17QPkuSqb8Rsr8Da8PLDoNW	171	1128	89	1	6301	jxTgCjT15ho1rEGJK8XAbi5MnM1RPuL5ouVj9M5dVibxtWZ8mfP	3987	5634	5634	1616953320000	canonical
7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	7695	3NLJZydDYvY9QazzEBGh8eK7JYUXAujWLwLW5WEh3n8hmgaAb1uZ	1573	1192	89	1	6301	jx5My65dnv8yRGdbFjT8akAfEjSRyWErNAT1j76t2GnFJ5DsYH5	3988	5635	5635	1616953500000	canonical
7700	3NLn5iZGPE8KDBSyqCVx8qtVdtLy7Xz3AJG4YrkrQnejqqsdbyev	7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	1406	1393	89	1	6301	jxqyeFHPrLdNcqEvfzaZdXsmDRc697FnaThMyPxdrH7Ebu13SAK	3989	5636	5636	1616953680000	orphaned
7705	3NKD4D2uANUyFFU95CDfzEX1axYV923LGwp53EACavj5NgbiuKjP	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1523	1321	89	1	6301	jwknvjcRx9A7cc7awv29GE6QuKxpt2zxUQ6DRvD46m1wiDBbQQK	3991	5638	5638	1616954040000	orphaned
7706	3NLyYBqexZ1DCWEjivSHNdMAR5pjudhq1A7Abw3KjvRcwsz3M69P	7703	3NKYUEts4BPzENowJSRaEjT1tRRQxe8iV84keACM3z2C2ZQrWWLD	1668	1370	89	1	6301	jwkFjJ8MeXrvMAyWmFxLLoc3bbKHSc42mgxfG8JATrotcqe5jQg	3992	5639	5639	1616954220000	canonical
7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	7706	3NLyYBqexZ1DCWEjivSHNdMAR5pjudhq1A7Abw3KjvRcwsz3M69P	1637	815	89	1	6301	jxo7hgoNciRHQ6v7agbpnXW9Pv1jrnJ1u3Up82vxBK7xup6G1eu	3993	5641	5641	1616954580000	canonical
7711	3NLtnWUtmiGMNZLvKF2ZQCpAeTnKG5SGj74iEEMvYec8k5j8xwP7	7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	1405	881	89	1	6301	jx9ncH48nmnL9ou1FCoWkPHVDa2vSf1V6DZrvvfjJFYYP8WkGJe	3994	5642	5642	1616954760000	canonical
7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	7711	3NLtnWUtmiGMNZLvKF2ZQCpAeTnKG5SGj74iEEMvYec8k5j8xwP7	1467	1376	89	1	6301	jxWwfr3GFEqYv9R1WB3vnBr6ZNBreXP8my27EycYncaJJJCYjix	3995	5643	5643	1616954940000	canonical
13526	3NKSNjEuqTcpyQwVfcahC4VFZ9j4po6AHxHEgkTW2AG8JQSPCsN4	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	1522	956	202	6301	9757	jwrwVc8VFCSgeLLaMgquhibzy8x6q1iVgGn4xqg1B1otrneHLgu	6961	9848	9848	1617711840000	orphaned
7624	3NKypNxFntkuEEKxdtijn1KE2u4KaTkbLeZck27oAWReKJ4X8ibg	7488	3NLENm4KKXUnW8LcLFZbtUu9bD2qAMYY8PzGQop9vPL5ZcCxCcNG	1610	948	86	1	6301	jwddNjLAKtsYsXLfdW6MGdq9AvCALNP2tbPkF9oHzGnfAV5L9jN	3874	5574	5574	1616942520000	orphaned
7627	3NKx6QkGUWzh3PkECTA2LCqcXCdhAipkocwfZJzgFYnEmBmAkyTz	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1560	1045	88	1	6301	jxT9TGv7UQxLypHH4ixwBjdDRktBpuqHoB3fhpHJzSfWJHochgB	3945	5574	5574	1616942520000	orphaned
7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	7634	3NLd7p77ctV76SL2WQMXhRoFa3CQieNrH7odGiye7JyqRMJCuX7H	1476	1371	88	1	6301	jwLNLvwwRv878b3u2szK9EtjJJW3fd6nW9JrpnLwsbAeEs1cwQd	3952	5586	5586	1616944680000	canonical
7638	3NLhcfJm112NSTj9341Yt5M1b9kBEYdsjKS6XL4uYUzyAKqjVymS	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1608	923	88	1	6301	jwCoLbUJm8T6KkucEtnkmYqat91JdoAJyvAcakdfHKM8ZbpFQKV	3953	5587	5587	1616944860000	orphaned
7640	3NKYJpETJUVKcgYK4BJfM1zppNGaefteoTMkp56EHKViy3d9zJMZ	7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	1503	1031	88	1	6301	jx7f2S71TSSiUsL3HsyjdRW5hgNfz9rCH22u66mkXU1gjmnXuEo	3954	5589	5589	1616945220000	canonical
7647	3NKGgXvNZkqjwvzsd5ofP73eie2yoXWSJVATvVCQTnpocwz3FuJM	7646	3NKLk9GvMe4LwsN7Css7Ta4T1vX4mK2sQtDWg2f2Hw81hLSULYCt	149	1283	88	1	6301	jwcF6y3qsPFv8kYRe3BJxZVHmUqTbZ16VuUE7tvePHFcjGq8DUr	3957	5593	5593	1616945940000	canonical
7655	3NLaj6vpa5yVmtvv2oLKCXhEZKgWjZJSw2i77tdbsCEbWKk7df1a	7653	3NLg2zbrH2qQrN8VQjzz9aGGa1n48ijFt9cz2SAyaRVFfi6wsVrN	1503	1277	88	1	6301	jxHHjUbxNmHj1vK3wya2p4U8bC8BEP53Hw2YoyJ3xiU1cdbpYyQ	3962	5602	5602	1616947560000	canonical
7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	7659	3NL4eycTYsQ98gSNNrjvGGb3E9aSqTUEyJ1tqfEANtjBpBrwkCGJ	1402	874	88	1	6301	jw7RQLUPDQxFJx1KSba7fgnDaP5xFkZbNpXAEEGQZ2qimcJ5jtP	3965	5605	5605	1616948100000	canonical
7668	3NKVuoEFUa4xAB1cimawi5NFT4DBx18FYsr5XfhaVBafRjVevN4E	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1523	1075	88	1	6301	jxKQntZzfpPiQ8UDCHCtgpsKGPWcxryvzgyJUkktStjMgWfNUdb	3969	5610	5610	1616949000000	orphaned
7674	3NKm5ttUwRAbWSJCQpsE3Dxq5d9nchXQRf4Qs5Jc1LAw7XA2JWzp	7673	3NKM9c3UdAC1DsnwuNacwk86afaTMq3EvL9C7Tmk9rvPgT2PXNv6	1501	1234	88	1	6301	jxhwqnKmo48wskgQWpgXuZyT5UANAV5nKybctRhC3Z2KXUme4Kh	3973	5614	5614	1616949720000	canonical
7677	3NLbcNHVNroG6bizfiHye5bLmnx1cmsFnFNJEYgv5gegwVmLBYpA	7676	3NKjiJgvCS1gSoyitVn96PKSVcVLg9TK7A5MsQDHRFpXRiwFBkuA	1467	1250	88	1	6301	jwTtGpN4VtQ9ikSWBD1zMeifBwrRUXJFp7XTx2QUxmm1A6peFde	3975	5618	5618	1616950440000	canonical
7685	3NKDzZgG4NupAkULwGSZPBxZKvSefW6X5pPTbmizEaBAL5FxZHHQ	7683	3NKaAgYR6kW2xGZ13jX1xnaJvgNz1SsZ8yVHDLb9v3sZL7wgF8wa	1447	979	89	1	6301	jwpJrFoXQDrsooQtqaUtsFfGHm9o4xcrbvpsz4e4sZRGUZYDeKY	3980	5625	5625	1616951700000	canonical
7688	3NKcmJpGYyxihuVm5JzTsnWW3iUxTjtQa6RY4RPDVJ2YVa8k6a2a	7686	3NKgKRS4FgjQVgtZEPLFkNi2mhZdLeR9HZQwuKmSq566MCHbDChN	1481	790	89	1	6301	jy1JbsaLAxmwvwMHXRpuLyEjPfRoRyLmZo2uFvQfpmiWRra6zVX	3982	5627	5627	1616952060000	orphaned
7693	3NLiorWkgNEKH5N8e9L3qeyWpp2PK17QPkuSqb8Rsr8Da8PLDoNW	7691	3NKmtw9uiWeLg4oSGbbbMurTeZa2iyULrNoxiPwShWDrFpkggAQa	1631	794	89	1	6301	jwYzVLbfEQUpwB1zi13YH74NEYTC88XgTYBxKEEF55cbB45FkoV	3986	5633	5633	1616953140000	canonical
7702	3NKs2ak9NJ8LrPVVAfp7YsL4G69Bfap1H37imL3xKDHYs7bMeF5U	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1523	1321	89	1	6301	jxpVSaudGFH2vAGCURXmwu86E2Aupx21BmPZFzFStFd4mZPHT4i	3991	5638	5638	1616954040000	orphaned
7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	7714	3NKpBDEtjHY2wCv3BdnTJ7oGKwsmecVKyYamtq1s6FhmDyccEkLa	1619	1149	89	1	6301	jxspJyLFvkGiqi4itwMSzSNRt7gjKMTvPUT664KNMJdr4EoARKm	3997	5645	5645	1616955300000	canonical
7719	3NKv58ptjDqnik6cc5PCVBdHaYVdTf8tgXwF7CKxveGRuAqUNpJa	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1461	1271	89	1	6301	jxKVu5xvJLi68PucWiNMkH1VF4NNeCQJtzX8ueNtgURjkmJvdDY	3998	5646	5646	1616955480000	orphaned
7722	3NLJm1eZzJjd9EzprsinymXRRURnGx95Me2iJAe1L1bK8AcfC89p	7717	3NLa1goR8kyfsDupUjGNn7hDxYg79GGGNLTH9SDNW8GqqRrwx44H	1405	873	89	1	6301	jxs7JbBVUxgx2RBao5p89QtX1CHWuL4JRRR3A9Z6MPadiC2ndJp	3999	5647	5647	1616955660000	canonical
7723	3NKGrXzsaYPCCs6QSdVzexfvwWBsxmLE8PJvEq6dM61QZz3S1k8g	7717	3NLa1goR8kyfsDupUjGNn7hDxYg79GGGNLTH9SDNW8GqqRrwx44H	641	1090	89	1	6301	jwqJvYcx4meBdziNVphHU6NGbYEi26LFZAgTvSJ5RDcKER6EVHQ	3999	5647	5647	1616955660000	orphaned
7725	3NKv57G44Ao1XY9HazAWDy1fueBecRvkwzv9uCxe7nt4BhMCs1B9	7724	3NKeQrvPeZwY69mECXscxUhWy2f1irWRuWs4MXCpWA2SVDRsNDXr	1403	31	89	1	6301	jx6274zuuKgk1sdqNn1zeXKTxXYftPa9mLinJvLWLNk7XwnG2uL	4001	5650	5650	1616956200000	canonical
7729	3NLVV5NscNjkeYSReedAjv5Zp5JJBN3gDysv6HtwwUvvTRif9pX3	7727	3NLcsKPXACHW2NWfoA48QfsTU6eH4a9uRorZNhe5Dx9CeUZVEZcQ	1613	1103	89	1	6301	jwXFfB8iXNebCVjhL6a4iH9jH396mzxd5eR4nWHj7fFhDh24t5P	4004	5655	5655	1616957100000	canonical
7728	3NLYuVRPS8edVexYe7Gv3HXJcSehBjfwZnW2SeTUJPtH6MsVntb6	7727	3NLcsKPXACHW2NWfoA48QfsTU6eH4a9uRorZNhe5Dx9CeUZVEZcQ	1477	1350	89	1	6301	jxKzmVGTXhqgnYsi8JaJ7GaspZgzHVvDbnuuwWPfjVZ5Lkzxc48	4004	5655	5655	1616957100000	orphaned
7730	3NKPc37W4Vi5m49CQUcStp8T19DZMAhpjNAkKZa3jBxg8KDoSrzR	7729	3NLVV5NscNjkeYSReedAjv5Zp5JJBN3gDysv6HtwwUvvTRif9pX3	80	1273	89	1	6301	jwTwB1QAWRWXeeeHWwBs7bBRFpTdv71wxk7niHqmQQwKUHA11jE	4005	5656	5656	1616957280000	canonical
7731	3NKyq5oH8jjsZiW23F5wq2gvUfW1arfesKW1xFSD8opqzfQrR7zo	7729	3NLVV5NscNjkeYSReedAjv5Zp5JJBN3gDysv6HtwwUvvTRif9pX3	1406	1393	89	1	6301	jx97WgUXUdwTvn1knVPPPXBmgq5N2aonURKRjibMmZ2oKYH879K	4005	5656	5656	1616957280000	orphaned
7733	3NKCKzUMQtYxzCJFLptNGCebwCkpzuuoG85VyUE5BzbLvpicp7S6	7732	3NLTh6rPGbgxvGUPbMKYb9eSqZAFZSYxHugmEQbxu9xyfcnUb9Dq	1500	1297	89	1	6301	jxuYhvfLe3VJ1MU18kDsJyEPALTZ3ikQazSfCXTKEyus26yCBev	4007	5660	5660	1616958000000	canonical
7734	3NLZRGKvrkCkU2c3uTJkCuz3okGJYp9YzmJLBo65KnxmhwtTtq9u	7733	3NKCKzUMQtYxzCJFLptNGCebwCkpzuuoG85VyUE5BzbLvpicp7S6	1439	1033	89	1	6301	jxCmcxLh4MsRqDYQ7Yg1uzdy2pMkMmUPiU8D6VcumppyGUx6uGF	4008	5661	5661	1616958180000	orphaned
7738	3NKwv55s1CQhcvooVsetidQXuQ6pSEWUnQ9CSxAmbHNDoJ3Pucqm	7737	3NLoiA3ADW7qJWCa6VLJLB3n7VfW1zRhfxVcH7rT6WW4R5hKEGFv	1647	936	89	1	6301	jwgHBhWXnmeJfreThEKApxuQCQx7jwC3VpFCPQsuDAnQ8XSag2W	4010	5664	5664	1616958720000	canonical
7739	3NKicgb77cv3k9PqRFDCw6rjauxtewsNf8QtkLESHAuWxjfQnchZ	7737	3NLoiA3ADW7qJWCa6VLJLB3n7VfW1zRhfxVcH7rT6WW4R5hKEGFv	1406	1393	89	1	6301	jwk2ArMZXyn9mSMHp4KYMBAMp3WbWiUbYaec4TqiaC6btkUfkv9	4010	5665	5665	1616958900000	orphaned
7741	3NKeFeaLs1qp1n9aoebBLNqst3HpVULix1r5A66HtFc3Dm45NEw3	7740	3NLi3EHYtUXoiS8QXFLMXSz7amqFxxt1gbuTwqg793gAZd3KLMtF	1407	1395	89	1	6301	jy2SQfq4pnWNN2NEN2eJWsBtzcbJdpPPyxqMomGSvrBw9Zw2EVN	4012	5666	5666	1616959080000	canonical
13538	3NKrzW1mYEiWd13MiXfDJbfjes7d83CetyWaKPxj4tMcKwRLV6Hp	13532	3NL6byUDsLRk9mg81PqH3Zmz9GrvaWTa95zXdKnxoe4L92yumaWb	1542	1178	203	6301	9767	jwPhbYPtpuiMruvt5cPqtnQLrjontqUU7G3aedUqPNwTum2Jz1A	6968	9852	9852	1617712560000	orphaned
7625	3NKMBZ9GCsw6sp8J4N1NEXf32T2RbdJdnVbUwas7bassS9dWQ5Dp	7623	3NLv3rqwbLVeajkeTQ4EoXdY3mLGu2uvMjpaS7p9kSHtLYKGEZiK	1579	1263	88	1	6301	jxgPELWCSyFP7qPn9wrzhkq7CjpUPkv7wYnvnpV2v5dxqUibjvx	3945	5574	5574	1616942520000	orphaned
7631	3NLKyf4mNA9YsCbSFRbbyAcvMeFc1M857LWWi6h9LZ3PBaNZDNDb	7630	3NKqhaEk59GqSdGwmJtSEQ77rBy7T3JcwsuuedqM5KiPyunR63j8	1579	1389	88	1	6301	jwdSVTtVDKZaoTV9hdGs2qKPu7usfd3EzU3mW4RdaQfnG2Ttnja	3948	5581	5581	1616943780000	canonical
7634	3NLd7p77ctV76SL2WQMXhRoFa3CQieNrH7odGiye7JyqRMJCuX7H	7633	3NLy61sAD2TgwN9p5GwsQe59BmsmcsA3TNhkr3bafKocaPhev5pi	1403	782	88	1	6301	jwMjhEvJka3kQ8jicTCxGakw6vN2NwztirKodGECveJrfh8AF91	3951	5585	5585	1616944500000	canonical
7642	3NKwMTDe1x8LsbBukK9pdZtXDrqZVxRds4L8dsxfNQKnhoJjDkSs	7637	3NLY2P7vds1GrFsEdo2cwTDoV613RoJosZeqKHuGZmQGwsUKwteg	1607	982	88	1	6301	jxyehv7VhCiVJ7kGVY7Lqw25e8KWwHs6mKSbZUEtZZGWFzT8Ew7	3954	5589	5589	1616945220000	orphaned
7645	3NKn99YKQadDG1j9M2L9GwXm751oSFnjVQDkNk4ppLh52MxY8Z58	7640	3NKYJpETJUVKcgYK4BJfM1zppNGaefteoTMkp56EHKViy3d9zJMZ	1406	1393	88	1	6301	jxAz9JUJURPX9g5FZ96L475RL4qc5pgzVgBtmiw12y5shcJqJaJ	3955	5590	5590	1616945400000	canonical
7654	3NLrswjomW2xjubFtk23YugkKm9HwkABZBuYNp6o2AGn1bs9eGfs	7652	3NLyHVXEYy8RE9tiDK7LMBqpmnewd2wJF87uMBhLgJBX1XbMQSmB	311	1181	88	1	6301	jxSK8oRMBpNEw29hzn99ssmVRF2mRX1LxxD5BDcgh8z6foxxfxy	3961	5600	5600	1616947200000	orphaned
7657	3NLUXFc3XWKLfEBH3NsQ9J5xn2VdFG5XNTpxGHPTX7WdWHy8259Z	7655	3NLaj6vpa5yVmtvv2oLKCXhEZKgWjZJSw2i77tdbsCEbWKk7df1a	1406	1393	88	1	6301	jxGDg1nAW3ZQ9mwN2PG3vnKFwiCQ4633GhmEJ1raDHZaUrEZ66D	3963	5603	5603	1616947740000	orphaned
7662	3NLCrqv19naxw74MueonYq2TkBByvTGJeDVh4XHnKhW4BiDXHxHo	7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	1549	1116	88	1	6301	jxtKrcA83mmCr6iGBdW89GPkcHRzKuxGmVH1uL2V82cqTFpTCpu	3966	5607	5607	1616948460000	canonical
7666	3NLRsv7cnmDivPX1HPKzkBP4iHZ4PRbxzyMZNaUk9XSodSeRPBUw	7665	3NLS7uqfePh6eABFzT5Pbv2zrbTrTQ2Kg25rvmbt98NKPwtdaEST	1523	1075	88	1	6301	jxPMoZbWBayeZVVbs6nBWF5q3dBYPGkyuQKqqUcwigtSHygP9Z5	3969	5610	5610	1616949000000	orphaned
7673	3NKM9c3UdAC1DsnwuNacwk86afaTMq3EvL9C7Tmk9rvPgT2PXNv6	7672	3NLGb78AxKcsEVQYd8vXqXFCvUEYgRuE7FAyDE9SQSjeEzqbJrDm	1447	1345	88	1	6301	jwWtddY6wHVDAK9jHVVqgshXW8XSFMkN61dgsVcLs9G42evn9Jn	3972	5613	5613	1616949540000	canonical
7676	3NKjiJgvCS1gSoyitVn96PKSVcVLg9TK7A5MsQDHRFpXRiwFBkuA	7674	3NKm5ttUwRAbWSJCQpsE3Dxq5d9nchXQRf4Qs5Jc1LAw7XA2JWzp	1596	602	88	1	6301	jxWFu9kqMX6EwczGxW8VehLgFrBga1eLxDb4Zm4nfN1nz5wYbs2	3974	5617	5617	1616950260000	canonical
7679	3NLsEgNnes7XReGLJ9NjKcTKyPPny9P2RzNLpRdNzcogLjZnEgj3	7678	3NL7GysVjccTsZ3hQuFHyJFAhKZ4u6nDAQmq2AQwLD7YC6vfX42A	1637	816	89	1	6301	jwWNtBRTjNdz2z8Y5Jr15mA6JQEMt4VXaJgCp7DaxNUBn2p37L8	3977	5620	5620	1616950800000	orphaned
7681	3NKkQ4kdPTaMVv1HxcJyK5xLUqjyFrVTSAsTkzQLoBbg33bdFz2J	7680	3NKiszXdRtK2xaz4Sot4JDN9AhzWPRgLk9fWCBrsrFJ7aLFqYGp2	1407	1395	89	1	6301	jx4wUKwsYA328G2Sapb7B7e1tyGSws8iajMn6roUEqtncPA8YP2	3978	5621	5621	1616950980000	canonical
7684	3NLmLEsUgFsZQ57FDfvjKEoG3EwpMcn2SKZZcgeMZRsF4Z9tuUAy	7681	3NKkQ4kdPTaMVv1HxcJyK5xLUqjyFrVTSAsTkzQLoBbg33bdFz2J	1637	816	89	1	6301	jxdK5iKLJu5RrjwEo8mji8c7CrAQiBLvzMS8AoEKGXPEXvua3FZ	3979	5623	5623	1616951340000	orphaned
7686	3NKgKRS4FgjQVgtZEPLFkNi2mhZdLeR9HZQwuKmSq566MCHbDChN	7685	3NKDzZgG4NupAkULwGSZPBxZKvSefW6X5pPTbmizEaBAL5FxZHHQ	1617	1042	89	1	6301	jwsSNT25BncBLFhcspwpCFXFkF6TaNxzS1M8sSVZQWbSZdV5L5Y	3981	5626	5626	1616951880000	canonical
7689	3NLj1FPQhMB5mF9ufzLEiHQ7GX8QrR4UU4VQQEiFRzvHvb5hDx7e	7687	3NLmeGwng1pGKbNjjoEW6cViWQ6XvStkpgxSA9ytH7EPtfWvmbai	1397	828	89	1	6301	jw9Y8Q5tYh7SHM2bu7gZo9DjeRink8qZxGLBzS2LEWnywF44hCc	3983	5630	5630	1616952600000	canonical
7692	3NKcNagokH89fBVKRLgAnzKNMCaoVzpu3GtW72wvy2Hd8LiLBpJb	7690	3NKABg74eShZ6JWZ1xLxZNpDccNnncoFYYjqgsdpWB11CztkUNFK	1503	1277	89	1	6301	jwKYe14G3GVSywxqiJAc5airxxV3cPXFcVgKpC7Y1ybwyu1UgQC	3985	5632	5632	1616952960000	orphaned
7694	3NK8saw2hCMgzNvJrE5kv2UsZ5wF1q4L2BMJZpiYGH2BgUkKjP4j	7693	3NLiorWkgNEKH5N8e9L3qeyWpp2PK17QPkuSqb8Rsr8Da8PLDoNW	684	1352	89	1	6301	jxzXtG3MKPGDsPtFr34eT71ktFNeVYV5wFznTj5fYHdBdzFN3yp	3987	5634	5634	1616953320000	orphaned
7699	3NLrB5YqwFNAVXEr8KqbotLZ2JNfQP1MWxswYqFgPc6rKQgfjs4a	7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	1585	1240	89	1	6301	jxDicD1po42bXEgeyUZ2uqSdXo4F5hF5JTbkyXmm3CsaxhNsVqP	3989	5636	5636	1616953680000	canonical
7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	7699	3NLrB5YqwFNAVXEr8KqbotLZ2JNfQP1MWxswYqFgPc6rKQgfjs4a	1546	1339	89	1	6301	jwKL6C3sf2ojgCmfopN4irKgGGfR3sHvZAtciFSzytUowwrg9Y9	3990	5637	5637	1616953860000	canonical
7704	3NKRcjBuJUSci1dUnsmkqKdZR9UqEdwKz4Nd4KBfuLDyZGy6pJ3M	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1672	1039	89	1	6301	jwnzupLiXx6dAvvobbRASe9XikGSk3cFWzS7iyzrK5TptXMjZbt	3991	5638	5638	1616954040000	orphaned
7708	3NKmF1s93XJKqPu96QNQujotta1Suyvj2agKqFnRRtaMTrE6APJk	7706	3NLyYBqexZ1DCWEjivSHNdMAR5pjudhq1A7Abw3KjvRcwsz3M69P	1419	814	89	1	6301	jxk3fcb6GADMVq7p9thNKvQcgRaotkp9bTszyB7Sc4m7iRUkZ8B	3993	5641	5641	1616954580000	orphaned
7710	3NKZ2U7kcKJFLWgpTxZxxvVxkKWPQQEHFVRZzoMuWJQmj6E77h7K	7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	1403	812	89	1	6301	jwcvX1jid8hSP3QdBjkM4iieMhS7eeMad3mB6upQchvL9BFJ71V	3994	5642	5642	1616954760000	orphaned
7715	3NKqUtBbwzGQWNDZHkWXEx6KDJyjWvoz31DwUwFV1PzgCq4scywu	7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	1406	1393	89	1	6301	jwvtDkJ4R1xtDmf7BNi7aV7xLH371i39bjg82L7CfdmyD1hvwNQ	3996	5644	5644	1616955120000	orphaned
7751	3NLM4254hjJZmSmhqHShVcPLGc4ca7W7u2BpuEik19P9BV8vKqzE	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1547	1132	90	1	6301	jxPTpSayCgMPpuEKecRQ2oBoadoPjqYgEsQHU9tjHvHNAx2hc2B	4019	5674	5674	1616960520000	orphaned
7760	3NLrd63JLGqUFkNeF2Uo9JGGmmLiPykKMaoicZDBhWKs4rHT1owf	7756	3NLKNNQxEEuL3AEvG5qJmodyi4mwvp3v4rZ5PfUcg9XkYzYGLcqu	58	58	90	1	6301	jwPrUfQaThSTDkbJjomHQsXyQ3HjMrwMgGtZUrLJcuy2hnN15MG	4021	5677	5677	1616961060000	orphaned
7758	3NKaLSGgbMytZskTFnQj2fys7kMz26zS9hUPBpNDmMkHPHbfjqfG	7757	3NLwJ5HtfFVVfNJhGf2gKnXdpjH3imhrZiyoxoYUyY4d8prSeBLr	1403	824	90	1	6301	jxMn4SS1Q2NdqJwTrFu8pKS4kccniwxveiKMm5ATCd1mNN92ryK	4022	5677	5677	1616961060000	canonical
7763	3NLmgXBEPEWj3rAQpALNSSdKDZCvH8R49ixdoGPGm6Fbq1AgXTxu	7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	1403	802	90	1	6301	jxGrb1Qq5AzDZDde5FDDfCwprfQeZErezNKHwyjvE7WxBxmZQEs	4025	5681	5681	1616961780000	orphaned
7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	7768	3NKLrhiiJYr8Afukk6xRVsnicbWhCFHm9pDM73nXmVapmRVrHZFe	1631	794	90	1	6301	jxhTsS3yV5XpPCzrALK5mzcaVfcdNm7NLBEQ1hJ6MtqnAqd71uS	4029	5688	5688	1616963040000	canonical
13552	3NLTT3Evb8V4SWpwFZRpfA6saYfB4bomyRNPbMvPFQ4JUxEFiAd1	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1407	1395	203	6301	9776	jxHaD9oy4P5AuaxsRdvGf2MyAyuy7ZLm9vP4ym2hRJa4J7RBqgY	6971	9856	9856	1617713280000	orphaned
7630	3NKqhaEk59GqSdGwmJtSEQ77rBy7T3JcwsuuedqM5KiPyunR63j8	7629	3NL4dzjdAAMXNnyErnFDnrFFWDRpV4f29J8YiUQquCzzGjp8RZg7	1648	1284	88	1	6301	jwz43z5RRiSpnAgtTsR3kNHkWN2KN2xtdfGQALFV6pPGiBnFR7L	3947	5580	5580	1616943600000	canonical
7633	3NLy61sAD2TgwN9p5GwsQe59BmsmcsA3TNhkr3bafKocaPhev5pi	7632	3NKRk4kU8SUATocmksPiUbSaXFyoCLQAWiFoYxtaDPUJTPLHUpj8	1637	816	88	1	6301	jxCrhkrHtnRd1MMAczBetEdvNefmroGaLEyUFKKwVPjX3sKGRd4	3950	5584	5584	1616944320000	canonical
7636	3NLjigcLvW5nSFsVJ2ki6UE7PnUGipNAodXR2vmng6wDU64t4EbA	7634	3NLd7p77ctV76SL2WQMXhRoFa3CQieNrH7odGiye7JyqRMJCuX7H	1581	778	88	1	6301	jxCGLGXgF3eHwv6EvF16qdcS1PjaB5uBnuNHiUPcnEm5xstNT1r	3952	5586	5586	1616944680000	orphaned
7639	3NLWavH2x4Vbd5YCmCjke7Fn7Qn8T3knBf3bAkWRv91BGmUSDeXs	7635	3NKA4p3tHSRw94W8n2Vac2xjjhv26sSCbqEz7MWuvMvxheXQzDJZ	1637	816	88	1	6301	jxFsv2zoED2HFknFT3t6fHoDaRmYAQU1GDCA9qs1pn3Xt6AJPKA	3953	5587	5587	1616944860000	orphaned
7648	3NLwRDeXdoHqCZresqNAxS64eQ9Yj8DzikSFn4j8xdStERoDbaQ8	7647	3NKGgXvNZkqjwvzsd5ofP73eie2yoXWSJVATvVCQTnpocwz3FuJM	1559	1107	88	1	6301	jxz8stLSfyT7eoZw2Dg9E1ZmQ6j4Jg7AStkmrtPKCBcGhPM7srT	3958	5595	5595	1616946300000	orphaned
7650	3NK3YYuBZocqcU7GSEqDWRsoXbQSVEBbZ9oxUszW6GWVAjyvwyde	7649	3NKzDZ6RUVwP8r1XP9waL9PGsGjfCNgCrCLKu4sxPkMUycSJmnbU	80	1147	88	1	6301	jxa3pmXyoZo9gBXZjdejuXnYtAtf2t32243v99FnxHcVW7Tzfb6	3959	5596	5596	1616946480000	canonical
7658	3NKskW9N5Q8NQmg2d4SgCYhq9GagHB8hbMTAiP52f9Dnfy6ajHEA	7649	3NKzDZ6RUVwP8r1XP9waL9PGsGjfCNgCrCLKu4sxPkMUycSJmnbU	1654	1094	88	1	6301	jxp9aoAhS7S8e17P1zGgQgxGRkaEydLJVjRYpvSzFFNVqdzaM4a	3959	5604	5604	1616947920000	orphaned
7653	3NLg2zbrH2qQrN8VQjzz9aGGa1n48ijFt9cz2SAyaRVFfi6wsVrN	7652	3NLyHVXEYy8RE9tiDK7LMBqpmnewd2wJF87uMBhLgJBX1XbMQSmB	1634	965	88	1	6301	jxB3sDiPDhjKYUrEcM9NsA63PmN4Cm33F1ywjxs1kWNw4m2z4nK	3961	5600	5600	1616947200000	canonical
7656	3NLaowzww3D3q9NQ2hmUbVGtM4rwWrr6pdEqv32p2aLAfd6GokHp	7655	3NLaj6vpa5yVmtvv2oLKCXhEZKgWjZJSw2i77tdbsCEbWKk7df1a	1617	1042	88	1	6301	jwA9Br28D17BDjaoLaDQobDnWiY7AYgibfmP5JkznNvfcjKWmWZ	3963	5603	5603	1616947740000	canonical
7661	3NLdWoFLxZY5xawgTBgzEWudrzuzXrbTvYG9kKbhHiv89QT7FvtA	7660	3NLY4BaBVSKFH1Cf7XZH7bFqvAbCWE7ane2ySxnzervTM1n8mZLJ	1403	824	88	1	6301	jxWrX9vEPpbJQVGiDDt7mGtLGz8uARF8yLbpj1BzmFaZy57HTcL	3966	5607	5607	1616948460000	orphaned
7670	3NL2XX1JcqYSjMdLRPwxiBQvRU359BTtnZdMG28HZa1oApizFpW7	7669	3NLhN76maJ7dNNgqwQ5iB6edJ31K4sUdnMMko7N93wd1REcsXCVr	1648	1284	88	1	6301	jxpyt1ygsvBjQiwSPJnNtbzdwqQUzRCFKyYwrnuhixmVREMNVbf	3970	5611	5611	1616949180000	orphaned
7672	3NLGb78AxKcsEVQYd8vXqXFCvUEYgRuE7FAyDE9SQSjeEzqbJrDm	7671	3NLdy4gfCVaNffUA7JeSJoMYSGqRT6oU4wcAwGcoKJqGj8uHjNYz	1455	1206	88	1	6301	jwFqt3h7M4HYdy9gHCdbbTuQ2NDt4RJEfgrbPC1V37gvW6JDHks	3971	5612	5612	1616949360000	canonical
7675	3NKiTmwFgpjfPKjZt6iYkLPTis9ptfNR2H9nddk1n8mECymHjsxU	7673	3NKM9c3UdAC1DsnwuNacwk86afaTMq3EvL9C7Tmk9rvPgT2PXNv6	369	1066	88	1	6301	jxyeeaW4ydCK1hjVstgPpGMgrakBpSHUn2tKzSnjjFtb4n3KpgE	3973	5614	5614	1616949720000	orphaned
7678	3NL7GysVjccTsZ3hQuFHyJFAhKZ4u6nDAQmq2AQwLD7YC6vfX42A	7677	3NLbcNHVNroG6bizfiHye5bLmnx1cmsFnFNJEYgv5gegwVmLBYpA	1406	1393	89	1	6301	jx8R1cWxS1h47RsTpaL5u6QfMTzWE3CqUKHCbjY4XSosDxemfNg	3976	5619	5619	1616950620000	canonical
7683	3NKaAgYR6kW2xGZ13jX1xnaJvgNz1SsZ8yVHDLb9v3sZL7wgF8wa	7681	3NKkQ4kdPTaMVv1HxcJyK5xLUqjyFrVTSAsTkzQLoBbg33bdFz2J	1501	1234	89	1	6301	jwHPHtXhEUcYaNfejrX6LyK18akmXwgTzA8eJe724Zrkg1eZsW6	3979	5623	5623	1616951340000	canonical
7691	3NKmtw9uiWeLg4oSGbbbMurTeZa2iyULrNoxiPwShWDrFpkggAQa	7690	3NKABg74eShZ6JWZ1xLxZNpDccNnncoFYYjqgsdpWB11CztkUNFK	1503	1277	89	1	6301	jxv1JXyjgFCgoK3SCv4X2oDXjEdGMf3RhtvdjkRmaKDP2sRebKr	3985	5632	5632	1616952960000	canonical
7696	3NLXJi13LLNGrGADZedU1vmr6ygbyvsWTRWNHEDnqe6ZpiMbWbtN	7695	3NLJZydDYvY9QazzEBGh8eK7JYUXAujWLwLW5WEh3n8hmgaAb1uZ	1406	1393	89	1	6301	jwixwcQnmH4Fmj6bhiDdRB2qRisWV3uAzNAAWPpJc3id66Vcetv	3988	5635	5635	1616953500000	orphaned
7698	3NLyEd47WPKRLaNpUVksg7QWecNqUAsv7cSR1TAANYqAVeEdntQK	7697	3NLgCHhDKyDkscskixiSDFnk7tLB8u1JWCaPqHHcBdse7hApvfgB	1589	1160	89	1	6301	jwAUsiXftnrUVttfonmVTGjAHUyZnC9y2NdZSbGdXqEu3du54m2	3989	5636	5636	1616953680000	orphaned
7707	3NKboMgEPoMiK5vfkNrMLERFeb3TKfRqp1iWhRnv8Bg4GmUVUjB1	7699	3NLrB5YqwFNAVXEr8KqbotLZ2JNfQP1MWxswYqFgPc6rKQgfjs4a	1668	1370	89	1	6301	jxq3JtYW57sahyv7eQp4GodKKea7wS34EovM8c5gpdwGTbC6Ltn	3990	5639	5639	1616954220000	orphaned
7703	3NKYUEts4BPzENowJSRaEjT1tRRQxe8iV84keACM3z2C2ZQrWWLD	7701	3NLKwZKEZZt1yUkxPdPU5sq7mNFTLdXX3XL9JFWq52z7aPBtyAjM	1523	1321	89	1	6301	jxpoLsnMeKshr4pgupkvxfYrrb72KkNwKxAqRL1WmKSdwgEYXpZ	3991	5638	5638	1616954040000	canonical
7712	3NLCy5JAPTXidARvKn1fjnW4uw1KRoUYcbVr7SF2CSRZg6Rm3QnX	7709	3NLGoRMewnzqkUgUWMtrq8wVrUD9qAyqGGhgrHADcicDsRvMeo6c	1631	794	89	1	6301	jxmtZxMdMxCUxPuR5HCvtUfCDC5y9Fay9HN4dyPPaXYvE9GtRGH	3994	5642	5642	1616954760000	orphaned
7714	3NKpBDEtjHY2wCv3BdnTJ7oGKwsmecVKyYamtq1s6FhmDyccEkLa	7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	1585	1240	89	1	6301	jwHLeHF6LqUNPYz9xMWoqohpjozRbGSrb72NTTF5QRqgQMwh3Rm	3996	5644	5644	1616955120000	canonical
7736	3NKfsiovqEQcrtvQL5stiq8HhZERBey9WJwUuP4DXGJk7EtCY9Nc	7713	3NLsmMwrhYjmBweXKwsMUnCWyvypxnxmVzLVG3MsHhcorKPAtLU8	1439	1033	89	1	6301	jwiK5aLBwvouz1z7HAL2oW8xNJympN1eWzrPM47uBaz59TPue5z	3996	5661	5661	1616958180000	orphaned
7717	3NLa1goR8kyfsDupUjGNn7hDxYg79GGGNLTH9SDNW8GqqRrwx44H	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1523	1075	89	1	6301	jxViD4Uk574KVTJXF9eYCfqYCgYKHBGsKcBhSMj6SfnKGgfNWPh	3998	5646	5646	1616955480000	canonical
7721	3NKT6obL9FRJekv7gmzm79FZZF5HBuAp2w1zXMFLmT5hcnVvMq9z	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1523	1075	89	1	6301	jx7LJwwVCwxw2R1bg628z3FbeUAgzkmDbnoruvsMHKBuJYVLN4H	3998	5646	5646	1616955480000	orphaned
7720	3NLkqP9jBGU466eo5w5vyNcAUmsdoU9zAtoyPcCbfyeggDYJMVrt	7716	3NLHoaGD6L2xos9LAg35TRhquUMUE1Ubj1Zh9FysBThnmk2y9JqE	1617	1042	89	1	6301	jxjor34z9g1HazUyeTEyMwU2WGsmVivYoZPQuQbdSL6NHcNwJr9	3998	5646	5646	1616955480000	orphaned
7724	3NKeQrvPeZwY69mECXscxUhWy2f1irWRuWs4MXCpWA2SVDRsNDXr	7722	3NLJm1eZzJjd9EzprsinymXRRURnGx95Me2iJAe1L1bK8AcfC89p	1631	794	89	1	6301	jwnwgXoFWHNYTfR9oZkU2isoEuNgxtxqNsoyxRkTRKEF8G5LL76	4000	5649	5649	1616956020000	canonical
7727	3NLcsKPXACHW2NWfoA48QfsTU6eH4a9uRorZNhe5Dx9CeUZVEZcQ	7726	3NLCJtgusq162pidHAnvJAUxySvPNpZjwCVJkDYRFis1DPVdZTHH	1546	1213	89	1	6301	jwA5zPYTPYcGTbt2jxVR4Z7akX1a9tZXNdnSeJZDqWPwvnR1qyU	4003	5653	5653	1616956740000	canonical
7732	3NLTh6rPGbgxvGUPbMKYb9eSqZAFZSYxHugmEQbxu9xyfcnUb9Dq	7730	3NKPc37W4Vi5m49CQUcStp8T19DZMAhpjNAkKZa3jBxg8KDoSrzR	1406	1393	89	1	6301	jxRvmS2husvcNE15FHRCooj6BakxxFujtV4XonjijM3nwHCbze6	4006	5657	5657	1616957460000	canonical
13546	3NKNXvaKBuE1LUCUs9SmYTraryJzFyvFs262TCxixDz8wFyGAbVZ	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1447	1345	203	6301	9771	jwR6U9z2xbRa1ZcpyVQ4TedNEyobfvgji5LPJDRGSqiPaa9mhMB	6971	9855	9855	1617713100000	orphaned
15508	3NKDGzZbeW7cy68ZQ2K1uSWnvFZ2MEfFNswxb41akgU7Dh6jybRX	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1527	927	248	6301	11538	jxNjxWb1356fWKox2eigGqLqjXxHhetv7MZqu4DWc98E2ZsKvxn	7892	11162	11162	1617948360000	orphaned
7735	3NLgxW2CdVbXx9V63XgdkjYoJe7zFiEd8sSBx3A8GENCHa48Kckn	7733	3NKCKzUMQtYxzCJFLptNGCebwCkpzuuoG85VyUE5BzbLvpicp7S6	1555	981	89	1	6301	jwGkgxS8VYwoiKYPLPmbSR16hdg9kACzpr9ZjpoixNkkGCxBbHV	4008	5661	5661	1616958180000	canonical
7737	3NLoiA3ADW7qJWCa6VLJLB3n7VfW1zRhfxVcH7rT6WW4R5hKEGFv	7735	3NLgxW2CdVbXx9V63XgdkjYoJe7zFiEd8sSBx3A8GENCHa48Kckn	1637	816	89	1	6301	jxm1Wc7kXTzv8oyVhyXxa8cLXbeAFXrZFi5rxSLrRNxz2zdLAUt	4009	5662	5662	1616958360000	canonical
7740	3NLi3EHYtUXoiS8QXFLMXSz7amqFxxt1gbuTwqg793gAZd3KLMtF	7738	3NKwv55s1CQhcvooVsetidQXuQ6pSEWUnQ9CSxAmbHNDoJ3Pucqm	1541	932	89	1	6301	jwPaU66xhuHE5hRBDZtd7msYrG3SR82mUknSw4eBFH3dMUxga6v	4011	5665	5665	1616958900000	canonical
7742	3NK5bbmMNitaiZKqYDXQVE6QwweufoCVaRaioBJzjMd2ATZkq9qU	7740	3NLi3EHYtUXoiS8QXFLMXSz7amqFxxt1gbuTwqg793gAZd3KLMtF	1553	776	89	1	6301	jwVw98dU8yzzB6rJpSpkNbtmQn1HHXZuEaGAybxomR2xoD2wDwB	4012	5666	5666	1616959080000	orphaned
7744	3NKTKfJDxCH6sySKejebKb7pMx2MBqh48B1V9BNpJkLQfCDru7TA	7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	1406	1393	90	1	6301	jwE8uc8AM18niYuctj4ofAtrDYYU3DzUfLi8Shhxn3LjEqbv5pM	4014	5668	5668	1616959440000	canonical
7745	3NL3seoJmJm6DFkcaVxEG6Q1t7YrAgkJXoKfFawzRcEG5EdA5L1P	7744	3NKTKfJDxCH6sySKejebKb7pMx2MBqh48B1V9BNpJkLQfCDru7TA	1564	1338	90	1	6301	jxYfwvdtbAcJpoC1LtnpL6vWkJrPFYJVYnQX5tewoe5JkZFEJoF	4015	5669	5669	1616959620000	canonical
7747	3NLMbtVWtJiosebZ4fZv5chj4GeRAzK7bpTBNebmudVb8aNEjRqS	7745	3NL3seoJmJm6DFkcaVxEG6Q1t7YrAgkJXoKfFawzRcEG5EdA5L1P	1402	866	90	1	6301	jwwgwPVUP1TPztEMmYKHJNXTibSoDLbEeqqNwyiFNedk76swfyc	4016	5670	5670	1616959800000	canonical
7749	3NLKANXuPnn3tRMev7UWy1xAu5XGw6mroeLaoEgZDVeB7cR5xAXQ	7747	3NLMbtVWtJiosebZ4fZv5chj4GeRAzK7bpTBNebmudVb8aNEjRqS	1637	816	90	1	6301	jwV9GZE3v8w5auGmYTTn9eUdKyWByB2JADedwjRZKZAtvoqefEn	4017	5671	5671	1616959980000	canonical
7752	3NKkWAN5T5mgWLaUoDXpGYeK9JN8yfXiwZWoBzoL43rC26hb5fNW	7750	3NKsfXihtvzZhrn4qpERgY7RgGXNrQ2RNhFEPJZGzCjyrWmTncxz	1619	1275	90	1	6301	jxPMqRgdwspz3Wf19pagW77QwL4f71NBfCs2gpRcDLNvmSVvGDV	4019	5674	5674	1616960520000	orphaned
7757	3NLwJ5HtfFVVfNJhGf2gKnXdpjH3imhrZiyoxoYUyY4d8prSeBLr	7756	3NLKNNQxEEuL3AEvG5qJmodyi4mwvp3v4rZ5PfUcg9XkYzYGLcqu	1581	778	90	1	6301	jwyKFYbzgt7bBDzwqYLdqf6guaAWpd9pKMPWxBLGMEz3a8Sqewt	4021	5676	5676	1616960880000	canonical
7766	3NLoeVmbQaADnDU3qMWECS8nuYioZZ4k5PDMoZi14FbW9aQvaxM8	7764	3NLx5oD5BzPRdDS7hmbdh1KYB3dP5gxgBSUKfD4b3dcdtAiULQcC	1406	1393	90	1	6301	jwm8sVWWnzhaKyDqsGfBJsvCdzcC5Cw2mAvsfdVApPQVre1Kw6s	4026	5682	5682	1616961960000	canonical
7767	3NLhoqbvYZ5PeR71X1Cd8cY3ttQDtMqyWiN7HuEytWLer38ctJiR	7766	3NLoeVmbQaADnDU3qMWECS8nuYioZZ4k5PDMoZi14FbW9aQvaxM8	1631	794	90	1	6301	jxxySKXYs9zMbXasEroYS2TvBvUfhzLRg974QUrLFB2heYHPqcN	4027	5684	5684	1616962320000	canonical
7780	3NL3mSBjBnZSkh4ArwCakhPMsryAxakXk9bpTdRaRdfNBB4AzgjK	7766	3NLoeVmbQaADnDU3qMWECS8nuYioZZ4k5PDMoZi14FbW9aQvaxM8	80	1273	90	1	6301	jwDV4s3m9U2orC1LAArWpLc52sL9Uiwy8FSEWAkRqsorQ8GWfmW	4027	5692	5692	1616963760000	orphaned
7770	3NLEoKiHEtxLokyo3tsTYoYnisTBnBr6KwS7XuvTvbHFWHjaSf4E	7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	1406	1393	90	1	6301	jxkWv3gWRsK3478Ah8HmVSRQxC1d2226JCoTacdeMvJsYMKieTM	4030	5689	5689	1616963220000	canonical
7774	3NLRtb3mCYmL4PXZwwvYNZDWEuAVjEVTxumiYxaw7rutStDzqa2f	7770	3NLEoKiHEtxLokyo3tsTYoYnisTBnBr6KwS7XuvTvbHFWHjaSf4E	1513	1253	90	1	6301	jxcqQ6aYGckEs5bZvuNfh5PKeG9DMQMXWio9FDzPQuxbLho56K4	4031	5690	5690	1616963400000	orphaned
7781	3NLyBTQKGhhX2sxPrjDsGGcK7cKBBuLwCeMuQhTEGMuaJ2Es1LWy	7778	3NKNiE2iQhV51zBqhHx4d32FbjSfRgbR8wLJhLkHyLcX1tinzZQX	1405	849	90	1	6301	jwVyJbuTgDLXvSYdvRAGU1oCzm7pJV746YQinfRvJsnWuoJ786f	4034	5693	5693	1616963940000	canonical
7783	3NKsRnQom2DERuzPUwwLyT9qH1yK7PRe6V8rTSgJDjqrCmP7QAyd	7781	3NLyBTQKGhhX2sxPrjDsGGcK7cKBBuLwCeMuQhTEGMuaJ2Es1LWy	1471	1260	90	1	6301	jx7FyR9tiXkdxvQahwkC3H59wVptFGVS55RC57bYnZUUL9yvE77	4035	5694	5694	1616964120000	canonical
7786	3NKL9GVUt7nLzGvhQhqyTvXWpi6PjymCSgx97wV5AX53WmkL7riF	7785	3NKijXsehWGes5piGJae9L4zAZCuKjHcTAyxQ2FtnkTSgHYJf171	1483	678	90	1	6301	jxaGyAZdhkf3v31x6xNVbZ36eqeAGHNviED7Ph6WbssAgY6D8vt	4037	5698	5698	1616964840000	canonical
7794	3NLA52LN8MNLzd6NevUNqC9CtFXs4yGvJeUBa8uxQoiMwzZ9gNyB	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1553	776	90	1	6301	jxAryskn7FT4aZK7H3hkpyA9L1BCHjwsKcYM3aCDEWxBgmTksZk	4041	5702	5702	1616965560000	orphaned
7798	3NKfk5odkBftrYvS8Wsw4bdCTgeXr71tjwqvfKfEeWH7hEMVAia9	7796	3NKfDNR94hcUyCP244DbkzQiw1NPVvCz2BinNkJhh8NAH5fLFmo5	1403	31	90	1	6301	jwH8hDojStPagh5S9Hk4CcdfWyj5SAfKrD3sfaexvdHw21HKSeo	4043	5704	5704	1616965920000	canonical
7801	3NLNN3SaLEDBG35ZV7JfjgS8YTu9VAfHRfuuzojPqh5DEJNwD2R8	7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	1447	1099	90	1	6301	jxde4YRR31gzQBLhKituinnmgyZjXJv7BjSERYzm1CJ2FVX9B6r	4045	5707	5707	1616966460000	canonical
7808	3NKpVsu79r6H14TBYQDpJP19yQq7qQ1XzDBWSyrFc5PGYycg18MN	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1406	1393	90	1	6301	jxD4p6BSbWXNEDBJS8e4NrMBexzQhJMGhg5YWBDPTPNpEx7zzH2	4048	5710	5710	1616967000000	orphaned
7812	3NKjxRkXreDNP8Jb677eoohwHwJUx7qrGhY3Vs3M8acfGTHRtVVe	7811	3NL1rq3FqDxG4zgGa9PvPko8WoczHJZPe645ue1C2tatz7pXwNkD	1403	824	90	1	6301	jxiwAYiBsSQ9ZvoDj2mLnznH4C2JzNBxFP4vwPZgs85SvggxA1h	4050	5713	5713	1616967540000	orphaned
7814	3NKvKvff16TmsdQPNzgoPQGibYFeRW7dTNf5bRXHM7HT3tm97A17	7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	1549	1362	90	1	6301	jw6rfcr5ZYG9QPm9hpp7bdUKfah5gNer6Z12PoU1iPPMqQ1HYU9	4051	5714	5714	1616967720000	canonical
7822	3NKJZPjRUuxZzrjjbbVrzG68BCU5yrxKUdrxybsLiyWC6iqgdTSA	7820	3NL1pE4aBw7MKvSCFPtutxgjoBCxdBCfigVx2DKZjXkS6rHSBSUx	44	1325	91	1	6301	jxD5LU1vbAhaRpzNqW3HLWtq55mxPn2jcmSw9ZrDMowFPc2Wtt2	4055	5721	5721	1616968980000	canonical
7827	3NLohsRncG1p4L2cXgziVU6SnEFz6qu3JSTwCntqeT6vv6GCWhnP	7825	3NKN27mkNEpWWRULZzEyeZVXs2sg4W5RPjSpUryECsEoPNUjJUA8	1624	1088	91	1	6301	jxvBGaaQt5qMNv7c8tpSN2CrB4yHyt5djiqKvYvTjUVxx9XQvjL	4058	5724	5724	1616969520000	canonical
7830	3NKPpau9L9VphhqFxpGnDNqUossq3it1DENjYKPYXzduRgBgA3Ur	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	1407	1395	91	1	6301	jwK4DJXAoEKKH6TPU3ifb61omcFtXJXuxnXCdjd9T48FsTjjWz2	4060	5727	5727	1616970060000	canonical
7834	3NLirfXjgt649Nth3J24RuaKVsVRPvhUNoSWiZYxP5ummX8bu18f	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	1407	1395	91	1	6301	jxxgSJ8KXV3SLPoV3eUUxgo8RDX1LqVt6nk6XUnDb4pinNPFbT1	4062	5729	5729	1616970420000	orphaned
13575	3NL92p9TX4bRdTCx8LYnd9v1ZiRwdXxq9CaAPJm5t62NxF1RWQcF	13574	3NKi9E7NNcQQqxQL5awr6S7eJk8VxmB93aQJK1oJ85MjmDUWBKWt	1406	1393	203	6301	9796	jxEuMx8UprLH4TJ1BRaCYFBcsU5mNi4wxQ5dbvQdVuWwzbfhcPc	6981	9867	9867	1617715260000	orphaned
7746	3NKRrSG7SUXzu2EvwuSNxNttvH5rkr2Cw85qc1wTibwVKhbXAb38	7744	3NKTKfJDxCH6sySKejebKb7pMx2MBqh48B1V9BNpJkLQfCDru7TA	1451	1046	90	1	6301	jxnyezRRyrVknBtxSSGrZV6AyefLsdzSRXb8F3MzSpAJacH2VSf	4015	5669	5669	1616959620000	orphaned
7748	3NL4LLaCjyXnr5xtfQFnbSrS5RMvRXJgnBzZgEA2ScqLc36G4Jd6	7745	3NL3seoJmJm6DFkcaVxEG6Q1t7YrAgkJXoKfFawzRcEG5EdA5L1P	576	1229	90	1	6301	jxm1PHRpWPY4gWKrsW4xtyVmwetreamE5R9jDrXsfQFY4GVrtnf	4016	5670	5670	1616959800000	orphaned
7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	7761	3NKfdMA3yZCPLcEmEi25PqfyCuzVTuuBdQRK6fiBAJSfXhCexBMr	1553	776	90	1	6301	jwogbnHuWc9hqgwbdQNaCXHKNy1VJDNQ2xDetexVcgMF1M1nZvi	4024	5680	5680	1616961600000	canonical
7765	3NKg6QwNgP7xVag1jdJ2hPMDrUTxAkpocyZbipauxWXPcAhwJVDo	7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	1426	1364	90	1	6301	jwTw41DpPhGjFkApRuaq3yqFMnbGFRfr25PNikdi9cECnPZQvEQ	4025	5681	5681	1616961780000	orphaned
7768	3NKLrhiiJYr8Afukk6xRVsnicbWhCFHm9pDM73nXmVapmRVrHZFe	7767	3NLhoqbvYZ5PeR71X1Cd8cY3ttQDtMqyWiN7HuEytWLer38ctJiR	1403	824	90	1	6301	jx3SaQvS5EFsjfygAfV7ruabePvXAwGmKVD22cVQGxAedH34fvH	4028	5687	5687	1616962860000	canonical
7771	3NKZCaET6VF3J3gHuspLMfdd7MJsG5KFwFDwoMGcjvuGqF2a28eq	7769	3NLFAMUjYvZ9KPqCHr4yq4EV2tu4fjcfDwieWGRciyfEYwPbdxBr	1402	862	90	1	6301	jwadct4PokzJhF7DTsLmLCg53pNCnLtUChn7MyRDc39ZqrpA6pC	4030	5689	5689	1616963220000	orphaned
7775	3NLbsk6d95cN3CJR5veVYi5TCoUtUJmCHbcVJXfbnir7K4MfGHUN	7773	3NK8XkT5Coqi4BeFs3ySWxGvbK6DMSpeHHa2dSTBXw4P5DfaFVH1	1406	1393	90	1	6301	jwXpRjhUT1uCJT12X9nQxLancVCGSZyu29pgyvfqC9MYUAw36yB	4032	5691	5691	1616963580000	orphaned
7777	3NLyYrCM1gwyLaXhMSphVXVecbLSShQqxR5x269APfbCXF2WixYR	7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	1444	1135	90	1	6301	jwqbEV6mRg5fXC6vxGHdz66CX6XXUSidnkU6Xu8zCb86FGqqDGY	4033	5692	5692	1616963760000	orphaned
7787	3NKoSuy41nHphxtaPdLeVhjZuWBXnJw8KbCX9M6DCBTDEQpgg4dM	7786	3NKL9GVUt7nLzGvhQhqyTvXWpi6PjymCSgx97wV5AX53WmkL7riF	1578	1170	90	1	6301	jxvsfjfeVzYzry6Y9p9Qic72RJWtig7a17TGdoxHsZMgBgknK4v	4038	5699	5699	1616965020000	canonical
7789	3NLZu4hkeYdu6sajd4mR9YghRJLMGa9i5PtK6P9ZXFo7v8wqoTwA	7787	3NKoSuy41nHphxtaPdLeVhjZuWBXnJw8KbCX9M6DCBTDEQpgg4dM	1448	1065	90	1	6301	jxv3CfN1C3Cck568Xn6P7BwQgy5vSJBtGR97bwbsKTnfWLVQkmD	4039	5700	5700	1616965200000	canonical
7796	3NKfDNR94hcUyCP244DbkzQiw1NPVvCz2BinNkJhh8NAH5fLFmo5	7793	3NKd3mg8SFA3CuJ4WdozhSMCvDuys8nMAvcfZo1Q2vJK8hiKRcQb	1507	914	90	1	6301	jxdacDpBZVPyVQ4Xwkn1yEAeMpBarHYsq39LBAyDkrVuiPpXu4J	4042	5703	5703	1616965740000	canonical
7803	3NKjdEUt6Qmn36EognNRnffm2HZha8ppogtQsN376cbVazWssXQY	7801	3NLNN3SaLEDBG35ZV7JfjgS8YTu9VAfHRfuuzojPqh5DEJNwD2R8	1607	1348	90	1	6301	jwQrooot9YX4cUEdWQ9FMAgjwg1wtPsL2DEdThrTz2qMYEBdsyL	4046	5708	5708	1616966640000	canonical
7810	3NLL6uCZmdgC95shqicGoWyXPgVLtDVSxKQACeZz7zdRkwnBW2SE	7809	3NKDNPMZiPGgCRC2QCYH2VyYQtbr3xf9qETSQEAh5RMWZ8FRkq5y	1546	1339	90	1	6301	jwLd4qDt6tXVoAUrohrXBLMUVBtCL9d8ZnZPdH5ohVzV4xBYRUL	4049	5712	5712	1616967360000	orphaned
7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	7811	3NL1rq3FqDxG4zgGa9PvPko8WoczHJZPe645ue1C2tatz7pXwNkD	1637	816	90	1	6301	jwdTCUQCf7JR225EFLR6vaLqSroU4Cf7nmyh6MYaFyZNYEGSxXQ	4050	5713	5713	1616967540000	canonical
7815	3NLogcACrDZTuAeFxAvkuJ7PDXDmR1atZCufFYEjkmisVrjkxPFA	7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	1405	873	90	1	6301	jwndaXj3LkbFuEcpTHNz1hXsCJ58eB238p5XUcobQgK5ZPdo2M3	4051	5714	5714	1616967720000	orphaned
7817	3NKjd3seJjxy7YNXjhbyn3tcvDwSLzkhPr7dQoGf5hT4eiN7fGnG	7814	3NKvKvff16TmsdQPNzgoPQGibYFeRW7dTNf5bRXHM7HT3tm97A17	1407	1395	90	1	6301	jxyXJoq48ets7Qb2fyexA4jFHJ4Z22aUT8t7DrbeMzjREM2t5yh	4052	5715	5715	1616967900000	canonical
7820	3NL1pE4aBw7MKvSCFPtutxgjoBCxdBCfigVx2DKZjXkS6rHSBSUx	7818	3NK3bZxnR6BnGzudMDjDcBrN36n9fcfeA6Tfie1njszcMityP6L2	1444	1135	91	1	6301	jx2cyzHP6LSehBPKQWRgXBagifzLNXA5ahdAi2qBiJ9ohFTcUDr	4054	5719	5719	1616968620000	canonical
7824	3NLJkWGarV8kVvskGtsgMJruYLJ5sYNJ9mdcjSHx4Mxj5u1vK4ew	7822	3NKJZPjRUuxZzrjjbbVrzG68BCU5yrxKUdrxybsLiyWC6iqgdTSA	1405	849	91	1	6301	jwJqHfWrSmSMBce1MM3SzdvSrz6EicCG7WdqHXT2nKnG2p56iuF	4056	5722	5722	1616969160000	canonical
7826	3NL1ia312KrMQ8C1k2UUo8CjJJbHCQmgMEjDKCJoLw8Wmmo1AcSW	7825	3NKN27mkNEpWWRULZzEyeZVXs2sg4W5RPjSpUryECsEoPNUjJUA8	603	603	91	1	6301	jwyCb4nPhd7kskMQDP8eydAJkESTUCaLb9Ngmh28Up2v3aTeCjY	4058	5724	5724	1616969520000	orphaned
7829	3NLRRkCh9wH7p1hzJL8ZqXFSTPgB4TQkfSm4VKFvE2bUtUS8Jmcr	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	369	1066	91	1	6301	jxQ6ChcBiC8jBXS17TyPU3Hd8Q1C5QQNNzJyd8UxzD2hhJVvjVK	4060	5727	5727	1616970060000	orphaned
7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	7830	3NKPpau9L9VphhqFxpGnDNqUossq3it1DENjYKPYXzduRgBgA3Ur	406	406	91	1	6301	jwoDLHPbAbzNTZwYgcPwFe5tZSJQjzheN2qqWHGhvypUrJ54fUE	4061	5728	5728	1616970240000	canonical
7837	3NKJ6ZU3ZqLSRRJqYgQTrwaCPiYyQZpLwisVZ4HmGqgaFisBmDH8	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	1675	1096	91	1	6301	jw7XB1yx7B5AtJmmyTNAQQ5iQ9B8wgcwLyGx9jBuksDWnDiy5wb	4062	5729	5729	1616970420000	orphaned
7838	3NKP3FPV3fAR38KkbySBpZhJJs72wS7NnjWPCsgmsMFgexdwEkCk	7835	3NKhsnXZtjpkBr93qQfzwKNXEnstkerK4avdasU72GDJwcTegiDe	532	1303	91	1	6301	jwxNmjuttQP5WAEf1NGuC6ubLYtH9Ugyzr4M6QPbBgjtQtW7eKJ	4063	5730	5730	1616970600000	orphaned
7842	3NKCQwcTyDtoPhEWeVTkeUepbXyNtQrVC2Raje393PUpL8FKzprn	7839	3NLp4V1Sy52JLvfGaC7Mth8raXwbzXzTAPCR78UVcPxB11D2yUei	1651	1301	91	1	6301	jwqx5sH2R6z81ECTMKM9Zo6AXC9tXJoZ21xB47k1cCjAWE5U9u8	4064	5735	5735	1616971500000	canonical
7841	3NKb1h83nEiEHhbzMb8aVbDbRw67j4JfxYhXoH9aaDJwZcpswaPa	7839	3NLp4V1Sy52JLvfGaC7Mth8raXwbzXzTAPCR78UVcPxB11D2yUei	1651	1301	91	1	6301	jwvLNYFkVE7rsumCuXhMjE8MA7EHhxoMmDo5iWmsigbLC8UMQdY	4064	5735	5735	1616971500000	orphaned
7843	3NLGSdk2YzH4dUCAiESVGQj6aLCdoga5XgCRkaw3qWaZy4r8nm4d	7842	3NKCQwcTyDtoPhEWeVTkeUepbXyNtQrVC2Raje393PUpL8FKzprn	1600	1006	91	1	6301	jwser9RNWsyhsyqoDhcHKd642UQ4wBrC9mYJPTGW5QJnnhvzgKH	4065	5736	5736	1616971680000	canonical
7844	3NKezgi6hKv38jrwGnvLcyXZjDX2DEc92hbgbNguEviNJyod3kUK	7843	3NLGSdk2YzH4dUCAiESVGQj6aLCdoga5XgCRkaw3qWaZy4r8nm4d	1407	1395	91	1	6301	jwTdLpGkKWKHeQHF8LutaH5f7jNK6QfSEKxHCce3aY9U2aoqhck	4066	5738	5738	1616972040000	orphaned
7847	3NLQLAxE4UpMXthYVkotruL2pZ2T8YUyZXTacfgAbXok4xcYADVu	7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	1529	1316	91	1	6301	jwMRNezQMXvUGu8DUWY99EnNdaRHWYg35BkPGkwBzxCkhz94FT6	4067	5739	5739	1616972220000	orphaned
7849	3NKmnMPcaNYMsqyqyb3nLiRjittdDmjt1M3dweY6SPccHNf2j9fX	7848	3NKQjECHUz5RbSfq4ihAVAnsz7g6E6VNu84PXg1gx9YmdbAV9qpg	1406	1393	91	1	6301	jx5SVQd5d2S3SJzbVtAtpMJXjLUZnBt2nzwtZ9RQjjhGc7kRGbZ	4068	5741	5741	1616972580000	canonical
13589	3NKEbRwnvdyJQbBSRNGJ36Wx2pyecgbRXGCadBHHx5aEs7RSyjCv	13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	1593	1346	204	6301	9808	jxWVkGkg58LDGijsPqPs31ik7yWWgXJNkqWBhpoFF7D54R2hq3a	6989	9880	9880	1617717600000	orphaned
15711	3NKUtn2J1gmwEaN6n5fUuyqCHWniR2LSQw2DPM18Pv8cdDBcLq9A	15527	3NKhv97EPJ68DoCVNyt7F3B7uksdLYTb36BubG3dNfY9UAN2sia2	1444	1381	249	6301	11720	jwanMum7TrQmVVgGJTTP1jEDEPtB2UaEr95kb1F8r3ZGV9V3G8P	7902	11310	11310	1617975000000	orphaned
7756	3NLKNNQxEEuL3AEvG5qJmodyi4mwvp3v4rZ5PfUcg9XkYzYGLcqu	7754	3NL9ZiL5dp7LwVmevedcUH9GRxBhWyvYcNXE5eV3twJCbBDsuuDZ	1553	776	90	1	6301	jxo139kLuvKVYHPsgJ3BA1AxDkVAcZAvqCjsdcpgFMe164zeuwo	4020	5675	5675	1616960700000	canonical
7759	3NLjm34RLRckM32566NvZffzeTPptofgUAKcrX9mTL8HqaWCNEUG	7757	3NLwJ5HtfFVVfNJhGf2gKnXdpjH3imhrZiyoxoYUyY4d8prSeBLr	58	58	90	1	6301	jwoUKbxbmTymKGAL2BXaAJB9ToLiHhMoWkBdXsTeeHvCgjv8AL6	4022	5677	5677	1616961060000	orphaned
7761	3NKfdMA3yZCPLcEmEi25PqfyCuzVTuuBdQRK6fiBAJSfXhCexBMr	7758	3NKaLSGgbMytZskTFnQj2fys7kMz26zS9hUPBpNDmMkHPHbfjqfG	1407	1395	90	1	6301	jwCMTPgDn1uKSWsujpMp4atkLPa4Ph1eiFdj9q5Wm4pizt6PXZf	4023	5679	5679	1616961420000	canonical
7764	3NLx5oD5BzPRdDS7hmbdh1KYB3dP5gxgBSUKfD4b3dcdtAiULQcC	7762	3NLVr5FkiHJCq9pbpdVdRPzmRbFRsGQREHb2j4Y7oG1Aik6mvUdm	1451	1292	90	1	6301	jwYK9EJKf1MpgYSeR9hQvRuJFkbHJGkGg8SccTZFToWip7ZPdvG	4025	5681	5681	1616961780000	canonical
7779	3NLMYrBgr7XwoYmPvTTDdh9vTFV6wwtZo42trB4P1jQ9s97F4pE1	7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	80	1273	90	1	6301	jx5BspWhbbQVuX5M5XyjFPGobmWmnb8UNWpfVRcPpP5mtCW4rVr	4033	5692	5692	1616963760000	orphaned
7791	3NLEMp2tZ3PovceWdk6ea9pEK8rYBBSTXR3Eb1p1ho5JLABdDm3o	7789	3NLZu4hkeYdu6sajd4mR9YghRJLMGa9i5PtK6P9ZXFo7v8wqoTwA	1508	1141	90	1	6301	jwEyVWeamSWgoVNbEsfsmYGiGjTNzUC5PdZQeLSNJV9iUmGqZq8	4040	5701	5701	1616965380000	orphaned
7793	3NKd3mg8SFA3CuJ4WdozhSMCvDuys8nMAvcfZo1Q2vJK8hiKRcQb	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1549	1116	90	1	6301	jxGqdek7byCG83f5fBkzLoDrahWYeH2NwvJ4wLJv5V4eWAXZZcJ	4041	5702	5702	1616965560000	canonical
7797	3NLkmxt6P1gQ3t541hf3x8qosWhezGumCQpVzTuP344hM3voxauo	7796	3NKfDNR94hcUyCP244DbkzQiw1NPVvCz2BinNkJhh8NAH5fLFmo5	1670	1036	90	1	6301	jwfDYrocFsRBJ48nPV1SFDipLCt42FqQokgnShjRUPzSMNxsf32	4043	5704	5704	1616965920000	orphaned
7805	3NK6A6PXz9rdzPA2aBbHwaNs2w5gwSDC86CUnoiChouXvP96u2mT	7803	3NKjdEUt6Qmn36EognNRnffm2HZha8ppogtQsN376cbVazWssXQY	1578	1296	90	1	6301	jxXWBD5MW2A3dq3gRkiEgayJxWLPMBNRXngJBKPmrgkVtzk9UUL	4047	5709	5709	1616966820000	orphaned
7807	3NKxizqCZT3yDWxc2LxUupLqRqqqs7ghWodiFdf1GAfkKicok2uc	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1421	370	90	1	6301	jwCZVEW7rKCJrx5R6K4MN92mA15EiYd4vAn6Qc1MDSYe4a8aH35	4048	5710	5710	1616967000000	orphaned
7819	3NKMC95timwrWRPkxnEoRsrXLuYBxoWWqXvnE4BfTBRGzKYCYyn9	7818	3NK3bZxnR6BnGzudMDjDcBrN36n9fcfeA6Tfie1njszcMityP6L2	1444	1135	91	1	6301	jwimvwxdjU5VJzv43SxdJhz3E8VC3tYAx5Lwou9LVwNQXPttmc9	4054	5719	5719	1616968620000	orphaned
7825	3NKN27mkNEpWWRULZzEyeZVXs2sg4W5RPjSpUryECsEoPNUjJUA8	7824	3NLJkWGarV8kVvskGtsgMJruYLJ5sYNJ9mdcjSHx4Mxj5u1vK4ew	1564	1212	91	1	6301	jxMEG4yfTvVyFoDi8NV5gJQXXabGAL2f5nXTdKNp6ghxAXQQdvv	4057	5723	5723	1616969340000	canonical
7831	3NLCPx5iG3KV7M1QiqdNXwKNcdJnNESjbXgAexNAgvd8PZTfohya	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	152	1330	91	1	6301	jxgcBwBbgNFSkHdQYP85sqw6DwpsL6ugAar5de6gNhw4EHb9YES	4060	5727	5727	1616970060000	orphaned
7835	3NKhsnXZtjpkBr93qQfzwKNXEnstkerK4avdasU72GDJwcTegiDe	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	632	1382	91	1	6301	jwyaY2W2Ny5Nr1VCQTFg28HAk2Uc3M1Pz4wtXDN6F5qJV8BFdxe	4062	5729	5729	1616970420000	canonical
7848	3NKQjECHUz5RbSfq4ihAVAnsz7g6E6VNu84PXg1gx9YmdbAV9qpg	7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	1517	197	91	1	6301	jw9xS1j1atpz36QpaeQwo195mY3UDMZy3fe3qK4ZCGbSZ1XvYrj	4067	5739	5739	1616972220000	canonical
7846	3NLP2su761nv1rHu5SaiZrYXB4xVX7DYUc3FHg9zR6vfpxYviNNz	7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	1406	1393	91	1	6301	jwjUKKqaM4oARqWKfR1ygrLsgg12mBswbtxTY3BvZhhMZtGkvPk	4067	5739	5739	1616972220000	orphaned
7851	3NKBX9wJkrBbS1cUR15r6CQr8m6zs1JfwzxkuYtdoPB6sSaEZrRT	7849	3NKmnMPcaNYMsqyqyb3nLiRjittdDmjt1M3dweY6SPccHNf2j9fX	1460	1324	91	1	6301	jxGk5bvE9XtVcU6LqTiCusofEMTJkjfG9DVUz6WrXATYWiqgWK9	4069	5742	5742	1616972760000	orphaned
7855	3NKPrVmQBSncivM1nuWeUNMiSBi6x3fzHmwzPJkvxNBRRioeQibc	7853	3NLCEmLVNZMnba2pdHqnU7rKtjwtzGvRiz1BXqHY5waGvdrLxcNT	1593	980	91	1	6301	jxujwT1SSErFdp1qvYgrJNxsHVP5EeegUibJsqEmRA2jgAYBmfu	4072	5747	5747	1616973660000	canonical
7854	3NLh5tvwRMQyz5BYZmEhB5TomwTsyUTLjavWsYbDevZKzxWvMaBT	7853	3NLCEmLVNZMnba2pdHqnU7rKtjwtzGvRiz1BXqHY5waGvdrLxcNT	1406	1393	91	1	6301	jxzjtzM2VuAaHXSVYc11pAN6WBLFirXUmy2EEKtJfjx1gNXbKF6	4072	5747	5747	1616973660000	orphaned
7856	3NKvgugEAVsneTnebRKVmxJ9jybTnF6chFTq8rDQAKyiUHQEJtGK	7855	3NKPrVmQBSncivM1nuWeUNMiSBi6x3fzHmwzPJkvxNBRRioeQibc	1589	920	91	1	6301	jxKJ6nYCXbJzeUTkCYjTQrHA9onhohX355WQtjBDxR4V6F4J2rc	4073	5748	5748	1616973840000	canonical
7858	3NKmuy1cpDs9wRXsXuUm8B3VC1PN7YGoDGcAtvxwmzBPUyDkwMtv	7856	3NKvgugEAVsneTnebRKVmxJ9jybTnF6chFTq8rDQAKyiUHQEJtGK	1541	1298	91	1	6301	jx8qeAARrQPCsSQMuRhBd1VvmQKb9tbjRd9atiZsSpRA3yMabwB	4074	5749	5749	1616974020000	orphaned
7860	3NKuHKFoZYX81jHjaWYCwfZsu4RTuaJTdjVj2WBqJmSMjzrSpAT6	7857	3NLBeTNKomnheuuaincDNpL2sCuA9EXerZAM3Pf7sECFcTbmAHCi	684	1106	91	1	6301	jxanh3JWiEYoXEdLK9WzVKVP2F5PeFF8emXe9YCA34v9ZPmby5f	4075	5750	5750	1616974200000	orphaned
7861	3NKRAsK6zGXooJXmf6dvMxh2PeV4ArwUakFKVCkdChmANCaYBaJ6	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1406	1393	91	1	6301	jwxN6cCXzjuVGVLY7DuaiTiExPjELyCpR4GSfbyWGvKCF8sZb9W	4076	5751	5751	1616974380000	orphaned
7862	3NKtuZDhzN7rbUeRRpnmfd7kQ1ZRRGQyTLSUsyYcRf7wbqHfpwKf	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1542	1304	91	1	6301	jwCkweVzerMcFgGWKhVLci9sxChz1sEYPrXKQFXb9EyxgCAaJv6	4076	5751	5751	1616974380000	orphaned
7869	3NLN4RnJzQesYEHsYewuigwG1JyEDcxvZZASRcQKPW95PGF2gHFH	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1406	1393	91	1	6301	jwC5DMM6TDGCRVNZ1VPBEMTNNHFiPnzdofUmrMGrgGRFf3dLZkR	4079	5755	5755	1616975100000	canonical
7872	3NLKib65iEokXDzjJdaJJMmYWFHRAnLaoxSdBfA6SA3u5Zatcosm	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1553	776	91	1	6301	jwD815HBeK6HPkvwVVxrRYCAxTsQiQutSzmKwCF2ZNgDSyWyhJm	4079	5755	5755	1616975100000	orphaned
7873	3NLx1eY4tn4auVXF8PdeSo5J8Vd5mwTw3eZfbgwWKksfDAarfQoA	7869	3NLN4RnJzQesYEHsYewuigwG1JyEDcxvZZASRcQKPW95PGF2gHFH	1634	1085	91	1	6301	jxFhov1h4GTuvBi6bnk9vAmsZG1qQCPP84gPTK6zAcDNrWqNhZ1	4080	5756	5756	1616975280000	orphaned
7876	3NLMVrMGABKn3iky2CM5VGQn1CNrmhs9XwTRjW9D2qk9GuRKAf2e	7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	1506	1247	91	1	6301	jxUmd9Yx7g916U8Xk8sSzARD7rvYFngsLBNstx6KRN1RQ5RBrgj	4081	5758	5758	1616975640000	orphaned
13600	3NL2YZRpct2fqLxNPgiL9Q9UxLWdeDtbqra1JiN418PACceNGL2V	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1642	1241	204	6301	9819	jxVEsVkhBrZFiSkbp5cUBuYj3RYPUd9LHyYeD3towioipHZaGk8	6992	9883	9883	1617718140000	orphaned
7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	7773	3NK8XkT5Coqi4BeFs3ySWxGvbK6DMSpeHHa2dSTBXw4P5DfaFVH1	1599	1287	90	1	6301	jwQ6urcWcr627oZfxTF4y79PSUMLyWREUfEEMK9x2dmHFGMHDwN	4032	5691	5691	1616963580000	canonical
7778	3NKNiE2iQhV51zBqhHx4d32FbjSfRgbR8wLJhLkHyLcX1tinzZQX	7776	3NKbBGxEJxfEtJipf2rnaWNiE1u3g8SsE3Dvmrpby6jwxrRTsW9K	1406	1393	90	1	6301	jxDMLKWvhphXUHHFWMozQrjEqz1t2TiR5W5UqJXUHJbxVPiNrLh	4033	5692	5692	1616963760000	canonical
7782	3NL4gpSGmCWdx8rSHtQ7asySVrVGnyeBn5x1yas6nQsGjHKGmkxR	7781	3NLyBTQKGhhX2sxPrjDsGGcK7cKBBuLwCeMuQhTEGMuaJ2Es1LWy	1648	1284	90	1	6301	jxZnTzrpF2jv2JMqJcdENsaBkdDQvfN5zVDDhHgJ3WoRP6FZfyk	4035	5694	5694	1616964120000	orphaned
7785	3NKijXsehWGes5piGJae9L4zAZCuKjHcTAyxQ2FtnkTSgHYJf171	7783	3NKsRnQom2DERuzPUwwLyT9qH1yK7PRe6V8rTSgJDjqrCmP7QAyd	1581	778	90	1	6301	jxStGy8LKstUmc8kMsUgervBePXTQMhbXVTAKkYhbjMdrY5EekT	4036	5696	5696	1616964480000	canonical
7788	3NLTSaiMxZzkfUYPLejeGdrAGss518gmRzN8VA2TqNgZQCgqEJuf	7786	3NKL9GVUt7nLzGvhQhqyTvXWpi6PjymCSgx97wV5AX53WmkL7riF	1657	1344	90	1	6301	jwQz2LREA1pgCcNG4cmi2nZngTJPMxssrCueAw84p5u6E2HUhHo	4038	5699	5699	1616965020000	orphaned
7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	7789	3NLZu4hkeYdu6sajd4mR9YghRJLMGa9i5PtK6P9ZXFo7v8wqoTwA	1527	1293	90	1	6301	jwh2LZpQ24JGnoy5AhkMLHrm4kbsEifkKGhtdmQDGDasTGDDyV6	4040	5701	5701	1616965380000	canonical
7792	3NKGZyQ8Epp4hyhRxHFSVmSYkKGUe8GucwASgGKhXBNVy2xLH4Kz	7790	3NKV9AdoiYApVQczvMtqcdykfkU3B5S5EFfMEsZhwKKsi4nAszFN	1600	694	90	1	6301	jxJSbqi29eZfL1rnfzRZU1drWtjpHgebz9Y2CattE7zTMhsxXRY	4041	5702	5702	1616965560000	orphaned
7799	3NKHnrLbR7BwRZkrgPdgK8RVNQWvK1G1AFLXJ2KqgLJs8ur2qqz4	7798	3NKfk5odkBftrYvS8Wsw4bdCTgeXr71tjwqvfKfEeWH7hEMVAia9	641	1210	90	1	6301	jwyU4ffueFQAaLBUEPbbeuDPKL7Q4isQ4EXUjpPtRys5BshnaKp	4044	5706	5706	1616966280000	canonical
7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	7803	3NKjdEUt6Qmn36EognNRnffm2HZha8ppogtQsN376cbVazWssXQY	1646	1354	90	1	6301	jwUF6FwdGBpU5CvGG3vEtsKSkMtHBvrGHiSdjwPxrKSQ8Z51qKL	4047	5709	5709	1616966820000	canonical
7809	3NKDNPMZiPGgCRC2QCYH2VyYQtbr3xf9qETSQEAh5RMWZ8FRkq5y	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1405	873	90	1	6301	jwAgRU8b6ACRdU8PJWsWVUSDDiDhXF9ufWxzKPHXJFqHvYuVXQE	4048	5710	5710	1616967000000	canonical
7806	3NLWE5Qwy3MduYRQ8a7xde7dPpr4uVLhZ5QZYxDvGR953L5aXmp3	7804	3NKLapzN1AG2G24DjPHc2Zyv85mVUcGWiUtYL4mw2hSi1FQGnnjt	1407	1395	90	1	6301	jwMuwE8HBCM1Z8oGEQHWbMtceduZgHD2bVGcEH92uEFupbczBnT	4048	5710	5710	1616967000000	orphaned
7811	3NL1rq3FqDxG4zgGa9PvPko8WoczHJZPe645ue1C2tatz7pXwNkD	7809	3NKDNPMZiPGgCRC2QCYH2VyYQtbr3xf9qETSQEAh5RMWZ8FRkq5y	1631	793	90	1	6301	jx1ZGncjShMPEmMQye5ZXGBRVzmXtYvPeE4P8tL4VTPPwnstaQV	4049	5712	5712	1616967360000	canonical
7816	3NKzDbXxuy6kLoWfbKbpbHdKTMi5oUdAM6rAXwhBh5hMh8mbHjwf	7813	3NLQJ1h89e73MB8jENzvngbUjYMor6udHiDbDgqVsD2dGAwtXuWf	1631	794	90	1	6301	jwVbYXGpZQLJpyd72T8mAE5XnfTyTgHCTtPbzKHr1sDQdhvoT5D	4051	5714	5714	1616967720000	orphaned
7818	3NK3bZxnR6BnGzudMDjDcBrN36n9fcfeA6Tfie1njszcMityP6L2	7817	3NKjd3seJjxy7YNXjhbyn3tcvDwSLzkhPr7dQoGf5hT4eiN7fGnG	1447	1345	90	1	6301	jwZwovJFVmYTDTBCS7RJqc13qgGT3pYbd13FB4qQ4sNRwrpmqzw	4053	5717	5717	1616968260000	canonical
7821	3NLb5CwSRTzibiHw46QRPq7yot9SjGRMHUUTzva98uAwRjhNTUsk	7820	3NL1pE4aBw7MKvSCFPtutxgjoBCxdBCfigVx2DKZjXkS6rHSBSUx	1406	1393	91	1	6301	jwM6hYYM3VXj65QFzudaXRb87ZbnXUotw27kcDHZnozBKX63ZD4	4055	5721	5721	1616968980000	orphaned
7823	3NKmRxFnVEw1dxP8rkcCWQkMYm6YjJ8ibYQiVTF2KFxCz4jVz68x	7822	3NKJZPjRUuxZzrjjbbVrzG68BCU5yrxKUdrxybsLiyWC6iqgdTSA	1448	1185	91	1	6301	jxhjfTxrmZMmLYDjT8eBbzmohLkGbGmmQ2HRDfbKzYNyLyddqNt	4056	5722	5722	1616969160000	orphaned
7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	7827	3NLohsRncG1p4L2cXgziVU6SnEFz6qu3JSTwCntqeT6vv6GCWhnP	1458	1077	91	1	6301	jxyXgCh3jRsgwWVQEp8nQK2PwfRPHtqdEWFy1Uvq6G3znx1CVhw	4059	5726	5726	1616969880000	canonical
7832	3NK7pxTTZNz1VEUMwt2FeFPzkPJ2ZDm6sqQXy7yRf4QANNecomLU	7828	3NK9jKgwjWmfbWgZZXqvRVUtoyT1jdcHJaLg73uzj4uZjYphCoW4	1508	1387	91	1	6301	jwGu8kTpH2y5vjdtykGzAXBiSQ9rxpq7G3JVsq6EbZxJR6RznnX	4060	5727	5727	1616970060000	orphaned
7836	3NKDD54Zaka84Vy71hYLrAnZbQG8sYGFwSupExnTHNKKMduN6Yt8	7833	3NKh5BRPnaMh2nKGXphFqmwxsakt89bQave3NBeQX5JoUsLsiyrQ	1406	1393	91	1	6301	jwerLMrZ4KtGexer27A1auz3ctzvSDZtF27nWvYs8kkELLyCkfq	4062	5729	5729	1616970420000	orphaned
7839	3NLp4V1Sy52JLvfGaC7Mth8raXwbzXzTAPCR78UVcPxB11D2yUei	7835	3NKhsnXZtjpkBr93qQfzwKNXEnstkerK4avdasU72GDJwcTegiDe	1637	816	91	1	6301	jxqKgGjpwwDAQ3688GqquoGNQEoEFCi6WRUKMriuqGNkM6oZBQk	4063	5730	5730	1616970600000	canonical
7845	3NKssND4k1qMxAc4NEkjUuJsyWjLwnWjrMDCPzq2uKeQrh8AEP5V	7843	3NLGSdk2YzH4dUCAiESVGQj6aLCdoga5XgCRkaw3qWaZy4r8nm4d	576	1109	91	1	6301	jxZVtDski5FzV1vANrS5b7Nr73wotCkuFiyhNzDnGN3vqfZvke3	4066	5738	5738	1616972040000	canonical
7850	3NKrHdbfeRoa2iNPzYRBEokX83W61kUNLSxZuTZbwnA3iqkehwmH	7849	3NKmnMPcaNYMsqyqyb3nLiRjittdDmjt1M3dweY6SPccHNf2j9fX	1637	816	91	1	6301	jwQjoS8msBbwyhutndftcZDoirStUPjm33fkejVCTgEnhGqt5dM	4069	5742	5742	1616972760000	canonical
7853	3NLCEmLVNZMnba2pdHqnU7rKtjwtzGvRiz1BXqHY5waGvdrLxcNT	7852	3NLNnp3JrFa5RF9PEZe54tkgDX84BUkun1k8ZVkNxJYir3vHuYRk	1467	1376	91	1	6301	jw734EhW7LEFF4HzVVX16icyWL1sJitk9QqxEcHMSDE6LEdm14u	4071	5746	5746	1616973480000	canonical
7863	3NKxhj9dAKBThkAmGUPSh6yR5egpmu9mPuJSb1iv9uWa4z3bJXHF	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1509	1194	91	1	6301	jxbidvqEh3YGRBw7nv6VQC6es7JmA9CgbxrCJWqgZhWcSN47QBH	4076	5751	5751	1616974380000	canonical
7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	7875	3NLYNzZ3MJs6jtPjPRLj8NdJkKrWM28Acg6wEoB5TCaknMvHVEpZ	1624	1208	91	1	6301	jxM53azssZLnMHLagxk99cUxXfxapxzEccEXtGn7mZw4YZcWrz1	4082	5760	5760	1616976000000	canonical
7883	3NLKNTY7CaV9mQMS2QsQp6ddbtitsidFKe38obQ1g9zZsAPz4ae8	7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	1406	1393	91	1	6301	jwANA2Lfp5uAWUyvDbVJYAPGZLxrvYiH5SJeQT7v5pfv2qwy5F1	4085	5764	5764	1616976720000	orphaned
7888	3NKd5ErnFNcmX2r5vTjVUYy1PwxSL2td6iSbEaheWzvifjPGRiTq	7887	3NLvm1LBvvRpd3xgBXTgiAPzy4gDJDHdih1CvZHwTEkv6L7KgR1q	1406	1393	91	1	6301	jwowRf4x1RboW2S7wphowQGnsV9hosMNy2r6EuU8FAUS17ChHnr	4088	5767	5767	1616977260000	canonical
7891	3NKx3MXu322Zw6U1ZjwWGjeN4wiQU9v6m6uHj294MgDu5xdToxvi	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1506	1247	91	1	6301	jwKagksDbP22GuypkZSppSGDoVkKUKHrW14ayd3C4te79FJ7k4N	4090	5769	5769	1616977620000	orphaned
7895	3NKiztAiYFLcQVTaEkjAuUEDGCV9r5EqNfJ6HUg1T2j2NyhRuuK9	7890	3NKp65jv43PYMvNrMQ7bHUjdUU7e4y1kymcKt2U594AQNQnXv72c	1547	1012	92	1	6301	jwitj4fr3xgmMmEuvbGuvvFGXC27CqYNAx5YUb1riyKqRDqZjKX	4091	5770	5770	1616977800000	orphaned
13627	3NKgxfCfXCPs288mqZkpqzTGB2G9axwMd82pS84orVvuR2GXNqYy	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1419	814	205	6301	9843	jwQFGf5YX4RR7RnQuykJ6iHX8hq9tNX3YKGujZuFaueiRPgsv55	7005	9905	9905	1617722100000	orphaned
7932	3NKb6KSv7RmbChdyJ5wAzZcTzt2J23JuzDmCz5sSb7gpCnwfKJfJ	7736	3NKfsiovqEQcrtvQL5stiq8HhZERBey9WJwUuP4DXGJk7EtCY9Nc	1439	1279	89	1	6301	jxcpRPxAxoPbgRMhGiHfdSuYNdepEBHUgwiMY1WS1F6PrJU1dys	3997	5798	5798	1616982840000	orphaned
7857	3NLBeTNKomnheuuaincDNpL2sCuA9EXerZAM3Pf7sECFcTbmAHCi	7856	3NKvgugEAVsneTnebRKVmxJ9jybTnF6chFTq8rDQAKyiUHQEJtGK	1402	850	91	1	6301	jxaTSHEiYom9NBPgnmsQDx5ZRBWwgCmfwPoihTcyXMuAvS49iLU	4074	5749	5749	1616974020000	canonical
7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	7857	3NLBeTNKomnheuuaincDNpL2sCuA9EXerZAM3Pf7sECFcTbmAHCi	1467	1130	91	1	6301	jxNC5AfUzo5MgcRtcLRBeNrVgk14y6gBDqCqc5k9vkjEZZeq2C9	4075	5750	5750	1616974200000	canonical
7864	3NKyCA9mocYnzS28feSWTCFsGV6peS5Dy4FDcyyDQkbS17UPbsjA	7859	3NKbacJs2H5wR2vHMqKdgdD7wera35BfkoxpdbzLa7vDRN961smJ	1601	1022	91	1	6301	jwpGQpydaLTXf9tgLdRMJPPKGiLMBKC2PmRHbkNuLJroJLwGxmP	4076	5751	5751	1616974380000	orphaned
7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	7867	3NKG5xECuAo2csnMCEm8HUZGprxcwCKfRZY3AqZWgWDoKhBraEhf	1474	1083	91	1	6301	jwatCxKphrphjfLcFj4B4MdoeAH3adNgpC9Xwp6RvTsbKjSGXTR	4078	5753	5753	1616974740000	canonical
7870	3NKDUF3emK7nSFUZRbcXwr9Qy4w9bvzqxv4sqhiCsyAnCw9KP3vS	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1457	1145	91	1	6301	jwFvzQMhrRf5dtpLfQRN1ACKmBno8WvxaMDLfVK9dnCY1EtDjJi	4079	5755	5755	1616975100000	orphaned
7875	3NLYNzZ3MJs6jtPjPRLj8NdJkKrWM28Acg6wEoB5TCaknMvHVEpZ	7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	1560	1291	91	1	6301	jwaodrdxaBiftZHwDguS8JuRrmorFcmCpA74v18VnXY7nmaeAkS	4081	5758	5758	1616975640000	canonical
7877	3NLw8sLapnSs4wKcds9zJR8PSEpRfpinsgkfrqJomfNkaWT8x6pD	7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	1405	867	91	1	6301	jx9R9YLkkutTxLFa3BroA6yUgdsNagecK4wtWDUBYXH4xCKqjbs	4081	5758	5758	1616975640000	orphaned
7881	3NLoNpwZogCTB2neqDuiykfmruh6fLj9yorCrf59uG5TET65LsTg	7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	1642	1367	91	1	6301	jxkDUWLVsb9xpNQkfjNELzSPJrBanwyvZkraHu3Q9UDaE6Xc9Ef	4083	5761	5761	1616976180000	orphaned
7885	3NKeUpQazK83RV41HDZFSwvDTWUB76Pc8EMwRdHEx8dJ22LvLhp4	7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	1623	830	91	1	6301	jwXQbdx2BAhmVJhkV2sW1KCCxaZhtFEfJRQ1HYJiNw2dvd329CC	4085	5764	5764	1616976720000	orphaned
7886	3NK5UYSCpoHpbtQoZzJEfcheyCXzYVxYL5JCbgU6FnsUuBPJV89A	7884	3NLQ5cNGtNia5jkVPE4xz9Q68SEKH1z18Xk4uNrm7zCn8tXiSMeU	1403	824	91	1	6301	jxxAtK82bnHP9nbzddzcKDUcDwKVDsUY4VU8EAGXno9sZut2YHa	4086	5765	5765	1616976900000	canonical
7887	3NLvm1LBvvRpd3xgBXTgiAPzy4gDJDHdih1CvZHwTEkv6L7KgR1q	7886	3NK5UYSCpoHpbtQoZzJEfcheyCXzYVxYL5JCbgU6FnsUuBPJV89A	1577	1327	91	1	6301	jx9JWgvJHE7K3aW2uRQweBWZ7GtZYP3k8FSDVggrFPxKkxmbnLk	4087	5766	5766	1616977080000	canonical
7890	3NKp65jv43PYMvNrMQ7bHUjdUU7e4y1kymcKt2U594AQNQnXv72c	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1426	1118	91	1	6301	jxR1biPHRCjJPr2aWoBLp8MPjH9UuQzRJ5LCTUtfQXKZQzY5S8c	4090	5769	5769	1616977620000	canonical
7892	3NKeU4P54McMuFVFB6yeuSgxwQ1yXSiEVfQ5hNza1KsjZUzLFZ2j	7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	1405	873	91	1	6301	jwaMqUi8SRV2N9UnKWdRnnTBPAAemFscQjiGoA4GfW7DZo4Rjjc	4090	5769	5769	1616977620000	orphaned
7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	7890	3NKp65jv43PYMvNrMQ7bHUjdUU7e4y1kymcKt2U594AQNQnXv72c	1407	1395	92	1	6301	jxU7y1aE3AwBU8rfw9hPVEoaCvejAiZP9fgjmo2geCB8gK68vyJ	4091	5770	5770	1616977800000	canonical
7897	3NKQTUCXz1HQ2DCog7qaXa8F7gVzkrYp6mvDv6QGMmugnaHyEuSf	7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	1559	1227	92	1	6301	jxQZv8o1ZW582sTEzZiuS7j1WD2LUsaaNVUu6fnumJwGsgoKSQu	4092	5771	5771	1616977980000	orphaned
7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	1631	794	92	1	6301	jwrcxF8jMVYwf5fPctmwktxnMdjS4ddgGYHzHMiopBHHf89QwX9	4093	5773	5773	1616978340000	canonical
7899	3NLr1YNGXUEW2SQvWA2ftTY4thg88Xmo5ZLZDzQ7mfwqgsXyiJhZ	7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	633	1384	92	1	6301	jx1ZjnLNpDwyqyuDoNiCVSztG6LFHu8diC465bEnyqLgUAdaPwS	4093	5773	5773	1616978340000	orphaned
7903	3NKBzYPAsx5Sy8Y4Xfz3CrL3LQQSMpKZR7z8ojmgoMZwTg9XbupK	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	1448	449	92	1	6301	jwWfo2bucGgnbvhrN2d3mxGSoouszePtrARVZwSGdr4LN924y2Y	4094	5774	5774	1616978520000	canonical
7908	3NKFbg4fPLfcsyDJzgeoKosL52YKnrPEKLuHwprmmYBTpW8xuQeg	7907	3NKxBa9jmFFHQmVCVGcp23oJr478KiTudXN65xmTpUytCcBeH5vD	1536	947	92	1	6301	jxYdjjR8czRUeHg1veJ4SPH478upUSH8syEExFpDtMqqTksWsqU	4097	5777	5777	1616979060000	orphaned
7910	3NLLjtCzdBL3RqihsofVpnQrgx5nPG9KSJfNEe5X7kjP6EEjZMnr	7909	3NKZqyRq926LLxdLLQdBymKiS6A4PXHxCK8sXCtLfF4zhQmLA9GM	311	1307	92	1	6301	jwEJ7rmz7CT3TrhtZvhZqnXWoyqHJawFA52zWPPPHZVuzn5D9Z2	4098	5778	5778	1616979240000	canonical
7913	3NK4S9uRnJTCBRXeKMXpzRJ2b2XCHMgNhRJhjo2FMkwhdvc5bwqT	7912	3NKr2i4CsDxxvJGuipQP1x4Wvbc46NMT2iY5V9B5At1GJ4mhZMfH	1403	786	92	1	6301	jxpfFL2keWM7vcYt1r6rENdAupNAPme6TyFqaai7kCNqmSTXhJM	4101	5782	5782	1616979960000	canonical
7919	3NK3WGSR8U11TquAcdFn2eiLLUojndpzWvrtPL4Q2KpDWWJpeSS7	7916	3NLmjQ7k4pZtbF3qhKbTMFaFR4iQ76JUUMsqxQGFbVgZKtLgkfcR	1402	868	92	1	6301	jxgxvX6KPmtf8M9GuEfZprn31QiL1o8CqXtGDFYaXsTrsayySQx	4104	5787	5787	1616980860000	orphaned
7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	7923	3NLC2P47mV5QCRZCMFqhQo1xXsGFVXDZFEAZYGa68ZxUwEr1sPYs	1471	1140	92	1	6301	jwsBUZy2wkj4SSM1UhwhMBgVxgJHMSxE7BsP74Hs38kq2SqScfN	4108	5794	5794	1616982120000	canonical
7927	3NLbwx5J2dsiVAqu5nCZHdEuNJG1P4WbGPXXnY5ieJofotz8C7KY	7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	1581	778	92	1	6301	jwNQu1SVEKjZF4BJywcRKWW7yW3wxrXRPgLRxmbcjcpvbXkGd8o	4109	5796	5796	1616982480000	orphaned
7929	3NK3HQh6s7Hy5DiQ7X2BdbVkm5TzVh6c2jHizwpk8Akmo2x66wUJ	7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	576	1355	92	1	6301	jwTr9WjD5jioPWrTmnM6Yp789CtkczN59EufQtaEeFJrU36uaGb	4111	5798	5798	1616982840000	canonical
7936	3NLhwfKmXUtDrVThe8vSeGE5pPsmRp1Emmyh7SLbyJwb2nYunTeA	7934	3NLUF9VMtFcayjJLGYBoxLAeBPpTWWCC5UeCdvougazhvxqiBf68	1457	1265	92	1	6301	jwWp2Ag98UvJgfiXzE1pFjBGbaoKCP5VUHN7JEGMurJ8mRRu7u2	4113	5800	5800	1616983200000	orphaned
7941	3NK9rkqgCztSPDu3dsMmxQ3LwRW9oWZRCojfQM65Y9uCYWNXAiCv	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	1637	816	92	1	6301	jxJDfVnZnBps7ZLvgj8ENP4BxVr4xLNoGc5qKCF8T1QSrHAkhaP	4115	5802	5802	1616983560000	orphaned
7946	3NKamnkmz8Cq5ixhapMYbCEZ1GYRuXvUGvMZ5jVmGGVQQsn6rBEX	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1523	1321	92	1	6301	jwiMBxSgtPhR8ynBKexxqgw23S4sw9KNCCFdDMymxSFFMWdo4nV	4116	5803	5803	1616983740000	orphaned
13635	3NKiq5Pfs1vNcaLeZkArz45ehnHcEtNiZeGb8C5zZNPjYxT9Qr8j	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	532	1057	205	6301	9850	jwF2BfRAWSqhv9w3C5TTHeX8pj8GiEbNBBPFeFPpZ5EqzT1DZ5o	7010	9912	9912	1617723360000	orphaned
7867	3NKG5xECuAo2csnMCEm8HUZGprxcwCKfRZY3AqZWgWDoKhBraEhf	7863	3NKxhj9dAKBThkAmGUPSh6yR5egpmu9mPuJSb1iv9uWa4z3bJXHF	1405	867	91	1	6301	jx8kshjUtLjYseAVu5Yq92V8BZGxTVN9nJUKjgpipfCerQ1UxuZ	4077	5752	5752	1616974560000	canonical
7871	3NK34dncNwKDTPmujN1AEYdwWaQ9cDHSY69BCAiXtqGVLjJTXZVX	7868	3NKHiEnbzZU9zWBcrEJv4mGMSdy3vPwZdKdEm4tzKuzWa6P41v9o	1405	891	91	1	6301	jwht39fHtkTDYpeDadL3ahG3MmnDttgWuPzoe38sRMRJaBQZSaA	4079	5755	5755	1616975100000	orphaned
7874	3NL9cvQrsqyHAMFjuYu7v8g1CukQRoksRRxv6p1G8emPD3P2wkMX	7869	3NLN4RnJzQesYEHsYewuigwG1JyEDcxvZZASRcQKPW95PGF2gHFH	1553	776	91	1	6301	jxU88HaUGrvMAWQhRURb4H6jYZrJE69xXDGeXEwRBaJbsG9PqoD	4080	5756	5756	1616975280000	canonical
7880	3NLuw3f6sNmJuJy9LSrGYaashWKLCoiu687YsUofKWxNUXFTkTfm	7878	3NKJYSqHcvH7Npr92JK3MfuLqfkFKcm3VMAPsmRpYQxPv6LrKtfR	1675	1342	91	1	6301	jwLQAJLqMntDgL7h7iE6qTH527DtefxGuiCuGWjUtcpgeYPaNRB	4083	5761	5761	1616976180000	orphaned
7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	7879	3NLhHmhHo8nB3WCpWooxkhfj2nPjyGSkRjsmnyehwqth6LxXmzxE	1419	814	91	1	6301	jwWVqvYyb18k7s4TZ232f6eZRZXo8YoLmgbTytxD8P5royHrhu5	4084	5763	5763	1616976540000	canonical
7884	3NLQ5cNGtNia5jkVPE4xz9Q68SEKH1z18Xk4uNrm7zCn8tXiSMeU	7882	3NKBHkbCFjvTur2Spd8FP7KXV5xSnGBbApdQo2h75kJ1BBZSmRNB	1560	388	91	1	6301	jwXwig5Yiue4xeHYhMV6dA5kL5AzwRoGkVbmnXKDQSP4YrXkQmx	4085	5764	5764	1616976720000	canonical
7889	3NKRPMuUUps1jaV9uzs7peZDta15KR6mbe38f3v1BUutVJaW5xee	7888	3NKd5ErnFNcmX2r5vTjVUYy1PwxSL2td6iSbEaheWzvifjPGRiTq	1403	824	91	1	6301	jx241MPr4Tz4RwSinhMMGVgQ5M5MtjS3NxCScAwNqnT42QU5YUE	4089	5768	5768	1616977440000	canonical
7896	3NK6TfH7L7qCmG1nQcxxKjqfRqN8fczWoM9hDSVchz31FtYGfphx	7894	3NK7ZpmjohY6HNL2hYWunU996ZwiPoSLatWmaCE6kbtRVuo4v4zP	1546	1213	92	1	6301	jwCRLzubEbBoXWxudEczDTFSGCqfzMkushG7KWTJLSMJQWqGhr5	4092	5771	5771	1616977980000	orphaned
7912	3NKr2i4CsDxxvJGuipQP1x4Wvbc46NMT2iY5V9B5At1GJ4mhZMfH	7911	3NK8WCxzP3wb2b5mWFbahYtG91da9ju9zVBhEpCzxWFEUQtPg3QJ	1573	1192	92	1	6301	jxyVSgSKtqBPr8RYGJXsLnFP5fd415gcN2j5eax9ZmCDbcpRsmw	4100	5780	5780	1616979600000	canonical
7915	3NL3HaksuMKtydxtyuT4yULeFXs9rZ2MpQ6i3gBkfeZPsU5dZoMB	7913	3NK4S9uRnJTCBRXeKMXpzRJ2b2XCHMgNhRJhjo2FMkwhdvc5bwqT	1637	816	92	1	6301	jxFZW75i7aLRf9TVq4CXb1QtJQNB8mLmHXVXFSzrLshHYeipoyC	4102	5783	5783	1616980140000	canonical
7918	3NLiVub12qx2jK1prqXA15XbXPRP4JNgH2yVvkk31YCY9Eh9CQvu	7916	3NLmjQ7k4pZtbF3qhKbTMFaFR4iQ76JUUMsqxQGFbVgZKtLgkfcR	1407	1395	92	1	6301	jwWhPP1BJ5oqZ487WLsKyiCS9mETDysYAW51QGmg4zfKpjB4xPP	4104	5787	5787	1616980860000	canonical
7921	3NLXg3TRqoaF3PKrYSMsk7hcHXXr41Uvvp5nt9QCN2Zm267dnWuw	7920	3NLVh9BVPvbiW9u1mxMQ3D7xPyxkr4tRshmcb4MmgcuLruiF1awF	1406	1393	92	1	6301	jx9TWXDoNf5LUPSqJHsNsVVskabY7JcCWf4QeakG1jQLdxz8EGC	4106	5791	5791	1616981580000	orphaned
7926	3NKseYQc4D5Mpv6ZoPdHPmCGEsH8rGNkJrAxFcSsD7DKLVCfwrhR	7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	1578	1296	92	1	6301	jx6vwnYVo2DbphY697jkKEFqntVKWH6y5pWpicbsG8dUs7G7hij	4109	5796	5796	1616982480000	canonical
7935	3NLTBZ69kqy74GwE9ep8veN4gc7tf5CuHG41cyW5zmRFLcm51zFd	7934	3NLUF9VMtFcayjJLGYBoxLAeBPpTWWCC5UeCdvougazhvxqiBf68	1407	1395	92	1	6301	jy268KAgrDecrGrbJTtou2P3ExGo8ozh2kEEQHcansdQX5mrgbr	4113	5800	5800	1616983200000	canonical
7938	3NLAvXw59xHohoHZ811wFfbwZpq7kLwQZoqMEg8sgU3jotsuC8F7	7935	3NLTBZ69kqy74GwE9ep8veN4gc7tf5CuHG41cyW5zmRFLcm51zFd	1642	1121	92	1	6301	jxp5ziQ1M3QQjrYyXk4aNhMZFvFwQFhjRxymjgP3fLxoH1hnDLg	4114	5801	5801	1616983380000	orphaned
7940	3NKVQziLSPgn8rSPfFuzQWb997PAnoZA6q7L65wEQVD6gkszhFBo	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	532	937	92	1	6301	jxdr4oXvBjehN17qkVKwakV7AdUisduL9SEbDohtE6fJ2CkNzg1	4115	5802	5802	1616983560000	orphaned
7945	3NKxbE42XuM2WgcqgWsGKwdu9p2vzQW9Vx6YsjLr2kMFZPwnmQKv	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1455	966	92	1	6301	jwUM8z4J87LHwq4sCzEpmADebWNcPHCaeMnU1XLWZDkYXK5LETX	4116	5803	5803	1616983740000	canonical
7951	3NL7Zg4GpHJQyaWzjKRAtY17z3XcLjE1aQeeXoueRnYn1YaRFCcr	7950	3NLRvgmpxuUQhQ7sqXEmSXkiKJcaugHMS4Dc4s7QQpDNJGWHN9U4	684	986	92	1	6301	jxH8aq7Z5SusBvqg34b9iqbcAVy8xzGKVrRYAcjRsnnAEC7CK6N	4119	5806	5806	1616984280000	canonical
7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	7955	3NKAEGAkYzth1WZkLAYDBGJgLLv5w2NpXqGkJE9Pu4mRarUUdykq	1590	1054	92	1	6301	jx7fkKmT9T2FQjvcbgzzXc79dB4rwZHyqM5NxhYdXYF1aJzqfSJ	4123	5811	5811	1616985180000	canonical
7961	3NLeC1F3zYCczPzi7XjEbeFvfUWAWFkKs7FNYTvcXeHK7DpiCkyv	7960	3NLQWpAvvYaknfPy1NZM3FVmvLcdk7N1dRBgmYDBeKyZrfweyvct	1405	849	92	1	6301	jxfjcNaDQjMGkK7hsYJS43Mpy4ptazGV9FxxUJ2EJqL61s9SL7F	4125	5815	5815	1616985900000	canonical
7962	3NLccEjytCrfk2hsCRU5pvH4EUDtSRYcvLU28azouMwcaboNJg2q	7961	3NLeC1F3zYCczPzi7XjEbeFvfUWAWFkKs7FNYTvcXeHK7DpiCkyv	1406	1393	92	1	6301	jxxEjE58zkJvWfGBMWkuTaNaZHgAx3visDpQpQ6JtHBvWCmNHdW	4126	5818	5818	1616986440000	canonical
7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	7962	3NLccEjytCrfk2hsCRU5pvH4EUDtSRYcvLU28azouMwcaboNJg2q	1402	810	92	1	6301	jxt8foCgGvgHq4wXHjQqHS1dMrDxWTX1sLqPvD2VyExdbt3awPZ	4127	5819	5819	1616986620000	canonical
7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	1652	1069	92	1	6301	jxByh7epLbUxkc1xUJP2LaiaxzGTt66749pQV1pZiugttZqsuv2	4128	5820	5820	1616986800000	canonical
7967	3NLfZxRkmxbWWBgZb5mHjue3yENgSEXJ6myPoUiFDGoeZ3Rkxucd	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	366	366	92	1	6301	jwN4WtSeQkSmgMWEVmygxzUUNchUe7TPsKMP39fADboNDiUEcyz	4128	5820	5820	1616986800000	orphaned
7971	3NKhjepU9MUfJGYMR1vrKJC1XrnLFM7L6tn1Qv37hFdHkkfgM7mw	7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	1553	776	93	1	6301	jxz4Cu5T7TGH7JXmb4xqM172owkRxvwZUsHaEYPqutg56VzEQPa	4129	5823	5823	1616987340000	canonical
7970	3NLw9kXUYTxDF4xeUBsjKmDd3pXFPwWgwM3A2JTqmcB7jpy78Yx9	7968	3NLriWgwPC74UfU25T5Fy6kZTUypt6mymTyRtdh47CJKMXvbbAhy	1559	1353	93	1	6301	jwaNg3GUFLxMs4KUNiUwW4MAcskZikYAJQnPbBrJQs2HFZu4vJW	4129	5823	5823	1616987340000	orphaned
7974	3NKc3gqnfFs7AeSKtxumbzoAqWJQZiz2cjUCHoP8VWgYWJLJuwsv	7973	3NKSndqLB6JU12Mm5ycyPA97DLh36BLiKGR7Qk4RjxanAso1R6Cr	1406	1393	93	1	6301	jxwj3xdibuoYmp35niiR4rXmWnfCcjaoj39Q7Gvs7GVVLrs2bic	4132	5827	5827	1616988060000	canonical
7975	3NKSWZgStbTyj38ZPRGLhosg8MqtYRnc9hwyTFKCcY2jRqPHfU7H	7974	3NKc3gqnfFs7AeSKtxumbzoAqWJQZiz2cjUCHoP8VWgYWJLJuwsv	641	1210	93	1	6301	jxy4aTi1Xcgad6kYk9Sfb8DBtev69aLczMJnn1n1yKBqBMiqgA5	4133	5830	5830	1616988600000	canonical
7979	3NLkhVGHPqQuNjFWGjVyAGjmS3v1gd5ZQEZDZRKLQgVQusE652cg	7976	3NK3nUD3mEXf7CjebksCrfbDm6f7GLPQQkMGV8AxM7YxYsaQEhkd	1593	1346	93	1	6301	jwimCvJKNuDUHe7cvUaKWTohj4iAAs4iSChE1VmVcQ3PdW9mdiW	4135	5832	5832	1616988960000	orphaned
13643	3NLkN5yPudXyo1F25aGVaDMMuVxY1Anw2ECRZUKuoDPph6qdRYYJ	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	1407	1395	205	6301	9856	jx9vLF67WLYTKdb2QS7dD8w2NcVB9CMnZdKqJHZ3hWfPGPMEhWV	7014	9919	9919	1617724620000	orphaned
7900	3NKJP7Ye796BcRuyYm82cUKrCgCyn4E3B7myYd8tAMncHbXaKR2W	7898	3NKNHXMugbHbDCLh7XhQnt7ni2BQpjGVa96PQu4CyiFR6sCf8xM5	1403	824	92	1	6301	jxcXbb6jU2vqshv3iDUTr1YoEaGN59MWZREivtJXGiJNN3rWzRi	4093	5773	5773	1616978340000	orphaned
7904	3NLsHWjhKFPEgoHB1KFZUgdYcC7YgtFDXz5G6FvsXyW7MNEjLVqE	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	1500	1297	92	1	6301	jwxnDCbkuK3CwcTBWbnHXJRzJ8MkDrmhU2eMKdpjrR8E44rgpZa	4094	5774	5774	1616978520000	orphaned
7906	3NLeivCZcniPFdhywUy4RuHuGLHQFE8nXJ3wMG9mrmPSWyw9pFtG	7903	3NKBzYPAsx5Sy8Y4Xfz3CrL3LQQSMpKZR7z8ojmgoMZwTg9XbupK	1549	1362	92	1	6301	jxc531J13T5xtE3Ycty2kJuSJNW9AyUy9FnJdCDYXoUtr1RHU6h	4095	5775	5775	1616978700000	canonical
7909	3NKZqyRq926LLxdLLQdBymKiS6A4PXHxCK8sXCtLfF4zhQmLA9GM	7907	3NKxBa9jmFFHQmVCVGcp23oJr478KiTudXN65xmTpUytCcBeH5vD	1637	816	92	1	6301	jwRBm4SJYuwLny53ScyUMHa9vcQuxVXzBw5R1sBVxyZ3Cmmr5ZZ	4097	5777	5777	1616979060000	canonical
7911	3NK8WCxzP3wb2b5mWFbahYtG91da9ju9zVBhEpCzxWFEUQtPg3QJ	7910	3NLLjtCzdBL3RqihsofVpnQrgx5nPG9KSJfNEe5X7kjP6EEjZMnr	80	1273	92	1	6301	jxMSfh23EagE1USFSqur6h9Lut4Aos2Q9CabW1QUdMUxQsLLHjV	4099	5779	5779	1616979420000	canonical
7914	3NKLpAfhspvn8V7Q3e3GcNC6Bm9g2KdT4KiEunxeStiTPwuAxMGz	7912	3NKr2i4CsDxxvJGuipQP1x4Wvbc46NMT2iY5V9B5At1GJ4mhZMfH	1581	778	92	1	6301	jxNuiXszgJ516ieKzsi73mqZdvrdi9zYpCq182myRExjnbTbmrE	4101	5782	5782	1616979960000	orphaned
7916	3NLmjQ7k4pZtbF3qhKbTMFaFR4iQ76JUUMsqxQGFbVgZKtLgkfcR	7915	3NL3HaksuMKtydxtyuT4yULeFXs9rZ2MpQ6i3gBkfeZPsU5dZoMB	1407	1395	92	1	6301	jxXjBBaAZdH6KwBCfowHkZtBQ5YHoqaRAnS94JhyYNXi8VEDbNH	4103	5784	5784	1616980320000	canonical
7922	3NKm776GCS6Fqm91YCA8p6agstHnjB3FT9ncB47qX5vsghu3yAhi	7920	3NLVh9BVPvbiW9u1mxMQ3D7xPyxkr4tRshmcb4MmgcuLruiF1awF	1529	1190	92	1	6301	jxBCUjf1dNqwb17hhEtJ49EEF7DuXfqJWcKjFjoJ5B7AiS8Skfh	4106	5791	5791	1616981580000	canonical
7933	3NLZyqKp5oTLCu4ThEUX6DMySWAPAXZVFXUyVzfKpkz4PsqLvsdJ	7924	3NLUJjpwJiFii6PZRpdNnwS8a5YQRsQckQVWFAqRWp29n93iLKy6	1476	1245	92	1	6301	jwcruE5UN74STr6RUz82cwCJuvUgqsKTHUHyEb67McYaZbxdGss	4109	5798	5798	1616982840000	orphaned
7930	3NL2ZEPRjbYHV9wZaroUmRG5hBkWUSkgsv9k4nYSfiDTHz3Fgwwm	7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	1439	1279	92	1	6301	jxyJzrPuVAcbMHcyogtWkgkSVrTuew7WTDoP77RETo9NWd8Y53S	4111	5798	5798	1616982840000	orphaned
7934	3NLUF9VMtFcayjJLGYBoxLAeBPpTWWCC5UeCdvougazhvxqiBf68	7929	3NK3HQh6s7Hy5DiQ7X2BdbVkm5TzVh6c2jHizwpk8Akmo2x66wUJ	1457	1391	92	1	6301	jx2yYsv2PXU2mBvJfVRc9hDhD2JyJBwm3p3N1FZag3Sdp2GgyUe	4112	5799	5799	1616983020000	canonical
7942	3NKLt7CQyC4HdZmUfAfGMoL5XdBfESuPQQ7GPVtHqsoxZG4B1P8t	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	1581	778	92	1	6301	jwQDJHqkKtAqdNuC7CiB6onU7gvJzuQhncWEd2k9ErU7oaUNVkz	4115	5802	5802	1616983560000	orphaned
7943	3NKDQZ5D9nbNuDLT5KShhRLWb3HepTrwRpcXw9dfDGExAJwhiE8k	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1523	1321	92	1	6301	jxfqxvjKh4YsY3JZueezSR7KevGSiwhxqBz2eLNEeMi9wtZJqd2	4116	5803	5803	1616983740000	orphaned
7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	7945	3NKxbE42XuM2WgcqgWsGKwdu9p2vzQW9Vx6YsjLr2kMFZPwnmQKv	1673	1002	92	1	6301	jwHvFUGgDabJ1jpYLD2ZKxG5xYs5exCZrhAmuPR8HTNvUGiDrRK	4117	5804	5804	1616983920000	canonical
7952	3NKpNcB19mujF1Eb4g8wZUdehTJmU8beoFeeYfkSsn7E9Magjzmk	7951	3NL7Zg4GpHJQyaWzjKRAtY17z3XcLjE1aQeeXoueRnYn1YaRFCcr	1549	1362	92	1	6301	jxDrLXzercvpj3oXPTmJj538PrjpZzWamtoBTGb8U7Xp83z7Wc9	4120	5807	5807	1616984460000	orphaned
7954	3NKomodL3S4UgDrr97ubx17ut9gGC9KJrm1vsyBiFxonLD8g67BY	7953	3NLnib2yNkLZhSePBiPf9rB4PHRo6K2Eis1Q9AFBXMG8StzHmcuX	497	657	92	1	6301	jwpyQKG86zp3eeAfJWcsfvFTbGFZy1tGB6TPUboqtKp4VkFLvah	4121	5808	5808	1616984640000	canonical
7957	3NLjxnTeKh8Xwd4SL9m99X5wHfTb9XeiHRc3aM77Y2NkdfJknccE	7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	1637	816	92	1	6301	jxGF8JifuwKxCTLVbB3cYoKy26scWXgc7rApZQjrcVaAYvERnR6	4124	5812	5812	1616985360000	orphaned
7963	3NKKRf6yyRx1XoxVqHAxkTuuMBhxvxWhMQNeqGomsJYFETFue7Qr	7962	3NLccEjytCrfk2hsCRU5pvH4EUDtSRYcvLU28azouMwcaboNJg2q	1406	1393	92	1	6301	jwTZ7sbPng19iMi18w7iowb8br8jKdsj3NsnySq9yr2gv6E7Ent	4127	5819	5819	1616986620000	orphaned
7965	3NLybPzHUV5K8txnLyYN3fx9PpFkAA1avPo8BM1gQB8T4xWzzJQ2	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	1619	1275	92	1	6301	jwNivj3Ctxf8m3bpM8Gj5AEuxMDbCLbqFb8vPCky68zcyKTzfLR	4128	5820	5820	1616986800000	orphaned
7972	3NKXdceDGLcz4gHVa1tPSnh29Q1soqbehzVrNubJFepsnqFeNP6C	7971	3NKhjepU9MUfJGYMR1vrKJC1XrnLFM7L6tn1Qv37hFdHkkfgM7mw	1477	1224	93	1	6301	jxKvFUUkApRQtBJedrobyNkbeEPoBeqRmcbk8k9EjaP8ajCH7ea	4130	5824	5824	1616987520000	canonical
7976	3NK3nUD3mEXf7CjebksCrfbDm6f7GLPQQkMGV8AxM7YxYsaQEhkd	7975	3NKSWZgStbTyj38ZPRGLhosg8MqtYRnc9hwyTFKCcY2jRqPHfU7H	1407	1395	93	1	6301	jw8HegERzLLGZxZmSZtiB8axA3Wiy8SEcwm7kLXRWWUQL1t77yt	4134	5831	5831	1616988780000	canonical
7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	7976	3NK3nUD3mEXf7CjebksCrfbDm6f7GLPQQkMGV8AxM7YxYsaQEhkd	1407	1395	93	1	6301	jwhXSRxsb8SB1SAFtnVENNge5t6KqyuyVYi8aSgEmmTiufWK8do	4135	5832	5832	1616988960000	canonical
7981	3NKiewZ7j39nZsqUE3FLNQZiQPSiY8ZBe1BbaeZ6MLTNrAvvtHnf	7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	1610	1314	93	1	6301	jx88bgfUyCXWgzDm9ZHqsaYmFxp1BbLGvVZUWT6kasrh8TMdNof	4136	5834	5834	1616989320000	orphaned
7983	3NKpyr8arPvQv3d3fWrtefEA2WLveHK7Eohz5f7YgGEDSBaVMFF6	7982	3NLRzKgenbcigVKTC8MJVecJXmZ9mbd1q6AHXkH8VUqejkAkHtPZ	1631	793	93	1	6301	jy25wypQp57SbTsHVMbgU29Zj7Yp6WTS1uSYY4TcaDKuWfsboRJ	4137	5835	5835	1616989500000	canonical
7985	3NLuYLefecnBBi53dkKf3hoF2XZhuS52tDmwW7BDoGkCqDGUUuZR	7984	3NLi2zVMXrkeWg31HELZr2SACEv16Y8YEepuFRJMikWVYzFZ13dx	1516	479	93	1	6301	jwtn29cEpMQFBNWaDyyLXgiGzRSK9xHBqrCTFD21u7y7BjDfQAo	4139	5839	5839	1616990220000	canonical
7988	3NKB6Em4bye2d5hAM6LRgWJCLbK1dEp2d4dW68ZmmoUULJ7GP2nu	7986	3NLnenhyuMNaQo9PeKGEAizQAf1vTWPxAEa2rQMkAaYLMZMmF9zV	1577	961	93	1	6301	jxos6hX5JD45zDzKkVRRyriKeDEsmhkaujwUJHfa5mw6S7cmfmE	4141	5844	5844	1616991120000	canonical
7991	3NLDgBFCLPDkRVeS1Qzmp5nmJhzP9wvBiE23vm5QsaTZGrJYkppS	7989	3NLjwwtEgHPJ16aWfnAm4cdedsAkdkmhdajTZrPFUtV79JtcNNFD	1406	1393	93	1	6301	jwqfq3NP1PS219A3buu7SPdjMw2Wq9AhTjapmtnHCM78xns2bw4	4143	5847	5847	1616991660000	canonical
7994	3NLYWVtBXRHEG2MsF9tFzVbU3zDojTLydqgt93mJ3Cs2bpzjwdbd	7992	3NKT5bWqJbXEdNnBY2mBQ9bi7qpMU8TRbDT2DxgLk34Fedb4Fpc6	1455	1086	93	1	6301	jxrsL8Lr38QLn7JqYUuFyhoC8FeTrTtBZmxgBCAjs4Sm3YBZjgD	4145	5850	5850	1616992200000	orphaned
8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1637	816	93	1	6301	jx7Qrxsd1GyRpoyAwdFcqEZ8E8nVFdUTfmHMZhyFmibhu3UxeHA	4147	5853	5853	1616992740000	canonical
13646	3NLG6QprGtJR1Pn3VqRNSMVv6odQBvDu6pZTNupLdPtdyRsAnHnC	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	1406	1393	205	6301	9859	jxKzjxtsyBBJsb2ujVbDmUqt7vGd8ZRGrXMycTVHvsMPs5ipfQA	7014	9919	9919	1617724620000	orphaned
8002	3NLfKQCJSYWQgD2cyLsWXuLtKgovC6kcRDSpjmMeKGE3LpsXLeJX	7743	3NLCSGv25hRnaCwpJea8ghaHWpLe7rJ7B9Q6mk5MdxVQuUfXm9Mz	1523	1321	89	1	6301	jx1obrfdK5zczX6bKZ8YkezJRq1PENhCA6SYbTRCdvpgsaJbSEN	4014	5853	5853	1616992774455	orphaned
8003	3NK7s7V6W63PjMoWUEB2w1F4ZBzvfg1jFajTMo8q84hxAJP7Vv6X	7767	3NLhoqbvYZ5PeR71X1Cd8cY3ttQDtMqyWiN7HuEytWLer38ctJiR	1523	1321	90	1	6301	jwMe1AqU12ExzA1KaMr7pdEijdmggaq65doMAK2fpaeWFoKrAjX	4028	5853	5853	1616992805961	orphaned
7902	3NLLX2mZTYZV27vzM3SXpcPb7FmLpoCfUZHGKwcxxSooiijB4psK	7901	3NKyikzrqby5X77qkNo5exrp5dJCasbeXbk4a1Zho5AQvbnkK3Mq	1406	1393	92	1	6301	jwg7oMyfWRaZL8ifiEh8yV853actKaWQyam2uj3CwR1u7geNo3F	4094	5774	5774	1616978520000	orphaned
7917	3NKvysxNPLNJiux5in2WVmSwGKaXSYozJDiQarrRJxHCP4MJ1W4X	7915	3NL3HaksuMKtydxtyuT4yULeFXs9rZ2MpQ6i3gBkfeZPsU5dZoMB	1430	296	92	1	6301	jx98UWoqLW4NYVs5NuQKbR7puWgwP3n1wuugqZGmrWD31rfsJyE	4103	5784	5784	1616980320000	orphaned
7920	3NLVh9BVPvbiW9u1mxMQ3D7xPyxkr4tRshmcb4MmgcuLruiF1awF	7918	3NLiVub12qx2jK1prqXA15XbXPRP4JNgH2yVvkk31YCY9Eh9CQvu	1403	824	92	1	6301	jxjfobwYNN7sBeiVcdpdzwFY2JayMC3vjbrwh5cMqgAG4ABtqHu	4105	5789	5789	1616981220000	canonical
7923	3NLC2P47mV5QCRZCMFqhQo1xXsGFVXDZFEAZYGa68ZxUwEr1sPYs	7922	3NKm776GCS6Fqm91YCA8p6agstHnjB3FT9ncB47qX5vsghu3yAhi	1490	1028	92	1	6301	jwqua4THMocWGcBxm4gwGmkBUAfDf8e88WeofyZ2YR7vKaJ9zPM	4107	5793	5793	1616981940000	canonical
7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	7926	3NKseYQc4D5Mpv6ZoPdHPmCGEsH8rGNkJrAxFcSsD7DKLVCfwrhR	1653	491	92	1	6301	jwTFCS3o5JB8ZfRiYA9YG5nsPxZGPdE3q43fv6JPxArX5ovJNx2	4110	5797	5797	1616982660000	canonical
7931	3NKNw3DXU8nhPb75BxP7DXbXCkrvVZpnK6xztQs2pbBCWzJhLPVo	7928	3NLwzyxGa3G7Pq23vPqQ1ypt34gdrNKEnk7dTSikzNeBYvHnXr3p	1476	1245	92	1	6301	jwrUpjevqLbRjMMrFLLQbzC32TJpFs8H599vWjsRubLtYQDrvW3	4111	5798	5798	1616982840000	orphaned
7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	7935	3NLTBZ69kqy74GwE9ep8veN4gc7tf5CuHG41cyW5zmRFLcm51zFd	1619	1275	92	1	6301	jx6EiGEW28c4t9MhhUbUdVuvbnuPDfLNK97MB9EUH1QfZ4uChSB	4114	5801	5801	1616983380000	canonical
7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	7937	3NLEJvSgXQgmpmvHrn8ETVM6wDYb5GuT8ruLMQ7MaFjCtxvUbDMF	1407	1395	92	1	6301	jxBRTAwFcHzsMwtCxPoYarWewgtBTG42J4YGXPoFG6xfTDx6b28	4115	5802	5802	1616983560000	canonical
7944	3NKKcB7UUiLToB7kwStVgHbZgZ9aCYsPezxcnKtjuZvzZrJ7Cd4A	7939	3NLxh2o68A4fq9yesWNk3pmfTPy7Bqm4qSgzNAdpuPK7WrXbeFT7	1523	1321	92	1	6301	jweFf75Ju7kpzVRt741dTBabb29bs3YYh5GrrMJcqN4kHX392pG	4116	5803	5803	1616983740000	orphaned
7950	3NLRvgmpxuUQhQ7sqXEmSXkiKJcaugHMS4Dc4s7QQpDNJGWHN9U4	7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	1631	794	92	1	6301	jwk9uHvrLgGv4oBCvHW5EQPfqbveSgf8N2s5jxjj2eSJgz9CnDB	4118	5805	5805	1616984100000	canonical
7948	3NLF8SL3Ry7JfXUfuzGkAPk66dfNGZwhj9MSijAYfQgA5QYbFWw7	7947	3NLtcap2nou5gXnGqiZNCHr2joYbKa6sse1Si8pKxUNLBc1saxhd	1406	1393	92	1	6301	jws4drotiiXPZwMukp1imnunV5Wz8GnGsGTy8P42ydjJLzcW6Zk	4118	5805	5805	1616984100000	orphaned
7953	3NLnib2yNkLZhSePBiPf9rB4PHRo6K2Eis1Q9AFBXMG8StzHmcuX	7951	3NL7Zg4GpHJQyaWzjKRAtY17z3XcLjE1aQeeXoueRnYn1YaRFCcr	1406	1393	92	1	6301	jw8xp4kkaBtD1othExmWJmegZ1MJQstmRfWWba3PsMKWcCFLrDR	4120	5807	5807	1616984460000	canonical
7955	3NKAEGAkYzth1WZkLAYDBGJgLLv5w2NpXqGkJE9Pu4mRarUUdykq	7954	3NKomodL3S4UgDrr97ubx17ut9gGC9KJrm1vsyBiFxonLD8g67BY	1460	1078	92	1	6301	jwqEtcSAEwax1FMtX2oiC9aCQARUU9BfuZUs1kH7vx7RFMNZ2QD	4122	5809	5809	1616984820000	canonical
7960	3NLQWpAvvYaknfPy1NZM3FVmvLcdk7N1dRBgmYDBeKyZrfweyvct	7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	1553	776	92	1	6301	jwJ1WCnWBXHGdhc5qHn9D1EyaUwV2xmgQu34copE5mdZm5ja49z	4124	5812	5812	1616985360000	canonical
7958	3NKpoeZNz4cMjfMzUFbUYxn8rPWUWyLHJKDeDWBwT3uUUeK6z48A	7956	3NLHi8fGFCjXPnRJkwKgL4SCNLPuMkTEQXXLCThQfpccTbUTgGpW	1439	1033	92	1	6301	jwNGByFwzKX1wNyU6B9XGCPSiohvy5ZMvWwtmy2wa24u6YYy9Po	4124	5812	5812	1616985360000	orphaned
7966	3NKrLhDSTEJZL12LhXSz82PN4q7UMnXfJDwGPBqqN2TomTN1Zun1	7964	3NKLnXrF6YzPF1b8sb7PBLjqD4oRZLh27e1Xv7yJb85hx7tEsDxw	1599	1041	92	1	6301	jwgm9eSvoXyJ59CddMhMHYgaiu7rJU6XHomf5HPriD5vGmQVzrz	4128	5820	5820	1616986800000	orphaned
7973	3NKSndqLB6JU12Mm5ycyPA97DLh36BLiKGR7Qk4RjxanAso1R6Cr	7972	3NKXdceDGLcz4gHVa1tPSnh29Q1soqbehzVrNubJFepsnqFeNP6C	1668	1244	93	1	6301	jxNjS5U9b4yNc8uSHqQPeXSNPR4NuZK6HJZPNxKARhJSjefekAH	4131	5825	5825	1616987700000	canonical
7977	3NLuDfFnVqexTh9LuaTH1ebGfHfq8Bq4kHEYFnkSer8JbRYCz6Kx	7975	3NKSWZgStbTyj38ZPRGLhosg8MqtYRnc9hwyTFKCcY2jRqPHfU7H	1534	156	93	1	6301	jxnbrZ3QMSM633fiL4QQYcSuo3hSWdibaUMk4QLk8rLjtxMJ7D4	4134	5831	5831	1616988780000	orphaned
7982	3NLRzKgenbcigVKTC8MJVecJXmZ9mbd1q6AHXkH8VUqejkAkHtPZ	7978	3NLA9pakc8xaGXdcYR5dEBUKW4ac3Hc3nXsUgLuq7s6qHv8LtYh7	1483	252	93	1	6301	jwmDArn87XSPTkZJMxbRGPrq8Aixv9qPJkQDeHY1UiJwQgzW6et	4136	5834	5834	1616989320000	canonical
7984	3NLi2zVMXrkeWg31HELZr2SACEv16Y8YEepuFRJMikWVYzFZ13dx	7983	3NKpyr8arPvQv3d3fWrtefEA2WLveHK7Eohz5f7YgGEDSBaVMFF6	1460	1324	93	1	6301	jwF8tM4qf7VK9PgFJHenKBaH7HyK4L3JmbeBQonjRNssYM1ZFZj	4138	5837	5837	1616989860000	canonical
7987	3NLiGJGWJJnoJir2477a7dkek5oTnkds56XPCqkvi1NPUKwZ7pYj	7986	3NLnenhyuMNaQo9PeKGEAizQAf1vTWPxAEa2rQMkAaYLMZMmF9zV	1610	1068	93	1	6301	jwCy6NTp4Rrhra9cSi9EjFv28uKqkG7aotdtAmgi6JUSvQjXpXk	4141	5844	5844	1616991120000	orphaned
7990	3NLXmK9ZbrmNUUdoMahM3GUnZbi368HLnroKBzPDvK4KzYpM5vgF	7988	3NKB6Em4bye2d5hAM6LRgWJCLbK1dEp2d4dW68ZmmoUULJ7GP2nu	1581	778	93	1	6301	jwu9mh1bJWZXtURCAZvuMRyc1o21Gq64Bygr2rtQe75356N2NmN	4142	5846	5846	1616991480000	orphaned
7992	3NKT5bWqJbXEdNnBY2mBQ9bi7qpMU8TRbDT2DxgLk34Fedb4Fpc6	7991	3NLDgBFCLPDkRVeS1Qzmp5nmJhzP9wvBiE23vm5QsaTZGrJYkppS	1622	990	93	1	6301	jwa8ExmQpPjFjjUkMTrMkzfQnzifuvFF1oJFuSDKrBwNgs3SZaL	4144	5848	5848	1616991840000	canonical
7993	3NLpS1NqLMJCN38L6ZWffJu3zJRz9Nc8j69KDoYApvLzpEDqBxSx	7992	3NKT5bWqJbXEdNnBY2mBQ9bi7qpMU8TRbDT2DxgLk34Fedb4Fpc6	1406	1393	93	1	6301	jwkBTKPAnVwxGcxzSmefJmssRYq19ymR2jemcgSVJwr5LjUtHWo	4145	5850	5850	1616992200000	canonical
7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	7993	3NLpS1NqLMJCN38L6ZWffJu3zJRz9Nc8j69KDoYApvLzpEDqBxSx	1406	1393	93	1	6301	jxivTT5NWANNbvFBzc6PQjFHGJxk9fQkwncpovvsbag9bDF3344	4146	5852	5852	1616992560000	canonical
7996	3NKJrDMbJAaRVzFTKJSdHoficRFMmX7HNcRvhFZ3yT2uobWojtcU	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1523	1321	93	1	6301	jxXrrcjMFkDs7TyjrQB762QAFPWtyDB8VsGszAGVkPUMPthMdLo	4147	5853	5853	1616992740000	orphaned
8004	3NKWkDn4MixL6jECdNMSmWb4eB5dAMwQZXHAAGtn6HdKJsmZk8MS	8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	1483	390	93	1	6301	jx3GDVviEFjWzXqgMMKaNgt1EeU9YQzFpo9u9ynjYCmPWDGvU5M	4148	5855	5855	1616993100000	orphaned
13775	3NKK7ETsTdLqsb6qB26BcSCqt5hf5LyiXTaCSyK2zyMuvVHNj5rx	13649	3NLUEBosVu4NikhU6vKnkzVqa5os6j9Pn672VP5uY8vWwnDRYRr3	1522	1322	205	6301	9972	jxFmVsFBTVbmj8sqHrn5E1WuB31tFk2cQEUL19tFpbsCDV95wiy	7017	10009	10009	1617740820000	orphaned
7986	3NLnenhyuMNaQo9PeKGEAizQAf1vTWPxAEa2rQMkAaYLMZMmF9zV	7985	3NLuYLefecnBBi53dkKf3hoF2XZhuS52tDmwW7BDoGkCqDGUUuZR	1440	1011	93	1	6301	jxeDWDih8k9edT2CLb6JKNCV3jiufwsNFeYT3wHcQExuCz2tReM	4140	5841	5841	1616990580000	canonical
7989	3NLjwwtEgHPJ16aWfnAm4cdedsAkdkmhdajTZrPFUtV79JtcNNFD	7988	3NKB6Em4bye2d5hAM6LRgWJCLbK1dEp2d4dW68ZmmoUULJ7GP2nu	1407	1395	93	1	6301	jwZTwry6wy2NNPwkMmP8W8rVzu4WHJCwcYVAzsHGPkh7fWuRDX6	4142	5846	5846	1616991480000	canonical
7998	3NKziHm8eiE2AY32tFSjpEgDT36PFd5g7YpPJe2iUo3bYdcSLpZL	7995	3NLkWbieCzfnaeaAmS1bJWiAudgqiYdXsGFkqnBXfWqSkLEJGP9r	1407	1395	93	1	6301	jwZjFYkodL523ZqRotA57eq4yGxVVWxHNR6YpAhFpRsiqdPmzeY	4147	5853	5853	1616992740000	orphaned
8006	3NLhYpKiPELj8YArcR3mokiaCYxPGVrfgdqFfPTz3TjM6KjRynFR	8000	3NLuFC61xdBrpbh8FnuHT6xBjvWxh6rpfWYzHHgNoE7XZzKZogwn	243	243	93	1	6301	jxoJW8JxTFyLGrjhneEWou9Dec6XV5g5xe828FAfiCeZhLHBdHR	4148	5855	5855	1616993100000	canonical
8008	3NKBtrPTbndQcBwQZ6qPKyd8wNTpAaq45ySPEGupVsV9PyRmcoFM	8007	3NKUsNxYdvmFZ4eHAy7rgRA3EaFgsFdb7DnWskmz31wTAcfQMa8t	1608	1289	93	1	6301	jw6nUkV4xyt6JGWkjPX5Dp1P3uCBG8jQ3AqHYkc4eptWCNh5iA9	4150	5858	5858	1616993640000	canonical
8015	3NKAvZsZ4gDNZFEDXpZ672wJjy7PDg48hco82cNsJreRC3fvk4Vm	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1440	1251	93	1	6301	jxVQfscs73qzJqjZ9UndpDcD87EWBbUnL3Pcc63RpYpkczd9Kdo	4153	5861	5861	1616994180000	canonical
8012	3NLoAsKA6qJm5NMHcD8KaMgXb8Wxk35RxwkF72aq7iXrzBFcs4BH	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1673	1368	93	1	6301	jxJGCVtHbGEZVWh238MqNmPjQqGmEo2TaSVdtyqEF5uGsgRiG9g	4153	5861	5861	1616994180000	orphaned
8014	3NKryhMCPn1FNZoTpSYS45TVdPFbnJjvcLW3yFat66RVrdfurqvj	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1517	197	93	1	6301	jxQn33sJoxFxbwWp8WVi1oez89yC9RavaNNg5SLtHP4FDqsHMZ2	4153	5861	5861	1616994180000	orphaned
8017	3NLZGH5cWUz6zs3S4bUQikje76VhtuF6jowevdKnQERqMU3Ukzh5	8016	3NLBW3YoAAN42NWspBfFD7uUqgCTuEd2Zr9pRx82XS2jG5KAM7kW	1560	1165	93	1	6301	jwMNiGuu7KG1XByB1p1WQNHBb7qJL8f9q7J81pRkjVtNfhfxZca	4155	5865	5865	1616994900000	canonical
8018	3NKQdnp9xS1oS98byBtkXWLks7cRXchQiZzPmzCiNQPqp8z2toBx	8017	3NLZGH5cWUz6zs3S4bUQikje76VhtuF6jowevdKnQERqMU3Ukzh5	80	907	93	1	6301	jw9DGPdG92uYKT3Ab56VC9tEoxBR9VnjjVTi27WmCK4Bp47oDax	4156	5866	5866	1616995080000	canonical
8021	3NKyYM7gGXNWTAXbD19Pj9eERy55gMmEKue1q1CFKK2WpXaDCjzo	8019	3NKRTzAbjrkqvSWEawezPCe8vsH42VvDRR7pcXE94vCmH7AtNJEQ	1675	1342	93	1	6301	jwfk6Jow2aRcjtXkFMxcLWciDmJNmgRrkewTeCE7ns5sPL25rfi	4158	5869	5869	1616995620000	canonical
8020	3NKtvuhwFGvzCuoYszaTfvZeoMkdKZruFtpXhp8kBNznwtJwum1p	8019	3NKRTzAbjrkqvSWEawezPCe8vsH42VvDRR7pcXE94vCmH7AtNJEQ	632	1136	93	1	6301	jwHvMmNGpfrsKbdmXpz2PgpYUHk88gpL61Q7f1o4XSoWyc34uHH	4158	5869	5869	1616995620000	orphaned
8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	1637	816	93	1	6301	jwzZsTDthnKoehVKeQwQXH7igtDSR6JoW1KaHYH5b1Uc4MEbwrK	4161	5874	5874	1616996520000	canonical
8024	3NLRU4VrT8RQC5dqoMaLEm359cvCpDLYiNixwsMSvSJg9rEEjGx9	8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	1509	1320	93	1	6301	jwvQWK6MvxMGRNDpKZqJiZwygegdwzfdPw3DdcARakhi34grxy5	4161	5874	5874	1616996520000	orphaned
8028	3NKkEh3oof6EaFc9Kti2vYzvFvhk68ooxxnoWMvRpjrXFeHp6S5P	8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	1601	1388	93	1	6301	jxJan7Gykg4sWBuUiBqcRsCfjwmXJiCQ6ZEHCuxfUtEhrRnp9yH	4162	5875	5875	1616996700000	orphaned
8032	3NLwKL4t5ZaZLE26qmXiXWCSRekEMwUhAm88XyKGTa4gtkn4x8uf	8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	1523	1321	94	1	6301	jwaqA3aWKMkbZLWsL2kueUWPwoSPfoqYRCWi1DcB5H18DwtAw5k	4163	5878	5878	1616997240000	orphaned
8036	3NKmN4wr4M3CSDxoNm4dCg4PgirFkAfPkRYuPGi8tiQZnXfWx2hs	8034	3NLD1wo1QhM8Q1ChhRaunKKznTvF8ji8H9Db6dV64hS6cZuLbwBk	1457	1025	94	1	6301	jwaJv8qocdaks9h9S7W5odioNHXqdSLVXT36fK2twip5LQ3k1SL	4165	5881	5881	1616997780000	canonical
8043	3NKPmdvB6gGTJeSjvytPx21UK5ZHhkToF9d4Xv3Auun6B9qAW3FP	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1534	1317	94	1	6301	jxY218dQEHsXBmvqAuXEd7G1SkuygUtFBNpSgwefhcBHSyvp7ZU	4168	5884	5884	1616998320000	orphaned
8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	8056	3NKiASiDTfSALex56aiU9yfh9tcQJXS7NLQQDWwzvnzsxyWYf7zT	1403	812	94	1	6301	jwNPeqytBpRrDLGSen3BYWVaPyGNtJDj27moYDDsrWwkof6ubDA	4175	5894	5894	1617000120000	canonical
8062	3NLPDqT9f5p81NeLXwZviisCFCws3oghBH2rNGnmQVP1dcor7BTK	8061	3NKt2Jtq1X389Ugw9YGN7cpLtbDa76PNtwRPJqE26DmPVtqg4qmR	1406	1393	94	1	6301	jw7XmNWT6GU4vtL17doC4CiShQPkXFKNc7MDCmjf51GmegMm95G	4178	5898	5898	1617000840000	canonical
8069	3NK6AmVwYuPMwEsMbjonhdqNtvFBp8C6As2N82fXsDuDufd3RsJA	8068	3NL88Nxxirtv8LFg3CuMyy5S5aaN13ggaDvXR6zc6vYWAxv2ny8V	1471	1140	94	1	6301	jwxaUU1xoE5eLhTMfEss1UnvU4VKAcU7vLcvmDpomn4GSntLhnL	4182	5902	5902	1617001560000	canonical
8078	3NKq4UDi8AjgvFTc5sMEMz2zsKdUUfLXZH1CYXQ3hrRzmJP6m1TZ	8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	1534	951	94	1	6301	jxcRAhzqxQyZXxDHoMSfKSrM8QbjVustUctHiHNYqYukWRGVa6q	4188	5912	5912	1617003360000	canonical
8080	3NKp442UDLpEjrJ5K6xE6Fi8hHHy1pqstNfgxHPx5pJBhAm6rWUZ	8078	3NKq4UDi8AjgvFTc5sMEMz2zsKdUUfLXZH1CYXQ3hrRzmJP6m1TZ	1407	1395	94	1	6301	jxm559sDVk5MxfqSw46ZLF56r6ii6f6axEmxwWKBfpnuJNxwYGs	4189	5913	5913	1617003540000	canonical
8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	8086	3NLp2QnSkhtRpyVm8JoC5jCQEDe8nFjYSxReMQviyjnTD1fcZ1V3	1471	1140	94	1	6301	jwU7XjvLXrqeTYmwRFymz6Teg6Rhc5CHb7NRt9rCsmVDkX4QoVf	4194	5918	5918	1617004440000	canonical
8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1402	868	94	1	6301	jwCDovxbpptEf37R6HYbxLycUh8K37vdHQV2YouJvQJuBN3bE2s	4196	5920	5920	1617004800000	canonical
8098	3NLEMuZAAEbmZyYC4fginpAdVkm3b4rsMbevFFfZq7sA42qg3pxX	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1631	794	95	1	6301	jwznuLP8HWj5S6u2YQXqAXAwdBBawpWQ9BgoyPjbhGZzPYm2qQW	4197	5921	5921	1617004980000	orphaned
8101	3NLNcVGTZrQAfJs7rv89wEs9nCTzWQYXx9HiyktQXgYF3dAu4f9F	8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	1642	1241	95	1	6301	jwS4hBh8jDVrH24BbT365q8wr8G1ZBK59NbWgnGSAsA9diLYfKV	4198	5922	5922	1617005160000	canonical
8103	3NKnd4oigxrnaHLjhV63FduuRHAeeAEJ5zMJCdwRj7XTMQ8s28bx	8102	3NKMxaTHP8F3LogWxjHYMES8huCe9qaAuoeMg8Jz3RfTsV9Wq8qS	1406	1393	95	1	6301	jxUmf4bWEAj44xRMTxLXfx6bEZUHujnKPPQJ2Lp1N5WFKcPARuG	4200	5925	5925	1617005700000	orphaned
8105	3NKzHaojP8JA57ywbqdcxmmZgB7YusZBV9m9sQs7fkhpweifEfBN	8104	3NKVyZkwc6ZqyZU7q4judUTd4TvkMymewKthakvhADN94FzetG1u	1541	1298	95	1	6301	jxRpK78mnMe4kyMUyEg1BfMp84wW6xPxrjHg6rQ2bsbF5ybGezv	4201	5926	5926	1617005880000	canonical
13671	3NKi8TSNdNWrxTMpt7hReCuZTnVzNmurNkbaXkLq3JWYWttu3vdC	13668	3NL1M2xYR22S6gyzmutK6L2JbMXphD1mcLsHoEn4t2EF2xZVYM5m	1444	1381	206	6301	9881	jwLYwsHoUZVH2BEHuom3FizKGk4HCuezmcr95VjsVMpR13LLzz1	7024	9934	9934	1617727320000	orphaned
8010	3NKaByVoDkgAHjxyS94J18yfm7Th7tcDm1WoYn6viFx9X4Df838t	8008	3NKBtrPTbndQcBwQZ6qPKyd8wNTpAaq45ySPEGupVsV9PyRmcoFM	1613	1103	93	1	6301	jwo3pskNH4etHnErSrvZ83TJoWzNoEkvUf6Lwtn51dJqoUK9jCr	4151	5859	5859	1616993820000	canonical
8013	3NLFCrWZFZUEHTGD6tFmX5mW1o8BmFiD3WfXNMBRrELYJ6iY8Lmd	8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	1460	1324	93	1	6301	jxwZCLGD7ktBGUGeGf1tsZUwMCFvkD6YMoAyAy2SKfE1K9fBJSn	4153	5861	5861	1616994180000	orphaned
8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	8022	3NLLVfA8ztbpGFxfdRrmmzh99UAXxZHSn46VWiUftaLVo8s3Pwtq	1483	146	93	1	6301	jwR2MTzNxmLwTdqHj9ijnAeYn4hhc7oNCf2he92ybP4aVbBUaRD	4160	5872	5872	1616996160000	canonical
8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	1523	1321	93	1	6301	jwVB1gJnYaow96xaPDdYaJDHSccmPC7J7TuJitH4aUrfsTZgvj2	4163	5878	5878	1616997240000	canonical
8033	3NKUCKCHhAJFgVTAmzTNakJGMbxwC838ZGUeKRwaTFi4J2xYGE9x	8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	1407	1395	94	1	6301	jxD8paqT4a7dzVjr7HFDeJaVpDgbjYHn98NeTDHXvdmxnFFYFj4	4164	5880	5880	1616997600000	orphaned
8038	3NL4jPQyJpi6YJbrGp75QpyKvrns2YxjHWzDTqdqkJsjrZLeEDE3	8036	3NKmN4wr4M3CSDxoNm4dCg4PgirFkAfPkRYuPGi8tiQZnXfWx2hs	1405	867	94	1	6301	jxHE1yJNrD7FhBnYHtkbYp7aiDNiiZELn8BMZAzhXQJVrHA53wL	4166	5882	5882	1616997960000	canonical
8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	8038	3NL4jPQyJpi6YJbrGp75QpyKvrns2YxjHWzDTqdqkJsjrZLeEDE3	80	1027	94	1	6301	jxYiokxzsB4Q6LiFYfHWBuBunUDoCuMr7T2HG4btmmPgtDAQ3q3	4167	5883	5883	1616998140000	canonical
8042	3NL72yg72kBVADmbqRwZA7LpuCd2FtkLp9Xjz4M1QDj3f4DXnvEN	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1455	1206	94	1	6301	jwjFkiJKK4TH79Uu5cNtUFHRpEpfhtSMwmZ7pU4Bnj5AHaEcbNS	4168	5884	5884	1616998320000	canonical
8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	8042	3NL72yg72kBVADmbqRwZA7LpuCd2FtkLp9Xjz4M1QDj3f4DXnvEN	1581	778	94	1	6301	jwTjBEbfY9yaqCJqXfXq9AHr8TjK9L63KdA1uRHgg7M5P4seDPk	4169	5886	5886	1616998680000	canonical
8050	3NKhXWq1SMqQedfvsNBehf97UniZ7a3L6ZLTviXnFpzkod7iwSLx	8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	1402	866	94	1	6301	jxuz9N42kfqinobwGGyrLMZbQETv2xy5e2LdhPW27CzThJzFk8s	4170	5887	5887	1616998860000	orphaned
8052	3NKfjfpYp1XFjRrWomFw9F1nq8TjWpLQTBW9ACkpau1YvC2aDR4N	8049	3NKCZV6DWpPj4dXqbpzgSnrkxkeQH6NQNqefx38mXZQvunyFtRL6	1559	1107	94	1	6301	jwXeWU7s1G4JyK5g6mAGnFgrs6LFEndCKTvFoLsZX9ZksfBC448	4171	5890	5890	1616999400000	canonical
8060	3NKRicEAwxbEvdYw2vNkqobQ69obRdpCmgaDRRD6NUwkETQ5KtfV	8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	1553	776	94	1	6301	jxCLNtN6FLALPEy723PQYpagEZY3L4ZVezfWaAaLvJpBqDhLRMS	4176	5896	5896	1617000480000	orphaned
8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	8062	3NLPDqT9f5p81NeLXwZviisCFCws3oghBH2rNGnmQVP1dcor7BTK	1406	1393	94	1	6301	jxBve6g3tVh51sQTewGyZRR2tPd2zevtm67rCvQ8sVMQuUrXRrz	4179	5899	5899	1617001020000	canonical
8067	3NLZNMUm29LZ43cNit8LB3sRq3zPbfAuxirPCsTpYSt4KobWVHef	8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	1483	910	94	1	6301	jxMV36K8PvXdrGewa59Dfe1rtrBCAoNt4P3aNrwcj2vyLD4yb5d	4180	5900	5900	1617001200000	orphaned
8072	3NLS9nZm5jUzrAopGQMNkvpPjYxoKVaFtmmBEPbLqRm4ESiL7ukJ	8070	3NKavsxfv8X7XeaUuUG9wNADfUe1rzpFiupuKZnu6jYzJMWRjEjo	1403	824	94	1	6301	jwL5aq5ixCCwd8kQeedseMj6DBaEyupitVUPzB8AiCLmu3dEEAs	4184	5906	5906	1617002280000	orphaned
8075	3NK7NnJowaYK1ok6gL6Jer18BwfBCSbntstmjcibn7dFENfALi3d	8073	3NKExeRRKpQ9MFSXYES2Yr5yktWkDuV2AtEU7QeGv3Ad1QScPoBD	1657	1344	94	1	6301	jwQEFQxJ9FzgZb8K7NcQFHaQ3iwMFguCZq9B29gsSVE6kzgaWqv	4186	5909	5909	1617002820000	orphaned
8077	3NLEkmapuzWHYgaQtZdUjP6SBS83aZM1Zm9XYWs5AvL7LK7xr6E4	8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	1407	1395	94	1	6301	jxWiR2JGuLSycyoeDR7tL9qkbyUU1zU3qY88Te38ZiNVTkBD3zD	4188	5912	5912	1617003360000	orphaned
8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	8081	3NK5w2Z6pv2B4VaonCSSUGsur2bYofyPTXHpdTWuGpj3jRryZEFU	369	1066	94	1	6301	jxe8vf8ZxGh5GsNzeut2Zj9qkHpKpG9wz1GLnPQskVuJaR3vKPY	4191	5915	5915	1617003900000	canonical
8085	3NLefGSrQjhTCx5TNEhyDgN7eB3ZRZ3yv5pjFay8AiEpkrVaSdFv	8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	1523	1075	94	1	6301	jxyTLGzxdr7si1F8o7fnAx93kYpb3ob6rvVtvPUDYLgXDgELf3Y	4192	5916	5916	1617004080000	orphaned
8090	3NLdsttVs7WMpEQQAU6iHppa3CFPP4XEBLKWGYFdw5DQCjBJdaRv	8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	576	1355	94	1	6301	jxRoXxVFsXC1RdhWupfN7qQK4cQvwdUcc1kr9zYHG929yUkyJuZ	4195	5919	5919	1617004620000	orphaned
8091	3NKvtZk6gQ5QWF5BL1Cxb8MBMoZxHWjV3jaqNrjCKPRj7Ezoc9i3	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1406	1393	94	1	6301	jx6RVNgThu5iKA5Mc4VHTzUJoaAJjULXuGcnMAVrvdo7iPi66bR	4196	5920	5920	1617004800000	orphaned
8096	3NLBMFy6CBDYjcSXis1WZPKzdti5wo7kzWPFfzUJCLJnpgqFhuc9	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1527	1047	95	1	6301	jxMcoGv8PsJcpxrHrRUjVypdU53f9Yg2UwR4F1FgtwRRLBx1Nsq	4197	5921	5921	1617004980000	orphaned
8100	3NKXJG9DapZCXgPCN7zwLF5zSuKmvgnyqVHsBDeniwNknqnbFxVw	8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	1581	778	95	1	6301	jxcstJEk6ykcH88M1F8CiaTrKvSh1i866NhGmwJLfRToGWWKovH	4198	5922	5922	1617005160000	orphaned
8119	3NLvqFDfzVj2vaJuBgDqEMQ8ounJFWBsXDqsRWVvHNo6KDYgD8s4	8118	3NLgurRsuMrXf6YWByqehUAWoghwXpCb5bwoJ4vhVNhZZHc5gpbc	1406	1393	95	1	6301	jwz3firWt1VECWwusL2sWB2Eb6E1A4aVuHQoUmxwAijcnqVMcWF	4210	5941	5941	1617008580000	orphaned
8122	3NL9Fhow8B1fX2Vde9WREGsU2jgGgFBVhyg7vLFzjA6xKUAxxaie	8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	1403	782	95	1	6301	jwLpNMC3189iRrF7URKQsg8azsz9s2AcQgt8DF988qrNxmv3kYf	4211	5943	5943	1617008940000	orphaned
8124	3NLtSTuHG76aULofk9k1ZoUdHgyuq96YA8gU7Rs7GdtN4LJDQJo1	8121	3NLbW8DYUW19N1jXTVbkxyrGRLA8LzMKbGha2K2T6D3qK5nmL1LT	1610	1068	95	1	6301	jwuJQY2V4NQN7BDXjcPqHBWWEP94mgji1hY2y5NUHtCeqtSwG7S	4212	5945	5945	1617009300000	canonical
8130	3NKPgS1wKn24tqLUb235qcqBtuyUFVRmRkbpfgeoNmURbtXTLFa4	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	1403	824	95	1	6301	jxJShw3afUF3Leqmq92vqc5YtCpc2S9eMdAgTtgXWjh4N6efFgm	4214	5947	5947	1617009660000	orphaned
8134	3NKsgfTWdh7EpUvV1r6dSQo5poNoGkfM3GM1897fmij1ZiFtRyHT	8132	3NKY2Ctj8g1e9aU6eD7dJn4USgCg7zWp1DLEGZ8re52UzvKBd8Fc	1631	794	95	1	6301	jxqGC9BkKrekofzbZXqbr9DScvw5DhyrbBCnHPYgN5yy65gR9R4	4217	5952	5952	1617010560000	canonical
8136	3NKeLLjh9aPCnePEJgML5wUhsoMRFGDU7mJGGht4Z25isngekV5N	8135	3NLBTPDRkHPfgvUEhEmAhuN2fxGmTbFHt2HWSppaWNKSJzqXsbak	1656	1097	95	1	6301	jxSuS3NFifdd8kF1cxvKBgidyTfLUC1XwQ5yCCP1pK7WPZniBpy	4219	5954	5954	1617010920000	canonical
13677	3NKudt8L3nPnNboKqo6JPg4TEqFfWzH7LXLf8MekUJyjqLyjfuGV	13676	3NLCVSFEh3SzY37Szqrp6SoGX1iNsnhzgackT9CX4RqZ6xyPtEcB	1466	502	206	6301	9887	jw8VQ8fmNBrdfQ3GUfss6T4sZ9Lo6jNRrCt2iqwvnVyvmwKGroq	7028	9938	9938	1617728040000	canonical
8011	3NLGi4JSEK9HxjYc79dihUZWt4KMirxRJSkwWji7fQtxrojxCFnm	8010	3NKaByVoDkgAHjxyS94J18yfm7Th7tcDm1WoYn6viFx9X4Df838t	1671	1365	93	1	6301	jwBht7wN3JX3Uo4gAXqqx5zLFzHSAd1fC9p5A3hmcsBr9eQU5kL	4152	5860	5860	1616994000000	canonical
8016	3NLBW3YoAAN42NWspBfFD7uUqgCTuEd2Zr9pRx82XS2jG5KAM7kW	8015	3NKAvZsZ4gDNZFEDXpZ672wJjy7PDg48hco82cNsJreRC3fvk4Vm	563	1233	93	1	6301	jxKsdUNyjL9nbmYUsHYN5TbjBXS69t36YNCfMWDiNT3tjkVgyr3	4154	5864	5864	1616994720000	canonical
8019	3NKRTzAbjrkqvSWEawezPCe8vsH42VvDRR7pcXE94vCmH7AtNJEQ	8018	3NKQdnp9xS1oS98byBtkXWLks7cRXchQiZzPmzCiNQPqp8z2toBx	1406	1393	93	1	6301	jxVZWf7uqcdCgC9L3burWbSpZwfwRRbWJXELeLDWyX4GVaUiQHC	4157	5867	5867	1616995260000	canonical
8022	3NLLVfA8ztbpGFxfdRrmmzh99UAXxZHSn46VWiUftaLVo8s3Pwtq	8021	3NKyYM7gGXNWTAXbD19Pj9eERy55gMmEKue1q1CFKK2WpXaDCjzo	1440	1131	93	1	6301	jwKBENW28LqsxF4NDHukLsBZLp1nFR3weM59W7GZFUaDXSjY5gn	4159	5871	5871	1616995980000	canonical
8025	3NLUQUmBMYGmwfkAdUDuVUG5AtXsuhLaub49NBNBFUHL7zxhtu16	8023	3NLYDStrvSAByY8fkgYyMR5txHnQTELizQtx495KSGcgxiN2qj5w	1652	1189	93	1	6301	jxskaMoVskBqrFaUVz7BN8ARNgMiEWk9X8Ff9TaWN2E5Qa9yVo9	4161	5874	5874	1616996520000	orphaned
8029	3NLAwWyjmcRKKDoNrH3Auc9prqSVvU3hk7hjWqXh91eacGCKycbg	8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	1581	778	93	1	6301	jwfSB2RmJxR337XmbG7i3pNTu6KwNxGtNfctbvJ7Su4LfgpNqUg	4162	5875	5875	1616996700000	canonical
8027	3NKWKiX8C4vJYyTxX6muZXeu9UmqpAxWQp71zArWfnLekXJ9YxQe	8026	3NLRHnPiVqscWMP5Ky7oKiQBN8PmdmJY5arhovUs9Efg1za4tu3N	1546	973	93	1	6301	jw7xUs7rUFfYiRxKbDrZ7JatsodYsecpUUDbFYz6spASiLgfFJd	4162	5875	5875	1616996700000	orphaned
8034	3NLD1wo1QhM8Q1ChhRaunKKznTvF8ji8H9Db6dV64hS6cZuLbwBk	8031	3NKFrwkzHWqZKbQrvRT9s9S8YUF9tobBKB8B8qVs7ZwJjkxgmQ29	1402	868	94	1	6301	jwnTMxtumkdep5kkpxd2nU7zLVDxJSHP54FpKwK6a7mpxw2Wyh3	4164	5880	5880	1616997600000	canonical
8039	3NK5Jy5KqGfEcjJjmJz35sAsZQnJUJWh2417aksGNaAVRdXWzkTc	8038	3NL4jPQyJpi6YJbrGp75QpyKvrns2YxjHWzDTqdqkJsjrZLeEDE3	1406	1393	94	1	6301	jwbBKo3DyPqqk7c2ZCY7t3L9hENRNXgbgneFsatXYxNJoH6Fwwf	4167	5883	5883	1616998140000	orphaned
8041	3NK4JBsaqj9PpvgFZYMMNw5j4YtQAitpUipNXgn7YuHrcqsh4x8W	8040	3NLyKXoDGE8YqzW9DJBPsBsHtQuJaqREDkJaPNhvxfXxCWiJ8gnD	1406	1393	94	1	6301	jwursEygpNLq5g8FysHDot8EPFUGSdjarcTzaSEYUmwetMGK7BP	4168	5884	5884	1616998320000	orphaned
8048	3NLW9Z9jHr6Rmf62iRNgszZUpSjiLD9y4hRYFyXLVtTiqb7x4Zyu	8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	1467	1376	94	1	6301	jxJEQdWnDWCgHvhMZ5nFNb6EZzuG49VJ6y9Nt2722gv5jMwsMvg	4170	5887	5887	1616998860000	orphaned
8053	3NLhvp6aYvtFDnqwywPxdLiYRsaAnyV4nk3YCZu3eGWC1euJSwuD	8052	3NKfjfpYp1XFjRrWomFw9F1nq8TjWpLQTBW9ACkpau1YvC2aDR4N	1407	1395	94	1	6301	jxswDHhviZ4H4hFAV8hUZoT3gEVHJU7LvDKs4kMKZkzdtG28WpD	4172	5891	5891	1616999580000	canonical
8055	3NLqLKpDDy8JaY63p742cGPkr46j1PaGhMziAyLGqtk2PpZAVBeb	8053	3NLhvp6aYvtFDnqwywPxdLiYRsaAnyV4nk3YCZu3eGWC1euJSwuD	1657	1098	94	1	6301	jx1uUcC2XcVyFGY4XUagzy81NLuKLYYL6PLs6N9CpBZ8vvstibZ	4173	5892	5892	1616999760000	canonical
8058	3NKYYUFHrMx4D2M348nHkAc8iruxXbAibaRGuts8Whe3qugBaMQM	8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	1549	1116	94	1	6301	jxC8QRSjkKwAbNBiKqbXfUJdQ69KfSbiteupiTjNWeBppm4g8Jy	4176	5896	5896	1617000480000	orphaned
8063	3NLwjioEsVvWGanK2B6EqZJ3A7cWtKjRdyoEe6T5Ti9DkJBk6VY2	8061	3NKt2Jtq1X389Ugw9YGN7cpLtbDa76PNtwRPJqE26DmPVtqg4qmR	152	152	94	1	6301	jwTicfyji9an4QbJdAUekyjVn53zjd42ub3yv7NLkadx5VG9Uud	4178	5898	5898	1617000840000	orphaned
8065	3NKeWBzZAhYxv1KyADNBeACxNqgKx6upbYCo3sEb8uPds9r433Jq	8064	3NL6ZanntiyQ7AuxtbPuUmMeU45qve6hwKsCJNXQ96KG45dbTvTM	1406	1393	94	1	6301	jxdAJjpoGaNia7WGeonaM3ZrJZqG6tJsScRa2iPUua7ioyPNvn8	4180	5900	5900	1617001200000	canonical
8070	3NKavsxfv8X7XeaUuUG9wNADfUe1rzpFiupuKZnu6jYzJMWRjEjo	8069	3NK6AmVwYuPMwEsMbjonhdqNtvFBp8C6As2N82fXsDuDufd3RsJA	1564	1338	94	1	6301	jxCVCq8wDVMukJ4TWAxLpaK3YKQ27J1iRXVy6DXMdcHB7TvJnaR	4183	5904	5904	1617001920000	canonical
8073	3NKExeRRKpQ9MFSXYES2Yr5yktWkDuV2AtEU7QeGv3Ad1QScPoBD	8071	3NKUnpD1GK33dH7dQE9qLuN1VjxUp5aLiZ4oFzaHwyzGhcXZYJCU	1440	1131	94	1	6301	jwfwZQGmL5BirwcdUDtvnKY9aJCByCjWpXmCSQ19pf736oeAaSV	4185	5907	5907	1617002460000	canonical
8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	8074	3NKG9nxVwoLrXAmwJKCDTqEZ78e741HMsvxc6UVMTWQRdMeXJBAe	1610	1188	94	1	6301	jwXQCRxAobjQB3Rh8d6hyiLVEF9AzmxMP2BccCHwVh33pS8rzHW	4187	5911	5911	1617003180000	canonical
8083	3NLidx2BKZv8ouh6Mw4smGwJuEsyybucpjk43M9gDu3V2Hewc2HX	8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	1523	1075	94	1	6301	jxLdAPpUL16C68kxmZ7S8wCysTnSp4biJ4Cn4MLUpxiuVG44WXG	4192	5916	5916	1617004080000	orphaned
8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	1460	1324	94	1	6301	jxqUsnRBDGu8RMiheZPJdHoZ1u8zPhuVobPNzwsKuxoYAVYaUoU	4195	5919	5919	1617004620000	canonical
8097	3NL5i62cJSvxQhNf3sUmrxJh3HJJaeFZBFw3iiBhWFYXzTfnBru4	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1527	1047	95	1	6301	jxMcoGv8PsJcpxrHrRUjVypdU53f9Yg2UwR4F1FgtwRRLBx1Nsq	4197	5921	5921	1617004980000	orphaned
8102	3NKMxaTHP8F3LogWxjHYMES8huCe9qaAuoeMg8Jz3RfTsV9Wq8qS	8101	3NLNcVGTZrQAfJs7rv89wEs9nCTzWQYXx9HiyktQXgYF3dAu4f9F	1547	1012	95	1	6301	jx7yv4MLWuAESatCUHtex5yK7u5NtPiHTTS8szFV5Kby83Xqskv	4199	5923	5923	1617005340000	canonical
8106	3NKkqzzGVgX4HPzdNswXxApgg8nDuUWi9vsfjhwRmpJaBPuBgwHg	8105	3NKzHaojP8JA57ywbqdcxmmZgB7YusZBV9m9sQs7fkhpweifEfBN	1467	1376	95	1	6301	jwTcHWTmhL3xNeEUDy4mcbSk2ddwUHGhwjgvhtRvW6Ac4YYvN36	4202	5927	5927	1617006060000	orphaned
8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	8109	3NLj28YXJFuatzecsZKAntZ8P4aGT3YQXTYdkDNaZ23ALhm8bt5x	1474	1329	95	1	6301	jxjtoZBY2P8SJ9ZajCeotiFs2Ktu6hFUDXeRYEGtJhmyWPrDT7k	4205	5931	5931	1617006780000	canonical
8113	3NKs5yh29ww3z8wwAXdQ3aVBvdb7NRNafcPrU3v5SzpzLy8aCgE1	8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	1558	342	95	1	6301	jwGffhrKGbcvXaGeynLSiv3ZsEWb9kFQVt5wBU1dw3f3AtaWy7k	4206	5932	5932	1617006960000	orphaned
8117	3NLFCZWBVreeCSya9ziiyhp3nYyQ3w53TSEtxg2yirajbaXtkS9x	8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	1631	794	95	1	6301	jxqPCK6giBsLmy342bcY4Zr3TvZEuZmQaVXp4KQCXPPcLVRbYTB	4208	5939	5939	1617008220000	orphaned
8118	3NLgurRsuMrXf6YWByqehUAWoghwXpCb5bwoJ4vhVNhZZHc5gpbc	8115	3NLpDC6CHd47wxDkFVSzD6jSTEaLUptbPXCfMND8xXhZtyHwT9y2	1445	1290	95	1	6301	jxdpkpg6Jh1QUwKLH8io2aNQprLXFG76DyJSKV5fEcsUhC6Xfme	4209	5940	5940	1617008400000	canonical
8121	3NLbW8DYUW19N1jXTVbkxyrGRLA8LzMKbGha2K2T6D3qK5nmL1LT	8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	1578	1296	95	1	6301	jxgfbTV8cdqqYFWtkj6hjDgDUdHYgC1fZrgc49MvgX6pfsbs5E2	4211	5943	5943	1617008940000	canonical
13685	3NLjdgQRa6WsUiGP5s6go4ohgYGqvgEqLEAWMdjeTxey4iRtaixb	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	1490	1274	206	6301	9895	jxp1uzDWAYZ68MkrK2AxNauLHTsc4cCUWphJPK4McjYDhF95ASt	7032	9944	9944	1617729120000	orphaned
8037	3NK3vrHNb17QRrTZHzwXZBGYCcLJFG64H2JVaoJxsnGsb6CsKTi8	8036	3NKmN4wr4M3CSDxoNm4dCg4PgirFkAfPkRYuPGi8tiQZnXfWx2hs	369	1066	94	1	6301	jwk7vEDZkPZ1ZWdux1g4n9eAHmDgHaNFz9zsaBRjBahGHvxgYe7	4166	5882	5882	1616997960000	orphaned
8046	3NLj8gALh1mtqYA4xDN1fTadWwDmEXjoyEdFTCiGsXZ1z2iUoFQF	8042	3NL72yg72kBVADmbqRwZA7LpuCd2FtkLp9Xjz4M1QDj3f4DXnvEN	1406	1393	94	1	6301	jwAyZVef8iiHKx158Q8MxrQ1j5WDMpoZt264qYH3zTYHvXLN4Pr	4169	5886	5886	1616998680000	orphaned
8049	3NKCZV6DWpPj4dXqbpzgSnrkxkeQH6NQNqefx38mXZQvunyFtRL6	8047	3NKs42Kd8N3o2nD77mvBeDf8TCaNsbP8rNsQg35UfAm5yEC8g1zo	1406	1393	94	1	6301	jws45vjwdK9SWJp5JVnLH5nv9D1uw5jH4SAcsQTmCBibVacYPmn	4170	5887	5887	1616998860000	canonical
8051	3NLfiz8hBXRUwyP6VYpaesPX7uxYvtQ41nDrkD4eheVFdQJVr9GM	8049	3NKCZV6DWpPj4dXqbpzgSnrkxkeQH6NQNqefx38mXZQvunyFtRL6	1403	824	94	1	6301	jxnnniDfAXbEqgoPfHQJyT622DLuY9VgB5eJU6K9KJMpUCQbF8R	4171	5890	5890	1616999400000	orphaned
8054	3NKq5S5HcMdvUGjt2R93cWvFUEB1ucCaCiD5wTUCeAVw5HqxVpRe	8052	3NKfjfpYp1XFjRrWomFw9F1nq8TjWpLQTBW9ACkpau1YvC2aDR4N	606	1295	94	1	6301	jw6htQ1ukyQP15Ksrezbdr68oxtZqYvF9GzyrL9cau5we2ga8Gu	4172	5891	5891	1616999580000	orphaned
8056	3NKiASiDTfSALex56aiU9yfh9tcQJXS7NLQQDWwzvnzsxyWYf7zT	8055	3NLqLKpDDy8JaY63p742cGPkr46j1PaGhMziAyLGqtk2PpZAVBeb	1610	1068	94	1	6301	jwTH5PGX9vh5MLAyi3G4fmfStrnwLaRYdQEVrEMq43nJZReX91G	4174	5893	5893	1616999940000	canonical
8059	3NLnVVXYsyVDCtZkbfhMvn3pR3dQVSzVdY4Y5eDz4v4bRsahEd14	8057	3NKhFhYfV2krMS1WKUMDFfx8VBpm6EpxwdNPQRibirgPxHhEHeRH	1458	1323	94	1	6301	jxk7MsNmyTRL7gTZxiNRyJc5mLsPvbT2xj3LhUrw87CVZNRh4jC	4176	5896	5896	1617000480000	canonical
8061	3NKt2Jtq1X389Ugw9YGN7cpLtbDa76PNtwRPJqE26DmPVtqg4qmR	8059	3NLnVVXYsyVDCtZkbfhMvn3pR3dQVSzVdY4Y5eDz4v4bRsahEd14	1481	790	94	1	6301	jwMRCo4UtCJL1UK42NmP8wBwJYciQkFjegEesR4nr4JXTz2gMAq	4177	5897	5897	1617000660000	canonical
8068	3NL88Nxxirtv8LFg3CuMyy5S5aaN13ggaDvXR6zc6vYWAxv2ny8V	8065	3NKeWBzZAhYxv1KyADNBeACxNqgKx6upbYCo3sEb8uPds9r433Jq	1406	1393	94	1	6301	jwjNGqLxDhwK1j7iJ9p9SLMLJL2xHAWdPqTimHxVJumWgwyCgNi	4181	5901	5901	1617001380000	canonical
8071	3NKUnpD1GK33dH7dQE9qLuN1VjxUp5aLiZ4oFzaHwyzGhcXZYJCU	8070	3NKavsxfv8X7XeaUuUG9wNADfUe1rzpFiupuKZnu6jYzJMWRjEjo	1402	888	94	1	6301	jwikacac6vxUXCajc9tvqwZ6QxfKroCR1uJAJqzTCZzjLJaZdnU	4184	5906	5906	1617002280000	canonical
8074	3NKG9nxVwoLrXAmwJKCDTqEZ78e741HMsvxc6UVMTWQRdMeXJBAe	8073	3NKExeRRKpQ9MFSXYES2Yr5yktWkDuV2AtEU7QeGv3Ad1QScPoBD	632	632	94	1	6301	jwGvM3rSExfFHfyqPcbUbHgF44NC6hVMQv3ieAnxYxXjYradePQ	4186	5909	5909	1617002820000	canonical
8079	3NLH3SQjHQXtZbYnJXrbrhTBcP8dWBC6q1oRSdG5ePG3ccVWPRSW	8076	3NLoHNwY1uE3UC2Nd4eRXrAmobj85PWHhgDPJ5RFNM9AqYJ1iyTh	1623	830	94	1	6301	jxhVYMCga8GiXvDWk59Aafebit5yC1t6ReRzaVzoojZzERhZ8ke	4188	5912	5912	1617003360000	orphaned
8081	3NK5w2Z6pv2B4VaonCSSUGsur2bYofyPTXHpdTWuGpj3jRryZEFU	8080	3NKp442UDLpEjrJ5K6xE6Fi8hHHy1pqstNfgxHPx5pJBhAm6rWUZ	1444	1255	94	1	6301	jxnrSBZZWrvhphFnHiq8w7cDhY613SyGxHmJTMs4JVJaRgkM7mf	4190	5914	5914	1617003720000	canonical
8084	3NLYFDrGQEtS3T2gimgZy6aDZZtqKruMPe2iW1dVLb3WF5eavSEF	8082	3NKMtynGaF6HXv9RAAMDgPM9KUsxCJBi2N7LfuyZv87cSmqRSZZ5	1523	1075	94	1	6301	jwf6imAhLB5hYb9RVRLWQ2rCmJGwLSQK1yvBvd8RiFgJXRuxdRn	4192	5916	5916	1617004080000	canonical
8086	3NLp2QnSkhtRpyVm8JoC5jCQEDe8nFjYSxReMQviyjnTD1fcZ1V3	8084	3NLYFDrGQEtS3T2gimgZy6aDZZtqKruMPe2iW1dVLb3WF5eavSEF	1593	1100	94	1	6301	jxWu5xQZJQrq5fUrWU2aTSfAvhcMqKNUK8XdkFphZP72DXzRHaA	4193	5917	5917	1617004260000	canonical
8089	3NLCQppLNZ7XTKugfhRKhnRnN3RP2N1oQavKoVP5nRQDp7reAXdm	8087	3NKgjNr6f2N7b5YZiVyKiC1pAw6Ey287iMtrUxrPHyS5i4rH29om	1670	1156	94	1	6301	jxKTMmLBnPYLi8dm4yFqGJQMJ3xZAqUbojppJxRcWgNiWZMZZwF	4195	5919	5919	1617004620000	orphaned
8093	3NLGnyhRU49rfEVCPBDygtWmUthfdFVqCn178WZwE19VzuNPWxQy	8088	3NKPhy4SSqjfD2VGeGA3v9VB9p7gPZ43sGPzzLNu5shFTPaNgNFf	1471	1386	94	1	6301	jwQbwWxH7VuRRjej94gYGJ5S6DbBtTGbBhfreSWve2d4BKJfeGp	4196	5920	5920	1617004800000	orphaned
8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	8092	3NK3U3xxkW3VZZMLvCf9rTn6GAptAryAThPTySfF6Bp3LHugy4Na	1406	1393	95	1	6301	jworxzaCEFXvLwftQzmVLknzrwKYvuJbE4LbD9oHWwsKCc7jiL3	4197	5921	5921	1617004980000	canonical
8099	3NLYSR7P3pupPVQeZwxbzDNpuai989gDhkbjYdvMawkyuhTjGMp1	8095	3NLDXSMkvda8UJe8caG8qNmFVfYK2WfLJ4Fbo1TfowawAEL1u1NB	1642	1241	95	1	6301	jxLuJ7j3uuwm4VfNxKDDyBQcaecDJxKxqXAjx8Fpr9bmdk8arkZ	4198	5922	5922	1617005160000	orphaned
8104	3NKVyZkwc6ZqyZU7q4judUTd4TvkMymewKthakvhADN94FzetG1u	8102	3NKMxaTHP8F3LogWxjHYMES8huCe9qaAuoeMg8Jz3RfTsV9Wq8qS	1631	794	95	1	6301	jx3vTtYuuefsspJFcBUAwDBWbQS8CFBFLsgpJwEizfo9UhN3wQ4	4200	5925	5925	1617005700000	canonical
8107	3NKSDnzAMqbU8b45MPnTy4d2mHUxhjyvnMtnaBypXQMdsomq6xr5	8105	3NKzHaojP8JA57ywbqdcxmmZgB7YusZBV9m9sQs7fkhpweifEfBN	1477	1350	95	1	6301	jxTQ8EzNN98uXgtEjwK7kFB3NxeSnoXsfKTXcoya7fcGEsEFiQC	4202	5927	5927	1617006060000	canonical
8108	3NK9oYAdpJBHbM3tT86a9Un9r2zVGZ6TSHhxFAyPhNnNSetnV517	8107	3NKSDnzAMqbU8b45MPnTy4d2mHUxhjyvnMtnaBypXQMdsomq6xr5	1406	1393	95	1	6301	jxnoY5syxmLX83NXjtSEkgTxQhAvMYhaBLMKocgyXbTjRtzLa25	4203	5928	5928	1617006240000	canonical
8109	3NLj28YXJFuatzecsZKAntZ8P4aGT3YQXTYdkDNaZ23ALhm8bt5x	8108	3NK9oYAdpJBHbM3tT86a9Un9r2zVGZ6TSHhxFAyPhNnNSetnV517	1637	816	95	1	6301	jxDLwwyJHzjV8joBgLWeawaENeXPVpoK5UCPyXVnLbKrR7SfnyK	4204	5929	5929	1617006420000	canonical
8111	3NKjsng3xQ6b5HWmiBXBvsirGHWSx6pnz62VT8uq2DSmULwa7dzR	8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	1403	824	95	1	6301	jwUH8Kjtt9NHNSPFKT6hsZsAGJnxCitHr2CVE3a61X5aBr9XXKP	4206	5932	5932	1617006960000	canonical
8112	3NLVnKUsAdpoLiHjBxCGqJeaxYwYAkeghrXzdXd2PFbDZ14rpZZB	8110	3NLYJGxRpbHjQL5AcHzCDh1hSW36oXpxo2sy49V4jG81t6skvmx3	58	915	95	1	6301	jxmp5rH9MNGyvNnXE1PBWpAUCf3T8B4heLgGmsbZZhhPvgYzGHH	4206	5932	5932	1617006960000	orphaned
8115	3NLpDC6CHd47wxDkFVSzD6jSTEaLUptbPXCfMND8xXhZtyHwT9y2	8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	1489	1254	95	1	6301	jxPvLmPNR6GKSY7unzoyT772GTDQzRwX68W7ShocexKC6e6Mx3A	4208	5939	5939	1617008220000	canonical
8116	3NKgryiQ5Ek4YJdhRk8adanRxEByMN72boZ196V3aAvWiBPSTKUL	8114	3NKs51Hg4d1HXbETYhaC7iUTEAry1ayGUHeBW3Bs7Nsjm1ePsPjp	1611	1341	95	1	6301	jx721vxk2HEpDpmW9MBQzeWzF4BdbcY5v6GUYje6GTKJ4RyVzmt	4208	5939	5939	1617008220000	orphaned
8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	8118	3NLgurRsuMrXf6YWByqehUAWoghwXpCb5bwoJ4vhVNhZZHc5gpbc	80	1027	95	1	6301	jxPovfuvmmWGFVzfexAR9nBC5M7KXxciXJw735gMisvsgmkmU2e	4210	5941	5941	1617008580000	canonical
8127	3NKHxTfnZ2iQhx8FhUhca64CniYTVehXWyoh5GmMxgyUhozGzE2K	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	369	946	95	1	6301	jxM8VikZRAZyQZAG4oLKgmRy6fWS9RdWQTVfgwNdSPkCMPp2ShY	4214	5947	5947	1617009660000	canonical
13706	3NKp5GWMTz6mPp9QCrp2yPL2LArEzoVeDAmxGAQRdG6wJx3BKvQz	13705	3NKt4su5DQeABTJcCBAnGUkGKLvAvK7LfHtTTAzkLBdPGtBt1vqf	1407	1395	207	6301	9912	jwgoWLDDgSRBDH988nM62vSkG95iKyBS7VA73pRkkq7E1Q28Hk4	7043	9960	9960	1617732000000	canonical
8162	3NKgnFq7xjN64JuxV1ZWFKrTqqCQ6snGD6nw6vyEpLscDr37wbK2	8153	3NLh1BmGjs2z1pLHFk9fuPCjoDMwEQFeX9FbHTfSxjoHLY58nSEz	1657	1218	95	1	6301	jxxeC2eBp476afWEs56jT3L8dpKK25zmAokAKfL5Rgzub8rMKgp	4202	5970	5970	1617013800000	orphaned
8123	3NKf1ndCxupT9kLcgrfthCjwBk9SBJ9GossUhB4vKDxefZYE98rW	8120	3NKPHbJziLDNSx4qKnpDSbn98VGFfmmi8LYgdTagf3raEHFXb9LD	1578	1296	95	1	6301	jxQAGo9LSmgLPgZkC7hgGLyzju3CgdL41Nhe8SmhX1DSKWqhb7V	4211	5943	5943	1617008940000	orphaned
8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	8124	3NLtSTuHG76aULofk9k1ZoUdHgyuq96YA8gU7Rs7GdtN4LJDQJo1	1406	1393	95	1	6301	jxgZbKTb3fytzasBxhWeBSAAeBcBECbyykCi5N7Eehkh6vcSkxN	4213	5946	5946	1617009480000	canonical
8126	3NKb5CnvpqCQZEiBNCJ2MRANhyXhadJBhDoLxsTKFM8Z2e5SFYdA	8124	3NLtSTuHG76aULofk9k1ZoUdHgyuq96YA8gU7Rs7GdtN4LJDQJo1	632	1382	95	1	6301	jxBGDwFrznN98J7GbrEvvH82T5SMj2japgAsAt7Vm8MYyg5UQg5	4213	5946	5946	1617009480000	orphaned
8128	3NLtsVpdaCTcgXi52pwTDkywJ7TKcw3Mk5Hcx6eRh2kPW23ULhqY	8125	3NLbmZnEqnbgCWjTppcJgF7LqWay7SrM5eJjiEtbmCZyJvHn4Tvi	1656	1343	95	1	6301	jw9eqsrX2RSmcjufFre27vdWVm4adJyrN45mtpYvUN9Rv5kqDQH	4214	5947	5947	1617009660000	orphaned
8132	3NKY2Ctj8g1e9aU6eD7dJn4USgCg7zWp1DLEGZ8re52UzvKBd8Fc	8131	3NKErW8SAk71KrAFccsvsfuBRW9wNTRiBjt96qWY2F42xm6WAZH4	1601	1142	95	1	6301	jwB59q49afa2ncbE2m2zrBo3miHEZJ9g54nW3xjvnVEocbgsoin	4216	5950	5950	1617010200000	canonical
8133	3NLMCeAjJPaKgkdFBG8w9gnf8UotT96aR3CLM7azSVggcjABAMJe	8132	3NKY2Ctj8g1e9aU6eD7dJn4USgCg7zWp1DLEGZ8re52UzvKBd8Fc	1406	1393	95	1	6301	jxzi9mNjXovnPMFqrMsF1ZsQFMeGHJTVuMh7mmucAFwYhue3p6v	4217	5952	5952	1617010560000	orphaned
8135	3NLBTPDRkHPfgvUEhEmAhuN2fxGmTbFHt2HWSppaWNKSJzqXsbak	8134	3NKsgfTWdh7EpUvV1r6dSQo5poNoGkfM3GM1897fmij1ZiFtRyHT	1549	1236	95	1	6301	jx39LmYpGF6EXiQMBBdGEN8dotmF9ZZyW7g9Smu9U25eJpoJSf8	4218	5953	5953	1617010740000	canonical
8138	3NKJ5sfqf6afxTczAvjKEwo8Kvn6Wz6vQfbaszRHGWJEFwhQ2MMr	8136	3NKeLLjh9aPCnePEJgML5wUhsoMRFGDU7mJGGht4Z25isngekV5N	1670	1282	95	1	6301	jwYDNy5nSWZ6hHiNNtn8oggF9p6bsvtewc5devVa9KBAG57uRbH	4220	5958	5958	1617011640000	orphaned
8143	3NLgWHLTDAym6tPoaq5RtcGcNLxJYPcpCPPzM6w1D5saVPXTaiF9	8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	1637	816	95	1	6301	jwNDRkSus452eyLMRMurB8iqP2XY9qGRidkYwWhTHDCAiXrriqp	4222	5959	5959	1617011820000	orphaned
8151	3NKVSjyBVMkMXadYVN5XjB5dXf7ThHBmukGdtPrPbkA9Lo7TtkYm	8148	3NKtyUQzf3bStsMzvqVxnWsYiyLi1tQgkiPNH9t6h1Fy2tAqf9Po	162	162	95	1	6301	jwSPFMXx2VfTT8wtjY5bP7vjqJgiZmx2raT5U6u6vbiC8i3y3Qf	4225	5965	5965	1617012900000	orphaned
8157	3NLDmCTjzUVZR8gF8uY58c3WYJhe5cHLfyNnnkBeP3DU9USbnVWQ	8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	80	1273	95	1	6301	jwzwZucaJs3BNihRBUFisSF9adZxkUUbzUdfCDFYB9zfFKmFGLM	4228	5968	5968	1617013440000	orphaned
8159	3NL7nYSihGHKiinCNThcVip5c96sSc2W7VVd9Vh712ZSWedi9qgZ	8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	1407	1395	95	1	6301	jwpmwHrMfkTvBe69Cwcrd2LGhDGk7GdzzudbXNi2zYZCeof7C1p	4230	5970	5970	1617013800000	orphaned
8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	8165	3NLPDWiJFwDUXyz6PgecZXCN6EQ9cQ4LndsWuDWpSBudeKDy95xp	1609	967	96	1	6301	jwZfCripmeG5nwTCJ6nu5HScgzhE8Kp4ys3a8z2enRBWWJS6uko	4233	5975	5975	1617014700000	canonical
8167	3NL6WQF755mfAuhybr3v1DKnTZnU5a8PWvXKKyMgtFVXH4hK6y3g	8166	3NLCHTM8SHypgaYUKwSQUkHRgDjAXdpiREEx8GZRxTPmLuYiwi8v	1646	1354	96	1	6301	jwFreBsFPMEFsnuMjoDRSgS6zwdgoi215N3hTrowxWiTBMuGD97	4233	5975	5975	1617014700000	orphaned
8172	3NLD9ny5CZcRR88gZDmX8sdgNwgWJmServKdD2xzSDXjFbH1BGEi	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1481	789	96	1	6301	jwbia1Zbaf22C8JsJnBHeGFXvTsVyvGC917a1hQbWU9FrGSgcCG	4234	5976	5976	1617014880000	orphaned
8181	3NLCsCNLfD5jiYK98MZbG7WthUVudsBw6mk2f9jY2kuvM4oeNuLR	8180	3NKBS1LR7dKuHHBEuDjxMJemB3Zqvq3uDVzF86kde6BiMt13famR	632	1382	96	1	6301	jxrt3bCLEPJphC7Xj94Kkm3V1pw8GLijUqob6BkYQ7SHBuYBb53	4239	5984	5984	1617016320000	canonical
8182	3NLMzSQ8SoYi6oQ18SCcjtFFxH7YcYrK6dKBJcxhATEJiBbQt3xU	8181	3NLCsCNLfD5jiYK98MZbG7WthUVudsBw6mk2f9jY2kuvM4oeNuLR	1527	1293	96	1	6301	jxeWwwcfGgpfAX4sDMFFhsbHHY6dDqY9VxYRd8qSjwL7ABvPwEE	4240	5988	5988	1617017040000	canonical
8192	3NLRvQ9A4Nky1QnWG8VBvVpEt7ANYdsgVXRUU2F43R6VvPoXGog8	8190	3NLQCBg8xqg9ZQzuuYfxxrxcMzzkuj2upCN8zdwa6PmjVHheeufd	1422	1337	96	1	6301	jw7J4gpGi3hfYTyEBoH13eHQ1wLPxyV8AxQvHj8L52T4oTLx8z3	4247	5996	5996	1617018480000	orphaned
8195	3NKgV93PwwwvT97JG6NiawqbswZWYtVGG6KBPzWQTz8dRkYsZ7iA	8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	1652	949	96	1	6301	jwwx7PjSXDQBeCxaR1iUinoESsfDQaoVePa3m2MCj3qCZicHSzd	4248	5997	5997	1617018660000	orphaned
8199	3NKwAubhEAwzm3vHqXH44kLTD81RjoBXVPjg9ko7T5jQPCdLLUVX	8197	3NKWLh4Z3q4z9Euugi5GD25kAwQHULH48RGgXsHcdVDkLVNx15KZ	1671	1239	96	1	6301	jxx8jeRrA2ff4xQomCJLW8NC4Lq5Z9fR5krVUxcSYPM47H3iSV8	4250	5999	5999	1617019020000	orphaned
8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	8200	3NKCZADDSrDixuT3oTncLex1mmhnWD1fQbdGfZyN5HXp8mxrYZ1V	1471	1140	96	1	6301	jxcwHLbstA4BU6ZcN6EZs5oQLvU9dRCvkBxjDy4yXo2Q6EH1j51	4251	6000	6000	1617019200000	canonical
8204	3NLi3Ji7V2BLBF9D4GPm4t2rq78JqBSAJuhTwn6VzfC6m75rK2dZ	8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	1624	1334	96	1	6301	jwWXHG9qcH9RrYeZSmjiTKkE2WPetZLTL8jdMGMpqpgn1rMppdF	4252	6001	6001	1617019380000	orphaned
8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	8205	3NKVe9xHwxURrwsoKES91wKjvgyiNMEuDPo8JWfUYnw7yfJox993	1553	776	96	1	6301	jwFDkUyyBGFhvqJqtuQth2ACv9gYic4zUsnKVGWhnNcGjx2PG1D	4254	6003	6003	1617019740000	canonical
8208	3NLRuywHWQ7cQuzXDAjz4XEev8AjZQBSjLyYm2vp8wHeEhxEKS22	8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	1460	1324	96	1	6301	jwdAiPhUDYGSdCodhAQBT5aqDBkLEEFoFJjTbJRy8GEgnJMcj3g	4255	6004	6004	1617019920000	orphaned
8213	3NKfzHzJCknehk6CZb15wPV5pMrt3Ghzbu6wkXpHTaAH8SEmVjrj	8212	3NKMhFY9sJ2emuGZTT9ZPqaLqaZhxwKdcRUcBndRCkuXSkojLAMA	1407	1395	96	1	6301	jw8joXXm7m5b3U1NWmWWNjR9kSWceTXrXgLJxkse6ZW3Safurqi	4258	6008	6008	1617020640000	orphaned
8216	3NLEeSYW3v7vkE2c5pHeJNfc4gHLcuqPg6oAd2LP6j6igTmV7cv2	8214	3NKyVeTxYSpn8qX5tQSw85cc4e2s5jNHScvXe1zmA8LaPtBrKTGE	1623	830	96	1	6301	jwKY8RHWKakc3rkjtF2WFKWi7jc2DbdaNdPWHcjvEFcre8EZwKd	4259	6009	6009	1617020820000	orphaned
8218	3NKJvaPqMkZYqKXN39xYWEN918AQtBxctScSZiZRWFJ8618hKQ2v	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	1407	1395	96	1	6301	jx7cWA9Xn5kQMfpX5dau9tPCCT2yXFHgRfaG62yCtAPi9nrZgMQ	4260	6010	6010	1617021000000	orphaned
8222	3NKjEEFk4Nh2dFvYtdBQQDRBYx6pmghiPsLfxu8K88krPPgYeNG9	8221	3NLs5z7qynvXYcu6kLJs3wJvEssaprywoH4AEMrs5jP9UbjdThU6	1406	1393	96	1	6301	jxZudmLBF4LV5TwHHUAKvvSB9FSVRP7cVCWBr4fhQgXDrnbSzpe	4262	6012	6012	1617021360000	canonical
13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	13707	3NLQ2gVZPpvytFuQxo8J27J6nbCUpVZvurpgbPmgi45fGSBG4a9f	1406	1393	207	6301	9914	jxSj2bSpMciUtnh7fR3jxLXFfHfNyykfKAwfz6frmp2kwb3emMv	7045	9962	9962	1617732360000	canonical
8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	8137	3NKGTKNEZ7RXeAJaMX1XSKQJxuY6LW2YJsGK4zCXLt6C5bSpGraS	1670	1282	95	1	6301	jwg3ERtXtKdjc4o4hUzTC6J666DdcVagUC6ZbcwK7y62fUoy1xG	4221	5958	5958	1617011640000	canonical
8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	8140	3NLNG1NNaWLek9HkUoS8oWJAbEkQhVUiJdYKPz5atuc4bRCnqXg9	1489	1134	95	1	6301	jwREwNj8PB1vFM1Ywuk2Qod3uHPBUWrrYY59wLbpCX9fGg7tKyg	4222	5959	5959	1617011820000	canonical
8147	3NK4ZT8VdyQ7TgZ35QjnqnzpP4yL5MRidQG8sshWoLfoP6i24kjF	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1611	1341	95	1	6301	jxAuA5r8G4zMQsgaKJf96jK9PVi8Sy1issdUFCCFM6jgYfjDiFR	4223	5961	5961	1617012180000	canonical
8145	3NK3RyMw27tWU3BiQRNDbqMmsUBu6eeX58TvEvShQyuSUQVwqYx1	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1509	1074	95	1	6301	jxNRm8ga1HLDRya64FYmMqthfu41DRZENhSNW1g2Lq2xkx1pUU2	4223	5961	5961	1617012180000	orphaned
8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	8156	3NKc8Ak4nFkR5yBpSsZcs1g1Rr3WuBQjPe1ce9snYBFjqaiemP1m	1579	1143	95	1	6301	jwvYGMSWX1VZF6vAigzEeeip4xpXzU6onqJZZMyKE5fC4JiB46s	4229	5969	5969	1617013620000	canonical
8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	8161	3NLJWWhSs6RW3nXCfkz4TouDBkKV2zvaQNTL9fCobC9i27SSzXZB	1406	1393	95	1	6301	jwzxcYQ1Db3v13Yu7UcRAnKpFWUoB2UUbEHPiRCxoqPVchv3nyP	4231	5972	5972	1617014160000	canonical
8166	3NLCHTM8SHypgaYUKwSQUkHRgDjAXdpiREEx8GZRxTPmLuYiwi8v	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1590	1300	96	1	6301	jws8UV4y17eCEJuH7XAEpAwk5p1vH572WxN9sbt6NQLdsg116iV	4232	5973	5973	1617014340000	orphaned
8170	3NLHyY8ynjDirA5n24uXnPJjMLN3sGEkcQCnxDNYWV8PWVTLHas8	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1549	1116	96	1	6301	jwMjQ1AXcdC2AW4X5VUcnAWk9h3Z8ShDjTYTJG75jwqgxHvXiqF	4234	5976	5976	1617014880000	orphaned
8178	3NL7VLf7aUSMcJtUXmZjrPhFzJYg3RzhYRCnBqLG5Ls4p4ePFGK4	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	1402	880	96	1	6301	jxmo7e2XDf5BMMHvCCyyRThiLLADLeFvngvL3nGbjjp5WB23BAh	4236	5979	5979	1617015420000	canonical
8175	3NKMyLMP4KwFyYCbtw99RHvMdLgzCeCNJUXCnJ76W7pzd5ZZEM3S	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	1407	1395	96	1	6301	jxSvCD2TNzehMLi2jph6cz1TwfD37UuxmfP3KfGU4o3LtPM6oMy	4236	5979	5979	1617015420000	orphaned
8179	3NLMgUPgT76FPtzDGYoWoPnDmTTWPp7e3WoNWb1TQ3aP4gETG65Y	8178	3NL7VLf7aUSMcJtUXmZjrPhFzJYg3RzhYRCnBqLG5Ls4p4ePFGK4	1656	977	96	1	6301	jxgfiwmxh3uzn1eJJKxTqMzhK3z8CeTeQ5Cr4LXKZMY7r6szRHz	4237	5980	5980	1617015600000	canonical
8186	3NKzVaEFbwtzoiRGzkUMPmKDQHgmQrcGobAFBu2cwf5BAfkvd22N	8185	3NKU6TaNFuZtM6hj4Gdcm2d7Z9GzgF6KQNUv56Ay4K9bqU4a7N23	1407	1395	96	1	6301	jxkTHSXEgbfqFmwAV7HGHg6Sn1W737N2NroDvMqt7sK2bAGWzgh	4243	5991	5991	1617017580000	orphaned
8188	3NLUdnaq8srVtXk6kJdysLE7RqqeZEdDqL663qp8Dk5sr3czd3tN	8187	3NKS3WuHhz2xykrVXMfPwjmipkZozU1WgrXNPJR3FyDwLY65crNm	1624	1088	96	1	6301	jwrybXsb5QhSsGfK6gouXdmpGgPaZKu1XGhPDWuc5owigAdgHGY	4244	5992	5992	1617017760000	canonical
8191	3NLYbWGoSkr2hfP8LgcBTetU1ewi7PSF6F1cajjLSsH8aDBc8UUv	8189	3NKmPTab5tCjnZmCmL5tT8PMzotHD5KKr7vJnh7UqDqDQUt4zZzD	1403	824	96	1	6301	jwpackWfyvY6XseLZi6VeVe9WYKASfxzvyxGiX9CBULUDCp2XFy	4246	5994	5994	1617018120000	orphaned
8198	3NKvz1zoL1WGgp1LBjqNNuvc82z2qjPNppz2jzg2AXVTWn349qWJ	8194	3NKcFVF4wBJw7HsyzUdgwsxix1BpZUjQivchpcdnc54k4AtbgAcB	1406	1393	96	1	6301	jwbUBPDZE5Pxj73TPNygkeqCan2cRzeJRNxRxbEPjzbRPaMuapS	4249	5998	5998	1617018840000	orphaned
8200	3NKCZADDSrDixuT3oTncLex1mmhnWD1fQbdGfZyN5HXp8mxrYZ1V	8197	3NKWLh4Z3q4z9Euugi5GD25kAwQHULH48RGgXsHcdVDkLVNx15KZ	1573	1318	96	1	6301	jwR7Y7oyLumTcYfLQtMGUEYMTKq3vbhdv6dVffmG61vXADhrBZq	4250	5999	5999	1617019020000	canonical
8207	3NLL6LSzXHxYwNYX6dM5NMRNtab4juCG3nUwDYpo9ECNJT8PMMps	8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	1406	1393	96	1	6301	jwHCU1AfERxFu2c4Dq5LpGRCtakx7hkJwdJdhUYjrqgYvc8VWNB	4255	6004	6004	1617019920000	orphaned
8212	3NKMhFY9sJ2emuGZTT9ZPqaLqaZhxwKdcRUcBndRCkuXSkojLAMA	8211	3NLMEF9u1L2Gse5kad7gKSXyQMjZNy9fYqSRKeP3snZfJKWAKvSc	1553	776	96	1	6301	jxBDvKveHb6iGKcFWkQn3rtCs1isiHQK474nyzMg6Lm76rVwLYG	4257	6007	6007	1617020460000	canonical
8220	3NLPAtqmfHJFuyYL5uZM6xrwN5aQybMF1SvSFzbPteqqPLFqUoDp	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	596	1306	96	1	6301	jxy5HGB7SGv5YADy7bYv8U927vvBbvxK7p1b1DH5Uvmw5iEWPqB	4260	6010	6010	1617021000000	orphaned
8221	3NLs5z7qynvXYcu6kLJs3wJvEssaprywoH4AEMrs5jP9UbjdThU6	8217	3NLmovmWHSjCePL1oUixoWWAW8cFgqeAB7MWsnV3BiJQMbESZECr	1652	1069	96	1	6301	jwoABWuDU1oky9SpRqwnaPRq1rBr4SvBmj6Cggn2hhzz4KSeS3X	4261	6011	6011	1617021180000	canonical
8227	3NKbxAgd8XwnphqCXrUUKdyU6LM2dtv6YHREJa78F7TqLx4FZwLe	8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	1637	815	96	1	6301	jxDUwfgjV2kRuM1VTKjTmrvU75ndSE6fTwkeYvprQjjd5ogXJrN	4264	6014	6014	1617021720000	canonical
8228	3NK65Bc8sznN475VUywb5XAdptD1GCsEYkm7eXmv6J82Y6ifAUWH	8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	1623	830	96	1	6301	jxezkyudafWD4v6YKHCCVvFafmdkQjsHUMc4BKvFAeDW1REGZqF	4264	6014	6014	1617021720000	orphaned
8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	8227	3NKbxAgd8XwnphqCXrUUKdyU6LM2dtv6YHREJa78F7TqLx4FZwLe	1406	1393	96	1	6301	jxfwbKv5S6KAGocucpUtVSdVeT7ScqJoHeDHUKtFCQTZMLWRrkQ	4265	6015	6015	1617021900000	canonical
8233	3NLUQCm9SWxbvybQaQMGSBmG52bZDV6WdJ7XFQSbyTQ1VUvPY8z9	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1675	1342	96	1	6301	jwZmsy5mxc1DRzEa4QRDDXg72CjAYUdemfGiAgFPCpYuqZzGCzX	4266	6018	6018	1617022440000	orphaned
8235	3NL3PNhxFQ2bkx3jDcV87rkWvkgsgzXFJecgSTowDoxMD1PdTgvp	8230	3NKybhXxKtRnBzHvta6iqiJ3wQw7bz5WUCZkt4TnKALpRSs2vK4D	1407	1395	96	1	6301	jxLeLeA4RQBbSJvoSBuHfki7z62zmuYkg8PAbsVFRHEYUz3H8YE	4267	6020	6020	1617022800000	canonical
8239	3NL6SqgJbmptoEcRDaTot8HQusP57Yhg4dEaXAfQF24NSpjGDSGh	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1579	1389	96	1	6301	jxCfGD6fPYKnjjppk4nweXJ461FJ1Derd5EJyeFAHPBLCxjJ4qA	4269	6022	6022	1617023160000	orphaned
8242	3NKLUDNr3yvNHToGrav1BGxKGqdu7iRUnGFCEPYPU2fDzf8BySr3	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1553	775	96	1	6301	jwXQLRh5HF8gVwSMfLXroqRBKUR4BTWbf4CuUGgtENLKv5tyGnS	4269	6022	6022	1617023160000	orphaned
8243	3NKP84FmBDq9ykNPQjswNEx9Ljjwg3fkZfiMZAHFx1kdjcJf2c1o	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1406	1393	96	1	6301	jwdWc2zY2KDq6ACB4HTUWnuJPCn7jLWytSfaDvc3WPL3dCLhcue	4270	6024	6024	1617023520000	canonical
8250	3NLCFjVaPbikZFCQSE8iqmYPSqJZizAcLxNAmFJ464R2aN9WYEHJ	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1406	1393	97	1	6301	jy3L7fNJrjkfTfpcjPKhhy7ju1JqHmuzc5Lyw459iv19Rskse6D	4273	6027	6027	1617024060000	orphaned
13780	3NKck4Cdcri8RZbtR3hesSzs39P4TGeQ553LETrtKMEaErEW64WN	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1522	1322	207	6301	9977	jxgMMQUEf8pPEiwbpYcEsQZRS11YAJ2xhVy41cqVAm8bGRHUK2x	7046	10009	10009	1617740940784	orphaned
8210	3NKdNN1mvZMAVYnynJm67CHYcdotvHG9vkAYJCneLmsHMcwhwNbF	8131	3NKErW8SAk71KrAFccsvsfuBRW9wNTRiBjt96qWY2F42xm6WAZH4	1460	1324	95	1	6301	jxY5mviaRHAopTXaLGvqYc6L1wHGf6TSaLwHpcM8meY2a1Ebg9b	4216	6004	6004	1617019920000	orphaned
8139	3NK2yyii56WZM7rqvmErDncqBXhigXWZohczSerGG3VBNjVej5mX	8137	3NKGTKNEZ7RXeAJaMX1XSKQJxuY6LW2YJsGK4zCXLt6C5bSpGraS	1402	850	95	1	6301	jwpaGLQjpH79Zaj2rS9HwvKdBY7KxoPm3ECDUBtHemDJETsBcDm	4221	5958	5958	1617011640000	orphaned
8144	3NKE65LRMgMAq47akCBZkFHxgn6scsC6qAeEZUfFZSKbfgMeq7Lf	8142	3NKgFtk4S1yjjy6Nj1JVKgWQ9ZJU1G2VVmHkxaRjUmBVC2sfT6k4	1634	1205	95	1	6301	jwgW7wR3SkpA6YdaNxYivcagdh65vutnW7TeSbq484Jm4fttFSj	4223	5961	5961	1617012180000	orphaned
8148	3NKtyUQzf3bStsMzvqVxnWsYiyLi1tQgkiPNH9t6h1Fy2tAqf9Po	8147	3NK4ZT8VdyQ7TgZ35QjnqnzpP4yL5MRidQG8sshWoLfoP6i24kjF	1403	786	95	1	6301	jxz5LmQdtuz4DgkT47oRiDXHkWymVrXDYxcKJ1pE13rzRifCR5o	4224	5962	5962	1617012360000	canonical
8155	3NLTBaap5hJ8A8m2KY7AKCUKrRAQmjMwYkk7auv1Utq2Q4hhoB68	8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	1406	1393	95	1	6301	jwPgYyYXJ3a3TzdznBRT9Froettaj9ypoyoW5nETte6RyrfKhkg	4228	5968	5968	1617013440000	orphaned
8160	3NKR7RfBQvt1VwtvpXYmum26X4HwxuJtB3aFxxVaXvQjb8nb5pZi	8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	1619	909	95	1	6301	jxGLPwZRfhYGBntnvbUSVQQ2rKFnsEmkiJYwHSVJ4VCtxVPMddv	4230	5970	5970	1617013800000	orphaned
8165	3NLPDWiJFwDUXyz6PgecZXCN6EQ9cQ4LndsWuDWpSBudeKDy95xp	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1483	295	96	1	6301	jwu6gu4s3XSK5sVrtWN4jQ6ikXXhGUpNoD43sstCYtgJrkpwB1Z	4232	5973	5973	1617014340000	canonical
8168	3NL5H3StugMNAAa3PC6oJMHBrB6qJ9AejW7SzTvsxwtfqJyEAbvp	8166	3NLCHTM8SHypgaYUKwSQUkHRgDjAXdpiREEx8GZRxTPmLuYiwi8v	1609	967	96	1	6301	jwBvPkhojhqZrHijDTTVCRmmnX1k9yyK3sukapz9Q7FeHMXaHDe	4233	5975	5975	1617014700000	orphaned
8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	8171	3NKJBSeWqVyfguaZXtef4NpyPXU1P6WhEZwj4iCif2x8qrsTUWEM	1406	1393	96	1	6301	jwMGEo4TqRj1r8AkQ7MHRiVsSkf6UjA2JdNAKJtR7q2BCkegFNt	4235	5977	5977	1617015060000	canonical
8177	3NKeyqaKbE7EnNTjExy4uYuHTNj1xKGZbMxL4uFLeoYhxnU81PnR	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	1432	109	96	1	6301	jwWNWuguBg9K8sEL179cKcaF9h1bA9pqooVdLhsKqyzgaQeFnG1	4236	5979	5979	1617015420000	orphaned
8183	3NKTAgoM1eihy3b3FiiPihCzdQ8qtXukXuWsaRUfvwQxnmnRgxw7	8181	3NLCsCNLfD5jiYK98MZbG7WthUVudsBw6mk2f9jY2kuvM4oeNuLR	1637	816	96	1	6301	jwHPRbGcLuriDFdGvnPmNJZaK6NdeZhbaACpoWepKrnnLuMcSEw	4240	5988	5988	1617017040000	orphaned
8185	3NKU6TaNFuZtM6hj4Gdcm2d7Z9GzgF6KQNUv56Ay4K9bqU4a7N23	8184	3NKMcj9Dq6VHAtMrMNN5gh63ycpr7PiHZnztrc2z435XCSgrc47p	1458	957	96	1	6301	jwAJ4cMeAMPmDkN9nJKr2UtvCNZ1ww4E27fvRiGZLtZdmKxuoK5	4242	5990	5990	1617017400000	canonical
8190	3NLQCBg8xqg9ZQzuuYfxxrxcMzzkuj2upCN8zdwa6PmjVHheeufd	8189	3NKmPTab5tCjnZmCmL5tT8PMzotHD5KKr7vJnh7UqDqDQUt4zZzD	1407	1395	96	1	6301	jxGzEwrFR89j4tLNRWD7rWpZpEtwX1asLqbBf18gZYS56xmZAbL	4246	5994	5994	1617018120000	canonical
8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	8190	3NLQCBg8xqg9ZQzuuYfxxrxcMzzkuj2upCN8zdwa6PmjVHheeufd	1422	1337	96	1	6301	jxtmeuXUmE1TQcvtySHXqLeA9W1h9hwjfPswkyAfrSs9jJ5Cy2U	4247	5996	5996	1617018480000	canonical
8196	3NL3xA2LhWH8Aq8zvUbZJDEsqqsFTR5PgvtAv1Ld8daYki34CHMC	8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	1403	812	96	1	6301	jwyxSR5DTDZknCHf2gVHNaP6c5vhT7sFGQcDvdLti1etgAqHxj2	4248	5997	5997	1617018660000	orphaned
8197	3NKWLh4Z3q4z9Euugi5GD25kAwQHULH48RGgXsHcdVDkLVNx15KZ	8194	3NKcFVF4wBJw7HsyzUdgwsxix1BpZUjQivchpcdnc54k4AtbgAcB	1407	1395	96	1	6301	jxfHbZuCx6MbT7nD5cu2g64o1QhbCMS45Z9PKT4J8C4hiutu6Ti	4249	5998	5998	1617018840000	canonical
8202	3NLtpR6vswFDhyzRkE2kGHzR4vEt4PE26BF71x23Tz5PFGKsyv3X	8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	1654	1214	96	1	6301	jxZ8mYStYvrJt86XL2qL579kHwvNUWkFqVwDWM6JwiZYwtSFUpc	4252	6001	6001	1617019380000	orphaned
8209	3NK3ai9GBiNWbBcgYNJqpYxaBckAXw5x6kFJjDQ35FGkeqvtkVUt	8206	3NL7sFEiGPSjG8L4XkyGVyxHAu69qPwcxhnfosstCdVAZzVpzRQZ	1405	873	96	1	6301	jxCWE8wuCU8tXdYta7oZFeVrkSKVMPJTjyrAfik6y9NRGZKSrk5	4255	6004	6004	1617019920000	canonical
8211	3NLMEF9u1L2Gse5kad7gKSXyQMjZNy9fYqSRKeP3snZfJKWAKvSc	8209	3NK3ai9GBiNWbBcgYNJqpYxaBckAXw5x6kFJjDQ35FGkeqvtkVUt	1588	1146	96	1	6301	jxHhWguCv6n85KSD1TsXPfeZ8jc6HSJytUErvN6P1jaU4nmwF7p	4256	6005	6005	1617020100000	canonical
8214	3NKyVeTxYSpn8qX5tQSw85cc4e2s5jNHScvXe1zmA8LaPtBrKTGE	8212	3NKMhFY9sJ2emuGZTT9ZPqaLqaZhxwKdcRUcBndRCkuXSkojLAMA	1521	233	96	1	6301	jwYw5ynfhNqteVxMqLS12xNTzUK6T1cpj9WfKsoY3NNjTdJ1FQc	4258	6008	6008	1617020640000	canonical
8219	3NKRfxMhmNGWYhrGMUqJSKKj68qaqpJ8tHBds3K1QGiZ4fMKfej2	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	1619	1275	96	1	6301	jxveZhENKd4AgnAKgSBXFphLuSevHVe6uWbW2TAyiHBLvtvC8vE	4260	6010	6010	1617021000000	orphaned
8223	3NL7WJqP9X6XbjqWN9CS1S6NMBXep49MBesLA1mH7WcizRhGzr6L	8221	3NLs5z7qynvXYcu6kLJs3wJvEssaprywoH4AEMrs5jP9UbjdThU6	1483	1030	96	1	6301	jxSZS1sJRJCHc5qoBhhWE8dECTe68sz7CsywpqE3zGxY5D4PZBC	4262	6012	6012	1617021360000	orphaned
8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	8222	3NKjEEFk4Nh2dFvYtdBQQDRBYx6pmghiPsLfxu8K88krPPgYeNG9	1553	776	96	1	6301	jxvc6c9u2Kx7qqNBgz5nEV5XJmBum87zUKo7Qy1cvjxQrbM9Dw7	4263	6013	6013	1617021540000	canonical
8230	3NKybhXxKtRnBzHvta6iqiJ3wQw7bz5WUCZkt4TnKALpRSs2vK4D	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1523	1321	96	1	6301	jx8fReHUiiarkg5yDMrPthkVCks3Mk98vYrhwzmUoC5xBTn3YtV	4266	6018	6018	1617022440000	canonical
8256	3NKWzTUCUmNULdRdG1JeSTZDpb4HdNYwvRLQuuD99PotDC179LEg	8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	1631	794	97	1	6301	jx2LQ3esrRXkZqBBpoaqAGCnWu69nPe9oEzPGnhvBzbHVsQ8fHY	4274	6028	6028	1617024240000	orphaned
8260	3NLC6VHfxWPpyAyEXreTcEAbfvNic71ZLD6fCXUCB24LewGRa3w9	8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	1448	1065	97	1	6301	jwh9vxGGmVKAzW78Ey8Jszymp1gruiTNDRuBPpU9da3n4r8Yexr	4277	6032	6032	1617024960000	canonical
8267	3NKcU1u2AH5Cd8hjutwcqnntXNB69Kd9V4t6UjDPZNFGGwvDTDgF	8265	3NLbPAyw77zcnwVvwqT29C2U7mPMRp62383wV5rC9L2gAHgBkgKE	1426	1118	97	1	6301	jxcWHLY4Pm2BzaNmtWk8xTuDpnCLc9bYeAFUr4MSyR523j5cge9	4281	6042	6042	1617026760000	orphaned
8269	3NLs2L3RQLAimghqN63UTRWmMCtEXtwFXdb93CECWiKnnYnsgYd3	8266	3NKQGshHaNqX4p6YvLXH8VCBombbiqSgEFAKA1essABGXBgbUMvH	1619	1149	97	1	6301	jxCJCoVRwNEKLqS6Mj2z7EupekFMZMV6aA8tvLEwfM164a9GiNo	4282	6043	6043	1617026940000	canonical
8277	3NKXpWqWhKUn1xzqg8qERtgDx4XgRudfBNScyk5xF5qkuhbFhN3T	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1427	583	97	1	6301	jxH1Nx98w4twHSNM8iaVif333yRKNwDYRW4ECvBgYfxVfGDyY7R	4288	6052	6052	1617028560000	orphaned
13738	3NLPHLdVWZPqqNtcYdV19mpJjgfgp9LAoNNs5hFLchUUFLXDtXwp	13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	1523	1075	208	6301	9942	jxhi59CQc8wJaSkqsEhVKCZT6RzXscsiF6R1JX9Dv259cLRVL3c	7061	9982	9982	1617735960000	orphaned
15539	3NKvvoACrXQVAewubwhrtzXTSDhtuVVjChWwQuAfPgYYfcmJAdTA	15538	3NKeTsySP8JtuBG61MaoXqe9on9V3in4tbpwQsxrSfmTRy8HCV8a	149	1283	249	6301	11566	jwv2ufdufZRWAZdRYQuo43c3qacmUkvQqQc2Uirhc2iejbCKDD8	7909	11187	11187	1617952860000	canonical
8152	3NKk5rEAvzY479tx2KHAcSKnG5xkJKCi1V2HhKibztoDCYZ6GXgy	8150	3NKbQ29heBG7pyLftuZ24P3CJ3R7KV5GL6FwBKWyzzFD4nbzSGd4	1657	1344	95	1	6301	jxne43eFodnwAX7xXhVvdG6gZUCFsX3A6H1tKmkgCCpjsWo111o	4226	5966	5966	1617013080000	canonical
8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	8152	3NKk5rEAvzY479tx2KHAcSKnG5xkJKCi1V2HhKibztoDCYZ6GXgy	369	1066	95	1	6301	jwxjhGXm81mWC8eGBL2VqeTqFkXCefAezLRUBSBythGA7W32mS5	4227	5967	5967	1617013260000	canonical
8156	3NKc8Ak4nFkR5yBpSsZcs1g1Rr3WuBQjPe1ce9snYBFjqaiemP1m	8154	3NLw4BmyRLQnJVMzimuLzkgzxVi4bMGWTNG8g9xvd2TRzzpw2ykn	1455	1332	95	1	6301	jxP1zjop2czJNpu2kJHyJ98F3UeCYrEdiG7BP1YLrtQXD7sM7nA	4228	5968	5968	1617013440000	canonical
8161	3NLJWWhSs6RW3nXCfkz4TouDBkKV2zvaQNTL9fCobC9i27SSzXZB	8158	3NLhBz9eWPScYoabijxPjTdj5ub6DyyR8mTYr2HJ4Rg5hqu13A7x	1657	1218	95	1	6301	jy2uu3enkpr4AqNvpWeGLmR3pH3iCAWjyLrfy6n2dNZcHHYYQB8	4230	5970	5970	1617013800000	canonical
8164	3NKTAw8o2yFV8dgHCMkTcWqVkCo91Wmice8GYuzbA2ViS4qCRCg8	8163	3NLWrpdWTFCrwpxhbRdyVRBXwq7Qf94KA1SM31SaYuALWu2YZwvy	1483	295	96	1	6301	jw8Dp4ffRVCMQAoqKfmbzNsv1XeaFhNr54SNcBi2qVxX1tbVqH2	4232	5973	5973	1617014340000	orphaned
8171	3NKJBSeWqVyfguaZXtef4NpyPXU1P6WhEZwj4iCif2x8qrsTUWEM	8169	3NLf1zJsjE4KPa3MyrCNiSEFg5smCvB5ALZVvk88rzW2YeRCrJP6	1402	868	96	1	6301	jxsNdsFSWaSgwSVGMoBjjmPbuPcWfpJRqa6p3L4dX4jnH5G52z4	4234	5976	5976	1617014880000	canonical
8176	3NL4cdJjbQyMQi8wZKpqTZ95F2BULs2XthX9d74xaJDGdM47Cv1d	8174	3NL1h54PprYsgqQPviCbaQWPpJS9xEAuG13V6tq7LnES3NXuMdJg	44	1325	96	1	6301	jwZeLGPDdF531BWGrqcJQYKz2RZKd7Nvo25Xc6ekKwua9E4rpEE	4236	5979	5979	1617015420000	orphaned
8180	3NKBS1LR7dKuHHBEuDjxMJemB3Zqvq3uDVzF86kde6BiMt13famR	8179	3NLMgUPgT76FPtzDGYoWoPnDmTTWPp7e3WoNWb1TQ3aP4gETG65Y	1633	1390	96	1	6301	jwM3ERZY3nKBus7ZSpEKPUt4ibdAt7kr89AN7mPnAHnRgXhU3vP	4238	5982	5982	1617015960000	canonical
8187	3NKS3WuHhz2xykrVXMfPwjmipkZozU1WgrXNPJR3FyDwLY65crNm	8185	3NKU6TaNFuZtM6hj4Gdcm2d7Z9GzgF6KQNUv56Ay4K9bqU4a7N23	1406	1393	96	1	6301	jwGUNwLvxZSVDnWVRSCTUNHYVp2nXNrWVSamhWjKxSUSh8zvwVS	4243	5991	5991	1617017580000	canonical
8189	3NKmPTab5tCjnZmCmL5tT8PMzotHD5KKr7vJnh7UqDqDQUt4zZzD	8188	3NLUdnaq8srVtXk6kJdysLE7RqqeZEdDqL663qp8Dk5sr3czd3tN	1673	1002	96	1	6301	jwMtJSLAmx3xNboN3aXNTbogpyofaFZPcqbPwK5DprBPaTWj1tj	4245	5993	5993	1617017940000	canonical
8194	3NKcFVF4wBJw7HsyzUdgwsxix1BpZUjQivchpcdnc54k4AtbgAcB	8193	3NK7yiiyCQWfkN3T83bKwPFK3pG1L7cBTEhn6pZxzPuDWYR84M1Q	1578	1050	96	1	6301	jwzJfMmzLnqU2hSatcUqJgHvWCSPNy4yEfczJC8S16qJvRv4d5L	4248	5997	5997	1617018660000	canonical
8203	3NKZepXEmZ7HnuXU8mdYNNnnt23PxuSY6mAHKk41sr1aLunVZJK2	8201	3NKqdm4285tudgKW6nzL3PqC8w3KSab72iJgaK777RGUBiv71CoP	1527	1293	96	1	6301	jwr12RqnBdErSYbZEHr3PsTJhw5BVqmWPE9WzzBh2hMjcyWRpLK	4252	6001	6001	1617019380000	canonical
8205	3NKVe9xHwxURrwsoKES91wKjvgyiNMEuDPo8JWfUYnw7yfJox993	8203	3NKZepXEmZ7HnuXU8mdYNNnnt23PxuSY6mAHKk41sr1aLunVZJK2	1588	1392	96	1	6301	jwCdqeQ5kJw795Y3ATFp3CgQC3fdH7ejYhJFJXaRKZ76Dq2kYvy	4253	6002	6002	1617019560000	canonical
8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	8214	3NKyVeTxYSpn8qX5tQSw85cc4e2s5jNHScvXe1zmA8LaPtBrKTGE	1406	1393	96	1	6301	jxHKGCU2FZjKAjJJkTYcGQbPMoJ1ggQW1othaZeisbwoDpU6FTo	4259	6009	6009	1617020820000	canonical
8217	3NLmovmWHSjCePL1oUixoWWAW8cFgqeAB7MWsnV3BiJQMbESZECr	8215	3NKfZx45kg9ZzrPj5jsey2zTkrfNTrZ3kMTWdaZ2bVSmGsdoBRwW	1503	1031	96	1	6301	jw84R9c86BPjboWtgTMyVs4nzyrD3bzAd7kvKKFLaaw8ekSVvzm	4260	6010	6010	1617021000000	canonical
8224	3NK55jJFYojzwQEA1yi3aVtjBVYgJydbUPj5kK8E4UR1b4kYxxw7	8222	3NKjEEFk4Nh2dFvYtdBQQDRBYx6pmghiPsLfxu8K88krPPgYeNG9	1522	956	96	1	6301	jxSVeJqB9cR242VUu939u56PQcHc3gEFnG2J643EzLACRFh4rpr	4263	6013	6013	1617021540000	orphaned
8226	3NLnB6LMDAQ8WW7EL58KsdLuw4JMRh7eUksVndBTeKMSrPp6CEBB	8225	3NL3M8F5gxe2VRFYCLra7ekXKd1aU2b9BdTTufyaviukq1CChHN1	1471	1386	96	1	6301	jxJ1NLH6pt9Kgt5VNnrzZq1goZ7Ad6eppcpTGyK1gXKx5rPkT8Y	4264	6014	6014	1617021720000	orphaned
8234	3NLi6bS7kkRQD2ekhSmK7zMxdPqzbJqV4SqUrXX5p2SnQxVsFHxV	8229	3NK8VGuxDEPXCCJ3pYfUkyJvx3MMGyWANmVQzRWyrRoJWeP8BaQN	1523	1321	96	1	6301	jx1SnKv6tF2wPFPesjV3ZtXsgfKVvp1AjESyYRtwXFbfvzbYmeH	4266	6018	6018	1617022440000	orphaned
8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	8235	3NL3PNhxFQ2bkx3jDcV87rkWvkgsgzXFJecgSTowDoxMD1PdTgvp	1541	1052	96	1	6301	jxiSmDugR9e7PxgZNZi9ZE1mrRgNCCBubUmKJZC2Xm8bXiY5m3u	4268	6021	6021	1617022980000	canonical
8236	3NKrcBjB7dHMko4QoszUDyZanxgGvqpp1Txz6iDb4GoXHyywoXGq	8235	3NL3PNhxFQ2bkx3jDcV87rkWvkgsgzXFJecgSTowDoxMD1PdTgvp	1541	1052	96	1	6301	jxfkDAKy9NtCSjyw6Ng3gKR177XiZauMMvJyyz14uSqNGKDSG3d	4268	6021	6021	1617022980000	orphaned
8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1560	1291	96	1	6301	jwfc7GCqD6pFojZNhFWjPTMfum7CmNPvvP3FH8Lmto8TUH34qKx	4269	6022	6022	1617023160000	canonical
8240	3NLqNyKxHJs2SVMhjQkUcVTfZGVp2KprLiy6qib3zKcXkTzoJHXz	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	684	1352	96	1	6301	jxHRkbTfEVjF4ZThfC48FoincTs5HSwMZNytYUHQbjnKkJUENpq	4269	6022	6022	1617023160000	orphaned
8238	3NLEj37sYmotdy5ZKogdG14cVZK9VEvn9yQF4G31w8MBXMhtjdHN	8237	3NKjj4GbWbpTa99UqXy571N1rb7aGcKc1oYN4Aqmc4tCPS34ooGA	1560	1291	96	1	6301	jwbJuJ9AeXoxno8FCUtoK4SxKwvQXFRoYUo5r9ufaMHL5gMR9j2	4269	6022	6022	1617023160000	orphaned
8244	3NLQnbArtu5Qj7UEFKETbftDG3cVPUoC8PWqRrzCEFtfbppE7Cig	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1581	778	96	1	6301	jxJuLbFEyH86euNTDA7RUHxDnBUV7iiJuNEmU8pnGW66bF5kx5U	4270	6024	6024	1617023520000	orphaned
8246	3NLjzGyQD33NzpMXbFVqWrWauT1MD9JNDYkW6JyuTaSSWprQVNMe	8241	3NK7ZduCgV2UG7ey6fX4PwG7zKvfYShtc6QwLLHf6UUht8QEhniz	1553	776	96	1	6301	jw7XKqZKfSxqtQowN3c9r69MFQQLgqmGYMuzMcLPZ6b2QBCTBQh	4270	6024	6024	1617023520000	orphaned
8247	3NKeQ4vQyzuJ4kUgLCeQGrs3Shx2znkvZcbKoVRu1oFKNR1Nk8wq	8243	3NKP84FmBDq9ykNPQjswNEx9Ljjwg3fkZfiMZAHFx1kdjcJf2c1o	1406	1393	97	1	6301	jxMAKydw2kXyMfdjK9eQW5AoNefK2KngYC7xbSEJUcqRBUKLPNG	4271	6025	6025	1617023700000	canonical
8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	8247	3NKeQ4vQyzuJ4kUgLCeQGrs3Shx2znkvZcbKoVRu1oFKNR1Nk8wq	1407	1395	97	1	6301	jxCjj1P319e5Wtvydnh7hE2PV4qHrfTDiYDYAkbRPB8NB21Xjxc	4272	6026	6026	1617023880000	canonical
8252	3NKThdYq9TJdnEqao8L1oRA5feZrLPF56MxTuh8pNBkgNMoM2PJa	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1402	852	97	1	6301	jxtf4eifWEbdoz5kqkcmgYrfuXVJUDdtAW3jzMjsQ1AZdbGxoyo	4273	6027	6027	1617024060000	orphaned
13745	3NLJFa5VZJRZsHBeYzFo4mftF64etPiWGU5jvqrYTkZHagdnNbvm	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1646	1108	208	6301	9944	jxARw2t4evEVxswGYXAEXdxQuepc8ymJV42RwTCyhcJNFSdH2Rn	7062	9987	9987	1617736860000	orphaned
8251	3NLidNXAMVZsYtvf5e8FPd28kQCTPfvj7zJuETooNZEBcxCk749A	8249	3NLKqF1YJUZT8Xm7FKA8eG2SSspni44g8perCeRoBTbF9B7nozPR	1657	1344	97	1	6301	jx3xyRXa5okLnvMSk5r7iCRoCahdY2iEEz4W4tQVNXBYUedXGhK	4273	6027	6027	1617024060000	orphaned
8255	3NL7hMLMhMCGX5WdNiofVYMP6njJ7RXzG2gwrmQUTddzjrAx4yS9	8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	1585	1366	97	1	6301	jx4Vo4DCDGro21aPruoypDTqzRR2VmvC4DoDtZ6soD4HTmRkmYN	4274	6028	6028	1617024240000	canonical
8257	3NKaCqXSGYPcTjvZjzSivRTsSdYfApMDjpnv6MSZQz3seQKc7eij	8255	3NL7hMLMhMCGX5WdNiofVYMP6njJ7RXzG2gwrmQUTddzjrAx4yS9	1406	1393	97	1	6301	jxoTgLQJqdX8Q3nijL3ihp1LZGNL4DuAnZ9z9fgwcXX4eFQ1RwL	4275	6029	6029	1617024420000	canonical
8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	8257	3NKaCqXSGYPcTjvZjzSivRTsSdYfApMDjpnv6MSZQz3seQKc7eij	1402	810	97	1	6301	jxNg88Dyn9rYktNKsCS9PGV89vVcio9wv9pS5T9M7qj9jwdC4WV	4276	6030	6030	1617024600000	canonical
8261	3NKH5yjCc1zjRQztNh4sX4ABuZ5sYbQtvfNmBzCGaVZKrNnhiVZJ	8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	1476	1371	97	1	6301	jxZrA9xqZatUHGQr5tgmjQ42PqMmNZyg5vuNmhXbxyVZTdEwwHF	4277	6032	6032	1617024960000	orphaned
8262	3NLuRKaxTAr6HfFtV9MTpW4y8NqsM7RGUF59J4ejxbeprvZE2UKN	8260	3NLC6VHfxWPpyAyEXreTcEAbfvNic71ZLD6fCXUCB24LewGRa3w9	1460	1324	97	1	6301	jxpYCcx1xfEdP9uvBxVmDm4CQ7CF8PqoKsgA3GiHRwFdKWCHM5S	4278	6037	6037	1617025860000	canonical
8264	3NKKFYxbKeofhW3LPwt9AcR8a1e9hQn9Yxo9bxrPLJgGk56cvsii	8262	3NLuRKaxTAr6HfFtV9MTpW4y8NqsM7RGUF59J4ejxbeprvZE2UKN	1527	1047	97	1	6301	jx1vaQ24c8q1zpaTLwwNGZxRfBaHYy9Yw1TZK66c4Q4BaXvwcTb	4279	6038	6038	1617026040000	canonical
8266	3NKQGshHaNqX4p6YvLXH8VCBombbiqSgEFAKA1essABGXBgbUMvH	8265	3NLbPAyw77zcnwVvwqT29C2U7mPMRp62383wV5rC9L2gAHgBkgKE	1406	1393	97	1	6301	jwFGTRiLJJv8TYn4Kr7tkTTTt9hpqTeZqERdCZ44gTySo4joHhV	4281	6042	6042	1617026760000	canonical
8272	3NKZUnnfsGbPcLjJ9QLRv3SJ3c4KQF21dqHEHZEQqjC4ax954wQ2	8271	3NLBDo1fJUws5ArEHNEtrHCXhCKZjnu5V7EaizHTCN79wQC87GVy	1564	1092	97	1	6301	jwVsYYe9qiztn7CB4ZXKUc9tzkwx1FntKL32Z3uS8qibsZaNuPX	4284	6045	6045	1617027300000	canonical
8274	3NLwXkpgWkW1Ad82GF8op7uPWPdVtGWHj84Y47oas75s1YDnVnDk	8272	3NKZUnnfsGbPcLjJ9QLRv3SJ3c4KQF21dqHEHZEQqjC4ax954wQ2	1403	824	97	1	6301	jxbe2Wm4Mxi746kbp2PvURQs67GPMG3HoY5nZys66X96cNxvhWx	4285	6048	6048	1617027840000	orphaned
8275	3NKLYgUa19rZU2CSh3EMsZNVvQ5mBW6zhYY4wX55N1ue9YkECLvG	8273	3NLa49MbjP4iy79hQUwX9ZKETrQyVWAkAvVBvUDm5oZ256MKf5eZ	1589	1286	97	1	6301	jwCSpiAyGWErE4K1wv27S2FqVegWQH4zx9S7jnMvgQJxvrsVTt4	4286	6050	6050	1617028200000	canonical
8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	8280	3NL2A9m1zLsTVUtMbCNp6cy3rGb3xTtrkRhybhET5voQyNEHFXaG	1419	814	97	1	6301	jxqkpnPhX8fdgCyNteAu5gevPY2xBWXhaoE9tTzjw6mrJxopHUT	4289	6053	6053	1617028740000	canonical
8283	3NKNT1PxwvuRDqEvZnY6Lxe8FucMnSvoRvGNo9yTBcfmryMMVtxm	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1633	1390	97	1	6301	jwyL4ij5phMCzNQHXcyJf7ysYtJHbT3kBgt1URLN2QpWj2ZEtnP	4290	6054	6054	1617028920000	canonical
8288	3NKhUhkJiu9aSgXbD8h3PSYBCu3hb1F2HNWehKJLYFfsXNyxvUdi	8287	3NKjS9AWyCMYGfyeygcUUhrWixC6rVjpZ2XnZQgzCQdH52nqKGNU	1405	873	97	1	6301	jx6F7fGYknXDbgu7r5eGybfKYT9S4LthJMWuK9NCk4WPoda1PSG	4293	6058	6058	1617029640000	orphaned
8293	3NLF7VzSNkG4dHkZLeQ6euM5t7KEhRN7gXH33ZpNrxN3tXnhx25D	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1610	948	97	1	6301	jxS4mRqy11aLWdXwESNW6CcN9AaG5u8mZdHRv2XkBTbfSk7amjZ	4295	6062	6062	1617030360000	orphaned
8302	3NLiuUguXzncE1MazhZ1iZN1L1x75EaXiZDFLsntWQ46WjY568ca	8301	3NKPPrc3s7VkojxtJRGUthjY5resBwq1Ep5Y3PbZhJL49HurhDYq	1508	1387	97	1	6301	jwRQjQGbM4HVsnHJWpqXSXxc1Ngh3fVnB8fSPySJE6cDt4Ux6Km	4298	6065	6065	1617030900000	orphaned
8307	3NLV1zXZGquVnb7G9THBjBG7R1nV39nXyvTjPxmEtCQd2VjJQBVD	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	1587	1357	97	1	6301	jwkYvrz6xk8Mn6PVHCwCVijsMz9pYYkBtFeXuwBQVXxeNtLwRoD	4299	6066	6066	1617031080000	canonical
8304	3NLLefSgyZgd11pNSXHhzHKkVzkRPLdAoMVXv6NncBwKfqvV1DrY	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	1646	1108	97	1	6301	jwKMELpBKnMVFGmjgPhTDc5a3SkKRQQFZ73BUdQRdAA9uByJ9re	4299	6066	6066	1617031080000	orphaned
8309	3NKfKjbRAqHKyvdhHWNZGF31ugmV698Upa8ccUFh7Nb5XTNCJZCW	8307	3NLV1zXZGquVnb7G9THBjBG7R1nV39nXyvTjPxmEtCQd2VjJQBVD	1490	133	97	1	6301	jwsvKm4MNUWKfrCn23VLMyKFAuWFcg7XWyjaDTE8H5nE4pfvGaE	4300	6067	6067	1617031260000	canonical
8311	3NKAHHebZGbGfvqApbafxyfhppysBbhnbR7ELvTUajuMCa3oyjp8	8309	3NKfKjbRAqHKyvdhHWNZGF31ugmV698Upa8ccUFh7Nb5XTNCJZCW	1406	1393	97	1	6301	jxLivx3rSTCLZp9qRjhc6Fpxo2aRkPKsLttGrTPt9mp1f7f8Lkn	4301	6068	6068	1617031440000	orphaned
8314	3NLupN8KG6vMnwrj3f72YbhPidXYpUpAR7JbwUofg5E28ie7D2yw	8313	3NLXEPeWcfeAQ4kdGZE6W5meKJGTbK4edvmT4fx6CgJTae8JodgT	8	8	97	1	6301	jx4Pt8PxRFCWjmoPHBHtoA4SPKQsH4nDNkaLp6sqry3S4pserzu	4303	6071	6071	1617031980000	canonical
8317	3NL684ztSTyTtqyn2Z686LrFVyEuHV3zfz2PG1KyUJfiMhaYh83H	8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	1559	1353	98	1	6301	jwYpjUtUrscn3FW7fukHL4tprs4Xs6CYFygDqtpkg5vrKu517hc	4305	6074	6074	1617032520000	orphaned
8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	8316	3NKyF2obwPV6eUHHBhcnZY3mhh2yb2Mivw8PPNJoAq47YVijrC3B	1407	1395	98	1	6301	jxJJ7HiyJTCxKo3HGdWwHFqN7Jh52o42QGWuqrPqjQWBEaCVY9p	4306	6075	6075	1617032700000	canonical
8321	3NKhe6fTeUMs15KQPoqgKdNCD5Djj2sKDPNJGBudMHmcMgw5A6TK	8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	1457	1391	98	1	6301	jxSZkYvY9ErLXddwW4bUVzdcmBGMGsxScW4rCLJp7fREtGFtMzw	4307	6076	6076	1617032880000	canonical
8322	3NLmV8V5BWASkqQDs9JEeu5SyxhqxsEUyUV6SXb4wkjcCw53MsGa	8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	1439	1279	98	1	6301	jwaByz615vjNLYuTNhmCSTuTeXEk9u11phVf1gg8nfdhzD2o6Pt	4307	6076	6076	1617032880000	orphaned
8324	3NL8wYD9PQr9KztwkoQziJS9xn1arpfYa2WFqfWQbsB767GqXqYD	8323	3NKjSzUjMmbSojrzocYKBdYptKWbdLecq6CT49Qp7zTERXhhjvvG	1406	1393	98	1	6301	jwG8nAdCxxTstT2xdXgSouKHXVXqE2e2FP4dbLPz2ZVSromd3mn	4309	6080	6080	1617033600000	orphaned
8331	3NLBG4AxqzQWgN2qyp3XA7DeuVa1VZBZ3iwwcGmB5gAMEJYj5aQF	8330	3NLGb5WtrcNAL9W9brvrSeXrbfozqGouM8WP3EpHxE5aisszxjFv	1513	1133	98	1	6301	jxDyvJ2JHVj5aY5Tht2oUMz6vk41RMNJr3ivskttYgcgxVEQU7x	4313	6084	6084	1617034320000	canonical
8334	3NLNS5R9j1mj11ieqhu4RMpXtxRW375mcKaykAR3zRsEhEQSxjTy	8333	3NL3PRZ1GywfMYgfbKjxucrqVK5kwCWMtDnV6aYokBGKx4X49hWp	1646	1228	98	1	6301	jwNJqbtiSZC1Cv3hCnupQn3i7NCVzq1ocumYNoAzKjyHrWJG3QM	4316	6087	6087	1617034860000	canonical
8337	3NKPCSoTuudPxgVN7zHqJ1JXALQ9M7ZizyuiFtoiNB3JdLNY8eQR	8335	3NKkWEQ6YrmBaruQz38bs9rHj8SGFUdTR4e4XXrrN48Y6jtRFuXp	1631	794	98	1	6301	jxnJppcTHuWe9Y233J2qUYfT3BJPtdTEK1PC84P1T6WgbdtCPx6	4318	6090	6090	1617035400000	orphaned
13758	3NLsrX467frx3tXpY3jGJsT6SjDkbc31EhMdNtGTTKdgXUkfNhfW	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1403	782	208	6301	9958	jwtiKNzaUCgEx4J9AgVd3Lxe7MxryKEzTGiSFAfat4dZMSnuK3k	7069	9997	9997	1617738660000	orphaned
8254	3NKox4ZBySvFb67oRKWw8HnLghcVxzPuESyLSGmobbHAr9TuBjHB	8253	3NLAMjpMv2WKha1VnTUZukJFJr1m2yWfo26bdAC5EhJxWTXMv3rb	1578	1296	97	1	6301	jxdRNNPyw71bmeC6HkWik25ceERBN8Uz8zC7bvuLDjQWD33uBg1	4274	6028	6028	1617024240000	orphaned
8259	3NKWRoxhXf4Jg88miH2Hrr4HUimNrbHUD4fRx7ZDEp8sPEe3qccC	8258	3NKWntWaExXv3aNZ7MQiVCSuTMt5i4WgcrHsAkgyaXh62BEdQngS	1672	1039	97	1	6301	jxpNstS5iCsxBriaBSRMwQwBPud8V6tSPZay3h9s5TfDprev5nr	4277	6032	6032	1617024960000	orphaned
8263	3NKDoFDboSYGNNoeibmiDmoipVkQMXGUuo3nQTjifyQTNaVNLbJz	8260	3NLC6VHfxWPpyAyEXreTcEAbfvNic71ZLD6fCXUCB24LewGRa3w9	1637	816	97	1	6301	jwR1SeKYDpmrMvjKVhUTUNHGsMeCvEHAzAK9tcYFQj53vz6SFVJ	4278	6037	6037	1617025860000	orphaned
8265	3NLbPAyw77zcnwVvwqT29C2U7mPMRp62383wV5rC9L2gAHgBkgKE	8264	3NKKFYxbKeofhW3LPwt9AcR8a1e9hQn9Yxo9bxrPLJgGk56cvsii	1458	957	97	1	6301	jxdz4961Z7kQjdicNLPdwS7JbeiQzQ5c5wGMXN6ZQjZ4y3iBoe3	4280	6040	6040	1617026400000	canonical
8268	3NKSRjhjxv2MYJ2QH3oM9NxZCpnhranevteg8wEJRDyg1apUsRSA	8266	3NKQGshHaNqX4p6YvLXH8VCBombbiqSgEFAKA1essABGXBgbUMvH	1600	1126	97	1	6301	jxc1nZFzSEYtWZSEtQpghX7EmZMxaFz1h8KpKsMPNp2nbbeMxWf	4282	6043	6043	1617026940000	orphaned
8270	3NLmwGA5egwgQyNCKjXa7SsUAA2NMLJrNhW5Pk8dDdpqxzB7t7xX	8269	3NLs2L3RQLAimghqN63UTRWmMCtEXtwFXdb93CECWiKnnYnsgYd3	1527	1167	97	1	6301	jx3veG5Wx8S7tzUHHooPvkqV4piYeH8a8BdrHHqggPNp4Uqxx7F	4283	6044	6044	1617027120000	orphaned
8273	3NLa49MbjP4iy79hQUwX9ZKETrQyVWAkAvVBvUDm5oZ256MKf5eZ	8272	3NKZUnnfsGbPcLjJ9QLRv3SJ3c4KQF21dqHEHZEQqjC4ax954wQ2	484	1193	97	1	6301	jxUWATLNxp7f5hqW1wYe2LRc5QSAoYUYPGw8tq9nydjBrQj5RBJ	4285	6048	6048	1617027840000	canonical
8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	8275	3NKLYgUa19rZU2CSh3EMsZNVvQ5mBW6zhYY4wX55N1ue9YkECLvG	1406	1393	97	1	6301	jx5YJcGQFZcEpwEA3wTjEmsQ5zod4F8mkcnFviHBYgvjHdQw2jD	4287	6051	6051	1617028380000	canonical
8279	3NKBt3Dpx1sBjQ8bKGS3GQzwbA9DH2w1vjdbTALQgBZgn43EiYbY	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1474	1329	97	1	6301	jx6spEEckUzZSy7CRFuWGzQLBfDu8G8j7Yi282siRsJkKc4mvas	4288	6052	6052	1617028560000	orphaned
8290	3NK9KaUW4VKw9qWH1tZQggmjELZf7MXetTCgVgiLxCkmQar2jU6X	8289	3NLRwiPLfGYMwLSXvzfQVyJX1oC3srBEvFowrw4JHhRmKPkSCy6e	1607	982	97	1	6301	jxCDxFAtsxSsa4ZBXeSNKEj4i6hwsqFX45UXGCLZwGbo37Y7wcs	4294	6060	6060	1617030000000	orphaned
8297	3NLcUPQNB6ZzTYKwETyrkT51p3JAKpvh7nx43zhiCpT3uKUiX4dK	8295	3NKBzWzWLqHF3NWu6isNd13k8B8kUEgii5GjgpTbxU4XFkPG2RP4	356	356	97	1	6301	jxVcEpnRnKxRG7FQQD5Y4cZty4dTEKx6ybFk28mJrmdVHNmjS2v	4296	6063	6063	1617030540000	orphaned
8299	3NLQPZzBZvmrESt15oHvGKSRJVCG4wtnTeF7rGuk6TqF8mkdNqxp	8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	1588	1392	97	1	6301	jxVXJE1o58eQxYLNrCYvsBmVBzXpoK5oX4A95GP1EeT3BUBPQe8	4297	6064	6064	1617030720000	orphaned
8306	3NLpdEY7LDY48YXfemZ5DyhEpFqhi3qwvTQFAVJF4MHPvWa5rdmH	8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	1427	583	97	1	6301	jxdHZP8kKnAMA2t6diBJ1gzq7VRhTLnzqkXUpqgtKyYzeLEWV7g	4299	6066	6066	1617031080000	orphaned
8308	3NLGhrmoQ5XELjRVB3DwuxSmqNxVmPCA7G6HvtDQzcXQgURegNit	8307	3NLV1zXZGquVnb7G9THBjBG7R1nV39nXyvTjPxmEtCQd2VjJQBVD	80	1273	97	1	6301	jx7u6W2pBae9b85mUbMNLssTKA1jNMuF5BXyoLRDCq3owJDPAkb	4300	6067	6067	1617031260000	orphaned
8313	3NLXEPeWcfeAQ4kdGZE6W5meKJGTbK4edvmT4fx6CgJTae8JodgT	8312	3NLu21XsAs6pEGks2z8bqzHnbtA9rXvxErynd3ZJNkf9KSUiUpmo	1403	824	97	1	6301	jxQgXiLNU4HiSPonfcreYDxVqjTJitFDoxkyAh6aQGdViwkqkez	4302	6070	6070	1617031800000	canonical
8316	3NKyF2obwPV6eUHHBhcnZY3mhh2yb2Mivw8PPNJoAq47YVijrC3B	8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	1648	1038	98	1	6301	jxbTb832b3gjwFPW6bsoQ1PJ8KCVReAjxJV1Xa1L1P7VUFpvU1b	4305	6074	6074	1617032520000	canonical
8323	3NKjSzUjMmbSojrzocYKBdYptKWbdLecq6CT49Qp7zTERXhhjvvG	8321	3NKhe6fTeUMs15KQPoqgKdNCD5Djj2sKDPNJGBudMHmcMgw5A6TK	1405	867	98	1	6301	jwkRRtm5vSEKeXMfFLEZV9B2LcLatACx91nBGdiKorTNibDQeVs	4308	6078	6078	1617033240000	canonical
8326	3NK32scBbipLLY7rdiqUBMaVT9ZXpgQjmQ8CRg5QPgB9mr2khrWp	8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	1406	1393	98	1	6301	jwcLSLvuECjWQvmp3HaqEhu4vCHi34M7QL4xG8fnEpAsmLMEoP6	4310	6081	6081	1617033780000	orphaned
8333	3NL3PRZ1GywfMYgfbKjxucrqVK5kwCWMtDnV6aYokBGKx4X49hWp	8332	3NKoTNDSLjMsy5cmpGzz27xwShpyMbYLa7mxVgdqde68eyvcY7vZ	1670	916	98	1	6301	jwrbE2TR4UA7ndoyhHtJLQ511fqNiASD1nVr3PDv6AbPvjmUzgB	4315	6086	6086	1617034680000	canonical
8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	8335	3NKkWEQ6YrmBaruQz38bs9rHj8SGFUdTR4e4XXrrN48Y6jtRFuXp	1534	222	98	1	6301	jxyX7Fo1GFJnyaRKi8DRTa7kA2MdNjvAgFp47jagcXAYT7qw28B	4318	6090	6090	1617035400000	canonical
8339	3NKUSmZEj5TWjqdvdCxzCGPrtD2K5oZi9huf44dAVs8wvgnPXgU4	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1420	403	98	1	6301	jwg8JFM3pJWCMeYuT6BYhLHh4ov8pfBjrbYsydEQ5MGcbb962BG	4319	6091	6091	1617035580000	orphaned
8343	3NKc4vvzay6LanbEmhpi12uKzwwXRq9hXyduqTTiuymhqDx37cNc	8338	3NKeMctuZRTFTB9RQKB7NxSVa8KACHtB393eNe6S5F3UajNEzso7	55	178	98	1	6301	jxhmMfsQ39nPFNcM5PDuuBievt1SDKLJs1gHhbTyt1vdyfMEt3P	4320	6092	6092	1617035760000	orphaned
8345	3NKp7GXrgvfpH1teAqrDUxQRgwnELUgSDAfqCtNN2UZE52oju8cQ	8344	3NLeZwvLQbRfU6t5CFB2oP9r16dLWDkocmaePCiRK2emZ1Ms2Lsq	1673	1242	98	1	6301	jx4r1GAGa1Cyx19i7fd5frT8zZ7h3jvah3atD8RrAXGS4v6RDLH	4322	6094	6094	1617036120000	canonical
8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	8345	3NKp7GXrgvfpH1teAqrDUxQRgwnELUgSDAfqCtNN2UZE52oju8cQ	80	1027	98	1	6301	jxXpUVUVeKEJW4cKAz7tskMzhkMuBpTCZAcHW5gxem43xvtb1vi	4323	6095	6095	1617036300000	canonical
8351	3NLcrMRSLUDAmoE6pK9rwnmGEUSYiBfktzyihXh91EN5Q9sdyrsZ	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1513	1013	98	1	6301	jx1afjeGDUusPpHKa8eSLxputHJciqEBBbs33nfX8psD5a4cSEL	4325	6099	6099	1617037020000	orphaned
8356	3NK4WJN146PFpM3odAQc68TfzhqH2x23iDH8KBrSYSfpZ3SA9wBr	8354	3NLX3LGSDXrx8YspeMxSUjH5AAVYerjidzpgTXukudGsyiyAYfdm	1440	1131	98	1	6301	jxYd9DVVVXeniFm8B5BXRWdwBE8H3qkgM7Tdq1etDZZMYomELUL	4327	6104	6104	1617037920000	canonical
8359	3NLvwY1pnyvSGsKREZhcwxR7hGVnSQzMCCKJD8eAoEuJs6X3z99S	8357	3NKzrans7HmZDX4CjGG2vmJu64LKe2yAsSg7pAJY3BXYMoZuh5RY	1503	1031	98	1	6301	jxzCjzgKeDHHmFLZYUFgieiRFqiDkxVpL9CfkVPee3c5bCSwKqb	4329	6107	6107	1617038460000	canonical
8362	3NKkDcksAb3UpvM1hgrsgBsWaCUHHuaTU1xqfEDCLEefUNaEutUg	8361	3NKt17qBGsTGejUSHFvNWUNVzEGeCT4ZMQucjyk4yqXkkLcs1Kxk	1406	1393	98	1	6301	jwHDJ4iJVmNRBQfrKqtjdJMiKR2jSotsiVFzzGRL2o3Au9HRqgL	4332	6112	6112	1617039360000	canonical
8365	3NLAeNmLAEjLppBH21bcK97LDCwszMvpEKQ8PQB2H6ddgD2VBWqd	8363	3NKa1NdTBSNXkYsbp4QDgBSqXZ1ovm1LDtdVu1QKc6yyBhRP6hNR	1490	908	98	1	6301	jwpQPU79EjXRc2YK8QqkDebfVcQf5owUYHekhHwck9ByLqLLjoc	4334	6115	6115	1617039900000	canonical
13776	3NKzNJ9oyivBMMUFeH5NbPUfktfJnzXpaR8rYcVeatjV9h3wMoij	13774	3NKShBWUcBLLWZ5qNFbyyH47WjrMFpN1CK3m9Xi8FsNJ1ho7P9mY	1406	1393	209	6301	9973	jxKrWZ8a5WvewVjyKRzqdMZPZYcF1jSWEmFMpYv6zy6smR7UfBn	7078	10009	10009	1617740820000	orphaned
8278	3NK4KtncCkovvFm14DastRWCMu9ewqnGqtwgFHqyRJ5pMQKhYZ5Y	8276	3NKdjsKRNx7dXnGewajq24848NMZqF2SYGeYRhWrLLvNQebeRYpp	1536	1067	97	1	6301	jxWkZ7c9RLBwXBBsm1czveJ6VwnEadnPeBYiDvVham34KNesVQE	4288	6052	6052	1617028560000	orphaned
8282	3NLQsL226TSboChGdkbiGqASQv5xJ9RN5xCytWL1aw5cZWwDerU2	8281	3NKL7hEfJXyaUESHF87t7EHmwYBVLJzi99NhjzPPnyRLJrmiKhZE	1407	1395	97	1	6301	jxiW4HQX4FSGKAXjrJZzh3YQjCirxmsA3B8aXtQd5iekvNmVwzL	4290	6054	6054	1617028920000	orphaned
8287	3NKjS9AWyCMYGfyeygcUUhrWixC6rVjpZ2XnZQgzCQdH52nqKGNU	8286	3NKBEGkfEVGf8yRQWdwxyS6GxhxytUQavYLHy6UeEbxgpSwTZbuo	1419	814	97	1	6301	jwVVaNKjkqiNrZSxpCbXhBLpDyj4jL8GAThJcFPxyJXoCmgei1X	4292	6057	6057	1617029460000	canonical
8292	3NKkXCka9WkAmeqJMHfVwrjx2FjpE6enxEKzmGrF7xi1G3QgwDhG	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1602	1369	97	1	6301	jx4ewMz57aBCDntn35FWJxWmr936UmYNaizH3u19ApDbT9sUkBt	4295	6062	6062	1617030360000	orphaned
8301	3NKPPrc3s7VkojxtJRGUthjY5resBwq1Ep5Y3PbZhJL49HurhDYq	8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	1648	1284	97	1	6301	jwhsMaH2iZMpPK313ca6qK8QZE9eFr5Nkh7rgGm2sgBA97uwUwL	4297	6064	6064	1617030720000	canonical
8318	3NL3fbnr5SFJ4HDVr9f4F43TP1UD7Vod3QyD7ijNRcsPZGMtSTdn	8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	1559	1353	98	1	6301	jwYpjUtUrscn3FW7fukHL4tprs4Xs6CYFygDqtpkg5vrKu517hc	4305	6074	6074	1617032520000	orphaned
8320	3NKTLHnvDtSQPX6jFdAQUq7of9YLWB2BzheLUCnttFU5hC1sDgLg	8319	3NK8mrSEc7e6umMEktgWRrSbJpCJj6wHnub63vE9KyKCtB5bQXVr	1460	376	98	1	6301	jwrTo8SYRKbbSgJpHHYrikjMevJKG8FJLKgo8DR6RiY8bdP9c77	4307	6076	6076	1617032880000	orphaned
8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	8323	3NKjSzUjMmbSojrzocYKBdYptKWbdLecq6CT49Qp7zTERXhhjvvG	1637	816	98	1	6301	jxdoViA85HH2qwL2osfWKsWTijnTUPKThszyu64wysK6gNFZED2	4309	6080	6080	1617033600000	canonical
8328	3NLAiyGuUp1w59DCxmRDCYBERfEdYCY6zcYZxTK354NgSV5FUXFi	8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	1631	794	98	1	6301	jxuCWSzJ4u6JtSZB2BxaAUMmMcgXT7J2Vv8AiN11oCt52bZXNw7	4310	6081	6081	1617033780000	orphaned
8330	3NLGb5WtrcNAL9W9brvrSeXrbfozqGouM8WP3EpHxE5aisszxjFv	8329	3NL4CqDZS5tKB4AH4K16Bz5kH29VY5KpZVV7aPQ67iF2FCf6VZ1b	1637	816	98	1	6301	jwMPx2u2B6A5gPxg67idgqSruhZR1yNP9WJCpZ9xHnNZPQmnMEb	4312	6083	6083	1617034140000	canonical
8338	3NKeMctuZRTFTB9RQKB7NxSVa8KACHtB393eNe6S5F3UajNEzso7	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1420	403	98	1	6301	jwkE2HtdN9krvxkpV4e4kTPjRKhUexPeHDibmV4aUQTL6L2p5qL	4319	6091	6091	1617035580000	canonical
8342	3NL7UEwXBM428KTiMvAtewEKzquaFj1XnuVxaPsoL2KMoaF1ahf1	8338	3NKeMctuZRTFTB9RQKB7NxSVa8KACHtB393eNe6S5F3UajNEzso7	484	1319	98	1	6301	jwYU2dcuxfFzkoDfnLHGVETib6WR3Wj39Gtw7AjCkJntscaGpaL	4320	6092	6092	1617035760000	canonical
8348	3NLqYYeK9QoNovQ48zXnZy83yv2jZPGMhPDENBdLuNQnqGiqWYUV	8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	1654	1094	98	1	6301	jxdyjVZmQj3xq5FXov87D8cMCrF4k2em8wEDqDkVHLTD6sR5b7b	4324	6097	6097	1617036660000	orphaned
8350	3NLZvw5L6mGd2SJrygVsHxjwKkPqW3z3i3coAi9WiZ42vSTZFzRR	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1656	1343	98	1	6301	jxcxLF88DStJCyaL6Y5CLyc6L3UA11T58ZmQdcJw3hSJWcEPN8w	4325	6099	6099	1617037020000	orphaned
8355	3NK42YXYVG4h6db56hKXqre1rPNfA5xYueGK97DomVU6K8LAXjK7	8354	3NLX3LGSDXrx8YspeMxSUjH5AAVYerjidzpgTXukudGsyiyAYfdm	1406	1393	98	1	6301	jwPyhkzWZiPUqGa4arA1Ghb1XS3vv3ppsKDoMwfQv7pwd8MdPyh	4327	6104	6104	1617037920000	orphaned
8358	3NLF2JAidWT43tiRtUP3jYXqytwgGPRihUipSp3hqAL9RPtKdR8B	8356	3NK4WJN146PFpM3odAQc68TfzhqH2x23iDH8KBrSYSfpZ3SA9wBr	1513	1379	98	1	6301	jxWFjskZFkm93kkc8bz4nUFBeAD353NQbzD7hY2P4oBwMY5u5Ei	4328	6105	6105	1617038100000	orphaned
8361	3NKt17qBGsTGejUSHFvNWUNVzEGeCT4ZMQucjyk4yqXkkLcs1Kxk	8360	3NL72jiJEUVxsE1Y6YVXstKSK3ZHJsXfdEncnCAUvhEdrt7B7FSN	1534	1191	98	1	6301	jxXuygW3dZMjyt7qWuf2dhMN3sx3xRDCBdx6PNPX8M46RXTd4sJ	4331	6111	6111	1617039180000	canonical
8364	3NKx7rpKjGLHXmkYwfp9TbL1rDp4mXyNTiUzKCjk5N3FQGwDGi57	8363	3NKa1NdTBSNXkYsbp4QDgBSqXZ1ovm1LDtdVu1QKc6yyBhRP6hNR	1397	699	98	1	6301	jxEH54LR6LKW27R7CKBf99FBHwaa6byena9izzgwBZZseuYPKpK	4334	6115	6115	1617039900000	orphaned
8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	8365	3NLAeNmLAEjLppBH21bcK97LDCwszMvpEKQ8PQB2H6ddgD2VBWqd	1592	592	98	1	6301	jxJ7Z1u4pz5y7DWhebtnPW5XKmkxZGqUbyq7qMaraahWbz9kdcH	4335	6116	6116	1617040080000	canonical
8371	3NKw5NtoJrvSpB5tvUpocDGJ9Ge1T7AUSNApCmQtxrvaT6yjFWJU	8370	3NLkQ4J2ds98mZQ65CCjpdkduuREqseqXGA6JXZXoiRcZ1jeKrdK	1588	1392	98	1	6301	jwM7Zb1ExUNWzjB2c8uHm7L3Hbjk8EnXUtG3ncEJpjpG4TqAQBr	4338	6120	6120	1617040800000	canonical
8372	3NLnaDmA9pKigRN4NF8ZQcxRHE7DTuUGNSebuKB1QBt8cTFPgfVb	8370	3NLkQ4J2ds98mZQ65CCjpdkduuREqseqXGA6JXZXoiRcZ1jeKrdK	1455	1332	98	1	6301	jwSG79W7TPbEnDgiNZ3e54waN2wHXsV3qgGZcT447ALnPnMpiRF	4338	6120	6120	1617040800000	orphaned
8374	3NLfrq4cWKGAK4Sn2nJGEEGPth8dH1JHGJHf837YPHYtWknrTLHT	8373	3NLU75wjPNVdMWNhvX9rF7ukAZPMwBra4nPQbjkGPG4LNUYwxtkn	1549	996	99	1	6301	jwDtcFH2ovhJXTXLhCwFmsXgwVc4gejzoVjyxxP4185ctDozaMc	4340	6122	6122	1617041160000	canonical
8378	3NLyEN4Vk9fQ8CfY6VJy7qPSe5Y7ZFkw9kYx9WoGK5psfSWMUU8Y	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1527	927	99	1	6301	jwEaCpWTL5TD3v2arJZ2xoh4y8nDVnP3DSfSAk66GZyn4y6RueH	4342	6125	6125	1617041700000	orphaned
8377	3NLspsAXXyBgCTyZkjncLP8AdTkF9NpotNiccRdXhheX6m8XfEDz	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1642	1121	99	1	6301	jwqVVh3gPK6M5D5FMhMHNVHtyp6gkWzeypxs45y7X4oAM289Rpy	4342	6125	6125	1617041700000	orphaned
8382	3NKYuroPpwtWUYDZJgzN22mh8BTPXqwA5jheFipo7FkrhbWFf1Jz	8376	3NKKBSikDwHLnj9gwR6drFM6MW8m8WM1MKABJw5soz41wv9P5cKV	632	1136	99	1	6301	jwEaiRw4LScbciMSgCpjNgxhJfqTTjmNwfmcazqyJ1GtWe1HH5u	4343	6127	6127	1617042060000	canonical
8381	3NKdjFR3zz937CASQwaytjKeNE48YiMi9ZvknmTZYL3DA1RoDVei	8376	3NKKBSikDwHLnj9gwR6drFM6MW8m8WM1MKABJw5soz41wv9P5cKV	1460	476	99	1	6301	jx7jiQ2pqLmUwsLBiAmrGkKBFN7uRAV2QRTN2GjmYNcxkgh5MRz	4343	6127	6127	1617042060000	orphaned
8384	3NKoLRWeib5cUC72MPcjWqpLdKtT8P67ik1gM3n3L7nZyFamRoGZ	8383	3NKoUJJ6pes1wupYeBDXMLiLNQ4RKVqhHAwA8tQN4Mfowhpf9cKb	1503	1277	99	1	6301	jxUemNZDPe377bAHyxbes95TRAwfg3Wo2q5kVniGEJ9gNubeGwR	4345	6131	6131	1617042780000	orphaned
8387	3NLGKbit7x5KVYyn7ezQ41gc4uKigatqpykqE5orbNkw2yK34hnJ	8385	3NKXvrzDbMTXctrBQFNYtX52fqMvusTkLgWEKbgm99DCzYwe1qCD	1613	983	99	1	6301	jwY4iDkS9EqJJuGsoNtysBassjbBR1LjMH1EgxaDfxikMWdHDAQ	4346	6132	6132	1617042960000	orphaned
8389	3NLgAVqSrtZXEcMPcZkuKvLmNngqx45wiGa7ZaP8H3jaGrQ6i9mf	8386	3NKikugdrM9Ws3DFxPgYBfHRXFyC8gBUSSDZwD44boJs3bWDmai8	1634	1085	99	1	6301	jxU89SnDeJBLLKkkRh1tyDQhFeAsUSv1w2CVeM7gGtcCoz23oY1	4347	6133	6133	1617043140000	canonical
13800	3NK8mVyLaGXKbgUVLGE8uXyMS2LwBHu7XKeynXfFfUrDjrSg392m	13786	3NLGnjSrQYgcEXrTHaQiqUyJGNcH6Y1SPH5CyJKNk2Lf8yMWguWn	1405	851	209	6301	9994	jxqUaBnooJ7XAZZR3yeBd5UniipmZdcgjJhaurCgxErwrVZKUBs	7083	10019	10019	1617742620000	orphaned
8286	3NKBEGkfEVGf8yRQWdwxyS6GxhxytUQavYLHy6UeEbxgpSwTZbuo	8283	3NKNT1PxwvuRDqEvZnY6Lxe8FucMnSvoRvGNo9yTBcfmryMMVtxm	1637	816	97	1	6301	jwtQs5Ghz4BsG6BkVXP433Qx13ucDfmtiLE9ookcAc8msZ621JC	4291	6056	6056	1617029280000	canonical
8289	3NLRwiPLfGYMwLSXvzfQVyJX1oC3srBEvFowrw4JHhRmKPkSCy6e	8287	3NKjS9AWyCMYGfyeygcUUhrWixC6rVjpZ2XnZQgzCQdH52nqKGNU	149	1157	97	1	6301	jx8EyM8PLUDGEtyRremLFbixPYEVFKhQs4VxeenNgE9Zory7cS9	4293	6058	6058	1617029640000	canonical
8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	8289	3NLRwiPLfGYMwLSXvzfQVyJX1oC3srBEvFowrw4JHhRmKPkSCy6e	1601	1388	97	1	6301	jx8eb8MctPCWYydydPGKyabrB2TK5p1pBbNm9t1hMSzpt2gG2tp	4294	6060	6060	1617030000000	canonical
8295	3NKBzWzWLqHF3NWu6isNd13k8B8kUEgii5GjgpTbxU4XFkPG2RP4	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1476	1371	97	1	6301	jy1vpkZAEHySuAghKUJyZRVERuQLadNYXiM7uFBCdmV2iirgQ9G	4295	6062	6062	1617030360000	canonical
8294	3NLFyvtgThfDhrSA9FcQGwA4hqANHTFfV6d5f3SxcjdQnPiRrtZR	8291	3NLRUdh5LKiwKL9moYKwz3VY8w2hD46finyqWCXiwJ3opfTPVYtc	1602	1369	97	1	6301	jxRnAzaDVz64SBczgF6YSyTNpz8FDpWj5VW87J2L8Y3jwjVYYt4	4295	6062	6062	1617030360000	orphaned
8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	8295	3NKBzWzWLqHF3NWu6isNd13k8B8kUEgii5GjgpTbxU4XFkPG2RP4	356	356	97	1	6301	jxGgQz8Jh6tETWRjZb3Z3GAyk69shn4RefVDuLxAntUTYu927Ug	4296	6063	6063	1617030540000	canonical
8300	3NL6YXk6ZsZQ3VjCer4HphmHs95PbB4ayuapn8DW7FTbEBLJRmHc	8298	3NLGTk71aEnJEnimm8Bjzzrnsb2Cn5mhUajztRLkRnhGtPrcj6Dm	632	1256	97	1	6301	jxAobbN3REU3jrvAdmycLFVYyf47k8SKq5KE3EQymgEB1Y3zKCp	4297	6064	6064	1617030720000	orphaned
8303	3NKbJRPGGKgwXdz1eGy1mA6gwaY6CYW9z6J2y5JGhpdAFwxJHbJA	8301	3NKPPrc3s7VkojxtJRGUthjY5resBwq1Ep5Y3PbZhJL49HurhDYq	1403	824	97	1	6301	jxcC8k4tQ4W3gfQEA5sUW8cHoz5xME22c4b2fB4uYx4GewZwC9B	4298	6065	6065	1617030900000	canonical
8312	3NLu21XsAs6pEGks2z8bqzHnbtA9rXvxErynd3ZJNkf9KSUiUpmo	8309	3NKfKjbRAqHKyvdhHWNZGF31ugmV698Upa8ccUFh7Nb5XTNCJZCW	633	1384	97	1	6301	jxc6dCXypComYdG6tkDLHhREDrTDJ9UVoD1qM8ENMzAkYqpcBAc	4301	6068	6068	1617031440000	canonical
8315	3NKCnJQXjwEHRJ7Sj49gg9DP7na3WqcXWkYZ564SBe8zxQ4UFmDB	8314	3NLupN8KG6vMnwrj3f72YbhPidXYpUpAR7JbwUofg5E28ie7D2yw	1553	776	97	1	6301	jx4XcYxdqztHEtseaSsEKEst1TJR3UjH8uxozgTUcqfUtCFMK8P	4304	6072	6072	1617032160000	canonical
8327	3NL7oKyTLdJtrJXra9aJLWXfKqjY8MpAhmLgAc3LkqtV81JSmTkr	8325	3NLk9EHA28v7gQgks3YvJvGXp7rdc8LhyLxo1JkBVWbc4iiXqNce	1403	792	98	1	6301	jwaEBUNsFWd83QFczJ26B8FuTwGfdbpqyZiovSjgtD6dgEhQ4mA	4310	6081	6081	1617033780000	canonical
8329	3NL4CqDZS5tKB4AH4K16Bz5kH29VY5KpZVV7aPQ67iF2FCf6VZ1b	8327	3NL7oKyTLdJtrJXra9aJLWXfKqjY8MpAhmLgAc3LkqtV81JSmTkr	1541	1298	98	1	6301	jwykAboPjKXbuvhD1HACE4BT5xVyYHUjRnyAA9mnRBvg5nR81Z5	4311	6082	6082	1617033960000	canonical
8332	3NKoTNDSLjMsy5cmpGzz27xwShpyMbYLa7mxVgdqde68eyvcY7vZ	8331	3NLBG4AxqzQWgN2qyp3XA7DeuVa1VZBZ3iwwcGmB5gAMEJYj5aQF	1460	1198	98	1	6301	jxcpVNWESe2XdZxq9mk42FaPBwW3z9Rb4oSqr1v4rHxKWPRgjRf	4314	6085	6085	1617034500000	canonical
8335	3NKkWEQ6YrmBaruQz38bs9rHj8SGFUdTR4e4XXrrN48Y6jtRFuXp	8334	3NLNS5R9j1mj11ieqhu4RMpXtxRW375mcKaykAR3zRsEhEQSxjTy	1581	778	98	1	6301	jwpCet1g9KcgCHWLzmunvFkt4VBnexeszwVgAdZ8WeVVc25x5HV	4317	6089	6089	1617035220000	canonical
8341	3NKHWat8W4JLofAuUuRBTNTJm6siBy9opBnu5wzaMFB1fT8GGjNV	8336	3NKznsMrebPTwTi3Rc8hkS7nhwMqAD1tfMW6YU85skEjefKh5mGw	1581	778	98	1	6301	jxkfgpjCUgeBH79tjyYYnqWNrqwgBBPwMLRBiRBzBxKKiKrCNFP	4319	6091	6091	1617035580000	orphaned
8344	3NLeZwvLQbRfU6t5CFB2oP9r16dLWDkocmaePCiRK2emZ1Ms2Lsq	8342	3NL7UEwXBM428KTiMvAtewEKzquaFj1XnuVxaPsoL2KMoaF1ahf1	1534	1317	98	1	6301	jwTUo28WKULmtAmPMZphgq19aCB4tyRnX5zMVYkiVmxzHe1Vkek	4321	6093	6093	1617035940000	canonical
8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	1403	824	98	1	6301	jwZJtq8vfQrHFG8tuMZCZF4ppMzQEe5TL7FHecSfk5tLJFunFXf	4324	6097	6097	1617036660000	canonical
8347	3NKabXvZUcaGCatdNSFBhXfjCdfhgQcWGTg1kJrpbjphSsEi5arX	8346	3NLCRVFBPVX9zUExqJkCskgAvntcVwn2UBFe7fp11t9pHdLFE5K6	1406	1393	98	1	6301	jxQhZtiF4WmgHkFEWSfCZFiye7fT4uwRfJGMBk89Vro6DTKJiAS	4324	6097	6097	1617036660000	orphaned
8352	3NKEoMSQtcAfntiYjNXN794b243ezvfrooqdwCns5gQ7nRESZ6MV	8349	3NLCW2fDp8s21wcWXuJf7CzEEiZg5GuWof8TnWxiAVbxcgPCXvFh	1637	816	98	1	6301	jw7QzX1xhVpVLtn7TJZtArY4tDyAUxSuUGRc7vahxBoCM9huVoy	4325	6099	6099	1617037020000	canonical
8354	3NLX3LGSDXrx8YspeMxSUjH5AAVYerjidzpgTXukudGsyiyAYfdm	8352	3NKEoMSQtcAfntiYjNXN794b243ezvfrooqdwCns5gQ7nRESZ6MV	1407	1395	98	1	6301	jwb58Dd5HHE4WNYvNCbU6WJj7xwFG8FYEs7JBnzWsHdcLUrBp8x	4326	6102	6102	1617037560000	canonical
8357	3NKzrans7HmZDX4CjGG2vmJu64LKe2yAsSg7pAJY3BXYMoZuh5RY	8356	3NK4WJN146PFpM3odAQc68TfzhqH2x23iDH8KBrSYSfpZ3SA9wBr	1511	904	98	1	6301	jwMB8RoUbevsQo1xBLY47wJrb9nb2mQyDuLeJYALJUm4LX758zY	4328	6105	6105	1617038100000	canonical
8360	3NL72jiJEUVxsE1Y6YVXstKSK3ZHJsXfdEncnCAUvhEdrt7B7FSN	8359	3NLvwY1pnyvSGsKREZhcwxR7hGVnSQzMCCKJD8eAoEuJs6X3z99S	1587	319	98	1	6301	jxSKatkhvtF9tuHsMKiSoAgZHheURDZy3eX49YbJvQjtDZntETD	4330	6109	6109	1617038820000	canonical
8363	3NKa1NdTBSNXkYsbp4QDgBSqXZ1ovm1LDtdVu1QKc6yyBhRP6hNR	8362	3NKkDcksAb3UpvM1hgrsgBsWaCUHHuaTU1xqfEDCLEefUNaEutUg	1407	1395	98	1	6301	jwnHpE63CvFxUYM8KoaHKwuCJRdR8iav5rk2Y8V5DUoZjmMMbaB	4333	6114	6114	1617039720000	canonical
8369	3NLEE1ACAfkWuujjQu1XGGUgFoxNW55rnyKYzkdErPP5TcsV1mEA	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	1403	824	98	1	6301	jwb6PcuHEUgYNbWWjetoqTZUVEQYL4sTosmSpCiG2dGZQQXZZ8b	4336	6117	6117	1617040260000	orphaned
8373	3NLU75wjPNVdMWNhvX9rF7ukAZPMwBra4nPQbjkGPG4LNUYwxtkn	8371	3NKw5NtoJrvSpB5tvUpocDGJ9Ge1T7AUSNApCmQtxrvaT6yjFWJU	1578	930	99	1	6301	jxpr57tJrchyk6awxA65dEz73Nq4y1CWw5JGwD15oBe3jZdox7e	4339	6121	6121	1617040980000	canonical
8376	3NKKBSikDwHLnj9gwR6drFM6MW8m8WM1MKABJw5soz41wv9P5cKV	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1406	1393	99	1	6301	jwV1Zg5NznJb6n7kThFvYyLiqMyHnT9iMzpRV7rwLADaWD1dPbV	4342	6125	6125	1617041700000	canonical
8380	3NKsa14dT4HKwLXGBahPBxM5WeunLWENsUXnHcM4tV7JRcwFwFY5	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1407	1395	99	1	6301	jxhmboYUQRbNizhqWSGfhMjLSTy1SpeyckD17vfMbPoCKTE2SvY	4342	6125	6125	1617041700000	orphaned
8386	3NKikugdrM9Ws3DFxPgYBfHRXFyC8gBUSSDZwD44boJs3bWDmai8	8385	3NKXvrzDbMTXctrBQFNYtX52fqMvusTkLgWEKbgm99DCzYwe1qCD	633	1384	99	1	6301	jxGMTTpupX3JzxNxKhMhqm9k1kGHeJSqkDWV21JzsLVidKZj1Wr	4346	6132	6132	1617042960000	canonical
8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	8398	3NLN8V6Ro7RB8igatqMKTtzKia2S2K6PAWeKkf6Qd6T3jjknnNUa	1590	934	99	1	6301	jxe8jUg1oTrEA81EuspGGwswWNTBj5AgsGY8bUXmqRoUz4LV8BR	4353	6139	6139	1617044220000	canonical
13794	3NKJN5nYtKbJSLDicVJ9PDRGsDceKTDmn7unF4mKaM1X1RsLwwRx	13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	1559	1353	209	6301	9990	jwcm1JxNaDZsSvzaSKZcqQjHMgKwMTqRqzoy6GtQeEhsWeuauAp	7084	10017	10017	1617742260000	orphaned
8368	3NKEKeuMuUfPyiRPUsP3uNqvtJiASGrxnTRVYBP5cw48xZmKjQYV	8366	3NKtL3dHDY61ED3RZVN9E5kT2mNVmrhgpfAy6KhYAHuyrd6HuqYB	448	939	98	1	6301	jy3ATaD4HpuJb8DWiwRaiibpCSx2k2kR6nrhJG84dr3SCXNgHk7	4336	6117	6117	1617040260000	canonical
8370	3NLkQ4J2ds98mZQ65CCjpdkduuREqseqXGA6JXZXoiRcZ1jeKrdK	8368	3NKEKeuMuUfPyiRPUsP3uNqvtJiASGrxnTRVYBP5cw48xZmKjQYV	1546	1339	98	1	6301	jxc2psJ5zoWWesr5fcd9TKEjya8UweWB3hFfyxpm6wtULvG28WL	4337	6119	6119	1617040620000	canonical
8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	8374	3NLfrq4cWKGAK4Sn2nJGEEGPth8dH1JHGJHf837YPHYtWknrTLHT	1643	1299	99	1	6301	jxxCArNv2W3kHk6hQaV1Pw8saTgBLDn18iUpvhj9xVX6xTABAVE	4341	6123	6123	1617041340000	canonical
8379	3NKTBrJD5iSptmyNoZ9KDLuZDy28ycPuT3PTg7Sx6kscXDGN5C4z	8375	3NKtSpoK8rn45yEpfGQJv35C5EqbHafdgTrmaDuYao9YMXU1AUHz	1649	1383	99	1	6301	jwNSmzFfrD2Fc9RsMk2N7LDZnSVgeYtNvQzzLoJWKEjVEBsnVaJ	4342	6125	6125	1617041700000	orphaned
8383	3NKoUJJ6pes1wupYeBDXMLiLNQ4RKVqhHAwA8tQN4Mfowhpf9cKb	8382	3NKYuroPpwtWUYDZJgzN22mh8BTPXqwA5jheFipo7FkrhbWFf1Jz	1549	1362	99	1	6301	jxdo85wDCjZmqs9eeXEhFYR4zaYcw2gmnNkNQTuA1YjmmGw88PP	4344	6130	6130	1617042600000	canonical
8385	3NKXvrzDbMTXctrBQFNYtX52fqMvusTkLgWEKbgm99DCzYwe1qCD	8383	3NKoUJJ6pes1wupYeBDXMLiLNQ4RKVqhHAwA8tQN4Mfowhpf9cKb	1652	1189	99	1	6301	jx5d2X4kRQePV1XfTWrEgERQcFcagQuouYoZDbDfzNyRmvNFNeH	4345	6131	6131	1617042780000	canonical
8390	3NKBdXYrcxsWHZmssfp6zbtyY1pxGXGPtQVCQzA1qHpUxgrATpJB	8386	3NKikugdrM9Ws3DFxPgYBfHRXFyC8gBUSSDZwD44boJs3bWDmai8	1405	867	99	1	6301	jxqUYPawyjpnkksvQFMXhBUVu62aTgTMLDKTaLTktx6sJcNj3Qg	4347	6133	6133	1617043140000	orphaned
8391	3NKF78nrvxw9QxVckYfkwatWXyyLMNHFWwD47QXdgkWNexQXc9Sf	8389	3NLgAVqSrtZXEcMPcZkuKvLmNngqx45wiGa7ZaP8H3jaGrQ6i9mf	448	1305	99	1	6301	jxqXLkLb2k4qJX2b95aYrUyjZFBv93B7HhL4JVhTAQezpnJG6u9	4348	6134	6134	1617043320000	canonical
8393	3NK3q6yG18iSJaLiTDFmEJ5oJJJZr4wX1XCCsMG5ccVGj1NqNyW9	8391	3NKF78nrvxw9QxVckYfkwatWXyyLMNHFWwD47QXdgkWNexQXc9Sf	470	1063	99	1	6301	jwNKKLgb8a3JJAKunVdkHjY8AYMo55PMWVGqYBweYMfksGboqPg	4349	6135	6135	1617043500000	orphaned
8396	3NLkQFTCMP5kjJm8yw5TyYVPEvxCbShRVAwHZ6f6QSGCjnN6JJqD	8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	1407	1395	99	1	6301	jwuKsoNuM33jDuuC3Qr3VqXgeL1HayMQeuf7azEZXX7u8YouH31	4350	6136	6136	1617043680000	canonical
8394	3NLZYnHR32GsEEPvxdYp7bRfx8qcjvhRhcBu5A3CCAZTaCed1H2y	8392	3NKY1zFEmW2sjy7TJn1sMDYmVwJad1uQ9rK9ejeor3ksE6oTbbKT	1406	1393	99	1	6301	jxnJCDb8u4X3yddinmdQsQ4uNpdqQjL1xkjqqHVCRayDsma5HuD	4350	6136	6136	1617043680000	orphaned
8397	3NL5YQu2gu89o4oiFDQvU1mTNsyQd4E5XrsBPfs2WEma1h7RXXLm	8396	3NLkQFTCMP5kjJm8yw5TyYVPEvxCbShRVAwHZ6f6QSGCjnN6JJqD	1617	1042	99	1	6301	jwrN2CjpQ36NSQtAG69UgFXBoeXFo6C366ssmeDri2KWXxFVBKV	4351	6137	6137	1617043860000	canonical
8398	3NLN8V6Ro7RB8igatqMKTtzKia2S2K6PAWeKkf6Qd6T3jjknnNUa	8397	3NL5YQu2gu89o4oiFDQvU1mTNsyQd4E5XrsBPfs2WEma1h7RXXLm	1675	1342	99	1	6301	jx7yiQQm4eTr8215znFYxwepoq8B9qRsV2qC4YBeM5WujtdFR5M	4352	6138	6138	1617044040000	canonical
8399	3NLMxxmv1CbnGTE5v9dH9G5PqBBaVDoqt9sBhg3a3FJ377vm5sJM	8398	3NLN8V6Ro7RB8igatqMKTtzKia2S2K6PAWeKkf6Qd6T3jjknnNUa	1654	1094	99	1	6301	jxaxU54ChiR1VoxEgo6tgtUcHc8jN8WjTddTGf9dGruVaGXthGj	4353	6139	6139	1617044220000	orphaned
8402	3NK9fuKzscKZNoiRcb1WXpk662FEb6jFTHVVNjswB2KEWo8vbhgu	8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	1405	867	99	1	6301	jxZb7RACp1FCKYDyDMNQC8R82NdWKoTJ7RKGKAE7vou1hf4zjJ1	4354	6140	6140	1617044400000	canonical
8401	3NKE5LvoGPpP6n6cBhrRNqskEKEEq8darVAXWUgfR933119xTkMy	8400	3NLgvMPP5wKsJkKQpZyfNhvg4nAdeftyo6xyWN2m4xqKGqkmxtsp	1542	1304	99	1	6301	jxRGBCRQ8yXKvXBpJsxdVG7PHmAUMkNxKTbjfA9UtJG5uqeQ1EY	4354	6140	6140	1617044400000	orphaned
8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	8402	3NK9fuKzscKZNoiRcb1WXpk662FEb6jFTHVVNjswB2KEWo8vbhgu	684	1352	99	1	6301	jxNvrPixaTBLhmHmQs7oTvujhxgWq5dqLPphDYtqeYYJWfoLBhf	4355	6141	6141	1617044580000	canonical
8406	3NKXPGghsiPGqaHvf9EuCuDVuA7F4aQCVPsWksoXxZr6me5Kipij	8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	1534	1317	99	1	6301	jx6Ky6koUCLowyBqFmb2YjMuhSuWDLz9R5hJNAWCUGSvP8aTL9W	4356	6142	6142	1617044760000	canonical
8405	3NLwtmAuRANacPKT3yA7gesvk5kkPePaFCqA3XccNyNs3xm8kb34	8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	1403	824	99	1	6301	jxVSKsNxPQxKFmuVGoTp8cK3aMo6RwURi1cZ2mkDQjNbUJSCRvV	4356	6142	6142	1617044760000	orphaned
8407	3NKxTNcrAgXUuhFBeLABH1cJNV9tPCu8yMvoioG5cWSQAEz4AEBb	8404	3NLFedPCXbVbdVaY4QpDq3jtyd2k1Ka4YZBwWEa1rXw9tj2EByhp	1631	794	99	1	6301	jxgrMkGrBXTQZDbihz6eq17iiHKUogwSu1RYvUNo6UBZThbXqQj	4356	6142	6142	1617044760000	orphaned
8408	3NKaGQ8Bebum7JSyFuPYFpgcvnKioYmKYr9ENr1ThfyJzP7qj4HM	8406	3NKXPGghsiPGqaHvf9EuCuDVuA7F4aQCVPsWksoXxZr6me5Kipij	1407	1395	99	1	6301	jxUeqNGkU9GTYtwynfSZrLy4EWpMNjqbQM6RdGjF9qN3SyEsDuF	4357	6143	6143	1617044940000	canonical
8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	8408	3NKaGQ8Bebum7JSyFuPYFpgcvnKioYmKYr9ENr1ThfyJzP7qj4HM	1553	775	99	1	6301	jxqq3xMYgYs834h3rJ7CoHD2s1U9WMezR1772qfwxTmf1TkLZZm	4358	6144	6144	1617045120000	canonical
8410	3NLkqUN5YnuiiYNvBfq24KT7BRqZ4d2pUk9pFAQ9T7hRSKdsBhrY	8408	3NKaGQ8Bebum7JSyFuPYFpgcvnKioYmKYr9ENr1ThfyJzP7qj4HM	303	303	99	1	6301	jxcNiaVZi7Nhjk5LmZQGCr4RjGeHS3DKBHD8dsxUjtkWcv3fQfn	4358	6144	6144	1617045120000	orphaned
8412	3NL8mAfuynWf7MGTuMjhzdAArLYTJJzKy7JsXEwvTpWwDmArtVgp	8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	1501	1360	99	1	6301	jxTSLxDPntaws3iZsEByD2Uzc56rVbe8SNNvc6BnZvrpQq71i8F	4359	6146	6146	1617045480000	canonical
8411	3NLCcPAvbiW78DMeR8hM6zv1aJvbkPtDSqfma1gkRGpfyXxxXfDe	8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	1406	1393	99	1	6301	jy1w39XNh4rXGKPeSBCCZ3SDWqgq329BUx4AznX6H8YSHF6yW6U	4359	6146	6146	1617045480000	orphaned
8413	3NKaWcEyYPBgGX7JWDxYyMjwAU1QtUHMWvcFkfKfmjs5bZgkVUym	8409	3NK9tR3hBQrGdHY5htk9mcKajDRGDn9JdsR5yVb3VKF9KEHaekmu	1581	778	99	1	6301	jxgWTyjoNGtFHcQzyLsmUudTcu44EiNy7Wa9F3qGqDpUefFB54R	4359	6146	6146	1617045480000	orphaned
8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	8412	3NL8mAfuynWf7MGTuMjhzdAArLYTJJzKy7JsXEwvTpWwDmArtVgp	311	1307	99	1	6301	jwdhhC7r1c713LVsz5XURaNCj4JeP5ZXVfeJKPHAj9QYxoa1YkN	4360	6147	6147	1617045660000	canonical
8415	3NLxvdYezt7ZYtQWR1XQdi7UUhTMMn2yFKu85hPkPZ1J9TZPmksA	8412	3NL8mAfuynWf7MGTuMjhzdAArLYTJJzKy7JsXEwvTpWwDmArtVgp	1631	794	99	1	6301	jxreP5EGfnPX2pbK1GhcdYDPsxfuaHWnmy6Q2DW4uSzbLQzRpDd	4360	6147	6147	1617045660000	orphaned
8416	3NLCD6WhZggS2cjeWv1PpuSBxpdmLwjipJbeJ7ewhjSZzqLuFTaE	8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	1542	938	99	1	6301	jxJPpb19h8zTHXysLgC1cq6DpQHkLZL5tT4RGEwW2Qx4XeTQTAo	4361	6149	6149	1617046020000	orphaned
13807	3NLnTVLGJsUPVr1Rmh7gEpzb6i8cSXjJNfNCEw6usjadQjJ2RiVA	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1649	1383	209	6301	9999	jxLQsxj4YiAMboNWRpLfkzUCXRrfvACorrbjVmRGiNtqmkmCPWG	7090	10025	10025	1617743700000	orphaned
8417	3NKWiarbhK8zabTn5YAtEqSZcvss3iAC6sqABQkSz3cVVTXghYZv	8414	3NLE5frbjK3mPCw5k3Y6dzLMqGn2LM8qwDFnv4bXwGjB3Ja7fyFR	152	1330	99	1	6301	jxjqWJnQPEmuhMvYLKoVGJpeWYRubMWx6sdhJ2aZZnzAYaM1mkG	4361	6149	6149	1617046020000	orphaned
8419	3NKVeFqpfMNUFPpTPHxVopqg8i87YnihBibxntuNW6ogLs4bGam4	8418	3NKEHE7nRnCkhfs9QCC5yD2CcHCBPsaZitQGxUhmTpDUCRRdVRBF	102	102	99	1	6301	jwnGbzFa9t5Ze3iBxo94QkEGLr7pRPPHNUBrqmb7DTAhnXwVvxs	4362	6150	6150	1617046200000	canonical
8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	8419	3NKVeFqpfMNUFPpTPHxVopqg8i87YnihBibxntuNW6ogLs4bGam4	1460	1324	99	1	6301	jwM7CmA8v1oufkZVhFo2kWyDtKwx2mBEdR8TTDMzgL21Ro8safD	4363	6151	6151	1617046380000	canonical
8421	3NLLbdrjkAoLHK1nGQJKBpCfz3kS3wQuEZnAs2QGLGaXt1QBwE1V	8419	3NKVeFqpfMNUFPpTPHxVopqg8i87YnihBibxntuNW6ogLs4bGam4	1407	1395	99	1	6301	jwihaefzq6bFyE8ihXPN7siT1H23p4Ud9H82Yj2JJMizK6LeraN	4363	6151	6151	1617046380000	orphaned
8424	3NL9D48fpZKvd9cDe5ZgDaGVn4UgeFzQYxHzs9FNXSTE8VRu2VLC	8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	210	210	99	1	6301	jwTj6k7wAGF3AwSfY1Lkb9d1jAq4Rk42SrdEE716sqdpDEGTHXu	4364	6154	6154	1617046920000	canonical
8422	3NLTe2yb2LhoAqzxU8DukKeit38AkbVxmuwf8sHbPs4rkEB3P8ji	8420	3NLSEhccFhpaJQtAZirPBYK5j8YE1ZRaosj6P5vHCUVLi6pkob6d	1536	1067	99	1	6301	jxJVjqP2oHc3CChwnM2cKoDdCuGEYv6H2ySyiTuHHXWUniwzZgc	4364	6154	6154	1617046920000	orphaned
8425	3NLCv1kKoSZdkVvdrAMtBa4Hrxm9thQkvJrCqT1b531KcHzmnGUS	8424	3NL9D48fpZKvd9cDe5ZgDaGVn4UgeFzQYxHzs9FNXSTE8VRu2VLC	1406	1393	99	1	6301	jxnzx9zkRz3F16KgJasosMcq2vp17NT4v4ekNmJTkvujpUoMtEd	4365	6155	6155	1617047100000	canonical
8426	3NLE8yX9iDX7c6q4h66PGgDSmsn7QLyLWmETeeSNSr7YxbdSDSGe	8425	3NLCv1kKoSZdkVvdrAMtBa4Hrxm9thQkvJrCqT1b531KcHzmnGUS	1406	1393	99	1	6301	jw8RdFhZFVGpFtWNDGoQfMV63UV2sZ8rsgJUY5MmhjK1bDaT9DH	4366	6156	6156	1617047280000	canonical
8427	3NLNPxhhuXUg3s6b4PwPDwXuNQ4hSPv4tuuojLPcnxGySeboFhnT	8426	3NLE8yX9iDX7c6q4h66PGgDSmsn7QLyLWmETeeSNSr7YxbdSDSGe	1671	1365	99	1	6301	jwusM6qqmwQtoQjYYKC14YJUMmVkaixmXis1tNd5g2ZiSRepHME	4367	6157	6157	1617047460000	canonical
8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	8427	3NLNPxhhuXUg3s6b4PwPDwXuNQ4hSPv4tuuojLPcnxGySeboFhnT	1534	1317	99	1	6301	jwD9e5ciQyjfCmSFJzDkY6ww2xctoDeaoK3qZLgBcKEkEYMRn4U	4368	6158	6158	1617047640000	canonical
8431	3NKmmLYf2udiLEGtw33ofNP2NwsBNoYKqH6bgn2awYLowfJTNvEU	8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	606	1049	99	1	6301	jxgRMhaewm8vum7cuVfwoorvjrdptznFzTojhRQbtkA13KHYcr9	4369	6159	6159	1617047820000	canonical
8429	3NKSGrb6VxPsVm3uADJ9iCGTLsf8mT6aKCrwBsJDqhLQRes8GdQs	8428	3NLhAktMweF7SZJ5LS8DRWkVGFaw8HBvxUvQZ5GCZ4EK6syyLmW5	1407	1395	99	1	6301	jxyntx6U58f9f7E3o5aA5gDpx1H3vzrF6zvLs6z5yAEt2Tfu38w	4369	6159	6159	1617047820000	orphaned
8432	3NLyC86PijmyABt5boBeefBd8mxGLkLdcW4BAWnMqJZXfkenkspn	8431	3NKmmLYf2udiLEGtw33ofNP2NwsBNoYKqH6bgn2awYLowfJTNvEU	1406	1393	99	1	6301	jxpciFv61nxuApAXFdA1LX2GEUKqheVt7vj7REQvsDdJSRvHXuQ	4370	6160	6160	1617048000000	canonical
8433	3NKv7s5bDW65BZwNewj5a6SjK41KMiVvwPrZbfGvTs5i3ijM7BsA	8432	3NLyC86PijmyABt5boBeefBd8mxGLkLdcW4BAWnMqJZXfkenkspn	1581	778	99	1	6301	jxJEooukjnfEA4W8o23aZb3rutN5wYy3akAeSXX1rNLkAJwm4DV	4371	6161	6161	1617048180000	canonical
8440	3NKX5vUD5Kp8SMLwkt7zjxo3Tu25Ez1ZoDJo85QCKmpbNwoAaK26	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	1407	1395	99	1	6301	jwc5oWRz53n7RcVSeWxBzUVN4ugjsDkBYi9x85TkjwQExtBF1kY	4374	6164	6164	1617048720000	orphaned
8442	3NLb4smTBHxy1qDV7BAGGa4aLMmvnYSdT1vyh2ZWNQzumHaHbSEL	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	1542	1304	99	1	6301	jx4GATohZkvngNzDEgbtk7UyFTv8zmaNCgzf2nX4UwFHwzRXvaq	4375	6165	6165	1617048900000	canonical
8449	3NLMp437ZFCfCWYnX1LbkqoR9nfUN9Je49gndB6LQ1TUeL7oej46	8448	3NLtTU9MuEMUZU7pjHx2Vbatcic5x8o8GfxfTo6dW8as8W981qgn	1596	997	99	1	6301	jw7RnbAPiyiEnzK4qy41L5U5J4RhfdLKN6nzE8QqYzetoPFcKW8	4378	6170	6170	1617049800000	canonical
8452	3NL7syGbiq7zRTzkEPBAcg24H2TgbTs7BTHzZ7ohHPao8paYa9xK	8449	3NLMp437ZFCfCWYnX1LbkqoR9nfUN9Je49gndB6LQ1TUeL7oej46	1397	828	99	1	6301	jxYfeJnuQTcYnZrxD9kx1NsxPTDWik7f73cxSB6FYgDJ2etZxBi	4379	6171	6171	1617049980000	canonical
8456	3NLmHfeuFw65iaS5wsPg3kRpENUMH2EMo96ocbxayFk88RCGcH5d	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	1407	1395	99	1	6301	jwLNPgRXjQ3qC7LyEz74SdiZf95iybKZD32v1v2LFy7aZh6PwKd	4382	6174	6174	1617050520000	orphaned
8459	3NKs3YxGvojaMds74Ytiuo7cZiHs3p1ws8HJ417FiyTUBGuQr9vb	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	1481	790	99	1	6301	jx7LwAZiga1a8D5qjQHwRvCqqQmdCenCSdSLzT5z7ACpkEvaxHc	4382	6174	6174	1617050520000	orphaned
8462	3NKWjvXTnQBM2QhCUMxEWzrwpqbFQrDzABVDsH3KCwkkbT2pNcdE	8458	3NL1F5tioGMhx4NJ8LvAbnyCSa8oeu93NQ3aZbvtnTsmfmdUxq2D	1637	816	99	1	6301	jw9RqYuLZWaxe4SEpvmXgMFQ19gzqi5LQZkefGxvGoznrTKGALj	4383	6175	6175	1617050700000	canonical
8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	8468	3NKQXsawvmZokQGKfeEdKkJPkbBEAu6TQkBQ9u34PchwU5RLzDEo	603	603	100	1	6301	jwfx9NN9i3zStDttgd3e3F23GJqQJBzxsRJi1j32q7tUQH417M3	4388	6183	6183	1617052140000	canonical
8472	3NKB5jhH5D5eCSERKZhzN9Q3juYSe8zALosZWHwZF9ipfDT8S3Px	8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	1668	1124	100	1	6301	jwsBoEQyHPvwP6H3qzsbsRFjUjqMVuRKosGSJqggHy6nmGeHC95	4389	6184	6184	1617052320000	orphaned
8474	3NKTFq2eJVMeTaraDnuoC9Qqq9jdyWX5gQxBebe9rhFArD4AZjba	8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	1611	1095	100	1	6301	jxkqrB6rgcAJWw7oAQNAyUJm2REDyme8BWEpj4eRL8DcgMyga7N	4389	6184	6184	1617052320000	orphaned
8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	1503	1151	100	1	6301	jx83uRSSeVTqZgAyy3C2oV6hCSRTfe4f63RwRa2Lyv7K2nDZJhz	4394	6189	6189	1617053220000	canonical
8483	3NLrjxnD1aYrZKuzaXpBjB7Ecu3ibiCfBiAzhqLcoT3RzKhjU5S5	8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	1553	776	100	1	6301	jwLQPurDLVj3PhTFxgzYg7KPwRQnPKaSepm4uJeV5P7aHoK8VNA	4394	6189	6189	1617053220000	orphaned
8488	3NKEHB3ZhfAEJWDoM4TgADwGZmLFWZ4BGrt7qqurzJPixUntwuHL	8486	3NLJUMqKdbfMigmbw7uK7uzhpCf3H1amJQQnXCyGLKgBatX1Yqf3	171	1248	100	1	6301	jwLvkcUDS2VhGWEjHRoTps94vtZ7zVQ8FYRLJg2BvG7L4BpsTQX	4396	6192	6192	1617053760000	orphaned
8491	3NKeky2VVHKRexFY1h89wUtiPEGwUmytESjwuGcKbmdJa4kxSJnq	8489	3NLWAETNuepFcgfTtW3HGLqx6jyPsCkLGz6tzWaixjPu9m6xAeBC	1457	1391	100	1	6301	jwosGQG7BB9sGH69XcTkuDFUP8jJGceXCKRiekp3T7AruRQrMVG	4398	6195	6195	1617054300000	canonical
8493	3NLqS5dc6D5duePT2Kxg3ru2N6kCtxxFqB8MTZNQLt94RZFUYzEg	8491	3NKeky2VVHKRexFY1h89wUtiPEGwUmytESjwuGcKbmdJa4kxSJnq	1406	1393	100	1	6301	jwSS6ztgcMaWERRQFF5ndoYVBb3AD3Z4k2zLxLXc4qUtDpbMtSs	4399	6196	6196	1617054480000	canonical
13822	3NKTz821KDRsZm3Pkw67fTBWNdr9d82qAQkhJjMnwzoTFg7YDZuX	13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	1631	794	210	6301	10013	jxRRgg79JFguJ2gk8RyKWVrtiLVabymfeM1Rmuima3tXKKRpH4x	7096	10035	10035	1617745500000	canonical
8437	3NKXw64tBt7D8gT9bnW5uC4xdYYbhaAEXWieKn7SguQmUzsqcxo9	8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	1578	1296	99	1	6301	jx6n8BNZfUy36sfdW9CKpb3ADS2hkSdTaMuLrSKQWc1wne3FFrg	4373	6163	6163	1617048540000	orphaned
8444	3NKgm1LoKpVimo6rABnhkAgrMrkLYoSbqRMJcsjCvgeXHhkb65ZQ	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	1406	1393	99	1	6301	jwmTf62AmB1J26z7fqT5tf3No67ccuM2qYi8gEJX2TULQNbqYit	4375	6165	6165	1617048900000	orphaned
8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	8453	3NKimwactNoNA2Bcu1SXhNW6NkBSgAdVc7q4u9T4FyZqzRttn4U8	1578	1296	99	1	6301	jxiuQuKKsCp5uPFZh79eU2C8GvnSKHZLA1B7aarCYiM59vbmZgw	4381	6173	6173	1617050340000	canonical
8457	3NL17iDHUbPFF6RQLSL3fARWjbwNwhv3EDw1o6Pih32HjhkK8KgW	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	1403	824	99	1	6301	jx1BLue1dx6zasfwMZMPt14G86TeHoCTknsxgtWdZeLZKXdt4aW	4382	6174	6174	1617050520000	orphaned
8461	3NLNVsCM4TbzKW1K5rgKW9tjq7qJLxGUQhgWiLjYi5vPZZPtp281	8458	3NL1F5tioGMhx4NJ8LvAbnyCSa8oeu93NQ3aZbvtnTsmfmdUxq2D	1406	1393	99	1	6301	jwgeirMQRf6g87GoyYXfxeiU8WG9uNv2YdBPbN2q8f1QhT9NfKA	4383	6175	6175	1617050700000	orphaned
8463	3NKoAveXD7UVCPYjxEw4kkiP1DtAfkbnr9RWrxGfHDqy3pSh9qiQ	8462	3NKWjvXTnQBM2QhCUMxEWzrwpqbFQrDzABVDsH3KCwkkbT2pNcdE	1407	1395	99	1	6301	jxfewppteS41bvBRrirCGQcuzRCbcBjQ59H1YbG8K9qwRwSWExe	4384	6176	6176	1617050880000	canonical
8466	3NLPY18MBLCcAMancTimmzbW6CHkvjYBcjsrHxUpwAzZqvYzq7Sd	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	1402	850	99	1	6301	jxN9Di8be29XExdxnZDwEkH49CanYHvzqGLdBo3yt67B1HxwhQy	4386	6178	6178	1617051240000	canonical
8469	3NKxotMX3HsVmTCVXtHwGtuQB7Q8vDFkxygPoH6WZkKcrvWiG1s1	8466	3NLPY18MBLCcAMancTimmzbW6CHkvjYBcjsrHxUpwAzZqvYzq7Sd	576	1109	100	1	6301	jx6k1VNx7bHthrzVdzk1gfFgcXy71Ct5YdhRxEZnmSFQjdnzPqb	4387	6182	6182	1617051960000	orphaned
8478	3NK5Tj1VyU2R2LwFTaZGpCqkko3UkwKoW7jeWdENvEumtWeYCunH	8476	3NLUm2eDeXKtfgGtS3VJXWQoR1iQ1gWuqJxg9cT7asxotVo6bXrf	1619	1029	100	1	6301	jwqaevC5om4qjzYzq4q3mRDg1HYz97Cw42iJQjkX8ooBjNUuwej	4392	6187	6187	1617052860000	orphaned
8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	8477	3NL2v97sR5J6WjLaet95AtJZpVynkfHYCQT7RutzDvtxEryVLjj3	684	1106	100	1	6301	jxrrmjUpRyGP8QFatnYP8UvtKoZsvAL2Xe3ZHiuWCX2YBSy5ULV	4393	6188	6188	1617053040000	canonical
8485	3NKBMyeRBB695dYP6jd374rdnFoakXGHHCr8Ut7SmMT8yc74uEj5	8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	1648	1158	100	1	6301	jxvKeiqQfM76akRYsAUHAgH7heKePUQE1NikDHw827pCMC64Zd8	4395	6191	6191	1617053580000	orphaned
8489	3NLWAETNuepFcgfTtW3HGLqx6jyPsCkLGz6tzWaixjPu9m6xAeBC	8487	3NKrLqg38sPTNR9HEwVFJqXywGvqqz65yTRJdrKnw6p3QQt95zYj	1577	961	100	1	6301	jwbWk3djwoN6K1sQq1vN8xhwwNixTNc8kq6tcwFUvVJYCGyRNH8	4397	6193	6193	1617053940000	canonical
8494	3NL6VWo3S8AkpPiuU5dRj5TQJkfraABovnUFDsBhVz6yxcPUGfrq	8493	3NLqS5dc6D5duePT2Kxg3ru2N6kCtxxFqB8MTZNQLt94RZFUYzEg	1656	977	100	1	6301	jwAv16M4qyHEybb97JWhKMxJA2tD4yWyFaSaabo6rJkvi76268k	4400	6197	6197	1617054660000	orphaned
8496	3NL4AJAF3L1qRgNa79mdjjfs8TJNx5JC94YaQ5gZ5yjxJahL6mLu	8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	1506	1247	100	1	6301	jwvArcKSMA3NZYDQSGYwoQCySfYXJ9RUAfztmPP5eZFHBF3aMpU	4401	6198	6198	1617054840000	orphaned
8502	3NLSohKNyDHT3JUyQCsKFod3ZSZm5LkaKAcmRJD544vVHa4SExwq	8499	3NLbkqpDo18GpoG43yDajSREG64rF2L6RHojm3uL9QH91GPwY3iS	1581	778	100	1	6301	jwf4uHc5N1XU881Kj9MLE9kaJGhcfPWgGwMySTPXKLyoJUGNbcA	4403	6200	6200	1617055200000	canonical
8504	3NKtE3ts8LK9xYGmGcVCK8LoeLT8jpwXq3tN5FjAPNN8341USy9U	8503	3NLXjF2Nj1kqCA9gcRZioZJv7nvVPnWUe3eCZ9HjauncRhPQaomE	1675	1096	100	1	6301	jwkEcBVmNAiKgdGoYNKLbRT4vAgm1Gz13yPYrhk8rUDJiXPD1N2	4405	6202	6202	1617055560000	canonical
8511	3NLEuWnWZDjKHXZP3gswBdUemNeq86BHkotPFq3sJW21uX2Ujm95	8510	3NKwzWo6J7uFrhR9kinajqDahdEXxZpiPabLfimPaNPxiya8WfJs	1471	1140	100	1	6301	jxZKyHyaLADev7qXEFKi3dvDEbR4rmmUMXgH6pSH9K6TAdUk9DF	4409	6206	6206	1617056280000	orphaned
8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	8514	3NLEWmFQMmvs8XicvWQ69iJTcHQWjEdzK6jBhAFtoWkwRPYJBFFr	1419	814	100	1	6301	jwZiQqRWHziKwe2tcfofhEk3eYjhM4NRM7mLf1sc1xQux6Xv38W	4412	6209	6209	1617056820000	canonical
8524	3NKc2Fehmr9mZbnLT3QT5D9FyiBbHoqFLFs8b3F1ytQfr77cTHAq	8523	3NKf6tuj27an2SoEN3DjK3Avi9GD9tvZ8dvC4iCG71Z4T38JSkjA	1602	1369	100	1	6301	jxAnjBRHBVu1rjUkC3n9PWVRv5dSZpNKKnsc75YCtni1L3nXnjL	4417	6217	6217	1617058260000	orphaned
8526	3NKXfMYA6R9mCw1FsqDq5gnYzZgppa5RpkPAcn4RsKQJFd6DmicC	8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	1549	1362	100	1	6301	jwLeCMxsM4EwRunA6xDT3BQ4Bx5bmRVTcpnMtksD2NQg48w4Ax7	4418	6218	6218	1617058440000	canonical
8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	8526	3NKXfMYA6R9mCw1FsqDq5gnYzZgppa5RpkPAcn4RsKQJFd6DmicC	1594	1326	100	1	6301	jwwBzFxLzY1zJsqNEA8JYJ4Pkr26mw2ExhC7sPvZURHsG7nM4ft	4419	6220	6220	1617058800000	canonical
8533	3NLJ8mzEFXNZEFnnTiyHWzUT9KSFbwvdfV3XdbqBBCXQ8EkEpXX3	8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	1516	928	100	1	6301	jwS5rgzmWBRSVogcGNp3PzgtSJui9KFMLayZkuQusvWhEDYrB5W	4420	6221	6221	1617058980000	canonical
8551	3NKepWzNiDcsYr6EQSx2aVcTJK1Umk3SZKTSXEP2rtDuMdUoyamV	8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	1553	776	100	1	6301	jxes61RXx8TWBokR7c2YifSjKniNh7J8CTCkThsNjsq7pvcJ8Sg	4420	6237	6237	1617061860000	orphaned
8536	3NLGe2ks2ZPMNeVahqbqzJWeQ5dnauwoMHAwP48AnZR8XPaGfhCn	8534	3NLv1QQQw2BroNmUP5e78wnM3AQt6uYXerJhAJkyRrkxPKV1RKM5	1403	824	100	1	6301	jw88iCRUeQSbndpsedi5z5aJJbz98tAWAk51gkxoYyW9J8xHHxK	4422	6223	6223	1617059340000	canonical
8539	3NKxvje6jBqAkbQV4ZwgU7fNffUXRm8wRJWCegRrf8SY8qUKvW1G	8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	632	1382	101	1	6301	jxmUdmZPTkkaqqM5ztQ2rvAzMfvE4ZnzJaCR9vzfseVyw3w6WkC	4424	6228	6228	1617060240000	orphaned
8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	8540	3NKFANNZiJGdapmsHhzv4gkJKZv7GKW1c86KE2MxmqrRrC8jFPZ5	1402	868	101	1	6301	jxwgmzxJwSTGS1ZqpwvZNkFtbzsv3i5a9vksyVxyjxPzF6KDY5b	4425	6229	6229	1617060420000	canonical
8544	3NKgXkYBRLeFPWvKhPkLYV93xTHsp4pxfELoStLGVcTpG9NbxU1c	8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	1403	31	101	1	6301	jxbYAdZLPvxaaymG4zvXBfFBiRwunZ2KGsgNGPM36v27UUeR9EY	4426	6231	6231	1617060780000	orphaned
8546	3NKVereYeg2tNLT6D2QExf7X5rFnGtd4DnUMvfb5KuwGTL9kdbgu	8545	3NKSjnvryyiZm1BhLFpmQUCw1gCpeCWuN1fSigAy5CAwnSm7he1W	1610	948	101	1	6301	jx2EUoEY1SK2c8esLwmTz4RJKqkZLSMnuQHJnRrmFjTy9CiwhNC	4428	6234	6234	1617061320000	orphaned
8549	3NLJ69RmquQmBp6ZsxRZbp5CRtEuPoagee7dA2FQdmuwP1f1mbih	8547	3NLMFqsbDkpU8YfyrhmAnnn4Z6usL8gnwDRMvNuxQrGXZtk7qFA8	1406	1393	101	1	6301	jxZn1HgL2jWxw4Q17VFQ33oAAXSjf6JQga8zPEzC1wWrYejRj65	4429	6235	6235	1617061500000	orphaned
13835	3NLVMf7YK8iryFBuFdzexNYTw15SWgrpn1JjSL4fjTh5qyVWJouF	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	563	1113	210	6301	10025	jwvq897N2jgDAy6HfkSphVMK9nc4tC6YUZNmPLKDCr7rhHLXcNe	7103	10052	10052	1617748560000	orphaned
8435	3NKwrT3ns86KNh2GxCFACDjK3cSbExEDudgZLAmfxhGiuSdvt5as	8433	3NKv7s5bDW65BZwNewj5a6SjK41KMiVvwPrZbfGvTs5i3ijM7BsA	1403	824	99	1	6301	jwEbd7FwFxpsfe224sjty2htB8ujmbeJovJssYaR2wjEJ8Ci2jW	4372	6162	6162	1617048360000	orphaned
8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	1581	778	99	1	6301	jy2bCoutdMTU3vbH1GuzBKBdFnLtkrae1E2GpJYQPBm6zGhmfsV	4374	6164	6164	1617048720000	canonical
8439	3NKMpFrEB3bU9amDy75sM2Hw7QbwwvAHsJdMYTFGpmsqcVFCULLJ	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	1547	1378	99	1	6301	jwxurxX229FHYUNi1Ce1mRCAx1L9KSGNYGcTwVbn3HjMwQ2y8vW	4374	6164	6164	1617048720000	orphaned
8445	3NLSHcuRu4a2q1guFoC6VTpvnEmRRzTaXm1krvJeeY2iQskDNiLy	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	632	1382	99	1	6301	jwsYi8vtM5xL3XBsKSymLENAuh2LmQxvk2MMvMwvcoDYiHxmv7H	4375	6165	6165	1617048900000	orphaned
8448	3NLtTU9MuEMUZU7pjHx2Vbatcic5x8o8GfxfTo6dW8as8W981qgn	8447	3NKNu1PwTYwjhRSgaQH5KFUnNG1u1u7gGfG5dnb5RQS67C8eJTZ7	149	1283	99	1	6301	jwRveYMFZZAZV8RWkuCEersh9qMC4fsPUiBf1vb2eMsS6WH2b1k	4377	6168	6168	1617049440000	canonical
8451	3NLbts27QuethfWj5tJpGZYB5VYT8wPrTbkfDnKbeGgDvBWmgYZP	8449	3NLMp437ZFCfCWYnX1LbkqoR9nfUN9Je49gndB6LQ1TUeL7oej46	1599	1287	99	1	6301	jxqXaZ1iZP9XqL4eiQZ8duLQn2t7tM9Xh6GX7LmVJZT4Fpzg9zb	4379	6171	6171	1617049980000	orphaned
8453	3NKimwactNoNA2Bcu1SXhNW6NkBSgAdVc7q4u9T4FyZqzRttn4U8	8452	3NL7syGbiq7zRTzkEPBAcg24H2TgbTs7BTHzZ7ohHPao8paYa9xK	1406	1393	99	1	6301	jxbfWKBkuSK2G7Ay7Nz6pkNk35wkGvxHAVP4xFeUnfMj6DZewGk	4380	6172	6172	1617050160000	canonical
8458	3NL1F5tioGMhx4NJ8LvAbnyCSa8oeu93NQ3aZbvtnTsmfmdUxq2D	8455	3NKYVrFQZbqNWmAnmcurVAJSfdU6KGTDzuL4v2onmMYimZ5unrmD	43	1184	99	1	6301	jwj21MnaRdU32PHMN6e3x7SaarKErW2ZLzayV8k18syes9r9aWC	4382	6174	6174	1617050520000	canonical
8467	3NL2n8qz76Q77CrhE2F1HTegHeyU7K517DR82w4XanDHbwEiG1q2	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	1648	1284	99	1	6301	jxtQpWnsmrzGjYAxiSkr5DpDqYMWb4tM56F2ejWnhukxF7D12gE	4386	6178	6178	1617051240000	orphaned
8476	3NLUm2eDeXKtfgGtS3VJXWQoR1iQ1gWuqJxg9cT7asxotVo6bXrf	8475	3NK4pq1yk3CRc4yvqqmDX5HZFHmiVZ81bZ9dmDqvmyCmFis5A17v	1623	839	100	1	6301	jwqjRqUhF3Ua2JHBm7RGbbs5xhJEjnkfRwWfyn3nEKC34GX3eba	4391	6186	6186	1617052680000	canonical
8487	3NKrLqg38sPTNR9HEwVFJqXywGvqqz65yTRJdrKnw6p3QQt95zYj	8486	3NLJUMqKdbfMigmbw7uK7uzhpCf3H1amJQQnXCyGLKgBatX1Yqf3	1534	432	100	1	6301	jxJ4HwaVTX6JCbqHDcm2F3WX9mTvdoLjziJNTHoHaxcmXZg9nUs	4396	6192	6192	1617053760000	canonical
8490	3NL4t6zpoad6vLU93EYUQ4C8bU5sZKamLGujA3YFokbic2C9FcLh	8489	3NLWAETNuepFcgfTtW3HGLqx6jyPsCkLGz6tzWaixjPu9m6xAeBC	1613	1349	100	1	6301	jxSVNwPg5282quM3yL7qf4c6LZKYjmbrB3xzUNEx5RdHgud8eKn	4398	6195	6195	1617054300000	orphaned
8492	3NKvX3RXV1BsgctLiNTHAFDGA5AAsUHVLYiUS1drwUhiLaZzAYtV	8491	3NKeky2VVHKRexFY1h89wUtiPEGwUmytESjwuGcKbmdJa4kxSJnq	1549	1236	100	1	6301	jx2hB8mCmJWq8eiVYCwpcgdAxwNht43z2tGhUa2GwrDGCQvto4o	4399	6196	6196	1617054480000	orphaned
8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	8493	3NLqS5dc6D5duePT2Kxg3ru2N6kCtxxFqB8MTZNQLt94RZFUYzEg	1668	1370	100	1	6301	jxkFrcGmaiNwZJdXKLvaA9rjUS5PwDKiVdbALM9dnEeyG6T7YZM	4400	6197	6197	1617054660000	canonical
8498	3NLW5mCGtz3qUHVHBiU9n5FKBkmKvcos1Fa7xRhqWb9moTefuSby	8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	1553	776	100	1	6301	jxJriYy9jrZriui38XhebbgQS5durRgXJv967WmjBq8H1KbrCsv	4401	6198	6198	1617054840000	canonical
8503	3NLXjF2Nj1kqCA9gcRZioZJv7nvVPnWUe3eCZ9HjauncRhPQaomE	8502	3NLSohKNyDHT3JUyQCsKFod3ZSZm5LkaKAcmRJD544vVHa4SExwq	44	530	100	1	6301	jxuErm53V7an4L64kYhcEcCpS71nvEYh5RQ7fF2GRUV77kWRdbD	4404	6201	6201	1617055380000	canonical
8506	3NLi52PZccC4NaJAqT91ZKC1GJRNeCZH3GUY5Ne2rdJLFjXgenqN	8504	3NKtE3ts8LK9xYGmGcVCK8LoeLT8jpwXq3tN5FjAPNN8341USy9U	1477	1350	100	1	6301	jxa6RjUUnbzizR2afsyTaco9PRHN97xH7xjqQwrddK1UYYTidoU	4406	6203	6203	1617055740000	orphaned
8510	3NKwzWo6J7uFrhR9kinajqDahdEXxZpiPabLfimPaNPxiya8WfJs	8507	3NLAthjV5wuH5uXWuSk4KK9wX5pJrfYoVw2w1eUJXSSF8nRbrK2X	1406	1393	100	1	6301	jwTzPNsyeQz91Qjz8Efs7GJHzhj7aFFSgX6X2dLAZACL781YaQT	4408	6205	6205	1617056100000	canonical
8515	3NL2cCES6fHqpmv4Lkk1KJCYmfwtgmc7oCnT8z6AkAXCEUWcELwN	8514	3NLEWmFQMmvs8XicvWQ69iJTcHQWjEdzK6jBhAFtoWkwRPYJBFFr	1406	1393	100	1	6301	jwxkSZ99DFxZ4GEjehbTKR1d7vzcpBKNTDLXmXGNGVyxP8LL3CJ	4412	6209	6209	1617056820000	orphaned
8518	3NKCYYrgiLwt3W6Zq6FJiSFHX7tyNCE7xxQVv77h3vhViNqSXStE	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1672	1039	100	1	6301	jxoUNLruB9Tc8nZ9CUeDuBnr8uhpDAptarSedB4BAVdv8ruwBQU	4413	6211	6211	1617057180000	orphaned
8522	3NKg3GxNL2pjDSRc1ZxDCVYQPoBYopAii42SwGjsd6xJqR16Gtod	8521	3NLeP6so39bvC6WzRc8gGPKd6VjAscPuUJvvqqzE6XGDQD6NWXWY	1587	991	100	1	6301	jx2VPoo5bmGiH8ogzNjum8eaSTxQNpLWGh1wS5GbXjdw66qtMzz	4415	6214	6214	1617057720000	canonical
8523	3NKf6tuj27an2SoEN3DjK3Avi9GD9tvZ8dvC4iCG71Z4T38JSkjA	8522	3NKg3GxNL2pjDSRc1ZxDCVYQPoBYopAii42SwGjsd6xJqR16Gtod	1577	1081	100	1	6301	jxBCnQQhTi2BYucTG4SsGsA5BYtCENp3gS8pjgSTGyaGhUFYCpE	4416	6216	6216	1617058080000	canonical
8529	3NLLbbpTPtW1v8F8VN1z5EhvLyPkfCeqK69TQZytREH2pCFrSS1J	8524	3NKc2Fehmr9mZbnLT3QT5D9FyiBbHoqFLFs8b3F1ytQfr77cTHAq	1490	908	100	1	6301	jwjDr26fPCREAn1pK2ej7fzM47F1ueDcUvvRFPci1ZvtFGsCt7d	4418	6218	6218	1617058440000	orphaned
8532	3NK92QJGgJ18d4LqpKKBzKbafy2jz9KDPrusmYimXR75MrwBCYsM	8531	3NLM3Zr6ynvQtJC2rbMWv9dhjSkjnnq5XhrGFatiXc4tN9b9sWjy	1406	1393	100	1	6301	jxtpbye61v76GSirseGDNmv5ztaYeQhiKTru2pdtQjFDmY7HCZb	4420	6221	6221	1617058980000	orphaned
8534	3NLv1QQQw2BroNmUP5e78wnM3AQt6uYXerJhAJkyRrkxPKV1RKM5	8533	3NLJ8mzEFXNZEFnnTiyHWzUT9KSFbwvdfV3XdbqBBCXQ8EkEpXX3	1613	1349	100	1	6301	jxEp2xEiRB9sVCFWcLbWc3ESDqHVaqHyzjWNgGRpnK92N36j2TA	4421	6222	6222	1617059160000	canonical
8540	3NKFANNZiJGdapmsHhzv4gkJKZv7GKW1c86KE2MxmqrRrC8jFPZ5	8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	632	1382	101	1	6301	jxmUdmZPTkkaqqM5ztQ2rvAzMfvE4ZnzJaCR9vzfseVyw3w6WkC	4424	6228	6228	1617060240000	canonical
8554	3NKF1EfUYcCYtTxgTTmqYuUJdq5Kq7SXo8krLxW4bQ47wrxTCfvY	8553	3NKKdq1pbawrBz7JavxAdeCHA5pX68XKA7532gNJfc98NNFTo5X2	1503	911	101	1	6301	jxb5NZ2PwuZxQvx3nfHT8PUXN78Napp1eVrYVPnL14rmWKpfxR6	4432	6238	6238	1617062040000	canonical
8557	3NLXQd1rMyfcb5V9mhzbkCZsrbQCq2YjDpm1DNmaS16rq9KuaKjx	8556	3NKX436utforzvrZfW832Fw5ait7jiEX6f2FGDvqLfGX8foTcibb	1581	778	101	1	6301	jw7pUyieDduvk1Ug9mSK411TD5czErp5GgaCRa1atR8njFLQGyk	4435	6241	6241	1617062580000	orphaned
8559	3NKnZUBh38p7mAygxJM7oZSnyuW1n8gjvj6qvd63WWvkoKZ7i7nQ	8558	3NKfsGRvTXuaqi7hXTBxXnqDmfq9EVmXEqzexhayDGnmqfHxpbtR	1407	1395	101	1	6301	jwcoc1gETu3YxEVitJmsC8TVtDhCmxqTE54MwvnFW2eFsB3VXTF	4436	6242	6242	1617062760000	orphaned
13853	3NKdAsV31VSEjXdUnxbVQCVeJL4BwN2eeWqLqRxJGTzCUzmTv6F3	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1483	910	211	6301	10038	jxfruC3gwd1r9ztYDvZz3U94qKKzEydZKbYdFfbXQA726sL55eT	7108	10062	10062	1617750360000	orphaned
8438	3NKZCWNreFsL4YyLs6RSZ5kBV4N7hbYTpTLuNfCvGCh8KqEMnnQ2	8434	3NLk5u5tSjh6osCVpENhw92uwUcY89QRQ63NBiTTRPAccLPSLEzh	1508	1141	99	1	6301	jx5skoKGu8s4Pw2q61ntfJy2P3syXHVz7REwAvSp4JJ7q7sqCVq	4373	6163	6163	1617048540000	orphaned
8443	3NLxs1ptiHgR5emiADLrbYHyRjwajDnVSw2ovrfiz2qT4b4UJLGS	8441	3NLri3FWLYKx8RbQ1jrxMSncaWvu1K2nsa9KUh1Ykbx4HQ3dH4o4	457	457	99	1	6301	jxS9vJ64vMUsvTrT3WzQcZjxQnjnoumZkx4qGFjYD95nXE6ypa2	4375	6165	6165	1617048900000	orphaned
8447	3NKNu1PwTYwjhRSgaQH5KFUnNG1u1u7gGfG5dnb5RQS67C8eJTZ7	8442	3NLb4smTBHxy1qDV7BAGGa4aLMmvnYSdT1vyh2ZWNQzumHaHbSEL	149	1283	99	1	6301	jxr39QrXXL53A7cV9MXRiKzFSxuqaXywucsXvLRttmxikJVe4Ci	4376	6167	6167	1617049260000	canonical
8450	3NLHxGscXucpWZ1XBnhuPFS84R5zGokZboF1pDwrm16kCWnBsrFj	8448	3NLtTU9MuEMUZU7pjHx2Vbatcic5x8o8GfxfTo6dW8as8W981qgn	1407	1395	99	1	6301	jw7TkopYV1K61BieCvpPhfjoK4xboiLqabuDLfCct49N45sdi4j	4378	6170	6170	1617049800000	orphaned
8454	3NLCQvkpubH1nLvpGBS1XGNcGXRji3qkJ7ebbuHsVjRRm4WeUKVW	8452	3NL7syGbiq7zRTzkEPBAcg24H2TgbTs7BTHzZ7ohHPao8paYa9xK	1448	945	99	1	6301	jx66EfkpgsbebLQ89Fp5zD3Q6womJK1kCuMXfVMLVZTLcKHpdB4	4380	6172	6172	1617050160000	orphaned
8465	3NLCuwg8a7ySpgdgSGASxDtuxwRWp5x3kcbp4VGJ5TP9EQsBG6Kx	8464	3NKymFfZRGCsEtu8WVC2ZFYmozvXsVRYA5jQj4S5SBcvVcTG66Gr	1646	1354	99	1	6301	jxP5cuzTRfeFrk6NKjSsRmoTYAQF2WwBPgGQLE65UF38La5nD7v	4386	6178	6178	1617051240000	orphaned
8468	3NKQXsawvmZokQGKfeEdKkJPkbBEAu6TQkBQ9u34PchwU5RLzDEo	8466	3NLPY18MBLCcAMancTimmzbW6CHkvjYBcjsrHxUpwAzZqvYzq7Sd	576	1109	100	1	6301	jx6k1VNx7bHthrzVdzk1gfFgcXy71Ct5YdhRxEZnmSFQjdnzPqb	4387	6182	6182	1617051960000	canonical
8471	3NKDq2pf9eYkUstQrWxfRjxcdtrAzZAbM8sDSDb4fnd4fo73t4oG	8468	3NKQXsawvmZokQGKfeEdKkJPkbBEAu6TQkBQ9u34PchwU5RLzDEo	1637	816	100	1	6301	jxUCbvJQPdYzyMTHztm3EAdexcV1xFXzb4AasbjLfYy6k6nsY1Y	4388	6183	6183	1617052140000	orphaned
8473	3NKHczTRCmFDNGvFQbe9xw2JLj472c3JK2xP66ULquVEoyiB2PeZ	8470	3NKGUhwRurDFQKFc9fuiQP4vejAYcMxArE8DYW2VujEh5Uu4Kryq	1467	1376	100	1	6301	jwY335Y2xR4Lhu6PRS7p8oGJXeKdR7VVqe26peXNGwRsUPyxfnc	4389	6184	6184	1617052320000	canonical
8477	3NL2v97sR5J6WjLaet95AtJZpVynkfHYCQT7RutzDvtxEryVLjj3	8476	3NLUm2eDeXKtfgGtS3VJXWQoR1iQ1gWuqJxg9cT7asxotVo6bXrf	1634	203	100	1	6301	jxsg8iSdpLf7PxBZqmzLzUjcPAYnnctYCNYZiq33v2J3vJ8bjLB	4392	6187	6187	1617052860000	canonical
8479	3NKrhTeDNcdZvMTvqUdGm993fhdWVwMJ3rVD8my2k2DorUAUHNYa	8477	3NL2v97sR5J6WjLaet95AtJZpVynkfHYCQT7RutzDvtxEryVLjj3	1649	1257	100	1	6301	jwUtMXDg1ZX6CbANvLN5GfSEyPapgkLcgiRgpGm87gbiBuFX3LQ	4393	6188	6188	1617053040000	orphaned
8482	3NK8bnJMChJZwxz5AFdBRQoVqn4dSKMZkyB1FYzdodwNbAxQzAWS	8480	3NLcSvJhybxKYUPLBsQ4MPEhEQX6QoBmbiqEDJ7FCqUvDff3Vznz	1579	1389	100	1	6301	jxEnRkF5qQZdbc27UUvsE2aofLRsP3xQKt2Rvd9hEgGZkQ2m83a	4394	6189	6189	1617053220000	orphaned
8486	3NLJUMqKdbfMigmbw7uK7uzhpCf3H1amJQQnXCyGLKgBatX1Yqf3	8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	1541	932	100	1	6301	jxJaTV3GrJ4kbFha6nCcbD8LqqpG6YbPY3ffdybJ8swPcieKddv	4395	6191	6191	1617053580000	canonical
8484	3NKiP9pCEDpXCXn34C7yiwNe4GV8ec1oJwmCiXPyg97CmBjCahoM	8481	3NK53TkaVUtBU4pwhCxb2tn1kiS7YkKUcQL2VaQE7d3UzLVujoHC	1407	1395	100	1	6301	jw9USgccodKfAWNvku86eEqJEuhdmHYHzC2dLuWFgPjWxLxareS	4395	6191	6191	1617053580000	orphaned
8497	3NLavVMNLTpqig7NBuMMCZhWkfEQuR3H5RAE9pEieELbZBKUBtEp	8495	3NKTooZXgq79uKbtitw4gaUsRYzoC72Cqo4d2Xsd4KMr2QjrGhaA	1402	868	100	1	6301	jxN7ChzRgJnk7ATdgPGKfw9Q35y8QzoUhdZmdiEkqRHxPg4TeRo	4401	6198	6198	1617054840000	orphaned
8499	3NLbkqpDo18GpoG43yDajSREG64rF2L6RHojm3uL9QH91GPwY3iS	8498	3NLW5mCGtz3qUHVHBiU9n5FKBkmKvcos1Fa7xRhqWb9moTefuSby	1403	824	100	1	6301	jwLwaRfBC6Lutmtp3GH2cAFgZSGvgsAwrVTLpjtMeY3WZAsJs7J	4402	6199	6199	1617055020000	canonical
8501	3NKHwUv24N1FW99gtnnemNUnsyAvLsmVHStpaJqopZUitxWwAjzW	8499	3NLbkqpDo18GpoG43yDajSREG64rF2L6RHojm3uL9QH91GPwY3iS	484	1319	100	1	6301	jx7syV9vweVScVcnGvwfMMceVk5N2p4aANhemtTMSCKFX9mmMQs	4403	6200	6200	1617055200000	orphaned
8508	3NKnSQFCphGh3d6wUiC5RXLGYYHzTe4GJQAfdfRGz12bxYvFkKgg	8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	1637	816	100	1	6301	jwtZoKb3g2hRS5FUbmUmegbFGYeyYfSWK8U88qAeH2TEaMyaNYi	4407	6204	6204	1617055920000	orphaned
8513	3NKhCq1Z8jmWXPKXo3gpx9QdpUpXsqCd6YA86dDK8vRwjUtDYejz	8512	3NLRU4bK6JS4n4mDxsRRRzfNi1UCUtgiA5ZnhHxXGVzUwvhrtaWw	1516	1168	100	1	6301	jxkVwi3TzzBrzpmw4SHAyKmicjADoYo4ndmpDUHQHQEsc3HueHf	4410	6207	6207	1617056460000	canonical
8519	3NLVx5Ytqm7eYUWkYuD7MJv2q8ACSPLQSfgZdwr7G6KUqsKoUn8c	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1467	1130	100	1	6301	jw6sZeZX5mNAGxkac5ttKfcfw3jM8ehoFkqe8epPXRXUL42QxJg	4413	6211	6211	1617057180000	orphaned
8528	3NL1zJTUmpyCbGFXTLrdE6XveaJBBFqJPhkj2uwDwZ81KP7RPPiX	8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	1490	908	100	1	6301	jxnun7x7WBf7XSpQCgWAoK9ixXFxuBY1E584NikDngHXxXLCRuN	4418	6218	6218	1617058440000	orphaned
8530	3NLdsP6dFDvpNNhCgvQW1cPvA9GREiQAqykjUH3Q8gZ2Z496RbhX	8526	3NKXfMYA6R9mCw1FsqDq5gnYzZgppa5RpkPAcn4RsKQJFd6DmicC	1522	493	100	1	6301	jx4wDMHj7XXPFyGvWsiAYdTvARNhtRkaYzDUNCANJGAhonTsiQi	4419	6220	6220	1617058800000	orphaned
8535	3NL2viHZBgpsR2pm5CnZ55uHMGFstQqBWxdgDc2ieYU129gNPiFi	8534	3NLv1QQQw2BroNmUP5e78wnM3AQt6uYXerJhAJkyRrkxPKV1RKM5	1637	816	100	1	6301	jxd5f47UcEbownW34YDP8Z7ELgTkjAf3piyM7CXaKJ7jL6KSBrb	4422	6223	6223	1617059340000	orphaned
8538	3NKe5teq6aV9GbqGGo74rFDP5nUthHEfC5N8zLt8wGx4XbcbHbHk	8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	1406	1393	101	1	6301	jxAEjrhiCc5YDGhTMNHauzxaN8nP7SPujMdstC14eqeMnvEnW7S	4424	6228	6228	1617060240000	orphaned
8543	3NKZJHindJTZ4xs2K8oxAjB2Rw2TgDs76yf1GpjqsAw2YWFNZrsk	8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	1513	1379	101	1	6301	jxMinfXbquDZzNmdRdTtiGCt7eGk2iAapkiukCmUkA1djsrVgHH	4426	6231	6231	1617060780000	canonical
8545	3NKSjnvryyiZm1BhLFpmQUCw1gCpeCWuN1fSigAy5CAwnSm7he1W	8543	3NKZJHindJTZ4xs2K8oxAjB2Rw2TgDs76yf1GpjqsAw2YWFNZrsk	470	1309	101	1	6301	jwrnv184FXPHpHWvMLqpGPKpTJKyZScvp4LsfUqNHFjVUeuib93	4427	6232	6232	1617060960000	canonical
8548	3NKbJhkDC9Uz8AnXrSRRnc6Qcf3kKNWb3oqXTKLiVwGpCaLUsw9f	8547	3NLMFqsbDkpU8YfyrhmAnnn4Z6usL8gnwDRMvNuxQrGXZtk7qFA8	1506	1127	101	1	6301	jwAYuoCgMns1Er66XtNKZt2hRjQjUQ6a3eCUGvJFFjdzAi45ZHr	4429	6235	6235	1617061500000	canonical
8550	3NLD344Si4NvPZ8MtBfCcjWtDCRYLFmJCywphNATZT3V8pjihuWu	8548	3NKbJhkDC9Uz8AnXrSRRnc6Qcf3kKNWb3oqXTKLiVwGpCaLUsw9f	1673	1002	101	1	6301	jxwaZVTwUiW5XCXi9JCoEizgDgMRfUkPkXPduxgKV9Nziw6rFZR	4430	6236	6236	1617061680000	canonical
8555	3NLTNBWj5ot23MV8iCciYGxoVQN3n4u8WmncaEbX8NFKayhxj3Qy	8554	3NKF1EfUYcCYtTxgTTmqYuUJdq5Kq7SXo8krLxW4bQ47wrxTCfvY	1403	823	101	1	6301	jwfhFQi4amoRkwypALkmNg1Dn6kaVKapamKnLESULpw7pXAnSDd	4433	6239	6239	1617062220000	canonical
14140	3NLbpPvULJfqdHrzkMnJWgDEBJ66dZdp9iWWh9Je3fUtukBgH7Kc	13855	3NKjDPGMjZpRG4wAYgEAgykYMgA8hFUh1oWcmA7Kwjznyj9G71CW	1451	1292	211	6301	10276	jxHVKyiMs4UEqH9eFsYNzc1R73kHctaVw8q8hkSemHeix4t45e6	7110	10225	10225	1617779700000	orphaned
8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	8504	3NKtE3ts8LK9xYGmGcVCK8LoeLT8jpwXq3tN5FjAPNN8341USy9U	1483	910	100	1	6301	jwsK8TPuTVdQm4t6eMzt9diernLDB2Xd6piUWbfuZ23CFrE9uxW	4406	6203	6203	1617055740000	canonical
8507	3NLAthjV5wuH5uXWuSk4KK9wX5pJrfYoVw2w1eUJXSSF8nRbrK2X	8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	1406	1393	100	1	6301	jwCaYgF6Ef3EbXG2xyCJGhcMvrNq8HiXpRQkKwwhSbBi8a6ngVb	4407	6204	6204	1617055920000	canonical
8509	3NLA7T6RTStHipSu2RdaMvREJofW5d2wR49BYgFTk6xaF3qd7rrB	8505	3NKD59yAReG5kznE4TNjDBycwfkZsR9JnqctF2G62x4hD9x3nD14	1403	782	100	1	6301	jwY1hHrk5JSw7ydPfhZnkZdSEMDjudTFWBSMav5GQTdY75viBaC	4407	6204	6204	1617055920000	orphaned
8512	3NLRU4bK6JS4n4mDxsRRRzfNi1UCUtgiA5ZnhHxXGVzUwvhrtaWw	8510	3NKwzWo6J7uFrhR9kinajqDahdEXxZpiPabLfimPaNPxiya8WfJs	1426	998	100	1	6301	jxWSHWF2eJjgEfX7QDjdAukXUdZ69EkRgUhc3n8nYfDM6Mb1Uf1	4409	6206	6206	1617056280000	canonical
8514	3NLEWmFQMmvs8XicvWQ69iJTcHQWjEdzK6jBhAFtoWkwRPYJBFFr	8513	3NKhCq1Z8jmWXPKXo3gpx9QdpUpXsqCd6YA86dDK8vRwjUtDYejz	1671	1365	100	1	6301	jwbRXdj88BDLzc7LwPwszAzbA1j7UL4kx33KGYqXBsJ5VKCtPCE	4411	6208	6208	1617056640000	canonical
8520	3NKNTFoJ78LNBumSC14YdBFBnKZ7LwpvAJj5XF3kaPgMLuCMWUWD	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1407	1395	100	1	6301	jxqVyPP3jVbBcNo317cyGUvwEEMmXejoy2irNKN5cxpa1wgtzQj	4413	6211	6211	1617057180000	canonical
8517	3NLJAVuYGtwvWLrpfvH8GrQWbePQj51byvAJCK6gMgJpweVjn86i	8516	3NLpfaA2nZb99L3afrJ7yhZgXPGEZnukQjqJxZ9XCDP6GyTLzRXR	1506	1007	100	1	6301	jwNAPN1waSmAUK3fmKodQnqo3yziBPEe3JXVfyDXT2vquZ3Kf5h	4413	6211	6211	1617057180000	orphaned
8521	3NLeP6so39bvC6WzRc8gGPKd6VjAscPuUJvvqqzE6XGDQD6NWXWY	8520	3NKNTFoJ78LNBumSC14YdBFBnKZ7LwpvAJj5XF3kaPgMLuCMWUWD	1513	1379	100	1	6301	jxD6X1ctqFRzuoT1Yav23qt23Fa3LBd1paLM2MD7s3Mf8MCrXTx	4414	6212	6212	1617057360000	canonical
8527	3NLYwLvicbNi9Se3vPQAxEMrErnMjBLTcfHtueneCxjD5by2yHum	8525	3NLdjpSBHKNymCsk6BhtjGcZ7Ke4593qYXAqAEWdNXnRunhvPFSR	1407	1395	100	1	6301	jxA8ABLeXoVVPcFrhaQMsvK7mQLhRNAfuYQco6qz8iJ58XtiYgH	4418	6218	6218	1617058440000	orphaned
8537	3NL5YNg8az9e5Jm1bdmAoqvFP1svDnw6YhNnoKA2fPssmi5ANhX1	8536	3NLGe2ks2ZPMNeVahqbqzJWeQ5dnauwoMHAwP48AnZR8XPaGfhCn	1637	815	100	1	6301	jwt91BWz9iobVKWv5KPjNqc6hDKzuG5eXdU5B9z6Fgq4dv4XYWH	4423	6227	6227	1617060060000	canonical
8542	3NLYaEFhMJhMHp8kbNR3ybGjtMUqmsdSFS2mFXMQS1t1A5emcT24	8541	3NKzLbAG5vgZi7WFfw9fcg91HdtPT5pqG5VhMLCFdWseZkXKq8rj	1671	1119	101	1	6301	jwFGaDPsxYUbB1uTcXoRharazdjW4vShhBSKdk15S1jAfJJWM62	4426	6231	6231	1617060780000	orphaned
8547	3NLMFqsbDkpU8YfyrhmAnnn4Z6usL8gnwDRMvNuxQrGXZtk7qFA8	8545	3NKSjnvryyiZm1BhLFpmQUCw1gCpeCWuN1fSigAy5CAwnSm7he1W	1406	1393	101	1	6301	jwNLHekExn3tNHzxeaKoB32BK9sZN4h1Y7dSWfwufNDEYMoxmGh	4428	6234	6234	1617061320000	canonical
8552	3NLwD9zST3HCogLGaSa5dZvD785rCb8CDy7KCfDenu7a1eRuF6AY	8548	3NKbJhkDC9Uz8AnXrSRRnc6Qcf3kKNWb3oqXTKLiVwGpCaLUsw9f	1407	1395	101	1	6301	jxUU9Rp5WaQDHUv1dEz5XBy23wDJaHkb9QTqQvVy7AB5kSjyybL	4430	6237	6237	1617061860000	orphaned
8556	3NKX436utforzvrZfW832Fw5ait7jiEX6f2FGDvqLfGX8foTcibb	8555	3NLTNBWj5ot23MV8iCciYGxoVQN3n4u8WmncaEbX8NFKayhxj3Qy	632	1136	101	1	6301	jx3PP2FwuDQJcEYNaUUV1kbvD7EA3trgYeeyvfZ1Er8LuYrWWpm	4434	6240	6240	1617062400000	canonical
8558	3NKfsGRvTXuaqi7hXTBxXnqDmfq9EVmXEqzexhayDGnmqfHxpbtR	8556	3NKX436utforzvrZfW832Fw5ait7jiEX6f2FGDvqLfGX8foTcibb	1631	794	101	1	6301	jy2wgLDo3F26QgbiNcJJN2jocAjHA95EwRVYeWqRQY8Xzyt5UuX	4435	6241	6241	1617062580000	canonical
8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	8562	3NLZTZx3BhwqjsdfSigZHxmAkq5PVvwqtGzRn9tLUYpV3E8Rca2x	1406	1393	101	1	6301	jwqmhpjrhfdpDuQV8oxBqf9to94hZoHA1brnyPXgM8F2pzHCfQp	4439	6247	6247	1617063660000	canonical
8566	3NLVnH4iZ8bZ8bbViXWkN4HpdxJEAstcZVLSg1dgkWPJzaD9BpCi	8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	596	1060	101	1	6301	jxdQridp7RHkNSSKKdsJYtQzRzSknoo7WZfyWij4U1wmWNsEArp	4440	6248	6248	1617063840000	canonical
8568	3NL4fd5bBmcTR5yf6Ba3zmBjUHfJdbQu1FPiE9DLN9qJvjbcLgiq	8566	3NLVnH4iZ8bZ8bbViXWkN4HpdxJEAstcZVLSg1dgkWPJzaD9BpCi	596	1060	101	1	6301	jwHfochuQQuQfrVHGNEqFJpscH74gcN7rKEKk3WGWFRNjbDPdig	4441	6249	6249	1617064020000	orphaned
8571	3NLi1p7mj3Y7h2gX9Y1vict3K8938W61qF735tHNcC9JvKEBsTqq	8569	3NLejZ4e5LGVzZbPwCGQNNYmum5AKDitiZXQWsa5buKED9BMQ6SN	1471	1260	101	1	6301	jx3yxPeePqQw6A3kFVv8aVbeozgQanXiFuETkY7JXzjzLyGj87p	4442	6251	6251	1617064380000	canonical
8578	3NKgnd1TzwNXmCsz7XCzbEdn8MsZCYRrK7j3jAjNceg6eeAoUVWd	8577	3NL5TNq1XLNi1TYcJwc2VbRdqE4XdYySnaBKyYuu9ZfVQ7keHkvy	1440	1377	101	1	6301	jxmuRyMFctDopXUqNTu9rppM3o1MSmoBQwyFG6PApaBs8e6eCSa	4447	6258	6258	1617065640000	canonical
8581	3NK8nhzk9uqWLQ2ehH3CAEgS6NimkGFamQ7KasAiZS8KxD89SrEt	8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	1522	1076	101	1	6301	jwT9iarSuCx5pw1tt2g1WZ3W6xAEqGqty5kKVqJ9QCKWqu2GZgK	4449	6260	6260	1617066000000	canonical
8583	3NKRUFPEfFmEzM5XxBnHix1UzS7us1KrPxDmfg6oJN86gMcQKW1G	8581	3NK8nhzk9uqWLQ2ehH3CAEgS6NimkGFamQ7KasAiZS8KxD89SrEt	1522	1076	101	1	6301	jwzcNKqUXFNdxcqEWcYNjFKVDuYGP7RqSgbcEFGZd8mstSYDceM	4450	6261	6261	1617066180000	canonical
8585	3NLMaFFCY8H8tkhg33kW34KREmPV4ybQYmEF6vwV8c2dhEK7qsct	8583	3NKRUFPEfFmEzM5XxBnHix1UzS7us1KrPxDmfg6oJN86gMcQKW1G	1564	1092	101	1	6301	jwj2fxQam9vPGcaeppc9DoaQN1J92fLbhmXqTLop451XeA2wDrT	4451	6262	6262	1617066360000	canonical
8588	3NKNF4YRjZXYq7GYPBFhvC4ABTK78Gn3dTNEibF29A7iuHmgFFAo	8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	1467	1010	101	1	6301	jwDqMkkzoWL1uo8JQgKDM5vnaj3UgsW2ey6rWGNnoWd9QvbjvEc	4453	6264	6264	1617066720000	orphaned
8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	8589	3NLhEH2AoKGY3wLCYo2PT11R4djtc17XUBcLMUrMs7xS8JPTB8Lr	1610	1314	101	1	6301	jx54hCFegpFRrt3vf3NsR6P8EpkN3kcsinUC9LpbQiUUsUSbWKd	4454	6266	6266	1617067080000	canonical
8597	3NLudkomY83ya8uPG51j6euxAXYSGSUv6ixzzrWEWG5vrXW13jZa	8595	3NKXKRgJNTcVWwSEXnVNbG9QCT4fu3dCwdK8tc8mttRnXmbvgUFP	1509	1320	101	1	6301	jxL7BPtwb66j9vkxAt2iBRvGW1wUeXjaPjLGDAk7RTdtihtP6r1	4457	6269	6269	1617067620000	canonical
8600	3NLBB6uTeyyCCqNwNdfrFdLRTZfAdryzpGeMgnXs5z1LkUUCGibq	8598	3NLXQASrvhWhEmfUeVo4x87AisRimpToxihKcUuRwovbDnPxWFb9	1643	1299	101	1	6301	jx8YJBG5bbErhqxWfmAHAepnMQN8aMbGLZjEDPfMvmETF3HHMhR	4459	6271	6271	1617067980000	orphaned
8604	3NL8B7ehSyTvdU7u1zgSBsgusJ2MbfjstoEv6gMzKXudNfoqARAb	8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	563	1233	101	1	6301	jxf9CDoqKVL6D4YyvKf8YZhsDnKaKVxEYvdndgbgVNvmaDipi3A	4461	6280	6280	1617069600000	canonical
8609	3NKqWz3CcXWzji6djY5cPku3yVvUtyZLRGZGckoRZ9fPm1NXQsyW	8607	3NLJRDb2gqs4mrfJYQnx4fKD7rq1eSZVcfGEXDVAZsTkadGqKhmC	58	1281	102	1	6301	jwAUV7DsYLzMXBJvSnmMzqCjcM8GQBZUmXsYD7xTFEwqoAhdkxX	4463	6285	6285	1617070500000	canonical
13860	3NLgUwjSt1zLV8nFLWWZ1yC66PKNUih6xrWZES4hFeTS2HcxzwMa	13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	1581	778	211	6301	10045	jxQbynxSoSzWPVWD98t3QxRqs8XacMj1nzhS2fkHDngKVJgxcuu	7113	10068	10068	1617751440000	orphaned
8561	3NKKUnt9WDBPWRuKjBGx1PtbcQLvRkmsJwfF5iySYqpsaJ311ckR	8560	3NLtt1QG87CPYGn9Rvg1JnEZ2x6ywqkrW4NGwZmNyrNtnuqZ8tK6	1407	1395	101	1	6301	jxS7MXQavVwYD3egJa8Hn3ZyaKDmEnRoQTZxUVFrfGTP7BXAyRb	4437	6243	6243	1617062940000	canonical
8576	3NLmBQBYfg84VKAc3jCJkxkGz8Z1GTbjSB6eoqzg2VK1EqRZoNuA	8574	3NLr9yur4fPZC3XBNhpW4sM3teFWB39urV1nPXRP9QCLckYjXcRY	1406	1393	101	1	6301	jxgsxLzPzMe3HCbEgQ4f8R853QoU8dUSeM2iYgNZ78oLkmXi6px	4445	6256	6256	1617065280000	canonical
8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	8578	3NKgnd1TzwNXmCsz7XCzbEdn8MsZCYRrK7j3jAjNceg6eeAoUVWd	1406	1393	101	1	6301	jxHochgerCbgqf5v6LZjMNTzJfY9kzcJpF5aBh4v4qHwdMdv6yc	4448	6259	6259	1617065820000	canonical
8582	3NLnXQSJLKbX6BFFDL8ByddCmUnCdTczaASv16Ym6Bb2btoQtm8E	8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	1500	1171	101	1	6301	jx6PYnErLLobSoEALirPY6M2BYEFUMWj2bxacNMuFDKA1UvbT9o	4449	6260	6260	1617066000000	orphaned
8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	8585	3NLMaFFCY8H8tkhg33kW34KREmPV4ybQYmEF6vwV8c2dhEK7qsct	1564	1092	101	1	6301	jxTnmsAm5WSPEa8T6S1a2KsawkXwb6Pi4FcG7p7ZgmjJoskmjmD	4452	6263	6263	1617066540000	canonical
8591	3NKbnfCnkYnZxiADE9y6fqwfVBJ1TjPGXX8ZanhUdVuhAuZMVHyo	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1406	1393	101	1	6301	jwdrq2mk21NUa7BxmZLr3HuCCjsmsL55pLEfjYetVFFazd65oQ9	4455	6267	6267	1617067260000	canonical
8593	3NLDDEMmzTKjwdSA8pLMTrZNAPeD5FainCQFYGM31X3QBc8kCrQH	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1623	839	101	1	6301	jwQzq3Ss9DwfzbCoF9YYGw44FGysx5NRFCzNL7mE9VQhqU5ejBR	4455	6267	6267	1617067260000	orphaned
8595	3NKXKRgJNTcVWwSEXnVNbG9QCT4fu3dCwdK8tc8mttRnXmbvgUFP	8591	3NKbnfCnkYnZxiADE9y6fqwfVBJ1TjPGXX8ZanhUdVuhAuZMVHyo	1643	933	101	1	6301	jy1WgnVNtZL4SWsGrYSLbFonWUMSNuPJhaALxKnVkwUc3nFNgK8	4456	6268	6268	1617067440000	canonical
8605	3NL1ey58vtZaBcdmzALAjugLYa6yZU9wBf9Gpf278zXSvb6wHg6z	8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	563	1233	101	1	6301	jxf9CDoqKVL6D4YyvKf8YZhsDnKaKVxEYvdndgbgVNvmaDipi3A	4461	6280	6280	1617069600000	orphaned
8607	3NLJRDb2gqs4mrfJYQnx4fKD7rq1eSZVcfGEXDVAZsTkadGqKhmC	8604	3NL8B7ehSyTvdU7u1zgSBsgusJ2MbfjstoEv6gMzKXudNfoqARAb	1406	1393	102	1	6301	jxxf7izg3qAqr16KbwRS4655AiB8J1pgyL3wEeuu1pHYJJZJnUh	4462	6284	6284	1617070320000	canonical
8612	3NLqLee6ktXJwvQVru3HWDKBBCrTsQs7KLPd5c9FpNHKt3bcd6Cy	8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	1406	1393	102	1	6301	jxn5cZem3jNTf3zBeTpZ5GRXnGkjrqoKBZdqr3gDDwxnq2xGy8V	4465	6288	6288	1617071040000	orphaned
8615	3NKYrhLqVHVww2cHJohc1baBCEiD4aNeHhGb5quUJb3azNto5edr	8613	3NLHhHjBLo5W39HjoQAjHZTxDpWob6tkXEmcZ7F4ctNfW8J6wTXE	1407	1395	102	1	6301	jx8WMg3yQuAwLKmk6W4jHxxx1FuRU2oabRZXVT8VCjTqNfRWm8m	4466	6289	6289	1617071220000	orphaned
8617	3NKcH7fby9nJpKeC9RandY2RvnXU6XCc61fTQyhfcgyE5uePHE2X	8616	3NL46wUnjMjJF8ZsQUr42ceUmrP6BAE1AZEGhC7gY1Q4wFk6nRS4	1542	1304	102	1	6301	jxCfCK3wHZY5E5js2KAxkzKDU385JPE8CWzbYLcoQTW9t8jyUMV	4467	6290	6290	1617071400000	orphaned
8619	3NKPzJZa5cBYDuYNXbvtQGkYBFbvF9ZM26Cny2tddwsMSxRmqqmC	8618	3NLvXn3WqK6cyoJJVVra17UcJtHeQb8djEZSyJBBhzLTWpXXtbrL	1672	1039	102	1	6301	jxjVz6Dgygj9EswxYrJCwfN7xbDTHHoufkbxxJKtHBmA5HW6LXH	4468	6291	6291	1617071580000	canonical
8622	3NKEiZak8XdKim7iGyVWxSngbdmmG3XKqL7oiXkn8Jk9WarvfNys	8621	3NL2Zq66HrtgYCBu9tgTur1wMssjrNUBu4E1DhifsdWAiYQK8FmE	1471	1386	102	1	6301	jxr3b1JU5axnv2AVAxFKNDAH125qh1EG9YHpzPKMZUPFywbKj63	4470	6293	6293	1617071940000	orphaned
8624	3NKEFnoz7egBEUjFECCXygxC6CJNdrN12KrN822Bre7KAnhVBUsK	8622	3NKEiZak8XdKim7iGyVWxSngbdmmG3XKqL7oiXkn8Jk9WarvfNys	349	349	102	1	6301	jw95vdySqMpkGnCAH1S2m5tS9p92GQqSxFptnu3S5By6xDNrhKX	4471	6294	6294	1617072120000	orphaned
8628	3NKzydT7cAYbXxjB3T7hKhmVnc2CdXEZ16p23yUarrBPY19JKbj3	8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	1634	1331	102	1	6301	jx2QcbaPkv2NEjV7LZBW9DcJpaomqVzZHQGHbpWaMe7mFijMtBh	4472	6296	6296	1617072480000	canonical
8629	3NKW75ukk7W3SRpKNDWVFb28YDa4sQo7P511t6y98zLco2BqcWA4	8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	641	1210	102	1	6301	jxYDpTMYtyvMWPTfzk5qt3hQSSWu5C8UUVEs4ikRxRXGUYprdqn	4472	6296	6296	1617072480000	orphaned
8631	3NLd5i8xSwuY9DSyRAf9e7YX6D4H51g9qpU8CwSEnfsgN1ZbKqms	8628	3NKzydT7cAYbXxjB3T7hKhmVnc2CdXEZ16p23yUarrBPY19JKbj3	1609	1333	102	1	6301	jxCouRCaZk6ZSeywfyrC6m7vaBNsTTbeZuQQAW6bLfcJLNbjqYA	4473	6298	6298	1617072840000	orphaned
8633	3NKUMAhKJ2bPUDGgNG53bRVYxcEHqy3qbcTxn99bXAVfC3Wi2iRk	8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	1646	1354	102	1	6301	jx3Wj58wiFX3r5UDuu2XNJXWL9fzxUfTmxEgJ25cgFSuFhm5Aiu	4474	6299	6299	1617073020000	orphaned
8643	3NKPNFWc1C6sgQKca7jwUsMc4r3heC3G51QuAhTWbUbob95HB2Uq	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	1402	808	102	1	6301	jxeVzMsevu3LNPcdn1rrTUyZNJP4XY14yxJQBqQMR8RWJYs4cFD	4477	6302	6302	1617073560000	orphaned
8644	3NKRvNvvAYcU6ynsT5KghnkqUReM3s7zGMVzifotjn1JTF8dmNva	8640	3NK7tJqSsA7QAgYepy7BLuwpB7rPtEnS4UfB5VyBSict9heGj92C	1406	1393	102	1	6301	jwsJ5foNZXUsJjQZAfa1uWyvFGNWzdcAjmHBqhgR7W17R7J3vuo	4478	6304	6304	1617073920000	canonical
8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	8648	3NKkXqWuNGV83B93e1vPDQUXkBVJYfUYGvjrRQnSAuFsgXr7dFk9	1403	824	102	1	6301	jwZ1MdMHvaMEpGdoVT6oqGqSEJCQBY3pFaRuBQDhH39TwSQjtui	4481	6316	6316	1617076080000	canonical
8652	3NKmQYtzjDjnb4NAeQFZR1MpgY4XndqqDU5P3mSZ4DpUXpub4Kvr	8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	1508	1261	102	1	6301	jwtZW46occmFMRuVEswpJVdRQYpE4GC7qa3MTGWreXF3vjPXHKY	4482	6317	6317	1617076260000	orphaned
8656	3NLsZvQP4rYmgs7Z7Zh5gb7TseX12QK5nuruexKa4UEnRn9TjSGm	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	1405	867	102	1	6301	jx2pnBTjjDbkKDpM42GXRXH8kbvbuyuCkpDzsg1vN64PXjJu5Jr	4484	6319	6319	1617076620000	orphaned
8668	3NK4vhsmiiQyzNrWFeXsPQpDeHWiJC35mc2UuHVLPhCHhoxVFkx8	8667	3NKWGMe85ZQmhmrD1b5TPu4TBcDAFVEWZXsaqdojQ84s8ScgeVEz	1527	1167	102	1	6301	jwgziigjgDBS4mLTsk28ziGfPVG1WoxDWmJyqKU6qt9sg7ZH2L6	4489	6328	6328	1617078240000	canonical
8673	3NLSz1JrWdT6gKNBP6nFHHBeGUkRkaBgfzWSx6eaL9cKiadqhAki	8672	3NKK2ARxT93gUw9rsoZf35hu6nA1vf1uAVL8Rk1oHg5nDgMhffeY	1460	190	102	1	6301	jwG38WHzTbYhSX9vQurt4KTvWXkdvEdW2gghkdw5dhJXtL2BDg5	4493	6332	6332	1617078960000	canonical
8676	3NKZLhhtfXfj7btnEt88MkDZnRywA6rLX5CiPbixob3F8MKLWLhZ	8674	3NLpYwQ2rQAaXuXf7XK3oLkh1PJRrKCWxa1JCBNhmCLY4Bqt419P	1611	1095	102	1	6301	jw7dWHZcCRHVVzyVBc3iJbzFFMTBCATuLTnVFHVG8BgzBoD7UPM	4495	6334	6334	1617079320000	canonical
8678	3NKzkP3CZCvWvdJ9qwR1NbkiaFhVgTUModUhtRChiJCBKfAh6nTR	8677	3NL6JwhxFwGoH8SjTAXHQWzE2NkeTGawsVTGyuLQdTxQoxFPZbuU	1573	1318	103	1	6301	jxSzZvhnGRpcSHWGwjrPZeqC1Hrce4pYD7Lf1nq6PEkarRzqVhG	4497	6336	6336	1617079680000	canonical
13868	3NLtW7Bo7hDg6mAAujjFaqbawayjDQqpARC3cNnGnrALcyxqFrD5	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	1672	1285	211	6301	10053	jwcbH5mnH2nH2LA8omG4xK1fZSvmSa8JeVpJkU4CgbcSfpqQkwb	7118	10075	10075	1617752700000	orphaned
8606	3NKJjVdW2dyygB7zczk3yypkbJq7fSoQYtbYYHFiWfnVNDEG3QA2	8584	3NK4TqYbw4Kiy1QAxDN51JehHDKxcFT58e2KrZZdmJP1MDrjorPX	1627	1385	100	1	6301	jxvxxNMB2a4ZxYa9NMLyVXMW2ptAiWuRcy7eCB64JHWzUmGyzJH	4368	6283	6283	1617070140000	orphaned
8563	3NKe8DApVMc7ot5yqGctBzx8zPUfAnE9KxiHDHWox6uKkUe19aq7	8562	3NLZTZx3BhwqjsdfSigZHxmAkq5PVvwqtGzRn9tLUYpV3E8Rca2x	1426	1118	101	1	6301	jwDgigW9k53hZBWBNDmAEUUG9M2GHV9XqoNATXKqvoEPutwxPAs	4439	6247	6247	1617063660000	orphaned
8565	3NL2WisGF2RcQ3f9YxmBB6NKJGWZe1P8Q6VTybSxEamx9AkUjRfe	8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	1407	1395	101	1	6301	jxVurAEpotait2xzh6yL97DdLWubREZrKPVeyk3UmYR65vvfhG1	4440	6248	6248	1617063840000	orphaned
8570	3NLwKArL2vP2qQKLXqyHmqwfhMowRERzC3AeG4xeEjRUssfA6PQB	8569	3NLejZ4e5LGVzZbPwCGQNNYmum5AKDitiZXQWsa5buKED9BMQ6SN	1407	1395	101	1	6301	jwb9gMf4MbMUQvxkJYECoQJYf1zELR8b7MVCqXQuAidsNdBH2zg	4442	6251	6251	1617064380000	orphaned
8573	3NKcENnGn1yaRZdKgLx95f6zMdmuqEe3dFN6u2VWLvKKRc3CPJwg	8571	3NLi1p7mj3Y7h2gX9Y1vict3K8938W61qF735tHNcC9JvKEBsTqq	1607	1222	101	1	6301	jwTTVeeUx4nHeWkAkvuUWoUwaVkvEcjNp5DPAcUSjCZUVAxsGnH	4443	6253	6253	1617064740000	canonical
8575	3NKN5tAhACjZV3CF3K3XMQStPBPdHWB5HLExZadV9rPV2GPKcsWz	8573	3NKcENnGn1yaRZdKgLx95f6zMdmuqEe3dFN6u2VWLvKKRc3CPJwg	448	939	101	1	6301	jwc9XEWianTr4tvy9JKjnxQ5pKCu4VSub7WWqNWD356pkb86tNH	4444	6254	6254	1617064920000	orphaned
8580	3NL1kK9rvKgqBC2wmugTKexXQNXHQFHity3VmBSvy3CxNoAxW4Ae	8579	3NL8TF6Y4gR2RfY35GtLtvrfNM8LniviDVqTrR8Cfzfo6eMENv7b	1579	1143	101	1	6301	jxfJjh1UKBaGPUc6vCQKBEHRPCNS5WdVpbqFxFvmuW5nemVp69Z	4449	6260	6260	1617066000000	orphaned
8682	3NLjfbFWk3AtNnfCrsVab6XDLQ2kpGdRAcFGifYsWqazG1w36R4v	8581	3NK8nhzk9uqWLQ2ehH3CAEgS6NimkGFamQ7KasAiZS8KxD89SrEt	298	1182	101	1	6301	jw7cNRiTvCqqkRLPrz9KUV1uQFc7RDRzujvSNLsv3qtRaMmydw5	4450	6338	6338	1617080040000	orphaned
8587	3NLVmGoHxVsdNBxykHqr3SLNxke4cxpDexaUxo8aZpksyBCS4T2A	8586	3NKZTKYcQrJ695xnhLgTAdFDfHxYKVWC6XtzitYViJuqfZg1wt5f	1426	1118	101	1	6301	jwNk9CNfAV7kv6QSmgidAA9W153GJhw5qirdCTgVt4AezU4eWAG	4453	6264	6264	1617066720000	orphaned
8592	3NKjP7nZ5GE3fUpBUNZykHzechcGgB6UdSqGDaTE39NPexYFWR5j	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1403	824	101	1	6301	jxCCmzXDdrxQYqbLwpQW3Dj5ndBYEE1CppQkKMpTfdjAgx1g7Ag	4455	6267	6267	1617067260000	orphaned
8599	3NL7Xm1pMhsRbMAJkSrRWWi5a4Pdjww94KNHQA7VoaKUYsXLE2HN	8598	3NLXQASrvhWhEmfUeVo4x87AisRimpToxihKcUuRwovbDnPxWFb9	1648	1158	101	1	6301	jx3KZmgQJgiQrRgzL1eru9gSgVetXTeEGEcKtSjq3FBUQQ6xFeu	4459	6271	6271	1617067980000	canonical
8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	8599	3NL7Xm1pMhsRbMAJkSrRWWi5a4Pdjww94KNHQA7VoaKUYsXLE2HN	1646	1108	101	1	6301	jwDuQX4C8CyUzU1qZhCq5Fa1ASH4dimgthkoRbUjY1pnLHFtdfF	4460	6272	6272	1617068160000	canonical
8603	3NKU5qUc4zBxXqTDkCxU14HWeSbB2Z1kLAqvbfJWisvjkqpCzvbr	8601	3NLNeTiz5wpcC3ZtJGZsxHTtwnpWxfHZLEYupCnDsEDKtS8R33py	563	1233	101	1	6301	jxU3jX2EYvnm3h5NVtTBLRVpgprmBEWuu1pP4k5kCnFsNWHwYMB	4461	6280	6280	1617069600000	orphaned
8621	3NL2Zq66HrtgYCBu9tgTur1wMssjrNUBu4E1DhifsdWAiYQK8FmE	8619	3NKPzJZa5cBYDuYNXbvtQGkYBFbvF9ZM26Cny2tddwsMSxRmqqmC	1631	794	102	1	6301	jwZzHC3mK9zgT74fxVXv4zHcA6sshAMTrHVUd2azLRLxWq7M4de	4469	6292	6292	1617071760000	canonical
8623	3NLSwf9VUGxW31X3PiJHVpA4fyBUGi7TP1BtGJ5U9qYh5DruzrVw	8621	3NL2Zq66HrtgYCBu9tgTur1wMssjrNUBu4E1DhifsdWAiYQK8FmE	1471	1386	102	1	6301	jwUd5CkdunX3wkAqXqUyUz5HPgvx5fJup4QCGFzyTwb6DmQWo4q	4470	6293	6293	1617071940000	canonical
8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	8628	3NKzydT7cAYbXxjB3T7hKhmVnc2CdXEZ16p23yUarrBPY19JKbj3	1483	92	102	1	6301	jxue1V47AoUfogysFDGvPTZJqTRJt9HnxJWtG93enBdzsHLpr49	4473	6298	6298	1617072840000	canonical
8637	3NL9vMaVk57ZUk53go4iPc2LTpXEdvuvXkyUoHyF75vovg5pEjKi	8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	1534	1191	102	1	6301	jwwfe8Qr15Y7B5xidkSbyLuHvgvmkcFia7ZtzmPH1DvqzYcEbdU	4476	6301	6301	1617073380000	orphaned
8642	3NLC699cf41ae9DfCHMZChoJJrYjMKoPgY8ssgR592cjsSxzLspZ	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	1426	998	102	1	6301	jwhhCXe37J7kwXYUJsXoBYRfwN58FmnkZ2C9ER93ciFRMcvBDp3	4477	6302	6302	1617073560000	orphaned
8645	3NL5SLwXqG9H25v4taD58hs8j52F57XqFtGM2VNWSmJmYi51Pxug	8644	3NKRvNvvAYcU6ynsT5KghnkqUReM3s7zGMVzifotjn1JTF8dmNva	1642	1121	102	1	6301	jxx8PQMBzDgzRshCtKTq2bAJg3WTDfqk8g8pjKEKrc7bTJvPRSA	4479	6310	6310	1617075000000	orphaned
8648	3NKkXqWuNGV83B93e1vPDQUXkBVJYfUYGvjrRQnSAuFsgXr7dFk9	8646	3NLXgxS73bSbAyD9B4by2VuCyMhB648EYPkdsGwpbzfc7DXNMFNo	1600	1372	102	1	6301	jxGfayUPGq4zMDJ4MNGkqaGUhbj9GyYvwacAaQUWBhsU1mDye2T	4480	6312	6312	1617075360000	canonical
8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	8650	3NKZN3joFr9PpT46uSR4bTGYg8dNLy2qM8yEZvatyHezXCy6fyie	1406	1393	102	1	6301	jwE5GRq8EH4bsgzXVEqnnA6RGyJUAACC1n8tFxWvvnQ3rkBN15G	4483	6318	6318	1617076440000	canonical
8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	43	1064	102	1	6301	jws8sB5cXTXcGkdv4JH2DrVAPCkPGMYRL8hKmMhHLYCWDQ57Q5K	4484	6319	6319	1617076620000	canonical
8660	3NK9mPJ1Eh7R9wvHpQZbu8XwoPG8DjcVmnhq54SfnWz8zk63KDjQ	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	606	1295	102	1	6301	jwCfhfJLfpD7UGNDqi1Fz9zfZRC3iqDRHY572XpyAjT837BPA7c	4484	6319	6319	1617076620000	orphaned
8662	3NKiiZ5WMKnd9cfdzymKnAT6YsYvgJyLkLYgoePBsAnYAiPHpKVN	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	1523	1321	102	1	6301	jxmq8gZ8Dqivnya5VyFzhqW19JXmYfU54PxYbxKk6YCZZtnN4Z1	4485	6320	6320	1617076800000	orphaned
8667	3NKWGMe85ZQmhmrD1b5TPu4TBcDAFVEWZXsaqdojQ84s8ScgeVEz	8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	369	946	102	1	6301	jwaSDHi3tVPzvshQSYVWewYTAQozNyaA39QtuqeJhvtGnHDZw7E	4488	6326	6326	1617077880000	canonical
8675	3NLCBdJqn8URMtdP3j5YfjVwX6n3MPs1RfYNeKH9y8tNbWNrmagp	8674	3NLpYwQ2rQAaXuXf7XK3oLkh1PJRrKCWxa1JCBNhmCLY4Bqt419P	1402	866	102	1	6301	jxxsFD23cxX9wt9nEqRhDdEPiKnafDaNRxmGgiYJDWpqrhTs8uQ	4495	6334	6334	1617079320000	orphaned
8692	3NK3SjHgr4QK9RGqD185vaqpnN31zSrbVqNjtQtgWuiWHuAmte2z	8691	3NKmAkathUxbXibi3otnkx54MtNhYzC7EYkmp7Ko784MbzPMhmmT	1460	1324	103	1	6301	jy1LZVro8jJ1HLe5AM4Lsuo8z1bFNfdL2pLrgWZviSRNYePyaPq	4506	6346	6346	1617081480000	orphaned
8699	3NLTG4bbAXXiaPj71NsCgzcDcqVKdo3XyyR9dffrLPekTt2JfwnM	8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	1624	1334	103	1	6301	jwVbYnH1rTz64KxfCLqynGCx8orFUaAGMgnF77tzTkJUZqf1apL	4510	6350	6350	1617082200000	orphaned
8702	3NKqXdq5EuNCKR4yNwNrcv2AA9bLKkCBACpCRaPyq4BxYhFNpz33	8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	1422	1211	103	1	6301	jxsFhCEuDoP4gUaHDXsXo2RtcfE8MHHQq7H9Z8etGdotXGgb9J7	4511	6354	6354	1617082920000	canonical
13870	3NLpysRVy9symc7kpPmHjW1UNVKqiHh7VNuSagpuWmJgoWeqEgky	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	641	1336	211	6301	10054	jwJraRicHNranVQPbSvvDB9KguFjSbWeWWtM3uvxnku2322HWDV	7118	10075	10075	1617752700000	orphaned
8658	3NLKRogzoQHNnRV5JVXmvmCZ966Ji5ycTpiB4J9mw3d9nH4PeqRT	8460	3NLojLcNpymZQAHTb1dqUFd2o2L4jBaxf99eX54PeJqyFZd7E5ic	43	1064	98	1	6301	jwYpYicNyoKBhD9LHoVhHDJNRc3zQGk9GwshxEaJnbEHdjynx6s	4338	6319	6319	1617076620000	orphaned
8584	3NK4TqYbw4Kiy1QAxDN51JehHDKxcFT58e2KrZZdmJP1MDrjorPX	8426	3NLE8yX9iDX7c6q4h66PGgDSmsn7QLyLWmETeeSNSr7YxbdSDSGe	1627	1385	99	1	6301	jx12MV2wx1Xem1wCRjRKcwoGPWeHsnW5TDDiuqd24JaoKatshw7	4367	6261	6261	1617066180000	orphaned
8567	3NKJ3EVDWRJWV3VQQCFD4tdV63GSTXmySSDhBLqEcyjtBLkNoXWE	8564	3NLSz9Nrsihfztg27YeXupMFL7SPrB4jxkEKxT8hxtZuttM92xRY	1631	794	101	1	6301	jx9yFRoqi222sMRyphhZ1hZs325Ya3odPHZNSYC5YwzLK9NyJRV	4440	6248	6248	1617063840000	orphaned
8569	3NLejZ4e5LGVzZbPwCGQNNYmum5AKDitiZXQWsa5buKED9BMQ6SN	8566	3NLVnH4iZ8bZ8bbViXWkN4HpdxJEAstcZVLSg1dgkWPJzaD9BpCi	532	1177	101	1	6301	jxPque7S5Du1F6adSAV2JWDviCibdkpBtKTNewwZEfwT3JbMbaE	4441	6249	6249	1617064020000	canonical
8572	3NL5AboN7cHRJEHjzmwiXsVy9A4emB836WknLLbUsu4Estiemyoz	8571	3NLi1p7mj3Y7h2gX9Y1vict3K8938W61qF735tHNcC9JvKEBsTqq	1406	1393	101	1	6301	jxvXE954wutLENeG1yBqJmHca5AkDheLuHPjdNtsHS2xzAChUPE	4443	6253	6253	1617064740000	orphaned
8574	3NLr9yur4fPZC3XBNhpW4sM3teFWB39urV1nPXRP9QCLckYjXcRY	8573	3NKcENnGn1yaRZdKgLx95f6zMdmuqEe3dFN6u2VWLvKKRc3CPJwg	1607	1348	101	1	6301	jxvoQiNMtneXRzNWizYsX4tuxNNbDu6Zc2oeypy1pM8QMqnhi3e	4444	6254	6254	1617064920000	canonical
8577	3NL5TNq1XLNi1TYcJwc2VbRdqE4XdYySnaBKyYuu9ZfVQ7keHkvy	8576	3NLmBQBYfg84VKAc3jCJkxkGz8Z1GTbjSB6eoqzg2VK1EqRZoNuA	684	1352	101	1	6301	jy2Ewyqsx5FSzT91RnCgQ4eCSesEe542KMgrkrzoJiTUdjpF6Eh	4446	6257	6257	1617065460000	canonical
8594	3NLaZsFZh6vPsUiCpbZ8RHs7umGNUxaRSFqWhMMY6kzxTow7GnZi	8590	3NKcDxytG9ax86u61M6M4NZYjSjKfHkUBijhx8K4M3uyG2DwKJTb	1577	1201	101	1	6301	jxcRyYmXzTXVgLg23DmaQ6ncLCeGGmByhdNytdqAxTskTkCBvqb	4455	6267	6267	1617067260000	orphaned
8598	3NLXQASrvhWhEmfUeVo4x87AisRimpToxihKcUuRwovbDnPxWFb9	8597	3NLudkomY83ya8uPG51j6euxAXYSGSUv6ixzzrWEWG5vrXW13jZa	1527	1293	101	1	6301	jwRUYu4jKDGzv5EKbjE6er1rPdqNTiDNyWdSmYLFJNrZgC7BfXr	4458	6270	6270	1617067800000	canonical
8608	3NLG59uWCGXrZJSamkyRGBX3EMqsigDWcwgnWapsa873Gzfkmao6	8607	3NLJRDb2gqs4mrfJYQnx4fKD7rq1eSZVcfGEXDVAZsTkadGqKhmC	1407	1395	102	1	6301	jwt5S6KBpK2cYbx6DSV2eFWvHDUQvRXZBMpNX8CAgantzSBsJC5	4463	6285	6285	1617070500000	orphaned
8613	3NLHhHjBLo5W39HjoQAjHZTxDpWob6tkXEmcZ7F4ctNfW8J6wTXE	8611	3NKuJXvmaLaSiZJFyvbPLBr7bkA7MyAv6FUds5omGH8P7SKDLBW6	1513	1379	102	1	6301	jxycVxLbjRkpEqH17hRE55ZMdUSs5RSMEXqQSMQHMCwBBkYzaPY	4465	6288	6288	1617071040000	canonical
8616	3NL46wUnjMjJF8ZsQUr42ceUmrP6BAE1AZEGhC7gY1Q4wFk6nRS4	8613	3NLHhHjBLo5W39HjoQAjHZTxDpWob6tkXEmcZ7F4ctNfW8J6wTXE	1402	868	102	1	6301	jwSnacfjxVf8XaGZhD5AhL2RePT8jUjSga1pGXnFfdFmNkRccp4	4466	6289	6289	1617071220000	canonical
8618	3NLvXn3WqK6cyoJJVVra17UcJtHeQb8djEZSyJBBhzLTWpXXtbrL	8616	3NL46wUnjMjJF8ZsQUr42ceUmrP6BAE1AZEGhC7gY1Q4wFk6nRS4	1484	645	102	1	6301	jxLx2N3y1WpLXzyxkLgpZCut7FUrojiz1WEqLrFxWnirbMuHBfa	4467	6290	6290	1617071400000	canonical
8620	3NKc1c4ZFEXnrT81D61S4G4GAU3ipfNgrwuNv7KnVB19bdQv5z4u	8619	3NKPzJZa5cBYDuYNXbvtQGkYBFbvF9ZM26Cny2tddwsMSxRmqqmC	641	1210	102	1	6301	jxF5pdVMFEuttWKbaanASTsodR2Ww9sTadMHFKiJcSSyWiVBHrP	4469	6292	6292	1617071760000	orphaned
8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	8623	3NLSwf9VUGxW31X3PiJHVpA4fyBUGi7TP1BtGJ5U9qYh5DruzrVw	349	349	102	1	6301	jxwneVDx96L7Kga7ksrWuCCRoTDoYdzTkehUsM8xcpvQaDBoDrN	4471	6294	6294	1617072120000	canonical
8635	3NLwBN4rzMiJR9BJKeNL5sYauH6jko4N4TscNrhcp3Ygs2J3Mm3N	8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	1419	814	102	1	6301	jxRLQHNfwUDm4Dp5ZeDKbgHMxYz4yFqchxz8uvzHj9J5XqAtD7P	4474	6299	6299	1617073020000	orphaned
8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	8634	3NLcTYfE4A8w3DqzFHkGRxpLpcpNaBYjKhqerqwniGp6munMKNos	1407	1395	102	1	6301	jxUqUGDiY2JSdLsZbt5eQYKeKdXZ7QcqYNHDX72AiFvsjXCS1zH	4475	6300	6300	1617073200000	canonical
8639	3NLNKAXLyudvDFnjkq9qkLzeb6jaBeDBeiTQy3daK2fgPPdzJbuL	8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	1623	839	102	1	6301	jxQSKp3zAN9vT8Bi4F5Er5jEb8EmKm4u8PGWhKYSFyn77q3i21L	4476	6301	6301	1617073380000	orphaned
8641	3NKyjDt9xzuzpTex9QUW2aGEjfU584EoRXoKybYfWQDsgG3r7tfs	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	311	1181	102	1	6301	jxgFzQfdnDwUuQtXwN4W5se6ugC4AuGvjLzJwn3h5v15tTXcUct	4477	6302	6302	1617073560000	orphaned
8647	3NKZuv1TCqWV5DoEsYbkWcsx2mdffpZLN4SmkoRgWaRrimBuZz1Q	8646	3NLXgxS73bSbAyD9B4by2VuCyMhB648EYPkdsGwpbzfc7DXNMFNo	1457	1145	102	1	6301	jxjjb3sfKzbrnHfs5dFKfMVzw7NS6ynXdEEc8pmzVssdxXkMrdq	4480	6312	6312	1617075360000	orphaned
8651	3NKy8Ai6ypoq61aU1N4XgVBVD3gTWu8ox6hEM9sXXBhmWbu1Pfxs	8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	1406	1393	102	1	6301	jxkQvBbEgTLXutAhz4xLYdcw4YueAUoDYcZH18GU665DBMo1SRo	4482	6317	6317	1617076260000	orphaned
8655	3NLf8VCBLwaLo1VJyzBqikQ6vBrzNZbH5wEpqZeUSCpwWkFVWM2f	8653	3NLh64iz1UsuVZYon4xeQiGZ6Dq4chfKSZ3KMFf48eG5wdATuecs	1402	888	102	1	6301	jwdjqjxPWNJXgWPfhUCyZCu2kMqPmCat8jj4N2qLhfrDuvBkXWu	4484	6319	6319	1617076620000	orphaned
8661	3NLsxQzHqGoGfw3Gbq2b9z1A9YdDdtnb1enbF9LMnvSXBgTALXta	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	1523	1321	102	1	6301	jx5eVAvnnk9W495yQ5Bk1ey2ojc3Xycpu82Z53YmPLs5SWFqAu2	4485	6320	6320	1617076800000	orphaned
8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	8665	3NLFfsxwGjTYqkjaWHEJonwzArcq9E4fLpGfwsaP9KDQoMvyzNCW	1610	1314	102	1	6301	jwrFEfRsxW56BtWGn8c1WoUnVB2VywryCcNTHKdAw8H9w6BTi9V	4487	6323	6323	1617077340000	canonical
8670	3NLdRr37ztbYiDtsMHKkXtDYxY2UrRiubcx2Cce4kjRTtuuj4XZb	8668	3NK4vhsmiiQyzNrWFeXsPQpDeHWiJC35mc2UuHVLPhCHhoxVFkx8	1422	1337	102	1	6301	jxizDw1px1asKPcw3ckboZYUvZ68M6V4yjBQ5dHyoGb55ZncAXK	4490	6329	6329	1617078420000	orphaned
8672	3NKK2ARxT93gUw9rsoZf35hu6nA1vf1uAVL8Rk1oHg5nDgMhffeY	8671	3NLZ6KP1csWxYDPvrjrAtg75Pes6m9xtgU62H98PwJrURvBUTBHt	1483	383	102	1	6301	jwAi8sYPMB1FgBvCPQES6kGRgwoy9KeD3yJsJxAriSKJEwMFTHZ	4492	6331	6331	1617078780000	canonical
8677	3NL6JwhxFwGoH8SjTAXHQWzE2NkeTGawsVTGyuLQdTxQoxFPZbuU	8676	3NKZLhhtfXfj7btnEt88MkDZnRywA6rLX5CiPbixob3F8MKLWLhZ	470	943	102	1	6301	jxnsEsr1u8KK4ecmfhiBAd5QVyFs1ztCxYsNoaWZNyw1czdVssS	4496	6335	6335	1617079500000	canonical
8680	3NKhKScerycvY1SZnwuTCPkrPH4f6k9ykaPTYw8Uk7RR8NATYA4v	8678	3NKzkP3CZCvWvdJ9qwR1NbkiaFhVgTUModUhtRChiJCBKfAh6nTR	1578	1296	103	1	6301	jxjVFV5eb6fM3dV7VcUKjTUePQvY65s59XffmDUs2vhp1yexe4y	4498	6337	6337	1617079860000	orphaned
8684	3NLRAYzM1oPghMUJWaQqMrdpaAwj4FpQ8BUw6GQ8e9Q4zW3K864F	8683	3NLpK6GhucG3JVhWiU3GJJng7E5mrwgBtWpnDm59K1kUfupnxuSL	58	1155	103	1	6301	jxp84QpAhFLh2YCm3Hya6cbdNXWv5y3gQK1xKTFGjvtjQwvWdXJ	4501	6340	6340	1617080400000	canonical
13871	3NLEVu95841FB3HnmLhWLF98FiCan6ChakJLf5qXppHirgjTBEgG	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	641	1336	211	6301	10054	jwGq3BNBgVxzTT5rDuMS4r7tnfUXS3cRv8GtNKEg9TZ82CEXvvy	7118	10075	10075	1617752700000	orphaned
8713	3NKbLRN6Zo3yNzwThSwKhgvyQUAAhsfWimM3dHUHcLUyZpGYyBc1	8436	3NLDtup7GVRiWqCdKKr7b6rixnMwvVeY4jHghTDy41MqVZsbrHSA	406	406	99	1	6301	jxZwQfUKThinGpv7WY1RirNB987n7mwN8iagpsqGFqTauFpkTQ9	4374	6371	6371	1617085980000	orphaned
8627	3NLhKEg6GirxBcTYm8pegByPUKDXSRYKS2TyrB5bqYUfD6iBDHgS	8625	3NLRsDH2KZmiUNGyJvQNxQ3y3euWxzs5exnTqzAmMdvk9Ar5Y2GM	1593	1346	102	1	6301	jxRsqZHGgG4FFjfkPpq5vY13iEKLQhG4ocdmhVWTY6hcKKbq4ro	4472	6296	6296	1617072480000	orphaned
8634	3NLcTYfE4A8w3DqzFHkGRxpLpcpNaBYjKhqerqwniGp6munMKNos	8630	3NKsEnAhcsMKgDUNDEu848YkesMkdgzzAXEf2pVDmrg5vbjWsdW7	1522	1196	102	1	6301	jw8nHRn2aULsTQRwVmm6f9nupuTMo8MuvxCRtkERD66jNyVdsCr	4474	6299	6299	1617073020000	canonical
8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	8636	3NK6Fw2uuB6xYb7hKy4Ts9duc6zToq7ojPgo8aVugqXxg3TXE4CL	1403	824	102	1	6301	jwtTN3Nkv6MbsEfX9iYdp6BxECJzibLBWc7CfE5yJ66LUHBCHpv	4476	6301	6301	1617073380000	canonical
8640	3NK7tJqSsA7QAgYepy7BLuwpB7rPtEnS4UfB5VyBSict9heGj92C	8638	3NLvth1mdi5Ktjw4KT9gT4BEJBkw3fHfZaVgp1fwGPn86MMFBiwj	1397	828	102	1	6301	jxerxQxfqU4iqgqvqbQAPHcjbrfr7EG5sXbczAexadWK5wjP7so	4477	6302	6302	1617073560000	canonical
8646	3NLXgxS73bSbAyD9B4by2VuCyMhB648EYPkdsGwpbzfc7DXNMFNo	8644	3NKRvNvvAYcU6ynsT5KghnkqUReM3s7zGMVzifotjn1JTF8dmNva	1642	1121	102	1	6301	jxbDwTL7b33b5YZ4u8miFGB5bQfgwL3FcHmP47uezv6nS21WDgn	4479	6310	6310	1617075000000	canonical
8650	3NKZN3joFr9PpT46uSR4bTGYg8dNLy2qM8yEZvatyHezXCy6fyie	8649	3NKVqa5u4PxRooYMcEYrYqZUL8azy4WNHuXKzGt4NQxS984tQ4vn	1527	1293	102	1	6301	jwyKHpDiZWZu6c63jSHTEvE5uTQxXQ188FbG8Zs6QQju2tBPoi2	4482	6317	6317	1617076260000	canonical
8654	3NLe5dhAC4AapL1AzvXsetXKRaUsS29WGNL9oYSZhe9KrvagJQES	8650	3NKZN3joFr9PpT46uSR4bTGYg8dNLy2qM8yEZvatyHezXCy6fyie	1481	790	102	1	6301	jwiPFyGs2moZnS8HsCTFirEaVDLNYwViNmiYDGw5JKLtsT2dgmR	4483	6318	6318	1617076440000	orphaned
8663	3NLhFQ6E5DTyKuTTWipw3QrW9xDjHtFpb9PTUsrjQkMbFYmsVMNU	8659	3NLxwkPzdisb81gDyozM1m7NCP4xgnPtshvgSrxMDDXJFgjWSxfK	42	1115	102	1	6301	jwi5d9cSeYJXThGNq5spUePW3jKLghKsDN5t6C1taMukX4FPdQV	4485	6320	6320	1617076800000	canonical
8665	3NLFfsxwGjTYqkjaWHEJonwzArcq9E4fLpGfwsaP9KDQoMvyzNCW	8663	3NLhFQ6E5DTyKuTTWipw3QrW9xDjHtFpb9PTUsrjQkMbFYmsVMNU	1477	1104	102	1	6301	jwU5vHngGUQN1eVzZUneSSgPog5ahhyAGyMgbgmZLnKoNadxK4b	4486	6322	6322	1617077160000	canonical
8669	3NLWtXVUaREsDCjntpafUtCq9MejNaFVs97GktpRV1S8s3qHeMfd	8668	3NK4vhsmiiQyzNrWFeXsPQpDeHWiJC35mc2UuHVLPhCHhoxVFkx8	1422	1337	102	1	6301	jw8PaqJeyadqYRssR7P9TtcWV7hNwYN3JxBajc6hJZauAepkH7z	4490	6329	6329	1617078420000	canonical
8671	3NLZ6KP1csWxYDPvrjrAtg75Pes6m9xtgU62H98PwJrURvBUTBHt	8669	3NLWtXVUaREsDCjntpafUtCq9MejNaFVs97GktpRV1S8s3qHeMfd	1506	1373	102	1	6301	jwi6vwVuofaviZQJ5TG9CPEtaGXfatm1yJ5soWpihpwY4DkUeLS	4491	6330	6330	1617078600000	canonical
8674	3NLpYwQ2rQAaXuXf7XK3oLkh1PJRrKCWxa1JCBNhmCLY4Bqt419P	8673	3NLSz1JrWdT6gKNBP6nFHHBeGUkRkaBgfzWSx6eaL9cKiadqhAki	1549	1362	102	1	6301	jwmyaUEAxomq6ZWzFRctP1ouBdhGLLQMqvD1iYJLEdp1YQx4g94	4494	6333	6333	1617079140000	canonical
8679	3NLbAGXcLQYpxzd37tfgLM46rP9LRFWLeN3ryfZ6s2JAUSsW2ZkZ	8678	3NKzkP3CZCvWvdJ9qwR1NbkiaFhVgTUModUhtRChiJCBKfAh6nTR	1522	1196	103	1	6301	jwSBxr6rygN957JV6bDhsArf2j6BYDYLi1f3s1qCwbmcJKggSkg	4498	6337	6337	1617079860000	canonical
8681	3NLjp7jizUKepY1WiWT4faRpvni5MoT6pV58NJqAGyDNPXESh1sL	8679	3NLbAGXcLQYpxzd37tfgLM46rP9LRFWLeN3ryfZ6s2JAUSsW2ZkZ	298	1182	103	1	6301	jxGRavW7Yhx1MDDn4FCmhqneb8bzZgPnsYYq7jsmigapKpmQfNF	4499	6338	6338	1617080040000	canonical
8683	3NLpK6GhucG3JVhWiU3GJJng7E5mrwgBtWpnDm59K1kUfupnxuSL	8681	3NLjp7jizUKepY1WiWT4faRpvni5MoT6pV58NJqAGyDNPXESh1sL	1657	1344	103	1	6301	jxPqgS7Wa7VkfAgyyoyUHdRPWrkxHPwoCCb1VwZXDZQMR41x9JJ	4500	6339	6339	1617080220000	canonical
8690	3NLbJY1iGuYqgZUNfLr8hpZ6LQPF2MEZzt8gqKo1FpnxN5NedgWu	8689	3NLH3a42wWyPEKGJVURviVwm1jS7yC3HZuat6pQYAXGtorYYEv9V	1402	868	103	1	6301	jxqMyghfP6hCExtgCgZZGwfvY5jYg718v3K2qok5c3ZUrwA5NkT	4504	6343	6343	1617080940000	canonical
8695	3NKbi6svExfnSRgdor424GcheGeaFqpwW98tagdkiaAUj82VPn7L	8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	596	1180	103	1	6301	jwh9hQ81RV9uEwxhGwfjiGtxsK6wMHgLHsVnNR79SVRkLXnXBj7	4508	6348	6348	1617081840000	orphaned
8700	3NLGgV8uwTX5n4pZY8cSdiq1g9qyXPjBRX7zr8sZxtDHbi1sNosq	8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	1624	1334	103	1	6301	jx5yUXE5jAzsaBsusCCPAUGBkraJkWeHRaYU1MStWSzkwVmPCsB	4510	6350	6350	1617082200000	orphaned
8703	3NK6H5gYstTDi54LFrdU9ddciwv94caCScuBRvH66f5m5Vw7M2V8	8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	1547	1378	103	1	6301	jwHvLdVbshwSQ2Mo7JRuRXFbm6foVmm9ZTVU655UenkcJjGabbY	4511	6354	6354	1617082920000	orphaned
8707	3NLtJiHxvwGFkEUVim3H14vViYZLoJh92PQbJpLCerLkZNmKa6eR	8706	3NK2wBydYwUhpMc9GjNfSPbgMUoH9mxRhzfJx5qMagSZa7L3rsgK	1579	1389	103	1	6301	jxhU9AZApFWF5QGzr87FLhV6LaSw55NTK7aKoBnaZdbWKnxfnmS	4515	6363	6363	1617084540000	canonical
8711	3NKAkp878Lcmfx4wRggLXY1qAyFKTsnXPirHAMLThCrmu7UjkvY9	8709	3NLnzDQ8Yos3JkTL6cdhi1Jy8GGE4RrsN1kPwkqT7cY1vWVqJpAB	44	1199	103	1	6301	jxJbwcziCHLJYJkia7Zc4XYWdNW6bvbM73ExJnXsi1Uk8rBWpDS	4518	6370	6370	1617085800000	canonical
8717	3NKXWg5idUuR89gUEEeXsEmR3FPZFUw6AudvbPjKoScegM13YLLu	8712	3NKNLXEidmMeMB5TNxtdMeex4DmhwENUwTq8WSHpGaoD7UPtxTk8	43	1064	103	1	6301	jwAQ8W9XW4pYkW3TZwZw6hN6nQyatsQWtJexiHCv96sLbMCJCTL	4520	6372	6372	1617086160000	canonical
8715	3NLrNGVCC8Njb6k1h5MtG36VwtBbyyBJ7VCNBgu1s5Es4CcJrpnC	8712	3NKNLXEidmMeMB5TNxtdMeex4DmhwENUwTq8WSHpGaoD7UPtxTk8	1476	1125	103	1	6301	jwPPQZbAqp2np1txXZE4DtbmnTaoRYMAr8G6eiebe1hjXBJHyaf	4520	6372	6372	1617086160000	orphaned
8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	8719	3NL7S8wgNKSBGavWgAEFoXJskteieFrzbZj34pu7io6co7cAGXo3	1649	1257	103	1	6301	jwm7RpBaD6a3h2K9RPQqofvqSRUCFh9Z8nEwFitdXtcqhXKayJj	4522	6375	6375	1617086700000	canonical
8723	3NKJ6kRziNs8doLT9NmYVrNxpY4RQXcp6rnoPVm5e518sMktaviu	8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	1451	1292	103	1	6301	jwp5bbCnY7rEg7Phs4uAp7ceNGurGcgcsGVzKqJhgCizUv6uWmy	4523	6377	6377	1617087060000	canonical
8726	3NLAY4sW1jFA1J8veZpYiQjZFMwedd7mQNsmYSdiwi6nnBBt9Pwi	8724	3NKyjeKaJ1YW1o62oPeE23gR7c7ZJLMtdpXg8duqgXfczzdbaLdV	1406	1393	103	1	6301	jwHNXxxvup5pokhWTDb2iJAkD1N2UiuP9qBJ4uuc7w5QkAj8jdA	4525	6381	6381	1617087780000	canonical
8728	3NKrWcwijk9VrxYUG4MoXx87nqZh2tpxRXvwq7dXpPpHJ4DYDS5B	8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	1546	1339	103	1	6301	jw9hS5czybRTg5G2SjR3p6gKB662bL2i832YZgCZFUgZYG6Y1dJ	4527	6383	6383	1617088140000	orphaned
8732	3NKnBBXf97NAnePGUgUHKthvAaYxEHPn6y4yf8NU3VbQ7Vb1bSmA	8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	1594	1080	104	1	6301	jxXFmQp22uCpzeL8DAxrP6xvwsxXDdgwQk6b4ML58AzXHC4qGtR	4528	6384	6384	1617088320000	canonical
13879	3NLmcvvV1n9Mw4wN179dJWx7qSsq964KevsuctJijpXsR6eq52nw	13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	632	1136	212	6301	10062	jwuunfaH6y3A8oporirK5z1R7jhhTyfsTX4CrTqDMSM4k7o2dWG	7122	10083	10083	1617754140000	canonical
15544	3NKHn3HwZHjfVmuFbrs3HcgE5WLKroGrjUxrEiTxeAYBgSVFBCp6	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1419	814	249	6301	11571	jwA8kkmPh2CjSvBpFJtvXB6z4gsUamNnWxsEZvbPKDXDjARMqsd	7911	11190	11190	1617953400000	orphaned
8688	3NLsDNXagApFN6XzRjoNpmoHJqNudek3abgitrmEK7S9uE5T8YEk	8551	3NKepWzNiDcsYr6EQSx2aVcTJK1Umk3SZKTSXEP2rtDuMdUoyamV	1553	776	100	1	6301	jxWUB7gvmosdNZ3LveqCTc6XY9cfXptyne8sPYNRzKmAA24Tjqo	4421	6342	6342	1617080760000	orphaned
8789	3NLa1AA5LgJrVMcZcizyvasB36wK2dAvqhhu8fJscSrDYzX6Gqj3	8725	3NKZnSphCvvarHEXUGCPv3vm75XXSdYzuYkEEdaPuKU3fqafgiik	1553	776	100	1	6301	jxjb7bkmwAEd9jqKhLijwNvyD1EmMQxnfK6MQK1xChYqJoHK9Qi	4423	6420	6420	1617094800000	orphaned
8686	3NKjD4nxUYxEdL8nr9DKmsHxTBoJyh3wvdoviBMeY6wTYDvuJM23	8684	3NLRAYzM1oPghMUJWaQqMrdpaAwj4FpQ8BUw6GQ8e9Q4zW3K864F	369	1186	103	1	6301	jwvaAnAPeeUwMkKxCp7kkKNoHbc4QZeBLEgpL78rupJPBf39tGR	4502	6341	6341	1617080580000	canonical
8693	3NKnzgyJ9c3kEeRSyiCkqXLMF9YTR2on4cPMssUfpD4drAf3T3tW	8691	3NKmAkathUxbXibi3otnkx54MtNhYzC7EYkmp7Ko784MbzPMhmmT	1405	867	103	1	6301	jxRGW3Sx97vbzqRAX1tkyDmcqycNKZCZZ9njAYhqXBW8YMkH4Ea	4506	6346	6346	1617081480000	canonical
8696	3NLAmrH3PmwvguTSUfd2aSaYXhXwkyJBtxEZrRZLraTtpuFc6tuT	8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	1407	1395	103	1	6301	jxTZhA583xw24oWiRiHKERczEm9aSPoMsGVseGg4yeSg2WbHCQf	4508	6348	6348	1617081840000	canonical
8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	8696	3NLAmrH3PmwvguTSUfd2aSaYXhXwkyJBtxEZrRZLraTtpuFc6tuT	1637	816	103	1	6301	jwxL6y8RK727CvNdYsg4ZAb7SBEm5Jk2PFMgL7CPXbvzH1iLgmq	4509	6349	6349	1617082020000	canonical
8714	3NKy4xHRPeE1AMWrr4ThxgnxchiYq25mGhFmEC2T7ZSv9Qt4UJnR	8711	3NKAkp878Lcmfx4wRggLXY1qAyFKTsnXPirHAMLThCrmu7UjkvY9	406	406	103	1	6301	jx8kkZU8QGwb9zXbdAetSgwm7rv13JDaaK1ZcWkdgeQTvopLjwY	4519	6371	6371	1617085980000	orphaned
8718	3NKJyqaG8ieZvMa2jFfqWKRHfnuAyWNvLa4bVh8eJzD49roz7gVF	8717	3NKXWg5idUuR89gUEEeXsEmR3FPZFUw6AudvbPjKoScegM13YLLu	1460	958	103	1	6301	jxJaERALnaxjpR84otvdVwBNJarKLN62f6QhdpLUYnbTYCRn2e6	4521	6374	6374	1617086520000	orphaned
8733	3NKETsxB2H3BjQa5mFyr75picWeGzQfkA4LgDpNTo9vAV6D1hNsA	8732	3NKnBBXf97NAnePGUgUHKthvAaYxEHPn6y4yf8NU3VbQ7Vb1bSmA	1407	1395	104	1	6301	jxftaLbPJbPEddFAnWsj8DyJfxmnvSNTiCVNjejJjQuxmX7k6sD	4529	6385	6385	1617088500000	orphaned
8735	3NKjKg7usdUdEfV4HVyxwUuJ6qUHbaXMm2xro3iTjNcrCwg3otVd	8734	3NLS4v8SbU7Ujpfp1AidZvLDkWvAucSFX9LiYWA4PzTuV83YenCY	1598	543	104	1	6301	jwzxLxTqRbeN8RFAwL4qXbr6iteKztmgJ16641xHRasGza1jhby	4530	6388	6388	1617089040000	canonical
8736	3NKcHfExhE8cnuemHdjDxRUAEB2Jg6SW483pAW4d3Si1MwHwXMpZ	8735	3NKjKg7usdUdEfV4HVyxwUuJ6qUHbaXMm2xro3iTjNcrCwg3otVd	1611	1095	104	1	6301	jwtP7hFiLgSkwbDxYnix7gsistfkym7HvhX6tBybbrUeUqsiAnj	4531	6389	6389	1617089220000	canonical
8738	3NL73oD8RNUwB9XBP8QC6386vgjVLUMaeso6qMGqEprKE3rukgHq	8737	3NKdkjEDjUSPtuQR3gDHLvw3BCqYPTGW98Fvq7gtoKmsACMa2XNR	1406	1393	104	1	6301	jwFGzWFsKLQntoumLrXaJnpMaqs3wMbotnRZ6g6hvCgFyVM8MGq	4533	6392	6392	1617089760000	canonical
8739	3NKWfZpqevCS1TgzwTx4eSBnrSH7ZYcCAs5ri7CPHHFXWVJ2oqit	8738	3NL73oD8RNUwB9XBP8QC6386vgjVLUMaeso6qMGqEprKE3rukgHq	1657	1344	104	1	6301	jwHuiV1LvudvrmgKuFYm1UF5pG1yEXF6Er5L6LS56VnKf4zenZ7	4534	6394	6394	1617090120000	canonical
8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	8740	3NLoyeCt7wf4f3thoY7AcjrtWErn3dZae5bjaYtQvxRg9Ya2ErQx	1402	888	104	1	6301	jwDjukLBY2tz3JWQTynJyBeGQV8hZKG6Bp4YXZg5cajbDG5JPLS	4536	6396	6396	1617090480000	canonical
8742	3NKRy49mtFrPG46KwhVvray73ji8mdW1gVzXtEyZ4bB23kkTiMKR	8740	3NLoyeCt7wf4f3thoY7AcjrtWErn3dZae5bjaYtQvxRg9Ya2ErQx	1406	1393	104	1	6301	jweU3WeaAMK9UF5AnMKEALX9yDF7nRqTC6P1KPXuRZWzfZWSo5W	4536	6396	6396	1617090480000	orphaned
8744	3NLHoT5wgAnCgDzrG4CwuzQ4NDSkEfAs7oYttGKTLB2CuZ2kArqQ	8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	1529	1070	104	1	6301	jxRyVhpwurWoyVAxTE6nkN2op2kMigqkENCp5eB7JkDgwyJkK5N	4537	6397	6397	1617090660000	canonical
8745	3NLJ1vjhTeLKyaAm8XRW1Jh3RTSAex5TKkoEkxCXeL569CdFcZwD	8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	1637	816	104	1	6301	jxo3XnnP3snVJhwJpBwi7gCrbFk85ei58GruJcYTL9zz5GP2Tgm	4537	6397	6397	1617090660000	orphaned
8746	3NLKfhmrVd96BvNkioebF6cUMZXJJ3ArXF9LAnSdbwNYLTvTEztF	8744	3NLHoT5wgAnCgDzrG4CwuzQ4NDSkEfAs7oYttGKTLB2CuZ2kArqQ	1573	1318	104	1	6301	jxbd3w96kgf3Hkz7b68R4ZyLShZoKnxQ4K7z5LDg35PhC4xotnk	4538	6398	6398	1617090840000	canonical
8748	3NL4uf8tyj3HEYYZgmzCXTLNLyYiAfP8aD9tvJrVAXNn7oAr7q4E	8747	3NLhwo67nsxJQsiJm9UKXGfDwWV23yEMCbAzorsRxTxBGTr4cR5D	1403	782	104	1	6301	jxun4WJYNgQD6J3p1BxTmsbBakhNBFbRRngc9srM2LT5aVV2zMZ	4540	6400	6400	1617091200000	canonical
8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	8748	3NL4uf8tyj3HEYYZgmzCXTLNLyYiAfP8aD9tvJrVAXNn7oAr7q4E	1407	1395	104	1	6301	jwUmFFMHhicUJscTyvdmBrsaTbeSypgKYQtFQ6S7YKG3LK93NsN	4541	6401	6401	1617091380000	canonical
8755	3NK4DExPeQivTBbahFQVhdJjn6EGmV3dK36a12mz1VrTfHCEb7Fo	8754	3NLUrcCw4pHtEwmqgaRH6PdWiqWDYEPTee1nvWxFiZ9txZtSdAqa	1579	1263	104	1	6301	jwLWfSsK8hEND9ZzcZEW5NRj4ycyyQqxpwuQq4DfuCwhsJu8YSX	4543	6403	6403	1617091740000	canonical
8758	3NKRGV2u9Sik5nNzcWFgbFdoHNcyrVAkyrTYkz84bDzS3se8XkAd	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1406	1393	104	1	6301	jxWuLtFnyce1cMiErAjQQGrkkRz6SYMzi6xJ4ywwJXyCBWw26Jw	4545	6405	6405	1617092100000	orphaned
8762	3NLFavijSg3zb42U7cWNDC8Bc6quuTuFc7ohQaykbPFgEVp4jVrb	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1671	1239	104	1	6301	jxp61bTXWDEKuH5KHijFcZXHr4utiUe1NkoWY1hKo61JgWjUV8X	4547	6407	6407	1617092460000	orphaned
8770	3NKR2zaiCypee5AcGVPQhKd7nfHDWzQAR4jxqx6Z96F9m2Vg9q1s	8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	1631	794	104	1	6301	jwWo4PyZubgKXdCDcLhpMRhTbpV6LWt1tLwY9xib2bHUm18TXZz	4548	6408	6408	1617092640000	orphaned
8781	3NLX9Z5SF3tAVdhdQaTBWsmbfHwdxjVdMWbHRmvNnVzBJHh2kJMG	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	43	1064	104	1	6301	jwCBpMeZSFhFXL9ZYoJoneJ31RToTU2JPyKjYHa83EzXVk6FDJ5	4555	6417	6417	1617094260000	orphaned
8785	3NK94H9bMEXzUNNkUAhbVCEfbyp8UnDjJajTpLJScFwefB64pKDU	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1474	1083	105	1	6301	jxR71eCaWHwtXPu4323JaXeB4rK7iFpATqAnFeQKZUAS7obzyYj	4556	6418	6418	1617094440000	orphaned
8792	3NLJ2PZqKfAyzZeiMzcT77ye4ktVL7XrHQowTzeBptuUkqr4fKTr	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1402	874	105	1	6301	jxRNcmgFj7afLkLUtu74ScDCDLqKv6FXYpaz1cW9nyyB5ZMStJa	4558	6421	6421	1617094980000	orphaned
8796	3NLP7dFm1VJT19KWK7gBKtyUdxxgp8zThLyz2ySPr2kqR6cKtD2n	8795	3NLiySTYhNvbRXHQhrh2wJgaYtqgA5EaoqN3xKrPLtVpFUzXKc9V	632	1136	105	1	6301	jy3CcSmTBXZ5fgdsYx7oy81QEBXeeUaU1etiXynkStfjLG78okn	4560	6424	6424	1617095520000	canonical
13883	3NKXqdL5VqJ7e6vPGudA6nUvoUBFLYNR7ULzrF5hmac13tYXK4GH	13879	3NLmcvvV1n9Mw4wN179dJWx7qSsq964KevsuctJijpXsR6eq52nw	1609	1333	212	6301	10066	jwK3qEcnebZAfCzmfT4LDkBhtmnJWhHM847qC6vyihCQPsQJZSs	7123	10085	10085	1617754500000	canonical
15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	15558	3NLJtNsw6NdZY2oKNbMeDdqw4W67LsdkMAuuayqetJALy68zNxY9	1406	1393	250	6301	11588	jwjjnYvVJ96WGHP4mfATSctohLvoCCA5113QhADaUyJv1fpYEcL	7920	11210	11210	1617957000000	canonical
8687	3NKURwodWHPxR1W7TKhAxy6SNnY8uZXd7CAospm37kKYJe2zndoh	8684	3NLRAYzM1oPghMUJWaQqMrdpaAwj4FpQ8BUw6GQ8e9Q4zW3K864F	1542	1058	103	1	6301	jxBn8EH54ED9P7wASpANQb6BTcXpXtE1mwZ5F3z89eToHJqEutn	4502	6341	6341	1617080580000	orphaned
8689	3NLH3a42wWyPEKGJVURviVwm1jS7yC3HZuat6pQYAXGtorYYEv9V	8686	3NKjD4nxUYxEdL8nr9DKmsHxTBoJyh3wvdoviBMeY6wTYDvuJM23	1406	1393	103	1	6301	jwhvj35WWKaXZq2VUvzxVyLxYsGtiREdi1YyS5fWBnoYQQ9qvGN	4503	6342	6342	1617080760000	canonical
8691	3NKmAkathUxbXibi3otnkx54MtNhYzC7EYkmp7Ko784MbzPMhmmT	8690	3NLbJY1iGuYqgZUNfLr8hpZ6LQPF2MEZzt8gqKo1FpnxN5NedgWu	1581	778	103	1	6301	jxQFM3fP9AJWKxQMshYaaSzWFFaddimcNWAGU4Ndt96qYWko6yj	4505	6344	6344	1617081120000	canonical
8694	3NLokrEQCgA64n6rDXooqwXQ3RFi91KBYyJHhgaMUhW3EZVWYFEt	8693	3NKnzgyJ9c3kEeRSyiCkqXLMF9YTR2on4cPMssUfpD4drAf3T3tW	1501	1360	103	1	6301	jx4MA6iMzoUSgSEfro2GCoywdTa2Ho7PwX7ZtXJqcDsuNzVpxcp	4507	6347	6347	1617081660000	canonical
8701	3NLuaPfxRGvGJFW8Hxn6JzJ7Kz7KiZD5W7GF27Dbi46ZvYgJAEMP	8698	3NKnefaiJwieP2fYHxR3tqcLZj7bprzkEzApruGoUkQNZLUdVVqY	1650	1249	103	1	6301	jxsXt75SLwR23UVjwBiAPqTEmcbU4JxGhzFd3sNQLg3uACKgmEU	4510	6350	6350	1617082200000	canonical
8704	3NKN2qYCfLWfytPBggU6gW1DpgdPQb82ojt4pAJjpBDijGsd3K25	8702	3NKqXdq5EuNCKR4yNwNrcv2AA9bLKkCBACpCRaPyq4BxYhFNpz33	448	939	103	1	6301	jxJvSuE3VjeBhRV3UcBBEsCwKLX1zfTdfZE8M2RypenurFvgbhr	4512	6356	6356	1617083280000	canonical
8708	3NKyGo5uAnKfzU3vKWhD3Rnf3xgQa6t7kfEEXmjS41R424a6fSdw	8707	3NLtJiHxvwGFkEUVim3H14vViYZLoJh92PQbJpLCerLkZNmKa6eR	596	1306	103	1	6301	jx8r34zAZPrQ8gybqVmEfMzpHM1UidwZ8dn66m711eQgMNu92kn	4516	6364	6364	1617084720000	canonical
8712	3NKNLXEidmMeMB5TNxtdMeex4DmhwENUwTq8WSHpGaoD7UPtxTk8	8711	3NKAkp878Lcmfx4wRggLXY1qAyFKTsnXPirHAMLThCrmu7UjkvY9	1501	1114	103	1	6301	jwGjABW6UhtqhVTYYG9UCWeZFPtAnEcgkWD2pn24JJr1L71DADL	4519	6371	6371	1617085980000	canonical
8724	3NKyjeKaJ1YW1o62oPeE23gR7c7ZJLMtdpXg8duqgXfczzdbaLdV	8723	3NKJ6kRziNs8doLT9NmYVrNxpY4RQXcp6rnoPVm5e518sMktaviu	1560	925	103	1	6301	jxBa3xfNvbLf9MsJ8kBKyCpAn1a13H2RgDzJyMRFkiPNucqFNpa	4524	6380	6380	1617087600000	canonical
8729	3NKunhhdgRBaosPDLEDmXz7QjoF2UWQ4vYxXjrzTm4QSMaX54zeT	8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	1403	812	103	1	6301	jxVTJkoW4mm3d1zNCuDAVXCtTJeUe2RoWsRTusvkMzup3JvQyeG	4527	6383	6383	1617088140000	orphaned
8731	3NL4ojAYsnsfgjBy3SHmpwTwF8YzBToLaYS4r9NSsZtzbdwU4KcQ	8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	1407	1395	104	1	6301	jxwLdH2qqCgbbNKQ8JqG2xsSqHYNg3So6BN7QE6ZR3eSYrCB7iL	4528	6384	6384	1617088320000	orphaned
8734	3NLS4v8SbU7Ujpfp1AidZvLDkWvAucSFX9LiYWA4PzTuV83YenCY	8732	3NKnBBXf97NAnePGUgUHKthvAaYxEHPn6y4yf8NU3VbQ7Vb1bSmA	1406	1393	104	1	6301	jxvAHvWXgeKpFLRDUHPi8zk7QggQrkifaehLFXxCh1wXXigFwkS	4529	6385	6385	1617088500000	canonical
8740	3NLoyeCt7wf4f3thoY7AcjrtWErn3dZae5bjaYtQvxRg9Ya2ErQx	8739	3NKWfZpqevCS1TgzwTx4eSBnrSH7ZYcCAs5ri7CPHHFXWVJ2oqit	1481	789	104	1	6301	jxpBaZTmzbsh6r3NxwgtPR8YfEpvWtikyPQFrMow3PcayHokSp9	4535	6395	6395	1617090300000	canonical
8747	3NLhwo67nsxJQsiJm9UKXGfDwWV23yEMCbAzorsRxTxBGTr4cR5D	8746	3NLKfhmrVd96BvNkioebF6cUMZXJJ3ArXF9LAnSdbwNYLTvTEztF	1406	1393	104	1	6301	jxBJqj8ap1BLBekoj6NAmpsQR9TKagmhYfrjkYFT9MGDEBvSF9W	4539	6399	6399	1617091020000	canonical
8754	3NLUrcCw4pHtEwmqgaRH6PdWiqWDYEPTee1nvWxFiZ9txZtSdAqa	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	80	907	104	1	6301	jxXne8s6t2sjBayf9DxeT1bMB94YHNy1BbwhL52b6xLtcGkNb7f	4542	6402	6402	1617091560000	canonical
8751	3NKpbDBcRngTg8dFsam1sQ7DPZy4zqY9HGrMjHsBGp9gYvJkCvie	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	80	907	104	1	6301	jwDeZQgvKJjw829muj7mR9v9yXfuxWVZTt4A5zn5cPTVjJHastY	4542	6402	6402	1617091560000	orphaned
8760	3NLtF6QroXqbCbu67vxj8nnVWfHuiUpVeadduhP8pY73cDdAJ7hm	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1631	794	104	1	6301	jwZzmga2mAWGeYxv1DAFNSbfURPYpLmsASV5cJ3vZzvpPpuuubt	4545	6405	6405	1617092100000	canonical
8763	3NLs7nto4Q9HysQ6YD4SXiyZp3QjVJdDEKYhaLW8xWzbYLpzYmaE	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1402	858	104	1	6301	jwwEApr3ojLsmKB2hVdAZzHPyN1MySnFjUJDNJqix2Nr8VVp3Hc	4547	6407	6407	1617092460000	orphaned
8766	3NLfUikm6tWP99P4yJb1DM6h6YZiV8HUQt3wrFy8NuV14HJeWqWx	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1405	867	104	1	6301	jwpyGWyit7MHu3BvDm1sEKv6LvAeeDJPZaP5FcqNy3KAAYNsddg	4547	6407	6407	1617092460000	orphaned
8771	3NKJSrZBDYUYf9z4He6E5ZU5re1KbHty7qZPe2Vr3jdXLhZoNu16	8769	3NLXpQqu9posrQZK8JXTiDaGWxq5mRw2JhGwzpzNhLycAosxLFrZ	1406	1393	104	1	6301	jwVn6MZPfjcPp44SrcGJCb3hSLZBWZsfEyHa4shNE3pzg3H2ypw	4549	6409	6409	1617092820000	canonical
8774	3NLXzdFj2KKzh6cQtXLPa1GAq3bHDs9hiyt9icGKjjATuFYj4m7m	8773	3NLNYrFym27EDRoti4Q4simodruJzQZEeYLAFebrXuTydmccnf5h	1406	1393	104	1	6301	jxXsW4G3f9cfJHC31nNK4BXtoQGTJpyjzWkhfEYyiGw2cUHpAgB	4551	6413	6413	1617093540000	canonical
8776	3NLXYZFfGkucm7uG79GYbyTbo9WN9aaPY3ceHmRmB2Fug1iWiY2G	8774	3NLXzdFj2KKzh6cQtXLPa1GAq3bHDs9hiyt9icGKjjATuFYj4m7m	1560	1291	104	1	6301	jxTbYBt9eEhfbPWJu8hXjYS3HPMojQWoKrh1Pr8Xu6jXuXbA22p	4552	6414	6414	1617093720000	canonical
8783	3NKb6oQgpqS9QeBUM4rWydEArVdHnXsdByNbhiKDwh1uL6YhhxVu	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	606	1295	104	1	6301	jxroQdEhAhs4QzeemsXnqCdBC6jq2rm7LjvSuKsfNn1PHQS8Ucr	4555	6417	6417	1617094260000	orphaned
8786	3NLF1FuoE7WLSSxdYndWQBJHd9yYfr85ai5tWxiRvoWBABPCfrd6	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1474	1083	105	1	6301	jxqpJCACRH6q6aeebkEcchFTRaPyvC7gkaRDWjWVMGAdxF1Qmd4	4556	6418	6418	1617094440000	orphaned
8793	3NL39ENAnScuaNDF75W5WcC7BLfdYLxhthnSrmkDF6WV1LmPUv9o	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1541	1052	105	1	6301	jw9EfD6k2GZt4QoeJfsLBRgcGWLUXdbQxgsZcwNvRwg3tX8eiw5	4558	6421	6421	1617094980000	orphaned
8797	3NKL4HCJYSK15unK1A5h5TdSgv6ScrVhomk1gWxF47gQiPaFNXJJ	8796	3NLP7dFm1VJT19KWK7gBKtyUdxxgp8zThLyz2ySPr2kqR6cKtD2n	1581	778	105	1	6301	jxr5XjK9gPPKoeMrQSSef5NriZLT9nQEMAo4SbdFmC5aVuELjUm	4561	6425	6425	1617095700000	orphaned
8799	3NLL5XLCY4hE3j9YqEKwjFkLxqHnF4gHmKhXXBv1epjW6wwxXwcG	8798	3NKV72BnnXRSqgFyEJRWE5sR6DQ4mRzxjWpx8oyie1hGYfN9vSU9	1671	999	105	1	6301	jxiFmjA4rZd78zqKKUsC72S22E5j1a47x9jaWyHEw7VmyDVfo1G	4562	6426	6426	1617095880000	orphaned
8804	3NLSmQ4U6HfYLwn8zbytMoFW5JC681Mj4VHtuqMqqa8tQkhNAjy8	8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	576	1229	105	1	6301	jw7ku8RQji9PP2tcKz27ohJvQGHKPrbAKr4ryUdZXwKVjTrgsGJ	4564	6430	6430	1617096600000	orphaned
13890	3NKUZZuP1iauZnFkNMMgLxVRGz8cjrrWxXFSspvvqmrx5h37aMxy	13889	3NLGDF7SMVqy8LLpBefbaztNYKsWharGEXv7ehU3hV2MEoiaosMm	1643	1173	212	6301	10072	jxoytUCMpfSj3WieBEnb9ApTfK9hG5EH3TMg3kyWNwVR9bmRr3C	7127	10090	10090	1617755400000	orphaned
8706	3NK2wBydYwUhpMc9GjNfSPbgMUoH9mxRhzfJx5qMagSZa7L3rsgK	8705	3NLQBzV1XSwTehAYRWcdt1wa2vyfJ1kL5LsWL9BsRTqMBVPFbqyX	1555	1347	103	1	6301	jxrm4ALxbynosfrSnF3HcmHcRhBTT8NTMKrPaftmVaD3FvHkNHD	4514	6361	6361	1617084180000	canonical
8709	3NLnzDQ8Yos3JkTL6cdhi1Jy8GGE4RrsN1kPwkqT7cY1vWVqJpAB	8708	3NKyGo5uAnKfzU3vKWhD3Rnf3xgQa6t7kfEEXmjS41R424a6fSdw	1483	1150	103	1	6301	jwmbM8RxvWmfnupwFDi3ErzxvWPwSY8JcDKRoUQMoyUmTtytRe8	4517	6365	6365	1617084900000	canonical
8710	3NKBTnvgrX98a3haMpaUBqxn5JRfAz6W2TRb4vdpBd84Qdj89H5i	8709	3NLnzDQ8Yos3JkTL6cdhi1Jy8GGE4RrsN1kPwkqT7cY1vWVqJpAB	1407	1395	103	1	6301	jxFn9KjUsFi3vtWVD1J9KjSqKNpgWqBYdBB1EiYRzhRXUfNbRzc	4518	6370	6370	1617085800000	orphaned
8722	3NLjgwhzvqBaGpojstLRY6diYfkAAuqbRHE9q32t1UHwjh1eMy6D	8720	3NLxqQcwHci3Cx9dpQG3HAe971DY9fCAkn6R5rvSLm2xBScocSiz	1652	1315	103	1	6301	jwtPqgH5ZYmUQzLL9rQ5dQJ6Z3XsXNHjdEE9sMTv8JqpbMgYe7q	4523	6377	6377	1617087060000	orphaned
8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	8726	3NLAY4sW1jFA1J8veZpYiQjZFMwedd7mQNsmYSdiwi6nnBBt9Pwi	43	1064	103	1	6301	jwAAdu55Q5rXMkCJPmrrn5oAsQK3xxELisGf6u48DvGp6reHcWs	4526	6382	6382	1617087960000	canonical
8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	8727	3NLK2ub5b9SfyZYy1KufMnCsVZutDZKoVVvhWGKJYaPyW6DSmPH3	1546	1339	103	1	6301	jxSZEVeqPJZngYkTLnuL7GLCQ6f2eQYT4hBvgbyJjH1KKfmRT9y	4527	6383	6383	1617088140000	canonical
8737	3NKdkjEDjUSPtuQR3gDHLvw3BCqYPTGW98Fvq7gtoKmsACMa2XNR	8736	3NKcHfExhE8cnuemHdjDxRUAEB2Jg6SW483pAW4d3Si1MwHwXMpZ	1406	1393	104	1	6301	jxByvZRLnA2ATr5hFkb3bHFWzrBn7vipMXqUGUsxk2KNa2omRmt	4532	6390	6390	1617089400000	canonical
8743	3NLWcnwui8rRv45ZRoUSJJnToDcNQUbpfmope48QESGGNct6vda6	8741	3NKXEMXbirY8ReSGi3b42RF5x6SR1dfkgWQkLYeddMBtxzvo2ZL6	1451	1292	104	1	6301	jxUZNZfRhrpL5RVsKVsmNmDqP4A8SDKQQwu4Xk9ecgM4iETL3rt	4537	6397	6397	1617090660000	orphaned
8753	3NLULdvfAMfG8uyMwpnnSYjn6VeDpKL8Z3PkANMptorHuSgg8uGx	8749	3NL7GM27WWmC6s8p2iXkyZQwb3BubjsgKomwtFhUKMpRByhL7Ekj	1406	1393	104	1	6301	jxvsVxwztNCDD95hEvxK9MHA7dGaJDsAwPhhSAr1pDggasKmLHz	4542	6402	6402	1617091560000	orphaned
8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	8755	3NK4DExPeQivTBbahFQVhdJjn6EGmV3dK36a12mz1VrTfHCEb7Fo	1403	824	104	1	6301	jwgyYSwFQQKt8PbKi4KmNFwx1xHiHitGign6gS8UtEVZiGLBjon	4544	6404	6404	1617091920000	canonical
8757	3NLhupHmLTeqo5baYt2PLPBnoLsj7WV77Y3BaGqSoQ6rsoDKXjqD	8756	3NLoDXHxzEihhKe94kW8mdyDmv6tEryu99MSqwFoVLWe7QP24ENa	1670	1036	104	1	6301	jwFwkEWzgHa2vWWSHxGSWnN4diPSnJ4hjz5oPU3fvN9sGABsqoE	4545	6405	6405	1617092100000	orphaned
8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	8760	3NLtF6QroXqbCbu67vxj8nnVWfHuiUpVeadduhP8pY73cDdAJ7hm	1500	1297	104	1	6301	jwL9RSe44YCntibyLWtXaSB1wTD21h6BCrqNxfaGrbpYHYhYbe4	4546	6406	6406	1617092280000	canonical
8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	8761	3NKPJP6gEf997bpQrFABF7kx3Dx2ZXxs8sXNnJHav8bRTw6jVxWP	1407	1395	104	1	6301	jw76Gc3mxD8mLysSjgnxE5qknjwgwP2Dax5BnfdekbWNjtAS7Vp	4547	6407	6407	1617092460000	canonical
8769	3NLXpQqu9posrQZK8JXTiDaGWxq5mRw2JhGwzpzNhLycAosxLFrZ	8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	1406	1393	104	1	6301	jwhTCz9wnjXvUNDqvhPi8y5NWANNn7Ei7W4nrypE3KzRWyXazG7	4548	6408	6408	1617092640000	canonical
8814	3NKGg5C2yb3xuGxYEZJ1pHyLNm4y9PrffqT4uJFV3jd69vxd6L1y	8764	3NLdFvWKrrGCojvSNBJNiXPqF1MAWkZZZexGCG5GiB6cNPWhwZUf	1529	1316	104	1	6301	jxKyvCXmQNAx5aNyg6qDgYJrze1GYuHY4z23DMzmX4fjCtU3PtU	4548	6435	6435	1617097500000	orphaned
8773	3NLNYrFym27EDRoti4Q4simodruJzQZEeYLAFebrXuTydmccnf5h	8771	3NKJSrZBDYUYf9z4He6E5ZU5re1KbHty7qZPe2Vr3jdXLhZoNu16	1619	1029	104	1	6301	jxpHWY7W3sLFpxXnQJ16HdeD9rVRcsKiUmLUUkYKxTJigf3mnFN	4550	6412	6412	1617093360000	canonical
8772	3NLsrYuhACJhRAoidVZ1MWVrhcZWH7YV7qSuKDRaeaaUUwRjc1gc	8771	3NKJSrZBDYUYf9z4He6E5ZU5re1KbHty7qZPe2Vr3jdXLhZoNu16	1599	1287	104	1	6301	jwaRvhxJPNW5D62Hrcv9feSa9AExe73duGe8Zdbv6BogTcCpfvD	4550	6412	6412	1617093360000	orphaned
8777	3NKBRrFxzzGin8LvFJxg6HPN3VvYZW2Nv9m6CKEaCRQDEQDXonxF	8776	3NLXYZFfGkucm7uG79GYbyTbo9WN9aaPY3ceHmRmB2Fug1iWiY2G	576	1355	104	1	6301	jxRedoJDcwugYTin3SPrFjy17d5daSMX5ko3D3FeLE5wVDZ2T3y	4553	6415	6415	1617093900000	canonical
8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	8777	3NKBRrFxzzGin8LvFJxg6HPN3VvYZW2Nv9m6CKEaCRQDEQDXonxF	1560	1045	104	1	6301	jxABRBCeBmXhey73PHM3T4v5SFc6xhptdYYyFjBn6LHvTEotXge	4554	6416	6416	1617094080000	canonical
8782	3NL2ZE8iZNNsBbxeAGPqEmovSGtA39grKxUVcVFtNfihifHJ2iHm	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	606	1295	104	1	6301	jxroQdEhAhs4QzeemsXnqCdBC6jq2rm7LjvSuKsfNn1PHQS8Ucr	4555	6417	6417	1617094260000	orphaned
8787	3NLgXpwsskKxjRCR7QjQfNKkBv3uhpvZLNRS5xAZNvZbRhjhUDcR	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1541	1052	105	1	6301	jx6EAaV6eUgYho9fKtt1Vg11vNHoXL3VB2EeTHrp6xnXErcLav5	4556	6418	6418	1617094440000	orphaned
8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	8784	3NKSoUrfAP9zqe6HP3EGWSrzhnpixbez7Hk7EerXjYpCybwKbdme	1402	906	105	1	6301	jxgs3BS6wVuYTsxbCHUFXufZ9WpZx8baFhbSwxJrXPWZEDHJkb6	4557	6419	6419	1617094620000	canonical
8791	3NLvkDbsM96kp7sbzu7UUmVVq8anDWCLzpHvQjC9DM6WWTqQs47B	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1407	1395	105	1	6301	jwvsm34fSzs8wEbwNKZdM5VqchS4JRqk4R8cD9LMFtC5X2ytwto	4558	6421	6421	1617094980000	canonical
8794	3NLVLiKHf7vYhp7Tws2dReNGikdjhVcfmD677PugS5fxGRrhNQua	8788	3NKjjDgYQkPJc5KKrBD3YjBednWLNeCYR8FrCQkPSVnQSBHhNRTj	1500	931	105	1	6301	jxTmp6PEfdFM8b5arAPmLwgH7vLCoxzVXxCFfKGHobTA9wv2vzC	4558	6421	6421	1617094980000	orphaned
8795	3NLiySTYhNvbRXHQhrh2wJgaYtqgA5EaoqN3xKrPLtVpFUzXKc9V	8791	3NLvkDbsM96kp7sbzu7UUmVVq8anDWCLzpHvQjC9DM6WWTqQs47B	1590	1054	105	1	6301	jwgT3g1ePU9djRMNi5rdTFZBSkU5yJFecE9SR3bpoz9QYwm9AQz	4559	6423	6423	1617095340000	canonical
8798	3NKV72BnnXRSqgFyEJRWE5sR6DQ4mRzxjWpx8oyie1hGYfN9vSU9	8796	3NLP7dFm1VJT19KWK7gBKtyUdxxgp8zThLyz2ySPr2kqR6cKtD2n	1633	1390	105	1	6301	jwGUkbj3HyTuvgFAUYWgQcc4rLTkNN5onNcRgL8MBcdHUZBZvFo	4561	6425	6425	1617095700000	canonical
8802	3NKpZo8Znke6DNadSL9rq1Xc3gWZ35AjPFUVPjpG9VmpMBduncvy	8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	171	1374	105	1	6301	jwCTtnWxfeymzMPxxK8JVRZa6UYP5muJCFiA11hbtKMxBNx8MNx	4564	6428	6428	1617096240000	orphaned
8805	3NLHC9WamYjvvUyW4VfSYQMFm1ZSnn3q5hhRHg6WoAZfxwnBSRNh	8803	3NLsATWUyFNdPh5g4DXBYX11SAAwLtJpffaqdUjjVbcEUGRA3jqv	576	1229	105	1	6301	jxTTW351Gy5Z4VLVZbvyoNQLJQr4FgSTkv52f4aKXPENtCRw1ZL	4565	6430	6430	1617096600000	canonical
8807	3NLnb89SL3nimVewtHLVR4nysvsWDZ4oJ6ZbESpsf5EvTXRGp1kX	8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	1423	332	105	1	6301	jwvULxeY9vPVWKiswrdYMUr9GaZ8diiB4k4E57Sfr8JZcRdxkPs	4567	6432	6432	1617096960000	orphaned
14000	3NKX5s792zci5Zroq4e98hWjzgNLiY6JDsVvuedsACv3wCzz8dYV	13984	3NKvzzWYUzdiV5hwUgfz8SqVN3nqnRbnYGek8sJ9Xt5j8AWKneie	58	1155	212	6301	10162	jwJQx2DbKULzC4UXy2vTTgQsVVxYzC41Qfqpn866q8WfGunZhyY	7129	10161	10161	1617768180000	orphaned
15560	3NKu4Vb6XVEK2uEsQBgSosHvvYQG7PgQYcx9KA1GEXNcikHVENAX	15558	3NLJtNsw6NdZY2oKNbMeDdqw4W67LsdkMAuuayqetJALy68zNxY9	1610	948	250	6301	11587	jy11HKz4ahBszJRtaSv1dhGqGmYcfN34P1VdJewAGPFyGXtbLcp	7920	11210	11210	1617957000000	orphaned
8778	3NL4XHSBymyUTuGRqKDB6M72jP3mt2ZREciTU3HAvjK14Jcz9AFE	8776	3NLXYZFfGkucm7uG79GYbyTbo9WN9aaPY3ceHmRmB2Fug1iWiY2G	1650	1249	104	1	6301	jwSxkNS5QTfCNoq8dwdTxuC8JF5aePTGa6ks2L2jHEqpJSVCCUS	4553	6415	6415	1617093900000	orphaned
8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	8779	3NLG2tcLSKTyBoWUBgrSpS2LY73BKqokUWJSS9AzFVHpJXaxCbwQ	43	1064	104	1	6301	jwW5pD22ChmR48TrRbPUDM7N9nfytbgfEL2xDLD22ZLcfJC778f	4555	6417	6417	1617094260000	canonical
8784	3NKSoUrfAP9zqe6HP3EGWSrzhnpixbez7Hk7EerXjYpCybwKbdme	8780	3NKr5Q1zNQavZXprRutfxsuUJWNoWc37KU9ge1hdiCAjBCAE23y8	1541	1052	105	1	6301	jxAVjsd5FP3ZhEJ6ZQMkYEp2KefmgGLULgB8p7n3SaFKEGwHRCj	4556	6418	6418	1617094440000	canonical
8800	3NKc17YLXfq9AaDcKYB92fdP7YUafYgaeo47yNYEyaF7YQbWaNgt	8798	3NKV72BnnXRSqgFyEJRWE5sR6DQ4mRzxjWpx8oyie1hGYfN9vSU9	1406	1393	105	1	6301	jwgBrWjE4fmYQmfANrMdDJQjS7jAje7kXYDsUFZXziquJFPhFN3	4562	6426	6426	1617095880000	canonical
8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	8800	3NKc17YLXfq9AaDcKYB92fdP7YUafYgaeo47yNYEyaF7YQbWaNgt	1578	1296	105	1	6301	jwSsp9E4nNxcmmzHJGEBXqGF3fSYKhvPWAwRcdWcBE1A2DWw12p	4563	6427	6427	1617096060000	canonical
8803	3NLsATWUyFNdPh5g4DXBYX11SAAwLtJpffaqdUjjVbcEUGRA3jqv	8801	3NKTRRD2W1mczNKkYdkosPGaQFjYYa7DUjy7Dg76NMZVobLzH3zr	1631	794	105	1	6301	jwwzg3YBnjMCwwMNCafL6A4QPZdRGUo1gZeQ7b4K8fHcA1KKYVo	4564	6428	6428	1617096240000	canonical
8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	8805	3NLHC9WamYjvvUyW4VfSYQMFm1ZSnn3q5hhRHg6WoAZfxwnBSRNh	1422	971	105	1	6301	jxZeYtA8k4QWXqsoFrXtZy7Z1WsYHWLJVPHmgNYHeNCynnfNSrt	4566	6431	6431	1617096780000	canonical
8808	3NLPqLytp9DZfkeTrvUNedkQRzGQDuRuY2VoQqo6xqHGxKS9QS4f	8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	235	235	105	1	6301	jxCsWCEu6TJ4wbx5PTx12Ncw72U37MM1wJGTVwDf4AnD9CoFuXP	4567	6432	6432	1617097010587	canonical
8812	3NLLcHxEFTurm35BeJuVq6A1DFSXRoZzwS2RkzeLF4zcbKqP9gyf	8810	3NLMAqFdiHhtnxXR9Xn55ARKnyVLMQyriRV6BJbiFaMAheukXEW5	1406	1393	105	1	6301	jxpFiS5UW3h8hG9KiRzp4bveBVngsZ4u45gDu4PDrfUWW456KHr	4569	6434	6434	1617097320000	orphaned
8815	3NLPjsz8WC6i2wxk37Sw3sEmWmJhj6Jv3xV8c3shgKe48X5vGPSi	8813	3NKakBmHufULt5BmD42mesjBbdYieovzLS9e8oz31cEdgKJSpQrt	1529	1316	105	1	6301	jwNPWmtdHnhHb8suMVwQ18MyQNPKQ2G3BZ5NwL64arngw7vj9V2	4570	6435	6435	1617097500000	canonical
8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	8815	3NLPjsz8WC6i2wxk37Sw3sEmWmJhj6Jv3xV8c3shgKe48X5vGPSi	1619	1029	105	1	6301	jwV5dvBRAh3DMRdqB4CZCTi4Q9hPkW9FuypCuxEzs1qJHNagY4V	4571	6436	6436	1617097680000	canonical
8820	3NLfHxTXYmKBFq9aQhDqYCAC3mzoG9bCb9xKiN8aS55qLsY9xn48	8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	1581	778	105	1	6301	jxFCRCYDGr5m5YLT2wF8jZrsCqLPf6yJfwtFwVnPkBsyDQrGQhF	4572	6437	6437	1617097860000	orphaned
8821	3NKfZaseBWVbCe7ePCkequNcHFbD1zqgrHKH9HeSW7xy9iRQfoUC	8819	3NLqsG6RsMnkiggR6ctbM2bshM3g5v2KRBjnuQwcRpzdYtA4wiMZ	1616	2	105	1	6301	jwNc3zVqubbC1ZZw9SnHc1FrJxST345pRuVLAgKav8iAxW7UAKa	4573	6438	6438	1617098040000	canonical
8822	3NLHgSSufe1ZartPSMNJ7xfocLJypsvMSPfXy2iyr6YsDMj7SuDJ	8821	3NKfZaseBWVbCe7ePCkequNcHFbD1zqgrHKH9HeSW7xy9iRQfoUC	1406	1393	105	1	6301	jwenCM9ZxG1GRk5yGw5wu78Yh76AUjFCV7eAAdv7NcTVFtKd3JV	4574	6440	6440	1617098400000	canonical
8828	3NLZAteZSHU2MrbMRGpWpsk9Gx7XSCRujMGCdZpUpQadR4Je4SmD	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1648	1038	105	1	6301	jxgZx8zQHHkScF38pZe65b1cXASCNRGTkv14FrW66rHf4gjchBk	4577	6445	6445	1617099300000	orphaned
8833	3NLN5k6n6H4A5nso68CDDe7pVKj1K4bdaggKabQS1AbgagVALbmc	8832	3NLD7pbfhJdVuy6aDtK7AVZEPB7dwzVFCyqqQN5x5kSDYTKYTQdY	1489	1134	105	1	6301	jwyXwP1VLD92StZFjg1on8R1zoRomTRWh4wzpn5Pbmji8f8tAcM	4580	6449	6449	1617100020000	canonical
8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	8833	3NLN5k6n6H4A5nso68CDDe7pVKj1K4bdaggKabQS1AbgagVALbmc	1407	1395	105	1	6301	jxyqZKCVo2RgbGnwzjHb72tPkyuJun5PjLMb4rxyqgxatS5EYjk	4581	6450	6450	1617100200000	canonical
8837	3NLC9YVeMVHHsbR2NGW5aTZ11R7jGUSgdJNDADsAgRWMmEJHFbtf	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	641	1090	105	1	6301	jxsJWZ7b9UpcLVKhWHWG8vhrvL5DabknqGQoRYresLQWXDj4WfW	4582	6452	6452	1617100560000	orphaned
8841	3NKGCotvWDVrtKmCVk7FCemMmc9KFDdWHLSZLj4NCRuQR9ttJyZk	8840	3NKfBaTtuvrrboWQuUdbnWAkjqPr5oNuVB4uNsTnHigg6FYDErkZ	1419	814	106	1	6301	jxPxY2mJzbwcaLieNdr3kAayHBXspSm5CCZAC47Dfbb2Zs1r9Kr	4583	6455	6455	1617101100000	orphaned
8846	3NLHHhzVhhStsS1gtXKbyys1hHd8wGca5GLqBBnopWkbJaM2kC6t	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	643	643	106	1	6301	jwRWBtomjtarJNytz4wKwWnF2MtFbSitQhpLroKxbDxAfq5EJas	4584	6456	6456	1617101280000	canonical
8844	3NLwAbwZEDySfMidik7qN7fJasr9vPs8CwEfC8uzqpQ4Ma3TrMf1	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	1602	1369	106	1	6301	jweqmbinT6P6sVpHUobEbPwTecDrWsgssQXoYDfchaTrPvhgmjj	4584	6456	6456	1617101280000	orphaned
8845	3NLowiSoVDtf3cXf9HAwfwiteKLP4xWuM1h4hXSQKa3yKqMui9Ay	8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	1602	1369	106	1	6301	jx9byeNPy7UREZsgVkyqCG1baAg3EvnZUpmVFwcaTBjMqNZiki4	4584	6456	6456	1617101280000	orphaned
8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	8848	3NLQ6Hkk1RTVzU5m6WVTpTvUTF5JzXBapYkcByUNDH1hXMnDhxDQ	1501	1114	106	1	6301	jx8n92bT5atgtgrvdsw8AWCC9xBsqGy4t6ubNyHo7QbB1xBanox	4586	6458	6458	1617101640000	canonical
8851	3NKDxryr7AXG85HuXnYUoi5PCGnw3u7bxrVwLdb161F7gTkMkiU8	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1523	1321	106	1	6301	jwtEMpF9pHZKm5ssjCNUSPfqJnqU1VNADYdZ5FttNUgWcGBrNj1	4587	6459	6459	1617101820000	orphaned
8855	3NLogt8tx7Njk7eaECnKDNfa7zLp273YK2vyhuAPf7KE56MaQqNG	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1523	1321	106	1	6301	jxXu44ShtvTQZEXoQ2qtzKT55cLWGZWU1zsJPe3H4t2droPoW7c	4587	6459	6459	1617101820000	orphaned
8852	3NKepoFo85QWgAoGptNgcAno12haehowcc5DR2cUrrcXW2E7pRse	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1523	1321	106	1	6301	jwenG6CRGtE9L49RLk85v8XS1Svp8HizAe1yr9JeKsMMYZ8HsK2	4587	6459	6459	1617101820000	orphaned
8858	3NLeHVHRXs4ASVh4SgE6aKeX3FBUVMc6tSrYtJ6Vn464xr4HEpDH	8857	3NKU3DMXojtMadWYH2btHYZpiSnZH2wGNUzD2KJG2FjvEpFkizNn	1506	1127	106	1	6301	jxZaB3Dj1pNsPtXEaUa7tbnxisHDKqLztVuXseDJ4dy5nJeXhfN	4590	6462	6462	1617102360000	canonical
8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	8859	3NKvDCR2Ee9hydssxVJPDLhXgeavHgzoAjzfCtL8Uc6qqGVDHpVH	606	1049	106	1	6301	jxhhj2dKDq4XbvG8fMUxZwgorLteehQuubZ67C1jc7aPRmfaSLv	4592	6464	6464	1617102720000	canonical
13903	3NKh2R5yY74pVxzCvdRuhmRU9T7wp18qWfsKVvR8DYzEiiZbD7VL	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1651	935	212	6301	10083	jxvM1KUNZwVzTnyngUqhQgmV1JpLP57hmxS3bgeEfR8CdFdpsqo	7130	10098	10098	1617756840000	orphaned
8809	3NLDRsFYiafu2mQPjJUWyVPxJzqsTo4P8P6wUixnwjpYEgi98WUG	8806	3NLq7niaRnzdtJzrciTsgHuWWefNrg3RuPJR9b1pcnGJrJaurUh6	235	235	105	1	6301	jwkLPE9eZB5mKNAhwUJwMoJ7XbD7szY2ZyHi7gRVryM5XXabfki	4567	6432	6432	1617096960000	orphaned
8811	3NKfQrwWxny6xnTdceG1gqQ8GYgFEhd3pAbmWZXCdXz9kumhiDvY	8808	3NLPqLytp9DZfkeTrvUNedkQRzGQDuRuY2VoQqo6xqHGxKS9QS4f	1490	1274	105	1	6301	jxQ7tvEZY1RbsS6q8tWcqZeVTC7vjyN1Yr9fntWd8TzxvkhWvmQ	4568	6433	6433	1617097140000	canonical
8813	3NKakBmHufULt5BmD42mesjBbdYieovzLS9e8oz31cEdgKJSpQrt	8811	3NKfQrwWxny6xnTdceG1gqQ8GYgFEhd3pAbmWZXCdXz9kumhiDvY	1405	865	105	1	6301	jwNrjo8w9DHphCYuXaVpcX7riJkPZhVgFjZTs8Jcsux3dArm4BH	4569	6434	6434	1617097320000	canonical
8818	3NLyQfcJTHDauabC5JZX1oB9xLJjzJMp65FsJG38KChQFmLmjf6H	8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	1608	1163	105	1	6301	jwSUpdnER7BrzhNseCXqT4qcArZfhn9fmvcM3Ke8vFNZCAeCRvZ	4572	6437	6437	1617097860000	orphaned
8823	3NLbRKqwAUAar83RXAjcW56ANbefypYW66vnQaCufzH6mKm9fkep	8822	3NLHgSSufe1ZartPSMNJ7xfocLJypsvMSPfXy2iyr6YsDMj7SuDJ	1656	977	105	1	6301	jwRPBHDzpbxLi2J6gaKT48CLDhsFVWa6Pyk2fKqGEzEbaV6RJjV	4575	6441	6441	1617098580000	canonical
8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	8823	3NLbRKqwAUAar83RXAjcW56ANbefypYW66vnQaCufzH6mKm9fkep	641	1336	105	1	6301	jx3U1DNtQtKCBJCFAcia6LYphjannVEML1JWqPBGucv93wj19KX	4576	6442	6442	1617098760000	canonical
8829	3NKUB54hJZg5QDrKzYAVeHMBnVLjw5de6T7wzFpGPGjJHdXJnc4b	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1405	873	105	1	6301	jxidkX3yXMxuiF2C3QJeprV75DRwRiwdKRiRMqximMyzkezofey	4577	6445	6445	1617099300000	canonical
8826	3NKhQgBRysGUaD25KnbYnmaubiCErXJLToYLPEb4NBH7RDiVS2zM	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1447	1099	105	1	6301	jwC6xLytXW59rxa37wxJMCp2ADBanXwAGHGSXmvgWD8hSthFdiq	4577	6445	6445	1617099300000	orphaned
8834	3NLf6VqiG46f8f38a7fL3uwMHyS1Zfck1uvAX7q96g4sqMu7KufW	8832	3NLD7pbfhJdVuy6aDtK7AVZEPB7dwzVFCyqqQN5x5kSDYTKYTQdY	1673	1122	105	1	6301	jxYLwG2f8Dvn8PFR9puVGTqkKVjQJ6cA5hG9thK8AgifK32fK2y	4580	6449	6449	1617100020000	orphaned
8836	3NLn8nBo17AqiEztjH4EsjDpVHJzvct3QvxJe3tArVkcyDoxwYbG	8833	3NLN5k6n6H4A5nso68CDDe7pVKj1K4bdaggKabQS1AbgagVALbmc	1423	234	105	1	6301	jxjHyBLo8kwwi5zt2iTBfXEm9LeESeEndFixaBQvFMc4gJPCNub	4581	6450	6450	1617100200000	orphaned
8839	3NKVrLUii3UFcLkBe1nZzZoN6bohjJbkoujTUz7XGnruY7sED5sC	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	641	1090	105	1	6301	jwtr8BDpSYddb74LAttSTAUHsdhJMoweyYwRC5AVKXHWUpDN3Mx	4582	6452	6452	1617100560000	canonical
8842	3NKfmALRs3hmKMuq61MhGvoUe3AgwPUDD6ATZ3eetkvrTKuth11p	8839	3NKVrLUii3UFcLkBe1nZzZoN6bohjJbkoujTUz7XGnruY7sED5sC	1560	202	106	1	6301	jxUAMvLPoTbuhFT4KfEATyQFMrGQ3LJUJcutNXkKTgLzEPgKVqf	4583	6455	6455	1617101100000	canonical
8853	3NLRZmrHFqB29ZsEu2L6jRmbVDCMVnH6PnTQd4AcZYBRcUjYsPF8	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1406	1393	106	1	6301	jxhVxuQgYKrNrNAooQjiNbg8KRFoRuU1rAxqAxowEay2n8VhyVf	4587	6459	6459	1617101820000	canonical
8856	3NLWswRAkdYmmYudoHcP8NnYEXeyeK1xBTDgRD3CUnM2hJAuhPfM	8853	3NLRZmrHFqB29ZsEu2L6jRmbVDCMVnH6PnTQd4AcZYBRcUjYsPF8	1594	1200	106	1	6301	jxf39pMpFTXP8HgGdgJVjbL3ry8QJHuyJzAGGv7wM2jJq3QFjAv	4588	6460	6460	1617102000000	canonical
8859	3NKvDCR2Ee9hydssxVJPDLhXgeavHgzoAjzfCtL8Uc6qqGVDHpVH	8858	3NLeHVHRXs4ASVh4SgE6aKeX3FBUVMc6tSrYtJ6Vn464xr4HEpDH	1406	1393	106	1	6301	jwkcKpLtPVQVVWBnJDbwgTYrCKf69AQCqb6PU6yRCCzp9fQbvmL	4591	6463	6463	1617102540000	canonical
8864	3NKmoazEPZMq4PshKwymmw2mjCCbhQpwp5cgXBhGtDJ47EHqKGT9	8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	1402	850	106	1	6301	jxUP3SxvpUuhiFXdzW96bDeW5aBxpjBR9FYbWjB2KvqYCo8DweN	4593	6465	6465	1617102900000	orphaned
8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	8863	3NKBpVNwqP99RkMdkWmz3SXN5MxDTaz7KxrhoGrWgLNR8vNaf4th	1483	660	106	1	6301	jxL5ectUz3FANqWpVrqWL3dk3NQXXuMo84uCgCCzhhLB48DRg5Q	4594	6466	6466	1617103080000	canonical
8868	3NKuLgdwU3f4JmQFwtX5YvXqnhXhuXS9LYyfeihgSwKsq2TnCRNY	8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	1405	849	106	1	6301	jxsHEsgMsQaEaKoPfgDfXeWnuLfjaYc2tn9bvd9fTMPXEDr7DSX	4595	6467	6467	1617103260000	orphaned
8923	3NKbWwN4mzn9F15DnhF7LeDHV3JwbFLx8UXoCzmcRjbsoVmV7Bmk	8876	3NKmD3KDk1Gd3kLfheMpqzT5PbmdiznVQAupc7EpDsYeDhvh7spo	1623	839	106	1	6301	jxUi8ka9uYrwCEPMfJtoxt169gs3pzxUCNJKG1UYXGUrtqN5GP9	4596	6511	6511	1617111180000	orphaned
8870	3NKZVCWzJYEonb75CB724ZxLYSqKRzamcQmA2c4xNVEEZLv3ptyX	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1654	1094	106	1	6301	jwwnPSfepnnQc2vXmBZg9nUMe3kdkhMtHUN8o4fdg9JH3ZP3ndH	4597	6470	6470	1617103800000	orphaned
8875	3NLNr7YCPyx7cZsUu8jGZWN7Hhy3HgT7nmRrUo5tKmkd6SDjonpZ	8872	3NKwNqMQMdM9uWhUw8FNeWbRGtPVd8MBgvAahNwyW8RjxWhRL62L	1619	909	106	1	6301	jwtBvsFT3qqUCPwjXcgp7hXW4QvxwXFmDrHWnqYQA2FhBPcJzdP	4598	6471	6471	1617103980000	orphaned
8877	3NLQ4FXaDLUTj7Qaxtanznn1RHPdSJLweuLVnubmetr59CLjiEYL	8874	3NLQHNmkB285R51rvL72Fe7SwXm51nnMc6KgG97Wvkv5PvEsZChe	152	1084	106	1	6301	jy1N9jHGx7tYyHGHfKsigp4MpzSbmyYNHZSuz6C1Y3dNYgH7ATP	4599	6474	6474	1617104520000	canonical
8882	3NK4kCuEQ5muQRENjWjfoSiEYvrQnHbK2eGCCrBtgY3EcHMW9MYb	8880	3NL9fZ58peZFbmPg4ratUYCNwoVGKM6m4yjH9Jbb2sUzdkw1Wh8q	1460	616	106	1	6301	jwxCyEMLCQNo9vztYX5r3ezGedGYVYcb3jAB2bFUs84b8hs9zs7	4601	6478	6478	1617105240000	canonical
8885	3NLNQwPb2ZHhCNp88AxNVDb36U1wunyb3vuYPbWZJDy2tgRqiPeQ	8884	3NKK64XiQ49VkKPFoWqzaahQFCFT5xxD4XYygFa6PYqWfnDEUgRU	1406	1393	106	1	6301	jxFBaAVmbnVFoaobCHyPnX4u5ZL53sjr9qtJamwuCnXd2xW6X3c	4604	6482	6482	1617105960000	canonical
8886	3NK7Ywm9VsUXSc4zCy12YuxJStj3k98qtxrTwLnH1MuSxAaN3S45	8885	3NLNQwPb2ZHhCNp88AxNVDb36U1wunyb3vuYPbWZJDy2tgRqiPeQ	1407	1395	106	1	6301	jxBY5UxWXviG39rsntYAZKufD1SKzHpY27JXpPdeEvVi9tKDsPf	4605	6486	6486	1617106680000	canonical
8900	3NKimzuG5uzko7WuTwkbr2J3DCSxovZ2PLf9iaKXUjUrzu1ToxZg	8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	1523	1075	107	1	6301	jwRgtt7oUCjqG4P5qjy2bLXBm9HdhD5BGzvSdCuKjJdWZ4BV3s8	4611	6493	6493	1617107940000	orphaned
8907	3NKDG7Va3HGwn2J3MYMCSUttmZRphhAMZUBE49TjMCPS4LJcPxRw	8906	3NK7pGuKToBXXQPxzodecKFFqQxFoJ5hT3HnDZAMoEi8ik78237V	1406	1393	107	1	6301	jwfs5LynD7Qn7hgFGVeH4M4UeC9QVZJde8wTK5R4LKZcaQrUk2C	4614	6497	6497	1617108660000	canonical
8910	3NKEPHK1tLuArybC5kddGgaXPUzDAZM6ox2S689hvsrjuFTsWqvz	8909	3NLdPfKzT4fSjMijmrZf6dEuF23JQwbHzgsXogZrwaZEoCNfnF8m	1406	1393	107	1	6301	jwLSUYKTmBa3BeFY7yqKYR4a8fhLqUAipDPtpx3epQDg9qKgJWE	4616	6501	6501	1617109380000	canonical
8915	3NLa8S3fmaQ1Gbqi1PsQm76j8jFG4q84VAxcEdcw4sn6WF3m6SA1	8913	3NL6rG6oeFMDG5zPPTGj1H4p77LJuJ55TWuSTAwNjdHMy6PqwZma	1405	867	107	1	6301	jwdf3wHhqTHKWgdXvBtzWW7ZAgwzfko8BqR2Y46Z3owW8WpDrXK	4619	6504	6504	1617109920000	orphaned
14071	3NKqVBdm9j8NpfrRC7vUPHnbrSMtWGdErGVYaXdgQGG9xX6yFTAV	14000	3NKX5s792zci5Zroq4e98hWjzgNLiY6JDsVvuedsACv3wCzz8dYV	58	1035	212	6301	10217	jwf5qCFzV7SNvnQo6rHUxfEu6xGnT2Robus4FV9dfwwcUjmaDVK	7130	10197	10197	1617774660000	orphaned
8819	3NLqsG6RsMnkiggR6ctbM2bshM3g5v2KRBjnuQwcRpzdYtA4wiMZ	8817	3NLAYrQHfHFVaNYzqLZDmjp3BLpRgF4q3rc2zGE69iumLbVj44K1	1406	1393	105	1	6301	jxBmr7ttkL6qdeFzRpPE85YUky1GASF9eNkYN6KShtH27bHRpVa	4572	6437	6437	1617097860000	canonical
8824	3NLbHBEwCALb6Sx75jsh4KcTbX6MYeBfXsnQJVNFphV92hH95LP5	8822	3NLHgSSufe1ZartPSMNJ7xfocLJypsvMSPfXy2iyr6YsDMj7SuDJ	1602	1369	105	1	6301	jx8o8egt5xyysFpWqej9cYDQxfaUZr1WdNuS97PUkRGo3A99wXY	4575	6441	6441	1617098580000	orphaned
8827	3NKD97hStEo7637Vyc6SQv4s7qmvePMhrdfEap6ZPjre8p8psiuU	8825	3NKzPDhsTcHmQ89Q1DEzSob4WEoFTMGWcxsCmrRAkhshut2Yzhin	1474	1083	105	1	6301	jwhQifujY2KdUsmREdrJVNz9N3p6nQAAaUzb1byJPjeVZUsd3mB	4577	6445	6445	1617099300000	orphaned
8831	3NKCXFDY4UhL78xPmSgkfkGQJHv7Zs8sr8nog3XRmWzYGsZSVr9L	8829	3NKUB54hJZg5QDrKzYAVeHMBnVLjw5de6T7wzFpGPGjJHdXJnc4b	632	1256	105	1	6301	jx5HbiviBL2CJ8NGau9wypwukr2gyruUWBK6TZsynVJeofCeBPD	4578	6446	6446	1617099480000	canonical
8832	3NLD7pbfhJdVuy6aDtK7AVZEPB7dwzVFCyqqQN5x5kSDYTKYTQdY	8831	3NKCXFDY4UhL78xPmSgkfkGQJHv7Zs8sr8nog3XRmWzYGsZSVr9L	1611	1341	105	1	6301	jxVQGU8rz8HMMdNTdwBbtugq8nUGrmpSURNjSnU9aDNdKfYFBXv	4579	6448	6448	1617099840000	canonical
8840	3NKfBaTtuvrrboWQuUdbnWAkjqPr5oNuVB4uNsTnHigg6FYDErkZ	8835	3NKY5NtgmFoNLk519mJbfa2YfBRacSCWgAPjxf5osLRcV9oZLqt5	1631	794	106	1	6301	jwbcyPZ5vMCWWDiQNfQv2N28ryzrNcfFT9fNVRKVCfWYN4vJ7zP	4582	6452	6452	1617100560000	orphaned
8843	3NKfC39jLr7WfMSuUzz2tcifFUqYgPBFsus5r1Gvay3xxyPGmdg6	8839	3NKVrLUii3UFcLkBe1nZzZoN6bohjJbkoujTUz7XGnruY7sED5sC	1633	1144	106	1	6301	jwueruUNd8RXw2Q3kf4qVawyLJE19Jv6h6vA53LAwx763CvVYJX	4583	6455	6455	1617101100000	orphaned
8848	3NLQ6Hkk1RTVzU5m6WVTpTvUTF5JzXBapYkcByUNDH1hXMnDhxDQ	8846	3NLHHhzVhhStsS1gtXKbyys1hHd8wGca5GLqBBnopWkbJaM2kC6t	1607	577	106	1	6301	jxdDxA2bY5XLrBfS7pRAuJnXCEpc3WJy4jp8i6k8iCJCFqmCBen	4585	6457	6457	1617101460000	canonical
8854	3NKnfdXHDcYY8fDx5kSRPeQBzHs8UzHSRZKmRfNix14ajdYq15hk	8849	3NKR9cbjBbcg2qCE9mwaznxdkPtLiiVHWCWPor1ro5EizUVUZTy9	1407	1395	106	1	6301	jwH4gd3ZPrFuYXRQQwpC7qqHFuNz8o31yyRhAK7Mf9k5YKeSAiz	4587	6459	6459	1617101820000	orphaned
8857	3NKU3DMXojtMadWYH2btHYZpiSnZH2wGNUzD2KJG2FjvEpFkizNn	8856	3NLWswRAkdYmmYudoHcP8NnYEXeyeK1xBTDgRD3CUnM2hJAuhPfM	1581	778	106	1	6301	jxmxPiF2UxeQLUEP9u33mWjsXXG6mqRmeSvQuzUkE784r9gNL3F	4589	6461	6461	1617102180000	canonical
8862	3NLUyaKPNt5ENfjW6qiV4cFDNHSBwwjUSc1J8MvRJv3uzFEyLor9	8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	1403	824	106	1	6301	jxdxGbSU9WU9rCgw2wab8G1ppDdMjew69xEeBKRmZsAnYQBJ8sR	4593	6465	6465	1617102900000	orphaned
8866	3NKb1jzWDKur2SNwncCH8nAH37VHGg4tBrMVM39KVV5Q7Vjm2r5a	8863	3NKBpVNwqP99RkMdkWmz3SXN5MxDTaz7KxrhoGrWgLNR8vNaf4th	1627	1385	106	1	6301	jwzo385xHGCAbrvKw9FDUxGL3qQ6z4qFhL7E9yfCnGoNWnDKUbG	4594	6466	6466	1617103080000	orphaned
8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	8867	3NLngB4k8LpDqJ3xn3xePWvHYp52L1Hy6oevFoGK6KTngjacYyz6	1407	1395	106	1	6301	jxPLmeK76cUfZA86vnceBVf4e6a7DorRCZoZx6fsnUSydz2LE3j	4596	6469	6469	1617103620000	canonical
8871	3NK81tU6YwSoxXaKPBZnEePXbH6ac2R7zE7NrSsk35FEdemRMvzB	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1534	1071	106	1	6301	jxvB6gpq2dkkKPPDKuiYmzjBqytAyz1gcw3yoZ2DPvvgbykTRSf	4597	6470	6470	1617103800000	orphaned
8878	3NLYnBGxMsUEvzvb3REsBf4jWmwuZdvbNoDMkrTcQXjRDqGiPwux	8874	3NLQHNmkB285R51rvL72Fe7SwXm51nnMc6KgG97Wvkv5PvEsZChe	1529	1316	106	1	6301	jxoYyoprV3F6uUjdRD9fMKfsGSCaLGrnBnQGoue53kcit2DQ5Px	4599	6474	6474	1617104520000	orphaned
8880	3NL9fZ58peZFbmPg4ratUYCNwoVGKM6m4yjH9Jbb2sUzdkw1Wh8q	8877	3NLQ4FXaDLUTj7Qaxtanznn1RHPdSJLweuLVnubmetr59CLjiEYL	1601	1262	106	1	6301	jxegeWjZciW8ZkXLWVbDSzXkr61F1zfJNA2F8Hb37BNBANY1W9Z	4600	6476	6476	1617104880000	canonical
8881	3NLCogj6L9EdCSQQz4SAnPvixxavwhRUJnxTPJjP52rLfijy4py6	8877	3NLQ4FXaDLUTj7Qaxtanznn1RHPdSJLweuLVnubmetr59CLjiEYL	243	243	106	1	6301	jxcgQcL4684Uq6fzKq8H5kQsXWiV1BT6NP2SmYuRqWUtUujzmyM	4600	6476	6476	1617104880000	orphaned
8883	3NKWApscVy96omguUENX8Bk7LdTEMJSb1dFkNbx3KRmE5ik2DvLd	8882	3NK4kCuEQ5muQRENjWjfoSiEYvrQnHbK2eGCCrBtgY3EcHMW9MYb	1610	1314	106	1	6301	jwhu6eFGSv3WxBjVsvWAxBW68wBeDQhABkzH1QbVwL2bUj9Ehtd	4602	6480	6480	1617105600000	canonical
8887	3NLwcsvShfiEKNEECngsYuVk9jm7fGKbXzLeUckfBJ47ivZ5FGRY	8886	3NK7Ywm9VsUXSc4zCy12YuxJStj3k98qtxrTwLnH1MuSxAaN3S45	1406	1393	106	1	6301	jx8DXoz98rPRGea8PtyKBiGw2XYrxqe1Armpk23RznjfSbkZBKV	4606	6487	6487	1617106860000	orphaned
8889	3NKivWqE5eE2CzvFgeKem9pkB2rykp7HyvHvbwCqGsMQmA3qipsB	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	1599	1161	106	1	6301	jwnHfo2MgqMw4aTG3FbNp7Mj8wB2BYExNnneU6eKfG3nLUB9K86	4607	6488	6488	1617107040000	orphaned
8896	3NKxDfYYJBAHzDexNc3JY4jMHVXz1k76VHyvupAspzxTbRyLv1je	8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	448	1179	107	1	6301	jxeD935YnKXEQfFK8CmUctBWCT1SvEu16ejdRLTxKSD8CtsmkTB	4610	6492	6492	1617107760000	orphaned
8901	3NL1PvRdCEUdpmfKvK8SZzUdibKKL4PrVAvy2h1Apwot2S29sC9R	8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	1403	824	107	1	6301	jxsW3gg4EK2ZfNxW5sSEQPomDRsewmBVT5NDDcgrNGxK7e9YdSQ	4611	6493	6493	1617107940000	canonical
8904	3NKCFnpohdC5iS353GiC8Wk9W2SeboHgC3zLF76fuVE7dQ64YV1N	8898	3NLruKxd2ed7UpoquTQW9b51V4MXyitYP5Rnw8Uti8Fj2JtwMZmw	1405	867	107	1	6301	jxTL1eLuEQEWJYHHNXJb1LRWwADEnYBfKGmPgJ9WbR6DAC31GA1	4611	6493	6493	1617107940000	orphaned
8913	3NL6rG6oeFMDG5zPPTGj1H4p77LJuJ55TWuSTAwNjdHMy6PqwZma	8911	3NKgYk59NL5t9JGriXEWU6QvMXg6U8c2sUZfcsUYrTPv9Aon3eNt	1536	1187	107	1	6301	jxsS4gFqgaJh6dg5MseN1JDC7kyskR7qr7Ds4dYeeDjJ5NgPmMz	4618	6503	6503	1617109740000	canonical
8918	3NKHxv7B25mCq7RazxyqDferyMvNunD2zqK8Dk1gha4dAFH1oH7p	8916	3NK3HhsW1CLkRayN2KaUxzd6MtvcgHnoS2jyyjo7YUsVQMSbzXvo	1642	1367	107	1	6301	jwXiiDbktvtxi2ppymkKsfFNR4obw8rCoXGCVBJ2NxBhQFBCRWe	4621	6507	6507	1617110460000	canonical
8920	3NKAsU6cGoQtVW9WV7Q128ik9N1BQvXPKq9qFpervd7p2F423CJe	8918	3NKHxv7B25mCq7RazxyqDferyMvNunD2zqK8Dk1gha4dAFH1oH7p	684	1352	107	1	6301	jxewLKuQ2oXSuDhNiVNACU6QBbRjV3rpHU2Lyzj8UrqjufZM6Ev	4622	6508	6508	1617110640000	canonical
8930	3NKPen8PWGwboGohB6hx18P3KMDaRbf69M2ThWs7uj4tCxLmPRPN	8929	3NKBc2E6fdGfUP5z3ZRTBQta8kUWeQWSpwcpwFYyXK4rDKYFDy9Z	1668	1124	107	1	6301	jxXHfRPtkHx56SFqpjHhYopzZb6iJ8vf8EFenU4BPZMZ5dYBT9L	4629	6516	6516	1617112080000	canonical
8934	3NLPDRpvayPb5FEJLvn9HtyNPDNXtC4169d3V58uFGWJYyHCZEVP	8932	3NLKqsJT8KWqWsTmmRVGSjJHv5PwVhFhjVRKbDbV5xvZW842sGLF	1541	1172	107	1	6301	jw9dm58rgttat8GMU1A6j7oH5r9G4Zcm7ct5x56uj6oTCAk2z8h	4632	6521	6521	1617112980000	canonical
8941	3NKRf18AsrgqVxo1mGDv9N1bExhifG7Uka36xdFUVmkGfRz9gPFY	8940	3NKhdjkkmTBwVeD68RtWkHrqcLSUtRdYSdY2rxpnFDwnhaLAbGvH	1559	987	108	1	6301	jx7KbRWdCsxamM9S59cDT1xd9ck1HYaGwiPKfFLTQNriFnr8ksi	4637	6527	6527	1617114060000	canonical
13909	3NK7J5o6RUSxgyGFZmJVwZhYVZL2FqXEYT4cLmP3VUUgANckojQm	13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	1444	1135	212	6301	10088	jy32YVJepgZksDet5LBNx8nV7VjzvKLgvjxx3N3rSLQkRGd7PoB	7133	10102	10102	1617757560000	orphaned
8863	3NKBpVNwqP99RkMdkWmz3SXN5MxDTaz7KxrhoGrWgLNR8vNaf4th	8861	3NKGCrzLnLixYCgY5keAzYW9ssaQVzPwDn9T8RZCRKF913EfEzVz	1406	1393	106	1	6301	jwqLTLkoEDiEXWJqNQDL5ANZfWsqPcx4wEQYzhLQveBBtJCYU5u	4593	6465	6465	1617102900000	canonical
8867	3NLngB4k8LpDqJ3xn3xePWvHYp52L1Hy6oevFoGK6KTngjacYyz6	8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	1474	1083	106	1	6301	jwBeEjP1WRXUzXW5PtqQyiraKbBt8WGHkMhSAt8rk9Go88ZWXJH	4595	6467	6467	1617103260000	canonical
8876	3NKmD3KDk1Gd3kLfheMpqzT5PbmdiznVQAupc7EpDsYeDhvh7spo	8865	3NKu4jk4AaCF1V9JJDGjMsPpAHYpUX37YosHSg6pLBrGjtMjrKrL	1623	830	106	1	6301	jxbpcUHmhbDDyvoDpdmftAf7Y9AKRMqwzPTRX2uZTRmbs5wN7Dh	4595	6472	6472	1617104160000	orphaned
8873	3NLQ57ZskB3SwW1yW8qbkanoujiMsrfW6kLczQ7LqFT8wBZWyuqm	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1651	1301	106	1	6301	jx2nVCEZMCCWeYENHE1busFKCEJjB5GqbdwK76SKbBKQhpJ11sk	4597	6470	6470	1617103800000	canonical
8872	3NKwNqMQMdM9uWhUw8FNeWbRGtPVd8MBgvAahNwyW8RjxWhRL62L	8869	3NLCBU1h5yguw6HV7VrCoqSM5JMhdsQU3etuuVU7s1fJBBWgcZn6	1651	1301	106	1	6301	jxPBrfqah2zXio73apiwnCNnQf4nst5M5KmtUPKzgMoxptvrpnu	4597	6470	6470	1617103800000	orphaned
8874	3NLQHNmkB285R51rvL72Fe7SwXm51nnMc6KgG97Wvkv5PvEsZChe	8873	3NLQ57ZskB3SwW1yW8qbkanoujiMsrfW6kLczQ7LqFT8wBZWyuqm	1619	909	106	1	6301	jxWYuouKYupSJeRXoZ4fyu3Y4Z9qkqQWrqCG59DL8bE8YaYJpEq	4598	6471	6471	1617103980000	canonical
8884	3NKK64XiQ49VkKPFoWqzaahQFCFT5xxD4XYygFa6PYqWfnDEUgRU	8883	3NKWApscVy96omguUENX8Bk7LdTEMJSb1dFkNbx3KRmE5ik2DvLd	484	1319	106	1	6301	jy19MiNBzwEWZ9J9xawEnb5FCDyf76xSirM52nBrwv36oX39Avi	4603	6481	6481	1617105780000	canonical
8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	8886	3NK7Ywm9VsUXSc4zCy12YuxJStj3k98qtxrTwLnH1MuSxAaN3S45	1637	815	106	1	6301	jxmf9m1Vvod59kxpVtDfBFHq4Qd8uoGzKoZjBL499gmDRx4fEBY	4606	6487	6487	1617106860000	canonical
8890	3NKKsTDv56kRbaPJi2g9xGB3mCxi2GR7sx9y9cr1sswbs4dcTqKY	8888	3NKh7yJtusUh3fzVgaxx3dFwbkU4gJd534KLeJ9Pop1grGxRvxgn	563	1359	106	1	6301	jwXq7JTsE9NbTEfoRZk7oQMAH9XBayzvStRz2JJeaT2Rv4iABQ4	4607	6488	6488	1617107040000	orphaned
8894	3NLR9RavenkiVqHiL2dBwJPKoQ19jv5HYZGU7JLt92P7gzkAVjxm	8893	3NKQXSu1TRUocWuSoFS8zqf1RZ1xnquPYaMQjNcb28FYvzsNF9wE	1673	1368	106	1	6301	jwP9FtjhryvhVU21M51SjXCjMwBR7g7GDbJtw9kKNbuAF1f6X3p	4608	6489	6489	1617107220000	canonical
8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	8894	3NLR9RavenkiVqHiL2dBwJPKoQ19jv5HYZGU7JLt92P7gzkAVjxm	1631	794	107	1	6301	jxu1nB1EDAKgwN9zVxfJA4wDtBcD2KZWi6GfzZxY577haL4buGM	4609	6490	6490	1617107400000	canonical
8897	3NK45fEMgv5diUhc3KjsYZR9KQ5iCdTGu4U676ZaBVijcMXZJwaS	8894	3NLR9RavenkiVqHiL2dBwJPKoQ19jv5HYZGU7JLt92P7gzkAVjxm	448	1179	107	1	6301	jxbsEq2dFcg3xnVKoS6DfkrGPZvmWGbNC8cYqksMWUZSNm1xCpc	4609	6492	6492	1617107760000	orphaned
8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	171	1128	107	1	6301	jx2zWg36VrE1dyDQP6UMrNnumhwXxjgkH9NjZqhMvmVoCWXmX6k	4610	6492	6492	1617107760000	canonical
8898	3NLruKxd2ed7UpoquTQW9b51V4MXyitYP5Rnw8Uti8Fj2JtwMZmw	8895	3NKWgjnJukg2GaVRy66QUzm1kpKCH9fvBzcNkF56BEa6HHRjmfk7	448	1179	107	1	6301	jwLwSEYVbN7t16T6r9MqxhkgB4ZXN9JMsg3LzYDA2KD4C5ZAhQj	4610	6492	6492	1617107760000	orphaned
8903	3NL2YLXoRx4CUqwrYLHriZ6cRSw3f8MiAdjJCd991eNTV8SEgYoE	8897	3NK45fEMgv5diUhc3KjsYZR9KQ5iCdTGu4U676ZaBVijcMXZJwaS	1523	1075	107	1	6301	jxkyE5nWb9k3rTp3YfFoDLgjeqWsCVKvE5UG6d4P1s3wXBZYAXQ	4610	6493	6493	1617107940000	orphaned
8902	3NKJmrjKztQCmSEUSgmAWAAbxgUwC723p6sEaZh35gsVbZifHpRc	8899	3NKGmYoUDyTAjJAX46YTE51dWA4DD6KEzuXX8i5uhLpY4d1GEMW9	1523	1075	107	1	6301	jwAerTT5ivvgc8JnqXJxskPyTXM1JFRAzM1zvdqMq6g3VZQQ4Ms	4611	6493	6493	1617107940000	orphaned
8905	3NLUL8Tx8SkATp2VjgkpPnvB9ubxBrKSdBAvqgDbVusAd3b3D6fp	8901	3NL1PvRdCEUdpmfKvK8SZzUdibKKL4PrVAvy2h1Apwot2S29sC9R	1406	1393	107	1	6301	jxgNdv1zJupB9qXdS8HsPkjerZ7L5dJpWnDbeAnCZ3zz4mBh9Hq	4612	6494	6494	1617108120000	canonical
8906	3NK7pGuKToBXXQPxzodecKFFqQxFoJ5hT3HnDZAMoEi8ik78237V	8905	3NLUL8Tx8SkATp2VjgkpPnvB9ubxBrKSdBAvqgDbVusAd3b3D6fp	1455	1332	107	1	6301	jwkExVVipygFvst3ejhBLSm3eBrjXYS1vyQGDthMdCyJtuk6vZZ	4613	6495	6495	1617108300000	canonical
8909	3NLdPfKzT4fSjMijmrZf6dEuF23JQwbHzgsXogZrwaZEoCNfnF8m	8907	3NKDG7Va3HGwn2J3MYMCSUttmZRphhAMZUBE49TjMCPS4LJcPxRw	532	937	107	1	6301	jwgQpEEDeKHAJXuMS1Dx8h5LiFgAVux7a4vFBvfsmFKDeGd2HMV	4615	6498	6498	1617108840000	canonical
8908	3NLiiKb8HPixWmx6PKuvD8CMJmUYJBf1GwoLtS1N1ac9HogWkNNK	8907	3NKDG7Va3HGwn2J3MYMCSUttmZRphhAMZUBE49TjMCPS4LJcPxRw	1407	1395	107	1	6301	jwvG947aUUyu37g8nWtfVvQ4icWc8tgoLGGj4V4ruofEapviBqb	4615	6498	6498	1617108840000	orphaned
8911	3NKgYk59NL5t9JGriXEWU6QvMXg6U8c2sUZfcsUYrTPv9Aon3eNt	8910	3NKEPHK1tLuArybC5kddGgaXPUzDAZM6ox2S689hvsrjuFTsWqvz	1403	786	107	1	6301	jxeveDP2z8wKRW51icVNSgXen6V19AL6DySabpMiGQ9rxagr6YM	4617	6502	6502	1617109560000	canonical
8912	3NKmnxKiszuPBrBf2VA3VtVLxqy2KLaGrHDgjBaeYzZcLgJwbBq5	8910	3NKEPHK1tLuArybC5kddGgaXPUzDAZM6ox2S689hvsrjuFTsWqvz	42	1235	107	1	6301	jxkcPqpNSCr965ckZf2Z8ujmkBS8YCy2uvRTSYXoUeX13JB1U3z	4617	6502	6502	1617109560000	orphaned
8914	3NLD1FEqUqpqoQ3QXymTSjptpVt5rJjMVXKRNjmZuedRAhbgSQGk	8913	3NL6rG6oeFMDG5zPPTGj1H4p77LJuJ55TWuSTAwNjdHMy6PqwZma	1642	1367	107	1	6301	jxPvMzyS4AGMPsTaBUBMQnGAAw9W2ofke32UFVNHRxewk6AXESa	4619	6504	6504	1617109920000	canonical
8916	3NK3HhsW1CLkRayN2KaUxzd6MtvcgHnoS2jyyjo7YUsVQMSbzXvo	8914	3NLD1FEqUqpqoQ3QXymTSjptpVt5rJjMVXKRNjmZuedRAhbgSQGk	1509	1320	107	1	6301	jwH2RcJ6Ns8Jo9JHnLCnpD3tXVQkcYp8xdcRMjwMX5a2PbZmMPt	4620	6506	6506	1617110280000	canonical
8917	3NK7DyHrdooFbe6KPeWdoLEi2kmw4C7nNKLfqVtTNYLtD4pTmdPa	8914	3NLD1FEqUqpqoQ3QXymTSjptpVt5rJjMVXKRNjmZuedRAhbgSQGk	1619	1149	107	1	6301	jxkvirj3gHJMYKZuBFfdQ1gbgdg8WLYEh1UGKbTEz4U4Qhaztdz	4620	6506	6506	1617110280000	orphaned
8921	3NKU3N5bvAzfp2Z2YtwMRxpwWUSGzTS8XFhDAYF8ENKBgjoB2Tbf	8920	3NKAsU6cGoQtVW9WV7Q128ik9N1BQvXPKq9qFpervd7p2F423CJe	1406	1393	107	1	6301	jwDqodr4tdCKei5Dhq9EuKPfdtWKuGCrsdq1vCCW7trFnPTbzCG	4623	6510	6510	1617111000000	canonical
8926	3NKTQrGcptGgqwCYXxaoeUV8q4BKccnoRv5hnbJH8yjaFSFdZYkr	8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	1406	1393	107	1	6301	jwrmHsdwxVujCS2HT4n7SbrGGYztuxFrPdamj4qaAs5vSg4r6k9	4627	6514	6514	1617111720000	orphaned
8931	3NKfgSktufykC5FKbcqTmZhCLEu4DLPWq6TSdyeEBU6kMfGDXrra	8930	3NKPen8PWGwboGohB6hx18P3KMDaRbf69M2ThWs7uj4tCxLmPRPN	1406	1393	107	1	6301	jwB4gsApPx4fWYgkX4Hk3h2MQ2NabQFicuGW24MuRzEgeUgkV5q	4630	6518	6518	1617112440000	canonical
8936	3NLYVJ78MnwjeptHJtRQFcH7HrP8JdLnJEFaPoM7WZsNbzVfsmtu	8934	3NLPDRpvayPb5FEJLvn9HtyNPDNXtC4169d3V58uFGWJYyHCZEVP	1672	1159	107	1	6301	jwxLES9hbd1VpFwEGHxT5kNdaBaNXSjRjVCW9XEcKUvn5LJQ1x3	4633	6522	6522	1617113160000	canonical
14388	3NLHsP6PQaKtLpDbx4pK3UxJftPou7jzXmKa6zk5nUVbRSNviDMv	14103	3NLWLMyvB9ago5pi5BFLHaCMM2rPvj9W8YtGpUdUymhEiV1FCzEF	1650	1375	212	6301	10496	jwbf5mtHmWM5nAik7nD2zCzSTN7wTKu2Jjc8RL7XFWhQAvAWyLM	7133	10388	10388	1617809040000	orphaned
8945	3NKKTMLvDwY3iZQc6AKW4MvCAsQHMQTQvM6oAgCkSxjGh2ERcffc	8923	3NKbWwN4mzn9F15DnhF7LeDHV3JwbFLx8UXoCzmcRjbsoVmV7Bmk	1623	830	106	1	6301	jxevLF9tWDk3zAPcwsdcRFPEPxiQJi8LJvRaQXZTLJT4jYryUtu	4597	6529	6529	1617114420000	orphaned
8955	3NLP4mKSBojXaRdM1i5rSdXaHx7E6gbyeJ28bD2Evkf4eeQ3GNbT	8945	3NKKTMLvDwY3iZQc6AKW4MvCAsQHMQTQvM6oAgCkSxjGh2ERcffc	1623	829	106	1	6301	jx4Y98WsUQQvBE9b6NrDy7WaDbTBAnxr26vFAd8yvLpcYwZb2SH	4598	6536	6536	1617115680000	orphaned
8919	3NLS8M49zoqALNeBjRHGawfZzeMsJVQBP4FPE7rf5iSySMzUngCT	8916	3NK3HhsW1CLkRayN2KaUxzd6MtvcgHnoS2jyyjo7YUsVQMSbzXvo	1616	2	107	1	6301	jwaEZVnkqgQVGVZKB9XTAs5xdtWkRcjfGh1T3daYtn9XhaM1XtT	4621	6507	6507	1617110460000	orphaned
8922	3NKD57zzqx8ifHwHbJjxzNks1nLvox2xvJsnhz373ioEXmdXmmBL	8921	3NKU3N5bvAzfp2Z2YtwMRxpwWUSGzTS8XFhDAYF8ENKBgjoB2Tbf	1516	1048	107	1	6301	jxKfJNyvxRJJkcKuxwZZHwcpmpwsjnDXL4dzvULCBfdNckVGt5m	4624	6511	6511	1617111180000	canonical
8924	3NL1s68Qqha5DPf5oR8JCETUcc4p5SMFPikRoAJhgP7mf2kEt2tb	8922	3NKD57zzqx8ifHwHbJjxzNks1nLvox2xvJsnhz373ioEXmdXmmBL	1656	1097	107	1	6301	jw7QS3HpbFft3xgTQcwwiWpgnwcPDJeJvjZXBSZcu4uQouhutjE	4625	6512	6512	1617111360000	canonical
8927	3NKXQKrp6fj8F8V4JyWhVe9pe5DdcyuhDqHc7KBLVthVzFKNNjqF	8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	1634	965	107	1	6301	jy1fvHRvt5xYGVGf6HsJCiX6xGrYYbb3rRGZsu1yL3SHTzcpj2B	4627	6514	6514	1617111720000	canonical
8928	3NLCxPuWfQsLFda7J2Ne4SXtTs5FvaStDGVCzc7cm1d62ub716UU	8925	3NLBuCHqc5tvNrDzNz5Z5wpodZvy99gAA5ms9Fk4azdh5fZ7DHoi	1643	1299	107	1	6301	jweq1sFMKUtPWrqFSUSbZZbJ95e8n3EKbPmv4P4U6KTBEsyvdir	4627	6514	6514	1617111720000	orphaned
8929	3NKBc2E6fdGfUP5z3ZRTBQta8kUWeQWSpwcpwFYyXK4rDKYFDy9Z	8927	3NKXQKrp6fj8F8V4JyWhVe9pe5DdcyuhDqHc7KBLVthVzFKNNjqF	1419	814	107	1	6301	jwbSwPh9EvZsWkivsQFPDNzxczVMESyoKPh3PkLZPAyxnocqNbj	4628	6515	6515	1617111900000	canonical
8933	3NKVJNfo5SByUSBtRoGwkL2Q3Riuw76aZSrC6XEgYwzt13S8XPVD	8932	3NLKqsJT8KWqWsTmmRVGSjJHv5PwVhFhjVRKbDbV5xvZW842sGLF	1602	1003	107	1	6301	jxuycDXZ9HXzHAmewSp8SLaWgzXHyBSxbodtjuK1yStSF9RjBUe	4632	6521	6521	1617112980000	orphaned
8935	3NKh68dzi8x4ekAaMeRxhU2vfQ4mfp2jehA2BuRJJCjBErdMY8vu	8934	3NLPDRpvayPb5FEJLvn9HtyNPDNXtC4169d3V58uFGWJYyHCZEVP	1407	1395	107	1	6301	jwviU35S3i3RZqSQ1BHsQVwwf4y2vf9rsSxPJmNR2RpQzxtFrc5	4633	6522	6522	1617113160000	orphaned
8937	3NLF6DNPfAj35eAvC2UEGZsVsuWJsTPRgXD7r8SKsoBAHfF6g33V	8936	3NLYVJ78MnwjeptHJtRQFcH7HrP8JdLnJEFaPoM7WZsNbzVfsmtu	1648	918	107	1	6301	jxNfmBwZUv8TkqpG44ahgQ86ZrAJS1EkUqch1QfyfUYD4qh1JU1	4634	6523	6523	1617113340000	canonical
8938	3NKJBRDCp6HLw4c41ba1fiitqxqrCPkXVBmHS5gRmjkT7mFSpuEh	8937	3NLF6DNPfAj35eAvC2UEGZsVsuWJsTPRgXD7r8SKsoBAHfF6g33V	1549	1116	107	1	6301	jxeAfQGzv8zygJbBP57pYtbXxkZ84MWj8keZyiRGGW22xDokKND	4635	6525	6525	1617113700000	canonical
8940	3NKhdjkkmTBwVeD68RtWkHrqcLSUtRdYSdY2rxpnFDwnhaLAbGvH	8938	3NKJBRDCp6HLw4c41ba1fiitqxqrCPkXVBmHS5gRmjkT7mFSpuEh	43	43	107	1	6301	jx37ags31UMf9aUn2yLnQr8K4QrCVkCqKApWmCNvmfKL3cuxhvB	4636	6526	6526	1617113880000	canonical
8942	3NLRPkDcbFUcYdU9QtMDfgRK7inaXUSjViZLjvavZ65JoTAemriS	8941	3NKRf18AsrgqVxo1mGDv9N1bExhifG7Uka36xdFUVmkGfRz9gPFY	80	1147	108	1	6301	jxQZzAnzMJDoZqnb5gfXtQy81kMTSxAYL9jZ3gFBRf23DLm5wge	4638	6528	6528	1617114240000	canonical
8943	3NLyFpbYwfoRGuEMsELaMrwAwNjPeMzsKo8iyFTcgYmN5pkEsC77	8941	3NKRf18AsrgqVxo1mGDv9N1bExhifG7Uka36xdFUVmkGfRz9gPFY	1509	1320	108	1	6301	jwB8YM1qdXeWAzdqhb4CPLvxvri6rtGy2Pb3bwMaQmYfNKbvAoG	4638	6528	6528	1617114240000	orphaned
8947	3NL6PYs8mr6TdQcwaK2zQFKyBqQGuSEVH4Qayy2AmDJ4Ms7sa5uN	8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	1406	1393	108	1	6301	jxDBuvNWC4ZzhpM4B6T6UM2rnDqcy2ACtwU4NbBMazb3w7Zx5fm	4640	6531	6531	1617114780000	canonical
8950	3NKf6qzwGVuW7sYLhQzMzcxrbBeasQQBAipwShnRwWwQHYTMbXjS	8947	3NL6PYs8mr6TdQcwaK2zQFKyBqQGuSEVH4Qayy2AmDJ4Ms7sa5uN	1599	1161	108	1	6301	jwJbaAzdkQwjqFrCYPSbMABRS16rf8jp3ZJr8jX5urncCGPu4hv	4641	6532	6532	1617114960000	canonical
8952	3NK78LQ1WzEGb8LmFFHZxhvCFgTqvKK3seSkyteZGTfeKsygdWnZ	8951	3NLxnrpXdUbiGQZJD57jqV44YgnUjEzMWyLP8UiotjtH2YqzURMJ	1406	1393	108	1	6301	jxf9PmaNRakY55wixdWzsnCSbscNwVxqTD9TJEs2nzxB6ynNQYg	4643	6534	6534	1617115320000	canonical
8953	3NKMKCm94qynEx3C92HTMR4UTbm1mXBAjd6c82wftgxLM2dvg2Ab	8952	3NK78LQ1WzEGb8LmFFHZxhvCFgTqvKK3seSkyteZGTfeKsygdWnZ	1608	1163	108	1	6301	jwqt151wuHZhbLYv9bhoTAMwPWxYdpoZ3dJ1Q2toiYTKcLGm64z	4644	6536	6536	1617115680000	orphaned
8957	3NL3VjSSjmKicxCE9wbgJvUMFAspZWK4kLc5QsDZHsjTw6Pof2NT	8954	3NLGsRkEprkhexkTtbU8YJ5FcYKayFNQ8ms7j69aUUvX5XuWzLVD	1500	1051	108	1	6301	jxR4SCLnT6A8fVkwtvtGXo5Cr7QXDnWAAec398iey4Cy2UMUXL8	4645	6538	6538	1617116040000	canonical
8960	3NKoCXnrQ17ChBqNkj8rUMzXKDJaBTXQzdRAjdMmhzFMMrAJqKB5	8957	3NL3VjSSjmKicxCE9wbgJvUMFAspZWK4kLc5QsDZHsjTw6Pof2NT	1648	1284	108	1	6301	jxBievWAn7xmcPYMyhgXoGq1he86jtaVfF3PN4ZKercLFDbnNRM	4646	6540	6540	1617116400000	canonical
8962	3NKanyvpY4jEoGvwcNxc1m5CoTpcZ6VDwAn5Ad2eRByAYHky5DY9	8960	3NKoCXnrQ17ChBqNkj8rUMzXKDJaBTXQzdRAjdMmhzFMMrAJqKB5	1402	874	108	1	6301	jy2tH8WXbb1KUQ1MMcYq6RwNif9vufFyzLXTpJ3uSmpYQkGi7J3	4647	6541	6541	1617116580000	canonical
8965	3NLBozNfL4kCMA2GKspWvBek548CwA86EeHNmcddUzdA1oGnBdRV	8964	3NLwCEKa3ZULLUuVAcijcsFe9ok5b5vh3AAq9p8XoH4qmsj2SGPy	1407	1395	108	1	6301	jwphH1TUPJ2zWQgiG2qxhbvyXbYWU79AvbrZ2PP5gfxaE8vbkht	4650	6545	6545	1617117300000	canonical
8968	3NKGHW5Eky38Pjbu1h9uZNkwwvr9c8EysGMKDqSyAPkm2UR9PZR5	8965	3NLBozNfL4kCMA2GKspWvBek548CwA86EeHNmcddUzdA1oGnBdRV	1596	1237	108	1	6301	jwGSYPWuX2nK6LU9z8DQbURom6HTeHDcr7hyZHXdeB8P2EHFXg2	4651	6547	6547	1617117660000	orphaned
8974	3NKCmhFkzQtxHt8UPXEn2jbXmz6N8N4m53YuJsvMCh6cNGrKmrW9	8972	3NLqgSAeC3HrxttWLmQ2R1BAxeu67E9oPsr8T9CehKLKQbw1y2U9	1673	1368	108	1	6301	jx3jFpdppSgwKKjceUE8bFPjF2D27KJdBmkmMrt6TC8AX33fWBA	4655	6554	6554	1617118920000	orphaned
8976	3NLnyLqnH8B3oiydi6VCY2oBgXCCs6k4edYwGf9VoHBBJ5ZQyUZm	8973	3NLZqsmi5A2kfTdcd5kdr53f5De8V2hQbtWuyuSVUEbjnMZDrCvQ	1527	1293	108	1	6301	jxYsx8h8LMXQknzrEq8VKXWuap7DPjjuCNNqAmHygRFX79GnMn7	4656	6555	6555	1617119100000	canonical
8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	8976	3NLnyLqnH8B3oiydi6VCY2oBgXCCs6k4edYwGf9VoHBBJ5ZQyUZm	64	64	108	1	6301	jwtSyR11oLVNdqHHtgtN7zcEh1otfvKdrBKfgXF2JJSCywjKPbW	4657	6556	6556	1617119280000	canonical
8981	3NLCWDixL2zgPhR2mCtDz4DEEi4VtuJu8yJFQ6FQvWM3umqN4qmh	8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	1631	794	108	1	6301	jwknpx6QG7L7LDAum6nNAgQvev831Dh6cEU9iBMxemuAMSbGLC6	4658	6557	6557	1617119460000	orphaned
8983	3NLmQRCb1SVc21rQ9ftPiven4GtgMyWkLguRjbUaxgoqzLrVpD5J	8980	3NK7sD4HR6RebGFRd15ky9sa2NNYQ29DW9krVGpitCx8e3ezCZk2	298	1308	108	1	6301	jwcjCBN1V8x8CxHbqVB1bajSa2h1MoKSUNQX53jqDLQQmhgEomV	4659	6558	6558	1617119640000	orphaned
14410	3NKgREYgoBpgyV3wRjyNMosCebZS3wCtYxWK8hK1HpY3GgCmxgsB	14388	3NLHsP6PQaKtLpDbx4pK3UxJftPou7jzXmKa6zk5nUVbRSNviDMv	1650	1249	212	6301	10518	jwhC485HBfGapU7BgBBfX5PAAsBwiNUjj9hWo6aoHn5geEMMJGZ	7134	10398	10398	1617810840000	orphaned
9008	3NKG9iwc7B6VzgDjmsHdEtooZAQTX9f3soYumitERjBkAg6U81Mo	8949	3NLgHZBoxMn9YtPu2Xpb6hVS2VfrvHVnCnHuRruutNi1oyZPRwCj	1553	776	100	1	6301	jxp4ezGfgBZaZy9Uj2ahpXKGsoAhe3kthZidHqJnBmGC4C1BuJh	4427	6575	6575	1617122700000	orphaned
8939	3NKVtq4EjQecqEZNKfuD83B9ANLNM4nJomfZLVxUgdTHtLE4HBB7	8937	3NLF6DNPfAj35eAvC2UEGZsVsuWJsTPRgXD7r8SKsoBAHfF6g33V	149	1283	107	1	6301	jwv4u4iZ4PYuxN6TZbLgS3ADwBMYzPrPgaP2MsWaxPXxWPRLo4x	4635	6525	6525	1617113700000	orphaned
8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	8942	3NLRPkDcbFUcYdU9QtMDfgRK7inaXUSjViZLjvavZ65JoTAemriS	532	1057	108	1	6301	jwyC2XtcpBUeDi8Cd4JzUt72rDu8CLTet2SoUs9vnGikzx6nFJj	4639	6529	6529	1617114420000	canonical
8959	3NLS5zq5CEJSENHi1EnApJBCg9GYArcZN5mMfvyMGvdnTUomB46b	8957	3NL3VjSSjmKicxCE9wbgJvUMFAspZWK4kLc5QsDZHsjTw6Pof2NT	1407	1395	108	1	6301	jx4hLfqhu4RFkouNcYcgg76pFkEjotvumPB57mK5rpSgwN5YSSV	4646	6540	6540	1617116400000	orphaned
8964	3NLwCEKa3ZULLUuVAcijcsFe9ok5b5vh3AAq9p8XoH4qmsj2SGPy	8963	3NKREMpCxKCJd2DL1XtnfMxsg6Bzrwo4WeEaAjwQUCXt4bPqBp7E	1406	1393	108	1	6301	jy3Aumdm6uP4HRV2T6sNT7UrSDTbpVNZpKVmFwVkNKBZmeTq6Gf	4649	6544	6544	1617117120000	canonical
8967	3NKwKSzgKPNFBd8A1RE6q4wwrQzHNE6rQ4bsZq3BPL2GVr6JRVWT	8965	3NLBozNfL4kCMA2GKspWvBek548CwA86EeHNmcddUzdA1oGnBdRV	1649	1383	108	1	6301	jwHAMXvKSYQTWsGRbJ9JbgcrgfbASy1xrmmpw4LocprJaVaC3JZ	4651	6547	6547	1617117660000	canonical
8984	3NLesnc8oGHi7YXGrZVJ5HELqHX42ynUj1MD3fU55vyw736aHQSZ	8982	3NKVnaNTeZ4nheySMdvCt2Pc3jk3eyPndpjysBGaXJeLWED7ABzQ	1406	1393	108	1	6301	jxEdnDWJYocVT1kdcLnJKsGbix5XeUbzkBQthEDJPHFQvnNPEep	4660	6559	6559	1617119820000	orphaned
8990	3NLGL4a3sN1tnFXV1GUxCSwpGNHuH7WXhvxam9y8uoLHWPoiuavh	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1647	1302	108	1	6301	jx2o3zVAJx3roCT1CGnt1dzEGhGqeVatp91Wmhi4gPb2rdnozaG	4661	6561	6561	1617120180000	canonical
8993	3NLX628b5csgNVqnGQvrY9YsNwRvC129RQWVX3YQfwN61o4pYUMK	8992	3NLCEv7V6s6rgzwuqDYrdR7nWj1PXVc8sVMbLV6H9jBrcdMxsErM	1407	1395	109	1	6301	jxvipsKQ2XmfufXXuhXigNEma3aVHxgWqqrr75QHSKyNhXsQ3j8	4663	6563	6563	1617120540000	canonical
8995	3NKs8gUCr27iZ2z78g7bpGuCuYSg6d4Bg9ssNUympg9baTwQQAJj	8993	3NLX628b5csgNVqnGQvrY9YsNwRvC129RQWVX3YQfwN61o4pYUMK	1460	629	109	1	6301	jwipPcUpBK7YpwWERV5hBEMq9FV3HdnXj7qB785tFeWQG6Rxs5e	4664	6565	6565	1617120900000	canonical
8996	3NKzZdkWsGbmDfdTg3TU1JwmmimDwtJg14aJ4FR54WyDM2UhkhZD	8993	3NLX628b5csgNVqnGQvrY9YsNwRvC129RQWVX3YQfwN61o4pYUMK	1599	1041	109	1	6301	jwaXeJirbZxRe56SC2mhqNF3kg7d5ZdKo96DH3KsELECGbnuNWD	4664	6565	6565	1617120900000	orphaned
8998	3NKbpL6tpRST7L8sm72kBLc7AAFoNd6vtuAd3axYmqCs8HCZYJM8	8995	3NKs8gUCr27iZ2z78g7bpGuCuYSg6d4Bg9ssNUympg9baTwQQAJj	1406	1393	109	1	6301	jwZYEaKxGLQYRQDbboUyHHYxSkGpbXE8EDuDrPFvzKiR8csV9oF	4665	6568	6568	1617121440000	orphaned
9001	3NKHTw76NifWpA6Nq3GErpvwYfYWgASgeG1wfURPheHSboybfLt5	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1455	1086	109	1	6301	jxmHKNnuZERjMKrMyJiHjVUfYGfyd4ui6v2nCHxpRCjNKzixS9x	4667	6571	6571	1617121980000	orphaned
9005	3NKwFUX6XVvf9jM8N7JwmqHSkr1SSY72ujQjNSL9AKf2pNSBuQ7h	9002	3NKpaozDMsbEDQPKpGq4SvWbm5RmzsTnJe4V5Hw1c9z5TkMDennx	1407	1395	109	1	6301	jxPASnV4BrTHMaAoQS9FhCrQQwJTowaGEy2UivKB9AmH1Rtr8Hb	4668	6572	6572	1617122160000	orphaned
9010	3NKuFmokKaMWNdKdER2WLYHhpEpkKAocAqRd2Lyx58LuPphZVGNR	9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	1642	1121	109	1	6301	jxADyJ1waVYDmpa78PMqHrgenwvr5deAzvoh15U9cmZ1DKDdJKN	4670	6575	6575	1617122700000	canonical
9012	3NLFxvE9nm4BhTgzou3prLEGLSthd3HiSrSnbCmpMmifLJr2L3KW	9010	3NKuFmokKaMWNdKdER2WLYHhpEpkKAocAqRd2Lyx58LuPphZVGNR	1608	1289	109	1	6301	jwZoh14Bwv6bN4UkkJ1VENaRcRi6XKfMzhQSNQCPrjrQp5d2h4r	4671	6576	6576	1617122880000	canonical
9015	3NLCRAjwWwjAght6jj8MAdh8LxudDJvF7sjzJSS7JsJpnxJPDMNY	9014	3NLMruXrVjhr71dPT7HPuzjc7AenJCK7dGz1JUrwPv5AXcd7KsTb	1406	1393	109	1	6301	jxKqnetXjyUtsG1b4DURhUohpaT6RxD9PmqHe48oYahwA6bH3DF	4674	6580	6580	1617123600000	orphaned
9017	3NKnCC17nhr7nYv2G1oyw46tovbpGx14HidLDoAE262Q8u4R6yw5	9016	3NLSis826uTJxkWYYFrjpSP58W8bz9UxUiRPhzmo1kmpfris673n	1546	1093	109	1	6301	jxA1bkmXYy249RgYm78Cknmqb9muuBrZBe3YjHNJMUjJeQjQm1H	4675	6582	6582	1617123960000	canonical
9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	9017	3NKnCC17nhr7nYv2G1oyw46tovbpGx14HidLDoAE262Q8u4R6yw5	1532	253	109	1	6301	jxBc84w8XZQ9rTrqVZdsnMkBFJ8GWa6jy2wbh1SX68YK8d8bA2K	4676	6584	6584	1617124320000	canonical
9021	3NL8Zkq1AzMb64V4K2Sp7VCV71HqomkRquQQFNwwbqVbFpHG6KWC	9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	1657	1344	109	1	6301	jxPqCxgQCcynzNbMCQxomGfDLsoQRBR7tHuGKTrECtyHWbYZ82L	4677	6585	6585	1617124500000	orphaned
9022	3NLqd78tGfeVttCLHTEp9ZbdpQW1VC7KkPcVnZdi1UZdxSrRLiLZ	9020	3NLJ3hE2DyrvZUZqyCF4HAWMYwqsD2Jax8wuyFkUEupGozS2Sw44	1407	1395	109	1	6301	jwJH3CTuDysmPiMpugtq46EGnvJZ4CmoMncQtUDeY2KpytvkeGH	4678	6586	6586	1617124680000	canonical
9023	3NKkh8kbcd1VTuQh2GAWguK2Whn6UufJwPdyoUeAFzz6ChoAha7f	9022	3NLqd78tGfeVttCLHTEp9ZbdpQW1VC7KkPcVnZdi1UZdxSrRLiLZ	1460	625	109	1	6301	jwSAAWervJdrZ9Tb6keVVMtQxDhPsRzLxppcdVTTU4rq1U1dk64	4679	6588	6588	1617125040000	canonical
9025	3NKn8KQqgX5A33ZAsoDnaiFkgH9jcvM9rcSWkAUsVoBUdYLbrQZe	9023	3NKkh8kbcd1VTuQh2GAWguK2Whn6UufJwPdyoUeAFzz6ChoAha7f	1403	824	109	1	6301	jwv7e1X5vm6NmhnGH5k9eKgJUsYQrKAvLtWtHTXorizQ3sknhhj	4680	6589	6589	1617125220000	orphaned
9027	3NL1hxaLBE6aUSbJ5WU1mzxQFEfBpujXrZaEnyiJTFtXYRf4rzf1	9026	3NLN1Mb4LyT1sVZmdHWQmDTd8J3eDF9wieGQG6UB9LWJFvTQ9jQP	1579	1023	109	1	6301	jxPa3BEJ94PmkJRkWesFMP7D8smqXGDXKuJTBQxAggzKJnxwa4N	4681	6590	6590	1617125400000	canonical
9030	3NLJSR7fH3zfJTQY6qZ89yzuungkr83ZitoooRYjXwM2bzxH62FS	9027	3NL1hxaLBE6aUSbJ5WU1mzxQFEfBpujXrZaEnyiJTFtXYRf4rzf1	1460	1198	109	1	6301	jxQPneMnZChDebKUM2v9J48UEGp1Wvohk2XAZ28YMDodDhnrRqh	4682	6591	6591	1617125580000	orphaned
9032	3NLq5QJXM5nNpw7JSir8asS944vzGmTkuW6rY2yFfNJtuXHeJeYn	9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	1549	1116	109	1	6301	jxANxwEJptiJ7nsa5a6Jso9Lcp5B5uWvTbztLC63UyP1HqY8BVq	4683	6592	6592	1617125760000	canonical
9034	3NKJRgKJT93QMXR8uoy1ts2PZUYz4xbMdQ6V3nR7QzZEvssCJJUi	9032	3NLq5QJXM5nNpw7JSir8asS944vzGmTkuW6rY2yFfNJtuXHeJeYn	1670	916	109	1	6301	jwhjsCbAd6qVPzRMTCW44Zf9MjPGeegZBLNQpYwcHVXD2wGc6D6	4684	6594	6594	1617126120000	canonical
9039	3NK56uz1eY7S5d8T7qKBxPRXBo4GsAKFiTWnmSMJBUS4DDLamaHN	9037	3NKmkxwogfkV2x5oL4RuR3WFWmvNpKmFghdNSZfRiRHn8pjvCxJH	1673	1122	110	1	6301	jwfihkFcGM8pXMRXbKGKvqyRuhHYqKn1jGqe31oXx4cJvv8nvp6	4687	6597	6597	1617126660000	canonical
9044	3NLTT25hAbPy5Q9VvpeZ3yXMQNq95sZrm8gPCa7doxNL4sxzQx9G	9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	1406	1393	110	1	6301	jx4JYTCcKAUCThXZ3tVuKmbPuMxHaSFXZJFs6Nn6445QgW4UqvK	4689	6600	6600	1617127200000	canonical
13916	3NKMrFH95ndQXH7J8trBRXHz3B87zfj7YNDrdssmHwLTgQWBBreU	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	1609	1333	212	6301	10092	jxUtF2rEhNTvGVkNEZXo8asKWoXw9pizg2k6KTUvme1EePXxmyo	7135	10104	10104	1617757920000	orphaned
15570	3NKHmCfvNDKnUGWXSXDX6BbTTmKkazArnr1S3rfTDgcKqwcRNAJV	15569	3NKbPtsqN629iFE8naDisiiKD92BxXUJCZMk2pvJUTtsVPFTEsK6	470	1063	250	6301	11597	jxhoR6K9dCGQu2QX15bJrG1eb8yupVPnpmocsxGKBuh2yBfdbXw	7925	11219	11219	1617958620000	canonical
8946	3NKQhA9DQprni2wVsoRw2s51L7xJBfLpZ5M3YDuHP8YLZNL5Pqgx	8944	3NKL7EULfkhx6qU6qkRDnSUTrANbzX8YRsRGpyxEDYuSLjhuJz8u	1611	1341	108	1	6301	jxTV6PEE6evx4LEab1pjdzSiwRwgGSWkopUrcN3Qep3j2Ti62vE	4640	6530	6530	1617114600000	orphaned
8951	3NLxnrpXdUbiGQZJD57jqV44YgnUjEzMWyLP8UiotjtH2YqzURMJ	8950	3NKf6qzwGVuW7sYLhQzMzcxrbBeasQQBAipwShnRwWwQHYTMbXjS	1406	1393	108	1	6301	jwChdb5XZ55kVDevcgoLkH5xN4q53zAqPovKM3xkbQFJSkT72c2	4642	6533	6533	1617115140000	canonical
8954	3NLGsRkEprkhexkTtbU8YJ5FcYKayFNQ8ms7j69aUUvX5XuWzLVD	8952	3NK78LQ1WzEGb8LmFFHZxhvCFgTqvKK3seSkyteZGTfeKsygdWnZ	1407	1395	108	1	6301	jwW4QfymNvLr7LfHdVbNDcYPwA6bZEPowTUEo3kF74RAvsoozzW	4644	6536	6536	1617115680000	canonical
8956	3NKynACmrWcqy4pYmYP3awekwefKb6kJBokBeUjbXVHF8YbU3PHD	8954	3NLGsRkEprkhexkTtbU8YJ5FcYKayFNQ8ms7j69aUUvX5XuWzLVD	1407	1395	108	1	6301	jwmK8Weym5RETbr821t1fULW5mcgVyMAapLj4cU8iqxxHJPSUHC	4645	6538	6538	1617116040000	orphaned
8961	3NKcZS3MjRhHp1YvLN4RcJA8cS4U9vxr19JQPiyHVhVCtU36UHKn	8960	3NKoCXnrQ17ChBqNkj8rUMzXKDJaBTXQzdRAjdMmhzFMMrAJqKB5	1407	1395	108	1	6301	jxHyAmFcr8d2hCvJKXwEmhZ5QAAU2ePsbym9ycwVPFg4NgKfv1K	4647	6541	6541	1617116580000	orphaned
8963	3NKREMpCxKCJd2DL1XtnfMxsg6Bzrwo4WeEaAjwQUCXt4bPqBp7E	8962	3NKanyvpY4jEoGvwcNxc1m5CoTpcZ6VDwAn5Ad2eRByAYHky5DY9	1407	1395	108	1	6301	jwoaJFL6DxuMovYEeXDHr8UGw1kLueHx63FtTaUGXhnvJQxU5Sw	4648	6542	6542	1617116760000	canonical
8969	3NKXdWgyU9rDWAxxGDz7Ns1ZZQdY3ZXNzvXvpXL2PF5VJJXt7B7B	8967	3NKwKSzgKPNFBd8A1RE6q4wwrQzHNE6rQ4bsZq3BPL2GVr6JRVWT	1406	1393	108	1	6301	jxmRwb5nZxD6irZDwqkpFw4MeD7awtdvp9WddzR3fvHWEWFiMAj	4652	6549	6549	1617118020000	orphaned
8971	3NKDYfcVcoeZJyzCVPKx4jtfSR2eEQcxCrkpbCSaeZEY7FyiWBWg	8970	3NKpjGJ9Bt68n6EmbLTUs3shRSHtfuU7DRHKVntexL4MerR7Tqy3	1439	1033	108	1	6301	jwHc4qCGHCimvfKHnQZeTresfzgo6P3pf3oyEveenbnTyHdUgfu	4653	6550	6550	1617118200000	canonical
8972	3NLqgSAeC3HrxttWLmQ2R1BAxeu67E9oPsr8T9CehKLKQbw1y2U9	8971	3NKDYfcVcoeZJyzCVPKx4jtfSR2eEQcxCrkpbCSaeZEY7FyiWBWg	1403	780	108	1	6301	jwF7xnpp6yiq5fA2YEXV2CKEsGAiD5xcLTPmUhTMLtSnxZqPWP5	4654	6553	6553	1617118740000	canonical
8977	3NLugJPVUv6TbcMM63xMcdqPZGWABrSuAqMnXYF59XWufSremRxY	8973	3NLZqsmi5A2kfTdcd5kdr53f5De8V2hQbtWuyuSVUEbjnMZDrCvQ	1407	1395	108	1	6301	jwGbjk6VLDgiNZ5buoC4Fx4pzCPwZpFpiwKFu76RTnZpBVBPgL7	4656	6555	6555	1617119100000	orphaned
8979	3NLgiL9gWW6oC1Zwxy4btY7NENYCXR4NaB1hJc4cpfyttF2m8k2D	8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	1651	1175	108	1	6301	jwLS28JaCh6vfHk1acv4Pk3BiBTuUdu7HZWL5ULt6MDvmo8Sgrf	4658	6557	6557	1617119460000	orphaned
8986	3NKDMEXqte7R9Aq7MZXCrdiBCq7CRcCiieuLEoSXz2qgmhXYF4Gw	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1503	1277	108	1	6301	jwU2o6wSZVSasqz5d1gM7jX5Y1LyYLVbMraom6fJKANAUaTBpm8	4661	6561	6561	1617120180000	orphaned
9026	3NLN1Mb4LyT1sVZmdHWQmDTd8J3eDF9wieGQG6UB9LWJFvTQ9jQP	9023	3NKkh8kbcd1VTuQh2GAWguK2Whn6UufJwPdyoUeAFzz6ChoAha7f	1407	1395	109	1	6301	jxdKmTa1dMxNcN2qiFyM4yzYx17B6EsZWLf7ctAe94sRafZzkr1	4680	6589	6589	1617125220000	canonical
9028	3NLeFEpkxum2jenVAW4ZNF8nZUv9mg4u7giBFPkxSzNyW6Dxq6Yi	9026	3NLN1Mb4LyT1sVZmdHWQmDTd8J3eDF9wieGQG6UB9LWJFvTQ9jQP	1609	1333	109	1	6301	jxJSgC3bJ2diqVnbbpNU7hAkrwQqPhbkB5Mq7G6Rsap6oFxXV6x	4681	6590	6590	1617125400000	orphaned
9033	3NL1nSNAiqa3f5FutRSGXGRicMCZ9oDWVM46yvMjaWzEzrJgsUMK	9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	171	1374	109	1	6301	jxHJHAoqomovibV3TjHwHNUuncqSUcw2LGYt77wcCPF73me5jeS	4683	6592	6592	1617125760000	orphaned
9035	3NLNoa9T8QDRhX2kswysag9KoCUGVfMD54Zm2NLGWpf69pDD1nwf	9034	3NKJRgKJT93QMXR8uoy1ts2PZUYz4xbMdQ6V3nR7QzZEvssCJJUi	1489	1254	109	1	6301	jwrsiKgAzgzqivNsBsxEJQbcyw2dbUCc1rNACpderZC4vLtFbNg	4685	6595	6595	1617126300000	canonical
9037	3NKmkxwogfkV2x5oL4RuR3WFWmvNpKmFghdNSZfRiRHn8pjvCxJH	9035	3NLNoa9T8QDRhX2kswysag9KoCUGVfMD54Zm2NLGWpf69pDD1nwf	1467	1376	109	1	6301	jwdicamFT1fD5reFd54FzWPuG6tYzC7WFhZgkqL4WJj9J4eSxap	4686	6596	6596	1617126480000	canonical
9042	3NLgHWZZ4T9BkrJqg5zQuNd7pnYdTwfMDZ7XS2UgQxkUfs9vemyb	9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	1542	1178	110	1	6301	jxZwgyD3MgFpNEE5p2Pyvbovo3jbb7fHbPeUmPpLFMfnNLv8RGu	4689	6600	6600	1617127200000	orphaned
9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	9044	3NLTT25hAbPy5Q9VvpeZ3yXMQNq95sZrm8gPCa7doxNL4sxzQx9G	1439	1153	110	1	6301	jx3B7j1sDFy38s4KnZMaJ8uUA1tuwjfNN5qMaTWwEKRizaetR6f	4690	6602	6602	1617127560000	canonical
9048	3NLn9PAb4rwz6Dw2GjhcKDm5emS9NQPVj8ty7qKZWG9PnFGVhEwy	9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	1467	1376	110	1	6301	jw8ZxLarRGNTw8bUpuEyAnysVFqj8iqgq1eUHJ2EHTRX3Ryf9Tq	4691	6607	6607	1617128460000	canonical
9050	3NLVzpuxqdmB6tTnoH7UqMTWno34Mh6eoR7Yt8xr6aN8AUmVbnSg	9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	1555	981	110	1	6301	jwrt9Q3NwVGYVMDZmJ39fNX8AeX5YdGVY1A49XQ2tdc1T1tn1E2	4691	6607	6607	1617128460000	orphaned
9052	3NL3zzNQ8WtAsFgU3MmZbHWjV8RruqAR64yiWxeUn3cnYJHfRT1h	9048	3NLn9PAb4rwz6Dw2GjhcKDm5emS9NQPVj8ty7qKZWG9PnFGVhEwy	1672	1285	110	1	6301	jwTRTSRaTiTW8HEmkGxoCNCMperbPS4FawSNZY2yGnLmBMUAHsw	4692	6608	6608	1617128640000	canonical
9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	9052	3NL3zzNQ8WtAsFgU3MmZbHWjV8RruqAR64yiWxeUn3cnYJHfRT1h	1402	844	110	1	6301	jxnGrYMfoBE4qUejFFphkZeaN8pJBvALpKhDHq6Lu9C2NVk4Ssv	4693	6609	6609	1617128820000	canonical
9058	3NKfAL5qyEdf2gvhascRX5rqSPvcxc53Acj7nLSTWosmrJJz1iVz	9055	3NLW55yLAdaaYUN3kfFayqcZMfKAoHQK2ToZBtc9hVBdGMaEbjPQ	1403	31	110	1	6301	jx8LjvYA57WmffSxJ1JBRH6rLdC3nLT7oxrMxA7qWoUg7PyFZHZ	4695	6612	6612	1617129360000	canonical
9061	3NKk4415Xun5Eh219ueDcc2ipbSajoJAJYkm2AR8LKQcd9iMSgXp	9060	3NK9DgLHha5PgbCdZR95xQ7sKdmxAtAxxx1RV1ZGah6h7fqGk5ky	1671	1119	110	1	6301	jwKY2E4n3FmS2JS5mrHQHwnraGs8wuvMzDbwYS38S1ZJBG88zi7	4697	6615	6615	1617129900000	canonical
9063	3NLQLGpbdKbdU5HsrNKRjf59NXr6TJkPwu2jbJaBrgCTTcu7NbqS	9061	3NKk4415Xun5Eh219ueDcc2ipbSajoJAJYkm2AR8LKQcd9iMSgXp	1403	792	110	1	6301	jxY8xB8bMQy2xaARNpahcQyQzS7QbSnz6cSNzfMSu48FgXg8bdZ	4698	6616	6616	1617130080000	orphaned
9068	3NKB5T56N1kkjECQGYUSY2xBZZ55uo4hM1hgxJ5voRa5pDRAzw98	9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	1460	958	110	1	6301	jxL2EsbYtfAc9GLGbt7AjcyVvegv7F27uQiP4GgHgMSgBXyJqgV	4701	6620	6620	1617130800000	canonical
9072	3NKCDvQSQnLWsoyu9b5yc3oN9B849y4hAqVpAF1iuHhmLbvuay52	9071	3NLhgXZEKBrxwbwNtMKtxudv8cneipQjvgu1BzZk6xTUXfgFQkH5	1406	1393	110	1	6301	jxyQyErVCvZFAkC1ibx67ppLCBWtAFrjjqBtqNWVfDudeMSJa29	4704	6628	6628	1617132240000	canonical
13926	3NK9MxLbfues9apFELYEobF2qzpBzjCe4KfCQNFZnMAVzhkizgSN	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1642	1121	213	6301	10100	jxidoj9xoFrkZQ2vZwS2Ho3jRwHFw5eGdQo42WBEzCLuLhqKQD6	7138	10107	10107	1617758460000	orphaned
9045	3NLKkzSUi7SmunZezrcwHirFu4b9WUPhzUdxiX5qkMfLjTVYtkae	9043	3NLkgMLwwDWfXHZKo71p6TWLzSE1nzEvTkxAXz4mDLrjk8DwdtmL	1553	776	100	1	6301	jxQTY8GYF6rtBwdGqcjRnLH9zDMrUsQGcfK3XReu2HroUYJ3ZJL	4429	6602	6602	1617127560000	orphaned
8975	3NLTV6SryxJZTtj8az98fFv2gEhNaUTfQvSa1hbY9Mx4VPLunhdF	8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	1675	1342	102	1	6301	jxpPCz1rRpzF21aKhkT3UAmFcw9of6USTKxLYMkd3JmLeecuQLJ	4488	6554	6554	1617118920000	orphaned
9007	3NLJbVBZQ52xbMWE7zxMH8jxBzTyz34A4yaf9kFmrsz48NUsGy89	8975	3NLTV6SryxJZTtj8az98fFv2gEhNaUTfQvSa1hbY9Mx4VPLunhdF	1675	976	102	1	6301	jxpPCz1rRpzF21aKhkT3UAmFcw9of6USTKxLYMkd3JmLeecuQLJ	4489	6573	6573	1617122340000	orphaned
8970	3NKpjGJ9Bt68n6EmbLTUs3shRSHtfuU7DRHKVntexL4MerR7Tqy3	8967	3NKwKSzgKPNFBd8A1RE6q4wwrQzHNE6rQ4bsZq3BPL2GVr6JRVWT	1519	860	108	1	6301	jwahR36W2GuohTxV53drAHFdF6iN3WgSEUy8STeJHNgmG3YTdFn	4652	6549	6549	1617118020000	canonical
8973	3NLZqsmi5A2kfTdcd5kdr53f5De8V2hQbtWuyuSVUEbjnMZDrCvQ	8972	3NLqgSAeC3HrxttWLmQ2R1BAxeu67E9oPsr8T9CehKLKQbw1y2U9	1675	1342	108	1	6301	jxx9FbaqTzGx14vDDTUW1mkx6ZhCt62UStC7ugPy797x7VomckA	4655	6554	6554	1617118920000	canonical
8980	3NK7sD4HR6RebGFRd15ky9sa2NNYQ29DW9krVGpitCx8e3ezCZk2	8978	3NKtWVhjRWgLMdxEBw7Zj9gtYzdgJ5gXTCrYbaiY8Y39cnsV3YEf	1651	1175	108	1	6301	jwcZcoNohQvfDnfzdkjHQGKZ2r27hFbvMrG1iAbPtUyDMRcgD6F	4658	6557	6557	1617119460000	canonical
8982	3NKVnaNTeZ4nheySMdvCt2Pc3jk3eyPndpjysBGaXJeLWED7ABzQ	8980	3NK7sD4HR6RebGFRd15ky9sa2NNYQ29DW9krVGpitCx8e3ezCZk2	298	1308	108	1	6301	jxdeeie6ZicVUj4PQft8piQFbyr4kGMvAsxJPTdrZ3NTxA5DG9p	4659	6558	6558	1617119640000	canonical
8987	3NLnCBQUgYGyXfzx8wPtRxJyz1GqUA89XFr44ydrNuK2JuA1Hw7N	8985	3NK7FHoJUjRSXfqrTEz11vKg1nRFrzp1oCdy4yDhF48Cx3oyLUv3	1503	1277	108	1	6301	jxmKsrpnj3cAqvEETgjHdYU94jMiMHVeTGTHqUMzEFhPDFUddEH	4661	6561	6561	1617120180000	orphaned
8994	3NLQMoPHceb6Fahh2Wfn1LVETNv7nGAhfZXBVQrWNioy5ZR1KydN	8992	3NLCEv7V6s6rgzwuqDYrdR7nWj1PXVc8sVMbLV6H9jBrcdMxsErM	1673	1002	109	1	6301	jwcEmk7EN6KDXJaAhDFhVW8Tr7uv33tP29gcPEvPGTr29umQ4Kx	4663	6563	6563	1617120540000	orphaned
8997	3NKeC9N36fW7x8rUur8MAaREgm4Kc673KpRCGkECZ9qHJZjkRCju	8995	3NKs8gUCr27iZ2z78g7bpGuCuYSg6d4Bg9ssNUympg9baTwQQAJj	1407	1395	109	1	6301	jwFhpEXL3WCfahTXQoqDcYz3sxmtpw3eLWCJqJ8Bt8xReCKLBSi	4665	6568	6568	1617121440000	canonical
8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	8997	3NKeC9N36fW7x8rUur8MAaREgm4Kc673KpRCGkECZ9qHJZjkRCju	1483	339	109	1	6301	jxJvJfB4N3AL9Cys2qXPyobq83bkBPaXuYGsBA4vUFKCo3yje9J	4666	6570	6570	1617121800000	canonical
9002	3NKpaozDMsbEDQPKpGq4SvWbm5RmzsTnJe4V5Hw1c9z5TkMDennx	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1476	1245	109	1	6301	jxmdejavJBFoJayMF3gRwrmxv9DWAVSY9jqtqjSrCtHzfqtp5VG	4667	6571	6571	1617121980000	canonical
9000	3NKjJ7upVCfoA2ySPZ2ersHDDEC4dKtPEDqsoRdBr5tSnDZxDcDe	8999	3NKAPj9zPTvy17i7uQ9ePGp9U377A4divJf2Qiu5dr2SQ3nD7Zsv	1589	1286	109	1	6301	jwkGMMSuxianb29YheVy3YSmwWZ7m5CwwgptzHzkvxwS5xYgy5H	4667	6571	6571	1617121980000	orphaned
9004	3NLLDkKKVN9PP3CBUYjpJeFqBMConwmbhNB6ZNbEfsXtMvKnkJ7t	9002	3NKpaozDMsbEDQPKpGq4SvWbm5RmzsTnJe4V5Hw1c9z5TkMDennx	1593	1346	109	1	6301	jxQkjwF2NtUqNn3VLy6ouctQyN1fc1LUVQX8YkQBFTnU5GfFe3k	4668	6572	6572	1617122160000	canonical
9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	9004	3NLLDkKKVN9PP3CBUYjpJeFqBMConwmbhNB6ZNbEfsXtMvKnkJ7t	1675	976	109	1	6301	jwjF8EXWT4emYNfAwk3y9NGLF2ggY1QoBVD4uk2YzdRWSmsRkJw	4669	6573	6573	1617122340000	canonical
9011	3NK72jtuR4fPFgo76RyXHeoSi8648ivygopvFeAp4YiygRSL8et1	9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	1483	49	109	1	6301	jw9wZCjqaKa27ramto2taZbT2NQkHdpDd36ipdeMvXQchSzroNh	4670	6575	6575	1617122700000	orphaned
9009	3NKGLfxvtXdt2coZ9sod6DiP9QW1Pc2ZffrGAW41SubuYpkXHHzV	9006	3NKTwR4myePNmZ8G7B14JbJkzWjYP6RETEh8SxcmXgNc68hyquUs	1403	824	109	1	6301	jxSJDxMGDsKHqXHSZmmEWKshPt4Y2Xf4wvT2P7ydJg5y942YBfq	4670	6575	6575	1617122700000	orphaned
9013	3NKXCpwTWsDAZrodszDjYNeb2bdrd6hh1c6rk1NthtcbpRbxXTuc	9012	3NLFxvE9nm4BhTgzou3prLEGLSthd3HiSrSnbCmpMmifLJr2L3KW	1546	1339	109	1	6301	jwaqp93WE1g1a5aD5Aydt6asrF2hBCYKNvGS4SJpSQyR9EZqBAk	4672	6578	6578	1617123240000	canonical
9014	3NLMruXrVjhr71dPT7HPuzjc7AenJCK7dGz1JUrwPv5AXcd7KsTb	9013	3NKXCpwTWsDAZrodszDjYNeb2bdrd6hh1c6rk1NthtcbpRbxXTuc	411	411	109	1	6301	jwAv1kEabjUPZ2PREeyWjQ9iKbeYkoF72twPcRW9CTMu16yzemZ	4673	6579	6579	1617123420000	canonical
9016	3NLSis826uTJxkWYYFrjpSP58W8bz9UxUiRPhzmo1kmpfris673n	9014	3NLMruXrVjhr71dPT7HPuzjc7AenJCK7dGz1JUrwPv5AXcd7KsTb	1513	1379	109	1	6301	jx7diZtUw123FC3opbYP6baCNZk8kbVtVuixocksoo2MJihhCzV	4674	6580	6580	1617123600000	canonical
9020	3NLJ3hE2DyrvZUZqyCF4HAWMYwqsD2Jax8wuyFkUEupGozS2Sw44	9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	1657	1344	109	1	6301	jxkW26ttuhnvhx6MD4tRg3VmLvzUpn6afsGaEAC986sMsCyC9tQ	4677	6585	6585	1617124500000	canonical
9019	3NKK3CPVdiQ6ZVVZS6XRZMMvYvwugYsPg5hpgQfmLLhVVD18Ytid	9018	3NLvUMssSzYMPCERkF2VioaME9KD1xSpdfbRWWwhvhHzzT8EtmuQ	1579	1263	109	1	6301	jxBNLnzHA98NzfZtp4TLeQn8TZnDJqj5Vt3uBjDzN9Za3nM2Lg5	4677	6585	6585	1617124500000	orphaned
9024	3NKwtWjCuzryTBEhMnws7UpuCGNSEMPg7pwqGD6AkzwtW2TcZdvx	9022	3NLqd78tGfeVttCLHTEp9ZbdpQW1VC7KkPcVnZdi1UZdxSrRLiLZ	1670	1036	109	1	6301	jxBzMMwrKPmDyTYvuKK6nccnJytTKS3AFnEMnyYP48TimALJ9kk	4679	6588	6588	1617125040000	orphaned
9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	9027	3NL1hxaLBE6aUSbJ5WU1mzxQFEfBpujXrZaEnyiJTFtXYRf4rzf1	1589	920	109	1	6301	jxmnpU7zKwEdq7nhWtQaKFRKC81RqCBFdE9wZ1q8cbDzRb6fmVR	4682	6591	6591	1617125580000	canonical
9036	3NKN6ze3Wvapn6E9nrNyhGP1XD1xTgFchVcPN7DGBcgvuazvBTS9	9034	3NKJRgKJT93QMXR8uoy1ts2PZUYz4xbMdQ6V3nR7QzZEvssCJJUi	1407	1395	109	1	6301	jxT4eeuzqtUUwU9qt9GM5wusgusKwu4vzKWBgUfvCbjKirs1iG3	4685	6595	6595	1617126300000	orphaned
9038	3NKVkvr67nNSYJhyn5Bh5pA1bV7CWtAkVEw9Z5vQ93JA6urstZ2b	9035	3NLNoa9T8QDRhX2kswysag9KoCUGVfMD54Zm2NLGWpf69pDD1nwf	1467	1376	109	1	6301	jx9bcKFXD7oTWY4sPGUauWGpP7H9ftKFDYk9odiLxxUXbAEczdK	4686	6596	6596	1617126480000	orphaned
9040	3NL7fNWWLK6vk2hS4mSHy92AcCSsup3xtbJU7jpCuuchjtg9maog	9039	3NK56uz1eY7S5d8T7qKBxPRXBo4GsAKFiTWnmSMJBUS4DDLamaHN	1602	1003	110	1	6301	jxvWaCgu3BHFrvt3i5wGBv4RzEGHXHfjA9R9SF9opegCmUtzEcN	4688	6598	6598	1617126840000	orphaned
9049	3NLoQ7ZhoXMQ9LoVLn7bu88jWztmQzRow176nDxnBqS9wKm2VfmV	9047	3NL9cm1mdTQfxr8LHh8iabdT4FBhmZHBPj8teSaRPSQst8QJedUG	1407	1395	110	1	6301	jxeYuL1TnZH1yasaiDj1tTjG6KnLPQHg3LoxzHWswJoEVcGtr1k	4691	6607	6607	1617128460000	orphaned
9053	3NLNtdCoXiWy4atDL4pxq3DKkZZyuSbQjitLam61PSs34DLsYcSo	9052	3NL3zzNQ8WtAsFgU3MmZbHWjV8RruqAR64yiWxeUn3cnYJHfRT1h	1489	1254	110	1	6301	jww5cSuAkdLc4oJs7dGrrfhr6xGd8a3QuDVg4XducUwMqmjiFnj	4693	6609	6609	1617128820000	orphaned
13936	3NKVtC6e9HDRcC1H8AegeanTcMsyzv5eiHkgg69MmfQewha9EFbh	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1419	814	213	6301	10108	jxu3zU3D6Yqi7XKwD5SZi4Ke2sjp3xNSCwcvmxPnw6byR7szyRb	7142	10113	10113	1617759540000	orphaned
15575	3NKmhfVauXptPQidKSLnMaMmpaMXTtbY8R9BSAFsJFjViNGL5AK7	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1527	1047	250	6301	11600	jxqfMQr8umkbDaoY93FRnsr5b9JMsPN3g5Xm9dMb8FhjhPTs5id	7928	11222	11222	1617959160000	orphaned
9095	3NL5XqVq627ea3miUeYjFWsQChp5rHoUAd6uZ3bbbHp2MzGny9Ap	8730	3NL3Bw33YFcJsT9baz2RuBJ5kMVmJivasuZZitcoMtwvuWHcusui	1654	974	103	1	6301	jy2cmTwd6R7326EemkPFCit2rTfRZNjq2UzZ4ie3RaBwz4yYPpF	4528	6641	6641	1617134686884	orphaned
9031	3NLteqBpuqoy5Nbke7p4UnWPXAx5kQREK16YsPmuZqvSAgJVtcEc	9029	3NKV75RLzWGMEJwcpJ2vVBs9axv4f5JSr3mtjwnezGoK6byifeB8	311	1307	109	1	6301	jxvYkizEbgMeSuZW9gCqftao8mxWVDfrcpHymPFBn4FK1iu8p5L	4683	6592	6592	1617125760000	orphaned
9086	3NKqTM86d8bYZRTnrDgsJ3Pcyr82GLGYDUUoKi9Qp11cbbm9UeCn	9037	3NKmkxwogfkV2x5oL4RuR3WFWmvNpKmFghdNSZfRiRHn8pjvCxJH	1611	1341	109	1	6301	jwAzFtszKCxtQZ424NMyNgqLjzmQmJoj3Cg292PqTe2PNTBh9gp	4687	6637	6637	1617133860000	orphaned
9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	9039	3NK56uz1eY7S5d8T7qKBxPRXBo4GsAKFiTWnmSMJBUS4DDLamaHN	1581	778	110	1	6301	jxPBwwDuXqxa6JUmGz17FohJtaftNmSkHQPxx3MLk6pifbLGdsu	4688	6598	6598	1617126840000	canonical
9051	3NLNcTWUMPrQdXj9iY2RhjgPh19ff9iGgst4CtpTecGLb2Sr9eN2	9048	3NLn9PAb4rwz6Dw2GjhcKDm5emS9NQPVj8ty7qKZWG9PnFGVhEwy	1501	1114	110	1	6301	jwYzDoi8fW32DzWaWJGbG8Zk9QsvZ3ebTEJi4nNpospWhXUEfgk	4692	6608	6608	1617128640000	orphaned
9055	3NLW55yLAdaaYUN3kfFayqcZMfKAoHQK2ToZBtc9hVBdGMaEbjPQ	9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	1474	1203	110	1	6301	jxw8y8EqcAsBhMZBrQbvho1hg5mypyxdTJ1ay4SirDjfRgfvKyB	4694	6611	6611	1617129180000	canonical
9057	3NK3pSFtgEo99Yg8Sgmbs62YzgkPsxbvUqiBsbLXYpxmwXemtqtk	9054	3NKmmHTFVFYBcfJXygGiZy7X5pC5ykodKQMGMGifJaAc1vGAZhDE	1508	1387	110	1	6301	jwRhS7NSQs6ccVrEkmr76YzBn9LR5dhVuLwJCRZ2NXMSjZbAWTp	4694	6611	6611	1617129180000	orphaned
9060	3NK9DgLHha5PgbCdZR95xQ7sKdmxAtAxxx1RV1ZGah6h7fqGk5ky	9058	3NKfAL5qyEdf2gvhascRX5rqSPvcxc53Acj7nLSTWosmrJJz1iVz	606	1295	110	1	6301	jwscmFJW2uBTLKi4RvxPZ4auNpK7UvFEQyBStA28iQ1NLNAZbUc	4696	6613	6613	1617129540000	canonical
9062	3NKMXWUi5u5M1dHXaUyDS7n4TUMXHPyhGpip95AFjWQotys4Gth3	9060	3NK9DgLHha5PgbCdZR95xQ7sKdmxAtAxxx1RV1ZGah6h7fqGk5ky	42	1361	110	1	6301	jw9fh7mfUKGoFqXd7reBeMXveDy5X23iYmHB6UsEMY78iRVcMMu	4697	6615	6615	1617129900000	orphaned
9064	3NLV249DVpsHRD6czU3oobUcb7PuyEN5BXJYXQ4o6Y9oXBQ7Uv53	9061	3NKk4415Xun5Eh219ueDcc2ipbSajoJAJYkm2AR8LKQcd9iMSgXp	393	393	110	1	6301	jxtgvGPoccBNKD5a9Qc16JwhZjm824x4vxCcxXbCMaxfZnJ2EGy	4698	6616	6616	1617130080000	canonical
9065	3NLffMY6UqgYTyaMRTm3DecPM43DDSkP3p4Ba7Qw86EezJVs2eo4	9064	3NLV249DVpsHRD6czU3oobUcb7PuyEN5BXJYXQ4o6Y9oXBQ7Uv53	1609	1087	110	1	6301	jxe7WE34VQU8F2auBAZbvNUPvWn2ZExZu94o79eV3AMomwwRCuk	4699	6617	6617	1617130260000	canonical
9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	9065	3NLffMY6UqgYTyaMRTm3DecPM43DDSkP3p4Ba7Qw86EezJVs2eo4	1457	1265	110	1	6301	jxvxs8hR7uNCzDjRET5qwChi3PBGyw3NdyEpQHaXYBy1SxYCZ6b	4700	6619	6619	1617130620000	canonical
9071	3NLhgXZEKBrxwbwNtMKtxudv8cneipQjvgu1BzZk6xTUXfgFQkH5	9070	3NLj7f98uPN1t6iUKCGCauy8ausvN4sCNgmmr5qGmTYhqgF9jR2h	55	62	110	1	6301	jwERajhW8wJUe19BjPU4CTMzRVAVcqe4ubrLhZX7guhnoss35MS	4703	6626	6626	1617131880000	canonical
9074	3NL7Lk4mopvXeL7MVELVLK82V4VHGUtqPrUvYJSSPzukx8TJXyDz	9073	3NKwrKhKsTa6sC8njehn9ChbZu4gxhE9as7nm6vihzRkDKQeWDu4	1406	1393	110	1	6301	jxzz54deh9T8c5LHVfBU1w5o7DKkMeniwfafR1Smpx1Bdg6zW7f	4706	6630	6630	1617132600000	canonical
9077	3NKRthyczhPRvKyJdJXSBLKURDFPV4tjs1nY4FYoW3ew5mRnYxeS	9075	3NL48BKJUFYnY4doS1kUUFdWmo18VHcxprVhBtxcUMmERDFetQKi	1624	1334	110	1	6301	jxgP528RKHToHCpG6A4PwrncamHpRN7aKGQiYDVCrWvNiFEMD8w	4708	6633	6633	1617133140000	orphaned
9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	9076	3NLkP7Wu2JovZj8MFch9ugfY6hGWwVe5Uy8J8qkeVVi16ay96dac	1654	1340	111	1	6301	jw8f49RCXe15xKoh1YtoYXYQVwQsiADpfBrjrsdFsfw4p7ybUX8	4709	6634	6634	1617133320000	canonical
9082	3NLZhbdbXyWXfSjD8UCPT3eCktQ5UA1ADqXiTm6gGtk13xf4DK5s	9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	1467	1130	111	1	6301	jx3KgZK8Jj3wc8yri5tFiaFjJfp9ywwSJJWN4d4eBAH92793a3x	4710	6635	6635	1617133500000	orphaned
9085	3NLRqcvkbpe9xAwzM4eVBmPB3ezDuTKH77BYdXamvVsYwBkkDjbP	9080	3NKSeUKxxrqV6KpqFZjxqqLtQbrQSATAWaQ7yrez23q8hPCyUFbb	149	1283	111	1	6301	jwaGZzoyt19qkg3nXFtGB6E39pdGMEJWEDcXWYwmoydgYyJVt26	4711	6636	6636	1617133680000	canonical
9091	3NKVkTm3dJ3JGuuRJ7DR1h3KZRRiHquyXvrMa9hPmS6oQ7oqbJ5Z	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1654	974	111	1	6301	jwu63rBuKvthDAxn65pV4g5Sw2xDdieuMG5MvSNhNb7NFjVPuCF	4713	6641	6641	1617134580000	orphaned
9089	3NKaCGFeit4LqXjgapccDRjXwydAma5KMTbskyiSEJ58VMQ8SUrJ	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1536	1313	111	1	6301	jwKKpsaSgxVXXQ28q9FTWujyq4oaE36Bxb1cFFcHTtzsxxxyQpH	4713	6641	6641	1617134580000	orphaned
9097	3NL9iQRSaLGTtEYSkEc2yjjaNMqmbGLqZyouxDEJruTg2YsuqgkV	9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	42	995	111	1	6301	jwzRMbgJcMdEHihziyNYjcnLY9yhQwQ7PwQajgt9EhMSPD9iZja	4714	6642	6642	1617134760000	canonical
9098	3NKQG41w9BthjwjxZTGuVNj8oXRRDpPnoS6eYG6eNs934rpUTcN9	9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	1581	778	111	1	6301	jwZqVfwHaYiqvKJpfhaqNsNoLv5YiRCFi9PcVBAUeo6WVG6GiaJ	4714	6642	6642	1617134760000	orphaned
9102	3NLL8dZ4vS5Q4EnzZaEE9n8baJxmuE65DhUtKLfbbXC7mcRDqwmK	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	1627	1385	111	1	6301	jwv4Fd89rRpr1Qnj7WXVdHiYdAcgANr3C9WRJnvWzrrtD9Zvx9a	4717	6645	6645	1617135300000	canonical
9107	3NKWsvrqoSjEgbKzLM1F5f37b9Ba5rG61vwVuNd1ZCeepHpyYpbD	9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	1407	1395	111	1	6301	jxC4hP3e5fa8ry76NCUBtGwEzNfXCEot13WnkLRsZHDjRoTGCSL	4719	6647	6647	1617135660000	orphaned
9109	3NLUdeQmr668fCkSQsGXaK7GjKK9qmrR4TjhKEHAwwXdicozPwte	9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	484	1193	111	1	6301	jwrR12bbJkC1VdTZ3sskR8bAYmxJy9abeW2199FHz6cxhnseMez	4720	6648	6648	1617135840000	orphaned
9111	3NLE74twfpogDNmvovyGdVmeqJjhYKovbHm6ztgqXWjvuj2qnCF8	9110	3NKqCjQDCHC1caNokBikDbLrFG6iK5NEgbJE9F1PLcoTVFgrsrDG	1637	816	111	1	6301	jwL3CU53UA8TgwjE4bT7TU17mYG6i1nVFncULP8JB6wc5aebv1x	4721	6649	6649	1617136020000	canonical
9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	9112	3NKja5Fd7Xy5t5psSv5B752UeZGNN5uacS9HyKTPiKCAhgQ6rwUz	1426	1364	111	1	6301	jwBPoftj2b1qP5b9U988PX6QRH8cJFp9HyjBcASZs8C2hxWHBo1	4723	6653	6653	1617136740000	canonical
9117	3NL3VMR2uyHFqQFmChNDs3uqa36Z68BtChz55ibj9HsZ63N5FHZe	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1406	1393	111	1	6301	jwPNayVxi8n7kRPrVXWqLf6XG4kBUTEgAZomNnQcCvX9Z59DKtV	4724	6655	6655	1617137100000	orphaned
14430	3NLgLuwXPnFce1tgtGLrqdF6W2AcUEg7SiJJUJ28NrEDVUtaKqZU	14387	3NLhjobMpxPYLNCnv2sv6bN3bBuKBPzVHt76mnNjEMZJFF2RytQy	641	970	214	6301	10538	jxJnWMfpip4uEJD8Wb3wepy6UGPXyDW7dNK68L1nAgehfA6J2bp	7166	10415	10415	1617813900000	orphaned
9088	3NLWJgHtpwrWGq9Hy3HbAR4mZku8RHTraJop5STwqkHvWsMZaC8X	8666	3NKLd3r7dB7uY3L94L9YwxXLYWsu5qk8nXd2KUGVRsD9GGoHd2Wh	1654	974	102	1	6301	jxua3GNCJUAgg3y8tHUfCdkBo6m7f9kiVQKxd5NK4jMVgNY4adr	4488	6641	6641	1617134580000	orphaned
9093	3NKb5Vb5MUEMWsC3XrLEkmGB4omMSnYNoQ8kFJfy4nw1U5gCBzGV	8683	3NLpK6GhucG3JVhWiU3GJJng7E5mrwgBtWpnDm59K1kUfupnxuSL	1654	974	103	1	6301	jwypww2Eb9KsJkttkqXmKhaa5Cj9yYseN2xHemCsthUdqFgWRB1	4501	6641	6641	1617134615432	orphaned
9128	3NK4gQEVaEFBP8HLgf7GgiFDEvccnLQm7HiN1R2vDMNAZj8DE5jY	8966	3NKFJc1RVLZbm1H7HAjX6qU38y1wAaFZSttSmeukzGPwyxS7WtuA	1623	830	106	1	6301	jwFF6CuSwtf54syp1z2n6NAvPcREfjvn53ci1FPgcQyqJnQ4x57	4600	6659	6659	1617137820000	orphaned
9059	3NKMTWfXCpPb85EYm4QFcncKRE6Rxo8u3W2fccYZKQH8i4HXQejt	9058	3NKfAL5qyEdf2gvhascRX5rqSPvcxc53Acj7nLSTWosmrJJz1iVz	1458	957	110	1	6301	jx85dYZf513WJwzSEACqggaPVy5QSg5ZHRz4aUcPkbrgAp8kMF3	4696	6613	6613	1617129540000	orphaned
9069	3NKwDJgxnBpCX2gr7JwL4Si7L1G7RZVXFUjPyUVhGaZu4ptp5RGv	9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	1426	1364	110	1	6301	jxmXjohTySAYsu5CbF5ryeLwJJdR4kDpEhbuwpkMUt4zxeTA8xC	4701	6620	6620	1617130800000	orphaned
9070	3NLj7f98uPN1t6iUKCGCauy8ausvN4sCNgmmr5qGmTYhqgF9jR2h	9068	3NKB5T56N1kkjECQGYUSY2xBZZ55uo4hM1hgxJ5voRa5pDRAzw98	1467	1010	110	1	6301	jwkUyytBmQAeVR7XcW9xxDMNSYTwWkcEiua8n85jJ7EsuWSkp3i	4702	6625	6625	1617131700000	canonical
9073	3NKwrKhKsTa6sC8njehn9ChbZu4gxhE9as7nm6vihzRkDKQeWDu4	9072	3NKCDvQSQnLWsoyu9b5yc3oN9B849y4hAqVpAF1iuHhmLbvuay52	1474	1329	110	1	6301	jwvxb29JptJZipufJrcLAY8ZEL8rv34694tjMsdjdjumSYsFmaw	4705	6629	6629	1617132420000	canonical
9076	3NLkP7Wu2JovZj8MFch9ugfY6hGWwVe5Uy8J8qkeVVi16ay96dac	9075	3NL48BKJUFYnY4doS1kUUFdWmo18VHcxprVhBtxcUMmERDFetQKi	1624	1334	110	1	6301	jxp8dv24GjUFA8W9vjFA7E9EKKM3jgm5bse51pv1c19Pjf9fRiQ	4708	6633	6633	1617133140000	canonical
9081	3NKUQsmP7FNsdqc5r4H8Tui5B7ReW7v29j43r5mkv5YCridebTPB	9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	1467	1130	111	1	6301	jwBavoHk4x472uSwgDwi7KH2TNtvC8DpCA6k77EQoXLTVdLvHbF	4710	6635	6635	1617133500000	orphaned
9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	9085	3NLRqcvkbpe9xAwzM4eVBmPB3ezDuTKH77BYdXamvVsYwBkkDjbP	311	1307	111	1	6301	jxUV5Fo92zUM2u6ufVqFFuJd2gfNXVBGz5mK5ZoZ6jSnHk43ePs	4712	6638	6638	1617134040000	canonical
9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	9087	3NKHDW2o4QPoet9KbCNFbb6GiM7M54woeMj38qCBBpnA4AVF81xs	1406	1393	111	1	6301	jxnty4Xcuqr6AVz2qXCxeCzSCfBXq41647Znc7ds5RRnPZ4cq9F	4713	6641	6641	1617134580000	canonical
9096	3NKS4p3ndbCCGKszU6DqwmvWHd4gdRFAkQGZ1pzBAYLCwcEjMehi	9090	3NKvGds2H738ieCqo5htC9jnb2frD3YCno6Vgc1E99Kb92gpENBm	58	1035	111	1	6301	jwCETQjN2xzePZAYrs1uZzNkRbdLz8HKJHHzZeZLUT2PBp9quf7	4714	6642	6642	1617134760000	orphaned
9101	3NK5ihLzpgdbwFojonDdaMfbgnnDUkbx1SZKgcdzrsqqSZPNHxTQ	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	1448	1185	111	1	6301	jwwfAKLGvtqk1o7LHRvMP11UWLgt14cpQB3nzsWcn93nSVpwX8U	4717	6645	6645	1617135300000	orphaned
9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	9102	3NLL8dZ4vS5Q4EnzZaEE9n8baJxmuE65DhUtKLfbbXC7mcRDqwmK	42	1361	111	1	6301	jwviShE7necfQW4boQKLCjqsQEsrbWA3Vs1JDAnNuvpBCm9cnip	4718	6646	6646	1617135480000	canonical
9123	3NKugnrnThqP6G91J2fGJjCgX8CZFXPKbsvwHGnMLczs4QKQPdeE	9118	3NLdJRpuZpWBqTr5uUk6sj2ynFxmJN9vDyyzp2UYGwqJku3DBjur	1440	1377	111	1	6301	jwkR2tmgYxgNNqmuMFeLPSsre9fBHUDoKqi85zYNZ8xM2zhfgtK	4725	6656	6656	1617137280000	canonical
9130	3NLDgvg3taoZjDWcvjKM2AX2FmTE6QxMRAGKFo8d7FRCJfTn1QVQ	9129	3NLFyAZkhaDK6SvuFbj8j6DCmtk5jFa9aoM2XGaE9qnrNpfPva5M	621	621	111	1	6301	jx5ZPNoaRgk5muWUGotGxnHHXAgdNShS247PYrBg81t7fuNFgM6	4729	6662	6662	1617138360000	orphaned
9133	3NLaQN6sZ8ysfyPZePwbhkJggWbDtDeWkQRUdMfPfnk4Dzn5tASJ	9131	3NKBuY9B9SE9aZDum2e63JHqaFPUj1ru6Mdnh2kMkkZFZkPSxznD	1549	996	111	1	6301	jwPr7MrHzjiBVEAQJBGSe2YF2r9ovK1vX4cVc2hFhnD7XKfbLGK	4730	6663	6663	1617138540000	orphaned
9135	3NLhEmUeaZH1KVHozfgFecUpb5zKie86Pph7a5tAz9VepqLfDuXF	9134	3NKp5j3TxvG6YqtyQ36oB3sY5NrutUHH5uQJE3pTuabdJVqmAtB7	1594	1080	111	1	6301	jw9Wvkr71BDqGsYcmknGCtMh2aupfStihGXhLdX82yoqfmRMt7n	4732	6665	6665	1617138900000	canonical
9137	3NKeE2B3nh5p3YhNdqtbSADMj1AWR8Q7K3ufEvrJu8hs21JXb6An	9135	3NLhEmUeaZH1KVHozfgFecUpb5zKie86Pph7a5tAz9VepqLfDuXF	1405	873	111	1	6301	jwsfc5rxzfFnGojaexzqxKMLq1Z7gPCXrLeqScoNxBcfJ2jufiH	4733	6666	6666	1617139080000	canonical
9143	3NKh9FjjDabcfNnWdnEwjm2ghZcxxxsXuM7MM5S3exAUU7dPZTpq	9141	3NLweBpqaw3RK23U2JP3zAaV8RmNJkCroxQN7LxQmZ5eS6XKMymM	684	1352	112	1	6301	jxhGHcqUok35dFuFp4Nt95P7UqELJBdx9o2RnB5fsnoFWyuznwR	4737	6671	6671	1617139980000	orphaned
9146	3NLrpUeakmVFUXYmzSTTyW6m3Jdkzspb8DHv8wboX4fKbVSQDKTB	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1619	1275	112	1	6301	jxBWjivNcXRX4Vm1mpqmTeLDhW8q3wcvEDGAviH5Ue22UiVM4Sz	4739	6676	6676	1617140880000	orphaned
9155	3NLLytvL3fv1QqjXuopwpSB2scXudbgKYfy9224Ms3dU3UUu8C4K	9153	3NKgKAGGbcmQjq2VwG1TmQG7XYq16UMS2hfpVNKf2k7HFLtcohsH	1652	949	112	1	6301	jxeygWVbsyUCBuxzsWA3dCtSG4ZKMrULDEnEzCb6L2ZBvVfFnu9	4743	6681	6681	1617141780000	canonical
9160	3NLtWC9HQC9EtF27ooK76Qx5nzVydCbTSRTJumFJPZxQ1kbvgtzg	9158	3NKuBq9gfm1iLtZrsh6imuuUrUSRXHnRrCbgPDHWS5Zw7TBiR37d	1406	1393	112	1	6301	jxHPK3APjZkmcMNqN12TJCrwai34grVkyrqhrrNMKcDqZBqjtEW	4746	6684	6684	1617142320000	orphaned
9163	3NLZo8TzjFtNi29N7f1p652WEPpkkbGLdYLi3LCmf5mTH44EuKP1	9161	3NKjPNDZFUMhfMZCsuHj9Eaem8y7xBeaQPygj7ZVhUzjEuGcS3z9	1610	948	112	1	6301	jxhbcEwWSUw5Yvf3iEsU3ZMy3znpTJ4cKXgAWuhEn7bQLJg8Hbu	4748	6690	6690	1617143400000	canonical
9166	3NLnKVAcTdDFJbGD12QuM8NAuhQbY4QwRfHqHM8Q9sfobK6rNRuD	9165	3NKSyTPh5VDwckij8Zzr8LLsRC7Yxa1dM9eBMCeWQB72FV83rKWF	1501	1114	112	1	6301	jxzEqpugAyzNZa3XUui94pqZj4e6uPtdz4PNURdH4xXFuGsTUME	4751	6693	6693	1617143940000	canonical
9170	3NLCB6o5UyV6NZw6HWVyH5BgR7JQSDQvY9ivtYeYVNbZiadF6KpZ	9166	3NLnKVAcTdDFJbGD12QuM8NAuhQbY4QwRfHqHM8Q9sfobK6rNRuD	1581	778	112	1	6301	jxBjrw1PCi68poMmcfPWuj1QRQA6oRGyQsniYrZf1iwYAirZTnQ	4752	6694	6694	1617144120000	canonical
9168	3NK78Hauk9ZevktvWurtYJfqszeRCxggaqebTryptEhxq93hs3pT	9167	3NK6Bw5UUWS2SY4d5A2YmRPuqHvLBaaBLSvnf3iYSpXLerpQHfC9	1460	1324	112	1	6301	jwmU7MiNGH2F8UUSos7oXQz1TiBnxbL8Z3JY6AFiYkn5yfocyy1	4752	6694	6694	1617144120000	orphaned
9176	3NKDbRvzVQdY6rFZ9su2bgKPs6GJgFzDyqUd6gDQfnrCPQj6XeDd	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1460	190	112	1	6301	jx1d67nwcdswvfcFoXnYEfMfQABLNZKyCGy6kcxnsw9AmD9hoZn	4756	6699	6699	1617145020000	orphaned
9180	3NK3Kbjht2cTxzAFguoxewgCwVKwME3mWDUvU967SorQ2wm3SEDc	9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	1489	1380	112	1	6301	jxuN2v4hc8EQYyhHEHjm8gYLdUoG9dNcx2k5qSAc8xGYFAty1v8	4757	6702	6702	1617145560000	orphaned
13992	3NKvePJpNSheHo7LZJ7msEUJebqdHcu3HHzWjiyWxo92KRjNvJaa	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1506	1127	215	6301	10155	jweWHnXNUaGHeSaoog2CZamwAko9TncfA9sJXBdBdToZ6G6JKYv	7169	10154	10154	1617766920000	orphaned
9120	3NKx1dyQz3anZHox1SDjZgDrsMsxtr7hW6QsgaZifRWhfkZTDpSt	8734	3NLS4v8SbU7Ujpfp1AidZvLDkWvAucSFX9LiYWA4PzTuV83YenCY	1553	776	104	1	6301	jxrycGNDc2SKqWdoNg9iewVTJ9aax1Kh8EsZmY4SkCFHTKtufFU	4530	6655	6655	1617137152383	orphaned
9075	3NL48BKJUFYnY4doS1kUUFdWmo18VHcxprVhBtxcUMmERDFetQKi	9074	3NL7Lk4mopvXeL7MVELVLK82V4VHGUtqPrUvYJSSPzukx8TJXyDz	1402	810	110	1	6301	jxYGEdNuAhSfU6wwDtSx9cbqo8Hhuc4LbJzfhSPefLhLroirikR	4707	6631	6631	1617132780000	canonical
9080	3NKSeUKxxrqV6KpqFZjxqqLtQbrQSATAWaQ7yrez23q8hPCyUFbb	9079	3NL6mnMWuCmf5XR2bKk63Fymgnd56qTDjZbJEDu4FBPDYQ9BJaf4	1509	1320	111	1	6301	jxZopJaQQKQX89XzboaSFo8181AwaNN6cJiaaZe4h9C3FtcSwEd	4710	6635	6635	1617133500000	canonical
9084	3NKdwRMsYegSiWMDP7okNRRpcUg6gkH1syECAS95Kara8WECwumG	9080	3NKSeUKxxrqV6KpqFZjxqqLtQbrQSATAWaQ7yrez23q8hPCyUFbb	1457	1145	111	1	6301	jx1tRemwBuhm9psRzRg1pEvzV6CS99TBYeVJrK8MBhXH85RZyRc	4711	6636	6636	1617133680000	orphaned
9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	9099	3NLtBRsidHKjHQdbihpsLYH816xZzL4ncWm6FTgJUyW7VRh2j5aD	1451	1292	111	1	6301	jwTk5DvBwhRrDypiYuTVrVDDSPv4KzZbx1eHquiWMwe6J3g94Pb	4716	6644	6644	1617135120000	canonical
9103	3NLtEDbDFJJjhkY9W88GVm9HtgB7h5aNTACe2uVhUgVipxG1XYvN	9100	3NKdEouRYnNxQm5wBBkQXTxcCq8xFDWqeXs5kystkYVyK2rmEMzG	632	1382	111	1	6301	jwzUCfDyk2Yxo14CWW9jg8FLYk2GGc5kFqKLCpndxwDKVQSLiVU	4717	6645	6645	1617135300000	orphaned
9110	3NKqCjQDCHC1caNokBikDbLrFG6iK5NEgbJE9F1PLcoTVFgrsrDG	9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	606	1295	111	1	6301	jxBiUbkdeAHkutmocJf4VuHU8gGZzpHA1sKZ9sDHyznV6kkvHnS	4720	6648	6648	1617135840000	canonical
9112	3NKja5Fd7Xy5t5psSv5B752UeZGNN5uacS9HyKTPiKCAhgQ6rwUz	9111	3NLE74twfpogDNmvovyGdVmeqJjhYKovbHm6ztgqXWjvuj2qnCF8	1406	1393	111	1	6301	jwnSNFBJiktJcmRaPBFKYRKifNdS7G4pg1d5WqF7DmvSBFdsya4	4722	6651	6651	1617136380000	canonical
9118	3NLdJRpuZpWBqTr5uUk6sj2ynFxmJN9vDyyzp2UYGwqJku3DBjur	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1407	1395	111	1	6301	jxQFiiHL9LHENqwq7xyyE4y3q8vKUdvZN2MAwMMNgcpr5AaBxFv	4724	6655	6655	1617137100000	canonical
9116	3NKAz2AsBNc1qHhfbgXRnHzJu2N3k3DSgjYnSq6KZiSCNn5uNfby	9114	3NLGtCEb5wTp3JB5AaKeNNycmSPL8UHE1YuUwERsEABkMK7VoqoF	1527	1293	111	1	6301	jxKY9PcJwUCywCr7km4JGww7iTTA2dtHE7sgfgkwyLG1BEJfZVu	4724	6655	6655	1617137100000	orphaned
9122	3NKkVwQxGU8MFft4mPPGtN2cH3qwCoqJAB3rBq4Ljwg7zhCBmX2Q	9116	3NKAz2AsBNc1qHhfbgXRnHzJu2N3k3DSgjYnSq6KZiSCNn5uNfby	606	929	111	1	6301	jxJWyqMVJjkDX9yusvBidNYste7iMbLgfuqjcY5y2NrYt2cUDWJ	4725	6656	6656	1617137280000	orphaned
9121	3NKqFaMvnmuyadgRQqQno7PdUKhXHNMXxR5yjC3trGSeXPSkScdb	9116	3NKAz2AsBNc1qHhfbgXRnHzJu2N3k3DSgjYnSq6KZiSCNn5uNfby	1440	1377	111	1	6301	jweBvifPzcA5VUTEpRiBafmKFzozvkpwr1Pmxgcbq8zxmVQkqeE	4725	6656	6656	1617137280000	orphaned
9124	3NKH7qM196byywhxNwcVV7J1fi9eh5vMsDY6PWFggawksvb7aCvz	9123	3NKugnrnThqP6G91J2fGJjCgX8CZFXPKbsvwHGnMLczs4QKQPdeE	1489	1380	111	1	6301	jxtXqDM2hPShc4a47ycFwArSnegnJpNS5cmnWeDSBrQCokX1q36	4726	6658	6658	1617137640000	canonical
9127	3NKp1FmVw86t2gRs1cbPJh1FeK1L9LWDracN53piki92bRyPMFAM	9124	3NKH7qM196byywhxNwcVV7J1fi9eh5vMsDY6PWFggawksvb7aCvz	1489	1380	111	1	6301	jxmwzWbbAaCpKYoXmP9RTYhNX3PaftE7FTqqhesG6gSThPwhs7P	4727	6659	6659	1617137820000	canonical
9126	3NLSNr84q9hdJDhZShCij5e7RDyLcDnrynETzUb3LSCbYQtiXkNg	9124	3NKH7qM196byywhxNwcVV7J1fi9eh5vMsDY6PWFggawksvb7aCvz	1447	1099	111	1	6301	jxj7zJpckmSjLmdTCrPR8UgmeATrSXnEiY6HP6AcQWFjtUbSSss	4727	6659	6659	1617137820000	orphaned
9129	3NLFyAZkhaDK6SvuFbj8j6DCmtk5jFa9aoM2XGaE9qnrNpfPva5M	9127	3NKp1FmVw86t2gRs1cbPJh1FeK1L9LWDracN53piki92bRyPMFAM	1406	1393	111	1	6301	jxWo4BeiS5iQKS5W59GZWqiCpZNJg8jZVvtmcrEBoy3ZVwDBySt	4728	6661	6661	1617138180000	canonical
9131	3NKBuY9B9SE9aZDum2e63JHqaFPUj1ru6Mdnh2kMkkZFZkPSxznD	9129	3NLFyAZkhaDK6SvuFbj8j6DCmtk5jFa9aoM2XGaE9qnrNpfPva5M	621	621	111	1	6301	jx197Up9vTucr21SkVtzBwKJzixjgDfB3QZep3NLuPk8LB6Y5fo	4729	6662	6662	1617138360000	canonical
9134	3NKp5j3TxvG6YqtyQ36oB3sY5NrutUHH5uQJE3pTuabdJVqmAtB7	9132	3NLwD4EfM3MF1HhzjcRheQvhbnw7Jkhdmk8wbYsQTGo9D2fvFhTQ	1631	794	111	1	6301	jwiCpLWM9NqdEapttnYYZ4w5RHFocAtB5e8Wq67HaTn6BivMkRM	4731	6664	6664	1617138720000	canonical
9136	3NLejJUyMhZmrn6dBpARMfjPYGa6q6ks1MmnJfkee9tqyzAfJKeM	9134	3NKp5j3TxvG6YqtyQ36oB3sY5NrutUHH5uQJE3pTuabdJVqmAtB7	1631	794	111	1	6301	jxoqAyX4i8wQdcNQcwT2vJUTqwf8KCDT3CXrXWzuKH7mvcxX91r	4732	6665	6665	1617138900000	orphaned
9138	3NKew52gVti3dVb3KYPxBLzB6oEPAPQDzCsbFmudTKHP3xMME19f	9137	3NKeE2B3nh5p3YhNdqtbSADMj1AWR8Q7K3ufEvrJu8hs21JXb6An	1637	816	112	1	6301	jw7j28ScoKwRzTcj4QNQVTh3hmprT2HgNbSskovqHbLu3x7eBeq	4734	6667	6667	1617139260000	orphaned
9140	3NLPw5BqwnBDG7ZYyAtqe6D5TiXHGz8rnyB9XNii9XfHZtrMJQ67	9139	3NLv4BAFpoHSixf8s4aW5rrkRQDt9m6CN2vpVkrzsgXFEjB1VDZy	1536	947	112	1	6301	jwZXSfigJLSimre9H9nfjGqsJG2CWXSGw32bURTEqt9KQVE3F7V	4735	6668	6668	1617139440000	canonical
9141	3NLweBpqaw3RK23U2JP3zAaV8RmNJkCroxQN7LxQmZ5eS6XKMymM	9140	3NLPw5BqwnBDG7ZYyAtqe6D5TiXHGz8rnyB9XNii9XfHZtrMJQ67	1601	1388	112	1	6301	jwYRxKvkurYmRkQaxRktVopRXto9L9JbKN7D5p2uswggYZF2ZPX	4736	6669	6669	1617139620000	canonical
9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	9142	3NLXczWqjR13kfAhnPBUtNAL7upmdW2AB6ZejDCQ9q9y2CGcbW9J	1460	1324	112	1	6301	jxFtUvsMpq22isXRLhPDqJmkzLVuZd2Kkmtq3y1ThDaZzux5UAi	4738	6674	6674	1617140520000	canonical
9147	3NKtmwmmkEBA1g29cJeC4CkDdXUvDPy88DnFAhigamCSfgNwoiVa	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1647	936	112	1	6301	jwcD38n4wZnuu7jqSmDCmKyDpGA7mxjERbwSXmm7dGL9BP6Z8zN	4739	6676	6676	1617140880000	orphaned
9149	3NK3q8Pz7vTGppThER5zDLLEKaUpkiRQj22obJWFY4Bs3pJF1Zdc	9148	3NKQGNuAPkyMDMQcwvK8SZFxz3cjhqyvWHZk4VNAHL5NXmrTP6Gr	1547	1378	112	1	6301	jwVZTAfuH8EnEgCKn3FzdbZXf324eniTfF8bxAMrmSP7JDnfwsQ	4740	6678	6678	1617141240000	canonical
9151	3NK4jEH4YyoaZgtozRXjbQy4aWNP46Lhomc6JnWEWS28qScduiPp	9149	3NK3q8Pz7vTGppThER5zDLLEKaUpkiRQj22obJWFY4Bs3pJF1Zdc	1527	1293	112	1	6301	jx6nkPQiG45dcLVucgPWBLk5A8cEX6pBMhYAMstBKkfiuDPjtLq	4741	6679	6679	1617141420000	canonical
9152	3NLJ8zBBaCztB7KPJUi1dFc8kjrEcRwTmy6J8Q5KMu4k8HH3LEGq	9149	3NK3q8Pz7vTGppThER5zDLLEKaUpkiRQj22obJWFY4Bs3pJF1Zdc	484	1319	112	1	6301	jwqddS2nPpDvvsqqBjKyPtNX2ZXdwKd4WeBUVAhuQkTtMZuwZGE	4741	6679	6679	1617141420000	orphaned
9154	3NLYZgPr5SH9kU8nmPFMeCuQr2hu64EzTvGsDHc4oUpsqDwgC5hy	9153	3NKgKAGGbcmQjq2VwG1TmQG7XYq16UMS2hfpVNKf2k7HFLtcohsH	1596	1117	112	1	6301	jxUAutJPpTvyMxjisWL3gCpEgpFzwA5p3UzVRABC8LKpVwdZdgr	4743	6681	6681	1617141780000	orphaned
9156	3NKDak38RmvZsXJDeEaPCzneuAxwnyqen5dc8WRv9uR8CGopc1J1	9155	3NLLytvL3fv1QqjXuopwpSB2scXudbgKYfy9224Ms3dU3UUu8C4K	1461	1271	112	1	6301	jxsFN7bcFEPFKpA6DJiZLeTiCnqPWqQ6qTRNBm1L4oJTgH8uMoh	4744	6682	6682	1617141960000	canonical
14079	3NKEdYLHMjU3J9veb4McCpKZZp3V8xr4mcgP1Q9wG5vwkCzxNTii	13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	1405	855	215	6301	10225	jx4E4p787ovxag62pKdojbQ1y9o9kT5eHNkWRTvKqtV5PwLZAK5	7172	10200	10200	1617775233350	orphaned
9099	3NLtBRsidHKjHQdbihpsLYH816xZzL4ncWm6FTgJUyW7VRh2j5aD	9097	3NL9iQRSaLGTtEYSkEc2yjjaNMqmbGLqZyouxDEJruTg2YsuqgkV	1581	777	111	1	6301	jwFpEXdqabexXKkBKb3LX12dtYGLW9FzJrNsSH55R49eo4icRn7	4715	6643	6643	1617134940000	canonical
9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	1402	852	111	1	6301	jwWVg78PZdinW7K2mX7ukJtyFq3QgxdwC9RtXvVLuMsgvpC3Vj7	4719	6647	6647	1617135660000	canonical
9108	3NKL4rWoh5q9prjB4bMWht1EZpLQDyXPJmxkbVDCzqFhVCUHMxUU	9106	3NKntVissbKissJBm7BQetj38vyLGjixpq2GVTTDSPGxrd5xQhWc	1407	1395	111	1	6301	jy34JjvjQrTWTfhgMcZUYK5Qv7iG1YZkjR8HozQGpPpJho87wCr	4720	6648	6648	1617135840000	orphaned
9125	3NKF2YMX9NQ4PX3GCyVdq8Tq15jnBTCVjJdr1ednDrJRX6pzsbvY	9123	3NKugnrnThqP6G91J2fGJjCgX8CZFXPKbsvwHGnMLczs4QKQPdeE	1607	577	111	1	6301	jxZp3PRJnPmNW2AxzM5t6YWug6LmqTDZggr98Z9yBWchVvaJHxj	4726	6658	6658	1617137640000	orphaned
9132	3NLwD4EfM3MF1HhzjcRheQvhbnw7Jkhdmk8wbYsQTGo9D2fvFhTQ	9131	3NKBuY9B9SE9aZDum2e63JHqaFPUj1ru6Mdnh2kMkkZFZkPSxznD	1406	1393	111	1	6301	jwhhCDXEKzbdK7Kic64TH93Kk3XpsvGQb9t2pwdkckJYemHMVdm	4730	6663	6663	1617138540000	canonical
9139	3NLv4BAFpoHSixf8s4aW5rrkRQDt9m6CN2vpVkrzsgXFEjB1VDZy	9137	3NKeE2B3nh5p3YhNdqtbSADMj1AWR8Q7K3ufEvrJu8hs21JXb6An	1407	1395	112	1	6301	jxtcU358BoCe5DuCChG86J75ox7h7UTDkrdHwmaFu3QNmJzo9kR	4734	6667	6667	1617139260000	canonical
9142	3NLXczWqjR13kfAhnPBUtNAL7upmdW2AB6ZejDCQ9q9y2CGcbW9J	9141	3NLweBpqaw3RK23U2JP3zAaV8RmNJkCroxQN7LxQmZ5eS6XKMymM	1643	933	112	1	6301	jwoCMS9SQegZGhrT8EoWhMwUszJveAmZmoeLQevy87qu9FnqdyB	4737	6671	6671	1617139980000	canonical
9148	3NKQGNuAPkyMDMQcwvK8SZFxz3cjhqyvWHZk4VNAHL5NXmrTP6Gr	9144	3NKEkU1kwCH1RDRx695u2W2dD8Wb4GxzehpQUayqPgo6rc2wHUTo	1406	1393	112	1	6301	jxR1iNsu7FnmT5PrGdzKqKZ3uZjmLiLwoEzAqTP78LJ8NkyaXqs	4739	6676	6676	1617140880000	canonical
9150	3NKjs75PnUGNg8Bk5UtHZd6Zf1XPqrw7aKsg3ZW2uHbymu2FmGx4	9148	3NKQGNuAPkyMDMQcwvK8SZFxz3cjhqyvWHZk4VNAHL5NXmrTP6Gr	1407	1395	112	1	6301	jxGj8xgTwE3xjySXa1URSCk1YGQiMoPkMTJe3z4aADPRrtAtaPb	4740	6678	6678	1617141240000	orphaned
9153	3NKgKAGGbcmQjq2VwG1TmQG7XYq16UMS2hfpVNKf2k7HFLtcohsH	9151	3NK4jEH4YyoaZgtozRXjbQy4aWNP46Lhomc6JnWEWS28qScduiPp	235	235	112	1	6301	jxn5Pg8Eg2N9VS1X3Vnbysw2poh21gwPVXG2MHUsoR3VTU2yQGu	4742	6680	6680	1617141600000	canonical
9158	3NKuBq9gfm1iLtZrsh6imuuUrUSRXHnRrCbgPDHWS5Zw7TBiR37d	9156	3NKDak38RmvZsXJDeEaPCzneuAxwnyqen5dc8WRv9uR8CGopc1J1	641	1090	112	1	6301	jxttfrYa18nj83qz7SW5tmJQzaU1ALu6FbieE18K9MrFM22aRB1	4745	6683	6683	1617142140000	canonical
9157	3NLD1TEaKLef58K4yixuFqu82QqhNoGe5g5mZz2f6Gr8iMESyt1r	9156	3NKDak38RmvZsXJDeEaPCzneuAxwnyqen5dc8WRv9uR8CGopc1J1	1405	891	112	1	6301	jwD1Hz1vCtvxbfcEFBsigA3iR9sdKwqoBZKZnJ4ZyUexM7UqJ1g	4745	6683	6683	1617142140000	orphaned
9159	3NKXmMJ24WL56jW2NseWKGgMoZaZ6QqKtqLhhxPBFEizhamefwfk	9158	3NKuBq9gfm1iLtZrsh6imuuUrUSRXHnRrCbgPDHWS5Zw7TBiR37d	1403	823	112	1	6301	jxJxZSWvUp2mwCQ8y2WqEht3eMHnSThTVeww3bf4JGZht7CeAqs	4746	6684	6684	1617142320000	canonical
9161	3NKjPNDZFUMhfMZCsuHj9Eaem8y7xBeaQPygj7ZVhUzjEuGcS3z9	9159	3NKXmMJ24WL56jW2NseWKGgMoZaZ6QqKtqLhhxPBFEizhamefwfk	1585	1120	112	1	6301	jwJ5usrCXcakMXKE45Yb4QCmer45qz8u7XkgcGEe8y51XvpsVsh	4747	6688	6688	1617143040000	canonical
9164	3NK8vf6c6Rs6waHnjW6KbvfGw9D3uouuzHZHMFaVwgU9TFtKHfjX	9163	3NLZo8TzjFtNi29N7f1p652WEPpkkbGLdYLi3LCmf5mTH44EuKP1	1406	1393	112	1	6301	jwjdh1vr21fYQhwwjWCMRKWSPqtBHarLbZH6iWZ3dhw18qTXpu7	4749	6691	6691	1617143580000	canonical
9165	3NKSyTPh5VDwckij8Zzr8LLsRC7Yxa1dM9eBMCeWQB72FV83rKWF	9164	3NK8vf6c6Rs6waHnjW6KbvfGw9D3uouuzHZHMFaVwgU9TFtKHfjX	43	1310	112	1	6301	jwUZPab9kji2iVidKAvLF2C3bRoMGP5DxMAMrZ96gf2VkSFfY2i	4750	6692	6692	1617143760000	canonical
9169	3NKRrvGyyT8XXJHzLEFzskeU6TGZdt4akZ1zKk39tgXxaHF36bjL	9166	3NLnKVAcTdDFJbGD12QuM8NAuhQbY4QwRfHqHM8Q9sfobK6rNRuD	1460	1324	112	1	6301	jwyPUUQQxcYeZENM2BQ5SDEtcqFiVAD4xVcRJM3qGxHt6ynVfmA	4752	6694	6694	1617144120000	orphaned
9171	3NKArAA9dJdBeS9c1RoxkbKjtjd2ZCWkk4TZLuq31zmjUcEDKBUF	9170	3NLCB6o5UyV6NZw6HWVyH5BgR7JQSDQvY9ivtYeYVNbZiadF6KpZ	1407	1395	112	1	6301	jxo5o8QPGiznzZkKJxHBg4aV47Z6SdL26vrV3g7tSYMVTvdvtzW	4753	6695	6695	1617144300000	canonical
9173	3NL2MezkPA4PRMhrf5t3qhE5qzNyijQjMQm4nzKUuPxmqVZhJm3s	9171	3NKArAA9dJdBeS9c1RoxkbKjtjd2ZCWkk4TZLuq31zmjUcEDKBUF	1555	1347	112	1	6301	jxFY5DBeHqGD7q787LHfuxWjip1xDXHGbrkhZWmKEaS9bkLWbpv	4754	6696	6696	1617144480000	canonical
9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1560	1045	112	1	6301	jxbYyrHTtp4m2Gf2xF4CMXgA7z7mhkVwenUYqCpWKZj4HjFFWuD	4756	6699	6699	1617145020000	canonical
9177	3NKgHqbW2epcnEuC9o8qKUzv7K3cGkLK6MtY1L9bP3ahvCVLn2Us	9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	1406	1393	112	1	6301	jxNQTEHhnk8Gdkmk1eSoHas9V221LY3kekxCjrVJG7j62punFJY	4756	6699	6699	1617145020000	orphaned
9181	3NKVWNwrkJJd26rB5ncBAYhXff6DfbqaBkfcfNgDc5JGVvKuyCBS	9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	1402	868	112	1	6301	jwu33ZBURQn99G8hAMGQt87PYbFtjqXqCwQkyPThM1uLUbb5PTb	4757	6702	6702	1617145560000	orphaned
9182	3NKm412uC1YhdicJF4Ar5bWusC8neKpJPMcD4tE5YhV9NzoBiLkE	9179	3NKjsFwQDroJgKn2wHTLKhFqX3QxzbB9fmgMviz1rYbwSYdCN1Tv	563	1359	113	1	6301	jxCNhTxvrLmqRQLKDZnwm6ZoJX8M6rbR6xsenhqCoXAD8sH9Po2	4758	6703	6703	1617145740000	canonical
9183	3NLQtmsHCU2q564jb2mxWBRJhbZvtxP73y4zzKaDSfDEcf8R9ZMD	9182	3NKm412uC1YhdicJF4Ar5bWusC8neKpJPMcD4tE5YhV9NzoBiLkE	1406	1393	113	1	6301	jwTBsCSbveLY8ryByKKwA6gZ1hk8Vf5c8V2HLFSBN95ngFYAtww	4759	6704	6704	1617145920000	canonical
9184	3NKWkJVvtuUsJWz7rv9dv4NJsQYtBJ66F6Qj6HkM6Xt6ZHVJtm51	9183	3NLQtmsHCU2q564jb2mxWBRJhbZvtxP73y4zzKaDSfDEcf8R9ZMD	1407	1395	113	1	6301	jwBYxuUuBkZ9VPmtqXQXgg2bewMZqiLVHZpN7SxWGsDLjp8mRVS	4760	6707	6707	1617146460000	canonical
9187	3NKzfc29YgfnxjAN1LB4hZm5dMKk9VBFN9bbWAUfuvSKLQ68DAuW	9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	1541	932	113	1	6301	jxucMkPZGPtmeQGiMSFmbJjUfStFx6HEhedRHdWdH41yCWDdrNE	4762	6710	6710	1617147000000	orphaned
9189	3NKxeGysRw7M9n9U6pPiHE1eh622Z6QAP6pcsHkAbBgDc3DH5wdy	9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	369	1312	113	1	6301	jwofYajrASbEzToDgNRn1Fd4pya4wK8c9f1jyRMTviNByjJAurH	4763	6712	6712	1617147360000	orphaned
9196	3NLtaV3exWXvxBBNQYoWm8w944EiUqp9DcDyp4MtM3CxAyghYWWe	9194	3NL846bGraTgCKj3RfexJUQ4GjV8Ri5eT6xDnR2gNfjqRh6XiNeT	1500	1297	113	1	6301	jwWT4UxVoZ7k4MAnett4bCfDPt4uoWJ5VhQMvfxir1Ecacg74hF	4766	6715	6715	1617147900000	orphaned
9198	3NKKL1kTnP7NnhEZ9d29RL8epkzmad7oXbbQ6agPT28nPqdD4rSz	9195	3NLdTVyzLT5VeatmM5Wv7oyGjgyEb21hR4ZWvEjkN76xSkHWU8px	1434	642	113	1	6301	jx816qt69TCbkjzdeNhcWNCXBBKa7HUjRLH17XwQjVcKD7HwD27	4767	6716	6716	1617148080000	canonical
14655	3NKD1iDUcAoVYM5W78XZuaEoz9LPtoFKoAfCpuPGR48Njosm34MN	14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	641	1090	215	6301	10746	jx2eDyEspBt2sv3LQUfMauGWxrMbQZacCqHHjQkXWnSUFRcS5j9	7182	10574	10574	1617842520000	orphaned
9162	3NLGJHYenUGooWnuDT5PwhgvkqBM8xBHAbH5LYkub6BqrVViuwbt	9161	3NKjPNDZFUMhfMZCsuHj9Eaem8y7xBeaQPygj7ZVhUzjEuGcS3z9	596	1060	112	1	6301	jxFaU7GyenF76Zow6hn19XfRF9o6mH6s5aDUS2EiM7sJi21mhMW	4748	6690	6690	1617143400000	orphaned
9167	3NK6Bw5UUWS2SY4d5A2YmRPuqHvLBaaBLSvnf3iYSpXLerpQHfC9	9165	3NKSyTPh5VDwckij8Zzr8LLsRC7Yxa1dM9eBMCeWQB72FV83rKWF	1555	1347	112	1	6301	jxCim77t2AxWxDjm2hLEN3S9bHnGM4yqdVT5Ws9BXYsYExW7rp8	4751	6693	6693	1617143940000	orphaned
9172	3NKPXXAi3no8nLVfdwV1aM58PTHJyobdJ95cBUQ9b56Z7BYCWyTv	9170	3NLCB6o5UyV6NZw6HWVyH5BgR7JQSDQvY9ivtYeYVNbZiadF6KpZ	1458	1323	112	1	6301	jxuUzdWd6cnPKbxUdGE4oq7tfmeEMycCh8GooAHs5eCA9yYfgpe	4753	6695	6695	1617144300000	orphaned
9174	3NLgY7MSbpiUDvExLcccKJvKq2dGKNQEXaPSSsA4GchKy8BEBDE2	9173	3NL2MezkPA4PRMhrf5t3qhE5qzNyijQjMQm4nzKUuPxmqVZhJm3s	1553	776	112	1	6301	jxHwpQoyoyK9UChjXRBvSc1T8fi9NeZ1mWBfWdvbrvCbn3M7hZR	4755	6698	6698	1617144840000	canonical
9179	3NKjsFwQDroJgKn2wHTLKhFqX3QxzbB9fmgMviz1rYbwSYdCN1Tv	9175	3NLm1icTpPnM7DZJDYvWvxBvr43oShTXrZpEULUmZ4PUhWmGLi7f	1585	1120	112	1	6301	jxAsCTikNwgvqC1575FkAXJkswnA4wRXuVUaWXuXhm6iSrMSKqJ	4757	6702	6702	1617145560000	canonical
9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	9184	3NKWkJVvtuUsJWz7rv9dv4NJsQYtBJ66F6Qj6HkM6Xt6ZHVJtm51	1501	1360	113	1	6301	jx3mhe6a4jyAdtZ4HnkgdtCCMvJ1iHnXKR1Wa7n2HL5aEJjKjrQ	4761	6708	6708	1617146640000	canonical
9190	3NKoG9ZxADkowDUMZ3hmanFvR7zq3xXZiPHnkqFodtfEjfqtugXG	9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	1553	776	113	1	6301	jxW1G2unjvTe8qXaBFdLhePGXLeZzmdMvjbbrB1Psgo2ZJcw22w	4763	6712	6712	1617147360000	canonical
9194	3NL846bGraTgCKj3RfexJUQ4GjV8Ri5eT6xDnR2gNfjqRh6XiNeT	9193	3NK4YEAghZEK8rfB2gr9k9NaxdyAgpHhU2iRfzTmAfNquiFZkmUC	1406	1393	113	1	6301	jx9Nvgs2EhhhJ4ZmCGa1dMNy42ZbESERzKki299tWrDL9fqAoYi	4765	6714	6714	1617147720000	canonical
9199	3NKSENjK3MqoF36kfD6rSAF9nLkuig7K8qd7ThHChsdQXqVG9Xkg	9198	3NKKL1kTnP7NnhEZ9d29RL8epkzmad7oXbbQ6agPT28nPqdD4rSz	1631	794	113	1	6301	jxW8RgS2YVb8WawDUTvQ7QjxfbPztj2rZtgWDWnwcvycQbBiSZT	4768	6717	6717	1617148260000	canonical
9202	3NKVcbeedJ6tHUb9GAD7hucwK8vfupnTfa9KNpZPWAdjy18aV8AS	9201	3NLkWFNfxJRmKbbh7vVve5mYEPvwKBkQyRQaP8Hz16UVTntuB5Yo	1627	1259	113	1	6301	jwoXJ5isapjSTEe3sDP8CRbtXet9MEFUWiFwfenL5qTsqTXBJBc	4770	6719	6719	1617148620000	canonical
9204	3NLRbB6KPZrQmvhe4GHobWscid7CEH5B5xv33rn4gJNkjasprPRm	9203	3NLjoNzTnTWSB1G4E2Twf9tVhqPicn3K3UsQ8NJmUmFKvpVsU7fe	1670	1156	113	1	6301	jwJyMNSvQw61dGfQZHzZ4VZKZqofhrMxFQRsAUX6RndeuRVtorL	4772	6721	6721	1617148980000	canonical
9205	3NLofxQmDYpofVWrgpJeixRj5qKfZza8LTjoVgiJxNNGg4ZnDz6v	9204	3NLRbB6KPZrQmvhe4GHobWscid7CEH5B5xv33rn4gJNkjasprPRm	1467	1376	113	1	6301	jxHHxwKnjQodwXC8TSEWSrxJ1ccFtEFHNsXPLYErMuATDzYmANT	4773	6725	6725	1617149700000	orphaned
9207	3NKSRCsANY2hi9d1mNm15CSGfP6gFwWezzQ4eKrrChaKc3qMv4hf	9206	3NK9drYacgJJKZLuyBkd5wFuBNmqAmTWRs6sNfuB8KfMsJqQAQtW	1553	776	113	1	6301	jxB7zKoaHMWyx3PRvn13zXjZ7AYjkNNdEYh4R47W6i9hf37f75m	4774	6726	6726	1617149880000	canonical
9208	3NLVTRP2YpyiFZ1rE7vuD84myiEBwQHxDLrppW48VWGdz9maH9mb	9207	3NKSRCsANY2hi9d1mNm15CSGfP6gFwWezzQ4eKrrChaKc3qMv4hf	1471	1140	113	1	6301	jwqu5hNyziQ51xMCqf82nba2cDhxcceZfe7WUD1yxMwF2Az7UCB	4775	6727	6727	1617150060000	canonical
9227	3NKsJty7tVQnMsKapAj57qfmaEi7AU19xp1UWcs6gnVFKo1zMbEH	9207	3NKSRCsANY2hi9d1mNm15CSGfP6gFwWezzQ4eKrrChaKc3qMv4hf	1542	1058	113	1	6301	jxYdJRyRtDA7zhf4ybWhRtMDCgLooFzr8gZwJLTvPtFazQUQ6UJ	4775	6739	6739	1617152220000	orphaned
9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	9209	3NK8z2vszqRFdnVCoefnZN1b8RQfmyAR5aAN8pqBM7Y7gqQSGbUb	1637	816	113	1	6301	jxqcCUaARyupsSduWkp4KBKWfuMh7wRV2tCwpg1wQpehSMpBVWW	4777	6729	6729	1617150420000	canonical
9211	3NLfyKEJEZ8ceT8HfHA7qencDKMRdKqmC4pVuEwGxDxJS8KLwu6j	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1403	824	113	1	6301	jwqpTqEwZAEa9u7HzeFvenweWH5xx1z1q2gef7mzVBK6KmgNBsC	4778	6731	6731	1617150780000	orphaned
9215	3NKfgwKwq3qWFFMNcr6BcAzv1BkZip3m6ADtr9htfjD6WftD3TrS	9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	1403	824	113	1	6301	jwYvecAHeXcUZwLqdQE6Gyi9Lg7RTXPQqUT4x8ZkrYK3efgfMqf	4779	6734	6734	1617151320000	canonical
9216	3NKFP76Ff7WXn6Ys9ApaDQ9TrhHLQ3RYtfg2gToDb1NVKaA9icoq	9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	1406	1393	113	1	6301	jx9oRq7b8ndgccvzibgh26T4kRMGb8Rt7dcxTDQyRNbGZWTrt1s	4779	6734	6734	1617151320000	orphaned
9218	3NLWFsn9pfbRFXbNRm6r9GEqMHeXyQ2YH7FD66A9RVSvT14HH8e8	9215	3NKfgwKwq3qWFFMNcr6BcAzv1BkZip3m6ADtr9htfjD6WftD3TrS	1634	1085	113	1	6301	jwhGJFRwgRj5TdygLqgbhLKaXZWFbnV2g4MpHLr4fF6NYY3qcV8	4780	6736	6736	1617151680000	orphaned
9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	1426	1364	114	1	6301	jxEyKFgZjcnYmJHumU4NCC3M8NcHNMrHphdN5AneYWVBe9u3vyS	4781	6737	6737	1617151860000	canonical
9220	3NLc8d5TAapwJwHffYyvgRmTUCsHvW5Nmkx4crfJ4cznR1Hf6QQf	9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	1406	1393	114	1	6301	jwiHVEhQJwy2zvqy5uCcV3VfMAdDjQH1VtSte5j1NSdbJc3fJUN	4781	6737	6737	1617151860000	orphaned
9225	3NK7NosCNW594vTcTEV4NiGhgWUgESyg4rrqmfsfBAD2PPqxEnsr	9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	1587	1357	114	1	6301	jwiUstevJ9qGA4vKdkS3CLKffKjfpSAz7xcY32CyLTEu4oGfDxb	4782	6738	6738	1617152040000	orphaned
9224	3NKztvMMFkLLQq2ak69XoprBYz7FHJd59oJ91z299MU1iNY5ub5M	9221	3NKpk6pKaDFAmNVzavrkVcmTiWzb6NmMLeTu86pE36ZHN535QBj9	1406	1393	114	1	6301	jxQkJBs5s58nC6riGVHJ9m2mcZfKPp1jM7z3G6scK1wm8ofGyiq	4782	6738	6738	1617152040000	orphaned
9228	3NKsgTmShxT3MLv2qWU76cD4BRT7SjLZ6SmWkiZgDJtvvdWAkYbi	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1407	1395	114	1	6301	jwSnZiJis3JoByyHGsGsGLwcvtai1YDs3Tg83EBeW1vUKq3z7pu	4783	6739	6739	1617152220000	orphaned
9229	3NLpNe5f7C3amA7fn1y3aGNxBS3SfM6BpSjQZLiNvxJeRucAJYy9	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1564	1212	114	1	6301	jwtfi8b933H8xFAgSFLWBBVvuVbq2h5xKftBWxDY13WmYY5gnau	4783	6739	6739	1617152220000	orphaned
9234	3NKavqsvCUpwJ94nUoZhUczLARMg9tKcNmC7M5FztrHhy7jq4grm	9233	3NK9fdnpDNZ1gLLTAyX8gcu2G1Do6x2pZJYRahCgqnt3MDheFeCm	1642	1241	114	1	6301	jwWnG42fLJU2CovhEykA13utwCachVybfwKM7mCUTNeooFiMXqN	4787	6743	6743	1617152940000	canonical
9239	3NKGfRZVESfVeXHYBMFpnJEPLvoQFjrQwgVqYNFWvocbix5VYsMQ	9238	3NLeuTsQDQGXBys4tteDWbydzJp2HkXbdVj4NXM8Yf6E8MwdbDfJ	1403	786	114	1	6301	jxxHV5xYVzU5mb9U2jaaATegeeVC52KP9EiBtLiXsXPrejiwgST	4791	6748	6748	1617153840000	canonical
9242	3NL5wX9x52GZMqrwJEfiqaLeAUXWw6iT4jGxbqjjQErWUXBkc8UP	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1405	857	114	1	6301	jwSHfQpckYTXzPwBzMpZMHSQGP3s4mWpdYqYgFk3iMpa4q378Wv	4794	6751	6751	1617154380000	orphaned
14025	3NKspJokL8XAFg9qc35ZciK5vE3BWJvyXdJWb238hZC7HCDHHy1n	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	114	10	216	6301	10183	jxpk9veD79EcmjS2MQcoeHBcnt5sN38R6u1LmkBztDoyFAGXD1U	7185	10177	10177	1617771060000	orphaned
9186	3NLhAXKgNKpR7uBXoi16XXUPq6HNYQzz51zZrPbfAdQGKs6FZSGf	9185	3NKVHGXDhBzFv6PUM6EL76bFekyPpEMw4B7rJEMavjizcYVBxi6M	1407	1395	113	1	6301	jwPoj256GTZeJVBsUhJqMFHSR9T93HEVEd8grBf9VckN2rtWVhe	4762	6710	6710	1617147000000	orphaned
9191	3NLfcVAjGV7vR8zt4LAFhHmhVKHe9UoMdVwywY1XDQZMs4YuG5du	9188	3NKRFiG6Ss4qpHaG61cd52TNyM5zZNLE7RFnxwR4fnqSD3PeHmHM	1483	352	113	1	6301	jxUyEcJQthXMZASAe1LDwS6TwPMqBbvCCr73pWD3rZDSxPA1Ve9	4763	6712	6712	1617147360000	orphaned
9193	3NK4YEAghZEK8rfB2gr9k9NaxdyAgpHhU2iRfzTmAfNquiFZkmUC	9190	3NKoG9ZxADkowDUMZ3hmanFvR7zq3xXZiPHnkqFodtfEjfqtugXG	1406	1393	113	1	6301	jwyBmAQhD9TjjAqJ7norzVC79Qs5f4YQFRNUNoWY2BLZPEXHMre	4764	6713	6713	1617147540000	canonical
9200	3NKAwJ711MsCfC3wDsbRiXcftzuvX8evCD6LZEjCdMRFTfNMbGQs	9199	3NKSENjK3MqoF36kfD6rSAF9nLkuig7K8qd7ThHChsdQXqVG9Xkg	1405	861	113	1	6301	jxajPeagvQeM4iu8KeDDpA1jxdZyJb9cqxpZhKrv4SEsMt9GyWP	4769	6718	6718	1617148440000	orphaned
9206	3NK9drYacgJJKZLuyBkd5wFuBNmqAmTWRs6sNfuB8KfMsJqQAQtW	9204	3NLRbB6KPZrQmvhe4GHobWscid7CEH5B5xv33rn4gJNkjasprPRm	1650	1009	113	1	6301	jxCiPp8eyQYcpBJJf6xiHRKr7dydqfcHQNVWLnJX8frqUV9BvCr	4773	6725	6725	1617149700000	canonical
9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1451	1292	113	1	6301	jwqydbR3b1VQTwqzTayd52oFpmyWRe1RYKaci3by6RfVphpXUwk	4778	6731	6731	1617150780000	canonical
9214	3NKfuURsnn283QxghmFB7tNaxfNfQTbbL7XeR6rzoRSAXTvE34hM	9210	3NL5bpevCpb9UihrXDV1x3urMnWVyUrsEYqoJJtRZogXd5oUQrZU	1594	1326	113	1	6301	jwWJdRxv3CrE4Xwo8gfN2TH4nJwXCRQNcrUNQhqDgABniGjscFi	4778	6731	6731	1617150780000	orphaned
9217	3NLLHL2NvNyZqLu4XNb8gTTn1FTqwBrzBgJnBvbWsBm7R6uwdbQd	9212	3NKQhPYhJgxvzjrnGYfcYx4azdashoU4HKa5kSRoqVEh8i36o9mm	1601	1022	113	1	6301	jwtpZj4txqQJQuegY9hd5jjBMwnucEKd35ptJpiR6mNBVEeg7KU	4779	6734	6734	1617151320000	orphaned
9230	3NKjsY6zs6fKzL5NoNWUJqHuGV4gedKwnwnviwkNDhoHvF8qUpyH	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1474	1329	114	1	6301	jx7Do2Kcnff5cR1uVBHhhdUvg4iuPyTUrL3reLSD4hj1wGk22r3	4783	6739	6739	1617152220000	canonical
9231	3NLcXcFjb448dyqVkmjuRLVNBsvL1i8fWi1AFPr92Wwd2DQ2VDbG	9230	3NKjsY6zs6fKzL5NoNWUJqHuGV4gedKwnwnviwkNDhoHvF8qUpyH	171	1128	114	1	6301	jxeq9nv5udrUL9brubazXCVZDQaZBVFECinSkUDz3UjhYkXGgR9	4784	6740	6740	1617152400000	canonical
9232	3NKHXrSJsR4qf6pupAYjAeC3SM4r52w6fVgzWPLAvr18tqRb1fKC	9231	3NLcXcFjb448dyqVkmjuRLVNBsvL1i8fWi1AFPr92Wwd2DQ2VDbG	1518	833	114	1	6301	jxEySKGFvomP5ZH4uJ67nTBzNy5xs9JHzRcyzuk14Lwv7c12Yi3	4785	6741	6741	1617152580000	canonical
9233	3NK9fdnpDNZ1gLLTAyX8gcu2G1Do6x2pZJYRahCgqnt3MDheFeCm	9232	3NKHXrSJsR4qf6pupAYjAeC3SM4r52w6fVgzWPLAvr18tqRb1fKC	1405	849	114	1	6301	jwCf6w5zbNzf1Jp6p49PXqNwzaMdRsifqSdbtCSYLePUECrTcSE	4786	6742	6742	1617152760000	canonical
9236	3NKQ9yUxzqRDNKErzcraxQU6YQvDFrAVJyCDRmZcFhfj99J3BYeJ	9234	3NKavqsvCUpwJ94nUoZhUczLARMg9tKcNmC7M5FztrHhy7jq4grm	1406	1393	114	1	6301	jwDPfRRfCcGw4JBHs3VmFQvSZm572jMAbhNaZUBKht4wQQfY8M8	4788	6744	6744	1617153120000	orphaned
9237	3NLMW7X5ZnX7UftEfbgyx2Yyc74B1ToaVs4HfKgMBbaWthYxK88W	9235	3NLYtW21Jv28gsKs7VbMs9VuTCMxbCSf2v5d1HGEh4J67UdZL7UV	1508	1387	114	1	6301	jxUsGkV3iHvj8cnjYvFe4W4Nw5dSL7Z7dbngjNcqv9MUyJEUaK6	4789	6746	6746	1617153480000	canonical
9240	3NKPr6Vnz3kJDziBUCg9hED5bC7SVy4Mvr9aCUzWaf7Ng32jgovJ	9239	3NKGfRZVESfVeXHYBMFpnJEPLvoQFjrQwgVqYNFWvocbix5VYsMQ	1406	1393	114	1	6301	jxowNT14kbtfgmaCy31hMUU5ipQPSWJCHd1a15u7U7ENmSTL3SD	4792	6749	6749	1617154020000	canonical
9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	9240	3NKPr6Vnz3kJDziBUCg9hED5bC7SVy4Mvr9aCUzWaf7Ng32jgovJ	641	970	114	1	6301	jxZNErQXyTTeGrmnW2pir1HDt3rSWds57iicvTEyoNyrVsPmypk	4793	6750	6750	1617154200000	canonical
9245	3NKvYqYABDtnToo3Pc5PaeMx5FjhTorFNH6kVjHg2ZSMd1oDqUzx	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1477	1104	114	1	6301	jy3HM8ZpkR8qKVNFcDmxP2m1vP8WHPaYXSrSYXoJZZJs6WFv9rw	4794	6751	6751	1617154380000	canonical
9243	3NL1fwHV9nkXrAcTk4WgCvpjeGoVLNEfMwMTaFCwyv9ebFa9QvZq	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1406	1393	114	1	6301	jwvuX2GTLCpxTzpfo4jbrYGDHW6dLSW8z22tnGrCT6Lg4xjKEue	4794	6751	6751	1617154380000	orphaned
9246	3NLTjbJKtasj6BcjQ7C5vjeUDoK4vEUALuRNQqDBsWuUHWHuyD7a	9245	3NKvYqYABDtnToo3Pc5PaeMx5FjhTorFNH6kVjHg2ZSMd1oDqUzx	1672	1159	114	1	6301	jwGX7SMQ9JHZ7P8ke7AfEqaKayH3zHoGbKUtMoj7NzFyJrfDkxW	4795	6753	6753	1617154740000	canonical
9248	3NKwCoim4e4ELhGpEAoXF8w6imBvJcBoQ46mWHuss8mZr2Rk7xpv	9247	3NLn3vAVaEvckyFbeWdSHUD5baYUQYHazsAET7taLCYjJWkjKPoB	1406	1393	114	1	6301	jwYsA8JJFKPgrBXhdUP8v9W9VJfkiGBrLufF5KvG3CLNA2XcWpV	4797	6757	6757	1617155460000	canonical
9250	3NKF34hZ3uYPqya1V6CKJdweT9QypD13cb21rHV5WPnMf23mWjJM	9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	1608	1289	114	1	6301	jww7LCgHbXYrucDEgCTxo4kWnSe2zvgQcKUhQWbTpY5nDQmdBKF	4799	6762	6762	1617156360000	orphaned
9255	3NKWSdV898ZQrfvfWsuBZRaDF3CwkYEqNDVoCt4h8wVwwvXg7ZE7	9250	3NKF34hZ3uYPqya1V6CKJdweT9QypD13cb21rHV5WPnMf23mWjJM	448	1179	115	1	6301	jxjHdmwp5tdXNNmTrquasXfmJjiHim9ACufCvLJCiDgQNsgiQzC	4800	6763	6763	1617156540000	orphaned
9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	1654	1340	115	1	6301	jxyXH1BXsXjYhPzfzCiaZiuYmKDCGdRaCUAVN1LMusMUzF9mxUY	4801	6764	6764	1617156720000	canonical
9259	3NLyKPsQABRY5GxKFXVXyrRR4Cwm8om2FLZxBNQ2ppEJomSfjFnS	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	1581	778	115	1	6301	jxxZu6Wk4S7wLr364jakkWgootXC7HXyWW7rXXWzQ4WGv3puXS7	4801	6764	6764	1617156720000	orphaned
9264	3NLCEWyTgECgP9Ld2mKkoFJjRNhHDP9cYWgimEyNJtvvvyrVBd5f	9262	3NKyUPwF7Rie5qoJGFfUTrod8uXPYFERTN925ngBCeXb8iZ3jZgH	1403	40	115	1	6301	jxY1LMxxotsTQBU73zQhsD6F4LH74Fa9iCEpsgzVXvfcMgKpyNw	4804	6768	6768	1617157440000	canonical
9268	3NLGYQLMX2UVLJFVjtH3CjRxCEvoW7ux3pr6MLpfZinWDiwD21bi	9264	3NLCEWyTgECgP9Ld2mKkoFJjRNhHDP9cYWgimEyNJtvvvyrVBd5f	1579	1023	115	1	6301	jxcZobCH2T1NDJmYqn3ifvLpeSQBeCtrsRwUVFWMBdAHDNW4jXh	4805	6769	6769	1617157620000	canonical
9272	3NLbWyH3Kob8r6ZhiprqrkzxCVZHZ2t2DTZZKNv5ojsDcBR8ZGUt	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1594	960	115	1	6301	jx5amFw5UbKFF1jMxHSkBZkxoZbHB1pxcd9n8bFsWVW7ofU5eqr	4807	6773	6773	1617158340000	orphaned
9276	3NL5SBRjA8PEbgqozb5RA349wPjB6ipDcFzfBCUKZfTSaRjsKCPF	9274	3NKMD5PGDrKWHNfGo4LD2ykNTgiXcNcHvkqctjW154fxsqceeyf4	1652	949	115	1	6301	jxGa8wRg1AsTCuSZ475qkJwo6X9wK2wq3y26MjeinvBUpamtqp4	4809	6775	6775	1617158700000	orphaned
9278	3NLUZhPQVZTH9XLXDrUP7a5Uv2XYwCVoeeSPjBbHuJTHzEQ6876W	9277	3NL9R76juiYXWgi1uKCpooEpYeCk18gKECjJ56EJdzb5KHqoGUxy	1403	824	115	1	6301	jx9UmVf24tun7yNzU7KRAX1MHL18Kh8JLfvbCxHP7rAvueaNYqV	4811	6777	6777	1617159060000	canonical
14022	3NLRzVk4SXdwqJMFKSJghiw6nmumJ34obH7Ve2rwEzAjZ8uwGbRm	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	700	832	215	6301	10182	jxdAfhezCEMjWYcBGEm79nhkS7sBhiCKu3ybqrRTiKk5F2Wfdp6	7185	10177	10177	1617771060000	orphaned
9201	3NLkWFNfxJRmKbbh7vVve5mYEPvwKBkQyRQaP8Hz16UVTntuB5Yo	9199	3NKSENjK3MqoF36kfD6rSAF9nLkuig7K8qd7ThHChsdQXqVG9Xkg	1403	824	113	1	6301	jwfgjdknz1xhZjaWfJDBpac81iioXQr4KBX4X8nCbgd3TpwLGyZ	4769	6718	6718	1617148440000	canonical
9203	3NLjoNzTnTWSB1G4E2Twf9tVhqPicn3K3UsQ8NJmUmFKvpVsU7fe	9202	3NKVcbeedJ6tHUb9GAD7hucwK8vfupnTfa9KNpZPWAdjy18aV8AS	171	1008	113	1	6301	jxtvXktisEkg2bFXXHVFrwAY14R9hH3z6ciChjNA5wCiJzVxrNC	4771	6720	6720	1617148800000	canonical
9209	3NK8z2vszqRFdnVCoefnZN1b8RQfmyAR5aAN8pqBM7Y7gqQSGbUb	9208	3NLVTRP2YpyiFZ1rE7vuD84myiEBwQHxDLrppW48VWGdz9maH9mb	1460	584	113	1	6301	jxy1Uf3HWDDkVZNYizqsLDQnWy3tuver3LYXA82WhERPQChbyos	4776	6728	6728	1617150240000	canonical
9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	9215	3NKfgwKwq3qWFFMNcr6BcAzv1BkZip3m6ADtr9htfjD6WftD3TrS	42	1115	113	1	6301	jx5BQcjMEHNS1ZMua3Ct2EhVZfEAcEYiJiPBkCaxe8CeP8iHWc7	4780	6736	6736	1617151680000	canonical
9222	3NKAY7TVm8RrrksQfgfiRRtHZVztZ4udNKaK1EeE7mbqsdHU3rni	9219	3NKDdenDBQ8aGrXt3zjntTnTHt8ysoqH9VAUnYR1J1NtN9cp1t1V	1426	1364	113	1	6301	jxEyKFgZjcnYmJHumU4NCC3M8NcHNMrHphdN5AneYWVBe9u3vyS	4781	6737	6737	1617151860000	orphaned
9226	3NLqp9aV1ZvpzJvYsbCF12QZV6MH29aApMPSHhRH5w57WS1KSv7Z	9223	3NLJLQ7A56Rx7MYzQHTYCXzFDMsUXTjfpFSi1Hwq6UDgMTDHquSB	1542	1058	114	1	6301	jwDEB2d6AQfQtGDndQhwvxsfr2mswnWWbAZiMQq1eRzpi3xZbpk	4783	6739	6739	1617152220000	orphaned
9235	3NLYtW21Jv28gsKs7VbMs9VuTCMxbCSf2v5d1HGEh4J67UdZL7UV	9234	3NKavqsvCUpwJ94nUoZhUczLARMg9tKcNmC7M5FztrHhy7jq4grm	1407	1395	114	1	6301	jxhobCbrHfQCraBS5NhrttwhEVc4ue9ZXFud2r8yCfWt4yBMan4	4788	6744	6744	1617153120000	canonical
9238	3NLeuTsQDQGXBys4tteDWbydzJp2HkXbdVj4NXM8Yf6E8MwdbDfJ	9237	3NLMW7X5ZnX7UftEfbgyx2Yyc74B1ToaVs4HfKgMBbaWthYxK88W	1553	776	114	1	6301	jx9xfNirK2JoLqedZ2MWJhAJHWQiit94XMcmKCfxZzfZyvtnfYM	4790	6747	6747	1617153660000	canonical
9266	3NLFj3ZUfEuwybELECGF1A72wVFZN5mDWtCrofCzZkZYU5gvpHqM	9248	3NKwCoim4e4ELhGpEAoXF8w6imBvJcBoQ46mWHuss8mZr2Rk7xpv	1407	1395	114	1	6301	jxxECGpXGJB7EuhqNbDoiTsG6VofNWZuKDycbi6k4XTuHdhC8vd	4798	6768	6768	1617157486862	orphaned
9251	3NKPNSKcG3JM9HNWZGNTi1fokLuQ7yo1Uc1h8xExZkZVjeMGvbUK	9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	1406	1393	114	1	6301	jwNBh5BpVehcsfsztCsxxJKkJ642Z6inJbv6pTFgocrgTt4RPcg	4799	6762	6762	1617156360000	canonical
9253	3NLFaqKj77ZRY6nob4C5qp31UohLxiAqCjqnbUPXyw3zdJiDnYhx	9249	3NLmBet9nMQ44kdAMLnFaEjemfUe922PVBRc7GpPUFHCnDnENTN3	684	986	114	1	6301	jxNCwi3BmxkEyJpK2r5KCHUoGp7LhLNBfnfCzJsFwcp8cpwc1Ye	4799	6762	6762	1617156360000	orphaned
9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	9251	3NKPNSKcG3JM9HNWZGNTi1fokLuQ7yo1Uc1h8xExZkZVjeMGvbUK	448	1179	115	1	6301	jxWmDL5WNXYxpkN7SJEuRoJLyPtJzqRtzjuawqtEuEYKub7TB7h	4800	6763	6763	1617156540000	canonical
9258	3NL4HyR8ygGcBTifLznU9rdh7sUu76abXqPcmS8z4iQ2hzHcknin	9254	3NKXXC4wMq1PZ7jS3zneVNdrGzZXe9ZUeLbUbmmZNA2vyVaWoWnX	448	939	115	1	6301	jxbNZnzSdohmi2y7gMfX6go8UKQLNeEKb84C5BVYKhNG6LEECVu	4801	6764	6764	1617156720000	orphaned
9260	3NKy5u8FN6PeCjpbc5QdsWcMEz5kdfkyL7seHVL35vEHEnbkwtjX	9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	1585	1120	115	1	6301	jwUtiWgZkeK8WHowHmahz5DKzHkaYDT6Ue7uZuUqZbxCRLCe5wH	4802	6765	6765	1617156900000	canonical
9261	3NKH9dVRooWBtjb7H9CraaDP5dCUNwTeVo8PsRSpWSDZw9cSYbdV	9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	1642	1367	115	1	6301	jxsGDnoWockfceUQk6QvHc9xkJAX15BLyCNmTfXLp2nc7jfaGA7	4802	6765	6765	1617156900000	orphaned
9262	3NKyUPwF7Rie5qoJGFfUTrod8uXPYFERTN925ngBCeXb8iZ3jZgH	9260	3NKy5u8FN6PeCjpbc5QdsWcMEz5kdfkyL7seHVL35vEHEnbkwtjX	1578	1296	115	1	6301	jxnrhGBnpG7CeaAe2EfZbayiiNDPFVQEZt7494Zaj2vsdkghhTG	4803	6766	6766	1617157080000	canonical
9263	3NL8EcLdBfd6ENXzXooQiBkSodLP6pVbxhFoM4PQUjCMnPEeLcmE	9262	3NKyUPwF7Rie5qoJGFfUTrod8uXPYFERTN925ngBCeXb8iZ3jZgH	1406	1393	115	1	6301	jxwG14ae5QKJtvM1Um2dU73khY85DpjH8YMpJRrh5GHv59cPyfU	4804	6768	6768	1617157440000	orphaned
9271	3NLW5ULF9t9gpsm2VwC7aSjHycdEtjQ2v7QQ7ofnLRJckxWPZUzV	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1403	824	115	1	6301	jwnn45MYR1vnpDEngCE9aDNj338MGrd4Qh7hNGgwvH1qswAk81K	4807	6773	6773	1617158340000	canonical
9270	3NLrmCxZSz9YHjxgj73JMUVjEeG1ZR9Mf3GXoCjvmu7ptcnGtC5k	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1405	861	115	1	6301	jwEa8RFCFpx3senm7LcLErQrHeAEEa2fwKU8ZLkL35JSCt3bNuy	4807	6773	6773	1617158340000	orphaned
9273	3NLuUWwcX3AAA3GaMdQj2cnfzuTMHUnnW3vuaFzPb3csYMqe1PVQ	9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	1534	371	115	1	6301	jxJqnsrBfAh5SViMGtBdRBtr6VXTS3Vp9zfj46P7KAQmCK3jvja	4807	6773	6773	1617158340000	orphaned
9274	3NKMD5PGDrKWHNfGo4LD2ykNTgiXcNcHvkqctjW154fxsqceeyf4	9271	3NLW5ULF9t9gpsm2VwC7aSjHycdEtjQ2v7QQ7ofnLRJckxWPZUzV	1553	776	115	1	6301	jwEaXAq42hp2HoMzZzxqR5vH9xY13NLYBXXcJxnTceoRtCPaZPP	4808	6774	6774	1617158520000	canonical
9275	3NLLvx17mphvrW7MSULWsziCT5VYx9HnUvAVGcvvu6gLAv9oAtrf	9274	3NKMD5PGDrKWHNfGo4LD2ykNTgiXcNcHvkqctjW154fxsqceeyf4	1445	1290	115	1	6301	jy1hihM2DvYe4p8biuRr8YmGdiMVNBrmwnaKKUPgi4oZqvwxddw	4809	6775	6775	1617158700000	canonical
9277	3NL9R76juiYXWgi1uKCpooEpYeCk18gKECjJ56EJdzb5KHqoGUxy	9275	3NLLvx17mphvrW7MSULWsziCT5VYx9HnUvAVGcvvu6gLAv9oAtrf	1547	683	115	1	6301	jwBehGDwpbTVBYYVRMobZX8DYE1oaxY6azyhPmBUwYQxkTFKZWU	4810	6776	6776	1617158880000	canonical
9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	9278	3NLUZhPQVZTH9XLXDrUP7a5Uv2XYwCVoeeSPjBbHuJTHzEQ6876W	1555	981	115	1	6301	jwkbMAEM9oW1N53LkL2Qqrrp2rUQY4kv6jsZFyfwzyTzH2cWECW	4812	6778	6778	1617159240000	canonical
9279	3NLcyrw9YyNCjQKnhcDf6PHpAmnzGXCnG7UENuJJXfb6jfhiRTPp	9278	3NLUZhPQVZTH9XLXDrUP7a5Uv2XYwCVoeeSPjBbHuJTHzEQ6876W	1564	1338	115	1	6301	jxDv5rMYpMRpqzscuaBfexbJG7nVFchMjGq1FmAYomY7D3MdMMt	4812	6778	6778	1617159240000	orphaned
9282	3NKVWhytagL94vG3x57VgfSfDmyrJvMCY1p66cYsThViSXVt3jrW	9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	1619	1275	115	1	6301	jxuyCTUQmvVW18NzWANDEKfhV5TepSGAnzrZ4USPHiK6EdJ5p4P	4813	6779	6779	1617159420000	orphaned
9284	3NK3jSaoBCmEviPVEW4jHuy2nmh6MRHq8rncNZWYBtwLobXRZ6og	9283	3NK496P6nDwe2HHUAXPd79swag7qXQhQGKjnGBhRWYfHwZkwyrPN	1549	1236	116	1	6301	jxXS631XqDSx8GpUVe1Az7RsdA3zwzWWPPmyt6B5miu7Zz9pJW4	4814	6780	6780	1617159600000	canonical
9286	3NKcZpSQfqAgpYaygLyupr27QoUm2haRBCyfJ66e5f8PUrFNaekx	9284	3NK3jSaoBCmEviPVEW4jHuy2nmh6MRHq8rncNZWYBtwLobXRZ6og	1406	1393	116	1	6301	jw9t6Lwk437FTncaJkyFREDvihxDEfDiVzQiGfCyR2CQoXEq4y3	4815	6781	6781	1617159780000	canonical
9287	3NLHaTRadCerw5sKABR4627aNhMb4kWuZho6DvwgJkbwuT4eFNCY	9286	3NKcZpSQfqAgpYaygLyupr27QoUm2haRBCyfJ66e5f8PUrFNaekx	1596	997	116	1	6301	jx1SkiL21dsXvKF6PT8Ph5WvQ2uwUQf1Zos2R32zD6V1oUTgboj	4816	6782	6782	1617159960000	canonical
14026	3NLS4EoVJE1gfZkhdQx6GyoQK9dspvfuDFsgkYFJwPuMS49jK4Pt	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1634	1331	216	6301	10180	jwUBpPSMUnryevUpNWnFXrAJT69vT64MC5nZUHfXQTd9Dic1uoG	7185	10177	10177	1617771060000	orphaned
14023	3NK8mxPy5rH5g87PXH6Q4chmXiwrPkHNgx16XyYSa9wGL6aBtZMw	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1444	1381	215	6301	10181	jxMgGU21ehvcxcB4bfgBF12uQwze7PnCayKNPy7hNTcwj37dGgt	7185	10177	10177	1617771060000	orphaned
9244	3NKMzrzoXL8AAPAAD8tF8xzjjgpRGLkF7Y1W3NLXBV16WPSjHqms	9241	3NKGwV4on168v2Vm1d2AtFZHyzyGnPTa8KKYSQLJuRGwy1PHYwwb	1553	776	114	1	6301	jxZgjXp4f1zQkvS5piXxkJoUfwD2tiiutWCQncrAT8BJAsJXs4o	4794	6751	6751	1617154380000	orphaned
9247	3NLn3vAVaEvckyFbeWdSHUD5baYUQYHazsAET7taLCYjJWkjKPoB	9246	3NLTjbJKtasj6BcjQ7C5vjeUDoK4vEUALuRNQqDBsWuUHWHuyD7a	1407	1395	114	1	6301	jy2jzNv1uF3z5mRYN2ZY4raJowHtMQiaAtGS4ujXqDPH2KMkaNc	4796	6756	6756	1617155280000	canonical
9265	3NL3oE38XuSN3HXXF5UmfYn2Xrj2BJVtyY78GcCiAdhT3kGg7coS	9246	3NLTjbJKtasj6BcjQ7C5vjeUDoK4vEUALuRNQqDBsWuUHWHuyD7a	1407	1395	114	1	6301	jxX5aMd9jA78PjpDpahoSRBbyT2UfsPdKR3yD1MXQRxmb9dx3Ax	4796	6768	6768	1617157440000	orphaned
9267	3NLWKhhn5tEx5zAX7pPf3WC8ALebe8evktD4LyRZ8mxu72JVvgQb	9257	3NKbozvDSmLEiuTofxkyud8BxCHZvhBz7tM788dTm1Q3zCjsqzqX	1407	1395	115	1	6301	jxjhRBtSPPSahPcJU4vEWpE7biD2GnYo8Ne6j1CgZ7QoSfWabJv	4802	6768	6768	1617157544783	orphaned
9269	3NKCBLZsTnNrSYFH4WgPuyE8UKcvQfoZfTiGvu5AexVa2FBSLsTH	9268	3NLGYQLMX2UVLJFVjtH3CjRxCEvoW7ux3pr6MLpfZinWDiwD21bi	1581	778	115	1	6301	jwDUFgbfnEVrevicTHMwkeDbugYGWrrDA3gyFy4ZqRgohQdtwpX	4806	6771	6771	1617157980000	canonical
9283	3NK496P6nDwe2HHUAXPd79swag7qXQhQGKjnGBhRWYfHwZkwyrPN	9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	1619	1275	115	1	6301	jxuyCTUQmvVW18NzWANDEKfhV5TepSGAnzrZ4USPHiK6EdJ5p4P	4813	6779	6779	1617159420000	canonical
9281	3NLgDgb8VSsZ1GpGZwjacbKZt7aW368X2ZcsujXiQV3c1JmYvYkc	9280	3NLeksSxQjLdD2CmfMpQSvCNAxaa6VikeGd7wcV7v5qPWoMMLmzp	1619	1275	115	1	6301	jxDgop7WtejeLz1RbmJnYw3fHRtWTcDgkU7FEedMYDwPmANfY3z	4813	6779	6779	1617159420000	orphaned
9288	3NKhbriFG9DAcNLzeQ5iNz79yxVkSpffT12YumfPrj5ADuR7gdEo	9287	3NLHaTRadCerw5sKABR4627aNhMb4kWuZho6DvwgJkbwuT4eFNCY	1579	1263	116	1	6301	jwPZxNiaFU3GTzu7coP4zVkioBG1RnxZafZsK9GyfCxmS8TkndR	4817	6783	6783	1617160140000	canonical
9289	3NLxeSMEHtA2Htf3TuxDUddbuY4NHN1S6bmridzAAV1FfoHezxJd	9288	3NKhbriFG9DAcNLzeQ5iNz79yxVkSpffT12YumfPrj5ADuR7gdEo	1405	849	116	1	6301	jwcBMcxhw6vUbBQuo2K4uikt5BshoQRtsx6neNXKds7jrCzTv2u	4818	6784	6784	1617160320000	orphaned
9292	3NKx5gpXhXGB5UcGK2EXUKpp8JkJYdmUs8Vd9CQEKm43imQBiARy	9290	3NKMRBd3GwniA3RyKXTo8ZPpXBfBdBi9CNvhYkM5yJGZyaixdBUs	1650	1375	116	1	6301	jwt2AuWJS7ThRfsquMBeM5ia3oZHMqh2Vrpyyy2BnkLXQ8dQJs8	4819	6786	6786	1617160680000	canonical
9293	3NLExPmWJZoX8ZEPextmEK3zidqvH5TffVpZuNs2gzW1URuTRKXa	9292	3NKx5gpXhXGB5UcGK2EXUKpp8JkJYdmUs8Vd9CQEKm43imQBiARy	1444	1135	116	1	6301	jxyy82Cvdyj7Q4YRgAsJFMWzstcjrFSrViWJpV7eahkc7pZFYAF	4820	6787	6787	1617160860000	canonical
9295	3NLmJCCr5kCZ8443mJwZcos13yDdBxEQBokxVf9YJL1UuXFk6wUJ	9293	3NLExPmWJZoX8ZEPextmEK3zidqvH5TffVpZuNs2gzW1URuTRKXa	1601	1388	116	1	6301	jxrDatqWgt9LSHFGk2Nv9TY9PigR9fzxajResqHPTPm342UdSXF	4821	6788	6788	1617161040000	canonical
9294	3NKaffUMdzy5VQzEuS5wTpyAATtvDML1dEzAXhcUuctcVYnNEaB6	9293	3NLExPmWJZoX8ZEPextmEK3zidqvH5TffVpZuNs2gzW1URuTRKXa	298	1182	116	1	6301	jwhbtkXJdVW1VpCeB2ntAeMWBYhi7RNEB5F85fU3Heov7zHSBNq	4821	6788	6788	1617161040000	orphaned
9296	3NLb7hvN4yMG9KbyHoeUc18q35qX4c9HRivMFxWsPxMPBN6qBFsq	9295	3NLmJCCr5kCZ8443mJwZcos13yDdBxEQBokxVf9YJL1UuXFk6wUJ	1419	814	116	1	6301	jxKXhZBzfTmSChe6B2iUXNaEaUCkNZqRocwoe8MjqjnPcFZKxSm	4822	6789	6789	1617161220000	canonical
9297	3NL9E8oJQtALkjyt45EcRYSfTQgN6fddbprcSvwgDX2mBEb1NUKR	9296	3NLb7hvN4yMG9KbyHoeUc18q35qX4c9HRivMFxWsPxMPBN6qBFsq	1590	1054	116	1	6301	jxWvMoH9Qt8njExXF2cgp13VgU5uAyHyAR31N5PxUycDcYw5u8B	4823	6790	6790	1617161400000	canonical
9298	3NL32KbLEVM6xqcavLGD2JL2HcJtJY2D16m83qCSMjHMCRPYjYMb	9297	3NL9E8oJQtALkjyt45EcRYSfTQgN6fddbprcSvwgDX2mBEb1NUKR	1670	1156	116	1	6301	jwy8mnUHjbQiaSFuMYABKw523bByxXoFFEJRtRuvPz4zJMxirUj	4824	6791	6791	1617161580000	canonical
9299	3NKmYXxjn5JThWDLTLDNnczXAumXNs4DsATJuzsLEzASP7vG7hYg	9297	3NL9E8oJQtALkjyt45EcRYSfTQgN6fddbprcSvwgDX2mBEb1NUKR	1419	814	116	1	6301	jxyDFWe4y9SLhagKRSwp7QjLDpL81gcBPfJkmGpwAwKcU35URPQ	4824	6791	6791	1617161580000	orphaned
9300	3NKSZTSkCmJoWd5Mkv4CrrhyFAMt4udQoir43hEdfoGuujGb86ii	9298	3NL32KbLEVM6xqcavLGD2JL2HcJtJY2D16m83qCSMjHMCRPYjYMb	1460	474	116	1	6301	jxA8rdmwDGhFjazkW8UTG5DWBijYnLt1qDbCTpkyYHEuoHPcgVT	4825	6792	6792	1617161760000	canonical
9301	3NK9k8NXAw9NyCCA7ycPds2KpT8YQ3drHH5pu1vz9XTmxviKhb2a	9300	3NKSZTSkCmJoWd5Mkv4CrrhyFAMt4udQoir43hEdfoGuujGb86ii	1599	1287	116	1	6301	jwZvGiAQDVXp7Ct84RDxdwkWZFcVwzbU7uGFaJkYSkPR85UP2W1	4826	6795	6795	1617162300000	canonical
9303	3NKRTQndstxsVdgUz8cFF3FWgeArtrRnDfyZmfdeN3AoardHxQyL	9301	3NK9k8NXAw9NyCCA7ycPds2KpT8YQ3drHH5pu1vz9XTmxviKhb2a	1476	1125	116	1	6301	jwYewHskz4Nte8knwxKFDo81dhs1f8Ps6GHfaVkofcMCHEY2E7T	4827	6796	6796	1617162480000	canonical
9302	3NLc6Xm5BeU5qw31LzZxukt1jmzmnskKE8sGdEMDEjNisJsF7imN	9301	3NK9k8NXAw9NyCCA7ycPds2KpT8YQ3drHH5pu1vz9XTmxviKhb2a	1483	6	116	1	6301	jx4e5NmWYNiK3UeKwyZXbowoT5uFFBVo5HWNxy4wBGWxWuHh46H	4827	6796	6796	1617162480000	orphaned
9305	3NKCLFYiSEW1DoU4cx5gHb9bh3cAqcYVwTgJRVv9HAtKmF4Evcw3	9303	3NKRTQndstxsVdgUz8cFF3FWgeArtrRnDfyZmfdeN3AoardHxQyL	1643	933	116	1	6301	jwHB8DbDHGm1D7FGL3NN5Tu1hTjJogR4sNUvGbmjBG8Gv8XVaRe	4828	6800	6800	1617163200000	canonical
9304	3NKGq4kW77C8hpWW7osggByKuE7faCui2Jjjzzbi394kXZv4e97h	9303	3NKRTQndstxsVdgUz8cFF3FWgeArtrRnDfyZmfdeN3AoardHxQyL	1501	1360	116	1	6301	jxfo5WkwqMgtKCdzD5xtrXXRoPinsBVjQbHn4pLftRraP9nPpDj	4828	6800	6800	1617163200000	orphaned
9306	3NKBE84JDcyymD39Ke8wjE7N9dwnzBWR6kWGHuGaabQBUadukQx3	9305	3NKCLFYiSEW1DoU4cx5gHb9bh3cAqcYVwTgJRVv9HAtKmF4Evcw3	1607	982	116	1	6301	jxg5XW3CwywWUcibZbqWQBnUr1RNmwiD7yhJvj2X2qMusp6oBFR	4829	6802	6802	1617163560000	canonical
9307	3NKxEq44mBaaaFuK4QpQTQsY6YmxUjpvCod2WQRLNaYeurCEokyM	9305	3NKCLFYiSEW1DoU4cx5gHb9bh3cAqcYVwTgJRVv9HAtKmF4Evcw3	563	1113	116	1	6301	jwX25YM8ZTApjwwfGSecw9w2m1dZ5XSMuMdkXraRBQPuLwm9pGu	4829	6802	6802	1617163560000	orphaned
9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	9306	3NKBE84JDcyymD39Ke8wjE7N9dwnzBWR6kWGHuGaabQBUadukQx3	1534	638	116	1	6301	jwagNNqq2xvSwRbeqEE4uyVsXfnfBURMEgxabJ6Mcdw9AsJP2if	4830	6804	6804	1617163920000	canonical
9308	3NLrMHhBwRdcD9LoaMAQAQXtNibzmPQWSRH98P644WZfAuQkM4D4	9306	3NKBE84JDcyymD39Ke8wjE7N9dwnzBWR6kWGHuGaabQBUadukQx3	1490	1274	116	1	6301	jwfHGbfCCJ6mcv2tuJhuc2snHUfvH8XBsW7KFKZoL84jeni4pSV	4830	6804	6804	1617163920000	orphaned
9310	3NLZX2xzKjfH11BLwg7WDRvXxnzN7HwsmyobNgxexRVRue2UtZNf	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1483	84	116	1	6301	jwXoTbRQzbyY1Ln86vLD3GaVYnCYGJtGeuQSLjnQJVVai1u2XQQ	4831	6805	6805	1617164100000	orphaned
14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	43	1310	216	6301	10187	jwM6FM1hKmK1YPEWgtUvNAnvhENRtLhAEZ7x3tzqni29tuUbcXf	7188	10180	10180	1617771600000	canonical
9361	3NL3KzYTYxidPdn1xb6qD3VQQvfAiNEhJVpeMyu8ZF5xDZoqnfMb	9041	3NLcNRsNtEtshGeVK7PhkS4CYc8VjSP6tYuXVr2XvGi626GHsBYN	1403	824	110	1	6301	jxspiuxeTzKsm7TvPv5WLDQxr6M3WDW5ZKdawxqtdJdft39YXrU	4689	6839	6839	1617170324557	orphaned
9314	3NLX6aX8yKeeG3UH8EWYS9vqqPTYEVxwK7xQnbnZ7kfoNtL2Nqzi	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1440	1131	116	1	6301	jxCW9mqRYfwrjhCFq7CKn3RVmwnHtLeP2xtc9MMBsv4ocY1jfFK	4831	6805	6805	1617164100000	canonical
9313	3NLgdepVKoL3byF72tfpUNpVwfv1R91SsEcq4AKCQMbgfD5X9Kp6	9309	3NLELewPU1ocHGz5Ho7PCDFotCd6zomWK8VFgZLw3bXf2mc6LpLw	1631	794	116	1	6301	jx9dmbQng55er3wLytqdQ7qihGPmvUx2cxiuaubxUEpEt2YUyB7	4831	6805	6805	1617164100000	orphaned
9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	9314	3NLX6aX8yKeeG3UH8EWYS9vqqPTYEVxwK7xQnbnZ7kfoNtL2Nqzi	43	1184	116	1	6301	jwAtkWyHVeeoft2rqFTU7a9z5jcyp9Ta2sRFcr7dX1ttZzLtREh	4832	6806	6806	1617164280000	canonical
9315	3NKeTnDb59HiALqFDpJRNw3GW9an9WXkjTHES2rpVFYvmUwmn9KM	9314	3NLX6aX8yKeeG3UH8EWYS9vqqPTYEVxwK7xQnbnZ7kfoNtL2Nqzi	1403	812	116	1	6301	jw7v9iidAaVXSUE5W4WxJxGTky8UcDz51VB4kXG41Ah6EVGQwNK	4832	6806	6806	1617164280000	orphaned
9319	3NKSq2BRpUWn2RGqzwa8zXL36eq9BQ8jqGzVNJsPZbr4L3ki4Rek	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1403	782	116	1	6301	jxpSraN9WdW4XN86HPCc7Nkq4tcFz2Y5onrDgCRnf5MCTjUgbwS	4833	6807	6807	1617164460000	canonical
9330	3NKGnC2e3KxFh8yixHLt1vLUmf5yzdChQWVDLxfupgPcrPLC4Qso	9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	1652	1189	117	1	6301	jx8zkSC82eDb4PRp9M1mnJsPeLzkW5cHTVLmzZEtUJ22UtqGM31	4839	6818	6818	1617166440000	canonical
9332	3NKD2duNMwZMg9UUyPwcmjkBpunC1tQ1q1ESdeG87wMWiSs1oPgj	9331	3NKkw9iidZ558Y2vPU7cmwCzKdZ7W15dVy4DoeSgJUH6gxKz8Zwb	44	1325	117	1	6301	jwEpz4YdBospdd8yY4fgawf6Vxek2jZV9EHzonnkL6cDodq6oxz	4841	6820	6820	1617166800000	canonical
9338	3NLVdzcFP5GnLsLrzfXWY4cwN1ApjfbSMngAt27XaFZUnJadwLzN	9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	149	1283	117	1	6301	jxq55pT6duWGQa55QW6oERJjAeE4Ny4FvjERrB1fWyazyCUaX8r	4845	6826	6826	1617167880000	orphaned
9423	3NL95rqTta9ytBX8hFyXtX9nke2H5zvRF7wb7MgejLrzKuNDmhdV	9339	3NL8aw2TwRY2sgd7FSfky1VbcTATzAGvad4VZnLUf1c1TEnLaibU	1536	1067	117	1	6301	jwkgx4CWEzRRxYkHyS8QFwTByH9nPhqXRM9pc1qcRiB3GovniaP	4847	6886	6886	1617178797600	orphaned
9343	3NKxMED7VAuQjepeowYMGDjcynuvPLFk6qo3fiwyWZLX9dSwHYMs	9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	532	1303	117	1	6301	jwU8pdabtH8aZYqWvcFWc39TNb2Tmn3BQQpgzYWe3Gyuvvgh2Xx	4848	6829	6829	1617168420000	orphaned
9347	3NK8hio2z3Rw3fXWq88mKmuLxb3wXPth6kxzmoKhkbaPwfpVhku4	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1406	1393	117	1	6301	jwLS6gW3NPTbacWcEh7VrXSRmkMjB6Rd64wemGGwddYN8GSJ8yS	4850	6831	6831	1617168780000	canonical
9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	9349	3NKXEDEHrFyqnw5h8witucJUEg13fWgK8vXt7BrAUxricWymMqWu	1406	1393	117	1	6301	jxCKqn7Wa7ChBqUUgsi3oUEXrHFtfZiXgtHzzHyQDXxaBL6LQqc	4852	6835	6835	1617169500000	canonical
9352	3NLJ32n7gcAbzLBz1PNCc2L4HVQDuNipLYEifcCHAY7uDqQmpSaT	9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	1422	1211	117	1	6301	jx28DQsRmy74ZHtYTcnwoxjzGzNNkdvXrDCrD9KNg2cKr8tYkT1	4853	6836	6836	1617169680000	canonical
9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	9358	3NL78w7jWqWuEtQKb2UkeZUsxdGGyL8FUj4pQLs5pkaMUUb2SfD7	1623	829	117	1	6301	jw8fugKr5qeJwSduhmVLADCPxtmprQyjsEub8GfehRzjrdfc47g	4857	6840	6840	1617170400000	canonical
9368	3NK3a7N7GibHSq19PRkC1PEEHMz4B72q8KeYmRnhCpPefWED7QkM	9366	3NKMnfw1exHUFFFeojeQhsoNE2hSsSGVbKT6Ns7noZNTLpyYQHJ2	1406	1393	117	1	6301	jwwmvsj7hThPtrcHQf32mPxHQ3CGYxs6o5HQrQZyALNERdSv1Hx	4859	6842	6842	1617170760000	orphaned
9370	3NKmw5nXUK7eA1YiCh6xTVPChHa98nc2aVJyFyeQGAm8knQqxanX	9369	3NLhaVyMGexQ3c9ZXfxyroGWFmmT9Np6e982LtH6f7nDgKwiGPw4	1577	1327	117	1	6301	jwWVpWWoAo7BLq21SqqxZwikut9YDNn2EbhaDD9eGcSQukxa68n	4861	6844	6844	1617171120000	canonical
9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	9375	3NKddKDHgcBPbYJ6oohsdgcRuNMBU6SYQAkRKKQckW6pFXUhG79J	1407	1395	117	1	6301	jwDwpn1gX9BycioVpTsYnhn26a2G21k6wrtroemNVZPfPnsvR5W	4865	6848	6848	1617171840000	canonical
9380	3NLdsnKFYKhnJa4XhY49Cavwppgb19sERJha9NEbxETzBHa23kg5	9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	1406	1393	117	1	6301	jwKgHJ3yCuNKx1wTGrZjWrMrWqBnmMfD49UjLoWZYrpUJeKmqYk	4866	6850	6850	1617172200000	orphaned
9382	3NKkeDxQKcEKQLk5ERwDQ5Zu7StUNn7R5K2mDk4ajpqg1HgJRsWp	9379	3NLh6CvH7pjioJNSWjMET4J7oRpeJYFw2k7HxZPP91UVPH3M8dqE	1403	824	117	1	6301	jwWzam1sEWRHEMHbjMHf8BzpsXiAfjXYRra8ztYR4k7fK1B9CdF	4867	6851	6851	1617172380000	orphaned
9386	3NLN8LvaAXUNB6aWZXJWgtGxYFWJw7tmkMHxXvt7g81gfgRukecJ	9383	3NLQV4mKPCwoFktGj731Mh4iVLwhfnAnKnfP4C1N31q8zprcBchR	1445	1044	118	1	6301	jxhmSxrZaFvgXRfb4npVBsrjmoFDSQ4u1Ys8rDd5ZUhrtSSxaHD	4868	6852	6852	1617172560000	canonical
9389	3NLPvZnZyVj69Ji8fP4rF5E9X3SqxU3q5YEaPNfuchfxkmReKp7i	9387	3NLQRCJ2tCw5XiGE7irZZ3L9wjvQaeir1FeWS9EDMhsUZwFhSJJd	1406	1393	118	1	6301	jxH2BGWVkrw4SEKYj2xc5pXLMJDjBYpcQuEx8taFckXqY95UhAm	4870	6855	6855	1617173100000	canonical
9394	3NLJ4soJmYsyubopz4Y49wugG3FXRJEdvtjpzQBbSwC4Gd2zzuvR	9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	1481	790	118	1	6301	jxFUD3JCcqgjURG368n3BgPJn3AE8jnqutMdEoofSesbMRrAfbX	4873	6860	6860	1617174000000	canonical
9392	3NLxYbbJEeaB7W415RPL6BoHwCnPzU6mmtoyWDk4QA1vxExZF3kx	9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	1642	1121	118	1	6301	jwGpyFmi1gc7H5pPyDD4ZmLSXhLpQPS4y8iztkYqjN9ZirHo5TS	4873	6860	6860	1617174000000	orphaned
9398	3NKYEjLGDD6fBaYcrxM7quAr4SRzw7bGrFJ9gC6j1Jj89NSJFMgG	9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	152	1084	118	1	6301	jwB4s4iXYLyvx3nxYEwa11Luz6PHrT6pFTmg9vXQFT3aEPLGLfx	4876	6865	6865	1617174900000	orphaned
9400	3NLnS6wjJYg3vYKbYq7sXLHZeNAx4SzTWuCysfznhxFL6T6pdE4L	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1403	824	118	1	6301	jwjExbth1e4dteAo1YdErxKPAu4VGm3EML1TppaPZuMWqAgNU1N	4877	6867	6867	1617175260000	orphaned
9406	3NKDQ1yFEqzGg8kJr719Hee41JXZGbZH4jLTnueVoG47XAwbpWnZ	9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	1600	1372	118	1	6301	jwkkfmJ7ffnVgQ4Q5xj4wW9Go4d1PRaaqBVGht3NAzXXCFmJyQg	4880	6873	6873	1617176340000	canonical
9408	3NKR5hsAJe5D7wcTBpHgm5Xo3xstx6vGi527KnGBz8jcTLqN6pHV	9407	3NL3nnRYJeWAchnv6EqpPzw4AcSP18W6YY3xSxfVRjX3H7xSAmoq	1547	683	118	1	6301	jxofVxfEZAXeZAqJn4R6TazKe8HMu1J8rZXQSshvaBGJqZ2PDYp	4882	6875	6875	1617176700000	canonical
9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	9408	3NKR5hsAJe5D7wcTBpHgm5Xo3xstx6vGi527KnGBz8jcTLqN6pHV	1406	1393	118	1	6301	jwB8ub5U1toxBHiBx7p23wJmQtAFeMPhYXrV6UKhyFYCCA9Z8dj	4883	6879	6879	1617177420000	canonical
14348	3NKwEkfPYW4htZjqJQ2pjkfJjjzitcRkhu4GkjcYcKvZcVSsEg9m	14040	3NKaZNFGFeEcn7eDqA7nQUV6tdDmv2DFJpahfEJRKwhD6ESTDFpU	369	1312	216	6301	10458	jxHb7gjZDgmyqX6wiDH7ywSp1d8iqECqBdoH7r2DRkE7hQSSNWa	7192	10362	10362	1617804360000	orphaned
9384	3NKdxxnBaQV46BMkC1UEEPVsx6CdZE2ybZiYtNhCfSRPAJnjGKdL	9252	3NK5XU8tTEX3gHufSQ1dXcjtf17hTJA3Sd4weoAvpbgANkiiQGZ3	684	1106	113	1	6301	jx5HDAVZWTcZLyPfXoQjrWSamUDP9mT1f54MVAxJcQZxun1YDTT	4750	6851	6851	1617172380000	orphaned
9317	3NL7ELkZkhWJUCbiRcSn7ZGkJcJrnJaEif7vipLu9e77Ma5xoEAK	9316	3NLJ6FFK8csN51Bfy7CKPrhyt46LXG1ShaBzqMrWCoa8rQcQyS4L	1542	1178	116	1	6301	jwL6c4jRtRP9RwLLfrvjCgJoPjcB33jjAXyuvwYC5hvUmfSXFK9	4833	6807	6807	1617164460000	orphaned
9322	3NLiVe7XvCjzNcnofi1BugjF6ys2zpgWN5RLucvxsuVNfqvmxAbz	9319	3NKSq2BRpUWn2RGqzwa8zXL36eq9BQ8jqGzVNJsPZbr4L3ki4Rek	1406	1393	116	1	6301	jxngFnCQsqCR88Fs7ykhDxfMgmfdRTVw1wf1WvGa4hHJfW4BPjG	4834	6810	6810	1617165000000	canonical
9324	3NLhDUbDB2FTGwN6TkZo8CCMEeEixgLo1MBFsZyMGwLzb5Znr51E	9323	3NLifRLwNMUjmJT7yoLSbSSEjFFfSfAkRmENeNRtAt4KALxFhBpF	1579	1143	116	1	6301	jww3bJodLtGAGrVTdapurSbBmn8jtGnyLJr8nzDGsdQFQAWXTrM	4836	6813	6813	1617165540000	canonical
9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	9326	3NK7UmkkofTR7zjnErnr4XDZq3HDpuLr5MikXu9Tqx6CFncC6Bi1	1553	776	116	1	6301	jwkHXKJ7PuXDEch5toxDyowu7c1zWgaYERt21npY9ghBmZpNjiC	4838	6817	6817	1617166260000	canonical
9335	3NLseBG1UnaWrtRUJo36cyuBqABR7wv8iLeNqT4GARgnqBqcWdma	9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	1403	792	117	1	6301	jxJu1bnnNL9qwyhC9ezidxuN6hsenoEzztmgB7ya8quHeikfqFM	4843	6824	6824	1617167520000	orphaned
9337	3NKGv6cbRfax2b2XLzebPKbFRBRz8npTK87Eo2yAvdJiDUW3PTDg	9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	1406	1393	117	1	6301	jwvcVp4E14n7LBrLhcSykxogDUdCz3WnHpWMYYYm5JMZycpiQ3f	4845	6826	6826	1617167880000	canonical
9422	3NKLpCQwVLsoc8PdhvgLcR4nrcwGCRV2LB36W8aRhvTo16wJfAtc	9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	1536	1067	117	1	6301	jwJUWGwTA6T8JcoTUyH1YU9QGQJgmDtQhZx3M1Jq8idWkbvrku2	4845	6886	6886	1617178759054	orphaned
9340	3NLmzjzBvrBEDF25X12t3ztGE9HRbuh91KXP68BqLegHey5ViV8c	9337	3NKGv6cbRfax2b2XLzebPKbFRBRz8npTK87Eo2yAvdJiDUW3PTDg	1451	1292	117	1	6301	jx9g1cyXXrU5K137dmtaz4dBCpiLqU3LhCt9oeNeitKen4eWhEK	4846	6827	6827	1617168060000	orphaned
9342	3NKKv4etg5dgJ9QbgGWNabJaRDVjgbW6FapjDNwzQqoMBvUySv8M	9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	1672	1159	117	1	6301	jxasHDEVoEmTtJ2mnYK1mRt15BLLGSKrJCvnDvcKKwuNCXVpoNe	4848	6829	6829	1617168420000	orphaned
9349	3NKXEDEHrFyqnw5h8witucJUEg13fWgK8vXt7BrAUxricWymMqWu	9347	3NK8hio2z3Rw3fXWq88mKmuLxb3wXPth6kxzmoKhkbaPwfpVhku4	1623	839	117	1	6301	jwMuZs4cp9BQDHzFMSy9GDdhFn3uRfiBxoS49BKskeYK8p6L7Hn	4851	6834	6834	1617169320000	canonical
9354	3NL54jJZxcNsKLeT8cXPwu4awpM4m2UCTMnXoUQuZo6E72kQfUtS	9352	3NLJ32n7gcAbzLBz1PNCc2L4HVQDuNipLYEifcCHAY7uDqQmpSaT	1581	778	117	1	6301	jwoWTYbvV7RJeUb765XGgoDFJDFw7dc3ubKX3TmnGjokjQtudUp	4854	6837	6837	1617169860000	canonical
9366	3NKMnfw1exHUFFFeojeQhsoNE2hSsSGVbKT6Ns7noZNTLpyYQHJ2	9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	1609	1333	117	1	6301	jwhMADabbbak4K8jFw3VSyebuVPKsvMcra8trWwLrJ8zRxtda6Q	4858	6841	6841	1617170580000	canonical
9367	3NLbdjUaMVXm5z266jzgzS7PsyhAihxJSStqAhguF1XaACr3hBJw	9366	3NKMnfw1exHUFFFeojeQhsoNE2hSsSGVbKT6Ns7noZNTLpyYQHJ2	1613	1103	117	1	6301	jxjezrnrZgTrBFNPoRsEei7Zgn82iSbcekW4TUhGF6Qh6vyx7vz	4859	6842	6842	1617170760000	canonical
9372	3NLiepWgqB6XDXQmURCUAGXX5JaeKc9BCFevgWy8iBGKDTczaRkK	9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	1403	812	117	1	6301	jwAnthCkJVcduHaajnaw3rvsvbyhBmqANqRVTH9sPSy9EDMnGM2	4863	6846	6846	1617171480000	orphaned
9375	3NKddKDHgcBPbYJ6oohsdgcRuNMBU6SYQAkRKKQckW6pFXUhG79J	9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	1646	988	117	1	6301	jwKgCYHq7AW4LFuFBHdcAfPnrcX1BPuecRms24Hqqn9SzRcc1s8	4864	6847	6847	1617171660000	canonical
9379	3NLh6CvH7pjioJNSWjMET4J7oRpeJYFw2k7HxZPP91UVPH3M8dqE	9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	369	1066	117	1	6301	jxwDv9qE1rPpwFkTbZwoUz5LYT9hMmkKVSEDrmZoWVcZNcgShNC	4866	6850	6850	1617172200000	canonical
9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	9390	3NKaTyeASLSr3KT5TRY7qrFhyudsuxJYMpFoTQbh3jwvDatL27Ee	1529	1190	118	1	6301	jxKK5WXiu4kbZXw6qPY2UhykMscQY4ZdwSddLLJ9srC7RNVJx2q	4872	6858	6858	1617173640000	canonical
9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	1426	1238	118	1	6301	jwZhhbHrW7jXgRV2QJGuqycaaDs8w8qWJXneWje2QJBEZTL4fLf	4876	6865	6865	1617174900000	canonical
9397	3NLtGFznXrzVGXqpoHdgq2eBALz19BssHsQSshk5GXgJvWk5LVZc	9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	1407	1395	118	1	6301	jwzvSU4KjUuYJPYVY14nxC9wGebLmkSBVVBfM7zWHb6rbKGUrdJ	4876	6865	6865	1617174900000	orphaned
9402	3NLvnFzpUPSyVbriuVFgP8zFHb2gqucDF56uULg3FRmB54f9Fhf9	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1481	790	118	1	6301	jy1ACuHfv5Bu8Hj5cobDBJa3ZACsDAdm9BFopuE8GxQB5WTAV28	4877	6867	6867	1617175260000	orphaned
9405	3NLkj8b9qmJc35NN7taoygvq5XaqXPufrM46igxRuAqyrXryYjEj	9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	1623	830	118	1	6301	jwjEifrBEqHrMyPzvBSdYiqFRFNKguY4U8ks3SJMDdps9nthUPv	4880	6873	6873	1617176340000	orphaned
9407	3NL3nnRYJeWAchnv6EqpPzw4AcSP18W6YY3xSxfVRjX3H7xSAmoq	9406	3NKDQ1yFEqzGg8kJr719Hee41JXZGbZH4jLTnueVoG47XAwbpWnZ	1406	1393	118	1	6301	jwdVjZywKou9FXuHkvXhmMEfppiTcog5mxxDRLZmF77Y2ttLqn7	4881	6874	6874	1617176520000	canonical
9411	3NKj9AwN4Xabh4QR3SvXwvvmn7auURoe32aRySRoRoTCFwqQXdqG	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	1553	776	118	1	6301	jxom3P7wnUAoh2Gg8rzXorZFgZJxar6nnQKfLstHkbF3Ut9k21D	4884	6880	6880	1617177600000	orphaned
9418	3NLa6bedE3yQ7N7icWXVyjFx9uqXSn64R2ZVNLGK3Xdcg8GsFoPq	9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	1581	778	118	1	6301	jwh4Sj1wCbdFQXmAKPe9nJwjvj2smB5RLNXDi8oAaWnG3uQzcTz	4887	6885	6885	1617178500000	orphaned
9427	3NLRW8ck5raT3uuJdtW3HCh79e2t3XfHHitF7EVVHViwqKjEzRhn	9424	3NKrxzX8nN1FYtWBq83aToSK6HWruxy4FT9KgyWBZCXcHeTR49CE	1625	161	118	1	6301	jwZHyvbiAoCYZF3Jf8DRLkzYaBKNjJoGmv5RJgSiZchisQLbmmg	4890	6892	6892	1617179760000	orphaned
9429	3NKak1HxPZBNogDFs4LpBrCf9nH3W9prjJ66PTxa1Q2SGwLQ6fRp	9426	3NKvnsDYmT5n25TH9VcNv3rDvDHB8Zj8eckYeHs5ewacJmxckgY2	1625	161	119	1	6301	jxCR6wnWgBcgYK6BKpzo4vRPKUKHuba9HiM5RzC1zkgtdREMcV6	4892	6892	6892	1617179788086	orphaned
9432	3NKtqNwqkpY12sreE86dKCzYBTv3u1ec9dEhsGGvxjHh8UqDPTp9	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1672	1285	119	1	6301	jwVbo6WgeGNroV7RUnFrJanfsZ96P9ZQrL2Spi6EQKd4EwCE543	4893	6893	6893	1617179940000	canonical
9431	3NLin4hju4CkV7WtRh39RwH9g3mYpBTtkpc25V4Y6cvoCPtSvNcD	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1503	1151	119	1	6301	jwCtdANNcjPuXffyAUornpGbc84ARHgRcTErMr8ba3DNQ4ttbpc	4893	6893	6893	1617179940000	orphaned
14047	3NKGZNQLcLbsMs3MQzjPCBNiD183YmDifEx2hueEafbRWcgTZcmN	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1534	1191	216	6301	10200	jwn46o1FihKwabhnyc3bjMdABqK72esGNueCi8NuxvdC8SncBUN	7193	10188	10188	1617773040000	orphaned
9325	3NKJBDm7yd82HqZQDHRhKoNMBRqCXu84b9gTiMZCMbjufWrFzPQw	9323	3NLifRLwNMUjmJT7yoLSbSSEjFFfSfAkRmENeNRtAt4KALxFhBpF	1555	1101	116	1	6301	jxKB38GChhGCNQNh3VpTZbzxdQQnmbs8LpCztjCXtbM5haz1xNh	4836	6813	6813	1617165540000	orphaned
9328	3NL1VToHNNUWD64TC7nCnw3hdYECY1VYMFXJEWj7JNNRGxM8CjS6	9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	1483	1276	116	1	6301	jxXeeJLtGDtrhyggkwNfajje4QD3TZ33rAc6WxmWm3eBfSDaNax	4839	6818	6818	1617166440000	orphaned
9419	3NLTVTtrM4nFQVgLJk6eWfC8k7cLKrcYAVnV4yb5uLhwHAA97hXJ	9331	3NKkw9iidZ558Y2vPU7cmwCzKdZ7W15dVy4DoeSgJUH6gxKz8Zwb	1536	1067	117	1	6301	jx24aFNgXZ3actCvwEJy5GhzZ1UnQUQcSeamvJJXwYpBptXR4yD	4841	6886	6886	1617178680000	orphaned
9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	9332	3NKD2duNMwZMg9UUyPwcmjkBpunC1tQ1q1ESdeG87wMWiSs1oPgj	1668	1370	117	1	6301	jxzeoV2u83ed3HPRJGof2spB3UsN4Ev8mLQWwYZPuXHEb4JHuYH	4842	6821	6821	1617166980000	canonical
9336	3NK6szUUMND8VENAgeox3FsxvxaX42M5ZzwoE9nwRs1U3AbxVf6h	9334	3NKeuCuAZ4TuGasJWmQzRTU7dLcfWPvVz7PxYVNC3aRM8wU7HcCf	1406	1393	117	1	6301	jy29uJDbBznx7JeaMAQRdC2F9Hem343FDJi4kazb5JqvCKGqg3n	4844	6825	6825	1617167700000	canonical
9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	9339	3NL8aw2TwRY2sgd7FSfky1VbcTATzAGvad4VZnLUf1c1TEnLaibU	1617	922	117	1	6301	jxmoGBEdUGs6BrWGZFk5ZVHdAtvG5H4gNBoxUMhhFZ7HLiw13i6	4847	6828	6828	1617168240000	canonical
9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	9344	3NLHHWF8LzXmBrXrq5DMEDYApbbuK1CyUhioyQEYr5snmDM6R2Ne	1602	1123	117	1	6301	jxjCUmXdZnmHVJRGVZT7C7XESbisaAJFQaYmxpAEkFvYCqLE3uv	4849	6830	6830	1617168600000	canonical
9348	3NLDKv4fmMpHpSgcp55nrDznbXuC1pe8u7GbeX6ygRWAZJumEkbn	9345	3NLxPrSMijPtG6rKQpL8s29WYXS9z4iA6N328RDCuxcxDqgx2EyE	1631	794	117	1	6301	jwhhTNBRSTch4DFUZYZru9kHHyqmzvrmfrXwx1gVh48FGarFYYx	4850	6831	6831	1617168780000	orphaned
9353	3NLD6mapAYtvnMSoVSaSx596dWg6QfsRx9fEivJdDkk3woM3xXxh	9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	1406	1393	117	1	6301	jwd3WK6uwnustKLAyCR2s34zbSXCfQCqqhLHSK82FE1A4jV9XhU	4853	6836	6836	1617169680000	orphaned
9356	3NLBE88GMGmM9DSSXHW9b3kaa4rXJnd6ZZMnwQu8otXDeWQYMKab	9354	3NL54jJZxcNsKLeT8cXPwu4awpM4m2UCTMnXoUQuZo6E72kQfUtS	1651	1301	117	1	6301	jxnD4KfP7vka3EDtdC149E8w4i4W9DHvZe2q9yhRGH7kmoz7rzH	4855	6838	6838	1617170040000	canonical
9355	3NKgJgCn8WYp6635vR2aovVnnG7TScuRe4fnaa6jfUTyC1moQBHu	9354	3NL54jJZxcNsKLeT8cXPwu4awpM4m2UCTMnXoUQuZo6E72kQfUtS	1651	1301	117	1	6301	jwdHBy3B15Wdby33Jbu8RNf2Kd32x5hHfJQxBoMRoPA2L3GF5zf	4855	6838	6838	1617170040000	orphaned
9364	3NLcN2kGcLjk38wrCaqjam4gVts734mopoj3opB6wZ8VHmVuyQYd	9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	1405	891	117	1	6301	jwbcJP4g8PicExM1g3QqMqe7SkvMumKp39wvyqjFzzQxmkt1ipi	4858	6841	6841	1617170580000	orphaned
9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	9370	3NKmw5nXUK7eA1YiCh6xTVPChHa98nc2aVJyFyeQGAm8knQqxanX	1560	925	117	1	6301	jxf8V8BUMwrdMGwyUKJt3pe7oAwjUiMPGgYNSR4GaeZNG5fyTJn	4862	6845	6845	1617171300000	canonical
9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	9371	3NKf6EqzY49fXeLpFKPfN47m367tkwePb7CTJL845DyG3fKQndXv	1483	894	117	1	6301	jxD9LA6TWQU4sxgS42HE9ucpfXt148EWGATtHkayPM41PwVxYXF	4863	6846	6846	1617171480000	canonical
9376	3NLMZA8bbLrXyCBCvwAW2Jj1PnR8FYJAkJovvJVSHQeXwrXwaiiK	9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	618	618	117	1	6301	jwQLQUsv5ZdVKQh8uQPpfoddAZeX6bc9x721DzHjNB1kAwwL19E	4864	6847	6847	1617171660000	orphaned
9378	3NKxH6ucbf3K2tXLVk8ao4sJxP4MYpY6HKfnS97TgZkHgQ5P6cgE	9375	3NKddKDHgcBPbYJ6oohsdgcRuNMBU6SYQAkRKKQckW6pFXUhG79J	1587	1111	117	1	6301	jxD31n82WcDQYHNS7LWR38RiCZt5jgEowH1Ag7HtD52SJ8gdNh5	4865	6848	6848	1617171840000	orphaned
9387	3NLQRCJ2tCw5XiGE7irZZ3L9wjvQaeir1FeWS9EDMhsUZwFhSJJd	9386	3NLN8LvaAXUNB6aWZXJWgtGxYFWJw7tmkMHxXvt7g81gfgRukecJ	1585	1120	118	1	6301	jxyJsprkn5bZYpFdqKHNAvG6FqjFJ4xZ3A6SwrXL2nSvLM5Vjuy	4869	6853	6853	1617172740000	canonical
9393	3NLriz1StJpgR18vBxFc55qkoUzu7YpzSG2KtZriC2FLxfaceFiN	9391	3NKZeP6VqUyYrzUpkGeL7H9X8tAghfoDu9ADiFffSb9iyMWAyDTg	1405	867	118	1	6301	jxaBFprxK1xq9UbJTG25EM8G12R1x7hyG9UkNLPH22XEKVjHtJm	4873	6860	6860	1617174000000	orphaned
9395	3NKxxNRiYrZQqLdNXYR9DXZC43gYJ62d7j5kfKNZrZBKvcJRurZ7	9394	3NLJ4soJmYsyubopz4Y49wugG3FXRJEdvtjpzQBbSwC4Gd2zzuvR	1407	1395	118	1	6301	jwpZkueMHGqGvbfd9HebsJ3k3Sv2BUakFkg8TYpCYpTDnnsNAc2	4874	6862	6862	1617174360000	canonical
9436	3NLTYKgaKCWAMQAnWg2H65QuL9Fg29RNRtXnJ3C2q9bNLyWBUVnU	9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	1467	1130	118	1	6301	jwqKcW8oiSCDetkr8ym1xhCFnu3nK2NFnjjQYahUwKQefZkt9hv	4880	6894	6894	1617180120000	orphaned
9413	3NLvkzhfzVek6WmVssgEMMyCxDkSp95GJ6mACRRLC9hdYAVKKFYE	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	1633	1144	118	1	6301	jxiiPT3YccPdyMhQxsjM18wcRPU1GCosFj4UFZZ8LykN3KJAd1a	4884	6880	6880	1617177600000	orphaned
9414	3NKjb8QhGZWxF8bKsi1oBByeBtZbV84mDPDHtnkhfYv5ai3fjv65	9410	3NKWEUoNxeAkTP9ZMUzvsZd2YeyizADniMWt4SjsdZkWU2XrSnmP	1631	794	118	1	6301	jxWYaKjHTzf1p7uF5MVBN5LC6n8hA1jygzpj8BWUfQMFz8nLedK	4885	6881	6881	1617177780000	canonical
9424	3NKrxzX8nN1FYtWBq83aToSK6HWruxy4FT9KgyWBZCXcHeTR49CE	9420	3NLiF49n66E5QsvXFrGUhwdWvfvqdmcyRhw2xVWJsbqY9YAr4aBp	1407	1395	118	1	6301	jxPfP6UrVJYdc7VdyTmKHousG462HyLK66idXYvhYot29JbF8uk	4889	6887	6887	1617178860000	canonical
9425	3NKLyLQY9v9Sp5qnGp2fYbHf3mujsGxJeH36g9cj7uAZrpe5gahS	9424	3NKrxzX8nN1FYtWBq83aToSK6HWruxy4FT9KgyWBZCXcHeTR49CE	1406	1393	119	1	6301	jx16Bjk4uZDvY1y5Lncq84nwSPXgUUSuiPa3AcNq1T5eJwRjXM8	4890	6889	6889	1617179220000	canonical
9437	3NKJ3gZvnUVhCAGEX2XamouDP4K2AkxPv4abwtg4BchbWEW1D74W	9432	3NKtqNwqkpY12sreE86dKCzYBTv3u1ec9dEhsGGvxjHh8UqDPTp9	1467	1130	119	1	6301	jxZSyEM1ueRFSNtgY4igrGApTmASqqB4KnkkbTmiYmeBF9hHDxL	4894	6894	6894	1617180120000	canonical
9439	3NKUhaw6ixH1VReNzPza7F7UMDc6MmgP88qQoAjFBbQ4YgrwAGLo	9437	3NKJ3gZvnUVhCAGEX2XamouDP4K2AkxPv4abwtg4BchbWEW1D74W	1673	1368	119	1	6301	jwP5Wo1KbJrpiMg1rZo1xb36ME7TK4QqkQmaC9EnaoREywZmJeW	4895	6895	6895	1617180300000	canonical
9440	3NKniw4VVngXcSu9dGz9ShJ1SwWjNE89VLfukeFRkXTVots6kKCz	9437	3NKJ3gZvnUVhCAGEX2XamouDP4K2AkxPv4abwtg4BchbWEW1D74W	1610	1188	119	1	6301	jxf1fh6ZFsEc96fXA7tXc21B1GNWdzXWByAps8F3p2jdjrVDnns	4895	6895	6895	1617180300000	orphaned
9443	3NKDNpS47PFou9tdYnSnAcwTNWW1m3vzpeXtKP4zzcsR87rBf7Kf	9441	3NLk5LbHgVixYkZAQqAh7npKyPyCuUZ5vd4j8mMvGBAy7pE5aAf6	563	993	119	1	6301	jwEteHUaSGenLL2jGufJdF5Tnf3xmVqdPm25eRdGrEWurdrks7E	4897	6898	6898	1617180840000	orphaned
9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	9442	3NLY4nPLvCCBRVWLK4KBbxqW7yco3oXZ7WkFWfouBe3S4mrSRYwA	1600	1126	119	1	6301	jy2Htjf9EkYi2HRu8Y5ptgX9AL7QNHcEms4PRpNkGyVqngFDhfh	4898	6900	6900	1617181200000	canonical
14049	3NKc62nciA327DhBuaPUgGM7NZe9CxFaRPvvWzt4V9zBRqgdsjoN	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1601	1262	216	6301	10201	jx94uzq782Wjx9GUZ7Ww1pH2iBmsdAeaHJWVUU2GNtZBU63XkgQ	7193	10188	10188	1617773040000	orphaned
9362	3NLSw2jHtAJYsMLiDW9npEM9ee5oXLeNe68o2pMHAknmTP5fRqJk	9067	3NKaDawtzZqcE1pPzgM6pV4H15dZmAx3QnPnZUVskYsopX5eWGxc	1403	824	110	1	6301	jxwHygQ4U8U9PmfLdM8nJk6r7FiXwkKvEudkedzbS4rBWeSFwjj	4701	6839	6839	1617170359814	orphaned
9323	3NLifRLwNMUjmJT7yoLSbSSEjFFfSfAkRmENeNRtAt4KALxFhBpF	9322	3NLiVe7XvCjzNcnofi1BugjF6ys2zpgWN5RLucvxsuVNfqvmxAbz	1449	385	116	1	6301	jxqzgNGJoHRdD2hLPqxfEEahfoa4DNmufGexKNmvH2gHze2ixBM	4835	6812	6812	1617165360000	canonical
9326	3NK7UmkkofTR7zjnErnr4XDZq3HDpuLr5MikXu9Tqx6CFncC6Bi1	9324	3NLhDUbDB2FTGwN6TkZo8CCMEeEixgLo1MBFsZyMGwLzb5Znr51E	1407	1395	116	1	6301	jwFtB3eMqEe3c7eUg7nqy33CtFACud3LszgnarYC84P9e2V24Ks	4837	6815	6815	1617165900000	canonical
9329	3NL7DMVy3biv7e2vSz5Uxsy1K4nQ1LzVPQ5PM4prF8qNtN4yYqzC	9327	3NLXwjvd6WQYtAoEwsna9scHcdsZERoqLBUrJDEDNzwz5AX3cXXH	1483	1276	117	1	6301	jxXeeJLtGDtrhyggkwNfajje4QD3TZ33rAc6WxmWm3eBfSDaNax	4839	6818	6818	1617166440000	orphaned
9331	3NKkw9iidZ558Y2vPU7cmwCzKdZ7W15dVy4DoeSgJUH6gxKz8Zwb	9330	3NKGnC2e3KxFh8yixHLt1vLUmf5yzdChQWVDLxfupgPcrPLC4Qso	1458	1197	117	1	6301	jxAmGUuq8S33h8jLa22ZUA3Z1ak2BD9S8FNombFZDEywAZxx16t	4840	6819	6819	1617166620000	canonical
9334	3NKeuCuAZ4TuGasJWmQzRTU7dLcfWPvVz7PxYVNC3aRM8wU7HcCf	9333	3NKZGV4WuY2EtzpmxkDf7dPREvtAoNsgiCSAwP4ikRJnQvPh8ukj	1627	1019	117	1	6301	jxxFPBXGxMUiNJupzx7n7Y5YD4tosLj2RH5BEUQFzzjh3bMkrVw	4843	6824	6824	1617167520000	canonical
9339	3NL8aw2TwRY2sgd7FSfky1VbcTATzAGvad4VZnLUf1c1TEnLaibU	9337	3NKGv6cbRfax2b2XLzebPKbFRBRz8npTK87Eo2yAvdJiDUW3PTDg	1403	824	117	1	6301	jxUgU83zf4hC1F3Ltvp2X7a9EnooCvQLPZ17UyJomWPes5pLDoW	4846	6827	6827	1617168060000	canonical
9344	3NLHHWF8LzXmBrXrq5DMEDYApbbuK1CyUhioyQEYr5snmDM6R2Ne	9341	3NK47k2yCNxaayiER9DRXMghWx9EoNT8nzUdJXwRKdZ1jTtSmPy9	1637	816	117	1	6301	jwJS38ai5YsfB6nF8rgZ4HAVrfuzMbGQHHjkHkk88mE1JdaZJqY	4848	6829	6829	1617168420000	canonical
9351	3NLnC7XKeA3Aw1ToxYyTKNqAaB7AV53WkMtiDoLsRx3oUL4KoGnB	9350	3NLFWhwe6eHBmyAEixBDX3Dj2xbijfbCYiaSn8djUMPrD3DsnjoQ	1407	1395	117	1	6301	jxin24kLxQKq163Lrfu9dbrTGgueoEXFrYkndt3c6P1RJV7tKHT	4853	6836	6836	1617169680000	orphaned
9358	3NL78w7jWqWuEtQKb2UkeZUsxdGGyL8FUj4pQLs5pkaMUUb2SfD7	9356	3NLBE88GMGmM9DSSXHW9b3kaa4rXJnd6ZZMnwQu8otXDeWQYMKab	1405	851	117	1	6301	jx78K6Y6AF9Q4QfJmNny4JxVTWgLV4rmDzdVsSw6Kqmr8qy9Grr	4856	6839	6839	1617170220000	canonical
9365	3NKYGDThrEo24dtWYrpgHXuZQxtUT77MqLj5BTzA7mD41DmgoNEs	9363	3NL2uqrKUgDx4gEhQtfKFVPgtkegCrGFo8RWX4LSZdUfJzd1bJyH	1623	830	117	1	6301	jy1HTAA27gfCRPkDwCP69da7BExowSYKVnqJFHgFt3smr9Lqsbt	4858	6841	6841	1617170580000	orphaned
9369	3NLhaVyMGexQ3c9ZXfxyroGWFmmT9Np6e982LtH6f7nDgKwiGPw4	9367	3NLbdjUaMVXm5z266jzgzS7PsyhAihxJSStqAhguF1XaACr3hBJw	484	1319	117	1	6301	jwuzoea4DAiznVh4xJKAKptAVcGWTJ2QJUKUYM32nrX7J6JQNuP	4860	6843	6843	1617170940000	canonical
9374	3NKxkXjgw63SKwfqSE8MV9QeVHsdDkASQWuCqJLxioaLSeQMXHdv	9373	3NLxWu1srPkcm5oaSDg6Bv6rTfeRiDToZHRs36AfP5weXQnCZ3ne	1623	839	117	1	6301	jx3nUvqkXLtpTagJZEfdmUbYZxBMbihiYGgwpNPZS6p1AFGJkYB	4864	6847	6847	1617171660000	orphaned
9381	3NLWxwETvhSxfFCViVdQYgakSuDEHLNWib9s5TjhTKPX8WbVkzsa	9377	3NKKMK7e5BcPSDiF7c33hcrU6LKCzLj9ww3BgoHq7v6HB7564wEW	1549	1362	117	1	6301	jwVQsPArij38b9u4hD6ZrjDyEzj1gejeYHLKn3bsFbEbodcvoGR	4866	6850	6850	1617172200000	orphaned
9383	3NLQV4mKPCwoFktGj731Mh4iVLwhfnAnKnfP4C1N31q8zprcBchR	9379	3NLh6CvH7pjioJNSWjMET4J7oRpeJYFw2k7HxZPP91UVPH3M8dqE	1407	1395	118	1	6301	jxvrNrjZYwJPP5D8hGaGCthqEdsJ2w89uTMmPyc2pUwzxg6M8gg	4867	6851	6851	1617172380000	canonical
9385	3NL7Rg3W2Yi6syoFpdhUvdMSfzkipkkLL73sJko3Ng2P7m2jpDA3	9383	3NLQV4mKPCwoFktGj731Mh4iVLwhfnAnKnfP4C1N31q8zprcBchR	1457	1391	118	1	6301	jwpjxCDPWCBeivqrnuYzMxU4PxPvPK4CVjZqe5cKkugg8p85g1U	4868	6852	6852	1617172560000	orphaned
9388	3NLZLn6EHfdCmHwNYjXHzHSnJK1zS4D32wFsyHh5dHrtNJewvNhJ	9386	3NLN8LvaAXUNB6aWZXJWgtGxYFWJw7tmkMHxXvt7g81gfgRukecJ	1457	1265	118	1	6301	jxx4YUyUXJUxvBUyP1v9nq1ZLFTsWvzR4DdtA5dvW1AsVLs2udk	4869	6853	6853	1617172740000	orphaned
9390	3NKaTyeASLSr3KT5TRY7qrFhyudsuxJYMpFoTQbh3jwvDatL27Ee	9389	3NLPvZnZyVj69Ji8fP4rF5E9X3SqxU3q5YEaPNfuchfxkmReKp7i	1594	960	118	1	6301	jwFPwCj1ffqhuE1G2ZGx1Mpr4yxScfEaGAtoqSNreQS581dtMSY	4871	6856	6856	1617173280000	canonical
9396	3NL4RtRfBCF1JgRtYTiA4Ub3FJYraNvt4y3gtdnaPRx7cfKG9vzQ	9395	3NKxxNRiYrZQqLdNXYR9DXZC43gYJ62d7j5kfKNZrZBKvcJRurZ7	1633	1390	118	1	6301	jxogx4rfXN3AaeoQ3oHSk55KND626qXuvG5YTjBwRfr2v4A3S8u	4875	6864	6864	1617174720000	canonical
9401	3NLqfz6BRi7Ndmrj2aLX5ZDXKpxjpUmPhsAQPqk6kLL1q9YEzFEC	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1407	1395	118	1	6301	jxSXtyzDL194Bp7egDU5LDFK2QTncj1hnory8Sd4Wtt81XWdQKY	4877	6867	6867	1617175260000	canonical
9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	9401	3NLqfz6BRi7Ndmrj2aLX5ZDXKpxjpUmPhsAQPqk6kLL1q9YEzFEC	1579	1023	118	1	6301	jw8MFSqnC9jF24stpQdP8w9evAo1ct82TZCGQLMcrgqkiwDGYRY	4878	6868	6868	1617175440000	canonical
9404	3NL11K4EUyuZC7MYndhjh5qUYCUBMNboUeaAJQnwhiGQ5Q7iHX9G	9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	1581	778	118	1	6301	jxkELdeE1PG3epJQLT7K7w2CfCyrYeEbqcatgBr1ckcWvoyh1mr	4879	6872	6872	1617176160000	canonical
9410	3NKWEUoNxeAkTP9ZMUzvsZd2YeyizADniMWt4SjsdZkWU2XrSnmP	9409	3NKqE2vTG7hRv11rNWkQJtKMaGJgNJ27Axd8BSZXmCJ3nuPoaBxt	311	1307	118	1	6301	jxVBLwEjnNpnBqG29QjwYrybZcijstHFqCDJvGkGyVPqGrMg9zw	4884	6880	6880	1617177600000	canonical
9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	9414	3NKjb8QhGZWxF8bKsi1oBByeBtZbV84mDPDHtnkhfYv5ai3fjv65	1407	1395	118	1	6301	jxByexzB6sjHm9AL8niv5DrfkTmbEVwPTfmDuy7VydZ72EnvA22	4886	6883	6883	1617178140000	canonical
9417	3NLRQBFe2E2qHBrUdusKEkB6aEBFAn7dVJtQVvW8P2RLXuc6oyVm	9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	1460	1324	118	1	6301	jwtjPWZJpPfu3QoVz7zjRHhcQefN7j3cZY3kQvx7MCgjdo9FdKw	4887	6885	6885	1617178500000	canonical
9416	3NKk8TLeB9M57zaPWsPhrSqF43g6Xw47yGnZpLj1kaSSYVBJR2A6	9415	3NKWG1ex4awgvsVzRQvqV7wMfmRHT1DMiXjt97bpxYU2PpvCQoX9	1407	1395	118	1	6301	jwJcQYquCCF9DegciqY31VTsnvTt7DUpYgWeEa5iYpT62BfXr3h	4887	6885	6885	1617178500000	orphaned
9420	3NLiF49n66E5QsvXFrGUhwdWvfvqdmcyRhw2xVWJsbqY9YAr4aBp	9417	3NLRQBFe2E2qHBrUdusKEkB6aEBFAn7dVJtQVvW8P2RLXuc6oyVm	1536	1067	118	1	6301	jxuLjzK72xMHSWXfjer68DxsxwVmrBMPLm9hu1t9Q8ETPhHjrfT	4888	6886	6886	1617178680000	canonical
9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	9448	3NKndyk9oEw3Ai7VQ3YjksCvyrYF4VNTR3EwbfrqKDXdxanmmYVx	1547	1378	119	1	6301	jwMR1isBXuhnTb6HUAGiGq8mkWxcrXxsGJaUrPgKw6Ac42amJiH	4901	6903	6903	1617181740000	canonical
9457	3NKuf88S7XyUY35qAkarcMkrWWohUPiJ8aLvA5odSozJe1kfs8Qi	9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	1581	778	119	1	6301	jx92mqZxt58nct5zyCVGfJnAUg6MZgZejanAqcaEGpPTQvzx735	4903	6906	6906	1617182280000	orphaned
14050	3NLfaKNXaXVESgk352cN5FcEt1DnmHU633ZNs1senBbihmJqVKWb	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1634	313	216	6301	10199	jxQT98S89ZUY2DPDW7mF6gdt5aJ6hYvcqWjd1pS68vkvbnqiTYt	7193	10188	10188	1617773040000	orphaned
9473	3NLi8MCzzhZWDznLkFb9PagSYLP7oAQhHwjSpVDTqm3frvoHDCFa	9105	3NLWZXzE2g9LLUsgf52YaVJoBp4wnfdeoqvHXBKqkhhPJzANpnsv	1513	1253	111	1	6301	jwL2mFbrT6jHfng25yPM1fpUSWoA62wdhQx9E7sfzc9Cb8xsgTn	4719	6917	6917	1617184260000	orphaned
9428	3NKHKncRbBnSuQoNLJB2x8T4BFj3oQRX3YQBt4s5ggL9v72Rv76M	9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	1603	444	118	1	6301	jy327G9HyKkxfvLDzBo82pvtcxTJDQWSY2R9jUye7w6gBrHGNd6	4879	6892	6892	1617179760000	orphaned
9464	3NL3qciic4FPkBj43WqFSXwUfsbREvxrfWY8r4ovP6TfycpAkokM	9436	3NLTYKgaKCWAMQAnWg2H65QuL9Fg29RNRtXnJ3C2q9bNLyWBUVnU	1467	1376	118	1	6301	jwj9eVmzz2exC534V32beUJ21rButs6rYnUS82FGGbhZnfNrNhc	4881	6910	6910	1617183000000	orphaned
9426	3NKvnsDYmT5n25TH9VcNv3rDvDHB8Zj8eckYeHs5ewacJmxckgY2	9425	3NKLyLQY9v9Sp5qnGp2fYbHf3mujsGxJeH36g9cj7uAZrpe5gahS	1585	1366	119	1	6301	jxpVXr3Caco4cRHcyZUjuXF9s1P5BY2uZunPVj8ursdoT7KnbLn	4891	6891	6891	1617179580000	canonical
9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	9426	3NKvnsDYmT5n25TH9VcNv3rDvDHB8Zj8eckYeHs5ewacJmxckgY2	1625	161	119	1	6301	jwuduTHhmiUENgFtN6NMN62dqdECcaz9RtxDTsmtKJZajtKZoJa	4892	6892	6892	1617179760000	canonical
9433	3NLkT5kL35bxohYFoAbkPwVwC4iM4DUK4iUsXqMLFKDb1uG9Ltb9	9430	3NKYptus7poeW4RXAaEC7xkApQxiYAFKqvzi35CQMSDZG4WtpPxE	1623	830	119	1	6301	jx4USwXghUicwBMeQw8nAXZcdoXKMZECK8jpmCpNEZkCaUYnmuN	4893	6893	6893	1617179940000	orphaned
9441	3NLk5LbHgVixYkZAQqAh7npKyPyCuUZ5vd4j8mMvGBAy7pE5aAf6	9439	3NKUhaw6ixH1VReNzPza7F7UMDc6MmgP88qQoAjFBbQ4YgrwAGLo	1637	816	119	1	6301	jwHs33zhbzgSECqdNmwC8kSMgcGQ4iB4fTcYk3MrEE8ZhMDrxMK	4896	6897	6897	1617180660000	canonical
9446	3NLajezVSmKVqRPj1ns1GGuQwGajiokbJK8RL4vwzJ2U8DgPj9mz	9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	1439	1153	119	1	6301	jxQhxUxhXzHpcnMsSKZKAciKwyLT3S7suCLK6f9UGeRn5D6ciQR	4899	6901	6901	1617181380000	orphaned
9451	3NKNdSjQ4Aqw86yFwungZ6fmh2EyLUGyZ6MJZ9U94deCUko4tLsA	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	1451	1292	119	1	6301	jxRVArWSB66jT3A9fMkawMJWyjbdjCLMGvpGJEGejgzh9HMavgh	4902	6905	6905	1617182100000	orphaned
9455	3NKqcT1vHr4V22JvwZbm1Q7nrYZrqZuT8fjypjscLwHQCKrWCjQp	9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	43	1064	119	1	6301	jwCiKQqmNbRncyjYD5gbBwf1rANQQuMtobEQKTm3qMbUffEqsqF	4903	6906	6906	1617182280000	canonical
9462	3NK4Mykw1AFE2bXQTp84LLFUJsZGGHonz86umzLoGSodenhCs3S6	9461	3NKBPcRrdYKNtJ3erGsRotw2Qc5aUvkGJ91bAdtZmgyzNnPpNCaE	1577	1201	119	1	6301	jxejDxmSJvvbHF2Q6WVqy1y4qNWiSzxhKCM9wrSP8eTJtVyAP6T	4906	6909	6909	1617182820000	canonical
9467	3NKLm1JL1jUQruqXCqw28FeaAwrfkGnf2Gifto1gHGhSwvtnPsZu	9466	3NLZLvKTE3DXkL6vQ1iKcJXccYeTuqhGhXJ6mjUSC4CVdf1cGFcx	1440	1011	119	1	6301	jxdC7Qy2fp99GBqJMfAcKntxHsMr8x68mb6XhUd4WNkTS9EYFMB	4909	6913	6913	1617183540000	canonical
9470	3NL67aqzY6dKZAPBdE2UdyZ9qS25QXJEj75Xx51BLAHSQ6p31hPS	9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	1624	1334	119	1	6301	jx3nPs783DyHmKDyg4eBxQB9wav5ik6cZFCWhwMCz8bovQjeUw4	4911	6917	6917	1617184260000	orphaned
9474	3NKofSpzmwXFqdvGeTtqnHfz3RmM1krsTakv5b7c1ojne6ZdvkTh	9471	3NLCbHZvackZkr3V3iSr2PgNpx3mbGdSk27Gzj5wEKXpphRj64am	1541	1052	119	1	6301	jw8EMQdm1nH7vF8nL5EicxZo52mXarU2Y7dQ9tAXzReav6AEUXp	4912	6918	6918	1617184440000	canonical
9480	3NL1LvDv9XEF4fv8wZzsNu1sAdhYzA2LC6tpgcm5VQbv8CfKtEgH	9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	1523	1321	120	1	6301	jwnwKmdxpnKcKV56F9VxMEDazcxL5QHp7BJ7DsfvVyJkxU7LAz3	4916	6923	6923	1617185340000	orphaned
9487	3NLu924SdkWTE7UA8Fp7CZB2UGmxW1SGLJfPEs68kYXxuXW7A9uP	9486	3NLtdnCTz4z2LzpHFMrEb8NK2ibMSjKjnZ8f9QapD818zZBq7Mqa	1637	816	120	1	6301	jwUML46e99jFBNxc7hFcZkKhBVGrbLSTWW5zi5dVPu2J3DzFsEo	4920	6929	6929	1617186420000	canonical
9490	3NL7KjGsXv4Rw92SeSeYCfeHEoCGfcLaRm3fBRG18CdEyknQSXxL	9488	3NLsXCXHhUQcB7Hu5X3Df2a1UyBiVNfLsjA66RTLTDegn89aj7a1	1600	1372	120	1	6301	jwQ8hTz4hYPabLFHrmGudKMmx1jncYrWagwJgUGZ2F9FbKLmUSG	4922	6931	6931	1617186780000	canonical
9492	3NKBX64gLK7t7BiFGWUBWNcx4puVLs9iexRTLPKzvnKr5P43sCUv	9491	3NLcPWHBuyBjrhKkBhQHnmVdbwaykaJ2LExHTZvsp3rVysseGsgF	1407	1395	120	1	6301	jxe22MvQKaHywwXQzmS5vaaWuEdJhreWCA1FgPbQmAhzWHxw6QJ	4924	6933	6933	1617187140000	canonical
9499	3NLEjHrB5oi4x1D1bU6DiZEc8DL1d9nVPwyxGBTuFX7hKStmq2Sh	9496	3NLPTrC5mb6ortNwvRM7htkEEqKw8CULxwszELqCzX2JySBrz1cz	1407	1395	120	1	6301	jxGjpgp4Yr4VP8TUWxG4myVZ2AJM69nxk2nDMgkstGdi7AqGsbk	4927	6938	6938	1617188040000	canonical
9505	3NLUbAmgnTdd4U36VaC9WYoza6FqAQjqXE3xLwuF7vFE4QB8Q193	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1523	1321	120	1	6301	jwxS6SbrXWd5djyhf1vZySELT6TZtsEPiYnvwzP4xC6QJj3jVdY	4929	6940	6940	1617188400000	orphaned
9508	3NKtf37R4WAyCnZwcmwQpJFB59YpEWLXVXLpiZzqvxwpLahHFAod	9506	3NL6mPSbwft7Jz8jHvd6y9V6ZHH6HqHHNP9HCwMsx2SFqzN2NU3D	1637	816	120	1	6301	jxkywbTNzBuD7yQtonbW9owSyq5xwUSSZz1dmLvnHvP1rM7MTaU	4930	6941	6941	1617188580000	canonical
9511	3NKxcouybtSFwqYiLUk94N6BU57v8BikBdiJnrwzYbvQ2ZXii6ts	9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	1406	1393	120	1	6301	jwqDbpSpr1eEzpbKPCq45GnMRzaR2ZCFikyKkdr7XRXdcLJaTY5	4932	6944	6944	1617189120000	canonical
9513	3NLsUwqgg9wLgs2jPt4fc7C6nCFVcwV2fEtUvBgayJ1Pj8LnoJDm	9511	3NKxcouybtSFwqYiLUk94N6BU57v8BikBdiJnrwzYbvQ2ZXii6ts	1483	1276	120	1	6301	jxLAUGk9XWwmYpyqPUxMQFrhnfv58we4B9AyrUaBJL8g7WseedK	4933	6945	6945	1617189300000	canonical
9515	3NLQuy564eEmNsjw35Vfjzn6rr8ouF2eCumbeNbF4NrPrJiigyDN	9513	3NLsUwqgg9wLgs2jPt4fc7C6nCFVcwV2fEtUvBgayJ1Pj8LnoJDm	1503	1277	120	1	6301	jwy3zDUxeyCJSyXhZ1tkG3wih4oC28k9HmXvifksPayWH34KbBL	4934	6946	6946	1617189480000	canonical
9518	3NLf5JV6xqvF3cddbXPKuvT4bziPbhKczPqF6B97UQhrpUz2otnd	9515	3NLQuy564eEmNsjw35Vfjzn6rr8ouF2eCumbeNbF4NrPrJiigyDN	1407	1395	120	1	6301	jwi5xU5p84b6gtSTMryv6eQH8TgTEP918MkLDLbLo8bz8EKpiTh	4935	6947	6947	1617189660000	canonical
9520	3NLd6ytKxho88HLP6dsuVmWTzaQxPaEKVeE3V3sp3A72hDeGJr9e	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	700	840	120	1	6301	jxt22EiXgL3zJbe6A2SaTd9cBt8hnduvw3SB77psUqesLm2nJQW	4937	6950	6950	1617190200000	orphaned
9525	3NKN1s515ne7VfHzyNsawEWx7zspHiFZXsMv7nvPVT3sGcJukeRv	9523	3NKfW5y8vhgijeigqqryoo88VW6RpQzpJQsNLXP9E3Z3xCLzNDrF	1407	1395	120	1	6301	jx47LaPf5zDMHy9UHMW5Ffrofo8GHjFLhFJc8dVdbiiRabMJ1R6	4938	6952	6952	1617190560000	canonical
9527	3NK2wvg2h6qLvnHj57sJc1KKBCdw9zHWQarwbshnwAijiVfwgshg	9526	3NL9pdhD4o9LxKGsdTwc6NnkZKF5bwuwcTryx6ZnjX4g4TwiYjRK	1403	823	120	1	6301	jx6sWhEJSJLteNRrUASobv1aaTuJsQeHZVy5ZALMEhKP5fBsmdZ	4940	6954	6954	1617190920000	canonical
9530	3NLF9mJqXX52EHkyyTBSVDFdfpv8i82jedxB6WY51eAyFYgK2JUM	9528	3NKSTVfhDuc2CPbKRaQKioRo6zBLFUSQ39WVJa2KaRsnSRHzDLrj	1673	1368	121	1	6301	jww6Zeq6zFRfNsfN6DAQKP6o8g3YHeU7aHiQT6XdWLZNHXVGf53	4942	6956	6956	1617191280000	canonical
14088	3NLiYVguaYUtXDFkwT4bcXfzbxYLMqeRPnXeHAPBYPFJauxyyBma	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1581	778	217	6301	10234	jx3gFrg9gJWK4cs4TzaDKrLW5uxudKuUSRRJF8UbmzguXnSx7ti	7205	10203	10203	1617775740000	orphaned
9442	3NLY4nPLvCCBRVWLK4KBbxqW7yco3oXZ7WkFWfouBe3S4mrSRYwA	9441	3NLk5LbHgVixYkZAQqAh7npKyPyCuUZ5vd4j8mMvGBAy7pE5aAf6	1406	1393	119	1	6301	jwecb4929pozd1ef41kCCMrabGum2ajFY3CVhxuQNRjkJXudnzU	4897	6898	6898	1617180840000	canonical
9447	3NK4rGXtMjgSBrLkBfkHETJ7Ju5jurMFKHe9itJVV9XC6mTf9AjT	9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	1555	1221	119	1	6301	jwHp1aZuWUExxU743FRsE59DH41bMXbbHqcn1Gm7CkGKErEK3bf	4899	6901	6901	1617181380000	canonical
9453	3NK6bWB1nByY3YUEbVwv9PbRefL7vM26Tcxs51eW7bmAQyDGBdX6	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	1509	1194	119	1	6301	jwR4C7VkeuyPddy1i2mf22eMZqRxmHFCvzwhYaUZfDNLpCGKGUN	4902	6905	6905	1617182100000	orphaned
9454	3NKXdQpD9ELwhP5bdHMRx11kuT3A9aeB1P32GTfjXBGWCL4W2Nmb	9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	632	1136	119	1	6301	jwFXnHPHrHGH7nFFFtzqGhwZsAUzdDD4uWyfWX3yjnV1X83ycPW	4903	6906	6906	1617182280000	orphaned
9461	3NKBPcRrdYKNtJ3erGsRotw2Qc5aUvkGJ91bAdtZmgyzNnPpNCaE	9459	3NLaNYd7kL4QXSL5QUhED9uARb6C1B5xDfxLAs2RpKJYpirrSFDM	1406	1393	119	1	6301	jwnh18jhRPU2jxBwrp3zEMRqBWuF9FqGN5xYRbxzyjBQuJDGJma	4905	6908	6908	1617182640000	canonical
9465	3NK7rMehm2oFF9ijK85XspS5T6PH8LXfGLUHYA8BeWM25hbzdVeq	9462	3NK4Mykw1AFE2bXQTp84LLFUJsZGGHonz86umzLoGSodenhCs3S6	1467	1376	119	1	6301	jxP8c6KTKGoWa69VBm3XApBkVNEdVZUbGSVrGLzAtSAteeoKYMA	4907	6910	6910	1617183000000	canonical
9472	3NLpZCP13aYZn3kC7N6ZeBMJVi5iTTnB2Q2fBYbVScSUmEzbgT2W	9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	1600	1372	119	1	6301	jwsN9a39D9evR3d5KzRT8vdjCFzUtk7QKdZ6aodYjNxLDGVqb98	4911	6917	6917	1617184260000	orphaned
9476	3NL4fm5ptcssT9S7Xg5WmhAJxwth99G2FTwKw7dG31y7DQa3pV2B	9475	3NKEEtx1JnbBtSKGzjsvmHr5CwwtSsRk5J4KJi1xqxYBr4zvdGw2	1619	909	119	1	6301	jwbDLjMkhAxcEU2ogzi9JowMeSUVa6otkJX22TYPhehSxnWN2nV	4914	6921	6921	1617184980000	orphaned
9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	9477	3NLqWzv4YJh4cLA9vnK8w3xLipnqBBsL1sPvYTGDfrfX41aPqWar	1407	1395	119	1	6301	jwjBicRu9SGKMVEyYLo9iYGFF1hiKsaz4QzrY8zu5kEKxgWFYbA	4915	6922	6922	1617185160000	canonical
9483	3NKGth6jNVn9RGvzqGCgsWiGnJBwsm3SR6RQmER7P7dzNKpcx8HK	9479	3NLLHFVYL3SipeeRxQFuPviLBdBM1vRCasfh9psvxtZVaR6HghEw	1646	1354	120	1	6301	jxxE8b8S6oM1mQrUR9BnXvCzxjh3PJZrGmoWFTxW54VMqHSNmEv	4917	6924	6924	1617185520000	orphaned
9488	3NLsXCXHhUQcB7Hu5X3Df2a1UyBiVNfLsjA66RTLTDegn89aj7a1	9487	3NLu924SdkWTE7UA8Fp7CZB2UGmxW1SGLJfPEs68kYXxuXW7A9uP	1403	824	120	1	6301	jxzxLYFQixfkV6nD6BsBkP7PUn2dktyhMS948KxyF4EkuojfFkD	4921	6930	6930	1617186600000	canonical
9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	9492	3NKBX64gLK7t7BiFGWUBWNcx4puVLs9iexRTLPKzvnKr5P43sCUv	1611	1341	120	1	6301	jwA8qdWL3kTYoAgUUGBBtfffCWfv8BPuvcLpsambTSiPXW1YVpU	4925	6935	6935	1617187500000	canonical
9496	3NLPTrC5mb6ortNwvRM7htkEEqKw8CULxwszELqCzX2JySBrz1cz	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1447	1345	120	1	6301	jwzKFBgJcGZ8Ci3LofsrUkYzLytTZDGbZJJE4edAyTZnvQFnh8m	4926	6936	6936	1617187680000	canonical
9501	3NLGq85q8eUpBfxSxh8S9vAFhj4gLLgcYh3jngzHBm9M3dmXa8s1	9499	3NLEjHrB5oi4x1D1bU6DiZEc8DL1d9nVPwyxGBTuFX7hKStmq2Sh	1405	873	120	1	6301	jxu9hCExEG346YC62sQsBrjpw8KQpZ7VWbK5xpqcCLvVALm2fE5	4928	6939	6939	1617188220000	orphaned
9506	3NL6mPSbwft7Jz8jHvd6y9V6ZHH6HqHHNP9HCwMsx2SFqzN2NU3D	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1523	1321	120	1	6301	jxPzDuc9g4jFT82jXmHC9VagM1TDY5kXh2xJicWKvW2K99Rg4Wk	4929	6940	6940	1617188400000	canonical
9503	3NLKddJ34omHTPyymRF25XKnqJXeT3PWj7PGbyGSd2FdvVNoFTdg	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	80	1027	120	1	6301	jws1VA73npLeXGYdpqyu3sAopiaKH9HZ7hYCAb33GaFSabQEWvT	4929	6940	6940	1617188400000	orphaned
9507	3NL4ag4td87wwKSqvHP9wHxZFHgdax9S4zXm6nbLNaeKq6dW2vME	9506	3NL6mPSbwft7Jz8jHvd6y9V6ZHH6HqHHNP9HCwMsx2SFqzN2NU3D	1407	1395	120	1	6301	jwHJqm1LSFcYoTUSbkcVFLTcP57C5nGPafB2TAJe7TQ1dAYsVEg	4930	6941	6941	1617188580000	orphaned
9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	9508	3NKtf37R4WAyCnZwcmwQpJFB59YpEWLXVXLpiZzqvxwpLahHFAod	1444	1381	120	1	6301	jxVyuwiETqG7wMcUntpBAEXxP42QWoBmXGd2cPRBBRhqLaBnGzh	4931	6942	6942	1617188760000	canonical
9512	3NLjyvei5QbFux6nn9a5UqmC2s2WAGTMJNDKKX2wE6HiWBWMiK5Y	9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	1637	816	120	1	6301	jwQDGtd6jQWrqTbiq41rggpxyUBoq2zSK3GaE5GX41D5ea5huGb	4932	6944	6944	1617189120000	orphaned
9523	3NKfW5y8vhgijeigqqryoo88VW6RpQzpJQsNLXP9E3Z3xCLzNDrF	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	1637	816	120	1	6301	jxowAYmWAtRiLmzFKYisn79NAgDgyA55sJhrZEDDziBqyaj6SKP	4937	6950	6950	1617190200000	canonical
9522	3NKFRtXMZ67d17H12j5nvTXcdMHu9oGeAn75MPMfdnurv6tM4SV5	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	298	1062	120	1	6301	jwesCPCBrzf63DDwTodbbNREHyZyQn2scun592Xc59jfycjh3uC	4937	6950	6950	1617190200000	orphaned
9526	3NL9pdhD4o9LxKGsdTwc6NnkZKF5bwuwcTryx6ZnjX4g4TwiYjRK	9525	3NKN1s515ne7VfHzyNsawEWx7zspHiFZXsMv7nvPVT3sGcJukeRv	1672	919	120	1	6301	jwSNkqKNAP7m8HJvxnVvN3hfm97s4PNvDLJ2WiNKUyeM7nh8HFM	4939	6953	6953	1617190740000	canonical
9531	3NKw3YpbFd3Sr9GNKgj9QHwob9QxSnmZEQpG61EEKM5CTfjbM65B	9530	3NLF9mJqXX52EHkyyTBSVDFdfpv8i82jedxB6WY51eAyFYgK2JUM	1451	466	121	1	6301	jwKXwXUk5HUg2YTnHjpZNi78KAUmK6Fn8ZpFBNFmyFPepHSLGGb	4943	6958	6958	1617191640000	orphaned
9535	3NKMTM8UsevFsDv9ehvMwM53cANJFDo7toWuE4wRe1mRhCdHg4aK	9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	1631	793	121	1	6301	jxpuSn4QB6gkTWEPknC9YomuiY1azJrPq8mXUGHZTgg14QM4Dre	4944	6959	6959	1617191820000	orphaned
9537	3NLJqmfzekfppYeGUv5eA6zfyHc7PLBi1LSWUhoygFUViS7jhy9r	9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	1406	1393	121	1	6301	jwboP8DW1pyQfRfCvgeT3TVKa85xdxB6RNSXcFgynvsuPi8kfo1	4945	6960	6960	1617192000000	canonical
9538	3NLsXYbKzwUkDTuBDjv15qrjT4NxeKBPuJXPRkgrboDZvLvwCn1h	9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	1637	816	121	1	6301	jwcq7mnTbQSSTpS9wdbz6fCnirNoVEbEkY2bqwno9YS7J54s9wd	4945	6960	6960	1617192000000	orphaned
9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	9537	3NLJqmfzekfppYeGUv5eA6zfyHc7PLBi1LSWUhoygFUViS7jhy9r	1403	823	121	1	6301	jxYDetiw98Ai2mSXEpo92GtQRVvjGBY7zmoabWWV4jVHvoVkxvv	4946	6962	6962	1617192360000	canonical
9541	3NL8NVPSuyXntkt6Q8TGRgWaLrgmhmePx7cvL6c6JannS7i6VExx	9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	1523	1321	121	1	6301	jxJDpuzFMqXzZfqNBSAdwBp5YopdhxyG8ftdsJfn17uTxBjXoNX	4947	6964	6964	1617192720000	orphaned
9543	3NLWDCs62HuytfujK59FUfAXTHUphkLbd9G16Zw41cBEDh14o4ds	9540	3NLHTfwxxQL2VYaQCt6KynXatrDN28HhtwtmLMkxoDSFnmEEZSFL	58	1281	121	1	6301	jwL9s482VDxNu1AT93C7wwtzHu9wAih42ogqL2PkgJejrG2sXhS	4948	6965	6965	1617192900000	canonical
14263	3NKAD2sofjTjgYWj8tXfNYYsepAbNdKD94KwoTadxoL4gdMCcXuq	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1474	1329	217	6301	10386	jx78E8CMK3c85ttXLeauiiwQ3zWRx9dFfynRCRY94mZVqu4hgPJ	7205	10302	10302	1617793560000	orphaned
9556	3NLNsDzvK9W5fNY3vBMvKjd91jdAvURjW8BaAprvWVeNy4bjU2X1	9399	3NKEZc7bCE49XHbPJyNiY4tvLM6bEmbFkxAbNzatZJGrev3sEVim	1654	1340	118	1	6301	jwhNikUgUQnkuMgBWQ4mocpVfiqreWRuyuMUUDXodPxLKuTiHs9	4877	6972	6972	1617194234287	orphaned
9557	3NKpCY62QEB7DyMhCLdeheRKJQAA9pKKhW6fYx5msznpyRT4HdV4	9403	3NLG6EczQ5Vgg1Pe5sXG5eaeczdemztoTetu9qdLjizEyXvVaj5X	1654	1340	118	1	6301	jx7sgrVeZh7vw3LqPVLRCvbT4GbAQhKEqK6NdC7zEz7Mj2dDinU	4879	6972	6972	1617194270012	orphaned
9468	3NK5pzWjnaSuwAj2ygDJ2fKYN2LJmKYFy6rT4VAHcH66gbZ3EkDf	9445	3NLMqToV53ANGr4WYvsGPimfSyu1feYY2WNCvnpxhAj5DVAN6Spv	1440	1011	119	1	6301	jwJ2QZ3D7CSw9iRCX3hDK5tbXKWGpVfRPq8rBLJ3PmfkEBmAtUm	4899	6913	6913	1617183540000	orphaned
9449	3NLoahW5TWn6MeXACZHSn5QqB5dpS1Gr5d4wkPM3ARFWAx8VUuBE	9447	3NK4rGXtMjgSBrLkBfkHETJ7Ju5jurMFKHe9itJVV9XC6mTf9AjT	1585	1000	119	1	6301	jwF849KanjZHxVCr2rj11LvkdELa3MqCQhLoZcU4HshxLzakKTb	4900	6902	6902	1617181560000	orphaned
9452	3NKjP6B5ZB2xk5iwVe23JHhyLJZ7bMnBvfp36xLfye8Tix4jF6aD	9450	3NKxT45JrdT5NvxQCk76ufD9iUMbtmqUixqwCGykATTtLHr677cE	1403	786	119	1	6301	jxVs8yEMLe7fvuCx7PesWEipq1hjyH1N7oztXJyf41xuq5RcSMr	4902	6905	6905	1617182100000	canonical
9458	3NLm9jZoUHT549NvMaMnmg7MzxK5EKCMCo3pAget8xfb9YRYnnx2	9455	3NKqcT1vHr4V22JvwZbm1Q7nrYZrqZuT8fjypjscLwHQCKrWCjQp	1407	1395	119	1	6301	jx2gFuyNpd7P1mrRGn7awCo3V9ywMjTW6BM3FSpsrGkDuqUdqxu	4904	6907	6907	1617182460000	orphaned
9460	3NK7wtazXnWNCc7pz9ZFL31r7zgbrRrvhU1aTtwmqj7RnoLPuTUz	9459	3NLaNYd7kL4QXSL5QUhED9uARb6C1B5xDfxLAs2RpKJYpirrSFDM	1501	994	119	1	6301	jwVQ1PbwhBx912SLHfmonngm8BmADikE1iXTHBqBRGkY19apeKY	4905	6908	6908	1617182640000	orphaned
9463	3NKZoHDnsGViDdZvgJJaYWeAwYVvYwGwrLiZ1hKGA4jyoZv2XTQQ	9461	3NKBPcRrdYKNtJ3erGsRotw2Qc5aUvkGJ91bAdtZmgyzNnPpNCaE	1577	1201	119	1	6301	jxaCPxcAv3XmaL3D1ND4vcKLL4FJ6X6eF1WyYTqnJWuuMR3AxTk	4906	6909	6909	1617182820000	orphaned
9475	3NKEEtx1JnbBtSKGzjsvmHr5CwwtSsRk5J4KJi1xqxYBr4zvdGw2	9474	3NKofSpzmwXFqdvGeTtqnHfz3RmM1krsTakv5b7c1ojne6ZdvkTh	1656	1343	119	1	6301	jwLF3YbKHy4zCpjJkR5x8MvFeKt9hwtho5CKzJcto1KNjNu9tRK	4913	6920	6920	1617184800000	canonical
9481	3NL4ynbi2YP2U9mvEL7JN6TfPNHXb6KNEMtCw9aZfNWXJHQ6Lnu5	9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	1523	1321	120	1	6301	jwRP8JmfbevmY88EpAQiY8MTUZ2eYt1scdrHrUrNzNBvGU3oavU	4916	6923	6923	1617185340000	orphaned
9482	3NKCfJuTcxjgvKk1QoiMidXfT2NXxPqAdiWspwF47ZLAC9pe7GBx	9479	3NLLHFVYL3SipeeRxQFuPviLBdBM1vRCasfh9psvxtZVaR6HghEw	1406	1393	120	1	6301	jxBiQ6DTmwW8XzrhU21i9cavtjjEqoqxSkFXhTwxs4GFes2S86n	4917	6924	6924	1617185520000	canonical
9485	3NKawVHcABYZJQfs2uid7bfEvVHUiqFfE3bbpUwr4A1GWPANM9q9	9482	3NKCfJuTcxjgvKk1QoiMidXfT2NXxPqAdiWspwF47ZLAC9pe7GBx	1406	1393	120	1	6301	jxrStdUECewmjCgk9VEFgVc9CDMFL4rLSsx4A9PzvTiFd2shncj	4918	6927	6927	1617186060000	canonical
9493	3NK6ErJs9JEtgg6Kr1osgW3zGLQnLh8vFstT9oW1DTS3mpmPpCuf	9492	3NKBX64gLK7t7BiFGWUBWNcx4puVLs9iexRTLPKzvnKr5P43sCUv	1447	1345	120	1	6301	jxiBTdRV66KuFrRpy4CKTxae5KRaHvbZnp6aGDdC8NFLoDxy8fZ	4925	6935	6935	1617187500000	orphaned
9495	3NLTgpeTBs3dPtYXKp7uKVxfUEvtND7VtUnXFmoML9S3MPKst4Rc	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1403	824	120	1	6301	jwpAuWSKpezsfAshe8n9TQH57hHmMfpqgsm52MBxwGp3YdtebSS	4926	6936	6936	1617187680000	orphaned
9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	9499	3NLEjHrB5oi4x1D1bU6DiZEc8DL1d9nVPwyxGBTuFX7hKStmq2Sh	1403	824	120	1	6301	jx9jVjRpRCJVKxis7XCPUHodMjtX8kZ1JpMhMGmmYSWEfEFwEEL	4928	6939	6939	1617188220000	canonical
9502	3NKrWvHhmtaeuxyYS5nS3jMAgK9pnWqZDPkQ4xekmsdjMQPhTqJu	9500	3NKW1a4VpDmjxNs62yiuFiEewS9gQwC72Ei3tSpv7j7GHJzzP2PP	1523	1321	120	1	6301	jx5KoWipr8vyMr4KEd5BvJNjdNzsLwQ6WTbo3HL6FFTiuJEbBXp	4929	6940	6940	1617188400000	orphaned
9514	3NLgKS8osPjSf9Ekgdfiv5FF7MAhMmBjjQAttZkefZGyWzUeXGcn	9511	3NKxcouybtSFwqYiLUk94N6BU57v8BikBdiJnrwzYbvQ2ZXii6ts	1490	1274	120	1	6301	jxMDjbvfG1xV7B7VszrxceVBTvRZLHADjYrr3bBfrYj5uf3Lcfq	4933	6945	6945	1617189300000	orphaned
9516	3NLp1Mq9kMRKZhzwh15mzjAUHJfdYH8aNeRo4mEBPrwHe73XHXgm	9513	3NLsUwqgg9wLgs2jPt4fc7C6nCFVcwV2fEtUvBgayJ1Pj8LnoJDm	1406	1393	120	1	6301	jwJRyrNveF4p3sNLK11yhemgr77Hr3e2xYaenwHRrYm9zAgsqbj	4934	6946	6946	1617189480000	orphaned
9521	3NLiAYG7p7ZVPFjqLC559xhqKDGNHHAE1a1xaAosAHChFyq1rpa8	9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	1474	1329	120	1	6301	jxpzx9fGdPSBPMkCyVPfmf2kZWqxVz3oczfpaLsX3iKnfuBBBiK	4937	6950	6950	1617190200000	orphaned
9528	3NKSTVfhDuc2CPbKRaQKioRo6zBLFUSQ39WVJa2KaRsnSRHzDLrj	9527	3NK2wvg2h6qLvnHj57sJc1KKBCdw9zHWQarwbshnwAijiVfwgshg	1608	1163	120	1	6301	jxNPSG6vSCYmNCZ9TBKRvZF6jR7AyUKBXqiFrWwm1syZGdqdpgF	4941	6955	6955	1617191100000	canonical
9533	3NLWzV8HML11G6oJAWR2yfbAWw4NoGDWboL4dTMi2DgxccFiT5v7	9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	1407	1395	121	1	6301	jxy6iqMtzQoj59D7DL8WGgzoXzjEt928oBVaJdbyrzyE9HqJd7c	4944	6959	6959	1617191820000	orphaned
9540	3NLHTfwxxQL2VYaQCt6KynXatrDN28HhtwtmLMkxoDSFnmEEZSFL	9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	1523	1321	121	1	6301	jxKfbye5Xoqr9ZgGsEdQef4mtWG9pc7F6w7NGA3E4uDgko43UPa	4947	6964	6964	1617192720000	canonical
9545	3NLEA174No6FBACGn2zVtF3tBXoQfiVuV3bGhC9hRfDtQNwQqbkJ	9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	1529	1316	121	1	6301	jwVYJaBknELbnqXkH7p8MTvmKrgDgVftM1cznrjoNNcwpXLHUgU	4950	6967	6967	1617193260000	canonical
9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	9547	3NKuuMjf7iTAGM2jULX3sSBxZ7Q2ksBLEHJavQsrX56ig8FAscGQ	1426	1118	121	1	6301	jx8gqHCkmrMfurDtZqosy3CjsVeB6ypYU8N66CsdUxbPLCvYc1E	4952	6970	6970	1617193800000	canonical
9550	3NLPPM89pHTLwbXoeBqHyLC8FHzPGBpWZXPtFuj9MHLcA5v7FFLX	9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	1560	1291	121	1	6301	jxy5ZAYkpoqZ8nydbaKmNR8vLky6HUT4w1nh5xMDUR4MjetDpbs	4953	6971	6971	1617193980000	orphaned
9559	3NLQPa3E6hcVo57eUXhGJSkBVXE9XTK45XKpiLtwJQpxEdFnxEL9	9558	3NKrJwHc9mg6ioF86mKvtmTNiT2sucQuHPJziXvaJS6oCS2AyHZN	1594	1326	121	1	6301	jxNhaLtBCiBv8TQCpvKTzhkfFsGAu5PaDCvDrrtijh3cwe7bqhM	4956	6976	6976	1617194880000	canonical
9560	3NLvvFUqjJEu5mzwPvRLYH8X2mLZs9QWPUvkExBbXNbz5c6SJ7nk	9559	3NLQPa3E6hcVo57eUXhGJSkBVXE9XTK45XKpiLtwJQpxEdFnxEL9	1631	794	121	1	6301	jwCdp1xBTwScofT4m1f3ZCupYV44SmRzBS4LYAQKTguMyCR9u6Z	4957	6977	6977	1617195060000	canonical
9562	3NLrUgywudEvabZyJLpuwHBN71YQUBQFXMqnMABbvBohSGF5McLR	9561	3NK6TKLipzVXqwH993VAuDyL4RphNongtYLUdPjPpKUkdzWHNjkB	1402	862	121	1	6301	jwpm93FJ2w6ZzAfXUtyFKwApjh2NDoDVDfdH9U64itXwvFXvWku	4959	6980	6980	1617195600000	canonical
9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	9562	3NLrUgywudEvabZyJLpuwHBN71YQUBQFXMqnMABbvBohSGF5McLR	1656	977	121	1	6301	jxN8iDrZNBASoeMoNLjavpjz6BnRRG9rXYpeXfqB2y8iAq62ax4	4960	6981	6981	1617195780000	canonical
14156	3NLgm85QFn5MV9c8ASHGfrCDuQdgkupFWy4DbVsf3vUAiE5Uk9oj	14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	1451	1046	217	6301	10290	jx8EeS17qN757JmHkh2nBa3pxzpae4m6oe26pHp61EmaigLEcQy	7209	10230	10230	1617780643035	orphaned
9469	3NKPWCQKF6En9VNAi7Zk15bJvvgNMVUwVz6KoSmCXXsy8WMUxsBF	9467	3NKLm1JL1jUQruqXCqw28FeaAwrfkGnf2Gifto1gHGhSwvtnPsZu	1403	786	119	1	6301	jxt1NPh7RqA7UxXFTei2kzT4qixSmaHFkTTPo4CP4QzQUQN4JnF	4910	6916	6916	1617184080000	canonical
9477	3NLqWzv4YJh4cLA9vnK8w3xLipnqBBsL1sPvYTGDfrfX41aPqWar	9475	3NKEEtx1JnbBtSKGzjsvmHr5CwwtSsRk5J4KJi1xqxYBr4zvdGw2	1406	1393	119	1	6301	jxwBYWmdLb2tSsYuv3ZprQNFo2TcgR7QDRdLmKG8nJzsg5nSifU	4914	6921	6921	1617184980000	canonical
9479	3NLLHFVYL3SipeeRxQFuPviLBdBM1vRCasfh9psvxtZVaR6HghEw	9478	3NKpzZSnx44UpoZZhtYq2uh1oS7Dg4fVUfV4e81jMFVTQqEBnPnU	1523	1321	120	1	6301	jxzEZSWd86YRBVR7FW94iecNmgwLjsv9RSL7YKSJvK9RzbwWA4i	4916	6923	6923	1617185340000	canonical
9484	3NLstK1ydLpv4Z8LNX3YzyJDQiMEFAsmVbkepzyfZE4XG1qPdD3b	9482	3NKCfJuTcxjgvKk1QoiMidXfT2NXxPqAdiWspwF47ZLAC9pe7GBx	1403	824	120	1	6301	jxMDbtLXto7opp5YbmnXrvtkLrmVB8YuxEmsbiX1A3936rXYdBf	4918	6927	6927	1617186060000	orphaned
9486	3NLtdnCTz4z2LzpHFMrEb8NK2ibMSjKjnZ8f9QapD818zZBq7Mqa	9485	3NKawVHcABYZJQfs2uid7bfEvVHUiqFfE3bbpUwr4A1GWPANM9q9	1422	1091	120	1	6301	jxtH7VmD5o6fbVpAa3dYVj6fZ8Bx785sZnF7bQx1zC9igCSiSnA	4919	6928	6928	1617186240000	canonical
9489	3NLBVg4y7d9dyzP12yMzTGBaKpPdcyStd6j8k3yzM7eP8dLqYsWd	9488	3NLsXCXHhUQcB7Hu5X3Df2a1UyBiVNfLsjA66RTLTDegn89aj7a1	1609	1333	120	1	6301	jxWt8V9udHNCjtWRKSBHirGe8SN4FzHuT9Cuapz9rgka8epmbmu	4922	6931	6931	1617186780000	orphaned
9491	3NLcPWHBuyBjrhKkBhQHnmVdbwaykaJ2LExHTZvsp3rVysseGsgF	9490	3NL7KjGsXv4Rw92SeSeYCfeHEoCGfcLaRm3fBRG18CdEyknQSXxL	1419	814	120	1	6301	jwk2e4XQUjkcYpKbR3wSdtvqUiRSWAT1cfzbRW3CLFDLWkQBBh5	4923	6932	6932	1617186960000	canonical
9497	3NLEqEYGQA7g6H3d2Rcg5qFpjfp6JLA2uYYw8A1a4Dks1dmUYAYU	9494	3NKY1LZQJcegZYHhXf3qvBHaFDUEbyebqVznEEgb1PJKuXjkaaXY	1406	1393	120	1	6301	jweMyJ1v2Wp1Aothst6TJYQ38cFGrBi1YTBNAdtHsCx95ULEkug	4926	6936	6936	1617187680000	orphaned
9510	3NKbqMgLTZcZWnpzYVbZLr5FH7pdcN52B2QqvCBhe4WR6VHRZ1xZ	9509	3NKm2UNX3GfYDTXfqTuN8FpWE3wKgca2eFjbp6KujuWGsXiCy68a	1444	1381	120	1	6301	jxJpRks6WaBcPFYbPSZgZsR1LQ5uT4HZ2mJxyDk5u8tg76wEoiT	4932	6944	6944	1617189120000	orphaned
9517	3NKiouCKZgChh8k4EVz4yR5AfKCY3Fgw22ctjvFYGBR2dkiatupB	9515	3NLQuy564eEmNsjw35Vfjzn6rr8ouF2eCumbeNbF4NrPrJiigyDN	448	1305	120	1	6301	jwEA2H8gqwqQCrorv4MPPBTaSc9dDcvukAKF7r8VDVEX2bMEtT4	4935	6947	6947	1617189660000	orphaned
9519	3NLdxMx7Gf2zq1Suazy63g8wCThyUGgywtSh5CpAeDo2r5T8NyHG	9518	3NLf5JV6xqvF3cddbXPKuvT4bziPbhKczPqF6B97UQhrpUz2otnd	1673	1368	120	1	6301	jxFaVMaw568U7vrr6qTHdQ9eJoM6PsPiatHRFpFgoyNGVGUW7gh	4936	6948	6948	1617189840000	canonical
9524	3NLwgvb6Xyg9X2VmX5FR9K2KF7oLTWKvCVb9tgFx6Y7dnviX2CMg	9523	3NKfW5y8vhgijeigqqryoo88VW6RpQzpJQsNLXP9E3Z3xCLzNDrF	1627	1385	120	1	6301	jwrJp37Wnzt5cebkuFwJ5HUPvESsFj8xHgYr2TijWdZrYBYf9Si	4938	6952	6952	1617190560000	orphaned
9529	3NK5k4bnLLxDM6DNVvMsjqkFNge82U1CAmvgxyXNWdC94G8Dy6ic	9528	3NKSTVfhDuc2CPbKRaQKioRo6zBLFUSQ39WVJa2KaRsnSRHzDLrj	1403	824	121	1	6301	jw8ee1MiJwGd7zeV4F2TCEVPzkMjzrwyb1PrAXjsFpLVMB41a3B	4942	6956	6956	1617191280000	orphaned
9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	9532	3NK6GciojxXUGcvjqDPmRui4yaEMvtT7eMwtkgwsgjdPn5HoJ26i	1594	1200	121	1	6301	jxwQMLkDFmcLrAE1tDzvS6xRDihjNiWvZLP39JZdowZLLL3JYZJ	4944	6959	6959	1617191820000	canonical
9536	3NLeQ7RCQ9SGL8ieY2oSzdc1ERBbCDiCmx4KZa9jtLE6qtMwuP3t	9534	3NKsEUPf1nUq2MDpeeFJufeEsoYa7uZBhRXz4GwxeT1gUa8oXrNC	43	43	121	1	6301	jxGdmZt4WPFnUvetRxuyKWEJzXS6evChtxQdvjHpaZAPSiWUtnR	4945	6960	6960	1617192000000	orphaned
9542	3NKurrEwNKLALXndMpRjjPF5Xz1oq6HkW43TCA3hqyV8PxXVp2Vh	9539	3NKMiMNUTvRy8WNVxbQpvUz8Z8ib1NxzKuKSGKWwgimHbrKqDybK	1523	1321	121	1	6301	jwR1q4HNsPqfFjBMqHVwvkHRKbZBSCeMuzVofNE3M3xfnaWBFuA	4947	6964	6964	1617192720000	orphaned
9549	3NKhc6PaS3ULttrTBbdn8w4Raoxcu6yUAxAoeWrnL6GQwTVVCDGf	9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	1608	923	121	1	6301	jxE5XdEKA3stQ7gJTTi9e5BHYZdeuCtcEVpMZsrFCVrHqb43VvE	4953	6971	6971	1617193980000	canonical
9551	3NK6DBDTx4nzMF1ZeBW29QvWsydH3k2tk1Q2H2rYyjobsCLngWGM	9548	3NLbC73Kitr5QKMoL3y9Tqn1qzorg9PKd5zKuwozLnCSR5AbkQV5	1560	1291	121	1	6301	jwy2X3xD19dj197qwfZUM4WPKUQwduv6TQXPstXtJTSpWXN1RAr	4953	6971	6971	1617193980000	orphaned
9553	3NKAUTetUQzAvPLw2nfyCpu6gNHE422duKo4tKV8QAZrZStMkqm3	9549	3NKhc6PaS3ULttrTBbdn8w4Raoxcu6yUAxAoeWrnL6GQwTVVCDGf	1657	1344	121	1	6301	jxBTSvHEAPetXPc3tX73YnKYiCQynMsrkAdLrUBEsoWeucTTtsj	4954	6972	6972	1617194160000	canonical
9555	3NL8jkkwW75ViFVFopo6MU2zcK97RAz1mJxrw7w2htsCQZtsCJPQ	9549	3NKhc6PaS3ULttrTBbdn8w4Raoxcu6yUAxAoeWrnL6GQwTVVCDGf	1654	1340	121	1	6301	jw9D2h2jJZpKbz1zzSfAe7mMxktYg1pY16UMj5HCVuFv6STQG7z	4954	6972	6972	1617194160000	orphaned
9563	3NKR3UeTE8cyJLHXNJqfAF5H2M86872FFgxkfxYRs1Gs7VpGvpwf	9561	3NK6TKLipzVXqwH993VAuDyL4RphNongtYLUdPjPpKUkdzWHNjkB	1406	1393	121	1	6301	jxJyczSnwSdPLwBk3nKgE9pri9MejvoLJXfUxaVHv8tpyGBggpp	4959	6980	6980	1617195600000	orphaned
9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	298	1062	121	1	6301	jxd62LPTGjYuQcXUH6dRrRbood6d83nWNiTWrvQ3kiMFWTzAa2M	4961	6982	6982	1617195960000	canonical
9568	3NK8EQnYri9YkBiKwjXeBeFm9S2muM5Fcoae4PNnfcmHJTd6pUtV	9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	1581	778	121	1	6301	jxj42tEPLZnKua49525EKubhte7Awi1SAadGS5B4gLpRj1YpqMi	4961	6982	6982	1617195960000	orphaned
9571	3NLQQqpTFGnqDo47fpJ7RFBzU7HqaMmPqBU7WX27xfmNgNy1ewmJ	9569	3NKPvCsgvM8QYgJ3iYAwPMNYgfkC8tMyYCt3XCp7yKV8qVbPmimc	1406	1393	121	1	6301	jxHEq6ga4NA5KUtsmEBNPw8k7apd7zVDJFP8cwd9eKd7U2sMuVY	4963	6987	6987	1617196860000	canonical
9573	3NLBiUkhvpVsSBdDTaNTiAhVMkDf4RsbB9JjHvRpuypV5BaauncA	9571	3NLQQqpTFGnqDo47fpJ7RFBzU7HqaMmPqBU7WX27xfmNgNy1ewmJ	1406	1393	121	1	6301	jxGQHurMS9Mc8KunycxTwSqskeQ7ozCRwdYCpMdL7p7C9CBPWze	4964	6988	6988	1617197040000	canonical
9572	3NLktzER5aJZGwrCZeoT93U3eUkiiyoaBotS26L33tWiKykTZz4j	9571	3NLQQqpTFGnqDo47fpJ7RFBzU7HqaMmPqBU7WX27xfmNgNy1ewmJ	1403	824	121	1	6301	jxGctZcaRbM4GPW2t33jhpEQUxsWp6XEitLz6dW9jJnpxirHvBc	4964	6988	6988	1617197040000	orphaned
9575	3NLeZpvjBbCaVoTGuEsaMhCxdHdK3eUHZuZCUz1xYigUUUHkf9Qr	9574	3NLiJ4giUhxtU5HLwCjs658A4gkk5P82nNEx4M4nxxNNoxbmeYYx	606	929	121	1	6301	jxsbUFkceHDR7PNYkcCqnyk3vUkAmVBvF2JrJ4KFTMBhKSVEouC	4966	6990	6990	1617197400000	canonical
9576	3NKNFgKuFn6PEYqvZY9iy5b17wAwmfJnGfY4MgtMjVgScjHycjqF	9575	3NLeZpvjBbCaVoTGuEsaMhCxdHdK3eUHZuZCUz1xYigUUUHkf9Qr	1581	778	122	1	6301	jxkjNuSFn1XcR7sH2wUTsqWPTvRYhKuSB4cC5hPTFxBAiBQVX7V	4967	6991	6991	1617197580000	canonical
9584	3NLmhjYEuzfQGhr1czfhuJmgspQPM7PhoHy3FQ6NLzrPTh7L1FBr	9582	3NKhZUedA2vnGHhgazZqHXMRFwaXg1AXcjjBaH9CyxGVYAkVXHxq	1407	1395	122	1	6301	jxRXLqYPnZ9NJ6SaNMkKMSzTJpMs53uGFGCR9ySgDzwUmWRZb7H	4972	6997	6997	1617198660000	canonical
14127	3NLLH34oVUEHfetyVKCgP57grjfjMx2DywWwm1eGR7j4W5fB7Bfb	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1422	1211	217	6301	10265	jwrKJgouqgsakpNcisDNMPH9mCJQvSWVqThkCsigktRF8DKuLpV	7219	10219	10219	1617778620000	orphaned
9544	3NLmoNVWDg2SBy6NvjAgoPP4kc88ABrcEUz1A2czivdtpK4EL7i5	9543	3NLWDCs62HuytfujK59FUfAXTHUphkLbd9G16Zw41cBEDh14o4ds	1542	1058	121	1	6301	jwNuwTZqG5QSYaB1mcPLYkSb4ygp3HnZ9uB4jSTF8BeaEMh37Yz	4949	6966	6966	1617193080000	canonical
9547	3NKuuMjf7iTAGM2jULX3sSBxZ7Q2ksBLEHJavQsrX56ig8FAscGQ	9545	3NLEA174No6FBACGn2zVtF3tBXoQfiVuV3bGhC9hRfDtQNwQqbkJ	1560	1165	121	1	6301	jxfLYHDMUrbH2HKWu9X5pyVj3BLV8Ki8cUvjn28dQygb7zf1Cov	4951	6969	6969	1617193620000	canonical
9558	3NKrJwHc9mg6ioF86mKvtmTNiT2sucQuHPJziXvaJS6oCS2AyHZN	9553	3NKAUTetUQzAvPLw2nfyCpu6gNHE422duKo4tKV8QAZrZStMkqm3	1407	1395	121	1	6301	jxk6EtPh24gHdpHbt5Xy9q692azhcytpDa6LowfrbykRJiV5t5Q	4955	6974	6974	1617194520000	canonical
9561	3NK6TKLipzVXqwH993VAuDyL4RphNongtYLUdPjPpKUkdzWHNjkB	9560	3NLvvFUqjJEu5mzwPvRLYH8X2mLZs9QWPUvkExBbXNbz5c6SJ7nk	1405	867	121	1	6301	jwCPt1UCAmU6joe3X72s6yxygT4f9Udgt3qxedFByyvhhp32Ymp	4958	6978	6978	1617195240000	canonical
9564	3NLGbHXraP8qJZPRDzEc9EMiSv7R9JfDjf2GbuHzwTVmqDH8Nvvv	9562	3NLrUgywudEvabZyJLpuwHBN71YQUBQFXMqnMABbvBohSGF5McLR	1483	201	121	1	6301	jxGRA2nCSdqS7NtRcsEGneVGDEy7tidTGaVVeZprJHX4UjA42Eu	4960	6981	6981	1617195780000	orphaned
9566	3NLtX4uuZTc9G7Qow9YWMAyWMWXoCQLWhVnNcRTMNDihuS3uYuFH	9565	3NLLh9gVrfSN8yQAM8eFa2q1khNp3PnVbyytBZAdkQJQxj2424mp	1609	1087	121	1	6301	jx4UsuRFCr74MEQSh1hb33JzKENuiS5C3fB2LGkKNy8tQy5aFRW	4961	6982	6982	1617195960000	orphaned
9569	3NKPvCsgvM8QYgJ3iYAwPMNYgfkC8tMyYCt3XCp7yKV8qVbPmimc	9567	3NLcuj3btkFnpwwy4FjurGkggEtysHUFjuAixoNuJKfefMZrNvH3	1422	1091	121	1	6301	jwojcpWLpRbJ8eTAd1QZabGXwR8XgvbNJ3tpriKoWtiwwevnZ4a	4962	6986	6986	1617196680000	canonical
9574	3NLiJ4giUhxtU5HLwCjs658A4gkk5P82nNEx4M4nxxNNoxbmeYYx	9573	3NLBiUkhvpVsSBdDTaNTiAhVMkDf4RsbB9JjHvRpuypV5BaauncA	1405	873	121	1	6301	jxyvP4a8uqXRySh2Rjs2T8CSZyXkrY3zp2yAfZHzB8dARqhvHX9	4965	6989	6989	1617197220000	canonical
9581	3NK97r7yszRih5N2MReEcE5KxQ74cP8jeth5Noq9x6VnGNNUy52E	9579	3NLHgchu4dMcZfviRufhAFHbXmAc4Re3pSfXwUDzkx8re9BCf7Qw	1588	1392	122	1	6301	jwEf3NjdoW8M8BjSGyoRD3iMn9rs3S7BRhiif7YeVFgQ1U73k6X	4970	6994	6994	1617198120000	canonical
9588	3NKoEwcjSYygWmq3ZJkoXa1QC6RKPf6qccUJ69FJLXnE47UdEnJo	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1581	777	122	1	6301	jxtL2kAMVKMfXVEYf3E8L2wDjTPXfBMvQ6qopVc9ZGwxdessDfX	4974	6999	6999	1617199020000	canonical
9589	3NKA7oq9s1np1sSUumQuG7SiwVerTzjNsj8mLrQ2qWw5uD9JoBx4	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1631	794	122	1	6301	jxvq3M2bkPDVCYu7ErHXoYVtSHnJMUpmxFCpGNJFpxHtTwRnTq1	4974	6999	6999	1617199020000	orphaned
9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	9588	3NKoEwcjSYygWmq3ZJkoXa1QC6RKPf6qccUJ69FJLXnE47UdEnJo	1406	1393	122	1	6301	jx8nFYEdBBcUnRcappSSaG7uUFftUzqRs5ns1gRhCo6oBfp7WGo	4975	7000	7000	1617199200000	canonical
9591	3NLPtB6hSSRMKaPdEbttBVwoeQiqQ32LBoeauuFNASeHi1vessDy	9588	3NKoEwcjSYygWmq3ZJkoXa1QC6RKPf6qccUJ69FJLXnE47UdEnJo	1593	1346	122	1	6301	jwfniftY8Hnfm9LqYgFtXAVbyFTkuHYnzWyvqATDM6g8q5PNk9j	4975	7000	7000	1617199200000	orphaned
9594	3NKAUL8GYCWGojqrAP7TTBWunxcYEGSj7F5qoYNSSi1RGCiqpqQW	9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	1523	1321	122	1	6301	jwyS9sMbwGC9D1Q7ks9sUHeiEDnEZ8diER5JZKT2V3atb83jUAa	4976	7001	7001	1617199380000	canonical
9593	3NKXja3RQkLuvsJWc7cWfio7phPRCuQq67AoJoQ3fbHNvkMAJFoM	9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	1523	1321	122	1	6301	jxpHHzC9Rw6J35sLeACHjAAF2cP7ERindUbcSk5wJgtxaYc4mhk	4976	7001	7001	1617199380000	orphaned
9598	3NLxpEca3dcQnV1rqWapmrMBJgQzWpuYVvTXvoXXV8VXppJzw22E	9596	3NLNMpiDLGzdSHPUPgzhYVEtyRGakfHD2Y6jLPqrJJUeYRpLtgts	1637	816	122	1	6301	jxjJvcTPPFhp2cVacLkzgTTQ9RpiN6jffFYatmn4RehVnmYPrFB	4979	7006	7006	1617200280000	orphaned
9603	3NKZfWFmn8tPpzqRsjbn8bUK19xo47vu7W6XrcM2cdmJ29iG5tag	9602	3NLojTgzhMJRSE2f64oUnDt82S5P3QHMNEoCU128hb3uQ1qUJvMF	1407	1395	122	1	6301	jxVYj69Z7teEuoXvXatKY1Ahn41N34VXeNG9TkDq6S11T9SQfqj	4982	7009	7009	1617200820000	canonical
9606	3NKbGTpKRKS24KerENHjBN54ejxDwGKhHxWHmQebsXL6PADNTQaE	9604	3NL7Vc4atus17VAQFzUBoTaAkCVFcES8Jkn2nUqkEFJoU5ZQEbNz	1403	824	122	1	6301	jwL1Fn2ENtb6GuuDBGaozYTcmP4YYtVEB3ZMKcTktBmgH2hiwvt	4984	7013	7013	1617201540000	orphaned
9613	3NKchFiW6KmCYHAeMW4nY8diRrwWe1mWn9FAoynGoNgh1eYosyTf	9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	1637	816	122	1	6301	jxHA84G7vh5LUzEjE2u5DNyyZrbipxum5KVtdfZLs5qHqSF1p1L	4987	7017	7017	1617202260000	canonical
9611	3NKk6EB1kqZa56Y9vn9LXsrjxx9n7ZHbqWWdShoRYhG3wjYqpHUF	9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	1451	1166	122	1	6301	jwS4an99HuCDUXdP4YPGrcbQmwdjxS1yeuvRQkV11xwM2igZTey	4987	7017	7017	1617202260000	orphaned
9624	3NL9vdeBBXhA3YdrKt2vqAYPaJ125nDVvJ41fKVWQ8g9uHD3htD7	9623	3NKcipz589LEJY3a4au67989giUCbgjEcYWfKbeqAS8NXbHSbAvv	1402	868	123	1	6301	jwJB4F8KL5oByUKcnoapKacqT3v8rvnB6REvKDYEhyQNDFLcASF	4993	7030	7030	1617204600000	canonical
9627	3NKP8Yx9XwSsSPDA4HLkcKnDnEEewEks4FP6qEx1RvmYgK2upsoi	9626	3NKExctYENxSUb5yuQ9L9LFMxJLGZU6NkAFy91nWjCidFroYzvwW	311	1181	123	1	6301	jxYzm7XyVmi1yTHMGbfQGRYkPJ1DX4gg8T87VghziQePWaHj7X1	4996	7033	7033	1617205140000	orphaned
9630	3NKeiEhmMXsk2Dz2MWPaPHHxi1Y7AWBduVGwfxevSacKxQobUrbm	9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	1650	1375	123	1	6301	jxKzpHcXvbqRuXnBRrC1rcfHZQh6uRq19N9oTT1PCNJXuSN2C12	4997	7036	7036	1617205680000	orphaned
9633	3NL3LNrLxiiTsL4GrGFRwgPZVXVZwaJLBw7Tqc2tAZLeeRYHLsmW	9631	3NLU9vTSBoGYzb5jrGeUw93b9k1fVbdo62sZeAxsADWsaMcWDf9Z	1508	1141	123	1	6301	jwxP8mh5q3ZEdTEFvEy4URwT9cuEVnjBos5JbbvMgNMnYmQBgGv	4999	7039	7039	1617206220000	orphaned
9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	9634	3NLn1bsWFjycHNJGGLy3KSxXSW6ixmFrunn1iym5GWjTXxkt6oFi	1516	1294	123	1	6301	jwXcy4BLoEnUKQZfgSw53V67f5svwBhn51f4zG5qBLBEapAJTXy	5001	7044	7044	1617207120000	canonical
9638	3NLjdtRWCDzrTNu1kFmsHd5R9fxnzEV2cqvoKQhtWRiTtG56CvLY	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1654	1214	123	1	6301	jxaA2jzgdSeQzCNkR9TphqqCr3LPhKzPD2ZraeZ41sQmsa3PfNn	5002	7045	7045	1617207300000	orphaned
9656	3NLfNoXFQGkZocN9R89c13rihe9DwYcVrGFFnmVE6WYYoMzuvdHx	9655	3NKQcZG98Pi5vvjX9SzWNgoiZEf3D9HSuTMPwBidLZmgt6yWuRgs	1447	1345	124	1	6301	jxo6rj6yfjMFg2A9mwvs7yfRap4bzG6qRKoo5yTVT5WWv71CNe9	5011	7054	7054	1617208920000	canonical
9664	3NKzCQCETifaw1A5amgyJuDB8Z7tWoXrif7tXW2wT2R8CCuz1dNJ	9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	1474	963	124	1	6301	jwjYR2FGoDACuagyDA8s5awJpRtM2xcAVY5sTasCNqSjS2tKQFu	5015	7059	7059	1617209820000	orphaned
9666	3NKSytwnugPDxYvwrTXymN2Ae7CPmaF3jTuMEspDpa57CywTavMr	9665	3NLY3L1qqKxySpMWn91gD5tXFQGAEkdfC2DWD9D6tdsWetkdpRoF	1402	866	124	1	6301	jxAQH1mSE8TYuGiCdgCLAAiwZkfzNvrRFNBuoJyyJepnbnuZ5ot	5017	7062	7062	1617210360000	orphaned
14133	3NKTWHPLf5c3af12HdDP2ojhUN4WWzZd6BcF6CMbMPpU3kAKTPKw	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1483	551	217	6301	10270	jxRfK7XsizCLndd2ENU6TLGX7j26FygeiLaaDSA9eCHynwhXvWu	7220	10222	10222	1617779160000	orphaned
9578	3NKbcKDf1uYEnosFVmQEuaevEJkvVQMydoDbuCj27CHdsxrHw6dY	9576	3NKNFgKuFn6PEYqvZY9iy5b17wAwmfJnGfY4MgtMjVgScjHycjqF	1559	987	122	1	6301	jx9dRpTGZLpxewkbiGNpxcqfGWZAPqd5KZBHDfiX6bXmw2RedVq	4968	6992	6992	1617197760000	orphaned
9583	3NKLLoAdoJrSMGoHXQP79McMsDdA6opQ2gidSrAAd59ZKzQHyHF6	9582	3NKhZUedA2vnGHhgazZqHXMRFwaXg1AXcjjBaH9CyxGVYAkVXHxq	1527	927	122	1	6301	jwGZguDpyg2c6QxdtLR9rG9SosX8WdjatAWQKnEqme7mB8xuDwJ	4972	6997	6997	1617198660000	orphaned
9585	3NKHrn73uJHLXDFAhkca4AV456y1CayDzAR3RnLEWj98Nd4tTkUg	9584	3NLmhjYEuzfQGhr1czfhuJmgspQPM7PhoHy3FQ6NLzrPTh7L1FBr	80	1273	122	1	6301	jxX99YLvaJS4yF2f524jqMidiSnhmXNMhWBSvdjKLtwUKRuaRcB	4973	6998	6998	1617198840000	orphaned
9592	3NKVkJdyBEnjWXC2rFA7qaKp6b5mMjLFPEn9Qbf494nwGCPapuZc	9590	3NLR8N2qZFTXjytCPsUb45otwk1scfznAyUnJPftCDiNPNgbDCP5	1523	1321	122	1	6301	jxr1dGi8oFkDxGQRYuFjZcR46cTvzJQQBoZS8AjUp3sM9opWEM4	4976	7001	7001	1617199380000	orphaned
9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	9596	3NLNMpiDLGzdSHPUPgzhYVEtyRGakfHD2Y6jLPqrJJUeYRpLtgts	1596	1363	122	1	6301	jxzA8CYnf1vV3x6vnuiPfAU8MZoNRprdfagwiGVg79MdXwXtKYQ	4979	7006	7006	1617200280000	canonical
9605	3NLdpMZjri53VmPVbMpR1FMJAjcM9iA1FSdCepygSuqhRMgukgsW	9603	3NKZfWFmn8tPpzqRsjbn8bUK19xo47vu7W6XrcM2cdmJ29iG5tag	1596	1363	122	1	6301	jwffv9KbvFhdHyHX4pPWe9VrjjWbe4MgNpDFg5RfZkWxbRHHrb6	4983	7011	7011	1617201180000	orphaned
9607	3NKdPieeBAexaiJjCAzGS1Cj1syGJywht2GYaorP8QGLbSQP8Er2	9604	3NL7Vc4atus17VAQFzUBoTaAkCVFcES8Jkn2nUqkEFJoU5ZQEbNz	1581	778	122	1	6301	jxTn2FdYFpyNworRafAwkkw4Zhvr8jsAEWmwdQUXpDi3Gvps6fd	4984	7013	7013	1617201540000	canonical
9610	3NK9Y2o87xZNzzUwxgw4qtVeGeRbhA2gHUEcfNYPaLvNnHhW8Wv1	9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	42	1361	122	1	6301	jxQCSsSYgDETdEGSgJ1T4e7b8aPj3RwiwUbwXdhhkTcBzMA3AP9	4986	7016	7016	1617202080000	orphaned
9614	3NLjxFz6fgqNiFiwWYcdKbRnpBjrxeDeAV8Baqenw86Pbz4tmBj2	9613	3NKchFiW6KmCYHAeMW4nY8diRrwWe1mWn9FAoynGoNgh1eYosyTf	1407	1395	122	1	6301	jxZgwVsJdXeknJxVAw875KF22pECHH3GYh5FWjk9tWvuHLjCjoY	4988	7018	7018	1617202440000	orphaned
9617	3NK2vM4URs644U6EZYeaL78BwYDXHRmZTmXjstYdbdwopK15dRmp	9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	44	1325	122	1	6301	jxeAQgEjyJ1ez5pBKTGrV2EKFxQ9uHAot4n6KU46srwqQScanQY	4989	7019	7019	1617202620000	orphaned
9620	3NKiyxhxfohCGpHkQg7TC1cNxHzAHbcHCUAdSM1aNt2u6dGtVrvC	9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	1474	1329	122	1	6301	jxVJGp3nnYD1VRDk5ita7ShAC44uYGRTXH3aiXenuYvCrHdwAo2	4990	7023	7023	1617203340000	canonical
9622	3NLCgStAZSqfGPZE8N8RYZR1XNjaMzMKnsNu9N8sUu9juRaf7xoZ	9620	3NKiyxhxfohCGpHkQg7TC1cNxHzAHbcHCUAdSM1aNt2u6dGtVrvC	1407	1395	122	1	6301	jxpJG1AYiDYgnBaTEjppfkY3whi5LSM6MtGKcgUX3uuwUY2Cwy3	4991	7026	7026	1617203880000	canonical
9623	3NKcipz589LEJY3a4au67989giUCbgjEcYWfKbeqAS8NXbHSbAvv	9622	3NLCgStAZSqfGPZE8N8RYZR1XNjaMzMKnsNu9N8sUu9juRaf7xoZ	1623	839	123	1	6301	jxMoT8D3KacgY75frjQdbJEnoAcj7HkfVH7caJanVKKt1a3dukw	4992	7029	7029	1617204420000	canonical
9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	9626	3NKExctYENxSUb5yuQ9L9LFMxJLGZU6NkAFy91nWjCidFroYzvwW	606	1295	123	1	6301	jwjoEKD8Wvw7SSNaEV4iiKHniDgWPZL9TMkMAZgQpsWaTyobnWF	4996	7033	7033	1617205140000	canonical
9632	3NKYJR1m2hFXw169JR3gUrxYv6KhG8TFRaidZJb17SXjxBChYfEG	9631	3NLU9vTSBoGYzb5jrGeUw93b9k1fVbdo62sZeAxsADWsaMcWDf9Z	1622	1230	123	1	6301	jwwd4t9pK6EEifWUCPmSNKfVyBKD1kYf4ftpfPeWN8x6LKjFdk5	4999	7039	7039	1617206220000	canonical
9635	3NKycYf7KsJnYEjxdhXJhVPEZTnYkuHf3wXEfUQaoyTyTVTyGW15	9634	3NLn1bsWFjycHNJGGLy3KSxXSW6ixmFrunn1iym5GWjTXxkt6oFi	1607	1348	123	1	6301	jxc1rknTgo8ndYQi8v4WvCEZkqGejfu3XSne9ASxb7rgsJJpD55	5001	7044	7044	1617207120000	orphaned
9644	3NK6ixgQMyf9c1PVHcXb4DPSZzmf4LEPaxGqxgGSwdtj8RDoqtv5	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1471	1386	123	1	6301	jwgfsvrrN4zLnj3h5mcwY21ToYGtGn4UPi3xN9429uiJRy7qW6W	5002	7045	7045	1617207337553	orphaned
9646	3NKr8K58vPh4mjrD9tgySSJ4EdsQsT5DQo6FsAysmAtxhfPASxjJ	9645	3NKafhdHewqWDerkSki7BrnfMhvrRsGd77cKYpQVUzCpPskjpKT7	1406	1393	123	1	6301	jxGmwWhXmekBGfTzAaTHWbQ1mwRPMW9mCDsesdyiX6Tpm3ivp2v	5004	7047	7047	1617207660000	canonical
9649	3NLcJ9mbVjsaWMHo84cRtaobPF7arEqcXmVSGym1fLhWNZBQnXXi	9647	3NLi1KcQYbpiEkxnfFEQ8UJMEUnEPQveAKrtWvN5rAG3VEvjSVkc	1403	824	123	1	6301	jwzwxtWcvjEjch5tqr6rBPUy5ksKjhNGgcD5Yikxfb6kJ2uEGif	5006	7049	7049	1617208020000	canonical
9651	3NKSxsJwyNBNJhFkAjgPSEQdLMmRsd8xtF4MZWU39vAihHYyEmBx	9649	3NLcJ9mbVjsaWMHo84cRtaobPF7arEqcXmVSGym1fLhWNZBQnXXi	1652	1189	123	1	6301	jxh2nep8Nxe4MEHQVbUjT9Hvvi2UTMNMqUAp9wQfThWoFvbKvPf	5007	7050	7050	1617208200000	orphaned
9659	3NKDE21zX7HH3oBoJrCmj3yK8B3kYGj4bLjWFFSB7BgQxjejE463	9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	1406	1393	124	1	6301	jxzaaBrAXtMtcoiDRif4PVyuZqj87WnTbQ1qCWrpSm8XbMwybAq	5013	7057	7057	1617209460000	orphaned
9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	9660	3NKXhTvd9vJWAt3Qc8LZE7rznNoLmywynLg8YJCCTEJQ2KY1PaFE	1631	794	124	1	6301	jxKfY6RMmcnXn6z72SG5YEKx4upVGij78ZWsKEa3woGZEwJYWML	5014	7058	7058	1617209640000	canonical
9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	9667	3NLnWvcKvM4BHEXJKbk66a7LXBCHYbHrE3VFN95RHFFJgfnx5uvS	149	1283	124	1	6301	jwrRREfPq8PZQz3CLJSXkMoYmHLCU3TjQk6vAewaPFVzuBSXen4	5018	7063	7063	1617210540000	canonical
9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	58	915	124	1	6301	jxZ1hTbkugGake1LdLqvitr9Qv6BzdJg2VXBkYT65B2CSoQEAaj	5019	7064	7064	1617210720000	canonical
9673	3NLmrhzdU9iaDPbfiWdYvi61cQ15WxTq1mRMpcFXRnMYXCJepruU	9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	1406	1393	124	1	6301	jwMa4v1Fdc8XiyJhF2stE7cme8QEdcYKHbg7WGMLTy7KFtZtTeQ	5020	7066	7066	1617211080000	orphaned
9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	9674	3NKq7XS2YDCiNKX6zpc3z4C7ZwsdBXdwbUuGjFCLMmNx2HLawAWH	1652	1069	124	1	6301	jwd233ssDhaG63z16N8icHisYatH1ECjm2kHZRKSH7ryq7Cbmyn	5021	7067	7067	1617211260000	canonical
9678	3NKjH266m9Nkj4hMpRyoSHxMdvLdMWjpbrQiULPursm1tHVVerZB	9676	3NKtEUWPZtCuXuNU4Yqb5cwQTVS8151vCV3ovdeNRrRVaMhp2phu	1627	1019	124	1	6301	jwmeQv6DUoBBL78TYfk4ULiYiGR1DJyydaD4u4EKNm9e7zMPrcd	5022	7068	7068	1617211440000	orphaned
9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	9679	3NLUbyaJWdeX9c7jWq2Le4hNPSR7EGBuyaxutq8npyukkkAmft1d	1407	1395	124	1	6301	jwwhfvifJDpbaon4GHg1ML5n2zqeDfFfgLx9vSnZcBkp6bDWuZQ	5023	7069	7069	1617211620000	canonical
9686	3NKpwPR3sehfUHR9weW37xABxy8RmW9FohqZUjByPqzQWjhNLQLL	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1637	816	124	1	6301	jxyvvNFWdyaPepLxBTW1vUfPAvAqyoSUgZ8FFUybpLxqg7r3kKV	5024	7070	7070	1617211800000	orphaned
14300	3NLQZzePxe44Ka54dNuKsN5MZY6FHjWWSZbMsqZecZJ7kFN2TYFd	14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	686	686	218	6301	10417	jwYuSj8CkL8Tn1Bdf8VvKN9wGXyeMHhxmpoFD3gQ9An9rnHsV7v	7221	10327	10327	1617798060000	orphaned
9580	3NKCf81p5vnJTphdALd9pJ2PTrQiB6C8LCmaBTqwJFJchgQa1Tdm	9577	3NKen2Hd6MX2wnvt9ftVoVniShed3f9L6ui8BFLj7tDusWPxSCXC	1581	778	122	1	6301	jx1fNSBC4TDeGYM7ncfM7se9PgHubB21nHFHFXxM8HmGNzPmNk3	4969	6993	6993	1617197940000	orphaned
9582	3NKhZUedA2vnGHhgazZqHXMRFwaXg1AXcjjBaH9CyxGVYAkVXHxq	9581	3NK97r7yszRih5N2MReEcE5KxQ74cP8jeth5Noq9x6VnGNNUy52E	1549	494	122	1	6301	jwo76vGVEAx2Wson1JYUqg37qwnSWoFJCLM9ZZG5UmjWUjpwtyY	4971	6995	6995	1617198300000	canonical
9587	3NKfWHzsBrVpjjpGtJgiUtBnAv8JdbYRMZihdwEceSCGKrjsC3td	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1553	776	122	1	6301	jxfvCKHcNcmAcAJ5QkrKdYW5yESdjhqe8eeTrycezocUUU7ibuH	4974	6999	6999	1617199020000	orphaned
9596	3NLNMpiDLGzdSHPUPgzhYVEtyRGakfHD2Y6jLPqrJJUeYRpLtgts	9595	3NLktfVoWnDxt56kGdo4HNW9NaCXMoqcYS2XSnN5a8EzE53r6YyB	1579	1389	122	1	6301	jx5ynFYdZaiibLSVsp7dF8TDfAEg9pKG5Dy123wGC9EP6AiRu1L	4978	7004	7004	1617199920000	canonical
9599	3NKH8a5AaG8hpjFJRQFrRGZkBB5vtAXcEd4YGCgnQzLyeeVPK4qw	9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	1599	921	122	1	6301	jwxGLohQMsKezR6wt5fVSXxZMyNtzDKc446kQDCUfKe1rbxQx4C	4980	7007	7007	1617200460000	orphaned
9604	3NL7Vc4atus17VAQFzUBoTaAkCVFcES8Jkn2nUqkEFJoU5ZQEbNz	9603	3NKZfWFmn8tPpzqRsjbn8bUK19xo47vu7W6XrcM2cdmJ29iG5tag	1403	824	122	1	6301	jxUwbgNFA5QHr3CZwxgyKwmfbYik7v85KS9YTEW23nxn4cVYHr8	4983	7011	7011	1617201180000	canonical
9609	3NLFb5ByCtPARWMbY9s1ovpwmtLaBZ5af3Nf87Q3tPKtinZKHU1a	9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	1490	1028	122	1	6301	jxM95ADPFiNVCdVRcgKikTRrenwiipLQcN7j9eKrJrvRSjbFt8p	4986	7016	7016	1617202080000	canonical
9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	1637	816	122	1	6301	jxYfEpRzzaRSDohACpgbkvpPY5y5eW4QzhCUikaprmMG2ChYGnx	4989	7019	7019	1617202620000	canonical
9616	3NKSLTM33XdNSHAvZycuAhkaDaNq4fze6oqAXofczDDjJYyGAivv	9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	1587	991	122	1	6301	jw93MTbfgzE91x3cP46aegk5dBCbJCT3a4nHhPTD38nFUcsbqej	4989	7019	7019	1617202620000	orphaned
9619	3NL8Qwi5AYJ2shExsrHziA6xL8nFTyxLausrhuGZsc75CKkhQvgJ	9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	1501	1360	122	1	6301	jwg6MbhbnETM8nvKRkjdwVvJRFi3N58ZGgKmSb7fThNdfEsan9n	4990	7023	7023	1617203340000	orphaned
9625	3NKiaQdEvzSvhVwpYavT2oYxGHgqrhkDEuR1xs6wRb9Vri7MtoAB	9624	3NL9vdeBBXhA3YdrKt2vqAYPaJ125nDVvJ41fKVWQ8g9uHD3htD7	700	832	123	1	6301	jwunSuvAh3wXhY9gtCQzD2iUWcwXDkepRFhr2MfTQUmEMEt28P9	4994	7031	7031	1617204780000	canonical
9631	3NLU9vTSBoGYzb5jrGeUw93b9k1fVbdo62sZeAxsADWsaMcWDf9Z	9629	3NKVX7T9nqFVvWiC8VzVyQm1JtmQwGT6ixDhGM58qhkrQCpW1Pmb	1631	794	123	1	6301	jxBfwUg9Nrmp1LyMUKcYNBXPrDwtozFX1L6T5FFgXrUS6sNeLaq	4998	7038	7038	1617206040000	canonical
9642	3NLH1pF7pNySYpQFHvKrbeSG4YHcs9p6z1KRaNAFCDT7y3Vt4kmk	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1596	997	123	1	6301	jxBn4sRLuaPDbdhmwjAjBcTjAa2ULCy2RfW4xJQwaXvuisbnHaK	5002	7045	7045	1617207300000	canonical
9639	3NLGmZpWWDymKxEob2UQJSTeXByXzeyxHA8i2asnHKJEy1M6xSbB	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	684	1352	123	1	6301	jwPJj9GesSEzrPZJrZNa5zAcehygUSuNUcydtgTijJvK4Dk4T43	5002	7045	7045	1617207300000	orphaned
9647	3NLi1KcQYbpiEkxnfFEQ8UJMEUnEPQveAKrtWvN5rAG3VEvjSVkc	9646	3NKr8K58vPh4mjrD9tgySSJ4EdsQsT5DQo6FsAysmAtxhfPASxjJ	1553	776	123	1	6301	jxQRjAt3geMWzPP6ioNvvF9ZLd47az8hf6EkXuv61URgoSSAov3	5005	7048	7048	1617207840000	canonical
9652	3NKMwRpUwbA58yePoJQGfT3iRRZnJdD912NYVT58zPVD3voGE3AU	9650	3NKSSySQge69rs4DQGVbR5Wr8TK7qUznyb5qbGEEc3XicxyNmf3R	43	944	123	1	6301	jxdE7sNeVbijC7ixefFxYmGAfYasSPTh1uPYSk5UtFsDhq7KFt8	5008	7051	7051	1617208380000	orphaned
9654	3NKbLu2FmaF3xvu2mYh4xysydQFCeoLREfXPTGrGwDVa1nxHm2xs	9653	3NL8mPQPCSJV16bqirC2NeWQrAJZcxeZEWmuUCmiYqFXVPWZBXUG	1406	1393	123	1	6301	jxGcBzUMdvJcFc5qvi7kCwq2K1T7KvxP72ZMRSrjAgLeCHjTHdE	5009	7052	7052	1617208560000	canonical
9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	9656	3NLfNoXFQGkZocN9R89c13rihe9DwYcVrGFFnmVE6WYYoMzuvdHx	1406	1393	124	1	6301	jwNv72skYNAyhquqx6wfUkH8oGo5keVj2qxdJS7FA5cxdz1Wk9L	5012	7056	7056	1617209280000	canonical
9660	3NKXhTvd9vJWAt3Qc8LZE7rznNoLmywynLg8YJCCTEJQ2KY1PaFE	9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	1581	778	124	1	6301	jwN8ymq6UhVEe9Jeph7QJa2W7ihLzL5ZtMvDcNXmHrBf3xQumNR	5013	7057	7057	1617209460000	canonical
9662	3NLKQqRSbQ8ba43P2Gn8yW7E54ot1vJwUaHqVx7ki7us1xARZ3fK	9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	1451	926	124	1	6301	jwzvVVS9ZABz2t1twtB5RLYkd11uLDNCqtonvXd73jstSSDx6dg	5015	7059	7059	1617209820000	orphaned
9669	3NLovyrDm29tYLjhBsGPSMNSD4Jhj8LjnZYMDdebGTXUvPJcuie4	9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	1402	882	124	1	6301	jwtk8CcsrXQoicWqGA3jjsZFCszBhs8um12FH5SdLqa92mXZ68k	5019	7064	7064	1617210720000	orphaned
9676	3NKtEUWPZtCuXuNU4Yqb5cwQTVS8151vCV3ovdeNRrRVaMhp2phu	9674	3NKq7XS2YDCiNKX6zpc3z4C7ZwsdBXdwbUuGjFCLMmNx2HLawAWH	1637	816	124	1	6301	jwqrNGbDM1aCRi6fAxwBowSvUMWiaHAB1L5CoG8VBgyb7A45e5P	5021	7067	7067	1617211260000	orphaned
9679	3NLUbyaJWdeX9c7jWq2Le4hNPSR7EGBuyaxutq8npyukkkAmft1d	9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	1546	1339	124	1	6301	jwkYFXhs3V9ZF3UQ5YX7rbWrEtSH441S93FKcF3zWsiyZVZpPxr	5022	7068	7068	1617211440000	canonical
9684	3NKtyATYZ7E6HPkwB7ZKCcFtrbxXknGnrXbCFJEnevbQD4tKs9i7	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1489	1380	124	1	6301	jxogK3oPNBYXUQHHPKCQZxonWxutkv2KUoXojRk8sF7WBVGVHGm	5024	7070	7070	1617211800000	canonical
9687	3NKQmnE8QqBjeBCExPQqD5iVVmFLqKk1Hypakyn8ztfBGR19KGzM	9684	3NKtyATYZ7E6HPkwB7ZKCcFtrbxXknGnrXbCFJEnevbQD4tKs9i7	1403	824	124	1	6301	jwokfQWC2QFEYzEpZNk3x8DicmsAPgwak1D2AjebU3QFXqU4VUb	5025	7071	7071	1617211980000	canonical
9691	3NKJjUqUrfLdgDLH42TyD5HX4AnC1CqAULYhEGkz8k2R6wDA4nrR	9689	3NKUMA9Wr441TnPzRHE6CnAxZGkhwoVepbY2H5XgHQWYopPa15LS	1509	954	124	1	6301	jxz21ueLK3XbTdtGFqZwR92cN3ZR5gJ88TyrVnQZC8JUuxSUh2z	5028	7077	7077	1617213060000	canonical
9693	3NLUDLDYZL7uiLz6GYuG8Wu4bHJDVtvWqUq6EWrkWa8HkViRnPpj	9691	3NKJjUqUrfLdgDLH42TyD5HX4AnC1CqAULYhEGkz8k2R6wDA4nrR	1406	1393	124	1	6301	jwjtPU735122PX68m2TSnuNNGXWM7t43Vw9pPvYm7PRAccdtGKR	5029	7078	7078	1617213240000	orphaned
9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	9692	3NKSRg3buRa2SXEdbcDv4RQYVBPnU9kn1xc9d2kR8Nyj4GfYx3k5	1406	1393	124	1	6301	jxHWU5SvdHXWP8f6GCvc5EsvwgZMSAz4AVCd3K4UfMx4MSPoHgv	5030	7079	7079	1617213420000	canonical
9694	3NK8M4bgeayYT5Ks5P5pbYxGLg1xksxzZVoAsVPRPLrhvesfX3ke	9692	3NKSRg3buRa2SXEdbcDv4RQYVBPnU9kn1xc9d2kR8Nyj4GfYx3k5	1403	824	124	1	6301	jxY8vp7adD413T8h4oNGCLLps42XKEQmFriq6sLJLFUjairkQEo	5030	7079	7079	1617213420000	orphaned
14144	3NKWwsD1zVjjh5e35JADFbosFHRWxWAhh7eCdyimYTjnwPzxxA2K	14136	3NL8fL2p373ja4xeqwp9MgNd1tMWbSG4CGi4jU1rC1V1hXSM1RRU	1508	1021	218	6301	10278	jx6DBLpyxAuAmzp729YfHaag5deomrjZeR29szdLPdnYNCULCFF	7222	10225	10225	1617779700000	orphaned
9600	3NKPpyNkfWZ6zt9PH1mfdmCzEEq6jpPFpN7xocWeFNUAzaaQvgVr	9597	3NLdjNNwXSne94TNRwM3cAQxtSU9Tsi4PZupZJn8MB3QX5KvnY7A	1613	983	122	1	6301	jxJaU92A7TxZTrNdVgGx6jz68Y83AuJ2i3MBXD2RxnSTVdAFstY	4980	7007	7007	1617200460000	canonical
9602	3NLojTgzhMJRSE2f64oUnDt82S5P3QHMNEoCU128hb3uQ1qUJvMF	9600	3NKPpyNkfWZ6zt9PH1mfdmCzEEq6jpPFpN7xocWeFNUAzaaQvgVr	1593	1220	122	1	6301	jxKwHiZfuNrE7nik1JvbGdEestVML1duoikgHUgovjVbdLRoVnT	4981	7008	7008	1617200640000	canonical
9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	9607	3NKdPieeBAexaiJjCAzGS1Cj1syGJywht2GYaorP8QGLbSQP8Er2	1623	830	122	1	6301	jxZwR6V3z45xqKNkM6R2B3jHfGaiyYQC9pbc2VYspKCnmHvfQxv	4985	7015	7015	1617201900000	canonical
9615	3NLPDQoJV5cR6CGHRLyreqFhWkMgk68AR1M6AT3eSAvsGy4AMxic	9613	3NKchFiW6KmCYHAeMW4nY8diRrwWe1mWn9FAoynGoNgh1eYosyTf	1651	1301	122	1	6301	jxFkzEDsNj6wvhuZacK1ETzGQTRVsicMNow9oQrdUBXJAbjAXtd	4988	7018	7018	1617202440000	canonical
9621	3NKNL2LQH1rfN8ZfMrBPM4KhfoaJWBSfoAbzWq17KXxwU72TSm1W	9618	3NKbJumHYtvXstoSSNmCaGiLw5BA37d4JTXKAwiXNE5j4HrHNDzL	1577	1201	122	1	6301	jwYRDrv9uvjLGTgGwpLHjTYcDKpTTUK4unPrqzGZvUb7Q9pSfyw	4990	7023	7023	1617203340000	orphaned
9626	3NKExctYENxSUb5yuQ9L9LFMxJLGZU6NkAFy91nWjCidFroYzvwW	9625	3NKiaQdEvzSvhVwpYavT2oYxGHgqrhkDEuR1xs6wRb9Vri7MtoAB	1403	823	123	1	6301	jxVickSjaFkWBZV2m6HYDtgsg2kxqbFKewJGg71ByQ9wWYTfvzb	4995	7032	7032	1617204960000	canonical
9629	3NKVX7T9nqFVvWiC8VzVyQm1JtmQwGT6ixDhGM58qhkrQCpW1Pmb	9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	1553	776	123	1	6301	jwiwvsUZWiozkEep9o3d9hXV3pJ8ukyo2dzppZp52bbTebSVWvi	4997	7036	7036	1617205680000	canonical
9637	3NKXAckpEE52ojiZ9ndXXLRirmHWZSePVMTUkTzoVnvyF2XpCAKA	9628	3NLJxyWYk4FWkxLA3xQJBQ4ez56su8Tk6wdGcD3epy5tDqdfywy5	1471	1386	123	1	6301	jxcNbok33WaHMTqbEDQV2jEDfc8y2q3BfDd4jK6ii2fvcoKLVWu	4997	7045	7045	1617207300000	orphaned
9640	3NL8fLePeq1c1qL6rd1MPtCjyzBE73ZDbc7sVcwaGKMZj7HBptbP	9636	3NLUKCeQ16Y7B31i79CTU4jcUSPUQTpjqNicK8SfvoWvrh2B9RYq	1471	1386	123	1	6301	jwJNQfw4yp4hiGYhAScR1z8UXgoSWKMhubTx2eR8Jp8jJEgiZi8	5002	7045	7045	1617207300000	orphaned
9645	3NKafhdHewqWDerkSki7BrnfMhvrRsGd77cKYpQVUzCpPskjpKT7	9642	3NLH1pF7pNySYpQFHvKrbeSG4YHcs9p6z1KRaNAFCDT7y3Vt4kmk	1588	1146	123	1	6301	jxG1RiNrDvuLmDWFnd8eSY1MhUioJZG1zTGZkrm6b4S6XoYMXKP	5003	7046	7046	1617207480000	canonical
9648	3NLfqtTEXkXSdtNcsEPtobAwFcJey3X7v4hxvJaULCrJgacbqq3K	9647	3NLi1KcQYbpiEkxnfFEQ8UJMEUnEPQveAKrtWvN5rAG3VEvjSVkc	1649	1383	123	1	6301	jxQEPBCTATXLiSmUEeUBk6zwozT52pP8tMgcySwsuYKkUsBkgdf	5006	7049	7049	1617208020000	orphaned
9650	3NKSSySQge69rs4DQGVbR5Wr8TK7qUznyb5qbGEEc3XicxyNmf3R	9649	3NLcJ9mbVjsaWMHo84cRtaobPF7arEqcXmVSGym1fLhWNZBQnXXi	1405	869	123	1	6301	jwPAn77Cywd4Bcreyu4WdhutFJgoF3FnR75i77miUDhM7mgTTKb	5007	7050	7050	1617208200000	canonical
9653	3NL8mPQPCSJV16bqirC2NeWQrAJZcxeZEWmuUCmiYqFXVPWZBXUG	9650	3NKSSySQge69rs4DQGVbR5Wr8TK7qUznyb5qbGEEc3XicxyNmf3R	1672	1039	123	1	6301	jw7JjFNCA38pjyfopneCeeNrJTQVksmPZSFHhGfRe84m5thADfJ	5008	7051	7051	1617208380000	canonical
9655	3NKQcZG98Pi5vvjX9SzWNgoiZEf3D9HSuTMPwBidLZmgt6yWuRgs	9654	3NKbLu2FmaF3xvu2mYh4xysydQFCeoLREfXPTGrGwDVa1nxHm2xs	1673	1122	123	1	6301	jxvXxKKzQAoEh74QEJG2yc1CpQxLkoearERg9ZMfdqbNjTjXRE4	5010	7053	7053	1617208740000	canonical
9658	3NK3RGxEoEbWt7NNfRxFeUUChSvxYRZu1KHgsjUMmhRvKFxBSqv7	9657	3NLXH8pLpYTR46MbDKQHp6PV2Qsub2tRGUBR4mPVRM6AhSXP6prh	1407	1395	124	1	6301	jwzoVtt4U6CFMyU2v3zP4EzjmDbicqNLerREsFpXxZf7q1LDJoJ	5013	7057	7057	1617209460000	orphaned
9663	3NLcpHNgBPHqM5puLqyNya5MYJTaBRgT7yeKz9oTspCqqa2Gn3AS	9661	3NKTm1vrd2xaGNyFGm4NYjqwvNYTR21Mwd9iiTJBX5yj5vCA3wmA	1402	874	124	1	6301	jxbbPZ653RAnxzqPFxiNNKNnnD3f4CGbw8FPZBHWLmRvdeW935V	5015	7059	7059	1617209820000	canonical
9665	3NLY3L1qqKxySpMWn91gD5tXFQGAEkdfC2DWD9D6tdsWetkdpRoF	9663	3NLcpHNgBPHqM5puLqyNya5MYJTaBRgT7yeKz9oTspCqqa2Gn3AS	1594	960	124	1	6301	jxAu4fChKe5og5emNjHK8EhcJvnq1zYbGVKTiY4tP4E3b4co4Ba	5016	7061	7061	1617210180000	canonical
9667	3NLnWvcKvM4BHEXJKbk66a7LXBCHYbHrE3VFN95RHFFJgfnx5uvS	9665	3NLY3L1qqKxySpMWn91gD5tXFQGAEkdfC2DWD9D6tdsWetkdpRoF	1406	1393	124	1	6301	jwDL6gagrduQHoqg8i1RsKhqQL366CnP9c7wvgby7sLmiWEiCKr	5017	7062	7062	1617210360000	canonical
9670	3NKHJYwqpN4roXvRCk1AeCJiuVHLGw1K6ipsj8WGHtVCQf71QdnR	9668	3NLHniZXvS6qn8qtGSYZaEgrVBLeHeXeYZph4iYfcndjSubv39fF	1564	972	124	1	6301	jxL4GvtbPVokDdL9wdw3jhEyChCaFs81yP2uvV9TX7mWYF12n8R	5019	7064	7064	1617210720000	orphaned
9674	3NKq7XS2YDCiNKX6zpc3z4C7ZwsdBXdwbUuGjFCLMmNx2HLawAWH	9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	1631	794	124	1	6301	jwTdZ11hzEBVXJTKZYA5HM25ZuPAGMonLLKVQVSrKTo3EXtYFUu	5020	7066	7066	1617211080000	canonical
9672	3NKc9U21QRe2WnovfpeHVSe6WQY3Zxkftp7jypk5AmDvHnfu8GcE	9671	3NKd5gGVbPJAvZpuFo8gGCBhQ9XehnfVsUnCX2PYoks5eHMefZCb	1402	852	124	1	6301	jw7ouhL66s8UzE7EMPbjhRBAPCK5V67Vcz4tgwgrASLkm5qEbBi	5020	7066	7066	1617211080000	orphaned
9677	3NLUMQFf18tsmW8iWDDzFfgSwD4Uixnzdd92erNjn1NjGmnpwoA8	9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	1527	1167	124	1	6301	jwb7sxreLMcYTHceZWgTbiocizHtfGi9TJA82pXQUiP6VGBW2Fd	5022	7068	7068	1617211440000	orphaned
9681	3NKsrmLK1xmhqehZ4sw1XcaiyTuQ5tBLaevZt1tUyFaH8bfFVdo4	9675	3NKVPfUW89ct29EXj3YTqrkQ4MvtWzCKz3Fq6FpB7mEqUkZ77YkT	1577	1327	124	1	6301	jxt86n28WQ92jmMtEG38HTtpgnvUy8YPhN3rTk7ZEpveNXtCaVs	5022	7068	7068	1617211440000	orphaned
9683	3NLnUNWregXyZ3TC4tjvf1hiKhhv24PfobsEstV3y6zTgnwn9hib	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1610	1068	124	1	6301	jxDJUjhb134odYHQfGCZMa72qUDvhthJQnUKnY5XBxaePFx7tvM	5024	7070	7070	1617211800000	orphaned
9685	3NL2QFsvxDRMckHA4sfVBVQjhxz4dHkJxgw3n37ZKx5JdKmjYDZ2	9682	3NKhHJYWu2XucnVCjiPisGB4iWjXKKiGugX5ujPSh6jNXMvfxwgQ	1406	1393	124	1	6301	jxojkWqZPtwD1P61M6wNXRYQPxexp6GaJmAb3dyMcvWibEbEVUC	5024	7070	7070	1617211800000	orphaned
9688	3NKqzhNTGR8nQ5JwuQZ4JtTbi7NP3mwDtDEqpAjXo6k7J5qjNeTv	9687	3NKQmnE8QqBjeBCExPQqD5iVVmFLqKk1Hypakyn8ztfBGR19KGzM	1599	921	124	1	6301	jxwsoCx6aWSoSuJ6uoBdMr65QZFHFrAiCqSfw89yEYVUJkCfS2q	5026	7073	7073	1617212340000	canonical
9697	3NKgTrEGAFuooFt8PvPCDJK28Unwdr96wQBByZtjEE78ZrCgdYvo	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	1460	1324	124	1	6301	jxgPdzqXa8Eppi6NFpg8iraFkDYvLiquQQ4YRPJouHVgqfBmgD3	5031	7080	7080	1617213600000	orphaned
9699	3NLBiGRYitr5XnS8MXceJAyTGPqsChBy78z573R49r57niV3s1LB	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	470	1309	124	1	6301	jy2d5xfkYGjoFpBAnxoJwAefj1EUzD6buAmMQ7tWDEoVwLXy6PP	5031	7080	7080	1617213600000	orphaned
9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	9701	3NKFiYXLRPsRHd7Lkf9aP7vRzdTjVa7tWuiLrVzaGEQCnUZWVFcZ	606	1295	125	1	6301	jxLKkGK4SdLxvvSTWvkdTrpKLVCWT4ZRrknSS8cBKshxLRNS6bG	5033	7082	7082	1617213960000	canonical
14496	3NK5F3aVirWc41U91YPcKgHteQ5j5dSFQN2NceiwjKcTnZb799Sr	14357	3NLY4CD4UDRXgpLfCDhQWssnFzDoU3JaKMrcNFMwAUAPAtWAFXNJ	1624	1088	218	6301	10600	jxtMX39QqqPQSrGtZXnWQyCe5nKv8z2EPFMMUQy6164naaEu6Si	7228	10466	10466	1617823080000	orphaned
9696	3NKuMSXeYsMMc2QDvwpKuY2ZvWrDiMFdhbxgZma8Byxu7xFt1PkK	9687	3NKQmnE8QqBjeBCExPQqD5iVVmFLqKk1Hypakyn8ztfBGR19KGzM	1643	1173	124	1	6301	jx2Lsi2fJn48KALeseEbsTbs1nDdPBekZVu9q3F1FweGoCLMG8e	5026	7079	7079	1617213420000	orphaned
9689	3NKUMA9Wr441TnPzRHE6CnAxZGkhwoVepbY2H5XgHQWYopPa15LS	9688	3NKqzhNTGR8nQ5JwuQZ4JtTbi7NP3mwDtDEqpAjXo6k7J5qjNeTv	1649	1383	124	1	6301	jwSu3zxKxq7GiLGUf7JkiDcCqe2bCiuKcdtFc3kgGZB4gg4x6S1	5027	7074	7074	1617212520000	canonical
9690	3NKGQ2XgieWzNkVfhj9USPHKZqHQNQNWRdX9a4QgpmKEJ9Rssy4b	9689	3NKUMA9Wr441TnPzRHE6CnAxZGkhwoVepbY2H5XgHQWYopPa15LS	1627	1385	124	1	6301	jwfpYP5bcL9aDaVKpRa1qB4QiGLcWvviyhBJ18puPW2KToR6uhC	5028	7077	7077	1617213060000	orphaned
9692	3NKSRg3buRa2SXEdbcDv4RQYVBPnU9kn1xc9d2kR8Nyj4GfYx3k5	9691	3NKJjUqUrfLdgDLH42TyD5HX4AnC1CqAULYhEGkz8k2R6wDA4nrR	1623	839	124	1	6301	jwGZ3jDBYyJBpUkrSZH9pfaiD337LW7QBB9gyxShq5mkcY4uFj7	5029	7078	7078	1617213240000	canonical
9698	3NLcyURH2WahtyinPeE82C1iQoa8UdDKu2NFvhiTQoAe1xeXDA7d	9695	3NLvAx6Giy8EUs1ZMzFWTnxBmQS84AEuHtZhbvTM6RafMGKSMkPK	470	1309	124	1	6301	jwPqS8JG4VKw9VSsaZ7SDFQdKHMdY2d2A7aPqMHeo46rQXJxw2m	5031	7080	7080	1617213600000	orphaned
9701	3NKFiYXLRPsRHd7Lkf9aP7vRzdTjVa7tWuiLrVzaGEQCnUZWVFcZ	9700	3NLtWNxvzfWgi6LaNqbwR8AiGbkLjAmtLKCezuGMWxxMiHdjwmJT	1634	1085	124	1	6301	jwjJAeNhvhs3mT1KfCQsLHj8Lv9wKAakpvUW3pgRFKjTof3tS7m	5032	7081	7081	1617213780000	canonical
9706	3NLSTPzj4qQ2ueFhonHSJiKTVZJBqF1xVFhRebBNUV4bmfMfaEoj	9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	1553	776	125	1	6301	jwqRAs9qKMqDvyQ2ojrvoKFsb6GEZgSZcw1euUNZiptduGSmFWJ	5034	7084	7084	1617214320000	canonical
9705	3NLwjKKEbpH56wCmKyiHj7x9AFPqgqDwToAmxECZ8jNgCTc9hEYo	9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	1619	1275	125	1	6301	jwFbUmQXZQ7DXsv4iqrzASScVokjJvDNuuYrFYUv1wA91TBnqKR	5034	7084	7084	1617214320000	orphaned
9710	3NL39XFUK5QEMUjuLfLmSeZ1y2amoQtDXYdnrScZqrhh9AZ1z3wW	9709	3NKado77Ur724TvgjcP2RmHNuNipL2DYhnZSbQt9PzwVcq5mhyWF	1501	1360	125	1	6301	jwbu9ivqSZ5N3ZEjM43fkmLAhT5ESBGPSMjRS3qEvySr4sYnAtK	5036	7086	7086	1617214680000	orphaned
9717	3NL8boZkTbTMQktLFSFnkZ9pJ8SG8EaTUhQ2MJVXxkyRRVNJGCy6	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	684	986	125	1	6301	jxccFjKFSSaBEC4L71rXcsnDg5CtCYP4C4NvkD9X2oSmjXVh3Rq	5038	7089	7089	1617215220000	orphaned
9721	3NLipVqLg1Eapc4QL32t6sBoe3sepyKQcHMUXJjYkyPqHjjjW9yM	9720	3NLD1StoQoXodrcUBqy9euCfN6Tev9uovZR4rxggzCkrrBMBpDUL	1402	856	125	1	6301	jwGqbo2s8VEqxK2GPQkQY8457xxS3R5hm7JzFnmkGLPXKXT96Sk	5039	7090	7090	1617215400000	orphaned
9734	3NKCqN1UPTSfMh1dPQbMnUpGB9bYKv84eCw3JMQvEiNtFP2JbqbX	9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	1564	972	125	1	6301	jxrTafShvVmTVsN9PG2r5HML2eksB2aAU38uKaG5QMGBMLMY7m5	5043	7099	7099	1617217020000	orphaned
9741	3NL7Bcs1M81iVDZWpQzYd3VrgM13y9HWoUN1QRgaijUDjage6wMt	9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	1406	1393	125	1	6301	jxgLtLk3zFHDgpzU3kFDuF8GfpJ45tk4dZy9wDSo1HhXhG5dfRV	5046	7103	7103	1617217740000	canonical
9745	3NLeJoLYR36RVSyBMRk7gyoBP7hgwspS2Qe3nEPtTtrXmPdhXtU3	9743	3NLctyk7dLY896tXpyuZSwr4nhAJ7x4aJ8trn1DAxZtcZjDQUf6C	1406	1393	125	1	6301	jx1DyHEFyKHTqJajZfBL9JyE1Rue2G4C2tp4CV2noHjieryCGz2	5048	7106	7106	1617218280000	canonical
9750	3NL8hMgEzVHRGqXgrVFkioZcUxicdNx4q9JUPXr1dxB4wLupBZpa	9748	3NKBt4FcWMcXGBWnAiQY4mY78EwWvJt46VdJcP2QmzrZdD4wbRrz	1559	1353	126	1	6301	jwgTqiqUzxsMTiwD9bNhaEUec42hP7pgnBhRycRy7GyemaSu24e	5051	7109	7109	1617218820000	canonical
9755	3NKhSWFmvXbjrYTcDh6odF7QpFshvCXJFWEKEsj4dnFBy8Aa8N7J	9754	3NLGBRFQr4kRjuNrVvfXEi1gyohBA9LQtoav9iURVpwmnaVi1wAe	42	995	126	1	6301	jwtaCZwwJhkdFy796dyh9vVQTCu8BTNuyJX5SdBBtkJuDnQY8Ab	5054	7112	7112	1617219360000	canonical
9757	3NLA2yCi3qxQanxKKcjJ9om84gbq4TjyEui1G3cG957Y87d9PU77	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	1407	1395	126	1	6301	jx5KuFmD83X59g39o87N15LmyhQ53sncCM3RUnYLMXnhaKphZtA	5056	7114	7114	1617219720000	orphaned
9762	3NKM9TQ7HRwdcZ51qvv9dmxNY6paTUBFSA173ZC8YEVNPJJZuDKU	9761	3NLU6yoUtcmJKs4gJ3vMFkKADiN4p7iTJpjPWdQbKXPoNJQRrJqE	42	1361	126	1	6301	jwgcYLJqjj76NLPS174VFumGCPhXWXLPA6Nse81a7pxj4pnqJYo	5059	7118	7118	1617220440000	canonical
9765	3NL5d8HsWxA8QmopxWSDPvnksoGNwHaCJbMVgTARxKfbgaiTgMcw	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1608	1043	126	1	6301	jxD53ngvcKQFPpBhssttzpQgSvH9Qkh6TuC2se9pUNdCViDuGgj	5061	7122	7122	1617221160000	orphaned
9772	3NKhuzquG5mLK7y9A8hLtfkFfcNdPU5hnFmKqQEE4vz6AhCgW3qR	9771	3NK8tGvHhEW11Wt34kLQimEVThVMvAt3tkkf4eUwGEdavU31peVQ	1522	956	126	1	6301	jw9pdqc3taBsHLrgeYrJxmK3Fu4sBsgjxym1bySnDDtxdxATscX	5064	7125	7125	1617221700000	canonical
9776	3NKkhDAf1fGYb2i23rEoGrLTvY4zUVVR9GE92twpLztM6fVructe	9772	3NKhuzquG5mLK7y9A8hLtfkFfcNdPU5hnFmKqQEE4vz6AhCgW3qR	1467	1130	126	1	6301	jwmfpQa5gvgWJ4ZuNy6sm8YGRni6rMpvN7qHaMwktg8ZY1WuKrP	5065	7126	7126	1617221880000	canonical
9789	3NKJadufDfqn1N1oemsuGDTkz8sHwkcv6EqEaVjiGMXk43RRfUwQ	9787	3NKSwAt2b5HPXjjLHkEHvGhEfXY2433HzBPqRqYiwfeMWZ45ffJE	149	1283	127	1	6301	jxbtZHM5xCtrqHbzPP5dR8D8b8UnFNEcG62DvT3QBibeP7ZLu7t	5074	7137	7137	1617223860000	canonical
9792	3NLZHUGTX9txxn8Mjcwc5oKvrXD5ff59T5kHKyvDTMvYAkLrbgtd	9791	3NLC8CV9kZYFkXnUipJzkkHvT9RmsttSUNpwfwqwWCfbP9bQmwNJ	1471	1020	127	6301	6303	jwM6RZq32nnE3CLF9k7ffud3ygvijFHwWnjzGBjPpYcmgwMCWaL	5077	7141	7141	1617224580000	canonical
9802	3NKvNTDgXpyviVnFsRSQy6mHXaMnHLP26FQKU9ztJw2uGVMCDJRF	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1407	1395	127	6301	6313	jwmgkVH5i5gzcCa1JyJ64sva2aE2J7ReBAsscZxwsA3ygzooAPx	5082	7148	7148	1617225840000	orphaned
9804	3NKTJBVhpPYixYZZZ3GB6CFmGBNgJFPEkFaNihhyjWPKNfTt56hw	9802	3NKvNTDgXpyviVnFsRSQy6mHXaMnHLP26FQKU9ztJw2uGVMCDJRF	1483	1276	127	6301	6314	jxwZpCPjZzfuRdF22CQBSSHim7fSJPzN1HYMB1UYMLqJhvstU2h	5083	7149	7149	1617226020000	orphaned
9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	9805	3NKYkuCaWi2fL7zUBCaEt2wqobA1xzTeQVPCWtvfKW6ABtDwDKLY	1672	1159	127	6301	6316	jxNMbmkuQZ7hHtqy5LUQfZvszxYvZu4s3d3zzmi2KrFmuL82GqF	5084	7150	7150	1617226200000	canonical
9809	3NKKJ6j82mMgNHHZgrtcNr4fYMoXNNJcDsT6zuJWvwAtgZqYvcmg	9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	1668	1370	127	6301	6319	jwz7eCTpL2p2284BtMWsr8DCJwGUSDkBphT7yABBHcdqN4tpdgM	5085	7151	7151	1617226380000	orphaned
9811	3NLktF81aJ2itdKpfGytMJmKA7GUATsfHLgMCg65oxGy6kUPL8KV	9807	3NLmLoiwXRXCxvvb6MGYcThRWSvDPJNHz4fvAVUaMCv88nq4zRUe	1631	794	127	6301	6321	jxKkjoftkzEYaTLiaaiBqTT6Y46eP9wjDrQUuLFFsYmmkegGs1f	5086	7152	7152	1617226560000	orphaned
9818	3NL1BDydCxnPLtNfTztzoBVnngJs78GGkfwmaRxHtZcDAbmbnySx	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1406	1393	127	6301	6328	jy1NFT24g8XNwP1TX95VJRBFBE1baD1c45d3LcmEMpqdDAeMxUc	5089	7155	7155	1617227100000	orphaned
14606	3NKWBaShBhs6WNPLEhZPyKmbRahww85SiquXsRpcfDiZtBgkR1qL	14496	3NK5F3aVirWc41U91YPcKgHteQ5j5dSFQN2NceiwjKcTnZb799Sr	1624	1334	218	6301	10698	jwSebM5tbr1DKcYM4JLMHi6TKhpgnKNvCTkTj8uTVKwSueeYDgU	7229	10540	10540	1617836400000	orphaned
9703	3NLd2tqBkB2ShqNz16yvsRVxcgayBuMDTYH7qD6V8o1bx3cu1iBE	9701	3NKFiYXLRPsRHd7Lkf9aP7vRzdTjVa7tWuiLrVzaGEQCnUZWVFcZ	1403	824	125	1	6301	jx6DbFMhxJcgErMwKXFAmTTryE3bNEYT6PLRJ2vZrjHRXqkxTod	5033	7083	7083	1617214140000	orphaned
9712	3NLWzsT84brKzHubZnAMQbW6Vzptgi4QEHxxEaGamt765HABYmzp	9708	3NLMNpeN76th9armsuf4pMTw9AcLoNAuGHcMCGnxvcJWcfcai7QE	1501	1360	125	1	6301	jx4ZhFW5PDBj29U1ov91fDyP26E3dsM4UgdXy8k1RaaJrDNYzNA	5036	7086	7086	1617214680000	orphaned
9729	3NK3fozJf6Pi5b7Pxtqw7APfdAgCKVzNQuVMUXYLxwBAejKGTnep	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	1594	1326	125	1	6301	jwZPfzbefZbexX2Ry9Eiw9kWveujG1pnWQhGjG5i6BtXVxNdgCB	5041	7095	7095	1617216300000	orphaned
9730	3NK6FezeXF49EfJBnHHu25pZiayZDn4qgV9USBmctSygtiozynfG	9728	3NLm2NqL2KsF5FrVUdxHzG9Ly83UmTL87QYKkZqoiY7BnEz9HBio	1646	1354	125	1	6301	jxyqVJqPZVEWYHzDHUd8BrP29AraJWHbbm4aQcyxCrpryPsqfun	5042	7096	7096	1617216480000	orphaned
9733	3NKLYRVL8nK2ND9mxenxbKmSNun3YJvu2EDskKo9KZCMKs9h4eB9	9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	1656	977	125	1	6301	jwDiWa5JGahJ5WjkaWj2dXzrEuXQF3cCdkCkXvYBSrj8WnbPP4d	5043	7099	7099	1617217020000	canonical
9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	1419	814	125	1	6301	jxinWSBP5S77b4nqLmDuove7FdDMYroMCaDw6Lurhd7i3bod9EP	5045	7101	7101	1617217380000	canonical
9740	3NLPMwFxuPNieic97PN8qDzjBX4X6we7nNdV45RRNMDMsKDYRtkw	9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	43	1310	125	1	6301	jxPA9HtFz8Uau5tch6beBPpQ5awqc7J5a33u2qLojzeKAwSeTvH	5046	7103	7103	1617217740000	orphaned
9747	3NLCDMAPMfm195hkC9aAjRMSaGNcKXvSmYXUw37nhaz6w87cyXqg	9745	3NLeJoLYR36RVSyBMRk7gyoBP7hgwspS2Qe3nEPtTtrXmPdhXtU3	1573	1318	125	1	6301	jwGoUkTCaNPUL67t1kVBgB5BvHNPadpZW57Q5WgxCxAGpt1c5rR	5049	7107	7107	1617218460000	canonical
9754	3NLGBRFQr4kRjuNrVvfXEi1gyohBA9LQtoav9iURVpwmnaVi1wAe	9752	3NKFuXAR7cNJg4fg9SxXG9gwJBAsigdtbcZznsCo2oCa7HzhcGL9	1406	1393	126	1	6301	jxbrRt1svHy9Z58k35cpxkvPSdGhEYpKKVhuE2N8HgKtLbykLoX	5053	7111	7111	1617219180000	canonical
9759	3NKWnw6yQkDQLGaKqPvhbZ2A9uj5YYMJLsxQMAZgQkuTPWMnrEDQ	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	1637	816	126	1	6301	jxkgdoEwfkqSBQdak8pwLC2unUki8w2WtotvaoREBxs15iUkL45	5056	7114	7114	1617219720000	canonical
9761	3NLU6yoUtcmJKs4gJ3vMFkKADiN4p7iTJpjPWdQbKXPoNJQRrJqE	9760	3NKTo18aiUskzfsuFyV75K3exNXmmvSQ98JdkeBBVeXdjohsQRPa	484	1319	126	1	6301	jwv8GAf3ore2Zf7Z7n1f3U66Aogsomo6iE3MM2ZLAezhDyJsPps	5058	7116	7116	1617220080000	canonical
9767	3NK4RdgGjrfEdAQMfSQAhE5agUVAfbaCZmnFFdSwdpDRh8545PTs	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1523	955	126	1	6301	jy1eZ7NYwAWHvUGKt7MgyTZMGkvLUArSRZnvTBHi7ab6Zoe8vbs	5061	7122	7122	1617221160000	orphaned
9771	3NK8tGvHhEW11Wt34kLQimEVThVMvAt3tkkf4eUwGEdavU31peVQ	9770	3NLFoCdJymDLpCaTKQ2BWsKdGp49t9TCRLu4z65k58xkNuLmjLg8	1542	938	126	1	6301	jwc5E4ByEByAsEPLz6XJcjc8hCbRnNE36TQLVVCp9bERo4iDVJg	5063	7124	7124	1617221520000	canonical
9778	3NKdzTrcvLTswosdrxW3QSLs1YHE3i1uunrJPtAifRixi46hHijS	9776	3NKkhDAf1fGYb2i23rEoGrLTvY4zUVVR9GE92twpLztM6fVructe	171	1374	126	1	6301	jxiDY8cXNfugCMKt4jFpULAdSTfZGcZwrvqm4Bpuq4y8k9vof8C	5066	7127	7127	1617222060000	orphaned
9781	3NLqWZFLCNKmw44Ddy68spYvaBRZPYZ2MYkGAEdYHJMQtAW4wJoo	9779	3NL61euL1AR7jVVHLJoEgqjzW7tuU1hRij1CfpB2d49K8hiiDRSM	1549	1236	126	1	6301	jwX5F4AAZdQesecXiYeJBSZYdW4cD8ucx738ufjhkiMrkvRU1Np	5068	7129	7129	1617222420000	orphaned
9783	3NKAUhp19AyDsaWNKZSocJD4XvP46DMJ8pThvcweCsM34jphSpyn	9780	3NK5sukdx2NiatK4rgqfCG9DekEkS1vyKtrEhQTUJScMxezZVUAo	1403	786	126	1	6301	jxnGjZ6pH5CKsL5ijFoAcNYrF2aV2Xz4N64sHqFYrQx5B89h6ws	5069	7131	7131	1617222780000	canonical
9786	3NLSpYkYCTdoePtzCPSpTgaQAcqcn9WYVwQvp35fHsps8tSTtyRy	9785	3NK4jRw2mp3bErPf8X6b16grXi97z4oQca1eQgV68NqChkpE3ofy	1406	1393	126	1	6301	jxd5VPSS5xfSq9yfQ6Q6HDVd1auAPR4miEL5gGSBWTTVFJy4wos	5072	7135	7135	1617223500000	canonical
9791	3NLC8CV9kZYFkXnUipJzkkHvT9RmsttSUNpwfwqwWCfbP9bQmwNJ	9790	3NKmKfm2RSTfA1w5mNSJRLoyAQgcRhWjH5qdNynchHar4kBmJPbW	1406	1393	127	6301	6302	jxDi1peuLKiuZQojfSqMHM4Yf7aDv3PDt2nvHTFWiS1D8iu5YRr	5076	7140	7140	1617224400000	canonical
9794	3NKUuMtcapwCX4pQ7gMRrU3UTyrete8nxye525CEwNUTxQL4tT3a	9792	3NLZHUGTX9txxn8Mjcwc5oKvrXD5ff59T5kHKyvDTMvYAkLrbgtd	1457	1265	127	6301	6305	jx2Zprhy7rpBKYUVjUyRbqpwka1o8YewF6dQhom8rd4zaPQWQ9z	5078	7143	7143	1617224940000	canonical
9797	3NL7PVdPq1SjjHpRRaF1NFHUMxk72EcRDHxyuNPo83gBNabaYUhN	9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	1402	810	127	6301	6308	jwptkKiStNESzw4rpgHmyAF6tBC5XRYTYcFm6w23iAdTWJ7NvLb	5080	7145	7145	1617225300000	orphaned
9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	9796	3NKsEa4QmijW4SXGK9BU74LaGgCGfQbqjUyeFVWet2ZuZsbty7mt	1637	815	127	6301	6310	jwPwrD1qSUFuu7dwF1eN4twtAUUpzgRFdn76drkLhFpDmXRsJv4	5081	7147	7147	1617225660000	canonical
9801	3NK5wJ1CF4PcHrAMZH5GuyabR5QzZxVWuDHNQB3tjtbxrCdWid2E	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1668	1004	127	6301	6312	jwysP3M69ooi2sokcTdJwjZMn3ZwYPH58AJvUpnD5AoDYUeRhH3	5082	7148	7148	1617225840000	orphaned
9810	3NKPm4grj9ZbkxaqM1RMqm565HTt95v74y24KXgUuGxZpygLZkLy	9807	3NLmLoiwXRXCxvvb6MGYcThRWSvDPJNHz4fvAVUaMCv88nq4zRUe	1440	1377	127	6301	6320	jy2hzgMGaT8yC35tiXLTcbqTnPPyD7wviMVyg7hCpM7QQiFHi8D	5086	7152	7152	1617226560000	canonical
9815	3NK48AtpUMBeyM1aXG9DRJpRoFft88UrJtQj6tthVfo7VYHo7ch6	9810	3NKPm4grj9ZbkxaqM1RMqm565HTt95v74y24KXgUuGxZpygLZkLy	1407	1395	127	6301	6325	jwW98MHiruC4zjdzFw3SBQFG4Rr2YgSYg6b7gQMD9aUtJgRWZeS	5087	7153	7153	1617226740000	canonical
9813	3NLHPpfvAKtxot8AABQa8rW2w4k9xpGXGLqkAFmXtsGs7anxujbX	9811	3NLktF81aJ2itdKpfGytMJmKA7GUATsfHLgMCg65oxGy6kUPL8KV	1402	890	127	6301	6323	jx1vVVyG99GeKFemr8ANP3dQpJ9jzURaR2FAQboCm4WAA7fYJnD	5087	7153	7153	1617226740000	orphaned
9817	3NL2SAyovGNprxwVmP7wYBZKBgRKxjRRNLe7LWZtUVW4tX62dZTk	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1579	1023	127	6301	6327	jwG9SitY6EwhZngo79DUzMK1MHn7p4vHLspDz9Vopss7V4EsQpB	5089	7155	7155	1617227100000	orphaned
9822	3NKjCTy9XMv7R3rGJFVQdpzVVoY3EgpBfQ3rHs9YrBimKVY1D3gi	9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	1406	1393	127	6301	6332	jxJJadbw3v5HHo6Vu2KyvBRAd1vyYYR5yhVa2fauosASzst5R24	5090	7156	7156	1617227280000	orphaned
9828	3NKvgqLAg9D4RjNtxvGnFoe1aPp48XQhdZZjzVYU9S6EVHVcpRgM	9826	3NL7tpPVq4GRwuJZyjUWWkLGL2uXQDQCGhK5bntJU4KaR7ef7953	1483	551	128	6301	6337	jwYRadBA5TjUh8uhkQkgsYmVL2aGvHsNfFV8qbGU8RpMBvuNNCE	5093	7163	7163	1617228540000	canonical
9830	3NKcdqKzUi1qnuYvrSq3iApBQGzp3t4CBmhVfdn8Pnyu2XAn29DZ	9828	3NKvgqLAg9D4RjNtxvGnFoe1aPp48XQhdZZjzVYU9S6EVHVcpRgM	532	1303	128	6301	6339	jy21QGQ9EGUwx2hvizaHCgaUqdr6QinFAHJYRHrvhsiFkLjayfD	5094	7164	7164	1617228720000	canonical
14167	3NKRQRFtQKH2s31MEBpHgnNMfBjY1yUbxUXcmGnEyk9S8SXiLd7g	14165	3NKY3CZVqC121G4nRSFuqDX1Wnsh955vriBj6NqAVxXMmVJiswgn	152	1330	218	6301	10300	jwA9xFRMxdQrrRrUnReSpqDFDpRdkvKhAgh28isiooUv4v4P8kg	7231	10236	10236	1617781680000	canonical
9824	3NKriBpYYwWMmTRqYo8ojBmy46h9y1Q7Y7BBV7k3D28ygpkUrdQY	9659	3NKDE21zX7HH3oBoJrCmj3yK8B3kYGj4bLjWFFSB7BgQxjejE463	1439	1153	124	6301	6334	jxHkeDAsx1gzZrYyFfyNhWfydrxG8wPzvfEWeWMk4rKuMZ7R3xk	5014	7156	7156	1617227280000	orphaned
9704	3NKsdRF5Gq2j769MtvweLVP5hkfauzsNQwBNvzpm3NG28gxHdcQh	9702	3NLQQsG8Ta2umDW9pA61DzifKdbtgjRg63yvhyNuVbNXhatHcd9x	1444	1381	125	1	6301	jwQ7xYH1LtwoHHoXukEgi4MMi1VWdhLbtXYoHAK1yzeDQyt8zCZ	5034	7084	7084	1617214320000	orphaned
9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	9708	3NLMNpeN76th9armsuf4pMTw9AcLoNAuGHcMCGnxvcJWcfcai7QE	1585	1366	125	1	6301	jxS1C6qcm2hP9tdiMoNMcZun3MnNZYeAQx6ij56KWDCuWXAMfEz	5036	7086	7086	1617214680000	canonical
9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	1451	1292	125	1	6301	jxLWi5hzMg1hGw3D3F9zuQD96SPEin8T9fC6gAoCHUm5VBVt7ET	5037	7087	7087	1617214860000	canonical
9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	1467	1250	125	1	6301	jx9Fpjx3ExYrjJTgxYjfMJtX16YtV84VVqG5eMgXr3niuyXfekr	5040	7092	7092	1617215760000	canonical
9724	3NKPmgGPCFjBgMYmXz6fWWjtiCCzr9m3M8cbRL4BccoAZcLcjiJz	9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	1403	824	125	1	6301	jxvkBQXaBLawvnxVdhNwCNcG7bQHGhPNSBUN9a5HRANdDePjgD2	5040	7092	7092	1617215760000	orphaned
9727	3NL2aeweB9vDD4QjF8eo5GqoXJfvzt3m4M6YRwtAm7BdTLoKDpRD	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	1407	1395	125	1	6301	jxNCkLH3W1YyGy1oZBc5EV4znwDDKJMzZZ8F6hbVxmyh2GgQqyv	5041	7095	7095	1617216300000	orphaned
9739	3NK5UKqBkjsUxEd3RnTvk42jw9RraBxoujpZTf4kezdEdb5FhsTa	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	43	1310	125	1	6301	jwKSLMU3KkGAHChKVhkuNnUaKpeSKaZ5jsrbmjWPDtgXBGW46De	5041	7103	7103	1617217740000	orphaned
9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	9728	3NLm2NqL2KsF5FrVUdxHzG9Ly83UmTL87QYKkZqoiY7BnEz9HBio	1407	1395	125	1	6301	jxtZ3hqpkQfPufeT6hrv4fKysbGsuyWzop6HmJetwRAr886kkpt	5042	7096	7096	1617216480000	canonical
9735	3NK9M8S2eqrkLrxV49EFvtwe74qjbR2ZE4HLWWSJuZkBfmyE5B6E	9731	3NKTzcjFrtC8YgB83CTStekgKEbfRiMfKYgMXHvYqJoGNbZmvkhZ	1406	1393	125	1	6301	jxjzef65DrgyTgjRqxJEt3rcaZ1uthnPhiZP7fgDRxsTz2DaLES	5043	7099	7099	1617217020000	orphaned
9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	9733	3NKLYRVL8nK2ND9mxenxbKmSNun3YJvu2EDskKo9KZCMKs9h4eB9	1483	1276	125	1	6301	jwsBA5bxssj7gYcHYRZDubAEFHQUV6GauBYhjPfFohR4Livx5S4	5044	7100	7100	1617217200000	canonical
9743	3NLctyk7dLY896tXpyuZSwr4nhAJ7x4aJ8trn1DAxZtcZjDQUf6C	9741	3NL7Bcs1M81iVDZWpQzYd3VrgM13y9HWoUN1QRgaijUDjage6wMt	1426	1118	125	1	6301	jx4GK4zKZZc4jxnGWZh5kFDDDh132Xb5j1WVWxLDWCnkdDFkvmH	5047	7104	7104	1617217920000	canonical
9746	3NLv3amCt2tT5M5uBNeFBLn3KCCYBUZnUyhsJKURcp1skEGRne3b	9745	3NLeJoLYR36RVSyBMRk7gyoBP7hgwspS2Qe3nEPtTtrXmPdhXtU3	1403	782	125	1	6301	jxUKbewHr3QbdztCFJKEPmyC6bhzTdXe2MKQn7omDXAnCvPwTEz	5049	7107	7107	1617218460000	orphaned
9748	3NKBt4FcWMcXGBWnAiQY4mY78EwWvJt46VdJcP2QmzrZdD4wbRrz	9747	3NLCDMAPMfm195hkC9aAjRMSaGNcKXvSmYXUw37nhaz6w87cyXqg	1440	1011	125	1	6301	jwZPz5zR8BpudWAfknwtAPQm5AisKZHine8Lid53v1rJXENUc5t	5050	7108	7108	1617218640000	canonical
9753	3NLRSSKBcftfG9xCbdRCHu5bFe91TsnLTyfhq3d97jQkLxv8LJG8	9752	3NKFuXAR7cNJg4fg9SxXG9gwJBAsigdtbcZznsCo2oCa7HzhcGL9	1673	1002	126	1	6301	jwvb4v6RwTL33LhChfj2p9kbDauy5ZMDSzforvLNwjEBsKgzGXv	5053	7111	7111	1617219180000	orphaned
9758	3NLKP7ZZHAVXCN5UEfUPk56fjogvudNzfWPArX6zdGPyM5dtFKJs	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	1406	1393	126	1	6301	jxVCDWJPQKGxf6UJRi4xcQVSGtGsLvMBeAYjUZZfLsCtDqMWvTU	5056	7114	7114	1617219720000	orphaned
9760	3NKTo18aiUskzfsuFyV75K3exNXmmvSQ98JdkeBBVeXdjohsQRPa	9759	3NKWnw6yQkDQLGaKqPvhbZ2A9uj5YYMJLsxQMAZgQkuTPWMnrEDQ	1579	1389	126	1	6301	jwabhrSBzrxfsDg9EzCZFRjFErmxymAWynx5KW786LARa1bjGYb	5057	7115	7115	1617219900000	canonical
9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	9762	3NKM9TQ7HRwdcZ51qvv9dmxNY6paTUBFSA173ZC8YEVNPJJZuDKU	1405	857	126	1	6301	jxSPhGAxp3uawPJvuShdP28xttSZdjRmrW776vz8FYGsiBE9RfG	5060	7119	7119	1617220620000	canonical
9766	3NKLrPQ5VKPtBQXj2vkCtEfauTcaN73W6yZkWGZje8sqLc1x84D6	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1523	955	126	1	6301	jxyuTfetvgwixTncQ9zFSyRLXERG1G9mVqnvhJ24YjRK3gXqRwE	5061	7122	7122	1617221160000	orphaned
9770	3NLFoCdJymDLpCaTKQ2BWsKdGp49t9TCRLu4z65k58xkNuLmjLg8	9768	3NLNoyASKuKYPAfjMALGFtdjHgBtjjquSRkU6fXtqgYFwqJmqicJ	1403	824	126	1	6301	jwwYrfCHELgpdnaw6VTjBQEisdcA9n7bV6wvdkCiykXzzpk7ktr	5062	7123	7123	1617221340000	canonical
9773	3NKDxfXW5CdVYkTo7irigW3gku2qu2ihP3LyXZJvqwAq13LUWZhh	9771	3NK8tGvHhEW11Wt34kLQimEVThVMvAt3tkkf4eUwGEdavU31peVQ	1406	1393	126	1	6301	jwcuivHsTRDtimWAtkdy2iA74VjBha8RQeLfRLq64oMrJwSRsw5	5064	7125	7125	1617221700000	orphaned
9777	3NLWBwPVGBDANwiX5o6YaXona1bXgvwoffmx2i1FG6kb6wyvteVY	9776	3NKkhDAf1fGYb2i23rEoGrLTvY4zUVVR9GE92twpLztM6fVructe	1407	1395	126	1	6301	jwea92Ash6Y28NWk9hFN1eGe8fHWoWJkic69CREDZ4i9MqvjoaX	5066	7127	7127	1617222060000	canonical
9779	3NL61euL1AR7jVVHLJoEgqjzW7tuU1hRij1CfpB2d49K8hiiDRSM	9777	3NLWBwPVGBDANwiX5o6YaXona1bXgvwoffmx2i1FG6kb6wyvteVY	1587	1111	126	1	6301	jw8QJ5dSbJokRKaW4SYxPdryHF5MW18FHjU16AvYZA3i4gHCEhx	5067	7128	7128	1617222240000	canonical
9782	3NK44xm668zuYRWDDgjLFVHhbgH9dx8W8T3fG1EzbDkFCPeXuW5Y	9780	3NK5sukdx2NiatK4rgqfCG9DekEkS1vyKtrEhQTUJScMxezZVUAo	1588	1146	126	1	6301	jwBFa93VFSLzHoncyv5AmxejNgK9eJ3J66z73wrULL8VBNS5fSu	5069	7131	7131	1617222780000	orphaned
9784	3NKy1bETcWVx2NspkUB3Vd3ABkuyR225y59M8Q45gZ3JJLxCFGVp	9783	3NKAUhp19AyDsaWNKZSocJD4XvP46DMJ8pThvcweCsM34jphSpyn	1675	1096	126	1	6301	jwdH6M1P3yZa4xrCC8nUWwu2rLzpm14esn1BGBR6qAy33XjjSyF	5070	7132	7132	1617222960000	canonical
9787	3NKSwAt2b5HPXjjLHkEHvGhEfXY2433HzBPqRqYiwfeMWZ45ffJE	9786	3NLSpYkYCTdoePtzCPSpTgaQAcqcn9WYVwQvp35fHsps8tSTtyRy	643	643	126	1	6301	jwps7g9iToGSZHNZYN1tsCN8D9EML7oJgMhf7Fz2eJQtFH5EZzs	5073	7136	7136	1617223680000	canonical
9788	3NKjtUrkTzLJ3KYGoSb6fDHNTRLTwWwJpmxXvY8kXScSG4nabGwm	9786	3NLSpYkYCTdoePtzCPSpTgaQAcqcn9WYVwQvp35fHsps8tSTtyRy	643	643	126	1	6301	jwps7g9iToGSZHNZYN1tsCN8D9EML7oJgMhf7Fz2eJQtFH5EZzs	5073	7136	7136	1617223680000	orphaned
9790	3NKmKfm2RSTfA1w5mNSJRLoyAQgcRhWjH5qdNynchHar4kBmJPbW	9789	3NKJadufDfqn1N1oemsuGDTkz8sHwkcv6EqEaVjiGMXk43RRfUwQ	1406	1393	127	1	6301	jwnomvb6fXewHaXcUt4zmCBuHA9oUwG2ERQE5YLzQcrDaBfHXd3	5075	7139	7139	1617224220000	canonical
9820	3NLQWK3VoMX4w4Nq2bwWtukJ9p9aRu2DN4Ka9Y8H6YKc785LUk3Y	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1419	814	127	6301	6330	jxJZjN2G41h4zKY5KXUgENYfEqJGNWgLfWsy35FvX5iGj4USng5	5089	7155	7155	1617227100000	orphaned
14175	3NLvgYoWacZZtiYQtyMEghk7gejrLpRXuZj6y5TuxQETU7hfP9sZ	14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	576	1355	218	6301	10307	jwE7H73Rfqa5USy9Hsv9SP8yf3msWV7MM5o6CYuska6BwXJrcgn	7237	10245	10245	1617783300000	orphaned
9714	3NKSCeEomeWQyWnB3VgjmqF2d9x9TnF6B53pkZLorxegRL5hbS9e	9711	3NLJ9q2N2N2syF9hSWdQWpx5pUY5sfC6KA65H2P56Vt9PetpPaNg	1634	1205	125	1	6301	jwJG4NBGhVoov5aDAHWDGNZMmA4hg6isjis1aRyMwuE2RDixvvs	5037	7087	7087	1617214860000	orphaned
9720	3NLD1StoQoXodrcUBqy9euCfN6Tev9uovZR4rxggzCkrrBMBpDUL	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	1559	1353	125	1	6301	jxAYoAUx2Fczteubkp1fXoc6W7drAWKZQ9Kh39mDBm4wxf1VSB7	5038	7089	7089	1617215220000	canonical
9718	3NL3MHJkjZUqq9JqgUm4NKBBFXBsQyjvdjFqFN3fGgdPpW3L1bC2	9713	3NLqtiGRdsKz2uEu2KkH7MKf9HJdG6bHbqeQxqK8dWwbrcd3dNmB	1407	1395	125	1	6301	jxcR9CSM4LZCaoUSHCUCbPDoSVM3qmFpbX5dqVtpii3vFH7fASY	5038	7089	7089	1617215220000	orphaned
9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	9720	3NLD1StoQoXodrcUBqy9euCfN6Tev9uovZR4rxggzCkrrBMBpDUL	1405	881	125	1	6301	jxWi3NpXxLEMHdSM7YyF6NrWQKHQeF7m3JkHn9g52bzpU8QwFDE	5039	7090	7090	1617215400000	canonical
9725	3NLf9VZLg2yGYeuM3ygfgAgKLtcCEZypGKTzxB8jrmc8BGckPuH3	9722	3NKsGfvaEwisXm2QCTy5LiLfD8oZdQTiH2vyXeB8o4SkC7ztbF4R	1407	1395	125	1	6301	jw84UVCzhY8HtrSnbHokFhKSUAyAGpZWLQ2AKC4HBBDqvmKDa5c	5040	7092	7092	1617215760000	orphaned
9728	3NLm2NqL2KsF5FrVUdxHzG9Ly83UmTL87QYKkZqoiY7BnEz9HBio	9726	3NKyoKSgk6cRQLtzJu22M5MvbZLGyJhdxJNQ2Weito2zc5trwfHs	1589	1286	125	1	6301	jxzLgH5KnETm4RQ9o4ciCD3ciMZLEwfgNDx2C25ALg4RFzAYTKv	5041	7095	7095	1617216300000	canonical
9732	3NKUrKHFMkx29wF9SwE2kzr1rp42yFqxEm6jCWaV7ZWNtwix6BJJ	9729	3NK3fozJf6Pi5b7Pxtqw7APfdAgCKVzNQuVMUXYLxwBAejKGTnep	1646	1354	125	1	6301	jx2HVzaNVhC64dvksTLKXibbwfBvQEVuRdpMF1oLS5btdw2AXNy	5042	7096	7096	1617216480000	orphaned
9737	3NLswbgvFReF1rb33qrxCLHc4sWEYMNCnyVBivpaP3XUn1Pg6jCA	9736	3NKwM2qNH3mHJUnVW7ceDD1vZmRwu6JRxh3yS9KURv84LSyiMjow	1609	967	125	1	6301	jwMqTqYy9LJWt66NxgGQyp8Yo43qjY81yEbqCcwuHpAvd68Fv4w	5045	7101	7101	1617217380000	orphaned
9744	3NLfDsVpZpGgixBvRX2Af4MtD2KMVdPSL4N2NQZj2kYyZ1F91ENm	9743	3NLctyk7dLY896tXpyuZSwr4nhAJ7x4aJ8trn1DAxZtcZjDQUf6C	1403	824	125	1	6301	jxXFkUkMf4jYjXWQLLcFUtXnTDpr2PXatM8BQ3iSaaxFVM9f4Xi	5048	7106	7106	1617218280000	orphaned
9749	3NKUfnDjptihyZ1kZ1d34qo9PYX2NhHJPuocxbw8rjcSj2qQimVw	9747	3NLCDMAPMfm195hkC9aAjRMSaGNcKXvSmYXUw37nhaz6w87cyXqg	171	1374	125	1	6301	jy1qAw9nwBfQd6Lo5EwpC1LPyYJ9T64ZQve8tBPsi7Ugn8FSGio	5050	7108	7108	1617218640000	orphaned
9751	3NLm5JiE6Y8pV54vTUCTqpuWZBJiBPRN7jhALLpZyKQgrpYXdcuF	9750	3NL8hMgEzVHRGqXgrVFkioZcUxicdNx4q9JUPXr1dxB4wLupBZpa	1460	483	126	1	6301	jxWL8ECcTpdvu4qycqj1fSWK29swvPZh2kmJ18NEYRFDbEPcqPk	5052	7110	7110	1617219000000	orphaned
9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	9755	3NKhSWFmvXbjrYTcDh6odF7QpFshvCXJFWEKEsj4dnFBy8Aa8N7J	1407	1395	126	1	6301	jxPjrT2d83dz64ss2fDJ6JnC1omFi1NoHVzVkkBh5CfepGS3niq	5055	7113	7113	1617219540000	canonical
9764	3NLqy1AGUJNTpWMME54yTw8GU2BfZb5THtJkapMxmAEyct6xxaGX	9762	3NKM9TQ7HRwdcZ51qvv9dmxNY6paTUBFSA173ZC8YEVNPJJZuDKU	484	953	126	1	6301	jw9S6zbkSQjk7GZiq2c9i3BGUL7E4c4yEuMmyaa5ijMuk3BqSRP	5060	7119	7119	1617220620000	orphaned
9768	3NLNoyASKuKYPAfjMALGFtdjHgBtjjquSRkU6fXtqgYFwqJmqicJ	9763	3NLRsFAKni5qLB2V5rsamDuSyVanZMopqwfqqwfPtvUHLt7iAse8	1523	955	126	1	6301	jxLqqwvD8qNRu68MXTLs6iAKJEsdR7tBc19Rjaqd9KcVYYbgK5d	5061	7122	7122	1617221160000	canonical
9775	3NLoxpxLLV2dPtaSzHT5yNeEAyWN1HKhTWeReFvhx1vZdatmywYp	9772	3NKhuzquG5mLK7y9A8hLtfkFfcNdPU5hnFmKqQEE4vz6AhCgW3qR	80	1027	126	1	6301	jxmXzQ2BghpYEoqFUDt9PHqWbNC7yQXfoDTmRHk9q3Z7JawPWuA	5065	7126	7126	1617221880000	orphaned
9780	3NK5sukdx2NiatK4rgqfCG9DekEkS1vyKtrEhQTUJScMxezZVUAo	9779	3NL61euL1AR7jVVHLJoEgqjzW7tuU1hRij1CfpB2d49K8hiiDRSM	1527	1047	126	1	6301	jwyYHGTHJ2gSJXNx6JbvK7EHvjS2QQzEDMFGTPgNBMqYinXxCu5	5068	7129	7129	1617222420000	canonical
9785	3NK4jRw2mp3bErPf8X6b16grXi97z4oQca1eQgV68NqChkpE3ofy	9784	3NKy1bETcWVx2NspkUB3Vd3ABkuyR225y59M8Q45gZ3JJLxCFGVp	1672	1285	126	1	6301	jxrW2HbGLAyufon3Mj461GiK7Zc3TfQ86Nv7M8iJFb5QeG4xYPK	5071	7133	7133	1617223140000	canonical
9793	3NKwrCZDQor1eHQkutv9Ep16Di6V4oPuHwxPh4q357xhi7vqWrhA	9791	3NLC8CV9kZYFkXnUipJzkkHvT9RmsttSUNpwfwqwWCfbP9bQmwNJ	1529	1190	127	6301	6304	jxPg2MXfy1VNwXc9mYMEv2LpmTVu3RS1M4FoDY6vGSW1k2ayfch	5077	7141	7141	1617224580000	orphaned
9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	9794	3NKUuMtcapwCX4pQ7gMRrU3UTyrete8nxye525CEwNUTxQL4tT3a	42	995	127	6301	6306	jxof2Fdn3tPpjsXnPWjkGGT1K3DuZbt2GkYx4Bh6ZkmhTmhAiLz	5079	7144	7144	1617225120000	canonical
9796	3NKsEa4QmijW4SXGK9BU74LaGgCGfQbqjUyeFVWet2ZuZsbty7mt	9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	1403	792	127	6301	6307	jwD5GPdcGMe9obEjUTpfjP3LTK6a4SwWsU5juQPHTdJx5b1agcg	5080	7145	7145	1617225300000	canonical
9798	3NLi8vLDtnf8xH9P63zHe9f1hZoezQzaqNymFjhzKDtSVJ4kCarc	9795	3NLXyDkp1nUNQYtLwDDVC8X45m3xNqmXTmFVgaBUastY5fyja4m8	1581	778	127	6301	6309	jx1N9kK41ewUZmqYeBKnoTRPJcMgtnZRroRcNR5fPxnyx4wbCyA	5080	7145	7145	1617225300000	orphaned
9800	3NLJFhqmfz9KiUKVWbD71Lp3VMJvs5igCX7uiVEW6WBpkCkMDdxa	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1599	1161	127	6301	6311	jxFpA7ThCtoGqPKM3eNBC7yUfawPvhrszx8fsZhYGbU28Yb4c9W	5082	7148	7148	1617225840000	orphaned
9805	3NKYkuCaWi2fL7zUBCaEt2wqobA1xzTeQVPCWtvfKW6ABtDwDKLY	9803	3NKBWY6KXDDhZwZQaRnC8A7TF472JmoZ9XshLsmSDauebd61YVF3	1483	1276	127	6301	6315	jwy8BUpFAEh6sGsqGFjgPgJbuHvZdiLvs6hxtRLumYTCEs6wX42	5083	7149	7149	1617226020000	canonical
9808	3NLjtqes69JnSj7Aw2rB9QnfquUCoifwzVCXNbZzv6EwX5m49dbr	9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	1656	1097	127	6301	6318	jxXBhJmJWt53wHSLGXxTFZCBkvV9pNQfCqikNUUoTFsbRYKHbqb	5085	7151	7151	1617226380000	orphaned
9812	3NKoS5GGcrPVM7yjuwzytJHsWUZx8V91L1qWFSHmYxyQzYdgoWMZ	9810	3NKPm4grj9ZbkxaqM1RMqm565HTt95v74y24KXgUuGxZpygLZkLy	1403	792	127	6301	6322	jxS9rPWdpdhurH1rXJ5RVJie44nMRxTYHHTXk6Ys8tnhERNthmo	5087	7153	7153	1617226740000	orphaned
9814	3NLq56dYY7oNPMqXqoAxXQEUU21Sb9gqub97mjD9Mi2xRNzbqXBD	9811	3NLktF81aJ2itdKpfGytMJmKA7GUATsfHLgMCg65oxGy6kUPL8KV	1405	873	127	6301	6324	jxBcKzdLZj332JTw6HCJaqbXPua5zesEYfa6qwCJRkNCEkKV6Qg	5087	7153	7153	1617226740000	orphaned
9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	9815	3NK48AtpUMBeyM1aXG9DRJpRoFft88UrJtQj6tthVfo7VYHo7ch6	1483	377	127	6301	6326	jwxwa6UtMLE5MpvNCqvDRwr5jrwCGN9hHHrnfeHKN791xMh81Xf	5088	7154	7154	1617226920000	canonical
9823	3NLF1qqXMwAvAsVrY1GSRxh9uKMaatQSqKiVKUvVpfQdbiYe9AW6	9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	1581	778	127	6301	6333	jwjWHQaHN1FgemwqCeH87ikdyxoeQcQg1Y3k6S9BnvEdbFJwqHZ	5090	7156	7156	1617227280000	orphaned
9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	9836	3NKCz6zRjejAuarZP7BwV9yLrMvV5gFCRhiNXgjq8L9UFHRfpGHE	210	210	128	6301	6346	jxTJ8mgT6Jc6a1DuK1gwaxVKBu7qqJYrPKEbkZvansWj5GeCtBD	5100	7177	7177	1617231060000	canonical
14184	3NLKN3SMQat8i6cnvtDbLmaHt5cYMayqRmcSuni8BjPiWuKF5Rys	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1637	815	218	6301	10314	jwzRowgzc1fpwKG4dqYjmnBun6kGHjaZNgaE5aELhGxD9QmbdVn	7238	10247	10247	1617783660000	orphaned
9803	3NKBWY6KXDDhZwZQaRnC8A7TF472JmoZ9XshLsmSDauebd61YVF3	9799	3NLUgD6tjBmEHtEkVTz7AqtE5CakcYhZBPDUKzEApisJWxzN9dTS	1668	1004	127	6301	6312	jxNLWbEhsJg7hxd4jdwhnRLRyaVJ4ED1eRSfCigt3BD8Bi2sVmi	5082	7148	7148	1617225840000	canonical
9807	3NLmLoiwXRXCxvvb6MGYcThRWSvDPJNHz4fvAVUaMCv88nq4zRUe	9806	3NLinNevDjV5Vnhryqk1NBbcT7wSFP1jc8dGahTrMdunAk1VPUbk	1460	576	127	6301	6317	jwe6Dpjr9w35rya5x2DhjFeW1a77fE6iXiPFgrJjE1vh9kbKf3e	5085	7151	7151	1617226380000	canonical
9819	3NLWbRKQSWR73vaR5tznikm1XjksPeqahoTDkosvD58VEHNKpHXo	9816	3NL8pKXB22XcvnHEcYx1GUAS422SMMsmUtbP1NnKJHdYEWZReQyX	1642	1001	127	6301	6329	jxgnShRqyn1vqGF9PdF4K1YwCgu6F2PWHP2yC81TxMGpPjry2LW	5089	7155	7155	1617227100000	canonical
9825	3NKkT8BjXizuEuAeNPdFZf3tEkwFzjjYBj8CfJXgBrjDFLxsg4q5	9821	3NK5QLjv5jkxXhBzo8iMBT7h5nEu2SoV4sLcdFJqj7Tvk5j64aeR	1631	794	127	6301	6335	jwdiQx7Rf64t7sGD5NYGdFUvm28oEkY2R2APvQfd3Q3coDtE27r	5091	7159	7159	1617227820000	canonical
9831	3NLqrvAvhuHQkymkMBBUicFkP3of1QLfeEZ2bo2H15b5E7JwWp3R	9830	3NKcdqKzUi1qnuYvrSq3iApBQGzp3t4CBmhVfdn8Pnyu2XAn29DZ	1631	794	128	6301	6340	jwDaE3a7123JLAyQ6d1TANh6HdC6Bj41DnDuuxcyghGJVH6Vjta	5095	7167	7167	1617229260000	canonical
9835	3NLkmsuEPKhTKtpFeBG2PxCPDzikngv528JhSQfGZ1uHXV4pBgpq	9834	3NKmhQYNCDEZdtyGRhpDo2nSL5TXU8mFLncrwThxMoeSjdKP5Lk8	1406	1393	128	6301	6343	jwzDvWeSdLY8L6oykz55n3Remtm2PmSBF1wv9nEFrvxRPVGsLDi	5098	7175	7175	1617230700000	canonical
9840	3NLYgEACaqaTUqSw3efvcstbj5YuMy4v45M2Ef4MDjv2ERMpPRb6	9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	1501	1360	128	6301	6348	jxyigiiRS94eQEzqCbJMgENpF4S6698Zu6PWXg9Vx1D54NaygdA	5101	7178	7178	1617231240000	canonical
9842	3NLFoScFqxEr66nFi9WFPpdcmGpYRQPVKsTZdo158MVJFRAF72SD	9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	1652	949	128	6301	6350	jxB8jf81RrPwMYEQai8ffxDsBK3zYnMgZSZBLC8MauT78UWghjf	5101	7178	7178	1617231240000	orphaned
9845	3NKmyX2QoFXMEgxFPQRx6u2UdzkpGKYjvCPBrS2CccunDxmTPHa5	9843	3NKvEctL89mFnmYFnvtDeRrMjqfmbTPyZtnxJzy7p7CKCLsUxcz6	1637	816	128	6301	6353	jxzGe74P9XBjHz65L2UptyozzXmTHwcqWuKfgvTUzMVmQHQ9Q8c	5103	7180	7180	1617231600000	canonical
9847	3NLqgiYgGFSjmSK26pXoYNNHbrgDzepnV42U2LgXeERMD4Cua1ya	9845	3NKmyX2QoFXMEgxFPQRx6u2UdzkpGKYjvCPBrS2CccunDxmTPHa5	470	1309	128	6301	6354	jwpWbt2KUuqpmZheH2p2cDGnGh5z1KVHQqJhMNdUfqSKbcWEDvs	5104	7183	7183	1617232140000	canonical
9852	3NLWnFYtNpmXy8uKCLRGnnDJBo4fBfo2qXjBuGNb9ZPwjev9YeHQ	9851	3NKqeof6HkoxbhAYWHFEb9sZWVdWsZf2MheWCh5TsQoWoaTuys1J	1529	1316	128	6301	6359	jx9TKtYZLtYWCFFk1y8aGhHLWEvv72Tmmu49H98i8uToUyC8ZyR	5108	7188	7188	1617233040000	canonical
9855	3NKg8anUxtu6V69JNR5zoK16CCgAaNWbdFcug1uKmCtC5p5WaZGQ	9854	3NK7Grzc2K8bWuMf3k1twak5qf4kx1s7VUb75DMtQDn651Xi59Vt	1407	1395	128	6301	6362	jxuq2mfoAdX5KW4LLbiYzjKwzZFJ3Pyb4nHhsgusU6nxyB61QRo	5110	7191	7191	1617233580000	canonical
9858	3NKbL5wHphSTPvTqAgYbxEcy8SRGDd2NsXA8dz7kbSjZ3KibLgQY	9857	3NL3aSjCt254WmJKVQmN7EtM3EMQ8h21vUmqSRBsqnMDXo7oLYnQ	1403	824	129	6301	6365	jxgCLRF1vP14er3Q7vfzmXFRp297LmRoJEGPSTjKiNBLBfFkrZm	5113	7195	7195	1617234300000	canonical
9864	3NKoY6fmJQuZV9q4tHTZpDc6B8sSYfqA4Dp6gLueMajaaHfSN5RB	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	1405	873	129	6301	6371	jxDFaPxrYjxXczNXT6PB1FwznXTdQtLReVeYoJHGACNwAwcdgbH	5116	7199	7199	1617235020000	canonical
9861	3NLjwyZWuDATwi8Pv3z3JB3scaF9cvFv8JSAVzdMv1hLz5H8qAkU	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	1607	1222	129	6301	6368	jxxFm3PH4poDQY1Xw2bttAEjXHQk4irBNWPYHRJpPiYnP4zKMs3	5116	7199	7199	1617235020000	orphaned
9865	3NLchAMNFcn8zHgTv7jjDn6beUh2FzDgAPE5acG9EiaoTCs7b9z8	9864	3NKoY6fmJQuZV9q4tHTZpDc6B8sSYfqA4Dp6gLueMajaaHfSN5RB	1647	936	129	6301	6372	jxi7VubeRPVY6ueEpq8Pa9WtoHAYpMMyg5C3pkrG2D4YH8fi7pb	5117	7200	7200	1617235200000	orphaned
9870	3NLFL67591a6M2rH6PeuSPDKaDRy2dbHXGTC9mrEsbUawo379p7M	9868	3NK8NEPiHXz3cRSwdKEJegXzh9VevcACX8VG8bXRetQUBQB1XbbD	1402	852	129	6301	6376	jwc7qU2SDwzPrGuYHDn968VmCr1dX4rVyVmuJTxf2wz95oj9cJT	5119	7203	7203	1617235740000	canonical
9889	3NKLZP6U3zNybPsv69QFPEpFGEg8yRqG8yWvBBHmsgMiZZgniQKd	9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	152	1330	129	6301	6393	jx1rx9UfYAHYghDMPtwFyTFYCVpa2H6Le3xq6UaQgkoVukzvRrs	5126	7212	7212	1617237360000	orphaned
9891	3NKLro9bZfA4dRmtZ89rbPwzMPcfwpB4GBviDayYQm4qKSyJtVsP	9890	3NKQeUvd9dsMiyu7DFoqLiZaj8LyvXCo5jTE1nW7MezpsvmKiAaP	368	368	129	6301	6395	jwXcH3SeMLZcMTLeENFc7xc6DvGWq6y1HZNBkqQNvvrSDKDgR7a	5127	7214	7214	1617237720000	canonical
9896	3NKFXJVQf56NjRrv7cdYFCPSAVwLr7xumYyG9WbY1Mhi8mdXNbBR	9895	3NLwTxRaNFgfpSugMfoRT8UJZstRZgEdUEP7EE3HvioQfyU5vQNn	1403	811	129	6301	6400	jwjYMwy93ptV6xBjgeErvmUc5YqYmTaNjfnbqJshqY3NGeBmC1x	5130	7218	7218	1617238440000	canonical
9901	3NL2bhe5iWPdZv8J19Hc92h7VLvYsKUFZCi6jqf8Q288YutkTqYv	9900	3NLWJmYQJP29vtsPifZUkkjPvs8jVpiCDDG2EgAoBjXDzP46mtJS	1407	1395	129	6301	6405	jwWBtLqhNoaqhWXLv3s23C5JQUey13bnnTUs8FBdymjnvuLhdvW	5133	7221	7221	1617238980000	canonical
9904	3NK4XNEKBZWyXuZMptJf7byJjUhhLgXVK9Yv864iCrgXcmjijtSB	9903	3NLp4J9oocy8hEUuxKUXR45daGDgGdr52Jnf24WKitu3NQqetdxJ	1657	1344	129	6301	6408	jwn4wJcmTcfHN1avaarqDqxMMehyG2cGAstgiZ3YkecWS6ErJgV	5136	7224	7224	1617239520000	canonical
9906	3NLRTys89tvAcBMmmaa8ZcdRd3AEEH5STHcXqXWYPmRrrbcBUws1	9904	3NK4XNEKBZWyXuZMptJf7byJjUhhLgXVK9Yv864iCrgXcmjijtSB	1571	969	129	6301	6410	jwosTQnd9cXbBt12Kvb6UCJHMdJ7ZEi1vx1snJRXqagPRqzuUNB	5137	7225	7225	1617239700000	canonical
9909	3NLWhveK42mynUEMaHLvSuuSYvdkmRPxLZpwYAGaAJf7bBfarz6v	9907	3NLAmp7MmfhhFK223oma2U7CKRGG5fpY2jQW7N14U32GHg5LRksP	1407	1395	130	6301	6413	jwdWpyRfJKXodLco2baby9nQJTqoXwgioUJUfoxmnUKw5ssec4m	5139	7229	7229	1617240420000	canonical
9912	3NL7rnmiSE93Kt2BaCMGGVmMfPALBpopHM5atJivUEj1Gh76usL4	9910	3NKtsECB4MWgsmRSEJjAZ2zGSK4zpwywDDZKZwaqiQ1bSTzjrVC5	1406	1393	130	6301	6416	jxqoVHMb3w1x3f4azFm1cevEU7C2FsR24DxFFwESEptcRDyQVxG	5141	7232	7232	1617240960000	orphaned
9914	3NLKgozbnph5jUfbz2f3aK2psfJ39J3YcCPvk4JaCXQQ3PZ6PRKy	9913	3NKkJdynCHyVtQvAQ6nUjbfQxgdNVeRrHnU2JXUBLURiFBDJqQFJ	1571	1335	130	6301	6418	jwa2NE1vZCSC45C496SsTgNScdj6UK4nSL3BMgFPPhpqEgE84DL	5143	7234	7234	1617241320000	canonical
9917	3NK75sBwSEicdEXTSbAvwvZLqEo3RwaMwAEQcxWfvKeSdFzLfvWZ	9916	3NLyHvV9Jk7YUQHYFmJJCzMJGz1fDvkNAyRh1XyVAVv1dEPbkgGY	448	939	130	6301	6421	jwCF4ZC6Tf75MMYjrFTadzAUDwkZFTg7e72G5FDrzP97qqnmS1J	5146	7238	7238	1617242040000	orphaned
9920	3NKhQe5dAjta9syHrb5svP17x8SDmPHtr58p4X5ptmUqPoLTP3Ea	9919	3NLpBMjhC8Ab1tH6TULipDShRoVvzRLLMMtDEkPjh2cmcG8TdoMr	1506	1373	130	6301	6424	jwDKQnsVbVK638KDm4FkT1E2McBacSy13eQ4nYRUp4uemBH8dJ3	5148	7242	7242	1617242760000	canonical
9925	3NK4wiefJojFtNS7G7pTuoQ9Tv49QDyYXWiNd3iDPuguQZvg1aGN	9923	3NLox3kJKRpJBLW8VgLJRRtR8EAu22SNKXdCSgRDof9sX5P8hWuA	1507	1034	130	6301	6428	jwCXwp4zvM4dKkde9gQ34NHsxGfC91Gh3QowBhSKrAcY1V3pyue	5151	7245	7245	1617243300000	canonical
14183	3NL1HingZAnuuag3Vx9h4cwqQ4s6VxnQ7p19iLRcD9hyenycRfr5	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1599	921	218	6301	10312	jxrAfTvVuvAe3McPasRutppw4e9899dt18yTTVrRNbe6ZFSLoCw	7238	10247	10247	1617783660000	orphaned
9884	3NKTWH559suBaN3FyZohnKRqw4exRfj8Ncw5ewQLVCDgiHBGyhjL	9784	3NKy1bETcWVx2NspkUB3Vd3ABkuyR225y59M8Q45gZ3JJLxCFGVp	1642	1367	126	6301	6386	jwTc4sQkNtJ8ZCJ4yg3VoktQoLDnwpesioYRbrDp7JaiEjbQdWZ	5071	7210	7210	1617237121650	orphaned
9826	3NL7tpPVq4GRwuJZyjUWWkLGL2uXQDQCGhK5bntJU4KaR7ef7953	9825	3NKkT8BjXizuEuAeNPdFZf3tEkwFzjjYBj8CfJXgBrjDFLxsg4q5	1403	824	128	6301	6336	jwQAcbGCE84RjJbaPChhESGX2MLvASakWq1CysZ4wFqVfsA4KHK	5092	7160	7160	1617228000000	canonical
9827	3NLNmgRHDgSA3LjqadHLakUVGXuiDZTm4srx49jnM7BNjD8EqtDF	9826	3NL7tpPVq4GRwuJZyjUWWkLGL2uXQDQCGhK5bntJU4KaR7ef7953	1483	551	128	6301	6337	jwAYaiQs6YGuMSoxYwkn7XCmAZZY3uCqmMxaj1mADPLCxMjAFBV	5093	7163	7163	1617228540000	orphaned
9832	3NLfvJcNq1HH39hEHooeJ8p58GynKgqJNrHfNUQ9m2rgQ17NVXtR	9831	3NLqrvAvhuHQkymkMBBUicFkP3of1QLfeEZ2bo2H15b5E7JwWp3R	470	1309	128	6301	6341	jxwWMztK44SLmfjG2ysZ36NWRGaLZyF4icA9Ktk4abGejNV6FKq	5096	7168	7168	1617229440000	canonical
9836	3NKCz6zRjejAuarZP7BwV9yLrMvV5gFCRhiNXgjq8L9UFHRfpGHE	9835	3NLkmsuEPKhTKtpFeBG2PxCPDzikngv528JhSQfGZ1uHXV4pBgpq	1600	1372	128	6301	6344	jwqaGr6EQMHm6E1RkCyRYyP7nhwd4bZ7wRRx31X59E4GWerC4sA	5099	7176	7176	1617230880000	canonical
9841	3NKPfiZWUL3KfbXdUTdSxtMUmqFG18knpDNKSgd8rxBbW6VWj1n6	9838	3NKL2juy6CjX4Va68v4k4CS6v5Kqsro74cn3u6Ae9V1KzkW17ccH	1471	1386	128	6301	6349	jxaixERbw8Fif4pd1n8A6oLh3vg9xTH5K3yojubQhMfSnZBQGp7	5101	7178	7178	1617231240000	orphaned
9843	3NKvEctL89mFnmYFnvtDeRrMjqfmbTPyZtnxJzy7p7CKCLsUxcz6	9840	3NLYgEACaqaTUqSw3efvcstbj5YuMy4v45M2Ef4MDjv2ERMpPRb6	1407	1395	128	6301	6351	jxA4GJ3QKuKnh7g5Wr68RtMZuFVs5x9Vkkgh9GWtktDpaqv268t	5102	7179	7179	1617231420000	canonical
9846	3NKxoJHXt5m5SQpGNuPMeuEeGm87eFcpMNS8aUsMm89nHtHaD33i	9845	3NKmyX2QoFXMEgxFPQRx6u2UdzkpGKYjvCPBrS2CccunDxmTPHa5	470	1309	128	6301	6354	jwU3u5PAbkipfdWEpHfcTvMzBZRL4TfjyY9Z2PbaPbad9JxMaix	5104	7183	7183	1617232140000	orphaned
9851	3NKqeof6HkoxbhAYWHFEb9sZWVdWsZf2MheWCh5TsQoWoaTuys1J	9850	3NLwjgFXHjbn6RMAR6anwBbrKQYpFCfhzCq1DBG9YqDQdyn1bfVe	1405	861	128	6301	6358	jxoRQZf2ByhENmDDhbASiyj8tcmYvKGGTCRtMRxijrRVVxUfFEn	5107	7187	7187	1617232860000	canonical
9856	3NKnZY7ZfWAZunc1easwechyB5YqwXdGUar1tc2F55fmSeMHTYFq	9855	3NKg8anUxtu6V69JNR5zoK16CCgAaNWbdFcug1uKmCtC5p5WaZGQ	369	1312	129	6301	6363	jxfP7sm3CNmBHzN4QjrwXi6xyjubyHd4HkrwsNiY476f8CcK4G3	5111	7192	7192	1617233760000	canonical
9869	3NKY1bWny3d21xjeJZJwL4y69qsV6HUDYDoEACWQGyeGS6bPeXyW	9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	1651	1055	129	6301	6375	jxsC7R1hUnPH1wwnaVXeQoAPtgNg7qWmFkZNK22YFiavR5TWxVJ	5118	7202	7202	1617235560000	orphaned
9871	3NKtxUhsYNU3VuUdUPux7vLRpLrFYVCJommMzz7XP9be1RG6WtEP	9870	3NLFL67591a6M2rH6PeuSPDKaDRy2dbHXGTC9mrEsbUawo379p7M	1522	1322	129	6301	6377	jx39nA9pjfFzAWdbQzvXW9N2gg4vL6hTAiHPEjJ94VQg6caPgn1	5120	7204	7204	1617235920000	canonical
9874	3NLKixnh3T7NvEtc9gTL5bKtqMcN7f1wkRnNmzjfyNDjpeBLXUFs	9871	3NKtxUhsYNU3VuUdUPux7vLRpLrFYVCJommMzz7XP9be1RG6WtEP	1444	1381	129	6301	6380	jwyLaBmQiXpvQqBXBRHLX9WL9q4titvVwdreyPUnsnHM75B8Zmg	5121	7205	7205	1617236100000	orphaned
9882	3NLXxdzXq9gvLWkg5biMcuGSM93Y9FTaPvJzARJ1toNBatmBhhpm	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1406	1393	129	6301	6388	jwo6kSgFRmvdNyiRtJSAukLp5y8jHzLE7jte7sJeTKah6n13oXU	5124	7210	7210	1617237000000	canonical
9879	3NLT96y9MEC4kuhkFSB8W46DyXhXJTsAm1xkWab3MFak4dYNi6Zo	9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	1407	1395	129	6301	6385	jw6t7LCZEjM9mWeyqjHHU7eP8EmPQiryVXPXJkwYYZx91ndL9WF	5124	7210	7210	1617237000000	orphaned
9886	3NKaZCQH6hFdZqmeds2UWPSwqZK1koRkgnqPwj6KrxV8iUKu2zK4	9882	3NLXxdzXq9gvLWkg5biMcuGSM93Y9FTaPvJzARJ1toNBatmBhhpm	1652	1315	129	6301	6390	jwwSw3KrJv2w6t4xArPd4snL1Ztj1g6aQHoHWggWZLa7dUUbWSX	5125	7211	7211	1617237180000	orphaned
9890	3NKQeUvd9dsMiyu7DFoqLiZaj8LyvXCo5jTE1nW7MezpsvmKiAaP	9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	1405	905	129	6301	6394	jxztVWQTF71gjuXty7apWDxaViE9gzU2xJzJADH4xfq1Eb4iuFM	5126	7212	7212	1617237360000	canonical
9893	3NKJjZiovFhqaCxa4MpMCipzoS3iNMbLHXiUiR7rrU5H1wgEsWVD	9891	3NKLro9bZfA4dRmtZ89rbPwzMPcfwpB4GBviDayYQm4qKSyJtVsP	1405	875	129	6301	6397	jwDDPHtiP5XHJTBYs4uMStrDvo4utbgqNUGy5jYRy7efHBPo7wd	5128	7215	7215	1617237900000	orphaned
9895	3NLwTxRaNFgfpSugMfoRT8UJZstRZgEdUEP7EE3HvioQfyU5vQNn	9892	3NLXwqaEZPk8wb3uKNUB7dNUQJrncW3gRA85oDK87phqxMqNU1hX	1483	1030	129	6301	6399	jxudVGRRjS79sFDPp2WnZ6ZvDUTFghVwzCPz34ATPuGR1bHDwDV	5129	7217	7217	1617238260000	canonical
9902	3NLc561ouuiqg2C9EfnT2muej8JDGM8f8Mip5Wf53bs5c4Dqjjo3	9901	3NL2bhe5iWPdZv8J19Hc92h7VLvYsKUFZCi6jqf8Q288YutkTqYv	1407	1395	129	6301	6406	jxMn5fqgU7hd29rAo4N1J8VR3Nxq9qkREyn4jnDByqdCtu9Kgtn	5134	7222	7222	1617239160000	canonical
9908	3NKMRFxbTksx6ueHjKxpdWNmgASc3Vx9dCE85rKLyPrhsYAU7HKV	9906	3NLRTys89tvAcBMmmaa8ZcdRd3AEEH5STHcXqXWYPmRrrbcBUws1	1547	1012	129	6301	6412	jwjkjoBXEX7kAMvH1s3umvKUQt3XyheUchTeRygjMvnWFB9ESJD	5138	7227	7227	1617240060000	orphaned
9910	3NKtsECB4MWgsmRSEJjAZ2zGSK4zpwywDDZKZwaqiQ1bSTzjrVC5	9909	3NLWhveK42mynUEMaHLvSuuSYvdkmRPxLZpwYAGaAJf7bBfarz6v	1445	1290	130	6301	6414	jxSLTrkLb7UGCh2HDtS3Zs7NasTd8sg4uGz9BbStmUSazWbY5Qf	5140	7230	7230	1617240600000	canonical
9913	3NKkJdynCHyVtQvAQ6nUjbfQxgdNVeRrHnU2JXUBLURiFBDJqQFJ	9911	3NKMm6kDTeztokSQypvWfuNNrsJRx2Fvur9D5TcRJhTW2uwSr8xe	1406	1393	130	6301	6417	jwCjxM6jTgzbg6st2NsVxn5ApAUCK5K8UtZZPC7Fn3mozUxjoTM	5142	7233	7233	1617241140000	canonical
9916	3NLyHvV9Jk7YUQHYFmJJCzMJGz1fDvkNAyRh1XyVAVv1dEPbkgGY	9915	3NLLzced8fUHD72VNcDeUQnTfye1D5jPzED47qDgRyxnhtU8FetV	1637	816	130	6301	6420	jx5j6Mkb7cX1asDwK46cHpUxG8xpWnpiCe9VNGvzg5gks1LyHFo	5145	7237	7237	1617241860000	canonical
9918	3NLt8QbvqqGV5vAmQrXFJXzQfRgLNWGQarh3ALaacFgiL12HrUEv	9916	3NLyHvV9Jk7YUQHYFmJJCzMJGz1fDvkNAyRh1XyVAVv1dEPbkgGY	1564	1092	130	6301	6422	jxmBn6H3cabfkKDHaSZm78kbsW3csnp1gvjETtpmXpgqpeChnzb	5146	7238	7238	1617242040000	canonical
9919	3NLpBMjhC8Ab1tH6TULipDShRoVvzRLLMMtDEkPjh2cmcG8TdoMr	9918	3NLt8QbvqqGV5vAmQrXFJXzQfRgLNWGQarh3ALaacFgiL12HrUEv	311	1307	130	6301	6423	jwnRH88ENmTm1SDwdJhTbQsBVTkeMu5mddUXTjAgfyDkdxzJQVj	5147	7241	7241	1617242580000	canonical
9924	3NKFJUSp53BReHPNHBPqyEC2wU9wCr9bbNywkYTgrC4cT2sDSwEB	9923	3NLox3kJKRpJBLW8VgLJRRtR8EAu22SNKXdCSgRDof9sX5P8hWuA	1406	1393	130	6301	6427	jxszThjkMXz5C1iusmt96e7d27TYTgCQbpZcQ4Rwa5V4XEYE6Jx	5151	7245	7245	1617243300000	orphaned
9940	3NLTxQ4GkZ6JQdnzV7YRcfDRYR1g3gU21aZAF318oGS9D5uMb1iC	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1406	1393	130	6301	6442	jwkPBcVPvoPToZ5UVtEBY9cwzJyPvxUJ5w2aETCAK3c3cHBwhhn	5159	7254	7254	1617244920000	orphaned
9944	3NLu9M8xPzKFgGD6Hzb4TVKXvD8fgRdKjuBcNvRUCjYFq11MqsKe	9943	3NLwRinnMFSAE6AEdW9SGo7zs31juZrUyXJcW6LXCu2TsT1csN8C	1594	1326	130	6301	6446	jwp7fGKQPdBguiNciWEGscR5kAaaAUcZGRtL7YnADJR8oPeubej	5161	7257	7257	1617245460000	canonical
14178	3NLEr8SkHsrodmMESug3NidQdqVK91hfruykYMEgXwdAP3sUwwSr	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1602	1243	218	6301	10310	jxNtFMzyRxQVyFe8vnAbbXAiA4SUKur7ijuixaktqejcgQVmbTk	7238	10247	10247	1617783660000	orphaned
9959	3NKUR7jdJnhw8hUVvQP9jGNjZjJQqRAv8AAKc96UxKtCTBf6h4KT	9586	3NLjvNp8GbyQLHXZjEnPreyddeRvmk1csDQk8JP8t7wkmob2fUmH	1407	1395	122	6301	6460	jwKVxrzMzVQxGmzT6PwWkH6548tx3hQoJpAAaZbfJqp64tQuPXe	4974	7271	7271	1617248050191	orphaned
9877	3NKBhYK7Txbu1xCSMjBnLh3HTafvan9Nm38uxPiBFWhggNETmAhT	9738	3NKp922oBgYoLudHRBmN5fbwtoga39rNGCVvG7oySxW9hLEoH56X	1642	1367	125	6301	6383	jwvCWimFvrjqFa7UjgT6mNyPf4RM8w4XxJVAJvHEUaNhgJyEyTD	5046	7210	7210	1617237000000	orphaned
9883	3NKfANTNf9VmnQci43sq1hAFGtpk5h7Q3js863Lrmh9cxJxyaXTc	9770	3NLFoCdJymDLpCaTKQ2BWsKdGp49t9TCRLu4z65k58xkNuLmjLg8	1642	1367	126	6301	6386	jwSCANwXs75WiGj2eL5tNERdw1SK2coS1S1EvStvJMrCEcj7cJ6	5063	7210	7210	1617237081379	orphaned
9833	3NKFZK8w9kit3iw6iQB5o4QkYjHQJziTicTsKocdRAuQLhsnz34N	9831	3NLqrvAvhuHQkymkMBBUicFkP3of1QLfeEZ2bo2H15b5E7JwWp3R	470	1309	128	6301	6341	jwVALr5gxPQhtCCcTxD4bjt15zMrxAwzpDmHfxL7eGSC2ZjNVnz	5096	7168	7168	1617229440000	orphaned
9834	3NKmhQYNCDEZdtyGRhpDo2nSL5TXU8mFLncrwThxMoeSjdKP5Lk8	9832	3NLfvJcNq1HH39hEHooeJ8p58GynKgqJNrHfNUQ9m2rgQ17NVXtR	80	1147	128	6301	6342	jxLbH3x3qggPEFddydprPY5TxScv1rA8CBC6EnNEQs27DYr14LY	5097	7174	7174	1617230520000	canonical
9837	3NLrP7DUjXrE67sXjxECuUSbjQhn3WtZtH5mv25tj3iEAEMTakf9	9835	3NLkmsuEPKhTKtpFeBG2PxCPDzikngv528JhSQfGZ1uHXV4pBgpq	1581	778	128	6301	6345	jxBbC2iJqndeRnUHC5Gj2J4bDooMRBhjRDqiNT1kqXnkMJJgXbm	5099	7176	7176	1617230880000	orphaned
9839	3NLLVgjnFJEk45fFEUUxjf2hCfBzCb1aD9e1muUQDSDAyW9sj2gk	9836	3NKCz6zRjejAuarZP7BwV9yLrMvV5gFCRhiNXgjq8L9UFHRfpGHE	1516	1294	128	6301	6347	jxffTjLUwf3wv7WdMTLntgPDKZQMascJ3umdo8oLEhqHF4fccZt	5100	7177	7177	1617231060000	orphaned
9849	3NKq7opTQ6eofJw8RpKbjovYVB9Lbgvbn61mjv7DwDQfzDmZVJqQ	9847	3NLqgiYgGFSjmSK26pXoYNNHbrgDzepnV42U2LgXeERMD4Cua1ya	1481	790	128	6301	6356	jxqVap7NJeecj45pcjrrwF2T9jRDnp38CKkapZytxcLGccdy54J	5105	7184	7184	1617232320000	orphaned
9857	3NL3aSjCt254WmJKVQmN7EtM3EMQ8h21vUmqSRBsqnMDXo7oLYnQ	9856	3NKnZY7ZfWAZunc1easwechyB5YqwXdGUar1tc2F55fmSeMHTYFq	1590	1054	129	6301	6364	jwZ6AZqqLoC1zH5Hxb2fcZRjaYFrbuK6bfh9eM1oxYjpE7Ae7Hw	5112	7193	7193	1617233940000	canonical
9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	9859	3NLRgi6682FbKDUof6hnU94bY3dYEX9EkT7SeFETpkCiLtTbBt52	1406	1393	129	6301	6367	jxGJfLcQVwXFybD6pFNQzre9ffKhJPUrMBe8arxy6PedzAGKuxk	5115	7198	7198	1617234840000	canonical
9863	3NLSf3MfuV4X9QkgHNqod2WBDWsrVVeyvrkXQBYEU79q4Gus2J3S	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	149	1283	129	6301	6370	jwpi2eHrusouLYXDUvGzT9jmgH8GqDxNgCZfjKukwHB8TsaKasu	5116	7199	7199	1617235020000	orphaned
9867	3NLnWTasw8CtP8ebU8WZLT1mm3iZQPDYLyyYmx4AZ4KvKw1j4tPL	9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	1444	1255	129	6301	6374	jxm3gdp3Y417jLnyPKjRsj8Wde6UWhwi5575VsBC7PSgYde2zNP	5118	7202	7202	1617235560000	orphaned
9872	3NLNaahCRk45LHKRSAqVjMeLHM2LE848jqtD9Hyi5SDLQBugcQaC	9870	3NLFL67591a6M2rH6PeuSPDKaDRy2dbHXGTC9mrEsbUawo379p7M	1622	990	129	6301	6378	jwvH2itVsq6nP6mRoETcUYyQ4eT8zVhXZRwv6QzwKbBjqL4Zxp8	5120	7204	7204	1617235920000	orphaned
9888	3NLCzCsVgbE6aPNFTiuRnooW1LtxvpbKxiCCfjZ8RWRCm87c1jb2	9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	1671	1239	129	6301	6392	jwEjE8CHzhbm4HPYJqi9635PLoTywPz2qexywki1CAeNTDnUhnw	5126	7212	7212	1617237360000	orphaned
9898	3NLDfWqrSdLYAia9dmq44z2v6pdimPgiRwcCRq4uYGMDxfvEadqp	9896	3NKFXJVQf56NjRrv7cdYFCPSAVwLr7xumYyG9WbY1Mhi8mdXNbBR	1403	824	129	6301	6402	jwabccPtyPVfGrCVSSpVFVJAMesxd1hyjeMq5PYqtMw3Z78L4kh	5131	7219	7219	1617238620000	canonical
9900	3NLWJmYQJP29vtsPifZUkkjPvs8jVpiCDDG2EgAoBjXDzP46mtJS	9898	3NLDfWqrSdLYAia9dmq44z2v6pdimPgiRwcCRq4uYGMDxfvEadqp	1573	1318	129	6301	6404	jx57aZZLMr3fVVnmv3y5oWXYsjoamtdNiwN8kvf57JJDecyu8XT	5132	7220	7220	1617238800000	canonical
9903	3NLp4J9oocy8hEUuxKUXR45daGDgGdr52Jnf24WKitu3NQqetdxJ	9902	3NLc561ouuiqg2C9EfnT2muej8JDGM8f8Mip5Wf53bs5c4Dqjjo3	1650	1129	129	6301	6407	jwjJgpVKCg5mNvDPZzqPKyMicGPNbuXxWooB7n6YSB2f8dvfQv4	5135	7223	7223	1617239340000	canonical
9911	3NKMm6kDTeztokSQypvWfuNNrsJRx2Fvur9D5TcRJhTW2uwSr8xe	9910	3NKtsECB4MWgsmRSEJjAZ2zGSK4zpwywDDZKZwaqiQ1bSTzjrVC5	1571	1335	130	6301	6415	jxsuHcg4crMKx83xv7mXXN78VqxZWgC5K9ygniEwzJpyvK1UkPz	5141	7232	7232	1617240960000	canonical
9922	3NLZ55iEHv3qaTuDP6RaAzUr8cYEhC6457qcHKJQazeQcipYyz3P	9920	3NKhQe5dAjta9syHrb5svP17x8SDmPHtr58p4X5ptmUqPoLTP3Ea	1646	1354	130	6301	6425	jxxSK4p9Hs9TLzp94cYh2Ti3vzG7dGVvgbhfk2xj8dXH14yjCBj	5149	7243	7243	1617242940000	canonical
9926	3NKHVG1ztPn5pz74Eaq7Y67Rb4WNhQrr8MS9ktpYWJ5DYSPy4XDB	9925	3NK4wiefJojFtNS7G7pTuoQ9Tv49QDyYXWiNd3iDPuguQZvg1aGN	1596	997	130	6301	6429	jwPtSREb5KSn4bBn1wSV94B68zoPTGSSJ8Q9UQFndXeYNAJT3zK	5152	7246	7246	1617243480000	orphaned
9929	3NLxjtyBa8MjzGqrzZZxp5rswsV76ELpppNN5PESG28ZfQobpZSf	9927	3NLY3LbrSsNCUF7b8Rzn2UW4iJxrjbUws5b4KjeoD89A8PnKJFH9	1547	1378	130	6301	6431	jwP2CfZ82Pgf4saqHWe4wjRiafV8GkZif5CCGubbYwLUphFxpVy	5153	7247	7247	1617243660000	orphaned
9931	3NLy7fC1WVrPW9Pc8fEjJprZYnfLRgXtQp7uThcQFqfUc9Mq4qQr	9930	3NLD15HiLbnX19eXQcz2fCg3FLANfPqNpfGuEhkWsjH5RseMpEuk	1529	1316	130	6301	6433	jwwCRSpNGANdmggA8gvALifLFm2joJPb6VrWTFACEzfbU9ScaEY	5155	7249	7249	1617244020000	canonical
9932	3NKKXfR79hiX5Ku2gTkqazG9CtCofE9KCKQRXQ6jFdzrWjZzEydH	9930	3NLD15HiLbnX19eXQcz2fCg3FLANfPqNpfGuEhkWsjH5RseMpEuk	1647	936	130	6301	6434	jxieKd44EDa39i2JF9PYnv9Qvzg3ybwiXEufVERRAgkPQoAxdUB	5155	7249	7249	1617244020000	orphaned
9934	3NKfB2VzJivsRTWJgnhtvQ1aMGrcgXaqbJN8vzJHNQwF95WfVzBx	9931	3NLy7fC1WVrPW9Pc8fEjJprZYnfLRgXtQp7uThcQFqfUc9Mq4qQr	1406	1393	130	6301	6436	jwA4CCtxdLGfLzDwuGxVNHLMWSeoGsKfzd3CvURXJTS5JSaDei7	5156	7251	7251	1617244380000	orphaned
9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	9935	3NKW4HqQqTSd4RiXhdCWZViBy44sM7bwzXvXFoYPwn66vJ4YLV5r	1546	1339	130	6301	6439	jxSTmMjh9QyhGLHehrboYXw6NQ3RnrZnsdxeZkkEt9gt9P2WrAq	5158	7253	7253	1617244740000	canonical
9939	3NLruTZ3TGSjFjJs3P5EPbGKZxjpvuaDtdTz1Vmgi8CTDicgnKTs	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1673	1368	130	6301	6441	jxkv3w8sN7yfajRExrw9PLLzMyjbzfemFJ2cXtXFkzrt9HU8x1c	5159	7254	7254	1617244920000	orphaned
9943	3NLwRinnMFSAE6AEdW9SGo7zs31juZrUyXJcW6LXCu2TsT1csN8C	9942	3NKQG6FvMsChNGaCaTbtLbvK4Fchm8seMDEVjZaBm5rhBnMquVZR	1590	1300	130	6301	6445	jwAh9RvRZiNp7RsMi1cWDHbuYR53Da1HXp8KGg8KFL4NasTeHB9	5160	7256	7256	1617245280000	canonical
9950	3NLizu8XgfP6xZFSbrMxrqnYGrPVA93RUc6zWB1aTTdLa3cXm5dB	9949	3NKsEWCWNxNPvGA6Z23FtsQe8ZABMdJ5iqwXqWCwAM2MyCmw4iNC	1633	1390	131	6301	6452	jxjVUci4UNBZgDWSjTFscDWc2Ez8xkTzirzoeSVsuZqErY416Dc	5166	7266	7266	1617247080000	canonical
9952	3NKn2VGzPriFWoaZWqxG6Lv5byfsQiUd1RgT17EoUtMAR1WmESpK	9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	1619	454	131	6301	6454	jxq7P6MWTM37ewiTVeJ7FwzDZZDrQCqDrQfFNvyGqsqoXUqKzgi	5168	7268	7268	1617247440000	orphaned
14182	3NKzuBh9AsrR5Rimwdn89B7d4yZX836wQctgBG13JQ74q1txy9KQ	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	42	1361	218	6301	10313	jxvbYmeMgJYuUUnjFL1QAhNV9SZkAWPB3TCyiKMn82gXqZBJ7ji	7238	10247	10247	1617783660000	orphaned
9853	3NKVkwCJjrPu8BcH26nf248KBqCh1sPyKTArEpbr7rovyp6JgWQq	9851	3NKqeof6HkoxbhAYWHFEb9sZWVdWsZf2MheWCh5TsQoWoaTuys1J	1536	1187	128	6301	6360	jxFDwFbFqbqTsMvsEvRq9uNe2hZoFm64bNw8eP4PbwSPptM7Wye	5108	7188	7188	1617233040000	orphaned
9859	3NLRgi6682FbKDUof6hnU94bY3dYEX9EkT7SeFETpkCiLtTbBt52	9858	3NKbL5wHphSTPvTqAgYbxEcy8SRGDd2NsXA8dz7kbSjZ3KibLgQY	1652	1189	129	6301	6366	jwMnb3yuu4d1eP6MR9NuygujkShs5Q3Z4bMLqFTsbPeGqodKShr	5114	7197	7197	1617234660000	canonical
9862	3NKpFit4tjWC6LxsyYtGWm9xftRVY4q3zqVa9FCYYoNs7fhBKhyE	9860	3NLUQcEconxvvF8A4u8CcW8zfFSxKoR3mrbKpBFHkrTdyRiypWj2	1654	1340	129	6301	6369	jwfimqwxokj3HCbEzsY6PP7K6DRr3RbU5iT54p4HyNeJ5mJEQnp	5116	7199	7199	1617235020000	orphaned
9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	9864	3NKoY6fmJQuZV9q4tHTZpDc6B8sSYfqA4Dp6gLueMajaaHfSN5RB	1406	1393	129	6301	6373	jwSnkqnBwHiqEQJ23mxiJnDbs3K9iyJWpBmfRD4WpkGvmnXjY9H	5117	7200	7200	1617235200000	canonical
9868	3NK8NEPiHXz3cRSwdKEJegXzh9VevcACX8VG8bXRetQUBQB1XbbD	9866	3NKaKJnhSniKVqvSU5GWQX23ZbuXbGPvsRw7o4muHLTziyeRUyCo	1651	1055	129	6301	6375	jxowzH6GJxz24d1U4wnPxCkF5KzVMxc7YwYGZLrtWDVKPj4TkNj	5118	7202	7202	1617235560000	canonical
9873	3NLKP5KHLBgWdKMDy1CwkqZDvr8h1BTg6DYaRT4QgXD5M3d5F3ih	9871	3NKtxUhsYNU3VuUdUPux7vLRpLrFYVCJommMzz7XP9be1RG6WtEP	1599	1041	129	6301	6379	jxh8kM8bWYn4wV2zcBKKB6aTHeuiTSXA2P7qfjjG7K7AmEWtQtD	5121	7205	7205	1617236100000	canonical
9875	3NKgXg5P2Uo9uDJ6KissF51rA5MmJbXsUszEdNMcc96P5tTE9i9T	9873	3NLKP5KHLBgWdKMDy1CwkqZDvr8h1BTg6DYaRT4QgXD5M3d5F3ih	1406	1393	129	6301	6381	jxsvQ3RogbjDRwVsPUko6p5xGV8vqzkanrBhvcQC4EKfu8Bh3hQ	5122	7206	7206	1617236280000	canonical
9876	3NL3H4ZrhdL4Tz7Yc1nyrg7fADqCr1JLMQPiDW5rEpBzZ57exhaG	9875	3NKgXg5P2Uo9uDJ6KissF51rA5MmJbXsUszEdNMcc96P5tTE9i9T	1406	1393	129	6301	6382	jwJXSgLH7znNYAqLrjU3h6B6HzA3Twa7JWRF99pPfTgHrZXLNyY	5123	7209	7209	1617236820000	canonical
9885	3NKh5k54hRqBCh3qSDjtRVwZwFvvfYX2gNG5aumwWEQL5MUXqEd7	9882	3NLXxdzXq9gvLWkg5biMcuGSM93Y9FTaPvJzARJ1toNBatmBhhpm	1407	1395	129	6301	6389	jwwmdgXkQat5GNtFeBoYsWNy9FVaaJ69an7e8NozkiVZPqEaPXC	5125	7211	7211	1617237180000	canonical
9887	3NL9bk9ekxZYmdbvLgZV5nnpucS6TcYpVCEfRspGyCxxkCJC8ejk	9879	3NLT96y9MEC4kuhkFSB8W46DyXhXJTsAm1xkWab3MFak4dYNi6Zo	1652	1315	129	6301	6391	jxTjHvKB8yNPqWoFNaEBg1mPPfBG8sRmk2DBoyvszLzM7yMMd2E	5125	7211	7211	1617237180000	orphaned
9894	3NLUtaco578SxKNJiL9Sms1Vr44QuHttSgxEKDHHdU3pZfGb5UUu	9889	3NKLZP6U3zNybPsv69QFPEpFGEg8yRqG8yWvBBHmsgMiZZgniQKd	1637	816	129	6301	6398	jx4NNn4BR3u1nRtQBvrMWL4qrr91Gnnx9YRbj6PAa3pEnPEhMGZ	5127	7215	7215	1617237900000	orphaned
9892	3NLXwqaEZPk8wb3uKNUB7dNUQJrncW3gRA85oDK87phqxMqNU1hX	9891	3NKLro9bZfA4dRmtZ89rbPwzMPcfwpB4GBviDayYQm4qKSyJtVsP	1403	824	129	6301	6396	jwCDjzJvhdkcNuTAvDY4Ra4ynfZSpt5BJ7YvUxx7UCNaYpfDHLZ	5128	7215	7215	1617237900000	canonical
9897	3NKMss5rsKoF5yWCKZiBJe5C3ktQ5aTwypWBzTKxpoMrr2QCEzh6	9895	3NLwTxRaNFgfpSugMfoRT8UJZstRZgEdUEP7EE3HvioQfyU5vQNn	1672	919	129	6301	6401	jxrXStAPhaHko3MLPMzrJoqpRzjQPrNbgBpDWR9pNEzqRpjokez	5130	7218	7218	1617238440000	orphaned
9899	3NLN135PHWJwQXx6Gm7rmVJFHndafC1Th1P3aCHhqG3tnvBKSZbf	9898	3NLDfWqrSdLYAia9dmq44z2v6pdimPgiRwcCRq4uYGMDxfvEadqp	1406	1393	129	6301	6403	jwgtXECgodJtX1uPV1WYvoTd8R9BpZPeNBDo9uYeu4sYLWPDsNj	5132	7220	7220	1617238800000	orphaned
9905	3NL7Rrg5kyrosG45Brmwr76DzdKt4w1DT8sD5kMCD3twjtpJ6b6R	9902	3NLc561ouuiqg2C9EfnT2muej8JDGM8f8Mip5Wf53bs5c4Dqjjo3	1657	1344	129	6301	6409	jwMuxiLGk3w7qDeSNMv9pnAwgX8z35KinYiK44Q5C18FaY5JM9j	5135	7224	7224	1617239520000	orphaned
9907	3NLAmp7MmfhhFK223oma2U7CKRGG5fpY2jQW7N14U32GHg5LRksP	9906	3NLRTys89tvAcBMmmaa8ZcdRd3AEEH5STHcXqXWYPmRrrbcBUws1	633	1258	129	6301	6411	jxfAt6W91RfEQZWbRQdDZk2fXzcxSniKq7aihfgz1rwzXCwm9Wg	5138	7227	7227	1617240060000	canonical
9915	3NLLzced8fUHD72VNcDeUQnTfye1D5jPzED47qDgRyxnhtU8FetV	9914	3NLKgozbnph5jUfbz2f3aK2psfJ39J3YcCPvk4JaCXQQ3PZ6PRKy	1547	1012	130	6301	6419	jwme7SQiZzRmZQMUJqEgLr7KdmFFH3Zh4vT62AyLd4e4nf4fg8Y	5144	7236	7236	1617241680000	canonical
9921	3NKTyF9a6cSvSmK1CnA242csbK2c4ZBG88ePun2UsCGaNugsYgSN	9920	3NKhQe5dAjta9syHrb5svP17x8SDmPHtr58p4X5ptmUqPoLTP3Ea	1646	1354	130	6301	6425	jwmQ4kc3QqiHCJNTVwttfc2DYytaTNy99hHWnyeFJRH4jQrtqSN	5149	7243	7243	1617242940000	orphaned
9923	3NLox3kJKRpJBLW8VgLJRRtR8EAu22SNKXdCSgRDof9sX5P8hWuA	9922	3NLZ55iEHv3qaTuDP6RaAzUr8cYEhC6457qcHKJQazeQcipYyz3P	1407	1395	130	6301	6426	jwGQ4Aa7bLgb8KdbSN6BDL1kvowqJmpN4TdThT6C76xcn15YbXm	5150	7244	7244	1617243120000	canonical
9928	3NLXDkV4vEA9DC57wBvj7db8PZ8WiXoFok2SxN5aDHnUXEVufURf	9927	3NLY3LbrSsNCUF7b8Rzn2UW4iJxrjbUws5b4KjeoD89A8PnKJFH9	1547	1378	130	6301	6431	jwkF7WE3SCMugSshfTkUJdz1oCmdG6hqn4qC2EbALnGbt1XQq6t	5153	7247	7247	1617243660000	canonical
9930	3NLD15HiLbnX19eXQcz2fCg3FLANfPqNpfGuEhkWsjH5RseMpEuk	9928	3NLXDkV4vEA9DC57wBvj7db8PZ8WiXoFok2SxN5aDHnUXEVufURf	1440	1131	130	6301	6432	jwuDC6keaceskG7ShuiymCNqDC79MXCcmqrCxzEH1TwSu27MqZp	5154	7248	7248	1617243840000	canonical
9975	3NL89UcHGoJGzNYxmWGPv1r1zokJyjRvPbAZ5TkSw3hJyisBJwrt	9928	3NLXDkV4vEA9DC57wBvj7db8PZ8WiXoFok2SxN5aDHnUXEVufURf	1407	1395	130	6301	6475	jx6184KSHYr5vEtipma6pSb59PgRbMFRGGh1dtqYZHxKcUMrjdX	5154	7276	7276	1617248880000	orphaned
9933	3NKGphyZBzjKeaFm8RvMj7eN3rM9rcuBd3ZyjcL17R6gqca1KeWx	9931	3NLy7fC1WVrPW9Pc8fEjJprZYnfLRgXtQp7uThcQFqfUc9Mq4qQr	1403	824	130	6301	6435	jxLkaxPt99cjNn6phUTF96KUU5XSTQjUhv2cAjrGP3isBmMGTdD	5156	7251	7251	1617244380000	canonical
9935	3NKW4HqQqTSd4RiXhdCWZViBy44sM7bwzXvXFoYPwn66vJ4YLV5r	9933	3NKGphyZBzjKeaFm8RvMj7eN3rM9rcuBd3ZyjcL17R6gqca1KeWx	1483	894	130	6301	6437	jwetXZeRh25ATfHJtV1CpK1SHiduWpNp3aPhJdHocze3yTcv92x	5157	7252	7252	1617244560000	canonical
9945	3NKV5c3hxpmNk2jpgFds9eNPivvtatLLPJopppax9cpvsid7FNDD	9944	3NLu9M8xPzKFgGD6Hzb4TVKXvD8fgRdKjuBcNvRUCjYFq11MqsKe	1581	778	130	6301	6447	jxcqNJq6wQjmycBDKVtUxuk64ZeszrMVYm4TsmfjwZLeuyvUiBi	5162	7258	7258	1617245640000	canonical
9946	3NLYQ7NorWtB5tgocjoAwXztsXZpjyzbyts1vkkeSxSgaDurdxJx	9945	3NKV5c3hxpmNk2jpgFds9eNPivvtatLLPJopppax9cpvsid7FNDD	1549	1362	130	6301	6448	jw6sZE7fNYJ23BvcKc5eJEqk9ZnpcD6jggYryCR3sXJ1T5UyhJk	5163	7263	7263	1617246540000	canonical
9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	9950	3NLizu8XgfP6xZFSbrMxrqnYGrPVA93RUc6zWB1aTTdLa3cXm5dB	1397	828	131	6301	6453	jxaVqZSTb14ZnrBohwq6w4J4pQ8XSsgnZ1sFXJeRbQRkMHzeVQG	5167	7267	7267	1617247260000	canonical
9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1593	1346	131	6301	6466	jxWTUyLjtUVKcXBTra9Ygo75jQp8uw1iXRKDqpqxsceZobWDdjF	5171	7274	7274	1617248520000	canonical
9970	3NKKqyj5KMtsc9cgquEGaxLU8dLtrGZistjYyo9SPepRYEieYppD	9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	1508	1141	131	6301	6470	jx8J2FEr5K1e3zBVvxmLCej9aeqDXvvAqF9xd8m2bvm8JavAA6m	5172	7275	7275	1617248700000	orphaned
14560	3NKYq94XTtsqmfcS98fNJdia3iXQqdChqdhHE6scLudTXVK2D6un	14519	3NKEPzSMw7ZKRkdRrhiD5JzU2mF9v2HwoHoFDRBDxJ1sPGpv3KfQ	1549	996	219	6301	10655	jx3B1bFVSorGF2oRJ44ep5JPUJYWP5Kvqc7v92sgTPsbBb8wAsF	7241	10515	10515	1617831900000	orphaned
9963	3NKDEsVTWJfrig6L4R2EDstxxeBEiZL23Gk5fUEozo9VAz1NUkhR	9962	3NKMUg5Z6k9LiPq9qwCpFzkM3dyJdy5eLbqXq5p1WJcwdjStAEbD	1407	1395	123	6301	6463	jxmoKtTgd8dQGsYyFbpUdPZVTcYX69FJESgpXYeJUVVeLW88Z8S	4995	7272	7272	1617248160000	orphaned
9936	3NKC3CYzJgmYzUSwxcZZm9j9vemjdbWWSeUQJ2F6mSwst7Uz9wFz	9935	3NKW4HqQqTSd4RiXhdCWZViBy44sM7bwzXvXFoYPwn66vJ4YLV5r	1670	1282	130	6301	6438	jxcDU6t9mgxLwt1ntkdpXhobBNsyZDAGJRKBR4vuGzbN3qdm1gy	5158	7253	7253	1617244740000	orphaned
9942	3NKQG6FvMsChNGaCaTbtLbvK4Fchm8seMDEVjZaBm5rhBnMquVZR	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1633	1264	130	6301	6444	jwnKjukPXFf814XJwTfQxUFUjVzDt3uMv2eRg19w5TQGYiW82vk	5159	7254	7254	1617244920000	canonical
9938	3NLvcjUuWJXpvkJurdeB4yACoBPjSw1kRKpqktR8iBUEjGW9GEid	9937	3NKtpn4Hpo7uPQ2DqsqmYQgKvYYpt2eWxBu4nM1gHb1VbwSHyT1a	1564	1338	130	6301	6440	jxPVCfAfzp3hKdi2k22xsmg4CShLTusmbh5wRn3WzDCwixuaSDb	5159	7254	7254	1617244920000	orphaned
9974	3NKoxjpFUC4MZug2phNPeZuJBU6Nc3pmoBLViZ1BBGrhEazaQy2M	9945	3NKV5c3hxpmNk2jpgFds9eNPivvtatLLPJopppax9cpvsid7FNDD	1407	1395	130	6301	6474	jwAQP5FJoJ2RkVW7vi9hQ6GM3jZ1hCoLMSVD3N1daWrHvdgUU4q	5163	7276	7276	1617248918530	orphaned
9947	3NKRZ5umTPRCKoFVDHLb9xeiGbMXPGNwnMrcnYt4YL4qSJLR5rCz	9946	3NLYQ7NorWtB5tgocjoAwXztsXZpjyzbyts1vkkeSxSgaDurdxJx	1600	410	131	6301	6449	jxPyMnML7mYZ9UxzbDWTfk7pgEiNDVD2axt8VwcQTGJzxEM2zHv	5164	7264	7264	1617246720000	orphaned
9949	3NKsEWCWNxNPvGA6Z23FtsQe8ZABMdJ5iqwXqWCwAM2MyCmw4iNC	9948	3NKwVT9vh7tKvZPCV8hCTYe2hbDoqouKp2AoTCYxpY9gXCNuj5mN	1553	775	131	6301	6451	jwNWci1xX1xdJxB44PaJZWtisQCMV1jQdu3JV3iigNJvXN93uGL	5165	7265	7265	1617246900000	canonical
9954	3NLVjsQZhxQ6TgHPx6dnJvCJTbA2UWSY437LhCjwAfsGtY9VLkYM	9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	121	121	131	6301	6456	jxVVKDhepNrRQPL25osKBc4w44tZU8oMzv6QcKZaiS2WCi9Zh1R	5168	7268	7268	1617247440000	orphaned
9956	3NKG5SZmvhvdwpJeR4QDAtjCuVP1YxNbi4o3A9jbDS8mKF53gpNM	9953	3NKeYs65JZoBCHnYHjAf9H2mFqa3YSQPyrkAEZiqTJeaASUxvPtQ	1623	830	131	6301	6458	jwri1ufteEMrtDAsXasUPYtfzixoXaMw13iTSxqubiz21DKSd7w	5169	7270	7270	1617247800000	orphaned
9967	3NKHcnDAt19C9mbaorMAH4jYR4kPEVxWcdzL89tHvLxFP5okpVo1	9955	3NKoei6KBvyejQT2s52ureKRnhyPWmxRc1gAPNPXwNFokLPRLkov	1593	1346	131	6301	6467	jxs4o7YfHZD9AwYdP9eCgXfMyDuroeRBk8vQ7gvWtEhAxeGmwgi	5170	7274	7274	1617248520000	orphaned
9965	3NKHSaug7HSPmRymvcqy2dxE1FFd9XjU4BAQ83p5L4aA3Jy2zw7T	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1406	1393	131	6301	6465	jxXoVyY2RsBtbjEw1ernYqrMm4WihzpLFLkGby4QGYPdMSJfTbq	5171	7274	7274	1617248520000	orphaned
9972	3NLaPbJ8b6mKeN9DeeU4XSNEAAnwh6JT2xHGK372i16YiiR95sCY	9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	700	832	131	6301	6472	jwrAkjgyEVp5xrXgoqryTNqSMwi96e1qC2Ckjt4yMMhzz4j8TSm	5172	7275	7275	1617248700000	canonical
9996	3NKx8sTVH5qse7JwxjDocmqW3Hzu2eceiFX9pQxCZJXLhoW36my5	9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	1490	1028	131	6301	6494	jwAAjL5VcqYSi5C3kdinDyBvxMstYPSoxq2EWeBM22H41MdRkz2	5175	7291	7291	1617251580000	orphaned
9982	3NL62XypAJyhU1mok3JH3rJFi1x5eB2sJCiDrDnYTCtvmuSRHRwD	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1523	1321	131	6301	6480	jwpRNNeB6HAm4wQAWMh25CDC3tSEsGc8CTezatbK3yQhPDVj4HE	5176	7281	7281	1617249780000	canonical
9986	3NL7waZyFEPi8sDo7rAvjcLn3KsMVaxSK55HsmyJi2USLhegrdY2	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1534	1191	131	6301	6484	jwHaJ824BXe9w4WuZkRVG4tnQFKPkRwA1xgVPymjhZbkt9Qx4ys	5178	7285	7285	1617250500000	orphaned
9990	3NKCfrDW46LNnag9DneuQvgJDJif9bU4iWutwBPfcSXbUrW5aAuJ	9989	3NLSW94EjXQSFfDRhWRVZkxmJBEN8YibxtHMTWDm8geC4KADvUmY	448	1305	131	6301	6488	jxGCr2rC6NEiNq7W5tcgbXnTRZVZA4NTM3U6qEhJMb6NQP45zNn	5179	7286	7286	1617250680000	canonical
9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	9992	3NKxTX88ztW4w4W1TvX7bG5CCnVbZd5nxJ7n9ePdy1iK1VfSWd5s	1654	1094	131	6301	6491	jxxfDgWdmshcHr5zYCT4HuihhRkGTth9Gi8ui9y1YW1d3yaydvG	5182	7290	7290	1617251400000	canonical
10001	3NLP7BhbvwCYfwfKZHz2bJBBbnrNEivym6fYrG1GZZwjhRhzYETd	9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	564	564	131	6301	6499	jxPiaBf1rtkAku7BqNvJFPBQsA4qX4APAWvVnvNaE4mFS7MtLEp	5184	7292	7292	1617251760000	canonical
10013	3NLBFKgb5pqE4GxwyXuPmGR1cAAa7AgMN5NefgRNNKZ6Vdkus5gj	10010	3NKAdaEteVnzB3CNj4vEj9xBZhJJFWMo6jjVxfRwSMgYFtNnmKjC	1406	1393	132	6301	6510	jxoUStEneMfZnvS4GxGKcsc7qt97U8XkjZqqMvVk852qYnLiDem	5191	7302	7302	1617253560000	canonical
10016	3NL74qXuohKr4cu3YTr59zLDxU2s1kmCHjoHBjbfJs8NNq8Lmi8R	10015	3NKtRPNomt3haQcDpKGCt3ox8zDk5WxZty2BJXBWeHyYo5KrvBC9	1406	1393	132	6301	6513	jwZkyeW96SCmV9veqCQUYgHcoqnNXa2wGbqb4bozKNFNrp7vUy4	5194	7307	7307	1617254460000	canonical
10023	3NLJbaupDLgfUd9zrsXeHfrmZJXW2jC4zmUvj4GJYa5edv8LhfPD	10021	3NKXi2Bq2hFvKxqmfQFZiH65ybNWAXhkW6y7s7zhXa4LW7H6sywo	1447	1345	132	6301	6520	jwxa1nw8xPXi6hJfQru2FxQPhMeo4i1iunRBHgQ5ww5ktgBhSmg	5197	7312	7312	1617255360000	canonical
10026	3NKbKmb7ZSCsGGGe8niTSHeiY8teyLpSEw3WqEd47Tuc8NjqWbUv	10025	3NL6mvhJHe1ft7Gx4rvY3nSuDNdU1iJ1kgXqyoM8MtEsrpooe9X5	1619	454	132	6301	6523	jxstwb7Sq8P4fdQjL81TyK17ebfnpExpQWnQdvZg7SfaZgpmqGj	5200	7315	7315	1617255900000	canonical
10029	3NKEVqxUimSRdx1yyjhgaZfvjTuNcueSqFAtAzQAfgMwp19SEgHB	10028	3NLTqnyMMWUo5G5dxPRSF1hotKGor1HqkLtCavUL1KBi7q2YB5RT	149	1283	132	6301	6526	jwKyN9wDpJJoiFUC4AheGDpbfvpQCKQwfSQLY4hEu23nDPyuhH8	5203	7320	7320	1617256800000	canonical
10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	10030	3NKWBfLerUX6HAomdJmeV4guUySnSisBP8jHL9i1sLuWvZXQsMoT	1508	1387	132	6301	6529	jxj3NJnVN3GPU9TwqvCycFFVf6NmTCgBPMxV9nP2NuuvvdPXBbN	5205	7323	7323	1617257340000	canonical
10037	3NKGBMgA4KLN8BmuB1ktcCAc7dPoM199uuwLk9gEGMLar9EF6YUK	10035	3NKvTtwqZd6W7hscaWb6TQomrWYA5JQjfNe1M7uYb2ZfUrq3tDnU	1654	1094	133	6301	6533	jx14wuN5Mb4c2GRv8y9qiMJxqfpGpqEUhpA6GgEYTst79v5NeYh	5207	7325	7325	1617257700000	orphaned
10039	3NKzTZhVMaRv8NLCYSdjyom3GrxGVJTaxBgox468Rc6Nom2ktKAj	10036	3NLA9bFHptK5MreZzkWkW652bXUM4B3GB8tspq5ALCkQX13idfmo	1609	1087	133	6301	6534	jwUTZsSwvWoTnn6zMYAA83qBSwvbKtfn2NFtuYEAZsJeQxA12yx	5208	7328	7328	1617258240000	canonical
10042	3NK6rCPN1Z27Wq9hertVkvypWNKgNyDW5r5amqFLyCRWUqztAS1e	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	1439	1279	133	6301	6537	jwijJzu4pvGQe3tvvaRSBX3MyGcmKfBDHio9wcViSrN5LVa3o52	5210	7330	7330	1617258600000	orphaned
10044	3NLRz7NFHSpxhmsB7ACuS5LDxnWy6P8qvimhAbhDXXoyhZMkAsqQ	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	1581	778	133	6301	6539	jxoBzPAGs6d2WpKUhtYDniTNvmAdGreyzR5Bwv8csH8gGrkFumb	5210	7330	7330	1617258600000	orphaned
10046	3NLWWraawfMitAZvhJXAAkDkjmriTPmPesTqXqqV2Ja6pbQqKZs1	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1560	1045	133	6301	6541	jwDZG9b69CPAYG4dfKVP7dnazwkEYVmW5fjiCw47yNfwQDhnZBn	5211	7331	7331	1617258780000	orphaned
14488	3NLEhTXfeLno4gLQmRihePtzdjk9P6Fq7ziLnkurezk1RFfAAfms	14220	3NLM1DDeY3i1PmVYXDYQFSvR8ZgHaGHDvDKWTuaFiCPXh3QyKzxi	1623	830	219	6301	10593	jwwLyb87HhobSiE1rjjGZ6kFDGTGJKUGmeSUZpiLqCQgqiUCyh4	7252	10458	10458	1617821640000	orphaned
10031	3NKWR7bDArZ413rjsCu9u1wWDnNdeZEGdNkfimJyt5fKs51pBPGo	9969	3NLq7em2KBpik5sLp2pLqCxrJec9btkNRtxB6Jz5MfCbYMHSrGhD	1508	1387	127	6301	6528	jxdCoRncgUcYQEsTB7az1VsUEwy7J5QAAvMSWy4r4hbUHod4fpP	5080	7323	7323	1617257340000	orphaned
9964	3NKjKznE1QvrzFidvhbLQYv59LSwQ8MWGNZnkCrgvrXqqLS75Luw	9950	3NLizu8XgfP6xZFSbrMxrqnYGrPVA93RUc6zWB1aTTdLa3cXm5dB	1637	816	131	6301	6464	jxjKsg5wH6A8pj7U5iC9NAc9L5Tg63VLtfieHjV1aTyBJ5ka98F	5167	7273	7273	1617248340000	orphaned
9953	3NKeYs65JZoBCHnYHjAf9H2mFqa3YSQPyrkAEZiqTJeaASUxvPtQ	9951	3NLeL9pFBREJXxoEU7artS3xn9ti6CQvRH5HJzXZjQ2RVLaVjSKY	1584	208	131	6301	6455	jwFsSooYfh6fm6fZV1xcKu6iz498bxf74WrZMANG1wcfFm9vCqE	5168	7268	7268	1617247440000	canonical
9985	3NLaxehn224SzB8pWMFLXPoMF3cov15ZmkCj6oM3DzPru3DLDr87	9964	3NKjKznE1QvrzFidvhbLQYv59LSwQ8MWGNZnkCrgvrXqqLS75Luw	1637	815	131	6301	6483	jw7N6pVArX7weUiZzwApxFvsKAy8jy1Kv4Ufhh2dFuxPWN3kqRX	5168	7283	7283	1617250140000	orphaned
9955	3NKoei6KBvyejQT2s52ureKRnhyPWmxRc1gAPNPXwNFokLPRLkov	9953	3NKeYs65JZoBCHnYHjAf9H2mFqa3YSQPyrkAEZiqTJeaASUxvPtQ	1577	1327	131	6301	6457	jwnvL7vGkGQkTacCxWe443s2tAZqD7PntXPUyGPgKJeG2gxoSH1	5169	7270	7270	1617247800000	canonical
10019	3NLrFnjhiDQ8n4GhW5y1UCqFy4ZvjbYoDK9K9xD99tJwYapSJYPR	9985	3NLaxehn224SzB8pWMFLXPoMF3cov15ZmkCj6oM3DzPru3DLDr87	1637	816	131	6301	6516	jwFjTnSNAnd6FpzqX67aCfoLht8yk5ZkoUzFVfxBKYXUa6RL1No	5169	7308	7308	1617254640000	orphaned
9968	3NLLysH3sXhCzT3adv27SbLXZvCD97XTbxqsNHNgjaXDz2m1eFUj	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1590	1300	131	6301	6468	jxxRuxGdxT7wnQAHZrbNkamUQhPSzWFSinnft3Z15V6tF8S1uvT	5171	7274	7274	1617248520000	orphaned
9971	3NLWSKgrtbWHS8ZLEra4cFU8fy6RRnZipPJLapH2an2SUEGU1i5e	9966	3NKpQx6jvJk22fkjDZHuyEuMyv9PELhDq7fGF2ZnsiQqX6WGLYi3	1406	1393	131	6301	6471	jxCannmsVoLeYVx7dHFLWmSbMW3dGPjyK32Vsay2QBo2Emeq2W3	5172	7275	7275	1617248700000	orphaned
9980	3NLtUL8mZgytyMjufm1sjBMpxQNUs4ZrUE7J2nyX9Cy1padhPGdd	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1523	1321	131	6301	6480	jwBNaVeJqjxobYfDwVM4XrjaT29MjC3QK2h1cRSjS2PUqbxo6Jf	5176	7281	7281	1617249780000	orphaned
9989	3NLSW94EjXQSFfDRhWRVZkxmJBEN8YibxtHMTWDm8geC4KADvUmY	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1581	778	131	6301	6487	jxxywcAH96osNMecXAJX6nPrsVU2Qto5gVwaK9jZYsHxxK3xzNc	5178	7285	7285	1617250500000	canonical
9997	3NKb5UZ2KM9TrcZR8w19HwnvG2mSk2shqaC4BJsHGKDhyJfxcJPk	9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	1617	1042	131	6301	6495	jxv7sBrLAkTV8pFmLJyS2nUNcYEeQo2YWafdpQA6TPyKV1Zzi5f	5183	7291	7291	1617251580000	orphaned
9999	3NLSK7xnyGC9sTMnxrUrbkzvdhRNzwkhjjqC4dhi1ZJJhPDsfu3L	9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	1649	1383	131	6301	6497	jwgZv9kxFx9x8P9LYKFqWMnbUnkd7V1CxSvFxLfcr6Jypx2Ujk8	5184	7292	7292	1617251760000	orphaned
10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	10002	3NKhaafr79XQ8Yjg4MMfCSx6RaX9cBv1nt7NKwhZxB1wpP453Qbi	596	1306	131	6301	6502	jx5TGHau85e37EW3woBxa7qGxFuYrsnhBnrsHaAFPCqzn8jVwGn	5186	7294	7294	1617252120000	canonical
10009	3NKsEUBYYLCaQCiNsLFYQzNQ1KAUPJcqrDNES1xLpahjLnm2Vesa	10008	3NLSNr7w6yHYqFcdcDexph1jfRNpuz1vY5gp186hFXV1XsVFhd8Q	1407	1395	132	6301	6506	jxSenFEq5mxWEcohRm63cGoBks4axrthDEEjx5gieZ6GZhCcv6m	5189	7299	7299	1617253020000	canonical
10014	3NLgkkMTDzrcW66a7YUD9twMcwWSDUPX6K6kXYDGqT5Hk3D277M1	10013	3NLBFKgb5pqE4GxwyXuPmGR1cAAa7AgMN5NefgRNNKZ6Vdkus5gj	1481	790	132	6301	6511	jy3KVi7JhJo99cjkdaTwSoz2Hp2oFjjHQkT2gL3ZSfL2RGo3Dyy	5192	7303	7303	1617253740000	canonical
10017	3NKpLC6ERcP2eBKZVnWLZdSofGZrTAaGym4batQgTGxNZBkZQTwa	10016	3NL74qXuohKr4cu3YTr59zLDxU2s1kmCHjoHBjbfJs8NNq8Lmi8R	1599	1287	132	6301	6514	jwofwqTDn29FBgh1QM38QHb7cYy1wCyhksi8BMLyoVCqpjKApid	5195	7308	7308	1617254640000	canonical
10022	3NK9eR8H2MCwYkaDkKGwHiCriWqogNdrPGoSsia8tv5MdCxUX6Ww	10021	3NKXi2Bq2hFvKxqmfQFZiH65ybNWAXhkW6y7s7zhXa4LW7H6sywo	1407	1395	132	6301	6519	jw88yQ9tdN3fYCBZqMcPtBboWqhCsHJvqmxtW2pYGmXCYu9g3Q2	5197	7312	7312	1617255360000	orphaned
10027	3NLAJb7wHPHKL55FQzYEdS8ycwooL9FEYFUZicHsCvmkizVGo7Gb	10026	3NKbKmb7ZSCsGGGe8niTSHeiY8teyLpSEw3WqEd47Tuc8NjqWbUv	1407	1395	132	6301	6524	jxMAALq62tsbd39MNw56qT36xVpxHChZ6WB9uRiDmAARXeiNCYu	5201	7316	7316	1617256080000	canonical
10033	3NL4nM5PtYHWVujuEkc4fDAYpzNzq9bPvKHMM7jSnK1Nmss6uA8w	10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	1675	1216	132	6301	6530	jwYdCRYsH89H2Tw3WPxPcgoKBu9mzqeSUffuoN5fmdqpW57umAT	5206	7324	7324	1617257520000	orphaned
10038	3NLNPHyFQjEwD1RfrnkXqczRwyw1o1ZwRFDPQ2oiqNowTjXc1C26	10036	3NLA9bFHptK5MreZzkWkW652bXUM4B3GB8tspq5ALCkQX13idfmo	1609	1087	133	6301	6534	jwHFQN5EoGp6cLiza8UWqw6sLXJLTysjR1S6cvTdaUnmmyHo2Bd	5208	7328	7328	1617258240000	orphaned
10050	3NK8BTdkRz2S8e6oK5jNfF6DmvuC4jEykPZrpu4UiFjAPkHxZPd3	10047	3NLqHaF65mn2SkimSBKn2ZGANu6sX256SUxyk6eMPvfzBeoswp7J	1407	1395	133	6301	6545	jwxx1dX4XWA37XmAXzgp5XZ7hhQSZ248D1WGww3P3Ad9X3ojXS2	5212	7332	7332	1617258960000	canonical
10051	3NKbFXpvvWi2i2aY51t4PjtJ4Y3GXVtA3qrc7W9rPgYFj6vHTKdt	10047	3NLqHaF65mn2SkimSBKn2ZGANu6sX256SUxyk6eMPvfzBeoswp7J	1631	794	133	6301	6546	jxNiRLekZFUimnqtUMNW1CPsDibVATscG1waRT5r2vkbYWY4hrd	5212	7332	7332	1617258960000	orphaned
10054	3NKLwVuCoYvJzGzzPPrW6WWuGv42EvPutixtKDhvFdyxJ7YEV6ws	10052	3NKTGXB3w7YufVa7qWJAWfWWuNcQSa84gA7mXmmfpbCpQwa3pYXr	1461	1271	133	6301	6549	jxCTmZjLfn3f3ADRUPRT6HH6KUjfemt4kYget9p14nHQjzGyBAm	5214	7334	7334	1617259320000	canonical
10055	3NLeTBfXuTntcfN3fKB6UPpMiheYtRW5Ktcd6BXn1HApEE6roGKp	10054	3NKLwVuCoYvJzGzzPPrW6WWuGv42EvPutixtKDhvFdyxJ7YEV6ws	1405	873	133	6301	6550	jxNeEotJqZrJJmmcq4Z9DXVnaDtFcEGWX7ib5dcfRQPRDPiVRUS	5215	7336	7336	1617259680000	canonical
10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	10059	3NLNyvtqGAjKboPkK5sZWQx1tG7EhLwVE3zhWMQwm6aTbBvUaWx2	1402	858	133	6301	6555	jwtM5Et8oKfsRxoeVsx6anufVXi56tC2SVGSEC7CRMk35ZHGFf4	5218	7341	7341	1617260580000	canonical
10064	3NKP4hS3t9jqVQjKTwzKEQ9H82421mxjsqeT381q8rc9UvGMYegp	10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	1631	794	133	6301	6558	jxQDD21kHbMpjp3vFxJELimGeqN1HRaYPxwZPFMQ92PViXcDDnu	5219	7342	7342	1617260760000	orphaned
10066	3NKhiSm3n2oqrjGLSTAhW3Rdoy6bRHyxF8cFtu9RQBtfAYcGoPwU	10063	3NL6WNBnE2xxsLDPh3Ahq6wGW3XQmxKeCSgXQ5zPNxk5YaigoZBR	1405	873	133	6301	6560	jwrrgQoNUSTYgmxLQg44Cv9GuPAwXYa2BpzJ9BiEFR2zVhUzCof	5220	7343	7343	1617260940000	canonical
10068	3NLWUcXA9jz6GLgMV3sgqkCpZptDcdd4mjLwMKMr7xKFf8tmQo5y	10066	3NKhiSm3n2oqrjGLSTAhW3Rdoy6bRHyxF8cFtu9RQBtfAYcGoPwU	1593	1220	133	6301	6562	jwPpipbW5hgWuBMDQGPZ7vCqohGGHmVDPf4vPFWvMP15u5X2guy	5221	7344	7344	1617261120000	orphaned
10071	3NKDUd5ZkJBDDnsnP8vCa8kTWjpJQaEetYJDTpPLergd5swQR1vk	10069	3NKuJe2GCPMKsDdu21ToTFzynCXGEjKUEDBUJNKHtTfYMh91ecn4	1657	1218	133	6301	6565	jxqRwLqV8CkS7ZPfWFkhJY54Cd9Gtrjr1CxRNax4DdJzGQijEsz	5222	7348	7348	1617261840000	canonical
14209	3NLvJratuWYgUNbfy81DSuVGHtARSjuDrX6teLWaAXkpNUYLRrps	14208	3NLG5LeXmu4iMJDEUiEMnh9EQoVBKqojxC47vGapf97yJGN2T3R9	1402	854	219	6301	10335	jxQkY7Np9MzT16cW5TdRyMQZpfHKeu52SbzeYkMjevFcEMqxJvb	7253	10265	10265	1617786900000	orphaned
9962	3NKMUg5Z6k9LiPq9qwCpFzkM3dyJdy5eLbqXq5p1WJcwdjStAEbD	9624	3NL9vdeBBXhA3YdrKt2vqAYPaJ125nDVvJ41fKVWQ8g9uHD3htD7	1407	1395	123	6301	6462	jxaFCUjUusAt3TM5t16XSRKXUfp3Ecia3sThn7iJS5HrignSYVo	4994	7271	7271	1617248116647	orphaned
9969	3NLq7em2KBpik5sLp2pLqCxrJec9btkNRtxB6Jz5MfCbYMHSrGhD	9794	3NKUuMtcapwCX4pQ7gMRrU3UTyrete8nxye525CEwNUTxQL4tT3a	1508	1141	127	6301	6469	jxyzq76dC9TRLTFwqGbgz7T4MD1PRQAoPKfPHZWrNjQR9QJ3bj3	5079	7275	7275	1617248700000	orphaned
9976	3NLwS5bys16wf4Z1srkrsisGWUXSbbsVDs6vqL2E8d5VhqEWAAJr	9961	3NKJAdv8zaQubFqcvDoYUEWZ5kNqhFDcnUwPSspxCybK5KLaT4PF	1407	1395	131	6301	6476	jwXPDhXpHWRRUk8HfYw1oRxVWaJrg1GD6DuthDCELuBf74LS8QJ	5171	7276	7276	1617248960685	orphaned
9973	3NKfRw4SyE9b4MB65F1UwnhuXT6j88dpWiutitrtzB5odtHLS2cf	9972	3NLaPbJ8b6mKeN9DeeU4XSNEAAnwh6JT2xHGK372i16YiiR95sCY	1672	1285	131	6301	6473	jxXScRNHmLmfiQwM4fHjkHAkgpyvqQ7tbb3h4x8b7sJhgVrzNdY	5173	7276	7276	1617248880000	canonical
9978	3NLu6HBuE91xgTug2ZgJGb5GDQbZcD9EiJ7kDn4k5fDHMXmCnVkQ	9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	1589	920	131	6301	6478	jxF3yKgUvbcRi3CcU4DLGVYDFxBsEJdwT9cEewnK9wsogxpykMv	5175	7279	7279	1617249420000	orphaned
9981	3NKwVeANK9XHUm4Lkr72RQcbPqhDh6Eky2WWEYh3LjSJgoU7vNep	9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	1407	1395	131	6301	6481	jwsjuJFNrcNB6eEp324z3ejfz6a7qyFfJNVbKtyecfnmY7R3Hum	5176	7281	7281	1617249780000	orphaned
9992	3NKxTX88ztW4w4W1TvX7bG5CCnVbZd5nxJ7n9ePdy1iK1VfSWd5s	9991	3NK5enD2F1SGpDWBNnZh4Ggy8Zz7EtUUPVTc85Q24HtiBsdGGdx5	1445	1044	131	6301	6490	jx2yJbJWUvXoCzJvgCTwxnZhDkroGQEnj7YhQou69fyArQX9s9a	5181	7288	7288	1617251040000	canonical
9995	3NKUaJLE38q4aaA3VagA5M8bL2s7xeKQeWCQjb7D62KkJbhqjBSg	9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	1490	1028	131	6301	6493	jxHScLu5CxeL3uVX4nZwgtkv5cx9bpANGTFt6Ai8UQd8fyhXPtV	5183	7291	7291	1617251580000	canonical
10002	3NKhaafr79XQ8Yjg4MMfCSx6RaX9cBv1nt7NKwhZxB1wpP453Qbi	10001	3NLP7BhbvwCYfwfKZHz2bJBBbnrNEivym6fYrG1GZZwjhRhzYETd	1406	1393	131	6301	6500	jwxJ43ncefifCLCwbVJ3aVdoBd6Wh9PMcVch1JuUX7PqbNizXE5	5185	7293	7293	1617251940000	canonical
10007	3NKrW5rsrH24pQLnBXryL1VrgYwNCBBWBkRP5X8RuWYbpkSntwRf	10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	1656	1097	131	6301	6503	jwwYUqKgBEg3xF2EnszVsMUq2EtvAwVGud39rsK39jVfw676vfV	5187	7297	7297	1617252660000	canonical
10005	3NLkXcwuPQycZSTNqr6FbXVPdessWdUWe24ycTG6NvB6sd7PqAhq	10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	1656	1097	131	6301	6503	jwmeDYhTF89u86hKofz9rWtVs8odWe8UDQD4rkutWesQc67qCGm	5187	7297	7297	1617252660000	orphaned
10010	3NKAdaEteVnzB3CNj4vEj9xBZhJJFWMo6jjVxfRwSMgYFtNnmKjC	10009	3NKsEUBYYLCaQCiNsLFYQzNQ1KAUPJcqrDNES1xLpahjLnm2Vesa	1422	1211	132	6301	6507	jxGhSUyPHYpxDH2J9xym92XUWtkCdmsfGMdVYmLhttV1tbWoirv	5190	7301	7301	1617253380000	canonical
10012	3NLnk1T7FxKoMRBRmR3qE2N6oqK2UHNrGhsjBW8uCFX538sKCvMq	10010	3NKAdaEteVnzB3CNj4vEj9xBZhJJFWMo6jjVxfRwSMgYFtNnmKjC	298	1308	132	6301	6509	jwCPmgoDV5X2LdiajKzgeZjhthueLBjTxRacrYoj9DkMTTRkErk	5191	7302	7302	1617253560000	orphaned
10015	3NKtRPNomt3haQcDpKGCt3ox8zDk5WxZty2BJXBWeHyYo5KrvBC9	10014	3NLgkkMTDzrcW66a7YUD9twMcwWSDUPX6K6kXYDGqT5Hk3D277M1	1403	824	132	6301	6512	jwdJjsjrEUAWVbn5eVgTZC8kXWGFCcs4ZertYhPF65joV8KbJEk	5193	7305	7305	1617254100000	canonical
10018	3NKYpqKDfmeBC28tgDG4YkkLv8yVKpUHkSR2tPoXXm1sZ6TpQUcV	10016	3NL74qXuohKr4cu3YTr59zLDxU2s1kmCHjoHBjbfJs8NNq8Lmi8R	1506	1127	132	6301	6515	jx3H9FcKQNoeEPjvSRBroVtebSMmr8aApksP1ApyqzsiUXMaWsP	5195	7308	7308	1617254640000	orphaned
10020	3NKWf1UpFcBp8VoFPdVKbEWGYH8p4NSJV313UA7DEb8dg4khcxmG	10017	3NKpLC6ERcP2eBKZVnWLZdSofGZrTAaGym4batQgTGxNZBkZQTwa	1627	1139	132	6301	6517	jxW8GtSyihcCn73yhFNKspFpJBsQmFwUKNyNdnfKfDitG7uN9uZ	5196	7309	7309	1617254820000	orphaned
10025	3NL6mvhJHe1ft7Gx4rvY3nSuDNdU1iJ1kgXqyoM8MtEsrpooe9X5	10024	3NKRyfQFLrLi7xr7ZtijkUG2dxeaf1GP7szLipyUXDBGoM2u3BKd	1649	1257	132	6301	6522	jwNA5NmECaiMQmqYxq5EZE3nQ7rtaVC2aXYj1t9t9ce13NCSRUM	5199	7314	7314	1617255720000	canonical
10028	3NLTqnyMMWUo5G5dxPRSF1hotKGor1HqkLtCavUL1KBi7q2YB5RT	10027	3NLAJb7wHPHKL55FQzYEdS8ycwooL9FEYFUZicHsCvmkizVGo7Gb	1407	1395	132	6301	6525	jwAPu1VaQkFSj698qxGmetr2oXUkjb5VcYQUAQB4JVGLo4u1357	5202	7318	7318	1617256440000	canonical
10035	3NKvTtwqZd6W7hscaWb6TQomrWYA5JQjfNe1M7uYb2ZfUrq3tDnU	10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	1600	1126	132	6301	6531	jxbG5Pqy4vGdXXzXGVTQa3QfnbDpyScAwmCEaFyCpHQeYx7zfFX	5206	7324	7324	1617257520000	canonical
10034	3NKQNLKfgZBZA6aes85nFz4GyMvTyFTn6CNjaXWxSE6WkWxcZRBj	10032	3NKc1vyzfQFTgjS4TEJWcemtt7xrRYvburtqf7kLDXjPCCmUzF4Z	1675	1216	132	6301	6530	jwYdCRYsH89H2Tw3WPxPcgoKBu9mzqeSUffuoN5fmdqpW57umAT	5206	7324	7324	1617257520000	orphaned
10036	3NLA9bFHptK5MreZzkWkW652bXUM4B3GB8tspq5ALCkQX13idfmo	10035	3NKvTtwqZd6W7hscaWb6TQomrWYA5JQjfNe1M7uYb2ZfUrq3tDnU	1407	1395	133	6301	6532	jw7zyF5H6pdbTjJgLjYRSgDBdq6cYZfbuxx8MiEmkVP9S14jRjL	5207	7325	7325	1617257700000	canonical
10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	311	1307	133	6301	6536	jxUvNv5AieWaAVaXqv33kpE7VwEXxsG2Dkf6CbTcYis57TbM5W8	5210	7330	7330	1617258600000	canonical
10048	3NL5az9SgXKpjMkB9vtzdLz2dyiqYnTrcanYe3yhkoDFoYvNWDAU	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1553	776	133	6301	6543	jxU1Xuxq6oBU762FuAxjMh1Ba3berp29i27zCUgEwMquPF5bvzA	5211	7331	7331	1617258780000	orphaned
10052	3NKTGXB3w7YufVa7qWJAWfWWuNcQSa84gA7mXmmfpbCpQwa3pYXr	10050	3NK8BTdkRz2S8e6oK5jNfF6DmvuC4jEykPZrpu4UiFjAPkHxZPd3	1407	1395	133	6301	6547	jy1vx1ibQyq5RNmzZ7TBaK5JMjEGDpSP1GYTNWbncWhuUyCNCcG	5213	7333	7333	1617259140000	canonical
10057	3NKe4gYXtmg3Nj3jF62VTdEwS1GyrKMDV1538KEdJe6bHiUfcHaZ	10055	3NLeTBfXuTntcfN3fKB6UPpMiheYtRW5Ktcd6BXn1HApEE6roGKp	1406	1393	133	6301	6552	jwZTY3zq5FhkKbNAAUK6nLtrPpSbqDBaobDPYiMdzaxGzbkSxUq	5216	7337	7337	1617259860000	canonical
10059	3NLNyvtqGAjKboPkK5sZWQx1tG7EhLwVE3zhWMQwm6aTbBvUaWx2	10057	3NKe4gYXtmg3Nj3jF62VTdEwS1GyrKMDV1538KEdJe6bHiUfcHaZ	1668	1370	133	6301	6553	jxWy39pRvLiD6qG9SmgqakdU5bvfHjoQP8J82qG5LwH1zSNRdgJ	5217	7338	7338	1617260040000	canonical
10060	3NLKGfx7zovx7wRZRNwHbhzwdmFTKAXwbD2Jc7AqXTqjPVpR9H96	10059	3NLNyvtqGAjKboPkK5sZWQx1tG7EhLwVE3zhWMQwm6aTbBvUaWx2	1599	1041	133	6301	6554	jxRnrKzi5T8PC4owCeiS3UKRKgoUx3S9wBQNq7wdr2LSirmSQ3x	5218	7341	7341	1617260580000	orphaned
10080	3NKmGtuBGCWvF6LoVKGp3mDaAYaHswGw8KZPhcukxnZ1pVEqWRkn	10077	3NLiHFtJnEJsz5nu2qXg7TyqZfDZTi7NkUqF2SaEf9DzmRsdh9KU	1581	778	134	6301	6574	jwNzAaaiggKG2ULF7KB8cAi3b5fRx3XuRzfDrDuUeaVKtPKE27h	5228	7358	7358	1617263640000	orphaned
10082	3NKugM9z4kjex3P18rFvCKoMoqvTSXt3RMYVHLtFYqV5iWvFGg7z	10081	3NLpudzktDM2aQjiXQongx9dPujrUHB5hcopc7H1KKgXVSJLdtHc	1407	1395	134	6301	6576	jy38qHryRxyFUMDj3Abefe76owasTzsVw5KRbVqC4kWVA8dSM9Q	5230	7360	7360	1617264000000	canonical
14745	3NLhJZnb97dJcR5eKkXjZ2D5G7LCMcrcxg7MNQaBGcqYDwHwiF2e	14488	3NLEhTXfeLno4gLQmRihePtzdjk9P6Fq7ziLnkurezk1RFfAAfms	1623	830	219	6301	10831	jwoMYu26MWTVqqVbvVCfPMvnMVyv6Kgpe4xj1xcUWxyg2TeUE46	7253	10638	10638	1617854040000	orphaned
10062	3NLRh2QDK5fJTtiHeh128imcL7UgnL6w1GoUA9xSPjxv9XhseCW7	9756	3NKXFyh1YehvTLWnGixM9PqZCEsBZXbExbCYYpsLWnSUQkwAfNYq	641	1090	126	6301	6556	jwcsv98pNHF4vdS1m9Z99WtstDjMYttssuUxrTehv15MXakkTAA	5056	7342	7342	1617260760000	orphaned
10070	3NLFPAem3kDMyiDFXaeNHhCep8fvr6ooh2Hw8JovA3S51Bqyfiip	10019	3NLrFnjhiDQ8n4GhW5y1UCqFy4ZvjbYoDK9K9xD99tJwYapSJYPR	1637	816	131	6301	6564	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5170	7345	7345	1617261300000	orphaned
10100	3NK8ptYjyZkcvdBT7GfWnpBnh9SNqLT9jrhVzmtCTtJzXerBzarm	10070	3NLFPAem3kDMyiDFXaeNHhCep8fvr6ooh2Hw8JovA3S51Bqyfiip	1637	816	131	6301	6590	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5171	7377	7377	1617267060000	orphaned
9979	3NKptrJmzerHQ7fZCNyXKN3E42SRrZAhba1FoXf5RrsZZ19HNkuX	9977	3NL6KQ3BVdDQ9mGS2aMVhadCb5soZ7CiTC2bn8psmeakJtaadFQ6	1541	1172	131	6301	6479	jx3vXdu7racrxcejaEeaVsMDYX7i7ZNryvKnHz5yAfuFHC9Kiiw	5175	7279	7279	1617249420000	canonical
9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	9982	3NL62XypAJyhU1mok3JH3rJFi1x5eB2sJCiDrDnYTCtvmuSRHRwD	1601	1388	131	6301	6482	jxALQx1ebr8y3pdpo834NdqypjiS6vuQyTpHPfrMQQy3iXDDLXJ	5177	7283	7283	1617250140000	canonical
9987	3NLy7iusvjFeFq4KDkQR7DnNQUVyMEfMMvzrUBGPD8hLHDhrzsDU	9984	3NKcXGnMrjRdFrwisWoC9o46KbZVLGzSV8SkAozw6uRPz8ifsPfM	1483	504	131	6301	6485	jxW2FpNZ1aDk1YHDjYwcGeJKXXdYv5xSeRAwgMsP8c3mvm8dGya	5178	7285	7285	1617250500000	orphaned
9991	3NK5enD2F1SGpDWBNnZh4Ggy8Zz7EtUUPVTc85Q24HtiBsdGGdx5	9990	3NKCfrDW46LNnag9DneuQvgJDJif9bU4iWutwBPfcSXbUrW5aAuJ	1471	1020	131	6301	6489	jwJ7HWuzGEVB4woiLQmaCpPGbZr9jBaSARHUdhybagSu5BG2gjz	5180	7287	7287	1617250860000	canonical
9994	3NKiUTV2aJdUCuB3cSZ1dn1fqk3SkpsXh3XpjuKLNSTupMZmbctu	9993	3NKt2k1KQqnKxGKd7vRMTa4BnnztfQu5gxaRjxKYDxjKpuvzbST1	1549	996	131	6301	6492	jxiPWfizKGdB6QzEdh9xiEcHUJ8qFV2hCreZkFs3aXeBVW88gKZ	5183	7291	7291	1617251580000	orphaned
10006	3NLQn9E5hjaDEbQzXfxcCj1Zdq2JPzf7hxHZhxYfCPsLw7vqwuZ3	10004	3NKq6mHhx31ikA9Gax1JcRuzTMp3tMudKfcwt3VxMDnvAeMYZGPA	1611	1095	131	6301	6504	jwusWRYdzgPUb4ujxW5nnXX6BL73wFwbWtBZfYeMbYT1CHKXiLc	5187	7297	7297	1617252660000	orphaned
10008	3NLSNr7w6yHYqFcdcDexph1jfRNpuz1vY5gp186hFXV1XsVFhd8Q	10007	3NKrW5rsrH24pQLnBXryL1VrgYwNCBBWBkRP5X8RuWYbpkSntwRf	1547	1378	132	6301	6505	jxbyCRhKth9VKQbCAiYRFdhg1Dr9medWgytdUBpzbAEXrXzCVqc	5188	7298	7298	1617252840000	canonical
10011	3NKLN4jRG7QPWK84yFLAiTR5NZJ3nwpC6K71A2T9uQdaWomApiHx	10009	3NKsEUBYYLCaQCiNsLFYQzNQ1KAUPJcqrDNES1xLpahjLnm2Vesa	1406	1393	132	6301	6508	jxQiJ5UUQhu4WiP2K5s9ShPomygbePCkX43QVGUdoZumXr3pLkH	5190	7301	7301	1617253380000	orphaned
10021	3NKXi2Bq2hFvKxqmfQFZiH65ybNWAXhkW6y7s7zhXa4LW7H6sywo	10017	3NKpLC6ERcP2eBKZVnWLZdSofGZrTAaGym4batQgTGxNZBkZQTwa	1631	794	132	6301	6518	jxFGQNUpDnBAkSuXXa9jUdgQoovg48Hvz9teqRL89fg3m3YMMnn	5196	7309	7309	1617254820000	canonical
10024	3NKRyfQFLrLi7xr7ZtijkUG2dxeaf1GP7szLipyUXDBGoM2u3BKd	10023	3NLJbaupDLgfUd9zrsXeHfrmZJXW2jC4zmUvj4GJYa5edv8LhfPD	1407	1395	132	6301	6521	jxymzq1kmUa8RAbbw8b6ck19VK1qAHWPeBmULkFMWCP7idQuQMg	5198	7313	7313	1617255540000	canonical
10030	3NKWBfLerUX6HAomdJmeV4guUySnSisBP8jHL9i1sLuWvZXQsMoT	10029	3NKEVqxUimSRdx1yyjhgaZfvjTuNcueSqFAtAzQAfgMwp19SEgHB	1607	1348	132	6301	6527	jwK8bnrK2XHquHCN37Qw8mLbbwpzgijxyu3ZZrTG3G9hQZPpw1r	5204	7321	7321	1617256980000	canonical
10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	10039	3NKzTZhVMaRv8NLCYSdjyom3GrxGVJTaxBgox468Rc6Nom2ktKAj	1407	1395	133	6301	6535	jxLRH65yPcFPg1xd4C3AuzJm7e5pLaQ4TDiPJhyqwNgHcDUu8cs	5209	7329	7329	1617258420000	canonical
10043	3NKc2GQtpKJsJLzcMTadt4UdXSSiS4dMAiPBispiL9At3P8dAhqi	10040	3NKq2vMx2w1MCtsVDw9qd2rVMS93ZZv9sKXjhUws1bwytA5zDDUH	1406	1393	133	6301	6538	jwwK5HxaFdy5x8MoaHWrzwpSogzCzh21oe4RBBXAHS9uG3bHVY4	5210	7330	7330	1617258600000	orphaned
10047	3NLqHaF65mn2SkimSBKn2ZGANu6sX256SUxyk6eMPvfzBeoswp7J	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1407	1395	133	6301	6542	jxCwLKm3frarysxZtHf2H5NqyS1TWPMdsjDdu4NvCSZXjEmiCdK	5211	7331	7331	1617258780000	canonical
10049	3NKWfmsc4TBo9gbdEbend19pN7QeEwjvFv6uYsm2tbGJ8LL9Qpxu	10041	3NL6yKU9M9bz5SbTfmw27kfNwhQsoTyfLcsPMsVg9XAr1P4TMzoz	1406	1393	133	6301	6544	jw8ZT6xxyAn2b3hff4LsLVkHgxRE6nrXivoYHvdayW4ueSTw8Lh	5211	7331	7331	1617258780000	orphaned
10053	3NKEvYqaagXER4qsqdQb3kpdM5EzntZ5CQBNKTGSSPFkmUgzxeQS	10052	3NKTGXB3w7YufVa7qWJAWfWWuNcQSa84gA7mXmmfpbCpQwa3pYXr	1440	1131	133	6301	6548	jxYGyVYQ9G1YbSg7ZeJzgpcDKkfLHrbVr9Fcij8qo9BWAtkE2hT	5214	7334	7334	1617259320000	orphaned
10056	3NLV7CxCbkhdoKmJU4WDQyqTBfBaPDCYt4HGCHf26jwqGMud9oaT	10055	3NLeTBfXuTntcfN3fKB6UPpMiheYtRW5Ktcd6BXn1HApEE6roGKp	1403	823	133	6301	6551	jx4JByqXfSeqvABPwfF6MF5fQCHEFNhp3myXrC91gXMXHFRjM7C	5216	7337	7337	1617259860000	orphaned
10058	3NKzxUtUJpnT79qvZbJVzVzhr9iV2cQJrJD4Jtwvm9MuhwW98ZmR	10057	3NKe4gYXtmg3Nj3jF62VTdEwS1GyrKMDV1538KEdJe6bHiUfcHaZ	1668	1370	133	6301	6553	jwHa2ZiaqiiD4twEUc5rsbeKLPiN6aex8myYfV7MgoT2Sn9rheM	5217	7338	7338	1617260040000	orphaned
10072	3NLNrb1KQgv92dj2sG6dNVkYNdgLNMkuvHRPD83jz3T9Rg87bNHR	10071	3NKDUd5ZkJBDDnsnP8vCa8kTWjpJQaEetYJDTpPLergd5swQR1vk	1406	1393	133	6301	6566	jwWv9TbvhoH3sarZAJkgnDBoA7VapZYxRcJ1iKRxJqT1pV6dJm3	5223	7349	7349	1617262020000	canonical
10073	3NLp1waWMqd4bKTG9wYWaKRG7P1djMhavqnS4xwBSVGN6UM6LSFH	10072	3NLNrb1KQgv92dj2sG6dNVkYNdgLNMkuvHRPD83jz3T9Rg87bNHR	1398	435	133	6301	6567	jwWpzYEfbJemtVV7zdVkxDfmrsgPfRL4ZjdAc149JGGC8GnxkDg	5224	7353	7353	1617262740000	canonical
10074	3NLpJ4Foox1kpraAZ8KdM4K4neNb1AqAvBPrcn1qfGp3Vrz7e18j	10073	3NLp1waWMqd4bKTG9wYWaKRG7P1djMhavqnS4xwBSVGN6UM6LSFH	1407	1395	133	6301	6568	jwqrDkXtPBx6bWPoMx8UonjuHYgkRcSzzFAhdDTKGnWX3kvfidX	5225	7354	7354	1617262920000	canonical
10077	3NLiHFtJnEJsz5nu2qXg7TyqZfDZTi7NkUqF2SaEf9DzmRsdh9KU	10076	3NLMFxuvjgkK5iQnNuHnvjZ2CMDvXSWVVVPxiEy4hsDAoRCRUhiv	1555	981	134	6301	6571	jwvDBPDpViQNcyZKfnDcTwP8X1TZS1JSaQCrAUwFgzHQkduydXi	5227	7356	7356	1617263280000	canonical
10079	3NLXfCbJLsqfqXc8tceFp6i9vCrCpkYSiEz3ZNdRwK9PV38Sxgsf	10077	3NLiHFtJnEJsz5nu2qXg7TyqZfDZTi7NkUqF2SaEf9DzmRsdh9KU	1673	1242	134	6301	6573	jy1mwYzonQyczkRZVZiiyeC3n4hM3kSZDxFNQeUxNorLuoUyP5m	5228	7358	7358	1617263640000	canonical
10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	10083	3NLDfjixD4GfFkiUinai7pzuAxH5TNY7V19xniqynJ5mH17745hY	1405	851	134	6301	6579	jxPLn3vXsjbRtqdRyBJAgkrznfrUq2defUKbYXAXwrsGLMXbqs9	5232	7364	7364	1617264720000	canonical
10092	3NKHWpy5egC7Q5UUHcaEEtA7EeRETH14iyLmPjFEHrMgYptGiYTD	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtLJ6RaMXQHZKEBQTujwyfn8rAatVdDu7bjRXPRJvKa8YGN4DR	5236	7370	7370	1617265800000	canonical
10097	3NKNmQh3xucq7LAMfiuXiuFipt3tvo2Hngw9GkitzFwddcdrtDbQ	10092	3NKHWpy5egC7Q5UUHcaEEtA7EeRETH14iyLmPjFEHrMgYptGiYTD	1594	960	135	6301	6587	jwjWbz1aHFFCW6HHK7bUP1XqfESmgep829iJskr3bko46i6eJn8	5237	7371	7371	1617265980000	orphaned
14233	3NLhpHQVA5L5XuFFzBj6AgwwuezzRvj4NrpNqiaEY4U7kcpdJRjG	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	1405	873	220	6301	10358	jwJNucKLcHGCfNJzzY6UeggjeoVZgAauDHUEDGncXwhdsoYEEbw	7267	10282	10282	1617789960000	orphaned
10063	3NL6WNBnE2xxsLDPh3Ahq6wGW3XQmxKeCSgXQ5zPNxk5YaigoZBR	10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	641	1090	133	6301	6557	jwXNTmBpFuf2hwTrSCrJ9kseTfk1B7WNGH8UfYfpaPNh9xTcwSR	5219	7342	7342	1617260760000	canonical
10067	3NKfJhd6gGrcqzkAjUVpZx1j6GncUKVdXPdPdir2Gy9fPXpKKWy1	10061	3NL1Eg1Dut8XyQKKaZj6uFc2hg7E3dLC4sSR9Tyw1hagAtq3GZtd	1593	1220	133	6301	6561	jwbMqqMrwXbfYoUv4u4S2qdnhfpEQ4snMu2mdytawdT7KVvLKfN	5219	7344	7344	1617261120000	orphaned
10065	3NKAeX6ezwASRto5YwojPLDKNX9DMVrtNQvN4UHisaaknWtFFV9E	10063	3NL6WNBnE2xxsLDPh3Ahq6wGW3XQmxKeCSgXQ5zPNxk5YaigoZBR	1471	1260	133	6301	6559	jxpuLWjJasRocU8c8RmdPeUmam16duWsvSq4s1VnbJmK5fGTEJq	5220	7343	7343	1617260940000	orphaned
10069	3NKuJe2GCPMKsDdu21ToTFzynCXGEjKUEDBUJNKHtTfYMh91ecn4	10066	3NKhiSm3n2oqrjGLSTAhW3Rdoy6bRHyxF8cFtu9RQBtfAYcGoPwU	1406	1393	133	6301	6563	jwmZ8M52fzFX62rZGFrwujgyQf4Fcj5sij5r49c3CHTYSTUscD8	5221	7344	7344	1617261120000	canonical
10076	3NLMFxuvjgkK5iQnNuHnvjZ2CMDvXSWVVVPxiEy4hsDAoRCRUhiv	10074	3NLpJ4Foox1kpraAZ8KdM4K4neNb1AqAvBPrcn1qfGp3Vrz7e18j	1406	1393	134	6301	6570	jxwBCxPCrR7fUPfxMs5cwUzeXUvt8zKeLFVQKrSzLWLezuU2T9Y	5226	7355	7355	1617263100000	canonical
10081	3NLpudzktDM2aQjiXQongx9dPujrUHB5hcopc7H1KKgXVSJLdtHc	10079	3NLXfCbJLsqfqXc8tceFp6i9vCrCpkYSiEz3ZNdRwK9PV38Sxgsf	1422	1337	134	6301	6575	jxGQ8hERpNcEtm2jC5Cwb5f2ECiXJppi8QGAjHhMzMb5nqY3fR4	5229	7359	7359	1617263820000	canonical
10084	3NKkxzBuGsTfJ2v1oo7EsMEpo14JNzhFd35MEevaixW1isoFD7uu	10083	3NLDfjixD4GfFkiUinai7pzuAxH5TNY7V19xniqynJ5mH17745hY	1426	1238	134	6301	6578	jy2sUzikHZLW9bW4qdhsqLo23952NeEVffaXpWi6TUTqikMiYPp	5232	7364	7364	1617264720000	orphaned
10087	3NKQZGA2WdoHuYqbGbtZVbKRFSZ2SvUhvtE7nVJmZwp5H1wc9U9S	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1407	1395	134	6301	6581	jwo8GNc4DRFW9rhswsw42QdhomvCbDCL4J89tzFfsR6cHzD8v8g	5233	7366	7366	1617265080000	orphaned
10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	10089	3NLJLnVLTmV33UKVrhjqVciYkcc4tBy7z3wBNwG4w97fsv2CxEfS	1518	833	134	6301	6585	jx5x23VcXkMkH4Zk2m3VD6qjykRBPCV1es4XaSafos8utryL15S	5235	7368	7368	1617265440000	canonical
10094	3NLA6bhZTpDjcWqQZDQi8pPffkj2i76Bhz24eUMM7GgZJShMnwrw	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtuc1rSneadUAQhNwzSA9KYzdYtYQJdgTMKpQfXXnLxrumJBmr	5236	7370	7370	1617265800000	orphaned
10096	3NKUCSy6puR8YJ4KspBLktxDxpj8grhWd6fZNB1q9cPoTjnghY8n	10092	3NKHWpy5egC7Q5UUHcaEEtA7EeRETH14iyLmPjFEHrMgYptGiYTD	1594	960	134	6301	6587	jxdyWeTpvm4tBs8Rd5bCv5dpuKRiiznURPnKwSYJqRdcYoYSckC	5237	7371	7371	1617265980000	canonical
10098	3NK8BKT6K1GTgLW6tpx76HMaBJQTuCcF8rajKy4XQvg6crCeEHJr	10096	3NKUCSy6puR8YJ4KspBLktxDxpj8grhWd6fZNB1q9cPoTjnghY8n	1553	776	135	6301	6588	jw6jEAMKxVFy4FWxFBG33W7uhAtjoh6QboUbMaNRTFgZTKmoZzM	5238	7372	7372	1617266160000	canonical
10099	3NLR47q1ZZTZ6iuXEDzHjLTTS4c68j9pENnXkj1JBGGoC45y9p5n	10098	3NK8BKT6K1GTgLW6tpx76HMaBJQTuCcF8rajKy4XQvg6crCeEHJr	1622	1110	135	6301	6589	jxjqkk9vJEoxvYknJkNYLDnsiqbGeLyMk2pBGy2BsaBsX45YtEJ	5239	7376	7376	1617266880000	canonical
10105	3NKnsjvzfjcx3kURmmdfMradknXG9hoFFatFhPEqycQywrWMf7RK	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1652	949	135	6301	6595	jxs46NLWEVVXpX2c1FppSac7muZaTuXTEUdoxVA2UM8RM2A6xBd	5243	7381	7381	1617267780000	canonical
10109	3NKzk4F3PhyhXm2MczT9h7pQ6WDKW7f7oeEjNiV5pjsgqorKVDgN	10105	3NKnsjvzfjcx3kURmmdfMradknXG9hoFFatFhPEqycQywrWMf7RK	1406	1393	135	6301	6599	jxHG9vjUa4XRpmgVaPFiANntjpbn5P3EDV3GopfehiiF4X9zdsv	5244	7382	7382	1617267960000	canonical
10107	3NL7NynbchtBjY55LjxKmP8CzaHKazjb9zLT3xCdPUWqxnm32DZd	10105	3NKnsjvzfjcx3kURmmdfMradknXG9hoFFatFhPEqycQywrWMf7RK	1407	1395	135	6301	6597	jx7ca8zWCeaTz8oEqzjLwHzYFyir7W1x2P2EVhGFJv87XnC48AM	5244	7382	7382	1617267960000	orphaned
10114	3NLVdXLS5MtrrUfXdyf4TrwMjBH8Ugm13R5624LJFJaU4CRX9ca1	10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	1406	1393	135	6301	6604	jwVvasWg84BRUriscGFPcLPirCDmSfXthZiMLZGBJikMcuyLRVN	5246	7386	7386	1617268680000	orphaned
10116	3NK9i1CD9abxSJqNa5bsQqHnQdsaeTzGd88P9ebEn2r9DnkYbnmC	10115	3NLJnw4RnUhw9MVQPpbp5wB2wWtekfJcA62a4XtZeJqdGnadaZWB	1403	824	135	6301	6606	jwoaw2CFCGAZYrxvQH49f8Hrp69qvS1iw4WZXGtWSejhwoj5N9p	5248	7388	7388	1617269040000	canonical
10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	10116	3NK9i1CD9abxSJqNa5bsQqHnQdsaeTzGd88P9ebEn2r9DnkYbnmC	1660	215	135	6301	6607	jxkAxsM4hoRfxhKzYtvDYKJG2zCfivRrEdK8J2ZarvnKf559zPT	5249	7389	7389	1617269220000	canonical
10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	10120	3NLSGHHdn1RzdAPMqdPTA2uZfUtzVzCskxHCtfZDALtSYUweWAtF	1406	1393	135	6301	6612	jxKFdvARqmxKek3K2FgUDk2nKj7obRU8NTWq2dsLUsvbfdt4TzJ	5251	7394	7394	1617270120000	canonical
10125	3NKaED8K1Ucie2Zr3TqLiouanU3VrWoXisLzx7nnYTcrj6e5ECG6	10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	1646	988	135	6301	6615	jxQsB4dYscyuSi5cDZVdwWYsHC3ctbnpXX9bCSopZnb2PUsJNvy	5252	7395	7395	1617270300000	orphaned
10133	3NLYDijrUhct8xE6gWEBHY1NbezLq317ARV4AHaZEhBPw7FuvRMu	10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	1426	1364	136	6301	6619	jwMhVVtf7pbqa9cPjFoy6Fz1ZpyK1bDPYPXCZn7oQ3GZGe5Pxhr	5255	7398	7398	1617270840000	canonical
10138	3NKLUz1v6jqP7Gdfmyi4ezft6PeDg7giXcZZRukyb2HxtnC8iP49	10133	3NLYDijrUhct8xE6gWEBHY1NbezLq317ARV4AHaZEhBPw7FuvRMu	1581	778	136	6301	6624	jxg118h8Nxs9JRJUYVyTxHiFknKj3XfFKtocz522zLHGefU3xQj	5256	7400	7400	1617271200000	orphaned
10142	3NLt7JCVBE3tNcsyXwNsKsZv8CCa9ED7LeiTp2LB3XNrC1LVXyyx	10136	3NLvvkc7fvkwMNWn6tWzczgGNjsATauRhcrmMcUPqDwfrwLK7i5M	1553	776	136	6301	6628	jx6VhS1gYwZw9YTXvHhEUbYdTDjHTCaWKSVTMgoAmxYrL1Unnaa	5258	7402	7402	1617271560000	canonical
10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	10142	3NLt7JCVBE3tNcsyXwNsKsZv8CCa9ED7LeiTp2LB3XNrC1LVXyyx	1447	1219	136	6301	6629	jwPtppwW391nyJJBGPHYgxSnjnb6hbckiAgZwWwp84irMjui11m	5259	7405	7405	1617272100000	canonical
10148	3NL8ckJ26VUxdvwMPozkPakJJLHYF4KdKG1VYwGjwnkGF3S4A9Mu	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1501	1360	136	6301	6634	jxFCCQjyZECKuCy2kkHpqCfNcRBofwwvr7aeFU2oxRpidnvqmuU	5261	7407	7407	1617272460000	orphaned
10153	3NKDgUgBPm44k7hGFtEJMbTHEMTuxfiXZVVSFa7BfFfYtrTyNrYY	10152	3NKbSEru6XvEVHpuMkvekAUtax2NSYP1X539PTFMgbrYfxkpGFXb	1447	1345	136	6301	6639	jxsfwoA791dXJXeT99BHCPFVLnBVRtstgYBJLadHLkZWe5TeAek	5263	7409	7409	1617272820000	canonical
10158	3NLLAhAB3bzsHtNMz1SNmTTv7zdFD65dZxrweMB9HTX75envkC3d	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1402	874	136	6301	6644	jwWzGq5PZ9NHbH3nvaZejESMG1X9353qx7kVcvionGehi7LTUYY	5265	7412	7412	1617273360000	canonical
10163	3NLRu5cRfmMcC11nxCE267EaqzGXjKbZrbVyKLjr8eF3rsJoNFd6	10161	3NKzsUJJZ6jhCWo55ZAWQTB7kh9SZraG2ygWECGb4ZZ7yPDcp1D4	1402	882	136	6301	6647	jwAXy4usHeCC3FLW4RHMr5S3MtDjRdjUt1jBnCsTCdVui4ApVra	5267	7414	7414	1617273720000	orphaned
14634	3NLy6rXqSVpBpLTMvW4yofW1mrFLWUxNG6rmWMZQiJd1Urwh63Jm	14249	3NLdjXWBzo3mZiX2HgBaxzDocAzwqzVVQEA59AAgwokMY68WLzUk	1594	1326	220	6301	10725	jweNYkjMdEW6gSj37Nv7HwczvwrnnPzuUeurzbLMmZBmfwSc1Mf	7276	10561	10561	1617840180000	orphaned
10141	3NLewUWUjiGRtJB5VWEdjVYqm7qciuAAmRL41mCnKRRYozhssi8t	10140	3NLJFix829nM2DFEjpUJNMenoFEhu5e4jujse37gsowB6orfGxnC	1578	930	124	6301	6627	jwWjo8u1GDhvd9t3ZM9nZBqpaAnjcsqitDSoQKK6Ea1AMRnVYju	5030	7401	7401	1617271380000	orphaned
10108	3NKG71X6Ch1cRCHM83NGXY6DWJbZv5Tpf46698WKzXB1XPYYJHP7	10100	3NK8ptYjyZkcvdBT7GfWnpBnh9SNqLT9jrhVzmtCTtJzXerBzarm	1637	816	131	6301	6598	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5172	7382	7382	1617267960000	orphaned
10135	3NLRTW3BVRec4sQd3zi1Qne6nKEFKL7AoxkZt6aZvJjvgRaTM3dE	10090	3NKN9mKLHRH3Rxhw1v9cMzwzmJpfxciYGMx9Ekn9uFQWCqAZMgdk	1578	930	131	6301	6621	jxV1tG39tCQWSN7o9cWvhQ7jwP1HFRsip82RUkkuCUge91GZu7r	5173	7401	7401	1617271380000	orphaned
10075	3NLxccBruesS9VZPraLPgbezVj7JC6NHhQZrWK2zJuQifvx7NUEk	10073	3NLp1waWMqd4bKTG9wYWaKRG7P1djMhavqnS4xwBSVGN6UM6LSFH	1406	1393	134	6301	6569	jwNdDrd6RQYtMGevGDhNuZ7nvEXyyAn7txjhhzMAoea14cWWX6s	5225	7354	7354	1617262920000	orphaned
10078	3NKADjnduzqJQ8ydrLLjDu8KLADEXxKdbXVjDLiCR7iNLntqsdoi	10076	3NLMFxuvjgkK5iQnNuHnvjZ2CMDvXSWVVVPxiEy4hsDAoRCRUhiv	1406	1393	134	6301	6572	jxSjP9uc97XiR5hgkar1yKZpG6c5d5qujZC35gYCuhKSt9Y1Hhy	5227	7357	7357	1617263460000	orphaned
10083	3NLDfjixD4GfFkiUinai7pzuAxH5TNY7V19xniqynJ5mH17745hY	10082	3NKugM9z4kjex3P18rFvCKoMoqvTSXt3RMYVHLtFYqV5iWvFGg7z	1407	1395	134	6301	6577	jxZfvvwTZv11myFW8PwfpsdB1eQdtccvpy1Z5qa8vhWS68NJ5pG	5231	7361	7361	1617264180000	canonical
10086	3NLk2UFCvDxWcdVtF7Pn2jUhSUcrm9xgZWej5xkbR2CMpy4RPvgs	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1448	1311	134	6301	6580	jwJTBUioerzzogtk8rmgJdZ2U1FYeHXqip9JL4H5s8TdKeHnQ8Z	5233	7366	7366	1617265080000	orphaned
10101	3NKvSpqHwT5EfhjdQSBLfwZ9eBEUPKvzbZZTnn6eyRU5B2CnbrMt	10099	3NLR47q1ZZTZ6iuXEDzHjLTTS4c68j9pENnXkj1JBGGoC45y9p5n	1601	1388	135	6301	6591	jx1rAgx4sAtGcyWZCY3Xgyc9W4timDnPBDvzAvvx38LPNorQmUb	5240	7377	7377	1617267060000	canonical
10111	3NKJtU9xBvAUpGzMbg3Z8KWc7vLch8NGbGJAt7LpF1JHthGpskey	10109	3NKzk4F3PhyhXm2MczT9h7pQ6WDKW7f7oeEjNiV5pjsgqorKVDgN	1646	1354	135	6301	6601	jxiw2pREYkqYpLz7reV9i1tGkeVh6vnXRaxSBJwFWGiXAeQExeC	5245	7384	7384	1617268320000	orphaned
10113	3NKt8K5LsVaCyYUWWcZkTVYzUnRvvdKMYHEkwfBYzPGErsFUioMV	10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	1593	1346	135	6301	6603	jwk5TLWv6aubUURiF2EbRTC1ojB6qwqj2Mj9aeMFGLH4vr2gsav	5246	7386	7386	1617268680000	canonical
10118	3NL6VGHpB5UaqgV2p1WrygCy1hGvnqfd9G3Kau1mhdBXQrKUE4zY	10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	1460	624	135	6301	6608	jw7XkEDWe5gCQarZYHv2wpQxp1pGPNFA62rQVThhvHfAqHAoE5U	5250	7390	7390	1617269400000	orphaned
10121	3NKVcFoa11pX8vsWoAtC4Cu8UeLyWLFjqFTrEc7xgFmMCFNnUHpA	10120	3NLSGHHdn1RzdAPMqdPTA2uZfUtzVzCskxHCtfZDALtSYUweWAtF	1624	1088	135	6301	6611	jxkSrQgJWQSWyVxTgC7tZQVkZaeTF7L2zcNADNHhXe1ybeZv3qg	5251	7394	7394	1617270120000	orphaned
10124	3NKWSr9qmsXFdfN6Bkms73EefPbob6YQu48o6qTBJpqsSRHipRYJ	10122	3NLFuZdEPGmm5VNrJ2ZmACcANfVhHrhgbAxTkU9MbonpmY2RA5Ze	1467	1376	136	6301	6614	jwHqrkewHaa5KFafQqoTkh6G6SVDufkf6fgYbvApV3cnQxxsdvX	5252	7395	7395	1617270300000	canonical
10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	329	329	136	6301	6618	jx5y8VUhjDX9pYeANyZKvQcn799aBKeQJfVmgg9K1k6PZzjTkB8	5254	7397	7397	1617270660000	canonical
10128	3NLC5kiWnsze9T2zDsYwEEttnPfsCZ9qd8muHtUkbRK6E2YRGjva	10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	1426	1238	136	6301	6617	jxUvWC25nTAHYvrGoJzgzp7cAZatJywJ5ZwzLVBAdzqHYu2cuhD	5254	7397	7397	1617270660000	orphaned
10146	3NKFEznqDdpREupbfPgXZ5xVSDVs8eegZc1xW1xMBr97ZFUgMGkr	10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	1406	1393	136	6301	6632	jwUNY5nUwSEXnbzqbHxvdq7ktTQNUHYiX5M8npcpbfXCMf5PFvN	5260	7406	7406	1617272280000	orphaned
10147	3NKwapKgAWCQXsdbSjB2usWoomPfuVfeRcvd1y59YvN8MwBXK9Wj	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1407	1395	136	6301	6633	jxU6mQ1zsZcEZytkguGm3gb2vfhrFuaaEUhSzLPobKQvvKXD51s	5261	7407	7407	1617272460000	orphaned
10152	3NKbSEru6XvEVHpuMkvekAUtax2NSYP1X539PTFMgbrYfxkpGFXb	10150	3NKHAVnUtuQfzLQ8XmTLh5fsbof8eqZHq7ZxBuoH9zkCzbKKJWvf	1419	814	136	6301	6638	jx49f88nQvAhK5cJFADNM7kgRbRW3nXmAdfonZ3uyNGrGBo2JB6	5262	7408	7408	1617272640000	canonical
10151	3NLXJcfmGAz7gqG97AvpAveMXrHHv6eMxnvmn1UJBpxBAmJd8LFa	10150	3NKHAVnUtuQfzLQ8XmTLh5fsbof8eqZHq7ZxBuoH9zkCzbKKJWvf	1553	776	136	6301	6637	jwGBQrnNzyQLtbSZuPA3vuFeNJezdqRbr7aMEKYjuPWh4tyuCP7	5262	7408	7408	1617272640000	orphaned
10157	3NKPar1Ewwpr3WTnXHnpoiTEJKhezyrZL4vhgbCYGGV4X6Bu9SgA	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1429	510	136	6301	6643	jx5dH2fZGThmek2DC8ikMz1PNv4RAvQc4k3jRr3vEofa7AXYzTi	5265	7412	7412	1617273360000	orphaned
10164	3NLDDELP7GhCWUMhGBPCMkQ7HEQDZxUDT5TVK3P69fHPHsRy1fgA	10161	3NKzsUJJZ6jhCWo55ZAWQTB7kh9SZraG2ygWECGb4ZZ7yPDcp1D4	1506	1127	136	6301	6648	jxqav6sBoFrzqX4cgxjm7hXLxS5aWkRjKGYHAKKYdbey1fcrVnR	5267	7414	7414	1617273720000	canonical
10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	10164	3NLDDELP7GhCWUMhGBPCMkQ7HEQDZxUDT5TVK3P69fHPHsRy1fgA	1405	849	136	6301	6649	jxPucDB6egEGGKASbYMa8DKtE54FdG4cLuwpjeKmMSwz4wPwkcH	5268	7415	7415	1617273900000	canonical
10168	3NKQq24oF3J87irV5uWSFhek515zssuHbpXn6YUWh7zdWozP3XwC	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	1397	828	136	6301	6652	jxFLRuN96mc7umTaWzVfVpYXRMMmsYfty9gzydDgq5L9UnwQR7c	5269	7416	7416	1617274080000	canonical
10169	3NLagyTz5vYmpXop8rqPNzpdAd85xBpTgNirf96VStYsiwXwCPBY	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	43	1064	136	6301	6653	jxq7tBQpWGZpcVLVaUDjnmfg9t3QU9PKCJ8mUGKQysxGU1mBR6o	5269	7416	7416	1617274080000	orphaned
10173	3NKsP1kCBDXCiWTAtMm2gMvgMUqyMtzbtPpkQwnzHdmrsfxdodqm	10172	3NK53RunohyQasvE5o7iQtbMnoWsCb72it3qemSK9hJn4FAa45Z9	1553	776	136	6301	6656	jxBRoonQam9VW5FxhukoLqb8i4You95iHZr52pPj1L5y8qzoSFh	5271	7418	7418	1617274440000	canonical
10174	3NLfVjuwNDsBrStJYeCCea2f9mi2xUG2D2JFubYMhD3h8q1LLLp5	10173	3NKsP1kCBDXCiWTAtMm2gMvgMUqyMtzbtPpkQwnzHdmrsfxdodqm	1403	824	136	6301	6657	jwc5mHFzKurwoaNfhLBUnxtyXGaNZog3z2jsiDmTBfa337JTSWh	5272	7419	7419	1617274620000	canonical
10175	3NL7ytbE5YPWtyv8eg8pWy75bYuAiHJJgCWYdSwVUYcZuAP1hypa	10174	3NLfVjuwNDsBrStJYeCCea2f9mi2xUG2D2JFubYMhD3h8q1LLLp5	1534	1191	136	6301	6658	jxtgENMyMTpShmGkXHWrFQ7pXm8zrvi4THt8X27JAkUxY9CmVW2	5273	7420	7420	1617274800000	canonical
10181	3NLVShmQggnigHStWFBLCR1zbwwKUELfS2WU1oefqFDxZvCQtCmq	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1608	1043	137	6301	6663	jxZPPKAHripoqtMqceoVx3zQW9Jdw5sAUS5rgfwJDxpu7xLnjao	5275	7422	7422	1617275160000	canonical
10185	3NLGsZ7x8Yp2wnJiMTNRSxy11oA3QKQs754QxWorPqFPptywZeek	10183	3NLXVh1dP2mhTW7neiQbDAzsRANQUPN9bdCVuWz2P43v9hDmoVR5	1422	1091	137	6301	6664	jwSCfLtq7UJVCSFFRZg594ueh4f3Gq76V8VGnKbCLjqnFqwZDju	5276	7423	7423	1617275340000	orphaned
14252	3NKjJHQWcrs6X9e1vGXZtBfduByqCv6i3TMrXA7tAZdUQNmXxzwV	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1490	1274	220	6301	10376	jwzaNgVvNm8acJqXJYWxPj5ScCjyb7FwEq8Ybnv9BRcynxJpqE9	7277	10296	10296	1617792480000	orphaned
10090	3NKN9mKLHRH3Rxhw1v9cMzwzmJpfxciYGMx9Ekn9uFQWCqAZMgdk	9968	3NLLysH3sXhCzT3adv27SbLXZvCD97XTbxqsNHNgjaXDz2m1eFUj	1578	1296	131	6301	6584	jxV1tG39tCQWSN7o9cWvhQ7jwP1HFRsip82RUkkuCUge91GZu7r	5172	7367	7367	1617265260000	orphaned
10123	3NLqh713pEKqjobnG71unELMfE7o3T2BggJ9XQEBbeJKfA95TxNm	10112	3NKnm3CCxzUn4eSoVet4wBGaYqdJnYnm41ZRFwVDFkQYNXrR94hv	1646	988	134	6301	6613	jxcQCmQ7JBSdkv4VYQuhphnc5pN5Ng9RE6MRSDFj2jUaXhfXPUX	5210	7395	7395	1617270300000	orphaned
10093	3NKgTM3ZkTM3DhBGe525zuyTPU28D5UWKF31Bxao27u83oowdwGg	10091	3NLSXyDJmqKt14TtCQGz6vFbamcyGFBFMkStL2BUAkQ5yJKScxWF	1542	1304	134	6301	6586	jwtLJ6RaMXQHZKEBQTujwyfn8rAatVdDu7bjRXPRJvKa8YGN4DR	5236	7370	7370	1617265800000	orphaned
10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	10102	3NKTbP1n21KZtji1AL2a1zE8iHqNWzyERYFnwaYNjST4EVimSsaU	1444	1381	135	6301	6593	jxH8qoUm33Ph9XjWSEipKZ4rZRYtzqrcLFSjByLiyhSxf6Txy1s	5242	7380	7380	1617267600000	canonical
10106	3NLKZBQ4fBgawEybhsGAurUsxj4UvboXpwMCcHpx4cjYVdTYWzvS	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1476	1005	135	6301	6596	jxyULSMBsva1xeoD81BqSpQPzsS1tzPsia4VoTVx8rB8eo3YsQ4	5243	7381	7381	1617267780000	orphaned
10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	10109	3NKzk4F3PhyhXm2MczT9h7pQ6WDKW7f7oeEjNiV5pjsgqorKVDgN	152	1084	135	6301	6600	jxcjyZU6N1Tui2eSyQRjvkpwpv35WcZLV3zwQBs5r4Vs1w6oCoR	5245	7384	7384	1617268320000	canonical
10115	3NLJnw4RnUhw9MVQPpbp5wB2wWtekfJcA62a4XtZeJqdGnadaZWB	10113	3NKt8K5LsVaCyYUWWcZkTVYzUnRvvdKMYHEkwfBYzPGErsFUioMV	1553	776	135	6301	6605	jxgQZtrAAv7yA9J6jQzdLYssyATSw78LFyhXfbeCaiFeDRCCmcX	5247	7387	7387	1617268860000	canonical
10120	3NLSGHHdn1RzdAPMqdPTA2uZfUtzVzCskxHCtfZDALtSYUweWAtF	10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	1585	1120	135	6301	6610	jxaY49kWWzAVM1FdLwU78iLACBwUuuJiVxo7KHLVKiWHnEBaMGg	5250	7390	7390	1617269400000	canonical
10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	10124	3NKWSr9qmsXFdfN6Bkms73EefPbob6YQu48o6qTBJpqsSRHipRYJ	1403	824	136	6301	6616	jxgFj1hezFmvZk9SHNPrtisZR1UJF72AfftPfu4GeJcEthmtpdW	5253	7396	7396	1617270480000	canonical
10132	3NKyKnLM3NVnEEdHGhsNbJJxwvdfaDQvbZhAX2Z5T6aaqfzZGjVW	10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	1426	1364	136	6301	6619	jwKjBum9djVLvKLfmdRVuptjg5SfCpFFksLAFUhysAt6JCW1nXU	5255	7398	7398	1617270840000	orphaned
10134	3NKMtAYTfSgvXqDfWxxBbKiZ3aZZHXB43A4WcjQKJwBZ5Dqi7HxK	10133	3NLYDijrUhct8xE6gWEBHY1NbezLq317ARV4AHaZEhBPw7FuvRMu	1490	1028	136	6301	6620	jwtggDfFqcaagZXdLsoogWTwocGNVnRyjJNgPw8RzpJ86Fnf3NB	5256	7400	7400	1617271200000	canonical
10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	596	1306	136	6301	6631	jwX4Cx48hynG5FzLoeteoFPTFCfawSJZcVN9gNQkW8KEtBdm2i8	5260	7406	7406	1617272280000	canonical
10150	3NKHAVnUtuQfzLQ8XmTLh5fsbof8eqZHq7ZxBuoH9zkCzbKKJWvf	10145	3NLE5Y3ojLCqegZZqDhzqMxohJJa9JWhyWXqTkak2Dx8zGXEigRG	1406	1393	136	6301	6636	jwzBjwSk1SmiCsYq3vZH5KdxDsM4CjvKmHUNvfoVdYDMyrGzYet	5261	7407	7407	1617272460000	canonical
10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	10153	3NKDgUgBPm44k7hGFtEJMbTHEMTuxfiXZVVSFa7BfFfYtrTyNrYY	1610	1314	136	6301	6642	jxTdnmnjz3hm6eKy7H6opDfQF7AeRRqyh82SPdzbUUBGs6kg2Qi	5264	7411	7411	1617273180000	canonical
10160	3NKTGF57B55vJ6TknWUYEimrbVxDaVhgH89jVcnRpw6fbA1PUZiu	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1429	510	136	6301	6643	jwRdxgzPb8dRNYgb3491FTYMG5Uz6KU52TZ3qxqVvjrK6VKr71g	5265	7412	7412	1617273360000	orphaned
10161	3NKzsUJJZ6jhCWo55ZAWQTB7kh9SZraG2ygWECGb4ZZ7yPDcp1D4	10158	3NLLAhAB3bzsHtNMz1SNmTTv7zdFD65dZxrweMB9HTX75envkC3d	1593	1346	136	6301	6645	jxDqA4VSmrdpPqMgozAYqHTzfjXNuyNSPeRXqBYWfV8RiWriF9u	5266	7413	7413	1617273540000	canonical
10166	3NK6wJfxGKHCmcH19LzAwrzq27zPhLHCuFaBVANPBMnuz3LJ1gRs	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	1534	1071	136	6301	6650	jwSD7baHirKdsUzbeeDJLf6EXUD6oe1zEKVQidozLhPFPdpcHZn	5269	7416	7416	1617274080000	orphaned
10171	3NL2BbbwJrjTTWsvwsGGgzS5HC1UU7wLfPrTtjZi5Js3n3nHNQvG	10168	3NKQq24oF3J87irV5uWSFhek515zssuHbpXn6YUWh7zdWozP3XwC	1602	1243	136	6301	6655	jx3d5kga4hpkFd13UhdTxjsLqgGR9PrwFx1P8AUazKkt3SSCtDS	5270	7417	7417	1617274260000	orphaned
10176	3NK3jDzTPy2RAtedg2eitoaKXG8bvvXJwJMBgbfqv4wooAgVrZBb	10174	3NLfVjuwNDsBrStJYeCCea2f9mi2xUG2D2JFubYMhD3h8q1LLLp5	1419	814	136	6301	6659	jy13UZfrQipxoJX1wEgV1TQaDqyj8QJfxNQAyga34MTiqQTzPdh	5273	7420	7420	1617274800000	orphaned
10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	10175	3NL7ytbE5YPWtyv8eg8pWy75bYuAiHJJgCWYdSwVUYcZuAP1hypa	1405	867	136	6301	6660	jwgbJozCSzEgAsfhFjfuRodngtvVRLejBfjENvkrQz6GkFHKFr2	5274	7421	7421	1617274980000	canonical
10182	3NKjE9NvJUAS1oXo82KwJ7D4TSJyn6mRLUrgwDHSUAwxWRGURJgA	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1435	665	137	6301	6661	jwSTwqYWAF9o8jXfmTXn5ymbmJ8LBkXELLPVyDsHQ5ihvtuz4bF	5275	7422	7422	1617275160000	orphaned
10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	10181	3NLVShmQggnigHStWFBLCR1zbwwKUELfS2WU1oefqFDxZvCQtCmq	1422	1091	137	6301	6664	jwSCfLtq7UJVCSFFRZg594ueh4f3Gq76V8VGnKbCLjqnFqwZDju	5276	7423	7423	1617275340000	canonical
10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	10190	3NLQ9bCd7JKkN2bR2gteVm8HYj6WrmQF6aQvaNRLnaZdUs7pSD3J	1403	800	137	6301	6670	jw8eShP4G5ZEi54hGLRi5qfgVFLwgnrQgYcQZxkpKrrgVnZM6E9	5278	7428	7428	1617276240000	canonical
10191	3NLodCVyJJvRmY8BbNPVURMw6sTm7ChjvPWFEH44CTjZQtZ6dhwS	10190	3NLQ9bCd7JKkN2bR2gteVm8HYj6WrmQF6aQvaNRLnaZdUs7pSD3J	1609	1207	137	6301	6669	jwHqGkWJFhhvjHwbnpcXT8PS17ot8yQyAFjQ5Z4GKZYznuC1MnZ	5278	7428	7428	1617276240000	orphaned
10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	1403	824	137	6301	6671	jwoDhryyNSUpg2YeeP8xah11WU17N9xYfQ8Z48Hw7YEL9m3pMYh	5279	7430	7430	1617276600000	canonical
10197	3NLpMsyHLfDSVqHttPndJb95sJTjxwqJjsrX87ViAsuqUu6o7vr6	10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	1670	1282	137	6301	6675	jxmERLuBS51uu7UPrfk8XE88UG6AvtYJR7pcPjhAmdHK5qfFtMd	5280	7431	7431	1617276780000	canonical
10198	3NKm9etuQaHXNDMXxF4uxxoRtXeZVdoMbdeopgZhbfgPjMonq9X3	10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	1549	1116	137	6301	6676	jxQ3VkNE2sCKSfqfrSktkyCHZs8PaaTxmHhjgjFFqJa5Lxq8yp6	5280	7431	7431	1617276780000	orphaned
10202	3NKtfsUneudZvc81UvK2wqFbtSuF92jeQ32ctZtzE9YyXvdE6YTn	10200	3NLF3BKyG84NTuFd95UQrGjiXj3a3fnj6mUE4GoAKQD8XNwMrM1X	1405	873	137	6301	6680	jwQKJKUkyaCpZ9CLDYoPxhUnFRc6dmsKYXReEvtxcVdDvuFzkUn	5283	7434	7434	1617277320000	canonical
10204	3NLEkyeRftSRZX8ZAnr9jxUjRyNPrbjP8eVmp1p6WUPw5okTAAun	10202	3NKtfsUneudZvc81UvK2wqFbtSuF92jeQ32ctZtzE9YyXvdE6YTn	1534	628	137	6301	6682	jwWD1pySRnnb6SBCNygyKuT5B5AepZMWz3oZv5ENVsgNPkNFWiG	5284	7435	7435	1617277500000	orphaned
14268	3NKunZoGnXiB9MfrFUMqC68L83iPVYRWo5buV1uPBxk56ePrZnjz	14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	1422	971	221	6301	10391	jwz79tLi78LLCFgyF4YkvbVkFEGZ8UiHRSEyVNt4Y1V5TRF9qjX	7284	10306	10306	1617794280000	orphaned
10211	3NK69hps4Pazp934xLiAa12FizAWScAq25Dja5p2wrizsRzJev1a	10108	3NKG71X6Ch1cRCHM83NGXY6DWJbZv5Tpf46698WKzXB1XPYYJHP7	1637	816	131	6301	6689	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5173	7440	7440	1617278400000	orphaned
10222	3NK3pRiUrZhyvSakaNM88vMXP1vHJmmrCJasFxbpZW3bRTEH3vZM	10211	3NK69hps4Pazp934xLiAa12FizAWScAq25Dja5p2wrizsRzJev1a	1637	816	131	6301	6699	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5174	7446	7446	1617279480000	orphaned
10119	3NLpCdw3ZiyrE1362TSk52D9UZ7KLiEQn1GANBKD2nvZ7V4TmGrv	10117	3NKCVx7DnCCDY2pC3UPxjuPwD73SsERsgdTbx8LQc9MpJhHe6kY8	1406	1393	135	6301	6609	jxuuQgX9FC2Uk5HciE9pTUtaTQfrNtfTCLmHCqKsmYM4PZ1dwnS	5250	7390	7390	1617269400000	orphaned
10129	3NLh2Xz3wPqa2fmiGUWV9dQPSDBMknagasWtzUoeGXwcLYk9cmeu	10127	3NKa3mwnNFT7DkdC4zwxxAhCqHyj5ChQ4Js9hykrnVDXWagH9ejk	1426	1238	136	6301	6617	jwWyMCrvnUy2Dx53PDW6Y7xsWaBtKtk6e73tLkMEyWri9PUDzUj	5254	7397	7397	1617270660000	orphaned
10131	3NK5F9q9Y5CkSaifrDEeGfuESzGa9cK5Yo9snLJbH8nwh9SCuk7s	10130	3NLJxtkcp2m9sazyEDucVoD9pkTFCgxuGrqpKoCWPB9rYXkAaXw7	1426	1364	136	6301	6619	jxCjGJeaxCbmhEdygr73D944pkAqbGWcAYGKiaztDpChW9mtRAX	5255	7398	7398	1617270840000	orphaned
10136	3NLvvkc7fvkwMNWn6tWzczgGNjsATauRhcrmMcUPqDwfrwLK7i5M	10134	3NKMtAYTfSgvXqDfWxxBbKiZ3aZZHXB43A4WcjQKJwBZ5Dqi7HxK	58	1281	136	6301	6622	jwhMKFZ76tkyMhWaUnUAtapLnRyEy5MRA1DjLGbkzYckHXGqXjy	5257	7401	7401	1617271380000	canonical
10139	3NLbyA9bX4sPMYh8zh15mzbtyd3chj6qnF5KRVqekGZnQCF4qMo8	10138	3NKLUz1v6jqP7Gdfmyi4ezft6PeDg7giXcZZRukyb2HxtnC8iP49	1397	838	136	6301	6625	jxWKmvz1ydJpP9ARFPgEabLok395XfhVBjGPc7tiKyDEj9jC1Kk	5257	7401	7401	1617271380000	orphaned
10144	3NLyPqQYJacymWZg1iJVBX8veyMAC9kUuBteEUcCjyYBvhRdb42b	10143	3NKuZobJAQRX7rJ3jFGa6F5xRjf5Majy9JkBgQq6SH7hgBRfLm4k	1407	1395	136	6301	6630	jwmfPWomW3YtsLugZm7JCvjbPEsD3tDzb52AsfD9Ws1JPNciLVh	5260	7406	7406	1617272280000	orphaned
10154	3NL5oBAnXZqxQ4vGef5osqsXUp1mB38HpVRHLDWMMMaKMB1Xi9e7	10152	3NKbSEru6XvEVHpuMkvekAUtax2NSYP1X539PTFMgbrYfxkpGFXb	1458	1323	136	6301	6640	jxzNnjtk5wKNNJnAnjdEb27EjwSqa8FsGSK1y7EFcsB9XdKTQ57	5263	7409	7409	1617272820000	orphaned
10155	3NKEXehkgKPk8A4Rxe2MMaQf2etC1eXA6ymBAqAYcrW2LmehGg6W	10153	3NKDgUgBPm44k7hGFtEJMbTHEMTuxfiXZVVSFa7BfFfYtrTyNrYY	1460	958	136	6301	6641	jxdKzXPPjJae5Eat5Q88r6L1jMavegN9NDFT3GnYM9RLJNsS2fJ	5264	7411	7411	1617273180000	orphaned
10159	3NK95PSQcdZyfiEV912niRrjHf7qWoVcjUDot3xYu1oXvtY5GPvm	10156	3NKkDoU9ND7itiaAMYnVgkehoRpqZ6EBFBBb7GS4Dr3s66RdPW1W	1429	510	136	6301	6643	jxUKh8WUWNyUVdu4StKz3jcUZ3dw5vDUYuk7D4x4ggwmVqFQPed	5265	7412	7412	1617273360000	orphaned
10162	3NK82htdQnjd7UKRMQ4mkeT4ArGsNYDce6XfxMxbRMDzMbRnfAPf	10158	3NLLAhAB3bzsHtNMz1SNmTTv7zdFD65dZxrweMB9HTX75envkC3d	1406	1393	136	6301	6646	jwZ8ufhsxxQosd6m94PHLjdytnyfFfn41Etpk3idmUQhfeA4s3h	5266	7413	7413	1617273540000	orphaned
10167	3NLea2USdEqeboBeQb2aBti2H29Lg7giNHhMtcYuNUvFxKTNXS4J	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	42	1361	136	6301	6651	jxSEeq8ReM7yaSWc8hQ72RYBEx2zvD6akCUA7jdhLbqwj39iwBE	5269	7416	7416	1617274080000	orphaned
10172	3NK53RunohyQasvE5o7iQtbMnoWsCb72it3qemSK9hJn4FAa45Z9	10168	3NKQq24oF3J87irV5uWSFhek515zssuHbpXn6YUWh7zdWozP3XwC	1602	1243	136	6301	6655	jxioX228Z2hYn4Cy4ov8aL3R5qB7o7kHiQ8VNGjsUdaxXY41rad	5270	7417	7417	1617274260000	canonical
10178	3NKvZWayuja9fkwxfzT5QNaPiGFpQRb8tejsTkbq2g4ZFfoBwpD7	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1435	665	137	6301	6661	jwSTwqYWAF9o8jXfmTXn5ymbmJ8LBkXELLPVyDsHQ5ihvtuz4bF	5275	7422	7422	1617275160000	orphaned
10187	3NKRy13kEa1B7rq5E4ZvbMHf3Tx3op4GFwwT9K2QNJVs3uKv2Uhb	10183	3NLXVh1dP2mhTW7neiQbDAzsRANQUPN9bdCVuWz2P43v9hDmoVR5	1623	830	137	6301	6665	jxAf1i7n6Zymqq16Ej81D2L3uL8ny8R6wBNS6EmoTFx6zEgUfCh	5276	7423	7423	1617275340000	orphaned
10188	3NKAGeqnZR4BNYiLekCd4dGjpJv9zTzKnkLYRbGRd4VYrT4tLBxm	10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	1593	1346	137	6301	6666	jwoYBHRnEeSussBBfAV5zz4dDHKoL88YMZ3HLJXyL9bcxC2dFo3	5277	7425	7425	1617275700000	orphaned
10194	3NLfvChFTnxZc3y9S4cAEuKsbErFHqqnMngXQuSBvmbxmk5CVRza	10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	1581	778	137	6301	6672	jxHfLw1BbQ5RSbuQRTKfAWQYybhFRAMbd6BGbfCvHQzyC3fQsZE	5279	7430	7430	1617276600000	orphaned
10199	3NKe1uKsh49G4iiQsM1cHzM3C3y97m24JetuE1MewT7aFjWka5PX	10197	3NLpMsyHLfDSVqHttPndJb95sJTjxwqJjsrX87ViAsuqUu6o7vr6	1407	1395	137	6301	6677	jwvmuw7jCTpN2fxi8UUGGnkNthxUKX28dKfJ1UBXUUV8H6aRcMT	5281	7432	7432	1617276960000	canonical
10200	3NLF3BKyG84NTuFd95UQrGjiXj3a3fnj6mUE4GoAKQD8XNwMrM1X	10199	3NKe1uKsh49G4iiQsM1cHzM3C3y97m24JetuE1MewT7aFjWka5PX	1402	906	137	6301	6678	jxNVa6Z2XYcG1bLzWbUk24YvNGFAXFKdfm4jfBBZemeimcBxjNL	5282	7433	7433	1617277140000	canonical
10205	3NLWQCJXPNmxmSXTrwnFnipv5fDAy7LcwVuDfDbdWuyzX5L6XkEF	10203	3NKHGorqt2x7BaHb2dQvURSBdR6KNzrrV3eeUjVPidtd66nZ2az2	171	1374	137	6301	6683	jwETt9vnpDmbf3rz2gqZB2uU1aANR8Z8cY36WTTzFwYT327pg47	5285	7436	7436	1617277680000	canonical
10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	10207	3NL7VgMAGanneGj3DGQvM5B4jqqYT2VVXjSJVQ2EuFmzMDeezsTu	1609	1087	137	6301	6688	jwRpihRev541KMzZdna5ejpVdeTe6EikfKfBR2uyd4h2HPMneXc	5287	7438	7438	1617278040000	canonical
10209	3NKccQPsBwdmB9rchMLTZ2u5rR3aijPYUUaF9eNw3qGNPKSmbjB8	10207	3NL7VgMAGanneGj3DGQvM5B4jqqYT2VVXjSJVQ2EuFmzMDeezsTu	1602	1243	137	6301	6687	jxFeSHHBc1vG3GrFhmQhPStSsfsBjCamG4FGsJSS2yJGamCNv7T	5287	7438	7438	1617278040000	orphaned
10212	3NKutKS94KKCcq1swMDYuDCwyMk8Z9p4wdEHucm49kkJNyFo1Sv8	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	1527	1293	137	6301	6690	jxaG9MKPs7gs1xm8kL2pCdvVv5noVRELGSu3enRqVAH8FNUutjS	5288	7441	7441	1617278580000	orphaned
10215	3NLRzzMW2ALXGsd79oUWHjgvBQoo1ibcn51KyxdanFNbPb3f28Lz	10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	1656	1097	137	6301	6693	jxVyLRYdcW9o22DpaGVXRrDMyNWRepBadpTWBy7sV1azdmJzbhu	5289	7442	7442	1617278760000	canonical
10216	3NKnv55KHQcJZDakN1Hvm5ycHAn63RgnohZkh7MxWrwMDEoHeHSg	10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	1500	1297	137	6301	6694	jxcYjeUEbvxzBmX4M6GCo89TB6Bbee3qMjPYUtZo499ETzQiWbp	5289	7442	7442	1617278760000	orphaned
10221	3NLJhc34fqd86Y9TFYxmZWuDTpyG8MGUf9dzJuRUQxkUnmJHa8jG	10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	1623	839	137	6301	6698	jxHgNd6egE2uSo6ezzCRhyxLjzMJnbzPcKyBbz24SEz8qvUmPe3	5291	7445	7445	1617279300000	orphaned
10228	3NKhWXiRoQnK4tr4fyv698oLQ6gcURWFpy3XHvLCUwFj5Z6Nrb3Y	10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	171	1128	137	6301	6705	jwFHmemvXeQEmjvuMARUccrn9XSm67UfpnEoCB9L9Wz3ewaqAQw	5293	7450	7450	1617280200000	orphaned
10229	3NLGCuMsdbnmd4zeJx8Ne4VRQv9GgixpRNsrB6i2Gr1NqN5z6kgH	10226	3NLJWaMvFezMA1s3RoAZ57DLJG352RAfUbtBH7ZkKhFNDXe9XLwa	411	411	137	6301	6706	jxRWJPDXirSdoePgH9ExFGD6Czp2yzbt3LbZXo3iW7qGmpDsyMz	5294	7452	7452	1617280560000	canonical
14712	3NKE2aTTB9a7sBVpamfyEnUQATHhWjC5d6inV2Ku5oVeshuwSJy5	14444	3NKRhPKew1azQU7aX7hauWZgU1Hpf7yXxAeBhQQ9ygsETnuV5nYU	1455	966	221	6301	10799	jw91r539jwan5vraMi7aZ6r7AxEFyy6TYaUb3e5SVqMmM3d1p5a	7290	10612	10612	1617849360000	orphaned
10236	3NKqjf6Fnjdn9ZWbshxm1hCqNxCiRwCGnWMURsixQVDQtUT7YvjR	10222	3NK3pRiUrZhyvSakaNM88vMXP1vHJmmrCJasFxbpZW3bRTEH3vZM	1637	816	131	6301	6713	jxyMHb24VEpieT5XyFTd9u7CJAa6TTgvSgRRcbeQVGgJyTHWGz4	5175	7456	7456	1617281280000	orphaned
10250	3NK5HmrRd4dvADZt5sTWhtAY1RXxEL5nX3TBXRZAcwSvnBtkot5W	10236	3NKqjf6Fnjdn9ZWbshxm1hCqNxCiRwCGnWMURsixQVDQtUT7YvjR	1578	1296	131	6301	6727	jwTTWVrSUyj34Ww7CgNrp4yN8AkWnTvVfEJJkBLqXTPb3zwh3QD	5176	7467	7467	1617283260000	orphaned
10179	3NKFgztRuVqsCa5sG6iXzzptoQyykfAKUhaP8nuAFYkoYx4tC3Je	10177	3NLVcjXW6Vibif3KS9FqwDqBSbdmCWe7Hs6NfPqpUysQ8ySEewDZ	1508	1141	136	6301	6662	jwWsqSduV19SSP2annGdHTmRTtkPZCB8JpR7REykabbTZeiWRoi	5275	7422	7422	1617275160000	orphaned
10189	3NL4p3EgXGvRSJ1AYYxUkSaCRL8ncvqu4PyufVZgDMDBiyPjSPwp	10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	1403	823	137	6301	6667	jxnBiRgxArwb8n6gQPyMJSXNaf4tP1G3zTCi2kbTMYkRSQPTRed	5277	7425	7425	1617275700000	orphaned
10195	3NKQYrJqchuKpV265V9UkGiUWAQQZ55DmmAgSw8Tth44KmdUquDQ	10192	3NLPchydZboRba7b77yF5cRE4FsMaXrUnrgij5kZvjktRtpRmwoj	1573	1072	137	6301	6673	jwN7C2hRuDYHcvsqJRAdLqub1B6qoRbstf8CTFNHYcMD6HzBCzC	5279	7430	7430	1617276600000	orphaned
10196	3NL7KBV3KRvzFY4Q2nurvKTjSvDN5tRhAK18fjQ3UQDpdVBhgCwT	10193	3NLh8PDr6ff6rFNg6UThF3yxeVUsxL71ZXSsKiorNnHvmu18KQyS	1542	1058	137	6301	6674	jxxK1hYydkXfkypTD9LZczqcdUz89FxVjncoLcn6tzLf5D3BMu9	5280	7431	7431	1617276780000	orphaned
10201	3NKMWpHmHUDgCQPVmZM3FJf9B2MLZhwWz1LmzqgEefjPTkrHruPa	10200	3NLF3BKyG84NTuFd95UQrGjiXj3a3fnj6mUE4GoAKQD8XNwMrM1X	633	1018	137	6301	6679	jy1f1sS12vPDiAc7Zu3mQWUj7TNWth1CxMi2bYNxYE8io5sxp3j	5283	7434	7434	1617277320000	orphaned
10206	3NLQs6hH8CZsRe2J7CC1Sv2UZVsjXmybnzYmQGjaYTGSPHc5dMpc	10203	3NKHGorqt2x7BaHb2dQvURSBdR6KNzrrV3eeUjVPidtd66nZ2az2	1477	1350	137	6301	6684	jxBBcUUu73XmXzGRirhDnJqfs7z8T912HufoAcHECg9dpBbFpPC	5285	7436	7436	1617277680000	orphaned
10207	3NL7VgMAGanneGj3DGQvM5B4jqqYT2VVXjSJVQ2EuFmzMDeezsTu	10205	3NLWQCJXPNmxmSXTrwnFnipv5fDAy7LcwVuDfDbdWuyzX5L6XkEF	1596	1363	137	6301	6685	jxtz3FZ5eAiCpNPkpjCJe1QERYKrTVpJ17EfziRrGjHJxtF98Pb	5286	7437	7437	1617277860000	canonical
10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	43	1184	137	6301	6691	jwivBwEPJRobt3Ff6txuHeWNvAu6ZmKddkMH6Ef7YJnWybKZonn	5288	7441	7441	1617278580000	canonical
10217	3NKp375co18gjPmkfka9jaDAqv3qniorsofWbtkZB75FCramfQgF	10213	3NLqykKZP2aFqYiZmWnEodD3994kMDdqNTEMxrBTgDcu4XDtHKdf	1500	1297	137	6301	6694	jy2xGqu56jRKHKHZXf6RYv6xx1ep88VQdfjLjVDByL244MiNJ7V	5289	7442	7442	1617278760000	orphaned
10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	10215	3NLRzzMW2ALXGsd79oUWHjgvBQoo1ibcn51KyxdanFNbPb3f28Lz	1483	408	137	6301	6695	jwBjUtizVsSgUzm26CsEDdM3ArwCfEhhNgaJr82yemyvzydUXyx	5290	7444	7444	1617279120000	canonical
10219	3NKpbVK5uMrNKGNhPDAD3WCsyXr17tFb2794WdWG52HkPZ9wNAbV	10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	1611	1341	137	6301	6696	jwbPyzSuSkcX5K2AfF5dVPnAeysbrQXmdU1FebWTMoaAeRES1x9	5291	7445	7445	1617279300000	canonical
10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	10219	3NKpbVK5uMrNKGNhPDAD3WCsyXr17tFb2794WdWG52HkPZ9wNAbV	1405	867	137	6301	6702	jxsAihdEiG9iwobpbiYYs8PzJDjehJn2EpT71n1maYbgFcSPMfU	5292	7449	7449	1617280020000	canonical
10224	3NLThz6QzoXjK4grzsLWPdbRpF9GyJTqwDQ13sJvmtDQ8Do5SK68	10221	3NLJhc34fqd86Y9TFYxmZWuDTpyG8MGUf9dzJuRUQxkUnmJHa8jG	1673	1242	137	6301	6701	jxqxiraAT3NYRT9tV12UY5N4iZwnPkLdvXUZhZthbmg49xv1wii	5292	7448	7448	1617279840000	orphaned
10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	10229	3NLGCuMsdbnmd4zeJx8Ne4VRQv9GgixpRNsrB6i2Gr1NqN5z6kgH	1590	1300	137	6301	6708	jwtjQY4jrdVXLHctggY73LytPPZ4egKAYRDyhGpCzXMnEDqruFG	5295	7455	7455	1617281100000	canonical
10235	3NKPoqbFNSXqcaTHi9mWGxpa3uzAKcviatuDUdNf2Fbj6kU5iNfL	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	1652	1069	137	6301	6712	jwPWF5xcVxhkVh32E4WbZqrxy69QGHqbcfwcjvRTPMxZopyA2su	5296	7456	7456	1617281280000	orphaned
10232	3NLM5gt9YA8WJC5og3yCC2r3BwKctawU9VZxEcXdZh7D2V4495gr	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	1656	1097	137	6301	6709	jy2irHR7Q1H6xxvr8AvFqsL9RVL6San6zwhX3fgG6zsZFbue8vv	5296	7456	7456	1617281280000	orphaned
10237	3NL53HX7S2nnDF9mU9d3jBguAeCeeAitF4Gmqy6piXs139d7Fnet	10233	3NLC9CCNaAUVC56qpNZxApYnbPdtWrqBTbboqiMffvhzSVLevtt6	1467	1130	137	6301	6714	jxk2Gj5vN44punU4TwDCA2KKWvq13Pcs7pU1muR5HcfBfR19QyK	5297	7457	7457	1617281460000	canonical
10240	3NLjNZSBjUR8eBGKY7WBRUUdV73LoQCa1QcCw4GLLwyJbLxSgxZd	10237	3NL53HX7S2nnDF9mU9d3jBguAeCeeAitF4Gmqy6piXs139d7Fnet	1673	1122	137	6301	6717	jwLsmgRkqjNsibvTwVJdLAhrR17LQGHrq3q9sXXxyZSLJfFcq3Q	5298	7458	7458	1617281640000	canonical
10242	3NLNeikqodLz7Ve9Y2WPKYJRz6jj65erFNSnJgHePNqhPBk3vsxb	10240	3NLjNZSBjUR8eBGKY7WBRUUdV73LoQCa1QcCw4GLLwyJbLxSgxZd	1407	1395	138	6301	6719	jw9b5tzPm6b1W2WLf2bVNXKbG9opWiseTA5Q45JY87SSLr4piWh	5299	7460	7460	1617282000000	canonical
10247	3NLeENBf1TCP1jh18o8q7v8Jd4BK5sgUNMM3g1KurDRaFsyW6wVh	10242	3NLNeikqodLz7Ve9Y2WPKYJRz6jj65erFNSnJgHePNqhPBk3vsxb	1419	814	138	6301	6724	jwvMZ4wNayfVat7cwxGkbTMgkSW9CzxzMdGLuxXTLCRXc18LxdW	5300	7461	7461	1617282180000	canonical
10248	3NKPKTFNabW1VLArNWKPQxzpVZXxJvMKzbcUt5J9uhNzEPqRdFRa	10247	3NLeENBf1TCP1jh18o8q7v8Jd4BK5sgUNMM3g1KurDRaFsyW6wVh	1599	1041	138	6301	6725	jwmz3kcvWkJQrqVyMksN9kL4neqgVUUueeEqsCfL7F8yAVarvC9	5301	7464	7464	1617282720000	canonical
10249	3NKBGbLN3m2c5TFdJNf5X1ZHvJ7dfriXLYZ6CTo2wWVHfWyQpurG	10248	3NKPKTFNabW1VLArNWKPQxzpVZXxJvMKzbcUt5J9uhNzEPqRdFRa	1608	1289	138	6301	6726	jxQT1woPqDzy3WpQ2P1zp26wm5vpnGuaWLvdnrBjvRU8cYTRBDM	5302	7465	7465	1617282900000	canonical
10252	3NKFKbRPVgnbsKx4e9L3jhphSbEYX7phyoUx86JvvMP3RtiLxhux	10249	3NKBGbLN3m2c5TFdJNf5X1ZHvJ7dfriXLYZ6CTo2wWVHfWyQpurG	1507	1280	138	6301	6729	jxmQsgNRB29WR1xeYjpmjcSq62zu5GYvEZqDHeWpcJQAKhjhphd	5303	7468	7468	1617283440000	canonical
10255	3NLssdxqLDGQ9UjLipcwexBGRwE1xT34mPN8UjJuXxK8tXhMDmHM	10253	3NLMSnVMoc5s1wPc3oPg5QBSfXjxjzwKZRPfcr8scxYtMdEChfdc	1654	974	138	6301	6732	jxbcPpDXgdu9wuiu64DyxV6zMCyrQS94ASYWWb9CVtWuo4fx21w	5305	7474	7474	1617284520000	canonical
10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	10255	3NLssdxqLDGQ9UjLipcwexBGRwE1xT34mPN8UjJuXxK8tXhMDmHM	1559	987	138	6301	6733	jxGS5gYo7G9mBoPFXRuhHG2zQQLqnwSyruczG6DVo7NZC2YbueL	5306	7475	7475	1617284700000	canonical
10262	3NLEVovLj6Vv67GdbT9amF1doif9bj6bsZkVi4WNPJRgPze5k8BU	10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	1407	1395	138	6301	6739	jwvUgZujRVLnCYY6rtGF48TcLbqDY9zDLsam3g9UrH79voYP1rA	5308	7479	7479	1617285420000	canonical
10268	3NL66b8xYVgGaRh7aREDuSsCCNM9ZixQYApKYmAaBNFTtwsPYrPh	10265	3NKmKYZ6hAB4zNusAFBVgyjm37gwLu31QdGM5JSaocyQtSRMYM38	152	1084	138	6301	6745	jxHPyJeSGCKGqFxmYEAjE6AUY7DBUFQVkuT8WPhPqZUNwd6LauY	5311	7483	7483	1617286140000	orphaned
14734	3NKBmP2PCFJCiBfQ2vnvC2Nh3Dty1WEKeMsxacBMcMB6X5Svgxrg	14712	3NKE2aTTB9a7sBVpamfyEnUQATHhWjC5d6inV2Ku5oVeshuwSJy5	1455	1332	221	6301	10821	jy2hMDQmD4F8VvYfBnLGZScvVWvCMZ2pMb1vQZXhLYAJZm2RqVD	7291	10633	10633	1617853140000	orphaned
10257	3NKoQhQqo2Bb11CitfWg8MQS6GDLfVHHUT68p3ECunFABf9LbFaN	10250	3NK5HmrRd4dvADZt5sTWhtAY1RXxEL5nX3TBXRZAcwSvnBtkot5W	1637	816	131	6301	6734	jwTTWVrSUyj34Ww7CgNrp4yN8AkWnTvVfEJJkBLqXTPb3zwh3QD	5177	7476	7476	1617284880000	orphaned
10241	3NKPvCaNeUZaABAWpCktaXvJhRxV6JvTuDTtLTgaJPwPA2UKUQRU	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1587	319	134	6301	6718	jxPSAG8SSRR73tJjuftN9eWcnsG6ShtXXfdcTASERfNTeFiho5q	5233	7460	7460	1617282000000	orphaned
10243	3NKYPzbuYPwiGDLvq7jXqYZ3jtGRJ4fdJhFabjNciBbMHWT64LTy	10110	3NLwTSMdf7ESfpLA2mjZmoMXv9JgbChiZBND1SzdF6TTH8is9uuB	1587	319	135	6301	6720	jx1JkqjFc1igJiydv3mb41yVs4eZE7JmJpZ7Y8s3QHCWvdPK7ND	5246	7460	7460	1617282040024	orphaned
10244	3NL9Hrcmbu61n2ySDphNg5RcVaMY4ZUeTCh4fWY2c1BUd3rPvJ1B	10142	3NLt7JCVBE3tNcsyXwNsKsZv8CCa9ED7LeiTp2LB3XNrC1LVXyyx	1587	319	136	6301	6721	jxiiBTXT6U4nP82aWkd4SPe5n7wp349LwqcYHy8vrQb12C1Ri54	5259	7460	7460	1617282077613	orphaned
10246	3NLdcVed6SrjYV3SiK3Xk1ztjF7rPHjoDo8mwKgfaBmPpX6P74gH	10172	3NK53RunohyQasvE5o7iQtbMnoWsCb72it3qemSK9hJn4FAa45Z9	1587	319	136	6301	6723	jxAkhRBBZjH7WTctnCm5UNCRZHSwecGkd3xVxyLH34Xroxo5pGM	5271	7460	7460	1617282114664	orphaned
10203	3NKHGorqt2x7BaHb2dQvURSBdR6KNzrrV3eeUjVPidtd66nZ2az2	10202	3NKtfsUneudZvc81UvK2wqFbtSuF92jeQ32ctZtzE9YyXvdE6YTn	1407	1395	137	6301	6681	jxcWgkyCqKRTChXBiRbDqeb87CL7pnPsoJnVzdWDzqjmTPikgaC	5284	7435	7435	1617277500000	canonical
10208	3NLV176Xdqsa8ZvYY1T7mLD7aH4D7CWjhrv86ehiNkDWN91jpGqv	10205	3NLWQCJXPNmxmSXTrwnFnipv5fDAy7LcwVuDfDbdWuyzX5L6XkEF	152	964	137	6301	6686	jxdksL32FLFbwJz5ZZRbzLKdVfgoFeZmgveXjVxB29qDoFP2xTx	5286	7437	7437	1617277860000	orphaned
10214	3NKoZbbm3NB6YY74P1DUoRk8ovdYEzkvueDkYPRvnaXvQJrxDSWf	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	1631	794	137	6301	6692	jxS2DpjHJ2zxprY2WKtewQwsTDPFndmoQXKxfCZuuodpiRAeY46	5288	7441	7441	1617278580000	orphaned
10226	3NLJWaMvFezMA1s3RoAZ57DLJG352RAfUbtBH7ZkKhFNDXe9XLwa	10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	1507	1280	137	6301	6703	jx4uniJLKR3rvMoJFshp2FKXQQ4tQmNk5CBYGKejZijV4r1xMgT	5293	7450	7450	1617280200000	canonical
10227	3NLVYR14ELubWJCLvqvKwcaP5n3ZWPDtY5fAkURtDigTTdG4pabA	10225	3NK8Qx3Re1HwUSTumubuU7gQVah6SorDswncm17MoncaBsAT9wm7	1407	1395	137	6301	6704	jxixhA3c11Fzw5dsUdYsU9B6JMdoUqY6PD6W3PtKzmk3gTtb8u8	5293	7450	7450	1617280200000	orphaned
10238	3NLUWrxbjoWVRZrRKU3dfLeGVwjZoKwywoDzxFU8ajeCCi9bu6Ga	10226	3NLJWaMvFezMA1s3RoAZ57DLJG352RAfUbtBH7ZkKhFNDXe9XLwa	1467	1130	137	6301	6715	jwM8DrwwQ6JKLDtdyfbK2Fgf4dYmNNJKhfWRgJjcVpDsvKdV8hd	5294	7457	7457	1617281460000	orphaned
10233	3NLC9CCNaAUVC56qpNZxApYnbPdtWrqBTbboqiMffvhzSVLevtt6	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	1407	1395	137	6301	6710	jxigELYJnzNNYGBTo2Pq7Qskvx6yHpMHgAtkMUxjs6sD8qXxzxL	5296	7456	7456	1617281280000	canonical
10234	3NLCJpUhpF4yoTv5dMqTZYXwPZ6Sz9abikC27K2dzGkZRGgt9jUu	10231	3NLZhsdA8ccE11HWuaBkSWu9QHuDbdpspRqAJFs7UKUQEDmxbRZD	149	1283	137	6301	6711	jxm4ppooPegcPKSLFT8rxVBJJQgytDBrnNGog4SSvwD3jokvREP	5296	7456	7456	1617281280000	orphaned
10239	3NLXp6FMdiUY6nGdwtccBpWbMzjMVNCuEf1skMwrbMDHLqZ7xrHY	10237	3NL53HX7S2nnDF9mU9d3jBguAeCeeAitF4Gmqy6piXs139d7Fnet	1507	1154	137	6301	6716	jw9C2re12kMMV7iafAzve2FnNni2c4RpWgRvfkWPBkuwirsLTKX	5298	7458	7458	1617281640000	orphaned
10245	3NLiiNaS8ReqYz8MXNoYvShEMp4RQNaL12qhb1BNSqmryjfTeLWS	10240	3NLjNZSBjUR8eBGKY7WBRUUdV73LoQCa1QcCw4GLLwyJbLxSgxZd	1587	319	138	6301	6722	jwmkgiugEkyRtXAAnM1dnvqN9UPqhSfxGiRW3EzsaBh7ww39k3H	5299	7460	7460	1617282000000	orphaned
10253	3NLMSnVMoc5s1wPc3oPg5QBSfXjxjzwKZRPfcr8scxYtMdEChfdc	10252	3NKFKbRPVgnbsKx4e9L3jhphSbEYX7phyoUx86JvvMP3RtiLxhux	1607	1222	138	6301	6730	jx912f9jTRjH8j8sUMczNwuootuTtDmjNWwcTvua2nrsG3kXMMT	5304	7473	7473	1617284340000	canonical
10254	3NKq2GJHfU1EB9NHf3txbQUtqZWcn4FVhGkFeFuN7x2tFyfLNn13	10253	3NLMSnVMoc5s1wPc3oPg5QBSfXjxjzwKZRPfcr8scxYtMdEChfdc	1407	1395	138	6301	6731	jxU3ywTCp5UfexU2mu59o4fjG9QVvCUWPgto1GVUxafodsoKZYP	5305	7474	7474	1617284520000	orphaned
10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	1672	1159	138	6301	6735	jwJGr5RqnsYsCtavKtnCCvJUwrTWXe16qbtqrkJNQ1jykzkY8nL	5307	7477	7477	1617285060000	canonical
10259	3NKYsH6H44fBx2arj3j1xHQPWcFS5qkpJwCXbBvL1YnmWkGEXXyr	10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	1547	1378	138	6301	6736	jwWCsxJB3fMchdFsymcZUv68QesjyPkxPheMegUjtsWquoPa2bS	5307	7477	7477	1617285060000	orphaned
10263	3NKUmYhpRTzzsrZMNfcxXquYicqAbD6MEyTzqsgjYWWgcJi6FnDF	10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	1601	1388	138	6301	6740	jwgrPpsMuJVw2Nvps1WsAUrbCWyTaayn2R4eCTNzwNGVHzA22Xf	5308	7479	7479	1617285420000	orphaned
10261	3NK4CWv6jjoE15tGqr1n9Xor3dGoJj7bkU65WQ2rF94QiZatMWEu	10258	3NKwomemtB9b9cWdvaZfmqbnfdFidH9hFx7bSHeozfcZyvgmN4sA	1457	1145	138	6301	6738	jwHjAbLNhqg6xarxPasPBTLiVyaHVEdzbKd7tqVwNsf5YxatMtm	5308	7479	7479	1617285420000	orphaned
10264	3NKudY8Njv7HJ2DDK4mDPZwC3ETRQZzgdMA8mPEm6ZkZUWVyjCUw	10262	3NLEVovLj6Vv67GdbT9amF1doif9bj6bsZkVi4WNPJRgPze5k8BU	1673	1002	138	6301	6741	jwV8e88DxYXXC8Xoebx3eBezgHuLtFWSWtrUSv3Wh41LfAUuLQj	5309	7480	7480	1617285600000	canonical
10265	3NKmKYZ6hAB4zNusAFBVgyjm37gwLu31QdGM5JSaocyQtSRMYM38	10264	3NKudY8Njv7HJ2DDK4mDPZwC3ETRQZzgdMA8mPEm6ZkZUWVyjCUw	633	1384	138	6301	6742	jx53g5Rxp2Ruu93iu1GNnhDAHninDH4FinAaLqvSa4PRLc7gFcr	5310	7482	7482	1617285960000	canonical
10266	3NLfvChn6dBq6h3hhopVnkUpE7cXMCoay2mertYrDfegEN7t1Xbt	10264	3NKudY8Njv7HJ2DDK4mDPZwC3ETRQZzgdMA8mPEm6ZkZUWVyjCUw	1403	824	138	6301	6743	jwQ1RdeoTSSbBuexS3JCRx3cEvbUga2vwiuAESW9juCNSkiU7xG	5310	7482	7482	1617285960000	orphaned
10267	3NL7RsSYCtnfMcBEKuaNkYQfZHKEdgkX8sZ4z1gPLAFCEfEnBzUo	10265	3NKmKYZ6hAB4zNusAFBVgyjm37gwLu31QdGM5JSaocyQtSRMYM38	1422	1337	138	6301	6744	jxq9oudyKyzDSkHHyvZjkrdL7GZfC2s9Xdkf6xN9VxAgWnHgVHT	5311	7483	7483	1617286140000	canonical
10269	3NKsfsKLMkj6VgENyBRQj85ejVmuKDWMpXWrCEUiwjerAwnrnfpu	10267	3NL7RsSYCtnfMcBEKuaNkYQfZHKEdgkX8sZ4z1gPLAFCEfEnBzUo	1403	824	138	6301	6746	jwBG5LRdxiLiAvPGqpAJ2Sx3abJahcPHpPhWkBpL8YZgeR5e4Bn	5312	7484	7484	1617286320000	canonical
10270	3NKP4HWMSipBx3Ah7CFwU2N7Y9eiN9jL7pNGJT1HN8peM4bMYjGE	10269	3NKsfsKLMkj6VgENyBRQj85ejVmuKDWMpXWrCEUiwjerAwnrnfpu	1671	1365	138	6301	6747	jxLesrq6pSf42cLDnBaPkKUTEZ1R8N8ZjZXNMGoQSK697dTdyvf	5313	7485	7485	1617286500000	canonical
10271	3NKBFhhPMzrvfwri8L7Tvi7QoQnf8crfzGDnBseyXchCjD8S7nFp	10270	3NKP4HWMSipBx3Ah7CFwU2N7Y9eiN9jL7pNGJT1HN8peM4bMYjGE	1403	812	138	6301	6748	jxdHTvXDPWUvTqtLRZ6XfkV2TSZfbgmvW9xJdHgzZpJR9y57RMo	5314	7486	7486	1617286680000	canonical
10272	3NKu8jsnzzudqmKme1NoEhGM4kXvnmmoEkZxAqYqju7Ec2prRswd	10271	3NKBFhhPMzrvfwri8L7Tvi7QoQnf8crfzGDnBseyXchCjD8S7nFp	448	1305	138	6301	6749	jxdL6YCsYMcz8GpVx7dN1tuPjNrQsSf1wnV4NGzkadGKaPPY22a	5315	7487	7487	1617286860000	canonical
14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	1406	1393	221	6301	10406	jxdLaiRDFyvpss9RZBfexuGDVXeV4mWdheqVoL3gREELjBCN5q2	7292	10318	10318	1617796440000	canonical
15585	3NK9H2KePEqLvXckmcuTStCRrPKAZr4vNefNT7BvrQwJdUJLVK72	15581	3NKZYshDe5KpGMqDJAgLEd5Tm2oEHWGyAXLCN9mHdYegHHybqCJS	1440	1011	250	6301	11610	jwd9Bbxc42rQK79zznNumZ9nWEC3CHdm65NtG2nh23KDktkHczZ	7933	11232	11232	1617960960000	canonical
10274	3NLg7yiAcQ3SH918wixFnn13ZToAthswdXkyYbGAZFmzxXZHaB3u	10273	3NL62QUJm879srXtdnVVHzq5YKeUBXmXUcJU935Z2DHBFh3rPtdD	369	1066	138	6301	6751	jwcKicvxf83asL2G98PEfB3xArBBjP9xLiUGKEKwMd2uUnXEgQL	5317	7489	7489	1617287220000	canonical
10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	10274	3NLg7yiAcQ3SH918wixFnn13ZToAthswdXkyYbGAZFmzxXZHaB3u	1559	1107	138	6301	6752	jwWcCnuLnNGFdnLomU9aCM2DEXDwpW4baketQNE4y5is7oEmrZE	5318	7492	7492	1617287760000	canonical
10276	3NKzyYhNQUidd6YwFkAzhdRP4juXvcaePN2kWxmg4HhUKfeatX4s	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1501	1360	138	6301	6753	jwrxoCtArPp3dK62vUZds9iT36mF35jof6thfk2vgNMuaJVQDEW	5319	7495	7495	1617288300000	canonical
10277	3NK4fxVyqcCw8h2qJjcmWvjgfebmhV5JemBjbqr2KPz45EcMTMQZ	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1458	1077	138	6301	6754	jwvgdPRBvwGtAxVL1RyKJ5r5HLrpDRVgfA2xEh4fKjMyYdiVbnt	5319	7495	7495	1617288300000	orphaned
10281	3NLo4ymEDnybcX5f6TjBBm1EZEToT8NoYqw1Gv8M3rS2dxm2AoKr	10276	3NKzyYhNQUidd6YwFkAzhdRP4juXvcaePN2kWxmg4HhUKfeatX4s	1407	1395	139	6301	6756	jxUR1auayGMK8vNv1k8uUGjHe4FRxnLavuunqUi79rEtf5Z1ywj	5320	7496	7496	1617288480000	canonical
10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	10281	3NLo4ymEDnybcX5f6TjBBm1EZEToT8NoYqw1Gv8M3rS2dxm2AoKr	1406	1393	139	6301	6757	jy1yCkvVj5QP4fk3jvaiFeruorLuRcc8GvCr6ynPNqEhEYFMuBf	5321	7498	7498	1617288840000	canonical
10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	1527	1047	139	6301	6758	jxne7p5Jtr1kuJSAapQZXPxcNN27k4QFmT7cDcpDTH1MHrdfVFF	5322	7499	7499	1617289020000	canonical
10283	3NKm95cr2NVmmk4BtDDKkkGXm9vHuyF6ZmcBd7NrsPbQ4UpWizHs	10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	1527	1047	139	6301	6758	jw8cPp11a1oVQ2Q3dMhLdnEQjAy3Hmr1vYtpeYRAUss4Jg2ivzL	5322	7499	7499	1617289020000	orphaned
10284	3NKcNPbe5EcN5HMewFXa6vcY9cmToKYGBo73MKpKGTqjDH7QMJsY	10282	3NLTQUDq7Ryi4xh6sQmBUzA1zrdJZfJzY5KBPHFjy5F69FqM36Am	1590	1300	139	6301	6759	jxGzNKzT2SLa27gLEWfgFbnwW92PrggpsjnkaiPRRhvCiUjYXRs	5322	7499	7499	1617289020000	orphaned
10287	3NLqiknXREb9YfTrkfs8C318hHTAkgcMBRSaYy93phLZ3Cd6RsK2	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1457	1391	139	6301	6761	jx5BvDFLRb8RuRVZVhWnGGyLog9bwDewyXfPKTVqzadoXAy6Sk1	5323	7500	7500	1617289200000	canonical
10286	3NKYVwAgK9c7TogcRvBQFc4L7hCfHXMKXssvfJesTYqXBnJKfssZ	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1599	1041	139	6301	6760	jxGs9JHyPpT1U6LRQAtLgHpnDiTCmiK8Wm7DEfKKGMAeKHubi28	5323	7500	7500	1617289200000	orphaned
10288	3NLTWtSb7MLAjyGnVJCBQSk83QFxsewncsNf1HFt5B2vyLXg42DU	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1407	1395	139	6301	6762	jxtfFFf7B3sZEaVKyvNRssv5GVA7KMi1NgdFKPJcnv7gjWyUUCR	5323	7500	7500	1617289200000	orphaned
10289	3NKgAwhVuYxQ5d7pCyRR1SNmpPt3DpSVivXpt7M4Lif38TBpmvmw	10285	3NK3QKhAgMY5sjLqXrdjiNR7rRdxvLXJsEUNjBHb6M7cwzg46Xxn	1553	776	139	6301	6763	jxYQoDDvmpfsq2QuQJvjV517NZqFY4Q2p8CpB94cUqjpEshynSP	5323	7500	7500	1617289200000	orphaned
10290	3NKpJEZZd7BR21oYGgiXQR31PBmKmx6pVtE2x5c9yoLaivsaVx7g	10287	3NLqiknXREb9YfTrkfs8C318hHTAkgcMBRSaYy93phLZ3Cd6RsK2	1403	824	139	6301	6764	jwyypF3QSEJ2tM3e1fBzRtvQ8a1PuRrLbLKzpvjArXNWyoyN54h	5324	7501	7501	1617289380000	canonical
10291	3NKHwa8ZubW8442JfJxt7onoutbnn8GWrxXhucGSmK5YSkqTXRuV	10287	3NLqiknXREb9YfTrkfs8C318hHTAkgcMBRSaYy93phLZ3Cd6RsK2	1573	1318	139	6301	6765	jwgLECibF6g1WPPwC6zx5UdAdajh8N6jycLykzxpLQYLY4wGtyJ	5324	7501	7501	1617289380000	orphaned
10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	10290	3NKpJEZZd7BR21oYGgiXQR31PBmKmx6pVtE2x5c9yoLaivsaVx7g	1407	1395	139	6301	6766	jwobJA6TrGBBWv6jh5VKxDHdKtMekhpjuPZXNrFJnejeaqTo9dZ	5325	7502	7502	1617289560000	canonical
10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	1581	778	139	6301	6769	jwByEYnwC7XswxWJM7piwYwgCZt78sc6jyscMttcJooCwUbPFuk	5326	7504	7504	1617289920000	canonical
10293	3NLu4VxmLDJvHPoroYNhzkM3x61gwLZkUY9PBjNN6Y2pnSDGSsKZ	10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	1403	786	139	6301	6767	jxGkDuyx5xNJkt4wZceDFdbT8JC9z2QsrmFNdJbgz1nK85Dk4Jh	5326	7504	7504	1617289920000	orphaned
10294	3NLAJE8BSfzvbEngZyHVjysxQ4Nj8an9t4JiKLTz9Fbm7d6CJP4o	10292	3NKm6nZXtxkMDaPyXaWCukSe1UYR5qRmG5TWyBQ54gJthTScp8aD	1541	1172	139	6301	6768	jwRUT6Jfi9fLBC5T6Nrk1racqmmnAxCpYA3vErwwLWGJAp6jLu4	5326	7504	7504	1617289920000	orphaned
10297	3NLSsDJFJyUmGULxrmqhLMhfcJ2FbP9VarZ2b6siMJ4v9RV4yTZk	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1403	824	139	6301	6771	jwJ6cHvckvCJcstNHwxwiEtF4hUkCWvgGjQutz5rX61zmX9DYWX	5327	7505	7505	1617290100000	canonical
10296	3NKcrxfEgKgCMrtvw3ajFLVHaf7SZdk1DwG6iohkiZyN12rqHWu7	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1407	1395	139	6301	6770	jx6oBnQiGgT17jCuZCMDdzhtCXeMSMgBytJLWfJLnSdVrKkMyi6	5327	7505	7505	1617290100000	orphaned
10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	10303	3NLDeUNa9jaMuNsrKVc7W5czSK15EphURSQxTMeBnxutYL6ntKeS	1553	776	139	6301	6778	jxXNyGNxXNxdSWt4WeZY3346i8EyFzo6eC9UrEWdSVnEWmdx3iu	5331	7512	7512	1617291360000	canonical
10305	3NKfzAPgUvDLMPcwFVg6tTfd28qi8AnvU1gvZGfzXqywSh5Skrdq	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	633	1384	139	6301	6779	jxzHMAPGRJraejW9oSQA9SVoZxQEsHVSRGxJeHJ6SogLTu6vR4S	5332	7514	7514	1617291720000	canonical
10309	3NKJ6KLyL888muWjVGUpGwSa74vp6V8LaUaLhLujdZdb3wQUBZW7	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	1403	31	139	6301	6781	jxS6dbXdyox9Z4tqTvYwPDoXebkTwdM6BB66es6jXJuocAuxtaw	5332	7514	7514	1617291720000	orphaned
10310	3NL1MG7spLpVBFXkQpwnM9m9UvSmrh4RXJeqSpMK6zYSoGjWmNpZ	10305	3NKfzAPgUvDLMPcwFVg6tTfd28qi8AnvU1gvZGfzXqywSh5Skrdq	1406	1393	139	6301	6782	jwWzaq4MJuAvu5As8yWu3kEuyCNhXTzJFbZkTU8rUvWsPibdN16	5333	7515	7515	1617291900000	canonical
10318	3NK8bzDTLwnFnTdjedwKKC7srkbZSJ8ck1BwXuntFA5nLB2Vv3z8	10316	3NKgsbFUbbPtNDQyBKEpYx3MzSaR2cCpLPzSnwb7kKXsQZzXadSV	448	1059	139	6301	6789	jx94tfSjeEDNQhrn1t11FRvuYXUgv3NR8zmDXFPJFJYSifSpztq	5338	7524	7524	1617293520000	orphaned
10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	10317	3NLYnpNToKogfSPTDsehSFEZMVJ14NhMw6mrwg989R1YKbir4kzW	1623	830	139	6301	6790	jx21jPvjNqGtRb2NupwnQjYfTLQNyBWwrgb3bwMLQVXV9JifAWu	5339	7525	7525	1617293700000	canonical
10320	3NKnXCDwLeNsbm2TnsajfZxq1eLm3JUyQMJ922GHqCeZRqaXq8zz	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1444	1135	140	6301	6791	jxCqk2nTMSUaSo75TMSSUrZPYACNfHCTmj2zamvEnJY3Bm2SH2b	5340	7527	7527	1617294060000	orphaned
14288	3NLwGxJALEFY6MUr76fwGaRFpTMvBMUftRLRUVHDKy2gS7B3YRWN	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	470	1183	221	6301	10407	jxqjJpiLVk9A6pu1BCc5EDYngf8pQL5KMJ9ZbEEiPsFTnCBRxPD	7292	10318	10318	1617796440000	orphaned
10298	3NLJHWea4dmUZAX3Xz6JEsA4vcZVVwKCkL7i24fN9cD2up9BNyWx	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1406	1393	139	6301	6772	jwfPJQbJpnF7tMyra4hpJpQt3xdHJDZ5UeT48GW1BS6XDAtEhE5	5327	7505	7505	1617290100000	orphaned
10299	3NKe3EaD8PdXB7yoMtCkDVyMMcmHzFEoSAHyoxRp71Kb6UGBN8wD	10297	3NLSsDJFJyUmGULxrmqhLMhfcJ2FbP9VarZ2b6siMJ4v9RV4yTZk	1593	1100	139	6301	6773	jxNQqi59Wi1D44a9ko3CAEnQxsAxwXizENYRoNgSDdLr7zn7DqV	5328	7508	7508	1617290640000	canonical
10300	3NKVsS6v8LqVei6QD356HAgR9XGsWeibanb2wVueyPJcThwWBp2U	10299	3NKe3EaD8PdXB7yoMtCkDVyMMcmHzFEoSAHyoxRp71Kb6UGBN8wD	1460	511	139	6301	6774	jxr3VbQEt1wBYVR3BFNEJyQ8yrsuPaBF2Afxn3qMkBtzGsYzN3p	5329	7509	7509	1617290820000	canonical
10306	3NKfBsESuKaabd7MVzTgrQeoVfQL1F53UAe2EikXoDXgr71pS1PT	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	633	1384	139	6301	6779	jxdDBgr6x7kHJieDpWa4DN7n9gd7NpJc75bgLPZc7Q756tgXVvb	5332	7514	7514	1617291720000	orphaned
10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	10310	3NL1MG7spLpVBFXkQpwnM9m9UvSmrh4RXJeqSpMK6zYSoGjWmNpZ	1458	1077	139	6301	6783	jxjbhhGt6As2KRw8wNiEjuY8jfVaARWWwWQ5Q7AoSR8XZqPJAb5	5334	7516	7516	1617292080000	canonical
10312	3NLWeZuMvGnyYcYHzuMzv3xm9rZteUPx912kqR27kqbhsf5BWBLV	10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	1483	193	139	6301	6784	jxhiNLMQ1ewt63QxwDEkeFKKEDgZAnmThZZuraYaLZ7n2mzcFDv	5335	7517	7517	1617292260000	canonical
10321	3NLt3WEYazTo9XjKqCZjWRkozR7z6oz8dCBPuY2ixDKgNG2RctW7	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1560	925	140	6301	6792	jxShtKXQaQYC8rKnFD7WfkiYEUCX1dvw7WPua2rs3cA6gWK5UuK	5340	7527	7527	1617294060000	canonical
10363	3NLDh3PUsRPchJRaBkSUWvAADAPi3UgqnbVSp9MEwYMpRjmntcKU	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1588	1026	139	6301	6829	jwEoNK3t2YDduUUMcmpJSVRX89pTmGdFFJQig9QKD1WYi1Zarbo	5340	7556	7556	1617299409142	orphaned
10326	3NLQ7WERq5WN6A61B8ixi6pibyb2FMandwPW5NoNSEnpp7pGjG49	10324	3NK9ggPL4kBztvt6dYgBzmqzZbt6ij8nAwwSp5yjnjFzs2AwrtiJ	1477	1224	140	6301	6795	jxywNsF2uhTrpcmFzzPK113kF9k68FkAHva6EA8zCCgB8Xf76fx	5342	7530	7530	1617294600000	orphaned
10335	3NL6SfuKxPpNEHUVttzHmruZ7fMTEUo3vfa8oxhTuwAGMrqzsQcy	10333	3NKsW8y5336DxNCeRBxzW7thi1pqGHZtm3HgyJEamyHpt9F6bhEh	1403	824	140	6301	6804	jwNNy6rq6jv4s7aUgGLHmUisWHCQQm2Gus1VsaAizCMrrNAPXQg	5349	7542	7542	1617296760000	orphaned
10336	3NK4pDTCwJKi9LdkYhSk1DqzJfC9BQA6uMWZUQ6Eq5bo3nM87M95	10334	3NLoEMKkzEVaHo9u65ibQL9XxxascBaDrUG48VnVtVJ2z1q54uPn	1422	971	140	6301	6805	jwUkWh43oFYLGuoyvMqpw6hKrfjTHtPeJN1KhKT3qUdjbTVgSuy	5350	7543	7543	1617296940000	orphaned
10342	3NKTYFCkrQNxkPbV2UstbYR2YeFLoErNxeMyb5hqTQpdhNEXrcEv	10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	1509	954	140	6301	6810	jwHt4hfzPUy2CqJaYY9PyWemZXK2GRbtp3pA1WdfVTHvNLdCGWK	5353	7547	7547	1617297660000	orphaned
10348	3NKZciQVVgErpBxZSx5BTx71Nz924Box66UvBhjvoY7utPd4n2Zr	10346	3NKyUNxHqymMbCTXmHkKDthCSxkMc8pkzUY5VNzY25BXELa7yjDB	1637	816	140	6301	6816	jwVzhuGusrBnoEMmBSp8XM9WjdJxsvr4Xqfn4mh6hGYCeQTunXf	5356	7552	7552	1617298560000	orphaned
10354	3NLX3fZ7vDq8ofVaQvPMUpDAAu9rAEz8rpUsW5dans33WZaUvAD7	10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	1523	1075	140	6301	6821	jxvBcLB6iFzo5FmdUjY4H8bTfRPngnDBxPWfEr9tvwbFGChFPns	5358	7555	7555	1617299100000	orphaned
10369	3NLydQnFz3yqK6JRqEbQ8pYeY83nvc8W4Qx9knGTYiDzoMBr6R33	10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	1647	1056	140	6301	6834	jxZRevDtKJLBg5BqXVxg881JjmmRowsv7wrgwSkfmTn2PDaxEA2	5362	7561	7561	1617300180000	orphaned
10373	3NK7myZhKu2DXc7fCqQWa1za39LS3PY9V9v3FrRxjKNEMiN27ccA	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	301	301	141	6301	6836	jwxF7wgs9AQxZCL95qfxq3FZVX9iXqR3sJMhCMpUpZo2dxGWGtC	5363	7562	7562	1617300360000	orphaned
10382	3NLay3YE3efeimrm7aYH9goZAcK6KigeKCVVQi4Rqy8XsHGnoFYV	10381	3NK4gSBaYMBh8mV76fJXh6nMygwmRg9Z7rfnVwbuKRFdhb9ZaJWE	1553	776	141	6301	6845	jx38vkgojDdvQ6EUgLPtR1d4pMvTN3AHMGCrio1ncN9tioVHvnt	5368	7572	7572	1617302160000	canonical
10388	3NKvfuMdkNnnZKpU8xL6RmCC6Ffw27DuoCKLS2NmdjqwvhKt9moJ	10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	448	939	141	6301	6851	jxdYzFg2RDaBnsrCQzKoMuRTNmYD71zbHFJbs8tyiRwHUa648tR	5371	7575	7575	1617302700000	orphaned
10392	3NK6DgbdWDTwSNgHaXf5gHy8SZwaGLkS3P7mrxEBXATbJ1CauFxc	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1578	1296	141	6301	6854	jxMS6cLLHEBCKcvxn5VPLbmTdBCBs6zK1kGjnPhVBXR7FQBV237	5373	7578	7578	1617303240000	orphaned
10397	3NKaebt8BxHH3xPJYBoFJMMnoczxJB9D2zDF93bLepXBDSzc1omK	10395	3NKfAPhis3SddS73g1jqC8PYJQxwF8CKr2fyXSJyk8jUuG1Ly7uu	1471	1260	141	6301	6859	jwTJpahNh1nrh2rQhYoFrYxGMLt4queTbTRtSYNWe72hZWGxfm7	5375	7580	7580	1617303600000	canonical
10404	3NL16Zv7nQJs7HLoCTUxt1WmrSSkesFU2EKTYXqq4xUGgarxDDwu	10403	3NLrBmZJxrzENxTgEUC8Tv7spbSrvHgKhHqsyTaPFd63AyhtCzkD	1615	459	141	6301	6866	jxABux9y9DecFDQzroFAso25JNHtyyQ2FoEPhYHuwz9xN9ddXEw	5380	7585	7585	1617304500000	canonical
10405	3NKSuhJrDj6CEYBf8zHWTLPv8USFJ4qUxHLm1X95X5EENzU4wjYM	10404	3NL16Zv7nQJs7HLoCTUxt1WmrSSkesFU2EKTYXqq4xUGgarxDDwu	1440	1251	141	6301	6867	jxhBCLnWDhqb6VR2DwQHyGKkqBBfXkx6QFWnwygnzzDDhZZ6pYS	5381	7588	7588	1617305040000	canonical
10406	3NKK8uF9GV8kPhXx2Xove7vgSmapVoStDmn5vHkCsRS2mVSJ4yPp	10405	3NKSuhJrDj6CEYBf8zHWTLPv8USFJ4qUxHLm1X95X5EENzU4wjYM	1634	1331	141	6301	6868	jxymrJCvg4N41iZnCfbuqChE2o6Nmgko8PMtndgi6BXwk89RmcV	5382	7589	7589	1617305220000	canonical
10413	3NKurFu8PnhyfNHmaB5r8d4RiDNs32MwCnexCifNJDV2JgjCSVeD	10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	1541	1298	141	6301	6875	jxHjGb5K6ZkA25EvLzEgFB5qQ8CBq3hsVDWnqpst92xsj8oAZ2f	5386	7595	7595	1617306300000	orphaned
10415	3NLxcJfSk8ti9RK9jjGdcb4G2yJynE4cAw4ipt1yB7FRjRkDwHJe	10414	3NK5GueTxLuKSYHRevPkqb15SZSggv2ja7uG5ff6gFgddqcpfoyZ	1622	1356	142	6301	6877	jwQ6CyuurMM8wN6n9NCkFVFQZdphUpSGdG1CJtF24dLkNBfY9D5	5388	7600	7600	1617307200000	orphaned
10426	3NL7VDjUMJB4PR8g774vWNQUCgfftCuJWKBZnXG8G6c5ULhQHY88	10425	3NKHVvb55fK92PivE5e1PZ3qfweJ7r42aPxWR636AvvsTBaFRN5b	1477	1350	142	6301	6888	jxugGsUAN52nPTfRuFwK7XzHFB8saXivaEAdFN385U15EtrBwu7	5393	7608	7608	1617308640000	canonical
10427	3NLFr4zDxPBQCby63bgz5zm7Pj1rgjAMbt9E5MknSfvsuUu1RZVW	10426	3NL7VDjUMJB4PR8g774vWNQUCgfftCuJWKBZnXG8G6c5ULhQHY88	1490	1274	142	6301	6889	jxQU5q3vF1QngRhtKceRpAAUSnYqCjCY3F7ztkfFnM4oLcDf18s	5394	7611	7611	1617309180000	orphaned
10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	10428	3NKiYxgemuVdmikdAEzydsaME7DnxRPMRvoHprhKh7PJh6yGcQV2	1407	1395	142	6301	6891	jxNboLaoTeGVfMdvRXUQky9JfQgDdfBWBj83PHgxg5R6B9rXYMh	5395	7612	7612	1617309360000	canonical
10449	3NKYcDpkrvD4gucoUxN3Kc3L4YiN2Nvy3KbahZfSZaqa38ak2GBs	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1646	1354	142	6301	6910	jwdVRqUZE9aNdN7tumEunSzdPCKQjfuZU86He44DNjG4A2Lg2Vc	5405	7626	7626	1617311880000	orphaned
14794	3NKnamkeEHfDmiAxzVfhu2pr9eVk3RMzTvB1LVjcf64PHoKUProS	14734	3NKBmP2PCFJCiBfQ2vnvC2Nh3Dty1WEKeMsxacBMcMB6X5Svgxrg	1455	1206	221	6301	10875	jx3hUZbvKszBT1j1ZJaJJPZfqXTmpJfg7fFinSbA6NohgeKSAcq	7292	10681	10681	1617861780000	orphaned
10307	3NLQEHZ1MBtVd4PpDwXBiXifogQ9FM8Mg7vb8KyeNU3qGXG29Rsi	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	1602	1369	139	6301	6780	jwDnChFiDgGi2ujRrcpfntJF4YBMhDwjzJepXAxHqx4Uhc21Jap	5332	7514	7514	1617291720000	orphaned
10313	3NKfcY6B7dgNWpiB1JeQ4FfBDzRPnNnDnJC2z3Nn4wJX3DxRM6tz	10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	1577	961	139	6301	6785	jxnKtBf4Qcigqx7p4AyWcxTpxPF27VBZJahsw37wonbBWzh8PaB	5335	7517	7517	1617292260000	orphaned
10322	3NKokCC5gpVDVBKMpGZxazkCddSfpHtWCjwCPJYeXn1DeMAfedqJ	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1444	1135	140	6301	6791	jxpwnkMaUCkprGpWpkSaNbjWMBN2MF48mYCYwsqxRNKENtSdi69	5340	7527	7527	1617294060000	orphaned
10327	3NKm2qjA3AeaCoBH27WCdUZpRuoSU879Hgo67DuYxLGj95RY7ptE	10325	3NKtLq26RtARCmjsU9nwo7JPk5PbBHBJerDXDNsBen5rnHRaGbxp	1405	851	140	6301	6796	jxa7g4mTdvt5fdM7h75DymvBiMxnMvb68yxybL4UTPeVMi7PcnU	5343	7531	7531	1617294780000	canonical
10328	3NLWtnNUzTL4RuGh7w216yf9ASiNSN3dZr7t3UAdCUEDpNTkyvWd	10327	3NKm2qjA3AeaCoBH27WCdUZpRuoSU879Hgo67DuYxLGj95RY7ptE	1559	1227	140	6301	6797	jxnmCjXmJAzZpNu7VcaBzxH2muc1pshRuTK3932S11CMszPeXir	5344	7532	7532	1617294960000	canonical
10333	3NKsW8y5336DxNCeRBxzW7thi1pqGHZtm3HgyJEamyHpt9F6bhEh	10332	3NKtderTbJsoBockC1MDPfLyb8S8xJm6GBxPzj6bE5njvuwnTygC	1671	999	140	6301	6802	jx9ZWJkWDzbKSK1udxYQwhZBWk4MFTWoYtvonTnBkMhAmM1b2p4	5348	7541	7541	1617296580000	canonical
10337	3NKyvTqvpareYqnf6rX6F51WbbdkPqigcz27PrNsdqfzUa426TXR	10334	3NLoEMKkzEVaHo9u65ibQL9XxxascBaDrUG48VnVtVJ2z1q54uPn	1440	1377	140	6301	6806	jx9tD2pve6zFhALEYCwuMrCCu1ADt5KRoLrKQsHAn8b5nEpvWZo	5350	7543	7543	1617296940000	canonical
10338	3NKGZdm8baUUMqm7GDDUqoeCHvhfFYb9vN5KxxbSR9nuQx2zcqkZ	10337	3NKyvTqvpareYqnf6rX6F51WbbdkPqigcz27PrNsdqfzUa426TXR	1627	1385	140	6301	6807	jxynpXhx1EttyUWkvpPs5gNuQxgY7skTeAmPxqtRnLqwgCbjBkM	5351	7545	7545	1617297300000	canonical
10343	3NLpWejJXqUAyoDZXA7EyJtSoaw4v2hsbvouGEfHHmYD2eBdULrv	10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	1405	865	140	6301	6811	jxHsoE1kb9bY87rt1LSCwtqsqMoNPnCjspFuj1w6W53ygSqQPLZ	5353	7547	7547	1617297660000	orphaned
10345	3NK6JcyBRLQ53dzx3nb2mMJuAJ4TEYmgZVUeuvHWgmenytW5iy4o	10341	3NLBpfcjuTasHDRWnJujwZWA2nTzg8vfXkTUf5DjPVdBNeMPbjUh	1406	1393	140	6301	6813	jwamdrJA1tKyuFKDEbqkEAFTbrazYDoAk5o2JLQmmFmpVkvXxLz	5354	7550	7550	1617298200000	canonical
10344	3NLuB5fmSGbxUiHHmBve9xt68K9HxuScrH67FtexxTGCLeXvK3Xh	10341	3NLBpfcjuTasHDRWnJujwZWA2nTzg8vfXkTUf5DjPVdBNeMPbjUh	1403	31	140	6301	6812	jxz61v6eAUpECjrgvypqsCMgZKYYFZgp6KPX6byeEKY8XzaP9X5	5354	7550	7550	1617298200000	orphaned
10346	3NKyUNxHqymMbCTXmHkKDthCSxkMc8pkzUY5VNzY25BXELa7yjDB	10345	3NK6JcyBRLQ53dzx3nb2mMJuAJ4TEYmgZVUeuvHWgmenytW5iy4o	1553	776	140	6301	6814	jxnS1F7fsJiEKtmaWTg8E9Qma31gXTVELbjp9r6NM5wD5H2MFCY	5355	7551	7551	1617298380000	canonical
10349	3NLXhhEsSyrdgcrY7kXUHTMUmA1JVtwj6n3gm8Kn8bhZk6CAonBN	10346	3NKyUNxHqymMbCTXmHkKDthCSxkMc8pkzUY5VNzY25BXELa7yjDB	1407	1395	140	6301	6817	jxCjuFeZjD1AMnkCGtL6k1NdNqXXgLkXdDNt2bDZQ7372gs6H8f	5356	7552	7552	1617298560000	canonical
10350	3NKLV1XdyQmLwg88XzSrZx5L3xqptEKrZEayqAy8f4rTTTgTmHM1	10347	3NLJHZyFkQGFduhmr6ghnLXN2DNJ1WC2Kwh5VmhVYWk8i5GQDcEd	1631	794	140	6301	6818	jxKnJBstuUn9EQSC1QdBLUb4JDS51jpXx5rb18p7xvfeMNcrSVP	5356	7553	7553	1617298740000	orphaned
10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	1523	1075	140	6301	6821	jxUSksKQKciRjYzoxzMs5HrjDR9SmyZfMwsMggaJFJsUYzzQBUU	5358	7555	7555	1617299100000	canonical
10359	3NLBbx3ALCZB4atVx3DvenpjRruo5tPEvp4dsk3cTSGFZN1DYsb6	10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	1654	1340	140	6301	6825	jxByCbeRMtjjQZeBGk6yBbsRdsWQnYBLwr9kRzhq39NwpY7Fgrk	5359	7556	7556	1617299280000	canonical
10364	3NKCRLe62TJQ7TRyp6H1HQaTKT3yeejBNkM5L2vFY3AH5NdRTD4r	10359	3NLBbx3ALCZB4atVx3DvenpjRruo5tPEvp4dsk3cTSGFZN1DYsb6	1423	559	140	6301	6830	jx6dFdkyuc6caHC42hBQFu5MHihXbPWTbDFB9srckDoRUxKG7cq	5360	7557	7557	1617299460000	canonical
10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	10364	3NKCRLe62TJQ7TRyp6H1HQaTKT3yeejBNkM5L2vFY3AH5NdRTD4r	1503	1277	140	6301	6831	jxW2nagMfZ5q844B1iMgpYU5fP6e622QKHMbPeuMeoEC4SmqeWk	5361	7559	7559	1617299820000	canonical
10370	3NKvjrXRzNEqYp1R2hCCaEhCCa7taVUeB24tBDgJZ2AaHKngAQex	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	633	1384	140	6301	6835	jx7cMUfuzWUZGwe9Zra5DZEmxsVNtzghVKov97Eq4kt66RPLNNM	5363	7562	7562	1617300360000	canonical
10374	3NL7wrhqedQF5SNSBid2rkf1afRPEDVXgMVKRThPENJY6hwUX9Yw	10367	3NKkWM9nqkkJdWKyVDhHQLNf5UMgHQFvvjQs56zujpzkysxuzBdN	301	301	141	6301	6837	jxyVHj9fpQ5reX7mL3okT4JUWU3bZ2airBJy6fS4hdqHZKFrFC2	5363	7562	7562	1617300360000	orphaned
10377	3NKCd8NQrTCsBpqR9WdKnia8XNvLBCpxiurVGd5p7UbVQZzURHPV	10376	3NK9XgWJ42Q4Rv3h4sg3X9p1ci8FxArBJeWZsBB1M4qrFBvy4D8x	1553	776	141	6301	6840	jxLLbsEJzs99Mg1JZvtGcALcqrybrsiUYHa57j7bCdovpZs5Wop	5365	7568	7568	1617301440000	canonical
10378	3NLbyTX9xXLikTGhr6zdLDBKnZbFcriNGaSDjhBpSPwYFpVZyLeT	10377	3NKCd8NQrTCsBpqR9WdKnia8XNvLBCpxiurVGd5p7UbVQZzURHPV	1657	1344	141	6301	6841	jwh1MxM8Sk8VHXuJ3KCRz5qc1BVrTCPRDJdLqPCMhPyHXShGdTQ	5366	7569	7569	1617301620000	canonical
10383	3NKXp6EjDuozcqD2YMZu6U9Kw4n7TYNoF85nsawAeVeB5MSzQiyS	10381	3NK4gSBaYMBh8mV76fJXh6nMygwmRg9Z7rfnVwbuKRFdhb9ZaJWE	1406	1393	141	6301	6846	jw86gtk24MTbqhTL71vXZi5pUXAVHtBeFcnpW5kezTadGVVZADV	5368	7572	7572	1617302160000	orphaned
10384	3NKLLVViLeqR96RVjENLQdSoYKvz35WA6Tv8KfLpGT4EGCdTcURV	10382	3NLay3YE3efeimrm7aYH9goZAcK6KigeKCVVQi4Rqy8XsHGnoFYV	311	941	141	6301	6847	jxB3fbhQkda6G7u79pcK9Qcg2teHPc4c3QsLP27N1uQJdmBBX5Z	5369	7573	7573	1617302340000	canonical
10389	3NLTUJhHzJ45V7xom7U499gyQr1di7YF2uHGRSP2rMjFmB9aWGMu	10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	448	939	141	6301	6851	jxBFZVWz9QZpDEwbVgNMBaxW3fKTPdGKSKCYcbYgvdtc8uoxh7i	5371	7575	7575	1617302700000	orphaned
10393	3NKmTS7Bw8eSikotFRMyTksWKDupuYBattBGWXBSyh7DVUbae89C	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1483	893	141	6301	6855	jwQ8uvygUAPY2YyWSkHYRArBFTQipiSu8Nu5Um4sLChvtF32oNt	5373	7578	7578	1617303240000	canonical
10398	3NK9uCyNRXDyW167UCy7BBrdfap6vPKuDZWZRrT9tvfkMyviKbW3	10395	3NKfAPhis3SddS73g1jqC8PYJQxwF8CKr2fyXSJyk8jUuG1Ly7uu	1581	778	141	6301	6860	jxXMq4n9LewGJ3B4Ynu7N3udZTeDp9Aaiwq6Mkh1BEbWrShn4Wk	5375	7580	7580	1617303600000	orphaned
10399	3NLU7fNR5LysYuAdqUK3HgxMSGXna8Ym8YRYRFRWgEgh2kYi47M7	10397	3NKaebt8BxHH3xPJYBoFJMMnoczxJB9D2zDF93bLepXBDSzc1omK	1403	824	141	6301	6861	jxhWvz9FhenGdHtxigB74nfWkSkjyHJHu5nVuB5J8epHYmF3Qhz	5376	7581	7581	1617303780000	canonical
10407	3NKkA2Hd9SRDeCWmKNLgwAtUkAkd9d93oxasaEMZHBPK4yytU4qt	10405	3NKSuhJrDj6CEYBf8zHWTLPv8USFJ4qUxHLm1X95X5EENzU4wjYM	1419	814	141	6301	6869	jw8NGjZdRdoUHGtaC7jtqQYyp8htHAYV8NAor1qUCdSMpYEjiZ9	5382	7589	7589	1617305220000	orphaned
14309	3NLbaJpbBDBR7Zn6pvAk6s8TV8YP4SvBh5vAhQr8TnFFys2vqgQg	14307	3NK7tyLNmF1GFtohGqdWs5Kb7oRBRboPKBEzxgTzt7uCCZnNBv6T	1406	1393	222	6301	10425	jxz4KkZJJcNGCmdvPYNafuCaYfESmLjkZuJ2EWrcDoxNg83yH12	7302	10335	10335	1617799500000	canonical
10356	3NLidbiiduNNXvDaP5ZrCrsZf3nZN7mjyfVPEiU8hAjX9SetFpsW	10210	3NLcxm1sXrdY6RqXqgEogTaQD1cqa2YoMRyKvgxpofgfTQpeo7Zz	1588	1026	137	6301	6822	jwY7qHta23jREQztZFiXB8ZWTEWRgvUKb6hPZQWBULquDdGHX8p	5288	7556	7556	1617299280000	orphaned
10303	3NLDeUNa9jaMuNsrKVc7W5czSK15EphURSQxTMeBnxutYL6ntKeS	10300	3NKVsS6v8LqVei6QD356HAgR9XGsWeibanb2wVueyPJcThwWBp2U	337	337	139	6301	6777	jxgTCbSUCAZaLrD8gD77ENfnXoRvkKDuJDrfsdj1iSwqd75MqQ7	5330	7510	7510	1617291000000	canonical
10308	3NKv5gmiTJu5dWvgBsQzn6K3wpudeSHpE6QsUaxCgeCWXcV4iFjk	10304	3NL94pCGqGLTCsQXYfZe7z2GyBnhR6oYyJrHoXwfJ9Nko6MZuhwV	1602	1369	139	6301	6780	jxjKn4MsPaXy3xQtBPTLB4i7qg6AuKGUb2tNGmSEsWwU114Fgvn	5332	7514	7514	1617291720000	orphaned
10314	3NLX6bgLMwrhJ4HZvaAdUjLTKAR8ghZhnqmEQxZGeYxsEKjgSDEr	10311	3NLGi5k2ds1QaEnTXgm7FKSwV4gQoBcwes2gM7NNh8vBv4tR6wY3	1406	1393	139	6301	6786	jxU9Bxvm3GL6RxtRgas9BFnGRdsaMGH2ZaQFFwRq79oMnGPvj86	5335	7517	7517	1617292260000	orphaned
10315	3NLkZJ3NCnPB35NHpqZ5cSZt7dsDaJkvzFoVjYb25C6uH9c66otn	10312	3NLWeZuMvGnyYcYHzuMzv3xm9rZteUPx912kqR27kqbhsf5BWBLV	1403	824	139	6301	6787	jxsAKssW7X6HFRuBXEmukiQXzQjRoQYHVxcyLRd3KQkpw6TaqCL	5336	7520	7520	1617292800000	canonical
10316	3NKgsbFUbbPtNDQyBKEpYx3MzSaR2cCpLPzSnwb7kKXsQZzXadSV	10315	3NLkZJ3NCnPB35NHpqZ5cSZt7dsDaJkvzFoVjYb25C6uH9c66otn	1527	1293	139	6301	6788	jx5kQpPD8VrPDXPTe83LrTE1QkVo7xNHtKTuGUpYpC1U2WbqiU6	5337	7522	7522	1617293160000	canonical
10317	3NLYnpNToKogfSPTDsehSFEZMVJ14NhMw6mrwg989R1YKbir4kzW	10316	3NKgsbFUbbPtNDQyBKEpYx3MzSaR2cCpLPzSnwb7kKXsQZzXadSV	448	1059	139	6301	6789	jwV4cEVDVmWfZRMDJmvhSsy5eamXwyreqLhN9JkefXjSHg2husJ	5338	7524	7524	1617293520000	canonical
10323	3NLVTjebRtxQri1ZiHySY23UD5buAis8LL5FyKnAHEZ8ar1g5rqi	10319	3NK5NDcLdzDyd4HuQWmUtH4EZP6twvSfGdLVXrNWQ7X3wwCuhDik	1560	925	140	6301	6792	jxLYPPYJkQ5F5QStNAA1Ld1igze6WQBUr2J3Pv6CHUJLwZ3o6WE	5340	7527	7527	1617294060000	orphaned
10352	3NKVtjQDvMxZfVPY2Ty1UfZJhyweeDkWfENFmeyJ4SfLFWq97S9M	10349	3NLXhhEsSyrdgcrY7kXUHTMUmA1JVtwj6n3gm8Kn8bhZk6CAonBN	1406	1393	140	6301	6820	jxBbMgwXkayUhTPC24U2VjJx9uTV1V5E41BFjierMULHfBKtnPg	5357	7554	7554	1617298920000	orphaned
10360	3NKwsYqwwLwo1LbUph9XGpRWG3kTxcapL4ALS9DP6dGJjUJm8ewq	10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	1534	1317	140	6301	6826	jw8PYPPpkMU45XvaNmpN4Q6SEqC9nQefcXr4Aqs1K8RXLECBCah	5359	7556	7556	1617299280000	orphaned
10366	3NKCermFEso2zwaHVpWH4Mw7gvHTexNm96KYkwm3jBdAWGe714e5	10364	3NKCRLe62TJQ7TRyp6H1HQaTKT3yeejBNkM5L2vFY3AH5NdRTD4r	1407	1395	140	6301	6832	jwn8P68VGkntMBbRsdzwrFxGrYR128oZtP7aqNkNGEZyiiJiMCS	5361	7559	7559	1617299820000	orphaned
10367	3NKkWM9nqkkJdWKyVDhHQLNf5UMgHQFvvjQs56zujpzkysxuzBdN	10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	470	1309	140	6301	6833	jx7NgEBiuiWPPwYobgpo4FDGpjgP77C3KstiWMDZPKyEGoVEQK2	5362	7561	7561	1617300180000	orphaned
10371	3NKF7Fe4YiuyAgNGpMSKNiyhF49mNguZE8TYBYUcrKAzYVMJeLBL	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	633	1384	141	6301	6835	jy2xUyr9vhrNJUgZCmNjDi2miF2PDReCNpPA7bfLHx2inTQwZSq	5363	7562	7562	1617300360000	orphaned
10376	3NK9XgWJ42Q4Rv3h4sg3X9p1ci8FxArBJeWZsBB1M4qrFBvy4D8x	10370	3NKvjrXRzNEqYp1R2hCCaEhCCa7taVUeB24tBDgJZ2AaHKngAQex	1564	1338	141	6301	6839	jxPNCRji5KBy6uJnv9MbDFHvYtkgUf49D5sQm2kcC2a31BL8B47	5364	7564	7564	1617300720000	canonical
10379	3NKLUxceLzQg6frXmWQzzEGPmATWvigmeoZVfcvKTHecv2tCKcPG	10377	3NKCd8NQrTCsBpqR9WdKnia8XNvLBCpxiurVGd5p7UbVQZzURHPV	606	1169	141	6301	6842	jwMiyZtkWUrJH2eEnYk597LT8QLcabVLZ3frquGTNHZ88wpYAdE	5366	7569	7569	1617301620000	orphaned
10380	3NKoLMkkoVNJZy4pDTYxoZVgA274p8mJRAHsGssPVQCKiBNpAfjW	10378	3NLbyTX9xXLikTGhr6zdLDBKnZbFcriNGaSDjhBpSPwYFpVZyLeT	1402	850	141	6301	6843	jwLqYv6p1toiCTWzGdApiCpzMFs9jeZSGSAkBDbeKmx2xsgFL9E	5367	7571	7571	1617301980000	orphaned
10385	3NK9Bebpfrz9o1asL83P9xb4Qf1rGmogHWbPAvMeTCrW9a8Yriui	10384	3NKLLVViLeqR96RVjENLQdSoYKvz35WA6Tv8KfLpGT4EGCdTcURV	1536	1313	141	6301	6848	jx7EehzUNUWz1t9U4nJk77tZCW61RKG5E1Df3eHxSFTSMpdWS1f	5370	7574	7574	1617302520000	orphaned
10390	3NKZayvxyRT1c16WoYE8RbSG3Y2xQmeEegM5PPw9wrFzqunxP9yW	10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	1607	1102	141	6301	6852	jwJBdj3gP2kvicvZSaEjTgyLf2iWUfdw6cgk8cGmKYtV8AGRmjh	5371	7575	7575	1617302700000	canonical
10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	10390	3NKZayvxyRT1c16WoYE8RbSG3Y2xQmeEegM5PPw9wrFzqunxP9yW	1536	1313	141	6301	6853	jwgyf2Q1rmAwZ9ZMEbPmQ2NbNmAGPbaTrVC2F2GJSDZ73AuU6iF	5372	7577	7577	1617303060000	canonical
10396	3NLKS7rAkfahWbjaNVYN8F76hMhh9xBbGLdzgXuikbpRGx2QRvtk	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1631	793	141	6301	6858	jwWAtRuWqtwyRtSx9ppfFWTK95q5FW5WWHp3XUEqo6QXMnEZfcr	5373	7579	7579	1617303420000	orphaned
10401	3NLwv7WaJq8tiPZeASuGVXFbTXeGwTDeLhghk1JNDTX3qMurj9R8	10399	3NLU7fNR5LysYuAdqUK3HgxMSGXna8Ym8YRYRFRWgEgh2kYi47M7	1624	1334	141	6301	6863	jx4jAcHTvbGNhdMKTHA8y59GX6gnFG7es88bvfnDgG9DW6UhC9m	5377	7582	7582	1617303960000	canonical
10402	3NLVRBZBmJQFLw5NqGWWXp2hNKjkxHqtLXGzVpKxUDjAr8PWmnTQ	10401	3NLwv7WaJq8tiPZeASuGVXFbTXeGwTDeLhghk1JNDTX3qMurj9R8	1476	1125	141	6301	6864	jwe7NWGc1yNoySpKcexBYdv9gMzDJV3TD49PzBjcpr8Hke4XACm	5378	7583	7583	1617304140000	canonical
10403	3NLrBmZJxrzENxTgEUC8Tv7spbSrvHgKhHqsyTaPFd63AyhtCzkD	10402	3NLVRBZBmJQFLw5NqGWWXp2hNKjkxHqtLXGzVpKxUDjAr8PWmnTQ	1406	1393	141	6301	6865	jxU8VvdQYZnCjh6h8iJNxCGMLuyqhvvzPpUqs41tuVSqbiHMdbt	5379	7584	7584	1617304320000	canonical
10412	3NL6aDHvieaB8z4STn8SbAzRy7896ubDxTWZ54f9MApiXCgGDDa1	10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	1407	1395	141	6301	6874	jx7aDyXGZTXAVDeThaw5fgvQ22V9FZAwjTUMJWe1X4xdurWniSZ	5386	7595	7595	1617306300000	canonical
10414	3NK5GueTxLuKSYHRevPkqb15SZSggv2ja7uG5ff6gFgddqcpfoyZ	10412	3NL6aDHvieaB8z4STn8SbAzRy7896ubDxTWZ54f9MApiXCgGDDa1	1581	778	142	6301	6876	jwawMK3weFdBY3sZtUDTWerHtcJ3agwGawAsSb8uucZ82TA3cRc	5387	7598	7598	1617306840000	canonical
10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	1406	1393	142	6301	6881	jxDrRZnkCAYoJhPgT2KxqkvPE7Y8uAGxDFN9sRSopmdccCX9wbG	5389	7601	7601	1617307380000	canonical
10420	3NKrZU2ghwXEzNsGEYmoNwQZQqdXVweSQHmorWrJ4ZCpttQ2y6wL	10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	1426	1364	142	6301	6882	jwBoVXs2DzXCXJznSdYQ6ryrBUyW7qP288xoyXBLE7FxDAoHZcP	5390	7605	7605	1617308100000	canonical
10421	3NKZN6FRjHxVmUe18qmNkUz3q1rhj8GnspaJPQpK4XU4nnTkLdeG	10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	1646	1354	142	6301	6883	jxX3u4EPzQMkrVoaYWx4pQBtEsNUETeuZx3QrZVvMEAFKcHJgoX	5390	7605	7605	1617308100000	orphaned
10424	3NKwSvhWjZuuKwE2KqDjxfgEWHDdWe5efbAVJjsmuBiHJkTcaBYj	10420	3NKrZU2ghwXEzNsGEYmoNwQZQqdXVweSQHmorWrJ4ZCpttQ2y6wL	58	1035	142	6301	6886	jxcXNuWA5HLBLkj63C77mmjhwZqY2PDpHqvjWZwdKaqdCsMSUTn	5391	7606	7606	1617308280000	canonical
14316	3NLJjZJsQcNmYkgyi56xA8vcs5REXP8G5VFuptQZX9id1zyLgxYF	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1523	1321	222	6301	10431	jws9rWPugZYt8etHWoWso4Ak7Jkcc2nn3Tf7tt2TSHxncf97TX1	7305	10338	10338	1617800040000	orphaned
10361	3NLHmdub3dqn8gXwYwbmcdXX9i7H2RPLt9qTmtEUrKmWEXM1zT8v	10269	3NKsfsKLMkj6VgENyBRQj85ejVmuKDWMpXWrCEUiwjerAwnrnfpu	1588	1026	138	6301	6827	jxxdgjHnRq1FjyHYfCmPAGAHAkqbBck6SRtnz77iyL7sQabXaGu	5313	7556	7556	1617299343232	orphaned
10362	3NLh21pd2UNsKVMDLdJTxqujJPC6SysUYjNt34bu11grimoq6UF7	10295	3NLe2QhGtZDEC28vZomLbcp7yfw9HXJVkuhH941xLbDdN8KRduoi	1588	1026	139	6301	6828	jwcZ1PXjTenPkW9QPm3fuacBEa451SnsRKr5ZjpqDWpdSo82UKS	5327	7556	7556	1617299376606	orphaned
10324	3NK9ggPL4kBztvt6dYgBzmqzZbt6ij8nAwwSp5yjnjFzs2AwrtiJ	10321	3NLt3WEYazTo9XjKqCZjWRkozR7z6oz8dCBPuY2ixDKgNG2RctW7	1406	1393	140	6301	6793	jxEqEP7u9ZgdPbkb8fxcrppWR1joe3gs6hZwPn9jeYnPGjRsSX8	5341	7528	7528	1617294240000	canonical
10329	3NL8ndGDoAoLefDNb96AkVYjHWHbdsfNKArojjCukpxz4GaZcJKa	10327	3NKm2qjA3AeaCoBH27WCdUZpRuoSU879Hgo67DuYxLGj95RY7ptE	1406	1393	140	6301	6798	jxVt4jrpMbf5ReujTBkJXmB1bWvzhsQTSSGgAFK5cxZcqmrzXtp	5344	7532	7532	1617294960000	orphaned
10330	3NKtvU5QDcbVKhWkMjs8ZovgwtqJqeWycBpTTA3ww7uPjULzShMo	10328	3NLWtnNUzTL4RuGh7w216yf9ASiNSN3dZr7t3UAdCUEDpNTkyvWd	1403	824	140	6301	6799	jxLVeaU6so8gB4MTqJj4ACcFrq8iEDK14iaNzyrB7YmtmLVKdM2	5345	7534	7534	1617295320000	canonical
10331	3NLiP814DH8VsqacagWNY2cn2r1zw7shpNwAAjqcdHSwGGH1Xta4	10330	3NKtvU5QDcbVKhWkMjs8ZovgwtqJqeWycBpTTA3ww7uPjULzShMo	1637	816	140	6301	6800	jxJVWKh1f31xsSGKLwMfhtwneRCM8v5Jxn6cTifad6JSCscmKmm	5346	7536	7536	1617295680000	canonical
10332	3NKtderTbJsoBockC1MDPfLyb8S8xJm6GBxPzj6bE5njvuwnTygC	10331	3NLiP814DH8VsqacagWNY2cn2r1zw7shpNwAAjqcdHSwGGH1Xta4	1483	399	140	6301	6801	jw9oC9bnrQ9MUoA4hiJpTNdVvZETbVXJUnHons7cv2N7WqEuJKX	5347	7538	7538	1617296040000	canonical
10334	3NLoEMKkzEVaHo9u65ibQL9XxxascBaDrUG48VnVtVJ2z1q54uPn	10333	3NKsW8y5336DxNCeRBxzW7thi1pqGHZtm3HgyJEamyHpt9F6bhEh	448	1059	140	6301	6803	jxsDedXk9Hn1N7oUg7M12CCoHYRKus5qiKH7NZCF5WEdGyerDcj	5349	7542	7542	1617296760000	canonical
10341	3NLBpfcjuTasHDRWnJujwZWA2nTzg8vfXkTUf5DjPVdBNeMPbjUh	10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	1668	1244	140	6301	6809	jxnG122w42LaTUkHVC4t2ee8Hu7TQ9CJopTrVzVhKNqPk6RKLYG	5353	7547	7547	1617297660000	canonical
10347	3NLJHZyFkQGFduhmr6ghnLXN2DNJ1WC2Kwh5VmhVYWk8i5GQDcEd	10345	3NK6JcyBRLQ53dzx3nb2mMJuAJ4TEYmgZVUeuvHWgmenytW5iy4o	1650	1375	140	6301	6815	jxEHcyAZygPi6Ph7JZxgenpPpWVAUqhhQnR7LzckmxJqsj5xGKP	5355	7551	7551	1617298380000	orphaned
10353	3NKwcBPahjc2pFhRjFZKEUYTNv2zPKyyygfmGvsE1wGg8qD11Wyn	10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	1523	1075	140	6301	6821	jwXo3txXEsyumzrf5ZWvFnJnSQetunkA4HL37inydungvTVAoGW	5358	7555	7555	1617299100000	orphaned
10357	3NKZrYSbt6Cx3UveZPj5wvpGnyEERSPmAMuXYMAuattPFYQswnxe	10355	3NLNwzC25oUEzagen1qirPJBVvGfnRxSqujiQ5i675oKJwN2tpJA	1588	1026	140	6301	6823	jwXfnTUb3PosoniDJJ2F25jcxr7Ny875uB5pASXL3cnZPvQHdrK	5359	7556	7556	1617299280000	orphaned
10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	10365	3NKRbffcCH2NKvBz7JsgNvbi3aT87KsCDjFZekqT9G8ugZCvoKBm	1647	1056	140	6301	6834	jxZRevDtKJLBg5BqXVxg881JjmmRowsv7wrgwSkfmTn2PDaxEA2	5362	7561	7561	1617300180000	canonical
10372	3NLp5qRLbK7SdnVwaszChmtAj86LGwoSVhRZf6DM17EL2W2gypzP	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	301	301	141	6301	6836	jxr7Aj4Wf3pBX1oLvEvqWnr8pwRZCWnbfkmz9nG5NBoQnmrnpUU	5363	7562	7562	1617300360000	orphaned
10381	3NK4gSBaYMBh8mV76fJXh6nMygwmRg9Z7rfnVwbuKRFdhb9ZaJWE	10378	3NLbyTX9xXLikTGhr6zdLDBKnZbFcriNGaSDjhBpSPwYFpVZyLeT	1571	969	141	6301	6844	jwDbsuxF3HHXiZokwztMaV2fkabmqm98VXPQVCfHUyn7UGUjs2e	5367	7571	7571	1617301980000	canonical
10386	3NLYKm8sJxAfEZt86p5NCqngt7gJX9Y7odp73xhaacsSCp52QL44	10384	3NKLLVViLeqR96RVjENLQdSoYKvz35WA6Tv8KfLpGT4EGCdTcURV	1467	1130	141	6301	6849	jxziowZwHpfkPCK3F2gWmkN1q7KYnoin5sCC3Yr9sUUrQo8uAp9	5370	7574	7574	1617302520000	canonical
10394	3NLZpGbfPweMD69aQe5YDgtiu6tS4vo4gRz4FBswmD7e5a9jwHJu	10391	3NLiRpjeL31nhLk1wGQkL5GkRJ3eHnucystKxyQanXiP6fEAdRPo	1403	824	141	6301	6856	jwBYFu5Zgpvk2Sxro3dc8tAiW55VvkBkid7b5mrKQPkj5WgPyzz	5373	7578	7578	1617303240000	orphaned
10395	3NKfAPhis3SddS73g1jqC8PYJQxwF8CKr2fyXSJyk8jUuG1Ly7uu	10393	3NKmTS7Bw8eSikotFRMyTksWKDupuYBattBGWXBSyh7DVUbae89C	1406	1393	141	6301	6857	jwTq8GsotB3iSX4ZvSaobYobczJEjt51bUCgXu7bPEswnxTsqSz	5374	7579	7579	1617303420000	canonical
10400	3NKLsyMkBtjkLQan9NMGcDAybZn6y44u9FECAHU6pVM9iUDgWExk	10397	3NKaebt8BxHH3xPJYBoFJMMnoczxJB9D2zDF93bLepXBDSzc1omK	149	1037	141	6301	6862	jwq9i4nDA2dRveeGQW7nevGcqd87AWQoFjuRQXXJTRh9sHKovu4	5376	7581	7581	1617303780000	orphaned
10408	3NLvpAGhUskYk1Rxge3iCk7Jp9ntoL1EUpe4Fw2KX4puLVtpyafz	10406	3NKK8uF9GV8kPhXx2Xove7vgSmapVoStDmn5vHkCsRS2mVSJ4yPp	1633	1390	141	6301	6870	jwaPNDJ3u87BQfZ4ypLj6fWKuEPV7HgUyCYpnCvKDNMXv7gJ52o	5383	7591	7591	1617305580000	canonical
10410	3NL8JXYmj6U5e3kQbhKskRX9XHY61oa7khDZtg7JD5dVvpFCCZRb	10408	3NLvpAGhUskYk1Rxge3iCk7Jp9ntoL1EUpe4Fw2KX4puLVtpyafz	149	1283	141	6301	6872	jwsKBz4tXvwhBQfGSuYrzbNV4qGHrmzoG8vTCnjXbLmTUZWDrqJ	5384	7593	7593	1617305940000	canonical
10409	3NLEEKMfDwPkbgqn9QT2L2XvPjPRNZ7nL2yunDVFyogRg3wkwJEc	10408	3NLvpAGhUskYk1Rxge3iCk7Jp9ntoL1EUpe4Fw2KX4puLVtpyafz	1407	1395	141	6301	6871	jxGZ3cBARRNTYmm4grykaJZHCLnZaxDUdHykVJGivcpJWtDS5hq	5384	7593	7593	1617305940000	orphaned
10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	10410	3NL8JXYmj6U5e3kQbhKskRX9XHY61oa7khDZtg7JD5dVvpFCCZRb	1406	1393	141	6301	6873	jwKdc9EJD9XTe6ZTqks9fsVT3dzYrpvixXcUponpeFYe2DesaWm	5385	7594	7594	1617306120000	canonical
10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	10414	3NK5GueTxLuKSYHRevPkqb15SZSggv2ja7uG5ff6gFgddqcpfoyZ	1402	906	142	6301	6878	jxSYQtjDtgk5S1Co5MytVjuwMK5C4iFSFQfLqYenbBAr2p16cvW	5388	7600	7600	1617307200000	canonical
10418	3NKox3SadUw2mJpQuyQe2UQQAxfAahPZURNNPxnJCP6qrJxDGZvC	10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	1553	776	142	6301	6880	jwEkn88rtGHBdmhsW76kLmbkpPJDBNHvLJqkhPR7ya46qAkrXqz	5389	7601	7601	1617307380000	orphaned
10430	3NLnY1B6JGAtTUxC3SpMv98ScJGwEKzP9BFMw7iMRBUkKBtVd3bt	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	1648	1038	142	6301	6892	jwkE1vyuh7G9wCqC6ZRJ7KVM9KXBQfbhbTnKHpYVe4a4FfnffWn	5396	7613	7613	1617309540000	orphaned
10436	3NKvMWrPvZ356om1apP3qJLyVj7WG3PKc7TYKko3efj7RK74Ry9Y	10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	1406	1393	142	6301	6898	jwwgvDiVqpvtZe8kkKfqFVxUq8LtU6qMRa4bAtuBjctfDdxmgGH	5397	7614	7614	1617309720000	canonical
10434	3NKpy9pEtwJVFZqmFbByCxJZ1Lk39kESvca2c2pc4YjyRpc7k7mX	10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	369	1186	142	6301	6896	jxA7wfZfMemRY8mtji6B613ep5G1xvVUHteY2QmCavy1JeEunte	5397	7614	7614	1617309720000	orphaned
10439	3NLyUYzx6NDuPY4dZQyuW3juafVQL6MfDm259sqeMsUBhx4uDtad	10438	3NK7DpHwJL8AhPUo9bcxmv9moCyR63LHZnPt53saNESHohyuSm1b	1654	1094	142	6301	6901	jxbY8QhAYJx5YV5gzCkmopmLywTCH8wP773bEwXe5AeUteuFNRP	5400	7618	7618	1617310440000	canonical
14363	3NKCEZ1vECkn312JKwgEYqGG9aLUSMw43XjijyFzvLd1CLn4Bg6i	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	341	341	224	6301	10471	jwsMvHcRbB39YFZEfN62dpR2uUUnoSB3yps2VwouYBGPuctTgNQ	7330	10370	10370	1617805800000	orphaned
10425	3NKHVvb55fK92PivE5e1PZ3qfweJ7r42aPxWR636AvvsTBaFRN5b	10424	3NKwSvhWjZuuKwE2KqDjxfgEWHDdWe5efbAVJjsmuBiHJkTcaBYj	641	970	142	6301	6887	jwozB6AndxNH2g1XxzkdW4Tc2w1C6MtEWXevvAakxECmJSdKd7a	5392	7607	7607	1617308460000	canonical
10428	3NKiYxgemuVdmikdAEzydsaME7DnxRPMRvoHprhKh7PJh6yGcQV2	10426	3NL7VDjUMJB4PR8g774vWNQUCgfftCuJWKBZnXG8G6c5ULhQHY88	1419	814	142	6301	6890	jxXJr4jxZgeL7aCyJsqPkU37vfE7rQQHF9emsPG6Fms5GLDk98a	5394	7611	7611	1617309180000	canonical
10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	1507	1034	142	6301	6893	jxvdWWALndd5fCNaQkSsctcJkUpHBC6F4tuenkXRfU4zRwVaeNC	5396	7613	7613	1617309540000	canonical
10435	3NKHHD8jAc8BqMRCc8pYm8A8aFcwNreW3BWS1oYVRdqWN9hZdWD4	10431	3NKEhqaem7RkYJHSmMTpQfHbGgPSjapM3DkWDH5EqT6jPhq2DrSJ	1637	815	142	6301	6897	jwU61iDqz9Uy4F2tRE6j6soFhtWR5YnHVYwKVvLy42U5dNKMBa6	5397	7614	7614	1617309720000	orphaned
10437	3NLJ7h4AepHyriSV3fqK4S1dCTKp14JG7SV6Hb1FqiNfEdThPQ5Z	10436	3NKvMWrPvZ356om1apP3qJLyVj7WG3PKc7TYKko3efj7RK74Ry9Y	1405	869	142	6301	6899	jxSGTiWcMCMtaN7hfxowYbHKHhodGYVBap3HGAUdKvPHV5msEdh	5398	7615	7615	1617309900000	canonical
10440	3NKNZndmVgzGgmgLDN1t5mthG2EXBzv5oqQQFjTpk9nU7SXq5Dok	10439	3NLyUYzx6NDuPY4dZQyuW3juafVQL6MfDm259sqeMsUBhx4uDtad	1657	1098	142	6301	6902	jx3yLyLjwmZ5qoXjYuNxZSzBcYqhAdh2G8uCr7DF3LGfMBrtyMC	5401	7620	7620	1617310800000	canonical
10442	3NKarYwKknTaWhgd8L7PZjuZ2jfzTafdmgNLM2UWhrRq2iYampBs	10440	3NKNZndmVgzGgmgLDN1t5mthG2EXBzv5oqQQFjTpk9nU7SXq5Dok	632	1256	142	6301	6903	jx5v7debMZ9zVKqPLoc6pVS8ff86ECFsYHNwhadd1JVA1veQauq	5402	7621	7621	1617310980000	orphaned
10444	3NLG2ghXvJjXbSjK7dCn3dgaevgmLPPViFzpA1epZQ4HWrUK6ebN	10441	3NKib36PumbXQ5ospMDgokHyyqXQg1hVCz2UAAuWrdG8YKSjxb97	1406	1393	142	6301	6905	jwZKEj6yWJK2tx2kbAHM1vz5sEBvfzu4564AeSWHy2o8bchn2hP	5403	7622	7622	1617311160000	orphaned
10455	3NKipHUjoHA1nCzpdqRoHrYTQjqCNAVVCUMtegWyk8Gykp9jMjo4	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	563	1359	142	6301	6912	jxb4T249eEDvkCT8aEAqU53vLDk34EFUqgM39W77u3fwQ8QiAn8	5405	7626	7626	1617311880000	canonical
10451	3NLgdofywHC7VfAjwvWiVbX5JhGyzr27nn52QcKDsEpAsYC2N2xX	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1406	1393	142	6301	6911	jwkmao21TFe8qucd1Bwa945FZ7mHfVepPGXxvEB1VFe8f319EqD	5405	7626	7626	1617311880000	orphaned
10457	3NLMrQk2VY5WXCwcFiYvo81YnvZitrnFmMCQ3YkY2BEqcPqE7MjN	10455	3NKipHUjoHA1nCzpdqRoHrYTQjqCNAVVCUMtegWyk8Gykp9jMjo4	1457	1145	142	6301	6913	jxVxKGDpdY8NM6ervAUj2nA6vtuyKGhxtos7RSTMc2GLeQnppKK	5406	7627	7627	1617312065184	orphaned
10463	3NLEANgq7nz3i7k6euc7rxB8wrEUpHZSrssz4fY8ZPBkz4icgsCq	10462	3NK8uh1EbVDaGJS7ey89z2BHAHfWR72GMGq2KEg4hpqefaKTCKME	1406	1393	143	6301	6917	jxSzY4CCYKYLgJJX8HiptGBt8r8oZwXtgq5YWATNGnDNZxEuMMY	5407	7628	7628	1617312240000	orphaned
10468	3NKiJ2DPqND99TYLm65v2X2CFPkoE3D5mg1LC9aQdTR2VHb3Ao98	10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	1406	1393	143	6301	6922	jwmZSNwAtyuGJ4fSgChQ3q6c4UZK8UmgSrTgvaUzd2NztURcsDX	5409	7633	7633	1617313140000	orphaned
10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	10469	3NLf1dE695uJJcYrmiSEsVByzyF27w7XK6ncibvTmM5ifnttUbpm	1483	551	143	6301	6924	jxHCPyYQatbHgSwGjX7G6JzzQTnoy7kgyzMCgTtP1txaGE4k8Ak	5411	7637	7637	1617313860000	canonical
10475	3NKmxYBtB99uatpSCdxvtBD83YQeadz1gSMxuFfv4vEHp21L1iH9	10474	3NKxirSBv2jrt2d8efUTFaXKvsn9h22H2zqxpd1TBDmCBybpZbXX	1650	1009	143	6301	6929	jwp1cYMcK9aiWUzzzB5hJZpirfdvQRo9APtBecfa7sywLZvHgAZ	5415	7641	7641	1617314580000	canonical
10481	3NKihxSoWVFYdoyX4ujW6cxjgKmY6C496AJJFeVUjFXZzpRVwN8u	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1516	1294	143	6301	6935	jxDukgZqUT25wGUkKepN1edtbsUZZEPVHJyqmFunRSAWrshjx5D	5418	7647	7647	1617315660000	orphaned
10484	3NKEJpu3yVLXYsFtGvaLjjyBUdki7JtAQQr8TrEFjDwgDrLcqnub	10482	3NLJ94yDPJXg9bsTG53hkBp5XCmT8HA2CZRMr8KakAe7nGemNDe7	171	1374	143	6301	6938	jwvZUpYDDr7vfdAHDeAfF6S1GkthtbTicGAF9YhAh296bycEahm	5419	7652	7652	1617316560000	orphaned
10490	3NK3bb8xHyZEA6MzNxLCnLkfRMoz15hPsqaVzU3t6pX6cE7e2ju8	10480	3NKUTrWohXD4w5xPtR1MaqJt9LqYVbQV8qeKodK6MNBQAPsDvxsQ	1602	1243	143	6301	6944	jwgx3ENoEeKuCJvTbGib4KC7xzMHYsZhE52WdiNDiXkofXhY7DW	5419	7653	7653	1617316740000	orphaned
10487	3NLQqURfKMyoahGXBc6kcYKwhrGn1JVvuux3Aw6xwFHUhHtsrHAo	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1542	1058	143	6301	6941	jwCdYad5QfzWXvyxHniwB8A8mHmj9Xqp6DBrDXqfgSenR7RhY4f	5420	7653	7653	1617316740000	canonical
10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	10487	3NLQqURfKMyoahGXBc6kcYKwhrGn1JVvuux3Aw6xwFHUhHtsrHAo	633	1384	143	6301	6945	jy3EtFht3g8JKhCw6PfWwNR6dMUHSfmeRQRy1JzCL1dwVWLU2V4	5421	7657	7657	1617317460000	canonical
10498	3NK5d65FT8xiB7GTnTf7P9ZKfbLj4zLRQpPrLVNFw1YGUNfav4wN	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1594	1080	144	6301	6951	jwkzGdZ7hmVsjgA22VTv18X97hV2Q2XX8CbbCHivye3jLhkqJTK	5424	7660	7660	1617318005022	orphaned
10500	3NLDtN8ndVozjENHC4JjKBx3q75HH1dmHkDkuhH8NfdLjjGn66Si	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1403	824	144	6301	6952	jxNuHjam1LGThggjEFVktisf5ufXTP2DVyYMG3c8YiHomyPJqTi	5424	7660	7660	1617318000000	orphaned
10508	3NLPFZwBuCVVndVUHpT87f4gJhtbszBneFmuzJmTYZxgeg8F5w5F	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1588	1266	144	6301	6960	jxJSzFbH297hmm78bnW5H2jjHpApT5ybCC5Sgx7k2g6AxWKyxqa	5429	7670	7670	1617319800000	orphaned
10523	3NLXFQLASAWjs9waQ1eSmq4SFHxTLCRPhhHWyVfPVaBNRvtuhsyC	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1556	578	144	6301	6972	jwe8TpLcf3sEZNtHhem8EagCnEVajat8rN5KZdweEzUMZS9s6r2	5434	7678	7678	1617321240000	orphaned
10525	3NKZKFnBhzyXqUgiRZTENnaXyAwiaHpLDt5vhLKyTebmGqMBCVWi	10524	3NLwr3pBzuFAEyeGQkSZkknAp7FurQKdn9Y8tdxVVVkSjXQXZdm8	1407	1395	144	6301	6974	jwoZuS4PVJzoi2zsVJyEDYeh5CviuPvP66cqHtdJ6k4mZaQ4rgm	5435	7682	7682	1617321960000	canonical
10530	3NKD1EivuGWRK7geGVJ4Dfkqvx4E6xo2JUpMFZQRPN9DP5ZSQX3v	10528	3NKfFgZfgi2XAWr338MdUrgP9BpD3jKT1NDYjysbQvxf6p382UjA	1451	1166	144	6301	6979	jxKzQsaKhpg9jMU6HnW2WwU1x8dmzSj4ywinKtFqpcbognCuydU	5437	7685	7685	1617322500000	canonical
10533	3NL5cLZreMTvTe4NJh6wk7gr457odP9TYGHsUzKdWCNzv8Lt1pgP	10531	3NKgEWPG8Sveb9Cp8h3pWiY1Eju9o6UmZZzWWX3NCmKViGKD8qjf	1406	1393	144	6301	6982	jwgiyywNKK9cpSjyhhzzS7QUmB9MaRzHFGLxkApJ6GsmQDHnQ79	5439	7689	7689	1617323220000	canonical
10538	3NLxt8T8GpSWjaSvT3RsKVW73WseUDiBsrXmiiygoKeVQMDeC9hZ	10537	3NLTb4NCYjwxuLgauEJPmxjToeNWTsFGKGediB8aVheEdYaR7hNQ	1489	1380	145	6301	6987	jxR3RY1NdmxfaojJ8bcnuMaPasbUZFfAcgAEp9yMSUwVBtwcX5r	5443	7693	7693	1617323940000	canonical
10544	3NL32URFRoL9g6RzLA8hoATi7wunaoxp526bmEvhbSKw8MbLRVMd	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1622	1356	145	6301	6993	jxuCrSq3KcP3NzQybQB1EbENYUcfWhqH5Xiba1Jt1RVDDx3HMT9	5446	7696	7696	1617324480000	orphaned
14360	3NL8L2Hf93hMzEMvja5UtCig8CJDK1CeMRLq5UZCaYaneo2QJmFy	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	1624	1208	224	6301	10470	jxKV6PwF3tX2zCumBukLRzD2KsvEXe1tEPHrW7UAiFvVgadUqV7	7330	10370	10370	1617805800000	orphaned
15595	3NLikWozSeV3nG3BeeyYZ7ijMf4ijfYZuNt5AWwsZBUnBrJrqB3m	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	152	1084	250	6301	11620	jwuNTdpWkuMLv6FjucFoGx9XgtEhqZ5TabNyY2HPfwxvnFfC5xy	7938	11243	11243	1617962940000	orphaned
10432	3NLH84KKPFHbF9hQ8AZdCsABFiG5nDTPEZSEjMsG9VgHRLQ46HTF	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	1553	776	142	6301	6894	jxBq5YoMKSU2ZRpgR1SrjUQeffvRX1vzgCbzKw1M6BgxaJPmZCJ	5396	7613	7613	1617309540000	orphaned
10438	3NK7DpHwJL8AhPUo9bcxmv9moCyR63LHZnPt53saNESHohyuSm1b	10437	3NLJ7h4AepHyriSV3fqK4S1dCTKp14JG7SV6Hb1FqiNfEdThPQ5Z	1522	1196	142	6301	6900	jxJ22HSp9YvE4mKkLsWLcV9nrGt7No1eJqVDjUkRoikoeay4voR	5399	7617	7617	1617310260000	canonical
10441	3NKib36PumbXQ5ospMDgokHyyqXQg1hVCz2UAAuWrdG8YKSjxb97	10440	3NKNZndmVgzGgmgLDN1t5mthG2EXBzv5oqQQFjTpk9nU7SXq5Dok	632	1256	142	6301	6903	jxupqMBpwrvQcdQFkX3nxMaeocEpqh2iEwLpTPAUziEV3huBVPb	5402	7621	7621	1617310980000	canonical
10443	3NLswohwPSpE1WLPyYbeePxmt3nSTitrChbU5hbdkJYuALkyFkuy	10441	3NKib36PumbXQ5ospMDgokHyyqXQg1hVCz2UAAuWrdG8YKSjxb97	80	1147	142	6301	6904	jxEkReo7GWhvS3FGBr2XJ1RgtWr6152ofh4zw5GaxauBjT4BY5L	5403	7622	7622	1617311160000	canonical
10446	3NKx58usebHR731aWAmfiom3SuL4L84rTRumFkSrRiWqnD9w7aen	10443	3NLswohwPSpE1WLPyYbeePxmt3nSTitrChbU5hbdkJYuALkyFkuy	1489	1134	142	6301	6907	jxrgaP74WVJjTEphmhjyDueaDsu3oiyEusfft3qqfq5fW522X7j	5404	7624	7624	1617311520000	orphaned
10453	3NKSPX6GruAnirooPi6Sefs5y6KCBtXQZjmw1uBeP2gGhTnBzAsa	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jwEM56ipKfcwEPHqqSwi5DeizpW5dqp12odQfRC5ZPuB9UJxdwV	5405	7626	7626	1617311880000	orphaned
10456	3NL6LAnPiapBQFVA2zKXNVaaHqmA15ZeDgsTMtvo4HAP3nqboATd	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	563	1359	142	6301	6912	jweZmj3Bq8hnK69rtwR4ZuiDr9mHW99qpSCvkeUyR6ckPABdbgz	5405	7626	7626	1617311880000	orphaned
10458	3NLY8oFDnccLHXUsVcCsWTuDGi3Xz2xuEhp4YECh2QzYekWJT56T	10455	3NKipHUjoHA1nCzpdqRoHrYTQjqCNAVVCUMtegWyk8Gykp9jMjo4	684	1352	142	6301	6914	jx3dCzRqHg6YL5HRTBjPFPu2dvNLtGG1uerzTbZ4L3r67BZo17p	5406	7627	7627	1617312060000	canonical
10478	3NKECi8WDg766KwrPJJe1H4oyZBMMutUjzx6DgKxqVwFvT8PM6cd	10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	1654	1094	143	6301	6932	jxRwpDDsDePiQD5Ed8FgxSNmkr9Vf1umNHPjewbqs5B2RVAA5Co	5412	7644	7644	1617315122725	orphaned
10473	3NL1NJgukuAENzur5KRrdHvxGEeCJJD6sGbHWqWdDThkae3Gaa7E	10471	3NLkJTVUrFLKaTgHmVFxMxaNG44xEoNy7q717BpiMZ4mPFXPegB8	1406	1393	143	6301	6927	jxu97cUgWKktgMcTRSLUiiL4ZeVByisvgh6izwSHVMzHEoEUgau	5413	7639	7639	1617314220000	canonical
10482	3NLJ94yDPJXg9bsTG53hkBp5XCmT8HA2CZRMr8KakAe7nGemNDe7	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1623	839	143	6301	6936	jxTCgpUJLVNzgFRj9yQmaCfwK6VJ3A8cDxnBaDSCsE5xJKipv4v	5418	7647	7647	1617315660000	canonical
10488	3NKQFDdhCiVyd9f7iSYyee1DUTSSRETZ1fdcGVfYihKf58JXA4sW	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1501	994	143	6301	6942	jxF4Ugy4Y8v1xs9VEWUVL5EhXng2njuph4gEgJaqa6ixSCbvG6z	5420	7653	7653	1617316740000	orphaned
10494	3NKBwscEwmU3KaesR7omFtCSk9j34kRr6LwgXT38HX9yW6hFN7R7	10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	1611	975	144	6301	6947	jx2xTSFnz7kmGAbjxFxJgmycshqDxjWrjg1LTDcRj6RNTf2vtw5	5422	7658	7658	1617317640000	canonical
10496	3NLSqqRiF3z7AP3mdJgRWQGzdDjSfVFPVmX9t14WqZ5HUJt2kAmh	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1503	1277	144	6301	6949	jxUJ9xfzAdoCtiCTHwM5R99i29Hfu4xCy79p12DsJurCnggLzcy	5424	7660	7660	1617318000000	canonical
10503	3NKckmqsaATbKjtJq7XNY4sGa9yCy7rezhdPWmQbA6rY4cFDQn48	10502	3NKhgujurMQBLVGde7rg1b1DUHhgNp8Ce9y1FHvTvHeHQqxEXvUW	1656	1217	144	6301	6955	jwyPucJKBwR2LH5oL5xSQsXFLXsFqk5QD37XSHgdESSbxyT4nST	5427	7664	7664	1617318720000	orphaned
10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1553	776	144	6301	6959	jx4gxgPW9cpCGJhu9bAkWFcaRW4CEHo2UM24ms2StgZKut7aqyP	5428	7669	7669	1617319620000	canonical
10509	3NLThNEXBJNyqfxrfBTqgRTHBUuXb6yEUCZC4uZFqvxppzRPpPeM	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1670	1282	144	6301	6961	jxJC18z3oqRyK3ptMacaHQxT9LXNeZopomiUUmPS744dgFYV7Bu	5429	7670	7670	1617319803007	orphaned
10512	3NKBaKN1skZ8XR2A6d24Aty6YgbmCekQWN9xoQp7F2njeVhEuGtS	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1483	84	144	6301	6962	jxoiUWCLGKarWJMtgopTgyWFRuGVh5rXuS7qfVqQq1mrqyP9GYh	5429	7670	7670	1617319800000	orphaned
10513	3NLt4H1VQrMLUe5r4BHgJQ3mombnmfbC3zDSsXqc3iPwb7KD2aRa	10505	3NL6ChSvdUAn6Lvf7Dna9UFG8GMA2wEMd1HZb23UFuJRE6XnL5xo	1403	824	144	6301	6963	jwYCSzc6AWj3QNd7Jsbyn9mLdE38EmLRZXT6BjusB3bWXDgDszd	5429	7671	7671	1617319980000	orphaned
10518	3NLi4Yz9FWb9onoA1ghHDCpdmUiWXUvDmKvtfkXkFw3rkLxwtNsH	10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	1601	1262	144	6301	6967	jxRkBahEKiwczUA34SUcV4nT1HMAE7PaZgkFLnGvrHXkSFUNVnA	5432	7675	7675	1617320700000	orphaned
10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	10519	3NLgH4Tjbs64o69NARJ1TYPWghdJcTYoCyReQ1mXEXWYnKjN2w3h	1402	870	144	6301	6969	jwhzCQFRFUh7khnUV4LnS8eagsZ7UWdk4hThsgcGZ6B9EmZdsrL	5433	7676	7676	1617320880000	canonical
10524	3NLwr3pBzuFAEyeGQkSZkknAp7FurQKdn9Y8tdxVVVkSjXQXZdm8	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1397	828	144	6301	6973	jxDJMYqs4kKJ2gtAS6UECG9j7WSrV7vTCXf1XQf9Y9nKCW84aRM	5434	7678	7678	1617321240000	canonical
10528	3NKfFgZfgi2XAWr338MdUrgP9BpD3jKT1NDYjysbQvxf6p382UjA	10525	3NKZKFnBhzyXqUgiRZTENnaXyAwiaHpLDt5vhLKyTebmGqMBCVWi	1587	1111	144	6301	6977	jxygsdt8N6ideSvT8XnkPmNfLKHPhvjZAtzppTSAKNPWoGR9XMB	5436	7684	7684	1617322320000	canonical
10531	3NKgEWPG8Sveb9Cp8h3pWiY1Eju9o6UmZZzWWX3NCmKViGKD8qjf	10530	3NKD1EivuGWRK7geGVJ4Dfkqvx4E6xo2JUpMFZQRPN9DP5ZSQX3v	1542	1058	144	6301	6980	jwtRM1ywgMKvN7qXEZTbnMQRGSeVog4rimFophpQfUEinJy3m3j	5438	7687	7687	1617322860000	canonical
10536	3NLA3ZtgJNiXfTSP55SKHfUnrJD9fVnmTRu39aGHfEPDSHECkCsn	10534	3NKdGh47ie7L9z1Na44SEHuKBqToUCwHzBbrM4cUGYey8swExwsq	1406	1393	145	6301	6985	jw73vGMkvZbFqT3udVcLHVxdr2XJUksyTrZDJ7zp986AcN4wEcM	5441	7691	7691	1617323580000	canonical
10541	3NLDtRbPZ7ASsuCh4hyTvCaFPDzZUMYLP5KTBMt4pjCKgB541cSx	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1407	1395	145	6301	6990	jxNDGXz1hQdeXNr3CDAXKeTXzFczcLGN4vLaNHb2ADHfStPqzEt	5446	7696	7696	1617324480000	orphaned
10548	3NKpP2Xjzw7zDXjigFxubqqKu71BixxAicpqazYjSpp2gHVCSu48	10543	3NLJ9eZtxN4ptSX2ERYenhpYMZuriJcT6dGSYTGR39bjsjYY8PR4	1397	828	145	6301	6997	jx7bXMTZgyo3W7mnhrTWAc3gHS8fwogeuXZGuSEYGRXoXh7Aba1	5447	7698	7698	1617324840000	orphaned
10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	10549	3NKxc3bvbK2jiLnLLtB4Zc7tABjXASCXMPUka1DRVDKiuRDeZzEj	1650	1249	145	6301	6999	jxrPJoBPRrwrENYZkY8EyZDf3XFSoJAK6AsCjMHxBsgrFhAofmX	5448	7699	7699	1617325020000	canonical
14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	14358	3NKnt83uDkLsPfhV7Zmu3n4Gq6Th1hQ93euXFvCNw14GiTRd7kjA	369	1312	224	6301	10474	jwCzqhizBGyUPcEgDyaCtDApaiQxUfse3AyxEEN79YyuxozTSj2	7331	10371	10371	1617805980000	canonical
10459	3NLSzy3ZJ5hD3FvfqbMPW7nyh5GCw1JqDBJUfhemhxq5fDHeDGgY	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	563	1359	142	6301	6912	jweZmj3Bq8hnK69rtwR4ZuiDr9mHW99qpSCvkeUyR6ckPABdbgz	5405	7626	7626	1617311880000	orphaned
10460	3NKqNKJQWb8vAn6B91Ksif961Lp8j2g92nTgbSTaw9iCPXqbE2p2	10456	3NL6LAnPiapBQFVA2zKXNVaaHqmA15ZeDgsTMtvo4HAP3nqboATd	684	1352	143	6301	6914	jwm3iEBsPt6R3MZofaWXpVKAW9uZwT2BZwTnLbgu9f8JSsgnoCo	5406	7627	7627	1617312060000	orphaned
10461	3NLg7UsEk4f115pBfh21vdeXf23vHG6PQSYTeUHLv8yKxttnKo4Q	10458	3NLY8oFDnccLHXUsVcCsWTuDGi3Xz2xuEhp4YECh2QzYekWJT56T	1407	1395	143	6301	6915	jxUczqT7YYQ6CBmxJo2e2A9HkoGZVDJQSCg57gihBV2DZcdRhBf	5407	7628	7628	1617312240000	canonical
10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	10461	3NLg7UsEk4f115pBfh21vdeXf23vHG6PQSYTeUHLv8yKxttnKo4Q	1675	1216	143	6301	6919	jxdXdCYvN9JiGPDTFmNqfmcjN2zWHFkwmzDEPAfYbTmLNNs9w6B	5408	7630	7630	1617312600000	canonical
10466	3NKKC1WXyTUXxMymzzfLykqvTgQMYipQ1XVtaxS5L1TdTvLFEnfe	10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	1617	1042	143	6301	6920	jwuYeQyRE8yB6QJNgkCru2VERpfRDNTnA8XvoQ1nqkBEdXkr36q	5409	7633	7633	1617313140000	canonical
10467	3NLucWGk2CHzuHrXqNV61tSPbXDMU7cS9VmC3BVNWqTQLzhYsiU1	10465	3NKjmKoao2D8mRCWi1nKPB8HXzAQDMAu8oZLCcPvFXCRQiLqPYaH	1579	1263	143	6301	6921	jxXJ27HkKTjUsw4zBVqHTMQDQmBtekcyTdyUvuoxmg2AWapj238	5409	7633	7633	1617313140000	orphaned
10469	3NLf1dE695uJJcYrmiSEsVByzyF27w7XK6ncibvTmM5ifnttUbpm	10466	3NKKC1WXyTUXxMymzzfLykqvTgQMYipQ1XVtaxS5L1TdTvLFEnfe	1407	1395	143	6301	6923	jxm8RDu52pbgbRpcJGgUGf1cVvGU6krSqawPAymcaqLvvA3zTkX	5410	7635	7635	1617313500000	canonical
10471	3NLkJTVUrFLKaTgHmVFxMxaNG44xEoNy7q717BpiMZ4mPFXPegB8	10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	1646	988	143	6301	6925	jw7GQXAHoeaFAaauNekPJXyqxJh2pRz5bUjPiWZdoUfhwD5uwSq	5412	7638	7638	1617314040000	canonical
10472	3NK9C13QvbxDuHMosZtq96psV9PL8jujeemhx1syRVSgFGfyrh4M	10470	3NLpJmUngLZqig6bXdsYEZRErhipUcj3Jx1knzVcaGcjJJyv9tWs	1509	1320	143	6301	6926	jwZ7MWcJWF9ab46Fcg9qdpyBxFGwYwo7fvRmv87hWVjLLwLd5un	5412	7638	7638	1617314040000	orphaned
10474	3NKxirSBv2jrt2d8efUTFaXKvsn9h22H2zqxpd1TBDmCBybpZbXX	10473	3NL1NJgukuAENzur5KRrdHvxGEeCJJD6sGbHWqWdDThkae3Gaa7E	1553	776	143	6301	6928	jxDZTSnaXQz24pd3qGyATarQ74F4LHmwuBDCBHs2QwVfSsJwNNP	5414	7640	7640	1617314400000	canonical
10476	3NLEcnh4BHFW5nc1DRwUzjaU6bFD7oHjRdKs61Wan5G5WGDUzVbw	10474	3NKxirSBv2jrt2d8efUTFaXKvsn9h22H2zqxpd1TBDmCBybpZbXX	1406	1393	143	6301	6930	jwCBbqNyXduGrG9dCQJEksPuhFwzr2eXtk9JMRYAYNfehDxP6VC	5415	7642	7642	1617314760000	orphaned
10477	3NLUqSrN6M9egAgBviN8yo9jbm2U1AP3o4CWHGU9e64uBWKDVQbA	10475	3NKmxYBtB99uatpSCdxvtBD83YQeadz1gSMxuFfv4vEHp21L1iH9	1631	794	143	6301	6931	jwvwnYuH3SDi9yLzyzNUzFvSsoYCjKZXpPsfCH9VQvBSdbWUyHG	5416	7643	7643	1617314945866	canonical
10485	3NKbctAwGdUQmcMUzBad7JnLfR4zbKZXXptcJEjtyGgffFzYN84K	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	633	1258	143	6301	6939	jwPYFfBWue1oUvsybPP6R1M2iZf5WuskBTJkxwwLNsS1k58CxNR	5420	7653	7653	1617316740000	orphaned
10492	3NLaJdV4dsuKe1F7kVusMMXkBvvVSjywkC5ngSFUizrNaKWa8Lh1	10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	369	1312	144	6301	6946	jwWKReFEX8EBhMeT9cjZjcG86qiyzR5i6vTNtWC7DZowbH1BP73	5422	7658	7658	1617317640000	orphaned
10497	3NKhaZ4CnNMgAe5uFmPCZ6PzjrK8giH1WTajQwNMzY7fboRu7GnM	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1460	490	144	6301	6950	jxTrskS1wiexZbSc6X5xDwJz2LrC7ocn1JRksgQ4jHfEEjLV7J3	5424	7660	7660	1617318000000	orphaned
10501	3NKZAmXfqfJNNgVC9LdnPWfFYXqK3n9Qp9FFApBcmRAzo2wSLG2L	10496	3NLSqqRiF3z7AP3mdJgRWQGzdDjSfVFPVmX9t14WqZ5HUJt2kAmh	1508	1387	144	6301	6953	jxV6XHtGRS2awUvjLHhV6xpWdoAaTvf9NxVi64v3R5VsMi1md3t	5425	7661	7661	1617318180000	canonical
10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	10502	3NKhgujurMQBLVGde7rg1b1DUHhgNp8Ce9y1FHvTvHeHQqxEXvUW	1675	1342	144	6301	6956	jxJi2vXjkut8cRfsD8qFA1webPCGBQjNdMJGEBYEjXUiVaWai25	5427	7664	7664	1617318720000	canonical
10505	3NL6ChSvdUAn6Lvf7Dna9UFG8GMA2wEMd1HZb23UFuJRE6XnL5xo	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1648	1038	144	6301	6957	jxXp5aZxAQbCch9QrdV5MNNeiLjzq1Cei3BBcpUHt6sKnGVGYZV	5428	7669	7669	1617319620000	orphaned
10510	3NLUqUsuvugLSakCzSaMz2pYEGMchGYdnwEQzxM8fqfyN6cV1WQL	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1588	1266	144	6301	6960	jw8hse6cfSmnMGLnnLm7SXPp7eNxVQoYVsT69QdxNNYZyPpDZDc	5429	7670	7670	1617319800000	canonical
10514	3NLndAaCpyv5mc31y5xFC3F1Ne46kHE869R7puMmiCvzHsxZkQ7t	10510	3NLUqUsuvugLSakCzSaMz2pYEGMchGYdnwEQzxM8fqfyN6cV1WQL	1577	961	144	6301	6964	jy3C6MsKh4J9Bq5xBmUek92zySUeMgCFF14SHXUftdtLWQM4A3H	5430	7673	7673	1617320340000	canonical
10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	10514	3NLndAaCpyv5mc31y5xFC3F1Ne46kHE869R7puMmiCvzHsxZkQ7t	606	1049	144	6301	6966	jxsexYKteuFmio9wCYsKGudpXQWueprHsWb3oQwKYDSRpWhA6ei	5431	7674	7674	1617320520000	canonical
10521	3NKkjSYMLqMrjwdzNQmNLQcJYQResZT4iWufUoPwEw6JJBEnhQ4E	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1627	1139	144	6301	6970	jxboisSQfJxeCKsatf9qsL4bdexcZTBfS86M1e4ixxgXVR6vh4n	5434	7678	7678	1617321240000	orphaned
10526	3NKPRacKpnyzhAeJ7T4WHU5rpoDQcuNLuYTCtqHjae1ZisNiwnaP	10524	3NLwr3pBzuFAEyeGQkSZkknAp7FurQKdn9Y8tdxVVVkSjXQXZdm8	1633	1144	144	6301	6975	jwYbeqpSbTDKUwtmbL4uoWX9Q2zJixugU93sBxLMLJ3MsiXFfce	5435	7682	7682	1617321960000	orphaned
10529	3NLJojcScXK8mnGbWhpK8qjvg6dw4E8nKcjirUco36SpyrN4wEae	10525	3NKZKFnBhzyXqUgiRZTENnaXyAwiaHpLDt5vhLKyTebmGqMBCVWi	1481	790	144	6301	6978	jxK3iuPadmnGWreMb44Yz4juiD3BS4rEuwdVnbPYcARGumFEn85	5436	7684	7684	1617322320000	orphaned
10532	3NLqudMfrAs2CpYXNez8So5qMFfseMV8p1XfYFKpEdTThs8fXmfM	10530	3NKD1EivuGWRK7geGVJ4Dfkqvx4E6xo2JUpMFZQRPN9DP5ZSQX3v	448	1059	144	6301	6981	jwRMxqX1CHA7iEsWpCJuhdWCFTcwtqty3PzCwCQYh1sivDskAag	5438	7687	7687	1617322860000	orphaned
10534	3NKdGh47ie7L9z1Na44SEHuKBqToUCwHzBbrM4cUGYey8swExwsq	10533	3NL5cLZreMTvTe4NJh6wk7gr457odP9TYGHsUzKdWCNzv8Lt1pgP	484	1193	145	6301	6983	jwVMejXmUMyaGUirGV4213zB17wcpcKzkPwyZw9XAu8j7xpDVwQ	5440	7690	7690	1617323400000	canonical
10539	3NLbXVdRcwhKkuVtiqk9eoC7VHeDKLV8FHTo4ZMd1nQSzUTnUdi4	10538	3NLxt8T8GpSWjaSvT3RsKVW73WseUDiBsrXmiiygoKeVQMDeC9hZ	1610	1314	145	6301	6988	jxwgNDsxbzE7gTzfzJ8vpMEenioq25DXCbZp1Mnno9ySQ4DXeRN	5444	7694	7694	1617324120000	canonical
10545	3NKwELKniFZUNxE12W7KWtVEFjvS8JMZg3iTgL73aeKAjhW5TbDR	10539	3NLbXVdRcwhKkuVtiqk9eoC7VHeDKLV8FHTo4ZMd1nQSzUTnUdi4	1622	1356	145	6301	6994	jwoyD5bYYkifNU3EfwQUtbMzy5LKe58jiQ5qZxrQc6CMNqi12kL	5445	7696	7696	1617324480000	orphaned
10542	3NKv5guuBAohAtG3BpQxWyd3jY44GSP4D1MzHs5Ey5LSaoQYtnMm	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1637	816	145	6301	6991	jwM2NSwDG52W97gEsf3CW5cgG7vKJpbVmx2YA1grfRxVTx6mZ1f	5446	7696	7696	1617324480000	canonical
14369	3NL2RW5VPLPUHFxNRgXnbHvdv7gWSS8hu6nNnWH4JjQj92vvY4eP	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1651	935	224	6301	10477	jx7FPFEdbjESwufir3JLTwLsTpVPQMRdK6L4yA2n6zFMDz6UhFy	7332	10372	10372	1617806160000	orphaned
10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	10477	3NLUqSrN6M9egAgBviN8yo9jbm2U1AP3o4CWHGU9e64uBWKDVQbA	1654	1094	143	6301	6933	jwGzewswB7etJxSmpTMBLgLxFgW9a3sHKZBaDUVScRePqd6AZa3	5417	7644	7644	1617315120000	canonical
10480	3NKUTrWohXD4w5xPtR1MaqJt9LqYVbQV8qeKodK6MNBQAPsDvxsQ	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1403	812	143	6301	6934	jx1ypMBLY3F8jD5NiaZQgRBxXffuHWNaWX31bQ14QHcahWg82DZ	5418	7647	7647	1617315660000	orphaned
10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	10482	3NLJ94yDPJXg9bsTG53hkBp5XCmT8HA2CZRMr8KakAe7nGemNDe7	1447	1345	143	6301	6937	jxNafYahDymukteeBR1RF1YxPpBP5F2iZCnaXJy4jDzXBBjE8Xa	5419	7652	7652	1617316560000	canonical
10486	3NLyTWAWMabHz58xoTcgdErXTdsdWgsAvuXQ2Au7Vs8MeDVcgpa3	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1602	1243	143	6301	6940	jwQ1So3jPRJ7gPnHNvj2sQpcuSudvmsNRNxMaHAxyp4BTbMexrZ	5420	7653	7653	1617316740000	orphaned
10493	3NLmnirkD37jLUHHPbpdaH12oUie5L7ZFFvCDqAYWShwRvodLgsu	10491	3NLJhpHNjZsvjiWUEqqJ1Y8vNytBBUzjAPrnTdV6zBjU3NcDH1za	369	1312	144	6301	6946	jwWKReFEX8EBhMeT9cjZjcG86qiyzR5i6vTNtWC7DZowbH1BP73	5422	7658	7658	1617317640000	orphaned
10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	10494	3NKBwscEwmU3KaesR7omFtCSk9j34kRr6LwgXT38HX9yW6hFN7R7	1440	1131	144	6301	6948	jxnoUwd7g7LPz6M15xYhHmvkwA7bjhXZCsAf8WZYQwu1rxs9BAw	5423	7659	7659	1617317820000	canonical
10502	3NKhgujurMQBLVGde7rg1b1DUHhgNp8Ce9y1FHvTvHeHQqxEXvUW	10501	3NKZAmXfqfJNNgVC9LdnPWfFYXqK3n9Qp9FFApBcmRAzo2wSLG2L	1608	923	144	6301	6954	jwSvSaJB6x4ZfUVJkRYDjXvT8ZWHTwgPmJM8t12c7wAc8AaJ8tQ	5426	7663	7663	1617318540000	canonical
10506	3NLF4Bn95ScGzm4Tdt4SSJYQwnK62GCS1ZVoptJ8J14gnLgK2iVU	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1589	1160	144	6301	6958	jy37MXC5EwmW2Nk4FWM5M7bVtr5m5ujP7oAGQ6Bk4Yw3Mda3RTT	5428	7669	7669	1617319620000	orphaned
10511	3NLv91UwZzsbPGPq5coxbzbafxHFvx7wiPjNRhUUneokLKLbR8Vy	10507	3NLfPdQG9cgD5GARmknPhkMP6Yt1ZWNk5ZdJA1K786ZpumFd6D7i	1670	1282	144	6301	6961	jxJC18z3oqRyK3ptMacaHQxT9LXNeZopomiUUmPS744dgFYV7Bu	5429	7670	7670	1617319800000	orphaned
10515	3NL8LFhZDozZb5765iY4zhUHXsLHU9QWre7EjkJVMPzmhFshcNNF	10510	3NLUqUsuvugLSakCzSaMz2pYEGMchGYdnwEQzxM8fqfyN6cV1WQL	1403	824	144	6301	6965	jwcuBJKpuUk2iPjisXPptDvDU9FpoMbk1kfwXXzdtwsgge1PqPv	5430	7673	7673	1617320340000	orphaned
10519	3NLgH4Tjbs64o69NARJ1TYPWghdJcTYoCyReQ1mXEXWYnKjN2w3h	10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	495	495	144	6301	6968	jwyaB4NehwTxKjEYciubcyFJYjL71GwLqVbQVgXcpCaTJN5UdZb	5432	7675	7675	1617320700000	canonical
10517	3NLMd1oJYcGzCLYavA96RRx43KHxXd8hmQhcbaJ297fMeDiwbhGy	10516	3NKs7fZ4aAGLuQaMkdY2KsoF3w7ZxTMd5cGdUmtfeLJuQvhqe1Xu	1601	1262	144	6301	6967	jxRkBahEKiwczUA34SUcV4nT1HMAE7PaZgkFLnGvrHXkSFUNVnA	5432	7675	7675	1617320703923	orphaned
10522	3NLx7gMYMP5YVtS9pZAPVsXnyLfegBvZYRuYuBeKEDb8H2eBTngQ	10520	3NLtaDXMMinYTgg4yt27236g4jjZ7de1dVv6Ft9fshZwDhdWs2xP	1501	994	144	6301	6971	jxBYBK247EGqhWiLELhcq7RpxubrvQA57FKv7moyWq54qTXNcCK	5434	7678	7678	1617321240000	orphaned
10535	3NLH3VWf1Ccxsb4znNKUwvDAH9XaPwaK1E9F1msanjECSSe5F6oP	10533	3NL5cLZreMTvTe4NJh6wk7gr457odP9TYGHsUzKdWCNzv8Lt1pgP	1481	790	145	6301	6984	jy26CE4UmvzvmTZeYiKLiz7kd2Vb4gSsEHG5nVqMZ1Wc9NT8oSy	5440	7690	7690	1617323400000	orphaned
10537	3NLTb4NCYjwxuLgauEJPmxjToeNWTsFGKGediB8aVheEdYaR7hNQ	10536	3NLA3ZtgJNiXfTSP55SKHfUnrJD9fVnmTRu39aGHfEPDSHECkCsn	1407	1395	145	6301	6986	jxwGZ6Vi4ogidozT6MAmXUDEC4JAXoFaQkMwvASBH7Nv98adTCk	5442	7692	7692	1617323760000	canonical
10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	10539	3NLbXVdRcwhKkuVtiqk9eoC7VHeDKLV8FHTo4ZMd1nQSzUTnUdi4	1631	794	145	6301	6989	jxB6ms5NF75B2bDCRLHbr1KUPWyqoHpdJK2Y3NGBW2FjzaYnCWw	5445	7695	7695	1617324300000	canonical
10543	3NLJ9eZtxN4ptSX2ERYenhpYMZuriJcT6dGSYTGR39bjsjYY8PR4	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1483	620	145	6301	6992	jwNZTAgpGMHEHZNTSvzs9V3fDHs5rLjqCdm6NfqfQidoPG1Lbgi	5446	7696	7696	1617324480000	orphaned
10546	3NKyb9Rgqgg5V4SPkSajD9dDQMQsUjNDVYs3ztXdtgFDyN2ZxZiA	10540	3NLbHrqnm1NkngHTnV67Vnyfc8FiLsKQ47H1nGJkJbex9JCnF8qL	1613	1349	145	6301	6995	jxoZNtPv66v9sPk86HQtffu2YjLfo5WEtmMLU641tft2A4QRGNW	5446	7696	7696	1617324480000	orphaned
10549	3NKxc3bvbK2jiLnLLtB4Zc7tABjXASCXMPUka1DRVDKiuRDeZzEj	10542	3NKv5guuBAohAtG3BpQxWyd3jY44GSP4D1MzHs5Ey5LSaoQYtnMm	1403	824	145	6301	6998	jwgxJuoM2BqH92u3Be4Dqzbkh5fN7Bv8qkj4VESWoD4iraAz1ya	5447	7698	7698	1617324840000	canonical
10547	3NLWUB5bLYG4iWUkATQ6N76E97fHmwwaucuToahYTDx6hpv43uUw	10543	3NLJ9eZtxN4ptSX2ERYenhpYMZuriJcT6dGSYTGR39bjsjYY8PR4	1407	1395	145	6301	6996	jwLNiSozLyuNRMRLkXQkqmhApjzSzticH5MPBjZhepFDgRPNuF6	5447	7698	7698	1617324840000	orphaned
10553	3NLwP5aU3otd4hT5pcsWsPidbWfPPGPdwPf4mHBV9FfYougjGcP1	10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	1587	1357	145	6301	7002	jw9kUvfJbsQHg92nAyWzwntZKNM2saCz9cPcpC9ne7cTM5kZkBt	5449	7703	7703	1617325740000	canonical
10552	3NKP4b8sSBFuVvSwCpcEUfqfVX3qiFU4bvWmvV133STXeZpgv5my	10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	1549	1362	145	6301	7001	jxuCq3TVmWaxvvb6JALhSCepGPyhyuy3UmSZkf7Ac4AA6mzs46e	5449	7703	7703	1617325740000	orphaned
10555	3NL9dLRT2CZghdA275zyQh2wMMG4R9qRcpsjRq2axHE8i1UXR7Ww	10550	3NLVhGFKKU8vxmihD1w8b5sho8ig6PyX2pTq4efmJSLEfZANsY1n	1403	824	145	6301	7004	jxojPueYigoCgdKjvreNvfGFxjCyNKEiELKriVrFRQQApzpJtmv	5449	7704	7704	1617325920000	orphaned
10554	3NLaRGPXhTpRrkWgVsdfbLNCGi8A3sxzhfQ1C3T7fhmgBrD2AD7x	10553	3NLwP5aU3otd4hT5pcsWsPidbWfPPGPdwPf4mHBV9FfYougjGcP1	1634	1331	145	6301	7003	jwhKnTfEQ223aNUrHwGzUqoqAX5K6ss5xzkM7KP2Sxk9fhpNazZ	5450	7704	7704	1617325920000	canonical
10557	3NLN9JGfti6wE8SJekeBMUwwmpARcGK78A1EquuXqMno68KfvY8b	10554	3NLaRGPXhTpRrkWgVsdfbLNCGi8A3sxzhfQ1C3T7fhmgBrD2AD7x	1467	1250	145	6301	7006	jxix7L2tFwj1V6AZT1mgko5XQgwKB5xT79qhH8rTu4dJ16UxHCa	5451	7706	7706	1617326280000	canonical
10563	3NK83DPSXFaM8ZMgSPVkZbXgC53n1CPaxmRj6asY6is43NgBhx8v	10560	3NK6xb4jkfXA8m8bahopycZWKHj6FyVPJes2NkkvS1RsnATDVCYv	1402	868	145	6301	7012	jwwwPyAN2uR4jxHcoQT2FLnEBKPBRR32RBUkXD2PBW5UFWjJmeK	5454	7710	7710	1617327000000	orphaned
10565	3NLyQh8pmqqpwc7UVCng9h4EzrJhszenkvgAEm3DrBsTjt2SuWro	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1546	1339	145	6301	7014	jxHTwbySwpMNCwFGdXJu1AF286TAs4NEReqf29rYLiHF1xXn9JR	5457	7712	7712	1617327360000	canonical
10567	3NLUA8MQotLuBRiAcR3o7eThKnqErczed1BCQzx4ZERctBkPVstf	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1611	1341	145	6301	7016	jwj8VG2cgLMHX2gxCfbmoDRYqtqRJMzXhc8oUJ7jEQYEuG1z6DV	5457	7712	7712	1617327360000	orphaned
10569	3NLQfB5pnb3StkQeo5Vpod6xRqgTqy9JGyR2hC7oKpb3MZ7HwxzJ	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1406	1393	145	6301	7018	jwEZ15XMnQFHLnjfaLoMF7TwRZcK49qQTdfcx2X8twG8KHXXjtG	5457	7712	7712	1617327360000	orphaned
14373	3NLk8nbqQVDJp6KsgQfy2yL5KgTRCQsVoUB7mn6gQQfe3MwUvfw6	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1407	1395	224	6301	10481	jx1kfbBG1FCVYfp5GypeUv1oAubeMqNwQTngnwaCdvwCmKrRdNm	7332	10374	10374	1617806520000	orphaned
10561	3NLs28T3at61pTp7Ji5BiwaSoof7HXERZWxrbxQLU8wcxeXR1WPd	10560	3NK6xb4jkfXA8m8bahopycZWKHj6FyVPJes2NkkvS1RsnATDVCYv	1406	1393	145	6301	7010	jxf58yY5bmtyZ8WeJKhmuCKDJm12qydEWd6bDLehX4TZTsFGZoP	5454	7709	7709	1617326820000	canonical
10566	3NKVWGqgbKn91hmV4RSC7KKCxUubVXJKc3jGrWviNav9GpQaTQEr	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	576	1355	145	6301	7015	jwoPx2jeyyLoSdDSvQ8Fv2t4sJNiQCPRcwq8kHqjN89YPgmoX8j	5457	7712	7712	1617327360000	orphaned
10570	3NKL7NoKFCtpcADcKUyxs5cRft86MwBhA8RgUFVMFok53mE9K77z	10565	3NLyQh8pmqqpwc7UVCng9h4EzrJhszenkvgAEm3DrBsTjt2SuWro	1444	1381	145	6301	7019	jwcjHtPAPUpqpjNc4uo4x1d37P7SU9aC6eTxYNhwahohAix4hjy	5458	7713	7713	1617327540000	canonical
10572	3NKT572cHQSDUdP3nBnRjfrGcuLRvg1g7LpSPwgrQV7LC3jxRXwa	10570	3NKL7NoKFCtpcADcKUyxs5cRft86MwBhA8RgUFVMFok53mE9K77z	470	1309	145	6301	7021	jx4vRHh7b6A5yRk2KVTLwhkBtfWyPsPLTxFSmQjn6VwhQkyEsUq	5459	7714	7714	1617327720000	orphaned
10574	3NKQ3DbCPitNWVACZcKTMtahXsxKNwJkph1dFM1V5yfJThYXPSjb	10573	3NK5ytfJDXg11P49y69Q3mjsio1fQLbWTjjJYMfciTCvdVQMa1Ye	1481	790	145	6301	7022	jwUsvxQEQQ8v8FPWvqJEve7Vp2KuhhJRjDgToGtxQ57oZJFb3pE	5460	7716	7716	1617328080000	canonical
10575	3NKRLSppTyvC8sdyi5q2GDySX5rDfHznYdQSLrHwzGJrQEBXNzXZ	10574	3NKQ3DbCPitNWVACZcKTMtahXsxKNwJkph1dFM1V5yfJThYXPSjb	1406	1393	145	6301	7023	jxfXmbVbJ7JKE7fUcfyCDrNDbr4VW1bNjiwDKWgi2UVvtfpqh4B	5461	7718	7718	1617328440000	canonical
10577	3NKgVm5cYorcMMAzYSC4qPR74yvXuSKx6owVL47JgcwVERvfob8n	10575	3NKRLSppTyvC8sdyi5q2GDySX5rDfHznYdQSLrHwzGJrQEBXNzXZ	1624	968	145	6301	7025	jwuQXoBc5XfyUD9KTw6Y1QpNTzoXcb6jnPyQESQJRxPh9SiJVps	5462	7719	7719	1617328620000	canonical
10578	3NLRMCKyPf2kE2tw6zhCxRUrffafREn4JjKGErxETgjMapTBfYy1	10577	3NKgVm5cYorcMMAzYSC4qPR74yvXuSKx6owVL47JgcwVERvfob8n	1406	1393	145	6301	7026	jwiRmTFxJWaHCios3fNFzCG6srrDtWHfKHnn26QkjDvFfCTtBAd	5463	7722	7722	1617329160000	canonical
10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	10579	3NKf6NEsGGWBi3JuL691caPbprquB4cr7XFLnCVirUPHceLR68hx	1490	1028	145	6301	7028	jxhfaD67V53KKMnddFpWWMSxZg6sRdHftCrSKZJz84edFBnixj4	5465	7724	7724	1617329520000	canonical
10583	3NKfhuzYrKmFTMikU7L6d6WGXVBGbSEbZ8prd9yLjJBNeJbSyRfD	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1407	1395	145	6301	7031	jw7bhGVQLvms4nKHYmKCKm1czaTCq3sNmq75sfNeZDyYfmfXCXU	5466	7725	7725	1617329700000	canonical
10585	3NK85sn3ncGgxhVsCc1fWjJDuXDZEVXEGEfamghNMYJ2hdvyFryH	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1581	778	145	6301	7033	jy1HmMqGdYx54Jgfi2wgxEdCu1Sq9VMz5VRnHgdjMzdB5voJYXi	5466	7725	7725	1617329700000	orphaned
10587	3NLwc3iKR4zZhbSDixCKtqv2oJ6zAkVEAM9najCNyPYVMySFEUTQ	10586	3NKCFWFW6HERKXHi63MPr7Vx9b3h2fwhuVev6fCuPFaHdBmdmu66	1403	782	146	6301	7035	jwXD8ekvYZ97QE4ouRXgrWWaTYB6vBQcXWxMmFvHN59FENFrq7w	5468	7727	7727	1617330060000	canonical
10590	3NK4nydL9FqAyDQwzZuhEWCYTqmekfq2nK1zdDLsx8kEYUYxq8Gc	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	1594	1200	146	6301	7037	jx13Fc9GpEyapgrd3HGsf7CnDuk5E8yVUuPXwuwYUvo5Dow1W9V	5470	7730	7730	1617330600000	orphaned
10594	3NL3T1bWK3mGwPAEMpTRxGdN1riDJiqMBUFCfpgtpRo9H4CpJpzt	10591	3NKD13t2HXv2VrkxFRxWqGr1a8NSbiuyTu6HtyfYt7UEu2uGvCLz	1406	1393	146	6301	7041	jxwMgQJEwGXZFGRyFBmB37EES8UQNtfTzqd9tk2yDhiqcQPyRnJ	5471	7731	7731	1617330780000	canonical
10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	10598	3NKZu8pWWH5qtjd4tuWVLtrRUs7KyTrrmczHJ98DaDMBdGgi2f4T	1555	1347	146	6301	7046	jwd9gb36kiqWRSxcr69Lx22pkeguzNcuJPWJLnoNqXizJXrJVDw	5475	7736	7736	1617331683952	canonical
10602	3NLbM5aLkd8nYw33g5yx5Yw4zoTWE4DupaP9kshYK5tKzSo2QWqY	10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	1601	1142	146	6301	7049	jwaZ94HzSQgDgn7X7D3G1982ckjtkuiBpMTVZ2KZorM5EJn9vvN	5476	7737	7737	1617331860000	canonical
10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	10605	3NLJTLu34kaQTByX3iCRDpMsE857hn6o3N1TGxe25io2DurUKFKC	563	1359	146	6301	7053	jw8qETgtAH9FhuXQgCBKh5vRsQdrjhah8cBVE3Sv6hgVEor9TWv	5478	7739	7739	1617332220000	canonical
10609	3NKpuSTcATFrdzaWiWWAd2aNrjy3VUr6paRuwxhh9YwdtP4oNH8R	10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	1607	1102	146	6301	7056	jwqV9DCncfR4shVDW9f2SyWaufya9L8RBxFP2BaBHfQG2RAkL6T	5479	7740	7740	1617332400000	canonical
10613	3NKHY5RecJrnfk6jjiFzVSodYXh5ZfTKTj1JfWJ9CZf8aFPykPbG	10611	3NL78E69ki4biJ9rpUvFF6Lm7iXezw7MMDh1Nu3vvj7oByGYNgk6	1403	782	146	6301	7060	jy18jAicL1Uoxor7nvUq339gDVBabDQPKVu8pq1xZNm8S6RmKnM	5481	7743	7743	1617332940000	orphaned
10616	3NKwFnQ81U4MS55Em2MM8wwRbTV2ULuZeejTiGWbd6PsaDhKLYR8	10614	3NLmBLn3K4tc5HLdVkaqxwb32MNTH3H2Q69X3tiJn4qtEAqNsvas	1623	839	146	6301	7063	jwS54iHEMd7tHPRwWNSSYetAvNRkqZrnLXXEU59Zt2w7VEyMFTy	5483	7745	7745	1617333300000	orphaned
10620	3NLRCLfVBwGj8Ekz4YvGwn7h6XXzVNbyAQjnkrBw9GDzkYPek7LN	10619	3NKuY4EkTPocpWw885oPJZLx65wVvxi1fHUBQWjuMDVXUebFNVT2	1637	816	146	6301	7067	jxWNuKt6424HdPwJG1hotkJXmNtfmnXW9ZkUMdA4aPKcKaASb1o	5485	7748	7748	1617333840000	orphaned
10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	10629	3NLtbxsk5H4H9SVvBvdS9FoNrC5QA3WnjXh6eC8sbxEpW5sF6Ygj	1406	1393	146	6301	7078	jx1bEXpALptF5GUrpxGgcGxsiPpdr4Fqn4veSYkj999Ritmgkuz	5491	7756	7756	1617335280000	canonical
10635	3NLUnanRNqSPh8ikpEbsEBNYfN3QPREXfA7UqWBZHNhYHfLiAVFd	10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	1542	51	146	6301	7079	jwu6hGypZE8ESexzTzNXFnVULGGQz61w5FFdnXrZ9ATsAGyC81c	5492	7757	7757	1617335460000	orphaned
10640	3NKqKFBBBfYoWWGgUWcj7WWFw2eDSv99bd8K6hWuYAErKvcUvwnh	10639	3NKHtemDQVjbYiYcck5cjVUJbhmPUw8jDb1qMUxnb5sVeHsAhrro	1406	1393	147	6301	7085	jxzca3UdmUQJF9PuYGgjJamyT8ZY5eejJrFQipadsJzPZp6BaMS	5496	7763	7763	1617336540000	canonical
10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	10644	3NLXbMx6UUbPtKjX89E13pWQ26wutVhGzCduZyo1x4Uod9d22z4h	596	1060	147	6301	7090	jwsHocLzP61jqY9MSWXfaCWcum14SK1QjM159HMuQ5kiVsPrYdc	5499	7767	7767	1617337260000	canonical
10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1536	1187	147	6301	7092	jwNtgLjhQVdXdhpJDppDSc9nA7Hpkz9XcsDYhrPevT8Fm8EZbjA	5500	7768	7768	1617337442386	canonical
10652	3NLvXuRoTGXiA4tbSbax58wBpHUiwRPtpqEXuLHDvK7rg4HL8E5v	10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	484	1319	147	6301	7096	jx4RTgpfWXhHjeZZyuBvhqABZidmFNpiweW6aam4HpcTmTSTV7r	5501	7770	7770	1617337800000	orphaned
10654	3NLhDEbw3ALRtcV1icTYN3oKDtLwaZELnNFVgUJiW9q85jxVFdzm	10653	3NLEMMxqNhMZpXUwj9wV6i16gY36HNrkiKRBp7uJgFV7GybHf248	1406	1393	147	6301	7098	jwoUqTxJGFwhKVjuRfCRTYBMttX7E6acuFyJBmXBq9AJXss19uh	5502	7771	7771	1617337980000	canonical
10657	3NLSZPpPyq2hU9g5Apwih9vgcNPgADv4pFeMmVHEdp4JQpNygvR8	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1637	816	147	6301	7101	jw6zDvs1J6KEpFqiGvjor7ASL7dw3YxLkimmVqCELEKT3ETq7EL	5504	7774	7774	1617338520000	orphaned
14406	3NKtREMXLdQgmYTspZayaVJHAtR43VV5HdhrJgdexWLCApWuxBqg	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1553	776	224	6301	10514	jwsGB2tvLyhR7JVjmoVtPpHQhgSmq7WmaN9yi496CcToT7xaR7o	7350	10397	10397	1617810660000	orphaned
10643	3NLiXWPiTH2SWbwo4BG6fyhitwd6u5R9Zs4ubakUn3g2XhJcT2BX	10478	3NKECi8WDg766KwrPJJe1H4oyZBMMutUjzx6DgKxqVwFvT8PM6cd	1654	1340	143	6301	7088	jwhLmtraaVy99pPuHU2dRm9tFBHC8cgYHCYE673kHkfd8u9ksEX	5413	7765	7765	1617336900000	orphaned
10662	3NKN6W3rZ76LPPy6vNvtcvdqG21jm91FQ7AqqeoCB714cnxwcdUZ	10643	3NLiXWPiTH2SWbwo4BG6fyhitwd6u5R9Zs4ubakUn3g2XhJcT2BX	1654	1094	143	6301	7106	jwG6F7RyKrBMunVi37HJyApafiEDHV7dKoJ3DyPLdbFCwRuHrfj	5414	7777	7777	1617339060000	orphaned
10556	3NKgCAZFTNC12UZ5GLQwhE9Gjsmbecd8ksFPBSfJ7zT3Hg37adD2	10553	3NLwP5aU3otd4hT5pcsWsPidbWfPPGPdwPf4mHBV9FfYougjGcP1	1403	824	145	6301	7005	jx4pExmiDKq4KGLLKxaK4H8kHFNDnAZo4HuZULTCkeMEUTBda2b	5450	7704	7704	1617325993148	orphaned
10559	3NLwL3pRmoU5DeKhRdf36XzJCRFB71aeAKuwGS8zNL7LNqtDpra8	10557	3NLN9JGfti6wE8SJekeBMUwwmpARcGK78A1EquuXqMno68KfvY8b	1607	1102	145	6301	7008	jxm4GrRbbzyxBBRC87e6ixYEANAzxbnjw91WcJGPW1U2kRKoxD7	5452	7707	7707	1617326460000	canonical
10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	10562	3NLA9eGrx5Tt32TT5C5saKrKTBC7Pv9edY7Hvw2oRLpaiykq8cYS	1503	1031	145	6301	7013	jx1xzGfrR14CNFnRWyMWxJk4JxHKxCU3JBXikcPN5C7QaxWioVS	5456	7711	7711	1617327180000	canonical
10571	3NL2BdTC1x7kJi8gHyzrromKJGtGgbWusK4BvSH7TLSfUu97hQFi	10565	3NLyQh8pmqqpwc7UVCng9h4EzrJhszenkvgAEm3DrBsTjt2SuWro	1553	776	145	6301	7020	jxTvM34P89F1QL5UHk7716QVajd9mn7yU3pEhPr2tFaYWJS8NiY	5458	7713	7713	1617327540000	orphaned
10573	3NK5ytfJDXg11P49y69Q3mjsio1fQLbWTjjJYMfciTCvdVQMa1Ye	10570	3NKL7NoKFCtpcADcKUyxs5cRft86MwBhA8RgUFVMFok53mE9K77z	470	1309	145	6301	7021	jxPTpYS4e6Scnv7Vjf65WtgGg2NtjoQURAAfnpCEuV9avmtjT7C	5459	7714	7714	1617327720000	canonical
10576	3NLddtcYca7mUVLSF8ozjLxxyvyFUV7wEJG5JMeHhQrJEMgC6kiL	10575	3NKRLSppTyvC8sdyi5q2GDySX5rDfHznYdQSLrHwzGJrQEBXNzXZ	1637	815	145	6301	7024	jwudFMVj3sZAhoDqTf4yeU9MRDf4tbEcrc8VQziM8aJXJ4NAU47	5462	7719	7719	1617328620000	orphaned
10581	3NL6H2gWeeXz4F1aBYtVqhuPKFXoXLWfSyZWYHxaNFgLYuVcHQqy	10579	3NKf6NEsGGWBi3JuL691caPbprquB4cr7XFLnCVirUPHceLR68hx	1406	1393	145	6301	7029	jxzkRrruWnWVRiobg9ZqdqtKBHEHujmX7Pe9DWLZw3vUn4UPxWr	5465	7724	7724	1617329520000	orphaned
10584	3NLnMyS45fti42hPdQBisYEd5XHp8jxRmU9EurkWgXEFCfWCtHod	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1403	824	145	6301	7032	jwigp4CFk5UUZj8fJeXZLhZQZdGxQhXe6Mkm3dZNLn5we7Y9uGz	5466	7725	7725	1617329700000	orphaned
10595	3NKRFSBVPKgQRqK1LcHeBsoQq73H6yrvCuq2S98cU3WBWVim1dh4	10594	3NL3T1bWK3mGwPAEMpTRxGdN1riDJiqMBUFCfpgtpRo9H4CpJpzt	1402	852	146	6301	7042	jwYvFQEctkm6gPWiXB55DHDeF7jAvbnGLKgunU5CmUGFj9ppbwY	5472	7733	7733	1617331140000	canonical
10597	3NKua5kjA72TGpFZH8y1VtmksWZBYFrtvJ4gMqWG1PDvJ9mJrz2F	10595	3NKRFSBVPKgQRqK1LcHeBsoQq73H6yrvCuq2S98cU3WBWVim1dh4	1403	31	146	6301	7044	jwTRuGW6QDYGnipjQyfhkWZeGY2Ksofx9ERArcunags3hGRGwn1	5473	7734	7734	1617331320000	canonical
10600	3NLPAwzYdukcT4Wkq6FH9kH53RgzB3dbHFgGpWyKnofYCd9pecqy	10598	3NKZu8pWWH5qtjd4tuWVLtrRUs7KyTrrmczHJ98DaDMBdGgi2f4T	1624	968	146	6301	7047	jwiyLH4UwxGP4TuLZAk73RgFJyq6fgWiAHqWKJUaMGJ3RJN2mTU	5475	7736	7736	1617331680000	orphaned
10604	3NLjnAXvqaf7e3FP9G4xWsXkeZmmmBF8xo5f4J9HZJy7xQwLmiPm	10602	3NLbM5aLkd8nYw33g5yx5Yw4zoTWE4DupaP9kshYK5tKzSo2QWqY	1631	794	146	6301	7051	jwq4NnPmaB2C5cL2VWBrwuPmNW7pm7p3GRYgxRj2gBK7JYwxMmU	5477	7738	7738	1617332040000	orphaned
10611	3NL78E69ki4biJ9rpUvFF6Lm7iXezw7MMDh1Nu3vvj7oByGYNgk6	10609	3NKpuSTcATFrdzaWiWWAd2aNrjy3VUr6paRuwxhh9YwdtP4oNH8R	1405	869	146	6301	7058	jxYLRpV6s3sDD8VPbMVBRNSCMoTKfAUdjziLVzN6bTiHkfdhU35	5480	7742	7742	1617332760000	canonical
10621	3NKk34FUaGsMxMxvfqKbf2V78iuvuRivNxkkPpzMf55jHyVGYMxP	10619	3NKuY4EkTPocpWw885oPJZLx65wVvxi1fHUBQWjuMDVXUebFNVT2	1627	1385	146	6301	7068	jx78HeUpKudLUMkF71CqXvp7tSb5QUZG627D4GMpFyRk1T2zsuv	5485	7748	7748	1617333840000	canonical
10626	3NLHy5h8kEoeQGYvdxrrcUEud3oqkECZcoH1zUkxG8b9G2SwvpUh	10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	1403	824	146	6301	7073	jwppgkPyzLYuH3HoeB2R4UE8TkvWNUyvUVhw5231pSwfASfX7k2	5487	7752	7752	1617334560000	orphaned
10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	10627	3NLCcebW6pwnvzc8SNptoLvfWR6c1vaL3np5W8YWcTm2h7Lxj5w9	1403	780	146	6301	7075	jxoDaR4ofRNyh4yy8NeZzKKWizHL6yrHATWU5kvjfE1Hg5V3yTx	5489	7754	7754	1617334920000	canonical
10633	3NLemWWMDpR1gvwkRsC3KLEyvoxQbB5czHRGDwVDF2th9Jc3r1o6	10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	1542	51	146	6301	7079	jwCAfouyZ2HYj3gMcXjXaEVimJBUybKrzCxd4vQ9pEszCv7fu6J	5492	7757	7757	1617335460000	orphaned
10638	3NK6RhTp6BrVvbaCKaLtxvFQKtk1MDTJDcyRp7Mp96Sko6Kn6iTM	10637	3NKSVMBbiLN3HstNkQUZVaNsfoMzTgh4wsBS1eejfSM6CXW2WVqo	1457	1391	146	6301	7083	jwULnjzQtZKuafmw6Qy4T1nFBEWo8vu79zEZDmdJb2eB157YZza	5495	7762	7762	1617336362449	orphaned
10648	3NLWRa7y7rRM94ngMiqhRsaudbsMWWayip1v9C6DhCCmj8w4WVQc	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1646	1108	147	6301	7093	jwcktqmxVngGhQN2EshQ2YfQ2yHnXn9mo6k4ZtN8JZ91nPVHRiY	5500	7768	7768	1617337440000	orphaned
10653	3NLEMMxqNhMZpXUwj9wV6i16gY36HNrkiKRBp7uJgFV7GybHf248	10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	1560	1291	147	6301	7097	jw7RPZ9ByXtMJHXxoBgGt7RA4F1YsJR5o8ZLdsww9MZCxG3uKMe	5501	7770	7770	1617337800000	canonical
10658	3NL7kZByJ5fKbmCVWzWoPuFiMQeLtfBcMSepr57LDhqPUia99ffh	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1506	1373	147	6301	7102	jxEJaQeiwr2EBRDvAbhApKqJL5hssKRoh7Ge2zs1Leh4Sjz9JVJ	5504	7774	7774	1617338520000	canonical
10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1623	830	147	6301	7110	jxYSanaCdNYcCd5DMiwSFKqXdWWeyi8HDwfdKyzbKqC5LdPavfu	5507	7777	7777	1617339060000	canonical
10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	1553	776	147	6301	7113	jxrVEEnkta6anA519dJchwYebyUARkvgurnDASdV6qZBbBemw8r	5508	7780	7780	1617339600000	canonical
10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	10671	3NKQHVryTUNmXbCLB3u3SbYcoEkrHHdj7iwM7ovYLY2KrriApJ3h	1634	1331	147	6301	7117	jxt4v1vZmR5kqkFdkVaZFc2XfCbJkdDijmoB9Sw7HsmVbcM3wqP	5510	7785	7785	1617340500000	canonical
10677	3NKZiemzFFxdYzPXitzCTvJkuJqQQwvVJSk5egQLT2kHexJWP9bE	10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	1406	1393	147	6301	7120	jwHyvfswjUjxQ5fEFS1cBdwqdGK9zhEtUbdUG5cZjy6WRGN1VF8	5511	7786	7786	1617340680000	orphaned
10681	3NLHVQyeceLSteYGRTSuzW9kF5gdomswEarFqRfz97BQCmpLDNzb	10680	3NLrvZB9duVCmNxEAoG75Nxm1wVM7Y276vZsnkXEbWBLanD84LBZ	1407	1395	147	6301	7124	jw9NRCv75UnVKuRzw2qUZ39C9PNohU2cBy9uj5xKNRzPKZZZjfW	5514	7789	7789	1617341220000	orphaned
10683	3NKLPRQ4odvDp7tU2nzDCW2rPckDXTEdRTY2vG1dCA6Q85uhSmNj	10682	3NKXKokJJfU1LnjZw8J7iEWvnWtXfeY8PEHh9k9UZUmwbNCnwWAD	1403	824	147	6301	7126	jwpqJnwhkTUzTn6KqYZbXxG2XHAYFfMRH8zj2km4vs6dSqL1WWu	5515	7790	7790	1617341400000	canonical
14409	3NK8KTz2qREmKm1qyupFHRqRmsB9Ks6fKoYft9EQd1Nj5zCKMMJH	14402	3NK6yxdPACVKK1514e2veBDzQBbiojdUTVDK2gYRNo4tA2sd2TB7	1506	1373	224	6301	10517	jwsj4Woxbsbe94vaNs7nuWYqJMWUecZBhinwmpokF1A1sB3pXAK	7350	10397	10397	1617810660000	orphaned
10562	3NLA9eGrx5Tt32TT5C5saKrKTBC7Pv9edY7Hvw2oRLpaiykq8cYS	10561	3NLs28T3at61pTp7Ji5BiwaSoof7HXERZWxrbxQLU8wcxeXR1WPd	42	1361	145	6301	7011	jwKJRyQyfNv4S1LZi1ivzgXi5r2J8X6wJSXBg7WPGEsGbZHLHku	5455	7710	7710	1617327000000	canonical
10582	3NL6eLpKcr9JqYjDVQ4W9MWSHUkxVANbkx6R8zh5U2KEt9jZzcnR	10580	3NKSDjqDaYkZ6cjVsvjTr8hNXDARTDJb1WcDC6PJiNRP78q1eQqx	1451	1292	145	6301	7030	jxrvCymqWwUbVRn7ZM2xSP5tV1r4Zw8oXkjEPfkZiEZGoHf4MgL	5466	7725	7725	1617329700000	orphaned
10586	3NKCFWFW6HERKXHi63MPr7Vx9b3h2fwhuVev6fCuPFaHdBmdmu66	10583	3NKfhuzYrKmFTMikU7L6d6WGXVBGbSEbZ8prd9yLjJBNeJbSyRfD	1402	890	146	6301	7034	jxJ7pT12SdKEUZ9WR6SQwicxsuACaa2u9vnYuw9fLviBjqDi4dx	5467	7726	7726	1617329880000	canonical
10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	10587	3NLwc3iKR4zZhbSDixCKtqv2oJ6zAkVEAM9najCNyPYVMySFEUTQ	1448	1311	146	6301	7036	jwt7aTM9xTrFb63o3yWNNBS5TNX2MM7s3oju6iGGpd8zAcBYF8p	5469	7728	7728	1617330240000	canonical
10591	3NKD13t2HXv2VrkxFRxWqGr1a8NSbiuyTu6HtyfYt7UEu2uGvCLz	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	1406	1393	146	6301	7038	jxcu5qbDoN46cNEJhtLNdiV82HBPDDpqx5V5f6wukJK2owBScbf	5470	7730	7730	1617330600000	canonical
10589	3NLxdZfUp6XBYCeLe15E46c3uDVgumPpSaPkGStfRJMjLnztGCHz	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	1594	1200	146	6301	7037	jxAaPFJMcAfKShnyuMZnWqmrBQJSCjQ9CSSVBuizFeEeKhfvbqh	5470	7730	7730	1617330600000	orphaned
10593	3NLPT2Tyjmc8vyPAxpSULDT14BoSUrRBjeTgQqCV1RrUQi4tFNFC	10591	3NKD13t2HXv2VrkxFRxWqGr1a8NSbiuyTu6HtyfYt7UEu2uGvCLz	1407	1395	146	6301	7040	jwbZLcezrMtretgmjHrTLhREwQ8KUJm4XaGxw1pMHuNYgf1zgFP	5471	7731	7731	1617330780000	orphaned
10596	3NKUtUsHwAYrKg74D8ddQqBVgf39aKXWTRHNrFkVx7qQP99JuKQR	10594	3NL3T1bWK3mGwPAEMpTRxGdN1riDJiqMBUFCfpgtpRo9H4CpJpzt	1406	1393	146	6301	7043	jwYGQWez6E71v3Z3EPkDKqyQzQWuk973GNXhVN6Ekujdfs1sDko	5472	7733	7733	1617331140000	orphaned
10598	3NKZu8pWWH5qtjd4tuWVLtrRUs7KyTrrmczHJ98DaDMBdGgi2f4T	10597	3NKua5kjA72TGpFZH8y1VtmksWZBYFrtvJ4gMqWG1PDvJ9mJrz2F	1623	830	146	6301	7045	jwU2s7DWTcJ3ALEE9qMkAkw225bF7FeqHvx65cS2HprUrDusYkt	5474	7735	7735	1617331500000	canonical
10603	3NLv4GeNdVLQJ4aFP2mRfmDoRg9qi4susitDFp5TmRiupgmgihVF	10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	1631	794	146	6301	7050	jx3kXgGKsZKFuq5KXfggJ4oTkuPthLU5xTYUfAny4QvaGG49WgN	5476	7737	7737	1617331860000	orphaned
10605	3NLJTLu34kaQTByX3iCRDpMsE857hn6o3N1TGxe25io2DurUKFKC	10602	3NLbM5aLkd8nYw33g5yx5Yw4zoTWE4DupaP9kshYK5tKzSo2QWqY	1461	1271	146	6301	7052	jxCHUcBYXVhQwQrB6rLdamVr9QU2Xu7Pb9Y28f9zeiiUfriazB1	5477	7738	7738	1617332040000	canonical
10607	3NKHh5QfhHWpUtUMnGQzpebEiBieEGsu9vffbFoDXRJsMmg9J554	10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	1407	1395	146	6301	7054	jwfBUVGSaZpmYkJrSqzw6AbJUqFLXmagG2PNT9HCfkoZ7xLSqQ9	5479	7740	7740	1617332400000	orphaned
10612	3NKVoMxBnGVhXh3WDpY5zWN2W957GKTyDMGcajP78hwkzx5TviUD	10611	3NL78E69ki4biJ9rpUvFF6Lm7iXezw7MMDh1Nu3vvj7oByGYNgk6	1637	816	146	6301	7059	jxXeMWMbYxQzzEhY9qWu14KrfFzGp1PM9EJ93QuV25f8F21zmkf	5481	7743	7743	1617332940000	canonical
10614	3NLmBLn3K4tc5HLdVkaqxwb32MNTH3H2Q69X3tiJn4qtEAqNsvas	10612	3NKVoMxBnGVhXh3WDpY5zWN2W957GKTyDMGcajP78hwkzx5TviUD	1656	1343	146	6301	7061	jwuTHZTi2ympWfuxNJkLzX1dRmiuwxMEWi7XQFecqddHZ8ZgRru	5482	7744	7744	1617333120000	canonical
10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	10621	3NKk34FUaGsMxMxvfqKbf2V78iuvuRivNxkkPpzMf55jHyVGYMxP	1406	1393	146	6301	7069	jwFyfyQSo5B7uhZBFJF9Won8515XGSWKruBZ7S9UCGQZJHRXzEB	5486	7751	7751	1617334380000	canonical
10624	3NLbYDKgpJe1e1FcLq1jiFXp96dxCU1DSXrkxJtWBXqjZSMLVzKh	10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	1407	1395	146	6301	7071	jxe7YFqokpZi66uZNybN5T7oxE4yDaVUQLvadY14USbG5NR9MYc	5487	7752	7752	1617334560000	canonical
10629	3NLtbxsk5H4H9SVvBvdS9FoNrC5QA3WnjXh6eC8sbxEpW5sF6Ygj	10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	563	1233	146	6301	7076	jxuxaFJEBXYKidcYkzCg1vz1MEgaSBiywJ9AX5dj6YLvsjqskzi	5490	7755	7755	1617335100000	canonical
10631	3NKfDqULh87XQ8kWyvzDSa9Hy7LrcmXzDaWJBgdzxkZH9xNrAn9A	10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	563	1233	146	6301	7076	jxWnQWfHNRndJSuhXG7Fi9bB6eDB7BEQoPQFsYHTdJLGs3gbEbj	5490	7755	7755	1617335100000	orphaned
10639	3NKHtemDQVjbYiYcck5cjVUJbhmPUw8jDb1qMUxnb5sVeHsAhrro	10637	3NKSVMBbiLN3HstNkQUZVaNsfoMzTgh4wsBS1eejfSM6CXW2WVqo	1549	1236	147	6301	7084	jwSkQejyH96yX9hjBm5hx1cycVMc1ifiWTELTSQxwsF319PSMUE	5495	7762	7762	1617336360000	canonical
10641	3NKLduQZvLzLZR1STZNWRN5MaykP21dbvEJJBdHtx44LV8mB7sqz	10640	3NKqKFBBBfYoWWGgUWcj7WWFw2eDSv99bd8K6hWuYAErKvcUvwnh	1407	1395	147	6301	7086	jw7SPrHzZu9m6kqs3e53TZk4yqX4qeECmGXWT1ETPxLQBVPqVkW	5497	7764	7764	1617336720000	canonical
10646	3NLDqfpuKVKFohtZQFYykGGEZVAaovkqdFQ3CXR2raeKJMgW27Do	10644	3NLXbMx6UUbPtKjX89E13pWQ26wutVhGzCduZyo1x4Uod9d22z4h	1406	1393	147	6301	7091	jwsJxsJN9uJmiprNXFGdP8yUUM3UFUpyaLyRs454pCCVQyLdorc	5499	7767	7767	1617337260000	orphaned
10649	3NK4FuwBxrkjGshHgBe6AvhjsCUqXie6WJNKwkwS6zyQXY2mGkkC	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1536	1187	147	6301	7092	jwNtgLjhQVdXdhpJDppDSc9nA7Hpkz9XcsDYhrPevT8Fm8EZbjA	5500	7768	7768	1617337440000	orphaned
10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	10654	3NLhDEbw3ALRtcV1icTYN3oKDtLwaZELnNFVgUJiW9q85jxVFdzm	1600	1006	147	6301	7099	jwm44YieLFmn1RoNBmCoUsZVCdBdWidrCoPHrK6rWceoRkSb8R3	5503	7772	7772	1617338160000	canonical
10660	3NLDyhS9tRnA7kzahPnboq26Aa4oMiPfuyfvyZu6fJKmL9uZir4P	10658	3NL7kZByJ5fKbmCVWzWoPuFiMQeLtfBcMSepr57LDhqPUia99ffh	1648	1284	147	6301	7104	jwyA8FuDoXu5DJ2h7ymgGt2Viy8b8rNgKieT2TyVqFCjqc1vRZH	5505	7775	7775	1617338700000	canonical
10667	3NLZ8JGad1SDXMuJmUw9nqopK27Kob4sEHf3pcPua9hvNJdnESTe	10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	1471	1020	147	6301	7111	jx314FmuKpTccebX1pe8pdQzZnRajxWWAwebcw2nYoQqhZYUZ8k	5508	7780	7780	1617339600000	orphaned
10670	3NLerWk88N8vBAKfMBLiMFQhzi3uA1cyqBpFEFCkvc8QaeRLr7oZ	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	1599	1287	147	6301	7114	jwgzWkkFspuxoWD7ox1T64x7tqPCh2zRFdCVKASbTxRpRx76jZc	5509	7783	7783	1617340140000	orphaned
10673	3NKa2p8aUgNfUdh3Gpw8bcYRsThjAmnqYcxqCqCgiJea8MAb3x8X	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	470	1309	147	6301	7116	jxSJPbyk4xSW7qQU6wMqhzxkSmwREPrfUMzNV7iyqizdurj7xmo	5509	7783	7783	1617340140000	orphaned
10679	3NLHPNNcUXdDJ2mRxxQT8nuQzgw4njYF2GAUp9qhN9j693XgVdcY	10678	3NKMaGbTnknJuCPSpREbxnMYVRvZYb6wYCm99xn9ERFiv1HnJBXq	1506	1007	147	6301	7122	jwtWnN8sP6HPJgYUaYh1CHUTj7FwRhXk9nXVkXzTsoyaMdUHuUw	5513	7788	7788	1617341040000	orphaned
10682	3NKXKokJJfU1LnjZw8J7iEWvnWtXfeY8PEHh9k9UZUmwbNCnwWAD	10680	3NLrvZB9duVCmNxEAoG75Nxm1wVM7Y276vZsnkXEbWBLanD84LBZ	1402	850	147	6301	7125	jwM9L5R7ndo8d4xVATgRL2aEMdVmbPxikusmoPgUd3SkwR2hR1X	5514	7789	7789	1617341220000	canonical
14427	3NL94iMMmZjLoBDwkFuRTxPxxhxVfcLy5emEyc4i2rKQu58Dns83	14424	3NL7gPQoeywnQQNz7jU1DMLZ4QeaBGqQ5dSRhbLmF131G9e3grTJ	1631	794	225	6301	10535	jwnL9MQv1qsxxWLxvozwb3ZjNPuEJADZgJXBDMjN4ZfZCKcdbUx	7360	10412	10412	1617813360000	orphaned
15611	3NKunhEWZezNgNjtAtU6Vhz7QNRNyRyZb9DKFMXEXCBGiR4BnMS7	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1553	776	251	6301	11634	jy1BBnSx1dFsdc8ncYsD5hCowet1K8f9qCZL19XARTRekEAaEhf	7946	11254	11254	1617964920000	orphaned
10610	3NLnQ3NvQAB8FfWThjgd3RMomZUfE6zyKBHaa8xVc2uLcHcsPyCd	10609	3NKpuSTcATFrdzaWiWWAd2aNrjy3VUr6paRuwxhh9YwdtP4oNH8R	1490	1274	146	6301	7057	jxRXYjtWonGAHksMEwpn2rK9eLKcZ1Vi1pXJn9fqH3sd3NPcozf	5480	7742	7742	1617332760000	orphaned
10615	3NKFPiRbfq9cGzUQJB1QFWFHsxL1wtHdJvo2SanE2AHp5qsZy4LB	10614	3NLmBLn3K4tc5HLdVkaqxwb32MNTH3H2Q69X3tiJn4qtEAqNsvas	1407	1395	146	6301	7062	jwwLZz7psVvZqK4jy66PajbBmtvB5iB5fhCDxRi1pKqmRHNwaFi	5483	7745	7745	1617333300000	canonical
10619	3NKuY4EkTPocpWw885oPJZLx65wVvxi1fHUBQWjuMDVXUebFNVT2	10615	3NKFPiRbfq9cGzUQJB1QFWFHsxL1wtHdJvo2SanE2AHp5qsZy4LB	1476	1005	146	6301	7066	jxt8oGQJFKC3GKLoGATsynAciUKvCQ6gqEDTV3uWwK18sqLn1Bj	5484	7746	7746	1617333480000	canonical
10617	3NKHZjYZt4ytSbZbyXWyHaTjKPU3nhDjXYjLw7Whnjq5uLUfGzkd	10615	3NKFPiRbfq9cGzUQJB1QFWFHsxL1wtHdJvo2SanE2AHp5qsZy4LB	1467	1130	146	6301	7064	jwFqXk59wUGZbZd99861FA7KguzkGunikaVVkvBUmtb4ZTbJ9XW	5484	7746	7746	1617333480000	orphaned
10623	3NKMLcYWrcya4MPbgkDmThfnEbmECDXNMJT8HwzA253o2DDibxen	10621	3NKk34FUaGsMxMxvfqKbf2V78iuvuRivNxkkPpzMf55jHyVGYMxP	1590	934	146	6301	7070	jxQgRYzXxSMomrMraZtH3iArdgJPPcrvgtgusumAb4e225ZYdQB	5486	7751	7751	1617334380000	orphaned
10625	3NL5WRH9FkQoY4eKYTiAjymLucVv7G4LJg6kRCzJzgFgroDkR6ZS	10622	3NLoHbK1QiGHzzMqnFbAfqec3oTHe6mr1rzNKDRwNbPFMZH9Hy1G	1577	1201	146	6301	7072	jwv8ktQAbgbhhPQpLxeEHhZXpsxJ6RJSJsbeEG3WuKDz6Z1WgAf	5487	7752	7752	1617334560000	orphaned
10627	3NLCcebW6pwnvzc8SNptoLvfWR6c1vaL3np5W8YWcTm2h7Lxj5w9	10624	3NLbYDKgpJe1e1FcLq1jiFXp96dxCU1DSXrkxJtWBXqjZSMLVzKh	1507	914	146	6301	7074	jwNqEbiNM7wo7BPBP93gXLkiuoECGhQ42tLEFHHiUe5u2C4zRq4	5488	7753	7753	1617334740000	canonical
10630	3NKBtZoJ5cdnNrRkiZvwnXp9tpMgoXgdsMf57oAjQWbKs1zaZmqt	10628	3NKbnE7JagGPz74brnnVUb7fNgki5VqLr4uSrcDnUY6VNEXRHLE6	1403	824	146	6301	7077	jwRqH8GXJqbXg1zDXZ1x8kZS5f5tBzHZqPWR9YJggS51CEFL2pW	5490	7755	7755	1617335100000	orphaned
10636	3NKvWwyEYJiacAE7n5BZursNm6yiJBrykNwEz9PSYU5avVkxiem2	10634	3NKe2iveVabJ49ohynM9XHstsNceRd1auSWrUY2gg6AwgM18wfPs	1560	279	146	6301	7081	jxyiseVA1KpDTEqZ92Hu1aHLJ4EnJEN2ZW5hMcUPzpoqXzLpD9C	5493	7758	7758	1617335640000	canonical
10637	3NKSVMBbiLN3HstNkQUZVaNsfoMzTgh4wsBS1eejfSM6CXW2WVqo	10636	3NKvWwyEYJiacAE7n5BZursNm6yiJBrykNwEz9PSYU5avVkxiem2	1637	816	146	6301	7082	jwK8HmTbXFZFMYjfgiuHNmcX9UpjEMfixFC5R4G4DKtUfBeW2da	5494	7761	7761	1617336180000	canonical
10642	3NKFnoUs1Ep4M69yDxP1jgMQAtqP79Cq67TFRk2TVQkmPkvKzQLD	10640	3NKqKFBBBfYoWWGgUWcj7WWFw2eDSv99bd8K6hWuYAErKvcUvwnh	1596	1363	147	6301	7087	jw6kRsjj5PbtKymronE8WBToY9UB4wTTDqvCpxmQa32c2msqRR8	5497	7764	7764	1617336720000	orphaned
10644	3NLXbMx6UUbPtKjX89E13pWQ26wutVhGzCduZyo1x4Uod9d22z4h	10641	3NKLduQZvLzLZR1STZNWRN5MaykP21dbvEJJBdHtx44LV8mB7sqz	1654	1340	147	6301	7089	jwHVcVry4YyFiULtHs8bWwXNPuQockX6KMsFW1MF7PZ1LFnEgXB	5498	7765	7765	1617336900000	canonical
10650	3NLfiy2NMpBisyinA6GD1kTrkXuuvNNkHPwcEzcJVwtDovSYomNx	10645	3NKLC2B9jjkcJH3vPT7LKXwLYD6Ei6Znwb7rYgp8SFsGQXH1aojG	1402	1267	147	6301	7094	jxT1u6T28pZY2qmMY8xnwMyrwSy4Bf8m8zPsZcHZGwJZ7hvnwdb	5500	7768	7768	1617337440000	orphaned
10651	3NLnTHeNCVM7re5kwfAMxxr1LiJ1wNvHci85PyNibMJj1cT89Drw	10647	3NK3TM22wuhD6y1Txim8HNgUwaxyB9VpymDQDe86e8PbvRUj3SW3	1657	978	147	6301	7095	jwZzBWWcALm5tCLzfupc71RLgs8YJT3DhA9XprXZrMBeuTeuZFH	5501	7770	7770	1617337800000	orphaned
10656	3NL94rvE6kdEJibPwVv8tTJ4wCv2ertJhFhQJdRG1k3sfjW9CAge	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1407	1395	147	6301	7100	jx399Guf7wV9swN5vcpUeGhqBdA8qVmTkyaZ3ZmTXx2Da5hqH34	5504	7774	7774	1617338520000	orphaned
10663	3NLT7H6AVvt9mnkXsHdy2AW7eX5FNpCtZFWCB15vYjeZRALx5hFP	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1455	1332	147	6301	7107	jxNJo6FA7SVR7gGhFFWFutW4qd9HRUc2VeudzSGxVA2xaqavyaB	5507	7777	7777	1617339062631	orphaned
10665	3NKm6eMMHk8xoR8JgPR36v3CEEVQTv6HgMGjYwNBEn2ofnd9VRa9	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1461	1271	147	6301	7109	jwJq8zKxLsLD5RBu47cAhvzdtUdE1DqUfo48mp7ftE1TN9K8epR	5507	7777	7777	1617339060000	orphaned
10668	3NKWbAodRJ3hYPnHjTw8cvEQvkCEWRUAb1yGTzfvmXjpSnTdFqkw	10666	3NLT4nqXgLyWByWKkkmAQgjdwyQCtLVoqmPPu7jJnc7DdcwAedqq	1481	790	147	6301	7112	jwAcNJZxQBDTKTknvi7psWC2iadkLhMZxRxsP53uVG9iEuEnyu9	5508	7780	7780	1617339600000	orphaned
10671	3NKQHVryTUNmXbCLB3u3SbYcoEkrHHdj7iwM7ovYLY2KrriApJ3h	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	1407	1395	147	6301	7115	jwP4An4ZwFGTQDcJKtJ2UuSHWQXSAvGFwmgjTDVBzWgxYhanm2q	5509	7783	7783	1617340140000	canonical
10672	3NK4JtDaQ8JMTPG6bNo3Ye3AMPrwWmp28B59Co8WZPFnVFrNzZ65	10669	3NLgSK22DLeAY95HCKaShoqhjS3BPpU5AsVaagDWbAjvxLRYgLhx	470	1309	147	6301	7116	jxaQ8qHrTgThh6UAWWeAfCtkRvTWMn8oieRMbyctcTykT9egMLQ	5509	7783	7783	1617340140000	orphaned
10675	3NKfxRMrFtKqY15ZL1TfwDrLhwAXJZpojymUF3yV8Xst53sViXqQ	10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	1617	1042	147	6301	7118	jxAYJqA9g86b41nuHZVsSPXaBgYRqJ8eSzFDu2JxJGgkzQMtj2S	5511	7786	7786	1617340680000	canonical
10676	3NKPxqc66X2t2CbfKWuKeVAuAMfNhREpLjpLe98GnnpfP7WkDsNn	10674	3NKApfPRrs4cGBooE9bggVLFrd2nLVRqAs5GDVJmNaJ4aRXjQae6	1407	1395	147	6301	7119	jx1yfwDPWmc8s1cLZjgsKtdCeJsKSD6fRaWt1Veop7kbsPdWzhv	5511	7786	7786	1617340680000	orphaned
10678	3NKMaGbTnknJuCPSpREbxnMYVRvZYb6wYCm99xn9ERFiv1HnJBXq	10675	3NKfxRMrFtKqY15ZL1TfwDrLhwAXJZpojymUF3yV8Xst53sViXqQ	1407	1395	147	6301	7121	jwPSW1D3sg2emj2HW1pM8SGu3trep2XQaHZcEC8DgEDzuYnNGVs	5512	7787	7787	1617340860000	canonical
10680	3NLrvZB9duVCmNxEAoG75Nxm1wVM7Y276vZsnkXEbWBLanD84LBZ	10678	3NKMaGbTnknJuCPSpREbxnMYVRvZYb6wYCm99xn9ERFiv1HnJBXq	1406	1393	147	6301	7123	jwKvPewxA5efBTmY2E7fMZb2toWN9YHFZGDjgPBrUAYTmy1CSfq	5513	7788	7788	1617341040000	canonical
10685	3NKJ7eXG9G644upfYcJnyPgSJ22HuoUCQ3EjM6VEzSEDVjCDhVj6	10684	3NLDSLjcHACSPu8BKT4FGpcs9KH2hHr1Ygq6xxeLuHZtcLPVU92p	1637	816	147	6301	7128	jx83WeRHjK9PbyNzyadpY5dUMcEwtRew3eqrBnnXX89rbZMHZJb	5517	7792	7792	1617341760000	canonical
10687	3NKZQTzFYhdNBPndPYeNqjXmsZvnirGYHQqVRLFtuVshRCNjbcYN	10685	3NKJ7eXG9G644upfYcJnyPgSJ22HuoUCQ3EjM6VEzSEDVjCDhVj6	1594	1326	147	6301	7130	jxJdZjJCWQJdjoXAV5K63evU6YiX3njEmMCYvf7X5wvJANXkrrF	5518	7793	7793	1617341940000	canonical
10688	3NKtjooSEMTQryssoLnxtoMHhubzmNAScndjhw4LHHpoPMnwtAXv	10685	3NKJ7eXG9G644upfYcJnyPgSJ22HuoUCQ3EjM6VEzSEDVjCDhVj6	1594	1326	147	6301	7130	jx2eghqghhx2EWxUKB5QpH7wUh6qrjufTEXCmhgu4urGgtJ9Kvc	5518	7793	7793	1617341940000	orphaned
10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	10687	3NKZQTzFYhdNBPndPYeNqjXmsZvnirGYHQqVRLFtuVshRCNjbcYN	606	1049	147	6301	7131	jwAEsT6CRVrpB8NhJJcAWbPnKb5SJjuMGvqpfnzbgDxEy42WFw8	5519	7794	7794	1617342120000	canonical
14642	3NKMZLiYb5Q9xmTqzD7kNQkRxDcB7bBqy8367PaonhwCLsLHg66j	14426	3NLnRpJAjP5bGtL7d2fZSu5YaY1kVGuoCs8GGCJJ5DkE2jFRnBwS	1601	1022	225	6301	10733	jwPhGTGfPHrqhkMmJCuaAaG7xoFzEUpyFpG17BmaCZ42MDXVKLi	7361	10563	10563	1617840540000	orphaned
10802	3NLr1SgutMpkemDNu33uxgQRYDEVsR7FgLCRpKPDvibBVGNBYhkT	10784	3NLKa6gU4RBJB6QPXGgDmzELGEZ6ypGcU75tNC717HUpuLqp476A	1633	1264	146	6301	7230	jwYtysRuocxauNAwdUtvoVFU9o49foZ3NGxcoza3kLuXhDmta78	5444	7877	7877	1617357060000	orphaned
10684	3NLDSLjcHACSPu8BKT4FGpcs9KH2hHr1Ygq6xxeLuHZtcLPVU92p	10683	3NKLPRQ4odvDp7tU2nzDCW2rPckDXTEdRTY2vG1dCA6Q85uhSmNj	1637	816	147	6301	7127	jx8wfjEKnUE4GjdFBUtp34C9KXftzecAmmui9vHt9HpEDftVwi9	5516	7791	7791	1617341580000	canonical
10692	3NLXjKY6cx5gDWnJZ449gDgHkL8ugyjvoRhpkm2o6zBT7C8zDn4W	10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	1439	1279	147	6301	7134	jwqrvqaEXc55bZsPHH7Fk9shYUSeZLDucEbWEMmJDu8WcYPkMnW	5520	7795	7795	1617342300000	canonical
10690	3NLbzeJs5kgvztsQToxQzdRAYsvKFizKg2jRftaYE7hUDVGDCSyp	10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	1542	1058	147	6301	7132	jx5U2NyNqWtKVQNuQZQ75tZo46vpnj3un6xee7DZd46ht9MLf3T	5520	7795	7795	1617342300000	orphaned
10693	3NKtGtUuk7qGztnTVfMmVUhm4pvwd5K5BJGxtWvUWFr1sWTiFYY6	10692	3NLXjKY6cx5gDWnJZ449gDgHkL8ugyjvoRhpkm2o6zBT7C8zDn4W	700	840	147	6301	7135	jwdUqobWnHJfFrhxFKAEVWhgAf4nc72UzLUMh7BjpykxMv19dKd	5521	7796	7796	1617342480000	orphaned
10698	3NKznNyHQSAETgvfEL1YQ7EMC5pLJANzpG3bYrVsJBnhCerei6kS	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1448	945	148	6301	7138	jx6wdQChfv7ae9R3XiyygtbVn1G7wS2Yq4AfZS2kWis9t5reJGd	5524	7802	7802	1617343560000	canonical
10702	3NKu9dkqou3AYYqRssxdDvkEShKztc1c12dDmGd4XJjBdFEeX2ZF	10698	3NKznNyHQSAETgvfEL1YQ7EMC5pLJANzpG3bYrVsJBnhCerei6kS	171	1374	148	6301	7140	jw9FDGgkj7dopZ7EPytknn2PvNkLb27Mfx53dddiJCp6KrNn4f5	5525	7803	7803	1617343744609	canonical
10706	3NKM1j3V74awtQg1U4R4HuWg4o7McMMniBrJV53y4NKsZQyuMdC2	10704	3NLfA5BihTfYAkMNzpfokXV8DtbpfpzBe27YfoP9RY8GSmNtFxvD	1555	981	148	6301	7144	jxBXyMVRuLEvN9FC72SRUvCB9ysYdFZwvtSvSvkphwyuUyhQjFE	5527	7809	7809	1617344824278	orphaned
10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	10709	3NKUkCry4nyV1TEv7se11nux8ZnzJnokGxHzZ5bHoFBfMc9bS7Uk	641	1336	148	6301	7149	jxcNKK8hmfhVBmvb8ZpRy9qLHYnrA9QEbfPFo8AA8fJpaGZjHSL	5530	7812	7812	1617345360000	canonical
10710	3NKLNPjydR8iKkTgAKLT2sFuAcxk9ueRZap2ZgWnQw1Y1PUqeHsf	10709	3NKUkCry4nyV1TEv7se11nux8ZnzJnokGxHzZ5bHoFBfMc9bS7Uk	1501	994	148	6301	7148	jwtgKfCfdrYEExU1oSYaV1Gmdx7aEfwKDdVoN7PgZ5iwtjm1ijj	5530	7812	7812	1617345360000	orphaned
10713	3NLuDjMYKP8SY625pvXAo3HJtEfYNT73Es5NPW4tQN3719qc3W2C	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1547	1252	148	6301	7150	jxFeQvEa9QxJKDjRFosNLXCtXezLaCHFRr5nYEU1to96RDLh5qx	5531	7813	7813	1617345544629	orphaned
10718	3NKFKQcpzmjuDaAG1yCG4YhA3fbtT8caFzjoB3pm3ghBrtLDtd8b	10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	1523	1195	148	6301	7154	jxfqCoTju4rjLHWcwLicTT6FE7mznbUh3zXCyptShS4YAhDB3P3	5532	7814	7814	1617345720000	canonical
10720	3NL6GgsDsVbx3NvkNvdi9cjXiViV3k5UUnwP47DXCfr3Umae5zZN	10718	3NKFKQcpzmjuDaAG1yCG4YhA3fbtT8caFzjoB3pm3ghBrtLDtd8b	1637	816	148	6301	7155	jwKaevKzncK7qjvgBE8t6phdq3WoeNGeqV5zc7yoqjbcaiDnXan	5533	7815	7815	1617345900000	canonical
10729	3NLyZQjRae4v8VT2kNMPUoaT1wSmJbEqffECNrCqMP8goy9j28MC	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1472	516	148	6301	7164	jxTPZwdE9SFh44qeBZY2evDytZbuuhQJ579TP3Du6oibLGnHLiD	5538	7821	7821	1617346980000	orphaned
10740	3NLo1rhF71rAxdW3vuEtmaXSKhLVPqj6om5LoKvhCaY57cDdPm1n	10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	43	1064	148	6301	7173	jxF1KZN9PDos32JAtU3NdeimpBSQPWXNf89xiP8Huc7h4owd6CV	5543	7828	7828	1617348240000	canonical
10743	3NKDvZYfXSDM9KRjatv6H7q9qnHkTYQ4HcZCnK2DENp4QtrAPTRC	10741	3NK9p91M3pNj3obcVAVzdcWxr4PRATftXDvKLevpK7AXHinXm2CS	1637	816	148	6301	7176	jxyerLbwtFUGhyPUF2Vme2oH8jMcBWPnkQaysXaDYTzzRnguoGH	5545	7831	7831	1617348780000	orphaned
10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	10744	3NKxhYa6T23aQmePDbSfYpbea1Aowqzfex9ddVXxneeZc27pnUoE	632	1382	149	6301	7180	jxYzy4TRperWg5yjAqaqEH8kjLrfGLGyn4X77rGF1iLNVtPnUHu	5547	7833	7833	1617349140000	canonical
10750	3NKC5ACgiT9x7stSXRH5ReQJcmz5XVzppYg23hHMGcNWxnoYSHcB	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	1622	990	149	6301	7183	jwyTXPe4okZjwjcYwnVBm4Skk9E9Q7yh3wgo656BSP2ri9Y5DGP	5548	7834	7834	1617349320000	canonical
10752	3NL6xL1rRaPveusHcLMvUFJu2VyBJaRL37X4MdgyivMoV6a8Y5Jk	10750	3NKC5ACgiT9x7stSXRH5ReQJcmz5XVzppYg23hHMGcNWxnoYSHcB	1553	776	149	6301	7185	jx3jNPYKJ6uRKCyD1XLFKeeRoR6s9CUQNCAFev8tK3bqaWTNJmR	5549	7837	7837	1617349860000	canonical
10757	3NLLtLjM3cVmnhEwcDQBaJMM8NykznVx6jpGKL4Y4hb3wYQgprnE	10754	3NKyNSN4iPqaGUL8eXNKz5cjXy5wk3vNR9m95a6hYDsfaqS9QrG4	1516	1294	149	6301	7190	jxdN9uVRzapdL18NDqhvGPxujKxRG2gPMRK3jbQqpvMm1eoPuAZ	5552	7842	7842	1617350760000	orphaned
10761	3NKpbWUqFCK16XFJEExQMGk6e3MAvyi5GU43kEq7oJAbs1jQh2Dj	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1553	776	149	6301	7194	jxczrfaNpVTmw2PaYh2NEzinUW4KEWrbVodvHHvgNZrspjmpon2	5554	7845	7845	1617351300000	orphaned
10765	3NKAS24DBmE7rJ5rh2NWyTaGQCgACP762qQFLnWRy22KVbj4qb72	10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	1397	828	149	6301	7198	jxGqffDY7qfvDNV2FPd2Rg7F5vFNmVdi31Pzaqq68LX6JAmeDvi	5557	7849	7849	1617352020000	canonical
10770	3NLDFJuYSEtBWfAL7A6R2JyHzs7V8Z2EwMJAvNjTd4KFuh6Hca4z	10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	1422	1337	149	6301	7203	jxEcn4EJQqRZYEMdFXXJGnMVMAy5vhMhssNQJGAQQHtYhemtvTK	5559	7851	7851	1617352382540	orphaned
10772	3NKEGgQLuTC34nNN7aUmyzwp7XzyCWBNZWuCoLY7zaYxNPaN9tkC	10769	3NLejUQ9Wc6bgRet4gMvmhZMxdziTbPBzpujzcSEQ5M29dAuEj5f	1668	1370	149	6301	7204	jwZwZR2r6JKVt66TktWKsNjX45KynmuxNeAPEjULyUsBjsBTBg7	5560	7853	7853	1617352740000	orphaned
10774	3NKhNREUV37PzXYDBxQV1UwpPJFoZYMLBuStJZYJqtTkw3Bw7SPN	10773	3NLprWf3UzqkE8s4s3Ruh5yiwxcJjZXTEhgX9zyYdAqqDuNXrzVz	1407	1395	149	6301	7205	jwbZ7X91AjZZDbbGGzEHXUyXC6yRwyubJVPjxo8ihaMeU3B26gF	5561	7854	7854	1617352920000	canonical
10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	10776	3NLTvMeFQEg6KAuyTjqfSQ3qEjyUtvAveVW1qWcFq9YLD68Vwmu5	1527	927	149	6301	7208	jxMFHG6UAnjEwv6eyBc25vtQRee6dke9m3UzJTP85VhPrcnCzhm	5563	7857	7857	1617353460000	canonical
10782	3NKF422hmbn42QdCvCpA3qcf8Q5iGVr1oD1JyMNQiu5o4Eegam68	10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	1407	1395	149	6301	7213	jwSL17odGau9iT8CnLVHb4uFH7wcMyxGMbcuKhDLFEha8Lz2kA8	5565	7860	7860	1617354000000	orphaned
10786	3NLLaDsGQwccNh5fYoUzzZa9G2qsDkvyg53nuSwZKp1L5LYZvvbZ	10785	3NKuU6aMBhMQ1wPdKqFuTNkZt73J2wStuFt4fpxdfUE9kdnRhWQ3	1602	1003	149	6301	7217	jwUDaUi59eMvwYvbx5aKSHdPjResJhv8JHoHeCMej3ncgf8UYdk	5567	7862	7862	1617354360000	orphaned
10789	3NKJc7tQR9jfg1Gcn6SGKH5EpxTEcTBgAgjjT2ttz85G242TJP87	10788	3NKMpewyVyi9HUFvwSBJWAdgbH3wTJAM8QWa7qySyZVQEUKkiGwC	1555	981	149	6301	7220	jw9TkyXHAQ9XqR32mQiJkZvUoftbMxYUSgSWFCPtReVWvJuXJMz	5569	7865	7865	1617354900000	canonical
14431	3NL8ng8byGvvrHL7YPTVfMVp7xL1h9L7rKv5LjVHB4YsQJPT6gLN	14428	3NKDYEWNhYMnkWr3PunMEJqV728LctekjzJwPMWBAP9nKzEkJTmc	641	970	225	6301	10539	jxYukPfjPiS9PmNdT912doKX8ih7uDNDzMUoDK53ZVjHACfo8Gh	7362	10415	10415	1617813900000	canonical
10695	3NLHmQggG46EEGbQ8WEgFAic8Y1mLHZfJDtk52F4Giy7Rb2CGLmv	10694	3NKH1ejF2aUzfW5ZQwrh3Wu9jZzi1M8oZoTLwAQJNYULfWRPdwro	1406	1393	147	6301	7136	jw8Ut4C34j2WSN7csXTxEEm1dXusPkPpfo45tmZBn7JRNqDuQho	5522	7797	7797	1617342660000	canonical
10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	10695	3NLHmQggG46EEGbQ8WEgFAic8Y1mLHZfJDtk52F4Giy7Rb2CGLmv	1406	1393	147	6301	7137	jxp1p9ESGHc6v32Bknh5xwv21N9sM1iTEgyYwgvHgsFKgKyATbX	5523	7801	7801	1617343380000	canonical
10699	3NLK5cYV7Acgfdoec8JrjQ8wxmEY699u8tWUGMjcSoGW2toNYvvq	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1508	1261	148	6301	7139	jwQVzVLhAodWqxCMkb3Z6W2UdpmEnuHiv4FpY5MGRGpMEqSzrZG	5524	7802	7802	1617343560000	orphaned
10703	3NKXZrcJXonNHHjbpC4xvmjuvqfKCkgVwXC7zG5xRtsjotcAqZyg	10698	3NKznNyHQSAETgvfEL1YQ7EMC5pLJANzpG3bYrVsJBnhCerei6kS	1631	793	148	6301	7141	jxAQ6nrDYFUR5iDF7aLiEMsqDaMsLnad7vP9vMZEykxvwp92bkF	5525	7803	7803	1617343740000	orphaned
10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1589	1286	148	6301	7152	jxXThn5DVpNSp8oj1s1KfwgeSuFYSUNqhVD2JPNXSPAm96xfaRZ	5531	7813	7813	1617345540000	canonical
10714	3NKtjPsoy7KEyVXZwYwoaDWYrsfUSiNdcLPSqg5qFDmftDtFgaLf	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1553	776	148	6301	7151	jwjZRyej3RGRkkBHUGdjCC7ur9uJfvJBm7zRrAzcVmSZUwLPqww	5531	7813	7813	1617345540000	orphaned
10717	3NKFZ7cHiJFb9NmMVBJZEUhCuC8ET9uc9uyeoGVBs8gEba6EeBL6	10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	1523	1195	148	6301	7154	jwoxpr64UpGBpSRsVyQtxdtRyasqYsYKdA1Tq2kRhyn9yPpEUNG	5532	7814	7814	1617345720000	orphaned
10732	3NLHiterrD8mUgBHoYxRtfngpTBqRjvQdunvDCYvnecnTF8errpw	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1631	794	148	6301	7166	jxv4KAYJ1o12qRCkkYnE5vw5rQZ32T2SGTWdG8LatqUCyLR1SFV	5538	7821	7821	1617346980000	orphaned
10736	3NKPjdFEnEL8khypKvjQH6Qi47tx22yGNejb6LYDZ7CerJ4yczRp	10734	3NK7Dk3E6Kcp5FJ7YEb6rV9vkA1DZW7KReE82n2mMHnnGw4fJmuX	1406	1393	148	6301	7170	jxDHRBzWDp2LoRShujoizrdrzuuBW8k4YF6x53fv2vLxGYHm3Wt	5541	7825	7825	1617347700000	canonical
10739	3NLDWHM9EcnS3C8i3Sk8cEpJRybtQZJrT6wCsSpFEXqcho2tVZBB	10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	43	1064	148	6301	7173	jxF1KZN9PDos32JAtU3NdeimpBSQPWXNf89xiP8Huc7h4owd6CV	5543	7828	7828	1617348245113	orphaned
10741	3NK9p91M3pNj3obcVAVzdcWxr4PRATftXDvKLevpK7AXHinXm2CS	10740	3NLo1rhF71rAxdW3vuEtmaXSKhLVPqj6om5LoKvhCaY57cDdPm1n	484	1319	148	6301	7174	jxVWbdiRutdjcbVe2iQrrXEtjo42Hjfb4GYFG6cQwzpSVbx3yHh	5544	7830	7830	1617348600000	canonical
10746	3NKCs2hDrFWM1spJpvBWR51r9jTPFyMQeHxwgXKyUK5YYD4oPErt	10744	3NKxhYa6T23aQmePDbSfYpbea1Aowqzfex9ddVXxneeZc27pnUoE	1501	1114	149	6301	7179	jwwtoPaRVHRcHcVJzKxcuaYUaTebBbPRCYP4dQBLWgrdiJgXTsz	5547	7833	7833	1617349140000	orphaned
10748	3NKsm5gxfC7sQwpgYrpaSxYxnPgSo9M6tVucT7R8YJpoAmBgnxzV	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	1483	534	149	6301	7181	jx9DQksmuRzGqyNSb3xZvqmAqQGzrRz3gYURPbxEdVR4F4gJQeM	5548	7834	7834	1617349320000	orphaned
10754	3NKyNSN4iPqaGUL8eXNKz5cjXy5wk3vNR9m95a6hYDsfaqS9QrG4	10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	1617	922	149	6301	7187	jwvJTdsbsBPmUo7TFznVuRZhngKw1eRF92fqGeqKp8Qp9gS8Z9u	5551	7841	7841	1617350580000	canonical
10756	3NLLEr98Ckm2VG7NYrgb32dhDm937TcvspwLgTyMy2LcjwSavPK5	10754	3NKyNSN4iPqaGUL8eXNKz5cjXy5wk3vNR9m95a6hYDsfaqS9QrG4	1594	960	149	6301	7189	jxnZFJtYiJ5qMh1VLEFctogQpAzVw8Bif17PHokGEW7dreJUgcY	5552	7842	7842	1617350760000	canonical
10762	3NKCtDQYja9A5og5vpm4g2MPCSufPhsJZUnSrySDGfrZ3iV6nEwx	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1581	778	149	6301	7195	jww23BA4kENiTfaSQ1sx4tCjzt2qUyc7WWzbSkoB69nZRs8Du93	5554	7845	7845	1617351300000	canonical
10759	3NLa1VoNWP8Upj6xTv3iytNHP1M4iMyM6QBxJVakPNtXVHsBX5m9	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1448	1311	149	6301	7192	jxck4hApYNMNKr4T9fg6Sd3oRXhQqodyG3ctybL1LcKXfMkMVNQ	5554	7845	7845	1617351300000	orphaned
10763	3NL83knf7cSqFsc7LddfiV9BjW4vEHiWnFjhGLQVtcfCiNid87gR	10762	3NKCtDQYja9A5og5vpm4g2MPCSufPhsJZUnSrySDGfrZ3iV6nEwx	1407	1395	149	6301	7196	jwJL5w83Z7h53cEwmbevoDMgbMUiuUickuyHhNYar6xLAXYGKGK	5555	7846	7846	1617351480000	canonical
10767	3NKB8YVRDRGHQZdZiGJ44BDdGsEVLosrHuDo2USyfh1APWFfQ2uK	10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	1631	794	149	6301	7200	jxurxWu7jdQtTJJ14koBvrAxXbx3KPssqMpuBtQCdJ2TNcxwDYs	5557	7849	7849	1617352020000	orphaned
10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	10765	3NKAS24DBmE7rJ5rh2NWyTaGQCgACP762qQFLnWRy22KVbj4qb72	1407	1395	149	6301	7201	jxCa4Hw634HRBFjF1ePYeuL1wqGvmMeZYdbdLaVh65T6RADEqdz	5558	7850	7850	1617352200000	canonical
10773	3NLprWf3UzqkE8s4s3Ruh5yiwxcJjZXTEhgX9zyYdAqqDuNXrzVz	10769	3NLejUQ9Wc6bgRet4gMvmhZMxdziTbPBzpujzcSEQ5M29dAuEj5f	1668	1370	149	6301	7204	jwZwZR2r6JKVt66TktWKsNjX45KynmuxNeAPEjULyUsBjsBTBg7	5560	7853	7853	1617352743030	canonical
10776	3NLTvMeFQEg6KAuyTjqfSQ3qEjyUtvAveVW1qWcFq9YLD68Vwmu5	10774	3NKhNREUV37PzXYDBxQV1UwpPJFoZYMLBuStJZYJqtTkw3Bw7SPN	1457	1145	149	6301	7207	jwQ7Lf53s4BePFrVZ6ZDVZ724sCQ1xDzFjh87LkLzhjduv3m4Hq	5562	7856	7856	1617353280000	canonical
10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1402	852	149	6301	7209	jx269n1k9YiKfXq9XDoBp6WPtDZePxRDouA33oMVouK2HBFSue3	5564	7858	7858	1617353640000	canonical
10780	3NKSTM9nsTJJAcKjHgG36jCyFPCUCkt2mQdojuxXnfdgjHSeehe6	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1406	1393	149	6301	7211	jwWxF6njYZZm6r8nRXCJW7Am8fbMtfSTKUxE3cJYWmNQ5BrKQzQ	5564	7858	7858	1617353640000	orphaned
10785	3NKuU6aMBhMQ1wPdKqFuTNkZt73J2wStuFt4fpxdfUE9kdnRhWQ3	10781	3NKyW4GBoyVuqNYNjyCcE8sVkzh4nkGFXtXgbWLcjynd7fcuhwpa	1553	776	149	6301	7216	jxVDHs5hR2jMu5nChwZwtnGyJMQqqodDgSg4Nehhk7PVwjWJUmA	5566	7861	7861	1617354180000	canonical
10791	3NLcS3zFdu2CBsNgwNLxVLnzqkCdKg7RHiGWP2X5waCgtpbXJEFJ	10790	3NLr59WirywpUz17ZM211ZusWvzvfTvc8mnTEtFSJBaie8rggMLr	1405	851	150	6301	7222	jwpUeYffxV1ijxavJq9kRBfn9pAy9psMGKDueVr2t9jpehNbxUb	5571	7870	7870	1617355800000	orphaned
10794	3NKf8zAwJDjZjLConRLEoqXfqb1jfYmydHhaLFKGXm1vBWLXfpN5	10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	1672	1159	150	6301	7224	jxB2kZftrRTr8BWyH3DaYVuoZhHAFYpsgLj3ZmSLSNC7rMxGKr6	5572	7872	7872	1617356160000	orphaned
10799	3NKyFLqkJGb3vSqxUpSmyhTurVcyDmf8ybrebYLv8iQ4nUknBS35	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1503	1277	150	6301	7226	jwbdDstTvCBm2133sBa73C4B9tgXunStzBHdiUog1ixECozpmun	5573	7873	7873	1617356340000	canonical
10796	3NLPBGmoaN2KiLXbFd9bxhC5MHCDU61fGbxf6RhkhgNaVDm4YUsD	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1503	1277	150	6301	7226	jwbdDstTvCBm2133sBa73C4B9tgXunStzBHdiUog1ixECozpmun	5573	7873	7873	1617356341727	orphaned
14486	3NKHBXyqF7BFdGUp7Yq85iJDtKvQy51bpDjbcRLtjUE9myfvZnhp	14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	1403	782	227	6301	10591	jwSzitqWE2LQVon9XwaDvUX6PDSTccLoTjF1bhz2Asez61F2ZHe	7392	10458	10458	1617821640000	orphaned
10697	3NKDfXTmkHUzmN9t9uXj4A3uXrVtKzDRsJ9sFLygE6qS2C3fnkNT	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1448	945	148	6301	7138	jx6wdQChfv7ae9R3XiyygtbVn1G7wS2Yq4AfZS2kWis9t5reJGd	5524	7802	7802	1617343560000	orphaned
10704	3NLfA5BihTfYAkMNzpfokXV8DtbpfpzBe27YfoP9RY8GSmNtFxvD	10702	3NKu9dkqou3AYYqRssxdDvkEShKztc1c12dDmGd4XJjBdFEeX2ZF	1673	1122	148	6301	7142	jwnqsK62wXd6c8AAzPhsfed4jD1YgExH8RmBhyvCQry5vxVHr3i	5526	7805	7805	1617344100000	canonical
10705	3NLULhLMNjJa9W1qdMahNV9WarcLUnN6sp2UyjrznCZyNn5Ct4Xf	10704	3NLfA5BihTfYAkMNzpfokXV8DtbpfpzBe27YfoP9RY8GSmNtFxvD	1508	1261	148	6301	7143	jwpXRAbE7PqkM4fuGAeM5AWdbQp7BRKLRqwzsSUynLiTZXgNZ77	5527	7809	7809	1617344820000	canonical
10708	3NKRmGuWX1w12PiUubeP2g31c5oYG4DQcGNpJ76CPBwSTdJndz3z	10705	3NLULhLMNjJa9W1qdMahNV9WarcLUnN6sp2UyjrznCZyNn5Ct4Xf	1406	1393	148	6301	7146	jwpNsPyv5zLaAjc1EHkjJATcHGmS3nyhwGBcNJ9kxRteN6FHwHe	5528	7810	7810	1617345000000	canonical
10707	3NK63gx1Q6PMQD7bpFZByfdWWwW9P6uQf8oiBnAwPa6qH8iyvTRn	10705	3NLULhLMNjJa9W1qdMahNV9WarcLUnN6sp2UyjrznCZyNn5Ct4Xf	1613	1349	148	6301	7145	jxmkPpQ9YaFNrYg5NEYfgtug63NcimHAmcbfrzHT7bQK1LyLz9i	5528	7810	7810	1617345000000	orphaned
10722	3NKcJEVWivGwVxbiTxDA1vREXJ7WRVTiNwUqj91q9AZZdLpHmbbD	10720	3NL6GgsDsVbx3NvkNvdi9cjXiViV3k5UUnwP47DXCfr3Umae5zZN	1553	776	148	6301	7157	jwjbFA5e2ry4vCpdUdEAMeC38g2sHD4Pjfm9B1pEuibbvb8czfX	5534	7817	7817	1617346260000	canonical
10724	3NKRonVAQFzqCgpjsce9QdgVAEFsUVwsquxkiKG7cGG91k8jt6xX	10722	3NKcJEVWivGwVxbiTxDA1vREXJ7WRVTiNwUqj91q9AZZdLpHmbbD	1579	1389	148	6301	7159	jxBdH1sm8nwro9gGdwM5XMqSae1WX4ZKU5vo7GAfY1PPTj9YYkT	5535	7818	7818	1617346440000	canonical
10726	3NLb3N8qtvNYQwzZJv997h6UsA3XTrLy33y3ukL1gWaSL96ynbQT	10724	3NKRonVAQFzqCgpjsce9QdgVAEFsUVwsquxkiKG7cGG91k8jt6xX	1407	1395	148	6301	7161	jwJtUhzFj9ByoyAeJh678rABYo23VgPFJDv8JiuVHRFZd4Exdrh	5536	7819	7819	1617346620000	canonical
10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	10726	3NLb3N8qtvNYQwzZJv997h6UsA3XTrLy33y3ukL1gWaSL96ynbQT	1609	1207	148	6301	7163	jxxHRyA3cxf8bX4jbssQ4Kah9YbswBaXbQhtB5AwkeaAuMWMjWu	5537	7820	7820	1617346800000	canonical
10731	3NLHHkduynePFkcR2N5E24iQJ7VtCPZxNnUonnyCngZvwng2QxRX	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	576	989	148	6301	7165	jwoqnrRcPBBakLvF8MMXoDCCQKY2bKN7ZPTXxDNUoyfsSXWUShy	5538	7821	7821	1617346980000	orphaned
10735	3NKfupUptDpf92FfaX6ReF3UfCsyPvAbCidZUYQCNvQYRfWMYZV4	10733	3NLYWfWMnZwLNbA7NFqGZqanY7DYvEPAKndsRF4rGXSohme19cQv	1406	1393	148	6301	7169	jxnSJ4yLNxxbjb4RsHvbmLu9KCWtfDH8PRPATFRKG8RrQTs6MJM	5540	7823	7823	1617347340000	orphaned
10738	3NLv9ubTFpu7ztZpm8wGZZkG1GshEMXsMu4dRXDLkv33Qy6mL5H8	10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	1407	1395	148	6301	7172	jxTwxaPGyF2x7kY6mkzjyN21sELQaXsMS5tBw1MgZGcxxZd1nAF	5543	7828	7828	1617348240000	orphaned
10751	3NKnFNpfBP1QNsfjEKHpwwPvpbtVpkAnNun94EGz6mY192rRX3U1	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	606	1295	149	6301	7184	jwLqkTf7WnuRjD7SQGp4AKJjW5RCuuvbBb83iH6qHHnVNB3bw45	5548	7834	7834	1617349320000	orphaned
10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	10752	3NL6xL1rRaPveusHcLMvUFJu2VyBJaRL37X4MdgyivMoV6a8Y5Jk	1541	932	149	6301	7186	jxBAd9oBKXfH9W4guPy1MXNEeSMQ37hVQRDuyj8nBfMpzPwUNY2	5550	7840	7840	1617350400000	canonical
10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	10756	3NLLEr98Ckm2VG7NYrgb32dhDm937TcvspwLgTyMy2LcjwSavPK5	563	1113	149	6301	7191	jwAZNhRbnVREK3EGb1FdpwVrrpLnd91E6KX6eVW2Ek1KQha78ZT	5553	7843	7843	1617350940000	canonical
10766	3NLtxrrkjQC69R7wCcaGQksgyK8PdTLxtzrumVTgYq3YmQWvKdcR	10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	1406	1393	149	6301	7199	jwKHpA1xR5S2NRZkogUXF6YZz783dGUpRMd6BVPpv2VmcokLZtR	5557	7849	7849	1617352020000	orphaned
10771	3NKJMu7wAbwQYtHrigfMWux1ywjeHY3MAkAsUX8FJK3FbcGYcDf4	10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	1422	1337	149	6301	7203	jxEcn4EJQqRZYEMdFXXJGnMVMAy5vhMhssNQJGAQQHtYhemtvTK	5559	7851	7851	1617352380000	orphaned
10775	3NKJoodjsPc2jLXkXx8XqCitJFFYz3sbj48irATvpZn9GxpoqNv8	10774	3NKhNREUV37PzXYDBxQV1UwpPJFoZYMLBuStJZYJqtTkw3Bw7SPN	1602	1369	149	6301	7206	jy2D6ByEJFdfsaJedLX6iVi3v2JCMeVrNBhhrErV7YE7ozAXrp4	5562	7856	7856	1617353280000	orphaned
10783	3NKxdFknGmy6iGp9zjA8jdJ1Dw1wr1ZVYVSPpVEsx47hcBovkyid	10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	1610	1314	149	6301	7214	jxxyPLPW8WmhPTv2PYDgDZMWEsna4LCXq8XyVwWDH9kUYFojXPT	5565	7860	7860	1617354000000	orphaned
10787	3NLnvRXCRBCH2iEWMvFGba5DgBs5tMfv4VqDwLAdBXY1bCtQg1ke	10785	3NKuU6aMBhMQ1wPdKqFuTNkZt73J2wStuFt4fpxdfUE9kdnRhWQ3	1406	1393	149	6301	7218	jxJjG9uPHMcQDuaThGJpnZsbxGGsMkErVoWdGdUCWPQx32A5MqM	5567	7862	7862	1617354360000	canonical
10790	3NLr59WirywpUz17ZM211ZusWvzvfTvc8mnTEtFSJBaie8rggMLr	10789	3NKJc7tQR9jfg1Gcn6SGKH5EpxTEcTBgAgjjT2ttz85G242TJP87	1559	1353	150	6301	7221	jwisgfeL1LxBMsTsRiBYAySincAb55ZnJnVPVpAFNjjPRzp2jeS	5570	7867	7867	1617355260000	canonical
10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	1672	1159	150	6301	7224	jxB2kZftrRTr8BWyH3DaYVuoZhHAFYpsgLj3ZmSLSNC7rMxGKr6	5572	7872	7872	1617356162920	canonical
10800	3NKbvS1EsmrJXXQpJKqREEFjJvnhbaw1R1K4kLm1WELuDSW3vwAD	10799	3NKyFLqkJGb3vSqxUpSmyhTurVcyDmf8ybrebYLv8iQ4nUknBS35	576	1229	150	6301	7228	jxbJMU2Bmk9AxH4KkjhJK4fThWjFPuzeTnEss8w1PaMDJR1uZzX	5574	7875	7875	1617356700000	canonical
10803	3NKD9j77whMAqsZM3aXxPDsFQKspBczTYNfCyk2E4LsbzufutKgE	10801	3NLy5cAwfD7TFEwYw12mgSSvZ2amFtvs1ktPHNC9KVGc8QyTXGRx	1483	352	150	6301	7231	jxq9dtVq8X5VLQWY9AT8A8pAeg1s5ne22ERhHBezDcbyEAQxLZc	5576	7879	7879	1617357423166	orphaned
10817	3NKmhEtsnuQN5BjWwKsG31A3gAC4x8bTd6fHM7DQSethBykeLYHn	10816	3NLwz3PWGtN2QgVJ8Fw6Esk5U5aJbS6JKRRbwBCzRfZEBZPaau3W	1402	874	150	6301	7243	jxvKc8JskLaC76TFfZdQkCfb2vhFmGqDJ9WfhZi2McX7nFiX97e	5582	7887	7887	1617358860000	orphaned
10819	3NLyTQfpMPusunNTiW5kLsUDKayBUC1NftpJWc89UVHYjMNVCSv2	10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	1668	1124	150	6301	7245	jxcr54MEZvxbBeHk3qCSnX3DqviX5LyAcnNupvBSZofkoan9EwM	5583	7888	7888	1617359040000	orphaned
10824	3NLM9gPD4VL5ftSbwMWh4hAN7EW8BXzohLVqXFjgSd4SCgrQfuu8	10822	3NKbxyrzz3UVSbUxLUgviHeZgaSTuXnEP1834hsMct4LtGC2be23	1631	794	150	6301	7250	jxmJKSGqKEyfn4Bx2uVyu531cYuN5xsrfmyRmVBvUxha6rS25iF	5585	7890	7890	1617359400000	orphaned
10834	3NLpjSjM1rLUPYpH5sqCJfqkFFdKQwWaaDPkTUZag9PeseLQ8izD	10833	3NLW6nLkpdTjSC4yDYxErtWSbY14r9fjDYidgEHfkQ4cocCDA7e1	1503	1277	150	6301	7259	jwpL2AUHZRgNiqhyStKKfw1S5j1UAHp4JfG568zSXs3syLkCdhR	5591	7899	7899	1617361020000	canonical
10837	3NKC7thfv9fpUYRkJjayaLBLGteKwxRMWwefFdCAGfBw3A2fjovh	10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	1675	1342	151	6301	7261	jy2a649Q2K8w4nA7Zp3PXcyUpDtHjWigezfr8UfKHDPhY8Tgrm6	5593	7901	7901	1617361380000	orphaned
14504	3NLLLcLRysy8aHnPNk4KdVS5myGeiitpMZn2jRQEQjjadrBx96ie	14502	3NLdvPebVVP9vk4CoxqtvogwAP5D6d88hjEozz6trZ31fK6apFty	1406	1393	227	6301	10605	jxn496zeGhf6Tqt2BJC2hDvapV3VsE1W6RqMEn93yCKnPDyrQpP	7398	10469	10469	1617823620000	orphaned
10712	3NLPBCj5BE38q4fbArQPKHvofrThx7FnWB3pMtijfA66HhD7yAPD	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1547	1252	148	6301	7150	jxFeQvEa9QxJKDjRFosNLXCtXezLaCHFRr5nYEU1to96RDLh5qx	5531	7813	7813	1617345540000	orphaned
10719	3NLW9KZxFS76E1CQrUXam7dmZdVxReZ22w6ZFCoeGieNWjmtrPAF	10715	3NLHjCiEC9QbFfoNKkkz9kqs4k3zP4STee2khNN7LgvbVZRfJ9Pp	1523	1195	148	6301	7154	jxDEZsMeXgc44KJoeSJyJqr7mr8o5v8qTwrstL9Pu5rQt87HmaX	5532	7814	7814	1617345720000	orphaned
10721	3NKAUo6JCvj2f6waa79Q7nnaUBzupdPadXAfTSZz6pxGSCcCxbAP	10720	3NL6GgsDsVbx3NvkNvdi9cjXiViV3k5UUnwP47DXCfr3Umae5zZN	1518	788	148	6301	7156	jwgqL2UFP6MwpayLB5gxhvJutkh8tj3TE2kzn5rytaDqCk4Jgzv	5534	7817	7817	1617346260000	orphaned
10723	3NKrXSjuDGGW5Din3BanNeRo6tSx24amkWchy4fcBouTPDU7274B	10722	3NKcJEVWivGwVxbiTxDA1vREXJ7WRVTiNwUqj91q9AZZdLpHmbbD	1593	1100	148	6301	7158	jwvSsGxbsnAFrwtC9ejhub4qqYHnwoAgN2spS3SZPPo2C56vDBk	5535	7818	7818	1617346440000	orphaned
10727	3NK8oB1mHhmzSDPMzFrGxpnty1finbhL2ThxbmFzXsY8xUdmB2Ph	10721	3NKAUo6JCvj2f6waa79Q7nnaUBzupdPadXAfTSZz6pxGSCcCxbAP	1406	1393	148	6301	7162	jy2yYoM3zoWeQ8WijhR5fm1KUMhh3k8hALxZ1gTaefD2P9HjjRt	5535	7819	7819	1617346620000	orphaned
10730	3NLVPQFfdan37PLrtz4xFoXGwkTD4Z8H6LfAjPEYyQ1DXnmD8UfE	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1472	516	148	6301	7164	jxt1ot3igQHcU2J5kDVHubTVQnCCckBdAuY29bQfkTaEfKQwHje	5538	7821	7821	1617346980000	canonical
10734	3NK7Dk3E6Kcp5FJ7YEb6rV9vkA1DZW7KReE82n2mMHnnGw4fJmuX	10733	3NLYWfWMnZwLNbA7NFqGZqanY7DYvEPAKndsRF4rGXSohme19cQv	1458	1077	148	6301	7168	jwtHr1U4fbixooMsC8dHM3pv4FKmnt3sKdrAnvYxYaniNdpfVUi	5540	7823	7823	1617347340000	canonical
10737	3NLfHHV4zffaWGuwHSTxu9eVNuVHTM9CCsfvnwN7obrv2wY6rRYa	10736	3NKPjdFEnEL8khypKvjQH6Qi47tx22yGNejb6LYDZ7CerJ4yczRp	1406	1393	148	6301	7171	jxkMswY6gENzArFfBfxoNdz7aBe4GuJKVdDcGiYaE3UA4RTPneg	5542	7827	7827	1617348060000	canonical
10742	3NKBLNvTQyaqAk2NWHSamZMTeDXjaFVuku6SYXeCrXjBmYrJuQHc	10741	3NK9p91M3pNj3obcVAVzdcWxr4PRATftXDvKLevpK7AXHinXm2CS	42	995	148	6301	7175	jxyChKP2VS9DJX9cQxAaPjxRW6r2pjXMUG3oV7MNibe49Dba7TN	5545	7831	7831	1617348780000	canonical
10744	3NKxhYa6T23aQmePDbSfYpbea1Aowqzfex9ddVXxneeZc27pnUoE	10742	3NKBLNvTQyaqAk2NWHSamZMTeDXjaFVuku6SYXeCrXjBmYrJuQHc	1553	776	149	6301	7177	jw9de6694bmkqjofawtSFGLMqW4ge3cXXingsxZMrnspcjFwJH8	5546	7832	7832	1617348960000	canonical
10745	3NL5i8QLNHUarHmdB6U3j4apm78cwi1i4jPQz8KtarCfSRiJQu85	10743	3NKDvZYfXSDM9KRjatv6H7q9qnHkTYQ4HcZCnK2DENp4QtrAPTRC	1419	814	149	6301	7178	jw9DRGzVNRPLpgKXE6g3k8vECyvdkEsLYi3dnLxEYbiCL91gTTy	5546	7832	7832	1617348960000	orphaned
10749	3NKxnsoVCd2hEcnaUDWSCPXyXh35HUtfPj66r3GgWkn2pXkrVW8g	10747	3NLWsRqSr69Xx85rQumYdrSHYwoi3UzjZx5nxiQkvzAZUnaZ9Yi4	1657	1098	149	6301	7182	jxXUtrYe97bVDUifo78EmtAqjkVQABxLm8DgGzubb81rAUm9UmJ	5548	7834	7834	1617349320000	orphaned
10755	3NKLnLjoYTbaMEFAg1pa1JgNxUap9x785K5pR8FeginqmARGgW2Z	10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	1455	1206	149	6301	7188	jxBxPUtF84RhRPJan3oxuiX3renSeJtWMjbfTpesb1YGRGtqFf9	5551	7841	7841	1617350582979	orphaned
10760	3NKVko2YQ2VnreqKXnNKLjiMWxWBtRwXfLkrgZktUKpRrP3rFVvm	10758	3NLPmwQiy5vrGN8BWjCtMkGZByVrE3xKstwWmgrVfHxJNRPDBtGZ	1543	695	149	6301	7193	jw7Vob4KqCq8EyAEjWC4kF9BDJ13BRecShQcFbXBs8Qq9YSY4F8	5554	7845	7845	1617351300000	orphaned
10764	3NL1mPDmEZBDxQLcTYBbMfRifbTJbenDJQezzgiMb6TqFGxcxxm3	10763	3NL83knf7cSqFsc7LddfiV9BjW4vEHiWnFjhGLQVtcfCiNid87gR	1571	1335	149	6301	7197	jwoY9u7moxQA25z3qVjwzxJMANqPnXHepG2eLcXJBnCbP4wk8WA	5556	7847	7847	1617351660000	canonical
10769	3NLejUQ9Wc6bgRet4gMvmhZMxdziTbPBzpujzcSEQ5M29dAuEj5f	10768	3NLTLk2KFc7oxi3W8TXkt8eEqdngEH3AX5sAF6aA68Yb1TEm5ZHA	80	1027	149	6301	7202	jwqJ3fnFePfgFUHFpptc2sn531acRbnpueEcBdTtZz1smdFxKdP	5559	7851	7851	1617352380000	canonical
10779	3NL5WS8ka5FTjCpuSY9BfUuxMiEGgFj64W8D2T3WZsD1UA5VojdX	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1622	1110	149	6301	7210	jwWiuPWYxpP5FWK8NuQVYy8zjrZYyowBJ5YQispcPgHDB4MYX4h	5564	7858	7858	1617353640000	orphaned
10781	3NKyW4GBoyVuqNYNjyCcE8sVkzh4nkGFXtXgbWLcjynd7fcuhwpa	10778	3NKCoa94NYi2yHUJ4F6xBmF8iLDLFSahiteuTbKyjCTUcKuxtzFL	1602	1123	149	6301	7212	jxbgifidCtWgumMASM9bGX7qqQrW4xqNsuTX7nXJLbD1y1GJkZP	5565	7860	7860	1617354000000	canonical
10788	3NKMpewyVyi9HUFvwSBJWAdgbH3wTJAM8QWa7qySyZVQEUKkiGwC	10787	3NLnvRXCRBCH2iEWMvFGba5DgBs5tMfv4VqDwLAdBXY1bCtQg1ke	1501	1114	149	6301	7219	jwXR8cGBwgL8XrxHqTVtbvoF8KMiPeU4F9yw3WBpMGJd93MwERJ	5568	7864	7864	1617354720000	canonical
10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	10790	3NLr59WirywpUz17ZM211ZusWvzvfTvc8mnTEtFSJBaie8rggMLr	1406	1393	150	6301	7223	jwTXH1qzykBMG8w2XTpJ2peSbGMxD2s8cSubdFEVbqhHSGprRqz	5571	7870	7870	1617355800000	canonical
10795	3NKb6CFQfjrvT4nVC3n3wZ1PpBdoCwSAJJ3tiSKu3m8v5S6jAY5L	10792	3NKSnfZoPzZDELrHL6B13rTyab2xBDiJXxQDUX9L4cmtvV1RvWhD	1564	1338	150	6301	7225	jwNZfWkcNwsmADgKaC664gcEg9ZWdcvVGLnMQsE7wiJ3riS3ZPy	5572	7872	7872	1617356160000	orphaned
10797	3NKnU16LZteTnuFffbAcu1frFsk8vnobMJgUmrCZwYqYQgCA1jYh	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1503	1277	150	6301	7226	jwbdDstTvCBm2133sBa73C4B9tgXunStzBHdiUog1ixECozpmun	5573	7873	7873	1617356342847	orphaned
10804	3NKnm4s1jtWf3PvM6MyZigR3b56529cckuEajHhecpBEYxgmePUR	10801	3NLy5cAwfD7TFEwYw12mgSSvZ2amFtvs1ktPHNC9KVGc8QyTXGRx	1483	352	150	6301	7231	jxq9dtVq8X5VLQWY9AT8A8pAeg1s5ne22ERhHBezDcbyEAQxLZc	5576	7879	7879	1617357420000	canonical
10806	3NKcqD84kWDV2LjTuikNujAyyYgNugFGfWqX13aUon1vbMjggpv4	10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	1649	1383	150	6301	7233	jwxb4yqzDGeFKXsgFSXMpuuMqsPTzvUoT8PXM7X9eyKPW53MdXF	5578	7881	7881	1617357782960	orphaned
10810	3NLuEebmPXk4q9mNYM9LnaNF8Brkkp6R6auuUMaYyVzS3PTX4q7s	10808	3NLALCyPYf4j2GZmzeXoCmPFvAGfz9ztuwHqxFDmuAmZd4UmzUXW	1490	1148	150	6301	7236	jwD5sFU245AdPzLwMkjqfkK2RdekhhPP5scQZAqXxPR2WbHxFsY	5579	7882	7882	1617357960000	orphaned
10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	10816	3NLwz3PWGtN2QgVJ8Fw6Esk5U5aJbS6JKRRbwBCzRfZEBZPaau3W	1407	1395	150	6301	7244	jxZtqfmQyDN1vGe9QiVsM92sWEizn9LyF7UTBbQepf2Gd6M58Jb	5582	7887	7887	1617358860000	canonical
10820	3NL7SvkhpGyQgBHj7MCWxFHJ1xpvKbkeyaEebcG41VhQbrBba4Zg	10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	1622	1356	150	6301	7246	jxM49NgkhuwvdVE2xdsRUuL9p3xeE9PZqRjm639LYoC9StvaYN7	5583	7888	7888	1617359040000	canonical
10822	3NKbxyrzz3UVSbUxLUgviHeZgaSTuXnEP1834hsMct4LtGC2be23	10820	3NL7SvkhpGyQgBHj7MCWxFHJ1xpvKbkeyaEebcG41VhQbrBba4Zg	1596	1363	150	6301	7248	jxjFnbYf5ut4RPahvEJhKTdRpTBTGoFad9RGScXdf6qTskrZp1E	5584	7889	7889	1617359261109	canonical
10827	3NL7oSisaDQtaRrjs7B56X4Z7HZhgGXgrLVsgDahb5pTB23L1pki	10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	1647	1056	150	6301	7252	jwfQtFvTQWeiXw8CFDkEtgMKt1Noqf1GybxjpLu9aAdJg45eani	5586	7891	7891	1617359580000	canonical
14508	3NKtJjXPVKa8dxQZuF8DmVGMrQgoHxZEc81R1PpAPBmhBfPodySS	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1622	1356	227	6301	10609	jxyBYdN5iPCQf94BWrHbvbAJdgjPUpaovu7QCUGExsZPuih75VV	7402	10478	10478	1617825240000	orphaned
14511	3NK4HDmHArXt5Noap7SqSEV9jHknWMDmXdfD8CXdcAVjxB1rP4vt	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1483	261	228	6301	10610	jxCF1C1CBwq4TERiaGdwHE1jL37QF4Rigfrr2RBsMQ2JkAdCfor	7402	10478	10478	1617825240000	orphaned
10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	10804	3NKnm4s1jtWf3PvM6MyZigR3b56529cckuEajHhecpBEYxgmePUR	1406	1393	150	6301	7232	jwTwVrK8xmcz7NXZue9udoagnFYPh7FUdjpsD8mvYMhCd6WAG6K	5577	7880	7880	1617357600000	canonical
10808	3NLALCyPYf4j2GZmzeXoCmPFvAGfz9ztuwHqxFDmuAmZd4UmzUXW	10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	1593	980	150	6301	7234	jw8TL2xjYSwQ6nUfSgYAFtsb96Qnc8vGs8niVcNTaFWnZQUFWAV	5578	7881	7881	1617357780000	canonical
10814	3NKEgLJsiuJn2fvGC4Das6bqNxCCDPYReMSBDmgsVL86EEHMQGY9	10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	1489	1254	150	6301	7240	jwNvVKN55xhn5qvvs4En1iUpTmySFeEtKEjdabAwxYv3JJDpYjj	5580	7883	7883	1617358140000	canonical
10816	3NLwz3PWGtN2QgVJ8Fw6Esk5U5aJbS6JKRRbwBCzRfZEBZPaau3W	10814	3NKEgLJsiuJn2fvGC4Das6bqNxCCDPYReMSBDmgsVL86EEHMQGY9	1439	1279	150	6301	7242	jwPSdNuW767Jwj11Ci7qALUPu168mpeYjoSvwfCDecGUAhyK3gt	5581	7886	7886	1617358680000	canonical
10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	10822	3NKbxyrzz3UVSbUxLUgviHeZgaSTuXnEP1834hsMct4LtGC2be23	1596	1237	150	6301	7249	jwQbasyTpXwsYd7sTFFc2hybYrEDjBeR1diSWeDQnwKB31Tz9A5	5585	7890	7890	1617359400000	canonical
10826	3NLV2qNAbVK8AxZvMGDAELqkicYh3Ax4HiV43VypcSenWng4zL3R	10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	1647	1056	150	6301	7252	jwfQtFvTQWeiXw8CFDkEtgMKt1Noqf1GybxjpLu9aAdJg45eani	5586	7891	7891	1617359584554	orphaned
10828	3NLfQErvDqwoKW7qCQrHdxipNoLRAJBvYd9mVnuTk3fy1WUSEkzY	10827	3NL7oSisaDQtaRrjs7B56X4Z7HZhgGXgrLVsgDahb5pTB23L1pki	1458	1197	150	6301	7253	jwSNrvFMZLRYRQ2nPrHstPnCTWPQWpw778PS25GTSuLRy3AxrMF	5587	7893	7893	1617359940000	canonical
10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	10828	3NLfQErvDqwoKW7qCQrHdxipNoLRAJBvYd9mVnuTk3fy1WUSEkzY	1596	1363	150	6301	7254	jxTXErBxZ2v9RrVSqzNfGi3rQqo1vP9y8nzmDbY8M28PtdUmgrG	5588	7894	7894	1617360120000	canonical
10839	3NKKrfMEkz22Q3kRt7wjfQeTEaRs3sDQ1Hf3Lu6af3HXKu4czeX5	10836	3NKkqDpnM7RpheLtEyFAnQ7VEz4QbjgQ11GBNmcoq1D3BoGhKBq4	1402	874	151	6301	7263	jwmYTfBrcRUypcjkjZxyndUz9GvvtdHfLhMKXpAAPMVKzkXoeHk	5594	7902	7902	1617361560000	orphaned
10842	3NLX39bjYSJ64dHS3kdaCkuugJfLKos4QuAoWjVETBre33GJ58EV	10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	1457	1391	151	6301	7266	jw79j2VTy4kGZjcLL8Dsz3HbaXqEYtakchw66obArA732L6R5G2	5596	7906	7906	1617362280000	canonical
10847	3NK3ToEqLCRU1NM3LvU5LweeBGqJEzYiSMp1GaBFwqSHydT2NU9Y	10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	1402	874	151	6301	7271	jwDLVmcBY7TqGhGfWEqD1gxkTY59y1XZWbarBPo7dN9zj2wDRNR	5599	7909	7909	1617362820000	orphaned
10852	3NKV8ZKXdktzDJRxZqLdPWQHKFVXJ2SbQ52CduXagSrM38snoBZf	10850	3NKru5geVTUJE9aossWY9eFtgSGgLn8xzqmC6VgF7spNQ1GXtRv7	1407	1395	151	6301	7276	jwAeLWAFNzkposhRt8vpBy8udbopB7awbrC712449ytMig626Fs	5602	7914	7914	1617363720000	canonical
10853	3NK7ipDGytMps5htPc6UXHhA8PH1FgdppCJVwh3LxV3V5kf4HQfg	10852	3NKV8ZKXdktzDJRxZqLdPWQHKFVXJ2SbQ52CduXagSrM38snoBZf	1581	778	151	6301	7277	jwuTG1Y41qjuG5fGbXbLvFvfRiWEjEYPYLwUTvvE9qNgYfutQVN	5603	7917	7917	1617364260000	canonical
10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1483	1030	151	6301	7280	jwzDUd52aCgnpY12c85FrmkkFJE6rAYVYCXXyV8tKSVcCHnFZEu	5605	7919	7919	1617364620000	canonical
10861	3NKx5yscL5CyWiTbEaRyKTSZzPMgSe2TKqfdJcyLJnafXv4jaBtF	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	369	946	151	6301	7285	jxwRGwF4M5BgqKZF6V8yV1vRR4q8jeNFdqCNsU6H1HbEwL3xgPB	5606	7921	7921	1617364980000	canonical
10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	1594	1326	151	6301	7296	jx6uco6yVwcMENssxNrH7NLmjXZUPD2QxtXvf8GVGJ68TL9UnNw	5610	7926	7926	1617365880000	canonical
10874	3NKcmgPvn9d9Stmkt7mjTqGHpYXmMfkTMjuHmtJ8mMqYwZGMBFuQ	10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	1590	934	151	6301	7298	jx7zCWFDh4TaRD2UmCFhX41swxKPGmJNt2T6nRUGR9Ff8fEgTFz	5610	7926	7926	1617365880000	orphaned
10881	3NKpYdipmAjA3m74GJn7DXxTebhmN24X4onDxDGmVMpRW6SPQFpH	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jx8QCUkNbe9tJmQYsMxh81mLURsmSBsFN8i4BZHuqvJGcCDQzwE	5613	7930	7930	1617366606915	orphaned
10887	3NKfHYHgjrnR2td1UX8zNe8oGx4gHsCgJxMWBZU49UbcWHnnicay	10885	3NL3JZZahsAaAEyjWbeVfpafVZrg9o48g9u1dd839JrJH4heRYDh	448	1305	152	6301	7305	jxdW7Gi2EgoA3qGGQLmMdNFjfQQCN5Nazsu5kX4gyrZ4N34eUps	5614	7931	7931	1617366783496	orphaned
10889	3NL6TUmRRnVrhQE9Q9XUD7WwPWBCmmbLQ6RWXSViniNM8S6TYKSn	10886	3NKS3DuPxopjWrqYgXt3B1ym7JAwdKCqo4cHPxfrZJWG9JkbYBrH	1649	1137	152	6301	7306	jwDDzUxfzu2xwr8EZXdgg4xtRakizjkgZ3C4A7vEcf9mibgBAdr	5615	7932	7932	1617366960000	orphaned
10892	3NLhmsu4vYxaREC7HW3rj43a5kLMRsiWUm9xsafiFK5kPqEwSN4Y	10890	3NKotGEHEDGDhKSGV8zB6mS293UiULPLKwf64YMZqgqL5DyUuvZp	1451	1292	152	6301	7308	jwbw9ejWKDhmHUiMccqfrPJPw7S4iis6KxPXyNHypgtEcQ4K8NF	5616	7934	7934	1617367320000	orphaned
10899	3NKJFcitYt859goJg5C75NegNDGFWpFBDdsjDGnRsUqwRa3VVg4V	10896	3NLujKpczkQ2qrfJw5TxvQHzJvjMPnNqpam4LZBEjDV2c7eCYVZk	1406	1393	152	6301	7315	jxFd93KqEVJcSdmYjaCaX4RFYCJdgEDMhAMWTaD4J5bCDijJfU6	5619	7939	7939	1617368220000	canonical
10902	3NKp8aKFgxHYgwXRCWqTjSvC5RFWitDq2wthVmdgPHSuABasaZra	10901	3NK7tX24vkoQiw2AWrsMw496EsP5PEKyyBSkLCgW48ac5nhDG6QZ	448	939	152	6301	7318	jxqeKMiXdXksdsGH74q6zAJjwLNpgt6JPkeSN7Q3iaTyxXaVjvT	5622	7943	7943	1617368940000	canonical
10906	3NKyLWJ4C9fKJpo3UTyD5CsyAWMW2V2TwpQsj2qtWqX6wenzDobP	10904	3NK9BozjnFuW9Q27dY4ftyb1ZHAUV7Sw29wVei5iq6qyVp6vckSe	1406	1393	152	6301	7322	jwDgPqMeY7YqFnP7Cdg4G6YUHC1Djud8pyYXsqRtaYADoRzbBey	5625	7950	7950	1617370200000	canonical
10910	3NLLMrPj3uvqiDkBi2kwDnyv6xoK2yvQv4f2sD14YgeXD7kLinfv	10908	3NL2GPoXZoR6c8w6sjqdELkVDKRTjURhvX8QbDRxseC39CkiZpn2	1406	1393	152	6301	7325	jxZrQ3danfudPzepFMntEpkP3dQWNyXKMaDdGNS6aoRPGgjRZkE	5628	7953	7953	1617370740000	canonical
10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	10912	3NKpxe9GVGUoKDMoUNcuNJAShRJSQdFEa5S6p4RGHmeSvxWpFBR7	1406	1393	152	6301	7330	jwczqRqxMvLFxXwS5LEsMcfj4xW7JqxsYTMMUunxtycgMUvNvdP	5630	7956	7956	1617371280000	canonical
10917	3NLYHojYRKSavBLvJ8VEkCywgpxF1RpLFmnrLppuSfZp9cdWwYKD	10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	1403	824	152	6301	7332	jwbWSq1ZR6PwRedvTLggXtz2zKgKoLChTwFmnMg4YcZ9Z9xJ2W9	5631	7957	7957	1617371460000	orphaned
10920	3NKxNSn8nDuLE9NPCArZP6NqzvFVhrpsyGromot8X9B1dHcxjRsX	10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	1476	1371	152	6301	7335	jwum5yW7hKTg32PaxasNP676GZ6fmxWLoc9tLu1KsgTJt9ff9oz	5633	7961	7961	1617372180000	orphaned
14526	3NKPRcBABK4K7xkF65hyKyxFBwGQUfGCaYsiJDuB5cCXmwuUKbXg	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	1406	1393	228	6301	10623	jwzsm8hxhDn6VTsJ9nGL4pkgSHxBrM95Ex9Rkxkz9pGEmQHf2kN	7410	10490	10490	1617827400000	orphaned
10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	10808	3NLALCyPYf4j2GZmzeXoCmPFvAGfz9ztuwHqxFDmuAmZd4UmzUXW	1546	1093	150	6301	7237	jxMqRbFQLW1KxDqkBABNJQuEkxduhKQB1G1MK7b2KbH13w7nR4M	5579	7882	7882	1617357960000	canonical
10813	3NKxc6Bi9YZVV2N6RcroaQcrgG2ZduAuiHoWzriccEtTvNE9CyfC	10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	484	953	150	6301	7239	jwz1hh92xXUcd6RBNjjC5gU8gw5YFDCtf3dmMqjj8VR585FU2ZG	5580	7883	7883	1617358140000	orphaned
10821	3NLxkyQ81HxbNJrEdeGTCFWAVvRX6i6sWBGjhsRtqdESLdY54sMt	10818	3NLrygbErbpzQTfhErTWSWX5cya1cLrYWqm4WKFXLKmVBxdt214w	1555	1347	150	6301	7247	jwhhi8f7MfkNgqhAJXYg3q5RcUtwWciz1kgS5AEwht6RABHHiW1	5583	7888	7888	1617359040000	orphaned
10825	3NKnqs6pdgyvrhPayfLqrnB1ttedaXUFFVCDWoyGvM7YgqpmoPrH	10823	3NKdUpB6px6YF8wDFbfQJsgiwYAwtKHrByoLgCLaC9zBeht1K6TV	1402	850	150	6301	7251	jxyezZohQusC5jGQvR6QfGkHyapSCaLQgytsZy8aptgJR4t8iHc	5586	7891	7891	1617359580000	orphaned
10832	3NLBMrs7tFzATwHa9iLxTG2ULe7STFAbgBfQxSp23KgcTdwnuqRd	10827	3NL7oSisaDQtaRrjs7B56X4Z7HZhgGXgrLVsgDahb5pTB23L1pki	1406	1393	150	6301	7257	jxcaANLJCv18RfoFqpb1iQHZrZyGjoTNrGVGXXZnNH16qKNju9g	5587	7895	7895	1617360300000	orphaned
10830	3NK4cKHuUxC3RCsYC4SJLKePiZHeGmEE5cEVFuJPXE63Z2SgT12o	10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	1447	1099	150	6301	7255	jxuxcKmque8o1Szs6qxz85bAG8Nvz9yp5GvwVTuPaTVuFbcxnCh	5589	7895	7895	1617360300000	canonical
10831	3NKi5s5GvYFPY21cdZLwEvTQxEcBHRVcbwk86VGTYMms3cQPtuwe	10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	1509	1320	150	6301	7256	jwVvLFZjc1dRwqBKja4DBeHZr7PrBwhWtDSZDfmRcs43Jj3prd4	5589	7895	7895	1617360300000	orphaned
10833	3NLW6nLkpdTjSC4yDYxErtWSbY14r9fjDYidgEHfkQ4cocCDA7e1	10830	3NK4cKHuUxC3RCsYC4SJLKePiZHeGmEE5cEVFuJPXE63Z2SgT12o	1503	1151	150	6301	7258	jwxd41kMhDHxzFX5q1i14skGmvMGpzY17WM8gbC2tfNRm1ssK7S	5590	7897	7897	1617360660000	canonical
10836	3NKkqDpnM7RpheLtEyFAnQ7VEz4QbjgQ11GBNmcoq1D3BoGhKBq4	10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	1675	1342	151	6301	7261	jxN23dJAmUXztUZEVBeNrW3ovn5HopmHSRLTgdRBK6xcMprZUA6	5593	7901	7901	1617361383154	canonical
10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	10840	3NLCJk7JFKJqR2XgrPp11AfRKe6oXUEVAzNyi1GQ1a6H8LnxaEd7	1402	808	151	6301	7265	jwsYRmPQ4khTg3uLaggo5sgyMPwNRnca8UwxMeQ2HfR5zVEbfUo	5595	7905	7905	1617362100000	canonical
10844	3NK3BdexpMijsYEsfo8dnzraqPEZ7Y4TcVCHKcghiZyRhtrvgbt3	10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	1617	1162	151	6301	7268	jwpJxP7cVAmkW4DTYRad2K9qcPJpJq8JEyM3GL6vxtKSsYoFCJB	5596	7906	7906	1617362280000	orphaned
10851	3NLxq8dcPQoNd2123a8Z7VWcXP11ZvixnBcW9AhHcqt5KgroLLvY	10849	3NKuWxbnvoqkG2cr7K84SJDFhdUBxehqQayk6ZdA9d9hKAcTWt7d	1458	1323	151	6301	7275	jxsswkSVSQigMXAG4uUpWhtQaN19WX5wiHNWGDGBYiBrLWbjrfa	5601	7912	7912	1617363360000	orphaned
10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	10853	3NK7ipDGytMps5htPc6UXHhA8PH1FgdppCJVwh3LxV3V5kf4HQfg	1406	1393	151	6301	7279	jxZqoe1tCvibmr88zhpZs1bBj9R5s5eMqBHX6ZxZX5MMfbn1nym	5604	7918	7918	1617364440000	canonical
10895	3NKnMtVx8AUb7nv6Q12F7WeW7UNUVQjLrXAaU17csiWqWWuchayR	10853	3NK7ipDGytMps5htPc6UXHhA8PH1FgdppCJVwh3LxV3V5kf4HQfg	1581	778	151	6301	7311	jwS4u1a257J7jS8Vvya1z2TFeyDwG51d7MQ6C7Vy8mcPZsTQzki	5604	7935	7935	1617367500000	orphaned
10858	3NKFEuZbaEgr7VFpgn2D2P9RA1Tnhna8m7jctbdwePKPzmG7GhVo	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1509	1320	151	6301	7282	jxPwMkM8hnouwU57DgUxwyyZvKUUEcykfK1VUgmacFt5UDrun3R	5605	7919	7919	1617364620000	orphaned
10862	3NKy9rirRWqYva92tLfJyphpxTMiW5zxrLRcyw4zFPSyUsKhB4HB	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	1575	473	151	6301	7286	jxngErQuMTwFVftrMXyaHoDgkgVS68avgcYVvgmsKDdSDTWSAhM	5606	7921	7921	1617364980000	orphaned
10866	3NLoBLXj4xpJggwuwC9ypAnNZdsYKq7WCuTUr53xnKK1QaA7dTcZ	10864	3NKysFsqK5vqmEH6y96Ko6ZTDms6LbcKRGf2q3HjAopMZih8jCMm	1445	1290	151	6301	7290	jwiukPEq6cYVFgw4fQPtnTPzsnAbiXALb6hSx18Rs8e6UFYRMsB	5608	7923	7923	1617365340000	orphaned
10869	3NKD3MegHvSLVyJsJ34Cq1JyADcWKB44vEPjxW9GgUZYhu4k1Kf3	10867	3NKSopRA4t7VyLfNdbJZatVMXY1GD2qneb6UMWwL78vit9rH9wAi	1402	870	151	6301	7293	jxnJ52bUAcYwP8KUxPwESgTuB53H5apciwnYcYE7kGrSzNik4j6	5609	7925	7925	1617365700000	orphaned
10875	3NKURnqB6jWenKyqGRBr6qakYRx9hUt5vGebrAKsZajkBpxU6STD	10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	484	1073	151	6301	7299	jwSQ6PWAtJz8d5mLiCwxnXAS2VomsWqpRqgd1oW3moHhKrtv9AT	5611	7928	7928	1617366240000	canonical
10877	3NKjeXkQmQ6TYDuBFcDsJiP4axCKT6m5Eg3M7iChyNo256BbMtdw	10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	1406	1393	151	6301	7301	jwCan7USY2Xi1sz91BdNs5mXrxgiu97LWRXnPr6GJ2KpQ9ZxwNJ	5611	7928	7928	1617366240000	orphaned
10888	3NKysARTaEkVoA5X8zmRVh36Ey3GN6GbVdt8qPKm8cxMP4DvCNev	10880	3NKYPdZBmeZ4vMxae7qYoJni9F4ykaFkrWbXEf1hmBqtWTmEFftx	448	1305	152	6301	7305	jxdW7Gi2EgoA3qGGQLmMdNFjfQQCN5Nazsu5kX4gyrZ4N34eUps	5614	7931	7931	1617366780000	canonical
10886	3NKS3DuPxopjWrqYgXt3B1ym7JAwdKCqo4cHPxfrZJWG9JkbYBrH	10885	3NL3JZZahsAaAEyjWbeVfpafVZrg9o48g9u1dd839JrJH4heRYDh	448	1305	152	6301	7305	jxdW7Gi2EgoA3qGGQLmMdNFjfQQCN5Nazsu5kX4gyrZ4N34eUps	5614	7931	7931	1617366780000	orphaned
10890	3NKotGEHEDGDhKSGV8zB6mS293UiULPLKwf64YMZqgqL5DyUuvZp	10888	3NKysARTaEkVoA5X8zmRVh36Ey3GN6GbVdt8qPKm8cxMP4DvCNev	1406	1393	152	6301	7307	jxgGWGwo1L5KvYsAtmgXF247oD89usG7kmF2LTSnJhaGZ3sm5M6	5615	7932	7932	1617366960000	canonical
10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	1564	1338	152	6301	7309	jwLTR2rrztcqCU9PF8Wbs8finpjK1XKz6fQbfdGGsHBmgv1VB9N	5617	7935	7935	1617367500000	canonical
10898	3NLtRH1hNhahuGfvbH5XJDNVyWwCLpB64i2FfXYTphFrjDhfrioW	10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	1406	1393	152	6301	7314	jxuxxmZAjwLfWvxyseMC95oHiQNAYdkz3wam3x4oe75qMWEAWqi	5618	7938	7938	1617368040000	orphaned
10900	3NKzCW3ZvaVg1dYMgFn6qqWemBVp9A8e32oErurpSGbVucTw6skb	10899	3NKJFcitYt859goJg5C75NegNDGFWpFBDdsjDGnRsUqwRa3VVg4V	1637	816	152	6301	7316	jx3a7z8zMu63WR34g8KUmmGEyc6YRGvkVsDF5fVkHuUBcWhsbHD	5620	7940	7940	1617368400000	canonical
10901	3NK7tX24vkoQiw2AWrsMw496EsP5PEKyyBSkLCgW48ac5nhDG6QZ	10900	3NKzCW3ZvaVg1dYMgFn6qqWemBVp9A8e32oErurpSGbVucTw6skb	1406	1393	152	6301	7317	jxV6w6jXVY36H5GbAniYV8sPXAaSj4HLEcBvDrQNViQqPfSKaJ1	5621	7942	7942	1617368760000	canonical
10908	3NL2GPoXZoR6c8w6sjqdELkVDKRTjURhvX8QbDRxseC39CkiZpn2	10907	3NLk9Gk81qX8sXJrTwQadsGpDV7yQ12BZNYzF9wMBdDmZn1A9oFA	1546	1339	152	6301	7324	jxK71GqZ5FvqtHFN5k8RF3DVn68LAWaQ4iitCMjytZLWQ7DqH8Q	5627	7952	7952	1617370562533	canonical
10918	3NKSyztCive9Ru5biYVHhyMgCeD5BZrZMArW497YKk5k4mdksjms	10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	1406	1393	152	6301	7333	jwGHwyf1HvaydgeiQZ6Js3UJ2dWr6FS5Pd71WTaFdJhek1dZJ5Z	5631	7957	7957	1617371460000	orphaned
14532	3NLyV9roNLwxn9Ti9DbcmsqmMUHjZ48YuHH19wm229QqcA3ru7MY	14528	3NLP8EAEjKMw1fGBRwR4qKGAgnuh1cVaTMtCcusPS3C9RPhrETbs	44	1325	228	6301	10629	jwxy2a2L954oBUNenmEMNJKi9bvKbcubF5tG3b4yxkNfptu6GYZ	7411	10491	10491	1617827580000	orphaned
15632	3NKttiXq3q9gCYwDrYC8aHtbtWUrgyvDs6kM1niHgzz6yn6Asxjr	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1672	1039	251	6301	11654	jx7bBrRxjPrZBnWpwR3MGaRn6ciFSNi9MYDteWYFgWyEhuFpBXn	7957	11267	11267	1617967260000	orphaned
10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	10834	3NLpjSjM1rLUPYpH5sqCJfqkFFdKQwWaaDPkTUZag9PeseLQ8izD	1407	1395	150	6301	7260	jxPPCRJuXRQh6XT5yyC9WasJu3cBLcZYG5dwEXPjkszN1UXvVMP	5592	7900	7900	1617361200000	canonical
10840	3NLCJk7JFKJqR2XgrPp11AfRKe6oXUEVAzNyi1GQ1a6H8LnxaEd7	10836	3NKkqDpnM7RpheLtEyFAnQ7VEz4QbjgQ11GBNmcoq1D3BoGhKBq4	1406	1393	151	6301	7264	jxHuydnqJwoJJ8RaPqoEB2bB8tNEHgQhcrWHd12jnSwYgS7jZM6	5594	7902	7902	1617361560000	canonical
10843	3NKSMQpCzETHBhJTPPRejQL2cAL1wHooL66snMmkPFSVkLykHKSV	10841	3NLLYTXNVj3g68V9h67QMLmEGGV9GRcbTf4dDKNR5dRgWBBxrU89	1460	1324	151	6301	7267	jwYE3gtiCvQRTzcnMTszQdxdY2rPtYUSyzhYt5q733EX594wmMZ	5596	7906	7906	1617362280000	orphaned
10845	3NKNppW1AUUx6u7GTkMSUJJ8H8ooH7Lg38LBromgrCR6fhpMEDpY	10842	3NLX39bjYSJ64dHS3kdaCkuugJfLKos4QuAoWjVETBre33GJ58EV	1642	1367	151	6301	7269	jxWMZzNQ8T4PZTWRi8Yh5vREdkTzZHtgsCBETwDGfG4VvKPxQ8n	5597	7907	7907	1617362460000	canonical
10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	10845	3NKNppW1AUUx6u7GTkMSUJJ8H8ooH7Lg38LBromgrCR6fhpMEDpY	1407	1395	151	6301	7270	jxRR9guLrW6HMbsspmuPdVviZzMybgc3CNDRwW8aPL3AdZ9efMX	5598	7908	7908	1617362640000	canonical
10848	3NKNvHhH4U5WtidvWjyAvEkZksazZJj81S2DxXu6YbQ6z4xsxytS	10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	1603	444	151	6301	7272	jxzAvVoKKZCbVnihgrLfQea5T1cnjnGLn44dgGA75JdUfMFPEky	5599	7909	7909	1617362820000	canonical
10870	3NLugWGnyYGfFy5zLWKVV3uGRuD9bDAZia5emBUmUvHXtwmotsJE	10846	3NLmCGp8AeCFzCHsTfaVkwJnAEp2fUSJADbqv1mFRbaBukwjrT5W	1670	1282	151	6301	7294	jxVGsQGaWqyFD2AFDPGHEndp7iSzUjHAa9fRnC81jhyrRLEy48n	5599	7925	7925	1617365700000	orphaned
10849	3NKuWxbnvoqkG2cr7K84SJDFhdUBxehqQayk6ZdA9d9hKAcTWt7d	10848	3NKNvHhH4U5WtidvWjyAvEkZksazZJj81S2DxXu6YbQ6z4xsxytS	1623	830	151	6301	7273	jxGHNZ4KqUKNWxH9FtcZNen6sC86dU3AbYu3ZgiW3B42hjfrrCE	5600	7911	7911	1617363180000	canonical
10859	3NLE63Z6MsWaVW3pqi7HZk1Go3LAEfnYqzWtDJkBYZQR9h9t1f9L	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1627	1385	151	6301	7283	jwtVo8ue132m2vMt2T5ELQRQUWai9pksoHUAw4VQKKcaPEPeBMV	5605	7919	7919	1617364620000	orphaned
10860	3NLEx4LTiKMfNKnE235fweH5m85pfVA4VjC7BCNXZ2EDQ1WsAPke	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	1649	1017	151	6301	7284	jwH2FCSpYpkGsnEC4JW2tuqpAidPxLJMj2opEw2aqwxdYcYeAJH	5606	7921	7921	1617364980000	orphaned
10863	3NLBmR29BbHxb9PLxsgF26isGLPFEroBG4RTUfNbZrFJ23VJd2mG	10856	3NKX88x2HiTPAKH7629thMSdSJgia5aGcFR6e77ax4AsmX5d2b4a	1516	1294	151	6301	7287	jxsMNyUwpjuo5QpXuGHLqAEzSXGW5niV2ARPP28xQJuvhP36FgJ	5606	7921	7921	1617364980000	orphaned
10864	3NKysFsqK5vqmEH6y96Ko6ZTDms6LbcKRGf2q3HjAopMZih8jCMm	10861	3NKx5yscL5CyWiTbEaRyKTSZzPMgSe2TKqfdJcyLJnafXv4jaBtF	1407	1395	151	6301	7288	jwAqVGh2Fy89HRQLbXkzdiRZRhizn8846fvyzrMcqHpysY8vtZ5	5607	7922	7922	1617365160000	canonical
10865	3NKDQKE9srun74ZrXLekdQLub9PeXmEQzzTu29f91k2v87SQHxbk	10861	3NKx5yscL5CyWiTbEaRyKTSZzPMgSe2TKqfdJcyLJnafXv4jaBtF	576	1229	151	6301	7289	jxnHKJZx3vM94Diq2Jyaa1ejj8B9RC3iH8w23WWa2HYoELUyecM	5607	7922	7922	1617365160000	orphaned
10867	3NKSopRA4t7VyLfNdbJZatVMXY1GD2qneb6UMWwL78vit9rH9wAi	10864	3NKysFsqK5vqmEH6y96Ko6ZTDms6LbcKRGf2q3HjAopMZih8jCMm	1477	1104	151	6301	7291	jxfWKJF3Eb6a2XahpHmvStCDzmqNYMqMGGk4KdcCGKiQRuxJNe7	5608	7923	7923	1617365340000	canonical
10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	10867	3NKSopRA4t7VyLfNdbJZatVMXY1GD2qneb6UMWwL78vit9rH9wAi	1670	1282	151	6301	7292	jwjEa5o8wPNN1djURtowfjjdrwGXYyHhVgGxh8rA9QNQRfrfvit	5609	7925	7925	1617365700000	canonical
10871	3NKiz9EibjdXJnHXePD5jRastiHGRjovaZhMDQcXTFQ7oC9YrktR	10866	3NLoBLXj4xpJggwuwC9ypAnNZdsYKq7WCuTUr53xnKK1QaA7dTcZ	532	1057	151	6301	7295	jxE9scYs1732MpCJDrGzb8njotLX7YaYnbwZQzkDspSVsVPz5B9	5609	7926	7926	1617365880000	orphaned
10873	3NKJv6DS77H6KvincAfRAXGvjFgaW1QYKMrcRS2fxQiNjF9V4RCM	10868	3NKJkAEgnJAjMpAVEGteyXzQjCz5ADzJyGX4q6f26GFGcCkztfb6	532	1057	151	6301	7297	jwP7pMWwoLkCCB5HCgEwXFhzJ91isJshoFsfPfAXyLELVx2Somv	5610	7926	7926	1617365880000	orphaned
10876	3NK6byHuHXw5QGkuytMpe8nSuu2adHyiEENoDkXMvFd2QdTy9Bh3	10872	3NKNYQL3QhgRPqkHDLyN3Lrzxfha3rN55SuApUrNy5X87CtH8i71	1613	1103	151	6301	7300	jwSw1aBiQem6wJp9AF8JVB1EosFspanSFwBepw4XiC8JhYqzeFd	5611	7928	7928	1617366240000	orphaned
10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	10875	3NKURnqB6jWenKyqGRBr6qakYRx9hUt5vGebrAKsZajkBpxU6STD	484	1073	151	6301	7302	jwY64YfbaW1LcHhPvhAPqNUddcjpaH1bEmdy8ndJT37oa8aySML	5612	7929	7929	1617366420000	canonical
10880	3NKYPdZBmeZ4vMxae7qYoJni9F4ykaFkrWbXEf1hmBqtWTmEFftx	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366603272	canonical
10883	3NKTUm5VkRjaT5k1fqx3T7kHjAgZtuYSRJGohmJXUKAaf1rbh8N6	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366604142	orphaned
10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	10890	3NKotGEHEDGDhKSGV8zB6mS293UiULPLKwf64YMZqgqL5DyUuvZp	1451	1292	152	6301	7308	jwbw9ejWKDhmHUiMccqfrPJPw7S4iis6KxPXyNHypgtEcQ4K8NF	5616	7934	7934	1617367323055	canonical
10894	3NL8SqrGJnNeQXv3vYwP2y8WWwCq4LKSk8vgYkdS6AGCAtVVEnBP	10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	1613	1349	152	6301	7310	jwPN6zPEbJS3nJ8T9GMCZpNewD8ZAv36cg7P3hvMyuW9iNmbks5	5617	7935	7935	1617367500000	orphaned
10896	3NLujKpczkQ2qrfJw5TxvQHzJvjMPnNqpam4LZBEjDV2c7eCYVZk	10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	700	840	152	6301	7312	jwi5XNXF6VxSmbmSvNxr8HKJcpdVW2UNF5V3p3gzYNw1tPFHQSg	5618	7938	7938	1617368040000	canonical
10904	3NK9BozjnFuW9Q27dY4ftyb1ZHAUV7Sw29wVei5iq6qyVp6vckSe	10903	3NLU9SZsbYZubBXT7rrohdtpsmgDwy2xNPv4gNYd4hfXDqMA3xQJ	1553	776	152	6301	7320	jwANDCBaFxQTzyfWcBeuv7kLTNKkETdZr2wBDtvmAz8VEuCWJqf	5624	7948	7948	1617369840000	canonical
10905	3NLm7cWYozcEfFc3m4g79E8if3omcCcHhetgszDRc6BuaxrPqPBB	10904	3NK9BozjnFuW9Q27dY4ftyb1ZHAUV7Sw29wVei5iq6qyVp6vckSe	1573	1072	152	6301	7321	jx89xxMR8qYQE9EsP6rEcZN9eAvqinWYnVr15DondwwDgNCUAqN	5625	7950	7950	1617370200000	orphaned
10907	3NLk9Gk81qX8sXJrTwQadsGpDV7yQ12BZNYzF9wMBdDmZn1A9oFA	10906	3NKyLWJ4C9fKJpo3UTyD5CsyAWMW2V2TwpQsj2qtWqX6wenzDobP	149	917	152	6301	7323	jxjGvCELfy3EbefbAhsUChV5P6USqYZWxaGwWNQ9tBfRX8ok7qF	5626	7951	7951	1617370380000	canonical
10912	3NKpxe9GVGUoKDMoUNcuNJAShRJSQdFEa5S6p4RGHmeSvxWpFBR7	10910	3NLLMrPj3uvqiDkBi2kwDnyv6xoK2yvQv4f2sD14YgeXD7kLinfv	1651	1055	152	6301	7327	jwstSsa165XhaTUbLqethVo6ZaGmTnCSXfacyBNX8rTYQ4eCaj3	5629	7954	7954	1617370920000	canonical
14542	3NLov3hKzyboZSzQLja772oU2tkhEnWcqMrw3PmpEHaYAxtV1zux	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	1627	1385	228	6301	10639	jwdxET9T7Cwnu1dGHexXUioygMCuHpn9BGJDzDyu7sLBBKeetaV	7418	10502	10502	1617829560000	orphaned
15808	3NLU6TknSjeDmtygBfGvxdrg1FW2nurhHpcNhwwMcUZqXDmb8YYT	15692	3NKsdyg5dWZgUQrroyzUaFS54GgMH8JKDq4L2nszqhkz81inZyp8	1593	284	251	6301	11812	jx3vriLQ3uM6Zjn6PqMBacLxQxo25aAbBmUNj893vaHfaLBFBXZ	7957	11395	11395	1617990300000	orphaned
10882	3NLmuoB9iJYfB97cyx9CTSo84tx8CgSNorv9DdVCyoKXxTif6Ux9	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366600000	orphaned
10897	3NL2kVf1sS2SH7VczZPwj3sZPxYZMRUkhmkTBKVfAy5mAdj857nh	10893	3NKdVbc9tLftdMmpQrXegDjcAtg7GNJZWnqJ56iDApcbrT2qBrwe	1638	630	152	6301	7313	jxQ9PrEa47h4PYRRuXnhqFzpbdKWrnctuAtMNerdqeGSbCfQKcg	5618	7938	7938	1617368040000	orphaned
10903	3NLU9SZsbYZubBXT7rrohdtpsmgDwy2xNPv4gNYd4hfXDqMA3xQJ	10902	3NKp8aKFgxHYgwXRCWqTjSvC5RFWitDq2wthVmdgPHSuABasaZra	1657	1344	152	6301	7319	jwcafLFybMeaaFjKXm4BNqowJ69spxWp8mBSEyLmUJMddFdBcj4	5623	7946	7946	1617369480000	canonical
10909	3NLGa5rrPwrGM5D35newfLEFoiZwymZ23t1ScGswqZLDjrqY2jtn	10907	3NLk9Gk81qX8sXJrTwQadsGpDV7yQ12BZNYzF9wMBdDmZn1A9oFA	1546	1339	152	6301	7324	jxQXCkTc5rQiZSr6JUshYMhaZUJseaq7iKPPuzpgmguBsGfYmjG	5627	7952	7952	1617370560000	orphaned
10911	3NLwT1w9vqKKAR4NDtJsoGdhCSDkCKg5vDpt6DRCRFbudvEwg9qV	10910	3NLLMrPj3uvqiDkBi2kwDnyv6xoK2yvQv4f2sD14YgeXD7kLinfv	596	1306	152	6301	7326	jxhsvbyt6vPyzhWtPA9E5fYu4N5xUM42SsWSRCNkTjDJrqe5xeV	5629	7954	7954	1617370920000	orphaned
10914	3NLp3HS4rcW3LvsfjnU1kVDGis7nLz6oAuVHbSVqS4dvkkGEEQVi	10912	3NKpxe9GVGUoKDMoUNcuNJAShRJSQdFEa5S6p4RGHmeSvxWpFBR7	1407	1395	152	6301	7329	jx6xRDAWguK2krAmGitC4oWmnuh3SiEzf1b9AcSbz3bT94SakDz	5630	7956	7956	1617371280000	orphaned
10916	3NKjpnANyvFCoFGzhX3y8rrusLJLALXp6FYUG2YYuuNzGZeS5t9x	10915	3NKWthw1NkKycfzeSdXzFFcqXqTqbx4yyLUxXbnJNmSCBo4F8SXV	1673	1122	152	6301	7331	jxeRFksZeEd7vHsHhkpVfEzRcQNkWdKxwhaakum8PcRasbQBa7Q	5631	7957	7957	1617371460000	canonical
10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	10916	3NKjpnANyvFCoFGzhX3y8rrusLJLALXp6FYUG2YYuuNzGZeS5t9x	1513	1253	152	6301	7334	jwHHc5a1j8zWyNoRusRjs3222gQt17uEF2s2shv3TuP5cuvH1yj	5632	7960	7960	1617372004370	canonical
10925	3NKzvjGrNSrPRcqAecpf3gv2vYF1wMpmT1mv24E4QLLtTjR7UM93	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1403	31	152	6301	7339	jxKWZM46VVUKcwTQ7Z2bu4rkEmYWVc6PnsZgThnBPEQVdiyPydY	5634	7962	7962	1617372360000	canonical
10923	3NL5uAb9coYYLZ1W9V4R93PgQ55RnCxcVwi21x26W8Wwkv1eeZ4L	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1559	1353	152	6301	7337	jy1ZczXzvGziTWB1hJWKVLVmyk9uJA5fR8wKWfUaWwhCjMNDHWE	5634	7962	7962	1617372360000	orphaned
10928	3NKmU4DwBFtCtn3BHmBmvS9PjV2qUovYjJSsGsNcyBwUWN4shiiv	10926	3NKj7zMeXdDNQb2B8gPY8eAd5TYwodwutfAHvWjKfKznYnM3SQCZ	1652	1315	152	6301	7341	jxKoNERp1YX6dRoewUhwffPMNcBxQyWNBNWd5FDtgsefJvDVHpr	5635	7964	7964	1617372720000	orphaned
10931	3NL1mqy56HS7E2nqEtgW6ZKmBFRGh8ks1YBjqR2jKtXvGtzzJgcM	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1652	1315	153	6301	7344	jwEAv9atv8UBD3cW6DDprEdgABvLaog6qMDWbSruffGkfXdWs51	5636	7964	7964	1617372720000	canonical
10930	3NKVmDrps9as6jKiiKv93LM3J9dL1xXLFJcLuC31qGjw5Gup7u86	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1651	1055	153	6301	7343	jxjppubKqAocxA1iyxFJNuf29Teqtbw7rpzGKaB8CzYnjTnen6E	5636	7964	7964	1617372720000	orphaned
10933	3NKqQbY9WVPz6VWoAtxmLpqyAsSZxEdnfZywHhwZSzmzsfQC6t5W	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	606	1295	153	6301	7345	jwtKJ77HyCNuY6DwPys9gZv3z7fbbuwrtXcfyhSSKhxkLQ3nk8Y	5636	7964	7964	1617372720000	orphaned
10934	3NLLrv9NFwTjJjVZD3tZMggxwnYo15EkfP7Zhbo3TGp1tQxoX4i9	10931	3NL1mqy56HS7E2nqEtgW6ZKmBFRGh8ks1YBjqR2jKtXvGtzzJgcM	1500	931	153	6301	7346	jxXhhr45qTuD93714DtUdw8JXmu9JPdwRCV6KxVmZ4vkuWXZX1x	5637	7965	7965	1617372900000	canonical
10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	10934	3NLLrv9NFwTjJjVZD3tZMggxwnYo15EkfP7Zhbo3TGp1tQxoX4i9	1673	1242	153	6301	7349	jwqoEP7BxbumY5yMbpdjuH5r9yAc2V99hE4AuSx566TyLnQpFNB	5638	7966	7966	1617373080000	canonical
10940	3NKA2KNCPRBjzTKUkLb1tD119LiadPeTGAzzE4cCjsw2TePAJpSk	10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	470	1183	153	6301	7352	jwNt4bhhizTHqhE833iDnt3qbKfoTjsWPWUV638JW9uBdhSeYBt	5639	7967	7967	1617373260000	orphaned
10938	3NLHPCDuh75R4WwiBdzCqHKMhRE2CBCo41zAQ6yc1XAzJX38WZve	10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	1440	1377	153	6301	7350	jwa5k52CHroVZ2Zh4mUMohq2yfCJQasbqUcJXDxazcUkCV3bexW	5639	7967	7967	1617373260000	orphaned
10942	3NKEVHrWW1qq1bf4AGCX4jA1txaJKHmA4RExeaAo8QtJA8Gk85zg	10939	3NLmZ72tQpKiBLWbRJvemqTNs13s56bvsU8owkVjmfvUswnZ7Lhy	1549	1362	153	6301	7354	jwDDiZYupfdA2UzpG5aCMd9ZjLZZttZpX5fzcBAxdojyw9vsX4t	5640	7968	7968	1617373440000	orphaned
10944	3NL5m478uU1NP8FA72E5GUnTDftX3zsxxkq2vPPJma5HFGVMhi9m	10943	3NLbuU5BcGneFBhZDNgm2n6XKse5CkBjicmkdmpscNk1acZCe2rk	1649	1257	153	6301	7356	jxku8nuuywhT9xwbFN6282p8fo52M5P2Psmr6Bd45tDJF3nPy9v	5641	7969	7969	1617373620000	orphaned
10956	3NLsrkhytcnaxxPjhTD9wNCktTQwBGVMjQktnMm3C4FDRUZAepa7	10954	3NLprCLA6FzRyvP4nNcDvTTFeW5ZL3ciWf2nkeDPpmaWm2eo9KQs	1406	1393	153	6301	7367	jx5rptcsaVG6JPeUzdt4DtPg8FeNytwfhVnFgq3HZaL8RZxXunU	5646	7977	7977	1617375060000	canonical
10963	3NKxNRKdmnqMMnWUTnjWXnpxSW9UMHPoQXFrdeS6Q1h53imSE9FN	10962	3NLxyhaAEJiVeZ7Xt8KuniBtskri4zFpBdFJiuBWDvoA3m7cteFM	1403	823	153	6301	7374	jwUFJiPpPKKjgxesXrHTsWaFEoWzVxJHiUb1xL1PsUuHcWM5nyr	5650	7982	7982	1617375960000	orphaned
10969	3NKmkXwt7ZhSYdoropRoY44Yjna2iWaFmWXZctAvMPFxmhtnD9wi	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1619	1275	153	6301	7378	jwX6VPAZDaGEvAmQsfkEakb6vHLmQAEGj4s9kp6SpjfzbmxZP1v	5651	7983	7983	1617376140000	orphaned
10972	3NLF33XssPw73M1jBW9CiWoghX6d39Mr42vXxvCVfZscgjTwJPrp	10971	3NL8nVEUPjifUjKVfrzHCMtkb1NuNL2uQDhgUVW6d69PLiRpuG79	470	1309	153	6301	7381	jxYcsNNJBhRCF9PbUDPyL4j8PizADapJufm7Kvm6oDiMqqhezaC	5653	7985	7985	1617376500000	orphaned
10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	10976	3NKwEq1U2ZAmiVPKrZwYSfdekuccrBzvrvuKJ3KnwYpiGrdta34Y	1474	1083	153	6301	7384	jwpgpzcGuSYcipjDfKohM5cmLGfohQ8hgruEA1tVPaLhdjMwF3A	5656	7989	7989	1617377220000	canonical
10982	3NKcx5gRafUimRkihQDdi55DZeG6zatjknJqApRLMbRW2nUm6958	10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	1594	1326	153	6301	7389	jwyhxGXsTrBBCHXLbcZoGoDm89ddQuq3qombJXVPSjvBW15uPga	5658	7991	7991	1617377580000	orphaned
10984	3NLrq2Kg1UWj3sShXDbgdaxaUtcRMg9K5SUdD7Hs4GxHSCwigvKe	10981	3NKtJ3HxegK9roYidXouHhU8ohNAfgj7fCLyLz9AjNQQQm7J5mcg	1650	1375	153	6301	7391	jwuoJkAX2s5oQJp9BbK4L3RiHcJ7R2zQNWb6z54k9cN9DEa4eJE	5659	7992	7992	1617377760000	canonical
10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	10985	3NKG8NvntNv5bG85TbvVNn3hsH89y1HnMCM7cjopRDq4YH293qQA	1542	938	153	6301	7393	jwERkMfdfJiVpcebNJazJ5TSHvEmb2N4cWs4QroKEbFuDbZgBg9	5661	7996	7996	1617378484039	canonical
14896	3NKHvyXqVHoU8XQwgqb98hx1H8GJaavDpdW4EWxgotnLGbfySTk5	14711	3NLRj73zuK69GJDrCKMUJh7qMiE8nZULdNpA2SbhNgL1sfptcAth	576	1229	228	6301	10962	jy2PdfHab8WJ4T9uLHMhmW8kxqU7F57LULnnfBdiDBmeq2c9Ku6	7420	10760	10760	1617876000000	orphaned
10926	3NKj7zMeXdDNQb2B8gPY8eAd5TYwodwutfAHvWjKfKznYnM3SQCZ	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1559	1353	152	6301	7337	jxHi92nWyUDSy1KcR6LthFdQanPoJELzK69Ciie6h36X5QN2bS3	5634	7962	7962	1617372360000	orphaned
10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	10925	3NKzvjGrNSrPRcqAecpf3gv2vYF1wMpmT1mv24E4QLLtTjR7UM93	1406	1393	152	6301	7340	jwaGxbZuKL8iuT3Bbeq2JNfmXvQLuanwGmkQQjLozzqVTzkQfjy	5635	7963	7963	1617372540000	canonical
10929	3NKQnLW2fKy3GovFX5gzv1b5yoKyhRvFQbR2GG5EnXJmyYT3L8an	10926	3NKj7zMeXdDNQb2B8gPY8eAd5TYwodwutfAHvWjKfKznYnM3SQCZ	606	1295	153	6301	7342	jxYb7XeZGPNVrbngsFkGHAKwhp6PmjVVb4tZBbf6efKs6eoS4sY	5635	7964	7964	1617372720000	orphaned
10950	3NLe2vTnYgxg4FMPSiwvrhng5BzXDA9yNepEpdJc4codicN1e2gf	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1571	1335	153	6301	7362	jxupvXNFLVHrHKV3Ho1didDnRWwSK7FDRQMaH8nEZErw1AY2A8E	5636	7973	7973	1617374340000	orphaned
10941	3NLaeoJrPNAKokLCZ6kXZv71hSfBjjdQWENFUHnG3GHj82WGxXmK	10939	3NLmZ72tQpKiBLWbRJvemqTNs13s56bvsU8owkVjmfvUswnZ7Lhy	1451	1292	153	6301	7353	jwhxjrFsWPs5qhmuUS63iLbdiHyhHHRGYc5rqW9u2MsjmFtQYkk	5640	7968	7968	1617373440000	canonical
10946	3NKR418P1uPqvcjLaD3SPhU7oj4cE8osfYXY1jd8jVvWsw9CDNf5	10941	3NLaeoJrPNAKokLCZ6kXZv71hSfBjjdQWENFUHnG3GHj82WGxXmK	1637	816	153	6301	7358	jxwLxxST1vu7LG2ixTfouWF1TFp9HkgUDuz4iqf1qW1uB3GcP7w	5641	7969	7969	1617373620000	canonical
10945	3NKw4JyGcbvLfdmptLnm45A5XoUQ6UB9tjbfGRbT6vWe3KMs4J1q	10941	3NLaeoJrPNAKokLCZ6kXZv71hSfBjjdQWENFUHnG3GHj82WGxXmK	1649	1257	153	6301	7357	jxADNHXA5QGHXL7ZXTheWnNYz6R8T17hQ1HQ4ehPHFaZixaMAxT	5641	7969	7969	1617373620000	orphaned
10949	3NLC58C4Aj95yok737V7byPB8VegyHabQZK1aMeHWn7fJpgEDQWL	10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	1407	1395	153	6301	7361	jxVpcgmrmmDdaLNeaZQkFc7Yj9s9acFiVX8n6bRtAVgQXZoRiYv	5643	7973	7973	1617374340000	orphaned
10954	3NLprCLA6FzRyvP4nNcDvTTFeW5ZL3ciWf2nkeDPpmaWm2eo9KQs	10953	3NKxj8EyWX7c2nudKtPwAiGswEr7WyQBa1HjXCFQcr1w3G3iYcJX	1437	155	153	6301	7365	jwNp7aoEyxtJWjypQwB16hRpw3R6BE25prZH7XnabwyNAmf2b4E	5645	7976	7976	1617374880000	canonical
10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	10957	3NKEG7v7opNjay5X9oijTpSA3fNz9c2JNCgMYCSRb1HjfC5sNAZW	1647	1056	153	6301	7370	jxLR5GLJWPriRnbbtVb8Hkz7humRwEkSfrwTo369EhncEZ6rZ3V	5648	7979	7979	1617375420000	canonical
10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	10962	3NLxyhaAEJiVeZ7Xt8KuniBtskri4zFpBdFJiuBWDvoA3m7cteFM	633	1384	153	6301	7375	jxW7GiwdWvLjDnD3ee6GkvETRHsGGd3tMd2UdULfnjQoPciecRu	5650	7982	7982	1617375960000	canonical
10970	3NLYwNBUf5ZjRRtdYF5prqE4Ni3DBxpMe3xG5vuYuQuhyZRwriDe	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	58	1035	153	6301	7379	jwFsRRhr9Fi9tSTdfJX1NB8zTeEMY4MxasbZLjmbTYv7eozWCwH	5651	7983	7983	1617376140000	canonical
10966	3NLq7KfzeMoriDHRKAfFisCPHiaKyxvL5zupb9n5FRCT7gWgjt6f	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1602	1369	153	6301	7377	jwTLFo45RcX8JVhptTGQ7R4nZ6XsR1da8qJB73Yx7S354XQfKd5	5651	7983	7983	1617376140000	orphaned
10975	3NKMjX7KD3CWWfjbMjK2xAX4aT9FyeY1paNS5n4Vx2yNWsCAAxco	10973	3NLLVQmzcc6QZ2qzrJH3r49qudCSvrRRzEqJhkuWAjVdTvKWeSCj	1578	930	153	6301	7382	jwvHpHJuzDm2k1P5319B16MekcJvZR9dSg9vNftpfBAi5fdjTqX	5654	7987	7987	1617376860000	orphaned
10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	1407	1395	153	6301	7387	jxUFWyvfTCAi3fmEcaibsjH6oF6RrwnjLmMDBv6P1uUkmNmAx2t	5657	7990	7990	1617377400000	canonical
10983	3NLjF51ssva96Sr2ZZqMMp3NujB342zJ16QGHVJjbRVickZuhYJw	10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	1585	1000	153	6301	7390	jwGjuPPfQDhKb2B1RTY137mfYEFwhka7T59MxsHE9DskG1rYZPH	5658	7991	7991	1617377580000	orphaned
10985	3NKG8NvntNv5bG85TbvVNn3hsH89y1HnMCM7cjopRDq4YH293qQA	10984	3NLrq2Kg1UWj3sShXDbgdaxaUtcRMg9K5SUdD7Hs4GxHSCwigvKe	1590	1300	153	6301	7392	jwbYUYii3ATvXaj2JopMbhhR6o2527Fb7bbfs7qiGknEMj1H1LJ	5660	7995	7995	1617378300000	canonical
10992	3NKqsoFw6DY25SFpgZa8ivxaCi3HAzLF7pyHkR1WFNHQzB14ZTnx	10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	311	1061	153	6301	7395	jwkmT93U9soPVwVTLMz4CaPoVRrnEbe6FyieumMnhawnttK9jJ5	5663	7999	7999	1617379020000	canonical
10999	3NKvccAv4RNC1s6ViFLexAKR8rScK3Xm2B4Q8bDxJVFa8LrtfkXT	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1483	1276	154	6301	7401	jwry4MrAJBto4P1PK3Sc9s8Xu9V8RFpxVLwjxUD5uK6bLC22ej1	5667	8004	8004	1617379920000	orphaned
11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	1646	1228	154	6301	7410	jwEAK8xqQfW3ZZYcP6KbGjyivf4TToXbbxNvgXigVFmuFpB2j3U	5668	8006	8006	1617380280000	canonical
11010	3NK4gqb2Ma47UYZGZXgwCs5xDwm16FUQJAJidinNrYSbDsMU6kyt	11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	1403	823	154	6301	7412	jxVvmCRuTSMmXwFPDzGC16cmXSmDiH4Z78grNxMf6a5AFcB3pLT	5669	8008	8008	1617380640000	orphaned
11017	3NKcQ4qoNg7FSH7nVcxggqxfh7vb6rX8XdTr1ksGAWmhz42emaBU	11016	3NLJpUMEy58ywF8LA5ngHagPMoH2waumEPrBFfvY94srZsXGu3gH	1406	1393	154	6301	7418	jwqRDy9hzkhg3nYQcc6SEU2UD6qP2gCkDgRj7yo37oPkwu4tRhU	5670	8011	8011	1617381180000	orphaned
11015	3NLRH3E7h2aDi45joeN3gvyMBGdK5ZQfAbKR3Bi3WZeeNa3QHXcX	11013	3NLeLuCuResFb7LF6YtfJu2pvwBukvLt9NW5MsvbgK8WmjZbAzAu	1536	947	154	6301	7416	jxUTC5KQUEEwmNZrB9ZxtXpQ9va9g1PJugxPeKhSSp9yqu5CSEv	5671	8010	8010	1617381002951	canonical
11029	3NKWCbwMcebYz3WLdP2KJBZdbLmLwogXuQFWDmCVDc2LX7aR8262	11028	3NLtMiTTfBetGVsj9ojo8Aiar94voRDoi4FuuyzEoT3YCLnDoX4U	1501	1114	154	6301	7430	jwHobcJWZ7etC88FRnbwomVGA9WFwqLYWHA18heaQhuMbrgPhZc	5677	8020	8020	1617382800000	canonical
11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	11031	3NKDee3A5U1rKDXWPq6QEyNTKAzVHZUCi7cLQMU4GiXn5z8VrqjC	1440	1011	154	6301	7433	jxnw6MYBHiVizzVJ5vP9DfhqYyka74zLB447gNQXAw1MAfFRUnP	5680	8023	8023	1617383340000	canonical
11034	3NKvxDqbPsTYtMrTrdbp3zNXbgPYshm5s1mAT1cm6rHNFeDGMtj4	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	1403	786	154	6301	7435	jxx6k2NSeHTq7Bu2rLHjEstV4MAjcktyi7U2BE898oWAWagP7NS	5681	8024	8024	1617383520000	orphaned
11037	3NKSYMqn67rJXjjdLCyQ97ksfucrz5jMsE9FyB5N15vGWC9RcN6t	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	43	1064	154	6301	7436	jwaZ8kpbByoAwfSWGk9kjitoRVFnEMcU6xY8uuV8iGRg4YZMZUS	5681	8024	8024	1617383520000	orphaned
11041	3NKtiY7daqwU8M3erSqQn9uGuxUos7TeVQn4QduXajPr9iWR6SLM	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1672	1039	154	6301	7441	jxgJTogFC6XvsAD2guBzBUcWk1qWzhtjHcFriZetjnznLaZfWH7	5683	8026	8026	1617383883464	orphaned
11049	3NK46zkysbj7DiuQ3kh9RZffX9e96EiTA9ezfNirFUNoMu3MT9db	11048	3NLEWKLXo8fCtYRfaSMAm2wxWexaU1hqWfwMamBu1WS525Vp1T9b	1451	1292	154	6301	7446	jwSQjMdutmEeyCY5ehM15ncFSoCBymtgSx58Fxs9CExkUYTvFLL	5685	8028	8028	1617384240000	canonical
14936	3NKc4ieeCKpJh5Q7w41qusgsyTNGgDdQm3tcjU4rGGJsPQAeDHxa	14896	3NKHvyXqVHoU8XQwgqb98hx1H8GJaavDpdW4EWxgotnLGbfySTk5	576	989	228	6301	11002	jy2PdfHab8WJ4T9uLHMhmW8kxqU7F57LULnnfBdiDBmeq2c9Ku6	7421	10785	10785	1617880500000	orphaned
10935	3NKSeo1wRi6SJQAwvTDbHxRJwipwJPcLRCasX3BVmxFLBdfiEsDq	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1406	1393	152	6301	7347	jxeZ8FdC135qhBHixq141MSm2MChsk3gBVto5VefZBGitGmD8Y8	5636	7965	7965	1617372900000	orphaned
10939	3NLmZ72tQpKiBLWbRJvemqTNs13s56bvsU8owkVjmfvUswnZ7Lhy	10937	3NLgA892Ez9ZkCxokfJqiuotWwyTuvur7PW4vHazgQmptke4gPEN	1522	1076	153	6301	7351	jwZvAKTc6kGbJJCftbrpreAh6jQgwkD868dH5rorMrsfGRcxDHx	5639	7967	7967	1617373260000	canonical
10943	3NLbuU5BcGneFBhZDNgm2n6XKse5CkBjicmkdmpscNk1acZCe2rk	10938	3NLHPCDuh75R4WwiBdzCqHKMhRE2CBCo41zAQ6yc1XAzJX38WZve	1623	830	153	6301	7355	jxdRZGDkWqX8JEFgy2JVDw528KkaShy3bJGmFDWuVbVrJt1XsyV	5640	7968	7968	1617373440000	orphaned
10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	10946	3NKR418P1uPqvcjLaD3SPhU7oj4cE8osfYXY1jd8jVvWsw9CDNf5	1585	1240	153	6301	7359	jxq1TCwxCL6gFDvxLBunnqSC1NPtWq8rouvzjQuhn9GtPmZCDqk	5642	7970	7970	1617373800000	canonical
10951	3NLPunqPAT9yvwvXx2t72s12tanHSzEcaxgmvbvbiSgRze6Y9dgN	10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	1506	1373	153	6301	7360	jw9jUK2L7UD6X932hhU5Jsw8jzdxYCHK9FekgvNpCfMKw24RiP1	5643	7973	7973	1617374344461	canonical
10948	3NLBPn3pAWeXmC6GG3n8LxkpwfCrcuuoxaUJud9X6RnGVdKwcrwn	10947	3NLZqQTgPUgFSKAagN8dkQedeZCjG9JKBQvcnAbqo9zitiZSHvYY	1506	1373	153	6301	7360	jw9jUK2L7UD6X932hhU5Jsw8jzdxYCHK9FekgvNpCfMKw24RiP1	5643	7973	7973	1617374342736	orphaned
10953	3NKxj8EyWX7c2nudKtPwAiGswEr7WyQBa1HjXCFQcr1w3G3iYcJX	10951	3NLPunqPAT9yvwvXx2t72s12tanHSzEcaxgmvbvbiSgRze6Y9dgN	1407	1395	153	6301	7364	jxLhD6SnCBuCDJiiQDJRCb16zgDfKgLMMx4ybHcAn8REEE3sQro	5644	7974	7974	1617374520000	canonical
10952	3NKZ7upCzyYAwpZ5eL2Z6KLpMp7tx8DxBTCqiRwcc9tYVaPPUJzo	10951	3NLPunqPAT9yvwvXx2t72s12tanHSzEcaxgmvbvbiSgRze6Y9dgN	1536	947	153	6301	7363	jxmN7kM8ZeJqVQGtkfebfkf6sUDfYNTu2CvBehrSHyPskHjhfXg	5644	7974	7974	1617374520000	orphaned
10961	3NLqF9ZFn7qzzyHogdjhevzXKETEQKmBr6ud5J4tMK4xn6xZ8bgi	10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	1405	851	153	6301	7372	jwvGrMMHN1FL1wL8R9HEXeCwq3M2BFNNmY679phfytcjxwYDm31	5649	7981	7981	1617375780000	orphaned
10965	3NKkNkUQgMSnDBPULEQ1RK46xPpcLzkeY25iL3BQwTaToQoQTZdZ	10960	3NKx3Qhw9Sbtop8twdEhsr2ZWHHaR6k9ko5Gy2vGNTZakk3vxkQG	1406	1393	153	6301	7376	jx8vSW7uJzzMBvdMj41tzPKjqWaX7pwWh6k3ecee6KY81qGEcj9	5650	7982	7982	1617375960000	orphaned
10968	3NLsjXBYTk1oEFRb5onRDksNLhCHrJzbDkXmUQ1pSKciXNSg5PgP	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1619	1275	153	6301	7378	jwX6VPAZDaGEvAmQsfkEakb6vHLmQAEGj4s9kp6SpjfzbmxZP1v	5651	7983	7983	1617376142738	orphaned
10974	3NLqJ3wD9LLdBxygRaSkP7dPKs4sC6CeFaRG9L2hDLza7bfu1YXN	10973	3NLLVQmzcc6QZ2qzrJH3r49qudCSvrRRzEqJhkuWAjVdTvKWeSCj	1578	930	153	6301	7382	jwvHpHJuzDm2k1P5319B16MekcJvZR9dSg9vNftpfBAi5fdjTqX	5654	7987	7987	1617376862660	canonical
10976	3NKwEq1U2ZAmiVPKrZwYSfdekuccrBzvrvuKJ3KnwYpiGrdta34Y	10974	3NLqJ3wD9LLdBxygRaSkP7dPKs4sC6CeFaRG9L2hDLza7bfu1YXN	1403	824	153	6301	7383	jxLZpe1aqhYP4b6aqH1ax66UZhUqiRDTexrUgpEGVjuhrhEQ75e	5655	7988	7988	1617377040000	canonical
10979	3NLLPHGLzY8Re8FMVNcBJJ8DRDVZccesnTWW1HTjppjcUD5VKXfx	10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	1501	1234	153	6301	7386	jxZKqhHGE2vMJPSAKAAxsVSrG1nAmk8Y2qNKqg9KLuXiGQ2Foor	5657	7990	7990	1617377400000	orphaned
10981	3NKtJ3HxegK9roYidXouHhU8ohNAfgj7fCLyLz9AjNQQQm7J5mcg	10980	3NK3PdqEZatCMVGLgUYdaW3HAC97fGR4dAnrSAeA6VUErh9K4PCD	1509	1320	153	6301	7388	jxMGcjeZsLJ3skpgkeShgrictyQGtYUdHnyVAcmdvSDpFtrDH5B	5658	7991	7991	1617377580000	canonical
10986	3NKWVfi2N4kFmatCfRoaKRpUDoj5bF6Hnx7pYYewzbz83Zg1Hriy	10985	3NKG8NvntNv5bG85TbvVNn3hsH89y1HnMCM7cjopRDq4YH293qQA	1542	938	153	6301	7393	jwERkMfdfJiVpcebNJazJ5TSHvEmb2N4cWs4QroKEbFuDbZgBg9	5661	7996	7996	1617378480000	orphaned
10991	3NKUHZYKcwkhu1q1JWng1PJ1YP9xHhvi2tPxhNH2xpS3tvD84kL9	10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	311	1061	153	6301	7395	jwPwZ1N3K7X2ozyA5Hcu7prJaxw1hUieFt171gsj8jjjxeFVjFf	5663	7999	7999	1617379020000	orphaned
10996	3NK4WgWooDhM8ZUsYp2WeT32SxMx3SwQDBE4MSrLVhx4Sgev9eaT	10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	1471	1386	154	6301	7398	jx7MZrRstSVEVr8eTxyPXzazhXFQyjeBSotr7bVNxZgfPY8ByE2	5666	8003	8003	1617379740000	orphaned
11001	3NKYcHBSRSdmpdhwmTb8crHBaiYuS6rwamPaREK3DnxEyqrq2GTx	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1407	1395	154	6301	7403	jxbXyNzTcFLAAM7Q9q19Repcs42NvsmR4DZaD2L16iYw5P8yoa2	5667	8004	8004	1617379920000	orphaned
11009	3NK7sWU6NZBFmCKqXQdG3TCjCeYJaQ9rvPusmm44Wdq1MiTUBLa8	11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	1448	1185	154	6301	7411	jwByFs4rjKcCjNJ53PaEh55zoEhw4bWqHJ2MGiwHBoUUcKRoChp	5668	8006	8006	1617380280000	orphaned
11021	3NKkRkmaRKLguGLtW7fP9JTLPFhrhan74JHSC3D8oJLtWFpWTTTg	11017	3NKcQ4qoNg7FSH7nVcxggqxfh7vb6rX8XdTr1ksGAWmhz42emaBU	1406	1393	154	6301	7422	jxUW4MfYy3vBoi3yQEoeeK8MtkrTnwKsX6yu2nNdRApkyDByq5Y	5671	8013	8013	1617381540000	orphaned
11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	11015	3NLRH3E7h2aDi45joeN3gvyMBGdK5ZQfAbKR3Bi3WZeeNa3QHXcX	1649	1383	154	6301	7419	jwStm7fSrnGh32f6gkfvgKWBb7u3pau2bFYqF2W7uzCNaZypVib	5672	8012	8012	1617381360000	canonical
11023	3NKgP59aaHXPDKEZVFQUGFrDryiR5YLi8zL1Ku4SZ8Wqpw6z85aS	11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	633	1258	154	6301	7424	jxWH46tzzK9rHnELEuUCiz5rsUqArYyBQrC8wAnjWuLe6cHmUXA	5675	8015	8015	1617381900000	orphaned
11026	3NL4txCiUvgqNFp1FZb1wNvEuVbiFpEnEkzDZjVDvB7MYfBs2AN9	11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	1642	1241	154	6301	7427	jwu3mfR4HNmGWD5SbAkw49v8Zi7sCygCEgRxLum3h46szf2qEdV	5676	8019	8019	1617382620000	orphaned
11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1522	1322	154	6301	7443	jxqcHNHaic2FkLRuLVXv7ByonFoD4UAacvuNbXbVxDNRqQExh5P	5683	8026	8026	1617383880000	canonical
11043	3NLgMkxsESS3B5VAK3DPitZ7sFsmmddQ2Bqqu2xGiihAYFp6ywsn	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1672	1039	154	6301	7441	jxgJTogFC6XvsAD2guBzBUcWk1qWzhtjHcFriZetjnznLaZfWH7	5683	8026	8026	1617383880000	orphaned
11046	3NLaNg4i9qGBC9fydjJc9uzMUMGimWYKppact4ANxtdvni8YYhyL	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1523	1321	154	6301	7445	jwR91DWzXgjvajRDveHhTtVfKKY74HVySg1pLNMPVyX2m2C76gv	5684	8027	8027	1617384060000	orphaned
11051	3NLRnUpQ5nEEWi6Ssc2z3zQZzzWyTXKkPFbzLwBSDoEfWScToGfv	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1451	1292	154	6301	7447	jxaPxGf1s5x4mS6C7sUJ53Sg1oCKVmrBjLSSXMMcy6KTZaHaPT9	5684	8028	8028	1617384240000	orphaned
11053	3NLaCPrfCiTDk9SsLhY3iact9qwpz8QMmkouW7ez1DpJtpULjYUZ	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	1447	701	155	6301	7449	jwNVZ2gmorfvmdEMkqCbge4ZSkEmrGV19qMo9Q8kc636LPyLxd4	5687	8032	8032	1617384960000	canonical
14557	3NLCchX4etVC62vdBZZmappmfZN7WcV9bE25uZw49JBqK1QmY5FU	14550	3NKL2m3D5FG2WfNzmGwyRiQcDXzozB1aVVdi6jpiurRGcPr2szX2	1594	1080	229	6301	10652	jxJqq8ZtoxQKAzZxqUriYvxbuS7cECr9V5V5WLZ63SpcAwcHU2A	7423	10513	10513	1617831540000	orphaned
14556	3NKcsc9D3ZkfJXtAgAQtqk53yyQVKs8VVhkGzf1gxHyjYSM26zjV	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1594	1080	229	6301	10652	jxJqq8ZtoxQKAzZxqUriYvxbuS7cECr9V5V5WLZ63SpcAwcHU2A	7423	10513	10513	1617831540000	orphaned
15638	3NL6B4gKdnA6fwMHMujmxme7C6cSrFSv85vx55fRxCCTwhvMJStD	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1555	1347	251	6301	11659	jwtngxATEMTkpDbK2ZfZrHNem8LQYBdkWotKGczSCrsZqrGMnSY	7958	11268	11268	1617967440000	orphaned
11003	3NKdegosEZcwUNrFM1prYBEKzu7qhsjMpMyM4JET6ayzQ3Mdd1kj	10411	3NKTKH8eL8BB9XAiA17vyHen5ZcT2vQdSgqyb3gkevHdYg8pA6J3	1483	1276	141	6301	7405	jxeY6a5j6X3tBVak2jxkQkU57BcDVEXC4JnAgBfaXn9zwNpsryX	5386	8004	8004	1617379970142	orphaned
11005	3NKAfzPkvZSHT1SfJ4HmiJEHb9GuQQEybGpz6YtVswwJU4NPiWQr	10412	3NL6aDHvieaB8z4STn8SbAzRy7896ubDxTWZ54f9MApiXCgGDDa1	1483	1276	141	6301	7407	jwiBXjfKLeFD2EBk68S996b8cSjYxGDrPB3NCwvqn76S36VwLoi	5387	8004	8004	1617380017498	orphaned
10957	3NKEG7v7opNjay5X9oijTpSA3fNz9c2JNCgMYCSRb1HjfC5sNAZW	10956	3NLsrkhytcnaxxPjhTD9wNCktTQwBGVMjQktnMm3C4FDRUZAepa7	1501	148	153	6301	7368	jwZvPhxqMDcGyR7C7L31PJCEQaSTcteWMxSky2u3MjS58QnmATA	5647	7978	7978	1617375240000	canonical
10962	3NLxyhaAEJiVeZ7Xt8KuniBtskri4zFpBdFJiuBWDvoA3m7cteFM	10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	1590	1174	153	6301	7373	jx3gJnnQuHVJD6HkNttbfyBdKvift62gMEosP9ueUfJxTJ6aALh	5649	7981	7981	1617375780000	canonical
10960	3NKx3Qhw9Sbtop8twdEhsr2ZWHHaR6k9ko5Gy2vGNTZakk3vxkQG	10959	3NKdvR2XSSWXgnTmovocB8B5Y2TMggcymHXvD3wJjiRhP8CE2zYJ	1483	878	153	6301	7371	jxy24tQfRNMKzGr4yHpCA7JR5LYzi2KNMUss6zKCvDh9jJMMW14	5649	7981	7981	1617375780000	orphaned
10967	3NLu6SKrw8EvKKDYSADVgsGP5pY6Hiyj7hhFv1r4Gb1tgfrtD4NJ	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	1602	1369	153	6301	7377	jwTLFo45RcX8JVhptTGQ7R4nZ6XsR1da8qJB73Yx7S354XQfKd5	5651	7983	7983	1617376142700	orphaned
10971	3NL8nVEUPjifUjKVfrzHCMtkb1NuNL2uQDhgUVW6d69PLiRpuG79	10970	3NLYwNBUf5ZjRRtdYF5prqE4Ni3DBxpMe3xG5vuYuQuhyZRwriDe	1419	814	153	6301	7380	jwjfQEW5JGdnUBBAeuvX7qrxWmKfkfkkHhdvqgPZ1ZeCAX3zG2g	5652	7984	7984	1617376320000	canonical
10973	3NLLVQmzcc6QZ2qzrJH3r49qudCSvrRRzEqJhkuWAjVdTvKWeSCj	10971	3NL8nVEUPjifUjKVfrzHCMtkb1NuNL2uQDhgUVW6d69PLiRpuG79	470	1309	153	6301	7381	jxbXMNLM76HzgY5awdf4V6rCzJ8gAZRErfwddk8o3KyYHgmSSkD	5653	7985	7985	1617376500000	canonical
10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	596	1306	153	6301	7394	jxebnApDo1RdnuS1vjAtpMeJWRh1RdKd7UtmgETBEu5QaWPTQsA	5662	7997	7997	1617378660000	canonical
10990	3NKAiVjJy3R75yC7amU8erEaRYdhdcmeARUdhr6qcyyaEfe6A83p	10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	596	1306	154	6301	7394	jx1YMTLhPMSQKbqdtjdeeGcsTYfeCnL6iNYbtceEhiAr1EZZTyZ	5662	7997	7997	1617378660000	orphaned
10993	3NKwA9WZeDrXABs8ThiovSRQeAY6aDAPVjSc32Vnw9rLYyXgz2BM	10988	3NLRt1K856f9nMUKjaWvWt3bZo5scLFk8Y8G1fpJqR5DRFt3toiM	311	1061	154	6301	7395	jwvuGheC4oyA15LwNzUMALS75tp5GQuY8YH3cZ9dUZ1C4rMX5AF	5663	7999	7999	1617379023557	orphaned
10994	3NKJUf9axu6eRXtpycbkqM5x8i7tLAb4PqeEvV4afMJzmGBZvKUk	10992	3NKqsoFw6DY25SFpgZa8ivxaCi3HAzLF7pyHkR1WFNHQzB14ZTnx	1508	1261	154	6301	7396	jxasPPjzEvQYXVnaLdipj6oZRvxwHY6W4fiyRVsacyWaezgj6Mg	5664	8001	8001	1617379380000	canonical
10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	10994	3NKJUf9axu6eRXtpycbkqM5x8i7tLAb4PqeEvV4afMJzmGBZvKUk	1403	824	154	6301	7397	jxKc9Dmn6pFdVL4hcsKnHHEoMwQ4kZgLCsG2ANTH7s9U9bfEWHh	5665	8002	8002	1617379560000	canonical
11006	3NLWBp2Na2ZK1FFnChdjpT27ZqcBTaWATJ7pVm1aEZKBMhh9JeGu	10996	3NK4WgWooDhM8ZUsYp2WeT32SxMx3SwQDBE4MSrLVhx4Sgev9eaT	1406	1393	154	6301	7408	jxXQ4X5N5ihGDMFrqGFgqcMxGUYZfcGmCp7RW7SyRuFKnGLDcJQ	5667	8005	8005	1617380100000	orphaned
11007	3NLmnuuG2k6rTpc12qsFmW3dfqjWwwzXeV9y3srmJZz3piZFWFRa	11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	1407	1395	154	6301	7409	jwiYHobEEQEwTQjTJTGPXrQnWMJX5LjaUs6B5gNDLhdBHtSydgj	5668	8006	8006	1617380280000	orphaned
11012	3NLtbMY246oNTLeTv8iuJxwjom1ei5vm5D7vArk6nWCTf52Ew377	11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	1458	1077	154	6301	7414	jxFDpcBKu4VZn46vDCGVfv5dNde4RaDbMxCMy21hq9Jnrvv1d3c	5669	8008	8008	1617380640000	canonical
11011	3NKGaXUqYdLMbR41pbjVCPSjEcgPa7H1J8Dwjr55rUQ1Y6ZFa3EL	11008	3NKJccu8JZoWoq7qaYFptdnYj192qRNoHustdgDnw5MSKRLVo3dq	58	1155	154	6301	7413	jy24izsr3DUBp3g5ZVAmLaFHaxgq3hzDjq2YFxDEyf4VUsBkYsJ	5669	8008	8008	1617380640000	orphaned
11013	3NLeLuCuResFb7LF6YtfJu2pvwBukvLt9NW5MsvbgK8WmjZbAzAu	11012	3NLtbMY246oNTLeTv8iuJxwjom1ei5vm5D7vArk6nWCTf52Ew377	149	1157	154	6301	7415	jxois4y34f6Jze3xF4RvmwP9NEjzpfkbT9imRWYWq27ULNSqrRh	5670	8009	8009	1617380820000	canonical
11014	3NLc9a6NY8AQ1vuzvWxEUhuAGPmFdfYHWRdii7dQrFbW2jaxuPgC	11013	3NLeLuCuResFb7LF6YtfJu2pvwBukvLt9NW5MsvbgK8WmjZbAzAu	1536	947	154	6301	7416	jxUTC5KQUEEwmNZrB9ZxtXpQ9va9g1PJugxPeKhSSp9yqu5CSEv	5671	8010	8010	1617381000000	orphaned
11020	3NLVRZW6aXsiAphDCMdTYJVbHZq3p41JT9TT7xN1BFdiD1gwmYN9	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1637	816	154	6301	7421	jx5UGAktCHvLXDLNtzmsNcEBTXgzDjB41tJXC6nWNqGRTsbr9qJ	5673	8013	8013	1617381540000	canonical
11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	11020	3NLVRZW6aXsiAphDCMdTYJVbHZq3p41JT9TT7xN1BFdiD1gwmYN9	1649	1137	154	6301	7423	jxyYghBGLEVsWNjHqTdrbzFw4nvjkBsAnp9Y9biRhr4r4yFB7a3	5674	8014	8014	1617381720000	canonical
11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	1553	775	154	6301	7426	jxE9ktdE7xdZuSYijDpowuVQLYCBHunQXi4MB4qfBB2Cnmcnuws	5675	8015	8015	1617381900000	canonical
11028	3NLtMiTTfBetGVsj9ojo8Aiar94voRDoi4FuuyzEoT3YCLnDoX4U	11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	1585	1366	154	6301	7429	jwye6swFTn5DPk5ZtY5NGa31HT77DmPqAEhmeqWraArAbptAJzM	5676	8019	8019	1617382620000	canonical
11030	3NLfEG95nnuFvffkQZpjcAg1gLQJEiUpuhuEeeZKPhAcPF5rMkgg	11029	3NKWCbwMcebYz3WLdP2KJBZdbLmLwogXuQFWDmCVDc2LX7aR8262	1440	1251	154	6301	7431	jwQdiXqoRF4yw7SANMNXPNKkjyNKJk53BWT4xMi57EeDmC3dX5y	5678	8021	8021	1617382980000	canonical
11035	3NLmMvY2ccKCJz3C7Xt6pdtZTRYNxtKMDeq7g23Ad8mB5oF8pSzp	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	43	1064	154	6301	7436	jwUteP71C51TT6eh575HofYKDTnZPHRHEw5emtXAB8MqXXLxUk1	5681	8024	8024	1617383520000	orphaned
11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	11036	3NKRmJMn5HiMwqjbSc2LFRHiR5jh6SJt8oipjQjmeyYwkvSc64Ha	470	1063	154	6301	7439	jwk9TYyk5jxX91sRSMcR5LfigoEp841u9jcYgLq9QPokuwcBGog	5682	8025	8025	1617383700000	canonical
11042	3NLUqSFR9zPnwCMK6k7B97YgwMNynmBRUvGrhig8ksNQubDpebhQ	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	1656	1097	154	6301	7442	jwfYWWsKT8JtpGNTpcKqPMbwKPM959sfHTcxUEJ2jmdFzZbjRxm	5683	8026	8026	1617383880000	orphaned
14566	3NLBKka2kvwwfSpcH21wsBnw67kfm8CAmDSFQm9XjdJSPTqCcH1k	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	1651	1301	229	6301	10659	jxrq3BDyQ2q8wwC2CF1wxQRTBwu6UVM6qS5NXLEyjFVweziVQWo	7427	10517	10517	1617832260000	orphaned
15641	3NKqg99XcfG9Z8HDFv1eGdszU4ER1C5rgpq2R9n1wUQwiR6z8USy	15635	3NLZPBYnFiPXu1ESJDaMLnVTgqgebkP34AeYNd8rBPNnNoNjici4	1611	1095	251	6301	11662	jwBsNA1xZU9RmhL8sxtW7RjjpRE2uNrZimDYuLsj9SuKzUvwkS2	7959	11269	11269	1617967620000	canonical
11019	3NKWFB4pCuoCxmLAJcaqgFwKwtWvHnt8A8wXbNZJbAvKA4Pw7L7E	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1460	1324	154	6301	7420	jwafU31ERVKbxPTidAKoGcrzF5ftPWbew8EBPWjV6fQK4JnMSba	5673	8013	8013	1617381540000	orphaned
11024	3NLGD931e4aMGbXVpbYEBPvCujZFfuNxdb9a3iTWr6zN7SBtpVEH	11022	3NKxA9cs3DkthwFwEvZQnNw6jq9ysE45WvcXajZ2BdYFTg5eGY1a	1407	1395	154	6301	7425	jxpKMznMK68P3uF9Sj2svoNfkypuAEDvn9Q5YVXt4rJGhHqA8Ux	5675	8015	8015	1617381900000	orphaned
11027	3NLLAsbaWwmLFfW4etCizPkzYvQc5hr8k24xJBapwdcJXpNNZE4G	11025	3NLwLiU2XWTUPrJiHs1Wxi4t4nfT8MRjsntBvh9ghiepoGQrSGEv	1506	1247	154	6301	7428	jwGWASZK9rytiLHA2h2EkdkQqgabN4gzfbmSYpWTTA1dy4g3Z1d	5676	8019	8019	1617382620000	orphaned
11031	3NKDee3A5U1rKDXWPq6QEyNTKAzVHZUCi7cLQMU4GiXn5z8VrqjC	11030	3NLfEG95nnuFvffkQZpjcAg1gLQJEiUpuhuEeeZKPhAcPF5rMkgg	1513	1013	154	6301	7432	jxdWscjbpbbRSMJuxptfSkznvjMNhyKi9md9QJ1KbQhJ22tdehz	5679	8022	8022	1617383160000	canonical
11036	3NKRmJMn5HiMwqjbSc2LFRHiR5jh6SJt8oipjQjmeyYwkvSc64Ha	11032	3NLUPrfJFD5ZWNbRgR8d3q6UM8gbM46aqf8TSfRpzibpfJr7Pzy4	1397	838	154	6301	7437	jwzgF58Kwg2KbSi8HACdidHJF4MwX3JfhKasqUj3rxpHv4VuoXZ	5681	8024	8024	1617383520000	canonical
11038	3NKKkW4p1y3AzhKMYtDWxDMCA1hvXAKcdJJQeDPmMWXMJVCwJo3d	11036	3NKRmJMn5HiMwqjbSc2LFRHiR5jh6SJt8oipjQjmeyYwkvSc64Ha	1406	1393	154	6301	7438	jy2rCY8Dr5iS1GR8x7fWdgoYzictVP8caxjvfjBb368NoSK89LH	5682	8025	8025	1617383700000	orphaned
11040	3NKzUQ2uxT9422BbgdaGUxaqjjJJ381eXz3ji2gc2NEiENUstPh5	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	596	1306	154	6301	7440	jxKaqGpAnwgvkv6Y2PTkVU73WbovrdP87xbEfW1hBW77iTGidg9	5683	8026	8026	1617383880000	orphaned
11045	3NKQqKaZWAAZzg2hJEH1nYNCBxmvcFawwekmocWqanM4sF7BxCPm	11039	3NKti3bkTtdQrvPeaA3BUWrfcxudCuxrWJR69mJ8uxfJUGPEfdEb	238	238	154	6301	7444	jwjuNYXMNXCxM3idRqMUZB7aAEcykhTVQ3awY4nhHmAXGQNqSoQ	5683	8026	8026	1617383880000	orphaned
11048	3NLEWKLXo8fCtYRfaSMAm2wxWexaU1hqWfwMamBu1WS525Vp1T9b	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1523	1321	154	6301	7445	jxUG5Gwpx1sa1Qq1zqGrLTFjCaaW1uBRvbku7nvYi7LztbGxgmq	5684	8027	8027	1617384060000	canonical
11047	3NKMvKoNX5riHdUbKGGZ5QdWz6yZS8GgG6dRCNMHq7qEYivt68UX	11044	3NLnmAKbhx23mEy5XyzdL9BFzPhEPZTzL6yuS92zBF3aPKPeHHXQ	1523	1321	154	6301	7445	jwDN2c6T2MWh8WwAedcDH2Tu458o16Ft69oYyHhPewCR5i3TwgG	5684	8027	8027	1617384060000	orphaned
11050	3NLNEzcUtwQRohK3mRHPfhn2Pwrd5MM4GSMxTnvTVPd6Y4GqB2Ym	11048	3NLEWKLXo8fCtYRfaSMAm2wxWexaU1hqWfwMamBu1WS525Vp1T9b	1451	1292	154	6301	7446	jwSQjMdutmEeyCY5ehM15ncFSoCBymtgSx58Fxs9CExkUYTvFLL	5685	8028	8028	1617384242911	orphaned
11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	11049	3NK46zkysbj7DiuQ3kh9RZffX9e96EiTA9ezfNirFUNoMu3MT9db	1509	1074	154	6301	7448	jxmxiSNJ9Eb926A5dT7WLNUXHqbTzuYsLre9xeJfFwD8Sbh7mZ1	5686	8030	8030	1617384600000	canonical
11054	3NLq3iPzZX925cA4zsAvHQR792tGPJeSQEuTU8cwErqVkSMd7dDp	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	1407	1395	155	6301	7450	jxwma8ByUChiKo8dFekPh83coQjBGeSpvyLDjrmgdKNzD157kjU	5687	8032	8032	1617384960000	orphaned
11058	3NLtBS9CnMvMnLvje8piLBiXRbAc6zoUr2RLAv9sE9H6Dv8jKtPq	11053	3NLaCPrfCiTDk9SsLhY3iact9qwpz8QMmkouW7ez1DpJtpULjYUZ	1673	1122	155	6301	7453	jwj8YzXqt1CsZj21WYBARAdagHd3s8in4DGhBEQrJPE4Ezx3ppS	5688	8033	8033	1617385140000	canonical
11059	3NKj497A4vMCrwqCHostCF5ymv5xMUw72u8c8iBwfTVWcH2jQkvD	11058	3NLtBS9CnMvMnLvje8piLBiXRbAc6zoUr2RLAv9sE9H6Dv8jKtPq	1455	1332	155	6301	7454	jwRvZiQHnhpBJDxKvkTj735X8YozBB5fWS9vabGNxxxG9jkxE2d	5689	8034	8034	1617385320000	canonical
11060	3NL4uyo18hYhrpKgeWYg9RxkCLoRh3QJrGazTH3mgijJsQNVQWNk	11059	3NKj497A4vMCrwqCHostCF5ymv5xMUw72u8c8iBwfTVWcH2jQkvD	1647	1176	155	6301	7455	jwK6xuu8TH5J7q1Zux6zegPbT3CKVZhabR2dXynT3TrWU5y9Fpq	5690	8037	8037	1617385860000	orphaned
11063	3NKfTgeALecF3ZGHwXjbk3nDGxnzagzibTBkYxd7eiPD1zaZ1XES	11061	3NLXRaQonqf8JmMekWyFANSKSfSyHuEbRNFUYyQaEmpUYm9eS1UH	1407	1395	155	6301	7458	jxodHzEm5vFG178ofQ2ZwZEhY8uB3xP68B22pPmjyW5aJD1eMba	5691	8039	8039	1617386220000	orphaned
11066	3NKXaYSjyYCda2nNbsAfWfBujNRahbQo5Vwuy1ScyxAc1rvXvtQe	11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	1602	1243	155	6301	7461	jwY5kaEVkPxe1nPghshSCw4YHZc59RPpo1NehqfC14B4e4UGLPn	5693	8041	8041	1617386580000	canonical
11068	3NKtmZk7nd2X4hBA2uQhsTucdVekAcVWHBMZzP4fA6RbXvKJuRaq	11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	1675	1342	155	6301	7463	jwTXAUT7dmtTJWdnKzU6CuHafrBfV3yxbN6DZ7VotFwvQoSDpzQ	5693	8041	8041	1617386580000	orphaned
11071	3NLoGh8p9AmwycVMxX71uCCwfT7g9RsJZq4WH8PVEeRSr9eYHmGy	11069	3NLqo1Nqsdm9buxNyBau4wE2ssN6CxSQG67wte2NRgJMweoeMwXe	1407	1395	155	6301	7466	jx7R76rt3EXyWrdXtt92Jx4p5EE1dJyZHagHus1rgRE4kuCpDvs	5695	8043	8043	1617386940000	orphaned
11073	3NL4gfjgyjP3zYaoq6TLcDkeajaaWqqR5gY1mEdVyBMnWxcMPP3L	11072	3NL9g5C2XfeqAzxyBzZ8nsdP8HtAG5EYtRHmtWLTtuu1EkNqCokR	152	1204	155	6301	7468	jwaHsJjtBxLUhR8KnB6mKoeAbHji7fZPpSHPmWwmkToqHnK4Bvp	5697	8045	8045	1617387301774	canonical
11075	3NKrxCiih6iYg15mYNG9fWUV465HHCjSAqQbHXWbDBahxatCsksH	11073	3NL4gfjgyjP3zYaoq6TLcDkeajaaWqqR5gY1mEdVyBMnWxcMPP3L	1406	1393	155	6301	7470	jxMmQz3dA3LrL2rxuhoU3UwyZdvrzBERjmxWwbSQbKih1UYEhmQ	5698	8046	8046	1617387480000	orphaned
11080	3NLYFGhpLp6jfdXK2xkMHXhDQucBeJLAx7YgGLkcLs8R4Pd18RrG	11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	1407	1395	155	6301	7475	jwNsMrxxzUFrabxkCtGHs4Q6kJ7y48xPGmBhmjnjkHx2vrpZ83a	5700	8048	8048	1617387840000	orphaned
11082	3NL3pgfzJWGD81SA64SJe86cmAYXv3zXrE3pb8w8SKis3Uo9CvfR	11079	3NLERQFPWrdFoYFY7NwfHrB25Zft6iiqoYjWGwt9pcjZy2oG8u16	1553	776	155	6301	7477	jwcN8JHaUdRJGQFJzDfrVN8uc5syWxxHHxQFuZniRwmntso5JV3	5701	8049	8049	1617388020000	canonical
11084	3NK4mY8zyCWFGAkRSq1QxPGEyNgzXYCHzMQ9DKZzbo3TBoWqP56J	11082	3NL3pgfzJWGD81SA64SJe86cmAYXv3zXrE3pb8w8SKis3Uo9CvfR	1631	794	155	6301	7479	jxV8q4Nt4sZyGrHkZLGmFBxQP7LJbaJ32GRkwGWNnrYySddMJcC	5702	8050	8050	1617388200000	canonical
11087	3NLRxcAdfCSGZjFyjhjuTwbCGxjNRvNM3bme8HMBtTeosoCYrbmg	11085	3NKHUcaf3ZYRR2FnqPmWUUCond4h9rgVDN4UHji68gDfnkkNYRw1	1403	824	155	6301	7482	jwjUz9A6asXTT4oZANq6pNisVevjg7AtcCm5KoqPpPUSjGDmoVy	5704	8053	8053	1617388740000	canonical
11095	3NKCmg8pxAFn69E27D4pTbwvGD2d7bgWUg2SAfMiLiysRJgGnuo5	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1403	824	155	6301	7490	jwkU2xvUnSZmkjpE2CJXAfZjuEsQ3awC5BtCgiRqgo62b6aRjYi	5709	8058	8058	1617389640000	orphaned
11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	11093	3NLNKaXNzu2sLYPVTs4abiqGEBzwcfxMNAawYeeTzuoYuGtwXZQm	1467	1376	155	6301	7493	jxt4BJ7UhqYuAScasGiJyGjwJLc6scJbXDtEt7hpp5K5nh9VZUi	5710	8059	8059	1617389822511	canonical
14589	3NKYr8cQzFphtjBWffLD5atJK8Q32nowd8tQNj6CQzKE4ZSoeHP1	14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	1642	1367	229	6301	10682	jxnio9rrhBUaD8TRULBpncJZivgZdGWKvMxHDBzdvh6BhdcMosW	7439	10532	10532	1617834960000	orphaned
11074	3NKoSPu9Dqi2scRekdLA5WxHW2zMNsdjRhCQ8r4YSs1FGpCPDQb2	10964	3NKkYqUnCGtsqeRdpTvv6UWQBqA233xMyEC8BigD7NUzJ4HS8kH3	152	1204	153	6301	7469	jwNAsC4w9pXEyPNj1RDsa1iSKUZPVo2XZC4vgCrdDmRehT1AxQq	5651	8045	8045	1617387300000	orphaned
11061	3NLXRaQonqf8JmMekWyFANSKSfSyHuEbRNFUYyQaEmpUYm9eS1UH	11059	3NKj497A4vMCrwqCHostCF5ymv5xMUw72u8c8iBwfTVWcH2jQkvD	1402	906	155	6301	7456	jwVcVmtFoEHPudozSvFveo9FemJTb67MSNNvYKZ5bcxBgNzF9gH	5690	8037	8037	1617385860000	canonical
11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	11062	3NLtdEwr2m5MpofLcFnuaLZYMgE2iJu9tDQq7HR41EnpTbXcJmWU	1589	1286	155	6301	7460	jwtvSEK3fVuVCxQ5VVQRyvn1Fm8Nx3N9VMe83EBCHfPBPmoxdTN	5692	8040	8040	1617386400000	canonical
11125	3NLJF5aSJy7LC8fmCaqdC58uykQjDgmsCxbZQtnTZ2zUDk7RWDV3	11064	3NLEEuAVGZifHW41AA1bFkd7GUHLtSZBsk8MZnXYYmtfpApUYk9H	55	178	155	6301	7518	jxMSSD8voUEvYtzcZrVC8y5eMEAbC4aCizgU4KkAtzD4ESEMmDb	5693	8073	8073	1617392340000	orphaned
11069	3NLqo1Nqsdm9buxNyBau4wE2ssN6CxSQG67wte2NRgJMweoeMwXe	11066	3NKXaYSjyYCda2nNbsAfWfBujNRahbQo5Vwuy1ScyxAc1rvXvtQe	1553	776	155	6301	7464	jy29hEnzxVXujQGkM2M7gqsULTWZEpVxBsBxVXefexBMsNeR9SQ	5694	8042	8042	1617386760000	canonical
11070	3NKbA6byVfQCsNNn2ifHznRomJGQ2g68K3Wm5ntyLgaMhG9XAqap	11069	3NLqo1Nqsdm9buxNyBau4wE2ssN6CxSQG67wte2NRgJMweoeMwXe	633	1138	155	6301	7465	jwvYASY2q46riVaQxq8GYLRetPFi3D9JQobMFveA5GKApq8ZKZx	5695	8043	8043	1617386940000	canonical
11072	3NL9g5C2XfeqAzxyBzZ8nsdP8HtAG5EYtRHmtWLTtuu1EkNqCokR	11070	3NKbA6byVfQCsNNn2ifHznRomJGQ2g68K3Wm5ntyLgaMhG9XAqap	1647	1176	155	6301	7467	jy1SJ4AVxCzEUicCzkVQsjb36qGhNiFseJc9EjqfWcSYU86TxNC	5696	8044	8044	1617387120000	canonical
11100	3NLA226SwG599W9MGP41K2bKhat2Eo14tEN3pDyguYQTvUnnnr53	11072	3NL9g5C2XfeqAzxyBzZ8nsdP8HtAG5EYtRHmtWLTtuu1EkNqCokR	1657	978	155	6301	7494	jxiajczHrdgGCKdHLtf4ZHKNRRbzWktNhUkH5qPprqiUbXBqMB5	5697	8061	8061	1617390180000	orphaned
11077	3NKfoz1djyCLJXDVC6ShnsBVTBurSUak6u4ZEsFMjHL7niAADHRF	11076	3NK46JCUtj3aubrJ9GhkavrKFRz5yxttfRjDdVsBeDr9v7EpvjP6	1455	1332	155	6301	7472	jxFnj7GTRhf5uVQ3fuwATD9JGyD5JTNq1JmibbzK1q2HcmJH345	5699	8047	8047	1617387660000	orphaned
11079	3NLERQFPWrdFoYFY7NwfHrB25Zft6iiqoYjWGwt9pcjZy2oG8u16	11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	1403	824	155	6301	7474	jx3QrxM6nd1Rj4fg7jsS3kFL1TwxhMYGe3SqaRcaUGZDrTGYyzA	5700	8048	8048	1617387840000	canonical
11081	3NLcjBA88hLC8BRTwVZ1eecDEPypwS69t9NfZwmCiFgK68TcMiMC	11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	1631	794	155	6301	7476	jx7SGvbjxBk6KoC8RVD6ENnjkWjpNBnifYmfQfCzwyssQqSGqYh	5700	8048	8048	1617387845003	orphaned
11083	3NK8skEQWEQfntRoiGMaXcHNigSe2oyAydA3v5XAqoT3rHUdP59s	11082	3NL3pgfzJWGD81SA64SJe86cmAYXv3zXrE3pb8w8SKis3Uo9CvfR	1599	1161	155	6301	7478	jxDAgfPh1zU45sd7eb8T1ma5GmQJSPsbM9Ed5LRP8XToCRiP2Xf	5702	8050	8050	1617388200000	orphaned
11086	3NKAA15Seyi5fD9NCh3AjU2xiJtQNs1cWXJ59PGmgjaWV3nVM2oV	11084	3NK4mY8zyCWFGAkRSq1QxPGEyNgzXYCHzMQ9DKZzbo3TBoWqP56J	311	1061	155	6301	7481	jxhHmtPEA9W5q2oJPVJ4stgq7ADXBy7PAHWmKnP2tvW1ocbFQrX	5703	8051	8051	1617388380000	orphaned
11088	3NKa9QS48ZWo4MFSbUSaBi836xH4rrqUuQtSkQA5EYCaVgU3vqSL	11087	3NLRxcAdfCSGZjFyjhjuTwbCGxjNRvNM3bme8HMBtTeosoCYrbmg	1536	1313	155	6301	7483	jw9CoSv5eMqeLDQ45kgr8pt6cgxnVGV2xqBuijrTAXzVh9Aua8R	5705	8054	8054	1617388920000	canonical
11089	3NKM53M4HkQaCpQVNGqmBtsWLgxvkT5pyAxQ26WXqGx1PqcNY3Ma	11088	3NKa9QS48ZWo4MFSbUSaBi836xH4rrqUuQtSkQA5EYCaVgU3vqSL	1451	1292	155	6301	7484	jwCtmzFSR1EHuNt8oGTJcgezQmVqZVCVg7kXAb65wbKLrm6oUUD	5706	8055	8055	1617389100000	canonical
11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	11090	3NKLtGKT6pCyjPNJwcH2QsFkfeJY8tEhTtDkGz1BHW1arbsJQFXJ	1406	1393	155	6301	7486	jx6f7EXk9YjLhNxwYYoCiLFg8TqncGxZub8T4vpkPrveEJzzEVz	5708	8057	8057	1617389460000	canonical
11092	3NLWGYwscRDutkSScCY9sCHMAb2F76aPa9xjennM2jEJAw9HvKJJ	11090	3NKLtGKT6pCyjPNJwcH2QsFkfeJY8tEhTtDkGz1BHW1arbsJQFXJ	1637	816	155	6301	7487	jwpXUUvpyK4w6BnTca9s1YMtRXJQkCqCyxRSVKAtjijVr34WvWt	5708	8057	8057	1617389460000	orphaned
11093	3NLNKaXNzu2sLYPVTs4abiqGEBzwcfxMNAawYeeTzuoYuGtwXZQm	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1622	1356	155	6301	7488	jwa4Ug6L57GjsmTo6sdTLMtyo4YSbUjayBc1VitN8CGuZqirQBi	5709	8058	8058	1617389640000	canonical
11097	3NKF4doKa3PvVRSuJ37hTXPqt4crPhHxi6sQckCEz4w9VXTsgD45	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1650	1009	155	6301	7492	jxSck2Pf8MWbYUAqJKH4EfhFVFLTdcUKiyve2X7Qw9FGWNVGd2c	5709	8058	8058	1617389640000	orphaned
11103	3NK4URCqeAnJzEnNU2sLt3rgPpxRdFbhsZZKPiNVkmkBbeJA4Du3	11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	1631	793	155	6301	7497	jxoooGxRpvCQxxRozFTFQUsLKroUpRGoeDnwGmLDVg9vk9HhMuK	5711	8061	8061	1617390180000	orphaned
11110	3NLS5hKunveKEZbgBBW8pckj4jyfbLAvYhBkdB6TVX31UPR9XRWc	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1405	851	155	6301	7504	jxNQiib3qi6woSzAWXV3n2tmz7yNkCLiWDobGTer7caJhT8MmKE	5713	8064	8064	1617390720000	orphaned
11111	3NLeiGvNtAdweBVHEwQsfJm2S6SMb3jf8w2r4Fa4Xb6v2NHR7ov6	11107	3NLxVFrX9jr5m4iSz81BWrYvgGZ3i3w4Kp3AuZW8szQQbL4ZZn1X	1588	1392	156	6301	7505	jwVp8HCUX8D9gqetMPEZTNSjyjyeNaH52oKPRTzqVV9mpAcdDqW	5714	8066	8066	1617391080000	orphaned
11114	3NLaEkheMkpEH43SJ5U96fDKCkb7XRF6N6eXLDCpw8RUto4bxr4H	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	1553	775	156	6301	7508	jwf6vSjETXswEkyL22fHBtNQJpmfNafgWyrhxtK6zc3ceZ9qFRi	5715	8068	8068	1617391440000	orphaned
11118	3NKas8tB1kVaqpTLYtwDC7dtdScL6isbcYXXSFyZs1g5EbXwAH1u	11113	3NKHYS6bWkDMRCtEfyt43pASqqXbWCbkeu5xRUGbDmnHGxhJJRBQ	1599	1161	156	6301	7511	jwaYv3RafVB2erAsTWGhViJwrFk238qyykkUVyLW6og5xpCwRcT	5716	8070	8070	1617391800000	orphaned
11123	3NKhC2hjAMeEKta2c51gyodPJnSHYgdg6pdeojR1HBdaj6jRSDG4	11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	1522	1076	156	6301	7516	jwJuTKJrS8Ngc9xSsZyzJdcc41sT9Z6Vh5EDoTdTa38sG42xErc	5718	8072	8072	1617392160000	canonical
11128	3NL5AAbGaUErRVJ8QazQgXnhhySZXgHwoaK2kR6qLumQ4fNobiwN	11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	1419	813	156	6301	7521	jxCGFGU4Wm72k9z6meA6THKJbRKakyqqqYS8pMxwRocnTqRJ6kx	5720	8074	8074	1617392520000	orphaned
11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	11130	3NKQtazttHL1R3JKewjs65cTH4ZBY767soB9W11kdxYqMyAdLyHa	1594	1326	156	6301	7525	jwty7yXsWxMDtfBnLrx1nCFmZ89mzNA9seZGaxAxc3jRz8hKgw1	5722	8077	8077	1617393060000	canonical
11137	3NLJLpTbY3E1fAAfFA9KfPLTYH6XLriUZhoUzDGCBfM1X7Pim2Hk	11134	3NKWuEjiuWeJ3GkuLMz32nAy7Rb8ZJeuAWYUzVaCng259YMc1B8P	1406	1393	156	6301	7528	jwjoup1ZiuhVKEFKr9HD6KTY5LipWpxYBGVxNvCJsVYmNTyEagN	5724	8081	8081	1617393780000	orphaned
11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	11138	3NLRUs4wh4A5AFeVDpC1XGtTv2jHvzWEHKfsL5LdND6Bwrmm7CUe	1407	1395	156	6301	7530	jxDX8ciGHsvstbFAeDSWhcirLU2TuPfp8YFGecXJEZX792Wd5km	5725	8082	8082	1617393960000	canonical
14615	3NKuSB2p9FmSeK73A4X9674shmUk6T1UeYqgz4RCR7N5vHGgXDp6	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	1651	1055	230	6301	10706	jwEyUFS1qe4ZxNJPmWY9TujwyTdNHHpWT6PkJjd3ejuhEKWeczR	7450	10546	10546	1617837480000	orphaned
11160	3NLZ5qbVG3pT2xDtSXWrvkxnySrZxNTUFGgre3F4rULoVGDyE1LV	10777	3NKpf6ZHztpGVStMSGkCNtKYZojyzzUpYpmopq4NbUFkYkkMQgyf	1403	782	149	6301	7551	jwncntuMjrAZi2S1MAdzrW5bxQXfq4ysCH9fiXsLGMUjiLg73uv	5564	8096	8096	1617396546545	orphaned
11062	3NLtdEwr2m5MpofLcFnuaLZYMgE2iJu9tDQq7HR41EnpTbXcJmWU	11061	3NLXRaQonqf8JmMekWyFANSKSfSyHuEbRNFUYyQaEmpUYm9eS1UH	1406	1393	155	6301	7457	jx2gZe3pnULyoL6rBaqr5g96hQBYL6uYFzQ3NBSYhSM8ew3tKGh	5691	8039	8039	1617386220000	canonical
11064	3NLEEuAVGZifHW41AA1bFkd7GUHLtSZBsk8MZnXYYmtfpApUYk9H	11062	3NLtdEwr2m5MpofLcFnuaLZYMgE2iJu9tDQq7HR41EnpTbXcJmWU	1444	1381	155	6301	7459	jx2WMk3GnB9y37aFepb6eU7mUaADsnMQtrDZhTEcBEwUqa8Dmfx	5692	8040	8040	1617386400000	orphaned
11067	3NK4oJ5APFfC2Jsm9amffF5PgusPrbhJt2CpMuckDQuDBGs5jT3V	11065	3NLFXyt8LAXNZmkpeyr31rPBGvnVLSEJRBBdyKWqrpKStoeh3Eq5	1609	967	155	6301	7462	jxnQU9SbyPgmf9gWkD9yuq2tyP6JqdcLfkDiQC72pioWiQDewjy	5693	8041	8041	1617386580000	orphaned
11078	3NLH1p2Apg2sf2hFkupdupYXkwJ1KJEBPREBbRbFpsAavrrAXtkW	11076	3NK46JCUtj3aubrJ9GhkavrKFRz5yxttfRjDdVsBeDr9v7EpvjP6	1553	776	155	6301	7473	jx9cCqhE622tDbiEQEyV5yWURYZmkFGxW1NGB5YKrEXxMzALBKe	5699	8047	8047	1617387660000	canonical
11085	3NKHUcaf3ZYRR2FnqPmWUUCond4h9rgVDN4UHji68gDfnkkNYRw1	11084	3NK4mY8zyCWFGAkRSq1QxPGEyNgzXYCHzMQ9DKZzbo3TBoWqP56J	1406	1393	155	6301	7480	jxr9ad5SUsyQdFD9yqnajoJ1PtBw3kiRYDpY7DVqGYex6ACKoaK	5703	8051	8051	1617388380000	canonical
11090	3NKLtGKT6pCyjPNJwcH2QsFkfeJY8tEhTtDkGz1BHW1arbsJQFXJ	11089	3NKM53M4HkQaCpQVNGqmBtsWLgxvkT5pyAxQ26WXqGx1PqcNY3Ma	1553	776	155	6301	7485	jwqReiydt8uG1jU9k9VV3YXgbtxwr4Q2h5PzqQhdesiCGim9E7X	5707	8056	8056	1617389280000	canonical
11094	3NLmwJxmAmouzn5Y5w3Jt7CSZbn5noQF7CJHn63FdRv5hAdKSvmU	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1642	1121	155	6301	7489	jxDpcWkAbRgWPa3gVyNBvqUrP9DvwxYY6eTbxd3hHGWWYotUg8A	5709	8058	8058	1617389640000	orphaned
11098	3NLaPHqAVamRsXQ58svkJH2oyUDcaZkzLziFeHkPCh7bEBSpG8dy	11093	3NLNKaXNzu2sLYPVTs4abiqGEBzwcfxMNAawYeeTzuoYuGtwXZQm	1467	1376	155	6301	7493	jxt4BJ7UhqYuAScasGiJyGjwJLc6scJbXDtEt7hpp5K5nh9VZUi	5710	8059	8059	1617389820000	orphaned
11101	3NKuVLKETFLnShNmmCPk5PwY7wCkHJKSN8LLCupTKwFdkhNT9sDe	11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	1602	1123	155	6301	7495	jwdq7yJYEciL33PknJCbSC2ABmTAtJGiziQTXRwBUBQVeQtpDFF	5711	8061	8061	1617390180000	canonical
11102	3NLgPeGVYX2kYAtWH8z3F4PisvVuYdynBrh6Qm1NectYUj2bvG6B	11099	3NLhWP27Ra4VtR3dKLBvzk6LH8hcH5hEEctssFfjneCsGCRSTU8F	1657	978	155	6301	7496	jxKNg8YrQ4Xy1wz9UFRd22Vpd28oiAt2cbPStSkA5a371pAtriQ	5711	8061	8061	1617390180000	orphaned
11105	3NLJMPn7AorxGnif6eXZrM7xnbFLiVLGJmZwNWRZWz9di8UXf8tW	11101	3NKuVLKETFLnShNmmCPk5PwY7wCkHJKSN8LLCupTKwFdkhNT9sDe	1460	1078	155	6301	7499	jwu88GbZEXU2BEaySqGChWxnNsjcTfGqqtBnnZ5sEFL3Ptb4EEt	5712	8063	8063	1617390540000	orphaned
11107	3NLxVFrX9jr5m4iSz81BWrYvgGZ3i3w4Kp3AuZW8szQQbL4ZZn1X	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1578	1296	155	6301	7501	jx91ycdt8T5cCfD79XY8Hpn5xGc4GibkuYZzzrBwfLmT1KN5bGm	5713	8064	8064	1617390720000	canonical
11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	11107	3NLxVFrX9jr5m4iSz81BWrYvgGZ3i3w4Kp3AuZW8szQQbL4ZZn1X	1529	1190	156	6301	7506	jwAtFGRS93ckA7MGywYqWw1mL4PY79ZcSFcJh5XAXbGBk9Zf5Lz	5714	8066	8066	1617391080000	canonical
11115	3NK3hsWg9g37aBpCMYFq5U5JTVb1Ypg2BZDbNvsQyHRCuhruHrA2	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	563	1359	156	6301	7509	jxvHaSA8K264BBftHEcQdT1TvnmYDTjwXeDnzpqR76dnsS2ULU7	5715	8068	8068	1617391444490	orphaned
11121	3NKMdBGy5QdGxESCkknLg8xNBVcMeU8xE4hyQbojRPNzXzEVSm69	11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	1474	1329	156	6301	7514	jxUutsz1t6FvS1BQTRuYZtpwcvrGZMz6BhU5nA1DDjJas5sq9kA	5718	8072	8072	1617392160000	orphaned
11130	3NKQtazttHL1R3JKewjs65cTH4ZBY767soB9W11kdxYqMyAdLyHa	11126	3NKbAKrwV3dN1gt98gEypHwSGYsgnReYgZ9zpsLvsZu7ksAik975	1637	816	156	6301	7523	jxmGURajW8E8nFhKWebCMDb6gznxbjLTDRriG7iqkC2WL5TAigc	5721	8076	8076	1617392880000	canonical
11135	3NKF4vcQXbJoU6BN1rmfcso96dpfzp6kfjV8Up9Cz2id2C5WHxLp	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1523	1075	156	6301	7526	jwFgycpxc11vu34CvxbwN1dw1w3JiHHDM564yFzQf15AVs2hLi8	5723	8078	8078	1617393240000	orphaned
11138	3NLRUs4wh4A5AFeVDpC1XGtTv2jHvzWEHKfsL5LdND6Bwrmm7CUe	11134	3NKWuEjiuWeJ3GkuLMz32nAy7Rb8ZJeuAWYUzVaCng259YMc1B8P	1426	1364	156	6301	7529	jwfxkHtSNtqzrURTor9pFWY63PjytkoA2Sk11ToWqV63b4zg4p5	5724	8081	8081	1617393780000	canonical
11140	3NKaq1TPbyFCvqb51nV57aAEWnxBUbo9fXC7RHBrAgn7VpEsebaK	11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	1490	1028	156	6301	7531	jwkwWGQUcyrtm7YGf5PEhdVieQrRJR1WU8RbfAsbZTqtjtCWvAy	5726	8083	8083	1617394140000	orphaned
11149	3NLkfSj4EG4EXwNLLJnmR6bvcwLNEcFpZjbfZAjCKQVcyzKNUFLA	11145	3NKuLbE2oKxRZrtDrvrwuJNJsNCwumXABBDE1RgARy4SDT36hfDJ	1596	1363	156	6301	7540	jx911accoh5o9LQhtiydh73PCpvdx7qZP1HivCCqs4LDzgP41gS	5729	8088	8088	1617395040000	canonical
11152	3NKw6aSEk7WdfXjKEAPfEoAnFDSB6NgcCxYgPJKMbo5GQB4uGjc6	11151	3NLcD9RHURdtouSBAVQvJGTPbrKDiAm4tAYHQMiE5dz5tUXhxdTm	1458	1197	156	6301	7543	jwUCcgNd4MSvcauuZ2VZMWzjpkXykYfJdVVhRnrjUtuP6t3mntW	5732	8091	8091	1617395580000	canonical
11164	3NKLqAinwkJaViEtdRBhv8drvTUFui1dS9n19nJmTpZNF2tQ8Pn9	11163	3NKiZmGVKuQsqxd5JPBvX3wJa3yWkVj1xYCcuBZGde3FRbrnf1cm	1629	157	156	6301	7555	jwUQAPuqmTvSfcusQVLkG7Um6MwGAZKfvYQHm6nBFfxwuHFV8Z5	5738	8100	8100	1617397200000	canonical
11171	3NKXaaR2MAw2rMkWTGcuDaCeeawV4Byyq85J3KicBtisNL6H4qTS	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1451	1292	157	6301	7561	jwDhYddNVcV5pCsfYK6CGK3GXf4AVRiWx84K2jY4RbMHg5wtGJY	5741	8103	8103	1617397740000	orphaned
11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	1483	1030	157	6301	7569	jwuGN9DEw4kjxBZmPKvEMEKkHh8fabKWoVLXgM93Bgja1Pwuxpe	5743	8107	8107	1617398460000	canonical
11185	3NKnjrTgmf9MPTGLPqL3vCZqUHfHYiq6MKPPG2vaykzX9A5r92uA	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	1406	1393	157	6301	7573	jxWpSEAJH4Yt159Zhaf1vM5wfbY455vwJxNJWjiFPbpbHy2VbpS	5744	8108	8108	1617398640000	orphaned
11188	3NKcKfgaFNmmGkuQkfKk7uCQhKennnXWVrTLD7RvEJubfdmMYB8V	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	1534	1191	157	6301	7575	jwCMFzWjTaJE9SY2EgUWTofwh3a2avxvcXMZFkKnxa7eDeSS5oK	5744	8108	8108	1617398640000	orphaned
11190	3NLUVfTTToUqcAuCNGdZvn8c4y3tHvq4MrvoSonanKAe6SXzryBA	11187	3NL9jgtj1VasGMAYQLPViNgS8gAxnMsXmUGhsQE5Xbu29B2Ao1ct	1643	1053	157	6301	7577	jxpDvReyfEhoCvLb7i7TmmwTGyZdgpDvfxtWnQSuUCdDajXRcKe	5745	8110	8110	1617399000000	orphaned
11200	3NL4rq7nU7QBgNumxh3Nfj3mX14yyaU6L74vNkMurTNf5eG69vdF	11198	3NL57M35FHXm5pHgpH3fUerGMJerV4Uy1jDaeCzQHTjhSZwakUzD	1406	1393	157	6301	7587	jximURABzmJyU7rzieiUgkBTxHZht5kzqvhmTZcmDqwg2xx3tVM	5751	8117	8117	1617400260000	orphaned
14620	3NKbhC2mL6NWTQUdm4kGgYrSFe4KUD7MHk14zWeprVUzdN3TLvqg	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	576	1355	230	6301	10711	jwLBrAU1L91VZzZoZf2yjnEyaHEStYmyRK4C9zdYdjajJzLMoH5	7453	10551	10551	1617838380000	orphaned
11131	3NLRe47XQT48WF4bUH2JEwgNLoCDuwCR6NkKU2FBzc5xfAPSHU5M	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1590	1300	154	6301	7524	jxZBqvmz9rELx65FRFza5VEHmVntva9q2bjKTKRZBVJSMHaM5wM	5673	8076	8076	1617392880000	orphaned
11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	11101	3NKuVLKETFLnShNmmCPk5PwY7wCkHJKSN8LLCupTKwFdkhNT9sDe	1631	794	155	6301	7500	jxxAumrUUTWxFrKWcwwVzgpU4E1AHVUUxsmTewPpuQnFzPPKpSY	5712	8063	8063	1617390540000	canonical
11109	3NLdyaNUgUeSSkqLdBEAMFQZS1msH27wxwAYcBjd5nGg4ecqYEFL	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1549	1116	155	6301	7503	jwJjZFyYKSaUpenze8vUDGWKpKPtwA2LMTcJuQeT7zr6tsvCm2P	5713	8064	8064	1617390720000	orphaned
11113	3NKHYS6bWkDMRCtEfyt43pASqqXbWCbkeu5xRUGbDmnHGxhJJRBQ	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	1623	839	156	6301	7507	jx6m96QS73QwWz9Ppe4begtkuGFQQgThgQRB2eXW1RKE88JBYPx	5715	8068	8068	1617391440000	canonical
11116	3NLp7Cc45aEFnxan5MTCFcgT8KgboDE3SBiYYcvm7NhDFGj3QbFF	11112	3NK3kPXAeeYfJbCkFshoZn5SGbyrSqQQNVjQWwnQe3B51EV3zcJd	563	1359	156	6301	7509	jxvHaSA8K264BBftHEcQdT1TvnmYDTjwXeDnzpqR76dnsS2ULU7	5715	8068	8068	1617391440000	orphaned
11119	3NKZ2VSkNc8fo1gi8pCkff96Wdc5iM4WrX7HKNnnatLgKQFgBJs3	11113	3NKHYS6bWkDMRCtEfyt43pASqqXbWCbkeu5xRUGbDmnHGxhJJRBQ	42	1361	156	6301	7512	jxiTXyWcL8AHsLxNZEgxkLqAViCWRZXNhFbeWQKwprWa2yE2LRn	5716	8070	8070	1617391800000	canonical
11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	11119	3NKZ2VSkNc8fo1gi8pCkff96Wdc5iM4WrX7HKNnnatLgKQFgBJs3	1506	1127	156	6301	7513	jwLeDmk3bjLWHAf92KCFfXQjqVU3TeJhv3WwkYeewcmBRRuP8vq	5717	8071	8071	1617391980000	canonical
11122	3NLYNQN7Q382utWN5wdho5hvN7wYzfUAzT9aRvTsE2icotVkvkiN	11120	3NKVWzxBj9XwmLynTophjM8rrpnaH9PWhEtC8xSZLaGMm2CjWzUD	1407	1395	156	6301	7515	jxrbAjvGv85Xnq8mmGW12dSDAEK1SvTcMFzrW44EQaMMMYPwM3b	5718	8072	8072	1617392160000	orphaned
11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	11123	3NKhC2hjAMeEKta2c51gyodPJnSHYgdg6pdeojR1HBdaj6jRSDG4	1672	1159	156	6301	7517	jwdHboKRbCtQre8F5zp4nenvABZrxmA8T43UW5PoJdx1nhvZAxB	5719	8073	8073	1617392340000	canonical
11126	3NKbAKrwV3dN1gt98gEypHwSGYsgnReYgZ9zpsLvsZu7ksAik975	11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	1402	876	156	6301	7519	jxFNG4i2g3TtfFHpY9fbL99NjYjZcNC52NYLX9z9y54rqt4ABoy	5720	8074	8074	1617392520000	canonical
11127	3NLCeRY1KBazspGJJXPh4ZaCM35MK9oftAbc8RQTvUcS5T7hPGcA	11124	3NLYxuLi671kam3vMLfruCFyPqoj7Xiof6quYbYFV5Dxw87qqZSK	42	995	156	6301	7520	jwQYcALcLiWPYCaBBFY241C2VTLJb4dZogUzk1GJzZC1z3JagMb	5720	8074	8074	1617392520000	orphaned
11129	3NLjc7L1CW5XmBTrQFZRt2xHRAd3WxDPXJikSygDvs4DKSqBLDem	11126	3NKbAKrwV3dN1gt98gEypHwSGYsgnReYgZ9zpsLvsZu7ksAik975	311	1307	156	6301	7522	jx6ZbbEjNsbZgLSAyx95tNNuPhECsRQViFFjACpSCABseHVDHhx	5721	8076	8076	1617392880000	orphaned
11134	3NKWuEjiuWeJ3GkuLMz32nAy7Rb8ZJeuAWYUzVaCng259YMc1B8P	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1476	1371	156	6301	7527	jxPJS5TEC4boQkyfZvzZy6zpPF1az1E9mabRgzBo2RTcsWb27VF	5723	8078	8078	1617393240000	canonical
11144	3NLKQnbKoWPoSAypGLwT1RW7bpQg4DWeKGdP1MH8LY5SoTbh4zmY	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	1406	1393	156	6301	7535	jwUz5wyQ5WbMCyMg94tw3MpQkKvNBieortBzQ6FaQ4F9eEyHhsm	5728	8087	8087	1617394860000	orphaned
11148	3NKzH4eHLsyf5fW2b7adsdNB78jUUyzmLYVpktSaxjSRYpWdfVd2	11145	3NKuLbE2oKxRZrtDrvrwuJNJsNCwumXABBDE1RgARy4SDT36hfDJ	1407	1395	156	6301	7539	jxS7yLhNWu2zAtAV4Jrrw1boJ6p8xy8q3BTEwfxN5SierZdYt63	5729	8088	8088	1617395040000	orphaned
11153	3NKsZxWmMNgpR8c1iLCvhKewseVmLNtUrqKkF1rkL2aqCiUpcT8c	11152	3NKw6aSEk7WdfXjKEAPfEoAnFDSB6NgcCxYgPJKMbo5GQB4uGjc6	700	840	156	6301	7544	jx6DuKsePvRZakJhzr7WDBa5aLHGk7HmmruDi9DikeMFEh2pAUP	5733	8092	8092	1617395760000	canonical
11156	3NKeSp7sz4QtV6ENiHyn2iaQf5RhXDi8zkeBdUUkj1ym72QBGoeW	11155	3NLhmEpVBVWEmATPDhRwykTaM9Z2RfEHqEXijFs6VHadd46m4VTx	1483	894	156	6301	7547	jxBusdCQJEDVRkZ8wW13PL1Az2hyZLNgF9FJ38LCCz35Cq6zvYz	5735	8095	8095	1617396300000	canonical
11158	3NK6iA3wc5fU9pmLrDEUjrGHVCqkEGbHu6cwRb1dtvYK4KEQPzv3	11156	3NKeSp7sz4QtV6ENiHyn2iaQf5RhXDi8zkeBdUUkj1ym72QBGoeW	1402	852	156	6301	7549	jw8pktVvxkoH9T7qE2yVKaqMKgboARjs7UAM86V43AaDhbGNJq1	5736	8096	8096	1617396480000	canonical
11163	3NKiZmGVKuQsqxd5JPBvX3wJa3yWkVj1xYCcuBZGde3FRbrnf1cm	11158	3NK6iA3wc5fU9pmLrDEUjrGHVCqkEGbHu6cwRb1dtvYK4KEQPzv3	1455	1332	156	6301	7554	jwjKhJz6KNaCbLZHT227NZuJnodZfAXb9TimsRagSENqA1V7DGj	5737	8099	8099	1617397020000	canonical
11166	3NLogaYC93gszc366r8qi8u5UVuAASBpYGAUp7ksR2uuyEVzRgd8	11164	3NKLqAinwkJaViEtdRBhv8drvTUFui1dS9n19nJmTpZNF2tQ8Pn9	1611	975	156	6301	7557	jxHKNE4Z35kE6ZHrCau2XN6ThdDHcYoGcVzS11vQLoj3nz4Kqvu	5739	8101	8101	1617397385535	orphaned
11168	3NKMmGZiwBaP6R9L9tVKN17mytFGswEVdW9wFe34nAdjZvoZJJCD	11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	1406	1393	156	6301	7559	jxSvz3wcNCfQoZHA1MWhEoocdRJEJibq7WSgcASo9Po9hzezwzt	5740	8102	8102	1617397560000	orphaned
11176	3NLngUC1g2n8TazxJy8FdLfBebj13ZR3Jkm27f2jTENogsEUhan6	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1631	794	157	6301	7564	jxBCUR9i3pLrF3FaVL25gyRciSn98cefAJzbvpCaQvmE8imzqK2	5741	8103	8103	1617397740000	canonical
11170	3NLwDUf3pqZEtAafAvPNThwTBhn8VYMeF2CrMSwg4MUFmyVBho1F	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1451	1292	157	6301	7561	jwDhYddNVcV5pCsfYK6CGK3GXf4AVRiWx84K2jY4RbMHg5wtGJY	5741	8103	8103	1617397740000	orphaned
11183	3NLeQ1EfM1aUafcXdVqu86HHVoGwP2co87hAy38yTXHBrugYv8SV	11173	3NKuSX8Wto3CETLzHXat9fHFXWi81m3tMdRNVH5s5uUfBGqgpxRr	1560	1045	157	6301	7571	jx1sq8mGquambbJxxiYmeMDDEEvRrya1fDoisdK8JDmjRj3EWc2	5742	8107	8107	1617398460000	orphaned
11189	3NLC9SLw8zZRG616wMx32SNRtZEvcV1BnBqrJ4utgJUCZ5qxX9eb	11187	3NL9jgtj1VasGMAYQLPViNgS8gAxnMsXmUGhsQE5Xbu29B2Ao1ct	1547	1378	157	6301	7576	jwoShSa8kSumxsXXFmj9hcrFzakfAL73TcFoLZoJMMT3Mn41hPb	5745	8110	8110	1617399000000	canonical
11192	3NL2EMbXZKGQL2dWydU7pUwZUju8CGEGTzbuA8MDqwscJhj6ExTn	11189	3NLC9SLw8zZRG616wMx32SNRtZEvcV1BnBqrJ4utgJUCZ5qxX9eb	1405	855	157	6301	7579	jxKLyt85pkw5rvBkLHTZiQ4YiCgxh7kDuW5LVSCdQs7HUgJXkJ7	5746	8111	8111	1617399180000	orphaned
11194	3NLtmrfLHenfPAJn4uLCtsLibNRznGgmnvAVeCXB8jRsPVgFm134	11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	1527	1047	157	6301	7581	jwzWVu11aLZYZHoACaAhTDpbzhNe7ifhUcXHsZ3nH6Q6axiNiLH	5747	8112	8112	1617399360000	orphaned
11196	3NKAMSNhrVStp6PW5CXed8nKxiUihV1Fkn4RRYMk2bjHHHrnheKe	11193	3NKAg6CBuGTEuH45GXdLHUyceXQJMparXzryUGFsrH7jAixaiyXM	1402	808	157	6301	7583	jwgBvJg4ULFz4Mu3HFF4sTC3hUGM79LTdqWSXcWJGRC7AE6aFp6	5748	8113	8113	1617399540000	canonical
11199	3NLojmLKFCH9ZxTSHhfCEwm1wsa41gAPrNFqSx8JmacLQ6PaZSnk	11198	3NL57M35FHXm5pHgpH3fUerGMJerV4Uy1jDaeCzQHTjhSZwakUzD	1403	824	157	6301	7586	jxZgi79YQ5wBZHdUm9nfhDeYNLMkWVKWGxeipSiXW9BEjFxpGf6	5751	8117	8117	1617400260000	canonical
14622	3NLsHuKRhwcctaYotngQtxq4Mxx7AS5qGcGDvaMcCmRaAwvMsoiX	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	1581	778	230	6301	10713	jwZfRfco18qJ7su41v5u5gEsLNiHYf7JZFNsBWqQJVfdLS2yUyy	7453	10551	10551	1617838380000	orphaned
15667	3NLsbgbE5unwi8FKJMcXeDzZ4r9TzbbRgMeFDNwdf2vpUTVBqHe9	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	1675	976	252	6301	11687	jwHq8HGuBX9EonV2XsZT279kyNsLs72opGhcexXKXP4g9NADirh	7975	11290	11290	1617971400000	orphaned
11161	3NLcEcTFc4hxyZ8cyY2pFnPX6qTcbJi9jBovg8wSLQNKRKZgQPYZ	10804	3NKnm4s1jtWf3PvM6MyZigR3b56529cckuEajHhecpBEYxgmePUR	1403	782	150	6301	7552	jxmeYMGmxnPZQpCBbBDzmgNM5TwnuVSTSjrzPHEdmfC5aCJ2rxy	5577	8096	8096	1617396580053	orphaned
11162	3NLrt31omU2ra5y656HEPsy8YSf33CKEqNVt9UHRro6eQsKaa4WD	10829	3NLWtv7p6JYPtsEWknqEMkoDPjDK4x1jYGxvPtPVNk8cHSkyA9z6	1403	782	150	6301	7553	jwzj6kwNsUPykbYXLipcnsV25bzNsK8Cmxzbhb9i5JK5JU3ekQt	5589	8096	8096	1617396613207	orphaned
11177	3NLqiUa3givU1mZ4i43oiYydwPaphGXqw98G7LMLoTfhrHEmYpGi	10891	3NL9f33xnSPjXW2JnpJxLEjNXjBz9JYsN3XU7nfJAUGQD5wPY1fR	1516	1294	152	6301	7565	jx9iiPgRULiLgbck8oGRtKie26xezzsEfVhA6zLveN6xYj2inRM	5617	8104	8104	1617397920000	orphaned
11133	3NLuvVXZSMDFcZZDkVF8pPxYnVMyTGSWLGNmxoRNhngnhTtpphTK	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1523	1075	156	6301	7526	jxJZuepP2qXcUEqeoQhVJj4MUeqjxnm7VGsfJ3DHEeRkjKi2Jvh	5723	8078	8078	1617393240000	orphaned
11141	3NK6qg3yTQHCGDZBqnauy7v9BxYL9nhchEVbiRuTfCrwXGka2gEd	11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	1623	839	156	6301	7532	jx3bqHgpSHf7vU7mwfktJ8tmgYjCY9bgXCv3iKqybdC2DTAnZpJ	5726	8083	8083	1617394140000	canonical
11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	11141	3NK6qg3yTQHCGDZBqnauy7v9BxYL9nhchEVbiRuTfCrwXGka2gEd	1403	824	156	6301	7534	jwHD79qt5z7Vx8FxqurW5RYXdhW3NHPuDjxAVusBgsMWdt291fr	5727	8085	8085	1617394500000	canonical
11145	3NKuLbE2oKxRZrtDrvrwuJNJsNCwumXABBDE1RgARy4SDT36hfDJ	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	80	1273	156	6301	7536	jxRozMB6QcWfTdPpnCt9AGwphuV5dFB761yaQYvYHVJULnxZGjg	5728	8087	8087	1617394860000	canonical
11146	3NLiVRC7uFi5ccZoypfzKbTsU3gvhBep9xExsfXEoBM2fSKs788h	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	1407	1395	156	6301	7537	jwLixvfJuTP7jTJMhV4tW4Ld9pJP5NknsdyPZfu3PhLeqVZZqLn	5728	8087	8087	1617394860000	orphaned
11150	3NKadcZAj199meqaUT2Azx2HtigLYo1gLNtmdCzDrypvdwRyVC47	11149	3NLkfSj4EG4EXwNLLJnmR6bvcwLNEcFpZjbfZAjCKQVcyzKNUFLA	1546	1213	156	6301	7541	jwuNzs8361ozjXktMkRJtGF6D2AcrcE8ccvZqmEzYQNPRxPKj6F	5730	8089	8089	1617395220000	canonical
11151	3NLcD9RHURdtouSBAVQvJGTPbrKDiAm4tAYHQMiE5dz5tUXhxdTm	11150	3NKadcZAj199meqaUT2Azx2HtigLYo1gLNtmdCzDrypvdwRyVC47	1536	1313	156	6301	7542	jxAyGvNus7GCJLomgcUQ2s6rNjTMsn1qaGx8QKXP3jzLN3pSFyD	5731	8090	8090	1617395400000	canonical
11155	3NLhmEpVBVWEmATPDhRwykTaM9Z2RfEHqEXijFs6VHadd46m4VTx	11153	3NKsZxWmMNgpR8c1iLCvhKewseVmLNtUrqKkF1rkL2aqCiUpcT8c	1419	813	156	6301	7546	jxeLoui9kQxakn6huf9nonHuZMRaEhqRn5CGMbhW8pgRKv9kF4y	5734	8093	8093	1617395940000	canonical
11154	3NLDzkvwb5aapaGF77unvzgw4Arnv59yL3EpvgdhyCtLvQ362ARq	11153	3NKsZxWmMNgpR8c1iLCvhKewseVmLNtUrqKkF1rkL2aqCiUpcT8c	596	1060	156	6301	7545	jxkzzKXC5fVYr8Fd48yzXxTXjkjgnJhvLA2zdFVNDDQY7h49fvX	5734	8093	8093	1617395940000	orphaned
11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	11164	3NKLqAinwkJaViEtdRBhv8drvTUFui1dS9n19nJmTpZNF2tQ8Pn9	1610	1068	156	6301	7556	jwPDm4bmcSEjsZjyYXNWhUq299RsarUfvunMW67eBg4VagbkAKV	5739	8101	8101	1617397380000	canonical
11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	1403	824	156	6301	7558	jxjHffXZvpYikovKPjFAirkdbq7oGr23tJR5G5GSDB9PQzSDSBv	5740	8102	8102	1617397560000	canonical
11169	3NKMLke3rb9HtUE7Mcwswm4g3SpLL4fjtsqQTPJjZjiUZW9Ar9CB	11165	3NLjuYoEDV5FXb5tNnEdjtjcSFipbaUWQsxG88ZGLPSCBa6TBwZ9	1553	776	156	6301	7560	jwLdtX8knL1RKd4F8p33saRTM25zEK114NY1fGpuH2s5gjY5uTt	5740	8102	8102	1617397560000	orphaned
11172	3NKwBNhnW5u7r6CV7AtJyoCW3nuLnYyS4AGGqt5wnSL6QVqqdKyA	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1479	672	157	6301	7562	jxCrtGKoYVqK5ezigWn81J1zk2wAVm1ahpWEF98XhLsammkThMA	5741	8103	8103	1617397744756	orphaned
11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	11176	3NLngUC1g2n8TazxJy8FdLfBebj13ZR3Jkm27f2jTENogsEUhan6	1652	1315	157	6301	7568	jx2GL2ZkMpT95JBuXzeguLFzDr7s7mYw8vSDdB2SRZ5i8MwFShT	5742	8105	8105	1617398100000	canonical
11179	3NKM5Skx2VEmBfgTcMDJsmcHGBKSVzwG7kojKMcpNJ3V7vv6Frgk	11172	3NKwBNhnW5u7r6CV7AtJyoCW3nuLnYyS4AGGqt5wnSL6QVqqdKyA	1652	1315	157	6301	7567	jxuEhW4x1qRU8QUMvbuFq4BSQ6Wpns72jJBYCAoWsBtJFMBhxGQ	5742	8105	8105	1617398100000	orphaned
11178	3NK7REqVSeK4vKaj45PZHkgHa1Z6X2qnQka2t1VGj3dtWA16K7Ey	11172	3NKwBNhnW5u7r6CV7AtJyoCW3nuLnYyS4AGGqt5wnSL6QVqqdKyA	1406	1393	157	6301	7566	jwuAdHkLaq4cNLMnAgF4MJr4a2M47poPghEaXxswzYg9XFue1tP	5742	8105	8105	1617398100000	orphaned
11182	3NLYniEih4DZ4cqjDh3qX5VfHoP843YEnoyG19KfQneox6d6S3Jq	11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	1560	1045	157	6301	7570	jxgFNUJFN1XAM1JV7W9skVRMJCGMNnJKU4EjMKmaF1r9rdZabeG	5743	8107	8107	1617398460000	orphaned
11186	3NKwxxJnaEyp8XHQEfonBCU9RFboaPJQxWbGEmYZKJA5fw5uUKbY	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	311	1307	157	6301	7574	jx3Zr5yiKaCn7KbXgzVSwQPCAmiPvTRgh6idDUUw8fDcVzGfzTZ	5744	8108	8108	1617398640000	orphaned
11197	3NKgyRgjTTphGECkgrdFwYN5u868FL6FYRqo6WZ4KS3uknn21BCw	11196	3NKAMSNhrVStp6PW5CXed8nKxiUihV1Fkn4RRYMk2bjHHHrnheKe	1406	1393	157	6301	7584	jxRnSH9DBRo4Xq1R5cHnKYwVbvK4CRq1qmd4J4gJU4hqMTTjZXp	5749	8114	8114	1617399720000	canonical
11203	3NKidZPiQNvx3bjFeRcHeJ4Hg4yTfigbF6fyX47dyUQXvzg7Hsef	11201	3NK5RRj12v63Wtd8Gfaj9QYpHzuvHCbaR76Du5URth94YFbAYchK	412	412	157	6301	7590	jxWep5N9dN1oscj2FPtxXeVTLhTyCX5UsqCTaGAzHwm9Bx9fbb5	5753	8119	8119	1617400620000	orphaned
11206	3NLepC4DM1qCQVqLCc8734KG4tjuF1RjqKGFgxsNhbZXnXQQkYe3	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1523	1321	157	6301	7591	jwVtxge67nfxSMWwg4wmGfycnjSv2NfCJP1MjpaUYauAJ71H9rn	5754	8121	8121	1617400980000	orphaned
11210	3NLcZoDu8z4WFxq5wpdapZaC393XvMJWxoAfW2K73FjEQE63K5PX	11209	3NKFZRRJnsWcGESJin1Rt7A4Hw9hGARrWTXSkiJ374MkEMaY7feh	1637	815	157	6301	7595	jwBrvkrcHXvKiQsAY9aZU6gCScXjjH5CcdBea2LUrZqkcGNiSrv	5757	8125	8125	1617401700000	canonical
11212	3NLqK5XQCyh5mpzVW5QPLcVACUq9RaQRVdS2FRypNJb35TyKhbfK	11210	3NLcZoDu8z4WFxq5wpdapZaC393XvMJWxoAfW2K73FjEQE63K5PX	1609	1207	157	6301	7597	jxv8Hy8cqYurg8PNsdm7dHiHNWQE7RjLREybjTs5zqgFWzXoXWB	5758	8126	8126	1617401880000	canonical
11214	3NKd8MUFkcZ2KjSEJLBk4fYH8mWgXw1vUcUgxH9UaHR6d7K9iN2F	11213	3NKS36eJC662L2PtenyLf1o9xtuxiTjYpH4Brb5HVXotTGLX1tkD	1407	1395	157	6301	7599	jxGMyNXkx3YuVA7jY1csLH28oJw1JR6p3ckSJxh7xxApRD7vNVk	5760	8133	8133	1617403140000	canonical
11216	3NLs8nUAmi93jzpvqwWnLN2aTdQFrCL7byknDHpkM8ChBP82sgCA	11214	3NKd8MUFkcZ2KjSEJLBk4fYH8mWgXw1vUcUgxH9UaHR6d7K9iN2F	596	1060	157	6301	7601	jwLkfZWoJNeQRvUetWpGMyuWgmh9JnbyqP9m96Uvtm8ypWVWZCj	5761	8134	8134	1617403320000	canonical
15101	3NLYSVSkncqbaXWWo6jHtAhBVFvwa5xjKMsRms4exXoqGzi6Lpj3	14664	3NKbxadnuRfPXTAvnnjn2MnzBXzEQZeHpgrFkan3gkrco4SqEzd3	1407	1395	231	6301	11158	jxg8orPbi1towXzgMf94KCSkngvq3F6Z3mj2KSibRPev7FdTYTG	7471	10893	10893	1617899940000	orphaned
11187	3NL9jgtj1VasGMAYQLPViNgS8gAxnMsXmUGhsQE5Xbu29B2Ao1ct	11181	3NL6GrZH3NGTeStKKb1e4buy9iJc69kg8FnA2AU4zFRZkRoTFuVY	1534	1191	157	6301	7575	jwCMFzWjTaJE9SY2EgUWTofwh3a2avxvcXMZFkKnxa7eDeSS5oK	5744	8108	8108	1617398642344	canonical
11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	11189	3NLC9SLw8zZRG616wMx32SNRtZEvcV1BnBqrJ4utgJUCZ5qxX9eb	1637	816	157	6301	7578	jxR13rtLRkDd6vmYDztyCtBjt2oX8XmLmQ5a5MuirYBqCDKZCig	5746	8111	8111	1617399180000	canonical
11193	3NKAg6CBuGTEuH45GXdLHUyceXQJMparXzryUGFsrH7jAixaiyXM	11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	311	1307	157	6301	7580	jxCTh29gx3ht6raFaRGiusThAyHnLcn5brFZzTRZyGvPK1UZDDk	5747	8112	8112	1617399360000	canonical
11195	3NLxZ1JPLhFPhWCAf24LCBz1XDq73BSi3oFmGhyHnU6M3pBiSD2T	11191	3NLiJMHYgYmkXjrykxPPxv4QmphYoYCHUmPM8CXf2WTX5dWvfb2i	1573	952	157	6301	7582	jwEmviyyJhoMFJfmpoGksFLbqT15mFLRqRji7MkgTG1G8KvEQ4b	5747	8112	8112	1617399360000	orphaned
11198	3NL57M35FHXm5pHgpH3fUerGMJerV4Uy1jDaeCzQHTjhSZwakUzD	11197	3NKgyRgjTTphGECkgrdFwYN5u868FL6FYRqo6WZ4KS3uknn21BCw	596	1306	157	6301	7585	jwD4LgFN7qGSGHNMaLDRmFRvjW7pBK7iHju1tvJWsaXZ1kCPWjm	5750	8116	8116	1617400080000	canonical
11201	3NK5RRj12v63Wtd8Gfaj9QYpHzuvHCbaR76Du5URth94YFbAYchK	11199	3NLojmLKFCH9ZxTSHhfCEwm1wsa41gAPrNFqSx8JmacLQ6PaZSnk	532	1057	157	6301	7588	jxKH2fn84o6ca3Ms6LDgjX2ttqfR55aFHndn4kxrQU6K6p2BC7e	5752	8118	8118	1617400440000	canonical
11204	3NKZKSSHcv179gsHfpLCFDNWmBbrrxBXHfMmu2ZmJSsfq5vCYAYq	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1523	1321	157	6301	7591	jxakVZtdoYEFcZBstdvvcEa68wbk9mEFu72TvR4gBktrYcP5rqF	5754	8121	8121	1617400980000	canonical
11207	3NLnFnxzJ76ryn1X43z11dH7VJtNF4LL45UMbHcs8zQBpcuZ1V6p	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1617	1288	157	6301	7592	jwydR7m9xY1frUAfm3K17AWYmhk7wWTEa1pQQsdE2VycSSkp6nt	5754	8121	8121	1617400980000	orphaned
11211	3NKos4yxiVWdVCnSQJTQ3F9EdGcp4xNws2cgNptG6t7APbmQiLzC	11210	3NLcZoDu8z4WFxq5wpdapZaC393XvMJWxoAfW2K73FjEQE63K5PX	1406	1393	157	6301	7596	jxTzEVuL6RAx67yqnvLBT4fJ3K2qbKZiNqbVUwDCuubFzg1XRBv	5758	8126	8126	1617401880000	orphaned
11215	3NLmDgV9dUci8F12aPywrkWENYDKrkYB64UvNqrjEvNhhQDtEm6D	11213	3NKS36eJC662L2PtenyLf1o9xtuxiTjYpH4Brb5HVXotTGLX1tkD	1594	1200	157	6301	7600	jwc37xuMopeLPNVyronAegSokE2Fb9biiJJr6Y9qD8GhjWtWwzg	5760	8133	8133	1617403140000	orphaned
11217	3NLj889pt4DCGu712L1iz4vm6zNYyYkSmbwK8nS4y6Vj23BPubC8	11216	3NLs8nUAmi93jzpvqwWnLN2aTdQFrCL7byknDHpkM8ChBP82sgCA	1578	1296	157	6301	7602	jx28ihe3wc9CAchjTKSgQm3d2ZMi1T33k5zwop6juSyWr3GdX8y	5762	8136	8136	1617403680000	canonical
11218	3NLgjBvxniXTZ8pqM87A7RLNYXTFMzqaiFW6yvHQKteDHbtcXAmQ	11217	3NLj889pt4DCGu712L1iz4vm6zNYyYkSmbwK8nS4y6Vj23BPubC8	1553	776	157	6301	7603	jw7Yu5PTpXJHhrbxj7REZUMmBNTVQRRRzXENmK55PNy8LY6opbx	5763	8137	8137	1617403860000	canonical
11220	3NLsn11uXwJEESWVUZf788E6mnQwyMidLoj44FBbG7dcSxamgEoV	11218	3NLgjBvxniXTZ8pqM87A7RLNYXTFMzqaiFW6yvHQKteDHbtcXAmQ	497	590	157	6301	7605	jxY3VDhXxapGTzeLk5GZMDC2MGUVfkHbsbzHedjSUF9KV7sfJjj	5764	8138	8138	1617404040000	orphaned
11222	3NLC47ofPsAYYPWhcg8xTCF1ugBxvmeZSeHhUCme5eST37RS5rLt	11221	3NKvFDd9kZZYEcWwTeEPGZDEqTYdJNT4SdLK1o5zuGV6cYuz4xHT	1507	1034	158	6301	7607	jxTikUT6UKs8kjC8xFJbrEDELAnUb6KyJ29PiPiCSY2SiLTvZko	5766	8140	8140	1617404400000	canonical
11223	3NKwG2tCiJFJTbkoNbBCNBQUMZ8NHJ2tMPJ6vkHf6XxtySfXZgpZ	11222	3NLC47ofPsAYYPWhcg8xTCF1ugBxvmeZSeHhUCme5eST37RS5rLt	1588	1392	158	6301	7608	jxB4a8QSAwrby4ECmmNhPT3NnWeiHZer4owtUjm8vNqRx7TvAx7	5767	8142	8142	1617404760000	orphaned
11225	3NKt4ELZFS9UnmsWcJ4WFZ6GA7Sia2uCs5mMhfXJdB9L8ruyrCAo	11224	3NK67q9ot8SVnJgJAfgg7PYdyLqwXc2NLCGfoVNfA58d9snHXCoy	1407	1395	158	6301	7610	jwUfvfcqB27CNSznTGTvEdLuCiwuc7466DARcbuZ5moxymoRDvd	5768	8143	8143	1617404940000	canonical
11228	3NKZtDE2MW8oHueRfcRUr17i7pjjzoFwadWP141FE4nLR9j55Cph	11226	3NKbwSpESccTXzPAHZiXmZbVDcbdbZvGw7KhAMYtEGc61X3QWbDT	1407	1395	158	6301	7613	jxh9UVRtLzh7PMHvAjmd9XykVsLo89RxaQ5Cfotwyc3V9Y5NDvZ	5770	8146	8146	1617405480000	orphaned
11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1403	824	158	6301	7614	jxVy5cnskM3vpZP4eS6Dwg4AhxdMVEVxGeQKUMKzFyRk8SR2khG	5771	8149	8149	1617406020000	canonical
11231	3NKpcPYBApHhBYRNYhCWBj5Pswzuw3TQYH5wkwGqxPbxGs68p2po	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1429	510	158	6301	7615	jxx4kny4RS5RiwTxbpXv4hSA29Mvr84FCv9GiwkViBcvTo5TEnR	5771	8149	8149	1617406020000	orphaned
11233	3NLuCRcriyRjH73eETKoGSTnStqTsaByEodmE6LaU8w9KcQVEisq	11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	1406	1393	158	6301	7617	jwPL1iAmsSfj7CsNykPexRi2SQ9GCdn3wJAq6p13yhBn2hXis8N	5772	8152	8152	1617406560000	orphaned
11238	3NLjkEEAhk7ePM7fyRZxfzKqq6qrvwc1UyFbeSFE9x5yRYtu94X8	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	1651	1055	158	6301	7622	jwYpzs7uX9NHAeQ2b94Ndzz18N4ToUcaV7JJdhKKAGtMDkZeWqE	5773	8153	8153	1617406740000	orphaned
11240	3NLGF2PpAKvXKAD72FXVeG3AVctLBZpgfudnS9MUEqAD9Nmwn2gg	11239	3NLJujbqGFJeb8wzqNkFTcb84sTkTtw9q5R3BsPbRbrCqTgoVPkr	1637	815	158	6301	7623	jxW6wEYfRrJ6A63Z6wH5LoMVqARxdef1fTLkiPLryJL6SGMJcKK	5774	8155	8155	1617407100000	canonical
11243	3NLbeg6DEpUwqKvpuiiKfL8zV445aSSvyhqh4SBYETcpFzAk9CEM	11241	3NKM49BehTvTij7BWArGUxvZpr7N4vHrRXV7EUKxMMQciv67ft5w	632	1382	158	6301	7626	jwvzxwFz2pjWx12vxQNyqDSsKkuWu5AC7oa26wrgpS5P32nSwQ1	5776	8159	8159	1617407820000	canonical
11248	3NLkQtvXkdMUbzWvMouDhhgirLfY1Qtz5ApfUNFDwt6MjCyywiFP	11247	3NLTPx6Yp63jZrwYLZHwHeSVmsxDX4KX1So27viCmcRLbi26AkLM	1447	1345	158	6301	7631	jwSLavM82Hx9GrzdUfYQgzENXhKUxTY9NxUZFTww6MfzJQK3g7v	5779	8164	8164	1617408720000	canonical
11251	3NL6mG8uT7uavtZ6gPYDXjXgwginZtwRzcKiRuZkAFaEYmNPJUZt	11248	3NLkQtvXkdMUbzWvMouDhhgirLfY1Qtz5ApfUNFDwt6MjCyywiFP	1587	1111	158	6301	7633	jx4PcLQC4r1CPaVNWGzdUVe2eWCjeHuMJdtqwfQhpFqiY3AYVSD	5780	8166	8166	1617409080000	canonical
11253	3NKodVuTpG2CTq3D9pdEH4ddDDmLvsGaApM9aPyCmQi8G8qtpBnv	11252	3NLjnhrFMMfXco6EPLBVgo1ApBxWCVAFMgK5ap8ruCt5Zwa41S3z	1403	824	158	6301	7635	jwMPhi6eH8gQwapqfzC9mMVTDpNra8UoTLT14QRiPqTruDF2w1t	5782	8168	8168	1617409440000	canonical
11256	3NLJ1cHc3ActrFzNxc4kmWjuC8psxkwraFjyzFWmPyK13xykYYEw	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1407	1395	158	6301	7638	jwLGaEcSQsebM7L5e5U3oGHrix6M8peDZGDCidsBeYqWG336M9D	5784	8170	8170	1617409800000	orphaned
11260	3NKAXhABorpdqdzqM928BuSyqtdUJ3rqGUPzJyyzRLU1FGMCYVEF	11255	3NKhESxSvdyLSQ9771RgxjjLW1RMhQXF7ey2HYYYT7Zg4TEfLsDk	1564	1338	159	6301	7641	jw6ruppnVHqg9LwmtmhMP3mUbmqAz3SDR4CoeynWwYEmXW7ySjo	5785	8172	8172	1617410160000	orphaned
11269	3NLjEVCxVTWM5WyFLrcepuXKZmvYhtUkawj7bZNUiKvFeRnL74yc	11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	1483	373	159	6301	7649	jwXfKcLJRqSsYYXTZTQq6zxM18mQHdC9jHWZ2cb34Xvz1hvGJQ1	5790	8181	8181	1617411780000	orphaned
14670	3NLx18jahxuE8JrSsVCTvU97f1yKNkwmMBXot6CFqgbkCSwss1HR	14669	3NKRZYNC7ERsGcDzv6xfyXfSDzRN1SQmgsadRwAToNYhT7tZrivq	606	1295	231	6301	10760	jwrH4FTS7c8HKc2neSvwNoGbadcFwaDdBV3JY2rW4X6ARLU3sAX	7475	10585	10585	1617844500000	orphaned
11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	11201	3NK5RRj12v63Wtd8Gfaj9QYpHzuvHCbaR76Du5URth94YFbAYchK	1534	129	157	6301	7589	jxm5iw4SmTvhbkbTyZKbFnHqtFSyT6cZLskQx58ZtYJf1pzvnjN	5753	8119	8119	1617400620000	canonical
11205	3NLhAMJq9cy951WgKhWLbApkjUqMAHLnQSAYqFiUD2AgJNb9Z8t5	11202	3NLDcu4fvxCMFLmXD2oM2m9K2EB1qNTZ9GPT6np1sNfHQqf63CAG	1523	1321	157	6301	7591	jxy5M41mnD7LZkA5nyEkiqFQXkdZBeJADsCpWQHGRTKcDr6owU8	5754	8121	8121	1617400980000	orphaned
11209	3NKFZRRJnsWcGESJin1Rt7A4Hw9hGARrWTXSkiJ374MkEMaY7feh	11208	3NLuRdUUbf2YYuSt47MqjiQN3bDerctfZLh7JGHwCEK5x3XXM5b1	1403	31	157	6301	7594	jwEHw42nsEsZ1pTYEwwXPzbkZPnMzpHRoyzpHScSDH7DThfubak	5756	8124	8124	1617401520000	canonical
11213	3NKS36eJC662L2PtenyLf1o9xtuxiTjYpH4Brb5HVXotTGLX1tkD	11212	3NLqK5XQCyh5mpzVW5QPLcVACUq9RaQRVdS2FRypNJb35TyKhbfK	684	1352	157	6301	7598	jwo4qdNLqy938v9Wv53HhSEs3UMWKfgNtpMiKZ6XnxFrcmXsLVW	5759	8131	8131	1617402780000	canonical
11221	3NKvFDd9kZZYEcWwTeEPGZDEqTYdJNT4SdLK1o5zuGV6cYuz4xHT	11219	3NL6HPR4qQCbxZoKxMAcQe36pYckb4DJm1tY7a5g9Y6pcQS2aT3X	1407	1395	157	6301	7606	jxh55YcoggYzDpMwJd2EsRKYbFYHADqAZt6seu8vqFeZQT5Fb2f	5765	8139	8139	1617404220000	canonical
11224	3NK67q9ot8SVnJgJAfgg7PYdyLqwXc2NLCGfoVNfA58d9snHXCoy	11222	3NLC47ofPsAYYPWhcg8xTCF1ugBxvmeZSeHhUCme5eST37RS5rLt	484	1073	158	6301	7609	jxf5DzroEN2w6KPpFdrf3251ZHMgs8fxA5YtwUsBmW7KUP689NU	5767	8142	8142	1617404760000	canonical
11226	3NKbwSpESccTXzPAHZiXmZbVDcbdbZvGw7KhAMYtEGc61X3QWbDT	11225	3NKt4ELZFS9UnmsWcJ4WFZ6GA7Sia2uCs5mMhfXJdB9L8ruyrCAo	1406	1393	158	6301	7611	jws6WNbG5KA5b1NuAKFmHuBJdpPpTjEEyaNwTu6mgafXG488UkX	5769	8144	8144	1617405120000	canonical
11230	3NK8MotkiRoFZx7ee4vmwwnCPLRYNVsJ1eBox2ET9B19zQa6M1SC	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1429	510	158	6301	7615	jxYk3aPQuakjvnZpCgan3nQUcmj5Nit14KKVjfgfWFXTnjCBi1y	5771	8149	8149	1617406020000	orphaned
11236	3NL1cTn166124K6utsLLzSrGMJdjEDUSevNhFPPVfErqEMupnsmy	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	1536	1313	158	6301	7620	jxTtCf26kmX4vjnRYXPM36ZzzisUQ3RV9pdGuVBgyho5BhHkat6	5773	8153	8153	1617406740000	orphaned
11241	3NKM49BehTvTij7BWArGUxvZpr7N4vHrRXV7EUKxMMQciv67ft5w	11240	3NLGF2PpAKvXKAD72FXVeG3AVctLBZpgfudnS9MUEqAD9Nmwn2gg	1407	1395	158	6301	7624	jxTm6Jos86nPiE3ABCtK7s7D5RASwFZcxdAjRwC154bvJtfhMuR	5775	8158	8158	1617407640000	canonical
11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	11243	3NLbeg6DEpUwqKvpuiiKfL8zV445aSSvyhqh4SBYETcpFzAk9CEM	1490	1028	158	6301	7627	jxK4pdWzm862GQwXwChEZK5kqhw8Rvr2nuq9gqwB8eL2jeDeKHb	5777	8161	8161	1617408180000	canonical
11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	11253	3NKodVuTpG2CTq3D9pdEH4ddDDmLvsGaApM9aPyCmQi8G8qtpBnv	1407	1395	158	6301	7636	jxa9dvrS5YG4x354t95JAExSisxoHeoMc9zLjuskV4w2UxRnUrh	5783	8169	8169	1617409620000	canonical
11261	3NKCq3dgUpvcojdzE6CaJzXVYqZNKwHgKiRZatwcJqg2rsXxPUr8	11259	3NLfNTaJ4XSSmgn6RNSRoyZgXjASzLhAYb4dixfC1YBxySFb9qSL	1406	1393	159	6301	7642	jwL5W7D7sXguR8VzNe77W58LTLAePa6u35ChWwGeJrU7kwH1xtC	5786	8173	8173	1617410340000	canonical
11263	3NKVLoYwLKpdFj4d61ggkHiUnBDs3BT2tmGytkKYAiSPvo6MUPNZ	11261	3NKCq3dgUpvcojdzE6CaJzXVYqZNKwHgKiRZatwcJqg2rsXxPUr8	470	1183	159	6301	7644	jxy2qV92EGWX1tekjNE3341qVC5Y9NUXKrNtQfSG4PtmWPjUVBb	5787	8174	8174	1617410520000	orphaned
11274	3NL1LTeWgXsAgf9aDVJgwsFUvFbN6vmULxiTmaabGgGy8AG5ZDFN	11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	1589	1286	159	6301	7654	jxRjESeQ9Q2qnmD6RDCphJCBw3d5PedRJWR6pgmKuQjRZWTB8A1	5791	8182	8182	1617411960000	orphaned
11281	3NKgii9hQmrnyz72fwaBet3VKeFnuuxjq5bv9WM4LgfPSPfVhZwy	11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	1560	279	159	6301	7660	jwGZuiwsEoXs5um9qAKteSUj1Q84Ea1sY9bm6FkFfHARSRyeTsC	5795	8187	8187	1617412860000	orphaned
11285	3NLGNFPnZkHUW53KCa8eX2kHqbomHZB9dY2rQfBg9msBRJ1c17L8	11280	3NLqrcSgj7L76vMoaHYxx5J6yAz1EQ1BCQKMvegonMD8Rq4FhAc5	80	1027	160	6301	7663	jxmor3Z2iYA9MCguMgQd7TJXnkm7JQEFEaNq2oPgmV8xq3tzgMW	5796	8188	8188	1617413040000	orphaned
11287	3NKaTr8XLgAhgoGDhjAPrE4GRX66paXnLzGvumg72SopfDvdK5gF	11286	3NKBzkHJaeyLN99MDrDMWT3Go9CELZe618Vas4MgoydvuLtHgrbG	596	1060	160	6301	7665	jwhTHXqaxcvM2aTm5RAjJr8yF6gNTZbPMyUzuwfpumEBp46Na35	5798	8190	8190	1617413400000	orphaned
11292	3NK7Wo9j9x14RZb3AVbdeRRRSVBtmrZMuyUFCy8TtPnk8B4bgaEd	11289	3NKgmXRSxzQ4S4peGQ2drx8gMsWLPrUWpLU3wwjkKdLWx4TU4f6t	1555	981	160	6301	7670	jxFvBEm6iLU1H9uUpRj8nLn5adJesf1eT9VMsxA3EhG3xV6eYuV	5800	8192	8192	1617413760000	orphaned
11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	1474	1329	160	6301	7676	jxg2qRtPsLp6JzC6PRXggDU8hf73EyudZTB9FzVTrqjUNQJYRDm	5803	8197	8197	1617414660000	canonical
11295	3NKp5n1fiTY95oghXT6eXgE52KdUq4ZebAxwyPnzG2cZncyY2azB	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	1403	824	160	6301	7673	jwn2LiNJWZCi7akbVyih3kD7XV1skSQPniucf1EYD7HvMCD9WJr	5803	8197	8197	1617414660000	orphaned
11300	3NLMQcsUgEDv5JuXJCexePvcP3zXR2DCeLTUYrtDRTAv7vnX8bZ7	11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	1467	1010	160	6301	7678	jxDtqSaiVRhXQZHRNUFo9y88TZMHmqNy5aUrZK5vrs2Ykk5BgTn	5804	8198	8198	1617414840000	orphaned
11307	3NKjJ71Amnj7q3iStkYmHRs7Sccg8NwJF2F5nCwfdQhuZydLpodF	11305	3NKAwACrvp5UF3ej2cPXWGpJPDLFG8KtF2mU8PRoLC2XEyUEUerj	1593	1220	160	6301	7685	jxgUq5bFwYdjFQ2NEHmantSoLEf5rJ8oGpKrARvXmrRhethQZLe	5807	8201	8201	1617415380000	canonical
11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	11308	3NLR1o137P3rrL2fR9iWLnhMdxuAwMppFtvpnVbALU5HjA3banpo	1560	1291	160	6301	7687	jxLNVQow4E1CmVk33PgyqjocRPfScsZJoKAxyb8sb1QHgJRH3EF	5809	8203	8203	1617415740000	canonical
11311	3NLp7Zvr1HxmAaVVmTQCMxQhBF9douQpu8uTsKmySL6HuuqU8LNU	11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	633	1138	160	6301	7689	jwzw38qAHhJ91BzqTLAqRsAfSFAZSGs84bCnVbkbvvWvWmdxwb8	5810	8204	8204	1617415920000	orphaned
11324	3NLfL8UfTsRHDCABWMR28VnDy5JRRfoCpMuCPKaEM7JDhdrm4nE6	11322	3NKRQF4RyBF1AYo7JLbpN2WBpmue3CeJan6Hm1ZzSTv6RC5C9G32	1587	1357	160	6301	7701	jwdAgv7iNezJDXL3QULabse7yvYU4qWiptm3sgVLpFMyVdj9fCi	5815	8209	8209	1617416820000	orphaned
11326	3NL8jMmandphCce2oT76YHMdpBKW7zi6PuKZSNyeFKJfKuBwa3eG	11325	3NKG8bUfrciX74W91D54ZUen8mDZ7othWKjN2bdWnmwdXjp6tESN	1670	1282	160	6301	7703	jxZPNjBnfCbL7ZTVDahiQXmapWsbHXjJJfoakXAQdeYypTNPp41	5816	8210	8210	1617417000000	orphaned
11334	3NKsmshyxYaXxn2kYvUEwL1q6RqUecRDEqTNZgjwG8XteayGdANM	11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	1397	838	160	6301	7711	jxeSe8vp46urhFM7np9NCTCP35okg4mUn9kFKr16awFWsVe19C7	5822	8218	8218	1617418440000	orphaned
11344	3NK7r8HckHaj2b4rsH4wEeYcueXocJjad5peVVa3xCwdbi8s8YkS	11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	1651	462	161	6301	7721	jxQz1HgnvDbYnshk2Y5gK3nj17sYixkGyUtwMNu16MgLT5zL5Gf	5826	8226	8226	1617419880000	canonical
14673	3NKs1NHhb9xhodsQga1C2em1FVT9boQTknq6P8XDkwj2pi8vj24v	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1426	1118	231	6301	10763	jxrxVH2D49An1XLRN6LtoYMHz1oqemWousToh4ZGXhRmdahtkat	7476	10588	10588	1617845040000	orphaned
11268	3NKXxu5Dn42wuR4rUj64Z8hCaPifmqYMu2prgk9W5JAr2rTiuYMw	11264	3NLAvbc9Z76WZLu1FpnqKarDTCXjVEnVLEGfxJMVQk3NemrmAZf9	1581	778	153	6301	7648	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5612	8180	8180	1617411600000	orphaned
11279	3NLhCQotr9CjuzhEnvgB7Jg8gWH65sPc3XVw9fBc4uGJ2u7DG6pe	11074	3NKoSPu9Dqi2scRekdLA5WxHW2zMNsdjRhCQ8r4YSs1FGpCPDQb2	152	1084	154	6301	7659	jwnhYDGrzJLhY7vyhZRVf3UKgKDd9AAEUgJtivNNerMgA1QKpf5	5652	8186	8186	1617412680000	orphaned
11299	3NL36mMNFstQUmyX1RzLk6CDjKL7ic8eXyMugvMBc5pQzEXVjkPg	11279	3NLhCQotr9CjuzhEnvgB7Jg8gWH65sPc3XVw9fBc4uGJ2u7DG6pe	152	1084	154	6301	7677	jwnhYDGrzJLhY7vyhZRVf3UKgKDd9AAEUgJtivNNerMgA1QKpf5	5653	8197	8197	1617414660000	orphaned
11219	3NL6HPR4qQCbxZoKxMAcQe36pYckb4DJm1tY7a5g9Y6pcQS2aT3X	11218	3NLgjBvxniXTZ8pqM87A7RLNYXTFMzqaiFW6yvHQKteDHbtcXAmQ	1647	1056	157	6301	7604	jxRjpaYRiucLSTeeV13c186p3YtppCEhwadLiJYDk81jXSXfM1i	5764	8138	8138	1617404040000	canonical
11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	11226	3NKbwSpESccTXzPAHZiXmZbVDcbdbZvGw7KhAMYtEGc61X3QWbDT	1564	1338	158	6301	7612	jxXJGJhqHsB16QUAMGKktrv1mGiRySu9HFupBGJKa9PbbpUZYjW	5770	8146	8146	1617405480000	canonical
11232	3NLSgpbYY32Yn68sS3kXF8NARXhGBV9rZ8pmDwDbZRtbA2ZebJVd	11227	3NLPkmKMWyQQUEBBRgvm9hFLYr8Rn9yziU82wKkjLwNMzjZzf7K8	1419	814	158	6301	7616	jw9gK5czEsg5CxyqpF4TCG6b6GU1HKLgFQhVqSekRCQLmbcFvLG	5771	8149	8149	1617406020000	orphaned
11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	1460	1324	158	6301	7619	jxQrjADyPBkJ7JJswMLhV4NXScWN7veBDYcYHHDQuk8Qwriyv8w	5772	8152	8152	1617406560000	canonical
11239	3NLJujbqGFJeb8wzqNkFTcb84sTkTtw9q5R3BsPbRbrCqTgoVPkr	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	1651	1055	158	6301	7622	jxnhFxQzR2Eeazg2Xcz5AnmvzzUXCwj6gNgAuSpXJzGSzNxRcmE	5773	8153	8153	1617406740000	canonical
11247	3NLTPx6Yp63jZrwYLZHwHeSVmsxDX4KX1So27viCmcRLbi26AkLM	11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	1627	1385	158	6301	7630	jx2GjTH2HMWap6GAx3PJCnbN7k1rPkkvNgRAYtqsW2bG2uWMPVZ	5778	8163	8163	1617408540000	canonical
11245	3NLbLD1uFuXuJP7p2B8BYiCT76MDnCXPUXVNpLpUvzFVMPu5PpSt	11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	1460	1078	158	6301	7628	jwHFGaFBmWt1LfALbdpXEHtiH3UmRjWcXMEBveoTab5bnsvQuwv	5778	8163	8163	1617408540000	orphaned
11249	3NKntAdYUaemKuFE4UXeJmRfKX8o4PyynA9ZdneuA5iajiFzjChx	11247	3NLTPx6Yp63jZrwYLZHwHeSVmsxDX4KX1So27viCmcRLbi26AkLM	1553	776	158	6301	7632	jwTTZPYsz6WC7yfwvD9pkmkL6CArb9e94vTrT1X7SJMdLGqru9v	5779	8164	8164	1617408720000	orphaned
11250	3NKXNJ6k5pirw6av32FavuPyhddpnqg1dct16VXTRzf4QgoXhMnq	11248	3NLkQtvXkdMUbzWvMouDhhgirLfY1Qtz5ApfUNFDwt6MjCyywiFP	1587	1111	158	6301	7633	jx4PcLQC4r1CPaVNWGzdUVe2eWCjeHuMJdtqwfQhpFqiY3AYVSD	5780	8166	8166	1617409083244	orphaned
11252	3NLjnhrFMMfXco6EPLBVgo1ApBxWCVAFMgK5ap8ruCt5Zwa41S3z	11251	3NL6mG8uT7uavtZ6gPYDXjXgwginZtwRzcKiRuZkAFaEYmNPJUZt	1402	868	158	6301	7634	jxWjmUMXA3QMbhS4yZzyxqzbmz8JRXPBtGHGqPoFjdLttJayyhX	5781	8167	8167	1617409260000	canonical
11255	3NKhESxSvdyLSQ9771RgxjjLW1RMhQXF7ey2HYYYT7Zg4TEfLsDk	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1406	1393	158	6301	7637	jwucVwAmrz8KaP7BXGGkGXdsvCwyi9vKQfsKbH7aRGzCHPfsqLk	5784	8170	8170	1617409800000	canonical
11257	3NKUbw3gUiLmvxipCfdSfFvBuBcKNESA8zgj5njp4WDrFYCVVdMU	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1651	1301	158	6301	7639	jwMMaQDveNvCMsG2CcYCmpFyvMPkYwqG9kPR78YXe1oWdGBzJRq	5784	8170	8170	1617409800000	orphaned
11258	3NKMZdsTbbWKKg77DBYGebKoE2PXBXz8aZn3hJApCDjwSpFbpBMW	11254	3NLwgGcJC1W9jQExZWr35R5D25ivsbmHATeaeUi6omQfj9QiB131	1651	1301	158	6301	7639	jxMm97LuNikiVCmRbcHqyxBxbJ4fQ7sFEffSLZD9QKw3evEfp1H	5784	8170	8170	1617409800000	orphaned
11259	3NLfNTaJ4XSSmgn6RNSRoyZgXjASzLhAYb4dixfC1YBxySFb9qSL	11255	3NKhESxSvdyLSQ9771RgxjjLW1RMhQXF7ey2HYYYT7Zg4TEfLsDk	1406	1393	159	6301	7640	jxdhQtVHYQiSParh9qGTKWD8UQza7VygUzc9MiJGFPhHkyeBq7N	5785	8172	8172	1617410160000	canonical
11265	3NLsZ2D2EnGRzS4PpFWzRoTj8NXae37je7efPu88zCEw18X4U9Z1	11261	3NKCq3dgUpvcojdzE6CaJzXVYqZNKwHgKiRZatwcJqg2rsXxPUr8	470	1183	159	6301	7644	jxHJ3woBfiGBQtJXuAZ928FoB2a1xHFJQUCdLk7QdErYCngFBN8	5787	8174	8174	1617410520000	canonical
11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	11266	3NLH28QpCjsZsrawanme79Kvyrr1YC3hp2bxvLYVqTexXKBAqtPJ	1596	1237	159	6301	7647	jwNp4Vg9oxo9X9SVKnbogcMKPr9wNRzyZunDKL3faBLs5UmLEW9	5789	8180	8180	1617411600000	canonical
11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	1402	852	159	6301	7650	jxzSJdHxQ4LjBatv99xG25roN5ZjGDqk5Dw8qGaJGeY629CPPdR	5790	8181	8181	1617411780000	canonical
11272	3NL8TxfBvrEz6QGXUt5y7RGie94MVZXvYbzYwnYr6WmkfZUhmic7	11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	1649	1137	159	6301	7652	jx81ocRtdaTq54M6HZoELStnjh8Dj7gk9LV7MULTpvCRwgBB5ji	5791	8182	8182	1617411960000	orphaned
11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	11276	3NLqq3geDZtzwHAZKGsu5z98WkBj58r8zDvbc9qcaRwgraDjpLRB	152	1084	159	6301	7657	jxAejPSmJbK3yQ4Tqm7yn39SKcDCrvWkkxXP5rGo64SATtTYd1z	5794	8186	8186	1617412680000	canonical
11283	3NLgGidzLgyBCYXsjmUzCcj3HoxBczcPA96zaHvvzVnEGGzzFVXp	11282	3NK8k3UEoa6HeFsRZVrc9rPRaAuL9HDLFfszh3VkJLKK1x2iNGoM	80	1027	160	6301	7662	jxdCLzbK3vPVA6fYfMnVZaTdXt9AqhKcGgXq5h7oYQRJrS3F1j2	5796	8188	8188	1617413040000	canonical
11288	3NKM975epDhaeqNvAovKGkVUmw73s8XvHDr7dMcmd6HwPuDh8wnk	11286	3NKBzkHJaeyLN99MDrDMWT3Go9CELZe618Vas4MgoydvuLtHgrbG	1631	794	160	6301	7666	jx8yBuQJXDLcBkVEWsUCDvzLiPB6UcSeoUziCCDLt4wguBcK1wx	5798	8190	8190	1617413400000	canonical
11290	3NKiCvY1JrGHFJCJWHqJsujHqsoqEtM7TBybnD3JL7G9GbNSdVcH	11288	3NKM975epDhaeqNvAovKGkVUmw73s8XvHDr7dMcmd6HwPuDh8wnk	1419	814	160	6301	7668	jxMDAMigHYUEhecNikATKhmhTa3YZGwMRi9kjGbHUutkHeXoPuR	5799	8191	8191	1617413580000	orphaned
11296	3NLqiRz8aTfiJsgYqAa3vGkGhNLvHTyDPUVPD1UkrHS1hiqdRZZs	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	152	1084	160	6301	7674	jwRnqsbvrY91P3KRbpaDhdpgxPCaVhTmZzuZhAui3zSoVgT1e3X	5803	8197	8197	1617414660000	orphaned
11301	3NKwNCEm1epSrxW6iUBjKopVyMRxaG9rY6rfY2YkoYJNCD5E3ZBr	11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	1617	1288	160	6301	7679	jweDGNWnLUNvkXj5FyuUxFUnpsY9zpq8Crv5naX6ZoR9Let9Mb1	5804	8198	8198	1617414840000	orphaned
11310	3NLr8VmDP2VWRiLMr8Z1CUw2rSrCt8wLdU9cxFhQKGAsLbvSpsu3	11308	3NLR1o137P3rrL2fR9iWLnhMdxuAwMppFtvpnVbALU5HjA3banpo	1474	1329	160	6301	7688	jxCUf3fTJLSwn1N6cVY4ipJSD8qvCj392SJGB13YBgUz6nVUmnQ	5809	8203	8203	1617415740000	orphaned
11312	3NK7ZiiQx4egAjKkXfLyKWUCHcYtVAr5HXVwaPWGLkxWYb8WWNeR	11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	1458	1197	160	6301	7690	jwAwcmxkgqcWRQifCBFq5BD5iuhSFB1CLj2vkUCQHSaNFWsT92w	5810	8204	8204	1617415920000	orphaned
14676	3NLNRr3BxU88FGRN9fBacqZgQRKanyL1dQoAcPfoNaL3Hjg7pc8R	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1451	1292	231	6301	10762	jxoe6N7zjZoXRoBb8aQe3vkXqYUJe4pG6Cm9WmXXb1UYcNo6NFj	7476	10588	10588	1617845040000	orphaned
11266	3NLH28QpCjsZsrawanme79Kvyrr1YC3hp2bxvLYVqTexXKBAqtPJ	11265	3NLsZ2D2EnGRzS4PpFWzRoTj8NXae37je7efPu88zCEw18X4U9Z1	1509	1320	159	6301	7646	jwqXJmJz6UvZNYyuZCd5mU2TCn3qptouh8ittVkKVkPcRxgzNmH	5788	8179	8179	1617411420000	canonical
11271	3NKAXEoxfSsxMHiE5JduuTVLsmP8e3gSXfqkNkDY7RQ3LFehy6Ho	11267	3NLFQJFVtXaXrYSs3ASsi1GAoofcpPNWxucViWoc2SWj3FiwViyu	1611	1095	159	6301	7651	jwogCHiGgbcgQQ8qnXaC7wk13EasKDPG2hVKTFhNQVwWucubsFF	5790	8181	8181	1617411780000	orphaned
11275	3NKyPThHKua9GY4RdKsi2s6kXUb42JvnnR9zDpKgqoQMsRiG3BJR	11273	3NKG4GuLkUe6wqCijpgHpRpLvwSLrbAtEa5o3rf5wYB2kQ72Bniz	1483	421	159	6301	7655	jwe2po4NCp5Ng1UeWmPFLEsXTrhxt3g1ZAMuL8qfiz4gJeAH11d	5792	8183	8183	1617412140000	canonical
11276	3NLqq3geDZtzwHAZKGsu5z98WkBj58r8zDvbc9qcaRwgraDjpLRB	11275	3NKyPThHKua9GY4RdKsi2s6kXUb42JvnnR9zDpKgqoQMsRiG3BJR	1407	1395	159	6301	7656	jxHfyXBBkP53oG7AZFByaTBvcKz1aNhchGoMVnAY9pUUNj5Yqew	5793	8185	8185	1617412500000	canonical
11278	3NLgqqn2r1gaoR4VJP8hYkXwj9aUQQNfqVReF5RWRXsMA1VomkA6	11276	3NLqq3geDZtzwHAZKGsu5z98WkBj58r8zDvbc9qcaRwgraDjpLRB	606	929	159	6301	7658	jxkLF5dkVCnHy4umci1Tri6Juo5kQyjkrBKTiyErQV4rr5eyhyR	5794	8186	8186	1617412680000	orphaned
11282	3NK8k3UEoa6HeFsRZVrc9rPRaAuL9HDLFfszh3VkJLKK1x2iNGoM	11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	1477	1224	159	6301	7661	jxiM98seVoNQZ6qJXpsdxuC6eSwMKy1ob2tRC2rYAeWmbyvU3b8	5795	8187	8187	1617412860000	canonical
11280	3NLqrcSgj7L76vMoaHYxx5J6yAz1EQ1BCQKMvegonMD8Rq4FhAc5	11277	3NLTLouEjvCttviK2KaEaMwmm8Ag91uX8kVKYhF1GMwthoDvTZus	1560	279	159	6301	7660	jxynsu3VVHPP2DowSVVAAbvSacZE52Spg2j59Vw3RxdECyPuJF8	5795	8187	8187	1617412860000	orphaned
11284	3NLwnjGUu1UFhbVB1nwXch5bos1tHgAx9Sr4pQXDdBQp92knPNfw	11282	3NK8k3UEoa6HeFsRZVrc9rPRaAuL9HDLFfszh3VkJLKK1x2iNGoM	80	1027	159	6301	7662	jwzn8C3ZX5j33X4ZiUc2dVkfvxitcirbGYvx6E9f66ZBP6HtjZY	5796	8188	8188	1617413040000	orphaned
11289	3NKgmXRSxzQ4S4peGQ2drx8gMsWLPrUWpLU3wwjkKdLWx4TU4f6t	11288	3NKM975epDhaeqNvAovKGkVUmw73s8XvHDr7dMcmd6HwPuDh8wnk	58	1281	160	6301	7667	jxNj4pkHf7WFi9Va3Um5GR37JJMzTWBC5WScN2TCgwsz8EG3fbk	5799	8191	8191	1617413580000	canonical
11291	3NKBLSZoeq8RScjGyBko7CHWDLUjz5fGviGZdHKtXuia4HKWSGSC	11289	3NKgmXRSxzQ4S4peGQ2drx8gMsWLPrUWpLU3wwjkKdLWx4TU4f6t	1471	1386	160	6301	7669	jwumSUmyVRSuxAjp8LdbV5UnCYWYQNqHAuP1nzSMXtaEfcJhzNt	5800	8192	8192	1617413760000	canonical
11293	3NLcBPkV8wsff5B2vr3Ycm6B5aoWf6cGYT3wx2wUsNjh8ip4pZzs	11291	3NKBLSZoeq8RScjGyBko7CHWDLUjz5fGviGZdHKtXuia4HKWSGSC	1483	6	160	6301	7671	jxrVdn68Aa1y26dzpEXQjWkWR25gVLehVMf3BTRXYjhaJbeNgEB	5801	8194	8194	1617414120000	canonical
11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	11293	3NLcBPkV8wsff5B2vr3Ycm6B5aoWf6cGYT3wx2wUsNjh8ip4pZzs	1536	1187	160	6301	7672	jxn3MUJLKfjCh2snoTpQKtZbiY8PzNpbtiZoHXDnY8E4o8oQJzb	5802	8196	8196	1617414480000	canonical
11297	3NKpVUKefLFVgkknMWf7rAcUarUGGF8Xsevfvx61fmGpbqForFhG	11294	3NKvdwBtNMPZsLsebhLf8sZrNZ5bpHRXAugYN2KBw8wuyn3XqyZK	1407	1395	160	6301	7675	jwZZy61PNBYZbGEVYtsLQvS315bwoZ2ZDwC9iFe7U36C4i9exAR	5803	8197	8197	1617414660000	orphaned
11302	3NK3a9aR82JVEvjPaPfYfKxodAUEapCS7XCic4vNC1xDD6o4hEdw	11298	3NKKBwQAYDSDvcKGA4zHa9kGGSaPTnBppwAnAS2J8aL2dYLLiHzL	1585	1240	160	6301	7680	jw8C3hDhRK4htXw1CsowRFPLaEJ2zdFEmncwmfkuHvexXNrqdkE	5804	8198	8198	1617414840000	canonical
11304	3NKTDfn5a8zhTohtbmo8FNcj78cnTz3jxdGif9URaJTsfNjNKzM6	11302	3NK3a9aR82JVEvjPaPfYfKxodAUEapCS7XCic4vNC1xDD6o4hEdw	1451	1292	160	6301	7682	jxaCZJ5va44RDnxKtLkAMBNb2gGdugzJmLwmqsfAWhappw5kVKM	5805	8199	8199	1617415020000	canonical
11303	3NKHud9upvJVXqiiy2z2HPk7RZd6ja9wf5jgXSM8C74XJdPkd3on	11302	3NK3a9aR82JVEvjPaPfYfKxodAUEapCS7XCic4vNC1xDD6o4hEdw	1471	1020	160	6301	7681	jwiZ9NszJviXioR5EL8m7NHZNwgFcwQzqwRt7FRsjtA46gh1fRx	5805	8199	8199	1617415020000	orphaned
11305	3NKAwACrvp5UF3ej2cPXWGpJPDLFG8KtF2mU8PRoLC2XEyUEUerj	11304	3NKTDfn5a8zhTohtbmo8FNcj78cnTz3jxdGif9URaJTsfNjNKzM6	1467	1376	160	6301	7683	jxcyC3jVcpNqr3aA6yEHDhH73r9As4fPqKqMx4n7J9mDtUk28FB	5806	8200	8200	1617415200000	canonical
11306	3NKMuAuLTkPdewUJjhdfGHwufb4Yjicdhr4wgh73dcEW9tnbwM7k	11305	3NKAwACrvp5UF3ej2cPXWGpJPDLFG8KtF2mU8PRoLC2XEyUEUerj	1637	816	160	6301	7684	jxozjLv431VhM4KXC7C7G3ShkLzN9kVDSHXLiZVpPLmFD2Kx4tr	5807	8201	8201	1617415380000	orphaned
11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	11309	3NLvfhaJswSJdV577JBC6t2Agvfus9KLonmrwGYgqhtQcBCcfue7	1536	947	160	6301	7691	jw9A1CQjYvaas62FQUTWCVYyDi2Q7Mwvfnt2HVr5hgXaFMTcLng	5810	8204	8204	1617415920000	canonical
11315	3NKyq5hkroHMMieHBhGDDeSpMCMsByVWHFS7viK5BBBJoJ9EWotT	11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	1406	1393	160	6301	7693	jwNVnAQhiAqAShqihTgBeUmXMJtKPiSJTyuF1JKC8NC6BFHNn95	5811	8205	8205	1617416100000	orphaned
11318	3NL8XvCjgT3ZFT2dzouBzSvJaSFTGb4a6hsuXa5EWj35EuaAAqQs	11314	3NLmqh1ZyxH7WremGvYzLadhdFWZyf19K4W7U8kKS5vEGnr9gaVz	1668	1370	160	6301	7696	jwmDnJbMGuXhfiL2A2eiZbuf8exWb8tpbw5vCi8cmtr25AAkMcV	5812	8206	8206	1617416280000	orphaned
11321	3NLf6kePGQmcdJRKNAZFZmd8CQgMTTS6MjKEfvki2oP1Z27U5qwe	11319	3NK4z73g5qocbvFSRQVkMb5U1yGTGaZF3qtQD3NYryq7JfQbjk8J	1647	846	160	6301	7699	jwVCv8Gi2eXD2juujpXXx1Pqi6jmCeJGQygPjfJXDipYtUoegxN	5813	8207	8207	1617416460000	orphaned
11327	3NKFvFMLb8jLcKre2vJmaCp1JwnntLucjf98tQaC8WvR2tziSLSq	11325	3NKG8bUfrciX74W91D54ZUen8mDZ7othWKjN2bdWnmwdXjp6tESN	1590	1054	160	6301	7704	jwNHY8gmPnk6Wuk1oYwaCwhonavGy9oJQqLHaEkRHRvJUQmQbim	5816	8210	8210	1617417000000	canonical
11330	3NKg5irx9fcWs8EQSfCjseByXh9HG4onp1GZNbU8u4AHtShbVove	11329	3NKdb9WK8YCGcosK3t9wNc2mGx4J6CRwwrtGWkK68B3GBeTM8Gaj	1460	1198	160	6301	7707	jwNw6EjvxFw2d5QKXUkRa4n12PMbNVcEExfNfuRLj6KqDHR1D5g	5819	8213	8213	1617417540000	orphaned
11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	11332	3NLLW8FoMMPLYBQxyiF75yTMNRssqBDrsXQ9a5hF5d4jw22LsZFD	1546	973	160	6301	7710	jx64ox2FYUsUNeVu8q9KaYcaRJ1tYxvPPWCTThmYwzZ559Cnk8Y	5821	8217	8217	1617418260000	canonical
11338	3NLbBmtQivK7MaShf3B32JinQo8vMVHEJFJ3VHE28ZGn5qSHy5kz	11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	1483	910	160	6301	7715	jwYNpMgwhhyCBu4kj73Uo4HyNNvL3QUo7FmedGAbxXpEraUnjUV	5823	8220	8220	1617418800000	orphaned
11340	3NKzpMPKHFqNGzouTMQTCj6Dod9XKLK2pdo8QagV4cvVhtaD4MuY	11339	3NKhARy2YW8druNm8VpfeJcMDionEGicSirGsWZdp4yFFC4fXg9J	1587	1357	160	6301	7717	jw97Zcx1rGLoauxtRA99tMwtKYxDUaB2rHgtd2YphPQVEAP1yAo	5824	8221	8221	1617418980000	canonical
11343	3NLYkqQ4AuCY8WXD7cwqYADK8N2J8KH7wZ8JqpXkTGgN3n4vS8qV	11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	1403	792	161	6301	7720	jwcdT1qNZPKiYHc3Xz9t5ESq37EJ8ra27WFqLo4rmVobKABGX9N	5826	8226	8226	1617419880000	orphaned
11351	3NLJ8TZsbHqsqiqENi5K1XyrFCnfWUzAZ8xs7An3kitMhbSv67Uu	11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	1407	1395	161	6301	7727	jwiJjdoxBuz46L8BeXrKQ6YJjv6ChgcDyF32uSyPmAujzsndohH	5829	8230	8230	1617420600000	canonical
14689	3NKM2jSDn865AuApyaRMfoTyZiPXx9872BBZ76afwmRGuBDZGi7Z	14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	1490	1028	232	6301	10777	jxrRyTt2S6DbtuLjGNAhTRW54jTTKCuxLAD6skrYFX71dj9jpC9	7481	10596	10596	1617846480000	orphaned
11341	3NKCmcRh79FSYeSUvHaeRCU7cK4MwCHedMsM82bWLtngmhTk5uBw	11317	3NLPL8p9hH5ix3dm1RGUTdA2r9LqzLfXVw7gQmdKYaKTMgDdo4GP	1581	778	153	6301	7718	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5614	8221	8221	1617418980000	orphaned
11308	3NLR1o137P3rrL2fR9iWLnhMdxuAwMppFtvpnVbALU5HjA3banpo	11307	3NKjJ71Amnj7q3iStkYmHRs7Sccg8NwJF2F5nCwfdQhuZydLpodF	1637	816	160	6301	7686	jxp15LXEJxCC9DCwCFkfVeYckB112ANTtPc8NJX46BVw6Rsk3LD	5808	8202	8202	1617415560000	canonical
11314	3NLmqh1ZyxH7WremGvYzLadhdFWZyf19K4W7U8kKS5vEGnr9gaVz	11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	1403	823	160	6301	7692	jwiLQFVzb1SasPkQPeGqvN8KYghnjAEuAjXf3uMfwEu1V4Rsneo	5811	8205	8205	1617416100000	canonical
11316	3NKDKKFz7Gqoehq7T9sPegSsVccsNvDVtCeGPmC1jB6pvchmAZYz	11313	3NKtKpDhm7eK2MjkaDZ6enf4NuB48t13BVbrU1ZiRUBxqxStNCpR	1637	816	160	6301	7694	jxjjS8HBDp6TYqRcUpEgNWUUUNF1gF2Z3YMBWKy2SiYpAzqQJkz	5811	8205	8205	1617416100000	orphaned
11319	3NK4z73g5qocbvFSRQVkMb5U1yGTGaZF3qtQD3NYryq7JfQbjk8J	11314	3NLmqh1ZyxH7WremGvYzLadhdFWZyf19K4W7U8kKS5vEGnr9gaVz	1593	1100	160	6301	7697	jwKJnbLweA2GAWRGHZMcdtcTt5EtS5vdXVA6Wt1dHs4t2DyaRRG	5812	8206	8206	1617416280000	canonical
11320	3NLD9h5QFRWYg5NJt8XKgdxnzKUgKhpWNo5DRrZHf4qjZZwF88dY	11319	3NK4z73g5qocbvFSRQVkMb5U1yGTGaZF3qtQD3NYryq7JfQbjk8J	1439	1033	160	6301	7698	jy34Bfo4gszirbBxKB5U9Jce67zRfKZr9Q8pkYtzAtRXtBhReYs	5813	8207	8207	1617416460000	canonical
11322	3NKRQF4RyBF1AYo7JLbpN2WBpmue3CeJan6Hm1ZzSTv6RC5C9G32	11320	3NLD9h5QFRWYg5NJt8XKgdxnzKUgKhpWNo5DRrZHf4qjZZwF88dY	1634	1085	160	6301	7700	jy1psSYLyCXmmrFdpFRZSkoBJYLaZbLMDKShMLaex3uxeefJmVh	5814	8208	8208	1617416642637	canonical
11323	3NKxtYZEYvXPjPB8vSTM6ysPSSFES866q25Mg4LdgN6HM8S6NQdv	11320	3NLD9h5QFRWYg5NJt8XKgdxnzKUgKhpWNo5DRrZHf4qjZZwF88dY	1634	1085	160	6301	7700	jy1psSYLyCXmmrFdpFRZSkoBJYLaZbLMDKShMLaex3uxeefJmVh	5814	8208	8208	1617416645623	orphaned
11328	3NKBQz1AoWT9P5S5v5bRSkaY24PEHVEyfquzUiPEMz4UY2y945JR	11327	3NKFvFMLb8jLcKre2vJmaCp1JwnntLucjf98tQaC8WvR2tziSLSq	633	1018	160	6301	7705	jxKwWK1yTQ5gb5vAbkDaTC9BZqPFXLQBqcPqYUPh4U6wAgy8ztN	5817	8211	8211	1617417180000	canonical
11329	3NKdb9WK8YCGcosK3t9wNc2mGx4J6CRwwrtGWkK68B3GBeTM8Gaj	11328	3NKBQz1AoWT9P5S5v5bRSkaY24PEHVEyfquzUiPEMz4UY2y945JR	1406	1393	160	6301	7706	jxeQq7jiRbF6JJd4MeJR3xTwcgNKCP9HD3vYB3hJUQyhj4SPdyy	5818	8212	8212	1617417360000	canonical
11331	3NLiWmk9Xkvmd1mzdZYkBYFEyWYZ2y8JAJp17Au7FuhG61HzgW2K	11329	3NKdb9WK8YCGcosK3t9wNc2mGx4J6CRwwrtGWkK68B3GBeTM8Gaj	1407	1395	160	6301	7708	jxiwZdXkzVTgrS4GJmw4LTZDhJrLXqpPdVWdstn6BdtPi3NyK5E	5819	8213	8213	1617417540000	canonical
11332	3NLLW8FoMMPLYBQxyiF75yTMNRssqBDrsXQ9a5hF5d4jw22LsZFD	11331	3NLiWmk9Xkvmd1mzdZYkBYFEyWYZ2y8JAJp17Au7FuhG61HzgW2K	1406	1393	160	6301	7709	jwJpmWyLhRUkPudzxHpf64xMe6vzueTHNQNzZbByU9eSdXbyh7C	5820	8215	8215	1617417900000	canonical
11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	1611	1095	160	6301	7713	jwh7zL89Ho1HZxE5ZpmFkxLECqjFQeqXNocTyqdTUJVHMc2wxhE	5822	8218	8218	1617418440000	canonical
11335	3NLtoYzCfBhQjBGPbG1fH5ZBftYty4izdomb9bNq53UHZhxMHHoS	11333	3NLiGrA7YwrLoi176z8Bub8BeEkCo75DpDoLWSt8LSS1f4WkQjex	1631	794	160	6301	7712	jwiytgcjcZrxbi4FS5NawrmTmkYzbcVfKJuZBdrW753yqELLS1m	5822	8218	8218	1617418440000	orphaned
11339	3NKhARy2YW8druNm8VpfeJcMDionEGicSirGsWZdp4yFFC4fXg9J	11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	1627	1139	160	6301	7716	jx8pYyvtyGYnmEiq9Zow1Fe233wLwZSACBEGR6FS3tszSmzFFWA	5823	8220	8220	1617418800000	canonical
11337	3NKAJqHgS1EM6DBWUxsRqgDY78FihQAZz2RPnWTME5eBWfGJJafL	11336	3NL8VQLoFoMT81xLQGUsZqfELtP741HVADJQZXa16jpGqz4V4BdT	311	1307	160	6301	7714	jxpWtXZHJ7mpV8f34upUEZPGsqdWSzbwGRD1dq4igK3YWZNw5P8	5823	8220	8220	1617418800000	orphaned
11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	11340	3NKzpMPKHFqNGzouTMQTCj6Dod9XKLK2pdo8QagV4cvVhtaD4MuY	1648	918	161	6301	7719	jwfojof6PzaizPdEPuoHZeM1jhEktsB8ncCqAaVYVg6DZwLzd6V	5825	8223	8223	1617419340000	canonical
11345	3NKGKVSJHhZci3aEKM3XRsWgT94SmE6MdxuoG8AZbFu52GfVmrkA	11342	3NKAHWS7QiJvbJmaUKUFZwL6S5Y6xGCbb13d9wPHUfe4pKxysBiG	1651	462	161	6301	7721	jwNkrryivh77vrWHiobtZDLxKXD12nPj9z69caV35ftkr1wCwGo	5826	8226	8226	1617419880000	orphaned
11346	3NLyNZsrVFALbf69xvziWUtej4FejsnjCaLDVP2Rcpei6ZTLgw1M	11344	3NK7r8HckHaj2b4rsH4wEeYcueXocJjad5peVVa3xCwdbi8s8YkS	1594	1326	161	6301	7722	jwprnzNTAqFYHJ9a3MFuqvz3RSkuEL2MgdSVKDo9bavBtmQB2vX	5827	8227	8227	1617420060000	canonical
11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	11346	3NLyNZsrVFALbf69xvziWUtej4FejsnjCaLDVP2Rcpei6ZTLgw1M	1445	1290	161	6301	7724	jxneazwPaamhnavR1XayJdtj6kFwt5rsVWWvMQCAJoEr8S1cwhb	5828	8229	8229	1617420420000	canonical
11350	3NLJojtNqvUynPEVdowV7rN2JPkq8iZyLWY5ekUk2gmoqb2yNWcN	11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	1406	1393	161	6301	7726	jwshKb3sJubfS12pNwA3yokWDs8aX5vJGL871cqwbGnvBJ7rGYu	5829	8230	8230	1617420600000	orphaned
11352	3NLXMfkqe6ZAepq6mxXDs2HyMAf63GvCRuzQFzPnoNwcxVfEgNLJ	11351	3NLJ8TZsbHqsqiqENi5K1XyrFCnfWUzAZ8xs7An3kitMhbSv67Uu	1578	1170	161	6301	7728	jxH9UN4UMWX5JJNeL1M8YeHn5vLJFCntxaZGYT9p5UptdqBCsWH	5830	8231	8231	1617420780000	canonical
11354	3NLbDNmgmU6S31hJjgoKB5ExudvaGnvNr2fhGRA6fnwshUPGsM87	11352	3NLXMfkqe6ZAepq6mxXDs2HyMAf63GvCRuzQFzPnoNwcxVfEgNLJ	1426	1238	161	6301	7730	jwbtw7tEi6s8VZz6BoXhoY6WNun95b7YYkf9djZNujkNahx33Yd	5831	8232	8232	1617420960000	canonical
11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	11354	3NLbDNmgmU6S31hJjgoKB5ExudvaGnvNr2fhGRA6fnwshUPGsM87	1587	1357	161	6301	7732	jxE8KgLw3dbEW9ZjPxgoxRNoaccJTH3XTHyG5a2unsUcpD196Vq	5832	8233	8233	1617421140000	canonical
11355	3NKNFkUxo2MLwTuGDGrQCB6bwz76pTxC8sgeby3yFZ22Z5JPq8oU	11354	3NLbDNmgmU6S31hJjgoKB5ExudvaGnvNr2fhGRA6fnwshUPGsM87	1483	1276	161	6301	7731	jxwZUKUzdMrJyTMA7Ly8CUD9HiK4wQwBKXqaNRvJTuRQbuxtW3Z	5832	8233	8233	1617421140000	orphaned
11358	3NLq2PHXTnrFX5aJbsDf2b22K7CjAMuPr5VsPcLbuRc9onJF6Y6K	11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	1609	1333	161	6301	7734	jxLxm7nJ8Njv9sasCh7e1JLN26WXzerkLMEG9Jc5TWVMXJYWYGs	5833	8234	8234	1617421320000	canonical
11357	3NLUV1RG6e4GJofUrn2Y5REkjj3Lp2RjYSw3GYBenbWfCTQQTAYH	11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	1637	816	161	6301	7733	jxrdp5mqjS4wTxgaGwrfsD5Ha42bHn7tiYGRg4TgNj7zeRa6qTc	5833	8234	8234	1617421320000	orphaned
11359	3NKi3x1c7xhYGyn2W7LhBRLax1fDTcDBfXHqc7HvjJTcg4EWUf7A	11356	3NKYPMmn24sb6XCxo4mL8Qw24pawoUTb25KVz9LG4e3dyzZmdJxY	1611	1215	161	6301	7735	jxRvPhnVAN7gF6aH37EKRbgmAtgpUgCMzZxu57AhT3n8rHHUSpn	5833	8234	8234	1617421320000	orphaned
11360	3NLm3YQ7eQ3F4KhyWr9gdB5yyUw1yZ25dzxkxdJsiTSgZPjr6W1E	11358	3NLq2PHXTnrFX5aJbsDf2b22K7CjAMuPr5VsPcLbuRc9onJF6Y6K	1534	371	161	6301	7736	jxf7Tf2Gm1uyKqiYUNfygdQA41KX4rX9Dr2m1rJYN9iSa5TZdH4	5834	8239	8239	1617422220000	orphaned
14691	3NLxcniCu9VEUFCoHpp1YFuhqJU7Q3bWGvCMBJvXVu7omiFxA3sm	14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	1481	790	232	6301	10779	jxoGNhhAknp4TbbdxL2LbLSuD5icRCVCFn989LURk9MwxHcnnNf	7481	10596	10596	1617846480000	orphaned
11362	3NK9p5ARwYZ7ZpnGfohyMeKQkdcykqKYcHAiqFr5idfdSu8eHxFc	11361	3NLqtzST6PG6MKKeRtqFGFyeJ7671Xa7KpMmSS8dU4erYutS3BAq	1547	1132	161	6301	7738	jw6pYrmdoXS3MakCHBnXMR17tduFBzXfiLKV6vaCso2PFxKgcnb	5835	8240	8240	1617422400000	canonical
11363	3NLw27KTCtRwPnfFU1xDz4AYjo7xUYNim7kcPnPFXJ1aYn4EENRj	11362	3NK9p5ARwYZ7ZpnGfohyMeKQkdcykqKYcHAiqFr5idfdSu8eHxFc	1405	857	161	6301	7739	jx1s68kn4jzKd4z8HCLsNbx7tVfn8zeJjoNAcDMXV68HMJMEpkb	5836	8241	8241	1617422580000	canonical
11365	3NLcRBvShV6hkaRQE1bWZyebAvm4LMxSDVdQrzymVw5KPbn7RkPR	11363	3NLw27KTCtRwPnfFU1xDz4AYjo7xUYNim7kcPnPFXJ1aYn4EENRj	1585	1120	161	6301	7741	jw9Ctp1Qa3csCZqw8bnQ5MRA116miNiPR51TJWNvYaY99uE5H29	5837	8243	8243	1617422940000	canonical
11364	3NKPCfLokF357EThocwC1AzhRDbKouKgrLYkeoifqKCpREwLCcrf	11363	3NLw27KTCtRwPnfFU1xDz4AYjo7xUYNim7kcPnPFXJ1aYn4EENRj	1406	1393	161	6301	7740	jwvRZjZvYA72wdv4Bg5TZ6Cv1NW1ddJ7UxM7vCUtQRy5CwfQTis	5837	8243	8243	1617422940000	orphaned
11366	3NLWDKLrU5zGMPotmJ6pMcsk5Q5gpWGpwhYQstn21ZyPzyif2kcv	11365	3NLcRBvShV6hkaRQE1bWZyebAvm4LMxSDVdQrzymVw5KPbn7RkPR	1402	852	161	6301	7742	jxHrZEbzCnhTkWg1fLWx8jb2FYbAQSakpcVmFtHVYGaTVwmGQij	5838	8244	8244	1617423120000	canonical
11367	3NLfbqMtxTbUEnJshhptS2aeULRayS1cD4wQvsF39oQRUVmKdPU2	11365	3NLcRBvShV6hkaRQE1bWZyebAvm4LMxSDVdQrzymVw5KPbn7RkPR	1564	1338	161	6301	7743	jwT3uzcuo87LytL7KYweXS9TL4tKxmY2diMYzDHXr4WaaEaZJW3	5838	8244	8244	1617423120000	orphaned
11369	3NLQfUnA5PqUtYLKcSQqNftwCH6jxZRPqHWwGR7veK5xrqf97dpC	11366	3NLWDKLrU5zGMPotmJ6pMcsk5Q5gpWGpwhYQstn21ZyPzyif2kcv	1673	1122	161	6301	7745	jx5xUU1xDhVc5P4kMvZAAhvjgthk2ipeZ7ij7Du6rWpBMmTjvbH	5839	8247	8247	1617423660000	canonical
11368	3NL55x9THeM1qwgbxDpswRZ5u8C61BJivwFf8i8SG7s2seKeErrK	11366	3NLWDKLrU5zGMPotmJ6pMcsk5Q5gpWGpwhYQstn21ZyPzyif2kcv	1599	1287	161	6301	7744	jwNQuvs1uh6ad1D3EAyTU9D1jbRGuTQphAecYQr7F2NKpFB3d2Z	5839	8247	8247	1617423660000	orphaned
11371	3NL77tLhYDdvuZjk2MaJ2E3zE9dQSYEvhXG2m96GYUA6gR1c5k3v	11369	3NLQfUnA5PqUtYLKcSQqNftwCH6jxZRPqHWwGR7veK5xrqf97dpC	1623	839	161	6301	7747	jxLsqg96WU86wbK4rHZ62RXqKaGMi4gZFak1VGUBsi4sDjsAHKq	5840	8248	8248	1617423840000	orphaned
11372	3NKuTJ9gfB85TBBvC96nz7ctgMQz1gM8CofRUrFv4Az9B52S6dSz	11370	3NLmScxzCvbTpZsfH2PNcZ7BWLqu2uyGhhBsK4ihV9J23Ephjj2X	1553	776	161	6301	7748	jxc1e4RqaP54xsGoJU7bAX4S6CBgncPE9PLdGtADtH6Z4j6Txa7	5841	8249	8249	1617424020000	canonical
11373	3NKqZ4RUUL5XdRhUSLP6ynwe17441ZHU7nCmSepAVudL5hZ4DF7m	11372	3NKuTJ9gfB85TBBvC96nz7ctgMQz1gM8CofRUrFv4Az9B52S6dSz	1403	824	161	6301	7749	jwm5K89XdpQjsPQEuc2jhM3Yk1SCteQRYVcwoj4gMDQz3nD1q2N	5842	8251	8251	1617424380000	canonical
11374	3NK35SFmx8KdFm2CCytxJ4rnwbQHS2VZjJuentiDTBmb6sMjaguJ	11373	3NKqZ4RUUL5XdRhUSLP6ynwe17441ZHU7nCmSepAVudL5hZ4DF7m	1406	1393	161	6301	7750	jwcxcQyRpAyTizbNn9SggtKC8gRM6hpXxLT8uUUvVQFKUxwJm2g	5843	8252	8252	1617424560000	canonical
11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	11374	3NK35SFmx8KdFm2CCytxJ4rnwbQHS2VZjJuentiDTBmb6sMjaguJ	1489	1380	161	6301	7752	jwDcjmPwki69AW38AQeSdgVG9Q1HLEMc3w611TKubsGE2Y2uYz6	5844	8253	8253	1617424740000	canonical
11375	3NLAeApa99VtepUxL7Ji9hSUUheaFgJ5qMJyK1Du7bdy8ztnF4Gx	11374	3NK35SFmx8KdFm2CCytxJ4rnwbQHS2VZjJuentiDTBmb6sMjaguJ	1406	1393	161	6301	7751	jxKHk9gZkX59xod7ynh4T766L4CRENKBdbyoC7vScEB5zFQ1T8t	5844	8253	8253	1617424740000	orphaned
11378	3NL2r7vhKxeJBMC44JF3aKnUJD5yak6T3CnP7J1rJMUj2AVT2RWR	11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	1654	974	161	6301	7754	jwDW1RiHTmDd6UaY8hL64BL9snZ2VjKCYAPqox3H45tmVNWJMzA	5845	8255	8255	1617425100000	canonical
11377	3NKKAfr68NWNKfNXLUdLbHUpqNMx9CiMb7nYGGT4FqHBhFcBapEi	11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	1503	1151	161	6301	7753	jwwHDZdLbfr2PsnUgyktngpz6D3dKK82s5BaTbFt5HCkFUsSKyB	5845	8255	8255	1617425100000	orphaned
11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	11378	3NL2r7vhKxeJBMC44JF3aKnUJD5yak6T3CnP7J1rJMUj2AVT2RWR	1648	1284	161	6301	7755	jwQrEXgLqAMj1U8wkQX2of9Mouiyd1Vn7Afq8N5DDZzz9yyCLP2	5846	8256	8256	1617425280000	canonical
11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	1529	1070	161	6301	7758	jxnpLAF7uq7x6ZBwXxQXsLjxeyz1eK9hqypoMZpc5UcoszXTwYk	5847	8257	8257	1617425460000	canonical
11381	3NLCqphSqtVzLBwKaPhQRLA6vZcGy8TT4kCurK5dw1aVDPhmbqaJ	11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	1467	1250	161	6301	7756	jwA5FL9SEWo8zws8pCmSYNAer4MRThnaaiditg8dpraxjazvAQU	5847	8257	8257	1617425460000	orphaned
11382	3NKXWSMUiiotvNc1Xm1vS64isTfyAmUeR1RJ7Qxr3ADDN283Amg3	11380	3NLUSEmGuk7SQGpnBWxAuJ9eMpvF5cb4E3GDzjJfHKuZRQ2Z63RQ	1534	68	161	6301	7757	jxcv2Qidc5Jz87Tg3SPQN5VZgpruUQ2YiTVq723ZYxXDLtFRq9Z	5847	8257	8257	1617425460000	orphaned
11384	3NLqtdjwvj3qyKH7w6hk7RzTHAg3wBHz616c1DCoKp9wmz1CToMm	11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	1670	1282	161	6301	7759	jxTuNjpGKM1SMHGD5LYarqDnFPaLLp1szmnEmtR7kcNPRfMYQtw	5848	8258	8258	1617425640000	orphaned
11385	3NKjsDfhfyWuCgAt9k74PKvpqbypJ4WH6ubarQBVCUGVqMvd3sqw	11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	1472	516	161	6301	7760	jxv2t8Y2i46iUHtdv14PcMriUEkVMjHm2RZWZLj9J9TJ52VGzaS	5848	8258	8258	1617425640000	orphaned
11387	3NKLY2VXq8YKS4p2V1bP5KgW4pDAUdoNmbeiAwaFTcjdqSav6kt9	11386	3NLJHr4TWNZAdd4gmvbNyVcRcmFkGt1EgTYLRfc1E5P3ZqwWqXSf	1406	1393	161	6301	7761	jwhbEMJVzu2nLKGMjxM7RzRSw3BJe3hkZ56vpPqbaAohbbUPGRP	5849	8259	8259	1617425820000	orphaned
11390	3NKxkFG9nCQ4JBvUZwVUF7YciBx8HBdjuzHJTo41z22C5Z6xoGPy	11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	1649	1137	161	6301	7764	jwKSeCeQz62F1bw9q29zx5frQ9Cp7Nc86jS5hzufTxLfNCAmZcX	5850	8261	8261	1617426180000	orphaned
11397	3NK77EidoQ4c1rXZiKRhStFYPQUogTcngr1kh6QkCGh9addeLj2y	11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	1407	1395	162	6301	7769	jx1jh6J2GAm3vkpbHMKFt7Xwv1bm4s5v3sML4TywHYGKYnCZpTn	5852	8263	8263	1617426540000	orphaned
11398	3NKqeM6JSNdR26yuyJfYNErhC3QuaFa1jcuVb9QHtGCEAnPr4PGU	11395	3NKaMJf33KpmFpS9G1o5q8QM1Pt2RV9Wu7XMqWePjWLZsBxJSsnX	1407	1395	162	6301	7770	jwRrnrLtbf2GAHzNHZAx5x7HhdrngQoiU7DHCv7QzajNBAy4Dn1	5853	8264	8264	1617426720000	canonical
11404	3NL8T2CGR4Hd61wYaT856aud817zb8dj5ShD8cU3Svmfru7PdYNS	11402	3NKH17Am7V1rATbwMTq5kXzFC17JwY4ghzczs5hkhTPjKDAMXsEf	1577	1201	162	6301	7776	jwE5NFJBGe9x4yBE4SYCRvuCHCBPVpBJngc6eANcdazq5L52naA	5857	8269	8269	1617427620000	orphaned
11409	3NLnENWtQ94bjrobu4AQUuvMVhFp3wfyZeLXaUAoF2PYgDRq7CRX	11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	43	1184	162	6301	7781	jxqkFBFUAAw7WbUAzQH6dCoCvVZa2xbVTdQtqw13QqDmPS76wwE	5861	8276	8276	1617428880000	orphaned
11414	3NKLL1MUaGUPsscqjyeoXBKRFBHbnqWEuwoa7cCBgd2324tGdy4Z	11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	1403	824	162	6301	7786	jwmcWtp1Z7QZW7hgn4GZpo7DdcyovbKcv6bWY35tmZkRqQPfnsR	5863	8278	8278	1617429240000	orphaned
15102	3NLJZ3evzSDmbWAb8wzxiTHcpjxHc4ACghSQc5z8Xa7u4WUqMfdS	14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	1407	1395	232	6301	11159	jwdLTUnDk5N85xgxxPdYuoZCsDKCanqjactiNxo3mjJAwtFb3oP	7484	10893	10893	1617899975257	orphaned
11441	3NKaUVLTMsRAtQeZzfzDEFNagW9gVj2YEVPiArMdCcBshpEwZt5t	11352	3NLXMfkqe6ZAepq6mxXDs2HyMAf63GvCRuzQFzPnoNwcxVfEgNLJ	1657	1218	161	6301	7813	jxhaiS4rXsAth5Z7mKrbaDc1cbykfP6b1kr2BfK9zN2NFdRrZJm	5831	8299	8299	1617433020000	orphaned
11386	3NLJHr4TWNZAdd4gmvbNyVcRcmFkGt1EgTYLRfc1E5P3ZqwWqXSf	11383	3NKWZ5zb7gnvPb2EZhwaQJtRhUhJ31q6qr76bEx8VTPeWY2TvEjm	1472	516	161	6301	7760	jxa27nP9G1PA8vVKziTkJUAwzqcABY3eqS3Nk4weGWEY2ccryGe	5848	8258	8258	1617425640000	canonical
11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	11386	3NLJHr4TWNZAdd4gmvbNyVcRcmFkGt1EgTYLRfc1E5P3ZqwWqXSf	1617	1162	161	6301	7762	jx1AHRs2ENVcvZyrBj2zVnTAo3eKNJRrDWXPv76NJdGEED7js8q	5849	8259	8259	1617425820000	canonical
11393	3NK3ugXRzi8oyH5d5XgTzGPvtSeHkK5sjx2FgRTDR3FcrFxYMN8g	11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	1601	1262	162	6301	7766	jxxVfoNxN9nrCey12N4c7P19eABF4qGzheSyFLL7PCWFFBCrBs2	5851	8262	8262	1617426360000	orphaned
11395	3NKaMJf33KpmFpS9G1o5q8QM1Pt2RV9Wu7XMqWePjWLZsBxJSsnX	11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	1460	1198	162	6301	7767	jwyuvnYFYLBVS88VQBdfc4yVmF8HwzxcFRWbesEEj1Z6ATwidrx	5852	8263	8263	1617426540000	canonical
11400	3NK6ud8CDTzPgWiFRuZXfxxKUFXLtpJ1Wg8yXwpA3AAhhkeZ5ort	11399	3NLQUYku116hDA363pvwufcZF4Ez9SzF4FdeB1qTdWvV1NWcEaD4	1608	1043	162	6301	7772	jxxf1EohEkc95pjDYc2J1zNjftsGZgTr8Kn5EBseND3nNiKTXJh	5855	8267	8267	1617427260000	canonical
11402	3NKH17Am7V1rATbwMTq5kXzFC17JwY4ghzczs5hkhTPjKDAMXsEf	11400	3NK6ud8CDTzPgWiFRuZXfxxKUFXLtpJ1Wg8yXwpA3AAhhkeZ5ort	1560	1045	162	6301	7774	jwungFPHFJmRanoJGsQM21P3q171nBNoUnpDEkPcEcopgZm9YNB	5856	8268	8268	1617427440000	canonical
11405	3NL3zoPw6AxHikYoHDy6FctDawv89LMF8UcePHBKdPZ1htj54ibu	11403	3NKxnHLs6QKduozK6QKTu1hJV1pJoHWXNGgnyc6hMem6yzzrN2AM	1406	1393	162	6301	7777	jxzSdgL7kbsPMPN4x2asXXj6tWwmhfxui3dwHiM3xLC36fvMtuY	5858	8271	8271	1617427980000	canonical
11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	11415	3NKSHu4y1inERdE9saUCqiDd6RytEu5fgVYBrHJwpNsEhDcnN5YZ	1477	984	162	6301	7788	jwMKirGZtoDsuSyfrBsJF7snmmocB8CVmfWgJCN32E6fnTPZfU5	5864	8279	8279	1617429420000	canonical
11418	3NLNzDNKXBATVzo4j4quu2pAxs99TnyEgjfCMQfTYXbhp58N65hT	11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	1406	1393	162	6301	7790	jwPERmHPoCaYrSSqXagQsmtFoSFd9maEkrg1t3VdaZgChLzWnsE	5865	8280	8280	1617429600000	orphaned
11421	3NLTQVTzkHEYYTj6EWXNPGsBW9BzRxKXvvVBsGiJUWntaxjfHEef	11420	3NKQVezy9LzXratSDFs9PFP5pXrDyNSBTxgFVrjsJanhLX915htu	1407	1395	162	6301	7793	jxYaUE2KDLEjRQT99B9KruppBr8MM93ujaFFDpFLKUbMTh3tevW	5867	8283	8283	1617430140000	canonical
11423	3NLCr5eBbWD61rfkwMT6kTPcsAXPjGbrnP3Vry64NEhyG5PRHpsb	11421	3NLTQVTzkHEYYTj6EWXNPGsBW9BzRxKXvvVBsGiJUWntaxjfHEef	1483	452	162	6301	7795	jwhaLgWCaPMiYtrVCo7BLUPpo6vJifsg2UtS5oCBzJCTEfDE8pZ	5868	8284	8284	1617430320000	canonical
11428	3NKbfAMfknnpGMrmpisxf4bYeEeCvEySQDwetwXop982dnvb7zPK	11424	3NLEQ18M7WotfNjEoCPiHfT5ZLVfbpaKQavTSA1aKyhsPmCy9SWM	369	1312	162	6301	7800	jwsUGgSkmN9ZC1QgEQEZ8MTEPexFubpmFWuZHy4SHktUUJYYuwS	5870	8288	8288	1617431040000	orphaned
11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	11430	3NKtjJdau3nYwKarab4CYAqqoYFvvnLbevsfHF16LckFSDtq1JDT	1634	1085	162	6301	7803	jxjP18gyGNUXUFzXkKVSjcUdrwRzvZE2qSwC2FVfDyWcA5AG5kw	5872	8291	8291	1617431580000	canonical
11433	3NKkWUrX9ZicBrxud7uhfDRApDeT71yaGZz3UPngqCvzzf9xueU4	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1402	852	162	6301	7805	jw8rewFafoognXGbzaRAWMf3CjmEREcLkJRNGAtPqoPJhFfsEhD	5873	8292	8292	1617431760000	orphaned
11438	3NKFnah4AoKJ1FJEZqATDdgzGSZrnBJQXeYaweSNc3HGZ2pEHmfy	11437	3NL3aRwhY9V2bfug1p3eNVsDKoXtUetfDB29914VD3BpfDDVTUgb	369	1312	162	6301	7810	jx97Aoyv12xuovjVtkWK3usSFYvC4Sp7KeLY9rTkcjrRZUGwnzh	5876	8295	8295	1617432300000	canonical
11447	3NKhCQ1Lg1Cf8pTooiyjk33eHWmzWi4WqEhmLFYkEHnt7itDyBTb	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1460	558	163	6301	7819	jxEiTZP1emLxdReWprysG9zcnJc5mYzHcQVdtsYknXBjSaYVRcH	5880	8303	8303	1617433740000	orphaned
11451	3NK9Y3cGPNVWEXz8xmrmiNC6KgPWxemBN41XYoYF897wmtADGutd	11450	3NLRvCGNR5HoHDBDPKySq2vBacdRaGAmkVDgFN5DnNsYbB7tqUoi	1403	824	163	6301	7823	jxM1Uh4J1yaBuTaTaURNj5ZcgUKWCvkf6A2Tkodf2uCm2MkCf6L	5882	8306	8306	1617434280000	canonical
11454	3NL3dL355rk41WT2kJMmaE1tDMdXKdzAND3PErnUVkTpSehLVP5K	11453	3NLZXAgKM9kgVcaTz8m5ZmqmidaMLpww1hCmm4uUUf7xprdivcrB	1435	665	163	6301	7826	jxHGFWoSMBeoS49jifp5LPW4iggv55RK9uhZChhVUiwVshA6exu	5885	8310	8310	1617435000000	canonical
11460	3NK6EsbsdHv426jFWuE2NcBGQXdFpBFrVKw2YSuuDSARxru8eQak	11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	1406	1393	163	6301	7832	jxnaxxfrVJMBT8AEx17F6znw1KMNzFqGTW6PdyRpauMaUC4kMBo	5888	8313	8313	1617435540000	orphaned
11461	3NKg2tnigsij6AwWmWHFuZAjP2T9QkLg541twmsgFJU2gpALun9c	11459	3NLucjt37BVhQJ8MZKpUmgnduFGP2wsWsXTz3oVWyLpt6nWVsjak	1483	421	163	6301	7833	jwTdz9mT85jKErgoarGrTdYehMdkgJpg4dUERyf9fB42rYFmZu2	5889	8314	8314	1617435720000	canonical
11464	3NKvAnRfNVVKeMHEbNPx9pmNKX8qQZFewy8S23xfMa2dwaWiXc1L	11463	3NL2Vq1hSjCDGYUgpbPAtnmeWWvHBPSEJ8UfZUjv94gV6EBK8LtZ	1403	786	163	6301	7836	jxC917k37sFJvZ8FmdtX2tszGDSR1dXGPMNW7vCxp3KM2DVcwzM	5892	8317	8317	1617436260000	canonical
11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	11465	3NLRWVzGKcu4xmmAE2tuUkSPNRsjnXAC4jm3WMNopMnwS6H8vDpz	1407	1395	163	6301	7839	jxrUtcD1afuZx5PtbGXUgWXVs1LEj6S6CMVvWWuekahQDHNqS4i	5894	8319	8319	1617436620000	canonical
11469	3NKdQqM78NDKkvvWZUnsnXc4iDhovgPVfs97xtmG9yGoKNhZAxDf	11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	1675	1216	163	6301	7841	jxrd8BBicFiJsWkL52s6XK6ye6hnc9MHruciCBtZK3CnKLYnc2A	5895	8320	8320	1617436800000	orphaned
11472	3NKin1YYhV6urz2AV4W4oXSiEkGcccKBwvM14p7opDw4ZZCcWvZZ	11470	3NKm29ogyJKrZWXD5HEUSrAVrLXTyzGH4WpULot999tGXc4RLD9E	1402	874	163	6301	7844	jwmMUp5bPkTuMsQWDrqthGVEPpxZeEH9sonsjTvnabHCv7nRkkW	5896	8324	8324	1617437520000	orphaned
11474	3NKD35iAh8duyj91uqyDWL5kb4p6GG4XB3qLsEK73TeWgMnfSKZQ	11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	1403	824	163	6301	7846	jwsqTA8p3KK2uGC5B3w9RD3ezEnkHrYrQ2GqSRo5yGCnHWR3CeR	5898	8326	8326	1617437880000	orphaned
11484	3NL1MytHhg6B5HXk2X9y6rkjt7jN22RnU1du33k5w9CcdRxjnQtH	11481	3NKPavoBPLxZKwtyQfpZPN63sFHDZ3DFRnug49ywNxxB2AjbxPHn	596	1306	163	6301	7856	jxier4RGCA8C1ABKFzQzZVkH9iU1XQeritJpMWHihMNnJX5uisa	5902	8331	8331	1617438780000	orphaned
11488	3NLQy5oF9P6yL1jdBRkG1W7hs1sLnJnE6vBgrGPc6f5xESVhwLw4	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1670	916	163	6301	7860	jwcKuYJqaBEx6ZVC1pnB9QddqgXqkj4qTukn6y3vuGXAyWAfpZj	5903	8332	8332	1617438960000	canonical
11486	3NLfajf4zKXeDAp6vnfMvvvPPV7XETw3Eqdbb1awgGCNpDpa1YRH	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1675	1342	163	6301	7858	jxEPW9diwhhmYxVuGfzowquexqxBNUDSTYLqct6qhh5G1mpPmEE	5903	8332	8332	1617438960000	orphaned
14733	3NL4d97xxg3eu62zzBBq3JvfDPeB2tTdCXmgFtvyHBR9K6ocb8zf	14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	1407	1395	233	6301	10820	jxSrS8xvyRKB16r7KRFMXx8naCL1vqZCew9GwS3m2AHn6rbbSYV	7500	10629	10629	1617852420000	orphaned
11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	1403	786	161	6301	7763	jwUc8JyGghE7h9kGBr8tEywQNobAWuQDNvb2ze9Ct1TiNcStDSw	5850	8261	8261	1617426180000	canonical
11394	3NKxwzyTYwuhYbNnV4Dsu5dEuxMfBSZxm4LsycjSE92m7W5Augc5	11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	1601	1262	162	6301	7766	jxxVfoNxN9nrCey12N4c7P19eABF4qGzheSyFLL7PCWFFBCrBs2	5851	8262	8262	1617426364096	orphaned
11396	3NLBCHdn3HdUaxgFt1dwDX4z7VdkVNhaveMfXsqH6X2JF2RNRQ5B	11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	43	944	162	6301	7768	jxBdpYnrU7rjhbTuzGGBD9wwNy4KGEdquKGgpqU8GqdwxzC19op	5852	8263	8263	1617426540000	orphaned
11401	3NKUN6GyM3XTMc12DXoBmPpjvMZ9yhRSmRDrtM3xHZjX4Zvj3Q9L	11399	3NLQUYku116hDA363pvwufcZF4Ez9SzF4FdeB1qTdWvV1NWcEaD4	1609	967	162	6301	7773	jwsqKh7bxVGLgDt7QCJ1ahoLxExiCoUmqurBbYS8RP1DqvteAQb	5855	8267	8267	1617427260000	orphaned
11403	3NKxnHLs6QKduozK6QKTu1hJV1pJoHWXNGgnyc6hMem6yzzrN2AM	11402	3NKH17Am7V1rATbwMTq5kXzFC17JwY4ghzczs5hkhTPjKDAMXsEf	532	1057	162	6301	7775	jx4jUyLhhdYDkBQHo9jq8ce86hJx3Zg5CgWorDodLGLWzW7ntSG	5857	8269	8269	1617427620000	canonical
11406	3NL5BAz15jVKm9tHZynAmkpTxBzzHECkbG9fUTjtZtR4A1PZu3oL	11403	3NKxnHLs6QKduozK6QKTu1hJV1pJoHWXNGgnyc6hMem6yzzrN2AM	1481	790	162	6301	7778	jwsNoRaUAXBMtunZbnE4yzC2Aknp1Scg6stjkMDipWNUXKkTvvM	5858	8271	8271	1617427980000	orphaned
11410	3NLnsvGhFXKCnDiiwz12XsJUDAoQrRDvRfvnJNWvkFJvSwEjUouo	11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	1577	1327	162	6301	7782	jwxroa9URhK8CY6tT2VtuPVzvkFaLFa6eSBRpXQMz41aNYtf4eL	5861	8276	8276	1617428880000	canonical
11411	3NLb7a1knyRUAehA9Qcv6EPz3CsFD4ynCqT2yWYdXKLemqRedZef	11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	1405	873	162	6301	7783	jwUSjHjmDxsVSVQk4oNhwERkqhXg1nrEbDhW6e8MHyaobrrHaAw	5861	8276	8276	1617428880000	orphaned
11415	3NKSHu4y1inERdE9saUCqiDd6RytEu5fgVYBrHJwpNsEhDcnN5YZ	11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	1405	905	162	6301	7787	jxikrJJUtz8Sn1ekNTV5LXfXnyWmNhmjVyFzpZJU3Pbuz6UGCUT	5863	8278	8278	1617429240000	canonical
11413	3NKWj4Tmp2ffpX2in1KTGTDg1nsSTQUYB1JkBPFEvPZTx6SA4Ncj	11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	1610	1068	162	6301	7785	jy27U3AAxdgFMkFhDLbHyaTqEHGKKH6uVMWwtct2nwhMta2TyaZ	5863	8278	8278	1617429240000	orphaned
11417	3NKf1Az3sLNREwdMeMnBSmjG6AAfKeawevCZHztogJ9FgvKyNTVB	11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	1534	1071	162	6301	7789	jxdgUWrdcny7CRXsRdezVChx6pzGEG9tFhvm9CskyhegDj7xQxJ	5865	8280	8280	1617429600000	orphaned
11422	3NKvhzWM9E3drxej1K3mHiiF4ofCdivySDXpSd9cSPovn2gNDBsx	11420	3NKQVezy9LzXratSDFs9PFP5pXrDyNSBTxgFVrjsJanhLX915htu	1636	140	162	6301	7794	jwLU1a3oJmNYWLjGFoT6AaDYGT1vZ6CUbXMw6QzWG1L5qYTLfyT	5867	8283	8283	1617430140000	orphaned
11425	3NL6APGHZPrSuUsfPKoUo7wjEWzWvascrP5mbH1FzKiE1E3SGwFQ	11423	3NLCr5eBbWD61rfkwMT6kTPcsAXPjGbrnP3Vry64NEhyG5PRHpsb	1407	1395	162	6301	7797	jx3Wtf3V59em3AaNUxsfcweY28uc57aErD5iteYnj4yWtSqh7uL	5869	8285	8285	1617430500000	orphaned
11429	3NKmZc3GmStizrtQNAg1TZs3LRFe52HzyVZMD9N6mb2SxUxug4vk	11424	3NLEQ18M7WotfNjEoCPiHfT5ZLVfbpaKQavTSA1aKyhsPmCy9SWM	1656	1343	162	6301	7801	jwVz3Ws6jw97idJwTWgeNzzCM5hBNgxFLtvvSKZSUttWBH5d5AE	5870	8288	8288	1617431040000	canonical
11435	3NKD8kaeSQwC826qRMxscWqbaWvjd2jX2EAzbUaVMaQt5FmGnQYR	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1631	794	162	6301	7807	jxKTeSAsPbyXadwQcJZ2nXWufQuyrETUuD9LkG4DciL6Zn6re3C	5873	8292	8292	1617431760000	canonical
11432	3NKD1u6zCx6espmUg4JPsnshN5cfArEYKrane7FqpgTURkd7EBTY	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1406	1393	162	6301	7804	jx4kV5suhzoGzWsS5naj5BwkWm45zyiXn2969ghcd9WxgymJNfu	5873	8292	8292	1617431760000	orphaned
11442	3NKmiDuFE9KAgLyH4wUtGDRsSQoWLe67Q9jxrBFW2uLqznjnSoQo	11440	3NKMsEQzWTrBJsNGMCgqXmbbWFrykZVAfBJup1axWg6zt1m9yEKc	1657	1218	163	6301	7814	jwNECtHG5EfkUwE63EKYdzLmHEJRtuEBfPkHAyks8W8D1NaSHTK	5878	8299	8299	1617433020000	canonical
11445	3NKEheBMgqBW9RdMpcBoKrxWCiKSQVJEjzDtKbphdfiZ9zJ1qVQR	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1403	812	163	6301	7817	jwdQGfmDU4h17LwKNjg8qf8sgQG85pq3acbxNeLsSc5WtEzDJq3	5880	8303	8303	1617433740000	orphaned
11453	3NLZXAgKM9kgVcaTz8m5ZmqmidaMLpww1hCmm4uUUf7xprdivcrB	11452	3NLLbvxa3sgBgjSBABKUuGA6DYfNAnB1BJVdE92kxai25J3eYgbR	1406	1393	163	6301	7825	jxhqztY5Bp3m9bpveXzZnMzid87qPttPEjnpRaWkLCPmcAAXLjs	5884	8309	8309	1617434820000	canonical
11458	3NKB8CLGnJ4PKoKikJ685RDWcN5mnXhxsXibEDz1JvAd2yADUNHV	11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	1536	1313	163	6301	7830	jxFD5S6wvHoPP3KYgHKhgqAiJEBBaafXVk1ikEwpmSRaSQBhnrL	5888	8313	8313	1617435540000	orphaned
11465	3NLRWVzGKcu4xmmAE2tuUkSPNRsjnXAC4jm3WMNopMnwS6H8vDpz	11464	3NKvAnRfNVVKeMHEbNPx9pmNKX8qQZFewy8S23xfMa2dwaWiXc1L	1670	1282	163	6301	7837	jwRaiqGAjytVYBtcp5R1KMJJwggZ8vJGaeFFLARwJGHVvHpgLKp	5893	8318	8318	1617436440000	canonical
11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	11471	3NL6NGU9sPseitRas1AxSeiLS5gSmcB8yxX1hE4exnRBcE7Zi4HL	1407	1395	163	6301	7845	jwPub9Sh77yZhjWTa4FdWSRd4GdQwFuEErKouUrjxHVV2a8MBzb	5897	8325	8325	1617437700000	canonical
11478	3NKZvPjru51s5orvYcfFhczsNmQDvbCMLn2Rk4Sz4NpwithohHVV	11477	3NK7u4dmFCL2ARiZasGh6ubk9igph1dR3DggjL7maW33NWxEMhQX	1501	994	163	6301	7850	jxvH94ErAwTKN7Bm5DB63ATTsHbuinDk5PebZU1ecaBBjUi7aLQ	5900	8329	8329	1617438420000	orphaned
11480	3NLLRrg9iULfUKT63CAM5HYujNXrpLhZ4Tz5D8ZZovUzRTHZurdX	11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	1445	1290	163	6301	7852	jxP6PpTxS411owdM7MPpNSAGvBQSMWEH18vbVfNU4jmn2n3mGNu	5901	8330	8330	1617438600000	orphaned
11487	3NLCP18A25BPqc2k6tQBoxwdL3GrdQckmNu6cDu4m8R2Wv3bY5ZY	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1407	1395	163	6301	7859	jxJv97aBNjXpBtBQKT5cVcK4qvXFBkHXFPSrZmeHoysrP4vyjt8	5903	8332	8332	1617438960000	orphaned
11489	3NK3Ujv96B54thFVEYU3r2DyBnQsi3LjMXB3gaKgF3JduQEJ3nCH	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1448	1065	163	6301	7861	jwgwh4EfESPQ2bi1wL8mVSaZ3Ls3wCX8YUUMqKQQRLtST7pWLub	5903	8332	8332	1617438960000	orphaned
11494	3NKtz9SbjahZh3tAg9pDqDk9qXXdHJdwykP1HHc5HKETB6e2VGNt	11492	3NLHcWZJz5dbD6hdbJJ7EFjeRjtXiS7NSJRD4wdnAci8Rh1Tqp87	1509	1074	164	6301	7865	jwerVVriYfxzEveg5pGdXr8JGEzteByiGAqnLC1m9jTGmCACkQd	5905	8337	8337	1617439860000	orphaned
11496	3NLUpU2g5H633Q4VB3k1u8LQwHDknhNrjVYCSJQHtcnGi7Hdmrx2	11495	3NLTzV3rwc2yxBQn47z2dZwWMqYCLAuErRDcUZy2DS9qXBE5x22J	1447	1345	164	6301	7867	jxi9WZy1c1BUWcoKBJxe42vWjwrtXHtNyKPZHiTMMUBysnKwRoz	5906	8338	8338	1617440040000	canonical
11501	3NLNRGxNTueGz6Z5VFcqxSC7DxwHvifJ1i8P6z9pCwS3Z6VKdZXS	11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	1405	851	164	6301	7872	jwxPuUqXDue53ocLsFeSkYRZFZCqkHYNgEZiNet3WWRqNpwzB47	5908	8340	8340	1617440400000	canonical
14764	3NKJ5ynUKFDrVrzMtLCtRubWJUeMzBNudXKt2wRkBQCvRm9g9eUK	14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	1406	1393	233	6301	10849	jxRbfYNFDK3YwwLBY63Ekuv86VTFNWsPTQiTrq7RmJimJCCygpk	7519	10655	10655	1617857100000	orphaned
15670	3NLRPFtfg4PK8Fq2DnnWCKgzXB65oc9i7JasKJ1Mn9zvXxEzj6Vc	15669	3NL7gjnKTg3XLRhTsYRu2LVqosbWDYPbYiCcJZrUGz4FhMCDYt6a	1675	976	252	6301	11690	jwQxnzHkBeDbe7ux4M6UfFkdjUaEcCr6uPRLnLitAGokpJcWJv8	7975	11290	11290	1617971400000	orphaned
11392	3NKavf6yqmYWd2VCDXeT8FzAN3yThfRzZL161MXm1dtdpfApXjgN	11389	3NLgPDHWrsANBEuzCTgt93bCcvhL7ixYxEVWa8rT7xUgp4zTscpx	1637	816	162	6301	7765	jxCzbvQFbWicHNcnkQjqVYLPtPQCkGkkwXFqii9FwVPWfCR2BXz	5851	8262	8262	1617426360000	canonical
11399	3NLQUYku116hDA363pvwufcZF4Ez9SzF4FdeB1qTdWvV1NWcEaD4	11398	3NKqeM6JSNdR26yuyJfYNErhC3QuaFa1jcuVb9QHtGCEAnPr4PGU	1477	1350	162	6301	7771	jwK242CQX8WVDbaT5TWGe8oaMGwb1CXcvY2uognZj3GnfTr7YtP	5854	8265	8265	1617426900000	canonical
11407	3NLdawetrV19UJeEy17qBDHD14SJQcQsNXEi57XVtuteXZvkBNBc	11405	3NL3zoPw6AxHikYoHDy6FctDawv89LMF8UcePHBKdPZ1htj54ibu	1507	1280	162	6301	7779	jxPwFdwYZyQ1QvHSGQi7A8mAKeWsqqYWuGMmFZ8sNNhpmPgtqXX	5859	8273	8273	1617428340000	canonical
11412	3NKEW8M8BaXD36k93kTZRXaTkJ3r6UQVPNLuLuZEE91HRPAy1dut	11410	3NLnsvGhFXKCnDiiwz12XsJUDAoQrRDvRfvnJNWvkFJvSwEjUouo	1631	794	162	6301	7784	jw9xv3mKT9eHqAbSA6A1QbzPmL6ukya9Wz6MwsWbT1QVYnSzF4L	5862	8277	8277	1617429060000	canonical
11419	3NKzdJy7S5CpUhSFXsmKGwhEvDxFBQdswroyTJzPyX6ryyhVjCqX	11416	3NL2pK3FmveA4YWWpLEqLpeJ5Hp7resgvSJqcwvvSU1xzEb5XiFg	1673	1122	162	6301	7791	jwfP7di15erw5FDYFBvVVA3efANYQd197YgiRqhuLk6CgCDkAVM	5865	8280	8280	1617429600000	canonical
11420	3NKQVezy9LzXratSDFs9PFP5pXrDyNSBTxgFVrjsJanhLX915htu	11419	3NKzdJy7S5CpUhSFXsmKGwhEvDxFBQdswroyTJzPyX6ryyhVjCqX	1619	1029	162	6301	7792	jwXjEyKfhZczFapZ2r8BfiAS7KGPxwEV1hmNyPZ56YSt9FgEUAX	5866	8281	8281	1617429780000	canonical
11424	3NLEQ18M7WotfNjEoCPiHfT5ZLVfbpaKQavTSA1aKyhsPmCy9SWM	11423	3NLCr5eBbWD61rfkwMT6kTPcsAXPjGbrnP3Vry64NEhyG5PRHpsb	1527	1293	162	6301	7796	jxRyztMWwxa7tuBXKneQ7Ci5MNQ1mvAY56JLHpyJAa18shX2eu1	5869	8285	8285	1617430500000	canonical
11430	3NKtjJdau3nYwKarab4CYAqqoYFvvnLbevsfHF16LckFSDtq1JDT	11429	3NKmZc3GmStizrtQNAg1TZs3LRFe52HzyVZMD9N6mb2SxUxug4vk	1406	1393	162	6301	7802	jwPeBfHh5LvdfdVxDA9FMAot4CoA31vDDLfzcruEUuhJfwnMoF5	5871	8289	8289	1617431220000	canonical
11437	3NL3aRwhY9V2bfug1p3eNVsDKoXtUetfDB29914VD3BpfDDVTUgb	11436	3NLPRgAXJpr1Z7MsPMWjSBDjBskJXciiE6Fr1ZUMzT6sHp6MWEmG	1402	874	162	6301	7809	jwa8qiAmztzpretAW9KZeX4BJEDmc4QGCwKi83GT8aa99xJnNNG	5875	8294	8294	1617432120000	canonical
11440	3NKMsEQzWTrBJsNGMCgqXmbbWFrykZVAfBJup1axWg6zt1m9yEKc	11438	3NKFnah4AoKJ1FJEZqATDdgzGSZrnBJQXeYaweSNc3HGZ2pEHmfy	149	1283	162	6301	7812	jwvKyZC3way7jyXiDaKo7r9Bp2SSyU2fTJZpjPuEUFdoC6qi1nf	5877	8297	8297	1617432660000	canonical
11443	3NKav5WZYjvGSv6gFcyPiddeGrj3dDGfwXaXtat2Nzm7uWjB29mV	11440	3NKMsEQzWTrBJsNGMCgqXmbbWFrykZVAfBJup1axWg6zt1m9yEKc	1587	1357	163	6301	7815	jx7XrbpeaaDPEzG46ftydVVihhBeD8zF9yB7B1EBSTGAuwNkFaT	5878	8299	8299	1617433020000	orphaned
11446	3NKee2tuk4so583T6St13USrufh6andXeihBH2knxyzFUE84r5Cc	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1406	1393	163	6301	7818	jx8DEUXCrD4A6CJNHzRrB8Xdjk1fJ2Rv1mHA7tce7hzYHQ3jLt7	5880	8303	8303	1617433740000	canonical
11449	3NL6iHDbeCEgALKtZnLojNrVdRrPTNV9UvnrEUEWviE9AG3Bsd7k	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1623	839	163	6301	7821	jx7RvWo69G1PbYKgGMUdryTVsV6BFTfi7Ry8ZtEhDG3oyvnVX2r	5880	8303	8303	1617433740000	orphaned
11450	3NLRvCGNR5HoHDBDPKySq2vBacdRaGAmkVDgFN5DnNsYbB7tqUoi	11446	3NKee2tuk4so583T6St13USrufh6andXeihBH2knxyzFUE84r5Cc	1549	1362	163	6301	7822	jwW8WfY3jepYTkBnaTJktLh1TnqU3piLDizZAXyM2tf3enExuPp	5881	8304	8304	1617433920000	canonical
11459	3NLucjt37BVhQJ8MZKpUmgnduFGP2wsWsXTz3oVWyLpt6nWVsjak	11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	44	1325	163	6301	7831	jxkQAukWxPkvAYe91N9MjhaddGsD5qGdmZvDs9U57DQpqfzrTaA	5888	8313	8313	1617435540000	canonical
11463	3NL2Vq1hSjCDGYUgpbPAtnmeWWvHBPSEJ8UfZUjv94gV6EBK8LtZ	11462	3NL5rmQm7Fq3nD72ri6fiHESiHBb714Qx1DvPzSUvTrbBXxJXDjB	171	1008	163	6301	7835	jxSE5AR3DBfZpsqAUMZDiBiNz5yVVSn5uQrqzpp8savkWVasDik	5891	8316	8316	1617436080000	canonical
11466	3NLy7wDq4ZSXJW6k8wNH8m5mbcPZNHznVScv3PJtyo36KRh24HZn	11465	3NLRWVzGKcu4xmmAE2tuUkSPNRsjnXAC4jm3WMNopMnwS6H8vDpz	1403	782	163	6301	7838	jwo83NTWbXDBLaMhZW7RUXMJSBatwinG58oGYSuWV4awHLbpxWC	5894	8319	8319	1617436620000	orphaned
11470	3NKm29ogyJKrZWXD5HEUSrAVrLXTyzGH4WpULot999tGXc4RLD9E	11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	1590	934	163	6301	7842	jxvHVWa1EVGLLzdVy7RcR7cH6Lk8UFHvWYtduT61M84RmqVzVgV	5895	8320	8320	1617436800000	canonical
11468	3NK5gHHMQXF1zJ6nApmy4Ue5DvzFTe3EjrfPRtG6PXZ32K1Mkhay	11467	3NKksKAgopCUA67iCDGvzKzQWCmCWQj9TP5vJDH2yRy71p8YQ7jh	44	1325	163	6301	7840	jwpKKrnRSFGtdYBvB1JxeCsJHwERrCCE5qQEbT8YEzX9PSg3GtL	5895	8320	8320	1617436800000	orphaned
11471	3NL6NGU9sPseitRas1AxSeiLS5gSmcB8yxX1hE4exnRBcE7Zi4HL	11470	3NKm29ogyJKrZWXD5HEUSrAVrLXTyzGH4WpULot999tGXc4RLD9E	700	840	163	6301	7843	jwDCmYUSnYxoseeqSQ6QpnUxCWb4uYpv7QK4NMa2839M4PAvWHd	5896	8324	8324	1617437520000	canonical
11476	3NL2AMqTpcASko1VJA4n1wKgDs6PoAzRtKRqJUgtyxd6fTLKiByY	11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	1564	1092	163	6301	7848	jwRjPfWFQin9MGekGrhgP8dWjHgZQkifqCYUGKXgWRZhPGG6WYR	5898	8326	8326	1617437880000	canonical
11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	11477	3NK7u4dmFCL2ARiZasGh6ubk9igph1dR3DggjL7maW33NWxEMhQX	1608	1289	163	6301	7851	jxfZhndK51tZrckYUCqwpFbNEUAfdhGt9ntDgWrja4QRXrpfTVJ	5900	8329	8329	1617438420000	canonical
11481	3NKPavoBPLxZKwtyQfpZPN63sFHDZ3DFRnug49ywNxxB2AjbxPHn	11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	1637	816	163	6301	7853	jwaQkURxq668PnHmoGvBvK89t4paQphkXHKndwdpEcaXHre6hJ3	5901	8330	8330	1617438600000	canonical
11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	11481	3NKPavoBPLxZKwtyQfpZPN63sFHDZ3DFRnug49ywNxxB2AjbxPHn	1656	1343	163	6301	7855	jwvxovRczjj9peQKu4VCWDuezagSYVx7vBAwxngcCdgRSxRF4VE	5902	8331	8331	1617438780000	canonical
11485	3NLT1BdrxP3CoCXUaD3d3ZDhRQJHBeExzAtsrZVJjvKUJ8U9CBR2	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1599	1041	163	6301	7857	jxfhibhNCU4emGVNJMHeAqN2vXgsVVDPzRKddxZDH2kA633WaKu	5903	8332	8332	1617438960000	orphaned
11492	3NLHcWZJz5dbD6hdbJJ7EFjeRjtXiS7NSJRD4wdnAci8Rh1Tqp87	11488	3NLQy5oF9P6yL1jdBRkG1W7hs1sLnJnE6vBgrGPc6f5xESVhwLw4	1617	1288	163	6301	7863	jxWZznQUvAji3Gh1Qvm5E1bLtagwAXcGuoWPMFSfzxTpkx8LBUd	5904	8335	8335	1617439500000	canonical
11497	3NLHtet9HCFzysaS7TDseHd3LwcsArQfK8Lcq6xE6X1z3wL7pQKR	11495	3NLTzV3rwc2yxBQn47z2dZwWMqYCLAuErRDcUZy2DS9qXBE5x22J	1657	1344	164	6301	7868	jwZkSZysso22Ug7P3AaTcE29PZQMQw4RQoQBMihobceiAixpDrS	5906	8338	8338	1617440040000	orphaned
11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	11496	3NLUpU2g5H633Q4VB3k1u8LQwHDknhNrjVYCSJQHtcnGi7Hdmrx2	1440	1131	164	6301	7870	jy258WxbMAvZSr2d7xu8MzfnPnNpE7hV7MpQjAhu73EXZjyzonU	5907	8339	8339	1617440220000	canonical
14770	3NLNgPgUn1BQM8cZaixQ4RWApsbijr6apLAdbUQ34uiw5pXStNpJ	14768	3NKHsnm3eegjPnWAVZ9U3NUpT5dpitxoj4xynezn19hsdcKL5Sph	1668	1124	234	6301	10852	jwmyvNMbzDnmtqA1vDytq4YKjXtnMXgQRLWGucXazqLxBMyXxiJ	7522	10660	10660	1617858000000	canonical
11498	3NKY17hQZkvgRVfJsiZ3iuneuyJktcEAvrjMLbcRmVoYr73qdUCV	11441	3NKaUVLTMsRAtQeZzfzDEFNagW9gVj2YEVPiArMdCcBshpEwZt5t	1657	1344	162	6301	7869	jwMf58WBV2NDyLg1q4696xHufwaXrs8Fi8x2UBPCqysi4suDTfY	5832	8338	8338	1617440040000	orphaned
11436	3NLPRgAXJpr1Z7MsPMWjSBDjBskJXciiE6Fr1ZUMzT6sHp6MWEmG	11435	3NKD8kaeSQwC826qRMxscWqbaWvjd2jX2EAzbUaVMaQt5FmGnQYR	1634	965	162	6301	7808	jxS7ZKZbW7Tp3WjCqb9pqG9kmW7zmyFBjZBvrHcZoWCbrQVzc8m	5874	8293	8293	1617431940000	canonical
11439	3NLKUWgS4X2bzMVvr3ehmfNZkx3fFSDdshRoRxaVjvxnqHmd1y6s	11437	3NL3aRwhY9V2bfug1p3eNVsDKoXtUetfDB29914VD3BpfDDVTUgb	1406	1393	162	6301	7811	jwJy7dMmjAafcrqzq6s5CFKmLhvueui6p1ZtQj1Wg9gFt4Wo9zA	5876	8295	8295	1617432300000	orphaned
11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	11442	3NKmiDuFE9KAgLyH4wUtGDRsSQoWLe67Q9jxrBFW2uLqznjnSoQo	606	1049	163	6301	7816	jwhLw4zzYMvtogYkUt1USKuKghbc2hsb2YkWu1Fo8VwwgiNWhmH	5879	8302	8302	1617433560000	canonical
11448	3NLjGynwJeUvNqj1n2TZfxLT2EhtUEkmAR8uaLf8UyXRmKHB3Dmj	11444	3NKvJDc4zhScX59LCSzHzthippZ4FhW8LcjKpZqS7LxfkcBbuzA3	1407	1395	163	6301	7820	jxzEazwhV6M79nw3XKoM5YNXYDRtUwv9vTxw9ckCqJoCJ1nhxr2	5880	8303	8303	1617433740000	orphaned
11452	3NLLbvxa3sgBgjSBABKUuGA6DYfNAnB1BJVdE92kxai25J3eYgbR	11451	3NK9Y3cGPNVWEXz8xmrmiNC6KgPWxemBN41XYoYF897wmtADGutd	1405	873	163	6301	7824	jx4vsjngoKrhLttcsCzLf2CZTE1oKHfqNaMrNQ954gTbw9PUx78	5883	8308	8308	1617434640000	canonical
11455	3NKw1sLFnAZENVNQyrKmUFzeVvfAiK3oX97MirZoyucZb9oThD3K	11454	3NL3dL355rk41WT2kJMmaE1tDMdXKdzAND3PErnUVkTpSehLVP5K	298	942	163	6301	7827	jxEoGFbBTenuj2H1mShQr62DNZJ82V3JuJkYpv4kdKx3oaGA1pg	5886	8311	8311	1617435180000	canonical
11457	3NLm1rpPfVgVz48FeD3ofq1VCukn9xSJBBbhnyxVZGzMozgPER5U	11455	3NKw1sLFnAZENVNQyrKmUFzeVvfAiK3oX97MirZoyucZb9oThD3K	1406	1393	163	6301	7829	jxRSEmYJk58YEUfF2pVzgJxyiyhsqQvASNkhyLnwstMhKp7yu3A	5887	8312	8312	1617435360000	canonical
11475	3NKyrLDumNYFmRHXBBc4k1HRy3xCGrynWLLV6knKnocsLs3gJxER	11473	3NK8zT7AZag7rjMU8xAyxXYBMR7HJH2ueuFQykWQSJcrW8Bt7PvA	1637	816	163	6301	7847	jx9ga8b5NQnnXBXowves7LxadCnScXtcaTXHdHnYNmwcJPbmGvb	5898	8326	8326	1617437880000	orphaned
11477	3NK7u4dmFCL2ARiZasGh6ubk9igph1dR3DggjL7maW33NWxEMhQX	11476	3NL2AMqTpcASko1VJA4n1wKgDs6PoAzRtKRqJUgtyxd6fTLKiByY	42	1361	163	6301	7849	jx3iex7sqsEUWn5EaUoVUx9xbwcaq5dPspiWHrV5LuGbtuoNNoC	5899	8327	8327	1617438060000	canonical
11495	3NLTzV3rwc2yxBQn47z2dZwWMqYCLAuErRDcUZy2DS9qXBE5x22J	11492	3NLHcWZJz5dbD6hdbJJ7EFjeRjtXiS7NSJRD4wdnAci8Rh1Tqp87	1477	984	164	6301	7866	jxKGZEaPHQW3BXAH4zaJgdkvse5QuEyrdxto5Vhxj792zdcei97	5905	8337	8337	1617439860000	canonical
11500	3NLiF5RfsppQmCfHbN8DEMtE3pxDMToA13k8sgPeY4XAzHgRw8sG	11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	1673	1242	164	6301	7871	jwxiy7hWQMroaSoWJFo1kMdCfwwMtCgf9D6TmAS3qiZFkLyojVq	5908	8340	8340	1617440400000	orphaned
11505	3NLaH4QSqrVoBH1duPZ83EcLh3H7nGwCcr6e3JbtdbXYTDDKYXu9	11503	3NLUx69JquAFqP4M2i5gBDknJtK8dFfpzLkJZMsQgAyuqj9iE3jv	1623	830	164	6301	7876	jxy7nAhyPn7t7xc38zqY44jeyLYopF1w3yfEB7ji9qL97weJ3rV	5910	8343	8343	1617440940000	canonical
11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	1439	1033	164	6301	7879	jxgHKBGpJgjKYcmhAKNhir37b9nqLXrF8RfCoJrLvWzA4FgXQxG	5912	8346	8346	1617441480000	canonical
11507	3NLeqJFanP3idA3RoBexjMmCNK5BakonZ11q37s3WvHoscoQXonJ	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	1403	782	164	6301	7878	jwShwEwPGGZbGuk25rCk8XFMuLDmHgsuHCvFsDT6F4aycoTojZ3	5912	8346	8346	1617441480000	orphaned
11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	1549	1116	164	6301	7882	jwHfCWW3YUyoi86hSWPNuoLxnLEt6ZPD4KmtUTh6H76CzFNLjT2	5913	8347	8347	1617441660000	canonical
11515	3NLJr31vpSNBxXkzqQRsmWLLBpdLaCa1zvAshkqF6hXUEU12fcs9	11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	1507	1280	164	6301	7885	jwfgKP5mMsaqWrrkMTSLLfoarqoRucvmmECu2EmXZLhVjp3i2gu	5914	8348	8348	1617441840000	orphaned
11514	3NKUqLq3enFiAM6R6pAFNrchQFKAtVM6A2Fady8t1CNxdRnGQBK7	11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	1448	1065	164	6301	7884	jwWPiKqRym91QXLizKwgnYmbdJUiNq165sTQqtPmvLxq8MqxL3F	5914	8348	8348	1617441840000	orphaned
11517	3NLuduP2yMrufw17WXtiGoUsjCahmJCJ4BGwji57jDN79MGhN2Ry	11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	1471	1020	164	6301	7887	jwzyQZgiVZath3PFfiGW8agHWznS9Ae6romhkPR9UjqMLVRKygi	5915	8349	8349	1617442020000	canonical
11516	3NKFg74XZSPAfCwmsC27eJtqiegQuZZ6LJ1Y2kEXPFiEM4tc71X8	11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	1403	824	164	6301	7886	jxUFyK4ot9QuXMYMNLZdaAVVdgRRdvBwgD4M4qcpxTqJfngdL48	5915	8349	8349	1617442020000	orphaned
11521	3NKFFS3kuerKNV4trMAWbYeutN8opc8TjkGkEF2MZGfxwCgDDjPF	11519	3NKAEwk5Jg3WApbRVJaSJtoV8CXhJTF61HEBtK2Toruer2eQ9RVD	1407	1395	164	6301	7891	jxEf67F7tk18jUpcKj39q4icJRKzysuBkSv9AUVSSm6DYj3AdgF	5917	8352	8352	1617442560000	canonical
11527	3NKea4DNqk1SDkCnoqSYXsH72GhDzGGi9hUpfoHyqer5FtcSN2gZ	11526	3NKdhpYj2WufNhw6gfWGPMMDe7hyunhwWFkJ55zDJYY5SWBRDWiF	1403	824	164	6301	7897	jxSHJhXbxbF2ygnzgKmNraCrWtJTiiTfHowpJqAiVrKg9LEDDH9	5921	8362	8362	1617444360000	canonical
11528	3NKS14q2XfLi2YqqYoc6dtRFgzrDZCzEEjzKVdDsMf1prSsq4GxC	11526	3NKdhpYj2WufNhw6gfWGPMMDe7hyunhwWFkJ55zDJYY5SWBRDWiF	1407	1395	164	6301	7898	jwq93a5f6j6qTEHatRNaiy4eTehbn8bxKrVGRp5Szuqow9Rw2gr	5921	8362	8362	1617444360000	orphaned
11530	3NK55Bwr9EaVoYhDUpe5XH5UmKJTYoet3czw3SE2ajVFMgBPykeM	11529	3NKzHsFNRwVAwgLsFASV5kUgAPj84aM7Q5gC3ED7WCBbHHea6ux7	1403	31	164	6301	7900	jwrdjUefqDTQREXLiJP9QrNa8rGxB6skG3G2bVhKFgrmdrssgY1	5923	8364	8364	1617444720000	canonical
11532	3NKcAx7KcsJX6jFLTK5z1K796teBzNKEbDAhSVnNCfyBziZKhjp1	11531	3NKJCwBGAVgRqqqtqc1WRi4RkMeLJNJdfQLdmuB1PBeA8MkaH1Da	1553	776	164	6301	7902	jxaFnbFzaPHMxia8xLipkA8vgCxx5KjkVGgPwwgHUaiSP3q13yF	5925	8366	8366	1617445080000	canonical
11533	3NKMcCzxe7AFD2avrzHLBukruh9M3X5inbNGrti75tFjxy3DKS2U	11532	3NKcAx7KcsJX6jFLTK5z1K796teBzNKEbDAhSVnNCfyBziZKhjp1	1608	1289	164	6301	7903	jwAqKgx4vEKLBxdWdhSuKHTBKV4iRhw7uN9R7G1rQjcEBVWbh4z	5926	8367	8367	1617445260000	canonical
11540	3NKXaxoJqLQrhbn9QNk41Wp6UkyQ1ghAfc1Tzc2S1Lhbq2hpEPhL	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1564	972	165	6301	7909	jwioRNQLtvwN2ReWEukBZi8mNL24mDRtMcZNNGuURLKEWGjcmKK	5928	8371	8371	1617445980000	canonical
11536	3NKTr7kA2qHMDBRyYpToQgScjvP62JvUwgUnNtg96xL5zFFxVuVx	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1642	1241	165	6301	7906	jxZkxteqvQpkJTU5rfg5fxHqk7CWwiseSGG5v7MFrFeWdRMd3cz	5928	8371	8371	1617445980000	orphaned
11542	3NK2upcz2s6BmmoD6btjtJqSw1wNdyM9H5tXSD9nmN91mQMe4vH8	11540	3NKXaxoJqLQrhbn9QNk41Wp6UkyQ1ghAfc1Tzc2S1Lhbq2hpEPhL	1406	1393	165	6301	7911	jwhJG6EuEWqR7RrHjfaYxasxs6Fs8b1nnGhL38QU67upZ4uoSQX	5929	8372	8372	1617446160000	orphaned
14831	3NKbn3mND4hfMtdiGD3j6G59amiwuniJdwmgNrT1Ca7fT1qjBqd2	14770	3NLNgPgUn1BQM8cZaixQ4RWApsbijr6apLAdbUQ34uiw5pXStNpJ	1602	1123	234	6301	10907	jwyBvm2x37kCeaxrZi191XoZ5VCm7f7GmWvoGuiDXHZQGdY33q4	7523	10713	10713	1617867540000	orphaned
11520	3NLqDXU8YtvPu7GKmnEFvwNK6pUkB5D6B6dcUfvxN5mA69inwYtZ	11494	3NKtz9SbjahZh3tAg9pDqDk9qXXdHJdwykP1HHc5HKETB6e2VGNt	1458	1077	164	6301	7890	jxRidqPb1H2EeUAiSDGg5FSzs2m6X6sTDjCCGgiRWVQ7ihfJs1u	5906	8350	8350	1617442200000	orphaned
11502	3NKbzzmKKBedmcto7s4jvkRkemmJ46xjfVNjFSeemBGEh6nLc7H3	11499	3NL1rfYcyTzyt1KE8dN7XUnpnmFon1JyNXvMfzi9G8tLxP3ekE5x	1631	794	164	6301	7873	jxVG8uNffVJcKcuSKYLeK3EGtZfCqG28KStGTp5iN6u8xBSNVcU	5908	8340	8340	1617440400000	orphaned
11509	3NLPbCHQX38zU3Um2Nuw3PuChXcYf9NMUBDJNZHMAKgMCEPDLLU1	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	448	1305	164	6301	7880	jwimx1AAfyvDaG8QYkaHi4yvZHvyHqxSY8CzTioqnEdAzHaysi9	5912	8346	8346	1617441480000	orphaned
11511	3NKcdBJQdsDoKn1trJhX2Yce61kotrS5eYRDCDKx69dbuK4ZVYMG	11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	55	59	164	6301	7881	jwcF5j5VsLmPfgWPCs8KsyFuEGLrA5pSb9xxdnNpYEzgBvEMdc7	5913	8347	8347	1617441660000	orphaned
11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	11512	3NK5TyLpt48Z5kBobXveDkTkdxaotfTmVbSjyr8P1iLoSFJHpR2o	1426	1364	164	6301	7883	jwjRsRsr3bpD1dPNjwUS7cbv57TZhgJzwiBZXhCj3R1a9MaBFQX	5914	8348	8348	1617441840000	canonical
11518	3NL68wR1Z1yEtHyNtE3hdUChCe8ibaoofb6UPSchPgop8YcqLeDK	11513	3NLrMuBTye5tVtfTTymDqy8LEgGxcCkBdo8N4fdTMBTq7JkiL52F	1419	814	164	6301	7888	jxidLpjBTJFq79YthAwFmm7o7xhUqA1HK4VWkaCKdBVqF9Q2KPT	5915	8349	8349	1617442020000	orphaned
11524	3NKrJa1seRRyPQ1diKTbs73zbnuTATrMDakZUxjfiYFuZh3MF9JT	11519	3NKAEwk5Jg3WApbRVJaSJtoV8CXhJTF61HEBtK2Toruer2eQ9RVD	1654	1340	164	6301	7894	jw8S4g3pH2acZTt9Jg1BDffWP9aEtaV3xdU2G8Dho4DEh8Bk3Tn	5917	8357	8357	1617443460000	orphaned
11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	11533	3NKMcCzxe7AFD2avrzHLBukruh9M3X5inbNGrti75tFjxy3DKS2U	1577	1327	164	6301	7905	jwWyK66pvxoTTCQn5Hq8WRcPsMQaKypvYbJqsERJNGCyFJ1cxCk	5927	8368	8368	1617445440000	canonical
11544	3NKPaPrn7zSWK9CUhmpUHac6TZCFLPZwCU5W4UA4i2zgCnTicSgY	11543	3NKrTJHVgBAcWzgJ7GDhYCFrDccr1kfxsyvQ9NjevxCt7ZcRjs5c	1490	1274	165	6301	7913	jxoy1bCNhqbn7WXkpWLozhrg7pja3o8uw3wweKCW6hfAdPZU3Ep	5930	8373	8373	1617446340000	canonical
11546	3NLqT1VmRtenoSvMGgvamGBLKampVLMouBtQR5josHq257Crt2Kw	11544	3NKPaPrn7zSWK9CUhmpUHac6TZCFLPZwCU5W4UA4i2zgCnTicSgY	1402	888	165	6301	7915	jx8ahbRb9uiBW2AvaK3oU1zbrikEogfv6GNWsucCnxVdqmQeQKM	5931	8374	8374	1617446520000	canonical
11551	3NKvMpMsNJR75riRJfFrkTBkESXhaoQbhMGeVjUXZhnJhnwDEvcw	11550	3NKF7ytr5yTfFA7Rsu3z95kXBqRCuWCZrvRhH7pdd9xEQndcRjcc	1670	1282	165	6301	7920	jxQTBSbKTk9C8UNqNAe4xpXPX7BkmgFdrkkncTj91bcTZD66Q4L	5935	8378	8378	1617447240000	canonical
11554	3NLCvDS7GPzzRMfPs97JvTwtkB25j8zJuv4vV3yokt8E8VUSo5zz	11553	3NKtWw4hRoEGa2VwbYPy7NSRQSTLuzvxnpcn9GpGtkcEw43fMdC7	1406	1393	165	6301	7923	jxtyMWSbjGfqa9Gfy1MeDUfgfNEx8Eg492sStDRMGXzVH6M6gQ6	5937	8381	8381	1617447780000	canonical
11556	3NKtjXRbs32dyb4vk2XzTbjPGiLgts46kFpuZ6BYFihkAR8qgdGo	11554	3NLCvDS7GPzzRMfPs97JvTwtkB25j8zJuv4vV3yokt8E8VUSo5zz	1403	824	165	6301	7925	jwUhFMYoB2qYwLudW43Z82N2S4npjA9mHx91UKfXLadtMbbbyLV	5938	8382	8382	1617447960000	canonical
11560	3NKFSJYpTuKRNmLzPk8tHZwMdBd3xmynTRmpPduLALf3WxRn9nK9	11559	3NL4KMGE2q5NxAxAMJgvaX71BiChpKpNk37QngAiGFHM13GnYbkW	1406	1393	165	6301	7929	jwU9VtKxDTzPAogz3T5rf5XdSEVkSgBMABxQuRCMVj2WNiqeQj2	5942	8389	8389	1617449220000	canonical
11565	3NLQw6pg82KEmtCouSttFyezEHUqFPB7RMWjZfMNhAcSkQpK3dwH	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	1518	833	165	6301	7934	jwfw13nL2ghMt6E6LTWSM8XR92ACz9BEFwx2Kym1TNfJXzGwQaD	5945	8393	8393	1617449940000	canonical
11567	3NL6p9tCgS9FG1MdUwwVzmxeNTxi8zYWr73JXmappXXgSX6FJgAz	11565	3NLQw6pg82KEmtCouSttFyezEHUqFPB7RMWjZfMNhAcSkQpK3dwH	152	1330	165	6301	7936	jwrUbiR3fYPZ1gm1mAgY9PZx4xaUuV66cr2bH6uBhC1piqVdJth	5946	8394	8394	1617450120000	orphaned
11572	3NK4cNW8kny26KuVVM7U1X71sMS9Ppaz4yMZQiJAchS7jqzyTPg3	11570	3NKbPaHK3m6DyaoTMyiJzVDRjhZqFaKsxSAQgeE9YcKe5ag9yTmq	1627	1139	165	6301	7941	jxDZUWdYLkTN35aBBo3VSLS9DwvHPH6mmPfjzuQ79rafdCXys1c	5949	8397	8397	1617450660000	canonical
11577	3NKZSwwW2BVqStXadrEDkz1ipaFyunAP65hdKg6X4CgmifDrDddc	11576	3NKCtz5AgqGC549Hiv3cKuzykrST4tj4ZENFXQQ4RbLuXrgekDJV	1617	1042	165	6301	7946	jxvjFWgFPzufrJcXLrqL5tX8vdEzFjqsvgX1PVHGSBF7DJPcXuR	5953	8402	8402	1617451560000	canonical
11580	3NKsTmCfUaY9RTNG69bzqekkuCRi96pUW6MkSpHNSxugeSqZXs7S	11579	3NLqoMRNeqizfqmXLPNt5RYyjxDETzaLMEWfGDMA6FwHcaja1DMW	43	1310	165	6301	7949	jxTv8RcBhq6sd5xYG8s6m7tekFogTmwyeGJQQkt4THKQfuFQTyP	5956	8406	8406	1617452280000	orphaned
11583	3NKkr1UmQvDJSabN41QUHda8SqaECVBa4SDPWC2tx86FnotZd9dY	11581	3NKzBkjiJYXRLnoWnpsu8vC9j8rHCk9QwyACwdiWFYFaAxB8di8m	1403	812	165	6301	7952	jwpy4XY2VQZYckzYpyf6VBV7ubp3822DsbrL46GENnWb76RV723	5957	8407	8407	1617452460000	orphaned
11587	3NKiUKD4zBMzzWEpE61sMGUyxShEG3Pzz9aQaMNQwMgvH8vUvXNT	11586	3NL4SKoVhAQu1SXdQm1iUX4VuhQH6E5unwQngsyWvGZVjKvgYkQy	1617	1042	165	6301	7956	jxetfyuY76P8qbWf1MxqvLvRRqKfKoJQBFwXYXrxa2WNb8yrRmt	5960	8410	8410	1617453000000	canonical
11592	3NLRziKyuHDKnWhrq6MkR8LdeLYuyvV3MAn5DTdhtfQpmf6tWDBL	11591	3NLPCwaxvixmXadoAuyeRZ8YSbYRerFLh7hcBHfjntYS3tZkhNRT	1460	1324	165	6301	7961	jxeqiXVsmyLSrSmYkvfkuMSj7CTfdtxxTFfoVCcABotDTSQW1ap	5963	8413	8413	1617453540000	canonical
11598	3NLLwp1cDU3ebAMe2M9AypxrXGqtVZBtNNLdjUyTJnTKBGtXsm5m	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1426	1364	165	6301	7965	jwUvK8mCyGhXYAj7CoTzrpMezkc6pQif69tZE5NBzJ5eBTbNq1h	5965	8416	8416	1617454080000	orphaned
11599	3NLHnyuHtB5Wuf9oZ1WupSh57kcVdQHGCrbfbk5DPwGerNRrxZyi	11596	3NKpJkbs3SHvvukJGRSqPqLjrALHMnCpRDu8Wxx7t29shevVWvQS	1599	1161	166	6301	7966	jxseZHqncQx1vbL9aM5bHXhpjLnYR8cV63M8i8NAJWySzT3wAC8	5966	8418	8418	1617454440000	orphaned
11602	3NLcGRnXYKRurt2nsh98eZep1NMT5sefzoXahmmeaCsmGVw1qhRV	11601	3NKLkK3wd2egYNUCuqkBZLts73TqBoF3W1nH7yahAQAwJyXMVNDf	1637	815	166	6301	7968	jwLQa6pfPWz2Uc7RxFNPnmCF3GbSsBrVFiKp8qpiwALH5VaVnjh	5968	8421	8421	1617454980000	orphaned
11612	3NLRRyhKy9haLorDXXxw4a5agRQkjGET1BywWpMQ8Ns4Qp5D5amw	11611	3NK8fhusfNnzT1VHP1NUXTedhpvPwKsaSQfPGobfwEzRWwN7jDPf	1555	1101	166	6301	7978	jxW6k6MEBP6j1YXx93NbUL8tgUYuZSwMJzJU7F75HG5S7Y1CPay	5975	8437	8437	1617457860000	canonical
11614	3NKZaEGVwTRfLsDprMJJM4uGmSebsf4Ss6nAkstg8id7hSt7MBss	11612	3NLRRyhKy9haLorDXXxw4a5agRQkjGET1BywWpMQ8Ns4Qp5D5amw	1407	1395	166	6301	7980	jxyw5THM9DAJAdgUkFd35TUnxLSgH6xLuHokbeGTsvSYGFK4UDN	5976	8438	8438	1617458040000	canonical
11622	3NLrz1kGjaNEXN8pVFT4gQm5WjUAzG96BgWrTAiko2rvHGDewST3	11620	3NKgvhvxZYgLthUf4DUwBk7z1TbcGPH6SqD3U7mGUjcyFbd5j95L	632	1382	166	6301	7987	jxHo5rRvpBzGuexDonU6tUe5WR396WGhbbf5ELEHuhKbq1s8Nor	5981	8445	8445	1617459300000	canonical
11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	11625	3NKyyBtmpMKDG3ihbGq61qc5zTQ9iqAEqVMrqmUaepSMf1E1vtxG	1397	828	166	6301	7991	jxhoyPKn83h1heHmKsGL64geN9sReJ5UVCEiPxLTfhAwNv4RsqK	5984	8453	8453	1617460740000	canonical
14787	3NLKX2kvYSkrmaj16Jnrv9DtG7fEXACYBbAx4L8JebuRBZFJCPzD	14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	1637	816	234	6301	10868	jx3adybjYHNn8S2D1FqmhaiDXmGEezXi7h7dk6M1UWHcwKGF94P	7530	10671	10671	1617859980000	orphaned
15296	3NLg9jRhjTTjzdvHsvWJqYF8g1ejjZoa4NpfMHh6gohCAx4usuFB	14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	1588	1146	234	6301	11342	jxbf1D4vSr2yFh4HbrJVKA4gbDcQczEcEgUaD25kGjTVAPGBLUG	7530	11030	11030	1617924600000	orphaned
11503	3NLUx69JquAFqP4M2i5gBDknJtK8dFfpzLkJZMsQgAyuqj9iE3jv	11501	3NLNRGxNTueGz6Z5VFcqxSC7DxwHvifJ1i8P6z9pCwS3Z6VKdZXS	1527	1047	164	6301	7874	jwQNEkKjLwS4EqYPfKjq7gwnyu1F94Cx4KC9R6DgsE6CSKU7T3a	5909	8342	8342	1617440760000	canonical
11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	11505	3NLaH4QSqrVoBH1duPZ83EcLh3H7nGwCcr6e3JbtdbXYTDDKYXu9	1445	1290	164	6301	7877	jxH9guCcTzTqWmz5BU3ukvANKhjZPkZj2Psh5givoZCBGz5KH2L	5911	8345	8345	1617441300000	canonical
11519	3NKAEwk5Jg3WApbRVJaSJtoV8CXhJTF61HEBtK2Toruer2eQ9RVD	11517	3NLuduP2yMrufw17WXtiGoUsjCahmJCJ4BGwji57jDN79MGhN2Ry	1458	1077	164	6301	7889	jwJc9xppaoBbosk1FdnYGi311LrU6J4GezyUkEjuWFh25XBknZY	5916	8350	8350	1617442200000	canonical
11522	3NL43wobX3syU3SiajooxkLiMNQGh1ERJARHDiTgHVzL296SChaE	11521	3NKFFS3kuerKNV4trMAWbYeutN8opc8TjkGkEF2MZGfxwCgDDjPF	1407	1395	164	6301	7892	jw82AeiJJxK6cF5WVmGbjS1DyyT7tUm3tUuZ95FRVeVKPrZTW4v	5918	8353	8353	1617442740000	canonical
11523	3NKKFU9mAuapfKzXJbEwzpP9FbTh4cF3GDhykLB2nFKtLszQ64h6	11522	3NL43wobX3syU3SiajooxkLiMNQGh1ERJARHDiTgHVzL296SChaE	1654	1340	164	6301	7893	jwpcNW2Csj5WidJ3R8iiVJiLyLvC7nUUn1FXZJPJuz6TALmDG8Q	5919	8357	8357	1617443460000	canonical
11526	3NKdhpYj2WufNhw6gfWGPMMDe7hyunhwWFkJ55zDJYY5SWBRDWiF	11523	3NKKFU9mAuapfKzXJbEwzpP9FbTh4cF3GDhykLB2nFKtLszQ64h6	1601	1388	164	6301	7896	jx1MYbiLQ8ayGEfnYJKe9qoCiKxs7wiRkf5VowjmJbVXsq5fyMb	5920	8360	8360	1617444000000	canonical
11529	3NKzHsFNRwVAwgLsFASV5kUgAPj84aM7Q5gC3ED7WCBbHHea6ux7	11527	3NKea4DNqk1SDkCnoqSYXsH72GhDzGGi9hUpfoHyqer5FtcSN2gZ	1624	1208	164	6301	7899	jwieRTMNUbXqLM9XZiP46ej178b8YF2WpDkRQxLeVMPX9nyPnFa	5922	8363	8363	1617444540000	canonical
11531	3NKJCwBGAVgRqqqtqc1WRi4RkMeLJNJdfQLdmuB1PBeA8MkaH1Da	11530	3NK55Bwr9EaVoYhDUpe5XH5UmKJTYoet3czw3SE2ajVFMgBPykeM	1609	967	164	6301	7901	jwzM8pM46kt37fvuqWfeUmU1ETeBsn5g5e5j3dgNxEFKoTrdF8E	5924	8365	8365	1617444900000	canonical
11538	3NKfqamq4p9XjFEZaYhYxLBKJiTaWwKn7FeTRTn3L9boGgm5CPL2	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1407	1395	165	6301	7907	jx8WGnpzVMj3HW4QvkucYN3TKbCctJSAMvo24emDR3qUqfhQqSv	5928	8371	8371	1617445980000	orphaned
11543	3NKrTJHVgBAcWzgJ7GDhYCFrDccr1kfxsyvQ9NjevxCt7ZcRjs5c	11540	3NKXaxoJqLQrhbn9QNk41Wp6UkyQ1ghAfc1Tzc2S1Lhbq2hpEPhL	1407	1395	165	6301	7912	jxgpRAir2JF2TwgaFwZyneU65TUYp7BDq9gkjhYTc3eRDk7sLEh	5929	8372	8372	1617446160000	canonical
11548	3NL6NcYtE6NXLbDtwbGCiz2ir3H3rRp5ah9WsSQi3RmqVgKgeZZD	11546	3NLqT1VmRtenoSvMGgvamGBLKampVLMouBtQR5josHq257Crt2Kw	1647	846	165	6301	7917	jy1k3PzLREQXijVAvhYwAoDx8eTabEwwGEsegMqVMhDhxBgmdTW	5932	8375	8375	1617446700000	canonical
11553	3NKtWw4hRoEGa2VwbYPy7NSRQSTLuzvxnpcn9GpGtkcEw43fMdC7	11551	3NKvMpMsNJR75riRJfFrkTBkESXhaoQbhMGeVjUXZhnJhnwDEvcw	1457	1391	165	6301	7922	jx5T6nByBjGcUG2ngSvVU6xBYQkPpTYVZ6V9Mf2FCsGkgzvXnxr	5936	8379	8379	1617447420000	canonical
11559	3NL4KMGE2q5NxAxAMJgvaX71BiChpKpNk37QngAiGFHM13GnYbkW	11558	3NKeNpDM5qTXrYQUk1KacL94CBZSU4FRkbbDBTeiWsFQDuQUTXjj	1673	1368	165	6301	7928	jwPmh7Z27ki5AjA5FkQf6LrQXyCCoXkVPLWQbrGgwamYbGG2WZw	5941	8387	8387	1617448860000	canonical
11562	3NKMVLMPqKSnp6b4CbwPFT9tKetEqxtzDV7rXkWbAP9xqVoSqzRj	11560	3NKFSJYpTuKRNmLzPk8tHZwMdBd3xmynTRmpPduLALf3WxRn9nK9	1631	794	165	6301	7931	jwY833owVtp5B3NeaY85o2KRuPkeeqcZU3bzAMHHLMZaLBJmKAq	5943	8390	8390	1617449400000	canonical
11569	3NLkGfbtt7Zy8zFg78HSBeRzUwyLYzRPrb79y1YGxyS5N2RGVHVf	11568	3NK3N36wt3HZXNRSjiWsUbRbi1H1mzZ8FyXRWCUy6iPvZ5FxwRfm	1534	1317	165	6301	7938	jxP4hVq5sZX5q8Bz9WS9pjyrjRZFZkvN22bRCiPG46zV9Cw5v9E	5947	8395	8395	1617450300000	canonical
11574	3NKKKtsLzvp24Fc4fiRW7Y8WWSGghvkX2mLeRtrUAV31gZkseUmF	11572	3NK4cNW8kny26KuVVM7U1X71sMS9Ppaz4yMZQiJAchS7jqzyTPg3	1579	117	165	6301	7943	jwKME8mJRg1fiCYJXj63ppGyKPj43Y1XmgRkZgftKoYZLtnohiT	5950	8398	8398	1617450840000	orphaned
11582	3NKsjM8QKpLYf83A2vcssh3VBH4XFCAQV2cQNy1FNATQgSuPZJPs	11581	3NKzBkjiJYXRLnoWnpsu8vC9j8rHCk9QwyACwdiWFYFaAxB8di8m	1406	1393	165	6301	7951	jxtcoXvBogAUNk61wtrmGu9d25VW4YCqNgGKemwCEbyLPnHk8VV	5957	8407	8407	1617452460000	canonical
11584	3NK45ebuCBHGDzn5VNnrrZubV1grq3oQDTaES8SaX2bDiRGDHsgx	11582	3NKsjM8QKpLYf83A2vcssh3VBH4XFCAQV2cQNy1FNATQgSuPZJPs	1406	1393	165	6301	7953	jwsEHkazdrRoTu3cjziyjUQYHCZQrdEh975dCfYoAdrCGSaZYwc	5958	8408	8408	1617452640000	orphaned
11591	3NLPCwaxvixmXadoAuyeRZ8YSbYRerFLh7hcBHfjntYS3tZkhNRT	11588	3NKXqsrsDzo4GLs8gGbVw8Rf7agpuVkmSf7GMTK3q2r6SNaYiwWS	1403	786	165	6301	7960	jwxKii1f5HpXyC2SgiNzMFoCLMmgjmJsZRwb79wqcsMTjDo89rq	5962	8412	8412	1617453360000	canonical
11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	11592	3NLRziKyuHDKnWhrq6MkR8LdeLYuyvV3MAn5DTdhtfQpmf6tWDBL	1489	1254	165	6301	7963	jxLUmVDFySB3tgZsiDaUq9qS1RJ9eQXTmuPoRmFL3vFGb1BTsv2	5964	8414	8414	1617453720000	canonical
11597	3NLg9CLE3zLzZGoADAmwEL5b7QLTdUHP8kFt3W5KonSd86BGN5h6	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1426	1364	165	6301	7965	jwUvK8mCyGhXYAj7CoTzrpMezkc6pQif69tZE5NBzJ5eBTbNq1h	5965	8416	8416	1617454080000	orphaned
11607	3NLRMVN5PXpbjG6NpNcX91RaBvBPDkqQxF3cx6tqx88CUeSHrYab	11606	3NLLUGgKi1t2vZvWrRk9vvRzhAg8EqQ4mw9vQEY5Xwu1BGLrYw4g	1607	1348	166	6301	7973	jx4vyNNCkaX532NrzSQbknRPqfCCQC9PwQQiLqseREwGqnZqCk7	5971	8428	8428	1617456240000	orphaned
11610	3NK5X1RvTzKyXbDDKYypWXLoteBVxoQeA93CeNfvEUX4u1bteqf1	11609	3NLKQ95aLbYbFvDMq5e7yuZEqGNwvUGKbjxPs16mkVWDBhrb9Kv8	1529	1070	166	6301	7976	jxsDd6EXJKUL5RJPycpaTvzvdfH5kvZY6xD5Uwum1iQsTnbTxjp	5973	8432	8432	1617456960000	canonical
11611	3NK8fhusfNnzT1VHP1NUXTedhpvPwKsaSQfPGobfwEzRWwN7jDPf	11610	3NK5X1RvTzKyXbDDKYypWXLoteBVxoQeA93CeNfvEUX4u1bteqf1	1509	1074	166	6301	7977	jxaAovessCCdLcScVQcqZ6FkxsQpa5HxREsKXNfayrcm2MXBL3d	5974	8435	8435	1617457500000	canonical
11616	3NLMeQYwqQChz2hK84vWLBuE6LK5PKzbmP9xFxeATLGnFUJypGL8	11614	3NKZaEGVwTRfLsDprMJJM4uGmSebsf4Ss6nAkstg8id7hSt7MBss	596	1060	166	6301	7982	jxfyJBgFr1qed33LFxaXVt5s8DdLdvRWfT5xfCNQJgz1E6y595t	5977	8439	8439	1617458220000	canonical
11619	3NKfMZq5RQ7rQf1ziXXkHKJ4QTCkVETHrZZeWU4JupxHMqFRgAdz	11617	3NKjknW994x4ziAkzY4W9X2vwGtGtpB3AyTkKnQ6fH8YFpHoHqyE	633	1384	166	6301	7985	jxCJirC3k4Zt5BEigv8oLSf9fwCvCgsdMDzDdXtebYnBa5iFrGs	5979	8443	8443	1617458940000	canonical
11624	3NLkoTp6A6YV6nyqMuaURy8MMKTr7xPjCes8hpC9kHJtFLfv5geL	11622	3NLrz1kGjaNEXN8pVFT4gQm5WjUAzG96BgWrTAiko2rvHGDewST3	1406	1393	166	6301	7989	jwmTYuYB2Sy74gutmcPpup69Kz73JufyNnHJenrktF9gP5pATxi	5982	8447	8447	1617459660000	canonical
11625	3NKyyBtmpMKDG3ihbGq61qc5zTQ9iqAEqVMrqmUaepSMf1E1vtxG	11624	3NLkoTp6A6YV6nyqMuaURy8MMKTr7xPjCes8hpC9kHJtFLfv5geL	1513	1379	166	6301	7990	jxXAaagQG2Uv9cLGJq7JXFHrKHw4evYFqKAcNRzS7WcSx2DStUU	5983	8451	8451	1617460380000	canonical
14798	3NL2GRPKojnWmtonVYk55LnpvG1W671gT4WYxvEae2Hw8pKEnhR3	14797	3NLGSzLhdbr1szwKnv5Z2iaZAJTKPVALfoCBj3wcN3uW3wHuZDdX	1672	1285	234	6301	10879	jxRZkJa1H7uLNETkjKrE1ZRiQWPscxWGNNTwD8w3Xu6CXPcLibn	7539	10683	10683	1617862140000	canonical
11547	3NKuundzfRqhZ3Azn85BkCREbXox5T7Zh6hRoyezs2DY5xmvMMmi	11544	3NKPaPrn7zSWK9CUhmpUHac6TZCFLPZwCU5W4UA4i2zgCnTicSgY	1577	1201	165	6301	7916	jwMHH9YBrjkfd7KtT5jfQh4sqRZhyfStwHPuNQwGdeMMawqDatP	5931	8374	8374	1617446520000	orphaned
11549	3NKVb6jfKRAuwBxcXUcBbQiKHcw1u2dSUh8SZpFMvgZVLqwDDofq	11548	3NL6NcYtE6NXLbDtwbGCiz2ir3H3rRp5ah9WsSQi3RmqVgKgeZZD	1602	1369	165	6301	7918	jxWxFg8Facwj5tDDz7kVG9ihxNN5rcLEhTdhTAAJapgCxbU2RxR	5933	8376	8376	1617446880000	canonical
11550	3NKF7ytr5yTfFA7Rsu3z95kXBqRCuWCZrvRhH7pdd9xEQndcRjcc	11549	3NKVb6jfKRAuwBxcXUcBbQiKHcw1u2dSUh8SZpFMvgZVLqwDDofq	1403	824	165	6301	7919	jxDoUAeV7fZ4magEM1vFkPkmhkL56gVH4ex4eaRntBKeLieyemh	5934	8377	8377	1617447060000	canonical
11552	3NKB19tMzbhVmHyV2aqbFH4mB6oyLsVHxpynZ4iyg1SohDjn5Pzu	11550	3NKF7ytr5yTfFA7Rsu3z95kXBqRCuWCZrvRhH7pdd9xEQndcRjcc	1407	1395	165	6301	7921	jwx7sbuzjj42vmZ8AmXsX6HKNt6CsTLwprw24qu4p7a4Az5zUrW	5935	8378	8378	1617447240000	orphaned
11555	3NKxiMb4r9PSfAPnVgnY1qE37pWtsK2MN7syvBnaAsByyuUDVJwX	11553	3NKtWw4hRoEGa2VwbYPy7NSRQSTLuzvxnpcn9GpGtkcEw43fMdC7	1461	1271	165	6301	7924	jwV3wucmtD8pGpavKY6iRE5VQzgP4wTGunFDUKueWr26YZjwdG6	5937	8381	8381	1617447780000	orphaned
11557	3NLp1VkLzdLhMyJuvBPFMSKaGpf7NEvHHbDdiqt2iBHFLch367c7	11556	3NKtjXRbs32dyb4vk2XzTbjPGiLgts46kFpuZ6BYFihkAR8qgdGo	1451	1292	165	6301	7926	jwQS681W9s8Dw7wFpFZkHpqohKL63pHF7mN4fncshxbJfJJ88Lt	5939	8383	8383	1617448140000	canonical
11558	3NKeNpDM5qTXrYQUk1KacL94CBZSU4FRkbbDBTeiWsFQDuQUTXjj	11557	3NLp1VkLzdLhMyJuvBPFMSKaGpf7NEvHHbDdiqt2iBHFLch367c7	1622	1230	165	6301	7927	jwJGBPH2z4bD6dKeHXwYxUUVveiaDsbPrjQNNsYHRtMaH8zzACy	5940	8385	8385	1617448500000	canonical
11561	3NLffmAVEstfV1GW2vGHmS6opCqn3RhEUjtrfThH7U5RkM42JKyF	11560	3NKFSJYpTuKRNmLzPk8tHZwMdBd3xmynTRmpPduLALf3WxRn9nK9	1483	910	165	6301	7930	jwMXiynE2yvJCKCbEPwHVPsbXRBzJD8mQTwsnSZufVvJ77mYvFa	5943	8390	8390	1617449400000	orphaned
11564	3NKpwvRQV2eyayKoow87UDLwKfu6Qxq4asNxrJEyxA9e4PtybFYt	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	1406	1393	165	6301	7933	jxT64e8g9SLnJG14DGLbS7f1dcEegstJkyVYRmqdr6A7Pt8P4wz	5945	8393	8393	1617449940000	orphaned
11568	3NK3N36wt3HZXNRSjiWsUbRbi1H1mzZ8FyXRWCUy6iPvZ5FxwRfm	11565	3NLQw6pg82KEmtCouSttFyezEHUqFPB7RMWjZfMNhAcSkQpK3dwH	1637	815	165	6301	7937	jwfmYyVZL2KPcva7f3iqaRFbpeTmsFwLidX2R9LMEadjW2yUthr	5946	8394	8394	1617450120000	canonical
11571	3NLTowh3NHPndRZe6n8mgCJzdvmQ6NURodjrZbq92nWUC5fqC2nf	11569	3NLkGfbtt7Zy8zFg78HSBeRzUwyLYzRPrb79y1YGxyS5N2RGVHVf	1631	794	165	6301	7940	jxPGmDmLJB97QJkQjMFkvN4gncxAhWescF4eHdmd36iNmFPFp2u	5948	8396	8396	1617450480000	orphaned
11573	3NLDbpV3sC6RNYi7iWMou4qURPsxSeEbJ2fC9UrNGoL8TaJHSErS	11572	3NK4cNW8kny26KuVVM7U1X71sMS9Ppaz4yMZQiJAchS7jqzyTPg3	1649	1383	165	6301	7942	jwNY3SXjsLtJjHgdWLgTgUD5yn4VJnbBoTgoUf25AUrwBepRFH4	5950	8398	8398	1617450840000	canonical
11576	3NKCtz5AgqGC549Hiv3cKuzykrST4tj4ZENFXQQ4RbLuXrgekDJV	11575	3NL8ua9XF41u8yED4YtUVfoC6cppMNsaB6Ts76uKouUXEAQ57ArL	1476	1125	165	6301	7945	jwjRPcRypJq3CrrErw13AKvL7CUtJ4WK4Cx7kFP7uFBfDErbpqn	5952	8401	8401	1617451380000	canonical
11579	3NLqoMRNeqizfqmXLPNt5RYyjxDETzaLMEWfGDMA6FwHcaja1DMW	11578	3NL3EcoGCE5B8VjWerRz88cSUWUd1o8kUX5Ba5pWcrowBqC88jQ7	1407	1395	165	6301	7948	jw9NKfPno8AmC1mZ258jUpBjXoPajisgpiUNXyzorAfi8NXnM1g	5955	8405	8405	1617452100000	canonical
11586	3NL4SKoVhAQu1SXdQm1iUX4VuhQH6E5unwQngsyWvGZVjKvgYkQy	11585	3NLgCU6ZVXFqUzqrEtb1XCgTgg1AHu65zVeSh7wYcsWLm8zHYVf1	1406	1393	165	6301	7955	jwAejpFKyXYxuZSX18qKMmGb2GWav7DfFQnES9JepRMpwpGeEsg	5959	8409	8409	1617452820000	canonical
11589	3NL4XRwmuY7Jb43Ao528aANrAEmuAESFghkHXhFcDMCK23a5Pkpf	11587	3NKiUKD4zBMzzWEpE61sMGUyxShEG3Pzz9aQaMNQwMgvH8vUvXNT	1476	1005	165	6301	7958	jwajt3UJXi2fA2sSxtihd7AFo3YHXSRjKZ6hxiZBuCJiG5venF5	5961	8411	8411	1617453180000	orphaned
11593	3NKcTBiFERPykAm8Nq1MLsmJsTHrpnBp8f3V6hZuwAEtNK1ChuJm	11592	3NLRziKyuHDKnWhrq6MkR8LdeLYuyvV3MAn5DTdhtfQpmf6tWDBL	311	1061	165	6301	7962	jxkGA7esM78dHYAdMXn5zJ2cLgcT7dVAs4gK41MPBgWXEeXHzXb	5964	8414	8414	1617453720000	orphaned
11596	3NKpJkbs3SHvvukJGRSqPqLjrALHMnCpRDu8Wxx7t29shevVWvQS	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1426	1364	165	6301	7965	jwUvK8mCyGhXYAj7CoTzrpMezkc6pQif69tZE5NBzJ5eBTbNq1h	5965	8416	8416	1617454080000	canonical
11601	3NKLkK3wd2egYNUCuqkBZLts73TqBoF3W1nH7yahAQAwJyXMVNDf	11600	3NL5AEXkAF2Pz4mzSRHNFgQdv1goUumr4g9TZNKyq6EY7Zv9rReS	1553	776	166	6301	7967	jxZeMou3k5KUk4j5KBjtF1o4MonzkKyWHH4v5kjGbNKeS3o4oFD	5967	8420	8420	1617454800000	canonical
11603	3NKXmEVJ3xydkW7KmS3tuFBiqjVfsZ9MjhxMbghtabNELwaiCUwS	11601	3NKLkK3wd2egYNUCuqkBZLts73TqBoF3W1nH7yahAQAwJyXMVNDf	1501	1234	166	6301	7969	jwUyQhNF36T282Agh2RdQkN2nWhriTW9fJteTjEo7USbmwTJ49e	5968	8421	8421	1617454980000	canonical
11606	3NLLUGgKi1t2vZvWrRk9vvRzhAg8EqQ4mw9vQEY5Xwu1BGLrYw4g	11605	3NLvAvR3143DdVdBn3WpKaNdw2xbNBxMfKoUXdYuxckMzJP3aQj6	152	1204	166	6301	7972	jxXdBXEQKUhDvKmoSS4s1yqSeah96TrZfueqRv6LuVuAMwhrcmv	5970	8426	8426	1617455880000	canonical
11615	3NKJHtruoL799iQoqJmRL5yBafC5F9cqUBSk5KYjzZhPJTtburdB	11612	3NLRRyhKy9haLorDXXxw4a5agRQkjGET1BywWpMQ8Ns4Qp5D5amw	1589	920	166	6301	7981	jwigKMZFHVvCZoDqTHHniVoakXEi2e8vpvUsV5T1Kn1fYtf28dy	5976	8438	8438	1617458040000	orphaned
11618	3NL68o4ghwuus2NGuQvZkbY4N6Uqubn669NEuEzQrAJfNHEcEfuW	11614	3NKZaEGVwTRfLsDprMJJM4uGmSebsf4Ss6nAkstg8id7hSt7MBss	1419	814	166	6301	7984	jxnQdcFkf1wbUpZxfEcSdRKHaQkGvPJKmStYh3LZpms4v2PMXQU	5977	8440	8440	1617458400000	orphaned
11621	3NLEw4qonPzpbjHL5s8YRyeCmrQvbnuRhnpteeU3Xca4ewE82Wo4	11620	3NKgvhvxZYgLthUf4DUwBk7z1TbcGPH6SqD3U7mGUjcyFbd5j95L	632	1382	166	6301	7987	jxWKA85U1r4U5JtruQDJswnvSHeBVbKix28NbRK7CE6gmM4snyc	5981	8445	8445	1617459300000	orphaned
11632	3NK3Pvk8m9CrF8XDT5KWQ6tPPbTonR8G6AejVLhSeeSUYc11pbw9	11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	1611	1341	166	6301	7997	jwrJzTYMDykuXhf8asfDrvQUTN2XHihCUFqjcystpskA3DhBaJm	5986	8455	8455	1617461100000	orphaned
11633	3NLEXEAtrn5wEkXX73Azyi4An3cThdKWF7A6f3wHsLLjwFBMThtU	11630	3NKxYYHGgrw3DhG3hUzvAPcGjGQ7F3n1ZGrKerakwFDFtU5qSzfx	1458	1077	166	6301	7998	jxQfyKdS7AXVk9vi4GH9EB5CL7X6EQhCwetYEQodCKNX5FD1cWM	5987	8456	8456	1617461280000	canonical
11636	3NKxS9bFbn7B4Yj3yAkwJ3y9C2J2VuT9ueY2oUexCkAnoVeoUDrj	11633	3NLEXEAtrn5wEkXX73Azyi4An3cThdKWF7A6f3wHsLLjwFBMThtU	1541	610	166	6301	8001	jxPbR1Qd2A9PFUh7piYxbuL514X2KY3Ab9ngQyhoiCwkF7aEc6q	5988	8460	8460	1617462000000	canonical
11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1609	967	166	6301	8011	jwnEcr8tK9gfyk4tYHSvzTVFqEoXHaVgakNhj8xb7ZdnCKuNFaF	5992	8465	8465	1617462900000	canonical
11644	3NKkUNuKaHDbjHhRVWTZREa4TMAFDhzeuwfqxN9ahQ7CgY2B5pW8	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1451	1292	166	6301	8009	jwLjMeg7qdNq3HtPwYcTbGf4EcpqQvS99ZwadHhhwXp2cwwjVVa	5992	8465	8465	1617462900000	orphaned
14808	3NKk6cMezV8CPy726X5fuc31rNB1tAeC8EqfQqwpmJuGevK459qp	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1624	1088	234	6301	10887	jxRmEGzRshRAdQfhn4L3Vf5EfciH5bS69AozzAUS84ixwE7bZVH	7544	10690	10690	1617863400000	orphaned
11613	3NLei58q5i8p9AGVMJdPJTfKPEQvLw85vcZuEdarfQTiQDZ2wR9a	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1585	1000	165	6301	7979	jx45fT5fdzMM5UEfqcuF3ABDyx9vyt4yEeAu1sx6ykbqpFaZL4S	5928	8437	8437	1617457860000	orphaned
11570	3NKbPaHK3m6DyaoTMyiJzVDRjhZqFaKsxSAQgeE9YcKe5ag9yTmq	11569	3NLkGfbtt7Zy8zFg78HSBeRzUwyLYzRPrb79y1YGxyS5N2RGVHVf	1613	1103	165	6301	7939	jxBRp6CPctEbA9uTWwtDCzzrcLw7ptXPzhJvsRTgnqoxqJARoeQ	5948	8396	8396	1617450480000	canonical
11575	3NL8ua9XF41u8yED4YtUVfoC6cppMNsaB6Ts76uKouUXEAQ57ArL	11573	3NLDbpV3sC6RNYi7iWMou4qURPsxSeEbJ2fC9UrNGoL8TaJHSErS	1611	975	165	6301	7944	jwRYNpTRtSrAGLR59ufX2RatNcwighzHYxyYkZDSCJpmxdrRy62	5951	8399	8399	1617451020000	canonical
11578	3NL3EcoGCE5B8VjWerRz88cSUWUd1o8kUX5Ba5pWcrowBqC88jQ7	11577	3NKZSwwW2BVqStXadrEDkz1ipaFyunAP65hdKg6X4CgmifDrDddc	1406	1393	165	6301	7947	jwoPkN1zruqRViKktecMNcDcFu5G1fYHTi6J9nb5sHZPeWDTRDE	5954	8404	8404	1617451920000	canonical
11581	3NKzBkjiJYXRLnoWnpsu8vC9j8rHCk9QwyACwdiWFYFaAxB8di8m	11579	3NLqoMRNeqizfqmXLPNt5RYyjxDETzaLMEWfGDMA6FwHcaja1DMW	1509	1320	165	6301	7950	jw7ZjDfN5ApYh5KmumJSBdnoK7XDVDjjYYjnYcUwm4uooiBraji	5956	8406	8406	1617452280000	canonical
11585	3NLgCU6ZVXFqUzqrEtb1XCgTgg1AHu65zVeSh7wYcsWLm8zHYVf1	11582	3NKsjM8QKpLYf83A2vcssh3VBH4XFCAQV2cQNy1FNATQgSuPZJPs	1471	1020	165	6301	7954	jwb7JeMN8EGeLodRgZYB93aLV5evC94aiJ7yG93eDubfb4CP16b	5958	8408	8408	1617452640000	canonical
11588	3NKXqsrsDzo4GLs8gGbVw8Rf7agpuVkmSf7GMTK3q2r6SNaYiwWS	11587	3NKiUKD4zBMzzWEpE61sMGUyxShEG3Pzz9aQaMNQwMgvH8vUvXNT	1473	185	165	6301	7957	jxUbc7CfFKzpGkfhEDd1yw15QPGj6KUUXjnvBFJ4qGDXfUmmxDt	5961	8411	8411	1617453180000	canonical
11590	3NLvh9BZ32wHBeR1N4RJkRBBwFgGCKaWrL1GSKWzkQPz9udfQ2CC	11588	3NKXqsrsDzo4GLs8gGbVw8Rf7agpuVkmSf7GMTK3q2r6SNaYiwWS	1649	1383	165	6301	7959	jxmwnfFNs4sXWigY3XrrLu55v9nedgLaSk5rovQe4NjnTaPwMoe	5962	8412	8412	1617453360000	orphaned
11600	3NL5AEXkAF2Pz4mzSRHNFgQdv1goUumr4g9TZNKyq6EY7Zv9rReS	11596	3NKpJkbs3SHvvukJGRSqPqLjrALHMnCpRDu8Wxx7t29shevVWvQS	1599	1161	166	6301	7966	jwYrNT45J346YLPvihkX8oprde5yRBpTmq1cfhJDpxZocPTB3U6	5966	8418	8418	1617454440000	canonical
11605	3NLvAvR3143DdVdBn3WpKaNdw2xbNBxMfKoUXdYuxckMzJP3aQj6	11603	3NKXmEVJ3xydkW7KmS3tuFBiqjVfsZ9MjhxMbghtabNELwaiCUwS	1406	1393	166	6301	7971	jxzz5dhJH32buy4JN6nhoSjZrX3wdfGooxYoknk7dNBeDjb2j14	5969	8424	8424	1617455520000	canonical
11608	3NLSALLUHZDjusCLi8g6TMTUis5cugUQBkcwsxm2nsdAPTyYMW89	11606	3NLLUGgKi1t2vZvWrRk9vvRzhAg8EqQ4mw9vQEY5Xwu1BGLrYw4g	1602	552	166	6301	7974	jxMEoNVawJ9UvsXttHtp6HfrAow3BeuH8qb5PrBnSGbJC1eZ8sJ	5971	8428	8428	1617456240000	canonical
11609	3NLKQ95aLbYbFvDMq5e7yuZEqGNwvUGKbjxPs16mkVWDBhrb9Kv8	11608	3NLSALLUHZDjusCLi8g6TMTUis5cugUQBkcwsxm2nsdAPTyYMW89	1637	816	166	6301	7975	jxNM6M4xUr9demFaASHrr954ArHzbtUxUfG9nv8B2eisuujFeoF	5972	8431	8431	1617456780000	canonical
11617	3NKjknW994x4ziAkzY4W9X2vwGtGtpB3AyTkKnQ6fH8YFpHoHqyE	11616	3NLMeQYwqQChz2hK84vWLBuE6LK5PKzbmP9xFxeATLGnFUJypGL8	1642	1241	166	6301	7983	jxW3Yz5z2iDK45Novrjt4ygCLZTBNQaSYM1jjDVErZhaezKHCT8	5978	8440	8440	1617458400000	canonical
11620	3NKgvhvxZYgLthUf4DUwBk7z1TbcGPH6SqD3U7mGUjcyFbd5j95L	11619	3NKfMZq5RQ7rQf1ziXXkHKJ4QTCkVETHrZZeWU4JupxHMqFRgAdz	1407	1395	166	6301	7986	jw9MoC7pDJ46zLy4K5aUC3KpyXCCM6UGe5GwnaQqCTFNNaLRL5e	5980	8444	8444	1617459120000	canonical
11623	3NLEAn7EzAz5ayi3ZbNLUPo88kNrbd6MXaFkFtZh4tqd1EbgzwDi	11622	3NLrz1kGjaNEXN8pVFT4gQm5WjUAzG96BgWrTAiko2rvHGDewST3	1407	1395	166	6301	7988	jxZzm1XZiQKaX59u8Fh2MDfkQVQYrJT43cWkcyVz7vRvfdxfBQU	5982	8447	8447	1617459660000	orphaned
11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	1668	1370	166	6301	7992	jwZSoUgWAGzgWT6Rxp2nzAQ6WiTdQtdpabzeVveQA87faYqyNte	5985	8454	8454	1617460920000	canonical
11628	3NKsitUgm8GQ1qneYueSjkDxAmq4dFWnc9xoZprec74CgRcBtqLs	11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	1444	1135	166	6301	7993	jxnPzmXVzYEdz2WuY6VwfZqBnpymTMFNMsYyTes51HRidBcq83Q	5985	8454	8454	1617460920000	orphaned
11630	3NKxYYHGgrw3DhG3hUzvAPcGjGQ7F3n1ZGrKerakwFDFtU5qSzfx	11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	1447	1345	166	6301	7995	jwNJg7FHk2qNFA4saaYneMcJV1FKbfaGx9cihiiy7aaE9wQgfTb	5986	8455	8455	1617461100000	canonical
11642	3NKxTTJGHnZXUK8DsAnUtRRaDaRMLnqF4aKdJCSxpGYDgqSK9pGf	11632	3NK3Pvk8m9CrF8XDT5KWQ6tPPbTonR8G6AejVLhSeeSUYc11pbw9	1451	1292	166	6301	8007	jxhLRaS6eTzxrF2vSLiK19YvZrTH76z5U6AD8T8TFCarBrPraqx	5987	8465	8465	1617462900000	orphaned
11635	3NLp7ewDp4RFjTy6vD2BvjaJfm79MNCxXkcrygUoq5saZheZh44n	11633	3NLEXEAtrn5wEkXX73Azyi4An3cThdKWF7A6f3wHsLLjwFBMThtU	1508	1141	166	6301	8000	jwFoHjebgGZWYWnpvKAGfbQPsqPwri9UEyyH4FdcVzpdortBTwT	5988	8460	8460	1617462000000	orphaned
11637	3NKpCw9DTarE7VhFatwMgbDbMzNYvQpZec9XoHBvJi3XdSnuVunu	11636	3NKxS9bFbn7B4Yj3yAkwJ3y9C2J2VuT9ueY2oUexCkAnoVeoUDrj	1406	1393	166	6301	8002	jxVQ5hQGar1D1jMAgvCdazpY5uBeP6EFnYKoiUtSrcnCQW9YxAq	5989	8461	8461	1617462180000	orphaned
11639	3NLuhko1FTqXQa8A8vvA8thLHjN4jG6JbMBuSv1uQEUveDxL7bJx	11638	3NL5ixrNBYfSq3nfjGHPtRjJ7mwTLe6gxG5zJgn9apbjSFmwftk2	1594	1200	166	6301	8004	jxLj75womHa5abWMmArR6wJvr7Kehu8ZPUbgAk76qRGaNN3cNGU	5990	8462	8462	1617462360000	canonical
11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	11639	3NLuhko1FTqXQa8A8vvA8thLHjN4jG6JbMBuSv1uQEUveDxL7bJx	1649	1017	166	6301	8005	jwPZRKsn2hAsgQaSwEBMbtGRjx1Ga2WJAhe7ZBCirdWqtktqFs1	5991	8464	8464	1617462720000	canonical
11645	3NKCLG86TRcXJtvoF727NKKVLiUaY7h9m6fBecySN4ms2YqDwrVA	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1624	1334	166	6301	8010	jwYLGHmQjFVx65huyo5U5jVYhDgA6dzyVzAhWbZ2oXTambsajgC	5992	8465	8465	1617462900000	orphaned
11650	3NKEqqKVT5CJPqRjuoek4min3rMHCKP4HMAv6gdYXuTEZk1AYypd	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1476	1371	166	6301	8013	jwLQj8LnbaSzV11SeqMWd5cApyvKeKV8rZ9vTiAMDVHZj619BLD	5993	8467	8467	1617463260000	orphaned
11655	3NKnJKWptRuN52Lir8NxvhWjNXf7nrndrM5TLNbZtxc4i3MDL2rL	11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	1631	794	166	6301	8018	jwLXLbsyyiZweXkqkrNTULF8k5wWjWmxUMPrdUTwWranazN8CqB	5994	8468	8468	1617463440000	orphaned
11653	3NLhtz9vfXnpjQJNwRRNBTHxgpPwB55zJW2rbbehmqCNwf8hjf1x	11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	1406	1393	166	6301	8016	jwRMFhpwacCZKtwai7rAZEUfYVVEfZC4pfjqNRcL68EFTAXS5yi	5994	8468	8468	1617463440000	orphaned
11662	3NKG7bg2iZJqQ5eMEagT4wZfmNqeJBDpfUWVhF56fDoZpCY1o9id	11658	3NL6HAYw2aNemD5jNxmtBcdDvzm2r8j4RC2NAfv1dXBBZEBCYMkv	1623	839	166	6301	8025	jxnZaaKqogvEUtQSDYXzHnYydPNd6mTioX6Wcpc7HKPyuiw27Rq	5997	8471	8471	1617463980000	canonical
11660	3NKnkLnUkvZUQXWBaGoqHmVFDh1QUc9xiokmVtdHkE2FUNsNRNwS	11658	3NL6HAYw2aNemD5jNxmtBcdDvzm2r8j4RC2NAfv1dXBBZEBCYMkv	1458	957	166	6301	8023	jxA6Wmk9TLLZesy299CHyhBEpipFdWig6nUgUQvCgBhDUQgtjvD	5997	8471	8471	1617463980000	orphaned
15002	3NKhYBA7GiwiKQbL2MF5EVUjaPJ5k2bYTQwKDbDaLenrGx5khDa1	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	563	1359	235	6301	11066	jwY5irAGFCD3TkDLgqE3N159weyw9kJTuwiAQwP9JgttD6na5yv	7547	10827	10827	1617888060000	orphaned
11631	3NLycTxLyMBazf7NkQr69uJd78cCos3zh6asNvwRH2UwtBxGnCqQ	11627	3NLhJW5EorF5qUELtjSbb6Pd5QRVJ4eKeGXXfcadpWiXK9PiwG5C	1403	782	166	6301	7996	jwVds8N7Gyr9ih4cM7XZovz4e2txdyeYAttkBPuidtLv25STcEe	5986	8455	8455	1617461100000	orphaned
11638	3NL5ixrNBYfSq3nfjGHPtRjJ7mwTLe6gxG5zJgn9apbjSFmwftk2	11636	3NKxS9bFbn7B4Yj3yAkwJ3y9C2J2VuT9ueY2oUexCkAnoVeoUDrj	1407	1395	166	6301	8003	jwmrFfZrnX8Wvc2w8QXM9faxRLbQ6H6oaHVywq2A3w5fbegCsoD	5989	8461	8461	1617462180000	canonical
11641	3NKWr89rZne5PKuQNoFBP7ZHjhvi1bcttfKCWZxrFgsYbDVWDQsm	11639	3NLuhko1FTqXQa8A8vvA8thLHjN4jG6JbMBuSv1uQEUveDxL7bJx	1670	1282	166	6301	8006	jwQE2gKhaLj2aoWTH34jjSvsk9SHFGeU7wk2zMevzE4u3vKcj66	5991	8464	8464	1617462720000	orphaned
11643	3NKVZx7P38FhdFe1pAW8Qd84othfwjjt5iZQVSfUuTC22gnPfrFg	11640	3NLP8DPRmWoS59mfoe7KAu3DAF58iSNK3z78E6UAwxSwnPw8aFXF	1467	1130	166	6301	8008	jwYUe1hVt3GFUkiKZ9uk123KBfhskVS43Fj1AEyYmGCKJihbJSj	5992	8465	8465	1617462900000	orphaned
11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1406	1393	166	6301	8014	jxjhAiTmUZ8UBBDqSTySZ19nZhevGMyYyF616SjrsyC1fuvq5xX	5993	8467	8467	1617463260000	canonical
11648	3NLB55ng7sfkarYFzM115GPoaXA5qzdhh69Hpi8zKamaYqjSn9zq	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1523	1321	166	6301	8012	jwuRjd3RDMFtqhtcYjedAzAwABzdiyV8CPwxGuhAZLo1XiCgUGP	5993	8467	8467	1617463260000	orphaned
11656	3NKwdFDRH8rmpEgckcG7smiPiJzDet3oVtCha7Thb89ghB3d4Zhn	11654	3NLsa7WpUNb7m6xvXq2wSyxcmmwFMP9EAMrMKDu16bMHzkXC7SRN	1483	1276	166	6301	8019	jx92y9gJdA2VfcpjBLoip93A9HuFGsBT1sPwqhr2uoqvEWJ6NGX	5995	8469	8469	1617463620000	canonical
11658	3NL6HAYw2aNemD5jNxmtBcdDvzm2r8j4RC2NAfv1dXBBZEBCYMkv	11656	3NKwdFDRH8rmpEgckcG7smiPiJzDet3oVtCha7Thb89ghB3d4Zhn	1460	523	166	6301	8021	jxFg4Jey9JgBG2TEWznwP8YdaTGvAAMH2ECSa2xSuHeL18ZZPW1	5996	8470	8470	1617463800000	canonical
11670	3NLB5N3J1YRfqwixWGmMiYPMNcRCR6u7as6VAXW8XnXVpubMWhA6	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1407	1395	166	6301	8031	jwJrupFrxrJth2UWR7aTKBthRCeg9tucudb9oahueFTREm64qh7	5999	8477	8477	1617465060000	orphaned
11673	3NKJWhMHnJYforMxWkpsYb477JerqjD2aDgH3jHYaio3RMJFkzoY	11672	3NKXfDdNo4Qs34MgxUVEwKq5gxPgxExLD8aSVU3gasXfxetAZ2Bq	1406	1393	166	6301	8034	jxem7Jw6o8L7JFbcGmKgGggSTRDBWMsL9zBhQiXFgnWGHN19A23	6000	8478	8478	1617465240000	canonical
11675	3NKYQRPcvRzfdxYTve2moiYVdEFHKw3K259MYQZZTA18V85N9b8u	11674	3NLWnzv1geb6JZ9s54qiSe6afSyAmGrjpkgmLeCUVtf7iUhWHG78	1407	1395	167	6301	8036	jy1QBPxQqUJbA2nLjrnBYs1VXK6TxBEq5v4R4tGowNNt3zbzasm	6002	8480	8480	1617465600000	canonical
11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	11680	3NLQ4ZWZWnWK3wE7YtM4zVhVLQbAEEyD33gh5zvdaQ7HKREKySch	1407	1395	167	6301	8042	jxdrboJw7faeK7be2bQeTYr4kRrTQQzryrLwtd87uSUmmgY3TLN	6006	8488	8488	1617467040000	canonical
11682	3NLpsjDnizKyrw3KrCs5BEEsjYSHbmC7mAFpC8kWbhCfgfsJuuPR	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1588	1026	167	6301	8043	jxf949Mwi8aQP2Kcy3cmwvbaF8GzD5PdFomMD7ugiyM7u8unjzA	6007	8492	8492	1617467760000	canonical
11687	3NLnpL84TZMLcNsRYaxSNAFDa1VHFygBYoSkRLc9QRkFstPXTr7X	11682	3NLpsjDnizKyrw3KrCs5BEEsjYSHbmC7mAFpC8kWbhCfgfsJuuPR	1402	852	167	6301	8048	jxArLb9TGq6G8iTgcFXZGFPySFNcN73iu9CQcN18gmz5bweH6ES	6008	8494	8494	1617468120000	orphaned
11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	1622	1356	167	6301	8050	jwsFcC6NqUNbQ6c2fhmUJH45Wc136LpY8f5ZEs7Pi6YKXGiMqjx	6010	8496	8496	1617468480000	canonical
11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	1407	1395	167	6301	8068	jwD9HSj2J8CSoerS2mdhTSqbACStG9ExUaVsryxJBPWmuGUjHFe	6020	8507	8507	1617470460000	canonical
11724	3NLvRJRk7uMeNRJcw37Wr1wqdSfxi9G83ooze5uP92a5RPqq3WDD	11711	3NKkJXoQhjgkHkDj1ZgTkSqMYVmGNRfyN6aJ6H8pr8Zaka5MSBc6	1483	1030	167	6301	8084	jxCuFtjtQu6UVcxej4zQgFuXB4awiFphEctUHv6xJBne7TkBFkP	6023	8514	8514	1617471851738	orphaned
11715	3NKiV74yVymM5EiNHhxmggGcz45SZX8aN98qgjo32AqBUrCLiYCp	11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	1656	1343	167	6301	8074	jwt5HC6R2UfioqevRz1wBvYsfGST6FEqkaX9SWsGNrEC6eP8Gce	6024	8512	8512	1617471360000	canonical
11713	3NKHBzuP7tnH2YVWCNoX9ySKxkinYB8VyPd4BFypG135LXQbhudU	11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	1656	1343	167	6301	8074	jwJjqnsnVAyHVebSpadgQFktjYaqQz92KRbBhcoMdYoGzyyXnMa	6024	8512	8512	1617471360000	orphaned
11731	3NLE3uMrGyfDSpo1kfJZMaGDEPFwnFdko9j96o9fUgxtNhEpa5Lf	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1652	1189	167	6301	8091	jwAyadPvXUShs2KPfW7ToW1191Y1iQVZ3mGuBLQpeN9t8bkmpWo	6029	8517	8517	1617472260000	canonical
11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	11731	3NLE3uMrGyfDSpo1kfJZMaGDEPFwnFdko9j96o9fUgxtNhEpa5Lf	1631	793	167	6301	8093	jwZ5x1AtUz2Ezmmx54QkmKqtHNjK3oN6P9yDSyC4KyJGwKK6Jsg	6030	8518	8518	1617472440000	canonical
11737	3NLEs2kMrrK52VijfYyCAdKCqnEpWyCjRnZogV41JM2FyXaYVb87	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	532	937	167	6301	8095	jw7fCzksG9msi6L5KyGgUE5KjaKw9MxLmu8iQgkgY8bAV55BnDF	6031	8521	8521	1617472980000	orphaned
11740	3NK6osgTCNfZ8UaLVEXVdab3byozYi8XRvdDiZJEnNLqpYZAw5gY	11739	3NKERoZW6X2szR6MNv6JXmf9qHXtTfxStnvBjb5sxzQhfLbW6xi2	1407	1395	167	6301	8098	jwxnx58RoyjExEmgM6fagqsf4TuRQMgLSyKgqMEPXdgsceAeExn	6033	8523	8523	1617473340000	canonical
11750	3NLjVzKJSpBfVCMXrrHgNxvpfmkJtbVUNGfGvETZ3VFeTwrhtRzh	11747	3NLE28NBH2WgwYxGBC7NM8MVX8tTyE1aW9zzmKGJe94UcFVedZTb	1553	776	168	6301	8108	jxcczPSYmZJQA1hh87ooSUKrEUxTaycaz69ij5DQF11QhmpeSBo	6039	8531	8531	1617474780000	canonical
11755	3NLyMerTXCxoaMLCMWRRKcDeuFZ4vdPyAHHBEHNiwSQMaSZa73wk	11754	3NLrBdeL9XfZdcu7iKxvSbJ2ecLeEnFWR5ioPtTjSmugkbkRxTSY	1631	794	168	6301	8113	jxfPZWTNnhnipCCzVxkFrdanMi7Mn8oGuqC1Hh7dvUWRxcGDc3o	6043	8535	8535	1617475500000	canonical
11760	3NKQ7x6YgecSY9hFD4dXLLUuDbJT1rFS6MHNyxmTGJfkUutUvE6p	11758	3NKf5HGtgMHiEaFVhknobQ7WvTNyU7E3v6jdnhqt7Tot6B5fVktV	1405	861	168	6301	8118	jxzcDPRchfBG233EczAYPMP6i2ErmoU6h7TmcjsB6qYFs62LxLu	6046	8540	8540	1617476400000	orphaned
11763	3NKpSWpJ8sqpv2Qugg81DdbqDWtog8TWHtWagkXa7FnjuQoa1yq9	11761	3NL3GEWJFk9FFHhBEKVstUUUCiYV4R5rwBM1tLU1fKLDFfcGHL8X	1631	793	168	6301	8121	jw9tuZbPVA2vDTM8KNBLjh7w2MddiuAyaivBfPtwbN9QP54kgcn	6047	8542	8542	1617476760000	canonical
11768	3NKZgM9o2kfwtz7TKwpGcTvJ2pcuUHspkFkgN387cAyZDZPgY2q1	11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	1513	1379	168	6301	8126	jwr9DiZaR8xYfPALUoumiEpjMv2Ki8xez4SNxjEgMuj6V8efcEy	6050	8546	8546	1617477480000	canonical
11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	11768	3NKZgM9o2kfwtz7TKwpGcTvJ2pcuUHspkFkgN387cAyZDZPgY2q1	1406	1393	168	6301	8128	jwxJCbetKifb4jLGMsLd2kDy3UtoEqzN8cctvvSrtB5wqpe6gZe	6051	8548	8548	1617477840000	canonical
14816	3NKrSnJA2YzWvz5fhHSMCnEPk54V9LXc92to2eKDCtYfLkAqmyQe	14815	3NLqF7SL5hWuyvxFmfdjB9gV37YYWX1qTFCcKGNTzFZJGgLwjZyv	1637	816	235	6301	10894	jwfmo1kf1Kigf1NE91b4T9tFhBTS91moJKVU9oLTsCb6HrxPRDp	7550	10698	10698	1617864840000	canonical
15680	3NLqpaKfXbs9SKDdRFQGX8RSWs5ME3xodx9Q3dWkaRmxY9bCgevF	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1523	1075	252	6301	11695	jxLEreSQzEzqNN4gkYxyzWmp4iLA6jFjLimraJJm4exSQNGzdhC	7978	11294	11294	1617972120000	orphaned
15709	3NKrVvdwYNgg1UzZwfe9mFi1CSmfNPC4T5m8QjUwJyRKh76jb5Mn	15707	3NLJBLw8JBEzKaWk7mBfESdkL2LhiWALhDscK7iCfH9h9m5XLjkp	1588	1392	253	6301	11718	jwKYTqqyYzvPhxFV8bnDj8Qxx5epVTgCMKUB3EFaWtmWqompyzR	7988	11306	11306	1617974280000	orphaned
11716	3NKq5n1Gak2ezbmasEfjQhh4DGqMeFATLAucKin6m4wauQmCBaPT	11508	3NLoYFjzPAiHvMNQpkiGFUzszdT2kecRjMgMQcD75enmaUwfJYRJ	1483	1150	164	6301	8076	jwjgU9JtBGP4HoQCjsd2Tom4iSXKeT7GADZBDJpQSVdvMJeJ3Zy	5913	8512	8512	1617471360000	orphaned
11649	3NKHNXp6uQrzAa4J2x9i8538NMtbFEKeAjbfiXaawtHN21QpnNSt	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1523	1321	166	6301	8012	jw7c4LaMxTxip9qDGd9H2eFNJdyciSr58FX4tE4tvez9TBJYNXh	5993	8467	8467	1617463260000	orphaned
11654	3NLsa7WpUNb7m6xvXq2wSyxcmmwFMP9EAMrMKDu16bMHzkXC7SRN	11651	3NLUtTp1mEK7SH2vedGCXsGXz85FPAYXXU2MuqtmwZtdfTMKVtqe	1596	1237	166	6301	8017	jw9LC5SXoiEkCkorXqfHDeM1gEuKu71zzXN5M1PMRwFjgu5jguo	5994	8468	8468	1617463440000	canonical
11657	3NL5MUyTCBLX7uTHWtBrSiWndV2QdhE3382LeU1yuTTnAPU16DZX	11654	3NLsa7WpUNb7m6xvXq2wSyxcmmwFMP9EAMrMKDu16bMHzkXC7SRN	1536	1067	166	6301	8020	jxUv4thz2oAwhrnJmPnEr6wMHvHh84vvxT4aVdmT4hWL2ppRDyC	5995	8469	8469	1617463620000	orphaned
11659	3NLuJzMVEWwsyMz8oFZ5XNftiSLL9rJDccbUgJW4J29drDBu1SXi	11656	3NKwdFDRH8rmpEgckcG7smiPiJzDet3oVtCha7Thb89ghB3d4Zhn	1594	1326	166	6301	8022	jxCkYQD7VUNo4jeBxRt5FRfu8pgmZhLXLTXxAZBZm87BcFSyEA1	5996	8470	8470	1617463800000	orphaned
11664	3NKJ5pK9rggjPWVEFcifJXA3uqkKNwEsxZSB9PE8wpof5cpqeyYD	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1523	1321	166	6301	8027	jxHLb4WVLamf6jcsuG5BQjqk2BXZnPDHpcYzZSZH1ngKXw8DYnj	5999	8477	8477	1617465060000	orphaned
11667	3NKT4H3QGzFDZxW5bBjdPB5ZnEYmtQ5L3n2htVKNX5Uu5KoC9AyC	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1445	1044	166	6301	8028	jxQJdSHuxA6d45zZ8oHwEdP7KbGJg1L4322S5r5BCb4MjuWXwsB	5999	8477	8477	1617465060000	orphaned
11674	3NLWnzv1geb6JZ9s54qiSe6afSyAmGrjpkgmLeCUVtf7iUhWHG78	11673	3NKJWhMHnJYforMxWkpsYb477JerqjD2aDgH3jHYaio3RMJFkzoY	1536	1067	167	6301	8035	jwaFDGWWTb63yEkLJ1dfWvxW5DvZVkdvcSptVCRcwfnSZFNMybQ	6001	8479	8479	1617465420000	canonical
11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	11675	3NKYQRPcvRzfdxYTve2moiYVdEFHKw3K259MYQZZTA18V85N9b8u	1460	958	167	6301	8037	jwbUpMCCdpr65cH343sMbFgx9kU7pdknHcDgvAXBerTVyWS8sR4	6003	8481	8481	1617465780000	canonical
11683	3NLoDNunfth2i4GskCARzQx7Z9Vx3VKZP94fkAzDv5mLgsDUiAup	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1593	1220	167	6301	8044	jwY29x7twXVHfYs7owBVyrdskPV8U29sWyhdB6nmnegbXR6Vac8	6007	8492	8492	1617467760000	orphaned
11690	3NLFySRYAetLu8QUpM623yrc2KFBbtMHog12dgF93TDeheCJ4bv5	11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	1673	1122	167	6301	8051	jwfcJLxyaPfSvNdod1TsJSUZ4CmbiCqSwSf6hjWi3qMGqxgyVRt	6010	8496	8496	1617468480000	orphaned
11692	3NKLViEw6ynXFxLRGNbXa4t8CGng3PG3B1sxkdXPz2yY1g6TJiyX	11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	1405	1	167	6301	8053	jxdx1AhNT3REhZyVgDjVtsg6aaT8Eu7Q9XyXHJGXbYcsqzSLi8Y	6011	8497	8497	1617468660000	orphaned
11694	3NKT8sV57CLofkvwqP69fTgeU2VGFF1BfCYMK5yuhCa7MmVGrsiA	11693	3NLWksgMViKHt6xHbat1KTgUuuhsNk17VmQBKQ5d7HGCdQwyXL9X	1588	1392	167	6301	8055	jxvC7VDK1HBuoYow1hWxf9bAZ7h1HzWuEiqVHaJG7bBtZEZaBCM	6012	8498	8498	1617468840000	canonical
11697	3NLUzPDTh6NjFMvzngR8A6xTEHvA7fJeboxNWeiJN11kZLDgzWa2	11695	3NLHHQohSNZ6pkjECridW2gKZptn98is3gAUE9RTHgsRbmKm9ia4	152	1330	167	6301	8058	jwwuBmfXATnVzNZ1hRpwisofXdaKWu7BLxMy6FZ54PX4Q3cU8C1	6014	8501	8501	1617469380000	canonical
11699	3NLbYiHnUVgDL7nhXFEbgY5ojSrv5ecuiFLDeBfPiUpU6NpdoVu5	11697	3NLUzPDTh6NjFMvzngR8A6xTEHvA7fJeboxNWeiJN11kZLDgzWa2	1577	961	167	6301	8060	jwkDHzUd3TkaGvxn4DLV3Ma11cqT6XPWJkvQWhgN7ZeSwKZxq2v	6015	8502	8502	1617469560000	orphaned
11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	11703	3NKUMVSTCuKvR66ZK49zhL3MkoBDy6YEWV5rnivJWkym4fRVGW17	1652	1189	167	6301	8065	jx6zm5hJCiSiJ6WT9Ca7HrniN2JGvLUFit6FuH2fbuXgg1TvkJ7	6019	8506	8506	1617470280000	canonical
11711	3NKkJXoQhjgkHkDj1ZgTkSqMYVmGNRfyN6aJ6H8pr8Zaka5MSBc6	11709	3NLvBWNsdeqGj785BDSQH4XR4dBedRzqtEDxewNboVDGYMaXGKfh	1637	815	167	6301	8072	jxK1wgpy5UL1qk2wK8gHzCQVi5D3DoTbHUXxZiBTxtNxuBpm1jG	6022	8510	8510	1617471000000	canonical
11714	3NLUoCTbpooN7kDerBVXCGbbYjtoLfUwJUg9BTR5B4PhWeHmRivg	11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	1483	1150	167	6301	8075	jxcbQddvAhB4HJquCsCE5keG2PDYtJPHyorHXNk8KBq5ce3f18k	6024	8512	8512	1617471360000	orphaned
11718	3NLtPvhyfAscZgtRcxd3yEF32z785YwbC8eGcWASjigYQXgJ6mHq	11715	3NKiV74yVymM5EiNHhxmggGcz45SZX8aN98qgjo32AqBUrCLiYCp	679	679	167	6301	8078	jx3CH4r6RvJWp98zpraHYZbYRSREDEEut4Z4VHE2q2M7AQNQGPG	6025	8513	8513	1617471540000	canonical
11720	3NLbPfDY5r92hswTbSQpPUToYmNWAGLupVuN7iS7o6zHHxf6eAhc	11718	3NLtPvhyfAscZgtRcxd3yEF32z785YwbC8eGcWASjigYQXgJ6mHq	1483	1030	167	6301	8080	jwhEPK22Qt3Y5mMWwhxnKojT7nfea4MnUAxGmv2AwmN4rvYhQid	6026	8514	8514	1617471720000	canonical
11729	3NLS49mqJRifhahiS2BzrBx9a8rhS4vV23FUDye9mxQYi3QaZs47	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1467	1010	167	6301	8089	jwopCuNPvZgqJPvkVDBVKv3vYbR3dTNrXwJnmHCyqjJshohsUzT	6029	8517	8517	1617472260000	orphaned
11734	3NL1PsZVR83aCDUMpjuNkEUzMTye4JdeB9bHiLQUaxC7EKJWEYsZ	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	1405	887	167	6301	8094	jwK8ik5QDZSxgNsfBi1bknzzZam8dBHP4QTEoZk53icn5YyVA2e	6031	8521	8521	1617472980000	canonical
11738	3NKtXn5rwsxKx9qz5LB2qubcmF3cMEA3RQnfCRdfVnR36mmUr4Gc	11734	3NL1PsZVR83aCDUMpjuNkEUzMTye4JdeB9bHiLQUaxC7EKJWEYsZ	641	1336	167	6301	8097	jxnfHhpGsT6w533iC6FkYp3JJ7Wpkz8dkwuXrGz743LoriCmaet	6032	8522	8522	1617473160000	orphaned
11743	3NLJ8LpqB3UXytg1DoQ6Qa8VzChFHRRHnsiwZSTmzx9R5diCh1Q1	11741	3NKsP4qiE7oqdodUiCVGN7CWDXZdqdhsLP64EQFQGsDzwDYLqynL	1490	1028	167	6301	8101	jxttVRtomEBh3KGsEFHKjRrc3ozoTEeGACiRQXaN8c5sXxJQzoD	6035	8525	8525	1617473700000	canonical
11748	3NL5bRYPowr7H3mKT2RpAbg5ecVa6iFXokHBGeKgnyudtGrVDyU9	11746	3NLTbYYQnpNRFZbs99UEeT65ooARdfLXY6n5AxHr6YFm2mPtkasw	1477	1350	168	6301	8106	jxXugAYztBtPSxETrGnxYFbLCATmGofsL1XKo3BAFEJppFiFE4Q	6038	8529	8529	1617474420000	orphaned
11753	3NKNK2du7ofksgCirT126jXjB1cQ6c9UvUa8HCWRuRzmN3DpcQUw	11752	3NLv9mEzCef3PFbVt2ndjvcSrnbRrLPWy9hZ9UgLJHQnipbrycXH	1403	782	168	6301	8111	jxPBJKJhqruCmKSiXLjzUXXFKRuzmjc3GVasokAecZcb6np5UVa	6042	8534	8534	1617475320000	orphaned
11758	3NKf5HGtgMHiEaFVhknobQ7WvTNyU7E3v6jdnhqt7Tot6B5fVktV	11756	3NLXhJvGHx1UtteJDUJXeh4Voz76ELJiaUy5VRJwmgseB71hsSzw	1608	1289	168	6301	8116	jxLAv1uxMYZoaKcemYsUVQP9VgVFRhh9QjCyQHZzij4fX6Zjjj1	6045	8538	8538	1617476040000	canonical
14821	3NKuyxxWPjfkSCyHn6UhH9Z3vrtCfybcMv89VhA9WxxZraivn8GF	14819	3NL5zjBwXRxVLnFpJeSBxVY4WmKnTw36KEJUP4XSJtknBeKgU75i	149	1037	235	6301	10899	jwZ9TCpu9dx7aAqGYVoPsT22xy9uR641xESxpPoQW8NpDwLWuCq	7554	10703	10703	1617865740000	canonical
11672	3NKXfDdNo4Qs34MgxUVEwKq5gxPgxExLD8aSVU3gasXfxetAZ2Bq	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1476	1371	166	6301	8033	jx8Qz5hNnXJnPfJNXZnxmMKdRJqrcqXeFc3ViNa5n5HqCohVr5r	5999	8477	8477	1617465060000	canonical
11666	3NKx84QLiqoR6W32xg9JdgJygQ2QtpC4YbapWeycArPEPi2CNoh8	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1523	1321	166	6301	8027	jwQZHK8PRU9JViazXHnPMVQwoapUMiiQP3twtyU4MffKPW3ejxr	5999	8477	8477	1617465060000	orphaned
11721	3NKnZVaygom1ohNcVCwqsdMPQsJUf8jn3AA3guyEe9JcL8qDFyat	11673	3NKJWhMHnJYforMxWkpsYb477JerqjD2aDgH3jHYaio3RMJFkzoY	1483	1030	166	6301	8081	jxoVbt9QnjnbuecE7KgQo3yXDbWTKYRLMHwHBTZdZ8ScZpvXK3X	6001	8514	8514	1617471720000	orphaned
11677	3NLUEFNQ1eaY9oCf5JftxHuzdDcY2JTWQ4aMZbxUVh8L1XicSvhq	11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	632	1136	167	6301	8038	jx27KtqFDzKMaoyCHmhnmX6pYMe898czNKDzfkiZDtoo6kLrR1g	6004	8483	8483	1617466140000	canonical
11679	3NKVxY7pjEkRecqUNjLM56KbXxwAUWBAwy1kQvcKdhFJUHCRAV8G	11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	1631	794	167	6301	8040	jweg3XAvP5Cu4DvtBosTrsFDszvR23tqKKm6ppe59gZfySyhGMK	6004	8483	8483	1617466140000	orphaned
11678	3NLY1o8mL65WXujpfb3RDFzFLk8mm7UBpMP6CnQpdAHdyKLUL5Pm	11676	3NLKY9s38HqsCNuyTFspRko1XJ52JEJtZXCJXSsMF3BfcFE7oTL9	1406	1393	167	6301	8039	jxJ4vvP2AUrBxc8tTofZ4YSAZstQet5hNei87RdmQDwQPo58n39	6004	8483	8483	1617466140000	orphaned
11680	3NLQ4ZWZWnWK3wE7YtM4zVhVLQbAEEyD33gh5zvdaQ7HKREKySch	11677	3NLUEFNQ1eaY9oCf5JftxHuzdDcY2JTWQ4aMZbxUVh8L1XicSvhq	1577	1327	167	6301	8041	jxLDk7UMRxu6TWq4WHuFg17CixsTRU6Z2KeVs8rhYzm9hdreWts	6005	8486	8486	1617466680000	canonical
11684	3NKVAXJ9vaVeXfKfgjkDoQniH2mq5zN3KPSw1L3EVBtKYdmMEVwz	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1501	1234	167	6301	8045	jxJhsXXFGWWDMWHAHa1ovqPr5u5eKgp2SnEjNahoWmt8hmHGeLo	6007	8492	8492	1617467760000	orphaned
11686	3NKbFoqg2xXNa3t6u2XMD6a49SeZ98vpXii6suwVcz7C4BVkmYQ7	11682	3NLpsjDnizKyrw3KrCs5BEEsjYSHbmC7mAFpC8kWbhCfgfsJuuPR	152	1330	167	6301	8047	jx1dGJ7mUFKwjC28Ns3HSgF4PkkVrsYCzuqmhmd43u12z7LrnZQ	6008	8494	8494	1617468120000	canonical
11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	11686	3NKbFoqg2xXNa3t6u2XMD6a49SeZ98vpXii6suwVcz7C4BVkmYQ7	1483	1276	167	6301	8049	jwLertNiduTd2gS2o7Mzadx7Ztd8PSm3u1CoTGBG1jAQi2wh7Mx	6009	8495	8495	1617468300000	canonical
11691	3NK5DWpksVf9jC7Q4WLixPoP3ycYewwo3Vs8NKJszxYWjjPmDPUz	11688	3NKwsTeXCza1qpKFM6k5pvQzKQBS73PGpRD4wgrNvdPxftKu77HH	1608	1289	167	6301	8052	jwNqFfVt79dW6ULYoNF91GQW75tpMFW6kmmjXpt3YScMU55ZXu8	6010	8496	8496	1617468480000	orphaned
11693	3NLWksgMViKHt6xHbat1KTgUuuhsNk17VmQBKQ5d7HGCdQwyXL9X	11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	1553	776	167	6301	8054	jwBBLjQi1cDifM1dX3dTHiASy2GSrBzf9n2FtKUGd1LdxCJm28S	6011	8497	8497	1617468660000	canonical
11695	3NLHHQohSNZ6pkjECridW2gKZptn98is3gAUE9RTHgsRbmKm9ia4	11694	3NKT8sV57CLofkvwqP69fTgeU2VGFF1BfCYMK5yuhCa7MmVGrsiA	1406	1393	167	6301	8056	jxKAMgnNdvHovAkbnu6gwwwse8PBRV4VaRfy28mQo9EdUuwvpSW	6013	8500	8500	1617469200000	canonical
11700	3NLhqeTih5DQaUvdvqKFW464bpTpCzyCNGPT32fHaVgwij7zfGdm	11698	3NKLC8jAM2D9jfAvNYxUVVzLa4F5WxZ7FtGn46JGcXKswodWDDG3	596	1180	167	6301	8061	jxXSzxDDaqAniGy6j9PGFoKiWVU75XQC8qRMA5AUXD8RS1FDzFN	6016	8503	8503	1617469740000	canonical
11702	3NKBei8VZ2GKYjMeAJuTLBUxHofiFWq3zTzZgrZLLAAVFjJM6NkY	11700	3NLhqeTih5DQaUvdvqKFW464bpTpCzyCNGPT32fHaVgwij7zfGdm	1637	816	167	6301	8063	jwngJ1ZQPTWB5Ug22azSGXPnFnbBZHRbtT9o72fYx8reLP4uLDF	6017	8504	8504	1617469920000	canonical
11705	3NK3ash2vdAT4M6fPRe5nziBTWoymgDCq9RCzwGWn4opKDRcs3NA	11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	1406	1393	167	6301	8066	jwrEykGBiPVAPXJ3UtovhBBhbmJ9ArYN1gyGJkbq9NzCmPf48Jh	6020	8507	8507	1617470460000	orphaned
11709	3NLvBWNsdeqGj785BDSQH4XR4dBedRzqtEDxewNboVDGYMaXGKfh	11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	369	1066	167	6301	8070	jwyVgUA3398yNWSLc3YChfsKKu6qqAwbSaWmYgxnD1P9Lia7QeM	6021	8508	8508	1617470640000	canonical
11712	3NLnMts9Hg9sLVfE7wpdu529sBjqb6GDQCePXnkPjqvbj3VZw7eH	11711	3NKkJXoQhjgkHkDj1ZgTkSqMYVmGNRfyN6aJ6H8pr8Zaka5MSBc6	1668	1244	167	6301	8073	jwHqoLyFV4j3g39KQ5xb8pqvS6Jeqyn87mGzqFiw7ezrp1o58XD	6023	8511	8511	1617471180000	canonical
11719	3NL2cvgDhBNrb9HqMjnyRNZ4UpvwVxSpPopq8dBAcBBstQZyP1b7	11715	3NKiV74yVymM5EiNHhxmggGcz45SZX8aN98qgjo32AqBUrCLiYCp	1506	1127	167	6301	8079	jwhTDXRdCPj25wXG4WNjvDSLHrTap9EmPk6G447HmDfpXu391LY	6025	8513	8513	1617471540000	orphaned
11725	3NKWg1695rsDnoFY2LC6wC2i9ZYo5tjVSSe8mpJ9z48ad6EFBCVz	11720	3NLbPfDY5r92hswTbSQpPUToYmNWAGLupVuN7iS7o6zHHxf6eAhc	1405	873	167	6301	8085	jxa2v5XC2ac3zjkk8iWZTCxB6mJdrwYijudpmg2dDQW1YYmDQRq	6027	8515	8515	1617471900000	canonical
11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	11725	3NKWg1695rsDnoFY2LC6wC2i9ZYo5tjVSSe8mpJ9z48ad6EFBCVz	1601	1142	167	6301	8087	jwyFbsdftHH4dJgbKZgcrtEitVE69VUxxGezRtciQ8gbxXWAVXc	6028	8516	8516	1617472080000	canonical
11730	3NLcGQ3BJ15vBrvshPwi4XCsvULr1pALErAmWWmjm1LeqvowJ7bz	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1403	824	167	6301	8090	jwAC9ciDF28JHEjJpb6P7sW1vGKVC1iwqSK9Us6BtBA9wKqHE8K	6029	8517	8517	1617472260000	orphaned
11735	3NK7Y4YURdpZEGyvGJiAMguJKo2wwfgFtF9agLgvnzRB7ywsEvcy	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	532	937	167	6301	8095	jwi5nNd5jH99aJgEsoMKfjzyYYpgPVFMJmoZWsK4bERFFK6wV1E	6031	8521	8521	1617472980000	orphaned
11739	3NKERoZW6X2szR6MNv6JXmf9qHXtTfxStnvBjb5sxzQhfLbW6xi2	11734	3NL1PsZVR83aCDUMpjuNkEUzMTye4JdeB9bHiLQUaxC7EKJWEYsZ	641	1336	167	6301	8097	jxjfjCE7u1paFU7pFmUj5yx91siMxQvveKumLVUEaiA7qTsZbfr	6032	8522	8522	1617473160000	canonical
11741	3NKsP4qiE7oqdodUiCVGN7CWDXZdqdhsLP64EQFQGsDzwDYLqynL	11740	3NK6osgTCNfZ8UaLVEXVdab3byozYi8XRvdDiZJEnNLqpYZAw5gY	1593	1100	167	6301	8099	jxzBcbYW9TV7xezEsqvsLFKo3fyanc7M5tBMZFGKXKryvB3qAEN	6034	8524	8524	1617473520000	canonical
11744	3NK8HaMYcqeS6VQM69fk2kgPepSUXV77p3cMVjQm4TGTTFFe6vXL	11743	3NLJ8LpqB3UXytg1DoQ6Qa8VzChFHRRHnsiwZSTmzx9R5diCh1Q1	1646	1108	167	6301	8102	jwykZNEvX2ysWhQj6V1TLRc9cVjo1pMNZUymxw7WFpNU8rPpAjL	6036	8527	8527	1617474060000	canonical
11746	3NLTbYYQnpNRFZbs99UEeT65ooARdfLXY6n5AxHr6YFm2mPtkasw	11744	3NK8HaMYcqeS6VQM69fk2kgPepSUXV77p3cMVjQm4TGTTFFe6vXL	1549	1362	168	6301	8104	jy29LZCWaGsULDMZitPdfr6vT2mt5BvWFPX16iBrgSJDcG2uxEm	6037	8528	8528	1617474240000	canonical
11749	3NLDH5GvNaro4wB3VSF88ZPvNaEGQrR2teZEkvTxZW7ev5CpqR9w	11747	3NLE28NBH2WgwYxGBC7NM8MVX8tTyE1aW9zzmKGJe94UcFVedZTb	1461	1271	168	6301	8107	jxGHnv7QvMUNdtigeJTy8JgDMZnsh54MX9L7t6mx1N7r9yNT1cJ	6039	8531	8531	1617474780000	orphaned
11751	3NL661TjLc4U9d8RnwKYxCDP8R1Y9bh4L2gytYcgpvWSKD3kyf3M	11750	3NLjVzKJSpBfVCMXrrHgNxvpfmkJtbVUNGfGvETZ3VFeTwrhtRzh	1407	1395	168	6301	8109	jxfPfXYzrHsYTZJbHqDoqUTpcBb4Ze9o2CBefw3WB5oa3quskVu	6040	8532	8532	1617474960000	canonical
14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	14826	3NKz8Nqoqmb3Lq9cDetkRPcvyX5z7sF5BEtf21Pg9VoXC16XZrV4	1406	1393	235	6301	10905	jwbFTVB5rWCpHaLhiGKHNPyv6xSQ9nkUwozVw8G9v4ywcFiHFTY	7558	10710	10710	1617867000000	canonical
11696	3NLaqXueZicfyQhBKZxgtdr8HwKq88see28mjXaS54zFbWjtrTJv	11694	3NKT8sV57CLofkvwqP69fTgeU2VGFF1BfCYMK5yuhCa7MmVGrsiA	1617	1042	167	6301	8057	jwhv2zspn7bcQa892ig3R6QyDA8ytFmoH1AXNbhwQcUFWJddsyh	6013	8500	8500	1617469200000	orphaned
11698	3NKLC8jAM2D9jfAvNYxUVVzLa4F5WxZ7FtGn46JGcXKswodWDDG3	11697	3NLUzPDTh6NjFMvzngR8A6xTEHvA7fJeboxNWeiJN11kZLDgzWa2	1407	1395	167	6301	8059	jx8SgEmA5BJqk3wp2D8Q7q9qrU8WBi2nM9XVbrDBaPWr8upDGjd	6015	8502	8502	1617469560000	canonical
11701	3NLve95FQnVDZVJFeNLvWhkjfTFyvfeMjJ5zqxLLz19NFkzz7ZEr	11698	3NKLC8jAM2D9jfAvNYxUVVzLa4F5WxZ7FtGn46JGcXKswodWDDG3	1578	1170	167	6301	8062	jxhy1oUszFZyp5J8ozhxcyf5W568iLQLMkU2dxaX1ad74xLd9Ji	6016	8503	8503	1617469740000	orphaned
11703	3NKUMVSTCuKvR66ZK49zhL3MkoBDy6YEWV5rnivJWkym4fRVGW17	11702	3NKBei8VZ2GKYjMeAJuTLBUxHofiFWq3zTzZgrZLLAAVFjJM6NkY	1403	824	167	6301	8064	jwaYeALmwmrmdJ5GKe9984uugWE882CUNSLJ7vqoamW7rp9kHAt	6018	8505	8505	1617470100000	canonical
11706	3NLXRqaCfiZPvcd35GLEGRqy7dXjqdUrZE3LRYkXi5t1vnfrWr4a	11704	3NLk9jAWFirRkS9gKL3ftkzGsFXgYeBrPPKViCiSygV3JcJQfdrS	1507	1280	167	6301	8067	jwR9uGdRQoLZnyBTFyQXZsQniCqEfSQThH7VpYyKA6yaAeptuss	6020	8507	8507	1617470460000	orphaned
11710	3NKar8xEzrd6gQJJfvFe3EBAboT7toCH8KChPQfjHnJ5jHYcaWmw	11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	1406	1393	167	6301	8071	jwtn6x1XiiwZAfSX8HLLs7icinexmqZiU3efcLGwzH828xMhQ4L	6021	8508	8508	1617470640000	orphaned
11726	3NLWY6vZFX7wjcdS5JXNwudajy2PRS8TtbUi7Gwn6x1ZU8nw9qbU	11720	3NLbPfDY5r92hswTbSQpPUToYmNWAGLupVuN7iS7o6zHHxf6eAhc	1467	1376	167	6301	8086	jwpTSawMsMc2BF3GYfSvAabptrrciiYAqqJBiQCQdgjDrdbF37g	6027	8515	8515	1617471900000	orphaned
11728	3NL76cqVYYeu5mSEVahUcqFoB7ajKp4APvcsVf22Wk8JWrFYiBKf	11725	3NKWg1695rsDnoFY2LC6wC2i9ZYo5tjVSSe8mpJ9z48ad6EFBCVz	1513	1013	167	6301	8088	jxdkvbjdm7yFYc6rgj11w7S1qH5k8KQWG9MaWrs5KWJKDSCGRyP	6028	8516	8516	1617472080000	orphaned
11732	3NKBj6LhtRVsoRNkV5sjaVFbG2ftyyykQnxPyGqyTXSMVFaRMAPU	11731	3NLE3uMrGyfDSpo1kfJZMaGDEPFwnFdko9j96o9fUgxtNhEpa5Lf	1406	1393	167	6301	8092	jwT9AqbHY1Cb4Q1pdfbriPszQ3WrffLnyHMBbvkEBCjfUKBDfYt	6030	8518	8518	1617472440000	orphaned
11736	3NKqQJuoeVgr1nFqRgfkJ6LvF5TG9pHMDEqju2ru4UouVTi86mkT	11733	3NK58qnFs5fNPsstcTQ3y8HMTuYuqWN1xfg71NQ8HraaVmg3UAx9	1407	1395	167	6301	8096	jx6k5cdrb6mkbfXnqW37gAYiYHXf7m8iX5Jvzq3bkmzz6ZsNzBU	6031	8521	8521	1617472980000	orphaned
11742	3NKgg8fXvikaprxagepdR7dFaynRwdk6hxVn2mewmg6A2bzRdQB7	11740	3NK6osgTCNfZ8UaLVEXVdab3byozYi8XRvdDiZJEnNLqpYZAw5gY	1406	1393	167	6301	8100	jy28xWxmxAcbtfwMcdrHeJZFgahgDRAviEN9rriZ2aPqbMo4Z47	6034	8524	8524	1617473520000	orphaned
11745	3NL6pM8mERGeScSHp8naep6bcUcskJKLBUAwSw4uc8fbv3BRUTZT	11743	3NLJ8LpqB3UXytg1DoQ6Qa8VzChFHRRHnsiwZSTmzx9R5diCh1Q1	1448	1311	167	6301	8103	jwLFUFWjXc8MRA6vufRjnemL9TF1oxcXdv9tCkuqvnzmShFfo73	6036	8527	8527	1617474060000	orphaned
11747	3NLE28NBH2WgwYxGBC7NM8MVX8tTyE1aW9zzmKGJe94UcFVedZTb	11746	3NLTbYYQnpNRFZbs99UEeT65ooARdfLXY6n5AxHr6YFm2mPtkasw	633	1384	168	6301	8105	jwfhnYeLwdNrxC1XTVaVJjoEXXb1jKkH1iDJmKTR6hY4sYZ3S9R	6038	8529	8529	1617474420000	canonical
11752	3NLv9mEzCef3PFbVt2ndjvcSrnbRrLPWy9hZ9UgLJHQnipbrycXH	11751	3NL661TjLc4U9d8RnwKYxCDP8R1Y9bh4L2gytYcgpvWSKD3kyf3M	1622	990	168	6301	8110	jwa6o5ZgHcNRhJtS19sQSZ5P1HKSJMKc5nDuVCLfuC6xxE3TddQ	6041	8533	8533	1617475140000	canonical
11754	3NLrBdeL9XfZdcu7iKxvSbJ2ecLeEnFWR5ioPtTjSmugkbkRxTSY	11752	3NLv9mEzCef3PFbVt2ndjvcSrnbRrLPWy9hZ9UgLJHQnipbrycXH	1406	1393	168	6301	8112	jwv7WtF2xcWh23v6Z4uSqhKEMCbqHN5cgMpgZeSPbY6WJvAcUdd	6042	8534	8534	1617475320000	canonical
11756	3NLXhJvGHx1UtteJDUJXeh4Voz76ELJiaUy5VRJwmgseB71hsSzw	11755	3NLyMerTXCxoaMLCMWRRKcDeuFZ4vdPyAHHBEHNiwSQMaSZa73wk	1406	1393	168	6301	8114	jwyuLFV22JdkvnJxy3x2azdUHSFQr9vwjyqD2pwBpy2t5tZAKCo	6044	8536	8536	1617475680000	canonical
11757	3NLrgwebp47N2Mn2HYYjbPfCTBB5KZZLVPmktKswCrERr3kEU3SQ	11755	3NLyMerTXCxoaMLCMWRRKcDeuFZ4vdPyAHHBEHNiwSQMaSZa73wk	1476	1125	168	6301	8115	jwGBaxmUJ7CarTSFCsWRgX6NqYYqPJZjU1hyPo4HGznXKkq45W5	6044	8536	8536	1617475680000	orphaned
11759	3NLY3Yu1HY5nwNPBWLsXcuSpTcbNVGUvkTWq3MpdvfsLK5aP3Rs5	11756	3NLXhJvGHx1UtteJDUJXeh4Voz76ELJiaUy5VRJwmgseB71hsSzw	1631	794	168	6301	8117	jx6e829tnwACwDPMTjjM7mUkU3UdRJBnUXbumMJqHdDQ37Wjh63	6045	8538	8538	1617476040000	orphaned
11761	3NL3GEWJFk9FFHhBEKVstUUUCiYV4R5rwBM1tLU1fKLDFfcGHL8X	11758	3NKf5HGtgMHiEaFVhknobQ7WvTNyU7E3v6jdnhqt7Tot6B5fVktV	1564	1092	168	6301	8119	jwwUqg5DpnEH1akP53W6BLFQCoBEAxUFf64z7rc4PfznP9DPS9f	6046	8540	8540	1617476400000	canonical
11762	3NLsJ3vh5kDAss1wCx2MKLuMDz9ByJD1g8kiPWyZxD3T3ix96Yap	11761	3NL3GEWJFk9FFHhBEKVstUUUCiYV4R5rwBM1tLU1fKLDFfcGHL8X	1555	1347	168	6301	8120	jwKg7mKcgLpmgBJ6LCyZUUdx7vELWMovbZ2r5Ctvz2sFQmeb4Yb	6047	8542	8542	1617476760000	orphaned
11764	3NL2ZUBjfq5kLNiDVABMF2mGGjN4HQ5ogYi884S4oE8peie919SF	11763	3NKpSWpJ8sqpv2Qugg81DdbqDWtog8TWHtWagkXa7FnjuQoa1yq9	1426	1118	168	6301	8122	jxQ468PYjyW1L9RRkPwuyAJEUZ85PoTGL7FZ29ReUEJdXKrbXLp	6048	8544	8544	1617477120000	canonical
11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	11764	3NL2ZUBjfq5kLNiDVABMF2mGGjN4HQ5ogYi884S4oE8peie919SF	1670	1156	168	6301	8123	jwbLxiSRVUSWKkVsLphkU14zVAgonaygLXwLUWbigdNxa3pCo3k	6049	8545	8545	1617477300000	canonical
11767	3NLh8ixhmNjmy9kszD9sTBLrjqGAT3tQjpYRLXXTa54LYmB1rU2z	11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	1407	1395	168	6301	8125	jxu93kKcf79Rts3pbstJTUwWdnquVSYat98gmpezvcVFVWryaiU	6050	8546	8546	1617477480000	orphaned
11769	3NLepjWJSg4jpRsc1NxiLZbhkfE68s5JRCvD9zpAH7QvZuJvtY8c	11768	3NKZgM9o2kfwtz7TKwpGcTvJ2pcuUHspkFkgN387cAyZDZPgY2q1	1407	1395	168	6301	8127	jxRLn2MUGoxXDDniJrEbxmG8qWxQrvuUvtpzg1BWBYtzC5eNXYP	6051	8548	8548	1617477840000	orphaned
11772	3NLaaui157vWtCef1WeU9dzmPxtCHzGSxBFcWSw3jyEWbGUECKfM	11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	470	1309	168	6301	8130	jxoWMAAXTshHWJ3nPDNSDqqsg54LPtg5tyZ3JHxNxKGLPpUx4ks	6052	8549	8549	1617478020000	orphaned
11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	11776	3NLf2HyLBkDAKY9ayjFanukqT4Xd8ZVDNUqKUEctY3fGCsB4PirZ	1474	1329	168	6301	8134	jw8PrgLrc8RcTaX3CC4JcmgbZdZWLdzaaEr7tyTcv5hwiM1CcB9	6055	8553	8553	1617478740000	canonical
11779	3NKbbXMtts7uj1b8JdRTqcNtwZMtoTQZcfWX7TGFLsTHLWkGpGKM	11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	1460	958	168	6301	8136	jwbih7U8BWH8Zggak8YZXmr6XVQgp1PWdsRNg5WfEHtvQcAdViP	6056	8554	8554	1617478920000	orphaned
11782	3NKhowUBNF5pJTJHn6MWBgXPcwtcRtLhu5EXYsEmrywtrFBnHoq6	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	1622	1110	168	6301	8139	jxjEMjWF4mMtyze2wgJtxkdfC5Yj3a35mC9Qx2VvssxWf7UKQQR	6057	8555	8555	1617479100000	orphaned
11787	3NK3SUMvQt49yX6YfKKcT1LKCLFSv4ETkUTaPJqkevRJA5yoZo5s	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	532	1177	168	6301	8143	jwE8zGeErieu4GzTgNWikBciWzzMQH6EkpgBt5U3JJ97VcjcN2t	6058	8557	8557	1617479460000	orphaned
14835	3NKoasyXq1Z5LL4AHvn21HMeacvm8RsB1YXTGRVoMsC6Qqi4436v	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1637	816	235	6301	10910	jxCTUkSgDhzmCs2wDuba1SZZWWrjeK2ceT2FTiYQsfaQwdGL3TS	7560	10713	10713	1617867540000	orphaned
11789	3NLARBR6vc9W92D9RmR9Bi6QDM3nyZD58Te9eqe5zWiLunWsL76P	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	42	1115	165	6301	8144	jxapfav7fbkGt16kLkHPfkCzkKYPCy8S9xjpFWKWX8VUwJ7tNYx	5945	8557	8557	1617479460000	orphaned
11766	3NKXh7rjQefAkGasbzE3n4rV6UPhTY13pPoG8778U3nJnWkerEQb	11765	3NKPiU1Tsrqu5UsmYQard4he1WkjG5YTGWKeHhzZhuFRamon8rj3	1474	1203	168	6301	8124	jwfiXxurVXhNaCHGSN7hcQpdjNzpwyYWXmvuXW7Y9EcLRGX11Tn	6050	8546	8546	1617477480000	orphaned
11771	3NLjY6R1dWC2XG3pfkWaSi3Nu2aWt6RfHk398vTckZDsNfgeMSAM	11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	1406	1393	168	6301	8129	jwzrkJKDincW8AxaHUbHsXfbRDpktGnabFuqYYdCJRRSnFzzfRU	6052	8549	8549	1617478020000	canonical
11775	3NLuswMKHCceTFP3ydsz2d4LLFAx8B72RX24cDdVAE6rokmtK992	11771	3NLjY6R1dWC2XG3pfkWaSi3Nu2aWt6RfHk398vTckZDsNfgeMSAM	632	1382	168	6301	8132	jwh2EzekaecrPHiXV8FS95bZyFHRdypsbJcMWtAVjVcP2ZVBjVt	6053	8550	8550	1617478200000	canonical
11776	3NLf2HyLBkDAKY9ayjFanukqT4Xd8ZVDNUqKUEctY3fGCsB4PirZ	11775	3NLuswMKHCceTFP3ydsz2d4LLFAx8B72RX24cDdVAE6rokmtK992	1631	794	168	6301	8133	jxAH3wwXEPvUj399p63tkSD8z4nMUHUa9EhNmsAMegJpnB7gRez	6054	8552	8552	1617478560000	canonical
11778	3NLsf6KBE5vHSAGgMoRgdXCxsj1gv2SHafXANqLgPp6epwenNMNa	11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	1534	1317	168	6301	8135	jwWkLU3u78GFYmXBMEQwSZS6xt2QBSziBopH71nr4aDBzfdMFwn	6056	8554	8554	1617478920000	orphaned
11781	3NKQPi4haNd8mFKvhzi2pbd8AwPQs4VJb9WNtfxiUd8bavEdB22z	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	1668	1370	168	6301	8138	jwraYEjwC5o7crcm5eSDzFiXvzs4zQ4JuY7d4cqWvuB3LqzVtN1	6057	8555	8555	1617479100000	orphaned
11785	3NL2iDCv5d1kshYoDrMJ54xVpcyF9vFkGg3eZGCi9NYc3sSLMBS2	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	1405	867	168	6301	8142	jwCK1V31xkqvEqgLYwhmZj1JdtT8Q9Vx4mRKsDUHjrsfUyFFxvK	6058	8557	8557	1617479460000	canonical
11799	3NLbsaHFpaNnPRFNxQXhss8QPHUzNCEhHucC9EcqdYCMXRu9HrkM	11798	3NKPtbmoUZZpgWb9y2MDdE8xWkqhaUEWyRdsjoiMvR8E43EoWL4E	43	1064	168	6301	8154	jwA51ZJM59WfeuzN7v9CrwAbH6sQkEsgF3BRpH1qbPXtpzsxyb9	6064	8564	8564	1617480720000	canonical
11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	11801	3NK8tgNa8BQ4eKV5KYbWKqhzV8UoAQxp7uiEgW6VjAcAVuauEij4	1501	1360	168	6301	8157	jwDbniKXpKHNUBC4pQLvQwuWTyym2MJGeYnZodE39oT4BqmVpHT	6066	8567	8567	1617481260000	canonical
11805	3NLXyYgQm6UdqAwwfi13opBtsYDtExjRhP3gmRKNvsaecutDSrze	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1523	955	168	6301	8158	jwNWmmFKVv1Txp1nNCgMnNwBrUybTC8eAc7kP4jtaTD8x6anKrn	6067	8568	8568	1617481440000	orphaned
11814	3NLLg7qyEfZzcctPmR4uvBYpnPrg3f3DCGxRQC5pdHVmoNuw1n5b	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	1407	1395	168	6301	8167	jwytFFuzytxoiJzwfnLDNxBscAMLVHFRrXr86s5XUaqvpn5Xk9z	6070	8571	8571	1617481980000	orphaned
11819	3NKD4GMzBWdKERV2stPimjv9WLAuLNMpUg7LoXNtuEfjfqmg92S3	11817	3NLfrtPh9SareLpQqEquVMNziU4Z2ZqUCHT1uXybcxCAUhgjwvsJ	1656	1343	168	6301	8170	jx82K3fXaPVmeT77vJawfyTvVVUjTvsc68WRzNNY6XNwfJBvJwz	6073	8577	8577	1617483060000	orphaned
11821	3NKuRhdNSgfmEdQ1UzpnEQR5FPw7USAvETxRWVJvDPHPx47hme1w	11820	3NL9tme3azTVHfrV1aKrpxuUEQqYSiZWwZLUTnF3nd2yGvjak4XC	1406	1393	169	6301	8172	jwmKE74XGS16L8pQAowAh8RgDVU7GHL7zya9DNae5ynZD29tbRm	6075	8580	8580	1617483600000	canonical
11826	3NLL9Q4twXKnjqv2wUmyXcLezLvuSADa9dQ3vQKPmMnhKkjzJjg6	11824	3NKJypbm14N99L31CBPRwNm2yUQzZcs4dhA23hEj4pCYHmSgWD9b	1610	1068	169	6301	8177	jxk861XQ8GP1fuoHanCTwAw37CnAxwbhuL2eKXTpcVqr18SCqmn	6078	8584	8584	1617484320000	canonical
11829	3NLCKVnVSsJgKXvFJJex9gUhU6Z5qyDE2eA69JFuXyn693T4Pf3x	11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	1594	1326	169	6301	8180	jxCvcViLwuW8UvDkeK4epP8vP6NVHK547tQbAkr9qfgarVBc5Jy	6080	8587	8587	1617484860000	canonical
11833	3NLKDU996CuseidynBm9tMEH92oKhHe5ZxpQpR16Vyor8DsEjmzA	11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	1467	1250	169	6301	8184	jwJ34GBxbNYjSHca1u8ZULyH1Exz9qnTfCM85uroKkdZa2ufr1P	6082	8594	8594	1617486120000	orphaned
11836	3NKhECZsdHVBQQZRkLuXuzJYGspL1EmfqN7nUfqxWciyezQmrfAa	11835	3NLKCGZCXz1QYkcmzMm7UfLgigry3Aw7DqRxtY3dWwxB1W9p6Y32	1529	950	169	6301	8187	jxgsGPmuqKMai3WmiXbBkND3woCHFMMsoo7ESTFSG1hGz25HJRZ	6084	8599	8599	1617487020000	canonical
11841	3NK8Vs4xSpsp9Nv36zCHAZ6XwpvmD7d4vRjqi3TmaTncCgtnL6F8	11840	3NK7RGHyPrP6rtmkgJqhAnDvrd6d1AKdQSnxpuihzdfjrgMBS611	1403	824	169	6301	8192	jwC3JsZ3kxQwnZpi93R9e2LjoxobVZXFtxP5mraNaxJPj6kNmhz	6088	8604	8604	1617487920000	canonical
11846	3NLde3KF4k3QqjBcxZ299paTPB1SL3L9PyhQUogKuiri1oz3GM5G	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1476	1245	169	6301	8197	jwi5ZyxCmB5fGGbknaRgxwR9fZ31Z5QtcAqCqHCx61eNEa9eW3T	6091	8607	8607	1617488460000	orphaned
11853	3NKh88yWe4KaHaAQ9aZE3BU4V72om5xua6QDV5SZtpECKVg8L9aS	11851	3NKeTEyr5S8LGiYSfAgERkyKx8tt8PqCjAgnuUtJr5ufaDj13UaF	596	1060	169	6301	8204	jw7KkN9hNm1JCiHSQtY5tjuLuQeT3hSRetet3jF8ypo6AbzYVQm	6093	8610	8610	1617489000000	canonical
11858	3NLuZDn8P6YiKj3pDde2gXka5P6NfgeXuroEpFqrnux7hUsW3CaU	11856	3NLcRp4VoQ7diShKhXQHjJ1nKgkJgDHmddo5XCyFo8kjAQQ4VfRa	1445	1290	169	6301	8209	jxUQytR5Muf5QDHScQnDuF82fn1xS4ccTDou6XsuG4QhRb6kYQC	6095	8613	8613	1617489540000	orphaned
11860	3NL39gxPzHDKMqxLYfKY5Qt5wmUBEqGMxbyCbeMe8oQNJq5nEzd8	11859	3NKCTg4ZyMcfXMBccontJVAKr51BJeLwBKtFEo8AGLTENvLJX7Dn	1607	1102	169	6301	8210	jwhvBMkS8anV5hg5L4K454jLbRN8obLmWqxBvWxJBx9ssEPPJaZ	6096	8614	8614	1617489720000	orphaned
11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	11863	3NLivNHbVWUSXfFNnwGD93iFFAHkQtKsgbSKWjgWY2jCo8GN1HHi	1406	1393	169	6301	8215	jxo8qi6aNt674S9AEE428m3ymzEcjYP6TvcS8tSmTmKjz131fuY	6098	8617	8617	1617490260000	canonical
11867	3NLsm7UkMawEgihb4VRtrJFhefbw3uriYQWYodmQ98xMECUE1fjY	11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	1649	1257	169	6301	8217	jwwE2LKgjcASELLeaeGReDn3RMJnDViPXbiYwQc3VG61Yw4m4FF	6099	8618	8618	1617490440000	orphaned
11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	11876	3NKoJJcBApFyopjvUouwWdXHHo5kJTz5NRGSM6UKJBM85Ar8MwbV	1406	1393	169	6301	8227	jw8V1QFqvTbXNEWihVCuXC7yBsrjPXJgsnF3AZJhusCfxn4kcn9	6104	8626	8626	1617491880000	canonical
11880	3NKV9ygWApZ47p26eTff2DaR3kkYmTAxE8qE8WfpbCWTxV3Bsf6T	11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	1593	1346	169	6301	8230	jxDdL3h54KrSMxv6vU5gPsvWJsWHhEJUHJQANz1NCL5PyCxe7C9	6105	8627	8627	1617492060000	orphaned
11892	3NK7mdW5bxNULKUPNSCyccT98TCr1FoNujhk7ziqjKztfhmFUrxT	11891	3NKSMiEeQGixYNddoRYrd2SxJD5JRzXCxPUs85Ap6etPUXHh8MJk	1619	1275	170	6301	8241	jwPt6tpuUGoiR3FUD3raF7L5rqHu7XnJQqcTwt6XhSdbRnNsh4A	6112	8637	8637	1617493860000	canonical
11895	3NLDnBxh219VwdW5iq9r1PNFm5jFtH6cVHdJErcnqt9hEd2u9uaM	11893	3NLg6wvu817hbxUmccwVQLGT5VafogRhMkZ7w1irhxKoYs7yiSAi	1546	1339	170	6301	8244	jxpK4Brg8yZK1XkVWWDVd7rE9wUhfaucZEUGKvAxs31sTosKH1V	6114	8641	8641	1617494580000	canonical
14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	80	907	235	6301	10929	jwRWwoLv3z8UTBZbqChoXSBpWifPu4FoA33bMED5jm4ao7pZDy4	7571	10732	10732	1617870960000	orphaned
11823	3NKVZKe8AGUpp7YvZaofUL9WybNk7ypbngS3K5Z7wNd5a5ASWF99	11708	3NLSb4kBdFC3bxSjDmi95H8s8y14GjCH13Bdw9sfrDUghG5Ko2CQ	369	1312	165	6301	8174	jx44EGJTj9jeszpkdj8cNzyvXD1DaKCFkwsYB1FHXKG86JPbtNV	5964	8582	8582	1617483960000	orphaned
11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	171	1374	168	6301	8141	jwkAgxwJjnSKDe6oDqScxszczgFPz6Meekguinc2NrUL68fCDny	6057	8555	8555	1617479100000	canonical
11783	3NL65b6UdcPrWzwzdRxkbkNRcWTwFQ4XRTtjVun4bh9N3Wyjv3ks	11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	1506	1247	168	6301	8140	jwZBCZpTCNxPhnHHYSgMkVvX74VDjnfnTvZRHYhpuiKgpdrLBrk	6057	8555	8555	1617479100000	orphaned
11788	3NKuorYtumcZVJWMNQp2n39nnvX6j28JRD2tjdrrUxDUJvzh9A2q	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	532	1177	168	6301	8143	jxXFt4Dgdy98G9Lt2R8vBrTo22dPGyJKdbKSFxLXvajXnan68FK	6058	8557	8557	1617479460000	orphaned
11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	11790	3NLU6KJVe4FwTcB5SghC7vyKJWcvdK7r7eV77XX9GJSJucE8gSH8	1655	682	168	6301	8146	jxxx9DeGUWMv5fnprjoMLAb4oi5oko5BaKnGJQE4iwQ5U6zGTmr	6060	8560	8560	1617480000000	canonical
11792	3NKUXDW8U5xyg5FQfyEAYUUwJCo885z9xWFnD7td4RgFZW3asCrA	11790	3NLU6KJVe4FwTcB5SghC7vyKJWcvdK7r7eV77XX9GJSJucE8gSH8	1672	1039	168	6301	8147	jxFbKkY488w4menh7u3Eh29t5DSvu1u5VXwW3MghRhcqcofVFyb	6060	8560	8560	1617480000000	orphaned
11794	3NKWBZdBm4TMxcCUBr5tJM7vT89gNfweHTVDNEaJ56fkgD5bVXYA	11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	1407	1395	168	6301	8149	jwPPXC8uqs99D78XsUjCgq8Z1Ukco486hSnh8XbKfR6gRTGvido	6061	8561	8561	1617480180000	canonical
11798	3NKPtbmoUZZpgWb9y2MDdE8xWkqhaUEWyRdsjoiMvR8E43EoWL4E	11797	3NLueF4obDZzkXQrGSVgzHcVJJBfEHWchqVy6oPLNiScjB6H2KPZ	1403	824	168	6301	8153	jxiQraiRD3ifcNe77vSE7XweVtVXsqtT4Cq8YetLZzqTdLSYtn3	6063	8563	8563	1617480540000	canonical
11804	3NLBYtDZkiEz6MQCMz3HcBfb2XfRKQqiZuJjHjxkaH3hjQ7SUCbb	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1523	955	168	6301	8158	jxVm9w3LtKnhpYgt3GhLQXZHFQ8gYSqh7HzG97MZUstA1jccsfu	6067	8568	8568	1617481440000	orphaned
11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	11807	3NLtFX7SEbRKZVZ4fjLxBeEJavhqAnXZpt8e8QvDXW45dTAS2aN7	1444	1255	168	6301	8161	jxjZAoEqehR3kpdYvF8aNPSPtfBjy3CbqG9GbFfYQbWZfkqtcPz	6068	8569	8569	1617481620000	canonical
11811	3NKApMrPaShuvosLwRVzf75kN5sCZyerKo3jvqBZVUc8XPZZNE97	11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	1589	1286	168	6301	8164	jxBdMoboY18cxLZ5bCPqZrGaZJHkfVTLELwtVtDYvckRfTg3vDJ	6069	8570	8570	1617481800000	orphaned
11810	3NLg5BzAHjdkSnTT827V2KF2ofDAbwojbMUwoyxkc79Td6waVU1c	11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	1673	1368	168	6301	8163	jwm5HaRxTzgmioBrkhemavtqxaGJpo9hcuR7aPpRXu5DLVsFKkG	6069	8570	8570	1617481800000	orphaned
11813	3NLLTjhKur3tGqpQxccLhUCXMCuXcyuFFDdTsDZb5j9W5WXyecgL	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	532	1177	168	6301	8166	jxMZZSYdiwGYUYWGEauDRcezwdcPjufk5sj1QPTwXzocLBvAfnw	6070	8571	8571	1617481980000	orphaned
11875	3NKbAjiNzT79UTPbhMrtUW4ojQhThGpzKg8irFcFED6AxXMbPFp7	11812	3NLqbRyKPDhoZh6k6FHCrKxBC6aV4vha72hmNqiKLSSZw5kfdepo	1439	913	168	6301	8225	jwbx4YnWQVrz9jCHRWVp58VpG3jQsNjxSQvrC1Jh1YmADauevby	6071	8625	8625	1617491700000	orphaned
11817	3NLfrtPh9SareLpQqEquVMNziU4Z2ZqUCHT1uXybcxCAUhgjwvsJ	11816	3NLGyhCJouXEQxNtHQyw8WZeD4cSJJSeFgGAk7ig296FSsxM17DY	1406	1393	168	6301	8169	jxV7YWtXMDsUqaYnRn5woU6K8h35XMCKR4CPFTxYaGracazQ3FL	6072	8574	8574	1617482520000	canonical
11818	3NLV6V7RHEBN3VDDQ3YsiYnp2nRkPsR1zk6BSt6yNn5PQsAhCUCu	11817	3NLfrtPh9SareLpQqEquVMNziU4Z2ZqUCHT1uXybcxCAUhgjwvsJ	1656	1343	168	6301	8170	jxbcjFsCJjEm73WBEgLoBCM1obodiPmTRgRTwNTEEkrgiK3VzB2	6073	8577	8577	1617483060000	canonical
11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	11829	3NLCKVnVSsJgKXvFJJex9gUhU6Z5qyDE2eA69JFuXyn693T4Pf3x	43	1310	169	6301	8182	jxVM1tMWiU754yiw5xNLajo3wgTXqsuxbA4s397vAWfPMTvgrVZ	6081	8589	8589	1617485220000	canonical
11832	3NKv9GGpV6uLdTPUQSp4vF2GHBkVUPNfu1dRcdQQ3pGc528YzTLX	11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	1405	861	169	6301	8183	jwcKUKNBarSyn8VyCBKEH953YSynjPpqivsHXn7e5PybwXDWA6c	6082	8594	8594	1617486120000	canonical
11835	3NLKCGZCXz1QYkcmzMm7UfLgigry3Aw7DqRxtY3dWwxB1W9p6Y32	11832	3NKv9GGpV6uLdTPUQSp4vF2GHBkVUPNfu1dRcdQQ3pGc528YzTLX	1406	1393	169	6301	8186	jx5YbDDKUmhgcFNHARiRjquBHX2TQPUxE2Xq7RZJYp6r8ZdyETX	6083	8598	8598	1617486840000	canonical
11838	3NK2uW3FRRtCHGxzNYA5P8vyy5NcxhtnQnxSfQXLuU93tDQuhjKs	11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	58	915	169	6301	8189	jy2F26RH59kjU6g3s2VmiWHbgNVAm4fnwZgoFDkdmbLiamh8g3v	6086	8601	8601	1617487380000	orphaned
11840	3NK7RGHyPrP6rtmkgJqhAnDvrd6d1AKdQSnxpuihzdfjrgMBS611	11839	3NKee1ANVGYro8D3LPzZ1fpQcwaUbk4YcjARdHb6ptpfc2vAFym2	1457	1145	169	6301	8191	jwT6sdX3M6Nj77fddcJB5j1GNe8XwENjSHEmRqpu4rqJbigBT4Q	6087	8602	8602	1617487560000	canonical
11848	3NLFCPoKjGYciQ23oNNumkuRPMJQU9FfQbUnUeXkKgxGAFsZeisX	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1648	1158	169	6301	8199	jwM4YJeVBhkRFuokcRBC7qtzUxiX2REnUHciurKqLyrr9GnaxBr	6091	8607	8607	1617488460000	canonical
11850	3NLkTAoxYsTEDeTT8N2Te9a781UidR2enBLj66Nc7v7woK4wzhPi	11848	3NLFCPoKjGYciQ23oNNumkuRPMJQU9FfQbUnUeXkKgxGAFsZeisX	1445	1044	169	6301	8201	jxwqGvbnfAqJpQXBaso6zTy6ScEdjLfeGmWNLHvzhogJp4NewXK	6092	8609	8609	1617488820000	orphaned
11862	3NLSVygdQzPzLp8ngEQ2xAnVTe9LhG2Vg9FrMg5tGP6UQL9JMTdj	11861	3NKSZRe6pF7FuS3DevnXLsXkBnKKreydjMQtgDmzMDGXKtiUC6Xv	1587	1231	169	6301	8212	jwzPapXfVUTJAUcaDQ6VSiKVdWKRDReDtiNf58EkNz5rRKyAmR3	6097	8616	8616	1617490080000	orphaned
11869	3NLtoyTXzcJB37sN9vXoXfjyJk9GanPuvUYf5uYqjL15WSaD7BBq	11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	1623	839	169	6301	8219	jxTXQK33dbKfhiV9XuZ9v4PzUkYsmGXjKA6vK6Z4WWZet3ApS8k	6099	8618	8618	1617490440000	canonical
11872	3NL5H9RVA599NSaEKwbQCKvyukBhjscXEmK4BhSjH8ntf615nK6R	11870	3NLByEgE7MFqimJNWmcvwm9rpYzpJov3piqn2Qr1jEMCWN1gHcQJ	1406	1393	169	6301	8222	jxDJuqwowGA3LEGyoGYVpXemrb7rvsu3Sngmwwcd4gNthEXsxew	6101	8622	8622	1617491160000	orphaned
11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	1406	1393	169	6301	8231	jwL6pP1yDsSsMR2bGUp3HUuqRJwa3KoQvLUgpFJx2HfkJqqTpHv	6105	8627	8627	1617492060000	canonical
11879	3NKu82MFgNxmeLudhYjNHo8jhtesQjFKVX8SiBK7guSzyZjd3kno	11877	3NKSJvAtNC2o8XuU6oRtdsbbzYrR5BG1WBr8qpRGqwnLmW9XW2Qa	1542	1304	169	6301	8229	jwEUbriFv2G9vpryDgpWhcHqdvTv9SNpxxw8UxJpRZFn8mRuQJi	6105	8627	8627	1617492060000	orphaned
11882	3NLZHfDM4qVCQs2LkrEJ6o1PBFCuDgre7aRv8CQLVTfCLmF59FK2	11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	1619	1275	169	6301	8232	jxk2KpJBER3YitW9mkoc7RhFMVJWMYkdyWWQef9U3DDPYzXWcJD	6106	8631	8631	1617492780000	orphaned
14895	3NKM8k4suhroKxiCJ8Yq7DSGGB2qLUXVYCTtm24tu6hy4EGUY54f	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	606	1295	236	6301	10960	jwYWTLJJU5kKpVBzXUjS1dJLvzj6G1ui16UKf4UJDWGoxr3xbLP	7589	10759	10759	1617875820000	orphaned
11790	3NLU6KJVe4FwTcB5SghC7vyKJWcvdK7r7eV77XX9GJSJucE8gSH8	11785	3NL2iDCv5d1kshYoDrMJ54xVpcyF9vFkGg3eZGCi9NYc3sSLMBS2	1440	1011	168	6301	8145	jwgAtwnXRy9o2XeitfdvV1QvdpUX75GaNvcXE9SJ64e13Wwi174	6059	8558	8558	1617479640000	canonical
11793	3NKPh9BBawkQsL1E25yoCCgV8Di9wbtEB1xBQTmXa2jGaELqo327	11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	1559	1353	168	6301	8148	jxoecKUA7TgzpYAsuKCWxRDoD9ZBeB4oGM5iMVwPuuoWoqGKhAb	6061	8561	8561	1617480180000	orphaned
11797	3NLueF4obDZzkXQrGSVgzHcVJJBfEHWchqVy6oPLNiScjB6H2KPZ	11794	3NKWBZdBm4TMxcCUBr5tJM7vT89gNfweHTVDNEaJ56fkgD5bVXYA	1403	31	168	6301	8152	jwpYsS9xmYu5nswUK8yU7jcYYpSKUcpSDygf2tCG4eoExTnPMVb	6062	8562	8562	1617480360000	canonical
11800	3NLLaoHqNceu1m2uS9PWiTEeqMLD8zQUag3x3eWFUp9NbHtbaadK	11799	3NLbsaHFpaNnPRFNxQXhss8QPHUzNCEhHucC9EcqdYCMXRu9HrkM	1534	1317	168	6301	8155	jwm2xxdU8zbFXGjdraYGDhkUKDHtnBXggdmh6NY5HgiKUEV9bjX	6065	8566	8566	1617481080000	orphaned
11807	3NLtFX7SEbRKZVZ4fjLxBeEJavhqAnXZpt8e8QvDXW45dTAS2aN7	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1477	1350	168	6301	8160	jxEFfL8vBEFEs5FD2rKiArcL5ar84i3Wqg62EFjM4kYh4iSe9fC	6067	8568	8568	1617481440000	canonical
11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	11808	3NLbZT7xhxMmFvhWUM9MdxVUNAr2jPtQYDND3sxQxjSmi8Ntd1xP	115	115	168	6301	8162	jw9fjLHG99WfsW4tou4PLzN5gG7f3gW52nVkKu2x1qvQPnro2LL	6069	8570	8570	1617481800000	canonical
11812	3NLqbRyKPDhoZh6k6FHCrKxBC6aV4vha72hmNqiKLSSZw5kfdepo	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	1668	1370	168	6301	8165	jxhobdmdXseExLi4DFUETbJcr2PhET3UPQT9xfWRwSbvxgVXJfv	6070	8571	8571	1617481980000	canonical
11815	3NLn1UtHkBBLgvtk1oBkwpjW3XKrRs5hbnmJkHnbYB4VoToZfKXs	11809	3NLt2NVxipFLzKtXAJFAGG4QzCBWfe1w8adgmaJ9cR9sQ55zLgGu	532	1177	168	6301	8166	jw83CtCsnSGF3gTaUvq3kyvbcow2sxR1dBUQU6ePBk2voWGjNZk	6070	8571	8571	1617481980000	orphaned
11816	3NLGyhCJouXEQxNtHQyw8WZeD4cSJJSeFgGAk7ig296FSsxM17DY	11812	3NLqbRyKPDhoZh6k6FHCrKxBC6aV4vha72hmNqiKLSSZw5kfdepo	1406	1393	168	6301	8168	jwYfPQytqYKRTfKj6awvEPPqsAbEqWrtcBKf8iKH2Uc2QeoibUJ	6071	8572	8572	1617482160000	canonical
11820	3NL9tme3azTVHfrV1aKrpxuUEQqYSiZWwZLUTnF3nd2yGvjak4XC	11818	3NLV6V7RHEBN3VDDQ3YsiYnp2nRkPsR1zk6BSt6yNn5PQsAhCUCu	365	365	168	6301	8171	jwgN77SCwV3ruuPKMJbr7jgmBFjB2eC9BiwGAYJaZ3PJ6pVqkFG	6074	8578	8578	1617483240000	canonical
11825	3NLJD23RhJrXimsUwM5zyxt5qttQbRbgTgSNS5gSvfPVd9uj7HhD	11822	3NKRctf7DoRejwD1BRYzc1taTkiG43rCfmS9CKKvcf96N4zkjXxW	369	1312	169	6301	8176	jwJ7pRETLDFPQcxjLrKy9qYKvWFKEGM4BKP98gCQm2619tT7i2J	6077	8582	8582	1617483960000	orphaned
11828	3NLKoU2wQLRDsfLr26rSvDcFTPftJPxeBGAESct4Rmtm3dLZ5wav	11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	298	1308	169	6301	8179	jxn9VfGTyjvp9fJ5aoK2JA4FoA3vinNnasKNpeaievoTFvPCdVu	6080	8587	8587	1617484860000	orphaned
11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	11836	3NKhECZsdHVBQQZRkLuXuzJYGspL1EmfqN7nUfqxWciyezQmrfAa	1508	1387	169	6301	8188	jw9ogdELNouh8UZuPmM3UXK5VCuW51okLfM1fiDjeBC5A1mZWQ6	6085	8600	8600	1617487200000	canonical
11852	3NKPDrFGDi1nzWXmuibnCWWgE7jaCXsgQ8su5nvhNxPpV1HLmTJJ	11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	1445	1044	169	6301	8203	jwptFaHke5p1ScPsxthCCLbbGhKFZtSX2MebeYUnP41xmjG2PyU	6086	8609	8609	1617488883603	orphaned
11843	3NLhFSzkn7SArmU1f6QHvkyZGMVUf1NvfBv272bHUeHEotiTt5Hn	11841	3NK8Vs4xSpsp9Nv36zCHAZ6XwpvmD7d4vRjqi3TmaTncCgtnL6F8	1652	949	169	6301	8194	jxZhespZPSEkwMgZhs4iraTnhBY1HvwEVoVDbXyJpc6pCeSdCXa	6089	8605	8605	1617488100000	orphaned
11845	3NLwrQxx73UArq4jAM3PTc3o9TDFFrRP8z53g2AJ85mD41cXyCWA	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1656	1343	169	6301	8196	jxwxmUGsx5ZA3o7XorK5UirwTATgJadN1TMeMVb1v95v8RocXMB	6091	8607	8607	1617488460000	orphaned
11855	3NLM7fHZWmhcSvU9e7TD3X9TkupRmHFYc4FyApqhFV3j7k87qugL	11851	3NKeTEyr5S8LGiYSfAgERkyKx8tt8PqCjAgnuUtJr5ufaDj13UaF	1631	794	169	6301	8206	jxofGAhKznAgajVFy417SWw8tRtHZ2D95izLef9h7BPud4jPLb4	6093	8610	8610	1617489000000	orphaned
11857	3NLnyn9ujRR8SLhDLa6rBujUG66JR6af1xmxVJKJutgZrbudcjhU	11853	3NKh88yWe4KaHaAQ9aZE3BU4V72om5xua6QDV5SZtpECKVg8L9aS	1613	983	169	6301	8208	jwMSo7Ptkc3kXBCcTCxUc5qiMc7jqC9xD5dCjsCHJHXeexxgKLQ	6094	8612	8612	1617489360000	orphaned
11859	3NKCTg4ZyMcfXMBccontJVAKr51BJeLwBKtFEo8AGLTENvLJX7Dn	11856	3NLcRp4VoQ7diShKhXQHjJ1nKgkJgDHmddo5XCyFo8kjAQQ4VfRa	1445	1290	169	6301	8209	jxawyRLZQNZDKWKJffTYj9qUTJkX2D7HHpkbsQwWSzFwQhcNyj4	6095	8613	8613	1617489540000	canonical
11871	3NLW7jFTSJfnYtJpUfAPK2hR1No78qsKu5CmxRHRfq2enhV5N8RB	11870	3NLByEgE7MFqimJNWmcvwm9rpYzpJov3piqn2Qr1jEMCWN1gHcQJ	1610	1068	169	6301	8221	jwLY6SSnCT6DuTFWK6QK4U129L3rp4JpVAwbvSDGgHB147mCRqL	6101	8622	8622	1617491160000	canonical
11874	3NLR5XMpgManuddmwfP9BDXi4ugyLTDYTND2CS3vuXGV2tqC7awb	11873	3NKQNsae7oTkCSdKDUyctxvQFd8tZGkRomDBHBv5re9CbHzdz1KQ	1439	913	169	6301	8224	jwuEQ9XU883XAQF97ZV2eLsBhWdbu6KEFCRQGYENvSfpdbXzr6n	6103	8625	8625	1617491700000	orphaned
11884	3NLj7uxNWyJ3ATJ6AGLaMJBXB7Z2HWo9t4ZGQDZD6ScNCoy5NCcg	11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	1455	1206	170	6301	8233	jwdQobgiQ8CZwpXbZrkwJJs3fUXndzj8fbgdD5hnnBGFSBdLXye	6106	8631	8631	1617492780000	canonical
11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	11885	3NLCmyjqDLs2MWxnXfr17TrfyJbAASBb7C9iFHCKMsvCacm61jjE	1403	782	170	6301	8235	jwUmY2TDDSKJMWHA8Ksk5b2JJSx9UMVwCpRWk4H3oqHa2UDNxkZ	6108	8633	8633	1617493140000	canonical
11888	3NLft7Y6WDV7YHVtep9rg43EehFWvPfNhgwNBz6iwzVygYBEcS6Y	11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	1481	790	170	6301	8237	jxk7MCZHHKzwRC6FqMTByva8KJDNbXCiTzcL6HqYYtbzDs7Wp9C	6109	8634	8634	1617493320000	canonical
11896	3NKomrH8iAyqMfziJsERLB8rHQ1YhJLa4c6mWJMbXaPtgTrLH1sw	11895	3NLDnBxh219VwdW5iq9r1PNFm5jFtH6cVHdJErcnqt9hEd2u9uaM	406	406	170	6301	8245	jxWUt76ePaSRjiTL1H99Bh82U4gPan1Dfy1oN9TGSJVpkEUWEGa	6115	8642	8642	1617494760000	canonical
11900	3NKqykdFAEUQTSLoxWcqGZdS19gSMLPUPBF89yP1DSFTE4hic8kL	11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	1631	793	170	6301	8249	jxVSQZo8Udd1yrNUySYQDnX9apZHPNcfqYevNT4She6oPkbmvXd	6118	8647	8647	1617495660000	orphaned
11902	3NKvuhZzuwLcXd8Zrx61WyAUHrfLvWuz94N3fKJ78KyqmJ2xt2rU	11901	3NKHDmLBGPS2LFe5C1t8UzAntWecbiJKnimv5aQiFTJELU2Yg1tx	1403	824	170	6301	8251	jxaNSUxF9WXt7NB6aP2DHsRN1iJmp86Sdnff21HECD4zmzFZMBs	6120	8650	8650	1617496200000	canonical
11905	3NKyjgp3XpSexYWmke4F5ABNYV3fjqtja4nwzBFTx35xN7ZuDHRr	11904	3NLAUtWvnUR8XyvcVc3aMALR1W2CEytEEufsvbRLtQuGukGZciHN	1631	793	170	6301	8254	jwbo5tkxbF8SJsFVYCy6LNKE4QEVQodzXXi2xABJzUzRGnLjrMT	6122	8652	8652	1617496560000	canonical
11907	3NKbRv1y1UkrqqCpMyymJJKw2ccf658Anqt3emVkDpe8na8EmXVd	11906	3NLjViZ5hLqpi4JsEEgNfzPyguYWWCcn39b2myuhLtXuievc7CUv	1609	1087	170	6301	8256	jxLxq1rNKKLaJv7L4vAncgu2CymDi5B7TjwvXD2A8BSKav9hAZP	6124	8654	8654	1617496920000	canonical
14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	14900	3NLkhH6tAdEoTfi3q8j86HLoU8LApG5DQccbxbC2uQzxvQD1JKUQ	1609	1087	237	6301	10967	jxXB1FNkgvvY5RvdVnNrKZQPvRJbeMfA649WCRfdUJxpaxSHKx7	7592	10762	10762	1617876360000	canonical
11878	3NLGY75wkHzeXm8vmpE7qcz3WSdnjzAtcbUSr297AXya3QS3QSeT	11741	3NKsP4qiE7oqdodUiCVGN7CWDXZdqdhsLP64EQFQGsDzwDYLqynL	1542	1304	167	6301	8228	jwpj1ZqgAcPm7VnzPUQsTRBXVuDcNhJqj9h6yAz7hNtwKXUzET2	6035	8627	8627	1617492060000	orphaned
11854	3NKQvzqVwRt6mpuB86tyR9GW24rGHGiL5ga3wyLjdGhSKdZqXW2F	11806	3NL2YGKfMwDTzg4oBEufKagCq6JpC9E3YzFhpwcDk5s7vAujFDao	596	1060	168	6301	8205	jwY5x7KxynMuz2nSvafieZsLhY2vvRu4obrCV9DEq6qaNmHQXS7	6068	8610	8610	1617489000000	orphaned
11822	3NKRctf7DoRejwD1BRYzc1taTkiG43rCfmS9CKKvcf96N4zkjXxW	11821	3NKuRhdNSgfmEdQ1UzpnEQR5FPw7USAvETxRWVJvDPHPx47hme1w	1402	874	169	6301	8173	jwRJUvQ6ivibWiDDe1G1Je6pizVxhd4TqjpPKQ2omQN5CTHAzwB	6076	8581	8581	1617483780000	canonical
11824	3NKJypbm14N99L31CBPRwNm2yUQzZcs4dhA23hEj4pCYHmSgWD9b	11822	3NKRctf7DoRejwD1BRYzc1taTkiG43rCfmS9CKKvcf96N4zkjXxW	1422	971	169	6301	8175	jxdfhASMB1N8GxWx1M2n7FzhYg9dK7aAMeXSa1wftLM7tuiJtuS	6077	8582	8582	1617483960000	canonical
11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	11826	3NLL9Q4twXKnjqv2wUmyXcLezLvuSADa9dQ3vQKPmMnhKkjzJjg6	1637	816	169	6301	8178	jxweGiJhrC27rxWtunUYDf2xYuqfRnZfz366JKcJBMyYE7TysRY	6079	8585	8585	1617484500000	canonical
11830	3NLU1PDJyJucF3TJS91nbHNPHML4Js8KoeWqc8W8wq8MnWvHVPq4	11827	3NKyRNwmiuTchv3kGbUJwwtkkFCc5TaHcgYBbhsz6ArAottNG1qm	606	1049	169	6301	8181	jxJRsG2eVyhtC4NyowyHAhDXj4VsAE3w7KMHxxmeZ8ReY6UtFtT	6080	8587	8587	1617484860000	orphaned
11834	3NKnv8bTM9ZcDHPYhyBTkLg59XjBA17Cq8V3dW5Uf9hkKahNEsnv	11831	3NKoCxWHMLtZogfbXAxbNzQnS4aAf2gEKWvo1YgpMDyiGzq55SGY	1637	816	169	6301	8185	jxkXuniDcVgCvnSCsiuLVRHm9mhAQPfJASPSGrww8qoWA87rDFu	6082	8594	8594	1617486120000	orphaned
11849	3NLRb6ZbymkMnH8qJzMTqqPs6xvVxqU9XJBb28Mzo52BioQSjqu4	11832	3NKv9GGpV6uLdTPUQSp4vF2GHBkVUPNfu1dRcdQQ3pGc528YzTLX	1445	1044	169	6301	8200	jxZUVHWZAcHkWve3XWQfk7uPza4vPG5uaxcaX7mnockKTfw9MVZ	6083	8609	8609	1617488820000	orphaned
11842	3NLFbYKRTc267peAoUjFCvugtiwkSDzu1W9PiD3B8qQomQTciFne	11841	3NK8Vs4xSpsp9Nv36zCHAZ6XwpvmD7d4vRjqi3TmaTncCgtnL6F8	1490	1274	169	6301	8193	jxYKRprCtShmb3CjsevfkeUzkxb2ZBGKzo63NFCwrWRjaZ67Lyh	6089	8605	8605	1617488100000	canonical
11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	11842	3NLFbYKRTc267peAoUjFCvugtiwkSDzu1W9PiD3B8qQomQTciFne	1403	786	169	6301	8195	jwNxqoEjSu9An7fbGoHUemgyvb2hSApquP4jMM1NrK5cq8uQYMH	6090	8606	8606	1617488280000	canonical
11847	3NKJFXBAs5LrqDWEhPNiuE5uxqUpmnXLy8RZo7ZzhmKLasoAjQNs	11844	3NLSY8LVysigKfGpokK6mdjMPmiPH3VJ6Ka9gA2fd6SBU6epumvA	1489	1380	169	6301	8198	jwrLGYqWsGWxcyyyLDMUPAzWSBsrejSMHLCjx9NAvuBqU1Wnhbh	6091	8607	8607	1617488460000	orphaned
11851	3NKeTEyr5S8LGiYSfAgERkyKx8tt8PqCjAgnuUtJr5ufaDj13UaF	11848	3NLFCPoKjGYciQ23oNNumkuRPMJQU9FfQbUnUeXkKgxGAFsZeisX	684	986	169	6301	8202	jwsonvnEB9RDRxabW7Kb4Y2nA1aqtZPFAEsPLmKDELERcfoWpfx	6092	8609	8609	1617488820000	canonical
11856	3NLcRp4VoQ7diShKhXQHjJ1nKgkJgDHmddo5XCyFo8kjAQQ4VfRa	11853	3NKh88yWe4KaHaAQ9aZE3BU4V72om5xua6QDV5SZtpECKVg8L9aS	58	1035	169	6301	8207	jxtrH7uuqT9KsYJtWjFf7CrbmnynXZ5RQxa9dSEKNKdzWjJwWh4	6094	8612	8612	1617489360000	canonical
11861	3NKSZRe6pF7FuS3DevnXLsXkBnKKreydjMQtgDmzMDGXKtiUC6Xv	11859	3NKCTg4ZyMcfXMBccontJVAKr51BJeLwBKtFEo8AGLTENvLJX7Dn	1553	776	169	6301	8211	jwy69v7CKVNewbwj8UWbGJSQ2oCt5MJjrpXxhYq2NaysTmQx5uF	6096	8614	8614	1617489720000	canonical
11863	3NLivNHbVWUSXfFNnwGD93iFFAHkQtKsgbSKWjgWY2jCo8GN1HHi	11861	3NKSZRe6pF7FuS3DevnXLsXkBnKKreydjMQtgDmzMDGXKtiUC6Xv	1654	1340	169	6301	8213	jxEf1s9tPeUeHzJSMZbgaRYwZHeoyMpwnY5efwuLtg3TXo2gugC	6097	8616	8616	1617490080000	canonical
11866	3NLMZ65ttefAbaaarzSKgc924KzdAZYpDEzzQGuw9Bd5273fJPPW	11863	3NLivNHbVWUSXfFNnwGD93iFFAHkQtKsgbSKWjgWY2jCo8GN1HHi	1561	3	169	6301	8216	jxbSpNXnPkV9UGB9KFeWnCLmgq22nzqzNUSuZyXThwk9kv7Etjx	6098	8617	8617	1617490260000	orphaned
11868	3NL7P5Y1EihkwmfQqgBoAqU6XzwD1qaCNmDpUWJcLFFVBG2Ae4Nm	11865	3NKwYctS2i8TborLVZRH7aLwMYicRigNhUbMsuukTJDv6dapjRS5	1403	824	169	6301	8218	jxrHRjGU9PT2myWEKG48YPZkfcvSiNCbe862KiTkyFypWoKF4tc	6099	8618	8618	1617490440000	orphaned
11870	3NLByEgE7MFqimJNWmcvwm9rpYzpJov3piqn2Qr1jEMCWN1gHcQJ	11869	3NLtoyTXzcJB37sN9vXoXfjyJk9GanPuvUYf5uYqjL15WSaD7BBq	1406	1393	169	6301	8220	jxddZiAn3xWeP4uYx12C4ybVwQrtw3mmPZ8mKHmsNbUNeitsWcu	6100	8619	8619	1617490620000	canonical
11873	3NKQNsae7oTkCSdKDUyctxvQFd8tZGkRomDBHBv5re9CbHzdz1KQ	11871	3NLW7jFTSJfnYtJpUfAPK2hR1No78qsKu5CmxRHRfq2enhV5N8RB	1657	1344	169	6301	8223	jx6rsvoUMnWSEigCHZLyUqHj45oQDskM1CWzXuNr1vZ9VzDy2nv	6102	8624	8624	1617491520000	canonical
11876	3NKoJJcBApFyopjvUouwWdXHHo5kJTz5NRGSM6UKJBM85Ar8MwbV	11873	3NKQNsae7oTkCSdKDUyctxvQFd8tZGkRomDBHBv5re9CbHzdz1KQ	1407	1395	169	6301	8226	jx9u95voafNhurveH2b7sdNGu9x94rjGDXEg6zvPDYdSLtgsEjE	6103	8625	8625	1617491700000	canonical
11883	3NLLS73noAyv2XT4gL3jBrSg6kTPdQNTKSWpd6Sv6EFdJUSuDE5A	11881	3NK77urJXmGEGpCKd7GqXEEMvgd4UWyJPmft1nsp7FxttDTk7etM	1619	1275	170	6301	8232	jwD6tBp8yMhFXFHdd2AhzYqe6TX4yGg5tdck7v47tqsXjV8zF9A	6106	8631	8631	1617492780000	orphaned
11885	3NLCmyjqDLs2MWxnXfr17TrfyJbAASBb7C9iFHCKMsvCacm61jjE	11884	3NLj7uxNWyJ3ATJ6AGLaMJBXB7Z2HWo9t4ZGQDZD6ScNCoy5NCcg	1643	933	170	6301	8234	jxFnTKYJG5y3A5yFmy4mFoWB4GdTeUkK8VpdarqSwFD3B7HeqAo	6107	8632	8632	1617492960000	canonical
11887	3NKHzF7dZNNWbPxfTKU9GipiqYSVELo8kWCxyYe4SYXhtMvs4bsu	11885	3NLCmyjqDLs2MWxnXfr17TrfyJbAASBb7C9iFHCKMsvCacm61jjE	1507	1034	170	6301	8236	jxNS6apQPAAUJu2b6E2qGaftDx6DgdLt7PgYDnnq4CxDrTRydCj	6108	8633	8633	1617493140000	orphaned
11889	3NKkR7ZBM9PqfHzaH9ZDPcFFXK4fHbGzWZ2aKZ1EbHJ3vC6iPjeb	11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	1564	972	170	6301	8238	jwfjscgxuVtL6TjnynVPoWhtqymeiwqq37DopYCqGf4YeSwUgGU	6109	8634	8634	1617493320000	orphaned
11890	3NLEYoysrjbK1L1oAroYFoyK4Z58WuC1x1opKuPZmBmmeR7WVLvF	11888	3NLft7Y6WDV7YHVtep9rg43EehFWvPfNhgwNBz6iwzVygYBEcS6Y	1506	1007	170	6301	8239	jwcCbCURxcEjyMqmnCxj7XWkwHwPXfAqVM5vAqsGGwH8myVtcBK	6110	8635	8635	1617493500000	canonical
11891	3NKSMiEeQGixYNddoRYrd2SxJD5JRzXCxPUs85Ap6etPUXHh8MJk	11890	3NLEYoysrjbK1L1oAroYFoyK4Z58WuC1x1opKuPZmBmmeR7WVLvF	1406	1393	170	6301	8240	jxKYrGnuDsZgRvMi4E62C4tvugBCjMxbgeB7vXkP4fxTuEiniEv	6111	8636	8636	1617493680000	canonical
11897	3NKeD75G5ScPJR3faWpGeQ1WH6GGgMfA9KKt7DTbcv6jW3uz95uZ	11896	3NKomrH8iAyqMfziJsERLB8rHQ1YhJLa4c6mWJMbXaPtgTrLH1sw	576	1355	170	6301	8246	jwWgXmNDMW7wC5KmEVuBwTkS3FrkqNe96tLoARgTEjx8nhUtb2E	6116	8644	8644	1617495120000	canonical
11903	3NLH82pSMqNgfGd1TUTimr7QPFQCAyteZWjV3HxKw6VYXTrNn7zR	11901	3NKHDmLBGPS2LFe5C1t8UzAntWecbiJKnimv5aQiFTJELU2Yg1tx	606	1295	170	6301	8252	jwa3pbJrmbYho1SxLZVN6uMUrfNtVNqXSuM9b11MmtvMMTHBtLJ	6120	8650	8650	1617496200000	orphaned
11908	3NLeNVDg13D4Bypju6Xyn675dAkocsfECLz91TBcjkfK4XAb2J6j	11907	3NKbRv1y1UkrqqCpMyymJJKw2ccf658Anqt3emVkDpe8na8EmXVd	1549	996	170	6301	8257	jx2zjcpNWEVyazARjqUT2V3tjiUfMHAzChCyvhmzXhjvmcpHGGM	6125	8655	8655	1617497100000	canonical
14904	3NKPWf7wJzsZXCFUZotpSpmE4gf1SiXquurM5R9Ex4kEqfYAs9EL	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1460	647	237	6301	10970	jwecUFPWhmB9ffPrr1NoYttnKtNyMBzTaYGDz2ntnWKrSjN5oU5	7593	10763	10763	1617876540000	orphaned
11915	3NLoZMvMty2djY1r2GD4WeS1BgDe734cd9qZBq5ngsdCN9vgMCRV	11724	3NLvRJRk7uMeNRJcw37Wr1wqdSfxi9G83ooze5uP92a5RPqq3WDD	1483	520	167	6301	8264	jxjG2h9SQ5g9tLnqdih8k4CXjGB46C9mwnU9S3UQpvSh1CW7pVo	6024	8660	8660	1617498000000	orphaned
11893	3NLg6wvu817hbxUmccwVQLGT5VafogRhMkZ7w1irhxKoYs7yiSAi	11892	3NK7mdW5bxNULKUPNSCyccT98TCr1FoNujhk7ziqjKztfhmFUrxT	1458	1197	170	6301	8242	jwGgcobdy1WiFvcT41TwBpJReFkhRWfLh7fz8BKHHNJw1BPvLkM	6113	8639	8639	1617494220000	canonical
11899	3NLTJP1FfikK6J8X5amHUbKJ9vW3oi2xBRcH2ERLWgotYigW5Aaz	11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	1649	1383	170	6301	8248	jxRZLwR2nBQ3KJzvwBAnMaC1BUcbv2eZ5UHC4GG6rjYeTyFvN4f	6118	8647	8647	1617495660000	canonical
11901	3NKHDmLBGPS2LFe5C1t8UzAntWecbiJKnimv5aQiFTJELU2Yg1tx	11899	3NLTJP1FfikK6J8X5amHUbKJ9vW3oi2xBRcH2ERLWgotYigW5Aaz	1406	1393	170	6301	8250	jx4vi6SDya3WjHZYKs2FE83QyihMEZjhp4t6xrMaGeHaG4Zg78x	6119	8648	8648	1617495840000	canonical
11904	3NLAUtWvnUR8XyvcVc3aMALR1W2CEytEEufsvbRLtQuGukGZciHN	11902	3NKvuhZzuwLcXd8Zrx61WyAUHrfLvWuz94N3fKJ78KyqmJ2xt2rU	43	1310	170	6301	8253	jxoDiVDxZujYgMFVyFuVKUqe65rJQM1HFmXnGubdmPpYk4BFPhm	6121	8651	8651	1617496380000	canonical
11912	3NLVgYbAxzRSdQDACfKnoem8JijcMv2E84LCHRVKYkbj62xFRVxz	11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	1637	816	170	6301	8261	jx8heanz4f7xhGeThJS2chc71eAKRrjhEVrG9bcrafAbg59VyV8	6128	8658	8658	1617497640000	orphaned
11914	3NLAKR72h99sPXRdVJNqoB3ziq5DsFBQKiXUGvrmqVyLoCXhpGMk	11913	3NKzHpw5vxkZrpaktaSdoZmW5EdzAiKTz2LVd1E4sTsjix7Miqz9	1608	1043	170	6301	8263	jy2doMkg2BftvPSHgg8ifv1jZQa5S6E4anPuWgKzkFjYygY3yhc	6129	8659	8659	1617497820000	canonical
11917	3NKzu5SRegrUw65bVyDamhw6gw2f9fnSBTtFV78e8beq7Ac3CrCV	11914	3NLAKR72h99sPXRdVJNqoB3ziq5DsFBQKiXUGvrmqVyLoCXhpGMk	1483	520	170	6301	8266	jwz1hvcGB5muFa5VV3zsYfJ5326iDMxYY2g1xbPjZmyRz9GhVgn	6130	8660	8660	1617498000000	canonical
11921	3NKQ5aexYBbneJFJMshmWAjydtVAVYZq9hAkDPu1asc7C8KhLYdz	11919	3NLYMQcUh92CCu9LiyNMxA9VQnFRjPgLydPLtbRKVcv6Wb1sPJkA	1500	1297	170	6301	8270	jxQsQC69teDkTvMnCoYhY8eyBZBc4ULRn9A3sm5dk6yvBe9uEGA	6133	8664	8664	1617498720000	canonical
11924	3NKVk1s3cShYBFtXciquA8wKocGkN9YZQZade2rdBpzsuShSdXvd	11923	3NK42XPgzt1LM5PuDmFtcoEhNtA2yT4hMfoaT8u1uyXf99nvQzJy	1406	1393	170	6301	8273	jxX79i9FFTtgk5Ke4KownPQRoyqS1m6CTtXPJHjqCgTUXaHGBVX	6136	8667	8667	1617499260000	canonical
11935	3NKp5hVDRPUG3QwCzjT5kZSwGVX6hgF4gZ9x63fPMhSusLrW86QM	11933	3NKqz8qbhvjs9S3EV9Cz3KwSKPLqzfRKYhRefvREbie93oL8yLNd	1657	1344	170	6301	8284	jwBV3ZWKjBqFFtyavdY2qeUx1Pu9MBKGrNmizALziZjV6iPHCCx	6143	8677	8677	1617501060000	canonical
11937	3NLHhLPoq31Pe86T1b6rDxQYDwHo6D1jAmmowxPvvKZEaDnqvE5W	11935	3NKp5hVDRPUG3QwCzjT5kZSwGVX6hgF4gZ9x63fPMhSusLrW86QM	1405	873	170	6301	8286	jwXpb5kpaaxWC1L4oet8UinnNVZ6EAaEq8VKn29JvhXQ4PmxhwE	6144	8678	8678	1617501240000	canonical
11940	3NLYYhiJexSuaFVrggVAqCwqMsTchwthM6Rd1VCs8qwSzyp9UGfg	11939	3NL2gF22hM2EFDdU3dPf6r9fJx7piGioqnJbsjLS6Pv4JA6VR3Xx	1619	1275	171	6301	8289	jxqDqft4y2ru99cx87W4suTKw212fZRiVTSJgQ3Nr88kWwyJzkv	6147	8682	8682	1617501960000	canonical
11941	3NKnWwFxWxYS8a7JGBF2xLepXGLxxW9J3YfUpJjoN9odsiRFsqcu	11940	3NLYYhiJexSuaFVrggVAqCwqMsTchwthM6Rd1VCs8qwSzyp9UGfg	1403	824	171	6301	8290	jxstbAXoA4pxSfQ9twFW8etAJMEZxzPaERT3R7J1qHLkJ3zp7D3	6148	8686	8686	1617502680000	orphaned
11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	11945	3NLPjmmbaJiR8caF5FRAmLHLGksTtievNbeQvAmrZYbGQ6YJADNp	1407	1395	171	6301	8295	jxwzGvcY12zmrgCzQpHhnNdBQwRGah5A7aQw8pC6LttNt4zrUaj	6151	8689	8689	1617503220000	canonical
11949	3NL8RhToXcKE2o5jmUrvP1JMemf4EMG4DUqc5qHVUGShYdSuzP1r	11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	532	1303	171	6301	8297	jwtmPuRXbew8t8h7VYtMpLfX85w1pt2yrT2QBezPjSJ8hLfykGx	6152	8691	8691	1617503580000	orphaned
11953	3NLgQ9C1DL2d58Z5gLqPvoQgAaMtqvJpCNhmeMkvvUGhaL3aKhnw	11950	3NKZieUrDJk1TRzi3567s6a2sKUuufAr86do82DV1tEXaK4AhZQD	1649	1383	171	6301	8300	jwxHXqeP3sVCveJSGuwp13nWXVSeUM6DqdMkggT5qvDiqWCeRV6	6153	8693	8693	1617503940000	orphaned
11958	3NLW2fQC3VonbCsRM7Dn8775tN8wMa1ZJLNWyeK58VZXN5RwsaSj	11956	3NKPZcsxEhNVAgBXzuWnbqL92UfLTSA3qMwjgAfox41m8s89Mc7j	1406	1393	171	6301	8305	jwzxb4VGCn7d3RbXghpx3NG1sDMw9wjUTkLBHcSk9Sz81vuyVjn	6155	8696	8696	1617504480000	orphaned
11961	3NLTwnZLr3m9HFF5G8vgqTTKGmGiMi7zr1umXF2RFUWG2TvyVJPz	11959	3NLUPf3xgavJszYd4cLwKjXfAGzhktuoezFwaBwgk9FSyVzoHsdA	1560	1291	171	6301	8308	jwjr4rvjPpyh259JxdRnnieZmCGADkjSwpVoMnczcyib1ZLYDZR	6157	8700	8700	1617505200000	orphaned
11963	3NLrajBnjUAzTSppifnEcty453v15kMzKWNBf6MysfMMYj5asPKe	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1670	1156	171	6301	8310	jwXBc8KPG8gAih7FY82MkEQboodA28uiLougNkraRYgTdSExpF6	6158	8701	8701	1617505380000	orphaned
11970	3NKEag4Wk3Qc5MLKPr3RY5dN2Ktji3ZhAXyxj987C6pd1WSzh54p	11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	1651	935	171	6301	8317	jxccbnfsSfnbiKtaLiQDgi7TRjsYcpwVMMyxBoo2rkrwMbct7u4	6160	8704	8704	1617505920000	orphaned
11972	3NK4B6oKCjkUMjr8bSX4jZZM3NzqrxLS9ajoBgATBByLqtiNunMZ	11971	3NKNzNthP2HKqvA1KpLdnSdGiAnmN1yYrHUNhGN3N8hLerDXDd3M	1444	1381	171	6301	8318	jxC2g8R2PSPRdUdkkzbb2aSAs5mu4Cu7iujVfz7q4g5mSvxvJcc	6161	8706	8706	1617506280000	canonical
11982	3NLeQS6UcxVKE9WqS4dS4s5gq1SNggFytnCyiDqxsRXQ5r5joMCf	11981	3NKuUe69bw2D4cAPVaZCNKsPEynwVuwjurcJruFqESDK9RuHG27Z	1588	1392	171	6301	8327	jwJpvfjF2TxkyvTcVUDqf2ejQobmQrcU9Um1bhNYk2p6pfDnY6q	6167	8713	8713	1617507540000	canonical
11984	3NL5oqnfSQjkcVgb5agxzJZYJS1jjQuom9tH5MfUa8dCTEYZVmAa	11982	3NLeQS6UcxVKE9WqS4dS4s5gq1SNggFytnCyiDqxsRXQ5r5joMCf	1406	1393	171	6301	8329	jwx99sY8Dx7HXEXWn1m5XSaToJ5AWUQFc4wfS18eMkb5tdjM2am	6168	8714	8714	1617507720000	canonical
11989	3NKC7nfqRDq53DT7GtA6GgUGLpVQ4QjD6biDtAJE5kJsmRVv3EaB	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1623	839	171	6301	8334	jxQvnLCbGgJ7GNJFjgpiqunUDqAKzAMp6zyVAAvtm4So8QQrEhN	6170	8716	8716	1617508080000	canonical
11991	3NKqYJmtY7hWGJDVpjc8HxdJweEfY3ACbPEiUfzxnp1MR95gB7e9	11989	3NKC7nfqRDq53DT7GtA6GgUGLpVQ4QjD6biDtAJE5kJsmRVv3EaB	576	1229	171	6301	8336	jxi1NSLaApcXhEPnBs8uW315SPaJ26nJscCWfLjNK3yGpdDg1ZJ	6171	8718	8718	1617508440000	canonical
11994	3NLcF9GLdjbtntQGQBaMSfHrCZc69FAR6882SWmJqxJdsKicS2h3	11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	1406	1393	171	6301	8339	jxajWFy3vgrjnyvQDPMr9hS72Gixt8vky7aXr3byKX6GadcDYJW	6173	8720	8720	1617508800000	orphaned
11998	3NLtfNf1jKCUXuW5y5xnNTW3UxAWnTLqy6Vx2LefXZEgVyo6PxNy	11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	686	686	171	6301	8343	jwbTJ55WipKQceLewKRQbaAow1sYHt4RHWJneX1fwkj9MGQxWSD	6174	8721	8721	1617508984364	canonical
11996	3NLQXqPE8eB1or3ADe4B1tVguEWLuuYifim8EqJ3TJCboV2EJYww	11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	1397	838	171	6301	8341	jxwBrxwubcVHcRt1CCWWFbS2HfY7pcjHCRh67CZiWeCcmiZH2sX	6174	8721	8721	1617508980000	orphaned
14921	3NLLDnhhpP3XeX8bwM7XTNEzM5k5qbrZcoXDRHJEAu2FLfMYoAQ6	14917	3NKrtx1G2JsBcG2nSndG9Lvv3VjabvvHwtDZ385o5wXhEhR1cdt7	1553	776	237	6301	10987	jxsWX2ZEYaTtT2xoC226y9b4hytXxBq5BjBsRiwrBd73hMSAhms	7602	10777	10777	1617879060000	orphaned
11952	3NLxwtsp2zFAAs6FptYd5byrNXxWPC68qgCM2iHzacKhftQPDnFK	11934	3NLofsZnCCXEV62aByXNsrQSTPRymBhz9gnuSKZapY8MpWyo5qUR	1593	1346	170	6301	8299	jxejEr4JpcNP2rUvm5Y1cU3qajiMdE1sQSD4tpXdhs37uuCCrVB	6119	8692	8692	1617503760000	orphaned
11906	3NLjViZ5hLqpi4JsEEgNfzPyguYWWCcn39b2myuhLtXuievc7CUv	11905	3NKyjgp3XpSexYWmke4F5ABNYV3fjqtja4nwzBFTx35xN7ZuDHRr	1588	1392	170	6301	8255	jxwyWMM1uJjq54ZJ78Gn9pgKDos1BYuRBAHSEgEMnDrKDuCToof	6123	8653	8653	1617496740000	canonical
12027	3NKqox4ec8fNmWTiJHUkGx48wbwDNNVaLpikeEnP5u9fPS6ng9eZ	11962	3NLLEdVeYRP8ohr8NXeV6BQT9MDZ9pABXbNj2TyyGwkuVWfHp1gw	1422	1211	170	6301	8372	jwvnSSg8RZwcrNgTF7CLEpMF2KhnX6kyaAyj1HorQPuggXkLu7D	6125	8747	8747	1617513660000	orphaned
11909	3NLrBWPcmTR1nQP4969AHwgvHFyzDb21XyYLnyAPPp78PHf4uuPp	11908	3NLeNVDg13D4Bypju6Xyn675dAkocsfECLz91TBcjkfK4XAb2J6j	1631	794	170	6301	8258	jxa612prRVn5VbfRFJDNvMv8uwNDXji4awTxHzC5c8nUG6hfNRz	6126	8656	8656	1617497280000	canonical
11911	3NLtn5T6z9LGR3Xiq2RUoomRc4UjC5Cga1i4jWNY6CeCDCMmffKm	11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	1619	1275	170	6301	8260	jx4Mvtj3UVKzxw9Hqh6m57UvKd5XSm2rjBRTHRR8MVNEnKbU2VZ	6128	8658	8658	1617497640000	orphaned
11916	3NL4jKTFMHC6MDHdLKLgxH2T84BGZGF8DnsYBdGefo9NX8iFBKGF	11914	3NLAKR72h99sPXRdVJNqoB3ziq5DsFBQKiXUGvrmqVyLoCXhpGMk	1444	1255	170	6301	8265	jxfVzWTCVbumoPFgUqX9vafJ6MFSWH6dBvVYGXGisZAwXe6Ew8q	6130	8660	8660	1617498000000	orphaned
11918	3NL2DmonS6tRQDegE2VpEsxKQqsA7ari9U4A3XJsSVeJmwV8ip8W	11917	3NKzu5SRegrUw65bVyDamhw6gw2f9fnSBTtFV78e8beq7Ac3CrCV	1507	1280	170	6301	8267	jwvznNA5CKHHJyvxqEHG6tu22eyM2FxZL2rSHVPY3mmXgWi8t4N	6131	8661	8661	1617498180000	canonical
11923	3NK42XPgzt1LM5PuDmFtcoEhNtA2yT4hMfoaT8u1uyXf99nvQzJy	11922	3NLSssZtrfVoeby2My7xzL9W85a4DmAT3gEJEDJZ9F6VRg4mpe4W	1637	816	170	6301	8272	jwSMxgHHSgTp2vJpyQk4JZWy5Xv1cKFiXjddq5z95Lza4JrqyjM	6135	8666	8666	1617499080000	canonical
11927	3NLRq8jWcqE5FSHu7BPwTZFEj3zFMKTiYkjUBTBBdc7vnWndupED	11926	3NKAqiE1Tkp3nG1eeACXzGvWaYmyVn1MaZ6cpBgEYNMGHr3KxsPL	1599	1041	170	6301	8276	jxcPecfFoQpMUhJkNw7V4tcqVUgZWdshEt6PWQv5xCjfC8dXgNb	6139	8671	8671	1617499980000	canonical
11930	3NKoXDDPDroznKzrgYdKPkbV4Qd5C1hTTP3X39FZgBf6GhypZtNj	11928	3NKQDtEW7unHxeUs2SzcxHteSknFXqsnP4YViSxUnJvuvBW62VTN	1506	1373	170	6301	8279	jwMmJEHNnH2vE6xUndd4kukTv6uRZ49JyYHuy5An9jmBVTCniNT	6141	8675	8675	1617500700000	orphaned
11932	3NKvtnY3e2odmMuFZbmpeJKuDrJwXavNY6tHrxaQBKJnq895Xra1	11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	1607	269	170	6301	8281	jxm7SRRQoETALL378g6juFWyWbzWbf2NCDzpgiqK9U6WzaFLmRa	6142	8676	8676	1617500880000	orphaned
11943	3NLX6b4RkCcWFgUy8PgrixMN23cMu65KpGga44CRdbrP1yQfUhYa	11942	3NLKeYzv5txhfHZDHMmAHwKYSPo3rDwkisnULr3fs7A55eh8bKJC	1619	1029	171	6301	8292	jxvFdLf7ZhaeT6toz7JSkPD7RR6U2JXtRpZ5U81P2yUUNPawFLe	6149	8687	8687	1617502860000	orphaned
11945	3NLPjmmbaJiR8caF5FRAmLHLGksTtievNbeQvAmrZYbGQ6YJADNp	11944	3NLQJ44N43FpJdKoiHoY93bsJ5YnSQGQqFyuYpT1ZUGEJSUwWKbP	1609	1087	171	6301	8294	jxT1PT4j65vpbNtmQaEHH3xC3Ehhkezh9z9MJ8DcrEYphT3f54C	6150	8688	8688	1617503040000	canonical
11948	3NKmG6BRCFWSKeUMP8kiQiZv6HS3TbShqqNy6xmmyfRGjeWxYDBM	11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	532	1303	171	6301	8297	jx8UbxRJrxV6v9oAyxAT4ty8ub84Cr1wbmpMSrmRcM2HeJhePRJ	6152	8691	8691	1617503580000	orphaned
11955	3NKrimRpkQn4QqA11zJ6LjEWqn1F2D7TcewJP1mm8CQobYXpXCgY	11954	3NKLMfD9MnxFCdbfZ6izw6RakcJ3xVdYwgY5W6L9jvjDUgnHe9WW	1610	1314	171	6301	8302	jwUjsz6QRaPXmVkShXXiDedh5pUzN7trw9scZ21FRJcJxaMEdLw	6154	8695	8695	1617504300000	orphaned
11957	3NLpwFN8pkhz1C74XNiwWFgYMRinGZrFtsUyh1jQcj7i2ojcKYrq	11956	3NKPZcsxEhNVAgBXzuWnbqL92UfLTSA3qMwjgAfox41m8s89Mc7j	1403	824	171	6301	8304	jwFHgQKhe8Aaf87RiyqFCD5pE5f2VUSxrkUhXK6mQvBmPrUF9kF	6155	8696	8696	1617504480000	canonical
11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	11959	3NLUPf3xgavJszYd4cLwKjXfAGzhktuoezFwaBwgk9FSyVzoHsdA	1549	1116	171	6301	8307	jxTUn9boLdnwCjH1hqgHb5iFW1ewZ7MXYohqncwsjqEVduDF3J3	6157	8700	8700	1617505200000	canonical
11967	3NLXLEgJJB7c9eeGvwdhhmTruzBsfauunijUoWmX6yuN8XpqoR6V	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1406	1393	171	6301	8314	jwYYEBG4pHnQ4EyDXhW2DjH1xXxjFmCScNvxaytLEPs6KoMzHbS	6158	8701	8701	1617505380000	canonical
11965	3NLkUhcccmtV17w4x4KpHwUJw3nijovRfcdrKDTsRjtcg4d1ZJRC	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1672	1285	171	6301	8312	jxvGpm8UFgeWKUZHFYW1zaFj6gyfmyFW71KutXki4FkoYzwdrCS	6158	8701	8701	1617505380000	orphaned
11969	3NKkujAAGEg32vVPGjbpGkDQY691NuwmeRRm55nE6rpcEfZH94yq	11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	1403	31	171	6301	8316	jxXiz1MpZHKARDWJV9mQviPK6HWVNtWBMEqV16vMJFj8Gzibitp	6160	8704	8704	1617505920000	orphaned
11978	3NK6rK9V7TVZdEXLwaV1uFqfysGYikTYPUV4Pj8KzPv24AkpLYSq	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	1651	1301	171	6301	8323	jwxm8mPsBfLuSiMZNFbLukBBRc9YHrta1WFZEiefn9ufo124ExU	6164	8710	8710	1617507000000	orphaned
11979	3NLeL4soGwLkK37bQ4Uy2J6axwQxUsAQ5XrFc7kcPi4sJ93VdwjM	11976	3NKoKkwQa6dSczpTnurza4eR7v4eRX9cgz8GrrFRdEmSoMGTr6RL	607	607	171	6301	8324	jwd5R5Kxi5EyFy8cMgEVHmpLsbYg7Z9hq84ZvqFEWnvqGrf3gem	6165	8711	8711	1617507180000	canonical
11986	3NLXszToZENoiRUAMvsvDX6YJb1sXAAPpjqEyPkrWEYsBgsc39Ys	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1448	945	171	6301	8331	jxnvrGXVDmZnwREoxzxVry33hTPg2opw9pFbUDZVdowXF3t4WXN	6170	8716	8716	1617508080000	orphaned
11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	1637	816	171	6301	8338	jwsrsP3emqQ1rznjPjFddzAkxtzkzn8AGqimWAnXoa95vwBVu4n	6173	8720	8720	1617508800000	canonical
12000	3NLAZHHPjYT5RJq54EH1sNTa89La2PxnLiPiUny2m3DE8bVeudvv	11999	3NL1BN3oA8aeVQveq6CE9i1nskPRzfkDPPooAk4X2UXwk9rUDB6a	1522	1322	171	6301	8345	jxyu7wVrc6KNjyY5Mj7sKngN5Ytr2ZUdAGiZyPeQvbbgN5YwgX2	6176	8723	8723	1617509340000	orphaned
12002	3NKep4D3gGjhcRqjeyP2C7zYzjpGdz9Vwo8JRWzhMgMkdsyx4TZU	12001	3NLA15WHuWxWFZTMcrYvLYgSPcPpWmSnbT3LmpWXEQaHVThcfQjY	470	1063	171	6301	8347	jx7bAcTpBnTgkUDs1cBKkhUToJSAZ88BC4fgJ8MB8h7mfTTxEYF	6177	8724	8724	1617509520000	canonical
12010	3NLpMFrGq9Hb4YmptAy8drkdDcxeggBVhATeafEi7hPeLsPqy26b	12008	3NKZe4u1NPTHvUfhKnmzptqoCvY6i915iXW8PfC8XVnhdwpNQJkT	1406	1393	172	6301	8355	jxdii97zmrdTVg7osYbcnvxqgMWSfppJWaPkmgNKBJ3VFfMwe5o	6181	8731	8731	1617510780000	canonical
12011	3NKES5dfUcsPikjCYx3UgmKZ4KU6NiofRB79ge1RkMSLoRcRkzsz	12010	3NLpMFrGq9Hb4YmptAy8drkdDcxeggBVhATeafEi7hPeLsPqy26b	641	1336	172	6301	8356	jxtNKcy2yoYQ6nnEpZaarUH6UrYWpvZj92URGVKuFy3dAttroyS	6182	8735	8735	1617511500000	canonical
12019	3NLbZ6DUeNSr6TJQuBhBSwAhs7d7B4NSUdWSHtzDXrJTUsWA4nrV	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	58	1281	172	6301	8364	jwmzuP3kG1KkTBynJonbv4bV7BaFhWJaeepBjUV4Tqz9DRNLesN	6186	8740	8740	1617512400000	orphaned
14926	3NL4wJnAwTeyLwdwTga2CVpaL1hESZuPrFsJNkvBpc84G8CPPBAH	14925	3NLebMDzHbnZUiMAa3KTda2voNuzVR6Hybi3croZ87n5zofmwUch	1553	776	237	6301	10992	jxc4QsakJD43H5fG3Zp6sHqzavLjCH2ccdh7aWxCqbA1uL9cbjw	7605	10780	10780	1617879600000	canonical
11919	3NLYMQcUh92CCu9LiyNMxA9VQnFRjPgLydPLtbRKVcv6Wb1sPJkA	11918	3NL2DmonS6tRQDegE2VpEsxKQqsA7ari9U4A3XJsSVeJmwV8ip8W	1403	40	170	6301	8268	jwVwp8xESRX3wGQUr5FCDSRx13bCmh7Mo83PH8J5Jngvh3JdZxE	6132	8662	8662	1617498360000	canonical
11922	3NLSssZtrfVoeby2My7xzL9W85a4DmAT3gEJEDJZ9F6VRg4mpe4W	11921	3NKQ5aexYBbneJFJMshmWAjydtVAVYZq9hAkDPu1asc7C8KhLYdz	1407	1395	170	6301	8271	jx4oAiofDED8JY7xD8z2DEtnTdP2FcwwjKXXPhtoWUbPAvF75be	6134	8665	8665	1617498900000	canonical
11925	3NLFAYNTe5iWzFvkWyaNiThdnBHgvBFVRs21VZ83nwysYjCxfvqQ	11924	3NKVk1s3cShYBFtXciquA8wKocGkN9YZQZade2rdBpzsuShSdXvd	1407	1395	170	6301	8274	jwo5DNGfL3Bwa4cU2oSgMf3K5CinoRcB69GioZukAik2nRGskrt	6137	8669	8669	1617499620000	canonical
11947	3NKwJ2tNCudvi8r8PjZp9cuH4uzToFEoScWwJs9H39QePJRNfBUz	11925	3NLFAYNTe5iWzFvkWyaNiThdnBHgvBFVRs21VZ83nwysYjCxfvqQ	1458	1077	170	6301	8296	jx8ve9y6U2j3LvdEJX75nU5QBEfLoUuK9DBS1cPRbyZ17NXP2zm	6138	8691	8691	1617503580000	orphaned
11928	3NKQDtEW7unHxeUs2SzcxHteSknFXqsnP4YViSxUnJvuvBW62VTN	11927	3NLRq8jWcqE5FSHu7BPwTZFEj3zFMKTiYkjUBTBBdc7vnWndupED	1623	830	170	6301	8277	jwC7gjikNKoURcmWgz6tSyfiFZviswZsxgiyrXydsaFFNpotiw5	6140	8672	8672	1617500160000	canonical
11929	3NLBXmaz9yVyALnY3Dvk9KwQzpdcyh88zrsz1i8qk1fscxKh9Nct	11927	3NLRq8jWcqE5FSHu7BPwTZFEj3zFMKTiYkjUBTBBdc7vnWndupED	1631	794	170	6301	8278	jwTGUaPowMhFNfhq59UnwyKoCEEbyipXdC9qYw4pYCtYMcoyH8X	6140	8672	8672	1617500160000	orphaned
11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	11928	3NKQDtEW7unHxeUs2SzcxHteSknFXqsnP4YViSxUnJvuvBW62VTN	1673	1368	170	6301	8280	jxjcbwFhvmgPhF9zrV1Rsxn66upr4DpB7XgN3aovBp25yDwvPfh	6141	8675	8675	1617500700000	canonical
11933	3NKqz8qbhvjs9S3EV9Cz3KwSKPLqzfRKYhRefvREbie93oL8yLNd	11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	1406	1393	170	6301	8282	jxQRwD5pYrcJKCQfMFEfw8uygPzc52MJt4VaDg8VzBbd5ANpfL9	6142	8676	8676	1617500880000	canonical
11938	3NKKqhnRaGoYMRi8QaSue7omytXe8AcSHakz56Vmr2Q4MH2RxuFF	11937	3NLHhLPoq31Pe86T1b6rDxQYDwHo6D1jAmmowxPvvKZEaDnqvE5W	1406	1393	171	6301	8287	jwde1s89RKkuumcMUddYJJjgD6Cia4y2roV2MkERzfedEV49iQa	6145	8680	8680	1617501600000	canonical
11939	3NL2gF22hM2EFDdU3dPf6r9fJx7piGioqnJbsjLS6Pv4JA6VR3Xx	11938	3NKKqhnRaGoYMRi8QaSue7omytXe8AcSHakz56Vmr2Q4MH2RxuFF	1405	861	171	6301	8288	jwQe483cVCXk2uHB12RsYEcyZragUyQTgmu3rKUqS9bVg6WDwU9	6146	8681	8681	1617501780000	canonical
11942	3NLKeYzv5txhfHZDHMmAHwKYSPo3rDwkisnULr3fs7A55eh8bKJC	11940	3NLYYhiJexSuaFVrggVAqCwqMsTchwthM6Rd1VCs8qwSzyp9UGfg	1624	968	171	6301	8291	jxr5TBTFxyPch28nVe1so3bUr6urWgTiMhJyYHqrJG9TvR1ovXD	6148	8686	8686	1617502680000	canonical
11944	3NLQJ44N43FpJdKoiHoY93bsJ5YnSQGQqFyuYpT1ZUGEJSUwWKbP	11942	3NLKeYzv5txhfHZDHMmAHwKYSPo3rDwkisnULr3fs7A55eh8bKJC	1406	1393	171	6301	8293	jwCKPDwkw5pnVzBvVe1C5fTjhLjEJCj4FfdndLUUpiMGaNdBXD6	6149	8687	8687	1617502860000	canonical
11950	3NKZieUrDJk1TRzi3567s6a2sKUuufAr86do82DV1tEXaK4AhZQD	11946	3NKCZcsQRskc4GiQnyq15FeURXWPYs2SrVTr9qzco37G3ftjkgHR	532	1303	171	6301	8297	jwLoCrgnK11jGsBqvNJyzEPMpAef1TefWJoL8fZJvJqLL9Tv9z1	6152	8691	8691	1617503580000	canonical
11954	3NKLMfD9MnxFCdbfZ6izw6RakcJ3xVdYwgY5W6L9jvjDUgnHe9WW	11950	3NKZieUrDJk1TRzi3567s6a2sKUuufAr86do82DV1tEXaK4AhZQD	1460	1324	171	6301	8301	jx8G81Xb2XCP2WpAzhzVBcrzvYwdLDBeUSjELa1gdJbSVqbEiXC	6153	8693	8693	1617503940000	canonical
11956	3NKPZcsxEhNVAgBXzuWnbqL92UfLTSA3qMwjgAfox41m8s89Mc7j	11954	3NKLMfD9MnxFCdbfZ6izw6RakcJ3xVdYwgY5W6L9jvjDUgnHe9WW	1476	1245	171	6301	8303	jwTaatzsrv49xefgKJ3G27CpMUtQeUFjvmcCqBQwGmvMKquFss1	6154	8695	8695	1617504300000	canonical
11971	3NKNzNthP2HKqvA1KpLdnSdGiAnmN1yYrHUNhGN3N8hLerDXDd3M	11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	1651	935	171	6301	8317	jwPiuHKAd5NysAfAiqZMsqVRvHboaGUQsH9AYfvnmsxAbYiLpfu	6160	8704	8704	1617505920000	canonical
11973	3NKdd5UDZ2GEQmB2F4Z28dCRKDm8dx2Jkx6EyQZen3BBwMHwqwCi	11972	3NK4B6oKCjkUMjr8bSX4jZZM3NzqrxLS9ajoBgATBByLqtiNunMZ	1637	816	171	6301	8319	jx7sK9DyCCV7m7WSDi4jJiTj4J8QXQ37oZNn36YXZbrixnW8r8J	6162	8707	8707	1617506460000	orphaned
11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	11974	3NKZ3GEFc98gUdyJreymfhYaqQrMg9NDr5n25aDTLWGHaraYBoF9	1624	1334	171	6301	8321	jwDB1vfs1eyyK9XPfkszexyg2ECn511xx1VUPkwU7SMzxQSW4be	6163	8708	8708	1617506640000	canonical
11980	3NKSfJtGmZgAgGhiFpGhTyZDKAXqBBYQGtVdQ6wMYyLwSDBErgBs	11979	3NLeL4soGwLkK37bQ4Uy2J6axwQxUsAQ5XrFc7kcPi4sJ93VdwjM	1637	816	171	6301	8325	jxd1ur5ZSwa7hSLZ4JwiaLt967QtWtDUWrcxXcY12WgLdFdAtbT	6166	8712	8712	1617507360000	orphaned
11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	11984	3NL5oqnfSQjkcVgb5agxzJZYJS1jjQuom9tH5MfUa8dCTEYZVmAa	1536	947	171	6301	8330	jw8CJ3BDmaUoJUFZqCY8D2jg7ytHv374qEJEmqRW8oQ11vGhv6u	6169	8715	8715	1617507900000	canonical
11987	3NKquzqqWKwVvvm31dE4hwnG32rhLvUwHxSQG9D9iDpbNvRcRQvd	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1460	376	171	6301	8332	jxsPgWP2K9wUPGiNDeWp1rnNCciwxJsPj4K5BTHqvueu4ZaqZwX	6170	8716	8716	1617508080000	orphaned
11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	11991	3NKqYJmtY7hWGJDVpjc8HxdJweEfY3ACbPEiUfzxnp1MR95gB7e9	1555	1101	171	6301	8337	jxXPbhVPr19JVHPw3R1pKsTX1qPm9SYLAUMes15JNPhhKCAam61	6172	8719	8719	1617508620000	canonical
11995	3NKHXEFja1xGbxGQHpKzX4x9yrUVqGHtrxJCKccj3GRfanbHLbw7	11992	3NLnNx162V9ZUnqF81dLHGeUjvZDonXuka9B1LHyzK694ud4D2qJ	1675	976	171	6301	8340	jxATkXHHWupFaQdqrHm5iQKoUrfHdPeCAG6qt2XWnSNJ3UpzKCJ	6173	8720	8720	1617508800000	orphaned
11997	3NKKXW85LY896NSDFkBqFEZ3Bcd6MQDqeVZc6RnP3RxZDt78AYPU	11993	3NKu6qmKPYjRd9hbeQXbwkACxJPDQ5yktxHy4x5hRJAe2cLsACF7	1403	824	171	6301	8342	jxiGeDhJn1ow46dqjnTrtrHiAPc17X2nUR3tKuJjFckYKVDYXcR	6174	8721	8721	1617508980000	orphaned
12004	3NK8gpMsMsd3dyhpncPvsfNKteqXhFn47U6rXMYf8SariG87qTpL	12002	3NKep4D3gGjhcRqjeyP2C7zYzjpGdz9Vwo8JRWzhMgMkdsyx4TZU	1656	1217	171	6301	8349	jxwnCyUGj2aqrtsLX9GBnWgXzYLNksiVPXSFVCggoJ1sQJ5R4H5	6178	8728	8728	1617510240000	canonical
12012	3NLHsX1itdffYo1HVsygshW51xWu94nfgNtDtfnr1maZjK5naNGf	12011	3NKES5dfUcsPikjCYx3UgmKZ4KU6NiofRB79ge1RkMSLoRcRkzsz	1622	990	172	6301	8357	jwvrqd2M3iyEabZc2zGndmfQskPZkViNYn56a9XoRyuECFv1JSz	6183	8736	8736	1617511680000	canonical
12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	12016	3NLaCHnQ391xMMGQ5kQdM6UTqhvbvJGuCHtekj5UZ59MzzMWdTai	1483	620	172	6301	8362	jxnEZQNb463jkWcH1gR51KAew3fCxbAAjn7EFTSYypz96X1b1iq	6185	8739	8739	1617512220000	canonical
12022	3NKD3sku8SYZXe1GJjPKHArVTsEgJQbovr8KCTGAbE6ev6veE4PY	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1541	1298	172	6301	8367	jxLmBd7YAHSfEbqWvTPoNrso4MiyLQ4NhkRqRfq6mtWCNnyfusc	6186	8740	8740	1617512400000	canonical
12021	3NKmmZhsPPvSNjtpHmL1UFdhaEMBpiNZkiQSHxPL1QHF7NhynkEi	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1624	1088	172	6301	8366	jxTgW8ePAQbkGF7888uzujUdoHX6isHUB5BLqAYCQYKav2porrJ	6186	8740	8740	1617512400000	orphaned
14934	3NLocjF7XRS4Zw1BiQC9TxpN68ywdwsZoixtr2iF1o9gbE8t63nM	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1642	1367	237	6301	11000	jx2Rfs7Enga51JtWFJhB1b8FfoUpd9zYaujig9HJS2hmfNnhfh4	7609	10785	10785	1617880500000	orphaned
14938	3NLMQ7SJKnHpznbRY5WDk9rcXrmLyAnMtBgu8i4GYadJXf1pSA3b	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1407	1395	237	6301	11004	jxSA2JawGf1ZGqBgUwx8dSRDHzLy46AAM5gNWU3aibzm5ZPkWTi	7609	10785	10785	1617880500000	orphaned
11962	3NLLEdVeYRP8ohr8NXeV6BQT9MDZ9pABXbNj2TyyGwkuVWfHp1gw	11906	3NLjViZ5hLqpi4JsEEgNfzPyguYWWCcn39b2myuhLtXuievc7CUv	1422	1091	170	6301	8309	jwCQrTqrVW2tiCFN16qFd5cUC3Dxkf49H4zsyXAJnWkj53MttJn	6124	8701	8701	1617505380000	orphaned
12015	3NKnr8ffDttC5Z1zZXhhcwkhT436X5fmqyQxi4Wx7FHTX4MbrJ1s	11921	3NKQ5aexYBbneJFJMshmWAjydtVAVYZq9hAkDPu1asc7C8KhLYdz	1439	1033	170	6301	8360	jxcpGdWChHKhPGNGx4P6ApFzPi6NrtmaweVVmmViYYydMnYWumz	6134	8736	8736	1617511680000	orphaned
11959	3NLUPf3xgavJszYd4cLwKjXfAGzhktuoezFwaBwgk9FSyVzoHsdA	11957	3NLpwFN8pkhz1C74XNiwWFgYMRinGZrFtsUyh1jQcj7i2ojcKYrq	1602	1369	171	6301	8306	jwTVn3aAfoqERJVx9HBhpuTwXYFPGXU9czbsZvoEUcM4dU1PJJm	6156	8698	8698	1617504840000	canonical
11964	3NK64MKbd5PUJFbLCJ6UpDAfqaxNLNczYLTKKEw68QW2EMYNqJZe	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1422	1091	171	6301	8311	jxbxZmSWhzitFXpUDZnGkxdN87tBy3FK4Ur7DHJ4VW1cDqoCo6J	6158	8701	8701	1617505380000	orphaned
11968	3NKZmHWrMsKXjkhq9dLRucPNtBcoxxJ61QnZiZvTjqmpbpcEAAMn	11967	3NLXLEgJJB7c9eeGvwdhhmTruzBsfauunijUoWmX6yuN8XpqoR6V	1481	790	171	6301	8315	jwwYtT4Pcy2fy9Q3ggV6mnGmFqtiBQxhQUeUpBd15sftVwzadAq	6159	8702	8702	1617505560000	canonical
11974	3NKZ3GEFc98gUdyJreymfhYaqQrMg9NDr5n25aDTLWGHaraYBoF9	11972	3NK4B6oKCjkUMjr8bSX4jZZM3NzqrxLS9ajoBgATBByLqtiNunMZ	1403	824	171	6301	8320	jwUAt4a8a3EBBF4oZLa8JecCpUPZtTsa1BhenyoWMnrbcAPRcvm	6162	8707	8707	1617506460000	canonical
11976	3NKoKkwQa6dSczpTnurza4eR7v4eRX9cgz8GrrFRdEmSoMGTr6RL	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	606	1295	171	6301	8322	jwxMDDL5dmBEtW2ZRufWr6VfZa3rZs5NQUmFbpDVcrh1oe5H173	6164	8710	8710	1617507000000	canonical
11977	3NL7huqXeJLdEsee3r42WrkkHdYy1knhj45GfJHmkYT3CBmK1K4z	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	1651	1301	171	6301	8323	jwYHWbFtXU6eSERdTAbfM9YGXvqpGhmxfNTvtfVodeb6FiQrtFY	6164	8710	8710	1617507000000	orphaned
11983	3NKggBnKa56tLYdUBqz4mUyH3MzWZrkJsk4U5VLXLN65pyTp2QbY	11982	3NLeQS6UcxVKE9WqS4dS4s5gq1SNggFytnCyiDqxsRXQ5r5joMCf	1672	1039	171	6301	8328	jwWPGGivj6qUocajwPKfkBXq9fEfQH8DP9k9MpsErcWXUtTJo5p	6168	8714	8714	1617507720000	orphaned
11988	3NLoi6DgPYDn3BcpCp49oPr8LufVAprmJsxTbWDn3FuGdomZb3kM	11985	3NKZqhCrC9JnPiKb2pN1dy6RZaPpe5Fu9jMwrujTotEvY7gddByb	1406	1393	171	6301	8333	jwXEw2dnU7jotEXcPMsx8BZp4vT1Sv2SmHCxfVKsZQwn1eGNPme	6170	8716	8716	1617508080000	orphaned
11990	3NLgov4BzYESpvL8hinQRniiRL6hrhkpPdytJHSTsNohj8HdTBzB	11989	3NKC7nfqRDq53DT7GtA6GgUGLpVQ4QjD6biDtAJE5kJsmRVv3EaB	1501	1114	171	6301	8335	jwx7ZWhJqBojinGV8hxYuwXS1MJXn5LMzvfPgyUHw2mmV6tg9CQ	6171	8718	8718	1617508440000	orphaned
11999	3NL1BN3oA8aeVQveq6CE9i1nskPRzfkDPPooAk4X2UXwk9rUDB6a	11998	3NLtfNf1jKCUXuW5y5xnNTW3UxAWnTLqy6Vx2LefXZEgVyo6PxNy	448	1179	171	6301	8344	jwDD331METaUutz8NUZvG5a3rLurztwo7NuArAXXdm1vA5NkFL1	6175	8722	8722	1617509160000	canonical
12001	3NLA15WHuWxWFZTMcrYvLYgSPcPpWmSnbT3LmpWXEQaHVThcfQjY	11999	3NL1BN3oA8aeVQveq6CE9i1nskPRzfkDPPooAk4X2UXwk9rUDB6a	58	1281	171	6301	8346	jwF7th4Ny3keUgAckyociN1Xw4zLfNLXdtNU21EpdT9S6DZcCq7	6176	8723	8723	1617509340000	canonical
12003	3NKR3wP3Z914LC6e47KfMZUfhF3rLGQaqRDCxRPsFfvgWwdVV2kL	12001	3NLA15WHuWxWFZTMcrYvLYgSPcPpWmSnbT3LmpWXEQaHVThcfQjY	1631	794	171	6301	8348	jwGBzAv57KpyuRBGxaXYJ6qgCwiWMnNQ7JG5vh2ZTo4eetp4FQT	6177	8724	8724	1617509520000	orphaned
12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	12004	3NK8gpMsMsd3dyhpncPvsfNKteqXhFn47U6rXMYf8SariG87qTpL	1483	105	171	6301	8350	jwxvaATS8oF5CUMsvdEb6mR9uBKHgS7EuzMYyTFSCRVRbLPCQBU	6179	8729	8729	1617510420000	canonical
12008	3NKZe4u1NPTHvUfhKnmzptqoCvY6i915iXW8PfC8XVnhdwpNQJkT	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	360	360	171	6301	8353	jxo5vjTHJPGzyvq68NKstPhDKTCVBsKdZfM2f6huoLrWmR1BX5k	6180	8730	8730	1617510600000	canonical
12007	3NL8UcVPqys9NjuXSwzuGvKndDRq4zi9j3K64nQM74L7ULcu4QJh	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	1675	1342	171	6301	8352	jxjpCL4p2sukq1rAtBXHqbhVF1uP2TPARqqv4VM7DRfrW5xEt6V	6180	8730	8730	1617510600000	orphaned
12014	3NKijbkdx9AuQN3NnVKezd1WtPec7JBe78MSeSsV8Ewm4wJ4ur6n	12011	3NKES5dfUcsPikjCYx3UgmKZ4KU6NiofRB79ge1RkMSLoRcRkzsz	1439	1033	172	6301	8359	jwdckbtr2HwSw9n8kxUp98KfzEvx1D9oSbBWKWkhJ3PAq1GCq81	6183	8736	8736	1617511680000	orphaned
12016	3NLaCHnQ391xMMGQ5kQdM6UTqhvbvJGuCHtekj5UZ59MzzMWdTai	12012	3NLHsX1itdffYo1HVsygshW51xWu94nfgNtDtfnr1maZjK5naNGf	1507	914	172	6301	8361	jweWsaT32ExKrPasdYNYfypFFkMdfDzPCywVWzU8MD51RpnyCHH	6184	8738	8738	1617512040000	canonical
12018	3NLU39FzFq2Xct37fmRM6CamzfL6Wgdi9ppsqUnxbPNsV8zQucB1	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1471	1386	172	6301	8363	jxamhqAkukMExtDcwvn8YfksZfezYPoNUh58RqLcWxZaFXRdwXG	6186	8740	8740	1617512400000	orphaned
12020	3NLMG8tcXVgUTXpcJ35gy5ZKsyqyPNntyqk9wuqb4DJaxo3dVqjn	12017	3NKYg4cSkFYX1fL8s4buut7TCztyGcuCP7roDLSfNyvtbkrs4uLt	1407	1395	172	6301	8365	jxdzdHoNGLUiRPRw293dMBBpX2LgR9i2oaRR6s87p773azVBk4R	6186	8740	8740	1617512400000	orphaned
12023	3NLvJ1RvFcodD6y9qnvS4LKYRc26zfvA2zTBRqnnFvisKKB9zeXp	12022	3NKD3sku8SYZXe1GJjPKHArVTsEgJQbovr8KCTGAbE6ev6veE4PY	1656	1343	172	6301	8368	jxbXrugbNPdPh2zYBaWyFL7FwHSQz3brB3PoujaeXnBeP9cs5UY	6187	8742	8742	1617512760000	canonical
12024	3NLrsy9ruRm49MKBPNTCP7ZcfHwteL16yz1JtL2JRfpKPxB3eVSQ	12023	3NLvJ1RvFcodD6y9qnvS4LKYRc26zfvA2zTBRqnnFvisKKB9zeXp	1447	1099	172	6301	8369	jy2AR58ibuowudJkBv4De44bN3bE31GPnJwLx5fhUuhb6XNeQvB	6188	8743	8743	1617512940000	canonical
12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	12025	3NKZEb51jEBcGjs5HFHJaA3SRonQ3p4fsQ67u92k2cBaTRPHvQtS	1555	1347	172	6301	8371	jxiXN655QRcKBAw14EDARdeG4uwoEZfeNXUgwDrSVvjVxLH38Qb	6190	8746	8746	1617513480000	canonical
12028	3NLWtKTrHLZC8vMcT42J1zwJ9JT19c3vW77eNzrycCsSx2j4LfPM	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	80	907	172	6301	8373	jwo2WUrq2HKpT77DMQb6QtDEoRc5CJS8moFS9qiY1u2UApBskfC	6191	8747	8747	1617513660000	orphaned
12030	3NKwM4kmEu3qXNYz2dUd9erFxuRJ9wXWjoMkjKKKYrTxP91qHf5Y	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	1403	824	172	6301	8375	jxpS2qHz4vvXzSb5SpsARoB3Bcy97CKGSAmmtFkhbFqz3aL8gJv	6191	8747	8747	1617513660000	orphaned
12032	3NLs259XMpif1yA8HvCdJKriJa4sKVFwzKp1sxBTKs6YcdiatwSY	12031	3NKkenPCNS34uUR4reZwC7KMooQuJ81cPkuoBvp6hhHbXGDfKPBc	1646	1354	172	6301	8377	jwEKCHgCacayVmwoykdyACSfGWWtKxT2B5oHEvnuvhRpVnh1Mog	6192	8748	8748	1617513840000	canonical
12035	3NKBc2M1oeoysDkeeXMaqQmEKhX3KhrKEpa6iB7AvHvSFdf2xM44	12034	3NK6kZp8ZmUAkL84nLWmbDYDe6ysxZWvD336aqvjDhNX7D5ZTHrA	1553	776	172	6301	8380	jxiZLj3Lkt81qrhejKySc5PJLU4rPP5hawi8r1ggpbKpernEuYw	6195	8751	8751	1617514380000	canonical
14937	3NL1p6yrj2HPwApaSQm9RGvARpr6rPeR2UdGsZRSkUwxebiucpQP	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1490	908	237	6301	11003	jxS7yBZf4GcWEMp392dwfQvcL9VA7YWTvDc66m7armujSVadboG	7609	10785	10785	1617880500000	orphaned
12059	3NK4ptGY7tzWL1DppKUJeTtJbsFQkY2b9q3G48sfdtMA5eefaGC8	11975	3NKu29gTeZFsyxhMm5GpGnrNZtHjFDxqJ62rrMpStMyxVH4suRS3	1440	1011	171	6301	8404	jxAtqCqP1fq5SnZtFz1PExUjF6tGrjdM6ZoEa9DoYC9Ar1qpW99	6164	8765	8765	1617516900000	orphaned
12031	3NKkenPCNS34uUR4reZwC7KMooQuJ81cPkuoBvp6hhHbXGDfKPBc	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	1406	1393	172	6301	8376	jwwUMCwk9AkfXmLQGzGKxXyz2yjdQ3AySpxmabDwy86yUCT5ojV	6191	8747	8747	1617513660000	canonical
12033	3NKt497xpvqqnCT4iJK5SaxoDq7PSgDXLKxX8WoqF6JqoiFPBfXn	12032	3NLs259XMpif1yA8HvCdJKriJa4sKVFwzKp1sxBTKs6YcdiatwSY	1553	776	172	6301	8378	jwckJCf4deqJeyuALyF87Qvg9EHrnFbbqssPcL55BqyxzhFiLqt	6193	8749	8749	1617514020000	canonical
12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	12035	3NKBc2M1oeoysDkeeXMaqQmEKhX3KhrKEpa6iB7AvHvSFdf2xM44	1637	816	172	6301	8381	jxdALZvhohupUNd95wshZ8jATSBh8VZtFmFP3qwMzoDT6WtXhhJ	6196	8753	8753	1617514740000	canonical
12041	3NKjWHFPzoJVdYjVvtBgkK9zauSi1rqPe7beezTwChfacLQb9N8x	12038	3NLEqS48h8Xc5k65dbkp9x6gfC3fAbPhRhq3mGeF4LtDbmwjSL55	1419	814	172	6301	8386	jw9NsqqbjjsWKEkYJQKt1x7GXch4M3krtA3bzpsZ1aJonHJZNHS	6198	8755	8755	1617515100000	canonical
12044	3NLKkznKn6cAJwFoYW2Kk6CFbbRMCBsx1RntRdf7pLnwELYVW7r3	12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	632	1016	172	6301	8389	jx7JJ3fr7HAtJaMQCzcx3s4SFytKoNwZfrqsqVmaLreXTbotPr7	6200	8757	8757	1617515460000	canonical
12043	3NKEFX5LxPnF9pbXxE1NuksFsQHcj64ZNwFZzeBRnermpWtYYJMf	12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	1588	1146	172	6301	8388	jwym1NJxpgVq3EsgxsXTGCAVQ7DKc7HdWis92aGjMsbxNvFcpdZ	6200	8757	8757	1617515460000	orphaned
12048	3NKYWxKRKzvUsAw8KuAiVnsugrEuzKtUQQcCG9YUPu3P92G2yH59	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1460	1078	172	6301	8393	jwyFdSGrVkmFR3XycctyomxZXApudwWnwjoDUg73TAYzCGBfWnV	6202	8759	8759	1617515820000	orphaned
12052	3NKevjRx9qQszAqnUrEzhwWkcHZr6GNeMm8xrAcaxFk8eMcrXTPh	12049	3NLpZuWfovesbNYSiS67fvR41jqCRVskazRMuRYUN6DtssJ3Nv8r	1622	1356	172	6301	8397	jxVzFXXVD8fepdoPaidXqTnhhBfxV9m5Ew772EU7pv2UcgoSihx	6203	8760	8760	1617516000000	canonical
12054	3NK4LY61rh7fWjhNQP2D3doRkEXXcHiTxZSjWJMvKYQdtuZBosdd	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1445	1290	172	6301	8399	jwyg9KrVKWBDMBawnVpwWsxFAbaf18uEPst21GXqXhp9L9Kj3Pb	6205	8763	8763	1617516540000	orphaned
12058	3NKfP3i6FguUU7YKAXZrX9RWuz5RTm455mstAKCB26hr8m3AEoaZ	12056	3NKrJCtLxGfbQrL7nxAyG5TBkVdtzFzgNzoWvWFunSiLcKwneR2b	1596	1237	172	6301	8403	jxWLKCUsVb4dVrv2bV1RWAACPznMSsYDG7eT4fPe66XosrfiW4L	6206	8764	8764	1617516720000	canonical
12063	3NLZPX8sfv9LAkdXGAReoEHWcRUwvujprp5Ch9x7WiHLcpNUY6FZ	12062	3NKqhLkW91zCCZBVkBmXwT6yB6thHaSC824ptzYTEVEo4yPRtZb4	1402	882	172	6301	8408	jwqomcG2TUGxmpan7rN29Yv9687hC2zirdouVQHiNBEtHpG54Hi	6209	8768	8768	1617517440000	canonical
12064	3NKTLt4nU7u54pZo7FCjhTBNhBBmz3ghKfNvuTkxoWDDDDa3YHeA	12062	3NKqhLkW91zCCZBVkBmXwT6yB6thHaSC824ptzYTEVEo4yPRtZb4	1623	830	172	6301	8409	jy2ijf42a1K5N2oU6oXmiP5wRBxFa2CabuS6viByyqbeJWotWAz	6209	8768	8768	1617517440000	orphaned
12066	3NLAnHxhNjqbKjgnYfh7MmLoqefsLSF54EB6o54Lx9BE9BPJ4x1C	12063	3NLZPX8sfv9LAkdXGAReoEHWcRUwvujprp5Ch9x7WiHLcpNUY6FZ	1601	1262	172	6301	8411	jwGRH47goHya2vcKoNxJatV2AACqkSB13TJ345AtWvLL8aANaVo	6210	8769	8769	1617517620000	orphaned
12072	3NLq5Lbd3JEc1reWTYLPBEHE16abg38BAFFYnqK9iRF6cm8aVQwa	12071	3NL5Zw6tjg1XSXT7HpQRyy479FkSUpSC9WWLK6hvqc6vcdZrvBK8	1527	1167	172	6301	8417	jx6cWaCfPxFk5Rc4RqYXY8c9CHsbco3jG1J3UHBCJ2RPunitg5E	6215	8776	8776	1617518880000	canonical
12075	3NKRRMkdVSnVWr4TkW2LzhAQ3ova4QFXs75aRVHt7MZUZPboMaEW	12073	3NLEAWKPWYMfqskJZe3Uk41ZTZPfvUnyUNJzc3vmYYDQXaAxYANW	1406	1393	173	6301	8420	jwNvz2N1rnX5Ehx6rr7WJ3Y6gV8QVWtLHk2D6MfdLNbW8Cp2X8C	6217	8780	8780	1617519600000	canonical
12078	3NLPFvkdanQYL1k4N9oSqV8uMHsieHTAmBVHiskeHdj5YEUvewv1	12076	3NKNe25uM2FSpT7zCyZf3V5mU7cTkJS2oc5zgtB9cCGDbEJe26LB	1573	1318	173	6301	8423	jxDzss1fRdQepWDZ1Sbj3S2mYNJWgNTPSWAXG3MfE3WPZNcy9Qg	6219	8782	8782	1617519960000	orphaned
12083	3NL2qF8BdEFVpipyD457Ea4tGAQTR6k46N3mqgrDXdPYqwHoBUh8	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1675	1096	173	6301	8428	jwCQAJ9Jp8MfyRmqkP6thCHuvd1JbcJSa5Jxh4qu9ZkJXi6Efay	6222	8788	8788	1617521040000	orphaned
12096	3NKFk1XZ1ycpXmtuy4jXkx4rSifBzGFmDQ4DXtgz1U26Q1J4QALB	12095	3NLfPeNUa4ySkeFcPG3xqPQx5vvTezpa4ad6LmMZ9FJeq9XQzg66	1419	813	173	6301	8441	jx13DhSkqonRVz7zfSqpDXMTZKQeWuvxFBpicFBW6EsLRfQoop5	6228	8799	8799	1617523020000	canonical
12099	3NKFddBajGC3skrvUDoUbFKxU2XmPvF82kgWnKVyBrnUwwcLrvwn	12097	3NKqnuEPMydkcToFAL5Ya2hLjy3U5CUVTHeK7A6mAJ4tKALSwo5m	1651	935	173	6301	8443	jxXSYQLv3meQtE9EDDih2ZLxhxGfFku1wMgmsW8y8578sUEYsJo	6230	8802	8802	1617523560000	orphaned
12106	3NLm4rcvccB64Jsdz5ngHaDh58Ebcwqkds55YyDQYzcBhGyxySKs	12105	3NLVGKipGTQZh8BRNTcdshPNBkcuqJg2Loz28JAeftcqWSYQfyJb	689	689	173	6301	8450	jwSYEdfgEMrwTsjfhXaRfsZoMkGbELcJjxuXJ8B6u13wzb2B2jC	6234	8807	8807	1617524460000	orphaned
12108	3NKPtcQgXLvuK5A3VJvtsnAAbYmxi3Bi4DwKJjX5VjUtj87xvcdu	12107	3NKVmy7vwivUTjxxmjZop2u8hTSoYN7pJAPNpNN1rRAqA5kirqgv	1643	1053	173	6301	8452	jwF2MZBahJBku8NCowfVrb9zBJtFmQXANYCtxrdbdE1G9BhWc8e	6235	8808	8808	1617524640000	canonical
12114	3NL7eWEnKcWPN6SMtvu5PV2cfU3RqerJcg4hb7JJphQ25SquwkwS	12112	3NKdCasmPFXh4zs99mK5npz3rHAPXnd7tFJstCpznHobmsKmsKah	1610	1188	173	6301	8458	jxYj9ynqaLxn5mXu9wYLV6eFn8x7xuV8zm1y2kFz5Ns2K6LqM6R	6239	8813	8813	1617525540000	orphaned
12116	3NLpbW2Dk6HA9tDbH99H745dHtPzHicGDnxT67v7hvqq2TAnWPAM	12113	3NKnPXUkzYresZZ27RH8gV8DCYFRj3pQ7hqMzBaBjR8fi95DDCzU	1549	1362	173	6301	8460	jxw1QbAkAEbRT9tx5sJuFvWYAwEqbQKh8t7Go7uuVJEHGrjkeNo	6240	8814	8814	1617525720000	canonical
12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	12117	3NL6uBAUmVNf1aCA6dBaoy5LhLK4vREBWN3DLPLtTEq88UUFkka1	1598	514	173	6301	8462	jwG5KmrQPJWEThRc6tE3xVBd1ZdR1vY8qSoEnPH782NwqXVC5Bx	6242	8816	8816	1617526080000	canonical
12125	3NKLtEBLjRvijamaeFPwQddTYQVuFgvNQNPqKQ3rm2QAbEiDbTZa	12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	1564	1212	173	6301	8468	jy2T9dMq32iRAuMdRK5BZd3P38ineq85rP5ejPHCm8hrLfRDGCQ	6245	8819	8819	1617526620000	orphaned
12131	3NK4SjDExWbw9CAn3Ua8bhuSRknQokdURAwVcG1euyzamxmHg8Vr	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1578	1050	173	6301	8474	jx9GDzXahr8VduGYFjNZzWiU5fzLGin6UJwG4q5tsH11Kfjd83M	6248	8825	8825	1617527700000	orphaned
12137	3NKHgHPGgb325foGeofiRetCLHNHDUA5N241XtdLaLszjPrd7PYW	12136	3NKLm2Nrm3evQTfzVePZA79223UJ1Ca3zd8t6Xdkzvt1ppRcCtts	1534	73	173	6301	8479	jwk861KDo1okkBwWhdza8anWbZdhYFcEEKmTV5zRJWJfBRLo42z	6251	8828	8828	1617528240000	canonical
12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	12138	3NLjvzKbsqAvbuFYYmdXc1gmfSQ979G4rCkSrSRoytnLxmjZpoyD	1407	1395	173	6301	8482	jweyZ49f1aFhG4ass8ePnwxtus9geW2ck3YNsAqRjDiHPaJREHk	6253	8830	8830	1617528600000	canonical
14952	3NLdr3hvgVxcZzVN5tbyzooMbnHnD58afSVQCSZ9xZN6osczv8CZ	14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	1624	1334	238	6301	11017	jxY4ed9UKPSGEQEWzGMRYdyzND7o19ygMabVa5DHMip6AqU6RAJ	7614	10796	10796	1617882562649	orphaned
12037	3NKD9RxUAdBNXWYnGgDysJ7tPC1xQG9mvWZcjBB53CSyYnTS5tJf	12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	1447	1219	172	6301	8382	jw9A7yw83yQ3g6rqgBwQivK8YbUfVc6APvqSix2ysBH2C3qGohU	6197	8754	8754	1617514920000	orphaned
12093	3NL4Azx5aXj1ykBt12zcvt4UZYBdXgmiNi2VyBQeTDUqte4Uqtvm	12040	3NK9QfDtNj4PgGLGzDtiJsyT9RMDUWG2rKAWzxzqZxMJE32zig15	1556	578	172	6301	8438	jxpgZM4HoktEKa9aeSHpabKgz44qpGCdYG77JyzrVWwsYdLEcf5	6199	8792	8792	1617521760000	orphaned
12045	3NLqfohb2BACiLMWwQN7SSDyXhg4dkjhpAQbP64i5F2YbSHhjkLe	12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	1522	1322	172	6301	8390	jxo26BhCSHx2sSZDPnQzdSsJT2Rq9GMTzhowpH81iWwhd6oZauU	6200	8757	8757	1617515460000	orphaned
12046	3NKLbzerkdsPULT6PQQ42nf1P2ttvg1dKMR2M6QxpKy9WDuoH9m3	12044	3NLKkznKn6cAJwFoYW2Kk6CFbbRMCBsx1RntRdf7pLnwELYVW7r3	1403	812	172	6301	8391	jwKvYSH7ikBGB3y4j1482nsDW7KhWXnHhUWWEkUgD1vNBNqUf25	6201	8758	8758	1617515640000	orphaned
12049	3NLpZuWfovesbNYSiS67fvR41jqCRVskazRMuRYUN6DtssJ3Nv8r	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1474	1329	172	6301	8394	jwFm4yjc5keNgsewircvZmfmiGnHJ28m5ghE2eBzRLSzcGwxYeg	6202	8759	8759	1617515820000	canonical
12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	12052	3NKevjRx9qQszAqnUrEzhwWkcHZr6GNeMm8xrAcaxFk8eMcrXTPh	1637	816	172	6301	8398	jwe6k2RNb4AouteX3PBrowBmCTZ3dbvyxWz1bfoxouWsRaLKS2K	6204	8762	8762	1617516360000	canonical
12057	3NLoTFe8GsWEkqjMAPR2m9sZ1xzAt6fT4DXvvxtimVza99UsehCu	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1671	1365	172	6301	8402	jxSf92Vqs52zFdZcTv7edqhGpjQFCJF9uzzQJRuqWpr5RFMe529	6205	8763	8763	1617516540000	orphaned
12070	3NL4pri2UPJUrL4GYjapGTpprPgcpFuYHkwYuKY7iAVxJ2Do3Qat	12069	3NLaq76qBYr7aWgVeEtYxmJ1T5NyypV2w1kD57hHsM5pG1DPT3z3	1407	1395	172	6301	8415	jwMjWgAHy41FKFnLNNjKRYT78siK7qwS4KP7uZ3oUXVAcnk5kPh	6213	8774	8774	1617518520000	canonical
12073	3NLEAWKPWYMfqskJZe3Uk41ZTZPfvUnyUNJzc3vmYYDQXaAxYANW	12072	3NLq5Lbd3JEc1reWTYLPBEHE16abg38BAFFYnqK9iRF6cm8aVQwa	1407	1395	172	6301	8418	jxUt37hoHCEQVVHSqfWu3WimnWFMtpL2XbDT9WpZVU6gb9CRZYv	6216	8778	8778	1617519240000	canonical
12076	3NKNe25uM2FSpT7zCyZf3V5mU7cTkJS2oc5zgtB9cCGDbEJe26LB	12075	3NKRRMkdVSnVWr4TkW2LzhAQ3ova4QFXs75aRVHt7MZUZPboMaEW	684	1352	173	6301	8421	jxJFrBcvf1fq1j2PHupEqMWbrRHVyJSuj9ruEYjSWhry95B91SX	6218	8781	8781	1617519780000	canonical
12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	12080	3NKPnFkZGBxz27Ua3iA1LHFffysf2Ny2TJhEMwdEQJWH7MfeCoid	1649	1383	173	6301	8426	jxfL3CkSWu5kNgHVZCXuYqC9JrRz8vtG84QoHXfgGzW7tEMRXUF	6221	8786	8786	1617520680000	canonical
12084	3NLDF7nx5AFGdT4m5HzfiW5L5823hsceSf73iGbCGQN5icWYDtBD	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1509	1320	173	6301	8429	jxR9B28pbR7dDq9ixZ591dkY1dnXerRkyQpsTBkSRhCfSCZNwch	6222	8788	8788	1617521040000	orphaned
12090	3NKDUKvftxR5qBriNWcix6Qj53m5iCasHPktbmgCt1oow9YuLSHT	12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	1419	814	173	6301	8435	jxDp9ztfUrtztJ4T5ELuVcrshJacrJyziNe5ZZxxkQquH8KazEH	6224	8790	8790	1617521400000	canonical
12088	3NKnoVZ4Wycizq4YEcHmL7QivnB129aqCCSKgeE1QgU7BrrwtHbf	12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	1490	1028	173	6301	8433	jxVyeMumKaT3GrBJFYC5sbaVFisSmq5SuaeBz8t4rmHMdtNSgNU	6224	8790	8790	1617521400000	orphaned
12102	3NLA9Bha6AGTWtjMAngSF3i1GVmiXxq4dC97qUB6DxC8GrnmtDzT	12101	3NLLEUJ4XtTN58nGD2m1FSv8ufNdyPWfSTfkBdRJFaQxje7NtsfP	1455	1332	173	6301	8446	jwZs22mycPChG1hSfeH5HLNea8yPBdajUDJZk5Ne2dn9jCQQsW5	6232	8805	8805	1617524100000	orphaned
12104	3NLC8wErqeY9TRzMBWR9UJMrtqAEUPnizS8iQziFeQfbbDVNFQZy	12103	3NLkDA5ooYR5dJbvDDgVrjsFrCebaoZXNmUX1RhhRZ4FrbiZ1M5U	1406	1393	173	6301	8448	jxg3oHYmQm1k5UDND9dFTBS7cp1CdaWKq1NerbjAYttsYcy7LfZ	6233	8806	8806	1617524280000	orphaned
12107	3NKVmy7vwivUTjxxmjZop2u8hTSoYN7pJAPNpNN1rRAqA5kirqgv	12105	3NLVGKipGTQZh8BRNTcdshPNBkcuqJg2Loz28JAeftcqWSYQfyJb	1407	1395	173	6301	8451	jx6UtTWMfdJqDabegJbqFCSyaU6CgYUcPXbs62aKq1HFYZNmxpH	6234	8807	8807	1617524460000	canonical
12109	3NKDSSwcKMZHphYA1viqMXVkwtGDD3ymdpWXiocHrudL9i5zFaG4	12108	3NKPtcQgXLvuK5A3VJvtsnAAbYmxi3Bi4DwKJjX5VjUtj87xvcdu	1506	1373	173	6301	8453	jwEusNpZ5wW2B7GwmEF2FCq4DbbdLc74s7ha6z5Byev5Wz9Vnhk	6236	8809	8809	1617524820000	orphaned
12111	3NLHxxNMASphwXEK9eX1cfn4hmwUuhXCsUJqt3BAawBYVxbWXEjP	12110	3NKRprD763T1dGD6JtKtaARVFmciPL6iXv1FVLwa4n5NHo8sHqHv	1406	1393	173	6301	8455	jxUWWRMVTaCoWW19RJurcts8cPQtdcC5raFC69AUHwVN39FDcW6	6237	8810	8810	1617525000000	canonical
12121	3NKd2Y5EjWhqEV3powj8ELg6MzX4R7QtrXSNcaPEAotWdZWwwQn7	12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	641	1336	173	6301	8464	jwf5m5YAUW96HcGseb2bSFC91oij9wgscqAXu9LLboREEk1b4sU	6243	8817	8817	1617526260000	canonical
12119	3NLSB7bsn9Gabm7zbFmR8BRYWUufboWZdM5fZzvWqjHjHY5Qo6mu	12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	1405	873	173	6301	8463	jxAbDWVZsJxQBKa4yPV3LAATYxY1a6JeVGbNjA73T3eQURwNoSc	6243	8817	8817	1617526260000	orphaned
12123	3NKCsEtMRiZjzu1dCnmeP2fTmKWZh9Uk94LgcLQSRHZj2yNz1yE2	12121	3NKd2Y5EjWhqEV3powj8ELg6MzX4R7QtrXSNcaPEAotWdZWwwQn7	1631	794	173	6301	8466	jwwmT2751dLPJrwuknuSEXKfvESfquRKZLbXP6DcFHzFfXePdcn	6244	8818	8818	1617526440000	orphaned
12126	3NLZbYwSvoJ1Rmbpf3S2P7JAFhCkakarxTUhNx23xgxUH2AHUd5T	12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	1407	1395	173	6301	8469	jwuPwt7zAtwMUuGqD3Q79MnznmbQ9SstK5iHXgJf5PeiKJTUvA2	6245	8819	8819	1617526620000	canonical
12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	12127	3NKZfw2QuM6AHfzpnBE4eYQk2EXGHSkjxVPki4hmtxpr1R1iQoXP	1599	1287	173	6301	8471	jwrzvFH7wGvTHcotUfzVsVoH95QiNxg9cst43yq19VWsf8Zj9P9	6247	8822	8822	1617527160000	canonical
12132	3NKRDQe4akSCTTRAwiU1jFKZqvCqSPeYGSh18UEUuCtrYLFfCokQ	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1649	1257	173	6301	8475	jxQwTeJsCXT3diC8Buae6dWgnprFHxxJ5R1UC5tKJdxn2Yda49f	6248	8825	8825	1617527700000	orphaned
12135	3NLREMHc7LhPPJogsDURYXvLydWAxnygb3EqWTSwFLN7Sr6WdpRK	12134	3NKYvRZi3biP4GEtoxadxoREsrkoeTG8JZqgCbbTtprKicJFfrwy	1670	1036	173	6301	8477	jxYEX5GcE4XYTsV4Y87154wQ6jVTqwBXUUr6BeszBKHA8RAuDtt	6249	8826	8826	1617527880000	canonical
12138	3NLjvzKbsqAvbuFYYmdXc1gmfSQ979G4rCkSrSRoytnLxmjZpoyD	12137	3NKHgHPGgb325foGeofiRetCLHNHDUA5N241XtdLaLszjPrd7PYW	1648	1158	173	6301	8480	jxgSLc4WCLWcx6WxmbdTAHSWxoY7zFTo18vUVe75Am7GTBWt4DJ	6252	8829	8829	1617528420000	canonical
12143	3NLpWW35wPrJT1W4yaiRDb3tiemJTVUgg2DHUHGHF89fSuSawAPz	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	1529	1316	174	6301	8483	jy2omBwX9MhZgEvdenoby4ChBu2WdooK78qBqthr1MSGM83xZaY	6254	8831	8831	1617528780000	orphaned
12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	12146	3NLtMmK2qNmwopvzCSsMMgzMTZAY5cRBBXTpgyD3fhpbaNm1Lpiz	1406	1393	174	6301	8487	jwDnm1kDtnkTcrbCax7dyTkiqt5vxaNr56DSNckjhqF6onrszND	6257	8834	8834	1617529320000	canonical
15382	3NKFh1k6n21ssy9mYSByeGfvpywG42V8NNEk4zfWCj6sbZHcHAzG	14964	3NKwpgGdFtr24G3N1497brHWvhbT4qT9v8AGzrxV7e5f3CKRefym	171	1374	238	6301	11420	jwwXqc8y3FonQt86AGB31TTfkuPjEYSJQ5H4wdQWKAW3XgFYr6A	7623	11086	11086	1617934680000	orphaned
12038	3NLEqS48h8Xc5k65dbkp9x6gfC3fAbPhRhq3mGeF4LtDbmwjSL55	12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	1585	1120	172	6301	8383	jwk4KKVSzWZNNPz5yHBtDP7dfnRvrkNVv79LhLD5yKgjPffdHLq	6197	8754	8754	1617514920000	canonical
12040	3NK9QfDtNj4PgGLGzDtiJsyT9RMDUWG2rKAWzxzqZxMJE32zig15	12038	3NLEqS48h8Xc5k65dbkp9x6gfC3fAbPhRhq3mGeF4LtDbmwjSL55	1447	979	172	6301	8385	jxgiWc9VHzHScKQy8eo8Gu8uKuX8vWAsoVqGe2Sjj8uaxThC42i	6198	8755	8755	1617515100000	orphaned
12042	3NLn9zbPDb1uoAe7Xv18LpF7vyX5Dy64rHv1t8CeogFLZ3nXo36R	12041	3NKjWHFPzoJVdYjVvtBgkK9zauSi1rqPe7beezTwChfacLQb9N8x	1406	1393	172	6301	8387	jw9eW7o6JejXCVTdLoqbgp3nbemo5Mxxs2TeJApPV2ru3kn5cwM	6199	8756	8756	1617515280000	canonical
12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	12044	3NLKkznKn6cAJwFoYW2Kk6CFbbRMCBsx1RntRdf7pLnwELYVW7r3	1402	868	172	6301	8392	jxGQcQQU7t6TH9Vsdd1tdLLdDzdpc4u6PPSa4KNdyw1nSNx1cvV	6201	8758	8758	1617515640000	canonical
12050	3NLLJjMP2PtJEGH83a2ksLRZhwzt3LzU5pnY62b9y6NSr1RLSuDy	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1596	997	172	6301	8395	jxiBParrJ9SLm4KZDDWpaAwYvKwqmrf8pPJJwPtPMNhy19HhDpE	6202	8759	8759	1617515820000	orphaned
12056	3NKrJCtLxGfbQrL7nxAyG5TBkVdtzFzgNzoWvWFunSiLcKwneR2b	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1623	839	172	6301	8401	jxhw2N8cUPxgxp5xPu8bfcwjUuTEB2ZB5WWD7Cfmy7ZaHGteZTJ	6205	8763	8763	1617516540000	canonical
12060	3NLZx4uxhXMGSb7NW1SgHTDTdt4dG1KLCVvky5bcnnc8GJRJQ3Se	12058	3NKfP3i6FguUU7YKAXZrX9RWuz5RTm455mstAKCB26hr8m3AEoaZ	1402	874	172	6301	8405	jxeQP93kJufA5yjWA9Dwh9LtMZdE1jXHfZS9NT9hrhMLi2uW46z	6207	8765	8765	1617516900000	canonical
12062	3NKqhLkW91zCCZBVkBmXwT6yB6thHaSC824ptzYTEVEo4yPRtZb4	12060	3NLZx4uxhXMGSb7NW1SgHTDTdt4dG1KLCVvky5bcnnc8GJRJQ3Se	1613	1349	172	6301	8407	jxAcfnGahW9rR2KiB2fiAjfW6ZK8Wt9k7x7AKH7wwxWiRh1JEUZ	6208	8766	8766	1617517080000	canonical
12068	3NLEMvmmZGH6Umn7ynUiQWSzQ1QzLjUc5QHLZ8ARHgzoj4EzXymr	12065	3NLwUrahMUbgyjfrnM39NkNZVg24xJyi3mW9ZZT5WoPLtFyfW4Ju	1553	776	172	6301	8413	jx9cWorsVHjcCtqemG5GSGFCNxdTRmGNk7GoRGLTRMRue4C2iMQ	6211	8772	8772	1617518160000	canonical
12069	3NLaq76qBYr7aWgVeEtYxmJ1T5NyypV2w1kD57hHsM5pG1DPT3z3	12068	3NLEMvmmZGH6Umn7ynUiQWSzQ1QzLjUc5QHLZ8ARHgzoj4EzXymr	80	1147	172	6301	8414	jwRCjy3NR54LDrzXnDMVVhkWTLuEd9jvgb88iwsjVsHniBrmL3A	6212	8773	8773	1617518340000	canonical
12077	3NLFAx9dPdTJhbCn4YSbFS7hcFY3hNvRhhZLpdBHpKdESBwVvaUm	12076	3NKNe25uM2FSpT7zCyZf3V5mU7cTkJS2oc5zgtB9cCGDbEJe26LB	1547	1252	173	6301	8422	jwg8QVP2MeeeU9g4F8JLcyfRHuKfZP2SxfjeNLyGabXdyj2AgWU	6219	8782	8782	1617519960000	canonical
12080	3NKPnFkZGBxz27Ua3iA1LHFffysf2Ny2TJhEMwdEQJWH7MfeCoid	12077	3NLFAx9dPdTJhbCn4YSbFS7hcFY3hNvRhhZLpdBHpKdESBwVvaUm	1646	1354	173	6301	8425	jwmfedrXf6RU7MwNZv8FyRfE95gnwbNzJAXTLSGCd7USm3JDRMj	6220	8783	8783	1617520140000	canonical
12086	3NKvfHyfSQYeDRQdePsVyMoh5pzYx4NtgAdjWfdaV1xRzpi4kREL	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1407	1395	173	6301	8431	jxCWZRhSdP5Zo31GB33WAR6kDjTSa39YzAo7GrJAiyfMTaMR87M	6222	8788	8788	1617521040000	canonical
12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	12086	3NKvfHyfSQYeDRQdePsVyMoh5pzYx4NtgAdjWfdaV1xRzpi4kREL	1508	1141	173	6301	8432	jxT3Fy5iafcDiPEaUoFwwopM6Jc1mUFPipwoBQmrPj2K2sYvvza	6223	8789	8789	1617521220000	canonical
12092	3NLcNiXEx8pAsvF9YckyBegYMVxoxKcqU8TAS8P8QTUVXMqwCKVw	12090	3NKDUKvftxR5qBriNWcix6Qj53m5iCasHPktbmgCt1oow9YuLSHT	1556	578	173	6301	8437	jwWSfVKCafMncRcmAFhrgGYXDmqQ6s8VaJiB6zLuYcsceJ5SKuZ	6225	8792	8792	1617521760000	canonical
12095	3NLfPeNUa4ySkeFcPG3xqPQx5vvTezpa4ad6LmMZ9FJeq9XQzg66	12094	3NL6wYQoKmtM92LQopfFtUwPzQYw1Z1ctRpffQwnBMbC6KStbzJQ	1407	1395	173	6301	8440	jwmqYLcKLroaifxUyBU6bW1UV1r5Yj7Hoth1YFJcx6PdJw8jrX6	6227	8798	8798	1617522840000	canonical
12098	3NLuQgBjUcXkf8xUogw97ZWcCqQPsJNg26EG66KAAG6LFRSD2XwC	12097	3NKqnuEPMydkcToFAL5Ya2hLjy3U5CUVTHeK7A6mAJ4tKALSwo5m	1651	935	173	6301	8443	jxvrhNs2AL8Fc4JbgPaQUFhTZqFGhdR1wu224NfdDCwsWfbgm53	6230	8802	8802	1617523560000	canonical
12101	3NLLEUJ4XtTN58nGD2m1FSv8ufNdyPWfSTfkBdRJFaQxje7NtsfP	12098	3NLuQgBjUcXkf8xUogw97ZWcCqQPsJNg26EG66KAAG6LFRSD2XwC	43	1310	173	6301	8445	jxmLcBLUm7gZJdg3G4LZTeieQvMZSGNCYKbJnU4Wbx6zvvCmzVH	6231	8804	8804	1617523920000	canonical
12103	3NLkDA5ooYR5dJbvDDgVrjsFrCebaoZXNmUX1RhhRZ4FrbiZ1M5U	12101	3NLLEUJ4XtTN58nGD2m1FSv8ufNdyPWfSTfkBdRJFaQxje7NtsfP	1402	852	173	6301	8447	jxa9vHWpPHBBUC84URQFYCy1AXbWm1HNk8bP37saB61WGiGAi84	6232	8805	8805	1617524100000	canonical
12113	3NKnPXUkzYresZZ27RH8gV8DCYFRj3pQ7hqMzBaBjR8fi95DDCzU	12112	3NKdCasmPFXh4zs99mK5npz3rHAPXnd7tFJstCpznHobmsKmsKah	1403	824	173	6301	8457	jwjigcNT5DVTpvZBbsvi1wKRaU3oXaEbfEVxsUP94DuKFGakzgd	6239	8813	8813	1617525540000	canonical
12115	3NKX8vy7X9Emsq1vALHNW7t5Ky2MkgE4xAnmXmfJLQdYKXr4Geks	12113	3NKnPXUkzYresZZ27RH8gV8DCYFRj3pQ7hqMzBaBjR8fi95DDCzU	1529	1316	173	6301	8459	jwuU1X6d6puTAxnUZrSNX4tJm2BJWexvD52MyBRj8MFfoLqvm7i	6240	8814	8814	1617525720000	orphaned
12120	3NK49Z4NK2Qjmv6ctrpZvmMx5GSsCmThcMt5VA4aMmz73C1ufiVH	12118	3NLY9UGJbjpYFVFGRbZBKnHt1g8WPBRvzVaHdywJcUb95ibeiqr1	641	1336	173	6301	8464	jxvTWWwWhr2ENVpvbXjdTVXadPC9wHWeD6CaAyrpbMfFhVkCsSd	6243	8817	8817	1617526260000	orphaned
12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	12121	3NKd2Y5EjWhqEV3powj8ELg6MzX4R7QtrXSNcaPEAotWdZWwwQn7	1637	816	173	6301	8465	jwN7nxVH97vz88AQefSGtF2Pv1FPz6RQJ6NhvqF1nqgY7KVNwjs	6244	8818	8818	1617526440000	canonical
12127	3NKZfw2QuM6AHfzpnBE4eYQk2EXGHSkjxVPki4hmtxpr1R1iQoXP	12126	3NLZbYwSvoJ1Rmbpf3S2P7JAFhCkakarxTUhNx23xgxUH2AHUd5T	1402	874	173	6301	8470	jw7SCs9A3R3oEtsYmRQQHCdCmrYt9Z3F4vRVfaHQkpJf4MNDiDc	6246	8821	8821	1617526980000	canonical
12130	3NLBLnAjZKh8gknZYbnujZKnVWNvchnq6Ac8cnwmMBj7L2sDYWuN	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	633	1258	173	6301	8473	jwtrUopBDC5e5m2TV4xRWW6Q4tvzu6xV8QHLPXHbiF1zTb12sS6	6248	8825	8825	1617527700000	orphaned
12139	3NLdeA9fyBXVR1AQ5vULgVUELh4YzzeSGtDtDRKyW7hKfk1x3yVC	12138	3NLjvzKbsqAvbuFYYmdXc1gmfSQ979G4rCkSrSRoytnLxmjZpoyD	1508	1387	173	6301	8481	jxfKYuQGsxgSww1gRxzkfPmCBVyWDjKAL1T9NugUsXTBMexwmJM	6253	8830	8830	1617528600000	orphaned
12146	3NLtMmK2qNmwopvzCSsMMgzMTZAY5cRBBXTpgyD3fhpbaNm1Lpiz	12145	3NKdZLHCPhRZ5T9PyoqhHy18GRjc3JAGcFnXWXVBEUWBugYJb7XW	298	1062	174	6301	8486	jxQwBQofKwBUBb748JtAccDxQ7PTgVvyTzMNCq8yDHzw16BoCy9	6256	8833	8833	1617529140000	canonical
12153	3NLHF81pi49rQA9TT7uGvrk32ZS338sSesh1xiZ9wVfWA93i65Jo	12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	1649	1137	174	6301	8492	jx5M1QARtMD4GEez7ZDip3HLh9o9ifUWox67NtVhh2GFFd2URFa	6260	8837	8837	1617529860000	orphaned
12158	3NLepVYar6nBMkrAibhfxmcBHDLttD4hG6fUV4EGDcT2KNjqo22s	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	606	1049	174	6301	8496	jxYN6PueH2YNqFy9kMrxbUcT9oetoyM1z3uq1dqThBgxWJ9noqZ	6261	8838	8838	1617530040000	orphaned
14967	3NLdhdHdyoWKKDF2DddZkBcwMHxcb7M9rgrLsXzyEbH18fgbArWY	14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	1594	1200	238	6301	11032	jxwco8ZSRaxA5sy6WjfuXyBTGmB8bZhxogc4MJ1wiwxUEpiHzAR	7624	10806	10806	1617884280000	orphaned
12071	3NL5Zw6tjg1XSXT7HpQRyy479FkSUpSC9WWLK6hvqc6vcdZrvBK8	12070	3NL4pri2UPJUrL4GYjapGTpprPgcpFuYHkwYuKY7iAVxJ2Do3Qat	1573	1318	172	6301	8416	jwiAdSpcK7ajdH3stQzm3RcfPTMkCo29afCJCHanvTWDF9NAm8W	6214	8775	8775	1617518700000	canonical
12074	3NK9CF8HyBwvXmBQJWxreTF2oSX7nVGyvtC9R71amCJAqvFoxh6F	12073	3NLEAWKPWYMfqskJZe3Uk41ZTZPfvUnyUNJzc3vmYYDQXaAxYANW	1405	867	173	6301	8419	jwg5n5YFmF6CvP6v1Nzk4dCuayCW8bgNMcy4idgRXEUUwWbDQTQ	6217	8780	8780	1617519600000	orphaned
12079	3NKZr2R1xFpWwhadDHReJUowkYRURW6LPCAkXYQBxNdRcDDDu2Xs	12077	3NLFAx9dPdTJhbCn4YSbFS7hcFY3hNvRhhZLpdBHpKdESBwVvaUm	1406	1393	173	6301	8424	jwbTFaTw695q8syksnsyFeJhti2GzZXPBALJsM5JpGCQBHazsjt	6220	8783	8783	1617520140000	orphaned
12082	3NKaiC2RDT82Yc1bFAkUgLA4jYBFHLvEqpsbDWsZy8nKZA4uE7sc	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1585	1366	173	6301	8427	jwPkCgRz8me99vtavFrC7RbHJegKCKox1ZMQ4wh64d9Uwrexm7S	6222	8788	8788	1617521040000	orphaned
12089	3NLfw9ajspsPJHGbQsGShoPWASp59zVBvdG9JE2YM8zYpfLTV6Ve	12087	3NKUwd52XwMutCZhTrM2PMuz85bJ3X4Hx3ZEKizSTETE14fCfJ2A	1407	1395	173	6301	8434	jx3yttA6ftVqLdRzh7LeEvqjvSJZdAaoxz89NyRzNeVaauLXdaY	6224	8790	8790	1617521400000	orphaned
12094	3NL6wYQoKmtM92LQopfFtUwPzQYw1Z1ctRpffQwnBMbC6KStbzJQ	12092	3NLcNiXEx8pAsvF9YckyBegYMVxoxKcqU8TAS8P8QTUVXMqwCKVw	1631	794	173	6301	8439	jxtndxbUc2WUvm5YBkc39qKBb1gp3LixzaTAAvZZnBFudQ5owqt	6226	8795	8795	1617522300000	canonical
12097	3NKqnuEPMydkcToFAL5Ya2hLjy3U5CUVTHeK7A6mAJ4tKALSwo5m	12096	3NKFk1XZ1ycpXmtuy4jXkx4rSifBzGFmDQ4DXtgz1U26Q1J4QALB	1451	1292	173	6301	8442	jxRBGid3CJ21qX3ccYgTU8CdzmbTS6NWjAhsqftzvQPLgFtqesq	6229	8800	8800	1617523200000	canonical
12100	3NLMDkyzANtQoEveYhrdz37nVzz4ZwLQ4G2TvvpnjvNt5HfqvPM5	12098	3NLuQgBjUcXkf8xUogw97ZWcCqQPsJNg26EG66KAAG6LFRSD2XwC	1637	816	173	6301	8444	jxJpwR8wMpA6YY6x31jGzUaXzQ5PSCfHrs6WsdUif2sFs192cY7	6231	8804	8804	1617523920000	orphaned
12105	3NLVGKipGTQZh8BRNTcdshPNBkcuqJg2Loz28JAeftcqWSYQfyJb	12103	3NLkDA5ooYR5dJbvDDgVrjsFrCebaoZXNmUX1RhhRZ4FrbiZ1M5U	149	1037	173	6301	8449	jwz13AGfNYQ77D77bqjHRm89RA9FMT6pJ9kyvWLsXAceyguyG6E	6233	8806	8806	1617524280000	canonical
12110	3NKRprD763T1dGD6JtKtaARVFmciPL6iXv1FVLwa4n5NHo8sHqHv	12108	3NKPtcQgXLvuK5A3VJvtsnAAbYmxi3Bi4DwKJjX5VjUtj87xvcdu	1624	1208	173	6301	8454	jwhHwP9uRJ19LKsKUvtdwJNR8oBzUAkTvMHxXV3Yf3aqtERYDL8	6236	8809	8809	1617524820000	canonical
12112	3NKdCasmPFXh4zs99mK5npz3rHAPXnd7tFJstCpznHobmsKmsKah	12111	3NLHxxNMASphwXEK9eX1cfn4hmwUuhXCsUJqt3BAawBYVxbWXEjP	1587	991	173	6301	8456	jwgSFUzsowEPKgjbkCUoAW1XwUKiedvXc4jQFi8n64Kwp6gG7Us	6238	8812	8812	1617525360000	canonical
12117	3NL6uBAUmVNf1aCA6dBaoy5LhLK4vREBWN3DLPLtTEq88UUFkka1	12116	3NLpbW2Dk6HA9tDbH99H745dHtPzHicGDnxT67v7hvqq2TAnWPAM	1654	1340	173	6301	8461	jwA9N17VkND3rZibFoyiSJQ2RmShfGeHL4gniuu1zzG1oD7CHb3	6241	8815	8815	1617525900000	canonical
12124	3NKNmdJ6wMuoxBYh7uE8ULjPk9obH7MRnFw9PiGszK97BbLuqpiP	12122	3NLimb9iiiRB4u6iQg5xeR2N3ZRGp2WmprGWviVjm8mPqccHsoE8	1522	1322	173	6301	8467	jxBYJRwJthzCprRzekcUHFVFPZm2jE71FJ6PQxkNNY2nA5uNJes	6245	8819	8819	1617526620000	orphaned
12129	3NKi1KomQgh1spw1pkah5NPXx5m1NGk4hyp7ezyUPx2G6k8i4hYQ	12127	3NKZfw2QuM6AHfzpnBE4eYQk2EXGHSkjxVPki4hmtxpr1R1iQoXP	115	115	173	6301	8472	jxCvWuf4vkJLYTWyzTut7LAuNMZMtfxt9xB7HKhkP5yDRRZSqoX	6247	8822	8822	1617527160000	orphaned
12134	3NKYvRZi3biP4GEtoxadxoREsrkoeTG8JZqgCbbTtprKicJFfrwy	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1407	1395	173	6301	8476	jxdt2W2sM9td4pLuhQ4qJwFcrJ79UKZA4vWGGpb9yhxKBGonjs1	6248	8825	8825	1617527700000	canonical
12136	3NKLm2Nrm3evQTfzVePZA79223UJ1Ca3zd8t6Xdkzvt1ppRcCtts	12135	3NLREMHc7LhPPJogsDURYXvLydWAxnygb3EqWTSwFLN7Sr6WdpRK	1451	926	173	6301	8478	jwkDZZ1eXV3ba3t3uV7pjkbvtriwAby4XQdDKhfnZMxqD8JZimT	6250	8827	8827	1617528060000	canonical
12142	3NKpSf3WdRgmQktQGWN8jFniWckBEYLqRs33U3HfgvK7SeWHJ2RY	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	532	1177	174	6301	8484	jwAdExdroPCzMyC49THTSkM6YGZ22fR1fPJDPWPWxR23wGWXoKR	6254	8831	8831	1617528780000	canonical
12141	3NLAxY57HVtKBZSg339y3waNAjGcnwBdyfUZPcFnVCKqmzyJYkML	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	1529	1316	173	6301	8483	jwtMGf2WsdkXx85MmzRYdLDg8FK1KndmHQ4ipncx2jwRn6jfgnw	6254	8831	8831	1617528780000	orphaned
12145	3NKdZLHCPhRZ5T9PyoqhHy18GRjc3JAGcFnXWXVBEUWBugYJb7XW	12142	3NKpSf3WdRgmQktQGWN8jFniWckBEYLqRs33U3HfgvK7SeWHJ2RY	1406	1393	174	6301	8485	jwFDzFzVpDDKxkM39PMtupKXd6H4HUkwzcWqWAg7J4NitvN1fWG	6255	8832	8832	1617528960000	canonical
12149	3NKgxRsG9FVdVjrKRT7Ljbr4EqkVVJQsiwb3F9iuqaGHED8DMuxu	12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	1671	1365	174	6301	8488	jx1tudnTU54YB4p1KYVgdFXhe9LsqjDvGAohPuXC7riGD3kYsfE	6258	8835	8835	1617529500000	canonical
12148	3NK7cEMkG9jXD9vv3V2XosrpXVSBXThsmKoJf4n9x6QXABcf47TC	12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	1671	1365	174	6301	8488	jwgQkhB1jvEQrvogCz3JVDhbnPX3S6J8B48XBtQeBJCNVVbZqyY	6258	8835	8835	1617529500000	orphaned
12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	12149	3NKgxRsG9FVdVjrKRT7Ljbr4EqkVVJQsiwb3F9iuqaGHED8DMuxu	1407	1395	174	6301	8491	jxqaguu54dQQffbNTWxkj2AVKLNem8uwCcSMkL1TKnt5bzZ1Pnz	6259	8836	8836	1617529680000	canonical
12151	3NLw4GDyJXNFzu7pULcRDjnr1uXyFnd4UZbpX6YN1zPzhFJhi9zx	12149	3NKgxRsG9FVdVjrKRT7Ljbr4EqkVVJQsiwb3F9iuqaGHED8DMuxu	1406	1393	174	6301	8490	jw92JryAD6xcgNeRaM7fA59WpgGNkGb9U3sAu6oCh7WPdqs8F9g	6259	8836	8836	1617529680000	orphaned
12154	3NLRC35xzDEVD7CuZ73pxkKUXVAx8mKyfuPc55Ranj4uwu2pdeUW	12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	1506	1373	174	6301	8493	jx4tYAae7VPBeHRhDx4aEMG9kWWBkGRQ3bjMxKYA91GgG45gRKX	6260	8837	8837	1617529860000	orphaned
12157	3NK6YAHhgy4rZXMNQjssUapeNpcxJE2yNAErV9GnYSns5JTWxpcM	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	1610	1314	174	6301	8495	jxbdXBu1AGVmUFn9Bb6PSC7HBREcRSBLijk2T3uJvdJTGPFGwN1	6261	8838	8838	1617530040000	orphaned
12160	3NL7bPdxK9gmgrx97zCr94LMBBQSvCUZiNJ3gA3ywrfnfhpMafZg	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1629	157	174	6301	8497	jwoFo8SfV2uzx6znL1SrT2eTEHcpevn7xFXuCXaBiaf6D84xQ34	6262	8843	8843	1617530940000	orphaned
12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	12165	3NLfJARkPbxb7sfPBQg9PmZxjTNjBM28JfNYegpX3BTVSSPmTkqN	1596	997	174	6301	8503	jxNpwAgLnrCJizTtNQGXM5CVajZApWGVtVuGusGQazxZx2rCwZy	6264	8848	8848	1617531840000	canonical
12171	3NKkEo6zVWSup2g9yQYZQKHEN51QBiAbXFQBGxuPyRFMvraM2twh	12168	3NKDMFRQUPvuiJQntQwCbbb11ZEaFQPy1bGZFYtBZqxT2N5y2PTG	1489	1134	174	6301	8507	jwyJGeCs88FtxHLtzBtbwmFH8JwUgiqa6XsjrJtpgo39WEorxyn	6266	8850	8850	1617532200000	orphaned
12177	3NKr28M8W8k8Wwmy8P4CE24NqJq2X6WnMvdC8i3o7utBcrQ8gpHH	12176	3NKLgwJAcLMabRpNfxVGAMca8RSreiLGAZBHao8uKQ7XKW6Lgg7D	1634	1331	174	6301	8513	jwYD8fj5fLMjrz1XeBcp5mjjJXeKbfwCZ8qYUmMbMCTjgsaoqo1	6270	8859	8859	1617533820000	orphaned
14992	3NK9KaCbu3Qg6A9DLZpSygCdRFfteCBLbcv5baDssx97SwyWGDjd	14988	3NKpe6Yudy76PxCicWjpuav9QoM6bdeA8iTubk1XV2ZVRkx1xYgD	1594	960	238	6301	11056	jxqPEaH6VGdqjnFayWbsVdXyu8fUgi8StEmMTF5QJzb4GwnJCqT	7637	10821	10821	1617886980000	canonical
12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	12152	3NKgHfypa6k9nrRJ3eohufEtrgCzpgy9Yoco6LDNAU3bR4YRh1We	149	1037	174	6301	8494	jxbzEZvaoyAArVshGi3i2Kkdf7UKYZ1cgbduSQ6CVrV5Dp9h17L	6260	8837	8837	1617529860000	canonical
12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	1610	1314	174	6301	8495	jwyYg76nZzXGKYXsMRn8G8AxgQsKsFW7kdVvMfYwMLwQuyCBvZF	6261	8838	8838	1617530040000	canonical
12162	3NLZ1R6FKAfrB3ANKBiuhyMDHXuRvGSka3uu5pTEGko9GeC23NLX	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1623	830	174	6301	8499	jwTzeYidiPdHx3XKsgBsfVFTAXg7KER4nPyhpJWDieCVRoEibAP	6262	8843	8843	1617530940000	canonical
12192	3NKBDrw6rLn7tXdSJMYwsJFBzS7AUY4Lu5eX8BK57EnjEGJwjV19	12165	3NLfJARkPbxb7sfPBQg9PmZxjTNjBM28JfNYegpX3BTVSSPmTkqN	1518	788	174	6301	8528	jxHAYkM9dBgd7L79V2LpVUowttfHtGvqdDToxsrsVpKseomcjRh	6264	8871	8871	1617535980000	orphaned
12167	3NKgLEQkWM8FeUH7YEsjGEUAJHRhY9FHeRtsCk3MMNynUMGnYfhA	12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	43	1064	174	6301	8504	jwnGDkSvGQeXugLYUgqcF6vspq4iT8Ls5d1ujMc7feNUUccKsD5	6265	8849	8849	1617532020000	orphaned
12175	3NKLLfEuxWVNrbjZraQab4KgmGw3WUg3thmCkPespX6jaigi976y	12173	3NKwKWGLvHDwirwyNJTYeJgkjrm1S2peSsLj897Kh8a9186HHD2q	1622	1356	174	6301	8511	jy14AYHW8BR9HrsqS7m92XCkUtmYfgQ6fA8vGmkVbfFjCJ3WCwu	6269	8858	8858	1617533640000	orphaned
12181	3NLCWmRH9GanQAoVB5yjcsBTcPsLYVQwMGnmNFNuJmRog18rkUNr	12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	1426	1238	174	6301	8517	jxVGrSur6ZjpLXazBs81q1zLHT2Nzkt4tn5E1z5FmMG1BLBA6au	6271	8863	8863	1617534540000	orphaned
12182	3NKP2ppFMLQytb1FN7ytUsVunMia3Ce4HxMYeoSNkPnUNLBJMHMQ	12179	3NKBhaLRVq4qLaSt5vD5UGbtMxkeGVVKyjFwFE4G7TziyngurnjK	1649	1137	174	6301	8518	jxTJGzoZzdGwQzWFyNy7RNBWXnDyz68b23jnJ5b77izMnrXFYSV	6272	8864	8864	1617534720000	canonical
12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	12186	3NLUb6DuL3hzMmwuxKdHo1ij7bz6APHeEBme1pVRzxVRtpSsMsTs	1489	1380	174	6301	8523	jwQJYHKEJyXdoV5YEAXEAMLLS8W82Cbt28QH92J1TMYxvds1JhX	6275	8868	8868	1617535440000	canonical
12188	3NLZRjtfJyo6PyLy8jdsumfc77HmaoPukZqofXoVSRyotLKYwLmt	12186	3NLUb6DuL3hzMmwuxKdHo1ij7bz6APHeEBme1pVRzxVRtpSsMsTs	1500	1297	174	6301	8524	jwmYprb9sqocQ7igLNThDSKiin6vD6MGGx9ZthLNBPorVfyPyP2	6275	8868	8868	1617535440000	orphaned
12197	3NKahgU55hiSbYUMioKtTq5fYixWWcTQmosLcNQuqRHWrX4qbxAC	12196	3NKDRJJGJrKDHgEzCQV2nVgftWU5FPFr6Bt4kWEkEhzjjN5dTJnU	1403	40	174	6301	8533	jwNMNknu3kCxm35SieZkovPsxeyf8M5iViTnEtPmeN67QdY7s3X	6280	8876	8876	1617536880000	canonical
12200	3NKHCsUCkYxhaapJLqu5UamCwH57t2idtQ87CAq2gy1t26udo3mX	12199	3NK6tt7GHxFwCWat5xZDGPXMA5ppefBzFb65czwHmrd5HhLcvFvz	58	1281	174	6301	8536	jwRqCG9zRqpUEMSwEZnKUSJmQLQhfdJb5eYN9QgVszL9GJXkVho	6283	8880	8880	1617537600000	canonical
12203	3NLhzgCtDzrSw9nbqu1SnMTZ2QzaVZXYbBE4xrG8rAzKnGgZe7QH	12202	3NKWQ9cG2FPep7it3uzgSo6qLSV3ghKP92NZW39LkXivGEUDQNCJ	1513	1379	174	6301	8539	jwDNue33wJ1aVf2PXzYoTBenEfn5kaisvo1NbiaErbC38ZjNpeP	6286	8884	8884	1617538320000	canonical
12206	3NKJ5GvttepZWQtCsJpjFFgrf2Jddufbv8eGqFKsauYPHsKxk1ng	12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	532	1057	175	6301	8542	jxMKnyumjSRKfCz5KdqPsT2NmhqgR7Tawo5MHbx6rwkdynqZ59M	6289	8887	8887	1617538860000	canonical
12213	3NKUwp9J1xy8LQBq6s12qN2ebcL7M9NAqc5QnZnmVo24GwFb88s5	12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	301	301	175	6301	8547	jwndhChB8N1xsLxQbytFKLa7BWYcR8iDNS2DvJabivEwZKJHXPd	6291	8890	8890	1617539400000	canonical
12216	3NLwhFZGDhxMfg8At9p16MNAgPtuEHt2mdbkzSw5AcVdCj76ykVw	12214	3NLJnT6p1v4X8yWQ4j9CQ9K24gA2ugMgLGx32eEG6Mh5JExdg577	1536	1313	175	6301	8550	jy2j9oLfc5fJDL9csAFdpdso5feRT7bCBytBPa6JNGzu9vbdSjm	6293	8893	8893	1617539940000	orphaned
12218	3NL2mUBbVkdiHSaKrYpksiRgugMhKgwrvA4YHKsJRvDgTrWu4MEc	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1457	1265	175	6301	8552	jwP8btSJUQtkyjqzZYQadtuccSqTpseBmoDA64vUANQvVN6virg	6294	8895	8895	1617540300000	canonical
12221	3NLHsx9BW93GzwcHmkQ6wDLMiF3mt1w5uSBJV9AZpyYSo19Ss8zz	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1631	794	175	6301	8555	jxc7zWJLMqKk72tHiWoQrrhpjSF4gCbNGc9kF3fzLTF4E3AsD1F	6294	8895	8895	1617540300000	orphaned
12222	3NKtAkvLKgk4iWteacudBZMPS5J4u2aM3wBShsBopP9v1LmFxi4C	12218	3NL2mUBbVkdiHSaKrYpksiRgugMhKgwrvA4YHKsJRvDgTrWu4MEc	1406	1393	175	6301	8556	jwXi4abrQcMf7su7d6HnJbSwSN6DgFCTTiAkb9eby4tC6GWmTmg	6295	8896	8896	1617540480000	canonical
12225	3NKsaek2PghUy2iWVzsGKMkCvzTcUjw4KJs4UQNpqsgLi5f9WYHL	12223	3NLqTMFSP48eDJxkUu3WKtf4h2LdUntuLrzSUSMkQrKpitySp411	1549	1236	175	6301	8559	jxLTqmav7boAE6hGhPE3jRgREj1jaQdrDVN8WwnKGCB7kV8ov2M	6297	8900	8900	1617541200000	canonical
12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	12230	3NKjHc8ZRQ5hyaiyyS88uvpuiYVfKXLDdfaRPHH4CuDSaPiSjXTQ	596	1060	175	6301	8565	jwXt8r6VuFLqiTb6Z21PSNHyrCabM9nuinGfhhodwxZ1hnN14SV	6300	8904	8904	1617541920000	canonical
12236	3NLFvjVNgLkmtBiCyF8rK3YyPpLXMtZYtZDCJVamCgSn2xJb35JX	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	532	1057	175	6301	8566	jxd8bYbdGuGDZmxgkdZK4txrCTBneuu6husEJqmUqPHqzfdR61G	6301	8905	8905	1617542100000	orphaned
12239	3NKUVtqoZ5EsF4QcyjaFaXd7k3E5NFWLUvjQDAvAu6NQ16sQNdhU	12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	1607	1102	175	6301	8570	jx8DU3oWd1Z4QHPeWk1wBTinQFzkPvDRJGrV6dwHbGZNC63uBDv	6302	8906	8906	1617542280000	canonical
12241	3NLQsV46rnZ2agccAgXBdTaUqPKhoA1wKHkBRGtGZW4xb4UAUrif	12239	3NKUVtqoZ5EsF4QcyjaFaXd7k3E5NFWLUvjQDAvAu6NQ16sQNdhU	1642	1121	175	6301	8572	jxTGGsht7RWwY4ziHoFJW3owWQ9gyT4iy7C5qGtvpMFfybJ3stx	6303	8907	8907	1617542460000	canonical
12243	3NLHkeDxmK2cwHcr75eM5Pr3iaGkfPsnLJMYmZntYVgqQqAB5CvX	12241	3NLQsV46rnZ2agccAgXBdTaUqPKhoA1wKHkBRGtGZW4xb4UAUrif	1407	1395	175	6301	8574	jxPXu8kVRWeWBLX1vgBFDaGuJBAVAYZaPXnaSq8pkXr45X9QH6V	6304	8908	8908	1617542640000	canonical
12246	3NKHAM2QzhUg5cvdJ3FctBRenRVsLKcPvR2fpyePU8YWJtMEywai	12245	3NLUsowZ6oJqPtxbvUFyw4HBdqwhtTkzM5uB8gHQKTKbR9duzTQW	1534	1317	175	6301	8577	jxnzcJGgm7Uz7J5QPRnDCYLsWHdkvKvx2zjebtc23awWgvzwDQY	6307	8912	8912	1617543360000	orphaned
12249	3NKEGb3F9k8NrCAt2hpVm9DjaAjzm32Nz88EpqmxwvBvKuvoZCgc	12247	3NLSX29nY9mqGp6pHGQxBw5YXzLxEEEk4yaKLgRF4TmAAwFaZEHq	1579	1389	175	6301	8580	jwTUBCBFZ8rotPzoanV5Ris5qzwgaaigjQGMn94KKGR9Pu7ENTH	6308	8914	8914	1617543720000	orphaned
12251	3NKYeUEkADDACNT5fK8VLQTkqBpvMSVPcse7E6M9tWYagRvxpzex	12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	1403	782	175	6301	8582	jxZe14SjsFqzbYPgZhvKSfAoeJCsYELqve3mNENZaA5uyjmgwhH	6309	8915	8915	1617543900000	orphaned
12264	3NKTkU3e9TSkmtaST9i1itibk4hNtUnAH17uARBQVJJAhpxiPVb1	12260	3NKR8QCh28xMfnUjV9a7vA1eYm6WChs6xZLeKeX7Hdm2tF4X4aQm	1407	1395	175	6301	8595	jxu2crZ8KkWzWfCDGu9k2CdZxxjJvHt9jYKGm8q456oJAVTK2ZW	6314	8922	8922	1617545160000	orphaned
15015	3NLaYgNzCQpPDAnrCibaw6tMCYXZNuScpQvmHSvMo4M3b8Bqoxkk	15014	3NLV8eZCHRtMPkcKaQHHPk8EiCUwHVk5RFhm6MWeERAPDoMmA7c1	1581	778	239	6301	11079	jxbg15tjoJHHkV38e8RSaZK1cnJ1y1FhS79fug89vF6nbG7nSxr	7650	10837	10837	1617889860000	canonical
12217	3NLNmB43aSf6igZUAmZo5Ai2He6BGwikzHcV8BW3DrcEkuCU2FHv	11824	3NKJypbm14N99L31CBPRwNm2yUQzZcs4dhA23hEj4pCYHmSgWD9b	1423	104	169	6301	8551	jwSukvAjkFM2RvmJdPmNR2uKrZYSmGU9H4uapGwfCuLrPNsxRaL	6078	8893	8893	1617539940000	orphaned
12261	3NLPG7x4jCHPUnpk3NHefcuN3obBzWFWyT87Vs6bpfxV2ydGZGwh	12115	3NKX8vy7X9Emsq1vALHNW7t5Ky2MkgE4xAnmXmfJLQdYKXr4Geks	369	1312	173	6301	8592	jwVEdfAyiCXApu53TraBFEsY6eyEUmV4iRnYmKCW5w4FaAcCkbZ	6241	8921	8921	1617544980000	orphaned
12159	3NLwd6tQyphbtj7a1p96HoJdRgbZNMb9PS7mszBabtEY8VMF4Nxh	12155	3NLgEqQBWgcVC4t4b8HAvTfi31TdyHek1sJfmWBf2X6XvkUc4uMH	606	1049	174	6301	8496	jwxcn2Bf453G9GaaQ385BAZhjnFzAd9nuXnMcHXve6YLibk7hcR	6261	8838	8838	1617530040000	orphaned
12161	3NLgjQo8CZEqDoAg2eNqLpVsHeA1Nji2c1dw1pchEUz1knqq9FiF	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1501	1360	174	6301	8498	jwk4wZ2Fihqu7eD3ekrDirrPs1bCfTjX6CC2GBehFf4MWU6DUAU	6262	8843	8843	1617530940000	orphaned
12165	3NLfJARkPbxb7sfPBQg9PmZxjTNjBM28JfNYegpX3BTVSSPmTkqN	12162	3NLZ1R6FKAfrB3ANKBiuhyMDHXuRvGSka3uu5pTEGko9GeC23NLX	1406	1393	174	6301	8502	jw6wJ7bCD9KyAUpDKNVVUZ3uFNpY1c844kUA5aqMTymwh6rrUsE	6263	8844	8844	1617531120000	canonical
12169	3NKS8MayPWhAKvYE6MwHWwzMBwngy1ArLysx6eGoxEb8jc2jNHJD	12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	43	1064	174	6301	8504	jwr3wqpckqE1ihqqcoUXFc96xZHUYgfj69bgg23JpQ5KcX3TDep	6265	8849	8849	1617532020000	orphaned
12170	3NLnB6ozynfDQdk2ZYzB3R1HryiuYbDfHCvwVoeUasT6WtaKvzuW	12168	3NKDMFRQUPvuiJQntQwCbbb11ZEaFQPy1bGZFYtBZqxT2N5y2PTG	1536	1313	174	6301	8506	jwkKQcFh9DLVgQG9YL5cCFLECPxHvf1WnLM1DAKwW6kG6FXEyUt	6266	8850	8850	1617532200000	canonical
12174	3NLe2Q15CQskZzCAZv3MWojfP27kTTKY4hn5dRXruzxDBNQC8BPZ	12172	3NKURyz4HsGP2LhPfNLfJWqXz7TWzTMvdaem16RYGvw9CWUHffVf	1407	1395	174	6301	8510	jwN2QeEHE2qVx3yLStGARnqgF73LUuZhLStTxwYjWyjNkU8ZcmF	6268	8855	8855	1617533100000	orphaned
12209	3NKq2PXkLsaE4RLvPxZGkLBNYxZspk8wi4eKfhgcbQaQ3Hreh4dm	12174	3NLe2Q15CQskZzCAZv3MWojfP27kTTKY4hn5dRXruzxDBNQC8BPZ	55	517	174	6301	8543	jwjt35kH1Qfq8Vxat3f6gsPjNbSPB8cQLTKFY8cRfcyZEKBLAj7	6269	8889	8889	1617539220000	orphaned
12180	3NK5kE6K4JAGxP2LwAcHGZutmbbAH69xZL6CEVAnZBYAuktffyoh	12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	1609	967	174	6301	8516	jxS6b8uZFHS1GJVhgDGXBW2t67UVSdebm8iVFT9mFJs6vkvNozs	6271	8863	8863	1617534540000	orphaned
12191	3NK4ZawbZJTsoZtWqWojPh7gqpQPA6omE5rwumdjW5kQtsx6P58y	12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	1406	1393	174	6301	8527	jxsRvfs3ivk9d4zeXccBZcVr7MiccUAD4Mhmd78kJb78MYB1pdh	6276	8871	8871	1617535980000	orphaned
12195	3NKVFEAjMLhqUX4NHAC3BcdQRhPuwL5PzUK4awYSRGsQWJk6VvD9	12193	3NKJch77h22pHdHNemMmAijM5AajpEDWjUCLJ1fqGLC9GxrRvri8	1426	1118	174	6301	8531	jwNoa3SzY2ZBxJN9zBvmPTbP3J3AgVexNSvZdq1WqEUsphnhfob	6278	8873	8873	1617536340000	canonical
12198	3NLvRWL94odHkBrkT4c5mswrXvAob65FnArLd71KcMqQ1yja5ZEq	12197	3NKahgU55hiSbYUMioKtTq5fYixWWcTQmosLcNQuqRHWrX4qbxAC	1406	1393	174	6301	8534	jwjpeeX9V9rXSraQ6rgtUoFgqVCfc7xAwKkhveNEK6FMw1TvLzy	6281	8877	8877	1617537060000	canonical
12201	3NLgWw6J1d6XsGWDNrXoeCNuyWJoNg1qeGTm7nBkmWJwFDa1BRSP	12200	3NKHCsUCkYxhaapJLqu5UamCwH57t2idtQ87CAq2gy1t26udo3mX	1406	1393	174	6301	8537	jwcbdSn7UrKrhQYr4wLBwH2MTQ1T4GQkTDToPWTw4miZrtfvXo4	6284	8881	8881	1617537780000	canonical
12204	3NLmAkdFi25aBP7BtU5J8eeV5saxJztqP2UShpFzwPTJpRmbwDiM	12203	3NLhzgCtDzrSw9nbqu1SnMTZ2QzaVZXYbBE4xrG8rAzKnGgZe7QH	1507	1154	175	6301	8540	jxDJJAduvE17x7EuvATRkzD1jWZuQh1u68c6zWXtnoBAGr9Qpy5	6287	8885	8885	1617538500000	canonical
12207	3NLhj4TUfrCqQPV7A7io2i4hxCHzSyxMKgu5NpYx4jXnDzMci4A3	12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	532	1057	175	6301	8542	jxVVVTcr8xYpsWeuNn5RNq7A3bmm1N5SBMv76TcFBF8iLMa3Z6X	6289	8887	8887	1617538860000	orphaned
12211	3NLHmNdzkuC5iFsBCq41fhXg9eCeadciwEvEP2VAYP3Ju8BjmUmT	12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	1588	1146	175	6301	8545	jwmxm3yjoA8126ZNFfvvsn25DiBrDYwBanEdFAvATGH37yCT3ts	6291	8890	8890	1617539400000	orphaned
12219	3NKrn9irp5ymv4WEZSJFXMJusYv1VfVXhJjBVeLZXsRMZTvLHAjX	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1483	893	175	6301	8553	jwqcJbT8Wt8Gea6cQEKWG8tmrGmJZFjK7nTriGuevDqfFPAgn7w	6294	8895	8895	1617540300000	orphaned
12223	3NLqTMFSP48eDJxkUu3WKtf4h2LdUntuLrzSUSMkQrKpitySp411	12222	3NKtAkvLKgk4iWteacudBZMPS5J4u2aM3wBShsBopP9v1LmFxi4C	1407	1395	175	6301	8557	jwrqyJASfEGY5YqkynsYtWc5Le2VtM9S9GBbZUbCPubLurwoxBy	6296	8897	8897	1617540660000	canonical
12226	3NLsLui7bp33q8sefUadSmNNDXpV5f5b9vGwqDtgCtbpHaUjtfL4	12223	3NLqTMFSP48eDJxkUu3WKtf4h2LdUntuLrzSUSMkQrKpitySp411	1513	1379	175	6301	8560	jxVqwpkpvrMH8nBSmwoRQ9pKtrsFx1jB1PziPerDksxD8UzPVCg	6297	8900	8900	1617541200000	orphaned
12228	3NLiMmd3DaYHsTE8ng6szTTup1gdXbLskqiJn3zGqu4fS5Xdh5kU	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1599	1287	175	6301	8562	jwmJwvUEmGoKPnYZr4zWREfgpUwjx7BgpHkdNAWKo2d9BmMpvds	6299	8902	8902	1617541560000	orphaned
12233	3NKRyhpjLCiehMjiB21NcxGMJwmCFWsGC8cUsrgfavT3X1mTWJvN	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	532	1057	175	6301	8566	jxMBFPYm7UjVdU1N6R6Tz4D4dhx1RxNSqV7gvJdWUJ7zsuKFt11	6301	8905	8905	1617542100000	orphaned
12237	3NKWU5ASkQbBe38kXudMX9QnRCrim1qaodr1xVbU78PbWkAWsb9B	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	532	1057	175	6301	8566	jwmKvZo8C4hFE1qnYMsUXjv8ScR91SJhRcTNpn6f618dLXb2o3D	6301	8905	8905	1617542100000	orphaned
12240	3NLFvof4mAbtr81cH91Zs4efx5XtnYMXjUqFnwjAPmKUmPD2DoJq	12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	1675	1342	175	6301	8571	jx1SB1wU4P3MqVbq1xacwSvkuHn1M9bbMXTEnrL7m14EbWsPFU2	6302	8906	8906	1617542280000	orphaned
12242	3NKKjuXpT9hKa9oHkcZCgwA3SFonCB4xzVWnYuyZBEGQxkcAA3oc	12239	3NKUVtqoZ5EsF4QcyjaFaXd7k3E5NFWLUvjQDAvAu6NQ16sQNdhU	1624	1334	175	6301	8573	jw83u572y6m6fJLKKdvvhvtEFiBifPu9LhMctAZaBEB7AGaEUTL	6303	8907	8907	1617542460000	orphaned
12244	3NLMcXg7X2CZpiPNJYZP3JU3ww1h9CANW2LLuAWjomQJVvtRgvr9	12243	3NLHkeDxmK2cwHcr75eM5Pr3iaGkfPsnLJMYmZntYVgqQqAB5CvX	484	1073	175	6301	8575	jwMqqs2T2fvZsbp7AvfwjUckJxsnkGGEJiF3QNW5GyuieuBVtJe	6305	8910	8910	1617543000000	canonical
12252	3NKqGTMoHXisjBiYhctCDPWYPkTEJQ72J98wjRj6h7GZ2uofTK26	12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	1419	814	175	6301	8583	jxQa3WyyWcKJLx9oqv8n2MdgbVkVFPisfVXMs7QujhPbmacJwsZ	6309	8915	8915	1617543900000	orphaned
12258	3NKJGW8xVW1W35Zn17vzK1aUfmakNRWMtLZtzjMd5sTTknkqQ12F	12257	3NKYgSvm385jNyBPu8PmDt77fAvVtL32toqZEpGrCvTxq7pc2uAA	1407	1395	175	6301	8589	jxEKCVPeBqs36bwTDvcDpqpwJYhuWpQ2Pxge6LAVGkRBxLpqwBy	6312	8918	8918	1617544440000	canonical
12259	3NKkb3nLVXckS4yneh8YhVMKwKeUw7viuNgRKjchv2GgyRn36PJZ	12258	3NKJGW8xVW1W35Zn17vzK1aUfmakNRWMtLZtzjMd5sTTknkqQ12F	369	1312	175	6301	8590	jxyauvmWF46s65rkQQATGaPdj3JeVYtywbZCba7yf5DczZ7ey6p	6313	8921	8921	1617544980000	orphaned
15380	3NLwPQczAE6CrHuff8qHPE7JAAQ4r3RKWzVxnQNcp5rqe8XZvx5L	15016	3NKvHDjEDMeePVM9SFZrcnH5ZtxKsV8sykF1BYDyMwpCudtRitLf	80	1147	239	6301	11418	jwnTD4qEoCzoNDmKs4GokBwSHqL2VHPW6qo4NJ82SiNXJ4yJAr9	7652	11083	11083	1617934140000	orphaned
12274	3NKXVGgQXFugoyKuf27iK5EXCgTseaJKwxgsPxShrijR2heC6hrA	11967	3NLXLEgJJB7c9eeGvwdhhmTruzBsfauunijUoWmX6yuN8XpqoR6V	1460	617	171	6301	8605	jxTYmXUA7EtAmcvLoRdk1XxZwJfg67mUSitjuEvwxjs2w7ozPDP	6159	8928	8928	1617546276807	orphaned
12164	3NKe88JJzL57HggkjedTG8WAzGTebLHtaUEpNNhC7B9s3Dycwj2K	12162	3NLZ1R6FKAfrB3ANKBiuhyMDHXuRvGSka3uu5pTEGko9GeC23NLX	1536	1313	174	6301	8501	jxARp9vaBM3sqA4jhiQajfPyot1HNWgvwLFJSGkqAwvW2gSXAKh	6263	8844	8844	1617531120000	orphaned
12168	3NKDMFRQUPvuiJQntQwCbbb11ZEaFQPy1bGZFYtBZqxT2N5y2PTG	12166	3NLbmW9N1hPijCMsx17Dx7fNcksJhuFuvMEpEa3xfPknSTNoqihA	1406	1393	174	6301	8505	jw73gAzM9ga1VbrudzKVq8qnU25x5o83i35Yy9jzcZeoNZ95L9S	6265	8849	8849	1617532020000	canonical
12172	3NKURyz4HsGP2LhPfNLfJWqXz7TWzTMvdaem16RYGvw9CWUHffVf	12170	3NLnB6ozynfDQdk2ZYzB3R1HryiuYbDfHCvwVoeUasT6WtaKvzuW	1481	790	174	6301	8508	jxBE8XfB5YLGzWz1qeV4iERXveU3wbCGtEp9XG7wfnY5eBEtNHy	6267	8852	8852	1617532560000	canonical
12173	3NKwKWGLvHDwirwyNJTYeJgkjrm1S2peSsLj897Kh8a9186HHD2q	12172	3NKURyz4HsGP2LhPfNLfJWqXz7TWzTMvdaem16RYGvw9CWUHffVf	1405	849	174	6301	8509	jwDfm4RFJ6ZpwFocaAWv5xWBdJEqJGtbcm5xveu4ioc2xhi8zy7	6268	8855	8855	1617533100000	canonical
12176	3NKLgwJAcLMabRpNfxVGAMca8RSreiLGAZBHao8uKQ7XKW6Lgg7D	12173	3NKwKWGLvHDwirwyNJTYeJgkjrm1S2peSsLj897Kh8a9186HHD2q	1546	1339	174	6301	8512	jy1AK5UtLgQc5Uo5CUdiSxTXT7s7UzjR36zuFrzi6mZtJG9Ekbp	6269	8858	8858	1617533640000	canonical
12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	12176	3NKLgwJAcLMabRpNfxVGAMca8RSreiLGAZBHao8uKQ7XKW6Lgg7D	1623	839	174	6301	8514	jwg6mhfxYEwqYbesdkSxYXsmbdGAF9wZYZjGgnTehNYwUZ1yJYw	6270	8859	8859	1617533820000	canonical
12179	3NKBhaLRVq4qLaSt5vD5UGbtMxkeGVVKyjFwFE4G7TziyngurnjK	12178	3NKTCDStnWBr3MSG8JE4fqvd1KNcw4joRW73k6qsaqYeeHNFjQum	1607	1222	174	6301	8515	jxwQedXhoL2uXgkawaFGEBLhNuydtuu6n7jaRMXd594N3bLjhhH	6271	8863	8863	1617534540000	canonical
12186	3NLUb6DuL3hzMmwuxKdHo1ij7bz6APHeEBme1pVRzxVRtpSsMsTs	12184	3NKaLKHikVorDTc7gaAEzXny7akZxMRfNiEpWcuToVw1hHVNo4pQ	1647	1176	174	6301	8522	jy2FNyEaMgwP1qx31DY3t2SqLjv2wqfK5o8Z3dMfRBX5QYrK7qe	6274	8867	8867	1617535260000	canonical
12190	3NLE9unEW28pWWvyYozpoxMjcUVRvS2zD8qNFJkTjXoki5xCVahk	12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	1518	788	174	6301	8526	jwZnMHx3QntsVwrkWeiqRUGgeme3QHYmJPxTggnFgs3cTszBKff	6276	8871	8871	1617535980000	orphaned
12194	3NLeTcXcFQGYVhTsTVEnACj1Rn862qQM1YpB78Pe9RsjA5NVwPq4	12189	3NKpy3VSrxXSJXmRPTuzq6MyESnPHH2YYDyyvKRvfmq7JqCHDf3N	1590	1300	174	6301	8530	jwAayPxTAV71Vx5yiWzVVA74JmzhStEWgaTXA7snEvRjgTQs7gA	6277	8872	8872	1617536160000	orphaned
12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	12204	3NLmAkdFi25aBP7BtU5J8eeV5saxJztqP2UShpFzwPTJpRmbwDiM	1405	905	175	6301	8541	jwux2K8ynhWBYesPdUFoobsZXo6joYtrWeno82ERGRBgHrmrq77	6288	8886	8886	1617538680000	canonical
12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	12206	3NKJ5GvttepZWQtCsJpjFFgrf2Jddufbv8eGqFKsauYPHsKxk1ng	1406	1393	175	6301	8544	jxnMMUbgV21VWtfWFpkBUKGbHSAKEozt6ec7333maKKZ46WLgnp	6290	8889	8889	1617539220000	canonical
12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	12214	3NLJnT6p1v4X8yWQ4j9CQ9K24gA2ugMgLGx32eEG6Mh5JExdg577	1423	104	175	6301	8549	jxxpE5pKVNpqMd1cawGkXhn7J77CsAyrsKsbWuMHYrPfpuPLdwU	6293	8893	8893	1617539940000	canonical
12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	12225	3NKsaek2PghUy2iWVzsGKMkCvzTcUjw4KJs4UQNpqsgLi5f9WYHL	1407	1395	175	6301	8561	jwir2yUB4mub8kyZk6QvMGoJRnB3a7aDeecz9zVXbuYNHimXcF5	6298	8901	8901	1617541380000	canonical
12230	3NKjHc8ZRQ5hyaiyyS88uvpuiYVfKXLDdfaRPHH4CuDSaPiSjXTQ	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1600	1372	175	6301	8563	jxD1G8BFximXzpXm8BdPW3bupUAKJV7w2vp3J2DrqDf8eFTQTeE	6299	8902	8902	1617541560000	canonical
12235	3NLPTJ6sC4xYJF9u82BhdZ7g3RezHnpvupR2kx2GEMn3tWfqwcVu	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	684	1352	175	6301	8568	jwe6poEV2P6N3FePFttEGViBMLsi1LkvTaRfJgebjHMvJ5KDJfY	6301	8905	8905	1617542100000	orphaned
12238	3NLJfYzQ5P8SrK6VvHj9tVYLEaX7RGEmwXVn5FkV48U5oxouhJGn	12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	1444	1255	175	6301	8569	jxpJuw3FuWYkWGuQv7wFCsQYYpG4fd5yT88huNCYShM1tFRGzdL	6302	8906	8906	1617542280000	orphaned
12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	12247	3NLSX29nY9mqGp6pHGQxBw5YXzLxEEEk4yaKLgRF4TmAAwFaZEHq	58	1035	175	6301	8579	jxk2jUWpPkU5roYxnYPqWceZpguhzKLYfv3tn7EydZTSEaUG8wG	6308	8914	8914	1617543720000	canonical
12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	12248	3NKDwUydmDSng2v5qcZJYmMfiHQshVMvUfJWFM6VFsSocAUNHh2s	1407	1395	175	6301	8584	jwbQDLMqnQ2L2hTHTrewm9pFV6jurUa3LKcpL4FD3cQskrzHr2o	6309	8915	8915	1617543900000	canonical
12255	3NKXHLjVLc2fH7XJVki1uian1FHHt2yiyyPd1JirLjYZMYqyiMxu	12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	1643	1299	175	6301	8586	jxFGr2L1WtdB4HtXhkSmStbMLDw3ikRZ6bYFscJt5KVXPjbs26R	6310	8916	8916	1617544080000	orphaned
12257	3NKYgSvm385jNyBPu8PmDt77fAvVtL32toqZEpGrCvTxq7pc2uAA	12254	3NLjwybu4EB64EqMhhfm2SiwXtb9FLghgoz2F84PPq2HE5qiCmYZ	1647	1056	175	6301	8588	jwEvsBxkomgzfwsGWabeRUEeiY1MPwyzzvMjkBCpTqJZ3iGMLVg	6311	8917	8917	1617544260000	canonical
12262	3NKeBmWCMtwenyU3Ds1CAe8GwyJmYETXFCgRL1xDKyjfedTDN5WQ	12260	3NKR8QCh28xMfnUjV9a7vA1eYm6WChs6xZLeKeX7Hdm2tF4X4aQm	1542	1304	175	6301	8593	jxPZg3VoAfxUvN1k3yTD9ymhSCzpx35KaFWub15gyiswdFLe2dQ	6314	8922	8922	1617545160000	canonical
12282	3NLr2nN9zFhaeqSX4CSrraKATPU47htPhL4MXtAjkAtntpFCq4vc	12281	3NLBKAokjpaYGeAeqi9HFm5g9nRiDxnhNhPs3KoMHbqbem6yRTV8	1406	1393	176	6301	8612	jw811uoKPiuJvxm8LrZXAtqT6QmCyZgPHaEjMfebSyWWA98LzTW	6322	8931	8931	1617546780000	canonical
12285	3NKdJkkJ5M26mv1sNcMayiaViKBZygmgs1JVHwZGg36Vg7vHKH8M	12284	3NKZEm7NcJBCjYBunhU9YPs73icUg3KUPh2sntevpSPNCSiyfgnG	1675	1342	176	6301	8615	jxZRrMW9vRcdS8LJCLitRfpmThnmrFwVsVWhxd6QSENEnNaFa2T	6325	8935	8935	1617547500000	canonical
12288	3NLANkFQhMTy1b2C61s5f2GficVpKv6oyE7VV1bRj2f6Qr93qJpa	12286	3NLNezV5X71Vi62V91iwbStBUjZPAScrCSakKC5qovU3XkfFZYo8	1520	48	176	6301	8618	jx7ssG6w7SXVB9UkfMcmVXnwhv5K6aj9MQU4Jqrpzv9EoWW2mc7	6327	8937	8937	1617547860000	orphaned
12292	3NLSKnUhygmSSaKc2BUGVuNMxChaMCqAYVfRjE18fzLaDT4L5hPF	12291	3NKX2TfipbMFsKwCBPeAifAH5Eri1NYh9ntsE4AUwpny3B5k4Y7X	1623	839	176	6301	8622	jwnGTa2e2sDRmL8FKvHEytKqR3fbCCfcbeDPfJUbyi1ZuNUt2Jv	6330	8941	8941	1617548580000	canonical
12295	3NLGMjuLf22okW5iAxtcMAAVqjuhL2uQew7dWWDpKJxBwmSHCVR8	12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	1672	1285	176	6301	8625	jxEa2nZdSEkee3r7qQBupx81yQmUo4RRY1GKANemthjmePjqsdX	6332	8944	8944	1617549120000	canonical
12297	3NLxBe7ozF9ofpL7APtwHM4j29s6nVgBTv7npop6Nd4EUt2esJPR	12295	3NLGMjuLf22okW5iAxtcMAAVqjuhL2uQew7dWWDpKJxBwmSHCVR8	1460	1324	176	6301	8627	jxqWJ3dtHqrv3Si9HeJm7CKTY8UEac4ZZ9TxV9M6e9b9B23orgd	6333	8945	8945	1617549300000	canonical
15414	3NLtD2Jf3w13xi96gz7BmfooVGQkfNvDENk6rxxUBEQ4M62yijAF	15395	3NKDasDzrVo5ZEi59fJLE7MMqVuggY9o8bFDhiFL7s7QzFzf3XCH	80	1027	239	6301	11451	jwcWDL7TQ2M3cjd82ucF7AxkJjRoJC1eye6PB5fiGdot3bnkiQA	7654	11103	11103	1617937740000	orphaned
12277	3NLvJ7ogpGFcNe4SteAyh756zEDAf91NRKhBdUPLLVtk5am1zdtN	12031	3NKkenPCNS34uUR4reZwC7KMooQuJ81cPkuoBvp6hhHbXGDfKPBc	1460	617	172	6301	8608	jxiR4hrhjQ74uEJXoj2KgKthnB357fosMQzKxYK9TtM9LWjdqkv	6192	8928	8928	1617546349773	orphaned
12189	3NKpy3VSrxXSJXmRPTuzq6MyESnPHH2YYDyyvKRvfmq7JqCHDf3N	12187	3NLfERXA4TVrCb32GAqcZpDW9FaGa2PAsyh3qvtKLPrdToDq91cL	1529	1190	174	6301	8525	jxrUzXDQWmvBu4yTdi7m3Aub4bxtQTUDjggFhdNqgC2s9yTrmmv	6276	8871	8871	1617535980000	canonical
12193	3NKJch77h22pHdHNemMmAijM5AajpEDWjUCLJ1fqGLC9GxrRvri8	12189	3NKpy3VSrxXSJXmRPTuzq6MyESnPHH2YYDyyvKRvfmq7JqCHDf3N	1406	1393	174	6301	8529	jxTpAXHFfX4tJaCio4AgsrLiBY2FqfGDJQrcYiYVMJTD3Enez3B	6277	8872	8872	1617536160000	canonical
12196	3NKDRJJGJrKDHgEzCQV2nVgftWU5FPFr6Bt4kWEkEhzjjN5dTJnU	12195	3NKVFEAjMLhqUX4NHAC3BcdQRhPuwL5PzUK4awYSRGsQWJk6VvD9	1637	816	174	6301	8532	jwFQEGFAP7Eej1n96h9kyYh1Njt7Ug4G18PdYc3jiTUV7EHGbw9	6279	8875	8875	1617536700000	canonical
12199	3NK6tt7GHxFwCWat5xZDGPXMA5ppefBzFb65czwHmrd5HhLcvFvz	12198	3NLvRWL94odHkBrkT4c5mswrXvAob65FnArLd71KcMqQ1yja5ZEq	1407	1395	174	6301	8535	jx18TAtb7YwMTLzekgUcH1erzWebdUq4tphK2E8WZQzTcUuvndo	6282	8879	8879	1617537420000	canonical
12202	3NKWQ9cG2FPep7it3uzgSo6qLSV3ghKP92NZW39LkXivGEUDQNCJ	12201	3NLgWw6J1d6XsGWDNrXoeCNuyWJoNg1qeGTm7nBkmWJwFDa1BRSP	1578	1050	174	6301	8538	jwQvupqxHYSge2eKYHk1BbiAHRAiyazCrHad43SHbWBiNwQhjXp	6285	8883	8883	1617538140000	canonical
12208	3NKMgsbSd9WN15932sfzJWsnZFS2vJsvA1GwNDNDQZYDXY7zyfni	12205	3NLY6YembzJwGcp7Pr8RXv7X6tgRG5fwE75nMw3a7nTDWKXVWfbb	532	1057	175	6301	8542	jwPdpTmBy6QdzRXGkVNhhX7mZkHMcbXs1vxJtwoKEZffctbFmE1	6289	8887	8887	1617538860000	orphaned
12212	3NKdy712vSBwPTd6jj8xLobsfGQvo87cJTVpYicqjrFP2rXwqbQ7	12210	3NLnM611mM6aJLUxRKWU5NE2kBzW8Q4TH3N5PGBaexdgq3r81s8s	1549	996	175	6301	8546	jwXDcjqcqcjd6xyquY3XpPfyo2Mq9zFfH2XxiFnq7QeQwzK4mcd	6291	8890	8890	1617539400000	orphaned
12220	3NKacsMzQEoN77B9aeq6N5ERMXRtt6G8bqbC3Nf5djBagELLsWmL	12215	3NLXLQrgNojKLPSjBFTqtzx9XxWTV9o7T4xh83sZrPXAeLGL7K9z	1406	1393	175	6301	8554	jxUotp33xa67NVejpWSVv3K4wkzjyFZZTsk1R9yfsC1NiqGHb6T	6294	8895	8895	1617540300000	orphaned
12224	3NLZ6qNHmqzHx4PfTHUkeJkNFVXxfs76oKEgQCYT2cXMsPwiZmUv	12222	3NKtAkvLKgk4iWteacudBZMPS5J4u2aM3wBShsBopP9v1LmFxi4C	1631	794	175	6301	8558	jwjMPZ2cVsmLvH83scGWJapFn9XtUxc4pWnYakuqDHCEjhL12ji	6296	8897	8897	1617540660000	orphaned
12229	3NKRPRKPwBYWhG1yyR5TVHmMvoAYJViC1BBfsAiKHVE5oE1W3AzW	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1599	1287	175	6301	8562	jwJnNzkC6dtUV8SrwwFyXtqy7ntXH9aY8bNm2q6Dav4qZnQFqNT	6299	8902	8902	1617541560000	orphaned
12234	3NKQZkgNej5no9J5EQPCG2idZoNdDRZpsEr1jKYtfBAcvSzz7CGG	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	1406	1393	175	6301	8567	jxUq83BpWUtWj8FvNKkMv1QXRKhx9QH8Z697Wnnsz4JJaH7tYuk	6301	8905	8905	1617542100000	canonical
12245	3NLUsowZ6oJqPtxbvUFyw4HBdqwhtTkzM5uB8gHQKTKbR9duzTQW	12244	3NLMcXg7X2CZpiPNJYZP3JU3ww1h9CANW2LLuAWjomQJVvtRgvr9	1631	794	175	6301	8576	jxVyPZ9Jdafsmw1TcW6gyfj2PDuW26t6Q61nLdbye34KXdywhR6	6306	8911	8911	1617543180000	canonical
12247	3NLSX29nY9mqGp6pHGQxBw5YXzLxEEEk4yaKLgRF4TmAAwFaZEHq	12245	3NLUsowZ6oJqPtxbvUFyw4HBdqwhtTkzM5uB8gHQKTKbR9duzTQW	684	1352	175	6301	8578	jxVg5LFEQCDd9wj2AxVWKDKUsEH27MRmyyoowY9VxqRqW1qtvER	6307	8912	8912	1617543360000	canonical
12254	3NLjwybu4EB64EqMhhfm2SiwXtb9FLghgoz2F84PPq2HE5qiCmYZ	12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	1444	1381	175	6301	8585	jwyNRgt1J4bv2cLYnzBEdWy5NgwTct2SQbTsjQbc9spbTkPWq94	6310	8916	8916	1617544080000	canonical
12256	3NKWGgEFz5eg3MZqYr8JK732LwKdNiPUFYQmrLo9FdqfpcPBB5hF	12253	3NL6n4FnLCji5hynnV69GGp2GqtnJkUjnyPR6wyeF66G4dopEnhS	1553	776	175	6301	8587	jwscgWLymK7LvdKbkR1fWLnD7n6xcrFE6GDAuu5TrefU7zoPeF2	6310	8916	8916	1617544080000	orphaned
12260	3NKR8QCh28xMfnUjV9a7vA1eYm6WChs6xZLeKeX7Hdm2tF4X4aQm	12258	3NKJGW8xVW1W35Zn17vzK1aUfmakNRWMtLZtzjMd5sTTknkqQ12F	1457	1025	175	6301	8591	jxpsuXdbUcd4RobLLGNAEqVHT1ERY3MRpiBJSn8BuQRudWbuPVG	6313	8921	8921	1617544980000	canonical
12265	3NKrjJkbgT6n8Jy4FNuNsnpBMgsp8Lfd3CWybUcXATkHzmoDvchp	12262	3NKeBmWCMtwenyU3Ds1CAe8GwyJmYETXFCgRL1xDKyjfedTDN5WQ	1637	816	175	6301	8596	jw89BsQjXvM6gzFqTWZtc3SUB8UQqJQ3SA7xcZQNxFdc8ruVMWD	6315	8923	8923	1617545340000	canonical
12266	3NLn2awJVqADmUNus3mR2ht9zTMtEJbWstXUWcEPGhxKeD4kAFuk	12262	3NKeBmWCMtwenyU3Ds1CAe8GwyJmYETXFCgRL1xDKyjfedTDN5WQ	1406	1393	175	6301	8597	jwRSUruLvUDpog7c5xKHiry2BkEGDcWhcHth1b9bhoSh8yGoqpe	6315	8923	8923	1617545340000	orphaned
12268	3NKjr3qzU5LQpr1r36hc9phDL1M3pnuEurgEWCQTR165WiUDGo5n	12265	3NKrjJkbgT6n8Jy4FNuNsnpBMgsp8Lfd3CWybUcXATkHzmoDvchp	1637	816	175	6301	8599	jwUxLBvCZpeEGTjiatNPgsT5fnNu7yUCFexs4P89eFs3oGdrxY6	6316	8924	8924	1617545520000	canonical
12267	3NLgJgasAxGH5VfyhmUqzrLHCbyVuLrHvVWfyRWQN35bADsJHS1G	12265	3NKrjJkbgT6n8Jy4FNuNsnpBMgsp8Lfd3CWybUcXATkHzmoDvchp	1603	444	175	6301	8598	jwXztSBrD72DaJRQ4YSB94qhP86rVkwnq3ovnnjqyL3mT4A7N9W	6316	8924	8924	1617545520000	orphaned
12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	12269	3NKn6fCb3PCh2Dz8wb9aRibL3uyLshbQjuk4rTPxLR94Mkt2JrR5	1631	794	175	6301	8601	jww4nbdX9Kf2Jtg3sgprrANBcYJWRaoBqqiL1fN21WNYZZJkEV9	6318	8927	8927	1617546060000	canonical
12272	3NLVuRFBjV8itLtQG7UbqRea3zQ512jtZRgwUMBAWmBCka4kNgNN	12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	1588	1026	175	6301	8603	jxdeMDXuP1EMS8phh2Fn2FfHBcExd4N6Py25KFm5CbdiH3Ueapq	6319	8928	8928	1617546240000	canonical
12273	3NKJBmjBKMCF72yMZTJN7RSG6zjMPzv8af3A5Y2DtpKdcoPEg7yD	12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	1460	617	175	6301	8604	jxru3hvvx2K96P8sTu8ZUHXYKyqdV85B2LvRGEaUGiTSzAafbzh	6319	8928	8928	1617546240000	orphaned
12279	3NLeGsvxSrLNhxPj3nbmv699cxcVuFk2wn9G8mnLcbqp412GLw6a	12272	3NLVuRFBjV8itLtQG7UbqRea3zQ512jtZRgwUMBAWmBCka4kNgNN	44	1199	176	6301	8609	jxhLwrUYmcUUHAkhEUcw4GGXFnL3B535eqbFKW7atm71dgWASYX	6320	8929	8929	1617546420000	orphaned
12281	3NLBKAokjpaYGeAeqi9HFm5g9nRiDxnhNhPs3KoMHbqbem6yRTV8	12278	3NL4eU4KNdtvnAHoRNSogGpcq9vQD4DRe6ghadRVr7N3CTK7VJKG	149	1283	176	6301	8611	jxRoQBRMnTqXDAbpiRYqfs3wgSahcP8cRJALshUG2QZKaNBRaCh	6321	8930	8930	1617546600000	canonical
12283	3NKSwYGMMZMMN7sc6Pb2ieyrrU8rKTvRE6kJwzmkEMB48zj6kW2A	12282	3NLr2nN9zFhaeqSX4CSrraKATPU47htPhL4MXtAjkAtntpFCq4vc	1407	1395	176	6301	8613	jxaa5iSTyXebuRgZQiJ4rG1uSdQDqYZHMmGcjdcWJcBVmkYyrLQ	6323	8932	8932	1617546960000	canonical
12284	3NKZEm7NcJBCjYBunhU9YPs73icUg3KUPh2sntevpSPNCSiyfgnG	12283	3NKSwYGMMZMMN7sc6Pb2ieyrrU8rKTvRE6kJwzmkEMB48zj6kW2A	1481	790	176	6301	8614	jxGoPYKMHx79tm3xK9TSSvnCsn1BedpHScpBZU4xwv2zPR3MG67	6324	8934	8934	1617547320000	canonical
12287	3NKNYRLvmnJKAsCLTrrUdwJCfk6k9yFUdfWEDCez85E1MX2K7qAC	12286	3NLNezV5X71Vi62V91iwbStBUjZPAScrCSakKC5qovU3XkfFZYo8	1422	1091	176	6301	8617	jwdhdsNUQ6y2fauohMr7kyW85B2W6fcSEgaSQwcXMBTqU1BAEWT	6327	8937	8937	1617547860000	canonical
15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1406	1393	240	6301	11108	jxNHAwzunBhXLsoMCkkKSnzC89q8aouP1nPKbRM2TuSXeax7wJV	7666	10857	10857	1617893460000	canonical
12290	3NL7AjZXdYxrQaj5tHvxrTBShvKzDehikyfZzSA8i6st13xpVZtq	11947	3NKwJ2tNCudvi8r8PjZp9cuH4uzToFEoScWwJs9H39QePJRNfBUz	1458	957	170	6301	8620	jxuF5vbgxowCPyQFCY2riUY8Ar1CQ7aYG1uAucp7uHGvHoLhK4Q	6139	8938	8938	1617548040000	orphaned
12321	3NKGkLxdJLgFsxZNgQ3uK6PfVBFd7EB7Ta31d9cx5dwH52JTbGw3	12250	3NK7Fc9CXhzEzG2DWDi4ZcbfELKUXFn6hkJsc6Em6iekWa8rrfdt	1579	1263	175	6301	8651	jwZM4GK9HAD1tRmVWxTPSqM6Ez9GVUnDTSuNzTZavdUfmr24ECg	6302	8965	8965	1617552900000	orphaned
12275	3NKzK9kEWcFEARjKxuU3joh5YoC8pkpKB2mxGD7cDi9YtHsuVHny	12270	3NLRKhY7Pr3J61Rn5S9bLV8Lgx9zBpUPvU1qXrfNNdJ3stbzSEdf	1406	1393	175	6301	8606	jxe9t6RdrCNBBPWyR2jAkukd51QtQ5pFf2BwExZKgTvTmDKvjea	6319	8928	8928	1617546240000	orphaned
12278	3NL4eU4KNdtvnAHoRNSogGpcq9vQD4DRe6ghadRVr7N3CTK7VJKG	12272	3NLVuRFBjV8itLtQG7UbqRea3zQ512jtZRgwUMBAWmBCka4kNgNN	44	1199	176	6301	8609	jxhLwrUYmcUUHAkhEUcw4GGXFnL3B535eqbFKW7atm71dgWASYX	6320	8929	8929	1617546420000	canonical
12280	3NLQx53KCpX3Pb95hUSzST59Zs6VsqKSPx3FQZSPUdHheT5ganp2	12278	3NL4eU4KNdtvnAHoRNSogGpcq9vQD4DRe6ghadRVr7N3CTK7VJKG	1406	1393	176	6301	8610	jxFxtptUdp1HP364JGUa3hkwLB4NDSqxLTDoG19FXPm59Aim485	6321	8930	8930	1617546600000	orphaned
12286	3NLNezV5X71Vi62V91iwbStBUjZPAScrCSakKC5qovU3XkfFZYo8	12285	3NKdJkkJ5M26mv1sNcMayiaViKBZygmgs1JVHwZGg36Vg7vHKH8M	1471	1020	176	6301	8616	jwPJ93zsxAyLZ2HSqdRrH2iCWYG4QFW3eZ8fdsnVbBHpzjDxLhW	6326	8936	8936	1617547680000	canonical
12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	12292	3NLSKnUhygmSSaKc2BUGVuNMxChaMCqAYVfRjE18fzLaDT4L5hPF	1406	1393	176	6301	8623	jxJUYe7SMkcSUHk2SsV2Byz2cW7d9BVtPuN3tJtiqP42FJhZBbR	6331	8942	8942	1617548760000	canonical
12296	3NKcmkKSJV34x2qipWogedjByFNJMBvHLk6UyRbdpxSJMuwpnZEg	12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	1407	1395	176	6301	8626	jxSppohjy2t3oXDsDVGHg5aCr882NPGqqRnxhASeCCxXaJ5B4zt	6332	8944	8944	1617549120000	orphaned
12303	3NKXuDX6fmRZYmWpFq3EDpikdip17BqSbeyCyDyZr96NsJwHA6T8	12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	1406	1393	176	6301	8633	jxfp2Ug2z8vbx4oUrqokEiVAd3YfsY2jEyWkkKWBAFY5Cc2EjTc	6336	8948	8948	1617549840000	orphaned
12305	3NK7CG2pvWk885nJnpfAJw1sgo7mZ4QrjZ1M59gzwvLHWpV2fvof	12304	3NLQiD7J67ke15hPfq36FoLVTxVhzNebJtBTjn9FTx4Zs7hNRoDh	1522	1322	176	6301	8635	jxaGArd7RRWjijnTRgeoWQPePDjiprJsg9pMsetpg1uX3PgmpDL	6338	8952	8952	1617550560000	orphaned
12308	3NLEprVH5gzTCuNYETsyGeBUFia2TQgBXHWfVW1ZdX3sCsDCfJKB	12307	3NLctvYWfxMqR1rcm2Juik4jy1XfyBqdKudq2PcFZSZk1mKXzuj3	1596	1117	176	6301	8638	jxrJf9rPgHcrz5uUxwAs2odZDvx2uJpugViSZVfZbUMw2ucrqUg	6340	8954	8954	1617550920000	canonical
12310	3NLX94nMi9R6t1TgATMnGsis2aRDTfk15GE4LFMcrrt5Ab8rdU4A	12309	3NLQ3WSfTMfWatWRcnRW58RJgZygsK1BkuKbC1VBRgdmvLYn4sFs	1406	1393	176	6301	8640	jwnmx2wiBWaAGAopjvziDDjP7pBayHgyPVafD7DnxYw7xL55opp	6342	8956	8956	1617551280000	canonical
12311	3NKey31c9G9o7N8CaRZ5VazXy5di8v9xZrLbhzoifjh7YU4m6XHC	12310	3NLX94nMi9R6t1TgATMnGsis2aRDTfk15GE4LFMcrrt5Ab8rdU4A	1622	1110	176	6301	8641	jxzPxEPFAXMxwqsWKBNotqa75cYEbydQUg22Q4ENMYQPD9ZBgSH	6343	8957	8957	1617551460000	canonical
12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	12312	3NKQzGbu6zWdqkG8M2p8eaQZSPRRKtRc3B1v6FAZzrSyH4v5ov7M	700	840	176	6301	8643	jxKnDQhAWQBe4C8JLB3KQkFxmc8NVR6urzwPcQ8Ecte4NpGqp8E	6345	8960	8960	1617552000000	canonical
12314	3NKejtMhZq4KitP4D9rzBa17ZiXw9Vc7jpsU2mPwQNW51JmppZj8	12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	448	939	176	6301	8644	jwVN4pRdKB9nDEM7wD2ZR44HgsbnUDnE6p4NLVoKWECcBvv6bkv	6346	8961	8961	1617552180000	orphaned
12316	3NL3AXYKzQ72QPZpQ35p1Ngaa9nvtUqumzrvrR9NHqDvR3hffSeC	12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	1406	1393	176	6301	8646	jxKT5MeX6cVCUYR4hgoUhqnhHbjJJKeVmprhT19XmfSY7WRfb6s	6347	8962	8962	1617552360000	orphaned
12326	3NKopCqiq8pr8P3BdsfCJhWdD7AwSjKjrcvEDLGXLCEJfHfei1BD	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	298	1062	177	6301	8656	jxCQBS52aSg4SkfpwfyEiwGfLj2z6wSFr8XvmAshxEipEVPbtVL	6353	8975	8975	1617554700000	orphaned
12330	3NL84msvQLh512TXqnvDtjRkmTA7ChMKidGYW3MCo2ZtraBnUott	12325	3NKNxRSRrfZDhyE6pd65yAej3bTw6UmPV8JMqfApurufsiMLv4gf	1637	816	177	6301	8659	jwEU8CFVRKTXkUMxgAuCAgDkLa2fA2XRwUQPK7EKj3ZfEaBC4Xu	6354	8976	8976	1617554880000	canonical
12332	3NLDQTLasbcm2qKCAt14saqKfBAjhtGxiyJ5JFEXq9Kr2kJucq6H	12331	3NLGfucdYQZm6xncAbzz3z2WhTZeYpe2Y3fk3qo788qnBYT5iPC7	1426	1118	177	6301	8661	jwcmbjSaTEDF2Y61xfe6zgGyU8vGdRHLSj48btHvTAr8beSkrqD	6356	8978	8978	1617555240000	canonical
12337	3NLxBj9KzEszPiWnt4ZT91Xt65jRXCSC7MvmSJaFXwqhzqqeFara	12336	3NLrSJQj3vN1xxYycj69t94UW8APatind1SKicptBiMkGpnwqnFM	1560	925	177	6301	8666	jxZb1BW1K1SgdKkKPMCSj8rLUBCtXRHqLNbhLcCnxmC8jaSvJck	6359	8981	8981	1617555780000	canonical
12342	3NKiuQ7uXq9QeiQR7b7vSmiYeNU7D1cGPNdhQMts6KoHgTTb3fHT	12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	1407	1395	177	6301	8671	jxUsTqjmCFiZFigqcFwUTKAXbPiBnekc5WAuk94hTKUMP1UVfrz	6361	8985	8985	1617556500000	canonical
12340	3NKwMqLNukUDkBBszwoPQEx6F3HTKyJJTAqBTFtEDzL8BJ5mSPRs	12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	1422	1337	177	6301	8669	jwEJYnyBYqck7tyraAxhUpvGBed9hHcMyTkPiCWXY65omiXbpth	6361	8985	8985	1617556500000	orphaned
12343	3NL5fRBseknr9Bk1236ENQQqTrRzk11k9dBqBFwC5hyuzSmzTRi6	12342	3NKiuQ7uXq9QeiQR7b7vSmiYeNU7D1cGPNdhQMts6KoHgTTb3fHT	44	1325	177	6301	8672	jy1eqaHXZzKhnxQXnM9mVwrp379a2QfnvT6pTbmy4TUv7SKrbi3	6362	8989	8989	1617557220000	canonical
12345	3NKyf4kphAK4DwHiCWVAAj7PrGzfH2xnc24EC2fSNSF1VRxK9DUh	12343	3NL5fRBseknr9Bk1236ENQQqTrRzk11k9dBqBFwC5hyuzSmzTRi6	1426	1238	177	6301	8674	jxVX1QDdscTbE3UZqedSrD5ASMLJ2xn81Gi5Y8in1sNcQdRxg8j	6363	8990	8990	1617557400000	canonical
12348	3NKDHsuxMHXfzqyCmZpkWvKznxZehvjFn4nf37ZibafaYJJi5MEP	12347	3NLXeFDAd4EwLUe7fhfVkT3AjEXxoPBZ5M2toQZxhvdi3MDHaddG	633	1384	177	6301	8677	jwsKmF8mYkeN5byFZqnEnPcRuDFUogt9mm7tUxgPaCPYGLcqehc	6366	8993	8993	1617557940000	canonical
12354	3NKucfYfyfbnMs9irSb41vN9mt8Wb77rEoXfjH2jfvBv5h6imssH	12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	1523	1321	177	6301	8681	jwvQSCSBbcp9sfZ1NGajE8PF67zo8g9iqRJmngSPQ1wcqauYmhd	6369	8997	8997	1617558660000	orphaned
12356	3NKL7uLEZtCwywKMTbRbW8CMSf8FWBJxs3BX3Sh3a7N3ehNKdg2f	12355	3NLftAZmJKMpV91awrEJgqKG6NfAUxsZCZ8ZUMS4Mrir9GcRQtpZ	1652	1315	177	6301	8683	jxe5ZemNRysJPyFDiHvLVfAmr4oaaQFXeDYnY1ETXNGgHwBshMj	6371	9001	9001	1617559380000	canonical
12361	3NKWnjDRm9GeoPHmv7JLby7KLSg8FsSrJsNSDhAHM6xzvAUSp5F4	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1507	1280	177	6301	8688	jwT7hT42CCLDGWmV1fSAXncL1BUiTLXRNPJ7SLnrdsa7Hx5NhYm	6374	9004	9004	1617559920000	orphaned
12366	3NKz4guaKEqPseVc4XGD27fsnM1uFTKnRJrd2Y2AYguU6CHHNngH	12365	3NK7Bc1E91spSm2FNBySvCbari8mFwU8Hw7VFeKkTyJdggajedPD	1474	1329	177	6301	8693	jwvuMSsKTUK6HkzJ8d2LTjHCbCC38U59ECLK3A5A7jPacJzaqFb	6377	9009	9009	1617560820000	canonical
15052	3NLfeLWBW7s5wQaC3mA9sKX4AQKxe56UfAzZ8Z9VnNiHpQPP4kF1	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1402	810	240	6301	11111	jx2fCE1C6Xfx4VERySGKVX45H1FVVULGLwgq2sNkAyjjwtbJ9dt	7666	10859	10859	1617893820000	orphaned
12294	3NL2xmi2FAb6WqepePgUERcPrpbxRQ9bvKn7BhTC4Up5RB1wNcFA	12293	3NKJrMHVXLrxCaqyzKoaajocoK6Zuj9h5T5H15XzF8W1XyJQM1mq	633	1138	176	6301	8624	jwDMYrGmzhqTs8Jj37tDNJuGGMwKLXKNxE53Q4sTgxPTSXJy4NB	6332	8944	8944	1617549120000	orphaned
12299	3NKznkZ3dQS3Dk7gyzQy6hbLex34JeNEPNhPwyGwH8Cyb7JkGPg5	12298	3NLv8FwgEy9wqiSBrmmEjNTLF1opvezwkLfVAUG1LxFYJDS5AM7m	1467	1376	176	6301	8629	jxMxwx46UfsecA13rcPkKjZDpk9eYv7AShCNQdE1WZtGTxxSERy	6335	8947	8947	1617549660000	orphaned
12301	3NKpKeDy14vFxDAoKweMtM3gCo1JrWGctRzRwU17H3ktaTxHSWec	12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	1448	1311	176	6301	8631	jxrbAxSkiCrvRCsnEJSfbhz1aEg783rCH1GFqW87VzTPAyVoaiN	6336	8948	8948	1617549840000	orphaned
12306	3NLqRwvZjX4sK8gAvi4yAfskgrxTZ7UPbngdYS7n9diE7mSuX8Cy	12304	3NLQiD7J67ke15hPfq36FoLVTxVhzNebJtBTjn9FTx4Zs7hNRoDh	1553	776	176	6301	8636	jxEcab9XtuZcdwnFf7pN27RqkRWukEhamwVoBdpWEyvTnawgCxs	6338	8952	8952	1617550560000	canonical
12309	3NLQ3WSfTMfWatWRcnRW58RJgZygsK1BkuKbC1VBRgdmvLYn4sFs	12308	3NLEprVH5gzTCuNYETsyGeBUFia2TQgBXHWfVW1ZdX3sCsDCfJKB	631	631	176	6301	8639	jxx7RvECWTZgEEoyzduv3XMojdCDfLMuqV48J1gA1B5jhEQHYFh	6341	8955	8955	1617551100000	canonical
12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	1402	874	176	6301	8645	jxTFQAPL57QYF3SQKZGqbjTcqKao1Tyuh3N2mMZ9LQpdeW58Xz2	6346	8961	8961	1617552180000	canonical
12317	3NLELJ5gvVN2h1izSenXjZt1372Ks4RZJFqF3T5qqEeptrKWG8d6	12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	684	986	176	6301	8647	jwV9FMda7XpbNnzYaAc8UwmrqV911WcQyigvNX4zTtPkKWoMvZG	6347	8962	8962	1617552360000	orphaned
12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	12323	3NKjDpLDWdTU8nsw1NX3dqZWQvrRA6VHSBExPC6ADzPLL7joQ6ev	1447	1345	176	6301	8654	jxJFmtYaoMKvRi7iYGy5vRyhTZELkpdcDM9rsvdu4f6i58mSCG2	6352	8971	8971	1617553980000	canonical
12328	3NKsR786gMEymBT88AGGTYXTgpeGyT75ibFfRJqh9MNkbvERsSNp	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	298	1062	177	6301	8656	jxCQBS52aSg4SkfpwfyEiwGfLj2z6wSFr8XvmAshxEipEVPbtVL	6353	8975	8975	1617554700000	orphaned
12329	3NK3Mk1u8UeqcQPy1d82DjMn6utWBQuNgU2jEZZJdNP5B8vK5yQz	12325	3NKNxRSRrfZDhyE6pd65yAej3bTw6UmPV8JMqfApurufsiMLv4gf	1406	1393	177	6301	8658	jwXLc4FUPfvuZqJTFnAZ42hn1qbUN2Z9e7pLqw3S9YynEXKphk1	6354	8976	8976	1617554880000	orphaned
12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	12332	3NLDQTLasbcm2qKCAt14saqKfBAjhtGxiyJ5JFEXq9Kr2kJucq6H	1407	1395	177	6301	8663	jwNZFaJWTQAX1CJht42KRRuYwW33VRjg9eT2P3pCnzz95SHvwrq	6357	8979	8979	1617555420000	canonical
12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	12337	3NLxBj9KzEszPiWnt4ZT91Xt65jRXCSC7MvmSJaFXwqhzqqeFara	1642	1367	177	6301	8668	jwmYLJwEAAVSt29psSitSKwmxEXqQVUtBGyka413ohmuckZcnsv	6360	8983	8983	1617556140000	canonical
12353	3NLhJStQvR98oMfUngP7UCDiEkQQ8DYDdZGsAovCeAb6cgoGatvi	12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	1523	1321	177	6301	8681	jxiGj2Q1vGqpQNnBfhwH18RnymQ4wiJkBBiyK2ptjPPijW68BUW	6369	8997	8997	1617558660000	canonical
12355	3NLftAZmJKMpV91awrEJgqKG6NfAUxsZCZ8ZUMS4Mrir9GcRQtpZ	12353	3NLhJStQvR98oMfUngP7UCDiEkQQ8DYDdZGsAovCeAb6cgoGatvi	298	1308	177	6301	8682	jw85U27UgD3BCMjii3Z9m8Mw9nh8XoX3BvYK31VcfLgCVQ822kb	6370	8999	8999	1617559020000	canonical
12358	3NKdKs7UjJNWRugGMUwFmDVg2Je1XSfbsw7JPApdkPov5cMGdPWi	12356	3NKL7uLEZtCwywKMTbRbW8CMSf8FWBJxs3BX3Sh3a7N3ehNKdg2f	1652	1315	177	6301	8685	jwHGFngLRD9T16KQBSxwVq26461DhryMFjK79Uax41NQ4yM7f4Q	6372	9002	9002	1617559560000	orphaned
12360	3NKM2sALnxjPesJkQN11RKTsJR4KRx9MdNAeXsvEGZBfG5VnAXvd	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1467	1376	177	6301	8687	jwS5gmEg98V3kU96cjwPKKBKbSoXVK7vK3Wsg1TTtTV9jaBQe7T	6374	9004	9004	1617559920000	canonical
12363	3NLsYmow9Vwcd6rtyB52BWzxJqWLc73XnsZGcz1z5vHX6siqLfPH	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1407	1395	177	6301	8690	jxNMLphju6Vmn1aDpkyGFUWbPqjGfAb1rmTuxgU4ae3Tgb9cpsE	6374	9004	9004	1617559920000	orphaned
12365	3NK7Bc1E91spSm2FNBySvCbari8mFwU8Hw7VFeKkTyJdggajedPD	12364	3NL833vFg1dwkTNpfjxeo8uemESdZexdyzo73XiFUYfnqqpDoC5T	1407	1395	177	6301	8692	jxjYkL2Ji6Du67E5hLDeb9iPADgTkgUs5854MjeePDvAyunhwBK	6376	9008	9008	1617560640000	canonical
12369	3NLhzFVWmgipjKpVjvihCCYAcroQXoU1hhpa1HWdTvx8fPVMD1Yx	12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	1403	824	177	6301	8696	jxEDASdth5TC8LMkK4qojV1XsDmpw4YscA2dNJGVdQ1Bo9DgRDA	6379	9013	9013	1617561540000	canonical
12371	3NKPpuMegA43hAaUzuB7LCqCdANVuGbAr1L5pgPpwUFQfg2H3Skr	12369	3NLhzFVWmgipjKpVjvihCCYAcroQXoU1hhpa1HWdTvx8fPVMD1Yx	1439	1279	177	6301	8698	jweqCtxWvN4yqaWP6MuQE5sSCHcpnNPjcF5sE9viZ3LxSdaKT9q	6380	9015	9015	1617561900000	canonical
12377	3NLJ37BbHdF3S6zwdNXNQgQZ2uE4TZ8zDWvKgdqhTog49AJeBa6F	12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	1601	1388	177	6301	8704	jxKvLSq9eb71GxRoZz9LnANS7Y4vo6ttzGg3Nfnnk78sepzxz2v	6383	9018	9018	1617562440000	orphaned
12382	3NK4omhco9dPfy2WVSNgK4XU2uD99r2xTiMuuJ6huXucSNh3yVVd	12381	3NLhzKXDL2Rr8xe8bPyfyEJmEE38G9kxgUjisQKR1phau6CMG9kn	1500	931	177	6301	8709	jx4srfzCtAKGCUiThD5zmP3XTHY8RzA8yCwYX8wzEUQi7toyBJB	6386	9021	9021	1617562980000	canonical
12385	3NLGqnRrWDG6UcnAXHwPiH6Q2fJ9CS1doUKnTUbuVFYSEA2CYio7	12383	3NLZHtaPSBsvJxx2zZCPRxFoRNWdqAThmehp3JxwNhTuc23KzNUn	1553	776	177	6301	8712	jx1X6DXxgPEr6uVHiDd988dRQZ8wo8Pxn7fAqpQE7gAiEp8UYiE	6388	9023	9023	1617563340000	orphaned
12387	3NKeroGaYMYLaPKWZTaZHyT1kwkxBPE8sSJ3CKftaE6xBE8Ca69Q	12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	532	1303	177	6301	8714	jwQUG9ibRoMapTLCudGyNPr3oBSEFbbcsYiHLZRF2SGEuJqsDCh	6390	9025	9025	1617563700000	orphaned
12394	3NLmwca5SJz3iiP63vqfYbEV5ANRYER4Qjj1Nw8hHdxRPg6vBMLj	12393	3NKn6kacxiErqbNvu7fMHNztffENaWg1XDJSmdGs25givg7aoB3z	1631	794	178	6301	8719	jx1XfevKmMYktK2tk2y9jtZyFgqbzB8LMgPYANV6UnsQjXPq5F4	6393	9029	9029	1617564420000	canonical
12404	3NKoru1bz9naMB3KCPHeEVppP4axBRAG37mxo1ccfuYkxKzqMS3L	12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	1460	615	178	6301	8729	jwU7CqJBbVwJn4nCvRZPti7Kv2V4F8t6gcwUsqxaJer1kfeSr5L	6399	9037	9037	1617565860000	orphaned
12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	1406	1393	178	6301	8735	jwWM3fS3wAPoch3yrHGZiw8EkSmrgyUx5Pnw73XDxduBEsAmCrj	6401	9040	9040	1617566400000	canonical
12411	3NKr9k3Td2jq33TAaqNL2FmEsri5G6N4QcmB4bcAP8v8CyG9oQCx	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	1467	1250	178	6301	8736	jxCshTYCNEJ74hY7PHyWV4Lds1iAYJLq5pZEpVgRewHzeGa8eas	6402	9041	9041	1617566580000	orphaned
12415	3NLnmFivfKpG9NVE3brKMJAn1fMNwGPDL1vS3trkqdVDyW5z8jZX	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1609	1333	178	6301	8740	jwoVTUXDJHjSMc8q5rDsVGeR9bJDQbZ9m5uW129aGgkQbx6hG9S	6403	9042	9042	1617566760000	canonical
15047	3NKWmjDK3YccKamwEdR3atTxqXoqMRWqjUr137tYaQ41SBsahFbz	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1675	1216	240	6301	11106	jxhRhEh3qTbpCKkqY8c8yfQV87ved1kYGSHa1VntdNatkxZ9zoA	7666	10857	10857	1617893460000	orphaned
12302	3NKm1v435EYdWU7jRF9gUt884tbxo9R7NTXq4iruJfUGjxBedP4J	12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	1419	813	176	6301	8632	jxiyVDRx6kbtjpZPaVSTsSwSzAdeaznUabRFrhpfWbZYoxh6N8A	6336	8948	8948	1617549840000	canonical
12304	3NLQiD7J67ke15hPfq36FoLVTxVhzNebJtBTjn9FTx4Zs7hNRoDh	12302	3NKm1v435EYdWU7jRF9gUt884tbxo9R7NTXq4iruJfUGjxBedP4J	1406	1393	176	6301	8634	jwRF72GEt1bfXiTgdWqxcBFChYtZ27Zorezkf2rA34BVuN7ExjT	6337	8950	8950	1617550200000	canonical
12307	3NLctvYWfxMqR1rcm2Juik4jy1XfyBqdKudq2PcFZSZk1mKXzuj3	12306	3NLqRwvZjX4sK8gAvi4yAfskgrxTZ7UPbngdYS7n9diE7mSuX8Cy	1631	794	176	6301	8637	jxkbxABk9QhnG9tdrAXUFyhNqAZJrsfunFE92vRreYt5g8ZDuDv	6339	8953	8953	1617550740000	canonical
12312	3NKQzGbu6zWdqkG8M2p8eaQZSPRRKtRc3B1v6FAZzrSyH4v5ov7M	12311	3NKey31c9G9o7N8CaRZ5VazXy5di8v9xZrLbhzoifjh7YU4m6XHC	1560	1165	176	6301	8642	jxXMZPaMMQEGVUNnKkWvE2bNkyio8CiV4n12WSzbDPAk3kyiq6F	6344	8958	8958	1617551640000	canonical
12318	3NKu6QQGK6jDaWv7EVJG4raDN8bB1g4uVp1QULcsmehgNc2pztHU	12315	3NLH98bqSFP91R9EDXfSDQ6v6cQT3PV9jGyePMECpsX2i14Pzn5b	576	1355	176	6301	8648	jwn9ATbEfLFpV4EQ52jtHZgAiPsS2HNwzhh4X6kzaob6jGp2VCE	6347	8962	8962	1617552360000	canonical
12319	3NLRknxvyTjA6cL12jnkQjLgietoboKdcXPi7XJhF9NrpJ8PLw4C	12318	3NKu6QQGK6jDaWv7EVJG4raDN8bB1g4uVp1QULcsmehgNc2pztHU	1501	1234	176	6301	8649	jxB6cZAmRq9BS4Zv2xWcicimrfCiL5xQ42udVqtP61QAbBod2d4	6348	8964	8964	1617552720000	canonical
12320	3NLtnq2s1kFGTRUkR2DPLqCxYuzPYPsZdwArtL7KYcSKMACZPtFG	12319	3NLRknxvyTjA6cL12jnkQjLgietoboKdcXPi7XJhF9NrpJ8PLw4C	1579	1263	176	6301	8650	jwdMsvoiPa4dffWBw7NRKC5BiZ3PTbWJeGy5XtAQgNwtfLb5Vp2	6349	8965	8965	1617552900000	canonical
12322	3NLV8ru2SF9E9hX4w5cSsgWfst1FWeeyhoLpQ7WgntFn7BgGjrzC	12320	3NLtnq2s1kFGTRUkR2DPLqCxYuzPYPsZdwArtL7KYcSKMACZPtFG	700	832	176	6301	8652	jxxbgy1wn5meYz9eqAbnyuBeXW1tY3sNg54wXiq1eYTgCUo1ZbD	6350	8967	8967	1617553260000	canonical
12327	3NKesjAocjmcd48Rhrwi32EFj9DwGroCgTSwBzgr9BTf9tAGXNNb	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	1637	816	177	6301	8657	jy1kW8TFmzYjR4fgq7HABfcbhTVWw5adVhcAtqCrwuA5fE3unwe	6353	8975	8975	1617554700000	orphaned
12333	3NLvY3BtdgfcPK2DTDfbAFGAXykMJseaExuQxtdS6w3ioLvSXeFt	12331	3NLGfucdYQZm6xncAbzz3z2WhTZeYpe2Y3fk3qo788qnBYT5iPC7	149	1283	177	6301	8662	jxtfdSCy98eJ2gKQdXyTRRHbLCdZ73Z2sC55VwCZa8fWRSc58Nf	6356	8978	8978	1617555240000	orphaned
12335	3NKm1yoGYMGEAFApEayhAi3demWqjW8odag1q7wpPgopN3d1Sd6n	12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	1637	816	177	6301	8664	jwgxzZUQtE3tm4PgaLzq9pZuUGmwktpSTTCboSCMSGknXbQxoE8	6358	8980	8980	1617555600000	orphaned
12341	3NLU9g3QXfDc5CCFXxccXGuCy8RFM1xbLapHPDLcPTqQSRVbjhHA	12339	3NKRjz9Krd5wwrfHv21HFyvk7yAnpdKWLWjceNtuj4nXjngQYMQA	1483	252	177	6301	8670	jwpGQnvPmoRH3ErigtbhLZ2vyBrBnP1RmTdjvCCnoqjN3mGpJK7	6361	8985	8985	1617556500000	orphaned
12344	3NK9yRwZYgadWG7YcLeEerzCkgnjoBsvyhLRFCY4SPfHf8KL1PAz	12342	3NKiuQ7uXq9QeiQR7b7vSmiYeNU7D1cGPNdhQMts6KoHgTTb3fHT	1585	1366	177	6301	8673	jwKXVw8wF3RFL32BKwc7wptmvJUzEPZHiW1eCoQqfgqR5NuZcJw	6362	8989	8989	1617557220000	orphaned
12346	3NKsiSB6C5W15tbkDzca7YRysrpnZdQoXEsXRMTH4dg61zgy37Us	12345	3NKyf4kphAK4DwHiCWVAAj7PrGzfH2xnc24EC2fSNSF1VRxK9DUh	311	1181	177	6301	8675	jxZDZvntUiRjFCPu8dXAqFQM5iqSJWQJqvYY5fxp4RTBf4mKJbk	6364	8991	8991	1617557580000	canonical
12349	3NL3YBPT2TeLsB2jbutMiQyLRT9dPuB85kjFyqKedKvL7hXf8Dts	12348	3NKDHsuxMHXfzqyCmZpkWvKznxZehvjFn4nf37ZibafaYJJi5MEP	1402	868	177	6301	8678	jxtqbHBGRxuwdegx4Hru5DwiY3obd3T2TU5nhXmDEaohWQomYCa	6367	8995	8995	1617558300000	canonical
12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	12349	3NL3YBPT2TeLsB2jbutMiQyLRT9dPuB85kjFyqKedKvL7hXf8Dts	1447	1219	177	6301	8680	jwGtxGqN5kxfBQbptMJUwLFuBh5gC5sdZ3QbfVzf8TYu1FA8pa4	6368	8996	8996	1617558480000	canonical
12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	12357	3NKpxSUMPgEVPfPEz7U1SZGHjEysThTakMTrS58PmH5YdXx1kh8y	1467	1376	177	6301	8686	jwnF3L6NYuHAv6ywCasZ3QwSxhuNiYNfgsLnYp1YkFtFkT3LhSY	6373	9003	9003	1617559740000	canonical
12362	3NL3eobUHTf8F5pazWbVNmcRcRnMjbdBHmNrnEgmynT1R5fpqwtJ	12359	3NKBt3Xzq6CwoPwqByk5msHAUCCAr7Dw8bzZ4G7AVzUJpVCpqXaC	1637	815	177	6301	8689	jwCY4xYvcSgCuWSoUFJzGuryttwWohWckLBDYQB58zf17Gafx14	6374	9004	9004	1617559920000	orphaned
12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	12366	3NKz4guaKEqPseVc4XGD27fsnM1uFTKnRJrd2Y2AYguU6CHHNngH	1594	1200	177	6301	8694	jxGRSp8Hrj61bCeGA49wY9eQBfdA64CcRqMm8b6VgEv9S8PprPi	6378	9012	9012	1617561360000	canonical
12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1637	816	177	6301	8701	jxC2V3G79sAX5tCChD6tuUAQFZU3MX3Pnokg5XoU7FJeZLetnNo	6382	9017	9017	1617562260000	canonical
12379	3NKp8b5kzvU8jeXtxKbTBWYSXt1SKPYEKfaCaS61m48rB55SyDH3	12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	1594	1080	177	6301	8706	jwBvd4yAs2Dx8NaQGp2SoPocSAC5YyVx2AcoiGkvs9RFMDJ9SFm	6383	9018	9018	1617562440000	orphaned
12383	3NLZHtaPSBsvJxx2zZCPRxFoRNWdqAThmehp3JxwNhTuc23KzNUn	12382	3NK4omhco9dPfy2WVSNgK4XU2uD99r2xTiMuuJ6huXucSNh3yVVd	470	1183	177	6301	8710	jx8jNGP2ETUWqApYy5uWb59MyRq3GcNVn3CQgzbXStnAHHsYFbV	6387	9022	9022	1617563160000	canonical
12389	3NLwCndMk84mfCSRpjoUvCwU4sbxmzSocGF5sw1UQoQGksCVNree	12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	532	1303	177	6301	8714	jxPMA5CwnjSrjX8sKdmNjmFsFozJhJfnaf3zLDxuhA79tk3krEW	6390	9025	9025	1617563700000	canonical
12396	3NKW6bCi87s8pPuQLgUWZadJy3XK8yAD6oHMyLkVBvzF5ankEYyM	12394	3NLmwca5SJz3iiP63vqfYbEV5ANRYER4Qjj1Nw8hHdxRPg6vBMLj	1500	1051	178	6301	8721	jxnxTENHkULkeBtFRoxoPbfCygS9ugjaJPtdk1VgMWZeFwTALpm	6394	9031	9031	1617564780000	canonical
12398	3NLhnQFU9NTo2qe4MvUjbenY8skY1RyUGGD25iyfmbLq7cVxvP8o	12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	1451	1292	178	6301	8723	jxzB92WWF8CkixdQqS5AkeURcZsEptPLAEXeiLEVwchgGarcChf	6396	9034	9034	1617565320000	orphaned
12422	3NK7vuV46n3skVoXgdasaZKSz4PnJFzWSYWUaxw27NJTh2zbTurw	12421	3NKMgyn1svwMnA67oRCHpK4KWn4edHGk8DZJrmqndCuXqNZX8LMs	1407	1395	178	6301	8746	jxPf1A2E8TVq8NC5di84vbJyQyuJEfcvjUbMBAXN5iwdUo3rxji	6400	9049	9049	1617568020000	orphaned
12408	3NKhF9H2zcwKqkQrt5eH5pvV8w5qF3q9dvpztXzhyFLtqgn1bExV	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	1610	1314	178	6301	8733	jwCwJRmLkgThP3DrHq9v3CQPHA5ZLUfmLFWHc3FDz6K74WaNDHQ	6401	9040	9040	1617566400000	orphaned
12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	576	989	178	6301	8739	jxBcZ9P4Z9GkTpoVQzKZSoDY3eenCncc28vophj9VBgV4km5m2Z	6402	9041	9041	1617566580000	canonical
12413	3NKJfFpZP6NnipJFBUXJHfzVb7L27y46xEi9WjyPpHsWvpnNYuJW	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	1481	790	178	6301	8738	jwB4bRTN3x68PgKEiPMaYpvxXo2od22MEF73jSYXG3gsaoJRpnP	6402	9041	9041	1617566580000	orphaned
15053	3NLdY6NNwGKGU2Kpu28MsCHJuMR9ghD5tFqGSBL2Urj4XeEQQFC9	15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	1402	810	240	6301	11112	jxeRKFbsWxtbNZNnUk5M1wDRG7AGXmGoc2qSPSGKSsxtGVxZXWK	7667	10859	10859	1617893854028	orphaned
12336	3NLrSJQj3vN1xxYycj69t94UW8APatind1SKicptBiMkGpnwqnFM	12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	1643	1053	177	6301	8665	jwBbCkVUsfMakUF3ZMMdTTn1wLuwtJhDiiEKogQDFZHMpTfuf98	6358	8980	8980	1617555600000	canonical
12338	3NKsjSqKPau3SozWmA3GfahYtmueF95L43ihbbE7gE5Ez2gCxEeU	12335	3NKm1yoGYMGEAFApEayhAi3demWqjW8odag1q7wpPgopN3d1Sd6n	1560	925	177	6301	8667	jwXwmxrUbs66zDgVy2Zx5QdW4bikUsPaPYVMi14NR1gg3E2AqhR	6359	8981	8981	1617555780000	orphaned
12347	3NLXeFDAd4EwLUe7fhfVkT3AjEXxoPBZ5M2toQZxhvdi3MDHaddG	12346	3NKsiSB6C5W15tbkDzca7YRysrpnZdQoXEsXRMTH4dg61zgy37Us	1631	794	177	6301	8676	jwoAJoEpkyQEXetoVCNpBqAeKDCbS1KwAaSjFe2yCzn9DHXWJ9z	6365	8992	8992	1617557760000	canonical
12350	3NKURxi9R98rkGJ64Enq2PHMkPrHG7dT6EMq97RHLw4WV7yrSBee	12348	3NKDHsuxMHXfzqyCmZpkWvKznxZehvjFn4nf37ZibafaYJJi5MEP	149	917	177	6301	8679	jxvimUKViRR5qKr8H3fteM6vRnVpyjmq4LoNNbCXk9MBDR531kT	6367	8995	8995	1617558300000	orphaned
12352	3NLkDYzTGTsne8jfgA37fGgoTAi3vmZCutnRoLudycPUSgYEKAAj	12351	3NLmhTuKqB1Hn8F6XPU9c7zJRxsx4V4Vfn1bYTTB3jZDuUeUxq5Q	1523	1321	177	6301	8681	jwqdffawuxhVbU1rxYeJ4WSgjKTsoGZszZM4Diw92nU8ufjBTEM	6369	8997	8997	1617558660000	orphaned
12357	3NKpxSUMPgEVPfPEz7U1SZGHjEysThTakMTrS58PmH5YdXx1kh8y	12356	3NKL7uLEZtCwywKMTbRbW8CMSf8FWBJxs3BX3Sh3a7N3ehNKdg2f	1654	1214	177	6301	8684	jx3EhTfm4Nu6vfkBKZ5qoM9cgKTjWT3n4Z6WY7Sy9UkgGMUrU1G	6372	9002	9002	1617559560000	canonical
12364	3NL833vFg1dwkTNpfjxeo8uemESdZexdyzo73XiFUYfnqqpDoC5T	12360	3NKM2sALnxjPesJkQN11RKTsJR4KRx9MdNAeXsvEGZBfG5VnAXvd	1522	1322	177	6301	8691	jwFuLT6eqKjdTwprx3BGPNfkv2KA1hU56aDVoK4AwvzDNj7us3b	6375	9006	9006	1617560280000	canonical
12368	3NKPLW7Ku8YSDgbBThdJ5H8Wi4gsC3pSbxCXwdwwR6J9YEDmPx4b	12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	1501	1114	177	6301	8695	jxYdtCYmvYU54nskKerAfU3F5CswRaoNHZbaVEBAXT8xdGv18ts	6379	9013	9013	1617561540000	orphaned
12375	3NK9p75BjVpqDNuk18xrnJnKtaFLMZ2ozGCnK5yEpvPPK6kHwxZK	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1407	1395	177	6301	8702	jwTsXpmHYkd92yukQKCWu7igKpgbaioiQkCMUJcL8tqbn9JSyxf	6382	9017	9017	1617562260000	orphaned
12378	3NK6mYJFKwN9Z3g8cGiBxJaEUsnC9H68tGtyBzgyLkKmaMjJj2Yk	12374	3NK3sTJHyrSFACu4AzCj8m5FiSLQX9Fi3pHMAX4Edi4DqBsqmAHM	1406	1393	177	6301	8705	jw8jUqzxKZJ7Ch1D646gtj9hZShFVoyfjPtEb6oA6ybfP8mv5S1	6383	9018	9018	1617562440000	canonical
12380	3NKzbgNqGeMztBrqrep18Afo1WQiwSjcagvNj35STKaN5b16YxU4	12378	3NK6mYJFKwN9Z3g8cGiBxJaEUsnC9H68tGtyBzgyLkKmaMjJj2Yk	1455	1332	177	6301	8707	jwe15UiB3s682MtUAJJm8ogvZjwWCCXjFb4qmYyqvPxb1MKVavh	6384	9019	9019	1617562620000	canonical
12381	3NLhzKXDL2Rr8xe8bPyfyEJmEE38G9kxgUjisQKR1phau6CMG9kn	12380	3NKzbgNqGeMztBrqrep18Afo1WQiwSjcagvNj35STKaN5b16YxU4	1609	1207	177	6301	8708	jxDm8XznyiM7jxyhtWnrjLujMnaEExkNeVkeMNWcMmsmDPXEtxR	6385	9020	9020	1617562800000	canonical
12384	3NKadvk5juLnkmpGNCUgvs9MEmMMKP34M5w9goZJbHvduk7pz1J9	12383	3NLZHtaPSBsvJxx2zZCPRxFoRNWdqAThmehp3JxwNhTuc23KzNUn	1509	1320	177	6301	8711	jwxCMRGMcGVQtCWDKpZZwSPk37YC8BA4bH4xB8kwQVXFwdF9tus	6388	9023	9023	1617563340000	canonical
12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	12384	3NKadvk5juLnkmpGNCUgvs9MEmMMKP34M5w9goZJbHvduk7pz1J9	1637	816	177	6301	8713	jws6Hv2VpD7XFRricNjek75hNBy7dD1p8d4AyG28v1bZ7uxMAq2	6389	9024	9024	1617563520000	canonical
12388	3NKjb5ZHhDB7ZWvsuzPKkKktuEu1BzdkSVr7zKgmvCyd5pEFviDM	12386	3NKcJPyncpDiXX93Rr6SRXbQ1HYewU3PGcsizJM7Gh6Y6b7xW26G	1407	1395	177	6301	8715	jwU2AhZfdf12CW7QhHCcMMg69dvzq7L6vK9isR27RF1i9AdaGrX	6390	9025	9025	1617563700000	orphaned
12391	3NLr9qY94AQD71uUarTvLfB8G4f5D9wCwNEnNNyrXtAFictqagVT	12389	3NLwCndMk84mfCSRpjoUvCwU4sbxmzSocGF5sw1UQoQGksCVNree	1407	1395	177	6301	8717	jxrrSDzTtJZVKBPRu2mSdxx9fAhswW3BEZA9khPMJB7fQKZWi7B	6391	9027	9027	1617564060000	canonical
12390	3NK83HdN2utNXzt1osBtyzaKNKWBMPj2Z3wQGX9VvMfK39ygYPMH	12389	3NLwCndMk84mfCSRpjoUvCwU4sbxmzSocGF5sw1UQoQGksCVNree	1553	776	177	6301	8716	jwkWqpkXdSB7jrwDVZ1o6nec8Hr2JUNG7iBhU4x8ErB1FeByLP1	6391	9026	9026	1617563880000	orphaned
12393	3NKn6kacxiErqbNvu7fMHNztffENaWg1XDJSmdGs25givg7aoB3z	12391	3NLr9qY94AQD71uUarTvLfB8G4f5D9wCwNEnNNyrXtAFictqagVT	1547	1378	178	6301	8718	jwUYXXGmPku5FsboubzRs3EbLPHUVrokBmprcN81PnUM4jX5gLs	6392	9028	9028	1617564240000	canonical
12392	3NL4P1n2tRyUfJ2odkFLgSHRVTT11g7ftK3o3gNcYxCsfARC23JF	12391	3NLr9qY94AQD71uUarTvLfB8G4f5D9wCwNEnNNyrXtAFictqagVT	1547	1378	178	6301	8718	jwUYXXGmPku5FsboubzRs3EbLPHUVrokBmprcN81PnUM4jX5gLs	6392	9028	9028	1617564240000	orphaned
12395	3NKKFoXZXtsWUXQ27BWaq4EBdHfPfRua7eE7iHFaznz6S7S5MMHV	12394	3NLmwca5SJz3iiP63vqfYbEV5ANRYER4Qjj1Nw8hHdxRPg6vBMLj	1587	1231	178	6301	8720	jwRpTGEmtiJhANSzxcAHDAqLG3iURVnFwRe4eU9ULaL1tuB1tc6	6394	9031	9031	1617564780000	orphaned
12399	3NLg6M36TGYj4UDF4kfKEFuA4dhs6VXirG1d5XXVmTLVNe16xWPM	12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	1403	824	178	6301	8724	jxJbB8coGae4kjRnpaiPR1s41WTDr4o7618nYf6NX49VK5WH8X5	6396	9034	9034	1617565320000	orphaned
12401	3NKL1WVh7KTeDCSJnzQgTdHucfn26vzZzzgiLivuN4MU7WyWwCAF	12400	3NLAMAyvcnkgE4eZQTsqaxfyMmM3JjXfer7tFb6D78GcMKEvNNVv	1402	852	178	6301	8726	jwZGYokLoDCftsT835pw2gsdkSVXYWZcdCBCVRc9836oKWf8S3A	6397	9035	9035	1617565500000	canonical
12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	12401	3NKL1WVh7KTeDCSJnzQgTdHucfn26vzZzzgiLivuN4MU7WyWwCAF	641	1336	178	6301	8728	jx2xr6fjuJVSrao7YzKwiTCbasYAfQHn5HqUWp3KFqKmfGQbqoV	6398	9036	9036	1617565680000	canonical
12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	12405	3NKF2stM3ztueAsuLzAEgRf5gB4RrrXrhQHortGGmUcwnQTnVdHG	1627	1385	178	6301	8731	jx6wEPqio7Esu3g7nRTpiBByYn3Y6YbM3gMAJsKGxwmKjRtSZBr	6400	9039	9039	1617566220000	canonical
12409	3NLFjmpSAqu7c6LwtPnMQfu8pLDSz2yAhmKnKCnkGsJzmBhS1Ati	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	684	986	178	6301	8734	jxGhiEwqz9ovtk4Svxz4GSTJLxWA6xCYPfFBnrVwL7dpCU8g23Y	6401	9040	9040	1617566400000	orphaned
12418	3NKMK3FGjAEf6yfQHFnC3veYSabZ41AJv2uCw57YHMHyPgnBh8ke	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1500	1051	178	6301	8742	jwNbMmqxsYzkboskUAy5mS5oQGpX9KQrtpGA5gT5eHrQYpyTQiM	6403	9042	9042	1617566760000	orphaned
12419	3NKw2RLBmrX23Mw6Um1ji4iGgJpb6sQbpE5JEWpxVJTCvaTVSAsc	12415	3NLnmFivfKpG9NVE3brKMJAn1fMNwGPDL1vS3trkqdVDyW5z8jZX	44	1325	178	6301	8743	jwvDQQiBhezjpYNugR2om7VPCc3kfkKQHzkEphHaHfaLUv4CkYR	6404	9044	9044	1617567120000	orphaned
12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	12424	3NL1M3Qm9Dg19e83Xnfd9jwEiEgyjP3PgqQtQ9HFB3f8FbcA8fJw	1402	868	178	6301	8749	jwuoJf2s9vfxzam9xWNUianH2ray6b93RKEoAUFjKC7ic8LpJ1f	6406	9052	9052	1617568560000	canonical
12428	3NKSPo5ryMqkt2gJQANfMgL47hbvgmAjPhHa67Ap5Z573Rr3HMZd	12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	75	75	178	6301	8752	jx7syLLwxNvTuhfAiVRNa6BUNvDfKfNdb4esfdD8RBypVKbhDjo	6407	9053	9053	1617568740000	canonical
15056	3NLsvMka42BDXn1G4SF9frUWokwKSTHmJDZy9QxrScwq2SZJe3jB	15055	3NLXx5TBTbScXHP5yXuhzZu3r1TdkSbzbYTkZnsPSjfkJEdsQm2g	1407	1395	240	6301	11115	jwEAvvaHw9qPcGsQybUzoeMJXNF4UchZHjgptZCwQhVAoNAcFWw	7669	10861	10861	1617894180000	canonical
12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	12396	3NKW6bCi87s8pPuQLgUWZadJy3XK8yAD6oHMyLkVBvzF5ankEYyM	1652	1069	178	6301	8722	jxtAm5X6uzwAwjmN6omRtP7F4FCCgiTZLmmHgUn57dCfQik4jQC	6395	9032	9032	1617564960000	canonical
12400	3NLAMAyvcnkgE4eZQTsqaxfyMmM3JjXfer7tFb6D78GcMKEvNNVv	12397	3NKcw9thbD2fCtj43TY3ZTrbk8tjBRhr9jPJVaeQdg3A3Bnb3Jbj	1406	1393	178	6301	8725	jxQd3xmVf9gD4jfeRNQ8qBqqGagtm9XMLTCkxADsE1YcMW1Z1NJ	6396	9034	9034	1617565320000	canonical
12402	3NLRg4xzcK76UGUJtTkPkwScWzhwDqJB3qmszxSAjinFFUtxTbQB	12401	3NKL1WVh7KTeDCSJnzQgTdHucfn26vzZzzgiLivuN4MU7WyWwCAF	1670	1282	178	6301	8727	jwyTzHpgU4FDpYwrLED8TGPqVaBGX1eM7dnkJUN6vyHH4FGXyMJ	6398	9036	9036	1617565680000	orphaned
12405	3NKF2stM3ztueAsuLzAEgRf5gB4RrrXrhQHortGGmUcwnQTnVdHG	12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	1642	1367	178	6301	8730	jxRt6WPSvKde3y7cpYCMn2sQBeB6EazZTW8hByMg9d7QAdD1onu	6399	9037	9037	1617565860000	canonical
12421	3NKMgyn1svwMnA67oRCHpK4KWn4edHGk8DZJrmqndCuXqNZX8LMs	12403	3NLSjyc5qUysNQWqPaStoPZ9HnnPMhNecfwRE1KpKKrN23pDXijo	1407	1395	178	6301	8745	jxL8JpZdgxfZaXBAh1GwbGEmmnZ5PugWQR314PVzBF6oNDRCsfu	6399	9048	9048	1617567840000	orphaned
12407	3NKTGzf4YG2n76vNbe3aPD9VVgZ8fx66r3Q7cecbp9F8uS5zdnCV	12406	3NLonrpA8ahwxk3PP9qDP4ot7zjbi5vnNvxPbdSp8qkAskwKZK66	1483	1276	178	6301	8732	jxkUYvWTGt2EhMyjDmFJyshivyQMnDWWMvAn5rb7jC1txbZ97yX	6401	9040	9040	1617566400000	orphaned
12412	3NKNXsktydsyJ4grb71iG7QgxAHbECFKhf98vna7nZ4aBGpCcT5g	12410	3NL6e2pMhXSayHxUQqQCAgz6GhjaC4Nk8V1hRLKskget7X8nQAi5	1547	1378	178	6301	8737	jw799g2MibK8WYQ92ecfRHJiJTwqU87Nf31fxpEt4GXjruML9BR	6402	9041	9041	1617566580000	orphaned
12416	3NLPiSffCrZeimS1ASAqMfo2X7fGGKmUM3rBwLoR4W8ewnPrBgun	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1559	1353	178	6301	8741	jxDnj1Q6QKQhJtPpgWWfNySRbqVa7bFHjkofSbEzZ3bnhmWRbZP	6403	9042	9042	1617566760000	orphaned
12427	3NLbSHJB9k7UBjnWeqUxH78GPBc9qxxHuqfg4gQFNEu5LTNpNrkq	12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	1406	1393	178	6301	8751	jwTMo7SXHswRqH2FCrXtupsKza6BP3vDVHd15afUAL7pJkTY5ng	6407	9053	9053	1617568740000	orphaned
12429	3NKSLZqe6wSZSXphcujBu3kUyuUctXJkSm2hoTuN5cPiJChkvWQU	12428	3NKSPo5ryMqkt2gJQANfMgL47hbvgmAjPhHa67Ap5Z573Rr3HMZd	1573	1072	178	6301	8753	jwvs6Ff6cuaJQrd61bNDSV8dFw1XQ8QWR2MGaDcZ6fAQAzZPLPy	6408	9055	9055	1617569100000	orphaned
12431	3NKSjfQ7MKbvjwF64VSTie2SFsgMXRhnPzym68Th1R3Se1VZgokY	12430	3NKjBy5LheQa22Y2Tyv1HZftew21vmoZujFcXhytrzz97TkPgpTQ	606	1049	178	6301	8755	jwMEHxor9EavVEbNwnhkmfxKuq6qePgBTBW4PGb1eyqTsQktzXf	6409	9056	9056	1617569280000	orphaned
12434	3NL2coXxxQZNZ1HnwXY2ZvJBTqLuMp2PxcnrDGKmF4s7pgED5AwH	12432	3NLqvioLef1c1xWdF6WddBHh1w49seGJ351U7RooeXTYL11LVfFX	1480	659	178	6301	8758	jxXj34q2GfkGRdEX9oDqPHsPfXPjbpxD7UTvyJvqnXEEH9WcLZ8	6410	9058	9058	1617569640000	canonical
12454	3NLCHceeP9ZdadZVsowfGndos25BeC8ffCyRXLyueKj8kMDtnzYj	12431	3NKSjfQ7MKbvjwF64VSTie2SFsgMXRhnPzym68Th1R3Se1VZgokY	1477	1350	178	6301	8778	jy3DXNSYaYP46iEtxZMpm2ZocSvjxys7SokSepUwMjeu4Cd6s6S	6410	9068	9068	1617571440000	orphaned
12439	3NLfZ4LD1nuJ5DnMiNqXRUX3FChQdAZ3wnMte7A9yQWCEjutge9J	12437	3NL9H45NCr3CTNV4UbaKbdKuy62eYooBJYPWpgC4VLzyFzmNskwJ	470	1063	178	6301	8763	jxXRBH1KhkTV1BWHRsK3gy3DqW3umMm3yWLyEUiLMTcDyKTUuT5	6413	9061	9061	1617570180000	orphaned
12441	3NKWMoV696D9dSvye2YNhoqH7SFzYPAHLpZEqoRhNNRnqc1Rmm4W	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1671	1365	178	6301	8765	jxoyyNqAkH51KVR9Wtdt2RFsLs7sehn2Q1GrzFC8FjASgV5okRN	6414	9062	9062	1617570360000	orphaned
12452	3NKrd8EiJzN6KZfDADN8GpejGhuPkhCVQhwuSXjn2GMPmoYuNxzY	12439	3NLfZ4LD1nuJ5DnMiNqXRUX3FChQdAZ3wnMte7A9yQWCEjutge9J	1406	1393	178	6301	8776	jwHoExNBbyzai1oW46i5T6i2ocR8ehRdTwhP8Aoj1eSJokSbW4b	6414	9065	9065	1617570900000	orphaned
12450	3NLi48iaGn7BvhrcYombxpa1TQNmhfsxVf2Tedm8c5RmxRe1JGGR	12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	1648	1038	178	6301	8774	jxSYoEwbraZKviiipWHmwAgaaGzYX5NF1V1pzmrDBNKs79m3MeB	6416	9064	9064	1617570720000	canonical
12455	3NLw1aHWqNXABDj1HY8hvwZWRe3Dz6S6CEC9zrPrjA1DsAiZ49Uc	12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	1585	1240	178	6301	8779	jwBMrZQnMnPbBXmseUXN8tFVBPrAcx2e7zAwxtLh1U92JUk8FAb	6418	9070	9070	1617571800000	orphaned
12457	3NKMMQ6BxpjPskf8c8vaGfDyRb83xLUPyXt3PDeZDBKxQSRSHJAG	12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	606	1169	178	6301	8781	jwXsquKQ7WP7QB4RNfFtrtmS1rtY3VTCKkQpLMhbfaJ52E4Sk9A	6418	9070	9070	1617571800000	orphaned
12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	12458	3NKWaAiW2b95t3d4Jt1SEcvzJHUFbt1PzDj6wfkGRuRKHynFJjJw	298	1308	178	6301	8784	jwQFKKHBAgC13KmrM2r21JkEtbyHYjGyEoYnAhwzEi4GBQf94tD	6420	9074	9074	1617572520000	canonical
12463	3NKnPBK1VWDiGXSmvwhN5Nhd2y19GcoAmvihXVrn8Mjr34Kj6jPb	12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	1654	1340	178	6301	8787	jxvHkEawps1qF9wH8RizSZE63xjGAn2i6fAfpH3TkB4x5jNNx7o	6421	9075	9075	1617572700000	orphaned
12462	3NLNuhq37AUfw1urrjTTd9rSAaABaBPe3FNzGzFroYkHXQWFHsq7	12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	1455	1206	178	6301	8786	jwEyG4b7RA6gNAf9FafqsSE3Vz6WxnAAkNAvcn87Yeo8v7yFkFm	6421	9075	9075	1617572700000	orphaned
12465	3NLhMse6WoEgiTb48PudBaeXDqMrWLFgPd8sAPCcWnLzhCdmgtuo	12464	3NKYXTMgpumn4wpt1GBjFZv3gvBSfxMtEUi1V9JWQoH1LESpmYqQ	1631	794	178	6301	8789	jxeSDkjfJfVFAy8xcEA4QnEqgUHAkUnFUx7gaXMjyfp6yjCjse2	6422	9077	9077	1617573060000	canonical
12467	3NKxMx3S2JtZ8X2Ve6YJPAU1gA2LaRJt36qTyAsdYNcyDDQjkdWN	12466	3NKYGQQd2DB8rJaFfPrp2as3BVVQT1PToA8XCnpJjgcbY2n2znKF	1578	1296	178	6301	8791	jwiy8KdUeHv8LWDPqudgNmfRfLHCw7H34xJ9W1FYeWgKNjbS2uR	6424	9080	9080	1617573600000	canonical
12468	3NKsCSzXMo2re3UjUBNqcEzQqUBiTFneZHDYLZkzr18LunsttgJP	12466	3NKYGQQd2DB8rJaFfPrp2as3BVVQT1PToA8XCnpJjgcbY2n2znKF	1637	816	178	6301	8792	jwfCcvMT7yzYGygTVGdAcb71w3anw75aV54U4Sx54mKCr8PFfQ4	6424	9080	9080	1617573600000	orphaned
12470	3NK599pWQphmtk8pNn7JCKjcxcuQDrSAJ4gpyEiFixDQdJM1n2kZ	12469	3NKGPSHwX4DWyssXM6kW54UtiAfXUG3RbusF3VAmTPgpDf8ubL1P	1633	1144	178	6301	8794	jwRRmwSaSM2x7UmLah8AriKqSJ7878gjEEH5TmzufiLErbtqT1E	6426	9082	9082	1617573960000	canonical
12473	3NLkJP2bi5axJirezkoBkEcifk4XEPgMPwjFwiCvEqTs7jVET9hi	12470	3NK599pWQphmtk8pNn7JCKjcxcuQDrSAJ4gpyEiFixDQdJM1n2kZ	1476	1371	178	6301	8797	jwV8sk3sLEXudzLmz5Bzk3pgEzeA7KPwzwp2e4rSirQbFTL6rwF	6427	9083	9083	1617574140000	canonical
12475	3NKrEhRXuYtoB8fxiG38NKkaCQdRk4cxhGmuNqHQycDrFbAXJTs3	12473	3NLkJP2bi5axJirezkoBkEcifk4XEPgMPwjFwiCvEqTs7jVET9hi	1675	1342	178	6301	8799	jwErACxxDRxCA1B7xPDA4CPbU4B4vrAxNpbE1ZBtiDmMmWWWrdx	6428	9084	9084	1617574320000	canonical
12474	3NKo7PZy34c5LKCJxHUGJZ6VJXgkAL7UuHsm3Ac7SH2wAvPhVocu	12473	3NLkJP2bi5axJirezkoBkEcifk4XEPgMPwjFwiCvEqTs7jVET9hi	1403	824	178	6301	8798	jxSSD4FJgQ2Zz6Ym14rSuqDjbNQ5NddtDTgjoZ5q5Ytr3g9JWx2	6428	9084	9084	1617574320000	orphaned
15062	3NLempH9idCbQvzT7QQxDJ2T1KQLTb7x1z2f4vkKpZsnGjrZ4z32	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1671	1365	240	6301	11120	jx7At5xF5VsqTmfXVNsZh7c9J7JfDmnbdExKTC8mv1dEV2vUSZN	7671	10865	10865	1617894900000	orphaned
12430	3NKjBy5LheQa22Y2Tyv1HZftew21vmoZujFcXhytrzz97TkPgpTQ	12428	3NKSPo5ryMqkt2gJQANfMgL47hbvgmAjPhHa67Ap5Z573Rr3HMZd	1407	1395	178	6301	8754	jw9FhjU78mAwiBJKmhQhDeStT5z9LvVTMj7YqVH8SVEPBzNi3ri	6408	9055	9055	1617569100000	canonical
12432	3NLqvioLef1c1xWdF6WddBHh1w49seGJ351U7RooeXTYL11LVfFX	12430	3NKjBy5LheQa22Y2Tyv1HZftew21vmoZujFcXhytrzz97TkPgpTQ	1631	794	178	6301	8756	jwBMAaWUVqiiVuguFCWWyyk4zXto8gzS3YofmZHHERLVwXj1LDB	6409	9056	9056	1617569280000	canonical
12435	3NKegaLAqoojmadzijeFeQSveE5tExarhUiM75f5F6VazqqqSBLL	12434	3NL2coXxxQZNZ1HnwXY2ZvJBTqLuMp2PxcnrDGKmF4s7pgED5AwH	1402	810	178	6301	8759	jwHcj37o4czM7s55yjRwnm9te6Q6NeLdnrfxRchURTMztWmBQVx	6411	9059	9059	1617569820000	canonical
12437	3NL9H45NCr3CTNV4UbaKbdKuy62eYooBJYPWpgC4VLzyFzmNskwJ	12435	3NKegaLAqoojmadzijeFeQSveE5tExarhUiM75f5F6VazqqqSBLL	1402	868	178	6301	8761	jxusR88YjAwQ94E4cavxR77SDVuLsmtmHyUri6bgzpx4ovSiR6D	6412	9060	9060	1617570000000	canonical
12442	3NL2kjKgmkAY2sFRytXmmt4fTA7kTw2EyuKnZdXbK9UkSDSHnvLU	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1657	1344	178	6301	8766	jwGUFU5bRjoLtLim8vsMv7mnybU9CgdMgHLadrtNohbZ8hnqHgC	6414	9062	9062	1617570360000	orphaned
12446	3NLQyz9orbiizM4quPMkWhM5Q8uMUxcaUm8Q2xE9Ez9BmGRWN3ka	12443	3NL45NGzvB8J51vmm3TETjoBkXfjNMFynPkqtUrDGSF7cizgnpcC	1402	844	178	6301	8770	jw9FPrjU5yP4N8whYdRN8EF4PHaCH8UNJearmHxbYUDRxzn3gSi	6415	9063	9063	1617570540000	orphaned
12448	3NLDvo6UU6hFW8qEF65yJF5qhHmPmDbJD3gwQ1EcXwrdbpoQg9QP	12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	1467	1250	178	6301	8772	jxL7iT7fTVLEp8XB2VVuCJg56onZD9Z6WzARXRNtqQCqVhTf4J5	6416	9064	9064	1617570720000	orphaned
12458	3NKWaAiW2b95t3d4Jt1SEcvzJHUFbt1PzDj6wfkGRuRKHynFJjJw	12456	3NKyrkftB3Dz3DS1eyL5ZdG2A2coDfBHxPDRUoCtb5pADACa8JCd	1406	1393	178	6301	8782	jxnfWGrtFdw8GL3JKNocpUk56U5iDMAXoPaoGjRf5m4sQh3VDi8	6419	9071	9071	1617571980000	canonical
12461	3NKASQHZAhEW77Whz6DJBgVMiQXLjQuj1UUEHqjZeYLmdKXsNEGu	12458	3NKWaAiW2b95t3d4Jt1SEcvzJHUFbt1PzDj6wfkGRuRKHynFJjJw	1407	1395	178	6301	8785	jwigwkqJBABKQazeYZQJt4tMJLqhJo4djmBD9jQrqdqJ65cLZmt	6420	9074	9074	1617572520000	orphaned
12466	3NKYGQQd2DB8rJaFfPrp2as3BVVQT1PToA8XCnpJjgcbY2n2znKF	12465	3NLhMse6WoEgiTb48PudBaeXDqMrWLFgPd8sAPCcWnLzhCdmgtuo	405	405	178	6301	8790	jwJ8TZpAtxj1N9mAFFk32qBJhJVcjoFK9Dwm2cFmhr4LhvmmPCL	6423	9079	9079	1617573420000	canonical
12471	3NLJVjWpFpckUfvqwuzKxoPqJLUqNCu356NZHQniJeuCeZdFdNJN	12470	3NK599pWQphmtk8pNn7JCKjcxcuQDrSAJ4gpyEiFixDQdJM1n2kZ	1546	973	178	6301	8795	jwbETZ1a34H4rCBe4cU8JuQbt2ZEUv6AFrLoVrbKDbE8Bhi8T44	6427	9083	9083	1617574140000	orphaned
12478	3NLqS4dMQDQqZzs5ZCuh7kCgNSkXTChvsCXJpi7V3Z7Uiiiazj9e	12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	632	1256	178	6301	8802	jxaHef53wxWgvAeu4cKZFZ5hB5VQSzYwpUjbiqGstwohVdExW6q	6430	9086	9086	1617574680000	orphaned
12480	3NLHCEDnmYW4gAegnDGPSw45YWM5i635FPL8ag6dh8sipAJbyJq1	12479	3NKiU5QMHXmpVQqQr3Tg2p3kugHxM5X5cWhZSeK9ykddXKbRuoXg	1652	949	178	6301	8804	jxoJmqNoXqt7bmsVHH2HXcQFfmEnU8Ze68JSUTxq2gwsU2XArwY	6431	9087	9087	1617574860000	canonical
12481	3NLsxaJgQDtcHHDB8x4jK2SVbP9rfRJfcvmwBZTyAzpEejC6Wk1H	12480	3NLHCEDnmYW4gAegnDGPSw45YWM5i635FPL8ag6dh8sipAJbyJq1	1407	1395	178	6301	8805	jy2Ue5MEw2LvHJkVL9WCHSC9KLKYHd6b5PYTdiUxii3rtX3725h	6432	9088	9088	1617575040000	canonical
12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	12483	3NLEEEdD5M2zw1NoSXKG5GffnrUumLrXoEo5id3oFjFCt4QtjfMw	1672	1285	178	6301	8808	jwzGPbazXyzTbuWyVCeudA7e7xCL3B3X9RSY14w9fVZ7Cp7Wi3P	6435	9091	9091	1617575580000	canonical
12485	3NKXerTWVfZ2ZDJDXbuCxNDG1Mi8p9WUTpcU5dVLwPHBAd6iJXMT	12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	1447	1345	178	6301	8809	jxAcTXqQDJ6MtexkinhtuLoDX85fyHcvxix8Law9PGqBBfEm6MX	6436	9095	9095	1617576300000	orphaned
12492	3NKPXwSxWuDdCHExHwcU4FLmBK81B3nBo4CFZHKZBwsLjBRyL6b8	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	596	1306	178	6301	8816	jxXUh5ubd9NTjk52XDN4LtoERX8J6ogZbSUZzea64eQy3yh8aBe	6438	9097	9097	1617576660000	orphaned
12500	3NLLgrwsF4v9UZXHuBWgR5oEcD9WVZVR5SADfwP752QENLk3z1ju	12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	1407	1395	178	6301	8823	jx7QrEWkCHThjCMoUTxu4gqST7C8pggpxej2U7jmVt2SRD7PXq8	6440	9099	9099	1617577020000	canonical
12498	3NKLwfqKVaFTvE7NFJZY9eYVhQBaiYk2wMTQYKuoJafpswnTJCnw	12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	1403	782	178	6301	8821	jxFXE2Wh6EMkiTvKvbqP6sCyfoDhWUJ8UpGLjbb1hyfAv2i6CyD	6440	9099	9099	1617577020000	orphaned
12508	3NK7JsHgWSACxWbkXEou9SNEHXbXgEP4kEnqAWEa2AhqT39zJi3B	12507	3NLMrMSBFwDDmEn1AwayHq45V13gjBuPboUd872as9ZtRp3LCnnJ	1589	920	179	6301	8829	jwTjBStqPKQANyyQFzZQn7ZpobV5t44TgLu8x5VdMQFC8rFPAU9	6444	9107	9107	1617578460000	canonical
12511	3NLQMNZL1hvs7zEbADyWaEmmSt6RMt4qrNftWUq2No7Hg8qWWRgh	12510	3NKhsMQJxJw3WGGiSqMH5ZxSMoL6i9XBcGZkXAPJeMwgBeBfPky5	632	1382	179	6301	8832	jw7zbdJLvajr38nyQtUSSL6kdBqrYpfaG6t5xX8huYrvQXGTZeQ	6447	9111	9111	1617579180000	canonical
12516	3NLNknkk46sW6Hn1XfxmULmHB7vgNRnQGF41DE2LTcnwxZitENvt	12515	3NKqU6gki9NHB3Zqur35tBQww5KJ8vPiuw61se94MvAHHcYVxe5s	1455	1332	179	6301	8837	jxSAow61kJRR3dzWUTXLDpf85SY4V7rVBuBPnHnxipDWi6HYKL3	6451	9116	9116	1617580080000	orphaned
12519	3NKjjybo642gkMFN64UruqsmYnY8PoapnJCqNgVH6fmqbNp2dpks	12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	1407	1395	179	6301	8840	jw9RZwGBd8c9faGydXxKjPurab2e7RyNpNMAYgvKsPKw4A2mzM7	6452	9117	9117	1617580260000	canonical
12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	12519	3NKjjybo642gkMFN64UruqsmYnY8PoapnJCqNgVH6fmqbNp2dpks	1406	1393	179	6301	8842	jxksUaZpZHtSddfZBztQqm6Gz4ksfBT6SbK3szevfxik6HxtSwZ	6453	9119	9119	1617580620000	canonical
12524	3NKWyx7YroiVMeQEL4175vv9sYKf4vtZMcNy27nhSuUjaBfcRpg6	12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	1476	1371	179	6301	8845	jwCp8T8CTCTsmeeb6DEEAyG96qbECr7LCd3Dvvwkw76n2L8fd2e	6454	9122	9122	1617581160000	orphaned
12526	3NLFvxF7cDD5e9vg5YRcnAzR35nCvjfXsx6ZnSGknVzeZShmSpBk	12523	3NKWtmAw824orwRmafPHFGv3GJqyYwD1Wxjg9UUTqZj41bNAuySF	1402	868	179	6301	8847	jxJy1ppw8wdUxp3i9Ca5YDox4BigrPGEVg9czg1SSV4GPAC5Wfn	6455	9123	9123	1617581340000	canonical
12534	3NKJWEjZibfrrHp7WtX7kmnxZgCUSWxmtZBXBEhzisTTRQZA11fk	12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	1500	1297	179	6301	8855	jy1RTUJsSBxVGCUDHAp8JMyjmDqSHj3jaK8tL9av8TEvN63LboA	6459	9127	9127	1617582060000	canonical
12531	3NLJStLR98NYwp2Ww6XL3DGJMgnVFZM9481FCyP4oLHWGAy3KLqH	12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	1605	305	179	6301	8852	jxQHQJJ3ELcSw8skAbS1zsjp48rfNvnggZS9qu68qv2oondkA3H	6459	9127	9127	1617582060000	orphaned
12535	3NLwoAwncnK6qijdnhKX4REBMX1AozErdtuqG8iHPJaiR2eL8dyh	12534	3NKJWEjZibfrrHp7WtX7kmnxZgCUSWxmtZBXBEhzisTTRQZA11fk	632	1136	179	6301	8856	jwFCZ2sSbfFJUmkrqukgm1PKVpe3hZLVG6xEvgMBXULNK7KjW3i	6460	9128	9128	1617582240000	canonical
15088	3NKbpYwFsttVUg4nCpSnXe2oSEZizJ5Y4ifMKcnvSyUxCuWWxfpi	15086	3NLXGMCwBbsXHYM3VvwkzobVWyxFXU4QP4rXreQSU2dse3UDiQPy	1467	1376	240	6301	11145	jwNECjUnSEDceyT3uW2jR9WugBnaEkTGbE1V6Rbu31BtGLvbdBZ	7687	10885	10885	1617898500000	orphaned
12472	3NLfcUTnZYVxLcKhhrPncioGHpwxiT1r7BTpuFA4VDpydbNMKMjJ	12384	3NKadvk5juLnkmpGNCUgvs9MEmMMKP34M5w9goZJbHvduk7pz1J9	1546	973	177	6301	8796	jwiBKHFSdXQvx5vXQQyTTGLKZghyZRHH6fLPYFTQcSuXRDPQkSk	6389	9083	9083	1617574140000	orphaned
12433	3NLQL2nmS7oxgDk1nCmhYENV2SEzaLhDX2MF3f23tCcXCbKK8jVE	12429	3NKSLZqe6wSZSXphcujBu3kUyuUctXJkSm2hoTuN5cPiJChkvWQU	606	1049	178	6301	8757	jxkKShKURGzyugBg3MtnLBYdL5mtgF6h4yg1fVtX7nxpvrFcXpX	6409	9056	9056	1617569280000	orphaned
12436	3NKK1XJSAmh8zBdZhZ6Ry9VaGVAAmgiQUaLWsXMtZGuXf641rk1J	12434	3NL2coXxxQZNZ1HnwXY2ZvJBTqLuMp2PxcnrDGKmF4s7pgED5AwH	1594	1326	178	6301	8760	jwu7tt21tjhAFY8Jd2ycupX5JtYHFnXpZVgstFUvcv7ZmQ5NoTq	6411	9059	9059	1617569820000	orphaned
12438	3NKfrYVQvgfUwNNxtrPuFQRXfJHXz8HDW5dQSUyPyYvd1gVnMycD	12435	3NKegaLAqoojmadzijeFeQSveE5tExarhUiM75f5F6VazqqqSBLL	1564	1092	178	6301	8762	jx3mgswTPkBidg4M6KrVSFedVen47CMvjodHybDQ2396FduUzZX	6412	9060	9060	1617570000000	orphaned
12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	12437	3NL9H45NCr3CTNV4UbaKbdKuy62eYooBJYPWpgC4VLzyFzmNskwJ	1555	1347	178	6301	8764	jxHYNZ3KSf5Rv1kuBQrK8eWL2QeNdJ2amTgyM98Cm9YTDzAWy2N	6413	9061	9061	1617570180000	canonical
12443	3NL45NGzvB8J51vmm3TETjoBkXfjNMFynPkqtUrDGSF7cizgnpcC	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1518	788	178	6301	8767	jxDYRMYMcekC5sJrVir5tAq5FnbYtj7oSWWTjxE4Htt7mzPFywe	6414	9062	9062	1617570360000	canonical
12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	12443	3NL45NGzvB8J51vmm3TETjoBkXfjNMFynPkqtUrDGSF7cizgnpcC	1637	816	178	6301	8771	jw7VxQ8bFLRA6ij5J3B3ftAAKpde7vL7JFf4eJbZXpa1s5Mqn7d	6415	9063	9063	1617570540000	canonical
12453	3NKAAMyjGAcSJqS8XQGzAq8XkjgJQULyHrSUBWgR5Xq2C6QNVBrQ	12444	3NLsYM91Sy7AsuV9T1BGjoe9qacwgYNSiRrFozZmuHeHJtUhZbVn	1406	1393	178	6301	8777	jxERN41GKaquE7LChnMzpQ8SntbhBhAVy93jWRFjqE1PBEEdEgi	6415	9065	9065	1617570969865	orphaned
12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	12450	3NLi48iaGn7BvhrcYombxpa1TQNmhfsxVf2Tedm8c5RmxRe1JGGR	1407	1395	178	6301	8775	jxvWdvLwVMJg6qxdiR8ZGEV3kM5XRGUU5fD4pNc4HkALsfE6y7J	6417	9065	9065	1617570900000	canonical
12456	3NKyrkftB3Dz3DS1eyL5ZdG2A2coDfBHxPDRUoCtb5pADACa8JCd	12451	3NKFKEVCMMMZZ6BkaqxMXhRMEk5Mc1gTewcvKscr3TCFt4sZVh8Y	1611	1341	178	6301	8780	jxbNbv9MBf6nzAiQzoX46ghBFvfZyUTDvreserLcgJMthmRLasB	6418	9070	9070	1617571800000	canonical
12464	3NKYXTMgpumn4wpt1GBjFZv3gvBSfxMtEUi1V9JWQoH1LESpmYqQ	12460	3NKi3wXM4W3XyKGXHspcLAWgytmJiiESk3LEWGXM5MThbjG2LDhs	1553	776	178	6301	8788	jwR2wQSgdhcMHdHhk792rHsHxgtucvDEH8r3EnqGqpCR9VFaqMt	6421	9075	9075	1617572700000	canonical
12469	3NKGPSHwX4DWyssXM6kW54UtiAfXUG3RbusF3VAmTPgpDf8ubL1P	12467	3NKxMx3S2JtZ8X2Ve6YJPAU1gA2LaRJt36qTyAsdYNcyDDQjkdWN	1656	1343	178	6301	8793	jwzsmaFcbS3dWyFmbv2YDRoWbXtJ1Wqd3yM4Eqd4MPDq2xbXSjp	6425	9081	9081	1617573780000	canonical
12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	12475	3NKrEhRXuYtoB8fxiG38NKkaCQdRk4cxhGmuNqHQycDrFbAXJTs3	1406	1393	178	6301	8800	jxfKKLkTHaCzjGGUG388wd4b34Us6ab4yXw2XMwYXYMLSP2G7bp	6429	9085	9085	1617574500000	canonical
12483	3NLEEEdD5M2zw1NoSXKG5GffnrUumLrXoEo5id3oFjFCt4QtjfMw	12482	3NKDFstEMxNCCxaNJeoWmB8ud9hHwnpVxFkzjCgiNSBRpBRt6u1b	1611	1095	178	6301	8807	jwWzeksPv4DhjfHWLioHGaCgeWTbWycPCJ5WbGhcGFuJfvbYTpy	6434	9090	9090	1617575400000	canonical
12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	1406	1393	178	6301	8811	jwa87i3cT5wDdeRsSTHJ8as8gGwuFGcmbgLrqqez2DzWEocMFjz	6436	9095	9095	1617576300000	canonical
12488	3NLFQeori8ZGkkeP4hPizVfQ6nAkxNAomw1cXpXpUZqu4o3Z7suA	12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	58	1035	178	6301	8812	jxm1UjcXa6yRjLFEYw6chrc5Enh4exJMUAhVqMoG8zb2cHJticq	6437	9096	9096	1617576480000	orphaned
12491	3NKUqadg7zvJwZZji3cNhdT2cz2tSnBA8s66fa165V5ZrRCu3jfn	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1671	1119	178	6301	8815	jwttjruVhmCzcRSFSNDxuFEPAfGBqnTTWBhDjA2aPFuNQjNmTak	6438	9097	9097	1617576660000	orphaned
12495	3NKuW9CNa8TRredGtCZUyzQBgFpifXe5Rit9VH4URvMm9tA7XprF	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1651	1301	178	6301	8819	jxdEDJcD4ZqESWoshZKdNXhTrtshe2Tg29DTm6CxMrL4y2tjiCH	6438	9097	9097	1617576660000	orphaned
12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	12493	3NKfmkSww42LBsdnLfQ53wiweabW2EKGWY7e5M8RChTAX9vVYMYA	1637	816	178	6301	8820	jwQyGhfiSLCjg4FrNWBrW55xo7FRTB6rnuRBuUjgdivd5Ea5vg7	6439	9098	9098	1617576840000	canonical
12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	12500	3NLLgrwsF4v9UZXHuBWgR5oEcD9WVZVR5SADfwP752QENLk3z1ju	1619	1275	178	6301	8824	jwsc65Kt8jKgp7VpRVvYU7rCYUiGuyAuhjUcQb6e8deNXrt52Ud	6441	9100	9100	1617577200000	canonical
12502	3NLwCXzFVhauroTJ9Tu1zW6XnT1JmtVrjc1qVZighdSGfSzLJx92	12500	3NLLgrwsF4v9UZXHuBWgR5oEcD9WVZVR5SADfwP752QENLk3z1ju	1619	1275	179	6301	8824	jy2Nz8hi6YAHb3E2BwhrSoAnjKE96UYvTYyLB7HHbdU8JkpaKa6	6441	9100	9100	1617577200000	orphaned
12504	3NKbPwTgJZa9m1HBrHKThud2mFe71hki2dZiTBUH2znkJsxXa7S6	12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	448	1305	178	6301	8826	jwsfEaoFBKC4tECw3ZTxhodnkEBoWbFo3XaZHwFcLuWh6ezWWAd	6442	9101	9101	1617577380000	orphaned
12509	3NLTe8vGq8NQAcKcnYFtdUYEwv4qzJ9YdPu6tc78rypDL76QLFs2	12508	3NK7JsHgWSACxWbkXEou9SNEHXbXgEP4kEnqAWEa2AhqT39zJi3B	1549	1116	179	6301	8830	jxDd2XeTMqmw7xsHFWQKxEaPciPSCuRM91hFfeCCL72vo2EPT84	6445	9109	9109	1617578820000	canonical
12514	3NLVRf6gjcssbven6ZhiZTJqDLwdqSzeGFWgVqQuEcqASkBt2iXJ	12512	3NK5J1hbphF8sGUeap2GBDH5cJYahfdFSW8vmXiJ2LUur9GQQLSX	1407	1395	179	6301	8835	jxjv1LBP998jqPcu1XC5ADacmZZSYm5Y99hq9xdT2Zd8UbVQcZN	6449	9114	9114	1617579720000	canonical
12518	3NLwxYK3HoNJM6Lu2A6744mNXxwGkVEh8RUNZa2ehc6ULdWwP8LF	12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	1406	1393	179	6301	8839	jwVWoTTDmdisqUymoSNtdQCT6xY1X5bF6YE4JSKKFd7gx6okkP5	6452	9117	9117	1617580260000	orphaned
12523	3NKWtmAw824orwRmafPHFGv3GJqyYwD1Wxjg9UUTqZj41bNAuySF	12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	1403	824	179	6301	8844	jxsGFEAgS2WeCpvQUAp1vmgSLWjj1kFxTvkLopeCh51A6CDUbff	6454	9122	9122	1617581160000	canonical
12528	3NL2fCqVCEMbhr5ZDykxfHZH7aSKpVdmaUUdGQpJUodmbefGui13	12526	3NLFvxF7cDD5e9vg5YRcnAzR35nCvjfXsx6ZnSGknVzeZShmSpBk	1623	830	179	6301	8849	jx849qKs7EJ2jnKWbgQduEoa5K2Pvj2x6ubR7ThNL1EvnTQtC3F	6456	9124	9124	1617581520000	canonical
12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	12529	3NKkDN2hoRUJErTNKEU4KYQ3DC3KegPsK1aqamq5HxsTWcyeksAe	1633	1144	179	6301	8851	jx7E44u92kqMrExdMT2CkUoLPcDTvP6GjxbGeU6i8EBB9oDDp3S	6458	9126	9126	1617581880000	canonical
12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	1406	1393	179	6301	8859	jx1fqqV75pHvqrEUVVh5v81WXT4qBWE5SYz4Ch76ANpUumr36CS	6462	9131	9131	1617582780000	canonical
15119	3NLcsyWY1id3MeMob3EbHipdtmZcpyZbnB9t6tFjVttN5yDgvGhb	15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	1642	1241	241	6301	11175	jwZvKxWpLPhUrp2xyMsH7ZgT7pg5Zr2o3M8ximyZQUKfh77PfaT	7706	10906	10906	1617902280000	orphaned
12477	3NLsAxE22cVhxBjK24EkxLokQZX51RWrpqfBMJ7hiNFHvpD5517i	12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	1422	1337	178	6301	8801	jxPnFKuf4ejBfQhpAiodPHiKk4pkLF6JJy6Q6YgnHfpgri9EKWr	6430	9086	9086	1617574680000	orphaned
12482	3NKDFstEMxNCCxaNJeoWmB8ud9hHwnpVxFkzjCgiNSBRpBRt6u1b	12481	3NLsxaJgQDtcHHDB8x4jK2SVbP9rfRJfcvmwBZTyAzpEejC6Wk1H	1422	1337	178	6301	8806	jxcLe4GqtnbkbaTQCS1SKu8eaQDZufoF5pDc6BX7MLF2Uiomwd6	6433	9089	9089	1617575220000	canonical
12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	1637	816	178	6301	8814	jwGtGuzpj3bQNZy6V1mCRbAwhXCfrqCAVQwQTu9jXHVVEPaxxov	6437	9096	9096	1617576480000	canonical
12493	3NKfmkSww42LBsdnLfQ53wiweabW2EKGWY7e5M8RChTAX9vVYMYA	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1587	1357	178	6301	8817	jxZ2Giu8cdr2vvFhiJ2s8iNnbuXAVspRZqmRFQNzEoLiVYWRyqi	6438	9097	9097	1617576660000	canonical
12494	3NKPFb6cotgJb96UrRXep4QNtkqHq6auvGd7zzcomMJTPwmYmQCn	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1406	1393	178	6301	8818	jwg3foWy2ejsz93guHreVjwRJr74sURY653tVzURbWFzYZUNgyQ	6438	9097	9097	1617576660000	orphaned
12499	3NKK7HoRqL9xYh6irG2pMXrcH7EWPKdzDRqsxpg3QEC5svrsfTVk	12497	3NKHR2HmyaYCmJBchdGBQS3HjKsDF6JTuKRQfCJjNSXyrKQKuv1m	1549	1116	178	6301	8822	jxWvnakvfnyY279VVBNYcrWt4Ritcf74Hx7jd6U4vbdAtzrpCRw	6440	9099	9099	1617577020000	orphaned
12506	3NKdG4X9fJjf8Svdx9BNj89CzyjEPHJmyA56GdfGUCKzBX3ddWp7	12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	448	1305	179	6301	8826	jy2JKWibkSAqtoRrrKhzaYjjNo9PabgjogEgRAHbMZnZkmZRs1J	6442	9101	9101	1617577380000	canonical
12503	3NKg9mqAsZuoWWv9md1ijwEGo8La5hDHc9zdi1k6QwhrMdKUBLet	12501	3NKQsA7of6rd5ZNUfGEUaZe48QFybj9LXEMpbhg6Li4ZPLm8V4jG	1403	31	178	6301	8825	jwemBSGwAF6zTghLb6cZVEHz38YJ8yv9wvLn4WP3csPaDHWSdVB	6442	9101	9101	1617577380000	orphaned
12507	3NLMrMSBFwDDmEn1AwayHq45V13gjBuPboUd872as9ZtRp3LCnnJ	12506	3NKdG4X9fJjf8Svdx9BNj89CzyjEPHJmyA56GdfGUCKzBX3ddWp7	1407	1395	179	6301	8828	jwzwxHiBsXmwzmverNtfDJrPZwqeskhXYHS1gTfwmLDv1FU8cQZ	6443	9102	9102	1617577560000	canonical
12510	3NKhsMQJxJw3WGGiSqMH5ZxSMoL6i9XBcGZkXAPJeMwgBeBfPky5	12509	3NLTe8vGq8NQAcKcnYFtdUYEwv4qzJ9YdPu6tc78rypDL76QLFs2	1406	1393	179	6301	8831	jxTgw2wX1Wy3gxkX9o2KTYB82GWNc3WG9ctuhR1riVN8mnaYA56	6446	9110	9110	1617579000000	canonical
12512	3NK5J1hbphF8sGUeap2GBDH5cJYahfdFSW8vmXiJ2LUur9GQQLSX	12511	3NLQMNZL1hvs7zEbADyWaEmmSt6RMt4qrNftWUq2No7Hg8qWWRgh	1464	591	179	6301	8833	jxmyXwvvAfVRBwbPP3Hn5qnw7VPHxRppbHVVCG4bfTzGbVNu9sT	6448	9113	9113	1617579540000	canonical
12513	3NK57NiUfcQ8HpzKwWUMJ9qhTqrxpb1VZqjv4rctVRtDZKLxyAF8	12512	3NK5J1hbphF8sGUeap2GBDH5cJYahfdFSW8vmXiJ2LUur9GQQLSX	1455	1332	179	6301	8834	jwxG1fJc8s9HEb5umX74EUeHzDgqi5xJ6KkZa3xQpfRLf6dWrA3	6449	9114	9114	1617579720000	orphaned
12515	3NKqU6gki9NHB3Zqur35tBQww5KJ8vPiuw61se94MvAHHcYVxe5s	12514	3NLVRf6gjcssbven6ZhiZTJqDLwdqSzeGFWgVqQuEcqASkBt2iXJ	1407	1395	179	6301	8836	jxqEUTBMTzMTHec7sKxqMDwoTuzHc54VZc1SJxafs8u7QVCHW9u	6450	9115	9115	1617579900000	canonical
12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	12515	3NKqU6gki9NHB3Zqur35tBQww5KJ8vPiuw61se94MvAHHcYVxe5s	1637	816	179	6301	8838	jwG6W7d3sc8GJMDj77PfYkdnhRYrURrfqBsn1Jr7RXMCVJ5CHRr	6451	9116	9116	1617580080000	canonical
12520	3NKm1BNqr2edRM8zuyUkASjUtXcJS8ynxeGWwQu2R67ryUao1PH1	12517	3NL2w4YD1127daRM1UJAykxmaAyp6yArmuNMk8LzpHLpf17yU4Lq	1624	1088	179	6301	8841	jwY6nUEfNVkJenH2zENiED2XVHrnE8NQB7bVcuBgDFvP7DRTnBQ	6452	9117	9117	1617580260000	orphaned
12522	3NLb49T1CjoaV3QtRn9bR4XmCPDdVKJwHofekds4kirYUdm2detr	12519	3NKjjybo642gkMFN64UruqsmYnY8PoapnJCqNgVH6fmqbNp2dpks	1481	790	179	6301	8843	jxaUDT2z1PFuEzvwvFiTmJysWrKDH1XEhLQ9NLQxfMeqsBTiT3q	6453	9119	9119	1617580620000	orphaned
12525	3NLTeJrauBeun7cfyr4YonNPACksrFo5mSi9hhx5TeLe8yGhsovW	12521	3NLkPBfTYwJkvwpFXAHmrj5jgFgKp1169x6LrWj8Fz82N1bD2xP5	1623	830	179	6301	8846	jwEvQwPWwhfeRmDXSrHcCRmGPSUmgPLF4x1N5cjGeErYpPbVhNJ	6454	9122	9122	1617581160000	orphaned
12527	3NKuZZWJH4PDXvNSS8SWSswpJ4TeMA2QQ8mFZEs555k36rMr6H75	12526	3NLFvxF7cDD5e9vg5YRcnAzR35nCvjfXsx6ZnSGknVzeZShmSpBk	1406	1393	179	6301	8848	jwN9ZRs1UAB8z653qbPcZz2YK8Pp4e2jvuvhLzrgmFCNQmGLxh3	6456	9124	9124	1617581520000	orphaned
12529	3NKkDN2hoRUJErTNKEU4KYQ3DC3KegPsK1aqamq5HxsTWcyeksAe	12528	3NL2fCqVCEMbhr5ZDykxfHZH7aSKpVdmaUUdGQpJUodmbefGui13	1407	1395	179	6301	8850	jxT2hJLStJWHfdTxGxeLUbSwss2JQs9i4xhivpUxwZrh97V1x2t	6457	9125	9125	1617581700000	canonical
12532	3NKjGzxZoe94c1Quxz1WfZeG6bprRpFcMgZdkX6WAghi3ZV1w5KK	12528	3NL2fCqVCEMbhr5ZDykxfHZH7aSKpVdmaUUdGQpJUodmbefGui13	1500	1297	179	6301	8853	jwRGn6Y7rgoz7SbVMbNFocd2EJTML98gGsxUzPLUv4qE1ZCZuPg	6457	9127	9127	1617582060000	orphaned
12533	3NLTnWMKjhbA9phaYqeHSNhpc4kkePzSvU6t7sAquV1rJnkLTexw	12530	3NLRAe4ujUW7Qn2K1vpFFQHXeLwPqNgiQ7JspoDi1coDY5H9VcpF	1406	1393	179	6301	8854	jxZaNobK8PieaCwxjnjri1Q1DS8yNh6QSQWdZcGQQSgKdQdDQAK	6459	9127	9127	1617582060000	orphaned
12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	12535	3NLwoAwncnK6qijdnhKX4REBMX1AozErdtuqG8iHPJaiR2eL8dyh	1610	1314	179	6301	8857	jwSpVZwzLnZuJknH2QL4G5HfUhdxLK7b1PDd5obFwZ1WTTVchhg	6461	9130	9130	1617582600000	canonical
12539	3NLweKK9TUoQqGkhwUAeGEFwAMhsMY9L53pAyFP2NYF2ymapcZcw	12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	1631	794	179	6301	8860	jwZhposEkirDBq38xiefYKTeJZSbE9E66Gsd83faHBnqsKymj8g	6462	9131	9131	1617582780000	orphaned
12537	3NKAneWkAZvbFVj1qFR16ySDGouGKQEZkTaEkE94GeSB84oDCiPK	12536	3NL7EFagzCKXYyJSPjBMnArVz219opgRRyYPEYQ3bHg5GTAuNezw	1609	1333	179	6301	8858	jxyYGVY4hGqYGs2Bu84uX1WLBYyDXDyRCfEwGngpeDhD5LJbNX5	6462	9131	9131	1617582780000	orphaned
12542	3NLHH4TRqk8po633733atc75bWhs5JB4khrEPBsW26rSKETeDcui	12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	1445	924	179	6301	8863	jxvt7sJfrrmgH23VYXiimStFKkJVP3L6qrbcnEjTxMP1gKdWjjN	6463	9133	9133	1617583140000	canonical
12540	3NKhQdPh7xP2dm8EKAjXD9ntAeqEbFVprqjqPhAxuK9owduuTziA	12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	1615	459	179	6301	8861	jwMqMuy5btHVNgWixcUNm2K9ctY8QNuafV5Ca2mcjqkvDAdEMun	6463	9133	9133	1617583140000	orphaned
12541	3NL7K4woZtbYzh6wTz4E5wmSifCU7aXP8vC4F4aJbRu9htTsYDgm	12538	3NKi7DAkfTxB7yMZoAs9WCH76bcgVhCdy7w5wLxYZA829rAsYEHn	1455	966	179	6301	8862	jxmih5auuLZHP9MHVN4FcVs1Trg2rJEYfZVf5GKtpopa6Eh3a47	6463	9133	9133	1617583140000	orphaned
12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	12542	3NLHH4TRqk8po633733atc75bWhs5JB4khrEPBsW26rSKETeDcui	1588	1392	179	6301	8864	jwbHLgDooTGF7nPo87GsFHSveV7PjGpaU9mhtPUixtg6hQuKmjN	6464	9135	9135	1617583500000	canonical
12544	3NLN1tprHTtt66HgSqu4S46QAmyGdPitF62NJgRPC39bJznCfWyC	12542	3NLHH4TRqk8po633733atc75bWhs5JB4khrEPBsW26rSKETeDcui	1467	1376	179	6301	8865	jwKHvpMDS2wpCwfhhngNhLJP7BhmXDhEzJiyTYofjut5eeaFsXx	6464	9135	9135	1617583500000	orphaned
15124	3NKVx7Xpi777wH7CYAxtymJCV82FWbD2wRXc63WEL5LVMNUV3Thy	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1527	927	241	6301	11178	jxYENBNGLzKypGJRtGHmUfsAiGRqYtCn7oMMvurGR5tmTDA9rez	7708	10908	10908	1617902640000	orphaned
12546	3NK9UdbD9GewsEju71FZfzFwnA3gtESX7ZRV7YkgboVUYCvFDqxQ	12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	1523	1321	179	6301	8866	jxtSRpyDipsKZcAeALTWdNziH9vDsSFigZyTzgS3kD9p4jg428U	6465	9136	9136	1617583680000	canonical
12545	3NKvdaaYRyixnHDJ5KW4FbqkruFq6wwZgDAH4npPyXpMQhcsjGPJ	12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	1523	1321	179	6301	8866	jwYhD5ZCAVko7GPjacxmw1kL1XAaf6Y2rjXWj4Ypku6GcKzFV9c	6465	9136	9136	1617583680000	orphaned
12549	3NKDGgQgn3yRDyLHfecy82aL5fNQzjRLswCqhFEwrvxYvxfRyrLP	12546	3NK9UdbD9GewsEju71FZfzFwnA3gtESX7ZRV7YkgboVUYCvFDqxQ	1611	1215	179	6301	8868	jxd9X191om2CEZcdTHR2PHd3EbnJicXanVKBSHdkgf6hQfdeJnZ	6466	9137	9137	1617583860000	canonical
12548	3NKVAePo3i4kitq2rw1jCQTNjzB7eBvJxk8ZES6g1GBsXMj4tFnK	12546	3NK9UdbD9GewsEju71FZfzFwnA3gtESX7ZRV7YkgboVUYCvFDqxQ	1619	1275	179	6301	8867	jwHLbwLsmT3EenbQjZiNPrgvPNEfHAWVa3PqjjheJDyp6pqRhay	6466	9137	9137	1617583860000	orphaned
12550	3NLYRJiJxtRpaaeo7c4A7JnBJ9vE9qd3frAf3RNx6TQ6Fz35SGRJ	12549	3NKDGgQgn3yRDyLHfecy82aL5fNQzjRLswCqhFEwrvxYvxfRyrLP	1488	458	179	6301	8869	jxM9zrppMjbZb3dBvJgj3bkXVbUrnA4c9mN59wpJMkEfJQppXc3	6467	9138	9138	1617584040000	canonical
12551	3NKpkbteT8umxTTXZnEUijY7fcP5VqpxQhrKUN9uwBSg5DWzbrgQ	12549	3NKDGgQgn3yRDyLHfecy82aL5fNQzjRLswCqhFEwrvxYvxfRyrLP	1488	458	180	6301	8869	jwzD3sccZdPTGaMsDXjXKeJ12Qk9GxnwfcUCfZKcvbwhrYKkjEk	6467	9138	9138	1617584040000	orphaned
12553	3NLTRc8Z68iDu3tx5J8dUKiytBjKNPo5BtjbsYRTPxobgRp5inwv	12550	3NLYRJiJxtRpaaeo7c4A7JnBJ9vE9qd3frAf3RNx6TQ6Fz35SGRJ	1613	1103	180	6301	8871	jxYQ11gtznwkMWQiqruHEHHym8hPv6ZLXZ1BBXHppHLvpLHnFnp	6468	9139	9139	1617584220000	canonical
12554	3NLVuZTej2PnGLCwKnvqLe5xGpCk1kutyaqisY1Bvz87Gg1dJVUr	12553	3NLTRc8Z68iDu3tx5J8dUKiytBjKNPo5BtjbsYRTPxobgRp5inwv	1406	1393	180	6301	8872	jwnFiJEWXGjCU34cJ9kqxGy9nfcHxBkZUhVVGz9JVXSyhLYxWRu	6469	9140	9140	1617584400000	canonical
12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	12554	3NLVuZTej2PnGLCwKnvqLe5xGpCk1kutyaqisY1Bvz87Gg1dJVUr	1406	1393	180	6301	8873	jwRR72HVdypXw1par6nNYurpoQDtxsnYsEzD78bMB9wH1CmzcSA	6470	9143	9143	1617584940000	canonical
12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	149	1283	180	6301	8876	jxZCfcYUvNtRSYjFvbv6k6QY7YoHtRsSxyM3k5o3yaE1M9uk9Li	6471	9144	9144	1617585120000	canonical
12560	3NLXZqhKo62kqdWQKwNJHky42j9nT8kfBmXqsWzJ2SBw6qai6ZP8	12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	1675	1216	180	6301	8878	jws9TEyxUDXAnqdDbMoAhM51o9ymtbKYAERrNz8PRrvLPSmNDVE	6472	9146	9146	1617585480000	orphaned
12562	3NLYymTHZExDpZ4qn88wQVE2vLhJrwkeK3MFWsaoc8zmarQdnBeo	12561	3NKdqjtqyC3RhzYbxdWUZnqRL7qWRYgxQeZih9eZt5x7cFkz6oyg	1671	1365	180	6301	8880	jxjKL5odGJtEszb7CZmo6Nsj5DNSEkers9QFTHY2ihfmiGiFvK1	6473	9147	9147	1617585660000	canonical
12564	3NLcnLxiGyr246gFJW1cbpYbsD6u9ENuhvjTb9pvekWtngK9ZjTN	12562	3NLYymTHZExDpZ4qn88wQVE2vLhJrwkeK3MFWsaoc8zmarQdnBeo	1419	814	180	6301	8882	jwUodK6LQyQrTrtLVaVswud7mZ5wjmgKJVauLJQMhpjeuWcTmbJ	6474	9148	9148	1617585840000	canonical
12567	3NKKqjyTfRAPcD6FUL3WyzVZY459fri449gc6RXuUGizGp8yBziD	12565	3NKbrYKAndTZisgWoX8HMr5ugLg9n5yemctHFpCSeU63Hd2URgbC	300	300	180	6301	8885	jxsTRBpK1M85XngGHVGUqovT7GVmUDEnnB3UJpgmJeAtMbL5uvZ	6476	9150	9150	1617586200000	orphaned
12571	3NKREj5W1L87ynQ1LUc3dnmRYVW8zMosX1unNrogZa4bhQGeTp6G	12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	1407	1395	180	6301	8889	jwaGLFZdE7g5tcYAnkwuUjbqKgZr6G14X93nYmjJDbdfSq8AW66	6478	9155	9155	1617587100000	canonical
12572	3NKy1KEGQ6CeLkqV8c3xmHC3PE8kmejtqQ2AGdtpDCFB6PdN5cqP	12571	3NKREj5W1L87ynQ1LUc3dnmRYVW8zMosX1unNrogZa4bhQGeTp6G	1668	1370	180	6301	8890	jxEdgc2iNJsWBXa9mSt3xYcfPLH7o8sKftBY38mE6nvoAiSmRNG	6479	9156	9156	1617587280000	canonical
12583	3NLcTxpKcab4ccxWcTgYtL6Dh4y1AZ2eQkd8JeDTkwc79R2QWLBc	12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	1406	1393	180	6301	8901	jxwph3HG7HFWJ4WrvVye5Daf4Lp7xLmdGZrnLrzMxXKjbqjTGT4	6485	9163	9163	1617588540000	canonical
12581	3NLTsNk2eF1n6c6chuX9SiVnp2dWvX755hYhkyKGNWwggy6dVtkq	12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	1448	1065	180	6301	8899	jxbcjbVYY3LNXXRHiqdafDzm1RKpAQNhrKvzxNq8eSXaHnhRJLC	6485	9163	9163	1617588540000	orphaned
12588	3NLvFDZofsNt4DY2FDXVEMoHwRQr8nSyTQ7DHY5zBZGAtTDeUFNN	12583	3NLcTxpKcab4ccxWcTgYtL6Dh4y1AZ2eQkd8JeDTkwc79R2QWLBc	1672	1159	180	6301	8906	jwJ8TVyeG5fdVqKNSozn26qiPQnEUn43LdeuPQXGJ79WUcYoWRN	6486	9171	9171	1617589980000	orphaned
12587	3NLxden6bnPM725WHBLCj9oekGsua9fRozLyb6UB2T3VBa3rnsTA	12585	3NKuszKPHK2u6MbqxRYxAQq8e9URQvdjwfaeHs98HJPgM8b5shP7	1643	1299	180	6301	8905	jwQhMba9jbBKbB2yErjnYWAEsQGmzhHgxYSPTspjDzZL3qhRsnn	6488	9170	9170	1617589800000	orphaned
12593	3NKiogDPf58CdF5BoYVZ5tiqMRRGsT5bau1Aatw8xWaKbcKTTCDq	12591	3NKTHf2jULPf7CCSySXmatzkvwkHGTroQx6RHrZPdDsCHsuNmR44	684	1106	181	6301	8911	jw9tTUV2YZvaCyLG14peFwrCa4XgeKMT3MC6osvEdz61xTdd689	6492	9174	9174	1617590520000	orphaned
12595	3NLa5ChtMoK5c4rqWxRBbUkdZ368Uq4ai2xswTR3HjZ4Ryqd5w52	12592	3NLafKgeZ7rRJBeGQ9X9BAwn6Kajw4rJe5qCwXPMQ1nb884hGj8f	1634	1331	181	6301	8912	jxA3rc3JFsshwMyyxVKrZg17Ah55G7Q2UJHkKoQm3NDLKtFcNwp	6493	9175	9175	1617590700000	orphaned
12599	3NLMfiPGRZ2SqNKaWZLstXKksT7J76VdWTYMhdXHLY8iaJ4J1XZG	12598	3NKU1zgKSXTuyFEZnwpE54NXC4sQ9M9JHo3tN4t1uNLCXukKep4m	1397	838	181	6301	8916	jwQQrNrZPioyfXe2T6L2cdgWcM1qWyvCWEn95aA4dZK83Tn6G8c	6497	9182	9182	1617591960000	canonical
12602	3NLDPseKcHbAe9s3Nvi3eCFZAcGbGGPbyVCCRad1QawWdpeh93Pb	12600	3NKSbqfN5mQpoRt7X2oDLZT7mAmroexDaq2hPryMcsgPcRqU1tbW	1627	1259	181	6301	8919	jxm3iv7UuGrmtjoM8kzLnY3AQHPMAq7x71n6MEjeLsDw5eEGrnK	6499	9184	9184	1617592320000	orphaned
12610	3NKA3xxxkPwRCJDmWC3aTesbQo511VFnGgNsnp6VyhJu5FKuWPhx	12608	3NLoVhLZy2gDwp4b3o5vr1GQXN1ESgctA2WZmh1dG6UTVQR1ANjK	563	993	181	6301	8927	jwraAQqfBvDNnY8KPiCoPRaZr8cstYuNKaHKNpsECGNABPAjS7h	6504	9191	9191	1617593580000	orphaned
12612	3NKb5MVBU71xMwxPZEmWN6GpKcRPP2K4k8UJWRQXNLVoj1yhaqUR	12611	3NKfYZ4h8iq6wtkukjgXrYZ7SEpuhLGuCaALVTtMMJsAMsGMVBhc	1650	1375	181	6301	8929	jxWajJgA7e5MVky9a5tGyuLMFwRfUcp3TiCzTkN6Mz3e9n2PVX9	6506	9193	9193	1617593940000	canonical
12615	3NLmeGRbS7SezCt9rSnMxUyCoXE3jwgpNpe2h185Pi3mJkWk2REb	12613	3NL7pLW882K6WPyMNiZNgb4s6Mc3qgXsXDbYZhoJNoa68Je59EHJ	1536	1313	181	6301	8932	jxPR3wNm1aEHoZ7zWXNVEweA4r2N4GBzDSWJf6k9UQ5MuF8hRii	6508	9197	9197	1617594660000	canonical
12621	3NKh2mvpyh4ZyMDagVhc1ax5kV2FdYChaQbqsyFBAMDVkXN19QnF	12620	3NKqmh1z1N2egXBoHcQ59U4oPLfXqHNMEmDJ1eQwVsqVGrL5KBQX	1477	1350	181	6301	8938	jwnjhcJn2uuYWRKWA9ykWa8DaLGSgDk9YjKSqw4poZ9mj7VRihM	6513	9206	9206	1617596280000	canonical
12623	3NKdfKTHGt1jqttJpQ5vQK6AaVkRHrTTwhWg8eNQzEeueqWTcPp8	12622	3NL8RBwzikFtfzXJh5Syek9YvfqeiKZjgijqakc6w3j4bzhVyUVE	1406	1393	181	6301	8940	jx1JneHCdMAahHvG1ogrHTfWdJ1V24j27V8BJ5Qhnx7WqXKsfjH	6515	9209	9209	1617596820000	canonical
15196	3NL8cFzaMW4acaXXtT5gRXoxuYNGqD4tfQFtxouyyUMJFbAGW6qA	15146	3NL6waza7nrf3Y7xmMGWaVHSRfSGutU38y2pxQEnHiUKic1sih6W	606	1295	241	6301	11248	jws8juJYd7PH2TJySdNsNoy1x6Lh31vvQbeVdE9nKgdUEbt5cBG	7710	10957	10957	1617911460000	orphaned
12628	3NKx8SqTzhbvgJ1ZUTJ3ecFLf1ZSPLUVN3csw1hHMeUmUSZ4A9Mj	12355	3NLftAZmJKMpV91awrEJgqKG6NfAUxsZCZ8ZUMS4Mrir9GcRQtpZ	1622	1356	177	6301	8945	jwjWp6aALuBiLQ3RARy7GgdY3eSRZoPJGGRx9cAUZVR271xVQKu	6371	9210	9210	1617597067051	orphaned
12629	3NKTQowWJ6jQibfSYkRZRYKf2h6EgZfNrVYa3Na2Htmujz4yYYkp	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1622	1356	177	6301	8946	jxBw7cm5khzXQkvp6RXsss8Fb79n9m557JwwuMSkh6oyTGRmkhg	6382	9210	9210	1617597099245	orphaned
12630	3NLbgueBUh74acgUJH1EuEojWUyB3E7wWNwAfvkoDyTYVVJTVv95	12393	3NKn6kacxiErqbNvu7fMHNztffENaWg1XDJSmdGs25givg7aoB3z	1622	1356	178	6301	8947	jxMqAE8wX9UHuw6iKjaUEdH6Rot5rSjtdUrbnL1HusxXRwPx6As	6393	9210	9210	1617597132707	orphaned
12563	3NLtx5UPEEUnm79BmLXmpKpNQL1f43uYGieqcv7fB8wRh45bpg5d	12544	3NLN1tprHTtt66HgSqu4S46QAmyGdPitF62NJgRPC39bJznCfWyC	1671	1365	179	6301	8881	jxaEabbpkpn8JbH5LoWbxeFAsckoVDWeFkK3cFSZPUNKSYCErgx	6465	9147	9147	1617585660000	orphaned
12556	3NKidq4nSNpZm4TYs4iEx2z3WQ9wNyqrQzwDqQb84rE9DNirCPkM	12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	1406	1393	180	6301	8874	jxjK39Ve8MwBWUd4MvBq8wzuxoCwHSnm5Qc1ZGhTK5J4Unjdkwn	6471	9144	9144	1617585120000	orphaned
12569	3NLq7SG2Xi85zRsiCy1tECMmNGw9G1uKhzxXYKFTKzdEDPcC6gFw	12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	1490	1028	180	6301	8887	jwvfFY7mx1iM1zc5ejejmMsMMcHmPXy9e1BALkAHoj8E9a7odVi	6478	9155	9155	1617587100000	orphaned
12576	3NKhKGnWr7HZq2bWqnY8qgcJGSKZujkFu1VFL9mNQbSdnakSyYDn	12574	3NLoShqbfBrp2fW5qav3e3MStWrGJbaE2qZpkEFp31eV5RP6T15C	633	1138	180	6301	8894	jx71fY5AUNiC1SPPpUHyiCikAXMrLJNs9b4oDP8XceMUGWyidhH	6482	9160	9160	1617588000000	canonical
12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	12577	3NKV475GZbXo2nGmscxUePAT4w8A1pfhV3ytcawGeZFrfbGsG1a3	1631	794	180	6301	8898	jxhJzBhFUkUbwkFqUcWLXb2aknbX4yWDX6kcVmEQxVjTjWNz5yD	6484	9162	9162	1617588360000	canonical
12585	3NKuszKPHK2u6MbqxRYxAQq8e9URQvdjwfaeHs98HJPgM8b5shP7	12584	3NL56v1JoNKWxqWHGnQk3WvhE38HjeWBP1ovhBBFk4oXT3P6aTnz	1585	1120	180	6301	8903	jwVxoFvvE2Vn9uM6MX5uFDfhwyYTqQnVFT32WbbMtkjDtDRWTHL	6487	9168	9168	1617589440000	canonical
12592	3NLafKgeZ7rRJBeGQ9X9BAwn6Kajw4rJe5qCwXPMQ1nb884hGj8f	12591	3NKTHf2jULPf7CCSySXmatzkvwkHGTroQx6RHrZPdDsCHsuNmR44	1406	1393	180	6301	8910	jwn8SNCYhT8ZTDJnfYfojG4ZWgYkcwK9sj12uknMcQyUC7q5r6j	6492	9174	9174	1617590520000	canonical
12598	3NKU1zgKSXTuyFEZnwpE54NXC4sQ9M9JHo3tN4t1uNLCXukKep4m	12597	3NLrDkiTDwjr8gFrzq4wM51aiMLTGJeRa2QSqpyPaG6aP94WyEDo	1553	776	181	6301	8915	jwEw1Ep8nZTE3eSxuyJnyRPoYmdsP6tj1mf4Z2KggHaZHYaiF7r	6496	9181	9181	1617591780000	canonical
12604	3NK5YhjqRJFTukdj6BZiJ6t5zuCkR3UN8TH6rJVpdE9SivQSPqAX	12601	3NLgGjPM2rKrop417EPt6LsxtqqQNU8EFTbf1DRjrq7q8Ajo7Srv	1564	1338	181	6301	8921	jxD2PABSMEFyKNhMhLnHJBkaea1T7Ma9V1Y51izF39iqhQE3ToU	6500	9187	9187	1617592860000	canonical
12606	3NLcVojSdSM1yyswF5a8XH9LmoxGpK2CGWVQWhsyZjmSD28ch2wq	12605	3NKidkko6H7vnZ8kSn5RBKLk9SeHpji3G3fgkR5FXhTbQAvpLv2e	1483	309	181	6301	8923	jw8PV9ZU6gsYsBsJVincmu5Nfq4Z5coFM31rYmDQiR4naohgA8W	6502	9189	9189	1617593220000	orphaned
12608	3NLoVhLZy2gDwp4b3o5vr1GQXN1ESgctA2WZmh1dG6UTVQR1ANjK	12607	3NLoPmPUt1SiNkcsp7e8rPnHJyW4VhMjznFwHsjDn7Y8h3Sqccdt	1657	1098	181	6301	8925	jxtGFAMrVbzzDF8xoMStgqrJnD6sxnwHMDhZ5v22mFpsbHXcVjH	6503	9190	9190	1617593400000	canonical
12614	3NKqWRAnuy9SxVzqox8TZdR9NvVxWSNJjqjVLGjABcQUpH7NWjwh	12612	3NKb5MVBU71xMwxPZEmWN6GpKcRPP2K4k8UJWRQXNLVoj1yhaqUR	1406	1393	181	6301	8931	jwNcEnqEsXJw2n95pootXa8EBoho3eDdDnMKGNJz9SZ33DMbZja	6507	9196	9196	1617594480000	orphaned
12616	3NKATSRWLbbCAbuu3ermbcrxYLapKpCwVBGTJjHCPbLQ64eQb5hc	12615	3NLmeGRbS7SezCt9rSnMxUyCoXE3jwgpNpe2h185Pi3mJkWk2REb	1527	1293	181	6301	8933	jxmiJCHWRRVGCAFq1ZQg3ATkcL7rotxp6MkyLWa9AR3maLgQoxe	6509	9198	9198	1617594840000	orphaned
12619	3NKkvCWNvCyQzDxqwtLY7Xy55iYyDhYMicA3xM6BQQWKAWL4m65Z	12618	3NLMHzMdeAAYPQEAj6dPnqRKqYTRWkGATSwX9krmY11FCNXvPmy7	1624	1208	181	6301	8936	jwhrEZ2cCPnvwzoBTRCmaMeciphk3z2NPCp7Pob6APKMX3PY5hg	6511	9202	9202	1617595560000	canonical
12626	3NLw5tUghbtJRapiKW2P2WiCbTV1N8D33Knv5WfjRsmGv1py7NMz	12623	3NKdfKTHGt1jqttJpQ5vQK6AaVkRHrTTwhWg8eNQzEeueqWTcPp8	1529	1190	181	6301	8943	jwHdrKGN99hUirvnp1452g31mxc2S2FbjTw1LsrGv1eQPnT4kBZ	6516	9210	9210	1617597000000	orphaned
12632	3NKiLsvCc28WjzzVv3y4SYWwLRNiM1fmFKTwnxkCwJo8oBgVRkj2	12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	58	915	182	6301	8948	jwFjw9g3nGTEEsLCsy6eJogz8ynhAbNwW3VWx11nt1HjFYJFwoj	6517	9211	9211	1617597180000	canonical
12636	3NKrLdLNopc6eSXwf6U9NZmQbBTSFe5Wt5A1YZktmevMR2V9mnhA	12631	3NL33z214cMAkgrPxyL5gRTvzZ4stWhm6E2CkEhwX7e2scJQMdDV	80	1273	182	6301	8950	jx95Bu7JGYdynJUgAm1WqSkbedshjFAoNGvqYhL9Md5nGQuBJ54	6518	9212	9212	1617597360000	orphaned
12637	3NLsscjRCuSw7bWJfNfgoBoyVhXfa85q7HYdETMZr7kVpXvCFtxH	12635	3NLPmq3CtKjgTCHZUdWJYXVghRFXrFmU1DjFamLYb5GDz64CJdmX	632	1382	182	6301	8952	jwgh6gZAiQ22UyxZDATTVb5F58V8CTuEvHjpYJcup8w1frsCBex	6519	9215	9215	1617597900000	canonical
12641	3NKWyYe9HymUoNAcKgPQ3xUdbvWegRkdY4vRgaMPkZGV566hzowA	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	1458	1077	182	6301	8956	jx5TYSVcrXoayPSnszafungUh2wc1rf5PGiPneWtPD4BbBTypnz	6521	9219	9219	1617598620000	canonical
12644	3NK5MyrRa2ky82hvaJJZHoTc69fANu6mm8bauU9A3kEF7jG1NBNF	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	470	1063	182	6301	8958	jwa2YtWZdHY9vCK9FPA3t6ucP338VtqQywr3RdgiTYD7mGrQM83	6521	9219	9219	1617598620000	orphaned
12649	3NLZcJqhVu4SqHBvJrgUZzTPQmU7ffVrNsbY3LJYRpmWkqXoiNHb	12646	3NKebYx4y8gxHSNiH4NRma4UKssA7nZh2ru6JJWh2zDRUDKk4UdZ	1406	1393	182	6301	8963	jxTAWbCi8vRBBHqPz2PVPDG7Djmbz41ahVYJmHTSBRDaCKTCZmr	6524	9222	9222	1617599160000	canonical
12650	3NLi1CP8uk48QpLsKgeEKmQoK2JYfUmgKq1StiphNwhFvUCpUbnM	12649	3NLZcJqhVu4SqHBvJrgUZzTPQmU7ffVrNsbY3LJYRpmWkqXoiNHb	1407	1395	182	6301	8964	jwFkCCtXtNZ9QQgbFsKutNZFN5ECHau4T5sT47yAposJraEM9xx	6525	9225	9225	1617599700000	canonical
12652	3NLXjYFt73WgbZ3Q9t151hBnd6M2JVLL48LnTLYtJYcLEzhP3Uu4	12650	3NLi1CP8uk48QpLsKgeEKmQoK2JYfUmgKq1StiphNwhFvUCpUbnM	1508	1021	182	6301	8966	jwAfin3YU4AapTygZmZhhDs1EeN1HpPcayFznsSh1dGpiDujcxr	6526	9226	9226	1617599880000	canonical
12656	3NL1QRNeZKo7rbeswDCEvFy4YpDaBVSwdhUiMuhbCKtbdrd3hoGV	12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	1406	1393	182	6301	8970	jxzoxGQb63zkjhLUCpeKV3RWf1kZDyLuYBiPbt4gGaANjTv75sD	6528	9230	9230	1617600600000	orphaned
12658	3NKz9PqziwfZu4JjYdY6P3HW38y9rzQVreH8Ywh8gEGerX9Jzh4o	12655	3NLC8HFXNGEsRg1HTqPqyUN4Jj89UpFU7AGogBhQaKD88smbtCz6	1507	1280	182	6301	8972	jwjk95SMSyGWRmwnHXfP2ADsg8etALccdJgx6d7KywP1DiGRzZV	6529	9231	9231	1617600780000	canonical
12660	3NLKw3mZVQYfrSDKSXmgkWZfnLzv2UYm72UKzKZfCCMJCz6KPCPC	12658	3NKz9PqziwfZu4JjYdY6P3HW38y9rzQVreH8Ywh8gEGerX9Jzh4o	1406	1393	182	6301	8974	jwegFeoJSYSNtWFUKCdr6cMG9AptzURYEGGkhNSWq7iHsQQ6KEC	6530	9232	9232	1617600960000	orphaned
15129	3NKZbXe74t7P7K6Ub72ogZnVtxsWe6J9PaRjteU6sxZWNEZwKmvi	15128	3NKDfU8FpZHV9KjXjCMoDHVHp1JxG9AbyrEGga5FhrjVgBvp518h	1489	1380	241	6301	11183	jx32BNNZEXopSLPkwS3MR4YDo1V5qFmxVsfoWjxQaVtXL5HkkBF	7711	10914	10914	1617903720000	canonical
12624	3NLg643UmaW8KwLVGmSuhZaR5qbRi6pfoksRhMs4JnUWoHhCv2e5	12313	3NLMrNhxyYpoyDevgavHF8agbAg2czasHZ9U89kGMdQoRGyuXjHZ	1622	1356	176	6301	8941	jxh1BnQoB6NEXPJgjRkkuQqTwPBPhG6fEppZvG3qddDNcxiP1vE	6346	9210	9210	1617597000000	orphaned
12627	3NLMPRs1uaqSyiCbdTwotUvE1izaYCzmURJob6PUfpzSSy5GckbX	12334	3NLjg61Wpbiqft1X1JjFu1BWiByjEMMsNiXxjDkW3utVupBTgFew	1622	1356	177	6301	8944	jx5owXdnY8KwuYYpGWyAbNyjqSKHyFziajJx8N3N7hzdK7gpwUR	6358	9210	9210	1617597033249	orphaned
12669	3NK3iczmFnnusyneCnjBCydmtmpEWN2MT3k7HfceYz8NamCV5XxC	12563	3NLtx5UPEEUnm79BmLXmpKpNQL1f43uYGieqcv7fB8wRh45bpg5d	1671	1365	179	6301	8982	jxaEabbpkpn8JbH5LoWbxeFAsckoVDWeFkK3cFSZPUNKSYCErgx	6466	9237	9237	1617601860000	orphaned
12557	3NKsnBXHTFhLvnVXprAdQBhburZCVgfyjukpNv5qXoKdoQ1eaLq3	12555	3NLM2j72HkUCoKqmuEb9sRBuj6ahZH3pybN8xmGsad3tLvMqE1ZW	1419	814	180	6301	8875	jxM5xwBztuTSsqChKL9zuzKkogLEWGyE2wpoq74gv9UTbunLAUY	6471	9144	9144	1617585120000	orphaned
12559	3NLTcj9RZBw4oPDovjVrtmvDW2w1EMxmxBNmKNrQWtgriMDVwfW6	12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	1419	814	180	6301	8877	jxErAvdSJs1wB9ksPSQLiqBTjPxPQyNTywMmUPYfs5hj7ins7bs	6472	9146	9146	1617585480000	orphaned
12566	3NKsbbKkuBUDaKohaK7Cs8UZfkdCn8NEuMm3crB8YhT1EZYYMzte	12565	3NKbrYKAndTZisgWoX8HMr5ugLg9n5yemctHFpCSeU63Hd2URgbC	1407	1395	180	6301	8884	jxBeJNMv3cr4rLCMTnSrwZoB5nBxaCVN1W58DVhiy1PP6j2NXNy	6476	9150	9150	1617586200000	canonical
12570	3NLb6HB52Wm92bjz189Stw4DT9AX3zczVg7t46RZMTN1PMTd1nTL	12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	1402	850	180	6301	8888	jxeu7pdd5ReKxmHWvtUkTW2u1eXY3BTDwLhsNQokGQ5szce59zP	6478	9155	9155	1617587100000	orphaned
12574	3NLoShqbfBrp2fW5qav3e3MStWrGJbaE2qZpkEFp31eV5RP6T15C	12573	3NLrpZ4eUjZLNF6Pd31vByGW2vkRkj5tQiC5VJoLoKcnZ2SRX9sh	1406	1393	180	6301	8892	jwypZbPpgN3wBA4ysmAfoNe2rpCFXCnjey4JmHE7qvCV7tfSZHZ	6481	9158	9158	1617587640000	canonical
12586	3NKJgnDPceJ8uai5Qakm3eCejD1LZjKefwktg2zDYCqKLdKrnD22	12585	3NKuszKPHK2u6MbqxRYxAQq8e9URQvdjwfaeHs98HJPgM8b5shP7	1483	1276	180	6301	8904	jxS5C64PMNJu9NeLBpnfjzjY96Jz5M4ktax9k7iNuBvayJgm5Mw	6488	9170	9170	1617589800000	canonical
12596	3NK2xEkRQMsYVjATie7Eh3zzw6Wsvq7pGREA3FsK5nTfqgEJ3zKu	12594	3NKx7NF4sbjV6Si9FagoUn7mE7ekLu2cBWu3pVobosWgjCtcFjeF	1506	1127	181	6301	8913	jwMG6d2suBU7iPnCU3yDX3y83ZQwAYq78xDBMgxEbNiTKHoZCJ7	6494	9179	9179	1617591420000	canonical
12601	3NLgGjPM2rKrop417EPt6LsxtqqQNU8EFTbf1DRjrq7q8Ajo7Srv	12600	3NKSbqfN5mQpoRt7X2oDLZT7mAmroexDaq2hPryMcsgPcRqU1tbW	1673	1002	181	6301	8918	jwMaHQGZEMv1Mkd7a4uYYN3DwyDSfs8Zo3yLaWAX4yzxQLHYe9Y	6499	9184	9184	1617592320000	canonical
12607	3NLoPmPUt1SiNkcsp7e8rPnHJyW4VhMjznFwHsjDn7Y8h3Sqccdt	12605	3NKidkko6H7vnZ8kSn5RBKLk9SeHpji3G3fgkR5FXhTbQAvpLv2e	1406	1393	181	6301	8924	jxYj8xMJnsJF6qfRoWuS7vAwVDLpKt51d6E9GBwCVRwA9yHNKSi	6502	9189	9189	1617593220000	canonical
12609	3NLVY5ekmrm8VPGBszfa1u2nM9Xx1rdowjSq14zsCCoD19hdUfK7	12608	3NLoVhLZy2gDwp4b3o5vr1GQXN1ESgctA2WZmh1dG6UTVQR1ANjK	1637	816	181	6301	8926	jwbgkSVTYavXrLAifJyG2pQVo6HbLf82zDPiGfGyqXL5ivzowSk	6504	9191	9191	1617593580000	canonical
12611	3NKfYZ4h8iq6wtkukjgXrYZ7SEpuhLGuCaALVTtMMJsAMsGMVBhc	12609	3NLVY5ekmrm8VPGBszfa1u2nM9Xx1rdowjSq14zsCCoD19hdUfK7	1407	1395	181	6301	8928	jwEFbuRqiLxxRoMiawmPEeVEKZPPMaX19hFq84HuEWbPhpyejKQ	6505	9192	9192	1617593760000	canonical
12617	3NKxZs5RoS5jkFsrS4p1gLMYz5tBMoQToonn7W2WViTyhbuHrDU9	12615	3NLmeGRbS7SezCt9rSnMxUyCoXE3jwgpNpe2h185Pi3mJkWk2REb	1419	814	181	6301	8934	jxjN8eW3bDwRkyerx1qwLsEoSkPU1TSLxJg9sSxcz7q2nsCF21Y	6509	9198	9198	1617594840000	canonical
12620	3NKqmh1z1N2egXBoHcQ59U4oPLfXqHNMEmDJ1eQwVsqVGrL5KBQX	12619	3NKkvCWNvCyQzDxqwtLY7Xy55iYyDhYMicA3xM6BQQWKAWL4m65Z	1601	1388	181	6301	8937	jxiypN6Pyk4aZkhyYKpiNbMtHhTYgprq3pidVq5zzHAPeCuHXeo	6512	9203	9203	1617595740000	canonical
12633	3NKH9BuA6WzF6CnDYAwaL24SjJcZ7BaYHGqbfdAXQL7XLNsgjsr5	12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	1631	794	181	6301	8949	jxoDei6AtsrxvPq4fh1cFyZqzjQWvPEcU4Ta764ypNwXBmc1754	6517	9211	9211	1617597180000	orphaned
12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	12637	3NLsscjRCuSw7bWJfNfgoBoyVhXfa85q7HYdETMZr7kVpXvCFtxH	1503	1277	182	6301	8953	jwUkwb66PogB9kFbTYSSMduJ9si5bsrczg8FPBS42fUo4GbxvBD	6520	9218	9218	1617598440000	canonical
12642	3NKG4iDtgB1KDu3TRSrESmWBFi9ZC4ruAzZ14qikbtNLaejGUdTp	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	1637	816	182	6301	8957	jwLJetKTF4YLhHEHa7LsWyxWhePh68cCy2hJXNPJZAs5sgvQcnZ	6521	9219	9219	1617598620000	orphaned
12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	12641	3NKWyYe9HymUoNAcKgPQ3xUdbvWegRkdY4vRgaMPkZGV566hzowA	1646	1354	182	6301	8959	jxagQyQS5zZbUYCCNAMK8Q7uZyggWYvLsw4L6aJ2WcjBiHdNFPe	6522	9220	9220	1617598800000	canonical
12646	3NKebYx4y8gxHSNiH4NRma4UKssA7nZh2ru6JJWh2zDRUDKk4UdZ	12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	576	1109	182	6301	8960	jxGYG8PEPuJ16CFcg27QD7DCPLav6Qh45Tik8FZi9EgWzdSFXwG	6523	9221	9221	1617598980000	canonical
12648	3NL8DTwCUFaCUdMyNCA3JSkPGyUmnLRzWcTiSDY2j6Zk2KoXUCFB	12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	1631	794	182	6301	8962	jwUEnGeifzQLTGnShjZSthv8wRFB8zT4h2V67nGcfZ2ZWh6ywxL	6523	9221	9221	1617598980000	orphaned
12651	3NL8ESkLgAkXyH9MpsF2LD3CozTVNYS1PthCd6Y3tetZpmuj7ZMe	12649	3NLZcJqhVu4SqHBvJrgUZzTPQmU7ffVrNsbY3LJYRpmWkqXoiNHb	1631	794	182	6301	8965	jwwArMfZ8aX38YmbVMfTRm9dMW2HCpq1udFhejWdSyp931SQHuD	6525	9225	9225	1617599700000	orphaned
12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	12652	3NLXjYFt73WgbZ3Q9t151hBnd6M2JVLL48LnTLYtJYcLEzhP3Uu4	1588	1392	182	6301	8967	jxUDRuzUBPAs9mTEAJ87ZLSScCkCkrxwuBZbBEFhCbAbWBzunzL	6527	9227	9227	1617600060000	canonical
12663	3NKzSv8ia7QJezE2iN9mgLV14Sn5rQcaEGYHt8GhVQh9N6tsN5Je	12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	1422	971	182	6301	8977	jwXzqyw867vZXXwmyjVLcxpwD458xVWgWazv91hHEudhqonTEwa	6532	9234	9234	1617601320000	orphaned
12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	12662	3NK5rzVtyxLi4wUr4j2iAD9jq1v5VpRpiHM5GVTPc1nAK6Fidz8q	1483	1276	182	6301	8978	jxUmUJc48RrA2R1Qyk1r1zifs3bZ4PvTcrXVrLJYHbiXGLW9aLM	6533	9236	9236	1617601680000	canonical
12672	3NLEoeWncoFULuvAs3JEdC12EW6VkE4jMag8uecof7JqjAtScrDL	12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	1651	1301	182	6301	8985	jwgutgEGWubzHsRAJSuj1SQbiMzsLqXwGdUQygUj3KANSMoYN6D	6536	9240	9240	1617602400000	orphaned
12674	3NKFYYdAUrkj5o5hNNYdsxwCdXofMvSM2cy2DrFePPGLYQC3YLpo	12671	3NLCHSzmSoatgjE5kSdC33juXqmrYQfKnaPr6UuLBBHv7zZyTpHN	298	1308	182	6301	8986	jxgPHv5GvrRzuJy9HT8QR8emVNR4mBJKqAHNYrGeNSD1ubBQyrM	6537	9241	9241	1617602580000	canonical
12679	3NL8FGyJ7DjCoZxzfTU5Vwh4UA28nbB95r14ovFaCZv7wUQQi7Je	12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	1406	1393	182	6301	8991	jwLEDLP8154e3AYp75jvsFUw5TgHu7iX9NEs5XaTzzky7r1EEXZ	6539	9244	9244	1617603120000	orphaned
15143	3NKkahYvt1KemuM7cRYTGwFNRRsdHjYuK4n3sWZjchg8f1QepTqk	15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	1406	1393	241	6301	11197	jwD1J7GnUDK2XtCGTVH7jD4ZQMdj8j8XUYdyzoCC6kWMNidQijC	7719	10923	10923	1617905340000	orphaned
12565	3NKbrYKAndTZisgWoX8HMr5ugLg9n5yemctHFpCSeU63Hd2URgbC	12564	3NLcnLxiGyr246gFJW1cbpYbsD6u9ENuhvjTb9pvekWtngK9ZjTN	1489	1134	180	6301	8883	jxN6RgW65Xp4kAknmZzAUX81kGh6Lj6ZXCEp4AYsyebySVEmvoz	6475	9149	9149	1617586020000	canonical
12568	3NLtuRfRD2duFqNUtMrUYJ56CHAgc7MssQ7dZFtCi3P38z2L7Pit	12566	3NKsbbKkuBUDaKohaK7Cs8UZfkdCn8NEuMm3crB8YhT1EZYYMzte	1406	1393	180	6301	8886	jxYtT3G4J8ZwEXfzQ3JA52DFtUye5UX7D38XBrrpvs6aXTewBXL	6477	9154	9154	1617586920000	canonical
12573	3NLrpZ4eUjZLNF6Pd31vByGW2vkRkj5tQiC5VJoLoKcnZ2SRX9sh	12572	3NKy1KEGQ6CeLkqV8c3xmHC3PE8kmejtqQ2AGdtpDCFB6PdN5cqP	1617	922	180	6301	8891	jwP2tet2MY2gYYsddt9LZYUGZ1QBPHZA9ptnwrY5oDvRGB5GnTY	6480	9157	9157	1617587460000	canonical
12575	3NKFUn1DEjx9THdZ7XT7VtzMMtRXZb5XQzvFQQ72mSTa7V88rq5P	12573	3NLrpZ4eUjZLNF6Pd31vByGW2vkRkj5tQiC5VJoLoKcnZ2SRX9sh	1439	1033	180	6301	8893	jwmbF1Y9fEodZRLt3BY1bwDcRuLRg1SfTDSVnfDmthiZFiAP23q	6481	9158	9158	1617587640000	orphaned
12579	3NLQegvMrhA2YUbiZdVgZLRTGf65iAjGGq1viudq6nFzmnqmgQ7q	12577	3NKV475GZbXo2nGmscxUePAT4w8A1pfhV3ytcawGeZFrfbGsG1a3	1647	936	180	6301	8897	jw7UWVGZ1q3GWsK3yZufgFCMSNTKgxhoDC6qtCGoaETriYvUova	6484	9162	9162	1617588360000	orphaned
12582	3NLhZY261PkPE6TaDP718cBWNtppq6hexjK99rDQypYmYGW9JTXS	12580	3NKNGvqZyhbnfWsz9WJ4c6Na3cdgtkqhhdfgRcX4eUQ5V2c1Ntxj	1422	1211	180	6301	8900	jw7jnEHbWwnP3Xq3BxSH2P63BDRJinKRprVeAhvmfW9UzSqni32	6485	9163	9163	1617588540000	orphaned
12589	3NKfM8pjDxn8yE766Zrwvqy4C4sdxBjTSwF8krknLMtyPxfzxCfU	12586	3NKJgnDPceJ8uai5Qakm3eCejD1LZjKefwktg2zDYCqKLdKrnD22	1672	1159	180	6301	8907	jx9k91fJ3nzGHnwGp2gq9gtaymvH3LU3nW88mufNx4BpEVTLFbz	6489	9171	9171	1617589980000	canonical
12590	3NLDiwowvQzjNLTeGbkGdErkPjRworFRWZ3q8aEYqcZJ35ZpaxtF	12589	3NKfM8pjDxn8yE766Zrwvqy4C4sdxBjTSwF8krknLMtyPxfzxCfU	1633	1264	180	6301	8908	jwgYQXr3KfsVwF8GGm6zqZzLcqY1dgDf12Uj7j1TB1Ywfis73bX	6490	9172	9172	1617590160000	canonical
12594	3NKx7NF4sbjV6Si9FagoUn7mE7ekLu2cBWu3pVobosWgjCtcFjeF	12592	3NLafKgeZ7rRJBeGQ9X9BAwn6Kajw4rJe5qCwXPMQ1nb884hGj8f	1634	1331	181	6301	8912	jwNKjo5aX4vkxKaLjh1wPXeViLs6oJwVCMR1NvZwJWLQkNYsnxG	6493	9175	9175	1617590700000	canonical
12597	3NLrDkiTDwjr8gFrzq4wM51aiMLTGJeRa2QSqpyPaG6aP94WyEDo	12596	3NK2xEkRQMsYVjATie7Eh3zzw6Wsvq7pGREA3FsK5nTfqgEJ3zKu	1407	1395	181	6301	8914	jx4MjPptwg9n1UFiZU2qGsPCGa8CHjFuKEED3bwFyWQUhpjwTsU	6495	9180	9180	1617591600000	canonical
12600	3NKSbqfN5mQpoRt7X2oDLZT7mAmroexDaq2hPryMcsgPcRqU1tbW	12599	3NLMfiPGRZ2SqNKaWZLstXKksT7J76VdWTYMhdXHLY8iaJ4J1XZG	1407	1395	181	6301	8917	jxZayZqa1hXAj7zsKtdoEZoWLT5yjM2doR3aVmQYMNuFvCzHGCm	6498	9183	9183	1617592140000	canonical
12603	3NLZcmiQedN2VCnzFEKj8f2JVPdfzkx8E3eURafBhPdDUNRoBRLr	12601	3NLgGjPM2rKrop417EPt6LsxtqqQNU8EFTbf1DRjrq7q8Ajo7Srv	1509	1194	181	6301	8920	jwXLcHBufF9kwSgHS3DtEJdJmawjQSWFCNnTbM5y6HxhEgKV9BD	6500	9187	9187	1617592860000	orphaned
12605	3NKidkko6H7vnZ8kSn5RBKLk9SeHpji3G3fgkR5FXhTbQAvpLv2e	12604	3NK5YhjqRJFTukdj6BZiJ6t5zuCkR3UN8TH6rJVpdE9SivQSPqAX	311	1307	181	6301	8922	jwTkJkMhyaKqscA8Wqeee8Zi4SRUvmQNr1d2gfNhwGaU63EH6UK	6501	9188	9188	1617593040000	canonical
12613	3NL7pLW882K6WPyMNiZNgb4s6Mc3qgXsXDbYZhoJNoa68Je59EHJ	12612	3NKb5MVBU71xMwxPZEmWN6GpKcRPP2K4k8UJWRQXNLVoj1yhaqUR	1529	950	181	6301	8930	jwt2t6uLjbq36eucaGqtHggFWgsA2G3ASH2KoNzHQaQ6wBS62HH	6507	9196	9196	1617594480000	canonical
12618	3NLMHzMdeAAYPQEAj6dPnqRKqYTRWkGATSwX9krmY11FCNXvPmy7	12617	3NKxZs5RoS5jkFsrS4p1gLMYz5tBMoQToonn7W2WViTyhbuHrDU9	1627	1385	181	6301	8935	jwGZ8GVXTVTsH55HDjyw8DUVXDL4hdHa8asGFVYfg4Vo74Cfpam	6510	9200	9200	1617595200000	canonical
12622	3NL8RBwzikFtfzXJh5Syek9YvfqeiKZjgijqakc6w3j4bzhVyUVE	12621	3NKh2mvpyh4ZyMDagVhc1ax5kV2FdYChaQbqsyFBAMDVkXN19QnF	1587	1111	181	6301	8939	jxnnqPkNmywum5MUwkwcCfh6hvdi8ygHwDkcihc3q98KiV1GZM2	6514	9208	9208	1617596640000	canonical
12631	3NL33z214cMAkgrPxyL5gRTvzZ4stWhm6E2CkEhwX7e2scJQMdDV	12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	58	915	182	6301	8948	jwFjw9g3nGTEEsLCsy6eJogz8ynhAbNwW3VWx11nt1HjFYJFwoj	6517	9211	9211	1617597180000	orphaned
12635	3NLPmq3CtKjgTCHZUdWJYXVghRFXrFmU1DjFamLYb5GDz64CJdmX	12632	3NKiLsvCc28WjzzVv3y4SYWwLRNiM1fmFKTwnxkCwJo8oBgVRkj2	1509	1320	182	6301	8951	jwGnmS2UFk4nqkbh9xsKeYhQ471eXFoXank8JFtnjqSoQAsAXES	6518	9212	9212	1617597360000	canonical
12639	3NL6oCKLZD2wT5Lr4RLod3EteB7gXZZEhk57pURpTEZDymRszx1m	12637	3NLsscjRCuSw7bWJfNfgoBoyVhXfa85q7HYdETMZr7kVpXvCFtxH	369	1186	182	6301	8954	jwsL2jsKKQ6E2Ncitg8juyiLTK4FkK1TAU999qZ34uzB1LbpP1p	6520	9218	9218	1617598440000	orphaned
12643	3NL5xcWvHkvQC49okDpfbaYsZp2JwBgR7JiGoGd5TnvA3SHnnhrJ	12638	3NLp2fGZc9KDVrUw3wJCBFcPCuNE3kFR68gXW4UACynS1ZXrX4TD	470	1063	182	6301	8958	jxFcj6jsU2KzWuvC7fhHFR98ibnaoQfSEMpncuGSLaNS4EmdFzs	6521	9219	9219	1617598620000	orphaned
12647	3NKZawCDef2DhhzqP41G7AK1u5h4VGu7ZMyXAB3XXPW9UaPzMSjU	12645	3NLqKq64sfFkSrf1cfb5Tvtu6curXrUAPa72ZsuZu4E5sMktFdXu	1407	1395	182	6301	8961	jwrQtkRWCA8vWnPzwhQV5m94Tb6PQAFqBwjvEu1Rc3YaCH4skjH	6523	9221	9221	1617598980000	orphaned
12654	3NLMgZnUg6nT5fdSYwD6BL31s9XKJKbG3pqvUZyPdKE4rfnQboHN	12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	1527	1047	182	6301	8968	jxWfwB3vGGnLfbv634r35f6Kds8FWejXVdjgSBKhVdioAtTtChg	6528	9230	9230	1617600600000	orphaned
12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	12659	3NKF1hYBKGn5xs194TqPyYuZzDvKiNuNVxVT5gnRiuFS9YqTg4pj	1406	1393	182	6301	8975	jweuDTWCVgzA7xEBuqG6BQWqfwXbKBCb8N2NM97oHHvyk3yJ4vV	6531	9233	9233	1617601140000	canonical
12664	3NL6rzv1KvGGzbKXbA265fjQiJvWHC16cAQprm56mL64pG4PLaij	12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	1422	971	182	6301	8977	jxqYiP8XrQgaq1r4uY7HHsTpvjz6WKizkxdR8iZVPxssK64N8bg	6532	9234	9234	1617601320000	orphaned
12666	3NLgFSPAcMqVsE1dc4nQCUc1SqvFmxcQtdzEzeAjf4UX2HHg5Ue3	12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	1671	1365	182	6301	8979	jwLxDXYHyTbefFKGthcGsPj9eHgnUhwKTW4XBWXARgtQTEMZXnJ	6534	9237	9237	1617601860000	orphaned
12675	3NLFDjjjLJA71uC9yLQWhbp1yaHadY2K27N6ksYf19vjE9THiFRf	12671	3NLCHSzmSoatgjE5kSdC33juXqmrYQfKnaPr6UuLBBHv7zZyTpHN	1560	1291	182	6301	8987	jxZsLgv6hnDnxwuFbSKvrong5Ka63gSt39WmLuFiNkvT4BLcSMQ	6537	9241	9241	1617602580000	orphaned
12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	12674	3NKFYYdAUrkj5o5hNNYdsxwCdXofMvSM2cy2DrFePPGLYQC3YLpo	1611	1095	182	6301	8989	jwx3ZuYDpAJrKx6boZizRHfEuL6PnVfNa99P9QwpEjW6K8TYydG	6538	9243	9243	1617602940000	canonical
12680	3NKFngGgxm6cLDdRHUL5LhRHrarRKiCtQPYvvU3zAt4E4FAb29HE	12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	1407	1395	182	6301	8992	jxDmYsbthusJdsuvJQtVvZF1bjYdkTbYSBhQ9nYkfjBYwsg4zXq	6539	9244	9244	1617603120000	orphaned
12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	12681	3NLgsc9n1b7scXwwjuoECrj6ZDYdvTQ8LEa1pjTWr8fvbzKGFtWa	1426	1238	183	6301	8994	jwMGjFUufSQysCmGgJN7tRdKCFordHBdo9wxfgjjJzSuWGbibJC	6541	9247	9247	1617603660000	canonical
15164	3NKD4R9hw42QZAjPii98AeUMYe1MyRcFLr83wtbFieLeVCSftkks	15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	1631	793	242	6301	11216	jwcq5AJ1uUbPjAcpy872bVpfD9tvdGM4pNcgktSjdisHQz7nMXH	7729	10938	10938	1617908040000	orphaned
12655	3NLC8HFXNGEsRg1HTqPqyUN4Jj89UpFU7AGogBhQaKD88smbtCz6	12653	3NKtWDgq3hTMSwHvPgQwaQyJ5di1WpsGF1S7ADoqjFbmZ2kGEuae	1402	874	182	6301	8969	jxteJ1HaGtMDpP1TCHYoqcUw3kPdk9eyQKK2vwaCsLgXXFPDDFy	6528	9230	9230	1617600600000	canonical
12657	3NKvuAMqcBuSYxNeYp5rxUErZUJmRFLr7Mo8LHqvdUyXeLZCapxu	12655	3NLC8HFXNGEsRg1HTqPqyUN4Jj89UpFU7AGogBhQaKD88smbtCz6	1510	167	182	6301	8971	jxHVDJrzfGcnzoLjwz7iHcUgMiC2sAAKT9bvLzX6MGmY8qafA4e	6529	9231	9231	1617600780000	orphaned
12659	3NKF1hYBKGn5xs194TqPyYuZzDvKiNuNVxVT5gnRiuFS9YqTg4pj	12658	3NKz9PqziwfZu4JjYdY6P3HW38y9rzQVreH8Ywh8gEGerX9Jzh4o	1508	1387	182	6301	8973	jxJYqp3KM9KakUxthrK6g4J72TpjZmNbNwUCNNeDpgo2eg6XnAC	6530	9232	9232	1617600960000	canonical
12662	3NK5rzVtyxLi4wUr4j2iAD9jq1v5VpRpiHM5GVTPc1nAK6Fidz8q	12661	3NLnrcKy5SYgDztAvJEn5mXpk5cHddGVX2eJ2GvAcaPTwgtgGLYp	1500	931	182	6301	8976	jxmx8RZ9NN2gymDMffWTPdcXN3fvyx4NnB6ZA8E7ZfWYxtPKbwx	6532	9234	9234	1617601320000	canonical
12667	3NK5qexJf77TXnixTd5dbt6Gj91dDtQHRqkGwdRmAA4jeXoKKrVR	12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	1471	1020	182	6301	8980	jwaY66d7SLVUCQrWTDpZZuLSHfeWvCJ3YgiSn8MxLeLhsANX81x	6534	9237	9237	1617601860000	canonical
12668	3NKyAoeYKWv6eXrGb4nhhu2Nx59aZNZTqdneMegpAPiz8FfkB3sR	12665	3NKK6cakpc5zSxQAENcynhqwuWERdqi8MZaQPkM2zpiLts2Vf6jf	1547	1378	182	6301	8981	jy1Djm7ZRFBpiDmiz2bGxarx8FnxrCv2FvAWT2fmd39tQNSCArv	6534	9237	9237	1617601860000	orphaned
12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	12667	3NK5qexJf77TXnixTd5dbt6Gj91dDtQHRqkGwdRmAA4jeXoKKrVR	1426	1118	182	6301	8983	jxUFarCPhRpqvSNDWpHejVd1a3TWUCwFp54spcSKdBHZJa572dL	6535	9238	9238	1617602040000	canonical
12671	3NLCHSzmSoatgjE5kSdC33juXqmrYQfKnaPr6UuLBBHv7zZyTpHN	12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	1608	923	182	6301	8984	jwbgPN8CDqrAjvHf2SrEHoeWwmgF7NdsbRzfCuwpZ4hFuTzkAB1	6536	9240	9240	1617602400000	canonical
12676	3NK6oVUaUSJ9JNT4T91dEZ7vEFgLvPDvrPenR82fLfDr3gZmUHJ9	12674	3NKFYYdAUrkj5o5hNNYdsxwCdXofMvSM2cy2DrFePPGLYQC3YLpo	633	1384	182	6301	8988	jxQRwUPkAEzEKcgsjy3wB9F7AGzzdi2hf9MHH45dFk2P1BQ2YhQ	6538	9243	9243	1617602940000	orphaned
12678	3NLb7ytJwUdeNYWBn2J4Wb7vAty7yUJzkVHg324FfdgiDWFMsyZ7	12677	3NKvHW817MbqPjfTkYxSSr1gv9FCvpNEXmtPmMUxMyWJS2J1Ygt7	1637	815	182	6301	8990	jwmY5Bvm2WsqfNd7ccPpvBVNpDdfze6M91U1vfgXn89YVoBXZDc	6539	9244	9244	1617603120000	canonical
12683	3NLfP9qdfGRF7BXRh6Tj2NmGgSymMaTy2p4dSNnFwfdFTQHQ5Ttw	12681	3NLgsc9n1b7scXwwjuoECrj6ZDYdvTQ8LEa1pjTWr8fvbzKGFtWa	632	1016	183	6301	8995	jwBMVKWnsQwgL5V2qGrukLvfB5gKtgoVhTvS7vcPRDZydwi3e2e	6541	9247	9247	1617603660000	orphaned
12685	3NLWPa32JgA3UWKbLWr343bMK5PGnumDdoZ6mxpXUEmRhTHJ2gGT	12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	1670	1156	183	6301	8997	jwDdNJqM8pZxsYy2bV88MfJyHs3ZwyDsmfXM91wFPA5vL7Lh5fs	6542	9248	9248	1617603840000	orphaned
12688	3NLWz2g8LHAn2XK1UT5ftnWZcGHzGXnCnwoufhZvWoVtmPxubJgA	12684	3NLJKiLhPgiQgUTUuMXPMmBh6abveP9rGCcp3s82rMKpJipJm2rH	1406	1393	183	6301	9000	jwiH2U8B9SK8dRygBHRj8cGCRfFPC2FiVc76S1yniB5mfg7Fcyk	6543	9249	9249	1617604020000	canonical
12687	3NLdjmkEHNo8xAZKy8S9XFguVuN5XpEnDv21gRV3X24uWVfAM3me	12684	3NLJKiLhPgiQgUTUuMXPMmBh6abveP9rGCcp3s82rMKpJipJm2rH	1647	1056	183	6301	8999	jxDj5GxUZDFErHs446YQffMzDqMH9pNG1YS3jVr2D55EerUragt	6543	9249	9249	1617604020000	orphaned
12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	12688	3NLWz2g8LHAn2XK1UT5ftnWZcGHzGXnCnwoufhZvWoVtmPxubJgA	1406	1393	183	6301	9002	jwxh21zn8feoj1dXDnPPJpKxeJT3JeMXk9hgpdKCowa8H8uLUVP	6544	9250	9250	1617604200000	canonical
12689	3NK9jDT5gwG8PeEzoNDj8mEYCcbcKkKjsFg61V1FvBxDUNcYu3Hd	12688	3NLWz2g8LHAn2XK1UT5ftnWZcGHzGXnCnwoufhZvWoVtmPxubJgA	1602	1123	183	6301	9001	jxAxh5BuiCDaWd7vYC7f7V526XWnFRec9bfE84LUzmqKGrew71m	6544	9250	9250	1617604200000	orphaned
12694	3NLSs5axTQPZKRGSSyfUoFjzyCeX4uwhRaGDeWzrdYf3z46K532Q	12693	3NLDTNUdDF95tUYHjmFkWVQD6tKHaCA3MxrFqaQyNVVA6DyaG6Q1	1447	1345	183	6301	9006	jwMtWrYfBxkPhuwShvQ569uupXNjCNECnCiyokhPVcfEVx5gonc	6546	9252	9252	1617604560000	orphaned
12697	3NLU6ZvKguTexcPfZAtL353nZJwsGYoJct9n43DYMKW7biDG8gGg	12696	3NL2JKUNmpZc2idRBqZ5mKhiS3QrkC2RsW2dhSs45dLBJ3y3fTxj	1654	1214	183	6301	9009	jwHmy7DYA1iBLRP3yNipG1JDM5tsqP8nxRcfv49v16gKohyZzPD	6548	9255	9255	1617605100000	orphaned
12699	3NLDdWus1nqi45ZVr5bkXDVmix8bLmp4vGkGQMWjGQvBZUMWumjQ	12698	3NL1TG5u3MKuia3x9XTTHbDMvSJN4cVTWtAmNvyrP4HvhLYpfeLQ	1406	1393	183	6301	9011	jwqaz7CgGgSKNXfyZ82M7BKBZiDjyA4mgM8VFoC3YAnpbNtFe5a	6549	9256	9256	1617605280000	canonical
12709	3NKQCoD7isoLYzi2YL2PvyQS4aaYm2MYctRzcizyHHFcKKcq7g4U	12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	171	1008	183	6301	9021	jxc12dt3nRJawTemVGPJxMZ6aUtESY4fUBmABnCTFejnPaHq9zJ	6554	9263	9263	1617606540000	canonical
12714	3NLLKqVt2qTA4Q1DU4WzjPMKawRUEVBxPTsnY6sRs3TJMbdAodwW	12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	311	1181	183	6301	9026	jxjFb9Um3y9Exh7eLJAWDZginD4UiqBP5rkK5GRLhE5f4dMyV1n	6556	9267	9267	1617607260000	orphaned
12728	3NK5SugZBBG3QfkstZSuooQy1oHw4v8fAA2GSY9kKxN7nMCrKgai	12727	3NKHBqD9can6Mmqa5YV9dwKfL4vpK1S6gVWjCy9yjmpAQeRKMyCo	1675	1096	183	6301	9040	jxcEh5na2smouAU8HK8YVaEVQojncMd9cgvsayfSqfpHGk8x3AY	6564	9282	9282	1617609960000	orphaned
12737	3NLUccXCGXfk7PUfGyvjKyx3m1KZysaSK5isvBKFvxrs9W3DNXfJ	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	1403	782	184	6301	9048	jxFcMmNDFgchwTzy6DrMuzfNr61PUG2vtDTsuSSo4uVDnQHLogk	6568	9286	9286	1617610680000	canonical
12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	1406	1393	184	6301	9056	jxAMJVqMpRve8agZrq6kdoSyeHToS8kiF7zqpMpv5dut4xUowSi	6571	9289	9289	1617611220000	canonical
12744	3NLpwVXpuDALu2HgBWh8trDuNvubAbFhqQMuXcw2JH7PxFFPppcM	12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	1649	1137	184	6301	9054	jwDNE4JP6E9zxNSSsb9FrYGAuJsYmeoQh5Hwv44A8Vfveb6hHe3	6571	9289	9289	1617611220000	orphaned
12753	3NLbmvAEEeZegBad1PAFy3VR5boaVmSUaLUkJUjAM31PLhXeFf27	12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	1613	1223	184	6301	9061	jwMtY7YZw1JB6ZhkDa5q7oECsHxZ1gxkpi78yAU7f3joPZ7NQw1	6574	9297	9297	1617612660000	canonical
12755	3NLcoKBSaWKEec8Y9iK5fEN39Y71YPWB28W1EK7idihN4hKNK3N6	12753	3NLbmvAEEeZegBad1PAFy3VR5boaVmSUaLUkJUjAM31PLhXeFf27	1637	816	184	6301	9063	jwEsMk5VmQqKzQgG7YHs326b15ywJzUxQ9dpJqU8xsJyuBHqMyj	6575	9299	9299	1617613020000	canonical
12758	3NLaHE7eaeGe8nry8h51KSCkoHyvp6mJqjgbac5pWrLSSfj7x4jk	12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	1647	1302	184	6301	9066	jw8cajzLXYk8weQbrzm1JQvZCVwWJ32JMPYvcTzbGaLiJifJeFC	6577	9303	9303	1617613740000	orphaned
12760	3NL6wcFzMhvC5igvJ8eZDogmeRLRufXRipHxKbSuXEeLgvSnbbtw	12757	3NKUR2bPz2PYdMLSiJ9mrvb8jj26QtirfSJRnSFGoJc1L8eD1ctE	1448	1065	184	6301	9068	jwsE2gKUS9za8jFZUAqzdbC8aw37g6oH63fEuw1rBsHu8qcXYox	6578	9305	9305	1617614100000	canonical
15171	3NL5SpMM3C8WaWmTWjnbAU4WCgeJqDKNu8hZJ3bmTEmnXDLGbAdB	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1609	1333	242	6301	11223	jwgKS2MueSMz85cTbhyZDzFoRJHpGyZTZ4ihjdk2vXkzxK9wEgv	7731	10941	10941	1617908580000	orphaned
15172	3NLW2e7eqN14uxg7KXrLtRR93uELssmUpVJABiKwqY89ZhxsAWjR	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1509	1320	242	6301	11224	jwknoESeMs3jBRQz7PhHb4jJjEDKZHgfPqWej7voV3MW4EeSuGL	7731	10941	10941	1617908580000	orphaned
12716	3NLoyVPppk2AiC1JULhrRw9Kh23AtJh9TXUNVx4ovHnn8UaiTtND	12572	3NKy1KEGQ6CeLkqV8c3xmHC3PE8kmejtqQ2AGdtpDCFB6PdN5cqP	1675	1342	180	6301	9028	jxQEabBbbNoEocc91auF5pf3mtwQUUAmVUDbABwogUfTfsJV6y9	6480	9267	9267	1617607260000	orphaned
12691	3NLJX5RAmZnM5fEqouCWTjbN4fd2npgQYJH398qg6D7VGtFxbRUj	12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	1654	1340	183	6301	9003	jwYDCSDNiSqV5tEePjWMhucGmBe5rep6Vxh5xS3TvkjTXYru2AY	6545	9251	9251	1617604380000	orphaned
12701	3NL2JHqkxogcqEMkiwM14q5LTnkpn1kQkNTBm3ZGtxzwGT34xSUY	12700	3NKLtJZVJf615xLeDA4QfnMUTbbWMeAP98SmWarEMBiqiKn4fXEb	1402	890	183	6301	9013	jwdL8c4VJy8Koqqwisk1jCo5ddmTB6LHBiQu498X7QSj6NxBBoL	6551	9259	9259	1617605820000	orphaned
12703	3NKyP9nJQAWAQnnHhAQ5AziaMq8RsaotjEPg9fQcJ4FN5WvNrpag	12702	3NL7crmLUURQCfoEkfuM9tTgJhTTsePV8Bzcq8Djq4SPbqCT6BEz	1458	1323	183	6301	9015	jwZAFutsbY2G8dHvHfF5zXnboPymbRM5hbgcmSirgZ1C1nt8Hge	6552	9260	9260	1617606000000	orphaned
12706	3NLKm9fodUpukJy2TUwDq7Waikpuj442VsJDhkyvMC6XJCqC6iKh	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1403	824	183	6301	9018	jwQSrNZnUcDy7nLdJgxFyRADz5Wnw8Fk4HPJrpgZdyujfm8wnVL	6553	9261	9261	1617606180000	orphaned
12711	3NKvTP9nUjtrUKUwQxqSJ1yc3RAGMWCZpRnWPxvtsTa42mwcaA44	12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	1617	1042	183	6301	9023	jxcaMDkCF3NJYSosY31jNUfzWXXRigBx23wQ77mHxCWePFzB2Bu	6554	9263	9263	1617606540000	orphaned
12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	12709	3NKQCoD7isoLYzi2YL2PvyQS4aaYm2MYctRzcizyHHFcKKcq7g4U	1483	1276	183	6301	9024	jwwyXowryKKx4CtmdvbQpmMyJY2pJfM7ijbECwvpa9EyXpu8A8j	6555	9264	9264	1617606720000	canonical
12718	3NKJLbxgDEP5Mqf3h6cNMCkesGtyiMZvJwN3FtX4JkNifL1PQNy8	12715	3NKUw2JUADonxPgtf41CkGmDfiGTW9TWY8S12HyihC2RjucJejdW	1600	1126	183	6301	9030	jwSCu8PD2C6tNom68bRHnD9p98JoWZ9eiCUwCAWQsTEeGKcPjqw	6557	9269	9269	1617607620000	canonical
12722	3NL3CJchsxRuQRyFh7RUi6Kx3StW2xz1U9LAwhhBNyBYXm62AWBw	12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	1507	1280	183	6301	9034	jwYrcuKVPrZaMUqBUkounuBPFpaGq8SKuTMKwEdfv4SbGo1WTWh	6561	9277	9277	1617609060000	orphaned
12726	3NK4JoRqDYTSy5otgoLxiWwqjdB6dpXTnkXpUyKMB2JqhVRk62HK	12724	3NKb5pr2oALX4mCS6pV53XDLbSoX4JrpUpnN7bGiHN5j7yCxYaue	1542	1178	183	6301	9038	jxEzwRLvgHbf2ww4ddWBdNHVJbjjGhQ18TisjLKv55dwXyS84vn	6562	9278	9278	1617609240000	canonical
12727	3NKHBqD9can6Mmqa5YV9dwKfL4vpK1S6gVWjCy9yjmpAQeRKMyCo	12726	3NK4JoRqDYTSy5otgoLxiWwqjdB6dpXTnkXpUyKMB2JqhVRk62HK	1609	1087	183	6301	9039	jwc1g6Ag1Ef8hhiNhAMfyyYJVTJ2vD9yDtL7dMTksPionhF3yY1	6563	9281	9281	1617609780000	canonical
12732	3NK9Uhg6fcPacQtcFHb7mKJi7Gk2qMHBzeSWncRyqexvyQ9mP9cp	12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	1503	1031	183	6301	9043	jwWoYkxQnE53B6q8UvdKb8goW9rFfPPNRouPmx8u3QSDEFhwLCz	6565	9283	9283	1617610140000	orphaned
12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	12735	3NKbvVL9JSG3oXz8rowv6MTDFtA33UTEGpNFyGqPdSg5uVs6tqkM	1637	816	184	6301	9047	jxpcjcCVhvkHxyQ7BkGUph2jyr4RqQdjZunZo6zuWL5Wg9vy3fe	6567	9285	9285	1617610500000	canonical
12739	3NKMBQZPE5jYziuu5yuwJ8qksy7fBa7kQQZHkVm6TpmV52jtorGS	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	448	1305	184	6301	9049	jwi6oPUarEtCHxjDh1tFBCnt6Kq7P3VirxskCMqo1BiHNRwwM5C	6568	9286	9286	1617610680000	orphaned
12743	3NLq3JVXC17Hs6JVQzHvqD3CZypNL3MAz5tDcYUpHXbTiWPgPnSW	12741	3NKfE2ukttMvvcj8YfiPuyUq5EzGLFvKQNktpebpgEA3pNa1iQbB	1611	1215	184	6301	9053	jxwYZ7LeZS2rkRgqgkKxT4rHYVm9C988fDaNea2zCFA5du5xUKp	6570	9288	9288	1617611040000	orphaned
12748	3NLtGuTPokToXeH29oaWHu2ENzkAyGGp9UPKyNiG8Y9ZmUx9VFEM	12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	1407	1395	184	6301	9058	jwoigYbMhbqqUUnbKyVuaMUJFtv6VKkzXjfMtQRWi5ZKJQhNFHj	6572	9291	9291	1617611580000	orphaned
12751	3NLfQXTAZNHyyenLuhmZo37xhDkdddXgRXJAE3d3pW1rdCiNfjhj	12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	1503	1277	184	6301	9060	jwsDNfVV3heoEwTxktjjEGhYn8ChbzoLB4ZPRyJfEBVshsdsk6U	6574	9297	9297	1617612660000	orphaned
12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	12755	3NLcoKBSaWKEec8Y9iK5fEN39Y71YPWB28W1EK7idihN4hKNK3N6	1445	1044	184	6301	9064	jxGWxjbhqmJBAkuTkSwFPFjPa92jY22G8GHGXwwwKbFV8b5QVBS	6576	9301	9301	1617613380000	canonical
12763	3NKfBrmuGxNLaFFujy148icjRbiyhFW92hGcBLDpJBbeHGhKUF8o	12762	3NL7dFCGK2bEj7CZfxdYV3e7ZgvuxZJqGwwLLLeAH5F6hjaWTXA3	1439	913	184	6301	9071	jxMYhUTRhuLumdrv82ioxEU1cGTVZBgFZh44nc8wJ2SoAm4ri5E	6581	9309	9309	1617614820000	canonical
12767	3NKY4mJnGK4KXv6s5fCweKsiJfZYNeDQ44eJJn5ZPX2czuFvcA3Q	12764	3NKMpAChr4YyzfshgxgF2Wyh7h9KLFZXxdY8XMYNTBXKTGPj4TQN	1407	1395	184	6301	9075	jwrjHYiS85rQBu5RpLNZeucwqwqeKGT6MEmaQjh5io5Gw69Qx8S	6583	9313	9313	1617615540000	canonical
12768	3NLjZGLP7VAJzu5JZZMp8SaQJZL34TFcrhb61prt6RvT3qdka7mJ	12767	3NKY4mJnGK4KXv6s5fCweKsiJfZYNeDQ44eJJn5ZPX2czuFvcA3Q	532	1303	184	6301	9076	jwJDBTx5n2pvZMaBEDL3CBxU83CGPiQhPVKMbZb5fNxdGEQbLu6	6584	9314	9314	1617615720000	orphaned
12774	3NKbMYKaHm2aEUgcbXNPo3sqnU1srb81jWxD5oE6tswXkRFeb7zQ	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	532	1303	184	6301	9081	jxaR8qsnC1iWC9Skjw9wKcP5RAagPq7VjK5otwkp5SiGRL31C9c	6586	9316	9316	1617616080000	orphaned
12776	3NK97twoskxZdiLCkq4MaSNjo3ZsvdVySC9CozmqsGXqRbU1LLuW	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	532	1303	184	6301	9081	jwTMT7wzuQyPQBd1FHh6nJr4oZcsBDkk6gratfbeC622xbJSRZi	6586	9316	9316	1617616080000	orphaned
12777	3NK7ZLvPVoMaMaV1ajFtG9a79J1tNV2XSzHNMZsFc2NWVZfKbgow	12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	1406	1393	184	6301	9083	jwLpssPD6vJQZEUWQnGJ4dzbEAvdMdDFdj9SuUpW6Zz6QGf6BKZ	6587	9317	9317	1617616260000	orphaned
12779	3NKi64p8iocdfgNPN9wsshNjWUAfYSDTX7omkTf18xG2VGkVyq3q	12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	1631	794	184	6301	9085	jwiHvQTYD1LXH7rbgMiHm4UgbqExpAjLuf4SB78vMueTQTjsbBj	6587	9317	9317	1617616260000	orphaned
12785	3NLk6HGfMH938pqJEeDRoDmTcJWhfJQUNX9yuF2x2ESDJ6t4ReYW	12783	3NLsgreAvGiGVoKDVu7o2W8zDBtoshF6L4c2xYBqoDXPLgrzxu5V	563	1113	185	6301	9090	jx7XCiW29Zu3tj6cCdSPUsfHZ79EpWNfv943Zf9uRS9D2V9Tscx	6591	9325	9325	1617617700000	orphaned
12787	3NLudJwCNb7eLHZGnMr32YZ5PZEp6izXVW2HhxyfrKJcaUP4uQJz	12786	3NKk33agmDXpxN4xgMw2qapbGo36KuKrFhn7rF8qq1Uvepmz9VwX	1596	1363	185	6301	9092	jxewKpgLiX9tZ5rY2ekPdviYSQc9Xe8bqZZAc644nbA5xB6inZc	6592	9326	9326	1617617880000	canonical
12790	3NLh73xwLdL2acAMHn3DXCKsNeXzkYxQwAiKpg1xhJ53m3UdaMZb	12788	3NKqrPnsa4oh25cwdh3zAGAyGTzYmECQm85GXuBR1YuakoCcZF8B	1422	1337	185	6301	9094	jwfMJJU8PyyGecAcgsiT2VwhU5KPdnsaiRp3mBYfQKbnsLj7iaC	6594	9328	9328	1617618240000	orphaned
15194	3NLwuWHbBZQ5VYH6fnss6LBFMZpP6LJxK4DxTVDNWLXaFQgHoWAF	15192	3NKoTn1rNjL7jUfvMiFmUxzTRnQguv2rAXixeG9tcWEjMndwBkVW	1509	1194	242	6301	11246	jxvPZkdDfExBqb1U2B8Vzka1AvXDscyWQox89Xc4KNNYeGgpDy3	7742	10956	10956	1617911280000	orphaned
12696	3NL2JKUNmpZc2idRBqZ5mKhiS3QrkC2RsW2dhSs45dLBJ3y3fTxj	12695	3NKiunS8BgXV957UFmBThiHsvD98TzdghsKVrR3nPFXq9AiXKNhj	1622	1356	183	6301	9008	jxHcEeuo9hdLgzbKxFiZQLQdmZGyEbwJ3RvfgiquN4n72wiKVzc	6547	9254	9254	1617604920000	canonical
12702	3NL7crmLUURQCfoEkfuM9tTgJhTTsePV8Bzcq8Djq4SPbqCT6BEz	12700	3NKLtJZVJf615xLeDA4QfnMUTbbWMeAP98SmWarEMBiqiKn4fXEb	1439	1033	183	6301	9014	jxfwJA1f5fs8GpYqZGRuvVabK8v3j27J7xG17hakA5uegQR29T4	6551	9259	9259	1617605820000	canonical
12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	12702	3NL7crmLUURQCfoEkfuM9tTgJhTTsePV8Bzcq8Djq4SPbqCT6BEz	1634	965	183	6301	9016	jxhD8w99zGK6tUhta9fAnQQmH5TaA8S4uVvmyFndnfGHLcAfmbo	6552	9260	9260	1617606000000	canonical
12707	3NLxayE1QSKNXv3T32jbNGUBEf4M2XNohuTDrU7tsMBXTJH4ZoBA	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1637	816	183	6301	9019	jwcmFhppN57RjnDTbdeVKCHkQW73EMgqPq5Gq27t7fCX7eg3FTn	6553	9261	9261	1617606180000	orphaned
12713	3NLLTx11568xdmy87Xb9qAbyMR6qPK8kYTzNAKgCCHRFiTL3RWRx	12709	3NKQCoD7isoLYzi2YL2PvyQS4aaYm2MYctRzcizyHHFcKKcq7g4U	1407	1395	183	6301	9025	jx4SCuvXshL3A2k8DJ9KrFkZ4SYqYYgGmyRd2baV5ygLi4qPByg	6555	9264	9264	1617606720000	orphaned
12719	3NLPEDBF1ywuU2K6Zd9TMbJbSqSo1pVtVKsQCUk6caNqT8JBfrhD	12718	3NKJLbxgDEP5Mqf3h6cNMCkesGtyiMZvJwN3FtX4JkNifL1PQNy8	1406	1393	183	6301	9031	jwqirvcwnf4RW8MkgBEZtR9PZjKxPrJ6zGXbKN1t9MJ1Vj5DhP2	6558	9271	9271	1617607980000	canonical
12720	3NKemCJ6Zg48AJAwPwXjRRQXJy7C1zXjvQ3yBFeZbPm3Fio664D6	12719	3NLPEDBF1ywuU2K6Zd9TMbJbSqSo1pVtVKsQCUk6caNqT8JBfrhD	1631	794	183	6301	9032	jwY28PyGEnd9o4KUrEtcezbPpy966NGSNxiLdL9nrNanwozpaRu	6559	9274	9274	1617608520000	canonical
12723	3NLr61qQ9Fa1vxusLFYQyDC46VMmANzead3GpRk9WjDgaYnPYC7c	12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	1508	1387	183	6301	9035	jwGfw9AQigPgws7JEXVGDD5dbv1qk32YCW45apuLtD3Pe7QBAZ1	6561	9277	9277	1617609060000	orphaned
12740	3NKyNudip3zyTjpGU8hB5FPnba1iFcJYPfkmKb3CS7vpqtvteka7	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	171	1374	184	6301	9050	jwAmQiB6RJdhpajqWD8hkD4WVMtGqwfDpgk6WUAUAU8SBfmjazm	6568	9286	9286	1617610680000	orphaned
12741	3NKfE2ukttMvvcj8YfiPuyUq5EzGLFvKQNktpebpgEA3pNa1iQbB	12737	3NLUccXCGXfk7PUfGyvjKyx3m1KZysaSK5isvBKFvxrs9W3DNXfJ	1577	1327	184	6301	9051	jxVcdaLeUzYnchZEBYUKTcmmcMnkNJ6hAqWvfrKkHgnVp2EtB5j	6569	9287	9287	1617610860000	canonical
12752	3NLCsUMfkh2GmmSP35Muj941m1tftcgP9SaSQ6Ad2iWCq48p1sL9	12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	1503	1277	184	6301	9060	jwVjuAC2DNYAoiiLFproSWb15LxmHJXAxUv4Cpt97ixpC3H9YNc	6574	9297	9297	1617612660000	orphaned
12754	3NKFiF8hLaTrkkMPHmniJ59E4wFLx2thx373iz9BjqrjsqjQPSNe	12753	3NLbmvAEEeZegBad1PAFy3VR5boaVmSUaLUkJUjAM31PLhXeFf27	1407	1395	184	6301	9062	jwhdQAVbcvPHwYU3s9USQGuhwnXB8H2LkXGSggVFcUmrmFa8aeP	6575	9299	9299	1617613020000	orphaned
12757	3NKUR2bPz2PYdMLSiJ9mrvb8jj26QtirfSJRnSFGoJc1L8eD1ctE	12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	1588	1392	184	6301	9065	jxeT9seNNJWQCK76RwbdDbGm5UhzSdkDeQSDjKHaoyyvHdgfrUP	6577	9303	9303	1617613740000	canonical
12762	3NL7dFCGK2bEj7CZfxdYV3e7ZgvuxZJqGwwLLLeAH5F6hjaWTXA3	12761	3NLeMVRU8UmWEouJ6jQkwgctLHmmHxurx36LRrFupNkX98Xk5TtQ	1403	786	184	6301	9070	jwWjGgg9cRpyz8Abk727Ya4RsMg9rXgW5LzhiEcqWZiBWPNAGEq	6580	9308	9308	1617614640000	canonical
12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	12769	3NKd1d1PchFf1JBzibDtycyyu78GTy3CuFHiy8mWKXUtZ1p4msCf	1442	288	184	6301	9077	jwt9e7wxAHTwVQMhiLRr9zLe4m2MnxaxmSJgxPWAWjrVcnXTt8U	6585	9315	9315	1617615900000	canonical
12773	3NKEPD4RtrbpAuvNwn1p2qdnqYJCaTHGQ2nECJ4jZpU8o1muW8Fe	12769	3NKd1d1PchFf1JBzibDtycyyu78GTy3CuFHiy8mWKXUtZ1p4msCf	1560	1045	184	6301	9080	jxMcfXRJ9UoLVjNLe7ccMEFjDZLriUbU1igDy29uQxMauLcq5mt	6585	9316	9316	1617616080000	orphaned
12775	3NLSYYwnLmb2chrwDgcz1XzaSJDgxNiQW92w1vcePXgAUNc1bJAf	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	1560	1045	184	6301	9082	jxcxDJBY9ZPPKREtKnPDzEuFp47753rfuzFsj7Jz6zoGCkYg6fU	6586	9316	9316	1617616080000	orphaned
12780	3NLuXLE8GDDfiZaUQzkz8QLFauJgTZGPuBJk6NsNbg3A6PdSEKiu	12778	3NK5BWz53wfNwrYBPnRr2qpdanLTP7PaW5Vw98ghCvYLkXHnB3tD	1407	1395	184	6301	9086	jx11eHuiuzXvrsTKZ1S5a77wd3FX9tNbBrv3PgHzVgtiV7bxArR	6588	9318	9318	1617616440000	canonical
12782	3NK3yc76cGb84GFRgCgCxyLupQNnSb28BJx2QQPWjo399tFCwNWo	12780	3NLuXLE8GDDfiZaUQzkz8QLFauJgTZGPuBJk6NsNbg3A6PdSEKiu	1672	1159	184	6301	9087	jxQHnfsqPY3nGAVhvfvUUHwChnZQgxVKXhDufofbHnLJYQrnibU	6589	9321	9321	1617616980000	canonical
12781	3NLKDzsiUci4w7dRF2HjfGnCMF3RuLGF6y7X9iXh3C8sXUcrVvmq	12780	3NLuXLE8GDDfiZaUQzkz8QLFauJgTZGPuBJk6NsNbg3A6PdSEKiu	1672	1159	184	6301	9087	jwEYeAG49xTmKnX83UTCJGk4EtortczJPpx6VvrRfzpvJQExtvG	6589	9321	9321	1617616980000	orphaned
12784	3NKGsZsmRQAWM9ZeP4itYmEeHqr6SbPaiX1v6Eawu5Hyfg3HAtTA	12782	3NK3yc76cGb84GFRgCgCxyLupQNnSb28BJx2QQPWjo399tFCwNWo	1405	889	185	6301	9089	jwwNiBRw4eiAkNqjXLkJD2FkTbX24EqfG9rXGdLKJ1KQJHrTAck	6590	9323	9323	1617617340000	orphaned
12786	3NKk33agmDXpxN4xgMw2qapbGo36KuKrFhn7rF8qq1Uvepmz9VwX	12783	3NLsgreAvGiGVoKDVu7o2W8zDBtoshF6L4c2xYBqoDXPLgrzxu5V	1650	1129	185	6301	9091	jwDL5KC6vWxoWEejRUNi9uWLpKjEmWQfuCsRacQCqzZ9hR1bMhP	6591	9325	9325	1617617700000	canonical
12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	12788	3NKqrPnsa4oh25cwdh3zAGAyGTzYmECQm85GXuBR1YuakoCcZF8B	1422	1337	185	6301	9094	jy3GijGGNTG1JsHjNMkE3fFiRpYVENFcZM7FFSHyvMS9EpAJ6f7	6594	9328	9328	1617618240000	canonical
12792	3NL6MgLYEkorhzMSnYWehazyEguhWzHVa8FUrmqvhfwboteKAcUf	12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	311	1307	185	6301	9095	jx55sBSFRde42p1HXtwQJTLa9wDoDniAjwbo9mA8F9RfXD4P8f4	6595	9331	9331	1617618780000	orphaned
12794	3NKAE6UQgVJ3HRGCddJjLFWyK8G5i15cqhy7nPMVrb6HEx2AFJsn	12791	3NLuGu6HzMZH9PCvF5UgCe7bJhGbZVqNJBp1cS6zeZjpzKM6NRZj	80	1147	185	6301	9096	jxyFtBYMAXU9Vux9sWEPD4mA5ExWGgAamgQFUX2UNKDWtfJwLU9	6596	9332	9332	1617618960000	canonical
12796	3NLov9PoSkmQgqiDYBZR9CKJ59o6WjHDfUtMZiV1EDQRWqj75MSR	12794	3NKAE6UQgVJ3HRGCddJjLFWyK8G5i15cqhy7nPMVrb6HEx2AFJsn	1553	776	185	6301	9098	jwUnm3jJ9mwoyK6BV3coWRMxKoKEF8P1RWVxhZQQ67UDD151jaU	6597	9333	9333	1617619140000	orphaned
12799	3NL2AKBC5skTSQ3C48VKf1Qmvvtpeg4sVoYKtm5zAotZBhKVTmGt	12798	3NKqarC5eTGn4KmWSXTiXm4fMUUVkUkzHwukeSA5HrCvsy8YFzJo	1601	1262	185	6301	9101	jxgNo4p272yvdisTXAZx5WBMynPic2hA4qwveaLKfoqU2Yf3w2T	6600	9336	9336	1617619680000	canonical
12801	3NKjUjmMBGwA8L2TD2mRGW9e1rHrxjtHauP4YazAdtm2sXxb477h	12799	3NL2AKBC5skTSQ3C48VKf1Qmvvtpeg4sVoYKtm5zAotZBhKVTmGt	1588	1392	185	6301	9103	jxjUmXoo8jrZzFQHx6TV7DZxxyTLV7jiK8VVUUpCfyY29z9xd3k	6601	9337	9337	1617619860000	canonical
12805	3NLopu7F3Wet6xFY63XSXb1pxVJ8qM4cn4oj9M29gCfAdJt9mbEo	12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	1407	1395	185	6301	9106	jwGzGoSUYZwRTd9e715yzqrwva7vfBfpusFCJwRdDZQ5iUZJRKx	6603	9339	9339	1617620220000	orphaned
15199	3NLhepFjYFY8FP4TME5yPMkZ4WSLgyeY1Cy623YvjCYXgBaejTDc	15198	3NLxbRSZQdvBDukWQzGnGVqnt4a2SnKorjz2zo69WdC4Fa3423Sc	1407	1395	242	6301	11251	jxiWZVqm26Uy1ThRCvnv3TbWena63exG6f874jBVSg6Rs6ayagm	7745	10959	10959	1617911820000	orphaned
12693	3NLDTNUdDF95tUYHjmFkWVQD6tKHaCA3MxrFqaQyNVVA6DyaG6Q1	12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	1407	1395	183	6301	9005	jxz51k78uW19o5ppjqHp8CwHM7aZtYPpS2PvsKdeWbmHn4ujs73	6545	9251	9251	1617604380000	canonical
12695	3NKiunS8BgXV957UFmBThiHsvD98TzdghsKVrR3nPFXq9AiXKNhj	12693	3NLDTNUdDF95tUYHjmFkWVQD6tKHaCA3MxrFqaQyNVVA6DyaG6Q1	1619	1275	183	6301	9007	jwxwvchJqqgni5mMLTJF3XxgPkiQYxJzgcYKEkju7p5Z87HMyRc	6546	9252	9252	1617604560000	canonical
12698	3NL1TG5u3MKuia3x9XTTHbDMvSJN4cVTWtAmNvyrP4HvhLYpfeLQ	12696	3NL2JKUNmpZc2idRBqZ5mKhiS3QrkC2RsW2dhSs45dLBJ3y3fTxj	1406	1393	183	6301	9010	jxWFWhAAn7f3Rn77f9zQ8f5ySCm5ifMmYFsobvGL51PpiBLFNUu	6548	9255	9255	1617605100000	canonical
12700	3NKLtJZVJf615xLeDA4QfnMUTbbWMeAP98SmWarEMBiqiKn4fXEb	12699	3NLDdWus1nqi45ZVr5bkXDVmix8bLmp4vGkGQMWjGQvBZUMWumjQ	1455	1332	183	6301	9012	jwjPswZ1FRBthRMw2bby3gfmSLY3QULtMxsG5UHmu4S9aZbvVGs	6550	9257	9257	1617605460000	canonical
12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1402	868	183	6301	9017	jxw213g2NkET16az8q8iGBnNmGuENyXYbGc4LYz9UnXgnT29xnW	6553	9261	9261	1617606180000	canonical
12710	3NKQB4MNzAYaooz4p2wSSXy8ggo1yJcWV1cqo6rZuujNtH9kUzQp	12705	3NLhW36YwKBayrwtrVFUfjGKUGP8Yx6vd3kqueiimtuZp6ha3GwX	1601	1142	183	6301	9022	jxigSvzUVS9s4gkAParhqg5Q29ucr2ZxfNiwYj9CueSNGz5aN43	6554	9263	9263	1617606540000	orphaned
12715	3NKUw2JUADonxPgtf41CkGmDfiGTW9TWY8S12HyihC2RjucJejdW	12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	1675	1342	183	6301	9027	jwPzpEGFRGtW6Lwu35L1Zr9XbVpjggc7AFWtPGqPjsQDdGYy6W3	6556	9267	9267	1617607260000	canonical
12717	3NLSuwTVXfvEcp2B6U58tKMo5PtMguQaD5h7Z1Dk4a1z8qx4RiJ8	12712	3NKtvkRi5uK79Vt8SkPsZYbmvZC2LT6KK5cgHDcCD1Qg2aKBQUZn	1631	794	183	6301	9029	jw7RC8Ds3C85FTVdLCEojVvVe8JT5aEb6TNsQr4iweCxeDWNHZw	6556	9267	9267	1617607260000	orphaned
12724	3NKb5pr2oALX4mCS6pV53XDLbSoX4JrpUpnN7bGiHN5j7yCxYaue	12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	1406	1393	183	6301	9036	jxjS2fwFs8ZbZX5KPffE3HcLawWSQGzEMvZBJgsdGo3UMH4JeTS	6561	9277	9277	1617609060000	canonical
12731	3NKoxqKimx684QLUpPJdr1tU22BL9uvw5WHbkf4ySUu95H1nckBJ	12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	1503	1031	183	6301	9043	jw8PgLdwq3pG39W3JBprDdv2pZHN1zNe8gsjnf5ZfwcBocpjCjL	6565	9283	9283	1617610140000	canonical
12733	3NKRZLMDiHJThFTCtj55snZuEj8CVUBvoSwE7qhHkWzTcdQN8RUW	12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	1650	1375	183	6301	9044	jxLWwVAaW4A2M2e48BoCfGKAbqYeB55pkJbadCMQeZTkUbRMt45	6565	9283	9283	1617610140000	orphaned
12735	3NKbvVL9JSG3oXz8rowv6MTDFtA33UTEGpNFyGqPdSg5uVs6tqkM	12731	3NKoxqKimx684QLUpPJdr1tU22BL9uvw5WHbkf4ySUu95H1nckBJ	1406	1393	183	6301	9046	jwKCoN4qCvTGduQdfFKRc3Mkuhzfm54VgDE1arEdZcMY5L8SnBT	6566	9284	9284	1617610320000	canonical
12738	3NKJ7UxmYYdGCoLos1YhhDDdWkh8naqSdV2RgQx8RCGLzD9tj7Jb	12736	3NKPeuYewabgp6YTCoHsWxFdrqaBmjqnFYku3y8SehNBcfnDWGXW	448	1305	184	6301	9049	jwuBmcVJhLPXVH4AXmxwtkwAbjbLvamWsn5nu2MyLr9biKFSBEz	6568	9286	9286	1617610680000	orphaned
12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	12741	3NKfE2ukttMvvcj8YfiPuyUq5EzGLFvKQNktpebpgEA3pNa1iQbB	1608	1289	184	6301	9052	jxWQfGTXfS6E8Vg43xwTbribo8XthUNTNRTh2DjtYgCgXoKjtpd	6570	9288	9288	1617611040000	canonical
12745	3NKjY36zWgafE4cwCoKNiF4yjWhJNBwZXcwZFo48eTwqi2Xus2B2	12742	3NKzqy6PsgPbwbCyeVb4hSjzhnKqpkoLHDtSUypmGUhGjSUPBpXW	1403	824	184	6301	9055	jxZ7FuakYmWzsQXFtWQapuGhMJkQCdmBZ4WuUh1oqqhjsk75kF2	6571	9289	9289	1617611220000	orphaned
12749	3NL4ZWnwJ8zw6B7f8ZKYX4PAwNkq27zCn7oQ7oUHyn3VDPYZWLiJ	12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	1609	1207	184	6301	9057	jwVGpGevWs5MkdR1aeHwfZzLjzcEv2pXeaBrcV7ZPXeKXVuugA4	6572	9291	9291	1617611580000	canonical
12747	3NLXqzJZMG9aW4NYk2gMAX8TihV3AJmnorHyyRPGaKkzfiKgHTAT	12746	3NKPvn187pkX2CbrY1iCtmyG4wpUGd3xaUqZvv7ZqHL3A1ZCAsQ9	1609	1207	184	6301	9057	jwTgqNfjKBR4dUraBbWuR919w1iW8H69xHTYAY8HDJSbQztdNG3	6572	9291	9291	1617611580000	orphaned
12750	3NKP6ApPZC2uUpa9AZy37w7JJ6csKbszZ2kCcZCt3wL1gqfc71wq	12749	3NL4ZWnwJ8zw6B7f8ZKYX4PAwNkq27zCn7oQ7oUHyn3VDPYZWLiJ	1553	776	184	6301	9059	jweA2CcFGJzcxWaz9rwcW6X6amg4RTHfxbwzPDRyPKUcwg8URtV	6573	9294	9294	1617612120000	canonical
12759	3NLazsJQ5caoteqQ2xhB4cuN8KTs13d8SEeWJoz8tphBdb6UmBgc	12756	3NKab2QzVDz2DAYK5cNDP7iXhLp7uieh4ctccUotFLTc9KUjYcuF	1481	790	184	6301	9067	jwdw3P5XFtPPd8SiExye8hY4jXHMccq2HJ34SD8VoX2CxktWVWh	6577	9303	9303	1617613740000	orphaned
12761	3NLeMVRU8UmWEouJ6jQkwgctLHmmHxurx36LRrFupNkX98Xk5TtQ	12760	3NL6wcFzMhvC5igvJ8eZDogmeRLRufXRipHxKbSuXEeLgvSnbbtw	1590	1054	184	6301	9069	jxTJbDMrgsQZ1sumDGX5JgZiQeCum8Yhin1QVmhmwaGLxXQZeK2	6579	9307	9307	1617614460000	canonical
12764	3NKMpAChr4YyzfshgxgF2Wyh7h9KLFZXxdY8XMYNTBXKTGPj4TQN	12763	3NKfBrmuGxNLaFFujy148icjRbiyhFW92hGcBLDpJBbeHGhKUF8o	1451	926	184	6301	9072	jxSxf6PdreNGbybkftLzGZvZ7UurYXwjrD69gjnUpBjtdyWbcCR	6582	9312	9312	1617615360000	canonical
12829	3NLcwL3DZBrKkUwcdXnwBp4Tka3LEAcDwAiQ51yGqVPpZqGgKBJf	12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	1624	1208	185	6301	9130	jx1EXdJE3rpXaNkY9W7TU5pANzL6XKNFWweqVKJ2n9TUj78zFdA	6595	9358	9358	1617623640000	orphaned
12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	12809	3NKapJvQzNdKWdxFqn9acPkgSrqn5RF4AcHhaNBY4CvpXsV4ZPQS	1403	824	185	6301	9112	jwrcEmuxt5KMpVHT4eGvUSvmApbxj4ycPQer1t8kzp5og8nZoqQ	6606	9342	9342	1617620760000	canonical
12816	3NLWdCVUtAKEYf9cqecJigYeX1Mfr7omW31UhdSzTJi7dxm4aBYA	12815	3NKdVJm1PKNabnqDcqEevJkKohJVS2xWS1FpiAikCwSAZYDZ7S5T	1406	1393	185	6301	9117	jwjhSB1HJoSQabE5tqAn9C6sqracnKGNzdLQ7fg9FBuWKHfBZt1	6609	9348	9348	1617621840000	canonical
12824	3NLuoJawByuwTcm61fGBwNWTzdbNfMvqSTPckbasPZpcAfMbDwbw	12823	3NKYUJtvvfaoT8jjDy7gzvbFfdfrihnemtTuKVWUegqdGYgz4m27	1637	816	185	6301	9125	jxQdGAGWC7EPMCxpV3jRoGER9sgmATg6PVrmaeGYdrMEKRPEGB5	6615	9355	9355	1617623100000	canonical
12827	3NLhaBZdXDcb7HGDUL6vBDHL2iabBTDSYPxZgkboMSLB9ViAPdGg	12825	3NKqZz5fyMCwL4FhVCJJGBcRxXiJzyP5we8ZaPrgJ3wShTZru1Yc	1673	1368	185	6301	9128	jxE9fvbi8g1QvLN2fx2CNQR9jjh6Ls8fBqLycqe6d9TMZwb2A3f	6617	9357	9357	1617623460000	orphaned
12831	3NKfn5ZxFE672Sx9mw5o9XHvnahPkuhjn9TfRKy3nkzeSfzS5x18	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	1467	1376	185	6301	9132	jwpEGtdo1c4prYE2k3kc3m9BnVVjLb9nf5GhucXaPPQE6gj8e8A	6619	9359	9359	1617623820000	orphaned
12842	3NKcNazHPJVDhssXjdYnEiqDmJ9jWdQi2EciNuGBFTELre8fmPhw	12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	1406	1393	186	6301	9141	jwv1evdryYjrsxqoUbrwH6s4WkyrmCEfZpAdNUTtVVoNyocZ456	6623	9363	9363	1617624540000	canonical
12851	3NLgDJSgGDiJh6Fh7VANCs86nSnR5GUnWsdTgvZrUrBwjdAawCnP	12850	3NKEEc8EE5R8TGJaFDnXmLH65CoKdKH7n2EkPWgonfTwev8LYcTb	1672	1285	186	6301	9150	jxyL5HLsUPHtSUyArqPFUarQufiLjHySwBkRAozi81WyZi8PdVy	6627	9367	9367	1617625260000	canonical
15207	3NLZc4C4rNiUhVuyCaRdct39ctAWqYTEFzyydk9KfK1hEXcdvU2v	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	641	1336	242	6301	11258	jwYH8GmCupEVcSQERWoEVrPidPscjBzZSjWa3d3U9rq4L2Hm6Th	7747	10961	10961	1617912180000	orphaned
12817	3NK9suBainM83RWgpe4va3PNvXwc4hxcAka5E1UqmfrrVsbpHcmJ	12729	3NKxodu4r5RtssNAF16SxiuVUV9y7aZ11oky2c6Vnf9XxZKSp286	1675	1096	181	6301	9118	jwztKN7A7EZegDdJP4Ek6Bw687FGpZgjHBdtyvg9D3TqV5hzJVj	6482	9349	9349	1617622020000	orphaned
12769	3NKd1d1PchFf1JBzibDtycyyu78GTy3CuFHiy8mWKXUtZ1p4msCf	12767	3NKY4mJnGK4KXv6s5fCweKsiJfZYNeDQ44eJJn5ZPX2czuFvcA3Q	532	1303	184	6301	9076	jwUGg7USsbvn68Bvj4fHCbTEzDSSkSBxYRGy3AvwFqt4pw56Fgc	6584	9314	9314	1617615720000	canonical
12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	1467	1130	184	6301	9078	jwoWrJtQDYbKS9gArbhpMxEibEujTwexpA6pC8T59eP5sDgK6GZ	6586	9316	9316	1617616080000	canonical
12778	3NK5BWz53wfNwrYBPnRr2qpdanLTP7PaW5Vw98ghCvYLkXHnB3tD	12771	3NKAXAVspJo9NuzDoS1sdECJNgJgsLFHwrtHVq4uMpPt78WmFxU5	1407	1395	184	6301	9084	jwwNiHoe935fmYpDtgcp28jX6g9Yi7Eb99qkdFfCATFuZUtGWEb	6587	9317	9317	1617616260000	canonical
12783	3NLsgreAvGiGVoKDVu7o2W8zDBtoshF6L4c2xYBqoDXPLgrzxu5V	12782	3NK3yc76cGb84GFRgCgCxyLupQNnSb28BJx2QQPWjo399tFCwNWo	1589	1286	185	6301	9088	jwni51xoKtBKzfgx3ZVrvtiGbSNBoWxMWGSgesPkvynLNCDP6wq	6590	9323	9323	1617617340000	canonical
12788	3NKqrPnsa4oh25cwdh3zAGAyGTzYmECQm85GXuBR1YuakoCcZF8B	12787	3NLudJwCNb7eLHZGnMr32YZ5PZEp6izXVW2HhxyfrKJcaUP4uQJz	1407	1395	185	6301	9093	jxUtLRmokt9fuPmyzsEajq62WXMhwPeCtGunw7m26uqNe2pCGc6	6593	9327	9327	1617618060000	canonical
12791	3NLuGu6HzMZH9PCvF5UgCe7bJhGbZVqNJBp1cS6zeZjpzKM6NRZj	12789	3NLjTrkHs755xdVoRQfpdsCLej2QZMXZKYz2qPJE6i4jgU39s4Qg	311	1307	185	6301	9095	jx4rRDP9vfgKmsMUg8nwzvGZoh5H68Dh2RQ5dQpKKNkpj7Rp3C3	6595	9331	9331	1617618780000	canonical
12793	3NLPw6jVXTjdxZmz8V3QaddoEVAx9mSV3nZ58GyMATdijPL6xQxw	12791	3NLuGu6HzMZH9PCvF5UgCe7bJhGbZVqNJBp1cS6zeZjpzKM6NRZj	80	1147	185	6301	9096	jxgMsucfqBkpRqpTFojk3yYhhhAz3M5QctFBLfL5fAKKN4eFH6u	6596	9332	9332	1617618960000	orphaned
12797	3NKpebfjFSaFB8zcZRLrPMERaKq9b7ovXpRCvstHiG2fF58bogSi	12795	3NKz97txVcYDpDBCyjsm44b1bfpbPConcaTYT32TbdWujmsdmCNa	1600	1372	185	6301	9099	jxVv3cWagHnEhj2TcshjcmAjj3WhkUjhCfnZXNK9LpYdWGeyyiT	6598	9334	9334	1617619320000	canonical
12798	3NKqarC5eTGn4KmWSXTiXm4fMUUVkUkzHwukeSA5HrCvsy8YFzJo	12797	3NKpebfjFSaFB8zcZRLrPMERaKq9b7ovXpRCvstHiG2fF58bogSi	1637	816	185	6301	9100	jwDB7LJwnnT7z6G8ggPxwPmNrjLpgjPDTxapX4h8r2R4jnSNHDo	6599	9335	9335	1617619500000	canonical
12800	3NLJ6gA3T3nxWtL3nMLx8tbasZk8kj7vj1zcScpujJTQdmbr5L6i	12798	3NKqarC5eTGn4KmWSXTiXm4fMUUVkUkzHwukeSA5HrCvsy8YFzJo	1407	1395	185	6301	9102	jxobjaFKCAdwHAdRQi86vYrq63MMtjFU5uEtnMCkjRW4pWjA6Mm	6600	9336	9336	1617619680000	orphaned
12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	12801	3NKjUjmMBGwA8L2TD2mRGW9e1rHrxjtHauP4YazAdtm2sXxb477h	1596	1363	185	6301	9104	jxKCaSem5EJPfzHJRfjT8Vkf3zZ6SAgUN5VCPeJm1s98bPkVzG2	6602	9338	9338	1617620040000	canonical
12807	3NLCrFDVi6ca1ANsBRKzsZ7QPZ9nfDPUz8uZcHMChcxU6xTEptYJ	12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	1657	1218	185	6301	9108	jwcw96jCfntdthEz2t3i1PjEF7o67aFoSQSQVtERK9Z5oggeAQ4	6604	9340	9340	1617620400000	orphaned
12809	3NKapJvQzNdKWdxFqn9acPkgSrqn5RF4AcHhaNBY4CvpXsV4ZPQS	12808	3NLcytqAatgzBePHPeJw4bwbDEoBdJQQmVH7hoYRB1YhVTtQuhQR	1513	1379	185	6301	9110	jxMBQXMYtgBtBm9zZirpqUR58KJXZ2MkRR2KAGuCm8jnVRK9hG1	6605	9341	9341	1617620580000	canonical
12812	3NKJ3brEiuPCsDNREqwZHSetvVCWy5Puj74RGmo92x6gCVG2oFzV	12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	1458	1323	185	6301	9113	jwpbMWSFWMffjLL3ydXCrh4TSmFGYgHoY4hYas14GgUz7FGFkgz	6607	9345	9345	1617621300000	orphaned
12819	3NKPdEy4Cpu3wPL3JkQJuhWNQfAAM2KMVTtHqrSkVCJLxkTvdMxf	12818	3NLyYSa9abQLuHzTdzoDxekkzu2LkQ5uf1hLsjM5CLWhxkNMfvzj	1507	1280	185	6301	9120	jxtiHrk9L7H1Fsyk8cLJyQUvznvzcfsu2dxUApE3HtQ8CCpZVMp	6611	9350	9350	1617622200000	canonical
12822	3NKRk7XX4FKsyEwjANRvEV4v4Z7b9dd9fkgF194o1zJSrWAUAAFS	12821	3NKitapkAfbWTCVgSitYbxE46WcMvcLCEmVSdsedMY5FJgBEvf9T	1622	169	185	6301	9123	jxWCH4CwidJjRSS9Q4NnR4sb32CWjVTVVgf4XigZtK1aDxCSMv5	6614	9354	9354	1617622920000	orphaned
12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	1589	1160	185	6301	9133	jx73KzUrqoVaKZURspSM97hCWxDvHTVDKA2bwV5isDSi4Xo2sFW	6619	9359	9359	1617623820000	canonical
12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	12839	3NL93RKw8Ec7w71p2osf1pBR2hpNLAXbPgK9WtFmbUn4NTmGt3Y5	1451	1292	186	6301	9139	jxuPwHyrrP7vVzhcyF3RyH9cg1pBqW9rJSePKa4szfPqE18aTBy	6622	9362	9362	1617624360000	canonical
12843	3NLE6vi8Suv3yicHagfegk57haKBi9Sy6FK7ZUj6JtpM23oMM9r9	12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	1403	786	186	6301	9142	jx4gFwzup3fdk3Mg4ivdjDj2JV9RYnN7wor77E2k92vdV1P9Y1d	6623	9363	9363	1617624540000	orphaned
12847	3NLSsuhRtW3i4jQyfkyWsh4BUkgXKhPofUuMP3DvjkdJsJnw8CaZ	12846	3NKxucCvLLKBkijVCPboWESrRoyuhptezt3Eeyq9fLvi4nv4TF3n	58	1155	186	6301	9146	jxhpUoJcQNNNTxkRXDpYwWyAkb1MC9chMsvaY2f2qnLMPCk9Dy9	6625	9365	9365	1617624900000	canonical
12849	3NLgu6T8zbaFBAiok5TCa6L9jNXA5Gj69KTm8EPCBMD6hq2U16sL	12847	3NLSsuhRtW3i4jQyfkyWsh4BUkgXKhPofUuMP3DvjkdJsJnw8CaZ	1483	205	186	6301	9148	jxRqTQR71cJB2G9MuCbFh5LyhGFfZiLvzkn2QNQcPLJPmhynEwr	6626	9366	9366	1617625080000	orphaned
12852	3NKMEDSMhexNKftXc3GaPdkkZ1BPEeZ8DwWpnE2BXshk4BHP6t71	12850	3NKEEc8EE5R8TGJaFDnXmLH65CoKdKH7n2EkPWgonfTwev8LYcTb	1589	1160	186	6301	9151	jxmwiPyhGX5GoeQZQb7JHb3iGWmhPY6qksqDBC7Fnw7zZnMr1Wj	6627	9367	9367	1617625260000	orphaned
12854	3NLQ16hRFEnY3xq2rqTbLurtoB1eKQ2aWyR7spG5nrTPLG7jQKk5	12851	3NLgDJSgGDiJh6Fh7VANCs86nSnR5GUnWsdTgvZrUrBwjdAawCnP	1637	816	186	6301	9153	jwW69Pf9k1mcEsFoyapKn98fDf3vLj8FQyyLtNKk3Yzr38zGeoQ	6628	9368	9368	1617625440000	orphaned
12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	12855	3NLMaEP7qTKfGTfCYWEHQKs86ZXMgMPemXPH3MFLLeSfD54tJXiE	1403	824	186	6301	9156	jy2Y9JDNiKpWVSBtMZTLz3jDQpa1u27oTYtvsN8Vy353CvuRiSG	6630	9371	9371	1617625980000	canonical
12859	3NL69wSaCCErKJWQyoAhXDDoo4Uop5B36vrKzPpqpBy3WYh18qWV	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	1646	451	186	6301	9158	jwkbvsoUawu8dvRJfvpwxwf89k3ptppLdfHrV8Siumxkk4F5iCH	6631	9372	9372	1617626160000	orphaned
12866	3NKiGmKPGhBxdYTedBnJk1tpqEoSH7Anf46wduVyvDhrncyFkcZZ	12865	3NKx3TNCMfeLN9K3hYcvSjA6xABnynLYcQ7SniYJgk8nbfoetiKQ	1553	776	186	6301	9165	jxic3sEHdpT67vB27ztbeEmJ2mRi7bCaUYbJxp65sFihf7cYjMY	6634	9381	9381	1617627780000	canonical
12867	3NKWJXeVHPdEr928DRrYyyk1USmDkyaT6jDPmGrjyz3g5LhY6SVn	12866	3NKiGmKPGhBxdYTedBnJk1tpqEoSH7Anf46wduVyvDhrncyFkcZZ	1467	1130	186	6301	9166	jwALn2QWCwRa6BiZxMVFgF5jg3yzur8rZ4aY4vSqV7ryw5CjXYE	6635	9385	9385	1617628500000	canonical
12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	12869	3NLTL9TxEQKo4gapqzy1QQsuQjnKV96aNETTsoofYqsJSaXDTJ2U	1407	1395	186	6301	9169	jx1L6pFRQvTjEqq5sdgEV5EmgBVGS8zypdpt4hhnFrJE5EwC6qH	6637	9390	9390	1617629400000	canonical
15204	3NK715qcJes7KG9n9C42GQhjeptA7339dMWLfY66HfaneZEsaweN	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	733	640	242	6301	11256	jxETPRLp7YnzveRtwWzJRkzh4Wb9NJrTEnbA9TmPW75reVU1oEf	7747	10961	10961	1617912180000	orphaned
15688	3NKJZwPq3m1Ld2bV4UP86H7xEjis6RbV2gPqN29C82mhK1Y91NMM	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1445	1290	252	6301	11701	jwLzrrYSG7NmbtE37gdFkdKYmF4BKcWwvj4s2BReULwwyQoDPWM	7980	11296	11296	1617972480000	orphaned
15685	3NLyJy9x9SajyUcDNC5eaKxto4j1nhoUyC5mtD7kjRJhWs42KTdC	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1547	1012	252	6301	11702	jwm794mwQmihwPq5HyWwwGDY7mTksAJ7o9SgU6xmtq7X1em24aJ	7980	11296	11296	1617972480000	orphaned
12880	3NLkJYvm5kzgHM4oE7S2zLZiAdmWRbQRnWuV4c7BFPzrboHxJ7i5	12848	3NKPF33CfH3URkMP9PeuYmrN3cLR14MsBgGphJCLjjUL3s9WCGan	58	1281	185	6301	9179	jx5YU4tmNGrBrLHNTvhf29v64xr1Z1UtvfJjBa3zKD1fUmSpSAV	6586	9395	9395	1617630300000	orphaned
12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	1503	911	185	6301	9105	jxUCPMWJJq1q8q8oaNqiLNh52fdsSaACSX3Z7SrvbkYwP5GEifv	6603	9339	9339	1617620220000	canonical
12813	3NKtp3KMkqSq5ZXjqZk6wNF6Y3Lwjc9sSJ5d4anT8wqMqz78BwMw	12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	1501	1360	185	6301	9114	jwfbkhtG3ctQrwmZEvuKjQfMnnRWL7UEbjjzrgESxVBDaXoQ4DG	6607	9345	9345	1617621300000	canonical
12815	3NKdVJm1PKNabnqDcqEevJkKohJVS2xWS1FpiAikCwSAZYDZ7S5T	12813	3NKtp3KMkqSq5ZXjqZk6wNF6Y3Lwjc9sSJ5d4anT8wqMqz78BwMw	1451	1292	185	6301	9116	jwDtFak6DLidwY2dsUjoqAB8FBgCeKkM9Qph6CbREuBh3EdouJP	6608	9347	9347	1617621660000	canonical
12818	3NLyYSa9abQLuHzTdzoDxekkzu2LkQ5uf1hLsjM5CLWhxkNMfvzj	12816	3NLWdCVUtAKEYf9cqecJigYeX1Mfr7omW31UhdSzTJi7dxm4aBYA	1675	1096	185	6301	9119	jxJ3eBftBt2JvAAQgeEQHLyVxTNwqrqxaQfEPESb7gh9qocN1Dd	6610	9349	9349	1617622020000	canonical
12820	3NKwQBMh9EXSKg4NCaXNFKxFXBPQYhE7fiUsVye6iqBwHdfWm9Yj	12819	3NKPdEy4Cpu3wPL3JkQJuhWNQfAAM2KMVTtHqrSkVCJLxkTvdMxf	1648	918	185	6301	9121	jxFKJBLYAf9vcGPettv2Dvtm3BFDkm2cfmgcTBdXbp4tLmcLJn4	6612	9351	9351	1617622380000	canonical
12823	3NKYUJtvvfaoT8jjDy7gzvbFfdfrihnemtTuKVWUegqdGYgz4m27	12821	3NKitapkAfbWTCVgSitYbxE46WcMvcLCEmVSdsedMY5FJgBEvf9T	1560	331	185	6301	9124	jxzSGf7ktjVE54u25tC768XDomwgXnVHEFF2QsUUeg62J5Y8392	6614	9354	9354	1617622920000	canonical
12825	3NKqZz5fyMCwL4FhVCJJGBcRxXiJzyP5we8ZaPrgJ3wShTZru1Yc	12824	3NLuoJawByuwTcm61fGBwNWTzdbNfMvqSTPckbasPZpcAfMbDwbw	1546	1339	185	6301	9126	jwvqwsbukGWt7LLmRgHQ5MQV1FfCtGSj8tmT42wQNrAx5AJbBb7	6616	9356	9356	1617623280000	canonical
12836	3NLU8ujHn3Tu9mmEz416fThjQmATrqZaePFZgzazofJgKqZwmGVx	12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	1471	1140	186	6301	9137	jwSBSRivyczVyWE92LRbHkXgj7zVSqvnrZ4MszkHawZm67My9D9	6620	9360	9360	1617624000000	orphaned
12838	3NKNGvstYHMgMBAHubmfbiq4pTe9LbZdeYuCStcMahzaXLMXtgrr	12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	1471	1140	186	6301	9137	jx4uChEm2kzVHfSqdGLVctTV34rxS3CcoedJqYhFWW3wghbXpjQ	6620	9360	9360	1617624000000	orphaned
12841	3NLnp7QJhXNp761MeByrCk3USxxLDSinHWc7oUjqfpKDupWYm8Tb	12839	3NL93RKw8Ec7w71p2osf1pBR2hpNLAXbPgK9WtFmbUn4NTmGt3Y5	171	1374	186	6301	9140	jwRoimPa5TWJbRGXHchyWmhETSDx3f1WzPTYpaHoafn1JvZ6kbr	6622	9362	9362	1617624360000	orphaned
12844	3NL3S2DTcPbDNAMZpipDgJktSoTJGjenfXmYPGX7PuqBiTbYfu7o	12840	3NLaNPpB9krrhxwnZSeDnEKFp6NLnyCnqiJWP1tY6Txaqj8uPAJU	1407	1395	186	6301	9143	jwox9Fhe9hifwBfvAfzAupuLVEsGSYjUNJXnmuojFNX2VJ4Agrm	6623	9363	9363	1617624540000	orphaned
12845	3NLCknUgzXoQFP9CtUbk7BUJYHGVikzMFt1JyxtyqdmGYXC294J3	12842	3NKcNazHPJVDhssXjdYnEiqDmJ9jWdQi2EciNuGBFTELre8fmPhw	1657	1098	186	6301	9144	jwtqcPu9K9QQp2PoAhXKGFmUHvLSSuB7BHAL24P1U8iZ2Kcjoz2	6624	9364	9364	1617624720000	orphaned
12862	3NLcXdTJHBboVhKzeBMhCzxCJc1ddvQX8UYvQZiGZiMB6NoRZi6N	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	1553	776	186	6301	9161	jxki947MJ5djmxdpkR7aHczuEygkpXbWm6nDnTQTbYnSpNpKM8T	6631	9372	9372	1617626160000	orphaned
12868	3NLUnWdMUt6DzYL1F9rs75qaBxFHZXe9dTaXuMPHYZQfi84o6Pac	12866	3NKiGmKPGhBxdYTedBnJk1tpqEoSH7Anf46wduVyvDhrncyFkcZZ	633	1384	186	6301	9167	jwd5U4qJD9uw1dud3RmFE9H7ojEF1rGnnhjAtd3FU1thJ67WzrW	6635	9385	9385	1617628500000	orphaned
12871	3NKYTBwPoi7yrYDcgfNqWrukKcAJeFRyBea5LSDMd8CwVa2i8MrL	12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	1406	1393	186	6301	9170	jwQMzF6KdLYoa79vgWjgwew2CbcZYhJMGzrWyWzW1durYN7Kd62	6638	9391	9391	1617629580000	orphaned
12876	3NLiHnSapJaZtQL8KwxpQyHyqe3zSyfmNiL79dwLapMMjZiMF86R	12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	1596	1117	186	6301	9175	jwr4p6sJFz9zkfh1fmTkNXhugd51MHRmc2Wf2kHYtaYsUubwcX1	6639	9393	9393	1617629940000	orphaned
12877	3NLEc3ywQa8fAXXyC6rBS71tgrTw88P9DVrAwTbMvbrYf1eFGKag	12875	3NKfMqmwe8Qyo93U9cD525oxiszSX2tKeF2Qno3TV9Ew71j71oPB	152	1330	186	6301	9176	jxdPAYMHhgZxUBFYQtKzZ5hNh7vLNcTv35Gwzoo1bdyz77pxMDc	6640	9394	9394	1617630120000	canonical
12878	3NLg8udHQGQbRQL6FhX2dRkELegpBZFXNAykyfMyiFDvyyVgGA89	12875	3NKfMqmwe8Qyo93U9cD525oxiszSX2tKeF2Qno3TV9Ew71j71oPB	1594	960	186	6301	9177	jwjdHHVpQHkFAGM8KXwLnw2xvQGWUW2GSRuVtKVNuRzqLMSvzYs	6640	9394	9394	1617630120000	orphaned
12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	1671	1239	186	6301	9181	jxzatUsuYXqsFu67huUAFAcTENpMJ21rPBb1b8hnk1p9sJFZbwn	6642	9396	9396	1617630480000	canonical
12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	1622	1356	186	6301	9185	jxKdLGRzgHaT3fGxPGsKtPoZpssrWbCq4SKmojjMwLoaA2NRHMp	6643	9397	9397	1617630660000	canonical
12888	3NKWnuzRY3XfLaNS3bEWGy6AdM696wy5dmVEsqzGxUJj3oRSYfZi	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	563	1359	187	6301	9187	jxbhdhDgJeoXXJfQbTUkxmANcrrjLHT4TDxXLAsoBZzDeHybPDK	6644	9398	9398	1617630840000	canonical
12890	3NKSZpP8j1uWQ1sHmkNdi1UkTeDbMm8NQwkJJp8xtLKY1D17BKk1	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	563	1359	187	6301	9187	jxbhdhDgJeoXXJfQbTUkxmANcrrjLHT4TDxXLAsoBZzDeHybPDK	6644	9398	9398	1617630840000	orphaned
12891	3NKJbeRdngViVPqFHt68zedab3xrW2pZJs8eadfvF6w6dYxqADaC	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	162	162	187	6301	9186	jxfPRvqYppCL3tyN7kPDvmJN63Vqqb1op8rED4bLVWpJNb6jxth	6644	9398	9398	1617630840000	orphaned
12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	12888	3NKWnuzRY3XfLaNS3bEWGy6AdM696wy5dmVEsqzGxUJj3oRSYfZi	1509	1194	187	6301	9189	jxhUy7DjP2UgCMXS1TmkUNvT4sovFtdVKDjXxi7xePwjEg34Lu5	6645	9399	9399	1617631020000	canonical
12900	3NLpGpaEgfSQJzLcBDewKCifaNqkn9ks3Kf6nt7TEAhppXfWXaG7	12898	3NKtrJhxZmah7sn2mPZPLP6B2iJXeZ8UQj7oK4WnXYtG2ygqH7XJ	1406	1393	187	6301	9196	jxDWMts6RWKaBnBaVxyS3f7HpcktF3De11V191vrM7xCs72hEE8	6649	9403	9403	1617631740000	orphaned
12903	3NK7bb9N72hGUP6jhMoHrSp5oTczcXqKJw5UZkPSzmWep8325H6z	12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	1509	1074	187	6301	9199	jxWUnBdGEE2Bd5v82BbKAdyeGWKqdyoJnv7B6zwG1AVwgeQYVf5	6650	9405	9405	1617632100000	canonical
15221	3NK5G6YL61tZA1XmhxZbAA933mxvQvnQo2stLRGNvJobYy5jVyWu	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1631	794	243	6301	11270	jwS6WuED4eNfoTeLPRWGUf26VBGyEGzB6cRa5xn9d6MhkRjkMVq	7754	10971	10971	1617913980000	orphaned
12804	3NLtMMbHrG6TLiDv1PT7nRiAY6fpPfaeE6YbVJ5C9i7xkD1RPkdn	12802	3NKtvJQ8V3CoW6karvb4bbXeY7NN3STFQYs2GbL4kMCbnUEzFBqm	1503	911	185	6301	9105	jwsAETfDaKqN4DaxkQ6NTTr9bwadGoWmvDHonrddvnAbrrbvehA	6603	9339	9339	1617620220000	orphaned
12808	3NLcytqAatgzBePHPeJw4bwbDEoBdJQQmVH7hoYRB1YhVTtQuhQR	12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	1553	776	185	6301	9109	jwY8RTt6qEK9u8yqkJ3boBjNb73mLJPmnVpXrYoxiQokRQVxYq6	6604	9340	9340	1617620400000	canonical
12810	3NKGtrEo8xKpk9Qvbmije1S9GjVcHMbJ4iAFk5cMEi9L6CcqysfX	12809	3NKapJvQzNdKWdxFqn9acPkgSrqn5RF4AcHhaNBY4CvpXsV4ZPQS	1406	1393	185	6301	9111	jxMFH7WYDqYhTQwEdCfuJqLPUPdVESELZbruqJEeRRGX6h8MXWD	6606	9342	9342	1617620760000	orphaned
12814	3NKVnDVifL4WqjcPj5QiTmD2LdChzNXZxAVZeH5P4pSMJ4eEd8Wx	12811	3NL2vjNz5EhiKbHRfv4VVcfYynA8pFSWzv3qCjWHvc8KjGZNApwx	149	1157	185	6301	9115	jwNBCZH64Fni1WyW9JyGYZ4CcUrfC6mKGYeAkKCrRUAu3abjx4Z	6607	9345	9345	1617621300000	orphaned
12821	3NKitapkAfbWTCVgSitYbxE46WcMvcLCEmVSdsedMY5FJgBEvf9T	12820	3NKwQBMh9EXSKg4NCaXNFKxFXBPQYhE7fiUsVye6iqBwHdfWm9Yj	1407	1395	185	6301	9122	jwVPPFSxirCDBVUoJos6Vwi2h8TPatt8TKyMU5tNTtQj3vojp77	6613	9353	9353	1617622740000	canonical
12826	3NKRBzqgnEo4BcBXnA6SVK1SRWNYDchbeiaJwu8FupK1B2o4bZSi	12825	3NKqZz5fyMCwL4FhVCJJGBcRxXiJzyP5we8ZaPrgJ3wShTZru1Yc	1403	824	185	6301	9127	jwvSXTa8QD34177eQumcjUnhkLWuHmwPAe1AQxMAsubSqWPsZXy	6617	9357	9357	1617623460000	canonical
12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	12826	3NKRBzqgnEo4BcBXnA6SVK1SRWNYDchbeiaJwu8FupK1B2o4bZSi	1406	1393	185	6301	9129	jwaW78PEAy7WBToACKNotVJJ6VX2cwvGm7QXTMwkQyPHyxbPQoP	6618	9358	9358	1617623640000	canonical
12830	3NKdqdpNdX44AjAQn2P98mxLspN1w6vq2iVRpiBZF5GguVXm2TkA	12826	3NKRBzqgnEo4BcBXnA6SVK1SRWNYDchbeiaJwu8FupK1B2o4bZSi	1624	1208	185	6301	9131	jxH3fA6TriYM3kpnHiefHMCyBNvgWbiJHBU1sQD1LRxctZ6n4ej	6618	9358	9358	1617623640000	orphaned
12839	3NL93RKw8Ec7w71p2osf1pBR2hpNLAXbPgK9WtFmbUn4NTmGt3Y5	12837	3NLAhmQdt71XXxFWVoDLuGx3bDeSe3yTSayuTP1M3KayGujNnX7i	1405	867	186	6301	9138	jxk8FYXDi6YfZS6QvgDQfqAxAsDg5SETof9p11XftXyivkvDcmM	6621	9361	9361	1617624180000	canonical
12846	3NKxucCvLLKBkijVCPboWESrRoyuhptezt3Eeyq9fLvi4nv4TF3n	12842	3NKcNazHPJVDhssXjdYnEiqDmJ9jWdQi2EciNuGBFTELre8fmPhw	1403	824	186	6301	9145	jxiA9nSxuJJQgK4YnRv3QiwHwUwJHMFCNAtLVkUWhE1KvMinTES	6624	9364	9364	1617624720000	canonical
12850	3NKEEc8EE5R8TGJaFDnXmLH65CoKdKH7n2EkPWgonfTwev8LYcTb	12847	3NLSsuhRtW3i4jQyfkyWsh4BUkgXKhPofUuMP3DvjkdJsJnw8CaZ	1481	790	186	6301	9149	jwzNUgS1hSWji6YsLZsXvt5KfjtuscccD7MeKPhMP46BtTMzSXw	6626	9366	9366	1617625080000	canonical
12855	3NLMaEP7qTKfGTfCYWEHQKs86ZXMgMPemXPH3MFLLeSfD54tJXiE	12853	3NLHUfuQzD8r8s3EJnLCMfA5KF9U9psNkP7AdXNd6jcVXGNYpWPE	1637	816	186	6301	9154	jxCwzK1gg8JUCTGZgoh6vgn8SDHr7xKVZczWByDmWHtkatob62W	6629	9369	9369	1617625620000	canonical
12860	3NL2FAVcDmqFTuB4txAuF5TbGR6nEjXWGbYcH84ng81bBhPwfybz	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	470	943	186	6301	9159	jxjQX1GcQkHNGePhE6nyprmhQF9ULUE8XEhGMgLk7kvfUDYEu4R	6631	9372	9372	1617626160000	canonical
12863	3NK7QW9r3LvjHb3eDP3dA8xEYZeXsULtqnCCttyY18C5bUUrUP1Y	12862	3NLcXdTJHBboVhKzeBMhCzxCJc1ddvQX8UYvQZiGZiMB6NoRZi6N	1553	776	186	6301	9162	jx8wa8tKDsvcuAZc33RGSfArTjGMQ3kjyEoiZT9md4Yx7PA6QSN	6632	9375	9375	1617626700000	orphaned
12864	3NKUYWJcvkuPwSQLyydPStFDTkGLoziCUa3i44ECL47TVf1MAhCz	12861	3NL6MMkKPRP82ZwcBNE1XUc7sN4S51YoALrFwwm4TUUtM53uERQZ	1447	1345	186	6301	9163	jxH5L3vVyWmWRpvtYUoiVozg5PYVHypmb2Eo3dDtchJNrWE4mUB	6633	9378	9378	1617627240000	orphaned
12869	3NLTL9TxEQKo4gapqzy1QQsuQjnKV96aNETTsoofYqsJSaXDTJ2U	12867	3NKWJXeVHPdEr928DRrYyyk1USmDkyaT6jDPmGrjyz3g5LhY6SVn	684	1226	186	6301	9168	jxD7SqzPxbJqegrmmSKtZ4JEa6KT4bUUXpsYFaFjDFp6r2JMkqu	6636	9389	9389	1617629220000	canonical
12874	3NKRUM8mTMobcsUWYATdQXgy7FxfB2qTqHHKZxZvjQt3ivyX1gZw	12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	1402	874	186	6301	9173	jwpeZXvpqPA1xP7FnWtgtWtiDEd8jQt8UrPHpk6kfvU3HVKmHMC	6639	9393	9393	1617629940000	orphaned
12883	3NL1D9jfyqRMgJpgYEi5tVyN9exd579Juc1jBd3swp2PE3s4qZ1o	12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	1590	1300	186	6301	9182	jwg6E5fSzwuoEtXPpKJsCPRxSkMJYavcmLCXS1S9W6g2MBtyS24	6642	9396	9396	1617630480000	orphaned
12885	3NK9549QRTLQX4o71FzFFBT9n2a91B1TqaDAJzbHg5w5ZvdNM8mj	12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	1406	1393	186	6301	9184	jxQt5JckRSZ38kxPTTnMYA79ebbYS36ggo4QDUU8QJisbu8Y5cn	6643	9397	9397	1617630660000	orphaned
12887	3NK9Pt5gdWZZfbMBcLSJGMb9HtUtVfmbqjYoJ5F9gasja2dxiDN5	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	162	162	187	6301	9186	jxfPRvqYppCL3tyN7kPDvmJN63Vqqb1op8rED4bLVWpJNb6jxth	6644	9398	9398	1617630840000	orphaned
12898	3NKtrJhxZmah7sn2mPZPLP6B2iJXeZ8UQj7oK4WnXYtG2ygqH7XJ	12897	3NKvnbPtHFB2XPrXssUPmgThqtmBfvPsRVB1ZU23vuwQUrNXSPQ9	1672	919	187	6301	9194	jxoWaWeJa2EZDnPJVqtTPioJU7xLK5BYJLZYpi8KZvUk1cgzpoV	6648	9402	9402	1617631560000	canonical
12913	3NLg6DyA9YskYcAQtvryxHjUAS9WVWjgRyukve1JJRCLWLFxdrAL	12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	1553	776	187	6301	9209	jwFRZJFGBnu8tWiP7qwhLnDJJuVvchiYgb4B6yRs3KC9oQnDoQd	6655	9414	9414	1617633720000	orphaned
12915	3NKsAQiQv4etYVZsukUePjqrYmmVDeMvRNBwnSFhkXQLnaiWhBog	12912	3NKcBf4cqUnbKmpQoKkAZfaDecvgEHMxcA6BALqq1SzgYsp9Smab	1560	1291	187	6301	9211	jxcmpHgzBduMBjTjjbpXwaZR2jvZasQjdHumQ2evFimRc9Vtsh7	6656	9415	9415	1617633900000	canonical
12921	3NLFDqRYurAE5u9cbc5oSBbeC5thGP9nEpJZFyQc9hWQ3yYGnLSX	12919	3NLBXwM7drXF4GpViQJspSbzqnoPuoMqD3sKE3hicEx7HoAffe2m	1407	1395	187	6301	9217	jwGPCx1J3tn8qtiGH6AkRhWFTqKuM5CM8sCZj29KUGcKXNsNX3w	6659	9419	9419	1617634620000	orphaned
12923	3NLjkkd6uwBpwB4vCqCf7daEt2XEXpo5g2CR5CRvA93gmKso2Y62	12922	3NL5VzpReF6mnSVTJoCJURjAfqHkM2LN2dCP63o12vvQJYdFi5TB	1406	1393	187	6301	9219	jxoZ9PMxDvaz56a2UY7e2oD85sU2kNieCWLYR1FZQDW5nMk84im	6661	9421	9421	1617634980000	canonical
12926	3NK63grYAof2QwaSv96BT2idZ8dRsZQKXx6r8zZ2oU74C7o5XEn6	12923	3NLjkkd6uwBpwB4vCqCf7daEt2XEXpo5g2CR5CRvA93gmKso2Y62	641	1336	187	6301	9222	jwNPnXH1qN785WMCLQKqUZZCcHoB247XRWaU68L5WYRgmoh5jNY	6662	9423	9423	1617635340000	orphaned
12928	3NLharLk4pjDGCLCjmVt8sr2EBuMvaXNvZ1bFPFcFWyLkKNLmWy2	12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	58	1281	187	6301	9224	jwQUBgpmcx2nYnscHQfTpC8XKtVEqtBgvXWV4SC2e7hf9v5GBxW	6664	9425	9425	1617635700000	canonical
12932	3NLbiT82NQYKZFawdAptQzGJ3sqQwACAHcvQorfDEkZMkK3pmUjn	12928	3NLharLk4pjDGCLCjmVt8sr2EBuMvaXNvZ1bFPFcFWyLkKNLmWy2	1608	1043	187	6301	9228	jxbrD9KJMmYcA7sc6RwTEZxakQF2tRqwfr7TMmTytNB7q5sGQKE	6665	9426	9426	1617635880000	orphaned
12940	3NLqyV9XmsRv82bLkMCr8TqBLQqaWSDxPrH9sdPUWyw35qQ9eizF	12938	3NKcuiGxTyLfMNhTpJa3rGeqZngKW4CKTnzshkvgLGr6kC1ufx5b	1651	1301	187	6301	9235	jw8Kou9KwY4tGzX4zqTVEGuxB5nAvmVgttBtMe9o2qpYeT1F5Fe	6669	9433	9433	1617637140000	canonical
15261	3NLwdxbCH5EgEdmjB28txQE5G4LyCywks8saSSqzcXDbVfjfKSud	15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	1407	1395	244	6301	11307	jws3zR9BXzcgvejo6WihnN57o4yUNhxumR2KAi7cpQ3h471eHjB	7774	11000	11000	1617919200000	orphaned
12856	3NLNyqAPwz3bUWKFXbsQzxTsutYDuAmRaTdxCzh5Afyv6GTexejn	12855	3NLMaEP7qTKfGTfCYWEHQKs86ZXMgMPemXPH3MFLLeSfD54tJXiE	1406	1393	186	6301	9155	jxud8fkHz2Y3SYtDJTZCU3gPbhX6MpDu4wTHcAfQ54sjvUC3C26	6630	9371	9371	1617625980000	orphaned
12858	3NLFodCz1FwYv5d2kMFYuLRRwo97cWcbhLPvwHfhJ6Xd8URcCmy7	12857	3NLTWuaDPfudc7tj3V5VHB6QdboPu7E5S97KoSLtuDiEHfej265z	684	1352	186	6301	9157	jwPHfd9KZUuh6BaHzfjjoqMsjZStX7oNqBFBRS4rCXNW8BhMTuh	6631	9372	9372	1617626160000	orphaned
12861	3NL6MMkKPRP82ZwcBNE1XUc7sN4S51YoALrFwwm4TUUtM53uERQZ	12860	3NL2FAVcDmqFTuB4txAuF5TbGR6nEjXWGbYcH84ng81bBhPwfybz	1596	1237	186	6301	9160	jxK3JcNcDyUx5yYRQ9VKGKEbPcRs3YYALM2kZEhWac9TtgyN3Br	6632	9375	9375	1617626700000	canonical
12865	3NKx3TNCMfeLN9K3hYcvSjA6xABnynLYcQ7SniYJgk8nbfoetiKQ	12861	3NL6MMkKPRP82ZwcBNE1XUc7sN4S51YoALrFwwm4TUUtM53uERQZ	1585	1120	186	6301	9164	jxwD8huFD69RdFkfemKL4GGrNCwXHcyvK3S7uecYyo3K4JK7hJa	6633	9378	9378	1617627240000	canonical
12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	1646	1228	186	6301	9171	jwGmx1M2Dfi3zUHsaU2s3YoeVj7189YUv8N8LorebbjPWrEXxX6	6638	9391	9391	1617629580000	canonical
12875	3NKfMqmwe8Qyo93U9cD525oxiszSX2tKeF2Qno3TV9Ew71j71oPB	12872	3NKZLUwAm2Wb3cXF2Nk694ebjuqkvnVkyoDmNRhopcsZ3u1r7pGC	632	1016	186	6301	9174	jwW3sdkQiU3PHXiooSXQo5pPM11GGPmPxdahdroj4dwUTngKihP	6639	9393	9393	1617629940000	canonical
12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	12877	3NLEc3ywQa8fAXXyC6rBS71tgrTw88P9DVrAwTbMvbrYf1eFGKag	58	1281	186	6301	9178	jwKssBW9tsyEV6XVndy93A324GxmAGPDaQJ5jeGonovVUbdauNi	6641	9395	9395	1617630300000	canonical
12881	3NKwcmoQzbmh98ApAkuTaUgv1uHWoEH8Q1MBG6oyfLbJAbtpNVHf	12879	3NKCHLgrj9cuhjuVcXWQ2eiHR7qt6KFb1wConED6pqzhxrXNiQxB	1402	852	186	6301	9180	jwSBZPpmvmQGUt6rFzpHKape57kU2MWpd4jGMQnwwHcNCA6Jd8Q	6642	9396	9396	1617630480000	orphaned
12897	3NKvnbPtHFB2XPrXssUPmgThqtmBfvPsRVB1ZU23vuwQUrNXSPQ9	12896	3NLRdvNWeveqHhzbBjMwCm4B4QMuzYdLGfcpqHUiuPfLoy9327wb	1666	669	187	6301	9193	jw6wDfPJctkB7TsJ1L4tGxU1gDdaa3XXr75c113auxTntSZrRxS	6647	9401	9401	1617631380000	canonical
12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	12898	3NKtrJhxZmah7sn2mPZPLP6B2iJXeZ8UQj7oK4WnXYtG2ygqH7XJ	1460	523	187	6301	9197	jxNHh1nEkFxwtoT9sDBSSYeyYJJMz5NNvCEBD3Zd94Qd6mHHFtT	6649	9403	9403	1617631740000	canonical
12904	3NKdW3mDUf3HAnzkoZ3ttdpHbGTAQ5xQJNvm6MAiNMRyCCuJgLtG	12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	1673	1002	187	6301	9200	jx22xii3heqsXgq8xsLuGBNLf52zChhNnzg3dvKaRY17sx9V9xt	6650	9405	9405	1617632100000	orphaned
12905	3NLaZg3oCShonsaCxqSVqHU7tbRuV8JEHXq294vVh49d2coj9dbF	12903	3NK7bb9N72hGUP6jhMoHrSp5oTczcXqKJw5UZkPSzmWep8325H6z	1668	1244	187	6301	9201	jwRWWFPH3cZiFKeCdgEDZ7gQofsP6kYdAqcScg1QktSyTJXsTR2	6651	9406	9406	1617632280000	canonical
12907	3NLWRhZt3C63oN5LhWYPEcGp27E5CbMF4HTw5TVr3Zj6WBDdi9un	12905	3NLaZg3oCShonsaCxqSVqHU7tbRuV8JEHXq294vVh49d2coj9dbF	1555	1347	187	6301	9203	jwycRdijhhbWfMDZvZUrxLqkWS7ncHXnwJbAV9MaA4PZE2URtYc	6652	9408	9408	1617632640000	orphaned
12908	3NLGfrsq96zeAQGKz5YbMgFqv5788jSHDVGb9ruXDur5m2vQPeFf	12906	3NLLxyzjdLNLfFBvp5LaWXwd5d3PZo43WBedgPS9Jk9UVuhtHZxD	1656	977	187	6301	9204	jxCrsexjvxAyt58y5BmNVKNDtCqS6g5eeM8x7e7GD4Dqgewuzfj	6653	9409	9409	1617632820000	canonical
12909	3NLuBtESa8Ycj1B8VoJWwKaN12N3K7U99peF5ijVaz7x67qdMWNC	12906	3NLLxyzjdLNLfFBvp5LaWXwd5d3PZo43WBedgPS9Jk9UVuhtHZxD	1617	1288	187	6301	9205	jxswVJtRt7PV8d2kSLzANTLSgFpLYzD3sS9iefYhBySVBdcrgTm	6653	9409	9409	1617632820000	orphaned
12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	12908	3NLGfrsq96zeAQGKz5YbMgFqv5788jSHDVGb9ruXDur5m2vQPeFf	1458	1323	187	6301	9206	jxb83xeF7kj2frrzaBizS6A2cWDsyosaXvatGLF5btBV15G1WN9	6654	9410	9410	1617633000000	canonical
12912	3NKcBf4cqUnbKmpQoKkAZfaDecvgEHMxcA6BALqq1SzgYsp9Smab	12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	1407	1395	187	6301	9208	jxzshuZHZunQ2vs3Rw9N9zqm1wnCR61d8CtRRbwgMJiE7kWLq1E	6655	9414	9414	1617633720000	canonical
12911	3NLxhh1N6dFg8kzpr3XMx4HG22EL755JfTYuFZmoWpx7hiUZ4YUM	12910	3NLVaJMjxFEPRcrbAFnJzJoYZ2h7KYbtW1PCwJCwZnGfNL8RANCP	1546	973	187	6301	9207	jxPAghzELos3XiApPK8e2kjEn26QBjcrtaU16vwptBtYUQ1hkzw	6655	9414	9414	1617633720000	orphaned
12918	3NLSCn3HcevBsAq3vCrNt2ryfVDkG1NHYutw857X53NvvyyARUjH	12915	3NKsAQiQv4etYVZsukUePjqrYmmVDeMvRNBwnSFhkXQLnaiWhBog	1405	873	187	6301	9214	jxMqJDhjkAGLs4HaEBcBGbsffafD5dV5p3VupiUytBCrrvDLy4p	6657	9417	9417	1617634260000	orphaned
12920	3NKU63PFJ8t7AZeibTq4PgMPMHQp3DvaLqaCohXjdfeDCz3eAoGH	12919	3NLBXwM7drXF4GpViQJspSbzqnoPuoMqD3sKE3hicEx7HoAffe2m	1406	1393	187	6301	9216	jwUowNMS1nFuh1ZKFJr1vG1oP8k2oTKzsRn5suxUqC6YXF3tYA1	6659	9419	9419	1617634620000	canonical
12922	3NL5VzpReF6mnSVTJoCJURjAfqHkM2LN2dCP63o12vvQJYdFi5TB	12920	3NKU63PFJ8t7AZeibTq4PgMPMHQp3DvaLqaCohXjdfeDCz3eAoGH	1406	1393	187	6301	9218	jwfz7BKRWJ9YMkDG18GAvnbDUvaieMVd3tuqAvWDvLuz7YfcnfV	6660	9420	9420	1617634800000	canonical
12924	3NLpEcdkdNhh1hqfWSAGU1GbQa3Mb9tgygSyuGCmemFREpouQa5o	12922	3NL5VzpReF6mnSVTJoCJURjAfqHkM2LN2dCP63o12vvQJYdFi5TB	1637	816	187	6301	9220	jwXZ3Akhm7ELDqNqGQhzeW734qbRvYnzzdgJTTejwdJ41vw9Z6F	6661	9421	9421	1617634980000	orphaned
12925	3NL1hhThYtt5nN6hio1DDBBU7a4qWUw2GArh8VAKaVMFUshAQqjw	12923	3NLjkkd6uwBpwB4vCqCf7daEt2XEXpo5g2CR5CRvA93gmKso2Y62	1613	1349	187	6301	9221	jxnE6PZCPFxQfZTRRVCZPt7XL2zCu8pkSAqkCaT8QmSX3YP8yDB	6662	9423	9423	1617635340000	canonical
12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	12925	3NL1hhThYtt5nN6hio1DDBBU7a4qWUw2GArh8VAKaVMFUshAQqjw	1402	870	187	6301	9223	jwN4iWQ6FcobaZuYZsNsZWKuaeHZBwSy7oGNA7JgNYHbJL9ThSn	6663	9424	9424	1617635520000	canonical
12929	3NLhQ1n3th6wkQ9LBg7X3NrVBdzVQ8tuShwU5RMU2WUoUX6CEokF	12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	1508	1021	187	6301	9225	jwdQhFt27LnBzc5ApMCX7WrQjmeCDfwA6s9H32mNh51BCfxLC8N	6664	9425	9425	1617635700000	orphaned
12931	3NLPVdwYuqKMhTXrdFCe3trgPD9dCmTsHVbscPtHGrAqNVzaJbZ3	12927	3NKPdSATGaXyqMJwUgoe5VQGPswu1J8ZYRbNdnkvFHwQnVvW2Uru	1631	794	187	6301	9227	jxQySiSmWH1LuKGcyLpJpumyYU3q4JPWVSxxQPMZwmrNvCUDjZx	6664	9425	9425	1617635700000	orphaned
12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	12933	3NLY1j7DtAczCbEAKL4bWf2UAXykMZkhKZ2wCWrNC7oFZ6hnsthb	1588	1392	187	6301	9230	jwRUvjFEkGFRheP69MXJB8SATPKkrx8prp9t54WXfYF1rYk8wGi	6666	9427	9427	1617636060000	canonical
12935	3NLmw8qWwkoqANYe5sT5BNSogG8NceCpxvo7fpsswJ4BmYE82on3	12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	1403	824	187	6301	9231	jxpa6ooDKyVZQTdjocvgCrmWFyHb9vvqe9Lf34jfpMDbhScMisE	6667	9431	9431	1617636780000	orphaned
12937	3NKRBk3a7nBq1Sg3rLaCHgBt8MsTyFcfVU4gJ2bgRdJjm6JvGR1f	12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	1631	793	187	6301	9233	jxR5vLv5u7HTh9r3NLR4b9yTAn3jqeVayvfDDXRBZuxFyf93L1U	6667	9431	9431	1617636780000	orphaned
15464	3NKjo8Hp2mSTjC2wNMvDMpVMeyLTENhfhbM1r64aY17mKgZc7r7Z	15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	1403	824	244	6301	11498	jxR8nVnV7ckixkmz4mUR7Fiz4qQKLd4jHFXQhBWWqyvNcq4iAJK	7774	11136	11136	1617943680000	orphaned
12930	3NLBxxMYKUv8vNhwxMUDNhxk2GnK4C3huMuqGQz9xyeXsStbS5pT	12880	3NLkJYvm5kzgHM4oE7S2zLZiAdmWRbQRnWuV4c7BFPzrboHxJ7i5	58	1281	186	6301	9226	jxTYDo2VMhzr19EgBumXA1swFeVtEfdTcm9ENV4UdFWJ36NGieL	6587	9425	9425	1617635700000	orphaned
12916	3NLuNaE7WCxxjP5AtdazNL3Kng1E2b7wN8a1Q3ZnecUWCh9SL5j8	12874	3NKRUM8mTMobcsUWYATdQXgy7FxfB2qTqHHKZxZvjQt3ivyX1gZw	1560	1291	186	6301	9212	jwYC84433wcQTk1Dkxrd8VxKqekPBreNF9ehPqrpXv5hFQ6UF1N	6640	9415	9415	1617633900000	orphaned
12896	3NLRdvNWeveqHhzbBjMwCm4B4QMuzYdLGfcpqHUiuPfLoy9327wb	12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	1601	1388	187	6301	9192	jwtKBBPWctLEzpiUpiMiykcrH9JTaAZZ3L7CdqZd9wzuLGMLrSA	6646	9400	9400	1617631200000	canonical
12894	3NLVqELsng16F6YKMnXsWdQor2gRd4FUquoFqrPdJKoMuBZ7fKRe	12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	1406	1393	187	6301	9190	jwquJVYMn1JZXKpdfhx4DwCxisRDDhAPeMajGHBbnhgkwS6DmDr	6646	9400	9400	1617631200000	orphaned
12899	3NLbtXVY2u6VUzWvRQ7hXvvwpLPphUbSzodL33piXs1macng3dfw	12897	3NKvnbPtHFB2XPrXssUPmgThqtmBfvPsRVB1ZU23vuwQUrNXSPQ9	1407	1395	187	6301	9195	jwZzLbtVzBYmePbeYppU9LUurkGX6p34aKpAcbZTMdaQTaZtRni	6648	9402	9402	1617631560000	orphaned
12906	3NLLxyzjdLNLfFBvp5LaWXwd5d3PZo43WBedgPS9Jk9UVuhtHZxD	12905	3NLaZg3oCShonsaCxqSVqHU7tbRuV8JEHXq294vVh49d2coj9dbF	1541	1052	187	6301	9202	jwMEbbkUKs35Lt8kS2NeihMnJTvRQ7UTTNFzhisiAKTd5cNjgen	6652	9408	9408	1617632640000	canonical
12914	3NL9fbuNX66xSeKXo7j3fnoaHpt9CFKWKCHh5h4EH9YsqfchGmSm	12912	3NKcBf4cqUnbKmpQoKkAZfaDecvgEHMxcA6BALqq1SzgYsp9Smab	1406	1393	187	6301	9210	jwSwgP1jG9KgyBWKDeVmNLYs2mAsyxwKFahh2yYwbySPGSQvxYE	6656	9415	9415	1617633900000	orphaned
12917	3NKf4BF31zm773shyMta7Em5KxBrmytVkuQKNCwbmWxtvukevJSw	12915	3NKsAQiQv4etYVZsukUePjqrYmmVDeMvRNBwnSFhkXQLnaiWhBog	1536	1313	187	6301	9213	jwxstdU4xpKNkPQh8J8jxxvoXPkrEm4FMt6s9eb3KRtVEmVPRgv	6657	9417	9417	1617634260000	canonical
12939	3NLmqhqCrdKdbif6NB9N89YQwnhk9iMdwuiTCYj63xMSnSPZCNGK	12938	3NKcuiGxTyLfMNhTpJa3rGeqZngKW4CKTnzshkvgLGr6kC1ufx5b	1651	1301	187	6301	9235	jxzgZEQg2HUyctk2o55dQCTMQV1Bot13PS1E9oZtcz9CJvPYcuw	6669	9433	9433	1617637140000	orphaned
12941	3NLebavyCGJqh28zpiMordBAKvzcy4mzuQVi9XGKvxur2tyUo2Si	12940	3NLqyV9XmsRv82bLkMCr8TqBLQqaWSDxPrH9sdPUWyw35qQ9eizF	1602	1243	187	6301	9236	jx1SM9owBu6tDhv99WunszMuKo4JtN28cWcocTpETaGKium5bD4	6670	9434	9434	1617637320000	orphaned
12944	3NKpu87EyqoYeAJvxf35kSeKwMwGs2w4WDAHzEhw96GWQPfcHAAx	12942	3NLpQR4ZTMnQsDzvtBes7jqoEQZEspiXqkJLWNhxSXPQU2oSGprd	1623	830	187	6301	9238	jxpT45SeKoa6SCEeYZTqrA1M6DRtTPZ4FN9q11pVcyrRqXXYBPt	6671	9435	9435	1617637500000	canonical
12946	3NLRixZMj6G7HUM2Xp5VGGvgSvzJDRAhpLAJHEZaW67wc8t8eEH6	12944	3NKpu87EyqoYeAJvxf35kSeKwMwGs2w4WDAHzEhw96GWQPfcHAAx	1534	1071	188	6301	9239	jwNpggzcW1ZFgPwpCW157D7CYpAU1YVkKWAyBWBiMqA64mqvyJi	6672	9436	9436	1617637680000	canonical
12948	3NKRZgfLBRKdYDvnGrMD548xTnCHYBRtHpggfjgaF4xW8ooXt9kJ	12947	3NKNhxxh8y7zk4AzHQkwczhSWDV4tKGe5fqqcrTaesFFaSWmdU81	606	1169	188	6301	9241	jy166ZM6Eym7ULjWmDDYXYEjhvFbxparCRnHaKSpgDyepVWWuFk	6674	9438	9438	1617638040000	canonical
12950	3NLf2p4QGLMkh5nTUu5aGNZHhChdWzDedt83ajkMSAZC8uPG3HU9	12949	3NLq84sVHpFV7AFxCEnrc2q8de7pfsWwb2TbcHww7ZLiH6eVN7UT	1406	1393	188	6301	9243	jxtGQWMmG1JMezAKN1U8FnHPo5BG9mrazbbB4heBK46UxFSpRgP	6676	9441	9441	1617638580000	orphaned
12952	3NKS7BFYM7g4MedWFhSmpi5AUDiTPZzytBraC49RvCZTbe224NrT	12951	3NL2PeuXYoS4666U614TSpeoMUZYTEQqz3YKC7NCmJeo8KXLZULf	1613	1349	188	6301	9245	jxemvzeqG1Xv3eXsc6hf12K1Y3FiU9BzBGnhqsDibt4VZ5dmm1p	6677	9442	9442	1617638760000	canonical
12955	3NLANfBCC5HvBKbqoSZmP76BvusAxS51vqsw7WyYofVR5isXD7ZK	12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	80	1147	188	6301	9248	jwZGxpBo7Un6EuPAyVjHhsDh5uEr6yuro8xhwDftm1hV1YoZgUQ	6680	9445	9445	1617639300000	canonical
12957	3NKEhcJsThrWpXzoqSKvR6DifeiJNNGdm8MCcFz8XMsRdiVakVmq	12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	1536	1313	188	6301	9249	jwkg7Gp57mwXbb7BZvzbyNTDyzXFQyiNYr6XciMwUoWk6EQnY6g	6680	9445	9445	1617639300000	orphaned
12958	3NKSiGeUR48j1LuPxv7iDAJtfCpbaDRNiUm1bcnnSaLV1JeBmUUs	12955	3NLANfBCC5HvBKbqoSZmP76BvusAxS51vqsw7WyYofVR5isXD7ZK	1507	1154	188	6301	9250	jxZjabxAQuYGHEjpSsPdFmfwhfCNg9aiMSyU52KtRzRNqZabVq9	6681	9446	9446	1617639480000	canonical
12961	3NLZ8twpMCJKrS66XD2EpsoiwfmB4RcffX76B5q9W8krBdg8W2ee	12959	3NLfg6EeUWNfWi5TMncyET5o5iXQTKtDdLDauR9ytuuHXtzGzbTt	1406	1393	188	6301	9253	jwpGAfTvdxbfM66Gzg2bhhCiqBZku7m4SaxtRt2wkcQdKCszDKs	6683	9450	9450	1617640200000	canonical
12963	3NKhqfz7ti424EGu3UdHH4QAVAxw1zujhK8yydV1v2o89ejYb7jP	12962	3NLoB3zcggbBusZXLQd4ycpQkdfPmihedqTB3mitNXn17cckUxJz	1671	1365	188	6301	9255	jwjZLrtkTLQKEH5Eet3XCw46UuqbLdZVsCwLnfu8iTUktbjj3fZ	6685	9454	9454	1617640920000	orphaned
12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	1637	816	188	6301	9261	jxoRhrWKgPzetCMwfXKija2TZR1ZoxeD5d7KpXAC6CAJRmkMum8	6688	9457	9457	1617641460000	canonical
12967	3NLRzkyCdMkKntzsUSSrp6Wur8ayX86TMnDZ35J8CsSYk2ewd12Y	12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	1406	1393	188	6301	9259	jxtyqxfvSX7vLY6N2Tvt4tb2dVSfZDssAPURkdUGjQYfwDtQcVG	6688	9457	9457	1617641460000	orphaned
12970	3NK91zKu6tLDTUgX5G8CeLsQsEjjfNdi221wwAXZCxCJ4igpyQzo	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1523	698	188	6301	9262	jwJptg5hTCFxUZSgZVKnNWknmb39KtLLGhQyP9Rp6ousRCKDNz3	6689	9458	9458	1617641640000	canonical
12974	3NKweTz7AakvBZrrg9WnFuzvjMnGTf2LX1wzJTuKhaXjyssWPpPC	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1523	698	188	6301	9262	jxnEv7QLiDyCBwQCQFevsGaeA5X3ykCBiS59XR8GfRjCZXzvYET	6689	9458	9458	1617641640000	orphaned
12977	3NKJvAK6ViFj2zPEqw5zTw1YP7YoSYUBfdpAcDD4khZ4UKh1gDYG	12975	3NKzE4nrzQAtYyYYc5szG4fBkCoAMHNPFyaizbNn53Wns8yrhpuT	1476	1125	188	6301	9267	jxfFACeiQdqTc6pjjxmKs2cfbVtwG2rayd68Wz2gnVLbZmBtCTa	6691	9461	9461	1617642180000	canonical
12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	12977	3NKJvAK6ViFj2zPEqw5zTw1YP7YoSYUBfdpAcDD4khZ4UKh1gDYG	1559	1107	188	6301	9269	jwBdHGcZCwKP5KfuP6eTxsca5BkDreaqc48x1J99BehWsCAFvxP	6692	9462	9462	1617642360000	canonical
12981	3NLZS1KHBd2UYJA1mxgMgDoyyt3m2hNr7TUB8d9wMJTysNGZAqA6	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1448	945	188	6301	9271	jxbzgLHYoYuksVXTHuRH6TVbz1DGK19bJD6ortEN4ZMLny9uUsn	6693	9463	9463	1617642540000	orphaned
12992	3NKfHUJFoCPNqLLgxG48os4vo2M7Xi83h6sVfG7n3Thwr6sn5XqK	12991	3NLT8Gsz8YK7MhfY94NuaGHLUKHq2GzJSqo5m6KndMc5LLpCcvrH	1633	1390	188	6301	9281	jwUztWmS3B5NttnxtGDm1etrNznKzLVuSymKpoUvNeHVn2cb39o	6698	9470	9470	1617643800000	canonical
12995	3NKibK1jyC9fkJbXQMWi8fPi91NsrHK3QpfKLJ7VsGzsZX6VPGU7	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	1536	1313	189	6301	9283	jwVRRVPqXFBPvgr9Qa3gMQUxYwp25Qdhf5KJTVYpC3VjNZXX22L	6700	9472	9472	1617644160000	orphaned
15488	3NKWuXcPwf8GRpsWL6XKz6MgRLKCW2eXKD65kBssxyFvnBgPuup5	15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	369	1312	244	6301	11520	jwjNHPB72Ss4hNdM9fVMbfUKbgGcjvBJ1Zm6sQEa7iMovubBe1z	7778	11150	11150	1617946200000	orphaned
12936	3NLRErF9CFvdHR3M4Nv5yDD8QhxAdtdriHeg6zXMN1osKotnweJa	12934	3NK5MgTWnNXCrWwR6nT8EVuQhkRkhNFPHNuSDWSf2XP8o1kAFbQL	1407	1395	187	6301	9232	jxfAjHaQAEuUSEqHmjJFgpaVw3hpkUGi55FbmTmmPe3R5bgB8ns	6667	9431	9431	1617636780000	canonical
12938	3NKcuiGxTyLfMNhTpJa3rGeqZngKW4CKTnzshkvgLGr6kC1ufx5b	12936	3NLRErF9CFvdHR3M4Nv5yDD8QhxAdtdriHeg6zXMN1osKotnweJa	1656	1343	187	6301	9234	jwntoFNdVMPQYNfg3J9KavzwM2oww6xAfQSZeq6hnVXW4MLCRHQ	6668	9432	9432	1617636960000	canonical
12943	3NLRf7JpbvPLumDZv4JbGS4w1wUtQGubxkjA2EH1Xe9gKHh2CP9T	12942	3NLpQR4ZTMnQsDzvtBes7jqoEQZEspiXqkJLWNhxSXPQU2oSGprd	1634	1085	187	6301	9237	jxRQj3Z431tJHLhUY6rNwMiwqvi2L4LGwX3b7Sgef1w8hG68H1j	6671	9435	9435	1617637500000	orphaned
12945	3NKMhgM2S5YSnVL1F3teQ4ZebpLHWJsUzFgpVqCaWCw9QQdMBRGa	12944	3NKpu87EyqoYeAJvxf35kSeKwMwGs2w4WDAHzEhw96GWQPfcHAAx	1534	1071	188	6301	9239	jwNpggzcW1ZFgPwpCW157D7CYpAU1YVkKWAyBWBiMqA64mqvyJi	6672	9436	9436	1617637680000	orphaned
12949	3NLq84sVHpFV7AFxCEnrc2q8de7pfsWwb2TbcHww7ZLiH6eVN7UT	12948	3NKRZgfLBRKdYDvnGrMD548xTnCHYBRtHpggfjgaF4xW8ooXt9kJ	641	1336	188	6301	9242	jwhuJ6kCKJKtKKYiYnagazw7cfqeAQsFpqF4R3Qyh6aCB1BxS3p	6675	9439	9439	1617638220000	canonical
12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	12953	3NLaPzUp185HqseqToVeT1Ph1b9reXM1UuNZC8nDBkXmxWSXSss5	1673	1002	188	6301	9247	jxXpBByzgrW62wJgJYjnriyWN6cgCsqE66ThDxSBqy3E1HAgTHe	6679	9444	9444	1617639120000	canonical
12959	3NLfg6EeUWNfWi5TMncyET5o5iXQTKtDdLDauR9ytuuHXtzGzbTt	12958	3NKSiGeUR48j1LuPxv7iDAJtfCpbaDRNiUm1bcnnSaLV1JeBmUUs	1403	824	188	6301	9251	jwGDXnrdAvanyQf3gtFVb8RBQEpZGQAzqBgojc5fzActc8iHpHR	6682	9447	9447	1617639660000	canonical
12962	3NLoB3zcggbBusZXLQd4ycpQkdfPmihedqTB3mitNXn17cckUxJz	12961	3NLZ8twpMCJKrS66XD2EpsoiwfmB4RcffX76B5q9W8krBdg8W2ee	1579	1389	188	6301	9254	jwKmCkqpSdp2s9LxfVRiakME6p2uus9AVMcZ2BvjmqUuCQ1yK2s	6684	9451	9451	1617640380000	canonical
12968	3NLKpE25VAuBLeL5oKR7Yo1jKzT7Pr1RLMy7eUMpxW6g6gZnaXbh	12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	1405	1	188	6301	9260	jxxEP6ewHgypCeupWaJzdV2cAE9X7gqEWSybBqH2SzDCujmrwHw	6688	9457	9457	1617641460000	orphaned
12973	3NKZVkKKEXzW4hE99HHYYVUaT6KvEChRMHxotqm3UjtjjHfRbS64	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1523	698	188	6301	9262	jwgGtDEpwBGDSvTo5mbHHGdthfFFnna3ZruxzbtPvsKCFxjKtVK	6689	9458	9458	1617641640000	orphaned
12982	3NKzSvNqwtvpVtMGxSZaVNZQKpheR6htyrbeJTTBvt8SeG69AfvF	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1573	1072	188	6301	9272	jxjSzGApjngu7ct9WQraNSyaN932aTwFFuhBG1DVdEKtMnFnzPj	6693	9463	9463	1617642540000	orphaned
12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	12984	3NLF31aLYfyKW1HBcMpq4am3by51n5QNtu7mCm1wxg7fJ8v86UiW	1585	1366	188	6301	9275	jwWTiMHWd8qw23mub7pfUayikc2hf5z84yYvirMa7CTqipZ4hD9	6695	9465	9465	1617642900000	canonical
12988	3NLcYG2edvxwFpdcwDNaEqRkc3jNmBcNpwbriat12tH4oa8ubaMJ	12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	1406	1393	188	6301	9277	jxT2cKYHpTvGYt6qMrimwFHezAFwqhqjFnR7JdPV1WJBuWYrLAL	6696	9467	9467	1617643260000	canonical
12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	12992	3NKfHUJFoCPNqLLgxG48os4vo2M7Xi83h6sVfG7n3Thwr6sn5XqK	1642	1241	188	6301	9282	jxrqkhbbKnrKkqXFcQTMTvQjQUy4ScPR6k8hSUU3enbHYcGUQbB	6699	9471	9471	1617643980000	canonical
12996	3NL4EcNbzHk3uZ9EB83vb3wBZfBx6FWo9q1U9CaiJVYWfM2vxGLw	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	632	1382	189	6301	9284	jwPFKuEB4LJxVfgCyMQxZt38Ym9jWN6T4gGH5NF9K4WgzVYzQiT	6700	9472	9472	1617644160000	orphaned
12997	3NL8dKFb5WD4jYCaYjZ6ogk3U4SjgJWfjwjULXNbQftrVSCdE5qC	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	632	1382	189	6301	9284	jwPFKuEB4LJxVfgCyMQxZt38Ym9jWN6T4gGH5NF9K4WgzVYzQiT	6700	9472	9472	1617644160000	orphaned
12999	3NKeBfJaiMEXakxUpByJQZDyBoPt4UemCd3ZhoP1rptcXy2TotDB	12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	1599	1041	189	6301	9286	jxttoVDfXagXPjvANRKXMW7AMcWgHAhb3JQiRk4JbZ6atxH7xDo	6701	9473	9473	1617644340000	canonical
13000	3NLfbcCmAxDhY6cfoMnikq9AKU9RLHRGaKH1urvx5Ev8yDYHog2Z	12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	1599	1041	189	6301	9286	jxttoVDfXagXPjvANRKXMW7AMcWgHAhb3JQiRk4JbZ6atxH7xDo	6701	9473	9473	1617644340000	orphaned
13004	3NKiZAf7ts5h3PAUCwqsV7wkvdeNWmPVQLqFA8iiW6GjSM8ZxaMG	12999	3NKeBfJaiMEXakxUpByJQZDyBoPt4UemCd3ZhoP1rptcXy2TotDB	689	689	189	6301	9290	jxNvPwrVAsJTSoDeRavhy9HJQ2YF3irk2CL9KeJG4dv4MM8RRKz	6702	9474	9474	1617644520000	canonical
13005	3NKfhHU282jei11hjB8sD9DFqMmqCentygiFU8noERgK9Dp5vEim	13004	3NKiZAf7ts5h3PAUCwqsV7wkvdeNWmPVQLqFA8iiW6GjSM8ZxaMG	43	1310	189	6301	9291	jxk7uagBWPy4fPNzfFVbKVtoEupX2rWMWZNiDPGCH2BpeiW6nQF	6703	9476	9476	1617644880000	canonical
13003	3NLncQhJ33qzUp2Wdydmwx1BKQ6pRB71oTz3qS2m1RDVtSZmk1Tn	13002	3NLTZritb4EqKEhAck8CHwgXrxHPokg8cp5XnSx4bk6XM1ua5Mad	43	1310	189	6301	9289	jxLYEKkmsci3FzZJsWwBi54NG46CcBq8Eabp3SLhApSgH6igrzb	6703	9476	9476	1617644880000	orphaned
13006	3NLsR5JuQGPM1Vm7Yc5xFdPULDpaFrvoDMH2W3YXXxWSXcDT4BpX	13004	3NKiZAf7ts5h3PAUCwqsV7wkvdeNWmPVQLqFA8iiW6GjSM8ZxaMG	1637	815	189	6301	9292	jy2FgE7XixQiNsd8K8SWAJrTb1XrjGTJKFuayFsXwuxBANoKzha	6703	9476	9476	1617644880000	orphaned
13007	3NK5mV9tbxkaT5fsaZFJB7S7FYmpso4AKuKCZ7axQmRUVYxPRGJ1	13005	3NKfhHU282jei11hjB8sD9DFqMmqCentygiFU8noERgK9Dp5vEim	1403	824	189	6301	9293	jxgCP4qv58a1So6PhehMBZjsbovyZTzbh4sAxHf69n1k7BP2X4r	6704	9479	9479	1617645420000	canonical
13009	3NLR7LMqswnuPGxa86mPPjSiJpRiEdN1w1gVwCjbhWsuvdgchDTp	13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	1508	1387	189	6301	9295	jxiVJEfH1NCxF5vCsM6U6Zn2559kCYM2nULJA6caBtqKr7qM5TP	6706	9481	9481	1617645780000	canonical
13010	3NKUTYNGQCS2rBCq1UJTuoXvWr9zxcxLfLfAT5m4pLSo6eVKEAoA	13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	1638	630	189	6301	9296	jwgzs4Sv7zmmYeaCqFkKw9NfXgHbrr3BtRcHAZxyTsxJgdfNcV5	6706	9481	9481	1617645780000	orphaned
13016	3NLAF4xB5AvvaJ3nCrP96eRYD6beUCJX93v7NAwUzWSj23P48CKx	13015	3NLDKCSr5KmErabsajey1hURuPThnuR93JoxF4ABVNgPtCscdU9s	1588	1146	189	6301	9302	jwUmS4owhLyjrQmbLLRWNdXzyFTgcep7ovSEuWB4cuV3eS2FbBj	6710	9486	9486	1617646680000	orphaned
13019	3NLdVYsKcBShimYXWe5bYkKbGVgqe5R2JZvQJnUUJK7FDLZEEAZD	13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	1642	1121	189	6301	9305	jwwrd1oQQ1UUqAa3feoYrGyZeQ2LRLSLD5hijTJLf5DVsLDqEsd	6712	9489	9489	1617647220000	orphaned
13028	3NKUUHLcAMToxG1zZF5d8utwVdhznm5xPMecNsqnvnWeaBtkZ38K	13027	3NKG5aSR5GB2yP5pFA2M7MrwWypQBVYeU2Rgt6UwvtvYLzz7XrJH	555	555	189	6301	9314	jwgLFY2WUaG3jQq6j9pnfDV81quTrexwFvajYHoKL1EGdE9F2zi	6716	9493	9493	1617647940000	canonical
13031	3NLuBWNJj6dwFLeAUqr4MvuyeQLR8ti3vby27p6sebTuB71EdyNv	13030	3NKKHPqPKPSrftNKC6hR4T3yCJuKE9BvnJv5WYKzQxiNHUXbVzqB	1467	1376	189	6301	9317	jwPemzSmNfFakUXnM7L27QUniFFmtrTYHKW7GVA1pHGG8sE9zky	6718	9498	9498	1617648840000	canonical
15280	3NLEVvaetQpgvh9uz5egcBnjkFH1i4sSA6qbS9eiJ6xZhoJhariM	15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	1652	1315	244	6301	11326	jxJWWE3UodvBDgmyUpoqAgRfvKbD8eC8DWR89ZeyzzkcTs9apug	7782	11012	11012	1617921360000	orphaned
12951	3NL2PeuXYoS4666U614TSpeoMUZYTEQqz3YKC7NCmJeo8KXLZULf	12949	3NLq84sVHpFV7AFxCEnrc2q8de7pfsWwb2TbcHww7ZLiH6eVN7UT	1634	1205	188	6301	9244	jxyRosZuNAtjJvrru9pnFZkgLqK8PbkTwZ2jmLc7RZBeNqmLPvk	6676	9441	9441	1617638580000	canonical
12960	3NLps8WQUWDZg7bCU9Z3kyqVFAyt9jhocR53YXpkCqJVS9dDVti2	12950	3NLf2p4QGLMkh5nTUu5aGNZHhChdWzDedt83ajkMSAZC8uPG3HU9	1577	961	188	6301	9252	jxgqwAnEKCiLoqXrhRsNV1ZL3QpQCGaYBuGxk7vbMVLaKTjZNnd	6677	9448	9448	1617639840000	orphaned
12953	3NLaPzUp185HqseqToVeT1Ph1b9reXM1UuNZC8nDBkXmxWSXSss5	12952	3NKS7BFYM7g4MedWFhSmpi5AUDiTPZzytBraC49RvCZTbe224NrT	641	970	188	6301	9246	jxsTi25Y4W9Wwz5zdBLk35mg1vc11GgSELesBQGdoxLdHjUZxGM	6678	9443	9443	1617638940000	canonical
12956	3NKYyr9hRUfS53PrG9nK1MiPpgi5rr8X5apqRkJT2WUEdHJn2hVa	12954	3NKgPitjkvT1Gsicv3ame1KVwjAKrgMiMwKx2sDrYAJycYgAQSDV	1536	1313	188	6301	9249	jwpj5PGUoiEZAFp9J3eK9pj3NzugREQE6CHmXR1kWixPp3r3nCk	6680	9445	9445	1617639300000	orphaned
12964	3NKCrk5c97jEu1SvoRWjr6gt8jHXcehxV5vsxswrcA1UxpM5hTDr	12962	3NLoB3zcggbBusZXLQd4ycpQkdfPmihedqTB3mitNXn17cckUxJz	1403	824	188	6301	9256	jxj2r5B6PYBRrXcJSLfmAvCTzAiKyzQtZxxr1HEffA7AYyU51sy	6685	9454	9454	1617640920000	canonical
12966	3NLDgwU12zbd8Mf1Qt6sKustjFdZiotHwgHwAQ7G8i6kzcVQMidn	12965	3NL7bVGNFBZGQePDS6bJmr7422AZRm1FQvMibBhvHhiwZuN9d5P6	684	1352	188	6301	9258	jwhtFi1dK6EfoeYR6SooRcqyosryvKVedxwEeKcN9LRMMc5HGvK	6687	9456	9456	1617641280000	canonical
12971	3NLQnVVcxUXo7fMquma6q77aqPMaDmqvW6NEMhfZScqT9HVjarWZ	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1670	1156	188	6301	9263	jwZiqZpbDmRvbbw9vr7Z8hdMv2CRm9JEgr3NRptPSbUKxxvCzwT	6689	9458	9458	1617641640000	orphaned
12975	3NKzE4nrzQAtYyYYc5szG4fBkCoAMHNPFyaizbNn53Wns8yrhpuT	12970	3NK91zKu6tLDTUgX5G8CeLsQsEjjfNdi221wwAXZCxCJ4igpyQzo	1406	1393	188	6301	9265	jxCTfdUQ4WVHYZUQTTaaq3cKyT7RvHoyPVfYK2gQUwvuqpyMkdw	6690	9459	9459	1617641820000	canonical
12980	3NLvWLTWo4brjAaxRU7WepZWANX9rZtrfQ7JduF8rsPDPS8Y3DdD	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1668	1124	188	6301	9270	jxmR2FmvcykaSvK4VhEm1UcSGnZLgVg681jLuYVrT8w2k3oaGyT	6693	9463	9463	1617642540000	canonical
12983	3NKPqZ8mWf5aDjjXeMko9hj8d6VzZbG9L7wvWa9WqCUcceDFt6Md	12979	3NKvWzVxN2PaYaQRrbyETFEM2U5WGFDhSnqToGu8nfCzQ1kD72az	1448	945	188	6301	9271	jxRoqaHqMoxeXqjJwMPTgFBNtV3AZ93agdWAWNsrdw1R8TvioGK	6693	9463	9463	1617642540000	orphaned
12984	3NLF31aLYfyKW1HBcMpq4am3by51n5QNtu7mCm1wxg7fJ8v86UiW	12980	3NLvWLTWo4brjAaxRU7WepZWANX9rZtrfQ7JduF8rsPDPS8Y3DdD	1587	1111	188	6301	9273	jwKgnwuxPRQPz2kj2NwW8fFzqcAieKKyDndA6CinGHadUzad2kT	6694	9464	9464	1617642720000	canonical
12990	3NKb5vgP2uQngE2kxMmtgSjXbPnUMjbNqPkh6HQ4QZHiQRVDx4AA	12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	1522	1076	188	6301	9279	jwhrE4RErWYkHRPvyb6tG1PzTy64xEiLH8NLejAhH9vqPRszDci	6696	9467	9467	1617643260000	orphaned
12991	3NLT8Gsz8YK7MhfY94NuaGHLUKHq2GzJSqo5m6KndMc5LLpCcvrH	12988	3NLcYG2edvxwFpdcwDNaEqRkc3jNmBcNpwbriat12tH4oa8ubaMJ	1402	874	188	6301	9280	jx1bA4Tuy3QsWitEH2a5f24J7Wo8W6WUv5NcALBtiPTUD4iy2Rb	6697	9468	9468	1617643440000	canonical
12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	1536	1313	188	6301	9283	jxqTB8wpaZprMuM3nbRdsPaTwpKAAqWMgydD9Z6WbfdK8S3xwVi	6700	9472	9472	1617644160000	canonical
13011	3NL9qTNsNX1nnh4D8uqgTRdTA6dQzZjujTfdZr7aLpqLuAhmQk1P	13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	1564	1338	189	6301	9297	jxAxYWL1bfhT4hCnt88Nq7ZpaLEcfQDKUUEvb6WQNgKxtHMajF1	6706	9481	9481	1617645780000	orphaned
13012	3NKwBfdQoFwwC6ytckL8MZmiCjvNka5CFSKwDaCWDNqurEtAFXDW	13009	3NLR7LMqswnuPGxa86mPPjSiJpRiEdN1w1gVwCjbhWsuvdgchDTp	1402	809	189	6301	9298	jxir3pVvzCbiYhRLYAFHQajrd5Qx6s5dvFq2YFjWXkPmBAemJSs	6707	9482	9482	1617645960000	canonical
13015	3NLDKCSr5KmErabsajey1hURuPThnuR93JoxF4ABVNgPtCscdU9s	13013	3NK6RjMags949pgs5dBcvSesnJ9R4NTWwDXKL7P19EfhqPijQpfg	1508	1387	189	6301	9301	jwecVuvv8UJXuyUb34AMcuNrdVbySgwwBf5QDbYy2TNcM8xYy1q	6709	9484	9484	1617646320000	canonical
13014	3NLiYymNjFuA8DiXeYWcajHDLbd3MqCXMGcGoRhWEYhfmMHHuJZU	13013	3NK6RjMags949pgs5dBcvSesnJ9R4NTWwDXKL7P19EfhqPijQpfg	1622	1356	189	6301	9300	jwgwmV1tuR22NCuPHgnGVfS8oZCn8Gtx5wMFHbbtrSUVgEuE65Q	6709	9484	9484	1617646320000	orphaned
13017	3NKvFU7U2K4DswnikiA6CxCR5KRZFCQsMCaMfuaDbQmcnkbU5kUY	13015	3NLDKCSr5KmErabsajey1hURuPThnuR93JoxF4ABVNgPtCscdU9s	43	1310	189	6301	9303	jxyHcuCsr9sf2NEsRi5gTaHijfp54tNCYU9h4Qh348idH9farDA	6710	9486	9486	1617646680000	canonical
13020	3NKMBS5N7znvTte7X6mQnKBQyoekZ8TkEpssQB7dZc9cDRRtJFfg	13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	1483	63	189	6301	9306	jxHiyD3AXip3mv8BixL5iGwuSnMrzxdtt4ojyaD9GnT2Te9fp9R	6712	9489	9489	1617647220000	canonical
13022	3NLTEdcGZcESsvgW4wg87DJaz7t3vWkyPiwUgH4P9Ast2uUgjN8d	13020	3NKMBS5N7znvTte7X6mQnKBQyoekZ8TkEpssQB7dZc9cDRRtJFfg	1536	1067	189	6301	9308	jxjzvVNrUgpK5X6Jo5BQgEke2SwBaPX95AhBHfgfpKQMx8PXPto	6713	9490	9490	1617647400000	orphaned
13025	3NLqetMN8RjWcsYaWQyWEPTKZ3pcKM6g6cKY7PCJG5t9y4m8Uds4	13023	3NLXZjSrmcGpgGUQ2vipk2UEV499T5qYkqvuBUriKj1A9E5RiNmL	1637	816	189	6301	9311	jx6rR5Rr59riRVPNC5kpzZ56r3Qt2MtcqDqKpJPe86gFxCWyvXC	6714	9491	9491	1617647580000	canonical
13024	3NKahGRqzM2n1gaB9Jp94hoY6cTYdVzGLhA9WkAfXdSAqUc1QAUo	13023	3NLXZjSrmcGpgGUQ2vipk2UEV499T5qYkqvuBUriKj1A9E5RiNmL	1579	1389	189	6301	9310	jwxB3kwzfvA3R6Ls9dL4ydMSGmmEVtbCkPr8EEqEFxxX4uS4dT4	6714	9491	9491	1617647580000	orphaned
13027	3NKG5aSR5GB2yP5pFA2M7MrwWypQBVYeU2Rgt6UwvtvYLzz7XrJH	13025	3NLqetMN8RjWcsYaWQyWEPTKZ3pcKM6g6cKY7PCJG5t9y4m8Uds4	596	1060	189	6301	9313	jxwqRgvZZQbvX9LnYZZWupNGMLA12ydf7ymHU1FkLvNXjLyjHq7	6715	9492	9492	1617647760000	canonical
13026	3NLsv7rpdQ6eEnZnD7E1eMxX7oewP1wSBuFNREafNMG6W4BxPXUM	13025	3NLqetMN8RjWcsYaWQyWEPTKZ3pcKM6g6cKY7PCJG5t9y4m8Uds4	1619	1275	189	6301	9312	jxwaRTBt4ZyhjK3bWU1a8YPVqB8Zq7efcUVE9PhVgiiudSZ9FLY	6715	9492	9492	1617647760000	orphaned
13030	3NKKHPqPKPSrftNKC6hR4T3yCJuKE9BvnJv5WYKzQxiNHUXbVzqB	13028	3NKUUHLcAMToxG1zZF5d8utwVdhznm5xPMecNsqnvnWeaBtkZ38K	1477	1104	189	6301	9316	jxnkDbk8XGkYfo3t2cU8uMaXyhJHoLKwaG2YV5nMWoDCn2XaNoV	6717	9495	9495	1617648300000	canonical
13029	3NKbsX86UW8DmtRVJ16nPn3XUhB3CYo6E7LdSBKKGjA1JcEXvvu2	13028	3NKUUHLcAMToxG1zZF5d8utwVdhznm5xPMecNsqnvnWeaBtkZ38K	1403	786	189	6301	9315	jwk4fNT1JC1v2nbTug6aDUjwHUB14993MCoXgp1Q3sHh5VX95A3	6717	9495	9495	1617648300000	orphaned
13032	3NKUAwYwttDSa2UHwzgsfu7doFuHzFptEE3arTwQTNMUMDxMEJQj	13031	3NLuBWNJj6dwFLeAUqr4MvuyeQLR8ti3vby27p6sebTuB71EdyNv	1633	1390	189	6301	9318	jxABdaLRze1f8xNJiVX1SBAFNEvtNw92TvAXgrhxGpJy9k9UW7U	6719	9499	9499	1617649020000	orphaned
13035	3NLgMTyhWWm3YwEdKCyq8bA7Dh5cjB9AcbtrPoxhmUjYMyh8cVfj	13033	3NL1SBBqp2eyynqLLQi8cDwDYLYR6ikEYRMMcwmrravzjzryyzrH	1403	824	189	6301	9321	jxF65SWKEVpyPM8Cnb47GHBf7c9x2QzZ9YLiENUmhLFFH5BepQn	6720	9504	9504	1617649920000	canonical
15304	3NKYEyYthqDijndoNeT2RbteRWzjbX6T8krRQ4vvPMsjq6NoEnwW	15281	3NLuT8QxRHEDKkT8jAN3UKdm4SSrepshayTir7kZKsM9v3MWksRz	1509	1194	244	6301	11350	jxu1FwKvJeBknQXz4x84yPm1E2ULVh9ZSp99RKMX8HhMW3nWihV	7784	11033	11033	1617925140000	orphaned
12987	3NKckbozqXhT6qkyqAfGYbdpVWfE65ggVxdfevEUL36SxzNTCtAQ	12984	3NLF31aLYfyKW1HBcMpq4am3by51n5QNtu7mCm1wxg7fJ8v86UiW	1675	976	188	6301	9276	jxjWwPdfrepbxLFwBya2pkbvQNPDXQTLaXdYzbQNDniDXYVf3B9	6695	9465	9465	1617642900000	orphaned
12989	3NK7TydgeWeuC4KhxXDkU1XKdKaETfai6r11VXGdQFFRdhGcQYMt	12986	3NLLnpPyYghCHDUdGBZVbXzcggUQh7cpEvj7cVqCQXP7QSJLfUR7	1483	1030	188	6301	9278	jxbjH8FUJrfybGetnaRhYWcMiP9k6wG554WjgEdpfsrB8LCinoX	6696	9467	9467	1617643260000	orphaned
12998	3NKusMtov1qMFv4HtLACzr7fY3ni7kMP4mdpa6FRCBX2pmCVA7iH	12993	3NLRyk6FxAn9mpyLhdQt82vgLCfg8hBRDSMJ7M3Nj3PHz1mHLahX	1631	794	188	6301	9285	jwVAVxymMScH6GT24aZAkfJtzgmNR55ErTsedrVn6tzqkLkv1Mw	6700	9472	9472	1617644160000	orphaned
13001	3NLNJHtb1xdPCJ4YRg5ekQBpyPiGDsSLHXcqiTVwgoJyqjTg6SZa	12994	3NKvEDcmn25Nuv8RCtxaQ621bKyZZVK9W1JDNsyjvA4Hh8wnZFng	1596	1363	189	6301	9287	jxt7Sm18pf1TzGbwP2LwQronxcfFzRuNpyXzA6GqU47USFogksk	6701	9473	9473	1617644340000	orphaned
13002	3NLTZritb4EqKEhAck8CHwgXrxHPokg8cp5XnSx4bk6XM1ua5Mad	12999	3NKeBfJaiMEXakxUpByJQZDyBoPt4UemCd3ZhoP1rptcXy2TotDB	1673	23	189	6301	9288	jwnX2g4nDYo4BZ5tsukKTgKfrStD8gstxmWLJEXvZ38NKJ3Y4yL	6702	9474	9474	1617644520000	orphaned
13008	3NKbQLGnNeoNpW6NEZtr8ZbvnjirXno7QeNAzxVR6XvuouoJ4ELZ	13007	3NK5mV9tbxkaT5fsaZFJB7S7FYmpso4AKuKCZ7axQmRUVYxPRGJ1	1573	1318	189	6301	9294	jwAbucbBGE2pxSPxGBDeyjFzYoLhzPzEKzsuRxHexWNaquGWN6v	6705	9480	9480	1617645600000	canonical
13013	3NK6RjMags949pgs5dBcvSesnJ9R4NTWwDXKL7P19EfhqPijQpfg	13012	3NKwBfdQoFwwC6ytckL8MZmiCjvNka5CFSKwDaCWDNqurEtAFXDW	1476	1371	189	6301	9299	jxnuNCnjZ4S6A3kbTzMjXdjokTV7GFLiNJZ2Xvq2XjDcExnrZKi	6708	9483	9483	1617646140000	canonical
13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	13017	3NKvFU7U2K4DswnikiA6CxCR5KRZFCQsMCaMfuaDbQmcnkbU5kUY	1601	1142	189	6301	9304	jwqvAGMDYDjsMrjmLeFmvxuJyrBdnbRFmAfG6im5Hc6T1bGepCf	6711	9488	9488	1617647040000	canonical
13023	3NLXZjSrmcGpgGUQ2vipk2UEV499T5qYkqvuBUriKj1A9E5RiNmL	13020	3NKMBS5N7znvTte7X6mQnKBQyoekZ8TkEpssQB7dZc9cDRRtJFfg	149	1283	189	6301	9309	jy2YbTNiZvrnAqe5kCKiWm5TyWTCZkMZSqwaV9oGMaFxrk5xeSU	6713	9490	9490	1617647400000	canonical
13033	3NL1SBBqp2eyynqLLQi8cDwDYLYR6ikEYRMMcwmrravzjzryyzrH	13031	3NLuBWNJj6dwFLeAUqr4MvuyeQLR8ti3vby27p6sebTuB71EdyNv	1407	1395	189	6301	9319	jwQ2dpjMr17HqEzrd1CJv4hJmgR7gMy1PML9q9ERLWvzxV5SK7p	6719	9499	9499	1617649020000	canonical
13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	13035	3NLgMTyhWWm3YwEdKCyq8bA7Dh5cjB9AcbtrPoxhmUjYMyh8cVfj	1402	868	189	6301	9322	jxJANro45yjoM1P7SkWGHZKn9vzUUMhh4PjxmZvD7WYix1VxC2c	6721	9505	9505	1617650100000	canonical
13039	3NLmd3AuyQnth9gK4VWXNae3FHzAfmGvymveMPoRde9yuC8BQaHW	13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	44	959	190	6301	9323	jxArBPFH9zZ9EYvkXTYpWwcniLZZwTwyu4x3k83hJqByGq5v6aa	6722	9506	9506	1617650280000	orphaned
13041	3NLBNBoJ7SMYHxtTWzL4LJG3Lye1JYLvJkhrMxvdvLDMX8VtdoKZ	13038	3NKGM7pqzuay5ZPWzh336GsaSzWbwnNYUMJb9Ht9WoMSWecZK3yJ	1407	1395	190	6301	9326	jx5dBvcpfsPJxXBHBSasvxYSzGafX8uhU8dW64jeXsjHRYoEuaX	6723	9508	9508	1617650640000	canonical
13043	3NKGCASwmAomTryuNucHdPKUyMYh34eyrGEqj57NhYQPxVtFVyqj	13041	3NLBNBoJ7SMYHxtTWzL4LJG3Lye1JYLvJkhrMxvdvLDMX8VtdoKZ	1403	824	190	6301	9328	jwreS9GWc4ycEsGBFLXuLhuWRvRXXXyKsJm8i6AmgcNa5hzCnsH	6724	9510	9510	1617651000000	canonical
13044	3NKhuNhwFnuPwtMEjUUpgkzrrG2bPwvu9DyGmLohBP4MGL93gPwt	13043	3NKGCASwmAomTryuNucHdPKUyMYh34eyrGEqj57NhYQPxVtFVyqj	1444	1381	190	6301	9329	jwBMR9jMZK5sD5yReHdVEeNSDfeyGm1BsMabjxk1cahcz3zvqQZ	6725	9511	9511	1617651180000	canonical
13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	13045	3NLjihs4uSUxVLLPrxrUMwmweYeQby12h9vAohVzAYAT98qm3aVL	149	1037	190	6301	9331	jxUZNobDnSK2mCYLxXnjRCy6tjDLCf5R2SwvWNb6hfYzCq9nZfX	6727	9513	9513	1617651540000	canonical
13049	3NKfqtqxRrXfnDmumAWVZyBCRPsLNVCvDU4T5ArHFSxrc6q2aidc	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	44	1325	190	6301	9334	jw9AYBCA6BV6anafQ4xQfsEMgxgxABjnUuTbP2mR3ymfun8nmSd	6728	9514	9514	1617651720000	canonical
13048	3NKYdcvnoZaQStqgwqwbu9NaKQErbnk4YggGsYTnNotXiiCKgX73	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1402	868	190	6301	9333	jwD9ApYHytbZn472rwEKvxQvymUfyQd8u5wqVtPvQveJTqURQkr	6728	9514	9514	1617651720000	orphaned
13053	3NKbq2JRAr9WySv9VNXxGxq1yCXs9miZuxGETFWsa6nDc4n68JzY	13049	3NKfqtqxRrXfnDmumAWVZyBCRPsLNVCvDU4T5ArHFSxrc6q2aidc	1623	830	190	6301	9338	jxhps4mSwNAQSM5BdeeLqnqcLVrtBEfnDRp13d8PKEu3qzgaSzs	6729	9515	9515	1617651900000	canonical
13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	1407	1395	190	6301	9340	jwjmeUnnkuGS9woo4eXaHr5cUCa3rfgHfXPMGHpX3mhasQnf7vb	6731	9517	9517	1617652260000	canonical
13056	3NL7P4UizU3qhanrziyDTsWTob3f1HuCuH1gL4TQHJeVT65JjGfD	13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	1617	922	190	6301	9341	jxnohFmcrK7LoGBnYdF3vzxi3hbPoWG6TPyzjxmc2XQNYYshRtJ	6731	9517	9517	1617652260000	orphaned
13058	3NKdYs9GgarwNV8vYp68qJo1xktdY3nc5d1j7J3DVXAUg3Rhy2Zo	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1523	1075	190	6301	9342	jw94sHQrphvCUVL2Nwq8y43rps3sJ1fyjZZu87Eh5wejRK5ZjMF	6732	9519	9519	1617652620000	orphaned
13059	3NKtT2p6gtPNaXmHoUdpwtTQ6Unn2DZ24qP9TQL4unDJU66B3ppb	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1523	1075	190	6301	9342	jxH2zzZ8QC7tX2KhRfPVQo8mufMq46TnHxaJns1b1NNeVNDKJ8c	6732	9519	9519	1617652620000	orphaned
13063	3NKA8WSWMrGXvZTEcNqGHgVMpr6bxxnUogGUMjqeHdew9kyRHLwp	13061	3NLmhkN2Pg2df3tgpBqcb4vAEz25svkjtAtuUtfmoAdY8uZmZeKy	1654	1094	190	6301	9346	jwePEVkPEFtdLqRXAwhzButLVQ7DSZ2h8f33sjyEb1A9JKHjMeD	6734	9522	9522	1617653160000	orphaned
13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	1477	1104	190	6301	9349	jxAvBt3SQpUYZstbsJjbAAEymVMTARipahvf3PQCHeq5jp7ptrF	6735	9523	9523	1617653340000	canonical
13072	3NKh6mwqahtf79vRWPRbQGPLL6szKSzduXoDyui8LzA2FHvpwVoA	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	606	1049	190	6301	9355	jwTnfdXT5cbHNWLCnGvKCvwPGEwp8oup2Qsk37rQjt25NWRSX65	6737	9526	9526	1617653880000	orphaned
13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	13075	3NKtkEFsmPJTuXMQ1AMgL7sWmX8YxumwUDHvzK97WZS14dKziznw	1406	1393	191	6301	9358	jwjiVuYGL5AkDP1W9UDBguyAm7nscBWFBvmUBNjyjPRECAprh3b	6739	9528	9528	1617654240000	canonical
13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1601	1262	191	6301	9361	jwQ34tqxsM9mS1sZsWDZM8YCYaLb4fDt5bFWvmQmbZM8Sd88zaK	6740	9529	9529	1617654420000	canonical
13083	3NLSXWdf3XtPE6dK1eiUZoerH3QLcdqsCWyQTkBdYcSJu82mr8ND	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	1657	1344	191	6301	9365	jxypZTz6FLjJ9EBy6VXXpUQFAV3BEZAa1mGMwR5N1FoK5Vmid5Z	6741	9530	9530	1617654600000	orphaned
15466	3NK2xkwnfq22cL3jPwyMS9C9QM1CrTGvXBrfUm6SM6Fgi47eeRWP	15286	3NLu2SxvefETEbKhcsJEwWJQymjCZFtDw8zXyNNzMcFTFax4W7kb	1403	824	244	6301	11500	jxUXSvQLFU3sYSVkKPXJGsMpWWCpwne6o76rbMHowu3QqxCPFsv	7788	11136	11136	1617943714550	orphaned
13126	3NLEwjUSdf6ZaV8W99sGH3a6YiHf6TXYVJcjWyn7ZqCxeY2nwfZL	13106	3NK8BvshvDnNsH57hsaYXbh823xSbwNmdSdX4SeRxSLyhPQJzZrC	1455	1332	186	6301	9405	jw8mkkwEx1sLb5K1vBT1Xr42V8xW488pLK41WoE35dvdgxi6BfF	6646	9565	9565	1617660900000	orphaned
13131	3NKa9tb1Z3mPn1dAnYrQEYDAS4MYymP2rsEzJfB1c82KDEAeCC7p	13126	3NLEwjUSdf6ZaV8W99sGH3a6YiHf6TXYVJcjWyn7ZqCxeY2nwfZL	1455	966	186	6301	9410	jw8mkkwEx1sLb5K1vBT1Xr42V8xW488pLK41WoE35dvdgxi6BfF	6647	9570	9570	1617661800000	orphaned
13037	3NKGX6m9WtrGbWVGF72JoSuQzAxr6gfQ1gYWBf6YBfvt566wUWem	13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	44	959	190	6301	9323	jxArBPFH9zZ9EYvkXTYpWwcniLZZwTwyu4x3k83hJqByGq5v6aa	6722	9506	9506	1617650280000	orphaned
13042	3NKYkcuRemSjdnpwFWjAC9SNbdmDfBoi3viACwFahd3CMnhryVh6	13039	3NLmd3AuyQnth9gK4VWXNae3FHzAfmGvymveMPoRde9yuC8BQaHW	1546	1339	190	6301	9327	jxpWSFxgaLZkVVgg66DGdaqDfQ6rx9moQtzjbqf4Xu8EJPjG2Xu	6723	9508	9508	1617650640000	orphaned
13050	3NK6MDby9XHUALGrYUMnMdTcoMQauwiJxDZQabTCo5oma1SGMMmv	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1406	1393	190	6301	9335	jx4BUL2DhoCrnHiBgcsRna4jg8rfDJeFaEfT2mns7EQCf6eiHzw	6728	9514	9514	1617651720000	orphaned
13067	3NLELMG6st7KFTv7UyhLGRmgd1coVmKwrcUJzMBpN5tKmWHYuXRL	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	298	1308	190	6301	9350	jwGkeCMw2EKsaqLd44i4WxoADNZ9FK41vqgj4SqK7nEy8qYUti4	6735	9523	9523	1617653340000	orphaned
13068	3NL7w52gz5upcNL7RQoJxs8Aa5k7V6btG6amvaBRoC7yG8WAUFb1	13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	1460	1324	190	6301	9351	jxq17AtsFNHMADTQKWyDxCJSBmTiHeerZzwTaxemuC7zJLF5fQz	6736	9525	9525	1617653700000	orphaned
13073	3NKWJY8PJELmXHzWUBoXAmCVJQjkL7DRgGseeYq17iYGsVyWGnfK	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	1407	1395	190	6301	9356	jwdF6vFzsiockRh9qsZNYJ65eZGFFSPbfKLD3dsxKeEX2QXG8fp	6737	9526	9526	1617653880000	canonical
13084	3NKu91kuBJc5y6yjTYjSsqAThatin7ECFvgyw3xrcbYqkKX5vJHT	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	532	937	191	6301	9366	jxNEK73UtEPkkMQtEWJTJ1nF9p9WQtBSWJsb1NG676xxb6UtWEB	6741	9530	9530	1617654600000	orphaned
13087	3NL1CkX8Tkm4Abwg4HNaxecBLCFBEPekxdy6xtgCgaX796k3qjQQ	13086	3NK42Q8sogk48iAPZ7xMNNzxQjuqrauP8tAgqb2oCU5XqENYAUDQ	1403	824	191	6301	9368	jwX38M4a5ezxid1cP4rB1r1AGMvHTwD6JxmCaoH99LFdsGQhFQr	6742	9532	9532	1617654960000	canonical
13088	3NLH375k9mA49G9LYHxjZSHzpyYBPEvux7rjNmjPqGtYYZzmveWu	13087	3NL1CkX8Tkm4Abwg4HNaxecBLCFBEPekxdy6xtgCgaX796k3qjQQ	1481	790	191	6301	9369	jwyx7zRrF3NStkti4Mi2qvM1nksFg5dbEdW8oBNRVcAFAJNRJ4U	6743	9533	9533	1617655140000	canonical
13090	3NKqZzRZs9qHV7QNycE9E3izY4vncKKgANFhrYw3GRknnZq9U4CF	13088	3NLH375k9mA49G9LYHxjZSHzpyYBPEvux7rjNmjPqGtYYZzmveWu	1406	1393	191	6301	9371	jx8uskRdZP7hYbks5pN6qCMDPE65X9mcXCrGXxDuBR8EYH7E65C	6744	9534	9534	1617655320000	orphaned
13092	3NKkhuychnjTWvGVUz5oVh4ae2CtMAEKLp3qRhHMVgb1vrtfLyU5	13091	3NL25t4iZVda7QmJDPRRwjTfJgyM6eBMwjsyxfRcrcb6vTPYfmvf	1654	1094	191	6301	9373	jxWE3fhAdcVWLu6DPCDQeZxPtc1mSkhVn1Lg1J9dFCX5eoJRM5t	6746	9536	9536	1617655680000	canonical
13093	3NLFMLZEWUtvko2p8XeLfRxd5FaSVJC4VxCAR4p8mQsaA8Epgq3t	13092	3NKkhuychnjTWvGVUz5oVh4ae2CtMAEKLp3qRhHMVgb1vrtfLyU5	1657	1344	191	6301	9374	jwqTpniGxGWN61BYsV2g96P5xWFRdUnCix9ReVPDWa54G3mZjgy	6747	9537	9537	1617655860000	canonical
13095	3NKJKSwLsi62EmdQNgASxHd5Jrc2Kivc8VtiWFRPXurWmrHJHPVm	13094	3NLFUZfFzAv5Z1HupSLGoC7Q2MVtzBGu3GAGZZX2zopusx8f8TSf	298	1308	191	6301	9376	jxULM6jwz94BEWDPGWDzsaB7TtYzLJvt8hWR1r4uFDbh8TPMFHs	6749	9540	9540	1617656400000	canonical
13096	3NKAm72eEPNFTA79sep7fyVrczaYRXVXU89Aq94Fott5UeJZpx5R	13095	3NKJKSwLsi62EmdQNgASxHd5Jrc2Kivc8VtiWFRPXurWmrHJHPVm	1403	782	191	6301	9377	jw7aS8AZjwSfTEu4peuMSc3xAWFqUjMKkPYiBzGc4CG6iDAcz3r	6750	9541	9541	1617656580000	canonical
13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	13096	3NKAm72eEPNFTA79sep7fyVrczaYRXVXU89Aq94Fott5UeJZpx5R	1590	1174	191	6301	9380	jwjhwDmuoeTKUswk2swNMJSksAaK7nCUnAUanDYMim9fgphCPuQ	6751	9542	9542	1617656760000	canonical
13098	3NLx5F5ntu3qPz7GCUegSbdQKFspEPZgt5bv6A6iD6p8fhYcpjoL	13096	3NKAm72eEPNFTA79sep7fyVrczaYRXVXU89Aq94Fott5UeJZpx5R	1611	1341	191	6301	9379	jxS5qwTsJANCARiyqr7J2yVnwfB2VK8j9bHCkX4zgp8sX4A8xhL	6751	9542	9542	1617656760000	orphaned
13100	3NLphz2EmCRpahndbRZfJKEkPkvGz9158vksyqCCFBgijiKVi78v	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1670	1156	191	6301	9381	jwmVKF9mZaE31BiboHypJtXWQJ1QUAARVggxqgtnUNwnq4VWVP8	6752	9543	9543	1617656940000	orphaned
13108	3NKNVH3Qhp5RCaKjHaqYvFcBmTBoZqk8pJwLbdZXUL3Krbke9oqi	13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	1508	478	191	6301	9388	jwh9LsH1cCmDB67H74B7P6u1ANsKE9D7sUCwGWBccZLYMVVVHzb	6755	9546	9546	1617657480000	canonical
13105	3NKPtCG5ULtpR2isLZbKaCziHihcEAnTu7ZkCN3VT8ui9b3xGjgp	13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	1527	1293	191	6301	9386	jwfT1QdioaEMo4Eot1XaC4UbtXCAEHqG1PdphKs9MtXy11GQ155	6755	9546	9546	1617657480000	orphaned
13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	13108	3NKNVH3Qhp5RCaKjHaqYvFcBmTBoZqk8pJwLbdZXUL3Krbke9oqi	563	1359	191	6301	9389	jxvSLTapXr7efwFWWrUQCU5bCvhRrAjzKqxhNNKkkJFH7Pi5y8w	6756	9548	9548	1617657840000	canonical
13112	3NLYGybyoJXLN1io72J9hVq8KbWWeZMm6Syyu76zadN8FaVxcKxX	13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	303	303	191	6301	9392	jwJ9G3WLF4Zi41DxtWsb7dUbD4vndZsZg22JRd1946nvDkRUNKE	6757	9550	9550	1617658200000	canonical
13110	3NK9GTJFCh4SxDoUKW5UCxQR4Yz5ApveUg9MDBZrAZwvGGDK7jyR	13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	1402	874	191	6301	9390	jxtNVUUebRt3pxxBDgQ9CMd3GVjHJ2R93dPUACG7GWGELQDmRMy	6757	9550	9550	1617658200000	orphaned
13116	3NKLS2B3PjVTEpd7YaxM8UafyTxfWgiYC4oaWLvznuW1zWXSxzJv	13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	1579	1389	192	6301	9395	jwdUL2VQcAS1yRJbz7Fq1PnC3mTksqAfFbhZkw2z1ceFCpdfuro	6759	9552	9552	1617658560000	canonical
13114	3NLgWVXf9wBHi2tmYQQEj3KQKAs2MnYFzKrLGiQ65uho5mx3kec5	13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	1619	1149	191	6301	9394	jwjT2YKR7b4jyt7nHwe4vdtkES9V2UEQ1ACdGKG8qcZaNiX1Dq8	6759	9552	9552	1617658560000	orphaned
13115	3NKLUshKEjPcEwrLuBgvZRXtYf2iMeaxt6f3HKvciSDZswfs2tH8	13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	1619	1149	192	6301	9394	jwi9tm4KtZSwAr7boYZFLjQQfDKXUNhkQ2frUf2MPJkFjuGstxk	6759	9552	9552	1617658560000	orphaned
13117	3NKVeCgPStehTzcjb3KhcoJKdN9fzTLfwhZGw8DSyQaX99kgaaN8	13116	3NKLS2B3PjVTEpd7YaxM8UafyTxfWgiYC4oaWLvznuW1zWXSxzJv	1406	1393	192	6301	9396	jwNVRZefUKjFe6SjK9N5hWTnrAsZamH1FK64FiUzdCK4whTiAm2	6760	9553	9553	1617658740000	canonical
13123	3NKh688ijS6sKHFTu4YBDtkNFrF82mgztme9RXhEJUnAJi2dgsno	13122	3NK9TKC2sPxFa9Yud1UAmgNyYoHDGYo4fBs12BZVurq45JYbQ1Fh	1518	788	192	6301	9402	jwhDX5P4ekmzK7Pt3pwbDZFRYoeBhH3efnns44PaYFiy6e9cqzx	6765	9561	9561	1617660180000	canonical
15877	3NLHSHV6WRK4kH4Mzoy9K8LqS6vZsznAc195mA2XgXsJ262jtb2x	15294	3NKDtAU34AMHYQJjWRdaQf6Zrsn81GbKJziTxdQ6NKp645EZ9gek	1407	1395	244	6301	11871	jwh7TVvKhUZEZNaVUuDhpSrcwSFskxshkSBVgwRpccWfka1WV9G	7795	11439	11439	1617998220000	orphaned
13040	3NLR1rL1xgVR8M4DvUSWnFNbdCepNAJEvWppzq2UTuCTf4k82nbp	13038	3NKGM7pqzuay5ZPWzh336GsaSzWbwnNYUMJb9Ht9WoMSWecZK3yJ	1546	1339	190	6301	9325	jwQ9aXokDcVZL6i9THTucsPHmsGXTZZ4auJbkGp3e9cgbhph9Zk	6723	9508	9508	1617650640000	orphaned
13045	3NLjihs4uSUxVLLPrxrUMwmweYeQby12h9vAohVzAYAT98qm3aVL	13044	3NKhuNhwFnuPwtMEjUUpgkzrrG2bPwvu9DyGmLohBP4MGL93gPwt	1507	1280	190	6301	9330	jwSohW5FtBVfbPe3hTtVFEUy6qQBtP1CE7k8HZSvGeiPgqq73jK	6726	9512	9512	1617651360000	canonical
13051	3NK32ZDS299H7guFjv8uUwbQh9KekmK34hhCYQmwVLdpMedfKzes	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1547	1012	190	6301	9336	jxMjQ92DpruVsj8jMsqokJrZ7fHpZJ8mwdYVc1L29Dpne9H6WjB	6728	9514	9514	1617651720000	orphaned
13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	13053	3NKbq2JRAr9WySv9VNXxGxq1yCXs9miZuxGETFWsa6nDc4n68JzY	1407	1395	190	6301	9339	jxeArqnYkH1dDQW8UDZovCX234EeB2nLns6d3srhJnKrBnzQyM6	6730	9516	9516	1617652080000	canonical
13060	3NKBvPtjcoTixnWUGgrmRmA2S4oviv3KF4nS7EZhk1YnXbWgx7Sq	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1637	816	190	6301	9343	jwwxQ4BrrDPtpajFyNR4efsdDnMbFKmWt6Uk2eruqEEZsdYt58b	6732	9519	9519	1617652620000	canonical
13057	3NKMQy9ViAieDs5uVgp1N4XmkmT1sZE9wimw4iZgWB8h5oTSf1CL	13055	3NK5196FCsvDbQscnHz7CWEeCKcAzmtNeth853bijsqTWowV8GYL	1523	1075	190	6301	9342	jxZdktCmsv1yhBYBE9mLmpDQDmku6wJPejcafXc21fphLjaw4xC	6732	9519	9519	1617652620000	orphaned
13061	3NLmhkN2Pg2df3tgpBqcb4vAEz25svkjtAtuUtfmoAdY8uZmZeKy	13060	3NKBvPtjcoTixnWUGgrmRmA2S4oviv3KF4nS7EZhk1YnXbWgx7Sq	1489	1380	190	6301	9344	jxHp6GwqRoBHRMbUwT89dMNn4Fj4RZrie4xRhPzm7jHNeCWLzoR	6733	9520	9520	1617652800000	canonical
13064	3NLMBoyE9sbPxuv1fC4aAMgWjZKyDv8YMox3FhaWMybV3cCRRJ2B	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	1474	1329	190	6301	9347	jwKzyJ6wf6yw5TL2Bs9thfGrA78mc1tXavusKFsjwDMTyeWokqy	6735	9523	9523	1617653340000	orphaned
13074	3NLkt8r5bpg46iPhC1g8WSJVrdps1pfsA7ebwN9Tfmc37wdY3fFm	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	606	1049	190	6301	9355	jwXadpnuJfpy625riAoXmFSNcsXMEw9L45CCw5skoonYm7F1uyK	6737	9526	9526	1617653880000	orphaned
13075	3NKtkEFsmPJTuXMQ1AMgL7sWmX8YxumwUDHvzK97WZS14dKziznw	13073	3NKWJY8PJELmXHzWUBoXAmCVJQjkL7DRgGseeYq17iYGsVyWGnfK	1406	1393	191	6301	9357	jwt1EUWnpQ1mVFbqXkKM8xdMqPrPQxNUyymHZNweRNas2uPmcq2	6738	9527	9527	1617654060000	canonical
13080	3NKEdximvsE7cpgtmifKn7tFKVGN6AWvdWP5DJ3EXi6YydBDBeY7	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1590	934	191	6301	9362	jxTshS8oKd7wGYrrGdLbvLXENokkpGRGmWgbCCZiTrNPw8D38Bh	6740	9529	9529	1617654420000	orphaned
13091	3NL25t4iZVda7QmJDPRRwjTfJgyM6eBMwjsyxfRcrcb6vTPYfmvf	13089	3NKTxhp44B17QMwk3YhfeWayR5iBC6G4PDNz8QnRELSrpj7C3W9c	1407	1395	191	6301	9372	jy33fD9T71zaZxS8GyjWBQL9FQsy27WRLFKcrHjPHRDzmGrF6FX	6745	9535	9535	1617655500000	canonical
13097	3NLBg8MdYM9siUoc8HE7dgpEbAiex1f5FfKm2UxoKxk6aLr9DKQ5	13095	3NKJKSwLsi62EmdQNgASxHd5Jrc2Kivc8VtiWFRPXurWmrHJHPVm	1405	867	191	6301	9378	jwqUXfKuR4U7vPDz2v6ZJanWfqWDurmzPSqrmEshm7wDii9eo4R	6750	9541	9541	1617656580000	orphaned
13103	3NKUY95jQwVkj8on8g5U93oVTiPV5NLWKeV6H83NXyGXVVwrovzB	13102	3NKuEux8fTKzUeyCbwzcUKZpVda6nDEpsH1AwSbwbQ6v79XxgQyH	171	1248	191	6301	9384	jxopDsCwE9PX1gnYQoXNiMAvNCUqWx5QogLkrSJ38M16sJXcG4f	6753	9544	9544	1617657120000	canonical
13111	3NLQpgbQxJh1K7TkHRwhW79o1pSD1XMGoqdweD1gESQDJvLca4e9	13109	3NKLfV6qyANuPBjQSnKYJZSww2TRdetqsh7qVQxxPiiXkBiarJC3	1407	1395	191	6301	9391	jx2MYp7VYt1Jxcv8mYWQ2inZjpgHndVgDbygvXCyYWZmGGvnizr	6757	9550	9550	1617658200000	orphaned
13113	3NKEvTZoVD5RaNH1yhfKDCtoiWb4wWmz5YpuVLdAEgAVSoo75Q2i	13112	3NLYGybyoJXLN1io72J9hVq8KbWWeZMm6Syyu76zadN8FaVxcKxX	1481	790	191	6301	9393	jxpk5aR1unmSh3XwKJ8tx5FE8aTNnnS9btJRMQ9QQrKCWkKbV4Z	6758	9551	9551	1617658380000	canonical
13118	3NL7xU9ANh9AbevD5ueBn97sDyemKeaPoQM2cY1VP3gAm2ZgsLLk	13117	3NKVeCgPStehTzcjb3KhcoJKdN9fzTLfwhZGw8DSyQaX99kgaaN8	389	389	192	6301	9397	jxi5xpDdRwedNsWEi2qkeqvo1hau7AYWnw43BY4LnisW3FtB3Ma	6761	9555	9555	1617659100000	canonical
13120	3NLS4aKQkhJZR95yXgnZDjqwLBCSxFHxsMStWvdvMdsyos43bCY5	13118	3NL7xU9ANh9AbevD5ueBn97sDyemKeaPoQM2cY1VP3gAm2ZgsLLk	1642	1001	192	6301	9399	jwNrkKGKEfKMNh2WE6uZf9udzS41JhHmaCZyynvoz5BDeLPtxcY	6762	9556	9556	1617659280000	canonical
13121	3NLV9aDPVveFdCQg8FHBXcTPoK2ux3eLrGqrPS52BaNWyPSxmqVg	13120	3NLS4aKQkhJZR95yXgnZDjqwLBCSxFHxsMStWvdvMdsyos43bCY5	1420	403	192	6301	9400	jwidJKxuNrS1gSUPN8j57vxd8mkbMhjSikxY5xWpUYfoR6VuPDG	6763	9559	9559	1617659820000	canonical
13127	3NLZQ29z2ivxbVioEBTwcmC2xdxn4RRwPmxFnsuPU3AWNc3AGNM4	13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	1507	914	192	6301	9406	jxNsAHh4JBvzoJequN2VVHnFXBxw6B9py8npet2hoG3Kp4tJ6MA	6767	9565	9565	1617660900000	canonical
13129	3NLeSm2BadX7EWzK9fFGJHrzh9PHQpinCpqCZFc5hfeNThBeKfeq	13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	1553	776	192	6301	9408	jxcb9mkgEZYpQCtdNccEsGyFgzrg1Say5wVSFehT2vatcPpb7LY	6767	9565	9565	1617660900000	orphaned
13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	13132	3NKf7iiAsCFVcf64fhEPKHaGNg8ArEKkoCsBCZKpixqdNJ4vFkRw	1581	778	192	6301	9413	jx65mraUxsdFq7ru9PASaSRmNPMyRRjcGHarmRk8yEqH8co1Vbp	6770	9573	9573	1617662340000	canonical
13139	3NKtJ8aE92pjRLvRdPLfNgoPz8oygbY5n1Pb1HfvHfrMDnqrgYhX	13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	632	1382	192	6301	9418	jwk1uEvKcvwU6JsRFWLg161kS1tqds5d92tnaN6SH8zHnc79dQt	6772	9575	9575	1617662700000	orphaned
13141	3NKsv5Lxt9zHq4uA4jBt9sNEo7ciQ3x7KjuEW5SRckB8SkEokTiM	13140	3NLa8UWbEsQSYB2VRwnhiFAJQAU7i4buZZ2DoGgxi814pmopeaXb	1652	1069	192	6301	9420	jxMMAMdxsFXRCMV4tXT7ko6nM6M5HBdCnZLx3qrtKGdzHZBHrVU	6773	9577	9577	1617663060000	orphaned
13143	3NLJ7WwPvREqoPvEjcvXoe8TgXTH2FyA54tXjEgty65SMdh9mfkT	13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	1405	867	193	6301	9421	jx2ZqJZXzWFdRsVAGe98zwg4M3UeACH7ARhs4AGgZZVjWvoAMKG	6774	9578	9578	1617663240000	orphaned
13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	13145	3NLRriuDDWa9ybPXwDDF8KHS3L4zuGZLkdKWEAYHi8D1K5vX4RRB	1553	776	193	6301	9424	jxXnpa23KAfqao9r3EA5MVLVy1hcBNGRQFxKz4tNxVh8kSzH59w	6775	9584	9584	1617664320000	canonical
13149	3NLw8ct3XdLgqPReVW9nEdiscpRqwB4iVJkgS7p9whTsjp3P1ZtF	13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	1553	776	193	6301	9426	jwe2XxkUwaWDestaEQD2Ae7ard5Ck7CLDcr6XAokHSHqdsHMc1k	6776	9585	9585	1617664500000	canonical
13152	3NLT1Szkwpkv9NSnLoFdE9mEEcZ7JFAuEfPzmuKwF1CE8W45qyoi	13149	3NLw8ct3XdLgqPReVW9nEdiscpRqwB4iVJkgS7p9whTsjp3P1ZtF	298	1182	193	6301	9429	jxcDYdELgDLG3CGBicquzXxaQAJKcBheebAB9cq9zeP7EnJCMXH	6777	9586	9586	1617664680000	orphaned
13156	3NL1qWPyLTNmmjZqK6e3j3WpogCJYkFVJst9rHuqe7kSnRNFqxTd	13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	1483	1276	193	6301	9433	jwhJK9wLgnkkuAe3MLJMGQ7tbbVHoARGDwz38VxrBaFUGweRu6y	6779	9589	9589	1617665220000	orphaned
15299	3NLfAzDgJFt6e6GUMFBWgELtJWWZ2niaaUuZgZLxknJwpCqekNAL	15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	1534	1317	244	6301	11345	jwCyebHKbuTsoRFKCAx8xCQYgky1zxqz1ZqqNVzBFQFb9EHoMjk	7796	11030	11030	1617924600000	orphaned
13065	3NLGaqsR7Qui5Pke24dPHhvqsqA4n3BHsyaARKZ9HZ73YboJPrem	13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	1581	777	190	6301	9348	jxHYC4BpMP9sgCRt3C2b1nbV4HA823m6Jm2LByUzwjqFXr2MRVJ	6735	9523	9523	1617653340000	orphaned
13070	3NLBdsEg1q8oF4qj3CCtEr6YY7U73SffQtVKTZfwS9Khtd3YaHsC	13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	1654	1094	190	6301	9353	jxFxidZYPDBVGDtBxzWyCuBcHeuuuVeGVWFvFr4yUVYqmqsPFMU	6736	9525	9525	1617653700000	orphaned
13071	3NKwRoBQUtxLzkPVz8jn1RKVb2Rku5ZfjLXwbuxXmT3Q5E4oiFdh	13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	1419	814	190	6301	9354	jxRazDmdyB1hdaW2urTZEr4r8vaiwgUX1cH5mJegkL6inLMDdcw	6737	9526	9526	1617653880000	orphaned
13078	3NLd7bZgNRT3utrtPpb3XkMCzVPQ5xiL6Mj6jg95atEQYprhS9CB	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1577	1201	191	6301	9360	jw8K29zJgrGhaQjm2g5gBM3C3LTDjmmzr6WuGX7Zc31Ws16mUNR	6740	9529	9529	1617654420000	orphaned
13086	3NK42Q8sogk48iAPZ7xMNNzxQjuqrauP8tAgqb2oCU5XqENYAUDQ	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	1541	1298	191	6301	9367	jxi5ykhvFzM6SuQg9DnAqaLmLCumgBaoofTLaaMbi6Q3LbDbnSn	6741	9530	9530	1617654600000	canonical
13082	3NKHcCnyaQ7Xr1A3pp6YaxoZoqYc8hC9TDLuMBW7pFFjbP48L5mN	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	1460	1078	191	6301	9364	jxt8eeAT53uGzG4VeXq9uZG1XjeAgxd3mQBUPSxnJ7PtCaPg5EV	6741	9530	9530	1617654600000	orphaned
13085	3NKKZpkxGmTHHQmYBWcJg3iiRF8d6cbPBRxcYRxU1bf5QHcCPNtR	13079	3NL3BPmiGhG4bMMyJqbV6gAPj79kDsDfVNN279cgoa7GJMTPfXn3	532	937	191	6301	9366	jwQYy3ubVWscBS2WUvCry5KDeygdAgiyF8GtWuMRbw56AbXaiCA	6741	9530	9530	1617654600000	orphaned
13089	3NKTxhp44B17QMwk3YhfeWayR5iBC6G4PDNz8QnRELSrpj7C3W9c	13088	3NLH375k9mA49G9LYHxjZSHzpyYBPEvux7rjNmjPqGtYYZzmveWu	1497	654	191	6301	9370	jwS8pCX2uS5pTt6apA6DWApuxkAB5HnKPEjSf4nDhfS3VCbMpAe	6744	9534	9534	1617655320000	canonical
13094	3NLFUZfFzAv5Z1HupSLGoC7Q2MVtzBGu3GAGZZX2zopusx8f8TSf	13093	3NLFMLZEWUtvko2p8XeLfRxd5FaSVJC4VxCAR4p8mQsaA8Epgq3t	1596	1363	191	6301	9375	jx5HY3KCkrRngUqnAujfj7umxxBSrdNytTgThemMta3DxxrRSXD	6748	9538	9538	1617656040000	canonical
13102	3NKuEux8fTKzUeyCbwzcUKZpVda6nDEpsH1AwSbwbQ6v79XxgQyH	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1403	40	191	6301	9383	jwXtvgYqmBiSdsWC1WPC7pJY5hmJKUq8F6J4RGznqX5BzJYx78i	6752	9543	9543	1617656940000	canonical
13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	13103	3NKUY95jQwVkj8on8g5U93oVTiPV5NLWKeV6H83NXyGXVVwrovzB	1649	1257	191	6301	9385	jwGdhiW3S3zVnTUfxcQs8qqqm3g4TYxdc8mrAwEiQ3pEvqNJbhN	6754	9545	9545	1617657300000	canonical
13107	3NL9h3xkswwYwbfXazLckLhhUBKC49k7x6i1qZxmNBGQrkbYMqq5	13104	3NLFhriLY9pJ9aPcRLDzAfJKzhGNX7b2XQSXp5kfYfztn8XYsvsQ	1527	1293	191	6301	9386	jwmGCAwpUTSLgu8TMnNTB3w4fHLWwqDBevbXHVGuKRAsszQASWH	6755	9546	9546	1617657480000	orphaned
13119	3NKiLxjbcsLwzGfutv88NGHJfCssr24qCE3kAgUmJ1F31Nb3q7qN	13117	3NKVeCgPStehTzcjb3KhcoJKdN9fzTLfwhZGw8DSyQaX99kgaaN8	1610	1188	192	6301	9398	jwwHeexjyaG3Ecafyn4UoeMvx9PniV5gzSybMmDB2Ns9TrYHHGc	6761	9555	9555	1617659100000	orphaned
13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	13123	3NKh688ijS6sKHFTu4YBDtkNFrF82mgztme9RXhEJUnAJi2dgsno	1642	1367	192	6301	9403	jwP58rTwbDyBGasCAEMrY7c85wnXpdvHsPbrJ34E6ShW8xEFFpS	6766	9562	9562	1617660360000	canonical
13128	3NLBw8Kdr7SAxY8wDxob7rYQNwpKeBRNA7nz4sb41tgLLXcjfdCn	13124	3NLLJimQ68E8SxyK8WsLvainsmKSty9niain4aGSnXsWKbX22Leb	1405	851	192	6301	9407	jwQiF8SnLwVXzcoLVEMKvSeDCGsaxdrwJS5x3j3Krqa5mdbwsei	6767	9565	9565	1617660900000	orphaned
13132	3NKf7iiAsCFVcf64fhEPKHaGNg8ArEKkoCsBCZKpixqdNJ4vFkRw	13130	3NKieB1T2x1BCh4TSbcJfGmJCFLnTFnY2QRgYf5YqhjzT7Gq9Zn1	1513	1379	192	6301	9411	jxDrcg9T15TrkcF4FUS2zXVcLUfMcerXKTPwuNeWSMkm1VZjZzt	6769	9572	9572	1617662160000	canonical
13133	3NKMhvtx4KUKeMeEVCU661NcJYC1FRQdScJ9n7Mmk7TmhURefMxM	13132	3NKf7iiAsCFVcf64fhEPKHaGNg8ArEKkoCsBCZKpixqdNJ4vFkRw	1527	1293	192	6301	9412	jwn7z3NG2VGWvvsYRxFmRS1BTuBt7QLDV2pQgXG6oJJiZdmP49Z	6770	9573	9573	1617662340000	orphaned
13137	3NKykzkjLprQs8C2Ckv9aFsmm2fdTmKg21H9tvabvodhTuaffW95	13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	1407	1395	192	6301	9416	jxob66BQ8qPySwTi2PWMutuyg6ZKGkyLa78CcLnf1drf3SLCiwY	6771	9574	9574	1617662520000	orphaned
13140	3NLa8UWbEsQSYB2VRwnhiFAJQAU7i4buZZ2DoGgxi814pmopeaXb	13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	1637	816	192	6301	9419	jxLVhthZpm94m6EDKTvyn83S5Y4yKCCBUETdV5WqZ3NGcRAy61C	6772	9575	9575	1617662700000	canonical
13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	13140	3NLa8UWbEsQSYB2VRwnhiFAJQAU7i4buZZ2DoGgxi814pmopeaXb	1652	1069	192	6301	9420	jxMMAMdxsFXRCMV4tXT7ko6nM6M5HBdCnZLx3qrtKGdzHZBHrVU	6773	9577	9577	1617663060000	canonical
13144	3NLYtNG4eosnMDmt4iYp8FKD7imVnYLT1LMBMCKSPS6LerkFYEvM	13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	1577	1081	192	6301	9422	jwQBLSUejZ4kMdEkgyJTZWyFsL5ATkfybAnkyhViiu3rRKNEjDv	6774	9578	9578	1617663240000	orphaned
13148	3NK91zKPwhy3dbohW5QLfbuRYbxvH2fVdXRaYUuN6nMS1PN4BV9z	13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	1581	777	193	6301	9425	jxPg943mzG3ZVxo2UUBn73Y8aDKCHmKaZqdNRv17vJYiFnsgFb3	6776	9585	9585	1617664500000	orphaned
13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	13149	3NLw8ct3XdLgqPReVW9nEdiscpRqwB4iVJkgS7p9whTsjp3P1ZtF	1587	1111	193	6301	9427	jw7wVEytvbmCNzpz4TQRrWXhJJVLFViRUncuwsCqhrJv32U2pd2	6777	9586	9586	1617664680000	canonical
13153	3NLJXvF7Z8J3vkZawufNnyb3ahhxksdrx34th4kYf6kM4jiinZpF	13148	3NK91zKPwhy3dbohW5QLfbuRYbxvH2fVdXRaYUuN6nMS1PN4BV9z	298	1182	193	6301	9430	jwioYuNWWyvRKpVv6k5tegvyMwyx1EGdjSwih3fr86fE4kHSpHr	6777	9586	9586	1617664680000	orphaned
13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	1402	852	193	6301	9431	jxsd1TXBWcFQarLDUdiw8mEBREqaFv96F5BxbhDDkKmQsno25zc	6778	9588	9588	1617665040000	canonical
13155	3NKAtE4AcAcRjy6odXxfctn44KUsMSAh9eNcSWz1iqApgYxH33vk	13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	1407	1395	193	6301	9432	jxrqAGkAc2GMDqTTdjp42LMyAskQLMzavc6hMp51vMmvfdPtBUY	6778	9588	9588	1617665040000	orphaned
13157	3NLrm1wYzQoipL59nyuhLwtvYU6LPa9TL7z6mQ5QynPVTFfHupPt	13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	1507	1034	193	6301	9434	jxjDRFkF9FznJdvXQkDqDhh491q7kBsNi7VxuVHDPnee4bLx6gb	6779	9589	9589	1617665220000	orphaned
13164	3NKpyBCa119qefFgwMPxmsCy48NYZShKsHz4uqZxBTvwKGd7HkeA	13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	1402	874	193	6301	9440	jw9dC4NjU5HkoZVEZaf3otBn1p4XhipwcQibLRPpMRVbmosnYsb	6783	9595	9595	1617666300000	orphaned
13169	3NLUVhXgTpANqKSFxHjcvqutx8g9SHKZJEYcqpPFeayDskDMuQJC	13167	3NKThgshA9ux5zgTn6swML2obaF8Mt7sRPax1vWss1Q5SVhWc7ic	80	1027	193	6301	9445	jx86LNNBENo6FdoFgUUcc7dUkoJnJfUdmUvTCCzbRQoZXoxkhBj	6785	9597	9597	1617666660000	orphaned
15306	3NKxi9kaREwDMxw8rSDXNKGFBJnzgC68nHqRrNn1ednbD8C4nugc	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1406	1393	245	6301	11351	jxKmgQCpgpf4ZLpjD56Gxgjq2nFhFEN4X6KUNNnWfAerHJcJhT1	7798	11033	11033	1617925140000	orphaned
13122	3NK9TKC2sPxFa9Yud1UAmgNyYoHDGYo4fBs12BZVurq45JYbQ1Fh	13121	3NLV9aDPVveFdCQg8FHBXcTPoK2ux3eLrGqrPS52BaNWyPSxmqVg	1406	1393	192	6301	9401	jxSC7gPqWKqxYAjEn6trk8hTxaJuu8qQm7dmGpph4G5R6p7WqHi	6764	9560	9560	1617660000000	canonical
13125	3NLxhnA9WjJLL9ezDEx53rWwcstcE1gtwXe4NBcvpVo96iHQXpKk	13123	3NKh688ijS6sKHFTu4YBDtkNFrF82mgztme9RXhEJUnAJi2dgsno	1623	830	192	6301	9404	jxxWubAdY3SzT558u5HQ2ttAQYcsMtJKZweeFga7zQhstCPpaNg	6766	9562	9562	1617660360000	orphaned
13130	3NKieB1T2x1BCh4TSbcJfGmJCFLnTFnY2QRgYf5YqhjzT7Gq9Zn1	13127	3NLZQ29z2ivxbVioEBTwcmC2xdxn4RRwPmxFnsuPU3AWNc3AGNM4	1553	776	192	6301	9409	jwqBRyLT7zfhPknKdeYpGvCnqm3oG3m81WjGLnDvziAMRnbHsnL	6768	9567	9567	1617661260000	canonical
13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	1587	272	192	6301	9415	jxPqUkCtmjaXNA45NeusWa5VwEKLeVq2Mpa1VyaNB9gWCpWv8tC	6771	9574	9574	1617662520000	canonical
13138	3NKGtCbMicDUgzaHymSPZqyo8xZsx1C5MG98EKZ21fyJ7RYzuxci	13136	3NKUUBhCp25fQQy834yi968GzZWsx1Myov3zHaRBesvG98Uo3EMY	1406	1393	192	6301	9417	jwUru4vdH9rrPS9WGNovLRB9ZMVyysT6EsmHmKy9ZgHKQNjv1RL	6772	9575	9575	1617662700000	orphaned
13145	3NLRriuDDWa9ybPXwDDF8KHS3L4zuGZLkdKWEAYHi8D1K5vX4RRB	13142	3NLrz4NA3B1xs1jNHkiV4eaCRG5HYUKygxrTUqicTJutU3V1bD7C	1577	1081	193	6301	9422	jwQBLSUejZ4kMdEkgyJTZWyFsL5ATkfybAnkyhViiu3rRKNEjDv	6774	9578	9578	1617663240000	canonical
13146	3NLttvBj8EFBskKBd8RgVDenCpfiPMqec8uVuzRNgMyGGuT2m6Ze	13145	3NLRriuDDWa9ybPXwDDF8KHS3L4zuGZLkdKWEAYHi8D1K5vX4RRB	1407	1395	193	6301	9423	jwHquAUv6TepijwtK4ihPycSsDMe1fwEYFpfYKB97GRVgWpRnuv	6775	9584	9584	1617664320000	orphaned
13151	3NL522V1mjFAg6784AubPUgL5owzuF9RSKD3TWJMpm1WNZzTr2ay	13147	3NKzqTUxpMxcE6ppUijzBqZxXjkF2F49FaEK7vdGXaWgbcezhSBC	298	1182	193	6301	9428	jwF6EZGmEa4JmjFmQEq4zYpSb5nSfiQedCi7LEwSeESrJNGy1fj	6776	9586	9586	1617664680000	orphaned
13159	3NKDLXgnRGm9Z7mRsHCptDuKed7hcMsPguYmc7U3z7ZvJpUbVG5X	13158	3NKYxmgH7zF6qjqAxViFgNRT9uEVydEyTyLNZJyJV3GXoTXeBqYr	1506	1247	193	6301	9435	jwZWsQiKWTTDoWbaMLm4wu8RwJd7kmNcMbemM2QEB83E1VwtSRQ	6780	9590	9590	1617665400000	canonical
13161	3NLLjhskXwzz4G4Zg3nrEmR55RWDaHZdzHiiQZeS1TEEnypjBoZd	13156	3NL1qWPyLTNmmjZqK6e3j3WpogCJYkFVJst9rHuqe7kSnRNFqxTd	1553	776	193	6301	9437	jwnTQNWaHkoXd4yxogjWp56afMXFCxEu9jiakG2t6KWwgzQSPRd	6780	9590	9590	1617665400000	orphaned
13162	3NKG8FrVveA8UYAjjGPZfP5nb9eGin395jm8usuiWRzwzZUDZ45u	13159	3NKDLXgnRGm9Z7mRsHCptDuKed7hcMsPguYmc7U3z7ZvJpUbVG5X	1471	1140	193	6301	9438	jwRDFNZjXzopffsg3n5ThM8R1TVSALdNfZKKtd7ZBNFUGYfUukg	6781	9593	9593	1617665940000	canonical
13165	3NLc6MWzZDD3s6U8UQ8CdMbiMNKk8uXRRQwdVfx5t8p8ii82y9Ux	13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	1458	1323	193	6301	9441	jxa17aSd4mCrXNyvrbyCYaid2KzinA1RFybDiM8hhgHFxAxYZuG	6783	9595	9595	1617666300000	canonical
13166	3NL9YBBRJZoamB7FkzQduMF2MTWbEXzEcKe7cqWDtu2JWcFXbVdQ	13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	1671	1119	193	6301	9442	jwhqNq82pj1e2hfhcmnZsNXtb7Yr3h97qHEgeLT4VYsaWWGgxmH	6783	9595	9595	1617666300000	orphaned
13167	3NKThgshA9ux5zgTn6swML2obaF8Mt7sRPax1vWss1Q5SVhWc7ic	13165	3NLc6MWzZDD3s6U8UQ8CdMbiMNKk8uXRRQwdVfx5t8p8ii82y9Ux	1600	1246	193	6301	9443	jxECM31z69A8jeFjrJoVcJMKShvLvXBzJ8ac1uoo4Apxhdf33yP	6784	9596	9596	1617666480000	canonical
13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	13168	3NLt1LKm2NH62itzZHhJ5hRjmSYykwgCpDdvoKosFwg9x1iFFTr6	632	1382	193	6301	9447	jwHsJtaPu28RgipFoMEenPnMG8heZDvK1mJhzjdfokojxPUsju1	6786	9598	9598	1617666840000	canonical
13172	3NKdfVtt9TqUiQdrY9inhfUTbYLQdRooFS43MubQQeWmnzkxwoqq	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1602	1369	193	6301	9448	jxFUiWFyvoM3H2htSfG2B4Ec284A7vvrNjcAgpYJ19W3yrx8AqJ	6787	9599	9599	1617667020000	orphaned
13177	3NKTi716amya5mHiFcqEwB6VXSpaAqfZMdR2fxWw2e74aXq8U61s	13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	1588	1266	193	6301	9453	jx1wcNo2g7cfpEzFVXN9CHsEEDmjupYWKXgHftiAxWCfCHiN5uf	6789	9605	9605	1617668100000	canonical
13178	3NKN5P1K1nwThLE55G45MAjLfbn94dLye2jEqgZLhbLEHaiYcrhH	13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	1622	1110	193	6301	9454	jwze17MWTNjrpGHirAzoKk89EmJQaYrg18jchRwWzUtB4A6coDV	6789	9605	9605	1617668100000	orphaned
13180	3NKSHFhYrv4JwLE185MpmALuMtaNRXHf1RnHz4CcZxHXvS1DWBQd	13177	3NKTi716amya5mHiFcqEwB6VXSpaAqfZMdR2fxWw2e74aXq8U61s	576	1109	194	6301	9456	jxPqvMLp9cGrnSb6D8uQa3rUXgreR5LfVMfT6bEqS8JVz4gH7mU	6790	9608	9608	1617668640000	canonical
13182	3NLtvaGSjxvcok639mpoAE2zUbj5wNDVdWUuJdZTfvyeF9UkoqqN	13181	3NKGcTmdZY5HaXSKVoTZMNVXXPEJG5MdchVu62ZxejWG9iAsPY3J	1542	1304	194	6301	9458	jxqy7aNKJPygrggjPBpJnr8Q1P2mxCa1RW1Gif1R3qp42dGAbWJ	6792	9610	9610	1617669000000	canonical
13185	3NKGAjiufvJG8zRAPc9mLJiA9UBkduz5vapX4WgT3gfhNjEWjv1U	13182	3NLtvaGSjxvcok639mpoAE2zUbj5wNDVdWUuJdZTfvyeF9UkoqqN	1407	1395	194	6301	9461	jxhxarigN6wv8XhT6neAsMsayWaTTCMxzfLJx4FEHnV6BpXUbA7	6793	9612	9612	1617669360000	orphaned
13189	3NLAJ66fzGH8CTNWWrdSC35Qg7AuGm64tHUqqYj5iUDCvf2vUido	13188	3NLJ8io4sTj2LByWkkrhrUdRti5yzQ3ms42JzusWRLQpB1E1xRrq	1406	1393	194	6301	9465	jweJ12TQ5Nyyedb4tH7hCtHqAwRb1GavQWFz4AenM4pdmmkY6hP	6797	9620	9620	1617670800000	orphaned
13192	3NK4DGoP9KgvViuargtKGwosGUusrLBVd69Ez9bB6ohjjBRgX2u6	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	1577	1327	194	6301	9467	jwpVWK39DRBW3BfpkKPSK3Khz5bNwh9s3aK6JSapvsAemUUYXaU	6798	9621	9621	1617670980000	orphaned
13196	3NLKDLPG2oqjucuZsHq7cWkRAwi2eNNuBxErqjA85QWec6NGb61B	13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	1560	1165	194	6301	9470	jwh99AJQeZnBtgLw9ZXMKU41d1jL4W9ypVj5q2keSxV99yP1dX1	6799	9622	9622	1617671160000	orphaned
13198	3NKkJnfnWBgYZMPyqKPNyH2ahiKm1UE3xPADJbiJbK2opAUuxAZf	13197	3NKwsrZAyKuCXRGTkNfhG6RBZoaJLk7agKa71MMnQURa4Z21NtwJ	1546	1213	194	6301	9472	jxeGtxDSyw3jmV3cx9TgsnguJCu5b4Lq7PZTD4QdUGRq43Kks88	6800	9623	9623	1617671340000	canonical
13203	3NKQyaMExat1G3SetuDsdqqhCpx2aK4yjWnXBiBvivEumnFepZa7	13200	3NL8Uukkd8K98T6U9be47RCFzCC5zTyKdgzth8kfQK4ENhaiEoXo	484	1073	194	6301	9477	jxKxJLdynzQi7iDCYgfRx3U3544UtufEmA6htZtyNuPRWPkPrM4	6803	9628	9628	1617672240000	orphaned
13208	3NKELNcGjgMFp6E22j1XXLa8UKy5cWRKdXvBnLnA9k8XpPovTfkM	13207	3NLmRWWiVi19zPn9WU2GNTASGCMAS3jwFMy4n6DU9X3yex72zTGL	1481	790	194	6301	9481	jwPmisS6AY4sFhXHQsCwa92zk93KvUV4wVXKA9vX1a6pgDb5ChP	6806	9631	9631	1617672780000	canonical
13211	3NKyraYKU93pT7jMuk5K3AeoWbSXHYr383BH9DsE37ip2CEtVtyK	13209	3NKwuzvVrCh2u11Lp3xo6KNrpV4a21EF7B9UzebBuPU6exHbt833	1407	1395	194	6301	9484	jx5VwsM8DZYqbtoyfNtry5Js81zwYXyyTDPbLt1SHoMYDFEb51D	6808	9634	9634	1617673320000	canonical
13216	3NLYPPZFz8PZumVBc9L8jVDLDhQyqLyAQrGH8sHmZbs5cWVfNUT7	13215	3NKF1sLbGrS5KMpJ4HwsjHHjNiHU7f6fFnmz2iLxMnhFuoqwbDFy	1542	1304	195	6301	9489	jxiuieqiDJY2g9BGjf3zwL4DUJ3ZVWysxRkFsNwYnqrdjGtZWnC	6812	9639	9639	1617674220000	canonical
15314	3NKi69QMXyCrmViawpT1PMcdqXAvSTpdar3YSptQSuPnmAQJSq5P	15311	3NL41Y645XbxFatAh6jMf4q1gMYABg5JeimCp4UedMY568f5KBfM	1648	1284	245	6301	11359	jxoSWKsHDk8UryqHgjLfXUmSRgq8x7sm2WMe2K7q6o1KskNA76g	7802	11037	11037	1617925860000	canonical
13226	3NKqWAjraKRYDuyykDJCT6T1kudRttNTpsMFrMXmhNkKNczFVBaY	13150	3NKQ6PzAkqY8bWfLG8WVNCM4MkjYWWtW8UtgGUPyyNVjdvXU6T6c	1610	1314	193	6301	9498	jxZT46J2aEdb73aB5AomWMH5KQY7UsHCSAL77jDg4pD1CmeFu5m	6778	9643	9643	1617674940000	orphaned
13168	3NLt1LKm2NH62itzZHhJ5hRjmSYykwgCpDdvoKosFwg9x1iFFTr6	13167	3NKThgshA9ux5zgTn6swML2obaF8Mt7sRPax1vWss1Q5SVhWc7ic	1460	612	193	6301	9444	jwNkV2PD5vLV9hnYerD7Ldzk1kVKtWedFicbLGCXdkf98t8pvFe	6785	9597	9597	1617666660000	canonical
13173	3NLd314XFewtMzs1yeFLc5eCTemz4AjTeiUSbWE9ripb7c1933Mk	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1397	838	193	6301	9449	jwbF9oep7gywXpuy4sn8yqAgG6YRRCKErocdao93zc4oX9Uxa33	6787	9599	9599	1617667020000	orphaned
13175	3NKb8YvEBhrvEwTidzeYxjv14ftGKuz75KPWVyBMfLVKFnA9frE5	13174	3NL5XDvnVQNE1iZYzc3nU8RxVmNHwr7FVEKjVJREZYLoSvU7Jikk	1403	786	193	6301	9451	jxd4GAhR7dUdUQLa7HhR1xLmMZdG7vPXpfyDyvTmZPQgp2t6Jtv	6788	9602	9602	1617667560000	orphaned
13179	3NLDXYmu4WHuVGwwBRbgdJqDsNg1kQoAKjJG6DA7prebB44sFKUH	13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	633	1384	193	6301	9455	jwzGsRjHYvCopXbf6p2pA93mdZsLEs4Vicbmg9td1yiHxmyCbG1	6789	9605	9605	1617668100000	orphaned
13181	3NKGcTmdZY5HaXSKVoTZMNVXXPEJG5MdchVu62ZxejWG9iAsPY3J	13180	3NKSHFhYrv4JwLE185MpmALuMtaNRXHf1RnHz4CcZxHXvS1DWBQd	1407	1395	194	6301	9457	jxYWzzqmhTMYm5y1AJZEbgBNjf2cZ8p6bk1ubUqXeSjWXURGNgB	6791	9609	9609	1617668820000	canonical
13186	3NKgbeajxdPUsZaSDWuQXt8dPoEyFusc8EmNypirK5bS1xijUWgS	13184	3NK3e1z4xPrKGcp5eyBRiqiFdbLvFczhwXHypYdHRnTP5pFCKYsW	1407	1395	194	6301	9462	jxz1Wh4wTZF5mTKQfzRWjDXqrK9RzthcaF572NpHrxGSkB6BDbH	6794	9614	9614	1617669720000	canonical
13193	3NKSeNyBCjaQxKKpCv6fkqhczk3WzFhUinMKK6PQsP1iU1XfCTN8	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	484	1193	194	6301	9468	jwfzDeeFWRBedymAhSPaT3CP1AtaB4E3EnXQLFFTRK9YCLLZ261	6798	9621	9621	1617670980000	orphaned
13204	3NLFFpKdVKrfMxVXWXxdB7wv4ynzq3xjjjf5NLf8M5xLDb6DzMUT	13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	1461	1271	194	6301	9478	jx2jyiCai3JMh227ZuJm3CnzMSMsMBVoTSmGJ1vb3d1zPtUygas	6804	9629	9629	1617672420000	canonical
13214	3NK9P8KFt3nZzBgaGa78SH696zWydUWiKQ7mypR7KtyPqaG5jmGc	13212	3NKd7s9fKTbwBMtbma3YjYBZtbpCqpSViW4ByMnVbXoVKuwVAg32	1581	778	195	6301	9487	jxMR4g9c9KuQvUBCbyG6YMjxzEQJWvWjd6dvPuaUvV4AMuykvpT	6810	9637	9637	1617673860000	canonical
13219	3NLfzVuegQUDhnpCZrmuinsYd2DmBm9n2Kh7tFdt4DFan8x8Eh4f	13216	3NLYPPZFz8PZumVBc9L8jVDLDhQyqLyAQrGH8sHmZbs5cWVfNUT7	1407	1395	195	6301	9492	jxFmxzvMByAVdJSviCAuetgvXZAEJBbj8WkEPtb2YgF7HuC9sie	6813	9641	9641	1617674580000	canonical
13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	13219	3NLfzVuegQUDhnpCZrmuinsYd2DmBm9n2Kh7tFdt4DFan8x8Eh4f	1549	1362	195	6301	9494	jxodKzV8hEvEd4XGLR37mRT82B5hh3RMjrdP9iwprSiHnmqnX9e	6814	9642	9642	1617674760000	canonical
13224	3NLQMwQC2pyBCCoZgx7giHEWJT5x3xnwZsxcNdXBBkHLN3Rmweua	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	1610	1314	195	6301	9497	jwzszpyy5TJmwQswhJN9rRDGwrJx6XMSWDCtGH7nGpBLC3LoBVR	6815	9643	9643	1617674940000	orphaned
13228	3NKppaVfX176R1GM8VBJ9RqvLFrsYAwZSqtrqoHiczmu5EofJiEq	13224	3NLQMwQC2pyBCCoZgx7giHEWJT5x3xnwZsxcNdXBBkHLN3Rmweua	1457	1265	195	6301	9500	jwzb7mozcMHpLTdVJVvDaMEPXyoJfPzNG16ScgHJnL7nrqxKfhw	6816	9645	9645	1617675300000	orphaned
13230	3NKc9yhsjCuHC8vzPeEpv69a7D2Q5vgUahA46Xn3cpu6sRHHNn1P	13227	3NKeksNaEC7NWcVSAm2ayFPnW9pKbdXrfSgsBVxyLGVHpVP7HYt3	1573	1072	195	6301	9502	jxGv9Y6TGKG3JsVaM4EEjbtEVu4GvBotu4APqJxZTaj1eqK5DGA	6817	9645	9645	1617675365015	canonical
13233	3NKBXL28qg5mZEsqFXzxs6YwMDAg9cQYq1aKH7FgzQUV52EwnnDu	13228	3NKppaVfX176R1GM8VBJ9RqvLFrsYAwZSqtrqoHiczmu5EofJiEq	1542	1178	195	6301	9505	jxzzAPBo52b2MvZUYTWhzW5cr2VsekcDoRFVcdnTg1SzYKHd6AA	6817	9646	9646	1617675480000	orphaned
13237	3NLDS4zxNjYxgmQW9bRmdhGzRU7xP3CueLUeV4NKdsi3So7wcKim	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	58	1035	195	6301	9507	jwCc9KPfcX1k9fvuXjUyKCbusbKqbup3XfCrxyASrMtgQsMSaKQ	6819	9647	9647	1617675660000	orphaned
13240	3NL6DvLcwiFBHvPnbxxgdyZZSsvK4Gu92YCteEzCddjmnxsEYdzL	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	1555	1221	195	6301	9510	jxT7kbUBDMHUqiSpsBpnhw24zNY4t7d84fezuLi9B2rU8uiyfCq	6819	9647	9647	1617675660000	orphaned
13241	3NLRYon6BtD5otZ8a7oN8J3rwKSzLx3v1AaA7HAiXiHT4QXtwVoZ	13239	3NKqS2BETkHvTLSRHdXSV26uyhzW22eScZrZSek6rtqTJccqmpCs	1457	1145	195	6301	9511	jwoehE5a6DFyqivK1V31A2SQxXnoHCB7p1asuvvxq3LF8L2GcgW	6820	9648	9648	1617675840000	canonical
13243	3NL4mdw9Jk5hGJohvLKSAPbX4ijsgQ7sMnYoh96P9nGynPc3xHrx	13241	3NLRYon6BtD5otZ8a7oN8J3rwKSzLx3v1AaA7HAiXiHT4QXtwVoZ	1471	1386	195	6301	9513	jw7wDgZ7a9uQ1JWzNt4RDi3cnJpzxhbWcMgrWVFQHLbJ3UsJ8r1	6821	9649	9649	1617676020000	orphaned
13245	3NLdauunvauzNKYsMYhTmoMC88deFAvh42BTT9DcBemMPTQPHH83	13244	3NKR8xQQ3VPYvgB2PcCxHuA1cP7Gab2P8EBZHrNEfuMryfcVtwSR	1506	1247	195	6301	9515	jwLhZ7FFHGokcy3chdSZegXAxh9HRD5BBJ7KpQbjrhz2oPnhYzM	6822	9650	9650	1617676200000	orphaned
13247	3NLixJuyn8arbx7YKRnfy2fGuGrZTVW3dFhWuZjEHPYTZ5SnSPqJ	13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	44	1199	195	6301	9517	jwt5aN5zvUWEpywwZvmHRngS5BXJBGGLmzF6nqnebpsNHci6Yts	6823	9651	9651	1617676380000	canonical
13248	3NLhSgkd6Tmr64AgPsifNU6akWFvDWhhgQeKsZusmBLLhFJ3FhZd	13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	44	1199	195	6301	9517	jxTq6M49J26pEZGCMrdmdE9sQB8NidnHRCfL4KWj7h9qvGtMZ7K	6823	9651	9651	1617676380000	orphaned
13252	3NLCw96ajfZVUoQKW6VGQj9EMdmUZJthvdA3zUW3gGskzvFHrPbe	13251	3NK4txS45Dje5Qq2xQMs8CLA2YjdwWHE2vKmKb8BrGTirC18Fd41	1581	778	195	6301	9521	jwVQWzfzJXYSxpCW7bn4HSVYg5i6EFf7tbQKYHGbaU4WrbD4oVS	6826	9654	9654	1617676920000	canonical
13254	3NLaxcNk89jMPjPh4f9hby3upmnhHkPD27UEsFxruzPga2ZRkyXQ	13252	3NLCw96ajfZVUoQKW6VGQj9EMdmUZJthvdA3zUW3gGskzvFHrPbe	1471	1386	195	6301	9523	jwAxpVGc1tsgunBAp38gkkk3eQtYqt1HMy5PVM1akU2w36S2bDu	6827	9656	9656	1617677280000	canonical
13255	3NKxveJeQNoUUH5zz6sktjgvuCJL1qAtkc1px7LG6rmKdMr96pUJ	13252	3NLCw96ajfZVUoQKW6VGQj9EMdmUZJthvdA3zUW3gGskzvFHrPbe	1407	1395	195	6301	9524	jxYsC65xcUbE2gZx9MX6b3TeFCoyVP25e1Z6pZ6N1ntorfNB6Rp	6827	9656	9656	1617677280000	orphaned
13257	3NKiFnphbZPyWCYdXMXXNfeT3UyiwZbuyEB4m3ZYzyv8x1bTBy1x	13256	3NLHxWbokotWZcYWBpySLSEdHNfT2mhuZ6miQ5W2DiFB5CU6vLoW	1451	1292	195	6301	9526	jwgnTbF2S7d9fARKAyAsrPruQc12aQpf8TVH6uVLhbVWNXhdzup	6829	9659	9659	1617677820000	orphaned
13259	3NK3HACXe5HPbnQdjm8Loy8p5HQvRjWgVSZFsRRJBteUZ1fTdKK2	13258	3NKRxJhBokT1m4WscsApDiPFALvPkVBQSonawMBoofqajT18Rq7r	1623	830	195	6301	9527	jxurtGYsWVtKkt8iZXdr6XjCYDL8dmoGPwMY5cScmp3Wjo8n8Es	6830	9660	9660	1617678000000	canonical
13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	13260	3NK7fAbXKUYA3pJt1MbdwcSYHLLY5XsGkyxH9qxUVL9LzpJNZEgL	1407	1395	196	6301	9530	jwpj66pcqATkMSovmEqYNKw2A1YttxaKikSqZbN5XeCbfvhe6w6	6832	9663	9663	1617678540000	canonical
15332	3NLmWxBoNjUfGeKSpeMPv9o9BFqivM19esiMsdKJ3eQJFt4Mme2i	15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	1448	945	245	6301	11375	jxMtGCCvSEiLrpXJsZjx91pWSHVsxeKwtYTaHtg9X3yQ3pzYDm2	7814	11053	11053	1617928740000	orphaned
13234	3NLwF1hJSSVsaEHg7P5VPsSLxBaZ8coDvoZSrdUX6uo9B4GneSET	13217	3NLLvYR94XtKs9kbnrC47dNEZjw3rBxRDJfQ2WqdiT9WW3MwbaTk	1542	1178	193	6301	9506	jx6qwVS1EJ678SQaJA8W8u7ZSaWg14FGZHNauvXjwi4DXNjAzsy	6760	9646	9646	1617675480000	orphaned
13174	3NL5XDvnVQNE1iZYzc3nU8RxVmNHwr7FVEKjVJREZYLoSvU7Jikk	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1507	914	193	6301	9450	jwnf27KgNKx6v1CZJVZ5c1FmjtyW6BvRG52FpVDC28dYorTCwTy	6787	9599	9599	1617667020000	canonical
13176	3NLqxbGW74qjCNib9nwFjk5hrBEbwmee2poyKougL6hbZdESXjWh	13174	3NL5XDvnVQNE1iZYzc3nU8RxVmNHwr7FVEKjVJREZYLoSvU7Jikk	1594	1080	193	6301	9452	jw6f9dPG4uMQawSn3NXFMihaQF21qzoyrsSRu7A1qEoSMfkRHH3	6788	9602	9602	1617667560000	canonical
13253	3NKZtCon6RWwEscVNQ4a5Q1kUq8H6ne2SpQmiTLkTtcRSGvw7gXv	13242	3NL7mbWHMWDfJpp6Hidq3C6xF3ecxCAEt1RSaLddN9Sy4fQJ7nad	1471	1386	193	6301	9522	jxe8YcLDz1Uc13YTnUMmETefQFDtstt4azKDxSKAhP3hydn2RDr	6788	9656	9656	1617677280000	orphaned
13184	3NK3e1z4xPrKGcp5eyBRiqiFdbLvFczhwXHypYdHRnTP5pFCKYsW	13182	3NLtvaGSjxvcok639mpoAE2zUbj5wNDVdWUuJdZTfvyeF9UkoqqN	1447	1345	194	6301	9460	jwieW2EP2XajA4yx3pnUGwdGUdtFd6S2VzV3VJfnbnmQLjh6k85	6793	9612	9612	1617669360000	canonical
13187	3NLAcbdJpiMrwqhkut7ZSD9k5pUrwU57UbTt5hmrjDVSe4S9Auig	13186	3NKgbeajxdPUsZaSDWuQXt8dPoEyFusc8EmNypirK5bS1xijUWgS	1594	1080	194	6301	9463	jwxK1ffzThFDZezorjdWV3mqQs7Qq22eZRuf7hZibUZFM91ZBoW	6795	9615	9615	1617669900000	canonical
13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	13188	3NLJ8io4sTj2LByWkkrhrUdRti5yzQ3ms42JzusWRLQpB1E1xRrq	1564	1338	194	6301	9466	jwfhpf711F8Gh6g4gsimhUqWJFWG99XBEoS45V2zdbNga7t3iMr	6797	9620	9620	1617670800000	canonical
13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	1407	1395	194	6301	9469	jxvXECnzG1Qcd32YJ87hr63ewnxq1wa4L6UnJzAYbZWTFP1eMkp	6798	9621	9621	1617670980000	canonical
13200	3NL8Uukkd8K98T6U9be47RCFzCC5zTyKdgzth8kfQK4ENhaiEoXo	13199	3NLDyFfTt6r1forhKEcQoGhovYA2oLvTHatCz9DtXeXHH1M8aeWx	1578	1296	194	6301	9474	jxRYhsr5yDUuZJrq2zsuGDUih13RGAiG3p31sNVyLUfHbdVonTM	6802	9627	9627	1617672060000	canonical
13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	13200	3NL8Uukkd8K98T6U9be47RCFzCC5zTyKdgzth8kfQK4ENhaiEoXo	1406	1393	194	6301	9476	jxCfWG9381jNtqxzt7AH1xULKurNYHn7FqJRekeypWGzfp16yCs	6803	9628	9628	1617672240000	canonical
13205	3NKBZYZK4c9QByeQqgmwyCiucr4VEbMJUu5WTzfivPWjdU8KyXi2	13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	470	943	194	6301	9479	jwtEbvHTsZVSdarpzPUwv4JyvSz8c2gVAn2T6EJ6NG9NtkfTHVr	6804	9629	9629	1617672420000	orphaned
13209	3NKwuzvVrCh2u11Lp3xo6KNrpV4a21EF7B9UzebBuPU6exHbt833	13208	3NKELNcGjgMFp6E22j1XXLa8UKy5cWRKdXvBnLnA9k8XpPovTfkM	298	942	194	6301	9482	jxN9tmD5Da6pTPJG7covZq9a2TQJ4Pv9ZyskwbRfDrUy2vqboy2	6807	9632	9632	1617672960000	canonical
13212	3NKd7s9fKTbwBMtbma3YjYBZtbpCqpSViW4ByMnVbXoVKuwVAg32	13211	3NKyraYKU93pT7jMuk5K3AeoWbSXHYr383BH9DsE37ip2CEtVtyK	1403	824	195	6301	9485	jwK58kU1c975vhKtazvB5t8rZCDZtGu7mKXmMabfXrjBpWqBdiC	6809	9635	9635	1617673500000	canonical
13222	3NLy5Kz8CAJkwFJx5d2GjcAG1ctH4KiQwaY8tMwB5zx8FWCUKkyn	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	1670	916	195	6301	9495	jxrG7rbjugqBHabVdPRSmf1nPqNePKyEUm3jyZGz7BoYoUJ69YF	6815	9643	9643	1617674940000	canonical
13229	3NKjRw4b9LMDQGgtVg64giXMmivyMD4T5uqHTwUrbG4SFaRTYC5g	13224	3NLQMwQC2pyBCCoZgx7giHEWJT5x3xnwZsxcNdXBBkHLN3Rmweua	1573	1072	195	6301	9501	jwAQi8Y8w1DMdAyZinfUrHo9kwupnk3j5KhXr62TANN5HWxTtW6	6816	9645	9645	1617675300000	orphaned
13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	13230	3NKc9yhsjCuHC8vzPeEpv69a7D2Q5vgUahA46Xn3cpu6sRHHNn1P	1542	1178	195	6301	9503	jwMDp7kvpAdweiEYRMxQ4FaPeeDc1npAgnYZG4giN5rAEJgrWd9	6818	9646	9646	1617675480000	canonical
13235	3NKcVsJJLL9hJjvgF7PsG3XSArndEgPNMfX686qpqqsUGzyMsbpG	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	58	1035	195	6301	9507	jxVRiqd4L6LqgUuLt4NCyQ3KjM9HvDaJMCoNTniQnCCLCUeok79	6819	9647	9647	1617675660000	orphaned
13249	3NLwhySMbeYL76n4kFwqbkvmbAKXQghCmnYVpMQXeL2Y5FZTJajn	13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	1652	1315	195	6301	9518	jxax47vmJX9bNNPFSiE2cWR5viCN7cn6QsKMGY4i2vsZ3xwi9L7	6823	9651	9651	1617676380000	orphaned
13250	3NK6gBH4KspY76G2RHuvqR5PqgLimftuinFHtm3EmYGCdH9eB7HW	13247	3NLixJuyn8arbx7YKRnfy2fGuGrZTVW3dFhWuZjEHPYTZ5SnSPqJ	1444	1255	195	6301	9519	jw84pqy1aAKZWwKe1gJo7iA115J2zZn8VYzyTifGAHU14kYE2MJ	6824	9652	9652	1617676560000	canonical
13258	3NKRxJhBokT1m4WscsApDiPFALvPkVBQSonawMBoofqajT18Rq7r	13256	3NLHxWbokotWZcYWBpySLSEdHNfT2mhuZ6miQ5W2DiFB5CU6vLoW	1451	1292	195	6301	9526	jxLunb4CqrRVK7CmsK9b4TkxJoN97NJsT3ywomH85Sw4LgLeLjr	6829	9659	9659	1617677820000	canonical
13260	3NK7fAbXKUYA3pJt1MbdwcSYHLLY5XsGkyxH9qxUVL9LzpJNZEgL	13259	3NK3HACXe5HPbnQdjm8Loy8p5HQvRjWgVSZFsRRJBteUZ1fTdKK2	1637	816	195	6301	9528	jxcweaqTA3sHuMnajHxXe49oetQqDXbLT9LhZtxJpMPU4VpXfv7	6831	9661	9661	1617678180000	canonical
13261	3NLCDXz2HrxqBAuHBStcj8KUKGAhe9xmcZF4eLgBUEG2XDMXoPaa	13260	3NK7fAbXKUYA3pJt1MbdwcSYHLLY5XsGkyxH9qxUVL9LzpJNZEgL	1405	857	196	6301	9529	jxsPzZyUmGibkV3waUL2f8ke21S3fa8NYK43syK6fkpzvfaFf91	6832	9663	9663	1617678540000	orphaned
13266	3NLCkucKArb7261V85rPhzxK8wUj85GQzCyfo6LwTdmmC9mZMVaB	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1407	1395	196	6301	9532	jwtSyULf2wM7zx3Qpw8j1pgDfK7h7FgHSvP32bTLwwXTzHQAbWL	6833	9664	9664	1617678720000	orphaned
13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	13263	3NKJBT16kFScC8C1abNVs2CuNZjnG49YLmXxUUWS1wdaCtivHLJC	1406	1393	196	6301	9533	jy2ySrvtYT74Hn9n6ku775dLST4nknSLYUaMP5oUPFFW5fCRy1B	6834	9665	9665	1617678900000	canonical
13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1594	1326	196	6301	9536	jwmTHUBLDE2TdG818gFzx8McHPmyssyBTwenrVm8SgovUCEGqAg	6835	9666	9666	1617679080000	canonical
13282	3NLtjqLSx5cgTMjQKMefH3gNwS199eECX6MdUSZtFwUnMf9FKYUr	13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	1581	778	196	6301	9547	jwYjKQnpHk5M1ADehMoHZoA7sHNybQ8SfonEUoDx4xvsKCAzYVW	6841	9673	9673	1617680340000	orphaned
13286	3NKimTMmfjzyVqgUmhG6Qwiy7aM6yaoT2EK1pfGJCbgaY3Tcc7gL	13284	3NKyxhgX4d2ZNpfrbYSwxoPUvMwmnFc6DNnnyQqTz77hNFvMeSe5	1406	1393	196	6301	9550	jx1s3FVzxpCYJUSNYWSnVitzLGf1v7LYkYHndPAF7VbgXmXAzst	6843	9676	9676	1617680880000	orphaned
13288	3NKbBRSpjpX7JSPzGr1RXceFmcXSpmDqjRAfFcWu5J1MDX6UEEPg	13287	3NLHnLy6TVxKShRVpjsNAvLAsnQH9rQ3PBi94BuHf74wtbfkFsEZ	1649	1383	196	6301	9552	jwPXLMQhwG5QcJSk8jYrnYxiaDmVhUTaDuMF4Y1bRvHRX1hKHR2	6845	9678	9678	1617681240000	canonical
13291	3NKaVHQFbaryjB7Jt9vendVvzSQUcUZX8ciFXS8V9Jqdah5cAHek	13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	1527	1293	196	6301	9555	jwCxao7vU2z7ofnATYZKjzfYJZxk3EN9aiyisX6qX4asow5BYLA	6847	9681	9681	1617681780000	orphaned
15336	3NKWGR1Vj4KtWpMg8QWL69azUMUSr4SDqhzRkghnX4Wpyykohtrm	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1648	1284	245	6301	11380	jx3GVpbMhkjEU5uboiQ9hoqUx5DuAK4Y9q5UVKM1Hzj71aTWpMS	7817	11059	11059	1617929820000	orphaned
13188	3NLJ8io4sTj2LByWkkrhrUdRti5yzQ3ms42JzusWRLQpB1E1xRrq	13187	3NLAcbdJpiMrwqhkut7ZSD9k5pUrwU57UbTt5hmrjDVSe4S9Auig	1609	1207	194	6301	9464	jxdop6uZRvgTEKYPRWPz9X4uthEY9opKkXD7vRvSTmgRpjQbxVg	6796	9617	9617	1617670260000	canonical
13191	3NLLL5b2VWhB6kWbw5wPM7hFJ1E7kvcZHawo74WteGGSgTTQDwwp	13190	3NLve4q7igQ55CSf2FLauKw85B3UxGaBMWSmewJ8WLDqU1jmRedG	1577	1327	194	6301	9467	jxfmBM1FQrZS5UZtpunstcyi4JxD43hd58FCxKevgYFADzuri8S	6798	9621	9621	1617670980000	orphaned
13195	3NLeazoAkrCEUeqqWvNwhjFqoUgmMqVuvEKUbMiazDSArhJVdeXa	13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	1560	1165	194	6301	9470	jxQHvJgk6Sxt2JarzEszaAgkn1TVtVMgXZrY2fnvshruYLTbCxU	6799	9622	9622	1617671160000	orphaned
13201	3NKcxscmBCyiLJAMbRFRvskK3LGiUGdWkrj4kTAG31yXvNqsBu39	13199	3NLDyFfTt6r1forhKEcQoGhovYA2oLvTHatCz9DtXeXHH1M8aeWx	1657	1344	194	6301	9475	jxGdXKd3aBo35dz6mXa4HUsijbLdPTyqruoRgrTtRdrh6ZUdDMg	6802	9627	9627	1617672060000	orphaned
13206	3NKJN6uBDuq1dVx14QxWKuJeu56pkUAeNLgVVj5ndbbXbykhLTac	13202	3NK446tt91MV7As6JXFqUpE8st7VW9ZZyf8bg2ZoAjrVKpGWXK1Y	470	943	194	6301	9479	jxRkiG61UsakgG54c8BYBzYpMw5vhisZhxisemmnfyextejabJ2	6804	9629	9629	1617672420000	orphaned
13207	3NLmRWWiVi19zPn9WU2GNTASGCMAS3jwFMy4n6DU9X3yex72zTGL	13204	3NLFFpKdVKrfMxVXWXxdB7wv4ynzq3xjjjf5NLf8M5xLDb6DzMUT	1405	855	194	6301	9480	jxy8UWeVVwwftvdwrG5z4zxu87GnkXpuL6LwU9oP5nCGJbE9q2F	6805	9630	9630	1617672600000	canonical
13210	3NK8qcuYPceK7J3gaQvMzx1fe6c11YngDQ2GHUuNVnmk2q6NdEdL	13209	3NKwuzvVrCh2u11Lp3xo6KNrpV4a21EF7B9UzebBuPU6exHbt833	1406	1393	194	6301	9483	jxsd6Dr6MsSGmrqNdDM1SrZ3E3tB3UUXTTtms3iowcrhkzZtxs5	6808	9634	9634	1617673320000	orphaned
13213	3NKioz9HCaV5dTjXMrSXtMoNf4uQMvcD9NcAXLMUxJS3WcRp8APX	13212	3NKd7s9fKTbwBMtbma3YjYBZtbpCqpSViW4ByMnVbXoVKuwVAg32	1609	1087	195	6301	9486	jwWgDsN59vbvRGHrvKYg8WvYVzbtzsixGnVTUsNDwutQ5b42Rq1	6810	9637	9637	1617673860000	orphaned
13218	3NLiyeS7n33vneBWoH7VFS5gtCgcW7aVQJjbitWsGd58Cj8WPJKz	13216	3NLYPPZFz8PZumVBc9L8jVDLDhQyqLyAQrGH8sHmZbs5cWVfNUT7	1406	1393	195	6301	9491	jxtnR19mDrD7N2xJVDqQ3kJS4F8MrhTWWPWdvxLP32gLoCCsUTj	6813	9641	9641	1617674580000	orphaned
13220	3NK52AxtwLJpToHd28CkNovhJUAAY7TDDUMHkpRwoaG27bnsvFkt	13219	3NLfzVuegQUDhnpCZrmuinsYd2DmBm9n2Kh7tFdt4DFan8x8Eh4f	1593	1346	195	6301	9493	jxwaVZHJJ36dXBMTUvYt3GwTQaErWRVPmzsoRzeRw6eac4XTtow	6814	9642	9642	1617674760000	orphaned
13223	3NLx7NATMPkncEAv3c6nd1Rt9mayAZY619igGsfdQMmqWX5u2QJL	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	311	1307	195	6301	9496	jxzqzdhba5z8JN4YbpF4d9VmdCu3d2qBpYKDqyEFZjCQwddbn3c	6815	9643	9643	1617674940000	orphaned
13227	3NKeksNaEC7NWcVSAm2ayFPnW9pKbdXrfSgsBVxyLGVHpVP7HYt3	13222	3NLy5Kz8CAJkwFJx5d2GjcAG1ctH4KiQwaY8tMwB5zx8FWCUKkyn	1407	1395	195	6301	9499	jwupEAP3GKZ5BddaLjU9LN2jQTkKh3EiQkRvj4EVdfi6QfJ8F3V	6816	9644	9644	1617675120000	canonical
13232	3NLD7CMMjJ6TRkSE4ALsYZehPddAqF8FS7zHh5RTTrL5Bb4c6LFM	13228	3NKppaVfX176R1GM8VBJ9RqvLFrsYAwZSqtrqoHiczmu5EofJiEq	1405	851	195	6301	9504	jxWrevYo3rjV8S8gfkzXxBwywexSiwn7MNPWUEV9pUaW1aMzE8o	6817	9646	9646	1617675480000	orphaned
13236	3NKmLuj7j5DD2ByxXQ97nUqCtvwct6p8vHzfeHNiXXSowrrjejkW	13233	3NKBXL28qg5mZEsqFXzxs6YwMDAg9cQYq1aKH7FgzQUV52EwnnDu	1648	1284	195	6301	9508	jwuH2y5zDmk1L1KNaLiZVnVpATu4i3uPeeeBeMsqcqUZ7oBbVdh	6818	9647	9647	1617675660000	orphaned
13239	3NKqS2BETkHvTLSRHdXSV26uyhzW22eScZrZSek6rtqTJccqmpCs	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	1624	1208	195	6301	9509	jw7cNc1RbcDGbfTAMRRmBEskRxNmh6ixZmKYST4AySho5M4NzA3	6819	9647	9647	1617675660000	canonical
13244	3NKR8xQQ3VPYvgB2PcCxHuA1cP7Gab2P8EBZHrNEfuMryfcVtwSR	13241	3NLRYon6BtD5otZ8a7oN8J3rwKSzLx3v1AaA7HAiXiHT4QXtwVoZ	1579	1389	195	6301	9514	jwWzcifQbZxuYnHNJ3xUtNKDgEaaPbxBMkfdpWidh3UZYhFNp6h	6821	9649	9649	1617676020000	canonical
13246	3NKU4BXwC4Pd7h2eWFfXwGcCVNodwDAYE9mJd3miNbJirTsgw8rX	13244	3NKR8xQQ3VPYvgB2PcCxHuA1cP7Gab2P8EBZHrNEfuMryfcVtwSR	1623	839	195	6301	9516	jwSVAuntF3f9z4EfinobXWzbYdpRFYK8C5XWa2EDDBsfZcB3Kmy	6822	9650	9650	1617676200000	canonical
13251	3NK4txS45Dje5Qq2xQMs8CLA2YjdwWHE2vKmKb8BrGTirC18Fd41	13250	3NK6gBH4KspY76G2RHuvqR5PqgLimftuinFHtm3EmYGCdH9eB7HW	1578	1296	195	6301	9520	jxqYHxgbAr8cdLubHip6RxeLJCJsyt1PhVnEC9UpuRwz2cdbELx	6825	9653	9653	1617676740000	canonical
13256	3NLHxWbokotWZcYWBpySLSEdHNfT2mhuZ6miQ5W2DiFB5CU6vLoW	13254	3NLaxcNk89jMPjPh4f9hby3upmnhHkPD27UEsFxruzPga2ZRkyXQ	1585	1366	195	6301	9525	jwcKD33fJ923N4XTnV8S3mLvU1vPACkFaVBV1owRiuiX6VuRrsN	6828	9658	9658	1617677640000	canonical
13263	3NKJBT16kFScC8C1abNVs2CuNZjnG49YLmXxUUWS1wdaCtivHLJC	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1527	927	196	6301	9531	jwsY4CcvbCkfSAQFxMBqE3UPBLT3CNAdGu2TmYRAwfcknHbpwwc	6833	9664	9664	1617678720000	canonical
13264	3NK5EDoBFGF22HhVCqDXEsn3XwWFyGBzukh5nraeEUhawEFtZBbS	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1527	927	196	6301	9531	jxQ9sdCruozbEgdvdxjV8D2HX9VpZPBa2HriCXkXJxxxEDpgoEG	6833	9664	9664	1617678720000	orphaned
13271	3NLSpkf3tVdeBv6MHJVmc7r7tKbQv8qr1XNWWPxuDixvb2Rt3svd	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1651	1301	196	6301	9534	jxdCywHrUkkWwxY59Nj2rUVudLV1vg9ZgN71PhBrDaxwzudySEe	6835	9666	9666	1617679080000	orphaned
13272	3NKMDftXt3wPkzGRZLWbg2Bw6ugks2J966LR74HzxxWE6nbncDV5	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1600	1126	196	6301	9537	jxZGtpA3hG4xAZ4qTf1FhgTDKKFusX2PnrTiJASa4kH4RzDMsNH	6836	9667	9667	1617679260000	canonical
13276	3NLYrnpjJpMMJq8JVoY1cMDkwZbzxxMkZig2Pe5E3zmVAhuzXmFJ	13272	3NKMDftXt3wPkzGRZLWbg2Bw6ugks2J966LR74HzxxWE6nbncDV5	1637	815	196	6301	9541	jwjcy1Sz3i3cZWArSviyaYRZY92uYhYRRZXpPZ2YMQXTrc7xL8M	6837	9668	9668	1617679440000	canonical
13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	13278	3NK658VsxQBX9SANW86AuqHj1yLnS14HSMLfxZ2SUCdrfD2itJyk	1637	816	196	6301	9544	jxMNXffBUqvhz8ukXRiXjkwAJubXkn5WxNHVJDKE6DomxSkkhAg	6840	9672	9672	1617680160000	canonical
13283	3NKVyxVAMCHMPYrnbXR3dLpATaZgPi6wpm5GvqfjbFY7YY19iqUd	13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	644	644	196	6301	9545	jwpiBJ7DFjLbYX8MvRmMSFADJwfN3YfdGwo8VnR4cCF6dxzwf8Z	6841	9673	9673	1617680340000	canonical
13284	3NKyxhgX4d2ZNpfrbYSwxoPUvMwmnFc6DNnnyQqTz77hNFvMeSe5	13283	3NKVyxVAMCHMPYrnbXR3dLpATaZgPi6wpm5GvqfjbFY7YY19iqUd	1506	1373	196	6301	9548	jwxdbQdqdcUV8expeJtPy2uVEjNHLhBbRxocz6DLEygdBQxvSdX	6842	9675	9675	1617680700000	canonical
13289	3NLVWGtJkUr2V614wr7jA3HfywqCrYT9YwCh6tb7vi3Fa11Psf2S	13287	3NLHnLy6TVxKShRVpjsNAvLAsnQH9rQ3PBi94BuHf74wtbfkFsEZ	1513	1013	196	6301	9553	jwcCBj7CC4kERnnGWyD3FndQKweh9EioNpttku2d5WTtR1acm7V	6845	9678	9678	1617681240000	orphaned
13292	3NKzwzWK1YuTAt5pcfKAwkBjB4zYyLT8tHPJVgm4RXMvteKXBcqi	13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	1527	1293	196	6301	9555	jwt7x5pSZNRn3XRHShxsbcQu9444Wca3FtiWWLfRUiH57ciCBfB	6847	9681	9681	1617681780000	canonical
15338	3NLejz2o5AFNrAHsAg2cbFvTqtquJTL7xHyby2mYZT3YKciBaQdv	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1474	1083	245	6301	11382	jxQ6Jgtmomb8qPF64dfMHvMDNhxvEZxabHPveFBCMshwE4raWjp	7817	11059	11059	1617929820000	orphaned
13301	3NKQV5qA4UWK35Cqu9gb66h5KDrUxtM5hMfh2NqmV2Ui59kW69Ko	13258	3NKRxJhBokT1m4WscsApDiPFALvPkVBQSonawMBoofqajT18Rq7r	1458	1077	195	6301	9563	jwNpSutyPhzun75ysiwFqoPr6MF6T8YdPnJUpYvQ8wd4JddGi8a	6830	9691	9691	1617683580000	orphaned
13305	3NLnwzWyFdB62VeczGXg4UX82XrdeSGpT4LztNGUFuDuZyWf1MT8	13301	3NKQV5qA4UWK35Cqu9gb66h5KDrUxtM5hMfh2NqmV2Ui59kW69Ko	1458	1197	196	6301	9567	jxHHHZwN8fLMoLXxhX7H1DHuSd3etAaw7L8w4M9nYSZE77CNgCz	6831	9693	9693	1617683940000	orphaned
13265	3NKF2EKV3TS4jhs3nFoYMwomG4nT6hewtivzuuT5khvWjPCmQytj	13262	3NLNCr6fjVqU9grFAHYzTek93CWcXfy1DaJUSvnRe2XEDf8pjsbM	1527	927	196	6301	9531	jwpHh9tNjVT1bmjt5mB95WKmUKrmXyk7vzss93PdUVbwuKVMauR	6833	9664	9664	1617678720000	orphaned
13269	3NKgT3PPRDXdXBNgV1m6uknfAW57Am2CTcZNDfpz6mnKbrDTQyCw	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1474	1329	196	6301	9535	jwRjfVxr4Rzr2m5R3kiVMEsy1fFzFapAEj2iseJBjDUduFjuoGN	6835	9666	9666	1617679080000	orphaned
13273	3NLS48HN6zNzyKuW5CJyeMXE3SUt2f8FdJKfJcAu56HZHzkZoX1g	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1406	1393	196	6301	9538	jwwSWpJNNw5uc9VaFchgnrN2znToATeb26ybxfjZaC7n3MbkmwW	6836	9667	9667	1617679260000	orphaned
13281	3NKdDsC6xfF6MoqLra7m3tp9as3pYHd6QKve2ageKjA73So1wWf3	13272	3NKMDftXt3wPkzGRZLWbg2Bw6ugks2J966LR74HzxxWE6nbncDV5	644	644	196	6301	9546	jwnatXoEn9z4SEwC1BJuFVTPC5KxynMiHSJCeeQfrT2F2M4z2XD	6837	9673	9673	1617680340000	orphaned
13277	3NLQfH35k1b9ZKn9GncFm9mSuSDTSaiF2zxPtTmRdpGyEHqJLLip	13276	3NLYrnpjJpMMJq8JVoY1cMDkwZbzxxMkZig2Pe5E3zmVAhuzXmFJ	1536	947	196	6301	9542	jxhusFrdSmTd8MKa2rWug8eWfFjS9ewmzAk9XMUp4LjXo4c65NF	6838	9669	9669	1617679620000	canonical
13278	3NK658VsxQBX9SANW86AuqHj1yLnS14HSMLfxZ2SUCdrfD2itJyk	13277	3NLQfH35k1b9ZKn9GncFm9mSuSDTSaiF2zxPtTmRdpGyEHqJLLip	1407	1395	196	6301	9543	jwzzTvoRn4vWXgaA2DaDbPVQVuka4mh5q2sAeUG2nUvYB3pY7qP	6839	9671	9671	1617679980000	canonical
13280	3NKNBCL4tb8sRTiYwNhq9ps7c7uoJDmQWAK8KseG7MWBRzbbShyc	13279	3NL7FL5edLxE4GsB9sHsnUQQcuaNpHHjhdyUHDKVFeCyyib4NKJc	644	644	196	6301	9545	jx8UJmvxHj18KDdY4uAVxPmSgndFPuKnqP8DghDZxAHwfyk8TUd	6841	9673	9673	1617680340000	orphaned
13285	3NLk8BscW1MT4sUwjPeUEwt6wR64a2j8G4pVH696r3rJRyw63fbC	13284	3NKyxhgX4d2ZNpfrbYSwxoPUvMwmnFc6DNnnyQqTz77hNFvMeSe5	1589	1160	196	6301	9549	jwXx3qW1fpPs5RBTt7YATK9FHkNGxXZ7Y67zpBAXnRnUJKwhC8M	6843	9676	9676	1617680880000	canonical
13287	3NLHnLy6TVxKShRVpjsNAvLAsnQH9rQ3PBi94BuHf74wtbfkFsEZ	13285	3NLk8BscW1MT4sUwjPeUEwt6wR64a2j8G4pVH696r3rJRyw63fbC	1506	1127	196	6301	9551	jwsdKe3SjoxGiKJoeSegevp4muyiJZTPEBgwU8RWonPCJT3J97n	6844	9677	9677	1617681060000	canonical
13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	13288	3NKbBRSpjpX7JSPzGr1RXceFmcXSpmDqjRAfFcWu5J1MDX6UEEPg	1541	1172	196	6301	9554	jwNfpE5YszmCaNfodvsZXSoaUm7LE5H65hkG8UTcj6SHRgeNvRX	6846	9679	9679	1617681420000	canonical
13293	3NLd9F3XuoCn1vYHAc8L9f83NqWaveFEv7pQRobB9sWByojPd2xW	13290	3NKjt5P4SaBf8NsYKvTQ4aewZ85LE7JSdYif28c4VZz43uUnu2EX	1527	1293	196	6301	9555	jxtiKiUjdhVWb1WYHjYWPseNEnJVxWNnoDqydGAgd1XRxnxK6N6	6847	9681	9681	1617681780000	orphaned
13295	3NKt4WbkF2atVaBfVv95EAfAikxw7YnmsLET9gNWSv7AQt5H2SuS	13294	3NKQYm6a8vgz9ZwLBRXjGTTzXMzU7acHKWCn9m2ixywrPuiwqaB1	1405	867	196	6301	9557	jwJx4MJZBu4FCJBnNL6FEGfR5gzdPtNeQFtrQgKPgKggnzNrZXL	6849	9684	9684	1617682320000	canonical
13298	3NL3toXJ1rGh7DuycfH8JyE82mnNdoGXYoyygELpVKpnWi4bWr6C	13297	3NKmRLApCbWPnNX99uWXUSTv8xx9gRPUiPYTkjySpLSEsisCpLC4	1405	851	196	6301	9560	jwN1KSTZb3L5ZMfVADnNSJ3X71Xk42utYQDwgtbYa7CHC38H448	6852	9688	9688	1617683040000	orphaned
13300	3NLLPxxxKCSsLetW9PajV6GJjc5ESeRfwSAT6iYnhbG7eBBkS7zX	13299	3NKTzSDkFFWVqj4N6Nk5iU8fatPNe91V9kfBikxUxD8rWDYbKtMo	1607	1348	196	6301	9562	jwV6dizWYP8cwc2pq395six4MLktXEvXpH4ViyGbn1PRdirSzUg	6853	9689	9689	1617683220000	canonical
13303	3NKGgWXgaMwPKmNZawoFaFSj6BWgnUAnX4K2DfGFGUFRsB38X8gh	13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	1600	1372	197	6301	9565	jwiLQ9SNvzcx7ruiU7DTvDwL94uoJMWAuaXCB3czZ8ZYsbJf26p	6855	9692	9692	1617683760000	orphaned
13322	3NLkYRW62VWm2WPZ2d2PH4H8HVS3KHivcLpNh9TTXVf6iFsHRGXN	13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	633	1258	197	6301	9582	jy1kH4vYuPocXmxk2YA4QfYmEkdkuJfo4Wedq7PisYwvB7aaBWr	6855	9704	9704	1617685920000	orphaned
13307	3NKHN4mmYtUNtdvYprqoAK4FBpJfiX4WoLXAQWrHa1FvQT132GkV	13306	3NLNZzAXRmnmNo5bwaMW1TWKFgQv8dz3jzEi3jAdWaKeUs2Fi8BS	1483	499	197	6301	9569	jwHt4zBc2zRenWuEqFqQUe12VcJV9w9KrMMWefvHzmP7zWSMBXb	6857	9694	9694	1617684120000	orphaned
13310	3NKnm2PG4dVWNuA58mVJpu3SmnmA8wRkgd2WnvvSGvNbuYzfiKpw	13308	3NLBM51nHtPwDxgPoxx3jRbBQxF7t8otqDDERKWosXBBrJ5tWmsc	1650	1375	197	6301	9572	jwWo3cvQxkribRx69VbhPo4Ho28pkR6ozVUPkNJYn6CxaAdSiUv	6858	9695	9695	1617684300000	orphaned
13312	3NLeFMh5xG8gZiDP3vrWEN1tG9TEzMQiFPNscGGDpSmZTQkGnVXg	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1523	1075	197	6301	9574	jxdsZ2kAfnVbXee5SxvPqg45Miq1ZqTZ3xyQc5KyC6anynhHoXd	6859	9696	9696	1617684480000	orphaned
13313	3NKB8R9qLut6eeeZUyW6CfyTmUMABtADMsoUMrzmrBk3iKeHAngR	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1534	1191	197	6301	9575	jwTB8XFhATTwCyqhHSzLgfHAuj8FrUBuZtr9iPFiPQZWK8owVC7	6859	9696	9696	1617684480000	orphaned
13319	3NKM6o2DVEjYZ4iMDShhxRUW9Diw8MsFhArESgvQNvmYfTTisQER	13318	3NK6GfyT99L3Wpd9ST9pExjhKNeyLptq1oh7EWkeYKuLgBzzMzEx	1445	1290	197	6301	9579	jxowAi4Nc5UrbFQfDab623iPauX7cVh71Y8gmFnfmrbh4XMB5Rw	6862	9699	9699	1617685020000	canonical
13333	3NLnw1S5re45muKFWbLYqALvpoD2cfvj1HFJnGnj8hPAuKx7Bk2u	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1527	1293	197	6301	9593	jwE7z2JSeoFmSMVkZyTiaEA9mBjKvNfCM1z4b29y29Lh6pSe2nn	6872	9713	9713	1617687540000	orphaned
13351	3NLPuWfgnzh3jmnU8n6mk8F7Tzx7g3quhXm8zes7KX5g7CuWvsvM	13348	3NK2wRtNyhxUe5engDha8bTfM4Se5vK1iAEGoaEFnBP6Xxoezpvz	298	1308	198	6301	9605	jxyAyorEctxvL97UVdEx9oXSWW3mrtK13aZf8DYXZQUw6DodwVt	6881	9723	9723	1617689340000	canonical
13349	3NKGAPQ8C1RxaQ3oKBirnYbbQmPgyRGUbnepPRzhnNBY4Qnz7Bcc	13348	3NK2wRtNyhxUe5engDha8bTfM4Se5vK1iAEGoaEFnBP6Xxoezpvz	298	1308	198	6301	9605	jwcyft9iongKSi4WupVdF6KmdPtei1142EbuZFFWJSNuoXcCMyM	6881	9723	9723	1617689340000	orphaned
13359	3NKS1h1f3n3tmJKm3BcRRtUpSm6cFAtNi6TaVJinwcAqPZ7BqStr	13353	3NKQaHVWaK7K8nBBh9hLirM5cTcsg9LC5dqTSiZvVP1FFnZSXFzL	1652	1069	198	6301	9609	jxTrdh1nHgt2hRhZbEHtHUqAEJCZ1XV7tJNYjPDd4g9sUDsJUzR	6883	9725	9725	1617689700000	orphaned
13360	3NLGsPFPn3LPoodLghYi5DcFrBJg5DWdzbFzCMUBNizCSUkjAtpM	13355	3NKr1Q61FbJbyPFeGLvmD6J8rc6msW3Z46yhL6sGGPtJATfBZWDS	1654	974	198	6301	9611	jx3UGgDUhrgTHV448zcMBTsFCLNkEVx2TxWTc92JNJupkQjuGEC	6884	9726	9726	1617689880000	canonical
13364	3NLEGykfBGQJngKD4sLpxB7gJdB823qjK42CqYeBE1EJDh2XcWNt	13363	3NKm2nBsgMxkEeq3Hpznh6kdavxp52iJp3CBwX4W1j7JZbbCemP3	1481	790	198	6301	9615	jxAoub89yM5zP95VdhK4kU15Wrg8oqXUwRuAMEGQ3t6dv4zyVho	6886	9728	9728	1617690240000	canonical
15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	15349	3NKmxEZviiTTRmKVmUrirGzVbSL9AutsrkvmxegAXvGGUBfdQPnA	532	1177	246	6301	11392	jwjcF9kGJX6zZg2pjHwo2pic75h5aZtGaC4o1GjQPwXqY4hBrYv	7823	11067	11067	1617931260000	canonical
13366	3NKwpHXMMMi5JWFHifo6meuyFtFzFYveA49zpRWQGqZQ1Yw8DJGA	13160	3NKTY3YK6uiZ4iHK7a9x6e1dvD1u9J7wXWgv8oHbJtwJyu3e52kN	1569	485	193	6301	9617	jwsWqRhG2BWw6ZQYDDm4NTbbbiJqhR9twJcrAqXScYHV6mXWSCt	6781	9731	9731	1617690780000	orphaned
13294	3NKQYm6a8vgz9ZwLBRXjGTTzXMzU7acHKWCn9m2ixywrPuiwqaB1	13292	3NKzwzWK1YuTAt5pcfKAwkBjB4zYyLT8tHPJVgm4RXMvteKXBcqi	1637	816	196	6301	9556	jwJ6zthSfoGpewYf5UNy9XPTPNBj5uMi8sppBXoBDku76rzW8ic	6848	9683	9683	1617682140000	canonical
13297	3NKmRLApCbWPnNX99uWXUSTv8xx9gRPUiPYTkjySpLSEsisCpLC4	13296	3NLoCQuvVvcucn2R3PupziajKZqjWZPYvbw9UfNSr13NGRMVZTFV	1403	824	196	6301	9559	jwsr7xyt3JxGYgXCzyhoNZx52FWzdFqDQ2NSgD5tyv9St6Decmt	6851	9687	9687	1617682860000	canonical
13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	13300	3NLLPxxxKCSsLetW9PajV6GJjc5ESeRfwSAT6iYnhbG7eBBkS7zX	1407	1395	196	6301	9564	jx4j1ZrCpN9sPkzSe4bcmpupwpmGZVWXHsCwLaSNjpVQMuvP1gj	6854	9691	9691	1617683580000	canonical
13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	13308	3NLBM51nHtPwDxgPoxx3jRbBQxF7t8otqDDERKWosXBBrJ5tWmsc	1642	1367	197	6301	9571	jwVUD621NWi6yZVSYthULnuukDSAa2vy8gLxhXJQdmXKri5opDz	6858	9695	9695	1617684300000	canonical
13311	3NLG1LCZohd4o8iFMHFhNC1eAHk4q2A4ywA8JfWyGK1tRRHVgV7r	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	369	1186	197	6301	9573	jw93ZWPFBs6dgjkbkDfJXJu7HnyDs34KVbEELkhce6LNTE9xUtF	6859	9696	9696	1617684480000	orphaned
13320	3NLKhYadQv5W8yQCbDfojCFBoDv2T1MrnC3GZaqfB7fsU8hYm2ba	13319	3NKM6o2DVEjYZ4iMDShhxRUW9Diw8MsFhArESgvQNvmYfTTisQER	1402	854	197	6301	9580	jxjAihLVVwzJrfF548tQ9ESa4xpUDH9Mbnq6pWLF9qp4Du1ihg9	6863	9700	9700	1617685200000	canonical
13326	3NLBUEXTrv1C4A8HmyBa7GESVVW5yuswhxXzvGLeQMpM3nCTzgz1	13325	3NLqkSZuTb4BPJHpQ4cqV69GmBakLshdPnThzJXmrk91Ai3kMiE9	1402	844	197	6301	9586	jwp2vQiojbR59ZnndTgwzQoQGbK1WFQnT3iJQeTc9NBSqVbg55w	6868	9708	9708	1617686640000	canonical
13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	13330	3NL8A2huFdoS3SVAsMQPNmttrruJaiFGdn8eeMrhz7nLYrNMPeh1	1619	1029	197	6301	9591	jxrZcGdRTRcKKMXinFbSpP62AnGnkdGyiaG5HXrAKxpZajRzX9t	6871	9711	9711	1617687180000	canonical
13335	3NKd5nJnkSYCxorJumVbFgNUaTGzoSSdv7a1uwQwt55AvcE5FF6S	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1527	1293	197	6301	9593	jxoiY1duS7dS6frmaG2JLUanTCpFeuXQi3DaBnjzw5Jeo2qeNwf	6872	9713	9713	1617687540000	orphaned
13338	3NLjzRsgkwQjR5MnmtN8S2BXKt6sgQxGSf7Egw5fMdExDVYS8W2p	13337	3NLAT3y7CVcKH3vyxFcoDnxmJry7mJuargpX4WtJSM2EFnMbpi2K	1668	1370	197	6301	9595	jxS1u4ccRkL5YVRjTPDdkjiW4sGMBtFkgcKBnGgN57XwEHqsvqb	6874	9715	9715	1617687900000	canonical
13341	3NKjmfFarrJ6DjJmQ2SDs3sKvCjQENGeQBCCFZ32dgJaUSZoQEwD	13338	3NLjzRsgkwQjR5MnmtN8S2BXKt6sgQxGSf7Egw5fMdExDVYS8W2p	1406	1393	197	6301	9598	jwX11o7EKbGFXoWrgPSHqaqY7uV5Ev3x5AWJo7XwKdjr5GrNuic	6875	9717	9717	1617688260000	orphaned
13343	3NKpHzk4j9jZapoAHwG276sNSJcVyf2WR2WsX1hBeSKPeXb54DRF	13342	3NLbiNE6ambz96d3Qda34GNEFvaWRX7AoUQJcsQj2NksjtkT7Wvc	1483	92	198	6301	9600	jxPLqegWNW5r3FPesL97qMAeBCTCXChVTaoiYAdVWYT6m2pTVXi	6877	9719	9719	1617688620000	canonical
13345	3NLtYT2i5QhcVwt1sJ35r2b4YCbBCLPfK8yxX3bqDs5VphGRsLn7	13343	3NKpHzk4j9jZapoAHwG276sNSJcVyf2WR2WsX1hBeSKPeXb54DRF	1406	1393	198	6301	9602	jxcnDXFNRRGrfqYef3EHVS7y5ngkEGHVMYSm1yoZrh4DjqA7jof	6878	9720	9720	1617688800000	canonical
13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	13351	3NLPuWfgnzh3jmnU8n6mk8F7Tzx7g3quhXm8zes7KX5g7CuWvsvM	1483	601	198	6301	9606	jwWM8YM1RqErQN1ZzpEeKbiiAtcGRmNcoUYv8h1UnoUY39f92NK	6882	9724	9724	1617689520000	canonical
13355	3NKr1Q61FbJbyPFeGLvmD6J8rc6msW3Z46yhL6sGGPtJATfBZWDS	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	576	1355	198	6301	9608	jxUeYsT8iocSDtXXTCpE9qTH5mSwKp2tjuWztXHoVndCevFaavd	6883	9725	9725	1617689700000	canonical
13357	3NLg8fJRDezEsjE1emcmjUCP9UPDPxr8P11otqgvETPj1iLpgnnD	13353	3NKQaHVWaK7K8nBBh9hLirM5cTcsg9LC5dqTSiZvVP1FFnZSXFzL	1594	1326	198	6301	9610	jxriAybZGiokkoRtBaLjf9kCLK7wpYrZEHh95SRK2V53PF2NBam	6883	9725	9725	1617689700000	orphaned
13363	3NKm2nBsgMxkEeq3Hpznh6kdavxp52iJp3CBwX4W1j7JZbbCemP3	13360	3NLGsPFPn3LPoodLghYi5DcFrBJg5DWdzbFzCMUBNizCSUkjAtpM	1407	1395	198	6301	9614	jwNwM9eKFGRXicXaXkfsaWNSLtKN4zbHMDawDDrhFxRJ7chxgKt	6885	9727	9727	1617690060000	canonical
13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	13369	3NKwDqxdqYz89d8Jj7RDm6PpuvCYsaT2LbyPn8F5nUu6CgE3gKv1	1647	1056	198	6301	9622	jxh6dEW324beZFsuaENmpS3jUFtgfQSRMqa7mCEa6HiE7zrwcMT	6890	9736	9736	1617691680000	canonical
13374	3NLMenaor5TzFatCS8uR6HsnuKAsZTdAGg5SXfGRnYpJVLdSETzN	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1651	1301	198	6301	9625	jwwgKnKRcPQqPyHhwQbto22Lb35tehqSQeTEReh7sVPeUBJZPS9	6891	9737	9737	1617691860000	orphaned
13377	3NK8AMb6R9XWuxEBbmELBaWx23febcH9eegQLmGf2ttgp4c42Svc	13376	3NLabnTFEbVusrWYYkgkE9r6oH5esccpomB1EpzMx5y8k6o1mRpa	1637	816	198	6301	9627	jxM3a5KzFxBqoHD2kM4GA4AN3xnispE77EQ9AsoZkqunrcAJdFc	6893	9739	9739	1617692220000	canonical
13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	13377	3NK8AMb6R9XWuxEBbmELBaWx23febcH9eegQLmGf2ttgp4c42Svc	1649	1383	199	6301	9628	jxAUqBz9GkyQD7veXgsDuYKqoyNw2P1RnyhrRJvuXdrwKg8QzCo	6894	9740	9740	1617692400000	canonical
13380	3NKpzRNAsvq9AXCxGWLfSsQCTRnv2DRcS2z4fNqKf8zn15KmDcfb	13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	1513	1253	199	6301	9630	jxEbcM6cVsjya46ZDahCxAQU2sVSA7jtT1CV3VxGK83NEEuHgrP	6895	9741	9741	1617692580000	canonical
13385	3NK6ywLqTiYxWHGKmxrLugwg1kCMiuDjAkCyTFSWvKaSsr4XeN1L	13383	3NL6oEczUJiS686PC3MkLm5By6y4R5JZAyLpsG15cS1DZXXyCdPe	1518	833	199	6301	9635	jxydPZF5hG9V9BFG7BgpZZgdRDZQsvdSbqzN2zkQ9KQTXRk7pfo	6898	9747	9747	1617693660000	canonical
13397	3NKgtyc2pdFeUhwCtwfPVcKJZKiWXkX4DfdLVCQRiWn6nxPKxreC	13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	1419	814	199	6301	9647	jwnYATR4cgG1skouYv6Ev6sXh2GsB5DW5Lavd9uMd6GEfLJDYvg	6903	9754	9754	1617694920000	orphaned
13399	3NK45j4YaLBuvdJFu8SKuhP9ddirzxo2A8aXNHHMnM9eoXP6JWUT	13396	3NL92dHeS2ASMuri1jLot4LZ2P61G5k9cLhDaPJk3zqc9peFJkjz	1602	1243	199	6301	9649	jxM1YoxfkuGpZ8gpLJb42dUd1A4yBio2Y4HgnpL25G2nNYTR1sP	6904	9756	9756	1617695280000	orphaned
13402	3NKQmW89d1Y22mUfRJBVajwvqZZbYTDsZu3nNbC7stovUX8GCRGN	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	641	1336	199	6301	9652	jwNHb3uV1ztV4JbwXtZuezvESBjYoUyHUsNVktiVDtJvEGiup3b	6905	9758	9758	1617695640000	orphaned
13406	3NKJVmkzN1ah1ojm2g9Sswrxm8uZUTGvwzXUqi8XeLRYnG6ytLNi	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1647	1176	199	6301	9654	jwDPPybNhVaTkeQvtqcCjDNVYV2GxZxf2HMJbfvVwWFzz4EWszX	6906	9759	9759	1617695820000	orphaned
13419	3NLH9r8APXbEYa7pxVvDhPEdNDkiSjJJVKTQbny7vSet67wegCTb	13418	3NKyzD6sw6MEfr7RrBopp23pdimh7VB8vPDSp4wXdRWqXQDvNJFZ	1654	1094	200	6301	9666	jwXoZH5qsJoUY1iwt1aVd1U7RTBaQRcY4Jo4vnSm6qnHkd4iTSJ	6914	9772	9772	1617698160000	canonical
15399	3NLindUULaGhTCF5WELC5uryCD4fi8wSVHQ2nYSsy2bB55GZTauw	15398	3NKQ2uzcSSFvmugLqAMHtb8MYXDFb1PQMJsyEz8xcsHYH2baDZPb	1589	1286	246	6301	11436	jxLAxNRev4r3KPUsoEiPAxViMyca6nvWZHvD9fY8V47m4zLbUDJ	7843	11093	11093	1617935940000	canonical
13410	3NLsYLNGvH5duNUQFyMu41diehVozZbTPfjqv4kALJUDuR9MxaoY	13389	3NLKCAEUYdiSEmpkp5NbGqHRtJMgNYJuwXi1vF7L9y73HwccsUJ6	1553	776	194	6301	9657	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6793	9761	9761	1617696180000	orphaned
13296	3NLoCQuvVvcucn2R3PupziajKZqjWZPYvbw9UfNSr13NGRMVZTFV	13295	3NKt4WbkF2atVaBfVv95EAfAikxw7YnmsLET9gNWSv7AQt5H2SuS	1673	1122	196	6301	9558	jy1KGN7J4F6kbyL6sZmhrUkAaXvUz8JVTP7qzofiFzkzu5QUzRD	6850	9685	9685	1617682500000	canonical
13299	3NKTzSDkFFWVqj4N6Nk5iU8fatPNe91V9kfBikxUxD8rWDYbKtMo	13297	3NKmRLApCbWPnNX99uWXUSTv8xx9gRPUiPYTkjySpLSEsisCpLC4	1634	965	196	6301	9561	jwVTHH3KVCVavzxR8z5weHe5A8xYshEMv4VH7Cub4yRhUd9J65y	6852	9688	9688	1617683040000	canonical
13304	3NLCJK1wWVzLdL9GewN2knNCHraEAS5pqezBky1E2Lj6Lnf1zpjR	13302	3NKrcX2cig3ydq2dWaoj9omLVaGaTbG2sbgChK4qvbKNoBFSJRyx	1405	881	197	6301	9566	jwV8jWAtSjCTJb4Gf5RMS5BtS9tTeWRkFnrw5DjCSKsEncn4PET	6855	9692	9692	1617683760000	canonical
13306	3NLNZzAXRmnmNo5bwaMW1TWKFgQv8dz3jzEi3jAdWaKeUs2Fi8BS	13304	3NLCJK1wWVzLdL9GewN2knNCHraEAS5pqezBky1E2Lj6Lnf1zpjR	311	1307	197	6301	9568	jwCetfhDDL7tvn1wZyNjzJ9vKcX3gRTVrT1kPxLHiGhfB2tcszH	6856	9693	9693	1617683940000	canonical
13308	3NLBM51nHtPwDxgPoxx3jRbBQxF7t8otqDDERKWosXBBrJ5tWmsc	13306	3NLNZzAXRmnmNo5bwaMW1TWKFgQv8dz3jzEi3jAdWaKeUs2Fi8BS	1652	949	197	6301	9570	jwi5XYbPu2jT6QFjUCTxg2zw9ewE1viZHzDX7Mh16T6XqhJQEva	6857	9694	9694	1617684120000	canonical
13316	3NKto9JrwES2gAcQaaWwhEwbxQi1m2aUaZfwKTU4FaACb6AF1LLG	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1523	1075	197	6301	9574	jwQvqkikJEmrN5JVrN1TNvsVeHG2tPGD8jFBoD6QrvcxxWjNECy	6859	9696	9696	1617684480000	canonical
13314	3NKpM4ZJoUUXdD24mtTt9SQRfxLx18rG9PG89LFndGVB5vWHkVCQ	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	1523	1075	197	6301	9574	jxmwaAESiij8nsm9w6Eqk6BDDxYVRnjpYwsmDprmykH1bdJ56Dj	6859	9696	9696	1617684480000	orphaned
13323	3NKeoTcbeU41wV5iTosWYpmVqESqPpvsTJ3zEptJxbWhfeziR9Pz	13321	3NKmYikUXYNNajpFYM7WrBFyXGvAUx19SJqPnYbnAHPdBjRw4R2P	633	1258	197	6301	9583	jwPLynFkFMxDXY2pGrD5ZEZBj4zeWZmkSCXkbjYbYH5tqnMe7xp	6865	9704	9704	1617685920000	canonical
13325	3NLqkSZuTb4BPJHpQ4cqV69GmBakLshdPnThzJXmrk91Ai3kMiE9	13324	3NKTWMsESNuKhQom9xc6APM6je2XkNgVbyv7kFtPWoDYrKpXj7qS	1407	1395	197	6301	9585	jxiaNNaawyeD9W2T8ANSYKT859WQebVfTAScwX5um8zcMu5u6TB	6867	9706	9706	1617686280000	canonical
13328	3NK4SEP9A9q5NkvAPKV3GfLV8c8kwV2VdyrnKhUj4r5YcfVFMSxB	13326	3NLBUEXTrv1C4A8HmyBa7GESVVW5yuswhxXzvGLeQMpM3nCTzgz1	1447	1219	197	6301	9588	jxEWNLJbavfTjGJiAvcAJDZSdmAnpHB7sM9Q5wHyi2g2GHYm5ct	6869	9709	9709	1617686820000	orphaned
13330	3NL8A2huFdoS3SVAsMQPNmttrruJaiFGdn8eeMrhz7nLYrNMPeh1	13329	3NL7hkDJYBMjoynvRCyrckQ9tySM46wM2HytEBaZs8Jpdsc1R5Xf	563	1359	197	6301	9590	jxPyWRUPUZeaT5AjofDXaYviWmqBFAtvNQYP8bVCqcp1KwRqfKg	6870	9710	9710	1617687000000	canonical
13334	3NLMqUo2jhkh8TTb6nhWGV8gv9wUc3FXKMeEQo7x83Lb5z8sMkaZ	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1527	1293	197	6301	9593	jxfdx4g3D5NwMLob8dMnpLaaWxGqaYbTsuNyEUokZEf8GcG6WDR	6872	9713	9713	1617687540000	orphaned
13337	3NLAT3y7CVcKH3vyxFcoDnxmJry7mJuargpX4WtJSM2EFnMbpi2K	13332	3NL2HreiZLPCyFp38D7LV26AYYNwQzHLDC7jScAxftxJtTCQ6Asp	1647	846	197	6301	9594	jwKXayyNgTf6dxPestwUWuh1a1YjPcBP9fH6upRt3fpQ8ZB2mDm	6873	9714	9714	1617687720000	canonical
13340	3NK7Y2E7Qn5tGnkAQBQ8QCP2qppQqACxMPjGPMVbSFfeV2Nyt1uB	13338	3NLjzRsgkwQjR5MnmtN8S2BXKt6sgQxGSf7Egw5fMdExDVYS8W2p	1587	1357	197	6301	9597	jx33q8Sxd8kYEJ765Gag5kujc9cQxs7jTStue2PksizDVromoVz	6875	9717	9717	1617688260000	canonical
13342	3NLbiNE6ambz96d3Qda34GNEFvaWRX7AoUQJcsQj2NksjtkT7Wvc	13340	3NK7Y2E7Qn5tGnkAQBQ8QCP2qppQqACxMPjGPMVbSFfeV2Nyt1uB	1578	1050	198	6301	9599	jxQWJ2r6YHR1XR5kw1UnVhGk3Thr81puksKvE1dQUWM8zv74NyF	6876	9718	9718	1617688440000	canonical
13348	3NK2wRtNyhxUe5engDha8bTfM4Se5vK1iAEGoaEFnBP6Xxoezpvz	13346	3NLd2KgFZzuWFe684JAANjazdgsXMAGPe9RNPZyubtakkhc3hUxh	532	1303	198	6301	9604	jxVxBvPbhXcm7g39CmfbXjw8A5p8YfEzxveErHETaAQv7eUgR2q	6880	9722	9722	1617689160000	canonical
13347	3NLZ4ZXBAkadtXyxMVuG7fv5eVBhWE3eMU9xKafcYD4RTUJ7pexK	13346	3NLd2KgFZzuWFe684JAANjazdgsXMAGPe9RNPZyubtakkhc3hUxh	532	1303	198	6301	9604	jy36Ns6BcZp7qF9fR5e22LoeYt2yiddXgnyaXpVHccnxCKqrU2Q	6880	9722	9722	1617689160000	orphaned
13350	3NLPF3U6V3qPVTY9yJ4QtwUpJB7kApq8EbY7Y46ERneQfuqyufv1	13347	3NLZ4ZXBAkadtXyxMVuG7fv5eVBhWE3eMU9xKafcYD4RTUJ7pexK	298	1308	198	6301	9605	jwd3MMyHhX97YGnQyZBDefpcMaRqkoNsofCE92xnuxpJjhKstZ2	6881	9723	9723	1617689340000	orphaned
13354	3NKBUhv453VBYVkWjg4Nco29gDotuZFnyxRejch5RVaWSL3rG8mZ	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	1589	920	198	6301	9607	jwBHYio5zxyDk48wCwLaind7hWQ6gVNDPQJN5Vhjqthw52Te1ta	6883	9725	9725	1617689700000	orphaned
13361	3NL9SAFBZeuZ47nCdLpLrgbpfHadhHaM2na1WjVbQbtbUXYxjhqU	13357	3NLg8fJRDezEsjE1emcmjUCP9UPDPxr8P11otqgvETPj1iLpgnnD	1403	824	198	6301	9612	jwUpgxyDL2Hh6VtU5x8KnWMrLvE8zdzaCxBdB9Aps1wLJtY1D7x	6884	9726	9726	1617689880000	orphaned
13365	3NLmx2rLWG4WhNuWcqqYaaZUAgM7tWpd5LjdscPmrSKVdgoAG6Yg	13364	3NLEGykfBGQJngKD4sLpxB7gJdB823qjK42CqYeBE1EJDh2XcWNt	1403	823	198	6301	9616	jxFFGjWywvMaJbkEqs966YdPkKGj1zM3PUKPtGEua5mctp2by4f	6887	9729	9729	1617690420000	canonical
13368	3NKZzMLH1ucDgzhyrpePVVUyAPamd78u9q2aQBoJiTfTPqAMpNwe	13365	3NLmx2rLWG4WhNuWcqqYaaZUAgM7tWpd5LjdscPmrSKVdgoAG6Yg	1569	485	198	6301	9619	jxHtubcVhkHpUyETiUUyianD8RdzXyGTVFmJMkSfbyCeJpDRZbV	6888	9731	9731	1617690780000	canonical
13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	13380	3NKpzRNAsvq9AXCxGWLfSsQCTRnv2DRcS2z4fNqKf8zn15KmDcfb	1457	1025	199	6301	9631	jxwt22RXwzF6VKde6g9tbWvrAEWwgB75XmiSw4TBAaGKZuBSQMt	6896	9744	9744	1617693120000	canonical
13384	3NLqiHWRpA8DC7ga74dpZKMXBndSVxE5KPYmYqCGVnz8LC1uf8VE	13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	1439	1279	199	6301	9634	jwjgZU7KG2F6C33VduG6Tfgv4ZU3JAFpYsbPKF7jqcCqvfvBU4b	6897	9746	9746	1617693480000	orphaned
13386	3NKwQHk3GmBDUxFnUjsgMjaWS7udc7VWvo4XUeYXXu1p7tc29zNp	13385	3NK6ywLqTiYxWHGKmxrLugwg1kCMiuDjAkCyTFSWvKaSsr4XeN1L	1637	816	199	6301	9636	jxT7Ddemoaic9Z8AewRqvykc7Gzh9TGBwEwPqMa7y8PHnBc7fca	6899	9748	9748	1617693840000	canonical
13391	3NKCHUZQ7HCUKFEwAQRDCkdF9LC36uxTgZcNu1Lis9jXPs9zaURj	13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	1448	1311	199	6301	9641	jwv3hAngujTZ7TAAPJ8Y5xF4kUhYM3uKMEQF97S5ynLfoNnb6KR	6901	9750	9750	1617694200000	orphaned
13393	3NKqNR7BDPo3nNoEcySEcq8Y1b4szkGrGKJ58cxaVms82wxS15Mn	13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	1406	1393	199	6301	9643	jwioZZTUHXH1DcRWJ1vxf1dvhrebkShfZZ4L4xxm4vZ69fTZCSG	6902	9752	9752	1617694560000	orphaned
13404	3NLcAad2Z8GDgUDymvyiyLpT6PbcUbm9KUYE6iR9tcc7qVbAH7An	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	1647	1176	199	6301	9653	jxpeVcSLoZJgdHCsZzkDQeNdzAu1gV2dY8zQYpU7oCpka6MUFdJ	6905	9758	9758	1617695640000	orphaned
15717	3NKoqAuw2HhM9dW6kgbtVsHTNBCZmZYaVf4ywg2UjNx7z1QVWU5Z	15559	3NKvmoNKFsKTiHYb1dHGvNNtTUzB2vzHoo7dws4uSqPasA1uG6Ez	1507	1034	247	6301	11726	jxuk67cj6mfSMF1DeZW5YtvGyqN3mvBNNs1XzkSNDG6ch6tZdwB	7844	11312	11312	1617975360000	orphaned
13318	3NK6GfyT99L3Wpd9ST9pExjhKNeyLptq1oh7EWkeYKuLgBzzMzEx	13317	3NLejpeZ5TrXDuJsomJmtReyfXR3hfcAgAtUwgvbEUSpoHEXLw4d	1419	814	197	6301	9578	jwBynTdpac9uRMtJWGWfWjKZmMEm37iM4CshoL8ZyVx12EY5Wyv	6861	9698	9698	1617684840000	canonical
13321	3NKmYikUXYNNajpFYM7WrBFyXGvAUx19SJqPnYbnAHPdBjRw4R2P	13320	3NLKhYadQv5W8yQCbDfojCFBoDv2T1MrnC3GZaqfB7fsU8hYm2ba	1445	1290	197	6301	9581	jwXsncJYWtQ31YyXDP5BPwxKR8mRfbyZQq7Qz9EyFxXrMq5iJmg	6864	9701	9701	1617685380000	canonical
13324	3NKTWMsESNuKhQom9xc6APM6je2XkNgVbyv7kFtPWoDYrKpXj7qS	13323	3NKeoTcbeU41wV5iTosWYpmVqESqPpvsTJ3zEptJxbWhfeziR9Pz	1403	824	197	6301	9584	jwuqFCW4kv6kzbegfSKuNYYdDcpbmoVnByeW1bKW8R9LZp2nyvM	6866	9705	9705	1617686100000	canonical
13329	3NL7hkDJYBMjoynvRCyrckQ9tySM46wM2HytEBaZs8Jpdsc1R5Xf	13326	3NLBUEXTrv1C4A8HmyBa7GESVVW5yuswhxXzvGLeQMpM3nCTzgz1	1623	839	197	6301	9589	jy2cckHh4RBYrnQWCXTMjUNLTHH5nsVSje8yKqDgw83pjHKJXrx	6869	9709	9709	1617686820000	canonical
13332	3NL2HreiZLPCyFp38D7LV26AYYNwQzHLDC7jScAxftxJtTCQ6Asp	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1602	1369	197	6301	9592	jwZS44BM1uSYiNHQ1MChHHgJ7jbmviwnKq1HA4xg5AbHbij9MPN	6872	9713	9713	1617687540000	canonical
13336	3NLvZbkwbzvCNjegu9ryVmKiH2pm1YdowDjB1LtFhrxBUp6LmTdo	13331	3NKkNeXPMQA8Wd3p8N5oYoSMEsRKW6KNpCXybwtwpcQ1pZaK9f2t	1602	1369	197	6301	9592	jxy1pWpbEJ2Etu7VgprM5yRQ5jhMx1r5pvDjdghZD5XwutmPJcz	6872	9713	9713	1617687540000	orphaned
13339	3NL4NNVEQdQYE2bWdHnpVBjwap6Z6nbeH8V1kdBpDbiMHggRxvkU	13337	3NLAT3y7CVcKH3vyxFcoDnxmJry7mJuargpX4WtJSM2EFnMbpi2K	684	1352	197	6301	9596	jxtqpPBwain155acy4jAxHpowMEdkjJ26MhJHmsS5Vw1ZokZZB5	6874	9715	9715	1617687900000	orphaned
13344	3NLGLFiho3JEjtFPWyfdnufuoHt44CQychtTYrWrwznB8MiqSCDd	13342	3NLbiNE6ambz96d3Qda34GNEFvaWRX7AoUQJcsQj2NksjtkT7Wvc	576	1109	198	6301	9601	jxj36hBTJfuGd1jna4gwR31sSypArfR1LmF7nNdY8fmUZRf7CDw	6877	9719	9719	1617688620000	orphaned
13353	3NKQaHVWaK7K8nBBh9hLirM5cTcsg9LC5dqTSiZvVP1FFnZSXFzL	13350	3NLPF3U6V3qPVTY9yJ4QtwUpJB7kApq8EbY7Y46ERneQfuqyufv1	1483	601	198	6301	9606	jxo6gzRpqcZE6k6ntRNQyg1abZZwPM3Gt1nWfdhtHXeZdrxSyfE	6882	9724	9724	1617689520000	orphaned
13356	3NLZf2V4YGd4EDKytYBPKsuMw1872z3g3gLuPT4awgW3qUwqX3er	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	1652	1069	198	6301	9609	jwKqwjNhb9UFRma2BT3ZyddtPXTpUngcQpGN9KEskh59kFXyvtz	6883	9725	9725	1617689700000	orphaned
13367	3NLo1oyCaD3D8VtmAS4QNBx1i5N8CHAGCk5d3xARa3ckvn2ewy2X	13365	3NLmx2rLWG4WhNuWcqqYaaZUAgM7tWpd5LjdscPmrSKVdgoAG6Yg	1588	1392	198	6301	9618	jxLRZTbwyRDHMk34oJn3xU9Jo8UZ7VaydpEK5Hig35yxib3dNqZ	6888	9731	9731	1617690780000	orphaned
13369	3NKwDqxdqYz89d8Jj7RDm6PpuvCYsaT2LbyPn8F5nUu6CgE3gKv1	13368	3NKZzMLH1ucDgzhyrpePVVUyAPamd78u9q2aQBoJiTfTPqAMpNwe	1623	830	198	6301	9620	jwcyaTebUTZFufs5TKosSPsccNhEBTA4ZQixEZNaCXxymeGyVJf	6889	9733	9733	1617691140000	canonical
13372	3NKqv4rri2vE4aPApXgMAUANav6t4ceCw1fNgKYdEg3y6ro9z2nH	13369	3NKwDqxdqYz89d8Jj7RDm6PpuvCYsaT2LbyPn8F5nUu6CgE3gKv1	1407	1395	198	6301	9623	jwBjtJBV9p6Q2ahgBVWrWiQVR4wQNcGyoqLJX7Me7dbdiN7DAfE	6890	9736	9736	1617691680000	orphaned
13373	3NLLHMDMHMxTNj4gYD1FUSKEC4SmHeejRhCq5kh4zAWJAB6MXsM8	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1649	1383	198	6301	9624	jx7mtkTXBM61xmr9yKE9dx9etTunwBgsG1vCiRDvkeJiVd1456a	6891	9737	9737	1617691860000	canonical
13375	3NLTe4p2oQoojTDmoNtvbs5CwgkBzzX1UisoUfD3nT7tXUX85SyE	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1651	1301	198	6301	9625	jwi3tWDHu586SEVCvW4WNYr7naESvnoH6769XBNeTc4WCxA9CPm	6891	9737	9737	1617691860000	orphaned
13376	3NLabnTFEbVusrWYYkgkE9r6oH5esccpomB1EpzMx5y8k6o1mRpa	13373	3NLLHMDMHMxTNj4gYD1FUSKEC4SmHeejRhCq5kh4zAWJAB6MXsM8	1406	1393	198	6301	9626	jxjEVumAXk5nUQgQHb99DbniZWFauARWhGXV9DsFsQ6hB9SVJc2	6892	9738	9738	1617692040000	canonical
13379	3NL3vWP1GrjBiXJXhxn6re8FJeti7QGzqCuvcEwqJY5Su4tNA5uK	13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	1406	1393	199	6301	9629	jxGB7Add6EQUvEL4u5jXLBNz6VTNPV6kfqR4Sc6vfagsiVUsXYJ	6895	9741	9741	1617692580000	orphaned
13383	3NL6oEczUJiS686PC3MkLm5By6y4R5JZAyLpsG15cS1DZXXyCdPe	13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	1483	601	199	6301	9633	jw8jy3sDDxWNfe1wJ9GtgQxya6AcfSTznmHiQxd5iHNEw3KFEAM	6897	9746	9746	1617693480000	canonical
13382	3NL1afnZYUyAdssgzYZfgtX2qS7t1r6qwYcoBdRdLyn82kTUHqhf	13381	3NKBL8NbmpNXnFwZEsNSRXFHS5dp3HZsHLK7wmwiJsWTs5GFnL2w	44	1325	199	6301	9632	jwzuZb7WKutwpMLvJ86MScgmdgVHQbgayqk7X8z9wJV7awoFZQr	6897	9746	9746	1617693480000	orphaned
13387	3NKQuYyt3DScGLVGEncy6az72jSPwnAQkfyHrvF8pN22kCXm4asP	13385	3NK6ywLqTiYxWHGKmxrLugwg1kCMiuDjAkCyTFSWvKaSsr4XeN1L	1594	1080	199	6301	9637	jxAqcAPR76jQi71WX4rFT59sQWvanDk6UddkUx45bxdpd2sfsrS	6899	9748	9748	1617693840000	orphaned
13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	13386	3NKwQHk3GmBDUxFnUjsgMjaWS7udc7VWvo4XUeYXXu1p7tc29zNp	1637	816	199	6301	9638	jxk1BkjNeujdYzQHTSkNp7rPxuLbh25QpiUt8rQQxDJAgMsfrs1	6900	9749	9749	1617694020000	canonical
13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	1560	331	199	6301	9642	jwoWZdU9utqbe1URCxkXvrcxjwosmGGLy5wsaAzP3pwJDra6Dks	6901	9750	9750	1617694200000	canonical
13390	3NK7jSCk4ENWcb6R2YD8KhGHTZH12SmjurKctMi5Gaj3mD2H3PNX	13388	3NLBm6UEU4Ko6F6R2rAQtyQzKkiWeUHkZ7BSU4qD8YPDjds9UK76	1608	1289	199	6301	9640	jxsYyuSgwRsbLB8eqn8V7ywfQb13RKyFBsp1Gqh4Hjhh9zkGouS	6901	9750	9750	1617694200000	orphaned
13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	43	1184	199	6301	9644	jwsxBZgcySBa561spjbnZySMMcYUpU7WrHcVxH6EmUfpbe1Jsnm	6902	9752	9752	1617694560000	canonical
13395	3NL2Jjj6SJSqFBaWWpTgbfpCUJikQZjcEmqPnnSUZBHkMCHF5zaN	13392	3NLG5a6BukAURGuU2J5ZALEW7Co934F1hDjg1mXWGZuzXhCZbCei	1541	1172	199	6301	9645	jwX7LzPSorjoFZFoJpLr9wmm3NoE5w8gpSubcfb5sYF12mFT1iC	6902	9752	9752	1617694560000	orphaned
13396	3NL92dHeS2ASMuri1jLot4LZ2P61G5k9cLhDaPJk3zqc9peFJkjz	13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	1518	787	199	6301	9646	jwMT9aqpqE8iVQhrKo6PuPmcMxZauXZphkun8fhWEcQndJvWihH	6903	9754	9754	1617694920000	canonical
13398	3NLwNRTST7vMrgYwtDSAvwdXBGk4efLrJMGTaE1nmaVsxJSg8o95	13394	3NLqmQ5E17HQquZtcmP2KgVBmmMXeSfZuPB1tjHq6vqXzTn7n2mo	470	1063	199	6301	9648	jxSaobuGwS3Fw2fxwU929W5sWk35KGGvBKK9jYt9C3sCszgcLuU	6903	9754	9754	1617694920000	orphaned
13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	13396	3NL92dHeS2ASMuri1jLot4LZ2P61G5k9cLhDaPJk3zqc9peFJkjz	1406	1393	199	6301	9650	jxxb4k3HEk3eoboDFb1MS2owS5iCiVGqZt7XQf2U8JhRG8b5MiS	6904	9756	9756	1617695280000	canonical
13403	3NLMwAS7mG8eWHn7urH1qxqSBJEHLtakHRqvdkLzEMw9KohkxsuG	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	1647	1176	199	6301	9653	jw7kVpr8kpj8Sv7x4KR2cVZ8E3vehpj2ZVZispBUCvq11hBAqao	6905	9758	9758	1617695640000	orphaned
13443	3NK33U3d2sVtGq1WX2T8gGVoa8jpRVsyvawLmW6vA9N22yMDz6jy	13442	3NKmqPj6cd7S1TQuzP7KC3rVWshERVtjAyJT6QPDJU4YftwVCbT1	1597	274	200	6301	9687	jwEDAXpaVDVwKzKMyyGEC3MnC2KHWaMismQTzPpDCFFHcEvAF1D	6927	9792	9792	1617701760000	orphaned
13446	3NKALH5hr6sLb4be8aQYk5K6JktXc3Kotfj5VEN5f2tFGR3Tu5fc	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1609	1333	200	6301	9689	jy1bbMpYif7HSZ5VFSWL3hJPyiEY76m8KJLAkRLwQnJqwfd2TyM	6928	9793	9793	1617701940000	orphaned
13451	3NKM2nbUhoFXn6q6PbYT4eyS13TW9KsJM5iAN3rFDVqT2JadQcA3	13446	3NKALH5hr6sLb4be8aQYk5K6JktXc3Kotfj5VEN5f2tFGR3Tu5fc	298	1308	201	6301	9691	jxGC5zQE5sFVeWyYFePrSffEn3wSUtGqN9yzFPh7B6AXmNNC2C2	6929	9794	9794	1617702120000	orphaned
13452	3NLoZBJkpksBmou3Dzszw1j8D77Uuq3Lny4aZ8GTMagNRAyyTcYh	13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	311	941	201	6301	9692	jwGuHcLeWLudSJrBrk3Qt6JL3YvWerd74MPXYeM2EY1Ag3gizuy	6930	9795	9795	1617702300000	canonical
13457	3NK91rDUs2cRVZiD2rnHBbk3QfeQLmtL7SZogKjfEdaATj5AQnoD	13456	3NLNkJ7uqCZiQzcxrsEGvjk1EvycH9eTNjbboeZMx6BPUEUY6eHe	58	1035	201	6301	9696	jxdderksTPexUKgk1tfrA38HX5XTzBMqYc62eq3YvjNs2Ug9X7Z	6933	9799	9799	1617703020000	canonical
13463	3NKP7fnkgkjmvMLxu55BQ1U5JNiCDTZv9LJ5tya6ZueT7pW6WNe1	13461	3NLRNV4eSGQrSNLCt2BPvkLJQG41VFWvN4ivcuFGAWfwnw3b6fEM	1637	816	201	6301	9702	jxYHob2cKmR2CzDF1qjez6kE8SXummRargXzrm7QBr6rzvi3Zvi	6935	9801	9801	1617703380000	orphaned
13465	3NLk9ZzjKSpW2aYCmzwFSDT54hbVZuCYpFYBZdaT5A5EMd6XGymY	13462	3NLq4MAVV7f4wB5L86WNZK7uwaWQw4XMxRL3Grsgru5or5CieX2Z	576	1229	201	6301	9704	jxrMmjovEfhMdWcH4gGJs8w1ykGLSza4swHNEUZvgLLtu7tMZT2	6936	9802	9802	1617703560000	orphaned
13467	3NLKjy7Yv4Pz86VjDaZyDhBeiR3xzZ5nLU1dGN8RYvn7xA3ri6yG	13464	3NK7tce8ujnKPUq9xg66xuwARgpPH6Z9g9QuDTiz2yuxvdbAMbTB	1573	1318	201	6301	9706	jxRASiC13cKdFZQUtEXMP52Ea2x6RTQgrcA7gKy6wuwu9XoVcDE	6937	9803	9803	1617703740000	canonical
20072	3NKU1YbgDjwTs79mWTcKU2VPy924SpenQzomBbDVP4CbwFvgrwmt	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1406	1393	357	6301	12463	jwKxkyt3C5H1o2oDHTmnRRSaSe38i22CEfnywgnVXbMUcWDpYXu	10103	14246	14246	1618503480000	orphaned
13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	13469	3NKXPvE2XcHFpmxRYspz7oRHFkmP3EV1mCGcXtKq7zCcBoHKwv9T	1649	1383	201	6301	9710	jwUPJ6zQMUMtyJVcrnnCWvUcZSmEy55GiisKUKF5pcUZscBLDcg	6939	9806	9806	1617704280000	canonical
13479	3NKTFAnELN8jKXdxTUECW2mWbwCjJPwEXyMoJWLrzQKEtuMNnAgu	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	532	1303	201	6301	9715	jwe2aUMhgPqF38RtPC9GnrxrDxgujrMZQmqrLFw46nxEdy6b2sR	6941	9808	9808	1617704640000	orphaned
13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	13480	3NLPsRy2oTmV4rPqi5LRdvL68BeiMqr3CBUXU3r3buPJD8Ke2y5X	1634	1331	201	6301	9717	jwE2grfw5YLHBUNnt6sDpxMw4cBWo2NaKZ4ErVqZtoWYRGhFdQq	6942	9813	9813	1617705540000	canonical
13488	3NKki7THweuXrKyvAZ6NvvjwZsqmHEuXu5serfMaZqoNskusNkuX	13486	3NKvwjRkEmUjPaFLhgmBw9C5fKpHkMzVp7iF1GVr6zq4kJUYKZk1	1500	1171	201	6301	9723	jwPpwHyQGwgvWgRY6sgimTKLLDyZVACEvshxAFskxQ28bbgpgRV	6946	9824	9824	1617707520000	canonical
22553	3NLKkoNbnWyw8LN3EP7jbcVbRxsecpme9QprMBgNmgCMprbQS3AB	22546	3NKy3y3SVR2StjxQxTsHe3rYcQDChobAt79L8YeFRRkoxoc9yCwD	1553	776	405	12463	14648	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11041	15883	15883	1618798140000	orphaned
13460	3NLEoQ3Eprdkgkx2yxFq2ihJCcE3V23ncEsPNJXjDRzkcXG8x3YZ	13371	3NKWeotB42Suj9Vsg1iop6KJ9trQpJ4C247VVwbcgKqAFtvMcFe6	1588	1266	198	6301	9699	jxNSn52QhqZzrnrWtPYR79WjSARrAqRdxJNcr1sJUQj1R9DtHFu	6891	9799	9799	1617703020000	orphaned
13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	58	1155	199	6301	9651	jws1TAw78zNy2dDFPurFdmWVqF5MKeGCXA3R56nULzPYi56CR72	6905	9758	9758	1617695640000	canonical
13405	3NLNNvYuA8NfTW4amjCg7LZmzQ1nUntFsee6od9Cff5N4YM1KLDm	13400	3NKySxeJeewvS4qNWgqQYpuLtkLdjyYCbwSiWB9Wuom9dUJd3xQK	641	1336	199	6301	9652	jwjm35agQ7QR1Q6EbCbPevX6dhjiuseoYi916V6H3Rg4A4KiL6K	6905	9758	9758	1617695640000	orphaned
13407	3NKSNXN5EJKDj1BS5WtHCwqrfcmKodwX33ubkzGdp1euvX194Tvp	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1419	814	199	6301	9655	jwyCWnxESpxNGehY7VdTVu3FkHguFemvDDSWtTRj3en86vJn2Xg	6906	9759	9759	1617695820000	canonical
13409	3NLjun4jRRgPuVyuxzKxE2DkZ2JayqWCNV3gE7Qr6N3oYjMFKM4Q	13407	3NKSNXN5EJKDj1BS5WtHCwqrfcmKodwX33ubkzGdp1euvX194Tvp	1403	824	199	6301	9656	jwGKxkg8R3PecYeCQHejVbATV8fkRo4JZS78ApnTL2oKkR4KdSA	6907	9761	9761	1617696180000	canonical
13411	3NK9aCwSZcgAmJSfR3GTcxpWyEZ3vNfgTy1g8Awy2CPBshrET9Y9	13409	3NLjun4jRRgPuVyuxzKxE2DkZ2JayqWCNV3gE7Qr6N3oYjMFKM4Q	1403	824	199	6301	9658	jwDYjb3ji3NYhF7riimkiZY1hkcbAWo1phop9r7qB42QjARHziu	6908	9762	9762	1617696360000	canonical
13414	3NLyaniA73pd2sDNm1h14jsjEctrJcCY1RWSHTEJA4pSQRuFk7Xu	13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	1406	1393	199	6301	9661	jxuoyNjz4mfhJV8eUkq7CCRHZZCjsPMz9UStioE8epBhWPmhnJ8	6910	9766	9766	1617697080000	canonical
13413	3NKLPub7XUTn63k7qfxmr2joG2gNmWb1Jzd9Su5THHdPfjn3hEc9	13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	1627	1019	199	6301	9660	jwD8QHT4CrwMi5gdMNMtDk7jrA4EkqphcxGCzAbggmh5H2yVtrf	6910	9766	9766	1617697080000	orphaned
13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	13419	3NLH9r8APXbEYa7pxVvDhPEdNDkiSjJJVKTQbny7vSet67wegCTb	1642	1121	200	6301	9667	jxyH2T8pBSrLS6gn1yHYCbwrCwhTQychX3mcNpY4tkVXxqHx4zX	6915	9774	9774	1617698520000	canonical
13422	3NK8M3StjDDrxo33CZqdp6e67itc8a5V4gVyJPtuPBRiUTSPVk3K	13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	1447	1345	200	6301	9669	jwRTDRXYMo54ygSZW7T6diXauDCX2WzcLBtx73TRLfYhbXQJoqh	6916	9776	9776	1617698880000	orphaned
13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	13421	3NLQc9z2NYtWy1bq7YB6kZ9MsaQU5B6EbmKUVGxNJMbY1tGp1o42	1601	1388	200	6301	9670	jxTudxfSc3hx4eHf3Kgu2nQodfT8igTcDLNL4TXo8nivYQ5qZti	6917	9777	9777	1617699060000	canonical
13427	3NKUH999WNEkomJv6oMPJWY8T9uWz8Kfd2iLycndJuo3Hrcm2BYg	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	684	1226	200	6301	9673	jwJGmUKqyUVjwbCr8tpP97j8CxjuiM34Czfv24apdBaen8KAzA3	6918	9778	9778	1617699240000	canonical
13425	3NLoCfg6BUhxZiTMVuaJUX8d2WVbbXqdoG3gcJoyUcFnESt13eoc	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	1670	1282	200	6301	9671	jxHLv9vUtzkHWUJjTK7Eu7w2Zo4NpMDZSu1t8b4Y9zbPP7cJ8BJ	6918	9778	9778	1617699240000	orphaned
13430	3NKVQx3DSteKFShS4JiwBLJrsw3VorbM2sRQwHcihESFKpgFgJQY	13427	3NKUH999WNEkomJv6oMPJWY8T9uWz8Kfd2iLycndJuo3Hrcm2BYg	1405	1	200	6301	9676	jwRfbRm9y3TYPiCbuAaQ63t9TAbeRwX9p8tqPDUwe9EPLLnJuvj	6919	9779	9779	1617699420000	orphaned
13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	13433	3NLYPPhoMukjq4aPJrqqVijhBgxEDnRRCUAMv5zVF1gsEMmvyT84	1613	983	200	6301	9680	jwZqicCHCnEnVFA6s1iS1q4daNUzupQ9S6k1jUaxG5RMDxKnsfC	6923	9785	9785	1617700500000	canonical
13436	3NLH77jNxQmNTHRvFLHHXEH193We2bMh3CxCff23Fziop21RafsJ	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1523	1321	200	6301	9682	jwk6k3EegsnxW5YA549jQnsryzKkqc4v6QuV8jjkDVznk4FxbGN	6924	9786	9786	1617700680000	orphaned
13438	3NL8T82WkRQUQdhpp7rGWGEJxT7eGBS8V2WzDyHFEMYVqEsHA1Rr	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1523	1321	200	6301	9682	jwRjJUWUr1FDenNtDtrHpCZkx25RjbHkKjPtEhfM4MRq5idizgA	6924	9786	9786	1617700680000	orphaned
20109	3NLZ6BvV3eecioxyEoyyPJPPBZnJU7vZbfKrBw4so12L4EcjGQbo	20108	3NKaQb34WArxsWXF14ZfWENggkT9dZCGN25ut5WNb22d1tpbaRc5	1631	794	359	6301	12463	jwyyve3KFYUyymLV7c1kyjmvtZDUapYUAAdYVsCnHyzH3wVjGxf	10121	14271	14271	1618507980000	canonical
22085	3NL9FAQLK6eZ1wEjP7yrnk1qVAiNA4VNvmTcxiX6AKuAZfbSyANn	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1518	833	405	12463	14221	jwDj7fSSD2d19APQvFJjuZyuW3GdCzoUQ7cZhXv3yh96SC6aqRo	11042	15545	15545	1618737300000	orphaned
13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	13442	3NKmqPj6cd7S1TQuzP7KC3rVWshERVtjAyJT6QPDJU4YftwVCbT1	1403	824	200	6301	9688	jxWPp7E9tJNijncfT8RjvcDAuAKUmyc8A6hnvAVzzdJU4oCskbx	6927	9792	9792	1617701760000	canonical
13453	3NKHaRV5cHawPqB8DMhDAT4UBJCVtXi8EmByhpxopsD9nHD7no9f	13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	563	1359	201	6301	9693	jxKoo8tESupxn6nKKQY49XsbJa6oWVWU4ArsUd32k78xKChUJVJ	6930	9795	9795	1617702300000	orphaned
13458	3NKF7FUBmrHFYm7soTcSvdsSQiYsesnqauYxFWv4SYP595EWFTKZ	13456	3NLNkJ7uqCZiQzcxrsEGvjk1EvycH9eTNjbboeZMx6BPUEUY6eHe	1588	1266	201	6301	9697	jxs4RuJFSrrxMu8GmDM3W7gryUj5xiXTyYKqPZTUXTaHJw326P4	6933	9799	9799	1617703020000	orphaned
13469	3NKXPvE2XcHFpmxRYspz7oRHFkmP3EV1mCGcXtKq7zCcBoHKwv9T	13467	3NLKjy7Yv4Pz86VjDaZyDhBeiR3xzZ5nLU1dGN8RYvn7xA3ri6yG	1654	1340	201	6301	9708	jxEMPZ1xRWr9jbKrc5rXnNkLwJLRJxnXoSjRGwaC9JVunWPkjzp	6938	9804	9804	1617703920000	canonical
13472	3NKrLtikxFjCi5q31ycTjvFM8xr4JZ54eNWVcwWWr7f45iC4D8BR	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1607	1102	201	6301	9711	jxa27tBq7oKgMLUGcoR7szH7MLPeRWLc9Js31NAy1w4Z4g3Unr4	6940	9807	9807	1617704460000	orphaned
13480	3NLPsRy2oTmV4rPqi5LRdvL68BeiMqr3CBUXU3r3buPJD8Ke2y5X	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	532	1303	201	6301	9715	jxReiHPhBEQRvX4f3RUpAM8kEi9ffDdxb6EdKQnHg7ATAx9bwiv	6941	9808	9808	1617704640000	canonical
13476	3NL7BgW1GLT3qT2VF13m5AZoLaEWzYccaLmJG97E7v9UZ9um1qZr	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	1448	945	201	6301	9714	jwHZje1NRxm5xR8HzW5ZAU3mbk3vJLs5NNuzVX9Ad6a4tmsqntP	6941	9808	9808	1617704640000	orphaned
13482	3NKUzQ3CQgZjCz6YsE2pnBYCkBT5GCMMmp82SxSyVhECfxPKsXAs	13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	1447	1345	201	6301	9718	jx2vaVpV1RUVxPb43zWUSYnHsJ9JWiQCwTi7uDhCifG4RVZaqra	6943	9816	9816	1617706080000	orphaned
13485	3NLdKCpW1hw5BoRGoW8HBRx3DLTjCPYPch1xGnjxdTsjX98v2EBD	13483	3NKrgg5FwoqC3HWfqFTNqkHPqpr4RbqKtNe4DtbP1QjxtbNaAQmV	1483	245	201	6301	9721	jwwLvdBGug8BESErAsx6uszSNZQqZzr8TtRyQ51aPREZRYcGCz7	6944	9819	9819	1617706620000	canonical
13493	3NKYbcsMWXyyeULTfuEESTXppMjArsSXVKUuQMmXsZvatqzhjFx9	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	1474	963	202	6301	9726	jxkxzcHqX7eL9qLLsoLXBNnXMS88YMKfykcuTizmwANfykdV685	6948	9828	9828	1617708240000	canonical
13440	3NKeNK9ikZZfVSMFLB9iXyqVt5cLQtg2umumaXTtEodUYq67Hv48	13417	3NKR4bs7JEM6DYEHyJYHaQSEhWPm5bodCv6GEoXA9A4MN1uw5PPg	1553	776	194	6301	9684	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6795	9786	9786	1617700680000	orphaned
13468	3NLhMsrUgpVUmX15f6V1137ReoNhcRRYyxZvXMhJJJRwPQ8n5rhH	13440	3NKeNK9ikZZfVSMFLB9iXyqVt5cLQtg2umumaXTtEodUYq67Hv48	1553	776	194	6301	9707	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6796	9803	9803	1617703740000	orphaned
13514	3NKuYyoR4fvP3YHHKyUP9G7xyfDpaYfP1PPZf9MvYAf6MVLfiaCB	13468	3NLhMsrUgpVUmX15f6V1137ReoNhcRRYyxZvXMhJJJRwPQ8n5rhH	1553	776	194	6301	9746	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6797	9841	9841	1617710580000	orphaned
13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	13411	3NK9aCwSZcgAmJSfR3GTcxpWyEZ3vNfgTy1g8Awy2CPBshrET9Y9	1652	1189	199	6301	9659	jxupBcDYm5PurY6fwW8TN1F6aWH8XBGRxrbVfwP9WTpWwNQTDd3	6909	9764	9764	1617696720000	canonical
13415	3NKdAHJNCaQ3pcDXtypnrjfoAVLUKQxC4r4ARRjgZKexRzBkjhGK	13414	3NLyaniA73pd2sDNm1h14jsjEctrJcCY1RWSHTEJA4pSQRuFk7Xu	1407	1395	200	6301	9662	jwcWT5RbKQsfh2yP7HcF91X6taTPz9Z1LYmjosqAfTVvypyhgQP	6911	9768	9768	1617697440000	canonical
13418	3NKyzD6sw6MEfr7RrBopp23pdimh7VB8vPDSp4wXdRWqXQDvNJFZ	13416	3NKdbYpJZv4hJsVZ24CpjftJ4xfufKvpACTsMF6CV1vYAAAA3kj7	1637	816	200	6301	9665	jwtjzZfzwBq2dsGeAqTuHXypwuduFKNrkG1Fv8gZfV3ph5441N9	6913	9771	9771	1617697980000	canonical
13421	3NLQc9z2NYtWy1bq7YB6kZ9MsaQU5B6EbmKUVGxNJMbY1tGp1o42	13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	1500	1297	200	6301	9668	jwHZC5YXXMvygVrKKzjKxBo4Xf3UUZ4EJERw1jwFQ1orhQWyMDs	6916	9776	9776	1617698880000	canonical
13426	3NLAzMYysosfx1Yc5prP8ngZ29ogH6pmfPdbCHwpzt7y7YR3y4mx	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	506	506	200	6301	9672	jxsRsNo8wvXoEXit95PB4RJYaAx6p3p4yD28gxv4rDPKy1y51WX	6918	9778	9778	1617699240000	orphaned
13439	3NKzLvSHLcoQFSfmeF913jSd5bkzNJXHBbr4275qsuE4HMgkhEPo	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1523	1321	200	6301	9682	jxT18adE93xZ62synz8t7cMg4Swek4wNV1F8ZmSG5AuDwppqsjW	6924	9786	9786	1617700680000	orphaned
13441	3NLDZtq14an7Lk1PLAbCa59We47EGWHwq4Co2eFpb6BToQK2ZTha	13437	3NLSTxvv42YwequoPD5fNL88QPrzpxUMr6Z1kuJj99b2bDHzoUZt	1406	1393	200	6301	9685	jwMuGjSrqCdWobGjNQbfYp1gmVFZi6soigHZgwKrMnBoSCNxqYg	6925	9790	9790	1617701400000	canonical
13491	3NL9ab6WvV6MbRGxX8wk5DLCmnmrJEEwYYwSiMGwXFwmLdX2jtxu	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	606	1295	202	6301	9725	jxZ8GVC69W573GnjiVZ3DbwTEpfsHPWAgSXzijv5n67TCUUqQLM	6948	9828	9828	1617708240000	orphaned
13495	3NLgjjgayGLuQmiDwVJCV7PCfqa59jY7P6yJ4QWHWp7bzVJCc979	13493	3NKYbcsMWXyyeULTfuEESTXppMjArsSXVKUuQMmXsZvatqzhjFx9	1490	908	202	6301	9727	jwRxsbcWvotyEt6fk57BK5Rc5xiYw5eaM2cqYAxWLQFk587Zj3i	6949	9829	9829	1617708420000	canonical
13498	3NKeRsSNfB8cwYVhGVqb5tx5oQk7aqXhctHJvLGMAdU7czwvyTBf	13494	3NL7W7BXLZUFE5KcSSddfkUx9qTnKydz87XC6WGnQoLQepWn9kAy	1407	1395	202	6301	9730	jwNnQQJnjT5swKz9S2btTov9v7WS3iEt1UvAiQ2mnAEo7zbULXE	6950	9830	9830	1617708600000	orphaned
13500	3NKZqWNx7tukhU3LQARB9wmxSr5MqpnAz2wNiEa18UeF8LuJDZbd	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	1648	1284	202	6301	9732	jxcMAQmS5EoeWHjTLBsKDEJRTb6kjgtWtFNPy2Qyea2oy5c2B34	6951	9831	9831	1617708780000	orphaned
13507	3NLV84D32YRYvVJq4Le1uSx2uCpjbuF1mwnAM65Zi3adUDMzxfeV	13505	3NKYNk9D8K9mEubb8pRvcjbg73HsxHedBaDa8eLrW1mc5Mp8JCYo	1547	1252	202	6301	9739	jwcCYkogxXJmdv5hzQG1XW6ipqT92V1wmMKUi3FHt8wgiehBWoH	6954	9836	9836	1617709680000	canonical
13509	3NLMY9HDSdhrS9PdFXAgzzJSbdmXGWiGHJLzruymsoVw5eHTovfq	13505	3NKYNk9D8K9mEubb8pRvcjbg73HsxHedBaDa8eLrW1mc5Mp8JCYo	298	311	202	6301	9741	jxygLfvLK8aRj2AuDzytwAm4gHaaR5Ga6BDgGupPeQd42mepjQT	6954	9838	9838	1617710040000	orphaned
13511	3NKZNTbXnr4mNCoceu6pnwfuBHhNKTJrfFsTNfCoNQ7ARM2vj4e5	13508	3NLRTBLaawfFhrPCHTzrAwE7fUNVjU4tH8iSrWu7dWEwqqaCjjMM	298	311	202	6301	9743	jxdKLf4jx1SbGdNNyeQetMD3wxD7pgv6oUdYBpiVqBkrKpG4y3C	6956	9838	9838	1617710040000	canonical
13516	3NKFx4i1ZzfBgiJxXavQxvUVt7n3AYwvN9jD7DuUjkcUDbDMfy8L	13513	3NKwyxXBpQvZ9paF3aLXPU65eMAW3EhRDcDWwKcPcAyFrFNDvCM5	1471	1386	202	6301	9748	jwjDQmXBmdStYPwSc2ZTWHVeAMdsPDB5EJsFV2sahsyPr6V3We2	6959	9842	9842	1617710760000	orphaned
13523	3NKDaKaKxB8ta3YbgDjfh96XwLkzkhgkTNtCNXuQBC3ePyvouWpT	13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	1648	1284	202	6301	9754	jxM9E7pBFoeJRgB3q3czjbRFzgq6VPQz23ghxN6uLrxKDbBB81b	6963	9846	9846	1617711480000	orphaned
20147	3NKHeTbu9H6SrRR1MhfcAuA344oEDJcAh45qY9yKGs5Ug6bmR11j	20110	3NKaccQknFLjFbxrakGztYH6vEFuA5HAHavCgbFFyp6NdmmTc38v	1590	1300	359	12463	12488	jwFfG1SaMJgQ57C3mKzvUUdmECJzFpPCopbwtrZ13Ryk7xSW3KT	10123	14294	14294	1618512120000	orphaned
13445	3NLyN68AoRPLrbTURNdQEFxUew9RidBBpXFPW2XRFSnNH3mubu7z	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1609	1333	200	6301	9689	jy1bbMpYif7HSZ5VFSWL3hJPyiEY76m8KJLAkRLwQnJqwfd2TyM	6928	9793	9793	1617701940000	canonical
13448	3NLZaeT9DAd3LmAeem1BRbCWCKXW97DfFsukEEWzSd8tLLhkhU4r	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1651	1175	200	6301	9690	jxnBPXFRDCsLo8jM6yXySa47nAbUasbEDeyf48YoLfeThTGMeLF	6928	9793	9793	1617701940000	orphaned
13450	3NLhHsoP25WVyrpGgVmbJJrFvi8w2iCyFZZ9YVExWTdXHkmg6M3m	13445	3NLyN68AoRPLrbTURNdQEFxUew9RidBBpXFPW2XRFSnNH3mubu7z	298	1308	201	6301	9691	jwvcsFtcAsM9z4ysM3nGgJNwGsjUhPbczXmpT99v6c39dxEk9YR	6929	9794	9794	1617702120000	orphaned
13456	3NLNkJ7uqCZiQzcxrsEGvjk1EvycH9eTNjbboeZMx6BPUEUY6eHe	13455	3NLcYsgW1B5AGnGQ9qoH18a5MJ7NJz67MHfXWnEAqusJ3e1TVQo2	1627	1259	201	6301	9695	jxEHG4Am5ddVNFq24j1efDjzJBHdqcax8CtWgZUEyCctZUXCgRP	6932	9797	9797	1617702660000	canonical
13462	3NLq4MAVV7f4wB5L86WNZK7uwaWQw4XMxRL3Grsgru5or5CieX2Z	13461	3NLRNV4eSGQrSNLCt2BPvkLJQG41VFWvN4ivcuFGAWfwnw3b6fEM	1426	1364	201	6301	9701	jxAsGpWCAhx4GCqVUGmb8vFybg4R9YqFHu19NRZfxmZQrgA7xVF	6935	9801	9801	1617703380000	canonical
13429	3NL35MZ3QrLRDsrJ7Ae3aznihcCZRZvs5FUuXshTSrxYpj1gidWr	13427	3NKUH999WNEkomJv6oMPJWY8T9uWz8Kfd2iLycndJuo3Hrcm2BYg	1600	1372	200	6301	9675	jw78kUtvL6FtA3jb8jiFe2Da4SDiyeo2cymK9HEAK9aEkKKs912	6919	9779	9779	1617699420000	canonical
13431	3NLb6kxoA1iVAyPRDjR5BUrNWTxjd3mNwqXD6eUsXMnNdgAEpsYr	13429	3NL35MZ3QrLRDsrJ7Ae3aznihcCZRZvs5FUuXshTSrxYpj1gidWr	1419	814	200	6301	9677	jxwZJaYMZRXvz3yVoEWVXA12Z8GtzvWHgYLo7WZbXgLg4Z4YVC4	6920	9780	9780	1617699600000	canonical
13432	3NLcDz215yAMVD1ENw67QDNNBXbazb91DXXd9R9KmTgZwMx9Q1Ls	13431	3NLb6kxoA1iVAyPRDjR5BUrNWTxjd3mNwqXD6eUsXMnNdgAEpsYr	1406	1393	200	6301	9678	jwD7AMYLuuiJvjRukKZ32ACESjeQuECxcBo4VFcmjpJL7XPqkWS	6921	9783	9783	1617700140000	canonical
13435	3NLB3V9cB5KKzPvKCCyHG1i8mQS9fQ1bzgJkacFQiQFpZxeYuYo9	13433	3NLYPPhoMukjq4aPJrqqVijhBgxEDnRRCUAMv5zVF1gsEMmvyT84	1506	1373	200	6301	9681	jwEnp5VqvidHhQJ7ytu4matucd1RvhX6y2LET2mbX7gvnopQbpp	6923	9785	9785	1617700500000	orphaned
13437	3NLSTxvv42YwequoPD5fNL88QPrzpxUMr6Z1kuJj99b2bDHzoUZt	13434	3NKqFcoCGhTYvwrL11FzDSYwqM2XXxvdreDs6ACsAvj4QaFwWe5Y	1649	1137	200	6301	9683	jy1NQiuccYYuDh6EHfZKqmddFx7dD2pSbUcMCosG9TsEFJzrmC2	6924	9786	9786	1617700680000	canonical
13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1407	1395	201	6301	9713	jwBEyAR9AHMnx1CQefmkugKG2Jqx8uiqRPaUMG31M93exG6f1gB	6940	9807	9807	1617704460000	canonical
13474	3NKCJiqTPaLm2Jz2iStoBLLDY8H2TQovPSiCzE3MKMebVyPXVma3	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1607	1102	201	6301	9711	jwLCQSfoJd53SDC6ctzCfrq8L3oZCLRrQq4S297BwHpFxdtZvHe	6940	9807	9807	1617704460000	orphaned
13478	3NLWtGzYV3iChStKMwwNuCqz5vAJXKabvVLMbWP8H4w7m2cZbEh5	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	1407	1395	201	6301	9716	jwQme9ZV5wzqyVbxUGabTVSUYXRRjrs3vLTLMB3GDcfSJMkRhkp	6941	9808	9808	1617704640000	orphaned
13484	3NKxbsM2buC8k5cMBHkW5texBgN111FE71AP67kGx6V5P3EZR3u8	13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	1506	1127	201	6301	9720	jwvJyqbm8UXdrpS5WFcQR5o5Pt9L3ooxADfWy2dTABEkSiUDGMJ	6943	9816	9816	1617706080000	orphaned
13487	3NKMYQKdgmVVET3zFykiLZVZc76Pzaf9y4zdf8nJUU7YRdM57TsX	13486	3NKvwjRkEmUjPaFLhgmBw9C5fKpHkMzVp7iF1GVr6zq4kJUYKZk1	1500	1171	202	6301	9723	jxtrRFGjZ9aC7kzM1zfLVWRCwJbkXKf4DttJukSDzWGgb7qkMhm	6946	9824	9824	1617707520000	orphaned
13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	13488	3NKki7THweuXrKyvAZ6NvvjwZsqmHEuXu5serfMaZqoNskusNkuX	1647	481	202	6301	9724	jwQZhf7rgwcgu3hCyY9SwYtmNHJTKc7tduxPpmjG47wWtdQcjij	6947	9825	9825	1617707700000	canonical
13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	13495	3NLgjjgayGLuQmiDwVJCV7PCfqa59jY7P6yJ4QWHWp7bzVJCc979	311	1061	202	6301	9729	jxT6rPWZS9TPrZRsNDcivNycm8FjaHiqfSi5pWzycPHidVQ6uLH	6950	9830	9830	1617708600000	canonical
13499	3NKKAJXUDiYCfZcYYkNYHJ7J6XGBtRiYmuebsqhTrxFf1zUPMaaS	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	596	940	202	6301	9731	jxDQzK4SquJqjyrAjADNG5DQuC7BLD6HQQpKvU3vSuLkXyaGtuQ	6951	9831	9831	1617708780000	canonical
13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	13499	3NKKAJXUDiYCfZcYYkNYHJ7J6XGBtRiYmuebsqhTrxFf1zUPMaaS	1589	1160	202	6301	9734	jwMHkaW2ERbvMid2CqAkpvMUptzp9ZHGBWAuruaRXs8BK716opf	6952	9832	9832	1617708960000	canonical
13505	3NKYNk9D8K9mEubb8pRvcjbg73HsxHedBaDa8eLrW1mc5Mp8JCYo	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1406	1393	202	6301	9737	jxzsUrVqKdtrNCm1yD9Bxz6yx1uPYTU9wSywmwgL394WMc7C6Le	6953	9833	9833	1617709140000	canonical
13504	3NKgVJ5odoEZiU7Sh36VeAuMKctKF74z7XUaTtNgkRG9LkPYTLJh	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1440	1377	202	6301	9736	jxKMKnMRF1PE2X4Bt7JKRZLiKz7cRfzihkVQv4JV6vvQB3rA4Lo	6953	9833	9833	1617709140000	orphaned
13512	3NKrpHYf89WsYDqNftKckvr8bn32HdPJr44qux6ExCuzWq8KL36w	13511	3NKZNTbXnr4mNCoceu6pnwfuBHhNKTJrfFsTNfCoNQ7ARM2vj4e5	1406	1393	202	6301	9744	jwyMefEmxgzf9viBUnMijyQ1jSb9ZshyYT57hZwKTDSpAvxLJuN	6957	9839	9839	1617710220000	canonical
13517	3NKC3dn19fKUn575JSXjQGDQ4EqrUdT6XPCJ6f3sx7BkbLJANibc	13513	3NKwyxXBpQvZ9paF3aLXPU65eMAW3EhRDcDWwKcPcAyFrFNDvCM5	1471	1386	202	6301	9748	jwVHoP7YhUbgGF8XD2qvVTb1EsmKVd3nGUwzqo35b4D4U2CHZSb	6959	9842	9842	1617710760000	canonical
13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	13517	3NKC3dn19fKUn575JSXjQGDQ4EqrUdT6XPCJ6f3sx7BkbLJANibc	1448	1311	202	6301	9749	jwbbxc28XMvHxUG8kBv5VH4EKWhj1GpFoHjrY5eHR4W6MkM9raA	6960	9843	9843	1617710940000	canonical
13521	3NLmUpQzSfGyddXvEvfWgTfmB8zCYsNi3rtXKu2RTJY49meNKcUD	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	1633	1144	202	6301	9752	jxm4jmt9t7gGwX6tN4GRLV9EDpXdT5Ers1QB1vVB9CNUZFSuBQ3	6961	9844	9844	1617711120000	canonical
13519	3NK6mYs2wj1gyQKao5PySNypL8CUwvS5HCYU5kZJJnCqF4DYJu81	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	152	964	202	6301	9750	jxz72ZtHgwnDm51ZLVqpYkZQQkCjeqP76Nijkb3B1D8grcp3xUt	6961	9844	9844	1617711120000	orphaned
13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	1406	1393	202	6301	9755	jxyGHCo4pNeLxZNBqwLX9dUxHkkwUXTQ7rRAC58Nuhby2TAWP4T	6963	9846	9846	1617711480000	canonical
13529	3NKnV1ZkNe8g3UV18d47mG8SmsiAzpfR2pXoDHKkZDxpSQMhmdit	13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	1522	956	202	6301	9759	jwfkv1EVDSRiCw5NxCX6ZBKbsd3MCEbCtkg9YWCcpsUJdRz56u5	6964	9848	9848	1617711840000	canonical
13528	3NKocv2SWkSNxMHrmyWmazNzj4y41DhseUrC3epca32WAzJfqC7D	13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	44	1199	202	6301	9758	jxSzXvQvqBXGaCXvGY6NnfEq8CaKeqsy3ksRaq69WfyZRtc8iR3	6964	9848	9848	1617711840000	orphaned
15404	3NLAC6VKdxkKZ9SWViY1UytdRGtkmoj7YTvmj77wwBqSwZyg8MwS	15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	1643	1299	246	6301	11441	jx7HLJYRp7ZjM2zJ8GjL1eYSrD6Y1EWjdq4U9xQPT8nLH8LnC9E	7846	11097	11097	1617936660000	orphaned
13442	3NKmqPj6cd7S1TQuzP7KC3rVWshERVtjAyJT6QPDJU4YftwVCbT1	13441	3NLDZtq14an7Lk1PLAbCa59We47EGWHwq4Co2eFpb6BToQK2ZTha	1403	824	200	6301	9686	jxFTLy3zg7JJZ3SyfcwTgB5svRGKGNe1dn9jXX98rX1H454Tgk9	6926	9791	9791	1617701580000	canonical
13447	3NLshFJq6dgHTivsSE5Va6mNKV2T6Riq8UQSLpSWbAEo2Z9A8f65	13444	3NLGKvER6J1ZUnzVPaEoqp3apxnpa6n7P8SLT2a5SksQxG1hmQkp	1651	1175	200	6301	9690	jwLhHHesS8diTkZyfPx4R627fnUHFRFJSMa3wZ8RsUzWzBNnQ9n	6928	9793	9793	1617701940000	orphaned
13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	13445	3NLyN68AoRPLrbTURNdQEFxUew9RidBBpXFPW2XRFSnNH3mubu7z	298	1308	201	6301	9691	jxGC5zQE5sFVeWyYFePrSffEn3wSUtGqN9yzFPh7B6AXmNNC2C2	6929	9794	9794	1617702120000	canonical
13515	3NK8Sqk3SyxzpK68pLCppT6EYYsLwRxjhVvBSVPUC5XjUHHAXFrr	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1471	1386	199	6301	9747	jwSnYJh4TV74BJWaMDEuViREr5uK1P6eQJqXwtMCoJDKTzZxrzY	6906	9842	9842	1617710760000	orphaned
13553	3NL9gYS1QzPZ6RhpcDdiYQAMEB97M1EHPi6niE73HY1X42jPrbGP	13412	3NLfbuqPkoaLxcMLEgBueeGypFnHLN7eeLRNUBYMH6LJotMKjFQY	1588	1392	199	6301	9777	jxvHK4dh1PnkBHVSyEn9hqGQdntVzvHkyR166NM6y4ydfV1diVm	6910	9856	9856	1617713339779	orphaned
13454	3NK6eBw6YdMBd8tFAYPr18EC49kLLsCa384HSQYSSP3E1B21RveM	13449	3NKdGavk8phLyydptCLULTYycZW4E4kyuqaT5sCTURDocBrew68q	563	1359	201	6301	9693	jx3TEYpvT41rAUWTDsh49WDFCCX4ZSiwfrmaEEADSWCJQTtugzp	6930	9795	9795	1617702300000	orphaned
13455	3NLcYsgW1B5AGnGQ9qoH18a5MJ7NJz67MHfXWnEAqusJ3e1TVQo2	13452	3NLoZBJkpksBmou3Dzszw1j8D77Uuq3Lny4aZ8GTMagNRAyyTcYh	1581	778	201	6301	9694	jwAkRmtwLVjZN77tQrvqdoRJ6aCZLRfyJesZdTwER9Wrw5pSLw4	6931	9796	9796	1617702480000	canonical
13510	3NKsP2zMQJWdZkYuRUgHN8mjNcW74uy6Eokm7ckWWNiy4FjMMBgi	13454	3NK6eBw6YdMBd8tFAYPr18EC49kLLsCa384HSQYSSP3E1B21RveM	298	311	201	6301	9742	jxQoRFm3ZggMWE77JrQEpzPjN4i6hL2RhiKAkKkmDoFVieHyRGq	6931	9838	9838	1617710040000	orphaned
13461	3NLRNV4eSGQrSNLCt2BPvkLJQG41VFWvN4ivcuFGAWfwnw3b6fEM	13457	3NK91rDUs2cRVZiD2rnHBbk3QfeQLmtL7SZogKjfEdaATj5AQnoD	1622	1110	201	6301	9700	jwSNHza4xf2m45zfdyeRDiseYGEmJpVhExaCteHUaiGokSz6V6Z	6934	9800	9800	1617703200000	canonical
13473	3NKbuFPDAc55VCodpuE8eyU23wReXVxbpkeLSj15cQjsArhCm26H	13471	3NLWWDSeRSdWg6hsjVC3eGrspe5rn2TyLi3v3ggXxBYRbv9W6fXm	1406	1393	201	6301	9712	jwJnCPQ1codJcY9KHzPUuTHmPqQLsMWKMPo5h8NrmF3B4VM9qS1	6940	9807	9807	1617704460000	orphaned
13477	3NK4kAe4iyrY2BJiCAyeAU667wqg3B2gfgi7xmMjJ6gDRYrEso4g	13475	3NKbk56xPj8MA5R1Y2VtLYy5qpH3HZXJZczMB1yb4qdmLw2NkGit	532	1303	201	6301	9715	jxhPsTdXPwow5zHMo1G1cihYzDF5QUvX7ZzDAHsCi6cb46LtDgH	6941	9808	9808	1617704640000	orphaned
13483	3NKrgg5FwoqC3HWfqFTNqkHPqpr4RbqKtNe4DtbP1QjxtbNaAQmV	13481	3NK5LZEKjyMmtLBXtvy1uQYQVC3QuknH7eKtYh2HiNpC7XZDo6rT	1673	1122	201	6301	9719	jwxM9gwRPpmLSVmE3K8t6cGH2h5bN6EtbE1uz6xSURG1nHDTsGL	6943	9816	9816	1617706080000	canonical
13486	3NKvwjRkEmUjPaFLhgmBw9C5fKpHkMzVp7iF1GVr6zq4kJUYKZk1	13485	3NLdKCpW1hw5BoRGoW8HBRx3DLTjCPYPch1xGnjxdTsjX98v2EBD	1406	1393	201	6301	9722	jwyHakycDGCDCM9vbpHTTUp4UiHwGDJZ24otueP4uhzzkSERa8q	6945	9822	9822	1617707160000	canonical
13489	3NLvLjuvE1F6dnqLpFYVk3oLcDe6XY4KmUd9zQxrNmSdoeLj2WS3	13488	3NKki7THweuXrKyvAZ6NvvjwZsqmHEuXu5serfMaZqoNskusNkuX	1647	481	202	6301	9724	jwBQK61AiMZT6mUF4Cu4hEfveofPZkM8SWadSyamTRPgrBvzQcS	6947	9825	9825	1617707700000	orphaned
13492	3NKGSGdmE4RfmgVEh6AUkvvVPKPQEN42WvB7qPx6WnNbwQ22pD6j	13490	3NLNn83zbxJbyQPVeeKDAa47xSJPbChdnFAATCu3BnU76KayfXiR	606	1295	202	6301	9725	jxeNM2C7njCxg6wayip4k53ocd35662t753aw2CWQUnKnZjmgGs	6948	9828	9828	1617708240000	orphaned
13494	3NL7W7BXLZUFE5KcSSddfkUx9qTnKydz87XC6WGnQoLQepWn9kAy	13493	3NKYbcsMWXyyeULTfuEESTXppMjArsSXVKUuQMmXsZvatqzhjFx9	1490	908	202	6301	9727	jxR9v9UFL79bvpiKLCy7YdY5EA33gzgcCUsGkCLJTsnzVeuK3JP	6949	9829	9829	1617708420000	orphaned
13496	3NKEiqETKyqMdzcgmok6V2HhM8hnd6Zuf5pcrZCmz4Ktgp2FCuhN	13495	3NLgjjgayGLuQmiDwVJCV7PCfqa59jY7P6yJ4QWHWp7bzVJCc979	407	407	202	6301	9728	jxHpNLQxTUCGeGEaSpVF3TWA1bscnWb29CKhgjV8GNLBk8ZkRGa	6950	9830	9830	1617708600000	orphaned
13503	3NKYCrjgDS99Z792BsNkNW6C9Zh3JXMGk9EHn69wcXodkAnigYqB	13502	3NK99VGJKqCB2N2dYGCKg76CCKvmXuquri6shkW967imdL3YkEa7	1600	1372	202	6301	9735	jwVpsG1azDJCBBGW9HuaYPBgLy2xfcEaQ1rRKtacxXVPydvaF7u	6953	9833	9833	1617709140000	orphaned
13508	3NLRTBLaawfFhrPCHTzrAwE7fUNVjU4tH8iSrWu7dWEwqqaCjjMM	13507	3NLV84D32YRYvVJq4Le1uSx2uCpjbuF1mwnAM65Zi3adUDMzxfeV	1634	1085	202	6301	9740	jwpygEioWmdsEVTm9REnoYLoXgSBJDE1iw2CjA1rBugpBicbDXc	6955	9837	9837	1617709860000	canonical
13513	3NKwyxXBpQvZ9paF3aLXPU65eMAW3EhRDcDWwKcPcAyFrFNDvCM5	13512	3NKrpHYf89WsYDqNftKckvr8bn32HdPJr44qux6ExCuzWq8KL36w	1406	1393	202	6301	9745	jxT55bqSqP8A8SiKEJ2GPvMpamNR1h96RtwcXXai7bM7rgmZC29	6958	9841	9841	1617710580000	canonical
13520	3NLhfgf7yskffDHntoRkTTguf4toiKKQ32aGjD9U6V3qDZqBcNDS	13518	3NKsDigFKmcw5msS9agzWZhyF33ALo8kTijPf4tFKUQaywvKg7ng	1589	1160	202	6301	9751	jwerok3Dev5sus1fkx7qXE9chNqQHWTJpykFLC5bXUUP3LiTzWQ	6961	9844	9844	1617711120000	orphaned
13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	13521	3NLmUpQzSfGyddXvEvfWgTfmB8zCYsNi3rtXKu2RTJY49meNKcUD	1622	1356	202	6301	9753	jx9dcgeSapLAQp2w7cXN1JrMBLX2HoW7wHsd7Wv4gQRaFaz9ERm	6962	9845	9845	1617711300000	canonical
13525	3NLYsn2gjG2tCGBiXYH5FysPcyyHR3EVRTAfVFnTW22oBM2tSQjR	13522	3NLhGF56ZKUZ92j1bj2JVL8Df4phk7X5ffWQkyjECh3Wo1pYpFYA	1581	778	202	6301	9756	jxmWCFVUabs5Q2rKECULuMbq7oWSgyGsN7iLcsSELk34CGP1LK9	6963	9846	9846	1617711480000	orphaned
13527	3NKbMW1R9iuhZuT8NpYkkfrrA6isJmr5JhHqDnkPutEgXpjbkBLk	13524	3NLGCtr25MaaPP8jPVWWD4LzTixTDBUKdVVpc3NDuVLWtxk7Tuvf	44	1199	202	6301	9758	jxSzXvQvqBXGaCXvGY6NnfEq8CaKeqsy3ksRaq69WfyZRtc8iR3	6964	9848	9848	1617711840000	orphaned
13532	3NL6byUDsLRk9mg81PqH3Zmz9GrvaWTa95zXdKnxoe4L92yumaWb	13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	1637	816	203	6301	9762	jx2R6AEsTTQyXv3fGsHhEU2Sd7e4rTtkPtjBKigwZun2MBYfpFC	6967	9851	9851	1617712380000	orphaned
13543	3NLZF9GhPy6ucV71w2NYayS1vvapQ3LiCAyPsKLE55B8Nw6ViWbW	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1527	1047	203	6301	9769	jxNTNdwmDabvPNcZCECqJCjrRL7PTQWAHKzE9mmauAHt9weTgrd	6970	9854	9854	1617712920000	orphaned
13545	3NKxC8nuZFkoNik3ZwMZJAJE3wvRqeae5f8PFNs7oesSeNFb4R79	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1447	1345	203	6301	9771	jwH47FpNgLCpg1AGSGt5F4qFTDB3TvXF377fnRhG9FxDANGVTKt	6971	9855	9855	1617713100000	orphaned
13549	3NKtMXvTBvKY7jAjzEVKyLWk2kBXTqLZApgAivm2NKJLCSPAKc69	13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	1578	930	203	6301	9773	jwjqQEQdw82FGBzFaHjhAhQGsM4qCvavZXqAeCzrMmkDwYC9ZTL	6972	9856	9856	1617713280000	orphaned
13556	3NKA7MUyL2cLk7ow5eCGSR2UFagYK7VKSFc8p8BdsSTjy79MPSvj	13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	1523	1321	203	6301	9780	jwQpsrVHem2NBoeZ8QHM9ZH5riHABV2M3MNRzBYu5NUEdo7iDVG	6973	9857	9857	1617713460000	orphaned
15429	3NKqQUFaKJJQXii4zivBeC6QLJvn761FcCc5DCyhWmiYhb1pv2m8	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1448	1065	247	6301	11464	jxiueYET7WZn5x4MUz5gcwyAfzAXoDYgSkh9h5sdX9jSb3zwhea	7858	11111	11111	1617939180000	orphaned
20117	3NKP5iMfu5SbVsb6ubkxPnyyYUs5ToLp4aBbFHcaJnpvuXFAGM4i	20113	3NKEkiUZrR8hj3PLM182M3VoTHjUtFkKjN12fhBUaYpq7E4aCL8L	532	532	359	6301	12463	jx4ycf6VdbcQB2UgZAaFnEYEUAnxq5qV17gRiYA3csjhtz3NuWy	10126	14276	14276	1618508880000	canonical
13530	3NKkEL4UXsiyJWFxa9Kj4S6cvTFCz9KYZanPdWqqzDpPCRzQDpkB	13529	3NKnV1ZkNe8g3UV18d47mG8SmsiAzpfR2pXoDHKkZDxpSQMhmdit	1581	778	203	6301	9760	jxitEhVySsPbA9x8M2jaEdW1HWcyJQ8j1BB42b83FmnvewRrWQp	6965	9849	9849	1617712020000	canonical
13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	13530	3NKkEL4UXsiyJWFxa9Kj4S6cvTFCz9KYZanPdWqqzDpPCRzQDpkB	1406	1393	203	6301	9761	jwoxt6BozDqQBqewiSrC5tb8J4xjmjEFci4zFhCDkvGEoHSq9q1	6966	9850	9850	1617712200000	canonical
13533	3NLdeWMvDfwWwKu8TnvouUJcpjA6BGYyotHfBRTmQMMgL7vJGGLj	13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	641	1210	203	6301	9763	jwejCWu9J8jZmyuKvssxVQeQXQ5XedSSC446xgLKFbHc74UFrTb	6967	9851	9851	1617712380000	canonical
13534	3NLDKskXWeXw9REkB2HANCVTQK4mPadwkkusnn1HX3hPtwcqfYqt	13531	3NLvvTioPK7kj3fwMmjvDBd6XfYYFtYFFEiCAHp4JxQHkiUwP4kz	641	1210	203	6301	9763	jwQVM6Q6UwwwNZBHncYQGsvDW755G9wWUV1zz6GMeZfHe1mJDAc	6967	9851	9851	1617712380000	orphaned
13536	3NLPXaieCxxuoWKkGJfq5ZUUfwYSti79rHqgDcSLW7CMDhgsn4ws	13533	3NLdeWMvDfwWwKu8TnvouUJcpjA6BGYyotHfBRTmQMMgL7vJGGLj	1654	1094	203	6301	9765	jxCC34aiFhzNRJM8VrrX4XKbeAqSGN1fmDZRwfhRTaty834YBpW	6968	9852	9852	1617712560000	canonical
13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	13536	3NLPXaieCxxuoWKkGJfq5ZUUfwYSti79rHqgDcSLW7CMDhgsn4ws	1651	935	203	6301	9768	jwpG3bDC9ed7SsdentJTSfD46zeXWsEpb7jHpdsWCAkWuzm7t46	6969	9853	9853	1617712740000	canonical
13541	3NLf3sDpqLdsyYaS4bWYEei7qfjfR3EcfiNTArjs6MWiuas7DNEj	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1527	1047	203	6301	9769	jwGaPRybG9WLQvQZ9Z8DRe7HQoeeeD8oGu6BR92jbmnsHbWs5mu	6970	9854	9854	1617712920000	orphaned
13548	3NL8LyepaPBHXniWNY6K7CA7ZYNUu2dhEqR8akYXfLZSsj8TJcY3	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1476	1371	203	6301	9772	jxkJzprGMTw8Uk3gPD1RYYNdEsYeSUECbH1YS49cjhCJG9qUtfr	6971	9855	9855	1617713100000	orphaned
13550	3NLoYXJJwZQVZKbccFdEBxZbvr3nf8QLJCuoWwWpBJ2jsSudp61r	13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	1654	1340	203	6301	9774	jxyFrjn1Lmrg1xRZV8vB3q8W6UTx9hdxMWfxL61vc1ereEaCxZ6	6972	9856	9856	1617713280000	orphaned
13557	3NLRnFaCLZpdG18AsY59zP5UNHpga5tqPzY6g4faj8B7WaJfXtG9	13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	1523	1321	203	6301	9780	jx2haRvrVgnG7Ei8DKKY1LVqbXw5ZUncS1XZDYpgmGGHJ2Q16f8	6973	9857	9857	1617713460000	orphaned
13560	3NLyYomKNc4v9iNKxY6p21KN8SqQq8kzcEpRvwRtbS4QReY8CxLa	13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	1483	878	203	6301	9782	jxbYYnGbHa1vS6yzRHwYvJgj9Z4zyCTEJX8MQF3FDQcoV95T8FK	6974	9858	9858	1617713640000	canonical
13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	13563	3NLHJUpXZvgS2cLN68PNdC6qa69PUPUnV9zt4sT5mry98fxhAE5w	1406	1393	203	6301	9785	jwGvaxdcDxeSjfgzQzHnCg9BS4sFmMKAdVpAVj9xEXcxpB2WPyC	6977	9863	9863	1617714540000	canonical
13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	1406	1393	203	6301	9786	jxzxVyWGkurRpB7KNoGy85bK2rTKF3EYirKzDeHKyTodYAjvmnR	6978	9864	9864	1617714720000	canonical
13567	3NKdrNZYyGEt8eFt4n4BvLd5H4jmtC939TFk6chjrMzKEiM71p5V	13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	632	1256	203	6301	9788	jwDa3fBHzmuuHxk3eG6r6yMe1VHruBy61kz2Gv2PFJxUsSASZHB	6978	9864	9864	1617714720000	orphaned
13572	3NKyXdt3xbXpZAUVcfMPoTQ9SXrF637UfKyGUfTn9RDtijWfpGkr	13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	298	1182	203	6301	9793	jxtqYTsvzrTzqvqo8WEPmVMot6cBQzfm74HRwFhmtHMCqcEqbKs	6979	9865	9865	1617714900000	orphaned
13570	3NLj7aUxo9iSyzDB3XXKrPJcMPSZxqNgFU2EUh1GTUg8Dc7FKdaL	13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	1589	1286	203	6301	9791	jwR9w1BQ2iBwNgsm7f8wxfSNCqoqhH2aSPRpLgchv1wRSAL9B36	6979	9865	9865	1617714900000	orphaned
13574	3NKi9E7NNcQQqxQL5awr6S7eJk8VxmB93aQJK1oJ85MjmDUWBKWt	13569	3NLZbJLt3NU16H8QJYaKioUp16phCXesRqprXpvXuQaoQPfcFbr5	576	1355	203	6301	9795	jwxC24vhrC3Qgquo7soLNjgqhgtf4xLyBogXfizozMUj2KcCguc	6980	9866	9866	1617715080000	canonical
13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	13579	3NKMCwpVbk2ewtDH3cmQWkQrtgcwntKdP5M9JeQJ7RVmdXG7bfFs	1649	571	203	6301	9801	jwrZPHSsKd6fcw61yTY7N5gs1V4zVBQMYwQ3yNWeuCW9UAaDsYp	6985	9876	9876	1617716880000	canonical
13583	3NKBKxQyu7V28pcUvD4QPfw4teFHo3vD4taevxQsChx1MnVyVht5	13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	1527	1293	204	6301	9802	jxVcSAEDD2Pu6SzkEnKrWpxHpAUJNQ7EJnSo7m8Zj1YmX67o9Jh	6986	9877	9877	1617717060000	orphaned
13585	3NKQcMBGFJFvHbZEkmMiHajCXkSMNqv8UQTAEz97rQP7dCHEHpvP	13582	3NLcFWM5NFHVANgUz9a4AQUUKFKG5ZWyDe39bQzMU9ZsiMbJem57	1508	1387	204	6301	9804	jxAJVQgfMMUrotEJVhG3dp1D94iC3cfrSDY9rqye5v6nFmdim9R	6987	9878	9878	1617717240000	orphaned
13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	13584	3NKvbmohZDnFQjzVdVQgcEizVkNUjRMHJmWhSrmESf6zphz3uyAv	1601	1022	204	6301	9806	jx3DNkWf5rz9Rk7MwboVK3YFAjnosmQt43CtVz6rkzgdpCySmwx	6988	9879	9879	1617717420000	canonical
13590	3NKSZzUx2Mm34cY8mRTzhLA5XTkpbvo6tPTPiAdewzzyGsk3HnGy	13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	44	1325	204	6301	9809	jwttwUDCQrAxR7TU5ypCVGxt5EEtQFHc7yopZkFXaWq1G98oUfH	6989	9880	9880	1617717600000	orphaned
13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	13588	3NLK2c3Lz5aJAr3sLXkXnZ794YKurLXdB2mpdDLGtbUfCxR9y4Kx	632	632	204	6301	9811	jwV7TL7wBvgeorTYiNfwS4XqhxdWsBSkxeeimw9Fzp8w3KsyiDm	6990	9881	9881	1617717780000	canonical
13594	3NLRkA18deDkca2D2NgdMRZQEsTzPaDrA8BMxHY6SV86qbzaqqcy	13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	1642	1121	204	6301	9813	jxMkd3kSWiECNhHuSqMnj4QxedyXrkRCp7nYYSsLeSgueyYX6jF	6991	9882	9882	1617717960000	orphaned
13599	3NLXMHp2ksitdBh26brZedu5ex7g5dmzAFw1zVZskskAUKqGVJ12	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1608	1163	204	6301	9818	jwVBYpyRPpSDFDNSwb9HfSYh4xreRy9Raorfr21i1KaxFhkLTsZ	6992	9883	9883	1617718140000	canonical
13596	3NKy2TwxuoA8hhwyZs2orY2WCaZ94drWDUH1to1gyt59GNxroPXU	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1467	1376	204	6301	9815	jwPVD1yFMZF8EFbAkJfJCBuQKKpPyjd7cNnzDGjjgYkzST7NAqJ	6992	9883	9883	1617718140000	orphaned
13611	3NKBntQNFUfdzS17epQm7U4a4Rg2K4KYe4ipBeKQdCkP76RrXwed	13610	3NKjZJ8ATtsjM328xvG37TG8NEpJWh6mpSgGWwRhpbLHG3EFB1au	1529	1316	204	6301	9828	jxniWwLr3HXMMZ7zLZ6inVS33ttfe99NBHvjq8kCRspBUJ9nEyG	6998	9896	9896	1617720480000	canonical
13614	3NKNfAjNp1yJ7BPdtV1PbK3iCjjcinwTTP4c6YZcM22YbxwrPsXY	13611	3NKBntQNFUfdzS17epQm7U4a4Rg2K4KYe4ipBeKQdCkP76RrXwed	1577	1201	204	6301	9831	jxJCPw4n93UXhAGnhjmnrs1CSrdY4niVzCHdR7ZRj8qeH1j5NYi	6999	9897	9897	1617720660000	orphaned
13616	3NLkhmXBWW93esUDfaEBuEFvxSUudXtUQ4avTmrNUtwUJXmRA8Rm	13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	1622	1230	204	6301	9833	jx865Z6Y9G78gvUtnBwYh8txB7yxwvRDut5tQ4Hm2ML27fruk2S	7001	9899	9899	1617721020000	orphaned
13571	3NLfEjcMoCVBb1eTZFBc7MBhB3MeNA3UZnGLaWATA6M9ULbAZd6j	13510	3NKsP2zMQJWdZkYuRUgHN8mjNcW74uy6Eokm7ckWWNiy4FjMMBgi	298	1182	201	6301	9792	jwQExhKyX9P2cE4jL9RRjBuT9pgq36sjAfBH5baVLkYAm2sMRaV	6932	9865	9865	1617714900000	orphaned
13535	3NL6ouWWkspiAekMzLo2LZepxpEmEb7ittan46yJ5PSaEu494Hp9	13534	3NLDKskXWeXw9REkB2HANCVTQK4mPadwkkusnn1HX3hPtwcqfYqt	1542	1178	203	6301	9764	jxre9sfeGKnwCqgbJfaEgkMYozvnecKKkuw6PPdxqqTruJ8nour	6968	9852	9852	1617712560000	orphaned
13540	3NLdBUYQKNxDZex4CkSdx3HdvPYupq6RHmcaswDFmiasUbinwkBe	13536	3NLPXaieCxxuoWKkGJfq5ZUUfwYSti79rHqgDcSLW7CMDhgsn4ws	1651	935	203	6301	9768	jwZSNBbBEosQjHdRoz5afoiasbh6ASUyXzoBohCdTFi86ZC8BY6	6969	9853	9853	1617712740000	orphaned
13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1609	1207	203	6301	9770	jx7JDc3Cxjeuuedo9x6YYdzG4X3md4D2TGMqN2bdc9VG62Zii2U	6970	9854	9854	1617712920000	canonical
13542	3NL3Vuvczy5sgZqUSa6Mfuzn5gNU24XKoDdznzAiB6NN5gXmCMXm	13539	3NKTzByb2oihtkfa2ArugYJtThQbbN298eSRwvRGKvqxsSwogaST	1527	1047	203	6301	9769	jwv4jPGXbmHWPq5BydMcEhhs5kpvvDhDAqfXzFMgUvgS68egjei	6970	9854	9854	1617712920000	orphaned
13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	13544	3NKvicDxkiFbdzWwAUVm3JdjBSkvB3bqw8eKFRXRp6F7pg1Rz1Uf	1476	1371	203	6301	9772	jxHF9ir48WVht1QeeaeXVySxVuyZgoRneut2yJamNvrQcQ872d6	6971	9855	9855	1617713100000	canonical
13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	13547	3NKC5eN3giA3L3GVjcBV3Qy2FpyKMzNpmTMPBe65MxhEMZcQoNNd	1588	1392	203	6301	9775	jw8qja9C56PBV7MGnUeQ5sY2KajrGmqBTfDzykSoz835hnBLGLN	6972	9856	9856	1617713280000	canonical
13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	13551	3NLmrLmF5UGVS1K7qndw1WUvkwuF7xCRvbDLnbtGcqXuij69zKcd	1523	1321	203	6301	9780	jwuxyi1bazXMntdE4d2E2Cwk95HtwjrztsEXHdrSZaXkhdrVKDt	6973	9857	9857	1617713460000	canonical
13561	3NKe7P2A81WFdbvbLxLJ9e9Pxv1nzcTfSV9bWwXoy4E6taPFwcnh	13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	1483	878	203	6301	9782	jwnpe1boytzvL2etfrkssW1k4zWWjzHfHzpCAmyvnombFaXL4EL	6974	9858	9858	1617713640000	orphaned
13563	3NLHJUpXZvgS2cLN68PNdC6qa69PUPUnV9zt4sT5mry98fxhAE5w	13562	3NKSDhyiCPb2eNKEkWh2XFsgZstVHve4wHzdT6wNAR66YFgSc7Pp	633	1018	203	6301	9784	jxK8sS3rrEvsU1m42PJ2nRSxTvrUP2enTQpFwxSKakfp8fxKZyk	6976	9862	9862	1617714360000	canonical
13566	3NKQb3L8RVdssjvuJyDFUFe8h64QgiMnsBxUcSoj2Zbsa93RNQYe	13564	3NLiTvNx69HeYMAWZrHzTANhECgyX5UL2AM4PGDyb6EtdEQzphkA	152	1084	203	6301	9787	jxeoorTdnCcSGXtv6DdqFSVqxu9fbcgqhwEiSQfPLHWyyZwHWLp	6978	9864	9864	1617714720000	orphaned
13577	3NKKLPc4sg7QamFW2gwTZs4C7hLHK8CoLpuHUzfBVsus8YBoWXsh	13576	3NLZrSZgupc1bQWuTvJymKBCYWHVK1V46XovL7kAaenf2yM79Cpu	1668	1370	203	6301	9798	jxQAh6Hmr4jemur1nC457nxh4GM8VVb6JdwL8CytoV5NoncSntt	6982	9870	9870	1617715800000	canonical
13581	3NLkxdkMPzisvHBE8xrEkwVXeRdZGLocXffk1LkfXGzacXU1gTWU	13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	1527	1293	204	6301	9802	jwEjxL6XuiyJd1m97sBywQwbEC7Ehv4T5HQFWVNvrnz64xZexf9	6986	9877	9877	1617717060000	orphaned
13595	3NLupsgEHoaawFG9NKVB7cBYhRhJ7xNqFQiCt8moarn3gRZzreqL	13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	1637	816	204	6301	9814	jwW1E22ZCLQ6qRn4hLTXm1DgwaxfDUfj8SYhyrH61HaBuk7Ah4N	6991	9882	9882	1617717960000	orphaned
13597	3NKtg4ddZsaAsoT5pu3XP9t4L5ozGfJKDBYrtWSrYd3kFTaEZ8U2	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1600	1372	204	6301	9816	jwzoCVU1hJZFeNgZtJxoPAzihwzYoKtnzPLb5dbENBDkypnbKnU	6992	9883	9883	1617718140000	orphaned
13607	3NLuNQT3bvKPNqHSwrdXU5bBKfwT7a8ZD4TaFbZnhVb4CsBkvm6t	13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	1671	1365	204	6301	9824	jxT4E4fHBL77hYeemBCh2eGuLfXr9ToHNHRzFZYErjawChgMcJv	6996	9893	9893	1617719940000	canonical
13612	3NLptxZTybhiTwZgoXqgGjeJWgUuJXYfBHdwAXBMpRbfwBmAy5Ec	13610	3NKjZJ8ATtsjM328xvG37TG8NEpJWh6mpSgGWwRhpbLHG3EFB1au	484	1193	204	6301	9829	jxaHKh2UHpzZLT4wouNoVUKfpkkhVS3rUSvzvxvwtrm3HwxYeHC	6998	9896	9896	1617720480000	orphaned
13618	3NLi8iare32Pn4zaxLeFyC8rcoMvyMvGPfRrbv14XoCVZ8CcEgjt	13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	1581	778	204	6301	9834	jxiMTCTjezXrnnktEWAuCkNqLekTy32QQ1TpEAQZCzdmtXAAaRr	7001	9899	9899	1617721020000	canonical
13617	3NKtZDyXiNJAjTjRcFXvbpdujKTn7XhReUYHBs3zKw7pb27c9ZBj	13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	1622	1230	204	6301	9833	jx865Z6Y9G78gvUtnBwYh8txB7yxwvRDut5tQ4Hm2ML27fruk2S	7001	9899	9899	1617721020000	orphaned
13621	3NKP8fBGfNHBztcW6VDgzUaVq9Twus776Mdn3vxL2hgqMwpKx6cu	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1599	1287	205	6301	9837	jx38CMVJgiochLVRzpC2Bbqp1Y4F46SS99shDVWWVnY67NuPdCZ	7003	9901	9901	1617721380000	orphaned
13625	3NLcNH7dEFDP7U9LUwz8kPN8fnExC39DJAWLaoPwmseGbh92WefB	13621	3NKP8fBGfNHBztcW6VDgzUaVq9Twus776Mdn3vxL2hgqMwpKx6cu	1651	1301	205	6301	9841	jwsnmfodLXCF38NDGW64wTHLvLQrPvr8yibwiJatfq3bvzj1tRZ	7004	9902	9902	1617721560000	orphaned
13626	3NL666bhFHNeorQqXT7iv7g2p22GuokBeHEGWUzbFusnza3EoPfY	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1542	1304	205	6301	9842	jxXWeKncyfzq5vjkd7oZ83ecujf54vbugF7NbTb3LNN3nURox7n	7005	9905	9905	1617722100000	orphaned
13630	3NL6THtBcDqDyJCeaavfirtXhiURijhtQVr7s92QEEcWcBg7ZS9q	13629	3NLRLqkbL6ienaG346gaU57RopTTK2w2HHnZLFXMJwRXhWGzshLz	1534	1071	205	6301	9845	jxf45QDrWud3WnwZNCpRivXBKzuAGevvBbRKWLn4dDZUuZQL8Js	7006	9906	9906	1617722280000	canonical
13631	3NLZ9P9BXrYHQszXVhaC7FpqnYBhYYbfqKYBU3mzeHgcFdvdDMfE	13630	3NL6THtBcDqDyJCeaavfirtXhiURijhtQVr7s92QEEcWcBg7ZS9q	1457	1145	205	6301	9846	jwtM3nDxgNhBpPnkREg2F36cHtuG1LjkoB8KuiTKyZXeCDTXcjr	7007	9907	9907	1617722460000	canonical
13637	3NKXJnmr8buAkVvEHzULQS5H41N8WLCyVjp6kQfJ4NLSK2UoPaWF	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	532	1057	205	6301	9850	jwwz6VtwPfT4pqpC6qt4UCCeq99HBoW4gZoziH3YyhQ2YwCd1NK	7010	9912	9912	1617723360000	orphaned
13634	3NKfpMrrUv5TUcvWwdAJLizRnTfrpwBYjaVXwMFcj7BEmCSZNLA5	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	1555	1101	205	6301	9849	jwLnozMeAF5sBcvG6eCNtEKSFyAF7vDwcp1JuJqZsYYt4E1C7t6	7010	9912	9912	1617723360000	orphaned
13641	3NLLZxyFJGk6FHPN571MymRmKaVNwJx1TCgr1NR8D7q5juCKbEgR	13640	3NLiLivstUVPJwhJ3MDhSgPn7vhrZsZsu2Ee71eqCcLnbAmRyT9o	1406	1393	205	6301	9854	jwjNKKc9c4AH6k85h9g2MnmBxbPZV8uE6FxnMKhigqLLSPj32vS	7012	9917	9917	1617724260000	canonical
13644	3NKkAmsdmLdyzBAoUUAP63yHGsxV9UKp7At9w21vYgTNXLyZrYNh	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	152	1330	205	6301	9857	jx2YM2o3KCUXrWEEih61cQoJRNoERYBou4wm5KBCijucpcEPoPz	7014	9919	9919	1617724620000	orphaned
13648	3NKXfXd3Q2ckhmpdRc5Ua8vjLCxw2VXUnzNfBz8p9w6EXH3ZeEYn	13647	3NLbuZbnWa6wHvGdcFc3gxHzEm5ZtNR8YHKMK1TvTTuDzNwpnf81	1503	1277	205	6301	9861	jxYsjjMtFQtjZ9SMaefpVzGNWRKyRwgBv2FdrqzD2wKPVr9Z5MN	7015	9920	9920	1617724800000	canonical
15444	3NLrKTFYCxe4tuVXxfJoSr4hzDUKvTSYkYasWDSoxeKAYgimAJ5w	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1642	1121	247	6301	11480	jwZkPaHsSPVL4dfWt2r6JwVBV5Tv6Mb344hSqC9gPLqbdnfJENb	7864	11122	11122	1617941160000	orphaned
13568	3NL3wCa6m342LdMrW9oBF6pmraxiM9w48yCBpJSq5gQVg3WLeGJC	13497	3NLnYJXWy3i9kzC9KBwigCjKwpEASJKeGcWYnHDdFyfCPwVvgxD8	1564	1338	202	6301	9789	jxfsFgUdKzMoETSnvEVetc6NJFiFGa6kXgS3b1hfHbzBf49p1a7	6951	9864	9864	1617714720000	orphaned
13559	3NKa43fRaryZw88PX8xmRVFdqsnBkiT2mcrX7cx87DUfPXQ3yYGb	13558	3NLkgCg6jqGa1us4cqP2jej6ju3BxUUe2GvsDH4EYkrEStgvJR5V	1467	1376	203	6301	9781	jxrFYZmnjZJXQit8HdFFJ8ppXMaALmgkBtYdYzWnhcHkLxqa1Rb	6974	9858	9858	1617713640000	orphaned
13562	3NKSDhyiCPb2eNKEkWh2XFsgZstVHve4wHzdT6wNAR66YFgSc7Pp	13560	3NLyYomKNc4v9iNKxY6p21KN8SqQq8kzcEpRvwRtbS4QReY8CxLa	1501	1360	203	6301	9783	jwiiRuVCQ8fiCJChCTessWUxXCcwhq6oiLAhnhW9xXzWrMo3dar	6975	9859	9859	1617713820000	canonical
13569	3NLZbJLt3NU16H8QJYaKioUp16phCXesRqprXpvXuQaoQPfcFbr5	13565	3NLQXD4S4hAVCmR8KuZGT1foLKWEgPLRH96CAP1AtrQuPWgzyJn8	1457	1265	203	6301	9790	jxgjDq28RDz7pAAX3iEvWKXxz8ARXjLbhG3zKLUy9uDY7Cu3349	6979	9865	9865	1617714900000	canonical
13573	3NL8azPP5kkmwzta3Nqb77ibCq6KsSHV3LBAoMxByhJuaZxz2cZq	13569	3NLZbJLt3NU16H8QJYaKioUp16phCXesRqprXpvXuQaoQPfcFbr5	1619	1275	203	6301	9794	jwKV26gBYn3teBZTh9KLYTUQaDydPgi4q8G6iYRLzy2YPTZK23D	6980	9866	9866	1617715080000	orphaned
13576	3NLZrSZgupc1bQWuTvJymKBCYWHVK1V46XovL7kAaenf2yM79Cpu	13574	3NKi9E7NNcQQqxQL5awr6S7eJk8VxmB93aQJK1oJ85MjmDUWBKWt	1587	1111	203	6301	9797	jwcRtjik5iWQ7nuA3ph2umx4o8n7hyYnmgCgUoaSdeSQ2coKxNA	6981	9867	9867	1617715260000	canonical
13579	3NKMCwpVbk2ewtDH3cmQWkQrtgcwntKdP5M9JeQJ7RVmdXG7bfFs	13578	3NLws1vCNcE15CrA6mHHaekQYFJfME6QParmweNihAj5vfjz57Cs	1624	1334	203	6301	9800	jxAP2TVLkiFSwE6Qy3Wk8utmvr27p64xvrq1NNgGfv4dosZ2vgb	6984	9873	9873	1617716340000	canonical
13582	3NLcFWM5NFHVANgUz9a4AQUUKFKG5ZWyDe39bQzMU9ZsiMbJem57	13580	3NLCo4vxXrW7xEM4Kq4ovTNAtEJ1DwyiPrfGzPDNT46bSLPhhbVa	1527	1293	204	6301	9802	jwhgXVFMUkihwn7TXZWQH1aCgDPd3YKwRPmyzLAuxBdw537dADD	6986	9877	9877	1617717060000	canonical
13584	3NKvbmohZDnFQjzVdVQgcEizVkNUjRMHJmWhSrmESf6zphz3uyAv	13582	3NLcFWM5NFHVANgUz9a4AQUUKFKG5ZWyDe39bQzMU9ZsiMbJem57	369	946	204	6301	9803	jx9L6Pb37UudmJACGjVx9D5jpQKD9cbRN94HExfpoccQtL9RmAE	6987	9878	9878	1617717240000	canonical
13591	3NKfGSC3MBeCBnErBu8jbYo3L2rqzkYgbXwfRdEpKikN4rfhD6va	13588	3NLK2c3Lz5aJAr3sLXkXnZ794YKurLXdB2mpdDLGtbUfCxR9y4Kx	1402	852	204	6301	9810	jwzyBzTWNc2CH3TSJV6Nma8tmdbpnDPz5KjbuQbBczdVgN6UkYD	6990	9881	9881	1617717780000	orphaned
13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	13592	3NKFQVFPqvgC1JrjrgB3ArHmS3EwFyuMFxkWwpryz8FMKZTtjSyW	1534	1317	204	6301	9812	jwQfSxbkM2v1GZ2jjFU9mCSAptK32gyr9utgfkRwWgkTBa8wzmZ	6991	9882	9882	1617717960000	canonical
13601	3NLpM46DtgsrptqtfEsXrxiTaWVzWM68r5KbKzdBFc7kqLvZVhB4	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1608	1163	204	6301	9818	jxvBZuUfaAcFz5oEQqDWbK4WWcevhjz4fuTMLfzmx5WyShPu4LK	6992	9883	9883	1617718140000	orphaned
13602	3NL43MaXKfg3Lea8eXSd6iC162SbCHKsjzEYTZEomgFiQpowPTsq	13599	3NLXMHp2ksitdBh26brZedu5ex7g5dmzAFw1zVZskskAUKqGVJ12	1637	816	204	6301	9820	jwEh11rq9rC4bsdYknT9sW8MKD3U6F9ttKqjeWn388PGvJGzcRf	6993	9884	9884	1617718320000	canonical
13603	3NKqVWzwPkc9eX8v24hCR1zscQsJxfiF35froKT2oapRH9poZsoq	13602	3NL43MaXKfg3Lea8eXSd6iC162SbCHKsjzEYTZEomgFiQpowPTsq	1426	1364	204	6301	9821	jwPqrWTiWsG565GDgnH66SPEZRaKDGSYuUA4KCYkcAjQEHCXczf	6994	9891	9891	1617719580000	orphaned
13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	13604	3NLkKwAnEcaSDQT2mF9qKKPu9t5GYJx4kkwQb1ViaGT5DZJCPt27	576	1355	204	6301	9823	jwv9xk2A54qLq1XwhEazCpCLE2W3SJNumYse6gXZ6tcpDVV8P2i	6995	9892	9892	1617719760000	canonical
13608	3NKtBr5soQhnGyCJ1n4wie2CGDE5QKLMfb7QnJwd8eSMqu1qQUfz	13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	1503	1277	204	6301	9825	jxsJfPo2Quc8vipWYT19BsreZ6owC1pMTNCuZsrTT2PKn4PNaAs	6996	9893	9893	1617719940000	orphaned
13610	3NKjZJ8ATtsjM328xvG37TG8NEpJWh6mpSgGWwRhpbLHG3EFB1au	13607	3NLuNQT3bvKPNqHSwrdXU5bBKfwT7a8ZD4TaFbZnhVb4CsBkvm6t	1656	977	204	6301	9827	jxTG79fq9jFiCCCW9ENAWmBZppXimPb2vDcQihyJSxC7FtWpA45	6997	9895	9895	1617720300000	canonical
13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	13618	3NLi8iare32Pn4zaxLeFyC8rcoMvyMvGPfRrbv14XoCVZ8CcEgjt	1407	1395	204	6301	9835	jwKaLsbVArLxh2NN17zYWC45hidnc2myY6FJmtKGuhskPbAQtqb	7002	9900	9900	1617721200000	canonical
13622	3NK6QWRkjY5MLmAKomm2tjHYWtNUz6178Rui8L75KPr6z9V32nM4	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1631	794	204	6301	9838	jxGH8mEaDp8A9pmAGi5PAzehvQ4jVgiRvxmzMeCKrmotKjwzqJS	7003	9901	9901	1617721380000	orphaned
13629	3NLRLqkbL6ienaG346gaU57RopTTK2w2HHnZLFXMJwRXhWGzshLz	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1542	1304	205	6301	9842	jwtMKyjYxTG3gmoePcXkPyuMvNQ8HiQihX3UJwWgYByGTdynufN	7005	9905	9905	1617722100000	canonical
13628	3NL1aUUvobveDsXwrJdP2r4FLFEzPCTQuNXxsnjLTC1mCZZGHmRb	13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	1581	778	205	6301	9844	jxLwERLfyifsYMAVzJtNCLadMzuXRAUoF7AeL7cZXEDQ9DMRCtD	7005	9905	9905	1617722100000	orphaned
13638	3NLNJpQ6PEbL8Hw3oKx9n8dqJekzuG7Yne4VpkRpuJ1sSadszqQ4	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	532	1057	205	6301	9850	jxvb6PyUN8Jn3FmCHhQe8iKUrWespSYeb8dMcG3yFprSXzxXct6	7010	9912	9912	1617723360000	orphaned
13639	3NKiKdXiqAvpoJ34UokTPkS99rXKnAWrNLbZB7RDzJEnoQ4te9uL	13636	3NKuzsLK3u4nyUziRFkVtg6Vv1bbxCR3xMZDKYa9ixRfUtjf45RP	1627	1139	205	6301	9852	jwVhEgsZRAkASRpiaRLawer7rcssjKAMd2w3PpqVo6C6doZ47ns	7011	9916	9916	1617724080000	orphaned
13647	3NLbuZbnWa6wHvGdcFc3gxHzEm5ZtNR8YHKMK1TvTTuDzNwpnf81	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	1403	824	205	6301	9860	jwDG4D59A3boEyQVNsPEvJEMz2Q1DSBGEgYYQXy4xaU6VAE45Uw	7014	9919	9919	1617724620000	canonical
13649	3NLUEBosVu4NikhU6vKnkzVqa5os6j9Pn672VP5uY8vWwnDRYRr3	13648	3NKXfXd3Q2ckhmpdRc5Ua8vjLCxw2VXUnzNfBz8p9w6EXH3ZeEYn	1651	1301	205	6301	9862	jxtCuxEuzgM6AawTSSTRenPYw82NEmJL8JY2DBY9G2jgk1NYjoT	7016	9921	9921	1617724980000	canonical
13651	3NKKyKL1ddaPBiWWf5RkR1RDCsHDNk4tf8KDB16VU5LqXFGEHYbu	13649	3NLUEBosVu4NikhU6vKnkzVqa5os6j9Pn672VP5uY8vWwnDRYRr3	633	1018	205	6301	9863	jwijFkWsgJ6xRSPW7ciaUrucCBFAhNAsTofz4LkT9ysL4WEviwv	7017	9922	9922	1617725160000	canonical
13661	3NKzQ7cA7G8MtRY8qbHaVbvD1bf5T1Kzb6nvbmvArQxjokM8i3r9	13656	3NLUEVnDrtRLwYx56amCbJ5nAcyWDkPxwjtGPZUsW59mynVB3EgN	1616	2	206	6301	9872	jxzQeEoJuuYabNU76odZjkwkzkgpTLnS5Xhp7N6iG6JSauNKg11	7021	9928	9928	1617726240000	canonical
13662	3NLw637io8ndTdfdGPb6Dc7Rw8ENiRT8x3MDgRqmKvLsQygvFBy4	13660	3NLBQPcngP9P55sriw9NPmV6PjbvuSxPi8dXU2xHVdRa8jJXQXBG	1670	1036	206	6301	9873	jxA1eQUrq5ZD5f8th9uBJm5PFDoZxFYRSptimnb75TuQnA2aKcu	7022	9932	9932	1617726960000	orphaned
13666	3NLPPW7gaxTbijkd2GtkghpAmMVWtchvE9SZEarjF43VMNEiSNVX	13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	1588	1146	206	6301	9877	jwqn8vnwmQFA5Vk91xG4gzZsHq6GudT632qdfCNyN6qz9crXyzQ	7023	9933	9933	1617727140000	canonical
15449	3NLiWUZxyAwFa8SXN8iNKwcQSRto7KrPC6ZywF9ButYK37owBLkZ	15447	3NLyS1QKL4mo6bCNhvLrdQmjRemVQAtqNeq53UFEasDJDpDPd21K	1406	1393	247	6301	11485	jxKwiXcmS4RsM5ZSEoUYvhh3EwfpD8KCR92LKggpvWJc8Mv5cLz	7868	11129	11129	1617942420000	canonical
20141	3NKtviiDaz1Sa7Sg8sY9xKjgjyx9RaUaAX5caSYpWiY4X3j7SF6g	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1623	830	360	12463	12482	jxBwd8uq6EYMjignmuJEdukd8UweTqX3KxXe578MZa9pRTcV2c6	10137	14292	14292	1618511760000	orphaned
22090	3NLL34nBY2vU7ZVUK6GUhcF7CKjRLQ78v742Eoj3RqTggFsGtw7a	22089	3NKqYvfjZBc34r9CiPLEY1kqBQXo5xkVYzxzTGYmyurPxuXhUqLo	1555	1101	405	12463	14226	jwru4ctpg4jVMnM4nz6GzPhe93WL5VzcFt2nRvwRE8Lwo1fyVis	11044	15547	15547	1618737660000	orphaned
13578	3NLws1vCNcE15CrA6mHHaekQYFJfME6QParmweNihAj5vfjz57Cs	13577	3NKKLPc4sg7QamFW2gwTZs4C7hLHK8CoLpuHUzfBVsus8YBoWXsh	1403	824	203	6301	9799	jxxudWiPVbvdo5hMFyzA16FBry6DPsPR2WdL5UfeEkGhtNUXkWd	6983	9871	9871	1617715980000	canonical
13586	3NKSGnMqTAwcR8hNGKA1SsM14ZFryAK9GRwp9PGq6nTNuRthXHVE	13584	3NKvbmohZDnFQjzVdVQgcEizVkNUjRMHJmWhSrmESf6zphz3uyAv	1610	1068	204	6301	9805	jxZNafMmxYjoiw3sEWNu7N3rbwUvZLxKRtzS9WGDsaoLVGroQoD	6988	9879	9879	1617717420000	orphaned
13588	3NLK2c3Lz5aJAr3sLXkXnZ794YKurLXdB2mpdDLGtbUfCxR9y4Kx	13587	3NLZBmfVT3sSk5NvDYECWLi373qKatAday3D2kNJc155C5wsbukE	1670	1282	204	6301	9807	jwsYcgJ9eNF6FLdWy2Z5b7H2jVHM2oE2QzRnjESnF4b4L4Win1o	6989	9880	9880	1617717600000	canonical
13598	3NKzWKp5JoMhKaAMwZy5TxfArrM4PSwYJAWN1KqxNtoBQKXP7xUW	13593	3NLY5bQ1TWywZpS9HYdUtKcAunzMzSzck7PqfHiHz3zwbNaE4NUD	1406	1393	204	6301	9817	jwt4TZF3bjEdXiXeawahZQ4gsLxuXPqwqZMiRwqbJXip2ZxRoWr	6992	9883	9883	1617718140000	orphaned
13604	3NLkKwAnEcaSDQT2mF9qKKPu9t5GYJx4kkwQb1ViaGT5DZJCPt27	13602	3NL43MaXKfg3Lea8eXSd6iC162SbCHKsjzEYTZEomgFiQpowPTsq	1585	1240	204	6301	9822	jxxvUbGry3emcPNgdMtfLbu6JpNFLxZ9pJDxnvkV23SeEzGeijd	6994	9891	9891	1617719580000	canonical
13606	3NKyeYsn8P2U86MbTvgBKdX9AtChUXSxYSgd3qc5UxefYBnQUrmm	13604	3NLkKwAnEcaSDQT2mF9qKKPu9t5GYJx4kkwQb1ViaGT5DZJCPt27	576	1355	204	6301	9823	jwC1aEpWvSySgnGedkmBNzc77nAVcCtJCfBdiciirXGFJvqg4BF	6995	9892	9892	1617719760000	orphaned
13609	3NLWGrxhYoTKX88TvrfRHzJjCKE41bJqnRYV6uZ1tYWx3SHPFZBL	13605	3NLCjZRMgd34SuXBD4JfRZHbETnAthG4WVwP2ZNshCREYv6fT7VE	1631	794	204	6301	9826	jxGu8MD8jdJdBrWSQe4LptTJVFN2JTjRvea7yoRMDEjXbSNsp9r	6996	9893	9893	1617719940000	orphaned
13613	3NLpE7TwRLL4yKjiud8cnUzgMiDrDwrYK2SghHg1isF4SdMfggXU	13611	3NKBntQNFUfdzS17epQm7U4a4Rg2K4KYe4ipBeKQdCkP76RrXwed	1406	1393	204	6301	9830	jxXNvfuP5cYN2gBJ7YTYh7Pz8oVAcnVnwmZU3w6C2e5JJA7WNdt	6999	9897	9897	1617720660000	canonical
13615	3NL5tK3ujZeDAXpT6Dm8eyTZ9doxWH1FDuWoVYa4e4iJhU2jB1LD	13613	3NLpE7TwRLL4yKjiud8cnUzgMiDrDwrYK2SghHg1isF4SdMfggXU	1406	1393	204	6301	9832	jwnWwKi2aGMr88QGfUTDsVmsHNkx66fvDEcehA16DTZNZectUPH	7000	9898	9898	1617720840000	canonical
13623	3NK319reFKwib1d1dVyxcMM2xCuFmMkRfjqmqajvYr1z5y7jquBd	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1643	1299	205	6301	9839	jx9L3rUncWWZwCKbWT6jfcC7Y2Uqt76LzKshFp6SvBvMUY95x9a	7003	9901	9901	1617721380000	canonical
13620	3NKHHcq1yztqBNejpzij4cMY6SvSgzmTDLGatGJhBhPQxfYdtBSy	13619	3NKFFs79yGdGFACeHefqALcCHPzfK1UgZg7i6bVpawnhSgAy9t6f	1600	1006	205	6301	9836	jxV1CHeFrKEivxPBGtLtu3E8QRdNTjZmFEoWPZF767qrT4UspnH	7003	9901	9901	1617721380000	orphaned
13624	3NLrpxoAfvEw68vzuZRi7qpX3e6X4M7DRkMS1vpKw7UwS6xwLhEJ	13623	3NK319reFKwib1d1dVyxcMM2xCuFmMkRfjqmqajvYr1z5y7jquBd	1651	1301	205	6301	9840	jwtgkhKFG2GQyUi7fTXCcFojJw9iCdnt2CgW9n3H7uu1tTEfnRM	7004	9902	9902	1617721560000	canonical
13632	3NKkLgfPtJLXmWAuRrZf7EhcL1fiEdaZi1FSNm6dbeoB2RtJStRQ	13631	3NLZ9P9BXrYHQszXVhaC7FpqnYBhYYbfqKYBU3mzeHgcFdvdDMfE	1406	1393	205	6301	9847	jx2MDht5iaCHiEnthb31jAUw9ysV24yQnb1y8AwT6DkBiYygCA5	7008	9908	9908	1617722640000	canonical
13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	13632	3NKkLgfPtJLXmWAuRrZf7EhcL1fiEdaZi1FSNm6dbeoB2RtJStRQ	1623	839	205	6301	9848	jxhKNDGSasmugmrFK1u8L79wkbgRoorrWK1LW3Cnw1QRWEGkpZf	7009	9910	9910	1617723000000	canonical
13636	3NKuzsLK3u4nyUziRFkVtg6Vv1bbxCR3xMZDKYa9ixRfUtjf45RP	13633	3NKuc58f3uLhh86aH8EqCkBp7ENbFtAkpZJRrQrAiMVN3khdgh5u	1419	814	205	6301	9851	jw7Du5Dg2P3Q4f86uynhpvS3F5GvcDhERKjdNQsqdbi7BjGue9a	7010	9912	9912	1617723360000	canonical
13640	3NLiLivstUVPJwhJ3MDhSgPn7vhrZsZsu2Ee71eqCcLnbAmRyT9o	13636	3NKuzsLK3u4nyUziRFkVtg6Vv1bbxCR3xMZDKYa9ixRfUtjf45RP	1407	1395	205	6301	9853	jxk6LjYWSLVVcUWRc735aSCZtN77En7Rg6FrdsnQZ9RWoS5Td1j	7011	9916	9916	1617724080000	canonical
13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	13641	3NLLZxyFJGk6FHPN571MymRmKaVNwJx1TCgr1NR8D7q5juCKbEgR	369	946	205	6301	9855	jxr3UhFU8vEMuDNaYv1WupiRFqrmmauwDGZbsTUy5Tm87EwgUQs	7013	9918	9918	1617724440000	canonical
13645	3NLsuReMeF8LEJMLhjn9r3aoRJdDCHzXkVJRYu2ynwyTmgCBRVH1	13642	3NKn5wfdQ4CyVaiSqkBKJSuwka8dmfEX9UMjP5zFn2gh7Ety6h3u	80	1147	205	6301	9858	jx9ZMuKMytfXJRXb6cTrnYfCoDZzRh7FbAicaWyrTRNkj4Uf2J9	7014	9919	9919	1617724620000	orphaned
13650	3NK7aVnU34xxArcR1Z5wVsgdrf2jyvzWsXsVSiUaQLFfj3dyfD1x	13648	3NKXfXd3Q2ckhmpdRc5Ua8vjLCxw2VXUnzNfBz8p9w6EXH3ZeEYn	1651	1301	205	6301	9862	jwrNWJSwDStKQSuPXPBp2mmkw3p7yyc4ZDMyaDZFW4kasYXcfB2	7016	9921	9921	1617724980000	orphaned
13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	13651	3NKKyKL1ddaPBiWWf5RkR1RDCsHDNk4tf8KDB16VU5LqXFGEHYbu	1581	778	205	6301	9864	jwFjB9eumNXr9hLcjn56GEoRrw5VPFDe3RL3DCKV3FZXj3c4sDz	7018	9923	9923	1617725340000	canonical
13654	3NK72SmdCczS7yNhS9HMsRANM4X6CjnQYXbRrFYtCYvJ2hg9Dtwx	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1403	824	205	6301	9866	jwwCMgngqdcFa5D77mXdYHuFJkpdJc8brcsupgCJae6pAQt1PNd	7019	9924	9924	1617725520000	canonical
13655	3NL2NmZXY1S6vKKuq7mCKCrkJkq2QJHsqgwg1sAtLj8Z11oHNkR3	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1581	778	205	6301	9867	jxVWyMR8oA47BiWYPFf2hRFhBt7SM7PfGcyB3WgYafbmGvmW2sa	7019	9924	9924	1617725520000	orphaned
13665	3NLnEJEVVXMiVTsQ4WhrdLmNzHdxDXMfhY86QYFMGsXVkPzFzmce	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1588	1146	205	6301	9876	jwG6bNb7jtcu3cx4cAv8c6KqmHzugLtVprQQYpdbZ3XruBCBmFN	7019	9933	9933	1617727140000	orphaned
13659	3NK6nFSGDZ8nwqk1swak9ePkGoiieuGdGwc6hdfjvKQcjCJFnwVX	13656	3NLUEVnDrtRLwYx56amCbJ5nAcyWDkPxwjtGPZUsW59mynVB3EgN	1406	1393	206	6301	9870	jwyrGDVNn9CbJqYAyDfKJYCxuJc7GjUzNEkdnh8BGGw2QQhbp34	7021	9928	9928	1617726240000	orphaned
13660	3NLBQPcngP9P55sriw9NPmV6PjbvuSxPi8dXU2xHVdRa8jJXQXBG	13658	3NLCp51JurJpVTT1DLFA8eDFXEFBiQatXR4RET6xMBJAty4HxbHM	1490	908	206	6301	9871	jxzQwZZRTUZBj9DmgD1QP1dELjESB9sBT8f83NGQCuH9DoUPnPF	7021	9928	9928	1617726240000	orphaned
13663	3NKpNop5hZ8HjTaTc58nDzTzuQsWRJsEeQkrgcAud8mvWuJXZpGg	13660	3NLBQPcngP9P55sriw9NPmV6PjbvuSxPi8dXU2xHVdRa8jJXQXBG	1490	1274	206	6301	9874	jx7rtmQTirKAGRzYKbhjL8UQYqKtYC1NkLKTrCeDkkX8tBKqgVV	7022	9932	9932	1617726960000	orphaned
13667	3NKZ7d2WBL3dA1tX6vwFw6VRpUK5uWiddAmMypED7SYr13YNYmEv	13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	1642	1241	206	6301	9878	jxcNhUwS5SxyEJ7QS14ErkRQgJtemm1AzpNcHN1Y5m2RCv9MtPu	7023	9933	9933	1617727140000	orphaned
13668	3NL1M2xYR22S6gyzmutK6L2JbMXphD1mcLsHoEn4t2EF2xZVYM5m	13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	1642	1241	206	6301	9878	jxUTWrzJzwFD6cmkiusAWCLZuVY2gQ47wdFACSfwozLSePvU4bp	7023	9933	9933	1617727140000	orphaned
20146	3NL9f8a7bGrSaAnPmV7UxhviB9y6drGSLYDzybcio3Wsqv5S6W9W	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1590	1300	360	12463	12487	jxNRCkJ7km3MBBwn4swZuKY9hSKNza55w4Mahogfbpqy7Ch7adL	10139	14294	14294	1618512120000	orphaned
13653	3NLdG3aFjUgCzc6SCsJFnDzMnwW5LnpU4ER2G4dQpXkK2K42apRB	13652	3NL78dsTVAekgJXm96dSNJjXXBkox3mh7thiQDkfqqcUstisDTip	1407	1395	205	6301	9865	jx2Y2Pq1uy1sijpGjHBm9pqR4gTM9dJ1WTH7ey2qvKZ8XrNTB1J	7019	9924	9924	1617725520000	orphaned
13656	3NLUEVnDrtRLwYx56amCbJ5nAcyWDkPxwjtGPZUsW59mynVB3EgN	13654	3NK72SmdCczS7yNhS9HMsRANM4X6CjnQYXbRrFYtCYvJ2hg9Dtwx	1646	1354	205	6301	9868	jxWfk9JuU4Rq4utcFqhGKB3oR3zS5ZENUirFYXXPv5o2GsUbsVd	7020	9927	9927	1617726060000	canonical
13658	3NLCp51JurJpVTT1DLFA8eDFXEFBiQatXR4RET6xMBJAty4HxbHM	13654	3NK72SmdCczS7yNhS9HMsRANM4X6CjnQYXbRrFYtCYvJ2hg9Dtwx	1646	1354	205	6301	9868	jwojoi8eNDY9Fftow1PaDFNUeLP62HEVaeQ6fsi9VaF7uoTzdtX	7020	9927	9927	1617726060000	orphaned
13664	3NKVcUj25NeVNPqtL4VWdk3ghmd1ufzUd2PzqwYyfyQJoE9ZHeVi	13661	3NKzQ7cA7G8MtRY8qbHaVbvD1bf5T1Kzb6nvbmvArQxjokM8i3r9	1670	1036	206	6301	9875	jwYDiq7uqiFgmM1PUHEkZA6dqomKv6aKaxdcTqydZ8CtEn5ozy3	7022	9932	9932	1617726960000	canonical
13670	3NLs7dYQwvUaPZuiDuw5PHUZ311t3Z5RUBqifYKHpjRjBuKcUUR1	13666	3NLPPW7gaxTbijkd2GtkghpAmMVWtchvE9SZEarjF43VMNEiSNVX	1652	1315	206	6301	9880	jxhMwYRkxVzq8cp87cLeFxBRfkebwxaacfUmajySPLoegwHMYdK	7024	9934	9934	1617727320000	canonical
13669	3NLDQn71ueXdxND72rcMv1UzxXghR7j2AmtZEPX8u3Lzgf1T5SEU	13666	3NLPPW7gaxTbijkd2GtkghpAmMVWtchvE9SZEarjF43VMNEiSNVX	1444	1381	206	6301	9879	jwRyVbf1CsSwqY2xHAVT2Ppmw5SB4xyAD93rYDXhjKwMgrk42LP	7024	9934	9934	1617727320000	orphaned
13672	3NL235QMXX3xMgSF37JbYfTRYHsJiRdU8fGZyr2D2qccib7km8pV	13670	3NLs7dYQwvUaPZuiDuw5PHUZ311t3Z5RUBqifYKHpjRjBuKcUUR1	1534	1071	206	6301	9882	jwU1mcGKwixvbkrdCsMkm61Mv2o3RHdF2LqCAJQuQygeEqhQZB3	7025	9935	9935	1617727500000	canonical
13675	3NLqWKyRSLodQ8SWcspRteo3VDwxSgoFDjNd7g3bTWo5vVASJU38	13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	1536	1313	206	6301	9885	jwaNqAVyDShFps3rHtC5zfv1fE8UrxNaJfBC6gXmQ7BRk6QRzaG	7027	9937	9937	1617727860000	orphaned
13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	13677	3NKudt8L3nPnNboKqo6JPg4TEqFfWzH7LXLf8MekUJyjqLyjfuGV	1631	794	206	6301	9889	jxGcARFKPKXihh8xdv9qse5KrtiU1aaqaPTnvA1AGSpNTW2RDWQ	7029	9939	9939	1617728220000	canonical
13682	3NKBc5XG2pQUiPBZAEdnFWftoN1G1rfnJwGbT91MvKJsK8jZF838	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	563	1359	206	6301	9892	jwyfYV7QEJAYf8PZasCKJXhdzYXwAXePU1ERcFuNnUDQJhgbg55	7030	9940	9940	1617728400000	orphaned
13686	3NLsfKv324Wfc1XdFwqootu7tjtjUr9PUHkdbRyxBUXfej8QmzJL	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	1651	1301	206	6301	9896	jwx69FzZV4E4uMKtSNviqSjbYsjtpFW6xV5mQMKNqpHti11PGx2	7032	9944	9944	1617729120000	canonical
13684	3NLxSwW6hoZodkc1UEo7CpBgjpYiWUapGA19rvNtg73EUVBXQK6W	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	149	1037	206	6301	9894	jxirCm5Rv8Fyv7oxQJwvvSVDHR9s5KfKCvXDUFuXgHtQr2mYKx1	7032	9944	9944	1617729120000	orphaned
13689	3NLCpL8ZhbqoEMagVawP5ksnrfcPLSj7zKpM4RrS9Q4U88bfXPEk	13686	3NLsfKv324Wfc1XdFwqootu7tjtjUr9PUHkdbRyxBUXfej8QmzJL	532	1303	206	6301	9897	jxH6bMxHXGSpKRamgg2G7vBSgNXscYRV7e1r5xoR8AVvro8kQaY	7033	9945	9945	1617729300000	canonical
13691	3NL4p6cjCVuut3fvx91xLFhxfVjavMx3mP2SqcDjnPYqQWCbpmmW	13689	3NLCpL8ZhbqoEMagVawP5ksnrfcPLSj7zKpM4RrS9Q4U88bfXPEk	1559	1227	206	6301	9899	jwEojLUohR9NC3dDTgAN9z1LPDMA2UUFmfcDyypwbzmqz7j7Trt	7034	9946	9946	1617729480000	canonical
13693	3NLPqTPwEsoFP3mPqKTyrF3mh5VmeujExJ8RJwALf3nt6D1abo78	13691	3NL4p6cjCVuut3fvx91xLFhxfVjavMx3mP2SqcDjnPYqQWCbpmmW	1637	816	206	6301	9901	jxXfRa4Ctk11DmgrPEnTUDDf26v8jJqRzSYZHLvEVeTSSzWzzWi	7035	9948	9948	1617729840000	canonical
13697	3NLDCzFrgrajNJY8wUBkWbSSouKhU36sYDFsk6fq3aYZQLpsP1cV	13695	3NKKvzj6Wpqt5RXKHMgAgkhBKqvgQR8XmwzqpzSaCcpxaqp62vYn	149	1037	206	6301	9905	jwHYng394nvWyzJuqaB8wSLJC8pGBB1Xrm1ZcdPpRmzoWnoHtDQ	7037	9952	9952	1617730560000	canonical
13696	3NKqK4KJyoq5rUYAghTsBnvghTDSVRXo436hQTM6kkUJYG97qGGw	13695	3NKKvzj6Wpqt5RXKHMgAgkhBKqvgQR8XmwzqpzSaCcpxaqp62vYn	1407	1395	206	6301	9904	jxijhRsCqT8tzp2XAi44GeuNmp4BFZR8cDaBhSwrUJk6g6TqeL6	7037	9952	9952	1617730560000	orphaned
13699	3NKnFVNHjd3ENdkXxs1dSQ59WdzKUYAYzcrxYPf83goWYcKWU6V4	13698	3NKPiHAruBL5KVLbx1qavqnsKm1RX4H9ppSPckYd7GFbLcndWr1b	1423	332	206	6301	9907	jwQk3gYmLJhVxC1ZDE3QoiJEwZ3FhtaGJMaS3z59KxT6Vm1tVnG	7039	9954	9954	1617730920000	canonical
13702	3NKziwSkEbVWSHVj9QEYQqXsfFGsU6xiQBq7Ng61ijwc1W14LRHb	13700	3NKwnk2geNXcvz5YPs2GirHF5Dh5iNPHszA4ncytWzkNVbqMLiL9	1549	1236	206	6301	9909	jxmnHpUbWgd4PJFLAxs9VaANfHpifpN2sMcSEamWBUB3mKk788D	7041	9957	9957	1617731460000	canonical
13703	3NKHge5oczsPsdhq6TZ8btKd8ejYVeybRcG3cCASU2U42VFCzW6r	13700	3NKwnk2geNXcvz5YPs2GirHF5Dh5iNPHszA4ncytWzkNVbqMLiL9	1549	1236	206	6301	9909	jxmnHpUbWgd4PJFLAxs9VaANfHpifpN2sMcSEamWBUB3mKk788D	7041	9957	9957	1617731460000	orphaned
13711	3NLDqQefFEGHxg5uQKNGfbSMkJyEL4VbWKtAGy9TZDujQgZNmKxR	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1506	1007	207	6301	9917	jwUxCZ1ghYWGCn8HWkB3vEKzBEduVzWBbwJBH9WYvoDqts9atZv	7046	9963	9963	1617732540000	orphaned
13715	3NKaoiPTLzRaQVmbdFxkT5fGNABxKe6h9ETuFtMT4FPMsYUrDSCX	13713	3NK7Ny3TEvsvAMBCMhinyHwCr6bdiBv8crbsU4EzwM2emzudmuAF	1467	1250	207	6301	9921	jwRoBNjHBHRxocecPK46aS8RyBFSw9p89Aaz3J1UX9XzEapwJam	7048	9967	9967	1617733260000	canonical
13718	3NLHk82kqXSu7rti1FpLcVConFnmXqrccRLm3qtEvVorZPUpE53w	13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	1571	1335	207	6301	9924	jx2AEBna58tufhwvJsksGWrefd5BdgZLUkNiSCvhuymHZsiSr7W	7051	9972	9972	1617734160000	orphaned
13721	3NKsAyJm5Tc2XuscVpZHf5h7CnyvKKhd6FbfCDeoArkDw64j2PmA	13719	3NLhniyWRVPUGX6HSHVRVWoDJ7W29NyRMfDwKjn1aZNsUJTtnMSK	1407	1395	207	6301	9927	jwC7KciouvskwzLz2WoPG133rbsrkNqYE1w2LtxMPUTGoYgF4cn	7052	9973	9973	1617734340000	orphaned
13723	3NKzVSHP4fRFBjGgBXQ3Auz4trXPgudbpwY9Zs7DqjpbPSH1KiCr	13722	3NLdSxdiyT1pCJNVotBUXw1tbZDLpZ6LMLReaEkEATJAD36HkhMS	1423	334	207	6301	9929	jwU7YGXjiqrARc2u7twTP89GXCDyFii2qmNajwNKYHv68DHbX6m	7053	9974	9974	1617734520000	canonical
13728	3NKRNyxUeEzN28gMpwoojog8i7Z1HaPnYfberQDjJhLudbqk8rqu	13727	3NKKMhs9NHv8BsJ556DydCTpx5L3xTDXwMMDJaziyoTF4gTB6rwJ	1599	1287	207	6301	9933	jwdtqiwLdxNrXToiCHynBNA1mFZ8dKP75kXXJcRm1V1yWh2zCEh	7056	9977	9977	1617735060000	canonical
13730	3NKxhxq1rVDBPzLVgj8NsxLUzLb7BQE2WLHeN13ntoHxNPEmNpi1	13728	3NKRNyxUeEzN28gMpwoojog8i7Z1HaPnYfberQDjJhLudbqk8rqu	1406	1393	207	6301	9935	jwEekJPib7PoT6eN7eSfmv7KZYR6eBdFDanNm3KUsgnQod11Gdf	7057	9978	9978	1617735240000	canonical
13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	13730	3NKxhxq1rVDBPzLVgj8NsxLUzLb7BQE2WLHeN13ntoHxNPEmNpi1	1591	281	207	6301	9936	jxgvV9xUw9HTkm2UHabVr21VYSfympnFL9NZtKx3FLUZV9wK7H1	7058	9979	9979	1617735420000	canonical
13735	3NLkatTGZqfgM8HGfzZvpsn3r1TgXjyNwF7hkdNnJoJdSpim7xxt	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1506	1127	207	6301	9939	jxPpPX6Bj625kHAWfwZ9P5DLWpT8mSybrXYmifEtGH9JZNGVerr	7059	9980	9980	1617735600000	orphaned
20708	3NLvAvegF4B5SZqkHmg651KCMw7gDhhssTnsuWBNaZVWeSoycajb	20152	3NKCAYWP1dThMZiWsKNse23Ak2CAUCev37YDYJ4dmhSwfZJGJa7a	1480	659	360	12463	13007	jxbha4Nc1o8uP6mge8Qdtne44dVW7JS4wEKDA2j2h4XeVPfpo1a	10144	14679	14679	1618581420000	orphaned
13674	3NKRVdX869SZndhVKCoSqFb8rnc2AsmWXsmyUyVUkhwk9Q9k434a	13672	3NL235QMXX3xMgSF37JbYfTRYHsJiRdU8fGZyr2D2qccib7km8pV	1541	932	206	6301	9884	jxHGyweJf132phYq4csv4T1dhRy3oTewXS6AyNQqrjmwHVBPXsT	7026	9936	9936	1617727680000	orphaned
13676	3NLCVSFEh3SzY37Szqrp6SoGX1iNsnhzgackT9CX4RqZ6xyPtEcB	13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	311	1061	206	6301	9886	jwe1a5n1sU9FJWg3rGs37QgbWDNSTZ6aZKFmpQswfMTBcXCyTup	7027	9937	9937	1617727860000	canonical
13681	3NLiWPMGEoVhw3WAUpmjNj4bmi9KM8MY1KEqkCn1X9DHcWrgEVYf	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	1553	775	206	6301	9891	jwvKU4fCu2hpggeKcjvCbmGmHCHnXJ5ha82bnHaxpBotuYnpN1E	7030	9940	9940	1617728400000	orphaned
13687	3NKv4KESR6VUXWtWHSdGX7bxZKkTRUS1tmaGykMjvnC1aYnUdnzA	13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	1651	1301	206	6301	9896	jwmvHUgHG96c6np2wCfCg57HdDKF4fHAcq8EERqXiHtqE48HDEQ	7032	9944	9944	1617729120000	orphaned
13688	3NKTqVY3Csw5QRuD4tdZ4oUSYexLwxh8xYBb6gTNMpKU9XGSW33o	13686	3NLsfKv324Wfc1XdFwqootu7tjtjUr9PUHkdbRyxBUXfej8QmzJL	532	1303	206	6301	9897	jwisLQSvuggzAXajn8bgtpSzSCGG6uwwwN1PJCPMqhJDdcHRgCQ	7033	9945	9945	1617729300000	orphaned
13690	3NKfU9kjSShuL4kQaDmmbcWWWvty3NWAUgYYD6zF4YFCXnnjk6i6	13689	3NLCpL8ZhbqoEMagVawP5ksnrfcPLSj7zKpM4RrS9Q4U88bfXPEk	1642	1367	206	6301	9898	jwZ3mvRxhQ9eomw1di4SMBtKpKvuTqhC86aZoxFeQbysNvkmiUS	7034	9946	9946	1617729480000	orphaned
13698	3NKPiHAruBL5KVLbx1qavqnsKm1RX4H9ppSPckYd7GFbLcndWr1b	13697	3NLDCzFrgrajNJY8wUBkWbSSouKhU36sYDFsk6fq3aYZQLpsP1cV	1407	1395	206	6301	9906	jwcQt64zDMPidBG78gzbzysGdigPSVKuzMktm27QQ1pzjzWv76N	7038	9953	9953	1617730740000	canonical
13701	3NLMfcHFRDswoCdTruprRdh5F84fHshZtwt1HRgwn14hzQP9v3Nd	13699	3NKnFVNHjd3ENdkXxs1dSQ59WdzKUYAYzcrxYPf83goWYcKWU6V4	1651	935	206	6301	9908	jwCbuEdCf6CYWbhFfxwnniHBvBY7WHEyhfppHXJqhH5fJdMtJmv	7040	9955	9955	1617731100000	orphaned
13709	3NLm6CSdWcZBZaSE8on97EdzwCCi4bwDMWz6V9ZyPeewDahNEPUY	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1406	1393	207	6301	9915	jwpf99aSg1ntKDKNJCQsm6iPreoqrue3Xno8hMmNe2Q7GQyG53H	7046	9963	9963	1617732540000	orphaned
13714	3NKY6N9oEFZQUr5TgQ7kK5S2BJBLCTv2hsBiTAQRWa5nj5jEDSWQ	13712	3NLHoEUnccTX53JzQtYbrb2JaDK3sFSWWx76SuUfXS5Vzkmzc42Z	1617	1288	207	6301	9920	jwpNoxkga9bg7ks3JFZ8eQAvLiYAvSRkdfY5up1bvSV7DPCXay7	7047	9965	9965	1617732900000	orphaned
13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	13716	3NLLQoo8zZx7gi2knnHTmsquzcxwMu8DMgB5CwMT5SYC2Bx3kHXg	1585	1120	207	6301	9923	jxQGfLceDjhHi2eFyJK2jJdUuWR7zmerhMb5ntsUxx4EfXybvFF	7050	9971	9971	1617733980000	canonical
13719	3NLhniyWRVPUGX6HSHVRVWoDJ7W29NyRMfDwKjn1aZNsUJTtnMSK	13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	1407	1395	207	6301	9925	jxzXsGF1RHVFziMVUigNrotoaSmaX6T2ieBewNeNWrxNEkUjYZp	7051	9972	9972	1617734160000	canonical
13722	3NLdSxdiyT1pCJNVotBUXw1tbZDLpZ6LMLReaEkEATJAD36HkhMS	13719	3NLhniyWRVPUGX6HSHVRVWoDJ7W29NyRMfDwKjn1aZNsUJTtnMSK	1406	1393	207	6301	9928	jxzGkUQ321bFxVenCq6hituyYQLmmA6eyNpxUtQHb5U6xXvrQ7V	7052	9973	9973	1617734340000	canonical
13725	3NKhK4WAKBbNAMTj4qhMZqfDrfnAA4JXvNt33v4zLCSVPKSHg5vR	13723	3NKzVSHP4fRFBjGgBXQ3Auz4trXPgudbpwY9Zs7DqjpbPSH1KiCr	1467	1130	207	6301	9931	jwqtivWFCshGAFA1Z7kHa83UuvLAj5XzX2f4PGftqsQRNxzaLi7	7054	9975	9975	1617734700000	orphaned
13727	3NKKMhs9NHv8BsJ556DydCTpx5L3xTDXwMMDJaziyoTF4gTB6rwJ	13724	3NLhLorcj2tABabZBcXLAWofv1h6KbhFceEJWKqKZLe2rqFCAxwq	1445	1290	207	6301	9932	jxAAqoPoqvnHjm8LqBo1CkDqJhRkVtqNM5W5vUFEhUfFj57io8Y	7055	9976	9976	1617734880000	canonical
13733	3NLvp2k9X1ojgRY5cfw2XuZ6G4h993PjYa2tj6b7WHX3xMq6J1B2	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1553	776	207	6301	9938	jx9hCpTCrkfD9X7FeUeeQPDTraQsa48Z8N4Y8upVxQNk3vxdmRD	7059	9980	9980	1617735600000	canonical
13736	3NLPC5pnq97VVVxxVENJxBLzjtxZQJsAbdoCo2FuYgLJj9m1SJha	13733	3NLvp2k9X1ojgRY5cfw2XuZ6G4h993PjYa2tj6b7WHX3xMq6J1B2	1406	1393	207	6301	9940	jwWeXWAPdjP6oJEJE1KqfJKjWQK8vbBf57w4yaz8iu6rzHWnP6V	7060	9981	9981	1617735780000	orphaned
13740	3NKvhGWsq6kp6kEfBFqEzpn2JmnsoDS6EJ1xML7RexL3dQFSJ97a	13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	1523	1075	208	6301	9942	jw86BDjannSmjsLU1nuaiZcsQujYNBU5u3t5WtT1LruMKoEm4Wn	7061	9982	9982	1617735960000	orphaned
13742	3NKjVr1yEctV9ZFTRrc6oSnxpPWA3myM1qGSeoHeU3MKAWFctpa8	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1646	1108	207	6301	9944	jwuqPi1tJ99m7sgSkokbbg52udetW1Z9iYP38tk6LbV7gY3pTtH	7062	9987	9987	1617736860000	orphaned
13743	3NLYmCi4UEiL3Kwut2R9icLiJLde2kdvmZNzCTaGpF27YkhNeiHz	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1406	1393	208	6301	9945	jwQwmaEsWEyGsxUkQj1RbVAK6ZF2CFRQXfSWJFMGhTJy4R328KX	7062	9987	9987	1617736860000	orphaned
13746	3NLokfmEFrqEyH4wHWMY6nuoF8rS2fGbpuxtVtYBMBezuuumtjfC	13741	3NLXX8uwyBM3MVAA79yyqWTAvtT3ehrT5CAFD24Y6GYjcFUbdso6	1406	1393	208	6301	9946	jxrDKCW3dfRWFLhLqQxVX2LjCLGyLWQzEiw28wKn9vb45Bo97gk	7063	9988	9988	1617737040000	canonical
13749	3NLiWVFAmVe9rNtoaaMUqyYmWHoP2qX9xzK4JBzpm7ydZjYDVrCo	13746	3NLokfmEFrqEyH4wHWMY6nuoF8rS2fGbpuxtVtYBMBezuuumtjfC	171	1374	208	6301	9949	jwSuURQy8EKyT9c9nkyjgLaWWQHamNatU7CMqTMVjhT4X1GLjDM	7064	9990	9990	1617737400000	canonical
13750	3NLqG4oRPaZ5fehsvs6jLxJstmsvKfcxXroVKc9orZZoy4fcYgfz	13749	3NLiWVFAmVe9rNtoaaMUqyYmWHoP2qX9xzK4JBzpm7ydZjYDVrCo	1542	1178	208	6301	9950	jwtrUPSArVcVF579mjHQx5A64uW2tcWzo2Dbs4MpvrbYqcYDakJ	7065	9992	9992	1617737760000	orphaned
13753	3NLPsM4spYfT68mUQPqHptKbKsX3dSqKYYT951hepQ2MMQyLP12X	13752	3NL5YmA9hZqgo9yWoAj4BoWgMRY4rcVmfB4sn8rJfAWG7pTLpxio	311	1061	208	6301	9953	jwHutY3ckMnvrFJEwmNjadzYtoaTM91eAT6fXUVKkuqTRVDhjNd	7067	9994	9994	1617738120000	canonical
13757	3NLaGgW4wRWsgitBmJjzK9ygPYQ6k21hJs5L9BWd6eSrXf7YY4er	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1406	1393	208	6301	9957	jxGVYCAXDUNN7wK6yYRSVTntr5Pw8S8jQdTNJP42hobcEBJUhcx	7069	9997	9997	1617738660000	canonical
13761	3NLiQAhfStXtZ6g9fcqH2hKvzMh2NzuLi93J6KNNcf5UiQdLdg9K	13757	3NLaGgW4wRWsgitBmJjzK9ygPYQ6k21hJs5L9BWd6eSrXf7YY4er	114	114	208	6301	9960	jxveCRp1kV1FmYTFcjopvp3YUMzzz5w2mWLmVbUsL4cUV9J9Ttu	7070	9998	9998	1617738840000	orphaned
13766	3NLF43sxy562kx8trKUKT9YDNo7XEi2uSh7TJSXePQsMKZVQEhvH	13764	3NLmZ96KdqR8EBbPbKNBynxp9kajjNas9WB5LBavjtnDMD6nmLaf	1634	1205	208	6301	9964	jwvCkSzJiVDmF1znCe8CkZq6Ef6Gf6me5UCBHZeCr5QUJsZrt6x	7072	10000	10000	1617739200000	orphaned
13769	3NLbiSPCmioCPCigjW8DwXWFrii273EAQCJSRsoJkx32xeFPqKWb	13767	3NKoFSEuHKVkMqKHPhCXQroMepeo6Dem5PjyAwvyFjG1Jw3qr6K6	1403	824	208	6301	9967	jxVQRzEq1e3XaizswGfNUbLN4cmVPsdATzuYuN1WehLnXnh5jhD	7074	10003	10003	1617739740000	orphaned
13771	3NKDy8GbAEwPEQf4XRimCVLPkSwzP1LyGWbVwLAmp2bLNFiX8xBg	13768	3NKrhsCeWMdfN3eGn4ZSNPi9AUGvjSLoseAX9rrAKgy6LfzZsF4o	1649	1017	208	6301	9968	jwMkAaatqGTWpqzpKaHa2MyDs3amv5ZDeCp7mELwMNtaYrYtDFD	7075	10004	10004	1617739920000	canonical
20163	3NLCc6DvMUCLcurwFZsHG9hFN9v5rjWGut8ogWUbQXU1zJdhVVmP	20160	3NLWD4yDXkZX11LsB1bUy7Xof5osjs8dGLj2vymEcCDfBHiCx8rd	1483	1276	361	12463	12504	jwkjdYf4UTEHqGvDc4K4qegST87eYfAHoCgFNL6NX4xUqSSb7xZ	10150	14311	14311	1618515180000	orphaned
22119	3NLX6ecQHJVN8GGDyvXYk8t2nZHstUFQ7CwvRZg1Wcp4q5kA1N1u	22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	1503	1031	406	12463	14253	jxi3bjR9ygyxzKNSd9qt5TXrWiUakribpHF2Q9XFBA1e6FLM14E	11062	15576	15576	1618742880000	orphaned
13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	13672	3NL235QMXX3xMgSF37JbYfTRYHsJiRdU8fGZyr2D2qccib7km8pV	44	1079	206	6301	9883	jxdqCDdkCr1hzc8UKnMLPrP2LDgmFmcFrhL4cDVWQZwd87D9Mg5	7026	9936	9936	1617727680000	canonical
13678	3NL6cYV8r3Z48vqx3FVQxeBJUAEAXq4XCAETjbmQpfv4JCrUnkgC	13677	3NKudt8L3nPnNboKqo6JPg4TEqFfWzH7LXLf8MekUJyjqLyjfuGV	1426	1118	206	6301	9888	jxZ5RBmE9wbCknbnVEDertGjDkaonRBaiquUTMmVe6BJrxkgi19	7029	9939	9939	1617728220000	orphaned
13680	3NLvy7ZBEDYudWKHYKKr4wHAiWg5GuBpCEcHGiM7HULVjzHDLg3Y	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	1407	1395	206	6301	9890	jwzB9cRUqQ92cBCKnfUpbWXYWJAkq6MLnmc5q33RjrLufsxnZ11	7030	9940	9940	1617728400000	canonical
13683	3NKhEsJdqLxyHv9LJi7u8LLCDCAtW5UfNw6Lr6D5eiD975tRoRfj	13680	3NLvy7ZBEDYudWKHYKKr4wHAiWg5GuBpCEcHGiM7HULVjzHDLg3Y	1406	1393	206	6301	9893	jwgchbNL8C3WxLMY7mnvM3yMtxnfTioeurSDoiJe3DP8p41UeQM	7031	9943	9943	1617728940000	canonical
13692	3NKkqT46vCSZogUeV58qLSwbvbXybCwv88t77TASHpSkPvBr7Toa	13691	3NL4p6cjCVuut3fvx91xLFhxfVjavMx3mP2SqcDjnPYqQWCbpmmW	1457	1391	206	6301	9900	jwiL8RjafNN7HXS3dZ12wDLmMzrwXRwBAkgtSCiBunLzSqTEMkN	7035	9948	9948	1617729840000	orphaned
13695	3NKKvzj6Wpqt5RXKHMgAgkhBKqvgQR8XmwzqpzSaCcpxaqp62vYn	13693	3NLPqTPwEsoFP3mPqKTyrF3mh5VmeujExJ8RJwALf3nt6D1abo78	1403	824	206	6301	9903	jxeFKUG46U36gUjjjNSUw8aLJkp8G5EZTj51ShzKXiUiTCF7Jf6	7036	9951	9951	1617730380000	canonical
13700	3NKwnk2geNXcvz5YPs2GirHF5Dh5iNPHszA4ncytWzkNVbqMLiL9	13699	3NKnFVNHjd3ENdkXxs1dSQ59WdzKUYAYzcrxYPf83goWYcKWU6V4	1651	935	206	6301	9908	jwQ8ZjoSoJa9KFtAxkyyTVMNVEAgi8FXjHx38ySnYxJmQqXdsKa	7040	9955	9955	1617731100000	canonical
13705	3NKt4su5DQeABTJcCBAnGUkGKLvAvK7LfHtTTAzkLBdPGtBt1vqf	13702	3NKziwSkEbVWSHVj9QEYQqXsfFGsU6xiQBq7Ng61ijwc1W14LRHb	1471	1140	207	6301	9911	jwrA4gETn6A7wLVzqfnhMztsw5hDULmD2XCaNQCYgjwLxRGvXd1	7042	9958	9958	1617731640000	canonical
13712	3NLHoEUnccTX53JzQtYbrb2JaDK3sFSWWx76SuUfXS5Vzkmzc42Z	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	1405	867	207	6301	9918	jwVDtsz5kLg38nBps3na7Jx5XSPnS7PLAYqt7PLAVhEdnfY7eny	7046	9963	9963	1617732540000	canonical
13713	3NK7Ny3TEvsvAMBCMhinyHwCr6bdiBv8crbsU4EzwM2emzudmuAF	13712	3NLHoEUnccTX53JzQtYbrb2JaDK3sFSWWx76SuUfXS5Vzkmzc42Z	1649	1383	207	6301	9919	jxhmWseDwoCxFGHXuaNMwjAh8gEocsHfiRuhVo2SHkjDVN1cuej	7047	9965	9965	1617732900000	canonical
13716	3NLLQoo8zZx7gi2knnHTmsquzcxwMu8DMgB5CwMT5SYC2Bx3kHXg	13715	3NKaoiPTLzRaQVmbdFxkT5fGNABxKe6h9ETuFtMT4FPMsYUrDSCX	484	1073	207	6301	9922	jxsnxsfmGAkpFvZmCaU1FyWqyXKjTYzGZLBVRuTcZ8FwZ5doopV	7049	9969	9969	1617733620000	canonical
13724	3NLhLorcj2tABabZBcXLAWofv1h6KbhFceEJWKqKZLe2rqFCAxwq	13723	3NKzVSHP4fRFBjGgBXQ3Auz4trXPgudbpwY9Zs7DqjpbPSH1KiCr	1670	916	207	6301	9930	jxP8HfWVG433TEowdmmRHBnsczM9TSnWUeRbWNt4Ch1fScswC9R	7054	9975	9975	1617734700000	canonical
13726	3NKUDUeaE3UDieJcmBGhsg1a7jzrTSUNx4KEudWrxv9KmdStiB4S	13724	3NLhLorcj2tABabZBcXLAWofv1h6KbhFceEJWKqKZLe2rqFCAxwq	1445	1290	207	6301	9932	jwFRkM5zRr8SiCcCpyDAwnpKujES3yyzqBgxavYzNgP2QL1CnKP	7055	9976	9976	1617734880000	orphaned
13729	3NLRCuA31YwFufcpysE8pjFA3Xkz4E43UDWrC5uoDERs3Jxxdc5c	13727	3NKKMhs9NHv8BsJ556DydCTpx5L3xTDXwMMDJaziyoTF4gTB6rwJ	1553	776	207	6301	9934	jxgLSuxZmz6bHJTfjGUdysF15MV2y7dyVfPsarnVWaxKsVy3Whs	7056	9977	9977	1617735060000	orphaned
13732	3NKxv3WmScAQzfuMWWeKbhZ1HD4LCzryaWWRhmUCaKu2qf9sf8ab	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1406	1393	207	6301	9937	jwxLZ1TQJrWAZi1mL8mQVSP3XTPse2qw4H64sz3C6tKBefVBKuX	7059	9980	9980	1617735600000	orphaned
13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	13733	3NLvp2k9X1ojgRY5cfw2XuZ6G4h993PjYa2tj6b7WHX3xMq6J1B2	1403	782	207	6301	9941	jwYXusME3DqVcoSeti1EWhhB3xvyjFc64ABHRAnw9d642wSjnH5	7060	9981	9981	1617735780000	canonical
13744	3NKKww7VaneCRV1pW32QRqMwRryA8NxabN4LC1RAvzh6KGnCVACZ	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1646	1108	208	6301	9944	jwuqPi1tJ99m7sgSkokbbg52udetW1Z9iYP38tk6LbV7gY3pTtH	7062	9987	9987	1617736860000	orphaned
13751	3NL2kuDQWf64BugcV4rqDYpvsyiVjbn8d6B9d7HnGSRMqWmAUE4U	13749	3NLiWVFAmVe9rNtoaaMUqyYmWHoP2qX9xzK4JBzpm7ydZjYDVrCo	1596	1117	208	6301	9951	jwWq4C4Zj7kRA8zqQvRjxeGJ42tKCf5fdoEGbq4drSrjhZFK3SQ	7065	9992	9992	1617737760000	canonical
13752	3NL5YmA9hZqgo9yWoAj4BoWgMRY4rcVmfB4sn8rJfAWG7pTLpxio	13751	3NL2kuDQWf64BugcV4rqDYpvsyiVjbn8d6B9d7HnGSRMqWmAUE4U	1581	778	208	6301	9952	jxWouUUfzQfT173Cy6UDk1t3ybVmcDSJg9XjQ2cQMVrRi2Armkv	7066	9993	9993	1617737940000	canonical
13759	3NLd7ejZ4T2KFcncM69Wh2HxY96iuPu15aVc1MrYHmUgAbwi6SEy	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1560	279	208	6301	9959	jxucQ8Zcod96ygnjgTJNentdz33Cd4PYavZqqyEHWe8fWixYCsQ	7069	9997	9997	1617738660000	orphaned
13756	3NKHaR6pR7sA5kfWaturJBPrDknKb5veF2VPdK8gDiuptJKbQMus	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1587	991	208	6301	9956	jx9ZnREUUGjpZL3V1hKRoKySiTX6C7Gqge4ce49J7EjsVEKtgDJ	7069	9997	9997	1617738660000	orphaned
13767	3NKoFSEuHKVkMqKHPhCXQroMepeo6Dem5PjyAwvyFjG1Jw3qr6K6	13765	3NL4pixUFZ4W9xEGHDT3Wpt6ZTMobqfAvg4qc2NfgyhP59g9oPHR	1529	1316	208	6301	9965	jxNwDzg1bPmBwcj94ETFJdQtYhNSdCvBDw8uAWYswDnVrZ1Ega5	7073	10001	10001	1617739380000	canonical
13772	3NLFLTjeViMkcMJpEfgmjexn1t8oyYbNJUMXPwNWJYjCaSexVqba	13771	3NKDy8GbAEwPEQf4XRimCVLPkSwzP1LyGWbVwLAmp2bLNFiX8xBg	1587	1231	208	6301	9969	jx2Dw2DZpXprrdVGCu8ezDatSyh8mKXRNYpebdDtgk1zcTcGwTR	7076	10005	10005	1617740100000	canonical
13774	3NKShBWUcBLLWZ5qNFbyyH47WjrMFpN1CK3m9Xi8FsNJ1ho7P9mY	13772	3NLFLTjeViMkcMJpEfgmjexn1t8oyYbNJUMXPwNWJYjCaSexVqba	1617	1162	208	6301	9971	jwL5jyoZf8svasNCzE8DC248qfsJ2zTsX9VVDLHKVwDE3CDAMtq	7077	10006	10006	1617740280000	canonical
13778	3NKsMhCgbu36DEE7jTMhTwXfEE9ZvyEUD4s1hrvce5mRhKy8cqUz	13774	3NKShBWUcBLLWZ5qNFbyyH47WjrMFpN1CK3m9Xi8FsNJ1ho7P9mY	1522	1322	209	6301	9975	jwn3VGrVwjCsbYJMFLKtXPKc1zMc7PVav8vMgBvND78BZgLn91a	7078	10009	10009	1617740820000	canonical
13782	3NK9p8gUNjdE3EabXRCXU5yVHWh9tL63SoowFr8cJa6hubcVaM1g	13778	3NKsMhCgbu36DEE7jTMhTwXfEE9ZvyEUD4s1hrvce5mRhKy8cqUz	700	840	209	6301	9979	jwcDkjLwxNdFh429BqvSWsBfUHNTZYnDs9XLr65wpuGe853Uq5c	7079	10010	10010	1617741000000	canonical
13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1633	1390	209	6301	9986	jxyHmYPZ6sgpJsbwQxcwN9L6EAnqfFKZNLt7aeeXLoPTRFCNw6N	7082	10015	10015	1617741900000	canonical
13788	3NLcrrwKTRa2C7NrCQ66Ri6YKyEnHYAxnsj1rCC8dxMhn6meP8Yc	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1622	1110	209	6301	9985	jwAQ19Vgf9F43dNvneJT1p7UvresWxZbKo1zAp1PZdv6r9AG84n	7082	10015	10015	1617741900000	orphaned
13777	3NKUJKjLxkV4uFjCJ1pETm56Kwa1KztwLEmvVGP5MwsVmi6k2kZM	13673	3NLYp5U5kcRvYZGEW4KjYM5hwPbVVhmRdRu2vYmueb1XKAKTvBgd	1522	1322	206	6301	9974	jwaNLnxkuk3CB13yTT8apaficAhtZvAzbXLwv1jiQjGEZnpbpTx	7027	10009	10009	1617740862439	orphaned
13781	3NKHx984A8MMwzocXxvLyabhnTYh9unWCqRBTJ1Amd3BREkhYjmw	13679	3NKfbNtgnXb9b3Emu4m4bph4kQM2C68FtToLHTBH6qRKw66FUTHG	700	840	206	6301	9978	jwqJ1UQqiTLCYgKKukjwQWZTwF2kSvdttSmAH1LC2eCj9XWPPKy	7030	10010	10010	1617741000000	orphaned
13779	3NKFBNe33Ua8GhaoGHN5DbNRzRSuv6T3AoNkBN2xSjdWjTDfZLwt	13693	3NLPqTPwEsoFP3mPqKTyrF3mh5VmeujExJ8RJwALf3nt6D1abo78	1522	1322	206	6301	9976	jwENw12uqfQfCdh4DenXzSpsTJufbSxBjjvYLFxZdBmGEPWANdW	7036	10009	10009	1617740901788	orphaned
13707	3NLQ2gVZPpvytFuQxo8J27J6nbCUpVZvurpgbPmgi45fGSBG4a9f	13706	3NKp5GWMTz6mPp9QCrp2yPL2LArEzoVeDAmxGAQRdG6wJx3BKvQz	1647	845	207	6301	9913	jwbJg811ro3AP3w2GV7sDww1FCJcFeG5sVZvyxBjbqKXgWHBRXy	7044	9961	9961	1617732180000	canonical
13710	3NL9p9Q73dyUJMxg8zr9Udd39ysKCqofGHBFx9HQKmgtCGYxswfm	13708	3NLVXG2biMuBnBo1xQouHzUmzjH2H9w89fpP8yTrTpXocKX1C9yX	44	1079	207	6301	9916	jxGupFmozvxz3vznMrTEPEnUS1f8yhXFevMtnBa2STVgL1fv2vs	7046	9963	9963	1617732540000	orphaned
13720	3NLbf8jpoVCxxesNhoNjRZFJNRmvK8EV1xsRnStgkvaJW9tu62JW	13717	3NLjeJXdd77cY9ZQtZp7H56dvzcY1Gb94D7nr2vjT386JyQXJDfo	1561	3	207	6301	9926	jwWx4AtLEG4sSypSdYnDYPivK6CAFHwiPdKruYsHm5Vn4PcXKkw	7051	9972	9972	1617734160000	orphaned
13734	3NKTKrgZnfxJ1bCzrXWEZBR4fkpZJXpHSHoBdKkug64aoKJnYDE4	13731	3NKn3KewJKh2Eo54TxztW6k6dKTWwH6yrWkWdkSeVmdX4Q6s2Qsk	1506	1127	207	6301	9939	jxc9yAmht3Sr2MhSGt13iTxvehKwgVcAcH1rwk6M5hRLT2mF1yG	7059	9980	9980	1617735600000	orphaned
13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	13737	3NKh77oR5BP5vpqxX8LFtBd8qm7cfGANecPptGdYioVJk18uHKkf	1523	1075	207	6301	9942	jxmYB51PLjCQBAgTTJFzvG5LWbKTi4MXaXaXXVT5BxU8NcNk2aR	7061	9982	9982	1617735960000	canonical
13741	3NLXX8uwyBM3MVAA79yyqWTAvtT3ehrT5CAFD24Y6GYjcFUbdso6	13739	3NK42oGNSZB9fMuV7ohVeQXm5L51K9m2EVdWYqC9dyPwf67LqbBi	1670	1156	208	6301	9943	jwBBnwkCmQbA7BAhWeMxdUynuMY2frGnYpS6NtMWcJJqGk8TC65	7062	9987	9987	1617736860000	canonical
13747	3NLxHT5vYVKrH46qyAPxccCfoN9MWxvktEwpEWhKTUH7H1DtdMex	13741	3NLXX8uwyBM3MVAA79yyqWTAvtT3ehrT5CAFD24Y6GYjcFUbdso6	1637	816	208	6301	9947	jwjrRPCRjfv2GqymDEwt87cSAspAT8iLpqeY3Cn79wGHnLGUQh1	7063	9988	9988	1617737040000	orphaned
13748	3NK5MuZvQBvs3LJ4UCKqh1qVR3sxZLnhtNdAf8qLjKiGY9tdPp15	13746	3NLokfmEFrqEyH4wHWMY6nuoF8rS2fGbpuxtVtYBMBezuuumtjfC	1460	664	208	6301	9948	jx5kVzg3efjCPGrBmByEhu57536ztEaanWdB4NJcECuSPfVi8mi	7064	9990	9990	1617737400000	orphaned
13754	3NLZLk4q96sgPwvXYiBBaMVYjs4i9AxrxS71H1CMk47SLC3sx6J5	13752	3NL5YmA9hZqgo9yWoAj4BoWgMRY4rcVmfB4sn8rJfAWG7pTLpxio	1581	778	208	6301	9954	jwG41PSAiXQyP1bRNTSjNq8Ah2pcG1Ppe7jEvVhqMUUy5bJUs54	7067	9994	9994	1617738120000	orphaned
13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	13753	3NLPsM4spYfT68mUQPqHptKbKsX3dSqKYYT951hepQ2MMQyLP12X	1648	918	208	6301	9955	jxDPVxRcGyXCCzUXVjG7gPaoZ4dE3Eaob7rcRTGUX8gVDwARcXk	7068	9995	9995	1617738300000	canonical
13760	3NKKZg8R9dKhTFetnxPYa3xdawaGAAmUs8SM9Rw2gNTNBJj96i8F	13755	3NLisgx6jQ2e6kp9sWwucfh7c9faJDzHatbsJmC6mAUYr6Uzpk2Z	1560	279	208	6301	9959	jxJvVfZMApYcdrxPk2eZYAMtH2XiSJ5iUeJczBT7wLy2sXNJnp9	7069	9997	9997	1617738660000	orphaned
13762	3NKYdFxyjPKeHBMgL2QwCZsT9NZAp3quW42N1XWo76KrZ8Z5Cibr	13757	3NLaGgW4wRWsgitBmJjzK9ygPYQ6k21hJs5L9BWd6eSrXf7YY4er	114	114	208	6301	9960	jwdTxVACHYZ2NAhwJcm9wWYyyci6NdwpvvX2Avz2GFcvnskE8YM	7070	9998	9998	1617738840000	canonical
13764	3NLmZ96KdqR8EBbPbKNBynxp9kajjNas9WB5LBavjtnDMD6nmLaf	13762	3NKYdFxyjPKeHBMgL2QwCZsT9NZAp3quW42N1XWo76KrZ8Z5Cibr	1405	867	208	6301	9962	jwdWNkPSNTrmJf2faVTKBaArPNLFX6s9USzP98QGQfymKZsboAr	7071	9999	9999	1617739020000	canonical
13763	3NLxY5Ah8ZEzY7Rn7vkBgsdLKZfQcmZxNvGD7Jigadhp7N5Pm5jr	13762	3NKYdFxyjPKeHBMgL2QwCZsT9NZAp3quW42N1XWo76KrZ8Z5Cibr	1546	1339	208	6301	9961	jxSYTawdQcKZrcMErNUno6hcSGEazMTR536MZoxo3rnWTQwndJz	7071	9999	9999	1617739020000	orphaned
13765	3NL4pixUFZ4W9xEGHDT3Wpt6ZTMobqfAvg4qc2NfgyhP59g9oPHR	13764	3NLmZ96KdqR8EBbPbKNBynxp9kajjNas9WB5LBavjtnDMD6nmLaf	1467	1130	208	6301	9963	jwXyEnY4kPUE6WzRhRV1dh7oRcLe55nHL5ThFgndTS1uNzgM88M	7072	10000	10000	1617739200000	canonical
13768	3NKrhsCeWMdfN3eGn4ZSNPi9AUGvjSLoseAX9rrAKgy6LfzZsF4o	13767	3NKoFSEuHKVkMqKHPhCXQroMepeo6Dem5PjyAwvyFjG1Jw3qr6K6	1406	1393	208	6301	9966	jw7Pfz8Y8FYCjp4kysxuCpz7ba6dGgZhsENok8eRT6dBAbAZvUN	7074	10003	10003	1617739740000	canonical
13770	3NLm7Y9Dp8YoAMueJ3Y56CRuikU1SrQyLm4cGGTr1ZMrG6Q6DPYF	13768	3NKrhsCeWMdfN3eGn4ZSNPi9AUGvjSLoseAX9rrAKgy6LfzZsF4o	1649	1017	208	6301	9968	jxG3VhMtDfFiUaBzanDeLW3ZRY1VzJ4ZVUyCQG2CRXCjgpR3tVS	7075	10004	10004	1617739920000	orphaned
13773	3NKH35mGUrvcbLNnZjw7ToFeBZinsDiPX72nB7Gxe9waJHaVLbHr	13771	3NKDy8GbAEwPEQf4XRimCVLPkSwzP1LyGWbVwLAmp2bLNFiX8xBg	1406	1393	208	6301	9970	jxjR6qcrXzmULBjQ541VoxznSUybJC8uSNsf12ah2cqnHRBz3NY	7076	10005	10005	1617740100000	orphaned
13784	3NKRwZRY4Ln4hnkwrXm4FgUWwB2Nvxy5YBxLDn8KBHbRsu1BvLsL	13782	3NK9p8gUNjdE3EabXRCXU5yVHWh9tL63SoowFr8cJa6hubcVaM1g	1402	874	209	6301	9981	jwQC5yiZav4kvoTcNqE5prpu3zMGFv6pY9jRxh1yLkukhaTTmtT	7080	10012	10012	1617741360000	canonical
13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	13784	3NKRwZRY4Ln4hnkwrXm4FgUWwB2Nvxy5YBxLDn8KBHbRsu1BvLsL	1670	1282	209	6301	9982	jxcDK7FuLhw1AcH3ENzKDw2MVtH1FtVZsWooV7vF2kihcGmuYgM	7081	10013	10013	1617741540000	canonical
13787	3NLkaXbvVMPVgs1V8JpSEXqfhPpowAaQp5mrDXj5xb7BJqs29rZm	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1646	1108	209	6301	9984	jxwZD5zJzbvWbLNMBt6oHiYD7ULV79Ns44f1xzbxNqHAnciAUQ7	7082	10015	10015	1617741900000	orphaned
13791	3NL2hbVS3jbkAzwAXdG1aBoH1CvyjpXBNJB93ZubnkuyCRyYzBJL	13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	1534	1317	209	6301	9987	jwZuLCXUXhGTAggAJ3d7KmEJ9pE4Zhun52Qvfts7GyqTGPMBdaN	7083	10016	10016	1617742080000	orphaned
13793	3NKHeKX2oLqkLekx4GhDwuke9MNobExocRck5qrYguy77mUDx8NT	13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	1583	286	209	6301	9989	jw9nNdwkDQ2brqK2PMapvqcwvgx821u23H7pYtDpahCGHiyGMuJ	7084	10017	10017	1617742260000	orphaned
13796	3NKx29ynZuMmEFPUDaXPeZCXQZGfzp1GZkmYpaJ84sFViLGkoXKA	13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	684	1106	209	6301	9991	jwrQ7PXqJ1AQPJkPxHv8ZvStaZMiziv9bpjM9hQvBvGKiN2pgzE	7085	10018	10018	1617742440000	canonical
13798	3NLTaSoCFiman6fod6PEFPtedjunFCZ7RG9fq8DVA8yyHjx9Xbj4	13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	684	1106	209	6301	9991	jxvzVCc71Nxk2S3EttWcGsSexCW3oAQcrRsipFpQXKW3wRc2AGb	7085	10018	10018	1617742440000	orphaned
13801	3NLA4qkQDgrC1NsHa7PSzqUBKeZ7iXosxaimqyEoQ8sjRE9JTpEq	13799	3NKqYDt3aMDkjXKiVhKoiEyCgywEy1jPLX2fgvAQvFUaSuyYovqy	1407	1395	209	6301	9995	jwFDMbSGTe3ctLSmEup3rQzMHSamZqct94MuRjT1Qu5PWztzNu8	7087	10021	10021	1617742980000	canonical
15472	3NKyyXd9oGfUTjAFiEWNrV67L748fJxo7rhuWDQnNs6VZdy2kJW4	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1527	1047	248	6301	11506	jxXJRdePAeJkanyZUQWFcRvsr7T58nWCrWtBnrcAuHkoYGrMLTL	7879	11142	11142	1617944760000	canonical
20709	3NLpmYuhCdiXoXBF8McibS6eAiK1sAtwb1Gz3HcL7nNJ6hkDXHvi	20175	3NKwKJWyLKmvhyJ6S6ssZKveYDND1SZN8bbh6mspSpjC9SQf3ZEp	1480	659	361	12463	13008	jxqhzCGCd8PXddbQ7jqbRHjZjU9RCcwfFuV9eTGko7Y69PvSBYQ	10160	14679	14679	1618581479098	orphaned
13783	3NL4yA3XVxxpRCSyW1JPnDhAaFYYyt1uvhZLvSww2RGUNb5PxNkR	13782	3NK9p8gUNjdE3EabXRCXU5yVHWh9tL63SoowFr8cJa6hubcVaM1g	684	1226	209	6301	9980	jxT6yoJgvHAH5uuaoMnyg99sHebcYTwbfHCsZE21XNRPFLfsBHs	7080	10012	10012	1617741360000	orphaned
13786	3NLGnjSrQYgcEXrTHaQiqUyJGNcH6Y1SPH5CyJKNk2Lf8yMWguWn	13785	3NLL5zArb5BN3vnKhLZiLcN8y754rGn935uoU18kwmbUq5eBfxAT	1483	1030	209	6301	9983	jxNRAugU1EnqM1ySZXvRgY9qHa2LLqSDukmPxyUAGcV9xvNQtCV	7082	10015	10015	1617741900000	orphaned
13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	1440	1011	209	6301	9988	jxDsq519CfWbMtqN7c9ybfckZfUD3qigPcqvzDDR3oKcjfsdkGW	7083	10016	10016	1617742080000	canonical
13790	3NKuhxAKqWa9j5gyTCN7yvdk8J8jRNBVQRs22k4FigHBiH7jLHA4	13789	3NLq2KKMGa3zZekZ2d4qh6rSJxxSNUt5u8x4iKMnojTM4m5CscLS	1534	1317	209	6301	9987	jwMR8RMeg8DfyDemvgR7aqV3xA7PK5uz11Xb9DqPq63aF347JCF	7083	10016	10016	1617742080000	orphaned
13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	13792	3NK7dXEXeRVhpCaxL7cBGy1UMdy3u58xoqVFm3FGVoh2B5bPoNv4	1559	1353	209	6301	9990	jxtQ9cy8m9GmAPJV3LszvWPRKkeA6qUuf6MTS6uyZSp6mooCJBS	7084	10017	10017	1617742260000	canonical
13797	3NKpvB5j7qTUWaNRSfr6hySPkHXfXmg595viwf2kgveMdt84xZhy	13795	3NK8xEVhhv2bcFoe8msEXpAxna3HtMLeF5a2iwoahbm3KpuVRfsf	1402	808	209	6301	9992	jwwDrLZRSWrU8KDQvUCAsSgjr3oYanNDM8PPLgLGvDrfks423Nk	7085	10018	10018	1617742440000	orphaned
13799	3NKqYDt3aMDkjXKiVhKoiEyCgywEy1jPLX2fgvAQvFUaSuyYovqy	13796	3NKx29ynZuMmEFPUDaXPeZCXQZGfzp1GZkmYpaJ84sFViLGkoXKA	1406	1393	209	6301	9993	jxYu4fhbh8qbWHbyJz4eqrkRTE9i75KTswAQZM5P5RceSr3iECb	7086	10019	10019	1617742620000	canonical
13803	3NK8bZnDbXqhaCVXPwQ961193SDVrV48fUzkjuJhFU9tnNf4BJUB	13801	3NLA4qkQDgrC1NsHa7PSzqUBKeZ7iXosxaimqyEoQ8sjRE9JTpEq	1668	1004	209	6301	9997	jwaySP4pLubyxtUEF84ScSiqrYgpYycPstZH4X5rLfMEQGQ7ZUo	7088	10022	10022	1617743160000	canonical
13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	13803	3NK8bZnDbXqhaCVXPwQ961193SDVrV48fUzkjuJhFU9tnNf4BJUB	470	1309	209	6301	9998	jw9JVL9Lm6r9RV7YTpCUJb2YPe4ksUJ8WKUhGcaep2KK9DrpzjY	7089	10023	10023	1617743340000	canonical
13806	3NLuvZjtSLtoezVrNAMN6pQGYTrf8f7MwQ4EnSyht96csYr9bxhH	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1649	1383	209	6301	9999	jwB6mrYqFg9wmzo59yXBh8APPD1BBcPCuEjNwfHankJefdj33gC	7090	10025	10025	1617743700000	orphaned
13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	13808	3NKPaXWJ1PYT9eMBFGHzJ3rsKQtbZgLDi5WAMUhY7dHpyBsXgKPe	149	1283	209	6301	10002	jwTFvMQAyNMr85JbYZ48HsJomL8f8BaErDokufUbgbp9cbWyo4x	7091	10026	10026	1617743880000	canonical
13811	3NLqJP36HvtN3sRfM4x816jf1nDtb6bLBZ1hWtQYpXbBU1itPV4M	13808	3NKPaXWJ1PYT9eMBFGHzJ3rsKQtbZgLDi5WAMUhY7dHpyBsXgKPe	1633	1390	209	6301	10003	jxyHgtPB1Fdgh1QWnxTyUkfpvp4uN673X8kTNQU6iwRfxNSiNSe	7091	10026	10026	1617743880000	orphaned
13812	3NL7fHXV7PYZuZK5ghuAqwqTsKuzbR6Bshcdi6JUCcZ2bFJA9C14	13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	1402	810	209	6301	10004	jxuXxbkLxG1SCmn2GERftxhffc9nH1tBnGPqj4NWsuyK4YjRxzY	7092	10028	10028	1617744240000	canonical
13813	3NLb8yNgADmdGLWUhdHnHmHyVH3F9Pj4xNri7c1qFogRAcLT56TR	13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	1490	1028	209	6301	10005	jwC7kBFQmZYZ9Lk4HKRqDg8dmgnoFdFRVNEVMJW8L7QqwZsJ7tp	7092	10028	10028	1617744240000	orphaned
13814	3NL2TEicM9DunXPDBqDBxnU5JCDnxk3zP5pPy2wQ6vRPv8h8SApT	13810	3NLJdWGNQibZA9pGNHSHusfnZjCrbGJPbpyLUrLSRPhGm8uTj7yR	1490	1028	209	6301	10005	jxCHBWz38599M9rTG4QoY9ZHLxenu7RGQnCjKTEBC21VUWjFidZ	7092	10028	10028	1617744240000	orphaned
13815	3NKrof7hLNfXNG1F9LFrhgLjpS2Mhp46f5TuzTVudMuUAKkjZUnp	13812	3NL7fHXV7PYZuZK5ghuAqwqTsKuzbR6Bshcdi6JUCcZ2bFJA9C14	1590	934	209	6301	10006	jxwP78vrfrCfYEGe6gCwWdAzhETN68hnA5VEGqsFdK4hqFVKeCs	7093	10029	10029	1617744420000	canonical
13816	3NKyAyNDnUkdwGChNiCm8FHzRrDEVB35dRyxYamKQQzJsVEwXGBn	13812	3NL7fHXV7PYZuZK5ghuAqwqTsKuzbR6Bshcdi6JUCcZ2bFJA9C14	1403	824	209	6301	10007	jwie7KnkxtxQLpPufp4Qik2ATSK5vzkMozw88By3nW8G4RZZVB3	7093	10032	10032	1617744960000	orphaned
13818	3NKygvNTvFoxScgEkKBfQ13TTHeWsTNJWekPYgwQEbPUCLH7YiNS	13815	3NKrof7hLNfXNG1F9LFrhgLjpS2Mhp46f5TuzTVudMuUAKkjZUnp	1440	1251	210	6301	10009	jwKtvzcmqq4zN2n7xc1cYMvZkzLP3ijxza2awwMRUsvG95GtJGJ	7094	10033	10033	1617745140000	orphaned
13821	3NLH6knF3NoAQqnvGnD4Yka337cZFDEA9MrTdz4T9pndcFMsmyFG	13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	1549	1362	210	6301	10012	jwyPHd3VSTGd13e39DA549vvz37v5TRs4nAstFxi2pKWTcFrEez	7096	10035	10035	1617745500000	orphaned
13820	3NL49QwRB8d7pRh4xU9JfEcYFQBA4MCZSYVmuqziQ15bWGrqqJgx	13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	1402	796	210	6301	10011	jxPsrJc8yWCik9yhCicmMLB9n1kn5cNae9sJygAYbCZeuaLDK2B	7096	10035	10035	1617745500000	orphaned
13823	3NLAYkZHb6Ja9Bt8TFAm4RGjfiEtUhQH6UwfZ2jd1jmy2emyhANS	13822	3NKTz821KDRsZm3Pkw67fTBWNdr9d82qAQkhJjMnwzoTFg7YDZuX	1419	814	210	6301	10014	jwhWKnct67jia3HRa4b8NsHLJn5uBemPNmLkAQgHdadsVfgYHRm	7097	10037	10037	1617745860000	canonical
13826	3NLLewAfgDEKeyswB5tLuPdZh6RowMHPo9n7HWKbwstyZCMAjKXC	13823	3NLAYkZHb6Ja9Bt8TFAm4RGjfiEtUhQH6UwfZ2jd1jmy2emyhANS	563	993	210	6301	10017	jxncfs7xWb8aE7BuVK3gqaLFosJRwE5fBBV4cKyoKn47mYRoK32	7098	10040	10040	1617746400000	canonical
13824	3NKBdHYRz6Kmp3KAhWLF2dxKNACyQiBcRWMMjnGhLXuhmcSq3D2W	13823	3NLAYkZHb6Ja9Bt8TFAm4RGjfiEtUhQH6UwfZ2jd1jmy2emyhANS	1406	1393	210	6301	10015	jwFiq6Eybe52tG35R63PatnGmzi2ucFXF2hRwJu9ZgW9uwjTVTa	7098	10040	10040	1617746400000	orphaned
13827	3NK52oXcjBFLcXHMyLMZMcJaczjUc8ak3hx4QzWRB4XnyB8EegeB	13826	3NLLewAfgDEKeyswB5tLuPdZh6RowMHPo9n7HWKbwstyZCMAjKXC	1553	776	210	6301	10018	jwwaGc8tGvc2CW9bSkz8dHwuApQSziegycDVZJLPJW7Z18U4yer	7099	10044	10044	1617747120000	canonical
13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	13831	3NL7dnPBiTtFMnxK5tbSw3epAu8cNuWvj8t7drThRsuBPQkiu268	470	1063	210	6301	10022	jwFeyjBdrxqzMqZ2WxfX1fipvkGH7Q6yJzbVCpaXPhWZMLBn9fp	7102	10051	10051	1617748380000	canonical
13836	3NKCFAoTMuxpvhdaCUsv5rnEf5oyjhzKFZwW4hFTbM6Loo56KEyF	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	1474	1329	210	6301	10026	jxm6Hh3iWubvQUPWXBm1oj3UsRVRbMwZSDWZxd3jTH3tayymr6C	7103	10052	10052	1617748560000	canonical
13834	3NKLYc9zbM7NFscYMiafrGZKa45WWGHE8C4vphzaGvRfkSenaqpu	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	1397	699	210	6301	10024	jxYpxb6Mc9m6vZG9jmc2hfCkcsRTXECTZn6b6L4LzQnMF8kPuf8	7103	10052	10052	1617748560000	orphaned
13841	3NLtidEugpULcMTf1x46t5wtiugyPZRJ1GguAxhcezd6chatHQYV	13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	1605	305	210	6301	10030	jxjrJrQegurnCHoBtwb9NxDQsYgRA3XkhE1qSN7EKhgC4F91PB8	7105	10056	10056	1617749280000	orphaned
13846	3NKLYZvJqttJoToH4HVK8jv1Krjomr8YAfEVjJFh2Yx1xi8kqB9r	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1581	778	211	6301	10033	jxnEUMkygwNok5q9jwtQGKtnoUD3VHYJwK4u3tuHztBriZjuDmc	7106	10060	10060	1617750000000	orphaned
20236	3NKtbdN92Qd2WfuUw6UTv3wqzSH8sUeEspXYqnjQudb1buwigACK	20212	3NKb3rkwPYvxXkRM9baXeJGM46W14dpr4SHdPNeE52L1cyUHbzYF	1439	1033	362	12463	12577	jxjowtTtY4gh1W2SRosn33dkDHwSdxNMZmbfXTJoFZEe6gsyXMp	10165	14369	14369	1618525620000	orphaned
22134	3NLXot8YVQC967AtxomkmQs45r75whQM3XF5AToxYSBnE4CQrnPW	22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	1523	1321	407	12463	14267	jwpG9XXVeqWdm8XsHay2GhjyhypKRS8FrEeLpeXTL1RUgSRatwH	11071	15587	15587	1618744860000	canonical
13825	3NK8wimMm8E8b4UcaZPegZmfjLPZTc6sNJB5vxH4CP79qap1V9Qt	13773	3NKH35mGUrvcbLNnZjw7ToFeBZinsDiPX72nB7Gxe9waJHaVLbHr	563	993	208	6301	10016	jw6x5kq2nAL2yBHC8wQz9FtkRuFkK3DMvPACVJoa8jwbZQqJxB1	7077	10040	10040	1617746400000	orphaned
13837	3NKa5i2fYijJgdjPNXbGnMenYi27kDqHevR7v6jiGvGZ6Z6X6vay	13825	3NK8wimMm8E8b4UcaZPegZmfjLPZTc6sNJB5vxH4CP79qap1V9Qt	563	1113	209	6301	10027	jxSh66XzVH5ddZGoN3LfrbWSHPC6nQuURZWSfXXYGSz3jqEJHXk	7078	10052	10052	1617748560000	orphaned
13802	3NLMrSFf5dgroM69to6jcQCkUrzv83DADGgLP7yDsfna6heBpdkf	13801	3NLA4qkQDgrC1NsHa7PSzqUBKeZ7iXosxaimqyEoQ8sjRE9JTpEq	1407	1395	209	6301	9996	jwAZVvTVZzzGFKd5wgdyxLXJJzMCCS7MieZdcbDnY2T5vpcaxtQ	7088	10022	10022	1617743160000	orphaned
13805	3NL1EKe48gequYecqs7uP1WzrvLhr9ZwVdTZ3wZ92feeeT5k5BJR	13803	3NK8bZnDbXqhaCVXPwQ961193SDVrV48fUzkjuJhFU9tnNf4BJUB	470	1309	209	6301	9998	jww9LDMuL96ZjZqUshNu8hUEQwv8qDSzveb1qLbBQgFVTcJsPPB	7089	10023	10023	1617743340000	orphaned
13808	3NKPaXWJ1PYT9eMBFGHzJ3rsKQtbZgLDi5WAMUhY7dHpyBsXgKPe	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1673	1002	209	6301	10000	jxWxRYAz8nH5veRs5SjsA85Qgu3zWNY1xsaC3NnLEo77n1kVbiy	7090	10025	10025	1617743700000	canonical
13809	3NKwQRQVtu1qbAGKJ1TDnATE2HX5hUf7WJZA1PYYYziVyPoJCZBr	13804	3NLFCUvFQjDMXzvvYMsCkD6aGqUjWPjPuTHAbJYrVQwVd9ei81fP	1439	1033	209	6301	10001	jwqQsw3KWabCVhtMxKYUYCTFKAtEP7dj4utYSyh2SgGNdaJFnYL	7090	10025	10025	1617743700000	orphaned
13817	3NKHLoGjRVP14CNL1Agrgpy4RoHNshGxJebeXMAvjTNheas2EweE	13815	3NKrof7hLNfXNG1F9LFrhgLjpS2Mhp46f5TuzTVudMuUAKkjZUnp	1673	1368	210	6301	10008	jy1aH5cQXVyFYZqmVshTNpbK2pAp9KweQY1rohzXigev6Ewr1Wb	7094	10033	10033	1617745140000	canonical
13819	3NKDVrey4eMGuU5AgmZJ3EaahBjLhdfBsWWG3XtG1CBiDKY3TWBS	13817	3NKHLoGjRVP14CNL1Agrgpy4RoHNshGxJebeXMAvjTNheas2EweE	1406	1393	210	6301	10010	jxsBkzU4qSDGguxoD8XynTu2cPpXUsddZAxB8mob3Tre9QsvAw9	7095	10034	10034	1617745320000	canonical
13828	3NL87MZxdRT2oFYazDFcncRTis9iQMJHFtKjQtYLkWyXwp8XNtyB	13827	3NK52oXcjBFLcXHMyLMZMcJaczjUc8ak3hx4QzWRB4XnyB8EegeB	1406	1393	210	6301	10019	jxdew61YGX6LpsHqWLAaw4ppPPkT6GbMuZzDMbcntsKVR4CNATP	7100	10045	10045	1617747300000	canonical
13831	3NL7dnPBiTtFMnxK5tbSw3epAu8cNuWvj8t7drThRsuBPQkiu268	13828	3NL87MZxdRT2oFYazDFcncRTis9iQMJHFtKjQtYLkWyXwp8XNtyB	1651	935	210	6301	10021	jxEN4FCkw9h6SfJe8nYvLtEodSf8cZBqzAZd96pQyWgE2hvyfpT	7101	10050	10050	1617748200000	canonical
13830	3NKAvW3oUFj6S3usWKzbkV6zS1bLeYJkHW2wsuWxqZxgdQC1ad2Q	13828	3NL87MZxdRT2oFYazDFcncRTis9iQMJHFtKjQtYLkWyXwp8XNtyB	1651	935	210	6301	10021	jw9vEmtAZCo3rwnfr8D7UMXzYQE3exncYAoybNWUy7jDfmZmWc4	7101	10050	10050	1617748200000	orphaned
13838	3NKiZ3pghUUHRsT2p7zXkKaWewgaGk2XBUpKtMJqmZ27CwvAEFBe	13831	3NL7dnPBiTtFMnxK5tbSw3epAu8cNuWvj8t7drThRsuBPQkiu268	1474	1329	210	6301	10028	jxcBzbr9YhitHnUKHVyYHvvehTJPYfEk4TP2TqLz365i3gpiawc	7102	10052	10052	1617748560000	orphaned
13833	3NKu9pRAhjGedbjDETxJThkyytLjJPWWD2Mipq5K2iNX8JheiMx6	13832	3NKfh6qjvdS98CiVHX43pQi3LVr2Tk91bxzs9oRTDAEo3BS3LuhF	1589	1286	210	6301	10023	jxyhuuytXWsXojxMJ7Mg11NnMENG1J2sDMEJ7bx4KHiAANozRpW	7103	10052	10052	1617748560000	orphaned
13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	13836	3NKCFAoTMuxpvhdaCUsv5rnEf5oyjhzKFZwW4hFTbM6Loo56KEyF	1581	777	210	6301	10029	jw8vj26QV4VCN6b7tkhc1poJcW14o59wCFstKnKpRvhKQpYE7cM	7104	10054	10054	1617748920000	canonical
13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	1605	305	210	6301	10030	jxjrJrQegurnCHoBtwb9NxDQsYgRA3XkhE1qSN7EKhgC4F91PB8	7105	10056	10056	1617749280000	canonical
13842	3NLE2s23rJFnEQrPw163tfyivBh4txguofMNrux6f6Av64HA7cNp	13839	3NK3DtCBxnbekmiCG66zHvry9vccnKqfQ1H53SaCNQe1tfXuPQ2T	1605	305	210	6301	10030	jxjrJrQegurnCHoBtwb9NxDQsYgRA3XkhE1qSN7EKhgC4F91PB8	7105	10056	10056	1617749280000	orphaned
13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1403	31	211	6301	10032	jxeye3jAnMBt1Tk9aZneZz2cjGcCXcjwBFWHqQc49GA6MRLqG2w	7106	10060	10060	1617750000000	canonical
13843	3NLuo8EShtnRaZHtsGCU1GFCgdJTiAfCiKyjF998TWGP6Ravfp7K	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1560	1291	211	6301	10031	jxzw8EL1MJGLd667zcxU9ApSCs5qadtvp5iWwaBWc4GNLw364kv	7106	10060	10060	1617750000000	orphaned
13845	3NL1QbPdXSdtPsxGRshKFSAfGYYBy9FyrC6TFY1mBHmddkptSJaH	13840	3NLWReFB92gu3sQNZzXFcjYXndAR7GGrT5EhYLghd6zDpGp8QU8A	1560	1291	211	6301	10031	jwD2v3GnHdCMziBMX5RFxSGdL8Jsw2PedpPCULnHtEMWoh6HvMF	7106	10060	10060	1617750000000	orphaned
13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	1406	1393	211	6301	10034	jxGV1GfrUrbh2azRxnzByzFFNmzaY5pM3LhMRJDGZaeahuhFV7o	7107	10061	10061	1617750180000	canonical
13848	3NKhLQzL5PPckf53kKoW8uTo1N23K1YA5GMRrgDsuDZE1UFVfv1K	13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	1513	1253	211	6301	10035	jxzTiujy1vBjGdSSXK9YJFAsku6iRvH9rpkFC2C6tmN12hoePc8	7107	10061	10061	1617750180000	orphaned
13849	3NL15N13U4crz925yCyz4m2uHznDiYcMeV3RfcC8nYufvdxSLeFJ	13844	3NKN9fSAGXfx9UnvSGbXdXTcpyFWiNb4ziVbuB6GXojmRq3Po22Y	1405	851	211	6301	10036	jx38kHH9Cd2d8AMwQdqTje18aifC7qAACpoeRpwtL299QWbJNbt	7107	10061	10061	1617750180000	orphaned
13850	3NLAR1C2131pvSPBWtbzTPXFqtCh6fs4sDW5tPFzD7mY4SawUEr8	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1458	1077	211	6301	10037	jwhCXdF2pCecGoLqrUWhUmxF8NMZ6NEHEWJQDe8ZcmGPsxN6Uks	7108	10062	10062	1617750360000	canonical
13851	3NKeSAFRM9fFQcurSAe9tRKwCUHAhZQLQVNyWHUNPbuCm5TJyaF3	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1483	910	211	6301	10038	jx3wpkin5G6JhrA97AFyiQbabmkCQqZ2afyznDgXbWXxvckHsLA	7108	10062	10062	1617750360000	orphaned
13852	3NLkVgRgJv2fDAcyHP21jPYfuBWXQjL9TZz2nosZC4zoBSyDkviq	13847	3NKSN4cVQfBFfuAKHJFZyFysPy5GC38jTHSpDo5TtWcxuQmncfzx	1458	1077	211	6301	10037	jwwyMDVjew92YvPGwD6jVwvLRtVGWzuPHtjNcYgpKn2YVJmy6ca	7108	10062	10062	1617750360000	orphaned
13855	3NKjDPGMjZpRG4wAYgEAgykYMgA8hFUh1oWcmA7Kwjznyj9G71CW	13850	3NLAR1C2131pvSPBWtbzTPXFqtCh6fs4sDW5tPFzD7mY4SawUEr8	1631	794	211	6301	10040	jwbejb7Jt3GMjZbK3cfXoQJecYqusjV9t1h5CC7vapQTu54dNcf	7109	10063	10063	1617750540000	canonical
13854	3NKrpLY5jRyR5TCrDyFGHruUYwSnuGK4bQeCeseY7yiJ3avbs2YB	13850	3NLAR1C2131pvSPBWtbzTPXFqtCh6fs4sDW5tPFzD7mY4SawUEr8	1610	1068	211	6301	10039	jxAXUrezhGkNcBW2vxaEhgabweRQfEMEJ2LSL6DRn2Paf4zqL8G	7109	10063	10063	1617750540000	orphaned
13856	3NKcagfsAE5RrFZuvFuFhZiULe7M2Csy2utT2amCVKP1kyKdE7Qa	13855	3NKjDPGMjZpRG4wAYgEAgykYMgA8hFUh1oWcmA7Kwjznyj9G71CW	1407	1395	211	6301	10041	jw82E8cKBkidwVfdkqvLncLMzBiYD7CY1G4YqfbQf1qc6n69aSQ	7110	10065	10065	1617750900000	canonical
13857	3NKhk5Z9JXgbXE4DN5ib55KmqXvA2PbtFhTQFt1UdhPcdyWk12Kr	13856	3NKcagfsAE5RrFZuvFuFhZiULe7M2Csy2utT2amCVKP1kyKdE7Qa	1588	1146	211	6301	10042	jwvZ46Somw13thvZp9vLrM4CueUSQKPdBp7bmsdPP5pwupjFjdX	7111	10066	10066	1617751080000	canonical
13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	13857	3NKhk5Z9JXgbXE4DN5ib55KmqXvA2PbtFhTQFt1UdhPcdyWk12Kr	1407	1395	211	6301	10043	jwYSVRoYm1tGYdyiLpmabCNsbMiw5mFyutUy3HAcuLmAyEnSJp9	7112	10067	10067	1617751260000	canonical
13861	3NKGWXDHeb7kMv9trDoJyLFgHWYoTX9w4NbRHqhNMMPwmJXEmkbn	13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	1403	824	211	6301	10046	jxuY65AJSinwU6bijT28ZNRk5HadFpKe6b3RGf3fJTkBZeP43gw	7113	10068	10068	1617751440000	canonical
13859	3NLZxX9cexZ6ZU5dMmtuc6eyeKL7nPjm4Qwj3mQdvduSeY91vgc9	13858	3NLHsxNiXh7zt5AXi1moQKywfSGQPPS1sNSBPZvaoCZizWnhixH6	1402	874	211	6301	10044	jwvdXRg6EBwadG6bGS3hjp94ViNUkTvMuhKxTo77faKRCcfnSyG	7113	10068	10068	1617751440000	orphaned
13863	3NLjsBwYTbfXKm2fRwKud6LhbNFMVFMMfV2NHgnfkHAjLPAHGXxd	13861	3NKGWXDHeb7kMv9trDoJyLFgHWYoTX9w4NbRHqhNMMPwmJXEmkbn	1403	786	211	6301	10048	jwZxTf2mpbKpdHSRs9z5zFMGiEZv5peUtP1TRBK5BCD8UQ8wQhH	7114	10069	10069	1617751620000	canonical
13862	3NKnUY2gxesx4aVCFXnHoHoojPeLKq6z83wv9eUCGKXP236Y7dQR	13861	3NKGWXDHeb7kMv9trDoJyLFgHWYoTX9w4NbRHqhNMMPwmJXEmkbn	369	1066	211	6301	10047	jwvjuMrA8tUYUNwEgftViKzm3jCDa43Mpn4575V8ZdEGCv7hR2s	7114	10069	10069	1617751620000	orphaned
13864	3NK91UGpMapsu1kVaPANxGeZ54VFDumvMeNqZpf71mv7dDimrMCF	13863	3NLjsBwYTbfXKm2fRwKud6LhbNFMVFMMfV2NHgnfkHAjLPAHGXxd	1585	1366	211	6301	10049	jx7hy9GsqfQiRivPYXH7gAjeRPRmASJyMYc9hpbPEXdwnghqJwR	7115	10070	10070	1617751800000	canonical
13865	3NL5r7T8SUmreJ8zDRHZgtdVM9k9xeFP4UUeXFeg57HnQ2vw3PfG	13864	3NK91UGpMapsu1kVaPANxGeZ54VFDumvMeNqZpf71mv7dDimrMCF	1522	1076	211	6301	10050	jxYe2WSpWddBiVzhC95PFpgdzR331nnKYZq63ugLKuGisPQZ7gy	7116	10071	10071	1617751980000	canonical
13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	13865	3NL5r7T8SUmreJ8zDRHZgtdVM9k9xeFP4UUeXFeg57HnQ2vw3PfG	1407	1395	211	6301	10051	jxBDYi65k695ArQgFdsTNNyhjZ7JWWYwTByyvNMZrcBHzRyEpsA	7117	10073	10073	1617752340000	canonical
13869	3NLWaQfYK9dSaRbALhWcM5QPoCxYYEftRcigjQb4o35HiEN4niSF	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	1672	1285	211	6301	10053	jxgfMmPatgX4ZRkFd9fLtAGeCyHuegSr9GQE1sUCLiUDdnh5tdn	7118	10075	10075	1617752700000	canonical
13867	3NLvFgVhCb3m7U96NidjCYetunn9XPutHmNcUNfaUuDy5LBr3KUm	13866	3NKYHmpfqcahj9ia7KCsSdpxDoNLyEFjUZWZsCdyMYnZKCqxTcBn	1407	1395	211	6301	10052	jwVob6xx5jb7SomJ5cvXKwafiqs4iu8YMmNECcSTgX8PtiZKgAp	7118	10075	10075	1617752700000	orphaned
13872	3NLqMtQqfJzh2rGx5X9BEGtSQ9zgsBZUgCvxCSMPQW9bG62vmrPo	13869	3NLWaQfYK9dSaRbALhWcM5QPoCxYYEftRcigjQb4o35HiEN4niSF	1672	1285	211	6301	10055	jxg41GqhgFsaKupcn7rGSa3LgSXEB7CtnNP9f6DzcjNzesa18Sh	7119	10076	10076	1617752880000	canonical
13873	3NL8cqV2kMK3BSYJnGVjkqdKk9bj8vTePVFjpKH16rfCrP8A7o4Z	13872	3NLqMtQqfJzh2rGx5X9BEGtSQ9zgsBZUgCvxCSMPQW9bG62vmrPo	1631	794	211	6301	10056	jwyfydkRiLeNqPm7VxFUX5yFcZirNPMc6PswQGRPq9JaA88uoA8	7120	10078	10078	1617753240000	canonical
13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	13873	3NL8cqV2kMK3BSYJnGVjkqdKk9bj8vTePVFjpKH16rfCrP8A7o4Z	1631	794	211	6301	10058	jy31P5SvNowVVjRoVVTpXDHs4axFRM2hYfnhRnT7HoCNKMab2Vp	7121	10081	10081	1617753780000	canonical
13874	3NLjDL7vVje9fXbqnJpuhEMsDECKJjUxBf2so2R46XdhSAhLRRQA	13873	3NL8cqV2kMK3BSYJnGVjkqdKk9bj8vTePVFjpKH16rfCrP8A7o4Z	1481	790	211	6301	10057	jw7nkJ3HiqSrhXaUMozGDQZdrrbBjNnYd2ocwaiJaxdqtLyhffp	7121	10081	10081	1617753780000	orphaned
13876	3NKnysMq2h8aXtFuMYtjw3GACsCwdBkZsdYeNqf9oacPauP3wHK7	13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	1406	1393	212	6301	10059	jwWdUUL1dhh7R2RAFou7qahqjgLYXuaxBqLUqKJ36D5cTAxZpXu	7122	10083	10083	1617754140000	orphaned
13878	3NL9SWn6DsMYPAz5D1AgbTxFkEv9eMpD8KuNTkHgs4SGh5MxAo1x	13875	3NL9BXfCmobDnV7TpMCMdrZX5rF9PwrBG3N2Acch5ADkDMTKxr61	1656	1097	212	6301	10061	jwW6EJWC8TqthTjsx3S7LLY5gX4jFWqzutGw5B6uBGbrdo6SHET	7122	10083	10083	1617754140000	orphaned
13880	3NLjjT4krFu7emEL6zAMsVkUwTUap4XqFHd71BxWU82V3GVVZDDz	13874	3NLjDL7vVje9fXbqnJpuhEMsDECKJjUxBf2so2R46XdhSAhLRRQA	1477	1350	212	6301	10063	jxW89Ss6f4C1rhAkeYAWHg7vZbCgqobRzL789YcnXsASofXdwAD	7122	10083	10083	1617754140000	orphaned
13884	3NL5jVmqh18z2oEJtz7u43472HVkbedhjtxz4QDQ2yjwAH3TSBor	13883	3NKXqdL5VqJ7e6vPGudA6nUvoUBFLYNR7ULzrF5hmac13tYXK4GH	576	1229	212	6301	10067	jwf83YGdDCbeG7w3AdZCgVyWtBdBTcr27BHTMBvL3nacrHFhaXE	7124	10087	10087	1617754860000	canonical
13887	3NKsoEyw1jM3rVTvhjE5AQNQG5LjVLgNZMEsdsV9GddNy4M4u3T6	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	576	1109	212	6301	10070	jx1X9YPJytPECXWZ4yP7WCs9qB9tN8DWoZKMsJaX8JjbQgYG6ex	7126	10089	10089	1617755220000	orphaned
13891	3NLrMaLbBH4jYESqQ9HLKFgYkNmpg5fjALX8nRTtinZ1tgtrQh5b	13886	3NLYtPH9YFXRzSHcnGAsjBmz95FerXpthqj9GHs59qEGVPuXSppf	1403	824	212	6301	10073	jxWDNswBawmfDGTvDvWMUiZtLM1JXhSRj1XXXkCNb53JfTrW4SA	7127	10090	10090	1617755400000	canonical
13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1403	824	212	6301	10079	jwAnLFoByAAjrrL1S6yy9bS6hYpgA7Ffxs3p9wnhLQrhhp3AF4z	7129	10093	10093	1617755940000	canonical
13894	3NKNGFtzCa4wkT1pf5KSz6UWsXMVDMc5quqmqWbNnBAwC6VQi9rx	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1455	966	212	6301	10076	jwmRBMXFEEuwFN4Qk8AKzUzZTqQZT4xspBu8cA2EQBEgtEeTTiE	7129	10093	10093	1617755940000	orphaned
13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1460	666	212	6301	10081	jxpjRAGreZg75G8Jn56yhuK96XyBNnQ2wjXeqmLEc5fpCGiFc3D	7130	10098	10098	1617756840000	canonical
13905	3NK8yZxwDJEMjRiYk13DHkSJp9LS6C4GVYXm1sBQTXWBWKhQqEFn	13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	1631	794	212	6301	10085	jxRH1WfApzgbUjZD6svoGMMaM4GruiDELZ4cU6GFzZsJ4DQvdmE	7131	10099	10099	1617757020000	orphaned
13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	1444	1135	212	6301	10088	jwJVJPVkTdLrA7ysrDQbgbsC4rVcyExtBCgYBvTym8xU7sFqrHr	7133	10102	10102	1617757560000	canonical
13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	311	1307	212	6301	10089	jxxfj4i6c2sajRD4cyByAms6Mh3A2wwD3FXHjzRz7iZDJGRkRhM	7134	10103	10103	1617757740000	canonical
15475	3NKeHYoEJaJNiouVfnL28nwPoqANG3MsmxVzcSPtZQi24AdzvErF	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1527	1047	248	6301	11506	jxyCktdUgzSwDzpceYm18GZPNiomQmqVgUdYBdbHzBr5f3RW9M7	7879	11142	11142	1617944760000	orphaned
15486	3NLrBZQE2SGq7XGQzNSffT5TZe8wSL86kec2z6HShsqRJ232Km3y	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	58	1281	248	6301	11518	jxP49tSVCAH4DdcJSqLqPz78VBLp1d8RSknbFJvLYoR3Nb6FPo3	7879	11149	11149	1617946020000	orphaned
15702	3NLXGBvDXXTRNdfuaFgar74nfF3nHUArwQWqNUp5mmw2zM7oGPJu	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jwgw8DRF46Eti2prL7j81L84HeoaRH32rwsFzELGqpFnKf7AXCa	7985	11303	11303	1617973740000	orphaned
20215	3NKnc3M1K74qu1Zgp3vuaBZLxgzFhMzemNd1a3dMsKX2Cer5A9Cb	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1483	163	363	12463	12556	jwHB1r2AVPvmazdCiCFXXrwsZiHzoxeXBYbgZZNnBRTRh1QiidV	10181	14359	14359	1618523820000	orphaned
13886	3NLYtPH9YFXRzSHcnGAsjBmz95FerXpthqj9GHs59qEGVPuXSppf	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	1634	1331	212	6301	10069	jy1Cgs8joBMHdLeJ2dw4FoRDmx52cFBUNKrDyDFusHU3wm8N85X	7126	10089	10089	1617755220000	canonical
13888	3NLxQWkArakuaDeV5fNq3p78XAPLtpuUUDa695eUmAnpxnFSMCZo	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	1631	794	212	6301	10071	jxD1EK6Y4x8qbpNYmopN4sgo74rWPW3uHHgJnWngMPq8rW1HRZB	7126	10089	10089	1617755220000	orphaned
13915	3NLQc4BpZpa1y9P9JYqMn9AdkgRZ1pYhwB7qWXLnV7J6SBtHZTHH	13889	3NLGDF7SMVqy8LLpBefbaztNYKsWharGEXv7ehU3hV2MEoiaosMm	58	1155	212	6301	10093	jxrci6rnRwUPiw1h4RLVuu7yCyq7E1zMZ5aWk2pyCPKLaYnqUfh	7127	10104	10104	1617757920000	orphaned
13893	3NKQoP2SGzj1Gtfz3JV1vVT1riZCNLJmjMtb93SWoPMPQemj2fhp	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1672	1159	212	6301	10075	jxhxhYS3w5WzszvY7zZPiECppx9ML2bv42K4fFH5nvSYQXvceVp	7129	10093	10093	1617755940000	orphaned
13896	3NKpN468143CDPoBCntfU4ngjh5q8h6M9y3TaL22CoFvjvr5DqFr	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	1581	778	212	6301	10078	jxbM23Lte1G9T4HchoQtu16o17bPCqbJt9nhyNdpprmbWgJcrGd	7129	10093	10093	1617755940000	orphaned
13898	3NLT5MgoNbjaRWqd9w2bQNPsbeJrA4GHjWhLwfUKLscdSgR1u8ej	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1407	1395	212	6301	10080	jxxJDL7pbNWgRwLyHSCfg35wb7NF4J1eayFaXg9ivMw9GXQBn8p	7130	10098	10098	1617756840000	orphaned
13901	3NKqyS7rAarmj6ycf3HmrjP21TtHKTQvkp8TtEB18d6LN6HqeTHw	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1542	1058	212	6301	10082	jxrfDpUdMcHTSunYpdxkcEnnHhbtqNtMvNyezCCrJmbVc6EPbDJ	7130	10098	10098	1617756840000	orphaned
13907	3NL3QzRr2EghK47oSMgyBbSn26eGUGq1rNMXWqo6SfVZ7Etf2nPY	13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	1608	923	212	6301	10087	jxcdN6W48RwB8vVYjXi94Xi1SRhL8bJ2u7YdmdaNxrNnha3dCFk	7133	10102	10102	1617757560000	orphaned
13912	3NLNak4exA5wbXPXXmh8JcSMnaS9tF8rUjJLYPgqsya2NSUCz4i8	13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	311	1307	212	6301	10089	jxU4o777mScMBx7RPdy2ySLen6bviRvcC38rkeao5k5ScqkUohF	7134	10103	10103	1617757740000	orphaned
13921	3NLZ6FmUfQcdKgorqSg1uF2GcZjKUC4ePzY7Yg2QkUNAPi4kxB6V	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1523	1075	213	6301	10098	jwb3GMokrmcyaNXuRGZjtdhei9DbfT766PBHtiiAWs7sQJyNYM1	7138	10107	10107	1617758460000	orphaned
13925	3NL993dSFoe7WCFyFx5mu5ZWgXRDeZ1mN89zmefoHoKWLa1dAUV6	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1642	1121	213	6301	10100	jwFKmDXrqgfXoe9ss4ywM1iUVJrDPKT6Vyq2s18SYuY6M6R5bHW	7138	10107	10107	1617758460000	orphaned
13927	3NKe3R18sZFKFAHoU3d4jVR59AYgZmssZdYkKJay9a5KyDBUojKF	13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	632	1382	213	6301	10101	jxcYjtUzhMh1vzoXc5LCFgVyCurXjAXrQ5jnnYnhZx5D3SgPezr	7139	10108	10108	1617758640000	canonical
13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	13930	3NKxC9XAQypCv7KvDT7XQbeEfztkwNXcGkwuX3Z4p5NGpTB6FP53	149	1157	213	6301	10105	jxZrroidXKq1aH8mGznK2xbSzu5YVoU8fDezBRoDpiAz9LVXu33	7141	10112	10112	1617759360000	canonical
13938	3NL9gqoGHvfmiZZDEjBmWsunAhcuN5fhY5K9Nyo76VRwa9HATyWa	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1508	1387	213	6301	10107	jxXXocmEoRVU3iiY6R3eLFxYafbXh1cvKa4PrUrCG5yAznJACiz	7142	10113	10113	1617759540000	orphaned
13941	3NLTVYL5bmX3KNvULi8vkVa2zpnc8xu9VidQL88QYTAsitnUnuui	13936	3NKVtC6e9HDRcC1H8AegeanTcMsyzv5eiHkgg69MmfQewha9EFbh	1672	1285	213	6301	10112	jwLedmFwKqkx8d2sVDgLyTGwrugCytDWW2re9HpqeD4qQuPsEh8	7143	10114	10114	1617759720000	orphaned
13946	3NLZALhaXkvunU6q6PSHBH7AVbG8QGbezPLSBmf9kLy2teyQtFLf	13944	3NKHH9t6r3jFS8Z7VvJQ1auAXQGrZthz1fZEh9rgMW3jKJxSNAWg	1407	1395	213	6301	10117	jwJLEgXi2cxcTgdVhC4erQpTNSykJtCNwhYTgFAtnHmD9t2q2yb	7146	10117	10117	1617760260000	orphaned
13950	3NKi4GpwpPsRHTFZiYgVC2EbaLFiGn9Laxze9rz6Zap2GA4CbNVo	13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	44	1325	213	6301	10120	jxda2utxJEr6KZ17fqRuKGF4H8R3NvC5wZqu9RfravawcAL7Vh8	7149	10120	10120	1617760800000	orphaned
13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	13954	3NL2XdGzQFNMKoAwDMUyABUkMF7hqdnuc16CdUbezCP4Trx8MaVy	1631	794	213	6301	10124	jwFSxPd1HzhmbBV4iE57Fi6P1E3Vzm9AYcqoYggUCDmCCoHevnZ	7152	10124	10124	1617761520000	canonical
13964	3NLgdu99ZtcaY5j4HSy6B92ovMsjFA5GCXRmdni36npSTwHxzqmi	13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	1654	1340	214	6301	10132	jxqYgpLCHSog8NcVyKMoz9qrSZs2R3E4vrc5hVy6jyWcgTUiM7c	7156	10134	10134	1617763320000	orphaned
13966	3NLB4MYcLnX1CeZuXdTrTzXM97J6mdv9ZAxqSTf7ZY1UXMdEwedn	13962	3NKYGqncTiY4iPdFnBEBPzeqHL9SrUiTc1n9rqCTLieokwZJ5PUY	1607	1102	214	6301	10133	jxTTmHkDaoCY16TQ1PsHaeC2mKRYsQqwuvbpyE5CgTzXsi2iPq2	7157	10135	10135	1617763500000	orphaned
13971	3NKjK5Tnn7yN6CayVbkzwWHk3zwtDcEawbjAtSTFsgfh6h5yTwyE	13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	1419	814	214	6301	10137	jxSnrmQAZXgUR8Az1T6nYePh1ArN3djSiVvxdPNotpSx9F6r5FT	7159	10138	10138	1617764040000	orphaned
13973	3NLcXeA5mFgHidr8Tz4EqGoGVuFPpYC15LBG9Hkgfza27586TvBF	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	43	1064	214	6301	10138	jwzFvwaBoAPGLYTBGMfesamwvAFSksFyPSGL3SVNftdKYhM67oU	7160	10140	10140	1617764400000	orphaned
13976	3NLqQyxckHyMBbJwKEKbsXfJVQSda3RBohPFJ55obnkaySsAip49	13974	3NLiRCfX9X7e82w18CghLTWC2g6ZdBDkE4nfQkZyzXAi52iEsL8Q	1523	1195	214	6301	10141	jxf6FFGSnNwLNMB1tVrnyh8i8nxjWWHmXKfQj6AGxoPch7S8gc2	7161	10141	10141	1617764580000	orphaned
13978	3NLkm5VggrMgcPnDQb8BJzRTKsgjmDm6fykbVhabvREHXFmiBmbL	13975	3NLtDQXjGKFQmDbYPgJvHC1U15JRMXTzbwL2BpLD7JfJZ4aVATGT	1406	1393	214	6301	10142	jwpP5kzhKURAuFVYXHRYbcCMKLD9aGTrgsVAnoEs9nqb4yn1f7P	7162	10144	10144	1617765120000	orphaned
13981	3NLV9jM2VN7b7fkQXxLb9YfBPyKGvjtQHAZMXTssoQoEvadgSQYs	13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	1513	1379	214	6301	10145	jw7UWd4MHpAaN7UGtPuddsaYhjm9rgZE47WuvPPkseUp4yoEJQG	7163	10146	10146	1617765480000	canonical
13983	3NLu5eGPC9nNC6qvdFEBYMRAwgJ34w49FRsEUJVHFPo8Q1BckowZ	13981	3NLV9jM2VN7b7fkQXxLb9YfBPyKGvjtQHAZMXTssoQoEvadgSQYs	641	1210	214	6301	10147	jwjZNUo1xwFJuCWcoSNa3hyXLW5hFEE5uxiHYYotYDjsUxoAzUS	7164	10147	10147	1617765660000	canonical
13993	3NLo1nqwhZ8qP9PwkF3EarMRnV3Xc9oL75Bqw21KH7R5ChMUKx7e	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1506	1127	215	6301	10155	jxFLh4DghUfityAjF884yas3oNNvvmdYeBiZHPnYKPiafun1dBP	7169	10154	10154	1617766920000	canonical
13995	3NL9pqUJm9QmvpovjAocUDjnXnt2JXmXnNWFShBMxUcaum9Bz9bo	13993	3NLo1nqwhZ8qP9PwkF3EarMRnV3Xc9oL75Bqw21KH7R5ChMUKx7e	1403	824	215	6301	10157	jxdsrdiaRVUkZdoQNpdxeS49ebhDwEnQDPGa7hgFmDpxMEKeWJx	7170	10155	10155	1617767100000	orphaned
14003	3NKfcLCaxD75q7476hpFcSWyVt8maPVyNmw2AwDwFotkEj28Tuhz	14002	3NKU97f89fAapQ7qzkfTWmNJduBscyMRoGRtQ78JDjVihGzAn4T2	1637	816	215	6301	10165	jwu4rmuQCGQdnT7tF8twxGX3t34Hdtkzoj2y8Ws1kBFg8Fo4pWw	7175	10163	10163	1617768540000	canonical
20216	3NKb4qnmCngNSigNrJpMPxoRwyBH8ebkf7Qy1SZ1jGCk3259VL66	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1406	1393	363	12463	12557	jx3RQiW1o5ieoBWDrKi6QrxrQU3jTt5CeFhjm5gw7g4cwAZYTM1	10181	14359	14359	1618523820000	orphaned
13882	3NKoGkSEEpb6LCckwd2Lb3NLjFr1qQZ1FUASeU3dT2bPwNchuqH5	13880	3NLjjT4krFu7emEL6zAMsVkUwTUap4XqFHd71BxWU82V3GVVZDDz	1609	1333	212	6301	10065	jxSAvKiuAXmeMLm4ZeFtFqhBxpbWuEh2QeUsoS8Pxi9pEVvcqsg	7123	10085	10085	1617754500000	orphaned
13889	3NLGDF7SMVqy8LLpBefbaztNYKsWharGEXv7ehU3hV2MEoiaosMm	13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	1634	1331	212	6301	10069	jxo963j1UQW5JWntJJCu1WSpkZuUyNyaWNYkPszhMicLbjhJYmy	7126	10089	10089	1617755220000	orphaned
13895	3NKxWMkMMwquPYZSBKDjFQhX8UTQD4wr3fZ91U2tAvoJ6yBxn9A3	13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	684	1226	212	6301	10077	jwvNuc2mnpM3XEQP2pehPxXHn3zgd6qFDTX4w7JTjHQgUv6fvFd	7129	10093	10093	1617755940000	orphaned
13900	3NKhWaT1PEAEgUr8h7FhEiWYHfRLuQp3KRajwFcaDVMMrXDJywCe	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1460	666	212	6301	10081	jwrvhfNuJ7ahK4iKAFMq6gyYo6kSxrxeqhytt6wQj7VyNxYRxSZ	7130	10098	10098	1617756840000	orphaned
13911	3NLC97ZT7Shnj1jnyJAk2GCRXZYdESpi7BkB4zuHYU5NSUtQSt1K	13908	3NLX24oEpcLBLtnghGd6QfTpMfgiU6aTkBeMYGWNTq6RDjXwg1uW	1589	1160	212	6301	10090	jweQaSSAH6vAR8yZNAVGK24MpZLfAyJnTr9XAWYCA6i2MjjEaK9	7134	10103	10103	1617757740000	orphaned
13914	3NLiTJEm9oA7zLpUSWoEJVh81CuUi56UvuxT6godnBCGnfNKKRkf	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	1609	1333	212	6301	10092	jx6oD5gLp4uhkiryJ9qWEFNxH9fwnXJbCBMbKs1ZVqRv6GA54Np	7135	10104	10104	1617757920000	orphaned
13917	3NLXRkuri7NbcetZNbfs7mL9nhPuJq3q6MSLXura4NR9m4izfjgo	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	58	1155	212	6301	10094	jx22QwpaE92YPPgJ3WQ2wBFwji7yxXZgA2ZpS7bVG6MkPgLmzcw	7135	10104	10104	1617757920000	orphaned
13919	3NLnD4KWL1iMNMiJsJ5RzWdpWgMaj18EejgE7SutjXRvRGhucjd3	13913	3NKVdk8KgFUtB821J8ZJcrgxYYXAqcTBRhQfmeUJAJ9AXcmeyRk5	1623	839	212	6301	10096	jwwk1DyiRFz4MpKsiAeNcQLtgCJVXt3W6UdTQKYeBFc9byjQppX	7136	10105	10105	1617758100000	canonical
13918	3NLrEksXbrzvFeedRWT1bsqK6FMmLz9EC6ZtA8NkhJfx3m7EKHA5	13913	3NKVdk8KgFUtB821J8ZJcrgxYYXAqcTBRhQfmeUJAJ9AXcmeyRk5	1406	1393	212	6301	10095	jxWhZvHnE1Y96qLUprCmRypY9WtsShDX7NKqJ9k7i9LfNQ758oL	7136	10105	10105	1617758100000	orphaned
13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	13919	3NLnD4KWL1iMNMiJsJ5RzWdpWgMaj18EejgE7SutjXRvRGhucjd3	1406	1393	213	6301	10097	jxiRurKUv7PVEs1P1dpCF8zZzzG8PDjfXo82g7MkrevAZaRR4yD	7137	10106	10106	1617758280000	canonical
13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1523	1075	213	6301	10098	jwgNMgHXP4QTU5P3VznyiyaSJ1sEa5oYem5Tgdfdc7F864RVJec	7138	10107	10107	1617758460000	canonical
13924	3NLjzq1iwC3Gww6S1cENqtW9j9W1ATqTcQo5eLFg5DdeowUUx8Gj	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1523	1075	213	6301	10098	jwYJaH3uFjjeXbsmvQcrcahu2HADPEg8tL3kuJ96GTyB2N3uRHN	7138	10107	10107	1617758460000	orphaned
13928	3NLgzq4uG4HDUKqaqph66zFuCAj5KTcaCs9YPP3PYahyUSKovsQE	13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	1513	1253	213	6301	10102	jwHXeR3DpaEWHT4ViEigyQAGHNpnigSExU3CfzqB3N7qtZawi4N	7139	10108	10108	1617758640000	orphaned
13937	3NL7fsVkxJeFA7uwcxtrc5t6FuySx3NQttDw1M7EtSmLMnAU7BwL	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1578	930	213	6301	10109	jx8eVhxdzPks9TRDkHpKn9Fr7shHTEak6yXxuVPdAPkQ6ShwTgp	7142	10113	10113	1617759540000	orphaned
13943	3NKpwZpRPDN2VkRLeSJNfiwJk6SWAUc2yyLGvQhFsT8cKHrbwFHo	13940	3NL5iJHuZX8E3hsZCLAfxAXSJzpyz63BKEvaPXb68STefXJP9E55	1534	1071	213	6301	10114	jwhZvPQ8sZkZNq5t9mqMZhjoTC5rH4rc7qnRD6gqkuMNpzQ9nvB	7144	10115	10115	1617759900000	orphaned
13945	3NKHDoBDGhsbqHnc4Tct5iPYCpWNXx5DpmVGTUSeRZYbBK86LZXv	13944	3NKHH9t6r3jFS8Z7VvJQ1auAXQGrZthz1fZEh9rgMW3jKJxSNAWg	152	1330	213	6301	10116	jxJoiFpii7ASkBLXbenWhq9DWyHXaCo8bs13rP35rHHM1A69DAp	7146	10117	10117	1617760260000	canonical
13947	3NKp8iPH44NXRKWJyqPPi5A1ZhdG4pbqrnwtfikdwEFrNPB1n7Bc	13945	3NKHDoBDGhsbqHnc4Tct5iPYCpWNXx5DpmVGTUSeRZYbBK86LZXv	1670	916	213	6301	10118	jxoTM1R3AYpeZ8FcVxFvcx13nNAsCGoSafg4p4eACC9vKRVZ6nG	7147	10118	10118	1617760440000	orphaned
13954	3NL2XdGzQFNMKoAwDMUyABUkMF7hqdnuc16CdUbezCP4Trx8MaVy	13953	3NLSTSpm5VNBPn8kwsbYt93ABEF88H2HXQmbRq3b5E7FZjFiSp5L	1571	969	213	6301	10123	jx3FgpyBFrB6FRRtUE7hRfjWA41sRJAzRVad5E2WJJMKZd3yYA4	7151	10122	10122	1617761160000	canonical
13957	3NLHLJ5wgYumR5rqkjZYmWU2KSVjDttfg9BJpDGpYRGnH6XDuXHc	13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	1403	786	213	6301	10126	jxtVStZ2LwF75VZfbYdwbXYfe3JZhtCCfwaQkK1F7zcjYspHGjc	7153	10125	10125	1617761700000	canonical
13960	3NLrPghEp7qiyBckrkWnxhYJzAERzCAx3VLno4ovT3vySnkmniVQ	13957	3NLHLJ5wgYumR5rqkjZYmWU2KSVjDttfg9BJpDGpYRGnH6XDuXHc	1594	1326	213	6301	10129	jwcx9L4AEEDZBpssmmMiy1ewHRn7Yj7x4GwJdEkD5chHYVyhJMt	7154	10127	10127	1617762060000	canonical
13963	3NKHvLPT97PMGqhEepEe1DGiNG37RhUhaxZPG4A4PFweKt6dj6MT	13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	44	959	214	6301	10131	jwmdMLt7qHmBjh3rmFddZa1YKjp4h9dwom7t2bit1cNPmkAdFao	7156	10134	10134	1617763320000	orphaned
13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	13965	3NLJn8bDBSFfztZYdwz39Na2WzsVZWpV5ovL7PicfZGMWubLS7iy	44	1325	214	6301	10134	jwWv3jrCb9CFhC3Dx74Hm1iFFn3S8paUJsC412YoGkh9YuLCgHX	7158	10136	10136	1617763680000	canonical
13975	3NLtDQXjGKFQmDbYPgJvHC1U15JRMXTzbwL2BpLD7JfJZ4aVATGT	13972	3NKMbPTRKxp441vbQogp9Jqp7ktUxj5ouj4L63eZtEqXKPs6w6K4	1523	1195	214	6301	10140	jwFLtXd5ErFM4bySgsbd5Uax2kQqPt7X8ZR6UGQgTs2TqnSXQUS	7161	10141	10141	1617764580000	canonical
13980	3NKwEaA822ksueAhSwKBFHgW7c2zPWqHPu7rhpQoptmVTtGk1TDq	13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	1407	1395	214	6301	10144	jwBh9QRk8CkJAqXkCCUjSVc1eYFn1G7QBrucqsHA51T8UcwARvy	7163	10146	10146	1617765480000	orphaned
13985	3NLcncJXouBf6ChLWrygXCo5yU4pmvJBTRYtZpnafuSTihKJ8B2S	13983	3NLu5eGPC9nNC6qvdFEBYMRAwgJ34w49FRsEUJVHFPo8Q1BckowZ	58	1281	214	6301	10149	jwz48XebadPHeUECktm3wdECyBtrJDqd6B56gGN3TLfpcX1virn	7165	10149	10149	1617766020000	canonical
13988	3NLt9z5PQr3JKogoeGm3dFLGJXukfaadd2VwpdStoz5UNUQLV9yB	13986	3NLBNXcxz6yN6gJyf4Nw4GPMXeQSGTVkbY9xtrmVBfurrjzi5fxq	1672	1039	214	6301	10152	jwFjk4gXJvgkouoekopu4kWGCtvnAUjrbBubqGGiddweeT2fDoB	7167	10151	10151	1617766380000	canonical
13990	3NLCiVSaBGz1qNBM6VGz9Sn9WVBbBycNGSWhoRpYNNwysYJ2W7no	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1670	1036	214	6301	10154	jw9M1GprAXyqvdSwKXnG41JQixASPtSoMCDsdjeTcFdAHQeGxVr	7169	10154	10154	1617766920000	orphaned
13997	3NKuXob8VUEihNQP8xKYodg71TuV1vnwgC46jdPvQz8JyuFMDqPp	13994	3NKMuZGzXu1bnkSjGZyNZkyDNTHR9YWcUonEG54Wy34DFjSeSeCe	1581	778	215	6301	10159	jwxm9fg27kHvpNyznHqorxHQPoMkDMQRn4AsuGcW26jFgrVZZeA	7171	10157	10157	1617767460000	orphaned
13999	3NKdNBamjGaSiDVomVHkadzMJX74qJ7pNZQT9iiWSWwvuNGCYQpV	13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	1403	824	215	6301	10161	jwAN9tqoT1e8dXeUvAK6xnUb29PE5j4BAN79UbRd3Qj87oirRQh	7172	10158	10158	1617767640000	canonical
20218	3NKwS9f8busqwUfzDeyqLKPgmi8GmrJrwVz9uhmXpgtCH9xvJKjw	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1407	1395	363	12463	12559	jwMdSVdoRTTAeTb5Bq6bDCTQ8Hr4qmK9yEkuEBkYPVCXZ2V39NC	10181	14359	14359	1618523820000	orphaned
13885	3NKa8QwEe9JskBtoEq2ngH15a3hNktNgp6jYNwMYvr5QsuZcBoEg	13884	3NL5jVmqh18z2oEJtz7u43472HVkbedhjtxz4QDQ2yjwAH3TSBor	1631	794	212	6301	10068	jwp75Y1CzH4JUwczS7YVoVFgZnYUotLJSuA3c7bCRCQUayfx3FY	7125	10088	10088	1617755040000	canonical
13892	3NLWB6ddj6Hzp7Tm2tAL6aW2Bfj3t5opnpvCD8wTKbQUX4DSY9NJ	13891	3NLrMaLbBH4jYESqQ9HLKFgYkNmpg5fjALX8nRTtinZ1tgtrQh5b	1637	816	212	6301	10074	jwugFJBPGWkvGiRfiUGD75NRpuJVoiuo85QBBNGk8DB8doZhw2B	7128	10091	10091	1617755580000	canonical
13984	3NKvzzWYUzdiV5hwUgfz8SqVN3nqnRbnYGek8sJ9Xt5j8AWKneie	13915	3NLQc4BpZpa1y9P9JYqMn9AdkgRZ1pYhwB7qWXLnV7J6SBtHZTHH	58	1281	212	6301	10148	jwVhciLVppFsgYXusffQfdAMUmG99PtB4eWguh2ApUwWjHuPXmg	7128	10149	10149	1617766020000	orphaned
13902	3NLd3kyXXKTArHXpSjs2jXNnWPmKXh4q7LQA4o9cYXkkqUn2CUWN	13897	3NL9H8XG6foVVhSK511v9F3Emyfut2gH6zezr8TUCQ1FNHFT4j5J	1651	935	212	6301	10083	jxwzsE2AKARTHVsZnFeZWJhWyMUY723Cqu3pFbAnSj7MqSHcHci	7130	10098	10098	1617756840000	orphaned
13904	3NKFQZVdak3JoaiKgDXEC5cCHwpLNcyPcNtxwoDRpDH8ScvofKMJ	13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	1407	1395	212	6301	10084	jwrZFS856fvHAMh56aZtGz9Y3dFYXKg17XeCNTYQ3eydziZ3T4V	7131	10099	10099	1617757020000	canonical
13939	3NKDSjxjuEAfL7qvVU1JKRZEZz9NVAgCY9uMfPkHQCZPQwCeAfVr	13899	3NKy83LYW5NJhLiM8TYG6w6c6MWkS8KzSRjgTNKkUR1fTM3g7GFK	1590	1174	212	6301	10110	jxwDsvp7AX2WBfX13XtUaWiXgifpQcY2GjqD3gGUZW5CwNJf297	7131	10113	10113	1617759540000	orphaned
13906	3NKAsVi9RDsCUCm2xT7xXYnLdK36hYsLCQy9tkCkFmCBnCthepXZ	13904	3NKFQZVdak3JoaiKgDXEC5cCHwpLNcyPcNtxwoDRpDH8ScvofKMJ	1406	1393	212	6301	10086	jwh8XGBysxceoibDBRK12G2ReAWTqfLBiSeL5exFyNLcneSsTXD	7132	10100	10100	1617757200000	canonical
13913	3NKVdk8KgFUtB821J8ZJcrgxYYXAqcTBRhQfmeUJAJ9AXcmeyRk5	13910	3NLLcqU4Nd68Vy1aTr21oGcht5YyRD6tKkNx73VVpvMei53bEfKk	1405	843	212	6301	10091	jxDH31t9wJ4G7B7mYLjdd1ro1tS61VXPdyictrbFHqXAw52Lc8C	7135	10104	10104	1617757920000	canonical
13923	3NLCT6Hv7JFdkUZrsLUbdWjRqN4dF543zPJtSe7xM4rxnun4J4aa	13920	3NLarqXm8oUhsX5WqTnBaJSW56U1iS4oR4ouhiDCEGm2FggMjYkN	1619	909	213	6301	10099	jx5ZcuCJvftCXu9retQUrdGKZkfXTWKMmfvJtgG5fCPsjytvRGd	7138	10107	10107	1617758460000	orphaned
13929	3NLVbdM1juVw8FTqxTy9wP5x8Yq6PHyKQuCzd2yb58VAfT3JfC4E	13922	3NKApm4ESCFrX762rUt7bZhfroh3RyqQQUvuPC8GMrKBnTfeXfAr	632	1382	213	6301	10101	jxLkhEPn4pRXw7eLLwk1oFUAh7bT8MxYqJgtwQexjr3Et4zNj42	7139	10108	10108	1617758640000	orphaned
13930	3NKxC9XAQypCv7KvDT7XQbeEfztkwNXcGkwuX3Z4p5NGpTB6FP53	13927	3NKe3R18sZFKFAHoU3d4jVR59AYgZmssZdYkKJay9a5KyDBUojKF	1643	1053	213	6301	10103	jwbznnfvuTbB46FneR2EoRyZhHzDE8rMkE4mLkLbqaqpx19pUYx	7140	10109	10109	1617758820000	canonical
13935	3NKaRgrmrza35EEcNxqN2EAP22LimZVbJ4ZY87pXmBWDcXGoZNxe	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1508	1387	213	6301	10107	jxxeYbksqyn6AEXj2o8rHzSLCi2jMrTt7o8avWRw2mJUZizF6uc	7142	10113	10113	1617759540000	canonical
13933	3NKgyu4H4NtpiHkzF8pEsZLwYAdh4gyJv2chdxkB5w6yCn8hMfk3	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1588	1392	213	6301	10106	jxXQjW7qBsVA5b7o2J4xNY64Ggj8Rjqfou8RBxHAUTaBXVo1PR8	7142	10113	10113	1617759540000	orphaned
13948	3NLpXdAdbhnaU3VbUCthxuPehF2GupMkhdTubRK7bJhyt3iw8Ft7	13945	3NKHDoBDGhsbqHnc4Tct5iPYCpWNXx5DpmVGTUSeRZYbBK86LZXv	1670	916	213	6301	10118	jwdGx7kXe7gLnnFdS8qPG3GQCaw1msSzUjSEL7XSwCAZwbKxKp4	7147	10118	10118	1617760440000	canonical
13951	3NLa2cx3cfmjT3SWjpzQjbXWowNg7MsUqnPFMHRZMhtrVAJX8Sjq	13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	44	1325	213	6301	10120	jxNcp3k53aeQkyTgm9S1Qn3jWeUQXnyaNxBmduZmrdzdsxkGvTd	7149	10120	10120	1617760800000	canonical
13953	3NLSTSpm5VNBPn8kwsbYt93ABEF88H2HXQmbRq3b5E7FZjFiSp5L	13951	3NLa2cx3cfmjT3SWjpzQjbXWowNg7MsUqnPFMHRZMhtrVAJX8Sjq	1637	815	213	6301	10122	jxEhJe8q8tJkuwStGjFj1MM1Pj89JUZgyXaZgwDDGfx9bagmz8K	7150	10121	10121	1617760980000	canonical
13956	3NLgnS2PkPCPaK94XByXFtZVZuxTBPK89K333kWbKgiKtv3TKDTT	13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	1407	1395	213	6301	10125	jw81PYqFF18TP5fFBD3ffi9qQLgtiSCKH89hbDVKjMJ6bpCCdvj	7153	10125	10125	1617761700000	orphaned
13958	3NKVgdztsVMPVzsoDEHsQQWWYv1eKGu8q2LR3VGdC6pofBSQ75v4	13955	3NKfMXB87gqZcvNYSGGYVJqJFhLD11wuccY1AHQsoJ48jnMTvyRx	484	1073	213	6301	10127	jx29goHtF8Km9SBsAES4Eg6VFaaE4NfyB69C79FPuNfofatc3v4	7153	10125	10125	1617761700000	orphaned
13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	13960	3NLrPghEp7qiyBckrkWnxhYJzAERzCAx3VLno4ovT3vySnkmniVQ	1483	304	213	6301	10130	jww52gyeBpfmGxPHCpC2of2WndDavc5JPWuVz3hgPiQbd7DW2xT	7155	10129	10129	1617762420000	canonical
13962	3NKYGqncTiY4iPdFnBEBPzeqHL9SrUiTc1n9rqCTLieokwZJ5PUY	13961	3NLJLkT66FNCCwpEkhhyiJofze4GTWLaQu8GnqixNVDhqUN7xnBd	44	959	214	6301	10131	jwLzNgL1JE4H394M1SH4ySVqeSUeBfWg7KfUPRrUTHQ3urXZsn9	7156	10134	10134	1617763320000	canonical
13969	3NLFr7WmtqPFUCMUP9bfvShuFs8vtNMj8g8BjeK29WsAt2AEwu7t	13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	1406	1393	214	6301	10135	jxo2tENifa3XTiRTuDsZz1kZWSgEnrvSjNXu6jCtQVP5TqVbayr	7159	10138	10138	1617764040000	orphaned
13974	3NLiRCfX9X7e82w18CghLTWC2g6ZdBDkE4nfQkZyzXAi52iEsL8Q	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	1461	1271	214	6301	10139	jx327xHXFcvifDYxsQCWw7Bu9oKMJVzBv9ji6DdbHWGJHVuq3Ve	7160	10140	10140	1617764400000	orphaned
13977	3NLQUHLX4Nwggch8yMVwuwJYFtV8YL8HANNPwo8VL4WCxKnqTVZE	13974	3NLiRCfX9X7e82w18CghLTWC2g6ZdBDkE4nfQkZyzXAi52iEsL8Q	1523	1195	214	6301	10141	jwTv6CCdNmbDRZYpxoJ3hsgndbPuj89SxpLDYjs6zjtji4uXfR6	7161	10141	10141	1617764580000	orphaned
13986	3NLBNXcxz6yN6gJyf4Nw4GPMXeQSGTVkbY9xtrmVBfurrjzi5fxq	13985	3NLcncJXouBf6ChLWrygXCo5yU4pmvJBTRYtZpnafuSTihKJ8B2S	1647	1302	214	6301	10150	jwSb5FwMuUxs5ajWUsw34gJb9U5L6nPRsQrCvHKRWGHPMzWG6kM	7166	10150	10150	1617766200000	canonical
13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	13988	3NLt9z5PQr3JKogoeGm3dFLGJXukfaadd2VwpdStoz5UNUQLV9yB	1406	1393	214	6301	10153	jwkxGPkyFjCqz9oj9HiHnNzEa3eNu8tYnN54KTbWzVhzVezFZAj	7168	10153	10153	1617766740000	canonical
13991	3NL7d1FfzBD9Xe4fu4YEz37EVrg4QoHCf7QMDZp9heLmr1JKtWUg	13989	3NKBys6u3vtZJzsJfnmm9RHZHUZSNb876ZSN4cVndZ91TNj5bwME	1670	1036	215	6301	10154	jxrrCZXswrU1iJcSYycxDMjuhijfSWAGqU5GY29kFzEHZ5tRbhc	7169	10154	10154	1617766920000	orphaned
13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	13994	3NKMuZGzXu1bnkSjGZyNZkyDNTHR9YWcUonEG54Wy34DFjSeSeCe	1406	1393	215	6301	10158	jxiGi9wxR8bjPMEvzZVzkEVEpdZgr17rGem3rjvwvb6TE1HgCGE	7171	10157	10157	1617767460000	canonical
13998	3NLMdWZK8Ek3TV5M3uULxHgC31zkdKMFNQWL7mh4o5RLBiRKy7B2	13996	3NLGCbZoBgLGMircD3o9vkupVnrAdY7PtvwLVZne6zNjt55otsPo	1406	1393	215	6301	10160	jxWSBLhMBrgyy9bzgUSgcDfx72wMhAPYt8AWzYXtoUD3a5u7SQ7	7172	10158	10158	1617767640000	orphaned
14001	3NKFVZCRjezd97fEo1ahXFtKpjGwUDS31kLvdhZuY159WHv3MUK7	13999	3NKdNBamjGaSiDVomVHkadzMJX74qJ7pNZQT9iiWSWwvuNGCYQpV	58	1155	215	6301	10163	jwC2LNdiz58e5hNgsh1yxo748eWZkkb4rXRJshwFrH7va5bK1wQ	7173	10161	10161	1617768180000	canonical
20329	3NLKXrG3qhaLJgkXmdjWByViFVHy5YErwEvHfRNB1kEC3gNWesUn	20227	3NLVpZ9btxB6Z9Aa2rCUCJWp2bU8Pzw8RL28dNXJXfgGxfoq21qH	1643	1053	363	12463	12662	jwiTgQuCp5nA8HxbUkaS3iZ9WdBQR7XtFEGg23Z8iLbf6mM9Rck	10185	14445	14445	1618539300000	orphaned
22734	3NKHaUapqFQaeDqGGfycXJYmRfBkmmmFsthtAoVG6375x5fkfsnz	22148	3NKNd864qnR1Bq6AXg9TGphqmmjBsp9SqYyD9RnunoFxpZT54yUT	1581	778	407	12463	14813	jxg2cH8VS87FkScfaggu2bZxhb44jjDR9Xp2PsbS58GTAgCQxte	11080	16007	16007	1618820460000	orphaned
22557	3NLE8VUiuxh6gBcjfzfSppbMcrNPU2UoCzFFm8fs1HNPCw7tdfh1	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1579	1143	419	12463	14652	jwt1PPcZqDPrmn8sMzBd9vY3LUnKKbxvqDz3maXbbjp7pwHZgt9	11286	15886	15886	1618798680000	orphaned
13931	3NK9NpxRqH5QheJLXJ6JctqQ3FF4SPkx2JNi2VoMGNpRcchqr142	13893	3NKQoP2SGzj1Gtfz3JV1vVT1riZCNLJmjMtb93SWoPMPQemj2fhp	1650	1375	212	6301	10104	jxyyLCTAkqQGx5w75A7y9aTYeJC6gb3Z2jNCm246NNzVozrEhs4	7130	10111	10111	1617759180000	orphaned
14018	3NK3RZQo1Tu4fXgxK8Xp8P29x3KUxPi7YiDMDVsDCteNR65L24ii	13931	3NK9NpxRqH5QheJLXJ6JctqQ3FF4SPkx2JNi2VoMGNpRcchqr142	1650	1129	212	6301	10179	jwtkCfM9ZYuJcyuf4sDvzy5crqZm28gn6pCfw6XFZdGu2ScfLMW	7131	10176	10176	1617770880000	orphaned
13934	3NLwzYQUDRLyjkJWuat5KVwc4X6ZYnKRVgFwPCV1B5fvfdcmQXQx	13932	3NKve6HY2EeYokZ144GqoheXErUsZC3HNyJz3yyn5anYQvELwshj	1588	1392	213	6301	10106	jwBXv5ACWADbKVNJkf6jNXuejjX8QMJspbbicEP2jGiFDAnZk4w	7142	10113	10113	1617759540000	orphaned
13940	3NL5iJHuZX8E3hsZCLAfxAXSJzpyz63BKEvaPXb68STefXJP9E55	13935	3NKaRgrmrza35EEcNxqN2EAP22LimZVbJ4ZY87pXmBWDcXGoZNxe	1672	1285	213	6301	10111	jwtp75ShuqZTT9XUBebMjSNdSCb22vFCh1oFaGkfF5u1kRwntUN	7143	10114	10114	1617759720000	canonical
13942	3NKgPtmoycE3zXdaNsotU9nuVZFi22qM3fpd9k9r2qSu1UzGibFx	13940	3NL5iJHuZX8E3hsZCLAfxAXSJzpyz63BKEvaPXb68STefXJP9E55	1402	866	213	6301	10113	jwTWq9ChNkHzTL7Pu7qwWNSPjoCKcavL5PiKWxZCFw3S2872PCF	7144	10115	10115	1617759900000	canonical
13944	3NKHH9t6r3jFS8Z7VvJQ1auAXQGrZthz1fZEh9rgMW3jKJxSNAWg	13942	3NKgPtmoycE3zXdaNsotU9nuVZFi22qM3fpd9k9r2qSu1UzGibFx	1613	1103	213	6301	10115	jwoWKWJgarmru8T5BrQY2Hqq6d1sF6ouTFkFzBDirWT1MDGD41R	7145	10116	10116	1617760080000	canonical
13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	13948	3NLpXdAdbhnaU3VbUCthxuPehF2GupMkhdTubRK7bJhyt3iw8Ft7	1458	1077	213	6301	10119	jxJiuQfiZotFakFBth5qBTkBS7NjwcNfDsJA8raGLpibhHoKF4f	7148	10119	10119	1617760620000	canonical
13952	3NLJFfVQaRsn2Z45oBqFhq45Zrr7r8cVjeeRhWowu671anHU3YNH	13949	3NKmz6fHbsgUaBvCkJ8Z2fmHZ4owrwJD7ooRGvX3mEQPwjaW49q9	1403	786	213	6301	10121	jwcVjUcEgFrNjVo1YPTwjebQHewJd6sBhJu459dfg3bW7AZzuV2	7149	10120	10120	1617760800000	orphaned
13959	3NLQ5d4Lf1xmMDvRhafcrCR8BEU9zqXRKouKesmavAMFgjvig7ss	13957	3NLHLJ5wgYumR5rqkjZYmWU2KSVjDttfg9BJpDGpYRGnH6XDuXHc	1406	1393	213	6301	10128	jxj8o1rwticSHdtGrBcX6wK7v5MT1nSnhvrxP51dBgS8DXy3e9g	7154	10127	10127	1617762060000	orphaned
13965	3NLJn8bDBSFfztZYdwz39Na2WzsVZWpV5ovL7PicfZGMWubLS7iy	13962	3NKYGqncTiY4iPdFnBEBPzeqHL9SrUiTc1n9rqCTLieokwZJ5PUY	1607	1102	214	6301	10133	jxKAhWezJPubSrrLzx6H9vavYwCoBziCj2R2iP2SJVw5761HrQN	7157	10135	10135	1617763500000	canonical
13967	3NLm1Rf8Cj637ge2v2v5V2jyXZEcbydea9ZCZX9TNyBU1VEMWJpV	13965	3NLJn8bDBSFfztZYdwz39Na2WzsVZWpV5ovL7PicfZGMWubLS7iy	44	1325	214	6301	10134	jxBkDf722ofsomVYQVr6wdXDuBNASpX1DdMCJSV88PXCEpF7sHX	7158	10136	10136	1617763680000	orphaned
13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	13968	3NKNCW6wZf6hgAbg9cE4NcuJ9NwmLD3HXUjNrEypTY2UGZ9f5gxM	1397	828	214	6301	10136	jx5Nu1uCr8ncH3FH5eyZW2LK6q2bHZ41Ly9qX2dty4jc9X6qpCf	7159	10138	10138	1617764040000	canonical
13972	3NKMbPTRKxp441vbQogp9Jqp7ktUxj5ouj4L63eZtEqXKPs6w6K4	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	43	1064	214	6301	10138	jwkxNouVoCQhz66z5AzuNkVAkMKUqYGn2B7JxmYHT1E2v8SxLWg	7160	10140	10140	1617764400000	canonical
13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	13975	3NLtDQXjGKFQmDbYPgJvHC1U15JRMXTzbwL2BpLD7JfJZ4aVATGT	1474	1083	214	6301	10143	jx5jYn8epugYWpTuDeMCHBQM4J3mqTYCCyYyZzMh6gg8XuMNGZJ	7162	10144	10144	1617765120000	canonical
13982	3NLY6TTRPCFR4spZU9fub5V7HuGA29aD3x782MeRZYwvaFHfid4q	13979	3NL8Fea4Wm8J3nqogbkX2RuaHm95BWZn816bq6VFnK6j4FvC9g5T	641	1210	214	6301	10146	jwxFo1qZsBmFnY8NKietBV7NqqMxYU1QoLD8PUTVMdaqcSFrY4u	7163	10147	10147	1617765660000	orphaned
13987	3NLazT68txmf7FnaekH2PbDpifAhyCcQio1P1dNZjiZoo3UNDjXw	13986	3NLBNXcxz6yN6gJyf4Nw4GPMXeQSGTVkbY9xtrmVBfurrjzi5fxq	1656	1343	214	6301	10151	jwi8cGprYDTFZbgF6qYkdXvrmtTqWRnytpYafLVSdcmyqCRHm9q	7167	10151	10151	1617766380000	orphaned
13994	3NKMuZGzXu1bnkSjGZyNZkyDNTHR9YWcUonEG54Wy34DFjSeSeCe	13993	3NLo1nqwhZ8qP9PwkF3EarMRnV3Xc9oL75Bqw21KH7R5ChMUKx7e	1607	1222	215	6301	10156	jxCv8eBiXnyWnsLuQCvCB4Z7fvztqXUYujMHXaXf1fh5XG8a6HQ	7170	10155	10155	1617767100000	canonical
14002	3NKU97f89fAapQ7qzkfTWmNJduBscyMRoGRtQ78JDjVihGzAn4T2	14001	3NKFVZCRjezd97fEo1ahXFtKpjGwUDS31kLvdhZuY159WHv3MUK7	1419	814	215	6301	10164	jxiPf9d79qag1U9RQNwiuNwF4gPqCVPnwFkWBxSpApJBB1uyLxh	7174	10162	10162	1617768360000	canonical
14005	3NK87G1tsPqaWfr54ETor1Gup8fHVuW7XPwtdTqdwsRj3LpXPEpw	14004	3NKT8jQXTnhDjFr7AgHQjwnNaGGepcmTDoZKo55vcqk7f7jK1yxg	369	1312	215	6301	10167	jwF7GjcsPkLLwYqipRY75e8Q7jHMBQVDJfwBGC8ZpLyH8T64ZYV	7177	10168	10168	1617769440000	orphaned
14008	3NLtaxsckw89FAksjha1hUTduvofQG4qb3qxWdPuipuuU5jv5VDw	14007	3NLjhTTkm4G1TSJt8ciHsRJbKbN1pbFMCs4ELLpRrMsqoZMDfP91	1500	1297	215	6301	10170	jwzUcrqwKwGro95Yx7egNGawCKmuPZBXYNHssr9UPN46bToF7B8	7179	10170	10170	1617769800000	orphaned
14010	3NLSa9eSYXrS6bBDTr2iZK7J5BqXZCR8M8eK9mjrzW2ffRVmGtvW	14009	3NLj3vmhLk8mFqTZfrtp4aEVH5zH5oX59xAMrz6xqL7238N3NmH2	1593	980	215	6301	10172	jxbLEdreaJtUpYqzxMM3SpW3qe7MTvYoLkQSbenQVbyKiaYjuKG	7180	10171	10171	1617769980000	canonical
14013	3NKfGg4RARyLAmzDsvN18x3NQmzmQj2csJkzbd5f2fYPg3tXeK38	14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	1476	1371	215	6301	10174	jx4ievuwDN3qP1cXpuQg97nM1os81dx7hWP19hcBE4kB1kQMp1u	7182	10173	10173	1617770340000	orphaned
14016	3NKpGWW4g8DPYYsq1cBoWxWVWWNiBaQGgQJACTvn79F1M4LFc3SV	14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	1581	777	215	6301	10177	jxaUbLZSbRN7SrHYhusHDJvuZaiZuBDBM4dyv9Z3HDVKcEFUs1f	7183	10174	10174	1617770520000	canonical
14021	3NLYrKSHGx7jarct1YHtY9R6qeamg2WGJsrPdAYBtgvbXadzpDkt	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	700	832	215	6301	10182	jwzN36xiaUXSe66WGwGXGW4ULXJEU7cQrjEazhdwfdNnjm3Ny1S	7185	10177	10177	1617771060000	orphaned
14029	3NLueTiYZp8pnpkMN19JNFZbUgZDtfoGa3J5wRSzjpX5bAxyU4RB	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	1560	1291	216	6301	10186	jwvScn5kYXjmLbvvtWtVwwgUVdfe9Sgj71qVWmDaNzCezNAnCpU	7188	10180	10180	1617771600000	orphaned
14035	3NLr3TR5rRx75vmaEg1xK1xR2Mj6GqgquGtKSHeH3XxUm4MEBJKG	14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	1402	874	216	6301	10191	jxUYdwmEQhHB55iG1EUdGPzAPypfucRgqRfV7b1tEDYXqQ2Dn7f	7189	10181	10181	1617771780000	canonical
14034	3NLC8tvoLB3x6kQcnjmECk2wfsWBPpGmhqtStmZhPJXemXRACEep	14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	1444	1135	216	6301	10190	jx77d9M9YR4UU8enX6rHseD4CH45fEuQ5o5JRe8sZqCt2H74pMY	7189	10181	10181	1617771780000	orphaned
20399	3NKkNKJqeXVYxewmWSzW65ALzJgAEimU4R9DJCohPbZaiB6mCTYT	20329	3NLKXrG3qhaLJgkXmdjWByViFVHy5YErwEvHfRNB1kEC3gNWesUn	1643	1299	364	12463	12728	jxR3uMcyMautKQv8yE9Zk6gZLCBUUkKXVPy6KDQZZmWcJF2PNvE	10186	14497	14497	1618548660000	orphaned
14004	3NKT8jQXTnhDjFr7AgHQjwnNaGGepcmTDoZKo55vcqk7f7jK1yxg	14003	3NKfcLCaxD75q7476hpFcSWyVt8maPVyNmw2AwDwFotkEj28Tuhz	1577	1081	215	6301	10166	jwiqBHEty2WbfYCPYX1DaTubfgs6uvFrJNYBn7shPrTCLQRinZi	7176	10165	10165	1617768900000	canonical
14007	3NLjhTTkm4G1TSJt8ciHsRJbKbN1pbFMCs4ELLpRrMsqoZMDfP91	14006	3NL2PK4BzDcPqTCo2zQp1mpyf8vLfZ6QwTgHiJ499WjCY4c4k2xa	1513	1379	215	6301	10169	jxMEsicaLoLYMjeQJc2HFmveUueFVDybEYGqYMNZhCzLGkXmSP9	7178	10169	10169	1617769620000	canonical
14009	3NLj3vmhLk8mFqTZfrtp4aEVH5zH5oX59xAMrz6xqL7238N3NmH2	14007	3NLjhTTkm4G1TSJt8ciHsRJbKbN1pbFMCs4ELLpRrMsqoZMDfP91	1403	824	215	6301	10171	jwdcuEKoUMqa3mXU8LcNFJbXhCfugW4tX6XbBrSJ2HyzUi3UjLH	7179	10170	10170	1617769800000	canonical
14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	1476	1371	215	6301	10174	jwJb5CeZBUCavo8zrvs8md56ypcaKQLVgTYf7AT35N5iUUEtNaJ	7182	10173	10173	1617770340000	canonical
14015	3NLJk97eWfsWNoYqWyXawM5muNM2X6BpsHa5WbjWyPDhW81Y7Nmf	14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	1406	1393	215	6301	10176	jwMC1qGNcoK9HZzmbqQkZRG2KHt21p9MFmRJPYXJhQQQzQ1Ea5s	7183	10174	10174	1617770520000	orphaned
14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	14016	3NKpGWW4g8DPYYsq1cBoWxWVWWNiBaQGgQJACTvn79F1M4LFc3SV	1585	1000	215	6301	10178	jwVSvxN8BGRJTMPJZKqMNfmGXYQjiaritVVWSvzDtTu39YPHikC	7184	10175	10175	1617770700000	canonical
14020	3NLJYpKcCtaHwaVcdR9GCvg1GCQAj3xecTm3fqSrcnnb4w2kBLkD	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1444	1381	216	6301	10181	jxszv57vDZWJSZVGKhBDvD1nDHikb28HKkJMeLMjnZcbFFS7Z99	7185	10177	10177	1617771060000	canonical
14024	3NLvXQXHiJ81aRMV2kBws2r3e2jJzkosSthzNCxpWN76ThVq7sRK	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	114	10	215	6301	10183	jwsnTFCFCKvZRXdBhodSdypv1n4TVBRhf9U1aukeLor9cZQnCSN	7185	10177	10177	1617771060000	orphaned
14032	3NL42xqiUijUMyShDvrCmkTYgp4UiiWcCyHCn1QKWS4dEnwfFZFj	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	1560	1291	216	6301	10186	jxjrYKY11xdHQBGJmpvEW3FsLcb8u2Kz3L3tNz7SEhhU1kyJ4kc	7188	10180	10180	1617771600000	orphaned
14036	3NLXeqsKy8gvS34JyyNKPnr3C4gBdUXbj6uYP7BXu2ZjtW3W3VW7	14030	3NL3KfSLYWaJEWe1uLG2ujMWoKsSFd5qdSEzf2MpV6uQaetgK4Sx	1509	1320	216	6301	10192	jwxhgzgchnrgXD8hETdVvmLKkc758yTQq9ridzSJSP6XUimSvUX	7189	10181	10181	1617771780000	orphaned
14042	3NLVSyst7YiPjZ8x2jzWQbKiN5o8rVyM38WJ8wtMbdNnwrp3YEJH	14041	3NLr8RdXndYmuMZayrsMqGSvHFftMpjn3HNLRm8mmF2useEkf4VN	1506	1127	216	6301	10198	jwYtPxhwmskSAngu2s3t6MeapBG7bUb1WPFf2kPBfp3Jnjps5pG	7192	10187	10187	1617772860000	orphaned
14044	3NKTdCrKNnZFqB5MrWMJ1i3h7XsYkhDXthZE31TYq9v8vnKwt965	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1634	313	216	6301	10199	jxMX1BBmbS2AaP1N8NGuXrVtYrTpvPyPoQ8mZ7TrByfVXm7Dp2P	7193	10188	10188	1617773040000	orphaned
14053	3NKeGGf83sMrDDVFSiakqhUXR6NVDWwxBHjsfvD2GTH6qBnM7akK	14051	3NLYjVS7BoLsfoN2LpDPLPU4kF5Kqy2GLh3MspptSbxQ6jqKfi8p	1474	1329	216	6301	10205	jx9CdWiAAUmKqGQcYPpDPkwXde1KRGNxuxGwJUN8Edh76dXeyyX	7195	10191	10191	1617773580000	orphaned
14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	1587	991	216	6301	10206	jwHv7LN9GwR9hXiuYkyKhRQgxBYC9veJDKUC3f7C7Vo19TAvuBp	7196	10192	10192	1617773760000	canonical
14060	3NLoYCqS5bU4argT8v5SJqxkycHaBeieDGhQBHi5H4MpvSxVqFmD	14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	1522	956	216	6301	10209	jwNVk5znwZ859mD67sRRmUvWSTNavBAz4fP2nyjR78Gjn3uc6qn	7197	10194	10194	1617774120000	orphaned
14067	3NLEGGyZBsUGADKy49zqrTLApvoHFW34bUD6xzrGCx7NjwZ5cSWN	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	1602	1369	216	6301	10214	jwSEYXEk2RXGUmMpBAKDUPCtXybfw2JfDEtjYNjMuP1TSrLN1XF	7200	10197	10197	1617774660000	orphaned
14070	3NL5oMtehYzbKTdPvj9VQvHJdiCv41Jn9taDbwLzokG2L1YqHCXw	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	58	1035	216	6301	10216	jxY1smWV2tfjaYHVjPLGq6F8yAG52SqbhFZsvS5iKa3UXGQWxJj	7200	10197	10197	1617774660000	orphaned
14074	3NLcjrgQgoNBXUmih7tT3uY5cHykSaXJA727U8vLPEtPbaJdj2VJ	14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	1608	923	216	6301	10220	jxM5zgA26KGXPtJtjn3Qp5wbz3UagoqUBFFsmfj1oT7gxpHJ5Tk	7202	10199	10199	1617775020000	canonical
14076	3NKGUkCka6Cq1tuMh4TjSK4fHwuRoDVBdorQ91eKyN2kyANkbgmF	14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	1637	816	216	6301	10222	jwuYVxHyXXQkAPt5yGpPLmJg1tD61WYZAB8ogWcdYWJumFNKVx9	7202	10199	10199	1617775020000	orphaned
14085	3NKWzLGnNRyubThhXL3Z39UFD9mbUyQpz6NxmgidyxVLN2rKa9aw	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	607	607	217	6301	10231	jxB1TbW6NPfuvAYXuXpw1VE6ntsZwEyG7yLkhLLSXJ4Qx1Eizkd	7205	10203	10203	1617775740000	orphaned
14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	1402	906	217	6301	10235	jw7TX4vpkXZRw7mjo7dw2XAX8FGH7XMUAFWhUy9VhVJRuR4v8ue	7206	10204	10204	1617775920000	canonical
14098	3NLhbhLgdSPNqDVnsFg735TS89JJSMzHk4mDDVURbi6ZEfn9Mc2u	14094	3NKwDX8AFcUZJV4nXBBYFkcdbiap4JLrKeFxJ1uNPyNUXvmJTJ8Z	1406	1393	217	6301	10243	jxCczszbPPo9j5QmYc7MK2egT42D5QoYY8cZbG1J5bpBFVpJewH	7208	10206	10206	1617776280000	orphaned
14105	3NKQ1bmMPZkVSbsRnHF3LGgqXrNHr94VqFZ7NoDxaz2r9Q1Wkc7v	14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	1652	1315	217	6301	10249	jwCdZn2LnV2bPUS8xrpXqXjkwQnN3HmWZ4oyz9JBAhKgmAqpSV9	7211	10209	10209	1617776820000	orphaned
14113	3NLpGdbbSUw26LPdBcxFoBTb9hhtgdr89vQecFQD1d98Gv4jdiba	14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	1471	1020	217	6301	10253	jxMsfiqrK9KcaxZNr18KqAdz6NNce6NbeKEZYsCQm8RAZLwNp8P	7213	10211	10211	1617777180000	canonical
14111	3NL1X4PTYutXKyr3wY6YEvtxMKw6EyJxP215B8joKxxdZtS4dzdq	14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	1471	1020	217	6301	10253	jxq2vzQe6zJzRhgPZhQfkYJqxemos7C6tXzwdCTTJoYNJqxNtrG	7213	10211	10211	1617777180000	orphaned
14129	3NKdZDged1WQjxpms1E4BrSRNQa7keixY58NfcDyr7ZpM17zyQGM	14113	3NLpGdbbSUw26LPdBcxFoBTb9hhtgdr89vQecFQD1d98Gv4jdiba	1406	1393	217	6301	10268	jxmQER5r6S3zjz78aQoVsWCrVoGE2Xr4jFbZgyohPZTYyiQUusc	7214	10220	10220	1617778800000	orphaned
14116	3NLBaSgQqDJpYot4dLXjroeyMLfhAkQFjMmqr3ZXdB3FZfx7oSQy	14115	3NLJBYsK7YnMWxMe9SSvTSSzHdhW2VmtMody1LcJvr3oYRWpcdBC	43	1310	217	6301	10257	jwMc7p2BAFxUxJF8t84J4Je6QkGhFE3CJyuLFnetSr5YUfjU3w3	7215	10215	10215	1617777900000	canonical
14125	3NLgr39HsdGjS8FY1KgecuV7SkF5BCxMXaYoRNygq7C61HvHC2TA	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1422	1211	217	6301	10265	jxVqtXqvwdaZ3oSL72pXxcYQ2Qu3uUZwQYg9iSPFCkmQoWS3nqr	7219	10219	10219	1617778620000	orphaned
14132	3NLoeQjhCyFKfJ4PRrkmHkCqPm2ViYmfCPz2p1LrbfauLN7Pwvaa	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1407	1395	217	6301	10271	jwN2eT8V6h1LMaRWnNA4QpVkjmQv5pdnbXhwzD4cqfRopqzsDi6	7220	10222	10222	1617779160000	orphaned
20536	3NKBoHpawZ13QUTmSMaY24RmpDRdAXQ94NawR4gboU2aL4iZ1wCG	20399	3NKkNKJqeXVYxewmWSzW65ALzJgAEimU4R9DJCohPbZaiB6mCTYT	1643	933	364	12463	12848	jwq5WxKZ9XeNERXoyTPa7jWHLYNeenTr6wyEhkD29KyTMWqqN7k	10187	14577	14577	1618563060000	orphaned
14124	3NKDe9ukEpcmo5Ha45kBFty4MhR9MRsH47mqvpMtjVqkVSt3XrPY	14063	3NKEkuPqhKmot8hPEMJwYwLLuPQ9u1eBVrBcKTu7jpGP3EKLrQuh	1564	1092	202	6301	10264	jxZUz7rKVxqiHtSEezPAB4rntV5CwprSqaKpdBk5EkepQBjzb54	6955	10218	10218	1617778440000	orphaned
14101	3NKoFXpri7232Ei173vrp3nFWbyDXtXdrR7VW3wUt15GoC515GAr	13959	3NLQ5d4Lf1xmMDvRhafcrCR8BEU9zqXRKouKesmavAMFgjvig7ss	639	639	213	6301	10245	jxn2dByWsLS2E67HqLpaPRwzigCFaU7wimNHHE8hH1Sr8fEmFMN	7155	10207	10207	1617776460000	orphaned
14006	3NL2PK4BzDcPqTCo2zQp1mpyf8vLfZ6QwTgHiJ499WjCY4c4k2xa	14004	3NKT8jQXTnhDjFr7AgHQjwnNaGGepcmTDoZKo55vcqk7f7jK1yxg	1403	782	215	6301	10168	jwoEAuMcoNVVAuR8K9qheZSfhP52FA1C14nQwsyzwcMUo9RBySC	7177	10168	10168	1617769440000	canonical
14011	3NLFVXskd64qiqcW5kY3dbhrBdjZ78MvipKKW72MNrpjywA1WFLM	14010	3NLSa9eSYXrS6bBDTr2iZK7J5BqXZCR8M8eK9mjrzW2ffRVmGtvW	149	1037	215	6301	10173	jwBZsZdZRsxVCN1sfcuGw5p94pvoYBDG3YGpqEHuk4aWkX1vZGB	7181	10172	10172	1617770160000	canonical
14014	3NKvySwBPX77Li4ctGi8kfaFLoWGF1tqvkY58Rs1jmFmDwe5FPmV	14012	3NLbqEQnR84sKWGfkNjHDWhuocsr8WhxWxHcMPgw5CekmLJBkrWx	1407	1395	215	6301	10175	jxprsE8mGKhR2e5biKPrjoCbWu3shKnM75td5NXksBFRXc12tM3	7183	10174	10174	1617770520000	orphaned
14019	3NKMrfCzErKww3DzhJekQfuKFtjLhcz5YS6oAAoastMQLPs2ZPdH	14017	3NLAESFFeA1JHpECoaqNHExbhKT9rEDFHd7nX9KjV7oi6U6NFrNg	1634	1331	215	6301	10180	jxZuRERBB2zmv6Luk936nBcBjaHu15x7jFjSeFuzBJ54quPvmUG	7185	10177	10177	1617771060000	orphaned
14027	3NKftdWPhGF1VpoiNq7FsmLVJWUfajBSNgzXDCF2xJx6RjrW4UAs	14020	3NLJYpKcCtaHwaVcdR9GCvg1GCQAj3xecTm3fqSrcnnb4w2kBLkD	1672	1285	216	6301	10184	jwTeSdKK31oYyCA8vuQRPZ2YXuL9AYL1ZLoAHrw6PBZ6JiFDDNM	7186	10178	10178	1617771240000	canonical
14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	14027	3NKftdWPhGF1VpoiNq7FsmLVJWUfajBSNgzXDCF2xJx6RjrW4UAs	1637	816	216	6301	10185	jxUR28yUMqjAqYRfzE8UCowB3LgDZh1vv8FXvhWU4rT357qLpzs	7187	10179	10179	1617771420000	canonical
14038	3NLAFptvuYYvzXSwqUTTtBSp39oerWFcmHFGjbEh9pxou6wsAsVi	14035	3NLr3TR5rRx75vmaEg1xK1xR2Mj6GqgquGtKSHeH3XxUm4MEBJKG	1607	1348	216	6301	10194	jx4a2WuNA4r86eqfgSWZV2tDVxjDChyqrgn6eR7TerqpBWzz9QV	7190	10183	10183	1617772140000	orphaned
14041	3NLr8RdXndYmuMZayrsMqGSvHFftMpjn3HNLRm8mmF2useEkf4VN	14039	3NLPmm9VTh4rBZvrgKgZQQa72HEtFBhyLHJsaCGtMNrd8Pr1XYp8	1513	1133	216	6301	10197	jwRwxrGthBPWCYuzwm2xg88PUVBv2eCSPbFrkUjJd95b2BREygn	7191	10185	10185	1617772500000	canonical
14040	3NKaZNFGFeEcn7eDqA7nQUV6tdDmv2DFJpahfEJRKwhD6ESTDFpU	14039	3NLPmm9VTh4rBZvrgKgZQQa72HEtFBhyLHJsaCGtMNrd8Pr1XYp8	1406	1393	216	6301	10196	jwR1SKpg6ovX2DDpaG5gRgHwo4gw2jSQNW7tNwhFe2fkTMfR8T9	7191	10185	10185	1617772500000	orphaned
14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	14041	3NLr8RdXndYmuMZayrsMqGSvHFftMpjn3HNLRm8mmF2useEkf4VN	1506	1127	216	6301	10198	jwSAGBuHxzjHAaJxDZSRWyfd1kaecJaQsYyhkJKD6FHPHJDRHhX	7192	10187	10187	1617772860000	canonical
14045	3NKx4fcs1MeyQe2t3KVgmKhyWnifouMqJ3MhP87udLaCjTs64xJ4	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1534	1191	216	6301	10200	jxK89pmATR6AMHTfeedDb6hVCWkuBEhmSuuAwfEhpvwuVwB9TdY	7193	10188	10188	1617773040000	canonical
14046	3NK8v8xMfskKR1gdiUTz7deaFkmdBaLwyMLaa5uhu9yz2iZiraMn	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1601	1262	216	6301	10201	jwqFB283BVXcRgTybbnJfRzAUWUEFAT6FWNNSJBtvwEfZeMTmKQ	7193	10188	10188	1617773040000	orphaned
14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	14051	3NLYjVS7BoLsfoN2LpDPLPU4kF5Kqy2GLh3MspptSbxQ6jqKfi8p	1474	1329	216	6301	10205	jxFZLHF8aLX85uiSQPNLaHyXbSAKZusotw4hEUi1fbPCsMYhhNL	7195	10191	10191	1617773580000	canonical
14057	3NLvzDafpY95zPijQVJ7yAri2EsBwhr7sPCTbD4XkPzeLmaZEmF1	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	684	1226	216	6301	10207	jxymzqibCt2U6xUHbV6t4QCJ6i8C64Lry9jiTuNHaiagxf3dYuA	7196	10192	10192	1617773760000	orphaned
14058	3NK92FDcKznQpA8fwiPvXww1MGpLmbFisX1nV3j9E9xVMGgqn6fS	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	1587	991	216	6301	10206	jy1H8YTLYqFqzRrKdyaTwrioLNBSDiwNWNqWcZ82sGqbtFziCAE	7196	10192	10192	1617773760000	orphaned
14061	3NLdAMusm5yXZtvnq6L8ynkRhrUHZJPhZ1FFWFTr7fvPJ5wdRMBH	14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	1542	1304	216	6301	10210	jx5wUtZk1GgRBkD57U9T8qpZRzcf4htnFLy5V9LBN2rWJN9aN4t	7198	10195	10195	1617774300000	orphaned
14069	3NLFnzxs4G5pSZHPaH6VTcut8RQhdzGPDL92VUW4yQhhnhVziJyb	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	1483	1276	216	6301	10215	jx1oTLQo8BZuqTKJVeZzGuhvWNMwxmYvoDdR4yUe42ko8zv9QtP	7200	10197	10197	1617774660000	canonical
14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	14069	3NLFnzxs4G5pSZHPaH6VTcut8RQhdzGPDL92VUW4yQhhnhVziJyb	1406	1393	216	6301	10219	jx83rrqEQJaHGomMWjyXSsBUuHZ8f5PCk5QW4ySGn1RvgKzFEhn	7201	10198	10198	1617774840000	canonical
14077	3NKLsBWQX4ZYXxwjBPqFtH4QGtJ9bvqqspk8Q2KBryN1wygKFVin	14074	3NLcjrgQgoNBXUmih7tT3uY5cHykSaXJA727U8vLPEtPbaJdj2VJ	1406	1393	217	6301	10223	jwoat6nMAcaqJ2uWQ37471khCLbjDBmzZHudVoVan3Zg4Ftqyjm	7203	10200	10200	1617775200000	canonical
14084	3NLKcnuASLkHmY9JLi2miCpyfm1iTk81xEoQisY8a1ihawUhd4Yz	14077	3NKLsBWQX4ZYXxwjBPqFtH4QGtJ9bvqqspk8Q2KBryN1wygKFVin	1624	1208	217	6301	10230	jxNZ4G6bTahwHH3mC17f5pmaaJzNXMJAzKQdSNLTZgVoBJJfGu4	7204	10201	10201	1617775380000	orphaned
14091	3NKVsY7N9JARvYrwCdnfn8oLjSdjmrcsjVEjTDSb56EPoEBkxTCE	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	1509	954	217	6301	10237	jxnoan73uiyUEQEk2YNSNhnU9jyvmdi4m18tLwBXqQqwzm7sZdv	7206	10204	10204	1617775920000	orphaned
14095	3NKsysc8xEuYzmvrabk69FfzErT8ASH2AX9PCtgtYYihE9yEm1t5	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	1549	1116	217	6301	10240	jxBWQzRC2GwmMG6oeV4KjY4c9dw9rkQtfx9VNQatA8nTYBS2hBq	7207	10205	10205	1617776100000	orphaned
14099	3NLazUZW9Govqtza9znGJVhBZrK99vPJbx2sNs4xXgi8LQ1pZyWR	14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	1622	1356	217	6301	10244	jwXCmY5gHmtpEp5Bwd9u6fj5XjWRoJ7LgdFWm5hFHF6BNysKur4	7209	10207	10207	1617776460000	canonical
14108	3NLknQp1UaWwgA9HDk1Qc2EF42bm49EJDidN4RBVc3vmAkVcxisc	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	576	1355	217	6301	10251	jxDe8kCNyJgNJziPXoQqn3S7Ls7H5DRcWPmLBf8n6UMN7jAzDqG	7212	10210	10210	1617777000000	orphaned
14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	14116	3NLBaSgQqDJpYot4dLXjroeyMLfhAkQFjMmqr3ZXdB3FZfx7oSQy	1407	1395	217	6301	10258	jwgFX8gT9dEEKCYCGg3TsX5FminAVxQroyq7tprjZdpUXTfDL7x	7216	10216	10216	1617778080000	canonical
14120	3NK5UeogWiexwKJ3NXeHHby5DiiQG9vPbJtjM6zXwdi2LhV1mat6	14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	1651	935	217	6301	10260	jwKrLa3pF3DTCnGBgDRZAJERfXCiDJ8iRWwM8zEn5ZBPZ4qyjPw	7217	10217	10217	1617778260000	orphaned
14122	3NKHpGQxDE5SLsagBtt8Axr28wgoWVPSiHfUrGzdro4Lf9mP6dP1	14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	1589	1160	217	6301	10262	jwHHW5r3ZtdKDH5f27hZA55EfnfuUpjGi3oNbMLBJm3EcsceLYr	7218	10218	10218	1617778440000	orphaned
20233	3NLjwHo3PPxJzuaEKEnZZv3xe4fvE8Akg8AhPBUDXLEv58njA5VJ	20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	1457	1391	363	12463	12574	jxHFioU9w8qDfxXFffh7CKyoV6pevuGgMrpBB85NqnW87nicXb3	10188	14369	14369	1618525620000	orphaned
14078	3NLr1Kju9iLAfq5Uz3d4Eam1zvXighGZHo9mutPmnopdEaJBffS3	13970	3NKxbj7VZUhLbTr7r92NEaSKoJEegF2KUwWr9LsJLYzzxckC68X3	1405	855	214	6301	10224	jxEip17XsPXcPuq1kARTVbqksHfkeqVQo3dQUQpVhNE5DznHwia	7160	10200	10200	1617775200000	orphaned
14080	3NKbyfJvgJm43KYzTg5qAb28cuRdfJrupXEVxzWHFdUQTThTLmaf	14016	3NKpGWW4g8DPYYsq1cBoWxWVWWNiBaQGgQJACTvn79F1M4LFc3SV	1405	855	215	6301	10226	jwFyniGK5hmoHgyA2k8GboccUcnuGHbYHghRTbNj2vQ7Xy6ZvS5	7184	10200	10200	1617775267232	orphaned
14031	3NLsWjBfKEiZJfEbkC8pUEPu2p2pVroYtby6K6M3BYFgRmXhwZXq	14027	3NKftdWPhGF1VpoiNq7FsmLVJWUfajBSNgzXDCF2xJx6RjrW4UAs	1403	824	216	6301	10188	jxPKxSZzsRCaAVNnoxZFtNVJjjfGi6RzqgckeUq2zFDUFA4TnbA	7187	10180	10180	1617771600000	orphaned
14033	3NK3APUPxtuWakMeeFQ1qzYdAJX25Xs4W2TSrn9YpAegNt6SMUpz	14028	3NKZYqSH4CGkqW29655gWofa2t5ap2eu3Kn9WEtKfYitq4pX9FZ1	1403	824	216	6301	10189	jy2A6WjU3nxUrgCKMsMAbmLSYTRvijZWgP3JTCth1H5HcETeJGg	7188	10180	10180	1617771668545	orphaned
14037	3NLQwiZoYueLP1HH9yN5QxMEKmmdp8tsLrQTw5po72k7D8437UVA	14029	3NLueTiYZp8pnpkMN19JNFZbUgZDtfoGa3J5wRSzjpX5bAxyU4RB	1444	1135	216	6301	10193	jwh5z63pBQf8zxaKAUCpgurW36U1Jv8ERj69aaqykmwTxAKpJxg	7189	10181	10181	1617771780000	orphaned
14039	3NLPmm9VTh4rBZvrgKgZQQa72HEtFBhyLHJsaCGtMNrd8Pr1XYp8	14035	3NLr3TR5rRx75vmaEg1xK1xR2Mj6GqgquGtKSHeH3XxUm4MEBJKG	1631	794	216	6301	10195	jx8DSTLHpqMfLJKVDHQL4FMkGb5hvMV7LfqCm6jg5mxsD9dfETF	7190	10183	10183	1617772140000	canonical
14048	3NL1XgrqZwWw98Cspf7wLULACCj3dS6Wj9rtzo62fgPfK1Mbfpnp	14043	3NLhUrFo5ar6JktF6pZViyhHs52mjyQfU7hHVNPRozDqozXTdnTY	1613	1349	216	6301	10202	jxJcQxKV68bT88KjKX24VxSDvEoE1MchWpohudfRnJvep7GC5vP	7193	10188	10188	1617773040000	orphaned
14051	3NLYjVS7BoLsfoN2LpDPLPU4kF5Kqy2GLh3MspptSbxQ6jqKfi8p	14045	3NKx4fcs1MeyQe2t3KVgmKhyWnifouMqJ3MhP87udLaCjTs64xJ4	1648	1284	216	6301	10203	jxiziyPhVWkLGp6S7dG5cZ8BdiMmxStQqtJpzNZqB3H9qfjwexK	7194	10189	10189	1617773220000	canonical
14052	3NKuuDLdXQMwwgBZCxNWq6cSFvFYsghSZ7uaPdwiaU4pNS3M4B3X	14045	3NKx4fcs1MeyQe2t3KVgmKhyWnifouMqJ3MhP87udLaCjTs64xJ4	1631	794	216	6301	10204	jx5PGoxQQFAs3GQQHMjokyJjpLB632RbupUDyBfzWpvVcj7yUzs	7194	10189	10189	1617773220000	orphaned
14056	3NLTa3XsoMmQxEgVfZHPM2QeDyYXpjE2TuFzTTE8YQ73qdyGrJgn	14054	3NLwFZLjjSzdRvLnjaZoSN7G8TLKnBBMjhEmobhwquDY4mYwdrnG	684	1226	216	6301	10207	jwziUe86M4zo2VXv2aFeEGsmpCSKx1zkMmS8mD1rcFrMSHZz8my	7196	10192	10192	1617773760000	orphaned
14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	1649	1383	216	6301	10208	jwpPZ19MNRnpJzBcAGZVyzCtRUxSc36vwyoDei77L87YQWH8kro	7197	10194	10194	1617774120000	canonical
14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	1631	794	216	6301	10212	jwGWhotqhJJSHzARUhQ5wcH5J1nHD2NuL4onDi1RsKWU6xNPv6F	7198	10195	10195	1617774300000	canonical
14062	3NLdfdgARLyQP5AdRVeNUiraXjahG4A9SUpvtFB42Kg8quBvTY7p	14059	3NLLKZdrgwfs2DK4C1ivrPmdWKMerpjGk6L4MUmEwAHTAhd9Y63c	1542	1304	216	6301	10210	jwBrk4jkYACo12Hram4w9quaVXh8h6oSALd2bPR5DfUc7PygcfB	7198	10195	10195	1617774300000	orphaned
14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	1593	284	216	6301	10213	jwPMo8yAjGy4TZjTSkSLCEdwAca127AdJcx3S8z4aAu3udCSMT3	7199	10196	10196	1617774480000	canonical
14065	3NKS5V6Sr3EfFKm5B1pFDCf1dPM45NzZ85x8ev3zq9W2Du5LAKUZ	14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	1593	284	216	6301	10213	jwu3DHUfWFYHUqvxN6yWGSZofaLdWApxDet8kRYgS6LrfhspdsJ	7199	10196	10196	1617774480000	orphaned
14068	3NLDvFEcYJJ6SCyjB9ikXwACPEztuTfjG8kVFhKVtFbPdCJcENym	14066	3NLiQp1EPtGLjMDtTWkaWyjEJodSaCFZora9t1B6BHh87qHzZKde	1602	1369	216	6301	10214	jxsHQG2jwFyQoKwCVpsqaPJb2FveMxn8tzu9CasEGVXJnFufFGd	7200	10197	10197	1617774660000	orphaned
14072	3NKf6r8cMwMTQYoEwmhsM1mAGfM9KVNW53NCqq4QB42tCjbCdS9M	14069	3NLFnzxs4G5pSZHPaH6VTcut8RQhdzGPDL92VUW4yQhhnhVziJyb	43	944	216	6301	10218	jwibHVP4Twfmbqg6F6fwHDSdG1AGfeET7jF111ToeVJ1aGeWKi1	7201	10198	10198	1617774840000	orphaned
14075	3NLPd62fqXDdpREzv6Laa3N9zRQePaMRjchgbMeMCKsNeLG6RR1v	14073	3NL9BGWCHXLbhWEKTPsCAMyR2RDVEKaBGGUY1x1JeJ5ovkDkbA8Y	1536	1313	216	6301	10221	jxyHSQMjx2qzRGvtzn2DpKN9x5mn1mvhRgZTDoJZb67WPqxJeDQ	7202	10199	10199	1617775020000	orphaned
14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	14077	3NKLsBWQX4ZYXxwjBPqFtH4QGtJ9bvqqspk8Q2KBryN1wygKFVin	1407	1395	217	6301	10229	jw8D6o3zdsEwzMqnrEdpB7KJarn9RniXHZeDjjo6Ne9fG5ZphGM	7204	10201	10201	1617775380000	canonical
14086	3NKPAs7iejeHvYSS9DTHN87JNmGpGXpD5C5foDD6QYe3t4xxfAaj	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1406	1393	217	6301	10232	jwAJubshAdtGtWWSdqcN7q7T6VqpFPJX6sPXPB5pdUADhWC1JW3	7205	10203	10203	1617775740000	orphaned
14090	3NLtanB4xYueuLfaRDGbZo8QcgTkQmzuwZ88j49UozNuEphV1mqM	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	1589	1286	217	6301	10236	jwAg3uQjzvinihxMbpRXSHrhTBGiuq66RryRb7kvfigtehqVzpJ	7206	10204	10204	1617775920000	orphaned
14093	3NKwCgZT2mVMVwkADHR4F2Ncyu49khRh7Mfgdt4zgq5zbxmAhQqG	14086	3NKPAs7iejeHvYSS9DTHN87JNmGpGXpD5C5foDD6QYe3t4xxfAaj	633	1018	217	6301	10239	jxdDQ2STpPs2ATRS6uGimSrhxvptSdhoAqaqLaGSkrAZeR35WiB	7206	10204	10204	1617775920000	orphaned
14094	3NKwDX8AFcUZJV4nXBBYFkcdbiap4JLrKeFxJ1uNPyNUXvmJTJ8Z	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	1549	1116	217	6301	10240	jxUFoEDuC17a3pkNYcs7nnBjMv1AR5zoqMg2HHZZjB2ETqT5nVg	7207	10205	10205	1617776100000	canonical
14096	3NKPDTwYWrgEK3enpZwLvG6Q8MUy7dA4NciXshcFcACbhmXY6dH2	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	1631	794	217	6301	10241	jwoxNhYSftkJq67h4aYKjv68HKQmYXuvHGRSdVc98RzJK6Exqaw	7207	10205	10205	1617776100000	orphaned
14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	14099	3NLazUZW9Govqtza9znGJVhBZrK99vPJbx2sNs4xXgi8LQ1pZyWR	1594	1080	217	6301	10246	jx8HiLxbFxBgfiefmo5hFDo6pYzXQ6KEeTWR3g6gkfwJHxch9Pq	7210	10208	10208	1617776640000	canonical
14106	3NLKWX4x6CwAcxi8Lv3GNyDDhMgW4U7TXRcb3VVLwruPhZYFwgLt	14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	1652	1315	217	6301	10249	jxXZkTostWT9pbY3ys37M9R676WVsqLqRfZc5vKGRQDay8a9tfZ	7211	10209	10209	1617776820000	orphaned
14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	1600	1372	217	6301	10250	jx4QovGaKSGd3fQumKcufDVG4ekb6NLpXSVg9k22ym2YDnfmz1t	7212	10210	10210	1617777000000	canonical
14110	3NLf5ntSo3bu9HazaxcMfJxkAsCcAWWwbmSB9iVYLxRhBfV4Kc1h	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	470	1309	217	6301	10252	jwc8rB5T3bDCvFQYcAS6GJ4QePUfEDAJfhhC59bPDuhRMehne4e	7212	10210	10210	1617777000000	orphaned
14112	3NKCbVhcEa4p9Js4cphrnr2eErTMN8n84uULPxMdZXbLSrexBJ7E	14107	3NKnNYBXT52ZmgcXHXUGdgvrs6VZ4njQydEU3cjcvsmBsZJ4PeWV	1617	922	217	6301	10254	jx27USunXr157nKt9C2jYoM4xFrJ9EcFWjJyFRx5ABgSr4RYRLx	7213	10211	10211	1617777180000	orphaned
20716	3NLAa55bBCkeW7H1LTwS619Z5PKbyovXPhg7gLBDRspNQXD6VPzM	20536	3NKBoHpawZ13QUTmSMaY24RmpDRdAXQ94NawR4gboU2aL4iZ1wCG	1643	1299	365	12463	13015	jwqwjLcW37Ng5d8XFs91s5fd7cDSKwNaFrF8V7aKrvgucVFZT79	10188	14681	14681	1618581780000	orphaned
22155	3NK79Atnns1qrbhVsXTfJAXLQGUrp7FT2B6YLVqTAvBrsAUsx5W9	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1654	1214	408	12463	14283	jwDcte4JgaVKoAUudvycFEPSKwxqeHqAaUJhHwa7ahNg5u6LcpK	11083	15605	15605	1618748100000	orphaned
14103	3NLWLMyvB9ago5pi5BFLHaCMM2rPvj9W8YtGpUdUymhEiV1FCzEF	14018	3NK3RZQo1Tu4fXgxK8Xp8P29x3KUxPi7YiDMDVsDCteNR65L24ii	1650	1249	212	6301	10247	jw7pSrFAnMJnzLeM9RQQkPchhukq3JgYj4KRKzcyBcGUymBEFi4	7132	10208	10208	1617776640000	orphaned
14081	3NK6yGRzHNUbFf4rYAD7QTpFwZR27V5y4ynyxtcqTE55v6XJN8tQ	14055	3NL8X5x1pmHs54PH45udukNGTjz58iFvfRzMShR4mHXbcQpXxMxp	1405	855	216	6301	10227	jxTFAZxc1meyozuCRqZBrmmKirktJBRza8knnEEWma9eX6ezYp6	7197	10200	10200	1617775302004	orphaned
14082	3NKtZpgvpjD4pJX1WrKcaFp1Vxw7TT7gYxE1X7m2gLbNVMK2kNJL	14072	3NKf6r8cMwMTQYoEwmhsM1mAGfM9KVNW53NCqq4QB42tCjbCdS9M	1405	855	216	6301	10228	jwtoTDAR8BvH9PvpnhXFUPASSdu7xH1reeGqKB3KDnyeJYXnvuF	7202	10200	10200	1617775334868	orphaned
14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	14083	3NKzjE7ESGE1BPzqUy6vbY8uPJU885gYzbcmmK5sXHPuw9spFBE1	1624	1088	217	6301	10233	jxQwJZvunwwNuNE4h3pXvrkZ1jpJN42EifShEBBsfinMoPWuDCi	7205	10203	10203	1617775740000	canonical
14092	3NKzwNwJXptHojhjYmnNz56FvLdBvh3KD3p5zBt2tzekgXFayMk2	14087	3NLiFAWqVBMWzBjiwvxf3SsvGFHrmE17ABkEWDu3EzhUc6hzkWAU	633	1018	217	6301	10238	jxQJSdG6us5zUZxrtMYj2o5yBwKZVA9JGtoUGaoNFcbUkiaci2R	7206	10204	10204	1617775920000	orphaned
14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	14094	3NKwDX8AFcUZJV4nXBBYFkcdbiap4JLrKeFxJ1uNPyNUXvmJTJ8Z	1407	1395	217	6301	10242	jxRjDRGubBMMzYbb65FFrYmtqhED3cXmY9yjYGmyyH8RWRanhkr	7208	10206	10206	1617776280000	canonical
14100	3NLudZvrxqyC5Jf4uDpXSovEjQ2Re4oD9ST7VKHhk2EqhJezrkn7	14097	3NLuRbRwojkQzUpMGhz9C4Gh2QhrJBzNBq1KDTwrrEWhsUSjzU9J	1622	1356	217	6301	10244	jxb4nZEq9rcAoqC498PfQwQDWJdGpRibnvmRAVWKWu84tmpfvYo	7209	10207	10207	1617776460000	orphaned
14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	14102	3NKX9Hym7U9msZbLE7vKvp4DJHzcK6GG9HfuEBMaavS7JZ1fEbPy	1406	1393	217	6301	10248	jwxVnAabEpGAgtD4Mz3Y9Qua3NDM4SwMoxBZnPDzTMpDS2uNWao	7211	10209	10209	1617776820000	canonical
14109	3NKMWhBHaEGN1eQFDpj8z6zPGPLQaFAnCR91PzaiXwDT5yrCGDTw	14104	3NKDap6bfWmWWM5sD7SB5nBwmpugmte6GsDyLzLe3pY6i65dUwyE	470	1309	217	6301	10252	jxhs22VB6CFWn4X5dbQDN7s6vZfkKehSzjLupFtMxFXjt69NaxY	7212	10210	10210	1617777000000	orphaned
14115	3NLJBYsK7YnMWxMe9SSvTSSzHdhW2VmtMody1LcJvr3oYRWpcdBC	14113	3NLpGdbbSUw26LPdBcxFoBTb9hhtgdr89vQecFQD1d98Gv4jdiba	1559	1107	217	6301	10256	jxJQfFQ1UXtSYSgsnvcUt4SM43dcXJUU5eouR9iSodrUUjBceyX	7214	10214	10214	1617777720000	canonical
14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	1651	935	217	6301	10260	jwWyGCHDRwNQQsgA5XsFK58k7SFj4V66Pr3kc8oSEsK4QLySdED	7217	10217	10217	1617778260000	canonical
14118	3NL9qXCekv3ft7dM2dqGsfMZxjV1wGuzXQGeAirPbSWDdBwSE6BG	14117	3NLhXzJSnK1Fzcw6HbP8myDGrCkPRGgDA5zfTr5xePvKwpGfaTNz	1627	1385	217	6301	10259	jxd6j6tJDbPRnitJdVoLyFSBibYeWNXN4Yqnsq3WkVXpzTrji7C	7217	10217	10217	1617778260000	orphaned
14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	1547	1378	217	6301	10261	jw7QUXwGwKaxwfSK2cpPv8uSMy1xrgeZXUFerdg6mUJTckvF7wL	7218	10218	10218	1617778440000	canonical
14123	3NLQRj8psG9iEH2yicViietBLJ6SNpW55nbvokMbcvPJJeFJvr4M	14119	3NKMbJtu9VAnuiSiN9RNV5qVAvEdkH4aXtYp4yYPdEy7CCS6AeBb	1594	1080	217	6301	10263	jxepivmdoSagLurSUG4WpL7gJyA2t3noQu4i5henUA7yS1rdAd8	7218	10218	10218	1617778440000	orphaned
14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1402	852	217	6301	10266	jw6hfFR1XgYZv1YroYz4wCuxxywvFXtaDq931uaUJFn5Mg5DAWW	7219	10219	10219	1617778620000	canonical
14128	3NLDR6az15bMDghzQpytyNdUorP2QdCNf4jzwRoA5S417MJyGRW2	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1637	816	217	6301	10267	jxHR6ch8eeA9tbbM5HDAhb4HPcXE4pTLTp6dqS5PJn39GXmV1jF	7219	10219	10219	1617778620000	orphaned
14130	3NLQWf4emsoWqnL8pxHu95fmXCRpg4EswJaZ2qQNW8w3CHuNshba	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1445	1290	217	6301	10269	jxPoosRkUp3ZeyaHekS9q7LAfkbnLejdYvXsgnwSmfc7z1XxQSZ	7220	10222	10222	1617779160000	orphaned
14145	3NLsDcR5r1hyD7YtzYALBz8Yj7nT9L7rqndZaj2LXKX8uou5wgHd	14133	3NKTWHPLf5c3af12HdDP2ojhUN4WWzZd6BcF6CMbMPpU3kAKTPKw	1508	1021	218	6301	10280	jxR64G7vJrfyna4jvd5HBk6656GWK2QDUDrnhiqzjAVnhP2NWin	7221	10225	10225	1617779700000	orphaned
14136	3NL8fL2p373ja4xeqwp9MgNd1tMWbSG4CGi4jU1rC1V1hXSM1RRU	14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	1607	1222	217	6301	10273	jxFaqiWGh4DzmgNwNwJ5APTWuVkeQJMBYhM2bMFQAu3sYjDSKqV	7221	10223	10223	1617779340000	orphaned
14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1451	1292	218	6301	10275	jx97LaFdKPiokHToR3G2t2BYoy8KLms39qTWKAMtijtqXxcfRJm	7222	10225	10225	1617779700000	canonical
14141	3NKJ4513fR1bbVmWQf91m9tmubZNNCL5BZ6f8E2gcJBuMQDz91bJ	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1642	1001	218	6301	10277	jxpedXPg8zbmq33mBThGT6nvTJhJFxfWgnMhhSq4GbMfkR5erB4	7222	10225	10225	1617779700000	orphaned
14143	3NKFuJzskg8AdWLxnuXT4dCfG9PTgbzDhZHSxgvEEYpCSD83Jdfk	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1539	325	218	6301	10279	jxoSnth78HyMNFPnccSdJaZczU31rUxWrxQKrKSpW8PZohin2xm	7222	10225	10225	1617779700000	orphaned
14146	3NL77c1uJ1Q5WavHbPhrKBgpk3HuWYFiXhCtEmKRqer9tQqFmwH7	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1444	1135	218	6301	10281	jwC27PPix6Rc831QUCXUB2AqSgddLJXaUsfYtVynyE8jWLJWzHF	7223	10226	10226	1617779880000	orphaned
14149	3NLm26Pz39y3omqckgeqcdqudPcb87F7taTGYFPAGL7J54k62Ahz	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1541	1298	218	6301	10283	jwLKRrJACVdxBZKgK1emxXf1RJNz8Lhjt3DoaZbqGawCXxD6fTo	7223	10226	10226	1617779880000	orphaned
14153	3NKkCWJXPoTWUftKV1Uy4id7sYrnw1jTxqCitf6xzqkGiWBDdN9D	14152	3NKZG2wUiphir5Muc8VQ6tBFHfK8sBR3c2GMHb23TCdSiWiT4a3g	1652	949	218	6301	10287	jwoY5ByGP18LK42fWtefBDnAHwhm3jifNAZdVSUgExWpBVSihP8	7225	10229	10229	1617780420000	canonical
14162	3NLvWUXFwZQyAL3ZVcbbSASVa9WWAYP1bdpXtAdzzdRnijwcnimH	14160	3NLnqRCrvZXbBPj1TWhdAD83Zq8kkcfUJuESL4cgfxSyobWTPJ4u	44	1199	218	6301	10295	jxFV5J7hvqZafGaQsbjvAGpd9cd6jN22x95jLkdea12D9D9w6gj	7228	10232	10232	1617780960000	canonical
14165	3NKY3CZVqC121G4nRSFuqDX1Wnsh955vriBj6NqAVxXMmVJiswgn	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	1407	1395	218	6301	10298	jwK7nbVkitJQrtZbkCffyaTJK1C1cFyWWgm4wRD1xLnFdjewLwQ	7230	10235	10235	1617781500000	canonical
14170	3NKgHDbiJdtW5sKGU9ooq64VvtHSpYocEgHoS67nxiPEKprFrsvV	14169	3NKvJ7H6yoqjTi1rVqdP9BZuXpQ75KRfoB2UYpQFjzMiKfGAGxni	1619	1275	218	6301	10303	jwJRki13dXRXJ1CiaJJbWcQVtJmL4PybgSrZ3TtACXcNDG3X6Ad	7234	10241	10241	1617782580000	canonical
20243	3NKHFsmkRP2Lbpfi5q4v4xwkNRRteUryKDqLmgxAbYA6tZhT72St	20242	3NK4gM2239yJBZgZveBdoyCzhKL5zdRgGDCoqvm6MVicC1597Gx3	1406	1393	363	12463	12584	jwYeURKGx62LGeddDNMQs7RkeQpX67P24FxKrdeJYEVSfNEkDss	10193	14374	14374	1618526520000	canonical
14155	3NKobMTu6iyc6S2ic3jStuo5GFxzy4gc1ckxbodRAxpNsVBV9cMi	14064	3NKMt6VfkfH9VNHRVvvgA7YBghcudNgN6RbqVtHu3zGm8oSmLXQJ	1451	1046	216	6301	10289	jxEVMfh7duA7bXB4eMVeJJSAuzuVcD84ufvVTaAHekD4Q9YHsjN	7199	10230	10230	1617780600000	orphaned
14137	3NKtyFEoEPWKtCvJM4jVxfKphxdH6ovAfvMNWPyzn7Z4WiwKFsis	14129	3NKdZDged1WQjxpms1E4BrSRNQa7keixY58NfcDyr7ZpM17zyQGM	1406	1393	217	6301	10274	jwwSUhQv3441gswPMehKX7R2SBdRHfuWjDtxjzsS3nFv7VBnX7b	7215	10223	10223	1617779340000	orphaned
14158	3NLqBzu24iYsyAjxuY7ZkNxhmWX58FeTBep2xTJMjJnB6s87SHYv	14121	3NLkQk3bVgTLeqXj4NdzxbDQEH5dsXKvQnepG72m3eMpTWTtNYNT	1451	1046	217	6301	10292	jxknQAum81FTCrtRR6iBtZ1dRXkvRx5aZYcvp8kyChDeHuAZcrp	7219	10230	10230	1617780684715	orphaned
14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1577	1327	217	6301	10272	jwU7gnEgdeF5fkGNsbFd3SmzhW9t1aC2xiQwPy8cMQXyVtaE1RY	7220	10222	10222	1617779160000	canonical
14131	3NL1c7rydVZu84mc6NmZhutUjTaeBu2xhnL5n8KYSKUFLgLgmca4	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1483	551	217	6301	10270	jxRfK7XsizCLndd2ENU6TLGX7j26FygeiLaaDSA9eCHynwhXvWu	7220	10222	10222	1617779160000	orphaned
14147	3NKUSyeiECef6YSrQrjj2xn95nQQg42WfZDVtM794Af5ZUXNLui9	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1613	1103	218	6301	10282	jx9oujs8jfSEd2BxXvZ1zRFuC9TrStJDZhmgS4CeBndUXk8GbAh	7223	10226	10226	1617779880000	canonical
14148	3NKnYb7yuGaPvT2f1HpjKQJA7yyW5ZxWj45WgAnDjr9PRvgyR8od	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1444	1135	218	6301	10281	jxJ3ZTE94nLfqgNM69AsF3x6kRH9PRw7GteHdYfcWG2WpLFpcjf	7223	10226	10226	1617779880000	orphaned
14152	3NKZG2wUiphir5Muc8VQ6tBFHfK8sBR3c2GMHb23TCdSiWiT4a3g	14147	3NKUSyeiECef6YSrQrjj2xn95nQQg42WfZDVtM794Af5ZUXNLui9	1637	816	218	6301	10286	jxmNH6vAQbiogndbxBAppDQys6eYiYGJbuAf21uqWn53W8CkRQ7	7224	10227	10227	1617780060000	canonical
14154	3NL6Bz6tMMKBGWH4THw7D1YQ4mhA4o1p8mumeeZLZzRRUL8g59uc	14153	3NKkCWJXPoTWUftKV1Uy4id7sYrnw1jTxqCitf6xzqkGiWBDdN9D	1451	1046	218	6301	10288	jwoQKKGstHwDDvMTvYqF5GAwT5hvFzxLxivpNj9at6seH1Vu5sr	7226	10230	10230	1617780600000	canonical
14159	3NLaMdhCnuzj3KMg7UKDhSu2snaWE1cRHtJxuWAk1Wv47d8RYMMX	14154	3NL6Bz6tMMKBGWH4THw7D1YQ4mhA4o1p8mumeeZLZzRRUL8g59uc	1673	1122	218	6301	10293	jx7hj5gebekBLsmwG8taPXt51uvqKpC6BBArWwo3s43gRqw3TZb	7227	10231	10231	1617780780000	orphaned
14161	3NKzdaKqTXXoGra6AAJowKjHf7Lu86k9mQjGW1KEsDve5AfmvQfS	14160	3NLnqRCrvZXbBPj1TWhdAD83Zq8kkcfUJuESL4cgfxSyobWTPJ4u	44	1199	218	6301	10295	jxVpTwxVxMpoCqqqJD2pR4EjMjPMp6h3o18Ht5DaJqFkrv93RkQ	7228	10232	10232	1617780960000	orphaned
14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	14162	3NLvWUXFwZQyAL3ZVcbbSASVa9WWAYP1bdpXtAdzzdRnijwcnimH	298	357	218	6301	10296	jx2X1vo1BwysFQs7MNbnWkjKz9Ms6GjfAGZedkqZpCbKCuUfj9S	7229	10234	10234	1617781320000	canonical
14164	3NL3NTHGDJ18yaAARzhBdNcShueY2V8SU38gDicBxTjUbatiqMBT	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	1546	1213	218	6301	10297	jwba3rwNTgRoUbdob3maF8ASexiWbNPTGXTQxP6yVTAenfsDCZW	7230	10235	10235	1617781500000	orphaned
14168	3NLeEbK171dHWMHcw6HGyJro5rzeCtBUsM5iNdHbxiEk6XnPtvaj	14167	3NKRQRFtQKH2s31MEBpHgnNMfBjY1yUbxUXcmGnEyk9S8SXiLd7g	1668	1004	218	6301	10301	jwz4UPjmqADq3mo2V1kLFkStopXTBipBwEfTDa8Az4Lnf5KXSMi	7232	10238	10238	1617782040000	canonical
14171	3NKfaie7MAUF8BUsDBx99hx26rCiZaMEB2M6FjuPyFpLoYxBJvsX	14170	3NKgHDbiJdtW5sKGU9ooq64VvtHSpYocEgHoS67nxiPEKprFrsvV	311	1307	218	6301	10304	jxLykon3Et2UHqZag9iBAkz5s3Fe4G5Dk7han9LQJ8FxkbUCiE4	7235	10242	10242	1617782760000	canonical
14174	3NL9gFLXpNB4Nv7NTHPREw1juF4z7BfzaPFWofBRVkiZPdj5pNCS	14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	576	1355	218	6301	10307	jxoEu4J5bRrjhPPCtpwvk1z1tybxcd7fcQnnx3i2qj8XKcvQBSd	7237	10245	10245	1617783300000	canonical
14180	3NLeRdX3PXFVjMytPsuHt7hKF3DcwoKbsQjkScVecZxVutUXg3ci	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1471	1140	218	6301	10311	jwBHqMYMYcJnfFXCfJTNV1uRf823XJaAVZq71JpxLPu4THAQAtb	7238	10247	10247	1617783660000	orphaned
14188	3NLYZJGaZd2jWZxLv3afExveDEXWUfUPz2zJG2qjZDwkRVYmB1qe	14180	3NLeRdX3PXFVjMytPsuHt7hKF3DcwoKbsQjkScVecZxVutUXg3ci	1403	824	218	6301	10318	jwXyqHCy6jATkZn9roToFhwSpzAz7Y5ta79BXUk18iQUkGtpECQ	7239	10249	10249	1617784020000	orphaned
14190	3NLWsVfKBdLgVuQSbgntjfwAaGyZKPjVesaLpeKXQpKni4KbaxFi	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1448	1311	219	6301	10320	jwxye9H6Nwi3kt8whWKsJ1eqsMpnE3dEWHLrPuLSUWaAqjuKAbi	7242	10251	10251	1617784380000	orphaned
14197	3NLENQ4NZrrX3zGaKv3ZW88ooKZvAkSEpGCSHmJbtdxUcuh9yoFp	14196	3NLd2W3tkUHVTS6yVotNUL5ZN7BWrbU8WhN5vhYHF7cG44fd2sGg	1670	1282	219	6301	10324	jwiWeA4EQGNbre5VPRwD1X4h5tVAiY12CHsuDuHWtSVUzsmj2ai	7244	10254	10254	1617784920000	orphaned
14200	3NK4oPEiQhhzVEe83jJaR6ktvd6grqspF7vFJnxJofgsVDWPZM3c	14199	3NLsrqcBQTGx91EPPVmxbBEMySwBs6EdFavFMrpi99RNn9QxXPMM	1407	1395	219	6301	10326	jwySc7Zi3VGWrpL7PQqtFewgYmepAEN1y3AqxcKaRYScn8eXEJk	7246	10257	10257	1617785460000	canonical
14203	3NLT1U4TEoUdEf3pHBLKkePohb8nfDNkzc3EeU9rW4J8rkVJGuED	14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	1406	1393	219	6301	10329	jx2XgU4Qdosnwng7qDFGo9FY8jyDV1XqJrNSeTY8xvH23jKTn8Q	7249	10261	10261	1617786180000	canonical
14215	3NL6AndpkNFRosoyLmYeYsbZXZJgbDSbthCAeevg4srEPKMxcwLA	14212	3NL8FCMG1diAhfAN2TYL1WH7XJRi1kXhD1ag7e8qhESuizxujsQH	149	1037	219	6301	10341	jxRS82KkU2Y6Kr9jHMpRgui7iuMbPCt5CpSw8YEmSGoVAnSGpio	7256	10268	10268	1617787440000	orphaned
14222	3NKpzm42Q3HFvHAL8AGmQQHiJMYCV4PmunXx4YpMYv8PqD4x4pRv	14219	3NKMBfVKYFbyT75eKcq7rBNFpxsorgjWs52SvvYqE7AzoL8uruKB	1403	782	220	6301	10348	jwFpdvoZxZhrS3vktZY3W5uFXq45wK2dr95BMFZqbg4bYT4YDgi	7260	10274	10274	1617788520000	canonical
14225	3NLDfmpdLgtiJtg8YcoQCVyeKU3oU4QsodZpvZU6xtKvTP4z1aPf	14222	3NKpzm42Q3HFvHAL8AGmQQHiJMYCV4PmunXx4YpMYv8PqD4x4pRv	1403	824	220	6301	10351	jwKJtbdCee3AFhhkKYSdkkpdSvDcwTr8E9zBdot82Jm4wfhkZi6	7261	10277	10277	1617789060000	orphaned
14235	3NLvj97BWHDzhDaFGKh4Mg6rvWZkZ4Hb2C4QcB8vg5AvuqSWN5L3	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	1406	1393	220	6301	10360	jxWBGb6GKte42ZM7WfyMxNqTXMeW1NPaAejz4ZqhXVkB2Gtzs2T	7267	10282	10282	1617789960000	orphaned
14239	3NK3BcU44ZLyxoKTfaqAusvp8SU3RLrtnMkdzGG5VSfQdE8gofd8	14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	1506	1127	220	6301	10364	jwbTq2k2fNywLy3Sppv83vP3b9mySfpv6s1MUEgusxBU7Ap7Xmn	7268	10284	10284	1617790320000	orphaned
14241	3NKgfyDE2QJYppHeaVMjE5PzWiUeZHQvRRtZ4EhAhAmkXhi4wWdy	14240	3NKYNBHvoAG5UHZvPHPwMMJrbqmhhYVGYwS1VnrQjeXn3cwFoV5o	1402	850	220	6301	10365	jwAoVmYkzgg93Dx4H2Uuse9D7bkezAYGzh9Z45CTSZRwCFybQbL	7269	10286	10286	1617790680000	canonical
14249	3NLdjXWBzo3mZiX2HgBaxzDocAzwqzVVQEA59AAgwokMY68WLzUk	14248	3NLfna9q1Q8EY6iuqv2kPdR2meMFT7FBrL9mXcBPdNzYRDFDECQX	1581	778	220	6301	10373	jwAnJvpWLQDg1JZvazfFHkxcMNNY7yGnAi593dEQBkjuuqxniKX	7275	10293	10293	1617791940000	canonical
20249	3NLQPTR7EyVLCCW8gKNdtiz1cXXUqYZC4bKvm4ktXqgrks7nTCmC	20247	3NLQRsaSK8zSv7U38JQZjyvbfYLLThnGRmGR8Wn4GEqHubrBvvCf	596	1306	364	12463	12590	jwkGT1ewGs1RE3E2EZLCsJJMaSH6UXupkh16esCKizrX5jG7FFn	10198	14384	14384	1618528320000	canonical
14135	3NLMZ6iNo4KffTNK8Q8XKpgA5DftCyyskfA7BAsHaBYShpjv17EV	14126	3NKygS3iV7DWkBkhYeBKH29tUVPL5niTRhoYbzMMofq2G3XAoEJ2	1577	1327	217	6301	10272	jwU7gnEgdeF5fkGNsbFd3SmzhW9t1aC2xiQwPy8cMQXyVtaE1RY	7220	10222	10222	1617779160000	orphaned
14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	14134	3NLw8PeQS7k67jHBQsZjWusVZ1PeU8nma2wf76ZKqsgxhQpH2zDu	1607	1222	218	6301	10273	jxFaqiWGh4DzmgNwNwJ5APTWuVkeQJMBYhM2bMFQAu3sYjDSKqV	7221	10223	10223	1617779340000	canonical
14142	3NLrN3B45v9SkSzkxyTqJg6TMG2f6MVKN4K3akoZNLxCoxF7NN2p	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	1508	1021	218	6301	10278	jx6DBLpyxAuAmzp729YfHaag5deomrjZeR29szdLPdnYNCULCFF	7222	10225	10225	1617779700000	orphaned
14150	3NKtMwmMfKJU22qN62tJpcoHRtJ29ew2sEK95zv4GdPLESAyenbk	14139	3NLtS2s6m3FajYqsfoLooQg8nZyxExP7HjQ7DE3kHZmP7FM9k9FE	1633	1024	218	6301	10284	jx1Lp6THRzWmBQd7NgL9g5B6u7goQVpQeShmtasy5a1nwVjRR6t	7223	10226	10226	1617779880000	orphaned
14151	3NKqNwjHy94vqrFrw2FH6f9fD7keWC61YzV3rsfDVcg39GMsMFeW	14149	3NLm26Pz39y3omqckgeqcdqudPcb87F7taTGYFPAGL7J54k62Ahz	1402	874	218	6301	10285	jwXcfnmtMWEVEvfMmVK27hv1xk3uaJNUVPSqMAULmXCUE53Div1	7224	10227	10227	1617780060000	orphaned
14157	3NLZXP4mtfQhZLGwSjGiV8ZMpbwszoaXNHPEREa579fwRtqnZSsY	14153	3NKkCWJXPoTWUftKV1Uy4id7sYrnw1jTxqCitf6xzqkGiWBDdN9D	1581	777	218	6301	10291	jxxC6HwgNSsPkcG7uZicx17uNHGxymc26FnY5L1DQxB91yoQKT8	7226	10230	10230	1617780600000	orphaned
14160	3NLnqRCrvZXbBPj1TWhdAD83Zq8kkcfUJuESL4cgfxSyobWTPJ4u	14154	3NL6Bz6tMMKBGWH4THw7D1YQ4mhA4o1p8mumeeZLZzRRUL8g59uc	1581	778	218	6301	10294	jxHoH3Vtwefu97suvJg12FcSrBNiioobJ1bK5BNvjxRqnu8eStf	7227	10231	10231	1617780780000	canonical
14166	3NKnt7Zobxn22MjiV5QgKF3SafcJY2h7Syn55viyubfvQAc23A7x	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	1573	1318	218	6301	10299	jxrVnomK3cyku3CyLs46agD4nXKDBUJkzCHzBCifXA1zPEdEiJm	7230	10235	10235	1617781500000	orphaned
14169	3NKvJ7H6yoqjTi1rVqdP9BZuXpQ75KRfoB2UYpQFjzMiKfGAGxni	14168	3NLeEbK171dHWMHcw6HGyJro5rzeCtBUsM5iNdHbxiEk6XnPtvaj	1637	816	218	6301	10302	jwPpZ3PifQ5hhEF6vUdyybyAHowd47boLxqf7CMNCoRMu2pDj6w	7233	10239	10239	1617782220000	canonical
14172	3NL5un3Co8P1G2S8LMhgRHhcF8UGZbCj21JfQy19VD7RS8FCwswu	14170	3NKgHDbiJdtW5sKGU9ooq64VvtHSpYocEgHoS67nxiPEKprFrsvV	1524	119	218	6301	10305	jwDcFKkKWZuPWo56TwNf6mqcnLbgsVxzmWPGqGS1UmbGKQJbxqF	7235	10242	10242	1617782760000	orphaned
14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	14171	3NKfaie7MAUF8BUsDBx99hx26rCiZaMEB2M6FjuPyFpLoYxBJvsX	1549	1116	218	6301	10306	jwRo8yjvBFxcXqHTwxvYy4YPKvLXR8wf3x5SoZGCUSjnJVDiypW	7236	10243	10243	1617782940000	canonical
14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	14173	3NKnNya7sBPfi7cTKpoBCPd7CvGpiJzLWpaD9kSbfN97E7Hzk1nH	1461	1271	218	6301	10308	jxebi3og3j3mt77g45uXKkeuAqkus5yzoiPpgGR6qsAKBs3sBAg	7237	10245	10245	1617783300000	orphaned
14181	3NKdJZN9oLwBU45TLotTsRBZg2Aim46sCwuozYAvB2ZznyFqgwFu	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1599	921	218	6301	10312	jxvsaiBCKtJnhsdtwPvEP9SHMWu9eTLu4KKtgjwYyYQokPdpWdH	7238	10247	10247	1617783660000	orphaned
14213	3NLWxyzZ2hAyBjhmbFkYpdtxFQn9NkwQdDUzknvj685MmB8kygf4	14180	3NLeRdX3PXFVjMytPsuHt7hKF3DcwoKbsQjkScVecZxVutUXg3ci	1444	1381	218	6301	10339	jwBiDov7yFuwP62jMviRPtrqwXJxq5UUj6dsLNr6DHnaMxVH5Qj	7239	10267	10267	1617787260000	orphaned
14194	3NLLUU7VKgDBJcgxJTfytPn5QZoP8NJ4uTrGFyjPAcKZQC9z4Fff	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1622	1110	219	6301	10321	jxpC3fxAb6QCJEKsCcgWwxTcwGfz3HeBRDZFVTsKy4DHj6GKWU8	7242	10251	10251	1617784380000	canonical
14191	3NLw5XXzW6ZawbZZt6UrzbYndrBGtn8Gv6ex3Hfukt1eM21XeF65	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1448	1311	219	6301	10320	jxpTew9Nb5XZE2twSWVDYsmA7DbnZ73bJZ52DN4MNZNq41G92uK	7242	10251	10251	1617784380000	orphaned
14198	3NLiZggj5xRjP1PUyad1YWxUKJHz6KMkMfDgHYKLidkvHicqSYAW	14196	3NLd2W3tkUHVTS6yVotNUL5ZN7BWrbU8WhN5vhYHF7cG44fd2sGg	1670	1282	219	6301	10324	jxACjuYP8L6xqw7jkK3a5stDWqDPEBAptHc63SmkRwXyTBTEJoi	7244	10254	10254	1617784920000	canonical
14204	3NKwHhfgkwbJydy4Qxa9m992Um3GKnje48STuFNPdGFTTE9rizxn	14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	606	1295	219	6301	10330	jx6Sguv5EiQ8u1nzQWXgYAq9EimJS7VyRZg9oS7MgFJ9tsWTRnd	7249	10261	10261	1617786180000	orphaned
14208	3NLG5LeXmu4iMJDEUiEMnh9EQoVBKqojxC47vGapf97yJGN2T3R9	14207	3NKscVJ91xsHoNoD5nNmaftaJnJmuENqGpZme3AtVR9NhTSwA3ai	1407	1395	219	6301	10334	jwaJdUsCNLKsoVBUzaARN6q28rXnsDpJ56qnSQfGhVQR52oiVsL	7252	10264	10264	1617786720000	canonical
14218	3NKUFBYPWsc9CAdBMJNe1MpNEG9uLc1u6iqDVuy3HEpxq8Bce7VA	14216	3NKyxbUhVxzM1hHnFgkrfH7zEUzwPpAYqeMYHoSamCHiCUh8bmf1	1406	1393	219	6301	10344	jwL17BGDVN9NqURzSG4TbVejJ4jFAbjKAMYyjdD9Cw8RCbT5FZL	7258	10272	10272	1617788160000	canonical
14221	3NLKJrmWrMNXoVuC4GdsNsnchLQF8Wvgye4gozQ2EYeBKWw2pSVJ	14218	3NKUFBYPWsc9CAdBMJNe1MpNEG9uLc1u6iqDVuy3HEpxq8Bce7VA	1637	816	219	6301	10347	jxZ9oByXHqa41Ht52euG7iaw3QEb4ysbPwdStZP9vxyP3Ti4gGx	7259	10273	10273	1617788340000	orphaned
14223	3NLK85dNgMMvH2UX8hfxkwgtgZH15PgceXNbYy4oQVzs5zgZapNp	14222	3NKpzm42Q3HFvHAL8AGmQQHiJMYCV4PmunXx4YpMYv8PqD4x4pRv	1637	816	220	6301	10349	jx5RnfSao5GsJY5JtyJQ7BEWgXLKiPH87JtsRHiMbWPNPqtuUK8	7261	10276	10276	1617788880000	canonical
14228	3NLgqChYNELhjArUz1QeSB1pJHxq21m9ML2fvevJi3b8AwtkkjSU	14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	1440	1377	220	6301	10354	jwu5QLdEeEeKF9HyPCMFzuZULfjQrhdiebd8quoMC3SgSKjytQ2	7265	10280	10280	1617789600000	canonical
14237	3NKsENGLhzeguB58zrqMZ9zF899RGVFEjVvxasFtxL5oTbdcdxt4	14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	1593	1220	220	6301	10362	jwyQeJ6eLHvm1XfLcyB5cjvtR6YdDxysrv6kYYpUkPng5Xuv8VJ	7268	10284	10284	1617790320000	orphaned
14243	3NKUMmBSqDatmYyMAD8rGvnimYtSu1avNmcJxrsesAGqTRbm3whD	14241	3NKgfyDE2QJYppHeaVMjE5PzWiUeZHQvRRtZ4EhAhAmkXhi4wWdy	1637	815	220	6301	10367	jxZ2AVxkzC6eczXN9hbsm7ewjuqHnLZmR8pE33Ri3J43i2bn3EJ	7270	10287	10287	1617790860000	orphaned
14246	3NKXYndrD1pT4c145UswvtdwAET4hXyRpCoqmkL4f8nNuRQHQUAD	14244	3NLvepT72im7vwpZHixdkAUQPh3Zv7oBiYaE6ZBFYcxeBbYRAgBW	1553	776	220	6301	10370	jxnKqViHMhUWB9eKgCYrULQdnKzvpWkqLynRkX6tthJdQ8NUseG	7272	10289	10289	1617791220000	orphaned
14248	3NLfna9q1Q8EY6iuqv2kPdR2meMFT7FBrL9mXcBPdNzYRDFDECQX	14247	3NL2d5GYZs1ZKCXZV5YRBs2t8VzNVoBF3K61a5KTQtPe9EjSoGiq	1407	1395	220	6301	10372	jx4WtQ9aobZvTni8K4VhvfSGSQdTAH34xpugq5tfg1odbYtQGqt	7274	10292	10292	1617791760000	canonical
14251	3NLcjZ8nego175Jhg9eywbuRJH1UyepJsTJEskbtQM3MZgZhrZbN	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1407	1395	220	6301	10375	jwqbPMK9Hgna2ZorLyua9eqMJHemk3om49UgrtJZLFmbhBG5nns	7277	10296	10296	1617792480000	orphaned
14258	3NKEvVpu3ZJogcr9fW6j6rSXFYnEDkb249Xhr3FmhVDsyQDNb1nh	14257	3NKTMm95aPbt1nsbiRGdH6Dy2xhFZehMXJd8TwAnpDmparxNJhb1	1622	1230	221	6301	10381	jxDypYHYg2gEULSbdcszMC3rU7mUU3Hex5RGLxfWrxoFL1sQsKp	7280	10300	10300	1617793200000	canonical
20272	3NKnuTn3WpSQT5eF9t3yciZWqoVYfE17SZ1daq62RaeL2u6GVD7X	20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	1534	1071	364	12463	12610	jwxs8uZUVuWwRVVzVJB3k5ZmE8qVpKrF5B63wFvRubgT28CZVqj	10209	14402	14402	1618531560000	orphaned
22664	3NLucMvdfhdA3D9QJQPAA9p7GMmGGTLRwdbRJsjyGB11edJVTbJs	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1637	816	408	12463	14748	jwgUwhN8j38fVawBe4mBUWrbrzbtuE4tZ6epdhaEh2VyFpK3eFs	11088	15954	15954	1618810920000	orphaned
14185	3NKM4h6kHGhiPooGzMeMkbf2CjJPQfpJauPdeMJEfdkQfGLVZ2Lb	14174	3NL9gFLXpNB4Nv7NTHPREw1juF4z7BfzaPFWofBRVkiZPdj5pNCS	1471	1140	218	6301	10315	jxCFjpxXrYJSUeAZWPJpVZk4kTWRjb348Az9ZypeUJUeMaBjFGS	7238	10247	10247	1617783660000	canonical
14179	3NKdPaUbEFNdCFMJ3o5W5Smrby8iXN6AG8LaEfdr32rCHCK4zU2G	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1602	1243	218	6301	10310	jwMXqHMF3o4vis3tzVH4bKwC5Gsj3eAG3pXyrdCBPi4XB7TCN3W	7238	10247	10247	1617783660000	orphaned
14186	3NKtiVJhuhppz6NZM5vovKdg794rai2n7eru3TaHuCyREY5nF4av	14185	3NKM4h6kHGhiPooGzMeMkbf2CjJPQfpJauPdeMJEfdkQfGLVZ2Lb	1476	1125	218	6301	10316	jwMUiKuFUszF3ieHwnncWQ1jUZfRKLcyRysvFpEWV91gSebWvtT	7239	10248	10248	1617783840000	canonical
14187	3NKtpp4Pxzk6qtKE3eGhnFZaFCFuC8QcgX6mJXGzY6gXPDSsYDZ2	14186	3NKtiVJhuhppz6NZM5vovKdg794rai2n7eru3TaHuCyREY5nF4av	1406	1393	219	6301	10317	jx93jDkRzHB5iZpZYWmPZcKTqZJSN22RKkuYah6wGPkcwBebege	7240	10249	10249	1617784020000	canonical
14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	14187	3NKtpp4Pxzk6qtKE3eGhnFZaFCFuC8QcgX6mJXGzY6gXPDSsYDZ2	1407	1395	219	6301	10319	jx1sjTy2NA4Jfy55ePTAQo6SkkTPUvJC8XoeZCMTzRcuJVnCk1u	7241	10250	10250	1617784200000	canonical
14193	3NKitN2W9S6JSqdwZ7qKN96HZo8AGds4oo1CFW3GkiCPZgCQYxRH	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1440	1131	219	6301	10322	jwJBsE7kxBfhvMRJ1aQX4S8R5J2PDFfFYJL8B8pLgwuBBKxX8d7	7242	10251	10251	1617784380000	orphaned
14192	3NKxykhzfyERQtfsLtXyRngaHHRhd3ePg87ytwmXrtoRXT41S5yu	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1622	1110	219	6301	10321	jxdqrgUSpdyVb1suXxfgcfgHGMvotzYCRRH53yVrSHnCCZBA7fD	7242	10251	10251	1617784380000	orphaned
14195	3NLTKMqSgGZVmU3bAPBSPNGajkC9B1Z6ZLkCBPA7V9hUR4BBKcmd	14189	3NLL6X9LRDV29vxxRFLiSB8brEBdEzYd7yg7qhpW4kxgL8TGEB7Y	1440	1131	219	6301	10322	jxzL1V7eoBoQQLnURzXhqup9Zp2HKXE5f5wECiAQyCGtBET9J2F	7242	10251	10251	1617784380000	orphaned
14196	3NLd2W3tkUHVTS6yVotNUL5ZN7BWrbU8WhN5vhYHF7cG44fd2sGg	14194	3NLLUU7VKgDBJcgxJTfytPn5QZoP8NJ4uTrGFyjPAcKZQC9z4Fff	1675	1216	219	6301	10323	jwvemak4oQ9bsgXivQ8uUzr7GBqiUUzZzSYDnVKVF3Q6NUdHnhQ	7243	10253	10253	1617784740000	canonical
14199	3NLsrqcBQTGx91EPPVmxbBEMySwBs6EdFavFMrpi99RNn9QxXPMM	14198	3NLiZggj5xRjP1PUyad1YWxUKJHz6KMkMfDgHYKLidkvHicqSYAW	1654	1094	219	6301	10325	jxve7V6Qj3u1mqBKdoMx7Aj6fjCVASnr4NqJVKznwwZiuo7MvMV	7245	10255	10255	1617785100000	canonical
14201	3NL79Garmviry9UdHWaVBwKNhpFr9rhha2GYkXWLqNE8TZePEzzM	14200	3NK4oPEiQhhzVEe83jJaR6ktvd6grqspF7vFJnxJofgsVDWPZM3c	1406	1393	219	6301	10327	jwpu553QfwQUu8zxWUFS96cqh2EStxZ2EseqGxQ9eH6UnV7m9bi	7247	10258	10258	1617785640000	canonical
14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	14201	3NL79Garmviry9UdHWaVBwKNhpFr9rhha2GYkXWLqNE8TZePEzzM	1397	838	219	6301	10328	jxZXBz4vSMqTfpU6v8bwtThcND4tX34ykFrwaNpwGE3i18CZHpN	7248	10259	10259	1617785820000	canonical
14205	3NKp56XgjhVETHYrJuwP8AimU6ubbJ55LouT36dBEHc8JLMzotkv	14202	3NK5ksEqKshxf9FyTq7Fx8E5wMXkygTucQyNgAXLoWCUKLnPd9ek	1439	913	219	6301	10331	jxDbbGLmMwAYbqygKbFUNRCmsMPuqfL5iJpQH6w9i63B2DVzHXE	7249	10261	10261	1617786180000	orphaned
14206	3NLtkictEDcXU6jWt58jerVDuEbKdZLE1UxHu8kTrWxUPdRcMpmj	14203	3NLT1U4TEoUdEf3pHBLKkePohb8nfDNkzc3EeU9rW4J8rkVJGuED	1585	1366	219	6301	10332	jweQ2QmaCRcNVa9PK28pCXT4vmH3g1UZKviGVU8tdWxdCicuecD	7250	10262	10262	1617786360000	canonical
14207	3NKscVJ91xsHoNoD5nNmaftaJnJmuENqGpZme3AtVR9NhTSwA3ai	14206	3NLtkictEDcXU6jWt58jerVDuEbKdZLE1UxHu8kTrWxUPdRcMpmj	1610	1188	219	6301	10333	jwGHZQzQJKqGQYdNsbpvFbRmGERQANHDhpn9ipzLbamhyG1qHk7	7251	10263	10263	1617786540000	canonical
14220	3NLM1DDeY3i1PmVYXDYQFSvR8ZgHaGHDvDKWTuaFiCPXh3QyKzxi	14206	3NLtkictEDcXU6jWt58jerVDuEbKdZLE1UxHu8kTrWxUPdRcMpmj	1623	829	219	6301	10346	jwiRLLR8zT4SUSf9DwbSkGkqvTRXinT8vvPT9rgDctbJ8hsKV5e	7251	10273	10273	1617788340000	orphaned
14210	3NKU7PH8nurKTAFkwRPbDkU1GTqDSgpz72TMP4XnuVoFV6WsZJsc	14208	3NLG5LeXmu4iMJDEUiEMnh9EQoVBKqojxC47vGapf97yJGN2T3R9	1406	1393	219	6301	10336	jwxMeep5Q72PPwUbufv7oYaPQSbYFrvPQo53Ek8AtuVRa3CVat5	7253	10265	10265	1617786900000	canonical
14212	3NL8FCMG1diAhfAN2TYL1WH7XJRi1kXhD1ag7e8qhESuizxujsQH	14211	3NKzgrKQEGqZyAie6EKKfMgbU2kQRqZbK92QDVscQLQ4hZ2WKsqC	1444	1381	219	6301	10338	jxY2oGiTNL7TCVyEomNCVhRait5H5wLDArsy1u24KFNpKjkduGP	7255	10267	10267	1617787260000	canonical
14214	3NLRkfzgu2tJS2nc2rPksmD3QgHYpZPqTyrT2QicrBJEUrKnaCCF	14212	3NL8FCMG1diAhfAN2TYL1WH7XJRi1kXhD1ag7e8qhESuizxujsQH	448	1305	219	6301	10340	jwppH9hwU9E4qtxEysGFjjyxp2EDd19uFcwcas2pnaYnT4vQMSe	7256	10268	10268	1617787440000	canonical
14217	3NK7a2KpYuVM6cX3mGTPBREEVjkXACSpFUp8quzbEky9gNemyzSL	14214	3NLRkfzgu2tJS2nc2rPksmD3QgHYpZPqTyrT2QicrBJEUrKnaCCF	1406	1393	219	6301	10343	jwGQ5XXUaJd8a1L9PdwxCLTAyBZWAt5jq6Lr99bysedq9HV2xSP	7257	10269	10269	1617787620000	orphaned
14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	14226	3NLjn3VgyTkBrWoPqEwQ4oXqRNqZikJmRUVpxRKQxu8Uax93r6QA	1513	1013	220	6301	10353	jxTB5BPh8ipzpq44Hkd6h3uTc2ByDTfzayRDMZCY3YvqcwpJVXG	7264	10279	10279	1617789420000	canonical
14230	3NKLRirJmV8GFyfcWWzKeNgNToBGkaE16En5uvAnFHrd6qKmbemy	14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	1651	1301	220	6301	10355	jxv99ZxFfq3CCfqqM9by3WnMsPCnnYuuakZtErphjEUePf9qdD6	7265	10280	10280	1617789600000	orphaned
14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	14228	3NLgqChYNELhjArUz1QeSB1pJHxq21m9ML2fvevJi3b8AwtkkjSU	1406	1393	220	6301	10357	jwmUt67y7SEendZ2GDFmCSw1aEYQSBw1VFAtPLCcNP1T8YsHZ3c	7266	10281	10281	1617789780000	canonical
14234	3NL4EXhqxDpW7JU9Amy2JMTVC4ru64z9vjzBJR2QkmuRwmz74ks4	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	58	915	220	6301	10359	jx4AhzyoiNAJWW5BsSFEVSyUCUkGJgFA9xXS4CzCw42wq1PUosR	7267	10282	10282	1617789960000	orphaned
14240	3NKYNBHvoAG5UHZvPHPwMMJrbqmhhYVGYwS1VnrQjeXn3cwFoV5o	14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	1593	1220	220	6301	10362	jxo8ffD3ShrenjFwU6aGAPPbMfoqjSqvoLzu4C78xiQktCxZuSH	7268	10284	10284	1617790320000	canonical
14238	3NLYg7gvjviziGeo9CLsejZ3RfGKp6FDqEKbAQhS6GvpoB9jEM1g	14235	3NLvj97BWHDzhDaFGKh4Mg6rvWZkZ4Hb2C4QcB8vg5AvuqSWN5L3	1506	1127	220	6301	10363	jxZEQCUH59bsXvomg3qLwKd5sZR8MHpJMwCuKYXfwiYKpGbcMvS	7268	10284	10284	1617790320000	orphaned
14245	3NKKnYc5hNt6c9mVfEQiXGz3WHhkdGi2yrH78bhSbNUmESihzViE	14244	3NLvepT72im7vwpZHixdkAUQPh3Zv7oBiYaE6ZBFYcxeBbYRAgBW	1619	1029	220	6301	10369	jxtA6e1cuZqvACNy9rHaCsEQ4MdmpUwxBrmGBsYTug8xwmBRfYH	7272	10289	10289	1617791220000	canonical
14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	14249	3NLdjXWBzo3mZiX2HgBaxzDocAzwqzVVQEA59AAgwokMY68WLzUk	1631	794	220	6301	10374	jxry9rv9E55Xb2mXXfeebjv5whh5TPyGNbAQuYEYdJj29v4W4VN	7276	10294	10294	1617792120000	canonical
20291	3NL7Fx2ZsfCdvsdcy5Fn7xqVScroU2MduRphzXW8P5C7zD74sXJA	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1448	1065	364	12463	12626	jx8517oqRR8TCYFpNZb8HULxfY6tax35B8adpJXMXWoQH1jHm5P	10216	14414	14414	1618533720000	orphaned
14211	3NKzgrKQEGqZyAie6EKKfMgbU2kQRqZbK92QDVscQLQ4hZ2WKsqC	14210	3NKU7PH8nurKTAFkwRPbDkU1GTqDSgpz72TMP4XnuVoFV6WsZJsc	1513	1013	219	6301	10337	jwtyxD4iGdyG9kb6xCL8WnjuDh6gY2RfwniGzqWrKTCsa4fscpg	7254	10266	10266	1617787080000	canonical
14216	3NKyxbUhVxzM1hHnFgkrfH7zEUzwPpAYqeMYHoSamCHiCUh8bmf1	14214	3NLRkfzgu2tJS2nc2rPksmD3QgHYpZPqTyrT2QicrBJEUrKnaCCF	1483	304	219	6301	10342	jwgcumqrPr7ZuQ9wWpGTTzStyUSqT9W4gRAhy59eioAM92TZitr	7257	10269	10269	1617787620000	canonical
14219	3NKMBfVKYFbyT75eKcq7rBNFpxsorgjWs52SvvYqE7AzoL8uruKB	14218	3NKUFBYPWsc9CAdBMJNe1MpNEG9uLc1u6iqDVuy3HEpxq8Bce7VA	1553	776	219	6301	10345	jxnuVMRqgs1CjLuMriH6Dnyokh7uAMJcejY7K8f5LwL8ZJejdY8	7259	10273	10273	1617788340000	canonical
14224	3NK7kGooSB3ivkZq52HMDK2vU4VTX4qNcJKKCqNKwx7iTCeUgTrV	14223	3NLK85dNgMMvH2UX8hfxkwgtgZH15PgceXNbYy4oQVzs5zgZapNp	1579	1389	220	6301	10350	jwsmBhays7Me5ErduoSeitDCfLQTLSL5tAktmV95fP3eK5U8B49	7262	10277	10277	1617789060000	canonical
14226	3NLjn3VgyTkBrWoPqEwQ4oXqRNqZikJmRUVpxRKQxu8Uax93r6QA	14224	3NK7kGooSB3ivkZq52HMDK2vU4VTX4qNcJKKCqNKwx7iTCeUgTrV	1407	1395	220	6301	10352	jwC5Ju38WMSxe9oPLGrzKU4XPHv1hGyTNDvdjXhPrAtB6E1GTme	7263	10278	10278	1617789240000	canonical
14229	3NLC4KZ5r4cwJ4KPCNX89r5crHULDEYaFjW2BeeZzWKr642iSKn2	14227	3NLZPUycnAEvfzXWRurdHvb69RvfqCVgR8WcGucK4A9sVDWh5TSA	1651	1301	220	6301	10355	jwAczxGzfYwpLSGKZGYyamecDkcqo1fGE36cp9mqfp4qE9JCn1H	7265	10280	10280	1617789600000	orphaned
14231	3NLTWw9vhmqeqpmoUBTJaHboFH8A4Z1oPNRXkCFsY9SSxgqUDpgC	14228	3NLgqChYNELhjArUz1QeSB1pJHxq21m9ML2fvevJi3b8AwtkkjSU	1407	1395	220	6301	10356	jxzCmhXw77JV3uTbukmhYqmtbsNBntbmbBAmjqBoM4zfEEEKGSw	7266	10281	10281	1617789780000	orphaned
14236	3NKFaTtfeQ2wv3vdmtALoc3tbzdckubxkzeL26nz4K28h8CGZzxo	14232	3NKe8etv8VchEAiUeGnGthnssCzq2nU9K4DH5JgRw7nw6CyxWNB9	633	1018	220	6301	10361	jwSjUtUqtWzoFZv8kEmd4wLkn72CbXuuj2epfUAAWxsetce4hiK	7267	10282	10282	1617789960000	canonical
14242	3NLc1jJnhc5Xp5Bu2TMPpii8ebEFG87KokmdfR2kozCW1CbWYxvt	14241	3NKgfyDE2QJYppHeaVMjE5PzWiUeZHQvRRtZ4EhAhAmkXhi4wWdy	1675	1342	220	6301	10366	jwQvQFf3bC49KciMHLKnuWA97Cb2bEgHJfiE8rAj75s2S6jYB7y	7270	10287	10287	1617790860000	canonical
14244	3NLvepT72im7vwpZHixdkAUQPh3Zv7oBiYaE6ZBFYcxeBbYRAgBW	14242	3NLc1jJnhc5Xp5Bu2TMPpii8ebEFG87KokmdfR2kozCW1CbWYxvt	632	1382	220	6301	10368	jwpxg7rZ6vaGThhVVB7DWcqfuMqCRtyUpnG5pPFLXUskDKkLC1F	7271	10288	10288	1617791040000	canonical
14247	3NL2d5GYZs1ZKCXZV5YRBs2t8VzNVoBF3K61a5KTQtPe9EjSoGiq	14245	3NKKnYc5hNt6c9mVfEQiXGz3WHhkdGi2yrH78bhSbNUmESihzViE	1518	833	220	6301	10371	jxCkaZTuwNXqKmX7bb4tm4azRp6nmr5aTVcgjbLYfHvRNoxKjJr	7273	10291	10291	1617791580000	canonical
14255	3NLY9QcwNyUtAczZiYYvVoXqsDCrLEDA3p2PHZCnS3vt7qpyqt5W	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1613	983	220	6301	10378	jx3XqmezCkMHxQjAyawxU3SGTGdyQWNmjhvH9pzbjp2SipYRGUw	7277	10296	10296	1617792480000	canonical
14253	3NKU1GsC9md67GPdKEzf37kKmLBfVRp7DMFQQARYdgHC4kB4ApVx	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1647	1056	220	6301	10377	jxVUddvt7PeYH2L72fCpkjLprDvNGfsLsCc8Tw2axVWAKGjeSzD	7277	10296	10296	1617792480000	orphaned
14257	3NKTMm95aPbt1nsbiRGdH6Dy2xhFZehMXJd8TwAnpDmparxNJhb1	14256	3NKDQgvjUZM98hgjAyQdyxTavnzpCPcAi5i4Fx9HFrpsHFcj5KrM	58	1281	220	6301	10380	jwfCC8VSZQbJzJ48WLDQSKk4Ce4ULkaEa7mhehWuzQm9LQs9Yf5	7279	10299	10299	1617793020000	canonical
14260	3NKYx1yZBnSwzYMQb2QNFjqdpzMXk5JRBc3UEiw3ziqumyxWVbQ3	14258	3NKEvVpu3ZJogcr9fW6j6rSXFYnEDkb249Xhr3FmhVDsyQDNb1nh	80	1273	221	6301	10383	jwxCfQsUkvsRM51hFtTvUVYyjm7zzG2npkCLwQfRj9zoNiNAfLd	7281	10301	10301	1617793380000	canonical
14262	3NLJaxgQHoiwKGVTnvTc339DpYrcHtDzQps6WZ35gYXLoSJARRkg	14260	3NKYx1yZBnSwzYMQb2QNFjqdpzMXk5JRBc3UEiw3ziqumyxWVbQ3	1474	1329	221	6301	10385	jwacpnp5mwGb28LLtRga69vZQjTEXZSjjS6unnMoJGxNFpMje8L	7282	10302	10302	1617793560000	canonical
14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	14262	3NLJaxgQHoiwKGVTnvTc339DpYrcHtDzQps6WZ35gYXLoSJARRkg	1471	1260	221	6301	10387	jwBER1EvyYfEfPpgUTFuMFqtXnEgLUYvwAY9FPihywz6Zyvwq6H	7283	10303	10303	1617793740000	canonical
14267	3NKfueYDTqpEVBz2SxqyE7q6EzwtdGFanebSaLpe7Hz55y9GGLYY	14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	1407	1395	221	6301	10390	jxwFBaJhbJEoA5zzPp6KXYQeZNQBK3KumKSGEuKofFMPHAuzatf	7284	10306	10306	1617794280000	orphaned
14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	1581	778	221	6301	10394	jwqh33Yi845FebeRm67wfNEds6A7rtWRzVJrXVCWMAGdrC3Ke5e	7285	10307	10307	1617794460000	canonical
14269	3NKSuSaj9FvdYqm4SLecHjvcMgErBSu3zeVoAu9qexqByNyFZpoY	14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	606	1169	221	6301	10392	jwCTP4P2JpqFKaVFVX9ToatEvxE5tQ3CzZdyu59UUccS7K8NG9w	7285	10307	10307	1617794460000	orphaned
14270	3NL2xd2Wo2TZgqWTBhFfNhxeAehLUDyDxi4yYgoR5zdkfNvaMpjs	14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	1631	794	221	6301	10393	jxJAuDLu8WKCvY7yEtmHa6NwduMcrZGCy1Vz3amMSAAWdmkj7ni	7285	10307	10307	1617794460000	orphaned
14272	3NLGukMq3NsiyE5b9o2zMa4Y1cRSUP7YQNfjuKALzcudykzWFkpj	14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	1483	1276	221	6301	10395	jxzo7Dz46N5Hc251Az2aZJwBtYSBojtHNSksRGu5Wxj1pf5scx9	7286	10309	10309	1617794820000	canonical
14276	3NLaK3CcbDTtdwo8N91cojUz4QKBQEXXNCkomeKDpxZ2EogooRES	14275	3NKrjhMRyi1GUh2dbcXmnFpFwu2heMhqRRGLqch42zaAvV2Wu9qa	1534	1071	221	6301	10398	jwft1aYa278pP4PB7mTjfMPu1T2VoXAfgFWehieXQxBJddRbxz3	7288	10312	10312	1617795360000	canonical
14277	3NLLMHjvR3itDfwLAP9SyrdNGX6SDzZo3fwyNRiSvXrBysSMU4qK	14275	3NKrjhMRyi1GUh2dbcXmnFpFwu2heMhqRRGLqch42zaAvV2Wu9qa	1534	1071	221	6301	10398	jwt4JQgjbbfwoQkNvvpyLDPFHYurJTNZSfDyVWZj9zyMmg5JrbU	7288	10312	10312	1617795360000	orphaned
14279	3NKswhS6qbpM95u4KAiCvB6TfdaYmfZr2wbuwfdoA5NJg1Z4h6oi	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1599	1287	221	6301	10400	jxmnxbQ9FnD9oVSiRq4idCfPhvkoXb7v6fFNNDT5uF8kc2HP5k8	7290	10315	10315	1617795900000	canonical
14280	3NLXsrZyVsG1zm1CxQCaYhKu8uqzbe6G3iBcf6c3UT14MC3WHEsH	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1599	1287	221	6301	10400	jwfqdepqj7tX2JcC8tfWjQRGX9eEAQaGKGBNqhLxKGMUMQmTtVF	7290	10315	10315	1617795900000	orphaned
14285	3NKCmBDay77AVPLHm3vziZ2zaEFiCavi3oSuGWgkgLTSAuPZmGPy	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	1402	874	221	6301	10405	jwqLiqefVhJQjLFcxsdSnqRrnXwm9vFfFuSYxtieibBoEkdWd7w	7292	10318	10318	1617796440000	orphaned
14289	3NK5WCyonSzmd5mUNmbnEaYznXN1m8nFtXwEfdN4b7v6yxT8Fj2a	14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	1407	1395	221	6301	10408	jxKzR8fvRRhw8LjNtHJ8dPS9Zcb6pXtiM3P5z8nwHsEpS7Knoxf	7293	10320	10320	1617796800000	orphaned
14294	3NKB87SzCa2kdaGDpbJBmzTFRYqziEijssKc4HT6E585iZFEryJc	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1406	1393	221	6301	10412	jxqery8wFQ87o8bAPK1kja1gvxjQT61UX8QuvD3cead7Czp5pq1	7294	10321	10321	1617796980000	canonical
20292	3NLcSrucU9xwsB1GiNW6bzqAEuYPgg8giucxfXfTZgaY2qKWwcBn	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1601	1142	365	12463	12627	jxWyDRfm7HvfjArJwf2Dk7uqp9ANJS4hxHRvpK2Lys1CGX3MVHZ	10216	14414	14414	1618533720000	orphaned
14376	3NLTMCnL6wSN8CjdnkWbE9oX8KQRge5XjT57mgj6BjBMfyJMTFn7	14138	3NLFcgd8Z7it9XGaYqpYJjYxfaLo26KRa1zypER8B9c1Yn1WLD6P	641	1210	218	6301	10484	jwbEiKrWZQzxVhz9xMPVYsT8b3nWkAfcX88E7zm38vb4ADzYoQL	7222	10375	10375	1617806700000	orphaned
14254	3NLZcLkZQJ32FC2yuJUUACSYw53fyCjWWUSbMMUBSiHKWAwdwGM7	14250	3NKmrfnVHemevf3ji1Cs9fw4hkHHG3DfXnvsomSa7p52BjErYJSs	1613	983	220	6301	10378	jxNY6N7kMc7SiSYR3CvM3rLNQrZnmrmG2txQDPZT6LBEYNxa8wf	7277	10296	10296	1617792480000	orphaned
14256	3NKDQgvjUZM98hgjAyQdyxTavnzpCPcAi5i4Fx9HFrpsHFcj5KrM	14255	3NLY9QcwNyUtAczZiYYvVoXqsDCrLEDA3p2PHZCnS3vt7qpyqt5W	1673	1368	220	6301	10379	jwWfqXQasZtEXM9o978183uFVwRMhw19yddUuwyGm3nAbVkt6hH	7278	10298	10298	1617792840000	canonical
14259	3NKWg7pA38498JBNxhrYnj5M9zKm4YkrMzJY2HD43vctMnLL5J7X	14257	3NKTMm95aPbt1nsbiRGdH6Dy2xhFZehMXJd8TwAnpDmparxNJhb1	1508	1141	221	6301	10382	jxUMN32HeTBHsPMXZxDKji5iVZEXca45ZroL7Ft7xnE9r128hL1	7280	10300	10300	1617793200000	orphaned
14266	3NLCy88G7RgW9qM142fHXjsfBZ9ByssrPoqJyyREJZmVqqHseWr8	14264	3NLvWdQXrfWy8yn4gh1AtVhfVYVuC8RXgwhpnR6buuG9ifvjAQa6	1426	1364	221	6301	10389	jxR3445gTVV74fFDhu3AJewc3Qt9yCnq4sK7Vtg6Q12jQzejToj	7284	10306	10306	1617794280000	canonical
14273	3NKKsuuaKY79MmFHxLHC1sq5rBzo3GQssa4oBEH477THDyqBd2cL	14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	1642	1367	221	6301	10396	jwBCU8oDfTWSr9enFw1NsDdNFBanPpHfxH2c8SMyUJYAiiY6R9Q	7286	10309	10309	1617794820000	orphaned
14281	3NLDEJKj3pU5P3RZFvBMfA7W3HdTsS6j584PdKoxkZkCxRDgQifu	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1637	816	221	6301	10401	jxbvc5KoYiiNkDuebXGuY8F7sm4bwNVdKkuKNRTNQ1DsDYtYQ6U	7290	10315	10315	1617795900000	orphaned
14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	14279	3NKswhS6qbpM95u4KAiCvB6TfdaYmfZr2wbuwfdoA5NJg1Z4h6oi	1609	1333	221	6301	10403	jwwJ4ybKcwU7AjcmbnhWiSr446Cd7g7zojtUcYq53fxr46BajZV	7291	10317	10317	1617796260000	canonical
14290	3NLe3giykBqP5EkxVA9Je4LuAqGNDkHaAWwCuK9sSQDRiS26QGuN	14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	1627	1385	221	6301	10409	jxTFNfnXRd5R5WK1ufbXGJ1veSY3VuvKR4A1jmKj72ZA7C1hATp	7293	10320	10320	1617796800000	orphaned
14292	3NLy8pKGLKvdycgvoWC7z4oqqz75jD986zmgujonCVPpFkvredw4	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1534	432	221	6301	10411	jxqj9Sts2F5qjay4PWw4UsQnD4EicBnrWbLaYpa92Cuz7XrDfca	7294	10321	10321	1617796980000	orphaned
14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	14298	3NLAzhHeNME57BFuQYinf3MvoZwpoWZx5BB44UqXxZdDGT5W6nJC	1407	1395	222	6301	10416	jxf4G6LxKy7MY3jYazqm6ZVEj6gpMionZo4UeocxrHvyMJnGRu7	7298	10327	10327	1617798060000	canonical
14302	3NL8DnApsb19BjvUCqNN6RukKfaJjEErGXy3jayJD2pjgxwMP9kC	14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	1529	1070	222	6301	10418	jwvHrQWLdskq9PHTGFc7HZBHAG3gt7MXcm9j8mrwL31LdTvAJHj	7299	10330	10330	1617798600000	orphaned
14307	3NK7tyLNmF1GFtohGqdWs5Kb7oRBRboPKBEzxgTzt7uCCZnNBv6T	14305	3NLN3Bg5jgZEMwPLYNyEbxNg19dkBni7NuxfN8wPNn8ZB17K3fs1	1579	1143	222	6301	10423	jx89boqcSzfaK7sWMhgFYBKPfE9n2bKJ96dP2m6rj8Fn9FssTxW	7301	10334	10334	1617799320000	canonical
14312	3NK7oHKRdysE3vPdFeBBmzzEaAieMWaiTmrnSB3HAZy76769fauK	14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	1407	1395	222	6301	10428	jxuV7MsfxVq3EJK5tZvQPuko5upFgd2sLHWP1rwsV28tb7Lmwh9	7304	10337	10337	1617799860000	orphaned
14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1523	1321	222	6301	10431	jwuLyKMDzXuXpRe2y93pxE6ooGMPys27JUACWZTYCBUwE7Uh72p	7305	10338	10338	1617800040000	canonical
14323	3NLuixbnXu9HaWWHc8cX9DV9N9dz6Hv4WZwDFeUmWVUeWZ7CiRg3	14322	3NKYxpZ6qxKp8sTpa8ia4MSTVFR41CfCnt8Zg7C8Rt6ucRwawu9Y	1529	1070	222	6301	10435	jwE6yf1gtoLBQxsosJCggmDaAVh1YQXQAMk3XcL7DqLSZwZBELg	7308	10342	10342	1617800760000	orphaned
14331	3NLEEbkRqZnPKwVsEjSw4o8bUHruau9uWWtKjnnTUtuNXA3EFYEJ	14329	3NLJzy5vXFmPBK5Tcb132Zqp1ibmnSDQyvyD9GD5na8VkZNuwvzb	1406	1393	223	6301	10441	jwzMrvuNKKakQEek7HTX8imuKWpPFuJsvAWDb2wZgThBLBcKfMa	7313	10347	10347	1617801660000	canonical
14339	3NLwsntASX8q3KogrLsrsqdK76Hz1kqcMqyAYe81gcZypQv5pUK2	14337	3NLE9aQsKhD3AKoHZSp1AjFXdpyNkqM1JmQeLKr56fXvqUdMAj8S	1402	874	223	6301	10449	jwgdSN1zDASATRfY6FXBcLJJ9az2vMTgW8u1KPyPRbv4yzRwS3g	7319	10356	10356	1617803280000	canonical
14342	3NKbS85unzF6WdZm7casVFeCwxJYnYuuKU5KYXUYvtu4eWgqNxnq	14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	684	986	223	6301	10452	jxmspC3adYtH778ADDV46Yqe5KTCLLp59dobr83MM5utexEUYNa	7321	10359	10359	1617803820000	orphaned
14349	3NLda4oWz4rjqPXNAUDsDeEVAV6j6bZhUjnmZqZiRJiuQFDbvCLj	14347	3NKkgck1ifzLuLHcsYSM1hmLfm9HrdWetxcF8wfZMZ23Be2ioJjo	576	1229	223	6301	10459	jxEjLR1wfX6SgdDMH7eYBytCgXEwRvGfBvPWwjD6f1HqsDsJNys	7324	10363	10363	1617804540000	canonical
14359	3NKgUjzBSsvxopNnzgmN1zYfx18Gxm5scpLcn6i2pAABLzGZ4MaX	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	1549	996	224	6301	10469	jxvpJTjCfy2DqMiCvYvyn149NiekVERegp93wmRb6xLPLpjsEGu	7330	10370	10370	1617805800000	orphaned
14368	3NKse3FhvpfsdJgTqGa86iXwHdqDuSuK5zUXXjd76mq8ZSncTX3m	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1651	935	224	6301	10477	jxAkXcUaKe2ZbX4yyVQEosPY3o3M93JJ2sV4mwJaHEAinDkvAi4	7332	10372	10372	1617806160000	orphaned
14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	14375	3NKKqMpSAgFmq1mKuB2rgEcRUEmGdec4c7iYqtC9kvoKwv7wF3sc	1406	1393	224	6301	10486	jwnzYgrbXf9CMTgv9XHNznTHPV3ru9xrjz8F7FeRF4JHDkGfZwy	7336	10377	10377	1617807060000	canonical
14383	3NKzwojcGFHPAAMm3hwrhLzYMJ715otHXWx5jKY4214hm4gemCEu	14382	3NLArFJcm2EkusyvyL16zxz35YKJYuq6ve7rQmY15Tih9CkY5zwQ	1672	919	224	6301	10491	jwMgCa6zcrAX9RefeCSfoJcEPxVkFHZZEBVSm4TrxUMrf2UK4wq	7339	10381	10381	1617807780000	canonical
14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	14386	3NLqgX7JPuFAXf4vcYE7ieXu5nYTEeU78Pui5EHX6E2JZyzKwhxc	1673	1368	224	6301	10497	jxhrfeZMeh75HY3V8g6PjGpHxv9FPscN9WqyzBmQkKB4qXm6d7X	7342	10389	10389	1617809220000	canonical
14396	3NKtUZSMbj5YZyh2Wzynp9jC38h9Nqu9k74tLr41CRjUVznNqZgV	14394	3NLZQ33skVM9GMiFKghHyUaXQt3votsKbufawRD5jfUssVLQmav3	1637	816	224	6301	10504	jxBPvdDNV5vRzSHjbbRkEkFyfYmBNQvrqBTseX2KyT3oGtGBgXq	7346	10393	10393	1617809940000	orphaned
14399	3NLVmM1uXGerMj4Wx4CGLfLMKvZHQyPfpxSoHu6J1nsrCGHgiqqL	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1483	878	224	6301	10507	jwH9kqo7DvjJaGxDtMaeXPjvzww4Tgn3hFMGYjvR95eUdoK58VF	7347	10394	10394	1617810120000	canonical
14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	14401	3NLNEFBT7szuyhs94NpLhtY5S8YKcMoivXp6phVw1ig9TEiae4DS	1518	788	224	6301	10511	jwYbgFV8qAHSZfXmUDAohufjrQZUCwsYigmx8eX9EBVsREWsFfb	7349	10396	10396	1617810480000	canonical
14405	3NKF7X8UqktC1thmCWMbdK8M8Zc1pTMe21z8TRrRDZ87r23on4LD	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1536	1313	224	6301	10513	jw8Qv3bWpNuwmzH3pU6XD1j3kTxxDxkzNfZ892aobdCtHAVYLqw	7350	10397	10397	1617810660000	orphaned
20385	3NKnkwCfYHvcyTGRdKjwYVVfAyDDU3bQRWuoMX5zLJ2kpjqeN1zy	20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	1509	1194	365	12463	12717	jwowcptrnEb5iy4be3WrHDjFsVyPH5ceVX4bukBb8nQWWALTm8Q	10227	14488	14488	1618547040000	orphaned
14357	3NLY4CD4UDRXgpLfCDhQWssnFzDoU3JaKMrcNFMwAUAPAtWAFXNJ	14157	3NLZXP4mtfQhZLGwSjGiV8ZMpbwszoaXNHPEREa579fwRtqnZSsY	1624	1208	218	6301	10467	jxS6F1fF6ayy6dgt2JcLswPBLvAqdqtJuKtFZhdnreUj8r9uCR9	7227	10370	10370	1617805800000	orphaned
14261	3NLUE98UjRkc9AvvjmLLQGQ8dtDAJt9HYhWJ5pKuDDNrZWfiXN7c	14258	3NKEvVpu3ZJogcr9fW6j6rSXFYnEDkb249Xhr3FmhVDsyQDNb1nh	1547	1252	221	6301	10384	jxkCfg7q3379RYK2RTP4xKjn5KAVAcSPLFXkrCHuNXZxPrb2rHS	7281	10301	10301	1617793380000	orphaned
14265	3NKWzra6hfDXeBaD52KcHzbxi1ScdLAYYtCDcD3JVQtKFCKWfLpi	14262	3NLJaxgQHoiwKGVTnvTc339DpYrcHtDzQps6WZ35gYXLoSJARRkg	1631	794	221	6301	10388	jwp3bgs4C6GE5YbvVhVXeqJsfDpsY4WQrj7fU844cy1NuzUjnDM	7283	10303	10303	1617793740000	orphaned
14274	3NKekgxMUiA8kyXuDonwU2x1AEr6unUMwnkGukW13zKKqMSYqTF3	14271	3NLRB5pzZekDEe54Bf6wYKRmTFiQSDym9H66UwtxixBwcykRcabQ	1642	1367	221	6301	10396	jxLGht5LijENQ21nujx7db3urKv52b5Z3WLCj8QqN2W4k5nse4j	7286	10309	10309	1617794820000	orphaned
14275	3NKrjhMRyi1GUh2dbcXmnFpFwu2heMhqRRGLqch42zaAvV2Wu9qa	14272	3NLGukMq3NsiyE5b9o2zMa4Y1cRSUP7YQNfjuKALzcudykzWFkpj	1406	1393	221	6301	10397	jxKb5uQkdfjApVuqmMF71FFfYFbmdSrZWwCzVQhWW7dqJZsWjJh	7287	10310	10310	1617795000000	canonical
14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	14276	3NLaK3CcbDTtdwo8N91cojUz4QKBQEXXNCkomeKDpxZ2EogooRES	149	1283	221	6301	10399	jwSPi6yH3Jzr7bEkcDp2gXXCWPWRWKcQSQoiK6Ek59A7GQWuYDv	7289	10313	10313	1617795540000	canonical
14287	3NK6DexHrJ9QCgFWP3NRAssbu1Ko6SpLMkAiMH4w98G8cTYSGDmd	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	470	1183	221	6301	10407	jxJkLQwMSqEvyzrDwVdWXvL1LFsYxofg2tFaBJAbSzEfSMTzmaN	7292	10318	10318	1617796440000	orphaned
14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	14286	3NK5HfAVZfHFdUuNuo4WVZYTJqpb2sngVfS4yWvebw2QcrvE1wiK	1631	794	221	6301	10410	jxwxrXBxrA9mbGmbh7EJUwXAiUji2tGsp182ywarKhuNHofmxrE	7293	10320	10320	1617796800000	canonical
14295	3NLAdQwjnyt8SbKNSjF3LJ6sKkHemiG8PEzdeCnvspGykH3vThDU	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1534	432	221	6301	10411	jwuuJy7pRNodsfYwTWijvWUUAiQCmVEsmKDDvCBNxvf36Bnsw3x	7294	10321	10321	1617796980000	orphaned
14296	3NKVjupfM82ckRDcxVjemFKEkzmYNiNcUP6J1bkbTAyiP5wKTr8X	14294	3NKB87SzCa2kdaGDpbJBmzTFRYqziEijssKc4HT6E585iZFEryJc	1407	1395	222	6301	10413	jxPSDF7ZnEAUBscQ1Wytn8rLuCMQtfxiEnQuWbzHNqUYsRKd5i9	7295	10322	10322	1617797160000	canonical
14297	3NKTjLUGdN3X6mAZcjFwj6Trak6gXHT77PgzR4q6xzCPy2wgwaKy	14296	3NKVjupfM82ckRDcxVjemFKEkzmYNiNcUP6J1bkbTAyiP5wKTr8X	1673	1122	222	6301	10414	jwGQvcqdqZAq7mLt75TVw4edWpNv4taPGTdumeefT4XcanBFFCK	7296	10324	10324	1617797520000	canonical
14303	3NKY7FXcmCcq7KrD2TG8r5d9n1AhbRFopMNoaHKSEKX3JUFVwfhP	14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	1474	1083	222	6301	10419	jximdCxSrVxjAVPUaaAPddciejixDKBjsJ6H8eWVmCWTRDJswAg	7299	10330	10330	1617798600000	canonical
14305	3NLN3Bg5jgZEMwPLYNyEbxNg19dkBni7NuxfN8wPNn8ZB17K3fs1	14303	3NKY7FXcmCcq7KrD2TG8r5d9n1AhbRFopMNoaHKSEKX3JUFVwfhP	1405	851	222	6301	10421	jxS4rVMH7p2H7pe8xhuropbyzAQdafkMH8aFoZiynJYQFfakjYa	7300	10332	10332	1617798960000	canonical
14308	3NKcXsw9ShauWUP5QxgjCdHFVGSauSb9zzNS9dHFy2NsUZd2FUeq	14305	3NLN3Bg5jgZEMwPLYNyEbxNg19dkBni7NuxfN8wPNn8ZB17K3fs1	1509	1074	222	6301	10424	jxKLjUUYds6tkkg8cdtzE9ezbLaf6tbLmigmArK8ejLjjus1gWN	7301	10334	10334	1617799320000	orphaned
14310	3NKyXuv6rbmLyu6C699pnXuZzScbUVmhkNDSV5SAkdhHqfCZR9SS	14309	3NLbaJpbBDBR7Zn6pvAk6s8TV8YP4SvBh5vAhQr8TnFFys2vqgQg	1559	1353	222	6301	10426	jxq6Fn2m97czhTLrhtaB3kTrb1WQU9vwdGQyUwQr5LiLb1RPVxM	7303	10336	10336	1617799680000	orphaned
14313	3NLu8j5xSTmBd1MEag6VDPnGTBUAFeX4eNtViZsYHxxk15kcuTrR	14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	1646	1354	222	6301	10429	jxirJ21x7VTWNRmvFmEgw7sd9xLUCp9sQwnskgajXscT6cWW3FT	7304	10337	10337	1617799860000	orphaned
14318	3NKRiwtCANbtywRuXwzJj4DXQjgjZeEKAyNnBeu47eRmpmhPLNdk	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1406	1393	222	6301	10432	jxrVgdvQgcr61Uw8a1trMTnc14VEkg9TnH2n4XHANzMQwQTf6a5	7305	10338	10338	1617800040000	orphaned
14319	3NKcUqHHmF3oihmTSSumngo7SQeQAETwKPKnVK7fUBsY4BnU7DNj	14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	1523	1321	222	6301	10433	jwB7rq4zhSYSD8mDV5fHzg2rkfitgFAEaXZci9iRZEbovWM4Fqt	7306	10339	10339	1617800220000	orphaned
14324	3NLozZmv7LmyKMetBs35dUfzdV1gnJDzbnsTjXn8w5Q1k3hhmRA6	14322	3NKYxpZ6qxKp8sTpa8ia4MSTVFR41CfCnt8Zg7C8Rt6ucRwawu9Y	1610	1188	222	6301	10436	jweuSMwAzyazhMCH3SHazpPsirXuTo8xoSKQSnEW42vsEY7F8gJ	7308	10342	10342	1617800760000	canonical
14326	3NKSoC9ZKCJ1qTMTnEiefYqrR1pj1tVnpqVZgtDfVNtwTb7LNw2m	14324	3NLozZmv7LmyKMetBs35dUfzdV1gnJDzbnsTjXn8w5Q1k3hhmRA6	1508	1021	222	6301	10437	jweaRK8fQxKnMGeBq321LPrrVD5bTJtxpBkewkM9sBqZJ8eCvfp	7309	10343	10343	1617800940000	orphaned
14329	3NLJzy5vXFmPBK5Tcb132Zqp1ibmnSDQyvyD9GD5na8VkZNuwvzb	14328	3NL7TDAWauUB6X9578mTJ4Kkr62zjuLPVUJN6NTLYtsTZGesA5Gn	1587	1231	223	6301	10440	jwATAUZpgQ4GzGzEzom1bb5LsAMHPVZsN5VvATR6wm5xG3bRENo	7312	10346	10346	1617801480000	canonical
14334	3NKrgnqH3BkfgnJrgMaJeFPYw7aiQ67VZ4XavkGZNQtiJmh9uFnT	14333	3NLupc159jPs2RUJTH5BgU1cqvPu2XDer6v6aC4EgCJW7NLdVPBW	1402	856	223	6301	10444	jxhWsofAenek2SGZKPABFFy1zhCdTQQ6GSAG1hexNexb8VMJxMV	7315	10350	10350	1617802200000	canonical
14337	3NLE9aQsKhD3AKoHZSp1AjFXdpyNkqM1JmQeLKr56fXvqUdMAj8S	14336	3NKAnak9hJ6LwxcDsjJNXjPukJoWeH9m89YLkoRcZ5cNEN2ACqgR	1571	1089	223	6301	10447	jwa3tMVjKDqkC95vDMJmeNgV5fxDn6HjCQ8eddGjXXUNw1XpkmA	7318	10354	10354	1617802920000	canonical
14340	3NLw6mjE446t8nmpH2JZiFCjqwxCYueimPLa8ETZ4GLn2Qavvrys	14339	3NLwsntASX8q3KogrLsrsqdK76Hz1kqcMqyAYe81gcZypQv5pUK2	1406	1393	223	6301	10450	jx58xYEiKD5DjNuYmYTNiw3W6wbM7nKvZ8g9o2Em3iv5yw2KgKq	7320	10357	10357	1617803460000	orphaned
14343	3NLKAcRTKyjXzqEA7xei2NHUWGmw391sEgrLVXuzUu8zWzDNn5cg	14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	1609	1087	223	6301	10453	jxPy9ryVk1oZQt88GWRQBS3LgZxdyAB7iQHeQAcQKKAw78SfXLQ	7321	10359	10359	1617803820000	orphaned
14345	3NKFSSpMrsvRkAgG1EeLZ8XKxLwjwoGLKVnS2ejDKXHC7Pw9VjWG	14344	3NLtbjfe42CBqjnsoNuogGcZuCJYpC4B8qbjhasvnifP7tY5hHou	1536	260	223	6301	10455	jx7Nt5qhJuRBrpwp9348zDoBxJALZC8EM7xYbAMJRK6m2s1XnEE	7322	10361	10361	1617804180000	canonical
14347	3NKkgck1ifzLuLHcsYSM1hmLfm9HrdWetxcF8wfZMZ23Be2ioJjo	14345	3NKFSSpMrsvRkAgG1EeLZ8XKxLwjwoGLKVnS2ejDKXHC7Pw9VjWG	369	1312	223	6301	10457	jwSHH9hDbBGFiNHeREEqkGPj3nAR6BQt51iSfkbap3A98GJhPfZ	7323	10362	10362	1617804360000	canonical
14350	3NLtzVfGipRBgRivM8xGh15ChnFZwPuKkk2bvXzcbiy2ZRa9h4wg	14349	3NLda4oWz4rjqPXNAUDsDeEVAV6j6bZhUjnmZqZiRJiuQFDbvCLj	1407	1395	223	6301	10460	jwqGScGLvvBzQpikHFNxSGL7CNMxzAwbWgh5LAhLmzkdZPwgq6j	7325	10365	10365	1617804900000	canonical
14352	3NLK2igpF4GuLRsTksgx83dx4G6EZ2ST6Vyyt87vW22oP64czdi7	14350	3NLtzVfGipRBgRivM8xGh15ChnFZwPuKkk2bvXzcbiy2ZRa9h4wg	700	840	223	6301	10462	jxkw5u3wEJMbxMWh6B2d49MmBa1YmLnWJ6v8czSW3rs4tBk5dW9	7326	10366	10366	1617805080000	canonical
20508	3NKVnKHskUxH4czJhD54DiHtUwSaejGR9fu5FeZsnArYDqUriFqn	20311	3NLwHrQiCd4DyhdrUC37zs4mFxaMujYQh694DeBbnxKPAWoNsJF4	1675	1096	365	12463	12825	jxx6Q8vRjCwSMkpan4CySHuRKWps8waFt9K9BpEeZ3Ty4QTmosu	10231	14560	14560	1618560000000	orphaned
14364	3NLCzs6vtegxXawpYfmh73x1u7w2wQT8bnjcnX7YpaRp3WqchYYi	14348	3NKwEkfPYW4htZjqJQ2pjkfJjjzitcRkhu4GkjcYcKvZcVSsEg9m	369	1312	217	6301	10473	jxPyGnNyws8WkgeMChYYJTme3huJeJswmLvrqQ4QUL45sdVxPqL	7193	10371	10371	1617805980000	orphaned
14304	3NKS62uRAJEpUNz7SNBekFQWuMpcAHJ45JYrnJfhhBwhEHSPYjrx	14263	3NKAD2sofjTjgYWj8tXfNYYsepAbNdKD94KwoTadxoL4gdMCcXuq	1474	1083	218	6301	10420	jxm8oFMYrAmf7j2uMKig6FRrNVCTjKdpC1YaxqwYUDHuhRmVS7u	7206	10330	10330	1617798600000	orphaned
14282	3NKiAbRkeCy8McCsUkLvPTyzgDmBefNSZA1DB9b9VNHMh1qn3mVX	14089	3NK5H61AWkQpMUgfn2UZ1u4Q75L9a2Mk5UPu7HgpafB1hspsaP54	484	953	217	6301	10402	jwgP3pYZmLAL6FMSod5oDYe1P5ERPEuU937ftAkCFscznKs3mQR	7207	10315	10315	1617795900000	orphaned
14284	3NKXodLNskAsTNtVUy5GgueLuRmyKPfH3YY6jpTdJjf1jvLq5aht	14283	3NKmcFu8meJYp8PDkxXboT7i7haJrsMAQ5YMvQeJ2LXd1wx2A6se	1407	1395	221	6301	10404	jwwT462qjbpBNwhR4h4GoLo7weUgnV9aAd81dvKyjdnCNSdSMri	7292	10318	10318	1617796440000	orphaned
14293	3NKMvKQunzXcRgQK3qFNFdfYayq4pYQUZNhSKNzmQMtZjDouqspL	14291	3NK5s8whuc1o4X99B1KCet51taQEbqjuuySfszDizYwEM1L31Sz7	1534	432	221	6301	10411	jxBgC6GLGuK44vupJbWdGokH4LhvK5ww6siftfFmVYeo8xiwkm1	7294	10321	10321	1617796980000	orphaned
14298	3NLAzhHeNME57BFuQYinf3MvoZwpoWZx5BB44UqXxZdDGT5W6nJC	14297	3NKTjLUGdN3X6mAZcjFwj6Trak6gXHT77PgzR4q6xzCPy2wgwaKy	311	1307	222	6301	10415	jxo1mwwWLgBebTfk8swbe6MrzxDiCdCQgaC3tAh6dxGsouXsrME	7297	10325	10325	1617797700000	canonical
14301	3NKBEpYFuuyAT5Ekq8sNx7wGH37pyd2pB3MZbWP879iA7FNUxRoF	14299	3NLR6bLwrSoiqkanzHa1XmQfDukLZMnqfFGhNYsCtyJFtkwtPxEf	1529	1070	222	6301	10418	jxGvyaffLSzaRkMNsdsTonHnAUMNP31h4Mrb26Jh8sRFbkkjsvV	7299	10330	10330	1617798600000	orphaned
14306	3NL5aDKRXXfVESr7tBU2DQDFSyu6SUtGatTWVxUbSFGByUMbFSZh	14303	3NKY7FXcmCcq7KrD2TG8r5d9n1AhbRFopMNoaHKSEKX3JUFVwfhP	1577	961	222	6301	10422	jwodaWobV9mqKfNs3sTahJYr4zxeVEuQmwbHUyYrQPCYsbQsMVZ	7300	10332	10332	1617798960000	orphaned
14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	14309	3NLbaJpbBDBR7Zn6pvAk6s8TV8YP4SvBh5vAhQr8TnFFys2vqgQg	1513	1013	222	6301	10427	jworKRY23BL67xjQQ1Tn9XjybzSLadBK5LthfjVqUHZWQdZiLVP	7303	10336	10336	1617799680000	canonical
14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	14311	3NLfRyhBNSVs1XRFPzsSb3JxrMPZ1oW7jCMLJP1Nx9pHSb5e7gMU	1599	1287	222	6301	10430	jwov8G6QPcJmmJJrcfT7ZF4ron1GSPbEisQjHthWxGbqKoJwGVV	7304	10337	10337	1617799860000	canonical
14315	3NKqzLtdeUTLCDL7euppTC2oxHbo3JSuGzD3HzUHZ7k74g8D1ZaJ	14314	3NLCQVbfhzvXKPP9nXffZw65gXJYCFxbZrJzpMZYqLsB5taeVXfa	1523	1321	222	6301	10431	jxTPpfSM57r8t4iUTTWeAWAaspsmD28U6qW656CVtaGzUiCeY7K	7305	10338	10338	1617800040000	orphaned
14320	3NLvPES8QPJuxi3ZetYQhE8PCm7MVXddaceCQbhP2E24Y6sPqbYf	14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	1523	1321	222	6301	10433	jxvBKCxkeb62zhuZ4tZrV1CYT6BuBXcrRuiN9bGeSAEYVhgvQgM	7306	10339	10339	1617800220000	canonical
14321	3NKERpaT2xBTEZXqKnSeEYoLetWnsze7VLnuP5VTRLMFVuviYoH4	14317	3NLNdvDbUMTA1jR8gzWcrxKzNZesQFx58mq56vfYtTEpCneYSs3w	1523	1321	222	6301	10433	jxSTxBoWL6LAnJWmD3q8ANZ1oyMwD3VCuyHHGvzQcFukuDBbZBf	7306	10339	10339	1617800220000	orphaned
14322	3NKYxpZ6qxKp8sTpa8ia4MSTVFR41CfCnt8Zg7C8Rt6ucRwawu9Y	14320	3NLvPES8QPJuxi3ZetYQhE8PCm7MVXddaceCQbhP2E24Y6sPqbYf	1407	1395	222	6301	10434	jxc3Yon2krQD8CWcJettMCZXTEdiV9maduw6VCLpY1QC181UZU1	7307	10341	10341	1617800580000	canonical
14325	3NKkGQspF5GPEura7mWToxdohJB2if42HUQG7NofER77UgTuc6jL	14324	3NLozZmv7LmyKMetBs35dUfzdV1gnJDzbnsTjXn8w5Q1k3hhmRA6	1508	1021	222	6301	10437	jxQQqHw6wa7p42r7TRGXSZM1Atqb9KZN37Gtz99x7x9Jzi4e3hC	7309	10343	10343	1617800940000	canonical
14327	3NLPr6hDrKRLMyFD5VZVqySCxQu3voYYSNQagSMY29dwxcegGjqN	14325	3NKkGQspF5GPEura7mWToxdohJB2if42HUQG7NofER77UgTuc6jL	1581	778	222	6301	10438	jxp4Lwv6WiU7gqWFwYQpuTdJtdLgDnV98TNenT7gwEYEWF1FXg7	7310	10344	10344	1617801120000	canonical
14328	3NL7TDAWauUB6X9578mTJ4Kkr62zjuLPVUJN6NTLYtsTZGesA5Gn	14327	3NLPr6hDrKRLMyFD5VZVqySCxQu3voYYSNQagSMY29dwxcegGjqN	1581	778	222	6301	10439	jwpsVgSY8TE7yGPzUpUoR8Fytkz8fNncNJxWtuD5G3uHzxaZP9P	7311	10345	10345	1617801300000	canonical
14330	3NLtR2W6yPLu8sUySHAd6q8jDnHnarUHQEYXaBip96zZD4x2pQFw	14328	3NL7TDAWauUB6X9578mTJ4Kkr62zjuLPVUJN6NTLYtsTZGesA5Gn	1587	1231	222	6301	10440	jxDhUpMRjM53gLXswBXeN11N4RadgUdDxsx6ZmYjfxvpBxvuM9x	7312	10346	10346	1617801480000	orphaned
14332	3NLtP4pP5sCmpbWAesWnKo8ZdcESCGTvRHDgsvE2ieCYd4ykg4zR	14329	3NLJzy5vXFmPBK5Tcb132Zqp1ibmnSDQyvyD9GD5na8VkZNuwvzb	1481	790	223	6301	10442	jxiEUrYwbhchzxwU8PLfb7guZYe4UWdy5636H2aXQUFWUnmwkDK	7313	10347	10347	1617801660000	orphaned
14335	3NLTnppnbzV7DnX3Q9DFjGFFzfc7PA6JGWujpmLXSxXpPsAD6yRp	14334	3NKrgnqH3BkfgnJrgMaJeFPYw7aiQ67VZ4XavkGZNQtiJmh9uFnT	1573	1192	223	6301	10445	jwsHHtTVNjvSr389tVFznic6UZGz8taE9i9DSTeBW65TDG88Kg1	7316	10352	10352	1617802560000	canonical
14338	3NL9DAoh15pAzi9Pppg4zNhSg2XTKYp8mDki8Jsv9NzhkzkuHS8F	14336	3NKAnak9hJ6LwxcDsjJNXjPukJoWeH9m89YLkoRcZ5cNEN2ACqgR	1560	1165	223	6301	10448	jx2m8qaBMf12q78UF2zXChUVCqCFgeRy1CUcgJ4jTaTEvKE5HS3	7318	10354	10354	1617802920000	orphaned
14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	14339	3NLwsntASX8q3KogrLsrsqdK76Hz1kqcMqyAYe81gcZypQv5pUK2	1553	776	223	6301	10451	jxYG673va3nWHsWuosLh2korgHdGcSMxYdNtquvTicyeHNhPjjq	7320	10357	10357	1617803460000	canonical
14344	3NLtbjfe42CBqjnsoNuogGcZuCJYpC4B8qbjhasvnifP7tY5hHou	14341	3NLTLUPWH2gm6mrjqPsmoqcZNFhEH97aHUFSwPQgZdkHS3pfqBQN	1587	1357	223	6301	10454	jxpjCEuWWpsxmEWf338A55dxFFapizUbtQ8cMZ9D8L7ZqxEHHgk	7321	10359	10359	1617803820000	canonical
14346	3NL2pT8Jg7D2G7rzXR12qWLPpq5H6A4C9jndTYiFtnrxf4CrpL1L	14344	3NLtbjfe42CBqjnsoNuogGcZuCJYpC4B8qbjhasvnifP7tY5hHou	632	1016	223	6301	10456	jwvGG3PyxTRhyXAZq7Q6KG8Fzww1zPFqB3DM43HNecKDjPFigpk	7322	10361	10361	1617804180000	orphaned
14351	3NKopMvRsZwNcQhd6fpFkehm1fTSALB3gFoK4sBvmZ6jCbx3CAp6	14349	3NLda4oWz4rjqPXNAUDsDeEVAV6j6bZhUjnmZqZiRJiuQFDbvCLj	1540	229	223	6301	10461	jxqYtJ4VYwQksY7YRu3YdyG9JoVqPuKBXXLuBpTXciE7V9cBSbq	7325	10365	10365	1617804900000	orphaned
14353	3NKauqYdsBXcB9MPs9TFaC4Mo9mztvMhJT1BKLjWUQ5cNGUFjvSZ	14352	3NLK2igpF4GuLRsTksgx83dx4G6EZ2ST6Vyyt87vW22oP64czdi7	1670	916	223	6301	10463	jxxEvEbcCtZLjfBsw7XMJTw2vZ64pNeGnQduHMxkrHzvcFSxnV8	7327	10367	10367	1617805260000	orphaned
14355	3NLSSwuGKqsf6ASY8UE3UTqp3wfHpqAd2wGpdtEeCybnucfS7WMK	14354	3NL4jCuP32JhkKcRrXhZbP2mu94rukujNuTq9o6gSy7TeCgtJzTu	1405	873	223	6301	10465	jwUaA7CAbCCsKSCYgX7g9MfzjQBXjeDZWnFy18kqN3pcner68pU	7328	10368	10368	1617805440000	canonical
14361	3NLKoUoV9iLRg1q1ghnrVhBb1DFTayFCzSvenkcFM8EQHSZ4jhWt	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	341	341	223	6301	10471	jxvpgTemym9RegLiiHTCJVQPKxphVbqWteia7yViqyrvxEboHPK	7330	10370	10370	1617805800000	orphaned
14366	3NKh15AmBsBixAu2JczuwUnarp3i6gp6zTpXkb7Rrf7AJyhU1zhD	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1617	1042	224	6301	10475	jwkyVYxBL58PF9LvWsficmRXFo4tA3VLz5ftfJdeTKZZcaaMPtg	7332	10372	10372	1617806160000	canonical
20327	3NKzPegiiSJFPySxDSHdCWfwEz2ykrUEScWXokfyWLc1vJuXBb96	20326	3NLrSVMC5uwTzuA81MjHMwqX3sqiqYEXULPT8rgBXpHcUGPEBSKz	1407	1395	366	12463	12660	jwbRaVypxDeVvERLinAAsrXxH5iichR4YQENxaoJpTk3LyL39Gq	10237	14445	14445	1618539300000	canonical
22735	3NKdxbAHHx4LQPWA7CSRebTwRo2gucJ6p8E1BpDpDq8RRs1vEasY	22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	1581	778	408	12463	14814	jxaAqsJoLRisLQSG3VtXaV9iVfT76e69VXsbzPQLqqQC7Q9KNav	11097	16007	16007	1618820540213	orphaned
14377	3NLtMVqeHo1uiX8gxApUfJwByjxSNcm1sf1tDGwGKMed43aDCKGq	13982	3NLY6TTRPCFR4spZU9fub5V7HuGA29aD3x782MeRZYwvaFHfid4q	641	1210	214	6301	10485	jxFQ56LenRs6XkMR2kzkVfX8MYDvjy7fnEeWQmFncjcSTB3BySG	7164	10375	10375	1617806700000	orphaned
14387	3NLhjobMpxPYLNCnv2sv6bN3bBuKBPzVHt76mnNjEMZJFF2RytQy	14377	3NLtMVqeHo1uiX8gxApUfJwByjxSNcm1sf1tDGwGKMed43aDCKGq	641	1336	214	6301	10495	jxRfgCgCZh6SzmkiD9UkcCdwrXbGjNXuLSnFByVNMUCryMajqHC	7165	10384	10384	1617808320000	orphaned
14362	3NKnoPk9LmAhNE4CRDWKYMGQESFMAXi9M5aAg1GNvKjmcWKPGCBb	14176	3NLo6HxrcKePDEMLbkkr9CZcCdCFCvowBTa7W6bcjujhNuuArNNw	1549	996	218	6301	10472	jwbm9x3dz9ewmxrDNxs3ejCS4a7yttiYTEqyyADV1HZJGwjrFQN	7238	10370	10370	1617805800000	orphaned
14333	3NLupc159jPs2RUJTH5BgU1cqvPu2XDer6v6aC4EgCJW7NLdVPBW	14331	3NLEEbkRqZnPKwVsEjSw4o8bUHruau9uWWtKjnnTUtuNXA3EFYEJ	1553	776	223	6301	10443	jxpvxvrp6zBoexqBDBDgsjSUcRNQtBJi1mdJeRcHGjkaT7e6Pj8	7314	10349	10349	1617802020000	canonical
14336	3NKAnak9hJ6LwxcDsjJNXjPukJoWeH9m89YLkoRcZ5cNEN2ACqgR	14335	3NLTnppnbzV7DnX3Q9DFjGFFzfc7PA6JGWujpmLXSxXpPsAD6yRp	1407	1395	223	6301	10446	jxawW7TZR56NbYd84FHxJ4VaZrLUUS6e5aWAjHCkq5iAUb4ZTt7	7317	10353	10353	1617802740000	canonical
14354	3NL4jCuP32JhkKcRrXhZbP2mu94rukujNuTq9o6gSy7TeCgtJzTu	14352	3NLK2igpF4GuLRsTksgx83dx4G6EZ2ST6Vyyt87vW22oP64czdi7	1406	1393	223	6301	10464	jwaVdwR5BSNCwWt6FPxH9rwXvj7mkL6ZXFobHmeQKoj2FxjFNmB	7327	10367	10367	1617805260000	canonical
14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	14355	3NLSSwuGKqsf6ASY8UE3UTqp3wfHpqAd2wGpdtEeCybnucfS7WMK	1476	1005	223	6301	10466	jx7kmLE674UDejdPC3ZUHUSbGcMkakj3QqTZMKQRVFJguayH78t	7329	10369	10369	1617805620000	canonical
14358	3NKnt83uDkLsPfhV7Zmu3n4Gq6Th1hQ93euXFvCNw14GiTRd7kjA	14356	3NLAFrT4YUheQkLayWhuBdSRmewMLehdDmT5WQa7fGUF86bymAUy	1406	1393	224	6301	10468	jxTBkWMB95cNzGsvpjPAJedwj1R7V267vFuBckq9ABWJzTE5Tqf	7330	10370	10370	1617805800000	canonical
14367	3NLfRRRcoSJBPGLcGAkPfbahtWfRUR6xyLjXW8TXZ6k1M6dMri9z	14365	3NLavjtTdJzeFhBLffFS2CFGdJVWWaQ5AiFgZHo1kLp3UgQ6Bh9x	1507	1280	224	6301	10476	jwdh26WDdj9ioBdTeyqz5ydGHatBm5AgsKrYkPtgf1D9Hw6Xr1o	7332	10372	10372	1617806160000	orphaned
14371	3NKEAsdUHSmDc5PkMTmRJKGEJh14fh3QCYJkcSZXLyBuhpmCUxg3	14366	3NKh15AmBsBixAu2JczuwUnarp3i6gp6zTpXkb7Rrf7AJyhU1zhD	1631	794	224	6301	10479	jx3dPDjbSqa3y5XvDT5uewqKLyuKYYu2bvdrmVqTEgDPe23dxCr	7333	10373	10373	1617806340000	canonical
14374	3NLyB3sUxFFHHdBgSrZoFioRtiPZzLCvSPi8esj1hTtbf8hz22E4	14371	3NKEAsdUHSmDc5PkMTmRJKGEJh14fh3QCYJkcSZXLyBuhpmCUxg3	1402	868	224	6301	10482	jxpA2shWLYR4yrDM6f177eHdBS2w5iZ6mApvuM8jUaaxk2ZhD3J	7334	10374	10374	1617806520000	orphaned
14375	3NKKqMpSAgFmq1mKuB2rgEcRUEmGdec4c7iYqtC9kvoKwv7wF3sc	14372	3NLbeg8PxxYiCfALmRwU66kV6wX32HwkR2wwvRQLRPDwin8G7aEZ	1403	824	224	6301	10483	jxQsy2Fe5fmhnLhqNXgdQaF5mY6c53KvVvdfPwNvCCXoUjBgPb8	7335	10375	10375	1617806700000	canonical
14381	3NKvuYNJ9vxu4TwCBSZxRTXa114M6QD8g3NHQTZJVYsiuRnVUanb	14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	1581	778	224	6301	10489	jwq3o1xBVhvreYauNHUpBJZL1JotFXDEh7vPVMiie2sFZ9qqUNv	7337	10378	10378	1617807240000	canonical
14380	3NL8GAAVCaAakFiywGssqSu7xp5zPpWkqR9PtmqADaxEbBEss8vn	14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	1555	1347	224	6301	10488	jxrKZQteR817QySbMXomVDdTDpwKDuQ17mQydQX1nRxVbJ6pEEP	7337	10378	10378	1617807240000	orphaned
14379	3NK3rBUfJTyrYZ8fK48JUqwxdhNygG2ChjLf9f2mnewDPFdmrLR7	14378	3NKRMnoQT8CiLu2VTHSUrKAHK5fCaqiAXa6tjMCpgUyLEhwBHzqU	1522	956	224	6301	10487	jwpoQWBc9u3CB53ZbhTbJpFvNPRVWzrdzRgKukSuiDGoxmh3Tzm	7337	10378	10378	1617807240000	orphaned
14382	3NLArFJcm2EkusyvyL16zxz35YKJYuq6ve7rQmY15Tih9CkY5zwQ	14381	3NKvuYNJ9vxu4TwCBSZxRTXa114M6QD8g3NHQTZJVYsiuRnVUanb	1581	778	224	6301	10490	jxjsQBbLAkMKXmSbdrJBhv4Z7CmyQimzPbbAiMAkZ6sr14u7Zbv	7338	10380	10380	1617807600000	canonical
14385	3NL6brMZKzdR8pBvxKHx7AcVy9XCeYXHxoHkVqoi8qc8n42UNWWg	14383	3NKzwojcGFHPAAMm3hwrhLzYMJ715otHXWx5jKY4214hm4gemCEu	171	1374	224	6301	10493	jwzX8QzELvHb74xJhevHGvDkPFakEWkoAtphpej8YMgRNxP8q9y	7340	10383	10383	1617808140000	canonical
14390	3NLFiqUJ3jRwSpBXHQJ8BvSLZRSjRH6GMCco1ccZYpLznnjxHXqt	14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	1593	1346	224	6301	10498	jwP7rzyoSJudUqzay8x7zAiBtzNvtkYWvZDev6xwuUBqDiMtkin	7343	10390	10390	1617809400000	canonical
14391	3NKnYZBvjzPw5v7p7gzh3NPde4Ji592eeYu2uVA6GXkToG1efZeX	14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	149	917	224	6301	10499	jwnQ7FwSYY5eApciiioCySm3Z1nX2GiAeJZBhbgib6bBAjEV8gW	7343	10390	10390	1617809400000	orphaned
14392	3NL9f2PzpPi7SCVoqbbSDCaKYndhxiqU5hod4GC41wSHMHZvYCuz	14389	3NLHMJQKW6MGowEV8FqBHHDAWJK52qUCQM5QcvaRz31mUc49fRQJ	1611	1215	224	6301	10500	jw9YXVk4Chiobo1fyDUicioz6XefT5xjru1vDhC2rmUXw5jSuH3	7343	10390	10390	1617809400000	orphaned
14393	3NLjxTy1ZAxQA45tPZUTEhSNpLePbThNxtZywaXNiEu56MW3vxJr	14390	3NLFiqUJ3jRwSpBXHQJ8BvSLZRSjRH6GMCco1ccZYpLznnjxHXqt	1581	778	224	6301	10501	jxQfL6JEcuqT2HRFFsGdDxhEVJFWr9QqRfJYMpQbM2V9QDghF7f	7344	10391	10391	1617809580000	canonical
14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	14394	3NLZQ33skVM9GMiFKghHyUaXQt3votsKbufawRD5jfUssVLQmav3	162	162	224	6301	10503	jwcZhmT2shuJysCu5DVdjXCs3tDYXHV3LiCPjoEUh8qbpe2fUPB	7346	10393	10393	1617809940000	canonical
14398	3NKdghLzHFxL2MD3yPcyiQqqZBtY1jVBE3Hw67i5o7BswFu2j3tb	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1675	1342	224	6301	10506	jwk8UpCXPckMh7hUWCwSZLNzn5r7iJEm2YbosVsmDynDecvLswz	7347	10394	10394	1617810120000	orphaned
14397	3NKxjoiEs3J6N6N7SfjWmiUg6YPL2gjtbPxBet2xSD4GXTjU17pq	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1407	1395	224	6301	10505	jxRCC1q1amQSZJjWTstUdp6FJikkLoihX5GMyWLDoEMkeTv3PVA	7347	10394	10394	1617810120000	orphaned
14402	3NK6yxdPACVKK1514e2veBDzQBbiojdUTVDK2gYRNo4tA2sd2TB7	14401	3NLNEFBT7szuyhs94NpLhtY5S8YKcMoivXp6phVw1ig9TEiae4DS	43	1310	224	6301	10510	jw9oV1DnWEPExscPUN2PdY7c2Ei9wErYA6gRMCaBtsRAmBSXchJ	7349	10396	10396	1617810480000	orphaned
14407	3NKrFKe7geJpF7162t14mJP9kTmkAnTU1zeLiRbZyeR6oQuySW9z	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1457	1265	224	6301	10515	jxCAxk9XP9V3XTtAoAdp7vMudGuWjNbUA2Z7iYyVCyny5c8ktc7	7350	10397	10397	1617810660000	canonical
14412	3NK8jpngkjtJcJVCJJD5s74k34iFMx5VCnaAu6wdrMGbJmQQHP1Y	14411	3NKrQRTZyaGvbtsZzSWoHvFqfDqALFdSpptmrLuXy4SePTynX59g	1407	1395	225	6301	10520	jxZsGJTcvJJvjvh66ueheCFoy1eHnnpHYXqoKwnpu7DoF6tYkHh	7352	10403	10403	1617811740000	canonical
14418	3NLfYBmuJBKPmAom3xJbvqSasm88QjdQChRrjSpUwcUmJVYyfJbR	14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	1419	814	225	6301	10526	jxwcQbvumZUcXjsYwmV3qg5ZV5ZeqTcKEcEqBLsQJhWhv5GU9XQ	7355	10407	10407	1617812460000	orphaned
20333	3NKZXBwVXNEg3AeK8mz1RYJUdNnt226vNc2W9GSC1cGjkikh9ahx	20332	3NLx934rP9SVejtaUH8R8Y3ynrb455yHyE2DUfymTDA4dAJrPmJv	1440	1377	366	12463	12666	jxRYAqDCWrUP93jdeKT7wMDozVg7m6YpxZWTABJBqiK4u4VSBoE	10240	14448	14448	1618539840000	canonical
14404	3NLbVQQbDYsHe43Ge9GRDJPJpTxPxryuY8aBmFXF8vaCuyjPMXyW	14163	3NKdKeiqoJwxTkYTPVHeazosfMyTkQJikED6FjeVjpjpLDhckDgA	43	1310	218	6301	10512	jxyGDCwfukW7jGUzD2DbHzXxgPfxMpchBuExjCwef88r6XN7aXv	7230	10396	10396	1617810480000	orphaned
14370	3NL1LnsHRGYi1N1zSaPAkbtSMntk5FoQkFxhkVSABeRdWbpDxbsU	14366	3NKh15AmBsBixAu2JczuwUnarp3i6gp6zTpXkb7Rrf7AJyhU1zhD	1422	1091	224	6301	10478	jw9QKXNnTyGwhADxyz1jYTkCVZFwcsPq57KNMF8BhbKu7exkp99	7333	10373	10373	1617806340000	orphaned
14372	3NLbeg8PxxYiCfALmRwU66kV6wX32HwkR2wwvRQLRPDwin8G7aEZ	14371	3NKEAsdUHSmDc5PkMTmRJKGEJh14fh3QCYJkcSZXLyBuhpmCUxg3	1405	867	224	6301	10480	jwuWW3EPZJiCnRgv2GVKpFbT2b2hKpmC9SW43vRyed9NuPcZrye	7334	10374	10374	1617806520000	canonical
14384	3NLGsQ4fBku7EXSaguj7b6RecXbxTQCmTRsV33GSZzCXCGggPTjd	14383	3NKzwojcGFHPAAMm3hwrhLzYMJ715otHXWx5jKY4214hm4gemCEu	1672	1285	224	6301	10492	jxzPNpTPWFAhMQDQ8y1w5EuFzXi1urMhZyyvxv4u4865k3JVmW6	7340	10383	10383	1617808140000	orphaned
14386	3NLqgX7JPuFAXf4vcYE7ieXu5nYTEeU78Pui5EHX6E2JZyzKwhxc	14385	3NL6brMZKzdR8pBvxKHx7AcVy9XCeYXHxoHkVqoi8qc8n42UNWWg	1627	1385	224	6301	10494	jxPpfQbazguieh29961bjHcd4gNyreh6FoduMhidBHq8jyptkCZ	7341	10384	10384	1617808320000	canonical
14394	3NLZQ33skVM9GMiFKghHyUaXQt3votsKbufawRD5jfUssVLQmav3	14393	3NLjxTy1ZAxQA45tPZUTEhSNpLePbThNxtZywaXNiEu56MW3vxJr	1631	794	224	6301	10502	jwm3YhFRcVep5nF81C5uMLXTdKdTFTzrh8BxhQMqsuWqdBiQaLy	7345	10392	10392	1617809760000	canonical
14400	3NLFLrcVn3mY9piPRhRymanDoEQ3WAc8yMdSzz9Ta1BAtK7JJFWV	14395	3NLPjKhayJZAUsdSkkTtm6jnZJfejnd2NQrJkbCsANDznPwWceKd	1652	949	224	6301	10508	jxL2Qj1zFicJVtsW7k6dqsgLP4YqujNk7jciwSSxtSjXXKCWLr5	7347	10394	10394	1617810120000	orphaned
14401	3NLNEFBT7szuyhs94NpLhtY5S8YKcMoivXp6phVw1ig9TEiae4DS	14399	3NLVmM1uXGerMj4Wx4CGLfLMKvZHQyPfpxSoHu6J1nsrCGHgiqqL	1593	980	224	6301	10509	jwrSmZkxbQcS95Js1sFEPfssHMfiHwMTZT3d7dM1DNZHJNJBNSs	7348	10395	10395	1617810300000	canonical
14411	3NKrQRTZyaGvbtsZzSWoHvFqfDqALFdSpptmrLuXy4SePTynX59g	14407	3NKrFKe7geJpF7162t14mJP9kTmkAnTU1zeLiRbZyeR6oQuySW9z	1419	814	224	6301	10519	jxNgQXQ8r28NMq52D85KhsAx2oJqF3DSoaVE3GBDWSsANiWte9Z	7351	10402	10402	1617811560000	canonical
14414	3NKNLxSJggUutHbFSDWT3mfJgfoLmMZy9V6rceWHB99Ld8n9Efdm	14412	3NK8jpngkjtJcJVCJJD5s74k34iFMx5VCnaAu6wdrMGbJmQQHP1Y	1600	1246	225	6301	10522	jw8xtMTQWD4B5KkoLyw7wejGF25dVyG4TWBZF8fJYhA1dPAVtQm	7353	10405	10405	1617812100000	orphaned
14417	3NKp7DvFtYbYraVN3xLrin7bEZh5CH4gkQ2SwvEPCNganpNVyu36	14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	1471	1386	225	6301	10525	jwmgjfjeQB4n9n8YqzJGJtbBVNt1cmeq8UwYd18UWbPNEkrToYj	7355	10407	10407	1617812460000	orphaned
14421	3NKmxUt7KSGrhXaxrurSYhi6RWVrWzjNXgucwy7RQpktZ99aQ2Rx	14419	3NK9wxhXQT9pFrJwjeGKSiVomwrLiriJZ6oQTkmtUuL7xxrmG2QM	1406	1393	225	6301	10529	jwXACftE56eugwEkcjffJfngroFYR1NTLaNfMz3WM6q3B4L4k8L	7357	10409	10409	1617812820000	orphaned
14423	3NKKDU3XwR3cbtbiuEAF9v7etZNBBisf5syjwtG2DDTjDxEWG2fZ	14422	3NKEtLRPdye2noVkcY5pzz9mixL7w4jTD2ggZHAQeww2TT459njD	1631	794	225	6301	10531	jxsJoWggTS5o9NcXfoyaatxxQ4FnwqHEhSksyZNUCbmzeEqHeUw	7358	10410	10410	1617813000000	canonical
14428	3NKDYEWNhYMnkWr3PunMEJqV728LctekjzJwPMWBAP9nKzEkJTmc	14426	3NLnRpJAjP5bGtL7d2fZSu5YaY1kVGuoCs8GGCJJ5DkE2jFRnBwS	1646	1108	225	6301	10536	jxRfGmfg4TzH1uLMatd62bW6JwcfBVAoc5bHFoeuB5DPFjJA5u8	7361	10414	10414	1617813720000	canonical
14434	3NK3Ka6LM3cxhZgdnZiY7EokZKSAwEGRTEDVN1Awo6SHsTLzfK7S	14432	3NKuZC195c7pqUpaBkrjyYvP8ZAA5FejFsgMKF8kCWCn7R5G7yMh	1647	845	225	6301	10541	jwm2CsHMjA9zrPqykLRRJy62NpWyaMiixGZYYrUshtrzyDsQqvi	7364	10418	10418	1617814440000	canonical
14433	3NLbUuvmiyhNL2xMAycTLQB63EjDEdgD2YshmGqNhZ3EVwLPEd7X	14432	3NKuZC195c7pqUpaBkrjyYvP8ZAA5FejFsgMKF8kCWCn7R5G7yMh	1647	845	225	6301	10541	jy1H1NafRdtyNbSgrLgVL9KgTiPhy8PaXZ45yV8VDtSqEQ5i1W5	7364	10418	10418	1617814440000	orphaned
14436	3NLV5PdLmGHPiJbagfDyRnYpYBsr6K4yc3ymfaHtwR3o2SReTe26	14435	3NLjf3H721zXwTirfMEMcBqn2yCS2HnZGg6TsRLq66qjYEsVmBnD	1406	1393	225	6301	10543	jwr3unZaQXEoVMzBEPijxQLX7iGETMX5EnCsHXmecx3tDLtBZgL	7366	10421	10421	1617814980000	orphaned
14438	3NL98ZNCoWGjFNsx3HRvqqgKac4yRx2FmFKK2cA616PskB29x8sy	14437	3NKZfAnC6oryCuu3pGuqEthwjS5pAqUsbNBfYXZBsgsiUv8Z3XrJ	470	1309	225	6301	10545	jwqceU5H9TLBVb8udVLHmZBdrg1nDtevy6ywp1zru3Gc3nfyyWa	7367	10422	10422	1617815160000	canonical
14441	3NLaSgzViMZVcHyod8fBBdB8Af5oB3CcregPkr8PPwWP7BagHbd2	14440	3NLACaCteTtGF4gVLw8wKoHvHjJhagyV8zin6VLP5vpePoxDmuRk	1447	1099	226	6301	10548	jxP4uUc6ysytR7WZMruuLaQDVBanWGGowoLyYpzLFFtjACwGeAq	7370	10426	10426	1617815880000	orphaned
14446	3NLGMisqNgGYed26oNiHk3pnodn8yhDptMLhU2cByqHpqi2G3CtT	14445	3NLU6tPVBtrV4FwxDm1pkGFCVSapnRcc3KhUXZMpwgvKKeFz9iNn	1642	280	226	6301	10553	jw8WAzbL7utUDSxbzHvkAQ1q9SC74EdQV51uX2wRRUtbqbk5Gnj	7373	10429	10429	1617816420000	orphaned
14451	3NKpyDkbiRLCUnkR4VWy6GY2oxf1fR7SeTqxoEcHtCEM8mvcz4wP	14450	3NLS4x29stoogXb9vKsfEQDRqKwMHJ3PgpuZGGuvnDrs9Nb9P51n	1560	1291	226	6301	10558	jxyAnVDdMbpohWT74aZkECsPM1Cru7hBBYnviYNzU85szUUuqXr	7376	10433	10433	1617817140000	canonical
14456	3NL6hxcXR3iphtAuQCSyKSgymzyGQk6ErUFt83VismNKveDUeFdc	14454	3NLiDFWrGJi2Mq3u9LPjLyht3HmyVoNnTajqH5qH3LaWW1nSaGAD	1406	1393	226	6301	10563	jxg68beP7Q27HWXBuE649yZ3cgv5qmPG62mVgssJ1gfRq2pxWwz	7379	10437	10437	1617817860000	canonical
14459	3NKm4qMAsqULNnXTN253n8AeGiJRsGHC6N88RmVC2w2E4mWvt8Bi	14458	3NL9AAY38poFDFYH5BeYVyDiW39HR1zuzSYctC4Qs6Wqma3sJSjA	1542	1304	226	6301	10566	jwiZ3eN7R8VMZXpsu8AjHSiBAGoXpCvEDmPDBQDbnvyoqsLYDys	7382	10441	10441	1617818580000	orphaned
14461	3NLoaHgNuRpDyaAwusa21Yoa1n9mPNPGm2Zi8WAdwbmcBMPJF6dQ	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	633	1138	226	6301	10568	jxC7SLTi4cqcH5yFG5YbuKbLwLd2FZVquxErdybiMpbrzR1U6Hp	7383	10442	10442	1617818760000	orphaned
14464	3NKsJENgY9qHcp4onjDBKrpdZGgjF3bAiPWLbvhwJZZA7vurCLQf	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	563	1113	226	6301	10571	jwBt3rJqdm38pToscakbD14jXrMwEu4jruuY7eDsJRc966fnzdd	7383	10442	10442	1617818760000	orphaned
14473	3NLjNrd2Gk2hHGqr1NWfk9MEd5r95tWBXAH9qFS5THtv2SyuSajT	14471	3NK97Vq5iJ3JU2PQe72GEEDLVxS8m694W9a3tyBdPRLYHcccNAU3	1602	1369	226	6301	10578	jw77cHouaRaYzRNFbTAU1crzsMFe73yKbbmeg27KDXFrvmdC8Wd	7387	10447	10447	1617819660000	canonical
14478	3NLGSxetzykDsUmiaoh8hCyRFp2nLFc2mzLut2kiC62caY1XEXwH	14474	3NLAdzvnQ6UQ3pS3cXmj4fq45QiUcdwXn1YesRJG1mzzi3nK9Tbf	1671	999	227	6301	10583	jxqNBo4jnq6VZfkNbWk1qX5QKyCysPAxLBrcEJuc9edeJ9ZTc2B	7389	10453	10453	1617820740000	canonical
14481	3NKgiysWzqxmDZ2GkpPUffMoE5ukZR5SZyRwLXe163dDmEJjbfpE	14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	1405	873	227	6301	10586	jwH6c9FkB7Chyo9inhvbb5bkdxjHByqUgua79LMaMyDEzQ4vq6X	7391	10457	10457	1617821460000	orphaned
14485	3NK4jFasyMz9nbZCtBpKuR4Uvb5xdQwZonGZFCJM53WNkRNVDZtu	14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	1578	1050	227	6301	10590	jwoPWQS6WsuTT4Gx8pnkcqjcQvV8rVAjMTuGgxFpGshY4qM6onM	7392	10458	10458	1617821640000	canonical
20339	3NL39fL63AKZPqGNkstkhw2vcF5nGaJ4T1FvNWFoasyW8tgusWmd	20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	149	1283	366	12463	12672	jwxwdSMjvPdkHrDY3zeajKLosy1gzvpiTZFAXQMNwdCa7sAd9aA	10244	14454	14454	1618540920000	canonical
14476	3NLubvzZGKVTM5VJ8ZhrpuQN9Ck4gbQJrHyR5dfxHmGeYjCGyGL9	14430	3NLgLuwXPnFce1tgtGLrqdF6W2AcUEg7SiJJUJ28NrEDVUtaKqZU	641	970	214	6301	10581	jxJnWMfpip4uEJD8Wb3wepy6UGPXyDW7dNK68L1nAgehfA6J2bp	7167	10451	10451	1617820380000	orphaned
14425	3NLyC33j639CwngrdThH6iLyXgzYoApzFvT41jciobhbC2nnnWcs	14404	3NLbVQQbDYsHe43Ge9GRDJPJpTxPxryuY8aBmFXF8vaCuyjPMXyW	43	1310	218	6301	10533	jxeXryFEDRqzPgCpGgFVAwjTsYkT6sM51NoPBBr7emqmRkD96jh	7231	10411	10411	1617813180000	orphaned
14408	3NLw2gnavQw2Mqy6xPaWG4K24tigvCm7ef31ADJYvxrap6dLtNxz	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	1506	1373	224	6301	10516	jwidKcKT5Q2svHpdAoi36dqzwMTyu9H98vkL1ikmR78sZKNdg6L	7350	10397	10397	1617810660000	orphaned
14413	3NKLGJDUD9x8oyX6GhHCkyLd4bkgSN5UenFW5vHqBF2MX73bqQ1P	14412	3NK8jpngkjtJcJVCJJD5s74k34iFMx5VCnaAu6wdrMGbJmQQHP1Y	1407	1395	225	6301	10521	jxwfgnQMSsY16BgtVtihB9cPamjnfNmUwGbZQSeD6pbQ5cM5YSo	7353	10405	10405	1617812100000	canonical
14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	14413	3NKLGJDUD9x8oyX6GhHCkyLd4bkgSN5UenFW5vHqBF2MX73bqQ1P	1627	1385	225	6301	10523	jxVQAgoNPtHTFHi2E3azumffXCPGUkwo8VLW2AYbsp2Y4TVZD8Z	7354	10406	10406	1617812280000	canonical
14416	3NKxb2soLjh66edDZutuPFxAW3RywxmJScuR9szfgZETDQtXQ3TN	14415	3NLoUo55npjsAQz2mbFr4p7DTMwVByiGsuR6vK5fGHd4sas24cjH	1534	1317	225	6301	10524	jw9GRVxptYY396ezd7xiWFLS1dq5SFrdJN6vhSBse9CgH7J1P33	7355	10407	10407	1617812460000	canonical
14420	3NLmyX8jAwEEhSM9F7KjQ3pEUX282MvaefP2HhJ4Y7PDdr24PK4d	14416	3NKxb2soLjh66edDZutuPFxAW3RywxmJScuR9szfgZETDQtXQ3TN	1637	816	225	6301	10528	jwZYteJJtNJ1fUhNsTX7DCwBRhgdhJwNxfz1Q9P5TECkVcAYgw6	7356	10408	10408	1617812640000	orphaned
14422	3NKEtLRPdye2noVkcY5pzz9mixL7w4jTD2ggZHAQeww2TT459njD	14419	3NK9wxhXQT9pFrJwjeGKSiVomwrLiriJZ6oQTkmtUuL7xxrmG2QM	1647	846	225	6301	10530	jwMuPwSX6bReW6cECbwmtxAPJYWDaUK6U6tkoEoCTV5oxjsLy49	7357	10409	10409	1617812820000	canonical
14432	3NKuZC195c7pqUpaBkrjyYvP8ZAA5FejFsgMKF8kCWCn7R5G7yMh	14431	3NL8ng8byGvvrHL7YPTVfMVp7xL1h9L7rKv5LjVHB4YsQJPT6gLN	1631	794	225	6301	10540	jwLLdCgWqyXVkqow9X74zCAgc2vyB6SQqvrKpBzXLfVuDESFckq	7363	10417	10417	1617814260000	canonical
14435	3NLjf3H721zXwTirfMEMcBqn2yCS2HnZGg6TsRLq66qjYEsVmBnD	14434	3NK3Ka6LM3cxhZgdnZiY7EokZKSAwEGRTEDVN1Awo6SHsTLzfK7S	1426	998	225	6301	10542	jwu7FZYoWuYH2DRh8Rngow8cFLQkP7xVJVwA1Ps8yFXC1r6RCAi	7365	10420	10420	1617814800000	canonical
14440	3NLACaCteTtGF4gVLw8wKoHvHjJhagyV8zin6VLP5vpePoxDmuRk	14439	3NKwHoEMXT7hzVsrVAYNhsSEuyhGtYvLwBQupceVGzFzPGb2qtjt	1460	440	225	6301	10547	jwFTvtGEbDKaLnnxFqRrywmCN7MQL5YqN9PxczWbxJAseX8EWev	7369	10425	10425	1617815700000	canonical
14443	3NLSUip2x7ovUJQmvBHzLz3ya7zfHQMEjknLm84MRQXVwKBbDqV1	14442	3NLHG45LQ23M4SM5MMwVNWwXXY1orEWPuQECmm2R4ikVHA7iRYRR	1489	1254	226	6301	10550	jxAJbGaYUvWnLSrC8FYDpdrnUf5HdMun1GSpaK8HP4y9GFZQRQo	7371	10427	10427	1617816060000	canonical
14445	3NLU6tPVBtrV4FwxDm1pkGFCVSapnRcc3KhUXZMpwgvKKeFz9iNn	14443	3NLSUip2x7ovUJQmvBHzLz3ya7zfHQMEjknLm84MRQXVwKBbDqV1	1406	1393	226	6301	10552	jxNM2KLzeeQGS77b4ea22QNgq18mgYzcYrtrsf5f5ER7tWc34XV	7372	10428	10428	1617816240000	canonical
14448	3NLR6J4h7JCoiCudYtJhuyb1XabgsvsxfLgiVKzatcWarC225isX	14447	3NKHg4Pxsb1jj4zrzqGPgyZfk13AXPZkzQpx76HuQ18oK8dUJ5a3	1671	1365	226	6301	10555	jwMspkDs21qgEpKhSVSg4TRVS3bDde7BbXdaAyWt6aT93gxYs5D	7374	10431	10431	1617816780000	canonical
14450	3NLS4x29stoogXb9vKsfEQDRqKwMHJ3PgpuZGGuvnDrs9Nb9P51n	14448	3NLR6J4h7JCoiCudYtJhuyb1XabgsvsxfLgiVKzatcWarC225isX	1560	925	226	6301	10557	jxruFEWj9aE323pHwYAfMRAs9H2UDcHRg5WgA8UakYRAoNKNoo6	7375	10432	10432	1617816960000	canonical
14453	3NKJNyN73q333mVSdg5g4mCQkpkSvQJGtryRMbxCFKj9kUo7ST5a	14451	3NKpyDkbiRLCUnkR4VWy6GY2oxf1fR7SeTqxoEcHtCEM8mvcz4wP	1559	987	226	6301	10560	jwHVzT54CXzvB7y4AGno2YYm7PudPnm9ajfDf5cibP1LcaswqMC	7377	10434	10434	1617817320000	canonical
14452	3NK36pYbDf8krnNkTcNF1P4yvPQq2paQA5htwVJgRrrzn4svTh4G	14451	3NKpyDkbiRLCUnkR4VWy6GY2oxf1fR7SeTqxoEcHtCEM8mvcz4wP	1547	1378	226	6301	10559	jwJTbgtjbk746VPGyuziFrf6yHUmGtTB28wUeQkoTitz8WWncfN	7377	10434	10434	1617817320000	orphaned
14455	3NKKidQ53vscWzs85sKBGdSv8DaT77nAf67DX4xYRoHGgkvieAv1	14453	3NKJNyN73q333mVSdg5g4mCQkpkSvQJGtryRMbxCFKj9kUo7ST5a	1633	1144	226	6301	10562	jxTmppPVnaii3VSfGT23xsSfGTdYrz2H1aGo5NGgYkL9xzWKLtj	7378	10435	10435	1617817500000	orphaned
14457	3NLX3zJhrVamwC68PmmZSfTxaqG6x1iTuD6iqQtar5JktQVmw3C1	14456	3NL6hxcXR3iphtAuQCSyKSgymzyGQk6ErUFt83VismNKveDUeFdc	1407	1395	226	6301	10564	jxYNRX6GYetpsJAYmmTAhptbTTs56oGgUuKkkSyxafJZumnL4P3	7380	10438	10438	1617818040000	canonical
14458	3NL9AAY38poFDFYH5BeYVyDiW39HR1zuzSYctC4Qs6Wqma3sJSjA	14457	3NLX3zJhrVamwC68PmmZSfTxaqG6x1iTuD6iqQtar5JktQVmw3C1	1631	794	226	6301	10565	jxdonqqa1LUjhAYw4jtNceTrjc9V7Cjsavdy28QEFz1H2QHcRnS	7381	10440	10440	1617818400000	canonical
14470	3NKPeYTs36KSxtJsZ6HpAnDv5TRUHRG2h5mkxjZd9SUhXeAAhYVM	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	1613	1223	226	6301	10576	jwHSSsQkHtMPrm19qr9P6FunEDFc3gZYvw87H4nbsiDeGDpjEpf	7383	10445	10445	1617819300000	orphaned
14468	3NK7VwnBVRmAS1BMKs2WJx4YX2cbn7z9nGYt9ndvTgBXC1WJxed7	14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	1406	1393	226	6301	10574	jwTJQN1Dr1fJ6758MzsgjuPnhknuyQP7ocKmPa4LxhuRkau9rpF	7385	10445	10445	1617819300000	orphaned
14472	3NLZB5PAjn7WRWPhYHMVH56Bb3icCzmZkH1Ta3ipE9ZUHbg4A9Lc	14471	3NK97Vq5iJ3JU2PQe72GEEDLVxS8m694W9a3tyBdPRLYHcccNAU3	1602	1369	226	6301	10578	jxfR4BwyGNqNfSbLKeJYthUiCT5yhMD1UEUXjkcysKztSDb57ET	7387	10447	10447	1617819660000	orphaned
14477	3NL5f6cK8L7u32tfqYChCpZebqJCf8RQYdGw29SEfN4sp7k7GYgW	14473	3NLjNrd2Gk2hHGqr1NWfk9MEd5r95tWBXAH9qFS5THtv2SyuSajT	641	970	226	6301	10582	jxVQyeziaPnZrPTJccav5DQqSASi6NfDUzHMfBmH2yagiUidrMy	7388	10451	10451	1617820380000	orphaned
14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	14478	3NLGSxetzykDsUmiaoh8hCyRFp2nLFc2mzLut2kiC62caY1XEXwH	1403	786	227	6301	10585	jxLYFE8g2HDERDy3Z3YjkmgbmADrQA5CUtj4RGytZeiTjXdcJL4	7390	10456	10456	1617821280000	canonical
14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	14489	3NKrWG5N3UmXyxU1kzymjGVFQBPLLKnMXpskcq75AFswicyzsDPL	1555	981	227	6301	10596	jxNRmAbU924xG4FFhFcLt4xEr3TrbsXgmADVrRzu1vrD42nREcr	7394	10464	10464	1617822720000	canonical
14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	1624	1088	227	6301	10601	jxr73UCqfmjA9CFAwdcH9KMbjEuYUJ3UogCuiBKzRz32PvHRMTs	7396	10466	10466	1617823080000	canonical
14497	3NLbmAvxW1aDHGFm3XuYKafutZNz9rEJepToCVD2Nz1tHES3Yx1f	14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	1624	1088	227	6301	10601	jxbyFj4bitjK8wHBeaxMXzpTDK6khqmXsF5WnXdUSCWPHCJEDx7	7396	10466	10466	1617823080000	orphaned
14502	3NLdvPebVVP9vk4CoxqtvogwAP5D6d88hjEozz6trZ31fK6apFty	14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	1483	1030	227	6301	10602	jxeSPcXr29Yxd6QeeQmS6WqsJET43VCHqde6vJAj4woti4D3Bfq	7397	10468	10468	1617823440000	canonical
20478	3NL3a1KXQKngoGzRjVSrk8n7iC6jhWZMDUpj8sbBXhfEGVG1vx4Z	20378	3NKvxGzSnpAuikuBRqqAeaHWraPvZQzvWz2wwV5czKa811U85t4w	1419	814	367	12463	12799	jy2ojta64JWQjCjJQn6pwjjpjDMa9B4wfebHJNhMYikaBRStPYo	10247	14539	14539	1618556220000	orphaned
14492	3NKXq5FqaiPwUdesPaikqp6Ro7Mw1QUTka7w2rMHdva7VfbxL3F4	14362	3NKnoPk9LmAhNE4CRDWKYMGQESFMAXi9M5aAg1GNvKjmcWKPGCBb	1549	1116	219	6301	10597	jx3B1bFVSorGF2oRJ44ep5JPUJYWP5Kvqc7v92sgTPsbBb8wAsF	7239	10464	10464	1617822720000	orphaned
14519	3NKEPzSMw7ZKRkdRrhiD5JzU2mF9v2HwoHoFDRBDxJ1sPGpv3KfQ	14492	3NKXq5FqaiPwUdesPaikqp6Ro7Mw1QUTka7w2rMHdva7VfbxL3F4	1549	1362	219	6301	10616	jx3B1bFVSorGF2oRJ44ep5JPUJYWP5Kvqc7v92sgTPsbBb8wAsF	7240	10481	10481	1617825780000	orphaned
14444	3NKRhPKew1azQU7aX7hauWZgU1Hpf7yXxAeBhQQ9ygsETnuV5nYU	14276	3NLaK3CcbDTtdwo8N91cojUz4QKBQEXXNCkomeKDpxZ2EogooRES	1455	1332	221	6301	10551	jxbgUCmM5Sw16nvgL68e9Dd1HMo7cQ3taEx8PSrKwm4bxr9HEyf	7289	10428	10428	1617816240000	orphaned
14429	3NKdzLYCwfcmy1bkgeoniHziwLuXFPfngL5GpRAvkS1q9FvjYKxZ	14403	3NLBPmLLKvAtgJWawgeE6uQbTFrRZ4NaB7duYttyig8MnX2ifyBT	641	970	224	6301	10537	jwpK88AFdQBsU4CGK8uKfvYx9hqNjDEZrFxi3E52hK1K8xHBkzP	7350	10415	10415	1617813900000	orphaned
14475	3NL4JRUwo1K6DHKbiUaGA8GDu6a3ngHPD2HgLNhV8ZPuVXAGU9Zg	14429	3NKdzLYCwfcmy1bkgeoniHziwLuXFPfngL5GpRAvkS1q9FvjYKxZ	641	970	224	6301	10580	jw7DyLHCeZ3SaANPzv4cjGQBEKQm3pLQE9HevF8qgSF6erF9Nm3	7351	10451	10451	1617820380000	orphaned
14419	3NK9wxhXQT9pFrJwjeGKSiVomwrLiriJZ6oQTkmtUuL7xxrmG2QM	14416	3NKxb2soLjh66edDZutuPFxAW3RywxmJScuR9szfgZETDQtXQ3TN	1407	1395	225	6301	10527	jwTaFVLHwks6rUZxM7d4xML5JtvJMq6THz6WdN8L9rNced8epHG	7356	10408	10408	1617812640000	canonical
14424	3NL7gPQoeywnQQNz7jU1DMLZ4QeaBGqQ5dSRhbLmF131G9e3grTJ	14423	3NKKDU3XwR3cbtbiuEAF9v7etZNBBisf5syjwtG2DDTjDxEWG2fZ	43	1310	225	6301	10532	jwCyJoHYhyNmMizkx8YcK91WWdCdRG3iRZWgSmZ4J5Yo9Pc4Vap	7359	10411	10411	1617813180000	canonical
14426	3NLnRpJAjP5bGtL7d2fZSu5YaY1kVGuoCs8GGCJJ5DkE2jFRnBwS	14424	3NL7gPQoeywnQQNz7jU1DMLZ4QeaBGqQ5dSRhbLmF131G9e3grTJ	1406	1393	225	6301	10534	jxevrMSV3DXXoa7gU7F7Rg2VG8f5BbmXhNRrsC7qaDYFoQv9HPc	7360	10412	10412	1617813360000	canonical
14437	3NKZfAnC6oryCuu3pGuqEthwjS5pAqUsbNBfYXZBsgsiUv8Z3XrJ	14435	3NLjf3H721zXwTirfMEMcBqn2yCS2HnZGg6TsRLq66qjYEsVmBnD	1547	1378	225	6301	10544	jwPa9M4pB2MbY5fJVMPh5kAwSSimxySMtxXxUMP1AKznCW9s1x6	7366	10421	10421	1617814980000	canonical
14439	3NKwHoEMXT7hzVsrVAYNhsSEuyhGtYvLwBQupceVGzFzPGb2qtjt	14438	3NL98ZNCoWGjFNsx3HRvqqgKac4yRx2FmFKK2cA616PskB29x8sy	1589	1286	225	6301	10546	jxztMaD61a5jiVhBXzwyuaUr9hH6JPfDnEeUrGwg9HhZ1fag18N	7368	10424	10424	1617815520000	canonical
14442	3NLHG45LQ23M4SM5MMwVNWwXXY1orEWPuQECmm2R4ikVHA7iRYRR	14440	3NLACaCteTtGF4gVLw8wKoHvHjJhagyV8zin6VLP5vpePoxDmuRk	1642	1241	226	6301	10549	jwJeK7MRtmoF7PoYBD9iLdVqkB6W2UEsppHURgHPEGHRHopxAuc	7370	10426	10426	1617815880000	canonical
14447	3NKHg4Pxsb1jj4zrzqGPgyZfk13AXPZkzQpx76HuQ18oK8dUJ5a3	14445	3NLU6tPVBtrV4FwxDm1pkGFCVSapnRcc3KhUXZMpwgvKKeFz9iNn	1622	990	226	6301	10554	jwA4JyAYxWTkdAoDTVWatXAm8UmPvtgjuTmDFa7ZxSbMrW2ThpL	7373	10429	10429	1617816420000	canonical
14449	3NKoDd4HqLpt59y76yBUYxnLEvJMPGTKouWhPerzF3KwyyacxsjV	14448	3NLR6J4h7JCoiCudYtJhuyb1XabgsvsxfLgiVKzatcWarC225isX	1403	824	226	6301	10556	jwmVNdeo3HYgZLvPpXnCwDTV9cLf3scVVayveVKTWjfac6z4T4u	7375	10432	10432	1617816960000	orphaned
14463	3NK689Mb2cEoxBkm2x2ehH1RUeARS6VeVcktVNKXg9MxtuiEVNqb	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	1600	1246	226	6301	10570	jxz4kenpEFS841gRXvQBjzQS4jjeh6rT4UmKn6G5qLhrb3ZfnLJ	7383	10442	10442	1617818760000	canonical
14465	3NLec1F8SydjYEwhjoiDU6gkbBRnPL9tQwWeyHRUnSBqWz1dvDXv	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	563	1113	226	6301	10571	jwVq234kP13AmWGYT8SiCS3aU4dP1vva2c97knDLTXTK61Wqmbr	7383	10442	10442	1617818760000	orphaned
14469	3NKKpVG5n2cNin6uAWDpxSD3LHTP2FAonxrtC6sY75nDBTvZuWMe	14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	1613	1223	226	6301	10575	jxqXpQ6U86VENxpXegqFjm4WLUxKA6cffqNiyoTUcfb91zcEB5s	7385	10445	10445	1617819300000	canonical
14467	3NLaHvQQryQXXvafYwoZmo3uM4pk3NpPtSmeR8ppMQ6ifpXLpWF1	14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	1403	824	226	6301	10573	jwtp7UAHGoohADEcjHjucUQQyBFcd4kkqnDyTt4ajWoccXge84U	7385	10445	10445	1617819300000	orphaned
14471	3NK97Vq5iJ3JU2PQe72GEEDLVxS8m694W9a3tyBdPRLYHcccNAU3	14469	3NKKpVG5n2cNin6uAWDpxSD3LHTP2FAonxrtC6sY75nDBTvZuWMe	1619	909	226	6301	10577	jwVP8UqAG8B1mbvVuqUAGPjTjUcF47MaqooV1s76rUBsW4b3oh6	7386	10446	10446	1617819480000	canonical
14483	3NKMTGc37bWH6mUrYsGAaUU8qBpiw88ENDH5zTjnkRUUEZjtAgfj	14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	1609	1333	227	6301	10588	jxkKu4SmCC4aoFcZZ2eJQopgA1F5Q7PMn7MwHZao7sD7N2pVnjU	7391	10457	10457	1617821460000	orphaned
14487	3NLTpaoyKcoPn7gSaRMXp4UD9JP5TaGZ7C7GDi4bzbTN6VuRwAXz	14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	1407	1395	227	6301	10592	jwLUaXoGgQZV6mmC5tToJjXyhnBAkFsSorf6TjvATjxLSWCm3fF	7392	10458	10458	1617821640000	orphaned
14490	3NLPZwNkf8ivd7jtXu2pRiCjvfW7qHmpLCy4RwHL7TydtkMNWawM	14489	3NKrWG5N3UmXyxU1kzymjGVFQBPLLKnMXpskcq75AFswicyzsDPL	1549	1116	227	6301	10595	jy1Xu33GK7SDUwMWpQNoMrrirhp3zhrFdBdae6Wzc8sN4YekHSq	7394	10464	10464	1617822720000	orphaned
14495	3NLv9CrQ6aeFRW7Z2a27ddxziFshVKAHnwSyM3EqQEf9Hmfwzt9F	14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	1607	1348	227	6301	10598	jxdhWsM4PXP9AnHKuZ52rCiE5hm5T9vKh64uNMX5kznNtRcyJSd	7395	10465	10465	1617822900000	orphaned
14501	3NL9UtTSKttZ1xhc6qGUkL2GBuiVsS3u5r3trm6ymqytPttUtRNn	14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	1406	1393	227	6301	10603	jwUSwrvTR2PUkpTLwUP2XzF9WzH16eZFuWbmzrKHkgmFY4HwRp1	7397	10468	10468	1617823440000	orphaned
14503	3NLNnY73iBR8RRAXqroGinKmFPHQ61ybcMYHUG9uCMVvHituMoWh	14502	3NLdvPebVVP9vk4CoxqtvogwAP5D6d88hjEozz6trZ31fK6apFty	1553	775	227	6301	10604	jxu2729MvrGFP1voUUwARc8W6wnnhHsww7rjs881DKPcZdptvQk	7398	10469	10469	1617823620000	canonical
14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	14506	3NKgEQwYQDweZbSSvLqfWzGYLHMwiygmx1eB741YE6c9crHL9Gcc	1637	815	227	6301	10608	jxy5xYbbJSvzy9RGTz3bUBSeoxPgXWR2P7Jiz9AH2xmvo2BfQaW	7401	10477	10477	1617825060000	canonical
14515	3NKjSKm3XsR7N1M3GPkijFxPNdJiUcU8tfyPnbDtmkHTQFP9PLPA	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1448	1311	228	6301	10611	jwabUEe69ZqdRhPdeVfxjrKRZULSo4BiJaTLBkVwHw5o97eGA9m	7403	10480	10480	1617825600000	orphaned
14516	3NLhxCvEFZmJeA4mhQ9TVN6Zd9unfVSYDdjN9tpWx7Hf2wEqYm7Z	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1403	824	228	6301	10613	jw9xx4pKv5ABiw8TEYJsYvGuALxkoRT4mdv1WGFHzbQ2mRAi5E2	7404	10481	10481	1617825780000	orphaned
14521	3NKmA62eqX42eWtAwjzMuc439mYEB4f3GQWi9gMmqDSnhcgEdxFj	14520	3NKeSX6Dr94Jmsat9MTpT9xFajAcsvWLXGd2zoYHzD4R9ZPLyLwE	606	1295	228	6301	10618	jxWN2XRZqYZWHbXMXNeBbsDWaNkzqdNm8PfdDPP5ME3DHWoPYV8	7405	10483	10483	1617826140000	canonical
14523	3NLf5Aa2raeiaixdXTtRaMRLD5Qj27Bmc8MgPYhEn5AS36zdUP9D	14522	3NLDweopypXEqekt2fmutdBF8oMPA3nidQhHrKcPy4XGFw2yBT6G	1406	1393	228	6301	10620	jxyKfvSDzXMKf5RtMRwS5BE3q2RQYqxcXjFWJmjaJqzZCREnCnw	7407	10485	10485	1617826500000	canonical
20579	3NLhE6QAc9isGUKaA1iKDwP6ZdM1oS77yWbAUnkUVcM22k6qfCHM	20478	3NL3a1KXQKngoGzRjVSrk8n7iC6jhWZMDUpj8sbBXhfEGVG1vx4Z	1419	814	368	12463	12887	jxHHuH4phHFLjqZTj6izXvcUa5cAdAPSxHc9Bzma19PtkAWSG2V	10248	14598	14598	1618566840000	orphaned
22183	3NK75c8vX3tPUkbXiEnoC3EcjXQgoyrUBhd7VhLkTce1ohaZ1eH1	22181	3NKec9TQrPYxRR5nrbXiFiCTCBHffatSbMoVvRjep4W5b1GMR9i1	1581	778	408	12463	14312	jwZtxLsf9ZLZeU2RLYmKQTqaYTSi5PTu45rGVTjLEwB8UGTqWFB	11100	15626	15626	1618751880000	orphaned
14454	3NLiDFWrGJi2Mq3u9LPjLyht3HmyVoNnTajqH5qH3LaWW1nSaGAD	14453	3NKJNyN73q333mVSdg5g4mCQkpkSvQJGtryRMbxCFKj9kUo7ST5a	1648	1284	226	6301	10561	jwWqntdRQpmxmm6JsPBRuahfqSKdY5dZaR77apWnKdwgJHkz3d9	7378	10435	10435	1617817500000	canonical
14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	14458	3NL9AAY38poFDFYH5BeYVyDiW39HR1zuzSYctC4Qs6Wqma3sJSjA	1445	1044	226	6301	10567	jx5G4Bu2Mhs9gC2pwjCck9vRQg5GRqALk4oFYuVy7PXn4JpJLXz	7382	10441	10441	1617818580000	canonical
14462	3NLsMQGmeVJC3VCdhNKfqmzd8iSrb3WnQkLfHDzmQ1yUaCmtGa6v	14460	3NKL68LCypH2uC743mdsoVfvaQhCdkjf9F4L28ZENxDNFk3WP4aW	1522	1322	226	6301	10569	jwx9FqgVp2h41vRP714sDe2YucokAmEzfVVwdY1JK49wqBi9Xqa	7383	10442	10442	1617818760000	orphaned
14466	3NLo2oqDkYmaQ9e5RHW3emp3PPgWnPDPvryzf2VygkJ115tax6Uw	14463	3NK689Mb2cEoxBkm2x2ehH1RUeARS6VeVcktVNKXg9MxtuiEVNqb	152	1084	226	6301	10572	jy1m3mBDxYdHNZpYuyD8FxadsfPoHVVqHh9ML3A24wfCM1sUBg5	7384	10444	10444	1617819120000	canonical
14474	3NLAdzvnQ6UQ3pS3cXmj4fq45QiUcdwXn1YesRJG1mzzi3nK9Tbf	14473	3NLjNrd2Gk2hHGqr1NWfk9MEd5r95tWBXAH9qFS5THtv2SyuSajT	1617	1042	226	6301	10579	jxcxurQeCwQguzT9sCbhFnCkRxnqbFmLUzQZeA5xZ8AJWhfUQ5S	7388	10451	10451	1617820380000	canonical
14479	3NLHqzSeha2MWKiN6mh9Y7GWpz9yD61pZcGB5dVvjnkboLpaVT78	14474	3NLAdzvnQ6UQ3pS3cXmj4fq45QiUcdwXn1YesRJG1mzzi3nK9Tbf	1631	794	227	6301	10584	jwh2TgpawHHG5KsLakbR3ofZqA6qbzt1Bnp92bd8wmEUHoUB225	7389	10453	10453	1617820740000	orphaned
14482	3NKUDKBUPY11EDcTXLfKftCN5Ex8ApfKYZabzw5vaaoiBiwcxqYN	14478	3NLGSxetzykDsUmiaoh8hCyRFp2nLFc2mzLut2kiC62caY1XEXwH	1609	1333	227	6301	10587	jwWQVhttnAQzqHs85NRnmFKVMUqNfuZmA7dTrKeWq2hwmerJfP4	7390	10457	10457	1617821460000	orphaned
14484	3NKEEPgYGWRhPqE7iLs4phZBJP2db2GSbSb55rgb3gxXx4LrXJ9m	14480	3NKtA1AJSFYaLReWNrx6ioG4K81ozmhmYe95JoLJaWPbC4qXRjMS	1506	1127	227	6301	10589	jxToQ4kUTFRQx3Px9EffB7HcLUXcKomkqXuR3JkNS9uSxjtSdsQ	7391	10457	10457	1617821460000	canonical
14489	3NKrWG5N3UmXyxU1kzymjGVFQBPLLKnMXpskcq75AFswicyzsDPL	14485	3NK4jFasyMz9nbZCtBpKuR4Uvb5xdQwZonGZFCJM53WNkRNVDZtu	1490	1274	227	6301	10594	jxu8Qa38pfYnm1pxMCMn55Ha698V3WoJY89mFQq94jhA3ALZ8h6	7393	10463	10463	1617822540000	canonical
14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	1407	1395	227	6301	10599	jxd54mgJUbXwZ9xhunwJ2yCQZngQJpDentLNpizfotwkPNyg6Q8	7395	10465	10465	1617822900000	canonical
14493	3NLjuhaAhuHyBPhBk7MxatFcqLXFaSrpeneQANDELEMon9SmGTUF	14491	3NKjCDJU8bAXiAnTtq21c4VyWG42GRiMJ8aVqiWtLJVBcJRVWQFU	1607	1348	227	6301	10598	jx3mdMxoZXodUWxhnriPFAFZgaAFVp2hTyPxjX8kSWBaLmnSe9Q	7395	10465	10465	1617822900000	orphaned
14498	3NKYS228TfHuhA6w5W6aUdYHkePevyQWu6oVvnouVKSKJeuKQszq	14494	3NLNT9ehp7WJVCvrZbVGGPFM3B9bVNJfNwwnks24oZmZmARccpmz	1624	1088	227	6301	10601	jxSEQVQkrfv1DuasB46bC2zu6Zrw7dBgkrb2QGh3ULTr4mcVgVe	7396	10466	10466	1617823080000	orphaned
14500	3NLHaWM4EQJvnXcGrJ7VXwh79CkfmCsCEUrfXUnAXLWpJqA2Fx4N	14499	3NK9gT8eDy9pB7LUoCBsewLTVx9GUJXNLN2YpWjppefqN96z3Wmu	1483	1030	227	6301	10602	jwoogcpszdfoeksubB6MQSoW5eLFbGb2fh5BZ7YJuojBANDpuvo	7397	10468	10468	1617823440000	orphaned
14505	3NKSmqZT1jEdo1ruGH9stJ7kT8hj8HGmfixsdnMoAyqKBzXqoAfu	14503	3NLNnY73iBR8RRAXqroGinKmFPHQ61ybcMYHUG9uCMVvHituMoWh	1439	913	227	6301	10606	jwxoEjs4W88b45CbCNDpA2nrNrqfpjELRnFGa3pfaWu8GiJyNEV	7399	10473	10473	1617824340000	canonical
14506	3NKgEQwYQDweZbSSvLqfWzGYLHMwiygmx1eB741YE6c9crHL9Gcc	14505	3NKSmqZT1jEdo1ruGH9stJ7kT8hj8HGmfixsdnMoAyqKBzXqoAfu	298	1308	227	6301	10607	jxuwmRYEoZDuahAEz5mFhwDxpk1D9XkJScZUKvgqYbZmHd1WxJq	7400	10475	10475	1617824700000	canonical
14509	3NKkaXrcqHZ9mzYnf9DdqmcPJEuCYd4VFPHQevigJuVeF5xwJhM8	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1483	261	228	6301	10610	jxfc7c1GVETfyeXJMoQLJ2LwGDB67WeZknpGAGbUZddPJJRWooh	7402	10478	10478	1617825240000	orphaned
14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1407	1395	228	6301	10612	jxm9kvrLB2wFaAFo4RNGzwsSMMGKe8yVUMjH3bVFYE9nfLEKDZj	7403	10480	10480	1617825600000	canonical
14514	3NK3DwerPa9q4v37iQEhNSxWZoLfzoyBKXkNoRE6VoE91f4gFFMW	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1448	1311	228	6301	10611	jxA7g6qYYn3fFmhBCrPYxNQLyUsaucgoJxNgH34sX7xt6uSUmTR	7403	10480	10480	1617825600000	orphaned
14520	3NKeSX6Dr94Jmsat9MTpT9xFajAcsvWLXGd2zoYHzD4R9ZPLyLwE	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1594	1080	228	6301	10617	jwPDppth3f6shhG1pb4gt9Qfr7K4QDvL1oYi6HmyGJgr3p2M5pz	7404	10481	10481	1617825780000	canonical
14518	3NL3zcZgKrZkx3aBFHuX611Vir53bosF5r6FRUy8G3dUTdzSJ3FP	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1549	1362	228	6301	10615	jwLXEsauuAYNVQ4SwPq2D7MnVy1G7AgBK7tn32CNXZNZA1j4XAZ	7404	10481	10481	1617825780000	orphaned
14522	3NLDweopypXEqekt2fmutdBF8oMPA3nidQhHrKcPy4XGFw2yBT6G	14521	3NKmA62eqX42eWtAwjzMuc439mYEB4f3GQWi9gMmqDSnhcgEdxFj	1585	1120	228	6301	10619	jxRfiBThXoPSQLMWXWtJYoJKoHpnwzBUDuNz13FkJej5aLVoqQ2	7406	10484	10484	1617826320000	canonical
14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	14524	3NKLwcZdUCdAJoHBnzDPBdbWeyN9rQiX2W7VhPA1J58wugaDAEYw	1406	1393	228	6301	10622	jxKuyu9q28MCdMFut4YH7b35Ecf9WzjyxFFexrw3V59Yq1m7KKz	7409	10489	10489	1617827220000	canonical
14528	3NLP8EAEjKMw1fGBRwR4qKGAgnuh1cVaTMtCcusPS3C9RPhrETbs	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	448	1305	228	6301	10625	jwXXPi4P98vMrwUEn8qYhiKZvpx7LnioFsirqPWCSggDypuMbZH	7410	10490	10490	1617827400000	orphaned
14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	14529	3NLFkaDzyYV5Sd4DyEPtTAT4Wm6G95stMEsfJFF7xXAFBCybWqWN	149	1157	228	6301	10628	jwbeJavy9TaPABNAW454gNH1C4f6teC8PFU1otk64qC7c5YpqGM	7411	10491	10491	1617827580000	canonical
14533	3NKaZdgChgdxBXR6y1upNbYgG1dzyT1zKzrp6DwHgRgUi4WuHwU7	14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	1402	874	228	6301	10630	jwyCAxGpFPUnZLLtvwT3KmNjoAEe2KD6kJa6F6CDHN36KeD1iua	7412	10492	10492	1617827760000	orphaned
14538	3NLbiYr1tZrk9piHbnMJ86jZgV6GZ3SwsE4iwJJtLCfbwoEt7ri5	14537	3NLdmwBepUoDv8mMR1gexAj7rJYBCdF8SiddzM8A6vpexgFhE8DY	1407	1395	228	6301	10635	jwx9QF5m1e6af2KsSQdKeLRZqbdkwrNEZ4CwPvonMdQxmwEDpvy	7415	10497	10497	1617828660000	canonical
14541	3NKD97g5GghYhmTpXWYjs3mJ6oyHEKY4ybPVMU7wUS3vPa27SWuy	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	1403	823	228	6301	10638	jxX5G8Bb9dV6bziiUGWumVv1kww4dqceMNLoEdPcPpLydPjE4mn	7418	10502	10502	1617829560000	orphaned
14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	14546	3NKdp6WFZXnZDD5hMnFAs9Pq6n9V2e4notWLoB79mVju99s79qh1	1672	1159	228	6301	10644	jwPyh3GvfM7pjH1W2FwFV6QY2osvGydQDPb2k8QPTR2Ccs6iUQc	7421	10509	10509	1617830820000	canonical
20624	3NLwLyBeFhYv8EMfxgyAHBTcWgnoadkGwvCuqC5y1rPdppMLJY7h	20579	3NLhE6QAc9isGUKaA1iKDwP6ZdM1oS77yWbAUnkUVcM22k6qfCHM	1419	814	368	12463	12927	jxHHuH4phHFLjqZTj6izXvcUa5cAdAPSxHc9Bzma19PtkAWSG2V	10249	14624	14624	1618571520000	orphaned
14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	14507	3NKvmAjxEgFzCw3Eq89kdvxiP1THTZmcWW3zCd8sbPZ6CivdpJGy	1622	1356	228	6301	10609	jxb4AZjxLwTTdGk9HyvVYohXgrAtLigfcwjrSN3VL4Z9dFUrwaQ	7402	10478	10478	1617825240000	canonical
14512	3NLZgC6WH4AjHUzRAdrSXmrnkfs8msjqUNCbQLRJA9yqF4VGsMmB	14510	3NKhwopxoFUpgX3VkA3z4ogXPwX5LPCcqKHHXrG7MLaYJJ7bBYaD	1448	1311	228	6301	10611	jxQcsnkJhn3ouCdJQ3TVqKXgz4rgsnZuBdgYxU4peJa4AH3xB7n	7403	10480	10480	1617825600000	orphaned
14517	3NKSoYrund9QwiTAKhZLEn8BGmJ4KxegQmo8UcErVWnkMKvTNKK9	14513	3NKvDyCDoeY5jwL6WiaargVoSTKp8CSgoFPYSZxdyusTPWytJbAJ	1406	1393	228	6301	10614	jxE9K5cabsEoQu9LVsbpX7tEPeq7ntXZSsvjt6xrnAwEc1swoTp	7404	10481	10481	1617825780000	orphaned
14524	3NKLwcZdUCdAJoHBnzDPBdbWeyN9rQiX2W7VhPA1J58wugaDAEYw	14523	3NLf5Aa2raeiaixdXTtRaMRLD5Qj27Bmc8MgPYhEn5AS36zdUP9D	1589	1040	228	6301	10621	jy33u4m54kzkr6Xh49Fh6Tf2PQYFRfgH1ZNkf7Fh8cg9Gixzgzp	7408	10487	10487	1617826860000	canonical
14527	3NLxf3ohg7ZHhyPYDt6SJcYeQRFeXg5RGXEekj3arRX1bS6yacJa	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	1407	1395	228	6301	10624	jxnxevdQ9cxknnxPwgoL8pHxx3vQVyi1CZkPkscXpUqPvwze4nX	7410	10490	10490	1617827400000	orphaned
14530	3NLp4S9wVSEd9YAiD6avpYyxsTPL2mywBStuGNK4eSH12s7KqbwQ	14529	3NLFkaDzyYV5Sd4DyEPtTAT4Wm6G95stMEsfJFF7xXAFBCybWqWN	58	915	228	6301	10627	jxX5j6zrQHW22T6pRMEsJzXdCkCB1est44zx6Wtj4EXp57z29Dq	7411	10491	10491	1617827580000	orphaned
14535	3NK7gwzepEvvUX8zhBsSgjXj57zLN7XvHiRG9bskcZxNCMEbJoUB	14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	1406	1393	228	6301	10632	jwvwmZ9WjahJcGBvhYptxXZt9KKNUKfETwR6JhAarhSgGHgFQFs	7412	10492	10492	1617827760000	orphaned
14536	3NLK1knJ26qe2Hg9KgkyGsNziHRekNCjcNYSqHcoPabZxh8KpNnW	14534	3NLWt48q7MninuPrCosS8bqJKmNSFeY7boYqQRboQoP7gPpYWizR	1407	1395	228	6301	10633	jxx2Lmxa7tpPXTjSfLyzjPDtn1RVKQLwU2SsjgmhU7CXUoEBzaN	7413	10493	10493	1617827940000	canonical
14537	3NLdmwBepUoDv8mMR1gexAj7rJYBCdF8SiddzM8A6vpexgFhE8DY	14536	3NLK1knJ26qe2Hg9KgkyGsNziHRekNCjcNYSqHcoPabZxh8KpNnW	1594	1080	228	6301	10634	jwFEwQdu1shiCk7yd3AgSbcRq4FLh4cq3xq3APVQXV2XwdWzL4e	7414	10495	10495	1617828300000	canonical
14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	14539	3NLcUuSYkKbrVsson8faVsM8VCHAh9f8X1NdoA2Hq79TTMvEq6iN	1522	1196	228	6301	10637	jxLCegAQ3DQrFrS8vyJXq5Bont76RFw7u7sN63rXR1Um7Au2B4C	7417	10500	10500	1617829200000	canonical
14543	3NL39U4QNLHqnn3pNXzDssWs8SDPx1iNYJuE2aMVzNj6ybBfhYXN	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	1587	1357	228	6301	10640	jxERCNtDkujRqVxyXdGK4ZajAzqDi9f3WDrYxaYjg4mBjn33Ect	7418	10502	10502	1617829560000	canonical
14549	3NKdSMntRKe3V785AzjbGBHAsUhoFiKEXxnWZZcf7hGuPRaA8PMa	14542	3NLov3hKzyboZSzQLja772oU2tkhEnWcqMrw3PmpEHaYAxtV1zux	1611	1095	228	6301	10646	jxJs3UEAk8UR5G97ecZo6vW96EHn479D6EP8mb9yF9hGApCFrnb	7419	10511	10511	1617831180000	orphaned
14546	3NKdp6WFZXnZDD5hMnFAs9Pq6n9V2e4notWLoB79mVju99s79qh1	14544	3NKiwoqxCaNVeEUiCWH9husYzsrZPcJquBiWbo3bs1424PL7AvWe	1657	1098	228	6301	10643	jwtshCKfLKQBP4Qoiq8AibqLLHjYcBZMLcXC4DVu3WotAQ3ozg7	7420	10505	10505	1617830100000	canonical
14545	3NLLtvR5Eht5xVUGBrAzNNMXT5VoLwrH6JzNPAx94AuwBZYVUcE8	14544	3NKiwoqxCaNVeEUiCWH9husYzsrZPcJquBiWbo3bs1424PL7AvWe	1503	1277	228	6301	10642	jxYYDaaeBeKUhVJ6N37N5BtfJsgtqY8con2wufWFLuMn5HoBR5d	7420	10505	10505	1617830100000	orphaned
14551	3NKbEzeKk8FyjADnb9MGs2Ph9Q16LuYdyGzEdRhBo176qpR4kAtX	14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	1555	1101	229	6301	10648	jxuEtFTgZmVUwsec6V39oQ2MDRgH4QTqDyfSoaSukfp25nY2xRi	7422	10512	10512	1617831360000	orphaned
14554	3NL5Ubb3TYCmc4kyorLF9ucaSLtjaKod888rKALLtZ3Y5Htm2LpJ	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1489	1380	229	6301	10650	jwHeudThk4HbXrQ9bjvYo9eqkpNtADSTQaeXNZGdhYNMnARfdn3	7423	10513	10513	1617831540000	orphaned
14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	14565	3NKWqo4G1Q5ym4M2Jx389srXywHkufoR2BKTQnb7BMU1C4dcHvhq	1506	1247	229	6301	10661	jwfSmNetet9QfPoD7ppeEkmFhXkSxKWcFfe1VWmEECqo873vZHF	7428	10519	10519	1617832620000	canonical
14571	3NKsrSXuNu9TJ7pozT1Gcbk4pr7UNhFnZyZLFkBKRiavzp6n9y7r	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	1631	794	229	6301	10665	jxwdoCrV8TYtKawRv6s7uTAiBnL5B8VGndVzRPpzV4Dq4ffF6G2	7429	10522	10522	1617833160000	orphaned
14574	3NKuRpC8eJcUwhz7TPU9Y9RomU2rftVKADNfBasFursnCk8ogvej	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1646	988	229	6301	10666	jxoJGRX8oXPSqVu3mVu5j8kBfvR29z8X3wUWrcN2ez8pYwjzEQM	7430	10523	10523	1617833340000	canonical
14572	3NLLrecye59C9Fg94B6zezad2aSX8QZQU9Sgmh9wnW9BVofymB44	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1646	988	229	6301	10666	jxDvrirjUHPwhGqHqrSDwwL47PfrYNzRwAmhFgMMUz9PEAAcRNC	7430	10523	10523	1617833340000	orphaned
14581	3NKSWctdKzQSxds2hibkKGR4LT89M8CThReJKKY5c1ZpghSESkZE	14580	3NKxaSoRrb7qWawDMDyzttr5ujrZb22Pq7GmMrEGJL5J1HAoneQE	1473	185	229	6301	10674	jxgBMW5gB3fdhuHL6APLfqcxkhSG4bm4yXf7qZftZVgU637idEJ	7435	10528	10528	1617834240000	orphaned
14584	3NLTg6eEQJUnHPCnkqwtCZtR7xUDi8EuXQwDaeMNJtiJwc5tNWQQ	14582	3NKqqaefZSPS1bXG1DXdD6rDnjnCag1UFAVQdqB8PHCiRr7n2dJH	1637	816	229	6301	10677	jxJj7qkJNbvSeKH8h2j9BUccqmPrNzcib4PAjU6mT8MgVC3hJ5a	7436	10529	10529	1617834420000	canonical
14586	3NLAetfeiKZiUA88pDj7NX9ZNHynSPNL13MsWdQ6Gnv1Ahttz2E7	14585	3NK7irJUJhPRMJ6U7ayinmmRJ3QhnhzTmGwWr3hrdLatA5Ucv3sq	152	1084	229	6301	10679	jwFCnrCXUXEyriwicykPizaBd2GGEx7N8SWYuPfWLZYw1KiwBKo	7438	10531	10531	1617834780000	orphaned
14588	3NLbPbv3HhLQxmscM1jKxnPmbpVzrB5Y69rkChETHHXqXcTAVXzU	14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	1403	824	229	6301	10681	jwEsG7GQcWk9WWiVpXzuR9wJBCUUS5NvQXu7xUWvchsyoesYkL8	7439	10532	10532	1617834960000	canonical
14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	69	69	229	6301	10686	jwL4BUAPpdVcaB9uuKqG182ZnUezyKhaJfFsuXDbajj84PuH8Kq	7442	10535	10535	1617835500000	canonical
14597	3NLCnsm7KFZFBia1btVa46JEVfxMLnhrg2PDazByrqfejU7rKfxL	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	298	1182	229	6301	10690	jxRSEzQoFKBc5Ko5tTunzEpudhSx7gKQL1RdB4rdLaziPZEBuDa	7443	10536	10536	1617835680000	orphaned
14602	3NKBpAQi1ps3y3boEDvbQRnoiCAjr3hXLTsH4sLWwggMbZWNHGVA	14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	506	506	229	6301	10694	jwU8m7CLdv2NWBqqqkv2LzRA62xHoTjxrUkRbfsa3soyxMFAo3E	7444	10537	10537	1617835860000	canonical
14609	3NK6RCLfFSqpSQiAbZ2xziRYVFWZBiqPAniUCm7sZnTFHCXJZRMU	14608	3NLiUUqtx7ZmR8t33Zt6c7Vga7aq9Vs962mZfeqmiPLL8wu5vfyq	1458	1323	230	6301	10701	jxWhFaXX8VHk6NE64HBoYpYjEyy8qUMFQWDSyKWi1PKknrPf3yo	7448	10544	10544	1617837120000	canonical
14614	3NKDAM11jJEHFR7Wc6GFN9XHGNEVjv1CCDZ3PSfGRGxfY2epxqzJ	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	1651	1055	230	6301	10706	jwyuMcjy7RsvYEgfcmW2M5JSVZG1raAWuVdF3AtRbJKm2s9t4QM	7450	10546	10546	1617837480000	canonical
20349	3NL9hm5fLrR1cAdSBpAh6mrYCrBZixarofwYRpCcHJ72AGjJymX4	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1407	1395	366	12463	12682	jx3fBZVzujpymzdK1dioAKgiQwT3oCzPTDzB4UBWYYzsncrXZWG	10250	14464	14464	1618542720000	orphaned
14635	3NK5ajHJn4NkzRXZg5c6uuBz6yJmFunUhzESqSqre3md67XFcBbL	14278	3NLmfK739Dp8xnUSevi5kKVrEANhDeMZTu21qfLBH9fEBC3Br5BG	1594	1326	221	6301	10726	jwdUjhVqsRqqDURBZP1jUwpoHYawzzTZN7mCcrzhjjkDrTxpnj1	7290	10561	10561	1617840253355	orphaned
14562	3NLZqPyhzE8vf2us7ujKYZk8sbZhAStSehYJMm5kxB2YRUt7VgVV	14470	3NKPeYTs36KSxtJsZ6HpAnDv5TRUHRG2h5mkxjZd9SUhXeAAhYVM	1613	661	226	6301	10657	jwFirkcSibGTGA9s3WDrXkXT4CkPLv8ykTxZfAwCF6uwYCxekUC	7384	10516	10516	1617832080000	orphaned
14529	3NLFkaDzyYV5Sd4DyEPtTAT4Wm6G95stMEsfJFF7xXAFBCybWqWN	14525	3NLLM693wSa49E59p5ogP2Z98UkJD5a4KbWx1L9QDGQZ9QapkCJk	1631	794	228	6301	10626	jxBim3CZ6FhZb7zYSyfrjMdeQhvzvy9hvpz9T5GM6p2Vr41Teyy	7410	10490	10490	1617827400000	canonical
14534	3NLWt48q7MninuPrCosS8bqJKmNSFeY7boYqQRboQoP7gPpYWizR	14531	3NLCpeT9Wzje6sKxF5uoYTNoB6HcsTZXioUAaARYcoorJyDetPWs	1509	1194	228	6301	10631	jwn5FoAgyPUP1VpUiTvXbgpYhJuoSAwLZfoHEcGsXfZFathz2m3	7412	10492	10492	1617827760000	canonical
14539	3NLcUuSYkKbrVsson8faVsM8VCHAh9f8X1NdoA2Hq79TTMvEq6iN	14538	3NLbiYr1tZrk9piHbnMJ86jZgV6GZ3SwsE4iwJJtLCfbwoEt7ri5	1483	91	228	6301	10636	jwfQUTUy2kAdF318Bo5d7oBzRy3fB97B6civt88nUNejwwq7QAy	7416	10499	10499	1617829020000	canonical
14619	3NKKWxrbXXVUWzkxjEMHY1ELnQwmEoGFuYcY7ytjGsHv1KPaaHDj	14540	3NLkrCEksBR9teeDmVVNMHuv9Sjq53brs7CwD62ucsRdJNZqgpYt	576	1355	228	6301	10710	jxuLSEkZX22qMvXsCPtqakDSCZY3vnx2wzGHsYTAquh9JhDwhB2	7418	10551	10551	1617838380000	orphaned
14544	3NKiwoqxCaNVeEUiCWH9husYzsrZPcJquBiWbo3bs1424PL7AvWe	14543	3NL39U4QNLHqnn3pNXzDssWs8SDPx1iNYJuE2aMVzNj6ybBfhYXN	1407	1395	228	6301	10641	jwjzG6QmCvFZFwfVvQfyH4bavUjZ5AnNWWqtkC3b2yAfk7HaF8X	7419	10503	10503	1617829740000	canonical
14548	3NLijV5SoxCNPKaJj4ZfTWh9Q1b5uTyQ5i7pmbQp8bZ6Lbvz65At	14546	3NKdp6WFZXnZDD5hMnFAs9Pq6n9V2e4notWLoB79mVju99s79qh1	1553	776	228	6301	10645	jwippGmHdKSk3XU4GHeyrkAVxdvrQF9DDg1e7fEfCbWMdR6RvJY	7421	10509	10509	1617830820000	orphaned
14550	3NKL2m3D5FG2WfNzmGwyRiQcDXzozB1aVVdi6jpiurRGcPr2szX2	14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	1546	1093	229	6301	10647	jwu8fWmKCi5xqPGcqc6bycn6cmFt74LBfmZtcwbsE4qLciuQquP	7422	10512	10512	1617831360000	orphaned
14553	3NLvERoM2uKx4ynYNBS4FDsZ7Z5e2mGKB8LTmMLtTxUihY1EPVr2	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1403	824	229	6301	10649	jxjPFm6iJrVqdXVWvPJc2nLVnye8oHUuKdhyHqWQSEarRf5j2tD	7423	10513	10513	1617831540000	orphaned
14559	3NLqFggrBFGgf5VuM9pWKfNwabX11S6mscNJ3bi5MSGhNoDTPe1b	14558	3NLeNbAZv9LpwWVsciw5CUXyBV5i387fdpefecgPZBQpmqu8hQRT	1549	996	229	6301	10654	jy1qZuBygQwLJTqDuNEG24Lnwj2DszYgqYtho9QdPEgwj4FaqTw	7425	10515	10515	1617831900000	canonical
14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	14559	3NLqFggrBFGgf5VuM9pWKfNwabX11S6mscNJ3bi5MSGhNoDTPe1b	1613	661	229	6301	10656	jwYAExwdvAMfQfu9Up3ALE6wcBRABL6PaDRhkjZFqirJighvkm7	7426	10516	10516	1617832080000	canonical
14565	3NKWqo4G1Q5ym4M2Jx389srXywHkufoR2BKTQnb7BMU1C4dcHvhq	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	44	1079	229	6301	10660	jy15aBBDYBpZ71wakZtn22spXNzVmFxCHqTLBKVNaML1cuhnnbk	7427	10517	10517	1617832260000	canonical
14564	3NLrXGqgTQZTRPrjoj4Q8c5He8eFJE9CS21b8KQmMGqZ8bAefBSR	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	1651	1301	229	6301	10659	jwHPyAzwPvVGTLo2U52fg1Lfxs7HbzbM5jeEQqf9frsRLABAKLq	7427	10517	10517	1617832260000	orphaned
14570	3NK4N2bAP3QjodLtoqfy492xbs4jWju1uiyQiLvUH6baM3YeSgKM	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	42	1115	229	6301	10664	jwNczgfSszSHfbY3J94DbXcgu4H3FG2ecPpVx49PPBVTNtFeFwq	7429	10522	10522	1617833160000	orphaned
14576	3NLprTib3yy27pZ1aQhM8rF2mBZKP2tcjUnBtddZ3MxAbvKhaBH6	14574	3NKuRpC8eJcUwhz7TPU9Y9RomU2rftVKADNfBasFursnCk8ogvej	1647	1056	229	6301	10669	jwDtr5tXDDKrovmWD8wumdJX2KShsRKFpiY48k3zr3fa5BjVeHJ	7431	10524	10524	1617833520000	orphaned
14583	3NL6DxzUQU1uyEpaFPFWtfWvdeFy44UugNRrao47m98e7djiBWnP	14582	3NKqqaefZSPS1bXG1DXdD6rDnjnCag1UFAVQdqB8PHCiRr7n2dJH	1534	67	229	6301	10676	jwZgisVBpcVKk1P4zikverdJbkk7GQRE7XimTExdLpZEZyS8X7E	7436	10529	10529	1617834420000	orphaned
14585	3NK7irJUJhPRMJ6U7ayinmmRJ3QhnhzTmGwWr3hrdLatA5Ucv3sq	14584	3NLTg6eEQJUnHPCnkqwtCZtR7xUDi8EuXQwDaeMNJtiJwc5tNWQQ	1581	778	229	6301	10678	jwjhaThwruFWpEXjedDxk2XcwtDJot9tbECWyQdiK6RPrRywECy	7437	10530	10530	1617834600000	canonical
14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	14591	3NKuMDzLnNxUa9MRpvaKE6X2MAyvWGu3JQE9HzHyYeUN7BZRqAPK	1608	1289	229	6301	10685	jxk1YabQzygZ4mjK6VJqWp3Fq9G5xdHa7FjeowtSp6MUyLB9GZM	7441	10534	10534	1617835320000	canonical
14596	3NKo7S2Pz6HpecFb9FNDkxjGTFoZfpgnNxbk7YLNJUpUg1WozGuD	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	1559	1353	229	6301	10689	jxfTwo5Vnh7XR1mnDfSZUiJnEvRoisC24HcNU6eR7pGXc9z58ya	7442	10535	10535	1617835500000	orphaned
14601	3NL7nPu4zAdLjH7bEqjgrukYiX3qwY765zWL2SGaCqKVfSUdqXTv	14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	633	1384	229	6301	10693	jy1jpbMSBYdttKxHEQLSk1MvpWm1AsCdw8yWe2VYGSwHixLrJgQ	7444	10537	10537	1617835860000	orphaned
14608	3NLiUUqtx7ZmR8t33Zt6c7Vga7aq9Vs962mZfeqmiPLL8wu5vfyq	14605	3NLR8m7djquDTyDoTayoL69Lb1B3RnJMN5BLQzGtS4ordngDU3Vn	1624	1334	229	6301	10700	jwrg7qVC1jRY7UPHJEM1YkaAogj5r6seEvbaCShZ7YceNEuMiV9	7447	10540	10540	1617836400000	canonical
14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	14609	3NK6RCLfFSqpSQiAbZ2xziRYVFWZBiqPAniUCm7sZnTFHCXJZRMU	1483	680	230	6301	10703	jy2rpFym2aT24hDbJSiSRDVuiiBEqVFUdNGKSZ4sS2gvB7DTsc1	7449	10545	10545	1617837300000	canonical
14626	3NKUiVLVJYct8MHtJmbPUvRbjGurcd35wQet3AGHdiTnQbEuRUsa	14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	1406	1393	230	6301	10717	jwofyZVUs7vmo1DQxS6P4aH4eKLh98H2PYtRR57uG55FPNEDq6f	7455	10553	10553	1617838740000	canonical
14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	14630	3NLKqqR5FN5wCMfSvLdEtUo1v4mDGAoA2VmVRsXP34V74nwrxt3A	563	1113	230	6301	10724	jx8zHt3btaJ8TKrR8aJzufsnZrKwevKxu9S7qUPfLdDGpdS1f5D	7459	10560	10560	1617840000000	canonical
14641	3NLdGENPaSN917uNbnqfYi5VtKdGUxj6JhvuDMwwBvYNpVNimqbT	14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	1601	1022	230	6301	10732	jwK5eQE5zv7db7DwPWDZm7fDKxXqb4vQs66ATE7s3pL5S27fcAv	7461	10563	10563	1617840540000	orphaned
14646	3NLQjQaoN7KZqUSsbovjayYbVtWSyzQzjGyDh97QB1jx8VerdcCs	14645	3NL8CsH955xcBxQcpkqgL4cY3WZSYKRHJtaw81FVcqvDkTrqHpWH	1406	1393	230	6301	10737	jwbyX7wpZtkRsMHWmzvqvucgKBZATNwBVJ13qgF721y5nKz8kuo	7465	10571	10571	1617841980000	orphaned
14651	3NLwSipKiyazwRUqkTWKhM9NVDEJVd6hwT3ftA3ZW8FR18jFBh1Y	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	1407	1395	231	6301	10742	jxrbXBLPHRHckP1cRWAWEvgrFiyVJeNhm782QaEcPneubEAanyA	7467	10574	10574	1617842520000	orphaned
14654	3NKwWKDKBJkPz7xAzeZuWzdwnXv9cW4ZUb6cinPfCfL7aagnVKV8	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	1631	794	231	6301	10745	jwafqP6TCwKBXarrRsL99xJSMrR9FdYSUEMVowtaZBZfZfznVy3	7467	10574	10574	1617842520000	orphaned
20352	3NLuae38guemSbwQoqtQymtGasf83FVa7USvGsjZPLFpNhwxyB2g	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1637	816	366	12463	12685	jwtcj6aJds98tHcX9Hn7bL1Lvcy9qg1aPzCN9PsggjiULsPBZFe	10250	14464	14464	1618542720000	orphaned
14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	14547	3NKJtU8JfERPw3aYWPuNEa7LRM1ZNDKo6WBzYp7C6srst5irzYJL	1546	1093	229	6301	10647	jwu8fWmKCi5xqPGcqc6bycn6cmFt74LBfmZtcwbsE4qLciuQquP	7422	10512	10512	1617831360000	canonical
14555	3NKcq3Nyn1af2jCRint47bWunNafKdokgkCQoFrcUefE2iAS4Foe	14552	3NKfS7nLdeGcasC6PT7t3fhQEtB2qDTFFsq23TTQi8aERSsgZutv	1439	1033	229	6301	10651	jwNZrdPa73sLjWxaPXPN6F1mp6JLS6jLrxWTDeXfkJUmCEzLJT9	7423	10513	10513	1617831540000	canonical
14558	3NLeNbAZv9LpwWVsciw5CUXyBV5i387fdpefecgPZBQpmqu8hQRT	14555	3NKcq3Nyn1af2jCRint47bWunNafKdokgkCQoFrcUefE2iAS4Foe	1536	947	229	6301	10653	jxvhgYEAqqjDbLTDBRwMZTk4W8iexKR5tS5Ti3NFpxQF2UnFpdy	7424	10514	10514	1617831720000	canonical
14563	3NLm28ewgd6irz3r9cowDrCE46hovVyzTRXF1EJn3rFFW8bBZgEd	14561	3NLZyzuPoRyd6AL2mnPcFvjnf63PDsx9xrhJ9pchoT7fUChfE8vy	1489	1380	229	6301	10658	jxtNiiTnPYaLF1VDzWHi8LUfyJcTjtqo3Emt3SbvQks3hzsDLTF	7427	10517	10517	1617832260000	orphaned
14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	1671	1365	229	6301	10662	jwHfAhumHVonuhLkbq53sqrNP6QSBsgq5iBnbKokV4rTCs5XJ7P	7429	10522	10522	1617833160000	canonical
14569	3NKQvZeC4G1hDbUzKtmzELBLq9HQCGQb3spDmjtxEntzpw6WPj68	14567	3NKbDSQ3vgQYKircqSDPpfs1Qop3kCdxU6cuvpXtemrED17xgcL1	1588	1266	229	6301	10663	jw7M97n4tzdBEtaUUA4sdMYxM4Lrneb3dtveMGHciE7ehUdChCa	7429	10522	10522	1617833160000	orphaned
14573	3NKfLTSzU3nm2emLoQUBJa7vrRESydTQzcun4acRsDZLTMBNRCv3	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1594	1080	229	6301	10667	jwDS1QvGqgLSU3niVBHvwZxgadsLmj8mAXyPF8tVSkxzXXAcZCA	7430	10523	10523	1617833340000	orphaned
14575	3NKdVkzGDTduc6kvsSE9e95xLRxHFbMAkrLUE85wdytQNhymn2za	14574	3NKuRpC8eJcUwhz7TPU9Y9RomU2rftVKADNfBasFursnCk8ogvej	1649	1383	229	6301	10668	jwisccBT5CCRT1B5RCuX4pJgrJ3s95DjpFfD2bpJMp7SEWRHmyS	7431	10524	10524	1617833520000	canonical
14577	3NKujRpwDiAkGYZZBSjkf4yPTU5K2oSEzVHLRhVyCv6fE62EgERZ	14575	3NKdVkzGDTduc6kvsSE9e95xLRxHFbMAkrLUE85wdytQNhymn2za	1403	823	229	6301	10670	jwK9kSFqHbMnRTbcvmjhyLwvrzPTeGfwoAf1DXZ6bUnZU8Mdrjp	7432	10525	10525	1617833700000	canonical
14578	3NLTTFMJmHdD6mXMMH5ojejFZ1CcpkuhK9xWVsbfZTvvzZj3C7R3	14575	3NKdVkzGDTduc6kvsSE9e95xLRxHFbMAkrLUE85wdytQNhymn2za	1407	1395	229	6301	10671	jxbm7s7V6pQthS7fgdZakp4bzzSjGbRmW6qQsrZKUsaNqVTzL9p	7432	10525	10525	1617833700000	orphaned
14579	3NKKzB6HFqyrYUiVnBh2P17dPhWzwbgeX8XPMjioLjdW2hfBpEkX	14577	3NKujRpwDiAkGYZZBSjkf4yPTU5K2oSEzVHLRhVyCv6fE62EgERZ	448	1305	229	6301	10672	jwMa1ASJxkh8dN5CU8HYQrv4PHYZSCek3LybjKyMhBwGmvoDjwT	7433	10526	10526	1617833880000	canonical
14580	3NKxaSoRrb7qWawDMDyzttr5ujrZb22Pq7GmMrEGJL5J1HAoneQE	14579	3NKKzB6HFqyrYUiVnBh2P17dPhWzwbgeX8XPMjioLjdW2hfBpEkX	632	1136	229	6301	10673	jxtMMGqs9caqBgmaez3mjUJZ1j9i4hP6aDq3LW7TP5dGT4UR5b2	7434	10527	10527	1617834060000	canonical
14582	3NKqqaefZSPS1bXG1DXdD6rDnjnCag1UFAVQdqB8PHCiRr7n2dJH	14580	3NKxaSoRrb7qWawDMDyzttr5ujrZb22Pq7GmMrEGJL5J1HAoneQE	1508	1387	229	6301	10675	jxeCvihViD9aAHaUbear9f9hEhCRdkkMW85Ty9Jo7uLouFfJgQM	7435	10528	10528	1617834240000	canonical
14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	14585	3NK7irJUJhPRMJ6U7ayinmmRJ3QhnhzTmGwWr3hrdLatA5Ucv3sq	1406	1393	229	6301	10680	jwm37VjyVKedZrFJbjoN65ZjL9Hfr3rWFJW3fqt38FKCHaPYDHo	7438	10531	10531	1617834780000	canonical
14590	3NLPU8NaoJLBw54VdzubDKSHTX6N94H41idxpdkkuu4AtqLM27Yk	14587	3NKpXfcpvUVx6uM8e8tTbi1BBnxh4Vfk6mD2U8Pqi1dPBZUk7LVV	1637	816	229	6301	10683	jwtf21vp8QwKpax7nbEMTj5FauUB7Lhm9UCvnCyPV5hPvKcoXdU	7439	10532	10532	1617834960000	orphaned
14595	3NKB861EadhDt8NKhmNbHRuChaPjY3mExUutxQDdCsfyEUpBxguK	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	1600	1372	229	6301	10688	jxCrB33htvUX3YjRoAh3GusFeWcpuFNCnS6wY8FjNzoiLgLN7Gj	7442	10535	10535	1617835500000	orphaned
14599	3NLXpZmHDrLhaXedG25nYor72R4W2wic75D4GQZxbrZnawpZnmnN	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	497	657	229	6301	10692	jwWyS94XHmVjvf1jgEb7CtEYB1DBx1QMpUWBHfSNHm9BJUpiBQi	7443	10536	10536	1617835680000	orphaned
14600	3NLNnzU39BhqwWXArZ3VH5kpN1DRkJLBRCD4yyZBkVcAQTa295js	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	497	657	229	6301	10692	jwsKN736kQ16aM93yXAbT6YSxhMmMmUweFqHKtS21GxVGAyhMXA	7443	10536	10536	1617835680000	orphaned
14603	3NLUEk5tWnGDmRArGQ5fCxdALgdhwWkxCCEs5emeaqzPVk2bPUHR	14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	1631	794	229	6301	10695	jwM1xV4x6W9msYWboxRFgFH4Va1H5UARvGmrvM2kY7ELbKxxpXC	7444	10537	10537	1617835860000	orphaned
14605	3NLR8m7djquDTyDoTayoL69Lb1B3RnJMN5BLQzGtS4ordngDU3Vn	14604	3NKofUKEcQ9vNVVhewY2YmjLGfrzyEFCm6LkdzxpG8484bqb6Tnu	1637	816	229	6301	10697	jwzGKS6Qh8G3c6LGb1tqzGbfDk8hUTFD8LauiSPXNGG9GS2y4yk	7446	10539	10539	1617836220000	canonical
14613	3NKVdbgFoVSPiBXTRgejuSt15HJ89GDLR7Cuki4FidrTJu8RjwXb	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	42	995	230	6301	10705	jwHPjrYkEGbD4tvyTF6rtPb42n6R6yoLua9izL1jyLX8rp2q8xq	7450	10546	10546	1617837480000	orphaned
14618	3NKxEdPF9wJSnP8xGxzz4r3aQ547Wn21boa5Gk6WWACAHNUxSJH4	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	633	1018	230	6301	10709	jwNLNhUUoosbi8cLREiVv3AbWqCHSyRAFtry6rSi8dvFGJts1wN	7453	10551	10551	1617838380000	canonical
14625	3NLWhv17hq4aUdqDPVCJNeRNjFdZFEZqSSLiYMAFEAaSJH1uaHqZ	14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	1587	1231	230	6301	10716	jx1PZ1APudRcpNtcqKawTdGtzofhbWxvS7cwJMwq6Qug5FvdpNJ	7455	10553	10553	1617838740000	orphaned
14627	3NLYY6yDTyTqCWHfu8TtfpnRuR8fuEQtGVsmHE1cS3kGizwWSrZM	14626	3NKUiVLVJYct8MHtJmbPUvRbjGurcd35wQet3AGHdiTnQbEuRUsa	58	1035	230	6301	10718	jxbhrVF6mrtjMZ9tE34QopKbpzQdHhPH5H1h3zF6XH4RkVcnRya	7456	10555	10555	1617839100000	canonical
14630	3NLKqqR5FN5wCMfSvLdEtUo1v4mDGAoA2VmVRsXP34V74nwrxt3A	14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	1457	1391	230	6301	10721	jwsF8vtBc2cX3E2SNBxfLKN6Pg4L5ZDjxR5714W6W7SBmjz2ewF	7458	10557	10557	1617839460000	canonical
14632	3NL2BxgrB89CVpasCFcuqNK6ECBtUbvt3mY63YgLFN2GNpk3fPLb	14630	3NLKqqR5FN5wCMfSvLdEtUo1v4mDGAoA2VmVRsXP34V74nwrxt3A	1439	1279	230	6301	10723	jxkuGrPViQdcU78RanfuVo7uvgf5qZgeUzaTpVpE5UCMBYBK8Ny	7459	10560	10560	1617840000000	orphaned
14638	3NKfU72JNrfsoDvohUCVL5k8xBVoCvEedjSz2WFghxoWU3QXJjo3	14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	1406	1393	230	6301	10729	jwf61NeMeiyafr2sAH8XgCBtNRuvrEvz5DVHmTLSxmeu2SNw6nv	7460	10562	10562	1617840360000	orphaned
14640	3NK64m7tAYL8274o8CyoufTT1fCiT89Sy42QxVYeWZhhVQJnwpdG	14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	298	1308	230	6301	10731	jxCqVoAxnWKAp5EKQ8Fa6ZYcu6KJ4qAyDH5T1WAcDuNpT4LsA2L	7461	10563	10563	1617840540000	canonical
14645	3NL8CsH955xcBxQcpkqgL4cY3WZSYKRHJtaw81FVcqvDkTrqHpWH	14644	3NL8Z44E24zGm2YkLop8enBZuAmLdZUTpRCNYWX6Eeh9BjB11qEq	1553	776	230	6301	10736	jwxNi8uvjq5Mh5ivgMNeSKuE2cgH9Pud9JkJ9MA7jgrL1Fnvaug	7464	10570	10570	1617841800000	canonical
20377	3NLJ48A1YgG92fDXykZpp28t8WHz1AQRZnzLTNXAiGm5KE8xDVHG	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1474	1329	367	12463	12708	jx1CTeZgwZgqfT8QQfDXNfkf9bpjnFDwraBPFEgvo28GPXP2fsL	10265	14481	14481	1618545780000	orphaned
22665	3NLFXnRo4haKpTDoL9kiAnBHWioxtZLJpHYxvGtWbvxzCHvzjN76	22188	3NLF7o9sJ8ky1rSwZgfuKM9wfuBWusxtV3QEaacZwtSr1CmqsyEY	1637	816	409	12463	14749	jwbNdfUJJMfqcWFzqX3pWHADoYfULqqLPfuu4MQ6cjSg4uaG8E4	11105	15954	15954	1618810969360	orphaned
14591	3NKuMDzLnNxUa9MRpvaKE6X2MAyvWGu3JQE9HzHyYeUN7BZRqAPK	14588	3NLbPbv3HhLQxmscM1jKxnPmbpVzrB5Y69rkChETHHXqXcTAVXzU	1547	1252	229	6301	10684	jxcJ84ZTCMpmmp1g7363K1RvHexo1c3D6WFJwrKxaC1UJxsHkdy	7440	10533	10533	1617835140000	canonical
14594	3NKW6biJNekoYLXnJRDuPdg9FRc3vdEckLbrRtWFZxpTHDeRVc3N	14592	3NLd1WojbBw1Znm8VSQXCrBKrnMpq1knzwV3hnStaNaUZyg9mEjf	1460	1324	229	6301	10687	jxwNEG9fU8H7KT3uECymu9Hsq8xEyzTiB8mNqAjY2sSARmTuAkk	7442	10535	10535	1617835500000	orphaned
14598	3NKdyMHKP5FseSRYu94wwKc6oxpHSUKWNT72ARS1oGZ4Mm7PNMFF	14593	3NL3yepebBxv6EcTS4YovRsjHD3PyGELHCNAmM1Zp2wMXA87jbr9	369	1312	229	6301	10691	jxkjd5QABf1GuoUoYsnm5p6oKsYVt58XzjLkBxcAN2KBCyUVw15	7443	10536	10536	1617835680000	canonical
14604	3NKofUKEcQ9vNVVhewY2YmjLGfrzyEFCm6LkdzxpG8484bqb6Tnu	14602	3NKBpAQi1ps3y3boEDvbQRnoiCAjr3hXLTsH4sLWwggMbZWNHGVA	1407	1395	229	6301	10696	jwxsHFw1Kwe8bBcM7RdKX6qvXuxitTgAUC453Lfu7tSe37Yxm6u	7445	10538	10538	1617836040000	canonical
14607	3NLvPFWne7CFLu2g6HW95Z81kRcpa2bSAJYqjjmgt9snkuo9AqY4	14605	3NLR8m7djquDTyDoTayoL69Lb1B3RnJMN5BLQzGtS4ordngDU3Vn	1406	1393	229	6301	10699	jxeVs67pnU2V4W4j6No84KDpjQB2acNLjyE7vZ8hpWX8JiywqFV	7447	10540	10540	1617836400000	orphaned
14610	3NLTotp87tYYXQ6vtYvvrZbgUPvN9VNfgLhbCkNnMYdMznwPgKKt	14608	3NLiUUqtx7ZmR8t33Zt6c7Vga7aq9Vs962mZfeqmiPLL8wu5vfyq	1594	1200	230	6301	10702	jx2sPVn1PA8LiSdt82K9ffLqZx4Lhff4seTsXWJp6QetZma7JXW	7448	10544	10544	1617837120000	orphaned
14612	3NKCrNLhBQA2fvLLCChWv6ZjgEG5etAAcCRodGFDpYyQx86qvxet	14611	3NK3rMCfXYxwRuQ8wYjNYVEH9mJgn9ZUhDY7jCcKFhmRJEcxsnFT	1407	1395	230	6301	10704	jx3MRZMtfizW6HtRS7PNqKHiKFCph3Nhi1mB1jEetqudmCrbKRd	7450	10546	10546	1617837480000	orphaned
14616	3NKKHWqzSZ7ZHPEzCVsZjmrMkFeYEtjGN4VMYExjjjjdy3LQRNK1	14614	3NKDAM11jJEHFR7Wc6GFN9XHGNEVjv1CCDZ3PSfGRGxfY2epxqzJ	1403	786	230	6301	10707	jxwKW8GLdAsvyhkPTnC19bNEB4RotSps8fAqPmq1Tztf5fdEzoe	7451	10547	10547	1617837660000	canonical
14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	14616	3NKKHWqzSZ7ZHPEzCVsZjmrMkFeYEtjGN4VMYExjjjjdy3LQRNK1	1585	1366	230	6301	10708	jw9ZibWkKckzJmo8tCoQqGCgiVgmqpokr61ES55mRBhhuPfz3Ux	7452	10550	10550	1617838200000	canonical
14621	3NLSAw2aGhCHP2JaehF8murieF1CFYCHCnD9HWFgU6JYmtg5ATNc	14617	3NLZPvRnT9oCpbUNQMg99596wAqzytaXHNL3KBYnKexZCCbXnfTv	563	993	230	6301	10712	jwjeQApBNteFzdoikjnWRSrtEB3aSEPN7eFRBQXVA3TorGT8zCg	7453	10551	10551	1617838380000	orphaned
14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	14618	3NKxEdPF9wJSnP8xGxzz4r3aQ547Wn21boa5Gk6WWACAHNUxSJH4	1406	1393	230	6301	10714	jw8mW7RCHF1wRmEQxqVowmua8tLsXNvAQ7cCcQTT6pvPVcnD8zE	7454	10552	10552	1617838560000	canonical
14624	3NLGQ4oaptLoTou7AQTpk3MUPF9ZoRQgrkWtJVzap9aJmtbcLSG9	14623	3NLBVxj9KQ8EwTc2Tt8jjgc4Bp475D5Mh3NYYdYH1LN2jkXpaQxB	1403	786	230	6301	10715	jwk4x5pcYZfRpMWpJxRDh8nbNVj1KYkH5GN16h8BkdAmTu2bao8	7455	10553	10553	1617838740000	orphaned
14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	14627	3NLYY6yDTyTqCWHfu8TtfpnRuR8fuEQtGVsmHE1cS3kGizwWSrZM	1529	950	230	6301	10719	jwPz9HF642NjD827iZRzEgXFGGQGLtPNFsxFTzdp9iLmac1hUag	7457	10556	10556	1617839280000	canonical
14629	3NLgXtLsPW8us9gzhbHpobq7u2wNYRQJtvAHdmfoY5Pdb8KrPA3T	14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	1405	891	230	6301	10720	jxP2xCnTsUU4PUR8jUBfNmheyiy6hFmi8VCH3LE5GRWvG7DQ2n1	7458	10557	10557	1617839460000	orphaned
14631	3NLDRtfJtPeSLU5HxXGNgR4XHeVxirYX6omSkv4dAfwaygF6voMK	14628	3NLGTKwS2j2LWBPed73nakhP1Yua7Dc1NPWKqHoNkzChsbNbvqCe	1581	778	230	6301	10722	jxRNaXe7iRnJnHGG65E7SbF11pDmRpue4nQ7rjBa3g7SJSkntRe	7458	10557	10557	1617839460000	orphaned
14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	1637	816	230	6301	10728	jxb5kFLy2S14Hh3FtTFV2f43xWmvBi9DdUdmgLkEPXKDJ9sZ5Q9	7460	10562	10562	1617840360000	canonical
14636	3NKsX67qitSFjVuyc3F8hPmdHL8HA5aWsaJUZFqrXXHHjEf1k7ey	14633	3NKRU2cUuBjkjjYuzkzuD6SePbJ5mCLeACx9gyA9ZHnyctevhLjX	1457	1145	230	6301	10727	jwoY7DapmoiqKqQJT6yeuxqcJUVf6xoDM4wSU6Ui7m3Gvvuf963	7460	10562	10562	1617840360000	orphaned
14639	3NLDr1MyeTgLG7oUuc8bxWUiyN2yuUAuxXjmKzLxynszQwpp2uGS	14637	3NLwH192QshssSSBr4mBQ3SMSdgoNyNsFJuPjpu2TyDXfmgzQKk5	684	1352	230	6301	10730	jwDnGCzKNAGe9kHbJnuDAPfhTspvWCGRFYnSrwNVuAGiYJbz1c3	7461	10563	10563	1617840540000	orphaned
14643	3NKcdp2NbPMbxTL4SV7BdGVWG1Cx2viW63R7vVhRhWzwG9oUGzDC	14640	3NK64m7tAYL8274o8CyoufTT1fCiT89Sy42QxVYeWZhhVQJnwpdG	1407	1395	230	6301	10734	jxa8V6utz8kqQ4wfjXYJqLivWRJfWu2spg2HEkXxbBgwhU2okci	7462	10564	10564	1617840720000	canonical
14644	3NL8Z44E24zGm2YkLop8enBZuAmLdZUTpRCNYWX6Eeh9BjB11qEq	14643	3NKcdp2NbPMbxTL4SV7BdGVWG1Cx2viW63R7vVhRhWzwG9oUGzDC	1402	868	230	6301	10735	jwCZYR7ztDLWNsb9ckW7CE26gmSbsDBym8QR6tYWgeBuybZg3VR	7463	10569	10569	1617841620000	canonical
14647	3NLkJXV45YeSyA2fptEXKgCPmNAR6rvDiTUBwD4JtiPNfN2DtyVf	14645	3NL8CsH955xcBxQcpkqgL4cY3WZSYKRHJtaw81FVcqvDkTrqHpWH	1601	1262	230	6301	10738	jwuoXqrWK9AVpx4LFJDdDTi3KRWTg9xnJncpSb1TgY7YmSWJbt5	7465	10571	10571	1617841980000	canonical
14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	14647	3NLkJXV45YeSyA2fptEXKgCPmNAR6rvDiTUBwD4JtiPNfN2DtyVf	1648	1038	230	6301	10740	jxuMT4fvC949v1HNWfyA8fM7tq8YscumksHyfJgTABicja5UayP	7466	10573	10573	1617842340000	canonical
14653	3NKstPasuHEQgzFmdAqtsErHRWoh3Hfw9mzQCX8oWbJy7N7jwG8h	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	1481	790	231	6301	10744	jxJ9AprExwY9mEhu4WxoPZuxtz3BVu7oTZ8dcLuMSauZSjgDx31	7467	10574	10574	1617842520000	orphaned
14656	3NLTq9MPrgf5nE9UrSyp8Cu55W2oAkQUTBdbMTqtthpPk5fp19E6	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	641	1090	230	6301	10747	jxUJFJRo6ANpfF6nnyuQ3BQyqVP9hHFmtCg2tT6n83BfQ2gcFkt	7467	10574	10574	1617842520000	orphaned
14652	3NKDgwgkdZWZG8FiNewCXw6Vymr8jspF1Uc5KHvKjSzNQNpUG6To	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	171	1008	230	6301	10743	jwx65U8RCrMQjGhRcMhVj81m7YanTv2fDomVgzYTEGx5yi6mZRQ	7467	10574	10574	1617842520000	orphaned
14657	3NLdAwgna7VW7NoMQx2wwt6DjyjYgA9FC3iP7JNQnqBLj9yx9U6L	14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	1460	483	231	6301	10748	jwKMHvSF16wecAyfYb7M9PgjYtVaCjiLe6d5JtqgdpYB4Svze6g	7468	10575	10575	1617842700000	orphaned
14662	3NLq8TVE7KFn858i3Fu3P3yvBnpdWZoFrHPBYmftN4GeQjF2KTpp	14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	1483	1030	231	6301	10753	jxoVAjjRKeqAv1rHAaReYP1n23fAHZxUkrRmvRsNykzabiWgbqL	7469	10577	10577	1617843060000	canonical
14664	3NKbxadnuRfPXTAvnnjn2MnzBXzEQZeHpgrFkan3gkrco4SqEzd3	14662	3NLq8TVE7KFn858i3Fu3P3yvBnpdWZoFrHPBYmftN4GeQjF2KTpp	1407	1395	231	6301	10755	jwSnxGXPQ8d5DeUVwVdy429ib1iYdHiDrzzNivC6SMbzgnLA8zg	7470	10578	10578	1617843240000	canonical
20380	3NKig7XGA4u9P2FErZ99d62DC2yAFRCwespFkHXEHNFRXEqPh8qp	20379	3NK5hFLFTMM5CRJb4bNRSynLe79ENipqWeMiTo1HgCQA1ALGwBp4	1529	1070	367	12463	12712	jwBeJVK5z4S4dD4J9csNpja1W4eMpghpNZxakGFgNiwQHuoeyhg	10267	14484	14484	1618546320000	canonical
22190	3NLYPGkvsuKD6ev4KPoe8J2K4vXXVCLLnmzAgwKKNoop57q5uKGi	22189	3NLdcZLtt51bJhYYx6XsWqRE5fwWqHKXAXZjBYgFKbGeywaNNmzS	1594	1200	409	12463	14319	jxG9DRaBW3gnMBFdKPmnbYccYFwNwryHvC4BuNvbQcYWRapi42n	11106	15633	15633	1618753140000	canonical
14700	3NL2QuCP54SdqFfzyDoFQseLYm4qVfbvjcrAkabgoQxB9eR1LWj8	14606	3NKWBaShBhs6WNPLEhZPyKmbRahww85SiquXsRpcfDiZtBgkR1qL	1624	1334	218	6301	10788	jxjTSP3nxeNyiEKsuLxWVkEkTq5w4WcR9E6JT33gwfmeH37h6Ye	7230	10601	10601	1617847380000	orphaned
14648	3NKhrNTEp3PncMV1Y5XNzeQdDaQRSTAk1CuSZNJsBGoTVBy5LgAo	14642	3NKMZLiYb5Q9xmTqzD7kNQkRxDcB7bBqy8367PaonhwCLsLHg66j	1601	1262	226	6301	10739	jxfMmnwEMzRNLfaxtwmvQ3M4hypTQdhxss3cB5NL5y1WrxduNxX	7362	10571	10571	1617841980000	orphaned
14683	3NLQc1yX65ZuYYUFFaxgPyYWSGEJabHTwm2UUeQSpB2UNB1rr55B	14619	3NKKWxrbXXVUWzkxjEMHY1ELnQwmEoGFuYcY7ytjGsHv1KPaaHDj	576	1355	228	6301	10771	jxETZM8mq5W346tYHNePZxR2wo5CL3JYFiRijh71o2RpH2zCJFf	7419	10594	10594	1617846120000	orphaned
14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	14649	3NK5bbE1CGyDHVzTMbdNKqvJZiAqDKerjbeEgyyiMZj23R1iTXAd	633	1258	231	6301	10741	jxcLxmEDaVrJq44jsWtUL2jbZVjjpjXENFbJB4YbSQcSsxfzb6X	7467	10574	10574	1617842520000	canonical
14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	1500	931	231	6301	10750	jx7ZgonAkkHnWYvXzS4Gqg2tS1QkF566ApVxLtV4zHmhWNb21VM	7468	10575	10575	1617842700000	canonical
14658	3NL8tgEf9uQaDRXxBURNpahzu1jGqBA3ppd7t5CmKpfnBgzH4Myc	14650	3NL8nzrkxrDPJFzchWBWcHsX2pHUeZVaJZoLQf5KdhGeWQYmqbkr	1407	1395	231	6301	10749	jxMrfzWuWgFmnTYDWPykk6dhJikge3ipDVQs15VF8nEeBvSwRdE	7468	10575	10575	1617842700000	orphaned
14660	3NLtwesUKKFGwJF7meRT1ahJKTx5FgyhJAfSEUAHwwSDhUeQtjpv	14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	1501	1360	231	6301	10751	jxceMhk3xxQqCopLxwYn4BR1AoX919mS1jzj6Hc6GGGaVQPXjUZ	7469	10577	10577	1617843060000	orphaned
14663	3NKpE6Lm6frnuG59NSDVnqWj68iR4isQ2xH6E2Bj5k4Lh2wW8n6x	14662	3NLq8TVE7KFn858i3Fu3P3yvBnpdWZoFrHPBYmftN4GeQjF2KTpp	1637	816	231	6301	10754	jxLWhyMxLqpYGg3nUVohqyQGGaeQFdi711EkhfCesdeMbWUnTru	7470	10578	10578	1617843240000	orphaned
14677	3NLTLfowssixGA5v35krWvzRvdRRjCxvKNnVvWGwLDh84kWqNg83	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1445	1164	231	6301	10766	jx1cGMo43sk8qLQghJfoJLbM9hfhTbqvwXEWDcVZYEtXd6qXKTZ	7476	10588	10588	1617845040000	canonical
14675	3NLA28yhFXgsz4dwvP1D5fhfe55GMZc9iXViiVsfoiGfodJLASS5	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1405	881	231	6301	10765	jxGz46GYJyNfrh5P9jLnnyaM26qNohJ3dtMeiKuv3Vh93iM7yZz	7476	10588	10588	1617845040000	orphaned
14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	14677	3NLTLfowssixGA5v35krWvzRvdRRjCxvKNnVvWGwLDh84kWqNg83	1403	824	231	6301	10767	jxbsLVS1q1njNwqc33Xx1a5Jvj6c37bw6fWpeTcqjv1qQGkVUeV	7477	10590	10590	1617845400000	canonical
14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	1654	1340	232	6301	10768	jxgxncRe1EGjoNoKjKho9ocF3WzcSrXjWRdE4QBFuYGkZtnb1hJ	7478	10593	10593	1617845940000	canonical
14681	3NLkagAcMW2fwVyP21XN5pMmY2JoeBvDwQ1xZMz4cBYHP9qb13YV	14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	1654	1340	232	6301	10768	jxeNTKaEa9Kw1ymvbPgnBfWPVss93Fgk2ysTQzURyU7BX2Bwa2L	7478	10593	10593	1617845940000	orphaned
14686	3NLq3MeAWxdXk1cBb9s9k3xuW2v62aMjfLsmixzcXd3kqcBmxWzc	14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	576	1355	232	6301	10774	jxJhoTDggnZGGFVQADtJP5eQEFAitXYYigmqLNSvo2gFHSQarV7	7479	10594	10594	1617846120000	orphaned
14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	14684	3NLrJo5jdEN17zPjtMT2ECCMj4P1TFhCeqDq521D3KKWkTRquydh	1490	1274	232	6301	10776	jxTyQFd7VrwVNBMJoWwZ6voyDvVkVUtNpGBTjcCRZXcphWx2UmF	7480	10595	10595	1617846300000	canonical
14690	3NKFJa7afxGCEQAXgndku7rYqC7w5BKf8EoRGnRkXEn4beqv5kYM	14688	3NLZZhro4DRj8vfvvzN79vuBRGNz5xi8vkdNBZcLeeXGEZBJhVzr	1535	93	232	6301	10778	jy2QGvushXXUpfqEaRTejT7UA2mZ8AHETkpxVBrYfaCt3PW7k7P	7481	10596	10596	1617846480000	canonical
14692	3NL3YH3kFGaqiNtyXs6j3vS6ZfT9Fq6Dq7UpsH8abnahx6q9Sb61	14690	3NKFJa7afxGCEQAXgndku7rYqC7w5BKf8EoRGnRkXEn4beqv5kYM	700	840	232	6301	10780	jxevab7uT8Mipm7LY7nbda5Ne5UD2dXC9ngcZLsozAg6Z3VhMjR	7482	10597	10597	1617846660000	orphaned
14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	58	1035	232	6301	10783	jwNHy7qY74UxrgK3kA4ztAzt8HGJLSLkfNXhPDN1R1RdmxLwtWZ	7483	10599	10599	1617847020000	canonical
14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	14697	3NKsUUPv9m8x3u3QXYwgu9reVtqaJYJdyZUpjimeaa5ZEb66nquk	1451	1292	232	6301	10786	jxwoTq6BAHwGVHGKQobWprJsxcpnpemKzNhPZ5VSRocSrQp2991	7485	10601	10601	1617847380000	canonical
14702	3NL9ijcLwNLyDFR9bigvdwYhy9hBr6yc5HcbCT5VVF8LPJikGLc9	14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	1406	1393	232	6301	10790	jwWFun6AUHJEaQp5fRpzhk1iskiWtemgQtE9r4cJT6mBBpSB6eA	7486	10603	10603	1617847740000	orphaned
14705	3NLDWcfXQteGD2cqpyke9ueA8DRdarmPiXX16fJmtrGABBJuz9UP	14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	1422	1337	232	6301	10793	jxMXE2PNm8NpxLBbSqBrq6ZTdwwSzonFTr5QSsiQxKt2zxvZPaL	7488	10605	10605	1617848100000	orphaned
14709	3NKaYgauENsgg4mMekfvJaS9V4v4dNfb2arykLxCxr4q17fbDK5g	14708	3NKVn9EnstR6Laccj4yHkKefAu98yK9ATVQtArKMXaVthQnbkEd7	1460	617	232	6301	10796	jx2Nf1wPEY9YUKxpt3TokT4Ezke9njempoDhL36rUp1aSiDFMfR	7490	10610	10610	1617849000000	canonical
14715	3NLX8MSpgaaTfCY65BcPJdd2Nnyifn3MMQvJxWmY9EmbkFGD9jPJ	14709	3NKaYgauENsgg4mMekfvJaS9V4v4dNfb2arykLxCxr4q17fbDK5g	1547	1132	232	6301	10802	jwtMryGAEkiLU4oHQTbDmpHqKdZhsQdUZi9GN9XqBbcqkbj1CmE	7491	10615	10615	1617849900000	orphaned
14717	3NLy88qMYPsQytn4XpXeQ4s2b8wsHdJSfpD65oV4zqswpJcUDZbb	14716	3NLBScb5djkrxZKbF4g3RgYonbgLKdMN6GsPwF1vVGMgPvW6Uc6q	1507	1280	232	6301	10804	jwnzLoYY8oQy6orb876wheD4ghw37PUPDvo1av7eLn68bgoiFH7	7493	10617	10617	1617850260000	orphaned
14719	3NLimdeSNotEL9QBfiVvLjYnMtUKYb1PCVMJgTcKVJiPBL8UtoB1	14718	3NKyZPWwx3uM3EtwT42FkHJWkFncEUqpRLqqCHA12tchd7EEnKgs	1657	978	233	6301	10806	jwkDFZXSQ6gaoRMouEYYLxgNCUSkTdWzanzXUqTKEcJibnQREH9	7494	10618	10618	1617850440000	canonical
14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	58	1281	233	6301	10809	jxekoXaBoSVKdoJqV4fQYbVQH9NERpSEk2uunHVsXhu4HPGopWb	7497	10622	10622	1617851160000	canonical
14727	3NLKPMxQ1o14ergJUXLYMBvFgMmw6sDSF79VrPmuFQqVT3v8otXq	14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	1560	925	233	6301	10814	jwEoZwDp67egGRAfhEWVYfavnyra4DPDmEpWVJmLxHrA54sKpKQ	7498	10624	10624	1617851520000	orphaned
14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	14728	3NKzDsHQtPx4QmvZCjmbZJTmAo6JNQRzbWrSQhmg9aySAyWWAKNZ	1608	1043	233	6301	10816	jww6HGMMK9Cs78h9h5CvZWG1sp3btnxTrW7J1uBXiifJDwbVZSb	7499	10625	10625	1617851700000	canonical
20564	3NLgNH4Vos1HTyjdBHY8aSrmB8NpWsTo4SCTKv7T5ZxzkUxFPArr	20402	3NL9ohbTzjUkvy5XXoAMdFNxBAEjELGJt8QfYLTeGHmURnCCBBiN	1422	1337	367	12463	12873	jy1humBQbbTu26RsE4vaimuggjcUcoB45E3bryvr4MSubTwssnE	10267	14595	14595	1618566300000	orphaned
14661	3NLQmgKHMCCsWex1LK9umQ2k9jtPYRmFTHnxJNRWSrdrxWsnCabs	14659	3NL8mBti9axGnPL6U6sMHYRYocskAY4RxYoPsqzuAWB9kWvLHpnY	1644	544	231	6301	10752	jxHSz545TKV2M54PMNa6WzbuTaGVpWrimNngsQan33WoemQ1yCj	7469	10577	10577	1617843060000	orphaned
14665	3NK33aBrbLfeJocKS1f7o3qwUHdyzUipSPAwypnpZpBPiYtu8gbS	14664	3NKbxadnuRfPXTAvnnjn2MnzBXzEQZeHpgrFkan3gkrco4SqEzd3	1406	1393	231	6301	10756	jxy5ox9bBCsBeT8eaiqK1p2qb19jPh6jPbgBWUVwUjCVHCq99Fo	7471	10579	10579	1617843420000	canonical
14668	3NKZpVKfa6frBTP4D8LcbwrSXr9PaGjsdzMrMpfAHwKbRGJY5X3s	14667	3NKsS2s9gu83viCq4qwx4MM1SRhPXqxvvz6BXZPLjfGTogyJ2pV7	1593	1346	231	6301	10759	jwG7PPzdY1b5MGoJTWiUYxyfCePPHaeawR48jEo8EN4XTJ6YKk6	7474	10584	10584	1617844320000	orphaned
14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	14669	3NKRZYNC7ERsGcDzv6xfyXfSDzRN1SQmgsadRwAToNYhT7tZrivq	1649	1137	231	6301	10761	jxpYQwnyYMFs6Q2aHsyvSwe9T1hyVTTN2HyZoMeoBcVYdmEHoZx	7475	10585	10585	1617844500000	canonical
14674	3NKwpKc9NU6kS74GSfqwGGMsNn4qyFLkmj3zo5qh6zsrQBnvaRWD	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1419	814	231	6301	10764	jwBcpHpvQv66e9Pt5JrS1t7Mzz3KKSGvytZUuWVH2TnJUaqXP1m	7476	10588	10588	1617845040000	orphaned
14682	3NKCAeruuMQQ1kS1w8AcRr1wWrHRRVMNEQwAKopTfAtjtYeo35a3	14678	3NLczpU2k6cwDsrJQm5txDpuYdFEft7apSnd8wGj1grP5fNhZGMk	1675	1342	232	6301	10770	jy1P9Mea6YxDXwGXeFh2g5gKH3Qbs8rMRvvYHTvtGZKKCpQgKxy	7478	10593	10593	1617845940000	orphaned
14685	3NLb4YiP1oGB6FzCN4ESWkEu2aZ6DnKdEwVThtrVQK7FdnmaZKDS	14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	1406	1393	232	6301	10773	jwpWe56aChZhqz1Rj9o5zUf9GEXkuvoMyRwqzAXKr7gv1fGkHeM	7479	10594	10594	1617846120000	orphaned
14687	3NLKhrnwktEL9dPR4DonJ8nYdi8ao4xfScmjozF5UR3rEQEfWJaG	14684	3NLrJo5jdEN17zPjtMT2ECCMj4P1TFhCeqDq521D3KKWkTRquydh	1444	1381	232	6301	10775	jw9t38Y86qDjp1mEudufdgqybCxUFbGbR53u6koGGcsX8n4YUig	7480	10595	10595	1617846300000	orphaned
14694	3NKpvTfD82VG6dttBTD79SdaEH24iPxu8aHD6RBt6z7rmzqpN7qg	14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	1608	1289	232	6301	10782	jwgiXQMbRqYtbMBzpDTDpdFULU7cniesyU3NFNndun454zJDtqd	7483	10599	10599	1617847020000	orphaned
14696	3NLsyCHCMQYVcwvdGDEvnVauzgBd5N4cj168chwJ22RnkFW5ShTK	14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	1529	1316	232	6301	10784	jxKUGjZhK4ABVJZF4FWvRbLXPyUiwtvXHPmcKFamh8WdawUUcU3	7484	10600	10600	1617847200000	orphaned
14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	14720	3NKCLgF2ZqmdZTY1nYCBfH7iz4hiiwfsPskG9REbxmdXjat31HXd	1617	1042	233	6301	10808	jwEuYHwNy8rjpchBreM6Cs6i3dAktsTeNbLMKdJ394PVCUvLipN	7496	10621	10621	1617850980000	canonical
14724	3NLs5inZdSdm9ytojfX9DFd3eUz4hppzt7EF9eaiYNSBXYSACn3Q	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	1506	1007	233	6301	10811	jxkppbZQe4KbzvdKHtZMeDS5HQbb5tqVrJmMqBuvrEymLCnaf34	7497	10622	10622	1617851160000	orphaned
14728	3NKzDsHQtPx4QmvZCjmbZJTmAo6JNQRzbWrSQhmg9aySAyWWAKNZ	14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	1596	1117	233	6301	10815	jwKW2iEt7F4DjGF4xLUv8BxSBm88gjwq2CiduBVKtn68aKxCwzf	7498	10624	10624	1617851520000	canonical
14731	3NLiEJbfNo9fWibgvhryaxJRYMBRm2Sj8nrpefGcQeiVoGGzttPr	14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	1467	1250	233	6301	10818	jx3Xo4WBaYU6z6wmSEVGjobvjME6Huom1zQJncwefn1xNgqwM2u	7500	10629	10629	1617852420000	orphaned
14736	3NKVngCfGkbnqwaNqwPDK8NP26LjQt6mnXcpW4xCopvkyGjRHDxC	14732	3NKjGvTWYvPVmUZqiW6QQMEC4YpxGRuyzwq9fskMCXQQUuMjdbKG	1675	1216	233	6301	10823	jwqEHssYv6pyLSz7ozq4PeeQXDeb7m63sHpMrRDNWP6QeRBxSkA	7501	10633	10633	1617853140000	canonical
14738	3NLGz5xZqBJhmqU31h5d24Znr1A3Yu2e9WMRdzMSbQ3gVa8eMyRh	14736	3NKVngCfGkbnqwaNqwPDK8NP26LjQt6mnXcpW4xCopvkyGjRHDxC	1481	790	233	6301	10825	jxt2ti1p7EuAFjpuHwfxaRk3DeGZ3DtTCrxTXAVrzUZheBpMaFD	7502	10634	10634	1617853320000	canonical
14741	3NKRoSy4xDKyszezvuCni38dt4hjkAUGVCqsGPmS4biA9E5wwJsE	14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	1534	1317	233	6301	10828	jwDvUKmCPhABLB5QrJ2NdRDWZwTrEZFr8EgUb6hojNhongKnUvJ	7504	10637	10637	1617853860000	canonical
14747	3NL2TJoSgyc9sGc1GCf5u5KP1YZ6hCBDFKuowi8h9vKQUBbnQLs3	14746	3NL3kmB1364ahxmhzNfsinPNT28x4C8yie16yKUo5Z8tGD5iVtpi	448	939	233	6301	10833	jw89nNsoA1sNG9FUB2MLCwVyjH9PwqvnfM5UYC9VAK6EDqPvSPQ	7507	10641	10641	1617854580000	canonical
14775	3NLPjss3TqmqjqDzFF5PeXNmZC8ox4ZjFycPPHJgc3KvADgdJEyV	14747	3NL2TJoSgyc9sGc1GCf5u5KP1YZ6hCBDFKuowi8h9vKQUBbnQLs3	1405	851	233	6301	10857	jy2wxYGygw23PzMmfGREscLaPcntCeRyfH6TwvZ4jVRA9oZTyc9	7508	10662	10662	1617858429362	orphaned
14752	3NKQgpt2jLVnifxdEniaDtmPZ2segU9etBP7TB5MrQZoNBmRGDBp	14751	3NKqnYEo2owzYCkt9529VHbt2Ph32FnRszEM42CbBJaUKo4iAB4y	633	1384	233	6301	10837	jxsgGV4afvfDa1D28UhVUSL7FF8QvmJeGHwD9fxio5pwJR6ca7h	7511	10645	10645	1617855300000	canonical
14757	3NLkTjZAgzRKXLTdLRyLC7TfxmvGpNkExeGqjeSbLjtYDa51ziPD	14756	3NKmgzeBoJN4DCcYQVpM8yGjCgwnxji6SwvdUjmMsDAYVEaqufTS	1403	782	233	6301	10842	jxvaCGzcaJ7XZbxGqiSQzyofHtad8dkLx3fNQxRVqygKUiB8rFk	7515	10649	10649	1617856020000	orphaned
14759	3NKrsWSn3Ph1gtV544qpEiFF1vATGWhMrB9VMwksobetbsmvRWSC	14758	3NKYpPmRCXoyisxLYkMsgZw4dLeLjLtcPkphhbp6qRbN3BM9E2MZ	1403	824	233	6301	10844	jwp7kwiSKFJZN2f7Eb93GtrtDrgZKG1W7shjak1gctWTGtGTo2y	7516	10650	10650	1617856200000	canonical
14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	14760	3NLn8y3drs13131QqLZeEy9f9bYQ6oCVmxxCZiNGcKcc92jBa7JG	1631	794	233	6301	10847	jwB64r8TkjwVbuzxVTiJXWCTYya1TgH5KKSfHxi7DWYaKFPF1qf	7518	10652	10652	1617856560000	canonical
14765	3NLHF1Jz6fkJ5oH1b81YxXzSRmLZDgfnfS4oRkKSRhK9bYYotef8	14763	3NL8aED4kkNVAuba3mSebudcC8ZTB9dZ68fgWRH4MKb3UaT52rqz	1671	1119	233	6301	10850	jwKDKMyJq2wvdCRBvXLEE84RiE7jL17NjojacU1qyyKdG2hUpjq	7520	10657	10657	1617857460000	orphaned
14767	3NLrEAbsVEsma6NGaeuC5hjrzisTCuv3XotqUjD3R5Sgh9c8ZXSn	14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	1527	1167	234	6301	10851	jwjBrTyaGAVShEek9gAoaLExAA86VkeE73rkVay5pRCpfnkfZgb	7521	10658	10658	1617857640000	orphaned
14772	3NKQkf3ekf8uJYCZyknmFCJDL2kiB15AdH5kcy4nauhgUbo5LL5z	14771	3NLiNawpFZVskCYU6rBFev86dtPvUmV4kvvBRNbAdVLUdffLVh7J	1406	1393	234	6301	10854	jxQewRM4T55o4P7qeWEiVk8U3CF5JkYwLHaq5gKujAQ2Lj1hqUy	7524	10662	10662	1617858360000	canonical
14777	3NLyKKYkb965txvEk79tuPT9QEpxP93Ws68sukk54ALFX9ab5rGV	14772	3NKQkf3ekf8uJYCZyknmFCJDL2kiB15AdH5kcy4nauhgUbo5LL5z	1402	868	234	6301	10859	jwj1pK7Pk1zUp2KoTiJHtFkyDkDC72yzv4hssCyM1McZtBsX8KT	7525	10665	10665	1617858900000	orphaned
14779	3NKQKqd5bG8ZP7GC5ETbCYCBenZPDHJ3VpVxFVread9PimLpZDgf	14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	1403	824	234	6301	10861	jwGGLSkjPNgh1nrhXLxVvFATJZk3Tdfn7wH1KVECKLoZe32QDqn	7526	10666	10666	1617859080000	orphaned
14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	14783	3NLLxFiKejpzQS4ygzFC8mPfcWn4qjMA41BwwtFrRPK7ppvU3xS4	1610	1068	234	6301	10865	jwD8Jeo3J5wm8zMTFiSsoJRZ23GBuzxFHAxs1Zp28E62seXEnJF	7529	10670	10670	1617859800000	canonical
20396	3NK7qz9aWc8yUHd19EMb1AZo6eWNRuR2PyLN7C5wN7mKTHfmTRTr	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	1523	1075	368	12463	12725	jy2bStT2TSQJMcEUauq89rxJppGji6qs6Vdo6sTgWCTt6RKNTAw	10276	14496	14496	1618548480000	canonical
14711	3NLRj73zuK69GJDrCKMUJh7qMiE8nZULdNpA2SbhNgL1sfptcAth	14542	3NLov3hKzyboZSzQLja772oU2tkhEnWcqMrw3PmpEHaYAxtV1zux	1634	1331	228	6301	10798	jwfu56UQzjWRFnXRQwLSCTo8vX8dcY8W7MVK3S3rsxVQ9t4Bcmc	7419	10610	10610	1617849000000	orphaned
14680	3NKScPsiY42qLMcVn8Sqw9iKSHgoZRHci47Zw2Hkh4Fu6odH71L4	14591	3NKuMDzLnNxUa9MRpvaKE6X2MAyvWGu3JQE9HzHyYeUN7BZRqAPK	1675	1342	229	6301	10769	jxyqpXivm3ctddA3Tzo8Fbk9EFciz2mCzJgRiGpM9kBWuU6jf85	7441	10593	10593	1617845940000	orphaned
14735	3NKwQKT4oAz2XxR1MuroWq1KTHmnmbK6V8X6rzCfemH5KWxF8CjQ	14713	3NKFdqZ1BbTEHJMhjarB92aLEviGCCozK3CtuywXX1k1nvEHph9S	1675	1216	229	6301	10822	jxyqpXivm3ctddA3Tzo8Fbk9EFciz2mCzJgRiGpM9kBWuU6jf85	7443	10633	10633	1617853140000	orphaned
14666	3NKaspPbe46atu5UYBCNxHGwTeWv6LtjZsuJf1Du1aoE2owRrWAP	14665	3NK33aBrbLfeJocKS1f7o3qwUHdyzUipSPAwypnpZpBPiYtu8gbS	1406	1393	231	6301	10757	jwE9FGv9QjtVxBGuN9aezSoqZaABAymH2WH1K2DuydwnFi9nK6W	7472	10580	10580	1617843600000	canonical
14667	3NKsS2s9gu83viCq4qwx4MM1SRhPXqxvvz6BXZPLjfGTogyJ2pV7	14666	3NKaspPbe46atu5UYBCNxHGwTeWv6LtjZsuJf1Du1aoE2owRrWAP	1406	1393	231	6301	10758	jwLVBiq5tMQUpdmAwuV3TapLDVsxthz2q6pmZREnABSDWcMT4sc	7473	10583	10583	1617844140000	canonical
14669	3NKRZYNC7ERsGcDzv6xfyXfSDzRN1SQmgsadRwAToNYhT7tZrivq	14667	3NKsS2s9gu83viCq4qwx4MM1SRhPXqxvvz6BXZPLjfGTogyJ2pV7	1593	1346	231	6301	10759	jwC9HASs2r4tynXqykBdop1WAtmsGDBJdwGmKY8JJwGgKKftLKL	7474	10584	10584	1617844320000	canonical
14672	3NLYcQiYCEDxaty8Fd6U2X6HGJNDdcRQtsEngXgQK5cQzBHnrQa8	14671	3NKA2xgvBiS8c9J3G63px7oz4ybV6bPreL8cKRXjaHtMQQanVvpS	1451	1292	231	6301	10762	jwz7XmavCmBx4UsT26tyEcfoeAyqxhGuefxyatM7jfTmN3XpeGS	7476	10588	10588	1617845040000	orphaned
14684	3NLrJo5jdEN17zPjtMT2ECCMj4P1TFhCeqDq521D3KKWkTRquydh	14679	3NKpgwBsDwuftJy6xheW54iXWgv1Zmi1jRAYTrTjvBghPgCQRv1q	1609	1207	232	6301	10772	jxk1B5ghoVNn8K23wPgcgga6pcuMizd3zRxFbyrtDPkS1DBi9Ph	7479	10594	10594	1617846120000	canonical
14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	14690	3NKFJa7afxGCEQAXgndku7rYqC7w5BKf8EoRGnRkXEn4beqv5kYM	1407	1395	232	6301	10781	jxppTDn3Pym3vkkNVYhWY5CGPzEQHzBWQ4b6KL6hu2MetxzVF28	7482	10597	10597	1617846660000	canonical
14697	3NKsUUPv9m8x3u3QXYwgu9reVtqaJYJdyZUpjimeaa5ZEb66nquk	14695	3NLLknt2UhP8qjRTePE6c1QZfTfYC3GjNwniAn333eGrXES78cpb	1513	1379	232	6301	10785	jwKCH8r5eYvJHcYGVHb4PvStPq1gZ3XARHbMmNA5sZjaMqSKVck	7484	10600	10600	1617847200000	canonical
14699	3NLNgGe336HKH7MaWzgJ9UFgDTHiSxHYdBNKimnRpJBBAFTgguYK	14697	3NKsUUPv9m8x3u3QXYwgu9reVtqaJYJdyZUpjimeaa5ZEb66nquk	1624	1334	232	6301	10787	jxxD4RZqRyDeFswQQukdt4fzmQAAXXEZd88dWbz7wBZGP5EBnBE	7485	10601	10601	1617847380000	orphaned
14703	3NKcep78ocDmpVvBZhiVmhnMnMmTec8cCG3LGiFUme6ZFVxnrHTc	14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	1407	1395	232	6301	10791	jwmoLUxxGE9RfhieE3LH5szXaAkXHCs7WJzPCtqrYPxT813cHfC	7486	10603	10603	1617847740000	canonical
14701	3NLyWMsmCLbSsnxN1DSjYakbat3aCRm6LJEW3k9UNs7YxRwf4JoP	14698	3NKYq2oPvDz2ujzqnnu3ntmavj6nvJXAtfH3BRmdMarAuysng2tk	1670	1156	232	6301	10789	jx6oXrdTXWcsDGR5o6z5Ejh6eEZEdA1Ms8oJ4SQYbxweLsabWEU	7486	10603	10603	1617847740000	orphaned
14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	14703	3NKcep78ocDmpVvBZhiVmhnMnMmTec8cCG3LGiFUme6ZFVxnrHTc	1564	1092	232	6301	10792	jxYoVmoMVYrKBYtYoMTn85wbCpAdBLKN7WsfY6bkfiAyJV8uHuh	7487	10604	10604	1617847920000	canonical
14706	3NKZyjEKbV5xUMppdAWCHVAw7HD6jkphoUdqcpgbPnyXLonTyLKQ	14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	1448	1065	232	6301	10794	jw6xUWynLrA25EvhhL6Wsq8P6f5c3GxVBDGJCWMSmguMhhgBTEy	7488	10605	10605	1617848100000	canonical
14708	3NKVn9EnstR6Laccj4yHkKefAu98yK9ATVQtArKMXaVthQnbkEd7	14706	3NKZyjEKbV5xUMppdAWCHVAw7HD6jkphoUdqcpgbPnyXLonTyLKQ	1406	1393	232	6301	10795	jwrvbU9jaanQpaZNJpwCmcohTB2F4HbNha7ZTLtk4q2w8msMzfE	7489	10607	10607	1617848460000	canonical
14714	3NKtePdiTeHf4ScW8JUDo2ESWq6jLhTifuoRLFE6FQXWMN3SfdQR	14709	3NKaYgauENsgg4mMekfvJaS9V4v4dNfb2arykLxCxr4q17fbDK5g	1675	1342	232	6301	10801	jxmVroo7d7uBu4eWykdsUnQb1LK2GTGkWxdaTA9GCB4jaHZEixZ	7491	10615	10615	1617849900000	canonical
14716	3NLBScb5djkrxZKbF4g3RgYonbgLKdMN6GsPwF1vVGMgPvW6Uc6q	14714	3NKtePdiTeHf4ScW8JUDo2ESWq6jLhTifuoRLFE6FQXWMN3SfdQR	414	414	232	6301	10803	jwu8tuYaenDxpUCjDnQSRxCKV2AEGMapeVs2xXoaGSDjcAGBk5V	7492	10616	10616	1617850080000	canonical
14725	3NKJbtz8J4ecaL5Qxno6Mbf6ehMawyVRmQkgEQgR7yWbfLyWkzyx	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	563	1359	233	6301	10812	jxuqePeqJJW5ezqCRQMLQQNPjAUYPf8hVPSNDE7bjos3HX3vnfX	7497	10622	10622	1617851160000	orphaned
14726	3NK6PpXrTpQTLi2d3PAVmPSrAMLffdgCU6jNM9sWdrcRpvWomDyz	14722	3NLboqfoUHLAsuHkSP3p3EYuHUHMP96ybdBgpVXL4bCehGF1uGbA	1529	1070	233	6301	10813	jy1jMcyVitzjUpf3bzhtzeypRfQXB9r8ZpNCcmyuLGF5dGo4Vis	7498	10624	10624	1617851520000	orphaned
14732	3NKjGvTWYvPVmUZqiW6QQMEC4YpxGRuyzwq9fskMCXQQUuMjdbKG	14729	3NKE25ZoGr1cGdteW6VGUGL8u3wmKH2Kx51H2TpbEPz57RFLhRrB	1671	1365	233	6301	10819	jwM928BHx4TzRv1RrDxHoKyUmWkt5hLm15sQnUh1GMz9PffkNxo	7500	10629	10629	1617852420000	canonical
14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	14738	3NLGz5xZqBJhmqU31h5d24Znr1A3Yu2e9WMRdzMSbQ3gVa8eMyRh	1529	1316	233	6301	10826	jwFqfM3ZMG9XxLUyabcEmDzT4xFzPRi5yphoBMrwgFVsiZknMiW	7503	10635	10635	1617853500000	canonical
14742	3NLU3ioVRq8WmSfAahNKmCqY2jxY4NVkbNCQeKrHuaMsdkrkq5VR	14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	1651	1175	233	6301	10829	jxS8D2dRobVUnf6mkYDZeBc5kBS3gYqFrr4Trk3BBmccpJXG9SC	7504	10637	10637	1617853860000	orphaned
14750	3NLZiXHmSasAWqQoecAMEsVbNdzft467nQ3iNqpcWW54NocrnSkw	14749	3NLvQyJn9Yrhiqngy1s9fjyAe8qPaxb53jWDJgzQFTURaxDphSUw	1448	1311	233	6301	10836	jwUjuuoWhKfkgz2yqJXY9aCQ5B9ueqAqXFwtVMi4RiAKgrZsmEk	7510	10644	10644	1617855120000	orphaned
14755	3NLw6SD9HKfNdrPSMGxNfc2mb24UZUkkbD3FuiTeJcw8NXaruUZL	14753	3NKFrdRrGWRaGfxciA43XPzyNLx4oFLcba5MZDnsy3cBaUr2MpLh	1581	778	233	6301	10840	jxwN4JNvcKdfTymmkzLHwoCBe1BZpJ9YUCR7TNzi1nxHBapLS1k	7513	10647	10647	1617855660000	canonical
14758	3NKYpPmRCXoyisxLYkMsgZw4dLeLjLtcPkphhbp6qRbN3BM9E2MZ	14756	3NKmgzeBoJN4DCcYQVpM8yGjCgwnxji6SwvdUjmMsDAYVEaqufTS	44	1325	233	6301	10843	jwrscR7cww8TMYPmynHhy7QonLRYNbyeaAHstLKC8gYrf1QpJHs	7515	10649	10649	1617856020000	canonical
14760	3NLn8y3drs13131QqLZeEy9f9bYQ6oCVmxxCZiNGcKcc92jBa7JG	14759	3NKrsWSn3Ph1gtV544qpEiFF1vATGWhMrB9VMwksobetbsmvRWSC	1419	814	233	6301	10845	jxnSuEzmjmwh74LGVBesozfCjcoZffi35wJVPMB84up3UoXE3JC	7517	10651	10651	1617856380000	canonical
14763	3NL8aED4kkNVAuba3mSebudcC8ZTB9dZ68fgWRH4MKb3UaT52rqz	14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	1516	1294	233	6301	10848	jwnbUb64Habe1pcZ8JUDz3NnL2FMgc2FenJFieL9kST2ZrZhxUL	7519	10655	10655	1617857100000	canonical
14768	3NKHsnm3eegjPnWAVZ9U3NUpT5dpitxoj4xynezn19hsdcKL5Sph	14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	1527	1167	234	6301	10851	jwAcohc5fRBum2yuAQf5vYXGWGRKmqNcb3FJbdLsCo3nqiNKGnr	7521	10658	10658	1617857640000	canonical
20427	3NLcN3FbUjFAKv7sG8PVSMUHJ4pcjAKZ3bXBadHstrGAaJzajqmW	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1652	1189	368	12463	12753	jxbapmRsRF7UxhG6UCnnFEYMvwP7JX2EU8FKcF4AFc9VePVsNQv	10290	14516	14516	1618552080000	orphaned
14713	3NKFdqZ1BbTEHJMhjarB92aLEviGCCozK3CtuywXX1k1nvEHph9S	14680	3NKScPsiY42qLMcVn8Sqw9iKSHgoZRHci47Zw2Hkh4Fu6odH71L4	1675	1342	229	6301	10800	jxyqpXivm3ctddA3Tzo8Fbk9EFciz2mCzJgRiGpM9kBWuU6jf85	7442	10615	10615	1617849900000	orphaned
14774	3NKdDQoDgq3c5kCpndeMpoBgy8sKSE6neksxVppyBgsQ2oiCN6N4	14693	3NLid11H7NrDuHt4DYqKBHqCZyHkYEna7TinTfHLpVM5khkzZknQ	1405	851	232	6301	10856	jx8qTa29PCSmAgugCRYeQjTBonWDzUP63771kShVRCYRyFvoqHV	7483	10662	10662	1617858360000	orphaned
14707	3NLUSbvBms9MWHrm57kGNgok9BsQ1HygmdqP2iNdg8HpRmDTXvsP	14704	3NLkavhYmqYFEe3k9e22vpFtx8hhc4D7E5QCj9RBBMPpTgCuvm6M	1448	1065	232	6301	10794	jwkQfpgHZETEELUXtShyM65mKikWpJPx48CyP4xYPP9845gS5qm	7488	10605	10605	1617848100000	orphaned
14710	3NK9SB9wSFkBaiPphchzsUCqaM4d1LHkvAaS1cNk6jT9gQQCmRZo	14708	3NKVn9EnstR6Laccj4yHkKefAu98yK9ATVQtArKMXaVthQnbkEd7	1634	1331	232	6301	10797	jxj2VAzTZaFXMBZiwH1eVoUqo2HuxqxKTsS4pHezV5qaW14nBNK	7490	10610	10610	1617849000000	orphaned
14718	3NKyZPWwx3uM3EtwT42FkHJWkFncEUqpRLqqCHA12tchd7EEnKgs	14716	3NLBScb5djkrxZKbF4g3RgYonbgLKdMN6GsPwF1vVGMgPvW6Uc6q	554	554	232	6301	10805	jxozNdoX9TEKJh29Kgez8B5PkuoMyTeWf9QC1smLYDv9bS9Lo96	7493	10617	10617	1617850260000	canonical
14720	3NKCLgF2ZqmdZTY1nYCBfH7iz4hiiwfsPskG9REbxmdXjat31HXd	14719	3NLimdeSNotEL9QBfiVvLjYnMtUKYb1PCVMJgTcKVJiPBL8UtoB1	596	1180	233	6301	10807	jxZHCNq1zoBgHUq3uBcwwRY6po9dGXrey8ktWQFcnEhaWRnZqYr	7495	10620	10620	1617850800000	canonical
14723	3NLtbrriEFJpaLKgMWka5pJKoCM3ikgGosVBbLpxbvNpYs6KNqav	14721	3NK4KsNfhMnHipTgo4j2xfBYe4Eg1uBoUDKzgg2dpkJUUv6Q8LLJ	1490	1274	233	6301	10810	jxpgsNLjSRRrXfh18843F33BBwGuttP2D4QxSRqFjeB1CkChMBJ	7497	10622	10622	1617851160000	orphaned
14730	3NKwBKGXjxXWUvhrDvX7kH5Q3FrudK14nDvH8jXDRHU2baFKUXqY	14728	3NKzDsHQtPx4QmvZCjmbZJTmAo6JNQRzbWrSQhmg9aySAyWWAKNZ	1560	1291	233	6301	10817	jwsqDeoydyUgZE7YJVEqng9K7cxb47TnLuXtooZezmDfe9ynVmK	7499	10625	10625	1617851700000	orphaned
14737	3NLNu6hJa5cP4HAcktMmGEeWYNMziBRDqh6xtWP69oiWejdc35SG	14736	3NKVngCfGkbnqwaNqwPDK8NP26LjQt6mnXcpW4xCopvkyGjRHDxC	44	380	233	6301	10824	jxJCapWZn11qrxL7EG9bndki5GJWmVRVQg1DsgsnYesndtrh3et	7502	10634	10634	1617853320000	orphaned
14740	3NK3YREPZ65f8obvcMEx2fxb7iFaabbDwZEEmcDLMe4jSQPtcCPJ	14738	3NLGz5xZqBJhmqU31h5d24Znr1A3Yu2e9WMRdzMSbQ3gVa8eMyRh	1581	778	233	6301	10827	jwvUDTxAJn5rWRMRDhsmQb1T17iEQpLWamwbcic4DCPg7kXeS7C	7503	10635	10635	1617853500000	orphaned
14743	3NLyS7F4d4z6BHeZ6zgvp7im7WFGbF8bVuDvzeQqimSRA7GnYdL3	14739	3NLQah3mbCgshqPbguF4eCKsUzWQB2YSrhQVsymFZLH3eVTtbNWo	1651	1175	233	6301	10829	jxNBTAmZLTxLoJvpJH1H4DPQUn5Spa5xyY6X76PKvUyVxy7BX9W	7504	10637	10637	1617853860000	orphaned
14744	3NK7Rm8Bw2uX92ETnCHsLgmrvtR8nrNZnXUSpJ3vENHVkoWR1KFo	14741	3NKRoSy4xDKyszezvuCni38dt4hjkAUGVCqsGPmS4biA9E5wwJsE	1406	1393	233	6301	10830	jwtatzjw2DhnEnqLxRogpWwoj32RHLHQxf4WnYrZ2nZFmntYt9w	7505	10638	10638	1617854040000	canonical
14746	3NL3kmB1364ahxmhzNfsinPNT28x4C8yie16yKUo5Z8tGD5iVtpi	14744	3NK7Rm8Bw2uX92ETnCHsLgmrvtR8nrNZnXUSpJ3vENHVkoWR1KFo	1637	816	233	6301	10832	jwXwyQoPbJTbsfkC6epJWfbw347JGJDWVW1KFmyhhxadoTmuvgW	7506	10639	10639	1617854220000	canonical
14748	3NKoe4E71kMUM8fbFYrBN7hWyxnb5QpxAgNmLeeNqQjJVEBYTApW	14747	3NL2TJoSgyc9sGc1GCf5u5KP1YZ6hCBDFKuowi8h9vKQUBbnQLs3	1471	1386	233	6301	10834	jwmWCPD9EwKaAG4cZQnvdS8XPRF67xQ9yjNZKuAtzZUiEAdUK1F	7508	10642	10642	1617854760000	canonical
14749	3NLvQyJn9Yrhiqngy1s9fjyAe8qPaxb53jWDJgzQFTURaxDphSUw	14748	3NKoe4E71kMUM8fbFYrBN7hWyxnb5QpxAgNmLeeNqQjJVEBYTApW	1405	873	233	6301	10835	jwk8cTwUQ6BH4xtDLFPDiXwhHJr1kd6MoFTDL7bqxcZ3PtS7tjs	7509	10643	10643	1617854940000	canonical
14751	3NKqnYEo2owzYCkt9529VHbt2Ph32FnRszEM42CbBJaUKo4iAB4y	14749	3NLvQyJn9Yrhiqngy1s9fjyAe8qPaxb53jWDJgzQFTURaxDphSUw	1448	1311	233	6301	10836	jx8UwKVMg7K9gEjouZ2HQfgmBzBawKEP2PYkS7aNxmFxfJoVm1p	7510	10644	10644	1617855120000	canonical
14753	3NKFrdRrGWRaGfxciA43XPzyNLx4oFLcba5MZDnsy3cBaUr2MpLh	14752	3NKQgpt2jLVnifxdEniaDtmPZ2segU9etBP7TB5MrQZoNBmRGDBp	1656	1343	233	6301	10838	jxr8gjysdGufwFKhkBGfjKATUNn43Taet9RqA5XsYDge8DeN1Vq	7512	10646	10646	1617855480000	canonical
14754	3NKPmKHHTqUPB32p1uXmppfeiqyhFvootLtbm8zCJc5Xh5hqi8kt	14753	3NKFrdRrGWRaGfxciA43XPzyNLx4oFLcba5MZDnsy3cBaUr2MpLh	1460	666	233	6301	10839	jwyrnaToiE2HzqujKjGtXG6t8xfux1pmnkibC5bkFbp3iDSKmcL	7513	10647	10647	1617855660000	orphaned
14756	3NKmgzeBoJN4DCcYQVpM8yGjCgwnxji6SwvdUjmMsDAYVEaqufTS	14755	3NLw6SD9HKfNdrPSMGxNfc2mb24UZUkkbD3FuiTeJcw8NXaruUZL	1406	1393	233	6301	10841	jxZnrdGrEwcbWkKWC6nUm3zzTSbzuMVeqpNeokPmrymvY7hn7jj	7514	10648	10648	1617855840000	canonical
14761	3NKdkR3CpUEBR7RirGUqJPN9DWLDhY1kb8WdKUVLBLSSFWEijmUj	14760	3NLn8y3drs13131QqLZeEy9f9bYQ6oCVmxxCZiNGcKcc92jBa7JG	1406	1393	233	6301	10846	jxjAj441uihs5ezXYk5cUh9yAVq6ukdi2Pc8gp1xGJZNgHwdpiQ	7518	10652	10652	1617856560000	orphaned
14776	3NKruEgcRHECjpoZ2F6iPRAw5NCP8qG1YcdzLit1V9BCafZZm4eg	14762	3NKEXtsPbVq1N3eqnKYmiUMVHLFcXt4VFweeusn1R9PotFRs4Hb4	1405	851	233	6301	10858	jxNafLh3voD1FLhtJ825fdEcopbfgNJCXeRArYBc9LrzJst9Hsu	7519	10662	10662	1617858462724	orphaned
14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	14763	3NL8aED4kkNVAuba3mSebudcC8ZTB9dZ68fgWRH4MKb3UaT52rqz	1671	1119	233	6301	10850	jwKDKMyJq2wvdCRBvXLEE84RiE7jL17NjojacU1qyyKdG2hUpjq	7520	10657	10657	1617857460000	canonical
14769	3NKbobLftdyL7eUAJsJF4N83X9EMD9sdzZaYoHfmxD92u3rZ2WQH	14766	3NK3ZnHP5G94vPCi4bKE4ve7iY1LdaVwbi9Eq1crmYvdRLX8wNs1	1527	1167	234	6301	10851	jx1oceVc6weQ9xNRdWiF7HcxGwXhXEJGgWtQbwR1WqwLP92mXQQ	7521	10658	10658	1617857640000	orphaned
14771	3NLiNawpFZVskCYU6rBFev86dtPvUmV4kvvBRNbAdVLUdffLVh7J	14770	3NLNgPgUn1BQM8cZaixQ4RWApsbijr6apLAdbUQ34uiw5pXStNpJ	1407	1395	234	6301	10853	jxFe4pUgRxrpNnxKLCofqjhSGvQuMZy1J9N4FhRLLKp22DMCBkQ	7523	10661	10661	1617858180000	canonical
14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	14772	3NKQkf3ekf8uJYCZyknmFCJDL2kiB15AdH5kcy4nauhgUbo5LL5z	641	1210	234	6301	10860	jwP1yBW8GTBeSbrYCLN5VMZB97C7nsVe82RW9h2h6dYZQUcB4wB	7525	10665	10665	1617858900000	canonical
14781	3NKA6uLEpzcx1WkDVqKN8GWxkzjecHTjpC2QVvVZxTiqJZ8JYJcK	14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	1652	1069	234	6301	10862	jwB1ogJtG1DHhaRyQK54mzFu4jFvbhfTTvbEshK3D3LiLueDPap	7526	10666	10666	1617859080000	canonical
14783	3NLLxFiKejpzQS4ygzFC8mPfcWn4qjMA41BwwtFrRPK7ppvU3xS4	14782	3NKB4w38KXGKbJf3p4rhDNt6EBCpXCEmKq2PwqJkTSjvvcztyzCz	1571	1335	234	6301	10864	jxAgtnhpjKFa1QYgjEfdEv88XFT3VoLY3mjQkTjisyHPiVixUf8	7528	10668	10668	1617859440000	canonical
14786	3NKdeUZNjurFRm6prJTBwVYoxR8vxdSxbJdXiVdf2UVHSJpmpxkc	14784	3NK4EXDMqwkF35bc9tkHRxZnFdEMXFCP3uQr1iJE1L43kMQ3ztzK	1610	948	234	6301	10867	jxbCN9KMpNJpcG6Lf3mZRe6XJBCi42RGQdNrP3MD9hV5qs4zb2h	7530	10671	10671	1617859980000	canonical
14788	3NLvK85ZhPSBr4M9JTtL53S5nRvYaVR9g8LcgskYhNUMu5dNfdmK	14786	3NKdeUZNjurFRm6prJTBwVYoxR8vxdSxbJdXiVdf2UVHSJpmpxkc	1509	1320	234	6301	10869	jxcZ9APMZiEehxEzwLQomf42ZUpcBWWKt2H67GSNpngmsXd5MhE	7531	10672	10672	1617860160000	canonical
20460	3NK9fVycEAC2KaKZMEf5NWMTWH8Y1M6Uw9C86Pxi2X9hko7yjTd8	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1613	1103	369	12463	12783	jwz8UaQwAKbyVEt9stqkw9oYjCUgjWLufNvG8bcbRTbwrFMAKUb	10302	14529	14529	1618554420000	orphaned
14846	3NL8MyRKqskvEd8vdzJ1ijmXbsyyJPGyQjePSgCNftCauHGCwSK4	14568	3NL6htbXB3QAsdHzfQonBsGeHYrx4uuWqVXikyx7DG8ZCAPjSkxq	1508	1261	229	6301	10921	jxDEe1oJq5XtydyXCuoaqeBoxWA741w8qGMFuPcwvvDMaxHWZ45	7430	10722	10722	1617869160000	orphaned
14773	3NLmyRPJkNz5nkKWNih32NRTopd7zMUGu9xbHazEyznZAyn5HiUP	14719	3NLimdeSNotEL9QBfiVvLjYnMtUKYb1PCVMJgTcKVJiPBL8UtoB1	1405	851	233	6301	10855	jwQaMF9CZ9nkbu3rSDV7HXuc5mBeFZrTXtWXKoQRoS6f2M5QGnR	7495	10662	10662	1617858395724	orphaned
14780	3NK99WnBMZZWELW2i2NVLSu3PmDKXi3EMjbTyMLcJNYnNkeFsRo4	14778	3NLcw9oMhsy4g1ynSDxKUFD3q9JoKR6D2nXNq3p8B4o11VBHB7z6	1652	1069	234	6301	10862	jwbsctFMjR7CcVkvTwMsjHYNLeAfg9fQZkUib55gm5irBWSZy3c	7526	10666	10666	1617859080000	orphaned
14782	3NKB4w38KXGKbJf3p4rhDNt6EBCpXCEmKq2PwqJkTSjvvcztyzCz	14781	3NKA6uLEpzcx1WkDVqKN8GWxkzjecHTjpC2QVvVZxTiqJZ8JYJcK	1642	1367	234	6301	10863	jxUueJ6DtjEJR96jnExGcVFo3tQ2JYhJ86Ju3feGVkG8cKs6Qax	7527	10667	10667	1617859260000	canonical
14785	3NL1ZMNZ8iMpLHVzoPjjD54dx9DWJNGA53yvU1xD98nQRT2cQLCS	14783	3NLLxFiKejpzQS4ygzFC8mPfcWn4qjMA41BwwtFrRPK7ppvU3xS4	1590	934	234	6301	10866	jxZD9zYckLTgCf4g6YrdfUWtrTD2yzfxAGLLVK2a9PNULWHBFqU	7529	10670	10670	1617859800000	orphaned
14790	3NLesXwMfbX1PNp1mfGEJr3GsZ4jiGhQVK6XnJX5sv6u7HBJRkSD	14789	3NKFsUuqDdHWCJTdYN1GmEywmJttYhGnBZ5Eyt5W8kWoFAWcoE6u	1631	794	234	6301	10871	jwhG4yCXNNji7YQZBy4aZVu8mR1o8gQMrjB1dLPfdWyq1V6pYJf	7533	10675	10675	1617860700000	canonical
14793	3NL4YsaMFTVwQMHMCB3vm3zGxoFq5Y9gF41byLmdAaEHn8LP4cRY	14792	3NKfDGjMXZ1uXoviRGB9o3TFpcmMbE1F6iGxarivTWFjtfNnTprn	1407	1395	234	6301	10874	jwxNVAuWnKzTxcyvEFyHdjYwhK8DScHbREDXRS4p4erG6ZxSz7S	7536	10680	10680	1617861600000	canonical
14796	3NLgDkaT58b6Mfr9nfeN1hYw3RpQDqCFU51y7aFwi1ioMjCjbQTf	14795	3NLTPMbncjhUwYpCWMypD4GJa2peAjNkufVtecbGkSyu93mjKsgQ	1609	1087	234	6301	10877	jx5xzNp8MjqyjoDuqnuhsNvQj13Wm4BsHUEKTNU4NkLxoTpXfvM	7538	10682	10682	1617861960000	orphaned
14800	3NKvMWGLpmybGFPRCRD7sfNmU5F5KZgSE1YL4SWYCKq8isPb697y	14798	3NL2GRPKojnWmtonVYk55LnpvG1W671gT4WYxvEae2Hw8pKEnhR3	1553	776	234	6301	10881	jw9dNR3SyZZ4Dj4p9spQBu3Z8QZuyAHvDrAJgDnDrBuEbnB1CRa	7540	10684	10684	1617862320000	canonical
14801	3NL65NwJtJ9uGHQz7s1urjo9jh8eJJPSN2RTLzT9fRQD8UP7gr3m	14800	3NKvMWGLpmybGFPRCRD7sfNmU5F5KZgSE1YL4SWYCKq8isPb697y	641	1336	234	6301	10882	jxsJ6YGdaYqqBGN5hskgoHLxABE8WPzro28D9G8K8rmWBtT18Dx	7541	10686	10686	1617862680000	canonical
14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	14802	3NLJfHk5hbQVrYJStySyZ5PbvinPt4XLTgsZH9zQ6VGQAmaAxCTK	1656	1343	234	6301	10885	jxnCbQWc6QSnt6xbRzeMKK6keM6aWRLomWAQd3Ut1p8YyP8ASGF	7543	10689	10689	1617863220000	canonical
14806	3NLSxF66n3gs7cbS6TyBg7r83TVeYVbh19srV8DqoprrCv5CWXgC	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1624	1088	234	6301	10887	jwzqEpuezpPMgJwsshLnKhr7rAckN9yxREWvfddauwSp7qrBQa6	7544	10690	10690	1617863400000	orphaned
14811	3NKazSHkPmktTU8Ecd6xHf8RGb1DG1xvozFFwwEU8DyS8AYcx7GP	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	1534	81	234	6301	10891	jx9mfi21SiM6TDDVkn9ZyPAW3UrgzErvBLqEht71NfkynjCutAp	7547	10695	10695	1617864300000	orphaned
14817	3NLcPzf5YAGiNGF533mi9Nz3Zf5L8Vks3Jbk6yauaiL8GiDwNbgG	14816	3NKrSnJA2YzWvz5fhHSMCnEPk54V9LXc92to2eKDCtYfLkAqmyQe	1587	991	235	6301	10895	jwTBezztB9gpz1iGkKpMErmjeTRhkaEkGRmZB6hTmQkodvCx8MX	7551	10699	10699	1617865020000	canonical
14820	3NKKuBHFSiW7aR8FE88BP8o8hhnkeqs1cD1GiXaEnMtgMrbfUJHo	14819	3NL5zjBwXRxVLnFpJeSBxVY4WmKnTw36KEJUP4XSJtknBeKgU75i	1643	933	235	6301	10898	jx7nCDU2sm1d2R98TteXEDtUAcxqL21dnX49KV74gVyjyD7g39c	7554	10703	10703	1617865740000	orphaned
14830	3NKBK18Sx5HS4RykD9gh1KFgSx6XaqFG2UfhBHsQCbEnbWfT1gD2	14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	1527	1293	235	6301	10906	jwDo163shFTt9zwHwFVdgnJTtNmgsAAprXaGpEgLq9oC4soE7dd	7559	10712	10712	1617867360000	orphaned
14832	3NLkQD4641g41tC9JMEM9qcMmn8521Ce83DJoE2Yek5czRsgVu9h	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1426	1364	235	6301	10908	jwxzadC2s61KAs4D9YJpLYEwD2ayCeqrXacCBiktZ732CFeP3wv	7560	10713	10713	1617867540000	orphaned
14840	3NLAmaS58pj9jdGxzu5CeQ4FaMjHGwgy8QQPuXkU62DRHAEPg8rL	14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	1637	816	235	6301	10915	jx8xNVSFpawJ9rfT6qwctJvxgX96fMETABoyf2bGJCfmcdXfpv8	7563	10719	10719	1617868620000	orphaned
14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	14838	3NKtonFUJNuNurGJHPMHZ8jShB2VCcNgnHeJ4e6SkqZTZznGc8D1	44	83	235	6301	10916	jxoywj1ipTM3mKWoAFeM4cn31YcDAC5QdLLffkjRBFjg5MQYLRM	7564	10720	10720	1617868800000	canonical
14844	3NLvfyFV8rnft6iUUk4UED9xrdEiMFnoYhBpxpCx1zx9Mk9B4cWD	14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	1507	1280	235	6301	10919	jwMBPormy26Dvvs5m8iWM9JcS9wcHzXw3e1ZYpNB5GGTbCYZD3w	7565	10721	10721	1617868980000	orphaned
14849	3NLFRTjHqSZAK2AR9ZvchVKnpgZrFJxhdKGrDqLU6st5Lfi8qA1R	14845	3NLDgqxZMMP8KoRtWweS68B5DAo1hTGzDqeeTX6tea3rKDUqxzJP	1406	1393	235	6301	10924	jwYQeWE7wMjYpGGrKiW5GuiWGSGR91Xe4VNPQkXvjbQSmZKBe91	7567	10725	10725	1617869700000	canonical
14851	3NKqcmbeTbYzx9JfJ57dZwtVFJcY3SUK3fVou2iGMQAZ4bboZhW4	14850	3NK3CaXyvRhdeRpFvXnWPTTHnKf3LNbDBdkLtxLzx2RooPJVvm76	1619	1275	235	6301	10926	jx91Z1Zn4MeHCS3gXBTuupHd4abZcwrhqow3z1Y5AgfwZncSPj8	7569	10727	10727	1617870060000	canonical
14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	14851	3NKqcmbeTbYzx9JfJ57dZwtVFJcY3SUK3fVou2iGMQAZ4bboZhW4	1407	1395	235	6301	10928	jwXS8EFnRWi3BcHBvSxRbprEnQ6ixSaDmMV7msQ2fgk5qNn7DVQ	7570	10728	10728	1617870240000	canonical
14861	3NKeSq4xM1WGLacRUtssN7eYQWfQZpyJbtJ745VyCVwEexXqatGr	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	80	907	235	6301	10929	jxupU81sKbKkrE6cFx4UEZNATkndKWX8ZDMCWewuqK1SeSEL8je	7571	10732	10732	1617870960000	canonical
14854	3NLqY6DHgFB2U1G3RNRoeTjKFpx6b1b5bqdgReUko28LHyzXqKn2	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	80	907	235	6301	10929	jxZ1dRHCqun25Bjw6zJvcvUyyZucxVYBQdjVYdZVUTyuq6LeY9z	7571	10732	10732	1617870960000	orphaned
14859	3NK6XzKzUqydoyR8fvrE32SPvKUav9czhKJ5M43mZDXLjEA1ZD3z	14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	1619	909	236	6301	10932	jwRTTrZLSgVJmrrwMJdbrXzcXwTk87oqT32aNV94evNm1AGsjFY	7572	10733	10733	1617871140000	orphaned
14864	3NLr23qpfTKMM37foXJLpumKsYPSdNyvpA7knvtEKLsuVa1hNSBD	14862	3NKymcYKhBM79SRt8k2HVyQEDRyNCQJWyzfF6o1vd1S4DTaEXn2i	1406	1393	236	6301	10934	jx9G1W8PXuP5hSzqG9xUAhSV4DT9rufbghGMVemAGQMb9vFLJdJ	7573	10734	10734	1617871320000	canonical
14869	3NKKkkr5yYejjN6SFLq8EAeVksTwsNPMAj8ZUhVXK2ysp9PWhzLS	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1406	1393	236	6301	10939	jwkvcTfQtkZx3Yj2TCXXDeaDhHcMojDDtnrWXibMXPgYvhsGKYV	7575	10736	10736	1617871680000	orphaned
14871	3NKTXeB1eojR5aJoQdSuBT7sVZXgR6tzbyD182opR4hZXkkJ4Fga	14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	1403	824	236	6301	10941	jxFGJi9b88i6kgSCLmd2RAoKFA7557zj7hxggcPsBhBpWb7AsFa	7576	10739	10739	1617872220000	orphaned
20464	3NLrrX5cSmxMkDWv56udRS1rarn7gnA9SfArfBAhwnbg5HAdaKBF	20463	3NLEjCnEv8vHrBUXvfS2r7QdrwfNctwx6KSPvrtgZxYD6wVr9D2x	1634	1331	369	12463	12787	jwLpA25AmGh3d2AT4PWsyhzjVDG7uBmKPhsc3MQspcQHRRWVRFn	10305	14532	14532	1618554960000	canonical
14789	3NKFsUuqDdHWCJTdYN1GmEywmJttYhGnBZ5Eyt5W8kWoFAWcoE6u	14788	3NLvK85ZhPSBr4M9JTtL53S5nRvYaVR9g8LcgskYhNUMu5dNfdmK	1587	1111	234	6301	10870	jwP92B4sWihq4pPHkoyFjfAHrE4zbqbAzr4dRstz4BS7ESjuDYU	7532	10674	10674	1617860520000	canonical
14792	3NKfDGjMXZ1uXoviRGB9o3TFpcmMbE1F6iGxarivTWFjtfNnTprn	14791	3NLQys99Zp3RoU7eLDCXScHGTzATq41suYJMDdVSskNYSKFvtCNa	1668	1124	234	6301	10873	jxDk9eBMc8F2yweQRyXhekXPqW7HX2WvPXbBvDexFRHR4vGsyDx	7535	10677	10677	1617861060000	canonical
14795	3NLTPMbncjhUwYpCWMypD4GJa2peAjNkufVtecbGkSyu93mjKsgQ	14793	3NL4YsaMFTVwQMHMCB3vm3zGxoFq5Y9gF41byLmdAaEHn8LP4cRY	1419	814	234	6301	10876	jxAs8QP771jT16BGzS2wcke1a4ww7pDEWBL74nZZQrZHDixChWX	7537	10681	10681	1617861780000	canonical
14803	3NKT6TdomB6c4SovroB2tyBAegUh3apzuoYr1rxwyhzYcrjbdiMn	14802	3NLJfHk5hbQVrYJStySyZ5PbvinPt4XLTgsZH9zQ6VGQAmaAxCTK	1585	1000	234	6301	10884	jxi4WZUHWJd9sHkZ9cWXK33rXCed6ds9g9AAXR92YfNz7sj8Z7u	7543	10689	10689	1617863220000	orphaned
14805	3NLfMX8XKEkDWt63ddcKRp2aj4PNtcjuVzwyBm7quXZ42d7jLLT9	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1589	920	234	6301	10886	jxeDdTjpfVYk6jTnsVRmH9uHiLFzi1ndCJkz3LuA65uTQ4qVCRg	7544	10690	10690	1617863400000	orphaned
14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	14809	3NKoiTda5WdKv4fj9fG2u1DWZzjtaqZebrbgy1druHgA6m8VGh4L	470	943	234	6301	10890	jx9SU9en9kDwbHZng5s7p9vFbRitdvhdBp9Hj9QEVo6ZPBuPRGE	7546	10694	10694	1617864120000	canonical
14813	3NKxMWpUkAX7FGLJTGzXpJLwhShX3a2hsrAKgF7XttkqfDjR6Hjk	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	1534	81	235	6301	10891	jwGTALXqnAkhqVR17jWS56V6u4FE9WJh5BnjJhS7A7hVd59svZ7	7547	10695	10695	1617864300000	orphaned
14815	3NLqF7SL5hWuyvxFmfdjB9gV37YYWX1qTFCcKGNTzFZJGgLwjZyv	14814	3NLCcqKF7HhEUEW8PZvn8zDNSyhpLvhbZfgBKQ6RRXBVqjLUP22R	1483	127	235	6301	10893	jwx3FTRJkdwB4yh8tw22RPdt3zSjqRjvaz9cwXEqG3j7NsP9iZt	7549	10697	10697	1617864660000	canonical
14818	3NKx42ohk7icJpYpVo6rd1vzbwuyrLSBcSLqqjtHwaydyiGrDGKN	14817	3NLcPzf5YAGiNGF533mi9Nz3Zf5L8Vks3Jbk6yauaiL8GiDwNbgG	369	1066	235	6301	10896	jwTDxWbp6RV87B1Jjih5ARAcKHqDQx6UxTt8jbDMNTzrCT7nWnu	7552	10701	10701	1617865380000	canonical
14822	3NKmisMhP7aGPtwsdmg1rJ6dCU1DJgNSLaWaXg9zibUPBvWCivpp	14821	3NKuyxxWPjfkSCyHn6UhH9Z3vrtCfybcMv89VhA9WxxZraivn8GF	1624	1334	235	6301	10900	jxqvnfyAoFoSLfvfV9k8hbc2URuUWqrTJZPA1B9Y6N14NaNn6dL	7555	10704	10704	1617865920000	canonical
14825	3NL2c9kt9P7tARzyYnWxYmFQjcQtUtsQKZavE3Np7KSREAsh5nzD	14822	3NKmisMhP7aGPtwsdmg1rJ6dCU1DJgNSLaWaXg9zibUPBvWCivpp	1407	1395	235	6301	10903	jxAK6nWLerEw1ZUp8Sr6in2gURDmdfj5ooY6FbEBiNjjBHxFKdp	7556	10706	10706	1617866280000	orphaned
14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	1527	1293	235	6301	10906	jxmWHNMJ8TmW2VXyCmSBSoYyvuUeDqk2BUmUAdRGViwd9ifUhfC	7559	10712	10712	1617867360000	canonical
14833	3NKHxPvtazUsycSTeCjHuyR8axTGagnKYQLimdZFGQHacZtzjGZ4	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1602	1123	235	6301	10909	jxwMMHifdTdxmcYHqVDqVNcbmwa3mgDDxtALLNWAVqj8GfQfmEz	7560	10713	10713	1617867540000	canonical
14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	14836	3NLv6iPQLb9mwrGUPXF9Bh3Ke15qDeBc3fS5GimRbRjXNSN38o9d	1439	1279	235	6301	10912	jxkb1uRVPnKLPVHLvK6fc8Xjjo9VWMCdvzLRsmSqmFKG3zYeS9r	7562	10715	10715	1617867900000	canonical
14838	3NKtonFUJNuNurGJHPMHZ8jShB2VCcNgnHeJ4e6SkqZTZznGc8D1	14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	80	1273	235	6301	10913	jwJaNJLLtagVoQGwGBZkap2C54V6FsHBhyxtuVaCxe1ENdFeEkE	7563	10719	10719	1617868620000	canonical
14843	3NK7TQN28zWuJfCyg2pTK8xudyWLrrzcxm26c42ctBZwJik2SYHM	14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	298	1308	235	6301	10918	jx71QjvyD3zANw9dbESCDt6bGEDDxjLXSsKDtzSVMy68NC9uPkV	7565	10721	10721	1617868980000	canonical
14856	3NKPN588iCjRARm8PMXotPhAcKZmKEd8NeoJL7DxEnQbovT7GECQ	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	1419	814	235	6301	10930	jwxhZhmT26JomZWFCtvCNSR1oUU1JLvpBB6GtGr5sacasHnYXdF	7571	10732	10732	1617870960000	orphaned
14863	3NLZsom7eD2v4YEQ6AMYonmebhB27hAvk8D9KHThZGfejZLbMX6P	14861	3NKeSq4xM1WGLacRUtssN7eYQWfQZpyJbtJ745VyCVwEexXqatGr	1619	909	236	6301	10932	jwwXV4mteW95A37zkPs6fmEWQhvVt4vujXinWHSYHQQ41nuKsHu	7572	10733	10733	1617871140000	orphaned
14867	3NLk67R2yWTkAojWRBz39uB2GMSmYMmd5yotZCQM3eJNLCFbjmJp	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1407	1395	236	6301	10937	jxp5oRwyTgLWWcebPDJ6nbvja1PdBsR96inWL3gmJeEkXzCi87R	7575	10736	10736	1617871680000	orphaned
14872	3NKExzkZ6RiDVy7uaQXYApVNuGYSDPj6AF1KDYb5zw2QVUkbEUqT	14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	1633	1144	236	6301	10942	jwxBK1Sc6T1QTxRzodfri8EwUUny3eV4tWJ47TtSqzB7FPe6zdm	7576	10739	10739	1617872220000	orphaned
14875	3NKzSpsWwL86RXXgez6qC3gMVGtbKjspG826ZVxfkjbR8s19AZcz	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1407	1395	236	6301	10944	jwSD2A8s7V9UenjtF2MznXdduH88vJXBBFz8yYpime7uT5qAwvw	7577	10740	10740	1617872400000	orphaned
14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	14878	3NLKttNg8j9WHKiPd2H5jErzzEDgeg6XrYNVb6BTauBK8xGBzAtz	1406	1393	236	6301	10947	jxPZuDBo7fKJjSG8ouFMrPSzGzg1BwmDBpffG8kL3xGdWtphRnF	7580	10744	10744	1617873120000	canonical
14882	3NLMxn146rYN33yAmL5zMC2wpLRvGS3Jpxz21SJQvbjeWuqyzd8H	14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	1490	1028	236	6301	10950	jwyC5yoFZJbzBWGpwjc9p6fyiser7S9fzfp3KtotVaHEiH13bub	7581	10746	10746	1617873480000	orphaned
14884	3NKFnvKfg2JAkdKoFMueJi7SdXENmGcSA4tFGK8yasgJjE6debNM	14883	3NKihs35JbnCL5TmHasSdcZ1VLZU7EXAeMbTkEG3d9UpE9iKrv9Q	1407	1395	236	6301	10952	jxYtrZT9svBqdQchvvWX7ThsHkp57jfKhfeZrNaa3uLjk5U7zyF	7583	10748	10748	1617873840000	canonical
14888	3NKUK2ZvFT36PXZ1kvuvKkBGis5SnzNSPL1XfaFiSDVu8JJDTFNE	14887	3NK6HMgSzsZx9VJ1M7H9qWWfBVjBvADrnoZY6EKazGEaTq7ovwY4	1402	868	236	6301	10956	jwDHCCtCFJJTaKpmdx3wTgeLumtAXSB5UTXsLJGcaeXtn9u6nnD	7586	10755	10755	1617875100000	canonical
14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	1581	778	236	6301	10961	jxiiQzL3BSybDVu3PfaHkUEd54JEuohMqZrvnc64DeFqUCwstjC	7589	10759	10759	1617875820000	canonical
14899	3NKoB8o3YvdgVrPLdXEfCS3kBQeetH5ofQyH8SYuUCDcE1gPEAZy	14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	1406	1393	237	6301	10965	jxpcmadzoLqjpz7ugEgd2aKPWFANRGB7xJDS9bM1ahFQiakGZxp	7590	10760	10760	1617876000000	orphaned
14910	3NK4w9WM7jC7MGDht2dLDc19UkZuqC2MYr9qeHL4nvxm5fyhbzti	14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	1403	824	237	6301	10976	jwMQ3YNuQRQ9exVhQwKXfaeaytqWei9cpDCg8Gu51ZJhZwg8AMi	7597	10767	10767	1617877260000	orphaned
14919	3NKQ6onLr4WbMypNZYMympmWSbSGVm2E3UaSouwLABatgxfL6U63	14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	1406	1393	237	6301	10985	jwEjvStR6X72NnY9suimbpW5abyawwbydL2WbNFboMHWNz2MhpJ	7601	10776	10776	1617878880000	orphaned
20470	3NLmL9d4KWaQrDj16VQbwfJ7j8SEXFPkJf8S5ivrAEmduqdFzTYN	20468	3NKpYdh7ZVQfBN1recpWx4CaDphTutVJM7rqbRnq5FLe6shmWrvr	1501	1360	369	12463	12792	jwUjLKLRetmTTbSsXcKD3wamwF3kiYuBBzXmyEtmzXo54peU9Gi	10308	14535	14535	1618555500000	canonical
14791	3NLQys99Zp3RoU7eLDCXScHGTzATq41suYJMDdVSskNYSKFvtCNa	14790	3NLesXwMfbX1PNp1mfGEJr3GsZ4jiGhQVK6XnJX5sv6u7HBJRkSD	1406	1393	234	6301	10872	jxZ8EYM2YAXuCs8An5c8H73d5ZmPW3JepvMbEpNneMyA86KLuPV	7534	10676	10676	1617860880000	canonical
14797	3NLGSzLhdbr1szwKnv5Z2iaZAJTKPVALfoCBj3wcN3uW3wHuZDdX	14795	3NLTPMbncjhUwYpCWMypD4GJa2peAjNkufVtecbGkSyu93mjKsgQ	484	1193	234	6301	10878	jxpzU94iRhZgM2SSHb8MVCxS4gNibJy27xByYrWkEL1jd7BNavQ	7538	10682	10682	1617861960000	canonical
14799	3NLbjv6YFko98kTwhg9iRMbUBtkjdkTfVYQYXyfBaaEEj4F6SmD6	14798	3NL2GRPKojnWmtonVYk55LnpvG1W671gT4WYxvEae2Hw8pKEnhR3	1403	824	234	6301	10880	jxcMKUzVpEpLc19nrYroVEY1XeZyoeDhAjHiZYx5gzkZebMzYUD	7540	10684	10684	1617862320000	orphaned
14802	3NLJfHk5hbQVrYJStySyZ5PbvinPt4XLTgsZH9zQ6VGQAmaAxCTK	14801	3NL65NwJtJ9uGHQz7s1urjo9jh8eJJPSN2RTLzT9fRQD8UP7gr3m	1406	1393	234	6301	10883	jy3Kyd9p5BZwtEM9PCNyTxHrUTxjWGyNzCL1iduzdaUxhKX1UQJ	7542	10688	10688	1617863040000	canonical
14807	3NKt7DS55ySCrVxYVmEo2T2rXuhhYMmvD53n3cV9VUb3qXB9Ejgk	14804	3NKid18wHa1Xawwhv1DPjmc43QgsLWETdcCmK68NonbExDtzjgzd	1637	816	234	6301	10888	jwSmnUtLU4diKaAvKaMNDMpV6S8Yk6xZXVqrv9yEzWKCYW1NpCr	7544	10690	10690	1617863400000	canonical
14809	3NKoiTda5WdKv4fj9fG2u1DWZzjtaqZebrbgy1druHgA6m8VGh4L	14807	3NKt7DS55ySCrVxYVmEo2T2rXuhhYMmvD53n3cV9VUb3qXB9Ejgk	1471	1140	234	6301	10889	jxdN23VyjVqnDP6nGNefeZ9x9o5nNRb169HGewBZ4LP4AmHzYHW	7545	10691	10691	1617863580000	canonical
14812	3NLtFYuEoCoJg6szxqn1MkNKALMSy2AmJhHJkm97HrLbLyjhQdBb	14810	3NL74CoYVWUbdmpiNqrR4VVE5VdKorpr4MmRge7j4d7WaH1rNasi	1534	81	235	6301	10891	jwGTALXqnAkhqVR17jWS56V6u4FE9WJh5BnjJhS7A7hVd59svZ7	7547	10695	10695	1617864300000	canonical
14814	3NLCcqKF7HhEUEW8PZvn8zDNSyhpLvhbZfgBKQ6RRXBVqjLUP22R	14812	3NLtFYuEoCoJg6szxqn1MkNKALMSy2AmJhHJkm97HrLbLyjhQdBb	1406	1393	235	6301	10892	jw8sszYoFjYBoTE8RUtAQLfGMHBfW8fNcrUb2CA5345oiqj2EJ4	7548	10696	10696	1617864480000	canonical
14819	3NL5zjBwXRxVLnFpJeSBxVY4WmKnTw36KEJUP4XSJtknBeKgU75i	14818	3NKx42ohk7icJpYpVo6rd1vzbwuyrLSBcSLqqjtHwaydyiGrDGKN	1671	1365	235	6301	10897	jxjgmjZYjqGJv89sXYUDJmN4bEMnGj7j294v6gZjscM3tPnRCkQ	7553	10702	10702	1617865560000	canonical
14823	3NL3MyrXDjJ1wQQjFaWpgpA5g2LxVvXeK153957Vx19TN7FMNQEF	14821	3NKuyxxWPjfkSCyHn6UhH9Z3vrtCfybcMv89VhA9WxxZraivn8GF	1581	777	235	6301	10901	jx6P58dmhUzDNnD8nU6P9WuX1NGw5hLTH7J4WTb7CD7njqsjeyy	7555	10704	10704	1617865920000	orphaned
14824	3NK9eWtTQQDQeh6JetKeHLhGk2EZWNztH4LL67dNAG9eoKzZkSN7	14822	3NKmisMhP7aGPtwsdmg1rJ6dCU1DJgNSLaWaXg9zibUPBvWCivpp	1648	1038	235	6301	10902	jxHbUtGCMgs1D3esthB6LcC7Z2rRLfoXHk3AJcGa63oTW6T9ES6	7556	10706	10706	1617866280000	canonical
14826	3NKz8Nqoqmb3Lq9cDetkRPcvyX5z7sF5BEtf21Pg9VoXC16XZrV4	14824	3NK9eWtTQQDQeh6JetKeHLhGk2EZWNztH4LL67dNAG9eoKzZkSN7	632	1256	235	6301	10904	jxnxRRuKLmLBjK7PsFeDqxquZkuK9ZMQsqeMctKdSrsQebwZDth	7557	10709	10709	1617866820000	canonical
14829	3NKZLj6ECqssXactQeNU7ohSUYEHCnQBgabtKAZcME7yuFmWnYoY	14827	3NKhk6cKkbrCvBLFUjSY6kkkZThGZSPVjidnZR7C5DhtangHBRdr	1527	1293	235	6301	10906	jwHyzHAkPoAbwY3WXzYjqFPzLgY5HUbC592ENySTDuvAeFVhpcP	7559	10712	10712	1617867360000	orphaned
14834	3NLaxjxkgtsXeFnsfChDooTWyzMEMjq3Hied2FBDVhfPGXmRMAmp	14828	3NKCM8HmLJGyaBY34YEk1WxQF74i2CEDt71U4mY5nhWH7yFLXW1b	1602	1123	235	6301	10909	jwtKsy6uSvZrJA72jToRCRVSnV1JKZw19sUqmnYpVLyUCFfiJc6	7560	10713	10713	1617867540000	orphaned
14839	3NKaaKojq3E8LbEKXn5tzeht8F3F9WshXGkpbkydg3EQAr4A1ooJ	14837	3NLZwRrM82seZGgrP3Sq8S9cU1F2w926h2zSFY7LLoB2GeVNRmHa	1516	1294	235	6301	10914	jxUHiCXDgGzVKG5r57QFdM9v7rXLh6VRt7tozNXrxjpLFfm2qY7	7563	10719	10719	1617868620000	orphaned
14845	3NLDgqxZMMP8KoRtWweS68B5DAo1hTGzDqeeTX6tea3rKDUqxzJP	14843	3NK7TQN28zWuJfCyg2pTK8xudyWLrrzcxm26c42ctBZwJik2SYHM	42	1235	235	6301	10920	jwpdF6AwNiZyYasVkiVr3MiuTKnivnW72vxiM48Ag4sLkgLNtjQ	7566	10722	10722	1617869160000	canonical
14848	3NLvpk7mECqxtAXLimGmKzbWk2JJTGjJo6DpLNuCDiWJBeBjDB3i	14845	3NLDgqxZMMP8KoRtWweS68B5DAo1hTGzDqeeTX6tea3rKDUqxzJP	1516	1048	235	6301	10923	jwfQk8CVqYMBZBua9aBdwnC7dnZrMSLR9Zw8CTELqD6JY4kJsav	7567	10725	10725	1617869700000	orphaned
14850	3NK3CaXyvRhdeRpFvXnWPTTHnKf3LNbDBdkLtxLzx2RooPJVvm76	14849	3NLFRTjHqSZAK2AR9ZvchVKnpgZrFJxhdKGrDqLU6st5Lfi8qA1R	1647	1302	235	6301	10925	jxfARuzFmAdN68peAY23135u1xxpbHeVVzKuJzF9Ahc9bYV7jP6	7568	10726	10726	1617869880000	canonical
14858	3NLZ3jaMzpcETqa7V2CaQBWm1mKkVThkE3wh4gWzEAJxVMiRmmMS	14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	1471	1140	236	6301	10931	jwn4VEFm1bSBC9a5pXCyajwrjohfNc8bJmvat5F8G3DY3axkUZR	7572	10733	10733	1617871140000	orphaned
14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	14864	3NLr23qpfTKMM37foXJLpumKsYPSdNyvpA7knvtEKLsuVa1hNSBD	1553	776	236	6301	10935	jwJnemCEkAUTa5suyRJzE3CiNRpk6aF7yk3jTPmgHcfCm7jn3vu	7574	10735	10735	1617871500000	canonical
14868	3NL9x5Xyp1L6DCRHMhGNzvuquVBw38Zz6H1LmwUxQsyLue2xKr4m	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1581	778	236	6301	10938	jxXaqWKKHvaMLSCsjfXJujDu3tXbeNUdWDSmfBK1qFVREtbQHAU	7575	10736	10736	1617871680000	orphaned
14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	1467	1376	236	6301	10940	jwtzGamHdnJods7gQtukRLAdhPwQdDdkTdRwDhisLzBm5f8YxvL	7576	10739	10739	1617872220000	canonical
14876	3NLjhoGxTu3BtTPLycEbTw8X6oXsvLrAhTDP7hnKceJ3Hb9YFjfe	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1527	1047	236	6301	10943	jxGgmKmGnSbaS83EQpd3rrfYVyjS69LmsemQAz7V62zv2zWsVqp	7577	10740	10740	1617872400000	orphaned
14877	3NKcBMXaXgY2vwh562PoWmv3xcRTksVFTekmYDBSvncydvV2vfnc	14873	3NLCdDxWFPUPdtmkHyLkXWAevVCEyPq6cJKKsQrYGruo5bbBY3j4	1406	1393	236	6301	10945	jwzeXGrPtGJDrp4ge6aZWkFDYH9Pt2f4jWx7miRRQhbGxKMnKui	7578	10742	10742	1617872760000	canonical
14880	3NKHJmZS8t3QA5DfaDABoMWWQ1LN1tY3FyjhDnEKDWSmvSuo2KUe	14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	1403	824	236	6301	10948	jwEeavE74PSbSjBkPMsWbQhmbguWeL7gTNuZWEkY8o9UMaAdXxR	7581	10746	10746	1617873480000	orphaned
14885	3NL8KeVn47MzSastUUzUwanZLRB9onWhvGdV6y1nMutfhejXz2Eu	14883	3NKihs35JbnCL5TmHasSdcZ1VLZU7EXAeMbTkEG3d9UpE9iKrv9Q	1553	776	236	6301	10953	jx1BTNZKPPxMAVPn9dK95YNScedNPPGrgCTrvAqE52xiaKCQej5	7583	10748	10748	1617873840000	orphaned
14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	14890	3NKVADskzT5ZBfgDv7RmCwsAxCbozB5VoubtryvbTSygPbLsJT3a	1406	1393	236	6301	10959	jxMgSPHTNCNE4w2Diik2iaEMEu2EcZHq843kxq7rDZGY8uS3fAj	7588	10757	10757	1617875460000	canonical
14894	3NKoDU5DgVttR1dMEBeKun441e17mcd6NJvheaFQWxCJDxKLEZj4	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	606	1295	236	6301	10960	jwYWTLJJU5kKpVBzXUjS1dJLvzj6G1ui16UKf4UJDWGoxr3xbLP	7589	10759	10759	1617875820000	orphaned
14897	3NK9n4SVshN21dRjhjfeM6R9XUaDkKKmgkc1njHhVdWB5bVCQxay	14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	1637	816	237	6301	10963	jwfPTCA2STmNUH9eGS6kjGGdw4uiVR24tC96R9QAThju4ooRqcH	7590	10760	10760	1617876000000	canonical
20480	3NLAWbGbCeDk8mLX1AFZfgoMmMJzhaaTvGLFNUN7bDvZvatzBLoc	20474	3NLMYXAuZumm9oiK8UG4RSbmcnWnnRxAZKYGkgYd73sF6cNiH89e	633	1384	369	12463	12801	jxVVys8Q5SvEFo8r5ddyw9Qvb6uw4pT8MGwzFZDcygPMTGZKHy5	10312	14545	14545	1618557300000	orphaned
14836	3NLv6iPQLb9mwrGUPXF9Bh3Ke15qDeBc3fS5GimRbRjXNSN38o9d	14833	3NKHxPvtazUsycSTeCjHuyR8axTGagnKYQLimdZFGQHacZtzjGZ4	1406	1393	235	6301	10911	jx2xjgjj3UvaxKGkqDiqYZbYzjxX72soFD8J416T6MHCfUGcvHg	7561	10714	10714	1617867720000	canonical
14842	3NKBC1j8UQtXpDT8DfcizbY8Nng2naVqQVZdnymKbo3PmWH8HgN7	14841	3NLoxk5t7frsCDgxoxwQ3taLAeYobNZyhpENtS8aCN3dHi9y6vFL	152	1330	235	6301	10917	jxCjfeg8kaKagUHYGL8LqxK1xX4DtwKdx1NxRtRcZYkyVS5paQT	7565	10721	10721	1617868980000	orphaned
14847	3NLLDhEaAqcQNW3e9juAxJAnyRdWSUHZVsnCT8s5zW3KJJhPsCWo	14843	3NK7TQN28zWuJfCyg2pTK8xudyWLrrzcxm26c42ctBZwJik2SYHM	1508	1261	235	6301	10922	jxYbiwhvom594iU1Gq3PgrANa64C6dVPTgdmG3mM4h41eYkJTwi	7566	10722	10722	1617869160000	orphaned
14852	3NKphdGn1UiU9SGmRQFyEVEBggrJvSRwmUReXbp4U48LS4BS7shj	14850	3NK3CaXyvRhdeRpFvXnWPTTHnKf3LNbDBdkLtxLzx2RooPJVvm76	1406	1393	235	6301	10927	jwDx9r5cCLnRzXKYV65D2dYmnNeGpRyDdyUpJfXDLvyacSNnXRX	7569	10727	10727	1617870060000	orphaned
14855	3NKPoEGMLkruq3a9X2ys8KdfRG7pD2wkicMsFjSzRvLF6nydaTKt	14853	3NKFgKWC8v3wAqaVjfSbqWBn1gEZWCB5LkUmK8Nh7z4VRgQHGX9f	1419	814	235	6301	10930	jwuAqfshprakp34meQ54sBYCuxHzcJwrCykqJV9VXavG3Fhm5Kj	7571	10732	10732	1617870960000	orphaned
14862	3NKymcYKhBM79SRt8k2HVyQEDRyNCQJWyzfF6o1vd1S4DTaEXn2i	14861	3NKeSq4xM1WGLacRUtssN7eYQWfQZpyJbtJ745VyCVwEexXqatGr	1571	1335	236	6301	10933	jxQDbG3Qz4a5z9jpi6bbZdmFfThFjHxC2dg7evSHd6UVJQxLEZz	7572	10733	10733	1617871140000	canonical
14860	3NKdP4rEjwA73P2ztcgdZd18HG93HHNu2GvmoqypqEaBk6Qjc5SF	14857	3NLUM9h8KWZ3wzxbQwR8VqqQsHqZzFa1ZkptuvsGRAq2X87fJsCT	1619	909	236	6301	10932	jwr9BMyuhNL5mJzAKgmWz5CZ2XDmXTeWakhCUZ2yKycdm4cKhXV	7572	10733	10733	1617871140000	orphaned
14866	3NKQ5LEXzFrmcssff6gCcN8pKxZsfqCGgsZ61zbyRnkjPG3ARAKd	14865	3NKH5e4AtZT4cBtV47rcHPzwQHymtQNTRyYf7CMHRtQrrp15ws7F	1403	823	236	6301	10936	jxb56TW21wThxampNAAQkFKRgsKY7A3GuLmn434MUfiaTCGSZYw	7575	10736	10736	1617871680000	canonical
14873	3NLCdDxWFPUPdtmkHyLkXWAevVCEyPq6cJKKsQrYGruo5bbBY3j4	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1527	1047	236	6301	10943	jx2Afnb7BekM6qdrUXtbWmgZyc5kht35xFp3diQWVdKqhvpmZyX	7577	10740	10740	1617872400000	canonical
14874	3NKnW4Yh3yUCCuJRCA83SfemwemFWxf74Z8Bm16F59fS1EwMfwRY	14870	3NKXLo9DStyDkGHkJ7afddS2oU8FjAqFFj8q84pGHaqAqSgaYSF4	1527	1047	236	6301	10943	jwuAa7cddUo6WBSxmSUH5Bb8JaUYMYjM96brnZMbUTcLnjxpUT5	7577	10740	10740	1617872400000	orphaned
14878	3NLKttNg8j9WHKiPd2H5jErzzEDgeg6XrYNVb6BTauBK8xGBzAtz	14877	3NKcBMXaXgY2vwh562PoWmv3xcRTksVFTekmYDBSvncydvV2vfnc	80	1273	236	6301	10946	jwXbR7eBFaN2NRHUmVfg1zZQyULHLpsE6Lr5iHeDTZBYvaL1ZjG	7579	10743	10743	1617872940000	canonical
14881	3NK8bxJ7ojJ7o3AarH2haF1h4bmgfmtNsJzE5vnETQ3SRrbWJw5x	14879	3NKuHVAZ5cAR4b1GUtp9AoCPpKT7wcwYtsPxu14uqec1Gv68isUP	1422	971	236	6301	10949	jw9R8MVsojkr8BEDncqzuh1WXXrXLWpSoZPLkJGVDz3RJNHBeWV	7581	10746	10746	1617873480000	canonical
14883	3NKihs35JbnCL5TmHasSdcZ1VLZU7EXAeMbTkEG3d9UpE9iKrv9Q	14881	3NK8bxJ7ojJ7o3AarH2haF1h4bmgfmtNsJzE5vnETQ3SRrbWJw5x	152	1330	236	6301	10951	jxECmXrDFfTKREs7TNr8gcbFPDLc1JudYAf95t5GCdavdWLHybD	7582	10747	10747	1617873660000	canonical
14886	3NKMSmQaje1VxvHwkf9twxdcq3cqRWBuqwi75426tH4f4ZFeNvSw	14884	3NKFnvKfg2JAkdKoFMueJi7SdXENmGcSA4tFGK8yasgJjE6debNM	1455	1086	236	6301	10954	jxKY4J2AtX9hbg9cjEGUV5qB1zvY9TpoQYGyaPX4xGNvHonm8j9	7584	10752	10752	1617874560000	canonical
14887	3NK6HMgSzsZx9VJ1M7H9qWWfBVjBvADrnoZY6EKazGEaTq7ovwY4	14886	3NKMSmQaje1VxvHwkf9twxdcq3cqRWBuqwi75426tH4f4ZFeNvSw	1403	824	236	6301	10955	jwHG5uuTqKdiVG6xvyYuEgGL7u1fJdCntV7LpALWmdUdPc48qDY	7585	10754	10754	1617874920000	canonical
14890	3NKVADskzT5ZBfgDv7RmCwsAxCbozB5VoubtryvbTSygPbLsJT3a	14888	3NKUK2ZvFT36PXZ1kvuvKkBGis5SnzNSPL1XfaFiSDVu8JJDTFNE	1406	1393	236	6301	10958	jwYN28kyVJdfyi8Q44A7s3JK1bQD2WqRbSQgie9j2TPDQkfUiWM	7587	10756	10756	1617875280000	canonical
14889	3NKkkyKhdLWFoFf18dQRB9xuxDNt2CjJ87dKnLBz9fyfGRAQsV64	14888	3NKUK2ZvFT36PXZ1kvuvKkBGis5SnzNSPL1XfaFiSDVu8JJDTFNE	1407	1395	236	6301	10957	jwRZtnqq9gxcoEBFa9CGks9yc4JxUo82uztwLcfs33cziTyMfDa	7587	10756	10756	1617875280000	orphaned
14892	3NKBEPGwWxAowQ4P9dM3kaZbXKENf39nPkuCiLqyQxAhmjbcq4vh	14891	3NLKKn5RTWzQWxZsKs6EKeWRPvhH8YQrpKkyC7QeyqptAzKjKQGt	606	1295	236	6301	10960	jwYWTLJJU5kKpVBzXUjS1dJLvzj6G1ui16UKf4UJDWGoxr3xbLP	7589	10759	10759	1617875820000	orphaned
14898	3NKsnehF3BqTt6Ca4xF3kjxWZSKBxFD8fRGqrogteMXmFJUFXTjk	14893	3NLC1oZFrKwGaWvebAEPgq1RZVKfWFWZNc1L4Uz4djtZ28Y98NAm	576	1229	236	6301	10964	jxvUnp45B2esSSvHK1Z48bCxWpi1DeMsZcC7bcxZYosTQ73n8VJ	7590	10760	10760	1617876000000	orphaned
14900	3NLkhH6tAdEoTfi3q8j86HLoU8LApG5DQccbxbC2uQzxvQD1JKUQ	14897	3NK9n4SVshN21dRjhjfeM6R9XUaDkKKmgkc1njHhVdWB5bVCQxay	1549	1362	237	6301	10966	jxWT112Q4n2R36pU5iBDrxo3XD3sv2xrjzkKV375gDnuq14E4ax	7591	10761	10761	1617876180000	canonical
14903	3NLdQeyENgC2xemkvLf9hvgw4h998D2dGtA4xG1AdxvMyoKCT1GL	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1455	1086	237	6301	10969	jxfbCJ3xuhMQorEanaaN1yM15ARQHuWJZCQMEx5CRRvMr8b7ds1	7593	10763	10763	1617876540000	canonical
14902	3NLNEXHocbCcy7B8UJFpRPx4a334kR7MFPgAwY7akwLfzJuYtpsb	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1444	1255	237	6301	10968	jwJZA6ssz4BKS4gxKF4nGy54bN85k5AvABBF5ryaBgDYWqqA4wD	7593	10763	10763	1617876540000	orphaned
14905	3NKhfH2FaMRWdJnmEwK3PQ14z338xq6ZwRmgtMEAqWUywCo2keFz	14901	3NKvm12xCXgXX7thYNtGxLt8mJC1mSwVBNycox1Xu3bPYTF5jAFV	1600	1246	237	6301	10971	jwvN3ks42MD335BVamWYt5B88x8uVmfXFrKpnJNR9Pp5TfLMPeJ	7593	10763	10763	1617876540000	orphaned
14906	3NKmVh36MistMLzhGtEVdZAwNiLE5qGXaAp6TkCGCMoixeN1ZaFi	14903	3NLdQeyENgC2xemkvLf9hvgw4h998D2dGtA4xG1AdxvMyoKCT1GL	1458	1323	237	6301	10972	jxq62CLg3Q9WUM8yVKYTHoCTP5wwC4apTnQFHyX5BeHXtqzZU6Q	7594	10764	10764	1617876720000	canonical
14907	3NKvdhwUZwEtUH8qayvydkXxUozqAYeqc8emBsdnmwkyrD3bcDiD	14906	3NKmVh36MistMLzhGtEVdZAwNiLE5qGXaAp6TkCGCMoixeN1ZaFi	1407	1395	237	6301	10973	jwpJNaHDAVjhXEB1aQqfA7GVBFFPM82d36e5kRpKUbVxdJqQMCw	7595	10765	10765	1617876900000	canonical
14912	3NLhtghAL5HnZcTmD3rsBgHHHVTnsWcJ7xD6uT7CBXxupzL7vNne	14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	1405	849	237	6301	10978	jwShwa7wmkzaCq3BxjD3Kgg1JeTSyFv5f8ZKnhbfUS2tBGSMRt7	7597	10767	10767	1617877260000	orphaned
14916	3NLMPgN6bznKibuM78h8zEdXYJsyAe5C4FzDXZGzUUoYSwrEWAUG	14914	3NKB2UAz4mmDJxVtXsx4oirn8FjJgvL1erRieqGUrqzZRadx551h	1406	1393	237	6301	10982	jx3ALhdgszG4FGwFChuyqtNp4pbcdWAEwue55v7vjiVnB1WCttp	7600	10775	10775	1617878700000	orphaned
14918	3NLCbYrzQHqDskA9FoQigE6VS1EfTMpVodM2HagmcMxXqcwzAFAS	14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	1637	816	237	6301	10984	jxkwAy1RuCTyzk4szh89X5jFYU4hcrxi45QTkbiYMNVyBgFuWwH	7601	10776	10776	1617878880000	orphaned
14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	14917	3NKrtx1G2JsBcG2nSndG9Lvv3VjabvvHwtDZ385o5wXhEhR1cdt7	1522	1196	237	6301	10986	jxxjtvciurUrgYS6LQVAynzrjJoyYweDW9asM8jfaModBhfGmaj	7602	10777	10777	1617879060000	canonical
20647	3NKnXuWZcsRNwrGWoQLCxNvowGhnNhmwHaD5sEFJJq44d64Nv16C	20477	3NLC4XVbHa2nJeqjUejCeTokX9LrTtPKeMw1ax7KhNyntZquWqV8	1477	1350	370	12463	12950	jwsAiZdxxC6YKyG7bWrRZAjdxmQbpVi1TSqx8vutFAcYNi1e63R	10313	14647	14647	1618575660000	orphaned
22206	3NKyrJULJmYeExyHzG86LnHrt8fDY1kEr5kESMYiruzzfy5Cz9Aw	22205	3NKVBAu1upsM6z42XBrZvVJKJQCrxtmvbE9ruwwZF1B9sQX3gW6d	1607	1348	409	12463	14335	jwY4AynvQxNGg2ruJHTCjYZfHx2ZKi4b1Gq777u3kNewoMmCURx	11116	15646	15646	1618755480000	canonical
14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	14907	3NKvdhwUZwEtUH8qayvydkXxUozqAYeqc8emBsdnmwkyrD3bcDiD	1403	824	237	6301	10974	jwmsGmvUwfa9vzD9WS11mZJnFSziMqYPrfVhhX8U2xz2JDkqNwy	7596	10766	10766	1617877080000	canonical
14909	3NKgFxyyHVxvyJUWKi9cRcrwML5HJjaQPVCLhTN7kAEHAUwG8NxE	14907	3NKvdhwUZwEtUH8qayvydkXxUozqAYeqc8emBsdnmwkyrD3bcDiD	44	1325	237	6301	10975	jwAxnWcUuuDht9z5JXQNKxovE9AGqYrKZ5C1p6XQx1G6Lb7LVVn	7596	10766	10766	1617877080000	orphaned
14911	3NLgcx95yDUJ1jgeeTvad47QPteHDcxVuNtmREiF8Ns4wjchQZXq	14908	3NKNpfq7Y3vb4NzQUPoKzmVJXBnKfq8CzztaHUnWN6AW5x8ETtjb	684	1106	237	6301	10977	jwJyk58FTrgNCRUw8pCmVnigKpdAtYEZukNCmz9cohu6BB3qxsw	7597	10767	10767	1617877260000	canonical
14913	3NL6owY6FSwF8YLukhfUUKqAAFEEWvUV5iFcgNAGBgJdJkhGRfi1	14911	3NLgcx95yDUJ1jgeeTvad47QPteHDcxVuNtmREiF8Ns4wjchQZXq	1673	1368	237	6301	10979	jxJ7Hep6qgnURbAqoqYpQZSqNNVY2zU1yzMaRAsepf4cwea4gfD	7598	10768	10768	1617877440000	canonical
14914	3NKB2UAz4mmDJxVtXsx4oirn8FjJgvL1erRieqGUrqzZRadx551h	14913	3NL6owY6FSwF8YLukhfUUKqAAFEEWvUV5iFcgNAGBgJdJkhGRfi1	1406	1393	237	6301	10980	jx87WDQdjveQWRdUznmuhWPpBzpKqXFJ2s4JvJujKkUZTUticJE	7599	10774	10774	1617878520000	canonical
14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	14914	3NKB2UAz4mmDJxVtXsx4oirn8FjJgvL1erRieqGUrqzZRadx551h	1405	851	237	6301	10981	jxQtCjcoTJTLrd29JraUvNjaUxBoScTeRmNzTEyg2ox6mhUfpEH	7600	10775	10775	1617878700000	canonical
14917	3NKrtx1G2JsBcG2nSndG9Lvv3VjabvvHwtDZ385o5wXhEhR1cdt7	14915	3NLTLLV6hBnghHN8eqE4ZFhHn9eFBY2oUsji7znJVNU19asgEobu	298	1062	237	6301	10983	jxyJJiRM9GmGvHz4wcvbhJFdG4qsVKkJfc6TeT9kfdYCPVZcLSF	7601	10776	10776	1617878880000	canonical
14924	3NL9GifSBBfP4qoFLKPdKedY8wdR7zftqYpNFVxZ3pAVrdsxv6XN	14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	171	1128	237	6301	10990	jxCYupZi8wKfG7NQ3AGMjxN36U4GBcHe7tH3GN3rds7N4ssxVmp	7603	10778	10778	1617879240000	orphaned
14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	14927	3NKMb6CGiTs4RbYoChWQd8NB3wrked96TX8exM3iearix6brLpSG	1407	1395	237	6301	10994	jxSR3DxN8Dy19G5NMHLFxpayvaXKMDXc5YWmDV5sfg3fEjqHte1	7607	10782	10782	1617879960000	canonical
14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	171	1374	237	6301	10997	jwMfWxT4RDbABZeaJsVtpXwAUhEe9xAvwh91hMrmJwos2MU4kMz	7608	10783	10783	1617880140000	canonical
14929	3NKGoCwTUzNzHKJ8dqdDV4UfpUXYKZVdHn1tL2Kw8mTJCya7h9Sd	14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	1407	1395	237	6301	10995	jxjiNnEjX3PfT8LWezNuwLXpsZxDUeKR8VoRDJau4aFppPz5Cfx	7608	10783	10783	1617880140000	orphaned
14935	3NKVGw6FuLEqa642aFxkgUzzQcynNFpTsiBPnqGki8kWWtrSuPoH	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	576	989	237	6301	11001	jxvKESiuu7FFsR7JBgK1Q5pgtJQ2R8Hxw13C9EXbDa2HCibtjoT	7609	10785	10785	1617880500000	orphaned
14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	684	1226	237	6301	11005	jwTtEt1gnVoRZyfgWZ1tcqy1aZX9UqKxto1it1gXn4f42pHXBmb	7610	10786	10786	1617880680000	canonical
14940	3NLp6CnSwSXvVW12WZ6G6U6kawjBwphArBfxhc3NYTLknsxJs8wk	14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	1407	1395	237	6301	11006	jxPSLRkoahCBtVFEeDTns86DyUYPXiyu8CRiXGUgCigGovUtJ1v	7610	10786	10786	1617880680000	orphaned
14942	3NLtaepQGFpsCRcEEuMT5oMtiUEQSVzcEXzhg67DyybpPnW4CPx2	14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	1474	1329	237	6301	11008	jwaFWJkoFXZdbuYenQ3qsAYPLtcDC8fVWZgBb3eX7oPjqMoHKtm	7611	10787	10787	1617880860000	orphaned
14944	3NLcryMXWcPB4bkvpGnZbxpoVpt2zmSydUVkkLLqQRZYX8ZAXARM	14943	3NLW7KfbSw1t52GxJELqdPF4fEpVcBaDfw8t7iTUpBNXHCWNKX1R	633	1384	237	6301	11009	jwyMcFkPptSgXpXBzNNTZzJhFt4EdFN9WDUBCydRoEDfkbhVCTy	7612	10788	10788	1617881040000	canonical
14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	14944	3NLcryMXWcPB4bkvpGnZbxpoVpt2zmSydUVkkLLqQRZYX8ZAXARM	1611	1215	238	6301	11010	jwqger5e5kD4ACHRWvHtSQEvkcALLnHat7adpXMNtJHGJC8vCuf	7613	10793	10793	1617881940000	canonical
14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	171	1008	238	6301	11012	jwZvynRn7YtJ4NcKs6E9zsirej5jA5uXLYRQEWBDr3arxVrKn4H	7614	10794	10794	1617882120000	canonical
14948	3NL18yP9SHdHZR84KZBfFrRrmtcGvfpwB3qcybBxGPxjRkY4GKk3	14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	1610	948	238	6301	11013	jxmE152mEJqokyzuo3VLCD2btoa1Tc7vFxgeiePpLKfU52Gng97	7615	10796	10796	1617882480000	orphaned
14954	3NKFr3f65w5k4vig28Qso6YYDQ25uENfxSnpKJ199GDBQCefrrAZ	14951	3NKFf3N1UHptFnYBNdhKE2cBRmfRhcQGbmBNAprv58gyaGm2gzw8	1406	1393	238	6301	11019	jwppCtdnRsppAS4XUCPtpnakjjmH6PgXvY1WL4wyhVSs7y5HDqQ	7616	10797	10797	1617882660000	orphaned
14956	3NLbwjkGPgzPACQFyp2tof83YuUyLh7o1gUPUw3HBqpp6HxfZT6N	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	44	348	238	6301	11021	jxyzNZitzyEcZ3rxa5B7esq9FSrZiNERJSheqxgvS8cGkQsa5CS	7618	10799	10799	1617883020000	orphaned
14959	3NKwMqUoHUMc7ve84cMBzHFv45qFdR3co49n5ZQ5u84pDGEjDPC7	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	1627	1259	238	6301	11024	jxxBw7PvngfHWaubKku2WUPEjewpbKhEwBqLNuAKELoizKKSXAu	7618	10799	10799	1617883020000	orphaned
14963	3NLRK3wNxpyAjfdyd1X2JowowDRwcx26tXfAC5GgmSBxDFW98yuZ	14961	3NLSzibWJH1ZP8H9pQwVDbabUjNxZqZqn2AHchA3p3vaL2rPmCHE	1602	1369	238	6301	11028	jxQnpMutR9dkgVeYM6myE8yYJ5SFH6sGEWR2s3PzgBnGs9fA2Uu	7621	10803	10803	1617883740000	canonical
14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	14975	3NLsUF9fJ2YtPEtFszk2KNUtvGxVtDnQDdqrN5knYo8FPq7VPrBE	1440	1131	238	6301	11041	jwDiQNxZjhbcsauVYdFeku2kXtwgwH3tJhDfRrDg7WnbtQ7wc1U	7631	10815	10815	1617885900000	canonical
14978	3NKNVCFaQU2o1Ntb7W7iqjGBG1qeaTuRLAedt4sHjunA3WBLMZYD	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1448	1185	238	6301	11043	jwk8HCjaTx5YkUhYLQ559mcThBMKZmh3MUk32DQ1uyxUvqJLgJv	7632	10816	10816	1617886080000	orphaned
14981	3NKqD2QsMtrzvyWKW3v1RcXejMhMin31Zi2r9xMvKHL1v5Mmnx7P	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1448	1185	238	6301	11043	jwttTJtPuLNHmeRJjXjSeQ9SmT4ekQCX7A9V71Rh7FqJRdCcfsP	7632	10816	10816	1617886080000	orphaned
14990	3NKgniUmThCB91xqs12THjUeJHosvLL6jLihBXxM94Ye1BBeP4zH	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	596	1180	238	6301	11054	jxK7hus9xUU39sdCFvQRaBhWBk52Jr6mtBSu98dZ9AGyBPgwjFp	7636	10820	10820	1617886800000	orphaned
14999	3NLFHkTNw5XMXSgNskDWTFiafiBfn8qvGgbrcfWfMAFgW2maQXEH	14997	3NK7fd16CvHLtUj4zuLjjjKjLPLZwKaxjzRJKrtif7wtzfXKcSUS	1502	128	239	6301	11063	jwwKVFzhv1vMb9m4kmsVt6yJY66mNivJDqddQqmRwYGXJCaewWy	7641	10826	10826	1617887880000	canonical
20799	3NKHBJKNURUez4LyXRusEdkKjZiW5G2mNxmY38tDLTapawsjrsy4	20573	3NLRaxrwvPF6mrDsvJZcUNqSG9wrFCUHfhRMNL4apGds3DLyQ7sN	1451	926	370	12463	13090	jwp69q2SsgLzPdNkJduAKCiH3hzgcP8KuehfGF65VRDhcBjibCw	10315	14729	14729	1618590420000	orphaned
14923	3NKyH12zkbsi1XEF3ZU1ccHNL6xvuY69gtDeRsgq1Xwfy6Q7WzVy	14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	1471	1386	237	6301	10989	jwStPhAUyRXUtmzMuJaDw5v9UMbXaKxxtJ9R5BPVzQaGM9Dg3YY	7603	10778	10778	1617879240000	orphaned
14925	3NLebMDzHbnZUiMAa3KTda2voNuzVR6Hybi3croZ87n5zofmwUch	14922	3NKhSuHFX1bPUQs7rYZBh1uQeL3Dv2YtHrMko8xFCqAVcbcgeRZb	1581	778	237	6301	10991	jxKzGz5zwSywWxa4FpNShVwVpoThVzFQhUX36Q3iqWcUqRbzcxv	7604	10779	10779	1617879420000	canonical
14930	3NKRqiAwmAX6qcam6pGzFXF5TTLLSALKHJ6TkirPrzhWtKXVhaoX	14928	3NK5EGC7u5RnbB2CAwTJiADpgzGQ8KEqSTiAaThy8jtEofz1GPNb	1460	576	237	6301	10996	jwfcHY3iYDWEZ7UX6G19eoZfUmsznFadsvBRZL42erwjMdkqLm3	7608	10783	10783	1617880140000	orphaned
14933	3NLoLcNchVNqWYna4ykB6y4Wwfo6CR8ySyj7dsjo8VhDoWrEzk3L	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1483	910	237	6301	10999	jy2iQk9H2yKLi9zz69YQuJg3BxM2aGoWo5MvPPaEiHuTd9BH1c4	7609	10785	10785	1617880500000	orphaned
14950	3NLBt8KgA6joc2GzKGdaG6SB9n4MfFTgibf5XaaB9UGy2b1ckqJM	14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	1624	1334	237	6301	11015	jxbxiDdL67Mjz1r7KCwJwdPE2r45UW6cr612fcct4jmV9mzSSZy	7611	10796	10796	1617882480000	orphaned
14953	3NLrX2a3tCgEL61jEfpK2bP28LiMMhqyncX6dV3m8uZCmQiZ7Gnw	14951	3NKFf3N1UHptFnYBNdhKE2cBRmfRhcQGbmBNAprv58gyaGm2gzw8	1476	1125	238	6301	11018	jxzLif5NZLtRwCRUDhDjfgkWoCXAvT7T6TqyL7EyQcyED6B6z3X	7616	10797	10797	1617882660000	canonical
14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	14953	3NLrX2a3tCgEL61jEfpK2bP28LiMMhqyncX6dV3m8uZCmQiZ7Gnw	1672	1159	238	6301	11020	jwYY2DYdoM8GWHpzYMx4fxS43B3cgdSjE11Ntc8G2XkCTg37wDS	7617	10798	10798	1617882840000	canonical
14958	3NK34Jy2JTGCkhysYdMqGBjw1J6ynXGo8wG4vQeZDuZZB17ERJqf	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	1406	1393	238	6301	11023	jxyYoSbMjzUNBrNBXFUa4doNyGY62KJTeFtQ55EgG53xAeodWM3	7618	10799	10799	1617883020000	orphaned
14960	3NLaWtDiyMCyaMdNpnABMYWUJ2cV28TGkd4ewm1rKuGfo33jNnun	14957	3NKzxPXvCv2SkRkCyQcQkAR5PXNXJWpr4YURZNA6L8p4QNzrf197	1547	1378	238	6301	11025	jxAmK3gsCs3maNdWNr6f3ZPQb4RoZkQ8juQ4oBEq3PNF6tBWp3K	7619	10801	10801	1617883380000	canonical
14962	3NKCti9eFsTomntuDAB2FtLjWeaPgj5aAKHtYH8CKoQiudgBYS8L	14960	3NLaWtDiyMCyaMdNpnABMYWUJ2cV28TGkd4ewm1rKuGfo33jNnun	1481	790	238	6301	11027	jxvJ1uJBcXC7gYBU13pqH8LvyZ7MBAgxgzWgjE8junCAMwANb4k	7620	10802	10802	1617883560000	orphaned
14964	3NKwpgGdFtr24G3N1497brHWvhbT4qT9v8AGzrxV7e5f3CKRefym	14963	3NLRK3wNxpyAjfdyd1X2JowowDRwcx26tXfAC5GgmSBxDFW98yuZ	175	175	238	6301	11029	jxDkwqPnbsPtxSzWv8xDSNhjjA6v4oqNxzfQ72TZVq8ePZXP1Mj	7622	10804	10804	1617883920000	canonical
14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	14964	3NKwpgGdFtr24G3N1497brHWvhbT4qT9v8AGzrxV7e5f3CKRefym	1652	1315	238	6301	11030	jwpLuFhjXYQo5UTZewdVQ3xrbVmj41YStvi4eSwz8HKS47ESYGa	7623	10805	10805	1617884100000	canonical
14968	3NLMpAzb4zYWEjFn3L6G4jcuUACbYtwBKHNE2YBdwAju32u5ZWff	14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	1553	776	238	6301	11033	jws8yQaP7QL33BqZQkGtPRdVF8FLAtBDixFGG34oQJ96E4j7ofS	7624	10806	10806	1617884280000	orphaned
14969	3NKGENvHF2zjuSRz3KzmUbnknachzunysZc81G2bKYxPULgx49bQ	14966	3NKhsXuk2HUwGdzKfZirqF8XoxfAwZTouRWad19b3U5MEmJFi67s	1631	794	238	6301	11034	jxGSVx6Vy9ZkxMMa8vV5A6xchsi9zpbGXYmey4DZxcvJZjkGZm5	7625	10807	10807	1617884460000	canonical
14970	3NKYJ2Nz1n5ccAUG2Arhj2KMs8EaUXSJQX2K1sPPEsMSJTWaNGRk	14969	3NKGENvHF2zjuSRz3KzmUbnknachzunysZc81G2bKYxPULgx49bQ	1613	1349	238	6301	11035	jwza1eZ8Mf5ckpYsidRtEq9yAhL8ofi86F8eUF5xvwbZ21pbYuJ	7626	10809	10809	1617884820000	canonical
14973	3NLxK1iEsXoR2Uwg6huhyopzDFAcrwVeVUSBJk26WycbomhTJTDU	14971	3NKMF4MkuxPpWUkRWNMBcAW4iWe4zCWGK9tQ2gV7HvMa63qnzkb2	1594	1326	238	6301	11038	jxZVcAyyCYD9yJDaKKgN1HL3YEkFdec4W92Y8WgmxKn9SqWNm8d	7628	10811	10811	1617885180000	canonical
14975	3NLsUF9fJ2YtPEtFszk2KNUtvGxVtDnQDdqrN5knYo8FPq7VPrBE	14974	3NLmKT3pyyV2rvXgPh3KpX2AVbuK8ykn2EEKhN59t7kRsNf2VdgM	1407	1395	238	6301	11040	jxfuHuT4S7ya3mv4pcywa262PnEDwYUfQTWDuAreD6q6U1uZJf8	7630	10814	10814	1617885720000	canonical
14980	3NLsZFoonqzLTm1aBaANvEWXkyp5RZNR5bAUR51adACu66x3EF6d	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1407	1395	238	6301	11045	jwyWpqD2xHdCZj8GZWUKx2qLc8mwzPVMcu5dnjZ5EcqXYzdmSQt	7632	10816	10816	1617886080000	canonical
14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	14980	3NLsZFoonqzLTm1aBaANvEWXkyp5RZNR5bAUR51adACu66x3EF6d	1609	1333	238	6301	11046	jx8SXFQuYqWSqUd5unyTA3CGkk8E8BPt7zaew7b2GbRS7C71j39	7633	10817	10817	1617886260000	canonical
14985	3NKyZwrHLDS9V5NZ674hXVhuLCDP7Bkpj8NPHEHAQ7Kjy3ofZ3Gy	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	1445	1044	238	6301	11049	jwUTx8yVLFPfUD7cJZiJNSaGrZWZePVC2vwqfe9gFXisSHqdNA4	7634	10818	10818	1617886440000	orphaned
14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	14986	3NKR6kTgaKDcWXzRT7Jp9VRhbTJoA5tH1oSPkj5oyAMLV5kuTPR8	1672	1285	238	6301	11051	jxwDtgTb9ak7jLG83MMePwWbVGx9zRsaZJj75LppYBYVW3ZCRDs	7635	10819	10819	1617886620000	canonical
14989	3NKZMBM5E3skcfPS9o9BoLit9dxxoS9mxibR5VBqHLWSRyHF7vhb	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	1672	1285	238	6301	11053	jwGNmxYtxv75ahAsL7wgKkpNtFetY1iQfrdWKHQZSvLa3F4VKAb	7636	10820	10820	1617886800000	orphaned
14994	3NLZoCRjRKkCNzTJ4dGpDPcCskaQ1vDziPMdiNqiczDz5hTqBSVC	14992	3NK9KaCbu3Qg6A9DLZpSygCdRFfteCBLbcv5baDssx97SwyWGDjd	1440	1011	239	6301	11058	jwnTxBymz2YaayghGDPSaf5dQtDAa1ecvJ5niC6xUajx5gP5MpG	7638	10823	10823	1617887340000	orphaned
14996	3NLiTwLbE4ACZenHGhgbKLT2bWHnp5Ur1zZgLG3Fgc8aTw9DAM7P	14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	1553	776	239	6301	11060	jxYAnwTr3A2YQvGeTuhReEYfXocucBLLjBGoEERuMZd558m75tw	7639	10824	10824	1617887520000	orphaned
14998	3NLT7TbGgrpDFQ43ruzVnEw4c4qUwaa9Gb9WKtNUnzd2iwoYhpYV	14997	3NK7fd16CvHLtUj4zuLjjjKjLPLZwKaxjzRJKrtif7wtzfXKcSUS	1500	1297	239	6301	11062	jw8trCW6NcpVPs2w4KpvnVnDgbBct7xheVXs2dooRbNFJqtVGC7	7641	10826	10826	1617887880000	orphaned
15005	3NK6L2K5XAw6Ty3hY81KgCQpSdHLBnTAkmZdEdb58ibVSfF1qY8y	15003	3NKHVjQQdfjxT72VAAe6Pr9ov9MCZLzMYoVScwmEPdRx1CmMjWuP	1406	1393	239	6301	11069	jwHkjLz9tBAp5FUbDqTZSjtGLcesQdgo19L3bXwQsqXbvSzN5Bq	7644	10830	10830	1617888600000	orphaned
15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	15006	3NKqJ4xugCGtXLZmkcRpaA8nnNhJtUveUs1h1FkdfzrH7MzSnk86	1406	1393	239	6301	11072	jwL2w7w5qcrnHZg994vB5cPKJGEUGR6tNq67kiREhz4pBc8a794	7645	10831	10831	1617888780000	canonical
15010	3NLEzQkFt2ayKepGnZHYA5EBYoMPZ38pZQSCK8ditjxzRS5XoBs7	15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	171	1374	239	6301	11074	jxTCrBXVJftncgYdZAteSryQ6wdTyjMxjEEzMUVV8ech5Hy5zgB	7646	10832	10832	1617888960000	orphaned
15012	3NLSSdt19MyffgkK9FrdYZyndDFZQYreLDijBhTJY5sKGtueaP2T	15011	3NKT6bjvnNokUC9oac2BZDvLZ7fSyG7djqi8noRduhsArW64MYZx	1522	1322	239	6301	11076	jwy3RyAwtjhKJCyTuZVMWUJ3uNr1uoaFn1DKowbeTC8ds9S237j	7648	10834	10834	1617889320000	canonical
20489	3NKp7M5TGA4pMeNiqCLHFiQadue2TsGXfrjWwcSomaFCTPVxwKf5	20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	1476	1245	370	12463	12808	jwVpmjRSAxeEnFeEFmodsFuVWiuHdPjvewFNL5aieM9qxkZ2Cj1	10316	14549	14549	1618558020000	orphaned
14922	3NKhSuHFX1bPUQs7rYZBh1uQeL3Dv2YtHrMko8xFCqAVcbcgeRZb	14920	3NLcFG133gwtDGk7aytbNMbLGpHDobiDmhYfdWFBok6YmUpQjodE	1585	1120	237	6301	10988	jxM9RYGFV72SeopU3LUPBcebGoFkoUbUVpXA1Yvyo52w75zS1BM	7603	10778	10778	1617879240000	canonical
14927	3NKMb6CGiTs4RbYoChWQd8NB3wrked96TX8exM3iearix6brLpSG	14926	3NL4wJnAwTeyLwdwTga2CVpaL1hESZuPrFsJNkvBpc84G8CPPBAH	1643	1299	237	6301	10993	jxhSDbYrRCPAhAk7hG6QEB5Vx9tPnB7v1Gx2X4cZ7jZvc67vfrB	7606	10781	10781	1617879780000	canonical
14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	14931	3NL9dodXsqrCRXMrbXMigjGgagiDjLiGFNujNkTsYe3uJxDkJGgD	1397	838	237	6301	10998	jwYKjaxdSd4KSGGAgbPuqDKF2aaFw5XETYRSe22fAf3wCQfp2U3	7609	10785	10785	1617880500000	canonical
14941	3NKpRzWSwCWiPYbSJDUqqo3voyn9CFPLkk9TkEDaVr3yHvWSyAJ2	14932	3NKaFiv3oeSBMZJho2ASysTHLSsbLoMKVZxWQ3EFyKT8Hwxwi26G	1637	815	237	6301	11007	jxqtB8xxJxzUG8xGQtNn4n1T5WnyzbZLRZeTprEvk3TKJgPRN9B	7610	10786	10786	1617880680000	orphaned
14943	3NLW7KfbSw1t52GxJELqdPF4fEpVcBaDfw8t7iTUpBNXHCWNKX1R	14939	3NK6tFhv8qiXWNMVGkacLijAdTR7e2SWeN12wMP3DCHrJ2v7ua52	1474	1329	237	6301	11008	jwNZNGdf8P5V79BzmbJTqP9VaYYKuSLWgkBRtNS4Wx3khNiZxDB	7611	10787	10787	1617880860000	canonical
14946	3NKyHnuxDx87T1o4KnXpzysBb29vVQZmYiqaEr5NUJRCsJMWw5Ce	14945	3NLXt9in1RnjvdVNj1RQZgLKbnsoJG5xarfgqbR5mEbBtShn9hLF	1522	1076	238	6301	11011	jwBySNmJV28cn3abDCAuTQ6tkcJsnSbGLChbEySbzCZZDmKTo2s	7614	10794	10794	1617882120000	orphaned
14951	3NKFf3N1UHptFnYBNdhKE2cBRmfRhcQGbmBNAprv58gyaGm2gzw8	14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	1541	1298	238	6301	11016	jwzn9dX1jHpgmB8cxepyxfFdDhaxBtiTYXQsZ62FG64xresGY1G	7615	10796	10796	1617882480000	canonical
14949	3NKMT4KDjGKncrEH8PK6ZMnnF4VDq1fPEnXHewMsPKbtbdQMWFLa	14947	3NKE91CDi1rXAH2ibiEEiALuJZCX1BLanLuAjvZZAmW3JJDAFRxX	1624	1334	238	6301	11014	jxHSd4FtL8dUKvpCDoaeCXktxcFNpjbP1uo4NDzbf2C7bkHWb2a	7615	10796	10796	1617882480000	orphaned
14957	3NKzxPXvCv2SkRkCyQcQkAR5PXNXJWpr4YURZNA6L8p4QNzrf197	14955	3NKMonhdTvdp8SSM2aKVvLriaPBBJifgp1LU4W54RjkpipTs7Reu	1649	1383	238	6301	11022	jxSNXc4XXiWAvxiacpyAWNo9rtCe7mmZgKPoNiyeZrRX8xsEfgw	7618	10799	10799	1617883020000	canonical
14972	3NKRUuE4dMwox9gdxN7ap1wx135EeFwkBDhrDhb8AhqikE9nNrQp	14971	3NKMF4MkuxPpWUkRWNMBcAW4iWe4zCWGK9tQ2gV7HvMa63qnzkb2	1587	1231	238	6301	11037	jxnxgHxLUcBxmyhbmyJ4wvLT5xwPzdc12Bwao9Cd9jon1VAWUvd	7628	10811	10811	1617885180000	orphaned
14974	3NLmKT3pyyV2rvXgPh3KpX2AVbuK8ykn2EEKhN59t7kRsNf2VdgM	14973	3NLxK1iEsXoR2Uwg6huhyopzDFAcrwVeVUSBJk26WycbomhTJTDU	1426	1118	238	6301	11039	jwRC3Ne35YU4T9w2Ry41jSdNQcy1uqnoQRfT5AdZ7rwKb6HF8Tf	7629	10812	10812	1617885360000	canonical
14986	3NKR6kTgaKDcWXzRT7Jp9VRhbTJoA5tH1oSPkj5oyAMLV5kuTPR8	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	1633	1390	238	6301	11050	jxCEwtAWnBW9kFcdDBy4vjMNJhFviKpZBLoL4ZA7tsqaRH76w2c	7634	10818	10818	1617886440000	canonical
14984	3NKy21LE2EB9vXThzNfQtxUT8sBidEWUpNpZ9AUUbzNutCvisjEr	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	42	1235	238	6301	11048	jwG9rugU8ieP8adnWbszuFhjwwFVr2o3bP3Hq1W2ne8hNkFxMw1	7634	10818	10818	1617886440000	orphaned
14988	3NKpe6Yudy76PxCicWjpuav9QoM6bdeA8iTubk1XV2ZVRkx1xYgD	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	1607	1348	238	6301	11052	jwTkJvqnN99w4FnAzHbv18RpsybjNxotuda651jPJ3ejXCW72rb	7636	10820	10820	1617886800000	canonical
14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	14992	3NK9KaCbu3Qg6A9DLZpSygCdRFfteCBLbcv5baDssx97SwyWGDjd	1673	1242	239	6301	11057	jxqsjeS4TQ6KRxRppGudbUMQb4TLPtDkDfMquC798L9TmtvjbPB	7638	10823	10823	1617887340000	canonical
14995	3NK8JxCJdMYKnsyVzwVM51vdJXihV8isd9c77dPGXJ7xK7uv4UCH	14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	369	1312	239	6301	11059	jxYfSiU5TrnYGcZEMq7MkSt9m7dcPMKFZJGhcp4YEqWwZXzKaLh	7639	10824	10824	1617887520000	canonical
15000	3NLcjgzG8H9uwJGzu9i3WCUC67Mnwu7FvzdF7RJarG1G3ErJby5S	14999	3NLFHkTNw5XMXSgNskDWTFiafiBfn8qvGgbrcfWfMAFgW2maQXEH	1553	776	239	6301	11064	jwjzz62T9LhVTyd3asNVS2piMpGgsFSzA5fcuqmr1UaSHdjKhoL	7642	10827	10827	1617888060000	orphaned
15007	3NKs1HeVhpjNxZKvmGNVVtJCCPKXA8jvUUubpZcY9wG5mrqg6B78	15006	3NKqJ4xugCGtXLZmkcRpaA8nnNhJtUveUs1h1FkdfzrH7MzSnk86	1490	1274	239	6301	11071	jwwgBeLJK6TvADyjE5FuDSAkUDqxMzpq8dTi5Fv2oePaedM2qsx	7645	10831	10831	1617888780000	orphaned
15009	3NLEEVf5CsjCjxXyiDCfWksb5WRgzEFVa3H1xUL4NX4eDUPsJyh1	15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	1407	1395	239	6301	11073	jxa6Sw89m45cS2fxkBJRxouSkRT7WnqwnhRCaSW4beUJoSxpkqq	7646	10832	10832	1617888960000	canonical
15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	15016	3NKvHDjEDMeePVM9SFZrcnH5ZtxKsV8sykF1BYDyMwpCudtRitLf	58	1281	239	6301	11081	jwy7ppN7j7ygjdFD1upiMZPMTJcKz844PeqdPDkWeDcmpEipjQZ	7652	10839	10839	1617890220000	canonical
15020	3NKKXPqTsQ9MhaMhXXVehxHWLurqq1sMn41931Njt1S8uKHJyXv5	15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	1527	1047	239	6301	11082	jwXc2EpTbRT8idCoRAMZMAdE69af8Yb2xVqtDZUdj8ax9Fe5VqZ	7653	10840	10840	1617890400000	orphaned
15022	3NLv5VRADeYNTPea4sPJ3oFiUbMB81URWUsWSCoApcsbpTpEEFgE	15019	3NLgKHz2Vo3a8qsh3qWtX2Vt1ozZdHCV8sqgztq73HqvHR6DE6Ey	1516	1168	239	6301	11084	jwUu5VBNj4Prxfdt2npoGV1ptxUTGL4qGo2fh1jvZNQxdkz9mo9	7654	10841	10841	1617890580000	canonical
15027	3NLGW6QTT1XGLMJyshtdT4TP59Z5xG67JSsf62KyDDr2cF1EKHVL	15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	1507	1154	239	6301	11089	jwe3171udJdLFDZggayFw4PqkwQT2HTASdpo9a4zuz9pnfWhuWM	7657	10847	10847	1617891660000	orphaned
15029	3NLtiE1BgMhseV2QfcF735yp5uFhRevMG85BSV2oSAVJC98SoDDM	15028	3NLrz9mzKeiC9MqFVpf85nZXQZwpges2jBjysP56NE8uJ9HNMVLF	1407	1395	239	6301	11091	jwHPg1TiNpsckimaHBPWjNtiPhGmSB1qdz8gX7wGoD31XATnGwB	7658	10848	10848	1617891840000	canonical
15034	3NK3gpkfUmeWNUA2J9RuR3Skqv3bPrfAY8gNhPuyad3NpNbjsqa6	15032	3NLBmV7Q2iYHK9JspSY4yMKASryHLjS2RtnnBeNGBnfa6qgPikoH	1448	1185	239	6301	11096	jwB3R9ZL4u31otZMwqQ6E2derAdiYtNJW4SMhxgxFFtfvjujFtR	7661	10852	10852	1617892560000	orphaned
15037	3NLoXxQeeYm8sVpY2c77oSpJKMdqEJGW2Sj1QBRb6YxJEfcNTJdW	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1527	1293	239	6301	11097	jx8Kk5vL9ShSVCfyrCeGJMftfNSZfFpqfK27qSuTB6wYMars2xx	7662	10853	10853	1617892740000	orphaned
15041	3NLgu2yGGzC2BYExQCAM2SaJ2Gj1PyafXrbB2e5hJM1C2sDgkcmh	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1553	776	239	6301	11100	jwVntDEBNiK4suLL8Rnq1ooFBXkDtiDY87As2icpnvPwWn34yuZ	7663	10854	10854	1617892920000	orphaned
15045	3NLUsFa8xpf9JCRY5UpfRS2fBQLZCXj9wZsMzAUMu6EXiW38dKSc	15040	3NLUpXfoRd9jwykSg2bmBg1kBUJaR4gjUNNTXZgoeBnvR7UFTuTX	1611	1215	240	6301	11104	jwRdStZFe2GC2ENXqABLTEP2unHVfQTv4k5JZJ6iMCNtNmMST3A	7664	10855	10855	1617893100000	canonical
15048	3NL27Fk441ruh3XGfDHBbqdAesCxdXSizLbpSfTii6rRP2ibFHzt	15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	1634	1205	240	6301	11107	jxRNDKqBpt1ZcRFo35AUcvuD3d3RF5LjzKby9qxYfvfkf8LfjsC	7666	10857	10857	1617893460000	orphaned
20890	3NL4rBS1nydUm1rzAPT5td4Br1JdzCwieyzuka4uxfmANCKU6wsW	20799	3NKHBJKNURUez4LyXRusEdkKjZiW5G2mNxmY38tDLTapawsjrsy4	1451	926	370	12463	13175	jwp69q2SsgLzPdNkJduAKCiH3hzgcP8KuehfGF65VRDhcBjibCw	10316	14789	14789	1618601220000	orphaned
15031	3NKXCEEzSEayBrqdhSfuUiM3tGa3a739jy2TCChYjcrMTUEeMsfv	14823	3NL3MyrXDjJ1wQQjFaWpgpA5g2LxVvXeK153957Vx19TN7FMNQEF	1593	1100	235	6301	11093	jxcRridsXqPMPqXje1tHLQM8V3GQwBJvgphUVTnBYDhXLn3NhDM	7556	10850	10850	1617892200000	orphaned
14961	3NLSzibWJH1ZP8H9pQwVDbabUjNxZqZqn2AHchA3p3vaL2rPmCHE	14960	3NLaWtDiyMCyaMdNpnABMYWUJ2cV28TGkd4ewm1rKuGfo33jNnun	1406	1393	238	6301	11026	jxJfvWZ1LgSdJuRYXQTUieP1nRri9qBBWN8LKfaG3bfTjuxUwDh	7620	10802	10802	1617883560000	canonical
14966	3NKhsXuk2HUwGdzKfZirqF8XoxfAwZTouRWad19b3U5MEmJFi67s	14965	3NLFLGGRmADuSK9KmkAUr6LkiRoUNMJXZciAMCxpDR9vsdX2noH2	1483	352	238	6301	11031	jwHaBnUP1sLcPcbUydcpc1bku1exbFbvVkDEbfnno6hivHyMRaS	7624	10806	10806	1617884280000	canonical
14971	3NKMF4MkuxPpWUkRWNMBcAW4iWe4zCWGK9tQ2gV7HvMa63qnzkb2	14970	3NKYJ2Nz1n5ccAUG2Arhj2KMs8EaUXSJQX2K1sPPEsMSJTWaNGRk	1445	1164	238	6301	11036	jwte2KMRpiVur7Z3Nirj1LHDysH9fEYN8TXxEM4q27UmU3uPEgC	7627	10810	10810	1617885000000	canonical
14977	3NLmKVGwRp1v8RtdiDvEcQYE5ZHXgWvNNFwxj1TrpeayCSSqngZa	14975	3NLsUF9fJ2YtPEtFszk2KNUtvGxVtDnQDdqrN5knYo8FPq7VPrBE	1631	794	238	6301	11042	jwfo4yuKQqYUjsPPpxnkXk9krFdryh4e5HEkw9AvENmauyRjjbr	7631	10815	10815	1617885900000	orphaned
14979	3NLV3yPncVGo7ciq7v91L9wXbdbqP4xydA7QdNAAGdyEyAZaYH7d	14976	3NLAemHwNBNuTwY4b1speePK1omaenVceduTUZEbx9FqipLoxtAp	1596	1363	238	6301	11044	jxuc84CEF9BTUr1TdULigrB7vxGebut2r9g7RGcuoFQDgyfz6Cw	7632	10816	10816	1617886080000	orphaned
14983	3NKMbrgpp9AUy75xntnjNzLYjei8U9hmC7M8xtgfJaaPnFmiPjjd	14982	3NLEtDWeJNk1Gv72po7GLzvLqzwQWKCBsrnMkHcG4CizyFFRrM1w	1607	372	238	6301	11047	jxzMYTjYRVYdnHtyMkhBppRqoVa3hN458UoTY4uvPpxoUJuma3W	7634	10818	10818	1617886440000	orphaned
14991	3NKGqiSrtR3z57BdBP8hYFqiYnpAnrrvi3a6K3vswVXkPy8noYPC	14987	3NLNs9VRYvkH1vfUN5vseLuddfGQA8RbtThs2gwTbyzSHmXqeRjZ	1553	775	238	6301	11055	jxwYvygTFRnfa1ZbtzuuGcLrVNRyqkwnYdwYBuJ26FKA52SpG4M	7636	10820	10820	1617886800000	orphaned
14997	3NK7fd16CvHLtUj4zuLjjjKjLPLZwKaxjzRJKrtif7wtzfXKcSUS	14995	3NK8JxCJdMYKnsyVzwVM51vdJXihV8isd9c77dPGXJ7xK7uv4UCH	1637	816	239	6301	11061	jxHDn42Bj8F21iBziLSkSPf4qYr6YDeLTrh8Z69jywT1DHXcCxY	7640	10825	10825	1617887700000	canonical
15001	3NLWxjbwScNWj6hXrYMYH8Wesv5vgCz9MsNcWsS6rUqWxAonLxYU	14999	3NLFHkTNw5XMXSgNskDWTFiafiBfn8qvGgbrcfWfMAFgW2maQXEH	563	1359	239	6301	11065	jwubGixhfat75iSvnLf7mYesNHNqJdPs1VTcv4ArHSd9FcWt7YD	7642	10827	10827	1617888060000	canonical
15003	3NKHVjQQdfjxT72VAAe6Pr9ov9MCZLzMYoVScwmEPdRx1CmMjWuP	15001	3NLWxjbwScNWj6hXrYMYH8Wesv5vgCz9MsNcWsS6rUqWxAonLxYU	1578	1296	239	6301	11067	jxQJ3Jh6f2AjSdJS4ostQzX98qXZwpCYmXLWwCcLyXceoHVMCXz	7643	10828	10828	1617888240000	canonical
15004	3NLusySXoLtFRi67W6FGpfqiUJNQzoBVQ4tJhm4C3WKnRo8NqrBU	15001	3NLWxjbwScNWj6hXrYMYH8Wesv5vgCz9MsNcWsS6rUqWxAonLxYU	369	1186	239	6301	11068	jxhRAszaXJz5qLb2RFZMznqdhTWDqZYDPLhYEkQYJxbrcSrQK1f	7643	10828	10828	1617888240000	orphaned
15006	3NKqJ4xugCGtXLZmkcRpaA8nnNhJtUveUs1h1FkdfzrH7MzSnk86	15003	3NKHVjQQdfjxT72VAAe6Pr9ov9MCZLzMYoVScwmEPdRx1CmMjWuP	448	1059	239	6301	11070	jx6twRLtqrKyCc5S4o6LBnTNSZV8zcQrXeMoACc4wR6x1UfhgPv	7644	10830	10830	1617888600000	canonical
15033	3NL6ottfeBnqyapaUsWJpjT1KxkniKbubTKwywSXp9nHawj56RCF	15008	3NLgSv2mGnQMA3JAqGs9v444fLp8xLopmg4E479bDFZtkgeK1KW7	1593	1100	239	6301	11095	jwmw15DUwZvK1xBm9VN7hukPaU5Pd4s1Btxcic9t4BxSzdbaREM	7646	10850	10850	1617892200000	orphaned
15011	3NKT6bjvnNokUC9oac2BZDvLZ7fSyG7djqi8noRduhsArW64MYZx	15009	3NLEEVf5CsjCjxXyiDCfWksb5WRgzEFVa3H1xUL4NX4eDUPsJyh1	1403	824	239	6301	11075	jww9xYnZDA1hLHAseVtG48P5sd17rmBAQjxbsyTuUuzTdiCGKzC	7647	10833	10833	1617889140000	canonical
15014	3NLV8eZCHRtMPkcKaQHHPk8EiCUwHVk5RFhm6MWeERAPDoMmA7c1	15012	3NLSSdt19MyffgkK9FrdYZyndDFZQYreLDijBhTJY5sKGtueaP2T	1406	1393	239	6301	11078	jxesPhTcDv9RXjzvhzCuCvfNik8jzXsKRXD8QMUjeAT7poXkeGF	7649	10835	10835	1617889500000	canonical
15013	3NLKhSyt7gRdgY98rrdBZGuugqSoievgeC7W8VbagGMUuJcbPU8b	15012	3NLSSdt19MyffgkK9FrdYZyndDFZQYreLDijBhTJY5sKGtueaP2T	700	832	239	6301	11077	jwybVdDuDeLftmX9EJ2CVE8yvFPKz8Hy9F4vXGFXHtDu1y4QuC3	7649	10835	10835	1617889500000	orphaned
15016	3NKvHDjEDMeePVM9SFZrcnH5ZtxKsV8sykF1BYDyMwpCudtRitLf	15015	3NLaYgNzCQpPDAnrCibaw6tMCYXZNuScpQvmHSvMo4M3b8Bqoxkk	43	1310	239	6301	11080	jwscTDSAik55rx3gRfGZ9PyMzybRky2f4bSHr6dpXuRsDstaPVp	7651	10838	10838	1617890040000	canonical
15019	3NLgKHz2Vo3a8qsh3qWtX2Vt1ozZdHCV8sqgztq73HqvHR6DE6Ey	15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	1527	1047	239	6301	11082	jwM8MEWS9C51BPt93Sr5LiLaWvcpV8qg1kbS3fYbYhNUcMmyYSz	7653	10840	10840	1617890400000	canonical
15018	3NKqkN1j24QnHWS6FHND2RF4okiXGFAbFivZHh93fmSLcjdCcXGz	15017	3NL47V1cLdT5En6qDS7pxZ7L2e1Ei2MT5Xj84zsdRawkm8tka2D9	1527	1047	239	6301	11082	jwSHAbzbGawa1f1jNqrouBgsMDpaKb7q62XCWTqQh4qZ2z8uAog	7653	10840	10840	1617890400000	orphaned
15021	3NKf2FyCLCH4WJTVay8feje14rtrBxxEZ4aTXmfhJGAc6cYLyea8	15019	3NLgKHz2Vo3a8qsh3qWtX2Vt1ozZdHCV8sqgztq73HqvHR6DE6Ey	1405	849	239	6301	11083	jxrhcHUe2JMaJXAYRupPAzoWVJY84ucPQA3EM4hthwwwb6mT9Y1	7654	10841	10841	1617890580000	orphaned
15024	3NLXdPHELKeS9wh4Rv77beWVjEMRnNQBNbpfi7uypo6so1fqE5pZ	15022	3NLv5VRADeYNTPea4sPJ3oFiUbMB81URWUsWSCoApcsbpTpEEFgE	1633	1144	239	6301	11086	jxwRq7L25ckpZLToQtADLE1e7MT6ptPxPb3MfrRxFSgjmyurf5e	7655	10845	10845	1617891300000	orphaned
15026	3NKe32vasnuzPsNkfjE33b3BH6d9TFmz6gRcp1tba5MSMJL64QXT	15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	1403	785	239	6301	11088	jw9Fx9QyZt2w1tDrWL6MwYogeXsXkrnN2XUYgQ59XaSdwLUkJr7	7657	10847	10847	1617891660000	orphaned
15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	15032	3NLBmV7Q2iYHK9JspSY4yMKASryHLjS2RtnnBeNGBnfa6qgPikoH	1448	1185	239	6301	11096	jxup76W4ABXof33mDppDQFm5yU8BYzuFm2mu5pEzKmSMwY8abGq	7661	10852	10852	1617892560000	canonical
15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1445	1044	239	6301	11098	jxXiVGbCBMF7rWZySq1oqc6JosjFmTMmWxLEJDXNAQKoAwwCoda	7662	10853	10853	1617892740000	canonical
15036	3NKAdPJBoJhVPwdgbKjfkuhLEG98r4BXkDyjYpXPDgsHYixfyYsf	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1527	1293	239	6301	11097	jxZf8CuCYQ5mHWGyvy9gZJnJoufz9Jienw1RwvRKmVRLMNAgCsB	7662	10853	10853	1617892740000	orphaned
15040	3NLUpXfoRd9jwykSg2bmBg1kBUJaR4gjUNNTXZgoeBnvR7UFTuTX	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1455	1332	239	6301	11099	jwgcB2wny8YnyRRMmdLn1ocnZzw5FV5nkcZ3HRsjkh8gDSKvjih	7663	10854	10854	1617892920000	canonical
15043	3NK6M7BguF2A2yAJKiVi9qdf815zAABacYExJ99P1QWqAQACQACU	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1631	794	239	6301	11102	jxpx6zkU1cCWDd8iXH2TwkK9D8uPwoiQGwXHGBw2H7NihEZ255N	7663	10854	10854	1617892920000	orphaned
15044	3NLRuQszF8xe2BtCVWKAPLCyw3SVaHcys88ZMvxQk62K98ck9jgJ	15040	3NLUpXfoRd9jwykSg2bmBg1kBUJaR4gjUNNTXZgoeBnvR7UFTuTX	1406	1393	240	6301	11103	jw8fvb6rMutwCHinn3pUQDkbsk9EGEMJjUuZEoTz2VbNAmK8M4M	7664	10855	10855	1617893100000	orphaned
21017	3NLtQPu4fVFgzZFwaXHD7WwRdnSaVWtHLNxQFQRNAbjXaJsmGKEv	20695	3NLpwDXu4BZBFh7CZ2EuZVcvbNAmpynn9xfpSvYcv3Fn7JMwjwqv	1654	1340	370	12463	13288	jxtSqsVc8WcCgMbKm85VSuGvbF68R2MAXpLJkpKkzJvGTbKztwy	10326	14882	14882	1618617960000	orphaned
15023	3NKQdVBroQBTdtJa3Heqs8JrMYdJsrfWcPsxTdiUDMDAMWk6Kwex	15022	3NLv5VRADeYNTPea4sPJ3oFiUbMB81URWUsWSCoApcsbpTpEEFgE	1581	778	239	6301	11085	jw9SHTjuo8Jtk91s8q3k9taRuF9eztui2LX6DKDt8Y2GTkCjhg1	7655	10845	10845	1617891300000	canonical
15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	15023	3NKQdVBroQBTdtJa3Heqs8JrMYdJsrfWcPsxTdiUDMDAMWk6Kwex	1477	1350	239	6301	11087	jwXsWM6y9W51aPurQoqcFBGxUgQVCbWYimyfNm6ERU9nBkn8E9j	7656	10846	10846	1617891480000	canonical
15028	3NLrz9mzKeiC9MqFVpf85nZXQZwpges2jBjysP56NE8uJ9HNMVLF	15025	3NKCmoiCFfRjXX4RY1U1Pv7d8Zb3xNKjvZtiUFyDRdN6RFBEZgMF	1407	1395	239	6301	11090	jwHwWQz7zP4Xz1SFgEgcgy922bV7VVBMWCHv2yvCyJJU2KFZF8m	7657	10847	10847	1617891660000	canonical
15030	3NK8s9Ag5RYHCVNjWVWLhBDjeWG6phCQoHxhc4xCvwi7g27kTaD1	15029	3NLtiE1BgMhseV2QfcF735yp5uFhRevMG85BSV2oSAVJC98SoDDM	369	1312	239	6301	11092	jwC8csUePcF1WCappaLGyfADjNhQDmdqnNgRmPPhhGbVNKdgAEy	7659	10849	10849	1617892020000	canonical
15032	3NLBmV7Q2iYHK9JspSY4yMKASryHLjS2RtnnBeNGBnfa6qgPikoH	15030	3NK8s9Ag5RYHCVNjWVWLhBDjeWG6phCQoHxhc4xCvwi7g27kTaD1	1406	1393	239	6301	11094	jwvCJSPDU28J6VAtrbdGL3meg3cxbS7ztDcSU8sT7sEbcJHRYYm	7660	10850	10850	1617892200000	canonical
15038	3NLerUqr26PxXRJKmC1ZTvNu8sLKrPEb7PdDLoQxn1QZ1JNM8epF	15035	3NLQXhiVwCNbFWq765eFp8oC7SdZjoTqk4MKnbt4ENxeEHhvqhCu	1527	1293	239	6301	11097	jxSFad2GhaHMDsyW1AZgRPNoqkHsZkQ5atcAAZqHSYhmTXMyWVK	7662	10853	10853	1617892740000	orphaned
15042	3NKGp8zh1H8wFFScU4KcRx2zDFWPbR6tCZWZTX2ebxErrX3chQm1	15039	3NKWP72N54BfccQJxFo9cYTgZ2H7zWFnp4THvEgC6pZoDY8t77Et	1407	1395	239	6301	11101	jwKw4Zd2tGwcxx9FxtuaG1hZ8TedMAXTsH4gzzZw13qGw8otxSs	7663	10854	10854	1617892920000	orphaned
15046	3NKfaiBV1XPS6YyKtd1YVgTfBSN9Ym3zb9voAwbuRuTxLZcZ1xLH	15045	3NLUsFa8xpf9JCRY5UpfRS2fBQLZCXj9wZsMzAUMu6EXiW38dKSc	43	1184	240	6301	11105	jwQ21YcAb6ivG611q3D186MiWWdtnb7bq2FfZivUgZBuXQ9UQov	7665	10856	10856	1617893280000	canonical
15050	3NKcipdzyoFVArgTcbsaVekRuxDuNiuyejYh4WQm7fZ66SEFLqQp	15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	1457	1145	240	6301	11109	jwC8nyA8MKS7CQnMjbxVxTHAgCvWn3gJevUR7sqfAzB4Va5TLsR	7667	10858	10858	1617893640000	canonical
15051	3NLUGKtCKAHUZpKxcmpYH9ttjxL4MrTFtqyugcZGJzzEZtcYBFxB	15049	3NLQcsTQszXyF3ag2c13wYE1eTPLnrVXQGve6JyS1okvSsWYkRB7	1581	777	240	6301	11110	jwP8EYnsjhc7jwT19MNweoEiwcuoJTFN3LhXXbrn7wd74hn4eFw	7667	10858	10858	1617893640000	orphaned
15055	3NLXx5TBTbScXHP5yXuhzZu3r1TdkSbzbYTkZnsPSjfkJEdsQm2g	15050	3NKcipdzyoFVArgTcbsaVekRuxDuNiuyejYh4WQm7fZ66SEFLqQp	1647	1176	240	6301	11114	jwNR5SmBwED3NyfjJuwp9s8tjRVDXE9RJpeG6aCN6Bm4shpcVp9	7668	10859	10859	1617893820000	canonical
15061	3NLhu5knMwXBhkAvRqzhov8iMphRJKhNjCR7Jy2CDdptHJY7kdLf	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1527	182	240	6301	11119	jxoYZT8EVjj9iP18EYD1Zy88BmE7hEWfbiz6WpVFpBpYvD5VXgB	7671	10865	10865	1617894900000	canonical
15060	3NK5GgTyoDcGemsGQ7oUE4HQ9By2c8hs1ztBqUneb7p6R56XwVsi	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1527	182	240	6301	11119	jwn6YWuSFHSQhzaGbEPTMB8tmfGeEAfm2dYmpAPGATC6HEWTXQJ	7671	10865	10865	1617894900000	orphaned
15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	15066	3NLQ3s4v6bwWVCE2t57uCSxNAerWYduHXX2DmnAS6CAcQQ2wgDSn	1589	1286	240	6301	11124	jxc3UibsSSRh1pR46YcYXnSJmoTmtUVUBamk98NjaSjJQPHpMBN	7673	10867	10867	1617895260000	canonical
15069	3NK3NhDFRga9f2wZeRCEP8Zwmpyb98GeoVAJuWi6PeLGa4gpmNBJ	15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	1490	1274	240	6301	11126	jwBkHY2yZJcSLn9TSK1JHxQtNq7tQXPp7WzfGE2StbdVdmj8qqM	7674	10868	10868	1617895440000	orphaned
15074	3NLtkxWD5U6LExhyHLx6FMaW29FY2JctxCoXcBQrbqrVikzCRsKg	15073	3NLfs4JWsfHGrASY1m4VBhr1u1TSRBaE4B8Uxu2eQUgjLpyCe57c	1542	1304	240	6301	11131	jwSmYydjwpz3UVy7o2Ws1zy4gLycfhY1uncEzX3L1kCLiADqjea	7677	10871	10871	1617895980000	canonical
15077	3NL4ZuKMZHKGmvQv6aBgFfqADrw27TyEEhvguKs3aQSrZax3eg25	15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	1600	1006	240	6301	11134	jx7kFRyPbQKsN5v79ki4GvJnFGAWEwsWBHxozMkaU1gi3yY3yiK	7680	10876	10876	1617896880000	orphaned
15085	3NKuHpvRcKUfYdsU2GFJbSHs12KbdLCsAvXoiW8F2wSX3C46JwnL	15084	3NLZGaVNChBbXSwT971duN5PJ1qyqsmWxyr44Rjsp6g6JohdFqKR	1501	1234	240	6301	11142	jxLyCqxikJ7ZcZo5c1ZNt1fzVsF8rYaecdyVfDirQM5PjRWU4ja	7685	10883	10883	1617898140000	canonical
15092	3NKVQPmwvfgMnSKfghio1uKY6cmGUuoL1U8mwFFyhWge4anz3zju	15091	3NLrSP6kkMSH8TCdNQKTWDWGGdkCmZ5QF2KCREzdvowfqdnD9RJS	1407	1395	240	6301	11149	jxcdk5Q7a5FjaacRrrVBtqyUZASkLce6GDhexzAz8a3hpK8WQsZ	7690	10888	10888	1617899040000	orphaned
15095	3NKcmcDDiDUNFoiqo6xAwSszkG3quTnbU6VmVZzBXAtDkP5KcXNr	15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	1654	1340	240	6301	11152	jwH3aL7tN74DfRdURJzPQDtfzgUt96WuRzkjNZ3qcbr7pTYv8ZR	7691	10889	10889	1617899220000	orphaned
15099	3NKMAgBWvFQXEX8EDod9HRWxempzyeFr1PDQB2LRaaGgWcwtmR6s	15098	3NKjQyPxjY6pepHUjemQvG6fDWF3FgJhjtibHcnqZfguem8B7kjy	1455	1206	240	6301	11156	jxNFYcJXoNMECcue8PXYmZkvVRcPtXraaGZFb2bGCVDNSYmtqse	7694	10892	10892	1617899760000	orphaned
15104	3NLXMb3UA9iRMfPDHZXm4gu2pTMCh3BF1dzkEBKqVFijA6nAAhhy	15103	3NLGVHACtcPNjqgbwxnRv4Z31YuoTwbVid7hi17cMQeKMe3K4cQA	1402	852	240	6301	11161	jxKKpEcJacu8EAzu49MaADCLTMSiDWYouTpo99jgW4FppMfeVa4	7696	10895	10895	1617900300000	canonical
15113	3NLv6cKL9S9AUAYCbkPUZQYdn1vf7kTTQ6zBpeDSw5GvZr6mAzrd	15111	3NLcB2y7YSzd9g5NfgE6YBBA2gmc6PJYe4XdrobhJxJASX3ZihQa	1624	1334	241	6301	11169	jwqe8osHEXpYdB91cSVdHtVaKWUefqkR7GypyzKLEVr23hJip9r	7701	10901	10901	1617901380000	canonical
15118	3NLGFDEooVxbxV1RRhqFgjqGkofzoCR1iLrdovSFAEUMpzX6Esvv	15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	1477	1350	241	6301	11174	jx8dhiUGcDYUhFHtvmcmB5AbhzK1UjirqzhS9dyZr9Wf78SYH6p	7706	10906	10906	1617902280000	canonical
15123	3NKCNfR2d6wiDMfavbbpCGxqUDpuoZKHT9utzuidDsRjdAJFGSkJ	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1527	927	241	6301	11178	jwW1eu1pssYxyarET4gHhnhL5jWb5Ley9Y6a3jmuWrTEWV3WWn1	7708	10908	10908	1617902640000	orphaned
15128	3NKDfU8FpZHV9KjXjCMoDHVHp1JxG9AbyrEGga5FhrjVgBvp518h	15126	3NLQhTvSS3xJpjR36JqPe1ayfAAbJNqTQ3eKFdmnsCnWTX7AEzEj	1631	794	241	6301	11182	jwpzQX9pcdFGLYSFVcWZBEffaK5mhpsitZyk8okv8uQYQV3Q9gR	7710	10911	10911	1617903180000	canonical
15132	3NKzbqu9STcrVARBqNnqm3ZY6dwXsgaDzwLVZpJxq2BTrg5zo1HP	15131	3NKpVBwWpYnQPj7YCGNc4LkY5zta8dw8zKTHGgXeWU1VncJEL34h	1649	1017	241	6301	11186	jxb92sEZiJV5pvzJuoN5UCqriE5g3yQ6ZmAJQ3ExpoyW3TGmGyT	7713	10916	10916	1617904080000	canonical
15135	3NLFCHP1VX7KGVuC8kvDWowGcyuHcZyaXfwTLBS9XbwYP18QJmMH	15133	3NKoDJB1Dn9V1DdDZeRpmj3z2XjTKE6Jxxh11gBFy3374EFLDNxy	1467	1376	241	6301	11189	jwCqHe3JFZ9D8WsENhivrfzVKSVoCqwdeB5Q3Zo7KWNfoCGzncQ	7715	10919	10919	1617904620000	orphaned
15141	3NKYRhE455tyzxmqUoDPM4YAqAttpwNmZKFUKaC2m6t4EqAuPKaS	15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	1542	1304	241	6301	11195	jxUWs1oxP66GUPQYeighdRNFSGxQu7hjFy5FJPMoHCkK6USWfs3	7719	10923	10923	1617905340000	canonical
20516	3NLSg9bcfdv5HyL7m6qLkt5fapjnS1FhrC3yYktbu9xVNBAktPf8	20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	1406	1393	370	12463	12830	jxXMrfDGRJ3dDkt6C2MwHVS7vPydfLYsGz8ap9YgJ425KP6ABdP	10328	14567	14567	1618561260000	orphaned
15054	3NKUyDaQCV73p88ySPZxbFyroc8WxXRvNHPrVHo8pPc6ARj1AdQa	14995	3NK8JxCJdMYKnsyVzwVM51vdJXihV8isd9c77dPGXJ7xK7uv4UCH	1647	1176	239	6301	11113	jxcfaQqPGzSsFrdZYF58a9RQAA7fTEbMPYWY2kHVKfgAbaYMP6g	7640	10859	10859	1617893820000	orphaned
15057	3NL6soo7HckySQwwp4bkoGY7dsBY7DY3VxjSTYYABuVQiNQfkH4o	15055	3NLXx5TBTbScXHP5yXuhzZu3r1TdkSbzbYTkZnsPSjfkJEdsQm2g	1406	1393	240	6301	11116	jxmmobZXjyCSSZcFkRAqN7HxYZyH9qgiy1B64nd3fo1eWEHw2n8	7669	10861	10861	1617894180000	orphaned
15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	15056	3NLsvMka42BDXn1G4SF9frUWokwKSTHmJDZy9QxrScwq2SZJe3jB	1444	207	240	6301	11118	jxLUQ2q1MDMDkvQK1PCEJsn6eyLBtASVYWzXTjm5pzDAoaqNN7L	7670	10862	10862	1617894360000	canonical
15063	3NLv11odijAh9YqPyBYy6bWbgMqwEj9ji52niG3k7u3sVRkTaq2W	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	632	1382	240	6301	11121	jwSVb6jgzaWUbk9Yo7zZmn42xstiurrfoL68yw7H6PkbxkRGTs6	7671	10865	10865	1617894900000	orphaned
15066	3NLQ3s4v6bwWVCE2t57uCSxNAerWYduHXX2DmnAS6CAcQQ2wgDSn	15061	3NLhu5knMwXBhkAvRqzhov8iMphRJKhNjCR7Jy2CDdptHJY7kdLf	298	1308	240	6301	11123	jwcGBNBiZKBjPxrZecQZCQEJx4Xo1Ksut3qYfEm1EhWDVGCvsjK	7672	10866	10866	1617895080000	canonical
15070	3NLt6ePLt1i5rpmcZH8vAUSLxtVy6Mt9Q2HtrDLUgcvS3nsKiCkG	15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	1642	1121	240	6301	11127	jwEfMczUobyw5jDgTotkCugiYfix6fKsjPBZK2wLZQ3QpKE1h39	7674	10868	10868	1617895440000	canonical
15071	3NKzntTZdZGebFkE1kvH5RzbafDyC8J3gXCbNA6LMxVFTGjXvRzf	15067	3NLYfTBreTHBNp7o294zZUer6yTV59k5pMqsB3JmUCugjWBZhdJX	1489	1380	240	6301	11128	jw7qyBX6w9eg1cJhdYBrM3BqnBs2ctFCd15kCDCsYFE4YZ88xQY	7674	10868	10868	1617895440000	orphaned
15073	3NLfs4JWsfHGrASY1m4VBhr1u1TSRBaE4B8Uxu2eQUgjLpyCe57c	15072	3NLammVhcnFZUnQDmskN9Dr9QdpVpuftWHZ2ak2uMg83DYNAPcyF	1631	794	240	6301	11130	jxyjmxBCTfpeshxz8fYX7Y4ZyMHcWXTMh5jAJTQdGG6LczK39se	7676	10870	10870	1617895800000	canonical
15075	3NLi1gLdwgKFMKwSencx3mtBFbgJFe2fHq3v8nCTQGTwGiwrNdGt	15074	3NLtkxWD5U6LExhyHLx6FMaW29FY2JctxCoXcBQrbqrVikzCRsKg	1426	1364	240	6301	11132	jw8oZtUKVwia4pRibpVz9YXt9q9c6WvpMGCkrE7MaLAr7ww1aFX	7678	10872	10872	1617896160000	canonical
15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	15075	3NLi1gLdwgKFMKwSencx3mtBFbgJFe2fHq3v8nCTQGTwGiwrNdGt	1507	1280	240	6301	11133	jwr32yrrLTmHtWFpHVc1xuqVWHA7Byb4hyyCNE3VNohSEYmJbP8	7679	10873	10873	1617896340000	canonical
15079	3NKUTUb8JqYMMZuzuAniJnes4rgWUFrHj7KFiuPh4qTPsXrLxkM9	15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	1581	778	240	6301	11136	jx3VV6iap7Ak2RT6mMc5538ixB83TQpkHXk89maaerFPtjy6A64	7680	10876	10876	1617896880000	canonical
15082	3NLVBWkq55DsHQp2iwQHghijsb5QFMZgSrKrFDPhCWBKG7NLcmZ3	15080	3NLXsGhfTRwnhsYGTEoZoaKDS84bxatk8dwg1qdbsAzi3Gq9cdHg	1407	1395	240	6301	11139	jw8uPi4i5ow7GoJ1A6kVR5e35pHoMwN62qxb2FEJChh422noKZY	7682	10880	10880	1617897600000	canonical
15081	3NK35RbhMWe3U1rNhLzKYCQWx2Rywuj8siTUfT1VmYPhXrBN2CaB	15080	3NLXsGhfTRwnhsYGTEoZoaKDS84bxatk8dwg1qdbsAzi3Gq9cdHg	152	1330	240	6301	11138	jxZZ81QxeHny1NRV8bWSVKY5BGukMsodrup7aB87871FQfezS4t	7682	10880	10880	1617897600000	orphaned
15084	3NLZGaVNChBbXSwT971duN5PJ1qyqsmWxyr44Rjsp6g6JohdFqKR	15083	3NLW38otQEwnvzBDP99UdqCdv2ABJt5QL66aFGXJKK5hEeappsBr	1643	1299	240	6301	11141	jxKXZ2qPj6HwTCowMgFzE3tsriZkq2BYAWuJg78e1xz7LCjQkWN	7684	10882	10882	1617897960000	canonical
15086	3NLXGMCwBbsXHYM3VvwkzobVWyxFXU4QP4rXreQSU2dse3UDiQPy	15085	3NKuHpvRcKUfYdsU2GFJbSHs12KbdLCsAvXoiW8F2wSX3C46JwnL	1585	1120	240	6301	11143	jxLZ3Ejc3ThHNCHLETfpNWjfUy6fXgX94eRzG3KDdgjhFq7opVk	7686	10884	10884	1617898320000	canonical
15087	3NLRNmRScttNzeX4mjK3h6gLeF5mm9PWdta8EnL33oivp1ukSDrE	15085	3NKuHpvRcKUfYdsU2GFJbSHs12KbdLCsAvXoiW8F2wSX3C46JwnL	42	1115	240	6301	11144	jwvVQH7AuvbPxKYAQWxbWcYAYbHkQhReU5viSkvaymSox3n8E1X	7686	10884	10884	1617898320000	orphaned
15089	3NKJ6uetgXSY1nXqFxCrkL8ofbc2uTHcjHy8QfSAeSEwDFDjqXqR	15086	3NLXGMCwBbsXHYM3VvwkzobVWyxFXU4QP4rXreQSU2dse3UDiQPy	1406	1393	240	6301	11146	jxP4zNfRJ87uHKYdbZy8nmz9kNe5Syoso43S4BPkzB2m6NiHn3H	7687	10885	10885	1617898500000	canonical
15112	3NL1mY1VvUZMCFt15ZAcYdhBsFtCvzZXsHN4AUe4dhuYbCFsN1fu	15089	3NKJ6uetgXSY1nXqFxCrkL8ofbc2uTHcjHy8QfSAeSEwDFDjqXqR	1624	1334	240	6301	11168	jy2sQZZjs3anMEW5pTUZYK1XT95nXi8YqrnuXf2HugP4tFppZg6	7688	10901	10901	1617901380000	orphaned
15091	3NLrSP6kkMSH8TCdNQKTWDWGGdkCmZ5QF2KCREzdvowfqdnD9RJS	15090	3NKG7e21Gu8TqG9UufG6KPai1zqCQSfDGMAocaVvjaSREsp9PL3r	1500	1297	240	6301	11148	jwAR75ZNXr34iaWQ3W9w5uczchDyMS3EWT6XokbUiKeSP5gTVKD	7689	10887	10887	1617898860000	canonical
15136	3NKWHufVp2CYUssgpUYuUTLX32uLaLyaySDJS5zoi5N9TxFC43SU	15112	3NL1mY1VvUZMCFt15ZAcYdhBsFtCvzZXsHN4AUe4dhuYbCFsN1fu	1624	968	240	6301	11190	jxHJDUgTm3GAT2KVuW9EvxDxXqRe9hKRcSejfoZ1rQ62QvbePoy	7689	10920	10920	1617904800000	orphaned
15094	3NLkf4g3mteyfFWp5q89fhq75ZPNctCwPmfuT5o4jhCNZJ5reFZB	15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	1476	1371	240	6301	11151	jxefB4T42k7RbG8ohWxjEaqhBGrtof9EkyZ5jYokpr21YatxQcu	7691	10889	10889	1617899220000	canonical
15098	3NKjQyPxjY6pepHUjemQvG6fDWF3FgJhjtibHcnqZfguem8B7kjy	15097	3NLLvgs2Po8ap6kbzuo5dEFYXiCNUiHwrrairTR2vHyivWyy35kM	1656	1343	240	6301	11155	jxa37zkwceQYJnqmM6jbgkpjc7MHvm1baYsy8zEoonzHuXUMBaC	7693	10891	10891	1617899580000	canonical
15103	3NLGVHACtcPNjqgbwxnRv4Z31YuoTwbVid7hi17cMQeKMe3K4cQA	15100	3NL6radojmkEqXugSeXJAAtnD5VcRSmBuNUrEshwGaCQ1nMd9SXq	1405	865	240	6301	11160	jwhGFAn9a4GhW1NsxrwZBYLQQBCmrk2EjG3Ao4WvUvN4TpJnnNh	7695	10894	10894	1617900120000	canonical
15106	3NKDVFGZXMF1w8ESMKS7WHDcTYPWKgPJWMFbiuEHPwNnBLEh5qwz	15104	3NLXMb3UA9iRMfPDHZXm4gu2pTMCh3BF1dzkEBKqVFijA6nAAhhy	1599	1287	241	6301	11163	jwwC7mzMhP82fHiNcPEn28V4Y2KQjDj3hvj9SBp2PnW5Bp3XPSn	7697	10897	10897	1617900660000	orphaned
15109	3NKNFR2XMCTNHAWqcgeX1GVrXJnyDiWHqUWWMXBcSfYa81whjcGg	15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	1599	1287	241	6301	11165	jxbvEEoJtLHzZGe7BTbBEkBhNSMgPDWK17MU8n9qVBxR54SjU8k	7698	10897	10897	1617900729619	orphaned
15111	3NLcB2y7YSzd9g5NfgE6YBBA2gmc6PJYe4XdrobhJxJASX3ZihQa	15110	3NLc8qk7HicSr1haYzHsDm4sRWdE7ZsNsk8giPEHpkTPpGK8EfXy	1534	1191	241	6301	11167	jxHytWbFXZVPgxiRMKzBEZQiaDHoiG7LwYzGyHwjkL4img2yWXx	7700	10900	10900	1617901200000	canonical
15114	3NKALLjEDSsEt4v92THMaWhsHEsXYpWkdDTmfaJSDWHrSzKMwTU5	15113	3NLv6cKL9S9AUAYCbkPUZQYdn1vf7kTTQ6zBpeDSw5GvZr6mAzrd	1657	1344	241	6301	11170	jxgRa7zGcrg3VomTTHbBXup5d9vy8iippE4kGaCCBsGXv4bB4hb	7702	10902	10902	1617901560000	canonical
15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	15116	3NLBCTa92ETwSoL32dkog2xoTxgi7wrVLd4ARsnqciRNcj319jeU	1407	1395	241	6301	11173	jxit6h1C7R9K9zH2AKjz4TStuUJCzZ2vTGj7uuSUfT2dyFVnL62	7705	10905	10905	1617902100000	canonical
15125	3NLJj4VHbbACpGDgPqRa1jRUmxFsM8URU9eyJRGuEcpeRFYEyER7	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1481	790	241	6301	11179	jwyzXUVVS9tRT4wU3i8imnZJPfWqB6HXcg7ceyS1jonkQXyeQWf	7708	10908	10908	1617902640000	canonical
20519	3NLKxJbpqUJQpor3MH79PpqajvP7XgZViiDHttCQ8JyGXPQo6d1f	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	470	1309	371	12463	12832	jwVjwsHrAdkMxpiFArunDrpyW6MmC39UuKRqED5QNNDSJa7gGTn	10329	14569	14569	1618561620000	orphaned
15058	3NKFcGwDeozYSEP21jHziACfA6YZGPf9WeJ6mS1de5q4hhRzo6tB	15056	3NLsvMka42BDXn1G4SF9frUWokwKSTHmJDZy9QxrScwq2SZJe3jB	1619	1149	240	6301	11117	jxcAcBCPTciTa8vL1DrVLwJqK1DgGdmKbVpt6gymnQJPDutYJ4Y	7670	10862	10862	1617894360000	orphaned
15064	3NL5ebPZL4c823C7vi7QFLvC2Na6NciKf6ZCjfBoeGwfaaHRSKJz	15059	3NLiAcT3dBMxrxPQ6yWjxin7jjGW6vaEEGw2gt5gRVeme5t1iYzp	1527	182	240	6301	11119	jwCuQs5GPFsMKMAeaJ5yHE1n39xviyFPvoKE4z4TKdiewefxAkG	7671	10865	10865	1617894900000	orphaned
15065	3NKiVMz5pMxnWRccdc8RUggP2pBBEy93babBRiqXPH4jPcRBHdsz	15061	3NLhu5knMwXBhkAvRqzhov8iMphRJKhNjCR7Jy2CDdptHJY7kdLf	1403	823	240	6301	11122	jwDGsSbpCD3wg1Axj5gQ33WpJRK8xFYoshCn8nthvTLxnT3Yatn	7672	10866	10866	1617895080000	orphaned
15068	3NLEg4vVM6QSYJWKhjPV5rPTf4WwiUxrW76zZLCATHDRj1ZGDH4n	15066	3NLQ3s4v6bwWVCE2t57uCSxNAerWYduHXX2DmnAS6CAcQQ2wgDSn	633	1384	240	6301	11125	jxdpBrSbcruTjBsYzNSC6sTdwcrYWRg8ovWxWmPL2whF4jjCiNx	7673	10867	10867	1617895260000	orphaned
15072	3NLammVhcnFZUnQDmskN9Dr9QdpVpuftWHZ2ak2uMg83DYNAPcyF	15070	3NLt6ePLt1i5rpmcZH8vAUSLxtVy6Mt9Q2HtrDLUgcvS3nsKiCkG	1402	852	240	6301	11129	jxjgcUnH2ChyqZ9r76XHo54qFhJKSE58cbmBRSEgeamnZGwDDfo	7675	10869	10869	1617895620000	canonical
15078	3NL22Q6twbXJokeeVyboNGWDgC4Nfnvjjiya926xjNqEn75vDr7w	15076	3NLAQ79iZE7A6WvypqFP3ba9n9ZTuGHhvdSjWddG88PRMxkwRBV6	1516	1048	240	6301	11135	jxux1gr4kmx1b4w91LYsevNMzrsNE1V9C4vb3gwAASnbNtFwipx	7680	10876	10876	1617896880000	orphaned
15080	3NLXsGhfTRwnhsYGTEoZoaKDS84bxatk8dwg1qdbsAzi3Gq9cdHg	15079	3NKUTUb8JqYMMZuzuAniJnes4rgWUFrHj7KFiuPh4qTPsXrLxkM9	1467	1376	240	6301	11137	jwCQrGcoBbg6jdDRvjjnAuaKzzyHhrZFMqURfKNpTDBNnpZQW82	7681	10878	10878	1617897240000	canonical
15083	3NLW38otQEwnvzBDP99UdqCdv2ABJt5QL66aFGXJKK5hEeappsBr	15082	3NLVBWkq55DsHQp2iwQHghijsb5QFMZgSrKrFDPhCWBKG7NLcmZ3	1406	1393	240	6301	11140	jwnnj9M5gYyckRHnNW69CeGWFBE29XnDCo6Mj66PY6XMcf1WZMp	7683	10881	10881	1617897780000	canonical
15090	3NKG7e21Gu8TqG9UufG6KPai1zqCQSfDGMAocaVvjaSREsp9PL3r	15089	3NKJ6uetgXSY1nXqFxCrkL8ofbc2uTHcjHy8QfSAeSEwDFDjqXqR	1610	1068	240	6301	11147	jxrbuUznc25FCGX6pw15dNhEkMAuSFUQF8SgiSabycuYyYGUzaZ	7688	10886	10886	1617898680000	canonical
15100	3NL6radojmkEqXugSeXJAAtnD5VcRSmBuNUrEshwGaCQ1nMd9SXq	15098	3NKjQyPxjY6pepHUjemQvG6fDWF3FgJhjtibHcnqZfguem8B7kjy	1406	1393	240	6301	11157	jxnYkJUMiji3RdqymDN27R7DWoBPwggsBWxQKh4UdA6fahdrqpd	7694	10892	10892	1617899760000	canonical
15108	3NLCXQxMegXdjKhiuKNpUKoFZG7uGVnsgrt5iYm9qbNmXgdN3q9x	15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	1599	1287	241	6301	11165	jxbvEEoJtLHzZGe7BTbBEkBhNSMgPDWK17MU8n9qVBxR54SjU8k	7698	10897	10897	1617900660000	canonical
15116	3NLBCTa92ETwSoL32dkog2xoTxgi7wrVLd4ARsnqciRNcj319jeU	15115	3NLB8gPPt5qAkPnBWZUkyKboBMVmm9KxGncdASKZCsu6DT6Dg1ee	1405	867	241	6301	11172	jxGKtLiJuLEbkHaVgsDw7Ku4LU5cVqLzUY88jYNsjbQCP6FwsQ7	7704	10904	10904	1617901920000	canonical
15127	3NKvo2oBVirJt3TvdGFtDtRmu4yCVTb8qqHLMMpzvVmvvoNwZGij	15115	3NLB8gPPt5qAkPnBWZUkyKboBMVmm9KxGncdASKZCsu6DT6Dg1ee	1553	776	241	6301	11181	jx1E7h4vr5GYonBcKQeSMQ8zvfFX21y2CK1XPtXgYzdcDtApi7x	7704	10904	10904	1617901920000	orphaned
15120	3NKCkjxLQwYE5gtncsuurSQNEtZrL9odtmKT2D3MDAhNJPF7f3YE	15117	3NLrzrBZBuxacN8KW3eedTqDBA8sxugtzPgdxttg2Kpna3XeXFTH	1559	1353	241	6301	11176	jxqpPHKnqK7aovXF9Yg7xJmN3UJgwqaTc9qWxhasDsmorxcduNS	7706	10906	10906	1617902280000	orphaned
15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	15118	3NLGFDEooVxbxV1RRhqFgjqGkofzoCR1iLrdovSFAEUMpzX6Esvv	1637	816	241	6301	11177	jwJSmnaCEb6qsgnPueS6PSyhNWnR1k4FYSHWUSgiSDpxnCFm2tw	7707	10907	10907	1617902460000	canonical
15126	3NLQhTvSS3xJpjR36JqPe1ayfAAbJNqTQ3eKFdmnsCnWTX7AEzEj	15125	3NLJj4VHbbACpGDgPqRa1jRUmxFsM8URU9eyJRGuEcpeRFYEyER7	1529	1316	241	6301	11180	jwmHxQ5ypp8Hu7QrnzkJkVHEp7SVjuzDSmDKMTKijAkawmC1Ftf	7709	10910	10910	1617903000000	canonical
15146	3NL6waza7nrf3Y7xmMGWaVHSRfSGutU38y2pxQEnHiUKic1sih6W	15125	3NLJj4VHbbACpGDgPqRa1jRUmxFsM8URU9eyJRGuEcpeRFYEyER7	606	1049	241	6301	11200	jwDrAqFzZCjGpDRmCVA4WJeJdetdxRYbzq7cTTRsii6R8vFz1LX	7709	10924	10924	1617905520000	orphaned
15131	3NKpVBwWpYnQPj7YCGNc4LkY5zta8dw8zKTHGgXeWU1VncJEL34h	15129	3NKZbXe74t7P7K6Ub72ogZnVtxsWe6J9PaRjteU6sxZWNEZwKmvi	1673	1122	241	6301	11185	jwvYd2oenTHYJVESK9zVyjKcktgMqZD6aUxBKKBhKXb4mEnkWio	7712	10915	10915	1617903900000	canonical
15134	3NLfkeUXsQUexmCnjE1JbYoAggTiQDaT17YwpqWRzEK8rrCC1FuG	15133	3NKoDJB1Dn9V1DdDZeRpmj3z2XjTKE6Jxxh11gBFy3374EFLDNxy	1407	1395	241	6301	11188	jxKyiwBphZegwNax3jW7bxhtyab9KLfmD3cdLvu9VzMPFfXkoZ4	7715	10919	10919	1617904620000	canonical
15137	3NLd8hMBfrYhSsQATfAMyHjohTcWGqoJvnF7ahQDQkSjRjCMwxzZ	15134	3NLfkeUXsQUexmCnjE1JbYoAggTiQDaT17YwpqWRzEK8rrCC1FuG	171	1248	241	6301	11191	jxKo4NUmjHMW934HPqU7pbdU3UZ4pedpCaSURVdDpmUU2Thy2Ct	7716	10920	10920	1617904800000	canonical
15144	3NLwfbrDxPyFit1cDcS37PhVrRcZsKA15ueaRp62JrhfXQVfsHKF	15141	3NKYRhE455tyzxmqUoDPM4YAqAttpwNmZKFUKaC2m6t4EqAuPKaS	1522	1322	241	6301	11198	jxL6CEpsEjqp9hTL1aPGnPyNCCpwa7PZVFVKQMZ6DtDZ9TmrTiG	7720	10924	10924	1617905520000	canonical
15147	3NKgvDiVShGDGyEZNJKn63kxGFSsidd5xV8MVr662u5VV5j3hEHN	15144	3NLwfbrDxPyFit1cDcS37PhVrRcZsKA15ueaRp62JrhfXQVfsHKF	1581	778	241	6301	11201	jxRAaoRcmpH8fmw24Pz8LJc8HGu3871xWivSPpNRdgCcTk6LYdo	7721	10927	10927	1617906060000	canonical
15157	3NLZXsZXJGMDokWUx8ds5R9Ych3zXkoJnnvT2CvZyyjVmCNKjwti	15155	3NKbDDAPFnvWn6jDxfaqVWwRFhkGDEtwvErFfRRUjUNts7s8BnsC	1534	1317	242	6301	11209	jxjKZ4SUuj15cm2wiPGtZHKVDrsQTtYxdr9js4AixQury96WweW	7726	10935	10935	1617907500000	canonical
15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	15163	3NKPBWuezV3esSi8t64owjtNjtcqZfPJSSCpsNJoX3gTAuZqUsuS	1577	1327	242	6301	11218	jwGPo8d83Ba3uCXKU67BtnKDREfCG4eijeaXZdyBLgynqvqytmk	7730	10939	10939	1617908220000	canonical
15177	3NL7tsB9LafB1MSERDqsJmnqdsfwaFPHx6tbgdk4BqpcXpuyAQNh	15175	3NKBB1owGFTRkoAG4RAw3SLCwouoBgiwWhEXCLkUhtmLBsQkvfbU	1445	1044	242	6301	11229	jxiCoqg6KGCZGWQnQrULM23Gfy1hJoAtoApAcYrovtWyc1uULfs	7733	10943	10943	1617908940000	orphaned
15179	3NK34W9VZpDTpS3mBuq9AtuZr4SHyL1SnY7aBniokZPyncCP3dyu	15176	3NLmsN15VrcdFX2yo8xTxZqyB5HM5g4uwKR1X8zjCwcNuPQEyjuJ	1607	1348	242	6301	11231	jwrFxquDpSK8e5SutbffXxJd6RKfJTG7dHVDXpV5V3aqM23BNuT	7734	10944	10944	1617909120000	orphaned
15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	1483	1030	242	6301	11234	jxntHSbGd37UZdEeD6ZcLneCzeQtEQrsc1v7DYKrh1S8VjthYey	7736	10948	10948	1617909840000	canonical
15184	3NKrpmh9RxCQV5HD7A9cvVHADbpb2dV6jzuRnVNu7sQ2wkN8JzJ9	15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	1406	1393	242	6301	11236	jy1Zeiyd2kwXmkjiirPfjNcfkEq7R6mTqtpJZHGBB4WtWwb7EpF	7736	10948	10948	1617909840000	orphaned
15192	3NKoTn1rNjL7jUfvMiFmUxzTRnQguv2rAXixeG9tcWEjMndwBkVW	15191	3NLUZJWpZPhPAdxDAGjZAxYK6F2LLe9m6kAgEMDqeQnerbeUCPFi	1407	1395	242	6301	11244	jxmutssaD9xbsPBFbE6jNzmw811bHWZWTppf45FFUeCyMU6xUPx	7741	10955	10955	1617911100000	canonical
20521	3NLpmgwTZ3oQu4McGonx2rqQ4QvuMQkDoetnB3ruop96sVPv6r7h	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	576	989	371	12463	12831	jxwwipdoaFdxGdBMmYoknzE78jcDvXdwWCqJxDDA119TxWVCGMd	10329	14569	14569	1618561620000	orphaned
15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	15091	3NLrSP6kkMSH8TCdNQKTWDWGGdkCmZ5QF2KCREzdvowfqdnD9RJS	1526	290	240	6301	11150	jwLwFHUNpnoQ5FVf3NvPckKodgt6bPgqtNziNLjpZrSZKt2e7GD	7690	10888	10888	1617899040000	canonical
15096	3NKh5AiZT1w8qbbnFKGgZq3K7iq7nQQYeHv4e4xXDUGkTRGeR7Xy	15093	3NLuR95c1YxNofQnWYvohGhqUP3o1B5yJiHWwxyND2sbP8YX7A2y	1463	464	240	6301	11153	jw8CyRJrv5b4s8RvPm5zpxmuH9KeBxhoMN5u4Nnw2nrQs6qWkBn	7691	10889	10889	1617899220000	orphaned
15097	3NLLvgs2Po8ap6kbzuo5dEFYXiCNUiHwrrairTR2vHyivWyy35kM	15094	3NLkf4g3mteyfFWp5q89fhq75ZPNctCwPmfuT5o4jhCNZJ5reFZB	1406	1393	240	6301	11154	jxLSQSLkcxNuDWyb5ZPTSTpAVevR2dn4GKdsLVwH6NvBLZvNx8x	7692	10890	10890	1617899400000	canonical
15161	3NLq9QBYt8upMGp1C1qxb2QqYC3b7HQ6PCPXhy9t4ZfS56w8HkBq	15097	3NLLvgs2Po8ap6kbzuo5dEFYXiCNUiHwrrairTR2vHyivWyy35kM	1602	1123	240	6301	11213	jxZz9QYbS83exM7JXmNQspXJujDKuFhcNm5LtzCPNHj11pKY6xs	7693	10938	10938	1617908040000	orphaned
15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	15104	3NLXMb3UA9iRMfPDHZXm4gu2pTMCh3BF1dzkEBKqVFijA6nAAhhy	1631	793	241	6301	11162	jwq7ALCqJTh6KYhF7vCSxLoSxnTeyNi1G4UExT8ZHq4rzAnvnG4	7697	10896	10896	1617900480000	canonical
15107	3NKPvuBV8jL3YaFLUyL3w4UU3h5r7NKpU6e5K1KoX4azpYM1jQuq	15105	3NKxKjp2mwZJb3uA3Ed1JbP2iQZXJ8cRHTXSfYw4kbKdmJZJFMxu	1652	949	241	6301	11164	jwbyVmsmJq43FDPwJEmYh8DDc5MgwcackKrvDD6xNr1FKRj6682	7698	10897	10897	1617900660000	orphaned
15110	3NLc8qk7HicSr1haYzHsDm4sRWdE7ZsNsk8giPEHpkTPpGK8EfXy	15108	3NLCXQxMegXdjKhiuKNpUKoFZG7uGVnsgrt5iYm9qbNmXgdN3q9x	1405	873	241	6301	11166	jxhXAsL5CxZ4VZz9uSRL3eAuzCyjJdwTtDvmv6ARKzFfeVf7Wwy	7699	10898	10898	1617900840000	canonical
15115	3NLB8gPPt5qAkPnBWZUkyKboBMVmm9KxGncdASKZCsu6DT6Dg1ee	15114	3NKALLjEDSsEt4v92THMaWhsHEsXYpWkdDTmfaJSDWHrSzKMwTU5	1426	1364	241	6301	11171	jwPim5TS7zM2QKexjhZRhDkKYdg1LqSvtCBqzwqTWGCPmCKMEad	7703	10903	10903	1617901740000	canonical
15122	3NLt7JzS8eBLvteaDcLL79TrRgysK3yJMzoCJtb9rsDYvQNDjSQN	15121	3NKqKGgCYiiMV2dkfcYWEL1y4PfGEjbLD12t2aBc9x4EhJpjqY1u	1527	927	241	6301	11178	jxZMSxF4mg5kSJoUMzKkSCqr7skdrhjfJcuxPqt1DemqC2YAXBE	7708	10908	10908	1617902640000	orphaned
15130	3NLmRr8G1jAk5gs9Y3W9R4PBAWoyQqmx5bo25yTbEuakmhuoQxEK	15128	3NKDfU8FpZHV9KjXjCMoDHVHp1JxG9AbyrEGga5FhrjVgBvp518h	1419	814	241	6301	11184	jxYR96Zasp4gmbKVVur3ZMzzntcsZ99QJi5eptj7xaDhSfiHngU	7711	10914	10914	1617903720000	orphaned
15133	3NKoDJB1Dn9V1DdDZeRpmj3z2XjTKE6Jxxh11gBFy3374EFLDNxy	15132	3NKzbqu9STcrVARBqNnqm3ZY6dwXsgaDzwLVZpJxq2BTrg5zo1HP	1627	1385	241	6301	11187	jxPzvre6LXbNnH4kMGyayZZvQE2KCUhsktrPSQF82Pv8tJiUgbp	7714	10917	10917	1617904260000	canonical
15138	3NLTam9hcujem7N6Ms9TfFeJ1QjU9EzDZFnuVh5xn2FaGBRQ6CRh	15137	3NLd8hMBfrYhSsQATfAMyHjohTcWGqoJvnF7ahQDQkSjRjCMwxzZ	1444	1255	241	6301	11192	jwMGF2nkHtMcBq35DERhzbZhaCtNnfhoqsvFJsrR7WEpBRDyAcq	7717	10921	10921	1617904980000	canonical
15139	3NKoukRg3a2KAhmAVa7p2NCGTHzCguupxTU6AufSXmk5xJfbgB5H	15137	3NLd8hMBfrYhSsQATfAMyHjohTcWGqoJvnF7ahQDQkSjRjCMwxzZ	1402	850	241	6301	11193	jxucd8RRTP25QmHf9H1ACuzNaqf86ZdwnykZfBLSpSaFw9u6jjj	7717	10921	10921	1617904980000	orphaned
15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	15138	3NLTam9hcujem7N6Ms9TfFeJ1QjU9EzDZFnuVh5xn2FaGBRQ6CRh	1652	1315	241	6301	11194	jxFAivMEyZPDduti7EUeNTfqngkTGRodhei77BZ7djBELR23hzm	7718	10922	10922	1617905160000	canonical
15142	3NKxnG6pQLRXxWiu7nvYR1ybCdFKq6R9mTXF9RDZCR51bVmJdbP7	15140	3NKbQsAPuVwL5M2vtnSinYymo6PFeff8MJzkR8nKPZU4V7Pquakg	1668	1124	241	6301	11196	jwvm3PNUznHv1ZeM6dRkqpXBp7L1fcRazSVDBgVkhibhwRXRDqA	7719	10923	10923	1617905340000	orphaned
15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	15147	3NKgvDiVShGDGyEZNJKn63kxGFSsidd5xV8MVr662u5VV5j3hEHN	632	1382	241	6301	11202	jxEtRNjwCmQxBiCb2cwLkj2LXEh24DH2x25vfoVWid841zZFVAK	7722	10930	10930	1617906600000	canonical
15150	3NLUrLFWWtmMyV2rwTVRRGX1h6vN8eQxVvb4cXNvEG9VDTrhjPmN	15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	1474	1329	241	6301	11204	jwH8FSiSNo43VGGRg1n8ezjb7iSN9s9BiV6eiKNjhs7AzjjWDpZ	7723	10932	10932	1617906960000	orphaned
15153	3NLBCsDeE2wqaxS2PPhSo2VbktPioafaPCYPthn7y8hvWiuaDzXR	15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	1601	1388	242	6301	11206	jwLhd2ZHAr6mLigJF5MeKhBnSLseeYUJu3dLCRd3XrbVhw7Yh8D	7724	10933	10933	1617907140000	canonical
15152	3NKn9LWw6pjwuQ2wk2nU8SQpJixsVdtFtR9hgXwhtWsANQApT6Sn	15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	1579	1389	242	6301	11205	jwxtu2doYQevUxkKw3e2cY9NfWGQQZjN11HFrRri1RvV4KkogL1	7724	10933	10933	1617907140000	orphaned
15154	3NLoQMLjKWKtoZp6cubGpsJovLNUPbLr1rS89Sng5wBJYzqwkPd5	15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	1601	1388	242	6301	11206	jwa8ZkGf9S5yz5dKgsJFizvxb69pKzPb55N4k2N5b6ZGKRhNKkF	7724	10933	10933	1617907140000	orphaned
15155	3NKbDDAPFnvWn6jDxfaqVWwRFhkGDEtwvErFfRRUjUNts7s8BnsC	15153	3NLBCsDeE2wqaxS2PPhSo2VbktPioafaPCYPthn7y8hvWiuaDzXR	1406	1393	242	6301	11207	jwdqZA7t8JjJQfEajL5DNcdrkCVBtDJ37WyW3DUckpRvpFVgy6A	7725	10934	10934	1617907320000	canonical
15156	3NKMym4DkrbbTwXHyhf69VeYreTPK3JYGaHr45pyvWmfja8vWJnz	15153	3NLBCsDeE2wqaxS2PPhSo2VbktPioafaPCYPthn7y8hvWiuaDzXR	171	1374	242	6301	11208	jw9acYfsiM6Psy4hx81HfM4PWW84ysgVto1qQrD2hCVGULhWPYW	7725	10934	10934	1617907320000	orphaned
15158	3NKd5uzLu6jbKM8S49J8TrNk6HoVfefrbe3kTmBRgs4ti2PNXh4x	15157	3NLZXsZXJGMDokWUx8ds5R9Ych3zXkoJnnvT2CvZyyjVmCNKjwti	1406	1393	242	6301	11210	jwk9nT3kS4BcBe7q4mJuh6DMDK5b618NzyBGRggVQu2akrnRqiv	7727	10936	10936	1617907680000	canonical
15159	3NKCCWjvxDNw4qWaz9WvRBtHWB1CmPStFb3q6ZFg2EYmgg2w9pzz	15157	3NLZXsZXJGMDokWUx8ds5R9Ych3zXkoJnnvT2CvZyyjVmCNKjwti	484	1193	242	6301	11211	jwDyP1is62ZEQWAeu7DVza9x6GJhfrNH3VdoPwzN1wjEfxLQhv4	7727	10936	10936	1617907680000	orphaned
15165	3NL8ErsuE3ViDjupYJSFJSKjsQZkSENqWABfHpDQDYqF16xg93QJ	15163	3NKPBWuezV3esSi8t64owjtNjtcqZfPJSSCpsNJoX3gTAuZqUsuS	1406	1393	242	6301	11217	jwPmGPEVV9npN9zvDfhZYjkxD2SEssRW6Pj4p1351tNJ9TgTsk1	7730	10939	10939	1617908220000	orphaned
15168	3NKweDQbtDLN4aQWdQ2kuBw4BQB6sxPGfWVBbStw5coLp2pvpiHz	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1407	1395	242	6301	11220	jwV8dJmLvshfm7YHoLTXLW6PG9ub8ok2DQBnmvPHc3ihqAJ5Lg9	7731	10941	10941	1617908580000	orphaned
15176	3NLmsN15VrcdFX2yo8xTxZqyB5HM5g4uwKR1X8zjCwcNuPQEyjuJ	15175	3NKBB1owGFTRkoAG4RAw3SLCwouoBgiwWhEXCLkUhtmLBsQkvfbU	448	1179	242	6301	11228	jwaKs1oEfaxNnS572mE2f2FFUvKvpdgsuH5zqXJmnKrabSGFa93	7733	10943	10943	1617908940000	canonical
15178	3NKYXLqcxx9JRCS5uCeSsE75JLmTTQnoKethnP1cZ27HVmZ9ZFvz	15176	3NLmsN15VrcdFX2yo8xTxZqyB5HM5g4uwKR1X8zjCwcNuPQEyjuJ	1587	1357	242	6301	11230	jx8AVhCBwaQSwRxZEXNUGtya1ss4XG4nkGbvXkuRhsRv9KsfH1R	7734	10944	10944	1617909120000	canonical
15183	3NK3Ash6bi1v3RYGN3vJTrT7tQ3KZ98ShrA2WU2VEz7ir71dP4kQ	15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	1560	331	242	6301	11235	jwafPCnyfGtCs39dNwCKctequAUkNkGhxxU2vov1C5ZqBDNcakE	7736	10948	10948	1617909840000	orphaned
20556	3NKVtKpfZq4NyeYf4D9tiGx9msZCAzEzCLcWV56kEXE3WByGmGHJ	20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	684	1106	372	12463	12867	jwCfTN8QBCqqaHaA3mbJiGrC5RWfQctRT55SFQXoGs7zz7229bF	10348	14590	14590	1618565400000	orphaned
15145	3NKvwdJhYASYvVkyN5eXtSurSEFgGRGatAAor62JJ3GzxwiDU75o	15141	3NKYRhE455tyzxmqUoDPM4YAqAttpwNmZKFUKaC2m6t4EqAuPKaS	606	1049	241	6301	11199	jx5rCcHaVMoePNZTA1nnySFvdQb8NfPcWhdWTrcsnKf28NuhtVk	7720	10924	10924	1617905520000	orphaned
15151	3NKX4LsuABsDVtiMGjXeJNdycfDQMZUSEsFaY8zX9yCMM8qNbUt9	15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	1474	1329	241	6301	11204	jxCFSm69gMKMRiKu5VJaaKdR9YmsffvaaTV6kLk5nNDhdbjTGpW	7723	10932	10932	1617906960000	canonical
15149	3NK6NigYLexktbcK55YUj7CUdg5LVRYbrZxC1Ke57yNw4x8XSXqU	15148	3NLybLADYMRM2MtJsueULPDh37PRaJqMZ7yutDcEfhT2yVrZfKKZ	1406	1393	241	6301	11203	jx5eso1T1kcN4QS11BqTKk8if7D6b8GwtnUNRwK55m8JqiXyhXN	7723	10932	10932	1617906960000	orphaned
15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	15158	3NKd5uzLu6jbKM8S49J8TrNk6HoVfefrbe3kTmBRgs4ti2PNXh4x	1406	1393	242	6301	11212	jxuXrfjURYSvfJYD4xpJMqupjY2foDUeu9PNHsyZhpJFmro1beY	7728	10937	10937	1617907860000	canonical
15162	3NLHJGKt42FRDShRzKTgUib4dxBa57ozH4AT7nGbb63BJxLYtCHJ	15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	1602	1123	242	6301	11214	jwoExKAukVVBCrddetxw3JaxhDJsdkAucSc2kPK58z59vi1VBBP	7729	10938	10938	1617908040000	orphaned
15173	3NKMajBL9v4gt8ADy7kJxT8b3B7BAVYi2mwDygz4N3AM5hGws4Gu	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	632	1382	242	6301	11225	jxqgpxVPvnccaLxWG3PBHq4WHE1wfFFKL5UYEPe6ApGCkpqZ56T	7731	10941	10941	1617908580000	canonical
15167	3NK4KvdJpy8ZzfYU8grUpsqDrNanapjvJ8HFFoi6AtiCWUSnmeUm	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1455	1086	242	6301	11219	jwbfxLwZTvYPyf3duS5QJ5CKX4DBdJvVLs8V4WXtR66awTyjT1D	7731	10941	10941	1617908580000	orphaned
15170	3NKBcSPuYLsVL5HmSrRHDdWFK4ry2EMSd668Sx3tZrgkwmCJTQ75	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1610	1314	242	6301	11222	jwdWkd8qUdc8D6Epyx4y3wV3Nm3sS7pGKVaxXibwPuDJGFHSZ9p	7731	10941	10941	1617908580000	orphaned
15175	3NKBB1owGFTRkoAG4RAw3SLCwouoBgiwWhEXCLkUhtmLBsQkvfbU	15173	3NKMajBL9v4gt8ADy7kJxT8b3B7BAVYi2mwDygz4N3AM5hGws4Gu	1611	1341	242	6301	11227	jxXzLrc2w6jB4ekhuBtb2QqR55p9tUVijghLXFeUYYHNDN7vP7G	7732	10942	10942	1617908760000	canonical
15193	3NLNLMPe7ZJPYtpucd75rbYf3fMK3DDAyknFCdJ3Tjm2iuoR7gVa	15192	3NKoTn1rNjL7jUfvMiFmUxzTRnQguv2rAXixeG9tcWEjMndwBkVW	369	1186	242	6301	11245	jwP5apmeJEqocZeqmLnbYXkXjfA4NGaBYbFhybookvfy7G3Pbqr	7742	10956	10956	1617911280000	canonical
15200	3NLufYuYow9K6ymPHJpFKBX321RnBVUZk2Pwp4QrE66tAWgP8FwY	15198	3NLxbRSZQdvBDukWQzGnGVqnt4a2SnKorjz2zo69WdC4Fa3423Sc	1445	1290	242	6301	11252	jw9tchaxJCVyfoBMaQsMXoBPkjfsytvYWbUsZX39WNQkZczTiAy	7745	10959	10959	1617911820000	canonical
15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	15200	3NLufYuYow9K6ymPHJpFKBX321RnBVUZk2Pwp4QrE66tAWgP8FwY	44	1325	242	6301	11254	jwq1TpjFMuvYZSQ6dw7kHA57Y1VvpqJYX4M87DgykjqF55CoirL	7746	10960	10960	1617912000000	canonical
15209	3NL5AmpCmcwq3iBULGSvDvXvXXyx9xRBPrWrajBayMEPVq6i2vk8	15206	3NKm3vm74YupNn6vViU6hxTBhwX7sf864oteTT41Fc6Fy31bgMKB	1471	1140	242	6301	11260	jxoMfpoLLFBJRhHwCU5ntBxxUqSppw27xDAFR2m1o8SHnPJEzHd	7748	10963	10963	1617912540000	canonical
15216	3NLQZNHLoAov3xDYpe8WQFX6ZiG9kGyB1T8YGfrH92RYqJJtcbvT	15213	3NLRJsjr7Adnvk6XHQoZewRfydh1Q8cjyiTogiuANKfVaRcBnsAw	1406	1393	243	6301	11267	jx98ZjWetbFjQDEdd9BiREGEMAznAdqEowRUXKzv25fTkd34wwv	7752	10967	10967	1617913260000	orphaned
15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	1581	778	243	6301	11276	jxTeCn28oVW5JuhCcxWWpRdDqXj8QteR6ekeHuznwZFrCtgwMBd	7756	10973	10973	1617914340000	canonical
15225	3NKcHqtxyUmdQ8s99hiisHDFfnrwJ6U3CnGs8bhFRjN8kA48KLz1	15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	1406	1393	243	6301	11274	jx5isk3duuYdzBCVzGxbhC1Qj9rHpzrG3e6XxbrJjsEPkV19kpY	7756	10973	10973	1617914340000	orphaned
15229	3NKv9vF2qDs9s7VynXqVZCrKgKSDHRGnJqL5rzinbCtVoy4yqiSh	15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	1609	967	243	6301	11278	jxnLFaMt2DJj7jsdJjfWN68CY6LCq1rWnzmrqXtYRQKSRYKGaid	7757	10974	10974	1617914520000	orphaned
15236	3NLDoNzYb6km9wCYTwGX3n3ozc8X7Acv3Lx6KCdHs3jGpVNuzYaM	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1508	1141	243	6301	11285	jxaxqaWeAJNzF5FmntrqK4p93ULHpuvLtYohSxGYD6TSoZ5TqhR	7760	10977	10977	1617915060000	canonical
15238	3NLE8GW5Zx19EPGmu7zvKss3xVuM152WwpXYP5L2F8xmK8xxkJM5	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1536	947	243	6301	11287	jwiqMNbFRdkdZx1CiXRbYFUFJ2S6vXZLVufhZoZEtZELPNANXzQ	7760	10977	10977	1617915060000	orphaned
15241	3NLgqZTbg82suQcv2EFJww5JtRGGXoVoZc2eoJ33ttK9Hg2wxrdz	15240	3NKjr32HD9UVfHHmoNDFL8WBy73uT3qUbd5zWT2niBxFLSwZAn7m	1673	1368	243	6301	11290	jx1JaLTn4LY3KqUBDD4mFC4zzqcKw7aACEHyF9QSjSCxKRf4FZb	7763	10982	10982	1617915960000	canonical
15247	3NLvf3aAMkx2zoo837bXGCLpUUycvzj7j61RwTABUZ5MAu6gvFik	15246	3NLT8ahCSoEa3eaKXfmCdAjSsBdqGw4phEbmFxPxV94oAM1y68Si	1403	824	243	6301	11296	jw9DtYpdmjX3JQKzRfh5Du5S88m7ttVNzVBwaNePfGeV9Z8nDUp	7768	10990	10990	1617917400000	orphaned
15252	3NK8fL16G3cGXdTfG97k83cDxYLSdhHKxtDDUeKrRANDvG3cNvoT	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	1589	1286	243	6301	11300	jxSdi2yWjyYaRMveuNWtbR4v1KkTnzk2ZrQK4XZG6kd9k17g19J	7771	10994	10994	1617918120000	orphaned
15254	3NKC4nytfW9SfjXQw54iKR6tUk6vPkSCjc83b8cVo4hh9duYGfCk	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	43	1064	243	6301	11302	jxTuPvCsJfBqjEXxHbXDDBuLsXKbRuw49nRnH9axbpdGvqKG4Bx	7771	10994	10994	1617918120000	orphaned
15257	3NKkXJ5ZfLYLSWMwtNAKF3qvgtm2FWzdGr5jnkDzbycQxbkoPsSA	15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	684	1106	243	6301	11304	jxe9naWE9SYKGXZxEXHjryfjFNqwfZwxjs6ZMcQ3jSNTW6xFQ91	7772	10998	10998	1617918840000	orphaned
15264	3NKuGbMUHc5N8aFmEUVWuVR9rLKw9ZHbYWeXhLXEorJtk2A5KWcS	15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	1483	1150	244	6301	11310	jx1mK8CytSGjYeEWFH15gHi9hZcVEaMA3D68HaHDfnHysz6ToSG	7776	11002	11002	1617919560000	orphaned
15269	3NKfHaTR4wYNuLksATbCc3hvvdiJVjNrr8aCBnDTTUPPaLpzcy7f	15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	1407	1395	244	6301	11315	jx3UPqnifKXa6RdHyqfnacX78GbJAjrboMZTgCrqhgSCmC6wSZ1	7777	11004	11004	1617919920000	orphaned
15271	3NLFVSMLyhFSdaShqD7aVGCSM3JTqgGeKdMy54BZpWHvfPUuqCH5	15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	1513	1379	244	6301	11317	jxU9qHozdbDxkwCJ5pvyoNubpqLRfZEsXPuReecAbwiLjcjRiQR	7778	11005	11005	1617920100000	canonical
15274	3NKE8hSCweXU8vhKZM81dAJirpvFnNNRQSorrogUj5gqMgZ3gDok	15272	3NLJxwpb5S8T4UJNXJMfwHwFeUU1vKsJhhKgNVLHayxhf7V4oSSq	1481	790	244	6301	11320	jw6xuj92BVYCudKFNddCxrRVBzsSWBVJdtaJtCnqo42aJC6QcMw	7780	11009	11009	1617920820000	orphaned
15281	3NLuT8QxRHEDKkT8jAN3UKdm4SSrepshayTir7kZKsM9v3MWksRz	15279	3NKBfE5HW3tKHuKqSCvAy2BP1bWbS3fTJpERwCcuzA9DAzrQJNWs	1596	997	244	6301	11327	jxPca2pHPyTS5XGeUykn51MUxLmNLUHZ1fYuU5WGpuzTqMGUAys	7783	11013	11013	1617921540000	canonical
20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	20555	3NKzgdcNQzRr7x9Cx4N6nWiEnCBfcqw4VwuopBH829GNufNPiihG	1509	1320	372	12463	12868	jxPx22F8bT8LHDVk4azQnG9SWoWZG7jLWVbp78TZybEYTFVKXZG	10349	14592	14592	1618565760000	canonical
15163	3NKPBWuezV3esSi8t64owjtNjtcqZfPJSSCpsNJoX3gTAuZqUsuS	15160	3NKRoUKwPj2RGHWMnZjn7MumGSfm7eSByC7qDYheUxLLNitbqRx7	1675	1216	242	6301	11215	jxvbt7NYuWZXPehRUeQwUPVq81GLNCVyMtFrvwnN6kM8mwGJuQe	7729	10938	10938	1617908040000	canonical
15169	3NKJPiqEg4U1qTN4BiicAh5VPErUMQZEnK1RdkpXvG8fZqhCP4RB	15166	3NLkms7dryGXrS291uByBRQQNZX8dVT569bCvN4WpkfNoCDtqPZw	1403	824	242	6301	11221	jxbNGG6ETv7ZBWCzZDVF8hQrZAysbsp22sGzYWKEZjsmBaGiURT	7731	10941	10941	1617908580000	orphaned
15174	3NKzaKyFzNxSELVsz9fnYqh4XPymoTP7Rha54eJDQiMWzSPZ8SFw	15173	3NKMajBL9v4gt8ADy7kJxT8b3B7BAVYi2mwDygz4N3AM5hGws4Gu	1578	1050	242	6301	11226	jwrBntdoVuL5UTPExpKdetxgBSpJ4ou21ABh9BnbUQdjaJebR6T	7732	10942	10942	1617908760000	orphaned
15181	3NKwGuwZRZ25LWGPi3wsw95hDny5ge4Drb82Ub6W5zi65Sauqrq5	15178	3NKYXLqcxx9JRCS5uCeSsE75JLmTTQnoKethnP1cZ27HVmZ9ZFvz	1461	1271	242	6301	11233	jwAizW2JzNRDwwUK7mrvwJrJRM5brsw3UKBT5DP11uJ1yDrXYvd	7735	10946	10946	1617909480000	canonical
15180	3NK5uUFni9GJpjG8cu8JeydJAL54EvzGicbm2eL1ihweTBgQ3EgA	15178	3NKYXLqcxx9JRCS5uCeSsE75JLmTTQnoKethnP1cZ27HVmZ9ZFvz	1613	1349	242	6301	11232	jwD92qzTnfMmkUb5s3RQ4bZ5YrSUAY2oRojGyeuJyPQFdv3q9EF	7735	10946	10946	1617909480000	orphaned
15186	3NKQ9PnvivNjKauTv8qJeH91U378ooJRhG6WAWsRp4V3pYG9jozW	15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	684	1226	242	6301	11238	jwe3zShS44pFeCsaY5kaHCGwaudgz7RpEpQ7z2xcJUQ1SWKhfFu	7737	10949	10949	1617910020000	canonical
15185	3NKCbG3ZZLQUfB4WKWJcNnfA2Rv3HkMN2t8CgnNDYX66sCVYacF7	15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	1402	868	242	6301	11237	jwbCdLFyaWqUj6yc3ZWjRdYXsUeceveDmRwn8NtMgpeyuNMBtS1	7737	10949	10949	1617910020000	orphaned
15187	3NL26ByJk91rF8j521dCyUkpekuFgEFBJ3k3DUvGEzJHQTwXdcj7	15182	3NKKfL45533JZyWHLnNjXMNQeznriQiKqYuSwE2b9PdqfHTtgCQG	641	1210	242	6301	11239	jwq7a9czyiG2TnrnJBbJ3DMwhTD2vSEMaVVg2ZKdtdGAiKoFd7N	7737	10949	10949	1617910020000	orphaned
15188	3NL9dXeddESpuX2x1HctF2gX4crWCqDMphWqPu1aXYVXo44yyFWD	15186	3NKQ9PnvivNjKauTv8qJeH91U378ooJRhG6WAWsRp4V3pYG9jozW	1637	815	242	6301	11240	jwP6qXPtfKNCaRgFC4L796cm7CyHK8BDC9UDUH7UbmF7LXkUbEr	7738	10950	10950	1617910200000	canonical
15190	3NK9vLom3dZcanLKS3n5icd6ZthXYPtaS9ajdcEDhR66uv8UwLup	15188	3NL9dXeddESpuX2x1HctF2gX4crWCqDMphWqPu1aXYVXo44yyFWD	1402	862	242	6301	11242	jwvz4n8gX95izB2vaUhqUp2sfG71MnQveiGUmfBrF1Q4PUUzUS4	7739	10953	10953	1617910740000	canonical
15189	3NLLKu7t6MzubxxZrqq25DsQ5axNjC737cZfsiog7eB6fhPHwqm7	15188	3NL9dXeddESpuX2x1HctF2gX4crWCqDMphWqPu1aXYVXo44yyFWD	1407	1395	242	6301	11241	jwBMxNSScm5p11spKp5kZHtRZdewxDvqgQ1FTtWpVumaCHgabAd	7739	10953	10953	1617910740000	orphaned
15191	3NLUZJWpZPhPAdxDAGjZAxYK6F2LLe9m6kAgEMDqeQnerbeUCPFi	15190	3NK9vLom3dZcanLKS3n5icd6ZthXYPtaS9ajdcEDhR66uv8UwLup	1593	980	242	6301	11243	jxVBkDiZJuFXvVaNz5enpwcF1npUMxfjcD9CQxU8ArwX49ku9ux	7740	10954	10954	1617910920000	canonical
15195	3NK3SupvTQ3mzt1WPcjQysF411ExBpFgBCJWHRRuaZHB2yNkjViT	15193	3NLNLMPe7ZJPYtpucd75rbYf3fMK3DDAyknFCdJ3Tjm2iuoR7gVa	606	1295	242	6301	11247	jxcG6avUvQGsZeo7Z6dKwGiE2YSGjEKowiCTNjkQX5XkKhCHaJc	7743	10957	10957	1617911460000	canonical
15198	3NLxbRSZQdvBDukWQzGnGVqnt4a2SnKorjz2zo69WdC4Fa3423Sc	15195	3NK3SupvTQ3mzt1WPcjQysF411ExBpFgBCJWHRRuaZHB2yNkjViT	1405	887	242	6301	11250	jxhJZa9jfF31emQg3jsMpQ13e9cGyTYHeoE1pdae9QZoA1NArs6	7744	10958	10958	1617911640000	canonical
15197	3NLTzTrvNHJrWZDn9VqzimCyUgAs4EfrVDBHQyjWPktsXiXYkCVN	15195	3NK3SupvTQ3mzt1WPcjQysF411ExBpFgBCJWHRRuaZHB2yNkjViT	1457	1391	242	6301	11249	jwG5LpaED2SdRr5Tx7rA3cr9rhcba4hsTqLxEUy6pZRuWttb6fK	7744	10958	10958	1617911640000	orphaned
15206	3NKm3vm74YupNn6vViU6hxTBhwX7sf864oteTT41Fc6Fy31bgMKB	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	1673	1368	242	6301	11257	jxx1uAen9Rd5MbSMgqkhRGfhB5udSXNpsAkFpPqbfH45U2tJC3S	7747	10961	10961	1617912180000	canonical
15203	3NLSWh9Bv48A7qJmTUykEmbb5JzWtaHXrmapQuJbG1u719DmgfPV	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	1534	951	242	6301	11255	jwKpUZTGzcwgKUMmMf9hPXLGDbddbo6cPhgS86x8cohCata52C7	7747	10961	10961	1617912180000	orphaned
15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	15210	3NLahnWkKneGhEf5nBxUZ796dcwUqo7GJ5SVYFa2dC9HgzNF57bN	1507	1280	243	6301	11262	jwZVsH8VeabZAuGk4Hcc6mgRifVUxeoC3S1H4bgA7uX6zb4vj3J	7750	10965	10965	1617912900000	canonical
15213	3NLRJsjr7Adnvk6XHQoZewRfydh1Q8cjyiTogiuANKfVaRcBnsAw	15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	1406	1393	243	6301	11264	jww24Ssu5TcCyQupD9fJSQhKcyenjE1KdZw8Qhz5xoqKZsHWuUJ	7751	10966	10966	1617913080000	canonical
15219	3NKGRUPiTEDunZurZ7E5YWmikKMK8QdR2zBcGY6b6BAaQbEoGUZh	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1527	1167	243	6301	11269	jxxptVhvi462rMFNfqotvK11VCFmcnCDkDYnHsvQEwAc6G35HTa	7754	10971	10971	1617913980000	orphaned
15223	3NKqeyuXpi8TcfzTWyBGZSdGc8VPW9A8uMbRbjWVCGispj4xyedo	15221	3NK5G6YL61tZA1XmhxZbAA933mxvQvnQo2stLRGNvJobYy5jVyWu	1613	1103	243	6301	11272	jwwA4NdsUSU3Wh51D5bbcrtKf5QZvyN5dfMBqb8v2E4Lxd3cp8m	7755	10972	10972	1617914160000	orphaned
15226	3NKcqnRDZZLmVfNGRm92XFaZPDFSakAiAhL1iYvg9BEDzKeKyLW5	15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	1489	1380	243	6301	11275	jx7pJ1u9c2XgM5CJ1rF1cFu729wiykjBktQHov2poe12MKKYDGY	7756	10973	10973	1617914340000	orphaned
15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	1536	1067	243	6301	11283	jw6nTMV23eSsFRxRdwM1RCwsAN9BtXLj5ernbVcoj9jFZMHeHQr	7759	10976	10976	1617914880000	canonical
15232	3NLJwvqFZBYG4uxz7majWjA83Z17dZaQ9gnvZUTuAbSUixAYTTsz	15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	1407	1395	243	6301	11281	jxHAGMXdD6gUfu7XqZYHpJxajaMKDTRsjSXDWsTDd8cvKtTL6gM	7759	10976	10976	1617914880000	orphaned
15237	3NLPv12LM5fthLv6X2KzPb8rki5qUfGyYVY5MibCmArmLsVpmpgw	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1406	1393	243	6301	11286	jwufZSbc9QBFjRALdZCa3ZamSSHMiqBxXMHwzvsFTPDBAdqgK9c	7760	10977	10977	1617915060000	orphaned
15242	3NKKG1LLrt9M5vw45JaBBn4EcCSyr1undsvUdwSWtnjTZArhRaM2	15241	3NLgqZTbg82suQcv2EFJww5JtRGGXoVoZc2eoJ33ttK9Hg2wxrdz	1407	1395	243	6301	11291	jxu3qnsypYPpYstZkT3DUPQHncRHL8d242sQ781QwsBkYcczFfJ	7764	10983	10983	1617916140000	canonical
15244	3NLcnKLayVAwWzxvgfviu8Q2Vz7zEMX3D6vEbMCaNR7YwSZVHQkD	15242	3NKKG1LLrt9M5vw45JaBBn4EcCSyr1undsvUdwSWtnjTZArhRaM2	1513	1379	243	6301	11293	jwv1SjdiqKkgkL3LKcwXD22iGDTKbGJpoAaZRx3Y5BDAHExRi4J	7765	10984	10984	1617916320000	orphaned
15250	3NKcipSnd4fWKyRBjiyopnReBQiLppSQKvrfSAt2ZS4cwcwpmq6C	15248	3NKZ2hm5k8XyzU4uiimgi4yULHByMVMSkEUvz2WRx16J2D919tVk	1541	1172	243	6301	11298	jxN1fkC7DDCUiFt7HZ7vbARVkkzJa1Em9CD2QGC8WdYJfFWEtnC	7769	10991	10991	1617917580000	canonical
15260	3NKSgFVcwLD7XhadPvZfWarTS2nR7xAMfmXBjNXyEwirXAghHqQp	15256	3NLqtuwKeaQNUV4vnCpLKdm9kxhr11cbV6j6JXnShsQgxfVwgmQh	1594	1080	244	6301	11306	jwN3udZmY5P5D8sWnKnJLwDRsywZzpaUQUDS4YK9htzimYV87ai	7773	10999	10999	1617919020000	orphaned
20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	1407	1395	372	12463	12871	jxhgThkcGnS3yD85zgRoDz8r47oSmmqXhvKdCew9ftfr1eanYa9	10350	14593	14593	1618565940000	canonical
15201	3NLn1oqx2X9o52DWznMqC8cSmNd18b9VKmNtAxFUn1c9dh7HkhKV	15200	3NLufYuYow9K6ymPHJpFKBX321RnBVUZk2Pwp4QrE66tAWgP8FwY	1407	1395	242	6301	11253	jxYX5ZphLL3dyGWDkfVV1pRQFbMfgGNCKQnMWDTBH4JT2hmngbC	7746	10960	10960	1617912000000	orphaned
15205	3NLxHZxK3fjYci2oCHLPMFAzuZAw9D8xmzZivbZY5rBpdL2WpLrk	15202	3NKMcR1aqEzMwESCugzJn2oPeq997g9GXhVWzZMqVJEc1JMvmbkv	733	640	242	6301	11256	jxpPhpgQybsweYXzoCGQVqEATkWbkNXfB3h6vio5XbtxsfNjRFF	7747	10961	10961	1617912180000	orphaned
15208	3NKDKkuUaG355XtExorJyjmVRVVQpqSfd6uNZsb2oxdYajFmSP9Q	15206	3NKm3vm74YupNn6vViU6hxTBhwX7sf864oteTT41Fc6Fy31bgMKB	1407	1395	242	6301	11259	jwHJ2zVPhGnfrwG5nTww6AKcVGPgqT7nXsYd3wWDYNBUhjDLLDZ	7748	10963	10963	1617912540000	orphaned
15210	3NLahnWkKneGhEf5nBxUZ796dcwUqo7GJ5SVYFa2dC9HgzNF57bN	15209	3NL5AmpCmcwq3iBULGSvDvXvXXyx9xRBPrWrajBayMEPVq6i2vk8	1403	786	243	6301	11261	jxexdwL9Pf3kKHoyb4p7QnY2BBLDCzCL37Cs4cAMKMuVjS7B72z	7749	10964	10964	1617912720000	canonical
15212	3NKVGWX9KKSa55KTZ1vgeZQ3TNeEuXu94RCmhLS6jYMG1yHdL1RL	15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	1547	1378	243	6301	11263	jwuzkvxnEa1RcLRxDms5ccVFFtWU4jzipyje2pjtSd6aahBW6T2	7751	10966	10966	1617913080000	orphaned
15214	3NLEd7FupbANu5odu4ejTqh8KzeQzFCQLrofDRdhTffc6cRMEMfA	15211	3NKRfB46uvGHTU5JDQm4ViRRrKCGSEbvJLEQS32rUCHCz6JQ8gMS	1481	790	243	6301	11265	jwx3qyFWRbbiocEwJi3J4XnhmtheuK5g1VEJpNgArhC1JTn7CVg	7751	10966	10966	1617913080000	orphaned
15215	3NKoKLYxuZWc1L8qegyU1sYfxMHoQMXvrhFEdiY4et7P7D265LMu	15213	3NLRJsjr7Adnvk6XHQoZewRfydh1Q8cjyiTogiuANKfVaRcBnsAw	1483	1030	243	6301	11266	jxSURBxLCQFHTytRbsftRpCpDkd2X8GAMebZMKphReuENh5aEEc	7752	10967	10967	1617913260000	canonical
15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	15215	3NKoKLYxuZWc1L8qegyU1sYfxMHoQMXvrhFEdiY4et7P7D265LMu	1542	1304	243	6301	11268	jxXo6eZ86qmqK9Lu7WbDUFaK6g5WPBgsY3sGgfrK86so4p2xJqM	7753	10969	10969	1617913620000	canonical
15220	3NKxvvBCoCbnc9V4qJRrDdczHTX9m11gTBLLQPAwRFjKfXUe6Qha	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1527	1167	243	6301	11269	jwBKMUnCyvdm2ZAS24WTufoVb3V5PhGEBsnWMnCEAaNDKCbJ85L	7754	10971	10971	1617913980000	canonical
15218	3NLZQjQcyxC5j2tVKxVfUFtQe98c2BRqgaS4ZbnDM78rYttaVgY6	15217	3NLiS6UfXVC5jzaUSPWHZKJGPkiTswXijkXJ8aq6MUefrfsfkdEZ	1527	1167	243	6301	11269	jxmCLaVwemmMVwDdqXmjvWjWBCn2ReDHaHAA6qxXTRBSJxxmTgt	7754	10971	10971	1617913980000	orphaned
15222	3NLGFCydq4uXvoevhv17QTSPXkGtpHazKKotzZNkX13hXhLu6A8H	15220	3NKxvvBCoCbnc9V4qJRrDdczHTX9m11gTBLLQPAwRFjKfXUe6Qha	1613	1103	243	6301	11271	jwRRwH7V16AhdSwJeaUUv8ygFBwrLDat6MLq36AKGHYqhN5WbME	7755	10972	10972	1617914160000	canonical
15224	3NKhQ87ws45W8d1dwhpboCbFP63vCS9m1PNX4Lm9bBefRPZrAHo2	15220	3NKxvvBCoCbnc9V4qJRrDdczHTX9m11gTBLLQPAwRFjKfXUe6Qha	1633	1144	243	6301	11273	jx7qzf6tEPpD514n6NfAGLzetZ7BQyZPr6rTrke2uxSzkTtfLgM	7755	10972	10972	1617914160000	orphaned
15228	3NKk9kkog2mtfJ2dYcPhMkbRQqr7NGSzthQ392WG9R7JWF9yygCY	15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	1403	812	243	6301	11277	jwQvZAZ14jBFdBqYzM3jpoRxYnjmVtfPkf2HeXDF747xLXznMWs	7757	10974	10974	1617914520000	canonical
15230	3NL19JjUEmfT88fgNaTALH9eN1NCy8M6gpzhgGqfmG5bME4w1ayv	15227	3NLvEoemKk5e5se1w5LFhwB8anQKSCc1iTjUPq6zeNZWbvpqSzek	1590	1300	243	6301	11279	jxExiYHUft1hjYLLLbzD7psqiC9da4hKS7BRxxDVNaRikRmbkoP	7757	10974	10974	1617914520000	orphaned
15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	15228	3NKk9kkog2mtfJ2dYcPhMkbRQqr7NGSzthQ392WG9R7JWF9yygCY	1578	930	243	6301	11280	jxMDJD7mkhWyQx3PNgvKsg8Bqh9u2ZfhU5YJLmfjoLaRzgsj3Wb	7758	10975	10975	1617914700000	canonical
15233	3NKA8CA3BihS7cF9zNtAVALX7GKLbEMmg2rDtTWybEvhGNuvjGrd	15231	3NKGn5hfU4sv7odqM62Jm7wf9HovYVnmgvsnXVvnFyXenX5cCbM5	484	1073	243	6301	11282	jwPtkAbgnmwkCVGArPu7rG4HBaUktbLK8D2tJa7b5yx9UdvvHqF	7759	10976	10976	1617914880000	orphaned
15235	3NLmg3iLTKrHFsojU8bF1V7HVShRFwXpvVnPs3qzbTpNdw8WSNKp	15234	3NKbaUQ65GZpWJYvHpS1PYPsM1jFGZAXg9whzMVUFouZNqn5hg7a	1483	1276	243	6301	11284	jxKo8KrrW1AJ3joiQT4AAEe9wRvhaBdccJ1kH71SkLUWEuMfABM	7760	10977	10977	1617915060000	orphaned
15239	3NKH6eWzMytfBnT7bxBQs69pBzexJZShZma6EYgm28FaxNkuikrG	15236	3NLDoNzYb6km9wCYTwGX3n3ozc8X7Acv3Lx6KCdHs3jGpVNuzYaM	1501	1234	243	6301	11288	jw9uKeZxRRs9BQpHn5uF4K3TnpKCRyyf8eTfTyqzouNXiMr18fe	7761	10978	10978	1617915240000	canonical
15245	3NK7THX1zyNcGbxuTUmHGQibH5nAyBYqChRW8cDsy1LdA3LpySqs	15243	3NLpuggKkeqG33pV1LGfSErA5mdvHpAugcER3zYq6cFQvScD1Jfm	1451	926	243	6301	11294	jwwAyaPx6cABqMQLpB7xLpBter2NQ1cWQRvHruiq5SsfeLdGiN3	7766	10986	10986	1617916680000	canonical
15248	3NKZ2hm5k8XyzU4uiimgi4yULHByMVMSkEUvz2WRx16J2D919tVk	15246	3NLT8ahCSoEa3eaKXfmCdAjSsBdqGw4phEbmFxPxV94oAM1y68Si	311	1061	243	6301	11297	jxZc7iEn7WhShpWKgUD1T6cHHGMqVHYYdfgDPesXTM3Awuu9eqq	7768	10990	10990	1617917400000	canonical
15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	1455	1332	243	6301	11301	jxqhjeph45dNntRbEntQCAo9JJJ9c94c1HFQzBrWAuV1XH9HGJi	7771	10994	10994	1617918120000	canonical
15255	3NLX28h99YkAo3gRa3ety3pwikXyHryv8ARUcaPptqYeHskD7P5L	15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	1419	814	243	6301	11303	jwbTXQ81uoULiGPsWmnPcSTa2iVZ3p3L21nYp8ijSJZBw4uKUXQ	7771	10994	10994	1617918120000	orphaned
15256	3NLqtuwKeaQNUV4vnCpLKdm9kxhr11cbV6j6JXnShsQgxfVwgmQh	15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	684	1106	243	6301	11304	jxe9naWE9SYKGXZxEXHjryfjFNqwfZwxjs6ZMcQ3jSNTW6xFQ91	7772	10998	10998	1617918840000	canonical
15258	3NK8RsopNKu8PECZpwWbgW21sD4NQuLSNT49QDBD9kMDTeq22DLq	15253	3NLfNoHm64jDqRh5QcEwBVyDjBNfn8q2s79xLhu6uF4xYFouPK7v	684	1106	243	6301	11304	jx8SoUcaaWXjiXv6GBzV12EZkGsbY2w93eH7AvhHNRSGiXdM1un	7772	10998	10998	1617918840000	orphaned
15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	15262	3NLDNdgogrbaFUtMzgqKPHy5TSrzrmR2pxizcVNq2WR6upch8jgj	1656	1097	244	6301	11309	jwmo4YVG7qEvVkUrNBMwnyoShwXY8dz8w2GRwMNEWAN3871Jyek	7775	11001	11001	1617919380000	canonical
15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	1671	1119	244	6301	11314	jxrxFKYpdV49vVAih14pveguL2xaAfWtpue456gGkkQPjsUpMoV	7777	11004	11004	1617919920000	canonical
15270	3NKPNeBsDTojt7tQ4pJZnfKNErbDMTe2N6ngvenZqgoLeZs2ByQh	15268	3NKvDrzBEqFiCivGKQnBc23YkzM3eEErwktkZEJRzcQR3VzgJC1Y	1631	794	244	6301	11316	jwVhHLE1z9DFhDSW798H7CvYn9FfYhVkpFvSjpExVBtHhMNnMQ6	7778	11005	11005	1617920100000	orphaned
15272	3NLJxwpb5S8T4UJNXJMfwHwFeUU1vKsJhhKgNVLHayxhf7V4oSSq	15271	3NLFVSMLyhFSdaShqD7aVGCSM3JTqgGeKdMy54BZpWHvfPUuqCH5	1529	1316	244	6301	11318	jxSSnoB9Kfc1eU13qUx83jE51uTbWc14zWpz3FzYRTswi4biJzt	7779	11006	11006	1617920280000	canonical
15273	3NLskRpN6JJr3mT9E7BQ7rCXXpnfTJZwSsr9FvcXvYLMBxoWkTK6	15272	3NLJxwpb5S8T4UJNXJMfwHwFeUU1vKsJhhKgNVLHayxhf7V4oSSq	1406	1393	244	6301	11319	jxoaJPTgp27QpdXKFdtbw6BCkxVSfHbmUyzhof996szE67Z8ggx	7780	11009	11009	1617920820000	canonical
20570	3NK6GvM49RHTk248SvRXpoGYqGry9uxstijnwhUzRL1amDxrtDts	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1623	839	372	12463	12879	jxeoTayMJQGzmZuFLAg3q9arKYN9ettaCp6EKm5bCGvPTE6VDNo	10351	14595	14595	1618566300000	orphaned
15277	3NKuwb3LywU5C6PEETLUbz4WRf3w7Tqc69w5359EwoK9g15iiBYV	15215	3NKoKLYxuZWc1L8qegyU1sYfxMHoQMXvrhFEdiY4et7P7D265LMu	1522	1076	243	6301	11323	jx4SmSNMbH4Cqr1qwscmQDrERohP7iyQ9VqhJ8jHJnozEYaTt8q	7753	11012	11012	1617921360000	orphaned
15240	3NKjr32HD9UVfHHmoNDFL8WBy73uT3qUbd5zWT2niBxFLSwZAn7m	15239	3NKH6eWzMytfBnT7bxBQs69pBzexJZShZma6EYgm28FaxNkuikrG	1403	824	243	6301	11289	jwsnJVaUMsn1aSrvsmqTUm9ioUXreGrEwmrrqGQbFAqtyftkCV2	7762	10979	10979	1617915420000	canonical
15243	3NLpuggKkeqG33pV1LGfSErA5mdvHpAugcER3zYq6cFQvScD1Jfm	15242	3NKKG1LLrt9M5vw45JaBBn4EcCSyr1undsvUdwSWtnjTZArhRaM2	1553	776	243	6301	11292	jwJYFWt8n8d6ktHHcwXEVPuXYw5KSfjunQc3zzCiQB1wBtaUN2V	7765	10984	10984	1617916320000	canonical
15246	3NLT8ahCSoEa3eaKXfmCdAjSsBdqGw4phEbmFxPxV94oAM1y68Si	15245	3NK7THX1zyNcGbxuTUmHGQibH5nAyBYqChRW8cDsy1LdA3LpySqs	633	1258	243	6301	11295	jxSE3bqBuHs11U8zeohiuY7KgaBGCHY1bcDyP2kVAr28RwS7dQM	7767	10987	10987	1617916860000	canonical
15249	3NKYCCTZWYnPi2HJ69u8kX62AMZUrhQvMQk5GUQ1vAqmJ9KR8kfi	15248	3NKZ2hm5k8XyzU4uiimgi4yULHByMVMSkEUvz2WRx16J2D919tVk	1541	1172	243	6301	11298	jx3Z7fNjQAXep3xwowTfsp4D5VHQMHfAuvtW3tWoFxUxWDNEDXh	7769	10991	10991	1617917580000	orphaned
15251	3NK7zvi4nL98PuT2UBLbroyHDg3wr82dzqNa9xLAKmKoDUboTrKj	15250	3NKcipSnd4fWKyRBjiyopnReBQiLppSQKvrfSAt2ZS4cwcwpmq6C	311	1061	243	6301	11299	jxRcEYgHKvQ1rgcEN4B3fF1iq8KZAWErsauqssNWZCE7kkcb4EK	7770	10992	10992	1617917760000	canonical
15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	15256	3NLqtuwKeaQNUV4vnCpLKdm9kxhr11cbV6j6JXnShsQgxfVwgmQh	1637	816	244	6301	11305	jwRkwUQNWyYoM9Dn9aD2hv9QnCQvZbmuX8Au6ch5VJjuLBXqGHW	7773	10999	10999	1617919020000	canonical
15262	3NLDNdgogrbaFUtMzgqKPHy5TSrzrmR2pxizcVNq2WR6upch8jgj	15259	3NKL8xbSCrCoW71i48XM8KXe3nn3qSrbZYzbwLmZDVmKrsMMRDr1	1426	1238	244	6301	11308	jwTgKBRr9u8nez9bCccLyPfZje4dhXkmgB4GpvkG6aap36P8nvN	7774	11000	11000	1617919200000	canonical
15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	1613	1349	244	6301	11311	jwH58jBVr5sbG6kt2SXJPszu4XkzUGZ6R5vePxCZkuR31xCEdU6	7776	11002	11002	1617919560000	canonical
15266	3NKsVJpgWrzRAwMD2CNcfy25abiq1xZbLCSw7pvE511eJqkHWUsW	15263	3NLuEZFgWdqmXGoCzuHwHFTXtBdxaZx5QkJCfFUb7xk8vCVgLxWS	1406	1393	244	6301	11312	jxvahkffu1jPhVtr2SyXm4acPJ7vE3AMFJ9vpvfUtdENhErz8th	7776	11002	11002	1617919560000	orphaned
15267	3NLDkKVY5x9jETed3fW1pdTMNzz1kQkS32TragzbspoiuTSA8eKS	15265	3NKvmaZx6wXoTBLphAVWfshNVK21BXyfvLuZbJN3gofJ46CovWw1	1593	1346	244	6301	11313	jwbgoNyDk84nWfm3FtLFadRfMFBaQd3ASnwnoLy7mD1qYUCRCVc	7777	11004	11004	1617919920000	orphaned
15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	15273	3NLskRpN6JJr3mT9E7BQ7rCXXpnfTJZwSsr9FvcXvYLMBxoWkTK6	1406	1393	244	6301	11321	jxwwwuZmBbeu2wZZumQhtEwc3iGfMMxQgo99AJi33NogL1kvfkB	7781	11011	11011	1617921180000	canonical
15276	3NLpvTkUjvcqEn3L7wqy1qcQpZQqXKsE984uAQicbqV7oxVXSxP2	15273	3NLskRpN6JJr3mT9E7BQ7rCXXpnfTJZwSsr9FvcXvYLMBxoWkTK6	1439	1033	244	6301	11322	jy1DfL4avPH8RHHHU3WNXG8Hv9JuCkXUaYGF93EPjzWRWYvW1G7	7781	11011	11011	1617921180000	orphaned
15279	3NKBfE5HW3tKHuKqSCvAy2BP1bWbS3fTJpERwCcuzA9DAzrQJNWs	15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	1406	1393	244	6301	11325	jwcH5gsQcTLsLGMj3qbENbZVKJt4E6oHNf4N96n4MKfmAApxarM	7782	11012	11012	1617921360000	canonical
15278	3NKHHVJi8A6wbYcNYcHnRQDtFukZPT453yoCWFvMEKMxt28EEkMj	15275	3NLWWfVPCMK8BcFYZZB6BUuEoiKagLkA7bsXdVvpmZvYH9JTZRVU	1522	1076	244	6301	11324	jxKoFXjdsy7vY3wt1Z65wxyEkQ7zzaePtcjcJUQ7mP946hyMAUP	7782	11012	11012	1617921360000	orphaned
15282	3NLsiYeUaWxFme8fo2DgTqdCHnVJgHiERKJhFVzYMYcVMS8WaveS	15281	3NLuT8QxRHEDKkT8jAN3UKdm4SSrepshayTir7kZKsM9v3MWksRz	1503	1151	244	6301	11328	jx2v372E5aC4VrVkLUG4gaiyZ1XfLX8stS7DbAvFWvTg7p1VGP5	7784	11014	11014	1617921720000	canonical
15283	3NLWKGArDejyBUXyr9B6VvcamHH1sSUKdrpWanJb9aoBnveWrpfB	15282	3NLsiYeUaWxFme8fo2DgTqdCHnVJgHiERKJhFVzYMYcVMS8WaveS	1406	1393	244	6301	11329	jwQFkWF4DsC5hyN3XMLR5FpHW2pDoeSRp7Eu7eETNiqm9RU9KsQ	7785	11015	11015	1617921900000	canonical
15284	3NKunWS7VXERBtE15cRDLfQGDsh4jYshUw2fwckn39NQmGxWJStk	15283	3NLWKGArDejyBUXyr9B6VvcamHH1sSUKdrpWanJb9aoBnveWrpfB	1577	1081	244	6301	11330	jwDYK4rUu4KMHYK283miq6s9RP9ExYzBExq24C3D5HtLoJiF43N	7786	11016	11016	1617922080000	canonical
15286	3NLu2SxvefETEbKhcsJEwWJQymjCZFtDw8zXyNNzMcFTFax4W7kb	15284	3NKunWS7VXERBtE15cRDLfQGDsh4jYshUw2fwckn39NQmGxWJStk	1529	1316	244	6301	11332	jwj2JnC3LzHmokUjzrFpKkLQZ85SuGHYJpD6UUi3NdAMfK5RFz4	7787	11020	11020	1617922800000	canonical
15285	3NLEnSWkFzxuzBctHTZtsEhmf7Gi1eahRVfQvkY3E4MmESTseec7	15284	3NKunWS7VXERBtE15cRDLfQGDsh4jYshUw2fwckn39NQmGxWJStk	1407	1395	244	6301	11331	jwbYvxxMHH66vFdjgkxXb6YNL9UEekTrK2P7bY3z2PYdCEJBXQz	7787	11020	11020	1617922800000	orphaned
15287	3NK9NKrofqoiScuVc9xm1aWFVes68br2hT5Tkur5zaDxAPBx5Hab	15286	3NLu2SxvefETEbKhcsJEwWJQymjCZFtDw8zXyNNzMcFTFax4W7kb	1500	931	244	6301	11333	jxNNHKSoKkJeTp86VzFmignRxNTdGVjp6ZbHra1cExyy6t1PDyA	7788	11021	11021	1617922980000	canonical
15288	3NK6k3LfpaEtvc1k1eAeVnLQMDayzuZijfdZYjgTRGKtwX4JtZdg	15287	3NK9NKrofqoiScuVc9xm1aWFVes68br2hT5Tkur5zaDxAPBx5Hab	1406	1393	244	6301	11334	jx9AdAnHSsLuhyvQkFB4LZTjMKVQU8kQ9kSHq2W6GgikA1qM3iK	7789	11023	11023	1617923340000	canonical
15289	3NKVMezU9uRHq97z96ZPXiHo7EQuipVvk9533LiFB6UehZgKJzSi	15288	3NK6k3LfpaEtvc1k1eAeVnLQMDayzuZijfdZYjgTRGKtwX4JtZdg	1407	1395	244	6301	11335	jwUVaVc6dfNbsqTnFEqkGxcYPm6zGghDeR6rmE3EvdU63KoyXLw	7790	11024	11024	1617923520000	canonical
15290	3NKg7vfpQY3hUFSN2wNnWQJ6Z2qXvhvwmAwPdTkwonxoXE1oUnA1	15289	3NKVMezU9uRHq97z96ZPXiHo7EQuipVvk9533LiFB6UehZgKJzSi	1444	1255	244	6301	11336	jw7Hg2Fdi9LdftdmK6cdc7xgu9cVMduXGsBqmt3XhtTX5tWAgLj	7791	11025	11025	1617923700000	canonical
15291	3NLmjPnydJBKnmLEBJhaMPbdPd5iKFwkNRLGUrMVXWyNKxzCx4kk	15290	3NKg7vfpQY3hUFSN2wNnWQJ6Z2qXvhvwmAwPdTkwonxoXE1oUnA1	1445	924	244	6301	11337	jxNrQMX6FVFdvdfL7QZAWTBgdHsZzg7p91y4wHaWbssPYMaicfS	7792	11026	11026	1617923880000	canonical
15292	3NL2kD1Fcj1Cv79964AodqmEJntXD2Pkcw6YVeMdNNsXtUqmQugz	15291	3NLmjPnydJBKnmLEBJhaMPbdPd5iKFwkNRLGUrMVXWyNKxzCx4kk	1406	1393	244	6301	11338	jwSoi9nWvn5yEsRusQnF8SuwHQUijCo1AgbHiaxdT1ziisVYV2b	7793	11027	11027	1617924060000	canonical
15294	3NKDtAU34AMHYQJjWRdaQf6Zrsn81GbKJziTxdQ6NKp645EZ9gek	15292	3NL2kD1Fcj1Cv79964AodqmEJntXD2Pkcw6YVeMdNNsXtUqmQugz	1513	1379	244	6301	11340	jxQM88KRz2aquUnDGyXnCYYJ6VBBAfjQKJXBPKhyBazckA5epRw	7794	11028	11028	1617924240000	canonical
15293	3NLQbPnB5V8Y4A7mU1zaqxt845RZq1DmcepS6GKouWhrTFxF1nHR	15292	3NL2kD1Fcj1Cv79964AodqmEJntXD2Pkcw6YVeMdNNsXtUqmQugz	684	1226	244	6301	11339	jwPjzuMTvgjRGy927VfrGv1UiCMBi3qvt9SAiEyevS9377X6mHa	7794	11028	11028	1617924240000	orphaned
15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	15294	3NKDtAU34AMHYQJjWRdaQf6Zrsn81GbKJziTxdQ6NKp645EZ9gek	1451	1292	244	6301	11341	jxFcTgbnu6ZH9GertyLA6keGaH1uKtKFFXHCpfAUA4BV1nSaT8v	7795	11029	11029	1617924420000	canonical
20571	3NLnZ2oG1ZHngAtZTaL33zwHbCdBQUaa5SLVqSxbge1ybg6FCtQE	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	448	1059	372	12463	12880	jwe6bbg7fXb1wDk9zYR15fNkgPUZJyhy68PL7Y4Pt4aSDTiYtow	10351	14595	14595	1618566300000	orphaned
15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	1447	1345	244	6301	11344	jwj23nxMxdS3UbPz8u7Q9pXXHX5rGQGFHc17xDP6txVri7wpdnD	7796	11030	11030	1617924600000	canonical
15297	3NLu1WaoK66KA6zPLtnC686YDgtNd3HD9P3Awx9zaUAtmb1rcVbz	15295	3NLcrQ12P4cxZerkZxadJChvLk5GM1U6YbhMtiUG1tnwJPR8FKf3	1588	1146	244	6301	11343	jxoRv66NQ3Rtj8XPpnw8Yn7PdsqaWwkTDJXKd9cxFb6jTDpWWxS	7796	11030	11030	1617924600000	orphaned
15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	1647	1056	244	6301	11347	jxLfnKKJVhG5Yr99HdqAvxwviBAkEKL3f5ZNB6CrTYbfrHNh86K	7797	11031	11031	1617924780000	canonical
15300	3NKyqs8JSuhtMYodwi4KAF74XNFjnz87qUmJ2PLaYASnkuR3rPgB	15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	1407	1395	244	6301	11346	jwtyBHMJJFdw4ZE5jzUFCQUfPFXZdZ7DXKaXHytkLw7frr8Xuex	7797	11031	11031	1617924780000	orphaned
15303	3NL2axgpXZcQvCUa73g1xUCtnGGCYTqmjaytGnL1s2kCWBoTnvaU	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1407	1395	245	6301	11349	jxLpSP2QxUrB7xRudPkefK4odbKVPD41HEMwxej1p4ZdzRw7wMw	7798	11033	11033	1617925140000	canonical
15302	3NKBEvJNpvBPYAWbVGjLZDpkzgGQvT1dfpfx65SfMLnpPdwF3kvW	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1509	1194	244	6301	11348	jx9ytSx4FSjjieCGwofxisnroCZ5RyMbgqGU5CcUZyAsFGw9D74	7798	11033	11033	1617925140000	orphaned
15305	3NKw4HzuYSbvg8U7WmXpCuSsGmYpEo7xVUppt8yQjLxWCmEPxYcF	15301	3NKaRE9kxexzecPSF2RED745NAeHkHWEA2g67q1DXVjbvWtQe5qH	1509	1194	245	6301	11348	jwqneEBYpKB5DMVLu57mMLPTCMWQjjHzYTkrMCsu26f5cqwQDuT	7798	11033	11033	1617925140000	orphaned
15308	3NL8VgzPuqUQZikxHvvkFAYD72nZza4w6ChfmBHf8Dpifo7riqpY	15303	3NL2axgpXZcQvCUa73g1xUCtnGGCYTqmjaytGnL1s2kCWBoTnvaU	1634	241	245	6301	11353	jwmpDVugLeUpDjT27VfxsrGrtqKKJ3oVHKgN51x2wpuZ2AwnCdQ	7799	11034	11034	1617925320000	canonical
15307	3NKwHv3tGpj2sVk7yHMRxQuUA9CcR7j5KEtmi2MQWaRqfDixu4Uh	15303	3NL2axgpXZcQvCUa73g1xUCtnGGCYTqmjaytGnL1s2kCWBoTnvaU	1405	891	245	6301	11352	jwq2sV9217zCACvhKX1qgW1Yy1uaGCqkBhgKCmVfZLeCo5TJSnF	7799	11034	11034	1617925320000	orphaned
15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	15308	3NL8VgzPuqUQZikxHvvkFAYD72nZza4w6ChfmBHf8Dpifo7riqpY	1406	1393	245	6301	11355	jxPygRye36rrQZJJrK8KmCZGxSYcFRGwRdDfhkRdtRdkZS4s2Ei	7800	11035	11035	1617925500000	canonical
15309	3NLp4thdyUTAy1DkjtFiS7UWw36aRXEz3JzURNV2NLWNUwgzStse	15308	3NL8VgzPuqUQZikxHvvkFAYD72nZza4w6ChfmBHf8Dpifo7riqpY	1407	1395	245	6301	11354	jxd8mVXZeQnapAB6Jzb4gKJX4tmSyeg2LDk5taUgaAdHfNcWKke	7800	11035	11035	1617925500000	orphaned
15311	3NL41Y645XbxFatAh6jMf4q1gMYABg5JeimCp4UedMY568f5KBfM	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	1600	1372	245	6301	11356	jwhYqskXhKNdxzTSoFtvJet52bU2a7wPH6y1kqhSDDJVwqmbWRU	7801	11036	11036	1617925680000	canonical
15312	3NKoZt42F2joitBzyz8Ckig6WWt2WSXJWshBBcvWxAj474QzzgSA	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	1477	1104	245	6301	11357	jxWoLpNepCMxYYgqmGGa2DWABHXgQNAzammqLKHibWsHno6fPhn	7801	11036	11036	1617925680000	orphaned
15313	3NLdzVAByva6e8nzz5c8c9ahoT6GYok2SUtJXqyL5YuXWZPkrdfz	15311	3NL41Y645XbxFatAh6jMf4q1gMYABg5JeimCp4UedMY568f5KBfM	1402	874	245	6301	11358	jwYz2skuJBMgDYHayxtem2W6Z71cphxeqYjcUtG8G46QsfWBL5r	7802	11037	11037	1617925860000	orphaned
15318	3NKP2Pe8kAo8oZvc38EU893os16Mpj7i7sJgTbJMDrHtQzPXLvD5	15316	3NKNGc67Ggruw9RTeJ4S4xDoUe4mBrHM7VAq1nbaqMFuY7ud1oaH	1403	824	245	6301	11363	jxksyFmdzqPoCBYRPF3wzkNbHoT8f1dgzqVeGgV7zCTgEq4pUfT	7805	11041	11041	1617926580000	canonical
15321	3NLSjjhSVeTRHz1T2W6Uf7ThLaqmr5wtVQz8e6CojfwHA3Ejvi9P	15320	3NL1TF1vfuErubaMHG9VrVzxvLhkBxsSM2gEtDJS2ioba8zrLRCF	1608	1289	245	6301	11366	jxh8bLQHiZFysNzFu6eSFjyPpECXWxqFMAvjdoV6VGiD9w6uWbd	7808	11045	11045	1617927300000	canonical
15323	3NKWHy2QpZBtKfaXvnx4aDYU1rnkUsJ6DsAhUQz7thRpQqM2Tx2z	15321	3NLSjjhSVeTRHz1T2W6Uf7ThLaqmr5wtVQz8e6CojfwHA3Ejvi9P	1559	1353	245	6301	11368	jwri5DzGePERXtwZ6M6hEnXVQQpXixgJvL1fzFgXrbLC5oM5Pkj	7809	11046	11046	1617927480000	canonical
15328	3NKSWAvHD7zSdsSm736Y3eRuUmgHkn3CZG6GWMMKNX6KYTDZPbT7	15326	3NKjgohK2hUZ5Wd3r5ZwYCwGeoByeXKAVqaAz6JFbFuiWmWRLuXg	1406	1393	245	6301	11373	jx9bp76vLBfWgMqb9gauf5DqtQEvxbtv8cNMb3LpBRaeHu2cZbA	7812	11049	11049	1617928020000	orphaned
15331	3NKB8dmXZmR1R66RLY8PK7JPw1tSPTskyE4XzVvhFYVm5eNfkgTt	15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	1596	1117	245	6301	11376	jxXLTczihRkd8jrqnaTQphnns893w515qpVCHU4g5L6xDwtnK5c	7814	11053	11053	1617928740000	canonical
15339	3NL84CVGiyVjJ1i2RTgg1HxrNYxd7GoiShSADXxc1aZqWrj6BAs7	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1474	1083	245	6301	11382	jxUVLYFxCiqRctTDeQpdp5nQ61VrCLaVuehDfYnYQgokSyEuL4J	7817	11059	11059	1617929820000	canonical
15344	3NKmoPo26AxkzHzPLiP2x9SA4iNMRSUybRp3xyBQsiBFqiS1JomC	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1506	1127	245	6301	11387	jxuo36myK59KWHtTRpb46M5AmvkHC7zLiVVyg1agWPc2TW8vtBQ	7820	11064	11064	1617930720000	canonical
15346	3NK3o2ESeA2DYHQJjKVorwhBu2WmYXjZQzxn5xVBnq5dmX3wvgEC	15344	3NKmoPo26AxkzHzPLiP2x9SA4iNMRSUybRp3xyBQsiBFqiS1JomC	1602	1243	245	6301	11389	jxpm3PuwE1Fdo5gfafHxD8jjBpmLVBBthrPFfn1m1q9Cz9CXeyS	7821	11065	11065	1617930900000	canonical
15348	3NL4mgj3dBVQ5JndqABWpJsQn6pEEZZ1zUjMPmcW3fpurTM6YPtr	15346	3NK3o2ESeA2DYHQJjKVorwhBu2WmYXjZQzxn5xVBnq5dmX3wvgEC	1542	1058	246	6301	11391	jwM1yFtjiM3U9W9WNoGcptUNj6b3aeiovNbfgqAdsVPc5XsMt5w	7822	11066	11066	1617931080000	orphaned
15355	3NKcQJTrrg1pvmt7zrtFN7k4DUcexvvjeuRgYx1bVLWGzG6tw6T4	15350	3NKPL4kDzTXXfNASyVVhpaDFQ6Jt2vjgmZBbf2SjjMLcNNYmxEp5	1448	1185	246	6301	11396	jwJUgeM24fGoVrjugdGNMphHqouK49J74B6tTbDM7x1XGYosuz7	7824	11069	11069	1617931663532	orphaned
15364	3NKf5a4YWpRpxiPmxZg7xEpZhwrqBnJCeXbDS4gmCFvpsQMzAsae	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	1589	1040	246	6301	11404	jxF2Czs7yPVwqGbDzxgnKA674Us6Rna4vz4XU74NuPHpxQaYyza	7828	11073	11073	1617932340000	canonical
15366	3NKcm25XtoUCwFqNpN3pChAfJusPP5UgABxK5dBJUTXMsrR8g2uo	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	1406	1393	246	6301	11406	jy3DW9DnhS41o23m7ma5uo43JF1fZhMLTpP7DwTohE7oJCk5p1o	7828	11073	11073	1617932340000	orphaned
15371	3NLDBkZUfw6svhEu6ivr4LBpAhuFvuMc7rPBKmAnbXixMDiqkF98	15370	3NK79CyugAMoghxkFpGne8z1g85twAVLkdh5BVvoBiijnbq7hYi9	1534	1191	246	6301	11410	jxF28f2WaEskSqJisvfit8ChUYSWbwdD2p39ngJasE7e2LfHQeF	7831	11077	11077	1617933060000	orphaned
15373	3NKespijr3RMDqVVq6Zwy3m5epRYBNHZsq2eUsgYJMMGkY44c3vp	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	1634	1085	246	6301	11412	jwEAwVaKaVTyyp69BakrM2F14C4ihp9fnB5Ead8BJzVvxZc77Ha	7832	11078	11078	1617933240000	canonical
15375	3NLkUXjmn1nKgLsPYh1pWWgY7XRiW17G8hsF6yK7P9cB3Uu7rL7K	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	1547	1378	246	6301	11414	jxCYTo4My2ubVzYLH2tNW1BoJrK7bkRbQkvji78jKY9YP4vfX6x	7832	11078	11078	1617933240000	orphaned
20572	3NLXbnLhoYFPDSemwrDmyjNw6DA4sGHNKaCxKrDcDMZw8QCeYjoK	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	448	1059	372	12463	12880	jwZ9EYSSAj2mmdTUK1ZneCWDEUFAgfEf7mb9N86w9juKSrQUGfZ	10351	14595	14595	1618566300000	orphaned
15316	3NKNGc67Ggruw9RTeJ4S4xDoUe4mBrHM7VAq1nbaqMFuY7ud1oaH	15315	3NKkyXUaV9KgtB8nEnj1D1sHHDyXcJoj7RFKkr2TxLJsufDuw4ye	1613	1349	245	6301	11361	jwJUd4GDisXuq7UgJd6iX23tfBZdrHRev2GAymRgbxBGsUFZPYK	7804	11040	11040	1617926400000	canonical
15324	3NLxz2VbEUFNR9xtFornX4NTTa74nXbkQRfbQugiqvnPpqbaadUh	15323	3NKWHy2QpZBtKfaXvnx4aDYU1rnkUsJ6DsAhUQz7thRpQqM2Tx2z	1637	816	245	6301	11369	jwMGFL9oq3zvcBfTF2MD2spZ49Pihe1DXVWVU2VywxJNHpnY1Fn	7810	11047	11047	1617927660000	orphaned
15326	3NKjgohK2hUZ5Wd3r5ZwYCwGeoByeXKAVqaAz6JFbFuiWmWRLuXg	15325	3NLRQ6o4rZeV3jqmftpphwqaLDzidMQcdBybBCyNcQ1Lb9m8zoN6	1402	852	245	6301	11371	jwcqmUQ5uLKoA5G6ZgmqV39n1Fg8hNPw3LxhuGMxagrdmHPi12t	7811	11048	11048	1617927840000	canonical
15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	15327	3NLMCuuZ98aSFz5Rep33EFkRm4HiSgkCvQt5HxNL3CHT66byrdFy	1637	816	245	6301	11374	jwuuXuwaJ3ytShesorJrxecQNBFMs9GnHXPWYaYJbvpjwcWz5MA	7813	11052	11052	1617928560000	canonical
15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	15333	3NLxbJrfL9TgX1NkFZB1hRuMNm3FG22LBg1cg8wg7Zu2an8qpEcv	1609	1333	245	6301	11378	jwpjpDAVHiEvNSMQUFTBdRVVXugzk4k6gkUq63o3B9vwyHp1eYW	7816	11056	11056	1617929280000	canonical
15337	3NKTNVb9uomhogcRu6JGPveU7LCufCeYGvhDKMpvdJ3C8SJ1ztaf	15334	3NKSYaLrQWn3i2gqAzGtHtDHWPWoXdXQD3gP1g7yvhvQPBSCgBjH	1406	1393	245	6301	11381	jx1ovr58S2pRocR8RhHdKK8yfqxbvvxUSkcf5NSv12qgq4zp7QN	7817	11059	11059	1617929820000	orphaned
15342	3NLUVv44XCYM2Brn3y6FXxbVaDmaesqDmpSWgU5wYAPj9X8ekArC	15340	3NKNE8viaHBapSTeCJq9jp7WodirBe3Cruhau8njxFRyJbEca5zi	1406	1393	245	6301	11385	jwderXq2R4ser4GKcN3YUV9FGDVHkSjm67D1FDXhoQCsSDvGU6d	7819	11063	11063	1617930540000	orphaned
15362	3NLezAVdkpn6aGTPGnQqqMNt6hHW7ZiHWw8rbnZ8N7xTSoprC291	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1402	796	245	6301	11402	jx1G9yJK8B59SZm36TYfrJjKCfMrwSRpMTXiP7LANN5qsZLt9rG	7820	11071	11071	1617932012903	orphaned
15353	3NLsZJXiqYSoJpb5XgEEd5e9Q48F9isZcuLJbGHyHH7Z9BA1PKUG	15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	1600	1126	246	6301	11394	jxwvmWpbaexyFKgqHLpQuMsxk4iGXuVabWXNcyADYhKLH6uEsSJ	7824	11068	11068	1617931440000	canonical
15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	15358	3NLDEe43mCoCoefD4NhRq2EXPGcCu86oKoMDuJTeKgzwqoCeAkF4	1670	1282	246	6301	11400	jx4wAEgSg8RdaQ9ExpmhmaJwegv6ae3ZSJv88Ky6P9HekoHYmVc	7827	11071	11071	1617931980000	canonical
15365	3NKSaLKCY7vxX6pZtpvNMPepucs6QzsraSAThAQzYnjK3uvXbTmm	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	532	1057	246	6301	11405	jw9nzHXUYEhaTgG1DWHr8JhTfoRxw7KDUXu5DA9qENGqupNZWDd	7828	11073	11073	1617932340000	orphaned
15369	3NLi78ycS42uXGmThQqN4VMPjxRmxEFn9wtQrEt1LZ17RvFzgPWr	15364	3NKf5a4YWpRpxiPmxZg7xEpZhwrqBnJCeXbDS4gmCFvpsQMzAsae	1406	1393	246	6301	11408	jwhvXzaoAUHfLrLMLWu4pwmoJD8G6w2YWkKqYhkVi12ywzNxsZj	7829	11075	11075	1617932700000	canonical
15378	3NLfoJTPg8wGxMUVDRYBSiMu69S7NQWVqdDfBJJf1Sd8ZLEiDcgr	15373	3NKespijr3RMDqVVq6Zwy3m5epRYBNHZsq2eUsgYJMMGkY44c3vp	525	525	246	6301	11416	jxGcyPZSqtWS5dfnAeULDQfScBBUahHrJ1FW1kVnhub8H48Ljsc	7833	11080	11080	1617933600000	canonical
15379	3NL64LRubqoENJmkRVpBnkxpHzTUkqntkYacSRpANEHRGiUi6cot	15378	3NLfoJTPg8wGxMUVDRYBSiMu69S7NQWVqdDfBJJf1Sd8ZLEiDcgr	80	1147	246	6301	11417	jwRTUmnavjpMPZxtX7g6guLdFEovHqmgYAvsAsFx4fAA26xd9q3	7834	11083	11083	1617934140000	canonical
15381	3NLjAtSbeZLp1GgKwvUaGDoZ6jfPozsNreGFJCjJymCGRep4emYA	15379	3NL64LRubqoENJmkRVpBnkxpHzTUkqntkYacSRpANEHRGiUi6cot	1403	824	246	6301	11419	jxmALC51zC7CDmh4an77Hmt6d5JxwxvSb3HjdNYaSWxePu5M6CL	7835	11085	11085	1617934500000	canonical
15383	3NKggisTYtqptKiqRgGJNpX1QCtidx8SEymcFeqd8NUVzJMfYUjy	15381	3NLjAtSbeZLp1GgKwvUaGDoZ6jfPozsNreGFJCjJymCGRep4emYA	1406	1393	246	6301	11421	jxUgS2mDw6hrxm7d5jjHxMMupxpk3wjj8xYLPfudeRG3npZAYuB	7836	11086	11086	1617934680000	canonical
15392	3NKPY4poNV2qEAcpicaFrHG2n8GhcJ6aPYyW4SNbbgCKANGEGNi8	15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	80	1027	246	6301	11430	jxAK85f9P5vN5RYjxmsZN1LFK3UMXs7iHzQuAkG8ZBubG5E5z1D	7840	11090	11090	1617935400000	canonical
15394	3NKdEfmAuQCykAq6xfENyEZpy7fvEWE4gfruKkZLTjQct8dL3RAW	15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	1541	1172	246	6301	11431	jwLjFe6YNGBeZnoKuykEfk9A4mikTwQbCFsxewsTfdQQ7CmADY7	7840	11090	11090	1617935400000	orphaned
15400	3NKkNLVKYN3rbGEg3qsVEdGXkEyftTQpMqX4XDo7Nmxabc6q4375	15399	3NLindUULaGhTCF5WELC5uryCD4fi8wSVHQ2nYSsy2bB55GZTauw	1476	1371	246	6301	11437	jxC7xEwtZwQPjQzfvnGNgzHjXHRZfGW8btREvVBF5Qqa4j3sksj	7844	11094	11094	1617936120000	canonical
15405	3NLWaUqfj7jB6CHb8wT3UoNsgUQNyy7dKUvSe4C6EFNrd8M17Xo7	15403	3NLTi1SPmixX6A9BFGRMpyNfnfx3fv4ucXHh4L5BGxPu3UeAPoTM	1407	1395	247	6301	11442	jxasomkJKe2rGqSCPLpw95v3nUkTeGWRep9H3Sv7F3374BS1pw6	7847	11098	11098	1617936840000	canonical
15417	3NLujZRKNWqgoMyHpcJHTypLDu1AJ7G2bGMiRG7TKDrq2GGWQ21L	15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	1652	1315	247	6301	11454	jwGfVUmZHkfb8jiVdsKZ1et6CchSFtU9QaS5YjuMWyDhiBLgZer	7853	11105	11105	1617938100000	orphaned
15422	3NKj1EEA7jd9AnZkmwjZDhXuxmY5voUudYHXLUxv69SDxCiWq2sL	15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	1631	794	247	6301	11459	jwocRNjEoALf46E5wRAmR89YRznqe6yWLTSNLZBDS22jeVQDffz	7855	11108	11108	1617938640000	canonical
15424	3NK73UNqdxtPBcBRot8id4dDvBebTqV8h3FVJDU8mvn4KgEZ8JwX	15422	3NKj1EEA7jd9AnZkmwjZDhXuxmY5voUudYHXLUxv69SDxCiWq2sL	1613	1349	247	6301	11461	jwfd9dzd1SwNE8tRLNCmVPzYTV4X4ZfwEysNmdKQuNGmL5m1zAF	7856	11109	11109	1617938820000	canonical
15434	3NKXj4brpzoYkyy6drPCvXc9AdM8n5U45kzMiZ1LXv6HeFuoNDbd	15432	3NKy7UtMhJBXhMFhGwi2gnWrb5mp5AaxHTp6pjo1syGpZgLAcS3s	1483	399	247	6301	11470	jxTUeUAfE9WSfRCGMba4xSHnWb32VW6J8tCKiLaeFkPBGjtrz1V	7861	11117	11117	1617940260000	canonical
15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	641	970	247	6301	11475	jxWaferqm619mBxHMyTWuN8fQBGLzbSvJHW1MWECsVkVKVuJJTG	7863	11121	11121	1617940980000	canonical
15437	3NKk23Pa6D9n5STtKUtgDwAsTTz3GdtEmzkbckkP94Av7RoRycpX	15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	1406	1393	247	6301	11473	jxs58snxoJYXKVukZfsjCNfk3srYXoNag4r8QP2zYutKmre4oki	7863	11121	11121	1617940980000	orphaned
15441	3NLi6gw44rXAvCDovS62QNDzChG9K9pZDPFRoyrdnoy6cu31K4a9	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1447	1099	247	6301	11477	jxvY2fFRzYKUvrNFtAXoM4qAUcse8A8u373oY9DnXrmttURy4Rx	7864	11122	11122	1617941160000	canonical
15443	3NLX5YZJQAAkrZB5jrPBfRJxSeJHSsh5orw5bqYHuvSUXRaBxU2y	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1529	1070	247	6301	11479	jwfVFv7LrgDGLn16zdpmC7LW8de71KHdhwPFWmPCKwQNsTgF9hU	7864	11122	11122	1617941160000	orphaned
15446	3NLBqkTMooxzUVsmh6UJiYzYUEiuNx8Cp2auZaGdHYNv7fT6XPuX	15445	3NKLiDpK29tqabXJ2GBc9Ce3GZDZnngCBYgEJ8mokzxPX9Uui6Cj	1407	1395	247	6301	11482	jwwp6o6Loz6pYk38G6GR2u4LLBGPMNKq7sBrrZLtacoFeFfka5Y	7866	11125	11125	1617941700000	canonical
20885	3NLA3nVadnmp8kCqc2nJrdzQGbSKP2zmVfiLqzgyirGMPdvH6wG1	20762	3NK52JKPChwWqpGu1ecSL3qJNAETShdJQtTvJdKeXPz48LG3g6iq	1627	1259	374	12463	13170	jwEwgRQoBXefJyUgo34xYDFHMuMb927QKZjYBEPMLV8qfieJSYc	10362	14787	14787	1618600860000	orphaned
15386	3NLwCiumnEd8rNyXhPBjUbdTwPZkCNC3MmgTRYGvK5Bs6rb4UxhD	15158	3NKd5uzLu6jbKM8S49J8TrNk6HoVfefrbe3kTmBRgs4ti2PNXh4x	171	1128	242	6301	11424	jxPQRLdFzwpWF6PBgEPbtgBbTt9o4DhZ8ECwNYLQL1pKVTnFuPs	7728	11088	11088	1617935040000	orphaned
15390	3NKDZtSXivG1v8FZ9wAQHr7xK8mjVBNxGrW8of51DKXG2MEFn7PD	15193	3NLNLMPe7ZJPYtpucd75rbYf3fMK3DDAyknFCdJ3Tjm2iuoR7gVa	171	1128	242	6301	11428	jxcJ6EWS2hfLk5MWsvaM4bqVeeHtsUuMfjoRRPdQfEuj77tcTYz	7743	11088	11088	1617935109325	orphaned
15359	3NKMDL8U7DbckmetdYPJaePeoGqzvc396bqNoH9cp3Px1pdaXLYx	15298	3NLfca3Q8vc2uHKaCz5jWVrmQfV1a4zuuSX3iyvZTao2fXgB5UBD	1670	1282	244	6301	11399	jxcmMpyEJ2AdQHLesWQfsFmvBrUbUVkWy77G4xi4LJ2ZPr2vsLC	7797	11071	11071	1617931980000	orphaned
15315	3NKkyXUaV9KgtB8nEnj1D1sHHDyXcJoj7RFKkr2TxLJsufDuw4ye	15314	3NKi69QMXyCrmViawpT1PMcdqXAvSTpdar3YSptQSuPnmAQJSq5P	1553	776	245	6301	11360	jwNxTbptEBJCWdYAgFsPeMxgtyqX74aCfy45gtZyEpBUGVnWBZM	7803	11039	11039	1617926220000	canonical
15320	3NL1TF1vfuErubaMHG9VrVzxvLhkBxsSM2gEtDJS2ioba8zrLRCF	15319	3NL4WPHx7TWRdZgKU3id7b43zQNhwFew8CAAAGsDUAuLkWfM2g8K	1589	1286	245	6301	11365	jxRSEDo2gHP7QGgK9WoBUAi8yD17otLUfmyNU82NcmdSwkjM15n	7807	11044	11044	1617927120000	canonical
15325	3NLRQ6o4rZeV3jqmftpphwqaLDzidMQcdBybBCyNcQ1Lb9m8zoN6	15323	3NKWHy2QpZBtKfaXvnx4aDYU1rnkUsJ6DsAhUQz7thRpQqM2Tx2z	1627	1259	245	6301	11370	jxfwhcm8Z5orduKcDg7ftutCAd9z47tVTwHzRKt6TEhrkV6weCT	7810	11047	11047	1617927660000	canonical
15333	3NLxbJrfL9TgX1NkFZB1hRuMNm3FG22LBg1cg8wg7Zu2an8qpEcv	15331	3NKB8dmXZmR1R66RLY8PK7JPw1tSPTskyE4XzVvhFYVm5eNfkgTt	1440	1131	245	6301	11377	jxvTjvTxp6t1hZwFUf44hag2MCTj2kgzLADkxEhgRxVCGBijycE	7815	11055	11055	1617929100000	canonical
15335	3NKLzS6H9i3GQ3QTvitKq4dhE5ntu8gYJ7DKKQ1iLrER69PUkfMB	15333	3NLxbJrfL9TgX1NkFZB1hRuMNm3FG22LBg1cg8wg7Zu2an8qpEcv	1553	776	245	6301	11379	jwjYaDJUsVMM2zHPPaWm8xzmCEMR21SSLbgy9eR6UVwFAa1B4pd	7816	11056	11056	1617929280000	orphaned
15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	15340	3NKNE8viaHBapSTeCJq9jp7WodirBe3Cruhau8njxFRyJbEca5zi	1622	1356	245	6301	11384	jwVwMdZnoyU3FNmW4PqPDnYht9B8AnQ26GH6WkzUpGvqjktKevU	7819	11063	11063	1617930540000	canonical
15343	3NKtAWzKar68HC4PSam2mSq1NPfqocNQXvL5zriFEgLBkF5TRnyU	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1407	1395	245	6301	11386	jxq6DuSQcGdZDGTRVpJbmuEPiWAShkpRvNHDKMpwJ4JK6oLZky5	7820	11064	11064	1617930720000	orphaned
15350	3NKPL4kDzTXXfNASyVVhpaDFQ6Jt2vjgmZBbf2SjjMLcNNYmxEp5	15349	3NKmxEZviiTTRmKVmUrirGzVbSL9AutsrkvmxegAXvGGUBfdQPnA	532	1177	246	6301	11392	jxCtkQoXHK4CotCUxVp3w71L3wMwiwYxP3ieHGpYQ84NmWh7HQe	7823	11067	11067	1617931260000	orphaned
15352	3NLQUwXHQjsPa33t1CEWtkPawn67mUMkW79YfvNjGtaiMY5PZHbX	15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	1460	647	246	6301	11393	jwHFKjLtMpEsWsrsSF2Tynq7oAiC82tyZ18TXkzmqbvhopk5Erj	7824	11068	11068	1617931440000	orphaned
15363	3NKUux9w2eDmKCk8iwZpqhB8od6Cu8vs1FzEHB1nB9NviAsv4pEt	15351	3NL69sjxf9hLoVhysYkdqny7maNUcuGXeFzqUNwjKuVtqgpzVHRu	1402	796	246	6301	11403	jwYHzhMeSubGCPx1kATb7qB1HHW5EHNoXLnKR2uny1AYpL16NZS	7824	11071	11071	1617932054627	orphaned
15357	3NLppi4GZnA8Rykn5jJt9rYVWjuJWdVyLMWnBPcbKK6eV41MntGg	15353	3NLsZJXiqYSoJpb5XgEEd5e9Q48F9isZcuLJbGHyHH7Z9BA1PKUG	1448	1185	246	6301	11397	jwXjkwbMzqUB5p3LZSmUkAXt79hzvAEbAPU4W8KmUo2wWoQmKXa	7825	11069	11069	1617931620000	orphaned
15361	3NLJwxc7j9BZCRRqReQn7M8tHPMyQw6pUUUfb86yFfNx5a3HFwVz	15358	3NLDEe43mCoCoefD4NhRq2EXPGcCu86oKoMDuJTeKgzwqoCeAkF4	1581	778	246	6301	11401	jwKsjKy8DRnKXTA7bTfkpeYZRS7geZDpFdsQH7NT7nuzDERrVhZ	7827	11071	11071	1617931980000	orphaned
15368	3NKvaXEcr2PaZhHhN2JTYCnhRBhRiGU5sVk6gNUZA4pzx4qtZ3kj	15364	3NKf5a4YWpRpxiPmxZg7xEpZhwrqBnJCeXbDS4gmCFvpsQMzAsae	1607	577	246	6301	11407	jxw5tZV4XGqkcSCb9qyBoBWt7U27nR5VdLgjV86wuygu5sunzp4	7829	11075	11075	1617932700000	orphaned
15388	3NLZoNFaFT5pJir7M4EeqTRMsSTGGhqAwCVZ7tPwasUY2oi8FJZJ	15385	3NKMocygwqf2bBMi9m8wJLivEEbrGXxDmLQnomVs1H9iUWosWPfd	1643	933	246	6301	11426	jwSAn8u9NBDd71Uj4gSGioigpxdocyLprXQHpeXndBXPfmNNjCM	7838	11088	11088	1617935040000	orphaned
15397	3NK7tgRMvmSNd7uSrcp999g8kmQPVtdVw6BgN4iTNnDmqM1VV46t	15392	3NKPY4poNV2qEAcpicaFrHG2n8GhcJ6aPYyW4SNbbgCKANGEGNi8	632	1136	246	6301	11434	jxfoPbn1Vtjz3vuMrKgu4GLagyttq3r3F6coJZ9JUDFvQ2JWW2z	7841	11091	11091	1617935580000	orphaned
15403	3NLTi1SPmixX6A9BFGRMpyNfnfx3fv4ucXHh4L5BGxPu3UeAPoTM	15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	1406	1393	246	6301	11440	jwQkd7QMjso8sN522xeJQ3NbZKYLASaCJwKmxxPxovqontAckWN	7846	11097	11097	1617936660000	canonical
15410	3NLNSmTpZwXLdZVCaQejeZK8wPDDAWko4GJnYxVUq51v1D5DLcBd	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1675	1342	247	6301	11447	jwiavU7Gs7iKS5GFMuBr3CzjVNMzYpLRU3BDXX6iFyaKPb8SCeu	7849	11101	11101	1617937380000	canonical
15408	3NKHKbHdmRftAL5Y3YcPdaH2zdi55DdaT3mhn4kULsTaFj2e9DA9	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1668	1124	247	6301	11445	jxTTxbvzJAD7K5DECBbvvohxFkMsPTRnaxznyfT3uNMuECQgeHP	7849	11101	11101	1617937380000	orphaned
15412	3NLLZdr13fb9EuPTZAGv81QH313EE3C3bn4X9fuKmRUgsbUSWbNX	15411	3NKcywyfsFnhxgtMkmANoXGMN9BvEnYB11KHCshbS4zGcQps4i1V	80	1027	247	6301	11449	jwssdzpuX6pcMT1L4UoYx165wvMPbgj27pBmKPprxsh7xpRqisH	7851	11103	11103	1617937740000	orphaned
15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	15418	3NKty5dYKWugFY5A3RApzGJkDZpXoFHi59wwmew1FrFJczcHonc1	1577	1081	247	6301	11456	jwquDM8wdzPZDJsuhj6zLV53p7YNhpbcRKVuEKyCE4Ggr5o2WUm	7854	11107	11107	1617938460000	canonical
15421	3NLC45tkeqcHG2yHTomt2pu2wRXtyBYMhxmgLxqB3Zqe5wHUrKFX	15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	1501	1360	247	6301	11458	jwrzvu2s5VcniZhwTR8Wo8ugPjq4jbfDuLcmaJ9s83z2AEvDae3	7855	11108	11108	1617938640000	orphaned
15428	3NLmh8pycHbgyfPjJmYitwYr593xSa1Bhu19xTjfwStBVk3xcvPN	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1617	1288	247	6301	11465	jxXtnZSXpvYzQaZH2tHoNNc3wCEzusnSkXuDseeyEtgTqA47MBy	7858	11111	11111	1617939180000	canonical
15426	3NLrvL8i8N5JbGVig4m6PcqwWQRTDPrNJPYR1F5xK9UShSNWezQP	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1403	824	247	6301	11463	jxYLpXPKDbbfvQ3uw2627ij84G4jBU3WkbHdoJbPA9V1k3DR1BJ	7858	11111	11111	1617939180000	orphaned
15430	3NKLQQnMm4xfnuRRoGD92gxFTpbizVyuF1ks4Mmm9ZxukqK8UchC	15428	3NLmh8pycHbgyfPjJmYitwYr593xSa1Bhu19xTjfwStBVk3xcvPN	1426	1118	247	6301	11466	jwgMw3gdma8kLXAB5GDEBTYgfXmpMLgegsAomUk6KLZfdrVFio2	7859	11112	11112	1617939360000	canonical
15436	3NLrwDvAAQDWFHHrCeNKqYeEqCYZ25MDZzz2jfVqnRQHXxiujCGp	15434	3NKXj4brpzoYkyy6drPCvXc9AdM8n5U45kzMiZ1LXv6HeFuoNDbd	1406	1393	247	6301	11472	jwwjRtDtJsa9WJTYPc7NN4jfRbz8AYrmd2Vep4AJsAirZP2qXXL	7862	11119	11119	1617940620000	orphaned
15445	3NKLiDpK29tqabXJ2GBc9Ce3GZDZnngCBYgEJ8mokzxPX9Uui6Cj	15441	3NLi6gw44rXAvCDovS62QNDzChG9K9pZDPFRoyrdnoy6cu31K4a9	1439	913	247	6301	11481	jwbVe9dQFhY9B9P48j2947riD7qj8oWkkXcSE77F6W8WcPiAk3G	7865	11124	11124	1617941520000	canonical
20609	3NKPaVvTdPE2vg1sD6JBPMCvY4TSUzdZA9MpkdKLvpWpmD7uJH2g	20604	3NL7GYCk8tZMEb23DYr97S3zG1GnvDXHuh8B2BhiT2mgtWFRLkuW	532	1177	373	12463	12912	jxfZnqz5jVTCy8hLwEXvBU1W1VckvPyCQ9mtZD5ip6kD7E6kE5k	10365	14611	14611	1618569180000	canonical
15389	3NK4sgxu4LcqXMsvtX9YyQqx3DBZ5PqLv8eTS856t2vBhaNHUe6k	15300	3NKyqs8JSuhtMYodwi4KAF74XNFjnz87qUmJ2PLaYASnkuR3rPgB	1590	934	244	6301	11427	jwtyBHMJJFdw4ZE5jzUFCQUfPFXZdZ7DXKaXHytkLw7frr8Xuex	7798	11088	11088	1617935040000	orphaned
15317	3NL9HdJH1VpHJKoxf9TNZACK55Yx95SsX9zz7xpUEp8SpgzaGihK	15316	3NKNGc67Ggruw9RTeJ4S4xDoUe4mBrHM7VAq1nbaqMFuY7ud1oaH	1578	930	245	6301	11362	jxuRY1KfvCfMvsLyUCKCW3S8ZhdaHeqACYKppy8w8nLEJwfWEwA	7805	11041	11041	1617926580000	orphaned
15319	3NL4WPHx7TWRdZgKU3id7b43zQNhwFew8CAAAGsDUAuLkWfM2g8K	15318	3NKP2Pe8kAo8oZvc38EU893os16Mpj7i7sJgTbJMDrHtQzPXLvD5	1596	1237	245	6301	11364	jwXrUwk9QCchfxLa6T8Fqs8WFAMF132vUMXpzzztp5N37Nw5zSV	7806	11042	11042	1617926760000	canonical
15322	3NLd9bwpwVFnGpUEQjRCfVJGK9eV5B8GSPyPuhdTzJJgQrARWmwi	15321	3NLSjjhSVeTRHz1T2W6Uf7ThLaqmr5wtVQz8e6CojfwHA3Ejvi9P	1522	1322	245	6301	11367	jwjJyp2BmuAQV51Y5cztYbwF3Gh9uj9z6aC1iE6cMH5gmsHSUu7	7809	11046	11046	1617927480000	orphaned
15327	3NLMCuuZ98aSFz5Rep33EFkRm4HiSgkCvQt5HxNL3CHT66byrdFy	15326	3NKjgohK2hUZ5Wd3r5ZwYCwGeoByeXKAVqaAz6JFbFuiWmWRLuXg	1608	1289	245	6301	11372	jwcUermV5gzJvmkbbPg9WgVskAuHowZdoF1xerz1dsSLV9ZjnJz	7812	11049	11049	1617928020000	canonical
15330	3NKuzASHYBXXuMLSUuwuFDyytrGTGWk3faweScP8Fjxk1aTUAC68	15329	3NKgWiZNfv8Hm7KHYD5siSLgHaAcmJQ4DPrhJ5CDCWWJgsNKAA8Y	1448	945	245	6301	11375	jwWJY1bMvc2GUSkYU363c6PUsmVAuDNHPAVW23AvHMkQqjWZVCa	7814	11053	11053	1617928740000	orphaned
15340	3NKNE8viaHBapSTeCJq9jp7WodirBe3Cruhau8njxFRyJbEca5zi	15339	3NL84CVGiyVjJ1i2RTgg1HxrNYxd7GoiShSADXxc1aZqWrj6BAs7	1553	776	245	6301	11383	jwimpZwHmWipJsggDeXMDDUTaxennaLHwpE6DVme5f4qd1Sguaz	7818	11062	11062	1617930360000	canonical
15354	3NLqH2UtmgX1knowmupCtVdaYmzXMcXWdfP7MtjiC3z6tdypEz8C	15339	3NL84CVGiyVjJ1i2RTgg1HxrNYxd7GoiShSADXxc1aZqWrj6BAs7	1448	1185	245	6301	11395	jwkEENVKdFBk4AWZDXPc9e1Vv5Vv1iR285cm3faZ3Ukj3x44Xr3	7818	11069	11069	1617931620000	orphaned
15345	3NKbDk5YvhaTBAdzJg6LXkowFuQLVj57x1s1BwQ1c4uFiucAMMAt	15341	3NL7McykdUJpxFxfaHDEdeMRMuF6D2uXKGFPba4NEtRfDvXFA13D	1623	830	245	6301	11388	jxEsZ3Ud318nHLcp8noE7MVjwxe7pAqTQLEouAJvqtQAUGK1655	7820	11064	11064	1617930720000	orphaned
15347	3NKYYir1zNa9Jt8Z4C5uVH78dHwSA4eD7yjDZBFQUURdLGYPFW78	15344	3NKmoPo26AxkzHzPLiP2x9SA4iNMRSUybRp3xyBQsiBFqiS1JomC	1405	875	245	6301	11390	jwFK3pfx3xPauWQMBzcC6mGKTNtu376vVnfEpekEHhzxk4SarKh	7821	11065	11065	1617930900000	orphaned
15349	3NKmxEZviiTTRmKVmUrirGzVbSL9AutsrkvmxegAXvGGUBfdQPnA	15346	3NK3o2ESeA2DYHQJjKVorwhBu2WmYXjZQzxn5xVBnq5dmX3wvgEC	1542	1058	246	6301	11391	jwRuRS7xwSYG1QvSaRhSwfwnPjbvzUfMq7LkpDRXmXPcRmu9R7g	7822	11066	11066	1617931080000	canonical
15377	3NLMTYhpaFbrR4wNMjK3gx7da2f47KegLBnWXdBhmDFqkGSYKY1k	15350	3NKPL4kDzTXXfNASyVVhpaDFQ6Jt2vjgmZBbf2SjjMLcNNYmxEp5	1513	1379	246	6301	11415	jxLiy89vm9qpCerbQzmRPBJBmfeuByx8dbgX4WEn6Q9Mtqn9NVq	7824	11080	11080	1617933600000	orphaned
15356	3NLxXmvMpYshdZMm6PSCfA4ZkaSaHmv7a6QVJs9j3ZJZCB6mnSVw	15353	3NLsZJXiqYSoJpb5XgEEd5e9Q48F9isZcuLJbGHyHH7Z9BA1PKUG	1448	1185	246	6301	11397	jwRi4F9dXXb3YpXoqdz4CU566vVfTndux9coznAHgUV4mg3UzKr	7825	11069	11069	1617931620000	canonical
15358	3NLDEe43mCoCoefD4NhRq2EXPGcCu86oKoMDuJTeKgzwqoCeAkF4	15356	3NLxXmvMpYshdZMm6PSCfA4ZkaSaHmv7a6QVJs9j3ZJZCB6mnSVw	1637	816	246	6301	11398	jwpYchToJ61LHmCnr9QzEhu6vuta6hPLkDP3MoAMti6JxXZqgwc	7826	11070	11070	1617931800000	canonical
15367	3NKdeextEFD8E3j16jreneWD2LztUP7b8JPPFkpZy8R8CPTV9WXK	15360	3NLXpqak6gBtTBFxEvt9pSdiXk5xxy61svPUceYMyocynQR5oMp9	532	1057	246	6301	11405	jx753dQpsRJWVp5xRS1R8UoGAq6xsjE99pMS9Mu7shESSYnF45A	7828	11073	11073	1617932340000	orphaned
15370	3NK79CyugAMoghxkFpGne8z1g85twAVLkdh5BVvoBiijnbq7hYi9	15369	3NLi78ycS42uXGmThQqN4VMPjxRmxEFn9wtQrEt1LZ17RvFzgPWr	1631	794	246	6301	11409	jwgjehhpno43PssXScFhFTzkK6TijxUeSgCP2rWsUXJsJNCrtRr	7830	11076	11076	1617932880000	canonical
15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	15370	3NK79CyugAMoghxkFpGne8z1g85twAVLkdh5BVvoBiijnbq7hYi9	1577	1081	246	6301	11411	jxV76zKwA52xyNYajFHzmnnHhFSkc7oWX1AvGHFhFCwFqbSF37u	7831	11077	11077	1617933060000	canonical
15374	3NLmrmgGZnXXv1B59TaygRwzq6ezv3ZfGtTB3z2UPJBR6WPRd27j	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	44	1079	246	6301	11413	jxvVYcsn9o3EJMhbpVL9ueivjPAdbA6uNQHMbYurRsCXo98yoth	7832	11078	11078	1617933240000	orphaned
15385	3NKMocygwqf2bBMi9m8wJLivEEbrGXxDmLQnomVs1H9iUWosWPfd	15383	3NKggisTYtqptKiqRgGJNpX1QCtidx8SEymcFeqd8NUVzJMfYUjy	1489	1380	246	6301	11423	jxzB2okUfF6PAHr2qYvCSxjzm6TzxbJQHzJSdQ5ogh6eAEdLoZS	7837	11087	11087	1617934860000	canonical
15387	3NLQvvHZLnkiKNVqr4SZesWSL1xnD7pWcNuwrCqsz7nCGbg9tLy1	15385	3NKMocygwqf2bBMi9m8wJLivEEbrGXxDmLQnomVs1H9iUWosWPfd	210	210	246	6301	11425	jwCporX4NGH3MKZD8t1TP7WUgWtGkY7eKpySzKBSpMCiAHjfc5J	7838	11088	11088	1617935040000	canonical
15396	3NLuURAL6PBo77hQzDoVyZEwsqENiK9AvK8RyrUf8Hy6P1X7nntt	15392	3NKPY4poNV2qEAcpicaFrHG2n8GhcJ6aPYyW4SNbbgCKANGEGNi8	1407	1395	246	6301	11433	jxirpQnHhaCdmqx6yEcdwwCCafyZ76j7fnJsERZm6vExUgTWANY	7841	11091	11091	1617935580000	canonical
15398	3NKQ2uzcSSFvmugLqAMHtb8MYXDFb1PQMJsyEz8xcsHYH2baDZPb	15396	3NLuURAL6PBo77hQzDoVyZEwsqENiK9AvK8RyrUf8Hy6P1X7nntt	1406	1393	246	6301	11435	jwVCQ1kNz9DfFd5Ar4Abj731hvdQKFp9TvBbCEHzPhHMDiASq1z	7842	11092	11092	1617935760000	canonical
15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	15400	3NKkNLVKYN3rbGEg3qsVEdGXkEyftTQpMqX4XDo7Nmxabc6q4375	1602	1369	246	6301	11438	jwxTqyeS76cAXLtWLpTZBKE9z7Ed3hifkDVXvoqL8CwJkEPtPDu	7845	11096	11096	1617936480000	canonical
15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	15405	3NLWaUqfj7jB6CHb8wT3UoNsgUQNyy7dKUvSe4C6EFNrd8M17Xo7	1403	824	247	6301	11443	jwVjcHfKiyYcp6z5tYLipaGR8gMCxowZWe45pLXumMZswmrAiDX	7848	11100	11100	1617937200000	canonical
15409	3NKeqYCipGLd68CBWifTxazEBwXhHRUjkdGuw923yphPZhZqQzQM	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1585	1240	247	6301	11446	jxgxL74PdAYShP2DsuhWmwySnAXxsesRYBci5UgLzkdFhUkQgbN	7849	11101	11101	1617937380000	orphaned
15413	3NKwgkyhsNjSXGqZLBV6vpuh7wCAtcXEe3NGTBhh6HoZkLFRt8dS	15411	3NKcywyfsFnhxgtMkmANoXGMN9BvEnYB11KHCshbS4zGcQps4i1V	596	1306	247	6301	11450	jwKzmJ6twRMjPZXmYXYyr9ihwtrDARMhYWB6mA9HeWLR7Hh1Mif	7851	11103	11103	1617937740000	canonical
15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	15413	3NKwgkyhsNjSXGqZLBV6vpuh7wCAtcXEe3NGTBhh6HoZkLFRt8dS	1406	1393	247	6301	11452	jxxh6xVPxaEnC8iu4UqCfJQrFAHPektBzJYu6SfFXThLzK54u7p	7852	11104	11104	1617937920000	canonical
15420	3NLuXgTY9YntdAk8F1TpkscTn62FCg4Y8LsmbpVMMh2amvmjXT6p	15419	3NLPhnGqLhbTWLekzobDZTgVjp9zSaKhbwTWnbLbfpp6ovT7ax3a	1654	1094	247	6301	11457	jxA2eDpTSincze8JBVNfz272vBEniM3sdxewwCTNTCcSsYRxj6U	7855	11108	11108	1617938640000	orphaned
15427	3NKkxPmRHT2Tzw9JKmLqS7KcjFPBsDGoRtuKGV2UuZyQ9KFnwPrP	15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	1448	1065	247	6301	11464	jwRWu7ewXYy1a5rkDnvVL6Rv9hGz8xQXwNHKvwWbq1nKrj7Nqak	7858	11111	11111	1617939180000	orphaned
21011	3NK74WQFAHxrLNysToXk1mcVAL7vMwsiwVT6o18xUJ4ZVbpvJtH9	20721	3NLxtdH3j71TYwYMkGjpewS8jfQVgFg5dCkZ4Qk9dspkVSidMUtR	1458	1323	375	12463	13282	jwpBYo11geqY8kf5WuRxcK4MhKDk6mAAmvNuBndNcujDD1HoqBg	10383	14876	14876	1618616880000	orphaned
15384	3NKDBAMj6yKyzm2GziW8Eoke1sWawC4raF6tTEmKkwiNgTWQJsac	14993	3NKmQHtqbqDtsAS22EDfXmvLxbFps3nUAJS3dA8vwtxRoQFrB3Gy	171	1374	239	6301	11422	jwYBx1eHmq2KAu7y9B7y43TE7fdaBz2yK7W8fpBShCrSfvfTewx	7639	11086	11086	1617934743913	orphaned
15395	3NKDasDzrVo5ZEi59fJLE7MMqVuggY9o8bFDhiFL7s7QzFzf3XCH	15380	3NLwPQczAE6CrHuff8qHPE7JAAQ4r3RKWzVxnQNcp5rqe8XZvx5L	80	1027	239	6301	11432	jxfyzxwvXARCjGWhBw8jGfXesisz2eEZFhA8kgTu7gdN5c5FS7D	7653	11090	11090	1617935400000	orphaned
15461	3NLZiKdhLxiimGK3qt41FmD74DBvcctPQhdUdoum6p6gH1aF5n94	15304	3NKYEyYthqDijndoNeT2RbteRWzjbX6T8krRQ4vvPMsjq6NoEnwW	1509	1074	244	6301	11495	jwifwAQtuTkYyZa4szkqfUomyNhrxs8SwjPBpTm7irn4SzH6BrU	7785	11135	11135	1617943500000	orphaned
15465	3NKRj198wXbPE599AXc3cZTNxZszHNrStbfQsHJKN4RhgbnjegEr	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	1403	824	245	6301	11499	jxuz79S4yV3LrB1CAoVJNzaZFSwBRqp2CFZZ6rETZBhSByenDbP	7801	11136	11136	1617943748149	orphaned
15376	3NLjWPjTzZZYNiontvbFjL7T69X5qVF68767v4WxN3RoR165XN4u	15372	3NKDGV4XQyQJ3aKGxfeERf4EjiJBjuaJRv34m5dQRJ64DUErQcNy	44	1079	246	6301	11413	jxTyaRQ7ULR85TxDPc6powKqP4zZFx3sJFhiRPXu7wqiTXQRyLw	7832	11078	11078	1617933240000	orphaned
15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	15387	3NLQvvHZLnkiKNVqr4SZesWSL1xnD7pWcNuwrCqsz7nCGbg9tLy1	1546	1093	246	6301	11429	jxzx86RLsWURLEFi4oi9SkzCsT4Tk59i9iQ4CQgEX3h9rEo3XyR	7839	11089	11089	1617935220000	canonical
15493	3NKYPeTAfpPiShW5WrwxiHWorvp1tB7chSDxpwEtgJqcYKXE9oRm	15388	3NLZoNFaFT5pJir7M4EeqTRMsSTGGhqAwCVZ7tPwasUY2oi8FJZJ	171	1374	246	6301	11525	jxKmNJLyNDEu9FeeqDihLhQCRzqoYMUbk6EkrPRc5Y9S5t8j8qG	7839	11152	11152	1617946560000	orphaned
15393	3NL3nuXTmrsLZpYAGA1dqXph1pckkk9J3Uwi5JBzv22fQCpKBnQM	15391	3NKE7bxX8dFMM7J6MKGjKYhWTyDdDC6JVHLKCZXbo51shikHxZxt	1541	1172	246	6301	11431	jwc2twvKLYB2aaajGUXDVj8D2ZFq7f3VHPGzdVsXPwoN3FsNsWs	7840	11090	11090	1617935400000	orphaned
15402	3NKpGCaCWS94N88d2SLtc4NXrR7ZRuGg6mD3Vr9SM9krmDPS8sR9	15401	3NLwFb6kXbkfXzoiKEL1ShyrboswqjqYQN5mfRS1PzsFbhS6c4ZB	1647	1056	246	6301	11439	jxDf4GBcCcjGqHHx8Ua4zeMyH4R5tfB4vFWZfHFDjBbH1iHoo5n	7846	11097	11097	1617936660000	orphaned
15407	3NKvUwitB3rpdQh4cjJCXAE3VyKB5YB4srKe2u9FYZiZLvrV2G2B	15406	3NLp8dn2n3rjVzoszfPqLMetVpNTqsmtQvudN83joYDH47yRMkh9	1476	1005	247	6301	11444	jwtKLyMwVaZGV7jQCnd7GXnghiyGkrXffqh44gLkqLP8i9oLvBK	7849	11101	11101	1617937380000	orphaned
15411	3NKcywyfsFnhxgtMkmANoXGMN9BvEnYB11KHCshbS4zGcQps4i1V	15410	3NLNSmTpZwXLdZVCaQejeZK8wPDDAWko4GJnYxVUq51v1D5DLcBd	1407	1395	247	6301	11448	jwpKzSCAn4EhsdS2bVy6yahNHxu5xoB8Srf84fAPbosbs7BZ5Yi	7850	11102	11102	1617937560000	canonical
15418	3NKty5dYKWugFY5A3RApzGJkDZpXoFHi59wwmew1FrFJczcHonc1	15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	1481	790	247	6301	11455	jwS22xtQm7gtqaHQwvxv2bSFYA1hQd8Fk4QZyfhDG5zL5n2skNH	7853	11105	11105	1617938100000	canonical
15416	3NKkV61TAwQUAEYhMbdUpVPd7BCCakHukyZuYQBWDAqyuRd8JL7L	15415	3NLhPhTa9mZ7TTv9Q5xbkB3pLDUFVaSBrWWCoy8t6tycvkktDMjL	1406	1393	247	6301	11453	jwfULJZBWrHFjCG6ox9Dc12Qnz586HtqCQfBE5fKQ5Sz7uaCRkn	7853	11105	11105	1617938100000	orphaned
15423	3NKtz1NS5EMAyrUtbGm1WHHEh5DnBvHhWZauAvzQMgQECA9u4Nqy	15422	3NKj1EEA7jd9AnZkmwjZDhXuxmY5voUudYHXLUxv69SDxCiWq2sL	1602	1243	247	6301	11460	jwqvDxxsPgDKygr4VuxpjqrDx4HTyUypUy3rYAHSbgzszFTUKAp	7856	11109	11109	1617938820000	orphaned
15425	3NLaCkPLvGcW6LkG5wR8quodAnYphemjW1w2gq6yYBNzVQ7DL5vh	15424	3NK73UNqdxtPBcBRot8id4dDvBebTqV8h3FVJDU8mvn4KgEZ8JwX	1637	816	247	6301	11462	jwQSTcAthZ54tpnFod4nwZbKTzSXykgLk5sQpcTmZn8c35csLbA	7857	11110	11110	1617939000000	canonical
15431	3NKkU2ReyUYMBDarf6E21kpTH3Vy3MzNMHitaKWguYV8ux8xcGKY	15428	3NLmh8pycHbgyfPjJmYitwYr593xSa1Bhu19xTjfwStBVk3xcvPN	1406	1393	247	6301	11467	jwzah7WPhBp3sKvLBskacdmZFuCpoC6qSowHhR7QwuoMnuUb7wB	7859	11112	11112	1617939360000	orphaned
15432	3NKy7UtMhJBXhMFhGwi2gnWrb5mp5AaxHTp6pjo1syGpZgLAcS3s	15430	3NKLQQnMm4xfnuRRoGD92gxFTpbizVyuF1ks4Mmm9ZxukqK8UchC	1407	1395	247	6301	11468	jxUvD3YMog7NhhmRXUegpc5BNaC3HFWqxTrKjvF4hsCKWKpN7ov	7860	11115	11115	1617939900000	canonical
15433	3NLcvk1oWcfMhXAowNohd3kTi7Kye7uW66BZghANfYJNwwv1uAve	15430	3NKLQQnMm4xfnuRRoGD92gxFTpbizVyuF1ks4Mmm9ZxukqK8UchC	1581	778	247	6301	11469	jx5K7UDAjz1Nyj4HWy8DmX7aYKCV1ZEm4dhHMomc2C9AUBn6nhr	7860	11115	11115	1617939900000	orphaned
15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	15434	3NKXj4brpzoYkyy6drPCvXc9AdM8n5U45kzMiZ1LXv6HeFuoNDbd	1403	824	247	6301	11471	jwtdKoNC8NrfNQhLWStHLKcMF4T6zDhENwZ8X5XpqJCMgHghnBR	7862	11119	11119	1617940620000	canonical
15438	3NKVfQL35ihAzA3V4ynkuWBeBwYopKcHqionMDKJ6QCCntF2MEDe	15435	3NLZxWWGPcnZdpfJScbkPmRewQyv5T7oHRNCd7k8Abnd5DojeB3u	606	1295	247	6301	11474	jwemZuMapKWrKaJJ8DRkLMRWftN3PR2Vymv6Hta8gJXsthQ8iib	7863	11121	11121	1617940980000	orphaned
15447	3NLyS1QKL4mo6bCNhvLrdQmjRemVQAtqNeq53UFEasDJDpDPd21K	15446	3NLBqkTMooxzUVsmh6UJiYzYUEiuNx8Cp2auZaGdHYNv7fT6XPuX	1406	1393	247	6301	11483	jwDgQp1i6BU1cPCLdaHPdcE2x2hpSCyUAs53X54JB2qgdqq3Re2	7867	11128	11128	1617942240000	canonical
15452	3NKx6npQKVGrZk5cpPkMtbK1rsYNww5y5ynXKWCZMg1P6XFGsmfD	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1668	1370	248	6301	11488	jy1SzpkPVAodz4fXEXzRfFydY6tGJ2QWijaBsE6dJghKvNhFcQd	7870	11132	11132	1617942960000	orphaned
15454	3NLMAW4XV6XfFizBkBraEQeByiiDGW8QbnNbY8JsWRW3UEs3koAY	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1668	1370	248	6301	11488	jy1SzpkPVAodz4fXEXzRfFydY6tGJ2QWijaBsE6dJghKvNhFcQd	7870	11132	11132	1617942960000	orphaned
15459	3NKjHK6Nym4eCwZiKFEqJbpC2yufQ6YMPa8SSt3LxoSyFAVghZiX	15458	3NLmiTBiAssGpK2VDqQmQ5qUeNuwWSz1SETyCJzpoNGZbGrNeoJY	1509	1074	248	6301	11493	jwiSx7RrG8tu5xJ3jdXmGvLzutukwsrEGatU69gF1GWFckK2WJM	7873	11135	11135	1617943500000	orphaned
15463	3NLCpjP2gg7jkaoFyQ7FCm3HgQdhaD8fpGiUqsXRUEonJwWp2MDW	15460	3NLbCYSEK9Z9X8R34hUAQGNLDHChVdCinMW11roZRxkfMEW6ViSt	1573	1318	248	6301	11497	jxBnmc89ND4g4aCChdpVzib9U4FDZtgv8R3aZDYgGw8tYhZzbMR	7874	11136	11136	1617943680000	orphaned
15468	3NL1MtoWHiaKYvuPAJQiz3t51QHAH1TUbG9cb1mbnEGCHqDPirim	15467	3NLJfFBJPgYpG2Fx6kCBu4F715ydH3kSdSKGgTaiNKfortkMXi65	1407	1395	248	6301	11502	jwB8WZ3TuxqayDjDpn4Kf5g6XhGsscYzVQyiDPkdhTJ8A4BSRwd	7876	11139	11139	1617944220000	orphaned
15470	3NKMVCA5w8oUFcT5rhotXY3Z6sdydPcSo5dFyfQG2Aq7eYvNCgSk	15469	3NL3DRvGShxbeC1Hun5otuNxRos3EkoTm116dMieYkYQVoopH9yh	1406	1393	248	6301	11504	jxTJvhhZFarQYZrErAFPaZ9oB7M28CNQfrBqiS31GucF3qCWNZ1	7877	11140	11140	1617944400000	canonical
15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	15472	3NKyyXd9oGfUTjAFiEWNrV67L748fJxo7rhuWDQnNs6VZdy2kJW4	1623	830	248	6301	11509	jwasfRZNxitRUYk2hTEV1a8vmfV1rkFc1zeZMd2yJYuPvadAS8k	7880	11144	11144	1617945120000	canonical
15482	3NLAmzi2u4yDj9au6jtt3pKsuAezzgbLp3c8oY3VGGqD2ktagd6y	15481	3NLQjsbt3c5AL1SfNGkUsBz2pTo5qqVsDU2aPuQYVvpn7jMh8MhB	1444	1255	248	6301	11514	jwXDH1qvhB1t1uqkHL4qbNFa38v3TLyJWddJs35km1BjrpcSVfn	7882	11147	11147	1617945660000	canonical
20679	3NLDpGV3Vmqi85zSCAAzm1cwR6Todjqthbsg3UdktkpLSyCtRFiB	20675	3NK6foP9YW1x4WDHLcrvWQcCZzH3gRCJ7zPRgDQuu8YoKDCQ4mcu	1456	244	375	12463	12980	jw9tY1y6Xx2BzqAgoX3nH1YgXFtK2cztBa1CxPA1f6cqv38EaVo	10401	14663	14663	1618578540000	canonical
22666	3NKAcxnQMfVeRVAspSUb94h19kkHTnSvet3VxKEvCqsf31hmz6L8	22213	3NLLZ2K2GGr53xKBbi6CUYiL5bUH29dNMBR2XyskwCDuwkKijnKi	1637	816	410	12463	14750	jxerRiZ9eDsKxggYpY9NoNdFk7VemP6UJMCfJWGRQzHxgYLEPhD	11121	15954	15954	1618811017854	orphaned
15520	3NKkjvtgmJwEPDuLpEcQP8iLJeDQEYQyXhfHv9mZRiyoG8jrwTs6	15389	3NK4sgxu4LcqXMsvtX9YyQqx3DBZ5PqLv8eTS856t2vBhaNHUe6k	1670	1156	244	6301	11548	jxvxmmuwcrHiNRpxdfkkXJ1L26UXhWugJ1Z3pWKDiCyfyHpLhLG	7799	11171	11171	1617949980000	orphaned
15440	3NKpGGyxA4ZmaFjttKYKBLiWCWB51sdHqWCFq1QQNW2EPKubZyRF	15424	3NK73UNqdxtPBcBRot8id4dDvBebTqV8h3FVJDU8mvn4KgEZ8JwX	606	1295	247	6301	11476	jxZFBmqt8skdy5MQsjQR2o1ER8nN2Jh45NT9B24Sqasn7ZPmUk6	7857	11121	11121	1617940980000	orphaned
15442	3NL8WaaFGVvfchPiEWzLyR3h1gX6FLDUcG5CToAzJEA9qrwsAMHB	15439	3NKrsq8eBb9bcKUsh37mqXAnnex1Qy3eo28vpscMpBa1UJqgEDik	1407	1395	247	6301	11478	jwTiCCNNGBNqPCp1sdrNatR4VrRWSg9JX36mgSHGyK9mKdcxdiV	7864	11122	11122	1617941160000	orphaned
15448	3NLcgsWr4Ai8vVQZe9sRWdH5E57CqvFBM97Mu6dNKqbDyhLewYDZ	15447	3NLyS1QKL4mo6bCNhvLrdQmjRemVQAtqNeq53UFEasDJDpDPd21K	1439	1033	247	6301	11484	jw73Q6got84nU7uREXzzvtjqxu66pDiNS6dJSp7G2GxDtQM5HUX	7868	11129	11129	1617942420000	orphaned
15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	15449	3NLiWUZxyAwFa8SXN8iNKwcQSRto7KrPC6ZywF9ButYK37owBLkZ	448	1305	247	6301	11486	jwnyTuE1yEkMf8qpt7YJSxts28XP9fgY3n3K9PdnotRgKwHqBaL	7869	11130	11130	1617942600000	canonical
15457	3NLZQ7Ncz7wnKomtL2wvZ91LhwM5PP5SdLeW5cvwM8EkyokcYUVC	15453	3NLBste8fUsVefM1yHPK4F3z99wFpfhYrJPCGspLHxnGdMQ5cbMo	1439	1279	248	6301	11491	jwT2YFjTiqQEEY3xfVLWg7Vwk1ftFFrFURd4bGR4GFUZrN26d97	7871	11133	11133	1617943140000	canonical
15460	3NLbCYSEK9Z9X8R34hUAQGNLDHChVdCinMW11roZRxkfMEW6ViSt	15458	3NLmiTBiAssGpK2VDqQmQ5qUeNuwWSz1SETyCJzpoNGZbGrNeoJY	1593	1220	248	6301	11494	jx7cdyZPFWaYDfDibvAXUejrNTLrMYbT1VP9TPseZk7u27WSHyU	7873	11135	11135	1617943500000	canonical
15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	15470	3NKMVCA5w8oUFcT5rhotXY3Z6sdydPcSo5dFyfQG2Aq7eYvNCgSk	1549	1362	248	6301	11505	jxozJ9unot314mbZ1mVYK9XVB8SLZ1BBtJQvQwS2qrhsjqRbwDG	7878	11141	11141	1617944580000	canonical
15473	3NKMJb9RpaULsNRbDNoUHpe7CJG2K8fEbWbUJZxSHqQUrYs8nrQA	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1527	1047	248	6301	11506	jwMwA3rDceKiBCc2iUuSnNyZ3Uc56qnGQr4uFrDPqyEYmgAyQTY	7879	11142	11142	1617944760000	orphaned
15478	3NLXLwFHynX4YAuhrZbzb27kBcJgntS9uHLGWQqdRdGMTFqb6wui	15472	3NKyyXd9oGfUTjAFiEWNrV67L748fJxo7rhuWDQnNs6VZdy2kJW4	1406	1393	248	6301	11510	jxsu9mq511J52WoKVWZKHpyKrzRSVxM7kAuRZ3LTBQpzWQHwGUG	7880	11144	11144	1617945120000	orphaned
15480	3NLVTCJziaYMigVfkewGAn8LcJwbtyR5pD4HoDTdrDbddowzMKCs	15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	1406	1393	248	6301	11512	jxQH7Jj5JQUwvVvC2fy8pYoSPTA74mdfoCsPHjnnpn1o4mkBRz9	7881	11146	11146	1617945480000	orphaned
15498	3NKoFDVLXa3samJ89T4FoimMY8MqaerA4oy8kMhwq81XNtv3jfyx	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	1643	1173	248	6301	11530	jwuKZn6x9uLDQqwww6k365uvgPitiP9i97ZUYuA4TtoYPnRknWP	7884	11156	11156	1617947280000	orphaned
15485	3NKHVNNeoKjicZBkL148aLmveVqjYseNv2q3JKrBYzoDjofu7f7k	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	58	1281	248	6301	11517	jwd3d7dBjRdiyY8witeUf6TR18eQoutH2WMuZNSMsSGnVq1jc3B	7884	11149	11149	1617946020000	orphaned
15489	3NLVjybCtLEHw2ypx6BRcgmwUiUruP6WKbopvBe4rEa6FgvWcSWZ	15484	3NLZ7fhphCnDe7t95cPQqi6VKUgBkzyhiPW3gPC2wZEq7CGqaASu	369	1312	248	6301	11521	jxBoJqkwqgBysnwqEQtWVjSEykKZseakVjawXLtyYYKiES3aguj	7885	11150	11150	1617946200000	canonical
15497	3NKUNFMYLMUKvF5WGj6NJyf6zsNCs6HPKR9q3P6uz6KqfQxHLWoZ	15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	1405	889	248	6301	11529	jwxfgNtVpx2mqWp6hcwijDG3oaWrzHc4Ewr5kGi5VHT1Jqmyp4m	7887	11155	11155	1617947100000	orphaned
15500	3NKnf9komnuKHvN3FvoCtnmux6Nsapnc38zi9TVVjgVBoQg5UPDy	15495	3NKQGnL6dDQcHLAj4ju9KehqwLtFL6nmbcCvchtSTTJ3x9x51Dvb	1637	816	248	6301	11532	jwve1w8gZm1m6GJD8YaaHv11L5seB8i1kxm5aWsrngiVzBnf4Pb	7888	11156	11156	1617947280000	canonical
15510	3NLqsRNqcujzK3v7zWphZ6GYjvxos92kvRkFQcUYek5qfeoaTNkU	15509	3NLCKa8Fj8cZF2ZFSkdg2GWEpTNtoNdxHjRyy67AhE7Y5UrgJUVJ	1590	1300	248	6301	11540	jwEJorj7Fv8smGVmzAMaseUdQ9mDTXGRuHVrLcPaWeWZH72S5Wk	7893	11163	11163	1617948540000	orphaned
15512	3NKpXUhvjEToVZtieDKFrooDSJnjoXXiCHgRTKBLM1MEN72jvV5n	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	1483	1276	248	6301	11542	jwECMatyJknh6aF6YLyMiA1dStsXamBS4g9C5EByo2utM8HcXy6	7894	11164	11164	1617948720000	orphaned
15514	3NKDFSHWaKGMTYxop7UZWQ4yd4hdeUSVkW27fWgnosuBxedL2MBw	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	470	1309	248	6301	11543	jwA8oZirtqEBU4vYP9b8UG7WHEw49rZ9WA5gavcnQfRkdt1rkKT	7894	11164	11164	1617948720000	orphaned
15517	3NL3a5qhMNpTwV2cJVuQETcSrHELTY1YVkdCdhd1qrF5CtaJiUhP	15516	3NKTxsQ9BXMnFgAncUz9pgoHHzPKWCfrNUYqRSPDWNGURUhvGGfh	448	1305	249	6301	11545	jxgyjStQxY2BT4J7DaxiEoCDrD33knM61SEZ6oECWJf9zr97b6J	7896	11167	11167	1617949260000	canonical
15532	3NLogBPb5FVkerp6sbaQ6P311U3fkaTozUqDhFRpCEoK6yqUW6Yw	15529	3NLgsX74vMcuNbymd7cdQrk8mYN4Woh2C6WXaYcrh1h6Ly9KiBkL	641	1210	249	6301	11560	jx6Vsux4KapZ3YUvTV54aBKkjaZsMLBAMPLAcE8f8hucrFNLRWs	7904	11179	11179	1617951420000	orphaned
15562	3NKWX6rZ7tfcnN3o2oixRJiEx3bNWwwaP8DGczxUyLbgRSaPMNEx	15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	1483	1030	249	6301	11589	jxcPedSetgbK7LVV4Q4YtBNTLKobQHwQooDsgcMG2Y2GT611aNu	7905	11211	11211	1617957180000	orphaned
15537	3NLT9CUM4n3u1ZHU9UPytusZ2aX6jYhkfk6pK75bZpPWQ9ULp4dh	15536	3NLk9UHXSMZnBtuXLkpitXng2QaW7mM8Mv9MCYuiaMD3AP5HxjP5	1406	1393	249	6301	11564	jxidgmrfYWnbBQN6E68WTX5zQpzWhBGgaePGjNbd9RAHaQTj64K	7907	11184	11184	1617952320000	canonical
15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	15539	3NKvvoACrXQVAewubwhrtzXTSDhtuVVjChWwQuAfPgYYfcmJAdTA	1451	1166	249	6301	11567	jx1GVbsp4DcxxEmxe8UGFhYfJb2ygC8y1vZxrZEsy2BHhBHoGgu	7910	11188	11188	1617953040000	canonical
15545	3NKTgJxmcj5wCmBWzxQKPZh8vRQEpA5DE2u2G7SifzRHUUSjZDzR	15543	3NLhZiMCSzRetndFVFD4yWRYokzjB21Tz5xePEwXaj11fwbYCDrz	1634	1085	249	6301	11572	jxi69FuQ5kkK99iQsHbkw9yvAHFy79BhaXwqDkpm7ydWy46q5SV	7912	11191	11191	1617953580000	canonical
15546	3NKcMjYBzJBHo2bWT9xs4VKYGudh5zjMRzWE9MqAnmGaBMMuT7e6	15545	3NKTgJxmcj5wCmBWzxQKPZh8vRQEpA5DE2u2G7SifzRHUUSjZDzR	1585	1240	249	6301	11573	jxMXMfjyxS7zDRpAEdmDCPLub3z2ByfxtvHFRW6mY7gqf1gjYAf	7913	11195	11195	1617954300000	canonical
15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	15552	3NLBiG1S8sHxk1nnvw7YtVkVCaSN8emd4hfyMoyrVMLLCP2binaK	1579	1389	250	6301	11581	jwn3g4umvyuxQp1UqQcQMXGN9ioaN8TUYEdTmxLH2JvmPqidnWN	7918	11204	11204	1617955920000	canonical
15567	3NKvMsfB7XqktmL6EjLKUbXSbjxwxy76SB9MURnE31sETisFxi3F	15566	3NLYmZJ77Dx1MBcjZien2BJgkbr4zwxxSES5Qo2g9zKvCjNMtgV5	1613	1349	250	6301	11594	jwfqmmr8aq9KYuYJX14uUuwjb76zxZAoeWZprKEYsXD8QR2xGL7	7923	11215	11215	1617957900000	canonical
20687	3NKtV6a8cEUDoNpxdmu7LRcqSp2NThTMhZgp2m9BbQAdV9mt6xU1	20685	3NKpot9tztVAPA93ri3WxmRDT7AKknABUDxuCFCMNAoDzsyDumZL	162	162	375	12463	12988	jwnkCBXmyHxtKpMGstEAhkpVRctXQNHi53JF31AYwAQZaJjLdxo	10404	14666	14666	1618579080000	orphaned
15490	3NLgsfGjJFpJwff12rLZro8EjK87q2XY9dDeovBStDxqBW6VDX4v	15288	3NK6k3LfpaEtvc1k1eAeVnLQMDayzuZijfdZYjgTRGKtwX4JtZdg	369	1312	244	6301	11522	jx8zCDDcv6KneRAWFDpXDPEnh9LYhq1KqKdxxEinVUTaQBEL2oS	7790	11150	11150	1617946237203	orphaned
15535	3NLZ2DzvUK81yFdWDptMSc7tbpnujyhjs8VZ5nM2twW4DKxbtzeG	15520	3NKkjvtgmJwEPDuLpEcQP8iLJeDQEYQyXhfHv9mZRiyoG8jrwTs6	1670	1282	244	6301	11562	jwQTHbiqx8pG2MMKQFjVnYepC3puuj4zGujNBR8Qo6XCFJCjJvK	7800	11182	11182	1617951960000	orphaned
15491	3NKpNc3XPwWrAgucvzuJY661AKcSBFYTyNkD1p6qfVRS2aNygEN9	15310	3NLPZtZCsRynTZHwmSXhZgp54xYAbR1MAv4FqMy8Hx2gwS4kjmEM	369	1312	245	6301	11523	jwe9vSJqrwjBKQ5QSUmcoUp5NVHv778Xk8MCMHwieKJdWPiFFjk	7801	11150	11150	1617946273208	orphaned
15492	3NLNVyEwA273kygnTv8BojXBnabr7uVYmURXsxLqPzwNHmQgETFn	15327	3NLMCuuZ98aSFz5Rep33EFkRm4HiSgkCvQt5HxNL3CHT66byrdFy	369	1312	245	6301	11524	jwEwVZW6ib5NoycZsAUma3LgspiodZmfJ4nZckjMwDwiVSJAehw	7813	11150	11150	1617946311294	orphaned
15451	3NKRCbah1XxLXhY6trheaeyP9A24mXNUNvjyBP9T6EGPSUXscoLo	15449	3NLiWUZxyAwFa8SXN8iNKwcQSRto7KrPC6ZywF9ButYK37owBLkZ	1406	1393	247	6301	11487	jwVeDAn2CWd4uhawcvL2Dr26KFpc9YsztTaJzyeYsmxATSXKqUu	7869	11130	11130	1617942600000	orphaned
15456	3NLxB17TSFNvZkT1byE1aYAj4rGL7rw8rsJxRCHpCdtzGCupeuGV	15453	3NLBste8fUsVefM1yHPK4F3z99wFpfhYrJPCGspLHxnGdMQ5cbMo	1490	908	248	6301	11490	jxCYvcPuoXBSzNxqqEGtzwbGxrscjnuhCDbAw2c6wtDCUAJycVd	7871	11133	11133	1617943140000	orphaned
15458	3NLmiTBiAssGpK2VDqQmQ5qUeNuwWSz1SETyCJzpoNGZbGrNeoJY	15457	3NLZQ7Ncz7wnKomtL2wvZ91LhwM5PP5SdLeW5cvwM8EkyokcYUVC	1546	1339	248	6301	11492	jx8jcNMyRUWxya3Vq5rD81XKjsWUZoNECWyxJ2djE9vZby8n7Fd	7872	11134	11134	1617943320000	canonical
15467	3NLJfFBJPgYpG2Fx6kCBu4F715ydH3kSdSKGgTaiNKfortkMXi65	15462	3NKvwGbBmQXiKi7Q3rLm1QFjoSCKN1copCjhA97fujQopZ1ibqUE	1589	1286	248	6301	11501	jwEkCUzqgrsKW8EpUgKq4gvU9eScauyoN7vThG2abN9vZGHmvqt	7875	11138	11138	1617944040000	canonical
15476	3NKhKRmgu9JF3SzxcugEEivYgtHCvALDLPz4n46iQgcZrzMEHZRn	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1406	1393	248	6301	11508	jwA45et14eHFiNDFofv7GQ2QJZM7Xk37sXwGskbXnjzHhXKCPqD	7879	11142	11142	1617944760000	orphaned
15481	3NLQjsbt3c5AL1SfNGkUsBz2pTo5qqVsDU2aPuQYVvpn7jMh8MhB	15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	641	1090	248	6301	11513	jxGdgutVeuA9WyKj28SdbsKqiJFxuY5ERo2R6RHW1i9arbnWdJT	7881	11146	11146	1617945480000	canonical
15479	3NKFkmL1Ai6WoDyoLReqZ8qN9cY6xJCGtMMpzU8kBxcSn18tQ6uU	15477	3NLNarBriS7nAmKbPiHTMcQSwL6bLTjfxmVK42ExRxYVBH8Sw7H8	1457	1145	248	6301	11511	jxTKPdz8qhCgjYWfeBUrfBW81idBZrVQHMVTvNRDtHjzFAe1CaD	7881	11146	11146	1617945480000	orphaned
15484	3NLZ7fhphCnDe7t95cPQqi6VKUgBkzyhiPW3gPC2wZEq7CGqaASu	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	1407	1395	248	6301	11516	jwxbUp8MArBufVTNxGXGMUu95uEsqLiU87ekxL32dGmW1HSE6pq	7884	11149	11149	1617946020000	canonical
15496	3NLg1wt56rA87BGNinE1n87ZvqiJvLZ7YeXpyPaqeLvJPn4Y94wN	15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	1634	1205	248	6301	11528	jwHkFriNptAFf3Hzp1KbrQyKtSkXQJmrcmqitPzhEZFHvQC74x5	7887	11155	11155	1617947100000	orphaned
15499	3NL7GYCbnbFaZccZSQtdNjTyywdNC3XAQUnagAFUgah4LEnpEPji	15495	3NKQGnL6dDQcHLAj4ju9KehqwLtFL6nmbcCvchtSTTJ3x9x51Dvb	1516	1294	248	6301	11531	jxrzDpdpBwkS3yFGBTUC4PEbsiZbomyWyZz7ZcUtTnXWMJa2Fo1	7888	11156	11156	1617947280000	orphaned
15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	15500	3NKnf9komnuKHvN3FvoCtnmux6Nsapnc38zi9TVVjgVBoQg5UPDy	1405	849	248	6301	11533	jx8FAEupSEoQLQoGnqGkLLuGkCMjsjRSVwGaWxrATxBNkbCpwhS	7889	11157	11157	1617947460000	canonical
15502	3NKq6K9jv6yCrEP9EhaXBtF8U9K2FNDTr3BgNVz3gm5Jme1mL3TS	15500	3NKnf9komnuKHvN3FvoCtnmux6Nsapnc38zi9TVVjgVBoQg5UPDy	1553	776	248	6301	11534	jxpfxbGW8yptuWJaLC6f42x3erhmTJ5q47dgayCXwiHg8G7t9Br	7889	11157	11157	1617947460000	orphaned
15503	3NLNboMMNNYanmZzy6FocjtyYFr82GdmmokrqbY4SbYTMSGSAPTB	15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	1634	1331	248	6301	11535	jwjd4vUoXWgCmRXXZRGMWeAt3PG3momSEnhzyxCGRnxoehjA37L	7890	11158	11158	1617947640000	canonical
15505	3NLqBu2WKHLYRA1FMvVcD28tbqtf9T9dLth7B3X3ncXtV8YcBpDN	15501	3NLR1UkghYJJB2zYm2pTqGcpWP2pNpDbetH7NpNt9sBD7FHdizRQ	1527	927	248	6301	11537	jw7MNaiWc3mztThDMjJ4dvCS7Z3zWyfCziksv8RFASiCuadvDZw	7890	11162	11162	1617948360000	orphaned
15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	15503	3NLNboMMNNYanmZzy6FocjtyYFr82GdmmokrqbY4SbYTMSGSAPTB	1483	569	248	6301	11536	jxuLYPjUJ35dKQPELEKPMXtSe93P4uSgVr3jXCnBzX68yYJd3rM	7891	11161	11161	1617948180000	canonical
15509	3NLCKa8Fj8cZF2ZFSkdg2GWEpTNtoNdxHjRyy67AhE7Y5UrgJUVJ	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1560	925	248	6301	11539	jwtegXuzQ6z7RAsCZjE5qjWXPKbj5Sr3mgbwWLrLKyY2JZAgVf4	7892	11162	11162	1617948360000	canonical
15506	3NKewNUeRz8fBFzi9Btv1Vn7QyM8zK1bui12PY7CR15nFtpQcB2e	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1527	927	248	6301	11538	jwHxHKMHmCZS93w7rjVZuC6BgTbpiro7pigzQTamx9TQu1NeVBQ	7892	11162	11162	1617948385602	orphaned
15515	3NL2nsfGfmWdGJq95r9gJ237BMQ7od1gESk8HNHXJ848jQ7CL1kD	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	1483	1276	248	6301	11542	jwpPPr3e8p6HyZpWphsUeEXfuFDnWSFFJAx27ebMV7TvFytarA9	7894	11164	11164	1617948720000	canonical
15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	15519	3NLE7RvwSrKmXvwNXLPk7zzXMG8srXUjs7QuKwPQXKDauZaSppN9	1670	1156	249	6301	11549	jwcBBv9CifiqzPBP1byppEGdq3HCoxkPfJRDrEfJCWX84yrm8xA	7899	11171	11171	1617949980000	canonical
15523	3NKrShmhWYAmDWuiNiqMUz47pDpTBSs6xCg9QBAMSjxRYmbVJTfT	15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	1608	1289	249	6301	11551	jxfSHsisdP7iDesbsw1qpMqTW2A3kUcAzon9QJZJe4cxLed81dY	7900	11173	11173	1617950340000	orphaned
15525	3NKSz6CCsvF84fQw9rN3MoCRN3Hc8KzBJFJxuiiipgg1rRwMJ1Fn	15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	1549	1362	249	6301	11553	jxgyuh9bJFByWgiKK6kqrXHumbQXhJcXyis3u6vxQF1YFZTuJbU	7901	11174	11174	1617950520000	canonical
15527	3NKhv97EPJ68DoCVNyt7F3B7uksdLYTb36BubG3dNfY9UAN2sia2	15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	1631	793	249	6301	11555	jxaVYhjYp12FBoqhBgxv3B91iTgmsqB1hBZwrFPcXogzivN95hY	7901	11174	11174	1617950520000	orphaned
15530	3NL9CiNBFeTw1gdLdTxuoFWAdrtJVADaC2VupHuqpg8UaW9V1AwD	15528	3NKwt6vaz4k7HQFMCw7XPELJvhYGY8B21gyWguJnDvEaBYeRHSju	1419	814	249	6301	11558	jwSoqU9peEbHha5HPxCtwCrz3ufrT9JV6MHcoNp3YYj1dUoFgQx	7903	11178	11178	1617951240000	orphaned
15533	3NL9thkbvHqSVmaBzdhathveJt14k8Ua7b16CnefPBL1ThYkH3Es	15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	1610	1068	249	6301	11561	jx7pxjqJrY2TPB6W1EbNg4uYsEwDFG3dogkJKWDw8oV7Uagnjfm	7905	11181	11181	1617951780000	canonical
15538	3NKeTsySP8JtuBG61MaoXqe9on9V3in4tbpwQsxrSfmTRy8HCV8a	15537	3NLT9CUM4n3u1ZHU9UPytusZ2aX6jYhkfk6pK75bZpPWQ9ULp4dh	632	1382	249	6301	11565	jwWvXr38Jwy23VEJFiyjtyUZRFeJXKBjGR4CA1MGWR3va3Foko1	7908	11185	11185	1617952500000	canonical
20697	3NLAo8TXwZKvwz8u7ZmkoEAWDXXvZss6uVved18KvpPijhz36Sn2	20693	3NKa8BkFgpGXi1q7pE6VA3XtxwY1oenGzmgMZSpAepJwpQWC45xq	1654	1214	375	12463	12997	jxraXTdwxwnGJfrkTyJbRk5AiFodNsV8X93dKvAfg7wrfBSpqtd	10409	14672	14672	1618580160000	orphaned
15559	3NKvmoNKFsKTiHYb1dHGvNNtTUzB2vzHoo7dws4uSqPasA1uG6Ez	15398	3NKQ2uzcSSFvmugLqAMHtb8MYXDFb1PQMJsyEz8xcsHYH2baDZPb	1507	1280	246	6301	11586	jwCyVJ9zQnD8t9eKZxGzNL1ebwWyXrJhDfXicNN5Swvvw9b3Sut	7843	11209	11209	1617956820000	orphaned
15453	3NLBste8fUsVefM1yHPK4F3z99wFpfhYrJPCGspLHxnGdMQ5cbMo	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1407	1395	248	6301	11489	jwHdjehXkMgtzbSZ2RdcXSpXopUpTCSo5LDtxE1XfdoJbYNEFFv	7870	11132	11132	1617942960000	canonical
15455	3NKZDEXrV7iep3z15Q8Df9jntkCFQN3hy28exn6ex7e9ShVsdDrL	15450	3NK5jG41X9c88aMCodu6tFSnMfMRyGwJnNr8TJcdAKcdaVqNrA8Y	1668	1370	248	6301	11488	jy1SzpkPVAodz4fXEXzRfFydY6tGJ2QWijaBsE6dJghKvNhFcQd	7870	11132	11132	1617942960000	orphaned
15462	3NKvwGbBmQXiKi7Q3rLm1QFjoSCKN1copCjhA97fujQopZ1ibqUE	15460	3NLbCYSEK9Z9X8R34hUAQGNLDHChVdCinMW11roZRxkfMEW6ViSt	1407	1395	248	6301	11496	jxHy6ixto4qS5qUpR4aKhTGJjJLYaCYDDuXCuCYL78VBP72R5YS	7874	11136	11136	1617943680000	canonical
15469	3NL3DRvGShxbeC1Hun5otuNxRos3EkoTm116dMieYkYQVoopH9yh	15467	3NLJfFBJPgYpG2Fx6kCBu4F715ydH3kSdSKGgTaiNKfortkMXi65	1581	778	248	6301	11503	jxweRdxUwq8K6XL6XocJzqNhnpoazQGp8bnWsE9QpLmX2kLVWWh	7876	11139	11139	1617944220000	canonical
15474	3NK8VXQBUoboXxKj6Uzunt74AenvTiJbkVmAuJTh99bndAHVVShP	15471	3NKdCPgmQEwdtmRJAxhnxXGRMpKTpVY12qyQKXeCUL33u8upzNuk	1405	851	248	6301	11507	jxGTXUAji2aZUjxggBUR8ME3HKFp6FJDJuiDZEBjkPXbTXYzyDe	7879	11142	11142	1617944760000	orphaned
15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	15482	3NLAmzi2u4yDj9au6jtt3pKsuAezzgbLp3c8oY3VGGqD2ktagd6y	1581	778	248	6301	11515	jxHw4sWK39Y6fuxYrX7oMpA9ZJtMLJ15mJ8VQTFsxSmE9f8u7KL	7883	11148	11148	1617945840000	canonical
15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	15489	3NLVjybCtLEHw2ypx6BRcgmwUiUruP6WKbopvBe4rEa6FgvWcSWZ	1577	1201	248	6301	11526	jxWrAjbNZupszn6CiD64fFcUjPkSNerMJT1KFAvgUfGUqvptt6f	7886	11152	11152	1617946560000	canonical
15495	3NKQGnL6dDQcHLAj4ju9KehqwLtFL6nmbcCvchtSTTJ3x9x51Dvb	15494	3NKKiKfhKptGwu7JKdBzTqJwa55LWBcX2XckHwSJJpzWr9kHuyDT	1672	1039	248	6301	11527	jxEAechti7ttejbuz9KtNP8Dh1BHHcvwbWXJacbSnWBZamN3232	7887	11155	11155	1617947100000	canonical
15507	3NLD7W5uG92VXxFxfTpvoXwEMANH8wF5n5Q2jF8P5hN2Q23RTWqh	15504	3NLYgcu9228oxhYHgsLAuGFtvh8SxHNi8pCvNoH7tPwrcnRikyTg	1527	927	248	6301	11538	jx2xYQpBNyWbfPHW9TEeBUxwaxgXuceGmnHWENpcHzdUinRgZKL	7892	11162	11162	1617948360000	orphaned
15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	15509	3NLCKa8Fj8cZF2ZFSkdg2GWEpTNtoNdxHjRyy67AhE7Y5UrgJUVJ	1406	1393	248	6301	11541	jwZ7Qvti9uo3qowcH11EHehRmx7Q4H561BGzkPLnue9wDEphorB	7893	11163	11163	1617948540000	canonical
15513	3NLGyfnAyQNq6gbvuos47YWejkG6RWro1HvxBA14rrFQ8KJLShJU	15511	3NLwDnYieJVn91Jk3m4RJuAWvRR6hiVooKNgVSqsZ7n7LeVoNb6t	470	1309	248	6301	11543	jwYC9tohj9YybTU9nZ7eKVQNcYzMgzYbrZ7WWSyPK2EmunfJjmu	7894	11164	11164	1617948720000	orphaned
15516	3NKTxsQ9BXMnFgAncUz9pgoHHzPKWCfrNUYqRSPDWNGURUhvGGfh	15515	3NL2nsfGfmWdGJq95r9gJ237BMQ7od1gESk8HNHXJ848jQ7CL1kD	1600	1126	249	6301	11544	jxK4e5bk2KBqxzd4qdAiN6myciqqB6NeVb6v2KzP9C2QJw7FY2d	7895	11165	11165	1617948900000	canonical
15518	3NKQqNS5Fc87x1bCAySKTBnNG1vYLq7rAH7En4PpcMahoMecKJwj	15517	3NL3a5qhMNpTwV2cJVuQETcSrHELTY1YVkdCdhd1qrF5CtaJiUhP	1672	919	249	6301	11546	jxrJLTUFBvef6yCbcxhfgpyhGHqL9As1BswANGycqT8X3ypG54f	7897	11168	11168	1617949440000	canonical
15519	3NLE7RvwSrKmXvwNXLPk7zzXMG8srXUjs7QuKwPQXKDauZaSppN9	15518	3NKQqNS5Fc87x1bCAySKTBnNG1vYLq7rAH7En4PpcMahoMecKJwj	1407	1395	249	6301	11547	jwHJzvwcCAaQ9JPHXUCaHEkZ1EUV5aJcJEVtLDMmHCdF7twoMwr	7898	11169	11169	1617949620000	canonical
15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	1642	1367	249	6301	11552	jx1qkjVMoDacUovTqLTrdsjqBjhbBXMEZNGMeZmozQjDavymbK6	7900	11173	11173	1617950340000	canonical
15522	3NLfR9YSpfRs3d5VVMLmzC74rUwoYYhCBZTKWsJWDLWhvkkt7fwT	15521	3NKmChoGbbyxGdV8tspNb9MYCQk5wZJ5K48tLQ969zQ5LDVHuZ1m	1407	1395	249	6301	11550	jxQub8jnGmHaoxChQHujzBRwg2pdjUSDzxzgLbv63zYdAURDa1n	7900	11173	11173	1617950340000	orphaned
15526	3NLxyJcEC9xmBxP6LSorh7BE3GRwgwXtXQb74P1Zn6azUmnMaxAW	15524	3NKMziZBWBbbxxzXJFUCBjFvQ896oLCoHVFL6AYgtFfWFPRUTq1q	1596	1237	249	6301	11554	jx3f61iCSXaoEqMjbrR5PeFRV2srqr8MvbaxS6p82VRZ3nzSb8B	7901	11174	11174	1617950520000	orphaned
15528	3NKwt6vaz4k7HQFMCw7XPELJvhYGY8B21gyWguJnDvEaBYeRHSju	15525	3NKSz6CCsvF84fQw9rN3MoCRN3Hc8KzBJFJxuiiipgg1rRwMJ1Fn	1405	873	249	6301	11556	jwhKJ6oL5UtWG5GfG1642DASj37EZueY5SS6AjpeUq8K2TX2icd	7902	11175	11175	1617950700000	canonical
15529	3NLgsX74vMcuNbymd7cdQrk8mYN4Woh2C6WXaYcrh1h6Ly9KiBkL	15528	3NKwt6vaz4k7HQFMCw7XPELJvhYGY8B21gyWguJnDvEaBYeRHSju	1673	1242	249	6301	11557	jx6cS5pBUqKQ293sEwDVLPQWL1dmhCeYL9pLhxAGtqNHF9qSGfw	7903	11178	11178	1617951240000	canonical
15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	15529	3NLgsX74vMcuNbymd7cdQrk8mYN4Woh2C6WXaYcrh1h6Ly9KiBkL	1407	1395	249	6301	11559	jwLCYMUqzEbaHrPcqz2EkxgvG7H4MUXrTUavzee5HqFp3o6u6DZ	7904	11179	11179	1617951420000	canonical
15534	3NKiUJYqWfZBgnmBD9Z3Tdftxunr6GTErwq5KRmFYUfdh47PBx4q	15531	3NKGJ3a7qjVwtuyuPKqrrgiNXfNZHVBg5Jt4M9nmVzv8LrgPs7bs	1610	1068	249	6301	11561	jxQLFYhTte5rhD6AFv5PJUwNVHKiCCsA4hZfCzCxz5Wofs9kmSq	7905	11181	11181	1617951780000	orphaned
15536	3NLk9UHXSMZnBtuXLkpitXng2QaW7mM8Mv9MCYuiaMD3AP5HxjP5	15533	3NL9thkbvHqSVmaBzdhathveJt14k8Ua7b16CnefPBL1ThYkH3Es	1670	1282	249	6301	11563	jwfTP3JiPSx6DhLXBs2SAVyeqDx88KdsMZL1W143pzzbz8gj7bQ	7906	11182	11182	1617951960000	canonical
15542	3NLPvjyRHUzGMkoATxNyMA8twpavMv816mk68ekaAXR9A3h6aQtY	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1407	1395	249	6301	11569	jxtga2fdvXrsyZEPucT1sGb1XV7Gi2h6qu6Zb2A3Xr55G668HcE	7911	11190	11190	1617953400000	orphaned
15548	3NKzXkWmsjGfNWhmthZxcg7aKRwvXhdfhHsK2kBrnBCnwEM4WUFX	15546	3NKcMjYBzJBHo2bWT9xs4VKYGudh5zjMRzWE9MqAnmGaBMMuT7e6	1590	198	249	6301	11575	jwfJbMse3DnvL8oe4PeYjf4rmaD41X7usD4yLSTiBLFRho9cXNj	7914	11197	11197	1617954660000	orphaned
15551	3NKdJzqo82rynWea5aTxsGyg88yNQGhgoVD4VF7DPd4tcyGi3jKC	15549	3NLcHroop6vfDan6DeCVLGNvr5gEG2uMYprpBkevT7jgogYxH6GG	1407	1395	249	6301	11578	jxwebC2GuVp4HoQNTVnRw6vhdNEDUJVAkiZw62g8REXEDfJJebu	7916	11201	11201	1617955380000	canonical
15553	3NLEQirzQa1Mocij4zpAeAeU4WjR5mgdWbka7rAfiUF9svWt4K3e	15551	3NKdJzqo82rynWea5aTxsGyg88yNQGhgoVD4VF7DPd4tcyGi3jKC	1581	778	250	6301	11580	jwpzJZv1nvB7cjChJFBDg5QmupSDRxumQv8G73nghbrJ6iKwkSH	7917	11202	11202	1617955560000	orphaned
15558	3NLJtNsw6NdZY2oKNbMeDdqw4W67LsdkMAuuayqetJALy68zNxY9	15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	1555	1221	250	6301	11585	jwP9Vg5Vjda4BySWEZZYSpkdMycLDB5ZnfbZhUcGQPxE9zRQi1S	7919	11206	11206	1617956280000	canonical
15556	3NLv4WpcfynBu9KcX1Vk7axi3AhaFpBjRuEkELsJuKkLSdjzZeBc	15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	1460	1324	250	6301	11583	jxG3HtJsRnbpHA4KPC2DN7yDzdPuqWoFcMiN8NHRYeReau4zxiL	7919	11206	11206	1617956280000	orphaned
20701	3NKa1EjM68eZepjShwA5889SraCKpWtFYNUaQcfN3YDoo5NN4rB4	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	641	1090	375	12463	13001	jxdamokx6pDKXBtfhKKsaEzCkaN2JFymoh7WsCsoq4kMzoxikKh	10411	14675	14675	1618580700000	orphaned
15543	3NLhZiMCSzRetndFVFD4yWRYokzjB21Tz5xePEwXaj11fwbYCDrz	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1622	1110	249	6301	11570	jxomXc8GAVzdKGHsVDwfTae2cb92k7SmhcpkszBkZedhVaFt6VC	7911	11190	11190	1617953400000	canonical
15541	3NKGVY5nVLKCotsLPrDdyk8cvgd9bB6hKptPUqnPshZvhJtJaohp	15540	3NLeopF1N5PAkEcgXrnNyZHJqTNFtNQsSiD3sPYJe7k232FLzVMJ	1403	782	249	6301	11568	jwLnaC51jcppciefZHaUkPXhnuz2B5tzLkh6MMcp6YX6vKMUVvS	7911	11190	11190	1617953400000	orphaned
15547	3NLC7ZtfVXr6wiL2XfVERU4UCBNWEWGV4HQifnUuuySrM4rKToKv	15546	3NKcMjYBzJBHo2bWT9xs4VKYGudh5zjMRzWE9MqAnmGaBMMuT7e6	1407	1395	249	6301	11574	jwQE21hjC1kucCKCc5i2qHBBsKknoKKJmaQY2yjVHVA7prKmzPY	7914	11197	11197	1617954660000	canonical
15549	3NLcHroop6vfDan6DeCVLGNvr5gEG2uMYprpBkevT7jgogYxH6GG	15547	3NLC7ZtfVXr6wiL2XfVERU4UCBNWEWGV4HQifnUuuySrM4rKToKv	1500	1171	249	6301	11576	jwvn4L74VgF9yi2xW6Ra5DxxZ3Qktooy8qfWWzko6DfQDwKrKmv	7915	11198	11198	1617954840000	canonical
15550	3NLk461QnyM3afHmcpBKGw7tkwYyJALgeFtC57NRVonqzVGsQb56	15547	3NLC7ZtfVXr6wiL2XfVERU4UCBNWEWGV4HQifnUuuySrM4rKToKv	1534	1071	249	6301	11577	jwRtMF1R2AuNa8Fw72umqoc7zuW5ex55jBv5dq8fUVMcDTWCoVD	7915	11198	11198	1617954840000	orphaned
15552	3NLBiG1S8sHxk1nnvw7YtVkVCaSN8emd4hfyMoyrVMLLCP2binaK	15551	3NKdJzqo82rynWea5aTxsGyg88yNQGhgoVD4VF7DPd4tcyGi3jKC	1642	1121	250	6301	11579	jwHhvCXEtNVSgzbX7cTMsLehXe22z1dnHM98gcBRgW49bjr4baF	7917	11202	11202	1617955560000	canonical
15555	3NKzKoQe6H6FDKMXuBt3zXKHxA4TNfpuAnks1XQj9KjMfPvyxKTX	15552	3NLBiG1S8sHxk1nnvw7YtVkVCaSN8emd4hfyMoyrVMLLCP2binaK	1581	778	250	6301	11582	jxBJcHnWAHR62GRNuMfxQCiu1F5cqDQqmaxBrfQ3XscQbmhDmEZ	7918	11204	11204	1617955920000	orphaned
15557	3NL34hpbp3oJjYtCpGUQxWDryrqP83ZLvNZMdeuNbsuAVW3Jq7X5	15554	3NKLeJCj1mXeqCJLyaqnnTx2gZddzp5S9mwSeY1PuVWKRzjdCy84	1581	778	250	6301	11584	jw9hepWpvZ7VhS1AznWZn9KKbZAioXW143ekPaaEp53dSnGTp7J	7919	11206	11206	1617956280000	orphaned
15565	3NKPMzciqk8t1kvcBrMvbinAAC9NG4j6CxJpEtFgCHnZury8P4jR	15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	1445	1164	250	6301	11592	jwbpC3donCjaVybSFQKpYUCsvnYmvCGN7h2gy2RDKj3ei6QDevu	7921	11211	11211	1617957180000	canonical
15563	3NLwYH3zP6VifK2rqeFxvea7ctMgDuwVEZ6WJX6zqaaMZZRW1h8Q	15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	1483	1030	250	6301	11590	jxSVopXJ4TNCDAJTYiSpYmVPsdg3GULjhhmYtyS45pVDzChWnoy	7921	11211	11211	1617957180000	orphaned
15568	3NL8MDLm6ttJ8so2Kqz7YxgoFfs1EBKYryqD6sRFegc7eMfXCf79	15567	3NKvMsfB7XqktmL6EjLKUbXSbjxwxy76SB9MURnE31sETisFxi3F	1623	830	250	6301	11595	jwKKbqhTyfGe8yhM8Zh7Uh9YnnpnTpiB1hM48hjjeZsBznXPxMD	7924	11218	11218	1617958440000	orphaned
15571	3NLTyjye6yeAZ8vtvhL9Rc5AA7e9FeBRcN2rcgJrpfbz9oJBPx4b	15570	3NKHmCfvNDKnUGWXSXDX6BbTTmKkazArnr1S3rfTDgcKqwcRNAJV	641	970	250	6301	11598	jwxkLnVE9goV7MrygPGo89GymRnopQvoLqtv65WFuu4H3dKmkH5	7926	11220	11220	1617958800000	canonical
15573	3NKwDq5jDNLkAmAAkASKkp5eDr4PodeKX36JbAuSQ6dnFiggpJdb	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1527	1047	250	6301	11600	jw7Yhq1BECibziz7Ca1k6VfDcodTKnDWG9zNEjp6jcqjUnq3m1d	7928	11222	11222	1617959160000	orphaned
15577	3NLVwE3u4B4cZQRwUZ8UU68gkkLRg4xM7iUF6WLoepDCXfouuAPE	15576	3NLuKYh4KYFs3jUMH1VkyNiqoHBJs5JerawyuKL3m2EWfEwQDhEh	1587	1357	250	6301	11602	jxhyVRZhETRE8WZ8s8cr2UiZodw2XcqexwJ8UqyP8wrvmq2ZYDM	7929	11223	11223	1617959340000	canonical
15578	3NKFes11qGb7uP9vMgbQFdpBvPejqt9A6sqeh6hctoqHQMU9sNVX	15577	3NLVwE3u4B4cZQRwUZ8UU68gkkLRg4xM7iUF6WLoepDCXfouuAPE	1403	785	250	6301	11603	jxP3LftTvcsXKRaeZnA9DKjVRRFDqsXe4SuW8F1h5nyk4MUxgCZ	7930	11225	11225	1617959700000	canonical
15581	3NKZYshDe5KpGMqDJAgLEd5Tm2oEHWGyAXLCN9mHdYegHHybqCJS	15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	1405	889	250	6301	11606	jwL7zMqfT1FYKddT6GXKnjGeq2Kruai2N8GKzXGtVFWpCzKai6N	7932	11231	11231	1617960780000	canonical
15582	3NLSC2sUCKhDgX7teRBww5YFuf2Q2gAGHG8VLqCWVgXpT7b7Aw1S	15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	43	1064	250	6301	11607	jxVAerYYkVaj1HopVW2cAowdxPNFZbvroz46xNAPCP1bGCjYfK4	7932	11231	11231	1617960780000	orphaned
15586	3NLJ53ir6h5PrKZorv44km1HWEpXuQxASdNWt5rbWWnUzTuAnt22	15585	3NK9H2KePEqLvXckmcuTStCRrPKAZr4vNefNT7BvrQwJdUJLVK72	1419	814	250	6301	11611	jxJJ6hPtkANrMhLFUzNM1AzTR1oTfJcaGkdVBsqMsDKXmvdTfRJ	7934	11234	11234	1617961320000	canonical
15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	15586	3NLJ53ir6h5PrKZorv44km1HWEpXuQxASdNWt5rbWWnUzTuAnt22	1406	1393	250	6301	11613	jxntren4Jy2ZJarVVZ6NL6tPB51VFoPSykGKV8nXAiBBHDRxXYi	7935	11235	11235	1617961500000	canonical
15591	3NKoh1xb8PRXKwEKxaaYCzFgMnT7bmf5QGN4gJNscLhKVYxiAQNB	15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	1673	1122	250	6301	11616	jxYXA3DYqxA4cc6WidTGLCTsEaJezAUGhZ7w4QotMCxu8p6nzij	7936	11238	11238	1617962040000	canonical
15589	3NLL1TmjmBg41EQnmob5kWgU1x5aStbvQgkwNuvhs2pmqRrx7EMU	15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	1476	1371	250	6301	11614	jwyzDZGDb4vpBM8M8M3MrNZ2GMSNYquzSAUaEE8D6TuLW6nT54o	7936	11238	11238	1617962040000	orphaned
15596	3NK9t8cR3io8VcCQrpJRhSBVvpiHttq1zXv38Nooyf5s1QK9nTrQ	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	1646	988	250	6301	11618	jwMi5CFC2LGLyH8vPA7XNiGh7GsRErnMgGD5xGa29aVzy2cF59Y	7938	11243	11243	1617962940000	canonical
15594	3NLXUM2xgnqmopAxnwqhfp5gDQYJJLuyy5uX2woiwL2w6BXFDK7n	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	1407	1395	250	6301	11619	jxBVZhzEXzXq5SLsXdKSWmWya9zRiW9iKJEniuGNFWxJG4K4Zoy	7938	11243	11243	1617962940000	orphaned
15597	3NL1Qz1PFisS92onc5e9fkk36Wd6GXjouFcgcEHhZX9ExHo8ySaM	15596	3NK9t8cR3io8VcCQrpJRhSBVvpiHttq1zXv38Nooyf5s1QK9nTrQ	1590	1300	250	6301	11621	jwQ2q9NboVga75FvYAzkdZaGen9mQuyi2ZKi4REPwtm5gYTGpQe	7939	11245	11245	1617963300000	canonical
15599	3NKX6QNVYG9deSuA3o3QrXab54Z3QfkLxhTurqrFEEaRvdWUxGbE	15598	3NLojF61NzbTyXC8xwuEV3Xn4dN2mbBqwwjgbDhnEHZWtQj35vsQ	1579	1143	250	6301	11623	jy3FSLnWwKodRqPHTizzWBCrtGGFEkw7LouWdTqAG8WcCZLrTUy	7941	11247	11247	1617963660000	canonical
15601	3NLHCexo4kk7utmJeRzL6hqXgudQHPzKE4jgYHbZPWg87DQd5LTP	15600	3NKxJg72avRiiMXnxnHaroaj5ATsK7cGq5hhfn1bdzp9u7F8FbmR	1407	1395	251	6301	11624	jwb1yES62JAhDCem3N11FEsBbtbAg1k2jipScmQS52oxdqDyjDc	7942	11248	11248	1617963840000	orphaned
15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	15602	3NKPJudHQRY8hEhkedEouD6dEV7ww26ZhXnJLCQbB7AqHubuh5v9	1405	857	251	6301	11627	jwcBtKK1suzcuFFWrvNSuyaxz26m2YwjCeC7nXdaJgqZUKrvUvw	7943	11249	11249	1617964020000	canonical
15606	3NL1BwqZK76wHPunNTCEQToYmLFdyuNJmZ4cV2r3qRUnmWE3Zk8k	15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	1609	1333	251	6301	11629	jxXAs2ZS4NeNCXjzyaT7ZM1NoSwp1DxDLyCzMvavEVKpJAnqmJE	7944	11250	11250	1617964200000	orphaned
15609	3NKJrM1UBWmsrxKZaWphHyzv2G35D11mTxNGWZ2s9Xw2idC3RG2L	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1403	824	251	6301	11632	jxG34GS2kciWR1dJk2uD1z36zTqd6KB8R3aEKRjQ1UPnpTvrpVj	7946	11254	11254	1617964920000	orphaned
20712	3NKWfSX2tJLm2MstMWsBE3GQc39hJSyTqMj3EF7mRzoZkDNUouwj	20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	1613	1349	375	12463	13011	jwg21oE8pqBAAYw1m6ufQNJkG9QWBAzEkusxxTcnRFfkka5292x	10415	14680	14680	1618581600000	orphaned
22224	3NLcmcoYMdGb1xcyP5nAPWNvXoJsUkabtQV5PxZFRYWB8nezQ9qp	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	1407	1395	410	12463	14352	jw7aHWZxjZVtraAkeFh3KGLo7Fe8KARptgKANxcmnWNTaFqe1L1	11125	15663	15663	1618758540000	orphaned
15564	3NL71R28hjvQ3wojw7WESphsdm2gvG4h6nsrqGCnTRnVeeawP8pj	15561	3NKvXudvpyaLNhvJ24fK9kEjMr9uN1NkGyuz3bG7FwF9AYfdDpn5	1467	1130	250	6301	11591	jwS5FvpNpeRViVbfkoqqfiFXD1zSchusopabz3Ci938ekm5A8Mx	7921	11211	11211	1617957180000	orphaned
15566	3NLYmZJ77Dx1MBcjZien2BJgkbr4zwxxSES5Qo2g9zKvCjNMtgV5	15565	3NKPMzciqk8t1kvcBrMvbinAAC9NG4j6CxJpEtFgCHnZury8P4jR	1634	1331	250	6301	11593	jx9DhsM7EPYm1GrcRwVPxrDtd2pumy9wbMS8nvi4u3SMD3hAn3D	7922	11213	11213	1617957540000	canonical
15569	3NKbPtsqN629iFE8naDisiiKD92BxXUJCZMk2pvJUTtsVPFTEsK6	15567	3NKvMsfB7XqktmL6EjLKUbXSbjxwxy76SB9MURnE31sETisFxi3F	1594	1200	250	6301	11596	jwrNa57zpPU2xmNNLJC79XQ3NP9m3gkQJjWMEemvLL7HiV6gK5a	7924	11218	11218	1617958440000	canonical
15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	15571	3NLTyjye6yeAZ8vtvhL9Rc5AA7e9FeBRcN2rcgJrpfbz9oJBPx4b	369	1186	250	6301	11599	jwhvJ1MkXZxfEsvmXhjf7SmTS2HwAiRFy7httTfnJPK56SnhUkv	7927	11221	11221	1617958980000	canonical
15576	3NLuKYh4KYFs3jUMH1VkyNiqoHBJs5JerawyuKL3m2EWfEwQDhEh	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1631	794	250	6301	11601	jy1xc2HBRapaTFxRS4ztFf9ouqUfrB1CJ1H6VDbicXG6mKXZHTi	7928	11222	11222	1617959160000	canonical
15574	3NKZvr9zvm7XKAPTBu2Bjb3PnroAA7tqEWTK7vjWHEf6sc3vqiW1	15572	3NKebipu4kTYD1i1sxn8b8DP5ymeebFLnMF8QcSmvpTa5ENTJCjf	1527	1047	250	6301	11600	jwM6iXV1Bm3TVtvXTGMLRgNsetCzLZLAhH7FVR63cYX4RRsPUuC	7928	11222	11222	1617959160000	orphaned
15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	15578	3NKFes11qGb7uP9vMgbQFdpBvPejqt9A6sqeh6hctoqHQMU9sNVX	1426	1364	250	6301	11605	jx9XXxus2vTsCFaNzZ7hcSR6HmUCguBU3VEH3vtpgffbdWG2yUj	7931	11230	11230	1617960600000	canonical
15583	3NLxhrY4FpDbjvfbhmc2xj3uFL6dt3ABREF1ii5WnUpDCBM5WTeQ	15580	3NLXvi1K6j5GcR3LihwMCn3rMGMyQaoXe5Psz9i39HsFE7DopiTE	1553	776	250	6301	11608	jxjNHhuTqHgyjm3aNHKsPj1F3oeCBN9BCFrs59xgTYckbQSbwZr	7932	11231	11231	1617960780000	orphaned
15590	3NLo7aBy7YjbsFqnWrLfqwNxVFW89izjndV2AQ1zW9VZMQbomoxm	15588	3NKuPvJVsgpVDaQJqArqpVBxv63Xyb52qq7bCcgqCo2UzJvgRPHJ	1457	1265	250	6301	11615	jxQdExi92Jd8uifpHVJqtVMMjPPZcLbTFWSq9c5JPhU7E9vtDd9	7936	11238	11238	1617962040000	orphaned
15598	3NLojF61NzbTyXC8xwuEV3Xn4dN2mbBqwwjgbDhnEHZWtQj35vsQ	15597	3NL1Qz1PFisS92onc5e9fkk36Wd6GXjouFcgcEHhZX9ExHo8ySaM	1590	934	250	6301	11622	jwoyVhhhWcbtYDt7Aq9fjg7zvQw7QvFsEkHFKnppdKXdcxWLjER	7940	11246	11246	1617963480000	canonical
15603	3NL9kfdFjqAaXWaJu3GfxJ2vpfXaUyfY6jqfKc9JJRQryMYLvQf5	15602	3NKPJudHQRY8hEhkedEouD6dEV7ww26ZhXnJLCQbB7AqHubuh5v9	1642	1367	251	6301	11626	jxzAsaCwMBVkzcfr4HCg78x3DRdoEq8e9EGkRWfHmPa4HFWWGTW	7943	11249	11249	1617964020000	orphaned
15605	3NKoWc9JRBYBKjFTT3KTQYRnXf6TScn9R9Eb3BJQ2t95D2spBHJQ	15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	1602	1123	251	6301	11628	jwBT3Q1W2Bi3gVS6mbUsqv2a9KDggsDWej3svH5mLVt8yy9smkL	7944	11250	11250	1617964200000	canonical
15607	3NLr7EBtkQdeeeFDRABsbc47w1fRMuGMG7z6yDWEeV1QqoJJZMWD	15604	3NKNJLW5CK7Ed7id85MyWLvo3ELhqr2Hqw4HdGzk53uCeTkewJfV	1406	1393	251	6301	11630	jxwzvc6Fj5FuoKNbnx1znbRU9GtEMXKDTf9HJfDpWpQ6kFLxhfL	7944	11250	11250	1617964200000	orphaned
15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	15605	3NKoWc9JRBYBKjFTT3KTQYRnXf6TScn9R9Eb3BJQ2t95D2spBHJQ	1406	1393	251	6301	11631	jxjqnmF9e2uPorxrCRQ1rfzWKv9ztxxEbeMQW2vZf4ctMwS9ycJ	7945	11253	11253	1617964740000	canonical
15613	3NL7DA73Xred6NKsrXDnJxi2Pwvhqu7ddio9AZL7hES45tBrpeuv	15610	3NLm5tXS9CP6zX3ve4TJXWC2DPyAFPLEUnjXVyWhqX7Z2wwpwPdF	1407	1395	251	6301	11636	jxZCibMKamwMEckeDqfebZkDJVBfDZnG8g65ZgnYkhWiMyuAr2H	7947	11255	11255	1617965100000	canonical
15615	3NK44mJqHik4Ji8yM41XmNgMBXiWX6GcSHzpYhQtQ5cQFMYg6M8L	15613	3NL7DA73Xred6NKsrXDnJxi2Pwvhqu7ddio9AZL7hES45tBrpeuv	152	1204	251	6301	11638	jx4Fp45BMdpZ911VHaytx7pBocDpQZwjHgstPmLwoYwqQGU2x6G	7948	11256	11256	1617965280000	canonical
15618	3NLe6sQJUeGCrryiKZU3smGNxg8U4qnewcikgwuPPvJ1GUbdyBGH	15616	3NKijWhJSC3FkVRHYodjdaZHPydgSTju5evq42nhZo3LTq6zXM39	1406	1393	251	6301	11641	jwaUyGaUwg25iwxpWdGf3VHC7PUcHT6nV3dTCLPLmYGKZpuGL6r	7950	11259	11259	1617965820000	orphaned
15623	3NLfniabDUkYRaL1oTWDyJ6aWMpVFMGPgQsiESEvRtEBARKz7RzJ	15622	3NKTcdxcjhAGecAcgyPoEidhTGDYij8MoDM5mMx6jxEj6UCjhSUh	1587	1357	251	6301	11645	jwuL5cUZvbcqYk8QPcGZ21CML18348y76tyLGZYan7uA53abmYT	7953	11263	11263	1617966540000	canonical
15625	3NKNHp6EaWH3vjiKUJPTkPC9yXtKumcMhhy6mdt3U9EezoyAieUa	15623	3NLfniabDUkYRaL1oTWDyJ6aWMpVFMGPgQsiESEvRtEBARKz7RzJ	1406	1393	251	6301	11647	jwgCsWpc8JvhEVS12hsd4s4AQU1avMfkAYcWnrSv6B66bsXRLkW	7954	11264	11264	1617966720000	canonical
15630	3NLNqYL8KLdRh1KqqHqdyp8Zqhh38qZxQEmCKH12FQJ5ynWdJ9B1	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1610	1188	251	6301	11652	jwQbVyhhRoJDg1rBbaJnCGwjGLwAoLXy7NYCpPPKNCmZJ2x2Ydx	7957	11267	11267	1617967260000	orphaned
15634	3NLKEYRRBtY3PTWkJBNTTQPKRj4dWfYHdPPA2opvEZMBCVoB3Eh3	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1448	945	251	6301	11656	jx7CQs2MGAraS192eT3utokFdQYcsSxgXgNkkBpEiQ9TNHyBGZA	7958	11268	11268	1617967440000	orphaned
15636	3NLV3Q5aj5Lax4pcNDUSreUF5e2ZsYEunMssAcytCkg6mwrzsi4u	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1534	1191	251	6301	11657	jwKPrN93wLJ9xys3GoFBQHu9Mx5AffuVwvhDBBJV9CsNH48Jb22	7958	11268	11268	1617967440000	orphaned
15643	3NKsuND9K9emqKy4Sp2pnJbzrDMuZLhYdftZjDWdytJMWxj6KdQ5	15641	3NKqg99XcfG9Z8HDFv1eGdszU4ER1C5rgpq2R9n1wUQwiR6z8USy	1536	1313	251	6301	11664	jwM39usDe6iTkuwbrgehLcDbY1AiXM14fpEaMXkVEjgAMXLJgG7	7960	11270	11270	1617967800000	orphaned
15645	3NLEN4uD2nQJ6TfEVScdJ9UepD79AyE2ci78bRL8ZZV5nyf9bVKQ	15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	1407	1395	251	6301	11666	jw7WwgjewSwPYD8sSEztwdCRMWXQocD37uFsNY7DBzz784h6rBi	7961	11271	11271	1617967980000	orphaned
15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	15649	3NLssDMMfKXoXE23qXLuvC4NLamrKTrgkdwPXrg5ujmjwVmLqERQ	1555	1347	251	6301	11671	jwRFCQD5uh74iYtZLpXXQkcNRqVL7jWKfLeEmN4E6U972zmUSP4	7964	11276	11276	1617968880000	canonical
15653	3NK3T3UdMsLYXGEsiC3BpFQ8wgSzCSv38L3v2Ey44EfH45ax8jsw	15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	1649	1137	251	6301	11672	jxDeuqgwPfJgknvHwzYJcipiCtu9FJZkANB6V8th1mgRD9yaHjB	7965	11277	11277	1617969060000	orphaned
15655	3NKyEv6qFVX3qJQFAvjGcvYV8Fpr2urqP3NNa3HuaPkUu94crqX7	15654	3NKzy4ShASdTMLyggQJqXS7VgUg5BmLTKrNwG68h8rMcFtcsQ5ky	1549	1362	252	6301	11675	jxmZ55ZL2BNuCdVxpUEzFTQLjaoga2FXzK1saC9Pds629ZGkLeq	7967	11279	11279	1617969420000	canonical
15658	3NLQrmCm1rz8a95wgsPB4kYeNixu7jEdBwco5fUGSGxBMwmE3DYE	15655	3NKyEv6qFVX3qJQFAvjGcvYV8Fpr2urqP3NNa3HuaPkUu94crqX7	1652	1315	252	6301	11678	jx1baprwveUthpZDEJrY9euhUvKHke6aGB1JmNsbaH9h1fHBbJa	7968	11281	11281	1617969780000	orphaned
20717	3NKxWFmpDdB7yRSeuoeSiEJ1VHrgqpdYfPegp54stit8EuU9MRHY	20715	3NKLUPpsukJ1GtpEzkqQ35qYVvSGjMLgpdzHHRtgBSaQXczMQsbE	1507	1034	375	12463	13016	jwomeqrAXocWxDFxLZac2aptRB3syMq53ERwe8BfT15fYXV9iiL	10417	14682	14682	1618581960000	orphaned
15627	3NKRRajueveQjX9kwcAwujnNRitEjZcZkBubNnsPUp34LfiS2Ngi	15570	3NKHmCfvNDKnUGWXSXDX6BbTTmKkazArnr1S3rfTDgcKqwcRNAJV	1569	485	250	6301	11649	jwdi8vzHxSW8d7YPAsFtEwVgC5S72mxq6N2ty14UTzR85gvHS1J	7926	11266	11266	1617967080000	orphaned
15579	3NKHT3sH9NRZcNnc9d5765vjs1XcEswtFzEkZExmeZP7EtcEY6ni	15577	3NLVwE3u4B4cZQRwUZ8UU68gkkLRg4xM7iUF6WLoepDCXfouuAPE	152	1330	250	6301	11604	jx1197ncZssExgiy6DP9d5AdJGVD57u6qnm4q21sdLmwza6iZxj	7930	11225	11225	1617959700000	orphaned
15584	3NKKgyGGu5fNpfkveC2C4w89rUQZSoBvKVg1XLAMCiVtxxg76zJD	15581	3NKZYshDe5KpGMqDJAgLEd5Tm2oEHWGyAXLCN9mHdYegHHybqCJS	1652	1315	250	6301	11609	jx9vKC33QqWQWw2CRWcLV9VNwf54wUTrLLHSUxRvvKv8nwHRnTS	7933	11232	11232	1617960960000	orphaned
15587	3NLV1ssopA3gpN5EvBZairhkLgYVRj8RJmRS6gVLRJC3HwV1TZ9P	15585	3NK9H2KePEqLvXckmcuTStCRrPKAZr4vNefNT7BvrQwJdUJLVK72	1406	1393	250	6301	11612	jxzAcZTFGCVqz9Cu6mwfof8gXAayqMdsfZvsJEEpfxzXhvvEeo9	7934	11234	11234	1617961320000	orphaned
15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	15591	3NKoh1xb8PRXKwEKxaaYCzFgMnT7bmf5QGN4gJNscLhKVYxiAQNB	1506	1247	250	6301	11617	jx4atHHQNY2eb42JsNkzyeH5xZFujR3zH8ncRnFymQQ9bZ2LCHm	7937	11240	11240	1617962400000	canonical
15593	3NLZS7WcsneAJWhmQiStW19chEkpdXrAF4wmYn9Cp67BcoqvyPA8	15592	3NL3gsgQoarAuZNHQhePAuqAoP2fBjL1BDzzuNrz6Efi2SsHj71m	1646	988	250	6301	11618	jxPZNw6YWN8v9syo6twmwbYUsGxSTxcgrCpWFEntDowiYbYXo4y	7938	11243	11243	1617962940000	orphaned
15600	3NKxJg72avRiiMXnxnHaroaj5ATsK7cGq5hhfn1bdzp9u7F8FbmR	15598	3NLojF61NzbTyXC8xwuEV3Xn4dN2mbBqwwjgbDhnEHZWtQj35vsQ	1579	1143	250	6301	11623	jy3FSLnWwKodRqPHTizzWBCrtGGFEkw7LouWdTqAG8WcCZLrTUy	7941	11247	11247	1617963660000	orphaned
15602	3NKPJudHQRY8hEhkedEouD6dEV7ww26ZhXnJLCQbB7AqHubuh5v9	15599	3NKX6QNVYG9deSuA3o3QrXab54Z3QfkLxhTurqrFEEaRvdWUxGbE	1406	1393	251	6301	11625	jxbYNYe5dCj713cKR1NhRL3PaxSRvT3jw1ykZC4mj1cja76L7kr	7942	11248	11248	1617963840000	canonical
15610	3NLm5tXS9CP6zX3ve4TJXWC2DPyAFPLEUnjXVyWhqX7Z2wwpwPdF	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1578	1050	251	6301	11633	jxzVdjnT91dQaXUf69UozeXSqH5VBFrBKFh3iXRCwSC6DfVxtqz	7946	11254	11254	1617964920000	canonical
15612	3NKEDn2nnPi9DmwwweoLFriL51potoAwtbGnhCzEdaC7yrdkkFi1	15608	3NLvXrUiDxcoXVHWswUNm8jgTcynnE3yTKFE6dsQK6QyNcpszBGu	1508	1261	251	6301	11635	jwnBdQSvSUPvFjC66A7nBkS1283poCU4MCTjuiCWCASiwWu3dU3	7946	11254	11254	1617964920000	orphaned
15614	3NLy3fbSTW73TmRip3uEzrRmjCq8GfuMpFY1QQHjdwmWPhpaSNMo	15613	3NL7DA73Xred6NKsrXDnJxi2Pwvhqu7ddio9AZL7hES45tBrpeuv	1403	782	251	6301	11637	jxXvwyZttgVCQKhUSrLFpmdjgdXypxU3mgXaKHdUTZMArk64PnR	7948	11256	11256	1617965280000	orphaned
15617	3NKfFzD9Sqq4NW6cJWiHppQMdmzX11rfpGwNjTWVCgjDceVYSQYS	15616	3NKijWhJSC3FkVRHYodjdaZHPydgSTju5evq42nhZo3LTq6zXM39	1506	1007	251	6301	11640	jxE6qfBbJtggUkVwwe4eHzzWGhKbCVJKMCzNMNVdV3wnoPfMtJU	7950	11259	11259	1617965820000	canonical
15620	3NKmeieKTBVUnyTCznw47LNC7xZ5pqd4v6K2aAJaRRvD9TXTrZuo	15617	3NKfFzD9Sqq4NW6cJWiHppQMdmzX11rfpGwNjTWVCgjDceVYSQYS	606	1295	251	6301	11643	jx8dBoJK6Cxy34Hiiy4uJf2LG4ViHGdxu29y2Lg879W2XKLjEKe	7951	11260	11260	1617966000000	canonical
15619	3NKY2r4J6WdVtEzDpy2NPWkBVWp5yCq2mY2irHBjLU8EuRJ8TMbM	15617	3NKfFzD9Sqq4NW6cJWiHppQMdmzX11rfpGwNjTWVCgjDceVYSQYS	1406	1393	251	6301	11642	jxY3EDK5A1zUXt7REkAeywaAbgS7V3e8V7tg3BcrMc1uZcmzm6c	7951	11260	11260	1617966000000	orphaned
15622	3NKTcdxcjhAGecAcgyPoEidhTGDYij8MoDM5mMx6jxEj6UCjhSUh	15620	3NKmeieKTBVUnyTCznw47LNC7xZ5pqd4v6K2aAJaRRvD9TXTrZuo	1448	1311	251	6301	11644	jx96drUtVEmYVkn3jJMf7SXEe1uBpppajram6qU9ToJtjz6qTkj	7952	11261	11261	1617966180000	canonical
15624	3NKrHoUZH6yQMiCqBVfnwTvC79Q86q99eveG1KZgFkCQhRzLePGt	15623	3NLfniabDUkYRaL1oTWDyJ6aWMpVFMGPgQsiESEvRtEBARKz7RzJ	1599	1041	251	6301	11646	jwS6mgGoqMyyk5fuNJWqw4EAsXuvGvmkqppVzFsNFjsBMtatAEF	7954	11264	11264	1617966720000	orphaned
15629	3NLKNiUR27pm6iBa4YmHuGnDHS1nwePDguXErP3agRUHYgNyCJMR	15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	1516	1168	251	6301	11651	jwyoKPRTQex6zmBtwFErQmKMHcRE91dSckoYu58a2yYyQkJZ1iN	7956	11266	11266	1617967080000	orphaned
15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1581	778	251	6301	11655	jx1r96t2ktyde6EwXkPJy8novBTQmUxavkWohrYNuHXvGypmLHj	7957	11267	11267	1617967260000	canonical
15640	3NKowRhHG1vHNFtHgqR56jdiyGXfwNFknphfcrdaadPrjVgk9cS4	15635	3NLZPBYnFiPXu1ESJDaMLnVTgqgebkP34AeYNd8rBPNnNoNjici4	1585	1240	251	6301	11661	jxr8DK2CDjdhNUwgavju6QL9vppaAECoRNCibEdUpYUA1VccPuh	7959	11269	11269	1617967620000	orphaned
15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	15641	3NKqg99XcfG9Z8HDFv1eGdszU4ER1C5rgpq2R9n1wUQwiR6z8USy	1619	1149	251	6301	11663	jxzHhubcS784sxDCpgZk7m8CQfNqpmgrsToXCiCsbb7UPSPUFWj	7960	11270	11270	1617967800000	canonical
15647	3NLNz4MjhmdcC3AXZ2fjw6yyXnQyCM3sMMVnX75qb9VmZc2PbR8w	15646	3NK336W2tEYF62Hop9pzPVCqJ9e1t7HATMwH1wRULHMYVuQuWnkF	1407	1395	251	6301	11668	jxik8rMmMNQRCxcf9JdfygpJhG33BASKeXY5K8rVqfcjyfXr1Cq	7962	11273	11273	1617968340000	canonical
15649	3NLssDMMfKXoXE23qXLuvC4NLamrKTrgkdwPXrg5ujmjwVmLqERQ	15647	3NLNz4MjhmdcC3AXZ2fjw6yyXnQyCM3sMMVnX75qb9VmZc2PbR8w	1590	1054	251	6301	11670	jx33bcgzwjKigqNURmwtx4mqC9vCvfYFt8TKEn21pnkzpFr1YNA	7963	11274	11274	1617968520000	canonical
15652	3NLAs36ANXo9WqY5zXBxhRGyTpRk1rJNktvh9imTcGK6WmcmL6DG	15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	1407	1395	252	6301	11673	jwrZmaGm46hzyxzZtD6E7duN2R8a1UaLTRpcRS8jM3qzniET65A	7965	11277	11277	1617969060000	canonical
15654	3NKzy4ShASdTMLyggQJqXS7VgUg5BmLTKrNwG68h8rMcFtcsQ5ky	15652	3NLAs36ANXo9WqY5zXBxhRGyTpRk1rJNktvh9imTcGK6WmcmL6DG	1553	776	252	6301	11674	jy2srkrL1ffbUYsvxmdo5Hb68uG6xJbTLUGETEdYezUzskGBBfp	7966	11278	11278	1617969240000	canonical
15657	3NKyvxAX9yYK2tFWUkFNicEUA2G8phVp3Uxx92rbr9Ekk3cQbjSW	15655	3NKyEv6qFVX3qJQFAvjGcvYV8Fpr2urqP3NNa3HuaPkUu94crqX7	1600	1372	252	6301	11677	jxYu8HGxy7TFhyqshgKxUc3oepcxfuHPA1o3YzhkWkVTcLaommt	7968	11281	11281	1617969780000	canonical
15659	3NKUVp5JSAixcGijMMDJzca222ZFvojcgPJWxQFQ2JPC9ZkRzLFr	15657	3NKyvxAX9yYK2tFWUkFNicEUA2G8phVp3Uxx92rbr9Ekk3cQbjSW	1637	815	252	6301	11679	jwBBhhHBzQzeCDAU5YnCb6NcAn7V1joFF2PyWq8LXRC8o7wkqBQ	7969	11282	11282	1617969960000	canonical
15662	3NKRArpz74TgR32bzXLG8mLR2LW3j8uXUJiBDzRfsN53SESwua4Y	15661	3NKonKZXavXtvK4HMLhqFj7AQi5rdeq7MH5ojQWHzFKzmcZo1Mqq	1637	816	252	6301	11682	jxPpHVEc4e5cjWkDq9KHufhPagiPCATWVHUHfMrnZokESq5THY1	7972	11286	11286	1617970680000	canonical
15669	3NL7gjnKTg3XLRhTsYRu2LVqosbWDYPbYiCcJZrUGz4FhMCDYt6a	15663	3NKRQmupdoT7rnMMLSX6F6bdFgtJion78jhPiaj8QovRPoB4eVbL	1631	793	252	6301	11689	jwdCmRc4rSgmP9SFG5uCT2S8njZNL9Rjdtn24NwrnJPeNaryS71	7974	11288	11288	1617971040000	orphaned
15665	3NKRZkeX8HDjTAXEGH3TsRvcWsVScp5TpDMhc1qJRAxVuLK7Y7xn	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	1634	1331	252	6301	11685	jx9TunjDe2UTmz6c3sSnwGDvRbfgkAkLC1XAPzfWZV8ctJQGtZL	7975	11290	11290	1617971400000	orphaned
20836	3NK4BZX8ytPGfY4yNSSTNA5tu5rEN9xLQwY5kN4FsFKYu76S1qjq	20763	3NKaBQrPvNGEcdyyL9si6tLxw5FVqJhqjYiZy8aveqKYdUfVtDi7	1633	1144	376	12463	13123	jwvYghUem3YbUtPi9woVqF127MWVdvmTj16UpDAG95pY2eg1ere	10417	14749	14749	1618594020000	orphaned
22227	3NLm9ZgofiD2YzSgR1CE79KRDtQG8N69HvTiaHtwxcPhDkZYv8N9	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	1577	1201	410	12463	14353	jwt5EQpvGpjgg9DgJjKEVS1a8baB5AMUjdSAtiEa8zhz85tY4MX	11125	15663	15663	1618758540000	orphaned
15616	3NKijWhJSC3FkVRHYodjdaZHPydgSTju5evq42nhZo3LTq6zXM39	15615	3NK44mJqHik4Ji8yM41XmNgMBXiWX6GcSHzpYhQtQ5cQFMYg6M8L	1500	1051	251	6301	11639	jxwKNrQhydTNNHeygH1pNeHWJd6eCMcaV1dbxqWqvkW1oQrY661	7949	11257	11257	1617965460000	canonical
15621	3NKQNqsPWBK4srMk8Lh8pXJQh5Hdd2DUAst67EZLtfK17jrmTc1N	15620	3NKmeieKTBVUnyTCznw47LNC7xZ5pqd4v6K2aAJaRRvD9TXTrZuo	1448	1311	251	6301	11644	jxkKDHbqNvE4FMXaE924xahfzK5EfnHXkbg6Mx68ycHdPTKWLWK	7952	11261	11261	1617966180000	orphaned
15639	3NKQaqma3f2YUfzPTZc67ecRB8qmrnmytBzs372gFRRiQyXJApbA	15622	3NKTcdxcjhAGecAcgyPoEidhTGDYij8MoDM5mMx6jxEj6UCjhSUh	1448	945	251	6301	11660	jwYbc1xAEYYShrgudFYg5ANsfqM2LXDHJUH2XQUzE6uFPQm8fRZ	7953	11268	11268	1617967440000	orphaned
15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	15625	3NKNHp6EaWH3vjiKUJPTkPC9yXtKumcMhhy6mdt3U9EezoyAieUa	1460	1198	251	6301	11648	jx98fYPb2DkDmEEJ3Q1F6W6SWWsrvGA69Jp2zWxcQoVbZSdhrH4	7955	11265	11265	1617966900000	canonical
15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	1569	485	251	6301	11650	jxDr9T3rbRejPfMPNp6M7qHnuu5sNYHEHstHzU9asyEvJZFSJC1	7956	11266	11266	1617967080000	canonical
15631	3NL7NYkmnQeUsBuJXjKhze1emZCqbvAhBUqQsTE3YTPURzvNmRom	15628	3NKa5nLhR6cyj2zuDvb3uhbQYPhPDrTRFtnDjvc7XLUf4pTiwFJE	1503	1031	251	6301	11653	jwDWCtfhz4TCXEZF7nL6kmjgsTGSNiE7WppxqXSHmGPykqbnvVq	7957	11267	11267	1617967260000	orphaned
15635	3NLZPBYnFiPXu1ESJDaMLnVTgqgebkP34AeYNd8rBPNnNoNjici4	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	1448	945	251	6301	11656	jwPz5YgKu9HKq2ECHmYX7UvU7njfoTBmrkCbt28Kje5FSBGnmGM	7958	11268	11268	1617967440000	canonical
15637	3NLDjLWXRZh319hasEKfKfqBMDeUh5PRR3YTwmfyYr8wtiS29b8K	15633	3NL8tKNbC4VfEjJ9rq4Mejh3EGSP3Q6iDrJUrmQ4MiHybXQEUDyr	641	1090	251	6301	11658	jwqTpdEuYtRkJCvjLHpsQ4swc2d6vUhsm8xUzovPhss5VvFJQ5T	7958	11268	11268	1617967440000	orphaned
15646	3NK336W2tEYF62Hop9pzPVCqJ9e1t7HATMwH1wRULHMYVuQuWnkF	15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	75	75	251	6301	11667	jwdzJHGYi1ZhFysH7EtACgsZcNk2kBEymBKGUQvGHdJabXjmPfE	7961	11271	11271	1617967980000	canonical
15644	3NLwNvvvRFT8WuzfH2VFmDqfbxb4xcrmXjAxgeZ24Q51ddLzuYJY	15642	3NLHfRQvHW6DQga2WRaxVCZpaeFVn4pLcHXf12hCb1U8PUqZSJ2w	1445	1290	251	6301	11665	jwExHhcxDVFtpjtoapNSpDMZPFf4sHgFYL28gGgpANj4hDLqEpn	7961	11271	11271	1617967980000	orphaned
15648	3NL1mHswvpWr28bxLhAQroDLx6fz2bLE1ySTY8fda2BWV6KkHYHj	15647	3NLNz4MjhmdcC3AXZ2fjw6yyXnQyCM3sMMVnX75qb9VmZc2PbR8w	1675	1216	251	6301	11669	jxQvN5mSBoNBgHk9uu772BnUGVuza3bEtR2PpyicLGA8zUmjHRE	7963	11274	11274	1617968520000	orphaned
15651	3NKPLumCf3AGV1Je6P47SpJ5psCwYvN4aze4nvrRiLJhGafXNLud	15650	3NLekEEZhj7ib2WZ4Yytnpc9ZLaeVvUk8tYmn5T5TnEJf5oiawAP	1649	1137	252	6301	11672	jw9Nb8S6jCdLxBCnGJK2GTCZ6sf2CdDdZwNWkZFBNNXWDy2GXFU	7965	11277	11277	1617969060000	orphaned
15656	3NLxFCsBVayqtgXuDrWfwSo6RRTj7ish92ty3s6Xp95rhGKYWoyv	15654	3NKzy4ShASdTMLyggQJqXS7VgUg5BmLTKrNwG68h8rMcFtcsQ5ky	152	1330	252	6301	11676	jxDmcUv9seYVco6QPfvAMizFmRngz9in9RbHerQcQzHtECHQq3s	7967	11279	11279	1617969420000	orphaned
15661	3NKonKZXavXtvK4HMLhqFj7AQi5rdeq7MH5ojQWHzFKzmcZo1Mqq	15660	3NLhvj5N5kqCHvePbTs5swsfH9d1jpAqUFAa3uWPFotvBkJkQNGY	1440	1377	252	6301	11681	jwHdxRtcFroKhgaCCYzVpeYBD35JmCzkWzPM1uMnN2nazBHp4b3	7971	11284	11284	1617970320000	canonical
15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	15663	3NKRQmupdoT7rnMMLSX6F6bdFgtJion78jhPiaj8QovRPoB4eVbL	684	986	252	6301	11684	jxm2KTAhaTAoUPpCYadiUvLqeFpRUZhqYvpPsSrbHnMosdPvtez	7974	11288	11288	1617971040000	canonical
15671	3NLP4z2m8hsubZr7EWbHw9kDLaYzQUhCnWSwRQZ6aQ1LGm1ByXZn	15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	1646	988	252	6301	11691	jwV28D3p2xe14CH43R4CSVYPhyLtVTkEsP3vX2pLYdyE4KRBwn5	7976	11292	11292	1617971760000	canonical
15673	3NLFCxYD9uzTZMCMNDMpR14XuJakARKdpTnudgVTWkHPGjxP24p9	15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	1646	988	252	6301	11691	jwkPS6J8kSjB1f95wgY3BZXYCgGrqS5ey5KHgv9DhHMyPjmBVY3	7976	11292	11292	1617971760000	orphaned
15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	15671	3NLP4z2m8hsubZr7EWbHw9kDLaYzQUhCnWSwRQZ6aQ1LGm1ByXZn	1501	1234	252	6301	11694	jx5KD5VSJHypTbnUmju6mhpGNk1hLHDz1d9RHVvaEvjXFvU8Lij	7977	11293	11293	1617971940000	canonical
15677	3NLQQBNMNmGZn3R3AFHeZMN7XnxWcmsCLdyfB2h1uK1XY4BwrJLx	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1467	1010	252	6301	11696	jxAnZnQcB6kYFKqn8TZVee4VrXT4RvNuCDA1x67n5JbGQXu3iGT	7978	11294	11294	1617972120000	canonical
15678	3NL8iTwGsG8ey1k3gLBxdhLB39k3UNY6nALxPK1v9CDoFbokQLXy	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1523	1075	252	6301	11695	jwiXAgHGt448KpMZuua7JUYdrk3B3vyQ5zAC8y1H434ARXGKjte	7978	11294	11294	1617972120000	orphaned
15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	15677	3NLQQBNMNmGZn3R3AFHeZMN7XnxWcmsCLdyfB2h1uK1XY4BwrJLx	633	1138	252	6301	11699	jxpzsp4QmrbKyevhwe12kWTVzyPxFewZ2oeBDrCMHin2UqQAQL7	7979	11295	11295	1617972300000	canonical
15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1594	1326	252	6301	11704	jwsvHykCxxMobXaBZry2w7qgbJZ8oZ2eajWRZb9bu59AqeM7i6d	7980	11296	11296	1617972480000	canonical
15684	3NKZdqHwGTWCVWG9VGnLrBZsme3DuYmTkLkLYSKX9u9LGd4pxvrX	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1445	1290	252	6301	11701	jxs2kzN1hRgynYzaF2giTz3fo8HJNTKXomxusCqEZAfmZGAUn72	7980	11296	11296	1617972480000	orphaned
15686	3NLSk4LGSja7eLgFvEG9YawjLVdLsQtwzzM5gU43LAKRcGXYikXM	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	42	1115	252	6301	11703	jxmN7b12mMFuyoJ6VTcKsQyyQLSYRUf3RrSxD7ZGMy2ohqujyDG	7980	11296	11296	1617972480000	orphaned
15693	3NKLyuag4kga9mGxD1JLvunnH2RpVi8Guajb5wS7Px9VhAWS4Pop	15691	3NKxU1viFMkeRD6UZDaLDWsDZDVy7fHX3LGYU7qjqBezRp8VMEKj	1593	980	252	6301	11708	jy17dPmr7nhFeBUj9TM5pu2x2hJUP3t8y4u4VbNobrfBzt8Xtrt	7982	11299	11299	1617973020000	canonical
15695	3NLYQTPkZC4dpvig8RskoWLgtMwqGXnBBmz8dWdrokbcf1koU31D	15693	3NKLyuag4kga9mGxD1JLvunnH2RpVi8Guajb5wS7Px9VhAWS4Pop	1651	1175	252	6301	11709	jx4ugzLsmUBEKCHVR8nFXUZe5bSUwEnuMf8qozQD1inPA7FfRFW	7983	11300	11300	1617973200000	orphaned
15698	3NLJBndbSvxH4y7cR9UipsZmcvtVNbN68AXnyrGv86oKBBKmYypB	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1627	1385	252	6301	11712	jwVqgi4WAAmKE4YiZph2H6S4G7yrq1WaFe7DrFXmpB1K1VVcxa1	7984	11301	11301	1617973380000	orphaned
15700	3NLfmu5KksCZSWXyndf2uTV79UwUmzHDaqW7riLE3rDRwmcdCHAj	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jwfRqWtDWQcMthevJDSmX8eZBAXwUJJ7Gx7Ntbfkrb7c2k76U4B	7985	11303	11303	1617973740000	orphaned
20848	3NKpF43nXvC6urWSBPmR8dcMjdSQof2nDh3CHxTPWVGAinkpKUu8	20836	3NK4BZX8ytPGfY4yNSSTNA5tu5rEN9xLQwY5kN4FsFKYu76S1qjq	1633	1024	376	12463	13134	jwHsP3HS8rT9x2rYYHabD7hFhvuBpLkAVYquPAP8LLz5bGMKRcC	10418	14756	14756	1618595280000	orphaned
15692	3NKsdyg5dWZgUQrroyzUaFS54GgMH8JKDq4L2nszqhkz81inZyp8	15626	3NL6z4JQvYQq4L2Jo5oEr9uGsg6742URsjCLNeapcbPhnpiRjVcn	1593	980	251	6301	11707	jxh1rEMKQXxto43tpWDkJ8oBwnGd5jVVWkptuRNTtjcXEJFHjhV	7956	11299	11299	1617973020000	orphaned
15660	3NLhvj5N5kqCHvePbTs5swsfH9d1jpAqUFAa3uWPFotvBkJkQNGY	15659	3NKUVp5JSAixcGijMMDJzca222ZFvojcgPJWxQFQ2JPC9ZkRzLFr	1402	796	252	6301	11680	jx2DJ2P7KZar2n2Xu5Yzf4bJYWW5hvP2WDovJLyPJtUaxxyM9MX	7970	11283	11283	1617970140000	canonical
15663	3NKRQmupdoT7rnMMLSX6F6bdFgtJion78jhPiaj8QovRPoB4eVbL	15662	3NKRArpz74TgR32bzXLG8mLR2LW3j8uXUJiBDzRfsN53SESwua4Y	1581	778	252	6301	11683	jxwBx17yGh5Vkr5kTgRutXTxr7rSVEhBM68q9GHe1D2nwFNW5tK	7973	11287	11287	1617970860000	canonical
15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	42	1361	252	6301	11688	jx8HZj2c3PrtWyXDfHf9rWtybgxrfQVTrg9pdqRKRBRJwkrbHga	7975	11290	11290	1617971400000	canonical
15666	3NL8GScXe71PQrxhjBpniRxRaZNhUrSiiFrRSoqrbnQey7nudZ9M	15664	3NKcpD5t7JHwCT5uE9tCa9YE7SZKse8GeamvYUGpH4jqzWSWKkRJ	1407	1395	252	6301	11686	jwhWFvE55FSibf6B3qtyraQ3LXD9XaihDw9dM2oi9tGf1ir7Y2S	7975	11290	11290	1617971400000	orphaned
15679	3NLu3mUjaDprmM2z7q1wY6E7MWKpP9VYHwrG8SUeq4dRrEoWotga	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1402	796	252	6301	11697	jxQhjrvhX8LbgEXT6GwZXK3yeGhq6jnJEr9EdKxu5Jw1UnRkZfn	7978	11294	11294	1617972120000	orphaned
15681	3NLRNGvK9gotitM2wbDK6sbYn3iRmoHnrem4ZaQFYRwaPBBr2uSM	15677	3NLQQBNMNmGZn3R3AFHeZMN7XnxWcmsCLdyfB2h1uK1XY4BwrJLx	298	1308	252	6301	11698	jxykVw3UCpejF1Q3fUPbLwJRhR4188mqjBx41jTekYwvns3UVnK	7979	11295	11295	1617972300000	orphaned
15683	3NKcsi7oqmX2KMnsTaNgtbDiaDQ71eb5pcyC5ymW5aDiLWcsEoqq	15682	3NLNbBQiA74JV1UKKgYxzDV4iRzBC9dEVLvHaL59nkLSoxDViD9z	1447	701	252	6301	11700	jxbKZRsQjeds9wWH2pftMWFqAoeKFa3jvrqarFP1yMZhwu3AinE	7980	11296	11296	1617972480000	orphaned
15690	3NKR1f3kFFsrteQQhcpS3XoV4qEtapZKGM2LUqCMF7RUigfuZSCp	15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	1500	1297	252	6301	11705	jxc1zryAZAerEcgbgPzT7wPmB4bwrdU65oM17bxzoFvNPdFsKMy	7981	11298	11298	1617972840000	orphaned
15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	15693	3NKLyuag4kga9mGxD1JLvunnH2RpVi8Guajb5wS7Px9VhAWS4Pop	1651	1175	252	6301	11709	jxRujxkwhP9u7REAqPkVRqcJtHJTSwZ6og7WnGKhjazWsWn4byd	7983	11300	11300	1617973200000	canonical
15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1553	776	252	6301	11711	jy2V5mC5RadvjhGV4rqEcadQ7WWxCyAYhEE9z8HrKJ1KcctrEio	7984	11301	11301	1617973380000	canonical
15699	3NKNhNrcNb1MEcQBh2u2bATuADHHcjJzSFTXMWKNedW7wZBYx4L8	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1631	794	252	6301	11713	jxHtiafpDxBcN9KLBMJuWhThP2VX5DBUoYLwe4Ptvze9gsACEtL	7984	11301	11301	1617973380000	orphaned
15701	3NK9ghpASjRCA9vsPC31VtHFxnPVDKdeZLQUV3vYBQyNEEXzemJP	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jxH6vqjoAxQYf8R4vJNDBRsdwstSg2C1GdXj9M14UNQaAwwLASD	7985	11303	11303	1617973740000	canonical
15703	3NKUNzi9dBANL5Bxd2VCWjSQqY9dWVePoGFV9rmfwfLKMqcmzJpU	15697	3NLo2F3bRMGq4zte7dFfJ7abmC8ZFsjKrAU8AuRvcwf83UHH5BDR	532	1057	252	6301	11714	jxCdLWV8k2fUtj797EBEBdqMaDeEFXq1rD1KAeCm368VHYPDjW4	7985	11303	11303	1617973740000	orphaned
15705	3NLDBqDvy3Gzv5aPfZSaRQnWGFdse52DD8zHQrHc2Hpwk1F1ADXu	15701	3NK9ghpASjRCA9vsPC31VtHFxnPVDKdeZLQUV3vYBQyNEEXzemJP	1637	816	253	6301	11716	jxJqYnEgiPnGWNotoeBaG6k44N5sMMgnEuincNuCkcrCV581U4v	7986	11304	11304	1617973920000	canonical
15708	3NL5FQ4zfkwVCrSZoLHuXg9pBTdBXvKwaAgEgeHhGKD2dY9JYzVo	15707	3NLJBLw8JBEzKaWk7mBfESdkL2LhiWALhDscK7iCfH9h9m5XLjkp	1588	1392	253	6301	11718	jy34gFkDqTxrKzoKSQYSXn1NXHikvRGvSRvSgWKQJJ8T4qwvGSM	7988	11306	11306	1617974280000	canonical
15713	3NK6eUxisftMJe4N8opGk3b5Qjm1cXRvUNM1CdLdLGFiFCMraA93	15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	1460	1198	253	6301	11722	jwrYmqeLvoaG4eTuZcTXdQ3ZNjc6yp6UAbXjFdiGWQwrsTztiqm	7990	11310	11310	1617975000000	orphaned
15718	3NLahEoULqLiPqTt9HmQURPHUcoQW7jN93LAytiNjYCVNBJcq118	15715	3NKuP4NAdPQwztr8Ry1GrkrQe26UWEjVZVBJvHyQyjwz993BWdzh	1505	276	253	6301	11727	jwrYtumxRygC2BLVSor9M6FoxccUrNkqbU45fiUhoWtYYnjcKnN	7992	11314	11314	1617975720000	orphaned
15723	3NKcNUC8MRRQTCiDaqyxwRtKW22E4tWT3wTuBzHEUQKToxd3QMZN	15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	1407	1395	253	6301	11732	jxWGkRXx3MghroNZTu8Atr3p621VRoCBcm1vhEC451DsBsMVNgz	7995	11317	11317	1617976260000	orphaned
15730	3NKP3RXW9oTkkBdEfpiw2BHHryTWuV7Qhdc2SzPGkK8mrNoeajwN	15728	3NKJKGMxQFp6tytPibq1w33MTj3PzQAZpEFk6JJDhD4aTwQKtbv7	1516	1294	253	6301	11739	jx9S9kxCDhd6bGQpcjiMr9ns1LN9X3y5vS843Q19DQd9XmAAFtT	7998	11320	11320	1617976800000	orphaned
15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	15732	3NKgGoLv6UES5d6EDtVuUoVo81okGe6saSZxUyYbqaqUHh3XibTp	1406	1393	253	6301	11742	jxFfFDi4hnHRCZaXjbQh69WZt85NXFLF5zgFgCjPuYRxJb4Ryrg	8001	11325	11325	1617977700000	canonical
15735	3NKujKzozfCX8FGVsHjid6iLDisREoGwyaxA3fnEF6SAFxvZDXZQ	15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	1564	1092	253	6301	11744	jxRoZdsHk5Wdtb7CfZuC1gV5W5KfdsMqUMhxejHserZPBbnDYVw	8002	11326	11326	1617977880000	canonical
15736	3NK9rcGTHhDLfpNWqPMQfbY6DF9JA1P4g3uVUhHzMrniiP9SgfQd	15735	3NKujKzozfCX8FGVsHjid6iLDisREoGwyaxA3fnEF6SAFxvZDXZQ	1455	966	253	6301	11745	jxaj8opmWCFdEwz47CELMcYzVhRWvsR15AyPEzBdj8iaDvZRJSX	8003	11329	11329	1617978420000	canonical
15738	3NKRfSa3eAfgZQq9ZEzrTbKBnZNkM4grdvBAnowEmNK6iWWD1BaV	15736	3NK9rcGTHhDLfpNWqPMQfbY6DF9JA1P4g3uVUhHzMrniiP9SgfQd	1642	280	254	6301	11747	jxPv1au6njMZ2ACiD25thaFmPKkSxBm47GdMoDF1HQS47F1BBz4	8004	11330	11330	1617978600000	canonical
15743	3NKr8cFvp2mCSbGn6EKnyXomY6bnVL2gQwyYSXia4u1mF1Fotxfz	15741	3NLn55kGWEH6qgHSEz6zTJRB8WCWySVbcNdjSfp8uFGPwrRtmmTb	1406	1393	254	6301	11751	jwG8CMpmzhxjNN4F1w3vXUYuYLYTYPUjypG7oGnSdMYrKzFAdPU	8006	11333	11333	1617979140000	orphaned
15749	3NKjAyzAXDaMxneAoCB9WbYtGGTggxkThWvNEjAmcuBTCH4CqCmp	15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	1542	1304	254	6301	11757	jxLj67HDdV1sacG9f2YyGYQcJwFmsqMgEdVEYht5Mc3YKti1gRs	8009	11340	11340	1617980400000	orphaned
15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	15750	3NKQtfG9qamY7DW7KLmqCFFBHqJgE5HzbAMb8k1RjCNx4HuGBz7B	1577	1201	254	6301	11759	jxVJTvMb38PLwgaXw4Qq3wEYWcGNPNZR4tWa4H93QMKBA6cJdUE	8010	11342	11342	1617980760000	canonical
15756	3NLyYS88n5dPc2o4YZhy9N99DGXiPeAs1ax8oyc85aqdUjbEoAsp	15754	3NL24SNDwpwag726u3aiLhqjgERM2FUaW1rwmvvKMvjCXFA1NMUZ	1402	892	254	6301	11763	jxg9Cx3c27xPnoHwDaV1NWr3sV9TmgpBKQYvSmiYeWdFSkGCnCh	8012	11346	11346	1617981480000	canonical
15764	3NLbrH2m69MrzPBNrV56fs2YZtPjQrb2LKxdpnVgZatDB5UV8wwn	15762	3NLYBSuK8Dtw66x4nBwqYCRDj2BaHs1ubyCU9nbC6pcDS9RV9GHM	1407	1395	254	6301	11771	jx2u4PMy7VQ4MskBnM8GUyKkB67khJ2NpwkAwyZU7itmPFAFPqu	8017	11353	11353	1617982740000	canonical
20728	3NKm6o2ckQDAHVsaMZSVHZWaBAHgp4R7CpqrRjz1FS4d6pcmJNqR	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1581	778	376	12463	13025	jwzHKnUwRgPrGSPzkB3cU9ENb2HSFCxnE8DQAos7W1Ty2aUQxGt	10420	14686	14686	1618582680000	orphaned
15745	3NLPtKydjYLUess249CGpatCJ2kTJFEfqLGFBkBZWDrf8gKiCSvw	15711	3NKUtn2J1gmwEaN6n5fUuyqCHWniR2LSQw2DPM18Pv8cdDBcLq9A	1444	1135	249	6301	11753	jxnPoqNJqa3GWpJacubYXrP1UuETTUq4mWc6aBBcfMQaNG9Rbm7	7903	11336	11336	1617979680000	orphaned
15672	3NLsyFx8VkrXjDtP8LMwLCY99sc9npYLFYw69tK23CjFm2PNhnVe	15668	3NLHcF9rePv7myZ4kvEU8CezZHM7fVtKgq38DpidKD6gP1ErRhFJ	1590	1300	252	6301	11692	jxU45k2wghk3Z2Hqw9mbEqvVunEnXw8oWeUSmeAe74wozKxvAaZ	7976	11292	11292	1617971760000	orphaned
15674	3NL82WnwV3aCcNDGzaBLi5Am8UKPvjCo6umonhiZzC3CnWyWWmBe	15671	3NLP4z2m8hsubZr7EWbHw9kDLaYzQUhCnWSwRQZ6aQ1LGm1ByXZn	1634	965	252	6301	11693	jy1bHYcjb7VB135quT55zezVNFunSE1KBiF3kZSQc3vxgGiVbgD	7977	11293	11293	1617971940000	orphaned
15676	3NKgjwwuM2pruYLQHpDyVdoBrQAc8e13UYA8BNrJzBkudtiGPEXm	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	1523	1075	252	6301	11695	jx2swvqsJoa4QTVY8uMzKxKgFJXeB34eHCNakk436Q8yirCfQxB	7978	11294	11294	1617972120000	orphaned
15691	3NKxU1viFMkeRD6UZDaLDWsDZDVy7fHX3LGYU7qjqBezRp8VMEKj	15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	1573	1318	252	6301	11706	jxfe2RJPzdiZtZBX2535JHWvRjhSdskyjpB76L44KvD5KgfJTxQ	7981	11298	11298	1617972840000	canonical
15689	3NKcHhjNLRxr1S9KSKVpzFMd4769qJCyMuYCwUeCZL3QJ7RqsVJ2	15687	3NKiY3E6j7QdHHCvqDLZ6RBhTJCA6rg2Gr1zybm18NN97DMG5GrQ	1500	1297	252	6301	11705	jxxzAkj6WbrRMgnQ8rcUGXW51uKPr1rpp1hq3nNy2HWLHRrHJ8j	7981	11298	11298	1617972840000	orphaned
15696	3NK33LZzi3bohgur6y8UddiYufqQfKksinSN4WjjEueRS8Gv6GVJ	15694	3NKjuYYtotib4bRcC2C2x5v43TKNqFvg26xurFQS7PfKHFY2LQyL	1403	780	252	6301	11710	jwvkPzw6ghZQSAE9BsJMfkBpeD3n59s9AAZhJuuiyYjj1VkeEwo	7984	11301	11301	1617973380000	orphaned
15707	3NLJBLw8JBEzKaWk7mBfESdkL2LhiWALhDscK7iCfH9h9m5XLjkp	15705	3NLDBqDvy3Gzv5aPfZSaRQnWGFdse52DD8zHQrHc2Hpwk1F1ADXu	484	1073	253	6301	11717	jxiLGt2WDUcoLEY4vtjqEstD8yCJ9SGn6bA1YV7FU8w1bChUguY	7987	11305	11305	1617974100000	canonical
15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	15708	3NL5FQ4zfkwVCrSZoLHuXg9pBTdBXvKwaAgEgeHhGKD2dY9JYzVo	1553	776	253	6301	11719	jwXsfu7SteR5eSHrg1mG67zixXudcgyMyd3GNN1qxsFGbKQR4r9	7989	11309	11309	1617974820000	canonical
15714	3NLHfLn3FMBNgExxzkgM7B7SVmq7sNATkYc5KpiM3Dk1CWjTx1GE	15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	1577	1081	253	6301	11723	jwCig2Fo7dDx9BNkfsERgxGgV1bFAuf3PCjcrZRP2hTwQqetCHH	7990	11310	11310	1617975000000	canonical
15712	3NKmZTNUZfgWo6DV1bBtcZLLz4ewBfvvAfsD5HEPmLJTbS7RZdU4	15710	3NKbjsNhhtbz88jxoSAfYiZhjUhx81LvoiiyiZKfnBsr3KjrZc5d	1444	1381	253	6301	11721	jwEeS6o8WyC8eMk2fuXLexqRyAkpHXXmw1zpKtpnVnMBWZVcLpc	7990	11310	11310	1617975000000	orphaned
15715	3NKuP4NAdPQwztr8Ry1GrkrQe26UWEjVZVBJvHyQyjwz993BWdzh	15714	3NLHfLn3FMBNgExxzkgM7B7SVmq7sNATkYc5KpiM3Dk1CWjTx1GE	1405	851	253	6301	11724	jwgd2fxQmCTvakKPGFnA6vkTrgCFLSoCqgz3hsT4qN6qBtDHzM6	7991	11311	11311	1617975180000	orphaned
15719	3NKkgXocgPZDCKyyPQqKhYTbWs7VuBA3w4bUioc4e6UecMDCczY8	15716	3NKT2TJcLkvftuwU8XKGaH5UNpDsSe33o6tbUBrg34Sfw1wFCDFS	1505	276	253	6301	11728	jxder4Todqz92tPGLZkUhF1KmyhiAd8L54cyR4G9uoRTrGnpjzi	7992	11314	11314	1617975720000	canonical
15720	3NK5gFmy6si36bmTxSd6DHdqXUrZkAdoSkd6TkYCmWzsBegA5RJY	15719	3NKkgXocgPZDCKyyPQqKhYTbWs7VuBA3w4bUioc4e6UecMDCczY8	1451	1292	253	6301	11729	jxEkyA23pt98rAxXwaAMhQwCz5y7PukhZfc3nK6HXJN7GD1Acnc	7993	11315	11315	1617975900000	canonical
15722	3NLYd2QePV8nxav3KCGcnZgyBgmLE42yjVuwuJK1Rm2ccDs9j2sE	15720	3NK5gFmy6si36bmTxSd6DHdqXUrZkAdoSkd6TkYCmWzsBegA5RJY	1611	975	253	6301	11731	jxgHx89zEnuk6UYMzrgxJd2ccxTDEUFnB9eBP5dFm4AuDURKG3X	7994	11316	11316	1617976080000	orphaned
15725	3NLCBM2tdE2KQKhCqxBbC7a3UpA5iVdoWoZo6dmG8FKSAAe1ynUw	15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	1406	1393	253	6301	11734	jxD5wVmeVggeAKGiHDBE35EPNzuv67HYV6Z7cGpc8JYRVuB8BzK	7995	11317	11317	1617976260000	orphaned
15726	3NKVn4ZjcDzB5RtwcVLPvzmeoRSdeiFgAyRHuQkU5sK5nVAcaidy	15724	3NLQXd9YDPsxq1p8dtjYaCgwJuYs4NHj7ZPDTfk7XLEkrsyCnVcn	1406	1393	253	6301	11735	jx2q9vZTgtCAGedJQyRr7yN5aWeADzMHWMVUZZCm2prmangbwvQ	7996	11318	11318	1617976440000	canonical
15727	3NLxWDca7EqfRJCq6VRxz9ge6F1szYmjzd6qTALSvP9DrZbW8RCY	15724	3NLQXd9YDPsxq1p8dtjYaCgwJuYs4NHj7ZPDTfk7XLEkrsyCnVcn	606	1169	253	6301	11736	jwhedv8Uz2xeaGaTyFNyfgFfofwWEujiArvv4WYjA7eBMwYRMbw	7996	11318	11318	1617976440000	orphaned
15729	3NLBHZ7CcFeMtskpPBr4eLt9sXtK24m1Kqx1MdpZvQhRWQAUQ1mj	15728	3NKJKGMxQFp6tytPibq1w33MTj3PzQAZpEFk6JJDhD4aTwQKtbv7	1467	1250	253	6301	11738	jxJiTaMxPUVkt8Q5GEH57A9EJU2F3gqDDJCZNLb5b6zR5nH6QXb	7998	11320	11320	1617976800000	canonical
15731	3NLByzjNML2Ya2mRHBYvKiv9rwTA1NZJB7FrJkrbBsrpWs8S9KDm	15729	3NLBHZ7CcFeMtskpPBr4eLt9sXtK24m1Kqx1MdpZvQhRWQAUQ1mj	1633	1390	253	6301	11740	jxA2JRWFVU566YsYoq8ijUZEappFYXGD16Hw55vKJYoVZkT3HkA	7999	11322	11322	1617977160000	canonical
15732	3NKgGoLv6UES5d6EDtVuUoVo81okGe6saSZxUyYbqaqUHh3XibTp	15731	3NLByzjNML2Ya2mRHBYvKiv9rwTA1NZJB7FrJkrbBsrpWs8S9KDm	1668	1244	253	6301	11741	jwMo4P8QviC8n5y8WWRAfvZ1Wg3f6ksvVUbjwHLAuhF4KGugCzJ	8000	11324	11324	1617977520000	canonical
15734	3NLSSBwFuerh1Kx72axeZJDdsdfJTFKu7cP176tyBasJpmgSVVmM	15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	1403	824	253	6301	11743	jwigcMQ463VeMxj975Ym7BQgrAXq5yzUKVFWAAagbq96wFtMLKS	8002	11326	11326	1617977880000	orphaned
15739	3NLjJZmJQ34f7m23RyknYEVgn4xzGLXomTXnxZ8tiM21Sp1hqrw1	15736	3NK9rcGTHhDLfpNWqPMQfbY6DF9JA1P4g3uVUhHzMrniiP9SgfQd	1642	280	254	6301	11747	jwknzY2S7D27m1b2K1bdPvpEVxVQAYW36pbMqJowhUjCQSqdjqF	8004	11330	11330	1617978600000	orphaned
15740	3NK3aap9ithYtays6P7RCAsSNgfFtwdK5T8jXGZ9o8ruqDRB4oQB	15738	3NKRfSa3eAfgZQq9ZEzrTbKBnZNkM4grdvBAnowEmNK6iWWD1BaV	1546	1093	254	6301	11748	jwWQsiDAPgiFR2FWEnkqsQ1RMqYjqe8URppFKmB6ktzLfs4fCSv	8005	11332	11332	1617978960000	orphaned
15747	3NKx4yav31DHPYq8o5CWQL1r5Q97UpayuWQHyi2C5Rum5dubeYBm	15744	3NLA1AaSad6Rz3hvEdAxQxoGmyu9YMUPtWZD4qkSKUufpDczFpAF	1518	788	254	6301	11755	jxJRAesGuAg3DQWt5pX2QsJ1dg5TdXfcPcPgR9s4bWnVouFUFoV	8008	11336	11336	1617979680000	orphaned
15750	3NKQtfG9qamY7DW7KLmqCFFBHqJgE5HzbAMb8k1RjCNx4HuGBz7B	15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	1633	1144	254	6301	11758	jxsUs4rRPNkyKXqResANfSML1RPzsGP9jFLLMVo4rTt84AhSNRA	8009	11340	11340	1617980400000	canonical
15748	3NKWemd9MJnXS1kZvtzpWkXp9Z8vT65wS5iyncZ2fWGqp4xatxi1	15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	58	1281	254	6301	11756	jxnYC5pLsCgodya53XRbWVxzMkft9LyHPCQcYLfSRdEFenKTG45	8009	11340	11340	1617980400000	orphaned
15753	3NKXgcAKTtCbZyHwkYKALxtipA7ptKwsmYaD8VA4d7uyeDWttRYk	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	470	1309	254	6301	11761	jxB5b9CQYKNHG7mynzXcWkVS6mxXc4P9h21LK6TQfkZ9FeuprLK	8011	11344	11344	1617981120000	orphaned
15761	3NKLFn5kFCCxXRpCpdEKaDEZ48LQmZajqTiUFrkAgT2ugFhsHWiM	15759	3NL6M93bLyvEG8Y3FhT2ZYdxVRCVLwVoUwghy5mZ5F6LdVZXt8oV	1587	1111	254	6301	11768	jxiEACom1meoegkxr6FGDANpXmksMbBwuuKqXSa9qixzsX7hnNG	8015	11351	11351	1617982380000	canonical
20767	3NKfqz8Cm2dGqJchuwieQZPqVyJg8BXRue28Au44t3uSnxsh14W3	20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	1633	1144	377	12463	13063	jwqF9u551BDDPrwJvkBJhZ7fU9Y8UKrEQYYCcUtGpb2vu39ahGX	10436	14707	14707	1618586460000	orphaned
15704	3NLEFH7LSnm8sKCPhRbtMJC2R2AyvjYLFeYpD2tvYuiPgJiWSe3t	15701	3NK9ghpASjRCA9vsPC31VtHFxnPVDKdeZLQUV3vYBQyNEEXzemJP	1542	1058	253	6301	11715	jxpHyzGRJsfTpdao7Ea9iAouFXWuy6peEjD2BmB6QKNV2CfFVeo	7986	11304	11304	1617973920000	orphaned
15716	3NKT2TJcLkvftuwU8XKGaH5UNpDsSe33o6tbUBrg34Sfw1wFCDFS	15714	3NLHfLn3FMBNgExxzkgM7B7SVmq7sNATkYc5KpiM3Dk1CWjTx1GE	1457	1025	253	6301	11725	jxZoyG3y6BM9D8YsTJu7mAZRvmaKy1chsAKqEWViQwiSe3KKDVU	7991	11311	11311	1617975180000	canonical
15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	15720	3NK5gFmy6si36bmTxSd6DHdqXUrZkAdoSkd6TkYCmWzsBegA5RJY	1406	1393	253	6301	11730	jwB36eWrtck9sp9G7mSU42ZVhuE149KWPBKpvc88YFfT2hpsdd9	7994	11316	11316	1617976080000	canonical
15724	3NLQXd9YDPsxq1p8dtjYaCgwJuYs4NHj7ZPDTfk7XLEkrsyCnVcn	15721	3NLMjdV16pTYJQA6NNaHoCiEufPkRuj1ohkzST637BATPTFPHQo5	1402	808	253	6301	11733	jwwBe7iQKkd9QwVpXneM6ggrgLcW764iiWmQbm6qT1heD3bbUSx	7995	11317	11317	1617976260000	canonical
15728	3NKJKGMxQFp6tytPibq1w33MTj3PzQAZpEFk6JJDhD4aTwQKtbv7	15726	3NKVn4ZjcDzB5RtwcVLPvzmeoRSdeiFgAyRHuQkU5sK5nVAcaidy	1489	1134	253	6301	11737	jwYso1DmH8h58uVRctg731sjnhdjxuYv4Jd9JHe7PuDBZfr5XL4	7997	11319	11319	1617976620000	canonical
15737	3NLhWQ7HYfG9ydg2V43bAzXUjEUhJiC3PKeK2FQb8V5M1whXACFz	15735	3NKujKzozfCX8FGVsHjid6iLDisREoGwyaxA3fnEF6SAFxvZDXZQ	1553	776	253	6301	11746	jxBZtPHLqvu3e5L7C7rZV7pVAPTamYSPQ2oRnzMwS2BYuHsLb8y	8003	11329	11329	1617978420000	orphaned
15741	3NLn55kGWEH6qgHSEz6zTJRB8WCWySVbcNdjSfp8uFGPwrRtmmTb	15738	3NKRfSa3eAfgZQq9ZEzrTbKBnZNkM4grdvBAnowEmNK6iWWD1BaV	1407	1395	254	6301	11749	jxJ7GCrTr93rCQgQGF7LsT6FLSVhbGA3zhREhi8eVpMP87LXu9D	8005	11332	11332	1617978960000	canonical
15742	3NKU2PxatxRa2KNHUA7X4U5K4JYnMEnAWmWE8rWvScD4cm8Y6Edy	15741	3NLn55kGWEH6qgHSEz6zTJRB8WCWySVbcNdjSfp8uFGPwrRtmmTb	1460	1324	254	6301	11750	jxfAn65Hc39Jg9uBE3kjLTrdTyZTPbEuh2id2GAysoizTnN9x7Z	8006	11333	11333	1617979140000	canonical
15744	3NLA1AaSad6Rz3hvEdAxQxoGmyu9YMUPtWZD4qkSKUufpDczFpAF	15742	3NKU2PxatxRa2KNHUA7X4U5K4JYnMEnAWmWE8rWvScD4cm8Y6Edy	1578	1296	254	6301	11752	jx55qxMDEER9rxcQP8BJRvYVNzfkcjYxQw61RR6GPekqNpWtESR	8007	11334	11334	1617979320000	canonical
15746	3NKJuK2KWWFe9qFhDu126wagwtEZhhDKMXGwUXn5V4Jhga1pHNNC	15744	3NLA1AaSad6Rz3hvEdAxQxoGmyu9YMUPtWZD4qkSKUufpDczFpAF	1444	1135	254	6301	11754	jxLK2RWM8NHBXk1M7n1ad8YYEYoZwNvZoToqFDZk2reZsekijcj	8008	11336	11336	1617979680000	canonical
15754	3NL24SNDwpwag726u3aiLhqjgERM2FUaW1rwmvvKMvjCXFA1NMUZ	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	1406	1393	254	6301	11762	jxMiEo73iDmhs1L6jaJYD4v5RZCbwkFJyFoYEqcd61NZV31cWnY	8011	11344	11344	1617981120000	canonical
15752	3NKhsreSXBt1HyeNEeFq8kYLXVUe78U3dpZ6gzALKBG9UUy5xGYo	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	1407	1395	254	6301	11760	jx3VosHfBF7prHYTH7MazVWmVDVCacBJyzy7BpqU5g2wg44Jyun	8011	11344	11344	1617981120000	orphaned
15758	3NKg59j3JoA74gaMNWQ5awACDgdbqqNDt9BGP7NHNjQaedJn2z3G	15756	3NLyYS88n5dPc2o4YZhy9N99DGXiPeAs1ax8oyc85aqdUjbEoAsp	1654	1340	254	6301	11765	jy1D516nFkyjNKgQLvoFWEhP6PafGnz7MsxJEGZ1iY7thHXj3ay	8013	11347	11347	1617981660000	canonical
15757	3NKiYFyZ8MejPCcQ3qMyEMjWTyxYPQLfUf2oGcMNXpwHVUzvDJwR	15756	3NLyYS88n5dPc2o4YZhy9N99DGXiPeAs1ax8oyc85aqdUjbEoAsp	1455	1332	254	6301	11764	jwdE7HquVByBhhwPhSgqpM63TejggfNvHQFu14jEs2V5ykBKxG6	8013	11347	11347	1617981660000	orphaned
15759	3NL6M93bLyvEG8Y3FhT2ZYdxVRCVLwVoUwghy5mZ5F6LdVZXt8oV	15758	3NKg59j3JoA74gaMNWQ5awACDgdbqqNDt9BGP7NHNjQaedJn2z3G	1529	1190	254	6301	11766	jxwyWRb4336QCBp1wR2cFBTnRSfK95XoZvTXDs92nY7krhK1ifC	8014	11348	11348	1617981840000	canonical
15760	3NLhovWtYDDjkHMgDcwnhqkXxXwEAvWG9dQvASzLMbpup2C4tejW	15758	3NKg59j3JoA74gaMNWQ5awACDgdbqqNDt9BGP7NHNjQaedJn2z3G	1648	1284	254	6301	11767	jxKqWnXazpz27B5efs3KUoC2R8hU5n9uxgvs99c4RAxR3krgUDD	8014	11348	11348	1617981840000	orphaned
15762	3NLYBSuK8Dtw66x4nBwqYCRDj2BaHs1ubyCU9nbC6pcDS9RV9GHM	15761	3NKLFn5kFCCxXRpCpdEKaDEZ48LQmZajqTiUFrkAgT2ugFhsHWiM	389	389	254	6301	11769	jwEBJt4sF2DTmrr1xqVMpsLbJiS8NgMBQfdqYgFqnKbNh4ipEhV	8016	11352	11352	1617982560000	canonical
15763	3NLtFaAnvaK5swxf9RrrTrmCmCtUKkNngvT3Zjdkkp41CeeXBmoy	15761	3NKLFn5kFCCxXRpCpdEKaDEZ48LQmZajqTiUFrkAgT2ugFhsHWiM	1508	1021	254	6301	11770	jxXgL3uwjzhTjY3M1LadnMkeahNqgPbRURkuA7yyfEayMNKKUG6	8016	11352	11352	1617982560000	orphaned
15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	15764	3NLbrH2m69MrzPBNrV56fs2YZtPjQrb2LKxdpnVgZatDB5UV8wwn	1642	1367	254	6301	11772	jxiGRLVBmPmYDw59LfncohLW1fxzTZDT5btPBYgLppoUhEgW6xk	8018	11354	11354	1617982920000	canonical
15767	3NKbrZkhyCLz1oBYnifeswBeLWK9W868eG2GyosCyVRxAY7Ug6Um	15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	1579	1143	254	6301	11774	jwgZdWPDtW6bS9XvFbc2MWdjtEtmiJSEqMPZM6gk9Hvc5uaBFFA	8019	11356	11356	1617983280000	canonical
15770	3NK79GGFU5uST55AaVshrhLgZFsQVv9Bw3MvET4xiqtbyztY2upp	15769	3NL8TNQvFgg4fYERwPSCHxEtixGVr34cndaGRT4GTs1yCfRKW4Wf	1560	1291	255	6301	11777	jxjAg49jqKBVWJPwtTADDxHN6WyJD87amnMCLzVvKNHsq1ZUamY	8021	11358	11358	1617983640000	canonical
15776	3NK6Pvf4BYenJLa9LchHTVvbqmAytWazjVJ3Wf68qmRRzdP7TDVp	15774	3NLTwrcK8bB93w8fJ1etkKdsyqxCenSRcLPwJ4fhmzgvqkScKTn3	1421	136	255	6301	11782	jwKSec2WkZxGfx7m8uEVDsx6nTNViLbwfpYQeYVKLyqMue9a8HJ	8025	11365	11365	1617984900000	orphaned
15778	3NKqhD4rthvigk5ymYdx379WoTiNvh1h1rnm2rurFkhE744Kpird	15777	3NLUmnEB8CZARUNBnBFgqgcrHJWenddzqNvU4H9VmXpdvcZb5QFV	1507	1280	255	6301	11784	jwiBBcoN7QChqXca15caob35EQSeicgzJ6YH5BmytX7PUB8Rs84	8026	11366	11366	1617985080000	orphaned
15785	3NKVFXAjqzavMgBGTEDqfkqtP9yid5yqkmkcrEkjgWsJXy96PRG6	15782	3NKMCLjuzCqnz8WD25ok83AEDVg8SW4chTRjDAAnTGBPNXaMp1DM	1402	868	255	6301	11791	jwRmpHHaBvVtML8NEymoR68aG4fRu2asAYjmojq5jArbdiYjsjr	8029	11370	11370	1617985800000	canonical
15791	3NKqrVgRF1PMQEM3bCtqveWfNPCsupDFs5Wpjy3nigXp7usXqXyz	15790	3NLQDJW6mEFHgS4HjaNP3ZSS1gQoM371w9PPAWLRkGDomUbiG3d7	1671	1365	255	6301	11797	jxEu8iTXj5MivtjvoVJa1oEGQ98KBJQv2YFs6PdM1P8ALNpxZ7q	8034	11377	11377	1617987060000	canonical
15793	3NKFZZQ8W8m4SQFajYPvqE3FKYHLqWGzcN3Z3sGYwswpsv5Vs919	15791	3NKqrVgRF1PMQEM3bCtqveWfNPCsupDFs5Wpjy3nigXp7usXqXyz	1668	1370	255	6301	11799	jxWJWMVrWxzoKmnrpNFhK6TccwMCENGtM8dyitqYu6uNioJ5m58	8035	11378	11378	1617987240000	canonical
15796	3NKAAJbttAbHsF7qiHA15gM3LGaxv3GjrHyWKFb4pzTHa8Stwmy1	15795	3NKhQ36hFWttyBHNHCa87zbbYFZEM6BwTR5ZJtUo1Mq3rA2apHQ4	576	989	255	6301	11802	jxvgQCFqHpej9WiyahZc9G5EefbpkGsrRWJ3itSr4cSEWbDHveZ	8038	11386	11386	1617988680000	canonical
15801	3NLctYrdFcsR78MkMznQFMHemCc8VwR2CqAERTtyFG3JmeJay5g7	15800	3NKiyocfyj5v3WWEU1iaDjCePnoRoruJT3HA9rgEM68MBCUfywzi	1507	1154	256	6301	11807	jwBudhYUf3BSQPSb8jRLYoWXhj7EGJDVFBESQXZf9LvKPvuPSV3	8042	11390	11390	1617989400000	canonical
15804	3NKUjwr3K7K1fqSZv2CWMc9A5CvJKJwrQEbemd1ruATwXRp1hLf1	15802	3NKtV3XR5J2cUpDJZdhRqKqPojHCrvqNqUaj9pSDXVJ9qParSYGL	1647	1176	256	6301	11809	jx2ZJFF44gbPB1GUZAdxQtWGnWHocDJzwGffTsXJsMdq65E1dbR	8044	11392	11392	1617989760000	orphaned
20775	3NKi86ANcvu7f7r4eyHnesZCt11UyiW5DADZLUNRqpB9UibRyvGB	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	576	1109	377	12463	13068	jxo3dxxL9iMCTN5pA2ApHC9vsB4ioRjUxovBDQV1DWEtxAgC4H3	10439	14711	14711	1618587180000	orphaned
22225	3NLfeBL1d5dobPWe1PSmTXc5Qm9Bjc8fQsiaZMP7NayEcFK4jrTQ	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	43	1184	410	12463	14351	jwK4TWHqDZNE8VRpCJC1AJgtcU3wyX5KPoFCzpRFodyPQnE8NDh	11125	15663	15663	1618758540000	orphaned
15766	3NLdiMyiAy6rRCqtwugz5CV21ZvRBKFFUAC9SbifVgwkX4eRc9is	15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	1599	921	254	6301	11773	jxh5jUehvmK5gSnx9ixbtR1dPyzMFSKU7FLJ8WHKJvsk5o2mfUS	8019	11356	11356	1617983280000	orphaned
15771	3NLXYcwaMkTxbEFNVwtN1or5sXyVrmhL8YAV8NrPsLmySiAuAwGH	15770	3NK79GGFU5uST55AaVshrhLgZFsQVv9Bw3MvET4xiqtbyztY2upp	1560	1045	255	6301	11778	jxQBhAk4jG9A35PpGaPfu5H8HFJpFUUwKjki5A9nttQN9UzwdLv	8022	11359	11359	1617983820000	canonical
15772	3NLNm72kxeoZXgzUnBkDJvJfNE82MqF1tiHn7r5yoELD3xg3JqKz	15771	3NLXYcwaMkTxbEFNVwtN1or5sXyVrmhL8YAV8NrPsLmySiAuAwGH	149	1037	255	6301	11779	jwqw4JF5ksMmymCm4Bd8ijTbq8qWtmZYK2AUjrLJHTiu6bVnyxg	8023	11363	11363	1617984540000	orphaned
15774	3NLTwrcK8bB93w8fJ1etkKdsyqxCenSRcLPwJ4fhmzgvqkScKTn3	15773	3NKwUBwebxjD4kKb8WQ9vuuM5w5kEFn7TST2DFqJNDPYHJishMxL	369	1312	255	6301	11781	jxthVZdvfYgwD6isPcSRd3P9Qrpysv14savCW5mWd6df6orWfJT	8024	11364	11364	1617984720000	canonical
15775	3NLARTnD1E7GPcg4w97meXBngFmhacQkNy88umhG9GDbBY8N7SQA	15773	3NKwUBwebxjD4kKb8WQ9vuuM5w5kEFn7TST2DFqJNDPYHJishMxL	369	1312	255	6301	11781	jwndP9KSRUQ66cHGACLdycUkKQ1mDBAzd9CwXeWnAWVCvoP59Gj	8024	11364	11364	1617984720000	orphaned
15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	15779	3NKhbdjLrRd61F3tqpQhmHCsXDgzHUCRvNpn45o2PWMriZTSkpJu	1407	1395	255	6301	11787	jwF47UzsAd4qD4iUwcggHvCEG3oDdhD2g7XTUPxx6zaXroGUqdT	8027	11367	11367	1617985260000	canonical
15780	3NKbhsyMnrh4AFoYooSn69gAZmKBXJ3DhuXYhBVw3YjzVty9q9Fx	15779	3NKhbdjLrRd61F3tqpQhmHCsXDgzHUCRvNpn45o2PWMriZTSkpJu	1670	1282	255	6301	11786	jxKnYeSTWNkT9suFmKNEFMBazTLyjqrYc9z1Q4511CTaHLbPVJ8	8027	11367	11367	1617985260000	orphaned
15782	3NKMCLjuzCqnz8WD25ok83AEDVg8SW4chTRjDAAnTGBPNXaMp1DM	15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	1403	824	255	6301	11788	jwKDQ9CGgpqD4Jvr1MBFWmHkA8oUM8JEgp2hgGZiyHMJdKH5a9T	8028	11368	11368	1617985440000	canonical
15784	3NKkQFAGwKCd1ya7wUoeY3wiEGhajxo5h2LoWVAFn4LhjNdgTu7Y	15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	1631	794	255	6301	11790	jwP1z5X1hNSJcpgAuSFV7n5esnu92vE9AWw96y9ek2knJqpdxJY	8028	11368	11368	1617985440000	orphaned
15786	3NK5reFGqMwVZkb7RWkWrDrJrdBap5cEiHcQx4iNzv2fAjKxQgjY	15785	3NKVFXAjqzavMgBGTEDqfkqtP9yid5yqkmkcrEkjgWsJXy96PRG6	1407	1395	255	6301	11792	jxZJXRMHSW6np6iy4E4fpy3XDxN2MYQqoaTRKxmdcfpsjpKEUvY	8030	11371	11371	1617985980000	canonical
15788	3NLRC9pH8fULSdMFxXLiiuFHMFvaZu7iCRQbsKQPVNxU6aM2Q1VC	15787	3NKMPBN8ucjjhczsQYimXPoZ4SwUk1wZGRatRe51bKccfLEde2bz	1581	778	255	6301	11794	jxUGq6h4GgvGuHhc9MhkXXWBJYrQVbGsz9Pgwuw25euUeAVUGVp	8032	11375	11375	1617986700000	canonical
15789	3NKffJEY9FTmnAgr5KGn2oBwkc97uS7rZ8jaTxS4LKhAzQTqWZsH	15787	3NKMPBN8ucjjhczsQYimXPoZ4SwUk1wZGRatRe51bKccfLEde2bz	149	1283	255	6301	11795	jxtGyUcoKxCvmGjpoSQ6aZGy7dkRkQqkk17LuJ4JCU1QTPS8YVy	8032	11375	11375	1617986700000	orphaned
15790	3NLQDJW6mEFHgS4HjaNP3ZSS1gQoM371w9PPAWLRkGDomUbiG3d7	15788	3NLRC9pH8fULSdMFxXLiiuFHMFvaZu7iCRQbsKQPVNxU6aM2Q1VC	1407	1395	255	6301	11796	jy2A8sy3BcA68HjpwKjohaTk4Ba8hS8yZvApYKG21GARC2y5ubu	8033	11376	11376	1617986880000	canonical
15795	3NKhQ36hFWttyBHNHCa87zbbYFZEM6BwTR5ZJtUo1Mq3rA2apHQ4	15794	3NLZ14x4RyPyppnWTEk7ghX9MNWpcBqArLW8vXWyov8q2heKn8rH	1406	1393	255	6301	11801	jx1gb9wFYZxiz2VSUtfeeJEc7gkRjgf6Shh1cwWSvtnFWBWimgt	8037	11381	11381	1617987780000	canonical
15797	3NL2b5z24LHKXPkQDjuonw9BscqXQquLmWSsT93hP8HiuAUhwChP	15796	3NKAAJbttAbHsF7qiHA15gM3LGaxv3GjrHyWKFb4pzTHa8Stwmy1	1648	1158	256	6301	11803	jxhgrcD9eYmuASCP7Rtxw7e4QCMsA7jftZEH6RgDtH9oCooHzYh	8039	11387	11387	1617988860000	canonical
15799	3NKYWhUsBH22P8CGTqZF4zeZdMHxNfK5cGDnQHNf4nX6Kz4L4dJp	15797	3NL2b5z24LHKXPkQDjuonw9BscqXQquLmWSsT93hP8HiuAUhwChP	497	590	256	6301	11805	jwNX2bqidmyXWkEPxejsERqQh7QGtEprd8HkQzguA9RNdna1iRE	8040	11388	11388	1617989040000	canonical
15802	3NKtV3XR5J2cUpDJZdhRqKqPojHCrvqNqUaj9pSDXVJ9qParSYGL	15801	3NLctYrdFcsR78MkMznQFMHemCc8VwR2CqAERTtyFG3JmeJay5g7	1407	1395	256	6301	11808	jy2qD6oJtSzouEbpC6qbnAfthK4hAYHkbMmSmwE8DvkAdnGDDLZ	8043	11391	11391	1617989580000	canonical
15803	3NK6nqaTaVipEWGHUmy1HEYULtjmYFDBYSPAhbPy6Mux1FEWXfZt	15802	3NKtV3XR5J2cUpDJZdhRqKqPojHCrvqNqUaj9pSDXVJ9qParSYGL	1647	1176	256	6301	11809	jxzQrxVUhTt9uqkggJibRyxppjkiiUVgzBeCXigFqPeqEZgZNwL	8044	11392	11392	1617989760000	canonical
15807	3NL99ngjM3mJtgNNYjeuCixSrpG1swJAiCwhqiEdBMwU2FFFp2qd	15805	3NKwG8HPB9em3ERL7L5vujAgU5AsH3172avahf7bbnihC9wAZNPm	1647	1302	256	6301	11811	jwbib6u3HuTUdVfYdWWR5sVsvqAY5iTLfoeMVgKxbTWQzQjbWJ8	8046	11394	11394	1617990120000	orphaned
15810	3NKMp9WJzsH6ULrJPGGex1RoHykg4q92WLBscgKqWtJQioy29fkd	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	684	1106	256	6301	11814	jy1Srzy67pfFHQVEtYooJUgenqYnbqBrgv7rffa9jpYkR9212Zo	8048	11398	11398	1617990840000	orphaned
15812	3NLcZQbZfk78WdA7x4wkmCGxJnnVkZf4YarPkN7q3ZFF3gVk9wBp	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1523	1075	256	6301	11815	jx3L6Bh3yUs8fb5cSWMYn6yvrPAHriYBHSca4hZMAqaZxY3vhcb	8048	11398	11398	1617990840000	orphaned
15817	3NK9Xp8bEH9DAtfCFLYivfcGuJugL1kWV9EVnhmsvyKHXSPnwJEu	15813	3NLDpekXqQFwqUhxqA4rCYRfk8fqnNoDQiero8ctibXq6qLEpnNL	700	832	256	6301	11817	jwesbJJgsZJBWWbTazo9xudnV77sEt5ga3yEYWqW2niAHMMtb22	8049	11401	11401	1617991380000	canonical
15818	3NKf8CMiUw7z4j1JWJJwNPUkBC285stiBvnmsZiUSRZyG7yABHww	15817	3NK9Xp8bEH9DAtfCFLYivfcGuJugL1kWV9EVnhmsvyKHXSPnwJEu	1407	1395	256	6301	11818	jxVPez9gqDiCAao2NoeQpAokaZD2VdzDvDGzeTQvXNeQh85B4QQ	8050	11402	11402	1617991560000	canonical
15819	3NLQEyATusavLjNq5N1m7Cn4eAkmFft89Kr37xgjMZR1iXMpQQTK	15817	3NK9Xp8bEH9DAtfCFLYivfcGuJugL1kWV9EVnhmsvyKHXSPnwJEu	1631	794	256	6301	11819	jwfQc1KWCUnweXTufXiFgkkDLruJ8412m87tNFJttzSjJR5K8K5	8050	11402	11402	1617991560000	orphaned
15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	15818	3NKf8CMiUw7z4j1JWJJwNPUkBC285stiBvnmsZiUSRZyG7yABHww	1407	1395	256	6301	11820	jwMT5xVNcAD44YDW7cmbARLp4uSV8VTPNHZnX3xUHg8AtWEcbrB	8051	11405	11405	1617992100000	canonical
15823	3NKQZ8vwYsGA4rs6trW7qDYFa7hZS1hJ49Uw2AjKsGtKHzJAVtto	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1403	824	256	6301	11823	jw8BgyaqwBVESJfxr955M76r5kep3hVz3LgXJBCm8yqXc2bNJwE	8052	11408	11408	1617992640000	orphaned
15829	3NK5oeyiXBoPoEKH8tRj4XiMCtG5PFKXqYd2FmZ7TmQbTLpgfbtV	15825	3NLCzvFd9RDb2jbjE7KbQChE9iJCLqpcwtNjoJyrVKUKSjVp2jn9	1407	1395	257	6301	11826	jxeB6TDz2ZRtan1HEfARMfzayMAeWgiK9EHqjoHNUCcghHbVBJB	8053	11409	11409	1617992820000	orphaned
15831	3NLdaN6ZPLXsBWFcFjAR2pKh9yKw2kwUteqo4egbMdwFkx5caMM3	15830	3NKehZocn3mF8KksirWggLvT3ga84Us52oBA1EhAjBNSp5jk5u9a	1623	830	257	6301	11828	jxZzt1JBkSy961GmDQ8vdV96zkTiyfC9u6uHSh1KMA2nt5FHz6M	8054	11410	11410	1617993000000	canonical
21378	3NKuxYuEQgvGCJqvhJgGEwgDMLDbJ4q8PeG9H6cQcHPv7aLQvG4B	20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	1467	1376	377	12463	13600	jwYMJjyEkJ4iDZkWFwJtUQAKkeMqTsJ1ek5NVKJWfiYS61L9LLA	10441	15108	15108	1618658738569	orphaned
22247	3NLR5wZHFC4FGG6riqJ9P6DMYPxiFE9CnXeUHVbgKEgSEdnNJkt3	22244	3NKagRuRqCeyjPw2URv4X6XK4vRuDCyhWmQjbmqUMprjbfbDrz4h	1406	1393	410	12463	14372	jwhFPjBSTJ8kw3faoer77zuVbUqm5JwCHeTvreQZDoPBkTjDTgC	11134	15674	15674	1618760520000	canonical
15773	3NKwUBwebxjD4kKb8WQ9vuuM5w5kEFn7TST2DFqJNDPYHJishMxL	15771	3NLXYcwaMkTxbEFNVwtN1or5sXyVrmhL8YAV8NrPsLmySiAuAwGH	1631	794	255	6301	11780	jxdSoh5cXnrWYKPir2xLsA5bYg8eTkdHP7xyVbUmLcXA4YLh7jE	8023	11363	11363	1617984540000	canonical
15777	3NLUmnEB8CZARUNBnBFgqgcrHJWenddzqNvU4H9VmXpdvcZb5QFV	15774	3NLTwrcK8bB93w8fJ1etkKdsyqxCenSRcLPwJ4fhmzgvqkScKTn3	563	1113	255	6301	11783	jwYiJESqMLywChPmjmkm9xBaUW9MbL5z9GDHZG4zW8mYUpbNL79	8025	11365	11365	1617984900000	canonical
15779	3NKhbdjLrRd61F3tqpQhmHCsXDgzHUCRvNpn45o2PWMriZTSkpJu	15777	3NLUmnEB8CZARUNBnBFgqgcrHJWenddzqNvU4H9VmXpdvcZb5QFV	1637	816	255	6301	11785	jwqKhUbzBDFqjTgVA5hZXvzRgY2CYZTpmiMXoTXzbL1kCfjxU1j	8026	11366	11366	1617985080000	canonical
15787	3NKMPBN8ucjjhczsQYimXPoZ4SwUk1wZGRatRe51bKccfLEde2bz	15786	3NK5reFGqMwVZkb7RWkWrDrJrdBap5cEiHcQx4iNzv2fAjKxQgjY	1579	1389	255	6301	11793	jxYvcnXBikZYVQiger6Smf6uSP7Qy9qbW3xa2xYXCGySx3SuLJ9	8031	11373	11373	1617986340000	canonical
15792	3NLM9V4YNVoH5n7sT9CAHZ4A8s2SpaUHqeHLARMpaX4P77qi3Jyi	15791	3NKqrVgRF1PMQEM3bCtqveWfNPCsupDFs5Wpjy3nigXp7usXqXyz	1457	1391	255	6301	11798	jxRwC7FA2ffbCssFcp2HnCVGixBWRDTWsmhg4naLruqwXHFNToz	8035	11378	11378	1617987240000	orphaned
15794	3NLZ14x4RyPyppnWTEk7ghX9MNWpcBqArLW8vXWyov8q2heKn8rH	15793	3NKFZZQ8W8m4SQFajYPvqE3FKYHLqWGzcN3Z3sGYwswpsv5Vs919	1403	823	255	6301	11800	jwyZY75QrLM3xBV4NXDR55BrqHQQRUrWhVBjLjZhCFxpDjoHMJS	8036	11380	11380	1617987600000	canonical
15798	3NKEq81jShjvFgo1Mvpo5nhgRZvfRZ8TA4NhCt3cfA46WsNLxjfx	15796	3NKAAJbttAbHsF7qiHA15gM3LGaxv3GjrHyWKFb4pzTHa8Stwmy1	1407	1395	256	6301	11804	jy14BdTiL678pLHMuFvmNfLBG3qBrKcUPCYhgjodf1WM31WFjLE	8039	11387	11387	1617988860000	orphaned
15800	3NKiyocfyj5v3WWEU1iaDjCePnoRoruJT3HA9rgEM68MBCUfywzi	15799	3NKYWhUsBH22P8CGTqZF4zeZdMHxNfK5cGDnQHNf4nX6Kz4L4dJp	1602	1243	256	6301	11806	jxyFdaciz4QiEh97XUmToKku87uUPBnVNZcCmSwAVK17V4sXqLb	8041	11389	11389	1617989220000	canonical
15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	15806	3NLnsABpdMjt44GGAw1U9pxaVxJ2eoSAyCgxPeEPNpu1xRVjDL72	1593	284	256	6301	11813	jx7gCszQUuy9fwYkg7tAo68fXvKQ8ZhGpuDGmE8MCW8YuvKJXwN	8047	11395	11395	1617990300000	canonical
15813	3NLDpekXqQFwqUhxqA4rCYRfk8fqnNoDQiero8ctibXq6qLEpnNL	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1490	1148	256	6301	11816	jwBRQVHecXM46CW4pi7ghTQCo75xzPRTdihEraJCTFCGxUXGdiP	8048	11398	11398	1617990840000	canonical
15814	3NKpdeRq9U5h7SqQnPrYWrze94EoeqULxsanKZzzKtzNDrCxtxdZ	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	684	1106	256	6301	11814	jxLZn34XX5uBtuMJuVotAtFwZ55pb8hxunAeHHaUvHzmLdn7SPS	8048	11398	11398	1617990840000	orphaned
15825	3NLCzvFd9RDb2jbjE7KbQChE9iJCLqpcwtNjoJyrVKUKSjVp2jn9	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1490	908	256	6301	11821	jwfBMG8S5EhdTPqgsi6tJmLoJPSFgK1TvYSnmtk2K5tsMTYgPov	8052	11408	11408	1617992640000	canonical
15822	3NLvqLaGNSjNisqoFnh5NbZuUsBL28JrsUiTR6tMHGHiMY44FUoe	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1506	1007	256	6301	11822	jwTpERpsf6MMUiCWGr4Hfem6cS3u2BuDSFDX4Twvhc9RFwH5JTY	8052	11408	11408	1617992640000	orphaned
15833	3NLnLcTcmFAqd3H2NhWg9tsWC9rGmePVe6b4q6nRvRXatMrYa8U8	15832	3NKczHMAEDtBnBCQwMcp8ChnTFxJGL56jfQCCMTRELAAXEYxoeuw	1403	824	257	6301	11830	jwoqPxMRupwPuPREa2EJQsSGzsqKn2vEzNADUHpvbN9zYMRMBRy	8055	11411	11411	1617993180000	orphaned
15835	3NKyzeCPMAPwcn4erX5aCaZRic2EMKeytaiTWKy9nL1mqFkjLP7m	15834	3NLf9vbytu8NQaFPo9WmguX5D5nANoqXy6xJS2W2JsSTZB1rGWTm	1594	1326	257	6301	11832	jwsqxFXdyMcDZqG9kancRBeGDqMcbBKE1DhJFeTJcMLVte7A7v8	8056	11412	11412	1617993360000	canonical
15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	311	941	257	6301	11836	jwqqgwsfJzvV14NfPhMqTwQYxyjoEWxrLKiahbNwMyriPsk4mZW	8058	11417	11417	1617994260000	canonical
15842	3NLpJp373sJu4YA1CcCwyRoVJNW3HRTmjgRYgQRATjR6Cm7KzyCx	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	1553	775	257	6301	11838	jwcGsq1ZcQqe9MUJtJ3Nf2Kx7mc9Lf14UKgWyHTDHKvQDr4dN3b	8059	11418	11418	1617994440000	orphaned
15847	3NKF2WZxRYWXue85KpR3FXdFgHLiBfRoGycqrs5bU1AKd5mkdnT8	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	1619	1275	257	6301	11843	jwnij8dXgWtquwBFESzyPaxy9AqX2R8duG95PNE4GCtD6jkg4pk	8061	11422	11422	1617995160000	orphaned
15852	3NLFLuJrru2YiDAkNu8MELTnhKLSBMaDBMMDeKc6mPVJ6pHUjnKv	15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	1590	1174	257	6301	11848	jxhmYPzhMDPqM4UpRCMqL2wWJambp2L1Uyy4FEz5ZXfHdkX226L	8062	11423	11423	1617995340000	canonical
15854	3NKFXtc1UdQYFBmFXFebzDyD7A6tUjH3No1z6e7q9rEgXGGpm6vb	15852	3NLFLuJrru2YiDAkNu8MELTnhKLSBMaDBMMDeKc6mPVJ6pHUjnKv	1467	1376	257	6301	11849	jwehpnL2SUk4mQV4gWJ3NHjz5eviyMjU3mjfHJGnxTXhSJmQQJn	8063	11425	11425	1617995700000	canonical
15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	15854	3NKFXtc1UdQYFBmFXFebzDyD7A6tUjH3No1z6e7q9rEgXGGpm6vb	1553	776	257	6301	11851	jwN3B6mLF88BFFKwiMoGkGYXEUiUGZtKpSwiBzdzEF71tftoGnD	8064	11426	11426	1617995880000	canonical
15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	15860	3NLmd5yESP81CwMKvw8xnT1mQdd3ZTTEH2SF8SyKgDmrP5Xfbkdx	1581	778	257	6301	11858	jwAcQNZLTU5prNSYXkb3piASUwE7Hr4AFdGTaWtixfW1w9YSo4Y	8067	11430	11430	1617996600000	canonical
15866	3NKMvMdj52X3npgPx4mB2SiAz3rPooVvxUbKwxkpzZucJtDDKtB6	15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	1623	830	258	6301	11860	jy1SV6U98tcLWRkScMVijJor9tj1Zf8L5kMAy8jYbyep7pQ1jMB	8068	11431	11431	1617996780000	canonical
15868	3NLqu8WroFqNGbrCh71UngPK3f5s4jeK56WziP6GCMqpRGAgpow2	15867	3NKqW4drVe7MU5GfGFAH83jfWpU4oor6pdkptsAmzdXJ6KLcandB	1637	816	258	6301	11862	jwBZyyKmSBNYmaxewyo1fYmQYS488rkzVKJgkZSRK59ZYp4HfSN	8070	11433	11433	1617997140000	canonical
15873	3NKjCoH2ccMskYEvaJPuhbBTFdWRBxF8jRCgYVan9VFcBwhsVKGk	15872	3NLbTHQX7nAP1DyDwp38NW5fXEg5ZoQZGREVkirEZy2GjbAoADiq	1422	1211	258	6301	11867	jwpaMzvUNQTEhU395nGmMeGonDmnxS8FBr2ajzdMcxF7g5xDHv3	8074	11437	11437	1617997860000	orphaned
15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	15874	3NKYwmskAQ4Y3CHng7bFyQsLv3a1xjGABrFwr9j4fgp3SRJZfJn1	1646	1354	258	6301	11869	jwrBu3hYaR3Dnb949ZUE2gbX5KFdia72YESTH86q3fPjUKCxHGi	8075	11438	11438	1617998040000	canonical
15883	3NK9xqvKA44YLcwdpsa7tjAyjSahLzu5vn5X8Vp3KwEs2nrLv99V	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	1611	1215	258	6301	11877	jwPFjEmu8M1LBA4F4FhPbvLY1hDjNKcWKm14hWRmQoo47Vcr6Zb	8076	11439	11439	1617998220000	orphaned
15892	3NL6MiuNV1hrwxhqvaen3imxJbNr2kY2atKEx7AhBxG4yWps5WM8	15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	1668	1244	258	6301	11886	jw949j6kdiiYFNwjoA53AexXbc8T8MWsAmRn6rBkD4JgPiMsR13	8079	11445	11445	1617999300000	canonical
21379	3NL2eU7DxEzeR5a9gUSyfg4yvRvSsGXUgjcWFzYDtjzN4Jf3YqWd	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	1467	1376	377	12463	13601	jwW8CXsWx5DqSbLGn6XTQhkbCnJLBLSUFT12v3exDgq1jrrdqtG	10445	15108	15108	1618658768267	orphaned
15886	3NK3xDXMmTCTq4QFGoJs4MAQuV4RVPydg25TkasCT8yTF4v49zcw	15782	3NKMCLjuzCqnz8WD25ok83AEDVg8SW4chTRjDAAnTGBPNXaMp1DM	470	1309	255	6301	11880	jxtE2VMVT2tPJTL29hLooH2WdmqjF3gmqSwDWWMy9E9wVG5a2yZ	8029	11439	11439	1617998340216	orphaned
15811	3NLw1kRPBU2Ww8oSXqrWx1qSU7NinFkxmtLqPVosuBuGW9biwYjf	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1523	1075	256	6301	11815	jxMrAfuSfU84Lobex4n1L25Ng1JkvneyuPpssJ639b5G8bM8Cb8	8048	11398	11398	1617990840000	orphaned
15821	3NLbNRKqoYAazH2uvbdp744gYdmk7pfZrEGnEAwhs7rUmWp5JHu7	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1490	908	256	6301	11821	jwzPDpNc3p6pg6RRJGMU1noL9hcqzSEimLFvUfDqHsMb7hhnMk4	8052	11408	11408	1617992640000	orphaned
15826	3NKTKeuu4kaE7DwWip1zAPC943opTM239XpXpZaDhbhcMDwdS2fm	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1508	1387	256	6301	11824	jxWoFDcQxhD4E6bVNMp9BMwHpxj1iqAnhcCrcLWPmrTC1fahjPa	8052	11408	11408	1617992640000	orphaned
15830	3NKehZocn3mF8KksirWggLvT3ga84Us52oBA1EhAjBNSp5jk5u9a	15825	3NLCzvFd9RDb2jbjE7KbQChE9iJCLqpcwtNjoJyrVKUKSjVp2jn9	1637	816	257	6301	11827	jxDyy1hWqfjQm4Zf1h1EEUgRRYD1zn2SSry743qb7hHH4vscimP	8053	11409	11409	1617992820000	canonical
15832	3NKczHMAEDtBnBCQwMcp8ChnTFxJGL56jfQCCMTRELAAXEYxoeuw	15830	3NKehZocn3mF8KksirWggLvT3ga84Us52oBA1EhAjBNSp5jk5u9a	1581	778	257	6301	11829	jxdexrBej5amGbGSGeFhCpzbCinv6EAne1hg862zXXHpfSZSscL	8054	11410	11410	1617993000000	orphaned
15834	3NLf9vbytu8NQaFPo9WmguX5D5nANoqXy6xJS2W2JsSTZB1rGWTm	15831	3NLdaN6ZPLXsBWFcFjAR2pKh9yKw2kwUteqo4egbMdwFkx5caMM3	1406	1393	257	6301	11831	jwpdvKFWdLAz9RmxDRwYmVW7TLz2X9x5ybUucpMZRJ4cgwRjnPg	8055	11411	11411	1617993180000	canonical
15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	15835	3NKyzeCPMAPwcn4erX5aCaZRic2EMKeytaiTWKy9nL1mqFkjLP7m	1637	816	257	6301	11833	jxPB3xmqAJTQM59KzQXvJBtChpM3tUGgyvysy4baa3ux7rtayXN	8057	11416	11416	1617994080000	canonical
15838	3NLefTMo8ifiucCSq6f8XPQdubCK8FNm3FSWnxHP8XYvNg2ViHHz	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	1489	1380	257	6301	11835	jwZGPinKme8xvjxQyGdN9eia2GNFUeqoYPLFNU5rKi4taSJTwqF	8058	11417	11417	1617994260000	orphaned
15844	3NKDt418vWzQgwDPabexUSJwYtc2eQQ2C33bzEuY72yRRF8PbVJ5	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	1560	202	257	6301	11840	jwBYK93gJucAhaoVSM2K9nLHH7ZoVJMqANRNWCTQ2DwGNsmEqv7	8059	11418	11418	1617994440000	orphaned
15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	15843	3NKj9Xs1MtJUmd9Y73vsnTPqHDZG8heWxp2A33AtFeHUhDG5iGTD	1600	1126	257	6301	11841	jxcisVNgZqmkseFuQxqhNUXe3jBc922x49pDq6RJWV6CjyLxBqJ	8060	11419	11419	1617994620000	canonical
15850	3NLPUPjmATDCYieU9qDk8rnjRfr9w15px7Ce6bhv1MHJpcyTLAhW	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	1406	1393	257	6301	11846	jwMf1aa64EsYGYGdd3iSmNgfZ4rh7cXop3KGLuctdiD4tPMZAjX	8061	11422	11422	1617995160000	orphaned
15849	3NLFi4kFzuQTDi5hyfwehBe7G27ni8HtN8PZ9PGF4GYhACJkYYj7	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	43	1064	257	6301	11845	jxpLCruGKNqJzvYGacN3GYR6kTxtRzr5zRdjeH7pefFAPeJKUfD	8061	11422	11422	1617995160000	orphaned
15853	3NLJFgTvoqgRE9qtjC2fpsb1tY8qkhbiFcoVgpxF99CoUajoGiVp	15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	1651	1301	257	6301	11847	jxba9S4P2vPV8xUHN3cfxoGajVJv1wvHpcejwW42SseNB2fjzE5	8062	11423	11423	1617995340000	orphaned
15851	3NL9uiVAWjHGhZjh2roupQjvpuWpFtZhQexdTVoHYzndxaumPpsv	15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	1651	1301	257	6301	11847	jwP9Rvf6ymiPtRFrCx12rBb1dE6xfJA9mJ7sxxFtEp2Gr5UXkmH	8062	11423	11423	1617995340000	orphaned
15855	3NLpHAv4NY4Rh7Gkzvfjdy2sySvGXCQ4KBTo16rYFWM3M64DNaBs	15852	3NLFLuJrru2YiDAkNu8MELTnhKLSBMaDBMMDeKc6mPVJ6pHUjnKv	606	1295	257	6301	11850	jwB6SatwgsN3C2KYekyT5AGvtwW9f8m7LGXX9N5vBCUx6wSQ1QZ	8063	11425	11425	1617995700000	orphaned
15859	3NL9QLDtkpy2VzXaPLdGdpj3isW2fjwB83c6Hu9JK16PhevGmJPZ	15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	568	568	257	6301	11854	jwnq1oNUNpqpMpuLHacQtdpDz6pS6o3fB2mYjn34AyQLGAQNStH	8065	11427	11427	1617996060000	canonical
15857	3NKATrik11t5Z3At1H2KQ2WYfhsfzKdkRVFwmXKopHqtKPA1WWfp	15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	1657	1218	257	6301	11852	jwpPbvUY7Bm4nB2tnBjeU1ZmT7eswytdebmvjkz9iVfp4KBkXhF	8065	11427	11427	1617996060000	orphaned
15858	3NK7zDUUXQoW2VYrJY9F1iWQqW4Ew5kmJiDYjpFGYmGzUMTiFpma	15856	3NKGyHF1N5fXXK1b9ipXx5FqMMwvQWXF4owGe8dV6ooduMDQus9c	484	1319	257	6301	11853	jy2c1vvofGCAiSnJwPxjfGMvmCbnnGLjwf6qYnjZi63k9PnXKiv	8065	11427	11427	1617996060000	orphaned
15861	3NLMvY1V3hd94SKr1XayCiK8QsHYAGZwcrqvWbxKNEJbxGbKJuNv	15859	3NL9QLDtkpy2VzXaPLdGdpj3isW2fjwB83c6Hu9JK16PhevGmJPZ	1407	1395	257	6301	11856	jxeCkdaS3dbH8VStTTg5m9M2GKGmmBCBh93NM9SDP47ysXFpwk6	8066	11429	11429	1617996420000	orphaned
15864	3NLRekTCvhy3z6bVTPVxKuDPQfyvB7XXKX8AWuxDcjfiut1UzzyE	15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	1537	227	257	6301	11859	jwf543ZohqY3ijHCow3F2QsvpWdH75tSEUaGwNbdwX5ozUSGEie	8068	11431	11431	1617996780000	orphaned
15865	3NKNnGiq9oJgMmjS48XTDpRi2UdmDqEwoeFMeWUmToP2XWrbRKiY	15863	3NLyVqubrQsrFDoomQQAYhFBEpKrs2QV5KSg8QYh1zpHahXRnMdK	1537	227	258	6301	11859	jxWUu55n46WSyxH86fMYAJ2qYTqdXnL9PVTMa7rYYjrZABmgLtf	8068	11431	11431	1617996780000	orphaned
15867	3NKqW4drVe7MU5GfGFAH83jfWpU4oor6pdkptsAmzdXJ6KLcandB	15866	3NKMvMdj52X3npgPx4mB2SiAz3rPooVvxUbKwxkpzZucJtDDKtB6	1456	244	258	6301	11861	jwaKbF7tp7NrssvADVFhDMfeE5b4auFotF8qD9sMaoToNa93wBm	8069	11432	11432	1617996960000	canonical
15871	3NKbD1HYcBo9XnT6wwj7F7Ua2UeFTiNbLSvB6Qiet72xSQFztQyL	15869	3NKjuJMQ6cSxYoRdr269MYAhntxZjqeWbXaFnFe1kuy9A6ypWB79	1406	1393	258	6301	11865	jxpNSf6cKjpUB5UQutG3vSzUGJdS77mbnQZ7EaNRDpftXvWEU6P	8072	11435	11435	1617997500000	orphaned
15880	3NKawEjdB7EY2DEUk74PNMCp6sgJ8WjmkePNGvaXqKwpPmivQUgn	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	1406	1393	258	6301	11874	jxYThKZKiZNy27GWZ46Bihj93Tv1QoCg7g9kojz6pMtmaovJukh	8076	11439	11439	1617998220000	orphaned
15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	15888	3NKWVFM6CpjkWyfAgjYWqvcmfgjFwqLnRHvoHNnB256AyvWqdPYU	1406	1393	258	6301	11883	jw9cJtm8JgFDyMwfzNKxxTovm3JSU5G7tghvGPD7pZX2WrKyAJk	8078	11444	11444	1617999120000	canonical
15894	3NKAD28dh1rkj74hWKfbbz256QQcJjLUReUb17RvzW2g9xma4Uxk	15893	3NLDtkZ6f4zCtWjiLCR2u2rSCyDezxFsp4wi3mtjoiH2D2eEXBWT	1460	523	258	6301	11888	jxMhfmBJvYmon2tSsBnmuGRy2yPvw15rkbBP9HpswdzdWyuXmfE	8081	11447	11447	1617999660000	canonical
15898	3NLZWhsDbvwZyUfLMoXbekaKAuLzek27RVyxcR75uenuG8rf77vk	15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	1637	816	258	6301	11892	jxqVpZhefmSxbAZv2RSd1HbUr2Mpe3UCesyFisXP2TQW9gXGGeW	8083	11451	11451	1618000380000	orphaned
15899	3NKS3Hx2pGBXCfaduQDCBoUASUtTkQEgdsYhJxzgGCqtA8PZvkX2	15896	3NK6C5sjEfv2Vu4CLCtE6bLnZV2jdBULgMPpSVsX72uefdg4rsUf	1649	1137	258	6301	11893	jw73R4DbABwVAoeFSKLfeF4HA1JWwipyx1MBTA7GVova5RtREGE	8084	11452	11452	1618000560000	canonical
20809	3NKPyHV8bwiM32pyMatSt5iuV4hgS1uEBVXhV8NWzxpkQVmVWiy3	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	404	404	378	12463	13099	jwYkjNmvTCj4eAbH8PNcbDMUZCLsXTnAvgc2fw5wFvgD9Mik6Q6	10462	14739	14739	1618592220000	canonical
15882	3NLuucPMBrYLCshvdeVx3wqsfA4J1hFDqPFBd5iZLeuzm2e2A9m7	15325	3NLRQ6o4rZeV3jqmftpphwqaLDzidMQcdBybBCyNcQ1Lb9m8zoN6	1407	1395	245	6301	11876	jxtogzWgL6i9XhDtAeABUE5N6urAVqf6s6eGbt6giLSHRfeZPgA	7811	11439	11439	1617998256947	orphaned
15862	3NLMSnHXDhyEHWL4eYink9C1uXRh7NLWrWWjWKjXHZtLQEetyfGX	15675	3NLuE3mcp4igyBhHhn1PsuHSBNsgFmT9dVAxFoAUozHuFW3AMU54	171	1374	252	6301	11857	jxjj4PJTHYNAkm2MLQwLndKfqF6GwebmcDna8NP9QfaonssEvh8	7978	11429	11429	1617996420000	orphaned
15879	3NLBrZGT5iay21bN5L81HwGyXjUzTDsChPoePj6qp85PXXvSqSqH	15754	3NL24SNDwpwag726u3aiLhqjgERM2FUaW1rwmvvKMvjCXFA1NMUZ	470	1309	254	6301	11873	jwAtFy8sDPGXYC6FuRy7sqPcGA2P4busV3Y38jXHJdS7A6ZdqV3	8012	11439	11439	1617998263274	orphaned
15884	3NLCKvGHTNxZEVSLo8gGugpcMubyhUnTjzSfLYcAAgyNExjypVGE	15767	3NKbrZkhyCLz1oBYnifeswBeLWK9W868eG2GyosCyVRxAY7Ug6Um	470	1309	254	6301	11878	jwgZdWPDtW6bS9XvFbc2MWdjtEtmiJSEqMPZM6gk9Hvc5uaBFFA	8020	11439	11439	1617998300614	orphaned
15837	3NK8T5DJHCPcJ4DWymiSjUq6rymNMWqHjx5m7m7LUXYDGy6h1Mhg	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	1460	474	257	6301	11834	jwAhWiNKoWB8Sxxso9NtFHDScfpMJNYqURdponZ728qodDZGo75	8058	11417	11417	1617994260000	orphaned
15843	3NKj9Xs1MtJUmd9Y73vsnTPqHDZG8heWxp2A33AtFeHUhDG5iGTD	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	58	1281	257	6301	11839	jxHKedcdgTqTMziTzmDPFYepoAbyMuRBqHnzgjZjMYhjf7DnNsa	8059	11418	11418	1617994440000	canonical
15841	3NLUto4n9nGuSCBTERWEm6VQV8o4iUkByaE3tUkcE61qjx6H4qpJ	15839	3NL1KMKh34N7LnPJzCZdgTdMG8P9pfra6SecUt6tjytanPkzX7R5	1599	921	257	6301	11837	jxc5on9x3AN9CbaaiNrEVL3WRJMrRQLqktny49VirZ8TjqrKmBJ	8059	11418	11418	1617994440000	orphaned
15846	3NLB6QaWN2hEeLaq9dra6gjKU5pw48kPk7gGeseWJ6WxpPYRjUQy	15843	3NKj9Xs1MtJUmd9Y73vsnTPqHDZG8heWxp2A33AtFeHUhDG5iGTD	1407	1395	257	6301	11842	jwYBDezK4SGwHMXpGh2zapJ3jhzqKXfUtjsfNAdBVY3U6RJHthU	8060	11419	11419	1617994620000	orphaned
15848	3NLr4goAEJrVfUqZTdDJSkDLD8k2J7upHvr6jxt8LydGHP4e2DMD	15845	3NLw5d6WfUbH72pzDq12DWdqNnDgUBF1gnFN9B9GaMBNkpvDyPo2	1407	1395	257	6301	11844	jxAwYUqagafrX3R1VKTAzZf13LTJUXN8pAf8GJtrtvpm6eHEFtw	8061	11422	11422	1617995160000	canonical
15860	3NLmd5yESP81CwMKvw8xnT1mQdd3ZTTEH2SF8SyKgDmrP5Xfbkdx	15859	3NL9QLDtkpy2VzXaPLdGdpj3isW2fjwB83c6Hu9JK16PhevGmJPZ	1501	1360	257	6301	11855	jxoBnfZJkkmDh4WB7xnSXCq4HU3HpnRbD96Nd2YybPYPhDmki6K	8066	11429	11429	1617996420000	canonical
15869	3NKjuJMQ6cSxYoRdr269MYAhntxZjqeWbXaFnFe1kuy9A6ypWB79	15868	3NLqu8WroFqNGbrCh71UngPK3f5s4jeK56WziP6GCMqpRGAgpow2	1483	106	258	6301	11863	jw7bdnppm6CMU15AzpDcka6EhU7dRaV6Qe8kubuYzE78QbAAwmP	8071	11434	11434	1617997320000	canonical
15870	3NKUhRG4d3MUMDajdBe8eeyhPS7KPRAp1F42SeeNNtpn2KgzkFGm	15869	3NKjuJMQ6cSxYoRdr269MYAhntxZjqeWbXaFnFe1kuy9A6ypWB79	1460	1324	258	6301	11864	jwedqe1vk7UdKqbmha7z59kqZirkW7sds1mN1f6LSHAqTwWuiKh	8072	11435	11435	1617997500000	canonical
15872	3NLbTHQX7nAP1DyDwp38NW5fXEg5ZoQZGREVkirEZy2GjbAoADiq	15870	3NKUhRG4d3MUMDajdBe8eeyhPS7KPRAp1F42SeeNNtpn2KgzkFGm	1403	786	258	6301	11866	jx6cMgHXuayNNBiD4bLGGfYhLKsQuDf2hGwgqTdHERZZfMsJNb4	8073	11436	11436	1617997680000	canonical
15874	3NKYwmskAQ4Y3CHng7bFyQsLv3a1xjGABrFwr9j4fgp3SRJZfJn1	15872	3NLbTHQX7nAP1DyDwp38NW5fXEg5ZoQZGREVkirEZy2GjbAoADiq	1403	824	258	6301	11868	jxXGGVQE4cwc42dPkBgmpkbu9RQgZcBYoQwa9NAW7Ja9kEKHD31	8074	11437	11437	1617997860000	canonical
15876	3NKHHrDM6n1mfwzGkxe656ogmy7QBawYd1XMNLzoKZqE3jUZqMaK	15874	3NKYwmskAQ4Y3CHng7bFyQsLv3a1xjGABrFwr9j4fgp3SRJZfJn1	1594	1326	258	6301	11870	jwwJEpTXADbjuhA7DeyVmENpu5EBKLRapXU711TweBd6tKcEFC5	8075	11438	11438	1617998040000	orphaned
15881	3NLaQbGLHA6gbQ4HudC9H8cQvqQtMAArHiQVnJ64vV1UZx2Tgsii	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	1581	778	258	6301	11875	jxZpinGSVMgQ6tcEE1sroR6hKPzqBadAAoKFVykbFPVzzuN8kah	8076	11439	11439	1617998220000	canonical
15885	3NKyiqmE64ruQmx2YPofrXEL6yPxHkSsR3V4u3Xi3LMRMPQyEXW7	15875	3NLUCRAmJ9xzYocVkM7GkAo9JEK1AS7pyY1fPxiSqhHzitL8iFvC	470	1309	258	6301	11879	jwKofdWT3wBZb5mrs8NaCFaa8e85V7qmAjeFu63xRqEEboVEJhy	8076	11439	11439	1617998220000	orphaned
15888	3NKWVFM6CpjkWyfAgjYWqvcmfgjFwqLnRHvoHNnB256AyvWqdPYU	15881	3NLaQbGLHA6gbQ4HudC9H8cQvqQtMAArHiQVnJ64vV1UZx2Tgsii	1601	1388	258	6301	11882	jwxvBCXhE2MU4D2L4Mt5QAojnQTqRzp4GT8ZwGJD3faQuYL1p7C	8077	11441	11441	1617998580000	canonical
15887	3NLQ8sJFba9TY4GFA5paXFr8wj9bx16aKozSutB61qdC3FMJqcro	15881	3NLaQbGLHA6gbQ4HudC9H8cQvqQtMAArHiQVnJ64vV1UZx2Tgsii	1402	868	258	6301	11881	jxbj3zmKXrp5Bd32FWUM2iwVkLjSm9XayJtHDorC14xZ528jpeT	8077	11441	11441	1617998580000	orphaned
15891	3NKRAQQ2sP5JZgpzE2jXZywiJZ9mH53714P2YyuevCKkpdxRgWHq	15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	152	964	258	6301	11885	jx11tJAv8ZUG4Aqwcgm8qrCXk1aE3sTmhDs6RqvVzhx3HCSJv6R	8079	11445	11445	1617999300000	orphaned
15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	15894	3NKAD28dh1rkj74hWKfbbz256QQcJjLUReUb17RvzW2g9xma4Uxk	1631	794	258	6301	11889	jxkB3Ei5jib4umZAr6XtFczrnZxY6o8bLkXZz6NzibLYPJmLKnZ	8082	11450	11450	1618000200000	canonical
15896	3NK6C5sjEfv2Vu4CLCtE6bLnZV2jdBULgMPpSVsX72uefdg4rsUf	15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	1402	874	258	6301	11890	jx83PVVktjcg6MFc7BBZZ88rkLzXPz6jXYyGFsbW8oybR5G5pfk	8083	11451	11451	1618000380000	canonical
15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	1637	816	258	6301	11897	jwaJ6g9XBArAAsuo4iN5ZNLYbehHcbG1TpgMpTuSzW4F3K7MEPc	8086	11455	11455	1618001100000	canonical
15901	3NLmQq1PY74ypPDmNrLWGjcAdGxu2VT8uELMnMCXFeEKGYiWUyqz	15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	1483	1030	258	6301	11895	jxQzYEszeHmbmVHMzDZbFYsxn4gTNrHP1EH3cEeATBwDNp1nEFf	8086	11455	11455	1618001100000	orphaned
15910	3NKKGErrthrV4725MgGcUPVzZRWavvwCRmsDUYJutCAnkpnaSLno	15909	3NKEBd91Kyo4JPPogHrPJrB1kP9eqRoTCogi68XRV9jGpXmonaXi	1405	861	259	6301	11902	jwK5vWwPRZeYFmWfwK4u2iDqfpRnUa1asg1rHfLTHtFbZjE33Fo	8089	11459	11459	1618001820000	orphaned
15912	3NK8w91zsbuF8puFvH3nseAn6QfWaViVUbjyEojH5w2PLWVE3J73	15911	3NLb3uR9fYfjT4QZ9wEKU6KnrgFiUKMuBDx52onFQMK2j5V7kzP5	1578	1050	259	6301	11904	jx9EFK72HkV6CBGPQ98RPriRmuuiUg5w6nvZX5sUGyiePCcqf1A	8090	11460	11460	1618002000000	canonical
15929	3NKj7dEv3GhchjpHrnEuRnjiKsC7p9hoeaKc7tziW7WDW1AdxYKu	15925	3NKmn1WHcMFZ2ZAadAXWioRPcA8T2c9Sq9opHLfhh32DiueGxWtx	606	1295	259	6301	11920	jxcuG76XMhhT1UXzHKWBKULkCqHMcHoxoDLXAA6byjMaES7Aeew	8098	11471	11471	1618003980000	canonical
15932	3NKKynnSRHWifn8bhcSE7fN3tV2Eafeku5CZn6xPyk2xcNyN7HB2	15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	1587	1231	259	6301	11923	jwbFMDzYKF2JE5mY1BtdWi1zGv5Qw9NqKE6tJUWMsRjyRGd5dTL	8100	11475	11475	1618004700000	orphaned
15936	3NL2PLPuTkYic12wuBktwZBji6jJszRb3YLNV1wJZX2Qi8fLLB7B	15934	3NKjL1A5dh7f2Ucw8Q45HjzEZfxguUDiSVZbMiUDaCQ46jeXwZd5	1573	1192	259	6301	11927	jxC6BSE1LN2H7cnXQqopB7rfzje7PvL2mjHBL786SxMPX7AMLut	8101	11476	11476	1618004880000	canonical
20811	3NLne7hb9sMz46dPKtJEFb8dZF3bU4dLm4iQenFSLwa6eTS7oA2F	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	1651	1301	378	12463	13101	jwcrwwYf2HdmeZQyrTsTRJ9kgDbx5T4f7vikJbJmFAr2yvEAMZA	10462	14739	14739	1618592224450	orphaned
15893	3NLDtkZ6f4zCtWjiLCR2u2rSCyDezxFsp4wi3mtjoiH2D2eEXBWT	15892	3NL6MiuNV1hrwxhqvaen3imxJbNr2kY2atKEx7AhBxG4yWps5WM8	554	554	258	6301	11887	jxuyMzC9hNi6ppZm6eHKs69tj2rskecWT7AAk8gZHiFP473VzEf	8080	11446	11446	1617999480000	canonical
15897	3NKr7Q9bLG3g3HajdugyffQ7CnDz1rvh4aKRhr8PnejCcyiynU95	15895	3NKSpTzh4J8NdsNJh4oBhzKukaV6sLdkQ5aLBYd4euyKraYSakLt	1607	1348	258	6301	11891	jwqqeekBCx3xgwcpvXPk8Cs1b5sJArdHyvnU8fgGSzfrXntL4bG	8083	11451	11451	1618000380000	orphaned
15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	15899	3NKS3Hx2pGBXCfaduQDCBoUASUtTkQEgdsYhJxzgGCqtA8PZvkX2	1672	1285	258	6301	11894	jxw7r4sHxRHSAmSuseCe599j4T7AEs7opuNSMx5gerdJsxRuboT	8085	11453	11453	1618000740000	canonical
15906	3NKFfzu5jj2JpPyLmr8nJxsvKnpsoHMGm5ckaNQmoYAM2bHmkLUp	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	1581	778	258	6301	11899	jwnbhuyPYonNCiwGzHCjrx8FTXDUYn9XFwUTLeM7zA1tDNRYyaU	8087	11457	11457	1618001460000	canonical
15904	3NKSRprKbCzpxgHVDLqsR4cQCbr5gPCcDrwoQv1UzAZgNRJjUGuw	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	448	1059	258	6301	11898	jwio91N9rHQvQm129DmvXLoXY5g97PUSVuChXDVmcEjjjsWxzBM	8087	11457	11457	1618001460000	orphaned
15908	3NKWPrd8BwxVULhxFfWJefjvMBhV2rY84Mg2cd9VB1Azy2Eby6Df	15906	3NKFfzu5jj2JpPyLmr8nJxsvKnpsoHMGm5ckaNQmoYAM2bHmkLUp	1637	816	259	6301	11900	jxYsiwwspcaQCw7ZppTUm7A9H1W3jBtYn2TkmhXnHX6knyKzWq9	8088	11458	11458	1618001640000	orphaned
15911	3NLb3uR9fYfjT4QZ9wEKU6KnrgFiUKMuBDx52onFQMK2j5V7kzP5	15909	3NKEBd91Kyo4JPPogHrPJrB1kP9eqRoTCogi68XRV9jGpXmonaXi	1534	1317	259	6301	11903	jwhLjr8XfkHkAakVrtAZ64rW8h4NHuVmo62YJUqNtSNDHFSgYy1	8089	11459	11459	1618001820000	canonical
15913	3NK5kQwZy6MxAcKGde8zCpuNs2WpWZ72C5PjwukZVDmj72nwUr54	15912	3NK8w91zsbuF8puFvH3nseAn6QfWaViVUbjyEojH5w2PLWVE3J73	1546	1339	259	6301	11905	jwYZxjWdBNgw9gEH4nnpdgJyHE3FHWqNEJ2zREPRLgwVwUGrJWh	8091	11461	11461	1618002180000	canonical
15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	15913	3NK5kQwZy6MxAcKGde8zCpuNs2WpWZ72C5PjwukZVDmj72nwUr54	1624	1208	259	6301	11907	jxaWQqJV8ntZKFnGej98fNkzyB3yjrjvCWxUDV4yMEQXPiENZoX	8092	11463	11463	1618002540000	canonical
15919	3NKF1cfHaU9RgDZ9ttPkSVqufQn5cLrCRTjmj2RuM2bwPbfVUYc5	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1637	816	259	6301	11910	jxHYAymf4g5KjnyKnUZYe5LtkpwfHY5Xwb9gQABZprCtFS8ho4w	8093	11465	11465	1618002900000	canonical
15918	3NKitEFyTPsSBBjtjdaQuPaFD3wqETRGXSWHwLevaWAa2RDyi9JZ	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1419	814	259	6301	11909	jxwGfMWdLiPdLFgeThA2Nj6ULGCzNXzxib8XkSPZ2ui57ywGpMj	8093	11465	11465	1618002900000	orphaned
15920	3NLYG4S9WVK5GT6J7tssAqwT7P1iJ7xQZZLhjj75aRxJfMsPvoLy	15919	3NKF1cfHaU9RgDZ9ttPkSVqufQn5cLrCRTjmj2RuM2bwPbfVUYc5	1600	1126	259	6301	11911	jxhrGRcJdbS4wogpA7hzzGCVPQV4sqDseYMpqWZ64EEcEznrzW3	8094	11466	11466	1618003080000	canonical
15922	3NLZrwpNURukbeofbptPpsLhCZzsb85fqBkyZgaofvQVt4miMSLF	15920	3NLYG4S9WVK5GT6J7tssAqwT7P1iJ7xQZZLhjj75aRxJfMsPvoLy	576	1355	259	6301	11913	jwbWbCpQaGLp2fyR6QXr5s82WjM65L8KtcHS7CaEaGaEpuTxCtT	8095	11467	11467	1618003260000	canonical
15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	15922	3NLZrwpNURukbeofbptPpsLhCZzsb85fqBkyZgaofvQVt4miMSLF	606	1049	259	6301	11915	jwfbu7QkfCYzwNLzzMmJrm73QSGUy5y7hynzwfXCFX77oyuoiUK	8096	11469	11469	1618003620000	canonical
15923	3NKmbwY8sHkc9MvqfTxD7XWLexaMcHBW42SBEnN7r89vxqcnZkvc	15922	3NLZrwpNURukbeofbptPpsLhCZzsb85fqBkyZgaofvQVt4miMSLF	1516	1294	259	6301	11914	jwoJBojK6kuHDH2MU763R3iJeCMTzx5QZo6eZ4obfFUZHz9x74u	8096	11469	11469	1618003620000	orphaned
15925	3NKmn1WHcMFZ2ZAadAXWioRPcA8T2c9Sq9opHLfhh32DiueGxWtx	15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	1553	776	259	6301	11916	jxgVtCFk4xQ3WDpcvbsbWAQTkpCWjLUbjKefghtAHhgL6oWg3ag	8097	11470	11470	1618003800000	canonical
15927	3NKt4BoEMyYmt8FYQGvWCt3zW3N2vfUbDoXA4V6YYCdyEwJN8uLF	15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	1631	794	259	6301	11918	jxtsYJwnTPYAqnxeRxto5VkmB9tVTbwTbQmhuWodnq22BYwWSnR	8097	11470	11470	1618003800000	orphaned
15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	15929	3NKj7dEv3GhchjpHrnEuRnjiKsC7p9hoeaKc7tziW7WDW1AdxYKu	1534	1191	259	6301	11921	jx9DGCr6TQJhHvSjNMMRtvney1vWgU4rmoi8iApSQU96ypexW1D	8099	11474	11474	1618004520000	canonical
15933	3NKy3Mp4oQGqyh6qEnJKj66DxK12wGJbijJUDFZsS5ZPkEFdbFsx	15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	1407	1395	259	6301	11924	jwc3ninJhvx8umfcnvtCrwxmhekHByziqmZaQu4U2q6x6WZYHzy	8100	11475	11475	1618004700000	orphaned
15937	3NLVLCL4q6obLajYYWF1wLYXyCqcMkQusLpzAjMZWYQfNHRNMK3X	15936	3NL2PLPuTkYic12wuBktwZBji6jJszRb3YLNV1wJZX2Qi8fLLB7B	1406	1393	259	6301	11928	jwtZASTzZ2cgAEpySvNBneW6NyvJ2FMy5w2a83anNm37Jirj7fy	8102	11477	11477	1618005060000	orphaned
15940	3NLJv2uH5P3jx5SS26acHR58BGSXRTSvWgJL75k5Y3HvanMUVK7C	15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	1654	1340	259	6301	11931	jwosNY9NkJQiSqdfocyRRa7x8Q7wk4buUFsZifs2Lf1ZgJmBZUb	8103	11478	11478	1618005240000	orphaned
15939	3NKLQesdg7As9viWZZymAtaXTek7YADFiQyQLmcFJok7p3WG2q1o	15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	1407	1395	259	6301	11930	jxAbUR1aWp2svAKB9sfBKZSipS6xz1qFnSigVvRZTyFBEXzXe9x	8103	11478	11478	1618005240000	orphaned
15943	3NLnduptEzdEXNpyZMzjMNGHoHPCpf6hxBqoSVdgJ7imroc9b33x	15942	3NKTSZKgvMDrSmyvCpdFTWte5UaBBMEgxifG8iWEo37qB8yo9tTX	1489	1380	259	6301	11934	jwvsAPvuJndHSVLkrtvPAxuet6SSYSXFxUWh71jSg9WsM5dCCNB	8105	11482	11482	1618005960000	canonical
15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	15952	3NKumYNNhYbtkLmzhUJnQvGJBXMu37YDuaGXDuKx6nHR2Wmwe735	1617	1288	260	6301	11944	jxxU9cwBnEenqZizQV361Ja62xUJBohkdGxtP3ao9ZLyrdgPJA8	8111	11489	11489	1618007220000	canonical
15955	3NLvZtsG2GhAAZFoMyv1vedfN4E26PCEaxGtdjqpUGGySoy5qUww	15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	1527	927	260	6301	11945	jxAG4y8HW5ZXXEFwzCRgc4Mc4JMaNPwVgqYVqziijKupiCBn2xd	8112	11490	11490	1618007400000	orphaned
15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1587	1111	260	6301	11947	jxS1fkCVxRjTt76ZjfqiCztJGq6ghYAUZE1TVRyFEzFJWnka74p	8113	11491	11491	1618007580000	canonical
15964	3NLE8PJum9J3BDxJ9Z49vAGbrku8kE8Uc8d3bb5XvDp39BVzC7Ct	15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	1652	1069	260	6301	11953	jwS4TCHCoRCZ2Nd974aJatMutVFAUeiJJnqDcyG3KRFi8A1NU9D	8114	11493	11493	1618007940000	canonical
15962	3NK4E147zXkFJiTaBmNjmsw5ypif7yNyQq2obPDfQHHzm14N38GW	15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	1471	1386	260	6301	11951	jwHKe7K6xWRtQJNgE6VWAnmHmVnLmRVwpvDSJVp9gj9Cpa19bVL	8114	11493	11493	1618007940000	orphaned
15970	3NKfPDa6wdT9Maf27DA14WWXybBAgXZQKPL56GGTrimRkMSMn6og	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1523	955	260	6301	11956	jwKX47YisXUAWR4VwSQCoXQkqBgygafLiMyKdcuS9fzrQT1yCmq	8117	11496	11496	1618008480000	orphaned
21205	3NKmuvwaKsK9mvkRLVoL45ZduHbYnDMeMNKDWXwXf5fBAUv1CrLH	20867	3NL4ucRdAXi6ra9Ko8ECoHiZKZNWTbPLoK7mZXDMmtPH6KuR5NgB	1647	1302	379	12463	13453	jxRTXoLG9jeJvX8ssgEGJqwESj6Ts32GFvQYaaFnvqoxpKQ7tc3	10462	14996	14996	1618638480000	orphaned
15905	3NKxn2ESvefkRswsix73ar2QuEG3pVUqvFhBokXLBEaoJWQifkBo	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	448	1059	258	6301	11898	jwio91N9rHQvQm129DmvXLoXY5g97PUSVuChXDVmcEjjjsWxzBM	8087	11457	11457	1618001460000	orphaned
15909	3NKEBd91Kyo4JPPogHrPJrB1kP9eqRoTCogi68XRV9jGpXmonaXi	15906	3NKFfzu5jj2JpPyLmr8nJxsvKnpsoHMGm5ckaNQmoYAM2bHmkLUp	1419	814	259	6301	11901	jwsVFYLrNPZTkeiug9di6W8Z98NdbXfsHC5zFECe99Sf99vZM5U	8088	11458	11458	1618001640000	canonical
15914	3NK9cLQMp9nuodPdTAbgExDwNjVeY5Lqqf3t6asrXkN5U8waegrS	15913	3NK5kQwZy6MxAcKGde8zCpuNs2WpWZ72C5PjwukZVDmj72nwUr54	1581	778	259	6301	11906	jwuYg5xuincu4DqtSvvkJ7jGSDzGtrLosLFbiX5HcwtVF6qq8vr	8092	11463	11463	1618002540000	orphaned
15917	3NL7w1DNHjePvRJNwXBkgmSwNS8KdjoYjzijBuo1JZ5kJWVy24LC	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1505	276	259	6301	11908	jx5RNAZamUYyRdJ4aghR8Z3oqJF7NCipnyi5kmjx1H5eWN2rbkH	8093	11465	11465	1618002900000	orphaned
15921	3NLtPzqpxENUk1eoyzPyfo9ZftSQshdM2u8h2feEa8tPHmxmNz9o	15920	3NLYG4S9WVK5GT6J7tssAqwT7P1iJ7xQZZLhjj75aRxJfMsPvoLy	44	1079	259	6301	11912	jwpVdMrYfVBVVkjB48jxXSBu3Rrc4iESBKMh8EHGLr5SS4RCAo9	8095	11467	11467	1618003260000	orphaned
15926	3NKr1G1XNiHDYGnLEeZa8vqoTF1ubqTMCL6JPd8KzNiZMEkeCJQk	15924	3NKTYVbw7jEspZpUT717n8sG6ugsx5q8U9Sea7fsA5caoy97GgaR	1405	861	259	6301	11917	jwjJYsbiUp6oEx6sFCEKbF2WEnyafcZshrap8rZT88yKi6eEnGz	8097	11470	11470	1618003800000	orphaned
15928	3NLJXgrT3Dk9QiB8iGHQTujDi2scQ87oFdSBeh5TEmLk8iiMyFt1	15925	3NKmn1WHcMFZ2ZAadAXWioRPcA8T2c9Sq9opHLfhh32DiueGxWtx	1407	1395	259	6301	11919	jwLUqdfMyv2iQxUbSERW1p2P1XZNAFLKAGhGhdhbmngqZVHz6Sg	8098	11471	11471	1618003980000	orphaned
15931	3NKmtkGz7EWUgzZYeW5jR17rnpqUjYMZMwEjrH7PB7ZCEVdLTKdv	15929	3NKj7dEv3GhchjpHrnEuRnjiKsC7p9hoeaKc7tziW7WDW1AdxYKu	1585	1240	259	6301	11922	jxcbYBfdinEwxUDkmdzF6ZBk3Btqj8DwQc3YGK877zLME1Cx8AM	8099	11474	11474	1618004520000	orphaned
15935	3NLQURGSQVct9jMNziLWKTmfCVhga44pBAhE6HpWvon8noLPcgFP	15934	3NKjL1A5dh7f2Ucw8Q45HjzEZfxguUDiSVZbMiUDaCQ46jeXwZd5	1407	1395	259	6301	11926	jwot935CHaNiH8rU7hW3qcyptmvCLsEqZUDpNHfLUZyxWbJq4TS	8101	11476	11476	1618004880000	orphaned
15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	15936	3NL2PLPuTkYic12wuBktwZBji6jJszRb3YLNV1wJZX2Qi8fLLB7B	1407	1395	259	6301	11929	jxwoyoQwExSkqnPhZgKFzTPXojEBy28Ye71tsnyX29vD2NRbtXJ	8102	11477	11477	1618005060000	canonical
15942	3NKTSZKgvMDrSmyvCpdFTWte5UaBBMEgxifG8iWEo37qB8yo9tTX	15941	3NLRmoP8gkNVjKpY5EgpXG2HYz4ggGGrx39fAzBaUuqedVsC6mib	1406	1393	259	6301	11933	jxTmXpZWXYS4u83sraGdYWvqwNJwrQWLfJHgyrzMo3JdrnYhBUu	8104	11480	11480	1618005600000	canonical
15945	3NKudg9xGiTKZzCJRd5id8i22cf8BjwoYXLnJjKiKSNn4v5i9gtL	15943	3NLnduptEzdEXNpyZMzjMNGHoHPCpf6hxBqoSVdgJ7imroc9b33x	1637	816	259	6301	11936	jwoLbjR1mCQ3u5Jpq4FYEq76Y2HQ2GKuC2rNAW2uQGAaRrkK2Dq	8106	11483	11483	1618006140000	canonical
15947	3NL6mRaUqbsZNtWfHrxKyZLAgYdyyCKWvbSsEwsn5FfN79v9gSeT	15945	3NKudg9xGiTKZzCJRd5id8i22cf8BjwoYXLnJjKiKSNn4v5i9gtL	1407	1395	259	6301	11938	jxpDqQGMaJXw1ASCZj2KDAxXyfrxNsSQH8PrLH29jDY52c4R1VN	8107	11484	11484	1618006320000	orphaned
15949	3NLqueQojxJ7EZHQc5N7kTnuuj78xn1ZBYFo15aPBYQXct5wKBub	15946	3NK8ttuxKkzAqsq1whSaTwJJu1A713KPJQSGzr3FnrXUTQ8Wi7rk	1631	794	259	6301	11940	jwNiC72AnZJimaMiHzdyHovf9KcZ1kjYL4k5GTXDSiYo9FEm6av	8108	11486	11486	1618006680000	canonical
15950	3NKbV7BgUPF15uvvL38YDDJ7QLsq61o6xNnyBDNnnf7k9wUd1r6Q	15946	3NK8ttuxKkzAqsq1whSaTwJJu1A713KPJQSGzr3FnrXUTQ8Wi7rk	641	1090	259	6301	11941	jwQwixtL8DzrvkrdP1vNLwopFkCU8pEjmrTfZVThenfjBz4n9ay	8108	11486	11486	1618006680000	orphaned
15952	3NKumYNNhYbtkLmzhUJnQvGJBXMu37YDuaGXDuKx6nHR2Wmwe735	15951	3NKQjDDnKaaP6cPYmtwRdejbZJuPPZKFfDr13wuhYQvyH5FHcCdp	1440	1377	260	6301	11943	jwjJYzAgKt5RrNChjp4F93x2J5ApHupL3Q7uEUqhxsczMVkfLMZ	8110	11488	11488	1618007040000	canonical
15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	1527	927	260	6301	11945	jxAwx2SPAXa35jJBPPodCJzVzY98es52s91jyJr9CwyTwUQ2KhY	8112	11490	11490	1618007400000	canonical
15954	3NKwTch9NZSdhkmPybcJpjVAJgduQ7LkxgoGY2bAUHyeXQuJMR2H	15953	3NKmt9rF4ecY4i3rL7QbWjSf4HvL6bDW9pBythXDxLiYK2DZzhwH	1527	927	260	6301	11945	jwp4DR6iv9K7RhJ44xWU43mhpRqFp72KtSUH6cuc3CzFJXhrRb9	8112	11490	11490	1618007400000	orphaned
15965	3NLbm6EXTKiRGfRSRehDjCTkZdPbN3XPKwoi28HwvAUd6sy7aMZF	15964	3NLE8PJum9J3BDxJ9Z49vAGbrku8kE8Uc8d3bb5XvDp39BVzC7Ct	1426	1364	260	6301	11954	jwkL1TpzjmzYDt1FSW33fZRbEDb5A9sj6jnG9j6TwixZsvpfuQ6	8115	11494	11494	1618008120000	canonical
15968	3NLCZKbjXa78AcAXxJpPVDe78TpaR1xavJypKbuPHWQdzQwwyxtv	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1407	1395	260	6301	11957	jxS1fH8ZesUCo6YwH3sXXJdRaWi8uprMySTNQkRAp65vfGEa3yw	8117	11496	11496	1618008480000	orphaned
15972	3NLhsUKZiRhXhuso7k464oDRGXv6ZS3YAAUV84EWC8hA98nRTrr1	15969	3NLm44feNh2KhP2o6SnmZy9Srni7paQXvYUBQhXGMLJu4gVYtzrn	1458	1323	260	6301	11959	jwxFhE79nPCj5b9CU3YB61ea1ScfSKH3GTPrT6816pKZJcXS91K	8118	11497	11497	1618008660000	canonical
15975	3NLHaEJ2sT8hCY2kj9EeokaacB7FQ7Aw3vYGemuFtLVH9FutvQNx	15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	484	1319	260	6301	11962	jxPP3VUDkRCDSH22Sy3rAKAQLZNVXyEVY142NfZfkqwgbPLzGNZ	8120	11499	11499	1618009020000	orphaned
15978	3NKA14mWs4XBEHQ4Bj3cMxv52A71VtyoTqsz3rqqVXak355mfVRG	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1422	971	260	6301	11965	jxckAAeLkiULsTQxbq2vXqhoN4DHWNStGQHmpLTxKhUnxfDAZ27	8122	11505	11505	1618010100000	canonical
15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	15982	3NKfzysfSbJSdkh7EGP9n16PqyK5eCZaSiP7NfqhBCQL6thcAaCn	96	96	260	6301	11970	jwNpCk14cGg2HcePftfWgQFEheUEjovbbK1Y2xhNdnhS1dL8KfU	8125	11509	11509	1618010820000	canonical
15986	3NK5Jnc6VaK2gay8eBKzumVgSwVEJLKvfy9tfwUrdJ6h8Yr2AWoT	15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	1402	796	260	6301	11973	jwNSUE3CNaFZW1hH8bRVCbqPuXzf7cg7MbUY4MVt1u2CVXrXHUH	8126	11510	11510	1618011000000	orphaned
15990	3NLjJJSgxXWEXnoFD4JZ7t82kjb2AmKRSyj6MUeMCuEg81s3Ywhz	15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	1527	1167	260	6301	11975	jwdrt6TsqawPaASvHxSACBMk22BtBCRF6mGLDuL3A4T5saH1fnZ	8128	11513	11513	1618011540000	canonical
15988	3NLW3H55GcjDU3D7aJPRjt6dbdwtv3t7Cs3pHFjB6vcRQ89bkRgf	15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	1527	1167	260	6301	11975	jxASoSjvZXkXefiERzyjht2N2bFVSCxkwnAtxah1Zx83KwDjrQU	8128	11513	11513	1618011540000	orphaned
15995	3NLtGJe7kVKhDDJE9tPvNNiFwNzJ1QBviJQSfRRQhL5E2PH4vj2Y	15993	3NKxhA5UYyFbEmG4GyjK42HfE3P3iNYB7CPWVwSmPWUV9RFboaBh	1406	1393	261	6301	11980	jxRPuLCgGQFMzG95J21VpFyRnGx7jxqMxFPR93tGydKmY7cUR4M	8132	11517	11517	1618012260000	canonical
15998	3NLqqQ2SZiwWonZXw9hYA5acdov4Cze6aovYPTd8BRwetu1YB4g4	15997	3NK8SYAG8rFJEdD8XHf3qX71Jzuou4EtBKyQrSBgNTQ9qj5fCsCR	1651	1301	261	6301	11983	jxHL9bZm6VMrnspVfpxFZJMJmGTehr1dwA9mtiXCxymC8zovDxT	8135	11522	11522	1618013160000	canonical
20820	3NKT4h5zJRoxQJ9xKfkix9F4u1gZusjhryxd4VP7tLqwqCe6PjNV	20814	3NLZH8sZDweybvo3izRdx2UJyH51G29VHbmkFEfTB9HW2sHvdzwV	1646	1108	378	12463	13109	jx4dq7aZHE5WKr1wk2dxVE14THhtNdvDaceAtWxeydEC7a7wNEg	10465	14742	14742	1618592760000	canonical
22265	3NLbbT3faH2kyLfGi9Nw7ELBLWj3syBbqSWMBdaBDE3Fvu7LwURt	22264	3NLk2cLJ3jj51nkArY1MUuTF7Eo7fbMitjfVwoA4mCxYJ6GkaiqY	1579	1389	411	12463	14387	jwUutWWHqUNboeNiWGCoHXN8bkPiUk7huiUdJnMmBxDWtzHbAXr	11143	15687	15687	1618762860000	canonical
15944	3NKsqjiy1EbikkC9nUYT6HZfPVm1pDRpccbCbCtKZwzvGCiRedXG	15943	3NLnduptEzdEXNpyZMzjMNGHoHPCpf6hxBqoSVdgJ7imroc9b33x	1406	1393	259	6301	11935	jwmTFQwnN1FQAGejrqYUBciJQt2N9t4BxkLMLREtakPTNGVTZ4y	8106	11483	11483	1618006140000	orphaned
15946	3NK8ttuxKkzAqsq1whSaTwJJu1A713KPJQSGzr3FnrXUTQ8Wi7rk	15945	3NKudg9xGiTKZzCJRd5id8i22cf8BjwoYXLnJjKiKSNn4v5i9gtL	1529	1316	259	6301	11937	jwLAjho1W4in6zLrN8Mu1ZKRiXBA5vdAuBAttXPuYYn532rfngo	8107	11484	11484	1618006320000	canonical
15951	3NKQjDDnKaaP6cPYmtwRdejbZJuPPZKFfDr13wuhYQvyH5FHcCdp	15949	3NLqueQojxJ7EZHQc5N7kTnuuj78xn1ZBYFo15aPBYQXct5wKBub	1637	816	260	6301	11942	jxudzvD6UwRZRfzxQeKXBi7kHbMHgF9nxZdj7VWrCY3nWdevB3b	8109	11487	11487	1618006860000	canonical
15957	3NKrX7sqy8LDTo3v7oyRW2Di8pX2psCkncPbdCaPkZEyF9DYrqKP	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1406	1393	260	6301	11946	jxFgEerDiyV9rxVZNGPppxHMnw3oSNxED2eaFD12t9iUESV5jvK	8113	11491	11491	1618007580000	orphaned
15963	3NLLGNNGbLDhj2qRC2kEqUSZ2CGjVXGbKPmRLoKxQGZrjEUQdMrw	15958	3NKoGJp63qWE7ji9FZSrBTwdTo6EunG6RfbKumM3WKVES9GszhYm	1623	830	260	6301	11952	jxn2pXcLZKDqctLweAaQgnNx6rQ6cKCQ8YaMUYz839QaActcnCW	8114	11493	11493	1618007940000	orphaned
15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	15965	3NLbm6EXTKiRGfRSRehDjCTkZdPbN3XPKwoi28HwvAUd6sy7aMZF	1481	790	260	6301	11955	jxC99EZUB2QkRrMZZVgcKfiEKugp9z5cbwkhTkroKPcyQNFoRXG	8116	11495	11495	1618008300000	canonical
15969	3NLm44feNh2KhP2o6SnmZy9Srni7paQXvYUBQhXGMLJu4gVYtzrn	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1523	955	260	6301	11956	jwbpUz8suANWRtwM9Kt6fWYjH2soVWXnHLfxy3qaLDyJw8dKKVC	8117	11496	11496	1618008480000	canonical
15971	3NKqWqAkH7NDrFeQCkmdJSnZtUAS1ejrZ8SYfYbZtPAvJYhqQZFV	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1403	824	260	6301	11958	jxzXGAUu5fRn9H8wY1sbir2c73Jx9dPWjLyAALpUGr4u6Edyy5f	8117	11496	11496	1618008480000	orphaned
15967	3NLFU2j6kUFu5gQaxq2UfoWJyL74rAn4sbvnK8ciYyCfSri5Ru9n	15966	3NLMJPXVanbsxjJfwfeWLugTrj4Y6BYZaTkGoP9ceqBn322PGq6B	1523	955	260	6301	11956	jwyQif6ff2U6sV8icEFzt1g3nfJUfgz7BUA2kNv4QZNYQm1TtgP	8117	11496	11496	1618008480000	orphaned
15974	3NKKz1NbgcYDgxHdHYTUSwYFMtZiLDyHgqktGxi3yEXYeWP6HvL9	15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	1553	776	260	6301	11961	jxkKjYQdqG86KcGQb7AyVXm3gbuKhZxAYCMH3LQkwbseSddsVUM	8120	11499	11499	1618009020000	canonical
15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	15974	3NKKz1NbgcYDgxHdHYTUSwYFMtZiLDyHgqktGxi3yEXYeWP6HvL9	1573	1192	260	6301	11964	jwYun8ip19pn6otHTV4owbmB6aDbG9C8ECbSzYdzuKK6XQiqbVp	8121	11504	11504	1618009920000	canonical
15979	3NLFsuyHzBGBbArRrEhJuX9F5gHdsbsAmP3ppw5DyQt7Zt6uFzun	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1483	1030	260	6301	11966	jx8oBzpJCR43gEQaazWkbEPZeABkNbEUx3asSfkXEQLdYjbtj6Q	8122	11505	11505	1618010100000	orphaned
15982	3NKfzysfSbJSdkh7EGP9n16PqyK5eCZaSiP7NfqhBCQL6thcAaCn	15981	3NL2iaz48Pe2gyDasZW2JyC4TBKqhZPXH9frvHgoiKqVkRQARLKE	1507	1280	260	6301	11969	jwLeG2KymzPvNf1KehLNbiXpMkQf8gVkvSrFHq2Lx1n1Yk9HLK6	8124	11508	11508	1618010640000	canonical
15985	3NLCnjSPW6A7wfqXFAtwuAcWUB8zcMEXSFcZHnqTL568AdFqWRNT	15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	1619	1275	260	6301	11972	jwtvHN7bbxz68duXDSPrKFmwaV1WDBsytXtnH6GEQ5U1MXKwJkZ	8126	11510	11510	1618011000000	canonical
15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	15985	3NLCnjSPW6A7wfqXFAtwuAcWUB8zcMEXSFcZHnqTL568AdFqWRNT	1553	776	260	6301	11974	jxzGfSi58gFLR4vWtvhLn4aViYXhcfe61xtogvKw2RkXiBvtMbG	8127	11512	11512	1618011360000	canonical
15989	3NLXRs1nhqaCDtvzLWV5iE2tyftqQEUMJqZd3YgPYjfbRV4wG2aZ	15987	3NLTFymp4E3Vw68TtZtLffzvDCcYQtbU4P4skZ2UCzzJpYoj9SPk	1527	1167	260	6301	11975	jxrjiAzPeyaAnCkJySuc11kYvUGM9xmNBx6uQsjEqkQQYdUhm8H	8128	11513	11513	1618011540000	orphaned
15992	3NKzXL6UQ5Hgxu9zJCRACtp3azW4JGeqnqAeeuE1h3o1bGSb18GS	15991	3NKXKidvarFMkZHz76PtzGEEWVuQkehxoWE8x94aA1N37kVtXXK2	1553	776	260	6301	11977	jweZLAfwAXfT8NsHuvLXKjmuXF3UKJUrV7NhFE6s5RqRzjfuaNe	8130	11515	11515	1618011900000	canonical
15993	3NKxhA5UYyFbEmG4GyjK42HfE3P3iNYB7CPWVwSmPWUV9RFboaBh	15992	3NKzXL6UQ5Hgxu9zJCRACtp3azW4JGeqnqAeeuE1h3o1bGSb18GS	1407	1395	261	6301	11978	jxHmYrw4aaNWfec4fdHjj9sgCUkVLZiHhFFPhLr4vnCcUTCWfEM	8131	11516	11516	1618012080000	canonical
15997	3NK8SYAG8rFJEdD8XHf3qX71Jzuou4EtBKyQrSBgNTQ9qj5fCsCR	15996	3NLgERvybuNL1ScjHmrJwqD1ZrWdwFM7LJQ5FZ4UeX815wu8BKZq	484	1193	261	6301	11982	jwFmrZSVtp8sc8MvY6WTEH7fgH2YVXiPNy2NhYV62bEXAtiSkPK	8134	11519	11519	1618012620000	canonical
15999	3NKNU3S7KNfsBuX9vp6x4mTaoc3kLZTafiG3GwMvVNsXt97EawJf	15997	3NK8SYAG8rFJEdD8XHf3qX71Jzuou4EtBKyQrSBgNTQ9qj5fCsCR	1651	1301	261	6301	11983	jwGU4zS4EDYPC5hYAUz41dGjKapqVqVBYHZciRys6EnUprVhXGK	8135	11522	11522	1618013160000	orphaned
16002	3NKJJ2t6hFSoUa8YCcBy4owSYwBVh4zRQYiSyw8PjSFCUFPGfdLe	16000	3NKzbHGzm3pTSwXX96VGTAnSBQWApBgeQeQqYWxrNTdxpGeHMiTo	1581	778	261	6301	11986	jww2NqT63vfxTvk5CzG6XQrQEicDUdwEJPHvAUrULcgJBcJJvxF	8137	11526	11526	1618013880000	orphaned
16003	3NLmB7HCn5gw9nJZHVeQn4ns5ifRzJFbuDjRTyfuuF5XHh2uHERc	16001	3NK339cMGouMJQz9wBJJdniksks75gs1yvgwKkdjH6aKT1PDRMWb	1631	793	261	6301	11987	jxcrXGPhd7hmKE252nNrUHweNiVDXSEGzzVucLN9KEF4uiJjND2	8138	11527	11527	1618014060000	canonical
16005	3NKx8VqESRytWnUbhrCe7TKKN173Bqn4fWbPBQ1xjPtnD3MY1Dzm	16003	3NLmB7HCn5gw9nJZHVeQn4ns5ifRzJFbuDjRTyfuuF5XHh2uHERc	1483	910	261	6301	11989	jwGNLcmbQngd1Z8XuCvLLDpcFDnWt8hM546CgX1sKHgrEMMcMAy	8139	11530	11530	1618014600000	orphaned
16009	3NKSuWfxpoCZhNKxmbcoovVzaYKuBjtot1HphstCkkE88vJWW34a	16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	1553	776	261	6301	11993	jxkSYkaM5d929yrFDJ7FzkiXxNbeoxwcSEjU1NU8zpuZA4j3nam	8141	11536	11536	1618015680000	orphaned
16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	1522	1322	261	6301	11995	jwjGHH3cgXUsy1Unmo1uKqMo2vg71RhPu7LLuo4DgQg1St2jKUh	8142	11537	11537	1618015860000	canonical
16017	3NLemKk576u7NxKp57DDAUT7U54CngAoEusu1WRP3pYVAE3b8TKa	16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	1503	1031	261	6301	12001	jx8NP8icdNakSzec2JnWYtNTCEDrwdh4gguHC8b38zstwvLeBcM	8144	11539	11539	1618016220000	orphaned
16027	3NKq8efsnWmbZ5F8yamDj4bwKtpcwdtgqpzmJgnwG5AemLQGGsC2	16023	3NK3wPg8BSsUUhgpwAVijsP8JwCx3AXB9pyKrvXWqSVhJtLhBrLJ	1405	889	262	6301	12010	jxmnGe16RZ61QgdWuHqV2VmX9rfdVHqrL8ACHB6oYVPKs7H6TS9	8149	11546	11546	1618017480000	canonical
16029	3NKAfZmkkCstd6wxM41QvrF3WrH3SGF9g81wVPPhhJa4KDKAbjgD	16028	3NKrbiJa2g18mzwnbWqp9xSkpqBMZkXjYg92fvfH5ozt7NpvAQBv	1406	1393	262	6301	12012	jxKZbnecjuPPPr6hX7wgmiw9UEmGDvPfcEG3ehbvjR9Kp2zGxr9	8151	11548	11548	1618017840000	orphaned
20825	3NKCeDK57Zbmu2jVS48vZZWTV9jVQPawUZWD15743XjWxAnqdjNf	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1476	1245	378	12463	13113	jw9ENV2zddSBEbjYvfDWCxnKLJ7wqrG6MpwMopZ2Feor5a7wCKx	10467	14744	14744	1618593120000	orphaned
15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	15972	3NLhsUKZiRhXhuso7k464oDRGXv6ZS3YAAUV84EWC8hA98nRTrr1	1445	1290	260	6301	11960	jxo4LxctUoQi6Hu5GeoMt2xQnPzfNQLbRvStw4BzBtwpMz92d4g	8119	11498	11498	1618008840000	canonical
15980	3NKkgueHStfivcr1sLHGWKorima9nuLADVTYYPQtVYD9bmSUme9F	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1447	1219	260	6301	11967	jxLPLNWBwWhzZuTgubQDkevfBsaWsg3tc3DhHR8gdWY8NbYULxo	8122	11505	11505	1618010100000	orphaned
15981	3NL2iaz48Pe2gyDasZW2JyC4TBKqhZPXH9frvHgoiKqVkRQARLKE	15978	3NKA14mWs4XBEHQ4Bj3cMxv52A71VtyoTqsz3rqqVXak355mfVRG	1445	1290	260	6301	11968	jwWF6L5YGt9s5DzfnMhHZxBx5BYf48aWSKPJfNVsuVthzy4PzaM	8123	11506	11506	1618010280000	canonical
15984	3NKcW2zwejCWNfcnz4MRLsR8PRiPhvNPyvgYNqFGfr4DYwhbsqHz	15983	3NKxNMhtpvGeVGZdsCVH2BSYdSFMj4U4S2FujwYbHgREHhoLpxHK	1458	1197	260	6301	11971	jy2u5B5QYQfLPtqTbsMbb2GjmchzHi8ufTJfkrnVzZn8iY7AFqZ	8126	11510	11510	1618011000000	orphaned
15991	3NKXKidvarFMkZHz76PtzGEEWVuQkehxoWE8x94aA1N37kVtXXK2	15990	3NLjJJSgxXWEXnoFD4JZ7t82kjb2AmKRSyj6MUeMCuEg81s3Ywhz	1631	794	260	6301	11976	jx1iqpp6UTpL1uR1VSC4TgJ5thZXwPAsQm1qLiq8TkF3HwMD2Ze	8129	11514	11514	1618011720000	canonical
15994	3NLVWi2Sg9AHfjufyZ7K6XhnbFxnUmmQvaaVMUchdpsvz2cEJZXy	15992	3NKzXL6UQ5Hgxu9zJCRACtp3azW4JGeqnqAeeuE1h3o1bGSb18GS	1602	552	261	6301	11979	jwaBXHfTneEwCon7J3H2RMhHRPGRMkhebL2kexquKEV5os2NJvd	8131	11516	11516	1618012080000	orphaned
15996	3NLgERvybuNL1ScjHmrJwqD1ZrWdwFM7LJQ5FZ4UeX815wu8BKZq	15995	3NLtGJe7kVKhDDJE9tPvNNiFwNzJ1QBviJQSfRRQhL5E2PH4vj2Y	1675	1342	261	6301	11981	jxanYBVWpfwh6MxQVebxEjy2ZXNV2PHg9NvgYzHTEFw17qA2q8z	8133	11518	11518	1618012440000	canonical
16000	3NKzbHGzm3pTSwXX96VGTAnSBQWApBgeQeQqYWxrNTdxpGeHMiTo	15998	3NLqqQ2SZiwWonZXw9hYA5acdov4Cze6aovYPTd8BRwetu1YB4g4	1451	1166	261	6301	11984	jx2TPR8yZtzY18nZoLNv8e4hnndwaJbfVY8baDexV8tQ7B68iob	8136	11525	11525	1618013700000	canonical
16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	1406	1393	261	6301	11991	jwRny6meXwRS2UqCwmQRu6j6FyYTmJGnSY6LE9i8SuY2yrZzLXz	8141	11536	11536	1618015680000	canonical
16012	3NLQb3hskVyWy6sVyNrWjRLM5FB3ujyPvUfUggH5EtyADVbG66eC	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	80	1273	261	6301	11996	jxb4v6HohsCTKy6BJE6xjtwDwF5YpGxBLDzspnbtkqdknNQSNeH	8142	11537	11537	1618015860000	orphaned
16015	3NKpfRxUifxwyZrywRBrxX6zSPNdpx5bQ4hLU7Z3HvdZP1HKnvVo	16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	1647	1302	261	6301	11999	jx9EqVy8stS6EJqkcJH6B9YhW8tAsm987m3Tr4gTBVCKyVQLwWP	8143	11538	11538	1618016040000	orphaned
16018	3NLhSUHkxUCGx7zSsRyqwEKebqUFpc9QLXnu4sL4BTi7oZVrbof5	16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	171	1374	261	6301	12002	jx111BLCLYW2QY6MB2Utfke7RK3CELQcYrRWpDkvKjww81rwDXG	8144	11539	11539	1618016220000	canonical
16020	3NLSKKosWff5dQdCwtVXV93acPiyGD7dan2nVYDpFi13E5wvGKzH	16018	3NLhSUHkxUCGx7zSsRyqwEKebqUFpc9QLXnu4sL4BTi7oZVrbof5	632	1382	261	6301	12004	jx7fqW69QJMRg5oed4DVm8DYMCvzRCQJGNREw12vRwQbW9yhTQL	8145	11540	11540	1618016400000	canonical
16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	16021	3NK3an3TY2m6oKfasjL922voB4oR9ivVMME3MG7cSL7UbQ4eap5c	1656	1097	261	6301	12006	jwvhH6qHZoUwR57j41wLmwwyB7qrvSG8hRkNFbjcN6AwaMXj7si	8147	11542	11542	1618016760000	canonical
16023	3NK3wPg8BSsUUhgpwAVijsP8JwCx3AXB9pyKrvXWqSVhJtLhBrLJ	16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	596	940	261	6301	12007	jxBXDc2c9rf84qw5c8hoq7f5j1oaoNdrTY2S28TqWofMVsCMcvg	8148	11543	11543	1618016940000	canonical
16025	3NLTLys3JpAmXbbWFZ3WjeFJPE3WkjJTEU5ekyC4sCqo5YRqkwnn	16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	596	940	261	6301	12007	jxBXDc2c9rf84qw5c8hoq7f5j1oaoNdrTY2S28TqWofMVsCMcvg	8148	11543	11543	1618016940000	orphaned
16028	3NKrbiJa2g18mzwnbWqp9xSkpqBMZkXjYg92fvfH5ozt7NpvAQBv	16027	3NKq8efsnWmbZ5F8yamDj4bwKtpcwdtgqpzmJgnwG5AemLQGGsC2	1553	776	262	6301	12011	jwqoUowLV2rRR76JHLNbyunmRjfj21msDqEjWG8AGBdynyjunWN	8150	11547	11547	1618017660000	canonical
16030	3NL7WJFsGUekhEHRpa5SqRyxcep8qhuGAymY1Fys27qL2gyoQ1vt	16028	3NKrbiJa2g18mzwnbWqp9xSkpqBMZkXjYg92fvfH5ozt7NpvAQBv	1637	816	262	6301	12013	jxAkqQSi6jJr7MibcHtpB8BydgX1NSANzz18E9bJsZA5CJRtEwY	8151	11548	11548	1618017840000	canonical
16032	3NKC8CEgXHpqxYyWp9tiMkeh4DmYZMwc1A97rKztKgRsvyCLSkfy	16029	3NKAfZmkkCstd6wxM41QvrF3WrH3SGF9g81wVPPhhJa4KDKAbjgD	1467	1376	262	6301	12015	jwbvYF7rwE8DMLKMurtseoMsoAnDuberfcLDpcnxoPiDDhoybhA	8152	11550	11550	1618018307528	orphaned
16033	3NK3pbXB1YH4weo4jzdjYR51ZV7rg7HeWSjBDLxL3nudGYWmaZgC	16031	3NLojjtyC9hFMJFhzxbYjRBdDnmyMghgQ5ZpsRYsbWwhYcTMRRrg	1588	1146	262	6301	12016	jxiDrY1aNoSxvbWAKpH1RoErhS6aBoyABdJDi1HQUbzgSK5pgdF	8153	11551	11551	1618018380000	canonical
16036	3NLxthGvGNwU1vQMDgyZog7CeQtQnPc594jaGoFDhfGLCaX8K2fZ	16035	3NKi3NkRbMpECDzYZhfk1xkdGLCtGZ4MWeVerwduYHVfaioPe2nG	1419	814	262	6301	12019	jxwZDBz7JW7EDiUGPwvZ792L6MYDmokUcLTTNRXzc5ci8e9PXVD	8155	11555	11555	1618019100000	orphaned
16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	16037	3NLXwuMhMfTEfTRhjDFn4Yfsx4LzteVCbkVZaR2qZFwgSiELUNxn	1440	1377	262	6301	12020	jy3C7fwo1QySEwYBMWBPmMNxGVQR1ZMVRcVjqheSGSW755ZSNyt	8156	11556	11556	1618019280000	canonical
16041	3NKKyp4AsBkrwXVJ4TYoKaKPEj2Q8adS6jpo1b4QAnMtL4DzvGcj	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	1631	794	262	6301	12023	jwaLhnLENU2YcnMDX7dWXJ3DwNABc4RqzYgcHPyKRyG18FqVNm9	8157	11557	11557	1618019460000	orphaned
16045	3NLBToHXDm3PkiC1HhSWykCdQe9k8BBm33EjVEyna51RDmrRdCiA	16044	3NLjutvUwYr5Xf912TPjef4TVyUvwsSfwkvMu4AFYG4GYffVVzuh	1406	1393	262	6301	12027	jwhcg9ZfhZPdUgDa8N6u1Jey8H8hDVHMZmfJzZkKubFfSBJZnkL	8160	11560	11560	1618020000000	canonical
16047	3NL3NB9gePxaUKDsK2F3toBtr5dFDGCGS1GSXhwGVM7ayzCi597H	16045	3NLBToHXDm3PkiC1HhSWykCdQe9k8BBm33EjVEyna51RDmrRdCiA	1559	1353	262	6301	12029	jxzLdfwj5TTLPnGZh4ra8qY92ZWcDkahiUsSuMePmcJFP8AN8Ai	8161	11561	11561	1618020180000	canonical
16050	3NKGWvBDRUHAqB2SLs8okS36DAv6UDqWP9vqrE3L8GSdzuBSX3tJ	16048	3NKv3ovbKTbPKPTF92YSTvFkWVw6F81HmvEEE6y6oQKeonaV4EG6	369	1066	262	6301	12032	jxTvQQ9AczzfKVj7q2D12Z6gyqgdgTe3yTMSmT86cafPTUaCHC8	8163	11563	11563	1618020540000	canonical
16052	3NKpZgjPYVfDa8dFSjK6pTJA6CVJUASWSvevqZgR9A1mGhnsipSU	16051	3NK5ppJmMvW17TAvT5Z8unbc3WBGN5AoSZxGQkZRW6NdiBW3kdaR	1599	1041	262	6301	12034	jwAuJ7RQNjp1jArn1cRVUC2RgcDFvESiLuJvxWFj4e9mT6eFisR	8165	11566	11566	1618021080000	canonical
16053	3NLTQUmob4yYXty5VC8c1JrSit1hvmGbSFSWksPmXtnkaDnjKVmk	16051	3NK5ppJmMvW17TAvT5Z8unbc3WBGN5AoSZxGQkZRW6NdiBW3kdaR	58	915	262	6301	12035	jxaTDcbupKBQiVR9c2CY1Eg1JnoENrHHDc3LssGAkoKw15c9NwZ	8165	11566	11566	1618021080000	orphaned
16055	3NK4R6Fi4bm5xG87K6bv983RXai9Ja2AbDzkSk7g2i4R7wKQschy	16052	3NKpZgjPYVfDa8dFSjK6pTJA6CVJUASWSvevqZgR9A1mGhnsipSU	1406	1393	262	6301	12037	jwUJ24sXqk7Yi2fLGEgKYuHCtgtUptK8Uii1oaY5BDfNCybw5pf	8166	11567	11567	1618021260000	orphaned
20830	3NLKTkrFqEwzr7taqtiNWQCPhkWaMkBDCeqTxaccocAENW1AU37r	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1529	950	378	12463	13117	jwz76ZSwPgY7bPctCih23MCaaAckzkbWmMQYGVghq8rEpTfZ9xG	10470	14747	14747	1618593660000	orphaned
16004	3NKE7pT9eGrk3BW3UuHSUFXM3sYLvDtrVWGiwjgxw7bZHSpEE66Y	16003	3NLmB7HCn5gw9nJZHVeQn4ns5ifRzJFbuDjRTyfuuF5XHh2uHERc	1406	1393	261	6301	11988	jxN2pdBYQF9Y9E1Ab7xp8kaEPXZRhtK2wadmHL3qM1YsU7vx3ai	8139	11530	11530	1618014600000	canonical
16008	3NKCAGL4jeG2iVHv8XRg7kJYsc2P7o5SAKhnAZRDwzZ8GQZNGd9u	16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	1451	1292	261	6301	11992	jxmukmxaQPbXLfaYtZUrq2yFzRyGVAnNueYhFDhYQAzEh6vSbwG	8141	11536	11536	1618015680000	orphaned
16010	3NLsrgQkNveHTU1dxQ7z4yjrMYQqajEjZkKW3ik1FxJ1zZKqMFg3	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	684	684	261	6301	11994	jxTMrWNQnFvciGuBL1GVwBzry8o12Mx1qmiqxTakZ1YZ5rVLkhK	8142	11537	11537	1618015860000	orphaned
16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	1603	444	261	6301	12000	jxoQX9mQC77cdbqSjoAmKqK4MpsBo2x2oGczzUd3Y26Hkif5gqG	8143	11538	11538	1618016040000	canonical
16014	3NLJnNu243zvM6avdiHShSoSwXFKW2tPrnk49acGa4j5gumihNwY	16011	3NLua8d5LcHXxWqfTQjQkooH4JMC5MXfTMqcNnM5D3MZNgRQSp3T	1503	1031	261	6301	11998	jw6sZ9o11X9sDfB2j3t2jmVR1u2wuvAVd1gguMHujP5uyFAKUFH	8143	11538	11538	1618016040000	orphaned
16019	3NKXqbh7CqQBKisbDXESXLhpD5ExG8XCtTK7dPudKrNxWTjEhxv3	16016	3NKoozDE8G8BLZnTv6dKGnmmMFnRjjMmePMDqxeZwCrY75uY2m7Q	1633	1144	261	6301	12003	jxt4J1GGQdaU9U3taiTcekzFcs7ef23Am2FTdCCmwtkKmWqRBiq	8144	11539	11539	1618016220000	orphaned
16021	3NK3an3TY2m6oKfasjL922voB4oR9ivVMME3MG7cSL7UbQ4eap5c	16020	3NLSKKosWff5dQdCwtVXV93acPiyGD7dan2nVYDpFi13E5wvGKzH	1405	891	261	6301	12005	jw7NpGqERw5ZLwWnKQZasPTvQBL6htLenzuoK4VTbwJAArC17ib	8146	11541	11541	1618016580000	canonical
16024	3NLgEs1NGEmAKtKcFvTeK1TjHTQF19di7grJqgBbzQ8Rdj2MPNru	16022	3NKM8ttgzcqzDYK8TDf7NRV7GPAoDXFFqqWKMKSVTTk6VypNHpQR	1564	972	261	6301	12008	jwsrVuwxsUpbEax1eLsZGrskS9zxF1o7coS9zJMJ6XbjXdo37zT	8148	11543	11543	1618016940000	orphaned
16026	3NLr68L6kz8pdpyapQ4WP5phvSk9zbkC5PangtydWtMjFBfzqGXC	16023	3NK3wPg8BSsUUhgpwAVijsP8JwCx3AXB9pyKrvXWqSVhJtLhBrLJ	1403	782	262	6301	12009	jwDxK2nvjdcsA9uwDfTZ5oLY8iy7gH3iNG9URtAPrX9DYmFQ5ca	8149	11546	11546	1618017480000	orphaned
16031	3NLojjtyC9hFMJFhzxbYjRBdDnmyMghgQ5ZpsRYsbWwhYcTMRRrg	16030	3NL7WJFsGUekhEHRpa5SqRyxcep8qhuGAymY1Fys27qL2gyoQ1vt	1467	1376	262	6301	12014	jwuMi5ECi1hQajniLFPHxWAx4XJvUhV8oTSyndmbYKCKAc3q2mC	8152	11550	11550	1618018200000	canonical
16034	3NKZtCDDbjB6XALHaNDtE6V4omsxwi9U3EcDENwMyYkfdJnbaDNn	16033	3NK3pbXB1YH4weo4jzdjYR51ZV7rg7HeWSjBDLxL3nudGYWmaZgC	1656	1097	262	6301	12017	jxyeavMTL64vx3MA3kxzyA6YkxKyTyG3TZHLVJdsGjWSeqK4o2L	8154	11553	11553	1618018740000	orphaned
16039	3NKvExQtzD6ZuawWJmzGEQoQsL3fBQhBYfRUy9rr3fsfFRZwKVW2	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	1407	1395	262	6301	12021	jxqJSPNqVnUVdc1mXELmEX4697BDUjmC1Z9edfETQ4CkRciYFeT	8157	11557	11557	1618019460000	orphaned
16043	3NLQQdKRVnQ4umr6AZrwHkJkNEnmMtpKEP8segNM56c3GwkuyuzX	16040	3NLBVEQtcZjJNLgKTXuNknnbHxaERkKeWemyA9TmzjxnCiXAUkmL	1602	1369	262	6301	12025	jxHrfR7JPdsH3HRrT82tbKUWAfi2TfDaxbVfD9AtrG3uHKBYXXR	8158	11558	11558	1618019640000	canonical
16046	3NLCQPZ82FMPLWpLFVf5GEwJpFvayoHkPyirSWk61dFrJNoYZHtA	16044	3NLjutvUwYr5Xf912TPjef4TVyUvwsSfwkvMu4AFYG4GYffVVzuh	1654	1340	262	6301	12028	jwc64jhdSQNGYzLMHPJLXHoFRQhnVBqbgML6pNYpa1PBbmvNWFE	8160	11560	11560	1618020000000	orphaned
16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	16056	3NKZhor6uEArx1mneTAtgf6hEiJ5Z1VjUNuJxagXcLtSLHeBNnWS	1546	1339	262	6301	12039	jxF1jDHXwtjRN7odvK8F7dJWRaZxDWptU6ppn24TghccygQdkoM	8167	11569	11569	1618021620000	canonical
16059	3NLr9ZA9989MVbUqrsWLN51AGMVvB57N7rhUgDvEFZh2HsQYSP4r	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1406	1393	263	6301	12041	jwtNxPSh2RzdEs3KJDpzZuWsBYkHRsHfYt5oDJBXDFkai8JeNg5	8168	11570	11570	1618021800000	orphaned
16062	3NKUtuGf26CMGyqzcrzdFR9r6roHDFp1CUhcRTtyjgS4AtHkMvhL	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1483	193	263	6301	12042	jwGHG6hP7UiSAeyuP1ggTfwbK2mL48QWHZQvPKLC9wjPd1qjPQ5	8168	11570	11570	1618021800000	orphaned
16066	3NLaeiVnaGHfVVYLRiHUzUivY6WGhWNp7SRv5iRZaWougZhSA4TE	16065	3NKyuUHUfbYZzuQkqK11FDgDFA8VaBouNHErhu6hEYPznuFWMsiS	1646	1354	263	6301	12046	jxNTPfqiGDSxUkrvSCKCLsDfPRKb5RejrWPxWZnmdhsNSVxDG5D	8170	11573	11573	1618022340000	orphaned
16078	3NLLe42y8dij5mLEy3a88FTpUKQ1K7vWTqekXQw8icKgtkzSCvru	16073	3NKU4NUFEyiSj7BoQ5ZHNdzTYzkAXCpcmoMpwv4U55CHTo4SQnrn	58	1281	263	6301	12056	jwJdkkgH1Q5z4nqSQm7RLNdTCdgK8iRptjHmdcVJvdtoPZBzqio	8173	11578	11578	1618023240000	orphaned
16080	3NLKuA3G9ASTSDH8zQEhdPyktWKwpq66dqakxRHLsV7jUiThGhEo	16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	80	1027	263	6301	12058	jxtcqtF452PXT8MMbWELwjRjAh4anXKwrLueA6k7HLkPDqg61ry	8174	11579	11579	1618023420000	orphaned
16084	3NKhsAvCotjejXg5DeLGzZez2B3caQaJkHvZMaBgvbcygX4Bujxn	16079	3NKXLwQNhhy7Kcy2CSkZKaBMPVn8DzueP5sw7EMR6JVyJWeDFr4R	149	1283	263	6301	12062	jwXYcCX2FiF8k2LxLJZa2gfNopFFJq9an7Uc4S1KaU18xmiqJQn	8175	11580	11580	1618023600000	orphaned
16088	3NLvuhmK9QURWwBVzYWLXvsauviRPSb2mKbA2iyqx8GwtEpBr8d4	16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	1490	1274	263	6301	12066	jwhmRNgBHoEBDxJHP5mepF6EbALCjTJpK1mg3Af3wnabeHwjNc5	8175	11581	11581	1618023780000	orphaned
16087	3NLWJGTbQxgEEUn78mGZEXeN5P1iN5KxASaKXKxMEdFtuqdBv9df	16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	1522	1196	263	6301	12065	jxL7WRxkYdMLYsXGp2PXhkH91fvYMrfANriRWbaL3sXehwMiYfS	8176	11581	11581	1618023780000	orphaned
16090	3NKbvhyfKi1WipAdAMJteA33ogQCBXV4RhFKwK54gNuetfHE2WER	16089	3NKuNZfnpUVCb81TFPMuYrPaRB6rNhq4P9X1UAZQek7TJW3AEupF	1406	1393	263	6301	12068	jx6qzZAZkR4qEvxSWnXipTENXJZWmbjm4cMdR48iUVgLzRJCmz7	8178	11589	11589	1618025220000	orphaned
16102	3NLpHRLgMd9Q6MwVG5eZaQGTBoboGRQAiXu8A4hrNtiLEdjLSkHU	16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	1542	1058	263	6301	12080	jwuLqeLnCS79JuN6Y8DpTDPjxD81JSRYLdsEQr5Um4y7wRLw7dV	8185	11598	11598	1618026840000	canonical
16109	3NKJmAcuo6rGkaZ63Nk3fNYcPL688uTdPFrzq2pML5pH5yHt7tnA	16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	1601	1142	264	6301	12085	jwpy9siMTkSmVayVpmT44PCR5VvDVufGZFxajE6z75XfChiQu9w	8187	11601	11601	1618027380000	canonical
16107	3NK6SUribEqrdmZKQKPn3dvopxzVz5zHEi222L9DPNTG4hddEF25	16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	1609	1333	264	6301	12083	jwMSM8uQLzGkEdxg7co4dmkvCx3DZXMAd87pHmMddpotmoSDR1T	8187	11601	11601	1618027380000	orphaned
16115	3NKKJFFCrP5PxVT6QZvRY8SUva61PL5nHw4NQzqFDXLDaTfJXLcx	16113	3NLeP5MhauCV5ByraDTTMzThH4Wse8Siec3gfGS6oopVTF6tknSw	1623	839	264	6301	12091	jxFbiuTq1GqeGBS6PQ8u6fRqhginjJ7epQ6yXCR5F4PJJoVaoqr	8192	11609	11609	1618028820000	canonical
16120	3NLC3dLGgvYYkiwEPZhhLP7LRXrPJYimiBuQDNPdNBJYedTTBg72	16119	3NLe85sd1U2YQ3kAasijpJ7g9zUJpa1Y7MrjAAShTtDUDakHaQ8g	1458	1323	264	6301	12096	jwf32WQqRg4YSM5BfRfsfo8vq81kcowZjfJ1SXzbScXh596xkVv	8195	11613	11613	1618029540000	canonical
20832	3NLrKd6Qz6zpWZkZcNrdKWiYRziFeq7xpqnFePQGSTXo2ZYXj7bh	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1403	782	378	12463	13119	jwa4joRkJVxH4rx6w3KoDz48W9Ui7PkqGNsV4LP26wAYmSHq7dm	10470	14747	14747	1618593660000	orphaned
22437	3NK6FSByGZYSvbh5zb9bkmPRoiBhPCMnjKYEMUAWAnSh8zJnM5Hb	22309	3NKr84ueCwbPCPfjL7QiU6na6UbQzNwxo89h8MJhQebhBPKHUd14	1607	982	412	12463	14548	jwxCMDSbSk2ALiNWLa9D9yHQDQtaMBb9bxZqBQv4CRkb3T2tJDv	11147	15806	15806	1618784280000	orphaned
16037	3NLXwuMhMfTEfTRhjDFn4Yfsx4LzteVCbkVZaR2qZFwgSiELUNxn	16035	3NKi3NkRbMpECDzYZhfk1xkdGLCtGZ4MWeVerwduYHVfaioPe2nG	1419	814	262	6301	12019	jx6frjbLBKV1UK1DCo3bGpwgLU6LNXLutgmb8NxD2q4uaf78Eed	8155	11555	11555	1618019100000	canonical
16040	3NLBVEQtcZjJNLgKTXuNknnbHxaERkKeWemyA9TmzjxnCiXAUkmL	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	1578	930	262	6301	12022	jw9zBCLztPkqALX46vfKe1GJ85ixyRq5JnzQN2iCzU23AFjHMGo	8157	11557	11557	1618019460000	canonical
16044	3NLjutvUwYr5Xf912TPjef4TVyUvwsSfwkvMu4AFYG4GYffVVzuh	16043	3NLQQdKRVnQ4umr6AZrwHkJkNEnmMtpKEP8segNM56c3GwkuyuzX	1406	1393	262	6301	12026	jwXBr3ZAFmu8uBC9hquVUDvQrhacXH8zfXVRvqjZGejHZ3eqxsU	8159	11559	11559	1618019820000	canonical
16048	3NKv3ovbKTbPKPTF92YSTvFkWVw6F81HmvEEE6y6oQKeonaV4EG6	16047	3NL3NB9gePxaUKDsK2F3toBtr5dFDGCGS1GSXhwGVM7ayzCi597H	448	1305	262	6301	12030	jwM5s2Fbocgj5f9ShcdZz4VoCvsXpsXfPuwGkY282CDoZXV41wJ	8162	11562	11562	1618020360000	canonical
16049	3NKyihJaX6TkhxHD3K3g4CXgbxJw9ABWb9d7M5uKy7viS1FbWk7a	16047	3NL3NB9gePxaUKDsK2F3toBtr5dFDGCGS1GSXhwGVM7ayzCi597H	1403	824	262	6301	12031	jxR914DFCC1hR1RfK3Ar1mNMy7AAq5ti3PGZP6zohKQCqFHDsJu	8162	11562	11562	1618020360000	orphaned
16051	3NK5ppJmMvW17TAvT5Z8unbc3WBGN5AoSZxGQkZRW6NdiBW3kdaR	16050	3NKGWvBDRUHAqB2SLs8okS36DAv6UDqWP9vqrE3L8GSdzuBSX3tJ	1405	873	262	6301	12033	jwVsLC91o9qAi7R4o5dN8w4Pom3LWa1R5z3Bom1CfS7c2BPD8qG	8164	11564	11564	1618020720000	canonical
16056	3NKZhor6uEArx1mneTAtgf6hEiJ5Z1VjUNuJxagXcLtSLHeBNnWS	16052	3NKpZgjPYVfDa8dFSjK6pTJA6CVJUASWSvevqZgR9A1mGhnsipSU	641	1336	262	6301	12038	jxWkcLr6MhyyCrSnE9t299Syo9Dy3BPyMmVLbDieFVArJGy2JJc	8166	11567	11567	1618021260000	canonical
16061	3NKi1V8TTRbUd397RiFxpkki3YYqVW9qPNgtycTwQnoR5k28HVb1	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1457	1391	263	6301	12043	jwSc7bst7jNBxN6SNwW4J6XHRmKg9T73LuNnyifhX61eD3vt5yP	8168	11570	11570	1618021800000	canonical
16065	3NKyuUHUfbYZzuQkqK11FDgDFA8VaBouNHErhu6hEYPznuFWMsiS	16061	3NKi1V8TTRbUd397RiFxpkki3YYqVW9qPNgtycTwQnoR5k28HVb1	1419	814	263	6301	12045	jwwSibgVDcgsQnTyzippsaVeB6GeA6DzgyNLE7r2sdZEFLsoAvk	8169	11572	11572	1618022160000	canonical
16067	3NLE4efoZ874b7GBDSFFVZNMazH4Aj6nngPYPfpYkuqsE6SKaZNY	16065	3NKyuUHUfbYZzuQkqK11FDgDFA8VaBouNHErhu6hEYPznuFWMsiS	1648	1038	263	6301	12047	jxSkaQSMezCV1G4QRehoaohSB75Je7AYi5MnNhrDCqAhFgcq3T9	8170	11573	11573	1618022340000	canonical
16068	3NLKwcJ8FFzyeta9Sd47GoHfSAXNY4UEzHStsAMvkVyFdGnbgrxP	16064	3NK8e1vbcYvsCvTrUsghkx2HK21KYDRR7TCZGxqvGeVCf5PrbfWv	1403	800	263	6301	12048	jxgK8U6T6HUerg449d2Lw18KEK8DLu55S9H9LS6qXckZ2P62XxK	8170	11573	11573	1618022340000	orphaned
16073	3NKU4NUFEyiSj7BoQ5ZHNdzTYzkAXCpcmoMpwv4U55CHTo4SQnrn	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1651	935	263	6301	12052	jx6JGpkqfZ1ef7AZP4anJWKuaDUnuNB4yyvP2p1mJ119CbvYWgk	8172	11577	11577	1618023060000	canonical
16070	3NK9fYV3wVPr28QfVHKF6XU242PRrEaKjaX663dngitvs8woAY3P	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1617	1162	263	6301	12050	jwYWPtQQdRp97PRTcgGr3aQveoTibXpoza8fg6GNYJpt2MkHjTH	8172	11577	11577	1618023060000	orphaned
16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	16073	3NKU4NUFEyiSj7BoQ5ZHNdzTYzkAXCpcmoMpwv4U55CHTo4SQnrn	1579	1143	263	6301	12054	jy2jEzeTQS2qnrEPrWStrHzDJCAczCTdAV8wyv4L5waE6ERQkFr	8173	11578	11578	1618023240000	canonical
16077	3NLPoWNmeMuu21xgUm2BNrhX5XsdGqbbFReJvYWwokmVLivLhbxV	16074	3NL6VKhFyQBtSgteuC3yPmmcfpmpwosF7T3ZDFaxhXnMuX2y5pXN	58	1281	263	6301	12055	jxK1fv1RTPrSxRc5jnZhZhA6n2TrsYGharQg26MLTXdPJx5uFQ4	8173	11578	11578	1618023240000	orphaned
16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	632	1382	263	6301	12059	jxJGUMNbHbejxaMKSEDCvXu7mC9q6NWCbQnx4HphdHFNbUSjcAU	8174	11579	11579	1618023420000	canonical
16079	3NKXLwQNhhy7Kcy2CSkZKaBMPVn8DzueP5sw7EMR6JVyJWeDFr4R	16076	3NLEe4s9s1MHatWzVNoziQWRwhtLytWcgQH95CW57Zj2yYWaninb	1406	1393	263	6301	12057	jwrzFjCXecVLwvfUuLj1t3BgS3DMZm141EmjhU6J8cGEGB2BSSB	8174	11579	11579	1618023420000	orphaned
16083	3NKgyC8xPCZrqBZCeavWkMeyrfmnahxPSSMxyaCXYmpktq8UPj2N	16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	1426	1364	263	6301	12061	jwjZTgejupgzUQH533haEatFKnxPabKnaw635uFUKRgfRpBwtbK	8175	11580	11580	1618023600000	orphaned
16085	3NLM5Q8u7UWo912RzBNG3zp9zvc8w5vo4dJwKBDpYypfoBi7am1o	16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	1406	1393	263	6301	12063	jwGkY5fTsgAd3VheY6MAkVL7ms8DcLTarYdCAhqykRVet44sLcs	8176	11581	11581	1618023780000	canonical
16086	3NLLxrTobXpUCZFEzc4zqyk4XFaZ9RBm25T43Sjn2t7TVKbK6JAM	16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	1490	1274	263	6301	12064	jwD5pp9aWLJCDyWz2Db7X3NpqSgdKtefaPxSTJRusJ8qfeqdHyg	8176	11581	11581	1618023780000	orphaned
16089	3NKuNZfnpUVCb81TFPMuYrPaRB6rNhq4P9X1UAZQek7TJW3AEupF	16085	3NLM5Q8u7UWo912RzBNG3zp9zvc8w5vo4dJwKBDpYypfoBi7am1o	1670	1282	263	6301	12067	jxq7RaFgHv85CkMA1b9KvchfcTZU7ohgEsyNhG4CNFmM18Ed2mc	8177	11582	11582	1618023960000	canonical
16094	3NKxp4cZSwN1CKtoPXScMjwKydJ7uD9LJ3MR8nJKQixbYZw1mfD4	16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	1553	776	263	6301	12072	jxMKVdvVu4SUNESYr9bmYq5cYXVX4YBgf9CJbEi3B2FYaSt9Wjd	8180	11592	11592	1618025760000	orphaned
16096	3NKzaUPTYtpPvE9QukjzZhUD3eyQZeLntBUWnzmifHhdL8Ev1iv8	16093	3NLELrD6KXpW1MUoa8ccY5W67WEzdmuGK7E6Zoi2NJEWMUF6tkzv	1406	1393	263	6301	12074	jwqBaBf73hM8WvyRf5DwdaXCfsXufe4x8LcEc44KCJsbECyi5kU	8181	11593	11593	1618025940000	canonical
16099	3NLLzJGmqKd15Tzpz36nPezSpzuL77yQueKAGo3LjwuZYnAGN4Fe	16097	3NLPKBDfNVdiMSkpdPa4MaBPZVY9pkG2yTgZNcyn8wuxhXgADpzE	152	1204	263	6301	12077	jxvEXFVqsoN8CDdy27nqhR7AKHfAAVAwGx7V9i9VZRrJ3QuM2oj	8183	11596	11596	1618026480000	orphaned
16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	16098	3NLFLsricPrYrVyHqzcVbyUE7eVYXRB8xRifR9zaHHyrb645CKNm	1402	858	263	6301	12079	jxav2BeeA1ZTvxSu5ZyPSZgX3WuwuTVfzvEQQ8ofsDxGByvX7Z5	8184	11597	11597	1618026660000	canonical
16106	3NKBnzzMPH8fUrRLHWspK3XWa1RhHsR3MUQHDnGKTyZ1H8x6FomN	16102	3NLpHRLgMd9Q6MwVG5eZaQGTBoboGRQAiXu8A4hrNtiLEdjLSkHU	1403	824	264	6301	12082	jxrb96uZfLMHf48nYXKUXWUptJ13DifX4ZhjHeFrsHeBkZNip4z	8186	11600	11600	1618027200000	orphaned
16110	3NLhBd4V928eSZU7pGtewWhciUhLY7bFf3qaHabY6btXMBMtxFDY	16109	3NKJmAcuo6rGkaZ63Nk3fNYcPL688uTdPFrzq2pML5pH5yHt7tnA	1406	1393	264	6301	12086	jwKANat1F1X5jeQHvgLnaM5aMv2NVayDHcSH71RDsvEgZpXpSGX	8188	11602	11602	1618027560000	canonical
16114	3NKLAEXinDik5hRcxAWUdfvonxKx5EHmxFhCvVfcMrAZWfF7ET2o	16112	3NLtMWFFjXdjbC924TTueJpW6yC94W32GCtaQG2X2HK3BMEVRsC2	1458	1323	264	6301	12090	jxHitRxarm8xwVuSYyoWDkB8YDmSS9npnsH6wRPVfvDnLeS8g2R	8191	11608	11608	1618028640000	orphaned
21169	3NKDNvYx6PzZ6WVVoH7Wtn1a7uqoxke7RvNeYMY5foVgJxSDH8qk	20877	3NLfPA49omPkpWeixVdpnG1M8Sgev1PkTV16XUEXGdDyLjgpX1fT	1671	1365	379	12463	13421	jxxqiddDcd8yPfE3yRV6ewam2DNB2PPRzu1AhYpmJLvzWZLw8J5	10471	14969	14969	1618633620000	orphaned
16100	3NK4UEdfpvQiX6X8bJ1Zycjiy2edbv2PFNWHLEq5qt6bP8i9KDTQ	16004	3NKE7pT9eGrk3BW3UuHSUFXM3sYLvDtrVWGiwjgxw7bZHSpEE66Y	152	1204	261	6301	12078	jwffFsRrrP6p2zGyV7w9zCM1FzdGguQyFN6VMa3GTTfTZ5MbnZB	8140	11596	11596	1618026480000	orphaned
16060	3NL9jnq4FqmuxYdMGRfBCgx4jJSwJF4S9R4gbwVs231HTukNsehs	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1483	193	263	6301	12042	jwGHG6hP7UiSAeyuP1ggTfwbK2mL48QWHZQvPKLC9wjPd1qjPQ5	8168	11570	11570	1618021800000	orphaned
16064	3NK8e1vbcYvsCvTrUsghkx2HK21KYDRR7TCZGxqvGeVCf5PrbfWv	16061	3NKi1V8TTRbUd397RiFxpkki3YYqVW9qPNgtycTwQnoR5k28HVb1	1419	814	263	6301	12045	jxq7PHLddxLBG6N6r5ZS2fK4ZTr3TopSm2bQsUwGKFV439ACgua	8169	11572	11572	1618022160000	orphaned
16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	16067	3NLE4efoZ874b7GBDSFFVZNMazH4Aj6nngPYPfpYkuqsE6SKaZNY	1403	824	263	6301	12049	jwRJPWbMTjV2EVed3RwSqoha6RA9QCoqsi4xyh4ktWx3gRxPPc4	8171	11575	11575	1618022700000	canonical
16072	3NKaFWteCH3vyL96kdtsRBbctWaiwuG4bBocRgu2qsZma49NgcEt	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1651	935	263	6301	12052	jwZMWsb2Mvsk7BeMB18QahL6ta5Ldk6sVS78RgGTjd1dqGWtsN1	8172	11577	11577	1618023060000	orphaned
16082	3NLotY57x5Tm6zRs9pXZTbsCvoPdtg6t2VS4i3ugbvQo9ALKwDKs	16081	3NKckiUWJgDpfjyXNqhyp2XUkgRDCp26g7qEWFnG9cNoisBRRU2U	1516	928	263	6301	12060	jweuuwhiZU1NUgCudXgvi253PPWYbYETXs6YJuj6AFX74AcTHqm	8175	11580	11580	1618023600000	canonical
16091	3NL3N3NNpmiiwsJVkStofrU1eHXi2LWv2qxdP8Sxpa1QYr7fEE13	16089	3NKuNZfnpUVCb81TFPMuYrPaRB6rNhq4P9X1UAZQek7TJW3AEupF	700	840	263	6301	12069	jxgF9NBbeRUuveJJy9c6LjuzDoSQ7yiVZZhMx5ALZ2v3ffaWDrF	8178	11589	11589	1618025220000	canonical
16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	16091	3NL3N3NNpmiiwsJVkStofrU1eHXi2LWv2qxdP8Sxpa1QYr7fEE13	1407	1395	263	6301	12070	jwxrD9nvAeNoVcaaGPS33PFVd7bytwDVJGweRGGRX6PdHVUinCC	8179	11591	11591	1618025580000	canonical
16093	3NLELrD6KXpW1MUoa8ccY5W67WEzdmuGK7E6Zoi2NJEWMUF6tkzv	16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	1407	1395	263	6301	12071	jxQLmVJDUCvNKzwPWdKpcqBcdBbVHv3u4yiPUP4M7dEaZjVaKaV	8180	11592	11592	1618025760000	canonical
16095	3NLXagY3fh5NJBeEN24LiLnoDfHHine9Xs7oTYVmSvv8oQesrMV7	16092	3NKMp1ARu6pFWeamjYZFBnXybFr3iCCNfqMiHAfKyWsD8Zdhz4ZK	1403	824	263	6301	12073	jx2MeGRLVoA2Bpvof94mLBHoff6JZMgU9SuJBdjJ9DRzhJnVyKi	8180	11592	11592	1618025760000	orphaned
16097	3NLPKBDfNVdiMSkpdPa4MaBPZVY9pkG2yTgZNcyn8wuxhXgADpzE	16096	3NKzaUPTYtpPvE9QukjzZhUD3eyQZeLntBUWnzmifHhdL8Ev1iv8	1631	794	263	6301	12075	jxcoqkfL5QZEeMXS86yCeuYGZCrQ4Jg5ghKp8pJ79sXhXYxmhNe	8182	11595	11595	1618026300000	canonical
16098	3NLFLsricPrYrVyHqzcVbyUE7eVYXRB8xRifR9zaHHyrb645CKNm	16097	3NLPKBDfNVdiMSkpdPa4MaBPZVY9pkG2yTgZNcyn8wuxhXgADpzE	1406	1393	263	6301	12076	jxTqtmgUZp3xPuCv5JReavAT5Xjc8BHTzYJCpWiDpAaidxpJvAM	8183	11596	11596	1618026480000	canonical
16104	3NL95K81h9uiTe1cqVjuwLvmxLtkYULz1PFA2go8Dg5UocpFPPZN	16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	1542	1058	263	6301	12080	jwuLqeLnCS79JuN6Y8DpTDPjxD81JSRYLdsEQr5Um4y7wRLw7dV	8185	11598	11598	1618026840000	orphaned
16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	16102	3NLpHRLgMd9Q6MwVG5eZaQGTBoboGRQAiXu8A4hrNtiLEdjLSkHU	1564	1212	264	6301	12081	jwDoJDdGtkzP4mjDmnwLsByNgL55sLprwu27TmzbE5cuf2vBHkK	8186	11600	11600	1618027200000	canonical
16108	3NKFSnT12b2qieaPNNaVuQgJgUzo7cuQEkad3dUbh5mxN8aqqufZ	16105	3NLRctNZNj8v2pGvM7KXUDPjEKpm721yuQJGUGDhaF84oEkmbkHu	1637	816	264	6301	12084	jx6RZrb8xbqgnLMREy4JhsBJhYkyoqwgBbbXh3J6v3Ex71T1w5u	8187	11601	11601	1618027380000	orphaned
16111	3NLoeawWXQiFBo1ez6NkWGj1ea8QYHSJuZWhWZKFuxiqBkWViu5j	16110	3NLhBd4V928eSZU7pGtewWhciUhLY7bFf3qaHabY6btXMBMtxFDY	1403	824	264	6301	12087	jxFuLoGvkA4QXgxXz2ZWHtN1XULhM761xm8eayheQie8j3BKVwU	8189	11603	11603	1618027740000	canonical
16112	3NLtMWFFjXdjbC924TTueJpW6yC94W32GCtaQG2X2HK3BMEVRsC2	16111	3NLoeawWXQiFBo1ez6NkWGj1ea8QYHSJuZWhWZKFuxiqBkWViu5j	1581	778	264	6301	12088	jwvQnZRxV9ubp3DtixEtZCfkSY3M4caCG1mDDZxX4i4x5vWiWT2	8190	11607	11607	1618028460000	canonical
16113	3NLeP5MhauCV5ByraDTTMzThH4Wse8Siec3gfGS6oopVTF6tknSw	16112	3NLtMWFFjXdjbC924TTueJpW6yC94W32GCtaQG2X2HK3BMEVRsC2	1406	1393	264	6301	12089	jxLbAAgX1MawWtDGzqsiRR1V8JQbLTvJYpc9at5H5icV28gqNCu	8191	11608	11608	1618028640000	canonical
16117	3NLi4i9ZD16YTcZYyX2KWk9jTkPbnGRGT4enwDvZn7T9ta3uqdDm	16115	3NKKJFFCrP5PxVT6QZvRY8SUva61PL5nHw4NQzqFDXLDaTfJXLcx	311	1181	264	6301	12093	jxuX6PWDMjZdqe4JhKpphh97ydQEsUouVjucxowbYbs4Br9HGZ7	8193	11610	11610	1618029000000	orphaned
16119	3NLe85sd1U2YQ3kAasijpJ7g9zUJpa1Y7MrjAAShTtDUDakHaQ8g	16116	3NKEfgxowxN9a6DPf9Dfxc7QDhVQ8tacCLuP5dDjfKPJyF45f49y	171	1008	264	6301	12095	jwpTe55UXjeMkeGo9NvwibfuN6guMcjUbtRpZxpXMXgXaHggfTd	8194	11612	11612	1618029360000	canonical
16118	3NKT4GgtFjY5oWhTpKsVD4g6fuNVNfWmhAhmGSB7WQLDM4kkDzX4	16116	3NKEfgxowxN9a6DPf9Dfxc7QDhVQ8tacCLuP5dDjfKPJyF45f49y	1406	1393	264	6301	12094	jxjpS56YtF7bMnH11te3xK3hmPonBAwQLDKvnGAR6VEDNxFoPyn	8194	11612	11612	1618029360000	orphaned
16123	3NK7mrSoyF67qVcW99NiUDuw8zv9ZDWnP4ZsqLTgF12uPNQakPC5	16121	3NLYXpWQG8TPhN5FzSWjybZNx8A5AmKnb78HeVVHbYgsrjEZmpX3	1627	1259	264	6301	12099	jx4LXtFB9vSbjcHRrTLYQ4JbNT7iuFc2Z5orsHGM6h4BRvMZ9Jc	8197	11615	11615	1618029900000	canonical
16127	3NKxzYuDcBMeqxrPW97w48bA6t5NoeqVvAaQczRSbrbtZ5KuppLv	16126	3NKeTA25kn3tn9fLB3SNQ5RHM9SQQCMjv3mT84L53NB28LyJN3tv	1397	838	264	6301	12103	jwiYfPBKGLde1VURSqEVWd4xFyfZRHzY8wx2hB1tRLAKdX2PBJf	8200	11619	11619	1618030620000	canonical
16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1631	794	264	6301	12112	jxZdsMmCeVCBS41hGkTMkrUoAKW1gkWDrs5icevRbQxGQLbQZyU	8203	11623	11623	1618031340000	canonical
16134	3NLMcKitfmQiKkXqqANSxmzSCLPLww4cpFyiVkmQjmwuhWDHZFYx	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1402	868	264	6301	12110	jxPE5ukJ2gmbHTh7uPDUNDk8Z6a6jZ6pdRBD97jXGJGBVFYzCoc	8203	11623	11623	1618031340000	orphaned
16139	3NKiwwkQwpVpspWUkVihZXDUt7MC27J1Wox9b715nsjYCW1NtWTs	16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	1402	874	264	6301	12115	jw8k3Qv8YHuBzTQJYWxR9VNv3vtfhD9mKRJa4nssbYtSoseS2wr	8204	11625	11625	1618031700000	orphaned
16141	3NLquoHE586jEAQYJ9a6Wi3xq9TA86trFF3kVvdJL5YYUghHXF61	16140	3NK5G6mV7YtUuFeC7iD7grswFfZr2GZKQhKVgKAfyxY6CpYRiEP3	1581	778	265	6301	12117	jwAQCKnXbFTXkTHuZnA9Dc2N1NRYJPLU5GhNmtogf38TtF1o46N	8205	11627	11627	1618032060000	canonical
16146	3NLjYyzCESRuuZzc6Ruc4PaSEcQnVabcR8sMxi69hH7yzhpHHnb6	16144	3NK6ghFqespGVhm1zdcWd6RvSSWLsqoHABt9RcdiBNDTcUh4di4g	1593	1346	265	6301	12122	jwe3hUGqUpb8tEY1jMtAxbApvyXfaiQxfz22ezamDXNyEZWWXzD	8208	11631	11631	1618032780000	orphaned
16148	3NLnL31RCAZZfXMvoADSTVnAbSGLESj2VPQY44GmkqgRhRgxMZfj	16147	3NLYgqGNdWiGSGa2VU3hmP3eVW6Mp1jpDUUjLGjoZHttMbE5PseN	1406	1393	265	6301	12124	jw9LupNFRs6V5zo1HzbrYggHTYunadYXdmqZohn4vRN6odTAA9q	8209	11632	11632	1618032960000	orphaned
21065	3NKtKkKuKLL4Vp2NkEXrKmwQ6oYs3PE18Ju92J51Wiv9p4LMN9aU	20880	3NKYvucHQbnwCDMfzTe9ggDfApNmw5FLezNi8RJLNHQwA2APavok	484	1193	379	12463	13330	jwU855a9iMgZcDYzzRAEUjdiWULqpjuZSAWTNQkeZux71uGjvkS	10476	14903	14903	1618621740000	orphaned
16121	3NLYXpWQG8TPhN5FzSWjybZNx8A5AmKnb78HeVVHbYgsrjEZmpX3	16120	3NLC3dLGgvYYkiwEPZhhLP7LRXrPJYimiBuQDNPdNBJYedTTBg72	1467	1010	264	6301	12097	jwqU1Ahwy2yooXtM4RkkCQRRMLyzagsjDJhhA9F56uC4Jfge9jw	8196	11614	11614	1618029720000	canonical
16124	3NKcoSSRaFe1a8BPzDd5xBwJ9Rs7uEBnwKPCVEEoMhfCJnLsF1hD	16123	3NK7mrSoyF67qVcW99NiUDuw8zv9ZDWnP4ZsqLTgF12uPNQakPC5	1407	1395	264	6301	12100	jwhgq1c8LaBhbo4PbTV43N6oonBxj6RsCUMLqYb8tZ8GsQWT3MR	8198	11617	11617	1618030260000	orphaned
16126	3NKeTA25kn3tn9fLB3SNQ5RHM9SQQCMjv3mT84L53NB28LyJN3tv	16125	3NKST4JHteH8q9jgTcA1raQFXeCL9XA3xg5VB9Lv6PofVdZpikQU	1503	1277	264	6301	12102	jw7K1U1uzVnFEviLZ5zF2miwYmzeGNQrrMvGafdVK9AcUYpB9x6	8199	11618	11618	1618030440000	canonical
16130	3NLxaWwFCmCsX5iztU557p2vDhhmdzPvcDSuYiNqtYAryu9nDJa2	16127	3NKxzYuDcBMeqxrPW97w48bA6t5NoeqVvAaQczRSbrbtZ5KuppLv	1500	931	264	6301	12106	jwtRANxrRf34AAv9xCFyY5KWENaF59QgTzeX7FiNaU1t4CXQ9WD	8201	11620	11620	1618030800000	canonical
16131	3NKvYgLtnfoVSWzpWCw31fwoEyCCGkSWTRdS5w5jVNJDfvnqPAuo	16127	3NKxzYuDcBMeqxrPW97w48bA6t5NoeqVvAaQczRSbrbtZ5KuppLv	1406	1393	264	6301	12107	jwzHo2f1VcwFYyxwVyzKdYrRfwzkDUb8N17vz1F3khrtMHhX8cG	8201	11620	11620	1618030800000	orphaned
16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	16130	3NLxaWwFCmCsX5iztU557p2vDhhmdzPvcDSuYiNqtYAryu9nDJa2	1637	816	264	6301	12109	jwSt2gTTgkCXbkf3xjRMUw973q3j1WL6JABkyAHNjbWqePGSBH4	8202	11621	11621	1618030980000	canonical
16135	3NLiJj86CBrcpksZQpT5HCUhbw45n2aGf1TqzAT7wchVd8H3bqBt	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1619	1029	264	6301	12111	jxEAgFcBtiKjGDZeuG1n9Ayr4Amp7CMdJpX5kiTs2ZoSyofqZPq	8203	11623	11623	1618031340000	orphaned
16140	3NK5G6mV7YtUuFeC7iD7grswFfZr2GZKQhKVgKAfyxY6CpYRiEP3	16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	1461	1271	264	6301	12116	jwgvJmEPiyfYfJc8sJ6tWfdELbtoHjnsr5avGkGzjGS3PwU7fzD	8204	11625	11625	1618031700000	canonical
16154	3NLoZ1p9U9KcGLSb9SEHjepMKu4Ku3vjo9ZxFwcapUPCek5ZsVb6	16138	3NLvasWRbQu9DaBjZdVaPjHf1EdRZZoriTzDzrTj1bXsG3HoTMa3	149	917	265	6301	12130	jxA5xBo3Vpz8ARQEjUZTtoC1EztXM9iDgShBwYWAW129BM3VwAi	8205	11634	11634	1618033320000	orphaned
16142	3NK8gUbyYFgWfz9bC8643LcTtPNLP5qLw56E52CC4x9ySe5HUARc	16141	3NLquoHE586jEAQYJ9a6Wi3xq9TA86trFF3kVvdJL5YYUghHXF61	1552	513	265	6301	12118	jxKD8iEU8NGEvXJh3fVtnU6tZEaM9voAtKxa7htbDFyZDDt3Fjz	8206	11628	11628	1618032240000	canonical
16143	3NLHJviGARhUhiiPuQN7Y7BGL17wpSPnsR53dnCKUofopoUvWMbf	16141	3NLquoHE586jEAQYJ9a6Wi3xq9TA86trFF3kVvdJL5YYUghHXF61	1471	1140	265	6301	12119	jxDe7hFaJdB9XZ5EDr1kgrZ7PASbTcmA8tJvbiYToNYSLtcsyMC	8206	11628	11628	1618032240000	orphaned
16145	3NLfeijqYEd7hsNxod9WiA3zap1xnKEkKHak5bkuoPgYp36CqAmn	16142	3NK8gUbyYFgWfz9bC8643LcTtPNLP5qLw56E52CC4x9ySe5HUARc	1634	1331	265	6301	12121	jxkeFme9sGeTyVWYTbSrfAbYdBNC4d9h9pUxw5G78Cyj3JPiacy	8207	11629	11629	1618032420000	orphaned
16147	3NLYgqGNdWiGSGa2VU3hmP3eVW6Mp1jpDUUjLGjoZHttMbE5PseN	16144	3NK6ghFqespGVhm1zdcWd6RvSSWLsqoHABt9RcdiBNDTcUh4di4g	1648	1038	265	6301	12123	jwYZEdy1PMPJYc3ajrTThgttUJwYZ6b1fTv3dgboJs4UMqdzqpn	8208	11631	11631	1618032780000	canonical
16150	3NLtxWASUTExDbt8mGAsq2fbGEkhgTZKJoWUkKnqsQM9mRJe6mDs	16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	1407	1395	265	6301	12126	jy3ArFyBKgKdf9KuDdMrVXJEEEeopTg5i9Bi5p48tJEt4VJSGxz	8210	11633	11633	1618033140000	canonical
16152	3NKaqZ8imKJu6FhzTSJavanojNBTVFP2JTkikaxYCFx6AjK7wRTU	16150	3NLtxWASUTExDbt8mGAsq2fbGEkhgTZKJoWUkKnqsQM9mRJe6mDs	1407	1395	265	6301	12128	jwUf917wNYYpoJbnkWM41iDJmP6Bi5E5qXLKtHkM7NPy6WGwST6	8211	11634	11634	1618033320000	canonical
16159	3NKtkjYS84hR7rEzDvfcCAVF8mXR4y3mGhcKoGVo6wvoTL74ZVCH	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1476	1371	265	6301	12135	jwdomiAkp8PMrZfnXFJh1QKBPhe6Rks3F3FQ3E27HxkwpM5Fj45	8213	11636	11636	1618033680000	orphaned
16163	3NKt8rVzb5rEYw6Q8Qx8wkCPCTsdLrBvWd7VMtiohb9qTPhEWk1x	16162	3NLUJiokLWB6Y6un6QAywqMDMmUG3JmT63iGZJov5x88Q4DtNSPm	1624	968	265	6301	12139	jwMrNSXSD7wh21w8UZiWt9WKJRqThEamCLyaNAzHttwSiqcQ7tW	8215	11638	11638	1618034040000	canonical
16165	3NLkt8w9HXezo55WSfgkyphC1J98SFRJhTSmc5PAQXZxVsiizJvK	16164	3NLEwJYMyKUpatAPCkdJsxNtFYczvaDUMgAxyZMo3P8dSk4ScND4	1549	1236	265	6301	12141	jwFoRXuL6q9f3dW8R3G3pinHX3J6hZrujTv55Wt7fCFzxzZvqsN	8217	11640	11640	1618034400000	canonical
16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	16165	3NLkt8w9HXezo55WSfgkyphC1J98SFRJhTSmc5PAQXZxVsiizJvK	1407	1395	265	6301	12142	jw8325bR1eBMAE1TEcghgtuzS1bDr15BsRVxYNKn6jEEvEP6nvh	8218	11641	11641	1618034580000	canonical
16168	3NL66fy4Nc5trdZTJyxDgGeb3B2wEfu1k67YQjUCSddWLZrQPvRn	16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	1577	1327	265	6301	12144	jx6qaxaLG2MwVZH2hpNHmGCBi4E2JJUxgZ9oVjCpjPXy8Zxd3Sw	8219	11642	11642	1618034760000	orphaned
16169	3NKmqiCMXfQH93HabCwTufyAzXMES2QtatqgMWjEg4ERWoq1UDGr	16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	1633	1144	265	6301	12145	jxE6qHpw5GTPQWDi2MnWswG1fS7MHnbWHoPHmRzp4Ma3ov2Y2u8	8219	11642	11642	1618034760000	orphaned
16170	3NLVumNtRgCrDUb4a1nFoa6grFdFjoqPLeV6oDtQKCq23zkn4gL4	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1567	567	265	6301	12146	jxzHDcMfW4ofrJbixzCBgyE5LTe2aiRaSbBFG3veD22ZDYaF1HV	8220	11643	11643	1618034940000	orphaned
16173	3NK7fxBmZqfb5WpJqimfdgpHhahcrhyorTm4672NKxrxvBt3taDL	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1577	1201	265	6301	12147	jwh8VaEXA7K9M1735niVtkuWgHMCXS6A5Y1PGtK9ficvvL1DUQp	8220	11643	11643	1618034940000	orphaned
16174	3NL3Qv38PPXYjcTunHZGp7SEepy6Vwo82mY7D5gxNJSMrWbb4h1g	16171	3NKG5sfi2rMNozvCF3M5nzJ1ZH7vFUYpdmHxc5WmJG4P4n1dL8eX	152	1330	265	6301	12148	jwZ8Fkn2TbirPRoJM4jhUWkcf47XjpFSySnnrmRXurf8Rt6UG1t	8221	11644	11644	1618035120000	canonical
16177	3NLpJY3NVMbHjZo1FWo4ssQGBZvyqHjmnMFs9YFj1cWBv43cdM88	16176	3NKCgLHL2AWSU2ctQCWjcogihvaptxB7ZuxNDBhhpuj1S2zg3VNv	1445	1044	265	6301	12151	jwY872woyUQ45qGjrqHM4M34bQZvQaqZUKMxL695Z3SMHm9jVgm	8223	11646	11646	1618035480000	canonical
16179	3NL55qE62ifApVh2HxHfRLLwpycdCR9DXQuvG1UcKxPQXvjvR14y	16177	3NLpJY3NVMbHjZo1FWo4ssQGBZvyqHjmnMFs9YFj1cWBv43cdM88	1589	1040	265	6301	12153	jxyWwxGq29GbHVixt54Qh62suzQN7aahJYM9ixgYLjMhnBjbAmd	8224	11647	11647	1618035660000	orphaned
16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	16180	3NK9pf5qeLkpfvYtkaAhDyCiL5dAjsLgvDCoCj6YVy4woLci1MZp	1601	1142	265	6301	12155	jwRawA46ZamomoGeiyZnhzJZvKuPoxtwT5KDzPDuDWVH8yfRW5S	8225	11648	11648	1618035840000	canonical
16182	3NLdbF3DwNeE1nfvA5s7x5i7exEHSnC4u3H4VTL5R8LiTfeswcG7	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1523	1321	265	6301	12156	jxoSA5o42RkHYxSwyvpM4SJX2oHbBuW9ef1V7szVESat4Zfuou1	8226	11651	11651	1618036380000	orphaned
16183	3NKwiUUdYbzMegeVhjfzZio2YBqhRKAJhkzNPgj8ZW8HNWzpQLhU	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1523	1321	265	6301	12156	jxfsNqdKYvbEA9cVg5gBKrqvtD6k4bXeWBx6PEoHp1jCiPtv2UV	8226	11651	11651	1618036380000	orphaned
21188	3NKFjg9tESEvZLRwhTTnMZorGYSpEhwyxHSMt4EgXGzCbQkvZLtV	21065	3NKtKkKuKLL4Vp2NkEXrKmwQ6oYs3PE18Ju92J51Wiv9p4LMN9aU	484	1319	380	12463	13438	jwZcozkAyTzhDzxYPT4cfsk8ukZYALzvgoJQbWLceQ3ogeVUXjt	10477	14983	14983	1618636140000	orphaned
16125	3NKST4JHteH8q9jgTcA1raQFXeCL9XA3xg5VB9Lv6PofVdZpikQU	16123	3NK7mrSoyF67qVcW99NiUDuw8zv9ZDWnP4ZsqLTgF12uPNQakPC5	1631	794	264	6301	12101	jxihQ1s9TvCXxMjE7t43mWpzSazoz2KhkxHRgQwfRF2NTqot2hp	8198	11617	11617	1618030260000	canonical
16128	3NLdAokqQ6oAQJmu8BqHxc7edDrU7gsRo3zA9xT82cysEawTxCLV	16126	3NKeTA25kn3tn9fLB3SNQ5RHM9SQQCMjv3mT84L53NB28LyJN3tv	1648	1284	264	6301	12104	jxJHxZz3VyCg2TkpRZ3Fasg4M5vYuBsQaiS9BH8Fb6FtmeWd8pT	8200	11619	11619	1618030620000	orphaned
16132	3NKG2PGqArv827XYjQqNviFt3E6mVng8p9zsA6q4YEonGnw5EbzS	16130	3NLxaWwFCmCsX5iztU557p2vDhhmdzPvcDSuYiNqtYAryu9nDJa2	576	1355	264	6301	12108	jxUNVwAPoPPnbfyxFnKmP1p2ckMceeQkDwV2RUmFndqDsYfSMWi	8202	11621	11621	1618030980000	orphaned
16137	3NLv4F7h6Vu24fhaGUCZjihYV4bMYcLdis5havbvidSgtXsBePCJ	16133	3NKsGVaQ6k7E5Pp3ijmYJiBWkDYRfEqzhfMCdkTxVVVfeLCo7S6T	1553	776	264	6301	12113	jxZ6budv3wKgjNiyj9U1PJZTheQcEswtcEkd5v7zzX6gar4HUdX	8203	11625	11625	1618031700000	orphaned
16144	3NK6ghFqespGVhm1zdcWd6RvSSWLsqoHABt9RcdiBNDTcUh4di4g	16142	3NK8gUbyYFgWfz9bC8643LcTtPNLP5qLw56E52CC4x9ySe5HUARc	1406	1393	265	6301	12120	jwSZjfHaCTK2ioHYTf3wPudqtw9Jozfgq5Wut9shtSQDUa3Lr5m	8207	11629	11629	1618032420000	canonical
16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	16147	3NLYgqGNdWiGSGa2VU3hmP3eVW6Mp1jpDUUjLGjoZHttMbE5PseN	1460	475	265	6301	12125	jwDW9Zy8TMpY1S5oB9aVgvSKThSpK36jemnfauEiKPiRDPvZ8sS	8209	11632	11632	1618032960000	canonical
16235	3NKTEBWZktuZPt1uK99KE4UzZF7cq8EDVLr7L3UCNw5KUekH7EH9	16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	1455	1332	265	6301	12201	jwqZVnxwHMTqAXWkKKZdM4XH33NNFFsLY7eE83frUGAa4rM98Nx	8210	11686	11686	1618042680000	orphaned
16156	3NL2EnSK5QnkBQqTsiUx2ZUzk26E6MBwGWL3ZmXjWydw8jxwS6GJ	16152	3NKaqZ8imKJu6FhzTSJavanojNBTVFP2JTkikaxYCFx6AjK7wRTU	1637	816	265	6301	12132	jxEjuBr5XTZP2Nt1owyZUtj1JvYSxR5vEB9rJnkTCnMouRieZjt	8212	11635	11635	1618033500000	orphaned
16162	3NLUJiokLWB6Y6un6QAywqMDMmUG3JmT63iGZJov5x88Q4DtNSPm	16161	3NKnE5qUbFHQjGZkA6NxCFMHvjrTRyP5LUzS8bXqdkyVXYMgZ6w3	1407	1395	265	6301	12138	jwThv3r7ZHB1RvhPhvkZN77Z9siDrJtzvMki6K9rQ25TrynTRWH	8214	11637	11637	1618033860000	canonical
16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	16166	3NLyZ6SRaGyYebFVpey5tfqGy7R2AgSuZQ4oXKrX71keUB9AKJfo	1476	1245	265	6301	12143	jwNjEPYUZLxNEgrCfn7uaydKrmDTLSVktugMSgdd4VVQxKocsM8	8219	11642	11642	1618034760000	canonical
16172	3NLkANLCpiVuwcf8GnLrzksAPEmSEBihbVmhwY9W62oeDW8L9g4X	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1567	567	265	6301	12146	jxya8nqoNEttRaJjLEFTjCNwxKn158Fz27WmDKZ71Cb1kmkPgPE	8220	11643	11643	1618034940000	orphaned
16176	3NKCgLHL2AWSU2ctQCWjcogihvaptxB7ZuxNDBhhpuj1S2zg3VNv	16174	3NL3Qv38PPXYjcTunHZGp7SEepy6Vwo82mY7D5gxNJSMrWbb4h1g	1581	778	265	6301	12150	jxv6FqpMaRDwYhyHvS7N9T37HJ6p59CFM6GWxT2Bu3H2fDKE1wZ	8222	11645	11645	1618035300000	canonical
16190	3NLBpMc4YGSMgbh2zeb1saGgn7FmVeehZSxKmKskFoB7NmTcF2um	16178	3NK9xg99C772UHSnUB26J68hVEcMVLNSLwAWhTULs8Bt5McW6JRa	1509	1074	265	6301	12160	jwAtLjP5wBELESGrtmsf2bXsRNj3U7HM7rPmyZTpAjrMF8LvcAH	8224	11654	11654	1618036920000	orphaned
16186	3NKmic7WCGSC4sNn3UfNMFSwavKv6Wvgj7TKJAPBGYPj2bUeR19V	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	43	1184	265	6301	12158	jxYFo5LaJxaH1zZJTvKZC6jtPZQAzhTTZs67rCG8owuV5ojDRrB	8226	11651	11651	1618036380000	orphaned
16188	3NKeUrrAGGCy1ee1zSvpj3rQW6D4qhuKcyNB95mD3n5ndZpToZUF	16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	1529	635	266	6301	12159	jwiveth7qfkoWUgy5URTy1Q7suur9Le7xaZZ4EtCmdurkX6PMtF	8227	11652	11652	1618036560000	canonical
16189	3NKiuiCjeFcHGP7Nk8JAaxCgYEYEb66RShLxfvgBdj8dVEYwabXH	16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	1529	635	266	6301	12159	jwiveth7qfkoWUgy5URTy1Q7suur9Le7xaZZ4EtCmdurkX6PMtF	8227	11652	11652	1618036560000	orphaned
16191	3NKhKD5vSHt9edS6qc5otL68tf3D17N8CAdnTcgnU4E74ZP985tE	16188	3NKeUrrAGGCy1ee1zSvpj3rQW6D4qhuKcyNB95mD3n5ndZpToZUF	1509	1074	266	6301	12161	jxKJa7xXJhDUBpUJatG1sPK1S6RWFucZQfvZykMjUxKNmhTtwce	8228	11654	11654	1618036920000	canonical
16197	3NLXNuYSEdPyLanWZEqMn3Lv79YiWZvHLcy2Y973g34mvVpo6GKp	16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	311	1307	266	6301	12167	jxbHXD2U3bDS1DhnjwVDCMhtorMBx4xEwRRvL9LHzzJxo14wt7k	8233	11661	11661	1618038180000	orphaned
16201	3NKCzEy5M7V7s3qBRJtAktsWtouKd6CGcvYYGvRGVV7gxikUDS4S	16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	1670	1282	266	6301	12171	jwpY6BWeDv2FXmxH6FeND7kBGpSLhqHPKgjf2TEHXpSJxAckXaH	8234	11662	11662	1618038360000	orphaned
16218	3NK86eGTdaDbsf12GNymZKaF4WnjbX9kx19g7d1hQirZif2uuGGh	16216	3NLq9QdsRYCtEesx5JmdvjKzXmG2Bp6kupWpRtRZ62vk5qgGHuzS	1406	1393	266	6301	12186	jxncQRcp1Tu3QTXBe8xKxCcLSAHjRJdQ3RYCDwMv9Wzcgc319Lh	8242	11673	11673	1618040340000	canonical
16220	3NKVxzvuFePz94jHdri6pi8HE4sFoArdKTcff8jxVtnVuLeuTRPF	16218	3NK86eGTdaDbsf12GNymZKaF4WnjbX9kx19g7d1hQirZif2uuGGh	1650	1129	266	6301	12188	jxhuHZmSDkUMTiQMnYNmK8QL5U62o7AbvPNPeQqHSHuweLFcjnz	8243	11674	11674	1618040520000	canonical
16240	3NKeDPXLd6a3juchSozfv4357hLv4K68b44Vwp12qxTadsXwWc9P	16220	3NKVxzvuFePz94jHdri6pi8HE4sFoArdKTcff8jxVtnVuLeuTRPF	1476	1371	266	6301	12206	jxFFK4tQSeR4GzDUv9qhQENr6n4QkZyPVLPbHb9XGrL8HSdbgyB	8244	11687	11687	1618042860000	orphaned
16223	3NKLmHEvt7S8fBH9syESCVZzy1huCRqm5TT8ypRTgmKVC9sM63PH	16221	3NKAZQ99yU47FjKWTLvouGW3tzzyoefpaiZ4jro5YFzsw3R3rztS	470	1309	266	6301	12190	jx3FZkSL67aHWHfpSXDodLDshLMZk5xQbjUkU9RvktkPypZsZyu	8245	11676	11676	1618040880000	orphaned
16227	3NL8aJzaJYR31tgeWcMURytxbu2Aq36CPB5YWZM4CiD2KW8W4BHt	16225	3NLj8fm6afRTmM3yrZqFaKRrVDLbhFukeWhefTtRUpUNgMGRztzh	1447	1345	267	6301	12194	jwpY52sVpVqQimCq8FWQApjnzN2bxSp9Ndk3UPWqSeYJFDK18kP	8248	11681	11681	1618041780000	orphaned
16233	3NKkC96V9yX3zzG7wA59nTuCKfwsC3nQWdHPA9kSfMg3H8uAxooa	16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	1511	904	267	6301	12200	jxyBQHSrmqUWdTAD65eqSBKbgqbvPs3LKeFewJ74GXnDK3FJ6Qg	8252	11685	11685	1618042500000	canonical
16238	3NLdGPhNeLp4Y7eufxUPEArpRetGxa7TF11jC5dmn78Ntv99gWge	16236	3NKDPEyT311FuK87YZHUPnL9HLpwJwjAcGqRHMKK5MWxyEb9mgNi	1547	1378	267	6301	12204	jxNhTmMHg7vVf9SLGoCQLCb5uv1akSGEHLa5kQcqc5obwUqbbzm	8254	11687	11687	1618042860000	canonical
16242	3NLEhYK7SmAty4KLCifLg98sZ2RTGdtE6EVwUWBqbMvTuwhGpJWb	16238	3NLdGPhNeLp4Y7eufxUPEArpRetGxa7TF11jC5dmn78Ntv99gWge	1631	794	267	6301	12208	jxyedaK8kXMsMJLZ2G7pUSfSsigvajhQoDS6MXoNSGFEVf2ZazG	8255	11688	11688	1618043040000	orphaned
16244	3NKvffaKr6bKpQqSWZ8vjujGXgcfjxJDLh7pjDxNEBSpHxyXJzSs	16243	3NLNGSZyQAWqxgHbEfeP7FeeobSx9pGGmnZVdUGnoENKzv8945rh	149	917	267	6301	12210	jxxpBqhf3SxB65sD8YnkZPpuX4PKiA8tkT5WWT3zDB1zfeR6V8N	8257	11690	11690	1618043400000	orphaned
16249	3NKH1m5f3it3uMD1aKEGUKcXGf4ceDtKmRPdehFWLTFVom1udqw6	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1541	1298	267	6301	12215	jxCzAGxmxCnTnc4uLvrnsyMNAK6hQpU3LFBwEneFdQhK9wtHESp	8258	11691	11691	1618043580000	orphaned
21442	3NKpG1ubUBKtKkCZ1BUizAYT69QbaQZ8FWPEhaWw47prDFRj2M9m	21188	3NKFjg9tESEvZLRwhTTnMZorGYSpEhwyxHSMt4EgXGzCbQkvZLtV	484	1319	380	12463	13657	jwZcozkAyTzhDzxYPT4cfsk8ukZYALzvgoJQbWLceQ3ogeVUXjt	10478	15149	15149	1618666020000	orphaned
16151	3NKGGehkjNgUztVcaKoB1XdG2PqwPBhtcoHpbm2dVWmFAsdsLriH	16149	3NKui4KJzpt8pSWHaKs4a2pjSHRbJjVGkL7R8T4m6bbEwKDcBKVY	1637	816	265	6301	12127	jwXc7jxDW1UZxHfY1iRpZmgxrKHuUBSKUwpvy3MogUcq2LBdrb5	8210	11633	11633	1618033140000	orphaned
16153	3NKJHfSv5HkNHn4cr14i3mtkJY8ej7HSpD2S9t7XsGSWRfCogNUg	16150	3NLtxWASUTExDbt8mGAsq2fbGEkhgTZKJoWUkKnqsQM9mRJe6mDs	1476	1371	265	6301	12129	jwJ47qkmtbCWuLvkX68jnKi4p1ZyXb4fkKg3RjYqkoosCg6Mw5V	8211	11634	11634	1618033320000	orphaned
16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	16152	3NKaqZ8imKJu6FhzTSJavanojNBTVFP2JTkikaxYCFx6AjK7wRTU	1439	1033	265	6301	12131	jxDDRLD3kSH3bWpFJNvSSi2wfaK6AW5W1NjYxi46fPK8y5bgegX	8212	11635	11635	1618033500000	canonical
16161	3NKnE5qUbFHQjGZkA6NxCFMHvjrTRyP5LUzS8bXqdkyVXYMgZ6w3	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1405	867	265	6301	12137	jxqcTfS6r9xYLdvCB55EAboC5ZqeVhyKC35LjEE97Y5q16TEe2w	8213	11636	11636	1618033680000	canonical
16157	3NL7PnpU8cjTebaWh5XRczQw87fu5KMKKhPknbQmCYKqKmRt8s9n	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1672	1285	265	6301	12133	jwxtXKbdeaacfWoaQrcPubGvjTWhpiPJc3sKYysn6cUGhdo3KMT	8213	11636	11636	1618033680000	orphaned
16164	3NLEwJYMyKUpatAPCkdJsxNtFYczvaDUMgAxyZMo3P8dSk4ScND4	16163	3NKt8rVzb5rEYw6Q8Qx8wkCPCTsdLrBvWd7VMtiohb9qTPhEWk1x	1553	776	265	6301	12140	jxnES2WarhxSoKda4xNXciNvMK8iRoTow5kugEnBUiyCaPMMDhP	8216	11639	11639	1618034220000	canonical
16171	3NKG5sfi2rMNozvCF3M5nzJ1ZH7vFUYpdmHxc5WmJG4P4n1dL8eX	16167	3NLH6JoazwH9GBzuc2Q2sTuRE6mTTBoNdkDFV8ZmKWYF2WQE7AWz	1567	567	265	6301	12146	jwap8z689ZaHjBePdj892oE9ZMyB3jf44JEddim56HbawwTp6oS	8220	11643	11643	1618034940000	canonical
16178	3NK9xg99C772UHSnUB26J68hVEcMVLNSLwAWhTULs8Bt5McW6JRa	16176	3NKCgLHL2AWSU2ctQCWjcogihvaptxB7ZuxNDBhhpuj1S2zg3VNv	1581	778	265	6301	12152	jxJSCnGQVary5KC2VYptQjr3hvWxJufTAucWHBKbVKkTUeREhSi	8223	11646	11646	1618035480000	orphaned
16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1598	543	265	6301	12157	jxcpqva1oEmD4StXX3zeMhM3ZFLiLVmK2opccnqqyXe5s5gCb9e	8226	11651	11651	1618036380000	canonical
16187	3NKVYUmenvnSAtpXwBTNbJhNNdpC168FfLFgiDWPcrfps883HH52	16185	3NLLJyKFuhShWU7biLPc7WEzhiQ4JB1dHT4obLF3XTVwwsLS1RB3	1529	635	266	6301	12159	jwiveth7qfkoWUgy5URTy1Q7suur9Le7xaZZ4EtCmdurkX6PMtF	8227	11652	11652	1618036560000	orphaned
16239	3NLvoWfsb3FfLe5S5dckf5khPEosCzCeLYUBdnP9vjByrM5on5TT	16188	3NKeUrrAGGCy1ee1zSvpj3rQW6D4qhuKcyNB95mD3n5ndZpToZUF	1547	1378	266	6301	12205	jwiDUQmEEcNu1fFcju8oRaLrKfzqZTQQEWq5xVoxXJb68HHAagZ	8228	11687	11687	1618042860000	orphaned
16192	3NL1GTeCRA6WbcRVzgQWcTgR6V4xfon3S7fcZHX7UmZTmcEmitPD	16191	3NKhKD5vSHt9edS6qc5otL68tf3D17N8CAdnTcgnU4E74ZP985tE	1406	1393	266	6301	12162	jxHGZEUhX2vxNvdnpFHCassH1M3ucqXsfRxHonwFN3cutV1ptjw	8229	11656	11656	1618037280000	canonical
16193	3NL2N9bE35FA8Ky7CsbEKHh6LzySgDgW8wWNqKTmcJLL2bYrzZ9t	16192	3NL1GTeCRA6WbcRVzgQWcTgR6V4xfon3S7fcZHX7UmZTmcEmitPD	1405	867	266	6301	12163	jw7CxL17Dkmo7xnSA8uSMi7wgiG2kWV7SL3tTFkosP9H1ZJeSAt	8230	11657	11657	1618037460000	canonical
16195	3NKFizQaheXUnERdGgHNbsEVmrX8tDDSiyfaKMsFyi8x1QRRa5LY	16194	3NLKF5BpCLyVKRuGnjSVS58EYWcigH6ozLmdgq5ekj6TDSa7xPxb	1516	1168	266	6301	12165	jwSfWuXfCik7Vzzu1Gi8GVbJiJMJyyFyPNrFgeLNsRX1QEUp1DR	8232	11660	11660	1618038000000	orphaned
16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	1657	1218	266	6301	12168	jxfWMwxa3er4PqeQVLhkEbovkJP1iuwDJsqSoenKRvkp5NMeLVC	8233	11661	11661	1618038180000	canonical
16200	3NL5vzahqv6JkAKZqXkiMLqmHBWp7hdwyLmLSP3rjNpdKoY7WJ8j	16195	3NKFizQaheXUnERdGgHNbsEVmrX8tDDSiyfaKMsFyi8x1QRRa5LY	311	1307	266	6301	12170	jxafrf8phKB2ZZ29jVXPYfoD1mu7dwuUSoxWDqTyiiJyTXSBkua	8233	11661	11661	1618038180000	orphaned
16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	1596	1237	266	6301	12172	jxYffQwGngtrxk2cU7BruEPsBimogYqbU2QZcitg6QJLfd5JXwL	8234	11662	11662	1618038360000	canonical
16204	3NLuAg8Nr7i9fUjGkKXWfoiKkEwUdh7G75EZpKPsMMdcKtJ5jHus	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1490	908	266	6301	12174	jwVpXuJsXuPGcLqccAY6ite7hRcVLFuvJUNUqSKHPPRXMzadS96	8235	11663	11663	1618038540000	canonical
16205	3NKHsnHXwptECrc2b4L2MVHt8f8Fb99FG177kqfjNnLW5kit5gdU	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1407	1395	266	6301	12175	jwt63mSvmZTCGqU9698ax6j2GRUXUAz7cvsGsTBJoi293bLrxAZ	8235	11663	11663	1618038540000	orphaned
16209	3NKiGW8Cm3K7VNKTwZXydz3sn5LJRLGoW9jGZ84Y5FkwSpGMWk78	16208	3NLK7shaFP42Yj1AujKVEYPmz7sjxGCkpVWG33KC737bUAUXwhLZ	1444	1381	266	6301	12178	jwGUqBKFy1PYHJmQt1wgATzwfFGwa7vauCtcaeKiKH8Rcnhweaa	8237	11665	11665	1618038900000	canonical
16212	3NL5H8sZ1hjYd9Z6UhXE4WpagCUyFyHHL9jdM8chaoNqkFSQoap1	16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	1406	1393	266	6301	12181	jxpyL5GDvdQxzswjs8Y3fpe6NSTc96gdPHJKFD5VibxtL5D7PC2	8239	11669	11669	1618039620000	orphaned
16217	3NKejUzcGQ6zqMRfdAXLFhnMFjdX3eCV4rW2MEn1f3NToAxwNGjp	16215	3NLwHfHeuGt6YAoGMRnGSwau9DSMyFEhWccvoi5seJuH5RuvUnP2	358	358	266	6301	12185	jxF9sDA259rKTZBr755LpsPjyVLqDWEmhX9ppL5RLiNFH1o4Chw	8241	11672	11672	1618040160000	orphaned
16219	3NKZjRHDXY7wRNMBX5L32MHsGGubpDvptstDE72EJKQJxx6xUrUN	16216	3NLq9QdsRYCtEesx5JmdvjKzXmG2Bp6kupWpRtRZ62vk5qgGHuzS	1637	815	266	6301	12187	jxLYXUb5gZXursVdP89AofSHVd8iSg8i7SXAU1aGyi57N83fizC	8242	11673	11673	1618040340000	orphaned
16224	3NKnXUwX77Raz8CMBupssLbr9RE85QeuLuqvD8ZBMaieUwvb1LrE	16222	3NLjNG59BeZzfyeBcYSzid38Jd2RUUKfiwJq7BfxVq13jjA5Ea6n	1650	1249	266	6301	12191	jxCifevP4PU9R6TeJE6uAx8WmDjAWUrZ5bquCnSXaaVcN4AbCzn	8246	11678	11678	1618041240000	canonical
16229	3NK4TwPypcbPifkb1p1E6yi8CwgqL7xA8xJNUuDnWc1ADkyDritS	16226	3NKB2qegWUXHzw3VfCahe4go3Br2NyEx9iGLfEbFzSRjYMsHoapC	1607	242	267	6301	12196	jwrTMC6fcUAtkfLfumEzv57h7xuBsxgXGq1L27YTWXjppzwDfGe	8249	11682	11682	1618041960000	canonical
16232	3NKcynFn1XwihayPcDnK42oKTPXC7uJNtep9J6mfDgkWg2fszjhC	16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	1600	1372	267	6301	12199	jxLC8sv2fE1hA9mASbGpyc7hiMp1puMxdHKuna4ktmtR8oeSgvs	8252	11685	11685	1618042500000	orphaned
16236	3NKDPEyT311FuK87YZHUPnL9HLpwJwjAcGqRHMKK5MWxyEb9mgNi	16233	3NKkC96V9yX3zzG7wA59nTuCKfwsC3nQWdHPA9kSfMg3H8uAxooa	1426	1364	267	6301	12202	jxH4tgFCgdDdCgo2F7HBTVv5cgHg4ddUzyxXiERvjU8q2Nvhtxb	8253	11686	11686	1618042680000	canonical
16243	3NLNGSZyQAWqxgHbEfeP7FeeobSx9pGGmnZVdUGnoENKzv8945rh	16241	3NKVJGw39pLaRzrWwLA73uupdxvz1RWMav11BVeUxK6CunZkAmn4	1406	1393	267	6301	12209	jweu2hEtSw4Rp9S18BvfBZxea5XMNbKU6ugJSQfut4wWV5BmoQf	8256	11689	11689	1618043220000	canonical
16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	16243	3NLNGSZyQAWqxgHbEfeP7FeeobSx9pGGmnZVdUGnoENKzv8945rh	1581	778	267	6301	12211	jwNeMDUKouFRnhPKDYmz3uu8cCE7ADTr6F8GE3mqMM2R3LUwyN9	8257	11690	11690	1618043400000	canonical
20964	3NLdU4d2d4RXBKxsEZot8vEYC6AXCkUDFHnyKos8djHuko2dU819	20895	3NLrYhK4P82DppAsMxGzQQbstYFKEWh255QZ6kCZ2zCpB4FMvQUk	1457	1265	380	12463	13243	jxfCXPKS3af8efCjxULFNmpBtAdujZxBfmw6B4e5c5LWnMQEekr	10504	14851	14851	1618612383175	orphaned
16184	3NKkdqr4brRfLvWvi8gmkwTqzJj5MNJ1dngtU3hKuTimkqvgHnho	16181	3NLd43Fo1DiQq1YKfJsWioyktmHCAt7tEiEU1E3aKjtzoCReYojx	1523	1321	265	6301	12156	jwZ2AxAcywwUNwfWgTougfAY2Mn5FGJXaeqdfuMpnGWgw4XnT5V	8226	11651	11651	1618036380000	orphaned
16194	3NLKF5BpCLyVKRuGnjSVS58EYWcigH6ozLmdgq5ekj6TDSa7xPxb	16193	3NL2N9bE35FA8Ky7CsbEKHh6LzySgDgW8wWNqKTmcJLL2bYrzZ9t	1560	925	266	6301	12164	jwmeT92FgVMppxeSqS8ceRhfZw7XUyZ1KRSG9tSxekpSc4a8FQe	8231	11659	11659	1618037820000	canonical
16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	16194	3NLKF5BpCLyVKRuGnjSVS58EYWcigH6ozLmdgq5ekj6TDSa7xPxb	1403	824	266	6301	12166	jwvFviysxeCiqBR4B5MJYc8kxpXoHd97Efii58tdUX78gttqQUa	8232	11660	11660	1618038000000	canonical
16199	3NL8u1rA92ePDdztuY13vA3k7w1eL3mr1XPCXMd88p5TSZj1F8z4	16196	3NL5tjHiNag2f6ysn1Fjq8Yvs4T539JYx8fxPfEATHa6YgFW9Jm9	1549	996	266	6301	12169	jxNe3uEw5Y8YbjT56LkgdWqxpNxPQfh5EZeacBdHcGUEVCT1UMX	8233	11661	11661	1618038180000	orphaned
16203	3NLDgV54Qfoca8CytpG4RPn9ZEaJBM3Aj76Au7MEnSTrsMtBrcvt	16198	3NL7Yf2KuXui1iUYqC7ZqAqZkL2C3tQy1fzGAYSfyHv9ccgXQWPE	1631	793	266	6301	12173	jxMWENnLeCqFU2xNA7grzHEYY6UAFuMxFpouo9vYNPZjFCT2sue	8234	11662	11662	1618038360000	orphaned
16207	3NKZG3GNF1stFnLAduKBSatCUS3XvzmAg6k1fjzkiRgFaPSq65ws	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1489	1254	266	6301	12176	jxXwwh1GwWaQDsYKWnCL7tZGH6h3aXDpVvHzkb5HqnBQfDbE2qU	8235	11663	11663	1618038540000	orphaned
16208	3NLK7shaFP42Yj1AujKVEYPmz7sjxGCkpVWG33KC737bUAUXwhLZ	16204	3NLuAg8Nr7i9fUjGkKXWfoiKkEwUdh7G75EZpKPsMMdcKtJ5jHus	684	1106	266	6301	12177	jwDfvTGwpMFJH1D791zcCnDmvU5wPDN1j7eSNvMNGrsgfCbEkvD	8236	11664	11664	1618038720000	canonical
16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	16209	3NKiGW8Cm3K7VNKTwZXydz3sn5LJRLGoW9jGZ84Y5FkwSpGMWk78	1509	1320	266	6301	12180	jxvUAKyb5tMTwJ1C2YSRGR9AJ11GpWH7dgHct4edykEQvoUf7j9	8238	11667	11667	1618039260000	canonical
16213	3NKgqdKpb4ZgR8p9sGfmk8yu6BG19Zzztt2cExeFvcsdgcA77MkX	16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	470	1309	266	6301	12182	jxYj4M5Pbm3FPKwjgMw4jYozJS4FzsvpN61BCJ7w5GKCidyYatX	8239	11669	11669	1618039620000	canonical
16215	3NLwHfHeuGt6YAoGMRnGSwau9DSMyFEhWccvoi5seJuH5RuvUnP2	16213	3NKgqdKpb4ZgR8p9sGfmk8yu6BG19Zzztt2cExeFvcsdgcA77MkX	633	1018	266	6301	12183	jxvbWV1zzZuFQK3KzEYrk28FsJYoppq7tNAWTMBCnuBYFbSdRV3	8240	11671	11671	1618039980000	canonical
16216	3NLq9QdsRYCtEesx5JmdvjKzXmG2Bp6kupWpRtRZ62vk5qgGHuzS	16215	3NLwHfHeuGt6YAoGMRnGSwau9DSMyFEhWccvoi5seJuH5RuvUnP2	1529	1190	266	6301	12184	jweaQuJUbwYfKcWa9fv27t3ZARvZHEBzLm3uVKNy92zM16rqDxR	8241	11672	11672	1618040160000	canonical
16221	3NKAZQ99yU47FjKWTLvouGW3tzzyoefpaiZ4jro5YFzsw3R3rztS	16220	3NKVxzvuFePz94jHdri6pi8HE4sFoArdKTcff8jxVtnVuLeuTRPF	1581	778	266	6301	12189	jwQMmW5r65uKvwAaEAXYsTpkyxsK2GevfYoq8McapArjmK9ECMt	8244	11675	11675	1618040700000	canonical
16222	3NLjNG59BeZzfyeBcYSzid38Jd2RUUKfiwJq7BfxVq13jjA5Ea6n	16221	3NKAZQ99yU47FjKWTLvouGW3tzzyoefpaiZ4jro5YFzsw3R3rztS	470	1309	266	6301	12190	jxxA65SLhLGu32ko2ZhMBDpsk2cqBaiiWLyvFKiYGrgNdR522kp	8245	11676	11676	1618040880000	canonical
16225	3NLj8fm6afRTmM3yrZqFaKRrVDLbhFukeWhefTtRUpUNgMGRztzh	16224	3NKnXUwX77Raz8CMBupssLbr9RE85QeuLuqvD8ZBMaieUwvb1LrE	1616	116	267	6301	12192	jxQ6mDtG8H8TaHcCp4B3489toPk6XYZNctTFmZnXCCvpU1Rbzug	8247	11679	11679	1618041420000	canonical
16228	3NKyEeMfUmng7wBdXjU5ZWojfZyTRnZviwpiRjFKRhiqeYAmAvGS	16224	3NKnXUwX77Raz8CMBupssLbr9RE85QeuLuqvD8ZBMaieUwvb1LrE	1447	1345	267	6301	12195	jwmcmQDo5W9UTAuFkV65Pkys7W6VV7f1ntM9FHxWyLPchjaA5h8	8247	11681	11681	1618041780000	orphaned
16226	3NKB2qegWUXHzw3VfCahe4go3Br2NyEx9iGLfEbFzSRjYMsHoapC	16225	3NLj8fm6afRTmM3yrZqFaKRrVDLbhFukeWhefTtRUpUNgMGRztzh	1402	866	267	6301	12193	jx2SUZo1R1ARY1Uijbc3knacibNuxhYiPab8GDorShqeSrWrKTn	8248	11681	11681	1618041780000	canonical
16230	3NKKwZ2TzNtHKXx8gjzchsWCot2qPX87HQW2Mbk8D5BfeSzFB5Hp	16229	3NK4TwPypcbPifkb1p1E6yi8CwgqL7xA8xJNUuDnWc1ADkyDritS	1643	1299	267	6301	12197	jwG89b7eAGHZyfabv5Q3fwsaYwEtjradLQtjbpsMZDEf2z1HBLq	8250	11683	11683	1618042140000	canonical
16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	16230	3NKKwZ2TzNtHKXx8gjzchsWCot2qPX87HQW2Mbk8D5BfeSzFB5Hp	1407	1395	267	6301	12198	jwVKvvJ41FfL2WS4VP3F7JThVDGhz7fz94VBwyPFvgr1sr6yGQj	8251	11684	11684	1618042320000	canonical
16234	3NKiudPuufxUWPu4oSYjQ8FvLJjFfWjgBEKLDoPGbvWfRyoPzjn4	16231	3NKYUoLod7VWUhyeVQTpcScQaUf5QsvKUZ2YPd5oZuBG2KXy5Kcf	1511	904	267	6301	12200	jwFQyKJToZkxmaDpbrBPcx9omiESiRjnVRMT9iM4btbE8YxFF58	8252	11685	11685	1618042500000	orphaned
16237	3NLKTGNUAtsuzu2PYCtQw23mLcy5QLhC1Heu3gQYTrFWsWU2YY4t	16236	3NKDPEyT311FuK87YZHUPnL9HLpwJwjAcGqRHMKK5MWxyEb9mgNi	1476	1371	267	6301	12203	jwhB3FjWY8SMpJeTCmeBcQ72DZV8xyoQjV34YuMYAbBH5VZ5F5e	8254	11687	11687	1618042860000	orphaned
16241	3NKVJGw39pLaRzrWwLA73uupdxvz1RWMav11BVeUxK6CunZkAmn4	16238	3NLdGPhNeLp4Y7eufxUPEArpRetGxa7TF11jC5dmn78Ntv99gWge	1585	1366	267	6301	12207	jwop7WNaZ8mqpPo5VNSvyuevoCj2PeWfr6LYNGjC6U5a89hKQRT	8255	11688	11688	1618043040000	canonical
16247	3NLoMefigDVhmPYTdnv75UYEfcGxK6AuiXH9yGijGg4jVuuootFC	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1536	1187	267	6301	12213	jxwcAL1qgYns87mAPEqSe2eGBXNUva74v7xBgqJPtSesoMFVXcq	8258	11691	11691	1618043580000	canonical
16250	3NLZwinVuUTtR1eeC24GbrwTcXZ5WoqhaTxc5gGz7aAhp7JKY99V	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	484	1073	267	6301	12216	jxJn1wNBkfeyNiYeB58Lm9NYy8Apmbbz6oHWnykVz3ncu4ZWHAp	8258	11691	11691	1618043580000	orphaned
16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	16255	3NLJbiVCNnHjRYhEQZTSPFueu3H6Qazy9N7uK9VoBd875GxQtpCA	1403	824	267	6301	12225	jw9KRRHFYnyiGBHASaxEatbwjcrjtTgaiAza31ZdiCCrRQg538e	8263	11696	11696	1618044480000	canonical
16263	3NLG4ESdC8HZP3wFTLgu9ayAPCnmhRR2aKB9w8RKSMQpgw1yUe2a	16262	3NLybzf6ExjtKWYndKMhsTF3ZafmwTXpzbWot16rCgiPonnMNXfr	1518	833	267	6301	12227	jwrx1NXESdUzH3TaCFBLbuh5AMxwSPtXHGRXBjhZoQBp2a52znN	8265	11700	11700	1618045200000	canonical
16268	3NKbAgfr45fscgoSFD5YgVcond7FsymKzseX7D1YLfWjwxxeovcu	16267	3NKQLXb3HQDVsjwx9WTRTER96MfVVZh3WAo5ijGtEDBR1QoKyATd	1407	1395	268	6301	12232	jxn6neWNFy3yLbqG7hMmxzD73PioVZ3Zg6FaNybvpcAZY7xRKSB	8268	11703	11703	1618045740000	canonical
16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1523	1321	268	6301	12241	jwwYUQXiuDKYKM7KsFcv5P9uUfS3Ha89ZcsSNJkWWc3BsghKTWy	8274	11713	11713	1618047540000	canonical
16281	3NLhqmVatzzAoGbCQFCUz6rFUywjyK38Zyr8AjfxHBVhAHpECTND	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	311	1181	268	6301	12243	jwiu5SxuVv5oFbp5WgRTdZL43SucVhNyFGBCy6EuB4GeK1nPYXr	8275	11714	11714	1618047720000	orphaned
16284	3NLvoXpZSsL6CmJa4eTAJRghdUd8RhEcYhehJuqiVSiCgd9b4XXT	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	1596	1363	268	6301	12245	jwoN4Kpr2QfvkZwHtLnCfHV8MpKSnazLsLr4vpancSNeDvnkdvi	8275	11714	11714	1618047720000	orphaned
20902	3NK64i5pTQnn675YWgN7Ksqjc7wTRPTgUQq5dRDZtQt3vvsnnKCz	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1448	1311	380	12463	13186	jxXeTuj1txQzjWRarMLm5VQbp4UAMMGeFfW5xkJxEvtw3HKx29H	10506	14795	14795	1618602303964	orphaned
20901	3NKZoiKrPbMcSFqi5pGgYiHMhCjDqFQaZaGXMgwa1C5XvSWiHC9q	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1448	1311	380	12463	13186	jwdJUPbPzC9EhRuxRVMRhtjMmHV8hMErT51wa78nSo35E6X423W	10506	14795	14795	1618602300000	orphaned
16248	3NKHkEmNq7t46oZw7wNFmsFDRzp2A82fTQppDbU2LkFkNLFHjaq2	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1483	1030	267	6301	12214	jwccxLduPkpxVwJFFjwSyM39hD1wStW7XNQZmxbcJ45KeWkH58N	8258	11691	11691	1618043580000	orphaned
16252	3NKdNfVkQEibT9j8o2ndXgcAfZwyMqLNcSFEJ1oTpa48DG5WExGR	16247	3NLoMefigDVhmPYTdnv75UYEfcGxK6AuiXH9yGijGg4jVuuootFC	1559	1353	267	6301	12217	jxLj18eq3BDTq1kzg3aKWnxn8q5wybccXS85N3VSkATjruzFuV3	8259	11692	11692	1618043760000	canonical
16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	16253	3NLCuyGd83Exxgjpd8uSML76yzdyZo7tidGV2KL9UowPFYGmxd4r	1437	155	267	6301	12219	jxhPdYX1c3a3vPzy9QpDJrGQd69fJXJ4WydwzFJRkMEa4s7NXjw	8261	11694	11694	1618044120000	canonical
16255	3NLJbiVCNnHjRYhEQZTSPFueu3H6Qazy9N7uK9VoBd875GxQtpCA	16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	563	1359	267	6301	12220	jxF57XBVf8SBcYe9DaHtQgtC4BoJsXdAyuucgradNxkVim9mjNB	8262	11695	11695	1618044300000	canonical
16257	3NL6fxPiF2zUDUY6tqnkuNdz5TZdttEEwzCfMpmH9qjJyeVX4bpk	16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	606	1295	267	6301	12222	jx6A9MysXuRqZKABU7EEAAMDMFXXigHb8y2cEmPWKHmoaPfJaaF	8262	11695	11695	1618044300000	orphaned
16259	3NLMQqbTj42XWRocQLozjmsb8SRdQV879X9djWM9KvqYnV1yvDWo	16257	3NL6fxPiF2zUDUY6tqnkuNdz5TZdttEEwzCfMpmH9qjJyeVX4bpk	1407	1395	267	6301	12224	jxokGHVcY9vzAiLYwgBDAhQYzHeRuc9ADfKkwFMaJXzneoMrtAA	8263	11696	11696	1618044480000	orphaned
16261	3NKpTLGarpB3b7ji3NRSsJT4qKvXCi3HaX7Vyb9NLoomKxQMe1rv	16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	1547	1252	267	6301	12226	jx1wUjpwJY6JHrYDuDnL8qrTJAo7GuwZmjXdV1DqHxJ9vdFTsLC	8264	11698	11698	1618044840000	orphaned
16264	3NKwNso4MtB7LByHCdfKZHff8Vd8X8HgcNcapMCbJroEG4zRgztk	16263	3NLG4ESdC8HZP3wFTLgu9ayAPCnmhRR2aKB9w8RKSMQpgw1yUe2a	1547	1252	267	6301	12228	jxepd2cta5VPYtMuHzGiegJSoipwYK3Qnx4ugwhXe2BPtsx7PRG	8266	11701	11701	1618045380000	orphaned
16266	3NKL4paL53Yp47dPk8NUcEa2Wkjtp4PkT542zMfVJt4NGCqs3DtR	16265	3NL1YaXj3uchhSgywaQefq8Yu8yCRE6yxvtnkQrDuaz2arGpypaq	298	1182	267	6301	12230	jxTuBr97eUgAbGsgk8grmWCMUtwyUTjck1Nw4Xon7F1WwjBqYyE	8267	11702	11702	1618045560000	orphaned
16269	3NKHdL3CuswnwG3YhkGtq4shgJCXV7m7KxsWCSZyfm2tAWq7BCMT	16268	3NKbAgfr45fscgoSFD5YgVcond7FsymKzseX7D1YLfWjwxxeovcu	1637	816	268	6301	12233	jwkeAyL5xctBi5g83NEEFsMjByzhxJwVwXqS8kBPVCatHhbfyzs	8269	11704	11704	1618045920000	canonical
16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	16269	3NKHdL3CuswnwG3YhkGtq4shgJCXV7m7KxsWCSZyfm2tAWq7BCMT	1406	1393	268	6301	12234	jxad4RypFcAMWrLJmn9vdWDXoicdtKpSQCgvF44TdauKKw2eSDg	8270	11708	11708	1618046640000	canonical
16272	3NKzwHkEyByQYRVQsxd3qk8M4zpGcuZMGyNN2vc1FT61biigB9mS	16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	1519	859	268	6301	12236	jxaMpoTEUW5NKqAD5ePFMHEw7CXoBurkvTajbECdJtKzqzSELjc	8271	11710	11710	1618047000000	canonical
16273	3NLcCDvGDKYKzX2ZJikdpdXqwen2hmfhVwdP6NT72no86iCXbBgD	16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	1477	984	268	6301	12237	jxKMWyxgTsmXTrHbYRTe2WKBhAFruyCEuxWiKC7smG6Ri8F5MFv	8271	11710	11710	1618047000000	orphaned
16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	16274	3NKxJeRkB1hoL3rdBucP9CXduTBVci9PXA9hy1dxy1NWpr4fA8s7	1673	1368	268	6301	12239	jwNbsqTEYSLz64yWk61J4eBDSvwbYDreUT31Rf5BtXo1JHhD84S	8273	11712	11712	1618047360000	canonical
16276	3NKQwKHViepjL1xryEeqN3KwMDNkyMYMMK6bpWLyujGxtmaFYjPF	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1422	1337	268	6301	12240	jwuA7Eyw877BWbgUUxeksGVjRb2hipiGxeUuQFt3d4f3orxFeyG	8274	11713	11713	1618047540000	orphaned
16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	1476	1125	268	6301	12246	jxEPXSwYp7oNcdiLWD5hrZ3GrwCX95oowK6bWCAU2fgp2QM7JmJ	8275	11714	11714	1618047720000	canonical
16283	3NL9DzZDGrZ78QLo85ASZeg5EFcetiy7qrw9oXLf13VYwxPkVfVC	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	311	1181	268	6301	12243	jwqXVbMtB66Kh2jaAzNPkstZ8UfRQafnCFAtxYzqm6sH9s31YtX	8275	11714	11714	1618047720000	orphaned
16282	3NLEJhST6PUcr3pV31a2p37Q2emyRjevzES6SmefgTNhmtwyGBzY	16277	3NK9STi4u7oFNYx9vZYBpgW2486usAqM8aPyyckv6rD1kVVTAAqd	1560	1291	268	6301	12244	jx8bZaWqbWBUTjtbsnXbEy752UK8ddmDFaP2kD72i6Zck66s1YE	8275	11714	11714	1618047720000	orphaned
16295	3NLWfN7hD8xpTL4SkGRsWCyThLuRseYJFREZq1VmQFQaAyGfPezF	16294	3NLGLex6VGoXTaKy28FfgsC2YMXxiKa1FmyxCUCVrFBB3q9SKM5m	1622	1356	268	6301	12254	jwMmijUsU5vUW6siDxK1C7AybDqzjb1hWGskUG52rX4nsYYpYdK	8280	11720	11720	1618048800000	orphaned
16300	3NKvG7xiUan6LwDyrTnFRJAVCdYADHFANrRfNYunjnFJzx1RPeS4	16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	1581	778	268	6301	12259	jxJUuDtLGb63T1Eb755ZWZaLSorLeYo1Wd4ezLSUM7aCoEXawso	8282	11722	11722	1618049160000	canonical
16298	3NLM9dNdmwE9kXM1HaZp8bQ3GguGZomjUbMfAV9qM46iSiuv2TNy	16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	1447	1219	268	6301	12257	jxW4oYaJ2Ff5YY6xVGRccgUiG4ZzTsdtxHiHx46YQD7uu7BK3sP	8282	11722	11722	1618049160000	orphaned
16302	3NK5ungoE3Fz4rfNPF87fLKjxbpL6JG8rsYLc7Y6AGsXFcgoN6iT	16301	3NLiyg51gTkL5K7Nabpeh6KKFpAmXYX5joBpB8augRfzt31enZCZ	1403	824	268	6301	12261	jxg1QnN7Yz2bdJsUjzZnzBdTdJ7rqa8RkKtzByHU9ufkv1RB83r	8284	11724	11724	1618049520000	canonical
16303	3NLQPgWxzYjF73dG78FoJ5AaYZvfLWSLfQaNh82oBATbJ9sQAiA6	16301	3NLiyg51gTkL5K7Nabpeh6KKFpAmXYX5joBpB8augRfzt31enZCZ	1623	839	268	6301	12262	jwdkKhx23R2NqEri6sBufN45FAP5N925xb4PRefxQpHsujSLCkh	8284	11724	11724	1618049520000	orphaned
16305	3NKn7KXAEADiYq3KDKXK6riYTLK4yFKjUp7Uog6kLwa5QYVj2UBA	16302	3NK5ungoE3Fz4rfNPF87fLKjxbpL6JG8rsYLc7Y6AGsXFcgoN6iT	1613	983	268	6301	12264	jxDh7tkVdxCEsyMQwvaFR3f8Ht9ehjypvMTya7iYpSbyaeb9Vsn	8285	11725	11725	1618049700000	canonical
16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	16305	3NKn7KXAEADiYq3KDKXK6riYTLK4yFKjUp7Uog6kLwa5QYVj2UBA	1407	1395	268	6301	12266	jwgTo6HVkkNJWRpSUff3W9x28xU8VRmzbGGRMXBCFHWx9Ms6Fk4	8286	11726	11726	1618049880000	canonical
16312	3NK4xSVTtdVeFXQ8WwhHuPNA5kUw98mkNkvcSJrWsZhmWMMHni58	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	563	1359	268	6301	12271	jxscuHSNg3z6Q9tYjSCrG7tpRwHeN3nkWebHfLGdUEPpzV9XnM4	8287	11728	11728	1618050240000	canonical
16321	3NLY1dC376kKPeLQKgqkTvYBA4hfM71e1YMpjrkNMZEzmBjLk1r5	16320	3NKEFTA6BGYt84fedi1n8SRuziS6ioHsVyDV8DaviqY6TCnvvRKu	1460	573	269	6301	12279	jxgCUy8pc1sYfQtobXCAGGQFZzjXP8sgwGsFKEBVJxqc6i8ge8x	8293	11735	11735	1618051500000	canonical
16326	3NKChFeEimnjCUgowPKai1irr8WPdLEGo7jR66bo9hHUW61iS4Vh	16325	3NLSbg6C1iW8rumivDR4LGS4SnvDRvLzWhNkw42eWjWk8y7fTcen	484	1193	269	6301	12284	jwaW8MJKDCzWVd8peHhfFd5H91etKoDSD23c3RDu3rAnC9W52CS	8298	11740	11740	1618052400000	orphaned
20909	3NKaD7QysyNYsvm8hJ95iYEXpAaDM48EdQGM3ZNUqwM6xEa1J12e	20908	3NLhNuj2RoeTNhC9igQNkYBywCuTedSg8HgLB8kgBEj5JwLnEAS3	1553	776	380	12463	13192	jxaRgnbNxvURXQRPLQd8aScUWJ1YgVUR4E6BtfU36Hji7UQVMTS	10510	14802	14802	1618603560000	canonical
16374	3NKuAakpjeRyjZpznKfn9FXjoEFyVRz7xgiJqHCcvL3SgZgdCmxf	16195	3NKFizQaheXUnERdGgHNbsEVmrX8tDDSiyfaKMsFyi8x1QRRa5LY	1513	1133	266	6301	12328	jw7pEnadrH1KzMRRn38nW8LhE839uSKjDnQmzHu2Moea2Na7CXw	8233	11787	11787	1618060860000	orphaned
16286	3NKBqZgScTQJWTjYgbm5uthbntFiLnM2aySSw7trLhuwCDwghUER	16240	3NKeDPXLd6a3juchSozfv4357hLv4K68b44Vwp12qxTadsXwWc9P	1476	1125	266	6301	12247	jxFFK4tQSeR4GzDUv9qhQENr6n4QkZyPVLPbHb9XGrL8HSdbgyB	8245	11714	11714	1618047720000	orphaned
16256	3NK3eUHkNWjCsdeahuVmbbDjtFAkgCcwLWvqWBx7bY1PBgC7sj8F	16254	3NKT7c4F5Zfokv2YrYLW6qkiEqD5MpzQNPhLYdu8mvYAruGr9k8T	1458	1197	267	6301	12221	jwboqhDUqzjcUPgspJRVFWbruRLUd59DFU8XwJiHc1bsJj8pUdq	8262	11695	11695	1618044300000	orphaned
16262	3NLybzf6ExjtKWYndKMhsTF3ZafmwTXpzbWot16rCgiPonnMNXfr	16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	1547	1252	267	6301	12226	jxAvFRhwmhxTDtn8cwaaG27hRQk7sEnjhmDVcb4S2usva1DnQ6U	8264	11698	11698	1618044840000	canonical
16306	3NLQZu4GhbFzR5A5B68pmJmfz2GtPjCYBnK5igsDfeTtcasfUnom	16260	3NKureDCsu7iYhzgDRZ7mVGXRXskyo3fZdWMtdmeL2irUhvWH25X	1613	983	267	6301	12265	jy2Nkq7tVg37wecwyBodMAs7D64yS1qH7votuHD8cha6hSyQnqD	8264	11725	11725	1618049700000	orphaned
16265	3NL1YaXj3uchhSgywaQefq8Yu8yCRE6yxvtnkQrDuaz2arGpypaq	16263	3NLG4ESdC8HZP3wFTLgu9ayAPCnmhRR2aKB9w8RKSMQpgw1yUe2a	1581	778	267	6301	12229	jwgMHe11zGTB4DvCYY1ARPhiQCSUXS1c8dhWLBoCyxeV9YF5S6i	8266	11701	11701	1618045380000	canonical
16267	3NKQLXb3HQDVsjwx9WTRTER96MfVVZh3WAo5ijGtEDBR1QoKyATd	16265	3NL1YaXj3uchhSgywaQefq8Yu8yCRE6yxvtnkQrDuaz2arGpypaq	1559	1353	267	6301	12231	jxUuXSyYg1JqNKDC6PoD2oSYjhoDaBJytRRb7uZYmn4yErMgKXe	8267	11702	11702	1618045560000	canonical
16271	3NLDcqWt6YrBZR442LY5tJ16qEPGsxQcqy5crQnREmLrXVPDc1mz	16270	3NKywKBn8raEdvbVGFr2MVb1Pt4H8hcffDkByxsEiobk5tKo9XPj	606	1295	268	6301	12235	jwdMfdcmyE7tsdABDsE5MvqaTcdhAqipcDjzMiESc9jTcPH7d9U	8271	11710	11710	1618047000000	orphaned
16280	3NLTnXRMXMoJnBDp61RWCiVBvwwEDdxf7kz1mm6E618f8mQ2LKJa	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1523	1321	268	6301	12241	jx5Vmbqx8nJR2LJcHAiQXGZYJzPEjYrRLtfrkJoSfzLc86kJTbN	8274	11713	11713	1618047540000	orphaned
16287	3NKLLikmxp8ADfyGskYVTWNesmEb9iR4tquvMsZQL3dRuUUHPQZQ	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1534	1317	268	6301	12248	jxgPpxe6KGpw9wn51f17r58ueVvakmNWXnWavCnTZXURv2x6xmb	8276	11715	11715	1618047900000	orphaned
16291	3NLt1CYA6khFdADs3V8mfMgSxLZhfraF2pomWZZAwbjmmwe5FdPp	16290	3NKTeQ32sQfgXfFRKx1JWfAsJjbtVVDCSawQ4NR2px7opLxdCEz9	298	942	268	6301	12250	jxCS845NEim6qBnutxp6DpKZR4juyskAfAGyKKQQMaEwZNB6rCR	8277	11716	11716	1618048080000	canonical
16294	3NLGLex6VGoXTaKy28FfgsC2YMXxiKa1FmyxCUCVrFBB3q9SKM5m	16292	3NLdgf33vyUCr9WWRBLqkjzv4kEk6pr73uwEyeFZRm7xDHSuRVQw	1634	1331	268	6301	12253	jxNitNGa1Ytu2sjXrGutG3hmdjVYbLy86EeNtA66vCoiQCm8Fme	8279	11719	11719	1618048620000	canonical
16296	3NLkWCgcECPhSX2Hht7BTr8skAQFNt8epdbg7eZAxPLGXE1vSGAR	16294	3NLGLex6VGoXTaKy28FfgsC2YMXxiKa1FmyxCUCVrFBB3q9SKM5m	1440	1377	268	6301	12255	jxm52adJv1nW4MANnZms7Tj7bd7tww5X6KHdMnQC3mK4bqoQVAf	8280	11720	11720	1618048800000	canonical
16301	3NLiyg51gTkL5K7Nabpeh6KKFpAmXYX5joBpB8augRfzt31enZCZ	16300	3NKvG7xiUan6LwDyrTnFRJAVCdYADHFANrRfNYunjnFJzx1RPeS4	1601	1388	268	6301	12260	jxeuKS4Day9RxBXNxeiP2LEz6Yonb6MU5f5kED2xtT9Ddy4Pcij	8283	11723	11723	1618049340000	canonical
16333	3NKg4mFaWaokVjLFNDBAG57sXZgD8Ttw4NxaZ5GY7ofqWpYXtRai	16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	1406	1393	269	6301	12291	jxdrr4JSiQSUiUwbAaGns9RnnFUzK5X7ttGVwddJZcQzPt5YEeb	8302	11750	11750	1618054200000	orphaned
16335	3NL7BWhmoES8Jw9FvDQxjjHVoziP9vkf5afYJB7uUHFS7bzZho7T	16334	3NLv6V6HvCHPUqhzgYMVF89kgNuEtMHJQ4E3WJySitxdNp2d6EFe	1406	1393	269	6301	12293	jxiAtVcUx7AoVSQzfBJ782Xo5kneZ8hGc4rKuSJ6ijv5rqKxFzX	8303	11752	11752	1618054560000	canonical
16338	3NKLNnA7xxuo7UCVCPKvSzm6ELYR56NHcBThN4dLsDBSky3NPvRs	16337	3NLGpLsYMpLgaUtAnttGakZKPnzKjncetgasjzqcToamPxCjjdqn	44	1325	269	6301	12296	jw9WwH7o38VzAgX5rJjQnVeKPWtuMKM8LJCNfZBXCwxtwEgnjjd	8306	11755	11755	1618055100000	canonical
16346	3NLKyJY7LVuMTLR7VDdAv85gssERhQXQaCdLMRTU5dQ4225zSRzB	16344	3NKcktLt3TVQWw7wMEGpAqJPqY2VKAEoPp3a3bhVd3c5ELtATvfE	1542	1304	270	6301	12304	jxz6rkknGMrrYF1DDXY6fxRfnbxF2WDcrxtyJE1WyaXCBdAaMKd	8312	11761	11761	1618056180000	orphaned
16348	3NLWKcKKzfCK6t3YMk85cfg8bZRTz8J7mrHeTqUSAEMstguovwkk	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1536	1067	270	6301	12306	jwJrCMzR86CiEnBGPiJ7eSEQmUM7S3zUaMRq4PGRYV86si6njxr	8313	11762	11762	1618056360000	orphaned
16350	3NLdhbLwznc9chCqNZgZqj5gwhgZSRUafKSNjUvMsL1h6YPNtihJ	16347	3NK53Wma46BZvNt2C9vHbTqsBpA65uGUxF7peera7m5oaGxwSPoR	1670	1282	270	6301	12308	jwwor11HpETbtSt9MtZCpfujSYnLFWNTs6twa3jiePZwSehXPbU	8314	11763	11763	1618056540000	canonical
16354	3NLZ1Lg7ERh29GhoZCkRLuXLw8pxFEiF8Y9HYRyrfP6uHKCvnYbZ	16353	3NLFmrsXARCdrQEqPderF9fZcifZ7GbKpX9UEg3qumeF5znLTb2v	1440	1377	270	6301	12312	jwenrpUQTX3Zr81buimAXeuct5jU27CDqvR9WVbfjKv5iuaKDon	8317	11772	11772	1618058160000	canonical
16359	3NKQeQ7sUh7sfaNyMqQvJCyCPvjQ5sicc96gi2LuXbnxDpZKbHCB	16358	3NKFuZaqJyBJFeQuHqdPKWhSUezW1YsxqvzTZT2Ufa3uYUvWYVNm	1407	1395	270	6301	12317	jwhgu9BNtCfpEyMWRYrtjLwkFP8aesT87GDMh9xWeZhqHVbhXZh	8320	11776	11776	1618058880000	canonical
16364	3NLaQSeYN16pPUQvUxjUAuzE1aJwik1aEANAUQJn7Sem1NsL2yt9	16362	3NL46a5VzV7CHh644Hsp65m7PCy91Ld3JpLDS2rqa91XuDhoiDga	80	1147	270	6301	12321	jwZ178YrJjJyu9UgBAwFQLZaegXf5hbhMNSafMfxbqPPVUA7VWz	8323	11779	11779	1618059420000	canonical
16369	3NKT8KfoeBSoF19tVtXBq2ySAoKMvUktWyhwGNdVGeoSTM3mbV3K	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	448	939	271	6301	12324	jwCfzzVgXubRstPFqASvJFdkpcmnnCVb56MsYoqRw9zRkAV8xiL	8325	11782	11782	1618059960000	orphaned
16377	3NKWmcxnPGv92fpxiaabGbT5GTrhKBjrfqRdTvjBVHp5hXuWKJhP	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1560	1045	271	6301	12331	jy2ooxZ2dNZcq1BSL2q4ZqaRXPzvsGU76xxoveaSXniLmWhAe2W	8330	11789	11789	1618061220000	orphaned
16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	16380	3NLsmZoLNd5ZisrqjC9r4gDTxb2T514grwP9ipkwgh2NectyrFMH	1406	1393	271	6301	12335	jxA5SBmZmuWR266iQmVfk7vcJp4oennKSjCEX6FczoQ2QPGfEzZ	8332	11792	11792	1618061760000	canonical
16384	3NKnfRbVXHk523FGCh96m6GufY1xuUqp9hpRjLYLqQXQt7gobSqy	16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	171	1374	271	6301	12338	jxFtf3QM5vMjzced2XcrUK1UHi6Gg2pSfSPScyUBfyj1eqVPxV4	8333	11793	11793	1618061940000	orphaned
16386	3NLeRaaDoYjPPMTbNCPZAFEu1X9Bkak3ZYm1YxrJPWC6tuBzveDe	16385	3NK4snNDM451BNsvPUQgpmmuGfKnNBadwMJj4jKWvKBveufonQNY	80	1027	271	6301	12340	jwAxokUDEq44A7gnax57U1CifefPiLuYNZDJ5Fd247MZWiqbCuA	8335	11795	11795	1618062300000	canonical
16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	16388	3NLBBfSGNkx8BXRnhqHky8idxn3JB28knw6d9UFMBkLDHL2LeNCX	1536	1067	271	6301	12343	jwNtdYCZP5mRZ1We1f1pMEQhHxT1vQASTx4Btw5QFqx4JPYTwDS	8337	11800	11800	1618063200000	canonical
20910	3NLMpRZ6mDpHk5CHbSs8YRo7hy83AtqT8AgAGYY9fpFi8DDpnDvX	20909	3NKaD7QysyNYsvm8hJ95iYEXpAaDM48EdQGM3ZNUqwM6xEa1J12e	1406	1393	380	12463	13193	jy1R1cWgKMFgiqB9MagH2pG7zrdz4ARLUeRZnZBRzEdJkyLQKuy	10511	14805	14805	1618604100000	canonical
16288	3NLrNo2r6meH5pW3ATV7ALKfyXCP6DKrf2cTG68QNTznBii3ezjZ	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1483	1150	268	6301	12249	jw9yiGXnoyaYgZyWY7eADrVGCRc2BJRVq1q14oTRdRj6FuE2HzF	8276	11715	11715	1618047900000	orphaned
16292	3NLdgf33vyUCr9WWRBLqkjzv4kEk6pr73uwEyeFZRm7xDHSuRVQw	16291	3NLt1CYA6khFdADs3V8mfMgSxLZhfraF2pomWZZAwbjmmwe5FdPp	563	563	268	6301	12251	jwoB8a5y6YT77YHYU5VHoHcSuSqj6inNjaw5PbdquoKhamhQaUj	8278	11717	11717	1618048260000	canonical
16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	16296	3NLkWCgcECPhSX2Hht7BTr8skAQFNt8epdbg7eZAxPLGXE1vSGAR	1623	839	268	6301	12256	jxvGcV7kQHU84ZsnzQ6SfD6wpQQMipt3gzMy5BRMM52JhJQpGjs	8281	11721	11721	1618048980000	canonical
16299	3NLbi7kKkzJHdeEJZF1JETVgHnZVGS814eG8CBYDeYVvkLwydmsW	16297	3NL9QkZ8P8kptyZj6r4DnFAYuyBjPP7X9PvQaBgUxutVeHfkPw4h	1609	967	268	6301	12258	jxGXpDkxLaYoyXDApPzgndegE6Utr2QiMLExQQhqes3aLUV5jYR	8282	11722	11722	1618049160000	orphaned
16304	3NKvSLwqZqUQyamEkeTg2fwrxB9ySqK6avNYV6aJD3p6ESfaCN4s	16302	3NK5ungoE3Fz4rfNPF87fLKjxbpL6JG8rsYLc7Y6AGsXFcgoN6iT	1610	1314	268	6301	12263	jwec4wnVqKPjN5FQVq63Ayxh8zpFDvr4FQkdG7C1TeUrZAPCeXy	8285	11725	11725	1618049700000	orphaned
16308	3NK6vgPRdxDVUvEdjHw57bct2DPZKvLcHAtGgMiMCyjCdK5YHXBp	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	1460	625	268	6301	12267	jx9RJikVggr6wTSGAGCLhYPNvs96BJvV5RM95UseyWXnupjngAN	8287	11728	11728	1618050240000	orphaned
16313	3NLXrNDSQcfEPvuKT2KKpkd1QtMaJJwdeHsxiSymTAPx3qhD2ktF	16312	3NK4xSVTtdVeFXQ8WwhHuPNA5kUw98mkNkvcSJrWsZhmWMMHni58	1406	1393	269	6301	12272	jx6EPvib2aeZa4v7BJq56wG7KqNUV4v9hpyZ4nbkeG1pGuPxYTH	8288	11729	11729	1618050420000	canonical
16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	16314	3NK69mLomM8vk6QiixVb1RHCDvEiDRkrMZJwXQECwcCkFFnaPgT9	700	832	269	6301	12274	jxfVdsbvAntRQopi9yoHT81WCqqkMSeJqLAwtKnTLW38sGeYsZk	8290	11732	11732	1618050960000	canonical
16318	3NKcNDWPvkLZS6EyV8jsVdsCwpE4u6t1WYWRaxRWpu1oWgtMjzSh	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	42	995	269	6301	12277	jxtcVPrRqi7k9SvBQA4YYLzgV3fz7VtoEaVxxrAjQfPaod9ZeJE	8291	11733	11733	1618051140000	canonical
16316	3NKcr7BjVEp1QK841JT8KHdf7ugW6TZV9K7bwmGKebJeU6Dv7zCm	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	1448	1065	269	6301	12275	jwTE1qkeJvF61PfZ4g9wDhUA4RTAetyPE9GaYSet4LfRA6wmDQs	8291	11733	11733	1618051140000	orphaned
16319	3NLKfqccDoNoUG8B2jarsEP2bv23yLM3pCDMBxfPZSNF71ACLtmi	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	1448	1065	269	6301	12275	jwMEdJTwsz5RbpGD1MqYmUobM7TUhnVm2M2ScqR5ho1wnjcqQN9	8291	11733	11733	1618051140000	orphaned
16320	3NKEFTA6BGYt84fedi1n8SRuziS6ioHsVyDV8DaviqY6TCnvvRKu	16318	3NKcNDWPvkLZS6EyV8jsVdsCwpE4u6t1WYWRaxRWpu1oWgtMjzSh	1406	1393	269	6301	12278	jwRkujqAn8qr5Fm8ovUb981KQhfpih8WFDHBYihVzmbkjECe6Dn	8292	11734	11734	1618051320000	canonical
16322	3NKKZqrC1GBRuTtUPcxWLXroZbtFbiYrsTgtNWLmPzpzRye4GtCs	16321	3NLY1dC376kKPeLQKgqkTvYBA4hfM71e1YMpjrkNMZEzmBjLk1r5	1581	778	269	6301	12280	jxdVpXoDrxcq6va4bzQ8pBXy3cWFeYMiAu7FmwX3LPKaJ5E2V1S	8294	11736	11736	1618051680000	canonical
16323	3NKVii5rCjkbwFTcmrWumEYwxijT29UEqxYbsGbDDQgc3DER6kmH	16322	3NKKZqrC1GBRuTtUPcxWLXroZbtFbiYrsTgtNWLmPzpzRye4GtCs	1516	479	269	6301	12281	jxqoTGQojKfCWS91Luf6DJU4LLaNLGYoBJ5zYRgd3nd67G3HyW2	8295	11737	11737	1618051860000	canonical
16325	3NLSbg6C1iW8rumivDR4LGS4SnvDRvLzWhNkw42eWjWk8y7fTcen	16324	3NK3Z8bkRzdeKPWSkRiYbgegdrs5dRCoX5ZeBFZY4corHs1xbasz	1637	816	269	6301	12283	jx9MeRnQ2fJ6wcn4XKSfDdgyqNYzaVwW8MJYmGoaTkHjTRQp4Se	8297	11739	11739	1618052220000	canonical
16328	3NLZUB67D1eicV9X7sESioWNHGJQVxHvr2DgBwUoPUaj96SVBtcp	16327	3NLPbRWoyjrKCvYXogui4peZk1m6YCuwtzZHyZVuqh8Agbv6EVEQ	1529	1316	269	6301	12286	jxJE93h7u1wxkiEgL2sFb5Av6nyEfv6toneLHPq1P6Xss3pGRuf	8299	11742	11742	1618052760000	canonical
16329	3NLa9PNaNZauHX1HozLCP1DfY1N72wkiDMaaAwHELcD8EcroZME6	16328	3NLZUB67D1eicV9X7sESioWNHGJQVxHvr2DgBwUoPUaj96SVBtcp	1406	1393	269	6301	12287	jwGv7d9YC1q4fPHrLzG6mUwdX3yrcCnndGN6mV4o8MjdVW1fkaG	8300	11748	11748	1618053840000	canonical
16330	3NKBAAGpMcKGHnJhL6xSSAAv2NUJukuweXMn7yqrDHzPJjxipHMP	16328	3NLZUB67D1eicV9X7sESioWNHGJQVxHvr2DgBwUoPUaj96SVBtcp	1407	1395	269	6301	12288	jwowQy6WAVvTKcBhaTyXmSUkgx2ceEwmLGvCWGq7jpk6BjcX4YU	8300	11748	11748	1618053840000	orphaned
16334	3NLv6V6HvCHPUqhzgYMVF89kgNuEtMHJQ4E3WJySitxdNp2d6EFe	16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	1490	133	269	6301	12292	jxN3vV8tYwejoy8pmXBgDkPVYXyU2e21rP2myggzA3MBpMrPEpB	8302	11750	11750	1618054200000	canonical
16332	3NL55ikRfpFJgGMGXJFtdUyS3D27c7Licv4cgsSQ2iMZXAgW4Kgw	16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	596	1060	269	6301	12290	jxcxyZ3MhuaVYM5ni39rjTwtVtiEU3qAphr9Zqy2gxwEdQazcJU	8302	11750	11750	1618054200000	orphaned
16337	3NLGpLsYMpLgaUtAnttGakZKPnzKjncetgasjzqcToamPxCjjdqn	16336	3NKcW5E5k1JikCgG571rBv1ETP3Qe6CweyDF7aWFQDHTSwmeUE49	1649	1383	269	6301	12295	jwWnNi8cFuZwtTerTSuQXG4rKdpdnc5yP1gW8a1XWCsyfLWVAqS	8305	11754	11754	1618054920000	canonical
16339	3NKxDidZ2Ein8CiVjBsFQtp8HQmXRvNS5uZPKBp1fGyksjqbvJGx	16338	3NKLNnA7xxuo7UCVCPKvSzm6ELYR56NHcBThN4dLsDBSky3NPvRs	1406	1393	270	6301	12297	jxsP69KD6ci2EhGww8rVvdzSNjb23dpmMcghF1QohPsTKr98YFJ	8307	11756	11756	1618055280000	canonical
16342	3NLdUwcKjPMkUCcpksCLRCJ6uS5cHiE9uv7aLji49SbL2j2Ncka5	16341	3NLPMGE1KtssQZhxnteL32ifKmKGcfVBLiCuGp4EVCqLrgvN996Z	1406	1393	270	6301	12300	jwmmBgvLyP4QNe4QAUfB147jWmK8eyjQ9rcQ3BgDfjzZVEe1Rv4	8310	11759	11759	1618055820000	canonical
16344	3NKcktLt3TVQWw7wMEGpAqJPqY2VKAEoPp3a3bhVd3c5ELtATvfE	16342	3NLdUwcKjPMkUCcpksCLRCJ6uS5cHiE9uv7aLji49SbL2j2Ncka5	1671	1119	270	6301	12302	jx1CXuBeHNusHXkCGr4i1zUmMzVfnv8vRG6uQQVjkhETL45zVjV	8311	11760	11760	1618056000000	canonical
16352	3NLvCn5wCbAnT116xAtVZx1iCqym27mmjfCj4nYRLhLFWH26Yo9R	16350	3NLdhbLwznc9chCqNZgZqj5gwhgZSRUafKSNjUvMsL1h6YPNtihJ	1617	1162	270	6301	12310	jwrBY2LJHusghK7di9o3wZqH3cy6aXd91siZbidMfH3D43efYMh	8315	11767	11767	1618057260000	canonical
16363	3NKmuwptLy2HxwkX6Jvhm5mBa4933qums8aTzH2XHyUhFQB1ePUU	16360	3NL6RAy8ZTAxeFTpbsBwVofQqWCh1hYCcdyHfDooXjbDwhKg6ge6	1403	824	270	6301	12320	jxNMNEqWS7LnUfUuMGaZxbMoS53DVr6RamLgGHSXViEixm6GjZS	8322	11778	11778	1618059240000	orphaned
16365	3NLf9rfW7kCdhr8PXfyrJYY7GZz385qPsvNvm6mfWg2djADR9LHP	16362	3NL46a5VzV7CHh644Hsp65m7PCy91Ld3JpLDS2rqa91XuDhoiDga	1403	824	270	6301	12322	jwTdfjsmJTSVuuVu9cU8Dg5PjSjvoB4CXuGjAf3j3dQVpiirshM	8323	11780	11780	1618059600000	orphaned
16370	3NKZKBqmH4eXYedKzkgZbMvDaLALrqA2hKPLqsuTTZXHfyqpdxQL	16368	3NLKsmk7fZ5mhYiqAsmLowkTxF1TvQdT5Li3UDWiktQbb8BsLfGg	1675	1342	271	6301	12325	jxnUB5uBcCMvd5Hx7eA6dmU7RLJ7kVe59yXscqURGCb4WHen7GN	8326	11783	11783	1618060140000	canonical
16372	3NKck8WfyKCuTcxGESr46ikEhooxiMbMHei9UKCN5HbzM1EynGy8	16370	3NKZKBqmH4eXYedKzkgZbMvDaLALrqA2hKPLqsuTTZXHfyqpdxQL	1619	1029	271	6301	12326	jwE5oLhXYWuTnT8WMj5eQWZgr7W5Mm9LUbNKLt5YU8ZZBBhnUPz	8327	11784	11784	1618060320000	canonical
21475	3NKhMQhPgGYNo1ingBomBHSvBh5YyLjjYrLaocdTnWVzjnLmUVnL	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	1407	1395	380	12463	13689	jwsyCJPJQ5iTv1atAPnQeoSKsTL5B1mVLprooXPtc7oeY9AkzN3	10513	15172	15172	1618670265253	orphaned
16314	3NK69mLomM8vk6QiixVb1RHCDvEiDRkrMZJwXQECwcCkFFnaPgT9	16313	3NLXrNDSQcfEPvuKT2KKpkd1QtMaJJwdeHsxiSymTAPx3qhD2ktF	1477	1350	269	6301	12273	jwoMY1WpLMZZVxn71sfvqRmfzNs4qpB6VAKLiur8XDgRLNgGydC	8289	11730	11730	1618050600000	canonical
16317	3NKadT9KXmVBK3o5TRmjLYLR8sfJdkDCQQMdFfewyV8qsu9W1BuE	16315	3NKTkS25TBuY3yizp7jfEmXGJeLpKn1jXgKe8PtYaJtjsdQmq8QU	1457	1391	269	6301	12276	jwWouobGsVGT6gi8YHgfMztKbXciboE3M2un4skycfKUJRkpSQX	8291	11733	11733	1618051140000	orphaned
16324	3NK3Z8bkRzdeKPWSkRiYbgegdrs5dRCoX5ZeBFZY4corHs1xbasz	16323	3NKVii5rCjkbwFTcmrWumEYwxijT29UEqxYbsGbDDQgc3DER6kmH	1637	816	269	6301	12282	jxduRZLK82bo5MC8BTVap1Xf2U3iycF7NYHDyksbxnmS2b9HHzG	8296	11738	11738	1618052040000	canonical
16327	3NLPbRWoyjrKCvYXogui4peZk1m6YCuwtzZHyZVuqh8Agbv6EVEQ	16325	3NLSbg6C1iW8rumivDR4LGS4SnvDRvLzWhNkw42eWjWk8y7fTcen	1559	1353	269	6301	12285	jwXxDuPB4c2w4RtjwLqKmpLcun2hMB7hH4ANuzcRW5WpJ1VBEza	8298	11740	11740	1618052400000	canonical
16331	3NKsGEhAmKTemcNfkKK1ngJDY1yvFdTgAnWD6pH7peS98hf9qPxY	16329	3NLa9PNaNZauHX1HozLCP1DfY1N72wkiDMaaAwHELcD8EcroZME6	1406	1393	269	6301	12289	jx6GCNW3g27PJp5RcJvmH9QatUzeH981bTwjFsZrsEbQZ4dzKpR	8301	11749	11749	1618054020000	canonical
16336	3NKcW5E5k1JikCgG571rBv1ETP3Qe6CweyDF7aWFQDHTSwmeUE49	16335	3NL7BWhmoES8Jw9FvDQxjjHVoziP9vkf5afYJB7uUHFS7bzZho7T	1508	1387	269	6301	12294	jwZNroX6zNg1h1s7QvaraPUbp3UxmRp7yUmeu6pkkN3Zm4eLgYf	8304	11753	11753	1618054740000	canonical
16340	3NLpVkYE42tpgS3NESp1Htp5FAxZzgLkPgBW9YuA5XUx5fzcrWq4	16339	3NKxDidZ2Ein8CiVjBsFQtp8HQmXRvNS5uZPKBp1fGyksjqbvJGx	1578	1296	270	6301	12298	jxXbJGXzCdHfNKJB5LNevYFWBd9ibuiiRYv7gf2sdt2YD5gdiji	8308	11757	11757	1618055460000	canonical
16341	3NLPMGE1KtssQZhxnteL32ifKmKGcfVBLiCuGp4EVCqLrgvN996Z	16340	3NLpVkYE42tpgS3NESp1Htp5FAxZzgLkPgBW9YuA5XUx5fzcrWq4	1560	1045	270	6301	12299	jwQqJRhoUt271qmDFVh7SzEHaavhasmBRtGEgTxkf4NW7j27P8R	8309	11758	11758	1618055640000	canonical
16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	16344	3NKcktLt3TVQWw7wMEGpAqJPqY2VKAEoPp3a3bhVd3c5ELtATvfE	1406	1393	270	6301	12303	jxofRDvLkH9T49T8U5P54E6eEbFYWhMRsFMiXcXPbYpyLTVEk65	8312	11761	11761	1618056180000	canonical
16347	3NK53Wma46BZvNt2C9vHbTqsBpA65uGUxF7peera7m5oaGxwSPoR	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1529	1316	270	6301	12305	jwF88LFudAeRTzuWG3b8Y9b7CyTivoqszSA92iKzg4RtYRXEsUp	8313	11762	11762	1618056360000	canonical
16349	3NK5i3Pg6w7qJJNfN32VL5iyRLxWjMDLr9mXaCYZi2QaRTmqQ9wA	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1650	1129	270	6301	12307	jx798SWSi6RGBHt3hrDE5BZnK9yTTshWTjmnFwrVRzmq3Htp46N	8313	11762	11762	1618056360000	orphaned
16351	3NKsgwuTpnCkofhtP51ruVVg2tKVFc7zgUVufMQLvDqFVjbNHv7K	16347	3NK53Wma46BZvNt2C9vHbTqsBpA65uGUxF7peera7m5oaGxwSPoR	152	1330	270	6301	12309	jwP2YXkgEo6pNqX7fonCKsBaxGJe19GKS97oq4iaRyqYkTrtAvy	8314	11763	11763	1618056540000	orphaned
16353	3NLFmrsXARCdrQEqPderF9fZcifZ7GbKpX9UEg3qumeF5znLTb2v	16352	3NLvCn5wCbAnT116xAtVZx1iCqym27mmjfCj4nYRLhLFWH26Yo9R	563	1359	270	6301	12311	jxeFvPpBVWSXyCnA2n1ZYBbn3k7qvwE1dGWqovyz9dAwcfH4zvm	8316	11770	11770	1618057800000	canonical
16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	16354	3NLZ1Lg7ERh29GhoZCkRLuXLw8pxFEiF8Y9HYRyrfP6uHKCvnYbZ	1406	1393	270	6301	12313	jwipt29zBLPmVDFzndNCTvJ2xrYpZi5jrnbfMT9B87Yc1PupQL8	8318	11773	11773	1618058340000	canonical
16358	3NKFuZaqJyBJFeQuHqdPKWhSUezW1YsxqvzTZT2Ufa3uYUvWYVNm	16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	1403	824	270	6301	12316	jxF5q6NpTwt7tjBbXhwvkVVWa3Rn2yDHN86VaX78g21XhGXzujy	8319	11774	11774	1618058520000	canonical
16356	3NLHzKe9KcU8JzSQCXzs28JYtYUHbsJ5ht4NcVwPaFEPjryMdTa1	16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	80	1273	270	6301	12314	jwHCsi81eAaQN4UMHK4qF1LVYPvnhgreXHjAoDpw35XEk3YmMyV	8319	11774	11774	1618058520000	orphaned
16361	3NK6FAztUEAHGZPT59MQ7eYkbdSzNj4RX1qhSvXSscKFUnk3nQsm	16359	3NKQeQ7sUh7sfaNyMqQvJCyCPvjQ5sicc96gi2LuXbnxDpZKbHCB	1511	903	270	6301	12318	jx2NQiuScmVvBjQLncibVve3SNZvFwhL5XGuzDmYcvWTa5MwrhL	8321	11777	11777	1618059060000	canonical
16360	3NL6RAy8ZTAxeFTpbsBwVofQqWCh1hYCcdyHfDooXjbDwhKg6ge6	16359	3NKQeQ7sUh7sfaNyMqQvJCyCPvjQ5sicc96gi2LuXbnxDpZKbHCB	1511	903	270	6301	12318	jxBLvDTGG9LPjuEBYeAyWbp8NTayhhsFWc9tSPci2ZxRMrEPxoy	8321	11777	11777	1618059060000	orphaned
16362	3NL46a5VzV7CHh644Hsp65m7PCy91Ld3JpLDS2rqa91XuDhoiDga	16361	3NK6FAztUEAHGZPT59MQ7eYkbdSzNj4RX1qhSvXSscKFUnk3nQsm	1581	778	270	6301	12319	jx1bHhUyA9LKW8Zg4x7mQ1TGq1k9Pn12H5Zg61qnh3hVsagy6XQ	8322	11778	11778	1618059240000	canonical
16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	16364	3NLaQSeYN16pPUQvUxjUAuzE1aJwik1aEANAUQJn7Sem1NsL2yt9	1599	1041	270	6301	12323	jxMU1o2wiKpMxF9WQ8SbegCq1XvHCvChXAY2imQR3tEseccJhrK	8324	11781	11781	1618059780000	canonical
16368	3NLKsmk7fZ5mhYiqAsmLowkTxF1TvQdT5Li3UDWiktQbb8BsLfGg	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	448	939	271	6301	12324	jwCfzzVgXubRstPFqASvJFdkpcmnnCVb56MsYoqRw9zRkAV8xiL	8325	11782	11782	1618059960000	canonical
16367	3NLA8scY7cE8Y2yNbeXA65CXAnNLeYnzj7pinEKmeS5jKkHNDupG	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	448	939	271	6301	12324	jwCfzzVgXubRstPFqASvJFdkpcmnnCVb56MsYoqRw9zRkAV8xiL	8325	11782	11782	1618059960000	orphaned
16371	3NKHg3tSoaLpZtK5KyP9PMveZXhvWQw2KD9QCxgQeEF9bkRVzWAS	16368	3NLKsmk7fZ5mhYiqAsmLowkTxF1TvQdT5Li3UDWiktQbb8BsLfGg	1675	1342	271	6301	12325	jy1MX8r3mbaCTnhkiKCp1NvxC4gh5zFGEGTA7ud8NB195MTBdXA	8326	11783	11783	1618060140000	orphaned
16373	3NKLEJj5erVTbe1DWm4iD7jqJfy6CaqhSAFVwet35DtB7urYE9Ty	16372	3NKck8WfyKCuTcxGESr46ikEhooxiMbMHei9UKCN5HbzM1EynGy8	1419	814	271	6301	12327	jwuuBMtfmdnw8y6nj4U7oK58fm5svEGcZQy2oEFLsShmUbW9Jga	8328	11786	11786	1618060680000	canonical
16376	3NLjj2PUZpSzXRhXGUsRedHQ5rob5PAXb8Xbr7pHsGEZ8nJXjPgo	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1599	921	271	6301	12330	jxbdpAxxPr5ypqBBxp5kgE1KFAMKbyj4hzfkDFAsKTBKdx6VU5u	8330	11789	11789	1618061220000	canonical
16379	3NLZ9gfDUteBzshVhGFaHQ8wmQoXrAUcmASSs6mSAD544Rwt367K	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1633	1390	271	6301	12333	jxmWRTyfYGW6onMxsAHc2nnTga3BhV4GBbEZGXtBQ4eia6wAnht	8330	11789	11789	1618061220000	orphaned
16382	3NLfnc8WtPrPuxeaUj9StHvJsQGxW6yXvWKHGsMNxD5eo9VGyLwN	16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	596	1060	271	6301	12336	jxemBCpPrsMYoB3A9zbZeifxLsCZnFA3skuD6P3UxZc9uduT7BQ	8333	11793	11793	1618061940000	orphaned
16385	3NK4snNDM451BNsvPUQgpmmuGfKnNBadwMJj4jKWvKBveufonQNY	16383	3NKpC5B8f9wqoqomgk8yEwmk964urwCKskQ75yH85kYRG9ZSHZCj	1668	1370	271	6301	12339	jx5NJdjUwLdU3n3mBEhPYrxtdM8TJ2kC9DnzZp2ERCsNXxiuCaY	8334	11794	11794	1618062120000	canonical
16388	3NLBBfSGNkx8BXRnhqHky8idxn3JB28knw6d9UFMBkLDHL2LeNCX	16386	3NLeRaaDoYjPPMTbNCPZAFEu1X9Bkak3ZYm1YxrJPWC6tuBzveDe	1637	816	271	6301	12342	jwRsJyYzytvvANEAZAkXKLkwqcYH7MqnpgjaHmR9suSoTGan7sK	8336	11797	11797	1618062660000	canonical
21310	3NKWjwFVZXj8GB1zRGeNGVCj4dAVHmPQyCkeFwH7FRHfzc8Kpj2s	20918	3NL3cH9jR7XiLm4rbs25897un3UPCXLg9M4v6d2b7aJfCQVQTzWy	1506	1247	380	12463	13549	jxg6MDmAQPUa8T5cvxZznxTHnDz5yq56W87QbfTCdiUsrJwHXzx	10516	15064	15064	1618650720000	orphaned
22277	3NLRyGuvH5fgPnD7rZofJ8suczt6tra5SFxj3xuwEwMs6th5n2aT	22275	3NKuF61ogpML3ioTrG9oUzsSSJ3QcqVuhTEs2wPkJzByBfo2eSQx	1461	1271	411	12463	14399	jwSwgiP9hjgeiH5xJ5mfHsVFkHQnWbsRwwWnW5Nw6jpY1x1vPy4	11151	15698	15698	1618764840000	orphaned
16378	3NLENGH2CcH8uW6nAbadGSG6RKNc2hF8dHzca9N2oBUWEw2JCffM	16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	1631	794	271	6301	12332	jwxsoS1TuLQAo3hamxERvivNQqddM7KYJrg9cKxXwKSVxAzqRQB	8330	11789	11789	1618061220000	orphaned
16380	3NLsmZoLNd5ZisrqjC9r4gDTxb2T514grwP9ipkwgh2NectyrFMH	16376	3NLjj2PUZpSzXRhXGUsRedHQ5rob5PAXb8Xbr7pHsGEZ8nJXjPgo	1407	1395	271	6301	12334	jxhj7nLpJM2cTyCJqLyvtGapa59v1t2hc5HC1TAPGECtRFtqdWZ	8331	11791	11791	1618061580000	canonical
16383	3NKpC5B8f9wqoqomgk8yEwmk964urwCKskQ75yH85kYRG9ZSHZCj	16381	3NKL42icxFZ2Sq7UQKTEFoW3hpx4Sfs4g3UNZzuBR2yPTdgy6auq	1406	1393	271	6301	12337	jwc7Hzy3Gt14JKn5887Uw9h6G5NXbKqaLBcmEzbKR3mJ1dJdTht	8333	11793	11793	1618061940000	canonical
16393	3NK4MoPRUHCJk3kX3ugmhGzynTABhDJU9HV9mFMCZNwND5v8GKmE	16383	3NKpC5B8f9wqoqomgk8yEwmk964urwCKskQ75yH85kYRG9ZSHZCj	576	1355	271	6301	12347	jxQVc4Bz2ZZdMegfTqcigcQGSNWMyUhF8F5RvhhNAugxeMcZBzJ	8334	11804	11804	1618063920000	orphaned
16387	3NKZBxcdBV1soZW7jbTzQaScp7RAd1T4RYMpVv6vh5ctmSaN7Whk	16385	3NK4snNDM451BNsvPUQgpmmuGfKnNBadwMJj4jKWvKBveufonQNY	1549	1362	271	6301	12341	jwsVwfcuvJwbWtcoe2jN78YTHmpVodUnJU5T25Byf37gC5QE2C7	8335	11795	11795	1618062300000	orphaned
16391	3NKCSyyrXKRZaXfMzbMvcuoKz4Ak1hCVq66xazCyWfq4ySx8nmMA	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	1657	978	271	6301	12345	jxe3kQdqaRpyhTqt7mcmsDowQ4B3xzTdvWn3S7MdrQUt8eq2zZ5	8338	11801	11801	1618063380000	canonical
16390	3NLcPbqm1YSpo6hBS5PArCg3kE1GatbGbBuEinEmtwVpFNRTPX9n	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	80	1273	271	6301	12344	jx4z4wK7oQemywKCkMJohpNpKV7Kvwk4Ey4QYyDT26c8qVxu5dP	8338	11801	11801	1618063380000	orphaned
16395	3NLWo7jyoEk4Q3Dbvdm9PK5S8VS3f97ueSybkysKDyhudRCKbEzr	16391	3NKCSyyrXKRZaXfMzbMvcuoKz4Ak1hCVq66xazCyWfq4ySx8nmMA	1611	1095	271	6301	12349	jx9DbuUKmmE31AfMnreqhwfgSh4zMgCQDwE5zUoRHKHRR1dCnUN	8339	11804	11804	1618063920000	orphaned
16397	3NLHd7Qhe1TqwKkFW8MSu7SwvaBZ2N7Lipc5jBuzJBvsSTDhTuNv	16394	3NLsE1LubotocxBuf32rurjLsuwUYGuNQ531joQTugMqfYMqPtAe	1581	778	271	6301	12351	jwUdqnrBZhVUuFwNrfr5F7RYRXMrSjBPtsd1TFtN4QP5S8QUuHo	8340	11805	11805	1618064100000	canonical
16398	3NK44xVvs1NawEjiFTttXpNhVxL3tTzQ2jZ39F9hLgjVA9mi7KYm	16397	3NLHd7Qhe1TqwKkFW8MSu7SwvaBZ2N7Lipc5jBuzJBvsSTDhTuNv	1447	1345	271	6301	12352	jxuar7RTN4ZYq5PTEt13MVCjMQ56nujq74BfF8KFU6d8qFndznL	8341	11807	11807	1618064460000	canonical
16400	3NLRErCgGKxot26DyenWvQJS9F1UEf5LEgYrkGYwRcxJRADY9yZk	16398	3NK44xVvs1NawEjiFTttXpNhVxL3tTzQ2jZ39F9hLgjVA9mi7KYm	1564	1338	271	6301	12354	jwop4wXPjakEhuBirSW7PbWVdB9xSgsMfzUrYsT951usoaMPGmU	8342	11808	11808	1618064640000	canonical
16402	3NLY6N5DaMbnqCyf5QpgZzpeFkSxw3Q6JCp6TgaYB4PEnv2vaMfV	16400	3NLRErCgGKxot26DyenWvQJS9F1UEf5LEgYrkGYwRcxJRADY9yZk	58	1281	271	6301	12355	jy1JM37ZtcmEBbJrinCzSw2tc1yYPqH8gfgb11G4Qt1WCxQByxW	8343	11810	11810	1618065000000	canonical
16403	3NKbok9CphKpetLcXVKBLcdvwXt2LLnyQcoMwLkPN8ZBFmEDm7n8	16402	3NLY6N5DaMbnqCyf5QpgZzpeFkSxw3Q6JCp6TgaYB4PEnv2vaMfV	1407	1395	272	6301	12356	jwnAmng1nsmz6sUQzQXakhHHQchqYrgEYXEkixTnKNRijoDYYaS	8344	11811	11811	1618065180000	canonical
16405	3NKB9MmT3xswMc7N3CnYLoa4UqCe5N1FY1U4UmFRHrG94twZiR9j	16403	3NKbok9CphKpetLcXVKBLcdvwXt2LLnyQcoMwLkPN8ZBFmEDm7n8	1483	252	272	6301	12358	jwnxehatfrKstu9M76SCZF1K1nUnDApv1PcbDECSidrL9ekEZgx	8345	11812	11812	1618065360000	canonical
16407	3NKgyMLTXuJysFEJjsYMo3N2YfTyoCXooDLeUinY6jWKs5hidfXL	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1523	1195	272	6301	12360	jxfjwMTNyRT3mzs2LhPzPrS81LwURjeKvE4gLNs6LYs8oEbaBGe	8347	11814	11814	1618065720000	orphaned
16412	3NKEGgBavXMT13KvmRTJoaW4tf22YdVw7rXt21hnG7smsykETHtY	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1407	1395	272	6301	12363	jxUxs1pJk3bczwgH5qtrxZkDbmsgBsWBFCKhqfJE8w4SJTu6jj1	8349	11817	11817	1618066260000	orphaned
16414	3NKdqzgMrWfpw3XaFVWWodSYbNqbXaM49x1yt1pfBbnFbCckYX8Q	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1419	814	272	6301	12365	jxbAe4ysS3WrHmz8Yv33AhiJCb3s55zWifGJTA95bf5r1Du7qWa	8349	11817	11817	1618066260000	orphaned
16413	3NLudT5vCJJmPcefjthebm7rtfEXZmLKKzQhgherJUE5odUU2ksB	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1406	1393	272	6301	12364	jx4SA7VGcRXYwgW3tdM9PdPTy6YMYtGhPh1LhP5T4hfW2V659S5	8349	11817	11817	1618066260000	orphaned
16417	3NKruSpF17XB8Uzvup5jAuX6qfxj17dTKabCYRm3bWzRBY9Cvgjg	16415	3NKKDtae4pCcs1VEkLA16LDsBjCZx6kv8MjUK1utA1UrTeDeBDqh	1483	690	272	6301	12367	jwYjbM27giXPxeVBLMjUTJpfYTWdwfSws3QEWewdFPjfCaBCU8N	8350	11818	11818	1618066440000	canonical
16416	3NKS8BzMAY4vdynP9rmwdNXJAVCijiFj8FnmY8A3KvcTMfinL4wp	16415	3NKKDtae4pCcs1VEkLA16LDsBjCZx6kv8MjUK1utA1UrTeDeBDqh	1483	690	272	6301	12367	jwocPacXSxTfcKAi9PZLDa7uempPp3GmrthqtS1xUJkNtJThGXW	8350	11818	11818	1618066440000	orphaned
16418	3NLm7rFFMH3tP5fD1KvxPaNVdS3h5mf1mWRP7QbND8s8xpopgdni	16414	3NKdqzgMrWfpw3XaFVWWodSYbNqbXaM49x1yt1pfBbnFbCckYX8Q	1477	1350	272	6301	12368	jxAiLjthTE5wAFChv7HKB915as51CfJBLdmqd1rpANb5ZLU73Zi	8350	11818	11818	1618066440000	orphaned
16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	16417	3NKruSpF17XB8Uzvup5jAuX6qfxj17dTKabCYRm3bWzRBY9Cvgjg	1407	1395	272	6301	12369	jxsLucd4npMMtQhSpJg6uxMLxCqprqBhdeZsHJmzA8GxHLPgozT	8351	11819	11819	1618066620000	canonical
16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	1601	1262	272	6301	12371	jy3748icKxAwpzqJavrEyv9gPpfvfgAZnqJvfGxNZFPnwTcamL4	8352	11820	11820	1618066800000	canonical
16423	3NL6v5Rq74aebcVBjiZuKzcCMjK4TXsgNQsbQvBLXjht23X9btzH	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1439	482	272	6301	12373	jx9ecRQHfDkh6AirwEgDjdzQTGUkPf7UEonzTR7CZkRc2EAjHZi	8353	11822	11822	1618067160000	orphaned
16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	16424	3NKnRxfPjgqFcmBuedkuHHwqaE5XWLdHnp36Z5DTDU1LLw9hxePy	1406	1393	272	6301	12376	jx2hr6fFTyc8RTgaXEuXwoxrhNF3PnTKqwko8WSDm8ExWDKk882	8354	11823	11823	1618067340000	canonical
16430	3NLGY9yKqusMEjYj7Q7TMkEHvScmnW1Bqg6ecMkxWngTtbbXkWth	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1407	1395	272	6301	12380	jxinNjxyoRbHmQDhEDHcZjFMinMTnvhByTaiQZoepYtz7DQRzkB	8355	11824	11824	1618067520000	orphaned
16435	3NLov1TwHwRJWjkS22yzzFgsiqyXDQsCvaAGrqwBVmrYJBN6HUd2	16434	3NKp621zud1R7xhAVov9gjviS57nMNPW2R9d4vvkLqzBt5M53MXQ	1588	1146	272	6301	12385	jwBeNRepDrkEpiM4xnz59HeLontLDFMoq9KuUFHSWYCc1LqmAUn	8358	11830	11830	1618068600000	orphaned
16442	3NLrzvHeMHsi1qJjyo4XtFmfNMFD2zYAkyTQthuYwLMzGBtMerPb	16440	3NL5GA4PD3psp2q4UY8tzvxYGHDuHqv97gnAcnUf9o435NNZRVAq	1637	816	272	6301	12390	jwSzvTMrfaX2FJER8qUMN3iG9fZBUtaNwEMDk2neXuHFFDa7M2k	8361	11833	11833	1618069140000	canonical
21515	3NKwnxrzMhHJPBYBatRGD6zrJETM3PqN9QGU4UNKEg5tQh9gCVDr	20937	3NLmJTBEypjEV9DsKTipM4MkWuoDhBYjAfdn6W7qiVjuJ21hmLHQ	1440	1011	381	12463	13726	jxyYpQCD3FFVGCw8GdkqfamK9LxcYzj4ebvknTCA4TyfBYjztbN	10527	15204	15204	1618675928455	orphaned
16394	3NLsE1LubotocxBuf32rurjLsuwUYGuNQ531joQTugMqfYMqPtAe	16391	3NKCSyyrXKRZaXfMzbMvcuoKz4Ak1hCVq66xazCyWfq4ySx8nmMA	576	1355	271	6301	12348	jwg2KtVQVemBh5P7C1pWDqje1HeEuHxB1CRvg4Da6MPrwhUhBp2	8339	11804	11804	1618063920000	canonical
16399	3NKijJMmqiWQUhzZ2sWDLS386wp7ACpeNGDv7kNkEXXDfoukkx4W	16398	3NK44xVvs1NawEjiFTttXpNhVxL3tTzQ2jZ39F9hLgjVA9mi7KYm	1588	1026	271	6301	12353	jxRxE1VJvJr7scpReFUJVFLPniFrPARyvJQLz4oXXCP3jE7kacJ	8342	11808	11808	1618064640000	orphaned
16409	3NK4SaPQ3g2S7Bhrzu8SqEcgayDHd76axBcPunxMGAL4etfgJFFk	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1523	1195	272	6301	12360	jxVUv4ypX5RpBdoc4mmcnM6k3t5EfKd3Q9FSLC1HERF38wpBbJK	8347	11814	11814	1618065720000	canonical
16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	16409	3NK4SaPQ3g2S7Bhrzu8SqEcgayDHd76axBcPunxMGAL4etfgJFFk	1597	274	272	6301	12362	jw9epRMYQ3yE4bt5YAb7MMvC56HRecgLEwYnpGeeyPMmYgj3M1c	8348	11816	11816	1618066080000	canonical
16420	3NL8LBkNkVAgWYJUnhQ3uE2njzVoER5s41WD3pRWbNGoJKxbntJw	16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	1406	1393	272	6301	12370	jxxWQ9SXria7fpTtwWh5NSLiptW4b2HLwiSLrn6Ves574GZmNun	8352	11820	11820	1618066800000	orphaned
16425	3NKJtUNWjRnCU63cjn3SfxhZ9Tf6vfcFhcPAvRok8dz2h8FQZTis	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1637	816	272	6301	12375	jxmJGnSXgnJVSQdgbTy5oJMpvsnNWQUwNiB5TVjkXhH1xdHqmYN	8353	11822	11822	1618067160000	orphaned
16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1406	1393	272	6301	12379	jw8fNCVHZKeSfVbwgDbDZNrCepfiomTZ2bqCQWsqMABMjHTTzvM	8355	11824	11824	1618067520000	canonical
16428	3NLjhuix2EMqY9m1Ba9e8XrabvPSoFkdLVSLWmNcYx647FPibaGa	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1405	873	272	6301	12378	jxAkKzWr34hXhUBs4Cyy9wrSyXGrVbogfjwbfLRhaRH1u4F3zM3	8355	11824	11824	1618067520000	orphaned
16432	3NL6cueoUf2wdf6e8b8wGKqorGd1UwkpiTAEjrMjyKa9aibBMHvG	16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	1406	1393	272	6301	12382	jxeZJDPXeXZs2AaaYVNmrcXHfBN1bsfh3hZmakv4UukaNvcbfKe	8356	11826	11826	1618067880000	orphaned
16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	16436	3NK7bvoBdMKRFeivw1ZjsXbNscpfE6MKDUwsAHmNsY4Mu4F52TXS	1542	1304	272	6301	12387	jxPmqW8KRxkq7iSdvbnLiU6ocExm2zU2NaTn8RFU4f1SGLG11ay	8359	11831	11831	1618068780000	canonical
16437	3NL8iwjyL6h7jm61uqsfBRAWyWDiv7ENCAnWx4yBPcA2gievqvjw	16436	3NK7bvoBdMKRFeivw1ZjsXbNscpfE6MKDUwsAHmNsY4Mu4F52TXS	1542	1304	272	6301	12387	jxqoNUwmg34XrowfHLiav82PwdTQLj6U5wchL6pTf6iceSVpHjH	8359	11831	11831	1618068780000	orphaned
16440	3NL5GA4PD3psp2q4UY8tzvxYGHDuHqv97gnAcnUf9o435NNZRVAq	16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	1633	1264	272	6301	12389	jx91SdTEJ88NbtgEzGf1RPDcQZDjv25yPuULpresCNBjWx4Xnet	8360	11832	11832	1618068960000	canonical
16439	3NKiisTTxQuKKTs6aiqtFduUehRt3cQ2wsjnek6ej7wegpgPKuAr	16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	1490	1028	272	6301	12388	jwzDQVVPeffaSSjnbzdVJkAQhLS1eYBDuQvCbBsoqZD6THRojou	8360	11832	11832	1618068960000	orphaned
16444	3NLnNXggMLQFkWmH13QJTmPfgoxcJ3RaAAxP6vXC3zUH1XVhVFZG	16443	3NLpL7gvamg9KdHpu2tPn4sg4whonbNmSqxXBg1hAECqY8njtysH	1406	1393	272	6301	12392	jxhnwVYPXwA3KpN4wX3wA3KuVkuwBJkBMzKLXtZ3JkZ28mPMiHD	8363	11835	11835	1618069500000	canonical
16446	3NLWNrV1EWDcUL38kfm8pEdTeCRP69XGfLZiNkUFZztVKJmb1K4k	16444	3NLnNXggMLQFkWmH13QJTmPfgoxcJ3RaAAxP6vXC3zUH1XVhVFZG	1647	1302	273	6301	12394	jxijUwN6tCvwo9U6Mjwqebo6Z2XtQgsRpsKm6dcCjws3JbRg6kP	8364	11838	11838	1618070040000	orphaned
16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	16445	3NKsg6kh7hfBefeLcSDSRfA75qiPr42m26PkYr13sMG8yZEnK5en	1397	828	273	6301	12395	jxSv4oXiLxGESMCkSNGFNu4cRMFmFUehR4ibFUmfvV9xCb6k3hh	8365	11839	11839	1618070220000	canonical
16449	3NLYdXTDx1eRrwUVZDCRBifKW5NYey3SnFmiSP6MZMnrVwtyDv9v	16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	1581	778	273	6301	12397	jxkwsWKkDnHAQMcyXjcGvnoBEEkRi5qpxp6D5MEBpdNy2yEFrSo	8366	11841	11841	1618070580000	orphaned
16451	3NKiViU4C4dyp6QNphYSHo8JCHMt23CPsSCeetJmxnWbpdyrPDWq	16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	1406	1393	273	6301	12399	jy2okcuRyj4f3EyHca8ea2ud8KyZ9G7jpCqJiYejqb6aJDN5hsD	8368	11844	11844	1618071120000	canonical
16457	3NLu3hUtSp617MWURR18bq3sktvYAeDurgg64xmYHu3XnjFpdPTd	16455	3NLDHC4Z7N5GUR6JvDLvFCtZ5bnyXFEjka9gfTQJJGcumTJ5ZZQ4	1542	1304	273	6301	12405	jx2XcCFKKf4dqkE49n4DKaBQ6aW5EjCqrp5opptJnXo31hYha7K	8370	11846	11846	1618071480000	orphaned
16460	3NKZCdZsLASba8gZV6sLG8RrREigsHxSUFKj2n45WrUAq7FtJ6jb	16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	1637	816	273	6301	12408	jxsb36aDV7MHTdni4dpVCbTFkKU7VAtUMh2v4nHciH2QHs2bN2N	8372	11850	11850	1618072200000	orphaned
16462	3NKahKGHYfpRhw8WTrYbqL4ezYWiFVLjGkT7GgyuJypWDgivcYfw	16459	3NKCz7X6rMXaPUYAr9ZTyPrmJ37UUzVFek2pcUujyrASnF8dZG5P	1403	823	273	6301	12410	jwac2pWxC8ejeD859cqkXudvFRL4vtXfVWxkqUB7w5T12wZ9rvA	8373	11851	11851	1618072380000	canonical
16461	3NKRD74aJkbcP4wqpvurpkm6rbag2TdyLnsCNwrXxVwGMnF2VuNb	16459	3NKCz7X6rMXaPUYAr9ZTyPrmJ37UUzVFek2pcUujyrASnF8dZG5P	1600	1126	273	6301	12409	jxn92Ys8VV9wmSWBxFCH32jRqDwj9U3nQESq4ZLBPoV2VVuubga	8373	11851	11851	1618072380000	orphaned
16463	3NLgQZpMYuV9SRZBjtjr2UhwZWH2gzBoDrjJeAsUR25PCpeR3Kqn	16462	3NKahKGHYfpRhw8WTrYbqL4ezYWiFVLjGkT7GgyuJypWDgivcYfw	532	1177	273	6301	12411	jwwivDWXugyhMK41eHUq6bujbGR5CcAxJBf5JH1LyzKzjLrvLzj	8374	11852	11852	1618072560000	canonical
16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	16468	3NLxZm9q3wcxWQXSB2Dc3QLQ6iMyYJs5TSHdYVLXtvdtYkv48gCr	1406	1393	273	6301	12416	jwXiBdhXjjPDdm1HEKmQqmd3Q82mVsLktYqz9p74jbZk6A2JU8b	8377	11855	11855	1618073100000	canonical
16479	3NKvgzVjthFXjFVzSCc67MAegXvx1HzpL1gpmCRmuhAjCUHbXKrS	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	1523	955	273	6301	12424	jwDttm7LzsEfHbjpMZi77QiQUmkUqD3tdgLnRcn73SMh3JkGLV9	8381	11859	11859	1618073820000	canonical
16485	3NKeUfLmFcS1tES8JfhrgdhLK6PLD3Xb5rkjVbZXmjdRrEtUsU3R	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1503	1031	274	6301	12428	jxwG8gxnfpRbFU1diuHFV4Nbw9ycmJth9oZ3kG26euRbVDpLniS	8384	11865	11865	1618074900000	orphaned
16491	3NKoTukgwFyZquYxMaCRNjJ1uCrBvSRBFEgBW4R4FkJv4ABNR7AR	16490	3NK9NRbFXFXyRiibSKhnAJuMkRMBrU9om1XCAaQ8Mp1h6u2GPGfW	1406	1393	274	6301	12433	jwuNsDFuAcwgb8ps4vDVv1YNKu9etmUofwCTr5L88SzJKoWCNFk	8387	11868	11868	1618075440000	canonical
16494	3NLYTrvGBNoRLAebegeDRvyr3yhJamEVFdbtxgPa5DSZ58RF2d5Y	16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	1589	1286	274	6301	12436	jweGfHQwXUKcU2GLSMJ8wungABmv87Y5tYdgusvfbCbASAvQHZT	8389	11871	11871	1618075980000	orphaned
16497	3NKVCCwWDYGuRTsLVZdGcvbuWQCmSitS4TPutgUGDzvEJ8GVjLhb	16496	3NLsBfAruM575veXPAdmiq1pjgPxauWjpcGqWqswQy4pihd828p9	43	1310	274	6301	12439	jwe4b24hkbi9r1Hxqq6jmhPDeEYYpPdyhDsvxbpvWsaYmDeUnu5	8391	11876	11876	1618076880000	canonical
20946	3NKCypok4j3uNXPDqcygLv7yNmRphXMLvfieDLhJW6PWreuTiQLq	20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	1594	1326	381	12463	13225	jxHqSbdE8i6nNdLzcWCYLXwCYzQMXPHpeuEjgfks4DSscB2f1aY	10534	14836	14836	1618609680000	canonical
16396	3NLxAWhetg7Ty8J1VwLCzE1cBBADUQpHE5bxwmdoPnNQq8WUsAdh	16394	3NLsE1LubotocxBuf32rurjLsuwUYGuNQ531joQTugMqfYMqPtAe	1407	1395	271	6301	12350	jwmZjPwk832RSxRssBtUhs4W3EEryfFyuvNGV6176TvCGF4vkrx	8340	11805	11805	1618064100000	orphaned
16401	3NLCcMTpcQwGLkagfra2maiu8Uc81zJNwDsAZDQyDtxDKc7byWcg	16400	3NLRErCgGKxot26DyenWvQJS9F1UEf5LEgYrkGYwRcxJRADY9yZk	58	1281	271	6301	12355	jy1JM37ZtcmEBbJrinCzSw2tc1yYPqH8gfgb11G4Qt1WCxQByxW	8343	11810	11810	1618065000000	orphaned
16404	3NKGLFkxz7ewL156vAekG6X4ANfJLyjK3VJAGvitZ6eYsV76SaAW	16402	3NLY6N5DaMbnqCyf5QpgZzpeFkSxw3Q6JCp6TgaYB4PEnv2vaMfV	1585	1120	272	6301	12357	jw8dNhUi7Wt68AWhtmbDQtkeSCbztJ24bECz4H52qrg4mTMohs8	8344	11811	11811	1618065180000	orphaned
16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	16405	3NKB9MmT3xswMc7N3CnYLoa4UqCe5N1FY1U4UmFRHrG94twZiR9j	1643	933	272	6301	12359	jwTLjMtN1YpvR6DqMprnGvZAbfHLNMKubUYUcsRw92ip7FN31jz	8346	11813	11813	1618065540000	canonical
16415	3NKKDtae4pCcs1VEkLA16LDsBjCZx6kv8MjUK1utA1UrTeDeBDqh	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1559	1107	272	6301	12366	jxzufYsKi8ZHaGQMwZNRfaR8xs6tvNe9vWiDSq9Z7NpUMiczqZz	8349	11817	11817	1618066260000	canonical
16422	3NLrxSWzyDQvW2T1tqYbzYDQvDPycCwMW3q2RnTBtyWQjkdDVq96	16419	3NLQcFmX6CnEpPcMvFbcRpxqUhg2cXFgVTnzzugSWrfmQtGfTpsH	1631	794	272	6301	12372	jxtzDKX9Sw3UX6hBynZJoAvcJD3GNPfdhKkU2KAnYYH5FtYcG3U	8352	11820	11820	1618066800000	orphaned
16424	3NKnRxfPjgqFcmBuedkuHHwqaE5XWLdHnp36Z5DTDU1LLw9hxePy	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1405	855	272	6301	12374	jxgsSijbjykGsfvvFNsHtLQtex7UrryTRMQE2qkdZHbX4x9yWAV	8353	11822	11822	1618067160000	canonical
16427	3NKLtMru2iwFbqFHp3aSbSdmmz627JD28zk37Hq7YKcMJx4qvnVG	16424	3NKnRxfPjgqFcmBuedkuHHwqaE5XWLdHnp36Z5DTDU1LLw9hxePy	1631	794	272	6301	12377	jwYwQQnGKGrzLchFi5LcpVdhmcNJqi4kYhxydPAKPyGbYnLyuS5	8354	11823	11823	1618067340000	orphaned
16434	3NKp621zud1R7xhAVov9gjviS57nMNPW2R9d4vvkLqzBt5M53MXQ	16433	3NLnkZrgNbdvXCRPnX4fTozx6WnakYhnJbHJrEeKdhGACDjRAbni	1534	1071	272	6301	12384	jxjvbDGARLxxTJRMTjbbutmorSTK1kfX99zXhNUfQkLi98nbWm5	8357	11829	11829	1618068420000	canonical
16436	3NK7bvoBdMKRFeivw1ZjsXbNscpfE6MKDUwsAHmNsY4Mu4F52TXS	16434	3NKp621zud1R7xhAVov9gjviS57nMNPW2R9d4vvkLqzBt5M53MXQ	1619	1275	272	6301	12386	jxS9YXRMeN9PeG25dwpviXyjuLFxBYqmeHEf6oZSeArrV3p9Edi	8358	11830	11830	1618068600000	canonical
16443	3NLpL7gvamg9KdHpu2tPn4sg4whonbNmSqxXBg1hAECqY8njtysH	16442	3NLrzvHeMHsi1qJjyo4XtFmfNMFD2zYAkyTQthuYwLMzGBtMerPb	1581	778	272	6301	12391	jwM62KwqA3E2RLcmQFKzBXc2uiQnNhMxaegkubaXh8JnfExk269	8362	11834	11834	1618069320000	canonical
16452	3NLLiMvsfXZ73eGT5iJ7be1YaM8m8y2phTT4wNgTC4or2yD4K1Uu	16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	1402	852	273	6301	12400	jxLaeiTwoiXLYGnEiz25oBwLFdNGoQwjSuX2oejDEbmMgPkgFhf	8368	11844	11844	1618071120000	orphaned
16456	3NKEkgTbJj9t7y3NULXhqfZfQGu3t41T8y5edyrRWc7Jp8CwP8jN	16455	3NLDHC4Z7N5GUR6JvDLvFCtZ5bnyXFEjka9gfTQJJGcumTJ5ZZQ4	1649	1257	273	6301	12404	jx3Hq4JN5CTqPxMqoH8fC68V6yCUgPCgVLkyqbY81iJbBwCe4b4	8370	11846	11846	1618071480000	canonical
16459	3NKCz7X6rMXaPUYAr9ZTyPrmJ37UUzVFek2pcUujyrASnF8dZG5P	16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	1613	983	273	6301	12407	jwFunR8oiNY1wJo6mhoLnbADvjx4TeAr9nFkrsLFRD2rbNvvsVR	8372	11850	11850	1618072200000	canonical
16469	3NL5qLcd4UMiiWTB9C6t1H1LoFGyR5g982jz6Stepbaf5CfZGpca	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1474	1083	273	6301	12414	jxPE7Xm4aGqq8jjzmADD4zt3hvU9BNfqdV16e9C1FAUnbRYvwWg	8376	11854	11854	1618072920000	orphaned
16473	3NKrczaf2hEVNbopmqrSYQaQ4UZ7iuChcvtCGvasrCGYz9SYNXjm	16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	1581	778	273	6301	12419	jxFGzdNEeVWEwiudgw6CQ96ypyneqxmbgXjLqcGeV6MYawtavsW	8378	11856	11856	1618073280000	orphaned
16478	3NK9AccikSkGjsTW29PxBBeR2gN8CkpUCJcm2QqTptNgV3SmAABq	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	1523	955	273	6301	12424	jxvXDz9TH3gbEYc2FeSycQv8gvo8jYMTGBJ2cA9dKRbdwUrBSXA	8381	11859	11859	1618073820000	orphaned
16481	3NKcpPtoU5bcf6UgnHqdkv8DFDyCeDqyorf5sZdn89CVTBHsJnYA	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	606	1049	273	6301	12425	jy1zdWSfiPrUUnCgotWuGDB39jBuo8Hx1qBtXgrWT6NMVLS2MfN	8381	11859	11859	1618073820000	orphaned
16482	3NKpTUGzPd9kS8sbUpcPdb2fRYombJP16rzvs5S8ckUGZEE3UzFs	16479	3NKvgzVjthFXjFVzSCc67MAegXvx1HzpL1gpmCRmuhAjCUHbXKrS	1515	287	273	6301	12426	jxyNBihtgzjGp5a7pSYqDtDMdERmTnNv5XXiCRAapVR8VNQuEGC	8382	11860	11860	1618074000000	canonical
16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	16482	3NKpTUGzPd9kS8sbUpcPdb2fRYombJP16rzvs5S8ckUGZEE3UzFs	1406	1393	273	6301	12427	jxR4g732bDw6xmHGndRqP3pGW2AyB6RzDKXe5ETfPgoEAmmAbLn	8383	11864	11864	1618074720000	canonical
16490	3NK9NRbFXFXyRiibSKhnAJuMkRMBrU9om1XCAaQ8Mp1h6u2GPGfW	16489	3NKF33YBCZbrsfPu94cxrGwQhmhC5EmtWBcS4PYDiu5HEF3E4f6h	1422	1091	274	6301	12432	jwwdkhxXShQ29pdQGsNDXpbKXhB4a7TsJmy6m2CKXdfnJ49JphK	8386	11867	11867	1618075260000	canonical
16496	3NLsBfAruM575veXPAdmiq1pjgPxauWjpcGqWqswQy4pihd828p9	16495	3NL51GCvqQ3PuQM7vzWUWbs9udsTnaoWbEN7HKhranS3Tj8RDrks	1610	1314	274	6301	12438	jxo5ez2nQs7EfZ3GFb2AMyzCTpbKWtPjk49sdLRWBpywVCLMA76	8390	11875	11875	1618076700000	canonical
16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	16499	3NLqJ6WtJYzyAm4HKtWEUUrntw4t6XWD2T7EKiEkatTGjzxNka1W	1406	1393	274	6301	12443	jwWbm5oKSpWo6vTVGeoqoj8jrYqrQNEiiKY3PyD1kbbSY7NN126	8394	11879	11879	1618077420000	canonical
16504	3NKjXkGLs2DFHK8NH4HdX7LB4P9DiqhxmmrxGjh3kFdxqwQ8oqZi	16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	1403	824	274	6301	12446	jxWUY8YJdpAvr2e9HfoUgCapETc2pZHmFyKDWBnoJvD1pb3vyiK	8395	11882	11882	1618077960000	orphaned
16506	3NLcgrDuEwV2mwJuQ2xocVMRH2B81w2BPmiQBTEdQi2j9oazWZw7	16503	3NLEceFuPCgkKNR7WiwZoJFiYc3XFL69ndk2TqgRfBz6N5QW3sQy	1581	778	274	6301	12448	jw8XmQK5uPFUqDrnKRZTgTHvkhMudPSi95kFDMWoUuYEM6WM2nu	8396	11883	11883	1618078140000	canonical
16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	1483	1276	275	6301	12453	jxmM4uWSTmHiu5ocWE1BTRm77VW5mdjZPUwmhz7SkiKDcKKjaQg	8400	11894	11894	1618080120000	canonical
16519	3NLjAMHJLuxomNyV22XGzrNrmVMhr1m63Cu9t7KzYdhMHc1YcnHi	16518	3NL6Y5M1kkUgAfj5yczYjzFsaUbzztExv9PT5mX3FN2p6oTUgD9g	1483	691	275	6301	12457	jxvmyyd4WxWv7KRFymZJ3gTr7eTEN61U5JZN5DGCXQhAmxEtqbK	8402	11896	11896	1618080480000	orphaned
16522	3NLVjLQDzibPgof69uS4gaZQn6cDuDUsHDCHEtikLffuak3CNAj6	16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	1407	1395	275	6301	12460	jxksXMHB6JhAB5jshonEYgACeNUJ5npR2NASNDS5xUxZ7WRxqFN	8403	11897	11897	1618080660000	orphaned
16526	3NKkWrwvz6jwNSQFjkXDvXUoX1rTv857WJaGu5e88Ejf4iNj3gCR	16525	3NKPWNFFny8dXd3ubnHcLrg85AFbZPprqoZkEXzswNYJYZUgfw57	1634	1331	275	6301	12463	jwq55ESVtQWDPK4b91iW4CJHcajyN8By6i3WnXTRTjzKbNYx9AG	8405	11900	11900	1618081200000	canonical
20945	3NLjs7iEXPSKzQKVVKVJ5g8uaNP6oZCtLMChPyos8EpcW15rtjcB	20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	1407	1395	381	12463	13224	jwjHxwr44eqVeNkEvd8GqyXYrEVxRkGqzJPMxvSK82TRHUuCkF6	10534	14836	14836	1618609680000	orphaned
22295	3NLm9t1sk8NqVbz7CCTLraA1H5hBrK7Q5JFS1Mk7bG4ba4Kha1pP	22293	3NK5q2jdWfNtiFbrDAPmC6zhY3HzD4qPBwM2FTEVdnkjySLYEZCY	171	1374	412	12463	14416	jwgn6sFUNs4ijxsFqu4ZdNBvDafY3AdPP6p5SgtHiGJDppcSdRy	11160	15709	15709	1618766820000	orphaned
16448	3NKZdFCE9WSHEGkozNmWSAYBgLTqgdANdYzh2uofNdrXGzDvYVwi	16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	1406	1393	273	6301	12396	jwvVACNQMP5iudNNN2dkhJTAFvxsxPFPyizJ65xSXgPa7a1fZY2	8366	11841	11841	1618070580000	canonical
16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	16448	3NKZdFCE9WSHEGkozNmWSAYBgLTqgdANdYzh2uofNdrXGzDvYVwi	1407	1395	273	6301	12398	jxczbVPDhho5Dgm94LymJ7gor8VgPkLwstiGG8SanBxBetc413p	8367	11842	11842	1618070760000	canonical
16453	3NKEncJTHfTCwUWDgf4HK2U7jfaXRRLVBKySmY5ZMDPR2pYvrn2E	16450	3NKWYRJq3KUwUzqvdQJGzrzSrtCY6Gd2bvYLLnRahnFGZMwTVBVV	1555	1101	273	6301	12401	jwkrstGxmaVh13PUqBA56ng9RthVUbNa8gtXLLy3ppKXzEsyWJp	8368	11844	11844	1618071120000	orphaned
16455	3NLDHC4Z7N5GUR6JvDLvFCtZ5bnyXFEjka9gfTQJJGcumTJ5ZZQ4	16451	3NKiViU4C4dyp6QNphYSHo8JCHMt23CPsSCeetJmxnWbpdyrPDWq	1406	1393	273	6301	12403	jx8AkiiugGisGfwTsJ9GxQ6MvK5JMr5RRenEjvhd2xB7LwRrwMz	8369	11845	11845	1618071300000	canonical
16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	16456	3NKEkgTbJj9t7y3NULXhqfZfQGu3t41T8y5edyrRWc7Jp8CwP8jN	1637	816	273	6301	12406	jxy6HTXN47nToDKmVcn4WAmdx7f8cpynQbRyrVW6AAzSbfWvUuX	8371	11849	11849	1618072020000	canonical
16464	3NKmU383pAkouEx826TXY3NiwdywH7LLSACq8wxGG3PKUqp9agWK	16462	3NKahKGHYfpRhw8WTrYbqL4ezYWiFVLjGkT7GgyuJypWDgivcYfw	532	1177	273	6301	12411	jwxpU8PuzYJoFLdenUgeWEZjLraky5YD9dQjvc2SEyAVTH2FeMM	8374	11852	11852	1618072560000	orphaned
16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	16463	3NLgQZpMYuV9SRZBjtjr2UhwZWH2gzBoDrjJeAsUR25PCpeR3Kqn	1406	1393	273	6301	12412	jxF24c8tHfmNKGQ1xVJeZxBD1AsTYq7VHcjF8rxCHX9x1bv9Be5	8375	11853	11853	1618072740000	canonical
16468	3NLxZm9q3wcxWQXSB2Dc3QLQ6iMyYJs5TSHdYVLXtvdtYkv48gCr	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1553	776	273	6301	12415	jxFkv286LffxKMBStcfECkYPNaSn9KxD4B1PiJFPwmQMv2HuXJp	8376	11854	11854	1618072920000	canonical
16471	3NLoBtD1AWRbtiYcc4jA8a62VaYnkqTowL45XzR3EnJjah4GGFSi	16468	3NLxZm9q3wcxWQXSB2Dc3QLQ6iMyYJs5TSHdYVLXtvdtYkv48gCr	1631	794	273	6301	12417	jwZSM8N4awqRXzLrQwhr88trt9tCFdMQ45GtE99KZSWadEFgBee	8377	11855	11855	1618073100000	orphaned
16474	3NLC25kemC8LfhnidkC5MfZ1nMWUnAmHNVRiaiUbQhCHZiD9kgST	16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	1549	996	273	6301	12420	jxYowAFsxLaoiaxeYVqbLYV8y3QgmkYzpNw5xHjcQYPbToi1ZcC	8378	11856	11856	1618073280000	canonical
16476	3NKNabtySedfUCPGL7FLaHHSFFjJ4ocyBuaBYYjTTMJhbxWWoVAx	16474	3NLC25kemC8LfhnidkC5MfZ1nMWUnAmHNVRiaiUbQhCHZiD9kgST	1648	1038	273	6301	12422	jxvdFPTgwQ8BU15f9EjZPbgn88TWGkwC66SuJQsTEoNotpqxnXM	8379	11857	11857	1618073460000	canonical
16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	16476	3NKNabtySedfUCPGL7FLaHHSFFjJ4ocyBuaBYYjTTMJhbxWWoVAx	1407	1395	273	6301	12423	jxbER8UCzwS4ANPqsvRxyPbXpoyqqAZnBXEEzYWXqmdrVQgfFri	8380	11858	11858	1618073640000	canonical
16480	3NKgPTjtJWeZskHYG7MDXEwADvBGxXvaKchJnT1RHNfH6C9kUJo6	16477	3NLR4eMucNEzSbBHYeRGUfB8mAw2Y5eQFK64Nvb49bYu8XSyyg8d	1523	955	273	6301	12424	jw6tc6sadX8xUb4vvno2wPUF6tr8YHTcmXK5EWdjcxeTxusnucB	8381	11859	11859	1618073820000	orphaned
16488	3NLFjRompA3PBpdabJxxF3U18DD2tCBCcxFMNT5mqeKnsdyytBVV	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1406	1393	274	6301	12430	jwm5t74eNwZ7hmu8gCw2cW8Z55RPoNU2eHRzSJNxLeimKWUvSt9	8384	11865	11865	1618074900000	canonical
16486	3NLuWyWnW2m4Cv8bscdfQvzB3paJixwW6qTHumuCp6GP3cNAPUuS	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1579	1263	274	6301	12429	jxr4uggKtWAk6iJZk5kMTEFZvTXv1pgbkTjoetX7FtuWXgmQgxJ	8384	11865	11865	1618074900000	orphaned
16484	3NKn5HpehzvF45ytspFioBwdU5pzTGP5ejkSr7xzpzX4xtpACMJf	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1503	1031	273	6301	12428	jxwG8gxnfpRbFU1diuHFV4Nbw9ycmJth9oZ3kG26euRbVDpLniS	8384	11865	11865	1618074900000	orphaned
16489	3NKF33YBCZbrsfPu94cxrGwQhmhC5EmtWBcS4PYDiu5HEF3E4f6h	16488	3NLFjRompA3PBpdabJxxF3U18DD2tCBCcxFMNT5mqeKnsdyytBVV	1506	1127	274	6301	12431	jwkYJMhi7gN6pbwKhgWqYEjtHi5PefBD973ruJejtCz9StU9d2S	8385	11866	11866	1618075080000	canonical
16492	3NLoUD1tbg1rokRSzKoMrKU8Zc1WVHV9qjrRU4rBKaiFdYfcwJ8H	16490	3NK9NRbFXFXyRiibSKhnAJuMkRMBrU9om1XCAaQ8Mp1h6u2GPGfW	1403	782	274	6301	12434	jxa1RXraHb4gFRVzcoNiSiBUonY5QGrCZDRaGmDsB8jWm9zDjdM	8387	11868	11868	1618075440000	orphaned
16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	16491	3NKoTukgwFyZquYxMaCRNjJ1uCrBvSRBFEgBW4R4FkJv4ABNR7AR	1579	1389	274	6301	12435	jxkJzio4twcqY5TDn9Ut4Z7es5kFDVHQhqzDCFb9hqfuNNibXtt	8388	11870	11870	1618075800000	canonical
16495	3NL51GCvqQ3PuQM7vzWUWbs9udsTnaoWbEN7HKhranS3Tj8RDrks	16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	1489	1134	274	6301	12437	jwmBaSP6EaWzspBRVDk6HqRzfWhuSzSfUepPTZCbT8oEkbJ5oKk	8389	11871	11871	1618075980000	canonical
16498	3NLFUgAGKUk2DaMfxx3Y19xRa6DR3awQUdwHw8mJcBvJFdQZnsQt	16497	3NKVCCwWDYGuRTsLVZdGcvbuWQCmSitS4TPutgUGDzvEJ8GVjLhb	1618	527	274	6301	12440	jxu8CU9RP9Z12QsE7GmR8onMTaCjr1FEb3VjRyTAdL6ydH7Pipn	8392	11877	11877	1618077060000	canonical
16499	3NLqJ6WtJYzyAm4HKtWEUUrntw4t6XWD2T7EKiEkatTGjzxNka1W	16498	3NLFUgAGKUk2DaMfxx3Y19xRa6DR3awQUdwHw8mJcBvJFdQZnsQt	1609	1333	274	6301	12441	jy1ft5hevJqKSzrfDkmwN2qtBBuWkpvhtKMs5HaZQbDhSrbadnu	8393	11878	11878	1618077240000	canonical
16503	3NLEceFuPCgkKNR7WiwZoJFiYc3XFL69ndk2TqgRfBz6N5QW3sQy	16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	1406	1393	274	6301	12445	jxjnzGvMvxiaTxqwGtnQU6Z7gYwbrvGR3K9HvB5X6AMhfXrSeoV	8395	11882	11882	1618077960000	canonical
16502	3NLbTHdUAvT65Def7BuGXr84xgqkkhukZwcQYBT2cSurrHeNBFBm	16501	3NKe4jTSUKa4PfZuHG5t5PwwK7Ldf2As3H5a92m89LF3cPW6cxRg	1402	906	274	6301	12444	jxitXxA3DwiZfrcsZ9MQynfX3ugyfjuXeuvcKBGXoHEFNGcSVGg	8395	11882	11882	1618077960000	orphaned
16507	3NLX6hr3nit3tJc4nUnwXEj7iUWSw5p8oLtUWrSxE2yR9VmcAc8W	16506	3NLcgrDuEwV2mwJuQ2xocVMRH2B81w2BPmiQBTEdQi2j9oazWZw7	1633	1144	274	6301	12449	jwcNZfiLDBQkgJnTrkDRii4ERNyxvSK8caMYjicd3uYAiF56U7u	8397	11886	11886	1618078680000	canonical
16509	3NLiuWUjSihJZAgzC8koUApi8vNppYuV1rnhWZ2DTZN1chZYJG2C	16507	3NLX6hr3nit3tJc4nUnwXEj7iUWSw5p8oLtUWrSxE2yR9VmcAc8W	1613	1349	274	6301	12451	jxLgY3U7wJZXWDSj1p2EYbfhgoGrmFHFCSz4wzMzk6913wZ9tU2	8398	11888	11888	1618079040000	orphaned
16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	16508	3NKEYWMaMgVnpYjcUvJ3rtMLap1VPFTkDBq2DwP8F8Fcu6kSsgEw	1406	1393	274	6301	12452	jwqzVreRk4YkKnQrQyYPcPbnYmtwF4V5SwcdRuQ8YBTFZhu9iqQ	8399	11893	11893	1618079940000	canonical
16515	3NKrTHHSyMj2rwA2pPgupd9hxeVHuJgsTk66UYyx4ZGLffuCwosx	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	329	329	275	6301	12454	jxCpc5ZJLb39CNMuzig1XMeCmFUXhSadJ4FZgnMKQYiwCknoN8s	8400	11894	11894	1618080120000	orphaned
20958	3NLU4QtfkGr2MEZKyqpssWEM8nhJqWr994VWpHFEkRHWq3Rkn4xr	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	298	1062	381	12463	13237	jxCuR8K5rGGQBxVo59nL27UqaXhx9FKHpYsWP6it8UXuV9wdVU5	10542	14846	14846	1618611480000	orphaned
22297	3NLaQYfPqsUQoHMkYNmRmaUrMkKGbW2qfA6q7efsqgumuX4nsqGm	22294	3NKfV1teVUidgULeRy6y5fW542coyX3R674FuVjzURfWEc5k4E8W	1397	828	412	12463	14418	jxWVbWxMf1cfUNnrrH3Cddw7CMtbmV36bu9ZyM2vJNCZznNLMk4	11161	15710	15710	1618767000000	canonical
16541	3NLmnXUp1TBwEZicdbXXuKvGhtQfdyS3xDigS6MGRUqSjUYEY8iF	15977	3NLrGSVrKM5oALUpPytKpyy5rwXLdTqm4ZQhrE1fmCAnYZCFMg7H	1590	934	260	6301	11964	jwSmxj2Ukx3nYVQiCJhBm1mc1F8opYwspABNkRqzZpJGGS2YECJ	8122	11908	11908	1618082709570	orphaned
16523	3NLu4ykxmyBoN7A25Mef1nPZuQJmS2ra4KW9KWqLrNCCDj8BLds1	16374	3NKuAakpjeRyjZpznKfn9FXjoEFyVRz7xgiJqHCcvL3SgZgdCmxf	1513	1013	266	6301	12461	jxQvwh4dKM8UVSLvewSJn5wAHsaN3iWi6CFoBBcb9qRxU4Rhpbj	8234	11897	11897	1618080660000	orphaned
16548	3NK71LHt949XAte2pzHeZpVNuYTuu8qTYz2wzEgbcREq8g75JU26	16345	3NLHk1wHvJAaZw417ugeX7CbfKSwLPR494xpiVEgjFQEq1ey1YRW	1451	1166	270	6301	12303	jxgexqeW6Y7VdhV2hvrBbEA4Px6nBDuyJMYFSWgxkKT3ckyy7US	8313	11910	11910	1618083000000	orphaned
16500	3NK7eYEeq6kRnCBBBjB2K3B2Ye9Ps8WqQyWReE6ATwicuqNa6yhf	16499	3NLqJ6WtJYzyAm4HKtWEUUrntw4t6XWD2T7EKiEkatTGjzxNka1W	1460	637	274	6301	12442	jxm99KLWG3JDDpdEGTYt17WgdvLo7XPpMbSAQds1vbrUmZLXtM3	8394	11879	11879	1618077420000	orphaned
16505	3NKgEWCsEoc8YY1maLqYUZB37gfBNQXhkFgWoZZdacT1gEfXBytG	16503	3NLEceFuPCgkKNR7WiwZoJFiYc3XFL69ndk2TqgRfBz6N5QW3sQy	1406	1393	274	6301	12447	jxwnG3HcF21uX6JF8viSdsmc9AWK6ewEheHpKCGGNh9ScZgSN9K	8396	11883	11883	1618078140000	orphaned
16508	3NKEYWMaMgVnpYjcUvJ3rtMLap1VPFTkDBq2DwP8F8Fcu6kSsgEw	16507	3NLX6hr3nit3tJc4nUnwXEj7iUWSw5p8oLtUWrSxE2yR9VmcAc8W	1406	1393	274	6301	12450	jwafUVg3Est6WHP5oX4rqsT2PJvLRFYdzBNhHLFSqKfjWGfN71r	8398	11888	11888	1618079040000	canonical
16511	3NKL3268KjEB1krnHZQmxbH7dVBKNCAMiYTKEzoKvL9UNY7osNUL	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	1483	1276	274	6301	12453	jwChc7iAQAVqPzrE5izgrcZ5FgWRyeBBT8dd34aY4UvWz3LDzg4	8400	11894	11894	1618080120000	orphaned
16518	3NL6Y5M1kkUgAfj5yczYjzFsaUbzztExv9PT5mX3FN2p6oTUgD9g	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1668	1370	275	6301	12455	jxsTKbq3mMkw9mp5CT1AmWWQSfNzQ7DcGyXtmHDjA3BJxwepymP	8401	11895	11895	1618080300000	canonical
16516	3NLJTBemQSKPj1vFj7DARia9wBexNYoHfQxVCSrk7Fgf7ZAt8dgN	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1668	1370	275	6301	12455	jy22h7ucqp8WCducUXd5XDhH2oKhtLRfVeUeKKNhKDhrYkaxCk8	8401	11895	11895	1618080300000	orphaned
16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	16518	3NL6Y5M1kkUgAfj5yczYjzFsaUbzztExv9PT5mX3FN2p6oTUgD9g	1608	1289	275	6301	12458	jxf91Vm2oWbewPpvdfqPBrEcBQJyHpmACaNrSZf5R1u8m99sJib	8402	11896	11896	1618080480000	canonical
16524	3NLcK7FaLXfdSJ81RUdeVFcbSJTWvYvfxaZ2YCy74SYv7vb5WiPb	16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	1403	824	275	6301	12462	jy2vLsfecSpzThEsF9raCWZoZvZXFiaM43txpSerEvjFxCgQaeH	8403	11897	11897	1618080660000	orphaned
16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	16526	3NKkWrwvz6jwNSQFjkXDvXUoX1rTv857WJaGu5e88Ejf4iNj3gCR	1483	1276	275	6301	12463	jxK7FUP2euSdzCb3eZR5BhSmWkb2avVnByzDZmVVJGjdrazj37m	8406	11902	11902	1618081560000	canonical
16528	3NKSagms6Gs3vs3LfirVZsSmvRcoiAjpquEgXYWEsANcjPt8Evr7	16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	1509	1320	275	6301	12463	jxMEJwsbPu6VDeUXLP8iTNfJb5pKnpNMMea6uuie4ePE3UfDeBA	8407	11903	11903	1618081740000	canonical
16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	16528	3NKSagms6Gs3vs3LfirVZsSmvRcoiAjpquEgXYWEsANcjPt8Evr7	1637	816	275	6301	12463	jx1uDwX3a4yVZwrvcVgW3J5DiheW3K99sw25wXPQAMBazE65C8S	8408	11905	11905	1618082100000	canonical
16535	3NLgGUuwrYGLSKysffuS357Ef5W1kdyMh3ZjnYnmpvXev7nLDRmq	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1579	1389	275	6301	12463	jxziL15pr5cJQtmyY4E9sWhGpEhC7hiNn3ykjfg1Ho2KFWSMv5d	8409	11906	11906	1618082280000	orphaned
16538	3NKdtVuiVTdmoPQg16XUUqsvM7YxVtCxsD979jzxzAEYxnf7aajk	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1440	1131	275	6301	12463	jxa8qgVD6SyZ2SdTH9kiY1cPsVEahyeF23UH4bFFpQ1LxSY1UGu	8409	11906	11906	1618082280000	orphaned
16544	3NLmxZgsHyhSpaMdTT38g7UDrS2QTqZh72dCBdzQf6kX66fPj1u7	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1406	1393	275	6301	12463	jwALhkDgxKHZ1cga8qVHeMyP4H9AJE34GBj5wz6HGiKnPV93r2W	8410	11910	11910	1618083000000	orphaned
16547	3NLW93ztdnC4SUQM5rTsv8hTngVT6H4L2AtdMyeg4nCaUGbmikPF	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1611	1095	275	6301	12463	jwgHcu2UMZJvnjLjTuxn75HbQreJwmWx282y2ArHyTTSH8hZyku	8410	11910	11910	1618083000000	orphaned
16551	3NKV5aruKkLmSgCRDUav4Wc5uhTGxrs8jNrSWZPNx4Y4ZiAYSiGi	16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	1651	1175	275	6301	12463	jxjH9awkgehWVTU13DsR3cSL3JQHbpKwKCa1QZdCVuqB9ikENYY	8411	11911	11911	1618083180000	orphaned
16553	3NLkXBU7gx8KETkR4hbjhqbrBSTq4Y16PMrhdPnspWuEm2w68aap	16552	3NKHDaytkuZmoQXyfcQi9ksQtVodqDNsC2V5NAkW5qzyJqJGnPPj	1637	816	275	6301	12463	jwFxVKa25zsgM35VMd7pJDaBUg3Aes7uTLBYJ1sEe94ysUfsrsu	8412	11912	11912	1618083360000	canonical
16556	3NKWhUffYsy61GSFPEtd1vRpUjwETs1w7e6KhUa51X93XV2C8BD3	16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	44	1079	275	6301	12463	jwHaRj8mUnKkrpxS6uUCDDVpXEjH2TSggz2aUSPgadnJCASko6g	8415	11918	11918	1618084440000	canonical
16557	3NLPzxLeboc3GxQawEnHrws1FJt1rkFxwrWnJQSAFoMFMcrDYoca	16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	1403	824	275	6301	12463	jxzuPw9DVNHPSGP1maAw2Vsnv1ExKPczRcyjntBAJiAyezqeU2N	8415	11918	11918	1618084440000	orphaned
16559	3NL6RjEBecoEtjurEoEbkub5nVgfnWMA3XBMZyNYZzx9bEu4emnU	16556	3NKWhUffYsy61GSFPEtd1vRpUjwETs1w7e6KhUa51X93XV2C8BD3	1501	1234	276	6301	12463	jxBh11DWtMbFSabcX99yDncJcYo4KeVJFhgVJ6iKZfbw3ZVvfWS	8416	11919	11919	1618084620000	canonical
16569	3NKaFgzE4GdZfEX3WSsTGm4qSXiGdp4S66RmPhtZU2xtdqzVGCLU	16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	1651	462	276	6301	12463	jxtyDd1v6xC89pwYLdW9iVkVHMJpjG7oMdXTLVpFxLcptMLz7uz	8422	11927	11927	1618086060000	orphaned
16571	3NL2GhmVK2iKPyouXvpZsNH5G21Fcgj2DQsDkf3Cx9y6d3dZnbzP	16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	484	1319	276	6301	12463	jwqy5QPXCkQn5gs9w4YxjYU9a9vD5HQfZraNLqBy7uWfRruwwZQ	8423	11929	11929	1618086420000	orphaned
16574	3NLgeR5iNamwqmDpTLQidLkSfSvBYqqGSPACLgQ7cWS4TMzxSF5Y	16573	3NLapShqFoCgJ62ySmDqRFXUUBN7xYJUwq444h8o8rG2CvSAkpe1	1403	823	276	6301	12463	jwaSdr1ZdZG2MiVayV3VYjtMmJNEGADXexTEzLo6B9r7yQEp8EF	8424	11930	11930	1618086600000	canonical
16579	3NLLEyw6U64J4kHEJkNPvrJoy4UMpPJVHymjGABoYCqthWJezUXc	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1631	794	276	6301	12463	jxxYrpRhUKF8BmXLtX48Mo9dqRCW9HgKwvg8LT6WCNLQzU6EyYg	8426	11934	11934	1618087320000	orphaned
16581	3NKEiE6gmAGT68zhXzq57Q12q5kkwsDJS9Q9LhExSVi3pymazNgE	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1426	1364	276	6301	12463	jwDF9HQqcYCxNfY6tPLh2cuxM9QSMvHi9YoLRKMB83MU4rJqMaE	8427	11936	11936	1618087680000	orphaned
20970	3NKWt3rQiKYVSjQ8hpggPgPMUPTnTRfyTPtbU18znUhEbLZYhL7s	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	684	1106	382	12463	13245	jxi5vwGY1enbtzY5652TY2H2bRRQW169ckqDn5YsZQ8cpb4Sojs	10546	14852	14852	1618612560000	orphaned
16595	3NKtAv3YUC5TSe89KCjEKaQFK5SwXN7BDnpEeXjacnzN74TchTh3	16576	3NLhPA57toFu5ZLDNRTfyd1yCCddF37VRyWjEs1QdSS21N3CHdFA	1455	1332	265	6301	12201	jxq9QwWfu4sNv179JscuT1FgzKNFWsJFdLrEop9HCzJELTwRdoS	8212	11944	11944	1618089120000	orphaned
16586	3NKToPnVubDrqiWSpw5XK27MyQDF2Tnxdq5uM2rwxnjPX6KzPibu	16287	3NKLLikmxp8ADfyGskYVTWNesmEb9iR4tquvMsZQL3dRuUUHPQZQ	238	238	268	6301	12248	jxpPZuuHAM2SgFG9GJkYyaPXcWu7HMU8GmGZLGYRS15rBCfHjhV	8277	11938	11938	1618088040000	orphaned
16549	3NKfZNM6cmMN5ycaDqPEMg7QwcGbeVH228Mxph14UfxY62G5Usqw	16366	3NLy892TNN1SQDES3kn7P2q3ckwt6oP8RWuLVTHU8HWoF33MuU81	1451	1166	270	6301	12323	jxMU1o2wiKpMxF9WQ8SbegCq1XvHCvChXAY2imQR3tEseccJhrK	8325	11910	11910	1618083037752	orphaned
16615	3NLB4XqWgRSkfzUEGvBzv4k8wjDrohZM5s2coFETST98wbyHr4f1	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	1560	1045	271	6301	12343	jxxrbKv5Gd5xSgSpbsKGUsNKMPSWj8a7j7C15jhgj8xy8pJRmjr	8338	11952	11952	1618090560000	orphaned
16517	3NLxw7RztqBdv5Ek9PjxMpq3QGtDJkQSbXB5EcUsTmQQTaTzMp5Y	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1440	1377	275	6301	12456	jwLrZ4Dp7e3QK3yuLuhQZyh5rWPPLcS8pFuw66b4U2nQNYYGr4x	8401	11895	11895	1618080300000	orphaned
16521	3NKeKRnRpNVsMdZUzWbkxMVF68bbCsYTsu4FYWXcY8uddZHNd3B6	16520	3NLcgkefFhzhMCtCSjWzR7xmFN8tBxgReSHyPSP1xDkKqMJHVxeo	1483	245	275	6301	12459	jxothbq8EcA3fDqD66rykkY1GbSXar2CWwUM6SHyDh8G2SVQ1Zy	8403	11897	11897	1618080660000	canonical
16525	3NKPWNFFny8dXd3ubnHcLrg85AFbZPprqoZkEXzswNYJYZUgfw57	16521	3NKeKRnRpNVsMdZUzWbkxMVF68bbCsYTsu4FYWXcY8uddZHNd3B6	1419	814	275	6301	12463	jxw8hjJBzJbgWKNw4qeFb9Engts36c5DBb8Cg1Cge3ZdLVAvAt2	8404	11898	11898	1618080840000	canonical
16529	3NLCciucR5NYWkbjDD4V87H2DXeC9BCojWmsSBwSNutViXpZPsrN	16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	1560	925	275	6301	12463	jwc8cU95yzFkN7skpUiSxYJjkkD5pVdA9Y5jdq6i1A8i7r6u2Xh	8407	11903	11903	1618081740000	orphaned
16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1448	1185	275	6301	12463	jw84U6Ww2a5bqqeB2Au7kj2ydUGAth8p5nGr6gkUwDQQR7FGg4i	8409	11906	11906	1618082280000	canonical
16533	3NKJinzKZBeV8Z2qdaKjMa7xS7jrZv8wBMNdZbB5GyuhoHsLTVPR	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1448	1185	275	6301	12463	jxxUbPmfcYT8ArgQPwyRNjimrK9tLwDVt2ew5xA6DCvoTWLt4fu	8409	11906	11906	1618082280000	orphaned
16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1444	1381	275	6301	12463	jwDaKUmkL8Zr4TkZAGf7Zg6XhnowHJiCFCEQ4vptWFaRr26aKzu	8410	11910	11910	1618083000000	canonical
16552	3NKHDaytkuZmoQXyfcQi9ksQtVodqDNsC2V5NAkW5qzyJqJGnPPj	16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	1651	1175	275	6301	12463	jwxss3wfaLCGCxtQ6mRD7GngfYk8WceuvsHUJ9daRZK8qfDro1z	8411	11911	11911	1618083180000	canonical
16554	3NKTg7R24LJg5xSqR3LvxbV6Q5nfhYwDYX39mXuRaXjYS1y8fdF1	16553	3NLkXBU7gx8KETkR4hbjhqbrBSTq4Y16PMrhdPnspWuEm2w68aap	1406	1393	275	6301	12463	jx2A7qkrenkr2kH3mKodeR7bRBJPE52DiMwufJULHiCwXPw7K9q	8413	11913	11913	1618083540000	canonical
16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	16554	3NKTg7R24LJg5xSqR3LvxbV6Q5nfhYwDYX39mXuRaXjYS1y8fdF1	1622	990	275	6301	12463	jxgJSmkXb3d9SHCV9s3ZiLa1pX2KjcEXeGnp1BMfYsUxSbEwCqB	8414	11917	11917	1618084260000	canonical
16560	3NLbEqpH3aDyeq59Y5UkwkDfavHcX6BSMiWRa8phyLxk6T8rjq8b	16556	3NKWhUffYsy61GSFPEtd1vRpUjwETs1w7e6KhUa51X93XV2C8BD3	1617	1042	276	6301	12463	jwgRN5KDXpBXrRef4VcKNxJR19rNoFqYdVmv6fUMnDE1mkXS8E9	8416	11919	11919	1618084620000	orphaned
16561	3NKWaiyZtiurss8wjZWC4gxvfgfTMvbvNwN48iPHsCaG8XATUfs3	16559	3NL6RjEBecoEtjurEoEbkub5nVgfnWMA3XBMZyNYZzx9bEu4emnU	1611	1215	276	6301	12463	jwmoGuVhFb8N6MkAGbi9p7QQ8KknZHVX69t4o2VecgvoCDuweP7	8417	11920	11920	1618084800000	canonical
16562	3NKqSAnJfK2ZotvsA29EQYTjCNDPmwZwxv3drGjdhybGYdBSPLYx	16561	3NKWaiyZtiurss8wjZWC4gxvfgfTMvbvNwN48iPHsCaG8XATUfs3	1406	1393	276	6301	12463	jwzn42i3M11wD6LN56UdoV1gSpeQAXmvhWqytVkKSQiEVj4MBho	8418	11922	11922	1618085160000	canonical
16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	1407	1395	276	6301	12463	jwLwBGtTfiFeoQUHwRc19Faex5uyr1MUbPCwt2woq6XPeqbz15p	8422	11927	11927	1618086060000	canonical
16568	3NKp2hnXtdEQxDa1PfxnSwKbZJKfZjmbWGGFPs6n7pzVRo55hVX2	16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	1651	462	276	6301	12463	jxLv84JNNPxF28EwAAzx8nq4gAw486D4TejfTCabDLD2d25j5BD	8422	11927	11927	1618086060000	orphaned
16572	3NLrYqC5vExP5VeCJMyhGKc53eVMAukMtQEHCjye5q3uDcRt6sfz	16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	1407	1395	276	6301	12463	jwvfyTqTir9LDdSvffcDAt6HJjmJYAMgcyQ738G6QCjZw7Yfc3N	8423	11929	11929	1618086420000	orphaned
16582	3NKDbtSZPzwfV2dAQjBfcAZMSkXm19Ep7XBVNAsfvxNu9bnuNQ3v	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1490	908	276	6301	12463	jxD84qyPQNKLqNXPzaieoL9xBWW1JQdJqePGYvruZkYX9kNuCRu	8427	11936	11936	1618087680000	orphaned
16610	3NLmFa4oMfms2iFHwd1n7oXgM1HeP1EwwNAXR3mDrziCihGidBzx	16584	3NKfTBS1FvrZTTdu9g5fY8kzuKD6NmgKW9cWgHdg1Wk7aycxcZf8	1490	1274	276	6301	12463	jxyW5mdWZmjqLLLBCGop49KG5biZqtHEywLs6D9ig1Lmc6Q5RgJ	8427	11947	11947	1618089660000	orphaned
16588	3NKGfoi29fXLMPKQdSVwnak5s3i4PvsLyzYMfL29Xqb57kWaNfow	16585	3NK9kv36rNKGN8nFxTXPQPVYkMCfRdeuSD7ADBJwiVPN3jqRRZ77	1581	778	276	6301	12463	jwXgBLqERHEHKRAVbvBSrjvGjWnK6WohULNprUrVFWm6CqvKmSX	8429	11940	11940	1618088400000	canonical
16591	3NKWLCZcXyRwRB1KvnZahc2MxwfQSRMQah4qcbDH8jRySFxDJhX8	16589	3NL35kSKR2p5RztMSyJSdAwJiCr9ejbywfs7jB1JCN2FsZ9FURGZ	684	684	276	6301	12463	jxxoM2pe2dghvxVXZCFEECY1AeTVeFu4sxzX1urZT4aceStBV9W	8431	11942	11942	1618088760000	orphaned
16594	3NLLkvHgb7vJBnNoY7sdu7kGcLoVjZpFt7zp8MPVCy8vf4wyqSJg	16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	448	1059	276	6301	12463	jws4WTztBzBTemtUS9NJ5HQ2iKKdcBHN3Urpf7RTCfnK5r9Gf3B	8432	11943	11943	1618088940000	orphaned
16602	3NLNN8FUu35niVhLULzJ1gAAHmvGbr9CgwHZFhkVSTw4J4NEGSLD	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	684	1226	277	6301	12463	jwNHQdcDsitLktHnG7zF35PGuXx7AfVikN8qpAuCbcksbGLWE31	8436	11947	11947	1618089660000	canonical
16622	3NKsSkx3kW5UaDd4i5KYjcpLQA8GwbQ5dYy4JfjRh7fftVGsFmWM	16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	1623	830	277	6301	12463	jx18XvuTLyAQpbuYHUifiuvziFJW3jZQBSRJUA6Cjo8SJwzcVir	8443	11954	11954	1618090920000	orphaned
16624	3NKFMGoQMbkHn5Gyqw17vdaoqQxw9EKdMixFGbQPhNPreqEGhR9a	16621	3NLC5Q61EkwrAdXgg7A9wSarwFNLixGmZ9rkyQriE9bYhMCcSN5Z	1578	1050	277	6301	12463	jxiAYwpSQUJoDXdn1rRHmDT35fcYysLPxoyS2Xz9H8iADyAbj4C	8444	11955	11955	1618091100000	canonical
16626	3NKZxGHbjos2sW2AfUqnpxhj17HqMVEuVFVL2Usf9eCepWQ6Nyfs	16624	3NKFMGoQMbkHn5Gyqw17vdaoqQxw9EKdMixFGbQPhNPreqEGhR9a	1581	777	277	6301	12463	jwuDQ5dUD6abqzBsbpGqDjvC2psaJBy8QnDvTddt372BV8hAT2b	8445	11956	11956	1618091280000	canonical
20993	3NKNgmuMshtAyszjdRM393h3Zwgn7L6fk65MmJckYeqTo3HxTyvV	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1445	1164	382	12463	13269	jxKrJCfCU3MpiArtsZYNaKCtnBGc5VGeLFFywyVfSRGXwByT6YU	10559	14866	14866	1618615080000	orphaned
22307	3NLrWTNFdig1G8mKPGf7gEewhwUeBe6wqaFBgT3KVS9cXHFGdYLH	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1578	1050	412	12463	14428	jxWKuPcW6mwNQqcm6fLbtFQYvb3XQ2LJqYWzTEBoB1yQwfekzJ8	11166	15720	15720	1618768800000	orphaned
16540	3NKJCSraNtz2NCsk1owJAaxSyySAkNjsw7LUZ41bpR7Dg8rnD433	16513	3NKTN46wkpoxwY2B8ZCHhaYFNdMN9ZyG3uLbFVWjTXfwtGTHbsPM	1590	934	275	6301	12453	jxpzhj2uQPdcRz2yYhpR24QwPFtjKGXeM4xzdp2Fe7fzjx6odjo	8401	11908	11908	1618082640000	orphaned
16530	3NLtgmifFVUkUSLD5jtMr9x4XwPGutJMxfy3M3hu4D8TCH7EX92t	16527	3NKVij93EiawtjFeaPWKN6mEfKNpfHQn13Vbj1RZTyiSve8Y21PM	1471	1386	275	6301	12463	jxcWhayvhkcLHGMCATgUh9qTAD1UycwNttiZ22iG6z6HYZaBQhq	8407	11903	11903	1618081740000	orphaned
16534	3NL8xySs6NYoP5HWdtiUdUqERmfHrEA2pVDbx7MUvWZAtwXRfX7u	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1534	1317	275	6301	12463	jwBL1UGsAPGVs3ASdnLjjRhWnT4229Rnf83399vuttqL7ZiwMBr	8409	11906	11906	1618082280000	orphaned
16543	3NKjHWUZKSKH1juZk4CLb5zvQF1QGePxRtXUQusWWQDyzNiYmeQL	16533	3NKJinzKZBeV8Z2qdaKjMa7xS7jrZv8wBMNdZbB5GyuhoHsLTVPR	1451	1166	275	6301	12463	jwtJq4rETW3KYvZMYtNDEAvHwrqJtmzAqcj2Je7JcG36tSiCKbV	8410	11910	11910	1618083000000	orphaned
16546	3NKLhLZnKyhUX6ZPDRBdXpo8JaxQzM1Cy6pRYrvgu8qKHKhvxEbD	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	58	1281	275	6301	12463	jxB8DFcY5nRYQMiRVkrvHkjMNXpE7jpBg8gYjTCvZqzpr8Hu7SG	8410	11910	11910	1618083000000	orphaned
16550	3NKN3vwusipSahvsKHHVFZRrLNVm1wwycwSjnQwuXti9ze9Sx9RU	16542	3NKvSGQkJKwDUN3MWaffPWzYj9T2PiHX7GykvK192ijZ9WoRQ8vS	1406	1393	275	6301	12463	jy1vvjeNF7Bg3XxvgtRUReK3E3XNGxQmSGvBFSbAGkCs1uyynxM	8411	11911	11911	1618083180000	orphaned
16558	3NKkEfgNu58XbNrPvhMKmWUGJeFpvxZxB4k6hNsbXsjAwiXUDq93	16555	3NLepaTp5dz4WwzMM3b1zrYWAHamXepEg739L9wJNS8Ze8Z3WzUG	1631	794	275	6301	12463	jxobEtZSDHoZEaPU2gFKJgkgAodG6WFRjWNxP8Qrgsg8Hstxf6d	8415	11918	11918	1618084440000	orphaned
16563	3NK8aVqxBRYdV9MKvSiDQ7d7LBgtHK7SL992ZyaEN64urdQuSgfX	16562	3NKqSAnJfK2ZotvsA29EQYTjCNDPmwZwxv3drGjdhybGYdBSPLYx	298	1182	276	6301	12463	jx1QKQP1LudWJB3UuMhVUuZxhLD4VVrWWqJHjXsoxfqRxWucoPr	8419	11923	11923	1618085340000	canonical
16565	3NKLRdeiufuS8p4dpEzLYX5mF9bj3vFT5fzaeyGMXALbxUS9ge5d	16563	3NK8aVqxBRYdV9MKvSiDQ7d7LBgtHK7SL992ZyaEN64urdQuSgfX	1631	794	276	6301	12463	jxALw9Cin442mFiKYRCpbP8M8aNedtRrgKFvfa6fb7SA38svzR3	8420	11924	11924	1618085520000	canonical
16566	3NKMuPBA1cCTmVsyZXyuhrMoNYujyX46WwrLLFyZECNZ4ESztAkj	16565	3NKLRdeiufuS8p4dpEzLYX5mF9bj3vFT5fzaeyGMXALbxUS9ge5d	1616	116	276	6301	12463	jxSZPfyTwfHLXyjWz8P2TMy5Gboh2HdxeurgYsH7ZquMR2rmnwK	8421	11926	11926	1618085880000	canonical
16570	3NKVQWND7R3PnqDnrtv6d3zuBRn2s71R4vTu2gnN8LEnqXnKYTWc	16565	3NKLRdeiufuS8p4dpEzLYX5mF9bj3vFT5fzaeyGMXALbxUS9ge5d	1403	782	276	6301	12463	jxEYz5njeev1uPk3N3SdL9R8WZJ9czUUmMZMrdrm8swwFY1Jmqf	8421	11928	11928	1618086240000	orphaned
16573	3NLapShqFoCgJ62ySmDqRFXUUBN7xYJUwq444h8o8rG2CvSAkpe1	16567	3NKkYfJ8MNCpGXEfFrtX2Ab3xxobLekDqawZEzP3VKDULhvaP4Vh	1403	782	276	6301	12463	jwKWhh6YimoktMvj9Ws5Jj3NnzhnBwxK9gKNaxVwE8sycawa7Fn	8423	11928	11928	1618086327117	canonical
16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	16574	3NLgeR5iNamwqmDpTLQidLkSfSvBYqqGSPACLgQ7cWS4TMzxSF5Y	1403	812	276	6301	12463	jxZoVAJnCFaWC8VCjTYoA28UAKdAnHDpfDVx781sz9Z4Ubr8JRj	8425	11931	11931	1618086780000	canonical
16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1619	1029	276	6301	12463	jwNN9v6CEt9pq8FdsJEAY1UzVN3icUSMqHfLKgQinp2qqvMCsrJ	8426	11934	11934	1618087320000	canonical
16578	3NLxU48ay37Bu8RkqvZmwv2x5QhVYX1EBiigXTht9MJZBdaNZddh	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1406	1393	276	6301	12463	jwf56gESUJPRHbEXSnoXwSwVMkTZLzjiTTp5rwKhaR6rZQ9kDVL	8426	11934	11934	1618087320000	orphaned
16580	3NL33eP7ysnervmRtixU3Co3AyRdb8PVPPRzxvnvdbNSWjhCtU7q	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1426	1364	276	6301	12463	jxhe7hmdmrMQVF2yVo46ghaNcc7yy2p5WppgoeYaMoARXz3ZJWE	8427	11936	11936	1618087680000	canonical
16589	3NL35kSKR2p5RztMSyJSdAwJiCr9ejbywfs7jB1JCN2FsZ9FURGZ	16588	3NKGfoi29fXLMPKQdSVwnak5s3i4PvsLyzYMfL29Xqb57kWaNfow	1406	1393	276	6301	12463	jwmhFVDpSkB5Dkh8XYwtEMEmkH4Kh28DQrd7LD9JBKfCqQtfFuw	8430	11941	11941	1618088580000	canonical
16600	3NLvzt17BqsovyHiC7ShQAF5noQp67NHY121qQHsABK84cEbtfzQ	16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	1522	956	276	6301	12463	jwJd1v9UHRgQ8N1cxntfWX2Qv9sui64HkcakrudSt3SDpRNCzor	8434	11945	11945	1618089300000	canonical
16598	3NKpuYsqv8DjSV5iHwPuyDeN7VU54Qzq6yKT79T1kCQ73dkygpyA	16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	1406	1393	276	6301	12463	jwXJXKdJeKfyxxQuzojyx9eGDNxQ6F3JpBdarFMzn7BnUTW6Kfh	8434	11945	11945	1618089300000	orphaned
16603	3NKFoHdxibYkBAXquXuFJgSbYJqiYXt5uLhVx1am1TgquXxF4T7N	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	684	1226	277	6301	12463	jwBNtChAbrSrHor4D6vyDM62CcFbM6yLaCG8dwyQhrjcuWCNm7v	8436	11947	11947	1618089660000	orphaned
16613	3NKv4vF6TXfaZxggiYaJxQBWy2pm3ULwwrvJUvuTUv3FHUW2o2fy	16612	3NLkBNM8roKm1CPw8jnXXDvdWFba3nLvHaRdM81ij9V51sJ6RhQn	1406	1393	277	6301	12463	jwCWrx5VPCnFgN2xhxTSYvhUpcRNNQ9KP1eGxJ8sCyg8T4PNfkq	8439	11950	11950	1618090200000	canonical
16616	3NL4e9Z8quqUjMdm9N6RogRxSH9mdLjgY7DSTRF2V1Y7UtrGu7xQ	16614	3NLopZiJNuAqGcqhYVR61u2dhejKa8AafPRA58kmwBBXCLsH5Nqk	1560	1045	277	6301	12463	jwwuHVGCbQPgUG12mFN46hoA8cyMj86VLPgbvAmTntCdyVTVWBP	8441	11952	11952	1618090560000	canonical
16620	3NLBpu9wSazZdspETaXp3YBnnigAnTwzuXjJhvMU1d6eK9EB5djf	16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	1547	1132	277	6301	12463	jwFV16pVHUFWrQzz4pa7xnPEqyjHfkF1mKBGZjWzUGb43G98iho	8443	11954	11954	1618090920000	orphaned
16627	3NLcTFewKGW4GMGvBH8JaVBjGjbrVt4gN3hoAAEZYcEzBoM1xGFT	16626	3NKZxGHbjos2sW2AfUqnpxhj17HqMVEuVFVL2Usf9eCepWQ6Nyfs	1460	627	277	6301	12463	jxTrxRrUttb2JCPpaj5KrUUvg95gecULRGQwoAeDRKyUNEyqmfa	8446	11958	11958	1618091640000	canonical
16632	3NLY8pXP6Y3o6bXC19nukbgbKegX1jSLvsMRBKSwpxQUDDrsWqHY	16630	3NLfTiwmRPWjEHdGbqMBAaanyyYR9pn1FZmoAf1M3AVZwy9CStYk	606	1295	277	6301	12463	jxaTSgUgVhbbU9ahfubQ8Uvj9vbQZ5XKnBcBUTNF6YYhrcKf6oT	8449	11961	11961	1618092180000	orphaned
16634	3NLRcV1YHTmyRLnpBz6aRhCK21gEYuMKt75uDvyeWD9B95mwc1J9	16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	1407	1395	277	6301	12463	jxXaGhn7uKm4aLwGT4KkN6f9dqrrpKFad4GThXfgoLQFg3puDyS	8450	11962	11962	1618092360000	orphaned
16642	3NLunpLZ9f8ar2bVnPx67mkZRcUm4recK8CV289gsmS1P99Pjy39	16641	3NKAX3moqTPcY4cu4QAdWTRz6AfwQyPHtwSjNvvNHN2BKGD34mwZ	596	940	277	6301	12463	jwGDLEJmdYMXm2KRch4cpgaMeS2gDyok7GCU9pBZwFAjAZnMr7W	8456	11970	11970	1618093800000	orphaned
16645	3NLvkUAGAC6CMFbGU32UcLHpzkndr4vacdjkSvJYdoRePY1ZoG3F	16643	3NLDbgnyHGg6JjAksW4Bd4TYhbt8kHzwyMasKkCGeu7o5NCfMyDt	1406	1393	278	6301	12463	jxWsLJXed9MgHYKh5TDfXpiVinV2ji8PcuhiMT7mWFdRj12z9Yk	8457	11973	11973	1618094340000	orphaned
21620	3NLUR83Fb1jRJPiBaEH7RwUFrnyj9ZkohghMFqSp9CWSM6B1AojK	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1631	794	382	12463	13816	jxUrzxGCkgP4kepmMVVovyGUbqMFcNFNZc53ss89YNAGU74BMqb	10563	15251	15251	1618684380000	orphaned
22321	3NKWjnGMGmCbFrAQoLUSsZgMX3mvTwrKC82Vt6LqE7BkN2fU5fk2	22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	1420	403	412	12463	14440	jxagik14qcoDWNPdrckeFhyNKNtVJLEhiUPNoqKbJoBFMq6hxVX	11173	15731	15731	1618770780000	orphaned
22570	3NLqag9cDkQwxbtUD2EyZK5irkFKhZ6d15iWRLLWL2fLiJSCo1nS	22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	1467	1376	420	12463	14664	jwXHU8dWgzCxnVXYYctjVo9zifHY38ajjTS9MZyargjk8Jtubg2	11292	15895	15895	1618800300000	orphaned
16618	3NL2KS2Ruh2NK7S9Qa6ie1eDntCBizLJgoLfzPBouZ7xqFB2pRBv	16447	3NLThkEZKvcKMxzMY4ERo6he4A3VKpW41a8PCQasHR7gpfRzgNJA	1560	1045	273	6301	12395	jxv5Sj9oHsT8W75ppgwEZbottzEX1YVTeCQjVd1k16drbzCVDF3	8366	11952	11952	1618090644744	orphaned
16584	3NKfTBS1FvrZTTdu9g5fY8kzuKD6NmgKW9cWgHdg1Wk7aycxcZf8	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1490	908	276	6301	12463	jwPFob1sYVPR4pNrZnajXHSq1gt1wwUsEn594bkpg28CgKW1hum	8426	11936	11936	1618087680000	orphaned
16583	3NLrg7WAY1yMQsSRoNqUZaEqW42Cs97dC8AjLUZFjMbdDXhia5aZ	16577	3NKvWNe3m5zbNs9JusPapSq6RHtp6k5G3UokN53P6do5F1kQQ8wi	1581	778	276	6301	12463	jxLHmrmvSAAutt9N7pB6z5qs5ZU2vVU3wZUuoPY9ySWwYdTtKCx	8427	11936	11936	1618087680000	orphaned
16585	3NK9kv36rNKGN8nFxTXPQPVYkMCfRdeuSD7ADBJwiVPN3jqRRZ77	16580	3NL33eP7ysnervmRtixU3Co3AyRdb8PVPPRzxvnvdbNSWjhCtU7q	238	238	276	6301	12463	jxCzZjf689NRpTzsPDc7ncKxhz7rkg4gvuYCPfL1pY8XXEMT9DY	8428	11938	11938	1618088040000	canonical
16587	3NLRxjJm6EAEQ9p5H7ERrVckHqnXteaKZVPRfF3e6Xe5fWbngaMx	16585	3NK9kv36rNKGN8nFxTXPQPVYkMCfRdeuSD7ADBJwiVPN3jqRRZ77	1602	1003	276	6301	12463	jxq2cRZ6KSq1TTGkSL9oBd7cANQqjgoDTiEZZGu7PbrumWKCfSM	8429	11940	11940	1618088400000	orphaned
16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	16589	3NL35kSKR2p5RztMSyJSdAwJiCr9ejbywfs7jB1JCN2FsZ9FURGZ	684	684	276	6301	12463	jxEiPHZ8m7tsNgyA7PhTkYVsohEKyudzLp749cNDWEdswsvuD4U	8431	11942	11942	1618088760000	canonical
16592	3NKYv9ThMDVM3bKzquqrtA5jpMQdXzxTiTK9F2zUL2qHxpTtQRKR	16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	1405	867	276	6301	12463	jxUe811PLS4Ha5Rmq3x2yUhmBrKw1x8VCjxozD7QBwAbJa6Z4iS	8432	11943	11943	1618088940000	canonical
16593	3NLZCVsv6QLLttmyt3mPTibUVmdQnKcf84ZAKEkruUytezNKXW29	16590	3NKrYTvp1R7pWeBXpesLrzQDnuRK7XYDBp8LbuemQuCUeJTxTRXA	1657	1344	276	6301	12463	jwD7PWiVfzddFbJiHdEFQ5DubQZjnzHvCM2JW974TRgxZFQfSHc	8432	11943	11943	1618088940000	orphaned
16597	3NKnuQ5CUfZfrfYexmbms8jbGoKjoHudo9AtzBJ9tHEZQ6AfZgip	16592	3NKYv9ThMDVM3bKzquqrtA5jpMQdXzxTiTK9F2zUL2qHxpTtQRKR	1649	1383	276	6301	12463	jxmZWDAz1ufUegdF2TxjvfwWRCWSdFZQDEGJBGsmHGar3TBbLMS	8433	11944	11944	1618089120000	orphaned
16599	3NKR7eqEL1LPQiWPLGvrWAqYWRTpBTd9fV39hn3GJ9Mz2MucwgAa	16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	1522	956	276	6301	12463	jwJd1v9UHRgQ8N1cxntfWX2Qv9sui64HkcakrudSt3SDpRNCzor	8434	11945	11945	1618089300000	orphaned
16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	16600	3NLvzt17BqsovyHiC7ShQAF5noQp67NHY121qQHsABK84cEbtfzQ	1608	1163	277	6301	12463	jwgfSh65Z7bDhPGobE3VafLSRt3G2USBGbDUSLPRcKiUNoBx7Qg	8435	11946	11946	1618089480000	canonical
16604	3NK5BWh6vCfaEGFagpJ9NvmfidDEh1VwjgjPUgrM6YPoVEq3KgsB	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1490	1274	277	6301	12463	jwjwuzWJ9AUmZWXXL4Z5LiQJfzYBqzqXSCN93krksz8JgzmrKVt	8436	11947	11947	1618089660000	orphaned
16611	3NKXviatc5HxtwC3Aj54xS59C9N4vsmgXSDVsbzbvDJrmMhQqyA4	16602	3NLNN8FUu35niVhLULzJ1gAAHmvGbr9CgwHZFhkVSTw4J4NEGSLD	1406	1393	277	6301	12463	jwGZWpD5asjNRBr9hHDg1QV5P9iuz8tEMhUW4rJrwdxYHiCn15L	8437	11948	11948	1618089840000	canonical
16612	3NLkBNM8roKm1CPw8jnXXDvdWFba3nLvHaRdM81ij9V51sJ6RhQn	16611	3NKXviatc5HxtwC3Aj54xS59C9N4vsmgXSDVsbzbvDJrmMhQqyA4	1657	1218	277	6301	12463	jwah4V7Tbb4rbofPFeMiZL9eanSjUAaNQsFxkMNKbH2vUJ52wDq	8438	11949	11949	1618090020000	canonical
16614	3NLopZiJNuAqGcqhYVR61u2dhejKa8AafPRA58kmwBBXCLsH5Nqk	16613	3NKv4vF6TXfaZxggiYaJxQBWy2pm3ULwwrvJUvuTUv3FHUW2o2fy	1622	1356	277	6301	12463	jxZMhYSgP8kgUGybpCz32p6ShSXzi6ddBMW8UiScCm5ujzsTMRX	8440	11951	11951	1618090380000	canonical
16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	16616	3NL4e9Z8quqUjMdm9N6RogRxSH9mdLjgY7DSTRF2V1Y7UtrGu7xQ	1553	775	277	6301	12463	jxndRA5ZcMJNsqnCCYrRTCFdKenwgGtSaNtnYS2TcprXaDsDsP1	8442	11953	11953	1618090740000	canonical
16621	3NLC5Q61EkwrAdXgg7A9wSarwFNLixGmZ9rkyQriE9bYhMCcSN5Z	16619	3NKSBqdarcWZBe413aKuKNtDU9cpnQAVavW6osoxHMFvfSduc6VK	667	667	277	6301	12463	jxZhHL2FGyfYs5XsuRhdgKLDhDP2Fa5Z73CGNbaBzFyRGYsSjo1	8443	11954	11954	1618090920000	canonical
16625	3NLGzreTjX2uggQWsc3mRVu9RmahwYqZVJmdwLGQgfQ89Lrwr1yS	16624	3NKFMGoQMbkHn5Gyqw17vdaoqQxw9EKdMixFGbQPhNPreqEGhR9a	563	1359	277	6301	12463	jwVUbdEXLWL8sh8mzmXkUbevACwJ8Ugqv8f47MMtQ54GpqevoTm	8445	11956	11956	1618091280000	orphaned
16628	3NKQLFy8TVz1i2LiAcBB295Wjm6ih5C3DspgP2JBib1kmz89gMVm	16627	3NLcTFewKGW4GMGvBH8JaVBjGjbrVt4gN3hoAAEZYcEzBoM1xGFT	44	1325	277	6301	12463	jxKZq573TsnqkHCRj2vt911SdXX7gMs312mkbqQjXd3vMiAm7h9	8447	11959	11959	1618091820000	canonical
16630	3NLfTiwmRPWjEHdGbqMBAaanyyYR9pn1FZmoAf1M3AVZwy9CStYk	16628	3NKQLFy8TVz1i2LiAcBB295Wjm6ih5C3DspgP2JBib1kmz89gMVm	1403	812	277	6301	12463	jwVGbWu9puQ1P7hQbMGSJwV98b4Me6n8xKimGaqYZ9kXMzmkPXL	8448	11960	11960	1618092000000	canonical
16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	16630	3NLfTiwmRPWjEHdGbqMBAaanyyYR9pn1FZmoAf1M3AVZwy9CStYk	606	1295	277	6301	12463	jx67QuY2sYaN7ss3omMgiWLoHSY5YKQMYpWgYHNNWMokw5kRM2M	8449	11961	11961	1618092180000	canonical
16635	3NKAeu1iWLbgKZ8HVqY81haSJgnb3tbsaAbbzpRfVUEDGRnpxKwV	16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	1549	1236	277	6301	12463	jwWif5sxGjJ9qbjMXvGVsaP7ZL2VfMsqzJA1QT3jkP5TxTmstFz	8450	11962	11962	1618092360000	canonical
16633	3NK93cLoGmmzue724tj4k4n3kx5R8cD51FK2hfWiSrnwXqzyLu4n	16631	3NL4gJunPCuRvXFyN4mUR1aQoyUS7kmMKjL6VfmaYRoo3czFc8L2	1546	973	277	6301	12463	jwWV74RRKw54eS2boYMBvaqucaagsw9SiwGrB5N6MzFcRJZj6oJ	8450	11962	11962	1618092360000	orphaned
16637	3NL1e2R6JpfH6oxHF867ZEVSjECjVKNfwt9HQpD6JXWq2ErSJXii	16636	3NL2ea3mSh7rpawYwJUbB2qhrJ5TVW4QhrLjpk4W8Jmr1YVinvAh	1407	1395	277	6301	12463	jw8PwFDMXeXqpmMZiDvHa6PNRQFnZdrxDfwUW6u2iZSp1PB4YJW	8452	11964	11964	1618092720000	canonical
16638	3NK811nG1hSP9MDGKfcU1Ve5oLBA8jHJGy85Qw98qfgDBmmM4iAm	16637	3NL1e2R6JpfH6oxHF867ZEVSjECjVKNfwt9HQpD6JXWq2ErSJXii	1406	1393	277	6301	12463	jwH8vUUa4tFNipJPTVojeoq6QJaavJH91h3PdgS99keBvpASiQE	8453	11966	11966	1618093080000	canonical
16640	3NLRcRZ9EZ29wWUDdXHR46o3kCnDRmx3mYuQZNY1vF1vb2qUy2PQ	16638	3NK811nG1hSP9MDGKfcU1Ve5oLBA8jHJGy85Qw98qfgDBmmM4iAm	1670	1282	277	6301	12463	jx6Up4gsuzV5sqVybjjcgnFiVx49G4ScacA3rNYmoQiLaTzCBp2	8454	11967	11967	1618093260000	canonical
16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	1581	778	278	6301	12463	jwi3BfDKkYoJtBpgJGfh6zU5YH5KUbMakqoBvnJYkUEBfG4jP1U	8460	11976	11976	1618094880000	canonical
21021	3NKeMvFLaXBhC73byugxJV37pQJpDsxJQHZjGeBqexZ59WueNkCA	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1509	1320	383	12463	13292	jwoFoqM6U6XsyaLpm2rmscvdqTwcAkSFjfBGiPmovD7LFyBScqH	10569	14885	14885	1618618500000	orphaned
16636	3NL2ea3mSh7rpawYwJUbB2qhrJ5TVW4QhrLjpk4W8Jmr1YVinvAh	16635	3NKAeu1iWLbgKZ8HVqY81haSJgnb3tbsaAbbzpRfVUEDGRnpxKwV	1571	1335	277	6301	12463	jwm7CmVY9dUUuj46N91WaUFrSHHiJSJaAjkqWgFLE2gFYrG53Tw	8451	11963	11963	1618092540000	canonical
16639	3NKHThymNh5pgM33obYThH6y9oGYR1ReBUffGkWBq9QYGb5uLtSQ	16637	3NL1e2R6JpfH6oxHF867ZEVSjECjVKNfwt9HQpD6JXWq2ErSJXii	1553	776	277	6301	12463	jwGHGPiLYNbsHuXgR4ZXNVLd7qH5QR4sw2CPwiduuemB96yTBmj	8453	11966	11966	1618093080000	orphaned
16641	3NKAX3moqTPcY4cu4QAdWTRz6AfwQyPHtwSjNvvNHN2BKGD34mwZ	16640	3NLRcRZ9EZ29wWUDdXHR46o3kCnDRmx3mYuQZNY1vF1vb2qUy2PQ	1419	814	277	6301	12463	jxeM1DHVWR61v9r7ucCn9ohqLgQmwA91v5ospRveZXoSDLiNySJ	8455	11968	11968	1618093440000	canonical
16643	3NLDbgnyHGg6JjAksW4Bd4TYhbt8kHzwyMasKkCGeu7o5NCfMyDt	16641	3NKAX3moqTPcY4cu4QAdWTRz6AfwQyPHtwSjNvvNHN2BKGD34mwZ	1406	1393	277	6301	12463	jwCQN84D9sgr98kQn57PE4wPfemDe73xXUgjvFofn5kQsrKKSeB	8456	11970	11970	1618093800000	canonical
16644	3NLAH26x6zZsM9K7WztnjWLRXHNT81Tt7i17VQB4bWxvj7wfXjbS	16643	3NLDbgnyHGg6JjAksW4Bd4TYhbt8kHzwyMasKkCGeu7o5NCfMyDt	1637	816	278	6301	12463	jx7DoXQNmHuAsSPLaEaB1V4zGyW9DyRJJHKGM63PWuJt2DmnMPy	8457	11972	11972	1618094160000	canonical
16646	3NKZMfaxJqQKhJAiWzibzXYAGsbKY3vExQTJhkZELFBYEkz2TVqo	16644	3NLAH26x6zZsM9K7WztnjWLRXHNT81Tt7i17VQB4bWxvj7wfXjbS	1406	1393	278	6301	12463	jwHJrE6eRedVopkXEo1eWBgvq9P2XeKHgfsEqHuKv6DR1DRhSnT	8458	11973	11973	1618094375206	canonical
16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	16646	3NKZMfaxJqQKhJAiWzibzXYAGsbKY3vExQTJhkZELFBYEkz2TVqo	1407	1395	278	6301	12463	jx6L4Rik68ZJWe3qQhzK7McdzaJy3yqvBMd7v9cpmq95RKopAdb	8459	11974	11974	1618094520000	canonical
16649	3NKHuVxtAAantxExA4QgwTR9iKz6xqK12NSdeGYX5E9MRapr7nGT	16646	3NKZMfaxJqQKhJAiWzibzXYAGsbKY3vExQTJhkZELFBYEkz2TVqo	1634	1331	278	6301	12463	jwsLACyqwxitwru5JVGEL1Nt8DJHa8YnzN8F2orMeNebxfc2YAg	8459	11974	11974	1618094520000	orphaned
16653	3NKmFB1B7UkmdeqNkf4E3dzMkiKVCnEFBFxAZ23jszknzSni2Vgt	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1588	1392	278	6301	12463	jx9TowEdjHhYSizXJ7LDtrGqTp9tWhwFfUG1WxBCjFFuh3XTwzJ	8461	11978	11978	1618095240000	orphaned
16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	16657	3NKdCnwPENrToUYsPYoBfa8QDjGDFCjW8kexhJuEp4n3VbjKczFP	1402	876	278	6301	12463	jweHhJ3bPM73vaZcXhygQE4pFVSHuzEUUoVB9U6UG8RpKYMrwt6	8463	11980	11980	1618095600000	canonical
16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	1643	1299	278	6301	12463	jx1EvFvLsPvXF81bFjnB2HdyeB7q6WqHnJUY58auXrhPdDX39YV	8464	11983	11983	1618096140000	canonical
16659	3NLt9p4b5EUYA3wJo3SAoqtx8YEvoH8DRYUuNRW6czvZ1E5axFKt	16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	1541	1298	278	6301	12463	jw6jFUuj7aGWoKqHJm5yvLuC55YVwhriJAVb3kieCuiKYEJ4oJm	8464	11983	11983	1618096140000	orphaned
16665	3NLChzrehTfvi1q6eeY92SLYPbMuBmj6jBdPUmdbbHPsjy6XA1bd	16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	1635	321	278	6301	12463	jwGXxymnjcfLKDh91aYCh7qZTxJek3BSMYgBYeEvBwjKtrt3rcK	8465	11984	11984	1618096320000	canonical
16663	3NKyifpPBkTyeSGuZStQJ99G4DnDxbSLdpDGExLKbbYZ9Gd2m1Dx	16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	1406	1393	278	6301	12463	jxsmDmKu2HbBz9XrMeWeALp8Kfdcp7DGtiTYfiYy3FsYqaDX1TE	8465	11984	11984	1618096320000	orphaned
16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	16666	3NKJ47hnEojCY85cqQf82X4jBzzw1B8Fks2wugmJjHBZaSdZvex8	1509	1074	278	6301	12463	jxAWHZnTBGx1CWARUJ7yMHohfw97CzeByxBJ7DMF7BRKRrEx1D5	8467	11986	11986	1618096680000	canonical
16670	3NLHnogWWQoHA8Pneg2UQMqLQKXoWqTKHW7x4UfwXwiNQ2bJDz4R	16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	1407	1395	278	6301	12463	jwre8pHMiUTtfTxrGXvyNWCV11b5GLbxBKVfzEUrrBTbwqGHkM7	8468	11987	11987	1618096860000	canonical
16672	3NKg7fyTWmuRspRnLcKmc6pai6XGEdKePoKSEWsd8p551MKfuzBY	16670	3NLHnogWWQoHA8Pneg2UQMqLQKXoWqTKHW7x4UfwXwiNQ2bJDz4R	1553	776	278	6301	12463	jwXLTqXoHY7rF7dKPba7Y1aJUWSjJwWFks5GeFJWQz34ZQZ9CpV	8469	11989	11989	1618097220000	orphaned
16675	3NL8HCauwHB2fBpC4gpwqKc515BnqM2sygUanA5xcHVSpiVYpTDV	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	1439	1279	278	6301	12463	jxtznad1jJQpf6SHEKtS181MXYkXD5j3VjL1Yjj7aTroBcoCj35	8470	11991	11991	1618097580000	orphaned
16677	3NLspqhjPHr3mQaKLBRnewJu2dHtceHeKmoBBNamrtnPE4ahv4CU	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	1631	794	278	6301	12463	jxAnEJ69tjphWyc364eZZx9M4rteuAxGpsXkkwR5i7q9nRt8NJg	8470	11991	11991	1618097580000	orphaned
16679	3NLwkjqrPY4ETBxJmuatvWKnhEv7XvjrBJNiRqxcmDXbLP64aV2y	16676	3NKdJ68pHutKhkA1gLidivnthjeyyUTABSTxR4ei2ZxUe9Cn5qDg	1403	824	278	6301	12463	jxXfunyccm3MZLnMyd1BFqV82jMQWBe9UKu4hW5LXadM18J5pXZ	8471	11992	11992	1618097760000	canonical
16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	16681	3NKxJAptYSxMz6edQkdU7ZPiDkNBXmeVY8JQwQtJM2ic2ddyFdbT	1457	1391	278	6301	12463	jxTvAV1rkvXCNMe3hMNu9rNCS46VwXs2jGy174WoKmA4kCRRPrg	8474	11998	11998	1618098840000	canonical
16682	3NLvW6PTVRT2Mfo8PdhSgS7MZUqB41VfdemHhtFXy7Gw9AwvGJDC	16681	3NKxJAptYSxMz6edQkdU7ZPiDkNBXmeVY8JQwQtJM2ic2ddyFdbT	1407	1395	278	6301	12463	jwh1JnTofa7xYmYoEcfERpVhyS8RF2ko3PUxC4pgWgMVyW7euvq	8474	11998	11998	1618098840000	orphaned
16685	3NL2t8M22gEdhWjCAD4ZRGos1rZbhHv3w5WH9mmq778E1daLbr5x	16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	1541	1298	279	6301	12463	jy1dyrQC4aLoder34jEVUi3yNhZmDqrNDiyeoxyeMLE77C9EwmN	8475	11999	11999	1618099020000	canonical
16686	3NLXkRo4s7WPW3iSauoQBDp3PjFZkzoaLCwXZ24zdN57RT5coc7k	16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	643	643	279	6301	12463	jwuS73DuN8mRJJPnfmom3KnapvUg3s1Db1rpWjkxuLFXazbNmea	8475	12004	12004	1618099920000	orphaned
16688	3NL96KTnD3d1bTgvUjNdWa1X9qs6KE3geufQR4SXhVRksSTiWS6p	16685	3NL2t8M22gEdhWjCAD4ZRGos1rZbhHv3w5WH9mmq778E1daLbr5x	643	643	279	6301	12463	jwUhjiQXd829im16q2QCGuvQXG9XWSDxQtXzAFr8RQKG96KbKjf	8476	12004	12004	1618099920000	canonical
16691	3NKeh1CZorqsb9TUcmuG6CkCSGP6bivCNFnMgEHqLQpDWWkPXJbX	16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	1578	1050	279	6301	12463	jxm6Ypr6wmvs4uDKWnUwBtyEJWakckMgqySH9snBXP1QcPNvKem	8478	12008	12008	1618100640000	orphaned
16693	3NKbVwjQc2JAfKF8c6Re1CamjxxtqZPkLua2k2ZCW7WY28s1VW7n	16692	3NKkiw4i441mAXeGncQa1h1UtwgErRY99DTBzMvweENRHvETyVUc	1397	838	279	6301	12463	jxpKsNmGXnjRStLn3MB8GjjjQnKYBLSE8qFAdtqVjQ71zj7AvWK	8479	12009	12009	1618100820000	canonical
16695	3NLK4gK8QSAHc2thbrWo8SYYQboCfKJrj1PhQAP3MAQjXcSc96Qf	16693	3NKbVwjQc2JAfKF8c6Re1CamjxxtqZPkLua2k2ZCW7WY28s1VW7n	1403	824	279	6301	12463	jwhbbaerY2D6PQ6qX7LU1nubgu7CCUvr5wp9Uh2JytteN69JaqY	8480	12010	12010	1618101000000	canonical
16699	3NLf2oGXeP65JeAq5FExUcCV87PJ9ktU6TagLPNLPA5aNGZMtz5F	16698	3NKnggaMX155tU6pbP7brrpr5CTDfa3fi4UdqfCVqYoWWCoSef8r	1419	814	279	6301	12463	jwCAvLxQdDn8dfxgX6QdkwYe6strTC8evPSvBJgu4mF1hU32xpr	8484	12016	12016	1618102080000	canonical
21025	3NLRDF69UsAPbWoW3rg36n88U6XLbYthYjM4DVr3oizDBswg9ydC	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1407	1395	383	12463	13294	jxTYzQk8RVdNtVyLxvjjKTqYEAsJAjgog1M5PcLh5Ty1Ai6HQsS	10569	14885	14885	1618618500000	orphaned
16756	3NK6VgufhrQiM22hY99r7whXsteGgeCC4tRggEHWC3v98ZExCFCk	16687	3NLc2SWcwke8uFTYABaZ311tv4hqckPWuyiukfYZL1zWW8EKD9oX	1564	1338	274	6301	12426	jwx2Xm616EADkikJRhUMUPCixEtzcK4xe6xzZBhWk3NbDExLwC9	8384	12047	12047	1618107660000	orphaned
16744	3NLVHjwLrcn2p1nKmnUfQ6y86wXNGW5ckwtSyWZiMohBgJHjMga1	16521	3NKeKRnRpNVsMdZUzWbkxMVF68bbCsYTsu4FYWXcY8uddZHNd3B6	1430	296	275	6301	12459	jwBR9NX7M9P9UpXNP2Soo3Syb2HEkhUSruYpNq7QXNLjJu7g2LP	8404	12040	12040	1618106400000	orphaned
16709	3NKqte8h5ynaoh1BAoWf6vKG5Fm7RbxL2spFXRka5juCBxrPBNCF	16575	3NKsjgT3wCNegdFDwgK8s2apC4t1cU3qGjKcsKjfbGHBJpyiYjRb	1471	1386	276	6301	12463	jxrYMsPYnLhytyxPVZiLExz2hq7GtcGP6XXR1i1xzocnCbQCEW4	8426	12022	12022	1618103160000	orphaned
16707	3NLnWeR7qdKmNFEFMLKjRrU4TH1LY1Q9sgENKK2QZNk5JpaFumiW	16610	3NLmFa4oMfms2iFHwd1n7oXgM1HeP1EwwNAXR3mDrziCihGidBzx	1490	1028	276	6301	12463	jxi3aCU9HTiRrmTj2bCtT8ajtgGZ4Y455ttPaPBBeTic5TurEhJ	8428	12021	12021	1618102980000	orphaned
16647	3NLFxaz9fPqs9Yvsf3ihd3moyPKaHMKmdcunVsJq98vu9C3XHFdX	16645	3NLvkUAGAC6CMFbGU32UcLHpzkndr4vacdjkSvJYdoRePY1ZoG3F	1403	824	278	6301	12463	jwAETPSScguyQUNXeoEVbn7RnfNpNN36L2Whm5DRWU2SDRrdSkj	8458	11974	11974	1618094520000	orphaned
16656	3NLBRyYU166BjBoys7DL5DqHehy1HNzXc5Xh8hwN4MLeSTDocfrU	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1650	1249	278	6301	12463	jxivRLNodbb8uoXi2Je6gxUP4c1pPdup3wqTPBcShXJyv69e3ia	8461	11978	11978	1618095240000	canonical
16652	3NKmf6axuZANzcLKdKKrb8czYyXXN1PChPYnS5AQZGCmWusxdeko	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1527	1047	278	6301	12463	jxcKgrrEGFwHy5xcojrqCk3Uf9S8a75Ev5kfx45TuND2QrTbQie	8461	11978	11978	1618095240000	orphaned
16660	3NLeDtTDgvBh4fej4FtxNAWGduLnsu5AprFKeWj16o6KCRmntbwn	16658	3NKq1dAGEWBskBLLp38qnPiLVZwwz5oqyDnCeTKrDHRg7gg67Zn4	1541	1298	278	6301	12463	jxJGpfgpt36sUrg9CXY5BLaV3kiQNxUyz8YAmszMDEKmKKFy5oY	8464	11983	11983	1618096140000	orphaned
16666	3NKJ47hnEojCY85cqQf82X4jBzzw1B8Fks2wugmJjHBZaSdZvex8	16665	3NLChzrehTfvi1q6eeY92SLYPbMuBmj6jBdPUmdbbHPsjy6XA1bd	1445	1164	278	6301	12463	jwGvnCZ5JpQoix4ZwhX1ABRFRRi3S15s6NgsUMS5LKGTswDzcEr	8466	11985	11985	1618096500000	canonical
16668	3NLStL4DhMs5dT6DwvpekH9BQwXzGpgEVkfSnFpASs8Pj1kB7xge	16665	3NLChzrehTfvi1q6eeY92SLYPbMuBmj6jBdPUmdbbHPsjy6XA1bd	1403	824	278	6301	12463	jwArwWjKvSR1kdUH12k8sKLy6X2sciWCrEHNyZCybFsS92sQS7E	8466	11986	11986	1618096680000	orphaned
16671	3NKR5GMBxVfqA2tABAyVGuQY1huFKnJGowHv5cMmVbUWraumQzHd	16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	1590	1054	278	6301	12463	jxWsAqg9tLEJGtse5ajHmUa8kdcoqScyxdVEW5bey4JQARq1314	8468	11987	11987	1618096860000	orphaned
16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	16670	3NLHnogWWQoHA8Pneg2UQMqLQKXoWqTKHW7x4UfwXwiNQ2bJDz4R	1652	1315	278	6301	12463	jwPqEBiqaJRxBeaxody1eQBcR257tH3p1hPFSpwSpy18bNYyQQn	8469	11989	11989	1618097220000	canonical
16680	3NK9RTkLs8R3dK5iqFMQghXtFbysBLpuQFZPiT29E4Ngdq6sUVni	16679	3NLwkjqrPY4ETBxJmuatvWKnhEv7XvjrBJNiRqxcmDXbLP64aV2y	1573	1318	278	6301	12463	jwjrK6sePdwzzxrCjnfy93QPArDwF3NkG71TdVjHCn2xjRTjXgL	8472	11993	11993	1618097940000	canonical
16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	16688	3NL96KTnD3d1bTgvUjNdWa1X9qs6KE3geufQR4SXhVRksSTiWS6p	1419	814	279	6301	12463	jxnVWFsfWKShve5rvkfzQ5AdQQhtJPKR5qKb7yAqshbC2H9Y4mm	8477	12006	12006	1618100280000	canonical
16694	3NKZranY1JZa3R8daEd8Nj2cHF2b22AMHSW2FReZPZAk2GmqaUZr	16693	3NKbVwjQc2JAfKF8c6Re1CamjxxtqZPkLua2k2ZCW7WY28s1VW7n	1483	201	279	6301	12463	jwbeg7bC4r6Eoddduc51twotmusYufe8E7VKzy5e5nC42PHkv8U	8480	12010	12010	1618101000000	orphaned
16697	3NKYaYgs2qh5qjxEV7PSDNs8AVPxJ4ZbgVfK8pyQSFtHWRf8pyZs	16696	3NKWmF3LkGn7cEFMdD5nFbfvx2iFEnnELHPGmSZ1iU8mZngcA14B	1675	1096	279	6301	12463	jwf2BUVUwHFYBoPbft4ymQ9da5VHkWB9XcupKKbW2E6Q8Haq6u1	8482	12014	12014	1618101720000	canonical
16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	16699	3NLf2oGXeP65JeAq5FExUcCV87PJ9ktU6TagLPNLPA5aNGZMtz5F	1587	1357	279	6301	12463	jx8S2vNz9VyLtvLvfYHSR8iZd44oUz1zSgB97TLVU7bsw56yjTy	8485	12017	12017	1618102260000	canonical
16702	3NL3rAGZpibddVNymzGZbwiiRBjSr37Ctg2udDGJksPGpn9NXL3R	16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	1555	1347	279	6301	12463	jxYAUiXqebb5UwpEum2bkovrwmLqYQJddKUWxUYCGhVfGfrSYUt	8486	12018	12018	1618102440000	orphaned
16708	3NLS4pzeBrEyYgBZpNpk7onauYXEGMqQRKj4uw319rDeLRH8bQQg	16705	3NLTLsjf7BV2hivQ3hzeMUKoc5dS1oNNb2P7nELRsAHN29zAoieH	1471	1386	279	6301	12463	jwmhN9pgyn9MeGFLsK797TZ6MBVKNtif2Xv7uNeAqSqowxVim5M	8489	12022	12022	1618103160000	canonical
16718	3NLSoVk9Ku63NqPvRSTNo2ztLwuuMKwLSaUAZJ58ULqg3Q1CPPdY	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1440	1131	279	6301	12463	jwHZUCs5TpT5yGLMznCe3Jvesxqn2oeCnpXV8CDFBGgu6fyWV3r	8492	12027	12027	1618104060000	canonical
16713	3NK66deqAEaM7wbmsZuzTHau5VC2PyXxQRVGWDQPj98KCaNPwE4v	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1560	1045	279	6301	12463	jxrCVSPu6kBDw3AVbDiF1Kww32WWcMyARY7sTbeph2APdCAu1cp	8492	12027	12027	1618104060000	orphaned
16727	3NLWTiKb3WSpE3Tv341uRvNkzb6pouiHycQ2oyuDKxqtLrbbZJsj	16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	1407	1395	280	6301	12463	jy2qQBshtJF77Ym3sFAoFw83cK2o27VRgapQUyN5oDa9tX8k1aV	8495	12033	12033	1618105140000	orphaned
16728	3NKrN5kT3rUZi1HhYDqBpynFK2xhu1eqtm492wMBKxrr3Si7Mavw	16726	3NKaD4HZBF2iUyHZpJYpPDgeqUBZmtsFNxsi3EC93r5N1JYimS8q	1553	776	280	6301	12463	jwgN2SAaz7HfS5X5Kz4iTNwMe4g3etcDMGX6P3CRX6FvaVrAaHu	8496	12034	12034	1618105320000	canonical
16734	3NLf45CMjQcjZAd9HPDdGQQZaxukrezmtbqfhydfHrY6Ji3gFw51	16733	3NKUCZX9Eg6s2nofVuzbRiqmdPFWzmkgfjd7VTwR3vYx389bhinr	1447	1345	280	6301	12463	jwLrs1zsTWZmhaMuCUj1q1C8AQ3AkqDBSFfqLJS7t7AS1ZhTRWA	8499	12037	12037	1618105860000	orphaned
16736	3NL5j7TEJuMTnK9RiVMyfwaWuQPDdf2cWoJY3Z2vz97VvQnkQ3Nm	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1523	1075	280	6301	12463	jwTRupadyRkjyiqPqsAobPNd6ubNetcnXVWqvRAbgaJdQCxwxAF	8500	12038	12038	1618106040000	orphaned
16741	3NKybSVGQERdS25GAGvygn1WRuhrwgvyHCxcHqHycxNjdn1BHkKz	16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	1600	1372	280	6301	12463	jxBbbeY8T2dqfeDmdkKkVXWBf68hNZKBgN3P4ZtdARHLD3VdYoA	8501	12040	12040	1618106400000	orphaned
16746	3NLJyDB7S9DXUi2Jca8oQVUXSicCgsEbuqGaTXjrfQviGmJAW6uK	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1407	1395	280	6301	12463	jy2WR9brcEyxa5x17vgNdR2TvEkDxpnQU5EnMqLfT3jTfbNWGfi	8502	12043	12043	1618106940000	orphaned
16750	3NLFBs178ezZWv3ZAQjm38dUAhqjYRmCzXvChvQGwNe2kTKZM2BN	16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	1460	1324	280	6301	12463	jxjc9enQYFJUzatAGKXuhZnuDbtC1gukvPLQSAEg7X93TBfqFQ6	8503	12044	12044	1618107120000	orphaned
16752	3NLHT1tQjzZcunEFRWjEFPDNdpR5wBgsdCLxm2yqRuTZoc4JsvPk	16751	3NLvAcTBsRW9u5uo7RWRoTwEkD4fGE2AaDvtB1NkupsGgUdWVsDd	311	1181	280	6301	12463	jxsRLuKitYxKyEpogAqeMnzJmQxpGwRrHMqL9xBguSNqgurWhmy	8504	12045	12045	1618107300000	canonical
21027	3NKtbyicT1yaxagZiR5APtTk1RHEENKbcWzG2eGpu2ApsUdD7rmj	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1607	1348	383	12463	13293	jxmkCxY5TQYsAZbZ6JBT97WAn1344qg4Aa4yaFH8BvwfCCLrjWW	10569	14885	14885	1618618500000	orphaned
16729	3NKdAACyLUNj7mefSnSPgk5wj2AkqjBB63VMyf6dS14sx2Wommjb	16662	3NKch96WaqyYa7eapYa7hsZs92aWUfZqCGBq9bue8A7hecRZ6B9u	576	1355	271	6301	12347	jxQ7VLqsKKARDXvdyPCQGGqZ7moXgKMcc2ogMTnqQnbQ895NGra	8336	12035	12035	1618105500000	orphaned
16657	3NKdCnwPENrToUYsPYoBfa8QDjGDFCjW8kexhJuEp4n3VbjKczFP	16656	3NLBRyYU166BjBoys7DL5DqHehy1HNzXc5Xh8hwN4MLeSTDocfrU	1506	1127	278	6301	12463	jwqwMKujfK5gZrmWT1rEUHm2LxU5kAK9dBjzZTA77LARyah9BGa	8462	11979	11979	1618095420000	canonical
16664	3NKDYTx2Yyr955LpXM1YBa85UTtzEnxfRCcnTTv55Qn8Qgxq8d4h	16661	3NKd8YmX8qrSauRQ6fYbw3cwcGwjbHNv13kEfZHNuL7rR6vsYNAC	576	1109	278	6301	12463	jwGZUVc35RJvLwLsgEENUcFy1P5nxcswdxjrkSoXLXM6RcDYizR	8465	11984	11984	1618096320000	orphaned
16669	3NKGDzp1uiVtWjzXeUhqcsg8J7ZHdjmTKCapkX7HAshtX2eLk889	16667	3NLe8pM1WZhM9vW3ST3u7pjqPwSVNFi2Gw5GeGu6tWkMnBozmmHM	1406	1393	278	6301	12463	jxYHU65UiG7A7zuAUYcBiDMrKMoYau7m3TXSAVqsr3cydarPV7P	8468	11987	11987	1618096860000	orphaned
16676	3NKdJ68pHutKhkA1gLidivnthjeyyUTABSTxR4ei2ZxUe9Cn5qDg	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	152	1330	278	6301	12463	jwRYeoYjmp2FNmGVmo9gckDopWAwYh7Jt1M1h7At1oLPnQpmxvC	8470	11991	11991	1618097580000	canonical
16674	3NKgHAV1bjjteHJKjkgMjVhw7DgnNL5U9H1CYEN6hTspP8VnJfki	16673	3NKG21t3EHek22Jx4HtaEy1Ur4jzDXD12yM5NghDfPPUJEbFXQoe	1668	1124	278	6301	12463	jxNEmeyX6MnNts3JnQFitfEbb4RRubJK7rEgQYtaeCMASUsJVTS	8470	11991	11991	1618097580000	orphaned
16678	3NLTXotFbpYwQdBiDrh3Q2zb9CXvcRy8h4yN2mopAbzHJpNY9ioH	16676	3NKdJ68pHutKhkA1gLidivnthjeyyUTABSTxR4ei2ZxUe9Cn5qDg	1407	1395	278	6301	12463	jwHyhPub1rrAv9whjX9WfbGUkj345qbgBFHMLgBgGAi32Dbi5vH	8471	11992	11992	1618097760000	orphaned
16681	3NKxJAptYSxMz6edQkdU7ZPiDkNBXmeVY8JQwQtJM2ic2ddyFdbT	16680	3NK9RTkLs8R3dK5iqFMQghXtFbysBLpuQFZPiT29E4Ngdq6sUVni	1547	1378	278	6301	12463	jwFEYEryRH3ZkR1uhvmZw93bM9Fq3TrexMmFT7Zydyngvmesx1G	8473	11996	11996	1618098480000	canonical
16692	3NKkiw4i441mAXeGncQa1h1UtwgErRY99DTBzMvweENRHvETyVUc	16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	1407	1395	279	6301	12463	jx2FXxvN5SwxfDFGmfRYcb3iZYmwGDGWAuJcJNN7jGWAXb3sR9F	8478	12008	12008	1618100640000	canonical
16690	3NKDSpkT6VU4YdTeKW3Hk859YzPqbbkh1M2B1cGcN234X4epy6Jo	16689	3NLSyQCTiLVunTMv2d5XXnWhPciNgQP1FuQYK62vnKMLVPXaaFjn	1422	1091	279	6301	12463	jwRwh3psTsCgm6GmeNBAwXM2KLc6yQnA4x4Ur8EHqfesz7dpcm8	8478	12008	12008	1618100640000	orphaned
16698	3NKnggaMX155tU6pbP7brrpr5CTDfa3fi4UdqfCVqYoWWCoSef8r	16697	3NKYaYgs2qh5qjxEV7PSDNs8AVPxJ4ZbgVfK8pyQSFtHWRf8pyZs	1406	1393	279	6301	12463	jxjUFCXkwkScSJhx8pBDeJCBrUkwUPZ43yBppYmqHhdwQD4CLgo	8483	12015	12015	1618101900000	canonical
16703	3NKNZ32Ane7ZQ4qbYo24mvnC1qg4au3Q8BzxPjgd71Rj4TSkTftt	16701	3NLiwjETm7S56WiTiyocT9A51x6ghquo4oaomtaivL2Sj5MrW2ma	1571	1335	279	6301	12463	jxjg92wEu1y2hmhfgSGhkFToAh658JxnuEfGu3TDwpmerd5r4Mn	8487	12019	12019	1618102620000	orphaned
16705	3NLTLsjf7BV2hivQ3hzeMUKoc5dS1oNNb2P7nELRsAHN29zAoieH	16704	3NLkSAXsVQMf84TXELK9pqSuzqhNugjqjiZzdUfZVj8N1cEaGfWR	1490	1028	279	6301	12463	jxXiwjF2BP6efjvcmt6z9QAghAqemtfeyaK12y2yZ2vqdphRREV	8488	12021	12021	1618102980000	canonical
16706	3NLjheEzzbHABKpNc6KiWtXste769EVYC3jEz2GCgL9Ni4pW2VaN	16704	3NLkSAXsVQMf84TXELK9pqSuzqhNugjqjiZzdUfZVj8N1cEaGfWR	1406	1393	279	6301	12463	jxg7TUe8TbRNGytaeFkgWhahUsr2ojD19RNu5ihapjwjwiTo3rR	8488	12021	12021	1618102980000	orphaned
16710	3NLqki3JsEUrWmFn698Hkz5yVcxBeLjb7WjiuWgSmxfsw3Hqkru2	16708	3NLS4pzeBrEyYgBZpNpk7onauYXEGMqQRKj4uw319rDeLRH8bQQg	1581	778	279	6301	12463	jwn9vgJ6EY1AkZ65cJuE8HgNYqpikaKF6YnqHFfcmkqpaN4CaZD	8490	12025	12025	1618103700000	canonical
16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	16710	3NLqki3JsEUrWmFn698Hkz5yVcxBeLjb7WjiuWgSmxfsw3Hqkru2	1579	1389	279	6301	12463	jwZhvFShgcMShCBhk4ZwNFc5BpiqH8YnYFG5h68iSvshf48gKZV	8491	12026	12026	1618103880000	canonical
16719	3NLfEZKFXzjGFiswRJmR3SjQ8172A2HvRHu9ssXHjs7DkgW1aSdP	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1560	1045	279	6301	12463	jx517uQPoEHZUaZdbRajgQfhLypwAUy3or6wT3LBF3xxgzK6zo9	8492	12027	12027	1618104060000	orphaned
16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	16720	3NKTo79K5XBYq27J8Giigg6PyKoKkGcoAk6pHK52daQD2kDPZ36C	641	1336	280	6301	12463	jx1Npi6BgTrPqvhtJsDMtqnTH6djeF4XvE3s4QAS6q4GY1ye96J	8494	12031	12031	1618104780000	canonical
16730	3NKL5mFzqPJ6YD5Ur3DDR8uMoZL9dnh3RgsBhN8t1ZQacQ8NeQEY	16728	3NKrN5kT3rUZi1HhYDqBpynFK2xhu1eqtm492wMBKxrr3Si7Mavw	1406	1393	280	6301	12463	jwCLZAdbsYrToaoMKYhowErW3uTF5XN5H3xoYKtaDrAAGo4S7nW	8497	12035	12035	1618105500000	orphaned
16732	3NKbmQyP8eKdxBTzqM8YgKUksDbUKA77Qy91C92YkfVZdUNe2MLB	16731	3NLREaHTBsYgfkjqTug3Y8H3tPpJTdemZW3SSNnWoHAz9hVSrksG	1460	565	280	6301	12463	jwpxCuABSBm6jc3Jf9MawMoaTe3SvG2KEV6ZseVWz1utQEvT1ES	8498	12036	12036	1618105680000	orphaned
16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	16733	3NKUCZX9Eg6s2nofVuzbRiqmdPFWzmkgfjd7VTwR3vYx389bhinr	1406	1393	280	6301	12463	jy1XjqfC5q8ZY2J1xTxZv4SxqptqXz7TFbT7rKvUTEmtcYYhr54	8499	12037	12037	1618105860000	canonical
16737	3NLpbnAP1hKhsMxFmKZYGg3rnGCypaizZf5FgARryqWeqQcFH8V9	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1523	1075	280	6301	12463	jx289HbD2nPcKEWhRktanY3DEcM4czkZuXAt2ush8sR8AsyiFvM	8500	12038	12038	1618106040000	orphaned
16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	1571	1089	280	6301	12463	jxxnnm3MuLXkdhxq3fTQjWNtskzxdBuoj3Nzan8kFX1CRAGFJL3	8501	12040	12040	1618106400000	canonical
16747	3NLYM9RG9qyka769MjsBFuVC8sDYKHkc8dWEG1Hp7SxhmtdGyF7T	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1527	1293	280	6301	12463	jwozEp4gL4aPy6SU94cUK1LZtaicszn2GnF3EbgYsS1rXzdNk1d	8502	12043	12043	1618106940000	orphaned
16751	3NLvAcTBsRW9u5uo7RWRoTwEkD4fGE2AaDvtB1NkupsGgUdWVsDd	16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	1406	1393	280	6301	12463	jwqKzCAyp32b96Npsz5SsPnMY5BNCdM9H59zXAw41umwkCX9PZn	8503	12044	12044	1618107120000	canonical
16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	16753	3NKL5EA1EJJbo4UdTZ5Ww5KFYmr8sBQnhNKHULUEZP6g8nnpmqV9	369	1066	280	6301	12463	jxthKnz2JBEfZXktu4bfF6wZSZQqCWsYAws6JMSrqkxC8TNViHu	8506	12047	12047	1618107660000	canonical
16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1406	1393	280	6301	12463	jxZYDtqwtPaaEzh25pjMFJfct3KzuZNdXBuP8oykGmgMGHKZFMa	8507	12048	12048	1618107840000	canonical
16761	3NKavbJcvNj6cC82v2NxangxyqeDGc6nJCSzsJeVcwE5t92tr567	16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	1503	1031	280	6301	12463	jxhDxjDHgnu8yn9N2F1hPE9AkMnGYaMYRn4isVyuTiTPt63nGrt	8508	12049	12049	1618108020000	orphaned
16766	3NKcYYyA8EDT5yyyt64KXdDr1HGj7Js3A3gcAZK6No66e2EGf2fu	16764	3NKrqQRpnyECsYWVntECfmfGj3z3AcitjMWPStsaMi6ScbH2qVdG	1602	1369	280	6301	12463	jx7GxMyWBSSrC8ptRtewv4ybLvHwxcPVATr69LGAmT2HYxS74Z9	8510	12051	12051	1618108380000	orphaned
21033	3NKyp555sZJYC6aqxZC5E5Cc9vvLjGdpC27PAvo9sVmh5X7Nr2c4	21026	3NKhnvqbiEcnmGmgGhk8VfV4LgfxV2vpKMCAio5j493Gk8aRjipQ	1451	1292	383	12463	13299	jwCuKM5GZSzPuNdBWjia3XnQWTFcuLNvpkxYczi1LvPe86KS66F	10570	14887	14887	1618618860000	orphaned
22326	3NL3VEHQc8rLZBSpfSov37xfqcCStH4EUcSJRPZok5B4to4e1DvM	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1477	1224	413	12463	14443	jwka3hxbYFhxZaN1tREVSCot3qY8LqDxdYERwgH1PXhfq9uUoTt	11174	15733	15733	1618771140000	orphaned
16721	3NKW8nkRBwiXdL2KYokicTwxnEjJbPsptimTtCn83NyFd4Qf8zyh	16426	3NL8ahg62xbfWstL4j9Zrif9a7fiG9jLuhyxUuZniPjaMg5RBy4B	1654	1094	272	6301	12376	jwguFivK42kuqkPQcr9oByLQBeyERnBLJo2dgFnqHXJXQoLRMFx	8355	12029	12029	1618104420000	orphaned
16696	3NKWmF3LkGn7cEFMdD5nFbfvx2iFEnnELHPGmSZ1iU8mZngcA14B	16695	3NLK4gK8QSAHc2thbrWo8SYYQboCfKJrj1PhQAP3MAQjXcSc96Qf	1555	1347	279	6301	12463	jxZLFEVCYC4JxBq9ae1fSCFtacFZMwpiDopnrTJwFKXdGu6s7Yp	8481	12013	12013	1618101540000	canonical
16701	3NLiwjETm7S56WiTiyocT9A51x6ghquo4oaomtaivL2Sj5MrW2ma	16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	1407	1395	279	6301	12463	jxpg6f2117zK8cbAQguyZ48rZtSJDrCUpaJ9a4xvii5cXe5mbZM	8486	12018	12018	1618102440000	canonical
16722	3NL4EUnS8TAeCUHePueaDyCsdVZCNmK1yg7cqmttCj7g5cyvkTN9	16700	3NKcsCnJoNKd3foiJQBoFHTUdw44p9c3LfqtMxZLawkZ4QAvKduh	1589	1040	279	6301	12463	jwYuWuCaNGoWmR1wtMq9VQZbzFLY2qHaSPTNePYgyR7byVmjiBi	8486	12030	12030	1618104600000	orphaned
16704	3NLkSAXsVQMf84TXELK9pqSuzqhNugjqjiZzdUfZVj8N1cEaGfWR	16701	3NLiwjETm7S56WiTiyocT9A51x6ghquo4oaomtaivL2Sj5MrW2ma	1403	824	279	6301	12463	jwFjJbc8Kgd8tggCwCkWvEPDqBTFhsEvV2fG21wmr156ArPHTzx	8487	12019	12019	1618102620000	canonical
16714	3NLJGNBruFEkeMTtuJw7f1a9icVS6QaEv48zqfSeD445vL7wNikY	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1440	1131	279	6301	12463	jwHZUCs5TpT5yGLMznCe3Jvesxqn2oeCnpXV8CDFBGgu6fyWV3r	8492	12027	12027	1618104060000	orphaned
16720	3NKTo79K5XBYq27J8Giigg6PyKoKkGcoAk6pHK52daQD2kDPZ36C	16718	3NLSoVk9Ku63NqPvRSTNo2ztLwuuMKwLSaUAZJ58ULqg3Q1CPPdY	1654	1094	280	6301	12463	jwxGEDFmMRZrqLNMSqvpMYrUCzRBrr3SWDFEaAL29Fu3oBUaQq4	8493	12029	12029	1618104420000	canonical
16723	3NKGVpy85MDx9g7wvdtpSS9BB5XxyugoGDMYU9u95tpythxwF7Qf	16720	3NKTo79K5XBYq27J8Giigg6PyKoKkGcoAk6pHK52daQD2kDPZ36C	149	1037	280	6301	12463	jw8vnHNyfTBjRe2ENx4qxdNi3yhDkj5K5yHKooXE49GcJ5DWHRh	8494	12031	12031	1618104780000	orphaned
16726	3NKaD4HZBF2iUyHZpJYpPDgeqUBZmtsFNxsi3EC93r5N1JYimS8q	16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	1439	1033	280	6301	12463	jxa5ftV9eWHLu914HtpQUx9eX9u1c392HM2ja376q3RxsvFcLfX	8495	12033	12033	1618105140000	canonical
16725	3NKK91uJ7rYfkfJjeEHrd32PNrbJWL1v2krZSUg2qMnXbADNJqUa	16724	3NKgXgGPdQKzRK6TLaByMaq6e3QV2njEtWHpduhtfzvdNwnCaUiy	1619	909	280	6301	12463	jxhmePpzvnZW7jMUnC7TUavQ9CKMCZt5rsLWvPdU9rBYZ23bgqB	8495	12033	12033	1618105140000	orphaned
16731	3NLREaHTBsYgfkjqTug3Y8H3tPpJTdemZW3SSNnWoHAz9hVSrksG	16728	3NKrN5kT3rUZi1HhYDqBpynFK2xhu1eqtm492wMBKxrr3Si7Mavw	576	1355	280	6301	12463	jwv9xjiNit1T2wem3FfiAXXGDpbUgRdfmfsFT1XaStyMJiHQhdG	8497	12035	12035	1618105500000	canonical
16733	3NKUCZX9Eg6s2nofVuzbRiqmdPFWzmkgfjd7VTwR3vYx389bhinr	16731	3NLREaHTBsYgfkjqTug3Y8H3tPpJTdemZW3SSNnWoHAz9hVSrksG	1406	1393	280	6301	12463	jwE6B7HeJC3SzzdpgHpsjWH2Cc4USJHYuTvb8Jc8VorGBBV3vzp	8498	12036	12036	1618105680000	canonical
16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1587	1357	280	6301	12463	jxBQDFHvf4SNqzyDs2uM83KgabiLLMbiCZ7gewS7iGtMz1xzkro	8500	12038	12038	1618106040000	canonical
16739	3NLvH6scustopRhGD3cFCwtF7zTYJJhEDRAkK5cJ77bkBJXnQgpE	16735	3NLTwhaKC1QpWd2Y5gB2r2YXfsnhSxFQCU3x5ge84bCqemtrBRRr	1523	1075	280	6301	12463	jwNFfU78dR2QzQ76UZxqEHaFtgpmQ2btcNXbN41cS7cRPsSk7NY	8500	12038	12038	1618106040000	orphaned
16740	3NLMPnjcwZuBp83KAsLqHVnRRTsiTqkcPazTZa7Xqeavtbu4EKVy	16738	3NL2KQtqGiwGMzjrNHzAQcB1mUwBFj5iGr4sbUQthdboxVf9kwnu	1509	1074	280	6301	12463	jxCKoBD3zCXrbSJkceUYA8TgUnhzvgcg83Rh7GqovS43xYLBW2R	8501	12040	12040	1618106400000	orphaned
16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1527	1293	280	6301	12463	jxDtfr1od3n55xq3EZVfkftStgWtHc3ZK2Aw59JzxRcr8eYGZNG	8502	12043	12043	1618106940000	canonical
16745	3NKGxrtjkA1FshAXnxoWZ7BNnhhypnGAComQUrf8f3AxLv2ZJEQh	16742	3NKSK94AyKFXmoxp8L8dYyiy1dT5skFWzxgnGB7WLsgVmZsq6Tbt	1527	1293	280	6301	12463	jxSghqoFPnhz97VAPpkt6ebr3RUGEk6RfNk1RcLbsB8njW9WMJ6	8502	12043	12043	1618106940000	orphaned
16749	3NL6JnXHDXJDnW1ReQvC659v6hJGs8owrxyLVPrExgs9TkpindD7	16748	3NLXSKwixY79R1mFsqFvLZoJ5uThXgV59z3AcMNohh3NuxjHd2CY	1439	1279	280	6301	12463	jwGYdzzmKBempNSQ2W8TuyaE8qo2nwGAvkCRVnXsFi3hVCjEwKw	8503	12044	12044	1618107120000	orphaned
16753	3NKL5EA1EJJbo4UdTZ5Ww5KFYmr8sBQnhNKHULUEZP6g8nnpmqV9	16752	3NLHT1tQjzZcunEFRWjEFPDNdpR5wBgsdCLxm2yqRuTZoc4JsvPk	1426	1118	280	6301	12463	jxm2tKq8ifvXTtsXFQx1YJvuCLh1S2WF7sf3CUZAskZQV1kuPhJ	8505	12046	12046	1618107480000	canonical
16754	3NKyFgmhcf5UpZ4d4xDWCXn2bHM1SzkEdrU3kbqz27bj9DzVj48C	16752	3NLHT1tQjzZcunEFRWjEFPDNdpR5wBgsdCLxm2yqRuTZoc4JsvPk	1407	1395	280	6301	12463	jxab2KunE525xHpMtxBS8K9HtrEgHfXqdVeaSCRuFjWt42jCpt5	8505	12046	12046	1618107480000	orphaned
16757	3NKhkb4fibjVzsdfNJoNkMV7UNUCy9Kf8sqgK4UUJmuUneW4kZaW	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1472	516	280	6301	12463	jwLr9B2SmCiMgTAB2nEcsSQLn36TZrZ2NAYRC7kAPaiCED2v55o	8507	12048	12048	1618107840000	orphaned
16758	3NKXheVytDyVZRnLTmmmnJrrmFjVKyx1z7J77ebBprNVhCqwN7ZL	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1472	516	280	6301	12463	jy3Hpp91kBxXyHiMPJbD4xidsi6KUqJMebquNUGhnsD1a8q6pjy	8507	12048	12048	1618107840000	orphaned
16762	3NLu2JtBJY3tpKZZssKReA9MAhcibrETCqxN3ePteKS36FVryvNz	16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	1607	242	280	6301	12463	jy2ek5VsxmMRrDaJkU4N6yrs1mZEonxJrYuPyNR6anxLEUQQouB	8508	12049	12049	1618108020000	canonical
16763	3NLVLJj6UnVQwhmeWV1C5NbkQxXioD7siYH4ERD3ZTJP1F9hFYNb	16760	3NKXC5q95fgmnYfBjSq2KdrohAxSXveR8EiNfUcns444CGfGq9tV	1406	1393	280	6301	12463	jwsyrC1ngrE25dccovKFyDziT9kp4Kse2pGiPeqKH4Khad1EQg3	8508	12049	12049	1618108020000	orphaned
16768	3NKnUGryTpGCe2pp9PxU3SzPQdQopLzjEG36pPGwP2aULScWEthv	16765	3NLdTJN8vMd2VuzakuNePQPro1iyxPk4248GagJCyHeeD18T56Rx	149	1157	280	6301	12463	jxmLQQAxvBucsf3CNbLQ7ASpzz55iCBeqKZCVR3jinu3p5M8Pgn	8511	12052	12052	1618108560000	canonical
16777	3NKXQhiJK9Y2uxVRyyuKLYwCtYQdXLQWkXdoaLcPevNdUZYcw9MB	16775	3NLKo3cw9pbQHLwzYSZvBHQ7da5BXxmLjdBspBURkyJWMiTpmNok	1578	1296	281	6301	12463	jxYRC631EfJwkvC8eKDfiLbjMHDErqb7TMf7r6ihkMw3daQaw7q	8516	12062	12062	1618110360000	canonical
16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	1490	1274	281	6301	12463	jxeUWW44rVws793bnNyVHm8FEjvYPrCe2z5KZDRYufADvghyp8M	8519	12066	12066	1618111080000	canonical
16785	3NK5o2UZANTDAuVkPyYhwaQEdzRKeg19hcafJkcPsQAHiz7294BY	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1578	1296	281	6301	12463	jxfqN11oJ4uoV5xKrPogz4aiHZgNU7xfqgnpeLQSJpDCyJLpTVN	8520	12067	12067	1618111260000	orphaned
21243	3NL8kzEEWB17qrUcTZscKNUAGxcSo72DrLLxBkmpyZFNks62xz49	21033	3NKyp555sZJYC6aqxZC5E5Cc9vvLjGdpC27PAvo9sVmh5X7Nr2c4	563	1359	383	12463	13489	jxXejbd7632stMyq6aaKFDR8XfpZpY5RR4y7LLCTdhrJgDX7nEE	10571	15023	15023	1618643340000	orphaned
16767	3NKjJskkTp3uvhtrFaYfCFwhxT9QR29WFZDpn6GGEjDvnqaxLzNQ	16756	3NK6VgufhrQiM22hY99r7whXsteGgeCC4tRggEHWC3v98ZExCFCk	1564	1212	275	6301	12426	jw9ZwZ6w9SoLVBzQKARsUk9yS83uszKYfgtoULWmUCykduqyXVC	8385	12051	12051	1618108380000	orphaned
16759	3NKjnGus3NuuHriinbEMNHJ6gNiCDsKbC3rpzTtfUiZfw8Jm4ehP	16755	3NKcLR2U8DVpSCu2yC1E9TJUqw1AhwVQ7Sb3tc4UJ5AfYCnWR5bo	1407	1395	280	6301	12463	jwQksU2y25t6ZK2VVy7oVURua5qXdeajquKvAv26zgDRRKDQcKe	8507	12048	12048	1618107840000	orphaned
16764	3NKrqQRpnyECsYWVntECfmfGj3z3AcitjMWPStsaMi6ScbH2qVdG	16762	3NLu2JtBJY3tpKZZssKReA9MAhcibrETCqxN3ePteKS36FVryvNz	1406	1393	280	6301	12463	jxT4EJgnWq62XxV7ZzgEqHo9FWGd3YvFmTwHG5RCVbLFd4m7vPf	8509	12050	12050	1618108200000	canonical
16765	3NLdTJN8vMd2VuzakuNePQPro1iyxPk4248GagJCyHeeD18T56Rx	16764	3NKrqQRpnyECsYWVntECfmfGj3z3AcitjMWPStsaMi6ScbH2qVdG	1509	1194	280	6301	12463	jwDATE74XRGVARVAc1upeMW9cG783mDH86g1cJgsjiRvvqwAQdt	8510	12051	12051	1618108380000	canonical
16769	3NKTSKx2ztq55CM6NZYvKgkF529PX1QDWvEZt98iJDZFfvZvcB16	16768	3NKnUGryTpGCe2pp9PxU3SzPQdQopLzjEG36pPGwP2aULScWEthv	1432	109	280	6301	12463	jwXWVdk3sgJNXhHxNPSNsTeQMvqvjai1yPGC3LmsyuX9VxsNJDx	8512	12053	12053	1618108740000	canonical
16770	3NLZj7Yfa9Ykeqm5bfhurt3nrakMGn5m1v2CpiRXbe37aCTgBpZK	16769	3NKTSKx2ztq55CM6NZYvKgkF529PX1QDWvEZt98iJDZFfvZvcB16	651	651	281	6301	12463	jwJwbQee6UpeZpEfNhFUapi5wQffAvR8tRrRGPY48eStephFqFA	8513	12055	12055	1618109100000	canonical
16774	3NKVCczE9GxbrguxuSPM3T9ooPYyxBpVeVHccHJDxTA4wQw6SvYG	16770	3NLZj7Yfa9Ykeqm5bfhurt3nrakMGn5m1v2CpiRXbe37aCTgBpZK	1534	1071	281	6301	12463	jwGhokZr4CFXxhUnvT1XQxGXyuvgLZK4znhhEtFUE4bJowbzoaP	8514	12059	12059	1618109820000	canonical
16773	3NK7j3JumFVNzq7B1S3yLxBZaFwme4sPayAao7D9iqmNxT4z6d4i	16770	3NLZj7Yfa9Ykeqm5bfhurt3nrakMGn5m1v2CpiRXbe37aCTgBpZK	1406	1393	281	6301	12463	jwWPfGziPiYbxQ4p2CbyqHz3oTagocsZQa3pK8e5BZJpssPijnF	8514	12059	12059	1618109820000	orphaned
16776	3NKqK2dSCMJvkoNYgTpkLExxGGn4Pw3KYgZpT95CYxLdM3H3ihdx	16774	3NKVCczE9GxbrguxuSPM3T9ooPYyxBpVeVHccHJDxTA4wQw6SvYG	1553	776	281	6301	12463	jwPd71fqotrhWGZik6Au5orcgSN7NnycLPia33HGGhtkDGH4WGj	8515	12060	12060	1618110000000	orphaned
16778	3NKqajKVrZfB1sAeokkwdr53LgJcAFFfGk8jFm78qW4gmdqh6XCi	16777	3NKXQhiJK9Y2uxVRyyuKLYwCtYQdXLQWkXdoaLcPevNdUZYcw9MB	1579	1143	281	6301	12463	jxppsNKk86rkZ8q2eX2at2xViVugj3uutmqvsL4JgMCgByEo7oK	8517	12063	12063	1618110540000	canonical
16779	3NKeS6k4BzJL3aWP35Ee8qEHdaYzZCyvXfGTdfAq6ZvYRpnKEpm2	16777	3NKXQhiJK9Y2uxVRyyuKLYwCtYQdXLQWkXdoaLcPevNdUZYcw9MB	1407	1395	281	6301	12463	jxxLVA8nohjjMpZLSs97jKtSVbUCj3C5u2CaaC64fx34Qt8smpA	8517	12063	12063	1618110540000	orphaned
16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	16778	3NKqajKVrZfB1sAeokkwdr53LgJcAFFfGk8jFm78qW4gmdqh6XCi	1596	1363	281	6301	12463	jxhuMaDSrVSPk3BKmK4USgAZcKqbi99EpESFcvAVt5KEShsw6so	8518	12064	12064	1618110720000	canonical
16781	3NLF1BwYJUXxNaDQJke6F8TZukoaJ5kroH8g8x6xb7K64nm9GHsg	16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	1534	1317	281	6301	12463	jxNdD8WjoMkyQKE6mc2z8dsMXssruJoPEL9QC3AmMG5MJQ2A4V8	8519	12066	12066	1618111080000	orphaned
16787	3NLcZhwbKd53yEUaoKy9eNpEZT8UYRUckA9bZA2ypQbfBMzL4Hwo	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1651	1301	281	6301	12463	jxtHSATG4nzKthVuB9MYkZq83wwZ4WQWJGNJUqwGS4vCnnSSZRp	8520	12067	12067	1618111260000	canonical
16789	3NL99Z15VL6jBFiepBemNUr7ykt2sThhpDiCsDBcnx92WMteAWcg	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1651	1301	281	6301	12463	jxUg4UneNi2uyXuTHUX2Pqss1LdFRTySgiqCLGc7a678Xpc96Zo	8520	12067	12067	1618111260000	orphaned
16791	3NLj44XG3TKRwB2N6YQd93t265WPp3ESJRQB4oshw7dFAVjBBY4m	16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	1402	866	281	6301	12463	jxxxyCTVH7bPaGBYusrb1MzKCAwSwS5F8KbHywEHvLE3birdPhQ	8522	12069	12069	1618111620000	canonical
16792	3NKGgydFyjwKYHuP1JrReo4583qezmoBbc6orCHnabxLJc7fBobj	16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	1440	1251	281	6301	12463	jwbwsuc451t9yfvLZg5C6MrV4njdLodLvbkMscjX5RtjjedzT5i	8522	12069	12069	1618111620000	orphaned
16794	3NL19daf2upubJcCucXRX3znSiqXvT8M5xN3mQztao8Mb1er2Tj6	16791	3NLj44XG3TKRwB2N6YQd93t265WPp3ESJRQB4oshw7dFAVjBBY4m	1555	1347	281	6301	12463	jwTr6HLBE7dfQMxUetquKvjw57ngGjnMZ5RRzH6mn196ZQSVXPD	8523	12070	12070	1618111800000	canonical
16793	3NLmfnpq1dgrJiUsoYHNe5dMHoyyLiQf8Dh18s5fARWHtm3qoEzv	16791	3NLj44XG3TKRwB2N6YQd93t265WPp3ESJRQB4oshw7dFAVjBBY4m	1581	778	281	6301	12463	jxBa28WDtoqjEtgk3fNux99RGWK9bwPFWyej6qzrzqnSfSWCgxj	8523	12070	12070	1618111800000	orphaned
16796	3NKAzmWbBKpvGmyP8bDXurfcErfgu5iSEdJfQPVo86ABGSbJ8n8o	16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	80	1027	281	6301	12463	jx1WaRRVrJ37ut6ocK5wsD6tXYKUr7kmmjSoNmHLDRJZtoVyus6	8525	12073	12073	1618112340000	orphaned
16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	16799	3NLJHfLo6mc5NiNFNixeqLRqfqVTAtu3k2Ys9VGgpTzdoZBfPXgw	1489	1014	281	6301	12463	jxNr3wf1MYUXGTSc3pf9UkCQyQ51qGLnMz9AQLsawS7rXTGBUpY	8527	12075	12075	1618112700000	canonical
16803	3NKcab1M2vF5GxNn4YdHcYUnXZqxSZQuuHwUrrxodSm1aRXeGyMa	16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	1476	1125	281	6301	12463	jwqVTU6Q8gAFyS9EoynCN3mDd4azMEHiiY8pJXmg8j5HHsHRHjj	8528	12076	12076	1618112880000	orphaned
16808	3NKMXQtxvWk6ntDyXYw6GoDt2eUAViTTZxHc136JfqetVdCP9d3N	16807	3NKVnG3Ku4b9fCdmz25ZGhJ2KRRPYjiUFw2Cen6vT114Lugkctbt	1599	1287	281	6301	12463	jwpRnRmtz1ebXxvhQdjVaewrZk6vQU1Zbc4v2WuC3pAvBFZSYo1	8531	12079	12079	1618113420000	canonical
16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	16808	3NKMXQtxvWk6ntDyXYw6GoDt2eUAViTTZxHc136JfqetVdCP9d3N	576	1229	281	6301	12463	jwWhNiwpKDLm82eUSQfu1jEiH48zgxQD2NwyVunsXMNq56gJUfR	8532	12080	12080	1618113600000	canonical
16813	3NL4ZAfPWpDPB1A57Mgg65U2pPdkaLqbb6fUMxdufnYfTjKfn4H2	16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	1577	961	281	6301	12463	jwmd8iLFMds4NrHQR9iMYeYpyhFDX53ihNy4i4uDc1MJGraj48N	8533	12082	12082	1618113960000	canonical
16812	3NL1Ft489YtY3cxM6TM98B9kHbXMjR8z4sV6DikqcSUi3PveBXqr	16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	1577	961	281	6301	12463	jxVnYH2FGzgQAwj9YqZMXhi4TuxMoU4Py9vp2B3HwZsUfTf4Hfv	8533	12082	12082	1618113960000	orphaned
16815	3NKWZhVuRZSPJwcMxPFmNRstLKwBB63dwHnt1q6gL5ZHbUv2vSHL	16813	3NL4ZAfPWpDPB1A57Mgg65U2pPdkaLqbb6fUMxdufnYfTjKfn4H2	1402	852	282	6301	12463	jxQENZCdar1qLFmetLAud676QhmDZC58FM3VEcgazSLGGX2APKd	8534	12083	12083	1618114140000	orphaned
16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	16817	3NLkKgayRj5nJDvf9AEFjogAxejXdE9vkF53bNAH5WNDNz322kwr	1407	1395	282	6301	12463	jxsPVndKs17qDAnsZpS1RJmViUQgcojU4tifddhG3XijBdpiZGS	8536	12085	12085	1618114500000	canonical
16827	3NLRrMCYwFpYyXXbyN7XXc3n8QWqCVf1BttcPNoWP9WfTQaTVBXe	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	1503	1031	282	6301	12463	jxK1uXsDokFVH9A6JKzGCmYZUQ8iHMDEQZEh9imyPnxaLEsoA8D	8541	12090	12090	1618115400000	orphaned
21277	3NKEJavF4kmmfcbangvbi7MivoU8afBwLVcFHJNde37NPXMU8pd4	21237	3NKLKW4quLaSegib2RPA3Ad77ZmLyrRu4hdchcmPgJdCrt8ErpVw	80	1273	383	12463	13518	jwHLssMhh52nbBwESPcpKe278fMneJ215nwngSDahtHo3AnKF7U	10577	15048	15048	1618647840000	orphaned
16858	3NKRLuh44FgcPK6NYPiw6k5Xe4FivQyZseCaoUehni4BAdoGtpCe	16388	3NLBBfSGNkx8BXRnhqHky8idxn3JB28knw6d9UFMBkLDHL2LeNCX	1646	1354	271	6301	12342	jx5WcEyRwgxFdbav7F522y6CP5SqhFDztmcba8K2ReDQoDkmXYg	8337	12103	12103	1618117775582	orphaned
16861	3NLmx48Adpc6HV9Jw3AXH3eKpyEf2A6KZnNBHUDCgF2s41ytjMsY	16438	3NKrzAwZXBMN2bpMzKT587hb2ihbgWsRGJ9sZ5XTAyd1NmPLyx9i	1646	1354	272	6301	12387	jxD5CBebZEVQ1c3ohc1N8CeZRkuZhYvTw4b4VZiqP5Se51R683o	8360	12103	12103	1618117844479	orphaned
16772	3NKqwZjPAHEdqEqkGeNMokrGcyrjfWuCPLjJd2c6dTQ2rESn5Q6V	16629	3NKMbEZgiaZPsdaUJoTcuobmKPaZFVZjQmEJYxMxjTATAFFu2AeL	1508	1387	277	6301	12463	jxjAcF7orRXa4SbyWzEUf5J3Kuyv84qMMTSYeggoJi5Bn3yw9Qk	8410	12055	12055	1618109100000	orphaned
16836	3NKRddawB3Dq2V1yvmd9KaD1Vgoz43F1AGdF1aHm3FxkfUSWVuz1	16553	3NLkXBU7gx8KETkR4hbjhqbrBSTq4Y16PMrhdPnspWuEm2w68aap	1646	1228	275	6301	12463	jxhsDe8raDuJwtJzak2n5RMf3T9hkhNd4by46NQ48kwDJ8EPBSC	8413	12092	12092	1618115760000	orphaned
16784	3NKXP61KBLST9kGEAcMcU2y3CJ8g2w61pkVnxUFNBajJgWfcMp46	16707	3NLnWeR7qdKmNFEFMLKjRrU4TH1LY1Q9sgENKK2QZNk5JpaFumiW	1490	1274	277	6301	12463	jxiTrn38DeKvFRNhVfg9yER9ywcu82WnTJ28pCM2WJkg6tZz9kf	8429	12066	12066	1618111080000	orphaned
16782	3NKFhn5uMJfQGqAungcHCwC9nMA5HsrM1psfS2ZyMXBNhvfNBxoP	16780	3NKMnW97U4Kr8AMDK56DWhmjDtVNE8e9GK3MszfNKL18UMGNxM2n	1407	1395	281	6301	12463	jxBsQXopVPuk3am8aiGrzQbu6ycDgP4snjARhuvF5ua737Wx4gD	8519	12066	12066	1618111080000	orphaned
16788	3NKMfhd4kpm1UgV317UL9wBEvKUdpWZ1RxpReCqUoMTTi2HMVm2f	16783	3NLtVaYeWKCK7mdWPiJYt1KmkEDnp4jQT3CUByqgGuwkJtALt2LL	1633	1390	281	6301	12463	jwBZNEtBtV1ianrmYHQvaGXqGQKCVu9THG1ShRgxg1QPqB7DFQc	8520	12067	12067	1618111260000	orphaned
16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	16787	3NLcZhwbKd53yEUaoKy9eNpEZT8UYRUckA9bZA2ypQbfBMzL4Hwo	1522	1196	281	6301	12463	jwkwBXozP9Rkwca4fXiv2XjQCw3rhrQ9M8aR5BtAnPrqWdrCFYC	8521	12068	12068	1618111440000	canonical
16798	3NLUM6frJYMUascAcvpHJfmCTymzoHacU8CNnP37jodeedocw6zc	16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	1553	776	281	6301	12463	jw8H6S146BjRun4Pt4HFJ6dYtM2Rz9onWUTa6iVBTgtCL28JnPu	8525	12073	12073	1618112340000	canonical
16797	3NLvjjGUCsMf9Ui5HAamqp78cJ7RkttHBCPBUCUL16Bzk1W3LD7K	16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	1406	1393	281	6301	12463	jwED3ytaECa6uNEjhe9VifJk388n7RtB675vwSGrWp81m79G5UY	8525	12073	12073	1618112340000	orphaned
16799	3NLJHfLo6mc5NiNFNixeqLRqfqVTAtu3k2Ys9VGgpTzdoZBfPXgw	16798	3NLUM6frJYMUascAcvpHJfmCTymzoHacU8CNnP37jodeedocw6zc	1670	1036	281	6301	12463	jwTuY4Fw174mmaR36mm26UUPF2VUJp7tJ75ibf8RcrkRjssTdgQ	8526	12074	12074	1618112520000	canonical
16800	3NK6C1gDU8L4mhtViL5ijQ1Ggg3Gc1oLKqkyfvgr2HECsrj5UxSJ	16799	3NLJHfLo6mc5NiNFNixeqLRqfqVTAtu3k2Ys9VGgpTzdoZBfPXgw	152	1330	281	6301	12463	jxAuAHYk6cNm2Xa7aDbo1ba1CM5W9nckyAJ7Jdk6Ew5Lgp5YYef	8527	12075	12075	1618112700000	orphaned
16802	3NKUSg4pJr4zYv4u6Hef98hHD6J2LnUR2UUa5CaD8b7RK8ynWobp	16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	1407	1395	281	6301	12463	jwomKo3YTi2gVa6qHdiqKapasGnyRFYXoX8cqp3etTcBDgmpZs2	8528	12076	12076	1618112880000	canonical
16805	3NKtbgDHUwKAaSj1xE3r6sSSuUJ275jFMaXkW5jz1HzpX5MaRMHQ	16802	3NKUSg4pJr4zYv4u6Hef98hHD6J2LnUR2UUa5CaD8b7RK8ynWobp	1458	1323	281	6301	12463	jwMpCE1V2QgNNedtQ9vXMfrnZ6kAaaERidxkadaMvSnBfwhksNN	8529	12077	12077	1618113060000	canonical
16804	3NLZEDESvbrCfMjBkcM424urPbyCvcXtsSA9mhPJWZmA9ZNT5hvg	16802	3NKUSg4pJr4zYv4u6Hef98hHD6J2LnUR2UUa5CaD8b7RK8ynWobp	80	907	281	6301	12463	jwuW83ZFKbLChjqZwpGwLyBnXgyey6hvhB5wM7hFW8BWpgYP6x9	8529	12077	12077	1618113060000	orphaned
16806	3NKUVkup1QFJ18b4YqwQtqTWzLqjf6zPK5LJgBBYSF18rLcsr4ub	16805	3NKtbgDHUwKAaSj1xE3r6sSSuUJ275jFMaXkW5jz1HzpX5MaRMHQ	1648	918	281	6301	12463	jwjwi2Fgd3D6BoSzRiFjWG8AUxVejDUqqwDp4VUCVMt18S67sZ2	8530	12078	12078	1618113240000	orphaned
16816	3NKXuUbEekLgwi4m8rJGw5DhqYP6ff19e7ALmnTM1TSYLQHMZdC8	16813	3NL4ZAfPWpDPB1A57Mgg65U2pPdkaLqbb6fUMxdufnYfTjKfn4H2	1611	1341	282	6301	12463	jwbxd6tuMuPMgczpD2gPNbxeaL7oxZN3V4F74gTBLvX6wo4Sb4S	8534	12083	12083	1618114140000	canonical
16821	3NKmgLysM8egxLdNrUzoGqe29jmXoRNMX2avpRdvqpnPgmWZjC6K	16819	3NLjxGF1PrwjdEBffuaVFDzbD3nz1St1ifJDbAv3rgToCQzbnSnD	1406	1393	282	6301	12463	jx2GXgB8BvdHbhwdnG9Vt4TwnreWEbBke7pfxiUjAse3ndazRWx	8538	12087	12087	1618114860000	orphaned
16823	3NKRSooWcBPByjTTFqK9ha7JiZ91xLJM1QL7MABpjnuPVE3BVv5w	16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	1587	991	282	6301	12463	jwkVgemHJTAwZTtE51mMDwLUMyfdrog9ATXuu4SNQqtXkKC13xR	8539	12088	12088	1618115040000	orphaned
16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	1627	1385	282	6301	12463	jy2mhYj57sAzaedV6XvQE6XnCSz5kyRGxMmaq77WkzE2Nk9Lw9T	8541	12090	12090	1618115400000	canonical
16830	3NLKrLoj4M2Wupq4ond14mE9UYLXL44AixEac6wr2csvakjNHKRA	16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	1448	945	282	6301	12463	jwAgvBR5mY7GTbhH3MgLnF7Djx8gf6RQEMSjWd1E4gxzzQcnGgn	8542	12091	12091	1618115580000	canonical
16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	16830	3NLKrLoj4M2Wupq4ond14mE9UYLXL44AixEac6wr2csvakjNHKRA	1668	1370	282	6301	12463	jwDocYRTnWsEHAmd7bV7LC5CSZXcA5hq3S1S5LkguCzL3yc9dut	8543	12092	12092	1618115760000	canonical
16840	3NK5XDcsYskmtHbCuAUCUmDyencqzwoxKTZ4thRSp1GWWYb68EVe	16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	44	959	282	6301	12463	jx2S3SXdX7DyciCWUmd9XctL4NaTDSbS4a6tfZaoda8YH6eFM2W	8545	12094	12094	1618116120000	orphaned
16843	3NLmCCQRBN8azxWEPZ4u1dHqRKZNafM3LodAcxcujogGZdGLdLgh	16842	3NLX36LD5E3dbuwDv915qA95dycPJY3t34S9LVx3BqZJBbWTq5xU	1670	1036	282	6301	12463	jwBkrL4P9RxSPvPwbSwjjCNAiDrjvsUJuUnNUcJ8VbdDZV8L4Fr	8546	12096	12096	1618116480000	canonical
16848	3NLDyUkLDCHmEaw3SZbXH1CB7zYasZ22cN6xMakeAja9U6kMXt4b	16847	3NLsJ23ZidsRkxYJQaBMWeK4vQ95md5E4Fdwt75DMPPsTo1K17P4	1581	778	282	6301	12463	jxS3aou4iRQCFCR9sCLwYANmM9qxr2qrNLQV8yY9fRUAUQCpUVX	8549	12099	12099	1618117020000	canonical
16854	3NKAZ9ihE3pnDYu9KRrMkSo3SoMmaZHhiZyQsfr8Nbf4qy9AVW2j	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	606	1049	282	6301	12463	jwygMBFDUJRx99xhk9h9V1YR6CUZNvEjwWYoqnFos1KaUuNH1Dh	8551	12101	12101	1618117380000	canonical
16850	3NKq2tixfCCXA8AkTrUs1UjHA4LCnLPuJemDhSjexsFHDucZzdXR	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1527	1293	282	6301	12463	jxJkXV6Y4ZErKV2jSUXF7iYv5XCoxfL1qDgUu2KQd5d3j1a8csy	8551	12101	12101	1618117380000	orphaned
16851	3NLpaqrxMMdTMDwWfr6HZJuRKcBMsTWzwrZFP5qsNaPnJ1EqDuic	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1407	1395	282	6301	12463	jwjtTaDG4H8PzN8AmMDYEsUcsHUkiym87FupE3jRBArKuTnYefW	8551	12101	12101	1618117380000	orphaned
16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	16854	3NKAZ9ihE3pnDYu9KRrMkSo3SoMmaZHhiZyQsfr8Nbf4qy9AVW2j	1447	1219	282	6301	12463	jwEkhMEVtaHazXWYsbk4LVG7sVn88J3xHm8WK6zttijZZrRj8SB	8552	12103	12103	1618117740000	canonical
21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	1406	1393	383	12463	13335	jxvsxfug7cdZbHcSj8sx6Gyj1aufLZcPUe8ycKHZXB42VsTwEAi	10587	14908	14908	1618622640000	canonical
16856	3NKCZGBBMQwMHVPCqx3qPtQbtgFQqkNzV8LG2D1rZ9C44zwg1yVv	16364	3NLaQSeYN16pPUQvUxjUAuzE1aJwik1aEANAUQJn7Sem1NsL2yt9	1646	1354	270	6301	12321	jwQHc6nChGFbG2YjYHCmWTX7bvBUbrEF5fWHk31h8wph2pey1RY	8324	12103	12103	1618117740000	orphaned
16859	3NLQppTj8jhJe64feokC9xCYaxdLQvCevpAyCwzg2GMfF88QUf4Q	16411	3NLDSRQKf7biReCkYsLimRPwGhrxUFZ9hndU9MchvSeTnVaa3CA2	1646	1354	272	6301	12362	jxXtQrVYSHG4uZxysA1uVFkt7CtqkNoYChz37Hj3uTaU7PreNrX	8349	12103	12103	1618117810466	orphaned
16862	3NLD7WnBwmDiQ9L57nQuXC3vhLtQ9wWvvHSSFKC4v3JmNG5mGLKZ	16458	3NKfRTEv2zFcMRwT1qX5ovLXwVgd3Ko5sCF7BVDRwg26kEvRnu6q	1646	1354	273	6301	12406	jxJfFv43wAfsKJiFfDu4XbbaqeFiXTYwzY7T851JY29UdADr1sR	8372	12103	12103	1618117880291	orphaned
16860	3NLJTV6Fqz3ZAAgm3qsFhvr52By2j5FWvGcxuGsU427bv3nTXYeW	16836	3NKRddawB3Dq2V1yvmd9KaD1Vgoz43F1AGdF1aHm3FxkfUSWVuz1	1646	1354	275	6301	12463	jxhsDe8raDuJwtJzak2n5RMf3T9hkhNd4by46NQ48kwDJ8EPBSC	8414	12103	12103	1618117740000	orphaned
16855	3NKyjYMBtDPk58Zt77NYv2YKyQQhBkdC89ySACepGoCZMdk8pwuP	16801	3NLs5xBap4jkXZhtDXZpcUQJRAK6oJTyqHohQno2d3jVDyJWouza	606	1049	281	6301	12463	jwAuEBKxgzafeTPHxYxnvpFj7CF6uwwAy8kt7qDfnZVAojUU8ge	8528	12101	12101	1618117380000	orphaned
16807	3NKVnG3Ku4b9fCdmz25ZGhJ2KRRPYjiUFw2Cen6vT114Lugkctbt	16805	3NKtbgDHUwKAaSj1xE3r6sSSuUJ275jFMaXkW5jz1HzpX5MaRMHQ	1573	1318	281	6301	12463	jx7Xxbegjc9arTNMwEkoQazJGHoqkTSkvrQBy57nrmjbyhBmogC	8530	12078	12078	1618113240000	canonical
16809	3NLv4iuXKXn6tt4PZQwpwTYmeyMwcJLJL2idgUL3gf88i5JnBHfK	16808	3NKMXQtxvWk6ntDyXYw6GoDt2eUAViTTZxHc136JfqetVdCP9d3N	1637	816	281	6301	12463	jwAWpnpkDeivUGcPW5biEV7aRYhZWahWSB72eqtEq3vAjq5fgmM	8532	12080	12080	1618113600000	orphaned
16814	3NKm7t2RcuTyRfDn63X9djRy26CWGQNbs5pFe2UyABHr96H9CYuq	16811	3NK9WFKhW5HeFQKFbd48XK5hmGcP7uQ6umpLVsDxiw8mbUY43FKk	1577	961	282	6301	12463	jwwFoZFyJCcrMoiDaFnTUzx9UAtkv6ka2kpqANuyRgtEbFxSZkp	8533	12082	12082	1618113960000	orphaned
16819	3NLjxGF1PrwjdEBffuaVFDzbD3nz1St1ifJDbAv3rgToCQzbnSnD	16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	1407	1395	282	6301	12463	jwHiEHAjp939WA74ewxngpwUHXw1r8zpj7x17hLixe2eFsoTYAP	8537	12086	12086	1618114680000	canonical
16820	3NLjF7TuA1eoANd1x55jUv6XdSc3XHnca54XR3UJDG9WbWrMtPRb	16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	1440	1377	282	6301	12463	jxw6HdysbFDkSwVxWBNx3JnEagcMC2oGqsiHzYn4buvHMTc7BcA	8537	12086	12086	1618114680000	orphaned
16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	16819	3NLjxGF1PrwjdEBffuaVFDzbD3nz1St1ifJDbAv3rgToCQzbnSnD	1631	794	282	6301	12463	jwH4SJYcZxYLXW43kbYy4H6jwXP4aEYWwFvnwVyDC4krguRWP6F	8538	12087	12087	1618114860000	canonical
16824	3NL44DpnF73cH6JMtiiRLNH7mGkHdQ6atb7QjCSaKaoLm4kxiKQp	16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	1402	880	282	6301	12463	jwXshaKrwNqmZBpimrFyBp3FpD6mfNedZZB25Y9g4FsRhX1hzmM	8539	12088	12088	1618115040000	canonical
16825	3NKP8EbGRupJ8onNGpvwEHG7ev1JJGv5YgNw1BK3oVX7qQUb7wru	16822	3NLroE6XUEBkLna88QGYQ4zAapNw8xmKakLCW5TQvXn4o3pxV1jv	171	1374	282	6301	12463	jxc8fmcAjBtRmbkCrY5jMtiuQfXFuHnkZk7yTy7bLzuD5SABduc	8539	12088	12088	1618115040000	orphaned
16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	16824	3NL44DpnF73cH6JMtiiRLNH7mGkHdQ6atb7QjCSaKaoLm4kxiKQp	1643	1299	282	6301	12463	jxUbbuUApC3wLiGamnwaLLboBnLCqF8P5oo5vWdtEazMkbTzSro	8540	12089	12089	1618115220000	canonical
16829	3NLiUbuHGv9PKPAzmdMTcjxEvFXJaJgNsLEU8hGnMpYrrt8VxZJA	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	1611	1341	282	6301	12463	jwXmkhZy5HVioL1XXTGXzNXKGt3gDpsW1g5ckp92jozgPD7PziR	8541	12090	12090	1618115400000	orphaned
16831	3NKGCfuxN25dhbuQAJeSQyW2JuFduGNLhx2b2rtuy3BR3TuMrmUu	16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	1439	913	282	6301	12463	jwdkWN9msyjC8uzghLgm2tP7mvvxQTxQwGN6bxixtDh6kFj1oVn	8542	12091	12091	1618115580000	orphaned
16835	3NKVZCjKyWEZmtFG7fXd43QZakNoZaD7eReGUpBLTxW3sy4SzPnD	16830	3NLKrLoj4M2Wupq4ond14mE9UYLXL44AixEac6wr2csvakjNHKRA	1406	1393	282	6301	12463	jwgmaZDroVzGCfYV3urfRZ6hwsHdVFSbUwTq5oxx7oqweqtzKYK	8543	12092	12092	1618115760000	orphaned
16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	80	1273	282	6301	12463	jwLYQrH7eRLX1q7FDrCzESU8mZvBhhfxU8cXH6snAbBoBeG8oF5	8544	12093	12093	1618115940000	canonical
16838	3NKgKqnSyoSRt7whuX52fTDyfjhUNh3jq7QwQbkMaQrPg8vxSnWh	16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	1506	1127	282	6301	12463	jwkEKdBSECKubX5vgYMS1xc67RemoHxmX8zG48n46MYbUdNZHMD	8544	12093	12093	1618115940000	orphaned
16842	3NLX36LD5E3dbuwDv915qA95dycPJY3t34S9LVx3BqZJBbWTq5xU	16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	1406	1393	282	6301	12463	jxJUMzRqW7DM7XazPCVBi6ZQf4GgA5dzQqzVEJEVydnN6AW1VWP	8545	12094	12094	1618116120000	canonical
16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	16843	3NLmCCQRBN8azxWEPZ4u1dHqRKZNafM3LodAcxcujogGZdGLdLgh	1672	1159	282	6301	12463	jx1mdPQmwxhfzcJCsmDAFeGvWXoS1TQiRSUyrXFYsYuqCSbzdZZ	8547	12097	12097	1618116660000	canonical
16844	3NKGWUBfJcuSbqpA8XJBCeLZdNudDGf1RHVVv1wjSy2dQRrgRQkt	16843	3NLmCCQRBN8azxWEPZ4u1dHqRKZNafM3LodAcxcujogGZdGLdLgh	1613	1103	282	6301	12463	jxWdQiwszh6NMn7eDpWrHfDb3Pqs974NxSbE1JSUeULcdzMMi3A	8547	12097	12097	1618116660000	orphaned
16847	3NLsJ23ZidsRkxYJQaBMWeK4vQ95md5E4Fdwt75DMPPsTo1K17P4	16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	1634	1085	282	6301	12463	jxDrtB6nVWZfRhK9aDF575g6znrtAMudpTcWE2a9b74nSSyUruX	8548	12098	12098	1618116840000	canonical
16846	3NKpQjKQum2zQxfbCWkTmKMPzSfaJDfNTWyZQpwD8ggiNHU6URVa	16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	1596	1363	282	6301	12463	jwhWoUgMSi5E3EUTodpLLiAV2PjpaRzR3khb26kwjio9WiV3upR	8548	12098	12098	1618116840000	orphaned
16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	16848	3NLDyUkLDCHmEaw3SZbXH1CB7zYasZ22cN6xMakeAja9U6kMXt4b	1610	1314	282	6301	12463	jwYGqNGPfASqsgfqXewPtj2yu8J5bqYxQRxRUk9Y9TcQ2u4ZzUC	8550	12100	12100	1618117200000	canonical
16852	3NKDaLCS398L5suxUhQSP8zTJ65utPN8QDGmyCH6cwzYjiU993nC	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1527	1293	282	6301	12463	jx569EazUcuAQcEKKTHUrGP2v4SBu7CerHXcMS5pf1YmuJZb681	8551	12101	12101	1618117380000	orphaned
16853	3NKuw3guPncyJ39QvnBt1WJvYWHwa18aRnWCgZNDmPb2mTcopwCz	16849	3NLfYcoEWkVVLeNfs1FKXoDQKJrYYZyFYmH9SQDGCmo6rK61PGt9	1527	1293	282	6301	12463	jw9hevqJbTG9oeLrHAiapUXJKsydL3hF15hHjsHtks5Tck5EZXV	8551	12101	12101	1618117380000	orphaned
16864	3NLgziZh2vDLQ5Rwme4jPesw47CPK2a18gsYkB4H6KqExLocymVJ	16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	311	1307	282	6301	12463	jwnLgwvgC7hUPKzQX4U9kYqVERZjxHuWFnfNYTjLxNML3NwCD7o	8553	12104	12104	1618117920000	canonical
16863	3NKkvJekcJnn51efqjp7GxMAsCbXLgwDsLJCPcKtcA84T1fQNb8T	16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	1654	1340	282	6301	12463	jxDDrNUqRpvxLzAXguEkG59NDUTMBcqsZPqAiQV6r3ED5BfGPyB	8553	12104	12104	1618117920000	orphaned
21077	3NKqUXoz8eSfEPn398twk4487Nn19LReVCqcStZUUAhQvHEcRGBn	21073	3NK9ThfUUg7DLQZq1xFerRLAsACjUkbFv5K98x39o4dWUfSEimq7	1402	868	383	12463	13339	jxG61jTkGcKe8r1zuFW9xPW1fuUvwmNSqGnixQehZvKsfdndvCi	10589	14910	14910	1618623000000	canonical
16878	3NLaFpH3NgMCBT8TPqjc5hKr8j68mz9rz5z67Ea2Rhv5PDCg9X9X	16818	3NKUD9JhroSBjAcWzwGtXnyDvunB1v9kwrzYu75Va1a9xhPSu9qg	1542	17	282	6301	12463	jwcLrNiiEPkFXAyPCSkygNhn4UaQjHMk5HbXud2ETMo36t5K7aY	8537	12119	12119	1618120620000	orphaned
16865	3NKqSatPNgcyPbznsAGAaNbVnd8FhnHk9Y2yzWf2ZrW89xvWJBYL	16857	3NLk81eF5KtFMLzsu9Nnsx3PmtRcPy7BzUoHCzpADggXuBcaYZFp	1633	1144	282	6301	12463	jwz73VoHW5n45QXJve17uhsSvnNqNadnAGGdG9uRMnRzSkSDZxj	8553	12104	12104	1618117920000	orphaned
16866	3NLMqnWKEiEHQwVMacyx44DgVxt6mjqw7Xn9Hrt2ysXszY6w1mJQ	16864	3NLgziZh2vDLQ5Rwme4jPesw47CPK2a18gsYkB4H6KqExLocymVJ	1406	1393	282	6301	12463	jxTUDFkoLL5MKFpSu5fALJmm89edgWHoqmnqjbgN9DBDDECkUg1	8554	12105	12105	1618118100000	canonical
16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	16866	3NLMqnWKEiEHQwVMacyx44DgVxt6mjqw7Xn9Hrt2ysXszY6w1mJQ	1631	794	282	6301	12463	jwH6EPqwP5Veefkoriok6WKcFwEWqVUdH4hSUc34HduVceST7Mw	8555	12106	12106	1618118280000	canonical
16869	3NKMJY5yfbd1cY1FezYQLFCwLGNmjgvmmbKzehhVhSXB7FiD2J5S	16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	1581	778	283	6301	12463	jwxfeabRrzU8cD6qX8mLMp7T2A1ekq8uEkzHMR9cXfWUJWJZ699	8556	12109	12109	1618118820000	canonical
16870	3NLjf2CY3PChZteqzyo2boVGV5GMiDpe8622tqhFb7b3GVybvV3x	16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	1471	1386	283	6301	12463	jwEnP2CNxGD9yzE36f9fmUpJjrQVPXzZtjo6vB9AdD2Z8GmdY7f	8556	12109	12109	1618118820000	orphaned
16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	16869	3NKMJY5yfbd1cY1FezYQLFCwLGNmjgvmmbKzehhVhSXB7FiD2J5S	1407	1395	283	6301	12463	jwUKsEiH5gKpC8Sky6fpmFDUWZwdWAA3prpXcenzbiQq3UVQaAb	8557	12110	12110	1618119000000	canonical
16875	3NLBQb14oLpNauVCrhALrugbfdPorYQCZqNH5BJbiHy2togJsA85	16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	152	1204	283	6301	12463	jwA6oNvJhyAyptdJPUWAx7tJLqWyzX8ZVX7CWgUo7ELW4nC7yiP	8558	12111	12111	1618119180000	canonical
16873	3NLSdRczbhvmTWu8pH7PFQiRoqERrtWd2SBDnQHNHdKtqtAuupsB	16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	1444	1135	283	6301	12463	jxbjnhe36fuQY8ZZEn215QCi12zsmF14UXTRywCNeDAK1nDNzmQ	8558	12111	12111	1618119180000	orphaned
16876	3NKgLbgFuAFnQAJMHU98zCg4gPYP6GrLF1XpTGdSrr3ZXgQKjt3Y	16875	3NLBQb14oLpNauVCrhALrugbfdPorYQCZqNH5BJbiHy2togJsA85	1407	1395	283	6301	12463	jwayqpmKc5559D3vxKktsyaSJ9djvX1dtxDJBu6PwfEoMAusGoe	8559	12114	12114	1618119720000	canonical
16877	3NKLaD6CmL5ragGd4P6bAryrHjPQmS7BczGVpnkD3Jdtt3CY3VG7	16876	3NKgLbgFuAFnQAJMHU98zCg4gPYP6GrLF1XpTGdSrr3ZXgQKjt3Y	1407	1395	283	6301	12463	jxHTU2oPE5SZBSqbsFgebRDtXWKFU3aMwHTse27WdTMCEHyqVy3	8560	12115	12115	1618119900000	canonical
16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	16877	3NKLaD6CmL5ragGd4P6bAryrHjPQmS7BczGVpnkD3Jdtt3CY3VG7	1542	17	283	6301	12463	jxSaF1RLABjqWfmu5WWLX9m3FufiwnvSFCJV4FAtAAmPaNvcuEC	8561	12119	12119	1618120620000	canonical
16881	3NLrVfpphT5gcndPqgJ64Pvw2sToMfPsc3HxevpUfGxTS7px9tjt	16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	1501	1360	283	6301	12463	jx2FBrm6fGUYtQmfLgQKiWmji9Evpsk7NMyPsVLdCUsccZ2fsuz	8562	12120	12120	1618120800000	canonical
16880	3NK6wnnLv3V6t2gBmogMCGjhQbZVpet8ty4enYsEyowyw1pW77PT	16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	1549	1362	283	6301	12463	jwNYqyvg6eyXzfQDZZVPYtNTBP8mx7GGZAj22w6b2DRxJVwmNtH	8562	12120	12120	1618120800000	orphaned
16882	3NKhyVbGRyeAfQJX4En623KK8QQQsY3gb5SShpasFUovyEsdMnSp	16879	3NLAEP34VFRJ9Kpmf2TvFD3UDzRbXHssvGu7qG1R5u6y2jrUSHa8	1553	776	283	6301	12463	jwywhwzp3KUFafWvAC7kSGwUL38xKXWuaM8XYKRJL2c1X9Rm3im	8562	12120	12120	1618120800000	orphaned
16883	3NKb33ge66ZDrNGVxTWd6hvc4ARcBRdo4XC72ZuyNVzFQxoCSoVX	16881	3NLrVfpphT5gcndPqgJ64Pvw2sToMfPsc3HxevpUfGxTS7px9tjt	1534	1317	283	6301	12463	jwNNdNLqmgW89mrBZZ1Mv9MGsUhH9C3QBmDC2spWKeXEpXxx1aN	8563	12121	12121	1618120980000	canonical
16890	3NKPkfWUrxwbdSgZAMmPh4M9KtUZ6nKdSEaCxhVdZiqPdoY7gccV	16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	1419	814	283	6301	12463	jwk7FkyGya94xBzE66BoaEJ6wS6W56fWyyhkA3mNyngJTfk3eVt	8566	12124	12124	1618121520000	orphaned
16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	16891	3NLDijABx7U9gHibvuBNzPkCYLcuuvKD16tpUJT2rUtvR4qy6Zhs	1656	1343	283	6301	12463	jxXFPYb91tj16iE2m8hiQVcJQX5hSsx2YqW96et13JGB3mYswRs	8567	12125	12125	1618121700000	canonical
16895	3NLWEjnRzbDvfL8SSVj531hzMo9NfV5eE8vrGXhZJa6o6mP63xFP	16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	1581	778	283	6301	12463	jwNebTQorfUPW3v95okSnuiFD1HtSZWD3ZjUbUnkSwhDECCHkiq	8568	12126	12126	1618121880000	orphaned
16897	3NLu9kHE92mTHCULBZaxd6dFrLws7tPhF4j88ztbZv4ad2QRAKGr	16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	596	1306	283	6301	12463	jwey6dv2a1MH6NrRtf4ZAZ2DFFZJVFnhnXKiojrpmNfHoxnt3CC	8569	12128	12128	1618122240000	canonical
16903	3NKzZLQtSYA4rT1wB9xWK59DZFXtZg5v3VydNxT3MMUZ8TUrnrR5	16902	3NL7ACpmnoccX8hV8Xy1ZL32LS4SPDzXvY32gKLURvZd73yr1Tff	298	1308	283	6301	12463	jwe5EFzKFS6SxLTzAsaBKb735omUbxap5Z3A98JY7MhFy4yHYxs	8571	12130	12130	1618122600000	canonical
16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	1579	1263	284	6301	12463	jxoAvSanHbV7YE1cM6kFqYkKa9Hv4au5XEHa8EyN1Ecm4VARcEb	8574	12136	12136	1618123680000	orphaned
16912	3NLxJ2NNnixSHJoEdPitiAKidHCtNLboxoJj5NHMqehrZWRWznpb	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	58	1035	284	6301	12463	jxahaMNniBMDutAneXrgjvnX8obsoXuftTcs2mSJDmsgmC6LyVQ	8574	12136	12136	1618123680000	orphaned
16914	3NLAeGmpviVNzbp5UHjYwRdxEgcepoeQGPPZhGqVQspddxi6zVmW	16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	1516	1168	284	6301	12463	jx7jSsQKkLLZmn6gdw8t38hfmXhZnm9DaWPiSNXPAyivxAae1Bb	8575	12137	12137	1618123860000	orphaned
16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	16916	3NLi3NWbS9LgBq36poFC6CJCGVL7Cj3GGnPxGzz5gvELNy5KV5Jj	1577	1327	284	6301	12463	jxsqwAAeUKexivJLHwiqUkQuYbbppXFjeQ4BTiaAcozF53QKwfQ	8576	12138	12138	1618124040000	canonical
16920	3NLGMMQJpmLJaJU8hzszrdEA3QP3ZQw7s4U7DWSKjC1bk46sAda8	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1406	1393	284	6301	12463	jwbgFD6MjGNAx5mkxc8wfFy8pSipJdu8rCSC2VGBhC4LgewuWR7	8577	12139	12139	1618124220000	orphaned
16923	3NL9dwJeRcWjdGjnrybSeKDG8y85gLWjkasc7CQJP8kWook6JxrG	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1633	1390	284	6301	12463	jxE3eLeMwrDUt4N5iResch9JdMaz5rAGAdayDpj6ViZvqdax4tU	8577	12139	12139	1618124220000	orphaned
16928	3NLBoyaXMDKtxpjLUWZVCZJT7zDLJVUzta2dUdppkqgd5NAqf2Rz	16926	3NKeK1bj6wELVtkUuMGdmjEhtD85NwChWk8bSGsWwTvvoTe6iMXU	1553	776	284	6301	12463	jxEVB8CHznfUrwgnQDdUBy9ba2hcwvRLQM4GdXV4cco3vyWK5j2	8580	12145	12145	1618125300000	canonical
16930	3NKmg684igcqRmaknZrTW7C5KNYm3KG8pxCtGpu4616RaycFcPsh	16928	3NLBoyaXMDKtxpjLUWZVCZJT7zDLJVUzta2dUdppkqgd5NAqf2Rz	1601	1262	284	6301	12463	jwAw34LvwxkRvtNSqGrNhrD3u3XjvUNrN3H8yHorXvSxYDQxvMQ	8581	12146	12146	1618125480000	canonical
21088	3NKjnh1a9vzkpiguBmujoYKNjby81vMre5afWJ6VRKxm9vr9HFmt	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	1613	1349	384	12463	13349	jwYRFphWZEGqetc934SVfHSQJgZXLRt2UBa8oWSSAzhSAR65f25	10594	14916	14916	1618624080000	orphaned
16899	3NLTY8EYd8KdrGWcwPXGrAcPwPJfmGVWHToSMuE1sMoFG1pfRZuP	16869	3NKMJY5yfbd1cY1FezYQLFCwLGNmjgvmmbKzehhVhSXB7FiD2J5S	596	1306	283	6301	12463	jxC2Cc5EwgTDCKUo1ENQiBYBQkNd2CFjFGSmC5VPTJxdDgWi65W	8557	12128	12128	1618122277492	orphaned
16884	3NLJEkQimrvgMTAqoDP6m5vT2GcUgmL91AJLAZhvekGjTv9gDLpZ	16883	3NKb33ge66ZDrNGVxTWd6hvc4ARcBRdo4XC72ZuyNVzFQxoCSoVX	1457	1025	283	6301	12463	jxUajeVNDtrzbBfoESYdyuT45gkrwM4zVFTGE1npoQWsE2Jj1R3	8564	12122	12122	1618121160000	canonical
16887	3NKicx2tznWyYGrqKXmVxE1VXtw49XE8z8PstdVG1nbmskGpGzrZ	16884	3NLJEkQimrvgMTAqoDP6m5vT2GcUgmL91AJLAZhvekGjTv9gDLpZ	1627	1385	283	6301	12463	jwVGpyojMe87ozYtZrbKNuQdRcRQzY94AhCRFTDV6TX1H8wMffw	8565	12123	12123	1618121340000	orphaned
16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	1588	1146	283	6301	12463	jwupgeM7NB9qPKuPkh6SBqVFrqF9Kq5DyPrXxiKh5jAMGkSR3Lm	8568	12126	12126	1618121880000	canonical
16902	3NL7ACpmnoccX8hV8Xy1ZL32LS4SPDzXvY32gKLURvZd73yr1Tff	16897	3NLu9kHE92mTHCULBZaxd6dFrLws7tPhF4j88ztbZv4ad2QRAKGr	1631	794	283	6301	12463	jwob4K13c7PX3cdw4TCejRdN7qqVQykdumRpzdYY17vfQNiK8aA	8570	12129	12129	1618122420000	canonical
16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	16906	3NKyijw446tcafkoVgrf5ojDka4NKh6qLx4pwa8CFk1stHNFKdvv	1500	1297	283	6301	12463	jxAJ1Ak3MHH5RSoHKeujJn9ZRpbWXmag6HQ5jQwdZviuJKdowAo	8573	12134	12134	1618123320000	canonical
16911	3NKViQLdJMXrnm4bceWTPiHCrNNnr4PgQk1L1WTeKP47D88heT3X	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	1555	1101	284	6301	12463	jwV6BTD7xhvRoiwdy4Wf5TMB8bsq4987Kb9ZMGWxKrSqSiFG1FJ	8574	12136	12136	1618123680000	orphaned
16913	3NKAp9TjkJH53Nuae7ps4JRTYRzA8oVGqMENy12ChNbKUa6LCpKa	16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	1588	1026	284	6301	12463	jxz5ceybAY1VQWZHTzsqB4YnUM7HDyvfHrRwZ6JvEdQqp5qNbKq	8575	12137	12137	1618123860000	orphaned
16921	3NLfu7Hkueoi4v6qyqF6K151fU4PLLa5pLpqPjRBZ6eDrBMHsKKb	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1553	776	284	6301	12463	jwCfVxChgguShyMDHNH48atViVPCvGzxdxkE5PhEWsg9rkRuYHL	8577	12139	12139	1618124220000	canonical
16925	3NLoBSQq8kbVZWjWUm69KSjqvFJHHehRCTtavPdEeKYYZFig9zL2	16921	3NLfu7Hkueoi4v6qyqF6K151fU4PLLa5pLpqPjRBZ6eDrBMHsKKb	1458	1323	284	6301	12463	jxuZQ41gtX6G1o129ZkuXDBe8Z5u1WBqHTBmjEm5MdpB2u5GoEn	8578	12143	12143	1618124940000	canonical
16929	3NLBSJibx2VpPmVbZtBqEQkZjiktLmvsB4i75vmLjaJwcCt2dJug	16919	3NLuEgs43gBNcXcWa3z5zHtsiXLyi6DxzsajKH3jbzoBSxsQaYEc	1601	1262	284	6301	12463	jwKC5LKs6jGpwJErXgEroAdckyknnfUKBjptAhLzYN8oDBsR56m	8578	12146	12146	1618125480000	orphaned
16927	3NLMWVqwSbVxgjLD6hNpfM4SDzvsgjUVundrTjPVsDVvgkWXCAvi	16926	3NKeK1bj6wELVtkUuMGdmjEhtD85NwChWk8bSGsWwTvvoTe6iMXU	1522	1196	284	6301	12463	jwmjAV9BL1jFXJz2Q5TSVLyepXZpetCHUzwxsD443aEx931RWvB	8580	12145	12145	1618125300000	orphaned
16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	16933	3NKSUogbTJ6mwb6RAJ52CefuGWEnHE9A1cPAuJTRxRwgfRZ4Rju3	1451	926	284	6301	12463	jwAUEa1VQRt4SRTN17EEkaqoCQFrGgLRhTXVzRRepjsMhh3GiL1	8584	12149	12149	1618126020000	canonical
16940	3NKtCSWhj5EmS4URtrzokcqwntUzwDFb3cv3rQCpisfBjU6nYHWW	16939	3NKzY2QHnDthMUNayj8HG22oy7KVtNTf3kQeuEG9uXWfvom9TKJA	1407	1395	284	6301	12463	jxAf1A2LZgvduCUtytbEL2jEyLk5UAqdv45DAJFxK6c7sLUTefW	8587	12153	12153	1618126740000	canonical
16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	16940	3NKtCSWhj5EmS4URtrzokcqwntUzwDFb3cv3rQCpisfBjU6nYHWW	1406	1393	284	6301	12463	jxoW2wdCA8jo94X35jf54sk83jQMJHAbhe8MZCM2Asp6KBsFbgL	8588	12154	12154	1618126920000	canonical
16945	3NLBXCGmjVdDuQz5MV7aXRFVVRqrnUCeoWuztP8L1X1bTQpNmMfs	16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	1407	1395	284	6301	12463	jxPGMgopi1Ku8sPF5hgWgTT2Ka2ELydMELDYCUzjQvXe15T5W84	8589	12155	12155	1618127100000	orphaned
16949	3NLRSXXhELYtZMH1KNS342w9yFCcV8p5fHmHTrX3t67yQgrR8A2M	16948	3NKgNMWMpHyjUi3oM3XTZVw6uuyNkKfNFQH5r8ZxsNMD3Ezr1g4F	1406	1393	284	6301	12463	jxmvD96upcMfb9fSzfJ6cJadu57z8xJma5Z7QWVXLoZd2jfrb9D	8591	12157	12157	1618127460000	canonical
16958	3NKSqPJP5mCFshdHa1utkc5prxfB3NScYbcjdNnLzqHdvwSUh7KA	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	1406	1393	284	6301	12463	jxuuhJghG3J6nhmgtygpgy1JipVhVNa3345H5ZuWDqiNvUfeeYb	8594	12163	12163	1618128540000	canonical
16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	1613	1103	285	6301	12463	jwq6q4Lox7YLTjLYRwqGy46fuzSsLEe7zbJeB6eJwyA1Mmxnu5d	8597	12166	12166	1618129080000	orphaned
16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	16965	3NLAtRqb1sc3HKnNJLbC1c4fK31BQ1znhPMZDYWJPrZPVqgsQJMz	1542	1304	285	6301	12463	jxsUEzpD7DouPcdgjeTjrkxM9JhXWtqvuKbRxNTTHVdU1SbWpZb	8599	12170	12170	1618129800000	canonical
16973	3NLwYLW2LoQcvSrQFrPn7Z31EjxRYMU35a4bmXrPW1J9oWcWkkHm	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1610	1068	285	6301	12463	jx6ah7wsDPp8b3w8qEfDsg2NgNFBa6XFXtHMSEPcHFTXb3PSDLq	8600	12171	12171	1618129980000	orphaned
16978	3NLidSiqUJASzsfFbBuBywj66rwqKSYh5ngbZFd9Ntf8mZDTnt9q	16975	3NLtpnhuv9XfmmbkUPxw4vXVQZnyb5h55rQw2zFnmNDRsVcSnA4p	1581	778	285	6301	12463	jwTjSdvymmNfwXapoVzg8CerfDtCkN6nX7y26oC5AhCjMrEPUoz	8601	12172	12172	1618130160000	orphaned
16981	3NLZ2LPogsaceW9iUV5z3nUUqjFjNkaKeTEcmQUiLttHg1ETf4s6	16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	1527	1293	285	6301	12463	jwEoZj5itw3P6ARjhsoVfZw43nA88GwcKxAefdyMojvt2cAwuiQ	8603	12175	12175	1618130700000	orphaned
16988	3NLhT4iuNaW5wuwQ8dsLSyzzGvgib8oj7BE2NdH3vVDdgrpW1YYz	16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	1523	1075	285	6301	12463	jxxhi1yv9udB8oi8k2PquErEPTei2x1L6Kxk6s7zt5YZbvBgkpo	8605	12178	12178	1618131240000	orphaned
16990	3NKNua7QfmDn3T939hzh19CHLvzuXkxkmcv8hfpLTgU1kP1EypGn	16987	3NKx9NeHsjxtDAtvf2ZK2gLzuaTgaJRk1gZH1r5RP9KpYGFfzGP1	58	1281	285	6301	12463	jxtRb9KwiQqmoozBxUyGqg1AnyGfF6NCncaE4C3Z3H1DsFyBaHV	8606	12179	12179	1618131420000	canonical
16999	3NKk6sXqpthU93nxkQVmzs1x9dCTniyww9giLx3gEcGzmf8FpA9a	16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	1483	504	285	6301	12463	jxEsoRrHQ5vyRFWP9RbLJ4AgPZ65xVUMZ951FuXcjqqzcWVL6zT	8610	12184	12184	1618132320000	canonical
17001	3NLnMyWGRhhrRjU47kAb18fyeLktD1d4vRVCAuxXy76SviWUhPu3	16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	1651	1055	285	6301	12463	jwvYjiVEZ9TnJqRgGjRGAuLrqLZ6zG4ffuNmBmzoY8D7qyYQJ4i	8610	12184	12184	1618132320000	orphaned
17004	3NKjzRWQT4sEVxSLHmXCwM3NKJwy6Um9awH6K96mGkG52P149ybj	17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	1573	1318	285	6301	12463	jwWtwku6UxvWHqEY8sJXbbtDuBQiK5CrAG1gcehC4FR7KpbHXRh	8613	12188	12188	1618133040000	canonical
17012	3NKxMRHJBc1bigjbNTsKQY84mPf1YA8T3V5KyJEgXqW1oGD2Nggg	17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	1581	778	285	6301	12463	jw7sznoNPCdRysTm3LnAUBuNHJEeCfqr4tDmt5ReWxX1PyE9rJg	8618	12195	12195	1618134300000	canonical
21096	3NLFq6bJ4HxqXoES7CEPTnkqaY1ZUywWCdR9ZtWTW8KxyQAHB5qm	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1523	1075	384	12463	13352	jwdLqLcwBk9eH38SGjJj2SLTzt1YQpjBmdMZ4n6YRL62A6wbwYK	10596	14920	14920	1618624800000	orphaned
16969	3NKUSXhxj8mqYUhxBVK7e4perbRwxoFAfM8WArcQ93Sw4mVpxvec	16878	3NLaFpH3NgMCBT8TPqjc5hKr8j68mz9rz5z67Ea2Rhv5PDCg9X9X	1542	1304	282	6301	12463	jwx8oCyHqsRVynjhN9KhMLo9i5b6WkyTEToXESXaskhakRSECFJ	8538	12170	12170	1618129800000	orphaned
16894	3NKph8Hsh1UoK7yZeQhVwMtbZirKJTiWhD21HmHJVYixAP86VMns	16892	3NLsrgW9CNCd76ecmPcuBndJYSS3uhfwomdGcKM9bUvVJy9FhpL5	1407	1395	283	6301	12463	jxKjAagzfAFL8p6y4TnMNE3Gm3fcRiUYDsMg37AYtmuPvWFC6ZE	8568	12126	12126	1618121880000	orphaned
16896	3NLp4W98un16HSCR7PcWj8qDSxCrorTcV43z7guacsoxeVHuCPje	16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	1457	1025	283	6301	12463	jwYsF8bm84XuQYe3qWt9P3B5b2YW1KKshN89jhRoECfQwUu4kHM	8569	12128	12128	1618122240000	orphaned
16905	3NL2aE35T3PY29W5V5HcNsrgwGpHzCTViueAHUQ495YStZu582nk	16903	3NKzZLQtSYA4rT1wB9xWK59DZFXtZg5v3VydNxT3MMUZ8TUrnrR5	1522	1322	283	6301	12463	jxpztJsoXEpqp2Htpu8mULgwND2s9nCTZZhq7HAa2UAhJiVkm7W	8572	12131	12131	1618122780000	orphaned
16908	3NK4i1NTTy9qSAumARQwDRSkkhMPoiskrNdfS9r3bXQs3GiKKG3F	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	1579	1263	284	6301	12463	jxoAvSanHbV7YE1cM6kFqYkKa9Hv4au5XEHa8EyN1Ecm4VARcEb	8574	12136	12136	1618123680000	canonical
16919	3NLuEgs43gBNcXcWa3z5zHtsiXLyi6DxzsajKH3jbzoBSxsQaYEc	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	684	1106	284	6301	12463	jx7FTTXs6qKmcAWKD6piaTkBzw8PvAarZF4ncw5z6MfSyrsSbU6	8577	12139	12139	1618124220000	orphaned
16922	3NK9EZfhPSBNK6LTFb7Zd2zt8exzBWTayvEhymL6cXp6Q2yMbcDG	16917	3NKupPHKMQgcYk4ZDMQFCHAYZtKd18FF87EQRfDoceRPt6GsDVbv	1623	830	284	6301	12463	jxN8Pub6fb3EugJ47X5jA4EcfoAwaLtizXcfE2JRoGHMUNxjZGf	8577	12139	12139	1618124220000	orphaned
16932	3NLneBwFiB4KynCy99ojVFcGMqF4CQFDV1biohg2vjAjb1UUzh5w	16930	3NKmg684igcqRmaknZrTW7C5KNYm3KG8pxCtGpu4616RaycFcPsh	641	1336	284	6301	12463	jxmK22WyNKG59tipbrtYctBjCf2xaT4Ljpzbw5YhdnR3dSWaXAS	8582	12147	12147	1618125660000	canonical
16934	3NL8pcM7XuzmZmk5saGs9mzNgBpCNCKaP2PziNY5GkNnhVcwY5Bw	16932	3NLneBwFiB4KynCy99ojVFcGMqF4CQFDV1biohg2vjAjb1UUzh5w	1467	1376	284	6301	12463	jwiYyE5saef7UtfkKFrATqDLeaCme1YXxY71GbihjbudCod568K	8583	12148	12148	1618125840000	orphaned
16937	3NKG4z4qM2aSMXHa2YmLzMX876TCicYFYNjWoVjDcv8gPgHRPNpf	16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	1406	1393	284	6301	12463	jxnNspraqaZfR3mP32yUMft718FrhRrWV5C1SJe4uaXiU6D5ce7	8585	12151	12151	1618126380000	orphaned
16939	3NKzY2QHnDthMUNayj8HG22oy7KVtNTf3kQeuEG9uXWfvom9TKJA	16936	3NKCtQgbsdcCBau2dqZ4HHg1uvFpZGhn3ansmw9CFBCTA6aEyk7A	1500	1297	284	6301	12463	jwi5WBFwfK7WpCip8JQBab9FQarHf2EqZsrHYL4yF5iM3cG3gx5	8586	12152	12152	1618126560000	canonical
16944	3NKcCZTahaFa8NsiRdBXviuHccSSnbYWyaeffH71exeHAUurCHuy	16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	1642	1001	284	6301	12463	jxPE3oVBQJisCSVYrFpKavSky5NfzsLwdDDage7eFFJTmb5eTe6	8589	12155	12155	1618127100000	canonical
16948	3NKgNMWMpHyjUi3oM3XTZVw6uuyNkKfNFQH5r8ZxsNMD3Ezr1g4F	16944	3NKcCZTahaFa8NsiRdBXviuHccSSnbYWyaeffH71exeHAUurCHuy	1647	845	284	6301	12463	jxCtCYQxLFx5sfdWMECy7dikz3MM2ozR3Mx92FNZS7Ne3Lfv6Qx	8590	12156	12156	1618127280000	canonical
16951	3NLZx9VKkVahdtf74Mc4tzeWaUNVbfpLREWAB47oxrgkRyFHCvxH	16949	3NLRSXXhELYtZMH1KNS342w9yFCcV8p5fHmHTrX3t67yQgrR8A2M	1560	1045	284	6301	12463	jwHBYcYBiKRqt2g1z459GvrKUefWxn2zxL1v8jkEVczeUGNGRdi	8592	12159	12159	1618127820000	canonical
16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	16951	3NLZx9VKkVahdtf74Mc4tzeWaUNVbfpLREWAB47oxrgkRyFHCvxH	1403	786	284	6301	12463	jxdygPA1MhYzSTypt7kQoM1Tq7Np1VDpnnp2P515U2posx35jig	8593	12161	12161	1618128180000	canonical
16954	3NKcSKGD2c1VPw7DEwagNaESdrsZpwCcR4fTd2XaQBPJnGK6Y3ct	16951	3NLZx9VKkVahdtf74Mc4tzeWaUNVbfpLREWAB47oxrgkRyFHCvxH	58	1281	284	6301	12463	jxk5Mf1Ui1ARJoTc3CNP3KxNTcu4j8X8CRJXMXcp7Rd1pM2e3n9	8593	12161	12161	1618128180000	orphaned
16956	3NKc2wFzh8h8r2gscQ14R1EHdaN3Z52KkipMfed8v5zsAsnhQgt3	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	101	101	284	6301	12463	jwnuhwPgwjRZRjg4p3oJvwAvXB2hcKtjHjZEfssgvDcD3qhetDD	8594	12163	12163	1618128540000	orphaned
16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	16959	3NLS4Dp3B4abDYbx5ygEkBhSeJC4HHryfzBiDwy7cubmCmNidzYN	152	1084	285	6301	12463	jwJ31MSWcCdcmhzBxJWgdjkVxJs4Phx8X12xkV6TFm2veVTChew	8596	12165	12165	1618128900000	canonical
16963	3NKQ11UaSR6FGacFiSDVC82QZRuPQ8oS3VVVPonvbXDjqVMhGmKs	16962	3NKebnZU1dMFom9t8cLDzrwp7UXYhnwnfvP7jCwMbx7QfeCycazJ	1672	1285	285	6301	12463	jx2vWFtThbNfszTK18kxnydBu2GzizXtbrbotdKKTiFD4xowDWL	8598	12169	12169	1618129620000	orphaned
16966	3NLMZRJ8izxJmweovygbPYqmYC2Y43fgV63Newv27PSbwmecKV3x	16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	1571	1209	285	6301	12463	jw9RKMX9Jotwb1onn2kPkyRstNe9YMT6zGoXKbvfrf2PQK9wn56	8598	12169	12169	1618129620000	orphaned
16975	3NLtpnhuv9XfmmbkUPxw4vXVQZnyb5h55rQw2zFnmNDRsVcSnA4p	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1523	1075	285	6301	12463	jxrkSfyw5QDXwwhdEFw29UyoMQ15xBokTqB8zTLHvwUSd2njLiY	8600	12171	12171	1618129980000	canonical
16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	1599	1041	285	6301	12463	jxGsEUAZDrLvv38DA6XpMFnA9iLsGN5LrmUwUKQDR6fnf86yKvT	8604	12177	12177	1618131060000	canonical
16991	3NLR6xHi3RoVhpwafSK6qUSpmcsZYaFph3pughduv6ZWwW9myGqP	16990	3NKNua7QfmDn3T939hzh19CHLvzuXkxkmcv8hfpLTgU1kP1EypGn	42	1361	285	6301	12463	jxD1j7NotC9bTnLkqNLY2vfPhQhHXu3LBspALXY26Xs4k9Yyins	8607	12180	12180	1618131600000	canonical
16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	16994	3NKatsiuk1qJL2vkH5oYqGnMWJwz2zWZnhhzDUGHYqa3fGRZRvZn	1547	1012	285	6301	12463	jxfcfEwLjf24HAK33zfem66VHDhja8wCGSbKXdxj1uCwk4NjYQG	8609	12183	12183	1618132140000	canonical
17006	3NLiGhqZfuE4w6SCRULtURPRZ2dPPmS6xkfW79Bc8tdgRqf4xPoM	17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	1651	1301	285	6301	12463	jwoxvrsoddmTfMwiLQRFXZHcRCXh92pk9oUSpwBZSoPxXUsye7g	8613	12188	12188	1618133040000	orphaned
17008	3NLi5wnB1U39FuzELLJWfMWHtpi6t4EhsadkXyVCtZ7ddzNXVnvL	17007	3NLZZ3b9TA25mTG7yPeVVTNLDNhDW3Tw5Hx42VoPBHk53yz448Vq	1559	1107	285	6301	12463	jwKXwAdxQ1As3Te6ziBszsxRb6mV9U7mMdAjmStv9tRrMbSzKZw	8615	12191	12191	1618133580000	canonical
17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	17014	3NKHn4HsUP3psPPN4eGo3F4ndBqFFcxDzQDMxGWyW6p4o6jMwWLc	1407	1395	285	6301	12463	jxveE6CGbBq5CUvke5Lpq7n99L9XaUivdspUDzca6MKENa8hdrk	8620	12198	12198	1618134840000	canonical
17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	1406	1393	286	6301	12463	jxvtRooZwqC39e6pRVxamySGTGfEmdjCXaqVPvwT3imsF384THL	8621	12199	12199	1618135020000	canonical
17021	3NK5grZfudmv2ufT26rMY16tyTKo72w3D5ayVa6JpiVyK9usd2fU	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1403	812	286	6301	12463	jxoj3FCZbiy8v6go6TEFRNTop39HtbVHmcLqdcYreoWgtzGiWn2	8622	12201	12201	1618135380000	orphaned
21112	3NKczj7gfVW1fFCpxqfiHPBJmSD3u93C3hqqDxboLtysVB1GbZXY	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1579	1389	384	12463	13367	jxad62hKa1EfXnxTJzPfr282QvXha8o5cZN18Ehidnb6dJ7SZ7Y	10603	14928	14928	1618626240000	orphaned
16964	3NLT4r9Xrvow13UgTCUFHiKrVEcFkkLAmUTasx9ni2ZgsKevctM2	16792	3NKGgydFyjwKYHuP1JrReo4583qezmoBbc6orCHnabxLJc7fBobj	1474	1083	281	6301	12463	jw6sJtwK6gMZdDamYLCAdEwBcc1Vk5eVaGLFGQdyCGtU4BuCqo4	8523	12169	12169	1618129620000	orphaned
16898	3NLT8QpppKM7VzrpAwbrMX7QfdWqN2JYe5gNX5wRhF3d4PodSD1p	16845	3NKif4yKG8SVxrP4GL57R1jzVEZXjyCPRoUPPFtu72i3jfwvVs9m	596	1306	282	6301	12463	jxxCgF55FYeJfs3dnMepiK3oBTKzaD9MUT4141SfuxC8Jya337t	8548	12128	12128	1618122240000	orphaned
16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	16884	3NLJEkQimrvgMTAqoDP6m5vT2GcUgmL91AJLAZhvekGjTv9gDLpZ	1654	1340	283	6301	12463	jxbkUnfnefqjuFgQ32dtM4YY2myys6GE72dwBiA9tkdvxGLUo8a	8565	12123	12123	1618121340000	canonical
16891	3NLDijABx7U9gHibvuBNzPkCYLcuuvKD16tpUJT2rUtvR4qy6Zhs	16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	1631	794	283	6301	12463	jxGhoNQEuyomHXBA4GemrjwNyFB5oEdmBvCmdyE1Jxxv4EHjC38	8566	12124	12124	1618121520000	canonical
16888	3NLrfxj2cjGvKVAmpeFTTFWGd7QowRkSjXM1VXZKib32yd4XxmnA	16886	3NKwnZjSs6iX4NNxD5a2U7go3bN5V1ESZvyJFmV87GbFHiokvgGg	1642	1367	283	6301	12463	jxw3W9BNC9EnM91fLB7SXY4DrTGaLegCiFATjSXtPe7jJtx3Ucc	8566	12124	12124	1618121520000	orphaned
16904	3NLF7NSyMfu2Eu7ynLSojNdxscJ8hMk9kkFVDQnwaK6XZbKWHCDU	16902	3NL7ACpmnoccX8hV8Xy1ZL32LS4SPDzXvY32gKLURvZd73yr1Tff	1623	830	283	6301	12463	jwXwC9BSPtBV9HDunwhLP1s4k5P9mt9YR3BxcSC4z3Koh9PRbUh	8571	12130	12130	1618122600000	orphaned
16906	3NKyijw446tcafkoVgrf5ojDka4NKh6qLx4pwa8CFk1stHNFKdvv	16903	3NKzZLQtSYA4rT1wB9xWK59DZFXtZg5v3VydNxT3MMUZ8TUrnrR5	1648	1284	283	6301	12463	jxVbK9WkbELkZJkeTZxnPdf6iJMhyrC7uyWYKUxcddmn8RoqYK5	8572	12131	12131	1618122780000	canonical
16910	3NKz6Y92qaKUtumgpvxsJojRMV9F3gEMo8uAXU7h9XYSJYhCjqiL	16907	3NLD6JUKpNuC5aJE3CWmCR6WLZvveSZZmChw3VkJpHKkzExnfqmW	58	1035	284	6301	12463	jxahaMNniBMDutAneXrgjvnX8obsoXuftTcs2mSJDmsgmC6LyVQ	8574	12136	12136	1618123680000	orphaned
16916	3NLi3NWbS9LgBq36poFC6CJCGVL7Cj3GGnPxGzz5gvELNy5KV5Jj	16908	3NK4i1NTTy9qSAumARQwDRSkkhMPoiskrNdfS9r3bXQs3GiKKG3F	1588	1026	284	6301	12463	jxz5ceybAY1VQWZHTzsqB4YnUM7HDyvfHrRwZ6JvEdQqp5qNbKq	8575	12137	12137	1618123860000	canonical
16918	3NKWESWx8AkbSiRERQmdKP8gXP45PTHKZxwBcriVDbpZZn71b7Pd	16916	3NLi3NWbS9LgBq36poFC6CJCGVL7Cj3GGnPxGzz5gvELNy5KV5Jj	1581	778	284	6301	12463	jwFHCYMuL2M6dHqdCxLKYMSwnpTdLAGFwg1sXZr1xAJ57kPuYxa	8576	12138	12138	1618124040000	orphaned
16924	3NKZP7G57Hck8t5RWfKq4usgqkwsCFXwXckmz7oo9d7Socv33QNt	16921	3NLfu7Hkueoi4v6qyqF6K151fU4PLLa5pLpqPjRBZ6eDrBMHsKKb	1513	1133	284	6301	12463	jwYMwqNXAtEM2ifGNoTjPfv6TUz4BWKCXsz3sJY14CZjJPcTXS8	8578	12143	12143	1618124940000	orphaned
16926	3NKeK1bj6wELVtkUuMGdmjEhtD85NwChWk8bSGsWwTvvoTe6iMXU	16925	3NLoBSQq8kbVZWjWUm69KSjqvFJHHehRCTtavPdEeKYYZFig9zL2	1610	948	284	6301	12463	jx7sMbc7TqCPretx8H2wHLHxB3izDpabNkjFiXrXLq97PDbWNf4	8579	12144	12144	1618125120000	canonical
16931	3NLhbUbfytP5xkQUzPiciBUbhzBEtdnDo3F5ctgJbtXPegGQS2iU	16930	3NKmg684igcqRmaknZrTW7C5KNYm3KG8pxCtGpu4616RaycFcPsh	1405	873	284	6301	12463	jxFwL96QB6vonjD6okDMWGKx3Rosn7RAr884brEfQrjaKAfcqiN	8582	12147	12147	1618125660000	orphaned
16933	3NKSUogbTJ6mwb6RAJ52CefuGWEnHE9A1cPAuJTRxRwgfRZ4Rju3	16932	3NLneBwFiB4KynCy99ojVFcGMqF4CQFDV1biohg2vjAjb1UUzh5w	1637	816	284	6301	12463	jxLPbSnmi8Gwq8ijNxgF9zgAuR5QFDxwHSmgELXchk2MUo65uqN	8583	12148	12148	1618125840000	canonical
16957	3NKTtkAY69H4zQux5br2pb4MPjvPnxUdU5YQvoMP6v75FhTiQXi3	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	1509	299	284	6301	12463	jxxknsvezndaUuga8nLe6qspeZ2mtvimPAB7XYACKWvFbbda6V1	8594	12163	12163	1618128540000	orphaned
16967	3NKhWoKX1gRM5EUN1zxhsZxvqCifwbHjxTAbKjdsipTqaHWyDZ4G	16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	1474	1083	285	6301	12463	jw8h1qzkhP8dEaYyRnoGQgFmty6sb5KD26isaee6e4crhn3DjJb	8598	12169	12169	1618129620000	orphaned
16972	3NKhu4jByJWLe56rXqKP8AtTUXwLiVe93JttBmZzoG79dWgVncCF	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1523	1075	285	6301	12463	jwWgREDmPg6YN1mLXc4ZQxixepmDbeaetMS1Jf5mhUZno5udtbP	8600	12171	12171	1618129980000	orphaned
16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	16979	3NLUvhAJErLBzqWre8N4htkFkH3pqNVfS7Phc6yEz39ZQSnnaZW1	1403	31	285	6301	12463	jxz9P6a3MC2zyQMwxEfjtvqCohGS4PuA8w8utQ6DWZCyeeYD5zf	8602	12174	12174	1618130520000	canonical
16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	1527	1293	285	6301	12463	jxwRhEX8gSQSJsizzCC7K5KW3ZpAgeG5LDQkjtoYAiDQ958aDLv	8603	12175	12175	1618130700000	canonical
16986	3NKbQDWrKin89117DRM25Qe6hQNHuLWidvuqxzzuDyHnraqGx8xV	16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	1406	1393	285	6301	12463	jxsKZfYpU1V1fMVuU7T5eU8GMBr7HwQYfaryJXhQfk5aSJETqGP	8604	12177	12177	1618131060000	orphaned
16987	3NKx9NeHsjxtDAtvf2ZK2gLzuaTgaJRk1gZH1r5RP9KpYGFfzGP1	16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	1523	1075	285	6301	12463	jwpNvxDewGJBcjbG3qZfQxnx5oS7MjWxjpVJVunfYDPqueiJVG1	8605	12178	12178	1618131240000	canonical
16996	3NLSMh7MXjJMcv6gQhPexjaUiJnE6rJDEFAVUWiECwALYMRTP4Ho	16987	3NKx9NeHsjxtDAtvf2ZK2gLzuaTgaJRk1gZH1r5RP9KpYGFfzGP1	1589	1160	285	6301	12463	jwJL6jGjwaQDeE5JRQUaZKJfzTzwHYjuC8gmU2EFwUsigbBu1Db	8606	12182	12182	1618131990288	orphaned
16994	3NKatsiuk1qJL2vkH5oYqGnMWJwz2zWZnhhzDUGHYqa3fGRZRvZn	16991	3NLR6xHi3RoVhpwafSK6qUSpmcsZYaFph3pughduv6ZWwW9myGqP	1553	776	285	6301	12463	jww2TUH8R52pG7isEVkvJHa9J9FKBCpz7dVCbpZ9noqY2VafW2y	8608	12181	12181	1618131780000	canonical
17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	17002	3NLUrsxP3ofZZLvmN9guf7AMPzZoKQyKFb28QJpC6TbVAbHdCbX8	1627	1385	285	6301	12463	jxJSLMHEUztq1rMqE81eMbYAWwC9qZ2bGPHGtLjLuAtoieFpPVT	8612	12186	12186	1618132680000	canonical
17009	3NKyscZ7BEfivycYb7HZ9vnzequ44hL72PwJCHdyGgryYmrLE3hC	17008	3NLi5wnB1U39FuzELLJWfMWHtpi6t4EhsadkXyVCtZ7ddzNXVnvL	58	58	285	6301	12463	jxDZPBH4Zgz5tRC7KJ74AMTxEAayaFBZyQizWtH6N4kkTRAWJ8h	8616	12193	12193	1618133940000	canonical
17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	17009	3NKyscZ7BEfivycYb7HZ9vnzequ44hL72PwJCHdyGgryYmrLE3hC	632	1382	285	6301	12463	jwChjArHgkMuAs7Pw9v8E2Zt91QkFA898CL2BVgBNjkfy58FJAD	8617	12194	12194	1618134120000	canonical
17014	3NKHn4HsUP3psPPN4eGo3F4ndBqFFcxDzQDMxGWyW6p4o6jMwWLc	17012	3NKxMRHJBc1bigjbNTsKQY84mPf1YA8T3V5KyJEgXqW1oGD2Nggg	1610	1068	285	6301	12463	jwfA8kKC2Rc48kDLMTdFo1xKXCqgEJ4PayJLVhzRraA6nsPn4WT	8619	12197	12197	1618134660000	canonical
17022	3NLiHkHuUUyCFaWppWkrHTeCbDTMMk7XA2qm3qcZTAVRino5Afnu	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1637	816	286	6301	12463	jwphRpWnC4Ync1qJ9gDzqtfe2pMr6WAPTt8iPurbywWFTsGsy9Z	8622	12201	12201	1618135380000	canonical
17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1623	830	286	6301	12463	jwyJ7hrWhEN4H1eJaVUZ63KPbRvJ2n24JQAAYVr8uyuxMUsWcDL	8622	12201	12201	1618135380000	orphaned
21137	3NLV4F7AdRXmiXuw73gw6izmTJrdq1WCX5abk5Cnqa6aK8SGQ5eh	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	448	939	384	12463	13389	jxJCWCYdDaN4hfaobCsC9dxoLxvKZwi2wJNoxsi9ZrE52Hdvizq	10614	14943	14943	1618628940000	orphaned
16993	3NLrUb5c86vHmLEuvJcvw6m4AKqcjE1hQWu8uXTHvDqMitq4w1Yp	16992	3NLLUDjGtBHMVccARBoRndiLTcEsBgMRwjBoGgxpSYBbC6QWDvXZ	1564	588	275	6301	12426	jw9ZwZ6w9SoLVBzQKARsUk9yS83uszKYfgtoULWmUCykduqyXVC	8387	12181	12181	1618131780000	orphaned
16952	3NKUGCPmAX8E8UAg24azmWMMaBQoHABD5PiJvBxf3rTtbCCtW9oJ	16491	3NKoTukgwFyZquYxMaCRNjJ1uCrBvSRBFEgBW4R4FkJv4ABNR7AR	1560	1045	274	6301	12433	jxdR6ZzAA3D8ycftzbJ3PJjn43okFVqN9AmkyVz3gDBSaX7TU7y	8388	12159	12159	1618127878038	orphaned
16947	3NKxdjatChYKGsjbWgB3HdJ77haZN5GtFmF6KCRHd2YEsFP9Ggvx	16889	3NLmbfHQBBF7abanzLhifTT6mvs9nxSUYg1agrGFxnZtsFyPZvaG	1642	1001	279	6301	12463	jwsZuQwaw2gUBhU4W2yvJGzaNbYwaBdogRkkt5XdKYPmodoaBEi	8461	12155	12155	1618127100000	orphaned
16936	3NKCtQgbsdcCBau2dqZ4HHg1uvFpZGhn3ansmw9CFBCTA6aEyk7A	16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	1534	1071	284	6301	12463	jw97wF7GDKgK1CUkTmd8yfNr5pbNuJhQQRAYY6Jimf94az9N6Yr	8585	12151	12151	1618126380000	canonical
16941	3NKkwK6zuPneoBRFBQL7oQCSgRTDPr3JgrstZ9acdfRN1jahGeA8	16939	3NKzY2QHnDthMUNayj8HG22oy7KVtNTf3kQeuEG9uXWfvom9TKJA	1581	778	284	6301	12463	jwRDSRYyHkPyQY1nrrP3PRTeWkQpSHjgiNnzZX9Tx1j5ZQLfoeB	8587	12153	12153	1618126740000	orphaned
16943	3NKgBczWv2TFgRgWW7EsC3Hhs5ofgB361afbzbN7vYHredQKfjxX	16940	3NKtCSWhj5EmS4URtrzokcqwntUzwDFb3cv3rQCpisfBjU6nYHWW	1650	1129	284	6301	12463	jwAxUUhLc5ry4ApytiPN2g5CHKVngiYiBs7FTV2qxYEf4YedJkE	8588	12154	12154	1618126920000	orphaned
16946	3NK7zmNXG1SDUNwGepRUqyuNRySWDCcAX3RbQ7UK9rFSW3ysP68E	16942	3NKLJhTosKpAs7rRv9vxRywp6MnnvpRT3deHfCNWYo17aA62sxfg	1406	1393	284	6301	12463	jwUDVGa15YJM1GGJ9FtxQPJoBYumFpDjcGFSsCiuNyRBp7ZzYFW	8589	12155	12155	1618127100000	orphaned
16955	3NLLJ6hpvH47roGfmfBzY1Vw6brUyK9XjSARLLGHujdQeQzNixnw	16953	3NLdCz76dJwcaQ2TPhBqVenmg9fdMEFpnX9spD1dwcmiyevXq2k9	1403	824	284	6301	12463	jxPBUxi7scJhMZHwZngY9Hu59wHy9pEzgPb1iSH52soy91TrDUv	8594	12163	12163	1618128540000	orphaned
16962	3NKebnZU1dMFom9t8cLDzrwp7UXYhnwnfvP7jCwMbx7QfeCycazJ	16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	1631	794	285	6301	12463	jwLpEG2g9SptFwz3YCSSdLBvnSHiYF5ESBWvRgoZ1A8vmr7YnA9	8597	12166	12166	1618129080000	canonical
16995	3NKD4me6N39beAM3KVj5AYiFxhkzDukEvq7UKgm6iP7Rwx32KsjE	16960	3NKhALLLzxUeP5RwFHwTxa2oPvHo1NvfGThn8HMQJGLqrfZSMNvH	1589	1160	285	6301	12463	jy251vnYNsvJvdwzSs4oK9M5ACkY3ujUDbw1MtttdXzUQbgXmrc	8597	12182	12182	1618131960000	orphaned
16965	3NLAtRqb1sc3HKnNJLbC1c4fK31BQ1znhPMZDYWJPrZPVqgsQJMz	16962	3NKebnZU1dMFom9t8cLDzrwp7UXYhnwnfvP7jCwMbx7QfeCycazJ	1483	6	285	6301	12463	jwwRvUTZJRbYmX1QgxLo3WcdvSreJVKnQHYpTSeybmnXmY8nZ83	8598	12169	12169	1618129620000	canonical
16968	3NKNPtZVNZoZShkX5UCVSf9KNWJqUo3CcGtGjzMFHBaaUZLVjJa2	16961	3NKHBKScGPHRzTqmJ4jjaonKj7JRE9hmZsR5sVC5AbfQZgXzboMh	1672	1285	285	6301	12463	jwZfCgcAuzfXGuW99A6SPm9yBUTQkt6MnmYVkJ4nin9bMv4qS5M	8598	12169	12169	1618129620000	orphaned
16971	3NKghnwv7aTmV7sDhv8SquX12PRYbcdowuNqJXpHWGD9NvNE6iLp	16965	3NLAtRqb1sc3HKnNJLbC1c4fK31BQ1znhPMZDYWJPrZPVqgsQJMz	1587	272	285	6301	12463	jwnkBaUvpVjsBGH5xJUDfNjC5Vyazr6WmzjTZzLmzhWt5DqbNG5	8599	12170	12170	1618129800000	orphaned
16974	3NLZAag2tpiehFA1xfLfxZX8sLKroCRfWBuXTHC3gBpamjbWuwp7	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1523	1075	285	6301	12463	jwhayrKzpmuSyaTjLLxMeoJ9hyKUnzHNK8teLwaZYZkVzEjJUyY	8600	12171	12171	1618129980000	orphaned
16979	3NLUvhAJErLBzqWre8N4htkFkH3pqNVfS7Phc6yEz39ZQSnnaZW1	16975	3NLtpnhuv9XfmmbkUPxw4vXVQZnyb5h55rQw2zFnmNDRsVcSnA4p	1477	1350	285	6301	12463	jwku5JnsnbYFvQdpkCyxCUczzZZiP8GeYCEr3QJ655j3QMf1CcZ	8601	12172	12172	1618130160000	canonical
16982	3NKkmbdxqM1EW59LsFg8oQw7Cs1Az5XSUt1ErvqBk9xcV5nsbiUy	16980	3NKCFvJVstoiSJZChhgDAafvo2WrGD4AAXYMdU584TWNW7tUgxzs	1527	1293	285	6301	12463	jwN6Z5c3sxmsLwDBV4c7F666fFvVwqb4kNQU4UXVSAHLFg32apA	8603	12175	12175	1618130700000	orphaned
16984	3NK9HqQF2iH66LfwRDg8z7tFpjJ77ThtAY2dkb422dwRAse813zS	16983	3NKdHnqnrrjMbbffRSUUM3cFrezLHFhDuXCyUaoiwygUWTWBWoxd	1588	1392	285	6301	12463	jweHzUqudYJRyqaiZui7YhYN23DbJwHgXCM8eAu6BikePrVJJYw	8604	12177	12177	1618131060000	orphaned
16989	3NLB7vNKCiNwHZ1YfYgD8yZWWghdKYzFAQbAWjY5NyP1pFi5mheu	16985	3NL3ZDBR5rQdRZUtLXprimBikwKMvvoSUC4ZeFCij38dLeNfiKek	1523	1075	285	6301	12463	jxgsoFhYpT2LdHtHQczn4VMNLxKqLgjCuYTdeimdm3aQw2Qf4Aq	8605	12178	12178	1618131240000	orphaned
16997	3NLdFbATG5arw6AKnYrGt552kAAuFUEJvqMw5e8hGNb1k4x4UqZd	16990	3NKNua7QfmDn3T939hzh19CHLvzuXkxkmcv8hfpLTgU1kP1EypGn	1589	1160	285	6301	12463	jxQ6r3K5k5taAyqsmHAe5YXPRZ7Hfnt9Vuw5XiiVTHWFVjEBk4B	8607	12182	12182	1618132023463	orphaned
17000	3NLJES7HCQqbhMsaz95KYSpx3bxhsvf7shUBGPcyUgyt1SAcxGXp	16998	3NLNB4iQwpxKCsvqSn1zB5PQ9hVkscq2My28NWKuWJ3sTuAMFS9a	1651	1055	285	6301	12463	jw7gefB2pvKRmHX9arFqmPUH65oNjXHBMubDa5bpCpq1UtXtbWD	8610	12184	12184	1618132320000	orphaned
17002	3NLUrsxP3ofZZLvmN9guf7AMPzZoKQyKFb28QJpC6TbVAbHdCbX8	16999	3NKk6sXqpthU93nxkQVmzs1x9dCTniyww9giLx3gEcGzmf8FpA9a	1631	794	285	6301	12463	jxc3cKC9AosjEFCS4tKhnD8oaFwyG6Rw5p1gTdUBBiJAG9k3nXT	8611	12185	12185	1618132500000	canonical
17005	3NKgQ6AWFXUqieSP8qNFYxnZ7k7DUFyMEYHGRsACuuc2BhEourb9	17003	3NLPH9v3rc8B2uqkP1HgTCGUZjtmsTf2zjcxw8fCqJ79RwgtSoxS	1651	1301	285	6301	12463	jxvtHDw1QGtcgKKWsi7f8TUTcQkQL7KPEg2CZEkBK8UdnHuSwTn	8613	12188	12188	1618133040000	orphaned
17007	3NLZZ3b9TA25mTG7yPeVVTNLDNhDW3Tw5Hx42VoPBHk53yz448Vq	17004	3NKjzRWQT4sEVxSLHmXCwM3NKJwy6Um9awH6K96mGkG52P149ybj	1587	1357	285	6301	12463	jwEaAbgFUEkhC45TdYqpkev9ChjntuFUk55rkoqc9QztdE1AdDL	8614	12190	12190	1618133400000	canonical
17010	3NL3azM3x8SPBo3pApb9SSCrUF3B9oyhtvT9vqM7Tkwaa6JLmi5B	17008	3NLi5wnB1U39FuzELLJWfMWHtpi6t4EhsadkXyVCtZ7ddzNXVnvL	1631	793	285	6301	12463	jxRWHFjXzA97YFU5wTiv7ac3Adye1vRhV3eX1KeHscFYhcfaGvA	8616	12193	12193	1618133940000	orphaned
17013	3NKfmFxdowvWnjNSpjCVNmachgcCPNSkLH9fHw9AK6rRVFwaunrb	17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	1631	794	285	6301	12463	jxmV9kPE5XiXor15CF5ZgPPgt5icEeoVUydpHKY2oaQCb7CufgW	8618	12195	12195	1618134300000	orphaned
17015	3NKVUZbtmWgQsnbmz4mv4cSE2MriQKXwgkWM5g7CDYoymkGphXWi	17014	3NKHn4HsUP3psPPN4eGo3F4ndBqFFcxDzQDMxGWyW6p4o6jMwWLc	1458	1077	285	6301	12463	jwcVsiEcjDY2udof4DPRvRBTC1qCqKU2YA1Y6zqaxc6gTZdJ6bp	8620	12198	12198	1618134840000	orphaned
17018	3NLByjNjgrtZ8aWegAvRmQznCZ6cYV2udBrmn8dRk668RhSaFB2T	17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	1476	1371	286	6301	12463	jxGMURFJtB6q8vfNwgV7FXMGXdCNknxZnPh8GZBsHsKVpfRHqLN	8621	12199	12199	1618135020000	orphaned
17020	3NKVSZuLLz1o8ma8AGjxiV1itP5BRXKHXYZPSM8uZjfY7yMLyNhV	17019	3NLBRby7T56WtUkcmC4TCGKfWoWoSpU5mrkdgRScRRQyZB44TKij	1402	870	286	6301	12463	jxo9riYHTQ2fMtidtAe8vtpYdVZTPnfF8yMrtqtScTYmGd26623	8622	12201	12201	1618135380000	orphaned
17024	3NKQ5Dm2ozCmhY6RJba55UhczaQrLtoJkVzuKzekAzzWoWpoCUQt	17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	563	1113	286	6301	12463	jy2LXEA42jHjJmKfVEyXdNpM2k3UiCJCp8fLtTV3EUKtvDsPz5S	8623	12202	12202	1618135560000	orphaned
21139	3NKg8LJ5EY2jq4d168wnLgxDA1jjAt6u6dZgJcxn1gF2Ab14PY9S	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1631	794	384	12463	13393	jwHSxJR76S1oG22a1GEosQ7FmRnaMQmmApDKfjkM97fNyEpdnM1	10614	14943	14943	1618628940000	orphaned
17053	3NLjvxtwxiuZvtqheDgLhL7UG94McuKvBn2Cgrrpr1JWd8b8fpXV	16969	3NKUSXhxj8mqYUhxBVK7e4perbRwxoFAfM8WArcQ93Sw4mVpxvec	1542	1058	282	6301	12463	jw85uwcNhNH9Ds8ScvUw45mdeQc7hP6BKLgaFSMYt9RMo6VK5jn	8539	12217	12217	1618138260000	orphaned
17027	3NKvNQoucp75MCs9zLDvtXEmWik9wJVRFkaHkkvzyZrmmVJmFHC3	16949	3NLRSXXhELYtZMH1KNS342w9yFCcV8p5fHmHTrX3t67yQgrR8A2M	1489	1380	284	6301	12463	jwpVC73AaAjAwCLbKZvb1BMwSm5mbgxBaK5oUrVytjVrojYBMCC	8592	12202	12202	1618135560000	orphaned
17030	3NL2dQmReLWCFAX89SLLyZ3Yb4KzsM5D3DEi1xFqbvHFucq67jcE	17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	1407	1395	286	6301	12463	jwKw1f39CFvmDrNjY6z4BNivKCqGxp7iu5ALRVd7TtxHJzcovVC	8623	12203	12203	1618135740000	orphaned
17031	3NLhmD12qJvr8oLx4byJ6ZYM7bUcFmowKujq8ZRP8TkxJtZ1QG9P	17024	3NKQ5Dm2ozCmhY6RJba55UhczaQrLtoJkVzuKzekAzzWoWpoCUQt	1593	1346	286	6301	12463	jwDMmKFkceMspPDHDD1bqqcWyB5QosAEUrGaQ91Tm2i4CEWKsJC	8624	12203	12203	1618135740000	orphaned
17034	3NKBro7eM4P7sLQqrkGyV2L1FUE8DM1VBTezcXmPtxjCS4y3nrRD	17029	3NL6q9ALL1r2WE2hfjV8b2ASMVxRd8gKXkM1CPyqf3vNedBBZxzR	1633	1144	286	6301	12463	jxbLNMoE1Zidy9QCvcaqhPNxczMEdzh6vRmnB4HiVBkvxaWCp6h	8625	12204	12204	1618135920000	canonical
17039	3NLf6knir91yfMNLt9vxkLE8PQ9tkZ5qCdiWwX4wi8N2GxojvEbT	17037	3NLvhrUJR3GDyGvpkXj7Sch9vAEvbATXAhRX5uAi8kMBZU3QvZGN	1589	1040	286	6301	12463	jwqcNfCaWMyyiPBXbQUctUqzqqrqTEkaLGYBK87NkU8CFgGURxW	8628	12207	12207	1618136460000	canonical
17041	3NKHWMSC7QzAGjKmrL5wtCtghyoBDe98AZHSiQPBkiKXgY7nj4D8	17040	3NKLCvh2GVZYhAx8RZnjZLygP2BQmm9C7BAc4K4V1qb1VzjpCm63	1631	794	286	6301	12463	jxST75dvhRisjcCcTLoqbBR25qynQxuUAfkW1z4wmhsPddHnu3G	8630	12209	12209	1618136820000	canonical
17044	3NKfXStn1jrReGxETVp8yuCrNSERQCbd1M2xdrp5mDc895zsvMy5	17042	3NL2MpeF3i5eD6zPVcqgLJ7ktx54qjauNPuLs6KBFdJr8GfNRvmK	1445	1290	286	6301	12463	jwyk19KStRAHHnHDx61yKcmbcwZ43scVJKMK22U8MEjY3n6G6nd	8632	12212	12212	1618137360000	orphaned
17046	3NKWa3B6roF77rYf73A8XA8bm22Vu522KmFqjAujUjXEsTnLyfqb	17043	3NLGJtuN8gG2NyMQoLwkTVssQpxDK4axh2QPfFs7BX2Gn578RhGZ	1637	816	286	6301	12463	jwPnRKLm2R7qNBS2hsWQW6rEgyHTL5K61ef8jHz4TBx4zarJdkK	8633	12213	12213	1618137540000	canonical
17047	3NLQDpvxchPJP4DNyuNDtafVcAAhzeUdTBpukgxgaefiduiXdU4j	17043	3NLGJtuN8gG2NyMQoLwkTVssQpxDK4axh2QPfFs7BX2Gn578RhGZ	1608	1043	286	6301	12463	jxArEd35KanTMJXuSu1QU8u6632Pfc9EEcUZ9xYvQFHBoAZWEHo	8633	12213	12213	1618137540000	orphaned
17048	3NKQsdnjX3Nz1HgUsuNvDQ8yfcpXv3UaLyqzDDKo9vvhD5WinqkK	17046	3NKWa3B6roF77rYf73A8XA8bm22Vu522KmFqjAujUjXEsTnLyfqb	1407	1395	286	6301	12463	jxgoQ3ku2h84kMzeGUCUwkWavnvJ5Pw9zuBF7mCiS1GwwWkGjti	8634	12214	12214	1618137720000	canonical
17049	3NKQm99Z79EfS297nhrVjDSRu82N2w5E1rsh76dUGeyKPHdbv75c	17046	3NKWa3B6roF77rYf73A8XA8bm22Vu522KmFqjAujUjXEsTnLyfqb	1611	1095	286	6301	12463	jwT7xvmrzuZedT7PWVy6uhJvyuJWJtN5CXpgzMzdvd2MrmA64AN	8634	12214	12214	1618137720000	orphaned
17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	17050	3NKZhVBVGGeDfVCCphEFPJ9Kbge2FtoxacZDcVVYyed3skUBZrZi	1585	1120	286	6301	12463	jwaJVxq8HmurPSjXJ6fWARv23wPjzpYvKSwr8XejyKSn6wyRjCU	8636	12216	12216	1618138080000	canonical
17056	3NLdGcFDyk2ydpuPBYfSKRP9yuAix283EJdrD392tar3LLSArFu7	17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	42	1361	286	6301	12463	jwDJ26Q3nMsyDHdRQGSPnEMWxrk75uMGbTqy8mfGnoHHrFczNQ9	8637	12217	12217	1618138260000	canonical
17057	3NLTxVHweZAkCvWKYb1VewJkdovQ7moYy8QD4weP7YYKAs3WnzXT	17056	3NLdGcFDyk2ydpuPBYfSKRP9yuAix283EJdrD392tar3LLSArFu7	1445	924	286	6301	12463	jw9Xr9kc6DA4RMdJGV6BEaFT6RFw3Lu3VHqA8pWScuJGvVcUwt2	8638	12218	12218	1618138440000	canonical
17058	3NLm9gwrtXC96zwCFbgfetswZUJvxTNqp58WbCyJzBNtTVt27Shu	17057	3NLTxVHweZAkCvWKYb1VewJkdovQ7moYy8QD4weP7YYKAs3WnzXT	563	1359	286	6301	12463	jwzo2WHNkGV64Tun9eiUCFmrHM8x692g9hQEwnAyfNzfaRv9krM	8639	12220	12220	1618138800000	canonical
17060	3NKbYt9njmnnrsdMEipe95gPRLtRNKoX9L8S3QwWFrumtg6gLNFS	17059	3NKAYTEBybbGQdt5EzY56yEUigWY3SrbXnCATmSv8unf7CB11Bui	684	1106	286	6301	12463	jxWAYPTeD7BNNkiv1b1B6BKQX7MJYQLBPpxo5EhK13KbZmUaYeT	8641	12222	12222	1618139160000	canonical
17061	3NL21QHJixP3bKLJwMkz86PVKpghxj6XEbbuTbYjrYxNfewGtm6K	17060	3NKbYt9njmnnrsdMEipe95gPRLtRNKoX9L8S3QwWFrumtg6gLNFS	1647	846	286	6301	12463	jxEnsMPbmf2poGP9uNKcPEsjngsxg3Hv2v1yZZz1nHPqA8Eu7Bo	8642	12223	12223	1618139340000	orphaned
17066	3NKG5sRewYxbzh4D89htneg3F3YmyCXUN96oNPhANMXED1HeD8PR	17064	3NLdv7eMg1MFFUCMyhBqU25262UAr9Re2HXySoJBw5UcEYhtqqM5	1440	1251	287	6301	12463	jwhy1xHgAymK6WWRW8fGEEpycPndAVLrH2YZrMvznto79hDDNch	8644	12227	12227	1618140060000	canonical
17068	3NK42jfsarr8p8bRNVBCBtrtzJGW4xjKewokskEwYwLZErBGeCoR	17066	3NKG5sRewYxbzh4D89htneg3F3YmyCXUN96oNPhANMXED1HeD8PR	329	329	287	6301	12463	jxSJCqddpoJzGpsJJPqqiF8KJcWxBytst7brVcBb4Hii7FTtZdc	8645	12228	12228	1618140240000	canonical
17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	149	1283	287	6301	12463	jwavZAHyVCU3hrmkYKx1nb6jZrxbDiXRyyXoJZ4AhCGgKdHL1PH	8647	12230	12230	1618140600000	canonical
17070	3NKBNdYW2GBkERuHfQKoc9huzquNgNgAQiLXLhymoiijvh5hbck3	17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	1403	782	287	6301	12463	jwo8s4Rt2UggJCipsAH4vP3jMkXDyrZYcu8EA8U8sFsDqqPDQtV	8647	12230	12230	1618140600000	orphaned
17073	3NKTPj99enaLpsT1R6kgRvrf9yJkXRhehshD6ghNMTipqcQoX2a8	17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	1546	1093	287	6301	12463	jwrdg9H6MNhBHCM6bpyqheHLR2RZRPxb8E7Tc5Ji8AubTvibEcR	8648	12231	12231	1618140780000	orphaned
17077	3NKUW7qA45C3zsKCb3c5kzpsFX3xGC5V1gNN1qJSt6B4yAGqXj2b	17075	3NLdT9a9DJevrogdFvwojeCybGfriaNgXBCgWxaqrNXqq6CRnNq5	1634	1085	287	6301	12463	jx2B7oqj1kL8r19GGHWG8shEE7w7nMxvsnas8fH7P74PA2nTFQy	8649	12232	12232	1618140960000	orphaned
17080	3NLvChDbd6Wk3x5HdwojRHAELpjmjibs6tNg2dUTWYbMssGTYHPC	17079	3NKGNx7wr9Yh1u7NFfE5yp1YMBN6oMTvdptV27xc1X3nyhsnWkJL	1490	1028	287	6301	12463	jxwGG6ACmbBMGQzGJRycaWsWsteJcS43MkZP6ESgoJ4hnAkZbpu	8652	12238	12238	1618142040000	canonical
17081	3NLQuUT8dAXq3dA3QkP6jPFGJTmYXsZfcaZRDmFc4JJ4cYjDqAp7	17080	3NLvChDbd6Wk3x5HdwojRHAELpjmjibs6tNg2dUTWYbMssGTYHPC	1564	1338	287	6301	12463	jwyoq7s8yZ2YFyFBUoHTiN2NoAw6EQZ6a78uRVyJ3CDYkDHmBju	8653	12239	12239	1618142220000	canonical
17083	3NLJY88HipcVJfHraNmxrVoyKcsEWPCcRDVwhswwtVbQ5eqLG1GJ	17081	3NLQuUT8dAXq3dA3QkP6jPFGJTmYXsZfcaZRDmFc4JJ4cYjDqAp7	1516	1168	287	6301	12463	jxuEhnTF4xZGvKPpKw3FYe71VWgg8ebxQfWur6GReNkVZu8ZWmU	8654	12240	12240	1618142400000	canonical
17087	3NLFgPJC5oTJJPAZYG7LyTjA2ExPu6944b5kAyMoQMBdan4mn1dq	17085	3NK7GnkmqJGT1J8uZuJBAieiaGvZs3R2PK1ypDT6ZUBLN9ZMjHHE	1406	1393	287	6301	12463	jxCoAvJSeeUqYe6mMj3HfCvxKwaCi4BpyuNK51YgSW1FJANfg9q	8657	12244	12244	1618143120000	canonical
17090	3NKQxCY84TnH16EK78HTpDTpe2F1vvfiGHaBRx1fZEcn5gufHEg4	17088	3NLWgZAj4FyQv458yBTJ9GUcsTZeByXGALnxUAXwJRuPNi1eRAZE	1637	816	287	6301	12463	jxUPxEDAVddA3W6frESzDbYSDjhuRQ9nZW2NR8gDzjfWNE98YYX	8659	12246	12246	1618143480000	orphaned
21154	3NLumbpzJMh9HvzE7D6arudUbctxCcC1282WhHVLuA3zPUFxqfJQ	21153	3NKJf8XGxnVoWVg2gLfVAcAsk7MzX4RLWyHbrghTCWYepPHZBTJr	1406	1393	385	12463	13408	jwVbwVsEE7KbbH9AjM4n5dPXvqSWpXfYNK6Rs3FnwbN7ziN5KWo	10624	14959	14959	1618631820000	canonical
17045	3NLmgWHipZhKGv8MFaEpCqj92XQ23TF4n4RPLheho1kNt55RqaXn	16959	3NLS4Dp3B4abDYbx5ygEkBhSeJC4HHryfzBiDwy7cubmCmNidzYN	1672	1285	285	6301	12463	jx5Tku8wnyfFYyQELpQe9oSF3bNS2Hm16cMEStwRQjqiRFXvc99	8596	12212	12212	1618137415315	orphaned
17026	3NLn5EUfnoQpkCDQoK4TsmZ4fZx1xVDv2HSCurxzUoSwHMowMhzR	17022	3NLiHkHuUUyCFaWppWkrHTeCbDTMMk7XA2qm3qcZTAVRino5Afnu	1489	1380	286	6301	12463	jwwdcs92KTQDcduVeG3WSeUZ4RUDE83DxShgNrbFynWMqmSeiGd	8623	12202	12202	1618135560000	canonical
17028	3NKkr5wDnR6UCztqYyFBURckh1L13q2rJAc8U6etmhX77V8ohtvs	17026	3NLn5EUfnoQpkCDQoK4TsmZ4fZx1xVDv2HSCurxzUoSwHMowMhzR	1593	1346	286	6301	12463	jwuaCo5g4MAxdZh6Wtr5cJUpvXyuKkg3EzsA5DyWrup9Amg8zwE	8624	12203	12203	1618135740000	orphaned
17035	3NKGm19xyNn2WwUbDwBgPunjtXVnvTT27us4CumXrZgkCjzJYrnx	17034	3NKBro7eM4P7sLQqrkGyV2L1FUE8DM1VBTezcXmPtxjCS4y3nrRD	1599	1041	286	6301	12463	jxRsTThrbJW7NiMBGU1kQkYCoaLNuP8KGTSPJpBeHpdtDs9BdWs	8626	12205	12205	1618136100000	orphaned
17037	3NLvhrUJR3GDyGvpkXj7Sch9vAEvbATXAhRX5uAi8kMBZU3QvZGN	17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	1637	816	286	6301	12463	jwK5SaNx6ctLzgUoymKi3vBCSuiHNYacPubTjFtSPrR91oCEw1c	8627	12206	12206	1618136280000	canonical
17157	3NLAL2NRDfmAeXutss19e1p6TiUkbGx5FP7rHDXtAwG2Uc3R5cvR	17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	1448	1185	286	6301	12463	jxqwsKYKjk9hJMeMFfyQZWZUfjCitS9jGq2Z7uRZx2TWaXoCFx8	8627	12293	12293	1618151940000	orphaned
17042	3NL2MpeF3i5eD6zPVcqgLJ7ktx54qjauNPuLs6KBFdJr8GfNRvmK	17041	3NKHWMSC7QzAGjKmrL5wtCtghyoBDe98AZHSiQPBkiKXgY7nj4D8	1602	1243	286	6301	12463	jwjPeKrF57npQU9Ws9AXybAkKzKoQFDYUuMnd8y6DSuiZKUr9bK	8631	12210	12210	1618137000000	canonical
17054	3NLYp8UBM1ZSGJXXmSxk27p6RvaHNVs75ZwNwYWvQLRG3Gwd1zeA	17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	1542	1058	286	6301	12463	jxgkYjDDXo2M8znsgYnD3e9Xv3WjVcrzk3HgXDT6YUgjAW2nbo2	8637	12217	12217	1618138260000	orphaned
17059	3NKAYTEBybbGQdt5EzY56yEUigWY3SrbXnCATmSv8unf7CB11Bui	17058	3NLm9gwrtXC96zwCFbgfetswZUJvxTNqp58WbCyJzBNtTVt27Shu	1403	824	286	6301	12463	jwKNi5BXRnAS22a5N12cZima4duAQByMygmZuC8gCAgzWdn3mys	8640	12221	12221	1618138980000	canonical
17062	3NKwq7Ha7RMJPtmFzMDBKcbgAK6jXsyavA9kpzR44H6HCLU6Ws9a	17060	3NKbYt9njmnnrsdMEipe95gPRLtRNKoX9L8S3QwWFrumtg6gLNFS	1508	1261	286	6301	12463	jwmnrBw9tZjpy9Fh6XSXQJSkYYbXXSHSZLpesiv5CSDDYKh7ZMq	8642	12223	12223	1618139340000	canonical
17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	17068	3NK42jfsarr8p8bRNVBCBtrtzJGW4xjKewokskEwYwLZErBGeCoR	1444	1135	287	6301	12463	jxzXcKG4annGymq3S8hhvnE4yPNbXXtEbe3Hb1s84rmiMSVTvLA	8646	12229	12229	1618140420000	canonical
17072	3NLoc9R4aZwk5vssVSZ4mmpn73kZLNKkJwj121vrCCVm3PX94XpY	17069	3NLdyrsSU3fugSAsct3iyDjUFKURj2wkwgkD5sMyrUuuCXaGK2p2	1601	1142	287	6301	12463	jwamcSesHEUf7fDdp1Jx58Cpt6Tftj3z74D7r53kNBBLpDH7esc	8647	12230	12230	1618140600000	orphaned
17074	3NLkkMbKPcbam7fKRvEa4DJX1w1b4RVZHDgrFrjHiDboQKgk5SjX	17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	1444	1381	287	6301	12463	jxjvzDSbZ3JRpFUfb19DtAxvWQfQTMhreAiq9a9qE65F88bqqmF	8648	12231	12231	1618140780000	orphaned
17078	3NK7bQaFC6e3qYsRjtx1DYtkVsx4heb3y2Ex6UFP99A4k9gY3NQc	17076	3NL3XWfuhR5MdM6VTan3Axmp8Gzb4T5FcNFB1QrNHkQ4w5o2a9Yr	1637	815	287	6301	12463	jwy8TVDtyj4Q5YSFWJn92gFsPPcmaUfFzhms4MNL2khBcuUWLiP	8650	12233	12233	1618141140000	canonical
17088	3NLWgZAj4FyQv458yBTJ9GUcsTZeByXGALnxUAXwJRuPNi1eRAZE	17087	3NLFgPJC5oTJJPAZYG7LyTjA2ExPu6944b5kAyMoQMBdan4mn1dq	1406	1393	287	6301	12463	jwkBiYMpK1FjTfvPWv3u4qRsTR3Mdqhex65TvKANXWF8gQ5FayS	8658	12245	12245	1618143300000	canonical
17096	3NKZfEqcJo2Wd2PPf6Qc3ravPAQHGz7zahEMtVbGsnPB4m7ZbbRA	17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	1489	1380	287	6301	12463	jxoCFXM6Kw8Kagm6yP5w6raQvwfUftm94D5kCVXfAFKi2k4feDu	8663	12251	12251	1618144380000	orphaned
17100	3NL9RfGBT8ZRUuZkMtpPuC5mfLA7opZuriU9mtCQaXHMH6C3t8vb	17097	3NKke7HDDssDn9F2UXCWbjoL29rnDbtuG2YEjwugEECrJCF8bq2W	1513	1379	288	6301	12463	jxwqRvbv2L8U7CELWfhtB77h7RAagxhWj7jGQjrymm9QpGsEPho	8664	12252	12252	1618144560000	orphaned
17106	3NKU9UkgbhTCvQEuNnwQ2PvaQxgX4k8PcjCi9ffP6YkgPdhYkTkU	17105	3NKnrNZ9soE6PXRgdpJ9gfamjwiBDXMiT45MBJ3P7WsY9ZFLEDMU	1637	816	288	6301	12463	jxYC6XTCkfUFYRLCQwoSog2dGWUzrbpE3mSAyz9zyVZV5tzEUWA	8667	12255	12255	1618145100000	canonical
17114	3NL3h4n12poVuSHJGfpfRTRubnX3Gd3gWxzhSYGEez4MESe8pzhQ	17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	311	1307	288	6301	12463	jwQfzXrfHFk3R9qV85Cz11e42GR5rAV2CJkgDgtcCjarKzpyKTr	8671	12259	12259	1618145820000	canonical
17120	3NKR7nQsoTR6T2hHoULHEazRPDby97CA6HNaFsHFNWA7BSEprwLH	17119	3NLo31p3qPdkW7QRBe3iJhzAzFQzSfjDWJyUYXKFsoFixKdTLFV5	1476	1005	288	6301	12463	jwzBW5EqGwoUkuigh9ku6jq8Q3VjQKEmEgoWK1qSnwwyHEe8aNb	8674	12263	12263	1618146540000	canonical
17123	3NKYba2k3rPWt7pKDSq4LCv6RuvhrqArbFkgfnQQQ5wBX5CbreBS	17121	3NKr4GPqBPDLaNT9Y9B29QBvVbMLtS6vhUnyQDHsjX3ZS5G6HmWW	1670	1282	288	6301	12463	jy1f6uuwKbfhWRGD6USU76g1qYquyeKXZi7k9jWtht31s6p1BSQ	8676	12265	12265	1618146900000	canonical
17125	3NLBcx5TtYPMyYTpXx5PTtPahV8jW6eijbb8W8KnLZh9soHB7mso	17123	3NKYba2k3rPWt7pKDSq4LCv6RuvhrqArbFkgfnQQQ5wBX5CbreBS	1647	1056	288	6301	12463	jxYorkYgoZ8F6sQHiwEUpECBFkRmESwnLnRtzstd3LuhjB8zFHZ	8677	12266	12266	1618147080000	orphaned
17142	3NKpzfoc6Rko6TnmsFAjTFTyKhfowugH9e5yNpHwxU2xMfFN3ZHj	17141	3NLiSperQxM59fXF8MNcYx8zrifRJqZBsobwiDnALptxLi1mKzLy	1608	1043	288	6301	12463	jw9yPHLDZmChQMuwAwKDz1wTVzBVqFs8mWW119EvCtrhszfUCPi	8688	12280	12280	1618149600000	canonical
17144	3NL5x2de632bcojhU5UEKUwBX6g8ceoASkqS7xJRagEra6yBLFMW	17142	3NKpzfoc6Rko6TnmsFAjTFTyKhfowugH9e5yNpHwxU2xMfFN3ZHj	1458	351	288	6301	12463	jwibBVSNdWD62zfdizkYTbn9tEMtrmwg1kds15q5n2KXwMnMF2F	8689	12281	12281	1618149780000	canonical
17150	3NL7pucqc9mnMFRKf1KeqfGsCVFmKVGA7deNy8WRaJ9BgFYRnn6F	17148	3NLFz2N2RAvvqkAUeFdzTv36hfVdjmjzc2Kd9TGV1b546aoBzfJw	1609	1207	289	6301	12463	jy1NEu6KHrTnbvdGaLZFRB4pACjzXeDMyqkFQo7gNDLH6v4GT2Q	8694	12287	12287	1618150860000	orphaned
17156	3NKevaTPGyjURyC5pybH7HEp9BmAzhZwtzqnDDoPbgvEpBiwSxnX	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1455	1206	289	6301	12463	jxtCyUuCLYiQ26yyaprTExWMcAuGAvDZDpmd6FUjaFTqutbbof2	8696	12291	12291	1618151580000	orphaned
17160	3NKxu11uUmHbtdj1TeEuNaArmwCPkuQyS9dMziNsevkWpy9r7NC2	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1448	1185	289	6301	12463	jwdXdV2ynJnW2dQXkeWvSYWjLWySCn7Fjed9RaH9FYfdGMiZKd8	8697	12293	12293	1618151940000	orphaned
17164	3NLkAye8RFbFNRJ4bQ6FNW3JDtXWXkd4T5eEPpfDZKvtRkx9sN1M	17163	3NLMadn3Zr7BcCwJXVQ3PSndujfk3zyetz1GLjTSjNhZwqMzurro	1580	422	289	6301	12463	jx6NuP8JN92X5MLj6fknGqFWiw2V1EeJsV9WeveUMmGc9n6LhpD	8700	12298	12298	1618152840000	canonical
17167	3NLhHZPhXVgusjvM7NJkgUsD4THkUvqe5PsGwMBWN6LDD6QmwHmi	17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	1596	1363	289	6301	12463	jx1zhvsw3VAFKXnN2rjRMxCvs3YgrHck1fykdSgCJSJoLr72Ukk	8702	12302	12302	1618153560000	canonical
21666	3NLibCgumSEokgUeoRiq4jAVR6cUkhftTMEr5jtnVtDqQYGZ5zC8	21156	3NKAFnentx5n9qPaX4n569kNN5mHrUHxpUwQZ3QHajhMxXPWVWHb	1560	1045	385	12463	13852	jwKwbn44ndNFJKZwRYgGPHPTi4e4Wm81cpbmWVz92jAM6gwHvgf	10626	15277	15277	1618689060000	orphaned
17052	3NLpitDQKKuUFatogn9FwkPWaAXVMt62Pp7QgpoG1q5KakJgQUiE	16891	3NLDijABx7U9gHibvuBNzPkCYLcuuvKD16tpUJT2rUtvR4qy6Zhs	700	840	283	6301	12463	jy3HsuCjP4gQZWYhDVxpGg8BsRneLNh5jKCL23JvRJ9VQcAQyMs	8567	12216	12216	1618138080000	orphaned
17029	3NL6q9ALL1r2WE2hfjV8b2ASMVxRd8gKXkM1CPyqf3vNedBBZxzR	17026	3NLn5EUfnoQpkCDQoK4TsmZ4fZx1xVDv2HSCurxzUoSwHMowMhzR	1649	1383	286	6301	12463	jwzv3r5AvHdewdso13JU43J6NRAFz33CBmzLRBTuBo6mjos9CR7	8624	12203	12203	1618135740000	canonical
17033	3NLDyvNxYchatGZFUvkX56pGyrD1dEqD6AwJ6miqXpR3CTrN75sM	17032	3NL7BYFUh54C8LP24eY5ZLjfo6uvxvsfW228oJutM1QEhGYmxNjg	1516	928	286	6301	12463	jwfDuapKDfUF5K59WkDnkh4JedP8zxvzTHj5nSFkEvutLDbxhhk	8625	12204	12204	1618135920000	orphaned
17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	17034	3NKBro7eM4P7sLQqrkGyV2L1FUE8DM1VBTezcXmPtxjCS4y3nrRD	1406	1393	286	6301	12463	jwL9T82rUgyMTBsuhwDCWAZYsGZ4ANZ4hC4ctPxxy1FhtE3kAea	8626	12205	12205	1618136100000	canonical
17038	3NLCCQVJvijDTGyoupqzr6seEEEy4u8RHn3E8au6ukABWACqUDHR	17036	3NKKQBJWNqtujwm8w7TgNksyp3FpLvo7Ajj49wXaXkPwvZLWeLpb	1407	1395	286	6301	12463	jwBuHZDPesjx1H5xy1oU6gFyqt1RcrwqHi93QBTKU7x25py8QY8	8627	12206	12206	1618136280000	orphaned
17040	3NKLCvh2GVZYhAx8RZnjZLygP2BQmm9C7BAc4K4V1qb1VzjpCm63	17039	3NLf6knir91yfMNLt9vxkLE8PQ9tkZ5qCdiWwX4wi8N2GxojvEbT	1529	1070	286	6301	12463	jw9k59GLnCsKTjsQnRXzCLVUBroqikY4W9Ax8mma7othrVaiqW2	8629	12208	12208	1618136640000	canonical
17043	3NLGJtuN8gG2NyMQoLwkTVssQpxDK4axh2QPfFs7BX2Gn578RhGZ	17042	3NL2MpeF3i5eD6zPVcqgLJ7ktx54qjauNPuLs6KBFdJr8GfNRvmK	1672	1285	286	6301	12463	jwogSJXcrUHqZMFwHRBV9f2hZ497z4wuyMQdLtABNA1JRD1xJHo	8632	12212	12212	1618137360000	canonical
17050	3NKZhVBVGGeDfVCCphEFPJ9Kbge2FtoxacZDcVVYyed3skUBZrZi	17048	3NKQsdnjX3Nz1HgUsuNvDQ8yfcpXv3UaLyqzDDKo9vvhD5WinqkK	1406	1393	286	6301	12463	jwWD8ABfwZc1E6bcqPYKutu7T2pEyuGuhXtjey8GVjJg3eB1zQE	8635	12215	12215	1618137900000	canonical
17064	3NLdv7eMg1MFFUCMyhBqU25262UAr9Re2HXySoJBw5UcEYhtqqM5	17062	3NKwq7Ha7RMJPtmFzMDBKcbgAK6jXsyavA9kpzR44H6HCLU6Ws9a	58	149	286	6301	12463	jxHFKFsCcztSoFUiukRtXVugcDMeMMTwDGawv5GbErSTtBwfBNT	8643	12224	12224	1618139520000	canonical
17116	3NK7u31aFSnjYH5JriPUKaPjynRdQ645Vbn3eL4NV6keC18EHYMw	17062	3NKwq7Ha7RMJPtmFzMDBKcbgAK6jXsyavA9kpzR44H6HCLU6Ws9a	1571	1335	286	6301	12463	jxQJ6gTFdLVCjgXAmF7WMfE88tjghLDXTBkQ1CiGf4KScW8A8VY	8643	12259	12259	1618145820000	orphaned
17065	3NKswBnAxntSwqgHYoc5RYSG1hTPxNKrVAWGxYnLshvYwSC36Ykb	17064	3NLdv7eMg1MFFUCMyhBqU25262UAr9Re2HXySoJBw5UcEYhtqqM5	1440	1251	286	6301	12463	jxKxhU8RF9QwHKTzXxdU1botmdhxT6rN3q9GwgUvqMgXVRZ3drM	8644	12227	12227	1618140060000	orphaned
17075	3NLdT9a9DJevrogdFvwojeCybGfriaNgXBCgWxaqrNXqq6CRnNq5	17071	3NKMJSktPmtWAMcN6h7qFFCMDB19sicD9JXcLrRFjRQq93WhfFXW	1546	1093	287	6301	12463	jwNxtWVDvzWh7RN3KMzwVSGwwJWGEon9QMeLWmnReBhQ361m1hQ	8648	12231	12231	1618140780000	canonical
17076	3NL3XWfuhR5MdM6VTan3Axmp8Gzb4T5FcNFB1QrNHkQ4w5o2a9Yr	17075	3NLdT9a9DJevrogdFvwojeCybGfriaNgXBCgWxaqrNXqq6CRnNq5	1668	1244	287	6301	12463	jxZ4nBJZA3uq5Vuye7FuBXVyPE9ZCisqYBKZWLUKXAJ2avFmH4J	8649	12232	12232	1618140960000	canonical
17082	3NKUZpZGcWNPPQiJL4L61ESQwhcKrrgSAc2rJAdo2pFM3y8LADAk	17080	3NLvChDbd6Wk3x5HdwojRHAELpjmjibs6tNg2dUTWYbMssGTYHPC	1536	1313	287	6301	12463	jwkdkZUyxp56SyAAAMMvkD3ekD99UTV6N3691RCMW6yT6Tw3Dqw	8653	12239	12239	1618142220000	orphaned
17084	3NKtoj54tMtBbWi3s3C2SACRGjpUYwurUdxuLLvX1Gqb1qC9YK1Y	17083	3NLJY88HipcVJfHraNmxrVoyKcsEWPCcRDVwhswwtVbQ5eqLG1GJ	1407	1395	287	6301	12463	jx8tq6ryWxLcVWyWiD1b8SJknEds1iGbMKvpW7sxTorQsWYUx2c	8655	12241	12241	1618142580000	canonical
17091	3NLeLrfuTQwv589aWJHWzVxbeGJYjGxdgwmHcUsqf1AHTmpPyTZX	17089	3NKnrN9qohgHqLokxDZsaaSXydfHqbXhhTB1BhFRhRrD2qKrffqj	641	1336	287	6301	12463	jxWra21X9ZsNfvtyv7goMocY4ekmktHJoiZtXkTdnLdNs7R9RmS	8660	12247	12247	1618143660000	canonical
17093	3NLUouUJXpqpMRZAEUGFrSCoLrThw3L3aRRnxxbiB2C1hgMzdFGM	17091	3NLeLrfuTQwv589aWJHWzVxbeGJYjGxdgwmHcUsqf1AHTmpPyTZX	1600	1126	287	6301	12463	jw9Viiks7pywm7DFRfDH8dMwUgAoKd7Rcrmf8335yfeKgYGnnKx	8661	12248	12248	1618143840000	canonical
17097	3NKke7HDDssDn9F2UXCWbjoL29rnDbtuG2YEjwugEECrJCF8bq2W	17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	1657	1344	287	6301	12463	jwFyTho1nxyK1vK9f6gEXTLp55HVg6FxRustoXMux1gSjbohQbH	8663	12251	12251	1618144380000	canonical
17103	3NKMBh5WhBGQf4DstoGr8932e3Ro8c2n5x877Ey1dJXNK5ZvUFmr	17099	3NKybMqmuBUf2AxZZKFpQx868UkmX2yiqnAsTYbkVdb8GXXnWHXT	152	1204	288	6301	12463	jwmVQXvP7J87agbcJnTG48S78fCu6LLcfTFpgVtL38hAJUfkT3c	8665	12253	12253	1618144740000	orphaned
17105	3NKnrNZ9soE6PXRgdpJ9gfamjwiBDXMiT45MBJ3P7WsY9ZFLEDMU	17102	3NL6752ygLo9keCJ2zQgwjkE1FkMZ2WLrWVHyck5sz3Q14KfUPoP	1553	776	288	6301	12463	jx9hwAkQb4G639KMzJ65FUh5NggLBBWdjUFNtEa1CLKbGHCQauD	8666	12254	12254	1618144920000	canonical
17107	3NK3VmTACTseigeSWvduhkMY8vR3Lm9PYKD7obi6JYpFMXWGYtzM	17106	3NKU9UkgbhTCvQEuNnwQ2PvaQxgX4k8PcjCi9ffP6YkgPdhYkTkU	369	1312	288	6301	12463	jxxbz5LknJZmXdWwa2hx7mrts5hh6Rnnzp7H6gVGfBx8r9G6rya	8668	12256	12256	1618145280000	orphaned
17110	3NLDTRG7ZLVB8bgjqs9SbMAf141ira3eSxi76q42HgrBKAUVDrUh	17108	3NLPaZhSeTo2zAppXV87xYJFWRZ24nGrXEjFDfcrjQFzKjy2c7UK	1633	1390	288	6301	12463	jwa3B2Z8VkJrQGRxqXvrMFo6K2ue8De4qM4ZKFVEFkWGHRC87DD	8669	12257	12257	1618145460000	orphaned
17112	3NLCyxw3rhQRMx5e3zFofRUBzuNKtiAaGFAFNvTiHCPY8bgaPGqF	17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	1610	1314	288	6301	12463	jwv6mVxiYd25ajtPTtZCYky1sL93fyoLudcTBt8UUXbVR8NTWv1	8671	12259	12259	1618145820000	orphaned
17119	3NLo31p3qPdkW7QRBe3iJhzAzFQzSfjDWJyUYXKFsoFixKdTLFV5	17117	3NLZAZMf3ZSxa1QfTQ5FUQtsQKWwE49nPKTX5rtEhifu6kD8MRaj	563	1359	288	6301	12463	jy2w589K5SfQHmeMxuhbCkrc5ftWniYokkPsWKASTVfgDFxG37W	8673	12262	12262	1618146360000	canonical
17121	3NKr4GPqBPDLaNT9Y9B29QBvVbMLtS6vhUnyQDHsjX3ZS5G6HmWW	17120	3NKR7nQsoTR6T2hHoULHEazRPDby97CA6HNaFsHFNWA7BSEprwLH	1406	1393	288	6301	12463	jwfGqtamgzFX8g2W8RaUKi6Ube8s8tKoze6kf1E743BRsHCSpkJ	8675	12264	12264	1618146720000	canonical
17126	3NLe5k4m1XC5ayRXiip7kXTeJt79gZZUNmRTFur6D7RnPzaqYouv	17124	3NKE96Me2khRDyVzjTzN6sMsW58RwWUSA67k7cAJ4wcx2SvRGFCB	1489	1254	288	6301	12463	jy2iWF2Gpvd9yAatvg45f2X8we9MzNu1MDeLbGvmba8H7AH4mGw	8678	12267	12267	1618147260000	canonical
17128	3NLo9H2r6Si6KxqrAezHQeucRgz4h7PwfQBogQkSqFnDceaWbnkR	17126	3NLe5k4m1XC5ayRXiip7kXTeJt79gZZUNmRTFur6D7RnPzaqYouv	1406	1393	288	6301	12463	jwxKneEMYmvYPJ1Rfehc2C2zeTDVYKCnxKn79jouZQvWeBN38uQ	8679	12268	12268	1618147440000	canonical
17131	3NKuZXB8VQduGXfCTE59guc1eju5PWWLkAEm4SpNx9KifrVieR1L	17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	1421	375	288	6301	12463	jwmsQ51nb2xbtS9X9MCqhSvXQw29ps7SAq3PzjnjUvqkkNaLFmF	8681	12270	12270	1618147800000	canonical
17133	3NLgGr8VNGbpE3XptUQySSLPnF1wWnecr74BtBPrJ3TccVWDkz9k	17131	3NKuZXB8VQduGXfCTE59guc1eju5PWWLkAEm4SpNx9KifrVieR1L	1513	1379	288	6301	12463	jx3UXNMoPy5rs3oY6amZRVaHr9cK4MtAWq6bq9B9pCriwZWRHuu	8682	12272	12272	1618148160000	orphaned
21173	3NKKKQuQHku1hvfFC7CpbuWfm3FCLyJB5p1fM6hTV4AzMB5cVa76	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	1406	1393	385	12463	13425	jxJyu2JHTG67KQJZiKNTyJq7N3HUFJzRoqQ6KVW5RVBT92nkfCU	10633	14970	14970	1618633800000	orphaned
17098	3NKdQafoPV6pzEUHn2fXQXwpGF5e3Fjy2X5h7KpkVrmFqejWkJ9F	17086	3NK7Zu3osh3uGZJRdPe2kyYTo1g4QsWQKD7tWbaBkatouYLnS9wA	1489	1380	286	6301	12463	jxSEL9rsP6wy7yT6jQgGM3dXqDtwitDfny8PkcJFogA2CYVUscW	8594	12251	12251	1618144380000	orphaned
17127	3NLFPzQvWamJ4FDotiZwvHeWLM9MhbrthEeqw2SnTUvRz5JHELtg	17098	3NKdQafoPV6pzEUHn2fXQXwpGF5e3Fjy2X5h7KpkVrmFqejWkJ9F	1489	1254	286	6301	12463	jxoLvYXuvsgPXR1mkUMgei15TmGvhhWfGxpdJMwxaoxgkyV1ZgM	8595	12267	12267	1618147260000	orphaned
17101	3NKgbYxLKhUJz2AgfbkGgim2tYT3yQZAV2YQ8Jq63pL2kJ8JHKB8	17011	3NL77VPrLUygRvfpF7Ec9QD2W7dhiVH1uGWspcid5qpKwdkZjpWW	152	1204	285	6301	12463	jxxKhC7XDmHFWYyxiu5fDqHirZFAEBbcdPzDfsQnkxFxo57dxrV	8618	12253	12253	1618144740000	orphaned
17115	3NKEUWyGk3u2b1uVEAjaS5SLeBXWQPMiC2gRUvSDKCpT9udreCgK	17070	3NKBNdYW2GBkERuHfQKoc9huzquNgNgAQiLXLhymoiijvh5hbck3	1610	1314	287	6301	12463	jwBq98GC96eGdKwnpumAiiF4wHSdhhnvQHuWYehAKPG5G9Ujuz3	8648	12259	12259	1618145820000	orphaned
17079	3NKGNx7wr9Yh1u7NFfE5yp1YMBN6oMTvdptV27xc1X3nyhsnWkJL	17078	3NK7bQaFC6e3qYsRjtx1DYtkVsx4heb3y2Ex6UFP99A4k9gY3NQc	1407	1395	287	6301	12463	jxEkDqkQUdsgqbPFXV7bBeSduiFqubfsYwcRagWAyyxuGKbV6w3	8651	12235	12235	1618141500000	canonical
17085	3NK7GnkmqJGT1J8uZuJBAieiaGvZs3R2PK1ypDT6ZUBLN9ZMjHHE	17084	3NKtoj54tMtBbWi3s3C2SACRGjpUYwurUdxuLLvX1Gqb1qC9YK1Y	1489	1014	287	6301	12463	jwYi1im54LFdyZrTfPNLxV4xjCUwubPLbJfT8rurkr7vJLxF8nz	8656	12243	12243	1618142940000	canonical
17089	3NKnrN9qohgHqLokxDZsaaSXydfHqbXhhTB1BhFRhRrD2qKrffqj	17088	3NLWgZAj4FyQv458yBTJ9GUcsTZeByXGALnxUAXwJRuPNi1eRAZE	1467	1376	287	6301	12463	jwmByctHGW7ULYoGiJSqJSDigNYi1P9nierEHi5kwogAU1gNVAK	8659	12246	12246	1618143480000	canonical
17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	17093	3NLUouUJXpqpMRZAEUGFrSCoLrThw3L3aRRnxxbiB2C1hgMzdFGM	1627	1385	287	6301	12463	jwVr5ns37C5QrHG6t1PfRLwr8tApCpQSCSmvNrVU8j6AsqJzMk6	8662	12249	12249	1618144020000	canonical
17102	3NL6752ygLo9keCJ2zQgwjkE1FkMZ2WLrWVHyck5sz3Q14KfUPoP	17099	3NKybMqmuBUf2AxZZKFpQx868UkmX2yiqnAsTYbkVdb8GXXnWHXT	684	1226	288	6301	12463	jx7nz9cuUAZ6f1K35aSbjHK1U3K3i2h5CT733DBjyWaMwMUc9sa	8665	12253	12253	1618144740000	canonical
17104	3NK3z7aygsKbwHTMuTsrxHDmH4RZJckkiJ6qh8xYTkSccA3NSMBe	17102	3NL6752ygLo9keCJ2zQgwjkE1FkMZ2WLrWVHyck5sz3Q14KfUPoP	1637	816	288	6301	12463	jxjeb8ojaNCYushxTdvkQ65xQ2S3WKvuPjJjYMtXn7iC78t5o72	8666	12254	12254	1618144920000	orphaned
17108	3NLPaZhSeTo2zAppXV87xYJFWRZ24nGrXEjFDfcrjQFzKjy2c7UK	17106	3NKU9UkgbhTCvQEuNnwQ2PvaQxgX4k8PcjCi9ffP6YkgPdhYkTkU	1590	1300	288	6301	12463	jxAc56dsrzueS1iAZGNC4gutttyzGbcMRVbV18nQJd6YPUbUTaz	8668	12256	12256	1618145280000	canonical
17109	3NKtMLGdueXSYsjbVXLao7y566wKJt5qVG6rhiydY9mR9fxVZ3M2	17108	3NLPaZhSeTo2zAppXV87xYJFWRZ24nGrXEjFDfcrjQFzKjy2c7UK	1419	814	288	6301	12463	jxBwAj3j59P5MMiJG8jSxy9hvcoeSeAEj6BZ96NQ6TSBdoswzGM	8669	12257	12257	1618145460000	canonical
17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	17109	3NKtMLGdueXSYsjbVXLao7y566wKJt5qVG6rhiydY9mR9fxVZ3M2	1406	1393	288	6301	12463	jwawoEC7ViiitqdLSANZgatVAHS7ZrSXp58FddwoZJd4NNRHf6Q	8670	12258	12258	1618145640000	canonical
17113	3NLPGpnXwL7AQVHbCxWTeNEd5qbXxtauLAmB43v7ygRHDGtFs7xM	17111	3NKkvRjBfJVAhG3T6RToBi2BptbUc3UTRFwteqfPrM6ji9hF4a1x	1637	816	288	6301	12463	jy17mY3yUwPG5vQHvCWEXADvf52P2SbvYLAgPTokd43aMCBoqS5	8671	12259	12259	1618145820000	orphaned
17117	3NLZAZMf3ZSxa1QfTQ5FUQtsQKWwE49nPKTX5rtEhifu6kD8MRaj	17114	3NL3h4n12poVuSHJGfpfRTRubnX3Gd3gWxzhSYGEez4MESe8pzhQ	1673	1122	288	6301	12463	jwVvi3VwsjweW3ymWhwaFLrMAcaTY7ZFd8Pvv7ipA1qWwp7VbCo	8672	12261	12261	1618146180000	canonical
17118	3NK79Stn6HUXwhT4MZgVn6N6gBFZybhaGk5x8NGuTbiNZ438PBzP	17117	3NLZAZMf3ZSxa1QfTQ5FUQtsQKWwE49nPKTX5rtEhifu6kD8MRaj	1405	865	288	6301	12463	jxKPT9wj9iPrnEzkHcgV5WxprQXK1zuuwa2wtqrBv5uuyTxSPZU	8673	12262	12262	1618146360000	orphaned
17122	3NKW6UqDD6TUiKx4c9JA6bRL3VkCqZYrT1K5pGmn22FYk3H19pia	17121	3NKr4GPqBPDLaNT9Y9B29QBvVbMLtS6vhUnyQDHsjX3ZS5G6HmWW	1522	956	288	6301	12463	jwdeHpKTMP3gguws3HBLthzJx7SnGeyznBn48g9aD61c7HbFSvY	8676	12265	12265	1618146900000	orphaned
17124	3NKE96Me2khRDyVzjTzN6sMsW58RwWUSA67k7cAJ4wcx2SvRGFCB	17123	3NKYba2k3rPWt7pKDSq4LCv6RuvhrqArbFkgfnQQQ5wBX5CbreBS	448	1179	288	6301	12463	jwg17AVB2G6xjKRwsw3yMbL6ek6D4YEWevZoQ4CkxuHcLm22Lx3	8677	12266	12266	1618147080000	canonical
17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	17128	3NLo9H2r6Si6KxqrAezHQeucRgz4h7PwfQBogQkSqFnDceaWbnkR	1503	1277	288	6301	12463	jxxushMmGkdtQGoMJEQP3KpJWyyt7XSGfcQVJDKQjdxj2EgRCse	8680	12269	12269	1618147620000	canonical
17132	3NLfrYDgJ8ySAWMuo6gHcQrHbYCZDSEMoQqsnQxZfmhFnhBMfWnz	17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	1406	1393	288	6301	12463	jwKAu3M8KRdNHNZgj2Hsfkm9y3Da1NENms1q1KZFiMsYto87gtJ	8681	12270	12270	1618147800000	orphaned
17134	3NKSZdmz8qievmVgVYUA6Z21njAXtC3whraqCesGM7Q1hym49xTg	17131	3NKuZXB8VQduGXfCTE59guc1eju5PWWLkAEm4SpNx9KifrVieR1L	1633	1264	288	6301	12463	jxbxJuVRuRa9e8Q83jy9VDzWbpaf6tZbifXLHedh1hogqAJ77WE	8682	12272	12272	1618148160000	canonical
17135	3NLAMGmHLR1wzz45DzvcasHxPJncdsxfaNDjSqmLosQBbMgwU4JT	17134	3NKSZdmz8qievmVgVYUA6Z21njAXtC3whraqCesGM7Q1hym49xTg	1529	1070	288	6301	12463	jxXoeQ7YbNVmA1k9FeK6gWFiKGu1YmZdzWLdwax4eeWEykG83Z5	8683	12273	12273	1618148340000	canonical
17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	17135	3NLAMGmHLR1wzz45DzvcasHxPJncdsxfaNDjSqmLosQBbMgwU4JT	1419	814	288	6301	12463	jwz3RcpEYBKzkhUN8VB7wkQTaKX1sXCYbmVpmkhHUGSWDT7NtM6	8684	12274	12274	1618148520000	canonical
17139	3NLdHQYuHyNGuVttJTEL6f8XAFoV5xEq9ZC12tMQbCVnQyvMfnz8	17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	1611	1341	288	6301	12463	jxrsqqZkXAUh4xLYGBCPuyhg4wj4xdDUH2KYnjjaMM5XTW2oZm4	8685	12275	12275	1618148700000	orphaned
17141	3NLiSperQxM59fXF8MNcYx8zrifRJqZBsobwiDnALptxLi1mKzLy	17140	3NLKN5jkaimpamcnSAZApoQnJMfX9MGBsbMCgcXe5oMC7U9mz33J	563	993	288	6301	12463	jwRke6Zi6HRHofoG5ZPC7PdqBqQCfnXmV6QovN4R7ARQNnnLTLu	8687	12277	12277	1618149060000	canonical
17143	3NKq4Cn9YpncpEMh2yskuRJXcij349zmjYY7FVRDu77BveiQtCWB	17142	3NKpzfoc6Rko6TnmsFAjTFTyKhfowugH9e5yNpHwxU2xMfFN3ZHj	1602	1123	288	6301	12463	jwirSkimPgVyztY2kxQDJGHn8ecyRVKhGgZrjTc3wvpLApQmYjA	8689	12281	12281	1618149780000	orphaned
17145	3NKKwyameAyKRATVLUtZQUxkBZmZMEvrsd5Y7ehfk1TYAyMAaVYb	17144	3NL5x2de632bcojhU5UEKUwBX6g8ceoASkqS7xJRagEra6yBLFMW	1647	1176	288	6301	12463	jwPA3LM26NXxcfTZnHG3T53WzGVVcZ7PmCiNPRifdc5nntYszDp	8690	12282	12282	1618149960000	canonical
17146	3NKMkQj9Nwj5fBeq8tn1yJkTXFLTJWhvKWmhWfrxrrbpL3DLRUoN	17145	3NKKwyameAyKRATVLUtZQUxkBZmZMEvrsd5Y7ehfk1TYAyMAaVYb	1406	1393	288	6301	12463	jwfyTP7iQ5AKxBC17w1MkninmzweeEp43ZxjvJd4LT9bLdBgWVL	8691	12283	12283	1618150140000	canonical
17148	3NLFz2N2RAvvqkAUeFdzTv36hfVdjmjzc2Kd9TGV1b546aoBzfJw	17147	3NLL2pie2iC3JXQgAMbWbp7NrfC3YQ9P2AGtaBPKeymsc6eB4svk	1577	1201	289	6301	12463	jxBzt9Yu1QXwweoqRGUdQezXj9wMNAzoCgmKW3sYxBcRtNzxFx6	8693	12286	12286	1618150680000	canonical
21181	3NKV2RicfQgG69TR83bor7MZX1vUEnC5uB2xiPtghw53HgeT6rfY	21179	3NLAbRKh6DxvD33NvWnxUjZb1MhWEg55FzqgMvvaKVy9Mg6ev3z3	1407	1395	385	12463	13432	jxMt1a7xQMGa4ZfL1GHjK2m3R1ykZx44yhbJvw8SZ8GbRM5feJf	10636	14976	14976	1618634880000	canonical
17166	3NKPbNbXDB2w6ugaJ75dab4qa7Q3pD4heHGiBrK6LCbb8kGkRVVg	17116	3NK7u31aFSnjYH5JriPUKaPjynRdQ645Vbn3eL4NV6keC18EHYMw	1571	1335	287	6301	12463	jy1EeZVGVvFkRfBXhbWeCfvDQw1eLPnuA6rBQy5NxZLM4XeDt8k	8644	12301	12301	1618153380000	orphaned
17138	3NLwxb9BEKQ2szNy8uWycuQgntMbq3nFrRRTjHyfrxmW5sHZ5knn	17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	1600	1372	288	6301	12463	jwDgyFNaafrE2XtGByjad25TYiJJyqjahR87pSc9YJUTbNQZ9cy	8685	12275	12275	1618148700000	canonical
17183	3NLQLbizG7ubii77wJsMsQnHmPbkfADwHGPoE9W5Kohe3mZF7TXE	17137	3NKWyKTnYQonCjZJJd7FPBFhRqhgHaCBRXqPxu1ChLqSeycc17cq	1599	1041	288	6301	12463	jy19y1GSWp8frsaNA5mXbf3xuiKZM1invf488LXjHCYoxuYnRZF	8685	12310	12310	1618155000000	orphaned
17140	3NLKN5jkaimpamcnSAZApoQnJMfX9MGBsbMCgcXe5oMC7U9mz33J	17138	3NLwxb9BEKQ2szNy8uWycuQgntMbq3nFrRRTjHyfrxmW5sHZ5knn	1619	1029	288	6301	12463	jxGmYpsN8bBNP9oZHuFtngAUeU8psk2QpeZ7XV2W9dGsfP647TS	8686	12276	12276	1618148880000	canonical
17147	3NLL2pie2iC3JXQgAMbWbp7NrfC3YQ9P2AGtaBPKeymsc6eB4svk	17146	3NKMkQj9Nwj5fBeq8tn1yJkTXFLTJWhvKWmhWfrxrrbpL3DLRUoN	1406	1393	289	6301	12463	jxJChiR1jJHnqKdKfyZRtiu9BP37z9U1BS6fKTeWPLfVJBYbxay	8692	12284	12284	1618150320000	canonical
17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	17149	3NK8fqTh28gEPheCfFn5W4VSbbEVVENBSmpKFDAsohKg4Z3NgwTJ	1553	776	289	6301	12463	jx7PhbeqyfYAbtBVmTFKAKTVkRZV1pFM3zok1zZrpXE1wdF3yJM	8695	12288	12288	1618151040000	canonical
17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1403	824	289	6301	12463	jxnZaDYKANLantsTuZNvieFKufi1QdnNRXwAC91h3GASW8e2Loz	8696	12291	12291	1618151580000	canonical
17153	3NKnGwwmcGixF4gnMYUFr9JwC4PTeFovUtY3Br8xF8poV1FwFLZ5	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1564	1338	289	6301	12463	jxSFb2Zzo2Gexef1jPVvUMCTUgWrF1S9VLRfYyDxmN4i3xotYjF	8696	12291	12291	1618151580000	orphaned
17161	3NK5G89ucYF4rGMEbJYpRXfsEDx2CgJj1TyKGr3FW1B3gnYbQ1bK	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1448	1185	289	6301	12463	jx4gRgi7yEQZAbip3Kc25L1QmSGAEuEUzTPEFKczZnwPjDtXyig	8697	12293	12293	1618151940000	orphaned
17162	3NKJppo2X4WRiae9aYSQQkTvfMhu1LRUeWyPoJVNwiePXAKmztR1	17158	3NLL1247JdajhEuzeaajtPU4FYMzfoQL5LzARvmnWuZju5K7YvZg	1579	1263	289	6301	12463	jwK4h2k8Wp4BuAdKxsXU7ZjcmErrTU4jB7HAiE4BsXss9fDKeVK	8698	12294	12294	1618152120000	canonical
17163	3NLMadn3Zr7BcCwJXVQ3PSndujfk3zyetz1GLjTSjNhZwqMzurro	17162	3NKJppo2X4WRiae9aYSQQkTvfMhu1LRUeWyPoJVNwiePXAKmztR1	1419	814	289	6301	12463	jxYeDhk3nXLB7gXWauvgVnqDEpKuqiwgHhAo13cW8j5TEqALZSK	8699	12297	12297	1618152660000	canonical
17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	17164	3NLkAye8RFbFNRJ4bQ6FNW3JDtXWXkd4T5eEPpfDZKvtRkx9sN1M	1407	1395	289	6301	12463	jwSogKaZXWoyaUooedqdx2esLBPhRhRGhFC3WHYsyXW8AY1R417	8701	12299	12299	1618153020000	canonical
17168	3NLEuzTWaSHuPBZSdoQc5aLocVJXvAoEqJhNd8yQJJJEotdiYmGi	17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	1419	814	289	6301	12463	jxGd1D1TaVjNHmj3zDY38Hcpn2R2uWwF9U67MzJGSZoVjcwUgFM	8702	12302	12302	1618153560000	orphaned
17170	3NL6xZ5tT9EVZLaxAYn8VfFE3rp4etAdc9kN9TftKo9KWWfzRo8B	17167	3NLhHZPhXVgusjvM7NJkgUsD4THkUvqe5PsGwMBWN6LDD6QmwHmi	1426	1118	289	6301	12463	jwrH978ji64wMgaWxK9UdGNmZXPobwMqQGjMp6QjE4h26WfUNUd	8703	12304	12304	1618153920000	canonical
17171	3NLdcp9Zcto2ZZMe9PMLLKduxpMrZVBWmM9Kno2bshTbQLsEketw	17170	3NL6xZ5tT9EVZLaxAYn8VfFE3rp4etAdc9kN9TftKo9KWWfzRo8B	1455	1086	289	6301	12463	jwr6b2dN5hLUe5993PubuJjEdmcJfrKCdXx7eaqTHc4zRzSPxNU	8704	12305	12305	1618154100000	orphaned
17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	17172	3NKPvUFJuvUoXaxCAnnasdvSDpHMJzHadyzaF9AyczQi3KcEZKQi	1405	905	289	6301	12463	jxkgcBW6fExrUXLYPVbB69jz29TnPnN7UuTLP7oc28LaUrZrGLQ	8705	12306	12306	1618154280000	canonical
17177	3NKRHHQQEnMy83RL81tFKYDjM2gYCJKmuBxpMBz5AEmVyKLY8bur	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	171	1374	289	6301	12463	jxaYnxD76xPAVZG7ZVrkUAgnswfkdzbcCWnwjxtb6UVJXLPuE3e	8706	12307	12307	1618154460000	orphaned
17180	3NLJpH8qRWb8oiE4Gsb97mar16CdvPm9zeJiDEwnDG8Gbwhnn9kJ	17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	1599	1041	289	6301	12463	jxN3V9ri6GmXVF1cUxgnNQRbeBQAfRKkLSuTUnoNwrPSzX6PXc7	8708	12310	12310	1618155000000	canonical
17186	3NKqwS6FhS3v8PGkdKKHtrSsSwL44GP3EW1exBCDY84jSez8Na3X	17180	3NLJpH8qRWb8oiE4Gsb97mar16CdvPm9zeJiDEwnDG8Gbwhnn9kJ	1549	1116	289	6301	12463	jx63cidp3njevqFps65SF6GhnXKfuGGojHfD5ajB9z7XwXWcniM	8709	12311	12311	1618155180000	canonical
17187	3NKqwD3UfNqzcdAosMarnFJabZXNdf45XJKJD5Q8D2v8HmZAJwQD	17180	3NLJpH8qRWb8oiE4Gsb97mar16CdvPm9zeJiDEwnDG8Gbwhnn9kJ	1407	1395	289	6301	12463	jxQ88AbPjCHHBQ1vRpwpvkvwt13R4e6KYUBDHBdqV4Y6sHCeKqG	8709	12311	12311	1618155180000	orphaned
17189	3NKVkPvf7YScR99gfMB9pqb8fzCT8ZWE7nJf3WqGTmuHJQSJ6FSc	17186	3NKqwS6FhS3v8PGkdKKHtrSsSwL44GP3EW1exBCDY84jSez8Na3X	1440	1131	290	6301	12463	jwVaGFULs5aSYyx28VWWS9i9AsRtU1iQ6K6M9x8sPZPhW56JyJE	8710	12313	12313	1618155540000	orphaned
17191	3NKcN4neVXnhLppNyxGQzuXvhxzdoq176o71TM4NLECMZq9wgPSh	17190	3NKaVoVmCQaNo6CJ3E62k9x7h5Jj6pTGoq1BEvZhvVp6YEyPUdhq	1406	1393	290	6301	12463	jxkUbYsqR2uSwG6g3gtzrKRseQ3i7FAxk9uUhhZYKwmKgKGSgi7	8712	12315	12315	1618155900000	canonical
17194	3NKSDF1SQTFTFn7cJXqMRqA7hRsPV9zwSJWozyAzUQvXFJmEacTH	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1448	1311	290	6301	12463	jy1Aak1pZFvGKRh4C7RpndE2xjba3HmaJQzN65e8eeDfkCQUodn	8714	12317	12317	1618156260000	orphaned
17197	3NKUUsyEdHLxTf5Yyyh9zPQALAX8TwVTK9Tu6MXvuM5u7UmPAbrU	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1581	778	290	6301	12463	jxk5zHbFXBfhGetFfKpW2mTca81A7ByURLqHV2RoVE1qMgS8oGm	8714	12317	12317	1618156260000	orphaned
17198	3NKw1ooggTCf6BjYZJo9kUKcq9LTWvQqS6nhwjRaBdCU84LJ8Lqp	17195	3NKDNeVqAmVGebE1GVbVv1jpSFM1KUXCTWP2Ci6w1WhFoPJSrj9f	1406	1393	290	6301	12463	jx1gCT8Pn1JVxGk1QHiiKWWMkcUwcVD9u1WhjpHZkNpSmD5Hg9o	8715	12318	12318	1618156440000	canonical
17202	3NKMbxXG9MDERA3JTFuReDHS8Lgpt8WgnK1Fkk4TE3axJyh37xec	17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	1506	1373	290	6301	12463	jwx3ZPsvCvj7RiTrPLRStDEuyYWa48g7CMdrBtJYEnczR9S3xuY	8717	12321	12321	1618156980000	orphaned
17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	1622	1110	290	6301	12463	jwbm49SiCGB6Ta8VXae2TFG2Gtd3VfsVQqtzLc5oQw1VsqLRENw	8718	12322	12322	1618157160000	canonical
17208	3NKnKi55UunEXWAWTcJpMPzVmssQZw9v6Ro857Hvjw2L62oemghi	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	563	1359	290	6301	12463	jwQHeidtbSUv4Z1tLwdWPgDxfGxr24oqXRHS3MT76A3TwRihBAg	8719	12323	12323	1618157340000	orphaned
17210	3NK7C4LnorF3JZEYUERBqFautzDJU2cnuLp3Zakaugb4yQT2SGSU	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	1649	1257	290	6301	12463	jwHZEs6QMf2z1RC8G9ULGyvfwp1orf6TmgQWn3P8rjaovz53mTQ	8719	12323	12323	1618157340000	orphaned
21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	21208	3NLsq6fBoXxuo6ZbyYGMEpYjBFERwQhKq6ur2uZSSPaZyvhh9Yta	1402	852	386	12463	13458	jx4B5A5qLuiftmQbNSUWPp2ZTk9HS77x92qw3MGFhUioGa9MKSq	10650	14999	14999	1618639020000	canonical
17169	3NKNwivqqNfUHHhBZPYCueSLmGwSrCUhY8N7CipQCKQH1nAhyMqu	16936	3NKCtQgbsdcCBau2dqZ4HHg1uvFpZGhn3ansmw9CFBCTA6aEyk7A	1426	1118	284	6301	12463	jweqGEiDrvS7SZfasK5tWWMVZHXAFvYnYwbrbJcF6opGZo4B7kr	8586	12304	12304	1618153920000	orphaned
17271	3NKzx9kfQPx1jE2Gv3DyijcmGjp9fVeW7AVx4i5M3QdrWUsU1Uau	16991	3NLR6xHi3RoVhpwafSK6qUSpmcsZYaFph3pughduv6ZWwW9myGqP	1601	1142	285	6301	12463	jwURX5TFDZWVrgGfRaC6Xi8J8TwyguNWdmb1Mzad4yukN5gQFsQ	8608	12361	12361	1618164242262	orphaned
17149	3NK8fqTh28gEPheCfFn5W4VSbbEVVENBSmpKFDAsohKg4Z3NgwTJ	17148	3NLFz2N2RAvvqkAUeFdzTv36hfVdjmjzc2Kd9TGV1b546aoBzfJw	1471	151	289	6301	12463	jxFpXDQf8ArAerh68biopcHeWXMs6bJV3QBY1bax9a4dpoAJAzq	8694	12287	12287	1618150860000	canonical
17155	3NKLtjAdwSwG9FxNmwFtPDfofpxfzLcgZVuwq3CjKiVfefrtDiTz	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1406	1393	289	6301	12463	jwuEF5tj7ARyebDxZcNmF9iZxXw7GK8Ga3NuRQQk8MaXYkucqjo	8696	12291	12291	1618151580000	orphaned
17159	3NKYPBQMjz4GfTiKsy6q4YJgzbroqxN6o1PrpUQCJ5THysLFeLwB	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1642	1001	289	6301	12463	jxpbQTL4pRJcfdof7rTaGX61NpMY5E3dzfQWYgPZ7QwSYwqYQqv	8697	12293	12293	1618151940000	orphaned
17172	3NKPvUFJuvUoXaxCAnnasdvSDpHMJzHadyzaF9AyczQi3KcEZKQi	17170	3NL6xZ5tT9EVZLaxAYn8VfFE3rp4etAdc9kN9TftKo9KWWfzRo8B	1397	828	289	6301	12463	jxYhuvsDfUCVDpMuAz8PnBKQLLunp3bF1ZiBt6PdZ7G3BYjpYTC	8704	12305	12305	1618154100000	canonical
17174	3NKqwGhdkmxkeoFjESYQbeCWGAjrBd7xkT6exALrW9sJeJaq6cqp	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1656	1097	289	6301	12463	jwCbWU4Q5WD4iUNaZpaMKwC6jiXxmCYomwck4Av3gr4rgk7wBdT	8706	12307	12307	1618154460000	orphaned
17178	3NLMrzGB6Gj8WKPkkgki9RFm3d5jDWGwwzMQqzh3eJCCSbXFGY5w	17175	3NLyQPDy1W6R7GQjU52ZfUSEmukHfvmL6QTPYeBomFdr9pzezT57	1581	778	289	6301	12463	jwyrCR76LBUTLQ7jmnTokGmoBNfNWXuevHWcMf8gWYSce7SmQfq	8707	12308	12308	1618154640000	orphaned
17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	17191	3NKcN4neVXnhLppNyxGQzuXvhxzdoq176o71TM4NLECMZq9wgPSh	1652	1069	290	6301	12463	jx3UFdViaYuVwFe4w6n2rMxp4z3ctq9x72dw83aVaPtMTwoDNJj	8713	12316	12316	1618156080000	canonical
17273	3NKmSLN5W3GvWNrjqL7UR8J2Ka9ynpZHmV2MgcwBysa6LnvhTqKU	17191	3NKcN4neVXnhLppNyxGQzuXvhxzdoq176o71TM4NLECMZq9wgPSh	1601	1142	290	6301	12463	jwwnJRS7shjbK73UJY1oTdCTnxHtNeSfYh7E9uTpebEtX5M9zsp	8713	12363	12363	1618164540000	orphaned
17195	3NKDNeVqAmVGebE1GVbVv1jpSFM1KUXCTWP2Ci6w1WhFoPJSrj9f	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1403	823	290	6301	12463	jwHcMZmUn7CaLGbST13BJiRndhvLWbHWLzwhT6NxXBeZdHveTu6	8714	12317	12317	1618156260000	canonical
17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	17198	3NKw1ooggTCf6BjYZJo9kUKcq9LTWvQqS6nhwjRaBdCU84LJ8Lqp	1579	1389	290	6301	12463	jwFTKwUVZDk4fzUHeuzvNtfLYxj4gXwa4MTViWRL4X1UUnCi2My	8716	12320	12320	1618156800000	canonical
17201	3NLXcbyvznATnNwRsCbNL5BaxJzTbwMwe8t4gihRCb69hzF3KJZo	17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	1657	1344	290	6301	12463	jwcHEbjX3CP6tjdcKKL56EReBRNhTVCZn9CnqwU1bekkhzY8E7v	8717	12321	12321	1618156980000	orphaned
17204	3NKEvFjd14y5AHNBn5M5HdgtPHAjtJyLUzUWKhXGGkCMYXj7pDUd	17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	1546	1093	290	6301	12463	jwwJRQEcvyr9H7wyZGcGJoNWJKaoUU2ddJxVcaGsQHukQdpWWXt	8718	12322	12322	1618157160000	orphaned
17207	3NKsDKEUQq2k7ePy4EzQMAAaaBGDtxcUGa4TadqBe2aguX8Vw5wx	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	1649	1257	290	6301	12463	jxXbwUNAW9TDpJeukYKDKJZ27FBXxvvXpfd4DkVE4vvzaYoLCkU	8719	12323	12323	1618157340000	orphaned
17211	3NLjpZuzHRHyXQu4QEKfBnQsB9goo2RVQzmMdsRxGYygCPYR8qNV	17209	3NL7N3aXsYYmc4rEFvVx5nXLNf6ZDRN9kZnm2PpgZHyfNe55outH	641	1090	290	6301	12463	jxEWZKTxGunhHgoujhLNfUZC6hmXQMDxkMeLhqQqanPLT7hmJTA	8720	12324	12324	1618157520000	canonical
17214	3NKLnXVtY99hvboksCyfydhuJ6q4UucbobmRf8vPKyhPkrSBLGuf	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	1397	838	290	6301	12463	jwiBeMD7L3cQuahZkj9b2aLPMos5KXURLipvTkfsTgLYWgBdYD3	8722	12326	12326	1618157880000	orphaned
17219	3NLCVMccXRAxvnvPf722YzMniqenCFqCamEPFWwfkTbjQZ8Mpn5G	17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	1553	776	290	6301	12463	jxidHDS13sQMikPrpgcyEFiz8H6dwGMmHURFsu5XY2LrLpLarZe	8723	12328	12328	1618158240000	orphaned
17217	3NLrou8s5inbzBsffP4RLKCoV1NWGUUaeYbPMRpCQnR9qWzY5fpt	17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	1407	1395	290	6301	12463	jxt4bgfb7krRKCojj34j1DtvnmDAJAVMKmQ2sXfUPVjjC8fDaT6	8723	12328	12328	1618158240000	orphaned
17226	3NLKQttny7x2RwQbnLje8voiu3dkyBNo7qZCHGd1dtLyD4skjKK1	17225	3NKCSG7wYaAD2hGLWZGo5NW64KtvJuQMkd3ARQcHGNVRNEcBLP8C	596	1060	290	6301	12463	jwnLuL3r2pQfhCmU1T2x9m79R4tEznGjCWMAZP8oAcWjzquLH8F	8727	12333	12333	1618159140000	canonical
17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	17227	3NLmhKSkkToMCwXSjRFpu39634zSB4NWuKtRyrqwBsCFDYPwmyrT	1477	1224	290	6301	12463	jxqj2BFMc7MDGeCyKAiiSwdeE8N85hKEbRFMJJeWXYHMyXEz8us	8729	12336	12336	1618159680000	canonical
17241	3NKrMRAyC2dwKvBDNkMZKcQipSqwQ4s6G6Y77E64Z87oCYyan8Vs	17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	1406	1393	291	6301	12463	jxP9ytq7NnzbdeJPcQgWRyHa3G4VLsTMrXgKvhkxD2EaMc6QXQk	8734	12344	12344	1618161120000	orphaned
17243	3NLgSfsvs7FKRjSQgBzdciFi1dkeELcexv1VLKV6aYDh2zp2gHNv	17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	1546	1339	291	6301	12463	jwju8vkExhpei41BjW2kZfg84Q1Fzqsau6nxJCaiDqS8PjWADCJ	8735	12345	12345	1618161300000	canonical
17249	3NLYJ9FnHgQn5VARsgRYGYTANh44KnBPYeev6SyA67H8666egjah	17246	3NLBQzrnwNWsMJNZJN3J7TBnT3nFdyU6A8GbKYCSvLcGRzAs22Vy	1609	1207	291	6301	12463	jwzM6G2zkUkVkzjbjzZoL6QPHTXyYxAHvYvP8ge3SdKLpxyH6JJ	8737	12348	12348	1618161840000	canonical
17252	3NK3aNKuruz2pi4EUsSgfhL4CZgtPN2wMvzUPPaeMFxTQ4NZW349	17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	1523	955	291	6301	12463	jwQ8qMoDR9ukGYMtsbdjwY2E4CL65KPKqstTgPT1VCGic7te8Ze	8739	12351	12351	1618162380000	orphaned
17266	3NLRVE8cUMbqzRT6eEk9qMJpuTjMghrQtPUnBXatg76qRysjsfdq	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	171	1008	291	6301	12463	jxfWJWzP8uLuS5gEZtE1EmMpuJ6XLWuSMgGXpLk3iztdiEcz6n1	8745	12358	12358	1618163640000	orphaned
17268	3NLvWhsP34rYduexTWKxs5DfJ4atmR8ZhkJSCoWpqNw16DTcDCJn	17267	3NKdooKXTLzAowQvwkswra5rwkk9LAaYpBwiYe2QyApVq1rwNJVZ	1633	1390	291	6301	12463	jxxoPwwEVGJSETHiJYgEAGNJXXCqvnAWf955qzcaSc1bV4ya53f	8747	12360	12360	1618164000000	canonical
17278	3NLHpebLbXLUVv6fsGVFq21LuSfF2Q3hvQaBtUnHNuN2BrXfXWC7	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1656	1343	291	6301	12463	jwDh21YSQ234tuCT3E1H11tzHSpiv3ZPxH8hAuNLnkm7v1LGiQ1	8752	12365	12365	1618164900000	orphaned
17285	3NKjTEVYgDbh5q65D4vQbVnBtVc3o1VYZBZvd6WyWo2gBpErMEQJ	17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	1637	816	292	6301	12463	jwggwuGLH43gvh1MLKm8RYDgQWJ4YeeTKefXiicHsnL7NHUengr	8754	12368	12368	1618165440000	orphaned
21211	3NLo1x2NbEBssLoxnVV5SgACRgtVqTmwQjBVW3UmWL8bNh6kpbJd	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1634	1331	386	12463	13459	jwLiAQqh4oE2MH5mUycdUdhWQfpaJ8Fwo5oaQ8TzgCyZxjCKZmS	10651	15000	15000	1618639200000	canonical
17193	3NKbZjwfhx3g2vPScVVx4uSwMJkCsXZBnbQCaTLCd1sVPUktNb62	17157	3NLAL2NRDfmAeXutss19e1p6TiUkbGx5FP7rHDXtAwG2Uc3R5cvR	1448	1311	286	6301	12463	jwzbqaYUrz9QASqfXBz825ksSn3JbWGpQgoR9pKSMtN3VrG4ePt	8628	12317	12317	1618156260000	orphaned
17184	3NLPbbYAodT6jBuTBADFXipX7KMYBwMmmcrwpG1pTJ1EPfw1wa1s	17152	3NKzkAPAhJb6b64LC87cYM2gKBNWTkXi81V2WoL4vXrnGvAg5kXD	1599	1041	289	6301	12463	jwJJWEcHMcW99cJQKqqXrQ2Maa1VbsX4cxzkbVpYRBW4Fr17miM	8696	12310	12310	1618155046386	orphaned
17185	3NLYSrP2idzRqzqxKSxvwvdD9QTerQbEV8VVDQyTXQRbeqMjcR2b	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1599	1041	289	6301	12463	jwdNS3Yy13tQuuK5hsS9Acp8fy37uRwgF4r1P4MAx61GD12LDgm	8706	12310	12310	1618155090237	orphaned
17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	17175	3NLyQPDy1W6R7GQjU52ZfUSEmukHfvmL6QTPYeBomFdr9pzezT57	1611	1215	289	6301	12463	jx2vYr6q5Hcvx6L8PXxcBrAurn83YjGZCgWGGLVhc1aBDsZ8EwX	8707	12308	12308	1618154640000	canonical
17182	3NLocG6XaXXAiKuTNMN1NB8oDXGeNxTWXCYsoXfaoBozA93oRDos	17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	1578	1296	289	6301	12463	jxz66Dsqq1hBMsgumb2AtcA8HhkXGYdyrbrkCAUEzkXGoSHNtE8	8708	12310	12310	1618155000000	orphaned
17188	3NLwnVXzzNXCmUryHfHwMg9K2pNF4qg2W98vPE26dQG3UVbjvYTS	17186	3NKqwS6FhS3v8PGkdKKHtrSsSwL44GP3EW1exBCDY84jSez8Na3X	1440	1131	289	6301	12463	jxdVwh3okgy7EARV3WsDGFvvJNzHjbq9jE1SsnH5vRsCFAjEWkS	8710	12313	12313	1618155540000	canonical
17190	3NKaVoVmCQaNo6CJ3E62k9x7h5Jj6pTGoq1BEvZhvVp6YEyPUdhq	17188	3NLwnVXzzNXCmUryHfHwMg9K2pNF4qg2W98vPE26dQG3UVbjvYTS	1402	874	290	6301	12463	jxPe8tajMFrn6ds3yptJpq9kndpsU4FCmAfStHP3248LzsENJZf	8711	12314	12314	1618155720000	canonical
17196	3NKtcEmcLkrpXqumv7bUqddAqWaajZJG13Bmfxuzrny1bBHaVkqN	17192	3NKxKi6NrnofQ1v4SDL9QvQcswsCW6DY8gJHBusL4wfJ19YGd548	1448	1311	290	6301	12463	jwgxvZM4n7msTz4DuCz3xScQrVG4ibqQ2bDxSB9vqA8S6MUV1Se	8714	12317	12317	1618156260000	orphaned
17206	3NKY1rCuw4hjSYL55jzQ1CvhFnMWTwJBWAqHfVEwg2XHsAGtJY7F	17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	1474	1329	290	6301	12463	jxqFDjefypncsvaxUMKWGAWqy2Gk1uv2TsrTgPJPwfNGoc6vZYw	8718	12322	12322	1618157160000	orphaned
17209	3NL7N3aXsYYmc4rEFvVx5nXLNf6ZDRN9kZnm2PpgZHyfNe55outH	17203	3NLpdF3qi42TmTuSnV1dQ3ziq2rXgKSBuw9ax6h8J5mXh7tFSpnp	1460	626	290	6301	12463	jwzEPRcgr2CNogGx1kczxB9mqSvdekPR9Ts9cTVUdLnrU3ZeS1X	8719	12323	12323	1618157340000	canonical
17213	3NLe7cCXNTMhvPviCV2DWETdWtHnG2FbCuyuMabq4rTJ9wtdyMD1	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	80	1273	290	6301	12463	jxsv1GwW75vtUq9HjZrMs5GH51WG29bha5ZMJGpydDctEyad6GM	8722	12326	12326	1618157880000	orphaned
17218	3NKQ9cQghRuc2g5UvnyqXGcJ93uPv2EVLAwb3EPU2HQSERRnprdS	17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	311	1181	290	6301	12463	jwKuf47wJi14xKbpCkLEMr6AXdoQx3h794Nz8yEop4zNR8bx1z3	8723	12328	12328	1618158240000	canonical
17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	17218	3NKQ9cQghRuc2g5UvnyqXGcJ93uPv2EVLAwb3EPU2HQSERRnprdS	1509	1074	290	6301	12463	jx4XUAEcnwq8StsrZXaEmZsGMr6p3ZvwC1PAWU7FzpXjTibTQXC	8724	12330	12330	1618158600000	canonical
17223	3NL8TykCNbGbAFbDcEFkNCzm9sXF78r2ZhRVJyAcvx3cExQyukJ3	17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	1448	1065	290	6301	12463	jx2LYqoWJVeGesCjpENAuRzdbu4zXpVxhwbCBFMn5Vuzi65qZcG	8725	12331	12331	1618158780000	orphaned
17227	3NLmhKSkkToMCwXSjRFpu39634zSB4NWuKtRyrqwBsCFDYPwmyrT	17226	3NLKQttny7x2RwQbnLje8voiu3dkyBNo7qZCHGd1dtLyD4skjKK1	1402	852	290	6301	12463	jwdBoSqA5nCTJFTUvbyByza8yBYXuC3W5jyksDU3dtmpPc39zEb	8728	12334	12334	1618159320000	canonical
17230	3NLwpAENSGMxKdwfHX1sir7X9StZvvJ2sYZT6Evp5apXoHqnAohy	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1451	1166	290	6301	12463	jxzxpSFKuXNmVEuycvJ41TgeFq9huJwPYRpP6n68forApvjgMHs	8730	12338	12338	1618160040000	orphaned
17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	17234	3NL4LoNmAHxVhWBdb6RtVhwSv6yTw2nCHYwQWxzvSMJkwXXBE2qd	1634	1331	291	6301	12463	jxs5iU8ojzE8GAUMxiNWZYqLreHzTfycuYRjegvV3NTFRkxo38L	8732	12341	12341	1618160580000	canonical
17237	3NKeT9BFTa64hZdPNMCdfhjMoR1R9t7VeeXfUtWfHnEXcXEVfumB	17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	1651	1301	291	6301	12463	jwxo3wnDxCLgHbWrgzbmrhonrRgNAHzKLX6RK8FSS9pYFcM9xi9	8733	12342	12342	1618160760000	orphaned
17239	3NKSSuhnD1QQzuPGPcjfrSqb6Kkb6bXFXpkrvE27r8SdrXH9iNeV	17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	1651	1301	291	6301	12463	jwXnp9y2Wv2LNVzwDfPNSLEFw5W1VeoYzCJjDxNDPfKCJ5KPnWj	8733	12342	12342	1618160760000	orphaned
17245	3NKeiw9gTo4A5urjYGJWNjvRutWWL2eheZpmbr6nSY77Xp7aivDy	17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	1609	1087	291	6301	12463	jxukxQsUKVxMSiPfcgUafLMwXeVhj2d5P6vu65BNrapEmsVHVDE	8735	12345	12345	1618161300000	orphaned
17246	3NLBQzrnwNWsMJNZJN3J7TBnT3nFdyU6A8GbKYCSvLcGRzAs22Vy	17243	3NLgSfsvs7FKRjSQgBzdciFi1dkeELcexv1VLKV6aYDh2zp2gHNv	633	1384	291	6301	12463	jxryzSed8qBbj3MXNUohdSMob4z9xXCcp6xs7LBEbCPRZepQdQZ	8736	12346	12346	1618161480000	canonical
17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	17249	3NLYJ9FnHgQn5VARsgRYGYTANh44KnBPYeev6SyA67H8666egjah	1671	1365	291	6301	12463	jxJ3rRqN82oVhMMLmmiuX3fjdcJVJmxhNcZNdWK8avPRowE9iPb	8738	12349	12349	1618162020000	canonical
17254	3NKUfiEvnMc9ykWP3vDojuVVsES421wfUMSwMESxjViHaffb15hy	17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	1523	955	291	6301	12463	jwvk7eh7BrqnsDNa8DNyHuYpGRSMxiyvbbPJtLpkzQZaokYBQmo	8739	12351	12351	1618162380000	orphaned
17257	3NK7cDu6V5dp9oGkGpxqGzN7v9vsjFqMBcTFfRGN6zPvWy3Pf2hb	17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	1476	1125	291	6301	12463	jxxwqi3ihEZEdmz9Ka96R5UfvPBaYiaRzduts1nGsFQnUUt21JH	8740	12352	12352	1618162560000	canonical
17255	3NLjoToA9QSGUVvds4PVGmAPqB6eC7r9w1nkWrHnrYgU9rhceNJb	17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	1476	1125	291	6301	12463	jwkC4s4Sw6tSjn68uMR17ALoK4t5EHxxF8Q7wejXq4TiktWqTsn	8740	12352	12352	1618162560000	orphaned
17260	3NKTbr8Shn663iH4rRfFEG8Vp9dPhzZvepHRW5HUmZFVsjZde9Ks	17259	3NKTtQNkwYNjQ9LyDAC6AqTvQzTqTqXw1AmCfVkRRurCt5cybFYN	632	1382	291	6301	12463	jxQmLg2hzC9WG7hKbVxWmFNCboiXETXsyg9vscHavHgszd47enM	8742	12355	12355	1618163100000	canonical
17262	3NLSDKgYkZ3Mo3VjXqbRF5i9yNq11eg6s71okDYUa26GUdiHCqex	17260	3NKTbr8Shn663iH4rRfFEG8Vp9dPhzZvepHRW5HUmZFVsjZde9Ks	1474	1329	291	6301	12463	jwNTYkc4ZTXzscQyYYYu8ppS41AtwqFbPngMunLM1FJShtDNvcb	8743	12356	12356	1618163280000	canonical
17267	3NKdooKXTLzAowQvwkswra5rwkk9LAaYpBwiYe2QyApVq1rwNJVZ	17265	3NK5dt1XSfXZcwycEit9sxtCG7BCCRr3VQGYWiTQ28S1WTyq7ehq	1507	1034	291	6301	12463	jwGXL9moSKkowhZZ8sEgbLafcUstDFS88qgPW6hQG8GwTY56hsA	8746	12359	12359	1618163820000	canonical
17275	3NKeD6SCDZ7Bmw7nKHxMDno8KVjSa4TEMiD5fvkdeocLQwWysTqs	17272	3NLFNsPKxVRmFKsqBmhk7mQNbsMbKC6DszMaKBrnRmNhDsb8hC33	1483	587	291	6301	12463	jwoJNpysLzeDLdJQa5wyHQABUoGzsTJ9vpPtzZf52nnZ6Wdn4ox	8750	12363	12363	1618164540000	orphaned
21217	3NLtdv41jHUwEv3S7Yw8sTnzGZVhXmzGx4UwhAvHvfaS8syZqEhQ	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1555	1347	386	12463	13465	jwhKW5JqtWX7vfX7E7DyvH4B7tCynPY8GXMAM2QyPxxJBavBkoT	10651	15004	15004	1618639920000	orphaned
17248	3NKzsc39CB1ZNTurhUqCkxJrfuw8nEKTtHas2CWRKt2ks5J6iS8D	17025	3NLunpMJknEJk1EwVTL3Hf1YQ3TFxdM6rbgdTex5LbBsMSNYw7HF	633	1384	286	6301	12463	jxGPpAbsacUeDiNs3oND3hYsPaBUY3Z14xNEtWkM31bB2EUmFxc	8624	12346	12346	1618161480000	orphaned
17221	3NKqeBMk83AZwon3tjALPt9E9UANtfayxKbUbwenYUPsNYkjFzZP	17193	3NKbZjwfhx3g2vPScVVx4uSwMJkCsXZBnbQCaTLCd1sVPUktNb62	1448	1065	286	6301	12463	jwn7YY5PtfuteSVjgj7fBQQ82rknALvVm7nhU8Atfoi8nnW2WNd	8629	12331	12331	1618158780000	orphaned
17264	3NLtZsybM9r5YfAqBd5bikWeqhQu38wFmss7GLySE2rG1RgEUpUH	17061	3NL21QHJixP3bKLJwMkz86PVKpghxj6XEbbuTbYjrYxNfewGtm6K	1588	1266	286	6301	12463	jxwEfV7q4sC7oJTADJncQmbCRP5H5esKwTWywgkLRsUNqve1hph	8643	12357	12357	1618163460000	orphaned
17247	3NL6bemdsc2bKbxJVmZEPGcT1eUPy9v47kyJuRWS71DSh49wsJJf	17168	3NLEuzTWaSHuPBZSdoQc5aLocVJXvAoEqJhNd8yQJJJEotdiYmGi	1481	790	289	6301	12463	jw9pCCBRKbG8UciYYfYW2wmzz9kVmczGfzkC9eT2pqJKP6bbqdA	8703	12346	12346	1618161480000	orphaned
17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	17211	3NLjpZuzHRHyXQu4QEKfBnQsB9goo2RVQzmMdsRxGYygCPYR8qNV	1631	794	290	6301	12463	jwDwGmUUhCXxU8E9GvtyVcSWrCUKByAcWWWbMFd9rRAJc5oSL11	8721	12325	12325	1618157700000	canonical
17215	3NLaFiy1jSKoszYkkYwZVVKbh3bwSpmumfGYD8DF6c8ea4hte3Kn	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	1637	816	290	6301	12463	jwAorwtNpA4RbSqDRxfspdhbicJxWmmfF2wrYBCePebSs9c39zg	8722	12326	12326	1618157880000	canonical
17222	3NLcvwPXi4EfpTj3trN91aH6rdDybFYVXvjyGqaiaL6GaGWXEJpn	17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	1607	1348	290	6301	12463	jxZXSKjw6yphiBJcA2DHiuoVj48YRFtPaScK1iq6pCeCLYkHPFc	8725	12331	12331	1618158780000	canonical
17224	3NKsqsby8etYaoEaHgWUJATQczH9RQZ8hhtHRU31ZRsVUQ6ZwY7F	17220	3NLQdqvpFfJ24WMsCRy7qTH1KKFBK3sNvGvMLwzQGZMNBLeahFKY	1448	1065	290	6301	12463	jxXU6S4YxcbdB99qznDbCCF74AARJ61uEsYdMmCuGFM4zDFoecP	8725	12331	12331	1618158780000	orphaned
17228	3NKc7U5e3V9qvJuoisjRBfdgMYWT8VzR4F3ZySRn5FkV6bVGiCJ7	17227	3NLmhKSkkToMCwXSjRFpu39634zSB4NWuKtRyrqwBsCFDYPwmyrT	42	42	290	6301	12463	jxBtLokPBx8rJ1zN6NXF8E5gG4DiD4BbYJVLPCEVveC8okKDU3v	8729	12336	12336	1618159680000	orphaned
17231	3NKSaG3H2daPdwTpgXbkj1ccxp2GwQLLZ7EemAMyt5tX7sgF72nu	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1407	1395	290	6301	12463	jwobHvEiAoV458qxxKcTnv1Tugv4tCwqezqa15584zdHAZwNYcW	8730	12338	12338	1618160040000	canonical
17232	3NKGdmPx8aGAxxH2uU5hu1qruzujdaMcfmtkwgZsWNCPA7gADbKv	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1451	1166	290	6301	12463	jxzxpSFKuXNmVEuycvJ41TgeFq9huJwPYRpP6n68forApvjgMHs	8730	12338	12338	1618160040000	orphaned
17234	3NL4LoNmAHxVhWBdb6RtVhwSv6yTw2nCHYwQWxzvSMJkwXXBE2qd	17231	3NKSaG3H2daPdwTpgXbkj1ccxp2GwQLLZ7EemAMyt5tX7sgF72nu	1509	1320	291	6301	12463	jxdi3Z8GXYrvH4WmEKDUcZ3CCCFHANCgFtv4yMogr7K8fjEEpoQ	8731	12340	12340	1618160400000	canonical
17236	3NLSGo1u8Xzf7kAjRXmmnzEJBL8d8VV6QCukN7Md7yMTfFWha5mT	17234	3NL4LoNmAHxVhWBdb6RtVhwSv6yTw2nCHYwQWxzvSMJkwXXBE2qd	1483	1030	291	6301	12463	jxWFW9pTk5bujZheMV1b4sTTdVCUJRWrHcC745gC7WANA6oVpHp	8732	12341	12341	1618160580000	orphaned
17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	17235	3NKsFRyo4mghXLhHkCRpTces8qU2YDnnokR4GBy7SMpxVH2Xf4W9	1483	1030	291	6301	12463	jwHfro1sM2bdPHP6yCo247jiB2mZgZnq3pmAEyrKoZPrim1iUoD	8733	12342	12342	1618160760000	canonical
17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	1476	1371	291	6301	12463	jwvhMLeh3Y42aq98ntCpgBkoToRdyjbWAD8MkK6FxhrcuWUcPmz	8734	12344	12344	1618161120000	canonical
17242	3NLZMnM7vZKmqbVpHRCrY8kkSkCiJp971Rc9Wo4v62baj7KLABjw	17238	3NLwq49LMR3p3sPG3Th1k1esaTZXJwpcAQHK3cYXfdY3VrKXewmv	1547	1012	291	6301	12463	jwNmRP58duw5a33P8qqfbZ5G8qsrkh19V2mgZMkp3LAZdczDQq2	8734	12344	12344	1618161120000	orphaned
17244	3NLmfXuyoNK6xXdr7LTxxfGHTDCbqHFvPp4a8UDWbtS5icqWV92y	17240	3NKyHV47CDcY5mzp4h2A6zTF7KAccSph5JnaTHeiu6eKWnsvW9km	1402	866	291	6301	12463	jxqvsmsXoPHQ632mYD9SXEzZyLkwcdcXdpWV1XS4KbSzA2ryL3L	8735	12345	12345	1618161300000	orphaned
17250	3NLxs7UUcrQqjshgkvptDMUr8DpXC67XwaLzckak4CG76w445EnD	17249	3NLYJ9FnHgQn5VARsgRYGYTANh44KnBPYeev6SyA67H8666egjah	80	1273	291	6301	12463	jw9te3fSHgfHRJNY4KFy3hsGMP4HW39b1VzMDYohLSNmbUojE5X	8738	12349	12349	1618162020000	orphaned
17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	17251	3NKYhJXiXp8mK5Pyr4uBVAJZrVJESNuZQZuyUrBRB42X4cU3YUd1	1523	955	291	6301	12463	jxg7rVSbDGHuwgvRkErBMVxnkRiy2et2NxoB8o41SZLYbdfNGCf	8739	12351	12351	1618162380000	canonical
17256	3NLL6XexhQeEbktvsFMdzaPPyAHvdPL5bbJfy7eojpdKg1VbrhUj	17253	3NKVSQJDF5r44wwDVouXzqBFEUMWczySFmguTcEko4kguePcFMac	1642	1001	291	6301	12463	jy2Fe83z8UiHPJVZSt6WDYPeMtJPNayC46iPcfUUDuJ2Vv2yC4i	8740	12352	12352	1618162560000	orphaned
17259	3NKTtQNkwYNjQ9LyDAC6AqTvQzTqTqXw1AmCfVkRRurCt5cybFYN	17257	3NK7cDu6V5dp9oGkGpxqGzN7v9vsjFqMBcTFfRGN6zPvWy3Pf2hb	1406	1393	291	6301	12463	jwQGCnBrPsibXD7pkwHWDyE4dCjPAkGWNHPnrwJn3XjMBf4w8S9	8741	12353	12353	1618162740000	canonical
17258	3NKo6srAME9FRKyGvnZ9Fzh544VobWzdegxnxTKHs9sNhsNYHos9	17257	3NK7cDu6V5dp9oGkGpxqGzN7v9vsjFqMBcTFfRGN6zPvWy3Pf2hb	298	1308	291	6301	12463	jwvd9P3EQAs5m1FXsBpNfAkmk9xBq6RHd3seHFTivFmvyLqn6ie	8741	12353	12353	1618162740000	orphaned
17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	17262	3NLSDKgYkZ3Mo3VjXqbRF5i9yNq11eg6s71okDYUa26GUdiHCqex	1588	1266	291	6301	12463	jx4g3vXRboHvCD7HDsbvRT4yjieVY81NFa3LyyL5WuUm2vrJw4i	8744	12357	12357	1618163460000	canonical
17265	3NK5dt1XSfXZcwycEit9sxtCG7BCCRr3VQGYWiTQ28S1WTyq7ehq	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	1529	1190	291	6301	12463	jx8NBP8rbvkhbQFLQBbb17JYDF5QNUSHUCvww5Etx5aeoAU4mEP	8745	12358	12358	1618163640000	canonical
17270	3NLMUVs5nYeFNpVqeKBZyKMguEdLTT2XpWZrVpYteZx5HHa6JEuk	17268	3NLvWhsP34rYduexTWKxs5DfJ4atmR8ZhkJSCoWpqNw16DTcDCJn	1601	1142	291	6301	12463	jxvJN8pc3q9r15qk7Tfg2tED5P1e9vs6ju4wuFpDvTNs8JQWjy6	8748	12361	12361	1618164180000	canonical
17272	3NLFNsPKxVRmFKsqBmhk7mQNbsMbKC6DszMaKBrnRmNhDsb8hC33	17270	3NLMUVs5nYeFNpVqeKBZyKMguEdLTT2XpWZrVpYteZx5HHa6JEuk	1406	1393	291	6301	12463	jy2sxpsXYCDKxd3C2QUniTj8BQZ5axCZheGrkZd3pVQEqpoPcrf	8749	12362	12362	1618164360000	canonical
17274	3NLu9HvpBHGadHRT5g8WsZNGvpKhEBfmeWyU51HxtSLYbLYD9ifV	17272	3NLFNsPKxVRmFKsqBmhk7mQNbsMbKC6DszMaKBrnRmNhDsb8hC33	1601	1142	291	6301	12463	jwbhwoN3iLLYeEn66V8FhZbVEmnynMAE1bMHM8VVQKpGS3P6gQh	8750	12363	12363	1618164540000	canonical
17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	17274	3NLu9HvpBHGadHRT5g8WsZNGvpKhEBfmeWyU51HxtSLYbLYD9ifV	1460	585	291	6301	12463	jwnvhEGdgaSHRZGKhVzJF82QCSZm7bGzSjLayKy2v8tpwiVdH8z	8751	12364	12364	1618164720000	canonical
17282	3NLcsCNqB2pGPTqTcy4oVCrhFccN6ekPdYqS4CckLBGGhpuSxzDh	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1633	1024	291	6301	12463	jxNFoqooB7YBcH2Djfp3oyvqr4vyCgRWK9a5ZDY3uuarjqGc2z8	8752	12365	12365	1618164900000	orphaned
21238	3NK8hBLzCocWnAmevo4yTrvNNwo2z3DT9KCUioyQk4LbFXofWk9n	21236	3NLa1wQed6VhXofTGUqVAAwGexdXYZA7PWxcSi76nnyXppV2cGCh	80	1027	386	12463	13485	jxFP1DdbMm7y5XE5xwycs9MsWw8Kd9bbH6cSPaEvAoAkaEN2VRy	10666	15021	15021	1618642980000	orphaned
17276	3NKjqcUAYM4CyhttwdYrWBoMHG3BDwNmPB2gTbH989UkdmTzp4k6	17226	3NLKQttny7x2RwQbnLje8voiu3dkyBNo7qZCHGd1dtLyD4skjKK1	1601	1142	290	6301	12463	jwbys7RZMqLaeyotkNJYGsQC9BCemDb9WaFArrazQU5cpej5Uxi	8728	12363	12363	1618164608275	orphaned
17281	3NK9ZJZcGjJqTtnzy5ULdBJXgYNY78F9AdnwnWyVLuPJF5hmSXDq	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1407	1395	291	6301	12463	jwXnQunUbs23MvG8Vh6QBfJ4pWMfZfu5ighoFyfojXjRwL7qiLV	8752	12365	12365	1618164900000	canonical
17279	3NK8k83YhsfyduqrQNAGAfR7sqbEtnDvwsRceWFmLqnjeLdF6UDH	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1656	1343	291	6301	12463	jwDh21YSQ234tuCT3E1H11tzHSpiv3ZPxH8hAuNLnkm7v1LGiQ1	8752	12365	12365	1618164900000	orphaned
17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	17281	3NK9ZJZcGjJqTtnzy5ULdBJXgYNY78F9AdnwnWyVLuPJF5hmSXDq	484	1193	292	6301	12463	jwj5w1o7nt6PDHU9BZzFhatK7vkHLiDKt4ewbnjYfyL8HkzH5wq	8753	12366	12366	1618165080000	canonical
17286	3NKSikaEgWkwNkA7pvZv8uut8jA5NDR3BEMtNVytrsLFfzPZyuDY	17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	1647	1302	292	6301	12463	jwQNvGSrjduUaSWfFNpuTvoJMLS5U2W4RuvEsmFLFguDUopJfmQ	8754	12368	12368	1618165440000	orphaned
17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	17288	3NKs2c4B8HqDh75XcDh8ACDhk3MVGXRNnxsPDLBLmSjxMkDeEWnZ	1403	31	292	6301	12463	jxR2gE4fS2NnxsYAH9Gwra2pyJtK6uaZbz9YVZ9XoFAYfnqpPLP	8757	12374	12374	1618166520000	canonical
17292	3NKvN2NMsEwMnZkKXNYxAWwhPQVwnWhNoCdeFiLfMtkVCxuGtJ4R	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1500	1297	292	6301	12463	jwi6vcr8cDQms3FKVz2PA9LMRXXfBruQvnh5b762HUCjfH6vfvL	8758	12375	12375	1618166700000	orphaned
17296	3NL8wDt5xy4QajadmwSdMP2AVBjSYrrYNUFQCxmsYZdVAKZ48tZy	17294	3NL6LycBQ67ozqVokazP7akvNAPvNcCxabufKur9XxjNGrdydwTP	1460	1078	292	6301	12463	jwjm9LgGmttuAzqaqyGDL44H4hWHVbPThMJHMbCFUivXq4wsioK	8760	12379	12379	1618167420000	canonical
17300	3NLXT2HeyZ18MvquDoSQdb15suRdG7NJwnMNnwt5UN2kfpt1de8b	17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	632	1256	292	6301	12463	jw9HVWCvKPJaPkS5kgNsQ3ELCFvPGekcjHRVLKvXGP6vRXNWFFj	8764	12387	12387	1618168860000	orphaned
17304	3NL5n9Z4cT3e5Gczp2nkZ3fFeiP9wce69TAwZahyhddY1hGH87TW	17302	3NLoMopcjuwzqgFxsb98A4QGpNg7HFfMugdgnmSWHAyqL3vHQTHt	1549	996	292	6301	12463	jwShuuz7By39njSVjh7rs12SPQhbsdLFdjQM21BYDTbGy6RVRW3	8765	12388	12388	1618169040000	canonical
17305	3NKi19coCg43e1Wxhz6aJZEqfa8iRNSurDpXmpBG7UgphJPJ1Sum	17304	3NL5n9Z4cT3e5Gczp2nkZ3fFeiP9wce69TAwZahyhddY1hGH87TW	1471	1260	292	6301	12463	jxZ1BALMQX42PyWwA6XkodiDRmoopuv9s1Y7ShXFGyEh7HkDyFD	8766	12390	12390	1618169400000	canonical
17310	3NKfvU1XVsyy41hQsCJEpoPLTCusnZLZkWcJ2JExCYdMyvNqerME	17308	3NLkm4Q82sCZonxpUS1rwCAA42KfQrFWTCf2KBSzTFQeaZ91Regc	1553	776	292	6301	12463	jwg3a7TFaVaA6651tTVRL8g2wDZxxQ21JEAdunAjkPVqjcuzZya	8769	12393	12393	1618169940000	orphaned
17312	3NKevqX5aUdDrwmmW5Cf6WCisM895PCXvpTRatYRb99YvGoJ83TB	17309	3NLRAuB7jA9cZvE5hyFpX5EYkfgqHctkjdqWdNSjfCw1hjNGkYHE	1607	1348	292	6301	12463	jwk6GaCEgJQiEMPuMLNpc2oMu9Xdy9JgNyLhsjZocZEJZYu7NJx	8770	12394	12394	1618170120000	orphaned
17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	17311	3NLyTGCYnSDVNjDerYKHc9vJHPQgqkaQTW31A9NcXFbAKAYpNWGJ	1546	1093	292	6301	12463	jwBG3e9wWBSSngobgmkNHnpx5i4wD2WeubmXrwLgEJCe22ZFME1	8771	12395	12395	1618170300000	canonical
17317	3NKS7wcY82hAMHwCy6pwpHGvqbohjqU4r8XQFFNPiS492fRDuin8	17316	3NKxSNQdCqCER9rnZiFYZfXY4o35kN9yf2cC3rykH7PpJza2majt	1581	778	293	6301	12463	jwMMQER67meG7W6Vr1XiZ8GxM6yCowDmdyYRgrEi5RpNxmtN2Zc	8773	12397	12397	1618170660000	canonical
17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	17318	3NLD1K3cJE1KzijD2aWfKFtxrq8ixLNHi4prZ57pzcESxf7uqfxF	1403	782	293	6301	12463	jwE4W1577tgRGMD973Rs5eCDcPDribqjeqifcJoPtP6SdoSSsWC	8775	12399	12399	1618171020000	canonical
17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	448	448	293	6301	12463	jwdmP2tHyFX9U8TJEHtZM1wjHkVBMYdx3Ybdb1pAFaK8z1ijQdQ	8776	12400	12400	1618171200000	canonical
17324	3NKz6joE6ZSd1oLdQoiFrtQVC5DR1oLckV299srpJa8kWt6BU3Ks	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1596	1363	293	6301	12463	jxbxX786TG7qbLUykKQXHL272kbPBBT1GhqHFtohCb9bXuoK1Jf	8777	12402	12402	1618171560000	canonical
17325	3NKqK2FieQJc31JRFfuKNzHC6fwDUq5ev8X4QvTwLaWVCuA4xMZt	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1634	1205	293	6301	12463	jxU7oNXrPayRLurVNZAvqWij7FMCyZehY9aN8tZzScgKmHL6Dai	8777	12402	12402	1618171560000	orphaned
17331	3NLnm7xpTpoDJz2MJbYyZ3jAoFF8bYawbZnue1Pe96Fmyouh8oFm	17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	1600	1006	293	6301	12463	jwwfhiBz8fFVxdDqmRVpY5LjiTgb7o2AsJRgZ8cQU1JSo4f6UeP	8779	12404	12404	1618171920000	orphaned
17333	3NLbqE1kEFJ55aWuKGimYRYjA3MrKp4VFqffDYQmM9jGE8PLrXnU	17330	3NL7gZQRfdQc72XwjJcbUau1M3W9vWcWDxdt67KH77cgxYadenAq	1405	869	293	6301	12463	jxZCieNKMooELbwqhZoxzA6RPZaJSTaSiWAMFzaTi9vyN21ykTe	8780	12406	12406	1618172280000	orphaned
17336	3NKsby7qhrxsJXHpsn3GMGCgsaVa1KSXMT5k6Yg2N5a7z622uvNg	17334	3NLn3UHKYZLHTvLrRDGbo3iCHAn4KKyftKNvH6bqvvr6cw1J6esP	1672	919	293	6301	12463	jxeVrrwFKSHVwX61mr7Y5MkK2jggYk3q3vYLcNMLQv5g7TfqDsM	8782	12409	12409	1618172820000	canonical
17338	3NK4AQ9S6TCxpoH1voBWYhApQSXpMiFbzYfyH3ykruMhPpoKL2B6	17337	3NLvrMRW36hYyWGisCKHABLGiZe5mqMcowy4kGBqyhV4HHPrAqdn	1403	31	293	6301	12463	jxbBXdMYQtgf5xh5iGzoVRo9M99fCJncLt21sRPKgU42AgLYBzD	8784	12411	12411	1618173180000	canonical
17341	3NKHqMJMpWomnWHcQPfD2NchSYg2fgBPVe6rBJSQUdTys6gWPFLU	17339	3NKSpf9LRMxHpEhTvk892ds26Cprbm5RzhWs3CvRGD1yZtMQsJxT	1650	1009	293	6301	12463	jwJ4cupfWrXb517d8TZe9XU2AeiVS72FqGgbZ1rv42PYwaHR75e	8786	12413	12413	1618173540000	canonical
17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	17341	3NKHqMJMpWomnWHcQPfD2NchSYg2fgBPVe6rBJSQUdTys6gWPFLU	1406	1393	293	6301	12463	jxdV2ThFHbcLN6sybFjfXJYhrscUPWqYzEtCseKxkMQktNiWPyS	8787	12414	12414	1618173720000	canonical
17348	3NLJ9FxyeykTEmztQzZSguMq42RsdsJJmraVc5hBufP8onwS9Sks	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	1426	1238	293	6301	12463	jxjHo5Knjyz9QfrojEzdPVWAyWrvsan6nLWG5Wwdx3oC6e95kF5	8789	12416	12416	1618174080000	orphaned
17352	3NKDdHgz5vAo8sdHJif9C2hoNxcL74qc3bpEcHHurR7WszVKSwzS	17351	3NLSdviqqcrVkzeQDEsgseH89WZsCGmVCZrwBoSj5kMDNPDjF91s	1444	1381	293	6301	12463	jwhZv6tEpJDBgeanV5nbXGGJQd8yuxBy9SDYDQnKx72RccaZSCS	8791	12418	12418	1618174440000	canonical
17360	3NLqGAqvrDNJ4PuSPdUGPBFMA5iEX4gfqvKoGmijgGfJFUYMiGW2	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1637	816	294	6301	12463	jxUheuBeeK91DL9JLwsFN6DwqrrUGcNXw4gHNUToq7pLePudx5M	8794	12423	12423	1618175340000	canonical
17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	17360	3NLqGAqvrDNJ4PuSPdUGPBFMA5iEX4gfqvKoGmijgGfJFUYMiGW2	1631	794	294	6301	12463	jw96NyjiPwKaAWT3SAn5JBEdd3Kqq3PqG4bg4WKcn8zktvStg84	8795	12424	12424	1618175520000	canonical
21252	3NKypvkmGmC5uYhnagNtU2JFazkDcAtBJghXkgVjiN7Ytkm8zBug	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	1406	1393	387	12463	13496	jxfMbx1toQrP2QCkaUg7awMcHYb3dBUWg88z7tUJX3TQiU3ByHG	10671	15027	15027	1618644060000	orphaned
17290	3NKBuaDp1PN7Tg3tJr34zZujWfLLy2kSUeUXZSEKsAongspQbR9a	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1458	1077	292	6301	12463	jwadF1byB42kqjDyUnRHc9K4w3tyEHpWbvPsB1FJqSfznFm2rhJ	8758	12375	12375	1618166700000	canonical
17293	3NK7GUssSYf6iapbu4hLy7CeMvdw3d2sM3dxug5YAgxAj2vn7iqa	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1500	1297	292	6301	12463	jxjekZX69J9BXXtSYvENYFGoN89ELSX3TxQcndkNxi7oVp9Vopr	8758	12375	12375	1618166700000	orphaned
17294	3NL6LycBQ67ozqVokazP7akvNAPvNcCxabufKur9XxjNGrdydwTP	17290	3NKBuaDp1PN7Tg3tJr34zZujWfLLy2kSUeUXZSEKsAongspQbR9a	1593	1100	292	6301	12463	jxxVAHRMfVLUU4SY92wtLF5mZFx36GLQU1iG2PFTozGMVTuu5Bu	8759	12376	12376	1618166880000	canonical
17295	3NLiHFEHRwXzEUYLFxmzNsKHijAmXivk4oYG92Fu4QgUaXUd9WUY	17294	3NL6LycBQ67ozqVokazP7akvNAPvNcCxabufKur9XxjNGrdydwTP	1455	1332	292	6301	12463	jwcMBTwX2AEhcKNkYv75JAgZ1mejR9BbzDzx3vxHrj7oTLewACB	8760	12379	12379	1618167420000	orphaned
17297	3NKK9k6N5B1jftbN27n9Kik8MB6KJjFj3fzCNs5En8TuXpzbcBee	17296	3NL8wDt5xy4QajadmwSdMP2AVBjSYrrYNUFQCxmsYZdVAKZ48tZy	1600	1372	292	6301	12463	jxDgGfC8d4zeemTkaW8TyjQXGPdfNZyKxJLv6w9dQxhT2ND3gFa	8761	12380	12380	1618167600000	canonical
17298	3NLo8TejEXz6NJG92ftzvPF2cwjVcc5UxvXPdS5WCbG2RAftzoRo	17297	3NKK9k6N5B1jftbN27n9Kik8MB6KJjFj3fzCNs5En8TuXpzbcBee	1406	1393	292	6301	12463	jx1sXSxYQYjFGSVdZ4SahFAy1tnLFvhDLEh8jfC1ZLMMw8JyCH6	8762	12384	12384	1618168320000	canonical
17302	3NLoMopcjuwzqgFxsb98A4QGpNg7HFfMugdgnmSWHAyqL3vHQTHt	17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	1406	1393	292	6301	12463	jwcARMAQrkt67WYxfobzRmbEXYi2zgospPAxpZ9qxQPWzCkLLza	8764	12387	12387	1618168860000	canonical
17306	3NK8QvSzmFpadFwJ2uk97Vn3wkxWKc8ESHjrSxYHAseJZvw2pPyX	17305	3NKi19coCg43e1Wxhz6aJZEqfa8iRNSurDpXmpBG7UgphJPJ1Sum	1601	1022	292	6301	12463	jwAA3MhBQ4L3H2o6RLktRDeqzuAVp2ykJtyF2st1hAN2wkUpgvt	8767	12391	12391	1618169580000	canonical
17313	3NKChLZnBddCmoazxeok8JK1csTsdpU5tf612U1qDN56fY2KKTyF	17311	3NLyTGCYnSDVNjDerYKHc9vJHPQgqkaQTW31A9NcXFbAKAYpNWGJ	1546	1093	292	6301	12463	jwBG3e9wWBSSngobgmkNHnpx5i4wD2WeubmXrwLgEJCe22ZFME1	8771	12395	12395	1618170300000	orphaned
17315	3NK6H3NEE4dHCoxfsqYTBhMvAwmNtZP9MTbrho4piwQTc5gwLd2y	17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	1405	867	293	6301	12463	jxDwqPgjBKKzGW7uRSvNFFhLYt6YSuy7fU8e38kBfodBfwbSUsx	8772	12396	12396	1618170480000	orphaned
17320	3NKorKh6km1HPprfgH3UCVVXbwz3D9eQwHCWzJT84hzisaMcvhV9	17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	1403	824	293	6301	12463	jxc3U8enoGt2jdFr1HE2taqF53wJqDpNCPMRqy1VJi6Vm8oNSrV	8776	12400	12400	1618171200000	orphaned
17326	3NKNafVFnecnp9uuvWDMjUoCuwd74jMaiP3yGZHfBUYbrRnrYkL9	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1577	1327	293	6301	12463	jwpUoS1UNyT8RNB3B8tu1vrF2AHrEo2rxAQa8K6EsTa573Ehpqm	8777	12402	12402	1618171560000	orphaned
17365	3NLkJ4XZitcVWgsgzffjvVvNnATxaqeKoTZF37kAsuSYouzsMpsi	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	1646	1228	294	6301	12463	jxNLqgyg7btbkWTmMwV2iNi7vjjzjDoDqgZhZd4vDP2WHdsy5Pj	8796	12426	12426	1618175880000	orphaned
17369	3NKzTf6cb1eLdsDhtTq9jcWo4wTGCfWshfMcE6zFUYnhv9f5bTSK	17368	3NLuQHqnMD2mBs7C78jwh8XKGXsn7AdCdHKNVzdFYMeL8CLaZXMe	1501	1114	294	6301	12463	jwEwhynBEnxcKLKLdJS4brfamEjMjUvZCzm2F9m4EYHfo1zWYyH	8798	12429	12429	1618176420000	orphaned
17371	3NKNpRpcFtnvHvVh3qMgvmyFZJTBbi6fwBn5AgCrGXkXTSBa38Ep	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1602	1003	294	6301	12463	jwQDgQ6CE1YWrQaA4HdF7nE2MfTAw88BkRnQZ5Eerh1UrBE91ph	8799	12430	12430	1618176600000	orphaned
17378	3NL9o56CQvr5e3kLHy3hr8ZRMhKmr7xnuDPrtMUe2LL6eqgjvg2S	17377	3NKYoXf3ziuFgp6XdwQBMUupE58CHJJ7CroxY1GDXrWBA4N8byhG	1406	1393	294	6301	12463	jxzNUkx2WDv3FJVFHSohxCgDvUvQQAjkhGg6FymandNV1VroJ36	8802	12434	12434	1618177320000	canonical
17382	3NLarSAzc7xytV14meEoTHsnMnJ8migYDmFsnysDChSFfx52Xz2y	17380	3NKEHBZ4ER9Szwe4h3NRbb4vhoNRJwuB5xDMHTkk7Z3qiWzKiv3M	1407	1395	294	6301	12463	jwt6i6BKzPZeV5xPy9XybLSMsh397ZnkwzWhXQRKdcuM9qCQyQx	8804	12439	12439	1618178220000	orphaned
17384	3NLAQAP3mXPT14VWFb4BJzahrpjXxHmJpeJEkCqFP8Z7hYWGsgyN	17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	1422	1337	294	6301	12463	jy1dYBJEn1pK9SpPM35MtKJrZdmmVKmGt8pjCCmae7fTE1ufM6m	8806	12441	12441	1618178580000	canonical
17389	3NLVeGQUJ67cmYwjjfBxE8TGzr2yeakhpxjF7S8u539brpGpfjLi	17387	3NLvR95FfQapTSrPSNQBVvbYYgF8N5VivjBJGqmNaC7EUavLpwWc	1675	1096	294	6301	12463	jwbyBNPtbZhQVoUkVaeKE5RV6Cu28jkh6jeeSb3BbC5SakgVSJc	8808	12446	12446	1618179480000	orphaned
17394	3NLWPHka5kE6pvfpyavMhQ1yFB4TUPsEGwex6QqzYEL6PNQUcupd	17393	3NLueCkr5EF8XSHvoGQmAue3cSxfaUNjbDQhTCBsY45sEcgx9cQS	1419	814	294	6301	12463	jxhEEJP7hFyyxk2oZqnUBuoiuKEwS6kbDuxXnBdaWtaBm6Q5qRQ	8810	12450	12450	1618180200000	orphaned
17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	17396	3NL8YHUtBXCr6SDB2erwE6LLpTTJYmfXZrba7L8LSpNuDHHvJsBW	1397	828	294	6301	12463	jwaPYJmop8JpNu4cDRnwrM6L1NZCr32YFd5c69yzrRburdor7Ro	8812	12454	12454	1618180920000	canonical
17398	3NKcjvSAmia3qWgJ571KxVtd2yvJo4wzfnCbnJURCXKCqrp1SgCy	17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	1490	908	295	6301	12463	jxJDg2GnkPLHbXT1mA51uoxbMB2HtujLCdDJv7Szymtpmcxs5Ra	8813	12457	12457	1618181460000	canonical
17405	3NK8GpJpkR3AJax79uXjyS3ytPDb4hYkcJSZHWc7RK6QMpyZ3aqR	17404	3NLGrp2v4a1z7N4qhMnkGLWaFmgghp2qpbh6mCsKTVgDob3JgrhJ	1426	1364	295	6301	12463	jxsLwMmFdCJePwKDLpxrPC3v1Ksa4951F47ibebHhYTzDnqmNTh	8817	12461	12461	1618182180000	orphaned
17408	3NK7ZvnsgD2fxWLfMu55A7sXHyVxfHN229hCrPwAvR5B116EdC6K	17406	3NLxdAk4FWaGkuc494zyrJXTMa175U9p5D5JTa9nyFfp2EbrCBWS	1407	1395	295	6301	12463	jwfhb4LpAqQ9ULzfS4kFuSdekAtpBZQAoKn3NNM4ggZWvBBCria	8818	12463	12463	1618182540000	orphaned
17410	3NKAgVJNKc5u5ZXMMZTwMahFafDBiuyENTe6dsnmehHdYTSDvyFa	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1444	1135	295	6301	12463	jw8fGyns1Fy7mT8EofGpFRvKDZwUZ5NjMMhD5jCQKBhVoNhPXmQ	8820	12466	12466	1618183080000	orphaned
17415	3NLSmcyAgXG4XHqvXGFAvPENDgbZWkdykUHH6BSTHhbD7hukoTye	17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	1407	1395	295	6301	12463	jxpCByM2Xm5KB4dkjA45mYCwW3hsLfBC2CxZNYQtKExmFQgZFwh	8821	12467	12467	1618183260000	orphaned
17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	17418	3NKHrRX2MK6NKGY8zqedAJXXsDbD6u6YXASenkgTSrenMmq2KFEq	1476	1125	295	6301	12463	jwTtRMjVc2XVVboiL6oxNcbApp8fFJNJkNtLHD5kD476zdo8TEj	8824	12470	12470	1618183800000	canonical
17424	3NL8Y663qSz5cT6eVER99Kz9MaCKQD9eAZoq1RxiBp2GsU7pdKnN	17422	3NKwkwVQYvd2t2fuJqsThhY2HKLrWmaP6gcW2tJ5VXT4TPnmkUA1	1619	1149	295	6301	12463	jxq7FRbbXb4p5qP9Xj1ntS6LvZfL19fDMUduC9VtkVcwwn2oQEd	8826	12473	12473	1618184340000	canonical
17429	3NKTL6jsYo28pJXhfb1GecfDrgBeRv64tykUsoZnmGwqs3MkcE7d	17428	3NLDa6NVRiAscd2HLekpG4Y5F13yPTiBZN217ags8Ay8yMQAo5sc	1467	1010	295	6301	12463	jxnVpC63qytPf4f5BPnnyr4NL3U9mgX8zmpoRT7Rf5wFDBdHU6A	8829	12477	12477	1618185060000	canonical
21846	3NKMC8mVPY3e2RdxRWKGsYX9govqmW43NijPZq7LRBDNEpLPg1iA	21653	3NKgeBUY9SLarVf9vZUwzrdJGwoEvxPV5FbPAP4hvPJyn1DpdsjH	1481	790	388	12463	14013	jwVbBvJiG4smNqxYMNLH5HyP9eb4Vwb44FHkCFiiEpDTTmx7ggE	10675	15396	15396	1618710480000	orphaned
17291	3NLbLhshTsgSDhmnrk8h7zSXRVAQWy3vTTeVHt9baJB1amBRCZee	17289	3NKDgdsMoK3L6JmmRNHgJQsUuNHEKzinm7U7z5Sc7uQRwyzgcNfX	1458	1077	292	6301	12463	jwZXbL3M8CQop9KYFDKozqeys7SvWNspoijAjpWTsz8P6XP2MZR	8758	12375	12375	1618166700000	orphaned
17328	3NK5xpnXiQ6gb4h3fXtArW9vD2sB12wHkrLCQcsSsRLuBnHRRokQ	17297	3NKK9k6N5B1jftbN27n9Kik8MB6KJjFj3fzCNs5En8TuXpzbcBee	606	1169	292	6301	12463	jxhQExArD1fR1Krcogz7wrELCKzEQTkGthoyA8qz5rNkmncJh9g	8762	12403	12403	1618171740000	orphaned
17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	17298	3NLo8TejEXz6NJG92ftzvPF2cwjVcc5UxvXPdS5WCbG2RAftzoRo	484	1073	292	6301	12463	jy2xRo8S7dLraEbmXRwMnTGcZLYHVgqTryZyneXCSYBGrAow7AY	8763	12385	12385	1618168500000	canonical
17307	3NKF1eQ2DFpxcpkvtS75J63PZNLVWib8yQvpyTK9WuuxHL4qv9av	17305	3NKi19coCg43e1Wxhz6aJZEqfa8iRNSurDpXmpBG7UgphJPJ1Sum	1483	1276	292	6301	12463	jxCcqzzTMEAETZoTNbRa8cYwbJocHjzVFA6zHTowEYN9DqFvQ5Z	8767	12391	12391	1618169580000	orphaned
17309	3NLRAuB7jA9cZvE5hyFpX5EYkfgqHctkjdqWdNSjfCw1hjNGkYHE	17308	3NLkm4Q82sCZonxpUS1rwCAA42KfQrFWTCf2KBSzTFQeaZ91Regc	1534	156	292	6301	12463	jwbevHRY24SoatRJYCSD33HsobJmaEajw8xkr9irXBTD6kQB4nJ	8769	12393	12393	1618169940000	canonical
17311	3NLyTGCYnSDVNjDerYKHc9vJHPQgqkaQTW31A9NcXFbAKAYpNWGJ	17309	3NLRAuB7jA9cZvE5hyFpX5EYkfgqHctkjdqWdNSjfCw1hjNGkYHE	1607	1348	292	6301	12463	jxJvm2cP623pSJgswmTdKUTUShtYVSEsUEd4BCBscQLwCyuWxch	8770	12394	12394	1618170120000	canonical
17316	3NKxSNQdCqCER9rnZiFYZfXY4o35kN9yf2cC3rykH7PpJza2majt	17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	44	1325	293	6301	12463	jxXtqD7CmG8F2QvvDtVKDShmDAH7WVgSJ3g2xEmyVPSdjfX9mpm	8772	12396	12396	1618170480000	canonical
17318	3NLD1K3cJE1KzijD2aWfKFtxrq8ixLNHi4prZ57pzcESxf7uqfxF	17317	3NKS7wcY82hAMHwCy6pwpHGvqbohjqU4r8XQFFNPiS492fRDuin8	448	1179	293	6301	12463	jy1Yu6YiPuBxp3dn4qsL6GJBxwhNEuUu1NF1pCAFZaDByXFzUjW	8774	12398	12398	1618170840000	canonical
17323	3NLwSBkvciauZ1hDzbPuLXifZFzzkN9WS845kbfvNCrbgKQ1BGYA	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1406	1393	293	6301	12463	jxTsYmNUtsNofBM5miXiuQ2m4N78EJ23Sgcpmcz8RQ8TvoyC6qx	8777	12402	12402	1618171560000	orphaned
17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	17324	3NKz6joE6ZSd1oLdQoiFrtQVC5DR1oLckV299srpJa8kWt6BU3Ks	606	1169	293	6301	12463	jxnkSmUoNKPcwwRa2iDKdq2buJoct3RPPptswE8X9ppjQzqM6ce	8778	12403	12403	1618171740000	canonical
17330	3NL7gZQRfdQc72XwjJcbUau1M3W9vWcWDxdt67KH77cgxYadenAq	17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	563	993	293	6301	12463	jwjPE7dQGJDELDTVvS5rW5yLJh44yHWTaeiWS6bCWoo2gLcZi7Z	8779	12404	12404	1618171920000	canonical
17329	3NK7UZFYcquZnEdPygdbPzRN3JWmbH1j34Lpu5wbJa4ePc5osNxP	17327	3NL7qN4oe4qGmVwRSgYdMUuEmY6fvNWpU52bzaBYvY4GTznVREzq	1419	814	293	6301	12463	jwRTzF6ujNNMoE6BJhwqqy1KeGxHHSJKNLM8uo66EZscpMVfsNb	8779	12404	12404	1618171920000	orphaned
17332	3NLvFTGtgEXFDg8Emw5vdwaE1CJrbZxqGdxWQns8SGnDERJdF3HC	17330	3NL7gZQRfdQc72XwjJcbUau1M3W9vWcWDxdt67KH77cgxYadenAq	42	1235	293	6301	12463	jxrrvqxYRKnEyR8tyi7hobnLk7b8cgxM1PPeXVyJdGMsxgLY6z8	8780	12406	12406	1618172280000	canonical
17334	3NLn3UHKYZLHTvLrRDGbo3iCHAn4KKyftKNvH6bqvvr6cw1J6esP	17332	3NLvFTGtgEXFDg8Emw5vdwaE1CJrbZxqGdxWQns8SGnDERJdF3HC	171	1008	293	6301	12463	jxSrgD18TAR2Sh2DLR8PrigCmwUTYLwTcGJmsianfDCrEZYddDs	8781	12407	12407	1618172460000	canonical
17339	3NKSpf9LRMxHpEhTvk892ds26Cprbm5RzhWs3CvRGD1yZtMQsJxT	17338	3NK4AQ9S6TCxpoH1voBWYhApQSXpMiFbzYfyH3ykruMhPpoKL2B6	1675	1342	293	6301	12463	jxXc9td5gzTLtpdGFb9MdhXE4co64fsns6AkwRVhhGkhBBPex51	8785	12412	12412	1618173360000	canonical
17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	1581	778	293	6301	12463	jwspEkErrEUKNS28f22npwgqxZCFzuyjtAJcFjX6QMAAN8B1Wef	8788	12415	12415	1618173900000	canonical
17344	3NLEt6vnnCBPxi312aNNjDzSbU9EYPf1WRVF3Le7gfNuUtNAWoAW	17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	596	1180	293	6301	12463	jx2a6JwsGXHAPgpMBFvgbFv3iLrgxAg6mK1nGoEFgbit8aGCFDJ	8788	12415	12415	1618173900000	orphaned
17349	3NLSERchRqwfwPm9vqTxMxuK5j395zo6fokdjW8SZAZyojy1LusW	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	1426	1238	293	6301	12463	jxAt9no9z6QDNkvu7AfwpESK1bmrbJJGcGunWYWUC8mB3txm1Ph	8789	12416	12416	1618174080000	orphaned
17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	17352	3NKDdHgz5vAo8sdHJif9C2hoNxcL74qc3bpEcHHurR7WszVKSwzS	1608	1163	293	6301	12463	jwnfKK5nUSbhkTgB8qwSgrGC3oq4j1aHArnL21nR739R14o2YSi	8792	12419	12419	1618174620000	canonical
17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	1624	1334	293	6301	12463	jxWPvUobLzmvwD4NF9vpQBx4jvYAoBmT2ZTEYZLnpMFuBr4ZUMP	8793	12422	12422	1618175160000	canonical
17358	3NLHogoy6JkNkzoh9VWvaKSLcz6WJm8FG2EtVZqEj4Nhzk5QXj2H	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1457	1391	294	6301	12463	jwBzYGyrCzWdCk9AhRHzwQKq5YJ34gdLibSudQh5EK5Si1rj1i8	8794	12423	12423	1618175340000	orphaned
17361	3NLt9bsvqBxQ9YXGqpeRUFp2pTqioVpPYefwxg52VyUY6aRgF6zo	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1560	1045	294	6301	12463	jx7fxavdtpxrn92SzoZgb9no1sVfBdxJDn5Joh2WHnZbkNyo6iN	8794	12423	12423	1618175340000	orphaned
17366	3NLYbzSVz7TrKepvYgQHaRHknkPScCWEEN4vpuKMdhBb1NXmJ45n	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	684	986	294	6301	12463	jxc2uxHrA3hxbeNL6qwKLjXdVfBrWqxmKPdBLJ1EZUjZNuZfyVr	8796	12426	12426	1618175880000	orphaned
17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	17368	3NLuQHqnMD2mBs7C78jwh8XKGXsn7AdCdHKNVzdFYMeL8CLaZXMe	1402	906	294	6301	12463	jxKthnvebT2moX9dnTiz92qNNvBj3jYpwadvyhVPCemEBmMNkEe	8798	12429	12429	1618176420000	canonical
17372	3NLSHgRAU9kJASj3YxqKQ9A89q4vFUPYMBDrMPHrVhbjMJV2FRnG	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1549	1362	294	6301	12463	jwqzQs7DJ1vEvGYitgqxEuqZTugy7NnfxiD2ucX33cd8d1SzfXv	8799	12430	12430	1618176600000	canonical
17376	3NKAYGSyeqNJKMwsqyaCi4miKtW85ZdTyB1N2Ph1giHFLpx6RgL5	17372	3NLSHgRAU9kJASj3YxqKQ9A89q4vFUPYMBDrMPHrVhbjMJV2FRnG	1403	824	294	6301	12463	jws1xcCWnxwCvArwiMQecgFE46sFadkRtT8p22UCHso4EEtpjZ9	8800	12431	12431	1618176780000	canonical
17379	3NKqHfhByxH5gqMwYD3dmvvwgWhtoMioB2kcrsc3Mk9tb7x5dFCQ	17377	3NKYoXf3ziuFgp6XdwQBMUupE58CHJJ7CroxY1GDXrWBA4N8byhG	1407	1395	294	6301	12463	jxi3D88uMkiXXH6goFFghzngxv7yfrjYrJEvKMPtxDfbkhuaeZ3	8802	12434	12434	1618177320000	orphaned
17385	3NL4o2iALoHcdgnkZkGY8XYyWaUdQmCDVtmFheGvtsnbueT3rb75	17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	1422	1337	294	6301	12463	jx8M7ZbG4PrLzJiPgNb8LFd1T5Pyffqu9xHcWLAiSYdfdZdA4MP	8806	12441	12441	1618178580000	orphaned
17390	3NL2kNKv8PxCNXpJCNXUqsiVFvTCZM4qNVffufrvDyyb6Qr2Rdtp	17387	3NLvR95FfQapTSrPSNQBVvbYYgF8N5VivjBJGqmNaC7EUavLpwWc	1588	1392	294	6301	12463	jxrMHmAAtEp3HdmYYBMhaUWtqAY4NWCMSeqqYZvt7QCkt9ezPib	8808	12446	12446	1618179480000	canonical
21280	3NKHz6AmRQg2gyeuL5YxxNeiVWns9DAh97nJ9FougNznaUZkEWE6	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1451	1292	387	12463	13521	jwe9QSfH3YW5wE4zJ4NyDAsN8W4f69yQnPp8kyACFcYxvHEZAxD	10678	15048	15048	1618647840000	orphaned
17357	3NKHcYPrc7EY3KGLQdMfgiuPYG8gSq6XkEBWyKo5o7PxjAz96Gof	17161	3NK5G89ucYF4rGMEbJYpRXfsEDx2CgJj1TyKGr3FW1B3gnYbQ1bK	1439	1033	289	6301	12463	jwx6wSw7tDyDT4qgZxKzewHhE4yfCpWzK94UiugPhxTqVULAUBp	8698	12423	12423	1618175340000	orphaned
17388	3NL8zHMJAZmubi9WTUkc8hLmXqSphwNjSnzispW23Fpv3F2b8UYz	17314	3NKPv86cKzy8Po2f7cSjbe4ijae6jnkua8D7sQmLifxEGBDjEdX9	1588	1392	293	6301	12463	jwVkZSr6bh6x5ZX6SxcXSoVJHEoAJMm9TAc3jTntCcphVePe7Rm	8772	12446	12446	1618179480000	orphaned
17337	3NLvrMRW36hYyWGisCKHABLGiZe5mqMcowy4kGBqyhV4HHPrAqdn	17336	3NKsby7qhrxsJXHpsn3GMGCgsaVa1KSXMT5k6Yg2N5a7z622uvNg	1407	1395	293	6301	12463	jxdTg1xuM3fGdLvNLE9PHDTy5XtjHNeJVX8yjocrz5aHdhWQnoG	8783	12410	12410	1618173000000	canonical
17340	3NKCkRhofLoyuvWeuwUjK2zrcvTu7YNCdfvTHjT1wLSBZ6mMmyVB	17338	3NK4AQ9S6TCxpoH1voBWYhApQSXpMiFbzYfyH3ykruMhPpoKL2B6	1581	778	293	6301	12463	jxXh1CzWoTC4iJ6LtwVgF2MvFh7o3UVhAh7QnZJE1MowGp8At24	8785	12412	12412	1618173360000	orphaned
17342	3NLfJgMKLnaUvrPJZtx1sZNCMsUnEUgknPTALVxgubmKfEDxqrNt	17341	3NKHqMJMpWomnWHcQPfD2NchSYg2fgBPVe6rBJSQUdTys6gWPFLU	1593	1100	293	6301	12463	jwjRV1Geh1kkqibWWiA1iSJzm39Nt7xPPy9gc5VL7MmvxofCaDD	8787	12414	12414	1618173720000	orphaned
17345	3NKn2oknkaA3M1Dk2rdqzseCtrGCgUMYh96MTpXXaAoP39wLgWe3	17343	3NLVWH9yjYGUqqExgzbWNtKopwyHWcY2ByLLQckMbR8ASQHZhEui	1403	40	293	6301	12463	jwxGyS9XNnN98gGzTDT7fpFx9Zeju8Uu5taKU1X3SPBcU94yNA9	8788	12415	12415	1618173900000	orphaned
17347	3NKFqz2knmTDtnF49p1szgoUthPgj7g3r8TpQJ1qAvxn7NCZK4Mz	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	633	1384	293	6301	12463	jwL6sKrwHcZWCWiMFVS7Tco1z8NH3JBaaRS6vmAi6VjQt96gPno	8789	12416	12416	1618174080000	canonical
17350	3NKEyEyv1fVSx3KX3ig47XEDKyf9CxcUYZB83Szi7yrh3vFNC5y9	17346	3NLBwwyHSEWXppN9JUF7JhscW4ML3cGuPLMnC4TiEuEwQWdxjMfu	633	1384	293	6301	12463	jy315BuvRNgWPNFjK3msWSdfVF3HgU146ix4QCKBxX5pgH5jdek	8789	12416	12416	1618174080000	orphaned
17354	3NLiWJkUzm6spXkRFMjLrDLYgf172r6h6woE7csQE8eft3MqKbRS	17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	1624	1334	293	6301	12463	jxWPvUobLzmvwD4NF9vpQBx4jvYAoBmT2ZTEYZLnpMFuBr4ZUMP	8793	12422	12422	1618175160000	orphaned
17359	3NKzZTyea7ETPRapnucjju8pQDp56Redfprorn2pjKJWfqiUUPcW	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1560	1045	294	6301	12463	jx7fxavdtpxrn92SzoZgb9no1sVfBdxJDn5Joh2WHnZbkNyo6iN	8794	12423	12423	1618175340000	orphaned
17362	3NLVxv3ao78RSNJZiZx5VJE4uQyYQXDPyJjpVHAaWB6d8qp6mf9e	17356	3NKRX6esXGM1h62t3sXJ1q3dvUaKMdASmr3v18VWRSB6oTmFLSKF	1560	1045	294	6301	12463	jx7fxavdtpxrn92SzoZgb9no1sVfBdxJDn5Joh2WHnZbkNyo6iN	8794	12423	12423	1618175340000	orphaned
17367	3NLaMWHu38wNhTEVGK2A1Ecw9zsWCLHbqMnGovkuvbbmE1pMqcnW	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	1448	1065	294	6301	12463	jxbR1wGeGxzYiqxyuCLo3dbFKyar9ipwV6BcZLc6KHriLqAv2jP	8796	12426	12426	1618175880000	canonical
17364	3NKxpx4BDNxK4tToY7XyNSyq6HgMRtMUhMERZtbpnYQxEdr1sYZH	17363	3NK7WDRZWoBsX9LZdbLTvru1jPhRPXr88hPgXGnf7mx67AyMEYhC	1448	1065	294	6301	12463	jxDoBqac89wxRy1YgEbGtv5y2PtkU1BRaLjcWBRrhYJZtEFHHLG	8796	12426	12426	1618175880000	orphaned
17368	3NLuQHqnMD2mBs7C78jwh8XKGXsn7AdCdHKNVzdFYMeL8CLaZXMe	17367	3NLaMWHu38wNhTEVGK2A1Ecw9zsWCLHbqMnGovkuvbbmE1pMqcnW	1587	1357	294	6301	12463	jwi7pbBsKHt3Xb2vQSprzGWN1PxEaj8iP4KxJmdP1aWDsV36C87	8797	12428	12428	1618176240000	canonical
17373	3NLcy11URd1HfNpBF2JvxR27jFKbjij5RMJdShsFEswZxv4RqCGg	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1406	1393	294	6301	12463	jxzFKxUbe7o4pprba2kEExEK77adGi57XqRnnW9F4SwgGEPy27F	8799	12430	12430	1618176600000	orphaned
17374	3NLrpQu9vwyhx1t1VBmiRdUVZq9rosgU8hMoAbqjwafN3hBoyebK	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1407	1395	294	6301	12463	jxLWQa92EBakdWDWauKarLARDvGtddUMvYCuTn28x8sAwJE8u7L	8799	12430	12430	1618176600000	orphaned
17377	3NKYoXf3ziuFgp6XdwQBMUupE58CHJJ7CroxY1GDXrWBA4N8byhG	17376	3NKAYGSyeqNJKMwsqyaCi4miKtW85ZdTyB1N2Ph1giHFLpx6RgL5	1656	1217	294	6301	12463	jwjCrLN9kNDj8VemsBjh85npBpuhN8N5Jcv5U75AM49T51TJE4T	8801	12432	12432	1618176960000	canonical
17380	3NKEHBZ4ER9Szwe4h3NRbb4vhoNRJwuB5xDMHTkk7Z3qiWzKiv3M	17378	3NL9o56CQvr5e3kLHy3hr8ZRMhKmr7xnuDPrtMUe2LL6eqgjvg2S	1483	894	294	6301	12463	jwitYstDtutHBwuF3p7iXqX8wkCvNQGNFLpwdCuKG4TTb4PzPcB	8803	12437	12437	1618177860000	canonical
17381	3NKz8V83wFM6ELha9aGHcpYcFtGFWFR1cBqoZSHy9p81dDvbx73j	17380	3NKEHBZ4ER9Szwe4h3NRbb4vhoNRJwuB5xDMHTkk7Z3qiWzKiv3M	1406	1393	294	6301	12463	jxQ14hDYoNKLbzb638DqYq5TEZnq8KhrdTJCqNWoXYWjaCWG6DT	8804	12439	12439	1618178220000	canonical
17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	17381	3NKz8V83wFM6ELha9aGHcpYcFtGFWFR1cBqoZSHy9p81dDvbx73j	1467	1130	294	6301	12463	jwePSJvQjqAVXe2CaamVTM7F3BPc9Bqc1yU1PGFGjcAFAw6rLqr	8805	12440	12440	1618178400000	canonical
17386	3NLRXFn2jtDB95hHowoT3YTbTyJdpzgbvjRdkToPUsdFMdCXM61k	17383	3NLUUZF2zJnNQfifKWUJGQKkhrA4mBas7pCUXNuRnQLNrbx2iN5g	1406	1393	294	6301	12463	jx1C9BxA7yGXjDZs32yrDdnp4d92BhR7RAxuvuYzF53xgnAf5PU	8806	12441	12441	1618178580000	orphaned
17387	3NLvR95FfQapTSrPSNQBVvbYYgF8N5VivjBJGqmNaC7EUavLpwWc	17384	3NLAQAP3mXPT14VWFb4BJzahrpjXxHmJpeJEkCqFP8Z7hYWGsgyN	1600	1126	294	6301	12463	jxTXBPdQnNxoYGRbnstgJsAAX1v5kzEJ1qdS8dAo73WLorQbZ7t	8807	12442	12442	1618178760000	canonical
17393	3NLueCkr5EF8XSHvoGQmAue3cSxfaUNjbDQhTCBsY45sEcgx9cQS	17390	3NL2kNKv8PxCNXpJCNXUqsiVFvTCZM4qNVffufrvDyyb6Qr2Rdtp	470	1309	294	6301	12463	jx2u8W1NxJMkPLJLuqqS6JXoPT63TBeBicmRuoJB4ojqaUM79HE	8809	12448	12448	1618179840000	canonical
17396	3NL8YHUtBXCr6SDB2erwE6LLpTTJYmfXZrba7L8LSpNuDHHvJsBW	17395	3NKcwN22kT17XRVXJwWtTunsKF47g9UJvK6r9jnZxJp929pwnKcC	1407	1395	294	6301	12463	jwNwVoYwzJhKisBWNYiVzJL1A6rSXT1uvMyDS7mT2gXTLaWP3VJ	8811	12451	12451	1618180380000	canonical
17400	3NL2bRvtsuTQq9C5EaXPGgzb1mZux4RucT1pAVNMew1fD1WXtPpM	17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	1490	908	295	6301	12463	jxJDg2GnkPLHbXT1mA51uoxbMB2HtujLCdDJv7Szymtpmcxs5Ra	8813	12457	12457	1618181460000	orphaned
17402	3NLknMnNAWB4F3zudmNSzNUj9uErYrBS76eJaz3w11q5Cx4aUoPN	17398	3NKcjvSAmia3qWgJ571KxVtd2yvJo4wzfnCbnJURCXKCqrp1SgCy	1406	1393	295	6301	12463	jxu6kA5o7EeJaD3zKwGFaXQaQpbLRKt3KzfRgQW9ZKR7SSzid23	8814	12458	12458	1618181640000	canonical
17401	3NLQy9CMXu4h8DXXKSJ7ob3XJuM5Qcj91LQJ1yH1TX9yDARuMF8m	17398	3NKcjvSAmia3qWgJ571KxVtd2yvJo4wzfnCbnJURCXKCqrp1SgCy	1672	1285	295	6301	12463	jwwWWKTWxGPX89C9PFb3cmo3ZrNstiKCnPDGC5U9WYzFH9qQ6RV	8814	12458	12458	1618181640000	orphaned
17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	17407	3NLgoW9xaxisgYRGAajYjLB562evDxfGLaNedxVuPgxJseGzMSDk	1471	1260	295	6301	12463	jx1hZquthKb1QHmzbk9qy8ysZBY1HxUxS6whvjay1ZZkVi4spLo	8819	12465	12465	1618182900000	canonical
17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1457	1145	295	6301	12463	jwYjSBaGeHfHX4nyz3SeqymGgv11wRkPjsGe2dL3zeN5EvBmvsc	8820	12466	12466	1618183080000	canonical
21267	3NL8aLaThcASht54XjXZMKEGGNGiRRwJjRNXYHPSsYNBAiwQa2xD	21263	3NL98NgwUtYDEb7BEkhEMJG77M6xXtLujmK15ZXEhCncx6Xm2WFp	1476	1371	387	12463	13509	jx6NPmh139nDcabvd3dJtbsgXmS5ge2Nk5xJVhgeVsfvEJX9QFj	10679	15039	15039	1618646220000	orphaned
22322	3NKZkqGPjpXw7EF88d67QzrevY6kP5W5VFcosgZPMB4FX2Fz2kev	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1610	1068	413	12463	14442	jwabDdyTKH42mUsSBeiCQfXrQLTV63QsPoxSFGakXscjncW7Vdn	11174	15733	15733	1618771140000	orphaned
17432	3NKFrcKe7JvyTn9CozVz8xSubsgz9aAffy1GVu6c5C3HdxCXu1Zz	17304	3NL5n9Z4cT3e5Gczp2nkZ3fFeiP9wce69TAwZahyhddY1hGH87TW	1671	1239	292	6301	12463	jxUgRf3ycNe7SJ8NUAvm4PtB9NfMSn7Nttm4bZKbmGkJJtSyx7K	8766	12478	12478	1618185240000	orphaned
17392	3NL77pvKDLk4AvbPoeXYoWjWGFksapqgVP7ZRs9hvSwkiWmM9SmK	17390	3NL2kNKv8PxCNXpJCNXUqsiVFvTCZM4qNVffufrvDyyb6Qr2Rdtp	470	1309	294	6301	12463	jwMeUobc4QbMokdPvJQTiLXx7oTbVyNKydNbdrnjCYXyWVLu2qm	8809	12448	12448	1618179840000	orphaned
17395	3NKcwN22kT17XRVXJwWtTunsKF47g9UJvK6r9jnZxJp929pwnKcC	17393	3NLueCkr5EF8XSHvoGQmAue3cSxfaUNjbDQhTCBsY45sEcgx9cQS	1407	1395	294	6301	12463	jxCmYox8Q72MSaJkYWknUbzgM6BAnrdjfDQBcpRhBqpU2PVpVz2	8810	12450	12450	1618180200000	canonical
17399	3NK91MsuVqJ1T5xh4FDmkVnsXcoxS3GxkcsYJadVGj3G6CdNRWzG	17397	3NKRd6sCob4L6smeyqWR5eXLUsuc3jV46NrRoqHST1jUExtZrGBW	1490	908	295	6301	12463	jxUUcKuaDMVCLqwueoHNUjp2GHSyh2WzNNbwAhgpYmBbDUy1rNB	8813	12457	12457	1618181460000	orphaned
17403	3NK8UwYd9Xy5StVtMiiK4uX3PjAZWrzUPct7bxUn4gk8bBQcbprp	17402	3NLknMnNAWB4F3zudmNSzNUj9uErYrBS76eJaz3w11q5Cx4aUoPN	1407	1395	295	6301	12463	jwFhEBpex1p6viK1aLwJBNMqtcsoEZTpaPcoSK6XJY7yEPDwFqW	8815	12459	12459	1618181820000	canonical
17406	3NLxdAk4FWaGkuc494zyrJXTMa175U9p5D5JTa9nyFfp2EbrCBWS	17404	3NLGrp2v4a1z7N4qhMnkGLWaFmgghp2qpbh6mCsKTVgDob3JgrhJ	1637	816	295	6301	12463	jwk7TGz53t5iZJLpEeiLL34x1SbdrVhLdaqHUM2nfF8sEtxxtbF	8817	12461	12461	1618182180000	canonical
17411	3NLLNNTvucugAg2dv9WhsPeM8JJwbmjVTQoPx35sP4gb5S1woEXV	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1439	1279	295	6301	12463	jxWhC518ZaNmZSH6RKqUfyer5WkMaVgVuAKvRdWHkEr8Zw4iYBN	8820	12466	12466	1618183080000	orphaned
17416	3NKUdHb7S3524faUrqRgvYaGvwHKvhLuminPvxbD1LJMD1ewKKxA	17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	498	498	295	6301	12463	jwZ2pAg2MB8Rh3jJiRBScDauUp1N6EjPLMLhqx3A5LJuLRS85cy	8821	12467	12467	1618183260000	canonical
17418	3NKHrRX2MK6NKGY8zqedAJXXsDbD6u6YXASenkgTSrenMmq2KFEq	17417	3NKTKtekbJfG6PZHa6phwXYtw2uJ1mms6Pr5DqfEVLtisXSEiHSd	1616	116	295	6301	12463	jwMAodGUyFhaEcC1a5JQJo5kcVbmKscEFPqFHT7Umhxa6iAv4bX	8823	12469	12469	1618183620000	canonical
17420	3NKhtJSKuaiKxNWuc5rC1iB7D9Z6ZW4Kht8LL3jmYhHsjk7reUL2	17418	3NKHrRX2MK6NKGY8zqedAJXXsDbD6u6YXASenkgTSrenMmq2KFEq	1559	1353	295	6301	12463	jxz5xqzT5rFEd2RtPyyT4522NC9F3nyFNRiBcHbm8FzQSNoYoDj	8824	12470	12470	1618183800000	orphaned
17422	3NKwkwVQYvd2t2fuJqsThhY2HKLrWmaP6gcW2tJ5VXT4TPnmkUA1	17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	1541	1052	295	6301	12463	jw9LLsnXxTkajZZHGgVQ8xbSvGMWqG5pzzvPX8N5DLyajZVmqFU	8825	12472	12472	1618184160000	canonical
17423	3NLE28Dp3N7x8HxRFbAnXXfVDQ9pqyvz8EDoorMjkuXGqa4avaiz	17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	1541	1052	295	6301	12463	jxxAEYBqNHkLrvnNXYWNeFVxaD9YDQx23icLMuovTJbkJ8FzMcU	8825	12472	12472	1618184160000	orphaned
17425	3NKsGYKEKZz8vodqq2oTJajbhWkCxtke71dD3BxdB1gzvdsC6zaS	17422	3NKwkwVQYvd2t2fuJqsThhY2HKLrWmaP6gcW2tJ5VXT4TPnmkUA1	1508	1387	295	6301	12463	jwyqsLK8NoXYqGo6dXB1yHfXJuBCn4RUs2ipLFBaQvFRR5jAv3o	8826	12473	12473	1618184340000	orphaned
17428	3NLDa6NVRiAscd2HLekpG4Y5F13yPTiBZN217ags8Ay8yMQAo5sc	17426	3NLgRUszBFih2nChtjJbrHyziGHiGFHyv73z6uuna9ASHRUEpkKB	1507	914	295	6301	12463	jxXEHbow7trgE7E2zvSio3iXRwcgsuuhXB4hVC3hejkH2bq7n3Q	8828	12476	12476	1618184880000	canonical
17427	3NLSNd5nCQCMnEQ74VR4sxPFDL5YMMvwap21e3Q2dtv2nnw7XpFr	17426	3NLgRUszBFih2nChtjJbrHyziGHiGFHyv73z6uuna9ASHRUEpkKB	1622	1356	295	6301	12463	jy3263Tgm7Ktso3vypbmin3vxFTByRNVMRfFghBbKH1NfFGikhe	8828	12476	12476	1618184880000	orphaned
17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	17429	3NKTL6jsYo28pJXhfb1GecfDrgBeRv64tykUsoZnmGwqs3MkcE7d	1610	1068	295	6301	12463	jwDxrC6Z7wGMEXfttVAaXPimRkJzRBWEHLCDRJXt7XmJY4a268F	8830	12478	12478	1618185240000	canonical
17433	3NLUBYyeeF5gP49vkyoXvLJ9T19NQwkvKE215qmCcSbXxibHsVnJ	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1549	1116	295	6301	12463	jwMH1DmEqnCM7CV6ckvrFcWbddYWskMrB9qC6WEfENB4NrZLKs2	8831	12479	12479	1618185420000	orphaned
17447	3NLk1VDoimPP8sGfQoxu7yVzg1KPRFj71pXbrkyePPeub8xD5QbH	17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	1553	776	296	6301	12463	jwzXk5cChHcEA8Hx5DMnbtWPYQ2M1Kjh3hzdAxAQ9JUeVyntRh6	8835	12485	12485	1618186500000	orphaned
17448	3NKNVq5VWE9KpFqqWxeZ5pQgEnTbGXGtzhUwnBuTNYpNmMm19jkE	17446	3NKUPDAJje58cNHod1AffyvnFUTiTJc3GgfsR2NHmz6W2NSqvAsz	1534	371	296	6301	12463	jx6WNWu9fxocvhEZ3kQNSpeWZ2i4u57Houg9b6rNQA7W62ndvGn	8836	12486	12486	1618186680000	canonical
17453	3NKPWsR36WybvQGZr1nJ2iYkLzwbPVCejfoMNiyXv61QKiwj5sDR	17452	3NKmZyy5p4yikHZNc35uW9YCkjCvWt79mkgfQCe3kALA8QDf4wvX	1546	1093	296	6301	12463	jxtQ3zrxWAbXpAgutRmm69xnvbMUvzN2VpEYAyaBLBVzaK7yj7X	8839	12490	12490	1618187400000	canonical
17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	1494	668	296	6301	12463	jxAoevXjGdDiraHu5zP4i4zMNckt6ai6es9BuXNyh4cxVYNZK1e	8841	12493	12493	1618187940000	canonical
17461	3NKg81EVCFUhX9SPqujXYubsr1E656njmARn2oJpauhtqUpPHn1e	17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	1406	1393	296	6301	12463	jwtivSHiTNV5APnQSZsY26E4e4MkMFNZLL5EwvfoMg3xFyvUkNS	8843	12496	12496	1618188480000	orphaned
17468	3NL9xs4NgKxDtQAXD9oUkMUejQG8QWgw7T38NRcLYPapRxPZqyht	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1471	1386	296	6301	12463	jwpHG54jjoXttqKb9DjzGhCiQvpgtbSETxAWDWq7UmqWG39Trxm	8845	12500	12500	1618189200000	orphaned
17475	3NKhmBYvDXRx4eePk499fq13frLFZHWjhCz2F7RAUx1EN7e42LAf	17472	3NKeWYjHqX8FtuFSsgLPoHavStdkfmvSWUHfhwBdTLysFtKvtKuK	1407	1395	297	6301	12463	jxn9UphYDvcHttFWtfsnKaUPjgsRA7bXGQJkSYcuuibbB5xFwe1	8847	12502	12502	1618189560000	canonical
17478	3NLLc8DMeAc7nCfgXzDyLkc35oVNMFjoYPyNtRQvneiSDu124b8B	17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	1397	838	297	6301	12463	jxt7CkXGTguEK6zZMqoc3Bby9gDEu8Gmb6ybZM2xjsK1iiznNYT	8850	12506	12506	1618190280000	orphaned
17488	3NKPK38tgUL4Lg9s1jWqxdBpwRpN9tFfuWu68313CcibzYbyMrXR	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1647	1302	297	6301	12463	jxu2EFTsgSZbQGuihaodN3TY8dbdW4RJANEg4e5H9wSCeaFABkV	8852	12508	12508	1618190640000	canonical
17486	3NLqW45pqFgNEQ21ypCfPk7QEw3HF2Tu3TYXwzQDZ1WJGDWC5iXh	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1523	1075	297	6301	12463	jxEDsoTFSSV4kduhkF5jpayX2HQhK4UDw2PFZNCGN5vTkGsLSw9	8852	12508	12508	1618190640000	orphaned
17492	3NLnQciDZ2rqVZdyEidz9UWEtmSp7yJMzMYib89Dj8hRk7rBRftP	17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	1407	1395	297	6301	12463	jwbXiiauzfesudRCYZAfixFBBqxZ4pL9ow7rwyLPkzj5he3pcbU	8854	12510	12510	1618191000000	canonical
21298	3NLX34i7oRQEw8MAhdZX4FDpqFoGz5uqV2abwJjBMhjKPT5qhLFK	21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	1406	1393	388	12463	13539	jxrfMJ9KHFvRNvLsN151nGEYCaWZcZALJ95GjuJV4bX2EEit6Qr	10694	15061	15061	1618650180000	orphaned
22327	3NKEkeBNnS7MSFz7YsreAsQHSnc31hpqL5LTpLNq2Vo2DTdudWnh	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1401	4	413	12463	14445	jxsW6dD2qMB4dqwH5xN5Cg7dH6Mvp4K8t9eWTkfDxTdvv9o2Bym	11174	15733	15733	1618771140000	orphaned
22576	3NLAGrjkbBUYsFb2V7NaxLikbZUGULj1YMN1TagWUhUnESRFPVa7	22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	1596	1363	420	12463	14670	jwH1WuiB39eWqhgD9mWW9yhxyzaHj5bt65CV3dUaxp6QnYoYSkm	11293	15899	15899	1618801020000	orphaned
17407	3NLgoW9xaxisgYRGAajYjLB562evDxfGLaNedxVuPgxJseGzMSDk	17406	3NLxdAk4FWaGkuc494zyrJXTMa175U9p5D5JTa9nyFfp2EbrCBWS	1419	814	295	6301	12463	jwnKHPVp4CsUhWvn3AfnhvWY3i58ghEnhVNRAJBPHytMYcewcDW	8818	12463	12463	1618182540000	canonical
17413	3NLQwepJC8mHmusacN6VJKQe5qoN6wrjZ26AThEV4M6bbr3WoFa7	17409	3NL6Ud23nQHLPbXbD6nN3VdLmbMDDdpMVuKK1E3o3gPf6qLt8J2M	1406	1393	295	6301	12463	jx8DZLTsDasp5ybihv3tq7n43opHGfSD2ix3b3q4C5koYcYnVZg	8820	12466	12466	1618183080000	orphaned
17414	3NKwYaw4S7ktgo6taQkLuQ6kAkK8CxS6RfCURKe5dxC3XZiWb3k6	17412	3NKvcpVKqc4NPkiDLVwLfAproKud2Cf7wbANTGnKf3tFtoRGqsoS	532	937	295	6301	12463	jxx7oCSMxg3N6QSPdhjiyz8GdzQiDj7xurreZGAqEo2ntYaU1oa	8821	12467	12467	1618183260000	orphaned
17421	3NL5pv7Y4z4WAstsRkJT4UL69GaDxSw5izLXbXCQf3STuAt42wZk	17419	3NL7DuuFnQj5dp2JEMNYBq4BpQKn3XZrozMqghtG27FbQndxWtdd	1668	1124	295	6301	12463	jxe24qJRcXeGsc32bbwDYKqJB4WYKhj7wtLKbztafD2Fcb2mQf9	8825	12472	12472	1618184160000	orphaned
17426	3NLgRUszBFih2nChtjJbrHyziGHiGFHyv73z6uuna9ASHRUEpkKB	17424	3NL8Y663qSz5cT6eVER99Kz9MaCKQD9eAZoq1RxiBp2GsU7pdKnN	1489	1134	295	6301	12463	jxraPPeLBzP3JzFRwFtqrNYAbxfqA1K7zsyWRY1udz6sfMxk3qe	8827	12475	12475	1618184700000	canonical
17431	3NLRR86TtRbLkaVSVMXMJ99MxnRWDZwscbUMdGSa71hYKPeyu29M	17429	3NKTL6jsYo28pJXhfb1GecfDrgBeRv64tykUsoZnmGwqs3MkcE7d	1671	1239	295	6301	12463	jxGvh8qEUKfuiG21G68HiJxRyrvBKTDcvy4jDGwLpWcPbsHvebz	8830	12478	12478	1618185240000	orphaned
17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	17434	3NKjPjrcuUZvDtd57hfqXTbJdiNDXXQ2hVGy3T2cyrGqFUVX2dSc	1656	1343	295	6301	12463	jxixiBZ2XMa6ha9Y2NCqkGzU5xGL7143Wtx8jSzqxtCPfbzYffV	8832	12480	12480	1618185600000	canonical
17437	3NLEo3YM4MuE5EZy94ghJVcQvbLCDEacVjy2n3tuY7pVMoFnW468	17434	3NKjPjrcuUZvDtd57hfqXTbJdiNDXXQ2hVGy3T2cyrGqFUVX2dSc	1407	1395	295	6301	12463	jwBhCtmTroduFfyi3euVm5Pp5FiYfgcHmQnhc898zoFsDNTrksM	8832	12480	12480	1618185600000	orphaned
17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	17441	3NK9uTKhaVV2XnKZ3PDjMq8cX23gRoidBcC8N9163aTiEu9JbwM5	1637	816	296	6301	12463	jxng3ungcTtYffSvEFnhQxvcoXEpKwv4XkuD38iUVxhPtwHRmT8	8834	12483	12483	1618186140000	canonical
17446	3NKUPDAJje58cNHod1AffyvnFUTiTJc3GgfsR2NHmz6W2NSqvAsz	17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	1407	1395	296	6301	12463	jwrjuisx1dLBuzqokeUAnV2BeqXExtkTywfpowcgrQWCEQ4t7nr	8835	12485	12485	1618186500000	canonical
17445	3NLwiHgWghNn6ZR5XECqfXXyP9fFVjMthDCxCnLzEWrKrULToHxY	17444	3NKRBcY51hZHXB6dL4vKPvTW6rjPBSr5QBgPW6AAMWrvFJDmqp1u	1637	816	296	6301	12463	jxS5koRa371JtQZiazjau2b8WQEhW9zuf8MLZbDhHjjV8dkCGBQ	8835	12485	12485	1618186500000	orphaned
17450	3NLoWUrHAyfNvfx9pfh8DRMvo77nsTK6ARDX8SEGRvQYw5v2mCUT	17448	3NKNVq5VWE9KpFqqWxeZ5pQgEnTbGXGtzhUwnBuTNYpNmMm19jkE	632	1256	296	6301	12463	jwnan61JmsRAekuUysdc21VmQwewMfXZ5WaRFkBomv1ELTEkVzS	8837	12488	12488	1618187040000	canonical
17452	3NKmZyy5p4yikHZNc35uW9YCkjCvWt79mkgfQCe3kALA8QDf4wvX	17450	3NLoWUrHAyfNvfx9pfh8DRMvo77nsTK6ARDX8SEGRvQYw5v2mCUT	1593	1100	296	6301	12463	jwiDDMBzX3JxULFv4GuQfkALUk8z74eYjPMk5Zxi7bGkGx9VdaW	8838	12489	12489	1618187220000	canonical
17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	17453	3NKPWsR36WybvQGZr1nJ2iYkLzwbPVCejfoMNiyXv61QKiwj5sDR	1476	1371	296	6301	12463	jy128kqMM8S3nqCaGvEvBPKbMyoJ7jRwMfprjrhGaPxAuQBhyMb	8840	12491	12491	1618187580000	canonical
17458	3NLZ41siZyUeaZhrNBbSEUbzcX4AYzzVYZKR71D88NQ4YbrZN4d7	17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	1405	873	296	6301	12463	jxxiffXjZgyYJxtNFn7ZpgV8QGeDSQV9fuQyPukcQWuDNq4j7qU	8841	12495	12495	1618188300000	orphaned
17463	3NLSmpWXzy4vmRc11FcnC1yTDXH1McKPdHE1BqbHmhMNXRrPXifs	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1503	1277	296	6301	12463	jwjzpTaXgiyu91D27uD6VUwGvn3xE9wee5RLSNKVwLK24RsjmcE	8842	12496	12496	1618188480000	orphaned
17471	3NLBVE54eZ1guxy2jB4a1KxDG3GSAcQUxZ1nYyet22vgBZ15MBGW	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1594	960	296	6301	12463	jxibe1hmJ54Aw8BDzzPh2eCh7oyK7NUm1WQA9X7c9ckTfa68e2S	8842	12501	12501	1618189441204	orphaned
17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	1503	1277	296	6301	12463	jxsvfPZgz7abE9yPLGZT5dvidpC9wVm5NcwfHFLWuATYm2N7m5u	8843	12496	12496	1618188480000	canonical
17464	3NKBef5dq4zqFi4eRvA7JxQZGxUhtXErEWonRVyZgUGHErJ6m9vJ	17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	1652	949	296	6301	12463	jxu4kihFdwKBFKj6U8CUNyqR7TKpkLWn34oXNXUXh8q2fhoUz1o	8844	12498	12498	1618188840000	orphaned
17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	17476	3NLdS7sdTkGoqRv5NnvRmQ8S1Xkvekzokd1KLupxGDd9JfmHPPiW	1405	865	297	6301	12463	jwaLWoJwcVomWD5YqELZRynKf3HLYEHhntAfSdHiKV2PkeMqCb1	8849	12505	12505	1618190100000	canonical
17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	1523	1075	297	6301	12463	jxLpfdXQc2rcY1pjtXi2qApCG6DzrTKbK96dt2eGyG5pPh7o9BM	8851	12507	12507	1618190460000	canonical
17484	3NLMCG2qUB8QwqKeRSrRRtyrePASeFRUjKeCxS9ShxzPR7YoSADr	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1523	1075	297	6301	12463	jxxh4g6u8XGEvBthogPqEjFfTEPhazFcffwdcZ1LfjYcttND6g1	8852	12508	12508	1618190640000	orphaned
17491	3NLXEXVMfneqhhkxU4ozFzSguUmpcD4w2e7he5j4zfmpA5Eqe6uu	17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	1647	1056	297	6301	12463	jwCUhirSMYPUDxwBzopwnqVRUxSkdKHbFPM5x1dK4uudgHji5pd	8854	12510	12510	1618191000000	orphaned
17493	3NLbsLAVeSTkNPM3V6wZTYhi3RjiJJR5hq2rBYbHFudff6vurJLd	17492	3NLnQciDZ2rqVZdyEidz9UWEtmSp7yJMzMYib89Dj8hRk7rBRftP	58	915	297	6301	12463	jxw8SKWiW7rn3KyEjsNXZmckq5ytnBLzws9U8b2RtmtzTx9NARy	8855	12511	12511	1618191180000	canonical
17495	3NL8uzRT7ApjNioT9Nj1dN8s2GHmPLGLMD3QxmnZv8vS6F64V1Re	17493	3NLbsLAVeSTkNPM3V6wZTYhi3RjiJJR5hq2rBYbHFudff6vurJLd	1631	794	297	6301	12463	jxDGUZ25zYNQEV2SFFviaMMDXRxyy1nWvPFNBxrFs9KWvv6HHU9	8856	12512	12512	1618191360000	canonical
17498	3NKbh77zQfcoyctoeEA1o5uGNNLYJxrifaCPrs1WTYgPBY8s4EVk	17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	1589	920	297	6301	12463	jxHg7ENjCU4BHH2WGEWNhcet2C7NP2CmigdDueCJCaViEyqqbfk	8859	12515	12515	1618191900000	canonical
17506	3NKJGjT9xGd3FhahHgDGYo4Wussz3ip9aivTHjJtfyoRzehbgWH9	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	1650	1375	298	6301	12463	jxqPrNMtDaFvPZznohZAsDpiWwq4GxXTDPyKCw6DwWkBQc8cbN4	8863	12520	12520	1618192800000	orphaned
21308	3NLHzSkLQhhuAgGfFHG6orASxhmkhRCWRwJc5X9BUAHzByj7wkWr	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1489	1254	388	12463	13546	jwyDyUhPRYUqAgvLTbjTLZ5W5sfdTrxUW2ULLbedftWw6WSzxH9	10697	15064	15064	1618650720000	orphaned
17434	3NKjPjrcuUZvDtd57hfqXTbJdiNDXXQ2hVGy3T2cyrGqFUVX2dSc	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1490	1274	295	6301	12463	jwoicb4ibCpd1kvF1hbwUEhjdp7ADcJTVTQ7QzMCArzZsi3JH74	8831	12479	12479	1618185420000	canonical
17441	3NK9uTKhaVV2XnKZ3PDjMq8cX23gRoidBcC8N9163aTiEu9JbwM5	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1581	778	295	6301	12463	jwmfYfU1FdiAfugybsf6uJmzCEV9Xdw48yddbhxNmXxt8PWtVk5	8833	12482	12482	1618185960000	canonical
17438	3NLf63UmvxiE4zPWFCBxMAynYjveRcSi8SJrj16Gt2akox2NruLL	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1402	870	295	6301	12463	jwmqQeeM2RfPiBNTdYFUvXwenP97AJao3aJJZqoUn7ubxEAmuo2	8833	12482	12482	1618185960000	orphaned
17449	3NKRwCesRQtMVwEsu5Mk6ftHvnBThqMetGWqAHPiE16pY3Pw5pjE	17446	3NKUPDAJje58cNHod1AffyvnFUTiTJc3GgfsR2NHmz6W2NSqvAsz	1637	816	296	6301	12463	jxmNSYw4pXVD7x87CVWNHDiGdiPJF5Ai8vd4QEdQf23KB6PTH3L	8836	12486	12486	1618186680000	orphaned
17454	3NL9BL9oSD8Zp1pBEfDr5KiE4WwBqWBv9qk5U9cndc3UWqHoJiEA	17452	3NKmZyy5p4yikHZNc35uW9YCkjCvWt79mkgfQCe3kALA8QDf4wvX	1445	1164	296	6301	12463	jxMAXXo4eumr4YkM6s7iWW5bp9B4L6fEwFy8msVbdcP4BtbwL8Z	8839	12490	12490	1618187400000	orphaned
17457	3NKTnkvo8a1WXm9utEmEGq8KsqmJoEKMFnDQ4JkyoPdakB7fgpYu	17455	3NK3th2bcJUXDBcN8NpbmaqJsZJqtnuK81BWs5E93ABKaptdqLoh	1642	1121	296	6301	12463	jxhVpQLR5CRyzjCebvfnWk9xfthiHSPQXL8Q6e7THDKeKAYdFz2	8841	12495	12495	1618188300000	orphaned
17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1642	1121	296	6301	12463	jxrLaM86Gy3XubUeJ9UuNZMJmRcBTSHRAvjH4DpvVHD7NtWTj1v	8842	12495	12495	1618188300000	canonical
17462	3NKBfK3cRZ9N63ubdEwStCd4A3BrKGScz2bfWvmHbNgKhosqp8AT	17456	3NLshVby9n9svfLQ5npDehDMfi5PYryXGXszpHZbwJzay9r45cZk	1503	1277	296	6301	12463	jxrs6sjMFSB14m9RGzfWSgkibbebYwVoxdjE8o6binSft7oHZou	8842	12496	12496	1618188480000	orphaned
17473	3NKF3mwfUkQTCavesSNjGD9ZE4eAKvHN98sALgZHw5xxJgckDSRG	17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	1594	960	296	6301	12463	jxfeuzUkjnBnmj2tqJG6uvMkiano3SH9LWB9G3fpmVNB4JzD7Xq	8844	12501	12501	1618189490647	orphaned
17469	3NKGjpZtZDg7fAsPpFhvW4eB3TMPYe6kyZ3esRUZ96RQ2rpyYVM4	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1471	1386	296	6301	12463	jx17JMFrkfvpijMgcD3dqVaPmJDo7XMbbhfh13fgymbJN73d1yS	8845	12500	12500	1618189200000	canonical
17467	3NLLQFLfkvohGFnzLT3GvJoSc4GLreXFwN4LYYhJsDPGqrGeQsiH	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1471	1386	296	6301	12463	jxtoR4NeHKg99ZQPjjQpAAVrbck7C9zp9qwpFriTVsCRyRa8Uz8	8845	12500	12500	1618189200000	orphaned
17472	3NKeWYjHqX8FtuFSsgLPoHavStdkfmvSWUHfhwBdTLysFtKvtKuK	17469	3NKGjpZtZDg7fAsPpFhvW4eB3TMPYe6kyZ3esRUZ96RQ2rpyYVM4	1508	1387	297	6301	12463	jxSGrtuab7HR7taJGsSXC48u3Dv8hNzzaN7LDxqMMcJ2e9d6H81	8846	12501	12501	1618189380000	canonical
17474	3NKcS3Aj8a2yMSXTPvuVd2jFnCG5kk6BPuoJJHjPv2p7wWbA5kjZ	17469	3NKGjpZtZDg7fAsPpFhvW4eB3TMPYe6kyZ3esRUZ96RQ2rpyYVM4	1594	960	296	6301	12463	jxzARivQ96D9rwNdiyj41eoK6N4bsvmvx5vv3pBvsS4eNGbd9zg	8846	12501	12501	1618189380000	orphaned
17476	3NLdS7sdTkGoqRv5NnvRmQ8S1Xkvekzokd1KLupxGDd9JfmHPPiW	17475	3NKhmBYvDXRx4eePk499fq13frLFZHWjhCz2F7RAUx1EN7e42LAf	1405	875	297	6301	12463	jwEX8ExhbC6bNfxSLhkdNFiy1QkAWYQBFTPkpK1znCnKiRhZuPM	8848	12503	12503	1618189740000	canonical
17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	1573	1072	297	6301	12463	jwebhYKUEaG9cNYbJLtFLbKeobJG1KaVzThyiQJAdXDT1QvFxgv	8850	12506	12506	1618190280000	canonical
17479	3NKU49VLxnBCXdMJZKYxBJM9LJyhXKGrmvxxV1kbt29iAiZyneLn	17477	3NKfjHPns85EhVhqkydY9AP1FsY84WHQuv95mYwd4CnRBEG18V7b	1608	1289	297	6301	12463	jwDdaCGbK4pibHe8QGsj7kRoCewidA6RVtbguvUJrPopdc8pUGt	8850	12506	12506	1618190280000	orphaned
17483	3NLQLj9LB2f1BKbZWFX8Ei7Y7DadXV37UcKZFqNC1Cg65gM977cz	17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	1523	1075	297	6301	12463	jxaWBRGvXRs9N1V3occHGvYTZYFML3cu5ar3bZCs1aZ6RSLM4Dr	8851	12507	12507	1618190460000	orphaned
17485	3NKtLPAAgu1EXG6ipR4Ex6ByYjkS1G4EVKbxfP3gfMaa1BniDGbh	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1523	1075	297	6301	12463	jxSPndTNAgEqfW5v6sQSiMZ7mpanoYsYGH6ptBTycFJyquPpNhb	8852	12508	12508	1618190640000	orphaned
17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	17488	3NKPK38tgUL4Lg9s1jWqxdBpwRpN9tFfuWu68313CcibzYbyMrXR	1402	884	297	6301	12463	jxoeaN3VWkndiJ59nsGXACAtF2UCaPd7UwXDyiXcLEQK5Ptm4tj	8853	12509	12509	1618190820000	canonical
17496	3NKfucVMHvdkiHhohLgnhrAjGm5tzvKT7qD4AokH4oFjisGHJsxc	17495	3NL8uzRT7ApjNioT9Nj1dN8s2GHmPLGLMD3QxmnZv8vS6F64V1Re	1406	1393	297	6301	12463	jxHoxVnUmLCBkbEhgik86hkirkyibhB1XSmbF14Pqa3RPWcJUZs	8857	12513	12513	1618191540000	canonical
17499	3NKecov8RtigQU3ENjg69jLdAnn4rMxjLkGo2LykuUggaYPBDtKC	17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	484	1319	297	6301	12463	jxQJd3ed6BcnxUqtsvd1HhV7Li9cubMfoMymSL2y8urr1SSREgP	8859	12515	12515	1618191900000	orphaned
17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	17502	3NLScziQXyJzdNAKB7bKQVCph15QYyRfxaoQMw9tSkawvEHWDXyq	1406	1393	298	6301	12463	jwE8zGmGmtVZmpCsNxtwVGwqhu54LjTSDwjYYc2pd8AgKQhwuro	8862	12518	12518	1618192440000	canonical
17512	3NKthLNkodgeFdhckN3EBMC7Y2jWJKjT14TejfAf5oMXH1ufKQH3	17509	3NK9NE1wAibFdoENZEbaNahKv135imQ5YipCbndZAsa6Ug779Sma	1509	1320	298	6301	12463	jwgFtb7sa3Ju6YAAqGXGEx8cBjZa7RoiVDTn8WycJxAx8FBT8Si	8866	12525	12525	1618193700000	orphaned
17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	17510	3NKgGBnNxm3r8cJnfx78BkCD5u4Yn9zE3J5rPEZmKvbZNf6mtiE7	632	1382	298	6301	12463	jxAzRgsoy6bWXkmxh9VA3JxQWSdWLLynnZeWbBgwrARhozwETaP	8867	12526	12526	1618193880000	canonical
17519	3NKk2PtVRPjpc57zc87eVa5UQWVSKeRHtmzE7PinRX2RisWqU6EH	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1448	1311	298	6301	12463	jx7QSTyrSKpkJLcjcPJ33M2EASG9WC8rZKRUoP2jhidnGeVXGim	8870	12529	12529	1618194420000	orphaned
17520	3NLUBW7KmC3pMnAzGA3mnLEB7SuLGg4nKxMEn3fpxB1HGym7zDPd	17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	448	1305	298	6301	12463	jxrU53NLPubszyGMtS4UpDhCgGpvWm6xnoW1iCi531SLeRuy1hp	8871	12530	12530	1618194600000	canonical
17523	3NLaW2ntTGyavfRWTLBhMgdeHKvZ7LQM7VvnpWmw5GmWmSU5QgyF	17520	3NLUBW7KmC3pMnAzGA3mnLEB7SuLGg4nKxMEn3fpxB1HGym7zDPd	1460	1324	298	6301	12463	jxZFHQziCJqNv9RaaxqXRCw1pxMkFmCMg9RukmWW9JDYboC5DKq	8872	12531	12531	1618194780000	canonical
17526	3NLbiRqbtvhNHYnGGtwuoBiDFjsganfGzwmtZBaUt6sZMcvq2J8q	17525	3NLKSeMoLrQVLX9D8t96eZGZ2uymBgtYkz9t4GRswXy5n1cAYPTZ	1553	776	298	6301	12463	jwiNWYBLG5F7YXJDUo6FBDZMTwUnEDDYzcPmwZtgf4SutQ4Ufsh	8874	12536	12536	1618195680000	canonical
17530	3NLZbkGNoLZ3QSRQCjZMnM1H2nj1QrHEgGnnyeXD16wjFV7XSoEB	17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	1637	816	298	6301	12463	jwMt2LgwKSZnerekR4mP1yhH5GmKQQ1Urvd9A52SmEKVv71Synb	8876	12539	12539	1618196220000	orphaned
21969	3NLRtqzPhMedcqYh7TKx8fejeRHKGiupryCmLMo956t7Enh6yUYp	21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	484	484	388	12463	14119	jxgRNTSjdyRb5qHaddR9MyzoZTjKMCtB5Pw1us8buRP5jAaoM7c	10699	15474	15474	1618724556675	orphaned
17490	3NK3VqbkNksAtgC6pHk2ULU2LRcL8ZT4zqGxJqTRT3ciJdh9AshA	17489	3NKNitk91pCbpTGX1hDQAaCT6NLXZTTd6oHAaNoRhoFrya92v9Qo	1403	824	297	6301	12463	jxKoFHMAedYwfJvzw3tZ6X7narXQwKQLP7N8mNGnBfktgrS1Nfy	8854	12510	12510	1618191000000	orphaned
17494	3NLVTPX2fxu7brjrTWJBY2HjMMxeH9y13MGgzWndCxVLVWPn49jq	17493	3NLbsLAVeSTkNPM3V6wZTYhi3RjiJJR5hq2rBYbHFudff6vurJLd	1458	1323	297	6301	12463	jxeckHJomWPAdHgcNvxPiYrVJc4HaTaSxn2cHVnjt4ZShLMz3fF	8856	12512	12512	1618191360000	orphaned
17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	17496	3NKfucVMHvdkiHhohLgnhrAjGm5tzvKT7qD4AokH4oFjisGHJsxc	532	937	297	6301	12463	jxqQXj4TahUeiaTSVQtkzDcK4r8KBjwqezyVdr9zx1AvKSWRV1S	8858	12514	12514	1618191720000	canonical
17500	3NKV6v2urBCroojjzdg4EAgx4croekx4wYysHLV69chdenPYLSoS	17497	3NKHiDmVe3WbWte8ELpktnAcu4RBPeuyjwkvpChDwNvV8tTPUWKX	1406	1393	297	6301	12463	jw6kYq7bC78gmAu7RDqRFKmqfKA3uKTY6BcmH2xWwcJVVmPXYJx	8859	12515	12515	1618191900000	orphaned
17501	3NKfzYrNfwXdJ6efKGGybZUyrbVg4RgVd4S5TFnX1EM8VNdYJZYh	17498	3NKbh77zQfcoyctoeEA1o5uGNNLYJxrifaCPrs1WTYgPBY8s4EVk	1631	794	297	6301	12463	jxxdau3nq4hzqMM1MEQXvcF2B69zFqTwAJb4MCQn3QpBRQ9KAzq	8860	12516	12516	1618192080000	canonical
17502	3NLScziQXyJzdNAKB7bKQVCph15QYyRfxaoQMw9tSkawvEHWDXyq	17501	3NKfzYrNfwXdJ6efKGGybZUyrbVg4RgVd4S5TFnX1EM8VNdYJZYh	1507	1154	298	6301	12463	jxFUuuXmABzsFHC7JByFHBbJci2rodU497AwtAGJbLsf4TcyG1V	8861	12517	12517	1618192260000	canonical
17505	3NKdG4HU3rs8Lv7XGWerj7ZFrBepPzonzDeSYEpHFtTYVfQrPT75	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	1581	778	298	6301	12463	jwZSpvUH2PNbL5scE4T4RLzxZPfPnHebyLJLcDVDi1acFoYZPKg	8863	12520	12520	1618192800000	canonical
17504	3NL8Jhx2cuHzVvyCCLmjQRvHhFh7FFnoJipMiYwwRcy5mReVmxXQ	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	1406	1393	298	6301	12463	jwSJTPv9enH6kQuNWCRjGpRBovbZ2CLgXBC9HpWJejGdj4wurss	8863	12520	12520	1618192800000	orphaned
17507	3NKGS6YvSvQCthLrFUhPjPANJBf75X4fwSwftAxiJFfcAn3t12qA	17505	3NKdG4HU3rs8Lv7XGWerj7ZFrBepPzonzDeSYEpHFtTYVfQrPT75	1649	1137	298	6301	12463	jwzDfxqW9QoPKE9GdB2D7EJYC4SAE2d3SUsUYaM3K6LViavhE75	8864	12521	12521	1618192980000	orphaned
17509	3NK9NE1wAibFdoENZEbaNahKv135imQ5YipCbndZAsa6Ug779Sma	17508	3NKjXAVCsntxzKcJiiqaRCiGr8vBoyQApqBheNXi2dce63KZfK2p	1631	794	298	6301	12463	jwfVt6MRPF6c6gwbLr1zrDn4edbA9t2gARfSHjnKMCMrthakFex	8865	12522	12522	1618193160000	canonical
17510	3NKgGBnNxm3r8cJnfx78BkCD5u4Yn9zE3J5rPEZmKvbZNf6mtiE7	17509	3NK9NE1wAibFdoENZEbaNahKv135imQ5YipCbndZAsa6Ug779Sma	1503	1277	298	6301	12463	jxCvyG8yWEGeSnDBj3tG7ChX1YnKfZyTT5Xrbz6LNSWpVgpz8RU	8866	12525	12525	1618193700000	canonical
17514	3NLYVmU9Pya6MSBJ8zsq3CV9PyC4ZyFb4X4EL88ShAsFUrxTe7CY	17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	1656	1097	298	6301	12463	jwqTvJ2EiXX4M6UwYdpGs6qmGvn7Bkco86e6oZWS5hqFXncSeS9	8868	12527	12527	1618194060000	canonical
17515	3NKcLqsumvwafXUuBbiPapLe6BAGkq5Bsv6gE3sXM5kewp5pw6oY	17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	171	1248	298	6301	12463	jwcxaTFuJEKLuFrVyZ5W52vMy5MdQYckutZvv5zC83BWnpAahhJ	8868	12527	12527	1618194060000	orphaned
17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	17514	3NLYVmU9Pya6MSBJ8zsq3CV9PyC4ZyFb4X4EL88ShAsFUrxTe7CY	1405	883	298	6301	12463	jwaq7LLi6Zq3NvoZXR1eEFYh6GGAQwpaBSMUyBQr16yFTLYAiHg	8869	12528	12528	1618194240000	canonical
17517	3NLLPfDRWVPT8y1hnQ5d9ZvVjnT91ZJ2eAW37wKhSBnBcSNjyC9Z	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1448	1311	298	6301	12463	jwXWjVLvAfR44LYGzpvJMd9pWrN5ckwwBMNHWCdYJ4DB28gjwgV	8870	12529	12529	1618194420000	orphaned
17522	3NKxja2LviB5iDqWbnT8GV2bVsyV5VumjLfTc21CZwdZtBxMxA5d	17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	1631	794	298	6301	12463	jxqTLbwZbL3mtzLu6TakUWghEwQVaxRpcvc3d6mHrRfUDCqaqZR	8871	12530	12530	1618194600000	orphaned
17524	3NLfieeSz7dWAjEdA4PAReuP5hsRQerkriBt7fDM8gBGTVAU82NX	17520	3NLUBW7KmC3pMnAzGA3mnLEB7SuLGg4nKxMEn3fpxB1HGym7zDPd	1406	1393	298	6301	12463	jx7surzicizgcN3FGEftTRmU53UYKBnW2s9aXWnXjAFt2KJE7mh	8872	12531	12531	1618194780000	orphaned
17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	17526	3NLbiRqbtvhNHYnGGtwuoBiDFjsganfGzwmtZBaUt6sZMcvq2J8q	1407	1395	298	6301	12463	jwWhFq1KA6yaLnEHC1GSo4pT6nNHQNercYV3uarJeY9GEHdmU7m	8875	12537	12537	1618195860000	canonical
17528	3NL68HU1jFHsYxqyVQ9Se9eJf7VZUT9scMNiXGAkdmyuEc6H9rc5	17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	1423	343	298	6301	12463	jwN733qFWuxUS6wnqbwyd5YFw7F8ruFaAgb6MnqN4cLjjXZ6wSP	8876	12539	12539	1618196220000	canonical
17532	3NKAaHNy8i9dwbDqkFAPwJLnGXoqoTFJr9vecM3PZzrdtt8LZp9Z	17531	3NK7xY6e8RAXUhCrN4tLAYD3RBLYqLaLz3vjJJWNzvVEUZ1Xrsqb	1579	1263	298	6301	12463	jw8tNBo4j8RBR5D1riHaa7DQE77sKU2t5YhTU6G9rX2ksDU5LCz	8878	12541	12541	1618196580000	canonical
17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	17535	3NLJ9LxdBa8yE2MzhWsHK5NsdchWnyWBkG5DhHkXaUsaa7VKqdZD	367	367	298	6301	12463	jxyn4NfCr9zmdXe98VY8LBH1F8jPsb6RExHEqWnE5GUPgCAHcj3	8881	12547	12547	1618197660000	canonical
17540	3NKJ1G2PcPyVYxNDULPsnhqTYLtEkHHtWGoCCG1EKSZoPN1D44n4	17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	563	1113	299	6301	12463	jxvYmdyEsq1fa5xff5BTwMUbvkRfWquutZ4sZeYiD7VRgLzvJNJ	8882	12548	12548	1618197840000	orphaned
17543	3NKyTTMsKxjP9HZVBJ8kqMnutEHtamAo6ohc7Lkiq7EYC7g7buvG	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1541	932	299	6301	12463	jw98wrpjAVh6CPaugHKwRrwBnApjyY8QeVxbprjF4ZGQq4wFCzs	8883	12550	12550	1618198200000	orphaned
17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	17542	3NKiyzPfjAwoyxVfax46g8crsvG17wQjhMPgFYJZF9UZnA8tdKu9	1581	778	299	6301	12463	jwH3ujGQuDLKjPZomqFXEGToTjdHoKQE5W7D7h2GtPgoD8DKLXH	8884	12551	12551	1618198380000	canonical
17547	3NKtQvnSXhD2Fm6qe6mpGFqCXK8zVkcJFmAJyJmLWXDD6nfGXTKn	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1403	786	299	6301	12463	jxYJCNocLHwTAHfaVVYW4QE9C4uacYuT5uT64mUFt2f9RqfrnVv	8885	12552	12552	1618198560000	canonical
17548	3NLjpQFNFLx3GTTwyGy4fE4Vu3cAHaDzqSGC3LiuyCQKtgJaPq48	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1647	1176	299	6301	12463	jx1Ba5Rkcb3z8VJA7MVa4EHfABToqmc6BC2Z6Zrggjr4doGpt3k	8885	12552	12552	1618198560000	orphaned
17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	17547	3NKtQvnSXhD2Fm6qe6mpGFqCXK8zVkcJFmAJyJmLWXDD6nfGXTKn	1507	1154	299	6301	12463	jxkt6yHkDf4stT2WnwFHt6reuYCbbJwLxQvogTPuwQoEAKQDJQP	8886	12553	12553	1618198740000	canonical
17550	3NKJ4sLxtfGcszigZxvhd4oJDXNBzXMUXEnNvW8HehfU3t3bt96w	17547	3NKtQvnSXhD2Fm6qe6mpGFqCXK8zVkcJFmAJyJmLWXDD6nfGXTKn	1406	1393	299	6301	12463	jwQQbJxEG5rBrrxL6NbczAL8AvPzg9tXR6NbAFetrjHCfRaAzt1	8886	12553	12553	1618198740000	orphaned
17552	3NLcmwNMMYEYhSjGKcJPDencLUGk8yGc3QHUQa3GCJ79xBBETgp4	17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	171	1128	299	6301	12463	jwB9H3i9XYHyYzmSvBWpEqLkd4tdoSy9zQ9VNeKi6JQKcPZ9ob4	8887	12554	12554	1618198920000	orphaned
21453	3NKpntES45ktnNinx2u9zPXxsZTExmMWBKDTcCCwDgfU73d2xJV6	21397	3NKBDJXJ884fLe3vxzLQMrNqSgrt9nsNtvS2tPBMvgMmvFLQtC8G	1581	778	388	12463	13668	jwa2YRbh8WbypLyrgwfWDqsAEftUYhzuyJhyF28AovGSff4SVLC	10702	15160	15160	1618668000000	orphaned
17508	3NKjXAVCsntxzKcJiiqaRCiGr8vBoyQApqBheNXi2dce63KZfK2p	17505	3NKdG4HU3rs8Lv7XGWerj7ZFrBepPzonzDeSYEpHFtTYVfQrPT75	1649	1137	298	6301	12463	jxzHBDLVbvUBQyM71oVZqDPvMba4xBj6NK6EPVC4Ej9bKmRerfa	8864	12521	12521	1618192980000	canonical
17511	3NLF66VpdcTLn6AgyjtXXWQSnYnaPo9UaREhYKTWkzJQypQnB1Jt	17508	3NKjXAVCsntxzKcJiiqaRCiGr8vBoyQApqBheNXi2dce63KZfK2p	1503	1277	298	6301	12463	jwALmsf5s9HWiwRxpmL8tGAqV8gSTUYpiEhSiqgPcHisQPsTjji	8865	12525	12525	1618193700000	orphaned
17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1419	814	298	6301	12463	jwMoRNLyWZNu8LkMXqka8BRkGNsarPtyYZwkf6ndSaVY4BWLGqH	8870	12529	12529	1618194420000	canonical
17525	3NLKSeMoLrQVLX9D8t96eZGZ2uymBgtYkz9t4GRswXy5n1cAYPTZ	17523	3NLaW2ntTGyavfRWTLBhMgdeHKvZ7LQM7VvnpWmw5GmWmSU5QgyF	1579	1023	298	6301	12463	jxGHLBXsFLMbpikVRs7GQyPbzSqC219tS47vNWTtmJkFGToKUMk	8873	12533	12533	1618195140000	canonical
17529	3NLgVMb7oR1JJ8UcErHnXGwWnS1rHAsKT9wcTZXMVcKXtXgwQrMK	17527	3NKNazbyyj3ayb82NNTueXXFMhGW7tTRDzuMAcEt1Jg3ogx6Wmng	1407	1395	298	6301	12463	jxcZaSKD2tjmKZzYhh2KeXsZwpJbDs7bSmQH1kkyudGnMQxS5oP	8876	12539	12539	1618196220000	orphaned
17533	3NLhSw1HfV94Sh9m97hSmLu6KbG4zKR7K8BWPyPqseEg2sCG6cDA	17532	3NKAaHNy8i9dwbDqkFAPwJLnGXoqoTFJr9vecM3PZzrdtt8LZp9Z	1559	1227	298	6301	12463	jwskGdt6ZfqrXL6t3Lkk1U5kqafesL1Qp544YQvdWhsbibaRvT5	8879	12542	12542	1618196760000	canonical
17534	3NKnT8pmxhE6C3BKSnS3hVFSkA4juz5Wr48vSqwK4bpjjxtMxhHz	17533	3NLhSw1HfV94Sh9m97hSmLu6KbG4zKR7K8BWPyPqseEg2sCG6cDA	1672	1285	298	6301	12463	jxRvxYJ1WsfP9FN3knbyiMtVqjYXUCckzoSUXy99a9AhgUm68m9	8880	12546	12546	1618197480000	orphaned
17537	3NKGTWYPZMwviZF7HoUHvQCdJYNhS6rJ8MnuTD48mqiA5UcS6VGt	17535	3NLJ9LxdBa8yE2MzhWsHK5NsdchWnyWBkG5DhHkXaUsaa7VKqdZD	367	367	299	6301	12463	jwKGBR4zHJBGzXrMXq62NgJma6SDwuW58KkShQfiorkrA16Dg5d	8881	12547	12547	1618197660000	orphaned
17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	44	44	299	6301	12463	jxr1LmaaJp9brVaNFoqRZtBARhZAnuaYruGKTEKqP8wT7wZ1Cs9	8887	12554	12554	1618198920000	canonical
17553	3NKsqiaApCQAZUcxcSuaytLiLbJiD5wGjgPN9cJTJVr6Umptpajj	17549	3NLPUAeVim4S7qkut9bZKgVBYFjAfxLYjSVGWhp3p8kXEuXhzxLT	1483	1150	299	6301	12463	jwtuC4Md7gZnqK6EkvbCWZ1GURLPgmyDiXpeBSypv3Z939TuTXr	8887	12554	12554	1618198920000	orphaned
17557	3NLKXJVnfPueDp4RPbq4n5JBXFYP9ckHndHEwCB9ETWtJSPwbyxK	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1406	1393	299	6301	12463	jxjPgQiGhoPgL3R1owoHzVGS6jJkSiG2xdUCA5DH5JUs73w5gJf	8888	12555	12555	1618199100000	orphaned
17555	3NLjF1BiCDvYMdT4Ui7y3Vxct8kt8EJdfu7MJ7rBPxJ1JsqYaHtZ	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1523	955	299	6301	12463	jwwJzZxJRhDWj4h8AWzQJSy9txiBLXCxP8J73NAeARM9D4FBMJq	8888	12555	12555	1618199100000	orphaned
17560	3NL52HLUdoRaBA7sFodJcsgvtMhXChQkwLaycGLMsNWzjaA2ArW7	17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	1596	997	299	6301	12463	jxqj8LRhkYsGpqsHQ2jkyyHfLAir2f63iivVbz5fsY3tnEbFZtD	8889	12556	12556	1618199280000	orphaned
17563	3NL5FWxq66cWU6Ug1xGuZoLzkJDHadrwi1uEjaJwFU4HB45VYaxi	17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	1553	776	299	6301	12463	jwUxtQXz8N3d5keR5aUZPPMSd15JoGo7bm1GGWkz6yVmJk48xKE	8890	12557	12557	1618199460000	canonical
17562	3NKG41wXQzoRxQK3BTaZnuvNVAG3AFbHa3pWGNCxUzZeUzfovKxL	17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	1627	1259	299	6301	12463	jw6kRTA52PJEoCpTAvBPKyY8eo7y1dH3yS9pG6JuhpARnzLHTHi	8890	12557	12557	1618199460000	orphaned
17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	17563	3NL5FWxq66cWU6Ug1xGuZoLzkJDHadrwi1uEjaJwFU4HB45VYaxi	1403	786	299	6301	12463	jy38cTMUeHP1Btmi7xJNCqrK2CYDSG8odrou74cJRNhro8DwCW3	8891	12559	12559	1618199820000	canonical
17567	3NKnZMCTf2nPbrcmGLBMPNrgfMtrPRTgXPhvJrXriWXzPzKhC9wN	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	1594	960	299	6301	12463	jwFBPosd3Ymcpha2FaX8CKHinbCqXX4dJK4yS7gwwBk97vYWzz3	8892	12560	12560	1618200000000	orphaned
17569	3NLd2QDP7sAULWpy9qLyZi5kwyeYg9wfPxkj2tfCvmvnHH4MM8Yy	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	412	412	299	6301	12463	jxSsFhahRNDk5VcJ6qnxHtTWvV5bQsfAr9tWpaBMumWBEzYwwAM	8892	12560	12560	1618200000000	orphaned
17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	17566	3NKS4gZwPNvwDdwjCwWGM8kTuZtk495yQ1Evt7cb7eH4y7UofNfh	338	338	299	6301	12463	jxtnrTrAE4Ppy8dhygLS25ensKvsnYHxmMgXpMhycNnS5Tuc4XV	8893	12562	12562	1618200360000	canonical
17576	3NKr7tq5xDRAUh6eFssjDApBgef1bFhpZMd7MqntpvkDpLqNUHKz	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	42	1361	299	6301	12463	jxPBaqHwcoNvLxJjYAPSeV4ndTNTzhbkgDeC6vAvoVe8NaaMdLk	8894	12563	12563	1618200540000	orphaned
17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	17579	3NLbUr9KcTY4KqaWACbnwWRZHea6pA43uAnvtYcVUA3FbzyYej3n	1444	1135	299	6301	12463	jxF5Fu9YwAbd1H4j68kcp1uSz9Ey3NbbDeSyBAX3FatAFQZAiFi	8896	12565	12565	1618200900000	canonical
17583	3NKgEEZk7KUMZvotchWKhRf9q6LcF5Wucn1EjnJd7m3WJvjBXpGQ	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1609	1207	299	6301	12463	jwyQWaTKnhqvdsQv765C8AZRh8i1XLYy9zn61SewZRHn2qhawNw	8897	12568	12568	1618201440000	orphaned
17588	3NKcpaVUiRVq5etMv3zH4VwhizTKfcNeCMmsG1G8v6VGaFUkGBnr	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1624	968	299	6301	12463	jxZRFQm5XtoNgKdNUoD33CeVQt4DzNtBxooRNMUdRzB9egUApoJ	8899	12571	12571	1618201980000	orphaned
17593	3NKB7SNZtGULXjwoz1V7Pbdp9M7JmvA38jHwhJ84upN3wvJps5i7	17591	3NKvwb1YYwTmFKaZrc1cRz82kb2NN8co8mjM7rVSsNJPLdZBnFsZ	1402	852	299	6301	12463	jwFh2RxZJ9izfX64cytic8WZjy3dN45ndNAFb9hZV1B3hhmxJfB	8900	12572	12572	1618202160000	orphaned
17604	3NLE68ASYqnF4bQ7J1srbHiYmxMphhcwKJLEtru3SppukKhZXKFL	17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	684	1226	300	6301	12463	jwMwn2gJPvMDSr75S37SiQtEAdJVtWjDdQPueK25jZ1eaMEUVvF	8904	12578	12578	1618203240000	orphaned
17606	3NL6Kf4Bs9ZYXqpJNGdwnFyibaaGThE88gwux1fSVYykHU719etJ	17603	3NKbNJnu4HrhJyCdMhMKu1srpLdgG2PETzveDoC8K2UacnhBg8B5	1406	1393	300	6301	12463	jwd3VqAiugDTcnUoms7aywnAcceWhLRUDEV76DnxdXGJ2fkmkgu	8905	12579	12579	1618203420000	orphaned
17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	17607	3NLAj3Wi6DE36hQEdR4PsrcXKtkiciU6uYcs6sAWsBzU1ts1jTU7	1406	1393	300	6301	12463	jw9a6xj9Vi2RQo5R7TXccUkvETaQUmjmk9zVoiELdRmnt1Z4JpV	8906	12580	12580	1618203600000	canonical
17620	3NKX7V3gaYM6Vmw3yfrUhMwT9SKQx75ArqDLbtp553pTeGTcBqC3	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	1405	873	300	6301	12463	jxeHq832J3FaquUbc5hxbeZAMFu83YTTJzAZbvBKD9pJ7wGJ2HM	8910	12584	12584	1618204320000	orphaned
17621	3NKBaSWtQJLS5ba5McTcktYhKZsRnt5GFc5ngCmFfBwe4mYvL3mw	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	1643	1053	300	6301	12463	jw9m7sAmD8Ki2Z7zW9pEwhkQeq6LKq5eWMFj5ELPePpz1v2AHx6	8910	12584	12584	1618204320000	orphaned
21594	3NLihXjD6fdtDte3J2GFMzzorh8i29NoRjaASVs1X91h9cvSegNH	21526	3NKu2sV1u5tGyDGauV28Gre7hdiwiLgJUjR1qeivooPYFdTAXU5k	1581	778	388	12463	13792	jxk4MnhSUeS2nRVcMmTcWF7fuSN7Ss9r4PC5DqPfZM5ivBu8F3s	10705	15242	15242	1618682760000	orphaned
17582	3NK5X4w4Apm5iySfFNqybA4vvtGgM2AXJiW4sY66SS3SfAeo1Qij	17538	3NKEZBg4D4pta6sbV9giuYYLuttqKuFzwhvrjL1sp4YgDppFirTM	1571	1335	297	6301	12463	jy2vmnLHANHfNJi3FD1LwhXvWT6AdYAoD8aVMHjsy9UBg2Mzgat	8853	12566	12566	1618201080000	orphaned
17531	3NK7xY6e8RAXUhCrN4tLAYD3RBLYqLaLz3vjJJWNzvVEUZ1Xrsqb	17528	3NL68HU1jFHsYxqyVQ9Se9eJf7VZUT9scMNiXGAkdmyuEc6H9rc5	1423	282	298	6301	12463	jwmvERaTCZRhWQttKqGePjrFvLiRA19BqzjxrWDsAFNnG374srL	8877	12540	12540	1618196400000	canonical
17535	3NLJ9LxdBa8yE2MzhWsHK5NsdchWnyWBkG5DhHkXaUsaa7VKqdZD	17533	3NLhSw1HfV94Sh9m97hSmLu6KbG4zKR7K8BWPyPqseEg2sCG6cDA	1672	1285	298	6301	12463	jxRvxYJ1WsfP9FN3knbyiMtVqjYXUCckzoSUXy99a9AhgUm68m9	8880	12546	12546	1618197480000	canonical
17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	563	1113	298	6301	12463	jwWjyGeKuZNMFzM87V3Gz77tf3qZZLkNBS7U1Qy31vqybVAwweC	8882	12548	12548	1618197840000	canonical
17542	3NKiyzPfjAwoyxVfax46g8crsvG17wQjhMPgFYJZF9UZnA8tdKu9	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1642	1241	299	6301	12463	jwQhLq4tawgicYRuu8Bc5kHXvy4XcNhS5zAST91J7s7vot1MVGa	8883	12550	12550	1618198200000	canonical
17573	3NLPnLezPHk3NNg6m4vSBAvjpGmYmSmf6MQUBZMgD65E9xxP3GDb	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	338	338	299	6301	12463	jx3Pu3hS4YHatNsndgo87CJ96ReuRjaHCBzLdHYcwjNxGaF58bK	8883	12562	12562	1618200360000	orphaned
17578	3NL6cyY2tcBCzXeN22dh8P8n5M7gWVqmj1afADQT5LYBhqQHtUoR	17542	3NKiyzPfjAwoyxVfax46g8crsvG17wQjhMPgFYJZF9UZnA8tdKu9	1581	778	299	6301	12463	jwmvdDB5bbyx647RbJyeScYzHmxoyQgHqN6Xhr7qbemsyapwZby	8884	12563	12563	1618200606519	orphaned
17546	3NLRjFDgnzQhqfKQyU9bdzj27cw8xzY2jQDy94F86uyf4xyxvvjL	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1546	1339	299	6301	12463	jx3PEtFBZaiU7pTzoDWScDyz1WNT81zXJPNJfEdtJyECR5D9YiL	8885	12552	12552	1618198560000	orphaned
17556	3NKdg9Q71wWtE8NEtjH7npuQrZTpJRnmY1evYsrKGvG7ZQ75D1v7	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1523	955	299	6301	12463	jwxoZ92ytgiH1JFuuog4oCXrFsE4apLSygscky57wxfirMUadED	8888	12555	12555	1618199100000	orphaned
17559	3NKMKLkD56G64ePBwiaKkfKYCaCvEyGN7YH8VrsxcdH5Ym8WGL8Z	17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	1403	824	299	6301	12463	jw6st3rQGMh85R1tfqeWFJK9mqFtAF3HjZs3hZzLG3tHjDi4ent	8889	12556	12556	1618199280000	orphaned
17598	3NLYy5eoaSNX9mdxpCNWWcZ5Kb3wMnBjEFa8xoaqsVkVw6g3eiCx	17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	1439	1279	299	6301	12463	jwDzLRg6KGfNUUm7bqoK2414AvdTq7miihLzU7KDLpoPEkFe2o6	8890	12575	12575	1618202700000	orphaned
17564	3NLRzPbEDk6yBhsc9mXVnYgZ3A2taWbmJsvtDcRd3h7bMhuLWMAo	17563	3NL5FWxq66cWU6Ug1xGuZoLzkJDHadrwi1uEjaJwFU4HB45VYaxi	1559	1107	299	6301	12463	jxspFC2Wg7GdNHTUEu4xaYti9bEaLD7dNV7ijdYFg1dcsCEApXo	8891	12559	12559	1618199820000	orphaned
17566	3NKS4gZwPNvwDdwjCwWGM8kTuZtk495yQ1Evt7cb7eH4y7UofNfh	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	1546	1093	299	6301	12463	jwVe9apbJdof4VmmT4noem2V1Rocq2kufQ7nfS6pQmpPCLzo9p3	8892	12560	12560	1618200000000	canonical
17570	3NKdX4a2iaVfZ36yVNQmvNNUrCCMNjPU5hyFsKnMwDyxyU9AZabu	17565	3NK4fbJnU9nbwuHGZJ5rTmNUH9XLsoys9zPn9afecuvHT2mPt7Lb	1406	1393	299	6301	12463	jwscjK2Jzm7T3ads9baMQBiZkAUyB8c9CSrMVMb7kbDatDFdDZM	8892	12560	12560	1618200000000	orphaned
17575	3NLvW4E5dbkNiuCr5C5oPaP6ywWETpFx3XcoopP2pZNkN9d4FuFS	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	43	1310	299	6301	12463	jxfcvnAS7zPVtWJeDUDb1uq5um3oqupoxnqSmfHTvhDW9E46ivY	8894	12563	12563	1618200540000	canonical
17580	3NLxgtxmS4tG5wSB7sy7nAcDsAosCmuqZ43n6tZxuLpdL55UJebZ	17572	3NLjP6RbCjM3LRTUErdSxq97ZZ2HaAAGEWrFii4hN1uaDJjcRipe	1406	1393	299	6301	12463	jxxAgePLkLaCGUz6E8huD8hPQHVTKiWwWJp7dLEFZppoEmWhTB1	8894	12565	12565	1618200900000	orphaned
17579	3NLbUr9KcTY4KqaWACbnwWRZHea6pA43uAnvtYcVUA3FbzyYej3n	17575	3NLvW4E5dbkNiuCr5C5oPaP6ywWETpFx3XcoopP2pZNkN9d4FuFS	1403	792	299	6301	12463	jy1MUakMnsHJjyVCZz9wzpkm4Xvpm9HRFv3CpEBqFpXhveL37uD	8895	12564	12564	1618200720000	canonical
17585	3NKM63aQt9GB71CVDdPJAE88bwePwytYFY23o6xtj27FBHk7k92f	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1407	1395	299	6301	12463	jwJpJg45EcKdrPMJs16yfWJ6J51GJ5dG9YCg8qWzq7t5q3bKQsQ	8897	12568	12568	1618201440000	orphaned
17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	17586	3NLxbRL8fdXdab52mmBaXoaqSMgUW78d7Vaa96ZttRMSv8D6xu9B	1601	1388	299	6301	12463	jxJhwkP2P84mE3fxmfkwdGTuioRDBSBNezXHK7LEpjBxL3e9QMt	8898	12570	12570	1618201800000	canonical
17590	3NKutoASJhx1jZPtqZk6GukB2xkbBD4nbRWoGudK89eB48p8GD4K	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1624	968	299	6301	12463	jwV34Yz2tQLRLgR2Tpk7AV4DhwVH2m3RXAR8wCkaZitANL4CxVQ	8899	12571	12571	1618201980000	canonical
17594	3NLf2XVKpAJWXrLscgWK2rebv5qKWMNCK7jwYEsde5iJw5YSieEA	17590	3NKutoASJhx1jZPtqZk6GukB2xkbBD4nbRWoGudK89eB48p8GD4K	1403	824	299	6301	12463	jwQQL2bVjpYRYjxLkaDXZPhCJPBhu6zj2HGgngnLVu8LkG7p5sS	8900	12572	12572	1618202160000	canonical
17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	17597	3NKBVjkKZs1NvsyUtmjGEBx9BmwcZhU7qN1Szbsbk8nDcRRN9Ui3	1581	778	300	6301	12463	jwgrbwcibyLp9AMjajv8Tf88x6jw1pxrWaeYQbXMqEztMVQkUfW	8903	12575	12575	1618202700000	canonical
17610	3NLSS7X4UazSE7pHsweMZQCpR9PM6niTfbSYUauFqwpSVP2Po6He	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1523	1195	300	6301	12463	jxC1PHPbZeNxvD9Jpx3zJE93RdSsgTR2VJVgsT9kP3LczboAT5p	8907	12581	12581	1618203780000	orphaned
17614	3NL5yFoGbJbQcYfHjWCNuompBz9X2rzUTi3fybXBeHuvNBaaCPEN	17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	1407	1395	300	6301	12463	jwBdKpF1tqqrx6tPRoDp5XbCbPZA3dPh2SyR2iRUSUugpJPyW6U	8908	12582	12582	1618203960000	orphaned
17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	17613	3NLqfro6kjeAM5azMqyqac2c2ekAm4XoCExuZrWqvqufLmdM3hUQ	1406	1393	300	6301	12463	jxQNrMtDLMYP4dRbSE8ZY3BroUdobVX4TRM17zoZDpJHDshGtD3	8909	12583	12583	1618204140000	canonical
17618	3NLPVx2BgFPQinqithyPGRkxR4CSVSCXcUsmd6rB6NG19GqViYi8	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	1542	938	300	6301	12463	jx24kqBRCZKoVYsrnwVUoheTAspt8hFmZeKsFhcDi4wTr2vFXiF	8910	12584	12584	1618204320000	canonical
17628	3NLg7R2BDf9G7AAdTMgB5ZUDPx6kGTUBwFLoef7pry21zSPPnd2C	17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	1611	1341	300	6301	12463	jwQ9W8hPQADUP5iULvz9AtHm1suRmBkqmntk1KfiBDxscgSVy9j	8913	12588	12588	1618205040000	orphaned
17630	3NLZVrMqDrpb5R8YgWSKUR9W89gYa5sMSa7SQSsxhTUi2zZPPY2k	17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	1670	1156	300	6301	12463	jxkZvSWpSbZxrwQmU7wkqVwZdaBJjf6E4VK2DsS3pfQYNvUqKVp	8914	12589	12589	1618205220000	orphaned
17634	3NLkoW5b6ydQkqbKLhbaqSPFDHhxeMpT2VqovZfBYNo6ZCeXAPa3	17633	3NLiAjV8o1wngGoz9cwWyw7S3gfrsENRbpeDxgUsXgsxFJ4NbQu1	1553	776	300	6301	12463	jwcwRZEPMFf6yDdS6G29DnSCd7DFEjqBD4kpARqnMbV7WFxed5u	8916	12591	12591	1618205580000	orphaned
21330	3NLUnLbR8eL99i3giqV9yoJk9Tm5RiU2Q8jNVVkgzxaRDhixbYX1	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	563	1113	389	12463	13563	jwQCvoKe4JPgA8P8sh3JSZq65aCdKvG6MbgYqBMJfe4FbcQnS59	10707	15077	15077	1618653060000	orphaned
17670	3NLtmvdMDWy6gQaGYHjhs6XqH74N1aFb6dpUK17NQjJS8M1LtHb1	17601	3NKrCAA86Yq8TpjNUsaDo9etgXSZnNNroC6rvELt7dG7AeCtZJfQ	152	1330	292	6301	12463	jxVEvCBEKrPexxkFFv4LnFUj3qJzVE5tvw2yRqmWVf6Z6vGAuiF	8746	12611	12611	1618209180000	orphaned
17596	3NLeABH9jXqDnUj6qpTyVmrLTiZZFP6uSZZkD9vZTr6SMFJpqKZx	17407	3NLgoW9xaxisgYRGAajYjLB562evDxfGLaNedxVuPgxJseGzMSDk	596	1306	295	6301	12463	jwfVz73SYjBKFtpAEQy4aDz99QgR7C4wfSjL7d7GjyH4pXdSNyL	8819	12573	12573	1618202340000	orphaned
17577	3NKxw6ao4ru9W482np3jc2Y1HjdhQgJyme9x49atm8nbvNhkVUfK	17513	3NKzWkXQn9iw3FuUkwheVZxnwvQjRnHMHtVgJD96L7CBfESz5gqC	1581	778	298	6301	12463	jwwvW2wzDjYnS9DZJ7xSMtdLmA52yVF7WwRoV9Qj2bBppubXiK1	8868	12563	12563	1618200540000	orphaned
17568	3NKoPRucWzrDmk8mmpwRvwfJjStH5vUePJuEC9vbiYkHPsSQw7Ua	17545	3NLNZwxptMPAVDDXbA3WdxPp4P629oxntpNHdKhC2sqZjhVHYQP9	1546	1093	299	6301	12463	jxuhPK9xmTd5pZLnpAk9FWEKdQFmSAhkdpVGKs571J7fNF3Cdpu	8885	12560	12560	1618200000000	orphaned
17554	3NLTMoZgPAjmNq2k1PqLiCn18Zc6AGgQv9iFz7vPtuWcTqWBrD3z	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1523	955	299	6301	12463	jwesWFtpoJjBrqKFatC3XbpvF865suVEjT8bY5SZtM8FNGMT6Xo	8888	12555	12555	1618199100000	orphaned
17561	3NLpqgmA1qYvNx9toR1HoTh8wSXXWgaVz6SMuvD1yAfCE1w56uny	17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	1406	1393	299	6301	12463	jxFg4WW9XwKtaxjekMgnznckBjeQRzPDFR1yzjbLA9pk9soHFDp	8889	12556	12556	1618199280000	canonical
17572	3NLjP6RbCjM3LRTUErdSxq97ZZ2HaAAGEWrFii4hN1uaDJjcRipe	17566	3NKS4gZwPNvwDdwjCwWGM8kTuZtk495yQ1Evt7cb7eH4y7UofNfh	1406	1393	299	6301	12463	jxN2ZJGpE48N1DazEQzJe9FSUjy2CEw3QKS9GmjZujgkG64e2Xm	8893	12562	12562	1618200360000	orphaned
17574	3NLE6FKu5kgb6sfpc19fUput4Tu1xCwKYYw1XtYA2jGLZ9RRfkRg	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	1609	1333	299	6301	12463	jwQoxz1nEZLPXpayJSTUef4X7e1kP1dZsqmUY1wrZJSNCgta9Hm	8894	12563	12563	1618200540000	orphaned
17584	3NLDWbBYJPiomb1ZfgjoSJP27hADFK3wX1A4fFAV7YKXYubJtgrh	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1651	1055	299	6301	12463	jxbKd1X3AEYJDHFvfMUTRccPK7gVD3gJJ92qAUgZTmpcy57deXV	8897	12568	12568	1618201440000	orphaned
17589	3NL525LMHR9g2WMyS1Q4BNPBBvwEck7bykKuz8fXy4M2XHZBC5vH	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1407	1395	299	6301	12463	jwLssQ4h9DTANzgTXWC2aUT8nqiRvtX7jtkCRZfJSfNeEVbSykW	8899	12571	12571	1618201980000	orphaned
17595	3NKjyXmwPUVMLJGzrZWKFzQPG7okDgH4foQ3Q3VwXYM8Tem6218g	17594	3NLf2XVKpAJWXrLscgWK2rebv5qKWMNCK7jwYEsde5iJw5YSieEA	596	1306	299	6301	12463	jwrFqph1gqLVSvcAmJ5tSo4S7War3jML1D9XYEynZh9WgWfrhJr	8901	12573	12573	1618202340000	canonical
17597	3NKBVjkKZs1NvsyUtmjGEBx9BmwcZhU7qN1Szbsbk8nDcRRN9Ui3	17595	3NKjyXmwPUVMLJGzrZWKFzQPG7okDgH4foQ3Q3VwXYM8Tem6218g	1522	1076	300	6301	12463	jxqrx5Nb58uDaTFxN7yFM4tkKRsQQ4UJuD2d8oNzj1xUPbBGbvh	8902	12574	12574	1618202520000	canonical
17603	3NKbNJnu4HrhJyCdMhMKu1srpLdgG2PETzveDoC8K2UacnhBg8B5	17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	1406	1393	300	6301	12463	jwwUou1UHJXA38HHRrTNeiCExjfUvLDwiejKM35QcYoRW1K5BpD	8904	12578	12578	1618203240000	canonical
17605	3NKDRtr6THLxfsuJ193VRqt61Rq2JGYQ5ZvAqDw7Kkqi8FvxkdLr	17602	3NKHUphXuUUXrTZiGrhDo83BhRpnfdiZUVpQxkgKJXfdL4Cz7moj	684	1226	300	6301	12463	jwLiZFU7ujr76SSjW6uUzxTjtWdFSMzUYmBY2RuAcuZuojLNy9N	8904	12578	12578	1618203240000	orphaned
17607	3NLAj3Wi6DE36hQEdR4PsrcXKtkiciU6uYcs6sAWsBzU1ts1jTU7	17603	3NKbNJnu4HrhJyCdMhMKu1srpLdgG2PETzveDoC8K2UacnhBg8B5	1507	1280	300	6301	12463	jwDmtpTy5cG9J2WjYqNaMRCj6skM27iPMy6Y29Yhg9ywHDVvn4n	8905	12579	12579	1618203420000	canonical
17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1506	1127	300	6301	12463	jwoHaY6ptUZBj6KsoWv2vNk9ue1K3FEZWkGWFtXSxpXpAHg9bBS	8907	12581	12581	1618203780000	canonical
17611	3NKqTvitCJUXuCaixuz4ExDiwG3rs6NezJnJQBw9wECecSSutARj	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1523	1195	300	6301	12463	jw9VmCuTmjxaUuakYMd2qXgEpNgqYgiWcGx3LDvb7aR3KqYo8HB	8907	12581	12581	1618203780000	orphaned
17615	3NL1bEhYbwBByKu2eNSZbc58wpM1jpaxYdopJrVpunEEYKrHueTc	17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	1403	824	300	6301	12463	jxyjTTT9CTv2pgn1V4Wd5jHQfyTi9no9VoPGvc75m7nkXob7Es7	8908	12582	12582	1618203960000	orphaned
17617	3NKvS4nvqEfkJNpPCGB2bxcJrbow9raFsqrhJfeGS1G39YLYbcAn	17613	3NLqfro6kjeAM5azMqyqac2c2ekAm4XoCExuZrWqvqufLmdM3hUQ	1581	778	300	6301	12463	jwiehXVJqFzTuaWeNP9DJLnKjQ77ahM5yJffnYReHc5pz1YxfH8	8909	12583	12583	1618204140000	orphaned
17619	3NLKVA2R48iNgxkzKzNFmjrS588RpyWF9T6cQaQciGmzMwBnr3xv	17616	3NKMRpm9dnC1UgWHetLBEgZdctpZLRW3idYW3YRxNp915veAVxes	58	1035	300	6301	12463	jwWmWLeh7JQk1jF7bRMGoSmZ69ibe2Z7CoWUQbQieve9RmmR7oE	8910	12584	12584	1618204320000	orphaned
17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	1607	982	300	6301	12463	jwdVjfk23XaZF1vXurKik4Dr5UJwaoo53Gqfjzv9wP9qLT2EhWb	8912	12586	12586	1618204680000	canonical
17631	3NLKZbVN7zP4tLr4EfmFCuGiHkGHuYv3tuRBwCHBV4PEzgp5buud	17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	369	1312	300	6301	12463	jwWEUKMaD7C8ct2CkNwZHYsZACfHbMkjA7QDXwfCmSQgVb1PNCZ	8914	12589	12589	1618205220000	canonical
17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	17633	3NLiAjV8o1wngGoz9cwWyw7S3gfrsENRbpeDxgUsXgsxFJ4NbQu1	1631	793	300	6301	12463	jx2JwYdMnYnUSfGA8eXdMzyum4yE6NT7JFUuTdQkDHaamrBdWr2	8916	12591	12591	1618205580000	canonical
17644	3NLBw8G5SJvc7A1TCDZuQQs3pZwSxtr5Ua3Ebnt6sF9kYRR53ruc	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1406	1393	300	6301	12463	jx4iR9iuLWPkRn21LF2wBJHk2bcxXLVG7VLAedCtKQ6pidtSKgT	8921	12596	12596	1618206480000	orphaned
17649	3NLapdSvUm5FkGzok63wEjxp6rADyzsa7bRf9eVSq13YM8FsdBWg	17648	3NK9ipU5QRuZaBhwocT4cJNBopR3HhT8WyK52xUPGzJB6HGgBxmH	1407	1395	300	6301	12463	jwXUHwXSXwuzgQZmRrGa3gCpMUERinUtMfXX6aTA2azBqxk23sm	8923	12600	12600	1618207200000	orphaned
17652	3NKQDrcGHRzZziViHfU52qUeNYbHJoADE8fkardBuiZuAW8PfXQ9	17650	3NLfoh412czzeG5EhbMtPCjAX7K2skSyVZDEN9t127VmuebmcFDk	369	1312	301	6301	12463	jxijwZL5QY2GzSifr9FmSHY7JPvcdww25yZMg5mm6tk6AgEtcG4	8924	12601	12601	1618207380000	canonical
17656	3NKSdg76Wews6Vb2588a6r1riYHZpWAS3qbjtSNs3mMwEncrhZm1	17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	1483	361	301	6301	12463	jx6TmgkfyFTi76QEPCqfFVMgrCcmxWC33Ar2cbN2G7YTjpyjUmD	8926	12603	12603	1618207740000	orphaned
17660	3NLaJ3rjTvv2ZbKrPb6697GePXvxcmveZgihpeUYf57GNuHp3QJc	17658	3NKkDwdkEaVCrFDDPeBpCfGuih3BZReZ7XbKHAmu9Q2TtYZzh5vr	1407	1395	301	6301	12463	jwDwna9gNwhLtjJwyxtmNavaeCrG3hVknSiyXnhTNPb1KVG7gfh	8927	12604	12604	1618207920000	canonical
17667	3NKVudxjB45PaDzuwL9UThcEopJ8RFtHvpXphH3ZshxFopcEfwem	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1460	1078	301	6301	12463	jwrMb4RouV3zAbYAjFEVHojfs1jYSRuTQAaT6tmasSb6FLN7b23	8930	12609	12609	1618208820000	orphaned
21764	3NKYx4m76BE8SF6BwoKcTfdbGze58ncF1WM9g1TTqmaPtXUfUB5r	21676	3NLKhmSE1Uzx2DZfTvkPkLMpSCSDjfpLgqksnTD5MNQPy6jqUUTY	1581	778	388	12463	13936	jwWJggFpyXrUDMkbFLmFdP5pwWeF2qw2bpJkNDuNmy1vVseJigT	10708	15336	15336	1618699680000	orphaned
17651	3NLbXsG7iECzqMCyuode3V3Nc4h47vvm6sR8gcXRiAW9wmX3oabi	17632	3NLsWUu3dtzLnxPYpY368EF8BgkpQPqjTW27qhvhHZtR3zzqdBk8	369	1312	290	6301	12463	jwuKhv1eVoix4yhE4jWwjgHn65dwjeqceWPgm7CoUxSHDW2EZ8w	8703	12601	12601	1618207380000	orphaned
17639	3NKqr1j1rARqv74btLNdmsB5CppX4NoHf8PYh733cz5AmB8EbTUn	17459	3NLV5k7mGWUS1SaSKVkyKYcSpWkQ3Rrz6wfEAJLrYJmBsAohh4Xx	1613	983	296	6301	12463	jx8rqV3M6XXQL1mNtoX3KRf37B2Ew8ataGtWHjwqiDnuwiC3m2x	8843	12592	12592	1618205760000	orphaned
17609	3NLruXAAkuxaWpPDqpAN8y3AwYxxifHV6RzussUuZYeDHtDhhrVM	17608	3NKSNQhokyMStpMvUdG7j63BK9K8Zh2sUQ8owo2yhfwqGPXR4duM	1523	1195	300	6301	12463	jwfdy68gVWFa1GMSxj7FiTtR3tqRbpnxa7oBNE5518HxTB2RQQo	8907	12581	12581	1618203780000	orphaned
17613	3NLqfro6kjeAM5azMqyqac2c2ekAm4XoCExuZrWqvqufLmdM3hUQ	17612	3NKZ9ZucMCysUVQqsNW6DLe9XiKfLXGmDaucHGJSMKPnnZaLbzsi	684	986	300	6301	12463	jwq2XvNAVXcEHueyGjPB2ts2s3LDbJ9g8bX2BjaFweR8e1j2KYF	8908	12582	12582	1618203960000	canonical
17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	17618	3NLPVx2BgFPQinqithyPGRkxR4CSVSCXcUsmd6rB6NG19GqViYi8	1406	1393	300	6301	12463	jwKEzCKoDoChYbWZXtgE3fptJK5FM4B6xNGoZtjkA7f7ByLZvLB	8911	12585	12585	1618204500000	canonical
17653	3NLAm5mhis4RDgL75VUN6ha3t1eTTXJ33tsgorhhWHMLzQ4wWNHQ	17618	3NLPVx2BgFPQinqithyPGRkxR4CSVSCXcUsmd6rB6NG19GqViYi8	1516	928	300	6301	12463	jwti7Lc99hup2tvgE29fkM5r4H1LsEMSE5DB3E39rdwjij499TB	8911	12602	12602	1618207560000	orphaned
17625	3NKdXajZ9sDbjWbhNViFDcn5cP5rMB3rSUSHCXScRydzeSHiBWNF	17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	1541	1298	300	6301	12463	jwWJemFztZgYpn3gnDTF9QZ4obaLkS8G8PsKgT3CCoDPEC39d5n	8912	12586	12586	1618204680000	orphaned
17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	1654	1214	300	6301	12463	jxqPPiARFZeyxrxzzNWPbumyZWXWXHfKozXcbLZzF6SF3fenKsT	8913	12588	12588	1618205040000	canonical
17627	3NKh3QMHMrAYzoWhDFUpkcS2KaY6vFGkGv4c12d9PZNCD16eCznM	17623	3NKqnnna7sY5SeZNr5yd2Xz2k6Y1RGg8NPaGd87Po8asjzV7pg6P	1403	823	300	6301	12463	jws5F7eGpm44WbJDisok5Kua3QLgAYv369XT6BgGs7nMsfGa7XZ	8913	12588	12588	1618205040000	orphaned
17629	3NLq8kfGbm9qLkwH7q6Ti7UryT4ChmfVpkkFLztyQrHrCnqjeqjy	17626	3NKQ8t2nqKMAZo17NGzM92jGP2pthcWnicdnwRaX4gN2VjusoXKL	1589	1160	300	6301	12463	jxVyWCpSSm9BxhxtWsbYtJR8xkQ2KuwXpQNoLsPnzFKJ5csS1ej	8914	12589	12589	1618205220000	orphaned
17633	3NLiAjV8o1wngGoz9cwWyw7S3gfrsENRbpeDxgUsXgsxFJ4NbQu1	17631	3NLKZbVN7zP4tLr4EfmFCuGiHkGHuYv3tuRBwCHBV4PEzgp5buud	684	986	300	6301	12463	jxEgmt21UwdsPQCdL95bzxgHFjLpkar4SA4HmbXNM3pB91xv9ry	8915	12590	12590	1618205400000	canonical
17636	3NK5nLh1phTqj47G1C18vSGSoQLkP1v4AtjAZojrSucUM27cLaYW	17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	80	907	300	6301	12463	jxs153p1X8AZnZ1J6qVaohvZCHbzf2UtR1GQqPPq9TBFhJgB9sQ	8917	12592	12592	1618205760000	canonical
17638	3NLNzTBcertzNUrayGqwMqaQ8YkHLkjWiQq71ZXkKK9uiFWwhJow	17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	1631	794	300	6301	12463	jxp5JGqYDZeQXvEmF4FQttz2YTmjoArCB7pmysjHdWX1P4A4EEd	8917	12592	12592	1618205760000	orphaned
17640	3NL9tSecgRiwYWhiquX1FrGX9rCbk4VwznsWvoG9H6JpN2yJppsZ	17636	3NK5nLh1phTqj47G1C18vSGSoQLkP1v4AtjAZojrSucUM27cLaYW	1406	1393	300	6301	12463	jwp8PKYoL6xSWcPyLFb9vTgVPtzVq3LgZMyoCou1AacFmW4vZt9	8918	12593	12593	1618205940000	canonical
17641	3NKtrrNFTLyw3SuRCvxFPBWb9wx4YJDGTtuq7LQxKMFaxDAXQQbZ	17636	3NK5nLh1phTqj47G1C18vSGSoQLkP1v4AtjAZojrSucUM27cLaYW	606	1295	300	6301	12463	jwrP9z9UWzJUtGYHaPBY4wQhdY4Ei3Xu2TFJgtNScHguf92kMJP	8918	12593	12593	1618205940000	orphaned
17642	3NKqJimvsjPxDYn3qnmsUJFsXTMcJ8q6ZPhGfLN1UnbdmJvEBBPu	17640	3NL9tSecgRiwYWhiquX1FrGX9rCbk4VwznsWvoG9H6JpN2yJppsZ	1451	1292	300	6301	12463	jy1fGnS31iWSmHSun8NuKUQYVmKG6qAbvyHiS7gsVWa8GNoyfMf	8919	12594	12594	1618206120000	canonical
17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	17642	3NKqJimvsjPxDYn3qnmsUJFsXTMcJ8q6ZPhGfLN1UnbdmJvEBBPu	1407	1395	300	6301	12463	jwbRbVqo1mZAtLtfqCNoJToiqKCpbCJubpaRQAFkYBf4PDN7nk7	8920	12595	12595	1618206300000	canonical
17647	3NKrEmbcxf1KUCBSUA4uWUNnv1rNoriFW55PgXjW2cVSD6Eudzei	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1549	1236	300	6301	12463	jxca7ASxfvajrGfycYK2gG5kdEm4C57typg5L9baWjBpk4PehuX	8921	12596	12596	1618206480000	canonical
17645	3NKtFVfNSBiof5vkityUaX5NzovaTWiQEmn2keMB4bWoCfxS5HTM	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1426	998	300	6301	12463	jwQHWuT4CTXn514Ux6oMWPjG8vJyBF2DTbEFS3z7kmfoJ5t2XTG	8921	12596	12596	1618206480000	orphaned
17648	3NK9ipU5QRuZaBhwocT4cJNBopR3HhT8WyK52xUPGzJB6HGgBxmH	17647	3NKrEmbcxf1KUCBSUA4uWUNnv1rNoriFW55PgXjW2cVSD6Eudzei	1445	924	300	6301	12463	jxQ95y4SDQBqRD3ZPX4wYzXk1uvcWWvjhx27BUuTmhzJSvZsBJN	8922	12599	12599	1618207020000	canonical
17650	3NLfoh412czzeG5EhbMtPCjAX7K2skSyVZDEN9t127VmuebmcFDk	17648	3NK9ipU5QRuZaBhwocT4cJNBopR3HhT8WyK52xUPGzJB6HGgBxmH	1631	794	300	6301	12463	jxpm6mGNzj3HdxaeFwfcYe7DSchDDhieC2gJVtj8Xp4qRtCxqeN	8923	12600	12600	1618207200000	canonical
17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	17652	3NKQDrcGHRzZziViHfU52qUeNYbHJoADE8fkardBuiZuAW8PfXQ9	1474	1329	301	6301	12463	jwfxsdqCckdPd1wDyai8nmJQpBTKS2q75KSDGzdthzDhCRcH97V	8925	12602	12602	1618207560000	canonical
17658	3NKkDwdkEaVCrFDDPeBpCfGuih3BZReZ7XbKHAmu9Q2TtYZzh5vr	17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	1577	1201	301	6301	12463	jxihwEfAdfvv5Udm2iBES9omJSbYsPGRdXwgkfA2GzFHG5DUJFy	8926	12603	12603	1618207740000	canonical
17657	3NLbQd6NhysS88g86RERJrSajS5eRyK6rdZ8cqwwJWFBhNUSWhJB	17654	3NKez1h1BSLkJJm1wEeSPy5qoGf5wsT8uABJCnerLq5cfJFPdx8D	1657	1344	301	6301	12463	jwaU1pnPDCa6HX9zDFJtVoCxvRDb9u3EQyP6Ti8N3if7XVYT76g	8926	12603	12603	1618207740000	orphaned
17659	3NKjm3ogVxdYmmohj824d6DZ55xr8sQzCiiBgPtkDiAJVmjhCtC1	17658	3NKkDwdkEaVCrFDDPeBpCfGuih3BZReZ7XbKHAmu9Q2TtYZzh5vr	1406	1393	301	6301	12463	jx7HsE6foWKTpFunDYuYdAXJKxWNoUDMwvnxBz3dLLPcKHZcE4k	8927	12604	12604	1618207920000	orphaned
17661	3NKHptvqBuE99S6wwmtf813GCSoqpiecyii6xH98STmL8tsr8BEq	17660	3NLaJ3rjTvv2ZbKrPb6697GePXvxcmveZgihpeUYf57GNuHp3QJc	1471	1140	301	6301	12463	jxY3sVWJJe4gFBbTmZJsjaEA7McDNedRKgKqrynLyzhKpgwai5Y	8928	12606	12606	1618208280000	canonical
17662	3NLKZFsYQAnKDKhuY9sA31bxhQmLxZz45bhT7fumSzp81Y95Qm7U	17661	3NKHptvqBuE99S6wwmtf813GCSoqpiecyii6xH98STmL8tsr8BEq	684	1352	301	6301	12463	jxsYkAjzmua4YjMw2VvbGrXWNrBPUR1GRTsTAUHBP4BKxPmCNrq	8929	12608	12608	1618208640000	orphaned
17664	3NKtoFEJnymwqiixrPXtfByeDEpMYC9hsHeJdkopbZMXFvFxXJry	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1406	1393	301	6301	12463	jxBaGSUXhCKaoTkTtFJ9GDXAUXFKCMB5c8mFtg6oxRWdEJdFdwW	8930	12609	12609	1618208820000	orphaned
17668	3NKNyixKBRpscWv8JWQ8Z6VYnGNibnysXgAgGLNGt4QGf3UA8zMn	17665	3NLxZDAhNXB2R473sQK74x154d2ZZA5Q1mkcNCiGb2zqw7cDKiNC	1407	1395	301	6301	12463	jxigEQZfR6b17SGSKgaowwbG1Met6MHQuho9hY39KZU6BuF1tBz	8931	12610	12610	1618209000000	canonical
21821	3NKmgPjM8sg3sdUqKQEKmgndEd7ciQZrrq2uVsbfcrF8wfZSTRVE	21800	3NKEeosCX84ZsK6bBJTGhb2pkXgbdXJmt427VS513vKkYYeDnmum	1581	778	388	12463	13990	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10710	15377	15377	1618707060000	orphaned
17686	3NKMMnutkUXc7BJRRPBZt4k4c4RXSPDvbadFsfjtZWVzzg3L31HJ	17503	3NLJ3mfBuDGHgpFtVk3n3HfBrt88Uoqk2b6nWsMAa26pfJXxZ92R	641	1336	298	6301	12463	jxx76e9MzV7pimSUT1MQecNz1AVeVHgGmRAuFGTSmLoD7u7w1rd	8863	12623	12623	1618211340000	orphaned
17637	3NLKe2sfjAGrnC5cvVavdsR8PcF192W38VBKzVv1oigQRjCVTJGo	17635	3NKNcQnjjxNkpDwaFVMNvw8jGFbhQ2qcCZNSL4VVBQHLyP9hL6sF	1581	778	300	6301	12463	jxu865B7FEiP81quDVnNGdLpkug392Z4i6CnSttWV5FNYMrJfSV	8917	12592	12592	1618205760000	orphaned
17646	3NLFx41rXEvYk11gzczmaYWrpepJMSkcwV6omMB1jehr7JtuAjBw	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1457	1025	300	6301	12463	jxjFDz7XWyV7xNEE8PGXPLMm4sJ4kW76FgZTiY1vCrE5HDDnXZu	8921	12596	12596	1618206480000	orphaned
17655	3NKaKW8NjL4nraZM4Q1i5jLboBy82XMDq6Dte9XnnbU3d8uRtQvK	17650	3NLfoh412czzeG5EhbMtPCjAX7K2skSyVZDEN9t127VmuebmcFDk	1474	1329	301	6301	12463	jwJpE4wHR5H7ZCrhAkBazMrYxeXzN1X4PVCAddLhQv6ajN9LogM	8924	12602	12602	1618207560000	orphaned
17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	17661	3NKHptvqBuE99S6wwmtf813GCSoqpiecyii6xH98STmL8tsr8BEq	632	1256	301	6301	12463	jwemvGGcFEY3id6oanB5KPFXDgsSpXyTq2sDjhpCqXPcjNsc3PJ	8929	12608	12608	1618208640000	canonical
17666	3NKXWMNkzUsSw5nzNWyUMfzWCoVqu5oqrPvfGj5TUuJovstqczQ9	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1594	1326	301	6301	12463	jwJeLtUzTkHprdYpmdyRwgMku2BXtjxDERPkp37nw7Eg7NUFBiy	8930	12609	12609	1618208820000	orphaned
17672	3NKm5cDpFCWXxERPWVimeKPtpk54qNudvim8Zxd56KE7wFZfUJwp	17669	3NKpDaPgaLGMh7wSp3dv9qBc1sXVEYfSYtUWi3tisNTbdTD39xXz	1407	1395	301	6301	12463	jxFhUW58sfQJ6L9orMx8wy39NKZzmz8XjK91bRdqXAPGpYyHNoD	8933	12612	12612	1618209360000	canonical
17673	3NKXBTCm727rvxaiH62yRLhAuchWCwE5uBCEJoMJ452KXYYpbjXo	17672	3NKm5cDpFCWXxERPWVimeKPtpk54qNudvim8Zxd56KE7wFZfUJwp	1490	1028	301	6301	12463	jx6fg8AbNXTvZs4taybYcofK9qkwt7xWYANeexk9sEcG4Cknd9k	8934	12617	12617	1618210260000	orphaned
17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	17680	3NLaGi5n6ZspLP4oRokMAzVBL9qWcnWz8vUf23i8CfCXC76xuCWS	1593	1346	301	6301	12463	jxERGEkWMhcEjyUD4QSr871QbSGYRm1bo6aNe7Zk4NR7GpHUE1P	8938	12621	12621	1618210980000	canonical
17684	3NLc2VmNViCxA32yUoT3gC4hkonyAfhA5CRRFQ5DXPrs2B33Tcys	17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	1623	829	301	6301	12463	jwqWzciv7Q9CnfnF5zTCNqDJiwQZeUKPZeGe6Uu3aHpSZzqg5Vr	8939	12622	12622	1618211160000	canonical
17683	3NLJxMv21giuB8SXovvP3rL7MFNyx3EAwBsywGB2YLDZcxv2uDbU	17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	1542	1304	301	6301	12463	jxNfrBadYjEKvBKyDJrWzBSQTzYBeXXSauvfUYTQ1BRS1iRJW3Y	8939	12622	12622	1618211160000	orphaned
17687	3NKPNti4qTxNchaqaFHrNvU6gLbBERtR7MsdjWV3LhfCLhQdKezn	17684	3NLc2VmNViCxA32yUoT3gC4hkonyAfhA5CRRFQ5DXPrs2B33Tcys	641	1336	301	6301	12463	jwztpUR32xbSgHT6hZ4HdngagkkvRf9wpTUNvCGkPhXjDVf5kGB	8940	12623	12623	1618211340000	orphaned
17690	3NKFEt5tvEVCjyzDw37K5y2KuVeqnxpfu2xhHDpG1VUfrmRNd5qT	17685	3NLxUvGy8wwj4fYeEuyH2q1TBXKFtKH5HriysD87SorGfmgRBsuR	1501	1360	301	6301	12463	jxi5FNMS6oeVAk3Q2yyCjKZ29jFRUvYPJttnW7Wht8QmPaSbjxp	8941	12631	12631	1618212780000	orphaned
17692	3NLBdBfHu3hDidybgY24bPmxoujdjXzbH7MDCPWKCBJ2csXMt4th	17689	3NKh4ED3tmwzE76FbgcFduMNyCBoYWatyQV4rK1KPopwozo42vNj	1407	1395	301	6301	12463	jxL6GqyHTK2t8ST4a4CfPndQ6UWB58FmZKSRiUrCuyKM2V9cuUE	8942	12632	12632	1618212960000	canonical
17693	3NKmycjxCBGDFycY4vbBza1wytacB2Bk2AfiTQjVbXTsnwz7oKuo	17692	3NLBdBfHu3hDidybgY24bPmxoujdjXzbH7MDCPWKCBJ2csXMt4th	1507	1280	301	6301	12463	jwr7xT6gofrVrrowfPSHz1pRTFcwr6weyMveK52veX52dspPwfW	8943	12634	12634	1618213320000	orphaned
17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1652	1315	301	6301	12463	jxyAQzRHZtQbxjQN9JgijQfnpTPZ1orNjiPmxYi5SjupgfmWZXY	8947	12640	12640	1618214400000	canonical
17700	3NKJmFYVSZuzzCEAF796GxxuzL5mMpR6EnEt1DegoCRkCe6kdLK7	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1652	1315	302	6301	12463	jweGXqVJjsrE91p1UWuqw2V94rFvcbPZ5hCMXDQ22RXwj9M75K3	8947	12640	12640	1618214400000	orphaned
17702	3NLCGoUH5fJXnNJyoJ9TSojPohAuuu66EvxvQSSX93KMua1vzcKm	17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	1500	1051	302	6301	12463	jwPnbHEA7RpQMescXm8sxB7cdbadnQg25KCWCybNF6gPwdzr7X2	8948	12641	12641	1618214580000	canonical
17706	3NLMgQx9SY4cijFT4w7gkZoB818zsRvT36q6aWDxmfDf6YsBPphh	17700	3NKJmFYVSZuzzCEAF796GxxuzL5mMpR6EnEt1DegoCRkCe6kdLK7	1648	1158	302	6301	12463	jxDdkmx5vEWhQvV6XGzpE6ciUZrvEVETDhZBvtJ5KVdWof1fExH	8948	12641	12641	1618214580000	orphaned
17707	3NLesCiK7Uhj6XHyf1U1EVYHbUMH5tqVw7ev1zW5LgY8Yi3nTWCW	17702	3NLCGoUH5fJXnNJyoJ9TSojPohAuuu66EvxvQSSX93KMua1vzcKm	1406	1393	302	6301	12463	jxBbWBQon84Prc9pmhTX8GjTrJa65EhmN25pcJY5NHKu8832eWm	8949	12642	12642	1618214760000	canonical
17711	3NK44gwccFG5cRxni2rXP7kcDpScy3CCv7eP9EcLnFS5UVm9Xuac	17710	3NLx2UmXkVz7HMGzgUps7HsKSAtyUm6WSSA5tVB3w6Bb3RQouvpb	1406	1393	302	6301	12463	jxD5SyjfvF6cPqc23jD5aHxY7tdCXwYXv8C81KogXLreixMkhV6	8952	12646	12646	1618215480000	orphaned
17719	3NLhqE7Qx1fviZDgDuem21tnqAKmQ3eJRuZje9V6r2fHUqfj1iP6	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1581	778	302	6301	12463	jwAnnKPSUTTQSm6ZwC8rxvSgFwdWDE8bY3kCmu2vCiog5EgmVvj	8955	12652	12652	1618216560000	orphaned
17721	3NLd1z2sRmqT1AQ3DoaoGhi6gE28NSbnhmitmHZfbxbDrsP9MH9U	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1461	1271	302	6301	12463	jwAjg7qbsdXo27V8SA4XVhSFEva4ghNTqnhMr6tro8zK4u1VSzW	8955	12652	12652	1618216560000	orphaned
17723	3NK4aHcB69ztT3whsHcgT7kVZHfDmxGugCks8S74Tay5LoydR7ch	17722	3NLr8JpaMbUDaTiMKQmrE7rYNXNqsbafG8gMJ2ZnLCMFe3AWWEbn	733	640	302	6301	12463	jwTZQHu6kfvuUBeHcu6yWRQCFYFFauxwXucNzoAjJyxfUpqq3PR	8957	12654	12654	1618216920000	canonical
17726	3NLJes9crH4hjxf8gcxo9JtQ7Tqw3CaxAKVYE89x7k9m62dvPYjG	17723	3NK4aHcB69ztT3whsHcgT7kVZHfDmxGugCks8S74Tay5LoydR7ch	1589	1286	302	6301	12463	jxBPDrAsAC8Xp1FXctLYWbK53rXBHQbQhbM6CoVhGhXopLnKd7K	8958	12655	12655	1618217100000	canonical
17728	3NLN1AeWjyBsG4R4BjHxzNAiQ239hFkUtCAGZ2cG6D6LbgmpBosw	17727	3NLaM7E18y48d7YnX5zpGbsjdn7FEPZkE6iwWv7md2MV6p6Aiv8G	1637	816	302	6301	12463	jwgZDXtt4i53zituCM1s1EQqf32k9GVSTK1CHiNhDdbGhKYJqmy	8960	12658	12658	1618217640000	canonical
17731	3NKkpeLPxi7wZig2r5AUAmdrcVNHT4iZg9MY2XGghk9whto3iK42	17728	3NLN1AeWjyBsG4R4BjHxzNAiQ239hFkUtCAGZ2cG6D6LbgmpBosw	1448	1311	302	6301	12463	jwKAAdWBWMmJth7MJW1WyY9BTufuSZ8d9RRS6ArxNSgKp2f7Cck	8961	12659	12659	1618217820000	orphaned
17734	3NKdvScgHe8AzdTtKmdckk1gp4vkqakq8LHCsr1zLLMdmQcr8GsJ	17733	3NLvpcuB7rzTKa1TjkM5eKdszH7ddWyjcrPRubr1JboV1cVKiiaW	1503	1151	302	6301	12463	jxEvHkSQnVAJpMxtUcZCJiVp7BTYxJQuGc1Yo5Bbc5YqWUiqgQq	8964	12665	12665	1618218900000	canonical
17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1553	776	302	6301	12463	jwnWzkvyeHnwSwAF345RSeWshcZ1qwZmwQCFLmXtEv9UEbcooS8	8966	12670	12670	1618219800000	canonical
21830	3NKeqVGiNrBHuZoSpi9DbdmAyb8kUAohGRc6TbWa6nCbE9X4J4cd	21821	3NKmgPjM8sg3sdUqKQEKmgndEd7ciQZrrq2uVsbfcrF8wfZSTRVE	1581	778	388	12463	13998	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10711	15385	15385	1618708500000	orphaned
17712	3NKWtHL64a7cYuqJz7r44Bquo9YiDvtBqE77d9TouVo7w7r7rpdn	17653	3NLAm5mhis4RDgL75VUN6ha3t1eTTXJ33tsgorhhWHMLzQ4wWNHQ	1516	1294	300	6301	12463	jy2fmPhuFKq8BWGyagWTZ3HAAXddfhRgp3YG1X6NPDn3tHugqoJ	8912	12646	12646	1618215480000	orphaned
17678	3NLcWNmpVcjuewT9m8kMw5Nb6ya1QHrAoKziKUZQWGk4TjubRbAY	17629	3NLq8kfGbm9qLkwH7q6Ti7UryT4ChmfVpkkFLztyQrHrCnqjeqjy	1500	1051	300	6301	12463	jxRy63th2FtXjmLja1fTthhhgWRFRESZxm6foFe6CDkgBngMaVm	8915	12618	12618	1618210440000	orphaned
17703	3NKGUvfByN6FGnmTVKAEE5VpXV3V19iaYMx7mqBccyxeLqbXhy7a	17678	3NLcWNmpVcjuewT9m8kMw5Nb6ya1QHrAoKziKUZQWGk4TjubRbAY	1500	1051	300	6301	12463	jxL7aGBg1axBA8WYt4rgDh5hkwGBj43ii2dRUYtzMSv7EbCZ1qS	8916	12641	12641	1618214580000	orphaned
17665	3NLxZDAhNXB2R473sQK74x154d2ZZA5Q1mkcNCiGb2zqw7cDKiNC	17663	3NKEdUW8nZSqMoEAE2Zk2uhJiKKC6ffJVs2tKsP2Cuq5eCctWLeK	1489	1134	301	6301	12463	jwWBiA87AhGjvb7s15rMfkPiv5bMnJsZs2UGigu9g6UHrgziZQX	8930	12609	12609	1618208820000	canonical
17669	3NKpDaPgaLGMh7wSp3dv9qBc1sXVEYfSYtUWi3tisNTbdTD39xXz	17668	3NKNyixKBRpscWv8JWQ8Z6VYnGNibnysXgAgGLNGt4QGf3UA8zMn	152	1330	301	6301	12463	jwAw3CisdshTzgNd94u6f8GKU4DDNr87dEuu1w5sJo9eyBcEK4w	8932	12611	12611	1618209180000	canonical
17671	3NKkgYY8YZ8e8tYAcAX1DF61mUUBQib3FFXgKN3iHReurQRS5hgJ	17669	3NKpDaPgaLGMh7wSp3dv9qBc1sXVEYfSYtUWi3tisNTbdTD39xXz	1585	1366	301	6301	12463	jxXmqcVZGW1HYo6GHSpSMzgmk4BnfUt3FQU1cNtW4eBh1E79xLi	8933	12612	12612	1618209360000	orphaned
17679	3NL7e1NBhmpLTb629T3uz5EKc6ejnvUChbjjMGLURmhhfAiTWKaX	17677	3NLt4LKFD3zSuULXAozE1X4bYEaRdoEjDLRi9pnzD5WfaCbnctJE	1471	1020	301	6301	12463	jwtowrQgXuhGB9uYp4FUpejinj9ViLjoW1v3aR4Xp6V4DeLMQpA	8936	12619	12619	1618210620000	canonical
17682	3NLji1fbaTkLMzGsJKVyqD5u7wKqc72PyMsqcUg9yYL2ozHprjwR	17680	3NLaGi5n6ZspLP4oRokMAzVBL9qWcnWz8vUf23i8CfCXC76xuCWS	1560	1291	301	6301	12463	jxiVSaZur45shVzhApMnDg8e7vjGaZXSLMz3KuertvXxEyzR7Vf	8938	12621	12621	1618210980000	orphaned
17698	3NKVCqFzG9uFDJh9D9X112fbtyg25qxCQNehjHxeXLnCb5Vaw6wA	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1652	1315	302	6301	12463	jxfJW1CM4e4rRz6UBvbLD1HKx4Mu59CDmH3Tf6RaZ1xdPSE3b2Z	8947	12640	12640	1618214400000	orphaned
17710	3NLx2UmXkVz7HMGzgUps7HsKSAtyUm6WSSA5tVB3w6Bb3RQouvpb	17708	3NKhXXXVf9gr7KhZP1wFQLrES38UWDR11QqRcAadfhBhjoAz4F6H	1527	1293	302	6301	12463	jx7g3jbvuMum5TZehtpPrCp5yADQSqNbkL2zy6vHGPCkHoiSxNi	8951	12644	12644	1618215120000	canonical
17709	3NKVWpf8k3RWjwTAM9V9oVwBwM3g8m9Ly7eUz2Eyg4SKzjn53cDp	17708	3NKhXXXVf9gr7KhZP1wFQLrES38UWDR11QqRcAadfhBhjoAz4F6H	1527	1293	302	6301	12463	jxtchXYbi5apoDcjdoh3FGQWb7cq7GnxAx1kDp9P8tGhyfajwRm	8951	12644	12644	1618215120000	orphaned
17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	17710	3NLx2UmXkVz7HMGzgUps7HsKSAtyUm6WSSA5tVB3w6Bb3RQouvpb	1671	1365	302	6301	12463	jwq2U5GYi57dyAwE7h9fCJ8vLECXtf7hDuNXxDjVyWVeougxzKh	8952	12646	12646	1618215480000	canonical
17714	3NLWpQsRyUwsK9VKzZCJNh2BZmZanFQpUzXJD2ZVw8v1Jf7pUKhP	17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	1527	927	302	6301	12463	jwmuyPJPZvEFQZDwuzoHLCpWxtaQLWCznxjiPqZB2ACK5kJcLTY	8953	12648	12648	1618215840000	canonical
17715	3NLCo1XjU1M5tcYMVS6fNGNngU3gspy7WgJJUwi1H5kzBKQvymqu	17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	1527	927	302	6301	12463	jxF24i4VnbNqzWs3AcP46xJTyyuqfkvy3nyY2FM3MTmdrN6H2io	8953	12648	12648	1618215840000	orphaned
17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	17714	3NLWpQsRyUwsK9VKzZCJNh2BZmZanFQpUzXJD2ZVw8v1Jf7pUKhP	1406	1393	302	6301	12463	jwnVZ39nvUp5kbeUBLNFQ25BMjXrxaxzAdghwXCm4eLhLWcbont	8954	12650	12650	1618216200000	canonical
17722	3NLr8JpaMbUDaTiMKQmrE7rYNXNqsbafG8gMJ2ZnLCMFe3AWWEbn	17720	3NKnHpSp5BtmbRDHQ2nEguke95U1DkebAvXZ6aadP1qvcTeHQAbP	1406	1393	302	6301	12463	jxEAgMtbfdUpkpJgRiLLgWgRuJ9DrMEYCxzNF1LCoep3Fbxq8N1	8956	12653	12653	1618216740000	canonical
17724	3NL4ag3ViqTUxAUWCX2gN7D883hNFUxWvtBY1pxHBm8YUiPUHJyc	17722	3NLr8JpaMbUDaTiMKQmrE7rYNXNqsbafG8gMJ2ZnLCMFe3AWWEbn	596	1306	302	6301	12463	jxT5vSGB54HpchKGcabt28d9N71SehkF15eDjihYVpCxzBZnRuz	8957	12654	12654	1618216920000	orphaned
17727	3NLaM7E18y48d7YnX5zpGbsjdn7FEPZkE6iwWv7md2MV6p6Aiv8G	17726	3NLJes9crH4hjxf8gcxo9JtQ7Tqw3CaxAKVYE89x7k9m62dvPYjG	1535	93	302	6301	12463	jwYxVVSmMtwYaN5QPHy3HN53c8zuVBT5hAyC9QQr45m8vUYfZLA	8959	12657	12657	1618217460000	canonical
17732	3NKNJZXA9b9Pjftc9vwM5LNcDVoau644tweFh2STt7U4jo1eFcsM	17730	3NLrQvd1E7RUtNMEsXLLaeAGW7FiUVorsY45cmjBDne7Kam9EAKV	1419	814	302	6301	12463	jwRkvn94TtGGVWrtxVDTy9Mdn666zvBeYbUaR1hzW7hWMJiTg2H	8962	12661	12661	1618218180000	canonical
17739	3NLQ5uB7pdP8T5guYaJLDaasHrBPx8X6XEg5mMd5nfQDemn4Kg4W	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1624	1088	302	6301	12463	jw7E5bQd5zn7XYLMaH2pD9mmLzg7HdCQUH2mecaUFLFjZrj7HcM	8966	12670	12670	1618219800000	orphaned
17749	3NKV3LmP1C3mSqoxGcCd3YEVoSUDAf4D76eauaPaW2yyC8CKGwSn	17747	3NLWDkvY8ktGVUuyhyKBZyo6emcoUcEBRvPQmuMguncKnavzAjjU	1593	1346	303	6301	12463	jx7tvokqNJNfHbPWpLA23ck81BhQS2omSDfy4iE1kqryXyFSz5b	8968	12673	12673	1618220340000	canonical
17757	3NLNrZCNjHFCzqionAHFaLK634yUnLsXa7Veia5QYW2AvAXfRpYz	17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	1649	1383	303	6301	12463	jwrvsvmsMTo1uMkbaLQvrc1getairGBY8vd8D9epfW1eGum4CZq	8972	12680	12680	1618221600000	orphaned
17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	17756	3NLpYLn8JYb6pZgCr1mU3YcsCQyDokWsf4gKzwG8RyrG3YuRSKg5	1503	1031	303	6301	12463	jxW7Hn4zv3Rm4VZFzBzJWFBYtyPX9Lcr52WB8BHQRnqEaywanJe	8973	12681	12681	1618221780000	canonical
17761	3NLHsMoVHfJsYfLu9UNunJrSswoTpGMYWhrEYS1LUZXSGEyffpLe	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1627	1259	303	6301	12463	jxyHMUo3N3QLCRJt1B5hWLwpHxmvSvnd8ebw5wQVTDGpZxq2nAR	8974	12682	12682	1618221960000	orphaned
17775	3NLkoUMSLDPbtyN2qUgNhW7GYWEijKhK38eHuopokPmtfKv2bau4	17772	3NLHf28sZNr12yw8VGWAKLug91FkBmffEFgUaahzMdrYZsEcjUh8	149	1283	303	6301	12463	jxEYNLKst7ULFvH3dvWA7VXg3fE92BEYRaLcf2r6Rnt2waiJbTo	8980	12695	12695	1618224300000	orphaned
17777	3NKeTNuQv6T3xU8cjNWjzn9N2g4tzhQ9CKjUshgHnYZgcugtmsG2	17776	3NKv8Eg1KkV8e1xwv4Ea3s5N9cbuVidTvbkGFTvaMNGdWxbPqnbu	1611	1341	303	6301	12463	jwApbd7bau8NuPFgqPDoQV5REuVFpSxEQMKAmTzdkAjffX6qZc8	8982	12697	12697	1618224660000	canonical
17779	3NLFEMmSqBJXC8P4Nk7L4VkHYu98GtKj3zi9gNg3L6AEkW4Kgi8x	17777	3NKeTNuQv6T3xU8cjNWjzn9N2g4tzhQ9CKjUshgHnYZgcugtmsG2	576	1109	303	6301	12463	jwJtGuGW8WTSBq8iuguD4CWPfpbD5nEpfZLqPnPNHS5F9JJFc2T	8983	12698	12698	1618224840000	canonical
17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	17781	3NL3iCMS6Gv9kAn5LV7QwLUyrG2jWQhYNpELA4zYqnWgKGSrrGcn	1406	1393	304	6301	12463	jxLK7Nri7cSGLB653q13hFvnemm6ixN8xym5mXaYLQNi5GuAMDL	8986	12701	12701	1618225380000	canonical
17788	3NLZE4xpifLTBFzKwrJxER5zQsjuQEWH8sMD2Vm4N91YSCJUbY9Z	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1553	776	304	6301	12463	jxHZP2zN7er3VXAUGW5hTHyeRFQzBt48y97TRufU5q6gizWd8Cc	8987	12702	12702	1618225560000	orphaned
21881	3NL3pcQnt8Wu87t15eDffTfqbftKxpy7amNny1P9UkbTjSzQWGtj	21830	3NKeqVGiNrBHuZoSpi9DbdmAyb8kUAohGRc6TbWa6nCbE9X4J4cd	1581	778	388	12463	14042	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10712	15417	15417	1618714260000	orphaned
22358	3NKWCtHdMWTSBjNqtwRtM8EC3LcuFSX96cdrQLAFwqp23Vcfi7xC	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1455	1206	413	12463	14473	jwnENgyToyYZBenb5ZevGuJwoonGDPL5QmMyb9nrNjZbgVLjC17	11190	15755	15755	1618775100000	orphaned
17791	3NKidjcSp7vh92wt257jPtBThBfuygHKksmhysp3rvyvqjvHNES9	17536	3NLkwB3NPHiqmheyJid46DN7tBNTGhx5CpCyC9ngdVWHScztLTMc	1549	1362	298	6301	12463	jxR5dDn1GDnJbJdrSyVo7ipDigg6LorTh6bTinZTUfnnCVp738w	8882	12702	12702	1618225663880	orphaned
17751	3NLPZdGZrEVqJ9TxB7QSVGMJUeDL8mDtKT2hfkxUhjjfJReykvPg	17600	3NLTuoFcbkUixe6NBTkoED6YQBmeFA6qPvnCTGeGtFUbebHbXB7R	1673	1368	299	6301	12463	jwsGfujodT2VQ5FoxoLg87LRiRHqPNMoMavUdx139mccpoyKmi7	8898	12673	12673	1618220340000	orphaned
17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	17672	3NKm5cDpFCWXxERPWVimeKPtpk54qNudvim8Zxd56KE7wFZfUJwp	358	358	301	6301	12463	jwQRmtp6xHdv9YUivpaZ6gdX6KHvcpoqeQADmUQMAebfckuTBeo	8934	12617	12617	1618210260000	canonical
17676	3NKB8tfmq4ExLYCNnbfGHnDtnnnEoXCsfk7eCh5ktVPpRrpuWe1K	17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	1500	1051	301	6301	12463	jwvuQqYJsSjMwdZ1nNPHh4wtLmMJ2prgg54ckyuNfpFvKqGYZTY	8935	12618	12618	1618210440000	orphaned
17680	3NLaGi5n6ZspLP4oRokMAzVBL9qWcnWz8vUf23i8CfCXC76xuCWS	17679	3NL7e1NBhmpLTb629T3uz5EKc6ejnvUChbjjMGLURmhhfAiTWKaX	1407	1395	301	6301	12463	jxstN32Sgm9Qcd6x1c2UfF9Eh6E4Jnxx5pz4AvcwvWuxvRe83wo	8937	12620	12620	1618210800000	canonical
17729	3NLWSU5P7hrVufxpRxKVQMi2b74jXS5PaPWhD9bDDh3Tfi9VRf2d	17681	3NL5DGYyvrhMLZGALLvpMtuWAyVRbgJ5vHvnZuS1x8n36o4y9N9P	1448	1311	301	6301	12463	jwE8gYSvxYYbDEiinAGzqUcyGcXDAdH1iDmjDLrX9d4jRrm9Jp7	8939	12659	12659	1618217820000	orphaned
17685	3NLxUvGy8wwj4fYeEuyH2q1TBXKFtKH5HriysD87SorGfmgRBsuR	17684	3NLc2VmNViCxA32yUoT3gC4hkonyAfhA5CRRFQ5DXPrs2B33Tcys	1406	1393	301	6301	12463	jwzFJmkgn1VcsRtEWiPcgBCVvzVLuzKxPpC9CEZ3dWLi89tCZ7c	8940	12623	12623	1618211340000	canonical
17689	3NKh4ED3tmwzE76FbgcFduMNyCBoYWatyQV4rK1KPopwozo42vNj	17685	3NLxUvGy8wwj4fYeEuyH2q1TBXKFtKH5HriysD87SorGfmgRBsuR	1564	1092	301	6301	12463	jxFqHZ3cwT61s2zGKpJxMsCyaEt8NovfNTwmfFNtKYWViDjE3iw	8941	12631	12631	1618212780000	canonical
17694	3NKQPTuXNXo3BWT7evgQMNYmRFoDFcT25iL5xa78A9ykxe16AzRv	17692	3NLBdBfHu3hDidybgY24bPmxoujdjXzbH7MDCPWKCBJ2csXMt4th	632	1382	301	6301	12463	jxRKLCEC4tyyjM99PNvnA21uQencuAtikbcWdKNp5xG6kMeEcq4	8943	12634	12634	1618213320000	canonical
17696	3NLErYVdWLBSNnsTASWDpzdpD4XAKXJW27fGaNtAE6zYTvKg83jb	17695	3NKhDVb6Fvc9NLVjpDe3spEfEqghZusim69VGikjnNbsqSy7tYBP	1457	1391	301	6301	12463	jwcfgREyYoFJ9mwntokmDGBC7ni4mzWdybfCtB3PEbp5nv2rMNc	8945	12636	12636	1618213680000	canonical
17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	17696	3NLErYVdWLBSNnsTASWDpzdpD4XAKXJW27fGaNtAE6zYTvKg83jb	1407	1395	301	6301	12463	jxW7o5W9TCzqQDFafJLtUDfSb6mJAkS6Ati2QXKNRqU3d4FiLPx	8946	12639	12639	1618214220000	canonical
17705	3NKtjBntoBMfRztbVh4baJib3WumxdDuRNsVMvY7z73QxvpNwFF4	17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	1619	1275	302	6301	12463	jxtpuDUyYEeReBX1MDAZCpZAK639YP7hXuefwoUsb1FnbArnQzc	8948	12641	12641	1618214580000	orphaned
17708	3NKhXXXVf9gr7KhZP1wFQLrES38UWDR11QqRcAadfhBhjoAz4F6H	17707	3NLesCiK7Uhj6XHyf1U1EVYHbUMH5tqVw7ev1zW5LgY8Yi3nTWCW	484	1319	302	6301	12463	jxEJDg9335NADT8Rbqd759BtCmysNEcT9JZUmL13TMRxF4S4MQp	8950	12643	12643	1618214940000	canonical
17716	3NKMwveqMeTiWmGEog6JPUS2U9SMkgbZe3jUBqdFyAFZLLxhqX3j	17713	3NKrn23cTVbgayTVczRU2KKcYmVmwnCBRvZWZj9vBCwonoHM6F3E	1617	922	302	6301	12463	jwhaE6CsXjNGvo41rEGm49zaKBGLyppH3yjXfmkDd4C37QM13Ju	8953	12648	12648	1618215840000	orphaned
17720	3NKnHpSp5BtmbRDHQ2nEguke95U1DkebAvXZ6aadP1qvcTeHQAbP	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1652	1069	302	6301	12463	jxYHdqd1JvugqJp7FwKfAZYF23KzkSn1uryiFUKLmNz5EAzn2n1	8955	12652	12652	1618216560000	canonical
17718	3NLpUmQZhkkjUTiTeSG4gFjQQLB1xFSBMCGEyNT9jcfGQrbTTvHm	17717	3NL5iX5qmWQuS2jK2keAUF3gYBke2WSWcN2sLpCZMTprj4h99Bhq	1672	1285	302	6301	12463	jxfLkiqCMahLJtuXNoTGx1r3dZzFYYjXeK4C4BkJVu6A9mXgF6y	8955	12652	12652	1618216560000	orphaned
17735	3NLyVAocpWzN5dVBGARKfN41ufVfJhFd2tKe9DUyUZE8zQDVVCMb	17733	3NLvpcuB7rzTKa1TjkM5eKdszH7ddWyjcrPRubr1JboV1cVKiiaW	484	1193	302	6301	12463	jwmMPwsBCafqAtXFy3b2vz5nN56d8B5TzTyndJgXvG6TGxjip5m	8964	12665	12665	1618218900000	orphaned
17738	3NLtt129DiUzd1SLu1miXQBpUp8tG4hynRaxFcafXZXqKNX25adZ	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1624	1088	302	6301	12463	jwMtj7hWUUJXzaD42ugo1GnkEgvP3SBcYRQkCC7PbrcKNsvZyPu	8966	12670	12670	1618219800000	orphaned
17746	3NKVbu2ssC3LLAWhKGzAyFkCHHNXpD5iUd92UeRnhrBBSeD8X9yU	17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	1406	1393	303	6301	12463	jxzS3DvJfZcHQpwv1Nv6yWsxsAxMrhkysAi8b5Nyjda2yn3Rb8Z	8967	12672	12672	1618220160000	orphaned
17753	3NLiQHuVvJmk2eswtWUdgijTXfCEqWHngyQ3qhhyjmiZi4Sb9AeT	17749	3NKV3LmP1C3mSqoxGcCd3YEVoSUDAf4D76eauaPaW2yyC8CKGwSn	1451	1292	303	6301	12463	jxCX8oDfLzWvPoyPSqapKdfk1FARcxPZKUAEX66QoCFEm43mGLy	8969	12674	12674	1618220520000	orphaned
17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	17754	3NLxptnEzRCcYJwzJ4g1Q2SokXs6xeAcXzN2C4vJQ71yEG2RcGF1	1509	1320	303	6301	12463	jwAGUB79MAxgx1EjouGvgriGULnVeiHGizKTK1v7PcMUwom6Hab	8971	12676	12676	1618220880000	canonical
17756	3NLpYLn8JYb6pZgCr1mU3YcsCQyDokWsf4gKzwG8RyrG3YuRSKg5	17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	1406	1393	303	6301	12463	jwAcUw9EeXsMKcVGwVpT1Jcmgt1pQupJtGvYDxAUvCkPHNmsxfq	8972	12680	12680	1618221600000	canonical
17764	3NKjbttZFy6WtswGMf1ZyJp2vTatX5QccF2f8BuEbtC637vzY2TP	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1559	1353	303	6301	12463	jwqK8FehwVeUW8imjDDmUrUH1HqjZXMkNtaM296U5MP79oVSNaq	8974	12682	12682	1618221960000	orphaned
17768	3NKaioaZi1iKA5e8Pe2a8d1PPFQwSsMKSPPpLZKJx81SM1yqgKpf	17766	3NLdZs75UPHjzWj8sfNFnkLsKETMh6XuBTVQVcispacibcRNysRp	633	1384	303	6301	12463	jwmC1N3bWRxNo7bK7pp9jkbsKPbb9vLwZhj11cByTyi7CfSDRP8	8976	12686	12686	1618222680000	orphaned
17771	3NLqSgx6gJ3owWM1hpepN3NEYHdyAf9QURUqcY4bmzLGYufYLwe6	17769	3NKvBQKKc8c8LCjyeHKeX3m99VTAdgY1fcviCTqysVPRR6sLE4X4	1631	794	303	6301	12463	jwfq5mnF65KPXJCiB3TVtVy9K7TgZGCnctEF4bzATpcUqA2BNVs	8978	12691	12691	1618223580000	canonical
17774	3NKNSGDTAMkbondsrDJRAbZpZvUVewHZUtvmC6oPoF3a95AsVMBX	17772	3NLHf28sZNr12yw8VGWAKLug91FkBmffEFgUaahzMdrYZsEcjUh8	1553	776	303	6301	12463	jxwatf4NJgu7SajwScyJv2KJTRFanrLXBk9ot89HGzqQasKZH9n	8980	12695	12695	1618224300000	canonical
17776	3NKv8Eg1KkV8e1xwv4Ea3s5N9cbuVidTvbkGFTvaMNGdWxbPqnbu	17774	3NKNSGDTAMkbondsrDJRAbZpZvUVewHZUtvmC6oPoF3a95AsVMBX	311	1307	303	6301	12463	jxfkf3sS3FC33jqpFPk3du5VTcGFkQWwBa7fLr2oFbiz7JyscmN	8981	12696	12696	1618224480000	canonical
17781	3NL3iCMS6Gv9kAn5LV7QwLUyrG2jWQhYNpELA4zYqnWgKGSrrGcn	17780	3NKJXJbS1BDGzKSQTrrCjNVjaRTLHLAinnFLFH4zUJ7g2hM8s5oy	1589	1286	304	6301	12463	jxCqWBXrnYxCTikrTmfqhKz7rmdRQoxwwQqV92ncb8tnUNpNqR5	8985	12700	12700	1618225200000	canonical
21345	3NL2esgbbgCFsMGVs3hxJBbi146cG2gHQgYf8J9rNQ77YqiXxPRx	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	1483	1276	389	12463	13575	jwtq1QDg2YGRXQRCyNCaWBTVAJThid7wgzJDEFteFgLgPmWSrLz	10713	15084	15084	1618654320000	orphaned
22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	1608	1043	414	12463	14501	jwiMqgy8rqUDTpftAARg5Tx9Eh8bKaYzJwuTHNsi6fgCHNbdVQd	11208	15779	15779	1618779420000	canonical
17725	3NKfCizTHz7Txw2WgU6wgcpk4cHDfJMxrEWPL53Jkjgnezk6qk2b	17723	3NK4aHcB69ztT3whsHcgT7kVZHfDmxGugCks8S74Tay5LoydR7ch	1402	808	302	6301	12463	jwjkxaBqHeer3h5WAy71jkTEyULHUfntzkm4G3nc3UihuU54a5f	8958	12655	12655	1618217100000	orphaned
17730	3NLrQvd1E7RUtNMEsXLLaeAGW7FiUVorsY45cmjBDne7Kam9EAKV	17728	3NLN1AeWjyBsG4R4BjHxzNAiQ239hFkUtCAGZ2cG6D6LbgmpBosw	1448	1311	302	6301	12463	jwytYQngubKYsPeusALaFhSX59qrNcMjrcd4FGyaTi49KAQu4Hv	8961	12659	12659	1618217820000	canonical
17733	3NLvpcuB7rzTKa1TjkM5eKdszH7ddWyjcrPRubr1JboV1cVKiiaW	17732	3NKNJZXA9b9Pjftc9vwM5LNcDVoau644tweFh2STt7U4jo1eFcsM	1637	816	302	6301	12463	jxQh1xCu4GzFK3nf1otjJ5wcBpK4w13xs798XoSRSr8YwvU1eAQ	8963	12663	12663	1618218540000	canonical
17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	17734	3NKdvScgHe8AzdTtKmdckk1gp4vkqakq8LHCsr1zLLMdmQcr8GsJ	1631	794	302	6301	12463	jwQsGNXTit1pjVvPgekc9TnZcDQbcaJAPpSu1KY7drCFxcGbXLQ	8965	12668	12668	1618219440000	canonical
17740	3NKdQHzFEkjLrqLeu45s8dQ9MGG5v4xfsrDw4JAbhse2Q6wAuZt7	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	532	1303	302	6301	12463	jxU1LR8enPhzn4qMsTWHvcu8ot2vbEtB1CUajis4QqEujaGQsMT	8966	12670	12670	1618219800000	orphaned
17747	3NLWDkvY8ktGVUuyhyKBZyo6emcoUcEBRvPQmuMguncKnavzAjjU	17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	532	937	303	6301	12463	jxTS96b8Gu2ECpTaSLrueK38sVKyCz8gZgULwustByhAgcAoE6U	8967	12672	12672	1618220160000	canonical
17748	3NLZXttXFYmGfcNKgsRdavEEjL8XZWpEpwQ9LLqGDS1Hwo79zHVn	17737	3NKJAZERz5xvxt9b7UeSZtRPwEsqLpVNW4qm2PFgyM6HmfuNeqUU	532	937	303	6301	12463	jwjLtSaX1vbpv7Hoa1kgoYxoCZaYki4vhDZos5qmdfUvFwSUz4H	8967	12672	12672	1618220160000	orphaned
17750	3NKbgWdbH4Ao8u5gQurasqG56iQagbYpKgyD8y9HPujyZLzG14Zw	17747	3NLWDkvY8ktGVUuyhyKBZyo6emcoUcEBRvPQmuMguncKnavzAjjU	311	941	303	6301	12463	jxtoA6F7EhnkbjJJRrEzHSPNzoEyuVJfgAUo3fNcWmyVz28XvCX	8968	12673	12673	1618220340000	orphaned
17752	3NLKCQ4UTkCg1z52nwDLB33CnMkGaRNoTG4CNoV2JUzFS5kc4Cdv	17749	3NKV3LmP1C3mSqoxGcCd3YEVoSUDAf4D76eauaPaW2yyC8CKGwSn	1670	1282	303	6301	12463	jxiXDpMmyrDau9WLH5B4PwY6A7cxHLA24rhgZTqcPDmoh1RguFc	8969	12674	12674	1618220520000	canonical
17754	3NLxptnEzRCcYJwzJ4g1Q2SokXs6xeAcXzN2C4vJQ71yEG2RcGF1	17752	3NLKCQ4UTkCg1z52nwDLB33CnMkGaRNoTG4CNoV2JUzFS5kc4Cdv	1668	1370	303	6301	12463	jxvddFdfQJihsoxFg2zKDEWrjYBvstedtRWVLNigg1bEfPWJJJC	8970	12675	12675	1618220700000	canonical
17758	3NKsYZMmkL3rKiitiF1unuob2uojKbubq34hXi6GDouyBkeW3MDK	17755	3NK7AiRJHsctSoptQ5XgkPGLRj9DhiWT6rt2iSS3PQq7sAMyik5c	1602	1003	303	6301	12463	jwsj534zmbjFQyergXPyMC68g8YShTJdErESoGxpVSfDLMXpDwM	8972	12680	12680	1618221600000	orphaned
17760	3NLuL4p8YfbR6mmk23y5UCwRkzUfM94xt3SQ41eHrEsUuC2cT3um	17756	3NLpYLn8JYb6pZgCr1mU3YcsCQyDokWsf4gKzwG8RyrG3YuRSKg5	1483	397	303	6301	12463	jwbALSfNAm71MMxffGNzEN75Sdwqxioh5WrTsYuNB2J2uiP8zyb	8973	12681	12681	1618221780000	orphaned
17765	3NLddKoeLA2ZWBmaEKrz7cEUL68JUbukq6vmafNvqJWyzppoESuy	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1451	1046	303	6301	12463	jwttKxjkhsFWUmWYcVSZfuRu9PUYRTE3cY1uVMxPrs5W3QyJinf	8974	12682	12682	1618221960000	canonical
17762	3NLRM7XynzDwBXh1VJs8ksuM1bJwDJ971LMovCMCrZjVsRK7ps2H	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	1406	1393	303	6301	12463	jwhrwkHcAx43byjf6DzXcqQY1Div5nKuJz8WN2amjwUNtTs32YN	8974	12682	12682	1618221960000	orphaned
17763	3NLXSW7Amqoh4qucb6u6xKR9TNu4a6B1NVviNN67HHxEssFHN3Kz	17759	3NLZwhryuFBwnaxP2h4gdQN8G9AS4MDxJxDSqiYMb3zf48kQ6Sp3	606	1295	303	6301	12463	jxUFy1PpkuKPF3o4drBtnZWR41nvi3sxTeaENssrLWCUporhQnH	8974	12682	12682	1618221960000	orphaned
17766	3NLdZs75UPHjzWj8sfNFnkLsKETMh6XuBTVQVcispacibcRNysRp	17765	3NLddKoeLA2ZWBmaEKrz7cEUL68JUbukq6vmafNvqJWyzppoESuy	1455	1332	303	6301	12463	jwkVBL1UKRiSemK5CgwxECb6MxkcxEaTyN8rvRQeZoysc5RbaGk	8975	12684	12684	1618222320000	canonical
17767	3NKM8WVFt9tm7tsmh2vNJcBCRmKU14WYC81eeVftveqvZy6HsXJC	17766	3NLdZs75UPHjzWj8sfNFnkLsKETMh6XuBTVQVcispacibcRNysRp	1406	1393	303	6301	12463	jxAksvJpmDsmfAR2VRxjax2pQXjnFfwhwe5HizsPEdh4wS8mVuz	8976	12686	12686	1618222680000	canonical
17769	3NKvBQKKc8c8LCjyeHKeX3m99VTAdgY1fcviCTqysVPRR6sLE4X4	17767	3NKM8WVFt9tm7tsmh2vNJcBCRmKU14WYC81eeVftveqvZy6HsXJC	1631	794	303	6301	12463	jwngVMtHXTmYzNrdV7hoF8mPb1eiNrLiSVrQ8Axo5zi1MVmEb1b	8977	12687	12687	1618222860000	canonical
17770	3NLtQbBASUHSs4pXjCG461UTjeD6mGRD9jcKtp2JbhNpcjRwuKgq	17769	3NKvBQKKc8c8LCjyeHKeX3m99VTAdgY1fcviCTqysVPRR6sLE4X4	1407	1395	303	6301	12463	jxUTdqKc1tvAHVdzr1CuNjU6J14d2kN1VGsw7YaDf48WUCVXDFZ	8978	12691	12691	1618223580000	orphaned
17772	3NLHf28sZNr12yw8VGWAKLug91FkBmffEFgUaahzMdrYZsEcjUh8	17771	3NLqSgx6gJ3owWM1hpepN3NEYHdyAf9QURUqcY4bmzLGYufYLwe6	1406	1393	303	6301	12463	jxm1hRfDRZyNiDkWBPXediPTjaF1EAzJoe6gQrfnjzb2uhrH13J	8979	12692	12692	1618223760000	canonical
17773	3NL4912t6k7EpGjTUyYz4wUeAiZzwmNdB821P41frFCwhcBYCBBQ	17771	3NLqSgx6gJ3owWM1hpepN3NEYHdyAf9QURUqcY4bmzLGYufYLwe6	1579	1389	303	6301	12463	jwnhhJgtaaaEe8t2k16YUZhXWcyWgo94y3uiZwuajZdsiNdTeHn	8979	12692	12692	1618223760000	orphaned
17778	3NK9JNBUApguQeLpJE6xKETePhKaU3va1JYzUYA5Kx1gTsM3HDVc	17777	3NKeTNuQv6T3xU8cjNWjzn9N2g4tzhQ9CKjUshgHnYZgcugtmsG2	1599	1161	303	6301	12463	jwFHKQJaHq4AyeQ8SKADi4LbaxiU2vWxvM8sRe38SZUCyQWGLMZ	8983	12698	12698	1618224840000	orphaned
17780	3NKJXJbS1BDGzKSQTrrCjNVjaRTLHLAinnFLFH4zUJ7g2hM8s5oy	17779	3NLFEMmSqBJXC8P4Nk7L4VkHYu98GtKj3zi9gNg3L6AEkW4Kgi8x	1608	1043	304	6301	12463	jxc1vR2295oVL3L4nA2iaWNMnf8huh9Ec6jyMZpsAnMDidH8Spm	8984	12699	12699	1618225020000	canonical
17786	3NLHLARUVR9LFZzNHWzyUtYpELuW3m4qJwKYogefqujo1JxQJvxN	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1439	1279	304	6301	12463	jwdHo7ayWmeL44pr7i9br7Ry8nyZSZBAFWGkBXct7DGzBso1GUU	8987	12702	12702	1618225560000	orphaned
17802	3NLLZQH2Y4qJ8iVQdejQg1pC5uZ8thqneGsDGTT7gR4ZzEx3Syya	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1581	777	304	6301	12463	jx68MKiwimSFK61a1q6G7ADhYN6CSMHrD8WaN1S582QPUnEUqcq	8992	12708	12708	1618226640000	canonical
17799	3NLmq3QpkwZyVHUzPQi1Qoe7TARv1rLVfQYUqsnEDMZn1dPTf4gR	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1406	1393	304	6301	12463	jxudug7wCeZv3f2Nno98aTrLTNasj8mHKWPkGwV1q8SRpNYFbnx	8992	12708	12708	1618226640000	orphaned
17806	3NL1hTbEdTFyhMJ59NuAAh4XtbeuWYob5nMHCgB8ZFg5TqGzMDfT	17799	3NLmq3QpkwZyVHUzPQi1Qoe7TARv1rLVfQYUqsnEDMZn1dPTf4gR	1648	1158	304	6301	12463	jwK1rPCnvi4YCFpQeFecZXNr8PsyabGUzHVprBJjYxMcw8LjFbr	8993	12709	12709	1618226820000	orphaned
17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	17810	3NK3boAK9cGAo7TkjTd7TFExjjnRNdP9gFrUAnMkF5bD4zyzT91u	1672	1285	304	6301	12463	jxY2Qw7LdtvxYUhzygVFMecHjMTw6w6xPEgK1EYFu2i8wd6oBCP	8996	12715	12715	1618227900000	canonical
21353	3NLYpvj3pnnNkmBwkXVsmey11naF53eNn8bA3nFTEDY7ZPmkEq5a	21352	3NKKLAB4znymkjAiPKTGtjqmq3iFNAx6gC6g5S9zbSgyhenGLNkc	1501	1360	389	12463	13582	jwbPbWHrxVLqC5Y8XuPNPesx9DSjPLEjbQNCrdD8SiNindFeZwr	10717	15091	15091	1618655580000	canonical
17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1540	229	304	6301	12463	jxacc44PvqFhsBnpZRWs99F3oqAyBrZ13s2nV9YQt7anZfQ8dBL	8987	12702	12702	1618225560000	canonical
17785	3NK4QjEmZV1xGnHhTiJWFh2osBi8kLZ7mSSjuwVibymHB9ECujMx	17782	3NKgBxFogAYcJwSj9ny5Pyiwj3f2aGSvkVbdWhH34VKycNHQMErD	1549	1362	304	6301	12463	jwf46Y5fyZy92Tc2meEcA5aS3JiY1Uy54Ue4MnBX5thb1QwsrGd	8987	12702	12702	1618225560000	orphaned
17795	3NKKboktSyLqjJWmsySiNGeCtN2iwQ8YAPAVBtJAfvFiNeRBFeMP	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	1403	792	304	6301	12463	jxbsndTqZzLZvCRLpuQvkV3PN1qawwiaiug19MSwV3uYDipKLBo	8988	12704	12704	1618225920000	canonical
17793	3NKteAhPtfWPR8SrsqCWT3s8xjwy2HM7R7iHkuCo9w94s5aLfSXj	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	1529	950	304	6301	12463	jx4b41NVnd5HyYJosd6ixoQ4mGsVG6QZ6KuViYJkzQQ6VK5FuKD	8988	12704	12704	1618225920000	orphaned
17797	3NLjUAUYtxjVs8mqDankxtFh2Lzj4DRESFjw7h9Ua5miHt9NXLv8	17796	3NK3quGv1mE2zsHvqs2q7oeNytLEXc6a5tejieHsRUVoTFqVLEho	1590	1300	304	6301	12463	jwtRyrP6iEwPaT4s1uLhvkUjDwrgcryKNnXNS4LXYmGTBh7EiBL	8990	12706	12706	1618226280000	canonical
17801	3NL5KxPvbE9Yd7AtLqtLE699tDptCvzWUvb5gxrE53a1JuieKgZ6	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	470	1309	304	6301	12463	jxh4QSMuQeQPT7SbhmLv7kWotezZrjgYqrPWaFssoKex3XvVJX6	8992	12708	12708	1618226640000	orphaned
17807	3NKZbKbZXTFttAUxWfzmNVh5KcY797sho8ZyWKWTzF6K4fkiwbWX	17802	3NLLZQH2Y4qJ8iVQdejQg1pC5uZ8thqneGsDGTT7gR4ZzEx3Syya	470	1309	304	6301	12463	jwufc5X8vuPnb9HZtKdwaiQrpfsaBhzfPXqhaqeSYRCaR7urGP9	8993	12709	12709	1618226820000	canonical
17805	3NL91q7FG5aUQpY8St5UFEF2Tbyt2QRYdaCj3trABVM1Mzz13yBT	17799	3NLmq3QpkwZyVHUzPQi1Qoe7TARv1rLVfQYUqsnEDMZn1dPTf4gR	470	1309	304	6301	12463	jwm6ByzNtBxyCXkqLSHPMmi8maGQ3t3KhqoxBKmypQtVbdEtbd9	8993	12709	12709	1618226820000	orphaned
17816	3NLEbLJSPLyJuEZXsxRewSchNA1bSV4q46FyY5bCwUMnh7ZhcXzB	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1419	813	304	6301	12463	jxbuGFLSciD5xxCtrch3nyMwHwottuCXbdokDSZAxjm1aNUZZEF	8997	12716	12716	1618228080000	canonical
17813	3NKjX2akump6n8PGedBrARjX8C4QBmZSZm2EMRDjUJS83HS7AptK	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1476	1005	304	6301	12463	jw8oioyRQFHi4kek2G1RZNw2DJTWnb5JAR6tQPvjE2jRfEjQu3t	8997	12716	12716	1618228080000	orphaned
17818	3NKnajEvcqRjxDh7ztArRKWu3iV2Yk7BKzo8Ns5kXgQiXnQBQcJe	17816	3NLEbLJSPLyJuEZXsxRewSchNA1bSV4q46FyY5bCwUMnh7ZhcXzB	1637	815	304	6301	12463	jx4yUKs6efCmG4a4WidEXdZjFeEyw8fHfCamQWWXst1UdKXAFvu	8998	12717	12717	1618228260000	canonical
17820	3NKtsLaLgw8FQVVP3ReG1w4TNSh31692bRhhyBX7XqD16P2CW4PA	17818	3NKnajEvcqRjxDh7ztArRKWu3iV2Yk7BKzo8Ns5kXgQiXnQBQcJe	1553	776	304	6301	12463	jwyXaeJG5Aipgk9wLrmhcKr4irmbm1mcD5y2KnmqyZ3Vf5FdxuY	8999	12718	12718	1618228440000	canonical
17821	3NKKwhdQypyFfQb7q9fk6Q9voLo9c1futpa8Zygd3JkybCspGNLq	17820	3NKtsLaLgw8FQVVP3ReG1w4TNSh31692bRhhyBX7XqD16P2CW4PA	1406	1393	304	6301	12463	jxi8ZReAoy5b78J9VHn3YJd8LAmnJEUhfvdX2uqakpihKJcpf76	9000	12719	12719	1618228620000	canonical
17823	3NKx6AvJkEqCPUxHUQvCqH1amjkMZG92Kf5WQicWPa4W4F3ZhDEM	17821	3NKKwhdQypyFfQb7q9fk6Q9voLo9c1futpa8Zygd3JkybCspGNLq	1407	1395	304	6301	12463	jwwLSZ5vSaAg5Je5n4kqmEDJDgv9Z5j661EzudLpqwnQSb6Lu1X	9001	12720	12720	1618228800000	canonical
17827	3NLb6bfLWPHhADWfNywUMN8ZkRrtdA1WLjovwiYvRvcBAXizHLwU	17824	3NKapUM8qYkaQVMiZxmbErifs8TSh2MtH2W9BBmS9hDbs2YXSyZ6	1601	1388	304	6301	12463	jxti8RjaJP6p2oAUjD4rNUr1CgqbVQUhtRd3PRLfBhZ6eX3hTCj	9003	12723	12723	1618229340000	orphaned
17828	3NL6bxJhj1PFtV8ABvh9BPL31UqxSJK6mAHhXMsCcbHkVp8ZrHC8	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	1402	868	304	6301	12463	jxUFgDyt26RQAR63Y4w9tGVSQoev7SMpCz8w4CXprRWYdESFEuB	9004	12724	12724	1618229520000	orphaned
17833	3NKWf4azAupKSk6SXYEeNK5dwbDAag34TmVymweWntFnj8nNjYBK	17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	1503	911	304	6301	12463	jxhuDh4UZVSe2C7Fgdi3W1swFjRA2QbZLFd3fDoCmry6VDmNJBU	9006	12726	12726	1618229880000	orphaned
17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1581	778	305	6301	12463	jxNDvvgnSqot74mFVTGh9GPWjDqDPmjeszxJ8siTTSwKRqW2sYn	9007	12728	12728	1618230240000	canonical
17838	3NLbvoAMd8aVqcTQwiDjyavLkUwPoejY51B5R8DEw4ydjtwCQLmW	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	470	1309	305	6301	12463	jwnTH8jxCxZQJqw9viLXKRNdKrAYXFGTc2N46nuVpnKwg6orqUv	9007	12728	12728	1618230240000	orphaned
17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	1546	973	305	6301	12463	jwyvEqyFL9mnNJgVHsXeaQHYgdQJCdFwE8NkxAX4vYAScPcrTyG	9008	12729	12729	1618230420000	canonical
17847	3NLvWUgQUbphBGEwySjAwMbx8WdSbqQ8VUcWx66rCy8Gyg4DL8VD	17837	3NLjkqXzc3nzadwdFJ3xnKaLFHHzWzAZynBffUS85iFQKUff8w4Q	1403	824	305	6301	12463	jxZM47psPnLA6BQB1ERABeGwnpqmT3SMaNpxB81b75Gp4hsU2A7	9008	12729	12729	1618230490001	orphaned
17852	3NKSdFb2vxJosVtJMFFEo4kaNBro3jcTCRGTMnLhzYzb2XJYS26F	17851	3NLFWtgKkbqSDMTH7NkA7iV5F1dhA6k7tJjzSbHQb8kFfwh3Jowg	1406	1393	305	6301	12463	jwCGPMmxKaRt5QtwTH4PGQygf57uH6gNiZLQyNXKKvsA91dykf4	9011	12732	12732	1618230960000	orphaned
17857	3NLXXAi9XhoCFe171Dxo9ofCvCeVTVgUjBUh65wCPpHWS3E4SDmZ	17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	1523	1195	305	6301	12463	jxsF3E3rYgtGw8Kvi85jxahU7H9EgA6GimifDZxRHdgYPfvF3D9	9012	12733	12733	1618231140000	orphaned
17862	3NLgPSQ88YY85oy4F7A4aGZdWpwKegJ6G9D6ZDBV39UwuteppHeV	17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	1406	1393	305	6301	12463	jwrxaSknkD93V3dYSLAA5keR51SwQAQmSzhvzckEFu36UAjW9om	9015	12736	12736	1618231680000	orphaned
17871	3NLXpp5w2NT8UiV6N615N7rt67tPupi3xgSRorQUwr8wDRPGsn4i	17868	3NLkFB3EhbF2XdBsGbLFJsWc44ne4VGuy9iNwdY5QDNW13pskokY	1458	1077	305	6301	12463	jxfAJu7XEtMg1erqoHt9LunJXoeTGrFNt2tYmPt8e9DiPtLeXMx	9019	12743	12743	1618232940000	canonical
17876	3NKksPrs362UGdqVptqsqQ4uqJMNjCPnZSnvCQsuTkviJcrS7YYb	17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	1553	776	305	6301	12463	jxuM41yBvCseD97t6SWuxuumyiTcb3yQK2HAtRBivtskcdqLP8f	9022	12746	12746	1618233480000	orphaned
17877	3NKjUeLwKLeRgnMmgNCBFT8WDa6RPsbqzENJbkzbhcQZiV6PFGtN	17875	3NL5gS76FRmbLgU8AFSZ3dA9bP56Eso3Qg38FrZQVBLZwVXr9J3Z	42	1361	305	6301	12463	jwnfbuUN9uHGg9Wwzt6DFPYBcH1qC5XuTYCCiLKATezr8qhPfzN	9023	12747	12747	1618233660000	canonical
17883	3NKWkUZjErNe9ZQ7Xa2TJpzsK4tbM5ry2DAPEkZbCUSz25qAMMSm	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1403	780	305	6301	12463	jw9HvnjRZXjTiy7tBWcsYXGW5Zghj9XeuCZbCKs6fmwP6KcS2z5	9025	12751	12751	1618234380000	orphaned
17884	3NKrKaKKNpCiWuzroXeC2tYRse1A8NhnjbFPUsfL13PosaeuexS6	17882	3NKY5QqTptMoauN2Jc9yYw36bXeuSe1ahL4Vja76zGeheb8dxVbz	576	1109	306	6301	12463	jx76Yh3ikzAcZt63MfjnEJSkmFhPtLUeppGpcKBWgan1eERs3eF	9026	12753	12753	1618234740000	canonical
21737	3NL2TXNKd1PKM4oE6xoh9tobSkqrQg1RC3f7Mdrewk5pjYdXpL5v	21618	3NKgWSebDqmiKojcsCaRSpJd1oB1jhybctuQ8degBg3juimRo9CS	1564	1338	390	12463	13910	jwx5LRrq3qx8Nbgqcb238SMrdM4PwwNXXYsz4PazSrmpfZX1y5M	10717	15325	15325	1618697700000	orphaned
22385	3NLRbd61CMu32ngBq4QXPQD7soViawAGohwySQDtJDysCYaLYne9	22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	1477	984	414	12463	14500	jx9Wn29RvK5RnNnubDHgVxFNCGqi1FCkVLi8KQtEDmccPWhDEJ7	11208	15779	15779	1618779420000	orphaned
23224	3NKikVmzN5D1PYBDWpv1dYnNpgQADD1HAb2WmXVeDZT23brKaGv9	22586	3NKkLZcQRggZ5cjjKExz47FWepb1HX5WxRv6BjYYxaxMBvq6pnSz	1547	1378	420	12463	15245	jxFjdeebj1PhPFAZZYa9qtzGv4PUanGGDe53arJ5esJeeEmwMZr	11301	16319	16319	1618876620000	orphaned
17817	3NKXQRbRrCR62Nw26ySELeuwez833sH7zYvmn9js2zKQrqnLADLw	17751	3NLPZdGZrEVqJ9TxB7QSVGMJUeDL8mDtKT2hfkxUhjjfJReykvPg	1673	1242	299	6301	12463	jwsGfujodT2VQ5FoxoLg87LRiRHqPNMoMavUdx139mccpoyKmi7	8899	12716	12716	1618228080000	orphaned
17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	17797	3NLjUAUYtxjVs8mqDankxtFh2Lzj4DRESFjw7h9Ua5miHt9NXLv8	1637	816	304	6301	12463	jxfh4DhuEfmiS1YWtcuR2hYzqKEsye6jX8wJ4D88fXWEoGLAFGh	8991	12707	12707	1618226460000	canonical
17800	3NLYhkiiCKFyyY15mab6kLokGLLUV3kjQouK7WdQwW1v4dixwtYV	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1594	1326	304	6301	12463	jwERjYHZ9Uk1E7v2k1KNPc9FM8yR9f9T2ZJfBbe1kCccH2hEcox	8992	12708	12708	1618226640000	orphaned
17809	3NKx6a2bXxduQuYJEQsaES36A1QrLiZoKiaD7c9hnK2hYQfyQfge	17807	3NKZbKbZXTFttAUxWfzmNVh5KcY797sho8ZyWKWTzF6K4fkiwbWX	1407	1395	304	6301	12463	jwWedSm3ApHiRvXWCE2A4XDVHRza9g4dRUSML91aLbfPquxfDFU	8994	12713	12713	1618227540000	canonical
17808	3NLwcyhHYyc3MGwbL7N6etjZsEKGJUbSqNLbw1gYF4HvdbcyrPHw	17807	3NKZbKbZXTFttAUxWfzmNVh5KcY797sho8ZyWKWTzF6K4fkiwbWX	1555	1347	304	6301	12463	jxztWJTSKWp9ueAXZYMCJadP3v4316aKv7ZKzRJedR8VpP8qrX4	8994	12710	12710	1618227000000	orphaned
17812	3NKDzMWSzLGuHQtnrskPTvpUXGtteVCjerexR17WKEhGaRGQ1f4G	17810	3NK3boAK9cGAo7TkjTd7TFExjjnRNdP9gFrUAnMkF5bD4zyzT91u	1609	1333	304	6301	12463	jwnGCDXW5GD4EcJB3i3wnAi9sW6tdPiyboFhKp2ps1QsUix8T1R	8996	12715	12715	1618227900000	orphaned
17814	3NL7uGqcRpZraaFrApKUzMViFu6GWAmQ7zVWs7t23yTSBvWfg68r	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1627	1385	304	6301	12463	jxAH1svKoem1w7RqqeX5MuBQWas2cejzujLL4YFMFibwo4SURvu	8997	12716	12716	1618228080000	orphaned
17819	3NKFULBwx2bbuiodVhtD7WA4iySQhYLgpcj1Zncdz8AgUMVwLSFp	17816	3NLEbLJSPLyJuEZXsxRewSchNA1bSV4q46FyY5bCwUMnh7ZhcXzB	1506	1127	304	6301	12463	jxe7nhgJwx3mUnPGM7XdD4616YVDWWXH6RndCMxBdAj89mWBjrK	8998	12717	12717	1618228260000	orphaned
17824	3NKapUM8qYkaQVMiZxmbErifs8TSh2MtH2W9BBmS9hDbs2YXSyZ6	17823	3NKx6AvJkEqCPUxHUQvCqH1amjkMZG92Kf5WQicWPa4W4F3ZhDEM	1589	1040	304	6301	12463	jx7VTaZENuSFbN7rWckgm7bddCbDkLCiyevgdc8t9w9St1xLMVh	9002	12722	12722	1618229160000	canonical
17831	3NLmQNXecmXj6JMvp8iZjVm2mJn16gEKCXn8j93C31vQYCsjBLfA	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	171	1374	304	6301	12463	jxjfHLqE3jBsFsThxPKH2HMw6RwTDqpWV1LwMompeEHmRh1MPkW	9004	12724	12724	1618229520000	canonical
17829	3NKxjCjpsGRsih9fyrp7UmTzMRDTVTDSgvSzywbDzwhNgCBQmRnW	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	1403	824	304	6301	12463	jwbQWnCVeaPPqF6skT5oxv8yJLQJfCM5D9H5rALbpWXSLPGKtUB	9004	12724	12724	1618229520000	orphaned
17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	17831	3NLmQNXecmXj6JMvp8iZjVm2mJn16gEKCXn8j93C31vQYCsjBLfA	1656	1097	304	6301	12463	jxaoECruUxEDm7uFhwireAzvv5n7MzgR7uNhCfVzQvMiMT6osXb	9005	12725	12725	1618229700000	canonical
17834	3NKtE7ifUyjShHjyAuboVTEMvmymRLCrDi5nAhgT8kyRroNk54Ac	17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	1503	911	305	6301	12463	jxhuDh4UZVSe2C7Fgdi3W1swFjRA2QbZLFd3fDoCmry6VDmNJBU	9006	12726	12726	1618229880000	orphaned
17837	3NLjkqXzc3nzadwdFJ3xnKaLFHHzWzAZynBffUS85iFQKUff8w4Q	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1654	1214	305	6301	12463	jxwNsCDo7GzPQd4qGyPauk9QBZVyPjL6ZXkcudXpYnFLFMRBbgT	9007	12728	12728	1618230240000	orphaned
17850	3NLjV6sm4ucxd8127i3djhQMvhCXTgAaS9z77wt3FBbGy29oDGak	17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	1648	1284	305	6301	12463	jxrEpajhwwFoMkHG3RFv4zDaniKHfL9aoU19QsYApWAJLoJnNJC	9009	12730	12730	1618230600000	orphaned
17851	3NLFWtgKkbqSDMTH7NkA7iV5F1dhA6k7tJjzSbHQb8kFfwh3Jowg	17849	3NLxcKhpuhSad6SUyyUnckdtprPX8RKBZLEyYo19jGNav897wVUX	1670	916	305	6301	12463	jxrDtvbcX3iDBd2FB15Nd3Dy3ywBUmy4t9VSWnQ4sEmuaSKWLPo	9010	12731	12731	1618230780000	canonical
17856	3NLtJgY9zFHhVn45w4YcCFLu1URciYqsCTz4iKsQUHrkX8HZAUfU	17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	1619	1275	305	6301	12463	jwtxq3D5XWy4qFXqJhfA7vEFU5BfydBnuRZv5VVvdtHXTvYmxVw	9012	12733	12733	1618231140000	canonical
17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	632	1016	305	6301	12463	jwv7zJohWjngYCgCeheHSSMQuncz2a4imvHfoaGYtaq56SkrSZu	9014	12735	12735	1618231500000	canonical
17870	3NKEHPCTdkCiTQm9EGxjBkaFaHUok9QV4vjkpQr3Qs4gupdoECN3	17868	3NLkFB3EhbF2XdBsGbLFJsWc44ne4VGuy9iNwdY5QDNW13pskokY	1406	1393	305	6301	12463	jwRVXEqPyMvWYQB8ZENQD1fGsUdvFMrQ6iVMFEN5CKxDFTsAMx1	9019	12743	12743	1618232940000	orphaned
17875	3NL5gS76FRmbLgU8AFSZ3dA9bP56Eso3Qg38FrZQVBLZwVXr9J3Z	17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	1407	1395	305	6301	12463	jwdCsrUHWAVSaPfMh2WfJ2ycU3VyGZ2974wnrP7WdPVBGhwSdfn	9022	12746	12746	1618233480000	canonical
17882	3NKY5QqTptMoauN2Jc9yYw36bXeuSe1ahL4Vja76zGeheb8dxVbz	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1467	1130	305	6301	12463	jxdEWZCRgPzu4QbYyrD7c2sFiETpWG8qUyfbzMD7xSg52hLSqWT	9025	12751	12751	1618234380000	canonical
17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	17884	3NKrKaKKNpCiWuzroXeC2tYRse1A8NhnjbFPUsfL13PosaeuexS6	1657	1344	306	6301	12463	jwHKZu5WqHTk6X1WUQYEc5ovbZFsvZ4G7Eiu4PE3imdySyWenyz	9027	12755	12755	1618235100000	canonical
17892	3NL5FUUHJtpGrYySQVT2wjZu9Y4PBqh5ypg5Wpobru9iGKSUK4kH	17887	3NKCkBaRaBrQT5Wo6r4MvfnyCdYCxY2NJpQRpwmSi7HzLhTPqqj8	1670	1282	306	6301	12463	jxvMUX5ZmBw2HwQCZ25HyXGh6xExDcJuMggouCtKZxiSHNxjwoA	9028	12756	12756	1618235280000	orphaned
17893	3NLerus6C2cscoSQFYpwLq9Vzwm61VxiCExDPx5DpgFcVQ1ngPnL	17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	1407	1395	306	6301	12463	jxePMHjvtkm1XmG5LnkGETdAkejj7ToDAN3aE2K2znYjJZkWdJ5	9029	12757	12757	1618235460000	orphaned
17900	3NKhd8zpGwZcRPYGhSZyafz7Ydvs6LEzW6GxK2s21riTjwtDoUaD	17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	633	1384	306	6301	12463	jxpTcuHmzVDxET2KafonhphggPUykwcZkKtgeUi66gM94x9FfRc	9031	12764	12764	1618236720000	orphaned
17905	3NLCDKfa6B3uZux3r2wZ8wQv1MHeYejWdFywYLZeLQgQQi9Ar2Uh	17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	470	1063	306	6301	12463	jxZmJnhg44K5vSFGK2XswsdstUAsuh4cYUUB9zE8emiqYUnu24v	9031	12766	12766	1618237080000	orphaned
17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	369	1066	306	6301	12463	jwG9NGw3zQFNxYfQihKhwrRx1P11hP5vKyfLV6bMenSzsLtEwL1	9032	12766	12766	1618237080000	canonical
21366	3NLbYSA86kZijBeh8hrcxbn8VQP2RPaB8nGsuYL2purmkBeA4Ucq	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1406	1393	389	12463	13593	jwTM6ch5fu1WviajVtHAcyvo2BWkwUdGBXhFL2vxD82V864wAoT	10722	15104	15104	1618657920000	orphaned
17840	3NLSpjwViszrFwBKzZWkcuYskB9uykmnp8unwpk1ASotCzFH6wTV	17571	3NKS7Dh64YeM9c7KWsn9NbwZDQjj6s7iEJjRwVMFBhwcJ9kLjqVk	1662	219	299	6301	12463	jxxwCdpxCWVVcUYPwuAZfW4q9HXiz59ZnkSg3szXQWxkDcGzP8h	8894	12728	12728	1618230240000	orphaned
17855	3NKRGMTjQ2dNyhxrpm3ppsbejcb15ozwuuNvKRg1HoWtq6KZg4wu	17643	3NKTQAho9DnipG4f3QHuMvqRGFoFCaDGAXnS9ykGsXwxBw9HT6eU	1523	1195	300	6301	12463	jwjRvWaSsFkLtm1a5tsaTyxggR2bdovu1MzGLTT8ocsfPpnduxU	8921	12733	12733	1618231140000	orphaned
17794	3NLhwsLfpuw1xaCafr2EGdZ9tr3jdMvS5HxrE2FL6H5hbbQEqXrA	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	1593	1346	304	6301	12463	jxp6V9W8T12BiszjkXejWmLGFZVYqZPanLL1kj5orStr8wNNuHV	8988	12704	12704	1618225920000	orphaned
17796	3NK3quGv1mE2zsHvqs2q7oeNytLEXc6a5tejieHsRUVoTFqVLEho	17795	3NKKboktSyLqjJWmsySiNGeCtN2iwQ8YAPAVBtJAfvFiNeRBFeMP	1407	1395	304	6301	12463	jw8LrydaR5Y1dd8wXvjFJeAMPMxPU8qgmRg9DDDsQntnzKoyYQF	8989	12705	12705	1618226100000	canonical
17804	3NLChghEx93bqedUxvKtZf4AiMDnRDPB7MwcoZQihyZa5FkSEaUc	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	470	1309	304	6301	12463	jwJXJFv88ECReSSHWxXjWn2s5NNAn4Q8heLZ7W5mPM4evQhJnMC	8992	12708	12708	1618226640000	orphaned
17815	3NKzjzH5wtEgGZxUiAKsmRLU5dD9t25hHrVZNzFQetJtCxY7UvuA	17811	3NLJJu8DktQ9j1cWPLLTY65QiERhuMxvxFsMgCeozXNfGyUVWj33	1553	776	304	6301	12463	jwR1JQSyvyCZQHSmsPtPkbyQWoNenfuvR5NVaMdSEC98kM2Frpw	8997	12716	12716	1618228080000	orphaned
17822	3NKDsqYwzZDWSnLJFnEvdnfc7cMQUaVosCNvbroKeUhnafAkj2Ap	17820	3NKtsLaLgw8FQVVP3ReG1w4TNSh31692bRhhyBX7XqD16P2CW4PA	1407	1395	304	6301	12463	jwH1mhgHS9F4Ci519zZ1KzjNv9A2uwAb5JD3DGPYjcr7rBctNUo	9000	12719	12719	1618228620000	orphaned
17825	3NK94RVekpSoWyx1PuSRj8xFVFN8Kny82ZNcUz8zccv95iYDTbKS	17823	3NKx6AvJkEqCPUxHUQvCqH1amjkMZG92Kf5WQicWPa4W4F3ZhDEM	1405	881	304	6301	12463	jwoaV5bfGt7bxJsRUMA2e8JjwVKo2VrmZrdXkKPYkaWRF22FWiR	9002	12722	12722	1618229160000	orphaned
17830	3NLNkkwaFjTTqHRqYRXvqcovCGCmqmwGjT4ZBmHWnHgCHNrWpZyM	17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	1460	1324	304	6301	12463	jxJ6YS7PVrewvLYU68LqRCsUF4cMqoJzzC5H41wG4EimMN66af4	9004	12724	12724	1618229520000	orphaned
17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	17832	3NL6yFk136F2wduLTwdM4LVdxqapj7L5b8rhVoVuJA8BBHGSiDuj	1503	911	305	6301	12463	jxhuDh4UZVSe2C7Fgdi3W1swFjRA2QbZLFd3fDoCmry6VDmNJBU	9006	12726	12726	1618229880000	canonical
17836	3NKDwYipFgyRh3UUnYpamx6E1B3uW6nDcGwkMnVg4RYzeNLJjF2L	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1534	1071	305	6301	12463	jwtnneM9dZCFq7eY5pLAAThFEeVGun1bs9G9DBTyGgrmCwqP6hW	9007	12728	12728	1618230240000	orphaned
17844	3NKpTQDdYD9cnSiiUm8beLCYtB8t7KjnsWF7KK7XN2AKFWYNPsrx	17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	1518	833	305	6301	12463	jwGWJauvnEQMqfrQLWYFsJcadeK2EwjV4moU1BH3YGPJdY2sBwS	9008	12729	12729	1618230420000	orphaned
17849	3NLxcKhpuhSad6SUyyUnckdtprPX8RKBZLEyYo19jGNav897wVUX	17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	311	1181	305	6301	12463	jwEYT2wttdisBEB6dqBeCrev4DrFhN5cKEUufobrSFUpyh6DxFc	9009	12730	12730	1618230600000	canonical
17848	3NLD31gC8eSfhjD96xaTQa33EJbuXdqiNtpArsA2hRfeVjRoZtdM	17843	3NKjmMM7GLNFHiMbbNeZPSyF2shxiKU3nWmWStvcbncXmye1w1wA	1460	541	305	6301	12463	jwCCT1Pf2bwAvCB5DLnjW5U2Toup76YAh8KdLXXGv5cG63M2wnN	9009	12730	12730	1618230600000	orphaned
17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	17851	3NLFWtgKkbqSDMTH7NkA7iV5F1dhA6k7tJjzSbHQb8kFfwh3Jowg	1657	1344	305	6301	12463	jxdhAUVTWaUYEt2SHYuJL5zouZCXRsnXiGHAdVUfr4Yd3sCimaK	9011	12732	12732	1618230960000	canonical
17854	3NKxUA9DzXPjv8cwpkRnv3CgPQFBdmegwGAWKzR12W961GQVtP49	17853	3NKpe1ExjGtpsutybYKDrspN3NCWT8BkDWtvPFVrCKiajTDboV7K	1523	1195	305	6301	12463	jxupwUsedvixpysaMMtEYbQ9gsXEmN4EWfvjghqBsGYnzZRub7E	9012	12733	12733	1618231140000	orphaned
17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	17856	3NLtJgY9zFHhVn45w4YcCFLu1URciYqsCTz4iKsQUHrkX8HZAUfU	1455	1086	305	6301	12463	jwErXGvBdvxftQ2PisWTjvtSU2ZWPo5fFnifycSfUtm8vHoGUAq	9013	12734	12734	1618231320000	canonical
17859	3NKjV866mGENL6GLQdwUpUZ7292RLnxLcgGkMrpouzUP3dQ7oiGD	17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	1655	682	305	6301	12463	jxRrQsM9vgMyas5r7rUZc1wWuG77j9WmkANPyJ7EVGjfYV2RcHz	9014	12735	12735	1618231500000	orphaned
17863	3NKzz3X5PwKyUGB66VDVa6stxj96Bvto3bhyVzuH4uyoo8EzaNko	17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	1573	1072	305	6301	12463	jwDPKgv11zYCjz3cV1wLDm7kNrPkAiqsDaKQw9gU4hNxoRPXNUi	9015	12736	12736	1618231680000	canonical
17872	3NLFJPtCj1G9VnZPqrkaLcCSBWfudJkisbzHHY684582QR4YM3ah	17871	3NLXpp5w2NT8UiV6N615N7rt67tPupi3xgSRorQUwr8wDRPGsn4i	641	970	305	6301	12463	jwWmXHpcCYrwepM16njFHuqyq4QBS2NViS9AkDMuaJwwt4KRhyj	9020	12744	12744	1618233120000	canonical
17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	17872	3NLFJPtCj1G9VnZPqrkaLcCSBWfudJkisbzHHY684582QR4YM3ah	1403	824	305	6301	12463	jweQEdNR7KvBmLysL1wKUyUipjqrPRGPNpkzKXfk6XVuYVFFaEs	9021	12745	12745	1618233300000	canonical
17878	3NLwk4Jc8a4dxqKnxZCAHMSi98LLct4oFUJfrTDc89zgSC72cHSJ	17875	3NL5gS76FRmbLgU8AFSZ3dA9bP56Eso3Qg38FrZQVBLZwVXr9J3Z	484	1193	305	6301	12463	jwfvWABef8TBiJoQc6wDbMw6vmeWbsUNZzKtxzKp1314CDURC8f	9023	12747	12747	1618233660000	orphaned
17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	17877	3NKjUeLwKLeRgnMmgNCBFT8WDa6RPsbqzENJbkzbhcQZiV6PFGtN	1600	694	305	6301	12463	jxRii8q89MbzPhaqieZXjxwrEvbxRt1RBuW6RrnV5kUTg71G2wa	9024	12750	12750	1618234200000	canonical
17880	3NLK8QPYadN3NneLrL3J1Z6N84LGF1sa9nrm6CBUWpLTPp9CPxpo	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1467	1130	305	6301	12463	jxdEWZCRgPzu4QbYyrD7c2sFiETpWG8qUyfbzMD7xSg52hLSqWT	9025	12751	12751	1618234380000	orphaned
17885	3NKsZrgkCK6AhUuNKGM3ogtfBx4FSasSgrPxmprEwog2Gq6UH8zb	17880	3NLK8QPYadN3NneLrL3J1Z6N84LGF1sa9nrm6CBUWpLTPp9CPxpo	576	1109	306	6301	12463	jx76Yh3ikzAcZt63MfjnEJSkmFhPtLUeppGpcKBWgan1eERs3eF	9026	12753	12753	1618234740000	orphaned
17890	3NKzWaGGpYATZ9JzKYmKWCTCmr6hrRmUe2zyMYLpF83Xt7MH1Coi	17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	1670	1282	306	6301	12463	jxZAHr8iwaTDXtBWZYXVY81JMkcj2KeVUHGUTVRXJLMN7A9Pciv	9028	12756	12756	1618235280000	orphaned
17895	3NKA7ERLuRme9tJVCdRhRKEZ4EgS1RdEvFrP1tJ41X8Aw8L8HSsG	17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	563	1233	306	6301	12463	jxU6SC9UDuVXLVikTDDLFsRbfy2k4hBtPTsTTjbbV75kX3YZFhP	9029	12757	12757	1618235460000	orphaned
17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	17894	3NLANVuTxt7M75iNhRtenMSRWnvX2J8NgFyhADAG8gpe8wtL2kvw	1668	1124	306	6301	12463	jw9zXVjELk9JwyAb2shKRf16qnSbCtqgGPhKL2H3ZnwocHTMxQ7	9030	12762	12762	1618236360000	canonical
17903	3NLx7ExnzBiPJ1dgEhvRTV61rSPAiVP6hX6tordGBYUQvePnYShe	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	470	1063	306	6301	12463	jxQfNq13U9KcjkWjn72JFatCyV3T8quNNA5KBRKfCvKkaC2ze8T	9032	12766	12766	1618237080000	orphaned
21361	3NL5eBa2bNf2tfyyr2XL6CwtmxsdUrYXbfSsz7D8jsYCYSioxmwu	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1403	824	389	12463	13589	jwKNMAqBqMpd28FVY6XoAG431yezYcwuT8MPhHqgAV6aa4PfM3H	10722	15104	15104	1618657920000	orphaned
17896	3NKHhP5nEwPGbmbWcsirKGiJhopFQYPRGtgs39M6KKtPd1ekMepD	17789	3NKub9qz3PnJdHKdS1irHW6QRpKq5u9xxDmaSHxQf8ahqxdMVyip	563	1233	304	6301	12463	jxtUJScjHNq5Yu2J6Yc2eTrhsskKARJspEoUZLCM7zogVfL6Vxn	8988	12757	12757	1618235460000	orphaned
17869	3NLGjyBDWhYbix5qAT1vJCGRWaWii8J3A9HEPyWAJxQ4xkRP8wb3	17849	3NLxcKhpuhSad6SUyyUnckdtprPX8RKBZLEyYo19jGNav897wVUX	1458	1077	305	6301	12463	jxCsPWm8ES7xVkPX7nLZHVRx2qLuDWkKR6L9v7NpfzKnCY5gcuQ	9010	12743	12743	1618232940000	orphaned
17860	3NKV63JYER8ZrJRtHwxNW2KUWfeibzorFDnPhBkgb6AN8bXa9PPc	17858	3NKauCJaZoSBprDtA3HaU8MuNXhnXrLSDr9JeGXTdZeXXv5MEaMP	484	1319	305	6301	12463	jxEA31DVMmAUSpAb9sgdTCiwdZA24WaqNbkr371o6szL3onXP8A	9014	12735	12735	1618231500000	orphaned
17864	3NKcMhi3QSv9HCQk4XG1ZGB6ztYvWZpJ7xEczvD4Tsn3LsRRxPyD	17861	3NLiA5DqTQ8oswG6T1NfUCP3SmSTap2dmTvKou3pqxDechcjp5ha	1611	1341	305	6301	12463	jwxBtCTpgTfE5efZfuXQ42vVye7Z3UbkYaLu7VBaTqw6EWzf8J4	9015	12736	12736	1618231680000	orphaned
17865	3NKHHVFqrdkFbvG6uT6iVPyv4FZf8Qp3YVSqixmYCe6E5VA2SXi9	17863	3NKzz3X5PwKyUGB66VDVa6stxj96Bvto3bhyVzuH4uyoo8EzaNko	369	1066	305	6301	12463	jx7rJCt85fTqGkeEpsiQzXJKjn8xJBbFiXf9zxasRPzpi3k11vd	9016	12737	12737	1618231860000	canonical
17867	3NLY475isKT25Zb5A8LCtDrbEAYuLm7wJFor1a5hfqNkZWCrw8HC	17865	3NKHHVFqrdkFbvG6uT6iVPyv4FZf8Qp3YVSqixmYCe6E5VA2SXi9	1406	1393	305	6301	12463	jxrW7PqtWkR24rsVguRfB49KEuxgA6cbnkh9YmLtR2vhLseo15X	9017	12739	12739	1618232220000	canonical
17868	3NLkFB3EhbF2XdBsGbLFJsWc44ne4VGuy9iNwdY5QDNW13pskokY	17867	3NLY475isKT25Zb5A8LCtDrbEAYuLm7wJFor1a5hfqNkZWCrw8HC	1587	991	305	6301	12463	jwEnbXd9bWn2GJHAEGBPHH8F2yEhZaFKgNFznHaVP7Td1whRzEn	9018	12742	12742	1618232760000	canonical
17874	3NKufvpqScVMyAevHtRhUcxZmFtuE8cE2nxfQGqaMag8bJtan7Rs	17873	3NKxYZWpgQBxeEi2QVhcVRZNxBTn5UM3ebJNt5gPTTvVvCJuHqJp	1622	1356	305	6301	12463	jxcbiLWnBGHPspoPXF2Ehz2dnXPQFozHPEGN2puyzWjTrMa3VVL	9022	12746	12746	1618233480000	orphaned
17887	3NKCkBaRaBrQT5Wo6r4MvfnyCdYCxY2NJpQRpwmSi7HzLhTPqqj8	17884	3NKrKaKKNpCiWuzroXeC2tYRse1A8NhnjbFPUsfL13PosaeuexS6	1657	1344	306	6301	12463	jwv7zeDKkEMzYb63ewTfcNjdEKk6FsQjvDe6ZPrs1YNFWaVdU1Y	9027	12755	12755	1618235100000	orphaned
17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	171	1248	306	6301	12463	jwTaMe174AFNQbyeDBgL5JDNxmZd7uXFRdR7FjCaGLGd3FKsx2A	9028	12756	12756	1618235280000	canonical
17894	3NLANVuTxt7M75iNhRtenMSRWnvX2J8NgFyhADAG8gpe8wtL2kvw	17891	3NK6zpBhKskUTJXeFb4yZ9tCJVaeb5JwCHkXm9qaKK4ccCxnpSgy	42	995	306	6301	12463	jwGkjM9A8fR9nzXUtSRp7R6vAGnZcwjV39sceRovrdvacWRydoz	9029	12757	12757	1618235460000	canonical
17898	3NL1UCSn6iVrw8xskCVSDznpbRmdGXhqRDpFffTKg5nXjzaMXJTX	17894	3NLANVuTxt7M75iNhRtenMSRWnvX2J8NgFyhADAG8gpe8wtL2kvw	1579	1023	306	6301	12463	jwGfdxp8Bc3ync4LCtbyiiuxE8F9PW95gTJtRsj7KbTN1YSQH9e	9030	12762	12762	1618236360000	orphaned
17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	17897	3NLx1czv6ZVzrco9qmwWUoNbLAq8fnLmJov1L6bCD1W3BRGwNPrQ	1406	1393	306	6301	12463	jxBkYEjrMPDA2YKiHKocu3YzafdodeghTEbf7z1YRPEfoG9WukV	9031	12764	12764	1618236720000	canonical
17904	3NK3uzew5R2qkEpdpeJvFCUJc7R5BeqBPeM2eWqsUQ8Nfuc3j4i2	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	1648	1158	306	6301	12463	jwvKmMM4SMY4MFVj3Qeg2AeKWThUwg41NBnDpRJMC4sEvuWyDbs	9032	12766	12766	1618237080000	orphaned
17907	3NK6P8iCCKNYAU6x51WdCx7AAN7TtZT6iHG2ufhNUMxGn2iNxHd5	17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	1419	814	306	6301	12463	jxcoBRUg4QUeRmgQQ2ZiDJGHd7noDQwgsKeiGT4SRHD1NjqN8Yv	9033	12767	12767	1618237260000	orphaned
17909	3NLiVzgCybQFAU4Bb7bYWQWnfxadUrA18EuJHjXSTbkktmTrHciQ	17906	3NKs8wpY8WigiV1nwziHAzJFKXdeCG9E4CYUH3F1tSjWgAPguKub	633	1138	306	6301	12463	jxCRaUQkkfg7RJCRRVqTbXeDUwDh1fpbtQeY8cdoMsER3chwLZg	9034	12768	12768	1618237440000	orphaned
17914	3NLa9GGeL51G76sx48PmmZvxLukfPhrJ2DfxBxDTHwemPqtLuxUp	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1623	830	306	6301	12463	jwXSx1kQtzgiyuVA7z6chRv7Bgot4X89aLNkpdSq3Sr5NwJ1C1D	9035	12770	12770	1618237800000	orphaned
17912	3NKHWpaXcnsPrLVguwo612GAeFJTucr9jme1wKZvbPK7tjHnDZjw	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1649	1383	306	6301	12463	jxB4GGwGcCAzVw6GxmC2xEJRBkmK5JTU5Nudcu4JPVfh32dng3a	9035	12770	12770	1618237800000	orphaned
17915	3NLEkZguQvuZM1Yp6krFk9gLDZ2VL5mmY4kdUeiqVubEHxd8vGYi	17913	3NKS63sy6xEc7Ba9iDvpsvosmBTUFGsiz6bJyUdoy1NncG5QDFaE	1483	551	306	6301	12463	jwxbto7r66gct5LmxEd61HRZaDLSYSJ8JtpZcJ5b2yMxCnRcL6m	9036	12771	12771	1618237980000	canonical
17918	3NLhTgv42saJn5qNbUXewwhNcWL6CnsKToSYCMTH811yUA8PLQKB	17916	3NLec4AKTHd2BnASeFFqeDkPjv8yCn1doFpcGocKFXimwUx3dcVo	1503	911	306	6301	12463	jwncueTKPmNkyc1ZZFKtJCVfvi1oofVrscV8RDymr222rBfXXrF	9038	12774	12774	1618238520000	canonical
17923	3NLangiYPgKRPMgrEPNUcdhzTsdaPjPwhTDKh3gGB8C3fo5G1TpB	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	152	1330	306	6301	12463	jwadZ8N4wEFS82CtJe67T81a2jJr9nwZYovq1Wd2zb5G7aprkYN	9042	12778	12778	1618239240000	canonical
17928	3NKTuUT1zNqGGxDAAznmYCSPgyumqkat7QfQGmJ8av6BtufPGTtQ	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1406	1393	307	6301	12463	jxqxRZ3KP8ATrWghzSJWCphrL5Wqg9nLEQ4iBudrazLCXmsibDE	9044	12780	12780	1618239600000	canonical
17934	3NKJmbixeoFuZ3UsuquGo9UpXQ5T7GRf6wy184vsyz1qtLzHMPy5	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1579	1389	307	6301	12463	jxgm3KzHAZasM2h7mpsgfreZjNA3axjmRECzsLEQXmAXq4t2ohH	9047	12784	12784	1618240320000	orphaned
17939	3NLEFozNWKYEywMviMyfUBXxmvdEr6dSYcdCbszexEnjYLcyGrgT	17937	3NLRrvmoqfGBBXVrwrKyqr1Dn2zCoxAEicNDfXswjMSFXRp8F1by	632	1382	307	6301	12463	jwYbJJhmqCD9FUmETXB8fd5ApC2jFcLum9CyQCXSyJfQDTrQGmh	9048	12785	12785	1618240500000	canonical
17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	17942	3NLmqti5DD2XzLRaRf3kZd5Ls1Hy8PZNL7QoUkvn6L2X9cvj6iZf	633	1258	307	6301	12463	jwjpQCXSZ3QpH67Y9Lg6wb7yA5gJmh7gLs7xTcCWtaw3jvnBUTq	9051	12788	12788	1618241040000	canonical
17945	3NLTf5mfnZWGtwXyWFzig7WjFi97B14CHx4jk2jqouXktfxPUD1w	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1671	1365	307	6301	12463	jwwmGsVrNP3NzvKMTxuWWYE4DqzritiohgiCbMjS95VE1bQYqHr	9052	12790	12790	1618241400000	orphaned
17950	3NKJC9fMsdKv5upGS6wY1cuq3TS38o6h6siDnyHS9EVrEuvq5yjZ	17949	3NLEWBKF56sD7fiMjWF27xgEJydtgRJCKY84w9DyTHF3MyTEMdkg	1657	1218	307	6301	12463	jw8fQpGs2rcLapnN9fnZFwQ16pbbhi4ApXAxmwmcrbKJr9rgsut	9054	12792	12792	1618241760000	canonical
17951	3NLsPDMhjC9eX3BiJ7HkSTNyxMfnibsayAdgFcaDkD3NGsBmYxJ4	17950	3NKJC9fMsdKv5upGS6wY1cuq3TS38o6h6siDnyHS9EVrEuvq5yjZ	1599	1041	307	6301	12463	jwqkURMEmk44XVv2acbfxUCxdormjWGrJ4HyXoNJqmo3KgHMTUT	9055	12793	12793	1618241940000	canonical
17956	3NKMoSg7Jnc5bxmE7aZt5gkx1BPtRj6yzQpTs8oV2CC28oX518LS	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1522	1196	307	6301	12463	jxmvqnjN67Fc1DjCZMT2766k44CjdppnubaNsTvCxRQXUTeCMRt	9057	12795	12795	1618242300000	orphaned
21369	3NKFPv8X6k2jV6UwnjEtokcYJ1B4HDxQm8YWoREDMt7gXfEBx1pJ	21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	641	1336	390	12463	13594	jwFmViidRffQRcRdqDtYX4rX1YdGFW4E6E8g7jjefhhU8BiPRC7	10723	15105	15105	1618658110369	orphaned
17906	3NKs8wpY8WigiV1nwziHAzJFKXdeCG9E4CYUH3F1tSjWgAPguKub	17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	1406	1393	306	6301	12463	jxKWmgPejbfkiTE4RRSzhxqTo6jmLNgdrUQz6F8heTtw72Pvaym	9033	12767	12767	1618237260000	canonical
17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	17906	3NKs8wpY8WigiV1nwziHAzJFKXdeCG9E4CYUH3F1tSjWgAPguKub	1402	888	306	6301	12463	jxpmWKzMaeTGnhTS1uhofZZYLe9YCktrrb8eHwiJGZ5fwGQkurH	9034	12768	12768	1618237440000	canonical
17911	3NLUUqnp52bPxGK3YpNECRURvzLKRbuLzjJ3Ezf9UvTmKHuNgMyi	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1407	1395	306	6301	12463	jxDW2bh1rGELgRYQenmrBD7VdWEnKQEbjpfFAGHwuq26JLHB5iQ	9035	12770	12770	1618237800000	orphaned
17917	3NKADAkxt67acMwdvhDUxZNjezi4m6xvd3ngGhhqpLs2ignLQ6a8	17916	3NLec4AKTHd2BnASeFFqeDkPjv8yCn1doFpcGocKFXimwUx3dcVo	1406	1393	306	6301	12463	jwJkhw4wQiTRbHc6jRn4tPF9zELLT7EgKw2QPVLhPWWTmXDvpHF	9038	12774	12774	1618238520000	orphaned
17924	3NK3iNU5v42bwWtqW3QFy76WrJuLYGGQnykq7Jojji8BHRVj2cPE	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	1594	1326	306	6301	12463	jweo9kAfDsT23EeC2Aw7u2mxUFK1tKQd4ixhF9MvwCjLy16dSET	9042	12778	12778	1618239240000	orphaned
17929	3NLyZnzb9H9jJN65gzKkFAQ4jJ5NHRBBLzrvKNm11dBYLjR5BmBf	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1483	1276	307	6301	12463	jxAK5XkRC4GtUt19GdnJ9zvcdtLYVfW4pqxqDfrvHZ7esh5uXMC	9044	12780	12780	1618239600000	orphaned
17935	3NKYmXapvGKtcxtp8Us8SJ73ZUDKwQoveMPqFL2ugGFdjhcQoeTK	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1405	873	307	6301	12463	jxPhe7n2CpsivXM7WTQbVRPLmk7vovD9QRzzQWiP8JnZXpGdT54	9047	12784	12784	1618240320000	orphaned
17940	3NK5d6wMdWf1N9t61u4pMQj9NbPR6vKqNpgoFNixVtSxedvDSJ49	17939	3NLEFozNWKYEywMviMyfUBXxmvdEr6dSYcdCbszexEnjYLcyGrgT	43	1310	307	6301	12463	jwM4EQKZqZU8NLL8USNgRAr5r3yjve7RcU9gL1KgcvK3NgHPJ5i	9049	12786	12786	1618240680000	orphaned
17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	17951	3NLsPDMhjC9eX3BiJ7HkSTNyxMfnibsayAdgFcaDkD3NGsBmYxJ4	1647	1176	307	6301	12463	jwbhqN35TK6CR9mDTNZVaSAggCQ7xqKgJjy39kV4UKu9BpSF1A3	9056	12794	12794	1618242120000	canonical
17957	3NLxq2o7hVtrHv9bgayXtiGA1aQHoHzhpGEnKw9L342jhBG7vkRA	17955	3NK4pxZF7q4WKKqsxu2PLR1PGiwZTiqqLpuzoePDLKG9GreURSp5	1654	1340	307	6301	12463	jx8rtiw4XVoXXDJStsKfyrX9g3S4iqjCaTfnE1CvpADvXRUSCfD	9058	12796	12796	1618242480000	canonical
17960	3NLgD5A5ZF13BzKAWXtczBZRA2jSvkAMhHdkcQkdF9Ypx3MZYzZG	17957	3NLxq2o7hVtrHv9bgayXtiGA1aQHoHzhpGEnKw9L342jhBG7vkRA	621	621	307	6301	12463	jwcx5C8cjU9p76FpkeFfn3g63DJcZvmCXDU2BjFjC6EZtqbZHxn	9059	12798	12798	1618242840000	canonical
17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	171	1248	307	6301	12463	jxLCLYtHjcp9upAaK8DUwmw8xrR6ojRsrTt3eEAnRaMRgCYUQVq	9062	12804	12804	1618243920000	canonical
17965	3NLiJ1ume5Zs6fEjddzzPjuWJ3NXmHe59t7s9L8uSKKYz4bUm3RD	17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	1405	867	307	6301	12463	jwyH8T8h6vKdVQEVJb3kxV3hy2qiQH1sqBbr652j5t4SpmDjUdV	9062	12804	12804	1618243920000	orphaned
17970	3NKZjsCqXELyz4wpao1H4QfRSEYikXBx4P9ofJX3X7Wc6nBaNR6m	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1403	786	307	6301	12463	jxyTVqPmJwXnYniUUJGCZmiYmqacg5cpzW2sf9fR2zXGBKFKqrd	9063	12805	12805	1618244100000	orphaned
17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	17968	3NKXFGjTGpjBoTqgnPj163UruBRbCBwcMGdHzMsxQ5iwgeqVHbSE	1403	791	307	6301	12463	jwiETUZL8EcvkKtHt5tcnScvfarQdPQuKi9VzLSEEHCRp3xT26J	9064	12807	12807	1618244460000	canonical
17975	3NKeShjA24xZdWRzdyVnA1gFaoaci2FNZgpbDTBtS6h8aLTxfZgy	17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	1602	1123	308	6301	12463	jwuzjmSwXHhr96SQr67nyG4LTmDbb1e3VTBhtuV8CU4hcreVQNb	9065	12808	12808	1618244640000	orphaned
17976	3NKJHsAegQfn6hj42xgrySmPjNgP2j6eMyS5G2zEMJZZ5Rr2Qbgs	17974	3NLi7cvrHJvv2ydkEU4JLnY9vxH1zHNtqDtqB3KAD3patNHdmen3	369	1312	308	6301	12463	jxSA79tcLXXAqVGbKypQemSgshdQ7yoHftMDNE5z1SMwiuCH7ez	9066	12809	12809	1618244820000	orphaned
17981	3NKiuxM9Th9rMTE6T96TATzCKSc2uBV4jBsCLi4Roq2MKp54J9cq	17978	3NLyNhYBttYxBQHKhJHnNEEQmNCJuRcT2PTND22gjpsx8SpBavXR	1403	31	308	6301	12463	jxTtZ4F3t9UT3PLDxbWthTuhPdxgyaVSyzMHHheTrPowFGPetZ5	9068	12812	12812	1618245360000	canonical
17982	3NKrAdMJm3Hbxy9fFyscH3zQDvPLAa4SkLSXnjx3Ds872iWL3Cpy	17981	3NKiuxM9Th9rMTE6T96TATzCKSc2uBV4jBsCLi4Roq2MKp54J9cq	1631	794	308	6301	12463	jwt1CX35gJwXNH5hvEm7sgFAAxfMBQbjqYq59728wRXuskW2po9	9069	12814	12814	1618245720000	canonical
17983	3NKFQCcVWtb7nsFpcEW4wqkTk4JRgaf6F7tU8L69tgSfFFkT8TNn	17982	3NKrAdMJm3Hbxy9fFyscH3zQDvPLAa4SkLSXnjx3Ds872iWL3Cpy	1623	839	308	6301	12463	jwT9pyuEMf2uMTKEfD4z6on7UoPvLYEdzAZrhQPJPs62BeEBSoG	9070	12816	12816	1618246080000	canonical
17984	3NLnZcpsL82o1Gt6S6LnF98mBcJQXGGG26ypK9jL58kZxMMvQJuV	17983	3NKFQCcVWtb7nsFpcEW4wqkTk4JRgaf6F7tU8L69tgSfFFkT8TNn	1406	1393	308	6301	12463	jwzcGLk8dNgToyrGgkyEfAbD3K2PJQYtRW58tZ4a7dJNqjfHW17	9071	12818	12818	1618246440000	canonical
17985	3NLgtDkofj4pVC3LHvmLEcDxJBbXWHoHEfZqotWSCPyu9HQBhpK6	17984	3NLnZcpsL82o1Gt6S6LnF98mBcJQXGGG26ypK9jL58kZxMMvQJuV	1600	410	308	6301	12463	jwTq8L9SRFKEddGVRkRSMjF9i1rRbf4NGe5MeuQLbJpFhzGfrCV	9072	12819	12819	1618246620000	canonical
17989	3NLdRhi2bVSXSCpVV3UYYZS51tNGrg24gmh6CXhk2mYAYw9Pyg2B	17987	3NKjLG325rdTNYf4aqFU5DYv2kB8yj6E39yfLYdGcq2KotbA52af	1651	1301	308	6301	12463	jxRgEcaR9mMUhWXuXh4vcfPBiSEL6Lk9wJg627nqoeDcp6vRr8s	9075	12822	12822	1618247160000	canonical
17988	3NLXFgoG8g6GZwNDDLYZcVVUQ1QkPNCt1gsRZcn1ede6t8MnQjUW	17987	3NKjLG325rdTNYf4aqFU5DYv2kB8yj6E39yfLYdGcq2KotbA52af	1651	1301	308	6301	12463	jxefm3jYKLfWBFZeC5eiBgTVq9h8g2xqskT6L2GgffvZcyWYUq7	9075	12822	12822	1618247160000	orphaned
18001	3NL2ehiffHNs2ZheVeVVur6oRm3WzqK4UuhBcdbC5trmdMBfMNS5	17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	1403	824	308	6301	12463	jxqr2oPKfc2o69HjvSSP2vrj6q4nKYS8hCYYLcpoHYQPpc3dkbp	9081	12830	12830	1618248600000	canonical
17999	3NKqwniuNs3A91EsLmqfAiVPFhYBUp1AFvcSsgKNzHjL5XmckCa5	17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	1607	1348	308	6301	12463	jxejGUnANd9RGYQekVKprV424q852REvc4Vkrx4SrsjPEYZWbdF	9081	12830	12830	1618248600000	orphaned
18006	3NL78NXVXgKztLNqBKV4vmUejToAZ2uMQeAqPRJUcCLFj6miq247	18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	1657	1344	309	6301	12463	jwuUtnERtsi3Aoz7fTv9CoBPmUkemas1TMzrcidtWb5BEPUU8W4	9083	12832	12832	1618248960000	orphaned
18009	3NLyYUVqDqcpzFVD5WQ2zxLrVJdF1qiAzMZXa4Hu9xzw9BfLtJck	18005	3NL8Z2YzLsGkUmX1AGnArWgK9sKQ4CDQ3LFzGwjS7ETwHtNVb5Ct	1553	776	309	6301	12463	jxRRc5fQZFW87qgLgjoPEd9EptzUAYQ1AAiXRAsp6NkUyw7KdZm	9084	12833	12833	1618249140000	orphaned
18010	3NLBpCxXmYGsPF6AjqBqC7gRUdzJJzeicDiezSNuAzVG3S2wRetP	18007	3NKjqhpqobANa69cUdLnqXVuJZ58a6gSu5ubmDZtNZhxR8NEPeMo	1637	816	309	6301	12463	jwtzVo8TbFgt3ZJe2G1YXXRWG6FCLyEUrB9wPYTm3RFsq2sW9U4	9084	12834	12834	1618249320000	orphaned
21414	3NK4JQzzYsEV4Lig6hEth3rMsCCjQh8eot7rPQJGE189AjFNJiE9	21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	1458	957	390	12463	13630	jxM8wMg2QCQ2hCEBDLmNdUiLK7S56j5xyPo963Zq3WuzDQtrXqT	10739	15127	15127	1618662060000	orphaned
17913	3NKS63sy6xEc7Ba9iDvpsvosmBTUFGsiz6bJyUdoy1NncG5QDFaE	17910	3NKSC9cxhWo8SfbX8cfxPszgehQoP5L58bxyETEGHoeBATrhbMdg	1445	1164	306	6301	12463	jxcieHbxyJF8q5dLJCTsD9CnfT5pQU2kc4Mn5f22Xra7aw7bkAA	9035	12770	12770	1618237800000	canonical
17921	3NKzeMSwenSPx5wiQQRfS7P9nGci8ywqUiqCRWu5NNVUgD2bghTu	17920	3NL1nG5x75u7n1HqCiSMkTt6Js5LB4f9wPC42yikc9oe7Q3RZXes	1406	1393	306	6301	12463	jwxvDgqBfZxwSQCLrZqJxLjNeaQHywb3YvM2vA6xwxGyBv8Cqhq	9040	12776	12776	1618238880000	canonical
17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	17921	3NKzeMSwenSPx5wiQQRfS7P9nGci8ywqUiqCRWu5NNVUgD2bghTu	1405	849	306	6301	12463	jxuCaMXbaH7ULF1NWX23yKS2JXFMJSHtxWKAxEjo4aZm3SR7Tyx	9041	12777	12777	1618239060000	canonical
17927	3NKHSjtrxEyFfnVSUYR2mfXxY1katvbpNAm548GhZQXYrU7oR7Jh	17923	3NLangiYPgKRPMgrEPNUcdhzTsdaPjPwhTDKh3gGB8C3fo5G1TpB	1610	1314	306	6301	12463	jwpTV2scLxo38Wp2hszRP9fUZUwQeKZG81ERQp4PSH2SnSR7nJ6	9043	12779	12779	1618239420000	orphaned
17931	3NLgeXT7QoXBDgWSTWV4xmY4SbFT8sv7U5mdvDMapqQCpMX6upNi	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1483	1276	307	6301	12463	jxAK5XkRC4GtUt19GdnJ9zvcdtLYVfW4pqxqDfrvHZ7esh5uXMC	9044	12780	12780	1618239600000	orphaned
17932	3NKDGzKNokSSuxGYZ74hnj8t5n27UiYKZP8wgkKv7VQ2DP2adhkq	17928	3NKTuUT1zNqGGxDAAznmYCSPgyumqkat7QfQGmJ8av6BtufPGTtQ	58	1035	307	6301	12463	jxKxbU4ZPQx22GZZ65zm7ecEji1soMBBtxAMMY5bY1VmsEHUYvA	9045	12782	12782	1618239960000	canonical
17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	17932	3NKDGzKNokSSuxGYZ74hnj8t5n27UiYKZP8wgkKv7VQ2DP2adhkq	1407	1395	307	6301	12463	jwux93F6Ydmjc76QT8txnnsmXLAPAsXpq2Y4so8PbiaY9JSmhqe	9046	12783	12783	1618240140000	canonical
17937	3NLRrvmoqfGBBXVrwrKyqr1Dn2zCoxAEicNDfXswjMSFXRp8F1by	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1650	1249	307	6301	12463	jwA9S9G6x7ZZafAamXaBFraML1VhazF2Q5BwyqPbXgkHNoHuKER	9047	12784	12784	1618240320000	canonical
17943	3NLBRZqWFeBddSNVas6GyZPe2S1CPPp42JcL7hyZ4LbSmNbTysq9	17941	3NKMnpvn99irDWSeC2EAVoEidtfMUtdJpvJ1hsq5FqUVYGfe7Uj5	1650	1375	307	6301	12463	jxWGe71TeA2bENdUujVsr8S2rf3u9fakYZavpFYzAVa8D5seuo2	9050	12787	12787	1618240860000	orphaned
17948	3NLBHcFDVn9NGCtB6a5bRWS4cRMrdF2pB3RcvoLyk6Terese16Dp	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1559	1353	307	6301	12463	jw8XV6cdoyFnbAVkWysPJFwwnsHfqP3LjKiCkMMPXC86ocvjrms	9052	12790	12790	1618241400000	canonical
17949	3NLEWBKF56sD7fiMjWF27xgEJydtgRJCKY84w9DyTHF3MyTEMdkg	17948	3NLBHcFDVn9NGCtB6a5bRWS4cRMrdF2pB3RcvoLyk6Terese16Dp	1646	1108	307	6301	12463	jxhuk5JWCPj5hw8Es8g966CUC5cKXhrfkDSSDGHZNnNdQUzAfx8	9053	12791	12791	1618241580000	canonical
17955	3NK4pxZF7q4WKKqsxu2PLR1PGiwZTiqqLpuzoePDLKG9GreURSp5	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1453	47	307	6301	12463	jwuEEVkiRaZgKe2xxRsgfzELmuWBQYsxJQWswbRL9L5epDK5vY1	9057	12795	12795	1618242300000	canonical
17972	3NKyKG3Ctrr1JVStC8cNyzaiQ5NzpUgYpZBi6ihNgj1QKZfQi6Dr	17968	3NKXFGjTGpjBoTqgnPj163UruBRbCBwcMGdHzMsxQ5iwgeqVHbSE	1637	816	308	6301	12463	jxYNPoooWuTV8MzJG6DhgBnvfjKHGMz3CgGzaZuFHkEKNMvh9cB	9064	12807	12807	1618244460000	orphaned
17977	3NKvHbe7uCFwx6sZvKu8xrTcwSHnSaVDVLvzzvqqKtGuq9KY589T	17974	3NLi7cvrHJvv2ydkEU4JLnY9vxH1zHNtqDtqB3KAD3patNHdmen3	1637	816	308	6301	12463	jxsyuPcMeLaP9bv2S3CkaDqdeLW5wmq6rAD8RXa2eFF69syQaAo	9066	12809	12809	1618244820000	canonical
17986	3NLZekAwjsuYXcYSFkwBMkwSpPBY3mR9wrX4cCwSATpwacbvuDKT	17985	3NLgtDkofj4pVC3LHvmLEcDxJBbXWHoHEfZqotWSCPyu9HQBhpK6	1555	1221	308	6301	12463	jwFuyhAtAruGuCfedHWLcXJbPsjEL5FQjCPoL82ANBA5pvwoivk	9073	12820	12820	1618246800000	canonical
17987	3NKjLG325rdTNYf4aqFU5DYv2kB8yj6E39yfLYdGcq2KotbA52af	17986	3NLZekAwjsuYXcYSFkwBMkwSpPBY3mR9wrX4cCwSATpwacbvuDKT	1589	1286	308	6301	12463	jxNUKBMHRxf4EXdyeZmVhARPJRe2tnGc3gc2UQpctoZRMaA5zgJ	9074	12821	12821	1618246980000	canonical
17991	3NL3srEntcYQpAFq1vBFHCLj5D4y6XjaPLQrn5bzN2ykL4V7iy1s	17989	3NLdRhi2bVSXSCpVV3UYYZS51tNGrg24gmh6CXhk2mYAYw9Pyg2B	1553	776	308	6301	12463	jxhusdPn6f51bmNqJDL3q5hkFJzpCdLmaYWGtvryVsdHF8q3K2u	9076	12823	12823	1618247340000	canonical
17997	3NKGPmr9mJoJVy43tZXSbj4YR5iqTvhrRPayk8VbDMCFR58Fq2Fb	17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	1448	1311	308	6301	12463	jwEDx6TpFdrzkMtG5YnTb7Uak2PCvUyaHNJzANHik3sFnRv55jy	9079	12828	12828	1618248240000	canonical
17995	3NLyHWUNXo4nUvWu9DrfkNJZLUVPTk86HhxmccT9d3ujZGE6hcLn	17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	1448	1311	308	6301	12463	jwiNLScsJVPPooRKLjYCGzshMEUHj8iP1LRsFeGKnS9RP2qmPmN	9079	12828	12828	1618248240000	orphaned
18002	3NLZabK9We4kxDBNVxMpUV9kGXvBbhzGLsREkoZyHyhJB6k3FiUE	18001	3NL2ehiffHNs2ZheVeVVur6oRm3WzqK4UuhBcdbC5trmdMBfMNS5	1560	1291	309	6301	12463	jxWX1yQwSRcF8rejmkT6ZKyFcKxXqWpKPSxsksXjFhBA6mY9GNX	9082	12831	12831	1618248780000	orphaned
18013	3NK9ihnWdC7WRgVdAHdKQTAzVwGA2UKiHAwb2ogRdRNBwyL5RQEz	18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	1542	1304	309	6301	12463	jxCWt15Qg8kHDf3mHroFphJjTS8EaJR1ZAYhy46ZA57o8JgYNZG	9085	12835	12835	1618249500000	orphaned
18015	3NKfvfsHcizyLVLFb3NtNF5ZSaCHHRqLk22NxvDDYzf3h2y1vK9v	18012	3NK3C6ktRr8PGypqDMF7XisJSBHhtqQDKggVEyazEoZc4bosaLbu	1590	198	309	6301	12463	jwY6gjq4cRCYfpQtJo4jfEZqnqd6WnHaJ17LBX2tH9Kpad7uNU6	9087	12836	12836	1618249680000	canonical
18018	3NKZWd4wG76Dfjvwhtw1FJ5QbfNQhKo5517LNjCVbZqodRaPSGfe	18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	1587	1357	309	6301	12463	jwj3kS9Y5JGKBaYKg2NyXaotk7yifQKa24u8SzesxDKaiBduHit	9089	12838	12838	1618250040000	canonical
18020	3NKL1xPaRHv8xNF8vg7WxfyFBcDmVhQN3mYmA2J9zPTPijVkEbcr	18018	3NKZWd4wG76Dfjvwhtw1FJ5QbfNQhKo5517LNjCVbZqodRaPSGfe	1406	1393	309	6301	12463	jwBufBajf6VG9hJtZhfQtYtjroWiTfk1AfyodPu7DCrpbWNytH4	9090	12839	12839	1618250220000	orphaned
18025	3NLX2LKw2irQDA8P2LZiEiBqLiGVXXWZg6uVP8sxgPARRTQrrckp	18024	3NKQeG2p4Lo3NGCWELdL2heJNfVfWnGYHG6yG1SxeGZmVxwhw7HN	1407	1395	309	6301	12463	jxNpm9zy8QEZJzsT7US9D5dnhoDyAJCE5HXpAGt3648BVGRrYUU	9094	12844	12844	1618251120000	orphaned
18028	3NLH5Q3KKBgaMQ7S21HBSxLFB3GMz5a5c37HCp9JYMxocAsXmLha	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1634	1085	309	6301	12463	jwVh4rjd5YpWFQNVoyj1wreuX2mBRnDgLAxUKJ9A5DyrjKpM5ai	9096	12846	12846	1618251480000	canonical
18041	3NLUWdDoL1kKYn7Rvb8L8vG59Fc33DHLrnY5RHAuvCBF51hjxv1q	18038	3NKt9YQ2DiZWZ83cNtcEMA9mHYDS3iocPgvn5rvDe9iKDpyQNuoJ	1405	875	309	6301	12463	jxtuAKyjTnUG2uZpWPQSKa2oTQybwogVf1eDx45noN89ztHs1Lb	9101	12852	12852	1618252560000	orphaned
18043	3NKMHLfxeLLtM1kLaUNipkDEg8B3K2ry9yYkHYGTKPZGGAuboPyQ	18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	80	1273	309	6301	12463	jxxcRR1m7hhconBZLQgGBZenLgeUckGG4H3CJn8cN7mEEZZ7CUE	9102	12853	12853	1618252740000	canonical
18045	3NLdddWptSCgkJ7h16h1DZWehgGqah8b1RQnzMk1CFGERAjNqXdt	18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	1403	785	309	6301	12463	jwJkrSzKUCrziMPVCCf21Lxkc2CG4HZUn6F5xrbPQnVJYDN93m5	9102	12853	12853	1618252740000	orphaned
21416	3NLJhcNXUHGstH1i1WuS8RAF5pBDSTVuS9hiFmQFt8EbZZm8nGoF	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1657	1344	390	12463	13633	jxY8scYgiub2uGx6wxXDGT3vW3HdsPtLYPhETxL9wMGHjnbc2Nd	10740	15130	15130	1618662600000	orphaned
17961	3NK8nh5qX8zQkGi4KDyq5G9y7oCRTGb6uTCwVJ7fEHkYAK6BvHLv	17716	3NKMwveqMeTiWmGEog6JPUS2U9SMkgbZe3jUBqdFyAFZLLxhqX3j	621	621	302	6301	12463	jxhnv6oraXG7nLGFv4awm5JQqNeEjvnpf7beZdwxsw36T7a12rU	8954	12798	12798	1618242840000	orphaned
17953	3NKhphhYP2KJic5ySbKiaLNmaiyRPrSimCiEnJaJDbVSbHibw9DU	17808	3NLwcyhHYyc3MGwbL7N6etjZsEKGJUbSqNLbw1gYF4HvdbcyrPHw	1647	1176	304	6301	12463	jxapM9D4BAWrbVu8DZjS8hkiegLiFcgXRzgQcaXEHqCdduE7Wrv	8995	12794	12794	1618242120000	orphaned
17916	3NLec4AKTHd2BnASeFFqeDkPjv8yCn1doFpcGocKFXimwUx3dcVo	17915	3NLEkZguQvuZM1Yp6krFk9gLDZ2VL5mmY4kdUeiqVubEHxd8vGYi	1590	934	306	6301	12463	jxyY7fz8cuinGiSaSsv8cZmyTcBHC7HEAnxA76edGQyQQ2kj68K	9037	12773	12773	1618238340000	canonical
17920	3NL1nG5x75u7n1HqCiSMkTt6Js5LB4f9wPC42yikc9oe7Q3RZXes	17918	3NLhTgv42saJn5qNbUXewwhNcWL6CnsKToSYCMTH811yUA8PLQKB	1506	1247	306	6301	12463	jxoxHrZEDDeLUx1KebDEiYN2kaP4e3zfhcJxJRyWJyv7sBYFyVu	9039	12775	12775	1618238700000	canonical
17925	3NKW9zS46PZW76PyRniA75GKJqJGZ3NQn7gNXAySFs69tBWMhJzm	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	1483	245	306	6301	12463	jxpF6aqTGKpLKbmL6TZDUJTG1M7L4J3Zc834eP5LyKcu5tZ1gQt	9042	12778	12778	1618239240000	orphaned
17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	17923	3NLangiYPgKRPMgrEPNUcdhzTsdaPjPwhTDKh3gGB8C3fo5G1TpB	1407	1395	306	6301	12463	jwh4ET2rnreb95jqeA3kD4isiHPAhuCK7NCUfydwAwvzv6U7GHV	9043	12779	12779	1618239420000	canonical
17930	3NKtVhkYD3GbnhPExkjDQKWJPvEBAcceaExiygmmFu31W5eFHKpL	17926	3NKnFtKPNTeM6vrqMkusqpKEdLpKu86cznRjYVxCAa5ymwuHk2Vd	1483	1276	307	6301	12463	jxLUCzuLFtPYT1sDxayVoaBVqkwmhAiuHxQYapzayiLLQfpU7vR	9044	12780	12780	1618239600000	orphaned
17936	3NLw1NRcarUHeHUnd6MgSVx6h8RRHNukruRnQ39L5Ze9nfKhFrnX	17933	3NKGozyRrKEQHCP4hWVmibkxAP1hanyBihbso9hBinTLkqDcn9kD	1579	1389	307	6301	12463	jxnShpx3uY9ZuUadfFMgUAZPevH5GKJRfCPKCwy4DpSJYmEQVke	9047	12784	12784	1618240320000	orphaned
17942	3NLmqti5DD2XzLRaRf3kZd5Ls1Hy8PZNL7QoUkvn6L2X9cvj6iZf	17941	3NKMnpvn99irDWSeC2EAVoEidtfMUtdJpvJ1hsq5FqUVYGfe7Uj5	44	1325	307	6301	12463	jx4urKP85wHTn8imoSj7LBpMcsZHajonn8qEkfmzwHXkDZo7f6q	9050	12787	12787	1618240860000	canonical
17947	3NLx8RfbHJFqYqGWtJ7r2jT9jjMp49aQhDjY8CNKM5unLh5PCWBY	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1672	1285	307	6301	12463	jxgkwLfYvqvoCAUvv5Tsp8KnxZHfVzNJr9TSCeFKkKWuJbmvytt	9052	12790	12790	1618241400000	orphaned
17954	3NKbCKZfmCXZiaXJamZsNog6ZMxMnMdoJDBWwBMeJoq7brfEM1zX	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1668	1370	307	6301	12463	jxmDVgetRnNnAboYZ9FrWZK6Lwf4vPCxoXrnMGCpjd9UPDXUxos	9057	12795	12795	1618242300000	orphaned
17958	3NKyU9eFVXSUSU8jYDyembGSkJZET72vExvY4wfVfA8ByWRxqFKL	17955	3NK4pxZF7q4WKKqsxu2PLR1PGiwZTiqqLpuzoePDLKG9GreURSp5	1553	776	307	6301	12463	jxq8XDGbi1QU8yELNGUeLttDfX8TBc4fUX38zpaCrqL2QFVaC1T	9058	12796	12796	1618242480000	orphaned
17962	3NL1atkVjoG6bpmEszzw2wRReaXAxw475SM1ybtqjVyGvdzqP7UF	17960	3NLgD5A5ZF13BzKAWXtczBZRA2jSvkAMhHdkcQkdF9Ypx3MZYzZG	529	529	307	6301	12463	jwPTtqsEqUapZJqtV6qkbLwexhy158eHaGGT8kwjJGggsUkn8po	9060	12800	12800	1618243200000	canonical
17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	17962	3NL1atkVjoG6bpmEszzw2wRReaXAxw475SM1ybtqjVyGvdzqP7UF	1672	1285	307	6301	12463	jw8rkQz3Y4xJcY1tcaFkNLEq8EY7aCFFwkaQBzis2cXQB7ZjgzX	9061	12801	12801	1618243380000	canonical
17994	3NL6bhs7ReWgGJnLjvKdG4YgFERB2hLwE7gpwZgg6SNjteivA76p	17962	3NL1atkVjoG6bpmEszzw2wRReaXAxw475SM1ybtqjVyGvdzqP7UF	1444	1381	307	6301	12463	jxarvg6qLtJgZkAmgaowsQhJ1EwgQoDpR6N5QQKoHLmCAE9camv	9061	12827	12827	1618248060000	orphaned
17964	3NL4F73esWZ3mzfe1Mg4wyyxZkSh7AHDTakEiRiT7avPftuqtyuP	17963	3NKeQ6J1mM72oAeoqHhocmvQsSbpPPNfZverUFD61iEo218dg7x1	44	1325	307	6301	12463	jx91wmeSdyFctwKfB93oxVP4rw5pBexnpFUSFMBoFo3PBh7CgNp	9062	12804	12804	1618243920000	orphaned
17968	3NKXFGjTGpjBoTqgnPj163UruBRbCBwcMGdHzMsxQ5iwgeqVHbSE	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1406	1393	307	6301	12463	jwdtiRUeT4i7ALA71XmKarMeVvFGpQ7FmYVfZqyxkumdr5sGVFc	9063	12805	12805	1618244100000	canonical
17969	3NK6zhqXS67HVFKThRXWhT7vDQnmjKzSJrJLkFPbd58WVwzuCo9D	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1578	1296	307	6301	12463	jw8LEaYatzsk3a9VApQgMu7SzhkKKX7CyLFoCjtrjQdhziN69oQ	9063	12805	12805	1618244100000	orphaned
17974	3NLi7cvrHJvv2ydkEU4JLnY9vxH1zHNtqDtqB3KAD3patNHdmen3	17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	1578	930	308	6301	12463	jxQ7LYWP4BHYDNortuDu4fU1ZTnxX2zMmTPrYxVpvLvEuT5AVKw	9065	12808	12808	1618244640000	canonical
17979	3NKYTouzhAPgJiuH2a9znBJgJCHctEUb36xZbjpzgyJtuyK5nzP4	17976	3NKJHsAegQfn6hj42xgrySmPjNgP2j6eMyS5G2zEMJZZ5Rr2Qbgs	1643	1053	308	6301	12463	jwU5J28cqhnuWWT5QP28ngnzKso1WqCzSbenUkyCabxF4bBNX3B	9067	12810	12810	1618245000000	orphaned
17980	3NKCZBJ1QcKAo4ir1zTn6cDupKnwbcE6ZSBLTCZndhdP5d958R7K	17978	3NLyNhYBttYxBQHKhJHnNEEQmNCJuRcT2PTND22gjpsx8SpBavXR	1553	776	308	6301	12463	jwj5hBk9pqu2cfPH8LDKNS7nFLYgQFzCb8SBPDCavKvjgWf6Exm	9068	12812	12812	1618245360000	orphaned
17990	3NLipawzee8D6tfSCthdbt47Bi5XbXf16Th4xQDL3YvWhVvV3RE2	17989	3NLdRhi2bVSXSCpVV3UYYZS51tNGrg24gmh6CXhk2mYAYw9Pyg2B	1407	1395	308	6301	12463	jwRpYrrTuPHRwBeL1ZmiXXWC6g52PmLHAtZJKghqRXpFeRYCVyj	9076	12823	12823	1618247340000	orphaned
17992	3NLT4noh7peEuXqKvW113zYv8SYHnAC5MinGQRYC9m3F9xYqiebM	17991	3NL3srEntcYQpAFq1vBFHCLj5D4y6XjaPLQrn5bzN2ykL4V7iy1s	1406	1393	308	6301	12463	jwar3UY5HqfcpZeepePnKZWB3yAsrBgPEZxNRgn8hdgUFwbK3sL	9077	12826	12826	1618247880000	canonical
17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	17992	3NLT4noh7peEuXqKvW113zYv8SYHnAC5MinGQRYC9m3F9xYqiebM	1444	1381	308	6301	12463	jxzayh3ppEbsUwETzUeFS3mAWWkMjBnTAeBg6o7Uf61wAW6oALv	9078	12827	12827	1618248060000	canonical
17996	3NKyHCj5NUwERFcJZPUidsqho7upyu38Y25EoephaFckZm7gCNLn	17993	3NKkZNH48dZNcg6xiDxwjW2JK6rvF4ym6bBBH1NDQD23rWFxdFUB	1623	839	308	6301	12463	jwwoosKeDjgJZjKTJdCQUNFDNfMRWtRbfEV1Wi3vWxyZkwRSju9	9079	12828	12828	1618248240000	orphaned
18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	18001	3NL2ehiffHNs2ZheVeVVur6oRm3WzqK4UuhBcdbC5trmdMBfMNS5	1403	824	308	6301	12463	jww4FUzz7wfWkNKmsTph7zV7NVqGitDLFhw3G4JySPAr7Y1smS4	9082	12831	12831	1618248780000	canonical
18005	3NL8Z2YzLsGkUmX1AGnArWgK9sKQ4CDQ3LFzGwjS7ETwHtNVb5Ct	18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	1657	1344	309	6301	12463	jwJX35x9zofaoh5FDGKfwokhrhPUMfwLXrNB7gWWDefYjMRZACp	9083	12832	12832	1618248960000	canonical
18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	18005	3NL8Z2YzLsGkUmX1AGnArWgK9sKQ4CDQ3LFzGwjS7ETwHtNVb5Ct	1675	1342	309	6301	12463	jxBQAknLDvBDYTwWqusLNGocpYzxQgHr5ypcTbPXn7YwfewUTRc	9084	12833	12833	1618249140000	canonical
18012	3NK3C6ktRr8PGypqDMF7XisJSBHhtqQDKggVEyazEoZc4bosaLbu	18011	3NLPW8NWAJMM7TNn2dAe6dCE2xCsBx9AkoTAENvXMj8yyrJfioXH	1542	1304	309	6301	12463	jx9fiYEsRzYYcmp9b2qGnbpcgCND1dLUt8aqSmB5wVzKr3k4fSS	9086	12835	12835	1618249500000	canonical
21439	3NKq9B9uUGKx73DjRWeRJ7iZ1HCijkzEteMDFPE5aB5qVpmTjLpN	21438	3NLwuYU6JtegiyYef9gasDL3Zph2rAF5E6jfMHPJ36FRwaiLTA7x	1651	1055	391	12463	13654	jwiWN6kqtUNqXqq5xYB6U6ve26e2zrvVCJf2RfpWShoDek82jHS	10753	15148	15148	1618665840000	canonical
18034	3NKszcAFgJPx6bEpiw8twoaAiYBVmEdev8UrLyqCqPRPXx8cHJqP	17927	3NKHSjtrxEyFfnVSUYR2mfXxY1katvbpNAm548GhZQXYrU7oR7Jh	563	1359	306	6301	12463	jwcbt6g6DYAg7SXwvMZydjHGo5FnB3s1aYJxKWCYnfwU7BudLy8	9044	12849	12849	1618252020000	orphaned
17973	3NKqKtx9pacF6wyUqqYNoL6T4ucTAXTuaR8m5VbH278KKFQdBfK5	17971	3NKTc7gWcQqtrB68T4gf4uiNNy5VKsxsqQ1rYtbRrZGy9nVxWscZ	1602	1123	308	6301	12463	jwAfRyUEGH4ipg3nS94BEJCYTYLcqzXkig1bGxXCRtgiPaRETW2	9065	12808	12808	1618244640000	orphaned
17978	3NLyNhYBttYxBQHKhJHnNEEQmNCJuRcT2PTND22gjpsx8SpBavXR	17977	3NKvHbe7uCFwx6sZvKu8xrTcwSHnSaVDVLvzzvqqKtGuq9KY589T	1599	1287	308	6301	12463	jwwveCpyV7AQ1KDNnokUumRuUCFzVJF952eziw2fGAjYcUF2A6w	9067	12810	12810	1618245000000	canonical
17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	17997	3NKGPmr9mJoJVy43tZXSbj4YR5iqTvhrRPayk8VbDMCFR58Fq2Fb	1407	1395	308	6301	12463	jwoYRgDdMRqL3fFRiQds9faiL5Disoo85wsC4dPWwUVPzEFVTiE	9080	12829	12829	1618248420000	canonical
18000	3NLoDCqLxN83iGis5fAv4nqkW8DVeVJikme6upTCTuexDwPFAePv	17998	3NLa1Pt43xf2GKbDtrfoEzBrAbBrrdQjFvPY4ksHKBZ495w4QkDt	684	1226	308	6301	12463	jxY4xQp821n3wW9uiGupVwcDwTv6JwZ1Tb3wWS5PHuZvWfL6wnx	9081	12830	12830	1618248600000	orphaned
18007	3NKjqhpqobANa69cUdLnqXVuJZ58a6gSu5ubmDZtNZhxR8NEPeMo	18003	3NLFNZextYbvwAycGXLSzQVawqnZo8s7z3KKoGYNsnzvVfzL8ybD	1675	1342	309	6301	12463	jwgoQk5y9GkxYm7Ze7bxPqGJH8p5ZEM6dWNWHc8am5AzKWyKpVU	9083	12833	12833	1618249140000	orphaned
18011	3NLPW8NWAJMM7TNn2dAe6dCE2xCsBx9AkoTAENvXMj8yyrJfioXH	18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	1637	816	309	6301	12463	jwW3S3SMwBazeBQsBrAP2Z2q1HUzugYK1HgW7Pe5j84o3NP1AHf	9085	12834	12834	1618249373224	canonical
18014	3NLG4AJ8rZ3BAutygh47n5gmk7jVfmeTVgsgnQQc96YUX6Pff68D	18008	3NLeBx65a5fzJrGtwHsQ5T8bmhEzhJSQ9sbgQTPLQ57w2vvGbBA5	1403	824	309	6301	12463	jwsCxiJvqLsYRE6F5HTPtCV5XJLw5Hu1qWWPjW4fuczUybrET7u	9085	12835	12835	1618249500000	orphaned
18019	3NLauCJjxgpHDAgnfokJsbi9rq28ciDaH9cWk5zCwbMCBLVgjUoU	18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	1587	1357	309	6301	12463	jwpyLmdf3jpTCee4WQ9sc8YvTFndj22hvGLkXCz8cmg54ah7L7c	9089	12838	12838	1618250040000	orphaned
18022	3NLU3Dus4CZTotRN5Q9uJRYLiUkyeP9QXStNVERZfy8dM9sCvgsV	18021	3NKzRHwVPai1ou466JdyEVnPHLBzmn2dbfDB3ebrSdDbcpCxwCxb	1600	1246	309	6301	12463	jxbbfnEuFZLk9XvwfXECrfmxDDFf5ucswmnVPQUUvr7495o4HfM	9091	12841	12841	1618250580000	canonical
18023	3NKJP4pe8MiB7QksEHUzM6WV7WACLBkdA1QsqvHpWX11Jc14b9BQ	18022	3NLU3Dus4CZTotRN5Q9uJRYLiUkyeP9QXStNVERZfy8dM9sCvgsV	1406	1393	309	6301	12463	jxBcsHJ59UeYgJ7BJkYELNy6yzgGRpQcBKy3Ao4UsbFr9KWsPRF	9092	12842	12842	1618250760000	canonical
18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	18026	3NKznHZmohvJ7LkHLbNdTg6UwU2V7vA5Ty7KghiHsf9qqs3UHizY	1503	1277	309	6301	12463	jxLXvYtZUPVLZKPiGpsK1yXuHBxAN6PVaWdqkVkMCukd3RsRUhr	9095	12845	12845	1618251300000	canonical
18029	3NLZXxBcwzNXCUftQo42JGvhvvxEqUWBNFt5WbLUrmR143RNxEB9	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1599	1041	309	6301	12463	jxAodB3r7E5mDYnZE5b7ZHwFKjFT2N2xfxFkLk4EGPXx4jYLEsm	9096	12846	12846	1618251480000	orphaned
18031	3NKRPJh4uXDVQvcAcLYfc5m4QChTWnLYnde3DsSrXnZgbHYRjiVS	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1637	816	309	6301	12463	jw7nuzvpt5oh52sj2gQKKKyy21uMMj5xXD1GmXRrFsPXyQ1dSM4	9096	12846	12846	1618251480000	orphaned
18032	3NKFsgvkXfkuNBTowfJZZV3JN29e6SGRiQ2DShAw61gMQGwvcRkN	18028	3NLH5Q3KKBgaMQ7S21HBSxLFB3GMz5a5c37HCp9JYMxocAsXmLha	1637	816	309	6301	12463	jxxkkZvcBfzw7BjXUgCPnj7tfVR7o7oCoqQ4T4grRJXmTeqKkfh	9097	12847	12847	1618251660000	canonical
18035	3NLjfH1uryDJPNEEMWhgY5R8yw89ZhUote4HhL3rDfZEQ3hSaEno	18032	3NKFsgvkXfkuNBTowfJZZV3JN29e6SGRiQ2DShAw61gMQGwvcRkN	563	1359	309	6301	12463	jxFYGUex67kXwgGL4KVk515qVfGBVbPxVpQWYx9N5KsYmBNK6qt	9098	12849	12849	1618252020000	canonical
18033	3NKkcoTvXcFUVeyjg8afNUpPHGSHtSBh3ZFi4mFxavmNBeZhvneX	18032	3NKFsgvkXfkuNBTowfJZZV3JN29e6SGRiQ2DShAw61gMQGwvcRkN	369	369	309	6301	12463	jw8jKSwXf7XFhWuALd2hpcSoQUBvK3TxcniKutDTSNHeH1BmQmr	9098	12849	12849	1618252020000	orphaned
18037	3NLHwVkUP1DDAvGCcR5hKkY9uWCcVtFtunS1grr4tY1ghpn6kbwC	18035	3NLjfH1uryDJPNEEMWhgY5R8yw89ZhUote4HhL3rDfZEQ3hSaEno	1407	1395	309	6301	12463	jwRCjEooBL5xuyyq9ejYttmfUqsfHgwzSocDivNgeH1pAJQEDSL	9099	12850	12850	1618252200000	canonical
18036	3NLAZM8rSpi2wHScM2CyXUsoFUagmjm4AiWgkpeudgxFXsqyb9kx	18035	3NLjfH1uryDJPNEEMWhgY5R8yw89ZhUote4HhL3rDfZEQ3hSaEno	1402	882	309	6301	12463	jxaYriGZoCueZ9v9EUARND1rJY9QQa2jiLuYJVqWYkRSAcBboy1	9099	12850	12850	1618252200000	orphaned
18038	3NKt9YQ2DiZWZ83cNtcEMA9mHYDS3iocPgvn5rvDe9iKDpyQNuoJ	18037	3NLHwVkUP1DDAvGCcR5hKkY9uWCcVtFtunS1grr4tY1ghpn6kbwC	1407	1395	309	6301	12463	jwfQBMM5PK81Dzca2BXm5vNPSufQ9tiiuAxb2E3tFsSWvSFjb5U	9100	12851	12851	1618252380000	canonical
18039	3NKDYV1VT36ZM9qdntKxQ5qB3UpFZY2XTQs9Kgg5RvygvvPKtcF5	18037	3NLHwVkUP1DDAvGCcR5hKkY9uWCcVtFtunS1grr4tY1ghpn6kbwC	1627	1385	309	6301	12463	jxWombKudt37RVmspScznefcwDFCzMNYfeCVxMCMT4M6YzUYupe	9100	12851	12851	1618252380000	orphaned
18044	3NKdkNAyvU2mi8LZMrHtiUfGg9PqhSe9yy32WnqWDZFCgLW4xoZs	18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	1534	1317	309	6301	12463	jx2DXLvsrEmEZ4CM4Bgr6EG9hX4vYyaTmexTdW7hYFJ49RK2khq	9102	12853	12853	1618252740000	orphaned
18047	3NKKBPTzD4vba4CS1B6vm1Th5PRbzosSyzK9wEodTdREGiPoCQDE	18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	1407	1395	309	6301	12463	jw7zgzhrxmDGkR9jo7HAzgwRpZSc4wmKYgPfuTUpkdU3jSHNbT8	9104	12855	12855	1618253100000	canonical
18048	3NKHCrhrDBinAUQDjdXTav6ydnMuwytTVun36vCLudsHUN4gvzuj	18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	1419	814	309	6301	12463	jxbvpJjujUecSNHkYBBwEfFBKrBMQPaQD85asAkx3taKES6ZUxu	9104	12855	12855	1618253100000	orphaned
18049	3NLckD3uMFncXAifJ2ymK8CrshSuz84t3Xj6ZYGqvLGjHqZRVhXP	18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	1637	816	309	6301	12463	jxYawEBUFcQmMPu4eGheMjWpvagBTYYLB5QmqCp61S8LfftLEYW	9104	12855	12855	1618253100000	orphaned
18051	3NKracEcBoLgnrvP3dArY3nWANTzjFAMFGYmqdG8hr3hd9E9sPEy	18047	3NKKBPTzD4vba4CS1B6vm1Th5PRbzosSyzK9wEodTdREGiPoCQDE	1648	1284	309	6301	12463	jx2hYwiNzG4Xh9BtmEB1zWWswivzFsrm7fVTTopGZxvPbEuYzGz	9105	12856	12856	1618253280000	canonical
18050	3NLHuJa7qtHnxKWknJtuwkVqrafAGrhRHjhdt1z8jPgkZgdHCmD4	18047	3NKKBPTzD4vba4CS1B6vm1Th5PRbzosSyzK9wEodTdREGiPoCQDE	484	1319	309	6301	12463	jwzVzQG12NE6pxfdWqXEsCp15HX1W2RPgfMN3BakeTEbAJUmy5P	9105	12856	12856	1618253280000	orphaned
18054	3NLmBZWXZVUKPFwNFfrVbS4vfZqLdYKHSA5kpTz1iPCJjfoF8Azj	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	44	1079	310	6301	12463	jwpnW6y31fsiSvLZDiafqHXyQ4i8raTtS11rkxSxmCVS1dGpPwf	9107	12859	12859	1618253820000	canonical
18060	3NLAVuV6dUyBLgaSQxiuLdLMf7bGGHHsyxcxAS4ymVkA1NL9Qag1	18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	1654	1340	310	6301	12463	jxEjBZV5v6tbhAJctXxEggeXT8tLSAJBryWNPUmxn2hrRjzjgxD	9109	12863	12863	1618254540000	orphaned
21447	3NKKEJaoxPopUgMpPn1XxyNxETzzeKrdKccQK1qZfJLZsSJtxmVc	21445	3NKLx6XQp4W5yKhfSzP9gXPjb73rgDXc2AVpRkq9WY3ianAi84XW	1596	1237	391	12463	13662	jwAbei6rzeK4SEfDfbTKwLavAsLy3KneVJaY3qCn4ddQcHktu8X	10758	15155	15155	1618667100000	canonical
18089	3NKKdKfHUhYhAANYYywD2TmEZArav66ncGW1uhFS2fgZRnckZd46	17953	3NKhphhYP2KJic5ySbKiaLNmaiyRPrSimCiEnJaJDbVSbHibw9DU	1647	1176	305	6301	12463	jxcKTpb5QkjoQgHgr4DZCYkFCbVAhyfkM21VMzoPxm9SPjHvZ7T	8996	12881	12881	1618257780000	orphaned
18042	3NLZ1F3F11iYbm18D8CiFa3pXrxYBud32s3t9M97xrQrXw58uGLj	17819	3NKFULBwx2bbuiodVhtD7WA4iySQhYLgpcj1Zncdz8AgUMVwLSFp	1481	790	304	6301	12463	jxesLtHsA4aem6MhXnXKubGGYCrnaBrV4oJ8FCJQ9pkRWHTKocB	8999	12852	12852	1618252560000	orphaned
18085	3NLajmpMCtHX1P9UzYAT3ZEj3uMWj1rFww68wDeaLvQ8FDA2Jg8v	18007	3NKjqhpqobANa69cUdLnqXVuJZ58a6gSu5ubmDZtNZhxR8NEPeMo	1547	683	309	6301	12463	jxiyWSeSHEz3XSSM3ExfdMw7jhUp7ZXbuL9oKCWxAN8w5eyhM1u	9084	12880	12880	1618257600000	orphaned
18024	3NKQeG2p4Lo3NGCWELdL2heJNfVfWnGYHG6yG1SxeGZmVxwhw7HN	18023	3NKJP4pe8MiB7QksEHUzM6WV7WACLBkdA1QsqvHpWX11Jc14b9BQ	1578	1170	309	6301	12463	jwaYbC1Fk3nSjmPtScxteF56WR1LML65JTzza3V7Crp4kGDAyp8	9093	12843	12843	1618250940000	canonical
18026	3NKznHZmohvJ7LkHLbNdTg6UwU2V7vA5Ty7KghiHsf9qqs3UHizY	18024	3NKQeG2p4Lo3NGCWELdL2heJNfVfWnGYHG6yG1SxeGZmVxwhw7HN	149	1157	309	6301	12463	jwFjdXTek132W5dCCJio64TRenPeb3uKCRiGf7zhXmEBw5P2MCg	9094	12844	12844	1618251120000	canonical
18030	3NKcVvoZZiGvFG637rGksQMpAWxq2SRTaAdzLBcjDNyS9kqoCW4Q	18027	3NLHULdU5hTSy6fHyok4ttsDk5wse5cdKx75jBg327RB87ZDkxpV	1419	814	309	6301	12463	jws7dJcQ3YshpweYxNBNAZV7mEE3dtksMxT15eYmVeMce8r5u9G	9096	12846	12846	1618251480000	orphaned
18040	3NLTvCPGiPwu1SCFWMbZH3fEHDSHAAu64dEeeAmEiyzcsmJzsBjy	18038	3NKt9YQ2DiZWZ83cNtcEMA9mHYDS3iocPgvn5rvDe9iKDpyQNuoJ	1588	1026	309	6301	12463	jx2Y2QUoprFRZgjsT5Kui6Vu8aMD6GcKwk7hiqTY9do4LmvQe3n	9101	12852	12852	1618252560000	canonical
18046	3NKWBZVVPqcrLeua93CGMCkFXYaSJ6jQ4xzKWYjGciXrioFThGCd	18043	3NKMHLfxeLLtM1kLaUNipkDEg8B3K2ry9yYkHYGTKPZGGAuboPyQ	1406	1393	309	6301	12463	jx66ghfyzzKH2195hKA2DxxL9SZtUeY5sFRdkmkafwbiFB5aC8t	9103	12854	12854	1618252920000	canonical
18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	18054	3NLmBZWXZVUKPFwNFfrVbS4vfZqLdYKHSA5kpTz1iPCJjfoF8Azj	1461	1271	310	6301	12463	jxZTEZXx4xDvMmw7C1PASUeWZk11Gx1E8t6qcjFpWb1mRb4pFrE	9108	12861	12861	1618254180000	canonical
18058	3NLSHLM91h5SSS7QGqEqceRbcNA98sjxWqnswyU4DS77V5j3XLSM	18054	3NLmBZWXZVUKPFwNFfrVbS4vfZqLdYKHSA5kpTz1iPCJjfoF8Azj	1476	1371	310	6301	12463	jxdt6kod1juGUQMwSe9ys2UDVwpr7gzV6KpHzJPsF1KK7chC3Pq	9108	12861	12861	1618254180000	orphaned
18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	1405	873	310	6301	12463	jwxS5271ibMPRFifCdgRXV7o2kR67FRVV2erZPWmtEkRZEJEHGL	9109	12863	12863	1618254540000	canonical
18064	3NKiveAsnouiwTaXjuRj3SyJt5VQqk4j2QXY73atTVHv4mTTDv3v	18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	1477	1350	310	6301	12463	jwf6qhZcEYcvB2GSeZ1BmTkSX889Az1cBePxDnnTGDMMhoXYiBu	9110	12864	12864	1618254720000	orphaned
18066	3NKnydX6PyQAby6PjsUAnfTaePZoSumcEGaFt3hiidgjYYbVcQXe	18065	3NKBNBrrgMQr4vE2ceYdrWp9f47SadUCPS3NU3BgaJCetx98xCF1	1405	873	310	6301	12463	jwRfhsb2eLEwSTasG23C215P1NS1FB9Ke5BWPz1i1ejL7WRc9jV	9111	12865	12865	1618254900000	canonical
18069	3NL5amxM9XXH6TagkUY2vLyff7EaAyfxphz13kTkEvt1y2Ro6jBL	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1672	1285	310	6301	12463	jx8XiqzFznJkZnm8F5FRTq9pxRAkvLJpn9FkGJuBupVYnnvGEne	9113	12867	12867	1618255260000	orphaned
18073	3NKXAoWS4PcnWKnXuh1kJMSVnf6yfZE8YD4CXxSHH1kGi63d3iKg	18070	3NKgQuNqVcArBLookgTXm5cYS1vE8rtiEj64W9nV78JDXP3sFiww	1670	1282	310	6301	12463	jwCMEcCKs3AUHFGKkbCkBoBpbUaczURRuNvbcqEgWHf4VcJqnha	9114	12869	12869	1618255620000	orphaned
18076	3NL9VqpU7FSX25ZSh28H2eh7NCHmWaHfZ37zMHWE346gnSPXF9QT	18075	3NLrsGAhKJmDtCouFsjnU5SpFSyPpoxZvtnzYP87qnSJDuHJksNd	1623	839	310	6301	12463	jwNABvXkx8rFBapnvaY9EyuZ2AaSQ2Aymv8x6PyYN36FhiGu2Dd	9116	12874	12874	1618256520000	canonical
18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	18076	3NL9VqpU7FSX25ZSh28H2eh7NCHmWaHfZ37zMHWE346gnSPXF9QT	1646	1354	310	6301	12463	jwsJKZHdqrttsq2JUn8MJoP6UqUvtDfJVHb5mNLimKWrZvBj9CU	9117	12875	12875	1618256700000	canonical
18079	3NKDv4uYdwoeSBiDwRRXBrS3jLnBikxpfsqUSUV5z47wqx82ztBL	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	633	1138	310	6301	12463	jxXtf7sjbQUbpFfLFwjQXzVsjhGKtdMNQxs68jntLjJuyQD78Bp	9118	12876	12876	1618256880000	orphaned
18081	3NKKmBEuDzWn5zPJJw6KhAUqsXxvm7sZXmqMTWfERxCubJrfRby2	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	1594	1326	310	6301	12463	jxsBmi8UoecHNbSt1cQo6FLLQeJLXrx7hurYJdoEY7DSk7fpBY7	9118	12876	12876	1618256880000	orphaned
18086	3NKtVSvNF4ztdvTSsEM6kzYKV2269XBhGvVpBLHUmaaD9DYqW7oC	18082	3NKdmg3FE2exgEmNgSG66Dp61zZpa4DTFFhXYhpzsE6yBBYFHgWr	1534	1317	310	6301	12463	jx88PXd2TVq9tvj2pExnYEUGJxFfZ5nQft1zz3MXdiXR2uh6MAj	9120	12880	12880	1618257600000	orphaned
18087	3NKkskyPTqwGsSnAM5k5PusHV2HdFzHcpashEdG2Xm5Z5KxarkPC	18084	3NLRteVNkn5Vt34xZGD4khoeVjc2JFiaXYuSQcfxk1dhvQFSRvwP	1647	1176	310	6301	12463	jxqSS38Lxsyti6M3UHaByrkhu8FNB6jAPBN4neY5ksTisTpxzX6	9121	12881	12881	1618257780000	orphaned
18115	3NKRVevNiUKRUwFknECdjpaeBz7VKk56QSe6RbXUBejKCSVko6hA	18088	3NK6f32pmrS9dXyjx29mGGSkduQycibEKY3eULbUobcZ4jdVnxFb	1474	963	310	6301	12463	jxe133DetaYiFeqx8FYX9qLov8pkZ2JgsW9wEdw3roWWAANAwX3	9122	12897	12897	1618260660000	orphaned
18104	3NKEAMccckxpx8qQE2jStRkNFSZSk3Ga7W4NVkvLxTLeoNRV3Jqg	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1671	1239	311	6301	12463	jweaUFoAHdwefges5tNS9GNwbPujQ9wpJLpgHNBGdB5sJkkMHDq	9132	12893	12893	1618259940000	orphaned
18123	3NKMUPkJkjH4KvJ4ri4goanHUAowTtT3qWG388Uu6v3UeHjr5Lki	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1602	1369	310	6301	12463	jxhzA7WDEVZY5FdfaMFaxc4grUSZ3wYbBR9azHuJdRN6J2Jt9m6	9132	12905	12905	1618262100000	orphaned
18106	3NKyiTjMuWKidgUcjsYjsy464TQg2BQpXoBRcH79VfYCCWcuMhbC	18103	3NL3mxtXqGiqUHswydNwH9z9CbHYEedSL46TWnGbyvkc46NJnk2q	1587	1357	311	6301	12463	jxKLTi2V7id3xXGb9pWNVkHYLGRq3jAmP6tUUvACiADxvCQ3k7D	9133	12894	12894	1618260120000	orphaned
18111	3NLX3w6BLoRV7eEtt5LaLyec5JLjdFmdxMLD9ucbnAQEnVeoD4ZL	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	448	1305	311	6301	12463	jxTqxmxDXyH3bj3TydGAHHBQbNFNtjckHgV4Poq68DQTRKXhmxd	9136	12897	12897	1618260660000	canonical
18118	3NL2csrWeerUKWDT5FjKKfokLY4nxQLYyWHAVieJP6XDyf89Pafm	18111	3NLX3w6BLoRV7eEtt5LaLyec5JLjdFmdxMLD9ucbnAQEnVeoD4ZL	1402	892	311	6301	12463	jx7Fxm4uppsKmrc1hxYD7AKG751Wirfp3sdw4SxiML4NfRpkfgS	9137	12902	12902	1618261560000	orphaned
18133	3NLHxzDjHjKEGoUszdSiuUReNZuf7qXtRhMDk66q1Rbh448tkg8D	18131	3NLp8TFc5x65hqrrhnhPw1t2yf73JXNHEB3hin91kox7zGJukWKn	1553	776	311	6301	12463	jxGmixxwqXAfp6g7KEo4TWjRPJBU4uQha6dLAqfCpHh5wgb76Aa	9144	12914	12914	1618263720000	orphaned
18141	3NLUv48HLw3PLoV7AcCV1GTVRyTYkWHp6vmqyLYpNx6HQcGTSJYX	18139	3NK2zYy1iECqEhFJj6G6LK8cEZbtZeAzT7eTP3KVbLjkvJs6h34Y	1613	1349	311	6301	12463	jwYsfMQi2RH3spkxRDhdnnqWdvyUygGjhaxDoWfnEc8PhfiXXtP	9147	12919	12919	1618264620000	canonical
22071	3NLYcwBLaPbb19Qz3H5y6z1zH4ePv3GxkTj4VXwneiLpW98uyRzX	21754	3NLAe3eSvtb3rfDEtXUS3Xp6QcRBgYWg4tkPHKpL6cwznfx4WN9r	43	1184	392	12463	14211	jwe8ee21WBLZBgAeDcWupshHmRhY1G9dScY2MFLLHtm4hxnEsae	10767	15537	15537	1618735860000	orphaned
18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	18051	3NKracEcBoLgnrvP3dArY3nWANTzjFAMFGYmqdG8hr3hd9E9sPEy	1406	1393	309	6301	12463	jwUQpF72hacYgQ9p7uMy29oq3uq3YKGBmLx5FLyXTNSTH1mHSuT	9106	12858	12858	1618253640000	canonical
18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	18066	3NKnydX6PyQAby6PjsUAnfTaePZoSumcEGaFt3hiidgjYYbVcQXe	599	599	310	6301	12463	jwvFffTekGdMkCVaBVDFCSCuoVot2h47F1rBkXJ4JdUikyBAV8Q	9112	12866	12866	1618255080000	canonical
18074	3NLZ3Yw2Uv9mvy9Wenp88j59f9iodx1URLF47BVJTyM5Qy8h1sz1	18070	3NKgQuNqVcArBLookgTXm5cYS1vE8rtiEj64W9nV78JDXP3sFiww	1651	1301	310	6301	12463	jweDx5YcS9AtGMwvE9cNMDUqxT8pdu1GHoto8b8W5djUZVx29NJ	9114	12869	12869	1618255620000	canonical
18080	3NLpuzmDrBGQmq22GpGiay3QJa62waD2MWbihVfy4X5PPGgjMMmW	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	1407	1395	310	6301	12463	jwD8q3rgz5ftvXpupQ3qHkBp5gB5HCnBDg3AtHDdLJ4R9PL5z1C	9118	12876	12876	1618256880000	canonical
18082	3NKdmg3FE2exgEmNgSG66Dp61zZpa4DTFFhXYhpzsE6yBBYFHgWr	18080	3NLpuzmDrBGQmq22GpGiay3QJa62waD2MWbihVfy4X5PPGgjMMmW	1406	1393	310	6301	12463	jwpLmuMoUPdSzkiJmCqcn1mW8WLbhhy2s2LxkkcLuYXH268kbXs	9119	12877	12877	1618257060000	canonical
18093	3NKeWG1ZcK5uV5W5e3jW7tvFUUEjCuduLhnRuQNAgpPh8rAoDeUR	18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	1581	778	310	6301	12463	jwLAmqWZr7943isBGKqBmyxB4ZMZZ7ferjpxKHZmfWEbQ9wU8yW	9123	12883	12883	1618258140000	canonical
18091	3NKMi19PH5TzoeGM2VjtPdot3KYgDJhNYfNkpwh59vzm1gXJM8gv	18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	1675	1342	310	6301	12463	jxHQQem2Rpbaiqi6NqgzWvmaqmbNrTvWkQYiaHAjW4sDzFPrCwa	9123	12883	12883	1618258140000	orphaned
18094	3NLL5VkvLhDbyXKsz1asseZsGjVYf45pDCrRS6GgvV1Z4PWdr6hi	18093	3NKeWG1ZcK5uV5W5e3jW7tvFUUEjCuduLhnRuQNAgpPh8rAoDeUR	532	937	310	6301	12463	jxYQjEyhmNYVMcg6Xudw4odC3VFNjJMtwuotJMKsgdGxgZKVijK	9124	12884	12884	1618258320000	canonical
18096	3NKFW8NgHRBaRwzeW2wiMm6f8N9G4zNX4sBewxCLxGhguoPpJiuN	18094	3NLL5VkvLhDbyXKsz1asseZsGjVYf45pDCrRS6GgvV1Z4PWdr6hi	1455	1086	310	6301	12463	jwoZxdQmNpSZNrt7U49Pnc1uBYAfEmG3TzuMDTqggo3C2KHkeEb	9125	12885	12885	1618258500000	orphaned
18098	3NKJG57BpsTUnyzt2bcGUPAbF4H1T9imE1k2Q8iayE76Fc2fBE8k	18097	3NLbANV9YKUksS7ZS7eG6XAsxgVceTPVL7PQwWaQcLjVDkAaudQd	1637	816	310	6301	12463	jxyQXYRuvBhvydwYhvouowMqHo2wsuryYtXRwrEAGiUveoZFg9i	9127	12887	12887	1618258860000	canonical
18099	3NLLUCaooVpUVgW7GsuNEQbsyA7sD5ZYjq7i8VAcrVrXKo7rYMMd	18098	3NKJG57BpsTUnyzt2bcGUPAbF4H1T9imE1k2Q8iayE76Fc2fBE8k	44	1199	310	6301	12463	jxj6LsWJtVxcpoP15UrqqWKzaaRtoEzZFYpHMyzjPPV5cLiGn3o	9128	12888	12888	1618259040000	canonical
18109	3NKmw5auRQ74hPFrYEjrGg3T4jSJicSiK4iUipfg9tfFBymm27HR	18098	3NKJG57BpsTUnyzt2bcGUPAbF4H1T9imE1k2Q8iayE76Fc2fBE8k	1560	1045	310	6301	12463	jxEP88j7aHo3oUK4MrYXNrCrdY2YYJSggFwAexeYGPaysP5cnZG	9128	12895	12895	1618260300000	orphaned
18101	3NKzqHAk5efShaiRzkJ1HF5orztURkyZHtnQ55aubdaxkG65Rvbo	18100	3NKFgKWVjnzShXtoC5qNmA62RBf1Qsu9ChKW6uSxj42CL1thkH4c	1553	776	310	6301	12463	jwqEY35jwg12SehBcuS7oEPidZv8EAjDYv1k2hrSz2a2YqkGrd6	9130	12891	12891	1618259580000	canonical
18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	18101	3NKzqHAk5efShaiRzkJ1HF5orztURkyZHtnQ55aubdaxkG65Rvbo	1637	816	310	6301	12463	jxP5Rn5ikwVcvYkkSA6kePoqRWRnHfcwWLNk6py6UefgKYcFYRr	9131	12892	12892	1618259760000	canonical
18108	3NL8oAcRFJuX5EdZ8nm3xW9gfLAVouBz1xSW6RjLHh5gTgxn7our	18107	3NKMu5aduv5Vx2QFbJAHdJJj2Zb5MRwzHt6LUv4TUT4V71hK2DDf	1560	1045	311	6301	12463	jwKuBrSyfnask5Di8S9VHiTg1Cw8idE3TPsPBgyoUBkxJpabzQ6	9134	12895	12895	1618260300000	canonical
18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	18108	3NL8oAcRFJuX5EdZ8nm3xW9gfLAVouBz1xSW6RjLHh5gTgxn7our	1553	776	311	6301	12463	jwiX3bLVHQfiuDh2aF9CM5djYpwxnhRMqgD8unfxA9v9PQaxw5q	9135	12896	12896	1618260480000	canonical
18113	3NLqWX1JCQuLERVxDqJesMCWBFF2BHRALjXyJYE6qBWPEbBQS2pR	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	1407	1395	311	6301	12463	jxi8uEyXkAvphVFgx85RGYYK2a72ahMJeUSYVo1u2CNyTdfZgKv	9136	12897	12897	1618260660000	orphaned
18121	3NLsKBHeyT8A1epttwfoHtQBPoGbU4TUkihMTUNu7K2cnYKzmRzH	18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	171	1128	311	6301	12463	jwFmPuG4VoBsJZRFRk6VjsMqhxq2xgH22a1MwcfUxGdEq2BtzhQ	9138	12903	12903	1618261740000	canonical
18120	3NLsMo5GaaYgQXtozTqmbM7wY3RqzAPjfGr4F6Kqr4WDuecGizQD	18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	596	1060	311	6301	12463	jwPVnSV1sSCZW1SN8FaVN15Qk3a7uWm8XPHcA1GtPRhzyoHf7jf	9138	12903	12903	1618261740000	orphaned
18119	3NKQ4h2LCkWLF1jortgFPKNqsxFNakHG6YLPqTkNDGeVhsmwW722	18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	311	1061	311	6301	12463	jxthxQ9CS8LHkCe1HLDxUkkntRJmTYJR5GMGjmHs4yKtFkvzWyv	9138	12903	12903	1618261740000	orphaned
18125	3NLt78JuUMrnzQvnGkytnm1EdcgniJnKtcF6SNWbu9Kyn4LSTwLK	18122	3NK6VgaVthknkNVyr3uwicBy2yc7ZnHdQtWkvbfhUU2jZSdWFpZ2	1407	1395	311	6301	12463	jy2LAAxkuqdQY3Yrw2LZ5HpdqKNwfKV7C5cT3U2wDkCspMuVpg9	9140	12907	12907	1618262460000	canonical
18128	3NKFGqoWoRTLeNybK6KDUiSxuUbT1qwuRdk3RTR4cHcxy5PwTrNU	18125	3NLt78JuUMrnzQvnGkytnm1EdcgniJnKtcF6SNWbu9Kyn4LSTwLK	43	1310	311	6301	12463	jxvXXgkd9R9ebUR5U47G9PjUgg38KssmgL2FvYNj4zZbREaJ3p5	9141	12910	12910	1618263000000	orphaned
18131	3NLp8TFc5x65hqrrhnhPw1t2yf73JXNHEB3hin91kox7zGJukWKn	18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	596	940	311	6301	12463	jwJ6nHG3gs5jr9cBPywbGyzNkhC6uGcZSmoHSbnCSss7XmdhZYT	9143	12913	12913	1618263540000	canonical
18147	3NLMW8eZxBM4tY6H4bw9sP5SJcqz9n4CaFYvN7PwYf1EDGdEk7qK	18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	43	1310	311	6301	12463	jxAvK4dzJqYHPU3JFbgRYfKufihL3QwqsC837kDKNEFTqQ2FKwQ	9150	12923	12923	1618265340000	canonical
18145	3NLcfnbomDrxb5zv5tB97SMmEFFCE1F3d6JiEZfAGC7KjdqCcKWG	18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	1448	1065	311	6301	12463	jxAQ75Ki6w71YcNmGQ1FK57TLKkGQcWXJpYYFvq8H3inosBrhnw	9150	12923	12923	1618265340000	orphaned
18154	3NLcRVs6YZqEW2RKa8x4thqX5e4X7PR7xCugrZFy3b2iWYdrvNuE	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1419	814	311	6301	12463	jwFTP4XrTRLWyYje29WDyRNVAf5eNJP23Z7SnxzxtTw46MsNWEt	9152	12928	12928	1618266240000	canonical
18150	3NLJGkDRePTZykPPPHVnnZUM49R8SHp3mSfHb8f5kJ3hT6jEAeFt	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1675	1342	311	6301	12463	jxM9Lv51gRHh7xT7uctrF6T62U2AwGiLC1beDN8TenHnZTJe96d	9152	12928	12928	1618266240000	orphaned
18152	3NKcTpmtTuwLPJQE7cTnsfH18qnMeZDkUaq95AGGqMo2xNnzoZNF	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1675	1342	311	6301	12463	jxM9Lv51gRHh7xT7uctrF6T62U2AwGiLC1beDN8TenHnZTJe96d	9152	12928	12928	1618266240000	orphaned
18155	3NLEhXuUjRFGg8VyRPanCut85Z6Rs8ScLdXzZhdnxMm9xJLp2aMB	18154	3NLcRVs6YZqEW2RKa8x4thqX5e4X7PR7xCugrZFy3b2iWYdrvNuE	641	1336	312	6301	12463	jwsnoakBh4f4T8zudsQ9QYNRuXcPq7A7mXhYDps3zQce8yLkMYe	9153	12932	12932	1618266960000	orphaned
21467	3NK4K3o8rkp5xHevT9mWkYLxjhGCTWQcBcLz5UWUeuu9fDrE1HVR	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	1599	1161	392	12463	13681	jwZTDuxA6qRDtYoYp5dpvUDj6Hu51h1LMjvP2yTAomz1M4gG7xu	10769	15170	15170	1618669800000	orphaned
18061	3NLoa3C6D6tNsaA52ciYQ7zShE5Cab2nh7GY2sFkq7Ume2PoYtQa	18059	3NLpmpWbCm1LmPdvxHjD8r1bhKrxpGruPWJZBRpi1oSimon5nMTt	1581	778	310	6301	12463	jx8Sc17YaxES2nqTWgrqd87yyyM6J2ryGFnCVg4NWB7YPjr1kWr	9109	12863	12863	1618254540000	orphaned
18065	3NKBNBrrgMQr4vE2ceYdrWp9f47SadUCPS3NU3BgaJCetx98xCF1	18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	470	1309	310	6301	12463	jwJ15eyUyQ82BNP5gjWzxLNc3JRnJUBMUJ8r81dVCGWHBPQJyjD	9110	12864	12864	1618254720000	canonical
18063	3NKcJUjLkgpuxX9jfbtiYokgeWUdwBmaR97UUcB1bM3B2tE3bxqL	18062	3NKtGzs8hDzXQKmw9xfA2oMZs36BfGrocwiztBYKCoN71JMv4p6v	470	1309	310	6301	12463	jxdvsuMaezaNfU9cRV88Sr4TUS9AF1MQVWywtUbD96YEnQP55fc	9110	12864	12864	1618254720000	orphaned
18126	3NKLbGi6j8gkagt9Bb2PFKrr4b1ZuT4sNmtjSEkYmhnUCuRKG2z6	18063	3NKcJUjLkgpuxX9jfbtiYokgeWUdwBmaR97UUcB1bM3B2tE3bxqL	1555	1101	310	6301	12463	jx4APUZBFeh3h18ZAc7BJpjQ45KyhkqWBStQNQykGaxFTnZRRk1	9111	12907	12907	1618262460000	orphaned
18070	3NKgQuNqVcArBLookgTXm5cYS1vE8rtiEj64W9nV78JDXP3sFiww	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1627	1139	310	6301	12463	jxQLf776VQVZLWk1WjBDiXQBuCTJCxQePHhajJGQPhT4X5awh3d	9113	12867	12867	1618255260000	canonical
18068	3NLLaUTiG6QSuyYJoJpnp7hHYGvf8BR5J6NeYJrNHSYXJZFqFDjA	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1634	1085	310	6301	12463	jw6qkosLiiPmKsFpBvNCN1T5FFSxDcMCYxGTVsfJPz7jhzrs49y	9113	12867	12867	1618255260000	orphaned
18072	3NK7H5jZnfYKbGagMZMyC8Wgje4ns7YZBWFvLhBNGv8DGWbujtra	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1652	1315	310	6301	12463	jwDuK2mKvRUP6eA1i3txqQcqhvThVq9QDu19gkMY3jXZf8js4j1	9113	12867	12867	1618255260000	orphaned
18075	3NLrsGAhKJmDtCouFsjnU5SpFSyPpoxZvtnzYP87qnSJDuHJksNd	18074	3NLZ3Yw2Uv9mvy9Wenp88j59f9iodx1URLF47BVJTyM5Qy8h1sz1	686	686	310	6301	12463	jwnWu76xAWWuMqErs6ZAt4cP5zExnWyt5ozA3ksxgs3Vg6paZWM	9115	12872	12872	1618256160000	canonical
18078	3NL5KNT7oeeywRfUzm84N4n67BCUmUw7xQLRxJjPaaQKjPqPnMxi	18076	3NL9VqpU7FSX25ZSh28H2eh7NCHmWaHfZ37zMHWE346gnSPXF9QT	1610	1314	310	6301	12463	jwtp4mCopB8CDXiP4QSfMVqkimr7E24bWzKmLSrJxb76DuSXiZX	9117	12875	12875	1618256700000	orphaned
18084	3NLRteVNkn5Vt34xZGD4khoeVjc2JFiaXYuSQcfxk1dhvQFSRvwP	18082	3NKdmg3FE2exgEmNgSG66Dp61zZpa4DTFFhXYhpzsE6yBBYFHgWr	1547	683	310	6301	12463	jweMxf42181a5axza2QEj7HLQazwjqrQ1B8BbCRtmsgR3NcMhrm	9120	12880	12880	1618257600000	canonical
18088	3NK6f32pmrS9dXyjx29mGGSkduQycibEKY3eULbUobcZ4jdVnxFb	18084	3NLRteVNkn5Vt34xZGD4khoeVjc2JFiaXYuSQcfxk1dhvQFSRvwP	1403	824	310	6301	12463	jwszQYhspQ7GvneqkRCHgAFUk6QT3gnfDa8VKMiGqhPe5852qf8	9121	12881	12881	1618257780000	canonical
18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	18088	3NK6f32pmrS9dXyjx29mGGSkduQycibEKY3eULbUobcZ4jdVnxFb	1407	1395	310	6301	12463	jxkZTdtpcwmBmKfEJYaZDWpBstGyHHFSW4g16nXthHyESGpnYgr	9122	12882	12882	1618257960000	canonical
18095	3NKXmjr15KQvMAuFBqCf7QTddWS7qwiLz3JjqaU9oLBfLKZKR4Tu	18094	3NLL5VkvLhDbyXKsz1asseZsGjVYf45pDCrRS6GgvV1Z4PWdr6hi	1579	1389	310	6301	12463	jwRBjfx6eWQY9Rk5YUvskRWuxaGaUnuAror3LCdjQCa3X2Fe9CQ	9125	12885	12885	1618258500000	canonical
18124	3NLnVUnenPJpF3ggJVGTbJ1hRdJpfuEAQV16VBTZgGjrNFU78ST4	18122	3NK6VgaVthknkNVyr3uwicBy2yc7ZnHdQtWkvbfhUU2jZSdWFpZ2	1522	1076	311	6301	12463	jxfdXnfjnNdVrSA29dvvVofqcFUNZkH7gdyPqCTYhn6Qub3ND6h	9140	12907	12907	1618262460000	orphaned
18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	18127	3NLJdsU64uhKDPnQJZP3wefu4L8BXcyRUVzTRKWphVCyTwS8tGQi	1407	1395	311	6301	12463	jxdSU8CEXdPvnXeknnYzFPua1vTtgTcDG9Ji2UDK8i6xZQw4dPr	9142	12912	12912	1618263360000	canonical
18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	18131	3NLp8TFc5x65hqrrhnhPw1t2yf73JXNHEB3hin91kox7zGJukWKn	1500	931	311	6301	12463	jx7zVN92VJuAiv4cLCUyj3LMUn7YwnzYPAyyv49m5gY6UzdQGDQ	9144	12914	12914	1618263720000	canonical
18136	3NKZdxGDkHxvLjQBAVcZcFJiVGEPX8wc262nxqohJRTdVgLKHGFX	18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	1406	1393	311	6301	12463	jw9CvRCX2m1BVa297JzyhqNkRLxf4TmC7HXxAg8LujNTaC1KnYV	9145	12917	12917	1618264260000	orphaned
18140	3NLckxdmnLPVSzkYhfPHaAtazijHsJwRdQAHCiWPNbodFgH44TPN	18137	3NKkgkynbCFg2UrzN6Ek9GXnDdq9JiHsp1uo6VsiTctFtFnMTEMU	1581	778	311	6301	12463	jx5vQyHKkuppQtuEiKnhowJFyjoreuKmHhrAVEBVcYJaooztFUk	9146	12918	12918	1618264440000	orphaned
18143	3NKkC2gaAsms8shM3tuRrRJN2ZCnXvBtVapEeK9s523RPyMPL2kD	18141	3NLUv48HLw3PLoV7AcCV1GTVRyTYkWHp6vmqyLYpNx6HQcGTSJYX	1593	1346	311	6301	12463	jwDXV12sZaucGV8RLXZVFa5c8BjQS5WXKVkm9ferjJSwDXcGGtQ	9148	12921	12921	1618264980000	canonical
18158	3NLQ4auwJcneU2SYW7dhGFcaY6XzuDUXfeSk1pYGadsdWqujL6td	18156	3NLSs1LpZexgD4SQupBoUMa2ND25Soxs7qsRuLmasdLWnQkWzsZd	1593	980	312	6301	12463	jwj4oyRwX7SRKm7dWieKMWGREBAXSkeLwXFbBGJJeYQDK8ufQZh	9154	12934	12934	1618267320000	canonical
18161	3NKsvxNkJG7H83XZuySsRUDzKLpSJKyeU4xQQ7uvc2U3gAQ5Z3aP	18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	596	1060	312	6301	12463	jxvr6AeNUwHmMh2gjLSbbvps5CNtv3Zaeq59X8Vy5dn6Hu89iJC	9156	12937	12937	1618267860000	orphaned
18163	3NKNU6F2fJ5fLGGTpJX3LpxguNuaw9KAHPMCSQyTa3gAAi2ErBV3	18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	1596	1363	312	6301	12463	jxbrunMuYak829DoqEpYdp9SuDb83NipACXDGvc4d2mo8LErAF2	9156	12937	12937	1618267860000	orphaned
18169	3NKHGVvjLE4NfaZiEqMTsJeEUHCp16TQTLKfwubSNfYYY7rKatNM	18168	3NKYZiG6vQhRSqNJ1D8vsfJb8gkK9FFAf8pkjDQwRg8gyuemfEzD	1405	867	312	6301	12463	jx8utckJj26W5RgpLhMB1bWg3XxcWS6RvxvoXk7Ahht1fLEVtRo	9162	12945	12945	1618269300000	orphaned
18178	3NLToiYdofEJxze4xi3p6ZNFQiTEftEAkVPVKKTuLn1XwUe2KJrz	18176	3NKvbsTNPghRyCzyA5omBd8FSfqxtqwfmEPhNEwpBnHVbTV6TyFz	1564	1092	312	6301	12463	jxkcAhBowvokiL6AfLtvH9WgrCTfYc1n4zFVbXwvCRLD6s5sKQX	9167	12956	12956	1618271280000	orphaned
18180	3NKgWoax3B1Jx7wy3SP2uu68ymWjQLfUKoJbALhcAGiLSjXGc6Y7	18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	1649	1383	312	6301	12463	jxhj9AkhF1kgsTgTCdbTt2JRnrFJw9Dzu9wnbA6HoHsn4gRzM1E	9168	12958	12958	1618271640000	canonical
18182	3NKwStQdfu8CJwxyEsUqLxMa1B2fRgpxrMec5433ixm86svbVRko	18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	641	1336	312	6301	12463	jwfkJaRpc6o5iKK146L3QTgDkgr4BX16E8dFWoGqe6TjsKb3tYg	9168	12958	12958	1618271640000	orphaned
18189	3NLPLGVSbKFXPs1YvTbt6sXKmLgTfqY3qJw92dgVfBVMKcYrgPRs	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1483	1276	313	6301	12463	jxzeUBRpfnpaeeTiWzphMTQZrr8nCi831pX7ULZ93DjvwVnUxme	9170	12960	12960	1618272000000	canonical
18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1403	824	312	6301	12463	jxK6XFavUx85kqPWzNFrqnLfyd2EXjPpfp4fw3FuKLHu9dfxCD5	9170	12960	12960	1618272000000	orphaned
18192	3NL7kUtq4UQoLWsFf3aCyUmbc9zwbWapr7xZDcGmF8aEs495ZRLb	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	641	1336	313	6301	12463	jxYrfpotPtDTJ3JojsjVjraQt1bRbPnLi1esFQJyeTU29DJ8ZZK	9170	12960	12960	1618272000000	orphaned
21469	3NLVg7Z2NQfp2sWPjemLYxVN4f7qiBi4EtPyzLw86s9je4Y3CaD5	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	1571	1209	392	12463	13683	jxqZZv3w7myPTLi7kRe8kQrbdHAZhLxAp82ZreroSYXUE4PSa6V	10770	15171	15171	1618669980000	orphaned
22418	3NKgHS7jGZtJzQ94jCz11ixCJkRhkPEMU7doyo1kT1yRfzCsX85Y	22407	3NLy4NRym53qoJixy5sQ5oLNc8WqK2oxP9W6RHrzmeUwSriUZP8p	1590	934	415	12463	14530	jwLnU6cagj5Zp5e3pYr7SdFyvfHYGv9DFXbvSKRLTmSxSpeAEsy	11218	15796	15796	1618782480000	orphaned
22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	22601	3NLiK8XNAxFqx6nMuiFfiimgEK7NBgP1UCfoKaGcd161bdjAG9w8	1406	1393	421	12463	14695	jwz88Jidu1TTKFsEGRwYS2Hg9VQXexXTAmUrdtFAcX5xKn8SCbv	11308	15921	15921	1618804980000	canonical
18149	3NKL9Vj1EecR2Fi9brF58xgQi8XzWfshy9pZqbwzP5doVj8rhLXy	17952	3NKtJuviGtQexE61BdxRt1i6X2RKpH6jxXDnrtCaQdWyaTYeDNTW	1650	1009	307	6301	12463	jxTVMtMmFwgTQuzXP1MeBc7kw6zM7p6qKUza96eqX9YvXbeUKCG	9057	12925	12925	1618265700000	orphaned
18153	3NKokvEp5kXMEYvDk3sYx8sf222BrBoAHGogRtzXiprMfKpxmyob	18077	3NKhbVRicedUFj5oVNJqSWW5ZhmkV6dyHTfvdB9WzTEUxDbr9BLi	1419	814	310	6301	12463	jxtUADG2zskBrEyZZWJAnScoXvjJ5Rh9vyACscHnDKQk5jtWwLH	9118	12928	12928	1618266240000	orphaned
18097	3NLbANV9YKUksS7ZS7eG6XAsxgVceTPVL7PQwWaQcLjVDkAaudQd	18095	3NKXmjr15KQvMAuFBqCf7QTddWS7qwiLz3JjqaU9oLBfLKZKR4Tu	1407	1395	310	6301	12463	jx7GNVMS8vQNvsZNA678TBLW69m5u7t1xmKaSDaDxf4U3UfKXva	9126	12886	12886	1618258680000	canonical
18100	3NKFgKWVjnzShXtoC5qNmA62RBf1Qsu9ChKW6uSxj42CL1thkH4c	18099	3NLLUCaooVpUVgW7GsuNEQbsyA7sD5ZYjq7i8VAcrVrXKo7rYMMd	1546	1339	310	6301	12463	jwwiwG61SyZcZZM74SbqfQ5yepqM2AQQaK5k6cjrBZncQAKmvqG	9129	12889	12889	1618259220000	canonical
18103	3NL3mxtXqGiqUHswydNwH9z9CbHYEedSL46TWnGbyvkc46NJnk2q	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1671	1239	311	6301	12463	jweaUFoAHdwefges5tNS9GNwbPujQ9wpJLpgHNBGdB5sJkkMHDq	9132	12893	12893	1618259940000	canonical
18105	3NKqyU9hMfGi3TC2ScFhd6XNWMyWa79nXVddEE3nB1xocS9d42DS	18102	3NLPoaYbE5RtAhuTx2pNWzn2c7z9251w2LvZ9WkMKmbhFxv3nrS2	1671	1239	311	6301	12463	jweaUFoAHdwefges5tNS9GNwbPujQ9wpJLpgHNBGdB5sJkkMHDq	9132	12893	12893	1618259940000	orphaned
18107	3NKMu5aduv5Vx2QFbJAHdJJj2Zb5MRwzHt6LUv4TUT4V71hK2DDf	18103	3NL3mxtXqGiqUHswydNwH9z9CbHYEedSL46TWnGbyvkc46NJnk2q	1587	1357	311	6301	12463	jwRK7NNo1Qdtrc36kiAjvSpNyv2NcsbdQKFmjCh2FBB1bs7SuZc	9133	12894	12894	1618260120000	canonical
18114	3NLGDPGAnYUcQUN2eHuhE1v21hyyc1zsHaQbb8mSVVp5a6ru5GaS	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	1474	963	311	6301	12463	jwbQZPXfma4CAHFeNUPLc1eM5ZK4EgtvFLcABFQTBfTuVVexQo3	9136	12897	12897	1618260660000	orphaned
18122	3NK6VgaVthknkNVyr3uwicBy2yc7ZnHdQtWkvbfhUU2jZSdWFpZ2	18121	3NLsKBHeyT8A1epttwfoHtQBPoGbU4TUkihMTUNu7K2cnYKzmRzH	1602	1369	311	6301	12463	jxNvwasCSQbXKkEc8nekqupNWi6cXmMV891bJSECJevngXNHccn	9139	12905	12905	1618262100000	canonical
18127	3NLJdsU64uhKDPnQJZP3wefu4L8BXcyRUVzTRKWphVCyTwS8tGQi	18125	3NLt78JuUMrnzQvnGkytnm1EdcgniJnKtcF6SNWbu9Kyn4LSTwLK	1637	816	311	6301	12463	jxvsFZi4W2SDMojhNM5qAy2RiGCgm2E2zZFXL7veS7b1a46k5mY	9141	12910	12910	1618263000000	canonical
18130	3NKTLvCJuT5Rsc4hyqBRaEShkp58gbMFgpSWRZRLKuHJzEL3gg6C	18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	369	1186	311	6301	12463	jx51AMZP8zuBrFzb2CHcP63zHyydgBfgz4wsD2xdmwXSkpxu3bS	9143	12913	12913	1618263540000	orphaned
18137	3NKkgkynbCFg2UrzN6Ek9GXnDdq9JiHsp1uo6VsiTctFtFnMTEMU	18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	1581	778	311	6301	12463	jx9am1t5usY7j8pgDTrRhooCS1u3v9VAuYKk3nKhnPXSpB5ZYmV	9145	12917	12917	1618264260000	canonical
18139	3NK2zYy1iECqEhFJj6G6LK8cEZbtZeAzT7eTP3KVbLjkvJs6h34Y	18137	3NKkgkynbCFg2UrzN6Ek9GXnDdq9JiHsp1uo6VsiTctFtFnMTEMU	1406	1393	311	6301	12463	jx67Ycwuku1Fzz85H9KoQLVUMm1DjEwkeNpT78YzDmaKoS1CNCF	9146	12918	12918	1618264440000	canonical
18142	3NLwX1ztbC7QbB2aM13eriNQHGnXqV4jikLEib5xBCdYn1menqid	18141	3NLUv48HLw3PLoV7AcCV1GTVRyTYkWHp6vmqyLYpNx6HQcGTSJYX	1564	1338	311	6301	12463	jwBe3jY5mp3xQkLWj6qN2cp8GYWvqN5HZheZqJgGTJ6Tk7esrqf	9148	12921	12921	1618264980000	orphaned
18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	18143	3NKkC2gaAsms8shM3tuRrRJN2ZCnXvBtVapEeK9s523RPyMPL2kD	1631	794	311	6301	12463	jxHAKvjpD7haqKDfmimir3LJxaqAnFCjnhLVPoT2rGFNSYwvLVQ	9149	12922	12922	1618265160000	canonical
18146	3NLuBYQRFbRsh8SzKZieLoKrLpWcdHNyWTbUMVtyxwLA8oRtdSBf	18144	3NLfwiwrb6S43wg8TdyD3B8zFqoNMbTBZwdTHUaNZL2xZnYtfNFY	1448	1065	311	6301	12463	jxXoRNBBLdBbykeDoDpmkYy1uFk4Hw3k5UwPVrTNhriikNSAp4o	9150	12923	12923	1618265340000	orphaned
18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	18147	3NLMW8eZxBM4tY6H4bw9sP5SJcqz9n4CaFYvN7PwYf1EDGdEk7qK	1553	776	311	6301	12463	jxSCm8v4kP9Ert1j5KtWUCvD9V8yprwzetKQcidfUbgmS38S4Gx	9151	12924	12924	1618265520000	canonical
18151	3NLn74hVwfhixqeitijHGXMTtRBJyP7ddcqKfuMXAiovXi1aziPa	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1675	1342	311	6301	12463	jxM9Lv51gRHh7xT7uctrF6T62U2AwGiLC1beDN8TenHnZTJe96d	9152	12928	12928	1618266240000	orphaned
18156	3NLSs1LpZexgD4SQupBoUMa2ND25Soxs7qsRuLmasdLWnQkWzsZd	18154	3NLcRVs6YZqEW2RKa8x4thqX5e4X7PR7xCugrZFy3b2iWYdrvNuE	641	1336	312	6301	12463	jwsnoakBh4f4T8zudsQ9QYNRuXcPq7A7mXhYDps3zQce8yLkMYe	9153	12932	12932	1618266960000	canonical
18157	3NK547NwJxJyRmKcQ4548YwrypXFKbpoG97v95FR3yEaJu9Mod7d	18156	3NLSs1LpZexgD4SQupBoUMa2ND25Soxs7qsRuLmasdLWnQkWzsZd	1407	1395	312	6301	12463	jwVZsWZD7p8LAGbbJmXtd3Vitqiquh3WkqCoYS1t8XN7tFS4Ak2	9154	12934	12934	1618267320000	orphaned
18166	3NKnJBa64AmaDAfzKkmrvsPUD6E4dwhz1tW4kPbgReN3ScD2QDZ8	18165	3NKfJ2n9j5cgXDMGEw9my9FxvS1X7vukj9huELnP18SirjzHasM5	1650	1375	312	6301	12463	jwRmPTHfDhMbsXHuwUdFyvyVvmkK4rVHu1yqfWBjnMudHHB1ZAB	9159	12940	12940	1618268400000	canonical
18172	3NLeLa7YjD56orjmYBFeBRHt2nGvgebq3sjzHBYfCafz38Hjdrt8	18170	3NLSes9einsTNBWKsT8nMpYzqkvfWmdoDsJZe19wJGxP8CNW3CmV	1642	1241	312	6301	12463	jwF5axn2g4szE3sPgbWWUtLzAi77HjGL6FDrJuaHw6KCFCWuXZs	9163	12947	12947	1618269660000	orphaned
18175	3NKES5mXbzYxAATzXxopJ3dnZw4W5tWFE78e983EYyfrFGwucV3A	18173	3NLDuGKkdqhqfr7bDy1BttdGYVJzggRB89EM9iLbG3SUdRJesVQh	1407	1395	312	6301	12463	jwhecBcJRjkanEPTxmVGXK9VLiXrmFiADhPDTEgVGEY9x4yxU6z	9165	12951	12951	1618270380000	canonical
18176	3NKvbsTNPghRyCzyA5omBd8FSfqxtqwfmEPhNEwpBnHVbTV6TyFz	18175	3NKES5mXbzYxAATzXxopJ3dnZw4W5tWFE78e983EYyfrFGwucV3A	1646	988	312	6301	12463	jxZvcRW3fiuhXZQPyjhmmXnFMKHgGFeANTuenQBFBxFy5RKD43r	9166	12955	12955	1618271100000	canonical
18185	3NKQ6qZeWUcwQpiF5NnKicCD1gx3E1c8eFr4xDJ9PxxhM5sQT3Qf	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1609	1333	312	6301	12463	jx6zE6DLierzWtpvzx5hHJm2ueRH5FYhVdovz9fzbGpFYR2mGkR	9170	12960	12960	1618272000000	orphaned
18188	3NKofR75MrhHEqcWBVxietPXMetgqQjvBRCoU5c1hSCDu6cDEyAK	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1609	1333	313	6301	12463	jwR1MQaCayEN8uYqy1UL3nVvUHnsZeiqMWXbEf1M8LBJ5nF3ZjU	9170	12960	12960	1618272000000	orphaned
18200	3NLtZJb1zLcXD3WKaHr21JRTDzUY5W8fBbD6KobDVzbbbo88gwyp	18189	3NLPLGVSbKFXPs1YvTbt6sXKmLgTfqY3qJw92dgVfBVMKcYrgPRs	1601	1388	313	6301	12463	jxgBY1nUGBN9he5n5BxFWdkVyTsJ6Xb9P7LyVUmGtiYcG9KB4gi	9171	12962	12962	1618272360000	canonical
21482	3NKBugBYBG72vnAhHKrGce4xsTgxrZF2yQdgJ9QYcEHRB3qNaqnZ	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1601	1388	392	12463	13694	jwe7JH5UJR6EAVdPV2SoibE7oSAZyYC9oPJxj9AVQ7zNgGBy5Ug	10772	15175	15175	1618670700000	orphaned
18159	3NLyXNuC31MduoH4JHaawByUYU4H5KJ5EwKnq8tcDz9BgEe5fGts	18155	3NLEhXuUjRFGg8VyRPanCut85Z6Rs8ScLdXzZhdnxMm9xJLp2aMB	1403	824	312	6301	12463	jxgtkpqv9TK6ne3XCe6njVUpHhURUHdh9zduE95Az64NHZNCSR9	9154	12934	12934	1618267320000	orphaned
18162	3NKi559yXp11uEbbsVQX1CCsVecSiLSLjKWyj3UWkY9GE1kfbFKZ	18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	1406	1393	312	6301	12463	jwFnaMrg63p8uWgxpxN1jo5X7ipBcvCQuAbEtoMAzgzdDZUVQJk	9156	12937	12937	1618267860000	canonical
18164	3NLK6sAiF55eFdVaypYEHbLXhLD4hTMuYMDBG5thjNmEqascJELa	18162	3NKi559yXp11uEbbsVQX1CCsVecSiLSLjKWyj3UWkY9GE1kfbFKZ	1599	921	312	6301	12463	jwNdBmE28Xhn8bH2GZ9RerWxHVhjXZFqPyLRFh3o4AoXiQHqU9i	9157	12938	12938	1618268040000	canonical
18183	3NKtLFR8HhcbZwGKsS8KaxsPYSh5ae9PchLrRWMduSKtJ3R6g6E6	18165	3NKfJ2n9j5cgXDMGEw9my9FxvS1X7vukj9huELnP18SirjzHasM5	641	1336	312	6301	12463	jxgL5kSLWFhPMo6R7hTXv5B1thZvMHD4AibT2oiDYEt2wt3YwU7	9159	12958	12958	1618271640000	orphaned
18167	3NL7Ft9Nz5wgKw2n7UY92uKcDqFfeMcfZiqhh7ojc2yDVgF43g5J	18166	3NKnJBa64AmaDAfzKkmrvsPUD6E4dwhz1tW4kPbgReN3ScD2QDZ8	1407	1395	312	6301	12463	jwArN3h8217Hgtc7sTXocpxQ8XP9H6vXjr9FckAsop4BQd3S7go	9160	12941	12941	1618268580000	canonical
18170	3NLSes9einsTNBWKsT8nMpYzqkvfWmdoDsJZe19wJGxP8CNW3CmV	18168	3NKYZiG6vQhRSqNJ1D8vsfJb8gkK9FFAf8pkjDQwRg8gyuemfEzD	1508	1141	312	6301	12463	jxsQp8LosVaGdAR98Z3dwMVMCBV2VJrYnPda1kheguxEdwu6Te1	9162	12945	12945	1618269300000	canonical
18173	3NLDuGKkdqhqfr7bDy1BttdGYVJzggRB89EM9iLbG3SUdRJesVQh	18171	3NLXMPRBpAAqrAc2qRpShHto1oR8KSoNAB1TnJ9j1wzhxGQQaVoJ	1553	776	312	6301	12463	jwM753hjNbtPGRukjc6xEhgi2P8vc4kN81VmHGprYxCthgMWezx	9164	12949	12949	1618270020000	canonical
18181	3NKq7YbBdzjaFT1izA6WGS6bLnnF579sYHHqU22dB3HjE3rMGF8R	18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	1407	1395	312	6301	12463	jwBZycJBzdZQn3y91B982rVbeFeyZfRbcLRUAPFuMdnwMMKSid6	9168	12958	12958	1618271640000	orphaned
18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	18200	3NLtZJb1zLcXD3WKaHr21JRTDzUY5W8fBbD6KobDVzbbbo88gwyp	1625	161	313	6301	12463	jwo5tuKsUUN43Jkaht9Z8sKuHf4nfzshZLpfqJ14HknNMs3VpJZ	9172	12963	12963	1618272540000	canonical
18207	3NLBibdjfyqGZ1ct7K27AycPkgNjdBTya3ywBfUJpNnFNfqxzRnw	18200	3NLtZJb1zLcXD3WKaHr21JRTDzUY5W8fBbD6KobDVzbbbo88gwyp	1624	1334	313	6301	12463	jwdkpsmQVqtt532jEFHF8NcNGvJSmDXpn5YbYQjkNgWZypNpxK3	9172	12966	12966	1618273080000	orphaned
18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	606	929	313	6301	12463	jxtuRvt94s1VXoxBbqVPaqQE2YebMdzRmrJGAf1sBxZWiQ1vdud	9173	12964	12964	1618272720000	canonical
18203	3NLKiAqnnBdgq2ZbSYwPwWmfdfi3WC1AkLyzJ11BoeddTjiU8MWy	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	1564	1338	313	6301	12463	jwuLURN5CsZZRXrvFr2cDX9ifsDjM32J4fpmGWG6FmbNnBw18Gr	9173	12964	12964	1618272720000	orphaned
18209	3NK4oqWe2eqnk75ksUBvxJWviuYHdXa3kJQLVqCqfgDN1iFtH1jF	18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	1624	1334	313	6301	12463	jwiCWrdQN4iytEicHLb5CXmQqp1QDG3p4PFNR6ovk9twByp3L76	9174	12966	12966	1618273080000	orphaned
18212	3NKjpDdUn15gQu9AzmjuPpnEfxRxVjJmxaUVp2AsrkXGmYe9wB1v	18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	563	993	313	6301	12463	jxQTotXGgE2JB8qa3xKguDDq22nmW8hqHvghang6URKNQK1p2iU	9175	12969	12969	1618273620000	orphaned
18214	3NKRXhvFvCgk81ycCZgaUg4rTDcAzDkni1DyW1XaCTiA3j1gtUe5	18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	1448	1311	313	6301	12463	jx8xtfHMnFYk6rMsEEiEZ1FgcDNjyn4Wc2rTMCieWin9833aYZD	9176	12970	12970	1618273800000	orphaned
18219	3NLHegPbxxYaHFmcvVQbFeBY9z3kds2SZBaXexP5aWVczwDhDZBT	18215	3NLybrHUmb3h7oCqCkHdgYUCxpS8rcpMPCs52gH48BafUeUXqZf5	1406	1393	313	6301	12463	jwMTeKccXNk3UwYm3zig7KWWxVNWyoF7BMZwTejn8PcJ65Vthvy	9177	12971	12971	1618273980000	canonical
18221	3NKmocnZVSr3RxCzBkTX9RoDSyU8Mk1fAAoWWZEdVSd4F6mNDBbP	18219	3NLHegPbxxYaHFmcvVQbFeBY9z3kds2SZBaXexP5aWVczwDhDZBT	58	1281	313	6301	12463	jw9rnWriERczExfiZqpZebTKSZ6NgZpi4gbuY327mwYKUS5oNAs	9178	12972	12972	1618274160000	canonical
18226	3NLVQXFbHJJ7wLBvUzSbHT4pgtus2GuKTrb1BN1YKYh7ayQg9QtG	18224	3NL18ZBdPU5QBF2CM1YLpdCDNNDgdrHD84VUeHu5k4GvSM34dRFi	1617	1042	313	6301	12463	jx749o992DnDpkQmez6cTNaJaq1xU8jfzxe9t7CTsG4GHr9YT6f	9180	12975	12975	1618274700000	orphaned
18230	3NKGWVQHWXpDjjJC7zFJ1Vs3yDV2LroVhX469tRnjkVdSfBMSwEc	18229	3NK3uTCXAN5sksVpLQSUGncPXSe4sMQFXmfJiTNvJDoTjStcQyLf	1522	1322	313	6301	12463	jwiSMiNS5HukCBy2RERtwaF5AZX4pq635wvkvNJrvBpHdTz4igP	9183	12978	12978	1618275240000	canonical
18250	3NLV8UgYZbHmQNn5QjWCs61dXDqXMmbqPsJ63ziYVRRDxRLCcqkU	18231	3NLSy5h2Q41zkWxTd7tJTJi7nt7kLZ7mdkDm3kSaPouvgxpnG7FX	1599	1287	313	6301	12463	jxnRQHJKqtYnNco5SzpZjR3YKg95ru4QAfN7xmPVh7bu45aBPY8	9185	12991	12991	1618277580000	orphaned
18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	1403	824	313	6301	12463	jwdmrLaJE3D58tDzL8VfDbu153h3qPGNZiSPiPXKaBcZyjgRjfX	9186	12981	12981	1618275780000	canonical
18235	3NKcibB8ns2GZCMHTHAEC8kNnXL24xYVwBjBMTLLcGhJgefbvejQ	18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	1613	1349	313	6301	12463	jwmia3boTjLgNK8hRnCtG8U9LkhsgXk1JAdQZLvRg2YsstNg87q	9186	12981	12981	1618275780000	orphaned
18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1471	1386	313	6301	12463	jxfQFii4YhRgr9qjA585jDdWaphdo5KjCL7xue1bh33dVhCpuTg	9187	12982	12982	1618275960000	canonical
18244	3NKmMiVcmTkXDFDMU5XtdXiofNMCafrc8ocaQidyV5yrVJ4LgXYY	18242	3NKb4ht6CcrWWM1HioLRcAdPoGA4e18HS7e1grWnYvsVxyTpN4Fv	1668	1004	313	6301	12463	jwzFnveQtg43xG6CeGSShczzyHYZjEUaaVphY8MtVcCeLWs5FDB	9189	12985	12985	1618276500000	orphaned
18246	3NKgUuHYnPskir6C5ESKDGcb8PyKAhxtm8Kkzjf7v4vL6Pkmg1LJ	18245	3NLWWFjEXxhFgBnbrXwyUZU55dtRdy9sT8AobMXefb9ms37n4kjw	1406	1393	313	6301	12463	jxFU7Sm51vKQkMuTGCVe8baZnJHtVroMX8ZWjWiJpts7ssg9SW4	9190	12986	12986	1618276680000	canonical
18247	3NKbr5NS9jEFxso9Q5r3tw4WHxZpVkQ1T6b7jfrNmhQ3ZrR7kFaU	18246	3NKgUuHYnPskir6C5ESKDGcb8PyKAhxtm8Kkzjf7v4vL6Pkmg1LJ	1501	1234	313	6301	12463	jwFbuFB8NXFHGNp7mC9noYihofURd5XZnU8i1YqmSCkbVFJ9U2A	9191	12989	12989	1618277220000	canonical
18256	3NKocuR3ubcDMGAELgexLxXfTC6Ej81xjNj1QxN51Gd2WpqVNxXi	18252	3NKgxnVV7Vs9v8sb8uw61zsmWijUnc3rGG92bkhrJEBxaZo26Da3	1403	824	314	6301	12463	jwMMuDiVj4bkfgC8ftGsdteZPxZbriz5RoS1KECc1GVMkXCPzoc	9194	12993	12993	1618277940000	orphaned
18260	3NKyW2Vv6MCXQT1dnPiTsQZNQf4HswcAvkDBethVTgdCx1HiT69B	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	1631	794	314	6301	12463	jxA432KvEggW1BvMbzCufMcLfk3snRuavJgJqR4xXMT1PhV9Vhk	9196	12994	12994	1618278120000	orphaned
18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	18262	3NKqN75ptR83J5bBg2qceVFawGQvFSDTrqWuBn5fXc4Y5i1gAxBL	1406	1393	314	6301	12463	jxpSxujpXQY16vEZrgcVeKVhnP21bXL7M9y8PydmuZwMBgNtQiM	9199	12998	12998	1618278840000	canonical
21479	3NLjAeWHA9GgxN8yLQqkkgDHJXj3odopL1ThQixjh3igA2LSA9nd	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1523	1321	392	12463	13691	jwCKRKQZmSmYpXXo9n6GzCUWd8ZKHSieZGHV5C9tmgD9Uo4nAFE	10772	15175	15175	1618670700000	orphaned
18160	3NKTMGgucvBBzqg7pCSCWVpfN53xJwkNwtyPRPuhniRzP7zN5Xkv	18158	3NLQ4auwJcneU2SYW7dhGFcaY6XzuDUXfeSk1pYGadsdWqujL6td	1571	1335	312	6301	12463	jwgzU4Pjo4gkd62j55teaxi96GtUt2cFsQfdi8Y7TYb6syTTpKw	9155	12936	12936	1618267680000	canonical
18233	3NLarzcCvLJiUSu1NVfrA7qCTtA5QHm3ycQm4F1cjyZGm7d1P4p8	18158	3NLQ4auwJcneU2SYW7dhGFcaY6XzuDUXfeSk1pYGadsdWqujL6td	1643	933	312	6301	12463	jwmS5o46iDpex4GfhVpdYLDTv52q5PGBvkcdjyt31vZvEbEhxrn	9155	12979	12979	1618275420000	orphaned
18165	3NKfJ2n9j5cgXDMGEw9my9FxvS1X7vukj9huELnP18SirjzHasM5	18164	3NLK6sAiF55eFdVaypYEHbLXhLD4hTMuYMDBG5thjNmEqascJELa	1406	1393	312	6301	12463	jwQ2q5uCaaGN91aDe4JQGwbrUtNRkZEzLL82a55NkpuhLjspYWf	9158	12939	12939	1618268220000	canonical
18168	3NKYZiG6vQhRSqNJ1D8vsfJb8gkK9FFAf8pkjDQwRg8gyuemfEzD	18167	3NL7Ft9Nz5wgKw2n7UY92uKcDqFfeMcfZiqhh7ojc2yDVgF43g5J	1553	776	312	6301	12463	jx4kS4PU8TP3pBqG8BbE1QFCtTR5bsJJKep8y2qVAjuAnD4RoQX	9161	12944	12944	1618269120000	canonical
18171	3NLXMPRBpAAqrAc2qRpShHto1oR8KSoNAB1TnJ9j1wzhxGQQaVoJ	18170	3NLSes9einsTNBWKsT8nMpYzqkvfWmdoDsJZe19wJGxP8CNW3CmV	1406	1393	312	6301	12463	jx8sR5dhXwzb4CSdtPVz98RFJZzunUXZ3d5t2i659LbV4Sxdirz	9163	12947	12947	1618269660000	canonical
18174	3NKeRFUoMX4xx8UwGmQHyziZGEt7kLtfqNvcivcLBwHpSwZgRFzd	18173	3NLDuGKkdqhqfr7bDy1BttdGYVJzggRB89EM9iLbG3SUdRJesVQh	1599	1161	312	6301	12463	jw8nDXHXbYDE8ZESBfao8ELBBcXN1bPSeEzMMv5zwxEqvkEC8uF	9165	12951	12951	1618270380000	orphaned
18179	3NLekTwuDD7ZbMkrzRujwFherkxe7qJfWif53oiavjf8pJzApfSd	18176	3NKvbsTNPghRyCzyA5omBd8FSfqxtqwfmEPhNEwpBnHVbTV6TyFz	1483	1276	312	6301	12463	jxXYEYuBExGvdMTi64ZDWMGiQXXiy6JLD3UmStcqfvuDqAtrfBG	9167	12956	12956	1618271280000	canonical
18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	18180	3NKgWoax3B1Jx7wy3SP2uu68ymWjQLfUKoJbALhcAGiLSjXGc6Y7	1407	1395	312	6301	12463	jxsyDgy39qty8vaFcMaDHqCSDHzEcAT6hnbjtb3uHVdWiFuKZft	9169	12959	12959	1618271820000	canonical
18197	3NKpUZQTGKcarogN3apCVh7BMtE2rrXmt8tbb6vUG3RbDCYCQTmJ	18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	1546	1339	312	6301	12463	jwFdqMestQ32PCLEgADAs4nXTFnuZ92PtvfVnZ4L85uuc2yxuwb	9171	12961	12961	1618272180000	orphaned
18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	1624	1334	313	6301	12463	jwrqqEFnrYBZc6d6f7Hd2GxMLu2cVomagcSV9hFCARAN8uaTwR8	9174	12966	12966	1618273080000	canonical
18210	3NKL3g6a3k7P5SVHBFs343N2YM4516EMYhuDr814VHjAjmh2gbSs	18205	3NKRMAR7Cuo8cVSxj9vTcJKHwThn1JbtLhQAsP9ZP7saCMwBV6P6	1403	824	313	6301	12463	jxUkHQcEcz6ci5tk3TCJCFk3odvpAzVqRVVJjk6bv9yeWaUcSQh	9174	12966	12966	1618273080000	orphaned
18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	684	1106	313	6301	12463	jwwV183W2Z5s7u1bcz43xkEdCeKi6GxPe5iGBSJkht1o3nmesdM	9175	12969	12969	1618273620000	canonical
18228	3NLjX3my65GikcnMKGw8FrGVhyejRykT644xhsvvqsir7QLXkWDC	18225	3NKEhVWcyFGqJCQfk7nKZkrJzV5tyWntMaYRWjT1UR8TBRdF8ELa	1578	1296	313	6301	12463	jxKiwBUvaS5w5HMsFSGitFngXqwX48ocNsRni6rcCVNxrExHoqY	9181	12976	12976	1618274880000	canonical
18231	3NLSy5h2Q41zkWxTd7tJTJi7nt7kLZ7mdkDm3kSaPouvgxpnG7FX	18230	3NKGWVQHWXpDjjJC7zFJ1Vs3yDV2LroVhX469tRnjkVdSfBMSwEc	1588	1266	313	6301	12463	jweBngnaXCa9Scfnw6NsVBZbwmzXRqEHT51xrgdt5qxHu9w4A5Y	9184	12979	12979	1618275420000	orphaned
18236	3NLhAT27pE8YrfiCmfEP766FggRx9Dcg3Xcn9WDfR93XB7zj7b97	18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	1613	1349	313	6301	12463	jxjh2DHUBJz5kuLQgEWAt6GBR6AqaG22ktJPoW7LpJas4yTKtvH	9186	12981	12981	1618275780000	orphaned
18284	3NKUoG4xZWyd1ivVwBwguB7HbMKThabZXaFCZuzjSmh2jpxM784k	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1654	1094	313	6301	12463	jxa5Rd4YV4mzZqc3gtvkf2rAeWQYoLcKGVNE1mt5LS12SAwNdXy	9187	13016	13016	1618282080000	orphaned
18242	3NKb4ht6CcrWWM1HioLRcAdPoGA4e18HS7e1grWnYvsVxyTpN4Fv	18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	1593	1346	313	6301	12463	jxqgGtnAdxaAvV7pmBSvmEiiNiBmg2gvdCaX8uuqW8QbXNGW4Kv	9188	12984	12984	1618276320000	canonical
18252	3NKgxnVV7Vs9v8sb8uw61zsmWijUnc3rGG92bkhrJEBxaZo26Da3	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1599	1287	314	6301	12463	jwi1L3KXWjihfVPgmqUkEJUZ4r4EFqo6WNMemMgzexqUHf5PH2D	9193	12991	12991	1618277580000	canonical
18254	3NLBSztUgrRf62XYgv4REMECQ8zva4SQ5n9tmDVQD6gMTFTUswdn	18252	3NKgxnVV7Vs9v8sb8uw61zsmWijUnc3rGG92bkhrJEBxaZo26Da3	1573	1318	314	6301	12463	jxDAjxmsugBMf3aYtgQFdqEJHaBg9ZBpRjAGzrvQyaTnkFT2tkJ	9194	12992	12992	1618277760000	canonical
18259	3NLdwfWtownYZgUUavMZ6HfHEwFhWRV4pz76V49BJLqYNWCPgMAe	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	1594	1080	314	6301	12463	jwyoML5uTECfGobscd5DV5qqbNnt23XZVLZZoxHf99Fduz5VKVj	9196	12994	12994	1618278120000	orphaned
18261	3NKZRM6RbRRVoKUaw1pUXDFwU7bKASN1wmGg9yeMEB7GBayP2oXT	18258	3NL1QN3CsZ7qdWMeoh7WM2KR97E7p6FJhU584qfSBa9z3oaaPUzg	1573	1318	314	6301	12463	jxTDp8qwPMPHh9vFVnTbXngHagb8mizBV8ncKjDeA6AgSmy9abn	9197	12995	12995	1618278300000	canonical
18264	3NLTc9ugBwwad42SxfkPF1ZJMvL4w3eDvG1AB8SY3tjKtRZ1u9hq	18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	1402	852	314	6301	12463	jwLrjJVJoCxxCJNSMoM2GrbmsbAiZUHqSrbUSzEpWxrxwddP1pW	9200	12999	12999	1618279020000	canonical
18266	3NKAR9pQ3gGVp7YeoJRyxZ8MvhoRhcDYzyqVaK2s9cwj6iF2SzBx	18264	3NLTc9ugBwwad42SxfkPF1ZJMvL4w3eDvG1AB8SY3tjKtRZ1u9hq	1596	1363	314	6301	12463	jxjJTYww698RCC5Xy44xAUNz4Fuhntk99dJJC29z2z6hrGYpz9z	9201	13000	13000	1618279200000	canonical
18274	3NLvYikrtGGB3ELxrFwzHY1awA9RytZnFhKxXS66qLRw1y6pxtrZ	18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	1483	893	314	6301	12463	jy3BGueXxLjwVSiQi5JcUF5v54v3SZzR6X9iVNLXw2ztnSYsiaW	9206	13007	13007	1618280460000	canonical
18272	3NKngHEobcyoicxeBBNTD7yX4UyjSYecNAQcgWyHGfV8Gxzdh4Wz	18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	1403	786	314	6301	12463	jxuWfLU6xtKFsemqVJNWuHm4oavyn9UUcGmoSP8eoEinQpM5oKQ	9206	13007	13007	1618280460000	orphaned
18278	3NLMM8AnbprFHjPDaovD8Zy5RyNAvGVwxYBfj1s7oYusm49BBidc	18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	1622	990	314	6301	12463	jwB7fjLefj33ncMqU4bn43eLvDbiR5jc8yiDGhKvR6SSCNVtTQx	9209	13011	13011	1618281180000	orphaned
18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	1523	1321	314	6301	12463	jxkKoJj7X3GLPLQ4aFWcdTNcBk6WCkVJaPNwkfKGHDwfwKUPxeY	9217	13021	13021	1618282980000	canonical
18294	3NLiF8QaFJL68dYLoKKQ5p4EpqQ1cDRPyWXf2CR1i7P3bSVAE2Qf	18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	1523	581	315	6301	12463	jwF66TWtRwFK8woL6DtZFdhFCe92LTyb8e57GbauVqdqC5t7RPL	9218	13022	13022	1618283160000	orphaned
18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1522	1322	315	6301	12463	jxiquwi843LNPpM74kLuVfPApmMnvmmazc2JkLEnFk864caRact	9219	13023	13023	1618283340000	canonical
21483	3NL2QjmVWpcQBpkaJhR95Wv1yGqhDENT5jbYHKBMDBdN7yVUkbEu	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1406	1393	392	12463	13695	jx9bWzeFVmxtLMpFgh5ivuBgRYTh32CEqmchnv81cotdEK5e5gS	10772	15175	15175	1618670700000	orphaned
18227	3NKHVam4LGvusWU4yr2VFhJAxLQRgr236yR3mY1MGpJhSpNf7sgm	18148	3NL8zSkaSShD81ucw4xK8d79q8hGo6eabn7GzV4aM4iRknwgrkQZ	1503	1151	311	6301	12463	jxZsKog8BZvdgqKVBVZhr6nJPqLsaq17uBay9MKFspfpF52bKD6	9152	12975	12975	1618274700000	orphaned
18193	3NL4UGxZ2zKgcojxVVVnAw786Hthx3FkowUpQfnU3CsoYZsPiZJC	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1483	1276	313	6301	12463	jxiFAxKEq9LYJwqwn574F4PS7kCcdMQtuAA6STR1RjZgavA9QSg	9170	12960	12960	1618272000000	orphaned
18217	3NKyZUA21McUNV3DmoC6Ejk4n2kfLr5SZ7KjYHrevKCQPqQkEsi1	18196	3NKsHJ5Ke7uwxvzToG1odkisxQweFzFXHqs43iXYFRoNhb3Kv6HT	448	1305	313	6301	12463	jwPPrCf4ysiu4sx54VWBV4sHX4vTME19HgV8a8ULV1CPZYrqyCB	9171	12970	12970	1618273800000	orphaned
18198	3NLhVFX9xe7hqjDGez6SCik4VCVdTG9Jqvoyjus2nq2ghnLDsxwW	18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	1546	1339	313	6301	12463	jwFdqMestQ32PCLEgADAs4nXTFnuZ92PtvfVnZ4L85uuc2yxuwb	9171	12961	12961	1618272180000	orphaned
18204	3NLSQsN9sihtmcfh4QKsyW9yBLTCpsyNyLeFHJkesrcoMW4wWJoW	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	1578	1296	313	6301	12463	jwBNtVmSFJ1fZZd5GsjP9FZvRTrKdsPwDcLbneXBccH4XTzy6MA	9173	12964	12964	1618272720000	orphaned
18206	3NKakLUtwFyZwKEjduU54NpFrCBjdzKBB14iBxytZUAvdLGLwsud	18201	3NKsH5djbR8WVCzZp4kWNcrqdnQuD445JbmXmPVpX4z5RZqyo7cf	1407	1395	313	6301	12463	jxyDhh3kY9DKHezzekzXN4beaQoSNXx6iUitradirFAavEFFvhm	9173	12964	12964	1618272720000	orphaned
18213	3NLpLWkzUJDMVgFwLUcfnM84vuwzJMV3SezXu6mf1Fx1vgNyeczG	18208	3NKCFZvkaqxpTTuG8dJVfCXs6miFKhbtKhqz3nrq6vprrQ1UQEda	563	993	313	6301	12463	jwT6kiZYPftDcHMxv532oPECYzdS3nXALzSsgtb1RNmKjknesaC	9175	12969	12969	1618273620000	orphaned
18215	3NLybrHUmb3h7oCqCkHdgYUCxpS8rcpMPCs52gH48BafUeUXqZf5	18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	448	1305	313	6301	12463	jwBgmoD3ebKR3dTs9BtY3vYJtMmF6grpMk1QmgevzqKgDicYPU8	9176	12970	12970	1618273800000	canonical
18216	3NKtShTi9QKaWiE58uaYuDpSmueYqyRhpqbiJvLQoAgP7DXg1wAH	18211	3NKsf9gNkoxEkK6CVvxhqNvNi77xxAQjga7rt8XMc9ofoCwqADoZ	1448	1311	313	6301	12463	jxnmAa3W9RMBkHVeHjX5zvMFqAPxAkbLFF5n9m3P5vtBwqyB1EA	9176	12970	12970	1618273800000	orphaned
18218	3NKe5GJVYhkqJwTLqKK9TxSjVk3UoLLUmsSf8XbbxRQppZPBYiV6	18215	3NLybrHUmb3h7oCqCkHdgYUCxpS8rcpMPCs52gH48BafUeUXqZf5	1589	1286	313	6301	12463	jxcNt4bhxchGYtZu7t3rhXwUYSau9dYUb6mWG3aEohj3JVHgXo6	9177	12971	12971	1618273980000	orphaned
18220	3NKAz8s2jQ51sNH13PqANgMgefiisW9rwHFWZVYTXD9YXeCYr6EN	18219	3NLHegPbxxYaHFmcvVQbFeBY9z3kds2SZBaXexP5aWVczwDhDZBT	1560	1165	313	6301	12463	jwQ4BozidekFFFhWikFaAMSEeVRxYCnXbTes6CxixbfGPuNVsEv	9178	12972	12972	1618274160000	orphaned
18224	3NL18ZBdPU5QBF2CM1YLpdCDNNDgdrHD84VUeHu5k4GvSM34dRFi	18221	3NKmocnZVSr3RxCzBkTX9RoDSyU8Mk1fAAoWWZEdVSd4F6mNDBbP	1634	1331	313	6301	12463	jxa5yFQsKnxxLXGPfNCVJJwSFcwFfiP9E88PuZiqWVaBtqYZUtT	9179	12974	12974	1618274520000	canonical
18225	3NKEhVWcyFGqJCQfk7nKZkrJzV5tyWntMaYRWjT1UR8TBRdF8ELa	18224	3NL18ZBdPU5QBF2CM1YLpdCDNNDgdrHD84VUeHu5k4GvSM34dRFi	1503	1151	313	6301	12463	jxVt36fBZ7bK3yLU1nZ7Yetxg49K1N6jDTt7qm6LQg1FsR3EJ5S	9180	12975	12975	1618274700000	canonical
18229	3NK3uTCXAN5sksVpLQSUGncPXSe4sMQFXmfJiTNvJDoTjStcQyLf	18228	3NLjX3my65GikcnMKGw8FrGVhyejRykT644xhsvvqsir7QLXkWDC	1407	1395	313	6301	12463	jx4MnnEbLapSCFQgRKpszBxduZ2PPGp7RzDuEptVLXFp4TEV6bF	9182	12977	12977	1618275060000	canonical
18232	3NKXcF6d1Kfvj5PTMrnVQMps3JxpMpEfqRv8wC1HAiFuxAiumRXu	18230	3NKGWVQHWXpDjjJC7zFJ1Vs3yDV2LroVhX469tRnjkVdSfBMSwEc	1403	824	313	6301	12463	jwEgX98bihzmVZDTpSEPkMZTeMssowM64mR4RtAjUcQPa6sGxhs	9184	12979	12979	1618275420000	canonical
18234	3NLDN27286c2iGMjqcEETBmJ81eTHRYMNzshx6pp87fda5p3UPek	18232	3NKXcF6d1Kfvj5PTMrnVQMps3JxpMpEfqRv8wC1HAiFuxAiumRXu	1587	1357	313	6301	12463	jxeNGzeg5nQgvXUkEUyVyeBYzK3emwHJd4nBzXqeGBvjV4GWxd1	9185	12980	12980	1618275600000	canonical
18238	3NKKjRBcTXewPyUZZKASe6kERP9qxCiojpiGyNwXxgEvxSRQiwkS	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1588	1146	313	6301	12463	jwMMeWqTtEcLAVrZGWBNqi7QZVsPQKb1MD3E9hhdLwiiCaNG5sh	9187	12982	12982	1618275960000	orphaned
18240	3NKnHMXFPYHt8eQEkTKQ2SnDHV8WTFN8vQA2V37cqD32NrqVRRaZ	18237	3NKHyBk51rY3PSL5wg4JRcGyaw68QKgQQe8UumPuUUKzghqkPkkf	1623	830	313	6301	12463	jwrXN9mp3CoVNFburNou979eZWN6RU7mFE5cQN4Ec5LR3QDknQU	9187	12982	12982	1618275960000	orphaned
18245	3NLWWFjEXxhFgBnbrXwyUZU55dtRdy9sT8AobMXefb9ms37n4kjw	18242	3NKb4ht6CcrWWM1HioLRcAdPoGA4e18HS7e1grWnYvsVxyTpN4Fv	1672	1285	313	6301	12463	jxYznsGTHuBXaaWcyrZ8jX2Mhwhk84sqbnQ6JtvTjchJF9sJgGQ	9189	12985	12985	1618276500000	canonical
18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	18247	3NKbr5NS9jEFxso9Q5r3tw4WHxZpVkQ1T6b7jfrNmhQ3ZrR7kFaU	1652	1315	313	6301	12463	jxvVcwhAWJsVUVdH9bqgHPQFnronHGcNpXbxhnQey1W3ZwFeaNt	9192	12990	12990	1618277400000	canonical
18251	3NKMf5M2Kioc3CGPMa6Kajj2DDPqFiUow7mf9SoMp2PV7HvcUH9X	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1637	816	314	6301	12463	jwc3yBtSSNwAS9oGqkCrREAHfcoUjUXEFtAPLnkafTEwN8Es2Ab	9193	12991	12991	1618277580000	orphaned
18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	18254	3NLBSztUgrRf62XYgv4REMECQ8zva4SQ5n9tmDVQD6gMTFTUswdn	1581	778	314	6301	12463	jwbc9fjd8owrh3eXPkwkqMYiwW9VDYmkN76hdcdVuoX8byKbRrc	9195	12993	12993	1618277940000	canonical
18257	3NKRx513Fk4udErQtVPcQrU9VUpmSvmxXjDZzUx4wEZgXTNHiv2y	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	576	1355	314	6301	12463	jxa6Bp8bfmAuh4miUj3dG1JdqAN72g1cBMu3eQBnikudmRyH8BM	9196	12994	12994	1618278120000	orphaned
18267	3NLr9v6Uq6PL3BFbxC23DeBP7QUJodTEFoZXYUpAydttEQfeTJfw	18266	3NKAR9pQ3gGVp7YeoJRyxZ8MvhoRhcDYzyqVaK2s9cwj6iF2SzBx	1651	1055	314	6301	12463	jxe9cUuwNyoQ9ToHgY4ZrSMgZjTAh6Szim4mSJiYpigyypKjTRy	9202	13001	13001	1618279380000	orphaned
18269	3NKhwom8RWmPVmnPnLipUcW9yDCrvnSoPpAmRtT27bnVszthCut4	18268	3NKG5Qpfw7gDbfzDFZ2GJEE81uCAon9oJkGzTc1yh2GxtsrGhRqH	1633	1390	314	6301	12463	jx48vYzfKn7KaBneCidWAZh2UbtLQaDPtiWQrgY4o2dpJEG8uxu	9203	13002	13002	1618279560000	canonical
18273	3NKGXdJ2nhHCjsLtetUvxVeqAjKvgyMkmoesYLExRjPgFBd4e6np	18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	1406	1393	314	6301	12463	jwMPtW9FZyoFMuQ4PoXouo2h9NN28xtVsaxKfcy4g7fZUMp2Dqx	9206	13007	13007	1618280460000	orphaned
18275	3NKQDBaB1f19eAK5r2xtBb1vBTEBfDS26Ao8Q9C653WU98pCmw9N	18274	3NLvYikrtGGB3ELxrFwzHY1awA9RytZnFhKxXS66qLRw1y6pxtrZ	1577	1327	314	6301	12463	jwXTBggE7e1FqUZPtFT27pfnprzf7c4j4sV6FBiYP36Gk6LNX55	9207	13009	13009	1618280820000	canonical
18279	3NLsxPQNV4RwSdMy3ykDbfsii3fCzCwK6eH67qShLUacXAokTQFk	18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	1623	830	314	6301	12463	jxd7dxJ3PDdao9vuQxF9nvEwQUQcfSemg8G87X9m4MpLBvvV8s1	9209	13011	13011	1618281180000	canonical
18285	3NKsFbCG4xBAKRjkoukXUEJkK9gyuysk4Ua9PX41cUWrXXAwtfdD	18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	1407	1395	314	6301	12463	jxyXZKnzXirEbXUKHUqAHqqvSf1icakFFbeVjZseBk2ufFEzstg	9214	13017	13017	1618282260000	canonical
21626	3NK59NetmjqQZctL1xRiY1nHwAQ1iXtJfB5YHUi91EBp5jWGGXhU	21497	3NKCq1T3L9YVm2t8jAsqCthUMPfM3TGe5919Cpx7Gqvd2ksmczXC	1670	1036	393	12463	13821	jxneHCh6MdoFEPnLYMsVouF2cHURwJtF4LjpF14mfhRC3KRxJYE	10782	15252	15252	1618684560000	orphaned
18249	3NLC61gMVxAfn6wbNMKxqbe5T27EDpQpR9KFzMgKrHFRyLcVquHv	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1405	905	314	6301	12463	jwSyUZdYL8u5Vd7cBHcc1xecXDqsYsyFpP6A1CCeHm3MGAXecnn	9193	12991	12991	1618277580000	orphaned
18253	3NKwar3fvFnHV4o4c9nbaK1s3RHZEk2A1KrvLPb3fxoE1SvLxqfw	18248	3NL6VaM5zmYHa9SrzL7J1QBpvmvPmvVgDnip8GrjEPeRj5wuyNma	1631	794	314	6301	12463	jwGP3WX4btgk7b1nSkGPYK6iW1ynA9utypV6iQt8CfhwEX9ksDR	9193	12991	12991	1618277580000	orphaned
18258	3NL1QN3CsZ7qdWMeoh7WM2KR97E7p6FJhU584qfSBa9z3oaaPUzg	18255	3NLXrqPrw6rkUr3RPMRjNducMMX4UUxgXSmSXdVm4xSqt2hjdWnN	576	1355	314	6301	12463	jxrDkzhPvF8AbvRqmyrq9dZviUgJfrhS47mhTka4vy9RD2ffVZS	9196	12994	12994	1618278120000	canonical
18262	3NKqN75ptR83J5bBg2qceVFawGQvFSDTrqWuBn5fXc4Y5i1gAxBL	18261	3NKZRM6RbRRVoKUaw1pUXDFwU7bKASN1wmGg9yeMEB7GBayP2oXT	1406	1393	314	6301	12463	jxqBMi1kQatf4zMAs4cWGGzaiACCkf9v4LAAQFftQw7rUt5fTWT	9198	12996	12996	1618278480000	canonical
18265	3NLsvQABk7ENkkq8bRJ3AbNwgw86GDo3dBWaQkBJLWWhzeCG3Fs3	18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	1406	1393	314	6301	12463	jwhnX3MmeS48jtvtDMysPW1mhiUZgcdz1vV1WMbAy19HxNrDZeV	9200	12999	12999	1618279020000	orphaned
18268	3NKG5Qpfw7gDbfzDFZ2GJEE81uCAon9oJkGzTc1yh2GxtsrGhRqH	18266	3NKAR9pQ3gGVp7YeoJRyxZ8MvhoRhcDYzyqVaK2s9cwj6iF2SzBx	1651	1055	314	6301	12463	jxfFF7j8FKiGizs8S28eUtZ3Y4G2gxz3QbmhG6cfZAXuTNrbpK6	9202	13001	13001	1618279380000	canonical
18270	3NKeibXVg2biJSpmKo52CN3sSynHe7G15gQsZUDNRuTiarSVcc5Z	18269	3NKhwom8RWmPVmnPnLipUcW9yDCrvnSoPpAmRtT27bnVszthCut4	1406	1393	314	6301	12463	jxxzAbkuqFHtVZT3aDAESgebTMKUECBEaFaiqa3ZsZegfvrBvxX	9204	13003	13003	1618279740000	canonical
18271	3NKqQHhotbHoFzx1E4inWBKJYvw28KhxuqSahnuKLToU8nZWJ9Eb	18270	3NKeibXVg2biJSpmKo52CN3sSynHe7G15gQsZUDNRuTiarSVcc5Z	1407	1395	314	6301	12463	jxtVk1vptvdPCJyB8oCgDxYpsBMJ5F3L8Yh58syUJEfRrtdvrX3	9205	13005	13005	1618280100000	canonical
18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	18275	3NKQDBaB1f19eAK5r2xtBb1vBTEBfDS26Ao8Q9C653WU98pCmw9N	1407	1395	314	6301	12463	jxb9XLdRKSZQWsApGj77aSgTzNsqYbw6AKLHTrC9uuVxko8LWBP	9208	13010	13010	1618281000000	canonical
18277	3NLdjNq2FHsH7u9yY5JPsth3Df1WaWmBtMLCCFoQuA7CWvkpU1ho	18276	3NKRJQbzv3h33yzTdnd8PRV8Hjx38JF9zH9huhhD8peYs7C48EbP	311	941	314	6301	12463	jwdcWvBidbnbiTMER9mjSsKFENzrvVYjsJGPufyWZiz6ZMBCnxQ	9209	13011	13011	1618281180000	orphaned
18280	3NKMXNEZFq3eECLMquh3rU5Kh12DmBhNrDsqJ37PGmWc3ypyB3jK	18279	3NLsxPQNV4RwSdMy3ykDbfsii3fCzCwK6eH67qShLUacXAokTQFk	1457	1391	314	6301	12463	jxEa52k5ZuRoK9KjYu2sHro3H4mBh7YuDpbELJjyruWn6CzdxH6	9210	13012	13012	1618281360000	canonical
18281	3NKUGbuJmEhXRmxS89v3dK1LxYGTphLu9ehzaFR7Tr6EDbvrCM82	18280	3NKMXNEZFq3eECLMquh3rU5Kh12DmBhNrDsqJ37PGmWc3ypyB3jK	1671	1119	314	6301	12463	jwtMxituVhJXaJKenJyzSgAWEJirzdVQRUXVEtCjAdaUP4pTs2m	9211	13013	13013	1618281540000	canonical
18282	3NKUMTAnvuQAe1UT3gPd2cUPHrPzDw2EECpQCo6ngDy9jM6JRkkA	18281	3NKUGbuJmEhXRmxS89v3dK1LxYGTphLu9ehzaFR7Tr6EDbvrCM82	1501	1234	314	6301	12463	jxUpqUvY7bxnLvT7GsRLKKHxtfVKLjb5x5y6YoELZErrRaX3Qn5	9212	13015	13015	1618281900000	canonical
18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	18282	3NKUMTAnvuQAe1UT3gPd2cUPHrPzDw2EECpQCo6ngDy9jM6JRkkA	1654	1094	314	6301	12463	jx8JUnHgSKunGe3f6KsPSFUfT8zir68r5Z8PAAgmyECwSZVHSFD	9213	13016	13016	1618282080000	canonical
18286	3NKtGwwuYQAqfHuCQcG1PX1dKMariNgJhUin4cxvLUFFBweASN3f	18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	470	1063	314	6301	12463	jwmgJwzd7t7ruLDUv3tzLojSyfPhUBt1vuv9i9AgV8KtTEvs6a2	9214	13017	13017	1618282260000	orphaned
18288	3NKF42eKaiBZNqTzaajjU1R2G4RQjesSHqxB27PtEYikVbS6YdEh	18285	3NKsFbCG4xBAKRjkoukXUEJkK9gyuysk4Ua9PX41cUWrXXAwtfdD	1507	1280	314	6301	12463	jw9RvPmNYd3fVuMYiSxr7r81WexXMLhSeMK5daHPaEwkY2aoar4	9215	13019	13019	1618282620000	canonical
18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	18288	3NKF42eKaiBZNqTzaajjU1R2G4RQjesSHqxB27PtEYikVbS6YdEh	1513	1379	314	6301	12463	jx6aq7NrZPaYWpjpV5tnyufLQzPi34ihCBxM2NwjscZ3XGTSsTy	9216	13020	13020	1618282800000	canonical
18291	3NLqBn7zaJY9JDwANPLfd9Rf4JZQdLG5xigKWPDXQGJdwcvQoJog	18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	1457	1265	314	6301	12463	jwoMdhoCn1y2b84jzdTmHe3Q9fPaLUu3eJMkbtfQprd4k4ShbcP	9217	13021	13021	1618282980000	orphaned
18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	1553	776	315	6301	12463	jwHrRaxk5j4tvueHHDgFb2tU8hZQvgLmUD45KUv1rbPpsNUMohg	9218	13022	13022	1618283160000	canonical
18295	3NLDn58ED5xEWMVAno7UqqoQGR4whZKGfnMYYpTTK4WPorjCMKvj	18290	3NLBa4aZYT5zJH4PpxQhPnb7K7Mvs2qqc9qBvygypxLs5Y4j11Xh	1523	581	315	6301	12463	jxEtZqMAUSC1gn96kbFdxmrf1Trpx6j7UmLf7x135HsLf7YXutX	9218	13022	13022	1618283160000	orphaned
18298	3NKAp38ax1anG1vPUmnbcB3scf3VQcFqmSZCBBSM1L3xVsnVDBoK	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1402	874	315	6301	12463	jwKa6TXZBQKRQvz9aMTSje4QihYrWoLnHD85ohmPWYZgoEQ7n1b	9219	13023	13023	1618283340000	orphaned
18301	3NKMNUXWjQKQ51ncwKzViEgwtZsjowtk5Z5VS7RbG3ZP1mwqHjna	18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	1403	824	315	6301	12463	jw8DRDon6nSjB6YJwsRaKSkN237zCN1uDVf2UTeZFH3nVnKT2ii	9220	13024	13024	1618283520000	orphaned
18303	3NKiCrPKQFsV6RLQLy3PcLeENYkxn1vpnf74NcV3FnyERvsnStNy	18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	1407	1395	315	6301	12463	jxiuvcTshqhhgiUKahWZwvuzt4g6FCczkh7Fuwmocxm523ChzL5	9220	13024	13024	1618283520000	orphaned
18306	3NKVBdQuxEbexKFFYkXb3BAeX1jKQ3pLqcHLkmLswfSnNuJurhhT	18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	1675	1096	315	6301	12463	jwd2X5GCyVB1Yf8s6u4xhUBfw1s5Ff6DCCUycnpwNjW21vpwoLo	9221	13025	13025	1618283700000	canonical
18304	3NLhvEmiq7ZEdz9CitD7Cza8bJdi43DY5RiMtMgKGXvtD5JZ31HC	18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	1422	1091	315	6301	12463	jxvsyjEEk9BtaLtumPgzXrFMKdvYVKoCry1hcZi2LSzH7Nj7qMH	9221	13025	13025	1618283700000	orphaned
18312	3NLwbzfjLnuDx3ocT8UqCZni8JRTMSmMdDoYrdyeoxVg1DuUwtnA	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	576	1355	315	6301	12463	jwNVheyostkxR96n63bN619JW39UcUXQrmu2SekGEp3FYHMAgGX	9225	13033	13033	1618285140000	orphaned
18316	3NKb92j4yx7NSHfkLpHEPoWgFjSAPXRK1p5tL4raqPND1j9ELPp1	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	1541	1298	315	6301	12463	jxpA3m2gMwiTWCS9rCQzmskQGEcdnMtGCbQKALn2QM2EGgH2GhJ	9225	13033	13033	1618285140000	orphaned
18320	3NLgyKcRyCUSQzN3achNYkRTfGdRZBmmQ29S4q8BMV33eteT3Bsm	18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	1651	1055	315	6301	12463	jxLxpEiJrDrem55iKXXHWc74jZWhE5kPioQ8p694wCMvgnjt7aj	9227	13036	13036	1618285680000	orphaned
18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	18323	3NLkSZVkcTGUcNXoVENPRxw1rArfZwjkEwUAB8nUBNjFvvsGVUer	1406	1393	315	6301	12463	jxLA7a7Rge8YyyQ3SKe7ZgPsa4Z9vBNwR2qCv319hUsyZRVCBCP	9230	13039	13039	1618286220000	canonical
22036	3NLjYiiSY1vPyTWmxvzUiHW7kcwjozCUEkZ1vTWP21kLVnBaiNGn	21626	3NK59NetmjqQZctL1xRiY1nHwAQ1iXtJfB5YHUi91EBp5jWGGXhU	1670	1282	394	12463	14179	jwM3FeG7NJa4DtCHskoFMFEnhEUux72aAofqMSxWzwiMR9zMXCv	10783	15510	15510	1618731000000	orphaned
18292	3NKrQYPmKCMfguEiTmPdH8yan87xmm19FY8ovSzuMdN95MfRJVHy	18289	3NKYM9ZYoMWRFC6HQLLsSwgipMhZ5d39pz8H7eJGY4uPMQGfYbr5	1523	1321	314	6301	12463	jwqZisyiNAXrjbCxbkcTxZG82JTfvaRegk6bWiZZxuDA79myqur	9217	13021	13021	1618282980000	orphaned
18297	3NL3C4K9FT56UYFWdyyugSwdQVejK1hCGQ84QxRR1ZoRai8S9Pbj	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1406	1393	315	6301	12463	jxWhVHLKFkX5aux8rVTexELCHjuooWdPLSPD1ozpE4TJLVGtQ4W	9219	13023	13023	1618283340000	orphaned
18305	3NKh21qegN5JGTjNo4U6eTy3MzDvmNAManWGHz6EBSoJumgfwsFb	18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	599	599	315	6301	12463	jwUvqvxwTKJb4RaCYHLRG1KvT15QHZE23xihZuw7Z75XJyPpqNV	9221	13025	13025	1618283700000	orphaned
18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	18306	3NKVBdQuxEbexKFFYkXb3BAeX1jKQ3pLqcHLkmLswfSnNuJurhhT	1622	1230	315	6301	12463	jwFHTyVYoGGX2hepFVhohBBGPxtmU1fMbag5qZn99q2etxcewby	9222	13026	13026	1618283880000	canonical
18318	3NK4JZUmLLN3CrHeaT3NqusXksNqDJTBu6gWPNFcAXiSSibHkXQy	18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	1406	1393	315	6301	12463	jwL5SvJaXCerUZDeq2cTZkgsJCJuPfVXLWks2hYzTWuMgqmSKzF	9227	13036	13036	1618285680000	orphaned
18322	3NLSm9sBkJZSx3qiE54bkQFDVHYKXTZfX7iBsEVT7uFZCkgoUa3D	18319	3NLKjugQYnG4sdkTbET4kZHS6hG17j8M65kpMSVQy9qXq3A3MWeH	1581	778	315	6301	12463	jwZexWA4fRvC61Vqji3KKtGNzqdKQmkYcS3W79mRbrzpRpG1Vih	9228	13037	13037	1618285860000	canonical
18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	18325	3NKiukESxmFjMAFtN4nj6zLKt6MV1p6yxLrFkK6khTMAG56vGvim	1553	776	315	6301	12463	jxaFVwvhsczJefgXdEFTP8stRVSBxiUEjhNM8363tcroZvxkZg7	9232	13042	13042	1618286760000	canonical
18328	3NLpkbqRAZ5ks67XYscE7ZvQbQKXyoh7gbYiv4PaLoVNQ165hAVD	18325	3NKiukESxmFjMAFtN4nj6zLKt6MV1p6yxLrFkK6khTMAG56vGvim	1406	1393	315	6301	12463	jwSxpkENVDPnYra3ZfDp1eBSBow5YrJyCZ9xyEFkBpxaq4xNXRE	9232	13042	13042	1618286760000	orphaned
18332	3NL8Q93d438Ye4nijwahjAvaCQYqxAzcTygkei2StEcW7kJwJdnq	18331	3NLQPj2bopMTr7dRWBoqDpXQtmbj1pWUoiL4CPnhuB2YgX6e15wa	1623	839	315	6301	12463	jxWKHF4DHJkupu9iUVsCbde7zQLNF7HdEE4ZZUEVbD76Yv2Af9e	9234	13045	13045	1618287300000	canonical
18335	3NKkx6cGrT7VpZjrigacgkseEyw22yLqs62j1ksxuBnKkZ6eHESs	18334	3NKU4sgrhAYnvyGL21cDPuQV3KUJSHCaxCihK6ZbrsqN4kLTrtQS	1403	812	315	6301	12463	jwgSoCmErgAZMM7LY6axW8icaT9SbTyU9E6itg2DGQtAawdLPC2	9237	13049	13049	1618288020000	canonical
18339	3NLHx7Y3Ytzq1PajDhFyzVuo1sXGkgibaJT6Tbnkrz2N3rCmVm1k	18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	1523	1321	315	6301	12463	jwZPdDg4vThU5uPF6hwft5oz5qGM8ghCUzEuRszzAod3fUU23gC	9240	13053	13053	1618288740000	canonical
18341	3NLVWRgow9C4vPQHj1uiJjvG5V1b3dU1ow4guQVLSnF8sksXWoFw	18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	1523	1321	315	6301	12463	jwp2KPgkjbpGU6ohPNmpgizea3NMWcx8P3M9wxs8efVTSN18cbh	9240	13053	13053	1618288740000	orphaned
18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	18344	3NLTDovKuYqdhtaQdpiKu6AbDjTkJQ3LWVX3zqvZbtaQzv2rovLZ	1406	1393	316	6301	12463	jxC2dJgM1xSiJz3KqQ1misnSKTmjo2iZ31M6NCrH4Fmgn1s7FpM	9243	13057	13057	1618289460000	canonical
18347	3NLqYSb5sHcZZLB3NZyZYxHDSui1f31CTE7gQUbmHbLcGhnEYKS1	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1596	1363	316	6301	12463	jwchES15e9xLosq5MLtLVSTbb5Fc9mtXKmbj28H3LkjEuRTeRdo	9244	13060	13060	1618290000000	orphaned
18350	3NKwiJyofBbFJu3RdJooUSUdPx7PbDGf7SHCEPtLo6nexrf6P2Q5	18348	3NKrPGwtRCcfBvWXYXip3kkFRh7UYoimaGBGRoqnFMByrQjFK3tt	1447	1219	316	6301	12463	jxoa2QJJETUP9ArVfEjRHLYuVZyvxePysRfpxsZzS3t1YhNr5u7	9245	13061	13061	1618290180000	canonical
18351	3NLxwVegeUCkatcdDhAY8mPdpwfm3XQR2A7fvUSqNwgR4jXqQ3KE	18350	3NKwiJyofBbFJu3RdJooUSUdPx7PbDGf7SHCEPtLo6nexrf6P2Q5	1407	1395	316	6301	12463	jxDKTe5LpygcQV5iN4aYxZDDCx6B16BDo81L7B72j2aG5vrDi8z	9246	13062	13062	1618290360000	canonical
18353	3NLDsQSs6QUVK1Jk9euEp6oyMPoynZLBSC875xRXfbiPQkMQC6Qb	18352	3NKc7TRzmdf1ot15uVk9hAmuB8giBsew2xGWuWWzco36BxKqFUBk	1673	1368	316	6301	12463	jwqpV8fxdWStv9t3pij9iNDX2d5mptfWfA4uk8fGAu9PLXTyqSQ	9248	13065	13065	1618290900000	canonical
18354	3NKaQg9AZJyNjukq2CFnyzCYHvYuhChtYFTxBrwUDQsT5isZL1hY	18353	3NLDsQSs6QUVK1Jk9euEp6oyMPoynZLBSC875xRXfbiPQkMQC6Qb	1407	1395	316	6301	12463	jxYoWfRqKtvTxXsTnqNbLyv1QTnuzGKxPqvxSYvvRfjeFGd216k	9249	13066	13066	1618291080000	canonical
18357	3NLNJJTkYNmtrYtYqPYpVnJZ4K77JZcwaeUpxk272mAvjWDDWjML	18355	3NLkvhRbBV2XXRAE3oKnNTHtSAVyboADYSSwJBA2aQ6ocN3aDez4	311	1061	316	6301	12463	jx6T1Miz4Ck15UZPs2XyNTvJTPvxQ56qsqHdqEtoYHYpqeSVNea	9251	13069	13069	1618291620000	canonical
18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	18357	3NLNJJTkYNmtrYtYqPYpVnJZ4K77JZcwaeUpxk272mAvjWDDWjML	1593	1100	316	6301	12463	jwRPuVUxB4p8fQxNqvp15gmJsp3nh9ks8C5AsvxJ531qzyQVyL2	9252	13070	13070	1618291800000	canonical
18368	3NLNp9KyYdZUoZGLA9ZcgR2nM32QdvDRPnE2WShTTW6xFEDSbzDM	18366	3NKcqWY4ZmvA9n7aRx4uQpB3waWrgyEuKYJ6FKvFasXteZqVMycs	1599	1041	316	6301	12463	jwex8ez37akB5kPttVRxaEPozFHzocXufNUe4wKAaCuMERhtiG9	9257	13077	13077	1618293060000	orphaned
18371	3NLF6hzfF1Q6nougErcUviTSm6zFiMBuDMaGCpNKzTiCfcT4SAuz	18369	3NKbbwFcVeBKmyiLvjaa9WJ4FS4ZAqx3drF7pvE5sMD4KFNYznzp	1522	1076	316	6301	12463	jxLroLUKj6s1d9Jr3ALJFqo2W9nrDJScdzKt5kaG3PWEnxmE4kb	9258	13078	13078	1618293240000	canonical
18376	3NLtNTZ6oVKKzniciRUEjFz65SfwftPAXTzN7fDah53431aaN5ZH	18374	3NLQRCz4cKBNPEBo5uu8jWyUk8vyQpjUwwjhoqmf1cGEfRDtPmwN	1407	1395	316	6301	12463	jwBGhz4eGcvvrwLVg5ywsEzEKQosniAa5q9hAsFG5m1tcx7LVvn	9261	13081	13081	1618293780000	canonical
18387	3NLecRTbyuVFGc6qJWC3eCLQQJYVFqTMGEcXBhrbwjBLKbNxNSCC	18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	1516	1048	317	6301	12463	jwQyh8p5hLaZs9bpgCPS8v5VWXv8dRXJbk2fSQedQzXWttNBnSy	9268	13091	13091	1618295580000	orphaned
18394	3NKHR5UP6ERWbV5wmENEcQy761DmPYJaPj7JzxgfBVUykf7qr8sB	18390	3NLF7Fc2hcr34ashnjFsU6VDDX8CExXxDoMhg46wzVdgD4ikFqSt	1403	824	317	6301	12463	jy2nLzPF24PbefRUGjbctParzxxRSh8ubTu2dnpLMnNFuk82Vxx	9270	13093	13093	1618295940000	orphaned
18396	3NLtJr4H9aNN3tfQcc4K14HMadeuWDKWKdcmDEkr7aTXuZZFawYi	18395	3NLBVdpbTqztbux2aaD2mPyJ7rhBWk3QK1yPR7DT31r4SDZsQxvb	1483	103	317	6301	12463	jxBaSbupmFPtH75EJ2TegGE5NpE76aJdEc5viZdWCP4zGDVWwiC	9272	13095	13095	1618296300000	canonical
18399	3NK3moHwqavT8WfPyAuRkGizURgEwgVhLUdT2B8yZE4kuC5LuaT6	18398	3NLk6tahbJ9ucq1gp2U6SgXyrsrsKevHwUDXNfwW4cfQvP4sZiNG	1483	1150	317	6301	12463	jwhVXvbxJ1wVA729Xxetm4FaWLhUPefkQGiicBLr2AjMjeJCPst	9275	13099	13099	1618297020000	orphaned
18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	18400	3NLkNBJKG2GW4NrsG2aVW63GqKKNMRjTzhTiK9KTBWB8wepmZngo	1522	1196	317	6301	12463	jxH4sZ7aBV6NdU2fGDV3YnzW6nc9UtED4NxZpoWYKoQDFBFmcxZ	9276	13100	13100	1618297200000	canonical
18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	1608	1289	317	6301	12463	jxW8w4Q5iv5SvY37xuEtFwoacnGNCQAvWgTgeUNT71pt7pLjU8H	9277	13101	13101	1618297380000	canonical
21514	3NLQwEnmBsLSt5z8DtKfpotQj4cCZL9E6WAb48GtzFadAHVgkkWv	21513	3NKaDsfvD1g3B7eGdxiWDPW9BHpTg6jE5tPXRt6hxUCu6C5vLadN	149	1283	393	12463	13725	jx8sdktivREAuNJexUXQL5igMWf1piWRuFz1TMAYcQUrJitxrR8	10793	15203	15203	1618675740000	canonical
18315	3NLsTfHrZxn3CMV4MAvmY8JTsPjmEsNM2uWvjLipPLNx9oWzVENU	18284	3NKUoG4xZWyd1ivVwBwguB7HbMKThabZXaFCZuzjSmh2jpxM784k	1654	1340	314	6301	12463	jxZNEET7iwcNEbDSmXmkc7JrTnbqSWfdEobWom1V18mnsnMr9vT	9188	13033	13033	1618285140000	orphaned
18300	3NKhqdMcy8a3JuidNSso5w57WTYP5ZHRqkWwW2sWJHiKxuELByTF	18293	3NL4XDEuN7Tgu3dfzKkPs1ZTjTkpSkKrXXPHfNZqPQWyCM8CvGfA	1546	973	315	6301	12463	jxPCPZJZtK3D87xbzYVBpd4NPiPZErQt9wrAqRELBjEudXFrbPa	9219	13023	13023	1618283340000	orphaned
18302	3NLQHR4An7E71FVPd2LKbdUXPnsPpNvnUEvGEMQ2LWViQfXNuZP5	18296	3NKAbVRunVJpCFjAEX4kdARvFNF6Rjz1QPJG2W9NoWiWU6rVp8jt	1426	1238	315	6301	12463	jxC4TiuftV8GvAu7inx3chDrNcvWsqE7gATutkGTgphSAakPkyH	9220	13024	13024	1618283520000	canonical
18310	3NKGPp7d2SwURujAWYgSFfS6AXVwmnf2A3DXV6YtLyB6DPXxJoDV	18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	1634	1085	315	6301	12463	jxrvors5HybESoS5PyDMEFZcD8Dyc4UJFqpvyJ2Bzy3eNhBbeme	9223	13031	13031	1618284780000	canonical
18308	3NL8Y3Drqf5PUMt72umq4M2CXcHD9UbpXry6gJHB5BJaXX28gAfx	18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	1403	824	315	6301	12463	jwxC3xyj3NiJ7YnyH5hQ4CLsocBmLrr2q9xeDrN6sV882wkGngv	9223	13031	13031	1618284780000	orphaned
18313	3NLSAvyq8vvSGugBoJLWMqmzuJ3RYPcQmgiJsGkXfQyuLAW62ASa	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	1541	1298	315	6301	12463	jwsvRwcx8MtmoWtN8XrBSfXAaYguT8rj2QfoEGS4oRZc1ov2FHh	9225	13033	13033	1618285140000	orphaned
18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	18314	3NL1xKVEZheGjFbCiTUf3VQJ7yJep14VJvcBUX3w5BZopNjdCPyd	1642	1001	315	6301	12463	jy3M1JcyEzpSWCE6i74sR39Mz2oU7saozjrLKwovKwFiu5Xesw8	9226	13035	13035	1618285500000	canonical
18321	3NL3RCnc3cHdSr4vHhEX325VetwACsC2v84ZjSY1iZuUgvVVSKCo	18319	3NLKjugQYnG4sdkTbET4kZHS6hG17j8M65kpMSVQy9qXq3A3MWeH	1671	1119	315	6301	12463	jx2bGUCVEJEKmLo78wFQ9SLciv61tgYK6Z8SXUNKdrYyKuW9Mgs	9228	13037	13037	1618285860000	orphaned
18325	3NKiukESxmFjMAFtN4nj6zLKt6MV1p6yxLrFkK6khTMAG56vGvim	18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	1440	1377	315	6301	12463	jxi6NAE8LMtP446av1ZQ7c5nfNaXDMrbm9ip3mD8odZpHwrF5pX	9231	13040	13040	1618286400000	canonical
18330	3NLDtJ2kV8xFEgpwK5LnF6yeTo7FKCGk6YH6Mknx5sgKym3VApDL	18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	1406	1393	315	6301	12463	jxhJejf1MJgVdnRYt4zufx83r2AXug91eEHNHvw1Qqnh5v8DAj7	9233	13044	13044	1618287120000	orphaned
18333	3NKLiPfDGjgRxkjR8gfN7d3zCmucy9PkC4XJeUVptwhFw67aTUrJ	18332	3NL8Q93d438Ye4nijwahjAvaCQYqxAzcTygkei2StEcW7kJwJdnq	1426	998	315	6301	12463	jxMGttWmwXmmFboJkJhA9f5eCkH4LS7cA5P9PNmkfBAAvM9urz9	9235	13047	13047	1618287660000	canonical
18336	3NK52DRJpdYyHGp1zwZnczvPwDGMN5qhz3UQN9qYrzCj1Xe4FtTY	18335	3NKkx6cGrT7VpZjrigacgkseEyw22yLqs62j1ksxuBnKkZ6eHESs	1407	1395	315	6301	12463	jxuRGzF8FPi9rp6yfCNP4iE93UcA4ftZo4A1YK9gWF69qJHiV5W	9238	13051	13051	1618288380000	canonical
18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	18336	3NK52DRJpdYyHGp1zwZnczvPwDGMN5qhz3UQN9qYrzCj1Xe4FtTY	1402	850	315	6301	12463	jx7GbEDVpCrYiU3UE69LpwkVNs7CVZJ8zYcNzn9TjD8EUmEnrHx	9239	13052	13052	1618288560000	canonical
18365	3NLkfFEv4d3LB4AuGiHcRhsm8dfPMY6tznqXbTH4BkqNPECVZsjm	18363	3NLW6mzQrBUonvRJnMfRZZCgb7oCEFiTmgHuR84QM1xz2fEkpsa4	1406	1393	316	6301	12463	jxDK6ZdKFHXJs17VJSAaNRLYa2PStwbaCfP58vob9UB1hdyvTr5	9255	13074	13074	1618292520000	canonical
18372	3NKd92PsnRGnTfATo43ZyGyQeQnB1UnhhYKAqSbmXEKGoE4xGana	18369	3NKbbwFcVeBKmyiLvjaa9WJ4FS4ZAqx3drF7pvE5sMD4KFNYznzp	298	311	316	6301	12463	jwtb86QNgNWZ62DLsxT3UdqJ1rz3WLUb4MfeMtEVszxwk7GNVFf	9258	13078	13078	1618293240000	orphaned
18375	3NLLb6qiE73VPDACS2GkSMuSWXrL2VJZ6KjJ75H7xEaZZU5eg5cd	18374	3NLQRCz4cKBNPEBo5uu8jWyUk8vyQpjUwwjhoqmf1cGEfRDtPmwN	632	1136	316	6301	12463	jy1ct5GnPEKMh6bbc2QuRKqQR3hrmW8Sr9TJKRJLFxeT53mW42U	9261	13081	13081	1618293780000	orphaned
18377	3NKJisvEV62kfqfnB5zJDhJBjoA1EkZQsiuNfFg9aLPwZ8b4AqfH	18376	3NLtNTZ6oVKKzniciRUEjFz65SfwftPAXTzN7fDah53431aaN5ZH	1553	776	316	6301	12463	jxjr4H4CnYXteuoBd4JhvXwRyq3gKDfRMXf7QQsHgJZZEmJrjBX	9262	13082	13082	1618293960000	canonical
18380	3NLuz4udmmM3zfsx956MphU5dt1dd6tKqKBp7TEESTzvF3ZteAY1	18378	3NL9Dobh5sgTMSRLKvSAvwNSkLN6MiFb9YeMB6HQsWu7ZzLCkKy9	1406	1393	316	6301	12463	jwHfizuazGLUn8PgptwtpPtuiGJso5CN6MjcxVrnvSPGsgMMmHP	9264	13085	13085	1618294500000	orphaned
18385	3NKKaQgotDnmhYX7vFWSeAZ4mvWvZqJiioPtKZL1b7weLKJ8s4oq	18383	3NLfY1fhegkFNHhPBHnig1xUz9U4Nc56bqMfkgZwmVq1Wq7FF8EP	1596	1237	317	6301	12463	jx8Vi4uo4c5jDMnQz6D9jHGsLJUqVpdnBXLAboNmLzRP1jVTbFj	9266	13088	13088	1618295040000	canonical
18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	1406	1393	317	6301	12463	jwEPokZMmgtTSV7SpEV9HPw64wEamqaVu7uS7DoLZTgmR6coj1y	9268	13091	13091	1618295580000	canonical
18390	3NLF7Fc2hcr34ashnjFsU6VDDX8CExXxDoMhg46wzVdgD4ikFqSt	18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	44	1325	317	6301	12463	jwGCkmsg1zwSfiTGJaieMuJc3VD8q9Rv1CsKRNT9PWiRs2gRd5u	9269	13092	13092	1618295760000	canonical
18397	3NKiVYCs2qwacc4RqEyfvUbw1Wi2MEA1fk57YHtcBkzQWrtE1PMq	18396	3NLtJr4H9aNN3tfQcc4K14HMadeuWDKWKdcmDEkr7aTXuZZFawYi	415	415	317	6301	12463	jwLu4K3EgMEFArV99GSzaU8jLh2J31pB6rBsoTjcsxu6T7RifD1	9273	13096	13096	1618296480000	canonical
18400	3NLkNBJKG2GW4NrsG2aVW63GqKKNMRjTzhTiK9KTBWB8wepmZngo	18398	3NLk6tahbJ9ucq1gp2U6SgXyrsrsKevHwUDXNfwW4cfQvP4sZiNG	1651	1175	317	6301	12463	jxsv9saWqkE2hieaKFYEqfCyAA5LDgvk8oBrqu8SERuuR8JTMYk	9275	13099	13099	1618297020000	canonical
18403	3NLmRMLN235pBiJhbJ77NQoU2rgReo7fwhJFaA8mTTW4x4Sztvbm	18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	1471	1260	317	6301	12463	jwZCyqF6QraoC9rPpgKZXmPSXDrafQ8whSPxokBCpWb1Y7SzDmw	9277	13101	13101	1618297380000	orphaned
18405	3NK7AAnC1ArfFiPQBBnNwC8unD86cbF3M3EJcNaWfhLviQt4BGcH	18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	1405	873	317	6301	12463	jy1uKn4ChbfF5mhSNkguZAqdYGGZPjLgyv8eoGKixQnaQvcrpxD	9278	13103	13103	1618297740000	canonical
18407	3NK6t1fARPhz2quTd3M3YWNZWXSfYJ6rnA2MoovA9CRwBCn5Y8c6	18405	3NK7AAnC1ArfFiPQBBnNwC8unD86cbF3M3EJcNaWfhLviQt4BGcH	1573	1072	317	6301	12463	jwBhNHCqX7Rbbdin2obsmRYUR75ymCqdAs2kFiZWNX2NoD8b4Xb	9279	13104	13104	1618297920000	canonical
18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	18409	3NLjnHPH2YorrWgaQ6SVvBixdv55n6at6wA1D9gmamhz64WHMNnq	1407	1395	317	6301	12463	jxwnp8GYvKuidxStKfEMThPTRddVoVKkzE8oXvdQfDis73rXJWQ	9282	13107	13107	1618298460000	canonical
18415	3NLK58snnqLwEVeXBtc2LzFjyfQ13GmBv1J3LjwfW9iHp8asEZ6u	18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	606	1049	317	6301	12463	jy1NxpkW3eRq6aMYQeGGLJNEBtLDYy5N8ezfCLiyMyfjQXdmNfj	9284	13111	13111	1618299180000	canonical
18417	3NL1mXfsiCey3Vh78rxQGA8aR2LY6Yx61czKtRC2eH4hayDCoXr2	18415	3NLK58snnqLwEVeXBtc2LzFjyfQ13GmBv1J3LjwfW9iHp8asEZ6u	1406	1393	317	6301	12463	jwtrjUfnDRsPPPJLPJDFQx2LTiCAYdkx7SkZ7Nvj9W7guHYhnYA	9285	13112	13112	1618299360000	canonical
21521	3NKjfNyShwG6TN17qdcQCyv1dacjDDU1Ez1KaH8kR4BvmMTXm9tz	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	1407	1395	393	12463	13732	jwRx176wTyVemimLA35g1MWMKRtrfqXgwJ1Lb1d2GiTFkM2CYrq	10797	15207	15207	1618676460000	orphaned
18381	3NLFJE7yzGM2qQMaLjMmScnEfQwyZuWgRQH6fYb9omjepwLT3o9p	18370	3NKX9cTRKHECTzDKXCTrWczBZELeW4zUrfuDfe3eyfDeNErfHTkn	1599	1161	314	6301	12463	jxWLmXskrUYnQ6FpGzmDyyjfZN6rBoEvi7mHpKb95XSCwZYpgyx	9187	13085	13085	1618294500000	orphaned
18309	3NL5VuuAZWBQexxi29pwXFDejHxJdYYgWRDowtY5L8YHGYDtFc1i	18307	3NKrkE214u523JbZAwtWy8Tg8CRUBZFXPGDaQQmYKd4MuRDFdTqD	149	1283	315	6301	12463	jwxfZuP5A2U5VdLtPCzhznonc9J8QmNALG2CiLi7QvkEhaPhoHr	9223	13031	13031	1618284780000	orphaned
18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	18310	3NKGPp7d2SwURujAWYgSFfS6AXVwmnf2A3DXV6YtLyB6DPXxJoDV	1602	1243	315	6301	12463	jw6duBcwW149aGj3pqMzahBHRkVgQVE4pCmgQ2fhSKq3ZUiAJPz	9224	13032	13032	1618284960000	canonical
18314	3NL1xKVEZheGjFbCiTUf3VQJ7yJep14VJvcBUX3w5BZopNjdCPyd	18311	3NLax1gzeeuPw6TZ9RnxTaXcMse2KFwWdYr8PL7GY6wtZcAvKocn	1654	1340	315	6301	12463	jwjyRFRhWVkY5W8kxVzx1LncGBpmWduqDzrG7qu46aXNyWbEBGM	9225	13033	13033	1618285140000	canonical
18319	3NLKjugQYnG4sdkTbET4kZHS6hG17j8M65kpMSVQy9qXq3A3MWeH	18317	3NKtyRKwfj1mPuQc7tvAEkb64HWdghUCf1pS3Fiic2mxAVVgXLnS	1651	1055	315	6301	12463	jxfAkzeH9hMdxS1NhqC835EP8WhQCZGEhGZ36NhC6zKLWk723K8	9227	13036	13036	1618285680000	canonical
18326	3NLxJdgQGv78Jk9EdK24ru2ykASHboYJGB4d68tULr7PiiypjKd5	18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	1440	1377	315	6301	12463	jy2kZUXPzHD5eKkpiV66faqtsfu2fniaARsSVHMXAv7TuaQmLFJ	9231	13040	13040	1618286400000	orphaned
18334	3NKU4sgrhAYnvyGL21cDPuQV3KUJSHCaxCihK6ZbrsqN4kLTrtQS	18333	3NKLiPfDGjgRxkjR8gfN7d3zCmucy9PkC4XJeUVptwhFw67aTUrJ	1403	824	315	6301	12463	jwfTKnVbgb1UXawfiyiYH7KL54CvMdxHLUH3z18CrLbHwjFa9dS	9236	13048	13048	1618287840000	canonical
18337	3NKkaG9krASvv2cZNPA6oFWGpDiuUsbZoVtksGkG4L5JyJtm6Kbq	18335	3NKkx6cGrT7VpZjrigacgkseEyw22yLqs62j1ksxuBnKkZ6eHESs	1581	778	315	6301	12463	jx4hBwH2v5PxYW1b2YG6xoY9frqQiAgPnqkAdtbnXZbYno85yqq	9238	13051	13051	1618288380000	orphaned
18340	3NKiETA7h3sKKByUPoUX7seejYDhLEsHxe8V1RsnBe87zGEngcCs	18338	3NKUsUr8ZjuCxzQxcMRqtTVQ7zY1a1qyNrCdguCPXKKomMjDnJb8	606	1049	315	6301	12463	jwMDeugWAvEeSZxDGB3wdBxVPhHuNMNMWfa9qP31QEeQzUFTWtr	9240	13053	13053	1618288740000	orphaned
18342	3NKNfqEqgF8QR7zE7ue3WTKCYkzXhwLzJVb1uGkjM8Ktks32J1p7	18339	3NLHx7Y3Ytzq1PajDhFyzVuo1sXGkgibaJT6Tbnkrz2N3rCmVm1k	1600	1126	315	6301	12463	jx4guwgVK1G1xBabDLUXZQvL4bVaJdgkt5P4QXxRMNXwhn3Biud	9241	13055	13055	1618289100000	canonical
18344	3NLTDovKuYqdhtaQdpiKu6AbDjTkJQ3LWVX3zqvZbtaQzv2rovLZ	18342	3NKNfqEqgF8QR7zE7ue3WTKCYkzXhwLzJVb1uGkjM8Ktks32J1p7	1483	84	316	6301	12463	jx5devpBrPbgn5hYhUcgaKyu6HzEzJbkkEPZrEPSmhGA3NbEbwk	9242	13056	13056	1618289280000	canonical
18343	3NKayRweYAr7HiFZ86RqxJbQY6pu6y39KCviSzkSdy2irJNeqBxw	18342	3NKNfqEqgF8QR7zE7ue3WTKCYkzXhwLzJVb1uGkjM8Ktks32J1p7	1483	84	316	6301	12463	jxawxA4WQQ6XgY8FHbQA238uaMtd2EovFf6SvcLN3VHCb19tNn6	9242	13056	13056	1618289280000	orphaned
18348	3NKrPGwtRCcfBvWXYXip3kkFRh7UYoimaGBGRoqnFMByrQjFK3tt	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1627	1385	316	6301	12463	jwc1j56895qXsoBjq2t3CeuPbYANizKeonzXNriqq6fVaSBr93J	9244	13060	13060	1618290000000	canonical
18346	3NKoehvQUQj3b8Kg6BfFSVsXUqC4YFy9s9iYbbKzBiLHZ8gntr9d	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1523	1195	316	6301	12463	jxtumarqidxe73dFUxpJCZUppmRSFzQ1re9A7xxcRxH2FeHswtd	9244	13060	13060	1618290000000	orphaned
18352	3NKc7TRzmdf1ot15uVk9hAmuB8giBsew2xGWuWWzco36BxKqFUBk	18351	3NLxwVegeUCkatcdDhAY8mPdpwfm3XQR2A7fvUSqNwgR4jXqQ3KE	1476	1245	316	6301	12463	jxtMxKy7vRCuQCvAJcKbPW3b9efFhhXgriYXceuDHCUtMDLWMTR	9247	13064	13064	1618290720000	canonical
18355	3NLkvhRbBV2XXRAE3oKnNTHtSAVyboADYSSwJBA2aQ6ocN3aDez4	18354	3NKaQg9AZJyNjukq2CFnyzCYHvYuhChtYFTxBrwUDQsT5isZL1hY	1425	184	316	6301	12463	jxXjiyE5XFNHpKpJtvZERDmLExwssBfA5XdUBEbcnrwPK8YCB24	9250	13067	13067	1618291260000	canonical
18356	3NKVKJK3RPKN28bTVzavkcXS5bj8vjghjoPj4n2KLmevsbTb8Jho	18354	3NKaQg9AZJyNjukq2CFnyzCYHvYuhChtYFTxBrwUDQsT5isZL1hY	152	1330	316	6301	12463	jwUPa7CnXf9PgPsdLsXGayWFTK2dTLkmJfGbF63XzYgHAoKUJVc	9250	13067	13067	1618291260000	orphaned
18359	3NKDivzBffr3hUCFSpkSTqqR8L2KN5vTDxdpjrM9daoTEz3w3F63	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1542	1304	316	6301	12463	jwkEbEJnhD6cRbiSgRQBTvcvfccjdhShR5ZwJLTpG7kRY1BE7MF	9253	13071	13071	1618291980000	canonical
18361	3NKRdpaooLTkRsmEd2fpRqHvksXZweYjAQsdU9SJMtXXFedgyN7h	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1448	1311	316	6301	12463	jw9NJ3k1vZDHy75ggeRD6x4yF4px7mNqA7Yf8Di2ExiLbQc87gx	9253	13071	13071	1618291980000	orphaned
18363	3NLW6mzQrBUonvRJnMfRZZCgb7oCEFiTmgHuR84QM1xz2fEkpsa4	18359	3NKDivzBffr3hUCFSpkSTqqR8L2KN5vTDxdpjrM9daoTEz3w3F63	298	1182	316	6301	12463	jwRJTgUjEzYvsaerJ6EUhRApCNbNk3qDxMWdQrdcfFd8uwinTyU	9254	13072	13072	1618292160000	canonical
18366	3NKcqWY4ZmvA9n7aRx4uQpB3waWrgyEuKYJ6FKvFasXteZqVMycs	18365	3NLkfFEv4d3LB4AuGiHcRhsm8dfPMY6tznqXbTH4BkqNPECVZsjm	1577	961	316	6301	12463	jwxZtvk2dgrwkF816t4Tz4yTDSLXRpauWxs5wsN9mrmXiEqnWpu	9256	13075	13075	1618292700000	canonical
18373	3NLiNNDxnphGoP9iDqfaF2Gs38VSjx6LQLUajSHbg9m8XczA4BSj	18371	3NLF6hzfF1Q6nougErcUviTSm6zFiMBuDMaGCpNKzTiCfcT4SAuz	1406	1393	316	6301	12463	jx3uFsB1pLXWn9fCruWhELRqeypF53qoHnUqRnFLVPBJDPpyZBQ	9259	13079	13079	1618293420000	canonical
18378	3NL9Dobh5sgTMSRLKvSAvwNSkLN6MiFb9YeMB6HQsWu7ZzLCkKy9	18377	3NKJisvEV62kfqfnB5zJDhJBjoA1EkZQsiuNfFg9aLPwZ8b4AqfH	1406	1393	316	6301	12463	jwVnJdsfLtjvHAkzKUjW51A4jgkZJA1ahVVMeCK6SRTiRTyw9gw	9263	13083	13083	1618294140000	canonical
18383	3NLfY1fhegkFNHhPBHnig1xUz9U4Nc56bqMfkgZwmVq1Wq7FF8EP	18382	3NKmC4dRzo2y6vr1ukqbfHCx2YZzpdwm6oMxbcsFPCrRid9xU5jf	1508	1387	317	6301	12463	jwi2XSo57mhKmYgvvNQg7tWEvqyWuzmatQwaULdfMrydcaCGQHy	9265	13087	13087	1618294860000	canonical
18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	18385	3NKKaQgotDnmhYX7vFWSeAZ4mvWvZqJiioPtKZL1b7weLKJ8s4oq	1406	1393	317	6301	12463	jx2sLbWg6CmQqCgEBqCVraxJmXu89HQTZ4493Jk9n4j7ab62ozA	9267	13090	13090	1618295400000	canonical
18389	3NLhqCHNkK8tV9bGPatGD4BCvvhk4TYgPSEBfKkNxTx83EQFUvNr	18386	3NLmYvtcUs6f27rWgGHKE3beVx7Pt9UCtcKTbCTLJfnoHM5S1X1K	1440	1251	317	6301	12463	jx3ATyrQCq1gENCyTBJhFFvAmertbJZRq8dN3Njg7AJtAUrNPK2	9268	13091	13091	1618295580000	orphaned
18391	3NLoEuYMQXJSunYRgTNH4L1qngMVMyV6o6EBbZEQ2C6dWwZEEDy2	18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	1407	1395	317	6301	12463	jxjweq9rG8H19pQdZ3rHzgssLknzRteuLEs7eHd2fdzBQRrbYQY	9269	13092	13092	1618295760000	orphaned
18393	3NL747zhAWNAEK7wpiRU1bSz8MTKyU1HtscqbuysTZJe1tU6viXo	18390	3NLF7Fc2hcr34ashnjFsU6VDDX8CExXxDoMhg46wzVdgD4ikFqSt	1542	1058	317	6301	12463	jwnyA69EqHUtAEnoLZDi8E9TFxaqJh27tL5Umw34WewzfQdJx23	9270	13093	13093	1618295940000	canonical
18395	3NLBVdpbTqztbux2aaD2mPyJ7rhBWk3QK1yPR7DT31r4SDZsQxvb	18393	3NL747zhAWNAEK7wpiRU1bSz8MTKyU1HtscqbuysTZJe1tU6viXo	1451	1046	317	6301	12463	jxxBPb82roteGPiCmfk6wZ86jpGRbMQQyeBCmrFE1y8WGKYE15Z	9271	13094	13094	1618296120000	canonical
21524	3NKtuUk3bwzJekrVDdBuFJxnkoUCvjjCUboQGGZh7PjqrMnTEktk	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	576	1355	393	12463	13734	jwcxEShU4aXuzokHcKznwPi2J1zwPB1UdMeskbnoCE5ndkR7fJY	10797	15207	15207	1618676460000	orphaned
18435	3NLenX4YgydNwCaJPhBPyFhV4cQFYTEtS9WP8789C9Df3E13hFrV	18153	3NKokvEp5kXMEYvDk3sYx8sf222BrBoAHGogRtzXiprMfKpxmyob	1419	814	311	6301	12463	jwi8pY5fBxTPHg1Ggq9oPZWTA7JSJWcQDaGT6mRufaizufAfd3z	9119	13121	13121	1618300980000	orphaned
18461	3NKvakwiXgoV2ExuhEhJcpUP5GTT3CQPvpaCKLjqrK5tRXmoVuxf	18223	3NLXdE19xMbnyE3DcZEpYNSpB59xEVgyYnrkPUf7da7xsSrxcPhe	1560	1045	310	6301	12463	jwT4syKDsUveN55VJBgJ5kp1x5K6nYugKVooidiM6gMzXYFByUw	9130	13131	13131	1618302780000	orphaned
18379	3NKfMQgNE71K8FMVSzPbjBNpgZXgsk91cJZzKhgf6jCnJxJ4F46N	18355	3NLkvhRbBV2XXRAE3oKnNTHtSAVyboADYSSwJBA2aQ6ocN3aDez4	1633	1264	316	6301	12463	jxjNqWCUHApEJwwEYXbg8Mqz6KaDrLh2VK73CQUkFWEg6qaYnvr	9251	13083	13083	1618294140000	orphaned
18362	3NLf5DwkNzyXkzKMSNoCUaRzdEsaDuej34ApSz5e5td7CJpjjgj9	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1448	1311	316	6301	12463	jxaWgYEqzPGt7BcqdryQV7BgFTWqmAR1bQGSv2RnbnzcR5obfQD	9253	13071	13071	1618291980000	orphaned
18364	3NKzgbui7Ea9hQguzekHQFtK1ifkN1AjJ4LQ97EkS3sx8ug8GMAC	18359	3NKDivzBffr3hUCFSpkSTqqR8L2KN5vTDxdpjrM9daoTEz3w3F63	1637	816	316	6301	12463	jxqnH2yQqKpfWSrcpgzxm85u1NGk1tABWUvGeTbMVeC6ziYsBvh	9254	13072	13072	1618292160000	orphaned
18369	3NKbbwFcVeBKmyiLvjaa9WJ4FS4ZAqx3drF7pvE5sMD4KFNYznzp	18366	3NKcqWY4ZmvA9n7aRx4uQpB3waWrgyEuKYJ6FKvFasXteZqVMycs	532	1303	316	6301	12463	jxwD4CFdJWtiDtSTDorv1RbSkMfo6kjcNnh5vwWiywEEudGF1cy	9257	13077	13077	1618293060000	canonical
18374	3NLQRCz4cKBNPEBo5uu8jWyUk8vyQpjUwwjhoqmf1cGEfRDtPmwN	18373	3NLiNNDxnphGoP9iDqfaF2Gs38VSjx6LQLUajSHbg9m8XczA4BSj	1406	1393	316	6301	12463	jwN67DpMvqK9QUdM9waQNLWoZm8su1Er27KTue7F6ucKizhzvqk	9260	13080	13080	1618293600000	canonical
18382	3NKmC4dRzo2y6vr1ukqbfHCx2YZzpdwm6oMxbcsFPCrRid9xU5jf	18378	3NL9Dobh5sgTMSRLKvSAvwNSkLN6MiFb9YeMB6HQsWu7ZzLCkKy9	1599	1161	316	6301	12463	jwTTH25N7AsMmoyBThX5wL6EHTcz7gfdCSwmsm9x9tXERJMLeN2	9264	13085	13085	1618294500000	canonical
18418	3NKs4wNXrFxpiYnppXSZdkLByq9zErHbvQaDPSouMzzCyJSVgTDT	18391	3NLoEuYMQXJSunYRgTNH4L1qngMVMyV6o6EBbZEQ2C6dWwZEEDy2	1675	976	317	6301	12463	jx582NUPvp67nrKPWQ4SdqmhNZNhQbwh6zh1QY7p5ePVDYzdfTH	9270	13113	13113	1618299540000	orphaned
18398	3NLk6tahbJ9ucq1gp2U6SgXyrsrsKevHwUDXNfwW4cfQvP4sZiNG	18397	3NKiVYCs2qwacc4RqEyfvUbw1Wi2MEA1fk57YHtcBkzQWrtE1PMq	1471	1260	317	6301	12463	jxN7KmE2TXyK1S5Pq1yFWAhqDyodWaqqKhCFfCH7bVRWnorhE61	9274	13097	13097	1618296660000	canonical
18427	3NLLG1dvgjzXp2VetZVaG6wkasiu1pTxiGATKA7hLdueFaTxqQ2j	18399	3NK3moHwqavT8WfPyAuRkGizURgEwgVhLUdT2B8yZE4kuC5LuaT6	563	1359	317	6301	12463	jxEHGwzC3X88AeKp9emP61jURQjZR83maurw9tkB1sfmzSQnFLo	9276	13118	13118	1618300440000	orphaned
18402	3NLQKSBAoiTUsqAcaiGuiuNc4QVryAsvQoiRKRHfvCSsAGua2GCz	18401	3NKcBXhe1ri2eGHhXFBMjTGXXGj8MCaYGK7Qnz2Y3KScRg7D12xW	1406	1393	317	6301	12463	jwrohst3fpqUuCz2LW4Wj2Agb7fJN8gCMpUkHDYeeUv4mMwVy6i	9277	13101	13101	1618297380000	orphaned
18406	3NL3ub3wb2o66zipoZz6sjcsSgBnTym4ycdagdjkLFZVxFwXJft8	18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	1406	1393	317	6301	12463	jwGQrjW6yk7CTUNbJRuCUF2rAp4ky46X6xHNW4CCvRndnMijoDe	9278	13103	13103	1618297740000	orphaned
18408	3NLidNYydWeihP8ZVBwbLqTnhhXb5pPuqiYoHPEXYNreTJcz6ZTy	18407	3NK6t1fARPhz2quTd3M3YWNZWXSfYJ6rnA2MoovA9CRwBCn5Y8c6	1489	1134	317	6301	12463	jwJj29eNyJw4cTNHr7cyuvWkEApVWGkXSKmJyBQa6PwdMdVGhBB	9280	13105	13105	1618298100000	canonical
18409	3NLjnHPH2YorrWgaQ6SVvBixdv55n6at6wA1D9gmamhz64WHMNnq	18408	3NLidNYydWeihP8ZVBwbLqTnhhXb5pPuqiYoHPEXYNreTJcz6ZTy	1440	1377	317	6301	12463	jwn2cL4AEuydNM3oFKppAiQZeCCeZyMHfQjYMitf6vuwFjJayZi	9281	13106	13106	1618298280000	canonical
18412	3NKfUp9fcfqQh7Uzj6q32GVycABFUrdEhon44q1mKc2mwmv4XNvC	18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	1448	1185	317	6301	12463	jwvZMjtNhX4oSCHFoadJZ3TgdLisLpWrteXuoYGzSvj4EmyYXNR	9283	13108	13108	1618298640000	orphaned
18419	3NKZhVCBeGPCe61JE1kfHFimD7VPDDPhzq3Rd734PbCP5BPnj98k	18417	3NL1mXfsiCey3Vh78rxQGA8aR2LY6Yx61czKtRC2eH4hayDCoXr2	576	1355	317	6301	12463	jxZ8XRbZ3dQtvEeeFR8kqRtCGag3E4g7njHeWdyc9P3xztaPKUW	9286	13113	13113	1618299540000	orphaned
18421	3NKEkPwTZ3vhbHHkZCnP3Jvrxy6pQH5w2iVDtMFkVDThrYAhWE1v	18420	3NLUsHDuxyopLoEutN4VuXrqByuoMHPWfpMWXwgD4A16YWjxTpxh	1529	1316	317	6301	12463	jx3NJqaHKkSicQXB4DMKLdkh2QEMcYnhQs3vvQ26CCRfnDPRHVK	9287	13114	13114	1618299720000	canonical
18424	3NKT7tHLyt3WXFiVeevuoj76VUcg1TUxjx7DSuDa7yjWVdUHNqth	18421	3NKEkPwTZ3vhbHHkZCnP3Jvrxy6pQH5w2iVDtMFkVDThrYAhWE1v	1477	984	317	6301	12463	jxxse8pfUdGFF3UuqXSbtLgCT4KjDMc5MycLxCvwBQRSisAdQw6	9288	13115	13115	1618299900000	orphaned
18426	3NKTn8sTjTN2aHAMH4cCVbEUchPCP7AbxsFZ5FHcT1tWs2U6BQfq	18425	3NKpF8HxByQiHnrUjpPpPtjRW12mTqgsq6bkKJa8haruXZ5vfWiT	1406	1393	318	6301	12463	jweoQ18ASFpteTMQQmEwqkwkDdn1ZcTKb8DekwxE7yU6tLu7iB6	9290	13117	13117	1618300260000	canonical
18428	3NKmLCFvhKKQHH9g3iGogsHGA6NKGgpH3WVshR5L3ovuofpM1xkt	18426	3NKTn8sTjTN2aHAMH4cCVbEUchPCP7AbxsFZ5FHcT1tWs2U6BQfq	563	1359	318	6301	12463	jxCdX7JTV1DYTBzvN6gRKxKsXTDv1BNdN6wv6u6gGiJtBbswH9p	9291	13118	13118	1618300440000	canonical
18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1419	814	318	6301	12463	jxKzzHdZVMfSaPxaExQqyfXVa771Lf3MCQ4SFNUdVStRihbYQK9	9293	13121	13121	1618300980000	canonical
18431	3NLpgCt7mroPDaAU4TKZq3kKnyHLxbFngneZN1XFZfqTthfpCB75	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1403	786	318	6301	12463	jwqMEfWS2e1AQzrqXacj83QGyiJC7wW9TGAVdR7SAUDmUioNX8w	9293	13121	13121	1618300980000	orphaned
18432	3NKoehQGQEdTStyoGnxhYssPZiJgWPsp44XbNRAnLbVia589ru6G	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1549	1236	318	6301	12463	jxR8LE3MGjsLu2J51xErQVD4fyTho937AQxQT51ExNL4jhYEdCX	9293	13121	13121	1618300980000	orphaned
18445	3NKDHmD4RJZ7i3L28gNCrGhmTPg159wYzw6hEgarbX2Wg187mSUR	18444	3NKPAHUSF9RXjGdnTysniQpnJYYUzWVhFxtAMATiPpCGMcgkk3FR	1397	828	318	6301	12463	jxH52utXCAG4PVHYjmhrmVgLYV366dDXVYqr43J9Q89UWsCwtxh	9298	13127	13127	1618302060000	orphaned
18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	1406	1393	318	6301	12463	jxV9CYjPvh3Y92medr4w1jQUuVhcHNuoU9ap3wM4SCpKW2i3wnB	9299	13128	13128	1618302240000	canonical
18449	3NL28wUZF5tEYkXuDT7VoRtbmvW2FcwMTeYgiPHJBZsftJ5Ldr7D	18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	1651	1055	318	6301	12463	jwjUDyCAqeyjmhDosDUR5qUHhHWa4M9vQTV2Y9B2XUfGLcKnRZ1	9299	13128	13128	1618302240000	orphaned
18456	3NL24BHS8yt7hdSMNHtz3KN5PcHDsto7oJwinxsCzyn4G513Uxrb	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1541	1172	318	6301	12463	jxPk9CHdBu3AR61LUrZ9mh915AnMv8LJxnvooSVW6tvPc8ax9wQ	9302	13131	13131	1618302780000	orphaned
18458	3NLYGDWjWSkJqhpqjo789xYrzG8rtyHgEBNcbLDmryHhBge96npG	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1407	1395	318	6301	12463	jwUc5skS9kSU11noqv2NnCfrWB2AT3B6p6F9yXBLikiKyogwqQ9	9302	13131	13131	1618302780000	orphaned
21535	3NLMrVbAtUtm2MATTmVNwBesci1rRBBR7oagvQrNrMknLzEYamAm	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1406	1393	394	12463	13741	jxHpbHLiLzyPs7WVemijxKxhaLrGnrk7am8vkpBHTjuKJ165NvW	10801	15212	15212	1618677360000	orphaned
18500	3NLYCpRs8GxEG6uijAsdvPmeM2vKZCi45fDBGDVa7MKvPCGQThPC	18227	3NKHVam4LGvusWU4yr2VFhJAxLQRgr236yR3mY1MGpJhSpNf7sgm	1503	1277	312	6301	12463	jwQrTLSif76u9NsLap6U5Jrjmx6weYKdJXsCCn7raZHwWmsW7Xk	9153	13156	13156	1618307280000	orphaned
18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	1448	1185	317	6301	12463	jwLPFeyr9uB7X8Dn8ZAt9L9WnDSA1R3fe2uLUUZ32EQsUZTf7oD	9283	13108	13108	1618298640000	canonical
18411	3NLGbYmiXQVLXvvKn6tXe7hCUnanPvrT1RydgBQqbBaqPiKCRE8B	18410	3NKkXEVZrcpHDoqxJddZMNWr67mAmhGTNyjZE1xvqFsZ4brSjNva	1406	1393	317	6301	12463	jxoAXWbLc8QNA1pN6YbTpG2cfSZZpP1GuEGcQa446W317JUL8iS	9283	13108	13108	1618298640000	orphaned
18414	3NKWDBxQiHcgfftn2gNK21Abr1BHLXoCisM6QXDPPAJdnYcqWUjx	18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	1403	824	317	6301	12463	jxfBCFcJSqtGh535EAFCCihu1WHHq1CgTKH6qwd2YgECARoJcni	9284	13111	13111	1618299180000	orphaned
18423	3NLN2vud2vmSbj5CB3yk961mmcZx9N4BVj1VirmUmruTe4punZ3A	18421	3NKEkPwTZ3vhbHHkZCnP3Jvrxy6pQH5w2iVDtMFkVDThrYAhWE1v	1477	984	317	6301	12463	jxxse8pfUdGFF3UuqXSbtLgCT4KjDMc5MycLxCvwBQRSisAdQw6	9288	13115	13115	1618299900000	canonical
18425	3NKpF8HxByQiHnrUjpPpPtjRW12mTqgsq6bkKJa8haruXZ5vfWiT	18423	3NLN2vud2vmSbj5CB3yk961mmcZx9N4BVj1VirmUmruTe4punZ3A	1403	824	318	6301	12463	jwuS7iqQ8cf6m4rTKBthFa8VxQJ116xhM1gT23EGrgZaXY7K3uM	9289	13116	13116	1618300080000	canonical
18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	18428	3NKmLCFvhKKQHH9g3iGogsHGA6NKGgpH3WVshR5L3ovuofpM1xkt	1407	1395	318	6301	12463	jxyvxCn7n9F3uezYdnqsDfDWnpQsFrsSNjxs9AN8z3b7oqkdMih	9292	13119	13119	1618300620000	canonical
18433	3NLH2eWprHTutKsjbjs5oyvvJfujDsLtuRKs5Gfe559QcsZhoUzd	18430	3NLrjNRjXgneLNi8LceuhPhcXMhyL9SoT9PFCRierXDw8Fauev1P	1407	1395	318	6301	12463	jxTp7skUcogXp85FU8sVTW4cZqA8JEKQcLpvxS1CSnJHPnFQLmN	9293	13121	13121	1618300980000	orphaned
18436	3NKDbB9jqBuNa87tYH3sEhw2u7GiJ5SnHRBhG1aUBmGTPsHMcE9P	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1489	1134	318	6301	12463	jxcRrsjnGSxQnUJV48NebyL73uLQPb9uxYAiCYt8SHPEg9LB4CE	9294	13122	13122	1618301160000	canonical
18438	3NK8p3AqUguKjvRWuRYHHbSTJPnmVk34w4RXQtrs5nKNhoKMfyXc	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1476	1125	318	6301	12463	jwSKZRaW7whUhqfpkoGMA96Z3unyHtW8Cfy4Tm2cGc1csQ9E9k6	9294	13122	13122	1618301160000	orphaned
18443	3NLFgKgP4n3fA8gJxeytGnVXs76QJbMLfXcxJobwXYVDp1p1bfXE	18441	3NKfJJMAPByKDenpwHPoTFPKZLnYtbaZxAThixsXnByxKVEnn6DU	1548	387	318	6301	12463	jxUcw94WYZsBV2wn1GHhquk9sstQVS21QGzF7ZpXNpvvkZf5T6H	9296	13125	13125	1618301700000	canonical
18450	3NKxbzfR6deEYBtT4bjuSGhkduGrW3HPxnFdgaN5y4Cm68tdVVyB	18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	684	1106	318	6301	12463	jwKcbkwAZRADfvQABDgL6Lb31KtxHJrhBfGBmojDkrw9TJUmY2B	9300	13129	13129	1618302420000	orphaned
18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	18452	3NKZPXSz6vquKRcFxWazyo5USkzAsnfqQRkiLgTdqKw5XePXZVHM	1405	849	318	6301	12463	jwG8Lh2pXK9w3LQPqMQVpvZRE3Q9c57Ur17rUyeYAy9M4XatJVW	9301	13130	13130	1618302600000	canonical
18464	3NLRye1kMRvJPdn5UCNNtXsvLVPCQG54gQCU7NmqreAsVgTdAreU	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	632	1136	318	6301	12463	jxf5nmTa5T93mFLbdiPuysdrMpseNWCaPBgWVrdEdR862mY8p4Q	9304	13133	13133	1618303140000	canonical
18466	3NKsVsuryixvNfq32KyCVWVAukkQgLPgGEUDcoFi6ER5N2YxathH	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	1637	816	318	6301	12463	jwvEEo4mrAAx8wnPCxNrDxQN2CnWNnBTH3b4k8RZ2rMyWKTHYjR	9304	13133	13133	1618303140000	orphaned
18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1631	794	318	6301	12463	jxSSmu6MnSdczZHmjHSQ2Qwd89CGeD4P9z81YBbSMqCyo1YMbLt	9307	13139	13139	1618304220000	orphaned
18483	3NL6wbBSNrVjiFi8jYyzX7Ewc9JAsWaeX1NzQE1RNjSysPLbH5wE	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1527	1293	318	6301	12463	jweeeJdbV85u5x11C2S6mk8SVyHp1PW9s5NdDzU3kp1WCk1oA3p	9308	13141	13141	1618304580000	canonical
18476	3NLEPKntrqP4eA89W4uUarSkWVDamQsM8mPG6kgpnegWF5Xca7Ja	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1627	1259	318	6301	12463	jxPA4f5mqEs7TY6D8o2NBy7ieyLynP4Qo6LMM7gKpv8puu1qZ68	9308	13141	13141	1618304580000	orphaned
18480	3NKdeTHKu44w3deqqzoz57MEQwPsm92kYUkvQX14LhSq93MwwTbH	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	532	937	318	6301	12463	jwJgQTyeekhd7maFdDhnYnTgonc5PyejJwrXV2B63pB2dWBi3BV	9308	13141	13141	1618304580000	orphaned
18488	3NKbrDc2cExcJGHSwCh5BsxvD9XufvFEXytT6HMQ9MYbZanixVN3	18485	3NKEYKzvqoaNTLFN2if98t3orHbtVCjZCc3N676dakiBSEV8JF3x	1650	1129	319	6301	12463	jwG4c8SNn6SinhFzSiDAx71AdtBDomNEdu5MesvsQXHSeQjVQzM	9311	13148	13148	1618305840000	canonical
18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	18490	3NKu39kWCLRuMtPPf4YD2ATznfH2oTFo2WrobiFyN13fgcj8cY4q	1656	1217	319	6301	12463	jx1gxJvYi8SJqoc6szcu3yqc4vcviQfvhDHH3iT7SvX1FMohvzB	9314	13151	13151	1618306380000	canonical
18502	3NK69y3UqMSri6Nh9hJHgjHqLqhpcY9Fe8sio9nabt1MM8D4XEfL	18499	3NLafgVVqpskgDPn2RfU9SwifoPXVZQsGzRucRmoyn6NTg4r1zc1	1406	1393	319	6301	12463	jxKjQV189ekY17cyLAhHxWPrw38adGp2UrJ3Aidubp4xRN12BxM	9319	13157	13157	1618307460000	orphaned
18505	3NK3yzwCxHRxzyakGXCb6Vsnif2M6Y82RAA586YzMzarnk7Jr34e	18503	3NLWEKmT7uqJzqaFWRyYkAUXWN7WVbuP1LoFYmN6h51CXKXcsCyH	42	995	319	6301	12463	jwdnT9EueTsZwDqPbVEy39yixek7gNPdNznLA3cPvKpF85KuxPu	9321	13159	13159	1618307820000	orphaned
18509	3NLs67KcWvrRj3bWRFAMbUqDvCUVbnJBN6soH7fcjQy4kxuJ2Pa7	18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	369	946	319	6301	12463	jwG3gsCTHZNoR98GgrwL7jdQ2ARH5HVKFVwCwkTnj6g2HZLG2P3	9323	13162	13162	1618308360000	orphaned
18516	3NKx5KPPMnUp7J3kMxfLrBQ5BWFyJCQozwHpwxN19Q7xH3PP9qCc	18515	3NLUQQpCuixLgGFKscG1bU5ZzwBDkPrVuFZXJ6FHPNPiquYNnX33	1618	527	319	6301	12463	jxQaKY4w8bZjNx2j7XXhP7u4mWEcY1ii54WNj9NSJBnqyyGJ3CB	9326	13166	13166	1618309080000	canonical
18519	3NKbyJ2dzNK8DQGCNbNLnpxSoQssfCJberWFTQEprKtGNwTf2Heg	18516	3NKx5KPPMnUp7J3kMxfLrBQ5BWFyJCQozwHpwxN19Q7xH3PP9qCc	1675	1096	319	6301	12463	jwrqVKptPtk9fudLXJGyjYYartjHieT7fNKBBU1zBLoZYm8edtF	9327	13167	13167	1618309260000	orphaned
18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	18522	3NLu3Rf2sN6nM2gVz3VxiMTBhyHT9oV6ZRvJ9eaYbgx3HFRgmoQe	1637	816	320	6301	12463	jwuBPomqZ9SnC8VL78EiRWTkHanmznxc5nJKJZCQMqscmxrNZy2	9330	13170	13170	1618309800000	canonical
18528	3NLydiqWHaTMzcvn7dDxjxdiL9kHGAWLjUAwSUTPoWVATQtMiTvM	18527	3NKeUEjo9pxR9Jbee8THi3SkNFW79LPd7YAh98MHqy73R9FyP189	1637	816	320	6301	12463	jxHZR1gNR7onm51BQZkfezd64q3CR8XoyAh8LbBDJZEjKEAGjux	9333	13173	13173	1618310340000	canonical
18531	3NK3jkTxuaRpFJfwairSs3mwmPA3Xy8RB45bJ7tNFWPJznhiAUPj	18530	3NL6qKXe2rbUAtSiAU5N2vjjuUHWypHvXF6w3yQSSLYPE4mKPwgJ	1405	851	320	6301	12463	jw6qwTGRKRrCKcX8n1yUHmCCkFoeTLdpHKFThqcs3vUnGg71r79	9336	13177	13177	1618311060000	canonical
22133	3NKu2rsZqYK4A921xGAASZjScaoJQSic2zjEhkntH3ZmjyMDjNYn	21872	3NL6v43YrYUNiNkRwZB7Qwc3rzyndcEWWQJeCHTUxhbksMdSpLjg	1634	1205	394	12463	14266	jxyaGoUNjq9jaeDKzT6hfWNnpFzPUUXpMUBW2ezQYKNXkNwyVmv	10802	15586	15586	1618744680000	orphaned
22460	3NLTPj5uCNAY5wxC2btdNradgBYNGgkWi43JRa3vTFYbTRo2LJ99	22459	3NLHMZuNuFPNAoNm4a1Zgis97ecNH4RU4kpeQ1rs5u2z7C3sNDi4	1403	824	416	12463	14566	jwBpnQVaGtHZfu5UwyyasavgYix3LbYkfybrP9v4TrgQaSW1DpA	11239	15818	15818	1618786440000	orphaned
22604	3NKTGd8qARQNkG6NSRA7z4xh7RDeCbig8bPGUZauPPeC9pnDC6ji	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	1405	881	421	12463	14696	jxNN8sY7V98v1jDJqXSMCpCQ7PajmYenbNJLtPuTckFjA9dVRa5	11309	15922	15922	1618805160000	orphaned
23229	3NKRyJpdyMvxwAuSFsDZvJXErew2QLtnKJXq98NjQcnnjuEB1fii	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	1547	1378	421	12463	15250	jxBh3zhz6hhjdBGywy9hyUFRqjr6fgqDe1gKqrV6XPRB4pjE9Ae	11309	16319	16319	1618876663888	orphaned
18514	3NLHG1qKjojdVvR4oppqDw4PkazPDMrpNfrYbHfnRuJC8CkcL44U	18418	3NKs4wNXrFxpiYnppXSZdkLByq9zErHbvQaDPSouMzzCyJSVgTDT	1675	1342	317	6301	12463	jw9SKbcDecGWQexy2VceLtCNutLNE3YafuNy7rsUyGxAT46yz3D	9271	13164	13164	1618308720000	orphaned
18517	3NKN7jMR45hwWyc2iFny67XLe1x99CMzaeFkf5q9yMSan3fPa9Lw	18514	3NLHG1qKjojdVvR4oppqDw4PkazPDMrpNfrYbHfnRuJC8CkcL44U	1675	1096	317	6301	12463	jxHP4bd8W2BHLpsqDCDhGUmsqaYhS38aDhS4AkQuCSJZH8EnhYh	9272	13167	13167	1618309260000	orphaned
18429	3NKE7tuybG9iVsQPmQwUpyyXR5aaC6ZMZyzC9f9fQPCrfHbXVmXT	18428	3NKmLCFvhKKQHH9g3iGogsHGA6NKGgpH3WVshR5L3ovuofpM1xkt	1460	1324	318	6301	12463	jxWS1i7UqANob1fbs3j8oA2j9xoLaY4C1uAkQraeTPNVcYby9Wm	9292	13119	13119	1618300620000	orphaned
18439	3NLbapZrWThtt3br8cUoVhMhiLghv5DMs9f7kqedNTtJV5qbY8rE	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1489	1134	318	6301	12463	jwJ1HNTn4HaHdrCX7hW9wtcfsXD7CrzQ7NWmkbvr1s5y1u9HnJ9	9294	13122	13122	1618301160000	orphaned
18442	3NKLNE5AJs5pNie1Zn9wc6w8ELJM2JypBPZmJfXqV9NqBxDkwWs1	18441	3NKfJJMAPByKDenpwHPoTFPKZLnYtbaZxAThixsXnByxKVEnn6DU	1460	576	318	6301	12463	jwnXd9P8xmFGaafPc8wLbDGQB7pQiLzs7g4SZzrmPXhSPpcMP7W	9296	13125	13125	1618301700000	orphaned
18444	3NKPAHUSF9RXjGdnTysniQpnJYYUzWVhFxtAMATiPpCGMcgkk3FR	18443	3NLFgKgP4n3fA8gJxeytGnVXs76QJbMLfXcxJobwXYVDp1p1bfXE	1407	1395	318	6301	12463	jxeoft7VaDRHSqWv4qsLpHCwzTrHxJVuqWVUiVURKLsm1SzLibQ	9297	13126	13126	1618301880000	canonical
18452	3NKZPXSz6vquKRcFxWazyo5USkzAsnfqQRkiLgTdqKw5XePXZVHM	18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	1627	1139	318	6301	12463	jxUSpCj3mckCc8LMmQkNSreNLKwu53FoFLyFFUXPZ1d3qYMQmzr	9300	13129	13129	1618302420000	canonical
18457	3NLTSBHGrk87GXHKR2BnQ3preRBLc5f77kfeBdSRfkfvU4yhs5jW	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1560	1045	318	6301	12463	jwmBJVNTnKmhjXECD8mr2n2PmyWLqK4yAmNb22NZi9xK5LE4g9H	9302	13131	13131	1618302780000	canonical
18465	3NKgPaLKTCKTN3ghA3BQdQV5xTn3vm9uuPDrbratTCbA5qNnBXa1	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	1447	1099	318	6301	12463	jxNDMTdX3Pt1GyBdGWPX8m8uMAQ4c2nvQ7bVUL6gaHheJ8XppJ2	9304	13133	13133	1618303140000	orphaned
18468	3NLdakT9c6BHwNYHQMN94D2qhmr5uCpXrKBfZ9Z2N7FTh3ztmBsM	18464	3NLRye1kMRvJPdn5UCNNtXsvLVPCQG54gQCU7NmqreAsVgTdAreU	1627	1259	318	6301	12463	jxK8YMbQTvG6j3Xa7mkYvoBXh46sjH7hYmiex12v871P5iJ3dk4	9305	13135	13135	1618303500000	orphaned
18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	18467	3NLjeSik5aD5JT35dd1XqenE5DWYpT5JoseGEWhFSPgZEXrbTKfg	1649	1017	318	6301	12463	jxhr1kRXaw6fDFonVXkoTXw1Z13n6KByYhGVK6V5tQxu6XEwASC	9306	13138	13138	1618304040000	canonical
18471	3NLt9wzWdFm5YQVM3zUVt2w3DFyV8vnCHkieRjsv7RRvTXwuD3p9	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1474	1329	318	6301	12463	jwriSfYSRwTjEeRN1ymRxbTrq3hBqnhF8iSiXPMnxSZPbtcmMVf	9307	13139	13139	1618304220000	orphaned
18474	3NKJKBZZdQFE7iTD3kjRezqdwsDWP7bkEb46bXPbJVNVJW1Q1v9d	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1649	1383	318	6301	12463	jwQ8nT6U6e2PQNsF1EAKtyS7sh1Q3qCdPQ5j9uhaZK6nHe5kNmm	9308	13141	13141	1618304580000	orphaned
18477	3NKaxTN1ZytHHccVxvdBZVHpxWYce2xEUw1CkU5gKpsCLpA8hc29	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	1649	1383	318	6301	12463	jxKck7X9s49yMiecGLcq9ULeNFe8ZU2Hw5FFncvAepxFJkxMxCp	9308	13141	13141	1618304580000	orphaned
18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	18483	3NL6wbBSNrVjiFi8jYyzX7Ewc9JAsWaeX1NzQE1RNjSysPLbH5wE	1633	1144	318	6301	12463	jxuWuTBbP5qExCGmppQ21cVnsRNMyhVzHCmGM1zRBxo5ePyV8cE	9309	13146	13146	1618305480000	canonical
18486	3NKipp9ubyZEpF4HQmLbhrA5NNjCu4uh3htFkMzf6DDDoteeFx1H	18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	152	964	319	6301	12463	jxiXruZEPNK6tikhb9ocFQ6P7AmuUSnWQnzU1kSX2MjysQMtcys	9310	13147	13147	1618305660000	orphaned
18489	3NLDHrixBDGPjwXbWGYXLecYU72hF7WZz7KLjWPYQoZ5vdFyJAns	18488	3NKbrDc2cExcJGHSwCh5BsxvD9XufvFEXytT6HMQ9MYbZanixVN3	1405	873	319	6301	12463	jxWRnwjodvW1TxjRiyijKQF3K2sCANPsyaJW4kwBjZiJ9NW1VG6	9312	13149	13149	1618306020000	canonical
18491	3NKq7YHngAZwhnxSUYD8cBTxsvzF6sZXcDWjRXmADFwCNgx9FHve	18489	3NLDHrixBDGPjwXbWGYXLecYU72hF7WZz7KLjWPYQoZ5vdFyJAns	263	263	319	6301	12463	jwk5B3kXXweDcUviNeC4dfS1S1G2eKPWr6XvTwaSr7vvBNQUqut	9313	13150	13150	1618306200000	orphaned
18496	3NK414Uji3w1RkssNXgB9KThLHQWQs7JCUB1T5XPdng8pgcjf7P7	18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	1637	816	319	6301	12463	jxSASRWKZAaJK6NmR3p2E5veWwjQ2buVzPBvujAboGvQJHuQpvF	9315	13152	13152	1618306560000	orphaned
18498	3NKu1CUV1vA5h6KXenxtQN5WYdtext4c1gjaUPbAXRnRUbu3oUE5	18497	3NKQjwmz9bLtq3W5xG5NEjJQEPW5qgquCKbhXXckZR96AthWV6xg	1571	1089	319	6301	12463	jwFvh8xxRp1N8bptdufkRoTVJUgGYAjPPZJ9d8eEtivwopu4vtm	9317	13154	13154	1618306920000	canonical
18510	3NKpn387mvBd17nJg1fFes5A3mEUMutK8nq6tkfCzNyCt17eo1jH	18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	369	946	319	6301	12463	jwhd531UnR6HQuEJbqWWoAHvcsm7TmY3MDDQoAFouMu7n1T6vJm	9323	13162	13162	1618308360000	orphaned
18512	3NL8sh9QRtkjX9Gth3VWtN7PGMKuq9vsooZywU2sxWMgVZwih1f2	18511	3NKXNCsMstZmjCQgfLB93K4dZF8Li7ChnQ5TPNmkwPxTiWA8Xn4j	1670	1156	319	6301	12463	jxx4PvWirpYHXbAaz2Vjwb4qBZHSbEnDf2PdunixcKTxQeg77mu	9324	13163	13163	1618308540000	canonical
18521	3NKrFrpdcbXiXpSztLgB7rXD1fN7k38YQkW9X5FkuepWNuEQqX8j	18518	3NLmz42388MhbhSw2jomPdPFGhiFDqESaNXaUWbhcfSEJLepaBub	1406	1393	319	6301	12463	jxnB197HzYT3XT4RNCNxfvPmDXcJUn9BrTcxVTrh6bwHGNRKYF4	9328	13168	13168	1618309440000	canonical
18526	3NKbVRPC3qPEdCqjDHkrmoXvRiYMoEtVZnR8ACSCBgRAdwAcTxhv	18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	1608	1043	320	6301	12463	jxAWB13UcNS3kUZUKy9sj2SCLzdpo2HhnT1Z2pnwvwu6MRjSgYx	9331	13171	13171	1618309980000	canonical
18524	3NKKQmX3CTBSgUsyScBwizW6wtNDk59HdgQoTqD42yjNcsRo8Cij	18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	1406	1393	320	6301	12463	jwsGYMchhyNQJif6JUi4MT37nqBTrRUz5zskCnCuf5RSxq1zi4T	9331	13171	13171	1618309980000	orphaned
18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	18531	3NK3jkTxuaRpFJfwairSs3mwmPA3Xy8RB45bJ7tNFWPJznhiAUPj	1600	1246	320	6301	12463	jxBQf1iiHKHxSmyKXxtU9JnuWDoU16ru3SFwsFrSgQ5EEwyTLWg	9337	13179	13179	1618311420000	canonical
21561	3NKr8tytcpLeWrmy75eAXfJ6Dxupi9rENXmU5tUafxt4ZBmnWead	21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	1527	1293	394	12463	13764	jwpr3RSzK8xVbGhDsg6QJyEkioDyVBcyzuBR95VRuAsGkT3siec	10812	15226	15226	1618679880000	orphaned
18441	3NKfJJMAPByKDenpwHPoTFPKZLnYtbaZxAThixsXnByxKVEnn6DU	18436	3NKDbB9jqBuNa87tYH3sEhw2u7GiJ5SnHRBhG1aUBmGTPsHMcE9P	1403	824	318	6301	12463	jxX15DDWKeyf9uFTzWNjcBLzJHcy9QZcoZokBxYHggPEsg3j665	9295	13124	13124	1618301520000	canonical
18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	18444	3NKPAHUSF9RXjGdnTysniQpnJYYUzWVhFxtAMATiPpCGMcgkk3FR	1600	1126	318	6301	12463	jwkmiiQNpyToZYHGSGKPr65w7QfNQxJYDDo1M8vLzqejyWeZ7KA	9298	13127	13127	1618302060000	canonical
18448	3NKDyeXNqVwoRuMtCRFQX7R9j71kKakvhh9ThiyRWm1uw5qtC3jY	18446	3NKYdT2kYoxFyLonXwprfFrsP6QB4XCScuLntGbUt5JqSAEb7wdU	1651	1055	318	6301	12463	jwxeza5KdK9uEegW2kzMMC9XQUViNj6QJGuzevRGSWotbHYowPK	9299	13128	13128	1618302240000	orphaned
18451	3NKbCM2GWgN2XMSH6v8vGj1Xpo4YqbMMc73pYEkAJSn54fUyUuwq	18447	3NK79QDDFhtfCgmVfsXg5bgtbWqN5mxtoUcz5PpnDqC23LprSArd	1407	1395	318	6301	12463	jx9p3JQZpA3Ddo2qtoY4HQYwA3yR4RPjfSgW58ySN7219WA3CVs	9300	13129	13129	1618302420000	orphaned
18455	3NLNLKnr4vVmMEPjZErFWVKrnhePq5M6t8m3a1p5PQxYUhPTo4Tf	18452	3NKZPXSz6vquKRcFxWazyo5USkzAsnfqQRkiLgTdqKw5XePXZVHM	1406	1393	318	6301	12463	jwL1VoGEca6TQkXjVVVwEuUG451L9iV42wnXraENhgNBitvQMu7	9301	13130	13130	1618302600000	orphaned
18459	3NLcph9j2g8jAJNZiEbtNkQ3BXw7ocF6ao7bZfGhhmkFGDxvmhLN	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1513	1253	318	6301	12463	jwUzgn9URnvWZchVyWrzNqD91znDQ4yffahc8yfVtRNtk7vdZvY	9302	13131	13131	1618302780000	orphaned
18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	18457	3NLTSBHGrk87GXHKR2BnQ3preRBLc5f77kfeBdSRfkfvU4yhs5jW	1588	1392	318	6301	12463	jxgvNbMXAZoRRNuRwt5AnuodtWUxGfyQYs3ypbEzvmXYtgGvqh5	9303	13132	13132	1618302960000	canonical
18467	3NLjeSik5aD5JT35dd1XqenE5DWYpT5JoseGEWhFSPgZEXrbTKfg	18464	3NLRye1kMRvJPdn5UCNNtXsvLVPCQG54gQCU7NmqreAsVgTdAreU	1403	824	318	6301	12463	jxU1zMV3JQJtz8m948Wtf7vFWn5cCVAPBJSSMsz4t9mnJ5ZbUWW	9305	13135	13135	1618303500000	canonical
18470	3NKJaSypMeyd4nkCdmrB9jcTYH3XHWqmU3M2unsSVHfDDEMyeX9S	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1474	1329	318	6301	12463	jxcg3aa3BNwF7cR5CeZW8rsvf6UzTxCKVRfT2cv6A66uuAm1hdi	9307	13139	13139	1618304220000	orphaned
18479	3NKd59qtu9nSNRJnZXE8zvzhQ7h4Z5hL88gQWZEYEnPGo3gmw3hb	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	1527	1293	318	6301	12463	jxStPwWxgf1rgvRnEGdjbf8LxxrbkkyDkTshYshyUev61KhsfvP	9308	13141	13141	1618304580000	orphaned
18485	3NKEYKzvqoaNTLFN2if98t3orHbtVCjZCc3N676dakiBSEV8JF3x	18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	1516	1294	319	6301	12463	jwqMiNhY2MKzgoJM8VMHdfo1fNgVMs1dH5rktNvhDihkFHxyy7A	9310	13147	13147	1618305660000	canonical
18490	3NKu39kWCLRuMtPPf4YD2ATznfH2oTFo2WrobiFyN13fgcj8cY4q	18489	3NLDHrixBDGPjwXbWGYXLecYU72hF7WZz7KLjWPYQoZ5vdFyJAns	1581	778	319	6301	12463	jx9uMQRbXbodhv7UrjCMPAgZ1jnfXFoUzPTzULKdBipReZcpTqL	9313	13150	13150	1618306200000	canonical
18495	3NLVsikeu9gFnTMztuwLp9QcKYvYKMVi5VnTcgqjN71tHmmc13QD	18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	1406	1393	319	6301	12463	jwV94BCv6k4jp7quC8Tjk7CDtkVUGJkXeL1GnrjgKghFygVm3nE	9315	13152	13152	1618306560000	orphaned
18497	3NKQjwmz9bLtq3W5xG5NEjJQEPW5qgquCKbhXXckZR96AthWV6xg	18494	3NKZRzGsfd6f5QJkxwVNYACkeSSJFHwXgDrU33vPNemv3eo46FE9	1445	1044	319	6301	12463	jxZsaowYGw9xUYVGoe8gXyJpRU4q1WRkHLm7HNwebgL2e1ShUN7	9316	13153	13153	1618306740000	canonical
18504	3NK5U7nd78QxG6SHiTa8Sq4nDjnvH24s1V4STPok4M9metYmkMLF	18503	3NLWEKmT7uqJzqaFWRyYkAUXWN7WVbuP1LoFYmN6h51CXKXcsCyH	1648	1038	319	6301	12463	jx8binnrYDUn7XppzcTDMYAfNtA2SyprchnBsb3vrLN1Jgy25vT	9321	13159	13159	1618307820000	canonical
18511	3NKXNCsMstZmjCQgfLB93K4dZF8Li7ChnQ5TPNmkwPxTiWA8Xn4j	18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	1467	1376	319	6301	12463	jwbooXjtiLY1wWCzKjUPughTHUFvUvfntAqV6CsYJLEfVNnTyzi	9323	13162	13162	1618308360000	canonical
18513	3NLRHPY543mh78msno4EECx4NQ1VS8GcjH5YzL2RqHisesx9WUTZ	18511	3NKXNCsMstZmjCQgfLB93K4dZF8Li7ChnQ5TPNmkwPxTiWA8Xn4j	1407	1395	319	6301	12463	jx1ojJXW4KJCHhAWwDjbK8NGhmW79wdrNVu17Tv8JmK9abK2pBe	9324	13163	13163	1618308540000	orphaned
18515	3NLUQQpCuixLgGFKscG1bU5ZzwBDkPrVuFZXJ6FHPNPiquYNnX33	18512	3NL8sh9QRtkjX9Gth3VWtN7PGMKuq9vsooZywU2sxWMgVZwih1f2	1675	1342	319	6301	12463	jwdaFgorUS3CvwLd1fTgu5t47jS1jBA5ahZ9h3fJsMg1ZYoEr75	9325	13164	13164	1618308720000	canonical
18518	3NLmz42388MhbhSw2jomPdPFGhiFDqESaNXaUWbhcfSEJLepaBub	18516	3NKx5KPPMnUp7J3kMxfLrBQ5BWFyJCQozwHpwxN19Q7xH3PP9qCc	1406	1393	319	6301	12463	jxTK69nRovhKFsBaFGjU81wPFugrVbaBtijTY1J2fcPcsPGCyDn	9327	13167	13167	1618309260000	canonical
18520	3NLsvDbw2j4yUBu7AwWDdx8TiZJHw3rLzN4BCuR3kG5j7nr95AXk	18518	3NLmz42388MhbhSw2jomPdPFGhiFDqESaNXaUWbhcfSEJLepaBub	1458	351	319	6301	12463	jwMAwmboN3vSdkh2HHZGQ2b395NgLWhdwVbFpp8mXEgUitBiA5w	9328	13168	13168	1618309440000	orphaned
18527	3NKeUEjo9pxR9Jbee8THi3SkNFW79LPd7YAh98MHqy73R9FyP189	18526	3NKbVRPC3qPEdCqjDHkrmoXvRiYMoEtVZnR8ACSCBgRAdwAcTxhv	80	1273	320	6301	12463	jwKE2FuLcGSvbyV2ew5r5YMqDPyXnbCpPkNVXPTAgUfKz3DrJqK	9332	13172	13172	1618310160000	canonical
18530	3NL6qKXe2rbUAtSiAU5N2vjjuUHWypHvXF6w3yQSSLYPE4mKPwgJ	18529	3NLVKVEJXrRAnWSBrN6Ppk22nxgvWnoHtH7jodC9EBBXcccji9fC	1406	1393	320	6301	12463	jxHZtfYKRPwk3uoViQdpzxTV591HoMnTLYQXcTwAoc7dc7wozBE	9335	13175	13175	1618310700000	canonical
18533	3NKZHpWmuX9LiXCKw1TvZakEuqHXSWtmmHwAo8KqbxZCEypGVRSu	18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	1460	558	320	6301	12463	jx5q2BDJHGR3bdnM8qUvesiGYCvLQ1WEa2RDcdqWDA2mRBEgTdy	9338	13180	13180	1618311600000	canonical
18535	3NKR35Lt5V96HkJCzVDSP31ohBi1rjspTmaHknsMMKSkXETpLDHC	18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	1489	1380	320	6301	12463	jwVxb5hfm5tp1VAJTJuyHyxvdac6FGEfuQ7BNjvH6eRFggq9P4H	9338	13180	13180	1618311600000	orphaned
18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	18537	3NLbiLzepgHtAXaeqGBRfFiBasNKqDxVDancJnrRzzFbES5XPzt8	1406	1393	320	6301	12463	jxR7iL43mtJrFzY7DCXfHD5GDks455k34MFkwVXg1r7b6gZuzyP	9340	13183	13183	1618312140000	canonical
18547	3NLBeMiktYPZXpKK355nSCDKmK7Hwvb9ERirkvMgWzet35LNZGTV	18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	1536	1313	320	6301	12463	jxDwBnGCC8mtqWuny4Q5ViZLZRdZSPNHaZp9doLoghKdB3wWjYP	9345	13188	13188	1618313040000	orphaned
18549	3NKTUV7sS7Q8eEmoHeNhofrw1rnUtRDNiefQZo1JJLiGSLsEsYbg	18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	1440	1131	320	6301	12463	jwiiAUy25KtZrjkTYc9norjh9fj3Tf88JGfR2RKDU1NDDNguAPL	9345	13188	13188	1618313040000	orphaned
18553	3NLcoRs6v1ZDe4c3reyti14DV2jSyFziNG8AvT7cJBbUzYomzq1k	18552	3NLY3sGFbsRhKDqt6SDXsRZZnk3YneDXFN1jGh4WiF3sCByHhKss	1600	1126	320	6301	12463	jxqxdu4S1XX2XbNyGHw5wpE63ggVwNfxePDEZiPCpHByKKSMf8d	9349	13196	13196	1618314480000	canonical
18560	3NLPbXoWpya7wZTEbzGup6Z6erBRcW9Aqa51q6ZXF3HgA2Dg76PS	18557	3NKZ2hgsDakc9Ekwf1HrhszNRUhBmzNcmvhvmQ21wiErx5wMUwBf	1406	1393	321	6301	12463	jxysagARTWTm6vkYHcc2aYr72S5swaBPPeVQmz2TLnZznH1aHJ4	9353	13200	13200	1618315200000	canonical
21776	3NLTBLFLvSYRR7V6JHJyifbsAojpM4XyRPngiQJfFhZP4kom53jo	21733	3NKGykXWDY8vdcyeCTJaohn58vXunLuaGaQLxqGchPNKEPNuAf1y	1402	868	396	12463	13948	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10818	15346	15346	1618701480000	orphaned
18575	3NKrrYHcf7qN9X7qTNpATtjyRDZCuGQYzuAiwkoFKY6T6vhwZxic	18352	3NKc7TRzmdf1ot15uVk9hAmuB8giBsew2xGWuWWzco36BxKqFUBk	1670	1036	316	6301	12463	jxGGdNagPE9tABMg1zK2YF26vogHvaHKpAHvRucqUfc7jsDgsub	9248	13208	13208	1618316751609	orphaned
18487	3NKoKvtiQmcCd4HphyxY9dhKtZxuzzGmAvmoLMg51hvVHThv63si	18484	3NKeXxAd6RUKsXf6Z5mK2FdLpkRS6ACm9JY44RdDKUwsi215uCsX	1541	1298	319	6301	12463	jx9RhZ8R3m53PzAaimErvhLRDKRoi2tJmXWBV5AvxSJnfADmt6v	9310	13147	13147	1618305660000	orphaned
18492	3NKdKQ9SC2PWLopKJhVttpsuCq5xrTGmQPVmB5u7DCy2CvZD2me4	18490	3NKu39kWCLRuMtPPf4YD2ATznfH2oTFo2WrobiFyN13fgcj8cY4q	1458	1077	319	6301	12463	jwz4ad6DuFvYb4yJbLPJZ31w3NGkNBC5HQNBWZa6T9zk4rd9Zzv	9314	13151	13151	1618306380000	orphaned
18494	3NKZRzGsfd6f5QJkxwVNYACkeSSJFHwXgDrU33vPNemv3eo46FE9	18493	3NL8pnQdAdxW8XrtVpuefanC2AA15ZamWoVr4WYxBCuLG3K41zi5	1402	882	319	6301	12463	jxLMszFkraZZHndBRJvLMeVPiba6W6qN4CugdeuyKN1T5hpwjAL	9315	13152	13152	1618306560000	canonical
18499	3NLafgVVqpskgDPn2RfU9SwifoPXVZQsGzRucRmoyn6NTg4r1zc1	18498	3NKu1CUV1vA5h6KXenxtQN5WYdtext4c1gjaUPbAXRnRUbu3oUE5	1503	1277	319	6301	12463	jxihhPc7qxNMhE6wQabxHrAMwkPDtGJa8KufJUMJ4HKfPwUF6EY	9318	13156	13156	1618307280000	canonical
18501	3NLECaQLUqKkAuW7YHou3bn1SHm8FX1Prfc2RbDcfVfqazXDGMn9	18499	3NLafgVVqpskgDPn2RfU9SwifoPXVZQsGzRucRmoyn6NTg4r1zc1	1622	1356	319	6301	12463	jwDhxEcmaqeCH27bpLHedwhaGPqSebe9uVMSX9hkwYoxSCPecct	9319	13157	13157	1618307460000	canonical
18503	3NLWEKmT7uqJzqaFWRyYkAUXWN7WVbuP1LoFYmN6h51CXKXcsCyH	18501	3NLECaQLUqKkAuW7YHou3bn1SHm8FX1Prfc2RbDcfVfqazXDGMn9	1585	1366	319	6301	12463	jxgPX2GkXaAxvGNqAudhAkEFAL4HGwbxi9joWGkM9veBo3Xpc8k	9320	13158	13158	1618307640000	canonical
18506	3NKv2Cefzr54W5gUQesNJuceDBLVYxhMhUfr1yKepot8wvsPypPc	18504	3NK5U7nd78QxG6SHiTa8Sq4nDjnvH24s1V4STPok4M9metYmkMLF	1592	592	319	6301	12463	jxKtWxmiZ2QYKYyYYkgZUxmrxo4Sg4VBhHyqRsj1jhXzc3Pmcf1	9322	13161	13161	1618308180000	canonical
18525	3NLKSACArJjZHySMCeEa7oHBfu5WdgjtyFj5ka4bgtb8fBT1U37S	18523	3NLuyU4vRxM7g5rvvkRCiBQDpHozA5aDhXTsJdrTfqWskdddfvRA	1673	1122	320	6301	12463	jxbCHxXwDya8fgyzEBSSNZLqDr7tkpwLiDhCoqfvbNX2epPnn7X	9331	13171	13171	1618309980000	orphaned
18529	3NLVKVEJXrRAnWSBrN6Ppk22nxgvWnoHtH7jodC9EBBXcccji9fC	18528	3NLydiqWHaTMzcvn7dDxjxdiL9kHGAWLjUAwSUTPoWVATQtMiTvM	1581	778	320	6301	12463	jxMS2BViMNjPLBBNjQMgBvzk9zRAB7unvjvEnUGcr4HT9pWS3NH	9334	13174	13174	1618310520000	canonical
18534	3NKp6U4L3AVyZfDEQuKgKn91668XAPxutnjRL6erq2kJCAyKxUMW	18532	3NKiQTpNuUmXbC7vGK2o2jaWaycw8fED9LWJie2XmuCBUoqL98k7	1440	1377	320	6301	12463	jwCpSWrL5aRj4inBbsBMB82XN7saEbKjkCbTkxr2erG4s8nfzWC	9338	13180	13180	1618311600000	orphaned
18537	3NLbiLzepgHtAXaeqGBRfFiBasNKqDxVDancJnrRzzFbES5XPzt8	18533	3NKZHpWmuX9LiXCKw1TvZakEuqHXSWtmmHwAo8KqbxZCEypGVRSu	1407	1395	320	6301	12463	jxoiCdtEUvom7JLcHvrPatZLqQnzXosPhxgUsQKUUXyRyRajqQL	9339	13182	13182	1618311960000	canonical
18539	3NKoU6LdRTrnWkgDcfMBoH4DhESYivFbTsECWyUD1mffYW7AX6E7	18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	1406	1393	320	6301	12463	jxtQ7cFULJpkm4Rbwg8qXeNNWXQxPmeJ2LMYtpgmytuxGGLEMDw	9341	13184	13184	1618312320000	canonical
18540	3NLMnkRTDET49y39GSgpC72dJiiFizV3EBKTmuYHPGdmJtkNtQQ2	18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	1670	1282	320	6301	12463	jwNkZPjrGfjN5xnF1hKQoAMkB6cKHNzj6uZzt6aVfGX6a4ykZFf	9341	13184	13184	1618312320000	orphaned
18542	3NKVmrYnP2nrpzXvZR6eXfB3oLoz9peQ1ZEogcNwFWdgCo1hwYof	18539	3NKoU6LdRTrnWkgDcfMBoH4DhESYivFbTsECWyUD1mffYW7AX6E7	1637	816	320	6301	12463	jx7oh7fQQszMt5oB6QStYyvzAqyGKTBZ9iVditMHaovo3yAd5K5	9342	13185	13185	1618312500000	canonical
18545	3NKFoBuS2TDd9CsFkraDx9dtmZDZvzduUi8AnkcBkQPSeSLb1WFW	18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	1507	1154	320	6301	12463	jwdQ5mNPfqRUdLg7GJAj3srbAfTooHZ3PchRwyTR4UAXHwxbqwf	9344	13187	13187	1618312860000	orphaned
18548	3NKwLvZMgv3upWc13q61WNo3WcDYpNYKzK6muLvf75H7P8VaF1v4	18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	1406	1393	320	6301	12463	jwzZEf6QVnGL3Guvj4jWsGZ32W6NGaQjTPpadZN26koWBMJUmQN	9345	13188	13188	1618313040000	canonical
18551	3NKY7NbCR8sRtxY4rPmmu1trXLe2z3CNWfkT1ZEJvBfJsNzHgwwo	18550	3NKfiJvPDhUmeZerwR6xE3ur7ouzYQU3ZbD6n6TFwJM9hgHo6kAv	1403	824	320	6301	12463	jw9s849trobPMTdNBsPk9ujDQxbJtY1feh5aA7mLNQTEGCUpkm8	9347	13192	13192	1618313760000	canonical
18552	3NLY3sGFbsRhKDqt6SDXsRZZnk3YneDXFN1jGh4WiF3sCByHhKss	18551	3NKY7NbCR8sRtxY4rPmmu1trXLe2z3CNWfkT1ZEJvBfJsNzHgwwo	1623	830	320	6301	12463	jwqBXcCxZ1FJW1jJmZrGhedmEjsXidkptrmYZJvGvpLyHEqRScX	9348	13193	13193	1618313940000	canonical
18555	3NL4J24GrT3RdCtZ7ephCtwZjuMdYj9QNcVe8PYKNpxfnBaHLiTe	18553	3NLcoRs6v1ZDe4c3reyti14DV2jSyFziNG8AvT7cJBbUzYomzq1k	1407	1395	321	6301	12463	jwMJN1ruYQcyLFsKLxYoy88WfRHLVqeCxtuPdceB12u2sNcQkX4	9350	13197	13197	1618314660000	orphaned
18557	3NKZ2hgsDakc9Ekwf1HrhszNRUhBmzNcmvhvmQ21wiErx5wMUwBf	18556	3NK3yoTttJKjcgPBPm3BrJkwgZxZVrpSurRzzsYfikKubprs3U2p	1610	1314	321	6301	12463	jxEYTqfWGinBa3Eu634KuHJ1sft5D2zbnbD7cah4X2vkF54m3pQ	9352	13199	13199	1618315020000	canonical
18558	3NLkGwxWuLvjd8RG2y7ihWWhgxBHQdPQWR3HpPZ2JYdTy79PzBL7	18556	3NK3yoTttJKjcgPBPm3BrJkwgZxZVrpSurRzzsYfikKubprs3U2p	1407	1395	321	6301	12463	jxYDazpcyDSxp9AFq3P8tXJcDgoWEHVuouNYkd6Y66P3mU8h7PN	9352	13199	13199	1618315020000	orphaned
18559	3NKrdBM1hcH8dV9cxauMqdk1gTXYDHg3beLBeSqFGt7CnVuxTD8T	18557	3NKZ2hgsDakc9Ekwf1HrhszNRUhBmzNcmvhvmQ21wiErx5wMUwBf	1547	1252	321	6301	12463	jwxKw5EKuFgAv1UTLii9hVsndVMchsBBuGMmZzNjn9zgESrcr4q	9353	13200	13200	1618315200000	orphaned
18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	18561	3NKwB6vyUCBff7jb4FQHDNas49DbWyCq8NVE2jg8VnpPTaVzqDoo	684	1106	321	6301	12463	jwnyNJiKUWm7pSn37tNqD5bki66RLgzrhg1wgZ9nAKr95FB9hsC	9355	13204	13204	1618315920000	canonical
18569	3NLPrtfa9j27zf5nnbEuhjVQndK4Q1coBEu48DmquTbNcYdzwFZF	18567	3NKYGn2KZJxNQ9MMcviMop1AcXSw5Gt3EKxBBYfNcRQk3S4CcWuh	1637	815	321	6301	12463	jxWB9dxs4mgvjCQ3igiu4JPX98LbXc4chiuTLeG25yiFi5PmzJx	9358	13207	13207	1618316460000	canonical
18571	3NKz7iTkLyHbwKG3AGjSWiQxZZkyUpff2wjBD6Fg143qnYXSFdFq	18569	3NLPrtfa9j27zf5nnbEuhjVQndK4Q1coBEu48DmquTbNcYdzwFZF	1670	1036	321	6301	12463	jwignEn8Gkc7kjV2paPTZzj47WUXPJ6PzcJ1gbkrdFGFDogRg2z	9359	13208	13208	1618316640000	orphaned
18585	3NLhZ2uZFT33MuFAtZUnUGoMHMMWnWGGpw8unTEMj6HgomFVUB7v	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	1625	161	321	6301	12463	jwU783ZGvqcKvyg6Eepyg4USmJLzwwDT1rJZBF8ECSwb9AHGsMS	9366	13219	13219	1618318620000	orphaned
18586	3NKhbpAzD3SdS1GEm9pzrUy3T6T23baARsQTKBB6WrexVG8mFEoZ	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	1581	778	321	6301	12463	jwu1yBEYxnpJzEe6q3ZoG92WzoasB1WuaHqbhDtwHtFQKUizyUQ	9366	13219	13219	1618318620000	orphaned
18589	3NLDi6yqnxbUGpK87f8GG1ZxV9SCyZANkTmQsynr1Xfv6ToHE7Zq	18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	1461	1271	321	6301	12463	jxegEtkc152nPieboz3qToq7ErTRdGSstJ7zYQa5YuWjoMUmyKN	9369	13223	13223	1618319340000	orphaned
21588	3NLAFU2kcMHLSoJHRniAVZwmy8CbXDvMod4StHmwmWzYNR2QG8r8	21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	1501	1360	394	12463	13786	jxpGrKEJpHePUb7nCHFUebfSioWzdEzutQz78mVqCfWQSsGknXw	10823	15238	15238	1618682040000	canonical
22463	3NKqRjLGKaSxYYh9hicXnFLHUFr8idVQ6TDE7pgKaxJGeR9aWGPh	22462	3NLwpcVoMDKCBTxfdHWwPC4w8NCh9DMPoa6oivpLqgdhLLmkBdTJ	1506	1373	416	12463	14569	jwsX3djnh9UnZjVCzFFsMTpKT4WK8e8W4TbmfSHw1AHBCANQajo	11241	15820	15820	1618786800000	canonical
22612	3NKaWUiGFrwvk9snxs2f9qa4J1urRCkG8Ayy9bDLqe3TLwQ9G4yk	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	44	1325	421	12463	14702	jwL1oNVUbXhmrNZnfz5jwjqfhuqvg6UzAfDufxty9iw2HX8rVXn	11311	15926	15926	1618805880000	orphaned
22626	3NLE5U8nLgQbrFYaFBGLsKq7YKwKxBXPUafHDcp9NPdYuwpDeB88	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	641	1210	421	12463	14713	jxbu5hpLsh2vTxnMJBtBhjZ4xCkyTPJZqLRsrJCvjTBfgMD32zK	11316	15931	15931	1618806780000	orphaned
22669	3NKdyxhLMxDaG16ekxEx8h2yhEH2WetYGmdQFbPe2VvNK35eX8sS	22668	3NKLy6Hx7RP77JYwgZSxka6K9wup4MwMVSjJ9KEwBD1Jz7edLvB8	1403	782	422	12463	14753	jy2zjbB6JqeAgoWJpcCtW54VdCrkn3QChYvz5eikqnjApgxLAx5	11333	15956	15956	1618811280000	canonical
22950	3NLxMoxcBS95BULSywNMrhrk9tsLmKPumbxDzeC9cftvZVfQaj96	22669	3NKdyxhLMxDaG16ekxEx8h2yhEH2WetYGmdQFbPe2VvNK35eX8sS	1508	1387	422	12463	15003	jwNUXXVQ1kukJuhckVczknXUBC4pyoZBmhbRPj6D6fgpwi1duhS	11334	16137	16137	1618843860000	orphaned
18573	3NLsSbs9ov418UZpEU8h1D1vE4hKoPtjy6oyAMqy731U4EkoJmfw	18288	3NKF42eKaiBZNqTzaajjU1R2G4RQjesSHqxB27PtEYikVbS6YdEh	1670	1036	314	6301	12463	jwPiJu3Qrv2xwgix11XLZEAiUu2itCieZZpiv6ZjrmntY13AnCy	9216	13208	13208	1618316677732	orphaned
18536	3NKosuVXs2mY6zm28DubDqdyJpYHArfFW4tAZziAMF1JP187rUbd	18445	3NKDHmD4RJZ7i3L28gNCrGhmTPg159wYzw6hEgarbX2Wg187mSUR	1634	1331	318	6301	12463	jxsE3vEothGENJvhcBbPM18U7HvAujEb1PUui1MqZZTQFGhtZCQ	9299	13181	13181	1618311780000	orphaned
18541	3NKZk5p4L4H9gLfYzGF7WYecMrRqSfSHFefGBLZdZoUYvV6m2XXx	18538	3NLp2zL5PcBsaJM23NWAV6uwzdV55SAgjkAqBKVDeLuTTwnhW7pM	1407	1395	320	6301	12463	jx58rJLakP5k5VfbdEtbt3nMRkHuN2vEGDSoojm3XrEvrb3eY9o	9341	13184	13184	1618312320000	orphaned
18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	18542	3NKVmrYnP2nrpzXvZR6eXfB3oLoz9peQ1ZEogcNwFWdgCo1hwYof	1500	1297	320	6301	12463	jxh25ppFbUknKc8RHrqCjKfgWvkvkYuY7zxXmSWnvndGohjKmsB	9343	13186	13186	1618312680000	canonical
18546	3NKBWEknFAtxsmv11E6btE39a7WTVfh7x7m1m4b9QHZwdTej3ekY	18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	1577	1081	320	6301	12463	jxGNH71JYgFHX3YWZtYxyLeRuo16cVakut1ffwLE3rHHfEV6NjK	9344	13187	13187	1618312860000	canonical
18550	3NKfiJvPDhUmeZerwR6xE3ur7ouzYQU3ZbD6n6TFwJM9hgHo6kAv	18548	3NKwLvZMgv3upWc13q61WNo3WcDYpNYKzK6muLvf75H7P8VaF1v4	369	946	320	6301	12463	jwUb5meNFG9s4pButra9tN19BrLGza9KZYhE8khfsPA4x3VBFXt	9346	13189	13189	1618313220000	canonical
18554	3NL17nFWU6oNLvB4RL4svc7sxneCUHbhuvhcayZvM8My6SQhw9iU	18553	3NLcoRs6v1ZDe4c3reyti14DV2jSyFziNG8AvT7cJBbUzYomzq1k	1403	824	321	6301	12463	jxvTWAALE5vqPPNtdZTZU787osP1XxnHJWrUUWt3cScJd9PgGsv	9350	13197	13197	1618314660000	canonical
18556	3NK3yoTttJKjcgPBPm3BrJkwgZxZVrpSurRzzsYfikKubprs3U2p	18554	3NL17nFWU6oNLvB4RL4svc7sxneCUHbhuvhcayZvM8My6SQhw9iU	1406	1393	321	6301	12463	jxZPNqSVZ1A8gnS8b79zmxxzqUKM6LVMHFTKGri5RcwSkeBKX17	9351	13198	13198	1618314840000	canonical
18563	3NKNP2vEYD1BKW5QvaAk65BD9RAc1iNpYwAbqEV7vhqHu6YTiQkT	18561	3NKwB6vyUCBff7jb4FQHDNas49DbWyCq8NVE2jg8VnpPTaVzqDoo	684	1106	321	6301	12463	jwpd89qmNNprZeawDJUDw692egb1Dk3sgsPqgaYbAWQ4btNDh5c	9355	13204	13204	1618315920000	orphaned
18565	3NKD6uCFre617X8NVTgCE7MhcbZgu5yxmnrMoyJVF1VxNbbRHrot	18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	684	1352	321	6301	12463	jx1irgJtsS7mujgkJH7gQzJUUQh137n5T74wP95iBKacrPJ2V3z	9356	13205	13205	1618316100000	canonical
18564	3NKjs1xvof98tfJa8PpVeaXUP5r7u37g8QeQUkintZJ7ZpPY8WXi	18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	684	1352	321	6301	12463	jxBqigPKgKcTvceSWRmxMEEbVwyYi2N2TaAtFWxLdx249hdrv1q	9356	13205	13205	1618316100000	orphaned
18567	3NKYGn2KZJxNQ9MMcviMop1AcXSw5Gt3EKxBBYfNcRQk3S4CcWuh	18565	3NKD6uCFre617X8NVTgCE7MhcbZgu5yxmnrMoyJVF1VxNbbRHrot	1587	1111	321	6301	12463	jx3wCkYn3obiyc3NhRk92M4fuqhWAbbsPqktXHdegFLXUnwNk7a	9357	13206	13206	1618316280000	canonical
18568	3NKQArzfjxcWzCdjWdF8yKXxVy2Lpen8wHv1X9WdAJrNR7yjW8ve	18565	3NKD6uCFre617X8NVTgCE7MhcbZgu5yxmnrMoyJVF1VxNbbRHrot	1627	1139	321	6301	12463	jxadC57QJ8JKLctsnKtw3FHdnLmT1XNr7uVqY89rkbtiiux787e	9357	13206	13206	1618316280000	orphaned
18572	3NL71RRR1MENAW5k98ifTtViXaGiNALVP3rMbwBNiyHYudacyo7X	18569	3NLPrtfa9j27zf5nnbEuhjVQndK4Q1coBEu48DmquTbNcYdzwFZF	1406	1393	321	6301	12463	jwLfr6d7SYZBXG85ZPGWT4YN6wpkgri91HhCtRGGGwLwXUYuPvD	9359	13208	13208	1618316640000	canonical
18576	3NL4z9G6czXoEvnB5Te6FeRbmCWLz3JvWb6zWY5JG7gmcFbsBWAg	18572	3NL71RRR1MENAW5k98ifTtViXaGiNALVP3rMbwBNiyHYudacyo7X	1406	1393	321	6301	12463	jxyd6ELrwepaTWBGUtmBX1v2hx7DUP4NKw5DVXHqHqPBzeBnxjZ	9360	13209	13209	1618316820000	canonical
18578	3NKwYPG1npidYHEQjYwvKW4rSVgS3frGpaBy6ygBiGUTU5UBkJkU	18576	3NL4z9G6czXoEvnB5Te6FeRbmCWLz3JvWb6zWY5JG7gmcFbsBWAg	1407	1395	321	6301	12463	jxqoFXhf94ijVZoKbrEfyH3bL7QHrA8ym7YqUHm9dkdUATYbq2A	9361	13210	13210	1618317000000	canonical
18580	3NKKt4o1nu5jJtdigsnKq9258ieaHCrQ4APnSpfR1uH79uedTbpB	18579	3NK9YXWDjn6J2Es5NPXGXnQKmZQzzx8htUr9QEQjSBfmTKLnzzB3	1647	1056	321	6301	12463	jwGF8aqvvHxN2Wz6XibQ1n9YD1mZRk3dkH825tM8rrApt3Vu8Hy	9363	13213	13213	1618317540000	canonical
18581	3NK3nbpDPqQf8wjgdFWBxsyqiyK5tycphoyrDdoBAAGhwQJgoJ4d	18580	3NKKt4o1nu5jJtdigsnKq9258ieaHCrQ4APnSpfR1uH79uedTbpB	1609	1333	321	6301	12463	jxz9rAg5u5RpySmA4i2gwMo3vbx4LhAEU5oH8ydZ4AR1WcACr7S	9364	13214	13214	1618317720000	canonical
18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	18581	3NK3nbpDPqQf8wjgdFWBxsyqiyK5tycphoyrDdoBAAGhwQJgoJ4d	1405	851	321	6301	12463	jwegMzUNq13npWuFgE9hd98jZc9vZ3vB9Kxg6NLCCN2x4qiXEyQ	9365	13217	13217	1618318260000	canonical
18584	3NKhasUkmX3RkMGLT1yK8MT6TULK34eHG4QTaeD1mQxc6Gc4WZRF	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	1402	852	321	6301	12463	jwBAS5H9XACepcNPPvadSbj1NsDomfFcreWifhV78SZNBUE8ypA	9366	13219	13219	1618318620000	orphaned
18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	18587	3NLtpVJhQpv3XKJKq3QVwJ4QZL9SjzuHSyeExPZiKYhi7nsZc5xH	1406	1393	321	6301	12463	jwUYnp5gBoB1HpZ7bheQZGpR3FFpRtPYzp8fPNY8Qat2es6xiYo	9368	13222	13222	1618319160000	canonical
18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	1617	1042	321	6301	12463	jwK82SWWu7FAq9VFbct6d9uQGL3U1W3mHGtg9432E2axi8sJMvw	9369	13223	13223	1618319340000	canonical
18598	3NLMFeD1NfhEk6umcYLn2uBNx2YY6Rkb4sTEme4VgzM7PkR4EfxW	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1407	1395	321	6301	12463	jwYfLXePn6UJaEqxrRgEAbJNNFEhq5a6kchfZZPhsVxfJot93s3	9370	13225	13225	1618319700000	canonical
18595	3NLwn6YcvjbnouQTQTjSvzMHLhBaYgrrPk8jtsrYXcjjXDCSetyw	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1596	1117	321	6301	12463	jx8HseiJhSXdPYF7YEzBxQXvmoAnKivMTLRBrwkWBGE2ZJcjSxN	9370	13225	13225	1618319700000	orphaned
18599	3NKiN55v7PABffmq6RniJb1tJ2KPq6hETfJD3AEHUmWBgHWnBwPL	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	470	1309	321	6301	12463	jwragg9MAoa2x1uZhmpBWLgiphadRMB8dKmMf16A65QQLLyWTh7	9370	13225	13225	1618319700000	orphaned
21589	3NLRyFn8bZPhTM1U3yHAjN8XD2G1Rhgz4ogvjEzadFXDUjQZ1R7y	21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	1631	794	394	12463	13787	jwiGus9wE6s4t8xMqByXWTPP29zwUyYDrU6NY8dHXpep7TM4FNj	10823	15238	15238	1618682040000	orphaned
22469	3NL9szxxFME6bBgxYQhiAYJiAceVG8edyfoHkEZPSdrXN9sckBPp	22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	1610	948	416	12463	14575	jxE4j4ms8gGqTW7hWPCvY2qfu79Ve9WuqEDnpdT2gBAbVv6Ez6Q	11243	15822	15822	1618787160000	orphaned
18577	3NKGL7GCXNmYq78TUUvsoSfE8u2QudDibFsFFo1QdmhUKvDrNhFk	18572	3NL71RRR1MENAW5k98ifTtViXaGiNALVP3rMbwBNiyHYudacyo7X	1445	1290	321	6301	12463	jxfcENDUBGSH3Pqm4oJuSSVs3dXyJCnD3PKjNLShqkAaKFkMCVd	9360	13209	13209	1618316820000	orphaned
18579	3NK9YXWDjn6J2Es5NPXGXnQKmZQzzx8htUr9QEQjSBfmTKLnzzB3	18578	3NKwYPG1npidYHEQjYwvKW4rSVgS3frGpaBy6ygBiGUTU5UBkJkU	1402	874	321	6301	12463	jxxSJ2tHsgrwtPcf9NrVM6rmDunW18dmtfQafFgqDJkBRdAvegU	9362	13212	13212	1618317360000	canonical
18583	3NKai4t9cgj5qaszBkqXHy7adXw9Bydz1zS7va1JkR1rfHDLgMoG	18582	3NLGChuExq3d7w9miVB1eXx2hufhwrhpMSgkViFifkjZmvDEQGsS	369	1312	321	6301	12463	jxf5BRp1zXZNRxe1TxoPUqq7VFZKg7aSfi5244htXSSsFzmZK8s	9366	13219	13219	1618318620000	canonical
18587	3NLtpVJhQpv3XKJKq3QVwJ4QZL9SjzuHSyeExPZiKYhi7nsZc5xH	18583	3NKai4t9cgj5qaszBkqXHy7adXw9Bydz1zS7va1JkR1rfHDLgMoG	1407	1395	321	6301	12463	jxhY1mVzW59CskJseSpDZKMEfAy6EMDdmFSSe4g4K1LuRS9trSh	9367	13220	13220	1618318800000	canonical
18590	3NLdLZqCX6pxY3zpe2RBVfEsAwrhZ3GJjgHQSwW4ETfX4DWbVGen	18588	3NKDKmMqLN9aEtouamogrJzEaZQmmgjWFAygYxLwBca1G9tRFoCH	1608	1289	321	6301	12463	jwBaAeEStjdF5m1HPFAeisgjx1cUyuoKirHfMDYBxzmtgxkq5w7	9369	13223	13223	1618319340000	orphaned
18593	3NL1zBDkujSHiqYaVh6k5nhQTHiDvdRR9Dnzo8ReH2auv6wZwzEF	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	470	1309	321	6301	12463	jxFfR5BKw5TxCYrFGcejVerUVCLQCxKKWhoUNUhCMj5jfhty9f4	9370	13225	13225	1618319700000	orphaned
18601	3NKws9cfr4rdHnnEBAoToRr1FGMd24WXjL7ZerLBRXMDyWmPbfUz	18598	3NLMFeD1NfhEk6umcYLn2uBNx2YY6Rkb4sTEme4VgzM7PkR4EfxW	1406	1393	322	6301	12463	jxWAU8JWnh2bingxYVRxTUChMKf9PoR4ckcR3nq1ccLgXTtxh83	9371	13226	13226	1618319880000	canonical
18600	3NLaK7bBpxeQKD3dfirygR6wmwY33hsVqNg6DMhnftG7i4frvRnw	18598	3NLMFeD1NfhEk6umcYLn2uBNx2YY6Rkb4sTEme4VgzM7PkR4EfxW	1637	816	322	6301	12463	jwZSTBR7jNj51Grxb1Su6ZwNBkARqpTteZBoKPWGbyM8Pqu1NrZ	9371	13226	13226	1618319880000	orphaned
18603	3NK42bjnZyyMnEtydBqSN4VgiAcHPo9sM8oS3ZvhdN4QBydxrvFg	18602	3NKKU9ygEAL458egN3K8wed3Sm61L7Utz4biLYzQvzMwcpSu8WrW	1672	919	322	6301	12463	jwdQeusafyUbyM1u9nrKiLKo1e7YJxbeVvLYBC3prJKP5GgiydG	9373	13228	13228	1618320240000	canonical
18604	3NKLHJmmz8zzt5D2fpksqBxa77fXAUeMP71gtTQ5EkJ9AUfvvEgp	18603	3NK42bjnZyyMnEtydBqSN4VgiAcHPo9sM8oS3ZvhdN4QBydxrvFg	1407	1395	322	6301	12463	jwVaxfzdFXBJ5HeVYFzxUrWsPo1cZ4GhB4XrZZFdCf3RKxvggsa	9374	13229	13229	1618320420000	canonical
18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	18604	3NKLHJmmz8zzt5D2fpksqBxa77fXAUeMP71gtTQ5EkJ9AUfvvEgp	1407	1395	322	6301	12463	jxUwu6Eu1czYG8eKqK3bJMzLUCEiViwj9AM4fg2bZz6AxeEhBaD	9375	13230	13230	1618320600000	canonical
18605	3NKsdTquRZ459xmM9uX1R4R7cYcw9kCspUCzRN77U5H2Ph8UNKFX	18604	3NKLHJmmz8zzt5D2fpksqBxa77fXAUeMP71gtTQ5EkJ9AUfvvEgp	1406	1393	322	6301	12463	jwUa4dFheGZiH6wUSQesm1m683wPptHNdoyZNbeSLGcTGEU6AWx	9375	13230	13230	1618320600000	orphaned
18610	3NLQrKJrQYH9Airi7Ys1NrsZZBfNLZru7EZpBszs5Mtt2GZdKEzZ	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1577	961	322	6301	12463	jwp92XRPXd8YymTosorFqRVsszAn9TYi1wez7KMTihevEyCoLmQ	9376	13231	13231	1618320780000	canonical
18607	3NL3C6QjvoP9Ndsa3emcrXU58g8eBpVryeVgNzvPwPw6p5LQGaR4	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1403	812	322	6301	12463	jwLsgg5gPQ8yNHkGQHW7SkwA1YSw21ArGmetGqGM1nVpNvtGtdn	9376	13231	13231	1618320780000	orphaned
18612	3NKSSfrvdrFVxt1j53ZrvX1fu2KX5u28kGerC2VKBiQMqRAdcZ7C	18610	3NLQrKJrQYH9Airi7Ys1NrsZZBfNLZru7EZpBszs5Mtt2GZdKEzZ	1581	778	322	6301	12463	jwnf21U1D2kVDU5xdyp4QPET9KP3qPNgG9gY8gDoXFNHXYQmN2D	9377	13232	13232	1618320960000	canonical
18611	3NLNQJ8DcnWimmTMcR2UE9pYJt6Qo1H7zhv5DphrxJ9BJB2gLiEx	18610	3NLQrKJrQYH9Airi7Ys1NrsZZBfNLZru7EZpBszs5Mtt2GZdKEzZ	1673	1002	322	6301	12463	jxhgmfGFzsJcSL5Fq6c4Zhg3kSch9AfQt6oyLTCLGfjqNNPhMsK	9377	13232	13232	1618320960000	orphaned
18614	3NLfBq9Z7GXsibfw7Yt9Mv2okjfqXVTSofQfRD2L8qS8QWXMnwTP	18612	3NKSSfrvdrFVxt1j53ZrvX1fu2KX5u28kGerC2VKBiQMqRAdcZ7C	1593	980	322	6301	12463	jwo3iq3GcUdwq85Un44oeJA1DRy6p5YsrV796E6wUkaxqnCuuQG	9378	13239	13239	1618322220000	canonical
18613	3NKTDV3nLQyDRdsP6PDfbBWxLLHhCnbuasoNK12VfFfDYiAunT7X	18612	3NKSSfrvdrFVxt1j53ZrvX1fu2KX5u28kGerC2VKBiQMqRAdcZ7C	1509	1074	322	6301	12463	jwPBzYbkqMachp81nocpaKGwjcEKDLeCz3tdpyqsoMZKZEdXPBH	9378	13239	13239	1618322220000	orphaned
18615	3NL1bN4UtmngzqfwEG2VvLUevDY5NF9CCa7xW9QTWKZpLYQ84N8r	18614	3NLfBq9Z7GXsibfw7Yt9Mv2okjfqXVTSofQfRD2L8qS8QWXMnwTP	1581	778	322	6301	12463	jxrdQHmNBw5Sa6Z7xsGBrFN1ePp71H3CJjfcHPETpjeW5Kcm7WV	9379	13240	13240	1618322400000	canonical
18617	3NKQt3LJgXsazV8Mp6VHTZopXnSveFd9tCJujnvFTQAXb4CzTao7	18615	3NL1bN4UtmngzqfwEG2VvLUevDY5NF9CCa7xW9QTWKZpLYQ84N8r	1407	1395	322	6301	12463	jwTWMUsan6jr3X1bgL21ocELy1bUWXZq4F6KyxM4fLxXfiJcvft	9380	13241	13241	1618322580000	canonical
18616	3NKauF1dVemTzoXcuCFQXxMb46p2b8F2aYTzGDHetCbmdoWrEeV7	18615	3NL1bN4UtmngzqfwEG2VvLUevDY5NF9CCa7xW9QTWKZpLYQ84N8r	1419	814	322	6301	12463	jwxZmp1GWdTBH7q92AWvSRZoWGEVcurXktCzKePsG1WLnXQ5rXx	9380	13241	13241	1618322580000	orphaned
18618	3NKFx6zi6woo4zTYbEeu3tyF9BNVjkw2gYDNqPoXc3Jqs5N4awAA	18617	3NKQt3LJgXsazV8Mp6VHTZopXnSveFd9tCJujnvFTQAXb4CzTao7	700	840	322	6301	12463	jxEXT1jZuR9cuJZhACECPcK89vje5hGgvNnxgiDpQr9HtnYUW6A	9381	13242	13242	1618322760000	canonical
18619	3NKeURXwUs5RBUqbtmMQtRzCogW7fRt54XrsB6trbYwCZKnR6k5x	18617	3NKQt3LJgXsazV8Mp6VHTZopXnSveFd9tCJujnvFTQAXb4CzTao7	1646	1354	322	6301	12463	jxdJXiwbWkGodczmqASnWNmDJYJieSq7bCvFPENCdxwb4vdDrVq	9381	13242	13242	1618322760000	orphaned
18620	3NLPb9CnTyR4v9Q55ZtbVgNjEnsXEsEPdXU6VYLNFDryt8v2QMTV	18618	3NKFx6zi6woo4zTYbEeu3tyF9BNVjkw2gYDNqPoXc3Jqs5N4awAA	1516	1294	322	6301	12463	jwdBQTUZWcphSnMcikxVM3B6p6wPZQQPqzHyCD3MWUZtZZdYkEz	9382	13243	13243	1618322940000	canonical
18621	3NLc45dyUhJtPnBWfz2naSdGQ2Jwv5ht8WcKZJVHoHFaaW7BE5VU	18618	3NKFx6zi6woo4zTYbEeu3tyF9BNVjkw2gYDNqPoXc3Jqs5N4awAA	1624	1334	322	6301	12463	jwGtAi7C4az9ox3ohWeyP4tQiBRfRWimmJToiMUpJaHWHxjXJYF	9382	13243	13243	1618322940000	orphaned
18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	18625	3NLY2cBTan9VqUV5m8KxfhHK1DNRdy9L7ySi5SPtFsDw7QhzmTpq	1407	1395	322	6301	12463	jwNu2ZhoJ3dbZupehyc2smnmGFKvdBjYDy4M5jm1RmCMuW8Kvrh	9386	13248	13248	1618323840000	canonical
18629	3NLMSD91kyREJ13moEAtqCicnduPi138pEw63CPMPEctQow3MUrb	18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	1623	830	322	6301	12463	jxDn3KFGUXAG5Ks1n5yr5rTCnE5KGTouiLtRur2UbtmTnZusYcJ	9387	13250	13250	1618324200000	orphaned
18634	3NLs15hRjEATLi9Vb7A6KvPnoJ2V1Sm7SoUSEcf1fCZ83joWyiTX	18633	3NKCNJN4JGX5GfNufgrkWv8EGBB8zxVinwYDTtkPvuT1b5PXaQnA	1546	1213	322	6301	12463	jw85jESCVXcS3c7aiLaAGESiznK3uSJyJLHNiL6V5zACrpXWZwg	9390	13256	13256	1618325280000	orphaned
21625	3NKi6sC9Vu3LawrnyZpJvjdJ6ZdHrWGP42YQMsFq1XB4s6W1vZpo	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1670	1036	395	12463	13819	jwNYbXPChiWNBrV84D4xEDM7MtkcK8PJc8XGri8MzqiaCaH9adX	10834	15252	15252	1618684560000	orphaned
18622	3NKh1Yzp71CF64phcQ7HkQZhRRbb3iXXkHDCwWjux5TeekTQjbW1	18620	3NLPb9CnTyR4v9Q55ZtbVgNjEnsXEsEPdXU6VYLNFDryt8v2QMTV	1403	782	322	6301	12463	jwFDedYX5nnLC2uzhRcuaDJz6VV9SzesMMhiPNm3AyLFZBrCZzT	9383	13244	13244	1618323120000	canonical
18625	3NLY2cBTan9VqUV5m8KxfhHK1DNRdy9L7ySi5SPtFsDw7QhzmTpq	18624	3NKThLA9FeFeVQCTSx6NLG1BFUGBE9NGneQ5huz32sXm1qxWdoWk	1483	910	322	6301	12463	jwPjoQiwzArTobyRDJ5Aa74baQ3EntevGEUkrezJ46sTuAyeQW6	9385	13247	13247	1618323660000	canonical
18630	3NLG8sRhebaHo6cCUMUKPnQTJmiybDYJhWT3rZxXUnfNKqUYEF9i	18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	1403	812	322	6301	12463	jwJjvM2cY4jxMwDLix2JuUspXhJ3ht6ro1kaFH3BAeR2xxwohMA	9388	13252	13252	1618324560000	canonical
18632	3NKnDfYmcuXzcuKXsA2be7PcrycXA1RoPjzBP7taF6AmJkJS9qFU	18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	1581	778	322	6301	12463	jwgWRtpA2xF5VkB6ixpMYdGNxzuuBgX3gFob9LjuaURxzAKwCoy	9388	13252	13252	1618324560000	orphaned
18637	3NL2PMJ3PHFD6cdQaxi89txoC8NfQuKbXRFsZV55FRMVYTxtCoCT	18636	3NLQgcNqgjD3EhZz7qWSdoATkWpk9U16qxeRRBznHH6EiDhzejK4	1549	1116	322	6301	12463	jxJyTU6m7aVh6AHyeJuwmgH3yiAUTLqihtHFEhde1SovNvTb9gF	9392	13260	13260	1618326000000	canonical
18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	18639	3NKkohzw8dpjv4G7KqdYTSsZkpHNCz5pLUKAs5EsVc6jaM2tz3Z9	1596	1237	323	6301	12463	jwFT1wXGQVtqfMy31jbK3kPYayRQGsqRWCn71VhhesJiVA5zLDY	9394	13263	13263	1618326540000	canonical
18642	3NLJLPHMctwL6WAhaZmKR6bRHEXk3obCXAM8JBZhTfF4mJtwnJUZ	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	484	1193	323	6301	12463	jxCGvpvb1YuLQAez6zd7Wj6YQYyqWSswhQG5iVnCCLErZ4aHp4c	9395	13264	13264	1618326720000	orphaned
18649	3NKu87sC5N5kyyVr9DJKjuQgthqfXzwc5iGGJGkXrSH2i8L8PjMz	18647	3NKHM5yGVR89gZKGWFJTP83Qkxo8ytvAwbYgNDuwKFmrc2iH7BNK	563	1233	323	6301	12463	jxqxYrvo4MnuTMu5671GuaBpVQjDExMVQnChfJC9kttQeGuCSAj	9397	13267	13267	1618327260000	orphaned
18657	3NKatP6JgrkHx9J3mQCB1bM1gcZZduXmMkxM4taHncsieiMPXC3V	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1507	1034	323	6301	12463	jxoZXiw4htErrHs9zXii5LrTA85MJNMTLKaciGPfY23bMVEWrn6	9401	13273	13273	1618328340000	canonical
18661	3NK8uSt2mrjHyaL49Fk3x5vqEj5kUyxaDB1rf3gxpD5M3bU3jKkr	18660	3NLb9qTmQRehSkjx7YrvCGXD48sMUXETnh688WRhRJ9saBXJVNcQ	1445	1044	323	6301	12463	jy1M1qqrhaFYdaKHUKjafVgGgp2BzFvM9n24wXwY6NUwW3wqLkk	9403	13275	13275	1618328700000	canonical
18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	1460	572	323	6301	12463	jwPGXNfg98sm3E9j6P1MSBjktoXp7iezf6dhpXYrEYQrbmCZTTi	9407	13279	13279	1618329420000	canonical
18674	3NKTRvaBdzz67FC6tGzaYh5PTH8hKZDANYnUXNwboP9rSqGHY89a	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1547	1378	323	6301	12463	jwXic8F2nFREVMwaUpW1nhpyCnfDaGRwYgVoqpU2p35DjqoJx5N	9408	13280	13280	1618329600000	orphaned
18680	3NKzRV2R79LUUcYtod3n1Wf6FtsGRUnZnR5eXimYTAA8fVpGtgT3	18679	3NKpZ3Yky2jzgAffKEjXLJm2VtCPDU9ZycwqaTVpuScNZd2NPUeC	606	929	323	6301	12463	jwGkWA9hP36ZtDgBz58UYzKv5wcsMcQ15EyDh8atQsjir2jtAD9	9411	13287	13287	1618330860000	canonical
18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	149	1283	323	6301	12463	jwgttPrjBEbPjcqamNGsTWjD6jZcSeNcmK1QosK7hHh7TyK6Khc	9413	13290	13290	1618331400000	canonical
18692	3NKNzNcxx6vvsxi7BcqvC8CiGAJEnqHC4t7eQ7GzNx5TE5BcgcBK	18690	3NLpZiVf14Q6DZ41xSxt2o8JRe3nz9cS2rZi9kXQE5Na9eWCS2SC	1610	1314	324	6301	12463	jxafLkq5cHqQmC2WWjaFt8DXQrwo82GXyN7CRdQXdmwbH7TrcgH	9416	13293	13293	1618331940000	orphaned
18696	3NKhynAtsrAvorB8BCMX12C6QrowXbRV7U6w87pYGvgR32J1PRgL	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1651	1055	324	6301	12463	jxu4iXeXxETmqpGPoai5sip9cJo5Kq4QLqpAe5EXp9LpE5MoTs4	9418	13296	13296	1618332480000	orphaned
18709	3NL56KM7LjBRjq7v9L56E8yxuqh33ERMN438BVtSdQjArEMkFhs1	18708	3NK451GG4V8cL2r5EpMESoFavf5yX2fD3e2diJDqXEtnvtkwhc26	1594	1326	324	6301	12463	jxBhRNfnEDgar8MQA655giN2S1LNq66TRKkixBm5dLQB1mM9h7g	9425	13308	13308	1618334640000	canonical
18720	3NK5Zh1BhoHL5hKWq4K4sPJiG3niLsEMVbzbJq88UgGsudg3rMFq	18719	3NLwXBDvYCSkeB9QEVtpEfgpfG6RwB7m7Wmz3XUKoHEBaWkr2bTf	1406	1393	324	6301	12463	jxSEsUE6rJqyfyGgqfrn4p1jsjRk7seh2yp7Bu2k9n7EiWKetnx	9432	13319	13319	1618336620000	canonical
18722	3NLDqxM8RStEDcKAYtniWxC8Y2cfD6s5SwEufTBjXN8B4RLjPi5H	18720	3NK5Zh1BhoHL5hKWq4K4sPJiG3niLsEMVbzbJq88UgGsudg3rMFq	1631	794	324	6301	12463	jwXUmf1JD2vnBYhrPLkUCZCFEyuuDHvg4axXEGHLSaDak1oGKUb	9433	13320	13320	1618336800000	canonical
18725	3NLr7nTa6gDiiQ9dsBtr4H56ubfNSZQdqqGBcqA4Gkcb4kMSt975	18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	1406	1393	324	6301	12463	jwWFvZxV5jMCVBzEKJVQYChqGQbPPcqJekjtyM3NFAgbQjbkWGP	9435	13323	13323	1618337340000	orphaned
18727	3NLegSCm9Kru5Jd2T8dBouNtjmc2NwfPHznUDDW3va4gNGCdW7nV	18726	3NKnNPXWLhsN7RuLgLRH1NWxwivZUrmUe4any6rbAjSL6PA5y11e	1588	1266	324	6301	12463	jwabssKWPCMSc4U74x8Wdowrzt9ZvB59bwqpZQ1Q8Uv14zEaDSe	9436	13324	13324	1618337520000	canonical
18748	3NL222n1K5s68n46TCiC9GHcgEgff8WwsMoskKkHZtH71sFBZFHg	18727	3NLegSCm9Kru5Jd2T8dBouNtjmc2NwfPHznUDDW3va4gNGCdW7nV	1649	1017	324	6301	12463	jxYVx27FYL31Ghm3MKQNxryJj6wcZbHqqQEfW5XbK2Nbtnk4DuK	9437	13341	13341	1618340580000	orphaned
18732	3NLwL6cWZ2ykeWrMocqDTSBeREZawqRSEoQgSbDBvYBSdkCLdEwJ	18730	3NKDBgcXyLwC3Cc26SsKduNjjTWFtKEJ3eVP3vsaDeG9VTFDedPS	1406	1393	325	6301	12463	jxBQN8xB9u7m9PpZFsQdWoJM1fSxzpG2RZkvgeSzo9arXzEycgb	9439	13327	13327	1618338060000	canonical
18737	3NL1fUan6y48GHEasCkAug9jk6TCVvZqP46Vj9d2TcW8NgZGUAW9	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	1407	1395	325	6301	12463	jxX4qAyVWJtiVPPQSV9DUeH47SPXaVMTdc6rH98PZfUXxRkZoVN	9441	13332	13332	1618338960000	orphaned
18742	3NKCNwgeTP7rZU5rqyEQ2akwUhrzwHabBg8E3PmzjB2tUur18jsY	18741	3NKSADEG7gkfLAnYbqDC1Kov4ZjzkQigUWhgBYHQrJrs2wrNCq9B	1601	1142	325	6301	12463	jxaRwF8bWBnzm7bUvreNKZByocBB8hkaUvtUor1tBgFyuxbiz3m	9444	13336	13336	1618339680000	canonical
18750	3NLTwWQZPuQN84STfdZWjPFSiMnkcS8bdc7kYTfSomN75BTd6eAL	18749	3NKWNjWdt7W4SEQ2uMygocSZddkYDFsfRnw2Yx1oC2dKJm4d3HGS	369	1186	325	6301	12463	jx2yAt1pC97q255TGADx6Tr4m6YT1dUcohCRUjhd7WfDTuLyxaU	9450	13344	13344	1618341120000	canonical
18753	3NL8uKsRATMXa74vPgLJaky9rPXGYShNNuiukmrS91pcwhmrU6eZ	18752	3NLdoJeTb9oL7UWXHXRPGxuTaSFF9SieE7BUpxzLgdcADVHfQru8	1471	1260	325	6301	12463	jxgVa7h7Wm7PbA32SiKXDPWrei41Vbxts7tPurkr7DpWUYB9nmY	9453	13347	13347	1618341660000	orphaned
18755	3NLUMLtTGdQowi2pPLXNvnrBDc2HioZKAH4i4E7MGiYNNpT821xo	18754	3NLR227DJwDwSfCyRNEFT8w1u5UMAPhs3nw8u4uE9kRnawQC1J1Y	1594	1326	325	6301	12463	jxt64XDY7vUSRS7B1fUaGHupaJQuyEdhSCkJwSYefeynRHkdGRQ	9454	13348	13348	1618341840000	orphaned
18760	3NLH652q7JeT9C6T3ebVJoVeXe6YfpxpgSTxahPZ3zxHo7SJ5BcK	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	369	1066	325	6301	12463	jwA1AEHby2KZ7dNjmyVtbNFsKEDnRegBSuQvSMmcnCzSUPkM29U	9457	13351	13351	1618342380000	orphaned
21636	3NL3fhzCnq9gbYcT8D82V5r4Am9gEj8M8SATWk6nkFdwtBc9LzKr	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	1593	1346	395	12463	13829	jxwkBrAubgTNyN2Y1DQ3XymzQGJy1FEYbnkdjJYNYwmHZwYyb5H	10839	15258	15258	1618685640000	orphaned
18711	3NLs7aehCJ6N1yePgaudw6CWVqRyskR6PQnTZn7dhhbmh1rgv9CK	18536	3NKosuVXs2mY6zm28DubDqdyJpYHArfFW4tAZziAMF1JP187rUbd	1634	1205	318	6301	12463	jxsNq9UQav6erpv9TXt45wtxshMtqR9hD5KEFyNCgxLC79jnAZ7	9300	13312	13312	1618335360000	orphaned
18681	3NL3xCF6VsWKAnXZnco5TxVi5H83YH4b5by6M7jMbJ5daBsQQ8jN	18601	3NKws9cfr4rdHnnEBAoToRr1FGMd24WXjL7ZerLBRXMDyWmPbfUz	606	929	322	6301	12463	jwJvV1kYaB5nv4MVRk12LGC1gkPrmYKc64NHJposXo7fGyb3cSK	9372	13287	13287	1618330860000	orphaned
18623	3NLrtZAQZ1DgMHRQFNPygoTu9EFKpbq4v15GAh9nGToTKQ94xrwx	18622	3NKh1Yzp71CF64phcQ7HkQZhRRbb3iXXkHDCwWjux5TeekTQjbW1	1463	464	322	6301	12463	jwDUwBnL2mThHzfaBoifSes8BgwN1L2grYSFBeYBEbxJrCHJFoF	9384	13245	13245	1618323300000	orphaned
18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	1581	778	322	6301	12463	jxv6M5DS1P6WS6Pog7KSAXiES1sAbbMuvux1BrL6toKV6LvCH2N	9387	13250	13250	1618324200000	canonical
18631	3NKMSvs41b17zHZRjgffVSqbUKaNHY1ycT8uTnYyygK5F5wUigdz	18628	3NLow9T7b6JGUrLe35LG1QaTCBALCG5C6TYQxECsHhk5yd1RTXCQ	1490	1148	322	6301	12463	jwvcjqyryTAJdXfLa85qTUUCxeT1a6uVq3nK6yDmFJxbYkAHFYS	9388	13252	13252	1618324560000	orphaned
18633	3NKCNJN4JGX5GfNufgrkWv8EGBB8zxVinwYDTtkPvuT1b5PXaQnA	18630	3NLG8sRhebaHo6cCUMUKPnQTJmiybDYJhWT3rZxXUnfNKqUYEF9i	576	989	322	6301	12463	jwMTbfhkbD7WuA26KVEKUmsQ7E4RvYQFaGUTjBf8sDdfbBU6TTw	9389	13254	13254	1618324920000	canonical
18635	3NLJM3526cWLFoLjc5jx4BC4BuezoECeR44fQ1F7ocNDLojXWwss	18633	3NKCNJN4JGX5GfNufgrkWv8EGBB8zxVinwYDTtkPvuT1b5PXaQnA	1407	1395	322	6301	12463	jwreos6EKp8Qz4xGBrhup15DBvChGwa77eYhPTw1L1YCtfr3gEA	9390	13256	13256	1618325280000	canonical
18641	3NKvYXh94LCKSRZtUBmwiawnFxaLkc9pHYq8nNLh5P1Ar9yhB9Ay	18639	3NKkohzw8dpjv4G7KqdYTSsZkpHNCz5pLUKAs5EsVc6jaM2tz3Z9	1650	1249	323	6301	12463	jxLshPHg8BTeVgxnNZiiKy9jqVWfJUQgApJnoGRztGioyLnkyGZ	9394	13263	13263	1618326540000	orphaned
18650	3NLfzSxvjFGcKcrZ6SprdqEEvmvSSgNd35wh6qzVDooX5g7wpgmt	18648	3NKNXvTgf22TeaWocALw5moEJa3yka8YZnxgW3bwJGS6UZiEUJUh	563	1233	323	6301	12463	jxP3KrLpoQGGiwu2D2Caowv52H6kzhJ5AMSGXEwT1vLeXitUNxw	9397	13267	13267	1618327260000	canonical
18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	18652	3NKx5DWBkmBi5ejktTsvD5TE7d451ZPy7zFc6Ho9KghWDCDvWQuK	42	42	323	6301	12463	jxHa1QjpJtBvdPQwXfTb3AdVXs38TiuyyNAMTAR4eBDuD8V963V	9400	13271	13271	1618327980000	canonical
18656	3NLf7kKv8FVtX2nKYLqsB6tkVWVY1zoALL1aaiQLiPjW8n5w2Gwq	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1594	960	323	6301	12463	jxkN1RQjv3AF82hi8SzshhZQnuDgPWWfN84EmwQifF3o4pteggf	9401	13273	13273	1618328340000	orphaned
18659	3NLSaQe5bFyxF6KKCNEwKsU932UsTBLeN13XReUqBKYmFcwhKyiR	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1581	778	323	6301	12463	jwfTCL7CJRe4TFq4jy46sYVZUWzc6cwmVWkDuEvALbJcfbdqArE	9401	13273	13273	1618328340000	orphaned
18662	3NLgf4ZZwr7Qf8875snWQ66GLtvukFuNMqWbceZtiZxnSGEYhwnB	18661	3NK8uSt2mrjHyaL49Fk3x5vqEj5kUyxaDB1rf3gxpD5M3bU3jKkr	1406	1393	323	6301	12463	jxFR2EpRbbrYJGBeDRb12oQYARH9rk7icsDwA6aEfJ8p2exvS7k	9404	13276	13276	1618328880000	canonical
18667	3NKpJfbxiRhGurtSMorwHfPJViGfG8idDA7KfYpHJDW8LRMacCpN	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	576	1355	323	6301	12463	jxUNQoEVxm5QhsCreLvtT1DnVh2cYNvzcnZrNzfN69zgUNCP2DK	9406	13278	13278	1618329240000	orphaned
18675	3NK3oAFSJ7BcQMUhFPHw4V3mLtL4uZ2UtnLcSXtRVbfnJi6UWJJt	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1637	816	323	6301	12463	jxPKsNnCvYTRfojFu2Rpk1Kd3De3q8vdkLWZdL9w3xCywSXkJRM	9408	13280	13280	1618329600000	canonical
18677	3NKxLDXkgLB6ykRc4x6NBqDxrdLwUZaUFgGr5XMM71gQc3rAxtur	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1547	1378	323	6301	12463	jwFwoav1hUzhScDLsUJWAGFDAbK8ABpku1AjaAZf8VsffkprUpY	9408	13280	13280	1618329600000	orphaned
18699	3NLRpjwc3HYceoa14eJpHPLPSSkBhJ6B318c3523DjJ8kvFW6YJe	18678	3NKwzdyPGThX5YjA3vWQD3hK9UNJZqous2sD4UNJXadsFHdottNB	1476	1125	323	6301	12463	jy2LmenXotgXiBCpdKyGfjAFTy5YR1BMu7evo6ytNgjXazBNfZf	9410	13296	13296	1618332480000	orphaned
18684	3NK51uodosEXMKBkSUVy7YHFe2JZnnRz2eXNwBCLNunrd7dmgFnk	18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	1560	1291	323	6301	12463	jxKvnqdEYdDAASo2rfLFB1us3tYGKHEiyHbxuhGvpET4YwiTN1D	9413	13290	13290	1618331400000	orphaned
18689	3NKoGY4vxS1hitQhM6ouPL1uPMzkhEfoGdLk1CjnbrV7PsZbKsxX	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	80	1027	323	6301	12463	jwvnoZaUqUCbePiS9smgjAHuXHNPaWaqfk3b54ejmbd3NhpKmjR	9414	13291	13291	1618331580000	canonical
18686	3NLTKW2MDeNHMCzXXLhBVtYPYNed12nibDAJJUq5pLDpVyoR3CoJ	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	80	1027	323	6301	12463	jwSCMuXdMLgSc48Kc3QHqGxPq4VrQwK8GPCAsU2GL3hGQJBLWzv	9414	13291	13291	1618331580000	orphaned
18690	3NLpZiVf14Q6DZ41xSxt2o8JRe3nz9cS2rZi9kXQE5Na9eWCS2SC	18689	3NKoGY4vxS1hitQhM6ouPL1uPMzkhEfoGdLk1CjnbrV7PsZbKsxX	1460	496	323	6301	12463	jxhugE72JwMnaoFs9NQurfDZHycUF7HdtsRxcupA3DKeHAyEPBe	9415	13292	13292	1618331760000	canonical
18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	18691	3NLj9JttBHRCmhtFrAK3LpRQ7jjHwxiKJ2QV9Ch4FAPEozLNsFWb	1656	1343	324	6301	12463	jx1z2rWCZ3uWCD3boHJbueTtskmK572umm2gprWcAX3zbfoRRcf	9417	13295	13295	1618332300000	canonical
18695	3NKyxTG9NjkkhakgqJ2imobM6fKyRFuehfP4MjpitxpW3WZVNbRt	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1563	66	324	6301	12463	jxDxYYXcaLMyteF3jszGG8HQJivT8jdZ9uppAoJZ4Ac66bEN4ss	9418	13296	13296	1618332480000	orphaned
18697	3NL4k3VKQJHqg5BcGDdBrP9e63jGrhseCm5hCfECcDxWJD62hLzD	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1651	1055	324	6301	12463	jxtXtBEw2KWFtHyMsEeBPXnSfkATBD9CZnQYsKroMXadi7MqMS1	9418	13296	13296	1618332480000	orphaned
18702	3NK3v655QRabdtZj31FMUrNPhaT1oetqan5kYE5jzS9bhZZoh4Yz	18701	3NKQwQARXZXPH2U3Nd7kCMHkmJtDbNkN8w5spPsDPubnEJwkp8uQ	1481	790	324	6301	12463	jwnGXTSvGZzrhAMwEDBaxBCbHtweZM4PAfr3SoH1qaCJgvnnxwT	9420	13300	13300	1618333200000	canonical
18708	3NK451GG4V8cL2r5EpMESoFavf5yX2fD3e2diJDqXEtnvtkwhc26	18707	3NLoy2m8XiFsMKUfBC9pdpTM1sKBgUya7XateXh6N9nt1numrf4a	1637	816	324	6301	12463	jwkkrB7F2D3kKBK9oHdH4BaTv52ps6ALmbWRVy2QUmTKAa3WeSw	9424	13307	13307	1618334460000	canonical
18716	3NLUTTJpqkJtroLWzSTB2T4ipVAjoFwPirVFVA7ZCHGhnC5yS1GF	18715	3NLJ2gzStBDTacd5NZAWwtNuUxmBUJU11GB9pN5WeYNbuhzao34c	1403	823	324	6301	12463	jw6eXmEH5ygFjKaswCaH57LUXDuh27d1C8w9fGQwLnVHtg6J9Ev	9429	13315	13315	1618335900000	canonical
18718	3NKYhnDca6EHV8wP79PZYodiux4sbtPJGE9HdT5RPNYZeusJ1VKC	18716	3NLUTTJpqkJtroLWzSTB2T4ipVAjoFwPirVFVA7ZCHGhnC5yS1GF	1407	1395	324	6301	12463	jxsPze7hSqzXFqhr1qsXPNVgPvJ3krKGrD44rPtHHWtBme3XL8L	9430	13316	13316	1618336080000	canonical
18721	3NKPRjEic1R7uVTAHZQ1MvoeuCZnLdNv4r4HPrEAqaHa5N4wicFw	18720	3NK5Zh1BhoHL5hKWq4K4sPJiG3niLsEMVbzbJq88UgGsudg3rMFq	1513	1379	324	6301	12463	jxWswNAYVuGirSYHWf2qMGZF15cwKCiVZ4JUXpR8wN1yDFyr1i6	9433	13320	13320	1618336800000	orphaned
21652	3NKxYsiAeNcTwfHporD6giUTPuGdxkLzG6YvoFFGVaqhaY9SHDmn	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1609	1333	396	12463	13841	jwhgbdiXTwE4hXoAX7mmRVBUNAPk6KMBrt12RGnSumXGn5CqAsZ	10846	15267	15267	1618687260000	orphaned
18627	3NKDExz1HRME7UxvNktr46xjLe699TRHXW29CtWnnenDgqMAyVUZ	18626	3NLHRzvCixmGFEB3asW5H8sW8hCHxRDAyBx49487SXTirenwwJA9	1406	1393	322	6301	12463	jw8BVaEgGGRvUrTwsWncdNZFyRfF7wjSfxTGxkxUa7tvUB7dkNL	9387	13250	13250	1618324200000	orphaned
18636	3NLQgcNqgjD3EhZz7qWSdoATkWpk9U16qxeRRBznHH6EiDhzejK4	18635	3NLJM3526cWLFoLjc5jx4BC4BuezoECeR44fQ1F7ocNDLojXWwss	1403	823	322	6301	12463	jxo7cAM77xk14tHnsrLUeXoC52Jzv5kVuFX1zTdjVphCtiiZ6jo	9391	13257	13257	1618325460000	canonical
18639	3NKkohzw8dpjv4G7KqdYTSsZkpHNCz5pLUKAs5EsVc6jaM2tz3Z9	18637	3NL2PMJ3PHFD6cdQaxi89txoC8NfQuKbXRFsZV55FRMVYTxtCoCT	1407	1395	323	6301	12463	jx7muko8iPaKghZLY62C5KnfXBLFMx5YTehr8WHkD367D9psf6X	9393	13261	13261	1618326180000	canonical
18638	3NLKjr6wze5Uu52q9K2WGiS8YDEexbeH34yeYu9PDU6B2F56ZVvo	18637	3NL2PMJ3PHFD6cdQaxi89txoC8NfQuKbXRFsZV55FRMVYTxtCoCT	1571	1335	323	6301	12463	jwoFDuebYEQzf21aHyPjmFXkFZqWHQd2jkWEeL1hdXj5bJoHZuY	9393	13261	13261	1618326180000	orphaned
18643	3NKTCNeC4neXpLxWT5CmUJzcvDP7s4VzH35dY8rZYAnMGQnUyuuZ	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1509	1194	323	6301	12463	jxpxb8AhhU8e124Ug8BX7KpgNWiN5cRine9LAJWisf4mth2kY3D	9395	13264	13264	1618326720000	orphaned
18648	3NKNXvTgf22TeaWocALw5moEJa3yka8YZnxgW3bwJGS6UZiEUJUh	18645	3NLLAdjTQiBTrYrkufw8xEkrWhibw3Y35hFgtPuaaC91XyxpkB5L	1590	1054	323	6301	12463	jxtVCxHAFEnzGTwTe4Sn7ct5zk6GC2qgAwSEuRzt5LEvbH7rqQs	9396	13266	13266	1618327080000	canonical
18654	3NLuj8K2fBwMfWhhuvPhKSU4UjTMeDcXC6oi6VSMBMnZQeAetibr	18652	3NKx5DWBkmBi5ejktTsvD5TE7d451ZPy7zFc6Ho9KghWDCDvWQuK	1579	1023	323	6301	12463	jwGkivpaFACuf34iFgCzPJbVkU42rKyzRrps2d477srtRvX2LYA	9400	13271	13271	1618327980000	orphaned
18660	3NLb9qTmQRehSkjx7YrvCGXD48sMUXETnh688WRhRJ9saBXJVNcQ	18657	3NKatP6JgrkHx9J3mQCB1bM1gcZZduXmMkxM4taHncsieiMPXC3V	1650	1129	323	6301	12463	jwfoyDDRyjxhkxYte8ZPTnvzUN1SmonHG8BvdUiUT5XphUH5dze	9402	13274	13274	1618328520000	canonical
18665	3NL8VzYoiXrRh5Umm6ytuNSZAuDJywnG5zdFbBQtTgwKxUTx2ysQ	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	1547	1012	323	6301	12463	jxc94ufCXm8RaJF93Kmy6kj2PsSSz1cb32oN14P4xommrq6iVqw	9406	13278	13278	1618329240000	orphaned
18672	3NLQ5M8JeeAF7tDG71uLDNgFa23AutpbS13LmB4iTqWjPVpxRJ6A	18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	448	939	323	6301	12463	jwx9XY9gAM4nSSJNL4ntqY8S8MrXsQUCXcDrQ5mPxYUDgTVNNdN	9407	13279	13279	1618329420000	orphaned
18676	3NLmwhHovUSF9m4GZoMnQFg3QzHhdtR57nHcwvAkvL4YMfCmBbsQ	18670	3NLbhg9mnLXRMuBPRWv8eNAV6KcwvuVfdsoA1XTL17iePCjyH3AY	1407	1395	323	6301	12463	jx3N8VJ1JHBW5u4CckaReMKjFdoeoeR6sN6bwFkrduEGyZLtnfA	9408	13280	13280	1618329600000	orphaned
18678	3NKwzdyPGThX5YjA3vWQD3hK9UNJZqous2sD4UNJXadsFHdottNB	18675	3NK3oAFSJ7BcQMUhFPHw4V3mLtL4uZ2UtnLcSXtRVbfnJi6UWJJt	448	1179	323	6301	12463	jwREKDLVSf6HeZHrh4sUyRW9XTHr857E3MEj9c3bTgwXtMByqNQ	9409	13281	13281	1618329780000	canonical
18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	18680	3NKzRV2R79LUUcYtod3n1Wf6FtsGRUnZnR5eXimYTAA8fVpGtgT3	1407	1395	323	6301	12463	jw7xX9gsFX9UZnNPXpHUhCoYjsJJ5V6AXS676xidF681ojvenE3	9412	13289	13289	1618331220000	canonical
18687	3NKeiaR2vgoecdn2hHxKDHhtieZYef9bn33jtmPLpJyY5zpQdvWP	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	43	1310	323	6301	12463	jwrVKy51EK1fD4kgY2xuLMvcp9e2jfoFkHyHoEY64Gck7VeDGD7	9414	13291	13291	1618331580000	orphaned
18691	3NLj9JttBHRCmhtFrAK3LpRQ7jjHwxiKJ2QV9Ch4FAPEozLNsFWb	18690	3NLpZiVf14Q6DZ41xSxt2o8JRe3nz9cS2rZi9kXQE5Na9eWCS2SC	1610	1314	323	6301	12463	jwNdVatdRfJTBxz71iUJEFYDsVbu6aqzjvYEVhmAMhq1A2ZViDF	9416	13293	13293	1618331940000	canonical
18694	3NL2dMZyFfuMPw2rSN2g9cAwg2PtCmMUza13ui4fQGb4idMK4m46	18691	3NLj9JttBHRCmhtFrAK3LpRQ7jjHwxiKJ2QV9Ch4FAPEozLNsFWb	1656	1343	324	6301	12463	jx1z2rWCZ3uWCD3boHJbueTtskmK572umm2gprWcAX3zbfoRRcf	9417	13295	13295	1618332300000	orphaned
18698	3NK3yAEA94nLZETV2jW3Suyw1VbhScJ4ZSEFbp2eZypSfZAeSwDY	18693	3NK7PnKM3wZ5K6LuvoQqpH1NMeHonWuad9GA2JyJQ2r9CjSTFuok	1476	1125	324	6301	12463	jw9xDusH3K4qzCmstA58vLjauw46eb4zLBpQaUe7BqjiZ9DPDFV	9418	13296	13296	1618332480000	canonical
18700	3NK58CfE7ZUVH8nXQvpGuPiwycs66sMTMBkZdPYKXBzTyko4LWqi	18698	3NK3yAEA94nLZETV2jW3Suyw1VbhScJ4ZSEFbp2eZypSfZAeSwDY	1444	1381	324	6301	12463	jx8MhcZ9koTnCvMqEkASGJtHqDS7D7J3nT39QVctmr4foG5i2cR	9419	13298	13298	1618332840000	orphaned
18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	18702	3NK3v655QRabdtZj31FMUrNPhaT1oetqan5kYE5jzS9bhZZoh4Yz	1596	1363	324	6301	12463	jwhvaSuRF8ZkrxwZcLEwdJ96BtAcm81h248aKb3nUNim7DeaNS2	9421	13301	13301	1618333380000	canonical
18705	3NLXJ6bmqnA5N5euQRQ5oVdAEpSYfWCGWGSuP1euZKx56dkSUrD1	18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	1490	1274	324	6301	12463	jwi9i6r4Rg2mQs69GQ6LHnzQN8Kj2pGccgGyd81jrKiXDPjjNAq	9422	13302	13302	1618333560000	orphaned
18712	3NLXyY6B7p5LuMszkDTikftw3ME4uemVuzFziLNhvgrLQEEvnGgP	18709	3NL56KM7LjBRjq7v9L56E8yxuqh33ERMN438BVtSdQjArEMkFhs1	1610	1314	324	6301	12463	jwEgUHZnc93ktYBJ6abdpiEUCt78rHPnbAwZReZaaA5KC76G3JB	9426	13312	13312	1618335360000	canonical
18714	3NLgYTjJcXJksuG44RJfwCLinsGRCVL7jQYffghpqw21Acet7nCj	18712	3NLXyY6B7p5LuMszkDTikftw3ME4uemVuzFziLNhvgrLQEEvnGgP	1590	934	324	6301	12463	jxmnHP8ed5iYyXyMeN3dG3uW3hgxo12zKxn9jGABQ94jiaKyUGA	9427	13313	13313	1618335540000	canonical
18717	3NLmW7gTbqpP3yAEqD9GJpwEHMKsD4eYLUnwZc3eN86CmrTy4G8U	18715	3NLJ2gzStBDTacd5NZAWwtNuUxmBUJU11GB9pN5WeYNbuhzao34c	1534	1317	324	6301	12463	jwgXv6JESYcvkZf8qGmiib3KiqDzEcuKkYTo8udqh8HRpgg1mWm	9429	13315	13315	1618335900000	orphaned
18719	3NLwXBDvYCSkeB9QEVtpEfgpfG6RwB7m7Wmz3XUKoHEBaWkr2bTf	18718	3NKYhnDca6EHV8wP79PZYodiux4sbtPJGE9HdT5RPNYZeusJ1VKC	1522	1196	324	6301	12463	jwB8fqFFG3WLZ3VvjuVg213RKNHVUcJe5Rbx5hQLrPwJxxjT2QJ	9431	13318	13318	1618336440000	canonical
18729	3NKi8H9ZHPMfHS6YRGnhpAxZUEWGukqcUETeQTMZjj9YSyJG9U6H	18727	3NLegSCm9Kru5Jd2T8dBouNtjmc2NwfPHznUDDW3va4gNGCdW7nV	1406	1393	324	6301	12463	jwc7aUXaVs36cdjM79ENERvpAojPNrZ5ENGADLGuy8X13yvvVdE	9437	13325	13325	1618337700000	canonical
18735	3NLrKpMqBSdsuKjuexRZA9v4BJ5paBCjvRTveKntAa1GxT13stK1	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	298	1182	325	6301	12463	jwXnwcishGt58YWaWVyTMq3T3NncQ5aeS9YGtZ55eddV6mTTbKg	9441	13332	13332	1618338960000	orphaned
18740	3NLmAnu2WYWH9T6FGGCVUpHUNpncnEG7cZaP6entjnu4nmcm243X	18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	606	929	325	6301	12463	jwtD6Forv5CWaUbp5LWBYgr8SEsQdNrNFz5SHzby6nQazuuU7Rw	9442	13333	13333	1618339140000	orphaned
18744	3NKYX8SLYNq28d1ApfTksSDh2Bv1GCv87UifWVw9Kngti2vKKMNm	18742	3NKCNwgeTP7rZU5rqyEQ2akwUhrzwHabBg8E3PmzjB2tUur18jsY	1564	1338	325	6301	12463	jxE6ikgP1fvNVBnsMS4KDrcdE7a9bR9QSEgT8Dt22qG8sTDxY1G	9445	13337	13337	1618339860000	canonical
18747	3NLLwA3Yt9oKq5MHpSkZHypFWht76PsQbYmrUTKvVxq1QRMXmLJb	18746	3NLpZJVHyGpMH4LEZ3ytnJC8fCqwaYgWowesWHDkh6R1yfSz8DQ8	1649	1017	325	6301	12463	jxUoxDwyvrNyyk6tSjneKvSMY6kfghg2L5ZNFBcmYXTHx8nCQs1	9448	13341	13341	1618340580000	canonical
21648	3NKUcCuBMmuEpXSK9AnTpf5Hudo8HjAgoDxtb8Ssfs1P2hjw64CC	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1407	1395	396	12463	13838	jxtJ6SywpnruCLS73CLeu6J1BcojuMarNxVVQifh4ZEFxLXSNZa	10846	15267	15267	1618687260000	orphaned
18647	3NKHM5yGVR89gZKGWFJTP83Qkxo8ytvAwbYgNDuwKFmrc2iH7BNK	18645	3NLLAdjTQiBTrYrkufw8xEkrWhibw3Y35hFgtPuaaC91XyxpkB5L	1476	1371	323	6301	12463	jwkNwZiqq65149rtMpckiJGKRegiNBMueyvN9W14yKyWvfRctzy	9396	13266	13266	1618327080000	orphaned
18652	3NKx5DWBkmBi5ejktTsvD5TE7d451ZPy7zFc6Ho9KghWDCDvWQuK	18651	3NLC1TE3iKM4xocgNxpUgkLB8bSkzk23CZsFpNPqre7nko6EUyTS	1406	1393	323	6301	12463	jxrFbBYVfys3XUFt4PeWsxSP6R2Bhc6hCBnYqaoZKo6jZ1iCrQX	9399	13269	13269	1618327620000	canonical
18655	3NLnQyQtRdZ8oaFstG9AfGzfASj9aLYAS3KM97qwVWvGDu1QkFPA	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1668	1370	323	6301	12463	jxYDEMxaAwxGjaKRwZPEz57xyz5FVscrqLpqhXsmmcYkY6a2Vjq	9401	13273	13273	1618328340000	orphaned
18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	18662	3NLgf4ZZwr7Qf8875snWQ66GLtvukFuNMqWbceZtiZxnSGEYhwnB	1397	838	323	6301	12463	jwUxtQBsz5y3tN3Px6s596nVTpk7nMZNbdRFGeMQUSiwA7ffZvz	9405	13277	13277	1618329060000	canonical
18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	1403	782	323	6301	12463	jxANWjJ6QbNUd7bot33TbMjEQBuF85iVcukiYNTzKP3BYJtehvu	9406	13278	13278	1618329240000	canonical
18668	3NLQzRwu8YeiZHRLxt9ysRT6RpMoQRYkcaxYC453iZW38Aa1Batc	18664	3NLMsCT3pD2dqKtDbEvx4cPgWecEXbsBFmVYtqWyF5YKLH2UDJkE	1581	778	323	6301	12463	jxawSe9o4FzQScVJcy5Trc8tA4fqGx2S6T88tERRkbSLLu8gJeR	9406	13278	13278	1618329240000	orphaned
18671	3NKSf7yuwn7kRj3rnf4oZrDeqjYs7j4UQyQAX3fqUkXm6bmKgbjp	18666	3NL62MANJJdBVGqhWZRz6qMaFPYbRv3jqv5PjEJpXMLwB4Z3UZXx	1506	1373	323	6301	12463	jwqMeXJvwYjFA2DcBDfSpwJzJiCdvzR7JL9fS9DFnBYsKFyxciB	9407	13279	13279	1618329420000	orphaned
18679	3NKpZ3Yky2jzgAffKEjXLJm2VtCPDU9ZycwqaTVpuScNZd2NPUeC	18678	3NKwzdyPGThX5YjA3vWQD3hK9UNJZqous2sD4UNJXadsFHdottNB	1403	824	323	6301	12463	jwtQ8geU94RHNWbh3sm2LBahLRwjcKBwitp8xvUvVKTBKWzyXZT	9410	13282	13282	1618329960000	canonical
18683	3NLt3FvzMcoHgXvE59pzoWgcN1gtgUEWMdjLZVRiZxziS6FJT3HK	18682	3NKiC2ZGkyUg1Joxkf21SEZSdHWLaXLqH5j7Rxf7yJt27AzhUDqs	1560	1291	323	6301	12463	jxzBTmBhqtXc4mgh77rMM6zjuofZ4GLTACMhqvppqCbv2NmV55H	9413	13290	13290	1618331400000	orphaned
18688	3NLAVif7V963x921KP11dzFWdRGPJ4AwdV7vLF9YKx4Da3vuety9	18685	3NKjZX6aTVDrc1wtrvKnYiBTqQxK9PDvneEcnUG4SoBYyA7QjaeT	43	1310	323	6301	12463	jxXBxtn5K44rgG1PJpfVLADaagrp93b5y7k5hoD39GqjBgKF5su	9414	13291	13291	1618331580000	orphaned
18701	3NKQwQARXZXPH2U3Nd7kCMHkmJtDbNkN8w5spPsDPubnEJwkp8uQ	18698	3NK3yAEA94nLZETV2jW3Suyw1VbhScJ4ZSEFbp2eZypSfZAeSwDY	1403	824	324	6301	12463	jwzTE2XcVopKPR6LtL6GQ173ZSvyCkiswg2UKYdsHSfeWZW1qbc	9419	13298	13298	1618332840000	canonical
18706	3NKggiEDbJYN1WGhLHXzdvhETiRamD6wauYCnMZxs7Rgmp8ywoaB	18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	1407	1395	324	6301	12463	jxzwA7zpRG9qNAFifz8mwdKsYzCWkNVVFmffFvA2giHF9eVaXh5	9422	13302	13302	1618333560000	canonical
18704	3NLVN68wQpSysCk9SYS9UabZyCPy6yoh9gpmyF9YdsR5F7V3V3as	18703	3NLHDMExrRapsgx28K44m2A9NoiqeiZ3TeBsjXVcuczfXukZuvTR	1500	1297	324	6301	12463	jxoT6EcPkFweAaD3fE1kgNb9Vc9tWXpEDnRAqUMvVJ5L8D2vnoQ	9422	13302	13302	1618333560000	orphaned
18707	3NLoy2m8XiFsMKUfBC9pdpTM1sKBgUya7XateXh6N9nt1numrf4a	18706	3NKggiEDbJYN1WGhLHXzdvhETiRamD6wauYCnMZxs7Rgmp8ywoaB	1587	991	324	6301	12463	jxxCH38beni27VT3eiWEjeSPBpFk2BWR9mxFHug3PFZh1wVzUS2	9423	13305	13305	1618334100000	canonical
18710	3NK8YRu4TfTFUUdcoktJxKWfxwbRmHqPnJDq6j7KHJCnMQZPBuek	18708	3NK451GG4V8cL2r5EpMESoFavf5yX2fD3e2diJDqXEtnvtkwhc26	448	939	324	6301	12463	jxVAS6gnyET2KYW1LojHemTVZZYaWLz6V5dZiBTvTWwco4Dr2p6	9425	13308	13308	1618334640000	orphaned
18713	3NLbpfcfXMyWrj7ZMGh3LU6srH4hEBJDUx9G4HKucxzFSrXgbQ5H	18709	3NL56KM7LjBRjq7v9L56E8yxuqh33ERMN438BVtSdQjArEMkFhs1	1460	496	324	6301	12463	jx7DkBXtRzSaL23gzi8c8Wdir9cPiaEu4Hnxufnj4hQp6Em6VtH	9426	13312	13312	1618335360000	orphaned
18715	3NLJ2gzStBDTacd5NZAWwtNuUxmBUJU11GB9pN5WeYNbuhzao34c	18714	3NLgYTjJcXJksuG44RJfwCLinsGRCVL7jQYffghpqw21Acet7nCj	1623	829	324	6301	12463	jxM7rMQXyuZnBNFEbkWB7o1tEjEB3aNme9F8xzYw6XgCZyj2ZBt	9428	13314	13314	1618335720000	canonical
18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	18722	3NLDqxM8RStEDcKAYtniWxC8Y2cfD6s5SwEufTBjXN8B4RLjPi5H	1559	1107	324	6301	12463	jx4DyGS5A8gFQxovMxp1QFpBywSQiwCGgDnTQQdZxMuw2aFa6YE	9434	13322	13322	1618337160000	canonical
18726	3NKnNPXWLhsN7RuLgLRH1NWxwivZUrmUe4any6rbAjSL6PA5y11e	18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	448	939	324	6301	12463	jxTXaKhjUM39eJj6FApw3LXsq62M9uERnfmZ12mpbr7ie2gwjem	9435	13323	13323	1618337340000	canonical
18724	3NLwTqak28Y1uYivpqC8Q7fRgKwMfZVSodE38uMZoBdGrd1K3yuG	18723	3NLBpNmJdnEJvn5WXttJ8fmufP1VZnbe4rvRfUuBnh1Aujtx1WLr	1671	1119	324	6301	12463	jxvr6wamunSS54bFZtHtxHeP3wFnXgVuLEoEu2ZNemtced8UKKe	9435	13323	13323	1618337340000	orphaned
18728	3NLefpUg4W79bgCJ7tuQZSfDiKaLf5xZWtz54FKauDoA2fAkr6s2	18726	3NKnNPXWLhsN7RuLgLRH1NWxwivZUrmUe4any6rbAjSL6PA5y11e	1460	612	324	6301	12463	jwqhWT2cCyuyTzpkMykGfwcdPomq9JoWkGirsLzDYErs5XUs668	9436	13324	13324	1618337520000	orphaned
18730	3NKDBgcXyLwC3Cc26SsKduNjjTWFtKEJ3eVP3vsaDeG9VTFDedPS	18729	3NKi8H9ZHPMfHS6YRGnhpAxZUEWGukqcUETeQTMZjj9YSyJG9U6H	1457	1391	324	6301	12463	jwUPqD4PeuoNbyXDBAtE86YzsqeBMUs9zpufQbbEZDwGK4z7N3u	9438	13326	13326	1618337880000	canonical
18731	3NL3NbdTWu9ALzAWnb1f58KB9VPoKaowg25g1qEyp5midNaA2voV	18730	3NKDBgcXyLwC3Cc26SsKduNjjTWFtKEJ3eVP3vsaDeG9VTFDedPS	1588	1392	325	6301	12463	jwW2xjbYLYnhu1g4hVs8LY1fLVAemSNazvTSFoFwbn69xwtu4NX	9439	13327	13327	1618338060000	orphaned
18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	18732	3NLwL6cWZ2ykeWrMocqDTSBeREZawqRSEoQgSbDBvYBSdkCLdEwJ	1593	1346	325	6301	12463	jxYF8aeejfEQ4H6UQRkzmh4nrCq9fDaLMKBA12nkRuR4dEXr3yH	9440	13329	13329	1618338420000	canonical
18734	3NLLGn6xeCGcMHcGbALnv34vpGY48LN6PxUcyfFyCPVWQ4Tkv6PJ	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	298	1182	325	6301	12463	jy3HUiprc6JtxdB1wkemBEMQk8krbVwmyn35qBN5EFhJRr959UQ	9441	13332	13332	1618338960000	orphaned
18738	3NLmdyMeiAq13GC7Yd3nKWo9o9zjop4F1wLfeBrBzNBvFR4k7HXr	18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	1509	954	325	6301	12463	jwE8GcbEcsuQRHhEYsuauqvBsWEq9hn7usc9VVLbvRnic2mXEu5	9442	13333	13333	1618339140000	canonical
18743	3NL4nFjeY8WKS8yootdhRCJGduGg3taQMJKFXzxDfLCHDeuEwJqd	18741	3NKSADEG7gkfLAnYbqDC1Kov4ZjzkQigUWhgBYHQrJrs2wrNCq9B	171	1374	325	6301	12463	jw9UqXTVCr6LGFfaY5CEWHTtuUcsABQJQ5cSSMVJ95SJG5QoMc4	9444	13336	13336	1618339680000	orphaned
18745	3NKKjfTepE7m2AR8veekCnQ7vu3qHx4VWyeiWZhdQURX2FdsCQnh	18744	3NKYX8SLYNq28d1ApfTksSDh2Bv1GCv87UifWVw9Kngti2vKKMNm	1509	1194	325	6301	12463	jwFMhF6HWjaBq8wusMFsfRpYeSgY3QP5qKCbiArpyz4KoKCNwGs	9446	13338	13338	1618340040000	canonical
18751	3NKZeHGuswJdMdAuPBNJTT3ydVwcPjzP9MvGibh9Kvi2bs8zP3WS	18750	3NLTwWQZPuQN84STfdZWjPFSiMnkcS8bdc7kYTfSomN75BTd6eAL	1589	1286	325	6301	12463	jwUvKtVfiHynNW1h5RQ7e2KcVjVFUAdj5RBZvByjejLuQSBu4cW	9451	13345	13345	1618341300000	canonical
21686	3NKu7Rewu6akGuCCTYjdcxKTRfcn6FuKEcPRNgy3BAEtSu7HUHfp	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jw8VNRnqNfUCAv4dFMBGJ5RAbNnccPcfjAH9ZGrC68eERM6WBaY	10863	15287	15287	1618690860000	orphaned
18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	18733	3NLqRjcH5GY5ei9VjZ5Jb12ruGGKfo7ppQbcsJcvBrQRTtMAYrUK	1601	1142	325	6301	12463	jxsertgnSvLro4BbiqfX8PAyzqDGgjR2Lz7oSXGwrQa4efaCsx5	9441	13332	13332	1618338960000	canonical
18739	3NLsfiD8pQw8qF8u2K283tUnvTUwXApoNKdYqtGxo6Rd4oc3PXFB	18736	3NKndBztBHJ52K1jCmmcffprmzGLMLnL5FzQ2Nf7DFvRJ4iZJuUX	606	929	325	6301	12463	jwDvCcjCCBMSyd24txVdD9WAL4z4RDvEr38g9k7Kz15cbRRy8gY	9442	13333	13333	1618339140000	orphaned
18741	3NKSADEG7gkfLAnYbqDC1Kov4ZjzkQigUWhgBYHQrJrs2wrNCq9B	18738	3NLmdyMeiAq13GC7Yd3nKWo9o9zjop4F1wLfeBrBzNBvFR4k7HXr	1648	1038	325	6301	12463	jxLtDqCyRyo1nTEvcwo8UP2cCY58tTxqKAasJdfDL6XU7psT8dT	9443	13335	13335	1618339500000	canonical
18746	3NLpZJVHyGpMH4LEZ3ytnJC8fCqwaYgWowesWHDkh6R1yfSz8DQ8	18745	3NKKjfTepE7m2AR8veekCnQ7vu3qHx4VWyeiWZhdQURX2FdsCQnh	1516	1294	325	6301	12463	jwS9oNiVFzohjDfuhaVQe85w4uyzGp8dhwV8FWd3JjpeENUnGcu	9447	13339	13339	1618340220000	canonical
18752	3NLdoJeTb9oL7UWXHXRPGxuTaSFF9SieE7BUpxzLgdcADVHfQru8	18751	3NKZeHGuswJdMdAuPBNJTT3ydVwcPjzP9MvGibh9Kvi2bs8zP3WS	1447	1345	325	6301	12463	jwyfDRAKVjocQ6Dfk38BY1jQimv5au1kEWbqmDzgHr1moYTp46m	9452	13346	13346	1618341480000	canonical
18754	3NLR227DJwDwSfCyRNEFT8w1u5UMAPhs3nw8u4uE9kRnawQC1J1Y	18752	3NLdoJeTb9oL7UWXHXRPGxuTaSFF9SieE7BUpxzLgdcADVHfQru8	1457	1391	325	6301	12463	jwPo6kodkRCGsnfbnVqZy8UzZPwWu6KtAJU74Yp51Sq7PQS5CTN	9453	13347	13347	1618341660000	canonical
18756	3NKAJ8MYXfSGNSzyWJ6b8hPUEwWgzmPLLjBJQfPL23gTDQouTzsE	18754	3NLR227DJwDwSfCyRNEFT8w1u5UMAPhs3nw8u4uE9kRnawQC1J1Y	1581	778	325	6301	12463	jwxMv1phgVBj6cWTCPWbbVvKqoJFxa6EuH4DCxuG6PUXwT7RKG2	9454	13348	13348	1618341840000	canonical
18757	3NKg7hPjfWEmcFkw2cCEdSLvEWwMWcnvrsbdzw1tnALkDdoQGePC	18756	3NKAJ8MYXfSGNSzyWJ6b8hPUEwWgzmPLLjBJQfPL23gTDQouTzsE	633	1138	325	6301	12463	jx5C3gXEqFQNrbbnoYfgUmu1SuC8eziZEpKjUynr9fpGgfa9WoZ	9455	13349	13349	1618342020000	orphaned
18765	3NLkAvHLBVQZ2LhUK2sX2dgu279VP8ExPGgEJCvPkbSAB3fq1uT6	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1631	794	325	6301	12463	jwa86hwCNugfGj1umfa5RUmzZU5CQ3Fiza9JLEL9ZLq1DBJFPyZ	9457	13351	13351	1618342380000	canonical
18761	3NKR1h1V7d7hJmQmmaqARZY273jC8mTDCcwNuKhXaW3ehPz8i47m	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	596	1180	325	6301	12463	jwbFY9Xqug3gkwPBkET37aVjMTzVmzgEB544QFmTDJCXVtBSQYE	9457	13351	13351	1618342380000	orphaned
18768	3NLDG6CdRY2CiigsbXCWAWb7y3gShTuceKBP2g5Dk7eneqrycFQR	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1588	1392	325	6301	12463	jxbP2akdSk5F8MovKCfRN3RsGpNCTCoFTd3rV2agExSSWKLKaqs	9459	13353	13353	1618342740000	orphaned
18774	3NLARSkfTYQheJob8n68zxfgFW3yX4z92MhwMBPvMMxaXjoAicLE	18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	1440	1251	325	6301	12463	jxCVNohvYfwZo3YKUMfcHMNttu9BPgxTby3DmeW2CVCtkQhmrEW	9461	13355	13355	1618343100000	canonical
18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	684	1352	326	6301	12463	jxifz8ALf3irf9EEMqJnZJuL8D8WW9GqBURjU5Khft1FTkLuwEd	9463	13360	13360	1618344000000	canonical
18789	3NLtyCx9vjHCXiUvy4CcX7wdBT6h7jCffzY61LY2jniykwafRGXV	18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	1652	1315	326	6301	12463	jxwo3WLmHgz5xwFsuRax28iRdALUD1bCj9BYcFVE1ys3L3fPBYj	9468	13368	13368	1618345440000	orphaned
18794	3NLvFTND8Yai9Af39s3APo3Bq7aSthT6Us1fMcFqtNf6yVyS5hK4	18792	3NL26YCr99NiPnNp48eeRYELWZaEXKzmCAQ1fxxVpQbwrPCSUbfH	1623	830	326	6301	12463	jwp2dW1SPpEg2WYY3nQv1FbmMqHB4B2Lv1k3t3m5zqWqb6hrgcG	9470	13371	13371	1618345980000	canonical
18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	18794	3NLvFTND8Yai9Af39s3APo3Bq7aSthT6Us1fMcFqtNf6yVyS5hK4	1553	776	326	6301	12463	jx2Tetsq5KgtmW9tqZFTAQe4igBeY9CBbJhNyHNDB787yfEKdqo	9471	13376	13376	1618346880000	canonical
18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	18804	3NL6Mtq6pvDMbY5qGKDMGzkcVBxq2DbHGEh4V4fY6SiWc1NAfqnF	1406	1393	326	6301	12463	jxfEkq6i9xRfF2ChFj1QSR4tvBzMqUdaUEC4HcN66frbCje91zH	9477	13383	13383	1618348140000	canonical
18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1407	1395	326	6301	12463	jwDX8F4BBi9S84XJfL4FXCEnPzPHMWswcJdTNyg6HpgjvUKBJnE	9478	13384	13384	1618348320000	canonical
18812	3NKsmk88Los7CdCBa8PFkSUvGaWhJpVQiPAqrvm8kiPQHP96ErKL	18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	632	1136	326	6301	12463	jwccdw4g5AUu1LFmcLDm7D4XGRwFn5QM5868avSymqyNLGWrR9h	9480	13388	13388	1618349040000	orphaned
18821	3NL7dqA7iG9nmgz2as8GasZZZCH7hMAUndKf7j84Uq1u8YGbvyBk	18818	3NLhRAZqPBznTiHE96dMCC1sbwpozArjALd65phzHqbmvz6X5i2f	1602	1369	326	6301	12463	jxRbSsZSWi1peUqPPLbfZNtzj3xTqrP7tcowPxjbbdUPk3AZKBP	9484	13392	13392	1618349760000	canonical
18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	18824	3NKddkor5atZAH2DK6QRmUya4wexK7pjkaWve17nfFqjDdGvYq5b	1406	1393	327	6301	12463	jw8DXWuaxzgGj2ETwFbxFX6NgTsuTy7FXi9xeYwUYH7J6bxphCU	9487	13395	13395	1618350300000	canonical
18828	3NLr6BKPTQ1Bm8WShZ9rAdeAo5BUb74d3h7awfv18fu3LLPYkqHw	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1619	1149	327	6301	12463	jwKGj9uRnxsmfa7PRtwbFm9JUaqK8bfHeyfTfEi8Ui2nHPFpBWL	9488	13396	13396	1618350480000	orphaned
18833	3NL2QrtP3LaxCvhMHHWmeoweo4tBLn4tN9i8q4XiTYLQu1LTgMBY	18832	3NLUUdUK3pM6oKqFHCURoBtpVTR3974RBWi376Psfr1sjCDdiD8b	1581	778	327	6301	12463	jwBFfFnbQKrnqhipbCnryPqmoAJnCae6kqxwWgQyp5uSKhtHcHZ	9491	13400	13400	1618351200000	canonical
18836	3NK5YQcadgamBKBkmz8GCNkQhcgCpEQEkyPYbgmGRMeH63PujGXw	18835	3NKM95BnCRZAeYv9h47o27dJxNhKsU7Mqdec93sAMw84zu2rqmrh	1657	1344	327	6301	12463	jwjDYdMbcVumg5t8zwwS86uNUGPCw3HkfdWW99VNZQVLa4kbMRW	9494	13403	13403	1618351740000	orphaned
18841	3NL1LqfED8j8z59TppRdudnPZSjYD6gMpqEJRuEqVrdpzT6EKBN5	18840	3NKNkviQpmPMZeDwTRsCRuX8G1cZQ26k1uiDA2cHuoPgH9RU5Lna	1553	776	327	6301	12463	jxW5L8Nxjhv7FvpiJbWbELkAwsdb3oiEKKK2awLEFJxdHJ8Hd6v	9497	13407	13407	1618352460000	canonical
18844	3NKacK2A5rehhLsJcYgVNqTTPfW17hNmUMHZVPvh66RKtJJaVXuS	18843	3NKTEo1cAzXu2iXBrtG3iiJsvCGD9AhgZX3Pvt4jiBX5YroxKdGZ	1581	778	327	6301	12463	jwDXqaJ72RhMriyeHdTcFfn2J1HVing4Y6B6vDUPxBEb6gzb7Rk	9500	13412	13412	1618353360000	canonical
18847	3NKfHxdPcd6m958zfNG2Av1Q31eXXd9PXV7UErgUUCGdU3oooGLc	18845	3NKjLjvCpBNTNg6SVZmHhkg6r37HYb88FNULZBtpBUazvkJz2dji	1585	1120	327	6301	12463	jxPHxfq7GyyocTWxZWpnDCyDoRb6pzC4YHDp32vKP76H8FFgET5	9502	13415	13415	1618353900000	canonical
18854	3NK7Rk8ReJgFcdmtVbmVUzsMW9ehaTUgBZTLiweLPfDDh9xcNbzu	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1600	1126	327	6301	12463	jwJPkQUzqyKNSQXHYuC77Av8hZYKEXEAZPBsnbmCbsswkQBaujC	9505	13418	13418	1618354440000	orphaned
18859	3NLtShg7JcBGKXa7m2cfTkbirAe5jtrX3QhVQ4pUYUMkhVF4mNUa	18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	1637	816	327	6301	12463	jwgWZruZfL1GBtzje1tE8AKqCw9XhjDJHuB5tanzhnAJjxihX45	9509	13423	13423	1618355340000	canonical
21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	21695	3NLxfDm6TsHAmVJE3HPk9txy67vCgijuA1vMLZRDtv1rabXFnwkT	1405	887	397	12463	13875	jxkRYKphEQwS7sbUqxfzYbYopoG1qz6vixEgmZ4PN8WRsEJZheA	10868	15295	15295	1618692300000	canonical
18767	3NKsbSV5y2Q82wVrrXJwkj4U1diNaaSxoS1y7H2Sd9SAKsGEmzbQ	18765	3NLkAvHLBVQZ2LhUK2sX2dgu279VP8ExPGgEJCvPkbSAB3fq1uT6	1406	1393	325	6301	12463	jxtndMDRHmwU81V3FJsinvUUwwAD6TEJu3WdjPsqskan1Stqh8V	9458	13352	13352	1618342560000	orphaned
18770	3NLd3cGBnfpJkGeG3qFcQCouQpF8xmwZ1bPm5SUhh5acV7fSvUDb	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1471	1386	325	6301	12463	jwSm8YUHifz9dT16uq2YozqzkqFrqAKgp8kHrDtBXy2LHsUXuSm	9459	13353	13353	1618342740000	canonical
18771	3NLDH89SBXtLRCoVBZ4stxJfrfEL8xAzHT5XvEcCwDWUkYDEHmHU	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1541	1172	325	6301	12463	jwECNpgnzo59KdoTbWDTVx8cBEpT1BorpqD7jvSdZDLQG4FVP9x	9459	13353	13353	1618342740000	orphaned
18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	18770	3NLd3cGBnfpJkGeG3qFcQCouQpF8xmwZ1bPm5SUhh5acV7fSvUDb	1403	824	325	6301	12463	jxGPLtY6JEkNsshKLmpWH3Jwtu3TbNyG7HTQt2Y87aBBtcPoHLK	9460	13354	13354	1618342920000	canonical
18778	3NLiJs6AZL5yoGfDuJSpyFd22wDBVf5fkEBYAm2dHGwDB89ZcQnP	18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	1455	966	326	6301	12463	jxG7Qu3RM5TTRphcRu1wCxoRGQBPnkT2FcDP7vSTxxRJfE32djB	9463	13360	13360	1618344000000	orphaned
18782	3NLpMmES7eu2zGaf4qf4LnbwPmLi6PETrUyHrcKBBPmvaGdS4Lgy	18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	1553	776	326	6301	12463	jxSN99CNFxVMruGLYrXvmN2owqYMogSCDw4KCWNmZdzooDBnFDf	9464	13361	13361	1618344180000	canonical
18780	3NLc1KMon8L1Sgq9shWYNKprmG2m7DYC3N426Ee5gQ824Mr4aCKU	18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	484	1193	326	6301	12463	jwAyWDGg1WDJisx4Kr68jKUufmiwHLx4EUJbBuUcoHVdfuS7m3N	9464	13361	13361	1618344180000	orphaned
18784	3NKg6oTVNVLgN46J2ouaWvU4HdvQAnr4vp3D1FcE1BXxuYsEVqri	18782	3NLpMmES7eu2zGaf4qf4LnbwPmLi6PETrUyHrcKBBPmvaGdS4Lgy	1608	1043	326	6301	12463	jxN1r4zBRF34knoXD4xsn6j635Q3SAHGre4ySDrPDCLea3U8MPf	9465	13363	13363	1618344540000	orphaned
18785	3NL2rxsgWjkdEsY6j1oe2cg3Q9tDTnUteFU47yFQEzNtDLDUGtNq	18783	3NKgLEbsinaFhjxWzaAcnp2bBPBpw6Bqve6sgq3ExvRCxtTshv6z	1419	814	326	6301	12463	jxxd9GjFVKnA564P4jDZBgcV6WruAEuairb6dWyAAKysREHSeTC	9466	13365	13365	1618344900000	canonical
18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	18785	3NL2rxsgWjkdEsY6j1oe2cg3Q9tDTnUteFU47yFQEzNtDLDUGtNq	1637	816	326	6301	12463	jwYDFCoDK5CDrxC8ufBmzXtXK82m4R2sh7r8NQPw9N4BF9sSezY	9467	13366	13366	1618345080000	canonical
18792	3NL26YCr99NiPnNp48eeRYELWZaEXKzmCAQ1fxxVpQbwrPCSUbfH	18788	3NKk1Q3SYbsFaob6k6YsK35sfFQNeJxgxZCrEUNFodDbCr4LJhac	1457	1145	326	6301	12463	jx4X1Tr5cRzHnLhJHcH69BxWDWqPWfjUW8Ro6Wq8FJhYdhJNpin	9469	13369	13369	1618345620000	canonical
18796	3NLBk5EFtjCx1K8YxATE2d5V7jDcwP5cSRz35ERGTzxYCbZjPzk4	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1501	1360	326	6301	12463	jwrgx9zrEMrWVhg91DRLcKqWspjH3KECdoWtaBQTmmTQiKY41tc	9472	13377	13377	1618347060000	canonical
18798	3NKZK74nz4xhHM6VdW63sBP5waNnGpEwm2GStXPdCHqiWyPphiW3	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1407	1395	326	6301	12463	jxDKQ5Q7hroPNJ2GK33z4zE1m7rPtwZagZRkjMaRVqxfCUAuNLb	9472	13377	13377	1618347060000	orphaned
18800	3NLiVjpqkJNhceFQjXGBJJBE5uFW2ng1CtgPWEcPccm4bEG6BZxZ	18796	3NLBk5EFtjCx1K8YxATE2d5V7jDcwP5cSRz35ERGTzxYCbZjPzk4	1579	1389	326	6301	12463	jxwj9m3UjoT9oQunqEtZwm8jwUvYuAwJq1D8m5pgLeJirc9ZSpm	9473	13378	13378	1618347240000	canonical
18803	3NKx5zS4DTaAHdfDRdZ5MeaXEGEWSAdSJFwmZf3TmHvWBTbtQUgU	18801	3NKVKsah6Mu2rgZLhPaeGopNsYLd512RMwW23BpvMC1EsCANhFNy	1581	778	326	6301	12463	jx3StVybUiioAY1ZkeDqBXfC75ecAkDx3rBxjG5Qac6ZvdCYmTw	9475	13381	13381	1618347780000	orphaned
18808	3NLkhJRGUoANZX7xup3sdHC2Qt8YA5KKGSWs6QS85jmULbnniSXC	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1631	794	326	6301	12463	jwfddS6RjPAsHqy1wsWBPvzKJexhDkwNGoBfNNJKjJ21w6CpV5E	9478	13384	13384	1618348320000	orphaned
18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	1651	1175	326	6301	12463	jxgvEV8ybocvmDP4SYHAzY2GuQgbazRN8RpCgA8vtKiE6mybP68	9479	13385	13385	1618348500000	canonical
18813	3NKMA79Auy9nEfPPFjaVBk9mnp2MNXjJpbQG4tCurkjGgU7Ap6Xc	18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	1656	1217	326	6301	12463	jwL8kasFjbCikchpS2G1TFarKoiR1GmibzhCgPvEN2GjR5139UP	9480	13388	13388	1618349040000	orphaned
18815	3NLJcx4ftPmKj9g85cXnPJJjAAbbZerCGNDFYN3tmZckXwJLGVeY	18814	3NKHbngE1uHX6kTMQCsLFTsUq16fHMK2fQKwtu9chUDuQWykEv7d	1601	1388	326	6301	12463	jwZjK4AasE7GRFtkfNdepe5PhhdcfVpw7yNXrUMsPREq48ge2Gp	9481	13389	13389	1618349220000	canonical
18817	3NKWonhXDJYg8Htr7KgMtSgMhdy4ef83dh69UVERTpzJT3iLGgYb	18815	3NLJcx4ftPmKj9g85cXnPJJjAAbbZerCGNDFYN3tmZckXwJLGVeY	1602	1369	326	6301	12463	jwEu22A81gjtbZkpupTkSkDy6tHMaQXjqJ7cdNaGCj6D7ajsc9K	9482	13390	13390	1618349400000	canonical
18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	18821	3NL7dqA7iG9nmgz2as8GasZZZCH7hMAUndKf7j84Uq1u8YGbvyBk	632	1016	326	6301	12463	jx7vzixwWMa6SbWNkSgj8ZRcB44EQL31JkLrQAbn4aG5vHAfnQ9	9485	13393	13393	1618349940000	canonical
18824	3NKddkor5atZAH2DK6QRmUya4wexK7pjkaWve17nfFqjDdGvYq5b	18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	1457	1025	326	6301	12463	jxYeLmv54jG2oEihS8CBqhv9MTjnEC89MSTyepcoD5UPc8MaYJF	9486	13394	13394	1618350120000	canonical
18829	3NLmEwmqc11G6VsQcJNGyy5vhhV4ZMuEi997FyK8ZCkgcqVzC78y	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1637	816	327	6301	12463	jw6k7W4RVrjLWvsmQmzVZPXFM8W7KuQVWh4NFpJi6CJsnyHimzz	9488	13396	13396	1618350480000	orphaned
18831	3NK6eimpbmf85rhfTu944dhHrCzYcf5f7zryTCStxWWi5DoqKyum	18830	3NLS64YvMM29UM9gGVzVfpfADg43UjfzjU3TjZ8ZGQvKSGRA2YGP	1419	814	327	6301	12463	jxZM9W9EM2ge7Yvgsm5AzDBujkfBHD7KdxuhFuuHUyRMS9L6Fvu	9489	13398	13398	1618350840000	canonical
18834	3NKm6J9FcD6LFuvkRdQZ6MBfH7tYwEa9G2U7MEe8rLDg53yzZjAN	18833	3NL2QrtP3LaxCvhMHHWmeoweo4tBLn4tN9i8q4XiTYLQu1LTgMBY	1406	1393	327	6301	12463	jx5nGriMniZ1Wxbffx1mS8QTL1CiEYwpBv1sBY4NjdUE1kUD75v	9492	13401	13401	1618351380000	canonical
18839	3NKsShn7z7VsRydzxBEVSt9LBZKKWTwg2Wt7UgKj2s4p7aT7571F	18838	3NL4SNJYi5kXKT7dhk7WZmoXsuya1Dpg71yepqapZj3g1ghiud7E	1648	1158	327	6301	12463	jwDpND2Lm3X9jkxtkei1xcTetMUxxHmeboxuHbmiYvSRyufEn1f	9496	13406	13406	1618352280000	orphaned
18842	3NKGZJiYS39KibUJTUUoRG3hJLnX7AMsv6cQkihUPvny7qu2tWUA	18841	3NL1LqfED8j8z59TppRdudnPZSjYD6gMpqEJRuEqVrdpzT6EKBN5	1460	1324	327	6301	12463	jxvyYPtfxgqMp1FGYCxYiP8ay27dfwYLk5nNqhrnGBRwJfJHeHL	9498	13409	13409	1618352820000	canonical
18845	3NKjLjvCpBNTNg6SVZmHhkg6r37HYb88FNULZBtpBUazvkJz2dji	18844	3NKacK2A5rehhLsJcYgVNqTTPfW17hNmUMHZVPvh66RKtJJaVXuS	1631	794	327	6301	12463	jxAviz8DRzsYPe6cioP26Efom2QwzhUfXAPawr7m5dytcFXFMk4	9501	13414	13414	1618353720000	canonical
18853	3NKFWBt5fe9YfqNjKqahnLD5UDq9a4nP71yngKeYD2gAqkVNPT8m	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1406	1393	327	6301	12463	jwUPTY59jHGzwXKFs8v76jxw7m37kTY9UQNGvrrkJGWLvswcRX2	9505	13418	13418	1618354440000	canonical
21701	3NLoqE2tFnG1MWH83iRennJTjgaJitwgUr9Zy2ixnhiHRzBM5hqA	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1590	1054	397	12463	13879	jw938zRGqccGun2d6PQZguUx1qHefDTA3MLVJJ5KPaenxU12B9n	10869	15296	15296	1618692480000	orphaned
18769	3NL2Vdunj6XzHxBBDJcXUyENyNvwumDhsF6jsm4KoJ7VND4roJpG	18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	1656	977	325	6301	12463	jwPPpJMe3xM5v1h2YJnX2pc8tjy8KJ4R1SDmAF9Nk4Ca6t1BjXE	9459	13353	13353	1618342740000	orphaned
18773	3NKmLQpzyRGEhqn6VRnyV59Jkwb9j3XmVQpEEhzFNFtdRfNqQt3H	18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	1675	976	325	6301	12463	jwUXHRLDun3PhnuaFTbXd8TS3Riz1nYy1S5bb4FvfKKJhZv1g7k	9461	13355	13355	1618343100000	orphaned
18786	3NLnejR18iXPbrAHqKvxh2SCgW9NEoAUdKaJcfn9xaAzb1ofYE82	18783	3NKgLEbsinaFhjxWzaAcnp2bBPBpw6Bqve6sgq3ExvRCxtTshv6z	1581	778	326	6301	12463	jxmhLPtsrEg82yWqfwgf2sP5wsDinT6h3og7ek1nex7jNueBxCa	9466	13365	13365	1618344900000	orphaned
18791	3NL4JQuRVJdbDoNYFHy3n1iSHvoSCUyqdq5skAmRpjkJuoAmTFo8	18788	3NKk1Q3SYbsFaob6k6YsK35sfFQNeJxgxZCrEUNFodDbCr4LJhac	1524	119	326	6301	12463	jxSQ31EK3ozAEysB4KjxoMJET6UwEqJktuAb5a3y8W1YzabXyTa	9469	13369	13369	1618345620000	orphaned
18799	3NLjCQ8yApBaU1XqUhWsfHj3eotw8yad6L9fWXa4TzTZnMzkMopJ	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1474	1329	326	6301	12463	jwBdr59qsnKu9eacWqAWbgHnp872EyA2ZskNQ7U67MKmKUkQCAf	9472	13377	13377	1618347060000	orphaned
18802	3NLdQsyTBoXXnDy6GsWG1KmDgFcJgjFDuSHJJ1tpwbfh6AiXBdoG	18801	3NKVKsah6Mu2rgZLhPaeGopNsYLd512RMwW23BpvMC1EsCANhFNy	1405	867	326	6301	12463	jwVXvimgCyVbG6jGstWngQzH27CaNREHaSeua5nutbVq9HwJs6e	9475	13381	13381	1618347780000	canonical
18804	3NL6Mtq6pvDMbY5qGKDMGzkcVBxq2DbHGEh4V4fY6SiWc1NAfqnF	18802	3NLdQsyTBoXXnDy6GsWG1KmDgFcJgjFDuSHJJ1tpwbfh6AiXBdoG	44	1325	326	6301	12463	jxN6fHrcaMjuvuh7FzeifzRR4mq1dFM7mqo4MPkcHdr2u8N1PQD	9476	13382	13382	1618347960000	canonical
18876	3NLuu2VfXqt8BVtvuqmPpoHU7VPGeyASqro1VAsoQMus2FpNLLAS	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1560	1045	326	6301	12463	jwNktZdzNCnmsEmRwLu9bUNMpCW1P9jAjA5PGQEa5PqoJTRZgga	9478	13436	13436	1618357680000	orphaned
18809	3NLhMZR479VigLWsNZdRRE9x64JJrZ2LoDWQwvfYYoTW1khFzh6K	18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	1406	1393	326	6301	12463	jxvmT7d9KSVh2gox2J6y3aaimzp9gLS1hGqJoqhaSQvb8sXvxsb	9479	13385	13385	1618348500000	orphaned
18814	3NKHbngE1uHX6kTMQCsLFTsUq16fHMK2fQKwtu9chUDuQWykEv7d	18810	3NL1rThysV57a95DtaRWT1HWoyU7p5tZRMn13C69c7FdDTyQCQzv	1637	816	326	6301	12463	jwgtnyBqBKT83EA23mnUTMqEyf4nZNFg8542Qa8c7aqgEuxeJyQ	9480	13388	13388	1618349040000	canonical
18816	3NLMFaZfqnnQxMdv5RoQA7Jv761YwQ53n8kiuk2826Yk1ud6KRuZ	18815	3NLJcx4ftPmKj9g85cXnPJJjAAbbZerCGNDFYN3tmZckXwJLGVeY	1617	1042	326	6301	12463	jx6hFUUr7LpCRYmBqmFXEcBuSezDwAuzmvFNYNUyEu5rFaRuC7W	9482	13390	13390	1618349400000	orphaned
18823	3NKdsSFLkhsrWbmH6dW9beZLuYuxGLQ61zrQoTJfaWurVen5r4Ai	18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	1406	1393	326	6301	12463	jwhe9WEXqGYau78cCEWVKXYfcW8RHLLFFZtfW5Y3jcy7GinGa3N	9486	13394	13394	1618350120000	orphaned
18835	3NKM95BnCRZAeYv9h47o27dJxNhKsU7Mqdec93sAMw84zu2rqmrh	18834	3NKm6J9FcD6LFuvkRdQZ6MBfH7tYwEa9G2U7MEe8rLDg53yzZjAN	1490	908	327	6301	12463	jxcWhaeAqduKXjofUxbor3QXMJxoWnbZqPXo1ebAdhA2NoN7jfd	9493	13402	13402	1618351560000	canonical
18838	3NL4SNJYi5kXKT7dhk7WZmoXsuya1Dpg71yepqapZj3g1ghiud7E	18837	3NKud2womi54SEtzJdghy9yhwmikYKYrbELrBF9AX59StdGtmyaV	1508	1021	327	6301	12463	jxCJWodWGqNthyDzTZbA5Ld9HsB44YRX5fW7kqt9CLNeUFd7GkJ	9495	13405	13405	1618352100000	canonical
18840	3NKNkviQpmPMZeDwTRsCRuX8G1cZQ26k1uiDA2cHuoPgH9RU5Lna	18838	3NL4SNJYi5kXKT7dhk7WZmoXsuya1Dpg71yepqapZj3g1ghiud7E	700	840	327	6301	12463	jxig6fDQzEJ3ztgLspTMSx3kYsytHcnHw1P9rU4Ek1dwepusPWe	9496	13406	13406	1618352280000	canonical
18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	18848	3NL3xRokHbtnwzmgHHXzhNE8tJ6SFAyVTaMAQQGRkcYPSoPoV7CA	532	1303	327	6301	12463	jxhUjLPiVHFkr4bpPvPqNQUspeLR7Vvp5A4EkvP2LKBag53ptTt	9504	13417	13417	1618354260000	canonical
18852	3NLPooAXWXS5rA2S8s2QKDr24rnSuEdypFX44ecjRCQvEJoEcf5D	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	80	1273	327	6301	12463	jx28BgXBysJnQtqX2Dg8wyUWcVVHiV4J2TvM4eG5cwCkYBXRz7o	9505	13418	13418	1618354440000	orphaned
18856	3NKggaQSm6q6Mt8WueHMFmK4eEAU9xCQXNDqCAZ7xrixkeYrwiCv	18855	3NK3faLafCoAxmdSa3dq3pNCVAs9zuBgueVPuakkt6NFERxm4o55	1460	558	327	6301	12463	jwQShTp3S8ziAiDbeojbvsrN1icVz49JAyZqmm22e7KZZpvFSTe	9507	13421	13421	1618354980000	canonical
18864	3NKLFVQpCHTVJSVzgjqL3kSWZAt45EJsawSCPJ2betYfrmFXw7BQ	18863	3NL767uQfV4aBkVbQZ3ZFg3kkMbydtBVD8Zbjq6z2g8NeJbJE6fH	1547	1132	327	6301	12463	jwCNDis93Djog6zHbHdnbMBLTY2GPVuWNRPEfj9b9ZPcmuRHAjh	9512	13429	13429	1618356420000	canonical
18866	3NLtaC5s9NtvhynrJfuZ7v5grSpEMK9Resk4qg4ymtRtpKvLaHZR	18864	3NKLFVQpCHTVJSVzgjqL3kSWZAt45EJsawSCPJ2betYfrmFXw7BQ	1407	1395	327	6301	12463	jxmrtLB9uNXu79mMDrJxcpiznw5TkkAJidKaGrvmvSoBNprYJ2J	9513	13430	13430	1618356600000	canonical
18871	3NLXybmaiFCCTyQZNjuwewW6PpZC1foWrdjra4yx6TUz3ZbUXtq5	18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	1407	1395	327	6301	12463	jxMUU3hRk11SY2agjuXfsnEFronE7qCfe8vMDuE9HZaLrWGTb4E	9516	13434	13434	1618357320000	canonical
18869	3NLLuhjFgrZsCEs57LkCUkBJRwZiY76N2QMrBA7UJcH1RHvfrRKJ	18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	1553	776	327	6301	12463	jwjYFsrDdT6EnRpQ6miGQKhXfJxjr8LA9q8wYjYo1PNcaWdaaMK	9516	13434	13434	1618357320000	orphaned
18878	3NLjjoQKcvsfnpTVtXkMLtTFGmLFGUcnjhfZpgho5i7DPDK699ef	18877	3NKaxXdxSkXGEsqBZpMrLukGCnZK5fdFwCrZxHmcnHhPUhQomNH9	311	1307	327	6301	12463	jwVP7Cyt8p4MNZMK5VYswSiauvpq5DDwGv9HCzmXR6W8tSWKbMo	9519	13438	13438	1618358040000	canonical
18881	3NKHk5k5wtyEKfuHyFN2KzWi77EJFYDRNRao1nAyX4SyxVY11fsc	18880	3NLQLU9WQRDzve36sGSweb78hn9ZqYRtEExpLtbsUpmj22vqb5bb	152	1084	328	6301	12463	jwnTwNofb12SwEbgx7oPuRjQUxoDtWTe7KMZqHqdjTcL8px2HXe	9522	13441	13441	1618358580000	canonical
18884	3NLNdEsCpm6pgo4kqzhJwUV9wCaYtnPw5QAVMDJNj1pReqpchRnc	18882	3NLo4XKXr3RFrcuWkRoEBDErV76jHc6MA6PxGBUwpuTcm5zdS9hL	1564	1212	328	6301	12463	jxyWW5HrrMxtvwJwgj6K5zxt22YnQHCw6G1oVrREGEHJpBqJSVs	9524	13443	13443	1618358940000	canonical
18886	3NLMmP1M4bYYkwZs7st5rY7gw5jWJPTGx1aVTj92CQF6kYecSghg	18885	3NKu6PWSAkZG7o6bHYy348aBDPYEqsm1deeJPEeXvYuTLCvv7FoR	1646	988	328	6301	12463	jxWMwt3QFg7NFRDCbUGj9z4Hj2CGsUh48Vfa1wewL9FiU7DgDY9	9526	13445	13445	1618359300000	canonical
18889	3NK3YCkwDQbHe4Cw7qhY9teHXPUUfkeYLmrs9ievuQnCgxa4QMWA	18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	1607	1102	328	6301	12463	jwKfWE6Km4as31BUQjHzuMQKyF53LdUd9xZGQycKXwaBioWGzdN	9529	13450	13450	1618360200000	orphaned
18892	3NLiSx381vNnNT3gczgqB12MN4E881PTZirhPFmotuXZ6K5CU2LX	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1527	1167	328	6301	12463	jx2LkjBwqy4mt7esYX3VzL1N7vwtKBrS3SBfQEZg6rSZZfjcX7C	9530	13451	13451	1618360380000	orphaned
18895	3NLpzjNA17WyyteoESUgievmF7wvJVp2YYbnEiThgL8JwRvhd69s	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1527	1167	328	6301	12463	jwKG41FCi6V8hnkWLBKTAjHw98uunmmxr44GPHYoX6g7s1G4KRS	9530	13451	13451	1618360380000	orphaned
21711	3NLvn1jGkMffJuJHPMfVyrfANcKEKipsFE6cFV6DwDk4JyNVjgXo	21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	1536	1313	397	12463	13886	jxKDB9z3LFdt2FhjjaHfJZm3bovj9zMLd8TSU6687Fgxm3RiUcF	10875	15307	15307	1618694460000	orphaned
18781	3NK94iA4mdbxAHUvcxV6xdZKdS9H2ccKUDekTRALp6WNWDxzQpwK	18777	3NLhJw575Zv2wc2RwG5MiJpRF3gtv2QALyqq7zuD8SCQcLz6SV4M	69	69	326	6301	12463	jwJ97VfpZNgPkeGST6FfF4AGejw3LfLywB2daNQymR2puGGUF2U	9464	13361	13361	1618344180000	orphaned
18783	3NKgLEbsinaFhjxWzaAcnp2bBPBpw6Bqve6sgq3ExvRCxtTshv6z	18782	3NLpMmES7eu2zGaf4qf4LnbwPmLi6PETrUyHrcKBBPmvaGdS4Lgy	1457	1025	326	6301	12463	jxS8FnC95ZjowUUPe9o3F41z581jEmwxZNR1g9Bmeh8HjdcTCMX	9465	13363	13363	1618344540000	canonical
18788	3NKk1Q3SYbsFaob6k6YsK35sfFQNeJxgxZCrEUNFodDbCr4LJhac	18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	1405	873	326	6301	12463	jwvbYAwZAm7a9VuNiQaA5QDL9QP71hx4ei5e8m3anu7VHEUDehm	9468	13368	13368	1618345440000	canonical
18790	3NKgimR5V5ZraDoJFnG8uR2CtasCbXvRUBaqsQNsbNAU7bXTkmc7	18787	3NLyBhRLyJi7iSJ8cGhkziM8jLLjoKe3sQdGNc34jbUQ37tzz869	1652	1315	326	6301	12463	jwYyYGvVUqVDCDvrvmyhnY1fk2wWCLK6eZBioAhdozHDeApfxkB	9468	13368	13368	1618345440000	orphaned
18793	3NLRTZfQ1QCSwhZxXts5W4q95Y3g9KWoMT4cn63kjDZgDN1SkCCs	18792	3NL26YCr99NiPnNp48eeRYELWZaEXKzmCAQ1fxxVpQbwrPCSUbfH	1637	816	326	6301	12463	jxJZCXqzWLk9fVVnJNeCoik4zn7mrfEMniTN2k7ij41jbLB1kyh	9470	13371	13371	1618345980000	orphaned
18797	3NKbeg4L8r5zcpCreDp3VRa5eoz3TNHxDFAgcroUath3QtuUajuE	18795	3NKt3GhNy5vBf7C96uNLTRNBySCiE1uBMgxMhxGtXFxzwMFzVBHF	1474	1329	326	6301	12463	jxipbtVBQAz6bKMvp3DYoHbXKecReZRZcWsjv68dzTgXZT4nBZd	9472	13377	13377	1618347060000	orphaned
18801	3NKVKsah6Mu2rgZLhPaeGopNsYLd512RMwW23BpvMC1EsCANhFNy	18800	3NLiVjpqkJNhceFQjXGBJJBE5uFW2ng1CtgPWEcPccm4bEG6BZxZ	532	937	326	6301	12463	jy2NyRknKrmXNJsjC2eAD4EKCp1pmfL4x4jEaEt1ozTxnhUBGsC	9474	13379	13379	1618347420000	canonical
18806	3NLFf2o9F2S2Der6rmhKvzxjbC1cNDznYPeTMSTA56kkf2iZ4V6H	18805	3NKAF1GFx9y5RgqArDJoUVWo8v33eibhcWjAzRkX5rmN7hqDZcmq	1406	1393	326	6301	12463	jwZeJHPAHs7ssjf6Rdsn8GaQ4enPPDqnV6xv2Pc1CFvxoHUXEhR	9478	13384	13384	1618348320000	orphaned
18820	3NLDcvJ79VQPXu8ikkWjcDjfEpdS8VXX8KZycJYGX3EF2Lua5qyW	18818	3NLhRAZqPBznTiHE96dMCC1sbwpozArjALd65phzHqbmvz6X5i2f	1649	1137	326	6301	12463	jx1W7t8EwqFkyMSFdqFog3tVc9ewa7xLBwXPPBbcMG1ao6forCx	9484	13392	13392	1618349760000	orphaned
18825	3NKHDYct5kAWfkM15eJie4XXdXrLKrqm5v9h2wEJ1cjwFUycygkU	18822	3NLv5YTaTJ5jrPriNgsKbGrwULqfrynT4Mpni2pdR9bYUQKW59Zn	1407	1395	326	6301	12463	jxamLZ1nEWxaLRWd8hXJNk6FBZWcpyEUZRznz4uJWQHK9sYHVMZ	9486	13394	13394	1618350120000	orphaned
18830	3NLS64YvMM29UM9gGVzVfpfADg43UjfzjU3TjZ8ZGQvKSGRA2YGP	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1646	1108	327	6301	12463	jwYRgyHHTJp1c5Yp9Be3WFoSFsDDWgyrnf5HBGRV3TGjwpYHWBG	9488	13396	13396	1618350480000	canonical
18827	3NK7VHsvhvPRcTzhn8A35xScbVQoEBJoee6M7tMtDrnomcoWabp7	18826	3NLXTL4dgyUYQg2wKnNNxRxEnmWkiFAnArbSAhGAmodQYMUiKitQ	1477	1104	327	6301	12463	jwmmKhMXrDh2tupaVKGibhYqT8rdHcDrbBgUfXZFecg9jZNNq1S	9488	13396	13396	1618350480000	orphaned
18832	3NLUUdUK3pM6oKqFHCURoBtpVTR3974RBWi376Psfr1sjCDdiD8b	18831	3NK6eimpbmf85rhfTu944dhHrCzYcf5f7zryTCStxWWi5DoqKyum	1406	1393	327	6301	12463	jwRD6JLQW7hXW8xTsX6VBcXtLTM1BdWdy8WXbPoia1kktQYeAH7	9490	13399	13399	1618351020000	canonical
18837	3NKud2womi54SEtzJdghy9yhwmikYKYrbELrBF9AX59StdGtmyaV	18835	3NKM95BnCRZAeYv9h47o27dJxNhKsU7Mqdec93sAMw84zu2rqmrh	1643	1053	327	6301	12463	jw9JCCh5WFhojZ1rAXoePHbEwVM3JwH8zJ94aru4rRRTdRkPqE3	9494	13403	13403	1618351740000	canonical
18843	3NKTEo1cAzXu2iXBrtG3iiJsvCGD9AhgZX3Pvt4jiBX5YroxKdGZ	18842	3NKGZJiYS39KibUJTUUoRG3hJLnX7AMsv6cQkihUPvny7qu2tWUA	1407	1395	327	6301	12463	jwr1ptLkXyQUmD4fkbBZt4tDgYKajit8ZwZgv7ws6JjVr6kHXbh	9499	13411	13411	1618353180000	canonical
18846	3NLeZevhmPm1gazbdPPu3upwtrTVHjnYDRzTNt39ArCi4sn5no8S	18844	3NKacK2A5rehhLsJcYgVNqTTPfW17hNmUMHZVPvh66RKtJJaVXuS	1590	1174	327	6301	12463	jwGsn6Sozx8davtW8mZzLB5B46MBanysEi712i51yYqAfCtSNGo	9501	13414	13414	1618353720000	orphaned
18848	3NL3xRokHbtnwzmgHHXzhNE8tJ6SFAyVTaMAQQGRkcYPSoPoV7CA	18847	3NKfHxdPcd6m958zfNG2Av1Q31eXXd9PXV7UErgUUCGdU3oooGLc	1631	793	327	6301	12463	jwxkUnTPP1mfqEBJwsoteHBFcuPT1Kzn9ckjLoutMrp2PxnEDkx	9503	13416	13416	1618354080000	canonical
18851	3NKo74eVA4y8YPBWe9AABi74ggYwnysrsMu1odzraexSDzZQ34fe	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1403	823	327	6301	12463	jwTed5vArNsU43smTVNk4kft6vsRdVJzCmGhRgiPAhvuuASzK4w	9505	13418	13418	1618354440000	orphaned
18855	3NK3faLafCoAxmdSa3dq3pNCVAs9zuBgueVPuakkt6NFERxm4o55	18853	3NKFWBt5fe9YfqNjKqahnLD5UDq9a4nP71yngKeYD2gAqkVNPT8m	1602	1123	327	6301	12463	jwoDa43PBs1NRK8MQEcBY9UDLtqmB3Waq3jxLPLxA6EB783vjsk	9506	13420	13420	1618354800000	canonical
18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	18856	3NKggaQSm6q6Mt8WueHMFmK4eEAU9xCQXNDqCAZ7xrixkeYrwiCv	1467	1376	327	6301	12463	jwjrWGdRSjJhvNPKvdvYCQdAp844TB78nSehWoDjsF7RracE9E3	9508	13422	13422	1618355160000	canonical
18858	3NLmjfUDsRFNV5EPnMsEHG9eb6L9ZSy4JvyHxKma5DbCw8PP8246	18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	311	1307	327	6301	12463	jxoxcLDVHtMHS5hP4n33zripyiZGf9qeEcJUTQ8A8cGadG2a4RR	9509	13423	13423	1618355340000	orphaned
18860	3NKbrTvxmy4VfZPaT8ynJNmecoaoYGBMqvWetxVtN48TUMmxvsG4	18859	3NLtShg7JcBGKXa7m2cfTkbirAe5jtrX3QhVQ4pUYUMkhVF4mNUa	1547	1378	327	6301	12463	jwAZGXxttCEhX6sfbQxe97ds8bcEngUT22x46SuNSG2toywbzq3	9510	13425	13425	1618355700000	canonical
18861	3NLDz8QEjks7g8rKVnNew5gKBu7ofVUBEyPyrJVcdXxLCdz4y5ba	18859	3NLtShg7JcBGKXa7m2cfTkbirAe5jtrX3QhVQ4pUYUMkhVF4mNUa	44	1325	327	6301	12463	jwBTedJU5DwiH6DFTjgfQCKYwHu6THPR56ytWUqcYZw92ZyhLQV	9510	13425	13425	1618355700000	orphaned
18863	3NL767uQfV4aBkVbQZ3ZFg3kkMbydtBVD8Zbjq6z2g8NeJbJE6fH	18860	3NKbrTvxmy4VfZPaT8ynJNmecoaoYGBMqvWetxVtN48TUMmxvsG4	1654	1094	327	6301	12463	jx4NEkM9ZTNt4d8u45U2fhnVj6whYEVgtLTCD88NbC9D646Y7Bs	9511	13427	13427	1618356060000	canonical
18865	3NLUxyUuoJ4uc17JJ5hkmGD645rFfJjhCGeKpRb6TDYJHUr6mRvj	18863	3NL767uQfV4aBkVbQZ3ZFg3kkMbydtBVD8Zbjq6z2g8NeJbJE6fH	1637	816	327	6301	12463	jwNR9TPAHd9UQymA6qP2d95WfxbKeURCV69R6hoKHJyG3Zdbkyx	9512	13429	13429	1618356420000	orphaned
18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	18867	3NLtWJnPrdmK6VuLKLHcNrEdocmYainH5VygkCLA2nPoyK7TETZv	1503	1031	327	6301	12463	jwe6nhmCDkyGJyCE144T9mgwD48i56W4bn8XEtePervzVdETttp	9515	13432	13432	1618356960000	canonical
18873	3NLZZLMpbGLyYCRpUfvjE2N4g6DsWh3xiVJr4Af4nuVcA9En8DTx	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1672	919	327	6301	12463	jwZsLTMfbvPJQYemXp11sZoYTrXq88kqkNEyoNtbxqmkSpcFgfV	9518	13436	13436	1618357680000	orphaned
18880	3NLQLU9WQRDzve36sGSweb78hn9ZqYRtEExpLtbsUpmj22vqb5bb	18879	3NLF3WSjFeMTJJX2VgvDrmiUDvWduYHthfcm3rDZo6JheA7wq5u2	1422	1091	327	6301	12463	jwcnYvAxpJybHDMJr4UtJ3xH5kYwjKpWjkBrx2rgp1MqJnb4N8s	9521	13440	13440	1618358400000	canonical
18883	3NKb6aQwV5fGgR2dETYn38rwZbMNXYBTyJgksYiCQWAWzVF19HxB	18882	3NLo4XKXr3RFrcuWkRoEBDErV76jHc6MA6PxGBUwpuTcm5zdS9hL	1646	988	328	6301	12463	jwaXcqg8iuwSzAwgJC5qQHMFTAs1Yy2yYBJ4Bn2vjSjaZCFez3P	9524	13443	13443	1618358940000	orphaned
21742	3NLQMmYZbtEd46aWHfj6bMiZAvFF61Mn6EBW66j2vcaRGHYPrDFK	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1587	1231	398	12463	13914	jxNwiVTyrbUB4mmBwQyVd8XCywP4X8d98Mg86aewx9wpdEJqDQ9	10888	15327	15327	1618698060000	orphaned
18862	3NL7V2ERcqVLShzK3onHbFYFXYxhPFNR1qbcn5TJobgH86Cas9KG	18860	3NKbrTvxmy4VfZPaT8ynJNmecoaoYGBMqvWetxVtN48TUMmxvsG4	1619	909	327	6301	12463	jxA5B1hPxxW4FgwowfNREVk3U7PNJgEf2s327Ds8tuHpTom5WUV	9511	13427	13427	1618356060000	orphaned
18867	3NLtWJnPrdmK6VuLKLHcNrEdocmYainH5VygkCLA2nPoyK7TETZv	18866	3NLtaC5s9NtvhynrJfuZ7v5grSpEMK9Resk4qg4ymtRtpKvLaHZR	1403	823	327	6301	12463	jx9BCjPxQC4SVuQtYquakqR4WR3b6BajwpjQLnDQAajy4Unq2dB	9514	13431	13431	1618356780000	canonical
18870	3NLf88wffJUG11Trow5UmyswRY8spNP4ExTf3gYwnwFEK2Vww1ph	18868	3NKYooX7aZhwhhmHPeGiEQUTMPJGWNvXa2yd3sLyKRvAWZMrRJfV	1534	222	327	6301	12463	jwuNjURdeyno9EJhtt2YGW9PdYrahvTBLwQb1MT1fBKb3hCM7AN	9516	13434	13434	1618357320000	orphaned
18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	18871	3NLXybmaiFCCTyQZNjuwewW6PpZC1foWrdjra4yx6TUz3ZbUXtq5	684	1352	327	6301	12463	jx5WR3GHqqBSymqbgzUP7oD5FqELLJpKBUrDPeQ1GCp7o1SMnQz	9517	13435	13435	1618357500000	canonical
18877	3NKaxXdxSkXGEsqBZpMrLukGCnZK5fdFwCrZxHmcnHhPUhQomNH9	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1407	1395	327	6301	12463	jwuQ8AS9HHQkBmYfQ63nGAjG4auFPbbEoCtZBX7MSNBbobv4jX1	9518	13436	13436	1618357680000	canonical
18882	3NLo4XKXr3RFrcuWkRoEBDErV76jHc6MA6PxGBUwpuTcm5zdS9hL	18881	3NKHk5k5wtyEKfuHyFN2KzWi77EJFYDRNRao1nAyX4SyxVY11fsc	415	415	328	6301	12463	jwwx9jC6TUQHRxGfutSGbmv8k5zDtVWqq8JJjy2NHjQpsux8uaU	9523	13442	13442	1618358760000	canonical
18909	3NK9G4DzNArUYZy6X23uc7MvmxUoqrWuhsD1LCgF9n4wgPhMHefv	18886	3NLMmP1M4bYYkwZs7st5rY7gw5jWJPTGx1aVTj92CQF6kYecSghg	1581	778	328	6301	12463	jxNaxf3vkiRLjFCcJtJBJf2cpF5W3bLAzFBqgrHAMiGCzckHNr3	9527	13462	13462	1618362425435	orphaned
18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	311	1307	328	6301	12463	jx1yCGvUU546QTs6q7GCNoZRGgzsTGzEnrBhPE5X7QD4pSuSWYE	9529	13450	13450	1618360200000	canonical
18899	3NLwrdSxY872RkBFVy2HVeL7fBmhhCm4X1JKtVcJ6rGq6seVeLAK	18898	3NKBbcNutDabHK2r2KzJhCP2mSae2biZ2FXWUX7EQzniQpENRHLJ	1422	1337	328	6301	12463	jxGwVQfP8nvzk8B3Ku3Xrmq6tnekcMVdKmgSuips4fArmTMh7eE	9533	13454	13454	1618360920000	orphaned
18904	3NL4H68uYjDG1Duqfhc3asTtjDb3xyZcaEKKaSBB6xSfb6YpbWAp	18900	3NKajkSjinKsFwF9md6XnJ6oVA2WZLLCtJoKvQxx1uVJmTLEQkMx	470	1063	328	6301	12463	jxEbQ6VA71MjViB7CmFKbmWMx3fDGQCYJueXUY38NhsbBBDxqfs	9534	13457	13457	1618361460000	orphaned
18906	3NKxfTG3Njoc2Ta9Re38oXFNoupNM3a2NxFa2Qr6CzZpZsQc3zyX	18903	3NKAP8uWRFn2g4h3HoRMjkXKjKLfpReYBkDsgcojNMM7oeKvhyoT	1627	1139	328	6301	12463	jx1Vcc2bSZEymk88xMpCNNuGgfgV71bjGnRSUADJNZmYhZVRnHb	9536	13458	13458	1618361640000	canonical
18907	3NKpcvFjUwfJRBa3HTzLcykD76HkMJV4AEdgAAgCQg4w6KLkYMKy	18906	3NKxfTG3Njoc2Ta9Re38oXFNoupNM3a2NxFa2Qr6CzZpZsQc3zyX	1546	1339	328	6301	12463	jxta7xkTs1wVScYBTriB8fX6nFitY95DbuUosDbyJSE5fzKf2kt	9537	13462	13462	1618362360000	canonical
18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	18911	3NKadQbzUZhitND9Z7pjvWawoxZRZypE5PZN2Nx2S85baDNwsEZm	1671	1119	328	6301	12463	jxSFwv7dKC63Q2BQTnygKsMj2rQhUy44mr2rrYCc4zK6opQnB8V	9540	13466	13466	1618363080000	canonical
18922	3NLQrHmqxEDuzj8xewBfMpBvMZoienZCE6jJTiYVxMaGsb5sDEe3	18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	1406	1393	328	6301	12463	jwMUhYhPBu17YCigDPsfdUFptaSDpCSCnmdpTnmfkV8fUBP5Emh	9545	13472	13472	1618364160000	orphaned
18924	3NLqN6HSQUDmowxCU3DMZLSseeZq9XFApNeFWDVBBVhMemh915mK	18921	3NKLTF6bk2VV3HiF7LC5ehbKUsj8JRgFn9jws3k86CS4JsjcBmbs	1476	1371	328	6301	12463	jwsP3N6cEeEt7TttEwvgsZVezZeV1swgzDffQuVjg5xhwT9ZZ8n	9546	13473	13473	1618364340000	canonical
18927	3NKexyw8bqNn9DC7fYW8AFjyD9BoSoTbPFsfuu3NBgG7sZp4UeEt	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	1455	1086	328	6301	12463	jy2EKTNuiZ6yAXPny4vp8wGVLKHtLauUjwdviNVezqRugTeHr1D	9548	13475	13475	1618364700000	canonical
18931	3NLjmddLq9VUZ3QEogtbhtejYVMKDmqA9dG1KtxazsLzzudaZ6B5	18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	596	940	328	6301	12463	jxqJ37AQHSGxZyYmwswfPoHsgL6716WSFJHuYQEkqjsKXpKLsSQ	9550	13477	13477	1618365060000	orphaned
18938	3NL4Rat7aB1hZyCFtNHvbDupKdXsGmfhmrPusJhyUWqDg9nybsjZ	18937	3NKTkt7CzSqAinkEwJPtac9rcEntLXe3hSbpgrXsiysEMVHCLx57	484	1319	328	6301	12463	jxfkdMVgpGtGonYab6HxXeVriDQug97xAHxtUEpKzF6jKSSCDMH	9554	13481	13481	1618365780000	canonical
18940	3NK5bhsDbfwxaitK3w8ixtsd4YPguCU2QLKPB9gCscEJC5fZuDtX	18938	3NL4Rat7aB1hZyCFtNHvbDupKdXsGmfhmrPusJhyUWqDg9nybsjZ	1407	1395	328	6301	12463	jwXNoUq6Hi8tJ1YZ2bwirwWmcYYFaDakVvjQUuQ5W47zreajGRM	9555	13482	13482	1618365960000	canonical
18941	3NL3pXA4aVuET7kMywb6Vj64tErvtvDwbwKzc3RqesRQxtdirzcE	18940	3NK5bhsDbfwxaitK3w8ixtsd4YPguCU2QLKPB9gCscEJC5fZuDtX	1593	1220	328	6301	12463	jy2v265S6ubDKQd2xhtHkYULL6hTdAJ5vPhDwtdBVrgCC4Xfuxu	9556	13485	13485	1618366500000	orphaned
18945	3NLFx6ZG57VvzskTRnFvRDshoPDPNzyzP8BKWLzLsdBQRLmg3FK1	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1553	776	329	6301	12463	jxUwDBgCMMKUKQi9gJKWt8EEwqcxTs7DzbseQmfi4CaJv3hg6Qc	9557	13486	13486	1618366680000	canonical
18943	3NK5TcsMoCi43gEtY2zWB1Ynd7MebppCWTvocPmDJv52JoqsT3CL	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1547	1378	329	6301	12463	jxPWV3ASFTTDhMxQePAijxx9qydpXV5SAj3MgaDrG7YTys3D8qK	9557	13486	13486	1618366680000	orphaned
18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	18945	3NLFx6ZG57VvzskTRnFvRDshoPDPNzyzP8BKWLzLsdBQRLmg3FK1	606	1049	329	6301	12463	jwB6xxHPYjgZnqgXmpXRC1V6gjxMBwUzUTmk9TiQ8b1vuseoAGB	9558	13488	13488	1618367040000	canonical
18952	3NLTFYgr3UKjxXFy35xwdyrdnhjV8GZw2RYCTdzxS4vzRczLXtmS	18950	3NLf5DcwhJhfj9CVDyqybUXb1xQZhri55hGBmH9rFYw5iHVBNE8D	1489	1134	329	6301	12463	jxhyMVbcnJr8HjRGJz7CSjdnPjvF2HqTuC6BTe3HQs5w8zuX44f	9560	13490	13490	1618367400000	canonical
18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	1608	1163	329	6301	12463	jx6UQ16Vhr4qprACuYfCzGE5AbnT6DkZtbz3hUXXQBMWg2HuvHi	9563	13493	13493	1618367940000	canonical
18959	3NKY95BgZsjYY5VR5UXmsxGrST83EsEdn792X33hTJCFi7ZW5Sxr	18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	1608	1163	329	6301	12463	jwPAJ47yqQReX9RdDH6jjCS2JBALE9waimrkvKUE9TYsgtpyL42	9563	13493	13493	1618367940000	orphaned
18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	1448	1311	329	6301	12463	jxQaGUGrF2ZYnXy3Lk5Xb6RRac6Dqfh9D17paRgpg1nSAx2iBiU	9564	13494	13494	1618368120000	canonical
18968	3NKHnV41pKGGz36ovPDmPqvS6PEosFJsGJm9V2X8rJ5G7ZfMftRx	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1643	1299	329	6301	12463	jxbaJEqq8rVwNwfLsAVZiuc793pFPsGLGCFZgfewGFdXSs4jyCE	9567	13497	13497	1618368660000	canonical
18966	3NK5bkt3FAU7m1Lh7LjUEvuGvKJZcXxHavB2v7jwHd4BP6vdsfgX	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1426	1118	329	6301	12463	jwUaLfV5KVoDdLr44GgkGpJLL1RFuQvkJYz9gpc2sFcXkYVFLfw	9567	13497	13497	1618368660000	orphaned
21743	3NKyaRAeAeAr1MDe8kJR6fyuNdKhiAgGEWmB1x4rXnrVKdsgHJDz	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1508	1141	398	12463	13915	jxGGQh9wmET91ruywWgchFRzEhKMsiPKASSzZQKRjaHVfxKWFid	10888	15327	15327	1618698060000	orphaned
18879	3NLF3WSjFeMTJJX2VgvDrmiUDvWduYHthfcm3rDZo6JheA7wq5u2	18878	3NLjjoQKcvsfnpTVtXkMLtTFGmLFGUcnjhfZpgho5i7DPDK699ef	1581	778	327	6301	12463	jx729t2awJaNLEcF5FbMaZcTARkBa98LDsYH9b8b3oR5Qxf9mpe	9520	13439	13439	1618358220000	canonical
18885	3NKu6PWSAkZG7o6bHYy348aBDPYEqsm1deeJPEeXvYuTLCvv7FoR	18884	3NLNdEsCpm6pgo4kqzhJwUV9wCaYtnPw5QAVMDJNj1pReqpchRnc	1403	786	328	6301	12463	jwdhVMB7BZFmhfHGWa55Z5HdTWcLbj3bha4vM6jmLyb7fKac3su	9525	13444	13444	1618359120000	canonical
18887	3NLeST2McgJpCokYb9darAWAHTV64DDr5C1jtXpTDpYxHTBrmJuH	18886	3NLMmP1M4bYYkwZs7st5rY7gw5jWJPTGx1aVTj92CQF6kYecSghg	1444	1135	328	6301	12463	jwGyXQXYgorZi3YKWZQ35T4FJJKF1abufXKyEbUb8iwg5jxKDn8	9527	13447	13447	1618359660000	canonical
18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	18887	3NLeST2McgJpCokYb9darAWAHTV64DDr5C1jtXpTDpYxHTBrmJuH	1647	1302	328	6301	12463	jwN9J1DVS5Vj3MmqtbBacf51ceEfyVF3QcWzv3dpCdKY5Ptquiz	9528	13448	13448	1618359840000	canonical
18896	3NLMeuMLBidnZ7U99X6tGCoJbfDENuzWp5ZvuU2DrmUZAq433t6N	18888	3NK58iJLfoq7Fj5gbDUi5rVaTJicGBTFt4E561L5JoAsN1ELX3ZK	470	1063	328	6301	12463	jwpmQQybMGsY95jhVP8n8X3ZFgrMNRjTdUFUn9UVCNLQQhwcBeR	9529	13451	13451	1618360380000	orphaned
18891	3NKZi1YZE4AHXj9YU3J7k5zsggvwLXCErdXFPrUtfFc6n9ModfGM	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1527	1167	328	6301	12463	jwswtXSfYhzm1ZwA6kbxausWc4RuqbxQ8U16MXEpHgAHbG9hRhc	9530	13451	13451	1618360380000	canonical
18894	3NL71KgCjF7UjaMNzkcVJiwvYKSqtigNY8XtduGPSiUTGdYZW7VC	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	1402	890	328	6301	12463	jxzqbp2E2iLZrXSgypwhNikj3iEw6Ryv9sv6gz4rLgVtfGKP2av	9530	13451	13451	1618360380000	orphaned
18901	3NLTRJr1o19LAL621Rh9hA2GgvM9o4Dgd3fdLZLRGTj5cf1ijhe1	18900	3NKajkSjinKsFwF9md6XnJ6oVA2WZLLCtJoKvQxx1uVJmTLEQkMx	1534	1317	328	6301	12463	jxrnnsauv5X1dNJRrGAw9HwmtGXtKr29qrezvcmjR4ef4zAhSej	9534	13455	13455	1618361100000	canonical
18914	3NKxS8xoek6FMM8f5jJ8cou6mTu32YhXNoMDmPdrzVc6poaL8f6K	18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	1406	1393	328	6301	12463	jwzf7uxwDkzVgC6phARSP4WKmN3mSr38TRvV2AV1r1va6ELb4q6	9541	13467	13467	1618363260000	orphaned
18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	18918	3NLtaTo25NAk1t55mtdBob6jJGfdAaWMZjqJUB8QR89ZUu3wSmkp	1560	1045	328	6301	12463	jwHZcBwjsgrfW71DVNEPEkaVvseSUSPaafD9TyMEBsBWcBbW14x	9544	13471	13471	1618363980000	canonical
18921	3NKLTF6bk2VV3HiF7LC5ehbKUsj8JRgFn9jws3k86CS4JsjcBmbs	18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	235	235	328	6301	12463	jwKNgRM4Y4Dd3rb91hxzyPrhGXVCFJKKrrznqSknbkPerQa8G3B	9545	13472	13472	1618364160000	canonical
18923	3NK4TSwDRHwwrfNSq9F7QJh8cfTpKNLEqzom9ghjUMmbZK7W9CwZ	18919	3NKsG4owLzhiJmJJhuoPn2p74thAXfsKXbipP5rQBNPDb29DDnyR	1624	1334	328	6301	12463	jwCn6yvBaG65HB53tiBYjd4D2J3hQG2d5CwhzVrJ3U1wMs1s8zs	9545	13472	13472	1618364160000	orphaned
18926	3NLNyop2bYCpuDA8q4jeNBeWRcjQKa3XtMQcCJYZsQpkqHByTNBD	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	289	289	328	6301	12463	jxwENqtdb77Aa7LRjWE899d23MRYS4WFUvdmvveTfLTMPt5Hd8Q	9548	13475	13475	1618364700000	orphaned
18928	3NLaV2nbo8rwYHxQXtkEVHt3kgZ8KQTHQucH2ZBCJQmY7xKErVZE	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	1471	1140	328	6301	12463	jxYj42fEND42BTYkNomSXvsmgF11afVf7qwmPZQ1dnMokV3CvSG	9548	13475	13475	1618364700000	orphaned
18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	18927	3NKexyw8bqNn9DC7fYW8AFjyD9BoSoTbPFsfuu3NBgG7sZp4UeEt	1402	854	328	6301	12463	jxL9iich2BNPzbQbNSTASZJGYXEZsSRdHz7tv9UGdginQL5DTSC	9549	13476	13476	1618364880000	canonical
18935	3NKtwknfN82roECRcDfPMuunNBPA2LCr1gFgxLF13zgvvduuJEoR	18934	3NLZDvbyiWS74PCEqVkWAVi3GoTsHoTxZXzKRMKQe9LR6F9yXmDu	1513	1133	328	6301	12463	jwp33a7FrBnHjdDdbCDH2HPH7ThUuiHMhgpu2Xax4ZVH2AYFqh7	9552	13479	13479	1618365420000	orphaned
18937	3NKTkt7CzSqAinkEwJPtac9rcEntLXe3hSbpgrXsiysEMVHCLx57	18936	3NKKPcVYbFrBcRQP2inXKsnRQDWigW6SMUkXkS6Bngh59Ke4gn1Q	563	1113	328	6301	12463	jx6RZEn6uuPaiZKXw5EKzu4sGaQHdkU5HBUmQB99orMerjbq564	9553	13480	13480	1618365600000	canonical
18947	3NLkfcEJQ49jF6RNWXEPpg5KnQFhqhKrJDiDFCKc4P2Zy3XfN34H	18945	3NLFx6ZG57VvzskTRnFvRDshoPDPNzyzP8BKWLzLsdBQRLmg3FK1	1406	1393	329	6301	12463	jwb9cNE4qu1PBMhe6BrSo5jcuTAK8XNbEV6qj9qfJUkNzzqgbYN	9558	13488	13488	1618367040000	orphaned
18950	3NLf5DcwhJhfj9CVDyqybUXb1xQZhri55hGBmH9rFYw5iHVBNE8D	18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	1602	1243	329	6301	12463	jwqf8tdx9AdMv9oewaetoCVDeMf9pNEFtQtSaRigAEqScS8af1R	9559	13489	13489	1618367220000	canonical
18954	3NL8hMBB3qDMuH8kw9yYKYqMaST4aXBybrx5TN6LT7zeSb9W4eTY	18952	3NLTFYgr3UKjxXFy35xwdyrdnhjV8GZw2RYCTdzxS4vzRczLXtmS	80	1147	329	6301	12463	jx8L6cNkzjzMgZRExbzbsEst5BhKXMBJqyHNW1HqyTtjBahTkFv	9561	13491	13491	1618367580000	canonical
18963	3NKGcm245wG9EbjjvZKbVkVeXm71y9t8bLDYPBRjSyLukMoBRe48	18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	1403	824	329	6301	12463	jx9ruT4aR4JBzQdbcmKzmtYLBVhka44GsxoXNqrRnQvyRAWMgNa	9565	13495	13495	1618368300000	orphaned
18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	18964	3NKRfRrgkbdFYwHFmT8nTWSviDHEAw2ccnzstkNz3499y2Vzrvzd	1419	814	329	6301	12463	jxhPU6a6R9x19GFVBzHPKCA9QDgGBkUNQyPPv4FohByBJjdbynq	9566	13496	13496	1618368480000	canonical
18970	3NLPivAsSETkpi3yCNdzkvGxYYaqHqMdqp2gEcQaZN91aEcXRaKM	18968	3NKHnV41pKGGz36ovPDmPqvS6PEosFJsGJm9V2X8rJ5G7ZfMftRx	1419	814	329	6301	12463	jwoegvVCAPdRch4o5HtZCnEogeRN237CSnfqddLQGkjuv3VD9fF	9568	13499	13499	1618369020000	canonical
18973	3NKndjdvptzrh7zbi69b4XbxPCRcSn163jJQExUQ3uH9oDWsWzti	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1523	1195	329	6301	12463	jwd17BPY3a9nfxVV13AdENpWQ369i19cCaqt9Lj78Cvzt2RCHzT	9570	13501	13501	1618369380000	orphaned
18982	3NKUBAMRq5uR6jkT8pzmo3eZxJmoii2TbQeNw5AuLkqxyFmSbzXj	18979	3NLuLz8gZF1cayo2PtRQGsqpntF4da481xJ78Q9SK6UcNpcEVk28	1444	207	329	6301	12463	jxpVCqeCa3oP5fUNi8ksWr5AsyRYNMMBtmXt8h2ZHqNfmYRrpxR	9573	13507	13507	1618370460000	canonical
18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	18982	3NKUBAMRq5uR6jkT8pzmo3eZxJmoii2TbQeNw5AuLkqxyFmSbzXj	684	1352	329	6301	12463	jxDCQVAnncHGdoa4LXywsSNjY3SnmA6duUk36ja9JXeocSoS6Gj	9574	13508	13508	1618370640000	canonical
18987	3NLAAmYN9hEb2z1SUc3bFMi3iSeW8qW8AqLTfkMyTjNMXaeT5PmB	18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	407	407	329	6301	12463	jwaVNJ7e7f8J8NYEN3ys473diUHMXADqJszpTnMxBEQNPwvYxPH	9575	13509	13509	1618370820000	orphaned
18991	3NLcnoF7rPK3NKkroYxwa3LkYTJpf4gBzZKuJp9A84aPcQuDr1B5	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1523	1075	329	6301	12463	jworhCtHbXWQWe3BXwEMhNwyoeEP6gmr7tjCooGtv1bZVe4T3oT	9577	13511	13511	1618371180000	orphaned
18995	3NKVqMyDpMxqXyPH2tLLZUH6aL97bUug9xhb5NNecg4AeFeHUTV3	18994	3NLLA4oxV8i9No79Ros1cCsLbNUhZATjGV97SREGY3xVZtnkFmvz	1444	1135	329	6301	12463	jws37yxYh3g9fmsaMDEHcHRua5n5XGJNLPDFrKNEkQWyNt9adzC	9578	13512	13512	1618371360000	canonical
21767	3NKv3TXrfhRpMNwFetGMAa1kfauK5PPtRnDv7fRe7gmwaoTmrVoa	21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	1546	973	398	12463	13939	jxuUnNTfpv8UaoRwyv3Qksab9VWGKyG4kxsqFyxyzEiDRRsD5KQ	10899	15339	15339	1618700220000	orphaned
18920	3NLxnCmPhX6uNphnxGKJh73dYpkZFjAVmW5Hg5MDwnL3wyVEWqhV	18876	3NLuu2VfXqt8BVtvuqmPpoHU7VPGeyASqro1VAsoQMus2FpNLLAS	1560	1045	327	6301	12463	jxxYZkUFpyierPD6HuqMe9mrx1XADBSAnbBnKrq5amWJ3BAUvsm	9479	13471	13471	1618363980000	orphaned
18897	3NLcHAupEFCP4j5VMEvG61y3ikuPpdoMAJkr8usbJLNiyimdC4YW	18891	3NKZi1YZE4AHXj9YU3J7k5zsggvwLXCErdXFPrUtfFc6n9ModfGM	596	1180	328	6301	12463	jx94hzG6rkffCLYprn6QG6ZDmB5rGqJghmjhjrpaBZrq1TamacT	9531	13452	13452	1618360560000	canonical
18898	3NKBbcNutDabHK2r2KzJhCP2mSae2biZ2FXWUX7EQzniQpENRHLJ	18897	3NLcHAupEFCP4j5VMEvG61y3ikuPpdoMAJkr8usbJLNiyimdC4YW	1637	816	328	6301	12463	jxW7hzxebwzXTV3C3Su82DYR3bpJVV6qUFBcDzh3itNnXK2pooQ	9532	13453	13453	1618360740000	canonical
18900	3NKajkSjinKsFwF9md6XnJ6oVA2WZLLCtJoKvQxx1uVJmTLEQkMx	18898	3NKBbcNutDabHK2r2KzJhCP2mSae2biZ2FXWUX7EQzniQpENRHLJ	1601	1142	328	6301	12463	jxA8rEpMGRrU7tMAi7XRcK9ZVJCHphSwu5qFz67JmhwHdPeVGUU	9533	13454	13454	1618360920000	canonical
18903	3NKAP8uWRFn2g4h3HoRMjkXKjKLfpReYBkDsgcojNMM7oeKvhyoT	18901	3NLTRJr1o19LAL621Rh9hA2GgvM9o4Dgd3fdLZLRGTj5cf1ijhe1	470	1063	328	6301	12463	jxeGDTr9osUqHcushnKuknfXhoLviubvpNgtSz62CDf4M6wkTdw	9535	13457	13457	1618361460000	canonical
18905	3NK5jjyZpj8Xqsib9MpoXvhYSpjk1nVTt1VyHYqXbtDu65xxA6kz	18903	3NKAP8uWRFn2g4h3HoRMjkXKjKLfpReYBkDsgcojNMM7oeKvhyoT	1547	1378	328	6301	12463	jxhtEqMkMVsCLKMLHeezqQajy1D5j711enakHnJfDX8frQZLVrs	9536	13458	13458	1618361640000	orphaned
18910	3NLSuaZPU4hVeaGwycmqX9jcpgb8Bdrw495Aj8oe8kmst7Tiax7J	18907	3NKpcvFjUwfJRBa3HTzLcykD76HkMJV4AEdgAAgCQg4w6KLkYMKy	1534	1071	328	6301	12463	jwxyJYNpmjcet1bG3FjCct8L1bN34dA6oPC4yAJXgn3QDmy7Zup	9538	13463	13463	1618362540000	canonical
18915	3NKCBT87G4cMDot4vxttSgRKDwbFYHVAxC2sr9fpiQYtQoCRxz5J	18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	1654	1214	328	6301	12463	jxnF3VHRCtuEYoDwyPnVsJUsMiaPZs51RsunkHvTK6ot4FMFDYH	9541	13467	13467	1618363260000	canonical
18929	3NLrLjY9P4pXnHvQhLxB84uoTkLUpBAwtcgS5dqzaUrwuXBTUx4v	18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	1406	1393	328	6301	12463	jxsGqkXfCaxA9bJvkCXgu7n6XUR1TLLMHAV2aiLk6swDZjwdbcE	9548	13475	13475	1618364700000	orphaned
18932	3NKCkArFFwWs3e4DdeMXZ9cvdDCASd2ZuDFkoyJukEASRLBS1ZXN	18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	1474	1083	328	6301	12463	jwsP4q5MCSxvRgfChz96r3JB4MqNpia32Dyd8fdMD5ttSaDydzM	9550	13477	13477	1618365060000	canonical
18936	3NKKPcVYbFrBcRQP2inXKsnRQDWigW6SMUkXkS6Bngh59Ke4gn1Q	18934	3NLZDvbyiWS74PCEqVkWAVi3GoTsHoTxZXzKRMKQe9LR6F9yXmDu	1631	794	328	6301	12463	jwfgsK2LphzqGXBPgKwzj7oxX3tpUpETRdYTMTrYCph2wDvDYXd	9552	13479	13479	1618365420000	canonical
18946	3NLo8oGWtCNEE2nGFafhPCYTV8pbH61PRhwKsKitdf7BEJ589G1i	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1599	1287	329	6301	12463	jwFBQ9FpnBSv5edsSYCJQXxtG4kHSiL8JA7dFdH4hB1YNo8xsQT	9557	13486	13486	1618366680000	orphaned
18953	3NLxb1wyEe9EozegL5ZgEEyhE7QbMr3vuUdjU6YHH34eUdREA2ho	18950	3NLf5DcwhJhfj9CVDyqybUXb1xQZhri55hGBmH9rFYw5iHVBNE8D	1549	1116	329	6301	12463	jwTLZ2KT2gkuJ3hW4afVXtbsd6vcRBMVW98e9TVUDu6ZCdgMt7Q	9560	13490	13490	1618367400000	orphaned
18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	18954	3NL8hMBB3qDMuH8kw9yYKYqMaST4aXBybrx5TN6LT7zeSb9W4eTY	1406	1393	329	6301	12463	jxBBwdUDJshyrPktGGBbcRNWZYWC6fzNnPX7UMTn8pCLvEk6HL7	9562	13492	13492	1618367760000	canonical
18962	3NKTnV1419pwuLm8geUsRACmbgADSk1NLg4DkGZYMmgxntjjDA3f	18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	1448	1311	329	6301	12463	jwyF3MSqS8Sd6YgCHib2JFRmg7Qzg2LbpQdz8suxqjcRyyjUtoX	9564	13494	13494	1618368120000	orphaned
18964	3NKRfRrgkbdFYwHFmT8nTWSviDHEAw2ccnzstkNz3499y2Vzrvzd	18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	1553	776	329	6301	12463	jxyuVAbiVGxPnjo8E5gbHP4vjXmfuYuCaTNb13Tmamfv7TrR2iU	9565	13495	13495	1618368300000	canonical
18967	3NL1gZzWKvFKjXD8r1yJ7oUgxM1ViQJbUzFJ1o54Jg7QKaeSZpbQ	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1406	1393	329	6301	12463	jxymJcmraLU2xBp5txioani8C2TpEHxcL7WZb7oxt7P1DFEeG5s	9567	13497	13497	1618368660000	orphaned
18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	18970	3NLPivAsSETkpi3yCNdzkvGxYYaqHqMdqp2gEcQaZN91aEcXRaKM	1529	1316	329	6301	12463	jwSsLbzjWsHa6WSqvtLWprJUPrc4VmA2GD1jKzYDKDeWyYVj8BA	9569	13500	13500	1618369200000	canonical
18979	3NLuLz8gZF1cayo2PtRQGsqpntF4da481xJ78Q9SK6UcNpcEVk28	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1648	1158	329	6301	12463	jxLYB3GJ7mhQjzxFJoA8dUM2HcmiPcKcP1fuqeQffHwRubTN8vm	9572	13506	13506	1618370280000	canonical
18994	3NLLA4oxV8i9No79Ros1cCsLbNUhZATjGV97SREGY3xVZtnkFmvz	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1611	1341	329	6301	12463	jxCdMnX9NmDSQxD8iuqneaJxjZCMHNv6mzyrboPR6KYTLeohdPZ	9577	13511	13511	1618371180000	canonical
18993	3NLWJmBgHsJvVNfjKq7kumoVGwQsBUg8ChxNR48YwpKneGrbjgr7	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1523	1075	329	6301	12463	jwYsdDV41CgffHNFuvxaM612q6ps9t4Xh49WQPLpVN55t9Dgz9v	9577	13511	13511	1618371180000	orphaned
19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	18998	3NLUfQGM6app2TggiE9NABfR2KsMYiESsG7VvHBZAebpSj27jFrm	1651	1301	329	6301	12463	jwus7FRiCpEzoaWTEvQcoWMu4ymha3VUbQ7KwnHrM92o8qFdoQZ	9581	13515	13515	1618371900000	canonical
19003	3NLCu6zU6BecgxC3yETZZYPuKQvGibebdy22DXyWkH83VCoArW5n	19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	1527	1293	329	6301	12463	jwTS53FhKxRsXFvpSiNToAkA717eNziNDwWDrqQh9Aj7nQJ7EEm	9582	13516	13516	1618372080000	orphaned
19006	3NL7vxrdH9hpqe6LkXYufnizgsoBUgCD2N3FuMU8Bkv4k8Pcp2Fn	19004	3NLNHdp4nb9Cg3FeJ7R1924zzf6Bqxrp2bnUPqzhVDmmNPX5RkSj	1587	1357	329	6301	12463	jxbGgUPRTiTg1KUGAnX9FYnqQcA9FV9MuYbJywbayTU59jFCYPT	9583	13517	13517	1618372260000	canonical
19008	3NKZxEwGdjMArkC6iawXrwkHiRLhmy3ou1nVAqoVAAKHxB9qXjcq	19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	1610	467	329	6301	12463	jxus4k4Xad2ndALkCpSCGZqn2AXHE7rydQTNJ7FWYGiim5nUND7	9585	13519	13519	1618372620000	orphaned
19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	448	939	329	6301	12463	jwWtdAMHNJTY9Vttik9hP2E2ZqPMiGZxqyNj2nKxtJcjXDDTBf3	9586	13520	13520	1618372800000	canonical
19015	3NKVXtR5ibuXmmrCah1hRfT8iS7c9oH7mQyTC7TfFfrazmhgBTFM	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1503	1151	329	6301	12463	jwJkxzQPdyjRATdwTKyqdXPP4sveEWTYmDaVjbZgeXG9RkHRppm	9587	13521	13521	1618372980000	orphaned
19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	19018	3NL3CrMRHqxhi5T1ffoxw4vQuLAoWBG6o9fYWLerTjZdJnerGVkE	1593	1100	329	6301	12463	jxaP5LGhtWELMjEKMUWPFnBSwnPQwPzQdFaQPKxUMQuXR9P7chj	9589	13524	13524	1618373520000	canonical
19024	3NLs2vEMN426P6cYQ7j7dkpYbzESppcgUudBYnJqw1TRPQQ2kbZb	19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	596	1060	329	6301	12463	jwhEYQuDFekMvUsy2CoJRmDSScDM2cZNmtsc2Grx19L6iwg3PEM	9590	13525	13525	1618373700000	orphaned
21788	3NLj4A3QRi4VtcX1Sw6nVrkuH4M2BXVjh6bPUXV2PQUVVtbhkRuv	21786	3NL9BoV6sb6CHnVKMFHfvJLSb6fYc9w7nam2Q6aSzAceE8EYaNJK	1613	1349	399	12463	13958	jxwdAT6NyoE9ctm6N1rJCu8ZGnKMUtCjQnSZDW8m8TVj7RZU277	10908	15351	15351	1618702380000	orphaned
22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1460	1198	417	12463	14594	jxsEtzGqcpuiAF5sxCuXz3CtRW97tV9GQTvsFo8xuZ2KgJ1EApp	11253	15839	15839	1618790220000	canonical
18913	3NL245HJsCZ5jYhyc7rSeTunF9xVsYEEDV7DYfAa5s6Ga5fZBde7	18911	3NKadQbzUZhitND9Z7pjvWawoxZRZypE5PZN2Nx2S85baDNwsEZm	1406	1393	328	6301	12463	jwDAQEUtusBX9cr7tt5gHVEW4Ww5MNVDdRYBJCjgEpX6Zbn2e4B	9540	13466	13466	1618363080000	orphaned
18918	3NLtaTo25NAk1t55mtdBob6jJGfdAaWMZjqJUB8QR89ZUu3wSmkp	18917	3NKwcPF9YG3r1bcEXxvTa1U6Q7c17BDsz7xf4Hkts1Ad97QQ6fS3	1451	1292	328	6301	12463	jxHcz81aixdjUv979yGqW3J5dBHhUokh6EqTZy12Fw1sVhtk6a9	9543	13470	13470	1618363800000	canonical
18925	3NKMXrq41RzcY1iRsCUxgr1hwteNptLasW71TPM1kNiDY8673Bv5	18924	3NLqN6HSQUDmowxCU3DMZLSseeZq9XFApNeFWDVBBVhMemh915mK	1501	1360	328	6301	12463	jxWGhCE9EZ1PPcuHYwZETUVFG5fWX5nR6njUsZt21QTX61RLNEQ	9547	13474	13474	1618364520000	canonical
18934	3NLZDvbyiWS74PCEqVkWAVi3GoTsHoTxZXzKRMKQe9LR6F9yXmDu	18932	3NKCkArFFwWs3e4DdeMXZ9cvdDCASd2ZuDFkoyJukEASRLBS1ZXN	1541	1052	328	6301	12463	jxLTcnhHVh1rc2YocfU8JWsk3sDYm2WhVVJMzPyWqEWUGpZhwu5	9551	13478	13478	1618365240000	canonical
18939	3NLDGKnGuvuYxnDgg1aig84vhdE6YrAbaRG4tfn5o9ACBnqWYzRw	18937	3NKTkt7CzSqAinkEwJPtac9rcEntLXe3hSbpgrXsiysEMVHCLx57	1407	1395	328	6301	12463	jxvXf8YwX7cwu4VMsGrmBpdqrCLAqUPDXEwbFKTGJBvuTDRXNrA	9554	13481	13481	1618365780000	orphaned
18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	18940	3NK5bhsDbfwxaitK3w8ixtsd4YPguCU2QLKPB9gCscEJC5fZuDtX	1407	1395	328	6301	12463	jxVRJCy4MCvwUSUxcc6JHUUXCTyay2NMSc5EubaLLLEUEyrXeMQ	9556	13485	13485	1618366500000	canonical
18944	3NLfAN69iW8vg2Z63QiNUFyQniDEmDy18LaZ8PJ5pVJkVE55YcgF	18942	3NL7uEr69Dx8ZyVd9rpiaEpgqk5wnoq1bAvMerg9uX445oM4X1zh	1599	1287	329	6301	12463	jxNPE6V3E6uudeCUy8hHVndSG4K7qE3k4s2pktPhATb8oXDmrXa	9557	13486	13486	1618366680000	orphaned
18949	3NKP9JaKZpTJRLftFZDPctdzrad2yc6ePHef63u5MBd7Rb7nHnJV	18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	1406	1393	329	6301	12463	jxk9FHDMDNBempeDnfSxRuLNmBxTDQPokVcn9xHxZqowZZS5iAU	9559	13489	13489	1618367220000	orphaned
18956	3NLwaGn4crxA6Pt1WXy2iJC6ELnDGZoQgMB7n6T2Gk1HdQ4mtmqT	18954	3NL8hMBB3qDMuH8kw9yYKYqMaST4aXBybrx5TN6LT7zeSb9W4eTY	1637	816	329	6301	12463	jxjo9umDeq8S2HNrXX7oHnnHSaQsEXHofacBRXaVUAtaNXogZXY	9562	13492	13492	1618367760000	orphaned
18958	3NKCPny86GxHUqcb41zhBfhkRcB4g2Yx2rjvTSEPhbvxRbHBUnVj	18955	3NKQy5GVqt3QxG66xBxb62PEZ8QGoM4AME6LojbTVrHtc7okWMZS	1581	778	329	6301	12463	jx4qUh42hcEBskvNZQA9yX7BVWtiodTw8GtDjKHn3ZPxSRJJr1B	9563	13493	13493	1618367940000	orphaned
18960	3NL5XjNNiH15R6xQgu9oUmcgpy1UEMQswrdA1xJ2Qk9egnFGDyi4	18957	3NLdL8du8JKMpDG6efVFsKkA42HK4c9ArYWicepoJy3Fz6jWvube	1405	867	329	6301	12463	jwnjeTDqpehaj3RnJZHV89FN8Gs6SayqQNKuADomPCzz7FssQ3E	9564	13494	13494	1618368120000	orphaned
18975	3NLjSNZs17HecHpCAARg7qcgQEFbL7vzFaqRGjM1jAR9Dx4fvfLr	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1627	1385	329	6301	12463	jwiDeBngr5QhgLMLgQAGSgy6RzEj79bTJh3MAWCAjPfrBqcsiVi	9570	13501	13501	1618369380000	canonical
18972	3NKBprv6CPjrEPR1em4XcHKo7eSvontoyXiZmkd6YNKYmvvpNjQm	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1523	1195	329	6301	12463	jxSFmcMbrdbhwHRXzsLiPApwHRDrhwpcp7ax5TjSjAEGnoiRJ8H	9570	13501	13501	1618369380000	orphaned
18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	18975	3NLjSNZs17HecHpCAARg7qcgQEFbL7vzFaqRGjM1jAR9Dx4fvfLr	1601	1022	329	6301	12463	jwLJopNBnEWyFQYzKUtusbCMb12NaCba8vWxkuS9toT2JRifvYh	9571	13505	13505	1618370100000	canonical
18981	3NLH3AhPucMi3pg3G7tpYiJih21JVGeBtmUGeVNGbgnkjSCJuYFV	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1559	1353	329	6301	12463	jwoAFNtwTrjTBw1S9VZB4CNZVV1vQrXwrHUPzBzGkxX7sLrxFwt	9572	13506	13506	1618370280000	orphaned
18978	3NLtNDQbc4aEbJpcrrZY1xqPEJCoB2Yi3sESmAy6E4Td829C12jd	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1588	1392	329	6301	12463	jy26AHCfTGPSN32gqM1m1HnDooupy9QyD44UKz71QmaHZMkM31h	9572	13506	13506	1618370280000	orphaned
18980	3NKb8ahWP3UWexPAvRKx13v89kW3eChMqhX75RCMudnb4RtCQAxn	18977	3NLutbNUoY66RDiitQVn7uBLE9A2QfsTduTynPGEVnmVtNuiays8	1559	1353	329	6301	12463	jwF7KEN5svQq7rsLsKBq5qvxrEbromtAPcfVXdZaGzvVVkcHC7D	9572	13506	13506	1618370280000	orphaned
18988	3NKqoQ5h61WaGfxV2EP6KW6b5EzvmMG4m2fbSKotoiqwf147CGKs	18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	1590	1054	329	6301	12463	jxV66t3Q7AHW3oZsybY6cLJpdgxMy7swx8JzAWSZ9XZ9qcJXAY7	9575	13509	13509	1618370820000	canonical
18986	3NKVmQYzKRWLdjmWSMV8eqURGG6uwzap3Y8qztzqvfyvvQJmZ5D4	18984	3NLZ5R2dpw8VVSp9DbzMMMJP9ZiMk4ymj2uDzSyWtL6cP2eBYPQD	1668	1370	329	6301	12463	jwWsHvqRMuYRrfFWiXtkVsafT9XimmR2D3LPjnFiYGNR8GCP5J7	9575	13509	13509	1618370820000	orphaned
18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	18988	3NKqoQ5h61WaGfxV2EP6KW6b5EzvmMG4m2fbSKotoiqwf147CGKs	1553	776	329	6301	12463	jxG4AbTpoXWtZAds81a34m61kpMsrd8xMh5S3cTgvEcuzh9m2NL	9576	13510	13510	1618371000000	canonical
18997	3NKrSH4SyDpmm5HHZr41eNUSjZiv5xQdzQSUdsKHckFYS9Ftxkpp	18995	3NKVqMyDpMxqXyPH2tLLZUH6aL97bUug9xhb5NNecg4AeFeHUTV3	1419	814	329	6301	12463	jwfsrrfHZAVcRtqP5Um3tL47h9BtHpyHQkEDkryAG4he4NJS6ik	9579	13513	13513	1618371540000	canonical
18999	3NKfdMiozVtTyH5axaoHiCP3thScEV56EHr8ECC4oiCa6FuEJEA6	18997	3NKrSH4SyDpmm5HHZr41eNUSjZiv5xQdzQSUdsKHckFYS9Ftxkpp	1627	1259	329	6301	12463	jxpN6sWcASSYNTCwsPYrMaWUAUahiwJFupDw1U8b3eUgbAhBtfb	9580	13514	13514	1618371720000	orphaned
19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	1503	1277	329	6301	12463	jwRjZZcUTLnrFzr7R2jDBvKEPump6LEwJLFTgGCRaZwg5yrQhFx	9585	13519	13519	1618372620000	canonical
19013	3NKbxWu4hYsxcvTBing3g8c6bMvwCzxLkon1K28cVwkSK1ieAjAf	19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	1631	794	329	6301	12463	jx7DiPN7wmyDY47XbV1EYKKdiDSydj4YkNTsH9ToUzQ53cDjD1j	9586	13520	13520	1618372800000	orphaned
19017	3NLfrWXG4Hm5etUCNKupmEskrp6gXTrp7rUJpWWmJ6D1tscvULZs	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1650	1375	329	6301	12463	jxyeQHdhYbhZYXrHCY8Nouts7Jf1SxXFWyxhdQzyCBrfUwAj4NS	9587	13521	13521	1618372980000	canonical
19016	3NKij9MDMsB4wnV8ZxeJbD44cpfHk7y5PYJ4KC3AurCVaiQxm3uC	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1547	1378	329	6301	12463	jwtk2nf9wH9nY9wFa5aGWi55MKWgfTR6Xbe4ytHpSWWKB1TsMJs	9587	13521	13521	1618372980000	orphaned
19022	3NLQ8WsgP3joyyHuocRhqm6wpML6RMikM5P2eseXxgrE4jaczCEd	19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	596	1060	329	6301	12463	jwhEYQuDFekMvUsy2CoJRmDSScDM2cZNmtsc2Grx19L6iwg3PEM	9590	13525	13525	1618373700000	canonical
19035	3NKszSPBVFDASNMv9SsxFhD9PpB45LHmCJ897Tk8AEogX2N39JTw	19034	3NLEma2D1Lxn8zeCLRNQUbdZvpdvgDQUVcvqgubDVaMHb2Haon1o	1534	1317	330	6301	12463	jxUTa6E64xVphszvpZkG7JYaAzKmPsuoVuDqNhiUBxqav4SAkML	9599	13538	13538	1618376040000	canonical
22216	3NK5sibNamMXwV9iTswGgovicEXm7j38Zfd2L9Si9mcfmGWjZ7A5	21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	1403	824	399	12463	14344	jxohfvhTNw4eSawfVXjskmeAmz734Xtszfx9qu7J6JDHHbc2SsB	10910	15659	15659	1618757820000	orphaned
18983	3NLNWGpbwgJesYzw2nJ5R8tz2S18ECN3t3JzeNxHsu2CLZJs2dZk	18979	3NLuLz8gZF1cayo2PtRQGsqpntF4da481xJ78Q9SK6UcNpcEVk28	1406	1393	329	6301	12463	jxC7BJEXaibXZ3vdQCBXZet27ixfgczjUu2C4twKgZ1RDc698jM	9573	13507	13507	1618370460000	orphaned
18985	3NLZSubVr1ze7zSMAGKXaQ9p9xK1JX1WaAhcLEwNqK3X7TxrbK8W	18982	3NKUBAMRq5uR6jkT8pzmo3eZxJmoii2TbQeNw5AuLkqxyFmSbzXj	1637	816	329	6301	12463	jwWMPAt3SQTZ55vTGHgSQF3n55wagSbQ1EAPPKX4YCix9amRLZV	9574	13508	13508	1618370640000	orphaned
18989	3NKH98b2tNttqi1pWxwehyHuwDturjMtGpaDnEBqjQKgDHGVQYMp	18988	3NKqoQ5h61WaGfxV2EP6KW6b5EzvmMG4m2fbSKotoiqwf147CGKs	1402	852	329	6301	12463	jxRiNWAhbdd7QTDvRjUD9ZxLPDHthRUKP3XcPkbSMqCc8WQedMu	9576	13510	13510	1618371000000	orphaned
18992	3NLek1pki11dLxh3HQPardsUrRfba5UKLcuNQda6GACzHYZpFuBz	18990	3NKcFTJAsW4aLBD2QFnPswNHero2Uaz5pLVr5oLepRUtzWkvpSNq	1523	1075	329	6301	12463	jw874gcHyewsaUQvEJNv2JEDpX36hRQchPn27wiFFHZBhXJ5dhy	9577	13511	13511	1618371180000	orphaned
18996	3NK9GywFgAVBWBDSVb4VA3VgpkLcX5brW5ZWQzVe5aErJp2ixQQJ	18994	3NLLA4oxV8i9No79Ros1cCsLbNUhZATjGV97SREGY3xVZtnkFmvz	1403	824	329	6301	12463	jwwQymZRsx2twCEoTPehuQXyuVXwmYGicDsToBdXy4iAouGvTmc	9578	13512	13512	1618371360000	orphaned
18998	3NLUfQGM6app2TggiE9NABfR2KsMYiESsG7VvHBZAebpSj27jFrm	18997	3NKrSH4SyDpmm5HHZr41eNUSjZiv5xQdzQSUdsKHckFYS9Ftxkpp	1599	1161	329	6301	12463	jwnL6B2Ee5rWwDgjLrQXMhqWLgXQ2W6bKCYWZbPJkVheoEuyTnd	9580	13514	13514	1618371720000	canonical
19000	3NKcMShfWaG3qHrhVL71sw9K78r9eR5YQfMv9osVzqBkjBHLwCjx	18998	3NLUfQGM6app2TggiE9NABfR2KsMYiESsG7VvHBZAebpSj27jFrm	1651	1301	329	6301	12463	jxVwrATBtTFPqtmHEjhB3PcHkmWpUMnLxp4YZq9iYminETpkwKf	9581	13515	13515	1618371900000	orphaned
19004	3NLNHdp4nb9Cg3FeJ7R1924zzf6Bqxrp2bnUPqzhVDmmNPX5RkSj	19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	1527	1293	329	6301	12463	jxAFLuUCKJnfp7mhVPNjuVUz5VkVap2VrF5GEFrG2Dg5AbV8D1V	9582	13516	13516	1618372080000	canonical
19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	19006	3NL7vxrdH9hpqe6LkXYufnizgsoBUgCD2N3FuMU8Bkv4k8Pcp2Fn	1588	1392	329	6301	12463	jwzXpLtxvu61p4c3KFkrMtTv71cJs46ALfnAnPB4ddMskKTAuuw	9584	13518	13518	1618372440000	canonical
19010	3NLhLHtkaMR93g6AbmQm5rZQub13sae6xuC6uxqFZt6LXcadFm9y	19007	3NLjAmtqA5ZYxKtRmCpuBpYms5JyoUVgJtzs34Jgrxpn6cBcgCo9	1405	891	329	6301	12463	jxRi5HfYZ1uwQbBTivfadei4cvjgu1t9t4tVkzRmfHn1nMfkw8k	9585	13519	13519	1618372620000	orphaned
19011	3NKRxaXmyLvNQEGS8NY8r8rRP3ydJfEDtFSkysrohk55nZvWsmHp	19009	3NK6u1H1oT88goJZVJ6snV3FB1BtUy18u67cLCszn86Fa2zYoMMb	1547	1132	329	6301	12463	jwGY1RvnTG63JR81sCRAkPtXAKMM7D326GQyjnCmFVsksv1syVA	9586	13520	13520	1618372800000	orphaned
19014	3NLab5fxCtHMSzUcZw9iJCVugZKG7qAjS9vy3sWULemv5ZyHu7yF	19012	3NL9tqW5w1LZ65bDdVuFy9R8NiYKYtRYZLAkjXcUDrrUd44NHghJ	1483	893	329	6301	12463	jwjhqLeLn36NFN2TzArfbxwJXsNKq7B1DdLDYNfUWNNyT1rCTnF	9587	13521	13521	1618372980000	orphaned
19018	3NL3CrMRHqxhi5T1ffoxw4vQuLAoWBG6o9fYWLerTjZdJnerGVkE	19017	3NLfrWXG4Hm5etUCNKupmEskrp6gXTrp7rUJpWWmJ6D1tscvULZs	1623	830	329	6301	12463	jwzgUwSdUEG6Ncr1sikXujiRSu6PqVvpwsYSbAcm723xRvjNhGn	9588	13522	13522	1618373160000	canonical
19025	3NLrXFoojixQ7x3rUeppbJNzpNebJL7VQwfGtGaVCGnRPQKJXLVR	19022	3NLQ8WsgP3joyyHuocRhqm6wpML6RMikM5P2eseXxgrE4jaczCEd	1402	852	330	6301	12463	jwPiMCGx9TTWx4tLykFsdndFWPBEYJzMDMdySBPBiNpg1Xm4Gch	9591	13526	13526	1618373880000	canonical
19026	3NLqoso28pDL2rCCdWAeFcbHMbzqxm62HXvZBduzru6H3SohjaQP	19025	3NLrXFoojixQ7x3rUeppbJNzpNebJL7VQwfGtGaVCGnRPQKJXLVR	1405	849	330	6301	12463	jwWUZkW8TeAAycE2ev5sRzWnBSkFcDd3VTJGgKcxX9UVsGho6Bt	9592	13530	13530	1618374600000	canonical
19029	3NKmzoQsW4i1LXBPYJZTfiqBZBEgGvQf86qkoi8PGFN37gybjq95	19028	3NLS6d9Q7diuNtP4NEUHdXYtmdFa6upA6nNJx8aesdgcTYpC5Veb	1607	1102	330	6301	12463	jxrDt3tWDV5JYNZLTEZV9uwDeLij3w1UaCUQtVoMotAXqeYjgjk	9595	13534	13534	1618375320000	canonical
19032	3NL7YzF6VS1YZf67qeSKtTVFrwjyiFhQqP8zA6nmuUiaA2YRv7z7	19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	1585	1366	330	6301	12463	jx1m7MVesWPaC5oc43zZ93rrfRwG8Yip5SKvcNWdyXyX5vKZbmi	9597	13536	13536	1618375680000	orphaned
19034	3NLEma2D1Lxn8zeCLRNQUbdZvpdvgDQUVcvqgubDVaMHb2Haon1o	19031	3NL2NUhwbxRk5ucjyw57vHzFZ78Yp4g8zwjZ1si7jFQ5GKp8LsA8	43	1064	330	6301	12463	jwWcBXxDZBD5FuhHiqo5rZAhZJ2ddvHDg4x3bgtEzYYxtyyJvBz	9598	13537	13537	1618375860000	canonical
19039	3NK5xpze2Np2FbvubBxvzahwaxz5x2YzSLk2RQhF4XAzcG9DHxCj	19037	3NKckst2tWb1KUvHdvCmfUvSV4QN8arS7nzp9vpGQ1fkeyYgLfDU	1406	1393	330	6301	12463	jwE9YbArEwLmBv56LY3hA3GyH7X4gMYjjsuJQbrtZHWgkbPAZyq	9602	13541	13541	1618376580000	canonical
19042	3NLWwRGYpXfdktDYVeMiYKsM5sMFRZmxzampNcPsY7Hx8YMbsdoM	19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	1553	776	330	6301	12463	jx65DfcxLRy4wEWcYMGMmbYGNxg1ApHDnAEaHiveTGGu8AYrbRy	9604	13546	13546	1618377480000	canonical
19045	3NL3YEE4u1tRekLHakYhhRZyRqpH7FEcB2CGUYW8NktoUzYM13RQ	19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	1523	1321	330	6301	12463	jxKVW89ovwgVFmWobw1otDwCrBzrSza72jGwh6PYjwRXwkvko7T	9606	13550	13550	1618378200000	orphaned
19059	3NLUnYg9MeNN3Nt6B6DgZ9EshjfQBNLh6XfhjkdMPbG23MwSWRDp	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1578	1050	330	6301	12463	jx8s6nXsaxi9KLTPJMqkNMbC6kjKxn98Fu7vRVhjtjn9NAUctoe	9612	13564	13564	1618380720000	orphaned
19063	3NL59XsvU5YUf1dk3kyN8UkURjmobDjuDtt1RnhaKXM8aDoCHLiY	19058	3NLfuQbbTYRf3T5aGCmrVMqjDSfs12q6fRhJVpnFRM8q5eU5Ag75	1403	31	330	6301	12463	jxuuC58MHHmVKCjcMEzBT9ehgbbiLJCu7oibCbJGVMM2BqFuYnH	9613	13565	13565	1618380900000	canonical
19068	3NLrmFQeBM86Bgtta4fnb1Vk5oLbaTTcV4843PdQj8jcSCAaCxHq	19067	3NLab5z6n9pKgB7eSdir2hUhMxE52EczNMaJ51xUu76iXqkLJhEa	1406	1393	330	6301	12463	jwxF7MpwGf8dAbKio8QFt9Muk97CFuSTBPvLP9HyHnMXdthNia7	9617	13569	13569	1618381620000	orphaned
19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	19069	3NKjW41aJ9D59kxGCuy9bJyW9rjy5Z7HtFfycK31ZyegCrFKYbsJ	1406	1393	330	6301	12463	jxDy8tALuKYZdZz3YaDS6dPiEGoDxfxt3es23bNcyVb2RvSwcQd	9618	13570	13570	1618381800000	canonical
19073	3NKQWbQri9jPnVUQjRW3zxSHzY1ohr5YpFiEM3aSQ8vX8oAiyKjS	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1643	1173	331	6301	12463	jxvWTk5eei35izBHqrbKin2h9jbdzp1L6HA9zTtn6pRxEfXLsLc	9619	13571	13571	1618381980000	canonical
19077	3NKh1cUM9rTkVUNC5PhGd48mSibw21Rp1BWCpmYREAXeygSp3Xob	19076	3NLfhHQXr48EKj1QSPAcXkeWJGExBhV5bho1DtLEXNkThdEtsGmn	1553	776	331	6301	12463	jx5xBnje2QsfDQKcEz3mcHVRcRtfcRDvCaKrSfqgfoZi4iZfXFt	9622	13574	13574	1618382520000	canonical
19082	3NKWYqEkQUAfkp8v35zVujkocvwn1KgVeszNksijakxDWT1xFvjc	19081	3NLnbdMcDqxAtuP825Cizmk8jUmagqWCNyPr2QTDcYrTgqNQ8uFi	1403	782	331	6301	12463	jxKUfusWVJUp3pg5nhMyVVcksFGawj2HTBtYz9dzWuM2XZ35PVG	9625	13577	13577	1618383060000	canonical
19085	3NLfwkCS5zTsGbqE85f9HQhprmqsKjJeRCd7vsKorR8HEZyFtcMU	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	80	1273	331	6301	12463	jx1v9uJCzNRpkbcvGtcgmpUzaPAo3zfniL1oSVCarCPRQKfHVFj	9627	13582	13582	1618383960000	canonical
21967	3NKMndxDe9ySV6zrcEKzVQBU45a9pDfYpPsGhhsiUn5Zce8hCfuY	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	532	1303	399	12463	14117	jxQRb4XSxYvwsJnPPFja3PqeUdnHRYo3NjtoryjQhEHN91XyMFr	10912	15473	15473	1618724340000	orphaned
19023	3NLcCeSot7hFFRygRHxinfuq5ow262WkvTjsA1bFDVcTViLKemUV	19021	3NLDntRpiznoZDPhrepnc9UWEpPFEZsgVxiorhEcHLQC4yTijuQH	596	1060	329	6301	12463	jwhEYQuDFekMvUsy2CoJRmDSScDM2cZNmtsc2Grx19L6iwg3PEM	9590	13525	13525	1618373700000	orphaned
19027	3NLZfPXhv9UgBqLsbZgypy9S69F7SgAs36fAZ1DEmv3h3HNHME5W	19026	3NLqoso28pDL2rCCdWAeFcbHMbzqxm62HXvZBduzru6H3SohjaQP	1406	1393	330	6301	12463	jxAiU3US3DTVWFicLnxKBp7j9DzzG3tvHLseujUgNbUC84v82rt	9593	13531	13531	1618374780000	canonical
19028	3NLS6d9Q7diuNtP4NEUHdXYtmdFa6upA6nNJx8aesdgcTYpC5Veb	19027	3NLZfPXhv9UgBqLsbZgypy9S69F7SgAs36fAZ1DEmv3h3HNHME5W	1455	1086	330	6301	12463	jxwi9hTthUh6dudkreGZvsHGgzdodVszikHJDbvcCzybzqDvyoR	9594	13532	13532	1618374960000	canonical
19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	19029	3NKmzoQsW4i1LXBPYJZTfiqBZBEgGvQf86qkoi8PGFN37gybjq95	1406	1393	330	6301	12463	jxbTRMzFVZZKXaDQKrJJmvZFJfbvHCronWSaGWi99ZFG8DAzKPH	9596	13535	13535	1618375500000	canonical
19031	3NL2NUhwbxRk5ucjyw57vHzFZ78Yp4g8zwjZ1si7jFQ5GKp8LsA8	19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	1403	824	330	6301	12463	jxmpTWnhTLUxLftghLQKVquRusEJezuwexAtcM1j2UJJLkSibMz	9597	13536	13536	1618375680000	canonical
19033	3NKwmom37gaA96BduZguYcdGTSAgBtShUdFMArF5NSoJNcaDsz7w	19030	3NKp4gikcFasE9pk4p7DwhJVj2evQB4g73BwuHF9hb2yG4kupFZN	1637	816	330	6301	12463	jwbxdNVJc62FqqRxMPLwFsCSHsfRV9gVZ5oaL2H8VHEyW7Lqqq3	9597	13536	13536	1618375680000	orphaned
19036	3NLaHWkXXEbHsnJeQEsvkhvAD9QhTjP8VqB1bDqSyKopdCBZaK9J	19035	3NKszSPBVFDASNMv9SsxFhD9PpB45LHmCJ897Tk8AEogX2N39JTw	1516	1048	330	6301	12463	jw9X8EaVuspNxfaXzJ1EUUszn7uhtrsBeMqnzLPZBcBJRAhBouq	9600	13539	13539	1618376220000	canonical
19037	3NKckst2tWb1KUvHdvCmfUvSV4QN8arS7nzp9vpGQ1fkeyYgLfDU	19036	3NLaHWkXXEbHsnJeQEsvkhvAD9QhTjP8VqB1bDqSyKopdCBZaK9J	1553	776	330	6301	12463	jxe8fxanhuVQagj6cd8xTvSQfPBxUD5GNi3CgAGfWmk68tui9WN	9601	13540	13540	1618376400000	canonical
19050	3NKCj268v6KGvsPp7XmCxAgWDYQ9mZye54i8H4cc75nP5Ungy3yu	19048	3NLk4Qj1drLMgErbYgJnzxowyy795NoiUBHNw56eUjd1s1mUpoCV	1513	1253	330	6301	12463	jxbkPM54jftvqJXZ1aW1tsN5CV1dzio39Hc4aw7Vkv3iSSqcBmo	9608	13555	13555	1618379100000	orphaned
19053	3NLAWBtV8sw5ybrgjKfeBQ9YpWwKsmyAMMzgw4D9PauQdTJ4RAP9	19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	1581	778	330	6301	12463	jxyUS9uUH9o9ptqAxxDjUQ8RVArpHf425VbV1ipqPCzGmi3SUV7	9610	13558	13558	1618379640000	canonical
19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	19053	3NLAWBtV8sw5ybrgjKfeBQ9YpWwKsmyAMMzgw4D9PauQdTJ4RAP9	1422	1091	330	6301	12463	jx62vvaEcZYY66WemxJno4kDkJCF8xXCPzy6ojDLYRKToUBteFy	9611	13563	13563	1618380540000	canonical
19058	3NLfuQbbTYRf3T5aGCmrVMqjDSfs12q6fRhJVpnFRM8q5eU5Ag75	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1407	1395	330	6301	12463	jxvHvANuMYEe1ssZWpWcvs9cypCmCxEzPo6MWFe3S2oh7kckH4H	9612	13564	13564	1618380720000	canonical
19056	3NKGm4zLRvscUnU6ykyNrCEQ4RAr29Djhmfz6QaakndZMjLqGnjc	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1523	1321	330	6301	12463	jxoYhKURXwHqBBDp1f22eu8nfJZYt7TYLYBbWqF9ELwfJJ586zb	9612	13564	13564	1618380720000	orphaned
19065	3NLGmH6yGE3X7J1fYh9uZtegs4n7khHQJBYrQAZtCWXMy3HfFumJ	19064	3NKvWf1WxY2LvdEfzZYj64HAYAu2rc1coh2qNYKpP9CjrgQ3N1Zc	1647	845	330	6301	12463	jwQkvNwinnd76kMKzecPahfzKRXcft7r2gB8Z7zHSDb5P5TnSST	9615	13567	13567	1618381260000	canonical
19067	3NLab5z6n9pKgB7eSdir2hUhMxE52EczNMaJ51xUu76iXqkLJhEa	19065	3NLGmH6yGE3X7J1fYh9uZtegs4n7khHQJBYrQAZtCWXMy3HfFumJ	43	1184	330	6301	12463	jx5YBmJRYezUALE1gcTFNYkDMCgSfv5t7hdh38kZEvzJXGvR4ux	9616	13568	13568	1618381440000	canonical
19072	3NKUrGzepi3EMLzFTVdopuoHgQJ36DzZq8W7WFvuPcKuXPJQs9eC	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1527	1293	331	6301	12463	jwKxLq88oTtCcbirkf3LW2C3vsssGmq5CjUodCpsq5vU7TjSPTd	9619	13571	13571	1618381980000	orphaned
19079	3NKqP9GumBf8Ze6QFnLcwA1HXbDgLUwct13wFGwWy6Ce8FuzWgng	19077	3NKh1cUM9rTkVUNC5PhGd48mSibw21Rp1BWCpmYREAXeygSp3Xob	1403	824	331	6301	12463	jwevxVY39XC9VgFYMcRAG56QixhbvyTG6bBxEwgeZFR2bQHjiCH	9623	13575	13575	1618382700000	canonical
19090	3NKgTk84c4bjvihauBC9HchbjRs8KQC3tQHeMKAgLgosxYBKQr38	19077	3NKh1cUM9rTkVUNC5PhGd48mSibw21Rp1BWCpmYREAXeygSp3Xob	1497	654	331	6301	12463	jwdgMRpNpZQhBBGYFLj173iKxcV3d2Y3grYJ4GRDRe81TpgfD3Q	9623	13588	13588	1618385040000	orphaned
19081	3NLnbdMcDqxAtuP825Cizmk8jUmagqWCNyPr2QTDcYrTgqNQ8uFi	19079	3NKqP9GumBf8Ze6QFnLcwA1HXbDgLUwct13wFGwWy6Ce8FuzWgng	1406	1393	331	6301	12463	jxrufsafESmE6pmp1RSArdhMQdYK7Qk2rJVw5msMuxu2NahuQxv	9624	13576	13576	1618382880000	canonical
19087	3NKoiFWxyBmca8R1roU9xA547jXBkjMHSHVE3J2aQsC7f21hQD6k	19085	3NLfwkCS5zTsGbqE85f9HQhprmqsKjJeRCd7vsKorR8HEZyFtcMU	1406	1393	331	6301	12463	jxUJS1kCMxvtDooie87eNCQCfajdkPBLmMFo8tuB9jAyuXshvRD	9628	13583	13583	1618384140000	orphaned
19095	3NKKGfJpP8sCoZrDAKjmQASKSajxcP6csfttpELX5qKA9so8NqFM	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	563	1359	331	6301	12463	jweGr2HS9XGGrRpDE46kA4pLmjoB7Hk5WB6TZ5pCoMU2Hbh32rd	9632	13590	13590	1618385400000	orphaned
19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	19098	3NK5s2iRHt9XiZe7h271u4WxPeRRMjNsnygvrEUgqdEa98zBxpi7	1406	1393	331	6301	12463	jwPBXpz9s7BnzC6L5fHPLv4hbr2ZspcvwKE5H5LGffSQVbjx3Z2	9633	13591	13591	1618385580000	canonical
19107	3NKW3Q5ErJJ4ac4HA8tmv5PrFUhz7XWQZr4Br7W43cVq1gAfYwnq	19106	3NKegu6orwgWLfFo9XnKhDfgfNRD7VWJoYmkcDehj39iygBn3uAq	1407	1395	331	6301	12463	jxNzVJdaiQNJSHEAqaU7tzXvCheRA13kVZCbksJoiYTuiHHWDRN	9638	13599	13599	1618387020000	orphaned
19109	3NLL9D431egCTcNKCL8tSqKbXLWbt2WraiQ41XzDEFo3auJfeJSp	19108	3NL51H2ZPJUvuSFBaR56cEMqSt1ytiPpoHx7e6aQgEFNsVUPxSAn	1407	1395	331	6301	12463	jwEddnDSCNXXk7jMbJzN42VhUAuSHLZSQqJ9ZHiJAUyFBpfE1Bp	9639	13600	13600	1618387200000	canonical
19112	3NLAArgDQULWLQMDby3q1Tvwd5sT6q791H5QdEsxb6wCgMx8T8mS	19111	3NKK3MmSEHDpqYDitCTJHAXQJ2x5MfaeQifUoVTxRhAhAW7zLMAn	44	348	331	6301	12463	jw8LBdSskQpZWywMY3XtJbZ1kXScmzZkQW35wHgQJRGSpsJAAYP	9642	13603	13603	1618387740000	orphaned
19114	3NLBknrus48wgn3qNimqGDPdBqTsnWstuKb8go7hdz3yKeHb2bc5	19113	3NKuceA72gCkjyApYcoRTiPTmE4ATvypb3q714F7GH8BPq1R6VAh	1637	816	331	6301	12463	jwneCT4fB34456iPozxxSgLWaCmsxa3Eki5xD9as6RnD8wrSptv	9643	13604	13604	1618387920000	canonical
19117	3NLyTaq3uuretjUU2NpAJdQq3Ba8AnBBCwxzEUxs6mSNaii6ZZgn	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	1546	1339	332	6301	12463	jwV7MM3bhW6CsMzhtqtXVi9yLPqKDavCUBRLLSbErdSvGg8oBTJ	9645	13607	13607	1618388460000	orphaned
19119	3NKCkFP95Gvk6PATsn6fEsR3K1xm1prpveK9Bk8gtkiNdGvrvpZX	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	349	349	332	6301	12463	jw7FfsqNR5gBxUWiy69xv3Nr9dxjTFQGS2xVTxgYQP5tE6DJvpe	9645	13607	13607	1618388460000	orphaned
19126	3NLkk3DBVwBA2KZq1rANbPDdtF2vwefXT3cB1Nv4vpX8uDwvYyX4	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1477	1350	332	6301	12463	jxRwm6KdatX2owB2Pom3oqHcFV1mAzNuakDphk43AAUk6LCrfbY	9648	13611	13611	1618389180000	orphaned
21802	3NLrX8w7RFXmqexd7y1Ejt4RNV3rS3fECn8DWBJXE14ZgLCg2S4c	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1407	1395	399	12463	13972	jx6KZFXHXBsnBYbgcJJDf1TQQe6J38uN17gLBREvbXsc3ja2U38	10914	15362	15362	1618704360000	orphaned
22492	3NKHPhtK5sVn1UXoc3m4wtFWkPZ7gz8tnBjPAwahyEDLPYzj5PFU	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1407	1395	417	12463	14596	jwhHQzKqHgimMTQmAJqoQn2b5D5WXR7e4sxdRxU2bATcoZYneyK	11253	15839	15839	1618790220000	orphaned
19096	3NKn4d1S7BaAe548hnyUtG14G5bUoryYrGJohVvsoHkyXVWBnHCW	18961	3NLP1STjrBKJDeGj1GsgKGG9beqi7CLYLKHmtaWzUeBa3MgUH9gH	563	1359	329	6301	12463	jwBTTT4i8iUfQ2VstfSFytLYU9t582usArCLT4g8NmAKxq3B5so	9565	13590	13590	1618385400000	orphaned
19130	3NKhboPFnRFi6hseihfdDJf3wVd4deUtJSJqS9K476nKSvXbQJue	19023	3NLcCeSot7hFFRygRHxinfuq5ow262WkvTjsA1bFDVcTViLKemUV	1571	1089	330	6301	12463	jweEwoZi4CCF55YC8LVFm4xQBVqqmwqkAFkGUET78pE4VQSfCbM	9591	13613	13613	1618389540000	orphaned
19041	3NL6tJUJF5ULaqkjWTkqusgH1DtnrUSRUnRPSFZkcKWL2AD57ek5	19029	3NKmzoQsW4i1LXBPYJZTfiqBZBEgGvQf86qkoi8PGFN37gybjq95	1407	1395	330	6301	12463	jxFEE3jeyoZp4GnkzxSTTmGpqiowqUuK5opHmEJcn3gLBv4KeZZ	9596	13546	13546	1618377480000	orphaned
19038	3NLAv83xf1ucxGWnErTQEhSaJRQGSP4WMkE1ETbapmdozGvkw6Ru	19037	3NKckst2tWb1KUvHdvCmfUvSV4QN8arS7nzp9vpGQ1fkeyYgLfDU	457	457	330	6301	12463	jxXnnZgw3uyudsh67rjA4R2fdYYhK3kxf6Upwpk8GMFqjwCKNBJ	9602	13541	13541	1618376580000	orphaned
19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	19039	3NK5xpze2Np2FbvubBxvzahwaxz5x2YzSLk2RQhF4XAzcG9DHxCj	1451	1166	330	6301	12463	jy143UnuQyHo8KZVCHh3pSLhp4qDsAZFEnH85JMrQr7NANa6gjR	9603	13542	13542	1618376760000	canonical
19043	3NLVSABFQtVoGiyfNG7EG8xAcXsE7cBQZWVhD3qPqZUi2Hys4LUg	19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	1623	829	330	6301	12463	jxYqV1wF5TH3GkvtP6gAuAPQFuuvDkTiZyavGRzp2PrCij1mS5d	9604	13546	13546	1618377480000	orphaned
19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	19042	3NLWwRGYpXfdktDYVeMiYKsM5sMFRZmxzampNcPsY7Hx8YMbsdoM	1481	790	330	6301	12463	jxVzgQ445CJ8gXZB5saKzgGErwQAqcbL9CEW9xGXFoV8dqPZ6y6	9605	13549	13549	1618378020000	canonical
19046	3NLEapPmdMwmFNVUJtG2q2QZ4erpLoaBf4GrDmLbvpRuKgjkyTKb	19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	1523	1321	330	6301	12463	jxag41YbMeJHLikQAi8AFq4zRr9ibesqk4ASBQt9NwDZLQJtFcK	9606	13550	13550	1618378200000	orphaned
19049	3NLr4TWRk1MQwpptcoH3xEVVUehfYoKvG4bMHqCdC2yQqPFShNjc	19048	3NLk4Qj1drLMgErbYgJnzxowyy795NoiUBHNw56eUjd1s1mUpoCV	1589	1286	330	6301	12463	jwWYDdrgNnmg6JqbgRUb8zvkNzGZ5GR9JoavcoUXLN6JQ6qcPEy	9608	13555	13555	1618379100000	canonical
19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	19049	3NLr4TWRk1MQwpptcoH3xEVVUehfYoKvG4bMHqCdC2yQqPFShNjc	1406	1393	330	6301	12463	jxoyz97BdLpsox3XSoqJTyx5K1QBChqRTCW76Pv1vyjheuLw2xC	9609	13556	13556	1618379280000	canonical
19055	3NL5uPETbfop6tsS1NKkTD92VxLrxRYjC6hw3vxjgT3SUdJhsMM9	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1523	1321	330	6301	12463	jxNtYBXJDhB3Mv1yFW3tQ7sp7JTHGMGPZ3TWTd5iZGTmqYu5sMk	9612	13564	13564	1618380720000	orphaned
19066	3NLxtq2WxAJYVg9cZLuFZNKUtZEJ2ziSTNb7b9QK5advR9BMEoAd	19065	3NLGmH6yGE3X7J1fYh9uZtegs4n7khHQJBYrQAZtCWXMy3HfFumJ	1407	1395	330	6301	12463	jxAPUcspUv59qShZVnfeQKZivs1eW4vYAMkmTWHr6tDNSSJ6dqh	9616	13568	13568	1618381440000	orphaned
19071	3NKnzbPCq1d4ZduBaTzqc6e7sZei2jfKewSLxhvcwztpKYifK6Lw	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1527	1293	331	6301	12463	jwApELFqLShiSyEnJoq4HLqUs1Z1i3SiH1RyYXpasrM7LpSb12h	9619	13571	13571	1618381980000	orphaned
19075	3NLZsAkjSxkn2y2jNCWJgkLhCEnGNckSwYs5gbvdRDMnSmrwMWtM	19073	3NKQWbQri9jPnVUQjRW3zxSHzY1ohr5YpFiEM3aSQ8vX8oAiyKjS	1631	794	331	6301	12463	jy29YaSUNBLXZvxMXXjwL2vLjCTdhTYjBqpEGa3SSt2GZTqxfBW	9620	13572	13572	1618382160000	canonical
19078	3NL79EGNzEoipdWrR1qFR5ySYJMZzzkECG8h1wuUo925CJs7NqrE	19076	3NLfhHQXr48EKj1QSPAcXkeWJGExBhV5bho1DtLEXNkThdEtsGmn	1601	1142	331	6301	12463	jwY3JiJHLWw8PMUJugkNE1c7zcAaDEoHxb4J8LCGiLEW7Bkn8W1	9622	13574	13574	1618382520000	orphaned
19080	3NKyx6azRfnbKc9LZjGJMHCFMcvYKQfe7i7HyZF6SYhuTAmSMx9J	19079	3NKqP9GumBf8Ze6QFnLcwA1HXbDgLUwct13wFGwWy6Ce8FuzWgng	1610	1068	331	6301	12463	jwmHkVMgcFmEGHfjGCJf2HHjZ2tu619zpHrHGkAwdpb4Wu64LRA	9624	13576	13576	1618382880000	orphaned
19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	19082	3NKWYqEkQUAfkp8v35zVujkocvwn1KgVeszNksijakxDWT1xFvjc	662	662	331	6301	12463	jwHhYS3qZSGZrzFG9N854QxK6tAQA3TmSJxuJjfFhbDAKEFPmHh	9626	13579	13579	1618383420000	canonical
19086	3NK7aFe25j71QkoLomNKRtcnY4WFqaTJt4z616KC3WxfTBUSCiSF	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	1585	1240	331	6301	12463	jxkGfw8srVvC2GrMnGpfTWrmSkWmMyvHs1ZX4JHE2auQFfuKR1G	9627	13582	13582	1618383960000	orphaned
19103	3NL2hYgP7BJEB5i277q4E9qr1YpJW63vDtaDN4mSSJPz5H27iDGo	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	340	443	331	6301	12463	jwPDvN9MRpdHffUeDjQHSvdcbpXmgqXd8QBhQ3brsPp3FPjKkZ4	9634	13593	13593	1618385940000	orphaned
19105	3NLvEQaPAkZRtABsiZikNcFEahu7YGAKzRsHqCXbi2oZ2KCfbQZK	19104	3NKJVBNtfsa1eiidCB4icrAMmAUnZtyJ3BnfJV9BfkTiBNYtgqKC	1426	1238	331	6301	12463	jwx47RLw7Yci17vV1G3FpbRAhnwKHEPVEy51tKCYJ6Gt1ArCJmN	9636	13595	13595	1618386300000	canonical
19108	3NL51H2ZPJUvuSFBaR56cEMqSt1ytiPpoHx7e6aQgEFNsVUPxSAn	19106	3NKegu6orwgWLfFo9XnKhDfgfNRD7VWJoYmkcDehj39iygBn3uAq	1645	460	331	6301	12463	jx4Tzz68ToYMDoZNpJYxDkqqXuRgLTLfxDFzDj6pKwU1UBE2aQk	9638	13599	13599	1618387020000	canonical
19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	19114	3NLBknrus48wgn3qNimqGDPdBqTsnWstuKb8go7hdz3yKeHb2bc5	1403	824	332	6301	12463	jwc59Lm1KiAdvDEjExxzYkYMQQke6VdyfNtBw4jn4z8L6ZwDYw4	9644	13606	13606	1618388280000	canonical
19139	3NKxEZnj3ygXuJpW3yBCyJRCz1B5KcZ67SddKwvnH4UtXHESXHWN	19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	1403	823	332	6301	12463	jxH4wYWodCnqDGfNnEXznkuMDstBdiTGDVxrQ6KhJnNWVPWVJHM	9654	13621	13621	1618390980000	canonical
19137	3NKtcLx2NJ5p64WNgJwZnZiq77GLwwLTebxAvDWer4zAvcfXtCCp	19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	298	1308	332	6301	12463	jwpGaDrzYM43vW2bQkfv5TAaBFNerYYKo81XtvLEWNqz83sJYN8	9654	13621	13621	1618390980000	orphaned
19138	3NLRcwfrNmid9xfVNg3xY7Mgs8rbWRC9ztR3QgbkqmCZatQaaGCA	19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	298	1308	332	6301	12463	jxEkFgX2o7N5e5gqh4qvwgWHx891eyL7cH2YFj1VojnfzGrWaXv	9654	13621	13621	1618390980000	orphaned
19140	3NKMD8hcR3qDs1AG8v54EkX9TMAsBUkFEp5bdvxzdXv7rzqRkbeq	19139	3NKxEZnj3ygXuJpW3yBCyJRCz1B5KcZ67SddKwvnH4UtXHESXHWN	700	840	332	6301	12463	jwrWUqgw969aZbiK62XakJKfjAFKNUCv6qdDT1ergQ9EeJhkrGa	9655	13622	13622	1618391160000	canonical
19141	3NLFpEiwduoK8ZsDJBxLtrQ5gd1qu3BZtXF2RYsENYrq24vnphTL	19139	3NKxEZnj3ygXuJpW3yBCyJRCz1B5KcZ67SddKwvnH4UtXHESXHWN	364	364	332	6301	12463	jwXKekdMDPjV4Gkedyo4EqLTywMuuQZejtfpbGpSkjbGa6MgnuT	9655	13622	13622	1618391160000	orphaned
19142	3NL4VfhtrFwyG7BnwtKaRuL38aqkyaLzNtFn3oBJrmFGqooJv8Dk	19140	3NKMD8hcR3qDs1AG8v54EkX9TMAsBUkFEp5bdvxzdXv7rzqRkbeq	298	1182	332	6301	12463	jxq9ranZ2ac5Zj9iwzVQyXifBUkUYdU2sqFC818ZZLsuYtBvYpW	9656	13624	13624	1618391520000	canonical
22284	3NLbLfTCQxH8D4HnvkX4Kk7TWNBhAGgS3kv9UX1YWYiQhymWP5vg	21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	1506	1373	399	12463	14406	jweRM9jzqquVgn1MkQ5xJMeApUQFijFWzaea8hqMk1gjeq6qvAX	10919	15701	15701	1618765380000	orphaned
19061	3NK8U1D8JHwYHP6XdLhLpKYMzezGaRGt7Nkz1UQ5m8qgn56xh1Bp	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1631	794	330	6301	12463	jwP9kmYU1Nk3fBZCk2M34DCohkPoFpniPgDrtCXA2hZ8o2tWa55	9612	13564	13564	1618380720000	orphaned
19062	3NLwqAcfFVbhyXZt87VUj8SKPykLywqe853NvMvrt66YkmPpTfwh	19058	3NLfuQbbTYRf3T5aGCmrVMqjDSfs12q6fRhJVpnFRM8q5eU5Ag75	1609	1333	330	6301	12463	jwHqFWZpNjYf1Yh5xNzAC4ixURsb8iJ7KsDwP6kc9ay4zDJavrt	9613	13565	13565	1618380900000	orphaned
19064	3NKvWf1WxY2LvdEfzZYj64HAYAu2rc1coh2qNYKpP9CjrgQ3N1Zc	19063	3NL59XsvU5YUf1dk3kyN8UkURjmobDjuDtt1RnhaKXM8aDoCHLiY	1549	1236	330	6301	12463	jxBJF4Vd6pS5KezFey7seksoRU8sBbx9JcZuXYETGBEzGCUUYB7	9614	13566	13566	1618381080000	canonical
19069	3NKjW41aJ9D59kxGCuy9bJyW9rjy5Z7HtFfycK31ZyegCrFKYbsJ	19067	3NLab5z6n9pKgB7eSdir2hUhMxE52EczNMaJ51xUu76iXqkLJhEa	1611	1341	330	6301	12463	jx2tQk4CK8gXAe1Dom97Tk9sohAXRDqgKvg4twHqeUgwH4h5Nfh	9617	13569	13569	1618381620000	canonical
19076	3NLfhHQXr48EKj1QSPAcXkeWJGExBhV5bho1DtLEXNkThdEtsGmn	19075	3NLZsAkjSxkn2y2jNCWJgkLhCEnGNckSwYs5gbvdRDMnSmrwMWtM	1460	958	331	6301	12463	jxoTznR69YxiHqmjk4fAEiPFooZWgMFChYCtLowYPS6QLAVRWc6	9621	13573	13573	1618382340000	canonical
19084	3NKoCHPxrW852toBsrag4QDEoPXaRtkGsyR9YzyLA3e7KpF4VFUx	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	1407	1395	331	6301	12463	jwKRtEgN6GHiX1R8CtKVQTMkxMLNat69ehWmbHhZzpsi71zowa6	9627	13582	13582	1618383960000	orphaned
19089	3NLZAAZ5WQ21hj173NCv2spZa3BXerjLt8Ny8Fvq7g4Dv7ab5hBT	19088	3NKoZ1DszYqbsp7WKiWEJvAzALJ8w5Q71oK1XoiNwCsXBzebCD1T	1406	1393	331	6301	12463	jy1UrQM1n4PDEzipGWhYu7HrEgJF1bGc16r2GnfCdniNZzNiDPJ	9629	13586	13586	1618384680000	canonical
19091	3NLDMENKGT82Q9nB5Ue1hiZm8N7d5SVYBTCS4HvK7pc8GoF6iBrA	19089	3NLZAAZ5WQ21hj173NCv2spZa3BXerjLt8Ny8Fvq7g4Dv7ab5hBT	1497	654	331	6301	12463	jwDVeLbvPc8HMaKdx2xGuTCXrxtEepnRghKmZPzGNEPZdDW1mUf	9630	13588	13588	1618385040000	canonical
19092	3NK9J48QGYeqB3WdoaZte1hhcV7gQSbzeNjwpsEhTGJfV9AKwbiJ	19091	3NLDMENKGT82Q9nB5Ue1hiZm8N7d5SVYBTCS4HvK7pc8GoF6iBrA	684	1352	331	6301	12463	jwtyx9A9uYysKNaD9ZePB8WNeGzaWFXHXNifMB7s2SLgsuW3D7C	9631	13589	13589	1618385220000	orphaned
19098	3NK5s2iRHt9XiZe7h271u4WxPeRRMjNsnygvrEUgqdEa98zBxpi7	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	1406	1393	331	6301	12463	jxErkA1ASJpevapoTUtrAd5QZBbruqg8Xu7BJvoMaMbE2MRHvYi	9632	13590	13590	1618385400000	canonical
19094	3NLovoFMFxhGFDkGdPBfuBwwAhXBW5TExM2EZw3r3iK9i8BCmb72	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	1671	1239	331	6301	12463	jwAx4pvKsTjRvnxVmQKTjQPDTK2maiJyaUkf3oxX5FuCX7eUv81	9632	13590	13590	1618385400000	orphaned
19101	3NKzKL2AsV5E92UU1shHtSMTaYmEKKQVp3SUjcMs8eKVJSB2EsFZ	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	1402	870	331	6301	12463	jx6oUyQkSp4tY9RKfYpcEdVhJHPGU3rSXBGuhC7UrwFrZcCoib6	9634	13593	13593	1618385940000	orphaned
19100	3NLg7RQaZFa3hhaC4irotPtkGSBJ89hS4WRQ3vb36VZWaEzyeMXK	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	1407	1395	331	6301	12463	jw9aufgybBtwP4tfJqSFoJpXqX7XMyiUMp3mQ7mGyM51X56Hxj3	9634	13593	13593	1618385940000	orphaned
19106	3NKegu6orwgWLfFo9XnKhDfgfNRD7VWJoYmkcDehj39iygBn3uAq	19105	3NLvEQaPAkZRtABsiZikNcFEahu7YGAKzRsHqCXbi2oZ2KCfbQZK	1590	1174	331	6301	12463	jwP4gmTC5hmbMx7mJ9KWdRVJqU57rKX2W1eEyA98yi2PdKpAnBt	9637	13597	13597	1618386660000	canonical
19111	3NKK3MmSEHDpqYDitCTJHAXQJ2x5MfaeQifUoVTxRhAhAW7zLMAn	19110	3NK7FxeAnpQUZMQKaAV2s4AT3NWEhwWvssq5AtjEoEzfCHpPp5nz	1581	778	331	6301	12463	jxFBL9FjEhK7CzGftgqPMk7mmFEr4o1AFjQkPkckEKHTxqaJu3t	9641	13602	13602	1618387560000	canonical
19115	3NKKurD97kPiiPPUEHnUuY8ULcbkrp6CUiERESJUU8DPkskG2JhD	19113	3NKuceA72gCkjyApYcoRTiPTmE4ATvypb3q714F7GH8BPq1R6VAh	1578	930	331	6301	12463	jwoABWqiqNnpbjeieV3G4BduWe1HUhk5rtahUQ7KKhM5UawP8Dt	9643	13604	13604	1618387920000	orphaned
19122	3NLVFCEBiJL7XH26tJw6BUEJdSwR3HFr6W31LudrP8oJF8rADX5y	19120	3NKENB625zL3NyzsBHZeNLHPW3sFni7qNhCjvkcdxAqxeECHJzPD	1407	1395	332	6301	12463	jxr7B73U2n5HwcN7hdgxP7GXqVe6Znf3UUhFNyRzbg5y62HFvdo	9646	13609	13609	1618388820000	canonical
19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	19122	3NLVFCEBiJL7XH26tJw6BUEJdSwR3HFr6W31LudrP8oJF8rADX5y	1507	1280	332	6301	12463	jwLUXYnir8Tb8QC4krvxsAouAUEfbAcQggKTmtDxRYgL2CfArGF	9647	13610	13610	1618389000000	canonical
19131	3NKTKhqtEa6iofhRGHqcadZ77pP8ionrixwuwVCRPdGuuRnB624B	19129	3NLMCKbJCwNEf8BPCp3zsQSfZ67j36SjwYT3iht1GaFWZPgBLt9q	1560	264	332	6301	12463	jwgHoqh5VRdruaGB3jG5dfhjyKsnRgUPshSvkKoKFDBSHg2jo6K	9649	13613	13613	1618389540000	canonical
19134	3NLf7d5TL1EjQ5UDvX8zoPSc4poq9SgMJWQRYeUXdzX2yEe1i2Fq	19133	3NKGgLDuFGBiZVMXAeuJ6GPf7LRrJydp3m9qbmCQovfaPsymKj8d	1406	1393	332	6301	12463	jwjKU7MWHLhW5puZUU5X45wp6MsYBRtnvmLfrmpawvv3iVTo15L	9651	13618	13618	1618390440000	canonical
19148	3NK911pKBnBnPoYBSdNQpGJaJkoMoG2BA7UMfXPTgQPCxd4Mi97v	19147	3NKurq54mJNZWFAUZCJe4XFcxMoUtj9cv6tfRSiPhUEFjfErvgdj	1462	471	332	6301	12463	jxRmQgACfUHYuCjT9TVAMDc3t2fLw4qE8ZD7WpaCBR4cHNYSwxg	9660	13628	13628	1618392240000	orphaned
19152	3NKaQ3gYXVSPWGZwyRyKUaxN8pvg2xRkURuGfiXWybX88vsFKdQV	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1507	1280	332	6301	12463	jwvsRqVuTWngErj6ZvVuZaYnNsozPwknnUuGoJ4zNLvX4iqvgq5	9662	13634	13634	1618393320000	canonical
19155	3NKPDTshBTXyS7N1HA4u12ATmb1XhmYDTZWiWWTyut4w4jvuHtRb	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1419	814	332	6301	12463	jx9GxfgXgkDfTUGW5FYri3ck8aNVLC2hnkCkujrPfdFSPhyoGD7	9662	13634	13634	1618393320000	orphaned
19156	3NL9XfA9PLSx6djF7kfiQT7eNqdubAyxN3nXSEsov6zgUrh6PZjF	19152	3NKaQ3gYXVSPWGZwyRyKUaxN8pvg2xRkURuGfiXWybX88vsFKdQV	1406	1393	333	6301	12463	jwWYXSeBFDXTZYxyVEsJdjrVoXKJ4m9hkb7kvSzcH4KXiMMyFb2	9663	13635	13635	1618393500000	canonical
19164	3NKcsoGGNfJNkJVkkn7XwfabTyp5765PmrX12HgzrfXCaHNctpWb	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1405	873	333	6301	12463	jwMmY7x6ib52RmHSphG9MuG1Uw7PMqkxYNDBeB5V5rF5XqRXAmr	9667	13640	13640	1618394400000	canonical
19165	3NKEsxJoo9tbk4ZsbHapCB7aNWdtiWWwNf169tAKTze3EaEuS6Fz	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1631	794	333	6301	12463	jxKmJBxZ1HWpoPp9nM6FRvxPaBr5nwutPunhPP25AExJRXB4WYe	9667	13640	13640	1618394400000	orphaned
19168	3NL9u19ggHVQAHEJAdDQhcGkgi89DfTc4BTQTcGPs2a9MtiiHNVv	19167	3NLBHJX4d93GigTMGMXCba7jtc48ucE9pEaeVAqunaPj4uCMsSBT	1406	1393	333	6301	12463	jxXNJx9sEh8AAGNQoT663dtAztbuRe2Wd7yHrz5GiuqbBq1xmeC	9669	13644	13644	1618395120000	canonical
19171	3NLR6aTTuayGmgaaraufJoaEnoTKVqnGQdmRTpacBxU4PYa5d4qz	19169	3NLdqpbR5mcJopf1L5yowr74mzWFiKJW8khx2nMrrDHTbFcYEmWd	1397	828	333	6301	12463	jwZaEq65hiJuA2uLXk1xRp717hpuDYmg1UveQ525VTKs8pXQdkk	9671	13646	13646	1618395480000	canonical
19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	19173	3NK5qbvLHuDAa1HTzTFqaoN34awEZEoDa6Hm1n7bAwYom1oKNspr	1647	1302	333	6301	12463	jxRxf6PzYHumBZFZGvbeAsFGGJmDQ7bEDzchFDzSeoDWHBL4F1H	9674	13651	13651	1618396380000	canonical
22218	3NKwxc4nniykhwkpPQHCEp5BaUd8Dq521CjCh3dZvFkNt3bW8bfJ	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1403	824	399	12463	14346	jxzaFDu6WUVfQmLS4VGM9PHd4kGKc9SoUJ5QXxLQjRRjyJpkc7q	10924	15659	15659	1618757854724	orphaned
19104	3NKJVBNtfsa1eiidCB4icrAMmAUnZtyJ3BnfJV9BfkTiBNYtgqKC	19102	3NKDn7ym7CHCD96EERqUk14w9oQNDmvDp6ymZ7nEgaEPjQiqBbun	1457	1391	331	6301	12463	jxsFxe3ZftuMFuSFqqk3JedWKFvgqPtgyV8zwquAGSPCaCBCLQA	9635	13594	13594	1618386120000	canonical
19110	3NK7FxeAnpQUZMQKaAV2s4AT3NWEhwWvssq5AtjEoEzfCHpPp5nz	19109	3NLL9D431egCTcNKCL8tSqKbXLWbt2WraiQ41XzDEFo3auJfeJSp	171	1374	331	6301	12463	jxqKwje21RPgHfZeVq9VJFqk9WBQPKQKjA7PTRLgC24YjgSodaC	9640	13601	13601	1618387380000	canonical
19113	3NKuceA72gCkjyApYcoRTiPTmE4ATvypb3q714F7GH8BPq1R6VAh	19111	3NKK3MmSEHDpqYDitCTJHAXQJ2x5MfaeQifUoVTxRhAhAW7zLMAn	1673	1002	331	6301	12463	jwnwFdbP28dRwFpjxGNdYyRq3pKpY5EGCKcaJ1iTcf2D1SEurZR	9642	13603	13603	1618387740000	canonical
19120	3NKENB625zL3NyzsBHZeNLHPW3sFni7qNhCjvkcdxAqxeECHJzPD	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	1541	1298	332	6301	12463	jwoMa4MG1ZGiYHpSgfHK4b1qzNuvvuLiqPwm1Rn7r7t9M6hTHv1	9645	13607	13607	1618388460000	canonical
19118	3NL76h69KB49h6Aie4JnKYVqhzwujr5gmoVDy5XHHUFDaUKuNF6j	19116	3NK4apiDvnT4ywWEw6KBEk1UzTd1XK7SGXFZDVC9GPCDaT3EXdsv	1670	916	332	6301	12463	jwDG3tkMFtzJJfCtAfn2EQSFSjoMactf9MMqtL6Sb96m57X92RQ	9645	13607	13607	1618388460000	orphaned
19123	3NKLANg6JDSHS7M7wMned5hs6F5x8bHwN8d7uYZfh1xbdHBXM4dP	19120	3NKENB625zL3NyzsBHZeNLHPW3sFni7qNhCjvkcdxAqxeECHJzPD	311	1307	332	6301	12463	jwoR3GBEauqntoG3dgrrioTbmnZ2GYscYCRRYTnUuvgL1FWkaTK	9646	13609	13609	1618388820000	orphaned
19125	3NLiC4s15FeQHYCPPUb3T1qTGqpzmZvLCoSS2aAg8ZKZEn88tsc2	19122	3NLVFCEBiJL7XH26tJw6BUEJdSwR3HFr6W31LudrP8oJF8rADX5y	1403	823	332	6301	12463	jxCcbVSYLhmk7E3Xt7uQiVV1ofEK2izVKgmKAVh2iUuE7rihd92	9647	13610	13610	1618389000000	orphaned
19129	3NLMCKbJCwNEf8BPCp3zsQSfZ67j36SjwYT3iht1GaFWZPgBLt9q	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1474	1329	332	6301	12463	jxo1pgTrLgKAbMGvSDAK4RdMzrzqTPsAr43AnCxWxLMfU7vKsNN	9648	13611	13611	1618389180000	canonical
19132	3NLXjpsWasd75LcjnjohGVZPvJ1F5Msq5mYBKfPehrnz7cByuAwg	19129	3NLMCKbJCwNEf8BPCp3zsQSfZ67j36SjwYT3iht1GaFWZPgBLt9q	1402	874	332	6301	12463	jwMdJ3sJaQLS3eiZijy19WKpwQZuSBAdSge4KA37xiBRn24cd6k	9649	13613	13613	1618389540000	orphaned
19133	3NKGgLDuFGBiZVMXAeuJ6GPf7LRrJydp3m9qbmCQovfaPsymKj8d	19131	3NKTKhqtEa6iofhRGHqcadZ77pP8ionrixwuwVCRPdGuuRnB624B	1549	1116	332	6301	12463	jxVS2idCMBZVTdtNo7uZ4y91iQUe4FhFoVuq8SBmJuvcgL9BC4R	9650	13615	13615	1618389900000	canonical
19135	3NKcWoeXK9JfgZroYFP5FSEM7EPTiq4MgNm5L5gm7Q6k7zWkkt6C	19134	3NLf7d5TL1EjQ5UDvX8zoPSc4poq9SgMJWQRYeUXdzX2yEe1i2Fq	43	1064	332	6301	12463	jxKBkafymJB3iFVbKn6MQfhzzeooTSup8rLxkFoUBCQP7foX9Vd	9652	13619	13619	1618390620000	canonical
19136	3NKL488AZLvCvhn8MCgKiy6Es7V9yPvEDZbmYeLMnyZZvhgL1H8X	19135	3NKcWoeXK9JfgZroYFP5FSEM7EPTiq4MgNm5L5gm7Q6k7zWkkt6C	1631	794	332	6301	12463	jx1R8cPFMKXBEz58RUHZigXjKnCKqY6Ex7Ccm2tp8ahF9LzXCer	9653	13620	13620	1618390800000	canonical
19144	3NK4a5vWTUDmFMKgVtJBTSzFAzPLBYGKjkHH1MHBgJ8g6BEFiHUd	19142	3NL4VfhtrFwyG7BnwtKaRuL38aqkyaLzNtFn3oBJrmFGqooJv8Dk	632	1382	332	6301	12463	jwzVe6zM24X5MhzfTRXwTw4B9xZ6QECR52udh6EMskhwFMnraqK	9657	13625	13625	1618391700000	orphaned
19146	3NLgedAYKTxQP5BoeZ82L1hanZ4VdtR5h7RuYzgnzKabn4FaqmqZ	19145	3NKadmh7VsCGahzWCSzsa7MoHjTKz5mXfFksWr3RrKaA6TbUy9on	1610	1314	332	6301	12463	jxof42AdTjbGcEMUCYfmxBn4bhZwhHf7hevgzazjymsy2GcBWcZ	9658	13626	13626	1618391880000	canonical
19149	3NK8rHuDRP4JDzYryDVXTDUrQxGgmGdmWHEMq5iTdr41Z6sCzSDG	19147	3NKurq54mJNZWFAUZCJe4XFcxMoUtj9cv6tfRSiPhUEFjfErvgdj	1610	1314	332	6301	12463	jxuNt6eupRztnMrQ733v4mf6fLH8bxjzUhA8CsfvtYu4H7ajxzT	9660	13628	13628	1618392240000	canonical
19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	19149	3NK8rHuDRP4JDzYryDVXTDUrQxGgmGdmWHEMq5iTdr41Z6sCzSDG	1508	1261	332	6301	12463	jxuvTLJ8uTNVUbRYHwttbLgTQBTuuZ4dPGZuyrZUmwUWZNC2rZh	9661	13633	13633	1618393140000	canonical
19153	3NLELvQXRJJMEMR9nnk24SMGEaB8xpz4fENtGxmfRcHGBQgCadP7	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1444	1255	332	6301	12463	jxNVFvxPP8RmHVeEL4YX4L7bJ13YrgCHfUHrnQSyGS9anDGBcqf	9662	13634	13634	1618393320000	orphaned
19151	3NKooPivUXcKRXZij9MnkfFGqsXy5fmggRWGyJwGRzv3rLYgAct5	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1444	1255	332	6301	12463	jxNVFvxPP8RmHVeEL4YX4L7bJ13YrgCHfUHrnQSyGS9anDGBcqf	9662	13634	13634	1618393320000	orphaned
19158	3NKVHQ5V8GpVz1sFro4Yu2CfoDaQDA6axDRC3pCHxx6TWudDeLCP	19156	3NL9XfA9PLSx6djF7kfiQT7eNqdubAyxN3nXSEsov6zgUrh6PZjF	302	302	333	6301	12463	jxpyyiMUvXhSx5fxcDGxJg6PzFg5jtXoPnKw6XdvtnB3muNgp1Z	9664	13636	13636	1618393680000	orphaned
19159	3NLhAjbD1tTE6Q1bREzgHwNRwx1CqKzGdbGGC4VeJyL87u4boscK	19157	3NKR2bnayEeRxSBGTT1sB1fKo8R9XerumrxJbpzDBhxovraeKr9p	1623	830	333	6301	12463	jxWtCx1F9zSBZjz1cFYJR3TDf5Syr7yE3mZSNrr342ACo7ckgjY	9665	13637	13637	1618393860000	canonical
19166	3NLWSfzjKZ61RYKpDKVszGfFLrjkceeJDUsgRvpVjVHJipssyvRD	19164	3NKcsoGGNfJNkJVkkn7XwfabTyp5765PmrX12HgzrfXCaHNctpWb	1529	1070	333	6301	12463	jwvcAfEPT2BpjxRfGM5BvdU52XbDB9gFmkwQysVUmRi484MRDJW	9668	13642	13642	1618394760000	orphaned
19169	3NLdqpbR5mcJopf1L5yowr74mzWFiKJW8khx2nMrrDHTbFcYEmWd	19168	3NL9u19ggHVQAHEJAdDQhcGkgi89DfTc4BTQTcGPs2a9MtiiHNVv	1675	976	333	6301	12463	jxxeSYGASXJaSNNxuHC1yPdtfos7hRW9YnTFp8XWtT6vxRCZrKb	9670	13645	13645	1618395300000	canonical
19177	3NKi8edBU9P9z1x8ejFs4g7o3VXjWjRCXHE4WX8zxaAks6kdYuwx	19176	3NLEKYqokV9G5mkFRzHgA75F1jGrCGLfrvyojFkhLsRB8YzJXpLL	42	1361	333	6301	12463	jxpexgw92TKvyv6xNgXyrdfEgKjTeo8mVFG7vQrwzvSi1KEcKYU	9676	13653	13653	1618396740000	orphaned
19179	3NKjgrdfdrmtaZqadeycE4vyvaZLwBQx2UUoGtudSfUez97SNDsN	19178	3NKJ1kQp1FmUT1GoSq79iQPrSpb6HDE28YKvruNDuEU8Gra2AD2X	1637	816	333	6301	12463	jxdomKKfH9FpnVduWNnjUAH5X53ujQ5eQ8xG8D1YV4Ycy82oEQG	9677	13654	13654	1618396920000	canonical
19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	19185	3NLqMjhSyvHcvWJCpu99zLv3vYgQ9GXyLNTUgFowSyKaZbZAFKhp	1407	1395	333	6301	12463	jy2mpqhHcUHWRPhic2Rf2vitWy8eGma7mwW7xCpet4xjYcJnTFd	9680	13658	13658	1618397640000	canonical
19189	3NKg5bYgP2hiFCBVj4D38ZU8zeqAjG5BLSUccUhTxrZBC7cR5Hub	19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	1406	1393	334	6301	12463	jxRfUhMKMGSTT2ih7ZALJKfzPQGckfC8cXJWMZkUh4ZJwCYsT2v	9681	13659	13659	1618397820000	canonical
19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	19190	3NLvmJJEBMMHtdsxgvnYzXRZ2WRwvv8qAjGWQRX5aSsRiSBCZDtY	1474	1083	334	6301	12463	jwDWHr5YWvtLLNStfFfcdxVnzqC8d4gkAQGqP9FaVgJXoFhqwEM	9683	13662	13662	1618398360000	canonical
19194	3NLaa95kEFZoZgwXPfgZYmRnXMxa5heqPTLFtgFrPPh8TurvhdKj	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1440	1011	334	6301	12463	jwvZ3HR6AKUoiaU8cYXxwuzuhZGVgZondKStaiXJ3UQedLYEjfT	9684	13663	13663	1618398540000	orphaned
19199	3NLFrFZwryRcRKwoCtdDofMmku6ZbpsS2CfhQNz11GehPKC3eTdb	19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	1406	1393	334	6301	12463	jwF1yMpoMAtZysU66xQiuMzTunV3NBDgv5CG67byWvf2QuuQfKD	9686	13666	13666	1618399080000	orphaned
21829	3NLjS754Kb3M5hjiz1tCoSpjna5muQcY5Tf5xY6Rq6DRM9MijcZc	21825	3NL6q7uAtsRuQ4vJHzZBSdoAqNRpYRACQPmgQnfLDthw5T79uzbQ	1509	1320	400	12463	13997	jy2ZndWhHYppPCKtXqF88XxdmsSCWfGo2teWqhXrZQQ1prjJ3fU	10925	15384	15384	1618708320000	canonical
22490	3NLBt5BkoocAGhdqf4HFZ1UMRK327p2G6GhRFg5cukAvvsVsYMCQ	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1460	1198	417	12463	14594	jwFkzGBQ23JEN7zBssscZsW7ffDhhdXvHQgh6MtHXwq8JXJ33yB	11253	15839	15839	1618790220000	orphaned
19145	3NKadmh7VsCGahzWCSzsa7MoHjTKz5mXfFksWr3RrKaA6TbUy9on	19142	3NL4VfhtrFwyG7BnwtKaRuL38aqkyaLzNtFn3oBJrmFGqooJv8Dk	1403	824	332	6301	12463	jxLPn5pVD5CxSPQQFQLcdRv8DGfvrxKrVmej9tidbexhPEsuH98	9657	13625	13625	1618391700000	canonical
19147	3NKurq54mJNZWFAUZCJe4XFcxMoUtj9cv6tfRSiPhUEFjfErvgdj	19146	3NLgedAYKTxQP5BoeZ82L1hanZ4VdtR5h7RuYzgnzKabn4FaqmqZ	1407	1395	332	6301	12463	jxhUSi5wujX3BwhMZ3PHmv1BHnxDge8bUJqL3Qrz5H5pCGFwseY	9659	13627	13627	1618392060000	canonical
19154	3NK7QFAUtXCVZwKZcjhzJBfUc5M2y99J2uyU3wzxsXChwhr17TBx	19150	3NLrcvAkjndNzyPVpPRuCSJMBSahjbb4qEcsmq36Jt3W4i2GzRZ7	1419	814	332	6301	12463	jx9GxfgXgkDfTUGW5FYri3ck8aNVLC2hnkCkujrPfdFSPhyoGD7	9662	13634	13634	1618393320000	orphaned
19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	19159	3NLhAjbD1tTE6Q1bREzgHwNRwx1CqKzGdbGGC4VeJyL87u4boscK	1668	1370	333	6301	12463	jxnna2UeZHweEbbe5PoKG5YRUrCnzv1Lf3uL3f7JCfxwEAciPxA	9666	13639	13639	1618394220000	canonical
19163	3NLyAmtrQSVsYQBhT9Vx8GKfKFVHeDWQ2PRW91rKHwCHxAKaxQ6C	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1564	1092	333	6301	12463	jx7PFQBRdBqTZHyzMUHtgjb7bwJMwxt5NP1e12Sbu6fyV9HH8Py	9667	13640	13640	1618394400000	orphaned
19167	3NLBHJX4d93GigTMGMXCba7jtc48ucE9pEaeVAqunaPj4uCMsSBT	19164	3NKcsoGGNfJNkJVkkn7XwfabTyp5765PmrX12HgzrfXCaHNctpWb	1403	824	333	6301	12463	jwNbdxXt9gRZMx5GBFM7hfrA1c9QPnX9F5PmgdXvbKSveBfURTQ	9668	13642	13642	1618394760000	canonical
19170	3NLL1f5a33Tpugkao3yH8hDHurV5RWciwTrtyo3Q1ZM9Wsujc8w5	19169	3NLdqpbR5mcJopf1L5yowr74mzWFiKJW8khx2nMrrDHTbFcYEmWd	1447	1345	333	6301	12463	jxfHST2oXAhNqLpEUXCGmuE5sSQc6LbjmG2NUtAyHB711JTUvKU	9671	13646	13646	1618395480000	orphaned
19173	3NK5qbvLHuDAa1HTzTFqaoN34awEZEoDa6Hm1n7bAwYom1oKNspr	19172	3NK776JeJoXyWjGc9W5sCYSNuJhfvdiq22sw1jcDzK62jW2P4Ygz	1627	1385	333	6301	12463	jxNgTgh5AygJk7Uv8tFbkEdUrkdw3ReKAhQiLPmBmPUvsX5jn3U	9673	13650	13650	1618396200000	canonical
19183	3NLqkHHr4zidEWrB5qSCqbz5ApU1oKUoxd94As36DXyFtZxj2fvD	19179	3NKjgrdfdrmtaZqadeycE4vyvaZLwBQx2UUoGtudSfUez97SNDsN	1560	1291	333	6301	12463	jxCYmfUjVxv5LqWM9naroBL461wGGPd9aRqUxEZzFJYQCEXNjEm	9678	13655	13655	1618397100000	orphaned
19197	3NKoEyfyn851gibg7zrPzFr6pNSVpJ8m8hN5YR4s7PA7nEJu5rWN	19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	1407	1395	334	6301	12463	jxWu7MgfMPoWg2UM6kRHhUbzY8mvHdY9cr5kMP1pxqyPFj1sP5R	9686	13666	13666	1618399080000	canonical
19208	3NKug4XfWo1XrYzhhjDgEeQ3sbXXGm2JAQAB4hooUvoUYdbTgLy8	19206	3NK64gVxPHddSm7KyXoBvaVAx56B9fihVyV28C2PwGiFJeJJQm2u	1407	1395	334	6301	12463	jx91WzFDfY2aPduws53jJKLGTwAnGBvXG2EYChtxwht8eSExFy5	9691	13677	13677	1618401060000	orphaned
19210	3NKfLw5Gx2wYq5grz6iBpCADJaG4TkRkHVtgAFrvWfa4nFReNKS9	19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	448	1305	334	6301	12463	jwptAoDKyFhP9harf853DvLTNh7B3wi4xgouWVKimpdPvuezgrf	9692	13678	13678	1618401240000	canonical
19214	3NKKKVXgNAiTRzL6YRQqZBcDuzUvNfvKEPr5JsXK7ziNuZmsAvz5	19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	1489	1014	334	6301	12463	jx1kPqMsBjzw6gsyoUL8UUDXDFNqGvcEpwGKHpTZLKowwwuj52E	9694	13685	13685	1618402500000	orphaned
19217	3NKMpD2A4PXkVvnYKF8VcJWX6ZGsLuFsBBoiPAqdafGH1UB5rLQ6	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	1407	1395	334	6301	12463	jxMvJEkRBChc2MW7KYgTiTHqxVkxzCwoNY4anFBjBpDABfpjFKs	9695	13688	13688	1618403040000	orphaned
19222	3NLdSWLsWTuxisyu5uwARZzGs57U7JcMKzsK6N4j5zAxPTV6tMGF	19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	1542	1178	335	6301	12463	jwNxPfVzX8wiAmJMp5x5F6vdx5V9KvH9xXw8zZ7vPJpFZG54ap8	9696	13690	13690	1618403400000	orphaned
19231	3NLPqRVZtWYkGa2HnEduGZcZzAgC4Ekq4RFUJB7Qw5oC8x4jaMam	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1403	824	335	6301	12463	jwa1B3G2PXZ5MrnF7y2V8kac23Fojidm22HaxVLhVbCLw8GB6c6	9697	13691	13691	1618403580000	canonical
19225	3NKEGzWgkQvsqJxkPM4bfTwzft32aw3V2obFe4poJRkH4BzBKJTR	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1523	1321	335	6301	12463	jxBvqfu6rXeFSBwWCjb4f5Qv2Dj3m3iByWa3trRN7QXDAQSm1Jm	9697	13691	13691	1618403580000	orphaned
19228	3NL1rUwpU9UGYYfmEKRbH3mn945R2TdwW9z5bKS8iEdNbiZRXAJ5	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	58	1035	335	6301	12463	jwDoA3uYdNrZm3uSdvsw9eT2JDMxV5LNfk3KCd4HsDU8LFg6Mai	9697	13691	13691	1618403580000	orphaned
19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1422	1091	335	6301	12463	jwcjAJSpMKFeicVNnrz2tXmL7xX9BnkYuDivAkCN2susPv1TjK2	9699	13693	13693	1618403940000	canonical
19239	3NLe2zyiQcYvNwbfTAtosDPGiQMkRcciX3Dug27HVz9QaZsmLdT7	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1403	824	335	6301	12463	jwRtMpHLoYQVoJ4e2wsJka17WFgZtgGo4AyDbk2DVxCMNxc2iEM	9700	13694	13694	1618404120000	orphaned
19244	3NLSJboDpJFqUgAF4VwCqeeqfPLD7ViiCkPi35kYcc39CvhGkBEZ	19243	3NKUAH4acNQuj21sZst2nvXFDirVB6dLBECz9XFE7o9zFR6rAj5z	1406	1393	335	6301	12463	jwfzF78JwrwpzDiDPVKJnhc2oLcUcuYwHdpPRU1s1c4oSp5Xvxs	9702	13697	13697	1618404660000	canonical
19247	3NKwEGn6GfKf6kyjz1u4qoyuJhzRJouX2y4gHCPR2nVLy2EKHvDv	19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	1458	1197	335	6301	12463	jwDb3Dkjo3GVFB37KUWPpZXmi7dw4BSb2zYKHtkpnzu2F3Jmns7	9704	13699	13699	1618405020000	canonical
19249	3NKwVQSGpcwy3w3bBaeuHkiWCSFTH6hekVzE38uSY1PNfjE21foE	19247	3NKwEGn6GfKf6kyjz1u4qoyuJhzRJouX2y4gHCPR2nVLy2EKHvDv	1477	1104	335	6301	12463	jwBi2CAdiFqFsrPD61koqrjoyHBUg3PzzcBSkNkzLMsai2GvkWo	9705	13701	13701	1618405380000	canonical
19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	19253	3NKpbuzHmj6DX4tLxNBARRQpu5cCXx2YQPN9mfCouwF1MeNA2DF9	1673	1368	335	6301	12463	jxMGH9D2QR3L4WgJ21SyVs1ZDHUrzwTYC1xRPXAZPjGGiguX9Gc	9708	13705	13705	1618406100000	canonical
19261	3NKCfcNsckHK7sGxshMAcuAPXC8cxBP5kWHdUcNRCLGfC39Xk4hF	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1406	1393	335	6301	12463	jx4WmkoUpiaJEqSrouCzFSpmJeJgAPDDpN5EwkDAzh8nxoBoEcP	9709	13708	13708	1618406640000	canonical
19266	3NKpKugHZfVLyxgNSX7c75t7taFftZDbfPdK9HAA2cg5zwoqAm5Q	19257	3NLpS5JEZ2vBBst8P1SjvUy4TV6d4cRNRG5vP7Uhwg47hjuFBTFy	1577	1327	335	6301	12463	jx6m12RTpYhCKw7DJDD6i6QEuRnjBTpUDxsiMk1J1k4dxvSbD7q	9710	13713	13713	1618407540000	orphaned
19263	3NKbnk9Pu9RkmyEKqFq1XPopZLRapn7mD7k8tULT9SdQoxAQHPbo	19262	3NKZEmx2FtTBTz2oh3Y7ywgGKUNW5256tLZuaCHjAvhA3u5535CA	1458	957	335	6301	12463	jwCDuVUawgc6vbs5cRAcqQavVuGCR1SeCRJTRFCsBNuGB7HYAC9	9711	13710	13710	1618407000000	canonical
19269	3NKV9iP6b8ab6fsSA3YH98GCfPgEYJg1AHfT8rQJ2GYXRQFdNaVy	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1577	1327	335	6301	12463	jwbWx8xieP7FHwo32VRzuZfBRdQFSTdUXmjCii4wZuKU78cN8Mi	9714	13713	13713	1618407540000	orphaned
21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	21829	3NLjS754Kb3M5hjiz1tCoSpjna5muQcY5Tf5xY6Rq6DRM9MijcZc	1474	1203	400	12463	13999	jwDp9Mfahxz9eURcY3AKckRFUoi7jNkqjavcaLm66ajnjnx2oJ7	10926	15387	15387	1618708860000	canonical
19256	3NLm3oNU4VMu6xrmi5958tb3dmeBimKTT2saKMjDGTQ1nMGKTLvS	19040	3NKE9dr4mfGC1rCjPtNAuoWKsQtv9wmckd57HStBDZP1Nmn2YqZY	1461	1271	330	6301	12463	jxMENyhNtpRFAwB9FT34x5TLp4tBJzYatnruHUoGVWcY2CGiF7h	9604	13707	13707	1618406460000	orphaned
19180	3NL4K1ik7zjxF73rdmD8Z2y5hycTVt61M6465rLaZGSeJivsb7w6	19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	1646	1228	330	6301	12463	jwDe1wDvuHGkH9utpxo4hvMwXWuaqCGdgJie8AwVAASuc9njv1m	9610	13654	13654	1618396920000	orphaned
19157	3NKR2bnayEeRxSBGTT1sB1fKo8R9XerumrxJbpzDBhxovraeKr9p	19156	3NL9XfA9PLSx6djF7kfiQT7eNqdubAyxN3nXSEsov6zgUrh6PZjF	1581	777	333	6301	12463	jxHonBwkHhUTmB5crtjHzCMVdZpd96ZSSmDfpsCDH39qTYvo9fF	9664	13636	13636	1618393680000	canonical
19160	3NL8HiWyk58T377nY2DLjmze9WYS6sf8W1c1Qoxc4RG8cRHpAr3A	19159	3NLhAjbD1tTE6Q1bREzgHwNRwx1CqKzGdbGGC4VeJyL87u4boscK	1668	1370	333	6301	12463	jwJ9hyN2JXAZM1cyq1oP9aozqP1gigcjAX66qdgD5JzSK6Jv74s	9666	13639	13639	1618394220000	orphaned
19162	3NKWjumEmXun4ESnTyBscZcdDLpPpDmsBrMy5C3TtajwCc3HEP1G	19161	3NKFdzmNihgvBXy2D4WCw8jSV3NQHzQ6BWsnM8BBQsB5hUkx7Wau	1407	1395	333	6301	12463	jx28LuSAZk8RQUAjY8Wqz4imLjLSVwaYGWUyGsEDzH2pDiFwTYw	9667	13640	13640	1618394400000	orphaned
19172	3NK776JeJoXyWjGc9W5sCYSNuJhfvdiq22sw1jcDzK62jW2P4Ygz	19171	3NLR6aTTuayGmgaaraufJoaEnoTKVqnGQdmRTpacBxU4PYa5d4qz	1642	1121	333	6301	12463	jwub2pKjg1oyWR7qb8imd9YukKvwJtxrTGMsKxPTwhiFfwo6tL9	9672	13647	13647	1618395660000	canonical
19175	3NK8hMkcw6pbQcoAqEyXQVC7t6zZADB35LQicGBYreP8ZaaCzWsN	19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	448	1305	333	6301	12463	jxFVmikH6AS6JWR5gdvrpsD6wApiykX6uBUEDfPQyviwMtG3dK2	9675	13652	13652	1618396560000	orphaned
19178	3NKJ1kQp1FmUT1GoSq79iQPrSpb6HDE28YKvruNDuEU8Gra2AD2X	19176	3NLEKYqokV9G5mkFRzHgA75F1jGrCGLfrvyojFkhLsRB8YzJXpLL	1673	1122	333	6301	12463	jxhrrfCB9Gwvz9hGUeZm3NLqy8dQtcTP5iweGx53mX6f8HFH3Dq	9676	13653	13653	1618396740000	canonical
19181	3NKWXXzoJbcEXWXZHVerLr47SbRzrWAmsL3i38jfTGGBAuXWGusm	19178	3NKJ1kQp1FmUT1GoSq79iQPrSpb6HDE28YKvruNDuEU8Gra2AD2X	1646	1228	333	6301	12463	jwuprsWJb5mYT6qkm5J2sUvHxVXiDHYyF9iRxYzcjAHvxVTTATH	9677	13654	13654	1618396920000	orphaned
19182	3NKHEvp71YgrBGig8qACswLy4g6NGrVyuChaSU5RhKXEzoy5ayrX	19179	3NKjgrdfdrmtaZqadeycE4vyvaZLwBQx2UUoGtudSfUez97SNDsN	1509	1320	333	6301	12463	jwmz6c45GeFtSsNL7PFTUeT9HSyk7uEMZdJ2jmufbDsXT7LMRCb	9678	13655	13655	1618397100000	canonical
19185	3NLqMjhSyvHcvWJCpu99zLv3vYgQ9GXyLNTUgFowSyKaZbZAFKhp	19182	3NKHEvp71YgrBGig8qACswLy4g6NGrVyuChaSU5RhKXEzoy5ayrX	1607	1348	333	6301	12463	jwDgmeL3BHnqjSzc1BVEzsWzBJq3CRKg1bdMN2FVwFsZJVqi72m	9679	13656	13656	1618397280000	canonical
19184	3NKyfqZrNASVQZnbxcVkXLX6Ya9UryisoZDTwopEnUdwhyLazbhg	19182	3NKHEvp71YgrBGig8qACswLy4g6NGrVyuChaSU5RhKXEzoy5ayrX	1607	1348	333	6301	12463	jxMjSTNEMMkLocDWHrqGFTfgey9nQpDY7JQQ8fd21NPCZKg1KKh	9679	13656	13656	1618397280000	orphaned
19187	3NLAKWiKgJGJNYGwLWeZvJR8tuqiWCUoCVHf9D7b6ZVbTfk7qiE3	19185	3NLqMjhSyvHcvWJCpu99zLv3vYgQ9GXyLNTUgFowSyKaZbZAFKhp	1403	824	333	6301	12463	jxdGr6o1NE4yH2V97Bf11HtekkkNphpt1kaits3PvcLPkbDjJ1h	9680	13658	13658	1618397640000	orphaned
19188	3NLoXCTqxZqEz8Bo2TFfQHRveakKAQ8Zsdw2psWWTxR8kUhe1k8T	19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	1402	810	334	6301	12463	jwyRgozekFc7khvQU3J8sHEeatiXaZ7mSFABCir48LRgqrJNxKq	9681	13659	13659	1618397820000	orphaned
19190	3NLvmJJEBMMHtdsxgvnYzXRZ2WRwvv8qAjGWQRX5aSsRiSBCZDtY	19189	3NKg5bYgP2hiFCBVj4D38ZU8zeqAjG5BLSUccUhTxrZBC7cR5Hub	1406	1393	334	6301	12463	jwK5i8dnZHyuwgN1WeqjT16i5J7AnCnLG1rbTduQoawdvJPv6AC	9682	13660	13660	1618398000000	canonical
19192	3NK4epemYzLc2TFK72KPjCi7soWPFZ1DgTxBwz9TnUrSmSxKhnGo	19190	3NLvmJJEBMMHtdsxgvnYzXRZ2WRwvv8qAjGWQRX5aSsRiSBCZDtY	1474	1083	334	6301	12463	jxnfge9SvT1kJTwgWcJYNbjTxjHY4Jg6qRgZickgH993ira253B	9683	13662	13662	1618398360000	orphaned
19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	19195	3NK69qA47SDJWLYSTZB2kyZ9kyuqZWP4WTYGUvh8pMYzZimYpY79	1407	1395	334	6301	12463	jwur6rbgeLBSrZE6Y6PLzd9JggaPpb4cb2Yz2ryvJZS1cVxZ4dd	9685	13664	13664	1618398720000	canonical
19201	3NLSs9TDjHWABRmYhZuNFsKjsZwpF1fdRsQzmr54PkmJ12xJ53iL	19197	3NKoEyfyn851gibg7zrPzFr6pNSVpJ8m8hN5YR4s7PA7nEJu5rWN	1607	271	334	6301	12463	jxwbodGPLm5ydPmEfc3BTTBGuxbLwFEiTkRcgpWwJumBp9bjXuc	9687	13668	13668	1618399440000	canonical
19204	3NLLKnuBTeNW9FVqgHxiKu9n4Mpmnrkz3BXVQ89VuRcrsVtYgDNK	19201	3NLSs9TDjHWABRmYhZuNFsKjsZwpF1fdRsQzmr54PkmJ12xJ53iL	1455	1206	334	6301	12463	jxseDRTv3aKWjKww8z9RJ3tqBzQ1LHX4yzkwCzQECuWnPTbPeTp	9688	13670	13670	1618399800000	canonical
19205	3NLdUBS2VtSpd5HLnJjW2hyGE3MqpTVmFMxTkFy6okAjWPUgoE22	19204	3NLLKnuBTeNW9FVqgHxiKu9n4Mpmnrkz3BXVQ89VuRcrsVtYgDNK	1587	991	334	6301	12463	jx5zAUvBwoFoghrTuQ1qYJCitGdTTvtJgvRcRPcp4Szw3vvT21S	9689	13675	13675	1618400700000	canonical
19221	3NKN6ZTKvU2x1G7difo5Aj8MP5qZEX5X1aByHrpm9KJNd4Fkeyo8	19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	1542	1178	334	6301	12463	jwDik6kxX6xETvJZJFuPLDg51BvGRH2q7GbbNX8TmbsPzdFsoVm	9696	13690	13690	1618403400000	orphaned
19227	3NKQrtJTkg4UN4Vk3dcw7M5noMFGVyYkLeNjFWqGwV2p5ovaB7px	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1546	1093	335	6301	12463	jwo6agMcLXkZMP53pz8AUtJBcF5ZJYKqoq1LqJXbKQeP5B5kNhg	9697	13691	13691	1618403580000	orphaned
19242	3NLTnKsVUt1pidBEKjaBRrb5BR9VqGjLwyYkFVjK8q4B9z9DATeN	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1406	1393	335	6301	12463	jwXnZF3EGDD53P3Kx95VpTb7qwwUQVz6PbMttHeNx72i9fZGNFJ	9700	13694	13694	1618404120000	canonical
19243	3NKUAH4acNQuj21sZst2nvXFDirVB6dLBECz9XFE7o9zFR6rAj5z	19242	3NLTnKsVUt1pidBEKjaBRrb5BR9VqGjLwyYkFVjK8q4B9z9DATeN	1406	1393	335	6301	12463	jwiUt2LErtXo7arvjpCkmCDPSp9FxAyxByUxRf4zm1wFJ5rwe3w	9701	13695	13695	1618404300000	canonical
19246	3NLvjs5YTDY2EoGYJMZTEj5pKpbBpAAm84rvE7JhCyExgBMBFedh	19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	632	1136	335	6301	12463	jwRFfmsAFwtXm8NUgLt1mCNSKAjFsUwndWX51HzEAgymYR5KXMN	9704	13699	13699	1618405020000	orphaned
19251	3NKN6avnh3KPYB4SaHuTxYoneCixzdTKKo5pH3Mt4V8Nkc8qWFud	19249	3NKwVQSGpcwy3w3bBaeuHkiWCSFTH6hekVzE38uSY1PNfjE21foE	1406	1393	335	6301	12463	jxn4mebtzAk2UVoXwnavKLQKBtLdWt5zGZosAgf3QriSWcoPEKP	9706	13702	13702	1618405560000	orphaned
19253	3NKpbuzHmj6DX4tLxNBARRQpu5cCXx2YQPN9mfCouwF1MeNA2DF9	19250	3NKGZuv3zYTVyJg1V4Rz9wPQjkpTmPaZKGceVAdLjCaJixtxBdT8	1631	794	335	6301	12463	jx4MgNPmPkakKGTi1h284CXdmEmQDaAhixERSjCY46PLNuih9uX	9707	13703	13703	1618405740000	canonical
19259	3NKRBwYY6Sdqdh3HGLShZuuq7srnv1EGMsstd5fKfxecgW96XfTy	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1419	814	335	6301	12463	jwDNBFmqoq4oGCXpZT3c4iWW61j8fWCFse4zdze22ud4vSeKGdP	9709	13708	13708	1618406640000	orphaned
19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	19264	3NLVjJ5g6QwKZ1WRMiB2UX3ft2eMsuyyYhyPeLHz4jfJBJdFfEAU	1637	816	335	6301	12463	jwgiUyJbpbEzmn5smUxsQLNF7spkAZsDBFcSJX62sTyFPhFNPBx	9713	13712	13712	1618407360000	canonical
21834	3NKxJi4ecbDtFjU53JiSqx2v7hKHvuBtfQGc6D2YgrsdsiDWxdTa	21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	1553	776	400	12463	14002	jxZbdzactMKywjRWnFGLHq8sAPshd6E6UNQGopSj8xKntHSBUv1	10927	15388	15388	1618709040000	orphaned
19193	3NKxz2T8aSJ65bcWUJSLwB3q4btSFzviFeKEhCH8xe95PPNMDXLY	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1407	1395	334	6301	12463	jwXfpZkTKGZTE65tAnNVnha3PqSzWwE4yza4cxtMnDioHHw9dhj	9684	13663	13663	1618398540000	orphaned
19198	3NLUr5PxQgtG2xPzVyvDx8TVFbFgML9Yt9VZEYdQPq9MaW3NAs2h	19196	3NK9YMZppLs99UYAB129r8r57rxhPfA5vhFjUjbJKRWuB2cG9K3X	369	1066	334	6301	12463	jwttELr44R4BWCRSsZaU29ySASzhMxeupufZhx1bCCxqfY4LKw5	9686	13666	13666	1618399080000	orphaned
19202	3NLxViVrGyUybJubqgkaxb48ZPy4yt216CRonwYHRgP3CGjYgWyX	19197	3NKoEyfyn851gibg7zrPzFr6pNSVpJ8m8hN5YR4s7PA7nEJu5rWN	1607	271	334	6301	12463	jxU8aC8pjp3rmLMPjcfQwRE6e8T7HwdBcf6o8b6Y1qXU1Q74tzm	9687	13668	13668	1618399440000	orphaned
19203	3NKZ62KmRUuoKDTH6MJUdk3mEytyEQ5vShh6aV229zbGvZHQ1Qwm	19201	3NLSs9TDjHWABRmYhZuNFsKjsZwpF1fdRsQzmr54PkmJ12xJ53iL	1407	1395	334	6301	12463	jx7pHWoSVdBuFwrmNkJMM6nwWCrHBgva3TNqs5ADeizRuc4Q4oW	9688	13670	13670	1618399800000	orphaned
19206	3NK64gVxPHddSm7KyXoBvaVAx56B9fihVyV28C2PwGiFJeJJQm2u	19205	3NLdUBS2VtSpd5HLnJjW2hyGE3MqpTVmFMxTkFy6okAjWPUgoE22	1489	1134	334	6301	12463	jx6P7KcHRzgbqTYSN6tNTKZdsipPhQfbp92XvkWC3zDg6TCGneM	9690	13676	13676	1618400880000	canonical
19207	3NLSuwWXrfRVjKtFdUELfRd5GpJhjK8B8g1TWDYfnb8a9tGMeYRe	19205	3NLdUBS2VtSpd5HLnJjW2hyGE3MqpTVmFMxTkFy6okAjWPUgoE22	1489	1134	334	6301	12463	jwgYZ1JCrYgmfV8gSjom76APjkUmsfyVjRBxSrts72iCXJNEWJ9	9690	13676	13676	1618400880000	orphaned
19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	19206	3NK64gVxPHddSm7KyXoBvaVAx56B9fihVyV28C2PwGiFJeJJQm2u	1585	1240	334	6301	12463	jxjLwZwWg8kh8qRFPc2h14N9CvfKruRyFLuyEHmV6oPLWtx1yeT	9691	13677	13677	1618401060000	canonical
19211	3NKRkpVQaxLvwYYka7R71b3S7X2wmdH1ZwXQXpnP1fd7jcJfXbJR	19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	532	1303	334	6301	12463	jwfRSQKM84RFs2MFnHY5BzDu46t15A1xN2ijkUhbwP5Duqf2u2z	9692	13678	13678	1618401240000	orphaned
19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	19210	3NKfLw5Gx2wYq5grz6iBpCADJaG4TkRkHVtgAFrvWfa4nFReNKS9	1406	1393	334	6301	12463	jxutYcdZnGB32CYhqLuoLqejP3cRQaP1vdKuRMZ6oKvMiBNkgVV	9693	13679	13679	1618401420000	canonical
19215	3NLQdh9GEap5Xeo9mkDd8QsGjuRG3F9cWRk9ShPKXGinPZ1y9MeA	19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	1489	1014	334	6301	12463	jwcSG4p3uc2c2gRSmEEgApqmFYYwXq99CvyFUk493BxfBNX4jov	9694	13685	13685	1618402500000	orphaned
19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	1542	1178	334	6301	12463	jwNxPfVzX8wiAmJMp5x5F6vdx5V9KvH9xXw8zZ7vPJpFZG54ap8	9696	13690	13690	1618403400000	canonical
19226	3NL2V5MVzrPYxUDrW3kqhZCSuMy2c3K1iqDzfzsyuz4ewVZeDNBY	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1523	1321	335	6301	12463	jwjbafZebjy8YMa5RJf6qnLAX3dFF4PZL9s7TegRGX8tQG3eK6n	9697	13691	13691	1618403580000	orphaned
19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	19231	3NLPqRVZtWYkGa2HnEduGZcZzAgC4Ekq4RFUJB7Qw5oC8x4jaMam	599	599	335	6301	12463	jwNYbRGB5abQwas8nvSfPqLnY8hjDSkdWXvpbz4ENU64sbBJrCw	9698	13692	13692	1618403760000	canonical
19236	3NKiW8Q8okgkpDa4cBoirc6t6XHBHBbharZKe4z9vUT1bJWrqy9D	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1589	1286	335	6301	12463	jxPhCj17XcV3KQTQqnDmgv3YkDREuuBSNGr6Eg4xE7fzhzK3BCo	9699	13693	13693	1618403940000	orphaned
19240	3NKMATBpdWnLvAUvgyvn51HRF8fnqDtC6unUAukJwT8fjb9vZdGs	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1516	1168	335	6301	12463	jwftcKKbRsQsVbU3KLjbQpHkCb1o2WrehbHXqoLZokbywGLFzAL	9700	13694	13694	1618404120000	orphaned
19248	3NLqgcfNVwXp7eVn7E97cuTJ3h8en3JEpKHFdTHjCPqPKe44jVif	19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	1487	53	335	6301	12463	jxDaBkT4tUuvmDajPsYWE1Qb1xuWkwCUUucYhFqF7hmQm57mgee	9704	13699	13699	1618405020000	orphaned
19252	3NKTTifzTroUjZH8oNo8nxxWJNLNUKpWbso1JYdMGuVEECyS2KRN	19250	3NKGZuv3zYTVyJg1V4Rz9wPQjkpTmPaZKGceVAdLjCaJixtxBdT8	1670	1282	335	6301	12463	jwqfYPYLok5rn3drWc551AyV6HHwP8QAFyHemZQGyCvs7Mn92ZH	9707	13703	13703	1618405740000	orphaned
19255	3NK9Bx6DJPu1CdrtDZKyASaqqUPHbRE9T6mNsSB34nufftVwbGQd	19253	3NKpbuzHmj6DX4tLxNBARRQpu5cCXx2YQPN9mfCouwF1MeNA2DF9	1643	1299	335	6301	12463	jwRT3eACqSvwUj4ne1sLght1dmstxC7Z3cBacVScqQ7FGGaVLLy	9708	13705	13705	1618406100000	orphaned
19257	3NLpS5JEZ2vBBst8P1SjvUy4TV6d4cRNRG5vP7Uhwg47hjuFBTFy	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	596	1306	335	6301	12463	jwvESgvULfskdfZUxPCzw8TJQEyfKhTDs3WEwAfD4H7vXr3DQgA	9709	13708	13708	1618406640000	orphaned
19264	3NLVjJ5g6QwKZ1WRMiB2UX3ft2eMsuyyYhyPeLHz4jfJBJdFfEAU	19263	3NKbnk9Pu9RkmyEKqFq1XPopZLRapn7mD7k8tULT9SdQoxAQHPbo	1529	1316	335	6301	12463	jwb6dRh4p6itmPRSfX4yP2YfP8Fa4hraRDvJVcx9qJFiu3nvLeG	9712	13711	13711	1618407180000	canonical
19267	3NK6o82YTKSfWqtHyH2YVN6MipwfgmECbDsMzNyZ2wRrBiBdbP68	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1577	1327	335	6301	12463	jwbWx8xieP7FHwo32VRzuZfBRdQFSTdUXmjCii4wZuKU78cN8Mi	9714	13713	13713	1618407540000	canonical
19270	3NLiEfjF8DXYtmBufuU2yrTQfrQYEftads4LwjnHXpk2iBq2Byw2	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1553	775	335	6301	12463	jxzXRD6EPPEnU9yYodAKu3HKdtbX8yBh7cnha97dLs2EgC5yPJi	9714	13713	13713	1618407540000	orphaned
19273	3NKriJvqoV7gjmpJneED6o1MLCGAv8RCVdLwwTyNDe7hFwLH22M1	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1523	1195	336	6301	12463	jxnWhy2RfsT6LvKW3r7JC69viKbsgZwhbHB7VhEhd2MaXjqqKTf	9717	13716	13716	1618408080000	canonical
19278	3NLQi7mLPYwHDDmGYBXJN6RTmC4bfCyZn4c3ByQst4wgAEAUxY8M	19277	3NKNFTJVCaTMXkaNEhU5AgaHnVvLL6an7qWbXg7EHV1cfJCiph5q	1489	1134	336	6301	12463	jxpJpTdaspKrEKsVUyproyqnxzb61WCrJZxTsegNCpJmj23AC2Q	9719	13719	13719	1618408620000	canonical
19280	3NK4gLAD3jYyGG7aAfY5dBPgPpEcsV479ezTNNDFjW5kKGBugh6p	19278	3NLQi7mLPYwHDDmGYBXJN6RTmC4bfCyZn4c3ByQst4wgAEAUxY8M	484	953	336	6301	12463	jwENCdJqRjZb9A7LNXodVWctHCjpeTt18F6dEUgRmp2AEG1aCpA	9720	13720	13720	1618408800000	orphaned
19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	19282	3NKrVtkBe2LKcUkQtMFsky2jjD5G5MYcw638m4vufgnkcXURFqTC	1403	824	336	6301	12463	jxdHePKFtbtAQpszW7THC3BP2fP5qV3ciEPSJddUZbfhPTjqTzZ	9722	13723	13723	1618409340000	canonical
19285	3NLDtWD3xekvuQ4AEAXzFSjaVU72Kx6KUH55rgj4LgmKFNfNRtT4	19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	1599	1287	336	6301	12463	jwTzovVu8aRzc1cjgqZxAWvsmhLtpBY1ueDF1Z39GUQAinARGJ2	9723	13724	13724	1618409520000	orphaned
19291	3NKLYCPSeARm3VdgeZZjH5bVe9NnZXb6npyhK2Ptsuw5fiU1dxSk	19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	1555	1347	336	6301	12463	jxDEzbyexbu1nbcDNfJ7FBNHZVe9b3NcRTg2YM6X5jMLjPRyMDy	9726	13729	13729	1618410420000	orphaned
19298	3NLFkB5dHo5bR2bVqzw25p6u9UT95u3H9UnX4TNNJtAEuzmLafdv	19296	3NLaZBbJRDsvFLi5zi99LSyLixNwG6YDDd9tefiwk4U7mW8bPkXk	484	484	336	6301	12463	jxb6xbjXFc359y5qbg6eNa4NpQbTdbvXAwefFYyQPoREiTSRwCQ	9729	13733	13733	1618411140000	canonical
22242	3NKm7btXhNdpycyDyuZh3ZL8sCvwcMKzxdJkqcigfM4huVHLWA6x	21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	1501	1114	400	12463	14367	jxseHGMkEhAMu8KTW2HPqozYRXHbs5iyDc9Mhk5C1t6GWxL4Tok	10935	15672	15672	1618760160000	orphaned
19219	3NLD4wwAbej5xkT2iLVLszTagEBX84L3Nn4jacnCgDHp9Yz1YSeK	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	532	1303	334	6301	12463	jx5rLp197XHkUHRP6kw6YHgJrKBe8ZX5FtXDgs8WvKTNbN5XR8n	9695	13688	13688	1618403040000	canonical
19220	3NLcmmTC16Q396BCkGj7zYn1w5PqeJYZ3ibLcKaQEhks4hGcNPhC	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	532	1303	334	6301	12463	jx5rLp197XHkUHRP6kw6YHgJrKBe8ZX5FtXDgs8WvKTNbN5XR8n	9695	13688	13688	1618403040000	orphaned
19232	3NLevQr6CTrmSpekQtcfw5oPSa8Gwmq7v3BR6CCn9opG2qhqZfXP	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1546	1093	334	6301	12463	jxgjAN8Hb8iSQqfcaUBd8SgYeVahLqX6PFLn1sjJGXSNkKDF6xv	9697	13691	13691	1618403580000	orphaned
19234	3NLpr9HYLoYecSssrQDmbmXUBcEWe1ZBZkhQCSfmHJt9neNMnBiq	19231	3NLPqRVZtWYkGa2HnEduGZcZzAgC4Ekq4RFUJB7Qw5oC8x4jaMam	1407	1395	335	6301	12463	jwyKxQLZvucvLRMzUH4qfrpWi4i8xMeUMyuVCHqWCZhpyNWN58G	9698	13692	13692	1618403760000	orphaned
19237	3NK5yyj2fE6qQu9bNxQm1JSyJsnya7oaBJKvr2StcQGwVExEeRA6	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1439	1279	335	6301	12463	jxH6GoUGBe1C4x7UcynJj7qboDG7P4JCkUce92KmGGy2PDg8cQu	9699	13693	13693	1618403940000	orphaned
19241	3NLJGy4ZEDodKLB3WbFp3GfPdXUa3fqExFSgnaErhRLGRrcfM9oe	19235	3NKW1QoASuy6MM3fKC6hCNVmr7mDTiP73zWkMQwvh4pAtdo8T5at	1637	816	335	6301	12463	jwV3CRxB9zQx4DPY2rYc1rZ1HiJTSVTwTpKSgMFPSiVuU5UYhpd	9700	13694	13694	1618404120000	orphaned
19245	3NKjds9AAG79e3Emw753JfUfUwXfLs4DCYWqD51fJ9sUTQ5Dy4ND	19244	3NLSJboDpJFqUgAF4VwCqeeqfPLD7ViiCkPi35kYcc39CvhGkBEZ	1588	1146	335	6301	12463	jxa5tXeqiCqbNWRcghEkjDP6gCfmGQUt9j9dJ1A12AptWoU7Vkx	9703	13698	13698	1618404840000	canonical
19250	3NKGZuv3zYTVyJg1V4Rz9wPQjkpTmPaZKGceVAdLjCaJixtxBdT8	19249	3NKwVQSGpcwy3w3bBaeuHkiWCSFTH6hekVzE38uSY1PNfjE21foE	1536	1313	335	6301	12463	jxnrtCch5qxf4Uev9QyBuY4SABsSy1yjQPbwiuo5a5YtgPvPyh8	9706	13702	13702	1618405560000	canonical
19258	3NLrGZVguYk1qsZZQ8kevR5Kopcw8xoQtiN9z2QaGAMwAuESfDqX	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1439	1033	335	6301	12463	jwDTaeE9tzSzrsYV4v1zgkixfRDtfexVgV2w9LyHu7yG4eWq5xG	9709	13708	13708	1618406640000	orphaned
19262	3NKZEmx2FtTBTz2oh3Y7ywgGKUNW5256tLZuaCHjAvhA3u5535CA	19261	3NKCfcNsckHK7sGxshMAcuAPXC8cxBP5kWHdUcNRCLGfC39Xk4hF	1405	867	335	6301	12463	jx2WUXcpLQurPHswtFJ95kDKAHte2eRLfThhfheyGGJhPggFB2W	9710	13709	13709	1618406820000	canonical
19268	3NLn4efUGjJg278XgkvCbg9h2SVaSutGDyZVZJayiFTShwnSnNFY	19265	3NK5VDtNtPj7faT8oPVtRtaqm1e5xbBCi72TYRKjVJ29aAK144Hx	1577	1327	335	6301	12463	jwbWx8xieP7FHwo32VRzuZfBRdQFSTdUXmjCii4wZuKU78cN8Mi	9714	13713	13713	1618407540000	orphaned
19271	3NLZrjb7bur7ZnwL27NkDJ1HeTu1U3PSteMxto9ZWZCNSgVnDHPa	19267	3NK6o82YTKSfWqtHyH2YVN6MipwfgmECbDsMzNyZ2wRrBiBdbP68	1403	782	336	6301	12463	jwFD1x5YztPbR9CFGK56XZAbAPquphfsjRQ2j4dbrbLkFNwocWp	9715	13714	13714	1618407720000	canonical
19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	19271	3NLZrjb7bur7ZnwL27NkDJ1HeTu1U3PSteMxto9ZWZCNSgVnDHPa	1564	1338	336	6301	12463	jxcziG6p37iHya6JhHRGoJWn2Ychy6gEjpfbpHeiP45e7W68kFe	9716	13715	13715	1618407900000	canonical
19274	3NKHrZsU3GT6uvTGmTucbDYPUqTmZEPiSkqMdN88gRhpBUKXjNn5	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1523	1195	336	6301	12463	jwb2JTT6m4v3mG7J4V8A8PCf8FtzWJjAHbv7mpVsWQ2FMshMMxs	9717	13716	13716	1618408080000	orphaned
19279	3NLHDjU3bBByVJEdHTWmXPDGCpGEdQna5N8RRXqJsJxwkwdznqLu	19277	3NKNFTJVCaTMXkaNEhU5AgaHnVvLL6an7qWbXg7EHV1cfJCiph5q	633	1384	336	6301	12463	jx1c6VMsUCQWL8TgsoobGUrGuYnGGb5zPLmYGU5gsE7rSnAbXNg	9719	13719	13719	1618408620000	orphaned
19281	3NKexMZxfWKeynS34bU6CkuQuam8MJx6DoYBG54QV5GKhk7tQTHw	19278	3NLQi7mLPYwHDDmGYBXJN6RTmC4bfCyZn4c3ByQst4wgAEAUxY8M	1406	1393	336	6301	12463	jy3CzNXjKowcAoJg73BwM21tTKGnYcVCggE4r74Wg2tWDVj1i1g	9720	13720	13720	1618408800000	canonical
19284	3NKMYnUjBk4nCTEm6vHtg4kKDh5BSKSF5cFhuoP3jpu3D7uMYK8j	19282	3NKrVtkBe2LKcUkQtMFsky2jjD5G5MYcw638m4vufgnkcXURFqTC	1623	839	336	6301	12463	jwEd2AqY5TxoHtj7FHniE7xTZr8GgoC386vZ5oVYeSv3pUcE9Gz	9722	13723	13723	1618409340000	orphaned
19286	3NLwvt95Wp4NY5F5F2r5oqTZwEuJUqHikSExVkQV8vU5RwEgV6rr	19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	1403	824	336	6301	12463	jxoA4ECatEULnodsGmhHCzGKCGnvGeRmsbTAY7oFXGdEXuceDrE	9723	13724	13724	1618409520000	canonical
19288	3NKdqWLg6n5WguqK3xjk6RYcMm3JUZzCjSFPTVP4ibKj7FvW9vHg	19286	3NLwvt95Wp4NY5F5F2r5oqTZwEuJUqHikSExVkQV8vU5RwEgV6rr	1406	1393	336	6301	12463	jwN5Gicki4MuEnhqEsqJGpnDU3qhLU1MqvMgL5gAEPoWs2MRXwy	9724	13725	13725	1618409700000	canonical
19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	19288	3NKdqWLg6n5WguqK3xjk6RYcMm3JUZzCjSFPTVP4ibKj7FvW9vHg	1637	816	336	6301	12463	jxh1BSKWJTkciXRTwTD8xjr1E3YPwrrvCrHKpiJMHRpVfGfqQih	9725	13727	13727	1618410060000	canonical
19293	3NL1S7efXZj8sHpjwKibjbP9VJR4jeQdWqRaM8BtXdfpY5DN1NmA	19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	1467	1130	336	6301	12463	jxmoqbydQ6rHBHbbX7mR6najKtgCqBaQRGPtgh6ak7fWWBHN9z2	9727	13730	13730	1618410600000	canonical
19304	3NLoN7pUyTrnrwgzW9yidVdDpfaeznaSqVFTd9Bu2eG5UkpEi6wN	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1477	1350	337	6301	12463	jwjRfaeYVAKphpEyQMTAv3fJgQGE93sbBoBjyytM4oG1bEZy3r1	9734	13740	13740	1618412400000	orphaned
19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	19310	3NKgcMAJSQFBv8JqK9cgvLZ7zdAtF5vf1nWrdUNw1ppeLdr5KAas	606	1295	337	6301	12463	jxuQm7A5xj5bsvzScjS7Ye7udiC1AmbbqPWjnwBH6dTi43Eh2ag	9738	13745	13745	1618413300000	canonical
19314	3NLRNbCVSrmxRx7AfgYHr2zAmgHrHovNwTCw87jeLsaagHniRnpn	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1523	1195	337	6301	12463	jxVQfVY4LF5gP4xTKDeT1s6VgGmJJhBWrmL5phJxVqxeQLJCDL2	9739	13746	13746	1618413480000	orphaned
19315	3NKcKydDeP8Lir7JMW9i3tR2pvcPim5mB3Rbq2pWJCdkRoHkeUSi	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1555	1347	337	6301	12463	jw6n5PLWMXgSwTWaVS3q5eGhmvb3qqyFhuiFzbCtw86jbVZF7ha	9739	13746	13746	1618413480000	orphaned
19326	3NK3gun3Ufc1EoAmHw82J15ByP1htTJgTU4Sm26HWUBqgqLRh92p	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	1407	1395	337	6301	12463	jx4hvYcygAtsmu6hFPwcQm8HgnLzN7T1bBeftzcndP2o3taQchw	9746	13758	13758	1618415640000	orphaned
19331	3NLsAr4YGd4BNyC71FjvyfE1G6zTDkWHdmYM7TBGoeuSXwZVAGHA	19328	3NKbehX9d86o7PoGf2ZkzWHvMCKbaZgj1fb6FfKLVs4shv3oDNVq	1573	952	337	6301	12463	jxteEBrJF5f1VbT3rbJwLpwm6VLzv9MEHj28sUg8DWwNBpFcfc4	9747	13760	13760	1618416000000	orphaned
19334	3NKtEW8m5Uyx1YYqfXX6WL1GJU4j7M5qsT7XrExE8kiC9nA9k4Ln	19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	1406	1393	338	6301	12463	jx1NpQw4xdSgAxizzwHeG19bDR6T1cE3VtERiSsarEp3vzhnWwu	9748	13761	13761	1618416180000	orphaned
19336	3NKTZL3UT9krQpEwCSDu3KpeJcxiYS7AtTc4SXj9caKs3tDkyfgA	19335	3NKdTef9RsE8uCo1bmRq2FL6TVSMPvsRyaEiqVNWsYim1MLyby8Q	44	1325	338	6301	12463	jwRMsGSryapPi3H8dq67nmuGro66XTkWtsBUciYmLVJWFDuCNzn	9750	13765	13765	1618416900000	canonical
21864	3NKMzKaRtL4Pdt5Nsa761NK1mAQLonWkjGNJaD31sxxH8tQMRct5	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1460	1324	400	12463	14030	jx8nKWS9riEbter7YrriahMQLcumDXHkEAziR4z9W8n7yvuwV89	10943	15410	15410	1618713000000	orphaned
23118	3NKBSzpkVaTfT3UuxGwhU91T8Xjne9h74N3osANrtJ8UADbC2Dhm	22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	1581	778	417	12463	15151	jxsaaFq6P8sdDqtaBW4UhQryBpfdTdup8tqjyh7mViR3szAPL3e	11257	16258	16258	1618865640000	orphaned
19277	3NKNFTJVCaTMXkaNEhU5AgaHnVvLL6an7qWbXg7EHV1cfJCiph5q	19273	3NKriJvqoV7gjmpJneED6o1MLCGAv8RCVdLwwTyNDe7hFwLH22M1	1571	1209	336	6301	12463	jx8oq5jMppgpHnDSwEN72b6K62ub3xLF2m9nkXmweg64RqwDkp9	9718	13717	13717	1618408260000	canonical
19282	3NKrVtkBe2LKcUkQtMFsky2jjD5G5MYcw638m4vufgnkcXURFqTC	19281	3NKexMZxfWKeynS34bU6CkuQuam8MJx6DoYBG54QV5GKhk7tQTHw	1673	1242	336	6301	12463	jxtCzLV5HuWffnoRiRe4v4kpL7g8fzY1LF3oNzN6h1Egrd5eada	9721	13721	13721	1618408980000	canonical
19287	3NKvwoPxndkYstASN2cGqrxa9vNAB5GT3Xcnf8KGdmYBgaxZuN6X	19283	3NKgxpxJTC6wCoujZjCi5DNpiKfoGQ2pNjSV3mgZKxHSypr4x9vf	1406	1393	336	6301	12463	jxYzUn8fGEfphHUktYicqT9ycF5JuQbrJ5crYDHK4C5H5Vyunhg	9723	13724	13724	1618409520000	orphaned
19294	3NLkzV5kpYKFen2nZfFViMg7vcCG8Xs8mMM2nk8aK2Qs2Dzw9ZQA	19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	1588	1392	336	6301	12463	jxBPeLzZCuXLe7cvtMBHfokDgT5sXPvppn8gPRi41VdjZjuoTDx	9727	13730	13730	1618410600000	orphaned
19296	3NLaZBbJRDsvFLi5zi99LSyLixNwG6YDDd9tefiwk4U7mW8bPkXk	19293	3NL1S7efXZj8sHpjwKibjbP9VJR4jeQdWqRaM8BtXdfpY5DN1NmA	1670	1282	336	6301	12463	jx6YprxKLssHWqRLnNX96Uff1wVGyZv4CC1vz7FCpaLwWcVKr1c	9728	13732	13732	1618410960000	canonical
19356	3NLRCGvGtTFdiCvGwnSwKvXAWXtXNYWKf7wUkgNohMSdhE1D76ff	19299	3NKRBePvr5kH61SAfRYDgHnMBVF9NVWe1TH6PohvenX92KGqgaLv	1444	1255	336	6301	12463	jxFRfEtL4g3334d7edZBArf3kPAE6rhatSL1k6MUBA1tuHgMdA3	9731	13779	13779	1618419420000	orphaned
19301	3NK7NANAGnqofVdTudQZozM6c1gCmCAoCbqmmEzWUrPBDRXwumjd	19300	3NKbdoebH4EL3kZACkGUdFEXxz4VV7Z2R5Urymz2ufKLRDTcCwKU	1407	1395	336	6301	12463	jwUVWuWN1My4w5d4VuTk8wZLnRo3wEmPa1jP1iA3Hv2EmDLXHeX	9732	13736	13736	1618411680000	canonical
19305	3NKV36rDVFKsFy49YLUNShY8CDgJbekJwAGSuqbqAMdywvsYby6z	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1477	1350	337	6301	12463	jwjRfaeYVAKphpEyQMTAv3fJgQGE93sbBoBjyytM4oG1bEZy3r1	9734	13740	13740	1618412400000	canonical
19316	3NL1TqpAYHBs5detqy8UApPXsCcEoEV5wmfrpx7oeA5G75qPJFjG	19312	3NL7TFCWXg8jMLt1VUdvSrHkxs1KTNWnEiGvtb1LULqSqzCrL9vL	1406	1393	337	6301	12463	jxrSjo1poUHmq1D1WBFHtATPvk9HLyxG9S42VQtvWpm5MDgaBFu	9740	13748	13748	1618413840000	canonical
19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	19323	3NLhDtE5Dckp9Ng44LtPj6oyXfUfRgyLxCn6qD2o8dTzMA4pSUPS	1637	816	337	6301	12463	jxjeWTSAyWijMP2wmwsFKe5Qqmjsr5em32vxPYtDYdBVcqdE9Ru	9745	13755	13755	1618415100000	canonical
19327	3NLkAfYz7JXui7voQV9SbSsuTH1XESRosLv9oTCv1PN2AMb7MuGG	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	684	1106	337	6301	12463	jxSHZ8sxhDsTsh2YvWpXTBpRzCdt76R5poepSkUAmy9GipsaVcQ	9746	13758	13758	1618415640000	orphaned
19339	3NKQDPahP4bcEHrChTvKSyKvvozRNMDUqs8QFfRhBRZZ8wWZi57s	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1588	1266	338	6301	12463	jwzpPC46jHEqER49ZGawkP8Fg3EiE3qMi896bx9QoWRzH5JMX8C	9752	13768	13768	1618417440000	orphaned
19346	3NLtyBBSfgkh1wZxZJk7EifZ6e1ru6fP1ehK3vUMveqgT7E5ET6K	19345	3NKmjbQRDQzvhS55YP7jCtq27BhpLSvQLnoPF7XoodcFjNGJBTs3	632	1016	338	6301	12463	jwLWAXDaif3xp9d23oADdnT16YpW9rX5mJrVFeEWNoJvReMwXEK	9755	13771	13771	1618417980000	canonical
19353	3NKRL52XDxc95QcUsyK4HtgYrZf4jZProUd3Q4Ax3uaQ4CdCWZv4	19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	1577	1081	338	6301	12463	jxU774tBbixpLThUUXoHWsrRJfeLLewWXukoPPYbJ7b7WeTA9Hu	9757	13773	13773	1618418340000	canonical
19362	3NLuGbNycTzW1GFLF97ipR2nd99hr11cEAmY3zUhtaDYHViDSSuH	19360	3NL3WHif9VBm29k3rqAK5WVVVb2BuUMZVngzHe4Gxfp8GA4jFYiL	1578	1050	338	6301	12463	jxFPv6GDdJZHA1jagRRS2WTheqeM36QzgbhvTyL3bYhkjHTkALx	9761	13781	13781	1618419780000	canonical
19365	3NKvQ5jcpanzsPbSAS2tmz1QS52HwA12DMc21FYLL4XvPV7uLzkX	19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	1672	1285	339	6301	12463	jxGbKWLxDpXdjG8CWx5ZYUvswvCb1asHiVWP5gHFQvu5fa7AhRy	9763	13784	13784	1618420320000	orphaned
19367	3NKYAAFGQEAE8eHYvRaCdHwWod2uzcTaxjfQApjMKhkWrqvmA8gm	19366	3NKtxjhKMu5jbjpvKDb3EMPPtRWXd28AkmUGsdAaEzZ4vR3QqLou	596	1060	339	6301	12463	jwNiGtVoAfdBu6tdqKsfJwvgrkskwJ8ggvbaSPDpdzsMv5TCqS9	9764	13786	13786	1618420680000	canonical
19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	19370	3NLGtQN7jG8pzgCcbtKcset9xT5E7eeaDGYUfzanq4sxoazfFEt1	1405	849	339	6301	12463	jy3D6P1vbdnfZuimd8EKvvqMKJnYb19WfBpCQqbwo1rSDCc6vfA	9767	13789	13789	1618421220000	canonical
19374	3NKAs3qYvZsWQppL4pN9HrhNqEBLa8W7xhKSsT2QPKi7PqdPBoe9	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	58	1281	339	6301	12463	jwLcPMYE9jfzq69DVdnvxJ88NXaXuLRW7gQEoscZq8wsCbaYGmF	9768	13790	13790	1618421400000	orphaned
19377	3NKRDmS1QbAYJNXwg6hXRzFwEbLKk4CHj94SJ3K2mgJfLWkHQu3E	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	641	970	339	6301	12463	jxGJfcQQQDtMHUp5jVDj7cBy7Q3zEPur8Bm4K9RW4AXQdqRwcuB	9768	13790	13790	1618421400000	orphaned
19384	3NLFEyZpAzS17ehF8RSYx7VhfZ2G3mFZAc5NZ3d5esaRDSJGmSAR	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1403	824	339	6301	12463	jxxW8R9y3vnGY5o6pHhXW8Euapm628uSAw6be983i9Qsc3ohTCB	9770	13792	13792	1618421760000	canonical
19386	3NLNQU4gnqAdLAHqwLTefwtQA4p3vLzE2ZSxkGhgcQj4fTcaWfv6	19384	3NLFEyZpAzS17ehF8RSYx7VhfZ2G3mFZAc5NZ3d5esaRDSJGmSAR	1650	1129	339	6301	12463	jwPb4377hqnQXqcNgAx68rVS3Uc8SuVZC2Cwoaff6YdK8wJhGYJ	9771	13793	13793	1618421940000	canonical
19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	19386	3NLNQU4gnqAdLAHqwLTefwtQA4p3vLzE2ZSxkGhgcQj4fTcaWfv6	1601	1388	339	6301	12463	jxFt6htH2oPBRXLNDqobAm3SaUQ8vXWabt3iRTJj22xBXGQo53K	9772	13797	13797	1618422660000	canonical
19390	3NLutSBoBQRcL6n8ibhrKa3nMigx9oPXc1nJhdKmTasRvJxx8fFH	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1579	1023	339	6301	12463	jwtTkbUzgKEQFLB2nCY3yaUFRiaeQXsPMGTbYanm7Y4HNMYkCsF	9773	13798	13798	1618422840000	orphaned
19396	3NLr9LHHedEaAsy9S4yy68uvAjkaziBc3He8CJJayqG3ydYG5vC3	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	733	640	339	6301	12463	jxG78K6XhYjftwKuXWFb7hWFX42YKiN3GSm9bcEcgp1VkNBSDjh	9776	13801	13801	1618423380000	canonical
19399	3NKntsFpWm6aejGuKBFquvMdYmbtkN2kunRDCMgBYHJKV7jbgzYt	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	43	1064	339	6301	12463	jwdgsxtRrXibTCG9boEYkKhhc8HVixAtZrQ6ncKveiM5piBuwrE	9776	13801	13801	1618423380000	orphaned
19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	19396	3NLr9LHHedEaAsy9S4yy68uvAjkaziBc3He8CJJayqG3ydYG5vC3	641	1336	339	6301	12463	jwbbUfRDxKMoJFGmj5zSf3zVYkvCuxXb2y6MywZqtrpiqLhPH7W	9777	13802	13802	1618423560000	canonical
19402	3NLttuDsdHP6w4rYVhsnT9EZyqPi3uVT3ZtzXsEKS8aboyv89H9L	19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	532	1057	339	6301	12463	jwr1MNTdXY94GPj5oxp9DPjgTAJADaihrMH2sw8ZjoZSqRAVRRa	9778	13803	13803	1618423740000	orphaned
21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	21876	3NKLWfmA4jQ8WUoepNNrdy3fqc7arerRg15XZqFHhc1XmUJ4fipv	1407	1395	401	12463	14040	jxDTGhcu16HdpjEEfAF1gigv8fAMiqPpmLZuCx35hxjev1hy7wq	10947	15414	15414	1618713720000	canonical
19322	3NLBNGnwqsaCzycCb7UJcTBopVZqZ45opqPKfafw4Da9TZxhytwH	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1613	1223	334	6301	12463	jwcdW4jtDUMuAzsKQ5kZTXrkdTq4u3HPTTVmse4hsbP4khwk2jX	9684	13754	13754	1618414920000	orphaned
19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	1407	1395	336	6301	12463	jxfYWjmCKN1QUWQCVs2csAjWaWkYjTAow9cDAEbaPuSpNbgdwUa	9726	13729	13729	1618410420000	canonical
19292	3NLD3cuVYpoKYwLHw4McJJi7hYZqsp5Bsc2pxg1t1xjnX3FZuPyH	19289	3NL4LdihD7ZUbijA74QDbssoHwTPm2QhKbL1SJwhT7T5UTcYbRdt	1643	1173	336	6301	12463	jx2b8cZ9WV8RMWeDexmeTmDfsCF2HHfLzdwstG3M1bY3B8rYJET	9726	13729	13729	1618410420000	orphaned
19295	3NL6wACyt6VBafggnHeyxAp1jQRqh5Ce4ye2Didq5BNwHJfCkhH5	19290	3NKqwMGYcsXEUBp1XcDajQ6LjguwpKiKp3RXsG1guHwfigLyC7Je	1444	1135	336	6301	12463	jwfPixQh3gFDHgU3tSqx3oJp8c1xVYMYgxnV6jYEevFbXgQmyfF	9727	13730	13730	1618410600000	orphaned
19297	3NLhvSbhrYC2VDe94TM429wBh1sr6bYDMw8uhrd1Eng57S4SQtA8	19296	3NLaZBbJRDsvFLi5zi99LSyLixNwG6YDDd9tefiwk4U7mW8bPkXk	684	1352	336	6301	12463	jwFtvCM9yKwi1Wsd7TiqwZPG5dhywNHxdoFVBjhKY23eLjZB4kJ	9729	13733	13733	1618411140000	orphaned
19299	3NKRBePvr5kH61SAfRYDgHnMBVF9NVWe1TH6PohvenX92KGqgaLv	19298	3NLFkB5dHo5bR2bVqzw25p6u9UT95u3H9UnX4TNNJtAEuzmLafdv	1571	1089	336	6301	12463	jwpD3Qru4w7DhF8TUYf8fQuheu3k4epyeKPpEJCVSQYyhHe7WH8	9730	13734	13734	1618411320000	canonical
19300	3NKbdoebH4EL3kZACkGUdFEXxz4VV7Z2R5Urymz2ufKLRDTcCwKU	19299	3NKRBePvr5kH61SAfRYDgHnMBVF9NVWe1TH6PohvenX92KGqgaLv	1542	938	336	6301	12463	jxSCFc7NKcPWTFHop4gVxTZca2BXx1RxbRjBwSZVzJAx6KNmkwQ	9731	13735	13735	1618411500000	canonical
19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	19301	3NK7NANAGnqofVdTudQZozM6c1gCmCAoCbqmmEzWUrPBDRXwumjd	1591	281	336	6301	12463	jxX3n7Yxb8EoJcnkhxnwGE4QjhWxo951dqe9fL2krh688PCtES7	9733	13737	13737	1618411860000	canonical
19307	3NLqz6tMRookmHkwqzee6ANpUWh3Qk3UoZE9nmSwcmVCLU8fpbCT	19305	3NKV36rDVFKsFy49YLUNShY8CDgJbekJwAGSuqbqAMdywvsYby6z	1477	1350	337	6301	12463	jwe7dgT1qAkx8ugx6bDchbikR5LiphXHcrG3SCLDVxz2WTeC8rP	9735	13742	13742	1618412760000	canonical
19308	3NKKZdXc3GZo2Nxc8tzqTvSTUqXAzmJM6X7MSmpgZcsQnbckZ4TN	19305	3NKV36rDVFKsFy49YLUNShY8CDgJbekJwAGSuqbqAMdywvsYby6z	1553	776	337	6301	12463	jx9TnZ4RByTDaVxPLDGmDbYDx8TJGk2CSQ1Em8qHAiSzWhARVGy	9735	13742	13742	1618412760000	orphaned
19312	3NL7TFCWXg8jMLt1VUdvSrHkxs1KTNWnEiGvtb1LULqSqzCrL9vL	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1523	1195	337	6301	12463	jxCvMRD6JJEJCTxbfomNw6srbLtg516d5RCK3FeBR3YhYt1kVbY	9739	13746	13746	1618413480000	canonical
19317	3NK7atu2cmJcfYJ4fnnDSAg92YLdFPPUPBzLFSyWfAtnUp4q6fzo	19316	3NL1TqpAYHBs5detqy8UApPXsCcEoEV5wmfrpx7oeA5G75qPJFjG	1542	1304	337	6301	12463	jxLhK1XL5QNde1q1GfpE3PYiDuDmsiQQwLyPb37RiyVtGQzGRZm	9741	13749	13749	1618414020000	canonical
19319	3NL8XabgX48W3jQ8fToK1JULbqLiCy3Tgq1ZRKwMG2VxZLCXsmyr	19317	3NK7atu2cmJcfYJ4fnnDSAg92YLdFPPUPBzLFSyWfAtnUp4q6fzo	1422	1337	337	6301	12463	jxG6Lf6KXkk8Bv13oHZJJ1uuEw29vmEzVq5a53AipEcPTQ4KkRj	9742	13750	13750	1618414200000	canonical
19325	3NLZ7Y6gkg8ubWGpLK8KFLrBDh9zyd5RvSrNyYiXk8Bk6pkuVodr	19323	3NLhDtE5Dckp9Ng44LtPj6oyXfUfRgyLxCn6qD2o8dTzMA4pSUPS	1406	1393	337	6301	12463	jwBQRTrW7RH5vujCcFaLgi8ZTmWuoJDBBxXySeDcGSVLRT9W6XT	9745	13755	13755	1618415100000	orphaned
19332	3NKUFcxwiMrDXGDhQPAWbyMPUqxcZiSVdm8LA8TGY4SdudRhHw6D	19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	1422	1091	338	6301	12463	jxCA1KYfLLgoubjF3K78ABZdFHoGoRPHAbw1yAEv4xCCLcrqbz6	9748	13761	13761	1618416180000	canonical
19337	3NKjApZkaK4rtTJMeEFRwLjxoBmGnUiVW5VX7TVRZqnsGXxF3xpr	19335	3NKdTef9RsE8uCo1bmRq2FL6TVSMPvsRyaEiqVNWsYim1MLyby8Q	44	1325	338	6301	12463	jw7UkRwVNM9937gRAqJq4K87Ut3RXdezSrgyDFBa74d6YDkFYJd	9750	13765	13765	1618416900000	orphaned
19340	3NLVuAfDbNuofJQrgXmbSd742bZRXn2R7sADS6AZMcGKyYnqWKgs	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1451	1166	338	6301	12463	jwun2wz8Pe64CwXQWvBNC9w3aRhApKEjs53D1EcTdXMvhPHqbEH	9752	13768	13768	1618417440000	orphaned
19342	3NKEkNvWPF9qideoCEWtPCMDJF778yBBgCEUW8ewZdKGh8NxzFT7	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1637	816	338	6301	12463	jxmSHfFxaFk7tJZNG4NoBdKDJpAwyN2xRoHouaooLeWkU5vyoYM	9752	13768	13768	1618417440000	orphaned
19344	3NKUsWYupqtHc5BV3ymCgCdrb7gSeFwnPim7bpSAJxkQhs7GTrnF	19341	3NKkqFHpQWfua88LSDD25hDvSp9sft8WvaTL3VWDHLoDsShp9xxS	1402	34	338	6301	12463	jxWp7MM3GnGXFfD3qUTEuhJon9UNKJkXkxe6fWBTaFueivB4bS7	9753	13769	13769	1618417620000	canonical
19347	3NL86a8F675it9Sy9NR4ifktu8TncQRY3ZQEvSSPpB6zN1DCidKJ	19345	3NKmjbQRDQzvhS55YP7jCtq27BhpLSvQLnoPF7XoodcFjNGJBTs3	44	1325	338	6301	12463	jwDaddFCNvXi5r7pQ6vfZUTErdGRZ8QroSHbZkjbwCkTZ4bKYE7	9755	13771	13771	1618417980000	orphaned
19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	19346	3NLtyBBSfgkh1wZxZJk7EifZ6e1ru6fP1ehK3vUMveqgT7E5ET6K	1405	867	338	6301	12463	jwyhSUZrGmMeb6ihB9Zc4ZwNZd25FUN4YMdmfpMuq17rMQ9Ry8Y	9756	13772	13772	1618418160000	canonical
19357	3NKPhxDwsmmtfuijCDxiNsZxQn3aspxTUfbHF58Z5aaSD47iXMvt	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	58	149	338	6301	12463	jwmLCQs1YrEw53D6QGz3tdyoENBgR3vyQN2EVSkjPSwQkbDsJp5	9759	13779	13779	1618419420000	orphaned
19360	3NL3WHif9VBm29k3rqAK5WVVVb2BuUMZVngzHe4Gxfp8GA4jFYiL	19355	3NKQVDZcP6hci2sL111qSTGhpuMutmktDu14ho7ozLYbGtiLq5cv	1673	1002	338	6301	12463	jxGRxiJTgVUAzknP6cJEFzzz3vx8uTP3FRYf7UEVhcLgH2ZAz29	9760	13780	13780	1618419600000	canonical
19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	19362	3NLuGbNycTzW1GFLF97ipR2nd99hr11cEAmY3zUhtaDYHViDSSuH	1460	1324	338	6301	12463	jxosoWszzBnHZtMjDf3EwpaNuBrH1ZRpJq8iM2st5FmoGo7KthU	9762	13783	13783	1618420140000	canonical
19370	3NLGtQN7jG8pzgCcbtKcset9xT5E7eeaDGYUfzanq4sxoazfFEt1	19369	3NL84FSyvunb3Hxp7Xog9ksxiqcss3oq7WZwfphAhrCwhycfyPk4	532	937	339	6301	12463	jxtgHz3FHPTroxnBMXDnEfSgov3sqF3As2yQc4TTkvuHjRYjrLf	9766	13788	13788	1618421040000	canonical
19373	3NLgmsFmbFoJa94hLjjM5gQEifQ4eHkvwDUPPjVpAQpJ6suzkMHe	19370	3NLGtQN7jG8pzgCcbtKcset9xT5E7eeaDGYUfzanq4sxoazfFEt1	1406	1393	339	6301	12463	jxh7U6w3hPuNjqfxBtJCTTVP9EwX4PspgundpenWXUb3Yn9rAoy	9767	13789	13789	1618421220000	orphaned
19378	3NK52ypJvMEhJmn3E8h3qDUN7vB7TKcENW6UgCqEC84QmhGEB1TP	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	1611	1215	339	6301	12463	jwEWpYV69RiubmuyxhoKK33oRxiQ9yQsbUqxv2hok85DMaaPQDL	9768	13790	13790	1618421400000	canonical
19375	3NKN4G2UcwiU2knCgVtczkCmJjbTxQCM17hCf2q7KrSCUPx2a1qa	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	1489	1380	339	6301	12463	jwS7yYiMqg4TRZ78Ge2KqVsTnyBXR8uCFRMZBxJUEuh3hnTDPwv	9768	13790	13790	1618421400000	orphaned
19382	3NKxsnoPEoTMStYX8DkJRmGS6qGi9z5XHSaVQmL6CB9wrnS74ko5	19377	3NKRDmS1QbAYJNXwg6hXRzFwEbLKk4CHj94SJ3K2mgJfLWkHQu3E	1646	1108	339	6301	12463	jwD7fc8pxmjGfjeqDWDKjQd1N351Ktze39ttUN7y3Zv4hNBQ4n6	9769	13791	13791	1618421580000	orphaned
21912	3NK9eZEM62HH5rMFXQZf2AWFNQ3FWs13GUQXEU9nHtdbKs9BjYVB	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	596	1306	401	12463	14070	jwDbBXFjLpVQYPL3z2pAF6rVv7nAgafbJNZ4i1KH7mRCst9Zh7X	10955	15435	15435	1618717500000	orphaned
19401	3NKN974iFpuQiwRQuX7LbnRDaP2DR8kv5QjQs8ma26wUtkGxfkq9	19379	3NLwa4ugD7TKDGAu3afQxyHmiL9qyNHSrKkn3GFBz7WKZfDKJnpu	641	1336	332	6301	12463	jxquJFN2ah9qpZAkhMrsPn8SQnnGQ7iFE5o8vVrpG1e9EEVGcPK	9658	13802	13802	1618423560000	orphaned
19310	3NKgcMAJSQFBv8JqK9cgvLZ7zdAtF5vf1nWrdUNw1ppeLdr5KAas	19309	3NKFfWRgEnZiFqFSKu4RMG7BAvCnezF1rLkcgp6WgBBuJ8mxUdsV	1637	816	337	6301	12463	jxmpk96M7dBMHPwmQqEoVxhV5GniATwRQBrMBcaxirQ6Bgpy1ex	9737	13744	13744	1618413120000	canonical
19313	3NK6vjjfZijhbduguTSnnBeEPxEto8Yu9p1ZegSAfWWZr1DWE4Tn	19311	3NLAT5pKR26jTJWB2DN5yH7GdY29SaywQR2kdYXr4Hphn3QFctze	1523	1195	337	6301	12463	jwDgbEDpibk1qzjALx31289vR3mLudyQ3V6CEGQfWxKPVFy5KcZ	9739	13746	13746	1618413480000	orphaned
19318	3NLuUayaAGGaVsjWCxjBcK72oYzgRUeSzbvZ2gA66t8xUiq6r5PP	19316	3NL1TqpAYHBs5detqy8UApPXsCcEoEV5wmfrpx7oeA5G75qPJFjG	1455	1332	337	6301	12463	jwi8ZotZ1YJyYvTGEUHEYbsps64Ju4wrt6Ue4LjZdhGMRw5zj35	9741	13749	13749	1618414020000	orphaned
19320	3NKw3poNVAj8WwdvTaSMUHSVaidfqHgdJD4gWCiqNu4SujdKnv9z	19319	3NL8XabgX48W3jQ8fToK1JULbqLiCy3Tgq1ZRKwMG2VxZLCXsmyr	641	1336	337	6301	12463	jwTzuGNvMQXJrqhwTFbjuENUFbkFmYC3tCmy14V1MQrzuzuJt27	9743	13751	13751	1618414380000	canonical
19323	3NLhDtE5Dckp9Ng44LtPj6oyXfUfRgyLxCn6qD2o8dTzMA4pSUPS	19320	3NKw3poNVAj8WwdvTaSMUHSVaidfqHgdJD4gWCiqNu4SujdKnv9z	1613	1223	337	6301	12463	jwCuQXGKmzkk7LVfrpcfcPMMkE94eZuF2gKqUJRFzZCeFdhfce7	9744	13754	13754	1618414920000	canonical
19328	3NKbehX9d86o7PoGf2ZkzWHvMCKbaZgj1fb6FfKLVs4shv3oDNVq	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	1406	1393	337	6301	12463	jwuerkXWTP2Qv4Q9yb85YpwfB53irNPvWRcGoi8BSEXwTpHKo88	9746	13758	13758	1618415640000	canonical
19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	19328	3NKbehX9d86o7PoGf2ZkzWHvMCKbaZgj1fb6FfKLVs4shv3oDNVq	1498	417	337	6301	12463	jwxcYnHSP1Dbf73FgFqzkdExRuiTmPHrYm4ocByaGSophJYpjSX	9747	13760	13760	1618416000000	canonical
19335	3NKdTef9RsE8uCo1bmRq2FL6TVSMPvsRyaEiqVNWsYim1MLyby8Q	19332	3NKUFcxwiMrDXGDhQPAWbyMPUqxcZiSVdm8LA8TGY4SdudRhHw6D	1631	794	338	6301	12463	jxhm55rYUGhiibVqD1jUnrsf9hqocDkGTq1JkCkHtzU8HFdhNsz	9749	13764	13764	1618416720000	canonical
19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	19336	3NKTZL3UT9krQpEwCSDu3KpeJcxiYS7AtTc4SXj9caKs3tDkyfgA	1599	1287	338	6301	12463	jwB1VxKyhQyxGJ5cQ9LGiK1imsdBJX2Sw7ieMY5gmfdQMTUN5zU	9751	13766	13766	1618417080000	canonical
19348	3NLwFgXvCKFZ4cFmt5kRdkAqSHAceQrW4cPpPybr14xbdNhK8ihB	19336	3NKTZL3UT9krQpEwCSDu3KpeJcxiYS7AtTc4SXj9caKs3tDkyfgA	641	970	338	6301	12463	jwFPu5EhWo5b9JwjbbupcxBUY9hLVtzg4X6LVaWyWx3zcpk67R1	9751	13771	13771	1618417980000	orphaned
19341	3NKkqFHpQWfua88LSDD25hDvSp9sft8WvaTL3VWDHLoDsShp9xxS	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	484	953	338	6301	12463	jwtGLcQQ66cRL5nat9W6JoR8WrNFS4BWFWytRCAnLLX9uBQ8CSw	9752	13768	13768	1618417440000	canonical
19343	3NKGs8z822P7AzL6EPqxgoDyys7jcESfHPmXDW5zYpUyXMnKNHDV	19338	3NLmjJY1ToE3C1b3hgnViRtUpnMf3byN8YeLWYezsJhWRijoeEus	1406	1393	338	6301	12463	jxtXkHNDYQMFDRmXc2UnN3xXGrRnjvmikcMjUsCAACyuu9af6DN	9752	13768	13768	1618417440000	orphaned
19345	3NKmjbQRDQzvhS55YP7jCtq27BhpLSvQLnoPF7XoodcFjNGJBTs3	19344	3NKUsWYupqtHc5BV3ymCgCdrb7gSeFwnPim7bpSAJxkQhs7GTrnF	1406	1393	338	6301	12463	jxxwQJ9k1KsaFbnh9Padxg9FuDWe9vjXcq5EXmrNJ1zT3cEvRKV	9754	13770	13770	1618417800000	canonical
19351	3NLsJu4TJgd5najxjWGh78gBc4Twe9WH3ABiJ7sgctCgiR8Rvmrq	19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	1406	1393	338	6301	12463	jwpehynqubaW2xM6iDGiJN7moiWatsP1EKF6KCysfsgRhWfEiL2	9757	13773	13773	1618418340000	orphaned
19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	19353	3NKRL52XDxc95QcUsyK4HtgYrZf4jZProUd3Q4Ax3uaQ4CdCWZv4	1403	782	338	6301	12463	jxrTW8Ui4DDdCpERgAduF5AScQ2w8rs66FMJTxXCiL9vDMBAYuN	9758	13776	13776	1618418880000	canonical
19358	3NLkTW7XCtdUSznRn3mx8psQnP7KF6pZ9iWrnndk2fWhdBWgFU5z	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	448	1305	338	6301	12463	jwwd1jPDFYcc6LwvhesTBT4Tfg5hrwU8Xpi7Tf9cYeNLeALgZ5R	9759	13779	13779	1618419420000	orphaned
19361	3NKyWHMU7e8mETW7YeuyKwF2VsrUZaqn8y7BJXapJDciMBFaa16q	19360	3NL3WHif9VBm29k3rqAK5WVVVb2BuUMZVngzHe4Gxfp8GA4jFYiL	1407	1395	338	6301	12463	jwNyX6sb2jAhMdyKuBkNfexXzkG21nUSVhxzQfe5X4ucoY4YtG6	9761	13781	13781	1618419780000	orphaned
19366	3NKtxjhKMu5jbjpvKDb3EMPPtRWXd28AkmUGsdAaEzZ4vR3QqLou	19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	1406	1393	339	6301	12463	jxCvzdLGaGS1WEiKKaxbxgPQCviQHfuLBKMmpNmoro97RSs8uRa	9763	13784	13784	1618420320000	canonical
19368	3NKdr5xqbkDV9ZWWbEu29RMakYY3fDTZ8wQ9mN4BK6Soj48Y9Z47	19365	3NKvQ5jcpanzsPbSAS2tmz1QS52HwA12DMc21FYLL4XvPV7uLzkX	596	1060	339	6301	12463	jw7YA9w4nhKNtkbHJVZ5X7UtdNooFd3kLnGU4KrPKik3rQq5z78	9764	13786	13786	1618420680000	orphaned
19371	3NLgV5rbMbrKn8657Tbngukerca39sjipaDYDQjcgRCTeLDfbVR6	19369	3NL84FSyvunb3Hxp7Xog9ksxiqcss3oq7WZwfphAhrCwhycfyPk4	1402	882	339	6301	12463	jwCGKuuJB4aZVFGKVY4VS5pXMjBgVLCyKMJpjcMJGz9UmA9aKff	9766	13788	13788	1618421040000	orphaned
19376	3NLHMRw4FAX1GBbr1Y3YcEz7PmfKBSkhX4QKbRTkDQfmSSDrzBuY	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	1522	1322	339	6301	12463	jwqE7gBHmpvMZUJ7y6jAGW9D8fjdrTFQoRVaJAd7SRQHnXPw3DV	9768	13790	13790	1618421400000	orphaned
19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1637	816	339	6301	12463	jwsYspv1utWuYXDtFiuZhzFZNdHJztUQn6ZsxjsoLw89i5giB8L	9773	13798	13798	1618422840000	canonical
19388	3NKasnebhcRs9ryPPHCw9pKxWBX86kGDvamKQjNoESZek65uw9qU	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1455	1332	339	6301	12463	jwAAeo3KVdJy6gThC7XydVBnefojzK7k4Ptz4RqzJke4sFep91J	9773	13798	13798	1618422840000	orphaned
19393	3NLoVSygy2BwwEy3YZjr4ix6BK18EWhfVQBYiSo8Ypk2NYdZeLE7	19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	532	1057	339	6301	12463	jwuWDfiW3i2ugFeJpoCxHx9U5X2Bpkh27LBghRH4HVHM4rYAqnf	9774	13799	13799	1618423020000	orphaned
19398	3NKx9vXRPWsaL17iCxYRj67exQ98k5Ww41d5paMVd8hzRrmbqZXp	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	1637	816	339	6301	12463	jxMVkeWn8KgBseu9vfeR7guuMujAyofztTtSDqHPuAbZsmTdxqJ	9776	13801	13801	1618423380000	orphaned
19404	3NK7Z1rts51SKAYzqVPh1tGAG1vpTUtVj3t7mbmBYAA9zeaV2d1j	19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	1403	824	339	6301	12463	jxhVPsj8oG5YJ5gm5bdMzW9st5w2N4Sx3vUgtwQVzKPu9rwmfru	9778	13803	13803	1618423740000	orphaned
19405	3NLakZRua639s2kp3qevB9t6QY2tWzcsH92ZffzXYmGK4dqJSCuj	19403	3NLDFBRqENnzi8X6y1p3QkFaDTuzxr96nXsPkYJz4szJs9WindXj	1407	1395	339	6301	12463	jxN17eu8Y1hkaAi53ehS36qDG1yBRjqkxJuUoSfsYSx3fvpRxCy	9779	13804	13804	1618423920000	canonical
19422	3NL8nuH8uiMMLidZNyF3B65M2nEoKKnLQmSwPVP8nnJY6DXvbV7e	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	311	1061	340	6301	12463	jx75Du3EthS5uyJwXDL6YrN1euoDjv2BzrLZih5CJqHBzJNa8JQ	9788	13815	13815	1618425900000	orphaned
21893	3NL2T31shpcWYt2nn1DKTXiFp8eS6qKrshryK4Zz2GsYNxkH2Dzn	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1406	1393	401	12463	14053	jwHMhG9p9vwjBjTtKTJbLKQY3sdbWL8Upna7Vodhmuj9Y3STnJ7	10955	15424	15424	1618715520000	orphaned
19379	3NLwa4ugD7TKDGAu3afQxyHmiL9qyNHSrKkn3GFBz7WKZfDKJnpu	19349	3NKc4Z54nPipK9AXKvYM9mrGSV2Q7rd45drMu7rkrrswLvvo2RP9	641	970	332	6301	12463	jwS5fikKYfespTzVkXtckQCUWgFwW4dXGDfJ6e4HaU27c9w7Wm8	9657	13790	13790	1618421400000	orphaned
19355	3NKQVDZcP6hci2sL111qSTGhpuMutmktDu14ho7ozLYbGtiLq5cv	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	1444	1255	338	6301	12463	jwAYmMY2SKAGjfvMu7rQAuWX9bojKVdiQ4zCToWRQy47iSeEJDN	9759	13779	13779	1618419420000	canonical
19359	3NKmGsnthhPFvKvygEVydTSX74ykcGx7uAetneNfk6zrozW8WuxL	19354	3NLb6FPaz4fhXg1xVkrw5C8vg2E6KVUw179BvkZz8nzD7obYkkbi	606	1169	338	6301	12463	jwX8c32HWziPuM145phWkuFHJ6MvFYWbaNRkdFKnhZ411hVXhxL	9759	13779	13779	1618419420000	orphaned
19364	3NKbvMLUEYXEVjzcUfWCoASdK2S2RLRcTDDMnQrZ6TUGoR4kM47Y	19363	3NLWsAeTjxpYFmVYXGNRTFfGeZjo2hqWeeM9zSXKCgjwxgKm2Emf	1672	1285	338	6301	12463	jxh1tDPaxq8VfR7VNScComAhoZXRy5NRd6r9XazYhJuVkRyURXu	9763	13784	13784	1618420320000	orphaned
19369	3NL84FSyvunb3Hxp7Xog9ksxiqcss3oq7WZwfphAhrCwhycfyPk4	19367	3NKYAAFGQEAE8eHYvRaCdHwWod2uzcTaxjfQApjMKhkWrqvmA8gm	1504	113	339	6301	12463	jxVNzTEpmhr98TkFFLPjSpn4nNm42QyJ1WbxtwmjsJiNZr84mBU	9765	13787	13787	1618420860000	canonical
19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	19378	3NK52ypJvMEhJmn3E8h3qDUN7vB7TKcENW6UgCqEC84QmhGEB1TP	1646	1108	339	6301	12463	jwo11aNcVwuXV2Zw72XJKK5mmGEaQcz9LXsV3ysTZXAh4WaAYe3	9769	13791	13791	1618421580000	canonical
19383	3NLd7a5CtwAqny2YTHDddNn4CWyaYtDeDNLSiEeWWpgnzpo39J2W	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1503	1151	339	6301	12463	jwQWS9GcGxg5Twc3KhfbsfegREMnvC5AtcKxReCjm4zcFtrUkNX	9770	13792	13792	1618421760000	orphaned
19389	3NKNQkG3ETB45N1NXmKEWxnY7ivd6LuEbgypByV3cBw9HdwpmhpD	19387	3NLMMfiFJ1RqZmDzTrRDPPVGwzcLKwW9r7ta79TQHe5fDcgXJmE1	1403	786	339	6301	12463	jxnaiBzDvzE4GKLpaVf1dPxr5uDBTjMwAhTeeTNsKgs47zEiEw4	9773	13798	13798	1618422840000	orphaned
19392	3NKqkT8FR25ozJkAgMY7vTUbb3rMB4Pi5YQR9brsRoHPqxZSDanL	19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	1589	1040	339	6301	12463	jwQouzWDMcdgMvLvgmaZyTkVB281gxbDQ5SCTtRbm9vEf7ghHgi	9774	13799	13799	1618423020000	canonical
19394	3NLUzRdzFDN87pjBLJjjEFaZLHDShJR1HjzjWcGRCmLwCoLG5KVS	19391	3NLdAdNSuyguTYfGmsHF4ZfUfFrKtP6XHwUPE9aKbK87pVr2xPGJ	532	1057	339	6301	12463	jxKjrP8mxdfGQ2qwFZK6xJbXFdE9f6FZKdNtJcBuu1ZG7A2CrGA	9774	13799	13799	1618423020000	orphaned
19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	19392	3NKqkT8FR25ozJkAgMY7vTUbb3rMB4Pi5YQR9brsRoHPqxZSDanL	1402	874	339	6301	12463	jwxWm1LnNFpEkbwiTrqa2zDho7nuWLy3arMa51UTrL4YpzSZsBH	9775	13800	13800	1618423200000	canonical
19397	3NKXMLWNhWh7Bu8vGUd1Q8LGra3QhAmZQvCxzWK2KhRf4Cnnoj1o	19395	3NKrmtzBACinmhsuK7cN2a9GhQzQwCiQFghJPjbpAi9nPcQJNz3P	632	1136	339	6301	12463	jxntHJfmT1cmrb3VJdCMkG1dchgSGiUQWz7JhWk1sif57c2pnDa	9776	13801	13801	1618423380000	orphaned
19406	3NK9du8wpTWz9utfrXtEyPDNKNVnb9ZbBGzdMj4ibs9MANyQWJKK	19402	3NLttuDsdHP6w4rYVhsnT9EZyqPi3uVT3ZtzXsEKS8aboyv89H9L	1553	776	339	6301	12463	jw6t6hFvr3FxnAZAyV9aM62q9CaX7M8hvmqcJjXThYZxBPdcf16	9779	13804	13804	1618423920000	orphaned
19410	3NLF3HZzaSmcKaipQtq4Z7ZdE9dH6pMzQCyyNEQBoxbiWnTuEYXr	19407	3NLLPTQg4xNLeXXBGXd5wd4dig4EP8f74qcGzheJtqRBGjtkEnPf	1534	1191	339	6301	12463	jwjhtAsVXg6Jy7zcdU5v5JiPnLTUpwPJCY1EueLg381AxUgE27q	9781	13806	13806	1618424280000	orphaned
19413	3NKxmisep5wPcJytwjtDQ4mx8xUsrrVevYtSUBTJb8oUKZFFJzm8	19412	3NLnjNNgdwxBXjfuVZXDGSvKz2saLzxbXHr6SsGGUR53mht5Wfjj	1407	1395	340	6301	12463	jxZW3VgUBL9zj4HBevcqooqDtdUjySVv11AdovnKZLzN4Va2efu	9784	13810	13810	1618425000000	canonical
19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	19416	3NLCiWNAnRJ7hCTycQvGmZwznjCHVAXjiPBBJNYxYFE8C6iaav81	1406	1393	340	6301	12463	jxspAiBGEAgMDTRXSKGeL2KWGsSgkXvBqrGugyaAp9SycWzSjpK	9787	13813	13813	1618425540000	canonical
19423	3NLai8jajeNhaWSHJiXxiNxcvEPSa1ujPBmXbNisnnMGFruhsJHT	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	1637	816	340	6301	12463	jwwkn9ByZmh8ZYw6eWNkB3RequSMQqordoEUvDsY8JGC7hkyXsm	9788	13815	13815	1618425900000	orphaned
19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	19421	3NL24NZaCYxQSDx2BUfsBhePoW7hVwPae5Geavk9Xsw2MqH2b8Su	58	1281	340	6301	12463	jxfmGZZunS3s2Teeprbh5ax1pJAS8ZasU8BMSgQ7r1vJ66d5pkt	9789	13817	13817	1618426260000	canonical
19429	3NL5bwSZUFGzWk6B7LSLAS1HHPWubgauWiA7qoez2DMF2SYjoFdy	19427	3NK8hiSMuhgbgYx1k1ywid5qYpdc4e7B7p5Fe3aSGTk8ZwFbzWdJ	1407	1395	340	6301	12463	jxjWFBtJ1oSNWaBbEsjmoRo2GkFqboVV5JK86TATpB8yrD398P3	9792	13820	13820	1618426800000	canonical
19432	3NLUu69konEJBhdjrhwuk119sJzjKEYeZFbFEKJq3efumujHFEz2	19430	3NLwyWJJrPHDjGrXSeqYNGHSCoS6s1FRZ1Q532Jrn6sUoFq8kURg	1406	1393	340	6301	12463	jwAvpNxQt58HavKJYhVywo5gZqGzhjb5czQRJk5HmurXxz58RXm	9794	13823	13823	1618427340000	orphaned
19435	3NKSVFHvYf49NkdcRXbp4V2cirrTdaxqQzukm8twQc6dgEJXsvrd	19431	3NKG23cBiJimvHZ6K3NDcyHX66HtcNPU6NfGaM625s6CNbTBv6VE	1555	1347	340	6301	12463	jwH8rtCe1T9YFFmdaCNbfkAoD5nfYp5jchQdaXVCLGXQwK7wH1g	9795	13825	13825	1618427700000	orphaned
19436	3NLSmjYi4aNhW6KMrobzkJvfyTMN2mn692E3gzAjjyPmUr7B2s6m	19433	3NLDm3mV1VSfvEyPi9opghANcreVcgQJe5883DS2f6dzN8MBb1Lj	1407	1395	340	6301	12463	jwcv2zAcFDVVsZm6zrvw5fyYoQf1fkEpLC51V5APMYovYJqcioT	9796	13826	13826	1618427880000	canonical
19440	3NKbGsxogPCDp8ZjhTwWQttUpfJ2EW54Rhdjcq8gpavcawxBCiUA	19436	3NLSmjYi4aNhW6KMrobzkJvfyTMN2mn692E3gzAjjyPmUr7B2s6m	1419	814	340	6301	12463	jwLnSy4ER5EPKwQ8e49icVPezPifj5UdLssJZ9dQ7mHkL8SKLnr	9797	13831	13831	1618428780000	canonical
19442	3NLb9puV755qXJqWvBfzzduQb97WjFZKRiZKnKRbJTFWk5irN1Db	19441	3NKK9YVPDnQRdm7tkZU66mKrvACGZjBS8RhjUWZJpJTtY7CnCbtd	1407	1395	340	6301	12463	jx721VvFvNrKLA7SDMjGucvAbw6GTxM6y4Jvo7nFCabWg12N7C9	9799	13833	13833	1618429140000	canonical
19445	3NKZHSZBCuQZf8sdSGojfbHdXSbvsVjqojqMi8fvAXkXLNWn6jYf	19443	3NL4a2TyaMWNsLDWVt9yBBp41Br63efiNZv7bruBK1Gw6CyQD2PZ	563	1359	340	6301	12463	jwwUfoasuXTf8Xv4VXARGbp8jjcUGcP3Hiria5VKgCCUptN5nVy	9801	13835	13835	1618429500000	orphaned
19447	3NLqBbxMLawF7gi6dayGUTUAVwqWLWgChxJZufBFxv3E97PH8YYx	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1672	1285	341	6301	12463	jxqLk8YZZXDWUMXgjEDpeLw37T8J2FYcSpVSTDyvhU12gfuARPa	9802	13836	13836	1618429680000	orphaned
19459	3NLbSRYu9yWVvtxxWpps7UZrsuYsiWKCwkirxR6MVVZRsgWYxxiM	19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	1402	852	341	6301	12463	jxGjXmWYZZbrzeiYyeBE77C3npFkRiFzj6ycnzRASGJuRg79q6U	9809	13846	13846	1618431480000	orphaned
19466	3NLGuZnh18g6pBfH8Sgpj5gWxjXdPxPtqsLfuRM8UrudyfUz4ipX	19464	3NKmeWqjhbUhyrq1QCMNpAzLTibZkocGzHYAo9ZB6Mn3W6tqgCag	1439	1153	341	6301	12463	jwzTrQMYMPztN8WY4RimwK8UPQ2yWz9zSGERkGBjDzbdfEXTVwk	9812	13849	13849	1618432020000	canonical
19469	3NKbeEwdQaLSw952KdM1t2Zg5J93DDUvYe6AtKuJ1B8B36TPUzJb	19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	1522	1322	341	6301	12463	jxbNC874ixhDip9pEn8h5Bg8PG2Eu3Dq6EAnwWSExrteZFmCLE3	9815	13854	13854	1618432920000	orphaned
21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	21913	3NLLNdGLXUMh1ZAH6r4nN5zWiLetUCaCykiBkrhCJzDHBnLbfXsz	1553	776	401	12463	14072	jxK6SKPeFCJ21g6BFHcuEK3eWzXYCQsxBrD4UrFnTyBb7Ex5119	10966	15437	15437	1618717860000	canonical
19403	3NLDFBRqENnzi8X6y1p3QkFaDTuzxr96nXsPkYJz4szJs9WindXj	19400	3NKkc5A2bXpFEkUXykYvV87nD4RLVptW4F9UbV9eWGdePK7eJcQY	532	1057	339	6301	12463	jx2nBzu1rZ1dhuhE7zUUcTn2xFKLwaSaXzRNoedGzfdyMQFCCnz	9778	13803	13803	1618423740000	canonical
19407	3NLLPTQg4xNLeXXBGXd5wd4dig4EP8f74qcGzheJtqRBGjtkEnPf	19405	3NLakZRua639s2kp3qevB9t6QY2tWzcsH92ZffzXYmGK4dqJSCuj	1457	1145	339	6301	12463	jwbmPpqwD33Zf1XNbzNPFD9C9kBvxyqXorrX9vn5Ycb4H5bADu7	9780	13805	13805	1618424100000	canonical
19409	3NLxGth7KbHLpFnDxFYNsTymRsHGnC4Fit1drU1pugSKAhXFDK89	19407	3NLLPTQg4xNLeXXBGXd5wd4dig4EP8f74qcGzheJtqRBGjtkEnPf	1406	1393	339	6301	12463	jwcEsRd7Np2oMpkxWSY5Z9GR6pTLrMzWaLddDab9B5GQ71FkBRr	9781	13806	13806	1618424280000	canonical
19411	3NLRqUUFejTTfZAEYA6fAVeFP7cMv4L9QECExus9Sbqzj983fjXC	19409	3NLxGth7KbHLpFnDxFYNsTymRsHGnC4Fit1drU1pugSKAhXFDK89	1406	1393	339	6301	12463	jwb1Mn9gR4UFUvVEfciyTxrvdD7cHi5Ea1afk2GXdme2ESep2yQ	9782	13808	13808	1618424640000	canonical
19412	3NLnjNNgdwxBXjfuVZXDGSvKz2saLzxbXHr6SsGGUR53mht5Wfjj	19411	3NLRqUUFejTTfZAEYA6fAVeFP7cMv4L9QECExus9Sbqzj983fjXC	1500	1051	339	6301	12463	jxFYyFfH13Uzg4CnYDMFVGNSonEG8hnYX276PUVvahzH5SPmnxz	9783	13809	13809	1618424820000	canonical
19414	3NLohbJLeYvqfqCFuK8iBGemM9nWjyrpwaF2erYzqpR2ibHBk4GE	19413	3NKxmisep5wPcJytwjtDQ4mx8xUsrrVevYtSUBTJb8oUKZFFJzm8	1403	824	340	6301	12463	jx4CF9ZBH53qArXMQzxZUGikmXQE1aKLtsfjAQTrm8pg9RkRXqM	9785	13811	13811	1618425180000	canonical
19415	3NLTGL8apQ81vPatW69ZQywPRFhrk5PBobpVgPi2jKEbpDECA4J3	19413	3NKxmisep5wPcJytwjtDQ4mx8xUsrrVevYtSUBTJb8oUKZFFJzm8	576	989	340	6301	12463	jwjUtKGyN4dTugo8jtLWq9yVLj8Dxpe1Un9wHvxsTdk15oTSssG	9785	13811	13811	1618425180000	orphaned
19416	3NLCiWNAnRJ7hCTycQvGmZwznjCHVAXjiPBBJNYxYFE8C6iaav81	19414	3NLohbJLeYvqfqCFuK8iBGemM9nWjyrpwaF2erYzqpR2ibHBk4GE	1407	1395	340	6301	12463	jwxR6X322pwxMbBd4MS1yntw6aTUS5DH3oCGwxrYBKKJTRkZwMc	9786	13812	13812	1618425360000	canonical
19421	3NL24NZaCYxQSDx2BUfsBhePoW7hVwPae5Geavk9Xsw2MqH2b8Su	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	1656	1343	340	6301	12463	jxHA8NgSo6n4syQhtEjdodApTxjoyUmg47gvsroLBAxF5PqHevG	9788	13815	13815	1618425900000	canonical
19425	3NLTKDruGP8Tsud1h1TEnZDy7DMp1Rz2bhNW6wUox3Yh8yVBDL6S	19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	1402	1267	340	6301	12463	jwTSvHKRvkUY8FeC3iTAdouyhZ5GStuWBUHiejnmyyzKWsVMo7N	9790	13818	13818	1618426440000	orphaned
19430	3NLwyWJJrPHDjGrXSeqYNGHSCoS6s1FRZ1Q532Jrn6sUoFq8kURg	19429	3NL5bwSZUFGzWk6B7LSLAS1HHPWubgauWiA7qoez2DMF2SYjoFdy	1406	1393	340	6301	12463	jxXCfpArwzdgGTDJnXqopKJBph5bJgB6X21wkXQX4myqeUW3xpf	9793	13822	13822	1618427160000	canonical
19433	3NLDm3mV1VSfvEyPi9opghANcreVcgQJe5883DS2f6dzN8MBb1Lj	19431	3NKG23cBiJimvHZ6K3NDcyHX66HtcNPU6NfGaM625s6CNbTBv6VE	1522	1196	340	6301	12463	jwzcywLd61peNg7A28AFxPH8uwKFtnBAnrGEMWKaavWwdTYTXm9	9795	13825	13825	1618427700000	canonical
19443	3NL4a2TyaMWNsLDWVt9yBBp41Br63efiNZv7bruBK1Gw6CyQD2PZ	19442	3NLb9puV755qXJqWvBfzzduQb97WjFZKRiZKnKRbJTFWk5irN1Db	1406	1393	340	6301	12463	jwh4rPfrcn3jLzGG3fhRnjP3unaZkEWVW5mowGg5VzZrP1o7BWY	9800	13834	13834	1618429320000	canonical
19448	3NLxXsQn3cFW8K4CFk1umrWvREMAP2r8WVeFFMLgqxqxqsT3t5xu	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1490	1274	341	6301	12463	jxVcGdkJ2bjJUmbiupjZtQV9ho8heuzis8iNj1CRH2TMww2dttZ	9802	13836	13836	1618429680000	orphaned
19450	3NL75DTN6SMS3c3eiYAs1bE8pqC9BwYtc4RSMb298b3BqudWBKz6	19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	1422	1337	341	6301	12463	jxfpZT6UvFHtkZcEEnb6FvBmXS6C3qWH9d3DXWRqiJyywpNECKF	9803	13837	13837	1618429860000	orphaned
19455	3NLqU5g8H5XYULmc5w7LLjf6eEqbqX8nC7WmwBuZc8x9Coo5FNLQ	19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	1617	1162	341	6301	12463	jxvc9zjZNre2zGCMPsGbhPq7wf5rcASNmDvzrvFFZQMDaoMUKZy	9806	13841	13841	1618430580000	orphaned
19457	3NLsvvthi9K1RTDmCsp57WMiwVeQjwp8SHCmBKj9URpW1dbNWobH	19456	3NK9npDsxs7aRPGPrrvVW7KYvvEGRgt1iJhjsqzooFqszgMUSBET	1610	1068	341	6301	12463	jwBw5cP9qZTzqJWqADM5KxRqkSzo8U9hWhDu5ZTJCmFcFBnfLYP	9807	13842	13842	1618430760000	canonical
19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	19457	3NLsvvthi9K1RTDmCsp57WMiwVeQjwp8SHCmBKj9URpW1dbNWobH	1631	794	341	6301	12463	jxbuE9GaiUsivX8Vc9QoU1PmjcCbhTHy2G8QGpSP5eUP6Q5Fahw	9808	13845	13845	1618431300000	canonical
19460	3NL6R6wvcpwNkPfojURsaF7DjU6AFMGCejhg265REkGkoaqgZPPY	19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	1403	824	341	6301	12463	jwexFutQ9WrX8w3RSPbojG34iJcibZ3y5s31f255qymtcHz8N2a	9809	13846	13846	1618431480000	orphaned
19463	3NLs91D8fjFjhjtj2oHgvAT4jhYrVac9Vi4Sv9YtzC5mRPDomN3g	19461	3NKkxjvpWgVssiw6RaDYrk3WDraYrTUSTx99YhzTdXSfMq7HuLZe	1406	1393	341	6301	12463	jwiDKqKkoGy3nxfHGcR1nwT3pXbiQmWgff3BdmRLLAyWHDexunr	9810	13847	13847	1618431660000	orphaned
19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	19467	3NLBGbdM5KBbc1uEnbzVPqUVZBLspACJAGrHUKeqrtydDGgAV5C9	1403	824	341	6301	12463	jwBwnKkqEQDoJyw1c86rscmaYNhnAP2zmsR6hbwrT4dbQCARVsD	9814	13853	13853	1618432740000	canonical
19475	3NKaTxtBKT3cBhbQVaguQXUzkAwJY1qKW7QVF5mwpLkAwThQwQ1f	19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	1444	1135	341	6301	12463	jxBa13EX2zi8xvTsddhWwcefGwEJLZpczG5DRJ2MMJhUvcqXSPv	9819	13858	13858	1618433640000	orphaned
19480	3NLn1ijVaXUWPSeJYkLjBJjR3S6SXK2aMGp4Y4QV8GHj6w7iRaQo	19478	3NKk8y2Y2pxqV5aow75FxfHfbDjzha51h7DnPUhX9SoUz9cuhdDL	1403	824	342	6301	12463	jwkdcMEZ6aVvKNfTSSJi5MB1nhZZwKQ2Dn7XfAU6krL7WddVpE6	9821	13861	13861	1618434180000	orphaned
19483	3NKLgtGppipzxp1sBbyLttFX8GAKeiEUACycCvjVA3mrF47SLo1u	19479	3NLbNBaTFEXWgND2eZQtuFHriZj2ePMQhVeqwAUen9HY2EfJA5fR	1549	1362	342	6301	12463	jxZSf5abL3pZ6oD5Yv8dHjzVCGiuTUa4JYeswxiGJ25JEBJ3U4n	9821	13861	13861	1618434180000	orphaned
19484	3NKrgpgcdES8pF5YbTxsaNxWCPHu3eCPiF5VpxvYsV5WkMNzSFzQ	19481	3NLpuSBdo1W4poB9RTQdZA4YNQQXYURLH4v1nuTjMzonMfQPyJU5	1406	1393	342	6301	12463	jwxkKYetqFJcKQZREUo4yxcjaGJQ6mV5wMHjAxBheAqzNnr3fd6	9822	13862	13862	1618434360000	orphaned
19487	3NLxLP1p7W9DGGqQvsfPervNx6jUiLqANJ9Nmd5D8EMxXvHQiezF	19485	3NKAMgquBWBPyufVryVw11k5Rdcko7wSiDTrYkuQY8rrFdeSmBPX	1403	824	342	6301	12463	jwQZBVxMtTU6RJ4p6gDx7Vms5HdkSknAWZK4jr2SJk1xwyTfsAR	9823	13863	13863	1618434540000	orphaned
19489	3NLdMZGpfAhUu8D1tnczp6CaB13mN4P57kWj6tyJJTsKyMhM5pF4	19486	3NLBBCvS5EX244vav4ydAep9f9jxJWhi5xzmKJtp1CK4btqQwpAm	484	953	342	6301	12463	jwB2hn825ZsXwdXKnpGwE2hdJ1qbKbS8h5fnp7D5SSN2BBtWR6d	9824	13864	13864	1618434720000	orphaned
19491	3NLQK4eNVtEtzJWwFx71qjtBhDy5WEd4MfoyCsi1rjKi1ig6G11y	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1460	595	342	6301	12463	jxWWHJuK5oqWcDgCJ4zgkf5msdAmB4S1darqgGG2GrazhV1zc9T	9825	13865	13865	1618434900000	orphaned
19496	3NKTpwoVzHJzc78uzSgLdVCnwrWgHXWxqRX9XCPijDvbWPhLUgCm	19495	3NL5i1yRrAMW4gYdkG7iG74EupwYHrCwHhvCyGkbTLYKJfAxbLG9	1547	1252	342	6301	12463	jxmzDcLKJHKWpW5HGGc5zEwupdaoWoQF3ccxZyuv6umcqdb1pZU	9828	13870	13870	1618435800000	canonical
21921	3NLXsG6chCvohguQynzndpdgZYj8KfLqijHJsyskobmFQ99vLKzd	21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	311	1181	402	12463	14076	jxu41GLYMYzpYUBg4QCfAHRx5XTj7hcPJajDv36HP4KzfLZ78Jo	10969	15442	15442	1618718760000	orphaned
19434	3NK47K2cSTbNYRfNfuXbJyzcKPod7bSLBKtkkQBJtxqF6QsLSHB3	19173	3NK5qbvLHuDAa1HTzTFqaoN34awEZEoDa6Hm1n7bAwYom1oKNspr	1555	1347	333	6301	12463	jwYqKskPnk4DCMnRBkKiy2JyHqaufXT8hTZceHrxk8j2grjo9qo	9674	13825	13825	1618427700000	orphaned
19420	3NLBsU7bsEsEQAmFfh7yR1Cx2VZqmAmmPrY97Nb8Tk9NsmVYaK7u	19418	3NLDn4p48nEFwxqoXwkxsP6MFFxFM9XgnJbp9RvX1vvptDs2xx11	311	1061	340	6301	12463	jxi4nwydp3QMkNQq9ry7gtorZzHoEpqUGkCwA46E7RHK48mVewF	9788	13815	13815	1618425900000	orphaned
19426	3NLxv6k5y2xwMyQ5pfjtRBEbXJ8Xmhw77WpFrtXGKbmvKNBmec7C	19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	1581	778	340	6301	12463	jxgDHdSBgmrPaD4kyAS7k55GUadyK3wVJneLV8DtxM9yc6ASGRL	9790	13818	13818	1618426440000	canonical
19427	3NK8hiSMuhgbgYx1k1ywid5qYpdc4e7B7p5Fe3aSGTk8ZwFbzWdJ	19426	3NLxv6k5y2xwMyQ5pfjtRBEbXJ8Xmhw77WpFrtXGKbmvKNBmec7C	1671	1365	340	6301	12463	jxLq6GVVuB7tsY6UFLowyJZCnbVWv1aqvavgBcfGUmEJE9QE3S7	9791	13819	13819	1618426620000	canonical
19428	3NLpbZeLnYcDmMC7QsEjcGrWAsRnr1pfhcDSNurqe23m4zQ4TrL3	19427	3NK8hiSMuhgbgYx1k1ywid5qYpdc4e7B7p5Fe3aSGTk8ZwFbzWdJ	1619	1275	340	6301	12463	jxpRoUE9bKCg7NoccYJBJapqWqRT8XShvYimWsycurmjqiiD45G	9792	13820	13820	1618426800000	orphaned
19431	3NKG23cBiJimvHZ6K3NDcyHX66HtcNPU6NfGaM625s6CNbTBv6VE	19430	3NLwyWJJrPHDjGrXSeqYNGHSCoS6s1FRZ1Q532Jrn6sUoFq8kURg	1599	1287	340	6301	12463	jxGRB3n5iLSKjBm9Xhz8yuxJeL82HcnpRgErJX4R4D4VrMmpcif	9794	13823	13823	1618427340000	canonical
19437	3NKVQmeatzeLCLK6C9BHskqjE7LQwLLBWSrc7euHig3dzEENejDj	19433	3NLDm3mV1VSfvEyPi9opghANcreVcgQJe5883DS2f6dzN8MBb1Lj	1406	1393	340	6301	12463	jwF9TyungprF8NNw9SQpXtn3BjHZev1zmwqgiwLqMnY4gG7DQUK	9796	13826	13826	1618427880000	orphaned
19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	19453	3NLexGnr5EN6M3wkrNfoZYhJcm7dW4gXcsp957Pg6B584Sgpujgd	1627	1259	341	6301	12463	jxvrWK3npMur8gth9Wtyw8ciENd1PAdrrnZRhrjW9MMBrun3e6Y	9805	13840	13840	1618430400000	canonical
19462	3NKZAyb77ip32YfrSEkBKM4s2NBTgukAxpv13yVZekdkCeAwvjH6	19461	3NKkxjvpWgVssiw6RaDYrk3WDraYrTUSTx99YhzTdXSfMq7HuLZe	1407	1395	341	6301	12463	jwyYEQfCw3tzLWa3eaE3zg6AzC2cnhoMDipfEMb1NDdiVKGR3Sy	9810	13847	13847	1618431660000	canonical
19464	3NKmeWqjhbUhyrq1QCMNpAzLTibZkocGzHYAo9ZB6Mn3W6tqgCag	19462	3NKZAyb77ip32YfrSEkBKM4s2NBTgukAxpv13yVZekdkCeAwvjH6	1564	1338	341	6301	12463	jxWQUNnBsifjkvh7GxviWbJbuQWmdDbX7Rhz7Amwokw3DoV7DwK	9811	13848	13848	1618431840000	canonical
19467	3NLBGbdM5KBbc1uEnbzVPqUVZBLspACJAGrHUKeqrtydDGgAV5C9	19466	3NLGuZnh18g6pBfH8Sgpj5gWxjXdPxPtqsLfuRM8UrudyfUz4ipX	1617	1162	341	6301	12463	jxDiZ7fY2M6jB47XHGtSuSsuLY9w7E8BL2sLqZwMm2QxrchWNxG	9813	13852	13852	1618432560000	canonical
19470	3NLUrbieswXmAoHsqoYBK2soczUMMEbRyE9jKz2TgLBQ4FHntdQN	19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	1522	1322	341	6301	12463	jwupxRP4aNCpxms3mBSkfRhrXAgaZr9U81J9t449vo4oVmzRxWe	9815	13854	13854	1618432920000	orphaned
19472	3NLin9VgN4Xo4tRsfccnGhsH3H5hjbNNerZCkn7XebNMTuRWjVcQ	19471	3NKZu22pVT48X3iBVhESeoqtcmqRG2ZcMgcFUgfwmJedsJGAUpPC	1564	1338	341	6301	12463	jwH6ne52dLq2QCoQ2wCvywNN18gJn98cKXTta2Bputgrejhv7Gv	9816	13855	13855	1618433100000	canonical
19479	3NLbNBaTFEXWgND2eZQtuFHriZj2ePMQhVeqwAUen9HY2EfJA5fR	19476	3NKwFY9cVSH2FEaKwvdPP84p8jUgiwcBnTFHeCr25wpxkpiyyCWp	1581	778	341	6301	12463	jxyXrgzu5e2xSFdk22P69bEVCbFsbsDBZwsVbRay7EZkrEYY11T	9820	13860	13860	1618434000000	canonical
19482	3NKcRonfeLRf2LEcd5Mudt7JBrQ4bP5UiugojKEN7hoZQsqXhrs5	19478	3NKk8y2Y2pxqV5aow75FxfHfbDjzha51h7DnPUhX9SoUz9cuhdDL	1549	1362	342	6301	12463	jxfXWBTzBhU9pc6wo31tsN34RtbBDfkKqSutU9JdCYnAzBNRghj	9821	13861	13861	1618434180000	orphaned
19486	3NLBBCvS5EX244vav4ydAep9f9jxJWhi5xzmKJtp1CK4btqQwpAm	19485	3NKAMgquBWBPyufVryVw11k5Rdcko7wSiDTrYkuQY8rrFdeSmBPX	1406	1393	342	6301	12463	jxk8TasZh26SPUakqnNAx77NCF4jxFUw5rHVxXkqTsV7Misgbdz	9823	13863	13863	1618434540000	canonical
19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	19486	3NLBBCvS5EX244vav4ydAep9f9jxJWhi5xzmKJtp1CK4btqQwpAm	1668	1004	342	6301	12463	jwkq4hRRDaJbtEdLtjPd8tu83oJXadCW5XRgTGqC7j8r3DKktsq	9824	13864	13864	1618434720000	canonical
19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	19496	3NKTpwoVzHJzc78uzSgLdVCnwrWgHXWxqRX9XCPijDvbWPhLUgCm	1578	1170	342	6301	12463	jw6ziyxwFZyuayJCQMBwuBLt7fyWRfKmy7fv1oU1WWdCiPEf5FG	9829	13871	13871	1618435980000	canonical
19501	3NLtCXZRQroZxLJ61xRGyHr1YPvMSDRc2n8kyBvw8Zwi4icD9ZVf	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1523	1321	342	6301	12463	jxknJa4FkcaV3odqKYRANywvMMFH3NTSfhUfzRN3hR8a6DzVzEA	9830	13872	13872	1618436160000	orphaned
19505	3NKS4ytv7zisE49ab3WJASWMUimSXEd37HXcALZfcVmbA6BxNDJE	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1402	874	342	6301	12463	jxgFzcWQJs2hG4Ba7bwB7FEAkJpEc8w7pP9p6YZi8nwa2yhiqX4	9831	13874	13874	1618436520000	orphaned
19510	3NLj7jMR3uJSneW9rj8t66KRCu4tUEyztsCAYZUprV9yMY3wUupm	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1594	1326	342	6301	12463	jwJkffM9ZpPT9cU5xgvwFn8Rmf8gAX8LC5wunZKSHeibZPe8QTi	9832	13875	13875	1618436700000	orphaned
19521	3NKtMRkrcQtxsCXhm1Z7z3sQdBVpTVsCvsAqQPhyxH8SPGQtzuyc	19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	1547	1378	342	6301	12463	jxgaR51XBgkQay1t8K2V7h5bPWzTdnDcakY94vabnNf9w76CA4w	9835	13879	13879	1618437420000	orphaned
19522	3NKCHd1zRwBtZqhgbkaP5idsne5tC6Hv8UnX1UrcKvLoty3wUkot	19519	3NLrTn2HJa5bASG3DsxZYv66FP9CdTAMoj5hiqFua4KaHkDMdCqf	1402	850	342	6301	12463	jwr3dQmkgVVXhuLdGp5HAsNXGHTzQaRbjbhsYFv5gmysekFPuz1	9836	13880	13880	1618437600000	orphaned
19531	3NLK43HTzCYsUoCKMQmww93hwAabu1V3Pikqt4YXntBQhadn29fN	19530	3NKhBDT33Uy9dGrjs77kWADVRkJwgYxhRrxLPRPEcQbvmb9essdB	1642	1367	342	6301	12463	jxS3PVTsQZFLffWZkMFdRrFJEiMzfaw9HR1vubUyoHc4P25nB5k	9839	13883	13883	1618438140000	canonical
19534	3NKNe7kAnmUg1eN7uQc4YKYYwX5kzyE3FKT3UbXgAjou1GVy1jyA	19532	3NLkYH6PKDCMxGF3EBuq8ertDkCrJ2K4sgQVMSFiqV9mTBL9q3Ko	369	1066	342	6301	12463	jweMNidFAQFFmYDQWKsUypXbE63EHkEt1Xdgno3zqL953tL9pbC	9841	13886	13886	1618438680000	canonical
19536	3NKWFhkQzUJmNKXFPqLA1DsuWBtkJwKRHhFVh7p3fzM4Bd3bmUuS	19534	3NKNe7kAnmUg1eN7uQc4YKYYwX5kzyE3FKT3UbXgAjou1GVy1jyA	1546	1213	343	6301	12463	jxvgoL6GMvQFYREnyjvDNHdmDfpAKH9XxV9sVmbvkvW8WmW1zPu	9842	13887	13887	1618438860000	orphaned
19541	3NL8hnyJBkPK3bTLL2i1soDF9pavN2aor1QX1CKZ8VaKHMUoVEGj	19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	1406	1393	343	6301	12463	jwR7Hu25b6Qg5qUmNrTxBR6S7PUJcxVD8RE3BAmxbhjud9c5WUU	9843	13888	13888	1618439040000	orphaned
19543	3NKiY8iQPBjbmfZhZA5c2Z8kaq3gzWHfTZHMA6zFX83WKe84CZ8X	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	1672	1285	343	6301	12463	jx6Zeyv7UsDTNiNpigh9y8hJ2XgwEAksB7Cw1GFmPBTZxxJVNgo	9845	13892	13892	1618439760000	orphaned
19546	3NKp2ExVjX6MYzSHCUHMHDPK5vFNXxGRG37MyhH7HxWwbFK1Mgkm	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	171	1374	343	6301	12463	jxXwPnU7moZbbsnURRssV7HguC5PmgcmoDcAGMq35H4GvLmFQNC	9845	13892	13892	1618439760000	orphaned
21928	3NKyuZ2mvmyYkCnZKNmQLrieAT7azgv8kFrVm15YFzRUuGe76XkN	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1651	1055	402	12463	14084	jx6HEMGgQQiyYeJxzddDCYAehj3jZUB6XdaJiH7ncyczTKwXzSv	10972	15451	15451	1618720380000	orphaned
19441	3NKK9YVPDnQRdm7tkZU66mKrvACGZjBS8RhjUWZJpJTtY7CnCbtd	19440	3NKbGsxogPCDp8ZjhTwWQttUpfJ2EW54Rhdjcq8gpavcawxBCiUA	1509	954	340	6301	12463	jwLYisyGUCB6oByRBfsHfqH3KUrAvGJvdiYoWVcoMUgzvMvnh5a	9798	13832	13832	1618428960000	canonical
19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	19443	3NL4a2TyaMWNsLDWVt9yBBp41Br63efiNZv7bruBK1Gw6CyQD2PZ	1672	1285	340	6301	12463	jxa8rNEpLNMfqh7fv5a9LrJYxpHrb9a8CwHbWdqPfVw68cWYhhP	9801	13835	13835	1618429500000	canonical
19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1490	1274	340	6301	12463	jwpCPnnj4XX64KLjpDzg8p55Z3MLtR3apWvU4kyXoLk4iLTMBKq	9802	13836	13836	1618429680000	canonical
19451	3NKRgehzVevmU6jsGrCBZUAUB4KXrAyXK2wPr2n1xEPW5EDhMono	19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	1422	1337	341	6301	12463	jwQQ7z6Hpiz93jJDAjkG2YvYboLCUE1SsfKZ78nSCC1WRzbpEdW	9803	13837	13837	1618429860000	canonical
19453	3NLexGnr5EN6M3wkrNfoZYhJcm7dW4gXcsp957Pg6B584Sgpujgd	19451	3NKRgehzVevmU6jsGrCBZUAUB4KXrAyXK2wPr2n1xEPW5EDhMono	1406	1393	341	6301	12463	jwPhiLPqr8h8njUay1P1UQKodKBwKbHq7qjgiKzhQ5kJoyHkHkm	9804	13839	13839	1618430220000	canonical
19456	3NK9npDsxs7aRPGPrrvVW7KYvvEGRgt1iJhjsqzooFqszgMUSBET	19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	1406	1393	341	6301	12463	jxZk7h5cn8BVdsv2mwa3GnVyCBQbQUzwoeADeYiaN5p1EVG7VGg	9806	13841	13841	1618430580000	canonical
19461	3NKkxjvpWgVssiw6RaDYrk3WDraYrTUSTx99YhzTdXSfMq7HuLZe	19458	3NK7Jgzpe1DbZ5iXsFM54p56YPStTRS28qEKCtSNpr6L52PLSGFF	1651	1301	341	6301	12463	jxsxpbaFP3u1cmcLQjPLnWXtrnqRnLDspRwLKia8ZsKJZN9i1zb	9809	13846	13846	1618431480000	canonical
19465	3NKe5QAV9P4CaQ3kpFDZyDTUKpJhYyyx8zB9KBuacZJA5d8gbCeg	19462	3NKZAyb77ip32YfrSEkBKM4s2NBTgukAxpv13yVZekdkCeAwvjH6	1631	794	341	6301	12463	jwR93K1ddJKoEVrJ7dvZhvFkWA8R3dxv9CrmHLqcy31oBxQ1dDG	9811	13848	13848	1618431840000	orphaned
19473	3NKT95FX2PC4WamH1Du9yraqaC7mEzHL7nKcatwq2AkZb3QC1GQF	19472	3NLin9VgN4Xo4tRsfccnGhsH3H5hjbNNerZCkn7XebNMTuRWjVcQ	1547	1012	341	6301	12463	jx6zqpRS2gctMmX6MG35uwao2CR7xH3eYa6W8so1mQtXxDcjZv3	9817	13856	13856	1618433280000	canonical
19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	19473	3NKT95FX2PC4WamH1Du9yraqaC7mEzHL7nKcatwq2AkZb3QC1GQF	1489	1134	341	6301	12463	jxgAMgtM5WnCEv9f9Q29axj8Jt56Sxe6Lq56WyE3dBD3FhkmVnR	9818	13857	13857	1618433460000	canonical
19476	3NKwFY9cVSH2FEaKwvdPP84p8jUgiwcBnTFHeCr25wpxkpiyyCWp	19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	1444	1135	341	6301	12463	jx5Utk1ZcYXHodB1Nevew5DX5L622JxKV6x5nmcDJ9rm5yUFTYj	9819	13858	13858	1618433640000	canonical
19477	3NLBavwMnYR42pgsDPmLZJDr5Cm7zd9LmE3kCBnAG4sQV5AYySDS	19474	3NLWHSyZFKr45cTWaNLHNWqhhqpN2ChMYcrkHYoPfZWwBDFJE6q7	1406	1393	341	6301	12463	jxUxNTZHfV6LidEF1b4SniGuxypmikKijssXiM1NBbtKd6f19xd	9819	13858	13858	1618433640000	orphaned
19478	3NKk8y2Y2pxqV5aow75FxfHfbDjzha51h7DnPUhX9SoUz9cuhdDL	19476	3NKwFY9cVSH2FEaKwvdPP84p8jUgiwcBnTFHeCr25wpxkpiyyCWp	1419	814	341	6301	12463	jwPFyrpnL78PJpgEEaXzwfvhwbpoCh3i88WEJV45KxQnYPR2awN	9820	13860	13860	1618434000000	orphaned
19481	3NLpuSBdo1W4poB9RTQdZA4YNQQXYURLH4v1nuTjMzonMfQPyJU5	19479	3NLbNBaTFEXWgND2eZQtuFHriZj2ePMQhVeqwAUen9HY2EfJA5fR	1647	936	342	6301	12463	jxBC1kAbwX4U38QCvkiayyHviu7MwWbNvrq6rEkwC5EraPLtrXV	9821	13861	13861	1618434180000	canonical
19485	3NKAMgquBWBPyufVryVw11k5Rdcko7wSiDTrYkuQY8rrFdeSmBPX	19481	3NLpuSBdo1W4poB9RTQdZA4YNQQXYURLH4v1nuTjMzonMfQPyJU5	337	337	342	6301	12463	jwQH1ypmtsCz2KgH6j9H3vwM4zgQqmwAznUTs8hLrxcSH2AhfVy	9822	13862	13862	1618434360000	canonical
19492	3NL6qNivAHceQx2VGdm6fY8veBSx8B3AgnR4XfFj3CUDYiPKJrYD	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1481	790	342	6301	12463	jx9UEC9Szb9itspw7XcPPSzWuCsBUpU8K89pbt3Sia4fUn1NYiD	9825	13865	13865	1618434900000	canonical
19490	3NKXNEcTCrB6bN9buvvwHTEGUiXEaB2agy7fgEJzsLtSCPErrQ5G	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1460	595	342	6301	12463	jwRZBLwfeqnEyd66RYfBZhmrSmmhwJeDWFUvRExnWUiBxEUpWkv	9825	13865	13865	1618434900000	orphaned
19497	3NKUwNn9ZdPkYbfHsg8aW7WRUU2NT9toDg9b9bT9aZ7atRNZhULU	19495	3NL5i1yRrAMW4gYdkG7iG74EupwYHrCwHhvCyGkbTLYKJfAxbLG9	152	1204	342	6301	12463	jwCfFwjGLFBgb1CDbsRENe5Ke5jKPDo7qcYeAVbyUYf6iRBWzdo	9828	13870	13870	1618435800000	orphaned
19499	3NLufnompj13qsuRRtuYYekv8zCiGuuwb2C5755vvzsS8NjuJEqo	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1523	1321	342	6301	12463	jwkMbK8eos5i436pAiVGF36PkUPUf4oumAMhzEo6f2UCvVeRPCN	9830	13872	13872	1618436160000	orphaned
19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1637	816	342	6301	12463	jxXDXxjVefuS1ZYWYadjRXFqK11fjzFnsXGzxJ8dRgj6qn2Gvnb	9831	13874	13874	1618436520000	canonical
19508	3NKWXwgVL91KwDRb3hh6yS4Nw4bFJaGhh7bnT19FWEgF6VcXwXHC	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1422	1211	342	6301	12463	jxsRMFVJ1HQmxBvZxQzKFXFdjkwGd3coJC1M2goyZdhmk5pkCis	9832	13875	13875	1618436700000	orphaned
19514	3NL7yMVTNjJfzwXyNdNtLTanSP4kxwXL2PmggUzMNzjTyg8szNYU	19513	3NKHS1xLxwqrgvtgTM9MxN7GokiiARXEn5r6xwZ3kJdbGLwyqkoR	1402	850	342	6301	12463	jy1TzfwdyVi1wNVY1BV1RKp1gmB8MSzuS4fo3qCB5YjqkvUVFYU	9833	13876	13876	1618436880000	orphaned
19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	19515	3NLZS4941z8SkoWSGTKju489AmcuPcD1SzNiEQt5ZzwaJycAsz6c	1581	778	342	6301	12463	jx5WBiWL4fLmzN1qgUZgiTNkiPnfgHMST37L18FSDUuZk5QsqE1	9834	13878	13878	1618437240000	canonical
19519	3NLrTn2HJa5bASG3DsxZYv66FP9CdTAMoj5hiqFua4KaHkDMdCqf	19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	1445	1164	342	6301	12463	jw96hPz82PMBroCVCtPACz1RkkFNjKRMyzittrhNNgVfawzHP5m	9835	13879	13879	1618437420000	canonical
19526	3NKS8ka1tk1A5RXFZcWNZQ8PY1xk1hqhHA2ikHwUPLZHc6ukCcBg	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	1541	1298	342	6301	12463	jwU4Wgr4szRi9eJpUJhnmWko1RhqrQeeRBsEX8854qhXusYQRXZ	9837	13881	13881	1618437780000	orphaned
19528	3NK9dFZ57Mgan3S7viR5nBCmyDsSmBBQCpTW3brCWxAgz5jYGEFb	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1523	1075	342	6301	12463	jwjikqLuUgpXXxE6UN6b1NtXZv3jxPUNkBPXhJ2PsAihJRkpMfu	9838	13882	13882	1618437960000	orphaned
19535	3NKVKVqEuby3bK9hvatxJVozBXQTUsujrrvKRF2v2a8hrzWpaZwu	19530	3NKhBDT33Uy9dGrjs77kWADVRkJwgYxhRrxLPRPEcQbvmb9essdB	1546	1213	342	6301	12463	jw9LnHzyreQSp5UaeSFiuk1wUxr7aqNPRVmjvvAuM5o7VngVZRC	9839	13887	13887	1618438860000	orphaned
19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	19534	3NKNe7kAnmUg1eN7uQc4YKYYwX5kzyE3FKT3UbXgAjou1GVy1jyA	1406	1393	343	6301	12463	jx23PQJzj2Cb316dtY2bLYV5qHL5KYgG2wabHkBxmsQg6FyQ2tp	9842	13887	13887	1618438860000	canonical
19539	3NKF2h6tGT3VZbwipa5362aAN5yAqSPDj25AeaQh5ARzvSh6vZzN	19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	1672	1285	343	6301	12463	jxF6a6ua6zPEnKN5avfgK8j7GdtxcRJfshc4ZoFGkpeqBqrPkQZ	9843	13888	13888	1618439040000	canonical
21947	3NKQ6F7TozR7ewXSvU33AxSSyBEAiDPQe6EBEDyPpB7hNemTNMnS	21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	1637	816	402	12463	14099	jxJXA13ysugKQGgk9634rkMvMyWbAVPM73jxnhZ3ATJt6NN6jvw	10979	15460	15460	1618722000000	orphaned
19494	3NKjYsu8ofGEf7ydJhRnKyws2MWLzs5JAFj4ovPzAc5kYaqVd99q	19492	3NL6qNivAHceQx2VGdm6fY8veBSx8B3AgnR4XfFj3CUDYiPKJrYD	1579	291	342	6301	12463	jxaKSdainjEs7W5HiG7ZrEw135a4qZ4NGuyS45U9xWzsTwcZWkH	9826	13866	13866	1618435080000	canonical
19495	3NL5i1yRrAMW4gYdkG7iG74EupwYHrCwHhvCyGkbTLYKJfAxbLG9	19494	3NKjYsu8ofGEf7ydJhRnKyws2MWLzs5JAFj4ovPzAc5kYaqVd99q	1637	815	342	6301	12463	jxpHcX4513qnbpzUtE9Lbqxezk2XMncivsEbHznCRTkANeMkjBK	9827	13869	13869	1618435620000	canonical
19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1407	1395	342	6301	12463	jxYhyfSqEv6pzauomvbJ6WVfasytHeshbzCv8zbzXQESGtTFWmu	9830	13872	13872	1618436160000	canonical
19500	3NL9nQBZrAGgzmugq3z2Z9moHiNsuYjrk7C2ALPtpUFxm4tXAYWt	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1523	1321	342	6301	12463	jwtciUbGtdU5ovVNWjzgdb8nn119pQ7WEEF9sHF4s7os33e9y5y	9830	13872	13872	1618436160000	orphaned
19504	3NLQHHtkP81JV72PyvNzjgKMApSfhg5exbEDiWb2XcB9YmMfaZvz	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1509	1194	342	6301	12463	jxHT2QVwKgAo12xh3u8wnFViBJVBFcCyHejvngcdqfyqxFXK8Q1	9831	13874	13874	1618436520000	orphaned
19509	3NL9YzLFgijyXnQy1STNgLj8m9GTqZmv6GajjCNjhf29ryRgHDgH	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1610	1068	342	6301	12463	jwNtAj9JByK9dS7eE35nzyCXbWtyuMUcKK5jo2fQg7cj689Ak79	9832	13875	13875	1618436700000	canonical
19512	3NKizJvMEtVJu9HuokrRGoGdhcBU16z9fGb63mZwyYz8hmkteZVV	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	641	1090	342	6301	12463	jxtNAwscz32o9SgVHjvuPBPv4AonQsrckP7agASwBsR6FTJi4wE	9832	13875	13875	1618436700000	orphaned
19511	3NKdYGQZ7ietNdTSgV6hN9ZpiTBMRUv7Bt2WRfWRKPSawPRjpkL3	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	448	939	342	6301	12463	jwGXLwERjBj3ESbdXs6KbjibegMPJ6MKDMMXvtmYG953oztZoR7	9832	13875	13875	1618436700000	orphaned
19515	3NLZS4941z8SkoWSGTKju489AmcuPcD1SzNiEQt5ZzwaJycAsz6c	19509	3NL9YzLFgijyXnQy1STNgLj8m9GTqZmv6GajjCNjhf29ryRgHDgH	1403	812	342	6301	12463	jwASfBmR9Amy5YGBnni8xAwhRvebi9BmrazYefvs3sLmt4YaR7M	9833	13877	13877	1618437060000	canonical
19538	3NLrd3HrdaWTLXRiF3oKKL4LRZGkkye6Qtc9UrqrgPLByBijymC4	19514	3NL7yMVTNjJfzwXyNdNtLTanSP4kxwXL2PmggUzMNzjTyg8szNYU	1546	1213	342	6301	12463	jx2TRb6PXdn69RWyn9rHD3A1jpHmaLMbWVKDuzWEksLaxSCBZsN	9834	13887	13887	1618438860000	orphaned
19520	3NKGgAMggKs3Jv7c84WN7NADCr2yhyvHUcMtFHi5heC7u5UoSGso	19517	3NKXFytVpgSVJD7pcEGkNhF5csWUYKBAbhVj8TLc9a4KsBYkthwE	1406	1393	342	6301	12463	jxY7Cb22XiJDbuKj6KWJGPuPT6Uy9UoFPHdG1WViL5rkq4W22Do	9835	13879	13879	1618437420000	orphaned
19524	3NL6gstE1swLr68iaQ9XSHwJL1TTheXmrZqVQcA5AaCEi26FUUjk	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	1622	1356	342	6301	12463	jwLHTSKdjjkdQqZ3gqFaHCHwj6jJW6SwfsLT6Vk8C5MWgKAarNM	9837	13881	13881	1618437780000	orphaned
19529	3NLLch361hGkyoWkCz3Bhd6kGwkbVQAufi4v2hjKRpLPRVrVyyLq	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1523	1075	342	6301	12463	jxRNHcjbibjrNoucJpcVJ14jHZL7NEwgyxRffgf9Ydm7xeRrzkE	9838	13882	13882	1618437960000	orphaned
19533	3NKKTtP5db9M1Q9zqQX2YmAaw8hr9yFf2nrHB62YavUnccGSrwbT	19532	3NLkYH6PKDCMxGF3EBuq8ertDkCrJ2K4sgQVMSFiqV9mTBL9q3Ko	1634	1085	342	6301	12463	jxNhY2cu11gy7gQHwyG84i8sTTjTKy9WLtmgrNqNdQKrPTrjZk3	9841	13886	13886	1618438680000	orphaned
19540	3NKDFzngMfqKrzjhnhzRxNMUxR5dGwQwpMNvPy5pRahe1gGVWc9R	19537	3NL1KhNttPwcnPUqgoLMF3R2RKkcBkmCLkGj3nipAwUz9qcpV1Jd	1672	1285	343	6301	12463	jwkUhZc5q5KKu6xBzzmmXY4qFEUcZF7v5MhKXHZdqRHYRSqrtam	9843	13888	13888	1618439040000	orphaned
19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	19539	3NKF2h6tGT3VZbwipa5362aAN5yAqSPDj25AeaQh5ARzvSh6vZzN	1406	1393	343	6301	12463	jw9oBFVpXxKPjUs6xQP7CU6637LBWPGkaH1gGjEaZQtX2VShUH4	9844	13889	13889	1618439220000	canonical
19545	3NLGV7EmEVuGYdWo8rwopSiq9DWFnezMfn2XWPkjXY1HfCnMSnLd	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	1403	824	343	6301	12463	jwTTtaVhujtPsVoXhqfPkvNCEXHwRU44dNiEBwGUJm9z8kWnz6K	9845	13892	13892	1618439760000	canonical
19547	3NLsTzrWibkpG1mqdM7s5Q6Ny2MuHm9D31MCr8XgJSocA6A8uJmf	19545	3NLGV7EmEVuGYdWo8rwopSiq9DWFnezMfn2XWPkjXY1HfCnMSnLd	58	915	343	6301	12463	jwG4dSUjVBWQ3imiReVawmxU6TnBgRsdizqnf7johnUyxSMpsGr	9846	13893	13893	1618439940000	orphaned
19550	3NLw94pmBWRFkzwG9a4HZbZTxXVUsRUW1AuPqwxroWHhNmg5JDiS	19548	3NKAE4VXDysEnkCt2RB7exYfwTGLCtvuUGjUGTMuza8PVCWyLRX8	1447	979	343	6301	12463	jwqyvrY6CkcT1SoE6NAL9BdTs4Epe5E4ATf47ecSzx1cSRTaHU6	9847	13895	13895	1618440300000	canonical
19564	3NKTxgwT564wu2w9GC8hiANVTz8XojGL6AMotWGaDHq1jXwKwP89	19563	3NKTTRL2nvsVMKLmmbK9e1FGKMt8QoDsHgpD6WXiBvVFXyUEbgvb	1406	1393	343	6301	12463	jwUTczFNLTYa2CSgqX5cNvxYQXWtQi8EGHd3jCZq1cJt3goooT5	9855	13904	13904	1618441920000	canonical
19571	3NKkRL53zhno7776QPViEysu2j1hS79ZKS1xa7FuQ8J7qNYdGi7f	19570	3NKbRVMoVioc6Zq6GacrM7Zm1LtmFdexvYbqgpTkQ62MgQ2reMpX	1642	1121	343	6301	12463	jxQZJBbYnxSKcksZCidohD9bKUwvtnioHJSLcD7PtNRUWfY6ko2	9858	13907	13907	1618442460000	orphaned
19573	3NKMZnmEKnyjxVXuzPVy46n6XQZy6eGa4bsYvzKt6fLLSULuTRkJ	19569	3NK33RpRu9qEXVrfbh8d2LXdhXnSkGp9nTGv4jpA7FAqLzsp9tkV	1457	1391	343	6301	12463	jxMEAcaegt7UuvTEvGNDtYAHKtCKuwASkCbGtS4Mccstz1xUrL1	9858	13907	13907	1618442460000	orphaned
19575	3NLdoM9B55t1fTKvBh6cT1yarhuwcM2rvydsy7W23qdWmpyuM4Ki	19574	3NKQqpbvtgo1jVzwirtjXFw5wfeztrXsAJLuE7ZCba6SvEvEKgGY	1652	1315	343	6301	12463	jxt2KzWofG7sZcqa17zGUd3EX5jCh35mF9fzUBav1pK9E6QbGzN	9859	13908	13908	1618442640000	canonical
19578	3NK3KzbTy4Rtxn53SFNaJXTxw4uD6oeXUbSG7ajZxUHbiQn12mR4	19577	3NLKP69KXcqH4GxDmnpaGVxJ5cFexWfij2qaWtCWTeaYUBHzMFqp	1439	1153	343	6301	12463	jxESq4UjAWNYchbZEbEJrfefhE5Ygk7Pso8jt18tAQSUoVPE7ZD	9862	13912	13912	1618443360000	canonical
19583	3NKHoTBhXkkpAg71Y4DAm2wwfoPkQsgE5B1m89szTPrRacZcUaoF	19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	1627	1139	344	6301	12463	jwTJeGQytAvkPZ7k69cqCA6mMZCs4RiMsmPvxKPhq2G96bauxvm	9865	13915	13915	1618443900000	orphaned
19588	3NLSKgfjDDCehabSPpeLVqRtvL82DY1exSHPwkPjqZUxooJgbzmY	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	1406	1393	344	6301	12463	jxNHaAvtrivWpkq7PVeK8xEqx2fyN7fB7ab9qTTHWW5QSo7Fxkf	9866	13916	13916	1618444080000	orphaned
19592	3NKgjzDvzGt6MM5Dcc3sjn6EPd1WBg12dU4f7kivFG8TbmbXXD7d	19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	641	1090	344	6301	12463	jwWPhtdEKrPaC4rDQKA6pjZQUkSUDNLj2j2DSQJdo5VAHeMU8Ec	9867	13917	13917	1618444260000	orphaned
19594	3NK8c9Ni13V2dgmduWrmSgfpzxZC5BMaw7yidFREn53tDzsjFA9j	19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	1623	830	344	6301	12463	jwxg1LSr58Qq3LkQbVazoJmFKbcSQ6Gg5QGJHCsYfFzQSnT1cA7	9867	13917	13917	1618444260000	orphaned
19596	3NLeeHSbbC26K4qVcGDBTeAen2L2JmwsXDH7jq1QhVrnfucjgNrk	19595	3NKZcderv3iVE9odGxEz1ui3eahNXJ3F8eyx1B5V4SbXM8rDsFh9	1600	1006	344	6301	12463	jxbrF3gfgcD9k6sNC9AQMuQEeicVUGoQvq4Zw8cFpYaaGZ3firr	9869	13919	13919	1618444620000	canonical
21949	3NKiiY5wFjqxGjMz4gP55ZTLVDB9wU6QGP58gNi3eGo83UTabWvy	21945	3NLH5mXXceSrgsBrWJHfnicscZXLCRiBLgtTK2d4Svc1RzbbAAYK	1579	291	402	12463	14100	jwyMTHW2b31ikJxbWpfmQmCKaCNxKD2avBGiy4gCebxc26jK7rP	10980	15461	15461	1618722180000	canonical
19607	3NLe3JhDw4596Kmsy5BsXkvsmzWkMEeD4JDciZ9sPxmpyeY1L2bx	19386	3NLNQU4gnqAdLAHqwLTefwtQA4p3vLzE2ZSxkGhgcQj4fTcaWfv6	1556	578	339	6301	12463	jxNAz42WPn1Z3pkVoaqd9BYi2wZhP6V3cz7cvUk77SKwmXpptby	9772	13930	13930	1618446600000	orphaned
19557	3NLoZHPdTimCeaN1T7tkijvWV4mpAKh81vJ1B5oRrpYGhJdAHEzT	19538	3NLrd3HrdaWTLXRiF3oKKL4LRZGkkye6Qtc9UrqrgPLByBijymC4	1546	1093	342	6301	12463	jw8MhQqUafL1vTNXWMWW7gdpq6nZBkZWfq9vPCFoNqyACibqy1U	9835	13898	13898	1618440840000	orphaned
19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	19519	3NLrTn2HJa5bASG3DsxZYv66FP9CdTAMoj5hiqFua4KaHkDMdCqf	1406	1393	342	6301	12463	jxZepysqKYcWKaJgnVHtn8rUuvsJ99pHPf9Nacd1ykmiXULz3S6	9836	13880	13880	1618437600000	canonical
19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	1622	1356	342	6301	12463	jwA2ioDH1J2BXaavWPDPTKEdUWNuwfovacAPJjcVieJS37cKvCf	9837	13881	13881	1618437780000	canonical
19589	3NL2hLumxPjaayaopL9s5sm9mV85RTRFvZh8e1QNv2EM4sjbCaZE	19523	3NLtwd8NEcmHbCMyyKJA8Ez6RvgKmxzZK8Hu59X4TgiFCNvubd2K	532	1057	342	6301	12463	jwxwp79ZqVU39w16MADfpUCuwZxKDgmWXSaoypmtTB4BzXNQjZD	9837	13916	13916	1618444080000	orphaned
19530	3NKhBDT33Uy9dGrjs77kWADVRkJwgYxhRrxLPRPEcQbvmb9essdB	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1403	785	342	6301	12463	jwEbW98NPJuJGZXztT75wrRVfubwxrFbzn87DpfpFDfn9s9CfWG	9838	13882	13882	1618437960000	canonical
19527	3NK8b7HGQ8obpr4PSWpTc5oftfpeKrKHWwq8XDVcHv4UeEvAK9rk	19525	3NKNuhTa5GtaxKci9eoa17ZMXZBiMw3XFSrMxP14LgKQH7oYxyt4	1523	1075	342	6301	12463	jwL8k3SaTtNJ4Wj7STvVs1gv5uBGAXcsrLZcswQew4AuD2JEStV	9838	13882	13882	1618437960000	orphaned
19532	3NLkYH6PKDCMxGF3EBuq8ertDkCrJ2K4sgQVMSFiqV9mTBL9q3Ko	19531	3NLK43HTzCYsUoCKMQmww93hwAabu1V3Pikqt4YXntBQhadn29fN	1647	1302	342	6301	12463	jx7fQ2qpgALT1FNHYLNUHwxwpD2Ywt6944zN6VET6qgnX8cbANa	9840	13885	13885	1618438500000	canonical
19548	3NKAE4VXDysEnkCt2RB7exYfwTGLCtvuUGjUGTMuza8PVCWyLRX8	19545	3NLGV7EmEVuGYdWo8rwopSiq9DWFnezMfn2XWPkjXY1HfCnMSnLd	1553	776	343	6301	12463	jwTcd4KggaSZeYyYc26gWsuBhkYWYEARE6PE5q5LQuKbppS8ERD	9846	13893	13893	1618439940000	canonical
19549	3NKeCNPRqrAA1F2ueoiLhzJwQxp74mJZSmHgxN6dvFgdFJZwkaEg	19547	3NLsTzrWibkpG1mqdM7s5Q6Ny2MuHm9D31MCr8XgJSocA6A8uJmf	1447	979	343	6301	12463	jx9AB5frovGe97BXypPSnfuBjHnqrBBKVsCwSP1QGxH63P6zUQH	9847	13895	13895	1618440300000	orphaned
19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	19550	3NLw94pmBWRFkzwG9a4HZbZTxXVUsRUW1AuPqwxroWHhNmg5JDiS	1483	438	343	6301	12463	jxFeqi6P4NhnKt3SoxgrBr6tAeRQZLy2xP81ytiuUFyTn4yJDgA	9848	13897	13897	1618440660000	canonical
19553	3NLu8cChCqe6Hp8iRtE4Ymkt2cv2TDLLce5u6A6LvhXyS7gDaMvZ	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1546	1093	343	6301	12463	jwjJQxQNtqKZS1MoUc9QjxXXBwVHvoCHGEoWYggagmTTBgjB2R1	9849	13898	13898	1618440840000	canonical
19555	3NLwdWqdXg1tCx2onJi4sqmEKkUwVvrsQx8EWcnPT5cCKSTRMdT9	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1407	1395	343	6301	12463	jx8gMmy3XJ4KPzLUqhkS5ftnTcukmwojcmDNH4Ne5nGAcWv6RPE	9849	13898	13898	1618440840000	orphaned
19559	3NKQRJDPxPWDAdnsvpbqnm1zGmDK2Lo9bHazwXdVgGsgXPQw6Rww	19553	3NLu8cChCqe6Hp8iRtE4Ymkt2cv2TDLLce5u6A6LvhXyS7gDaMvZ	448	1305	343	6301	12463	jweKeyLPg9KZHt4r1ttqsySFjNUVH3GCLBqZWw4nsfc7vpMwrta	9850	13899	13899	1618441020000	orphaned
19562	3NKfUUYW5ws2dqXktT1khfh3hNrN5ExdpeHrAfzxkH7BVJPUWxVN	19561	3NL1qwrRD1jhgPYt1a1SfsZBZrpjbB5TjxX9Y4jFxV8wBLhzBALF	1631	794	343	6301	12463	jxPDEbP5rqixDCWe2FWruiS8tLMTpAQqPFrp7T8P7GJFn9ZVCUg	9853	13902	13902	1618441560000	canonical
19565	3NLQrVNXke66VqRpcWV8a1SbFBvo3JgbMfoUjvqywc7QoQscX2j2	19564	3NKTxgwT564wu2w9GC8hiANVTz8XojGL6AMotWGaDHq1jXwKwP89	1637	816	343	6301	12463	jwmCLr6K1YVdC2j3ywjNzVnwSGupziReE9AoeoJyQMHMGxAgiAy	9856	13905	13905	1618442100000	orphaned
19567	3NKuHN4ps1KDZqkJtdLcgENgM92vEGATK13pPUCWjQiwLD5aXBoR	19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	1627	1259	343	6301	12463	jxPvzBa7QVSRDUSFnHpuFDyub7P7VBXe1zt6unPY3BjjBEvEhKn	9857	13906	13906	1618442280000	orphaned
19570	3NKbRVMoVioc6Zq6GacrM7Zm1LtmFdexvYbqgpTkQ62MgQ2reMpX	19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	1451	1046	343	6301	12463	jwkNKXMbayLhVvn5uuHdBFkpk3CjU8Hc4VgkfENDy6nraApFTF7	9857	13906	13906	1618442280000	orphaned
19574	3NKQqpbvtgo1jVzwirtjXFw5wfeztrXsAJLuE7ZCba6SvEvEKgGY	19569	3NK33RpRu9qEXVrfbh8d2LXdhXnSkGp9nTGv4jpA7FAqLzsp9tkV	1642	1121	343	6301	12463	jxwahJtxEyP7Ca4EQ5KXGVSiUDkaHiqnsUDga8piE4tSA9LALVt	9858	13907	13907	1618442460000	canonical
19572	3NLULaYo5t1PYw5fdntDAroD55PKQjv5Q5S54UzCtbbU12msaPKC	19570	3NKbRVMoVioc6Zq6GacrM7Zm1LtmFdexvYbqgpTkQ62MgQ2reMpX	1481	790	343	6301	12463	jxqc97zYgb3Gn3XHcmdrGXKfVK5w1kdzYdETfPVouY5c4NHdeX4	9858	13907	13907	1618442460000	orphaned
19576	3NKGYxYuDexH26uFwuth1QinF7xATn1eWcxgaKHRdvM8h8Zeh6jh	19575	3NLdoM9B55t1fTKvBh6cT1yarhuwcM2rvydsy7W23qdWmpyuM4Ki	1608	1043	343	6301	12463	jxdFkT3f4ykrWBuvt83Rp79pSrf1gYKnwvh1WjgAEqdCygEUaZX	9860	13909	13909	1618442820000	canonical
19579	3NLKSzBSKKofr6jY3HT4fLtoK59Jx8LS3eeSMg1NL5VYUqNZYG1c	19578	3NK3KzbTy4Rtxn53SFNaJXTxw4uD6oeXUbSG7ajZxUHbiQn12mR4	1649	1383	343	6301	12463	jxQLRX5v687tLxx8NFmhh14N38tX5z3SDwURgTxz2cSwHko1C9V	9863	13913	13913	1618443540000	orphaned
19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	19580	3NLpUFFEFiZjAL4N4BVX8LHyRN6NqtXsKVssLGJyvjJLf4MWAJPs	369	946	344	6301	12463	jwbKjxFtMgDdKorAQf9TPavpYvkWJCETQefdssLzJcvX7HZ211m	9864	13914	13914	1618443720000	canonical
19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	1589	1040	344	6301	12463	jx8e4bU1JiU485iocxvoXUXHSoSMw8hykdik8YSdSmjPL5qkCGH	9865	13915	13915	1618443900000	canonical
19590	3NKL3T97tuuuSgyteCkyrwaSDFmRbLraqrmwW5bAewuvT8yfDFYn	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	171	1374	344	6301	12463	jxzyzqkjvXhtPfMop6DGoENSepAYMMke9N5zkg2JoGEdUMuaN7p	9866	13916	13916	1618444080000	orphaned
19597	3NKGtdkHYDHqmh1CBza3DDa67GsYRLFqk5iEJ1MavAS7YJhgQ3Ui	19596	3NLeeHSbbC26K4qVcGDBTeAen2L2JmwsXDH7jq1QhVrnfucjgNrk	1508	1387	344	6301	12463	jwBa8SXZ2cazcwFyisYBGa6DFb6SNhnNHX55LxS6XdsCud5sXAP	9870	13922	13922	1618445160000	canonical
19600	3NLGGCdhsfLUXAsfaqKs1DQGugqXjk6eJ1eRPo5PFVf4iPgz7YUs	19598	3NKkBnojJAmRLSqXvA28gqNP7GmFthuqLusCW71YAUwB27NptUNB	1403	824	344	6301	12463	jx6wJh6UDP5kUH2Zhpm6GYh73PKt1gf5Rg2uTF5xmsqduTYsRbG	9872	13925	13925	1618445700000	orphaned
19602	3NLJ4VwjgUKPD4ZKz5JxCjSkhjJgjuprL8JmHZRmadTyLef8Yc1A	19601	3NKuwy4oShQusjVAoqfsEUbJutWamEJ7DMwMLy6UCPqCY5UnbAw9	152	1330	344	6301	12463	jx3sL9eZMsSAdch4DxSiujrJiXFisYSobYuPqXhtGC61kaHJzD3	9873	13926	13926	1618445880000	canonical
19605	3NKnoPNxYZxVxYJLVBv8NirsPyoxLMe1PnSag1HXNnRaS6Q5Q693	19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	1407	1395	344	6301	12463	jxs1MmmRYexyWiTomwcHHqjQ6gwCeHRE6fvzQ3yceNNULdUazJ3	9875	13928	13928	1618446240000	canonical
21955	3NKXEnbFa1KhSDSActkBSnETPsRLqENKLnLxFowGy4EZfjaQizqe	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1406	1393	403	12463	14106	jw7nYT5g7V9PncJNfmcXBmCWogRpaX97BDkjoPaBqb3z6eQAKhH	10985	15471	15471	1618723980000	orphaned
19558	3NKrxmxj9f1GAMknFPydY4NuJYY45RtsF5FRJLsMX7yvh7FEKBzu	19553	3NLu8cChCqe6Hp8iRtE4Ymkt2cv2TDLLce5u6A6LvhXyS7gDaMvZ	448	1305	343	6301	12463	jxdYfCLu8oA6ER4FyHWiEKty521G1J7LJD415BdzDk2bPmNdUAN	9850	13899	13899	1618441020000	canonical
19560	3NKvdj48z5bZcCwN8ytcj8m9pat3qaj4i3BMVprQBbEEmgGPeBzr	19558	3NKrxmxj9f1GAMknFPydY4NuJYY45RtsF5FRJLsMX7yvh7FEKBzu	1405	873	343	6301	12463	jwScuNRnTGcGH6zegz2hPkocaReoBEUZyh2fg1SF9Z95B8dzKBk	9851	13900	13900	1618441200000	canonical
19561	3NL1qwrRD1jhgPYt1a1SfsZBZrpjbB5TjxX9Y4jFxV8wBLhzBALF	19560	3NKvdj48z5bZcCwN8ytcj8m9pat3qaj4i3BMVprQBbEEmgGPeBzr	1608	1043	343	6301	12463	jwXeFXNtuT7Xy6SNzeGb7JyPNRC7rxYgbthhrSX7WS53Ptn8hzS	9852	13901	13901	1618441380000	canonical
19569	3NK33RpRu9qEXVrfbh8d2LXdhXnSkGp9nTGv4jpA7FAqLzsp9tkV	19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	1451	1046	343	6301	12463	jxcR1ocV59BPT1zaXFpyCAmVN8bT4fHs5e9AbGqCcH3YUNubS4u	9857	13906	13906	1618442280000	canonical
19587	3NKSQMoYB3scxmQDr2Mi4L21Cesg1KEYv5hLJQJxw1AubRmU6ws4	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	532	1057	344	6301	12463	jxq5zXqfSPBZzxWhrLV9hiSd6tP5e3oDWpi7479fCpCMvP73aMu	9866	13916	13916	1618444080000	orphaned
19591	3NKXAoYERJpLhp7WZJHopUhUJp9AaYA56VHBiu5rqrSuNayNUjpM	19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	1403	824	344	6301	12463	jwACoFTStRsf6p4dk5StroUTvj6ZscAJvFcqHcwicKgpVyidijy	9867	13917	13917	1618444260000	canonical
19595	3NKZcderv3iVE9odGxEz1ui3eahNXJ3F8eyx1B5V4SbXM8rDsFh9	19591	3NKXAoYERJpLhp7WZJHopUhUJp9AaYA56VHBiu5rqrSuNayNUjpM	1460	958	344	6301	12463	jxCpb4q9FKLv9iv1zaUBEqxU1c7BUXxHZc4JyKqBVirxA167kUx	9868	13918	13918	1618444440000	canonical
19599	3NKnr4cX5uJ2Dz43ks56hQ8tTJE3eS1RpX56ep7xN8zsLd6VPm9H	19597	3NKGtdkHYDHqmh1CBza3DDa67GsYRLFqk5iEJ1MavAS7YJhgQ3Ui	80	1147	344	6301	12463	jwSU2xMVCTNZv4KBQj3gLPYCT9HyHqbYcy8FYmP5oviMoUg9biv	9871	13923	13923	1618445340000	orphaned
19608	3NLFvtFNu9ZKXRWzqmMDbTSPvDydqa2yXgg8tYHLTSaCs3Dmf3KY	19605	3NKnoPNxYZxVxYJLVBv8NirsPyoxLMe1PnSag1HXNnRaS6Q5Q693	1556	578	344	6301	12463	jxLienVS4X9HLepRaDMcytjMFSw79Hatoj5g1LfjcNas77Q5gP5	9876	13930	13930	1618446600000	canonical
19611	3NKDZMxUdkAGZeyztKKhgTQmoYv3orbpNZDxuKrpNxMdMQFnyFS6	19610	3NKjUwrQmqRoyJczUody19pK5v53M2ky8kBMDRMrpPrz4o6z6MtN	1406	1393	344	6301	12463	jxk7XgT3wg1AvUFMYaDUihSvP6zRLSroLQjVztnKud6oxQp354F	9878	13933	13933	1618447140000	canonical
19647	3NKjACTp32Udm9ivqYxENh4f3DxLus2kuP6G2Gcca2gsyCTHbVu8	19610	3NKjUwrQmqRoyJczUody19pK5v53M2ky8kBMDRMrpPrz4o6z6MtN	1534	628	344	6301	12463	jw8E4d4kgggC34mc4x9fEiWo97HEUq1zHgFjVoZTs79QcyEJ5Cd	9878	13964	13964	1618452720000	orphaned
19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1555	1347	344	6301	12463	jxLudGw6dNrVzN5Zfas3LajdBdDae1n4YQw51fJyXtWmi8aXMh3	9880	13938	13938	1618448040000	canonical
19617	3NLVwRtZdfKEPuW13r7TTzKje5WKxVymUs1xLMb1thGGCdicyjEQ	19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	1403	786	344	6301	12463	jwcdX3QSJMQvvJd4r34BiqFAQEYMapqbe9LcwZx9T6QTb259hkb	9881	13941	13941	1618448580000	canonical
19622	3NLLYDmyMk3SXEqajeRgTLbqQF16bFf9EdzR1thfrGm5wyLZSG67	19617	3NLVwRtZdfKEPuW13r7TTzKje5WKxVymUs1xLMb1thGGCdicyjEQ	1555	1101	345	6301	12463	jwLD9SCrG3X3JVyh9KTaVmWoLrQYjhf5gspqFnbCW5fsfQ521tx	9882	13943	13943	1618448940000	orphaned
19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	19623	3NKjfvsoH95iVo5GpDZTTJFTgKcjzVzVPN9RhRWJMhYGifDi3BFJ	1483	894	345	6301	12463	jxaLW9mP9ZVee6kXAX15ehVrX78QS4M7jQqAnLAC6gx8oDECVv5	9884	13946	13946	1618449480000	canonical
19625	3NKm4KzRgAgLZ1JPqEb2m7kEbFwX7ihEYsZGRHEdFj88B8DpkvwK	19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	1613	1103	345	6301	12463	jwp2qaQsXqoFsBe62T79WkKKaHiw24Ua14BNDQGhV2VTLHHahf9	9885	13950	13950	1618450200000	canonical
19630	3NKF4bpp3UfMURrwSQuAaetvTp94GrBKF5R5RQ57PySQQErXiUpW	19629	3NLsyCgNsA9NA9QdS7M5P7QSUVG3bVv7hdYuj8RXq2GWHU4sDR2r	1402	882	345	6301	12463	jxDYxUtgok6YHeh1RthDXvEp7GUbiiKfCR1GybpK1SSRx7FD5Yd	9888	13954	13954	1618450920000	canonical
19639	3NLocnbVmm1Jua8TiUckXTnymc7Js6U9KgUDUDBfAgCyB4YjKmw3	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1672	1039	345	6301	12463	jwH4cznc2DiZCcUR5iTUxZ5rgkkDjgqgo3agbX2vV63jpv4xKzU	9892	13960	13960	1618452000000	orphaned
19644	3NKdhwtQptk8YUUe29SQzreCpw5vbN9sMkPbsjEQik7gKCPHMD1Y	19641	3NKtSLriLZ34ewkuQufiYGaZ8oL2bn7nxQYD394q23bZxQ7JNHaw	1553	776	345	6301	12463	jx2dbjM9SUK7Yr1tyf8nBpWzjwY6ZbBwpzo3vrNqAYgrvStaoRU	9893	13962	13962	1618452360000	canonical
19652	3NLn2LK5ZQebpgAEX8uJ8JH9mE3uYYwj3xfxs6RfJJWU42qvJp1T	19651	3NLph2ctSWjyNo7Nii4TNyLG7tR3DBtUjK9P4ENNz7nPkSDw42Yr	1675	1342	346	6301	12463	jxhbXbiWxN6WmoECuHcTsXNK6FrxRLjuggTDDKKPL9U6HUbijcZ	9898	13970	13970	1618453800000	orphaned
19657	3NLy9WEZN7BdKgMrbcaT73KCU5W5vMR4TULQmYogVCwgxYyphoGR	19656	3NLBQmF8bRn5j74tp7QYGG24XQY4traAxd5Le9ohUP1u3TzoPfjn	1631	794	346	6301	12463	jx3XoSjEyCZe8pS1q1bNbbmgMwxeB1urZEN1wVcU2sSwaibYYTy	9901	13974	13974	1618454520000	canonical
19662	3NKVAjSmzzRe5eXhYf2tQqyy4MngUD2bPjtBJwV3YifwqxmFXxJP	19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	1536	947	346	6301	12463	jwARxcM29wtuV4dBrXQkbU8rjLzfMYNcsDzCK8KyNsRdeUxRoRf	9905	13978	13978	1618455240000	orphaned
19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	1648	1284	346	6301	12463	jwM81DXWxhbntCoWBsCA4nFyq9dqNjHvJx6KHuy8n2xztReJFkP	9907	13980	13980	1618455600000	canonical
19669	3NLn36w2qkfjQDCV62xtXNY9kuS7YLxJUHKNrUos9FPvd9e6STcA	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	1403	812	346	6301	12463	jxpPkbbKemNnSoVeFvfDZZKVsuF1GgbdnMTcw6nxX8qbCw3a7Sz	9908	13981	13981	1618455780000	orphaned
19674	3NK5fqXcweBigSBFAz2v5hkxSWZ1RaUPcxbEc8z8A2wqskgkz7i1	19670	3NKvkKcCVzUWYAJ4aXRYeizyU94VH9vomQsfCiF2fLuhvQL3QRkx	606	929	346	6301	12463	jwRKBuyE87ckr2UfECz5Q34wACJnnSdmyRaWz6MUdNhAma9eNSD	9909	13983	13983	1618456140000	orphaned
19678	3NLdzFaTGRKQNHNc4Y1P5KMpE9X3JzGZF7jw85m1hxcc2hoDQMP3	19676	3NLtdiazTEcFmZm6nASwnu6ox9pGMghp678G2yDWBHderu7zJvsd	1513	1253	346	6301	12463	jwxZEnE8qaHEBRneUsff91yys7eg4pL3rBfJ2HQdTMbguoPCahf	9911	13986	13986	1618456680000	canonical
19683	3NLWV9CDCXZ2xQcD82nuJ4ZKbB97cMwvV4iJu3bGzDsqCtL5frvG	19679	3NKRb1HMgiJnT9QYiECmaETFWxPVcyD9CbNpNmABjsfAXXTGtQRm	1553	776	347	6301	12463	jxucP5oRRZ9sbMbnPwyM36skFf1ugzrZaeuHceakQZgZ2GqKfYg	9913	13988	13988	1618457040000	orphaned
19685	3NLgjKfUXS9CTGWqVPiVBRSsSxfPrCD9kMQ7GqkqNWo9rhK9rgGj	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	80	1273	347	6301	12463	jxq2xcBFTMcF7ZBFXbZEQSgSseC1G9Um1bpQDccZtY6wgKS7Ys6	9914	13989	13989	1618457220000	orphaned
19692	3NLarqWvZeWUXz5myJdPTz4XiMASMiL9cmdPhwAFBXx6QUoZJEUz	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	1534	60	347	6301	12463	jwkp46K6B6f3rqmGZ629yxKNj2rTTmn3wET7V2JcYbNwdrszdQt	9915	13990	13990	1618457400000	orphaned
21959	3NKypBK4o3qThpfS3DF5prpYwbM7VB6xCdyqj5xHRD1oSPkvJHmC	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1590	934	403	12463	14109	jxfuRNyB4kUa2fTrWPm4xWUR9BWkbDV5tVtSRLYAAnDpR2hJd1t	10985	15471	15471	1618723980000	orphaned
19568	3NLBRSSNRuRrD2AMGoLRrwKRUTfLrshRtaJQUv56MMMu47fyJWNW	19424	3NLhYxLWcoVcarLhwQYkoxvsS5gdoqb63Amr7u3ocLw49Fgi3iWK	1451	1046	340	6301	12463	jxLm7wHkQVr5aQBAHHjubjZFH8cBh4Qi4zYNeMk2QvJM28vLaFh	9790	13906	13906	1618442280000	orphaned
19563	3NKTTRL2nvsVMKLmmbK9e1FGKMt8QoDsHgpD6WXiBvVFXyUEbgvb	19562	3NKfUUYW5ws2dqXktT1khfh3hNrN5ExdpeHrAfzxkH7BVJPUWxVN	1648	1038	343	6301	12463	jx3uUEFXvrD38kXVvFZvUozAWkVaFvfyfYQLuUNmEVRcHHNbS4w	9854	13903	13903	1618441740000	canonical
19566	3NLyEQHcCZtW6Nmqjpn35SS9HLBKkSH2QRfaWrTuPvrZAN654vDJ	19564	3NKTxgwT564wu2w9GC8hiANVTz8XojGL6AMotWGaDHq1jXwKwP89	1610	1314	343	6301	12463	jxAZgHD4b1WvFVu3xMEtL4F1fbXKA4HsTbDGTyFDeG6EDrMr3tP	9856	13905	13905	1618442100000	canonical
19577	3NLKP69KXcqH4GxDmnpaGVxJ5cFexWfij2qaWtCWTeaYUBHzMFqp	19576	3NKGYxYuDexH26uFwuth1QinF7xATn1eWcxgaKHRdvM8h8Zeh6jh	1637	815	343	6301	12463	jx3xoaEeeLQti3CV56Lq621Zk3jDphEckzSSzVHHDbXWjh6gYg8	9861	13911	13911	1618443180000	canonical
19580	3NLpUFFEFiZjAL4N4BVX8LHyRN6NqtXsKVssLGJyvjJLf4MWAJPs	19578	3NK3KzbTy4Rtxn53SFNaJXTxw4uD6oeXUbSG7ajZxUHbiQn12mR4	1649	1383	344	6301	12463	jwoB7Bg9g76zVxqbzpEG2cw9nJ1RnUDvovNEsU3YPon1zurCd3M	9863	13913	13913	1618443540000	canonical
19582	3NKcJYZk3gyo7kH9wG3T51zr1bp2xhiKQqRbQM2bVRxnWamuSvtN	19580	3NLpUFFEFiZjAL4N4BVX8LHyRN6NqtXsKVssLGJyvjJLf4MWAJPs	1668	1370	344	6301	12463	jxQhAegPaYnpciZX373wGXTXYpf3Qg1wGAhX3cqZD5DHtppfN5x	9864	13914	13914	1618443720000	orphaned
19585	3NL4ZnstvP3aLAugYSNizBReAFp1xp9UJeL5Dx81GrkmDRpynXUq	19581	3NKGytLWtkq1MtqA2MMYZQTraHctiZMJpxj26y8cqGva9fn4kFRK	1483	304	344	6301	12463	jw8D9mNaADFYTGcGfsW3Bs5FpQEfzpNzJwkhJeEs1hm1SEYPcL8	9865	13915	13915	1618443900000	orphaned
19586	3NLWEpZWBtRVPteaAzhniN1nVoKGfVhBWfzAmfyjVEJ23thLE2Mb	19584	3NKQc1DTLLG6o8qQLaDqk1EaXobTE8KjX6RY3zF8pF4EeZ1NPrT6	1490	1148	344	6301	12463	jxYWEFREnWR8vPMFqiDXAUpmLDVKWwz2E9qApmHZ6Re3JFLthmQ	9866	13916	13916	1618444080000	canonical
19601	3NKuwy4oShQusjVAoqfsEUbJutWamEJ7DMwMLy6UCPqCY5UnbAw9	19598	3NKkBnojJAmRLSqXvA28gqNP7GmFthuqLusCW71YAUwB27NptUNB	1426	1364	344	6301	12463	jy3CQ7YBWKBLCUEovcj3GGztorXw4TsfTfDSHbJcpuBJwgswXdL	9872	13925	13925	1618445700000	canonical
19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	19602	3NLJ4VwjgUKPD4ZKz5JxCjSkhjJgjuprL8JmHZRmadTyLef8Yc1A	1637	816	344	6301	12463	jwwycc6AWJCkrkFTreFwfpU5ecuQP15b5MfFod7eea5tun8eECW	9874	13927	13927	1618446060000	canonical
19606	3NKDkkVa82oxSdjqNqQcxSBkNZkd4AD6PaXct75o9FkCygvLmCgC	19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	1406	1393	344	6301	12463	jwj2Bp2Y2BQ1EQdJEXbTgqF9xnZamRosNBKUXovovB2ay8uBJS9	9875	13928	13928	1618446240000	orphaned
19610	3NKjUwrQmqRoyJczUody19pK5v53M2ky8kBMDRMrpPrz4o6z6MtN	19608	3NLFvtFNu9ZKXRWzqmMDbTSPvDydqa2yXgg8tYHLTSaCs3Dmf3KY	1642	1121	344	6301	12463	jwiFGTH2qACyJEMMfUaxJ3dJKAfkhM68cbreZnhqwUxTiwiQLw2	9877	13931	13931	1618446780000	canonical
19612	3NK4MNqLDbWj4jScr3oK3Vo4nPV8PuCo3eW4GnJVfJApV3j2dMKK	19611	3NKDZMxUdkAGZeyztKKhgTQmoYv3orbpNZDxuKrpNxMdMQFnyFS6	58	1281	344	6301	12463	jxjLqLJMGxNgi2hiBDDduBbYMPMDEwq3zmcMtziRQG8cyfRXyDk	9879	13935	13935	1618447500000	orphaned
19615	3NKtMCx48YCgRJ9sgLrj6bb1RBmazqki1UhKk8DLrLGmxztLZiVM	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1489	1380	344	6301	12463	jwXE2CdqMiH29r9UBzQBPfEGLdh4odNituQXk6WEHVLN4hf9BMB	9880	13938	13938	1618448040000	orphaned
19621	3NKkhGeqqsjXneSjNMJYZrdH74W6ZT5xL7YbNxSpYCm7vixpnEF2	19617	3NLVwRtZdfKEPuW13r7TTzKje5WKxVymUs1xLMb1thGGCdicyjEQ	1555	1101	345	6301	12463	jwLD9SCrG3X3JVyh9KTaVmWoLrQYjhf5gspqFnbCW5fsfQ521tx	9882	13943	13943	1618448940000	canonical
19623	3NKjfvsoH95iVo5GpDZTTJFTgKcjzVzVPN9RhRWJMhYGifDi3BFJ	19621	3NKkhGeqqsjXneSjNMJYZrdH74W6ZT5xL7YbNxSpYCm7vixpnEF2	1402	856	345	6301	12463	jwteLcg9JwcM4WeeirCnyNTTpf8nYZAEZK38JCKNrmVa943NjZ7	9883	13944	13944	1618449120000	canonical
19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	19634	3NKDu9k1k5NCisjSpq8SLKKePhSgrJU2RWqShxuFNaJfQc6eyyoA	1560	1045	345	6301	12463	jwShSsHk3t1yjWJnBUDL9SBGCTi5w7NNii99hTiUvM4w5vLKQuE	9891	13959	13959	1618451820000	canonical
19641	3NKtSLriLZ34ewkuQufiYGaZ8oL2bn7nxQYD394q23bZxQ7JNHaw	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1599	1041	345	6301	12463	jxwsMugKLikaPGFkEgZ1DLhFnFhP43oWwgR4VVX4aRNFAys2a42	9892	13960	13960	1618452000000	canonical
19638	3NKzcSaKoEVsH4kMZLf5oobSPdVPxtemtqB68wVCnmxUKgFfwFWT	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1474	1329	345	6301	12463	jwYZZMWNvYRLcUV6tp6eQi6XDHDgFAJzyXER6ALCQX2v2W4WiZa	9892	13960	13960	1618452000000	orphaned
19646	3NKtRZNH2DBqofHnUbX6EYApt4bemavTyYUfy5hkdgST2xLyiRXT	19644	3NKdhwtQptk8YUUe29SQzreCpw5vbN9sMkPbsjEQik7gKCPHMD1Y	1631	794	345	6301	12463	jwzRjbk6f54317cQKvCrBWMVRYmUJHNAEqzAdjGAJCqKaPU8fts	9894	13964	13964	1618452720000	canonical
19649	3NKK3x9mcVCrieXdvjHDhyo6FUkSj8wdzEdx8CgfF5p7FnNdZ8DM	19648	3NKUMtUg7rfcKtzg9afA5Aap3dxb82JmPYhFtp5wrfMqx645TqC5	1627	1385	345	6301	12463	jxCsGxvZyiJpqYQBWGA3wMF96vxddT6Y36GxH2va1tCjeWxPzmf	9896	13967	13967	1618453260000	canonical
19651	3NLph2ctSWjyNo7Nii4TNyLG7tR3DBtUjK9P4ENNz7nPkSDw42Yr	19649	3NKK3x9mcVCrieXdvjHDhyo6FUkSj8wdzEdx8CgfF5p7FnNdZ8DM	1559	987	345	6301	12463	jxQGNbw8p7YtkJAs8iW9jXK1A1MMp68QQJGPw6fHhrpfjxZqkBo	9897	13968	13968	1618453440000	orphaned
19654	3NLWFANuggGTotm6Zrp7qNpRqjKzScdyRJ3wo9xq4L1A36ZQt5Y6	19653	3NKrENj3RGaacuHQbA52CbYSfG7jawNntDVDz1o6qcyW1Kz4HeL5	1622	1356	346	6301	12463	jy2ho4vKnRXiCJEUZGpm1HtwU2z8NEiME4d6ocTtQAStAnTLkz4	9899	13971	13971	1618453980000	canonical
19659	3NKJ4XUzSK9QyxhN4GDQucXir8mF62jnZQQatSoFqiGB2oDMHAp5	19657	3NLy9WEZN7BdKgMrbcaT73KCU5W5vMR4TULQmYogVCwgxYyphoGR	1581	778	346	6301	12463	jwkAzTgWEhBB3tWp3nSVwT3Z7bsKXPTNzCqeVBkYb7Fx4RnJGpH	9902	13975	13975	1618454700000	orphaned
19664	3NKissRVxVtQhCw4yoLLMCGLvdKCQqbtJy2vZJ6iJENeS93dw71Z	19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	563	1233	346	6301	12463	jxHwgjtDE8NwExntPYx9L6A8JyZBjNepDrWp7qke7G1SC8scmQB	9905	13978	13978	1618455240000	canonical
19666	3NK4U7cACZVxK3eJPxAsVy39y5LTyxCtS5nVn5dhhKwi86LPTHpu	19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	1471	1140	346	6301	12463	jwz94h29geAkqRXusFrYXVREpc9YuX43Q7hdyadfwdx48vkkDg7	9907	13980	13980	1618455600000	orphaned
19671	3NKMuFD9Uk6gAbNkuDn4ob9XdkHq6i5DApqCE7hLYzSZ8AtMgqVx	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	1553	776	346	6301	12463	jw9V5WQ13hjts9BgZMB7DoefKG2rHjJaxuHPtcBREa5FWgmmGpK	9908	13981	13981	1618455780000	orphaned
19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	19670	3NKvkKcCVzUWYAJ4aXRYeizyU94VH9vomQsfCiF2fLuhvQL3QRkx	1407	1395	346	6301	12463	jxrSYErStK8HW6ScTxhxvX19Enc5qREK3F9vzC1TMEEthbX3kwu	9909	13983	13983	1618456140000	canonical
19676	3NLtdiazTEcFmZm6nASwnu6ox9pGMghp678G2yDWBHderu7zJvsd	19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	1406	1393	346	6301	12463	jx9aDwSCUYCMSYKzCEYqJcjhXRJ8RMT54FPKzyB1iJZ87a59nKS	9910	13985	13985	1618456500000	canonical
21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	532	1303	403	12463	14116	jxwV9JwkBacG9cxHcjckywAXathoExgLfcyh3v7tevP6EC7Bs2L	10987	15473	15473	1618724340000	orphaned
19620	3NL5jQjDEuDF65FjrWSMUAZE3BRVPdow9NyN7E1NjhxDXCg9GFw1	19557	3NLoZHPdTimCeaN1T7tkijvWV4mpAKh81vJ1B5oRrpYGhJdAHEzT	1546	1093	343	6301	12463	jxMQjXrojJYjn9asmcxBmjKijNWW4M5b2uLAx7BFZzF3sbuBwwH	9836	13941	13941	1618448580000	orphaned
19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	19611	3NKDZMxUdkAGZeyztKKhgTQmoYv3orbpNZDxuKrpNxMdMQFnyFS6	1406	1393	344	6301	12463	jxktAQq5oWDCHrfgZj2EAdUcbvHhYQXzQTrNSXyBdiv2c4hBrFa	9879	13935	13935	1618447500000	canonical
19694	3NLsErhJXyegJySzhns996Y7vXZK6xradT9cBBPrfZtUkp5hMzyx	19647	3NKjACTp32Udm9ivqYxENh4f3DxLus2kuP6G2Gcca2gsyCTHbVu8	1534	60	345	6301	12463	jxRVXRte2gPnw3grcbpB5HzBhSeAjgrKPaP2ZhJRVQKVtyEr6PZ	9879	13990	13990	1618457400000	orphaned
19633	3NL9ZRHabkjJZTJxnbpqmCFUFf18moZo5Zyf6sDLKi5aKhrQrgXd	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1527	1293	344	6301	12463	jx25PZUDKYV3HLYfiH84fEUG8PFHniP4EfwzugbZSwxxpQhFM5p	9880	13956	13956	1618451280000	orphaned
19618	3NLp7pSeBsrsaV7VfESYs5pT5Gtvhvs66JGLpBX6xkYPZBTfRivi	19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	1546	1093	344	6301	12463	jxoJPwrDi7krCHHYGCMFJTacByoPQSfp4WYwE3zZ9VWhA6AssTU	9881	13941	13941	1618448580000	orphaned
19619	3NLqQNHrqBmXhkfEgGaPu4DkG67JbvZtXg88dRaU7dD2o87ZvG2H	19614	3NL61HXrE6c8NRjUWY2sZT5PqLrLakwo2R7mddYjmfo31Lz84pPv	1546	1093	344	6301	12463	jwuriRGuuP15V8EwHmatu7qmtn4Dg852xtSojS92Sk6XqxACXHc	9881	13941	13941	1618448580000	orphaned
19626	3NK6CDD4EEkRSmoaDQu5AwX3kg1ewUaR12SX6dniMNs4QgVMZmqx	19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	149	917	345	6301	12463	jwMJmhSS3QQbRxvt2tR5K4cdokMU5oE9xzwjrPvxgBtrWnmJe4y	9885	13950	13950	1618450200000	orphaned
19628	3NL2L6vaCoASFe16WMFD6R3Fjsh4ZFd9RRrGaKYh1xUPHYFNQr5r	19625	3NKm4KzRgAgLZ1JPqEb2m7kEbFwX7ihEYsZGRHEdFj88B8DpkvwK	1406	1393	345	6301	12463	jwEuje8XTTr24TFkK9ESoRPh2aR9Zt4bYmpiXZtRa2Ln4sBVgSr	9886	13952	13952	1618450560000	canonical
19631	3NKCtENQPhJw3z39BsonRmke9cqxXBvbfGprkiCLkcScNqWTWi6J	19630	3NKF4bpp3UfMURrwSQuAaetvTp94GrBKF5R5RQ57PySQQErXiUpW	1527	1293	345	6301	12463	jxwR23C5SgLaLgZMSWPRSwKsycDvvquebZMfdNdDrYAgubZC3iS	9889	13956	13956	1618451280000	orphaned
19636	3NKJTzKDBrg7qfA1vAeY37V7UnpcWxEgxJniPoAoAe9dkUHt9Qmb	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1578	556	345	6301	12463	jwvjkwSio4TabQ6sFtALuaPS8RtqZDUWCNyh1zYJ99eAqNAVgyL	9892	13960	13960	1618452000000	orphaned
19645	3NLDfvYMXrHWgyYRypTsPjw8Ep7x3PFv84rBBtxj7bsDdEmrgvyW	19644	3NKdhwtQptk8YUUe29SQzreCpw5vbN9sMkPbsjEQik7gKCPHMD1Y	1534	628	345	6301	12463	jwREWegY5KCFm2aUv9DyDAbUWaNUXohRMnkggk4dc8Vi36SeCFj	9894	13964	13964	1618452720000	orphaned
19650	3NKhpG6UFH1XHHtWwzzU5Gx4Q97VUjzfPEuEkj7UWB4i13PL3xVH	19649	3NKK3x9mcVCrieXdvjHDhyo6FUkSj8wdzEdx8CgfF5p7FnNdZ8DM	1559	987	345	6301	12463	jxQGNbw8p7YtkJAs8iW9jXK1A1MMp68QQJGPw6fHhrpfjxZqkBo	9897	13968	13968	1618453440000	canonical
19655	3NKTyep7QAbsVehAGZs8C5vwrkgQesueom5QKtuUn8JfhMC3fjcz	19654	3NLWFANuggGTotm6Zrp7qNpRqjKzScdyRJ3wo9xq4L1A36ZQt5Y6	1608	1289	346	6301	12463	jwL3wNaZLJNFRqk84f8aEKXugREEca8GfYfvBor4bemBWxJLv2i	9900	13972	13972	1618454160000	orphaned
19658	3NLkYjVeK67ujRvoKtSiAsXRWhdrxGHt8TTX5uZpwmT9PRzXLF9c	19657	3NLy9WEZN7BdKgMrbcaT73KCU5W5vMR4TULQmYogVCwgxYyphoGR	1455	1206	346	6301	12463	jwZeq7UXhSRwUQYKGYPELDJGdYwNxGvVMXSed4RDSJgryitcKLR	9902	13975	13975	1618454700000	canonical
19660	3NLdMSUavG2Bkm1rpkY42dASAYfSkoFKHhhvYNZTW2UcvrvTJ3yn	19658	3NLkYjVeK67ujRvoKtSiAsXRWhdrxGHt8TTX5uZpwmT9PRzXLF9c	1501	1234	346	6301	12463	jxucZW4genPePsiGTGmbQtbMMgAJhHZvMCafEgxDj9B48q3JmT9	9903	13976	13976	1618454880000	canonical
19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	19664	3NKissRVxVtQhCw4yoLLMCGLvdKCQqbtJy2vZJ6iJENeS93dw71Z	1406	1393	346	6301	12463	jx5ZvhsMV3oFn3FwFuimHnku8f3p1k9XSev4dQ79VkcJgu1sNjX	9906	13979	13979	1618455420000	canonical
19670	3NKvkKcCVzUWYAJ4aXRYeizyU94VH9vomQsfCiF2fLuhvQL3QRkx	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	555	555	346	6301	12463	jxtjfpX5GtqGkY2fVazHumsoxckZiJJ2hf91K4ZCovWmKfXVorC	9908	13981	13981	1618455780000	canonical
19677	3NLDEc2oxmVGVB4uJcT8fDctN3GHpvr2BD3sDpyyGnxbgT7yma8m	19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	1652	1315	346	6301	12463	jwRiHjAdAKKG6JXC7UX1eKkWHLEpxnrVLAMh54MJfGtYRNQQmnY	9910	13985	13985	1618456500000	orphaned
19679	3NKRb1HMgiJnT9QYiECmaETFWxPVcyD9CbNpNmABjsfAXXTGtQRm	19678	3NLdzFaTGRKQNHNc4Y1P5KMpE9X3JzGZF7jw85m1hxcc2hoDQMP3	1601	1142	346	6301	12463	jwE6nBFYNf7nuEUaxh9RicueSPVKnovvFsgN28Fi8VeytjhZghD	9912	13987	13987	1618456860000	orphaned
19681	3NLTjTteeXYr99iH94GJ4owQiKv671batV9CimKoZNGYyDvmZWQd	19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	1527	1047	347	6301	12463	jwMnkDVE7mwY1hofuih3rRQ7tbsuBDaVuq3cqfkWPY5kznj8Bfn	9913	13988	13988	1618457040000	orphaned
19686	3NKShbJHxfPWsNMnw3jMqK4pDa5ThM4jJ5Gbh7n4EGbnhWuUuKRj	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	58	915	347	6301	12463	jxRAgTmHPxSPkhRjAdYhnGqasN9fHMCWw18cqTLzdYHNE7dn2sa	9914	13989	13989	1618457220000	orphaned
19693	3NKvJV7d6Y4vCWym1sKj2xc3SB7Gm8Fg2gdbA1bdKN5KTGjTP1gV	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	1564	1338	347	6301	12463	jxVHpuviMXfUDJGMKUdN8nKjoUB6jd9cmpA37SKaG14u1CLgw5d	9915	13990	13990	1618457400000	orphaned
19697	3NLjXJgxkfCsMBD1jd5H98SroX2A1CieHF7UmmxMTyzWus2hWtfN	19696	3NKihFPMVpzeMj9MbpcCnykPvUxdGg2nGBpBRYSGQw9e4dVKTLiv	1617	1162	347	6301	12463	jx1CfPTAAmu51tQPqSdVWeSo4Rs4LLpXxYmGoLqGcWMsxP6Xuaa	9917	13993	13993	1618457940000	canonical
19703	3NKM8Z6mShYvkQUVNvN21ik9wghev6ixb1rbwgiJuXZLCCFwwqwb	19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	1448	1065	347	6301	12463	jxvhk6XQDySq3kj7FXK2w98qMyco9QgopQZbfmkJToR6Yt6XrJY	9920	13997	13997	1618458660000	canonical
19700	3NLCUDF9gfrtyVTHvXBGTNUT9m1WT8oipFdKaSPfkq1ZfzHQBqoB	19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	1634	1331	347	6301	12463	jwmgoGWgPgQEu1cDTYn1fvrecsrWaS647mTjBQu7ApujcvJyXcC	9920	13997	13997	1618458660000	orphaned
19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	19704	3NLb9XHLAGGy1NvwTsHbDAeS4BYgptha5UeJodEo3pTtmyc4pDms	1407	1395	347	6301	12463	jwjttPXRozGtxR6dngJ9pvs9gNBfsk35aazG2SVxsuiieAF6Zis	9922	14001	14001	1618459380000	canonical
19708	3NLcfbbaKoT1gLCM2yWeq1n7V9cF1PtVw8cuQqjU6w63L4jbBvio	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1439	913	347	6301	12463	jxhXrkZ1cuKfSY6DNnZkQ8HMxWk5tfSo9MPKgvgohufZqnRx9Jc	9923	14002	14002	1618459560000	orphaned
19712	3NKDCiEaVzpxgMdpJ5pJnhVuiv1PwdAApzHFtDP17LFj1zBqyMpE	19709	3NKHnAX8uykgbL8oVPgrZArYaivpEFQCdvRr2imqEe1XAd1chu5d	1508	1387	348	6301	12463	jwJBTif4WdJdkcwotqCEd8ehAqfS838StXXqd8VGSHEodQAGxUk	9924	14003	14003	1618459740000	canonical
19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	19718	3NLCtkeHSiVdu1xPhZxSE9xk3J5uAGMMdpEsc55BKS7ysHRpA3Sr	1490	1028	348	6301	12463	jwyZQGV6EACTSp2H3Xw3ZwpqjvDxQ3pEqLURj2uGvAEv4n8RYLb	9929	14011	14011	1618461180000	canonical
21993	3NLG8341JfdDZDbC2GVSsEDoh9BebGCEpnzVzfVmcY2n32m1Lc1N	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1553	776	403	12463	14140	jwJFdFoaYkocLqSgdkQgPrgTVrAPjfHhpYpH6njo7fvigjcRE9V	10996	15485	15485	1618726500000	orphaned
19629	3NLsyCgNsA9NA9QdS7M5P7QSUVG3bVv7hdYuj8RXq2GWHU4sDR2r	19628	3NL2L6vaCoASFe16WMFD6R3Fjsh4ZFd9RRrGaKYh1xUPHYFNQr5r	1513	1379	345	6301	12463	jwTS1f1c1T6aHGxRhnKCnsWwDcYj6Mjv7EXPxEVCAbd1qnGqt6a	9887	13953	13953	1618450740000	canonical
19632	3NK5MNapMfYG2ZkqsJHruh1fvB5H1ZEGvZuSkcuwr88vvitCDcEb	19630	3NKF4bpp3UfMURrwSQuAaetvTp94GrBKF5R5RQ57PySQQErXiUpW	1527	1293	345	6301	12463	jxZ1VDU6r39GJuA4k3ZXVrz7UsVDJtwBtWtucuFirZAZmKcfNub	9889	13956	13956	1618451280000	canonical
19634	3NKDu9k1k5NCisjSpq8SLKKePhSgrJU2RWqShxuFNaJfQc6eyyoA	19632	3NK5MNapMfYG2ZkqsJHruh1fvB5H1ZEGvZuSkcuwr88vvitCDcEb	1406	1393	345	6301	12463	jwtusQcrCPXzJP9ACQkoKdy1btcbyQvxNQNpTz2Vh59RM3EG4n5	9890	13957	13957	1618451460000	canonical
19637	3NLYbKh2cteGzJJxn8WgCuf7s7Ph22cHSzMkbK2m3APtMVyfzyQS	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	58	915	345	6301	12463	jwcJkDKW6oCaJwk5dt6vp3tP8YPqRL3xAkHbuSUrNfiihRyfre3	9892	13960	13960	1618452000000	orphaned
19643	3NLxikzyHN3yLi73DMLsBagYfD3NqZSL72ibMV9XLCZGXWao3ERE	19641	3NKtSLriLZ34ewkuQufiYGaZ8oL2bn7nxQYD394q23bZxQ7JNHaw	1422	971	345	6301	12463	jwitAR53cvdNoEd5KvJeRWxiM5q9hecawvtdudr3nPJxgSpteMb	9893	13962	13962	1618452360000	orphaned
19648	3NKUMtUg7rfcKtzg9afA5Aap3dxb82JmPYhFtp5wrfMqx645TqC5	19646	3NKtRZNH2DBqofHnUbX6EYApt4bemavTyYUfy5hkdgST2xLyiRXT	1467	1010	345	6301	12463	jwjWhdXXQZ83XTjn8Ww5KASL9D9TH71ChfVn586c3PgoHxf8PSK	9895	13966	13966	1618453080000	canonical
19653	3NKrENj3RGaacuHQbA52CbYSfG7jawNntDVDz1o6qcyW1Kz4HeL5	19650	3NKhpG6UFH1XHHtWwzzU5Gx4Q97VUjzfPEuEkj7UWB4i13PL3xVH	1675	1342	346	6301	12463	jxhbXbiWxN6WmoECuHcTsXNK6FrxRLjuggTDDKKPL9U6HUbijcZ	9898	13970	13970	1618453800000	canonical
19656	3NLBQmF8bRn5j74tp7QYGG24XQY4traAxd5Le9ohUP1u3TzoPfjn	19654	3NLWFANuggGTotm6Zrp7qNpRqjKzScdyRJ3wo9xq4L1A36ZQt5Y6	1407	1395	346	6301	12463	jxB6YJgwJguNoaQeKyxDESgv779eJiFHack25SYKrBcx6xWNrtF	9900	13972	13972	1618454160000	canonical
19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	19660	3NLdMSUavG2Bkm1rpkY42dASAYfSkoFKHhhvYNZTW2UcvrvTJ3yn	1631	794	346	6301	12463	jxdAJjpuUc22ZfQgQsSbKMmbDdyvAYsz1fymVPjsaruYJaKXkBN	9904	13977	13977	1618455060000	canonical
19663	3NLLzJdznnkucPHgm1CQqti1RkMSyRh6ks796xwXXVAvft4Tkrnq	19661	3NLH8ycWHRxa1gYSVYWjgWApGiPmu44PhjpmHnfPw13LNY3jM3am	1536	947	346	6301	12463	jxYFLwQfQEgMrgEhZXrKuPp36BScPjBmz6rnAwu2DG7QG1CrrmY	9905	13978	13978	1618455240000	orphaned
19668	3NKn6U1G6WQroVJXcU9YqDN4q5SPtP7AqyfH2rkXpbnFAH9SMrV9	19665	3NK3rfYtgTqUHmni244k7R49Cdc8ePoJzSRvzq4wcvkNTvGtqk6P	1489	1254	346	6301	12463	jwfQ4ZCtqAthusowWB1a61haRBiGFquaK6SDvW41YJsdW6RSEwW	9907	13980	13980	1618455600000	orphaned
19672	3NKQUM6PgbV6FcC4ADtBjXjvTygCQ3oF9ggitnwWj2efPLNphLFs	19667	3NKFSkk13DPhDUPpaGk8Zrsiam1NyUwAqWzVESgMYAzAkNcdW99k	555	555	346	6301	12463	jxas2SghrYMbBrpMfvq1t89qqLWnessfK9KmcpbEyc34s1MaiY5	9908	13981	13981	1618455780000	orphaned
19675	3NLAEye8rvRikQ8PoSXPN9iYXLyvScL87xaFN2iFMYEWb9VAwqaG	19673	3NL4JPKNTXDo6HsbRc26nUWvvxxw8g8mV1fKbriMRPJgcEYrCjSi	1560	1165	346	6301	12463	jwEaNUtkYTqF5zYYfdek6TedbZXy7wwWLk6462EB9KKsxJGq1g1	9910	13985	13985	1618456500000	orphaned
19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	19678	3NLdzFaTGRKQNHNc4Y1P5KMpE9X3JzGZF7jw85m1hxcc2hoDQMP3	1601	1142	347	6301	12463	jx1XdvxsNzLiWkVMfx3Srsmg8i2MnWhrqkMkTUfb8EYTHHLn8aa	9912	13987	13987	1618456860000	canonical
19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	1527	1047	347	6301	12463	jwANKmQs6yW2QGsEMxcF829HS2crVCEcT5eYHGmzWEU3PLS9swQ	9913	13988	13988	1618457040000	canonical
19682	3NLWiHywZnkusGBzz5jPz5KiV9NkpU2xkxJYSW3VDx4AbM7Wbu3r	19680	3NKcif2sMYwV6xetVN6PHSizTJv7oyUcQdnC8G7RkARXAhrqg6xz	1527	1047	347	6301	12463	jwR2hWvRdVfv6ZLzuUYVfzcvPBxeYssZqi9LuRXACWjf4uNMeGo	9913	13988	13988	1618457040000	orphaned
19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	1601	1022	347	6301	12463	jxV67F23tNu6m5bC2d4YWFv6CSBQsPGVV9eyVdEa1f2BCxmSwP7	9914	13989	13989	1618457220000	canonical
19687	3NKJSUwDxAXCvxUNK6u3oew8yaTVwPh7j45vq7TQh141pdeCBQB9	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	58	915	347	6301	12463	jwRUJfW2i5ye7E3B6bT52ETVBpLVZMGzBcyz2MLBRghxw81Zsco	9914	13989	13989	1618457220000	orphaned
19691	3NLEEv6c6e9oZgHW4gJc7VkiVxkFuVKY99aTabeD2r8gqBejf5m8	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	298	1308	347	6301	12463	jwLk5xznYxupgCujnNmFe77mrh17o3m86ZDpj38vcV2gMwDoVv7	9915	13990	13990	1618457400000	canonical
19695	3NKdFyof5nze6m4rW3TNSddJX9MyopELF8p97wkZ8X9Eez4HBGSr	19691	3NLEEv6c6e9oZgHW4gJc7VkiVxkFuVKY99aTabeD2r8gqBejf5m8	1419	813	347	6301	12463	jxi21oPUFU9XUbWQyZV8tMwm6HNVW5L4cgqZgz9U6L6o41DAupv	9916	13991	13991	1618457580000	orphaned
19698	3NKbXGgVnupMoAxjBG1zL5NsRqx8dqgrBvjQR8wa54qrcUo612cf	19697	3NLjXJgxkfCsMBD1jd5H98SroX2A1CieHF7UmmxMTyzWus2hWtfN	1407	1395	347	6301	12463	jxP7zw3iBmY7ZN7WUYZJVtFb5EBLxnENsEv1iMbTmQY2L2SZE9r	9918	13995	13995	1618458300000	canonical
19701	3NKLJRVrMsFSde1ME1etVJ6Pvny3zjjoHeBvkiEMF4xwguW2saNR	19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	1448	1065	347	6301	12463	jwQfZNZK3wvDuRJMvPFgXbKXK2KhN26rdzYK7LqtvjwLsRYWKwC	9920	13997	13997	1618458660000	orphaned
19710	3NLsrrMu4WhzhWmj4rejxnf8SCFa1Xf876jXrjyUJsVd46ryPaJy	19709	3NKHnAX8uykgbL8oVPgrZArYaivpEFQCdvRr2imqEe1XAd1chu5d	149	1283	347	6301	12463	jwSknJUZH74PfZ6b9LSMHn56PiurzGejLN57kVo8YxrwywcUfUY	9924	14003	14003	1618459740000	orphaned
19717	3NLM4jgkbtSXwm4erVSTWDo1Lk2rB45SwYwA9a57HcwTKKRGX9VF	19716	3NKjvAB7Z8Mue6iJxNc6wLpS6SGeoFBzKzPRjfjWkb1scvuUcSvC	1642	1367	348	6301	12463	jxb8KfMzdziW5cJYh9GB9NeRz3YRKwGa9vbD6ShTBnSWacLEYY2	9927	14008	14008	1618460640000	canonical
19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	641	1336	348	6301	12463	jwXT7vsBbt2iAAWDQmNixE61B7tZep3i3M2hF2mDpaWsJgvt48F	9930	14012	14012	1618461360000	canonical
19725	3NKGDVY4LdMkLMKaMSwcYDePiCUfs6rvnd1DXZJMsUpK8GU19j4E	19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	80	1273	348	6301	12463	jxaQw7t8EZCyJ4xgNi3VVzhGNo2r7HdnTD3CMANCrMeQwH2bzSe	9930	14012	14012	1618461360000	orphaned
19727	3NLhRc9jcKzVuzXEhWS4F3n3tvjXrRWhhV46k2oNpiwThnEucLy6	19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	1637	816	348	6301	12463	jxXVA3FroyLe6MRwKKYgPa8zK8ym6CeNpHoBgotPXXVj64LN8D9	9931	14014	14014	1618461720000	canonical
19729	3NLgAJPRJq4CBwAHs8sHTeZcCfMYevVm82jRYFhKqD9A1BRK4qUZ	19727	3NLhRc9jcKzVuzXEhWS4F3n3tvjXrRWhhV46k2oNpiwThnEucLy6	1637	816	348	6301	12463	jwsFUNUwdQ9SJG61sozzEFre4xyTNxvNACWsChkLYU9VPysMBmi	9932	14015	14015	1618461900000	orphaned
19731	3NLCmoYD5m43Na3GLqXewsSrwbgBEb5LwTmrKEM3UJtfcAAYzLRF	19730	3NLSb3wdHqPzVhJAcLeyBTakYxLHFFKuzr92FdcZhte2QBDfgSGd	1516	1294	348	6301	12463	jwFrj9jCCP4D6s2rybphnCeio2kGsrPmj1xbRSeXnnoLtRTsxxh	9933	14016	14016	1618462080000	canonical
21991	3NLGCS5Lffhij821qooMfQneaTGHMLLKtUPWsPbe4noFAS74SJp7	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1407	1395	403	12463	14138	jxk7C6LbTgqzU6N3p74LcExziZxUNxpx9MjTHrHBiby1sq1AaaQ	10996	15485	15485	1618726500000	orphaned
19702	3NLAJhfE1ZJGsXVVLgkffZNxAt45nvq2zZKyCFQmhm9FaSYtZ6WS	19627	3NL4LyKdTf8cYvT6k1DGeAeAsebUq7DquY55DQBFqqyVwAeCubbB	1448	1065	345	6301	12463	jxPXLccH4ZfyEVckETqqwWC5HXGv1v9bsfR5g9JyRnEJGdK5JSz	9886	13997	13997	1618458660000	orphaned
19696	3NKihFPMVpzeMj9MbpcCnykPvUxdGg2nGBpBRYSGQw9e4dVKTLiv	19691	3NLEEv6c6e9oZgHW4gJc7VkiVxkFuVKY99aTabeD2r8gqBejf5m8	1406	1393	347	6301	12463	jxovLkwzPcG34yjeppgK1tirCQie1br1t2CTKbqY6p85DrwJ6k9	9916	13991	13991	1618457580000	canonical
19699	3NKgg53kQjipDhfyZXqi8K227hd4a8uoCE8qXeeQkbiJToDWNS1R	19698	3NKbXGgVnupMoAxjBG1zL5NsRqx8dqgrBvjQR8wa54qrcUo612cf	1426	1118	347	6301	12463	jxcsX18zwDbGxKMKjzLR7AxnMNYtWbJmBJHW35mzH921JhkMxeC	9919	13996	13996	1618458480000	canonical
19704	3NLb9XHLAGGy1NvwTsHbDAeS4BYgptha5UeJodEo3pTtmyc4pDms	19703	3NKM8Z6mShYvkQUVNvN21ik9wghev6ixb1rbwgiJuXZLCCFwwqwb	1422	1337	347	6301	12463	jxaNcRmmsUV9duura7sAN9jyqZrjtkPX42dPt8txcwg73qf2S3M	9921	13999	13999	1618459020000	canonical
19706	3NKyQFPeJissGPLkCZa6DqevHUyEbjRFoiescCMC9k6Pc7xefTgi	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1458	351	347	6301	12463	jweFoWfa4bMtZCJ394ZPfBpY4PdQmpUrZPWF9xXP85G7dQaia9f	9923	14002	14002	1618459560000	orphaned
19713	3NKAgSVZjE9rCmFV82RDUmAsDodTU2kzzofDZmZLR4fw3YqQD9Aw	19712	3NKDCiEaVzpxgMdpJ5pJnhVuiv1PwdAApzHFtDP17LFj1zBqyMpE	684	1106	348	6301	12463	jwwaMHRRU5PUiJxxaA8aMaqp8Rhxyz6cQGAPowRNvUwQviZQ2Zz	9925	14004	14004	1618459920000	orphaned
19718	3NLCtkeHSiVdu1xPhZxSE9xk3J5uAGMMdpEsc55BKS7ysHRpA3Sr	19717	3NLM4jgkbtSXwm4erVSTWDo1Lk2rB45SwYwA9a57HcwTKKRGX9VF	1406	1393	348	6301	12463	jx4STayKSawzZKR1LG2tgDk5XBjKShWhUL5b9ZYAj5z3qnhXSv6	9928	14009	14009	1618460820000	canonical
19730	3NLSb3wdHqPzVhJAcLeyBTakYxLHFFKuzr92FdcZhte2QBDfgSGd	19727	3NLhRc9jcKzVuzXEhWS4F3n3tvjXrRWhhV46k2oNpiwThnEucLy6	1461	1271	348	6301	12463	jxAopLtZnoKSQHnfCGP11DjVRR7S4LQJ4dWdLKWRoU996tD7xFu	9932	14015	14015	1618461900000	canonical
19735	3NLGjVm7mcsLZNtV29gWiEnkuB2ejJ6qX5Gsa87Kowh7pLG2kcwG	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	633	1384	348	6301	12463	jwEFGrWG7W2U25NRT6QJmh43N9sQoQbK9tpZLnZyXYV5XK3RMq3	9935	14019	14019	1618462620000	orphaned
19741	3NKKutGYWRMpYu4xzGbC7ZypbKK5TYrBbVhXEEtvuptdAZEJGyrz	19740	3NKFKnmGjNWKpNQkevkKYmNvn6ZATNZPPTWsyxwheByTaydesHHC	1608	1289	348	6301	12463	jw7MMuVNdMPUv77HmAN7RBg9DwiXCHhpD4NVWDLdQaCdTEXpjx3	9937	14021	14021	1618462980000	orphaned
19743	3NL26TgVVmvvPvt3LfKRHi14K4e7PJ9aeVYbTyd9NuJzuZVweNJR	19742	3NLxDdjvSFcshxqaEe67ojL3yK8QaQk9Wjh6LdWeN9bxUMC8XdPz	1553	776	348	6301	12463	jwvRgfzUCJcbS14Rrpd9pnxzkVi5Kx5Eyc8MQMq7ofQ3Xe7EBPv	9938	14022	14022	1618463160000	canonical
19747	3NLDki4d7fek7u45kJkRg532CJpB4tZzgb9QmHRKoHfRB4eza2oW	19746	3NLvEafV4HFwEiDABjGahvH9ftFTLAYfGqZ9u34JqjshqSxCaW4M	1407	1395	348	6301	12463	jwvwh3TfRbhY9GXrNhz1VSp64SMgB9TAoL4Un9ThFbSjjW1hpKP	9942	14030	14030	1618464600000	canonical
19752	3NKbcg3Fv5q21pjBQrcJSagZVtN8qNpYtKnRvuDGc3aCMHaLsAHx	19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	633	1138	348	6301	12463	jxhpsBhrE4dk7rQJdUn5SUyf9F7cm2A5gd5eS4NCAJvgFeqj8vT	9944	14032	14032	1618464960000	orphaned
19754	3NKknxNMPZTQ9H9JxMkmUn6y1cJPT4k3He55uQvAmEYhNmXpNf2d	19751	3NKKGaunda59htQxjbPqXwsTZesu1hAgkysKCVzfsTMKBJDKPuPj	1536	1067	349	6301	12463	jxEcq8zaVDsEd4MpnnF2PBiSDda4yLbZZw8iQyHV8Jnq5AGZr3b	9945	14033	14033	1618465140000	canonical
19756	3NLRg8qNCfAwKbd1pvDtgJJFoJAi9SKoUb8mTxFuwVxAvTPSfyJQ	19754	3NKknxNMPZTQ9H9JxMkmUn6y1cJPT4k3He55uQvAmEYhNmXpNf2d	1407	1395	349	6301	12463	jwB2PuMXaGHGjnAeqjYFbrGwkxWvWZVQwgqQJhrhK8Kph7gipFb	9946	14034	14034	1618465320000	canonical
19759	3NLX7JqL8MLxf7Xj4DityG9CodHHRER351FiwSbn6VQeHiAgZm1Y	19756	3NLRg8qNCfAwKbd1pvDtgJJFoJAi9SKoUb8mTxFuwVxAvTPSfyJQ	1506	1127	349	6301	12463	jwSzfZo3ppN8Khv9ZdkejK8NsMoepAUsWJ7voMHaDpRHmZsRn8a	9947	14035	14035	1618465500000	orphaned
19761	3NK6cUASDJ1jMfxiunHP8rjooxcCrhJaQgFhPuZAie41tJf5M3uu	19760	3NLUbGZJg3HXzAuCunUbYRacAYs7QqQVMwKy4gD4BwYd18EUxx9M	1406	1393	349	6301	12463	jxmZetdH6bp81y3FodeyUKQ9ox9MxahR1WY5299TNyTsDqKLAMJ	9949	14038	14038	1618466040000	canonical
19770	3NKkEyNeDUcsqyF1aRGNHammgCox16ucWj5TCX2LNscKxC1hhd58	19767	3NKpYnFrnaB5XJYU56441miSZ8Ufye4rVpMCEXB9bobQbzXsVXA6	1611	1341	349	6301	12463	jwW6giEsGKe6sKQRTzfJWtwbFoRC5BjbEgcburcBmmyqx4B9RuN	9953	14042	14042	1618466760000	canonical
19782	3NLRnqD5q3xYjt5e8c4Z9XppZEFidfmcjhrowEqpRdwwT1fTbLcJ	19773	3NKwDyQg78RWMbxSXLahoxHZByLBPqwi8HGDukqaujpXYfRxD3Pk	1476	1371	349	6301	12463	jxwxU13RDTHQUpKSKbJxuoRaw4rqfMUSMSzxjnbyABkWPqUYPNu	9957	14055	14055	1618469100000	orphaned
19779	3NL8i6yw6GoC92zQzEUVFqYMCasjWMZR2pQv7neypzWJtr6YhT4i	19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	1419	814	349	6301	12463	jxKxbm7uvMAXgqY7y8UZthijq1d3aRty96BNrHviEYHjeCnqPQk	9960	14052	14052	1618468560000	orphaned
19787	3NKJGLmEsUUjSGPYFN5rvN99SgusopQREDTkBbKtYaLu8Va4aszq	19785	3NLEc8hbWsne7kUaQhE4Tb9U8KMsvqAvD6LHbjVKubL3nZNzF12n	1458	1323	350	6301	12463	jxNEvdGb4M5xhoyVBr5zJfCjAXPXkrjrVurckdpje2eBHF8p4kK	9964	14060	14060	1618470000000	orphaned
19789	3NLaar36LVhedcwy21kqrxPYAPNmFruW46zAdPydBB8AAVNdJaa8	19788	3NKnKLyTSMaBaQxd6jVPELcqpUm54WabuSUXwLZeMFxFZ8ZmqNrt	1402	868	350	6301	12463	jwKnpM3DvrKrmGK6uNfKb43JmvwEMYj4QKfS1wvFWp6EWvktqwr	9966	14062	14062	1618470360000	canonical
19795	3NLKtyj8zVvmU61Bq1thau58CdtCEeCtYXximHg1FRPDxsa3btjE	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1571	969	350	6301	12463	jwASxyTUGFt5sUwypYmNLZj79ywwEupvox3VKgiFkzZbKiZcA4T	9969	14065	14065	1618470900000	orphaned
19799	3NLZuD7kztMHLKTc5eovVj1woLYBAPU3AhgAfL1H8aMt53aFgibj	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1527	702	350	6301	12463	jxmN7s8Y6X9jN4cpRjYKcKLV9WxtWv69T9nV2CM8LQwr7EG8GVD	9971	14067	14067	1618471260000	orphaned
19808	3NLsjV8MLrRoqr1KCn22PqFoDQkWeLYZ5HXxbqoNq9cnCEwZLkrS	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	633	633	350	6301	12463	jwQiSCb8okcg5S1JEGLkRboMiE2ci42VZKauLh5sizkL2H7ceCq	9976	14077	14077	1618473060000	canonical
19814	3NKc3tZZWv1dRy8kZFD4SDG13DxmaRJ6j57nK5DnaPaUnyWPG5PU	19812	3NL5AtaduVnNRNRFu7gkancu1xiPTLSwfuAuWwAwcJXbMA1QUBJo	1422	1337	350	6301	12463	jxJnC2j7rXRrCmmhNLtQ6AYZKcCdxdvUzm9Kg94pxZ5dkpL6UEv	9979	14080	14080	1618473600000	canonical
19815	3NLotYLzRSZZhEDE6F8FT4RZSsig4YKUN7vTUt8ZKUsTuGyKpVrb	19814	3NKc3tZZWv1dRy8kZFD4SDG13DxmaRJ6j57nK5DnaPaUnyWPG5PU	1578	930	350	6301	12463	jy32iP1Mb9hC7pKrse134qUyJeBpW3V6gnruuJsQRvxdxrAYTab	9980	14083	14083	1618474140000	canonical
19819	3NLVfqnck1VByQwsAABppxubtgZyXvE1xGtJnGReRSP8nF3X9tJ8	19818	3NKZPdYbHNHfeTQAiZHkqEaz4rqPWWqn778F96g3BtJbhqqXo8ca	1631	794	350	6301	12463	jxiyg2AXATtpSr5tTHhaebqAXawV623z6bpve3unxnBHWCZkHy4	9983	14087	14087	1618474860000	canonical
19824	3NKHuyEy2zbskChWSMUEacjYe2CSuDRZ8P3BWwHfUd4Wm2AHwTjh	19823	3NLN4rbDdvFvfbxqS3WZXvPbZU2zBRDh85Zqv1iZCs4fJFYyRRn6	1579	1389	351	6301	12463	jxgjzjvpzonVYVNT5zCnanGLw6ZR3dsGCNHe2kyuYHKjTiMVqG1	9987	14092	14092	1618475760000	canonical
22007	3NKK56YnnbZaAJprMg6XURR5kCncXr1ida4CgQu3Sfp5SSdhjBsT	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1444	1381	403	12463	14154	jwWX31NAp2oBKVnSKAGWezWRdjM2tZRoe5XX5g83K1Mi6sDy3ps	11005	15496	15496	1618728480000	orphaned
19709	3NKHnAX8uykgbL8oVPgrZArYaivpEFQCdvRr2imqEe1XAd1chu5d	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1458	351	347	6301	12463	jweFoWfa4bMtZCJ394ZPfBpY4PdQmpUrZPWF9xXP85G7dQaia9f	9923	14002	14002	1618459560000	canonical
19711	3NKFj6bchyKs2YeSwKQGcjrnrEKm7dAdNrynCV4GUcCsQgUJoYwT	19706	3NKyQFPeJissGPLkCZa6DqevHUyEbjRFoiescCMC9k6Pc7xefTgi	149	1283	348	6301	12463	jwVwMatWDfVRTc7RB3G1FHSwb4ki3VY3SD2UT9upGs1ppJzTB9Q	9924	14003	14003	1618459740000	orphaned
19714	3NKvBDGhZ6MScF9CWySe1AbeQwWsfKtGQpkp5PDmhY5ftWhxzYdv	19712	3NKDCiEaVzpxgMdpJ5pJnhVuiv1PwdAApzHFtDP17LFj1zBqyMpE	684	1106	348	6301	12463	jwKM5a4Kwe62urDWwPsxgwi3g3cMZoQF2r4LXdzt2ye8kYCH2mz	9925	14004	14004	1618459920000	canonical
19716	3NKjvAB7Z8Mue6iJxNc6wLpS6SGeoFBzKzPRjfjWkb1scvuUcSvC	19714	3NKvBDGhZ6MScF9CWySe1AbeQwWsfKtGQpkp5PDmhY5ftWhxzYdv	1646	1354	348	6301	12463	jxY2NcMjFe4QLXdSjSorkjfmkVrWgwWAhK9CUtMJtVWr9WjXQ9B	9926	14007	14007	1618460460000	canonical
19724	3NKXo7SyTpxPAvTsG8Qcnrx1iYb6u6wmT2XsWM8F7fRC3k847fvA	19717	3NLM4jgkbtSXwm4erVSTWDo1Lk2rB45SwYwA9a57HcwTKKRGX9VF	641	1336	348	6301	12463	jxdnVXaC74GA6BAR7T4vA897X8GHL9UW51hJV5ErmZkJdthPJgL	9928	14012	14012	1618461360000	orphaned
19719	3NKTa2mu46b45ie7YkwnRdeKJNB78NHoEkr1A7BKX5iMM5C5CLXU	19718	3NLCtkeHSiVdu1xPhZxSE9xk3J5uAGMMdpEsc55BKS7ysHRpA3Sr	1490	1028	348	6301	12463	jwtsNuEfw4mN9gagWhiujJ4LNS5FRivNZUUMT6sbSRBySVw2npx	9929	14011	14011	1618461180000	orphaned
19721	3NLSdqn4ffaXaqMh5HBP6ktbZCi4kJeWw3fC1pJ6z7Y9yFhASq66	19720	3NKB9EGnfvzTv8yTZ8y5h2tutV1jT5P2exGxr1RmAZLDURet4vAp	80	1273	348	6301	12463	jwypB11AqaaamKuorKeJMm5ukF2FyhVdjWkkjphAR7KxKsQCMF9	9930	14012	14012	1618461360000	orphaned
19728	3NKHF3mybHdFkbGMAKWSSKv8BJZQ4UBii4wV6b7EjE1oi5F5qc8p	19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	1631	794	348	6301	12463	jx3MUoyns2cWRnjg8jTSXSUMpcjFVnCkerhRjkJVsybAiEnnRQd	9931	14014	14014	1618461720000	orphaned
19732	3NLj5fRFBxDYkEoWH87q27YH97HUzQJsmFMbBJgXjWhc5eSPpFnw	19730	3NLSb3wdHqPzVhJAcLeyBTakYxLHFFKuzr92FdcZhte2QBDfgSGd	1501	1114	348	6301	12463	jwQNeZ5K1Qc4Vajn1tXYTM59TWqxaZwFds6NSPP9gZ2PfLNTecB	9933	14016	14016	1618462080000	orphaned
19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	19731	3NLCmoYD5m43Na3GLqXewsSrwbgBEb5LwTmrKEM3UJtfcAAYzLRF	1600	50	348	6301	12463	jwpKd6pNmyxxFvKsquTLriyT5BG15mcrT3hEzThCG3dw8BorekR	9934	14018	14018	1618462440000	canonical
19736	3NKkDfyZstaKpnunLLQwCUHBfULHoxS9Cx4mgdxnJ21xZn4UTra2	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	633	1384	348	6301	12463	jxRu2EqucG4141a2vND2ed3qTpop5u2v5eqi92PDaGtVNVPieoy	9935	14019	14019	1618462620000	orphaned
19740	3NKFKnmGjNWKpNQkevkKYmNvn6ZATNZPPTWsyxwheByTaydesHHC	19734	3NL4n75xF6fAK5bhBmCEeMCSHEQfRAaE4jMcW8mPKJJDpjwVQJCe	1406	1393	348	6301	12463	jwsnhnA6XjcefydSXzxKJKfwY85V53n1CB8wWhBmvq37MbJBA16	9936	14020	14020	1618462800000	canonical
19739	3NLFuaissEoEWRC2b4QXE93fLW8RVVaSL5X3VKipmf6r2rNpG5FB	19734	3NL4n75xF6fAK5bhBmCEeMCSHEQfRAaE4jMcW8mPKJJDpjwVQJCe	1483	1030	348	6301	12463	jwjmDTy6iyBZEiMrAqnV2spkyQHqPETtw1oMuN3MpdugGFKXghn	9936	14020	14020	1618462800000	orphaned
19742	3NLxDdjvSFcshxqaEe67ojL3yK8QaQk9Wjh6LdWeN9bxUMC8XdPz	19740	3NKFKnmGjNWKpNQkevkKYmNvn6ZATNZPPTWsyxwheByTaydesHHC	1599	1161	348	6301	12463	jwWTBRPYGQvaFscPp5cK2puEQ5eChqcFcN159rsZNEfJaSFs2B7	9937	14021	14021	1618462980000	canonical
19744	3NLcsQV7kZdSBSuft8C8CSUUsNPfy1RGySuPbLxiNwVaKtTZmYqF	19743	3NL26TgVVmvvPvt3LfKRHi14K4e7PJ9aeVYbTyd9NuJzuZVweNJR	596	596	348	6301	12463	jxhUYqwcLKLySVmXirjt8hSQ1eCZNaT1UgeGyFRBN9NmCnJLY51	9939	14024	14024	1618463520000	canonical
19745	3NKQzu8JdN1XXSUwwkpS516WzQPdt8nxnzvbzMSqhLqHfgAgqHXk	19744	3NLcsQV7kZdSBSuft8C8CSUUsNPfy1RGySuPbLxiNwVaKtTZmYqF	1406	1393	348	6301	12463	jxH3gBgtSFrE8xRs6F3H2mPcbcCTWePkQBrVoM574ZgSt51s9fd	9940	14028	14028	1618464240000	canonical
19748	3NK53bgfMSjAy2ykvYkux1h9h6NV3tcVGAckrXCoMJ5aNhw2gxyY	19746	3NLvEafV4HFwEiDABjGahvH9ftFTLAYfGqZ9u34JqjshqSxCaW4M	1406	1393	348	6301	12463	jxoAr7yEYsXvAfqEkVhx8Q4McR1vndKKZLmGhBZNcRGqm1UsDzd	9942	14030	14030	1618464600000	orphaned
19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	19747	3NLDki4d7fek7u45kJkRg532CJpB4tZzgb9QmHRKoHfRB4eza2oW	632	1382	348	6301	12463	jwGQcHUxe6Xfw6YcghCv6PAxwh2rC95A12XiJsyZWLCAWG9NAZd	9943	14031	14031	1618464780000	canonical
19753	3NKihEKygs1cHdqJXQQxmV8pCXHhUjCcBuWW9EHq8nfQrtmB47zc	19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	1637	816	349	6301	12463	jwHJpBVsrQsjvmjTbDJ9t956ojUXCFLoT6WLYYjxVWtQBryZ12j	9944	14032	14032	1618464960000	orphaned
19755	3NLNuqY7FWy84V1XCLGoNTjfpGXGdLAxRPeSeMUR5P2yt6UMfKNn	19751	3NKKGaunda59htQxjbPqXwsTZesu1hAgkysKCVzfsTMKBJDKPuPj	1536	1067	349	6301	12463	jwmDMvfjX8YLLt84osb7btn1hhnQqD69T8DrimvLoaHf9tcbSai	9945	14033	14033	1618465140000	orphaned
19762	3NL2V36JDv31sMMvVSy8PFJajhJPadqmFcRLuYSyyC6t2UAYRXTq	19761	3NK6cUASDJ1jMfxiunHP8rjooxcCrhJaQgFhPuZAie41tJf5M3uu	1624	1088	349	6301	12463	jxRK6pmCUghTsYUQ6gmb16Ucg4NX19Sy8894ULFLc4n6BLzEc2j	9950	14039	14039	1618466220000	canonical
19764	3NKccGbfsunFws6CqEWTnypuoMxupSU31i3sbZ9BGKAFbijNFqDm	19762	3NL2V36JDv31sMMvVSy8PFJajhJPadqmFcRLuYSyyC6t2UAYRXTq	1560	925	349	6301	12463	jxHGLtAkA4dH1VXPssqd7FnUHbttbycLApCHh9NMnqxSJZGBhHV	9951	14040	14040	1618466400000	canonical
19771	3NLDhe74uJ8RVUPa5JZ91hj8RCiLFuZG5pTPGYubg3BWZYFq6Zk2	19770	3NKkEyNeDUcsqyF1aRGNHammgCox16ucWj5TCX2LNscKxC1hhd58	1490	908	349	6301	12463	jwJbEAqHhDK1wwuSK71mZUmkSXSUHUGW5dLt52tbHsEcVhN3Adj	9954	14043	14043	1618466940000	canonical
19774	3NLi2N1uAuQT6X9Y1oDZKB2Xqanjz2MawUNGzeDKk2jPvMzHs5GA	19773	3NKwDyQg78RWMbxSXLahoxHZByLBPqwi8HGDukqaujpXYfRxD3Pk	1421	508	349	6301	12463	jxiFt9eHuaHuzWsQcnkPtrLq254Tv61VB6A8c2Jg4mfkxu4F5P6	9957	14048	14048	1618467840000	canonical
19784	3NKc8ndK6CnBhXkUVqKPvAxJnVjgh2n6pQvQw3YAEKGEGt5tdc1f	19781	3NKka51tixPPBUd4MeJ7RZnJjbqceBHek3W5xfB8XB4RPDpSA7TA	1513	1379	349	6301	12463	jxuyxGDAmEzKRe2GodaZWoqgqf1LURyPJC4fGvUsjJYbX4do1wf	9962	14056	14056	1618469280000	canonical
19790	3NKfWzhYQVU4dy4UZxkqz9tN1JAs3CD29gL5dUbvgetbG5VivzoQ	19789	3NLaar36LVhedcwy21kqrxPYAPNmFruW46zAdPydBB8AAVNdJaa8	1406	1393	350	6301	12463	jw8kYVezoqHD9S6axYDsejsPRYa47RuVMabnxmc4vBaMhhZLguf	9967	14063	14063	1618470540000	orphaned
19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	19791	3NKCCFV287ccQTiBadoLynmAMJ9dCoEFXbgGkttYMts5FaEgQkN7	369	1312	350	6301	12463	jxM64PFhonK1fk1RRHMQ54wgoqV23bUxvh7sV2J8BKiQNqrHbBW	9968	14064	14064	1618470720000	canonical
19809	3NKLpRLZ3HLE6ihxrXyvzTU2Nb2EqB39wTys8Cs7iobyhdrSS9RU	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	1623	839	350	6301	12463	jxwQNupnwXR7FGbwikWMZGfmvX2vARCzHQq1PBCs4sd4A8ehoXL	9976	14077	14077	1618473060000	orphaned
19817	3NLW8CRzdV4VgF75Wkwifdom5DtExZaMG5R7cveJopTd3pbtY5pY	19816	3NLs3Akv3SGbksP95RMf3ttBc8ULon2TU7RWARdsuWuhnx5xjNVP	1637	816	350	6301	12463	jxeVE9gHgggdxhAquhtTyhrSyK4h4ERXQxwnPstVxKV3MNF7XMr	9982	14086	14086	1618474680000	orphaned
22006	3NKTMoUupYfFr9GUPgeT6tq4Qi8nn1bSNxvfZFN1PRDYgMz28LFE	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1403	824	403	12463	14153	jx6VN1RDcmepj3qeb9NyiGdbTRuQyVKUmhFPuZ3gRWfox5hhCxe	11005	15496	15496	1618728480000	orphaned
19749	3NL3BYScVgwu6mig7HAVXvF3XSPNkAHAgUmS7gQrwPSwz6yxPizV	19710	3NLsrrMu4WhzhWmj4rejxnf8SCFa1Xf876jXrjyUJsVd46ryPaJy	632	1382	348	6301	12463	jwgWpUnZWVfPzhcHgGjYPoPbc5AtyB7ArmvsAL9jSBjPzpnrD8C	9925	14031	14031	1618464780000	orphaned
19734	3NL4n75xF6fAK5bhBmCEeMCSHEQfRAaE4jMcW8mPKJJDpjwVQJCe	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	1534	1071	348	6301	12463	jwot6K7epzLjU1mv4ESXnCSMoVwxRF73qhWEZ5Jv6KzQHwu1GmF	9935	14019	14019	1618462620000	canonical
19746	3NLvEafV4HFwEiDABjGahvH9ftFTLAYfGqZ9u34JqjshqSxCaW4M	19745	3NKQzu8JdN1XXSUwwkpS516WzQPdt8nxnzvbzMSqhLqHfgAgqHXk	1405	873	348	6301	12463	jwk9wVJYDbyR7LPsiZhL1YANV3nDNwfXUXZVTbbPPAVHdSu83fV	9941	14029	14029	1618464420000	canonical
19751	3NKKGaunda59htQxjbPqXwsTZesu1hAgkysKCVzfsTMKBJDKPuPj	19750	3NLJC2EJAKrvuz2Nihr1BRWaAniE2WQDNa1Pa3Jt9iAV5roL18ao	633	1138	349	6301	12463	jwqqvLzEB29z8pJ47FXYMFBZXhcUM7U49qMiR9RtWqfeVNeXh5z	9944	14032	14032	1618464960000	canonical
19767	3NKpYnFrnaB5XJYU56441miSZ8Ufye4rVpMCEXB9bobQbzXsVXA6	19764	3NKccGbfsunFws6CqEWTnypuoMxupSU31i3sbZ9BGKAFbijNFqDm	641	1090	349	6301	12463	jwvzc87Hm4Lhoe71EB46rtCBZQD9MqmwiXfS6E5umM6gzjW6Hxv	9952	14041	14041	1618466580000	canonical
19765	3NKHBXudXT8fXihJBZvuiN1rn5j2U5uH3tdh4xCZwSc9dpn3hfUc	19764	3NKccGbfsunFws6CqEWTnypuoMxupSU31i3sbZ9BGKAFbijNFqDm	44	1325	349	6301	12463	jwsZ2ue5SCJafJUgwUswDYyp3stMPruAuVR6ipk8HcUiCDehzrB	9952	14041	14041	1618466580000	orphaned
19769	3NKjfhyTtU2nfUhXoudtrJEtbsd7zRWtYdNMTkhwrQ8zi4EU6AJH	19767	3NKpYnFrnaB5XJYU56441miSZ8Ufye4rVpMCEXB9bobQbzXsVXA6	1407	1395	349	6301	12463	jxVwGpWr77D5d1WRbBruHhzFag6NiMdgoabJmrvKqCA8ztgzz7f	9953	14042	14042	1618466760000	orphaned
19772	3NK7sKv2VTScnkeGCzjsUeuiicAYvAr5ZK5vJmAw1W9enKt6E95J	19771	3NLDhe74uJ8RVUPa5JZ91hj8RCiLFuZG5pTPGYubg3BWZYFq6Zk2	1599	1287	349	6301	12463	jx7y5GJx7yHoMf4tTgTwBECN1jxQgWDUhfQKt4MRahS8bbpzkfu	9955	14045	14045	1618467300000	canonical
19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	19775	3NKBkWhpEgzacU2M8JGECbrMq6ZoEAowWFthvdbTGkDdSCdn1m2W	1406	1393	349	6301	12463	jwNCDQotBHzxiDgPJMY7j5JanAv1XHJBVvM3PeoDNExXhiNDzNm	9959	14050	14050	1618468200000	canonical
19780	3NKJzh4Ue7HU8yC2zeNVWLaBtrbX4N3VkYirDbrs7BGSfHg4rGE4	19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	1407	1395	349	6301	12463	jxV7ZCojGAKFEvXUpYh4FKyav1zgaRbGGcAgJNWdvbGsHxwW1rd	9960	14052	14052	1618468560000	canonical
19785	3NLEc8hbWsne7kUaQhE4Tb9U8KMsvqAvD6LHbjVKubL3nZNzF12n	19784	3NKc8ndK6CnBhXkUVqKPvAxJnVjgh2n6pQvQw3YAEKGEGt5tdc1f	1581	778	349	6301	12463	jwPYr1Z8Ph1B6k3Mg4SnLNgn5tvAGJNuC6wDZaXPW76W93ES1vm	9963	14058	14058	1618469640000	canonical
19788	3NKnKLyTSMaBaQxd6jVPELcqpUm54WabuSUXwLZeMFxFZ8ZmqNrt	19786	3NLRjDFkVKsywN946nRfXmEUXDZ1NznFRsEaqLrRDVjYiBDiXLws	1406	1393	350	6301	12463	jwNkZR1sdMJKLrynTVedHb4mZ648FLNSAHdNjKaBayRFsXGFhMp	9965	14061	14061	1618470180000	canonical
19796	3NKbpcaeiRQuRtuhwJtbA8SbKbemBne8dmKUXKESEH5ukGb8LB7V	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1605	166	350	6301	12463	jwf1LrrEsSM2LCBtPqsdUfb2dMBuwkXXgFGyZKGDnZJ8CbeaZUQ	9969	14065	14065	1618470900000	canonical
19793	3NLhrd71PvVYpb2HjQZjwJofxswtZnLuPgseicnbX2VQf6n6WDHk	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1605	166	350	6301	12463	jxBKvZhapwjgb4E9g88mEfdzEpukYZYG2iezr9fst98SQBAGANL	9969	14065	14065	1618470900000	orphaned
19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	19796	3NKbpcaeiRQuRtuhwJtbA8SbKbemBne8dmKUXKESEH5ukGb8LB7V	1402	852	350	6301	12463	jwLXr719XuuwSedL8as6bXjev2xyQJ8JSdRzVCEeAammP3nu1re	9970	14066	14066	1618471080000	canonical
19802	3NLKGhTuKVAUHNfDyRC6fKaA9wvmeWTMxMeCsqw8zp4GbAQ7TLgc	19800	3NKjrgosMJnYpEBeqDDmZJiojEBwKVQhf6cZVycy2Dhwf6yMGVac	1407	1395	350	6301	12463	jxafWJm8ikygzspqdfVGioP5LRPGCHkE5wB48Xyd6iSVzzeYWTq	9972	14069	14069	1618471620000	canonical
19803	3NKx1JEKPHso7QGLcSLAhXaSb1XjgCCM5MF3ZehnvQtHAtnXdSio	19802	3NLKGhTuKVAUHNfDyRC6fKaA9wvmeWTMxMeCsqw8zp4GbAQ7TLgc	1467	1130	350	6301	12463	jwAqXZd4q9PM2rbqw1hnVAsF31yVQZDwxgw1PuqLAvtegnr3yTW	9973	14073	14073	1618472340000	canonical
19805	3NLBmmRa8VH1aG2R4v4qgpwTBsWsCGGN2ZmdrGPhoVxhvAcoeQwo	19803	3NKx1JEKPHso7QGLcSLAhXaSb1XjgCCM5MF3ZehnvQtHAtnXdSio	1407	1395	350	6301	12463	jx32PfQCLKzEz2WNoxHLJB3FcUTo2JsEs5Z3hqb4tw4hAMgjwtQ	9974	14074	14074	1618472520000	canonical
19810	3NL3guE3wPy49ouuWyGxpENvUBw2o4oBLnue5HDNAYfEeycHLLko	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	243	243	350	6301	12463	jwSXfCByqsoyJu6Hcr6sHjudcitLYx9ctBLQCuJXoKrsukXMy6P	9976	14077	14077	1618473060000	orphaned
19818	3NKZPdYbHNHfeTQAiZHkqEaz4rqPWWqn778F96g3BtJbhqqXo8ca	19816	3NLs3Akv3SGbksP95RMf3ttBc8ULon2TU7RWARdsuWuhnx5xjNVP	1407	1395	350	6301	12463	jx2mi7VaKgfWAkDh3m6wZWYQ2rTjJA2Nk2eeCBmtam9TgowNnRf	9982	14086	14086	1618474680000	canonical
19823	3NLN4rbDdvFvfbxqS3WZXvPbZU2zBRDh85Zqv1iZCs4fJFYyRRn6	19822	3NKrxKGr3JpYT2CzAFUeUb89ae6MFMsVWFX1QLYqYNJp1ffHR4ej	1403	824	351	6301	12463	jxWAzfCF3ckv33SSbPcQkVUU3mZse8n49cSr4ABQhJM1NPo2jGf	9986	14091	14091	1618475580000	canonical
19828	3NKSj9ZRtZq9XCKkbf1a5s5YHWUMJkpLtp6irQKMPMKi24dU9yLi	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1423	561	351	6301	12463	jwT74c4UuYr5KqXMDdHkd8GVTTGCcCMB6gtKnas4v4vp7DSviD1	9989	14094	14094	1618476120000	canonical
19831	3NLigkzhcpMpL8ebr3SfAQQ6TfzgJd7MPPCtM1KNwyKk6qLYVaD5	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1577	1201	351	6301	12463	jxAxkPoZ2HJtHhk3bwVvuKmnCtL2XLBTQeBVCj8XUKkCNEydGJG	9989	14094	14094	1618476120000	orphaned
19832	3NLAu3PFHBSzvrXtUMRJLfgRbex1JQxBpegr1h2mPJ8MPptRxWHm	19828	3NKSj9ZRtZq9XCKkbf1a5s5YHWUMJkpLtp6irQKMPMKi24dU9yLi	1637	816	351	6301	12463	jwaEAB5cnfFarYyuJjmiMF7TyEYuR8ezQrayFYSM884NyPR7x8W	9990	14095	14095	1618476300000	canonical
19834	3NK9ELhG8R1oqSmtpvCiLgEvmQekyJ9sv7bfzCTZdyd7kUoMUP3c	19832	3NLAu3PFHBSzvrXtUMRJLfgRbex1JQxBpegr1h2mPJ8MPptRxWHm	1457	1025	351	6301	12463	jxxanFeoFzQbetbhY3xEQWmbkN6R3g579RSUQLyCQje3WE8vUfM	9991	14096	14096	1618476480000	canonical
19837	3NKiHSvFR4k5iNXLMjrdQm23gUcmTwivf4dC4Va7Rn3zjmjQXdgt	19836	3NKfdnW8uY2CgpsubUKT2K8kLXFFa4HhmkCgbmBQkKvXKcuNf41d	1656	1097	351	6301	12463	jxHQ2P7suYie3TEbmFXW2zkBjkoPA8YaFgtVb8YMtjqsAL4JcsX	9994	14099	14099	1618477020000	canonical
19839	3NLoTex5WS72VpQkqZqVTkgxTbMq4Gm6ABLebiju158dZTB5jrFW	19837	3NKiHSvFR4k5iNXLMjrdQm23gUcmTwivf4dC4Va7Rn3zjmjQXdgt	1447	1345	351	6301	12463	jxT3RhuSL65G8RznjSMSmNrkNNVoJRYugvB2xfETkM29ffEKE7T	9995	14100	14100	1618477200000	canonical
19845	3NLsNLbpJGYkGYWVMPUfRoxkdi7PDrtpJRJBAhh94qtpLJ5FwRNK	19840	3NKdioMLUnWMaAfCRSN7xDXGhYE4HFZXnncg7W4goigLCsGRK2oE	1619	1149	351	6301	12463	jwd5wQeDHF2KgUe6hwzqsYEFqAS7UYbVLtF8t4pMS7HWaCE6mRG	9997	14102	14102	1618477560000	orphaned
19846	3NKrd5saMRPLRLXBZoN7wfxbwNhJVB5t2ksK4dVXatCKhYC1CK7o	19842	3NLmHHjWp7vGwrMFrsYYYW3MJLBaRneSZLohGHhsAvGgEH1J4RbE	532	1303	351	6301	12463	jw99hmX8kUpDAXWzEQBGg93TVsdnm6Gey5RXUSYh5ZBBHkBSws9	9998	14104	14104	1618477920000	canonical
22399	3NKVpfbzN7sh97EQJ5fgeAxuQ74FizLXFL7pYJYwP83saHCJjvNq	22249	3NLGkhJ3SgVUbXieh68gobTU4aT8qBVu9Ge3cAY157Q8M7tqMNra	1516	1294	405	12463	14514	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11009	15786	15786	1618780680000	orphaned
19768	3NLJPPEMgyGbvSjtrrhdiwWPoNvm2weoJHMJ1pmxhNuZiuRbkoFf	19724	3NKXo7SyTpxPAvTsG8Qcnrx1iYb6u6wmT2XsWM8F7fRC3k847fvA	641	1090	348	6301	12463	jwCJUKZZwwJeLDtvKYxEZ6Q8G5Yx7FhgP6AEbWvuxmBC1TXgm6J	9929	14041	14041	1618466580000	orphaned
19763	3NKiAijJ8MfLDDFAUiNEpMZXMmr6iWrAPD7fWkCYd7aS8i2pVyj3	19732	3NLj5fRFBxDYkEoWH87q27YH97HUzQJsmFMbBJgXjWhc5eSPpFnw	1560	925	348	6301	12463	jweRSzeggs2cYQ2EL89VTsSCPNpCtrsKYVhVB5ownGp9Tq2aHTm	9934	14040	14040	1618466400000	orphaned
19758	3NKs41WVupHK5YUjpdrGQyvyfjeRkd3HxuxXywVE6uSz2c26qrkx	19756	3NLRg8qNCfAwKbd1pvDtgJJFoJAi9SKoUb8mTxFuwVxAvTPSfyJQ	1588	1266	349	6301	12463	jxhKCBxW88Xau9oJCv39A313Vzpfr5D1mFHhijnXy4aB7HYoPeh	9947	14035	14035	1618465500000	canonical
19760	3NLUbGZJg3HXzAuCunUbYRacAYs7QqQVMwKy4gD4BwYd18EUxx9M	19758	3NKs41WVupHK5YUjpdrGQyvyfjeRkd3HxuxXywVE6uSz2c26qrkx	1637	816	349	6301	12463	jx3MhcZZdVTcH7XCTrxZNjQZ2EnJbUuu8qEtYBHRryz5srNdGzD	9948	14036	14036	1618465680000	canonical
19821	3NKZg2ttisyVftpu12SB65c5ZddgfYAW9PJ3KWDFYJw7wUSuarBs	19771	3NLDhe74uJ8RVUPa5JZ91hj8RCiLFuZG5pTPGYubg3BWZYFq6Zk2	1555	1347	349	6301	12463	jxy4wwAQHQ6JYbGZEVfMLbSXS984thXNNroPm7nsT7hjbrSLa3W	9955	14090	14090	1618475400000	orphaned
19773	3NKwDyQg78RWMbxSXLahoxHZByLBPqwi8HGDukqaujpXYfRxD3Pk	19772	3NK7sKv2VTScnkeGCzjsUeuiicAYvAr5ZK5vJmAw1W9enKt6E95J	1405	851	349	6301	12463	jxkJbskZpZnhVxLVebH9NnsVaqCN4kaKkhh6nVd6J6pmVhrh1fT	9956	14047	14047	1618467660000	canonical
19776	3NLmAX92racMwR56iuNBnX16Xw8UyViK94vfsLRksgAZke6weAVp	19774	3NLi2N1uAuQT6X9Y1oDZKB2Xqanjz2MawUNGzeDKk2jPvMzHs5GA	1522	1196	349	6301	12463	jwxyDSoKRzhUV98Qy2JyMJkKCawUCKzbAz3juWL7WAfNuSdyKvN	9958	14049	14049	1618468020000	orphaned
19778	3NKJRBsFWrFnzYjWpK8YV6zd6oBCw71RR4ZBNbanysG7w5Aw9yow	19777	3NLKNhbjksApXfwG3uQhHqXBegpFDd5gWNKEZvxQxFGWfbL5Kqup	1490	1028	349	6301	12463	jwcCagCBEJK2vGEnkxRyva9qh1BWvLiQrsLXNRD8bZteJZJvxa8	9960	14052	14052	1618468560000	orphaned
19783	3NKM1bwHzk5b3gL6NpVBAStmavRvmNFECPEuj1c3gZtXEZjWbPcZ	19781	3NKka51tixPPBUd4MeJ7RZnJjbqceBHek3W5xfB8XB4RPDpSA7TA	149	1037	349	6301	12463	jxhfwYFJNbMqvJ1h8uUoVHmmLp3HinPR3qs896owhSYJCL6WR9c	9962	14056	14056	1618469280000	orphaned
19786	3NLRjDFkVKsywN946nRfXmEUXDZ1NznFRsEaqLrRDVjYiBDiXLws	19785	3NLEc8hbWsne7kUaQhE4Tb9U8KMsvqAvD6LHbjVKubL3nZNzF12n	1622	1356	350	6301	12463	jwDUcJoe6K5nfCHyDTVraXg51YMn1HJiSWDRe1eRLKMTkyWpFgp	9964	14060	14060	1618470000000	canonical
19791	3NKCCFV287ccQTiBadoLynmAMJ9dCoEFXbgGkttYMts5FaEgQkN7	19789	3NLaar36LVhedcwy21kqrxPYAPNmFruW46zAdPydBB8AAVNdJaa8	1513	1379	350	6301	12463	jxZGd5wQPaYo44Tqzw7U8QdrbVUNMVHEpbo5eZTpiC7yYfocAca	9967	14063	14063	1618470540000	canonical
19794	3NLPKMpVLRYdbFwBULGM5XoxcCeh7EFL71EK69kSZYke33Hv4srS	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	1403	824	350	6301	12463	jwPhmanxvRCaGsG9qdcRu1eaUZGuiCQJH8rVQKHee43jgvJuXSu	9969	14065	14065	1618470900000	orphaned
19800	3NKjrgosMJnYpEBeqDDmZJiojEBwKVQhf6cZVycy2Dhwf6yMGVac	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1527	702	350	6301	12463	jxK2oWP3CA5VRRNkQ3JmbrLcYY1KnMVvXdZX9uCwwdBkn1h5vMu	9971	14067	14067	1618471260000	canonical
19798	3NL9zE2s2yEvLzD1UW1sLi6hc8gKLuxU7yDw6BC4coR9FmZnvmu2	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1593	980	350	6301	12463	jxPMNZ5RV39G3gKFhk58F1DCo5weai8S3Lr6mavaRLf2JC792YA	9971	14067	14067	1618471260000	orphaned
19804	3NKs1fh4wW9KxJkBac4FM1m145i9QeNkXvQWWZ8F59ik7uQXwm9y	19802	3NLKGhTuKVAUHNfDyRC6fKaA9wvmeWTMxMeCsqw8zp4GbAQ7TLgc	1483	1150	350	6301	12463	jwTFhW2tnkjXd2tUWc5vAoWxpmmf88r4yZrQUJDQV589qmvXau2	9973	14073	14073	1618472340000	orphaned
19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	19805	3NLBmmRa8VH1aG2R4v4qgpwTBsWsCGGN2ZmdrGPhoVxhvAcoeQwo	1515	287	350	6301	12463	jwawntwnZz8ZQ4J6HRLuQ99gZtTHbKfpdJPSi4zePnfxtYQw5eB	9975	14076	14076	1618472880000	canonical
19807	3NKGQedEkygoK3BEBZsDfwGBUPxK7PfNJ6Tys8TTkjnLaqTpx7QM	19806	3NKQZPUvEAFnHetM1bHU3P2UNLuYx8LaoxJv17Vs47x2VXh4vq9F	1405	851	350	6301	12463	jwBf1J5V5HD6qA4peTbw1UW5cXujjZrJwdza6zUPmYoX9wSxnv5	9976	14077	14077	1618473060000	orphaned
19811	3NLMK15oge6Ky1bMnunNZ6CWztd6bYEQUTyDva6WskbDHdzREKXo	19808	3NLsjV8MLrRoqr1KCn22PqFoDQkWeLYZ5HXxbqoNq9cnCEwZLkrS	1407	1395	350	6301	12463	jx41pawa2asRnQXmMFfQttNuBJRWGW21dBiGDDDdx49gH3tXXX5	9977	14078	14078	1618473240000	canonical
19812	3NL5AtaduVnNRNRFu7gkancu1xiPTLSwfuAuWwAwcJXbMA1QUBJo	19811	3NLMK15oge6Ky1bMnunNZ6CWztd6bYEQUTyDva6WskbDHdzREKXo	1477	1350	350	6301	12463	jwW2f1hCob1gCUG22XmmCGPcEJJTJQucg6HbF6H78Ws59rfGYp3	9978	14079	14079	1618473420000	canonical
19813	3NKtBcQT2vbwz6oqxTjzyCEGnKbhKofwytxYQYShZCcJdSx2xUab	19812	3NL5AtaduVnNRNRFu7gkancu1xiPTLSwfuAuWwAwcJXbMA1QUBJo	1529	1316	350	6301	12463	jx1vs9s3qD4SRr4mE51r1ucxs7vt3p7DcCvCpTm41u3rJYntz8n	9979	14080	14080	1618473600000	orphaned
19816	3NLs3Akv3SGbksP95RMf3ttBc8ULon2TU7RWARdsuWuhnx5xjNVP	19815	3NLotYLzRSZZhEDE6F8FT4RZSsig4YKUN7vTUt8ZKUsTuGyKpVrb	606	929	350	6301	12463	jxeBD7YWphYUPSwWHdPAzKuVkb4Pt7WhArG6NNpSnSbbkQLBQXw	9981	14085	14085	1618474500000	canonical
19820	3NKR3LoD3TLQ4Gotmhg59xUYcuq9hwVMuEujT99QywJhkDTYWwDy	19819	3NLVfqnck1VByQwsAABppxubtgZyXvE1xGtJnGReRSP8nF3X9tJ8	1403	824	350	6301	12463	jwqUHVsZfVd5Zrne9VqvT9KM37TR9XPj6Qe5dcnGtzHi7XPnWC3	9984	14089	14089	1618475220000	canonical
19822	3NKrxKGr3JpYT2CzAFUeUb89ae6MFMsVWFX1QLYqYNJp1ffHR4ej	19820	3NKR3LoD3TLQ4Gotmhg59xUYcuq9hwVMuEujT99QywJhkDTYWwDy	1555	1347	351	6301	12463	jy2QVgpV4ybF5v4Znhw38VWbEy5SdX66KJTQrk9Wwk9DkEP1vHd	9985	14090	14090	1618475400000	canonical
19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	19824	3NKHuyEy2zbskChWSMUEacjYe2CSuDRZ8P3BWwHfUd4Wm2AHwTjh	1397	699	351	6301	12463	jwYz1XQFt4vYLjLAMVdkgkaP8xkWRdKEw14X9BqpQF9s3ABa4K9	9988	14093	14093	1618475940000	canonical
19826	3NLMm2S9zPUUEFyyySmhuQ3t4TarA1LrDK1LYPeagCzmvXSYj2uk	19824	3NKHuyEy2zbskChWSMUEacjYe2CSuDRZ8P3BWwHfUd4Wm2AHwTjh	1631	794	351	6301	12463	jxvaQpZ14j7YGgUEJCmZHKpCZkfDR2atCD4LjwYXYFfwLbcN1aE	9988	14093	14093	1618475940000	orphaned
19829	3NKGz3HFZx1HccbFznsfY7bunyG6aPzywFC9ftj3X4TuPwspUuCX	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1476	1125	351	6301	12463	jxzKMKkhxiizL3gHwLjRJPp75rnaSJcPk6VbPeCEL5reqwZRZKw	9989	14094	14094	1618476120000	orphaned
19835	3NLtVqfra25CqZGXeHF1HH5XthLYeqqLYvnt3Q2GLmviMyy5nBwo	19834	3NK9ELhG8R1oqSmtpvCiLgEvmQekyJ9sv7bfzCTZdyd7kUoMUP3c	1402	882	351	6301	12463	jx1h6U15J69XwzzpH6NmthG7uhN22GsimrDNR1fFFiPVG4XTcPv	9992	14097	14097	1618476660000	canonical
19838	3NKnpRrkaoLtsJL7xdsMVMxFPdsMK3HwtdvYzsTg13wJ9vzyLiwQ	19836	3NKfdnW8uY2CgpsubUKT2K8kLXFFa4HhmkCgbmBQkKvXKcuNf41d	58	1155	351	6301	12463	jxsqokZPQMTjXCmspcG4e8kTv3QZNw2Z3cKWnQsUiH1BqX4MPBL	9994	14099	14099	1618477020000	orphaned
19840	3NKdioMLUnWMaAfCRSN7xDXGhYE4HFZXnncg7W4goigLCsGRK2oE	19839	3NLoTex5WS72VpQkqZqVTkgxTbMq4Gm6ABLebiju158dZTB5jrFW	1402	1267	351	6301	12463	jxhpPGgdtWbe6W4otVDJGxQsyYL7fB1dvNrmWBauKdvgNhBuWws	9996	14101	14101	1618477380000	orphaned
22022	3NKXhVMrHsw4AhLZoxAfb2YstUZgPKJTz9qgdrtTMvsmFBzZByrA	22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	1407	1395	404	12463	14165	jxgTKxc5ySa7j7zW8kSRdeCYWU8GUnUkbsKmDYPGDmioEZgYNCQ	11010	15501	15501	1618729380000	orphaned
19830	3NLuViLZZ36gLUDDFJ2hXqcZs2J7H1YpLk2SSfeQDWiXnwJ2wmtM	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1601	1388	351	6301	12463	jwJCwwpdhFR9biKJQmrJdKUARp2kzcnNtRvmMF7cp5rvRJf5s8y	9989	14094	14094	1618476120000	orphaned
19833	3NL5GsFzhCKJcSNLSZ2wrUJdXZnCDT6yWLVTj7NptBvmbrnA1xdX	19832	3NLAu3PFHBSzvrXtUMRJLfgRbex1JQxBpegr1h2mPJ8MPptRxWHm	1663	650	351	6301	12463	jwbxSbQMKbW3H9bJEK2KMTjUJMKPXcvsDS72WYxtwJ4iLGkQKME	9991	14096	14096	1618476480000	orphaned
19836	3NKfdnW8uY2CgpsubUKT2K8kLXFFa4HhmkCgbmBQkKvXKcuNf41d	19835	3NLtVqfra25CqZGXeHF1HH5XthLYeqqLYvnt3Q2GLmviMyy5nBwo	1534	1317	351	6301	12463	jxrD9od5Qnkfa8mV7P3PN7GkAS8bxcstDJP7JVzwEQyzpSftvEN	9993	14098	14098	1618476840000	canonical
19841	3NKeCAcqyEUEjenRvFVuea58wmSKuLLCvbtTFaRMjPqkM9Axs2dw	19839	3NLoTex5WS72VpQkqZqVTkgxTbMq4Gm6ABLebiju158dZTB5jrFW	1559	1353	351	6301	12463	jxMmc3mofNoY8oB5L9q4eksZUUaGzzUJGvUgquFoCTAjfBqpczA	9996	14101	14101	1618477380000	canonical
19844	3NLpcWsFesKbesARzHWFbbzQLDNGQP1Jto7MPPYwTrisRW935Agi	19840	3NKdioMLUnWMaAfCRSN7xDXGhYE4HFZXnncg7W4goigLCsGRK2oE	596	1180	351	6301	12463	jxEsGCgAz8ZRd1ushP1EEHpNpndmb6v6fnxEGs6t8CNbfvy1cf2	9997	14102	14102	1618477560000	orphaned
19850	3NLB1hQ6wdSHQbDB1L1xYMUv6oARhWz25uCMg4oeyW1jjDrs5Zjx	19848	3NLjanAoyqjqmPsQHafJcvQiGW2xbvyXANHxEyNwPwan2eUoZBV9	152	1084	351	6301	12463	jxziCkAob1uRrz2Mz83yaYLKvQkfd9WtHNG2oF4vaBQzu3NRTen	10000	14106	14106	1618478280000	orphaned
19853	3NKc7wHXZ8JGG19HEHfLcZQCcRyYivnBtCyuo2v9Zpp8iqEmE1u7	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	1657	1344	351	6301	12463	jx62Tm4VKq85g83ZDJmFKdWVBKkWfLDA5c1KrWY3JSu2aL3FU6r	10001	14107	14107	1618478460000	canonical
19856	3NKEQqcktCMj51TUzRA3JQt84w2LJKPUEvT4djeJofZbYLXG9CHL	19853	3NKc7wHXZ8JGG19HEHfLcZQCcRyYivnBtCyuo2v9Zpp8iqEmE1u7	1403	782	351	6301	12463	jwUVgaD8ztNiLHrMNiEnM6aFN6YJf5NBJZ1J5P8zgTpdRf9ieFZ	10002	14108	14108	1618478640000	canonical
19862	3NLXfiMRdv9fRq5QwwVxqtzH25QcaxYTvHr2KipznVok2BuPafY3	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	1440	1131	351	6301	12463	jwbi6F79L5mCpQmyV5wDhNypNUP63jJzeiCQRnuVdGcWC6k8jdF	10005	14111	14111	1618479180000	orphaned
19867	3NLDVvizXzmzVybEniAbjVsC9ftwzGWDbQrBSnSUeH9iDzp44miL	19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	1652	1315	352	6301	12463	jxpXuYWXZo4HS66rxryjAjHap1UKQPynQckXYYzZtSk5WJxgXus	10008	14118	14118	1618480440000	orphaned
19869	3NLQRwTKdGUKBovq74YELEBz2erfJXHrMFM1MDcXw76b7Y76bgof	19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	484	953	352	6301	12463	jwGzr5PpQWYZ3DAcQPsVU7yQjFxeLHpQCHpsnjSyFvsFZR4aTi2	10009	14119	14119	1618480620000	orphaned
19873	3NKVBWNv5bRWRxBFASkAkB6ET2AUxPmQaiW5ywJDUGVjErxYXYdb	19870	3NLukWgxTNbbsevHzSV3k6J15FNkuEM5aCeA94YDdXfWkwcZJFuU	337	337	352	6301	12463	jy1ho4jGGBBjaF4MfGsn6rknUPq227UiJr9NaZhq8gsNwyBeT72	10010	14120	14120	1618480800000	orphaned
19878	3NKLUn3dWUohbCpanooFi9pgDMZFmkDSortPnAXQXAw4KR7xVE1G	19877	3NKV8gHMFMxJDfwGY2x44rGTxm24ajqknAWwc62GtJ4cqvfY5K12	1508	1021	352	6301	12463	jwy8vePCfyhQtx5h68Ee6UscZCsm1pFPdQ34VP1QGvfy5usn8T1	10013	14123	14123	1618481340000	canonical
19881	3NL2hZmJ4EsWpBLf3nait5gbRy9gDAKQGsA6zK2P36Er729k7pK8	19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	1560	1045	352	6301	12463	jxHp8DmCLW6oxWyWRwXsvQDsoJPpHf4EhzX642CVH3zQYShVzPU	10015	14126	14126	1618481880000	canonical
19882	3NLJunV5pzoUPdkzNg3kGnaUQeM5mV37ciXZaTBTS7zCeYmBCx7G	19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	1419	814	352	6301	12463	jxoKz88UYAHFhVKh1ywB6NZSxKsjmpJF98BbPYaJFFCkjRvRA9G	10015	14126	14126	1618481880000	orphaned
19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	19881	3NL2hZmJ4EsWpBLf3nait5gbRy9gDAKQGsA6zK2P36Er729k7pK8	1649	1383	352	6301	12463	jxxep9yokwQFivgGzsUCCAyZfqhHFVLAGcPj2tujYNfwrLSCTPT	10016	14128	14128	1618482240000	canonical
19889	3NKuvuWsEAn2ykaKTDGj8eDY4Zf8VVzsL4kUpSfWshbZsiNyxjza	19888	3NKJitpuLy6EV6aakzYP2yjNbWynJFa17MobSEZHj7iQa91wbX2j	298	942	352	6301	12463	jwQUu5RMXdb4pA3A9wSfc35ZKi9YgvSmXjfhfLrCvWM42RGA1jn	10019	14132	14132	1618482960000	canonical
19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1406	1393	352	6301	12463	jwJ5mScuNZiUVPBimXpEWi88dciNcrCMtH17gFq8FTcWMi6sUAP	10021	14135	14135	1618483500000	canonical
19896	3NLEQnbofs6zSy6SJKZHHdHtMJuPHVfcvP5TZchQo2VqNJWT6nFd	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1407	1395	352	6301	12463	jwPBCeDEpPMYGhySXRRNGLEtsSKLDAN2mUHQF5oeE677ymkzSXz	10021	14135	14135	1618483500000	orphaned
19899	3NL2WAaRcptcBJooqjRMHBo95nTb3CdeVECdVuBKktXZvMbDGRZc	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	369	946	352	6301	12463	jxbUnJKQYTyB9BP9UrqeLiwj1opsxD6oqEnryn77azPxUtTJrdD	10022	14136	14136	1618483680000	orphaned
19903	3NKKKpk8PKKe4wi18wV2F3fphioF8Y6FE8kPLSFCZkxgVfdR7KWa	19901	3NKnh941uKc88pfZFAoyR5ijftJoy1giJeVsCYtvjvSNF5dWo9Hx	1675	1342	353	6301	12463	jx48QGWw5s6atYDRnsRiSTHfW5kx4zPaqRCtojgPKGDXiDjc5rs	10024	14139	14139	1618484220000	orphaned
19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	1672	1285	353	6301	12463	jwGrahiGCiSc72eFRSpnkSbvUMUX4vGsGhQRTQkrgPyWkLaNNrT	10025	14142	14142	1618484760000	canonical
19908	3NKeqQrCCrHWyKsuNsxu5LypKpFx86WyhSfnKUpAMgrnuxEyAPrV	19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	1406	1393	353	6301	12463	jxr5ttfBNH668hcu52nKDMGyrzAYGs6nHoU6TQ2BVVyN5xMH9qt	10026	14143	14143	1618484940000	orphaned
19917	3NKYDjoHuNZ4NvDzxKGug1qvRTXXdLFnDwBAd6GUDk5HJXU6CL3N	19916	3NLodbrfTp3Jh7nTfWaf25cDgcYdnMy8rRVMKPZHLwWUZ3HdK795	1403	824	353	6301	12463	jxofYt7KsJcescswSBeYgtFEmB9wfGcoBXiCep4xzwx3w8y3otf	10031	14148	14148	1618485840000	canonical
19920	3NKQfYWgRyUG29kNVju4vMuQemJMPEXm73HfLMquqsgfM5icsBKa	19918	3NL1kSRGHy9CZXQdixDp4aC1ANJ3XfDLMmo9KC6PSa34WQuoivtV	641	1336	353	6301	12463	jxzUUX46XZvrvhJ5rtB884Bz3sDGacM6EquXmmibHiBRDjQpEzT	10033	14151	14151	1618486380000	orphaned
19932	3NKjrXnBkDXhbF1RG5CHdNd6QeyV6kg3qNKg3uDM6uWed7xe46Zs	19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	1402	868	353	6301	12463	jwUHkhsNQkBbM1hypLBBRjih4RfSM27ksj3wYeyzJgb4oSgMA2Z	10038	14156	14156	1618487280000	orphaned
19934	3NLjZQDkyoop8bbDef4X8fUknSxF4G6LgXiRRQmbtZj2XY2t7NGv	19930	3NLHPD4g7HnYqKjHa7Kt3hC5ZovfXEUbXS7JQtfXgNnij6rZ9GfT	1637	816	353	6301	12463	jwDw2MJr5EnHo3JRpKRvKNWuhfSyzxcHjpRaj25N9MpAgF86NnU	10039	14157	14157	1618487460000	orphaned
19936	3NKG2jH6oDrTWzfCvTpLdCyavdx891xinkdt6D5dP6X85jxXUkQZ	19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	1407	1395	353	6301	12463	jwbixh9wt8cByYXRXc8Gre6FHdw2FrSri41CVc211qJhK8SMwKW	10040	14158	14158	1618487640000	orphaned
19938	3NKdnV2ms2T3nUo3BH1h6do2CCuUnJvRkYC6Jy9qAT5xRLe54j1L	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1668	1124	353	6301	12463	jw8wSADRmeQd9g2TCqKpZa9Grg3h47mw8xbTndqQmZydYcJXSNT	10041	14159	14159	1618487820000	orphaned
22056	3NLvwYmHC7gBZ6JKDv9tng1DP49HsAqYK5LnQrnHfvqKYjncK2V9	22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	532	937	404	12463	14197	jwCPXkoTDdn5s5gRPsXVmo5NkgriGHNSTi2sz2Wr52iMzUMSR6g	11010	15526	15526	1618733880000	orphaned
19880	3NLAWUiBBPbJJpHCnrYxoW6rthtbAxYhoJZYL5TP6BTw7fBk31Lg	19763	3NKiAijJ8MfLDDFAUiNEpMZXMmr6iWrAPD7fWkCYd7aS8i2pVyj3	1560	1045	348	6301	12463	jxzpMtfEAss8WvdgKkq7hdFxvuhyjHPXVsJHgma4Qbi5H5foWQ7	9935	14126	14126	1618481880000	orphaned
19842	3NLmHHjWp7vGwrMFrsYYYW3MJLBaRneSZLohGHhsAvGgEH1J4RbE	19841	3NKeCAcqyEUEjenRvFVuea58wmSKuLLCvbtTFaRMjPqkM9Axs2dw	596	1180	351	6301	12463	jwzxg9RSDW4bhhan82kNK9RyGyqaNmeVMqvJZB8br9YnRePJhWH	9997	14102	14102	1618477560000	canonical
19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	19848	3NLjanAoyqjqmPsQHafJcvQiGW2xbvyXANHxEyNwPwan2eUoZBV9	596	1060	351	6301	12463	jxUz36yLYqGevFdLLmw58NLVddgirH5zBf8HYhTRX81JYrLSCsq	10000	14106	14106	1618478280000	canonical
19852	3NLxvxZCWg2J9NCsV9RAajjAZBf1wacxaPhfiyMYzBE8rvbDswsZ	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	1670	1282	351	6301	12463	jxhYpesatEe5ZobngZgHHzgXVBqWYQ9VJsMoKPPDdJ7XRfP8Y7c	10001	14107	14107	1618478460000	orphaned
19857	3NKJMxjvM2Esmo9qWyfLNFMQSHMkJtjvjUwcZUNQ5QBBtmeump8w	19853	3NKc7wHXZ8JGG19HEHfLcZQCcRyYivnBtCyuo2v9Zpp8iqEmE1u7	1650	1249	351	6301	12463	jy2KVAzoGiN5hvRrC2QKNrivPoysWP2ddkH9RnrbhvjmSPWWrtD	10002	14108	14108	1618478640000	orphaned
19858	3NLtKx82ZEfLZDw4awGYTa2G1Na8aWndUjzoDxcRpoHXZCjiGGQ5	19856	3NKEQqcktCMj51TUzRA3JQt84w2LJKPUEvT4djeJofZbYLXG9CHL	1407	1395	351	6301	12463	jwCh3mRSYFfCFnG4eCWzcb5YF76nTATPBFcvM4BrQZyaF5wwKBp	10003	14109	14109	1618478820000	canonical
19861	3NLFara2XeR5sEdtW9bgEDLHTDY5Eeos8zmYWNNGhr55WBuGKTdz	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	1403	824	351	6301	12463	jw8mUAp6QgdCHHRfWcjeXn97L3qpnpijUN2VBZ5tZK2zcsTjPMD	10005	14111	14111	1618479180000	orphaned
19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	19864	3NKky7KkYZCEVboy5djh5gEF6PD3eSGBUAsSdy2ZkWCP2p1snxJo	1406	1393	352	6301	12463	jxqf7oxYpiKxt7ni9qRYfp4t88UaTYR6SK7EP5DECC7cJcrHNEs	10007	14113	14113	1618479540000	canonical
19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	1471	1020	352	6301	12463	jxWFd8npBPdyjsUmk8MD2i9wiofHnQaQnEjv4Q9VGs5gCcNTuY8	10008	14118	14118	1618480440000	canonical
19876	3NLugyMZ1rBiQyHfcvGq76yfrrHTirMwKdvB4txfQ5zfHWRBMKPU	19872	3NLinGz24QVWeZcVfnCDmqHH2ow2fthjPHHywdp4qqKW299W8tbS	641	1210	352	6301	12463	jwxopm4RZfuybUJMALVsMvg8HdYLxzDS31JcpqZaHGiXgLQE7HJ	10011	14121	14121	1618480980000	canonical
19877	3NKV8gHMFMxJDfwGY2x44rGTxm24ajqknAWwc62GtJ4cqvfY5K12	19876	3NLugyMZ1rBiQyHfcvGq76yfrrHTirMwKdvB4txfQ5zfHWRBMKPU	1403	824	352	6301	12463	jx2EAibijE3gkJNv4wTEwXPwiswWYz3cBheseiCDGxSH7GXKoJi	10012	14122	14122	1618481160000	canonical
19883	3NLmhn35AeRCdCcz8PTzFZQbwNvqEUZ66vZpSiP78N4KU3Fcxpwg	19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	1419	814	352	6301	12463	jxT5HHUb9F7ovUoJrw8FmrFsDmCuDbsYGYrenpZaom3vuyNBtN5	10015	14126	14126	1618481880000	orphaned
19887	3NLhm9xMDGFwf3xoEn9Q4FXQwyEfvNteaGxRNQDGZ6ZeV7ujfWTv	19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	484	1319	352	6301	12463	jxtqPkvRCitGm97jhuH1BYq1Bf7ToRuWnCypFnjC1eNJHJ3bAmH	10017	14129	14129	1618482420000	canonical
19888	3NKJitpuLy6EV6aakzYP2yjNbWynJFa17MobSEZHj7iQa91wbX2j	19887	3NLhm9xMDGFwf3xoEn9Q4FXQwyEfvNteaGxRNQDGZ6ZeV7ujfWTv	1593	1346	352	6301	12463	jxiecDU7c6RqxDJsBHDLHRYDZUp7QUJCT4Riukdk2vt9yQaHn6h	10018	14130	14130	1618482600000	canonical
19895	3NKG5ERdG24r1kzGdhUo6DVcaHW2sxmTCA2FA8VgupWQaP7rLQZT	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1637	816	352	6301	12463	jwYnwELzaaoEskcan5uLgJT9td7EPqdkNsK3LKYoTjvy48AhUcv	10021	14135	14135	1618483500000	orphaned
19898	3NLvAGyoFBRKRsLKSzUtqny7ptnvk6yyurfAGsMVKz8ugtLv3TEK	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	1458	1323	352	6301	12463	jxxdu7qosgUxqXzMqnPe2GpPuU5tmS3GoXmCJsbE2R5uhHB4tAY	10022	14136	14136	1618483680000	orphaned
19905	3NLYtEokqn2LGV8o1gwfvSYujroGY9UtYY7HpiBbnYn1iriBB8ty	19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	1406	1393	353	6301	12463	jwMya3G6MctZF68uaWNdLkthg3VzBQ2bsq2bVLQMn4y37jFRRZS	10025	14142	14142	1618484760000	orphaned
19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	19909	3NKxvzJ2RxeCN2WghLeRM1MNhEJ6UyrbSG4aZHVSPbKJ3127KxJE	1471	1386	353	6301	12463	jwN4rJU53y6hEM7bxHZfEPmoXiU6pbDCTmub2rJY5gVzgFygCny	10027	14144	14144	1618485120000	canonical
19914	3NKp2phvEvgfCzQo8fjN4E9krZkpuwo3gtrFYtA5JMS3zZXLfHiW	19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	1553	776	353	6301	12463	jwKicX5XyW5ra8whz26AE9NA4CVaL36BzSsad3kdVC3iQjMPL81	10028	14145	14145	1618485300000	orphaned
19922	3NLbxSGqcpSS1RRUB7LneXLJL7kBsFzsCboTJYUYYkmT4teefLe8	19918	3NL1kSRGHy9CZXQdixDp4aC1ANJ3XfDLMmo9KC6PSa34WQuoivtV	1650	1375	353	6301	12463	jwtxdLQ6vdRurPUdYsp4Wu1ys99UFww4HzgM3vkCSAoYYACFrbd	10033	14151	14151	1618486380000	canonical
19924	3NKJB2YScYr3JpXccREAdMCFXBP1j7u9ETmawWYtx6DjvsaMJ5ep	19922	3NLbxSGqcpSS1RRUB7LneXLJL7kBsFzsCboTJYUYYkmT4teefLe8	1509	1074	353	6301	12463	jxUZ9E5idx3AdNXJS11YUd5D6U49su4Ht83KfURVLtXYpuvfxoW	10034	14152	14152	1618486560000	orphaned
19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	19927	3NKYfsRBcZ91sQtLbRTtNKjsmvZTnukwQsx4ZUq3fix565WbysoR	1422	1337	353	6301	12463	jxgmM3vA6m4dF543REBXT8dVbrUfMNjBCyWHvAidZYsBsQymFNH	10037	14155	14155	1618487100000	canonical
19931	3NLZonpRNy5uPLm3gHFbR3tpvKFfh6g9DdM9uk3KqZ3daBKSySM4	19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	1668	1370	353	6301	12463	jwt9auUxedQZrRYWY1Jc7LP1V1e8k8Z6ZSQakm56ZeZfnPoRPs5	10038	14156	14156	1618487280000	orphaned
19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	19930	3NLHPD4g7HnYqKjHa7Kt3hC5ZovfXEUbXS7JQtfXgNnij6rZ9GfT	1602	1123	353	6301	12463	jxRCowpWRT5KuszSXqPShTeb6wJYtZRxiMpYoHe98BGZey5kfdM	10039	14157	14157	1618487460000	canonical
19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	1439	1033	353	6301	12463	jwAzN1kdE9GsLVcC5xJyaqxbbqPtkgTKDbVLBtBhoiqzNcnLsGw	10040	14158	14158	1618487640000	canonical
19941	3NK9u8khnguAQnr1KEGMJCHgDUukK8BRLBwg1FsRUHy5dSurrN8N	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1407	1395	353	6301	12463	jxydwAdCJVESP2XCCurMvUoimB1ec45zhJvx1GBwABkonixNstF	10041	14159	14159	1618487820000	orphaned
19945	3NKk87af1g764kzwE2SAu4VzTggzR5zNdsvmaLf2KHCgu53X2vTM	19940	3NLJnq6hNLkh4jmDaRRDxThTr7Enadv8LZ6CabegbtQ3smX3RYWn	684	1226	353	6301	12463	jwKbqv3x7zVBDhgRLycL19CcbJh7QzTCdC99Ya4UxHLFgoLZZtM	10042	14161	14161	1618488180000	canonical
19951	3NLHWYAGtsYmvZN7ip8cihJ2SbN8bFUJAjpcECvgLMaCpfVugRLL	19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	1652	1315	354	6301	12463	jx4k63xGMPjiXmpzzikQyxhPvDF8UcxwTQ3b4xT2q5pvwFoho2L	10046	14168	14168	1618489440000	orphaned
19957	3NKtYoLkkQo3D3WyfhWiNwNFvKZkPmTu84HHenP14qXKPFwt8NJk	19956	3NKvLBsW72gWCeKbdqn3t3NVEba6s9ZdXyHEPEMPJ4q1if7s1hz9	1547	1378	354	6301	12463	jwCjgU53CzyRRztMvv43FXp1qawT2RtgWZGgec9MDwjm4q4AQGU	10050	14177	14177	1618491060000	canonical
22427	3NLmtyXZU2Ahv52gJBgoMTMxkVERh82Br4hYRNSSooMoFf4YkvYd	22399	3NKVpfbzN7sh97EQJ5fgeAxuQ74FizLXFL7pYJYwP83saHCJjvNq	1516	1294	405	12463	14538	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11010	15802	15802	1618783560000	orphaned
19854	3NKwggyVzLZfPrUKfMqy5mbRZa5nroQ3ChwPCofwysPKDHr3YcpV	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	532	1057	351	6301	12463	jwBwPi3ykc8UoU2PW1GeKPzcQa3JDpqbPwGuUWW28LvfzRdgkq7	10001	14107	14107	1618478460000	orphaned
19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	19858	3NLtKx82ZEfLZDw4awGYTa2G1Na8aWndUjzoDxcRpoHXZCjiGGQ5	1407	1395	351	6301	12463	jwavJZFafLEyxyyAwTxVtSM8uBPsX6nRwwTZ3KGgZRRMKC5oofP	10004	14110	14110	1618479000000	canonical
19863	3NLPtUJNFi5ygksdJdpbKV5xpxyBe59CConpd35U2LYZW2DMT1En	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	1440	1131	351	6301	12463	jxWkuaksMniTwr98JWbNLVqShUgNvBbFBdeCXqbEFyJ4wDLdgSb	10005	14111	14111	1618479180000	canonical
19860	3NLk5zCrJb7tbCuR3gN61N8LLAQ7LLT3NXAf6MmyMKiCzeosh1ZA	19859	3NKUoqizVwFyiCnB5xhCUhTaRa44FDjh4yKWnuWngRKbpksMiz96	350	350	351	6301	12463	jwiv4vhA1YgydyfedMf4jS1KJU4eLsfLXm9KEM9p5bvXXHKS7Wz	10005	14111	14111	1618479180000	orphaned
19864	3NKky7KkYZCEVboy5djh5gEF6PD3eSGBUAsSdy2ZkWCP2p1snxJo	19863	3NLPtUJNFi5ygksdJdpbKV5xpxyBe59CConpd35U2LYZW2DMT1En	1406	1393	351	6301	12463	jwjmAic2Ld2m3xkhGJvFdKxTrze3121UUupVmH2oGoDjg48dy9d	10006	14112	14112	1618479360000	canonical
19868	3NLUKNMTiDnXZhTYc4aHfC2SDA3vrM7VmPqBxEwjoYrEdhTdrU1i	19865	3NLbLsyDZfZn5d45xXi9ohSx5LKfbPU9LR6nP6fCQkjjioTeHawL	1652	1315	352	6301	12463	jxmXj2d2RnPEBukz4y2ZSFFgbVXsNqY19W7mpKqkHzAMK67CEa8	10008	14118	14118	1618480440000	orphaned
19871	3NK77CeWSAH61kLkDBq3JtLF5yLoLg2gTYvrLrmnb9uAbws6vMNR	19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	1553	776	352	6301	12463	jxQgHK89evsnzkmeaTWonXBLuKjENTuZH4U23XbKgbtk4mGiYiC	10009	14119	14119	1618480620000	orphaned
19872	3NLinGz24QVWeZcVfnCDmqHH2ow2fthjPHHywdp4qqKW299W8tbS	19870	3NLukWgxTNbbsevHzSV3k6J15FNkuEM5aCeA94YDdXfWkwcZJFuU	1403	824	352	6301	12463	jw78cBE96KuJa1NAXZjXRUT6EqiSt5EwAYPmxxKmvTLq1WEHbGK	10010	14120	14120	1618480800000	canonical
19891	3NK4buffRbQcVhrNWTHZ57ugNqKnTT75w5cQLM76NdfEbw4y4yEB	19889	3NKuvuWsEAn2ykaKTDGj8eDY4Zf8VVzsL4kUpSfWshbZsiNyxjza	1534	1071	352	6301	12463	jxKkSRnRX2WwBnTrzudtUSgYiNtK65cckbNnJBH1rPJmnSnxqja	10020	14134	14134	1618483320000	orphaned
19894	3NLYo2aMaRPvpm69yjk3BSYPMm7cKU2JoqXNy6kqCC4FDdKjxeTg	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1555	1221	352	6301	12463	jxLBScpFvHdXoAMhYK2Hzmeu438PJN8BPktPY8L9ycjEemnU9QR	10021	14135	14135	1618483500000	orphaned
19900	3NK4T4RZ1vND3pdtBw2sBaxCT3hiSoiHtqwBTfqM6jtiU6MvXeWG	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	1481	790	352	6301	12463	jwrRgY5kPJb2vuGjwHyNcPDCRBTqf5n7SbKhE1VbJsp4KZjBpq7	10022	14136	14136	1618483680000	canonical
19897	3NLXrUgZWToCiDjpvg1MdKPzZ2B5ueMWLWwkAc8qC16WGajdaz4c	19892	3NLQgcqi3L9M1nFbCJCeoVcHYaJXda9o3hri9hv4cHrYNfAGgVH7	369	946	352	6301	12463	jxbUnJKQYTyB9BP9UrqeLiwj1opsxD6oqEnryn77azPxUtTJrdD	10022	14136	14136	1618483680000	orphaned
19902	3NKtGwQkMNaaHpDbWMRev6KJmcYBTCu2r2XNAidqEoMTuBeHY4EG	19899	3NL2WAaRcptcBJooqjRMHBo95nTb3CdeVECdVuBKktXZvMbDGRZc	1590	1300	353	6301	12463	jy11ozQmbJWYAf31aYHUK7NHBbakmcTbKws71DLoSX58ZFFAkLC	10023	14138	14138	1618484040000	orphaned
19910	3NKsVj132gCHQyM98Xy4DoamjoEGkg664RWn6o1wR9UQpLB25GgT	19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	1637	816	353	6301	12463	jwgbT9wB2MDiMBMLrjCrpTPfch45A2w4QgDLnA5GCXHqKjf7dYm	10026	14143	14143	1618484940000	orphaned
19911	3NLGZ7X6gPP2vH7rHSSZhRfQZLeD4mj6uUyABZocsPswmGmwnX57	19909	3NKxvzJ2RxeCN2WghLeRM1MNhEJ6UyrbSG4aZHVSPbKJ3127KxJE	1503	1277	353	6301	12463	jxoaqtpMduTgMsSu4xQFaMRfxsnBUDVvxqoSj2j6qN4zTrhXLTt	10027	14144	14144	1618485120000	orphaned
19916	3NLodbrfTp3Jh7nTfWaf25cDgcYdnMy8rRVMKPZHLwWUZ3HdK795	19915	3NLskcayzTcCMrH35ZA6X8phX2gJbfUkcqCmwmSF56buAMUjY1XC	1457	1145	353	6301	12463	jwfZYma6Zrz96rEXU8Z3xYnRZUFYb7LV73nQnHWUSFfSSXwyxhH	10030	14147	14147	1618485660000	canonical
19919	3NLPYtBaEkDuaA5HEmMMcA7VPtx2GUiVennh9X5v8RgqDRGBR7hz	19917	3NKYDjoHuNZ4NvDzxKGug1qvRTXXdLFnDwBAd6GUDk5HJXU6CL3N	1590	934	353	6301	12463	jwUtpEgMhZyBWjcfVNDakzpdxmS5ZF7CczP32nc93LJK8UQfFVi	10032	14150	14150	1618486200000	orphaned
19923	3NLBrPvzcbZf2XZN11KXJa966cWbgquhhnmN15Rhj2UsYUqokDdA	19922	3NLbxSGqcpSS1RRUB7LneXLJL7kBsFzsCboTJYUYYkmT4teefLe8	1403	824	353	6301	12463	jxDz7YhWBekuZZ9SyweKb3B66whSTjQXuZNKaPhGLAmnWNnGKoM	10034	14152	14152	1618486560000	canonical
19926	3NL9cAeP5iLaKDdrvKgrKD3w6PWk9UbkJyVK2DCThE4ubPjUJqNH	19923	3NLBrPvzcbZf2XZN11KXJa966cWbgquhhnmN15Rhj2UsYUqokDdA	1637	816	353	6301	12463	jwzwEtcSE3FYUfp1JFHs1YPHdbbTWAYhyoxBLyet142rQTfGyui	10035	14153	14153	1618486740000	canonical
19928	3NLxnPqCXzANMgXg3Z6UzF8qYdydG6DNPPGx2sm1cAvkTve98pDw	19927	3NKYfsRBcZ91sQtLbRTtNKjsmvZTnukwQsx4ZUq3fix565WbysoR	1422	1337	353	6301	12463	jwEWCq6pPmpPb3crxXp6P23UFJWC4rw9nYdre1bAkbVax6Ncjys	10037	14155	14155	1618487100000	orphaned
19930	3NLHPD4g7HnYqKjHa7Kt3hC5ZovfXEUbXS7JQtfXgNnij6rZ9GfT	19929	3NKFA12EkJbp6oMCE7fZCMFb3Wzv8VR7LCG6jY3kXV35Eg9L5aA8	1467	1250	353	6301	12463	jwas7MQjSfBkxoN1myoNcXyLUeX4cQFeJkmCQEHbJmjLw1yF1qS	10038	14156	14156	1618487280000	canonical
19940	3NLJnq6hNLkh4jmDaRRDxThTr7Enadv8LZ6CabegbtQ3smX3RYWn	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1589	1286	353	6301	12463	jxBbzY4kE5g68oxQRk3Hq7WJRuqZLwVHtssC4GSabEatYWf4jZN	10041	14159	14159	1618487820000	canonical
19947	3NLUbxh6CQZJHkHkTizC7woWjL6NCKWMoAip3Wn4fxpqJ1kdWKtj	19946	3NLMHG2cqipC18E6EFuwKyKz6nQhjHDiRcSnMZJunNHF7cpJ1UbD	1637	816	354	6301	12463	jxMkraPRPsjxFCggpGZdHcCueB3oqZsR9uKUF7AtHL4r6FyrfMY	10044	14164	14164	1618488720000	canonical
19948	3NKYZVKwtbEwqqmsU2pExNkjrvPpXHtBW3gJYPWgETZtBMDF9GFi	19947	3NLUbxh6CQZJHkHkTizC7woWjL6NCKWMoAip3Wn4fxpqJ1kdWKtj	1589	1040	354	6301	12463	jxf2aAq1DTzHs55MP8DoztEP21JRbj3FJiHvUzjd8ehYuWZ2bBw	10045	14167	14167	1618489260000	orphaned
19950	3NKNyWhwJo19gGFxLnMGKnuZy18Dx8xZSX4CfhZUV5hRSm6HFUjf	19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	1445	1044	354	6301	12463	jwmHp4RdFnatZWXbMQ6qjaxYLTZ48LQKPgqyvoAQUqyzwcYwxKJ	10046	14168	14168	1618489440000	canonical
19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	19950	3NKNyWhwJo19gGFxLnMGKnuZy18Dx8xZSX4CfhZUV5hRSm6HFUjf	44	1079	354	6301	12463	jxsh6UE2r7w5Hn2TpMka2oGMAe2eBkLFhf6Jh52XJLWmUXpb7vr	10047	14171	14171	1618489980000	canonical
19954	3NK7hpBe2L3rMKrstmoBpHPeXvpfVXMZdNg1m6hqggENWQDH7zwk	19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	606	1295	354	6301	12463	jwvw4yT7ixBQJfVuMBUeJtozLbuAjHJWdKWc5jHZTJSYnn5Hn7V	10048	14175	14175	1618490700000	orphaned
19956	3NKvLBsW72gWCeKbdqn3t3NVEba6s9ZdXyHEPEMPJ4q1if7s1hz9	19955	3NLr6jCYpnaFPjJgsJuc4nQhz4uUdfn1Y64ByWoR39PvELew1fQP	1406	1393	354	6301	12463	jwPuUFoG11wjNL3iEdT3oZRDpypHkj8eqhDgMTPkdnVZk9FtmHR	10049	14176	14176	1618490880000	canonical
19966	3NKDixwrbxLZMTT5hTVKGGnJBtfrP6kStTtzv81EhkTMsZ9Lryvu	19962	3NLs3vGrXaPMMBoESTdR9sZEqVUtCCgLsJQvDS7RyALW1XCwgt8r	1560	1291	354	6301	12463	jxSiV6V5eYtSS3FzCSdpnPLA1w2aqEpunksjBY83ELoBL9RHRkP	10054	14181	14181	1618491780000	orphaned
22473	3NKqfFp3DCJQURnMdPePTTAEubKmzSUKLa5cSHZiuFUar9Ams6ta	22427	3NLmtyXZU2Ahv52gJBgoMTMxkVERh82Br4hYRNSSooMoFf4YkvYd	1516	479	405	12463	14579	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11011	15827	15827	1618788060000	orphaned
19958	3NKjTXrMLKz5bakyLvcGNxHWMfUj9HY2VxoZ6iWLXoPykdKeiwm9	19780	3NKJzh4Ue7HU8yC2zeNVWLaBtrbX4N3VkYirDbrs7BGSfHg4rGE4	1547	1378	349	6301	12463	jxGbVq59dBtinPG9rpWumF2xCbU8L3FvzfGru7L2zXNQ9XgKTkR	9961	14177	14177	1618491060000	orphaned
19921	3NKnRumoD28URCCZ9iCy5MxMMi91w8UrLNhavGgYH5bBFkqeHahE	19875	3NLWbWj5US2atTS38JkecFofgRN3BUGhwsWGtMMvD2qbAeKJtb6m	641	1336	351	6301	12463	jwovLhPTVDEprU8MFz8qD5a3bWRgvjWNhPJhcPwM6kHR7hRamdG	9993	14151	14151	1618486380000	orphaned
19870	3NLukWgxTNbbsevHzSV3k6J15FNkuEM5aCeA94YDdXfWkwcZJFuU	19866	3NKKxDFBocSNhtcEcHyfGxATCgQhT2S62ePK4sJnutsnwYq6ER5f	1611	1215	352	6301	12463	jx3TxDSQxFaqPTz33Z16ocJwHmCtHBNYdfzN5pg4VoKJRXqRaYK	10009	14119	14119	1618480620000	canonical
19874	3NLsdEhcNbcEV71MgfiGfmTCtyhS4DoBPeuk49ZusnDFZZ2zwocd	19872	3NLinGz24QVWeZcVfnCDmqHH2ow2fthjPHHywdp4qqKW299W8tbS	1646	1228	352	6301	12463	jwkJZ3TKSsTmSEDt7fc6XPuwx49MjatK84bpGSBSPfAYuJHnSKg	10011	14121	14121	1618480980000	orphaned
19879	3NKQCmXYxPxvoy7W8r2V7WJjYe3WZnrC7Vg77juDRzepXuvZ2vqo	19878	3NKLUn3dWUohbCpanooFi9pgDMZFmkDSortPnAXQXAw4KR7xVE1G	1581	778	352	6301	12463	jx6kQyxjadXH6t7oFCCP5QxdFsjVajVSGk8fNeM3vSx8ySL5k25	10014	14125	14125	1618481700000	canonical
19885	3NKLeCskU4AYGQqcKKn3UsQFswgAfboDSbrCybidkFQiBRukNSih	19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	1622	1110	352	6301	12463	jwgSMNCSn4xXsPAzYE1ECJmY5o6ZQTx5GQSpRdzczC34RDxDZiB	10017	14129	14129	1618482420000	orphaned
19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	19889	3NKuvuWsEAn2ykaKTDGj8eDY4Zf8VVzsL4kUpSfWshbZsiNyxjza	1403	824	352	6301	12463	jwP9aWvbPefYyndAvAxGUKLwFKpZPVVS2PjG6BmGMcHSBbqfzKJ	10020	14134	14134	1618483320000	canonical
19893	3NLUsPBiAL1v1CRJmkHT2R37vtPWTuw5p21nCnQrA1bQvMyp51u8	19890	3NKMbBhVUN5sksHeTdLE8nnh7YYkz6MG1WZFD1KHdTzZeACAdpNE	1403	824	352	6301	12463	jxFpXMsCCDi98MHwcwjmVMWnJMZWDK1NF9e5sq9oqZ4C91Uhvjg	10021	14135	14135	1618483500000	orphaned
19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	19901	3NKnh941uKc88pfZFAoyR5ijftJoy1giJeVsCYtvjvSNF5dWo9Hx	1397	699	353	6301	12463	jx1jQy2nWb6xmhzywBEhNsPi4ZVkKv9FSexgKvajeMC6qJMgY7M	10024	14139	14139	1618484220000	canonical
19907	3NKqrUA3oTa2RC6eFJYFDYvcbHtKDBwBjcKwq7tAUaAG5s9cFyaq	19904	3NKfLp66wjqU9XmwnVqhw7xZh4o8bGsLcvuQgUq4MCLeFFP3mhTd	58	915	353	6301	12463	jwYi9AurJEFxYnVE8mdME7gxs2LJTKvw9pjT1HtB4BFgMYJjPDe	10025	14142	14142	1618484760000	orphaned
19909	3NKxvzJ2RxeCN2WghLeRM1MNhEJ6UyrbSG4aZHVSPbKJ3127KxJE	19906	3NLJoFhgjUgFDK49kvsmuwNRQG2M5PVJCzfhTE7b6oSmDfJs6cAt	1536	1187	353	6301	12463	jwZYyof73jwTAsJYjaxYqiKMKuzyguCHEzH9PoWx9LhFpTVJipW	10026	14143	14143	1618484940000	canonical
19913	3NKM6eYYwGZK7XDLhzvs7PkV7v3mhGs2AvLBFLLM1axX8RUSRVMt	19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	606	929	353	6301	12463	jwCod3eCFNsR1SX9xBwKKNUgRNUHA8PYGdBXd2YHnJTBvoNLDTv	10028	14145	14145	1618485300000	canonical
19915	3NLskcayzTcCMrH35ZA6X8phX2gJbfUkcqCmwmSF56buAMUjY1XC	19913	3NKM6eYYwGZK7XDLhzvs7PkV7v3mhGs2AvLBFLLM1axX8RUSRVMt	1622	1356	353	6301	12463	jxnc65PXxazkaU4wWiHNbU6X98o17ob7APFmKWjEeYvx6aV7XUJ	10029	14146	14146	1618485480000	canonical
19918	3NL1kSRGHy9CZXQdixDp4aC1ANJ3XfDLMmo9KC6PSa34WQuoivtV	19917	3NKYDjoHuNZ4NvDzxKGug1qvRTXXdLFnDwBAd6GUDk5HJXU6CL3N	1670	1156	353	6301	12463	jwJfm7cARkvGcyW7wJEsu8CebSqJjQGrbueqYfAWvemZaWqqQbH	10032	14150	14150	1618486200000	canonical
19925	3NLavqsRjkbw45T1eYtGjaAUHSGzSyzrRyuqZaMTjdvCKYJxA21r	19923	3NLBrPvzcbZf2XZN11KXJa966cWbgquhhnmN15Rhj2UsYUqokDdA	1406	1393	353	6301	12463	jwoUGD52pm9tCS53bkPwFdzSEcWqryU2Fi6kxtePNfBwANE1m2P	10035	14153	14153	1618486740000	orphaned
19927	3NKYfsRBcZ91sQtLbRTtNKjsmvZTnukwQsx4ZUq3fix565WbysoR	19926	3NL9cAeP5iLaKDdrvKgrKD3w6PWk9UbkJyVK2DCThE4ubPjUJqNH	1407	1395	353	6301	12463	jxsEbARnYQBXRxbzzKZ7dqS7MLz1y7mtUZpGb6fucdf3Uj8QoNm	10036	14154	14154	1618486920000	canonical
19937	3NLkckjrNi96v4WJp4qoqTYbrhMoAoxpMfqWJYUxDmmh5xr4hJdY	19933	3NKxu2QsLsV9hoBt5rQZYuxByykDLNJkHKBZEvsob2A3X9Bnbbt5	1611	1341	353	6301	12463	jxDFwFAJdALgeNaPGUh6eGr4RGxFMGGWkKvbbVZPifUWcLwkqtU	10040	14158	14158	1618487640000	orphaned
19939	3NLTyfK1B2EjU7NAnTxYvpbNYNLerfVUGcJU6RpcKr7gAvYofetw	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1403	824	353	6301	12463	jy316qRBrax1pzLn65ZQBTse7heXCkfmwaoPhd2uYemL9e1uHzS	10041	14159	14159	1618487820000	orphaned
19946	3NLMHG2cqipC18E6EFuwKyKz6nQhjHDiRcSnMZJunNHF7cpJ1UbD	19945	3NKk87af1g764kzwE2SAu4VzTggzR5zNdsvmaLf2KHCgu53X2vTM	1407	1395	354	6301	12463	jwm4Eh8yyVTcWpK32o4ia9Y3QndtKt7g459MxF33PTZQeJt8KeL	10043	14162	14162	1618488360000	canonical
19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	19947	3NLUbxh6CQZJHkHkTizC7woWjL6NCKWMoAip3Wn4fxpqJ1kdWKtj	1553	776	354	6301	12463	jwbmJ5PxXBfeGZCBiG5HtP3ydK5aM95wjrdw6SuJLkQDVecBigA	10045	14167	14167	1618489260000	canonical
19952	3NL5bZgRhFC2i9sw7MSYaVcUHoGLeiWqViSCyyB3bfXpJrnxHpu1	19949	3NLBrgADxNTGe6R2y29Nv7LMsnuU8xiw7aVzdPkXgEYkr2f7MTYY	1652	1315	354	6301	12463	jx3hR3qYxnX9EzWYXAqCQXxJhtZN3p8mMjSCMaGKLdYga6XDPPL	10046	14168	14168	1618489440000	orphaned
19955	3NLr6jCYpnaFPjJgsJuc4nQhz4uUdfn1Y64ByWoR39PvELew1fQP	19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	606	1295	354	6301	12463	jx4PxMwk9qitS9EJ1esSjL6MfSMjbYgqL2MV4VPa4ZEGRMmrh6P	10048	14175	14175	1618490700000	canonical
19961	3NKY7VWqqPqcgrEe1pt8iFF9KUFYu6o4iqHY95osTY4kfUNLgK9b	19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	1648	1284	354	6301	12463	jwa5FJffRv4nAjFx2AH8ev8uY91HKpuxszNgD6yCj5xvYaFFUtn	10052	14179	14179	1618491420000	canonical
19963	3NKwVwraYpDwBTd1kdJmMp4C8PELT2Bv65fzt2XW49UNnLMmDmnT	19961	3NKY7VWqqPqcgrEe1pt8iFF9KUFYu6o4iqHY95osTY4kfUNLgK9b	1407	1395	354	6301	12463	jwMVCYoRPGtwPEHv7AeiWSwEqTzDjyMLptjzfd3UawiWzBYet8y	10053	14180	14180	1618491600000	orphaned
19965	3NKbRBon7vNuWZRLrN5tYtxNgQvSUxPJsesrfhVZJzx46ZDCmn1d	19962	3NLs3vGrXaPMMBoESTdR9sZEqVUtCCgLsJQvDS7RyALW1XCwgt8r	1522	1196	354	6301	12463	jwaNfBUuWQ7PrJjy15P5LTpQ6xiPQjZFy1YaiSWCfsAVmY9X7mr	10054	14181	14181	1618491780000	canonical
19968	3NLNwrqUspxWnfVDHiEruyfZsrSRBGtphaDZBSWMpURzJ2MnSZqd	19967	3NKMxbzGSrMaWmtEBJ7UPMG9raSMxFxHNNAEm9iJRWbuCHxjtdLg	1637	816	354	6301	12463	jxMuNVgGtus8EB1QX5HYjwNYuhEaAQ7TkhcYSZR7SWKdHhpENtH	10056	14185	14185	1618492500000	canonical
19974	3NLh63DtQ32NGAf6CBsVJo6xDy98HdSYebMtTSFrmuEHRRYTayje	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1523	1075	354	6301	12463	jxVV2waqJMLguAkFw19y1q7QNBifDpFUo1fB2VatuBzAu4Ab1Gp	10058	14188	14188	1618493040000	orphaned
19977	3NKcTShGKTJnaxxZCN3oZZ4caWisAymQfZHc3CBMf7sVWrkf3Uq1	19972	3NLhGf3s9Aom2EvwAKhpQkn816W9dPipeesp3Qi3GSe4kayGn9P2	1559	987	354	6301	12463	jwtJMA7CFLxa7c1NriHWquPjXeFEqdriCg16DtCZZ85fYZmXCFM	10059	14190	14190	1618493400000	canonical
19980	3NL8UFJJAG8C5WYyAQ7qhr2hy5k2iitRPo5m94VRzJHBrRn37Rwm	19979	3NKSfyjGankB6TXzuGsBehF4MgUSezyUyZr9ukjFBGY8hHiTwTqa	1594	1326	355	6301	12463	jxo46Roxvp2YxeijhgKmqXVvKGKzwmXMXYj7SUf64rWWwNKC7QW	10061	14193	14193	1618493940000	canonical
22082	3NLj69q9bnxe8Mr56kg8ehWfqNqkmfT48hQKSfx3v17KXd9DWb6V	22052	3NLY4xqRM9bj29RMGPG7YgAoiBxtPTyi9QXehxhcsPobWXu36eyy	1553	776	405	12463	14219	jxfNeMNvfjepzGQkeryBaSW1ShQV9pfYc4o4gDqLtNVfFD2ckiE	11027	15544	15544	1618737120000	orphaned
20047	3NKii6LgmBxr8ifjQV4RD8rTVPNADUTDR593UWCEKotzrrTejpJd	19964	3NLShbNfNXB8ehdaYJJbhikKYWN7oVeCE9usSzd2t787rLYNJKF2	1560	1045	348	6301	12463	jwFL4bp7KDkPYT5EKd8aUYASh2bzQYFoE3uFV1pJJzYbLc778AZ	9937	14230	14230	1618500600000	orphaned
19960	3NLrCpFUuXcVv89CrWQb97ewPJjkM13gBSpLgucA5xJs5HMqEm53	19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	1547	1252	354	6301	12463	jwQ6AUpKkqF3iUnzZcv4jeA4LjKGKFtU5LRetdbrvZp2VdJVgan	10052	14179	14179	1618491420000	orphaned
19962	3NLs3vGrXaPMMBoESTdR9sZEqVUtCCgLsJQvDS7RyALW1XCwgt8r	19961	3NKY7VWqqPqcgrEe1pt8iFF9KUFYu6o4iqHY95osTY4kfUNLgK9b	1622	1110	354	6301	12463	jwjTQAxshnY3GN1GtQEH5Gge4m1RKkkRVufT8zLg8Qukpvu3eNx	10053	14180	14180	1618491600000	canonical
19967	3NKMxbzGSrMaWmtEBJ7UPMG9raSMxFxHNNAEm9iJRWbuCHxjtdLg	19965	3NKbRBon7vNuWZRLrN5tYtxNgQvSUxPJsesrfhVZJzx46ZDCmn1d	1406	1393	354	6301	12463	jxgrwNWATdgrwZ5gPAvr9LPtWqaozuNYSjuApR6FWdYgnW8mWFZ	10055	14183	14183	1618492140000	canonical
19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	19968	3NLNwrqUspxWnfVDHiEruyfZsrSRBGtphaDZBSWMpURzJ2MnSZqd	1406	1393	354	6301	12463	jwgYUn2WYeVHkCdq7RKSqbFCFnWQAugRW8CnaB2A2jHv8PJRhVM	10057	14186	14186	1618492680000	canonical
19969	3NKYJjUm4vtNsqEVuBzVk72jRioJJEo8NEB9C3dbHdLUEVc3HHVX	19968	3NLNwrqUspxWnfVDHiEruyfZsrSRBGtphaDZBSWMpURzJ2MnSZqd	1467	1376	354	6301	12463	jxTV5vZ9tsHcaYHCWpjsniXcKPeJBAJ4uYmbC3EtQDvLU4Zo4sH	10057	14186	14186	1618492680000	orphaned
19972	3NLhGf3s9Aom2EvwAKhpQkn816W9dPipeesp3Qi3GSe4kayGn9P2	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1523	1075	354	6301	12463	jxpX1iaoyU5P92GFf2HQw7HYs5Djr5vugYutYW8rcpwuZsDSPZC	10058	14188	14188	1618493040000	canonical
19973	3NKUQuojdL4xkexHHQbcCo3qBtBgyi2kzzGswpREuyc4xhzNeqcf	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1471	1386	354	6301	12463	jwTWJbbDQ7C6nc7vPcuykxyDgBA9CrLtPqQjXvygBjX3fTsAPSP	10058	14188	14188	1618493040000	orphaned
19984	3NKokUvHY23TA7PRgAtS4zJA3UnTcMf1qDukUiTPrBC1m8caCmow	19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	1631	794	355	6301	12463	jxzJdx9REz21VU6BxBmkSPFiuasBKk88w4vCSMTNHoxtrRk6zAy	10063	14195	14195	1618494300000	canonical
19982	3NLW8g5KssGx2YGhnMungTFsiLTsJxWeHwQbNvG4mgK5RfxiqCoF	19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	1407	1395	355	6301	12463	jwqB2FEKdn4Cr3GZsiXhcL1Wfb1otdtRZqswMVkFckiWQSJmvcD	10063	14195	14195	1618494300000	orphaned
19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	19984	3NKokUvHY23TA7PRgAtS4zJA3UnTcMf1qDukUiTPrBC1m8caCmow	1419	814	355	6301	12463	jxMoGR818ZTNsYCL8LMqJjtuSNTXKZVUM6K7Vf5o5BbVsYyhyFx	10064	14196	14196	1618494480000	canonical
19992	3NLPyGRGtxhDzn6z8mJ2M5bUSFmDEr2CMfFnf2rFmcScXutTWy7b	19990	3NKvBwz2F19mAHqgQgkam487bKnFyoT3XD6E4n9Yrk1gGcQ5h6ET	298	1308	355	6301	12463	jxKPKwGpPEtDrRXsQBUJZc4e6eLjG14qfb1isgi7W5VoL9WASpA	10067	14201	14201	1618495380000	orphaned
19994	3NKACV3fxhZw5G3LaLgjj3vtiu9Dmn7Bn24Mi9veHYLbpesBEe4z	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1440	1011	355	6301	12463	jwDhpFckwE3sZhhUer4t7FHSdEcEJsicpjbYPAegH31B6N4ivi7	10068	14202	14202	1618495560000	orphaned
20003	3NKyvRJoWYfeNtx4ky28ojcuqD8Ytv9EkN9LGxXAkq9oAhWVbyap	19999	3NKGzmxmWmZPU9dKTn9o7SZhFNBwKe6VNFFyKtt1uL2hEHhUEU9H	1460	533	355	6301	12463	jwjp4SEN2z5a1PkrJ7K7QTem5vy8qYJHHyVCF427bwHznmh6Mww	10071	14205	14205	1618496100000	orphaned
20005	3NKbudTvk5PvpUgmPCUjGBPKFdTeXMKYny9p4RhBLucGdYy7h8Ky	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	576	1109	355	6301	12463	jwHvgiMRVnECbyAJEhrUTPDwbTaXRoPRyQjUFKbts6rWegPSi8x	10072	14206	14206	1618496280000	orphaned
20008	3NLni6mL6Hkz4smP6UFXEW9xVZgBbyCfmB8bqa6a9i4vfwHNEj3f	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	1624	1208	355	6301	12463	jxHqheeXY3dJ5gaaqd5arvhun58iqwEiYkLCf4sPTPJtABMMREn	10072	14206	14206	1618496280000	orphaned
20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	20009	3NKAAvqPNFFMNMFBHNX8s7gjLrfpo2qGjEuxmf5jW7v15uKT2kxW	1589	1040	355	6301	12463	jwLn5ffztu5VnmcFH6PLfkP4TcK1SYDm5T587xufiy6SFk2Nzz7	10074	14209	14209	1618496820000	canonical
20013	3NLfDFUD4ehVrDBRw9m998dvz3EAsSPMCdCrW2pJQ3gSbFUkZmiU	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1587	991	355	6301	12463	jxkUENd5k6GjyXzqW9nYGt8AUdLCCSBzq3ZesBH2rTQYbq13pJA	10075	14210	14210	1618497000000	orphaned
20016	3NLPhqoPCYAkKFZVZimcgTLdi7wuNKGLaNE4xM8CTx2UWGwMQT4Z	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1508	1387	355	6301	12463	jwapMNwimkYS2qZyMyJV4NGGru4PsDM43PfVToxxgc89Y7gzdHq	10075	14210	14210	1618497000000	orphaned
20021	3NL1S5bn5FDUa8AJBL6HNBwiEX6SAbEAk8xaSs7bNZowBG9YJTqi	20020	3NKhMWiRJvVtCyq2eKEH7TuSwbedfW4dKuNKtCMKhfksbcPhCoJY	1578	1050	356	6301	12463	jwa4gHBCTpST9JkSjTWgo1Di5ZhBYRRpCiAmmGzXy8TgH79kDKc	10078	14213	14213	1618497540000	canonical
20024	3NKjhzviqtrHpdrQStRW9P6kzEVdgag8y5k68Pmj1V8JY5BQp1q1	20023	3NKo8RzX2S9rKUGWsjPenuqUyEoMMo6PBF3AsCpwLj6o39PbptTs	1650	1375	356	6301	12463	jwf8oFAsbDj1r2hyCepLYVtMawJ4agKzQNcdiDRzwGRPFjRn4M7	10081	14217	14217	1618498260000	canonical
20027	3NL5fTs19UtvpFo35p3h8WiFBP1qzMnPqSmcMbZTH5XuFWWN7UWq	20024	3NKjhzviqtrHpdrQStRW9P6kzEVdgag8y5k68Pmj1V8JY5BQp1q1	1619	1275	356	6301	12463	jxQvUR299uC4hr6qziQeASQDdPjFDh3xTueC1mmQjiugGWqWufD	10082	14219	14219	1618498620000	orphaned
20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	20032	3NK3rGEnGB9vwD7CGxWZnW3XRoQufJ4b7z7JTrQa6refdKmaG2ES	1407	1395	356	6301	12463	jxYCb8JxKWMDym2nt8e3voi9jKQjrSCHsDBCpXPkbZXhbYYQ1V5	10085	14222	14222	1618499160000	canonical
20041	3NKbWzU1AqHUGMKo6uRGDXQMrsKNVCECPn6ttLtyUj9UGyH848Zs	20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	1448	1185	356	6301	12463	jxAZ1e3vcMP81Ub4UAWd3DNVdgWQ9f61Tt5GWa9SeomHkbRKne6	10088	14225	14225	1618499700000	orphaned
20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	20040	3NKdJ231P3F63HKovuFZvwZ8NBqawLptyo6z7SYMwwpaSwn5woAt	369	1312	356	6301	12463	jwfdRhG32HxyKJvRveiePCJiPPLqu5mqF2q8kD1x7PJSicP3FDG	10089	14226	14226	1618499880000	canonical
20050	3NKBrx4svy3bTiBFFLbxZwnLHCL2QhKVMWP6bmdMGkjNEF8cZHhi	20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	563	1359	356	6301	12463	jwhQ3vmGx9wruKmZEezdPSDiXPtSB2Hoe8WZD3Ai2zp4F45n8Wk	10092	14230	14230	1618500600000	orphaned
20054	3NL9hyy2TySUNMAYo5qr1hrgcPrRzYuFHrXaczSKcbBnRRjDJrpR	20053	3NL63TQ37ZcxSurzzvLDNrdexoo7xZz2p1LfiN8yPg4p2pmUgUyH	1406	1393	357	6301	12463	jwDCK1ob8YWyyCfKRDqboAdi9fQ9tyNf5FLpXHFAL6jdwD6tMRZ	10096	14234	14234	1618501320000	canonical
20059	3NKmkKygKWHvoTY4Fx7at1qxWZusmBVR3MAaDJY9NU29ALTEiFRN	20056	3NL9C1FyrS5gcJm2AmJJu4XtQoJ2odoAs7fgZB5Wy5zeqPQxzXPA	1564	1212	357	6301	12463	jxB6fX7gMEUtdE9poV3559KzTHXppve3CXjH1uEBFwtzWQ1m2n9	10098	14236	14236	1618501680000	orphaned
20063	3NKQDGX7BkJVbkS8KMzorrh2BtsNt3EnTTtDo3eEWsWKyM1CCcHD	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1489	1134	357	6301	12463	jxD1HCV3SrDVqZNaaBrW5ikKAEtt9GxMBCaiQvQhatGdwoQd1NK	10101	14244	14244	1618503120000	orphaned
22060	3NLjGuXb9WVc9MuMLXZtN7Byb4hLgzJW9H3rYXqLoyC4F6MKEsZL	22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	1550	434	405	12463	14201	jwRLX95vJD9ByHNMU3z1728SCvVr7JSrSW7AkumL18FSy9qkiX9	11030	15528	15528	1618734240000	orphaned
22514	3NLyWr4117FsFnLDFHDimKHxSSf7Tab2nnR8Y8Sud4e7viw9XH9s	22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	1407	1395	418	12463	14612	jwC9GK7Wrs1gxsp1ZAChQiCaMmzU1AtB6KuFgeBY7MYQdLnoMBG	11262	15851	15851	1618792380000	orphaned
20000	3NLaq5fngarFo3FV9EdYY4UHEdqZ1EeWpzp3jes1uVqtwLi1cfZB	19953	3NLNdHyzKxjqhK4ycMWBMmhJSunY8EnWvin6ZbTQAimU4pc3KE4d	1675	1342	354	6301	12463	jxUmKQRUSFYK9Go4m2gK1sgMKopjqLFgGFp3eLy1PdPw4G5T62J	10048	14204	14204	1618495920000	orphaned
19979	3NKSfyjGankB6TXzuGsBehF4MgUSezyUyZr9ukjFBGY8hHiTwTqa	19977	3NKcTShGKTJnaxxZCN3oZZ4caWisAymQfZHc3CBMf7sVWrkf3Uq1	80	1273	355	6301	12463	jxhQ833ftCbwUucvzmmXxwJuwQNFXHMbtkksnuYnRPP218ssNGR	10060	14191	14191	1618493580000	canonical
19978	3NK8U2pb2aL4EGdbWLZmcenPRxAVocr8GBSqsPidQ3RYoA5R6Pqj	19977	3NKcTShGKTJnaxxZCN3oZZ4caWisAymQfZHc3CBMf7sVWrkf3Uq1	80	1273	355	6301	12463	jxaqTddciAkrXVQFH33ELZjDQWdxQqGjRtaCcSAPkcT3YcS6ceJ	10060	14191	14191	1618493580000	orphaned
19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	19980	3NL8UFJJAG8C5WYyAQ7qhr2hy5k2iitRPo5m94VRzJHBrRn37Rwm	1513	1133	355	6301	12463	jxg6R8UtDsnmZ8uYdJmirzALX2Fc8Sk2paTHjprB29AGmkr1sb7	10062	14194	14194	1618494120000	canonical
19985	3NLUkza3hLhT4aBsaVz35UtARrRkfG6egmmYFWZ4zvyK7xGBMYAu	19984	3NKokUvHY23TA7PRgAtS4zJA3UnTcMf1qDukUiTPrBC1m8caCmow	1406	1393	355	6301	12463	jwcJcUmW5BnJcoyJURDwFNJZper2RC4p7bjMUD4qboUpxSDbeqP	10064	14196	14196	1618494480000	orphaned
19988	3NKy3635az89f795NHLrhS1ZHVkewCZ5AJbVqfPsVm5BCuaH89Ce	19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	1596	1363	355	6301	12463	jx2g1BusUtCMqb8TCspjJqhE37wk2rxAvauXDqiDs9H3J12HcSM	10065	14197	14197	1618494660000	canonical
19990	3NKvBwz2F19mAHqgQgkam487bKnFyoT3XD6E4n9Yrk1gGcQ5h6ET	19988	3NKy3635az89f795NHLrhS1ZHVkewCZ5AJbVqfPsVm5BCuaH89Ce	1460	674	355	6301	12463	jxuxehgxhgNvNTYV2WyQCEH7GKq5WrSwkNJYHwbYGR4fv4AEWtV	10066	14198	14198	1618494840000	canonical
19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	19990	3NKvBwz2F19mAHqgQgkam487bKnFyoT3XD6E4n9Yrk1gGcQ5h6ET	298	1308	355	6301	12463	jwf9ZSPovQ3HmDcBsGz1ddG9qJu8sLtWqfUsNe3qqDqKH9bXCB8	10067	14201	14201	1618495380000	canonical
19993	3NKwBbc8mws66znqnkhhEPZaw7PgCUQXS6ycMiCr2TEp1JVzXnnC	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1406	1393	355	6301	12463	jwSTnMDcgLTR7PUJM4KKrrKHGxMU3VtuddgfARdvZcLDpwjoR4S	10068	14202	14202	1618495560000	orphaned
19997	3NLnYsHRToaNeWeuXzWpFw6fSZzVGvePUbyYtAtCDXPjpwN1QA3b	19996	3NKX6z6Y2WXBkH4V4Ek37w8yfBQ1oinV3bNndVTH1nnLvFD2rwTz	1406	1393	355	6301	12463	jxhKT6pJPoJcCrA2prHxViL8d42Pd5VYUrt9YrKu51mhr4mdWbW	10069	14203	14203	1618495740000	canonical
19998	3NLe8ZQDH2idLT6U3CYiEF9YUTkGA5UTLvQbAW5TuUNgGvCQ16vp	19996	3NKX6z6Y2WXBkH4V4Ek37w8yfBQ1oinV3bNndVTH1nnLvFD2rwTz	1513	1013	355	6301	12463	jxsNRfgjxafrw7dYtYP5ym9PgehGkf9rVsT61g2omVWnoRUk3jT	10069	14203	14203	1618495740000	orphaned
20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	19999	3NKGzmxmWmZPU9dKTn9o7SZhFNBwKe6VNFFyKtt1uL2hEHhUEU9H	1405	867	355	6301	12463	jw7ByJCgqyJRNoM7g4jZ66w58huyz4a7jKmtQeBomAurD9xQSwx	10071	14205	14205	1618496100000	canonical
20007	3NKZ1PtXNoyW3JaBzf1mj7WhmU2T55wfS9ryzNnLjzp97MP6pf2X	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	1624	1208	355	6301	12463	jwWz6n4NS9rkqFsTsdq8xwNUcUFX9CCCZXzkFqGL9QyUJVqNwBu	10072	14206	14206	1618496280000	canonical
20004	3NKjBJ8fCaJvJsjmpHae94VwYeZoTrzVFQMF4YLkomFRcVDqTH6s	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	1406	1393	355	6301	12463	jxwFAWAcvReFa28rdGkVXaWDpYp2Wn31v5uPiSFhB6sswVwKJbc	10072	14206	14206	1618496280000	orphaned
20009	3NKAAvqPNFFMNMFBHNX8s7gjLrfpo2qGjEuxmf5jW7v15uKT2kxW	20007	3NKZ1PtXNoyW3JaBzf1mj7WhmU2T55wfS9ryzNnLjzp97MP6pf2X	563	1359	355	6301	12463	jx2BR6PDJ9gg1aVbwdxhMMsxnHPrxcBAcL2qZ2JwqBVwW1CLQXg	10073	14208	14208	1618496640000	canonical
20012	3NKvNMTMgfrv2DA3RbMcE6EkJCEYuwnJoBkr5HsnyAESdCZA5Pbf	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	298	1182	355	6301	12463	jxMDTxnfAf89d21bsmaV9sAxorBfCwXvCtYCS2ZpguQkCZXLG5H	10075	14210	14210	1618497000000	canonical
20023	3NKo8RzX2S9rKUGWsjPenuqUyEoMMo6PBF3AsCpwLj6o39PbptTs	20022	3NKxh2W9wPsSw4tBoEgAog7sdTaG5M9kmm3DJzWmbuiLeJBJ6ALg	1503	1031	356	6301	12463	jxsSZVuSqJ2bK9fkzx9o5JdDKBVzUSb5j83mnxSGXREnQPyJqQy	10080	14216	14216	1618498080000	canonical
20036	3NL8QPERTg7jfh2FbK9158nrSt2SgQmKAjSWm7X2anua6RPcUh1S	20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	1440	1377	356	6301	12463	jwCRV8eTWoaCDPZLo6stxC9ToRP5XZoaEkiuerf7AF6oZkwbSKr	10086	14223	14223	1618499340000	orphaned
20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	20035	3NLVLnBFZwC7LUFkbFcvygWs4qFd71BgHM1NB7NNpLu1aAkrJUhj	1588	1392	356	6301	12463	jwZ3ioNyDZgei6GwFC9Atqsq9yKCybbqgDg6i8pgEmspJZbi5mu	10087	14224	14224	1618499520000	canonical
20040	3NKdJ231P3F63HKovuFZvwZ8NBqawLptyo6z7SYMwwpaSwn5woAt	20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	1637	816	356	6301	12463	jxU4mDUujHryG3AL5RHsMCXyxvaBZBy9pBi3T1H46UgcoMz71EZ	10088	14225	14225	1618499700000	canonical
20045	3NKMicJci6EprN4PYrWj8tvh7LmACYomwF5CuPaCTQPdFHMVr32B	20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	563	993	356	6301	12463	jwWfKQCHgPuytaFzkST89HPR2T2aSGHmndj6PMGDtdXiWVcMNXA	10090	14227	14227	1618500060000	orphaned
20049	3NLCVPQqv4KvFR22ftMM8t8qDdiyzMHtNXCbDNLixBoFrZ5UAErn	20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	1483	894	356	6301	12463	jxCREw6741vtwfzvkG8aGy7i7QVEjeRAkMZz2viGQsqYHRUugBP	10092	14230	14230	1618500600000	orphaned
20051	3NKEKJLiqeVPBBaGoWNupZSUh5DtdmBugjvmvR6XFkxjwNxRfiru	20048	3NLhsETMWMMnFStcktfjRHhWuyEwa39CE1ewavos4KWgXLYtvM8M	1402	892	356	6301	12463	jxHx3ERF4gQUYXpiYn28E2fnFU7yPrmrYhcH7hSbPJHzT9WRLHW	10093	14231	14231	1618500780000	canonical
20056	3NL9C1FyrS5gcJm2AmJJu4XtQoJ2odoAs7fgZB5Wy5zeqPQxzXPA	20054	3NL9hyy2TySUNMAYo5qr1hrgcPrRzYuFHrXaczSKcbBnRRjDJrpR	1477	1104	357	6301	12463	jwdAW2fQq5idbMc4j83kEr19oVhYukWo6DhLdTFEvwGbPBuaHAE	10097	14235	14235	1618501500000	canonical
20058	3NLENiz38Dkfctb4cmGcEpWZKhC2sdHBYndMHYt8L1KUktTfL97d	20056	3NL9C1FyrS5gcJm2AmJJu4XtQoJ2odoAs7fgZB5Wy5zeqPQxzXPA	58	1281	357	6301	12463	jxyciBhAGVtrTHGkppab26XThdwzDrCF2kQbeHH7twQm1aJ8BwN	10098	14236	14236	1618501680000	canonical
20062	3NKnw2ScoqLxev5qcP36Ep6Hg2maZ5HBVqyTncQMkL218J8EqdF3	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1402	852	357	6301	12463	jwsAxRAkRzxPq8bMLEd4YxTvBjBeetjRXm3TTPFpQ5Ggx7yi5yL	10101	14244	14244	1618503120000	orphaned
20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	20064	3NKzcwJy1Z8ZaFLssK2pjRSzgTGCiSPHZhhjWYzzcrfWiZoBkyxV	684	1352	357	6301	12463	jwy83tCkSvhWQnCFNL9H1iMBbdCysV4FNr1dr97X32ZiBWs1QUd	10102	14245	14245	1618503300000	canonical
20071	3NLhQuAvUjsPu54ityqscXCohLfn8vb59hpYBAb4fxBdvPbAb6Jt	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1403	792	357	6301	12463	jwgNrvGbDfSN5ndouZYfZj4KZpfSQyootzbgXGdtLRLgfN9tcQr	10103	14246	14246	1618503480000	canonical
20074	3NKZCzNWM8cMqxLR5Nb2TQYNHfHHKTUmcRWpg59JyjWH5HWxAfND	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1581	778	357	6301	12463	jx8nFAHuGW8K7dcGNzzjVQWnGqB1dnriDrT9P1xn6NiPyWJ4km6	10103	14246	14246	1618503480000	orphaned
20075	3NL2tygT4nB7HA8KFx4ibSbS1qNadH9eo16jV7BxnWc8zuHNoRFR	20071	3NLhQuAvUjsPu54ityqscXCohLfn8vb59hpYBAb4fxBdvPbAb6Jt	1406	1393	357	6301	12463	jwCLN4iLy93rdTeaPiiQJV3HHUqPfUJf99j7CUJ7hpBcTg67h4c	10104	14247	14247	1618503660000	canonical
20080	3NLbezfWgk8mCxUu51jPb7WvHt95639V3F2gUmEmoWsgpEGJPjx9	20079	3NKTyvxtqHLwBEqkiqsd35Aj3JcDobN61aRkBXKzhZXEXuNLZqbb	1406	1393	357	6301	12463	jwLeyNfrxnH3i139D6yYCMULt9jgWNecGHr7rFHTE1UQYNuMQcc	10108	14251	14251	1618504380000	orphaned
20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	20081	3NKbfyUzaGrnFEUW8XdtYSEzLGvzkwQch5CpWSVKiuNA4SoG6Jn5	1406	1393	357	6301	12463	jxyL6fGb8eLadTSWM3fQNYRbY2qPTyVbUuwWHPFjwJGqnVNSYpQ	10109	14252	14252	1618504560000	canonical
20087	3NKPbUtSic1jXWWR3oQgv6ybf9Xnz8oVVPd3ysoq5q41Jen3steF	20083	3NLskbi2sBLoTk2Rfs1bGSrJBCACnjEftTiht8jWy7337mLywis8	149	1283	358	6301	12463	jxNsQTicPY6cB4rvKknxev4HajUquoTxt4fJTg1qMBk6ot3hPaL	10111	14256	14256	1618505280000	canonical
20090	3NLJkosvNaizpMbEb4owVkE8EqexLo24qq1Lxhzxw7kz2eJ9tnoo	20088	3NKUNJ2npx3uCovMtzZZZ2aQwuZaeaxEmKvUjY3QwKgPrfJX666c	1648	1284	358	6301	12463	jxGpRVCnVpvspz6bXRdBPsh4koh4r7PTFUJ7TGg5MhhApUmaBVo	10113	14258	14258	1618505640000	orphaned
20092	3NLfoN18HiBJjWHK7GhhPoJBW9vVHmZay3oXKV7FLxbojjaWhB5E	20089	3NLJHgpUbNsknFaWzVbEHp74SFVyPgwmMpUTk781baAjeqkpqgGj	1631	793	358	6301	12463	jxfXNy7eDr3d5Xwm8hvXjHhZEgw57B4CMiZpu43QjJn3ahmN4zG	10114	14259	14259	1618505820000	orphaned
20098	3NKZagW1jQd8bdw8mfsSQ7jXNQ4Ct23XhvVVq5UHQjkqG5PgrKau	20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	1631	794	358	6301	12463	jw9DJQnMQwsw9Dmy7zhSJgeNjENB5Js1VPkmaUbkGS2NDpXGaer	10116	14263	14263	1618506540000	orphaned
20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	20099	3NKsBcR45nXvRSdbRZ4UqPVTtzuGGsVGrc3W6VEJ1q8vNRYbr58V	44	959	359	6301	12463	jxQVkVX8PgLo6CU1tKVioQdbe4g1i6UFt9GbJ7mbYJ5iFdSpxty	10118	14268	14268	1618507440000	canonical
20104	3NLhUPoBsL6GH7EzUfbg9GNkcvccoCudYW2ukidqfgZ3Vw4TCDfp	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	1406	1393	359	6301	12463	jxbptNiDW5gWyPxYZVnV9hDp43XzTnHTnDCrywJyCJmw2we4YY4	10119	14269	14269	1618507620000	canonical
20108	3NKaQb34WArxsWXF14ZfWENggkT9dZCGN25ut5WNb22d1tpbaRc5	20104	3NLhUPoBsL6GH7EzUfbg9GNkcvccoCudYW2ukidqfgZ3Vw4TCDfp	1407	1395	359	6301	12463	jwmUKyerQHvaDVMwVDJBcH1gurZbVccnHuUkhpk3odnz52MY8fp	10120	14270	14270	1618507800000	canonical
22352	3NK6K998PNu4xXzVHU1jzxDcXi9K1pSGXEf7pcgqR1guyZ5qPyM3	22315	3NKgUhpPju6FqZ9BeaGAfmLyFCDHz9QtJE5iDeke2R9mSxUjnCDB	1553	776	405	12463	14467	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11034	15753	15753	1618774740000	orphaned
19983	3NKYJoL1X4pZZ6F3m7BxqK8kJQHdeRL1e4vnp2hEnWLNcHkq4izM	19981	3NLYnd6z5i7vMgWmexPTE5eKaVVZ9C9RD52r8zX4qiNU34UHqA1b	1623	830	355	6301	12463	jx9bSeq4gRgL44jPbz3zELRjVDB5HhXRo3746Q55NWZ1FexCatb	10063	14195	14195	1618494300000	orphaned
19987	3NLQ8y9JF9WYqGhP7pyzNbtX1QwbRLJKw2H1c2c8AADAhUvEeYMb	19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	1509	1074	355	6301	12463	jx3miNgEctaNQFa47SM1HYuDvza6XzPMktP8Ec1uFJzr9LbR9aq	10065	14197	14197	1618494660000	orphaned
19995	3NL1MvGZ2Atdkvd1cqhdUwtRc4ZxDZNQtASJzMrcpUvkE64mHYuo	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1419	814	355	6301	12463	jwp5jPfTaBmNoDQYcSMPrySK41HQ1JRxJSfLF9A63bh8YwtLRhW	10068	14202	14202	1618495560000	orphaned
19999	3NKGzmxmWmZPU9dKTn9o7SZhFNBwKe6VNFFyKtt1uL2hEHhUEU9H	19997	3NLnYsHRToaNeWeuXzWpFw6fSZzVGvePUbyYtAtCDXPjpwN1QA3b	1675	1342	355	6301	12463	jxuY1yCw553tXr5brFCB56EfwaLhuRtx15TayqgXxsF9uYoDxpa	10070	14204	14204	1618495920000	canonical
20006	3NLingxuaxenGmDZsFEqvHmf2JPSSpAhQJCsxwUDGycXyKtGQxch	20002	3NKETK7fZiUNx9HKtrAXQMexWaJBBCUx6umutC3u3tqBV5T6UJkD	641	970	355	6301	12463	jwyN6qv3AEJeNikKgdTzrVwEfWMZ6at7jEgkoQdVdBVFy4bEkFS	10072	14206	14206	1618496280000	orphaned
20011	3NK57Bgcek4nDQNUmDfhn8ECjYWJnZYMsnGyPnzNg9cxmKPQoy6P	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1619	1149	355	6301	12463	jwePowWMKpHr2rdWpEtgR6zp9pTtbLVdG1iXY44m8qFdSd9AW75	10075	14210	14210	1618497000000	orphaned
20015	3NKPpHze615M2CJHXTnPXv8uSzzFBDsuBSSYG5Rc7DY9g2kwgNz8	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1637	816	355	6301	12463	jwMFq7Xkp7uNNWZpGuQB9VeamDgCuHogLoWZvEunbGES1bmV7c6	10075	14210	14210	1618497000000	orphaned
20018	3NK9YdTecTyyaoSrTRp7PehTeD4z8HDB2wGkcPbBvfgZbeFAVaXw	20012	3NKvNMTMgfrv2DA3RbMcE6EkJCEYuwnJoBkr5HsnyAESdCZA5Pbf	1407	1395	355	6301	12463	jxXx318QRMJ1LLnuCwYA6kgntw7CeSqcUwtm1LLoMCv2q4EAnJv	10076	14211	14211	1618497180000	canonical
20020	3NKhMWiRJvVtCyq2eKEH7TuSwbedfW4dKuNKtCMKhfksbcPhCoJY	20018	3NK9YdTecTyyaoSrTRp7PehTeD4z8HDB2wGkcPbBvfgZbeFAVaXw	1624	1208	356	6301	12463	jw9yfk1skC3tJjAAuUEhfFCXNnnsn2dBDknHDx3xHL8oGVAsYRp	10077	14212	14212	1618497360000	canonical
20026	3NLuiseRfwpKPXCNu2aPXZtHRP9UzC544AXekJj85iMoiWkqGmVw	20024	3NKjhzviqtrHpdrQStRW9P6kzEVdgag8y5k68Pmj1V8JY5BQp1q1	1549	1362	356	6301	12463	jwXQSGAjJSaN8Zu2KaArENABsguFgbDDUd6xE25Mz3zARJFj3sU	10082	14219	14219	1618498620000	canonical
20067	3NLFehztMFHj27ZuPjz8sno6BEPZbVm12MiyMqZSUBVyaiuNyzVy	20026	3NLuiseRfwpKPXCNu2aPXZtHRP9UzC544AXekJj85iMoiWkqGmVw	1553	776	356	6301	12463	jwCKKLXFYXeKiPCapS8FEheKXVVDqamm1tbzVPnCghKf3SVq65x	10083	14244	14244	1618503120000	orphaned
20032	3NK3rGEnGB9vwD7CGxWZnW3XRoQufJ4b7z7JTrQa6refdKmaG2ES	20031	3NKer5juTTJbduGpyJyNqQDrZKshgdgz3LVVBsEroJWnXT44KnnN	1672	1159	356	6301	12463	jxoo5xiXQhorBeUqzbYEJerQ522ct6tbJrPoV9UCXYKwp1q8HS6	10084	14221	14221	1618498980000	canonical
20035	3NLVLnBFZwC7LUFkbFcvygWs4qFd71BgHM1NB7NNpLu1aAkrJUhj	20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	1637	816	356	6301	12463	jwEhwmKpBVZPCw8nAoDdu9E8i4Tb4XWcpzcTrAY89QBPW8uxref	10086	14223	14223	1618499340000	canonical
20039	3NKM1GirA9GeuJJ7fAocpmwxpUSNxrrXJZ1Eiv1DsxZntVs3ws3U	20037	3NKfb2Dj5VqeeLB1MpvvDP9RSyAdcvmsEXkkDbBUPzxbt2S3xpZB	1448	1185	356	6301	12463	jwuPJjc6LM6B7avbE6PUwCv375Et2oRKPkbU3RnevXbwQ4LXNZR	10088	14225	14225	1618499700000	orphaned
20044	3NKQ88tp3QP5D1Z4Z1aetJb37kENWFRmPJgeZ6cR2W56nJHqGpcY	20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	1407	1395	356	6301	12463	jwWmg659ZfukRXGd8SxfRhov5NivrPjZZUJMs6J1gXA649FjzdD	10090	14227	14227	1618500060000	canonical
20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	20044	3NKQ88tp3QP5D1Z4Z1aetJb37kENWFRmPJgeZ6cR2W56nJHqGpcY	484	1319	356	6301	12463	jxx6zaz79FtLw7z5vM835nYk5d9xoZkR1FaC9h5gNUEw3d6Laqw	10091	14229	14229	1618500420000	canonical
20048	3NLhsETMWMMnFStcktfjRHhWuyEwa39CE1ewavos4KWgXLYtvM8M	20046	3NKZvQqrfDD3RegqGgg3RzQrzoeHJBjhW4TxSFHC2CjbNxWkXtA3	1560	1045	356	6301	12463	jxE9miV6Myi7Z6GRgREs58PFX8MvedyFfzS5DukW8EUjVoGMram	10092	14230	14230	1618500600000	canonical
20053	3NL63TQ37ZcxSurzzvLDNrdexoo7xZz2p1LfiN8yPg4p2pmUgUyH	20052	3NKnrkAKs5FLDWK6XvqjRLAdRXEbyG54WZShAEv7N5Zo3kBrHD9Y	1622	1356	357	6301	12463	jwbu9QGyj7eJ2URXSHaN5rHB1PjKF8dRCwEKYZAEPdLwZ2H5692	10095	14233	14233	1618501140000	canonical
20065	3NLFmQta77AhGa5sFcV3aGBuKGzWDmZ59jqMYjUpRkMfHtcbPNw1	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1652	1069	357	6301	12463	jwCtqvriBHYuZv9xPahJf4y7nMsicWBTKt4Z8U31hk6GQR5Jken	10101	14244	14244	1618503120000	orphaned
20073	3NKfdK1zSETExmcHRnbffE7QuPN8eAqYFHq98RHjJ5EQqFKJrKFh	20069	3NKG5TcxvE7L8PySFrwoSGk1oRdA6gmVZP2yLsD1sks5YqvSbByV	1407	1395	357	6301	12463	jwWgANBRjfSGDoGhGQrazZvyy69z5rSo38wr8q8aU3SxvERLALp	10103	14246	14246	1618503480000	orphaned
20077	3NLKjR9CWe2dT8ooxWqdDVTRpTuZzfPoVKxQmnCentmYkL8e9BZd	20075	3NL2tygT4nB7HA8KFx4ibSbS1qNadH9eo16jV7BxnWc8zuHNoRFR	1637	816	357	6301	12463	jwCc96GVvC5KU13naf9UHvjssfaNkoDdeskjniNMKSCrna39HBy	10105	14248	14248	1618503840000	canonical
20076	3NLsZViYzyHsXKdQpkRVctyXMcGXDdYFFyETRWK5SkqFEYvBBscM	20075	3NL2tygT4nB7HA8KFx4ibSbS1qNadH9eo16jV7BxnWc8zuHNoRFR	1426	1118	357	6301	12463	jwRyaAkC5DJXtReyUJNvRETTzqQK7i9a7o78qXoU8547tTec5Gb	10105	14248	14248	1618503840000	orphaned
20079	3NKTyvxtqHLwBEqkiqsd35Aj3JcDobN61aRkBXKzhZXEXuNLZqbb	20078	3NKKPArAazei278pk6HCgFsoejk9XWuuzGg7dUZ8p5dWpFu7E9Sj	1637	816	357	6301	12463	jwDmN3K9fY9nJPppz2QkX42cvJKyoCRS1TVHKa1EbWEeYnyRg5w	10107	14250	14250	1618504200000	canonical
20085	3NKgecg16aEPkVPrE1UuLEaV33BSjpkpZfzvBeUc42BcoxkcJ4br	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1489	1014	358	6301	12463	jxAKPrqAc7jEX3pxTGcyZfsXbYnu9bB5w4FqR31iBmPF94BQ7E8	10110	14253	14253	1618504740000	orphaned
20084	3NLirowv39WeR73UL22sBYmPpzWaerSHkyEJbnbuq6Gh2FKfozuM	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1503	911	358	6301	12463	jxDxCJz8yZdMbDPdnBgmSuKKiY6UU63N7PUrffS4RV1vwNkPuC7	10110	14253	14253	1618504740000	orphaned
20086	3NKiEAUEYv73yqdXPwSWrM2dPyiqBYZhVBWXQWFakbcQ7jgLeryp	20083	3NLskbi2sBLoTk2Rfs1bGSrJBCACnjEftTiht8jWy7337mLywis8	1631	794	358	6301	12463	jxVC5BBy4TQUzJs7pYmkHLf8J5x2a1sAUuRHYvF3WdtyLp7HTuu	10111	14254	14254	1618504920000	orphaned
20089	3NLJHgpUbNsknFaWzVbEHp74SFVyPgwmMpUTk781baAjeqkpqgGj	20088	3NKUNJ2npx3uCovMtzZZZ2aQwuZaeaxEmKvUjY3QwKgPrfJX666c	1571	969	358	6301	12463	jwvKWJDhHQYeWA6hwtfYFf6vSSfLQfZNJzxWAKFbzAvZaaeGoYh	10113	14258	14258	1618505640000	canonical
20095	3NKNnZAJMbAs1py4N3NNKpFk8WejxHt8EFmrnfJcecMbgYskpQZn	20091	3NKuGYK1h6Bs8b2hLazdkCtFfFjAk7Wt9YHzz6SHNY81JiDrD6Hi	1476	1371	358	6301	12463	jwWqjsnrrTxrNDTjtQjqcazvZMFSLFE8AvaFFfe3rgYoSYC4wpZ	10115	14261	14261	1618506180000	orphaned
20097	3NLsrqywfp4eBmcYJEPJMv2fjDjDhsCFuSJkazLQd5yW3aB7dSW4	20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	1648	1038	358	6301	12463	jwZ3z2kPceUhHe4mqpsXzWAtNVhSXZAUkaEZYM1uqAEo6L9Sg4c	10116	14263	14263	1618506540000	canonical
20103	3NLxYrBLdk2Ni3hDcNjxEKYNi7CEf8u995gFE5QzSsEf4Nc7VWzv	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	44	1199	359	6301	12463	jwY8WAdZNh8e4NhGXGoes3ajz9soXKMCmcSqaXJBhnf5Ys2qA71	10119	14269	14269	1618507620000	orphaned
20107	3NLmQ1dS8LPDg8z9j7FpkWZrbeReEKgwFHBTSpvGp9kbZ4gREFD3	20104	3NLhUPoBsL6GH7EzUfbg9GNkcvccoCudYW2ukidqfgZ3Vw4TCDfp	369	1312	359	6301	12463	jwDMuEvEsVuiqCYYrJ6UoZPG5s1tf4WEAaqcupWs2UrsdKZVSME	10120	14270	14270	1618507800000	orphaned
20112	3NLPtzF72qP6zCXcAEbuk1zDvPV8SRKNGDuLGBuJEmv9RfZBbETN	20111	3NKwKbTg8SjWDRBHTiTXewC8nCi9aiuPmXBLsWKnVVWnbhjb8N5P	1419	814	359	6301	12463	jy1hYfXtiMZpTjwNK7HmL7jHyP8VZ8jQZRgGnCzdkKw7yqNE25f	10124	14274	14274	1618508520000	canonical
26846	3NL2T3kxMhAR2DjDnKybHLYrNRckQLcVcVjUs4JJpaDi8fEnhYUG	26845	3NLdzrSwufXdHcAwYhznFtL13vkRWWkjchqFc9RDEtS6aKDkpPLJ	298	357	518	12463	18504	jwE9arzrHmgpKJkd2xYjBvnMd3upt2nngiULSHUF6kw9fj5ssJr	13278	18689	18689	1619303220000	canonical
29184	3NLxrQF45663i4QML3Ai3HRwkhKyZwHEXePtERMLe6YX9XXBB4md	29147	3NKofUqMvCr1vorUDtgKp3WyEapkpWiEz2995mx9qL2PaaW9dSsS	1576	605	572	12463	18974	jx9PaT69YCM96J6BS2DFzCvMb8iJER1BiHykomHCZTX8oYm9tcN	14373	20261	20261	1619586180000	orphaned
20028	3NLMhRoNSYJYTiDkscvU67ytWiS1kGSUx7vPjywsk6XJxePG5m5g	19877	3NKV8gHMFMxJDfwGY2x44rGTxm24ajqknAWwc62GtJ4cqvfY5K12	1619	1275	352	6301	12463	jxtZGTiFGJiw8qhh3TSiHXk5zvdAJ8EPZkwKna7S3aroDp1Heix	10013	14219	14219	1618498657907	orphaned
20055	3NKUWRLAHWMZXy2LxhwFChqJuhCeSQmC3EnpQzMGBMTPHSLdhiee	19945	3NKk87af1g764kzwE2SAu4VzTggzR5zNdsvmaLf2KHCgu53X2vTM	1477	1104	353	6301	12463	jxS4xBYoANr76JJAynP9mnVyqzjPBy1AS2xN6ogaNWC8sxsG3ag	10043	14235	14235	1618501500000	orphaned
20057	3NKMDAB2jAc7739kZfkgFkhkmtXDGtVnmae36aFqiVpDbWukELXN	19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	1477	1104	354	6301	12463	jx1hVvaNrTVfMATegkCibxus2HbTpcRCcZovCxvaNjgJNbXsi8X	10052	14235	14235	1618501555126	orphaned
20001	3NKwRyMLFZfM7iVSvH8WVK1vAvok8f2cL5jvFw3x7nFFTTakXa3V	19997	3NLnYsHRToaNeWeuXzWpFw6fSZzVGvePUbyYtAtCDXPjpwN1QA3b	1631	794	355	6301	12463	jxr4BiBN9XmyUhGg1yz2nACaJPMmxmd3ziN5RiAxLQB8ydLkhaU	10070	14204	14204	1618495920000	orphaned
20014	3NLscKa1AQ45ob7vEL1mKbtbfjFjnyuFa9YYaGPqKgH4bsZRZV6V	20010	3NL9kq737HinLBNj6Mk4bspL2LBvLkYsjRaKgLhLGsLJKXgQtcPg	1407	1395	355	6301	12463	jwbUxyUQNhDxMxyPhwmRMHpmjJNCtkybC1Tvhz66BYrnj6ZzyUE	10075	14210	14210	1618497000000	orphaned
20017	3NKcsXn3NrU2uNBu7eU5ATK9SEDbECF1fmGvujX42R8kvY3E2EuY	20012	3NKvNMTMgfrv2DA3RbMcE6EkJCEYuwnJoBkr5HsnyAESdCZA5Pbf	311	941	355	6301	12463	jwbmo7TUBRtoQnAfYf4AyGK3m8tRS4jE2RNzeA5eUYBNayNCncu	10076	14211	14211	1618497180000	orphaned
20019	3NK3vgfN4dA5f8EGq93XkHFSxymboub3FnBT9zfJXw53umn9SVAc	20018	3NK9YdTecTyyaoSrTRp7PehTeD4z8HDB2wGkcPbBvfgZbeFAVaXw	1406	1393	356	6301	12463	jxx3EGAxvC3B2C6wkZGeXyXhZ9kAh6WhiyPj2D1uNK3Azhad5za	10077	14212	14212	1618497360000	orphaned
20022	3NKxh2W9wPsSw4tBoEgAog7sdTaG5M9kmm3DJzWmbuiLeJBJ6ALg	20021	3NL1S5bn5FDUa8AJBL6HNBwiEX6SAbEAk8xaSs7bNZowBG9YJTqi	1457	401	356	6301	12463	jxnwf94vDBQfB6MiLho1rk3nszt9D91CwBqyHxiSZt3f1o2KX8Q	10079	14215	14215	1618497900000	canonical
20034	3NLAaQo3hrLQAu9hbv7iwXiffQxY22taMhXjP39mysMnbPwKzBxW	20033	3NKvP47upjbpUx6UkpBi8dVGjpgcRihSthzavDZ3MQ2nWoLFUC4Q	1405	883	356	6301	12463	jwVi7djqW73WYkELkGgqbTbqShaQZyxMVMpNL1bmxiuQvM6k1uR	10086	14223	14223	1618499340000	orphaned
20038	3NLoDKLrwc8ouBVTEjAa1Z6WVspKZKWyeAHqherD4juHV7akkKDY	20035	3NLVLnBFZwC7LUFkbFcvygWs4qFd71BgHM1NB7NNpLu1aAkrJUhj	171	1374	356	6301	12463	jwBAUVXmZ1bjfkgouXkQ8xmetUDqJPMdPaB5Vg6LZ7vdAfwXhyS	10087	14224	14224	1618499520000	orphaned
20043	3NKzsci66yLVjGXmBSYE4kSg1YDUzn3S2sTCxQaU2cvowFoWSQ8U	20042	3NLumxkErHw8uSCcmP6SMibGcpuuyhYCEDMT8HkZUFzMPuAudzUx	1403	786	356	6301	12463	jwEJcufcoHAH6rVh3MSCQWetuKUFWGJHUnamv1fEVaTSsws6AGV	10090	14227	14227	1618500060000	orphaned
20052	3NKnrkAKs5FLDWK6XvqjRLAdRXEbyG54WZShAEv7N5Zo3kBrHD9Y	20051	3NKEKJLiqeVPBBaGoWNupZSUh5DtdmBugjvmvR6XFkxjwNxRfiru	1610	1068	356	6301	12463	jwpvBLjsYLtLQ4AB7SR7jBJ27YA7pEMQz8HyChQXYuyqN38wkN1	10094	14232	14232	1618500960000	canonical
20060	3NLT154PUhFZAJLdXpYTbHvRjBqeiKvcndqzFeZufrmn35xJbLAJ	20058	3NLENiz38Dkfctb4cmGcEpWZKhC2sdHBYndMHYt8L1KUktTfL97d	1405	867	357	6301	12463	jxG1BPay9U9H3r36EcZFA2TT4n8i5tNkvKWg32EcNqTKFV6zpJy	10099	14240	14240	1618502400000	canonical
20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	20060	3NLT154PUhFZAJLdXpYTbHvRjBqeiKvcndqzFeZufrmn35xJbLAJ	1631	794	357	6301	12463	jwta6rfg254fXjxuGoZuFVkS172kL86GT8gdBpLepSeRFGYdhwV	10100	14243	14243	1618502940000	canonical
20064	3NKzcwJy1Z8ZaFLssK2pjRSzgTGCiSPHZhhjWYzzcrfWiZoBkyxV	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1407	1395	357	6301	12463	jwDZWXp6prcLz4MLEwurY3HdGU4hpvAadu6N4juYxnyvebLU5Sz	10101	14244	14244	1618503120000	canonical
20070	3NLeEeoH7i6wfgbHQExKSRocNzc42DtQtVBZr8zsJkc7NFJsCGUu	20064	3NKzcwJy1Z8ZaFLssK2pjRSzgTGCiSPHZhhjWYzzcrfWiZoBkyxV	1607	1102	357	6301	12463	jwtMz7Wi1q8v7JTjxk7h9hLwVJrnFK6S7ctwR1gBB92XCTZ76Gm	10102	14245	14245	1618503300000	orphaned
26860	3NLxXSeegEP9LpmqmFArmk3CMjRhxxE8ciUbqySbwX61sF18SoXT	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1406	1393	519	12463	18516	jxA9JrauAKtxuHDTRzyWNtUYDSHninRAW8afZ5cD2tSVxthVme7	13285	18700	18700	1619305200000	orphaned
20078	3NKKPArAazei278pk6HCgFsoejk9XWuuzGg7dUZ8p5dWpFu7E9Sj	20077	3NLKjR9CWe2dT8ooxWqdDVTRpTuZzfPoVKxQmnCentmYkL8e9BZd	1516	1294	357	6301	12463	jxoFoWJ9UocxwusYxhn37GfruR8dFwKE3P1dkeSXrtRHUiHvryb	10106	14249	14249	1618504020000	canonical
20081	3NKbfyUzaGrnFEUW8XdtYSEzLGvzkwQch5CpWSVKiuNA4SoG6Jn5	20079	3NKTyvxtqHLwBEqkiqsd35Aj3JcDobN61aRkBXKzhZXEXuNLZqbb	1403	824	357	6301	12463	jw9gNU5ba42b4WM2TrWe9RsGUsQdbaeGtXZ28iQAZttWS2sbq2p	10108	14251	14251	1618504380000	canonical
20083	3NLskbi2sBLoTk2Rfs1bGSrJBCACnjEftTiht8jWy7337mLywis8	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1503	911	358	6301	12463	jwPy8aiVbZ3DRVV1EwkdWU3tvY6afjt6ydJHivhmjtQq1RkjgJz	10110	14253	14253	1618504740000	canonical
20094	3NLD6pngMrH6FDm5WmoqhsZyXc6WhiFd5K1ERz8jT6o1V45TarPn	20082	3NKAtKxrsWyGcSKBueGEZqyCq2H7NTUDsT8xH1FeNBNwQ32N95eh	1547	1252	357	6301	12463	jwhxBYghdCp8WJPTLDz478pT35umwxv9dDV4XwUbcnTwTYpgtQa	10110	14261	14261	1618506180000	orphaned
20088	3NKUNJ2npx3uCovMtzZZZ2aQwuZaeaxEmKvUjY3QwKgPrfJX666c	20087	3NKPbUtSic1jXWWR3oQgv6ybf9Xnz8oVVPd3ysoq5q41Jen3steF	1573	1318	358	6301	12463	jy2SAqWicQbxdvUj2KVR5xdjdLiaRMmv9ThycasXjAMNXWyZE7f	10112	14257	14257	1618505460000	canonical
20091	3NKuGYK1h6Bs8b2hLazdkCtFfFjAk7Wt9YHzz6SHNY81JiDrD6Hi	20089	3NLJHgpUbNsknFaWzVbEHp74SFVyPgwmMpUTk781baAjeqkpqgGj	1407	1395	358	6301	12463	jxT2HbbnUQ8UESVtdvZoa6KRgE6fFoEuQQRLVxDuYFC5RboxB6h	10114	14259	14259	1618505820000	canonical
20096	3NKCu8KPP4MnsfwvT6cdLWpFNbBognJy1a8i7GBUycjzDKguHwb7	20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	1643	1299	358	6301	12463	jwHmWFRFXN88BaXCHbUsUBi3DxfVXxhaDaFZNxxxvFHLB1fm3EQ	10116	14262	14262	1618506360000	orphaned
20100	3NKmCigB35CqV8pH2c3YeEhzrrYqJS8y6QC7UPQNtgqFWfuWSeug	20097	3NLsrqywfp4eBmcYJEPJMv2fjDjDhsCFuSJkazLQd5yW3aB7dSW4	1439	1153	359	6301	12463	jxkrUzRo5AEW1n23iJbBLyw2aj3NkACU7eiJ6NycYSBFTFhYEg7	10117	14266	14266	1618507080000	orphaned
20106	3NLF3XzjxVJsAaP5q4hKUdiiA3uvTdP4SbGFodvRkzqQme5euHhE	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	1440	1131	359	6301	12463	jwDWPZEDedKuXyY6ALP6wvrf8voz5ZEhncvr7UFGonxqFzyi8mS	10119	14269	14269	1618507620000	orphaned
20114	3NKrt8eTeCT8k5qYeEfeERWe79t1sJgyj9qutkjpiSMxfu13tExT	20113	3NKEkiUZrR8hj3PLM182M3VoTHjUtFkKjN12fhBUaYpq7E4aCL8L	1407	1395	359	6301	12463	jwEeo2SsfTDFQxghictyQqBT1UQmUQto8abYZMU5fuZzt9MyCNi	10126	14276	14276	1618508880000	orphaned
20121	3NL2rMjHivnpZ4Rc4gXBosNapGanPz8g52o2c3655Nfp6ATRcNCK	20119	3NLo35NdvXKMu2V3u5mskT3wHu3imUDmuNasWk79b9CNBaRDEHz6	1631	794	359	12463	12465	jxcDwceuA4SeK4uEzAWLvcHfrnjRzFR6XhBq5v2RsoJpLAwa17Z	10129	14280	14280	1618509600001	canonical
20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	20122	3NLbQNzKqGrraXirGoWg81gGZm14tkZyVxqCXwKXCMP4ohKrMP9e	1529	1190	359	12463	12468	jwaGHxKaX5gxmSPbi8ThwPWwF6DEXgPWoehDVreQLFu4uovB6FM	10131	14284	14284	1618510320000	canonical
20127	3NKt7HVu4S4d9Q1hpB9oEf5mhCD6uQGDKeCddLwvUYGF17BonFyS	20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	1624	1334	360	12463	12470	jy1iJFsubP3C9D8KgNrQL1ivbeipwACC2Y9iPdGexyZcryLuKAu	10132	14285	14285	1618510500000	orphaned
20129	3NLubK2BwLtwvo1wBh2dpLV71J9MH2nrEAGAeqqX5LacLD46mNui	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	1652	1315	360	12463	12472	jwjtAYiTg4iZ4GfL4PTBQj5cb5KtuQDUrZ9xgtprSnhdeUdu2kv	10133	14286	14286	1618510680000	orphaned
20138	3NKG8p6bMQAmEKc8FF8tAGtqQeEdZbnbTNa6D6gt7W2teCH8Nh4n	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1610	1314	360	12463	12479	jxZKQHskHJFLE75MFGbyTp7De23Y9tEUmDspdttSG87QsqyuLmg	10137	14292	14292	1618511760000	canonical
20149	3NLLiqgyQaZ47VrQbywvVfpwmp91MMURFiTuXAYGRme7yynTZ5Aj	20148	3NKQgvYckGLUfnNREsTT1ZQ6uJxnxWvxVu81yLLD6pXUeskaevza	1608	1163	360	12463	12490	jwC8XSSjvkVXe9incYHRQLvn7mEaKgNqRfABTe82KpghkfXZYkp	10141	14296	14296	1618512480000	orphaned
20157	3NKzsFPUJGVbMjeGLpQ1dbHMpw2sM9MV9gdAvLtsmXezmtzJAADH	20155	3NLsY39qfWiqM5YBB1Cn8PV33kxMB2ubjehN18NQG9bf23hnxv7z	1619	1275	360	12463	12498	jxaMw9Ysa7wZhWen4fc7q3UY4A92vnDoucTC95cP7tBmUwGnxYC	10147	14304	14304	1618513920000	orphaned
20161	3NLaE67ffLQMg3muGGMMLmht44jvbR7ojmYTYmQiRFzxByek4YFf	20159	3NKfcSUpoJ5xBkLrqVEHQfZaPV7QVMbkjyrKrH7NSSNt5u9x36dD	1407	1395	361	12463	12502	jw7WMSCFZCyZx2VBNPHdFTBsiUYnyC1QXpb6YPV8A9uUDhW2y9Q	10149	14309	14309	1618514820000	orphaned
20168	3NKAtcaaHjMRTootcN3ZVoQTmvhaQoHjnwQp7Dd851YW6ibWMgFz	20167	3NLr3QFSCNJ4pZHAWQ4Tfbo3zgdhWb9DVKsmcE4mPaw8rxDxVjRX	596	1180	361	12463	12509	jwSgmXDUKKZyyQ77ZkhCvyrP12Ki1sruru8PdsP9wWrSY2XFm34	10153	14318	14318	1618516440000	canonical
20173	3NLm5wdkX8KcYh7Q5ZBA5uB5yKD78TnGjTFB1wAkk2wBFHU47Wv7	20172	3NLkTk1A316tV19UiqMBubYSz47KZNAiFJxLtHnXHecM2wJWXKWf	1407	1395	361	12463	12514	jwsaXm7DjWhjHEfMqc5HQinTxBjL9iWvMjrxNR39pWTcN9MJAxF	10157	14322	14322	1618517160000	canonical
20183	3NLE6nNLznKq6NGFm7b5zyYTGxjUghFbdntKoREravzK8XHaMwaH	20180	3NKo8UGvV2H4HJgxEd7V4EJ9azz6xY73tGc1SvzpppM7YznjrPkK	1407	1395	362	12463	12524	jwcFRtKsGXAjQTkTWwrTTzhDbXVvVZmERFRwcRyXBcHEJYzr5jQ	10163	14333	14333	1618519140000	canonical
20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	20184	3NLEp9R6zzve9tVXAx6yoDcpaPFUjzU51PWHmAaVsS18PynPB4hp	684	1352	362	12463	12527	jxMLwMXmHhS2naepMMfPiaXLceh3nuSR9uSLFRYUScYKMq4AtEh	10165	14337	14337	1618519860000	canonical
20191	3NKL3KmWSEWnm7dDGdZvZvJdbBT5qPBJYb2wJoE3w4yLTTmV1d8M	20190	3NLWmHaquCBfoLMVYcRekSepTvqJF4h8YaKDmtRuEo4iBDro21kG	1654	974	362	12463	12532	jxTVvghG4N84Z57NBciSZCCyASBW6322RgdC7J34VtETCR8eXoR	10168	14342	14342	1618520760000	canonical
20194	3NLVu8xR4wt9hoW7wyWZxp8dD6G5GrLUGU2FMqvyMWzkbkRnfCK7	20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	1672	1039	362	12463	12535	jwfR3LkGXi5Nx9pSneVkJNuNYcaDgE3vJMSPWQRmayFYow7bx1u	10171	14346	14346	1618521480000	orphaned
20199	3NKmffdbAieqorD1PUAiGaYbTWeU9CW8DFhcqA4bP5sLWqy23ghZ	20197	3NKL5G3Cm33iQYdhwxKnSqditWULA6QrrkqJVyqYMKQdZKQ82nx8	633	1258	362	12463	12540	jwg98WJo6XHwQzKjRRfc8aZnx3XG7Lc4T9rkQcsxmfxfiU5pZ2t	10173	14349	14349	1618522020000	canonical
20208	3NKE8p8YBy1A3reqkoq2L2esuN4NGqNSXEcWp2gnfQsVf2qsJqfJ	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1403	824	362	12463	12549	jw9uDU7KkMhcSSz67L4iAfTk8L5PVbrTP4AiPa4k3v1NX2TrAdm	10178	14354	14354	1618522920000	orphaned
20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1585	1366	363	12463	12558	jxUUMGB43Z5Cwaxf1XhwYBXgB9dohX6hmtnGmbYeZJktTvVrofE	10181	14359	14359	1618523820000	canonical
20221	3NLkSDG1Mog6pFMnT98hhYsYHtMQsoPGN3iP2bSu1hn1RhVUvH8t	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1560	1165	363	12463	12562	jwPZsPu3mSA5Faa6ws459hzSooDiXvpi9RAwDNqwT4da1vKQ2t9	10182	14362	14362	1618524360000	orphaned
20231	3NKgNHLELo6MWnMCvDADNxW1RtzCQ8semVMsf1B5m5yfeBVByHNa	20229	3NKxRV5Vf2UzEoKNsHovcgjSr5oSGChUjqKP2JGQcW8EembNpE2m	1501	1360	363	12463	12572	jwmK3zyrDWFWrncCZRGqADQU7BBz8384bF3dNYrQpE6hetSsUWP	10186	14367	14367	1618525260000	orphaned
20093	3NLMtR875hbMeyghVRWwj46EBYWfuUvVxcKz4uQQS5YA2dDFugNm	20091	3NKuGYK1h6Bs8b2hLazdkCtFfFjAk7Wt9YHzz6SHNY81JiDrD6Hi	1547	1252	358	6301	12463	jwwSJDsCbCCBkiaJSkB4UvmTFrEamsv2EKy6218DvJj3MPQ4Jib	10115	14261	14261	1618506180000	canonical
20099	3NKsBcR45nXvRSdbRZ4UqPVTtzuGGsVGrc3W6VEJ1q8vNRYbr58V	20097	3NLsrqywfp4eBmcYJEPJMv2fjDjDhsCFuSJkazLQd5yW3aB7dSW4	1602	1369	359	6301	12463	jxKNdUuQxNa7P6RgfaVqDAs2yKiEJhJXgkWhzsdp8QD6Z8N5JZd	10117	14266	14266	1618507080000	canonical
20102	3NKTKJvUK9zKf2Vb9L4ABaDLdZfqjjaPNB8xTGbMaJtgwwkP26zf	20099	3NKsBcR45nXvRSdbRZ4UqPVTtzuGGsVGrc3W6VEJ1q8vNRYbr58V	1406	1393	359	6301	12463	jxsAA8aDNWYWrBZKwHjNP9hU7rg8rEpWdPBdvXbKbzTyEibvvnU	10118	14268	14268	1618507440000	orphaned
20105	3NLmTft1m6vwtCxt2Bj3dEsxKP6fxTKKFuVXAhfE4AqRfYazeZsA	20101	3NKt3MWmSengUcFsaVE1z9HVx4ETowBiRMg24YyERmJCQhzkSzid	1407	1395	359	6301	12463	jwgBnSZR5pX4ydyHi6xEExCyCAiCxvZb6JcMUarnZg6Jjxu6xoK	10119	14269	14269	1618507620000	orphaned
20116	3NKgYpgX9TmCAWyCTnRKtBtj59gaNm2JRsC981RJ6eGxfd8HrpBS	19792	3NLa2W7ts7qTwoJA1J5BS7s4vuFzwcTNEriquNNithibKTFutFop	532	532	350	6301	12463	jwWbADVExzSxeP5wNqaXPcepS9ucp1hMSw46mSJXMf9Tuo33SWa	9969	14276	14276	1618508880000	orphaned
20162	3NKn4rWLnbDoJxucfopPNsw5ykBZVgmMGLG1kk6364VfLF6pdiBB	20067	3NLFehztMFHj27ZuPjz8sno6BEPZbVm12MiyMqZSUBVyaiuNyzVy	1553	776	357	12463	12503	jxMT6mfnnVNKWj2JaEguD1mUspe5sqrqtoEwPN8vH4cRAaX13oA	10084	14309	14309	1618514820000	orphaned
20182	3NLJdwzqVPGMKSo1kMyTqVrJUdvYbyBayN5PaPZ3wkME2mA2gEbn	20162	3NKn4rWLnbDoJxucfopPNsw5ykBZVgmMGLG1kk6364VfLF6pdiBB	1553	776	357	12463	12523	jws4wgm2oUCYMkVKqbQifPKFx16i8qvWSwXppCovRgTzngkxYSu	10085	14332	14332	1618518960000	orphaned
20110	3NKaccQknFLjFbxrakGztYH6vEFuA5HAHavCgbFFyp6NdmmTc38v	20109	3NLZ6BvV3eecioxyEoyyPJPPBZnJU7vZbfKrBw4so12L4EcjGQbo	43	1310	359	6301	12463	jwFwiehAEskC44gzCKfodQXq8TnnYEV9PSySHbdTnkbZqcn1E7W	10122	14272	14272	1618508160000	canonical
20111	3NKwKbTg8SjWDRBHTiTXewC8nCi9aiuPmXBLsWKnVVWnbhjb8N5P	20110	3NKaccQknFLjFbxrakGztYH6vEFuA5HAHavCgbFFyp6NdmmTc38v	1652	1315	359	6301	12463	jxvHvJUkLYrmeHc7ZgbuGaM7WYy3r7Fnso3TkThdNT3dKwaoHwN	10123	14273	14273	1618508340000	canonical
20113	3NKEkiUZrR8hj3PLM182M3VoTHjUtFkKjN12fhBUaYpq7E4aCL8L	20112	3NLPtzF72qP6zCXcAEbuk1zDvPV8SRKNGDuLGBuJEmv9RfZBbETN	1536	1313	359	6301	12463	jx3Hwsx2VnTey69WqpH7t8fSLtSSmB986K1xUwBQJ13RS7UG8fp	10125	14275	14275	1618508700000	canonical
20118	3NL7Z1Vwnnv6zNJpzmxZMx79m4pFB5rRAY3kBjyaeqqVy7RrYsdK	20117	3NKP5iMfu5SbVsb6ubkxPnyyYUs5ToLp4aBbFHcaJnpvuXFAGM4i	1406	1393	359	6301	12463	jxHYG9Yo7GHp5Ub4WT3FxmgJwTzZhEQCSZkXeHdukwYMnPcpJVg	10127	14277	14277	1618509060000	canonical
20120	3NKvW5TmDwppVrudkPCiZioEkq33LkYYHzTzVNFVgx3ZJDd7w7hM	20119	3NLo35NdvXKMu2V3u5mskT3wHu3imUDmuNasWk79b9CNBaRDEHz6	1506	1373	359	12463	12464	jxyAAQhgsFerXiNACNKfaSzq8jPPEnQWfxJ1kPoyNYyjmAsfngU	10129	14280	14280	1618509600000	orphaned
20123	3NLuqaGzPzahv7k3vNQnMJC1qFUsVwnJFrJgVaekutCjkrdq8Wjs	20121	3NL2rMjHivnpZ4Rc4gXBosNapGanPz8g52o2c3655Nfp6ATRcNCK	1643	1299	359	12463	12467	jwtNakHfhDyMGcDC5ZNWMcSjFoyh4wRNzSTxo6ixwz9buGeyL37	10130	14282	14282	1618509960000	orphaned
20131	3NK4hBsQkX5HRLaASzMyqs9jbWSnEfL4bobSK91VEo8f1isUNeAT	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	1652	1315	359	12463	12472	jwjtAYiTg4iZ4GfL4PTBQj5cb5KtuQDUrZ9xgtprSnhdeUdu2kv	10133	14286	14286	1618510680000	canonical
20128	3NLvG1HN74wuFFw8fWrw3T9JrAxeBLLCmXEWCMdBGf4G7gmgsEDX	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	633	1138	360	12463	12471	jxE4zqALNkH5xWkQ4URaDQzVRYBuRD2zxzfqucZxHieHUjWTEx8	10133	14286	14286	1618510680000	orphaned
20136	3NLUQbS8Dwt9YgPBdqWcgDi7iChU1M6MbCw2XYQHtrscZJxkoNRF	20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	1637	816	360	12463	12477	jxNFw2yXoXG7UTPuoTEhKbar36Tqet7JaXfnkn59QBGeAUNwdGB	10135	14290	14290	1618511400000	canonical
20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	20138	3NKG8p6bMQAmEKc8FF8tAGtqQeEdZbnbTNa6D6gt7W2teCH8Nh4n	1406	1393	360	12463	12483	jxyHUntxPjMjoZKa7BkoU1qvLb2x8Yw3iNzbxyzNBiCeXqNaLHg	10138	14293	14293	1618511940000	canonical
20145	3NKG9QGpFpbz5ZuMPHGewEYE9xavRLcDsdn8zvXi8DdaJoTvRb2w	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1407	1395	360	12463	12486	jx7NFUHaWJAgc3G66kRMVkrzy974XqSdaziLkrHFm5A2RaaA8tR	10139	14294	14294	1618512120000	orphaned
20151	3NKJsHccU92kHfWh3q3HRQzSkiUbAzWRaKC28gQXLUqtqyTZKgDc	20150	3NKJ9H956tN4HXCUbfKKes67yXen5jFn7ZDUSuSSCfSJz2aWfzkh	1419	814	360	12463	12492	jxhHcdDQDJVFoHYA4dbwTF6V7Ro5DbQjxeFetoFh1RCncix9ioM	10142	14297	14297	1618512660000	canonical
20154	3NKVzHRKKCtk1nDGvSpBmjsjjE2JLGa5VLomXVEFGus8giHU2tEu	20153	3NK8bxPy76Mk2Wh3Rh1fDMKMTK8zy8kVm9U4hs1enyBHPYdNLZg9	1499	515	360	12463	12495	jxDmqthpB6jpEERV9wd9dTzECzXeUZwSwBQLLSp7a1J8otN7D9L	10145	14301	14301	1618513380000	canonical
20160	3NLWD4yDXkZX11LsB1bUy7Xof5osjs8dGLj2vymEcCDfBHiCx8rd	20159	3NKfcSUpoJ5xBkLrqVEHQfZaPV7QVMbkjyrKrH7NSSNt5u9x36dD	1589	1286	361	12463	12501	jy2ESDiWRgwGzMeeL6qLXavwJqw7sdHqx9TWnhXYdjsyMraoBCr	10149	14309	14309	1618514820000	canonical
20165	3NKp6ZJ1WVdw1fxWGRcfWKFJ4wf2nHCS8Hb9Mh2vizt6xgHYaMa4	20164	3NL2kUHgwfKxorboTYNsNQqfJgFdw25f4bsevtLbByXJ8CWTJYJw	1675	1096	361	12463	12506	jx6Kk1Gv642NdvniwkMUJLniQno3CvnuBEe1xictAamNf8Q6mc7	10151	14315	14315	1618515900000	canonical
20170	3NK5WSNbd9PBH1qSXkdPZwUBUUD5B311XFE6njJ6QQNRW4jmXBb8	20168	3NKAtcaaHjMRTootcN3ZVoQTmvhaQoHjnwQp7Dd851YW6ibWMgFz	1407	1395	361	12463	12511	jwC9ErLVMj9GzFA2UPS5ZNo9737RfhaC9Bti3wJNzfjpNULx98q	10154	14319	14319	1618516620000	canonical
20176	3NL9rjpLTdXbMuezXnzAP1b4g21QynNHpzbN56PQPxc1q67SoBHW	20174	3NLsvb3rh5gKpx3vtMMru7Nozcdp9umV1dGSzrXGnhUEY5MzRsEh	1631	794	361	12463	12517	jwDFhebdjTGfVWQR56d8hr6CWm5qUq48vCJjsEbepyUMJC6djuQ	10159	14325	14325	1618517700000	orphaned
20179	3NLXu4DmYi9VXh7nigMzG2ad7iZZm4NRboy7rdeHRuwdPzD1RVnW	20177	3NKWTjKBgFzhK3YxqvfJ7P8TNK3HW3uLuxgJcbfmPwrZHFjKnxdZ	1439	1153	361	12463	12520	jxBPYnTWLmpg9BEjZDrHdLcJ3ThkfMbsxsFNpX4w961iMHoLFit	10161	14329	14329	1618518420000	canonical
20188	3NKCZ54B6ATecXHCoJ1hVV44eQ8mufdkj3vErRAWKNqmZ5fcu7KE	20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	1467	1376	362	12463	12529	jwnBNiyRCajgfkiATqVzH4yx7hkjF6hDDePkfWgVUz7HNFAn9Yg	10166	14338	14338	1618520040000	orphaned
20190	3NLWmHaquCBfoLMVYcRekSepTvqJF4h8YaKDmtRuEo4iBDro21kG	20189	3NKY56JgkHWSRYRHCmMZTsCx3LZhNPK9PXKwzpFCnecVL8sGQ57L	1406	1393	362	12463	12531	jxk1QXA4du5DgM4d7HduSSA7f1dKocPU4MjbmAaSH867zoxRtV8	10167	14339	14339	1618520220000	canonical
20201	3NLQC2VwQKbAHEypEhySsghnD9wiB8DfS68xVnqqEb1E3ERDGbdz	20199	3NKmffdbAieqorD1PUAiGaYbTWeU9CW8DFhcqA4bP5sLWqy23ghZ	1402	900	362	12463	12542	jwW9uRxrBVYSHk1dWTCVwNkJTVhR3aNoeKrzsyVtozwnDcCdZvb	10174	14350	14350	1618522200000	canonical
20203	3NLvSa1bf5MxgmqjPMJYV3u7pA76W9eXaYtXXqMmuPHXPGG4SNtV	20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	1483	560	362	12463	12544	jxLovp2UE7DUoX2mrpR3JB1ajQvWNf5vhUJpHgZMo3iTfbooWh4	10176	14352	14352	1618522560000	orphaned
22500	3NKQY3wYTrAGvSufsEhJeCb3ikLHYh2dghpJLJJz3Djg4Krna89p	22483	3NKuvJc7NtGX11dkf9Wpd6et8StuZ3epQdbgzK9qXu4vU7esmsjE	1553	776	405	12463	14601	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11036	15843	15843	1618790940000	orphaned
26881	3NLD7HVAnM5Jbuf7AfAGQNiGaFPYpECKTU6EZ6ZUpu1Wze8rY7JC	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1534	256	519	12463	18535	jxEsfQnzhL2VaRuKGD8Xb1qNg7JEcGw1UXmvLP9eaN6fc3Yp3VG	13293	18709	18709	1619306820000	orphaned
20119	3NLo35NdvXKMu2V3u5mskT3wHu3imUDmuNasWk79b9CNBaRDEHz6	20118	3NL7Z1Vwnnv6zNJpzmxZMx79m4pFB5rRAY3kBjyaeqqVy7RrYsdK	1406	1393	359	6301	12463	jx9ErQnMb2Y6UxfEFzmjNV4TMFWNJnd7jPJdfQ4FKBV9RtFGo6n	10128	14278	14278	1618509240000	canonical
20122	3NLbQNzKqGrraXirGoWg81gGZm14tkZyVxqCXwKXCMP4ohKrMP9e	20121	3NL2rMjHivnpZ4Rc4gXBosNapGanPz8g52o2c3655Nfp6ATRcNCK	1406	1393	359	12463	12466	jxNPSbQGMnooUjyAuPeufPRzZZ9zReboukdTeJGYNzk5B3RNH9G	10130	14282	14282	1618509960000	canonical
20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	1659	548	359	12463	12469	jxm5Jd4jW9vBrEftkci1GGVH8KWyP9nMafu51GwZgzu4hUqT3By	10132	14285	14285	1618510500000	canonical
20126	3NL1pqyYAB2XLZEcJmULJHhRZWD3cPmvCc1KxCGwcF8kK6jmzpTt	20124	3NKBoL88xpJYRuWG3o4f1qTaHsctZTqEL2HunoipB85iCsFg4hgN	1624	1334	360	12463	12470	jy1iJFsubP3C9D8KgNrQL1ivbeipwACC2Y9iPdGexyZcryLuKAu	10132	14285	14285	1618510500000	orphaned
20130	3NKCjZm8fBorPQYDHSULUmUPYF6LUjfhA9LfMPtDnXghax3koBGQ	20125	3NLo4zC7298EgXu2QC7bGSSZd4toQabD2mR6A7GXbHssgu5cpXWY	633	1138	360	12463	12471	jwQ9EVBotzcLKpDW8PSqosPPRwZn1XASngJ8et6pZfquxfA3b1f	10133	14286	14286	1618510680000	orphaned
20133	3NKjNQqRJ5kK2Mc7wKZC1tV2cNycMZc1AntnDEhacNKqjtFTqQxg	20131	3NK4hBsQkX5HRLaASzMyqs9jbWSnEfL4bobSK91VEo8f1isUNeAT	1637	816	360	12463	12474	jxQAqLQ5yKRjkdXUm7q16G2hH2M9R3TpKGfrAjPJPbBFJuo56uu	10134	14287	14287	1618510860000	orphaned
20135	3NKxmtvGtQK5t6Nbne2C3jwDqmjmUZ1YRdQUHFEXc353PhSR4QyV	20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	1406	1393	360	12463	12476	jx5QurucGfY5BoknzxAKXyjbUB9rikvy9bnmw5iD71p3XPZrZJt	10135	14290	14290	1618511400000	orphaned
20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	20136	3NLUQbS8Dwt9YgPBdqWcgDi7iChU1M6MbCw2XYQHtrscZJxkoNRF	1406	1393	360	12463	12478	jx6HDJoSPrK4nEqijEf5EUjrSAmPDfT6yDvXVigX6UgFM3W73PV	10136	14291	14291	1618511580000	canonical
20140	3NKB3eiocBqERcbE4R1djNTkoonhWXC7S4jEBmTaz91gMVbGhFL8	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1403	824	360	12463	12481	jwkYcYpngDigrsn7U8wyyURdiezDBbwcSZLBRCd2gaNrpi9SayG	10137	14292	14292	1618511760000	orphaned
20144	3NK7JbV5HH59BtBJGKueGFXqg5TMZv2Ph8es192hKm8d69TNGVkT	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1440	1377	360	12463	12485	jwYwmivpPphoCSPfNqSrXJaYicE39ZaYVVWLUFcpDami97KakdH	10139	14294	14294	1618512120000	orphaned
20148	3NKQgvYckGLUfnNREsTT1ZQ6uJxnxWvxVu81yLLD6pXUeskaevza	20143	3NLkGRdwNNzWzbZfMhAcvZizfzY41PbfaRwnKj4a1mrtXJLDeqRm	1617	1042	360	12463	12489	jwURmK87jG9vPEwCkRkeSgQZTgg2kseUbCT18CJTf7hkeDaUn2T	10140	14295	14295	1618512300000	canonical
20153	3NK8bxPy76Mk2Wh3Rh1fDMKMTK8zy8kVm9U4hs1enyBHPYdNLZg9	20152	3NKCAYWP1dThMZiWsKNse23Ak2CAUCev37YDYJ4dmhSwfZJGJa7a	684	1106	360	12463	12494	jwbmhaLDjYVgWrvJKLxgsLRkkT2PRXAym3Xdk1jvTCcLBvTTgHH	10144	14300	14300	1618513200000	canonical
20156	3NL8jX8mNosSTBJC5c5US5FCcK6kvS9o5cmGcdCuHmpzeaZhxzU4	20154	3NKVzHRKKCtk1nDGvSpBmjsjjE2JLGa5VLomXVEFGus8giHU2tEu	1405	867	360	12463	12497	jxmBwdH2LyYBADkveiXpiazbUvkfBhSJk9vXXBPiRi2hb8zKPNU	10146	14302	14302	1618513560000	orphaned
20159	3NKfcSUpoJ5xBkLrqVEHQfZaPV7QVMbkjyrKrH7NSSNt5u9x36dD	20158	3NLHpmpsFCNxjAyhXPKQPmDmj1aAVes4kMaEiidfwCWfLM89bZbR	1549	1116	360	12463	12500	jxsduu9cgiV8FVdmXEFh6vK4X761jVxUPdFrBE7FJYb1BNkXDwZ	10148	14308	14308	1618514640000	canonical
20164	3NL2kUHgwfKxorboTYNsNQqfJgFdw25f4bsevtLbByXJ8CWTJYJw	20160	3NLWD4yDXkZX11LsB1bUy7Xof5osjs8dGLj2vymEcCDfBHiCx8rd	1602	1369	361	12463	12505	jwTbC8XTpHwJBh7vCc9NPe6JbVvcPMpCZWG1HX42Hk5WyGHeavd	10150	14311	14311	1618515180000	canonical
20167	3NLr3QFSCNJ4pZHAWQ4Tfbo3zgdhWb9DVKsmcE4mPaw8rxDxVjRX	20165	3NKp6ZJ1WVdw1fxWGRcfWKFJ4wf2nHCS8Hb9Mh2vizt6xgHYaMa4	1547	1378	361	12463	12508	jwTAFd8TwLoewXUjjCV6sxECLtrMAC39e5W2EbbubHt1ctSyFm6	10152	14316	14316	1618516080000	canonical
20172	3NLkTk1A316tV19UiqMBubYSz47KZNAiFJxLtHnXHecM2wJWXKWf	20171	3NKBvbDoevnBtHr87cdXHUbpoRHpwqgJFSn6tKqLCFqioss87yKo	1447	1345	361	12463	12513	jxtndVmTm4B2gZ9wcHP6uX9NbRhNTVeAv7tB64cMxDWcjsApjwZ	10156	14321	14321	1618516980000	canonical
20175	3NKwKJWyLKmvhyJ6S6ssZKveYDND1SZN8bbh6mspSpjC9SQf3ZEp	20174	3NLsvb3rh5gKpx3vtMMru7Nozcdp9umV1dGSzrXGnhUEY5MzRsEh	1407	1395	361	12463	12516	jxr1an5cGyBy9ZSinihX4xAZZhSm9eEt4s4mR4oSPt4iKdBmQ4b	10159	14325	14325	1618517700000	canonical
20178	3NLGPcUKNzqZ6Qhim8niFTmfLsuyckchzzT43x6KMKcqZYw8XUib	20177	3NKWTjKBgFzhK3YxqvfJ7P8TNK3HW3uLuxgJcbfmPwrZHFjKnxdZ	1594	1326	361	12463	12519	jwEwTpAuBhQ2Zptf3TCA6VYWAoehppdZ9Puq4VrESHSLqtk3gn3	10161	14329	14329	1618518420000	orphaned
20180	3NKo8UGvV2H4HJgxEd7V4EJ9azz6xY73tGc1SvzpppM7YznjrPkK	20179	3NLXu4DmYi9VXh7nigMzG2ad7iZZm4NRboy7rdeHRuwdPzD1RVnW	448	1305	362	12463	12521	jxUWFsFL2ZUNG9uiSrrJ8dUHFsHE4Pp7xgfeHEVRsMbdBZwK7F6	10162	14330	14330	1618518600000	canonical
20184	3NLEp9R6zzve9tVXAx6yoDcpaPFUjzU51PWHmAaVsS18PynPB4hp	20183	3NLE6nNLznKq6NGFm7b5zyYTGxjUghFbdntKoREravzK8XHaMwaH	1581	778	362	12463	12525	jwNGYma6GmypWmPQAUBePfUgqiQPoFTTCjzF8PNveLcAKG9jqVu	10164	14334	14334	1618519320000	canonical
20187	3NLpb63UfKECAsySnopz2YRTaWXGKQ7eRhQhXVS6TgKpj1s2XVyE	20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	1406	1393	362	12463	12528	jwqt41G1EQpEdnDcn4C7LAABKsctj4FGh6KkKF2pYQEGmgzC6jq	10166	14338	14338	1618520040000	orphaned
20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	20192	3NK6kHx8w7bMjs7XMvCvxfLXKtuHWGBxRcXmsXGY2d88Vzq4SPfk	1553	775	362	12463	12534	jy3CF4hQKgM5MxmXcVAnNZuAvUuVSnxXvqoD8kTuHwu365MpSgW	10170	14345	14345	1618521300000	canonical
20196	3NL6JePvNwGFtnvqtBT4FBeTKY7Xcx7EQ9KeiyqyVcDYLjRKbdEF	20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	606	1169	362	12463	12537	jwPphNNNEh55kwBv3nSbG19GXNvPzexcp1mujXaPTDVDTitiMVE	10171	14346	14346	1618521480000	canonical
20198	3NK7FcYKfnC2E7eJzTt1hSs4yBKPHUT9mJukv99f64yZqZaSDEoQ	20196	3NL6JePvNwGFtnvqtBT4FBeTKY7Xcx7EQ9KeiyqyVcDYLjRKbdEF	1578	1296	362	12463	12539	jwS7mmEcPKxjCkViFLcGAynnEzXBVgwbNi7kZy1Z13hDe2yLw1B	10172	14347	14347	1618521660000	orphaned
20200	3NLVrkWor7LGH63Yt3dF51CvzvXnmkQjQHHWTYNpuEoBrpuo6GJy	20199	3NKmffdbAieqorD1PUAiGaYbTWeU9CW8DFhcqA4bP5sLWqy23ghZ	1529	1070	362	12463	12541	jwk8YGHMrpLLANnaMJGkuuNyrXBE3h4PSEKg16axmYnuhwAEe9m	10174	14350	14350	1618522200000	orphaned
20205	3NLdzPgunFRrod954Q31wwjLXyhpQsvp6ScSyNE87nSEmgHVDT6b	20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	1601	1022	362	12463	12546	jwytKPqg5X2rbNQpa777MKTWueGFaUVn5GnDoRskv8JVVZtH4zS	10176	14352	14352	1618522560000	orphaned
20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	20204	3NL3dRvp1EpA4u4wzLDUcggiZvNaN7EBKQesci4YtphZuMNnifxx	1407	1395	362	12463	12548	jxsFBqDPPg7BmJxADUAREiHeoFwX1zfN4J7MZ7EwZ61vMRqiA5L	10177	14353	14353	1618522740000	canonical
20210	3NKEq3y8Bu2LgJ39FShpsSLPwi9Bd8Ngiof9NfVRzaNNzGN31HUc	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1508	1021	362	12463	12551	jw9p5zyz8GfC2ymWWsjiUW5feJB1tNLmaTEXKeuez93wMgN7gGu	10178	14354	14354	1618522920000	orphaned
26889	3NKHpBdNQfvgKRc1yiE31NeCJyApAZRfQPEwr1XWH8qiHCdBMtPF	26887	3NKpHWsCbtLZPKi9naYgfN2nCgXSZ56YARMhp9iUaK9mj9tCmAvC	1402	882	519	12463	18543	jwrTvXWyjEDG5ibyfUAuUP5xZ4WDXNQvYGo7U1DchJbbDQRPL4x	13297	18715	18715	1619307900000	canonical
20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	20131	3NK4hBsQkX5HRLaASzMyqs9jbWSnEfL4bobSK91VEo8f1isUNeAT	1422	1337	360	12463	12473	jxDZsBA4M5oKfZBoY1zhL9wb9NYS6VXYJ5bJC3ghUEA2cxyJf7g	10134	14287	14287	1618510860000	canonical
20134	3NLn5WQYvAxNy61Xu4HmK1mHBWnfdUaM9XsCYg5urdKfTniRvY5o	20132	3NKLzRkoXYy1iTfy52Koma7FxSaHcSYkCYB5AZpa75hdJ59ztFLv	1671	1365	360	12463	12475	jxuF5FbuQMb8MNbKraKMJbZTL3ENFg9xbR7Q6k3tXsLhsQtcLXc	10135	14290	14290	1618511400000	orphaned
20139	3NKXen5SFCN4HJ6LUrSZqK8Yrbk4NdiN9T5GHZd8eiZWHxeChrMw	20137	3NKw7jPTRipZGkVuMEyxZ6EmAKukJRP3diWFUeDs68YoZz15Bins	1406	1393	360	12463	12480	jxe2iVvEmRsLKmGamTJwEKB9QvgxxaXNFLgeYVFu96tFE8b87kX	10137	14292	14292	1618511760000	orphaned
20143	3NLkGRdwNNzWzbZfMhAcvZizfzY41PbfaRwnKj4a1mrtXJLDeqRm	20142	3NLKawxk9tcQ9RhdtdKBBUxzZuxrkWiBJ5unY2rSQZa7HJbqwCRQ	1406	1393	360	12463	12484	jwWUFzXXYVH7KstGsnroyyfxEpuZFpxisrARtCbd5QsAa6HByKe	10139	14294	14294	1618512120000	canonical
20150	3NKJ9H956tN4HXCUbfKKes67yXen5jFn7ZDUSuSSCfSJz2aWfzkh	20148	3NKQgvYckGLUfnNREsTT1ZQ6uJxnxWvxVu81yLLD6pXUeskaevza	1646	1108	360	12463	12491	jxj2pQtgFExPdFuyskDUakWKAtCBZAWpCJbW8bBrxDwiP3YBKVt	10141	14296	14296	1618512480000	canonical
20152	3NKCAYWP1dThMZiWsKNse23Ak2CAUCev37YDYJ4dmhSwfZJGJa7a	20151	3NKJsHccU92kHfWh3q3HRQzSkiUbAzWRaKC28gQXLUqtqyTZKgDc	1406	1393	360	12463	12493	jx958qgCyypy7rxc3pwQS6iy3gkPe5eC67fejCzMoJX2UGkNkqx	10143	14298	14298	1618512840000	canonical
20155	3NLsY39qfWiqM5YBB1Cn8PV33kxMB2ubjehN18NQG9bf23hnxv7z	20154	3NKVzHRKKCtk1nDGvSpBmjsjjE2JLGa5VLomXVEFGus8giHU2tEu	1654	974	360	12463	12496	jxUPZuMimQifJECD3FZf6MkDSsht8hzB2GTxEgeEpYRpUZZSA7S	10146	14302	14302	1618513560000	canonical
20158	3NLHpmpsFCNxjAyhXPKQPmDmj1aAVes4kMaEiidfwCWfLM89bZbR	20155	3NLsY39qfWiqM5YBB1Cn8PV33kxMB2ubjehN18NQG9bf23hnxv7z	1483	731	360	12463	12499	jxukT587L4E62aEdNnqK2zVczCpUNVFTSLCs2dDRZyyBU2iTbjd	10147	14304	14304	1618513920000	canonical
20166	3NKFG9BC5pyLWVk1Fx7nFSYbwu8TK2N1chjTyhF1hNZ4pgw6bzqX	20165	3NKp6ZJ1WVdw1fxWGRcfWKFJ4wf2nHCS8Hb9Mh2vizt6xgHYaMa4	1403	782	361	12463	12507	jw9t395RCTNk95bgAmX28L9fB8FRvyt96iSUafsHsuWQqSqWb55	10152	14316	14316	1618516080000	orphaned
20169	3NKCm4tDNTHHu7oZoFDXEiZjgYz6cw2Qj9MPTwLcWFVfFfzdJGCX	20167	3NLr3QFSCNJ4pZHAWQ4Tfbo3zgdhWb9DVKsmcE4mPaw8rxDxVjRX	1406	1393	361	12463	12510	jxUnD8AfJpNZUyX7sKi3yjaNrRCTE3vZpzXr5FoJEsGCA5cr9yH	10153	14318	14318	1618516440000	orphaned
20171	3NKBvbDoevnBtHr87cdXHUbpoRHpwqgJFSn6tKqLCFqioss87yKo	20170	3NK5WSNbd9PBH1qSXkdPZwUBUUD5B311XFE6njJ6QQNRW4jmXBb8	1467	1010	361	12463	12512	jwek28Gf6XCXouqq8qRtyGoSK6SwDiAQjVAfutHsFQSbqCheTzn	10155	14320	14320	1618516800000	canonical
20174	3NLsvb3rh5gKpx3vtMMru7Nozcdp9umV1dGSzrXGnhUEY5MzRsEh	20173	3NLm5wdkX8KcYh7Q5ZBA5uB5yKD78TnGjTFB1wAkk2wBFHU47Wv7	298	1308	361	12463	12515	jwW3kaSHqD5Dn2LHdqq8nJVV43x32nEUTCmJMmpoFEzNpHZzdcR	10158	14323	14323	1618517340000	canonical
20177	3NKWTjKBgFzhK3YxqvfJ7P8TNK3HW3uLuxgJcbfmPwrZHFjKnxdZ	20175	3NKwKJWyLKmvhyJ6S6ssZKveYDND1SZN8bbh6mspSpjC9SQf3ZEp	1439	1153	361	12463	12518	jwHkecHT59JQxnR4MYH42SKQ7heZYUaj3RGZZJZdNTthKFgrPBu	10160	14328	14328	1618518240000	canonical
20206	3NLRezAc8ZhWzZrupUquzvyj13fHt1aTddNdvpx1xjWnuZ1oEGz3	20180	3NKo8UGvV2H4HJgxEd7V4EJ9azz6xY73tGc1SvzpppM7YznjrPkK	1439	482	362	12463	12547	jxQY9pH1N6y7JNXBLKZnqzXiL5nsnA6C7QcJ5sWxXzHXzsLBMsa	10163	14352	14352	1618522560000	orphaned
20212	3NKb3rkwPYvxXkRM9baXeJGM46W14dpr4SHdPNeE52L1cyUHbzYF	20206	3NLRezAc8ZhWzZrupUquzvyj13fHt1aTddNdvpx1xjWnuZ1oEGz3	1439	1153	362	12463	12553	jwBePJ99d4XnNbdgb6h8bo8S1GC9acBcawpm58YtfFP43g3sUzu	10164	14354	14354	1618522920000	orphaned
20189	3NKY56JgkHWSRYRHCmMZTsCx3LZhNPK9PXKwzpFCnecVL8sGQ57L	20186	3NKQJGo2uKzicARP2U6w89sNvGdqrSVgNndjh2dUemRQCJqB7GH5	1419	814	362	12463	12530	jwB5jpwS7799wgXzU15sVciYSAotMDkatf6VgQMB4tdMzwJbnTC	10166	14338	14338	1618520040000	canonical
20192	3NK6kHx8w7bMjs7XMvCvxfLXKtuHWGBxRcXmsXGY2d88Vzq4SPfk	20191	3NKL3KmWSEWnm7dDGdZvZvJdbBT5qPBJYb2wJoE3w4yLTTmV1d8M	1509	1320	362	12463	12533	jwi1fYdX1a2dQTZGcSeTdrJyFNQHJE3qX36ydJK3BrmcpE9d526	10169	14343	14343	1618520940000	canonical
20195	3NKzDFvjx1bZLCvURXzVUhwcQqYqiGPdghN4ZC1PcT3Tb9nhWe9d	20193	3NLvfbc18bUCcp95Fb5MRvhZcESfxhTcuYNxW8NTBsHmWYA6RuKM	1549	1116	362	12463	12536	jxCyq6qJaBTnJ56HxPMkYGSgGZxQjYyjqWadkYiodU2ejLYzvuM	10171	14346	14346	1618521480000	orphaned
20197	3NKL5G3Cm33iQYdhwxKnSqditWULA6QrrkqJVyqYMKQdZKQ82nx8	20196	3NL6JePvNwGFtnvqtBT4FBeTKY7Xcx7EQ9KeiyqyVcDYLjRKbdEF	1405	1	362	12463	12538	jxa7STNgz85QtyKqrZ9MeLHs1KX39wcWoeXxuMxFWBiRiEWpvM6	10172	14347	14347	1618521660000	canonical
20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	20201	3NLQC2VwQKbAHEypEhySsghnD9wiB8DfS68xVnqqEb1E3ERDGbdz	1407	1395	362	12463	12543	jxzvjj5wVPTsQhBKE2XRTXFUysKd3wACk5CB6vx9DAeRKAV9aYV	10175	14351	14351	1618522380000	canonical
20204	3NL3dRvp1EpA4u4wzLDUcggiZvNaN7EBKQesci4YtphZuMNnifxx	20202	3NLcA6XzXRm5Aqm5S2c3Ti5X1GMsU7LVrdRyRajgak3kWWTWVUub	1439	482	362	12463	12545	jwxaJn7EfBGDf9RoSwFKiQCj7MiEzc49EYAVCh6PjVPB56NipA5	10176	14352	14352	1618522560000	canonical
20211	3NKi2JRprYA9yGsG83awT5r3gCLjU7Y5Wbhdzm3ZfrutTkh2ZxNb	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1439	1153	362	12463	12552	jwYV2kzWkunayjySMt6tzmgoYTJkSNccdsJEbsZRzBzJ7vvmrTL	10178	14354	14354	1618522920000	canonical
20209	3NLPmMQCY95Kw7CYBBvPnzuCarr7UuBxRKBii9ksq8GiXu3gs9q1	20207	3NLWGErGjo2yPBNPq9JjprSDsBaUxy2ywbjdUzqeppa4nqSbet3v	1471	1260	362	12463	12550	jwvcJFf4bG2odct4jHTS1hxfSZedjwcC281imtsoknHb4ydpEsP	10178	14354	14354	1618522920000	orphaned
20213	3NKYMb6i3sH5KKW3g7xfcYQnCvdmhEVovL1No222ehHK67F4AUYB	20211	3NKi2JRprYA9yGsG83awT5r3gCLjU7Y5Wbhdzm3ZfrutTkh2ZxNb	1407	1395	362	12463	12554	jxWyzJYF5HrYorzQ2PW8xFtYUZDejBSt5iJKhacDRRp2PMSuaWQ	10179	14356	14356	1618523280000	canonical
20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	20213	3NKYMb6i3sH5KKW3g7xfcYQnCvdmhEVovL1No222ehHK67F4AUYB	1406	1393	363	12463	12555	jwNBEC8Bdcc6sMs83PMKxuv7g7SutbjFuYV4fHvSkUdG1f3sF9f	10180	14357	14357	1618523460000	canonical
20219	3NLftWSpfsZ8vEG9Fk6M2VwdDi6CZNAbD8z9yFr8AiEfFAVAHsBc	20214	3NLwzQUPtzpfxmyohYhu6nyQEAWyQPUvfbQTWRuCZ58J8FeTZc8k	1577	1327	363	12463	12560	jwNwMNdgdLjtAA9vvLbPJ5CcG54fQCU6jyUuvA2pohbNFt9ZP8W	10181	14359	14359	1618523820000	orphaned
20222	3NKXEbSXDSxQosgX8rFY2MH7Tdw8vs8uJTQCWEm54EzGewWQ6veA	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1407	1395	363	12463	12563	jw7eQBMkY4NJFqgQ53rUkhX9qpw2FZKzabvkiQrqAbkF7y5chCf	10182	14362	14362	1618524360000	orphaned
20226	3NLa42EW4QDB5EsNH9hmLGV7tYHi4UmP75cx8s54gNgSXgF8QmdA	20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	1634	1205	363	12463	12567	jxWC7nrQtMWuzsT3yY9NAuAa6D5N9WqGToRg7MsA1o5RQaKwz9s	10183	14363	14363	1618524540000	orphaned
20234	3NLLF7zovNx8Zk8oGXkPcRd8Tyxg18M85aoKN317VxCWF7d6mLtf	20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	1501	1114	363	12463	12575	jwpY4wAPwKBxndVtc5U929czfNCSVMf5RF29aHFT9YtVmoc8KSr	10188	14369	14369	1618525620000	canonical
26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	26895	3NKrAYMrPVqUugbzzQMVPwSJpTKKRyX3bzD92u5aMtyVrfC54EV9	1594	960	520	12463	18551	jxjaswsrqenQnoXWw35HMPxkkc3wcmeyvQkGcz5MoTcS6iJvpai	13301	18722	18722	1619309160000	canonical
20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1589	1286	363	12463	12564	jxybvmNC9aPth55tuvp8rVCwDkoKTKNWSrxBFxutiPa46p8k3Uw	10182	14362	14362	1618524360000	canonical
20220	3NLr3QvGY9N653YVP8CYxd5qXt8gvimjufBbEL4fixRSUnU4A5Re	20217	3NLG6g6TTr466fDk91cFnpxC3UtGbpcWCFX5fJjGhwBCVeeKsSB5	1507	1154	363	12463	12561	jxQct574wFYsdLMMAEA2v5YaBZTySFLPDBys5dszwrfyyC9iSZc	10182	14362	14362	1618524360000	orphaned
20225	3NLETtH6pNGUxZH7bsDPqpPqKBabDkkgSatAFs6XdiWD1vZ2DSdU	20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	1406	1393	363	12463	12566	jxzgwxH9bNzEcwHKqAhkfc6cDGq3rLdcP11WsYW2uH3VLmhaQLM	10183	14363	14363	1618524540000	canonical
20224	3NKUvWDehe8KBdxjnNGVjM9NUzyttbcLRe25eaWL7ZNi3XHyN6vc	20223	3NLs2bCiwmN8ctqzBQtS4fLcXoncKrjQAZXdpYHnYyEX93Sd2bx8	1503	1031	363	12463	12565	jx6L1Vr8Sap2Huejm77HWJaySGiMW4cczyEuUc3TmVDTo2mLkYE	10183	14363	14363	1618524540000	orphaned
20228	3NLM61Ky6J8ZdgFPbGmrEtx5S4tmt5Dr5CSzBpQ7f6WpUbDamyi9	20225	3NLETtH6pNGUxZH7bsDPqpPqKBabDkkgSatAFs6XdiWD1vZ2DSdU	1406	1393	363	12463	12569	jxnW7ZPfqFoNfwAjqUWXnjoPz31KwRyz7LT2dJiuRAdzpS18mHG	10184	14365	14365	1618524900000	canonical
20227	3NLVpZ9btxB6Z9Aa2rCUCJWp2bU8Pzw8RL28dNXJXfgGxfoq21qH	20225	3NLETtH6pNGUxZH7bsDPqpPqKBabDkkgSatAFs6XdiWD1vZ2DSdU	1656	1097	363	12463	12568	jx6RRKNYKhaJDtZjeS8pvTzqYDm4Vcbp7DYPQc2JZVf25EwnUkr	10184	14365	14365	1618524900000	orphaned
20230	3NK4cpFnqtVZJFymDHWRKtjg9jRzRDuqzbx2eg9d8Y8Qe2xxGVE9	20229	3NKxRV5Vf2UzEoKNsHovcgjSr5oSGChUjqKP2JGQcW8EembNpE2m	1579	1389	363	12463	12571	jx5YbHqb56isxB3wpFp5vPzrt8hAZfuPKy5KxgbpkMmAFDNETzS	10186	14367	14367	1618525260000	canonical
20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	20230	3NK4cpFnqtVZJFymDHWRKtjg9jRzRDuqzbx2eg9d8Y8Qe2xxGVE9	1489	1134	363	12463	12573	jxKYQTFqEUs6C29n2Q6VTron5X77kKkgCtU7Fq85qbDvfM7hr6Z	10187	14368	14368	1618525440000	canonical
20248	3NKfd89ohE4w4iLyN9R4eUYPRdRETWCkJj5zEaoh6g4kdVsfG68J	20246	3NKyfMSPLsmdn48ZctsvRQhEah4nCJVcJuGSC6ZMZDpYZ2ngP3PY	484	1193	363	12463	12589	jwEYz33cM1mW4HEz4YJWoXMidXD9np2x6qcQtntShTDTKfH4QHh	10197	14383	14383	1618528140000	orphaned
20250	3NLjTwQUr3L161WUaK1BGFbtyQL5kNBLtMT747f4MMUNse5dudHH	20249	3NLQPTR7EyVLCCW8gKNdtiz1cXXUqYZC4bKvm4ktXqgrks7nTCmC	1483	603	364	12463	12591	jxsV1MeXvzpvE1p86u4PvvUBxWPgnpsXYH97W5zYepFfSxbSLeQ	10199	14385	14385	1618528500000	canonical
20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	20252	3NLWeqYAPg2mmRw2ef8bjSzP3Jh3cq2LSu5XZESP1PzLCPmnEsoB	152	1084	364	12463	12595	jx4CDe43mLzLJCo2eJzJGHFJwH2WFPh5nHprh3JKfgxrmenYrvE	10201	14391	14391	1618529580000	canonical
20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	20258	3NL3BXDSygNdr7PkccL4e2YpBWvDvQNZcdthaFKf5BbxxX3DVZvz	1406	1393	364	12463	12599	jxeU6J1KEEMyyiWpNSQjAYsjQQsyBMCrMieNp2KGSConxA5Nqmp	10204	14395	14395	1618530300000	canonical
20262	3NKRkm63XQCcvDkS9ZBTBYpfCrsr8yhENkw5N4eBaBWtbt9kXmME	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1403	824	364	12463	12602	jwfaXVXhXz67tJDLuk9kjf9SRgaKBTGEujmXnaCuGJr5d5ruby8	10205	14396	14396	1618530480000	orphaned
20266	3NLogKGTYMuYdtd8pUFRq6rLvG27vkarnWpefGvuvezABHro3Luy	20265	3NKawpTzHCfbq1bmpzd9SMZMQ1Ywd3aDjXfVM2vFRHHHaZ1RfEmR	1578	556	364	12463	12605	jxU8DGsX2cQvhmLcxtDpZ5yHy93ZPzCi86hDVr13D3oo4SMUQNT	10207	14399	14399	1618531020000	canonical
20268	3NLBYM5pyjwBLyzaZbFXJecBRcmVbRu8qntKgMN72BndaZRc2iAS	20266	3NLogKGTYMuYdtd8pUFRq6rLvG27vkarnWpefGvuvezABHro3Luy	633	1138	364	12463	12607	jwHHan6hpZTCYLtRz7peCd9syhNa179Mesnx1T7UgWCqDU2rHHf	10208	14400	14400	1618531200000	orphaned
20271	3NLV7BS5f13L3siPZFehcaSoGCxDHxJ4hd73s7YAC9Noz5ssJBEB	20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	1534	1071	364	12463	12610	jxDLzSVzvNnJfNsvRU2HH7ex7RRBSMr3V9wXSWaFPJkbzravzNY	10209	14402	14402	1618531560000	orphaned
20273	3NLg4WAXPSFfzmrTYmZtVtcmD2GiLbsBM52fVW28drEvwakNZyrU	20270	3NKWRceBkp2E6VrregAPnF4Kk7ZrWBX1NoTkkB94wTQw2TQX8u2G	1406	1393	364	12463	12611	jwKDfvd81CiAN9t91Znr2A1e9nLQMmvQYrHnscWuk4A22vz1ZEi	10210	14404	14404	1618531920000	orphaned
20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	20275	3NLPNuP3gHnDkGdv32VD4xyPdab7oBgEPgxBnPe8uAxWBRRWVvN2	1587	272	364	12463	12614	jwty4rMTpzwY8apgm4JJ7uVEwYwso1JtWa4cyozoGC5d2GtegCp	10212	14408	14408	1618532640000	canonical
20281	3NLosPLvHi83Q2eK62u4rfdmZg2j6MN27NG5sXG2ed45e6RnM2Vt	20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	1633	1390	364	12463	12619	jxFxWUuTEf9gQALfz4bBLsaZo3UTf3UXnv83G6YR9dLppq3Qb4r	10213	14409	14409	1618532820000	canonical
20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	20281	3NLosPLvHi83Q2eK62u4rfdmZg2j6MN27NG5sXG2ed45e6RnM2Vt	58	1281	364	12463	12620	jwx5tRsLMDCB6B7NLMMXt5rnDvUceFhkS43qAkav1sRNSwjNARJ	10214	14410	14410	1618533000000	canonical
20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	1406	1393	364	12463	12623	jwpo9V7cjBvCRPCLthEw9xH4pFWjaqXm7Pp6LzDjRPPEFgVLJ8y	10215	14412	14412	1618533360000	canonical
20287	3NLjXbTkifY4uPGwa9goodQfpCmxUaFFz9SMydv9BAJVPySn483F	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1426	1118	365	12463	12625	jxEMNJn5LFrBrHFaB5n8H7vNwuJ4Ncs3pBmNFUNqrDNT1bhuEub	10216	14414	14414	1618533720000	orphaned
20296	3NKKrBYRqgr1syKuh8gPd6chQTXhy7SM18974AhE7UKDGeFJe5Cu	20295	3NKEgzahxvFEFw77FM5vYJ24Z9KQQPJ14opi6wRUBiLZyu8AUDQF	1407	1395	365	12463	12631	jxs5aM1LpoqKoWAVWvT2bUSYfpfTe5TT4tXy3p9cRPU81ZTkztq	10218	14418	14418	1618534440000	canonical
20302	3NKgnzheFCxWAXsspdewVzAYFRRALo6vJA8DYKV5FvLa5eiEX9PM	20301	3NLcfebKPqYZkA2WzAWhYZhY9CHzWC5KfHppqEiVZzvixtf6fn3s	1564	1092	365	12463	12637	jwsxd4KKYKQANtKzv9gzHH94eQuiCPpnc1yx8S7ebsKZ7G52BqC	10223	14425	14425	1618535700000	canonical
20304	3NLKnKyXowA7kBCh4H6MxQm1iv673fbLaeoDKBM6DAefqPxJqixN	20302	3NKgnzheFCxWAXsspdewVzAYFRRALo6vJA8DYKV5FvLa5eiEX9PM	43	1310	365	12463	12639	jxvP6GdALsAbuZ6pPtcJjsWvJG34ny8EU8tLfZZLtBhjAxYFr6v	10224	14426	14426	1618535880000	canonical
20307	3NLhovLn5bZohNwPuEGfE5C19TppAW5UcjBxCEveTwQ2oUKEdxFc	20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	1559	1107	365	12463	12642	jxgEXMEX8ipuTipA8p7s2wHAiqMjhvMWnMR7q5iBcQZ47zPUnhf	10227	14430	14430	1618536600000	orphaned
20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	20309	3NKPmjcEEnD1yuY7EdJ14CmFWydczPnp9GUNjZPQrzvpvnVsB6SQ	1553	776	365	12463	12645	jwVYuFgFBwECUexLSkqugz12h3RPaHDicfr5yb8f6xooqHhRVBx	10229	14433	14433	1618537140000	canonical
20313	3NLDNae6D4x3vFQtGcZJvEyeyHoGYRoHTGtsmFRFS9CmFT4wKkAr	20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	1591	281	365	12463	12648	jweUubJZsa2pNepBsiYE5UTgWcSFhxE6m5GFhiSfm1f8kZ1vn5H	10230	14434	14434	1618537320000	orphaned
20323	3NLneU6witPtDomacb4WHNTfuMAVhHKKCNRgxmhtJn3DsXt8qMqv	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1406	1393	366	12463	12656	jxAbgLmNnnkrSYKg9GVTHehVq2qjD3F5wmumduUioHMhSDU2uPL	10236	14443	14443	1618538940000	orphaned
27351	3NKpG4oKepVh23mqzvJHQ6SvCrFeoGzEQzsKy1fLoyLXehTiBY3G	27213	3NLZqx4NT4Cn8wk8Z4qT1FxwEXo6q23kyAm2oXTWWaunNDJoGuFu	1516	1294	522	12463	18966	jxHG7ECEFSdASXUHi1UHMHq2iZ4aTKSZvWPLUy8TcG1J3MwJXKa	13314	19028	19028	1619364240000	orphaned
20229	3NKxRV5Vf2UzEoKNsHovcgjSr5oSGChUjqKP2JGQcW8EembNpE2m	20228	3NLM61Ky6J8ZdgFPbGmrEtx5S4tmt5Dr5CSzBpQ7f6WpUbDamyi9	1668	1370	363	12463	12570	jwRJnxLpkMVJjb71aGhycNvZSHmR1E4GwbP5TFhUgydo5vpe5c9	10185	14366	14366	1618525080000	canonical
20235	3NLg4pag5zpcwJshJJxjJJX4MTV83tQiYShRBNX1ZBz8woNi4sVq	20232	3NKehrdtais19ts3w2epEjcdwkRBLbuixZN1xvrh1ojZsdeheUpt	1439	1033	363	12463	12576	jxYp8x5TFZprdF1Hn6sfwjCYxUfxvGyJkFP4Y1P2pHN3d4GyxCT	10188	14369	14369	1618525620000	orphaned
20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	20237	3NLL29mpY872dcvG7thsoou7qCq9x8djcBpEaKneS6uvANahK2wJ	1559	1353	363	12463	12579	jwUbFwvRRTHivdhT7Js5ozExDWD7TPSZ88H86bsNg818qFvCCx6	10190	14371	14371	1618525980000	canonical
20239	3NKqdCvWMptLLLKuFsKRHXVzaUtZhZawsLB3YqsLWArXtZneyhGt	20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	1553	776	363	12463	12580	jy2w83UPtpS6Srkr3KCtYJ3ouKk7h9g8EGYD7Vt3hxWMunjtGcw	10191	14372	14372	1618526160000	canonical
20241	3NLh9jz1Gnsag4CecuZAJ3esEqdETb5tTdbr5xEJvSNbC2YU36ya	20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	1407	1395	363	12463	12582	jxRqsp4UWAVWjCoxe3FbaVp5B4ew3Kf7R2Kc5rBSHhKbY1PfgdU	10191	14372	14372	1618526160000	orphaned
20244	3NLGYAQeD5xVGuokVTrNV8E7c3v9bSnKAnVpn331gwKt5FtV9cCV	20243	3NKHFsmkRP2Lbpfi5q4v4xwkNRRteUryKDqLmgxAbYA6tZhT72St	1529	1316	363	12463	12585	jwz83UCGKqaXfpr2XPPWkTcQ4MjGiNWux27cbrz4ypiS2fRBiBS	10194	14376	14376	1618526880000	canonical
20246	3NKyfMSPLsmdn48ZctsvRQhEah4nCJVcJuGSC6ZMZDpYZ2ngP3PY	20245	3NKys76karPnNSGTmnVD83CbECS7NFTsggzCWyqbH2wUP42qmNYB	1610	948	363	12463	12587	jwhfkmzhfKJLP4tPViCU6Eb9vL45tzLHh6U3yufU7swdizH4GYX	10196	14380	14380	1618527600000	canonical
20247	3NLQRsaSK8zSv7U38JQZjyvbfYLLThnGRmGR8Wn4GEqHubrBvvCf	20246	3NKyfMSPLsmdn48ZctsvRQhEah4nCJVcJuGSC6ZMZDpYZ2ngP3PY	1406	1393	363	12463	12588	jwx4otcJSuy2zjCHDHbwy2iyf1my4C8E7S8euH4L8n5kWrdH8ZF	10197	14383	14383	1618528140000	canonical
20251	3NLGKx7hHByRch6DNVvdc3Xn5e8n5sX7NjpaZBCRtCyBa1LAtGZR	20250	3NLjTwQUr3L161WUaK1BGFbtyQL5kNBLtMT747f4MMUNse5dudHH	1642	1367	364	12463	12592	jx41kBFwPcRkT72GYZ5CqXpTh8wsj2gRvztNih6zicmRwYGxcDo	10200	14387	14387	1618528860000	orphaned
20253	3NKU2B6fuoEyELhC44d7n2hkKG8r12pAZFyiP7y4Agwa1rVgp7wd	20252	3NLWeqYAPg2mmRw2ef8bjSzP3Jh3cq2LSu5XZESP1PzLCPmnEsoB	1407	1395	364	12463	12594	jxUurdfEehwVLBcDRaSqQFrSPrVwrLgHgMknudoHz3mKDqHppU9	10201	14391	14391	1618529580000	orphaned
20255	3NLCZGRoCK58J33Witbsu79QtzXAzRZ3NQFUVWcmKRzatvyMRm6o	20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	1634	1205	364	12463	12596	jwH5ewUSJYWXCjBwVWNWTvyKn9AvwaKYwcHqZepnAh4jT57bkZZ	10202	14392	14392	1618529760000	canonical
20257	3NKVUy9z2x2qurSsEmkGXTczCVQtjZDuXi5T4V5t7Ru8sY7xd4Ur	20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	1581	778	364	12463	12597	jwc5Z89pa8N47st7MVVvGDYFtZU8SLs5JLcJc85UTaZ23Hb39df	10202	14392	14392	1618529760000	orphaned
20258	3NL3BXDSygNdr7PkccL4e2YpBWvDvQNZcdthaFKf5BbxxX3DVZvz	20255	3NLCZGRoCK58J33Witbsu79QtzXAzRZ3NQFUVWcmKRzatvyMRm6o	633	1018	364	12463	12598	jxLqbjg6NCvykWdw2dHCGsDCb6oYXuFYz5EaQkVT7Jbuy87ow4r	10203	14394	14394	1618530120000	canonical
20261	3NKNeJTmv8n5EZXuuFTdazEPMsktY6ffEoTUc2BBNTpp8sfK3SQi	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1507	1280	364	12463	12601	jwkCrCYyz3BBiyYfBDT4H5iYaPUs3DV28yPCRCYg3sFb3yXDkbL	10205	14396	14396	1618530480000	orphaned
20270	3NKWRceBkp2E6VrregAPnF4Kk7ZrWBX1NoTkkB94wTQw2TQX8u2G	20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	1402	858	364	12463	12609	jwMPhzEWvXddgmy8ZMyHZctnT3BNfEuuipCRtkMLyvtEzH5Ac5Z	10209	14402	14402	1618531560000	canonical
20275	3NLPNuP3gHnDkGdv32VD4xyPdab7oBgEPgxBnPe8uAxWBRRWVvN2	20274	3NLk5iQgRbPzUhM1VkcbKJE4BqRMhmUzXWu65pnx3Gfm3z8Q19Zr	576	1355	364	12463	12613	jxdU4aTwbqt5ZAGBmdPeAbK2boZqsYbL8qf415a6QXDkhhRyans	10211	14406	14406	1618532280000	canonical
20280	3NKiH3LFr5LqpMMEBApVBuYt7zeYNYc5fyjzHn1LVePWYfxrfYww	20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	1406	1393	364	12463	12618	jwHSY7Ps7JpKVbvxzChAnh6tnXW8rigtbN2q28CFZhXn7eMM9C1	10213	14409	14409	1618532820000	orphaned
20284	3NLgXfAuVPWk1pzr71Td3esoqRexqwh8DjJtgUJvk1dMM8xsj2in	20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	1405	873	364	12463	12622	jxTXxh9uT1LnRa9RAmwaWagRiG4uV5RHuSstXyYL1RbrVELiiGi	10215	14412	14412	1618533360000	orphaned
20290	3NLcSmmHLWhCrsBNBecRh18YKfAR2LgkYdB5BDuWLv4fXRuyJ3fv	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1426	1118	365	12463	12625	jxQpje8yL5UAHUPdekhcDnJBSX6n7tZe9rLRUcGz4FFX8wWecfW	10216	14414	14414	1618533720000	canonical
20293	3NKwMKhWdTwT2A9Ha27M5e2khRCgKBqC2udkiXTr35AxXqwbSf4R	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1631	793	365	12463	12628	jxGXVFpZynjMiqtxmPanCNGKizHNi8c6MHFAavRNuBT4VN4tcnv	10216	14414	14414	1618533720000	orphaned
20299	3NKhMbX3EzXfAuxxqhFznn9SWMZWL74oxRBRwKFKywFoRDHjTPSt	20297	3NKjWjBdVi1MgqYJaiwgKJXGTUJoUQgYo7qLwyc8btnitv4STSWh	1483	301	365	12463	12634	jxqwyu26Rwg8WxaQ26V2z1VnDSBX9JFqzAGWq8o5RLV2e2WTarE	10220	14421	14421	1618534980000	canonical
20301	3NLcfebKPqYZkA2WzAWhYZhY9CHzWC5KfHppqEiVZzvixtf6fn3s	20300	3NKd5Hhpm6mUUXCJxqrNc7fYQTbfoDHHTsAghEoWHPHDcUXiNK5J	1407	1395	365	12463	12636	jxPbgKdjQTXZxsGLRaG7Q14QRCcTRyHiqRz6qWZQBpnmsGGcprm	10222	14424	14424	1618535520000	canonical
20309	3NKPmjcEEnD1yuY7EdJ14CmFWydczPnp9GUNjZPQrzvpvnVsB6SQ	20308	3NKRcWAEM4H5uQrKWwtayuBVGFbP6QnhD36LkW7yPnq2AFz1dLi3	1596	1117	365	12463	12644	jxwx1T4MNBTwuG5jdZuzopHU2xKLcmyPRhBkbvNzHvBr5PtL4P3	10228	14431	14431	1618536780000	canonical
20312	3NLK8MtUR2miQD5ULa2tatr4G37dAphse5Nh1mGrfPMxhkbps9Xf	20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	1585	1120	365	12463	12647	jxznEECEwPqd7Bg5tXJMWFbpPf2DsK85NwUz9mSNdxbcJcifVY9	10230	14434	14434	1618537320000	orphaned
20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	20311	3NLwHrQiCd4DyhdrUC37zs4mFxaMujYQh694DeBbnxKPAWoNsJF4	470	1309	365	12463	12649	jxuViAGKSY2ua6XyU6xnbncXEwZXebzwNsfCTiAx3omfcVCTkuc	10231	14435	14435	1618537500000	canonical
20317	3NLmAaBCHHgTTTZRySaaUTQeT5wRmPCLbioZGQh4iwMuFw7CiXi2	20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	1477	1350	365	12463	12651	jwzCJctp2Qr3Xa56a4BRp4Uebpa5J7339vAdrU7EoNR3xRaSj12	10232	14436	14436	1618537680000	orphaned
20319	3NLEKt6pEMitPcWKkKENhHpegtS8K4fmXxA3hLtFq77Gzobs515v	20316	3NLMYP7EG5kubohLBYFGtUetHYF4wrqyzjkVE6VpFtVq2mudvjMw	1477	1350	365	12463	12652	jwda8vG25cWukHNo8y6hm6DsukWfRBRMwBEMiybLryNR9rkrGCp	10233	14439	14439	1618538220000	orphaned
20326	3NLrSVMC5uwTzuA81MjHMwqX3sqiqYEXULPT8rgBXpHcUGPEBSKz	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1403	800	366	12463	12659	jxxCGFpayE4XPveMrqZphEKSze8C4G83LNLjNkvpJyp6uEWLCDE	10236	14443	14443	1618538940000	canonical
20322	3NLvTo3qA5S2TQCPcpYADMMGNJq2vaMJFWg9TWcwpsNWdpybBCVN	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1407	1395	366	12463	12655	jxoSAvtqXf8F5YH47Ycq3srsY7QXfEJgWxp3Q7uZ5SVB1u3nv3Q	10236	14443	14443	1618538940000	orphaned
27393	3NKwazUBToLHpquEyAMw23N5SsSAsJwqEwXt2Sw1dNSwKN3JwneU	27351	3NKpG4oKepVh23mqzvJHQ6SvCrFeoGzEQzsKy1fLoyLXehTiBY3G	1516	575	522	12463	18966	jxHG7ECEFSdASXUHi1UHMHq2iZ4aTKSZvWPLUy8TcG1J3MwJXKa	13315	19068	19068	1619371440000	orphaned
20237	3NLL29mpY872dcvG7thsoou7qCq9x8djcBpEaKneS6uvANahK2wJ	20234	3NLLF7zovNx8Zk8oGXkPcRd8Tyxg18M85aoKN317VxCWF7d6mLtf	1613	1103	363	12463	12578	jxeMoL4jhPjuC3XGPDrNdkFnfiX3Av56P7BkfUGprZCu31mFQzh	10189	14370	14370	1618525800000	canonical
20240	3NKgfYMnkRo85ygG94xpBbP1aB83nUaBeKazGhWq7Y5RBNNoG49f	20238	3NL7pAg9tsf5KeeZoDFBrseVPxD7SNwFFHZycYA6RJydc215LFBd	1406	1393	363	12463	12581	jx5AwS673Kocn2qNMPxKvGw6q3d2D2icSNZTKPejFQBaUi2jz4a	10191	14372	14372	1618526160000	orphaned
20242	3NK4gM2239yJBZgZveBdoyCzhKL5zdRgGDCoqvm6MVicC1597Gx3	20239	3NKqdCvWMptLLLKuFsKRHXVzaUtZhZawsLB3YqsLWArXtZneyhGt	1407	1395	363	12463	12583	jxepSqPrr2TKHhcc6FWx1UZTxSNTHMoPLbWpSzqTgzXShxPoXmm	10192	14373	14373	1618526340000	canonical
20245	3NKys76karPnNSGTmnVD83CbECS7NFTsggzCWyqbH2wUP42qmNYB	20244	3NLGYAQeD5xVGuokVTrNV8E7c3v9bSnKAnVpn331gwKt5FtV9cCV	210	210	363	12463	12586	jxUtyhLkrMXnSQ46Z4hyYAw8zpziciu6BgNDxJVXKX7Cw3rkquN	10195	14378	14378	1618527240000	canonical
20256	3NL8qvB6VjmFbdgmikWeZDkei9am82j4uEjNDkF2ZCaU1AEbUZCK	20254	3NK9WEMtFQDpAYWLmdHoiNXkAfvhqH85FfP38xA2zkAmxWFb6SsL	1634	1205	364	12463	12596	jxacfe1GzPA3LtLq4PRJjbnV3DQB9AFReJVz22SMLnnP9GHsvZh	10202	14392	14392	1618529760000	orphaned
20263	3NKfHcsYwc4n1zw7vN8YpT37bvuctbB8D6az2MkzTajJGZKjG4cL	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1547	1132	364	12463	12600	jxzQPvmPWBQ7JomYz1Dbyo1LjqJXxfosf2G49yMqZchXaXh71wM	10205	14396	14396	1618530480000	orphaned
20264	3NLNn17wuxhSMvCgNc4Ybz2AoRnvymxtNMze49vx38kNMybNSc3f	20260	3NKGB4XDuYhSvUFt3kjfw52MqPWNMy4eh8hRPJYnCF8McAwzhz3q	684	1106	364	12463	12603	jx1LCJbZsCVgro4hM9T7cP87KNmkkLA52LaTRwRdURxV3G3duVk	10206	14398	14398	1618530840000	orphaned
20267	3NKgshkVT92Rqgg56j12M4oD6dSqSGTxpR9GhQDa4C9R9ivByYbT	20265	3NKawpTzHCfbq1bmpzd9SMZMQ1Ywd3aDjXfVM2vFRHHHaZ1RfEmR	1407	1395	364	12463	12606	jwALrBrWUSRjuTnqvC4npgiW8BumUiwyz4xBaKrASD1BnUZDaM3	10207	14399	14399	1618531020000	orphaned
20269	3NKKQGZtvob32BovRZ23DkDRsjXeALvY92oMicyGMhdki5H8Us3Y	20266	3NLogKGTYMuYdtd8pUFRq6rLvG27vkarnWpefGvuvezABHro3Luy	1559	1353	364	12463	12608	jwDxrtfahNa2hskS9vrmLshVdFJi7jSw8kt2U6kHsFRs35NFXD8	10208	14400	14400	1618531200000	canonical
20274	3NLk5iQgRbPzUhM1VkcbKJE4BqRMhmUzXWu65pnx3Gfm3z8Q19Zr	20270	3NKWRceBkp2E6VrregAPnF4Kk7ZrWBX1NoTkkB94wTQw2TQX8u2G	1471	1386	364	12463	12612	jwifBbRXfq7FmCQyYQU4t4E7zy8yLfwCGfSNTJFNSKDujak23Hr	10210	14404	14404	1618531920000	canonical
20277	3NL8vXHXnxbPdBaXBKFYjdTef2yvoMGnC3yFDMHYNoLDVxAWWxaR	20275	3NLPNuP3gHnDkGdv32VD4xyPdab7oBgEPgxBnPe8uAxWBRRWVvN2	1407	1395	364	12463	12615	jxGKj8LxP9HTmD99iZtT1RXkU3SiFEQW6dz89ZcMBRvZuRyE977	10212	14408	14408	1618532640000	orphaned
20283	3NKsSd92FaWXwsGcUjoccg53Tfouh6K7sWGtm41BCUgeR6CJ9kmA	20281	3NLosPLvHi83Q2eK62u4rfdmZg2j6MN27NG5sXG2ed45e6RnM2Vt	1580	423	364	12463	12621	jx623ZZ2oqoZ6aKvgbNK4XfzakThmajnxhq88Bxe1tvWT7j5cVg	10214	14410	14410	1618533000000	orphaned
20286	3NKzpUFD95hyLSVnCfssRQNkvaPVYDn2D5HPtDPRrqRWnuJGLk2c	20282	3NL83nBjYBs5uq3DbjkcWnSYNUMAsCLcmeut3ovZnBvppXUFgzio	1581	778	364	12463	12624	jwnEEakojHFEGWwgJPZ4WeY98v6iBdJr3uDakBNyesM3Vk26ycJ	10215	14412	14412	1618533360000	orphaned
20288	3NL8mWhisquJu9gQrJ21m1n2dkcxKj6x932AMa9a1iHm9k8UJx7A	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1448	1065	365	12463	12626	jwizLhQ3ezUWzGsS56kaWAZwtYsu1T7tSRCV5jva9kzYAgAe5KC	10216	14414	14414	1618533720000	orphaned
20294	3NLVVthGPUb5if8RS6yt1dyMQLxbUorEWCHz7RsUQymFouSzHqtC	20290	3NLcSmmHLWhCrsBNBecRh18YKfAR2LgkYdB5BDuWLv4fXRuyJ3fv	1529	1070	365	12463	12629	jwtyVtA1UL1AQkUjCrVZYw1q7tHZ2FAjF8xyu6Rwrruznzjd4oJ	10217	14415	14415	1618533900000	orphaned
20297	3NKjWjBdVi1MgqYJaiwgKJXGTUJoUQgYo7qLwyc8btnitv4STSWh	20296	3NKKrBYRqgr1syKuh8gPd6chQTXhy7SM18974AhE7UKDGeFJe5Cu	1407	1395	365	12463	12632	jwfYjtnCSoXU3mDFrtZMgE7cjJTSFk8B1jaV2TqiwSoWfmMgwmb	10219	14420	14420	1618534800000	canonical
20300	3NKd5Hhpm6mUUXCJxqrNc7fYQTbfoDHHTsAghEoWHPHDcUXiNK5J	20299	3NKhMbX3EzXfAuxxqhFznn9SWMZWL74oxRBRwKFKywFoRDHjTPSt	1581	778	365	12463	12635	jwxWFPcFqK3UwwZY1zoUGXp9zDXem2tbDLBwAQmMz5J4FVUzsmW	10221	14423	14423	1618535340000	canonical
20303	3NLrji6ifUL6atXt6uZoL8zq5qNGtjBmJbKfRCG3sHoWRZdNakey	20301	3NLcfebKPqYZkA2WzAWhYZhY9CHzWC5KfHppqEiVZzvixtf6fn3s	1581	778	365	12463	12638	jwRX7mTSkp5xa9QDk7NToBPKrMFiKc6QA9Q8532jwoeWXmhVDoV	10223	14425	14425	1618535700000	orphaned
20305	3NK6xgQJ75gsteHGsWJpfPHXGedbwYGuWr1hpNJFaYCkxhprUZ9D	20304	3NLKnKyXowA7kBCh4H6MxQm1iv673fbLaeoDKBM6DAefqPxJqixN	1573	1192	365	12463	12640	jwQu982VMKRF61X5cCHswGePHBS3bSUUotjbjm9NPi7zaDFxv84	10225	14427	14427	1618536060000	canonical
20308	3NKRcWAEM4H5uQrKWwtayuBVGFbP6QnhD36LkW7yPnq2AFz1dLi3	20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	1581	778	365	12463	12643	jxxXnEW9GLoywM1pJsikJbZt2gqEuf1rdD675gGbF5rQDo39jG9	10227	14430	14430	1618536600000	canonical
20315	3NKGaSiiVMxzeQDVWcBVSpusWU7NSyhNumgtnfFNhPSJy6dppKts	20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	1406	1393	365	12463	12650	jy1erjnatBk8mnq4HY3xGvNRyVVQmwTZpn3mDxjnq2Uv46q27zL	10232	14436	14436	1618537680000	orphaned
20318	3NLD9sjMSLxVtFMCYxAkUiYwdn9h3YWxxNtD548gN3p8WpkUnsJS	20316	3NLMYP7EG5kubohLBYFGtUetHYF4wrqyzjkVE6VpFtVq2mudvjMw	1477	1350	365	12463	12652	jxtb3ZPw9K7mqaAc4YnLDeiFULRkXLznLdRbJAS3hn3CX2GEpPf	10233	14439	14439	1618538220000	canonical
20320	3NKzG6WYg5XepamDQy2YrC9TX7sX5XBZH93C16xNjMzrURFvCQAn	20318	3NLD9sjMSLxVtFMCYxAkUiYwdn9h3YWxxNtD548gN3p8WpkUnsJS	1610	1068	365	12463	12653	jxVvaSUPaXumKinxsaZD8sKs38Q1GvqkpXuJHByBZn367oEH6ja	10234	14440	14440	1618538400000	canonical
20324	3NLrfgGHo7mKanYuqhapVpARZ9biAW1AeoPTvpxf3QJrtqgYjL4q	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	149	1283	366	12463	12657	jwYSiGQBZZNtikx5jNvXwnKqU9NCq1XNQRSnvRa8B3HaDG8rGfi	10236	14443	14443	1618538940000	orphaned
20328	3NLreJxyoNK5yCooUkH6cev4tvF6EX7tqXpeEUj8DxB5de8aE452	20326	3NLrSVMC5uwTzuA81MjHMwqX3sqiqYEXULPT8rgBXpHcUGPEBSKz	1458	1323	366	12463	12661	jwrmD8cxyV6ABPsz4ePU5d5KU2xBM5q8v49wQMzJeT4pmgxgAL8	10237	14445	14445	1618539300000	orphaned
20332	3NLx934rP9SVejtaUH8R8Y3ynrb455yHyE2DUfymTDA4dAJrPmJv	20331	3NLSrCuDvAnRZLKUMUgCR24KA2gTzijuBSThjxGLFZHgzDo7drKu	1547	1012	366	12463	12665	jw6fs4j6fdYts3xDyZ1xMK6x8jamT8gwkvhGmkEdpGy2DcvY7eR	10239	14447	14447	1618539660000	canonical
20335	3NLof2FqxCzu4UwPPFPn3QZ6GTsxXKX5Tfhjy2kqvoz9JCyJmp2z	20334	3NLkaJjpgzyv9AQQBS1KKjKWXUdKN6b14VpM1zf3he5oMYpU9Fbo	1407	1395	366	12463	12668	jwV77EGKnwqTpx8eAVayLivpKygovz6HCfT5WG5mwsnUQibdA43	10242	14452	14452	1618540560000	canonical
20342	3NK8QgunPnQajUfefe3HmmDhktUwfWT2u8iCp7jeVR9tGjbF2tQj	20339	3NL39fL63AKZPqGNkstkhw2vcF5nGaJ4T1FvNWFoasyW8tgusWmd	1402	868	366	12463	12675	jwkWGs7mKUvM36Y23UXzGQM46QNe7kVrkUYWNpKoLcG3UGm3wfa	10245	14456	14456	1618541280000	orphaned
20345	3NKZBU6FR55EZcCqHWZRF3PMvvhft7Vnj3sFABvDCWXfhbC1666o	20344	3NL3ZM58HFvY4mTU8nhXx6YtETFoMhxvmDTPp8Q4Kq3ohzWA8wKZ	1516	1294	366	12463	12678	jxL8toQ2edUS82wz1L3nhFdgsQgTWP7fVXxfr8GiyGQY7rseVwi	10247	14459	14459	1618541820000	orphaned
26946	3NLT2tk1HCtw1qQJaqJRgcsgRjh6jWcD1h1Ri8zYPPQRq6e7bx5H	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	1614	315	521	12463	18598	jxCTDsHS1L2Py7NM9hiatVJov9NFVcTfdfZA8fQ6PWeUjATwW8j	13328	18764	18764	1619316720000	orphaned
20252	3NLWeqYAPg2mmRw2ef8bjSzP3Jh3cq2LSu5XZESP1PzLCPmnEsoB	20250	3NLjTwQUr3L161WUaK1BGFbtyQL5kNBLtMT747f4MMUNse5dudHH	1553	776	364	12463	12593	jwTsm2uDeQYcWDWrWjC9TM2A4ULMTAg4P1GorPE5f65sV2AJVBY	10200	14387	14387	1618528860000	canonical
20260	3NKGB4XDuYhSvUFt3kjfw52MqPWNMy4eh8hRPJYnCF8McAwzhz3q	20259	3NKomHA4KCvunECqNk7haxPRFgVhHNJw2tWHZdK9XyeFfkMZzd5q	1547	1132	364	12463	12600	jws1ghcKf4FpFHZXFXKvqaa9AyHej5nZLjzCcXVFSWEpMwtiJPZ	10205	14396	14396	1618530480000	canonical
20265	3NKawpTzHCfbq1bmpzd9SMZMQ1Ywd3aDjXfVM2vFRHHHaZ1RfEmR	20260	3NKGB4XDuYhSvUFt3kjfw52MqPWNMy4eh8hRPJYnCF8McAwzhz3q	369	1312	364	12463	12604	jxykCDYfvCtyRtk9Di7guP7tQaZKSzFnvbHzEkrE6uLoR2SWrMC	10206	14398	14398	1618530840000	canonical
20279	3NLAF9cMnV2CYj9e3Pgb8CJrtcM6HPtqNkXzRf5Pk8qXcCofr8e1	20276	3NKuGxtM9RphtDvCQCMV3PfS6CnTestxbM9P1nCcVzynPp7zq47g	1405	1	364	12463	12617	jxCPtWP1dZF4TWn6tcAazfkcjfcHcDYuyDL3yKEZ7sgaNtn9kmZ	10213	14409	14409	1618532820000	orphaned
20289	3NKA1GMqxCzEqgxeDuiin4hSpHnrk8JbNiLg7v5me34YZZxxXNrD	20285	3NKXGQ6bK9hQUVUQrX87hWXK27xYWeEoFNpQQ73FjFgD2zMnGeSR	1448	1065	365	12463	12626	jxyLmyLVFdRz8UgQXvzasWzUAWLUun25eyCQkGBchSfrRUWFFCZ	10216	14414	14414	1618533720000	orphaned
20295	3NKEgzahxvFEFw77FM5vYJ24Z9KQQPJ14opi6wRUBiLZyu8AUDQF	20290	3NLcSmmHLWhCrsBNBecRh18YKfAR2LgkYdB5BDuWLv4fXRuyJ3fv	1406	1393	365	12463	12630	jxd3fnkCKeZUuqiLAmN5GbNwHmJexhKe4xTvx17PthidzoSfaau	10217	14415	14415	1618533900000	canonical
20298	3NKP4xoMyGq1iY6arSu1VTvnmUpsNSwZJ9Z7y2BGtnn9iQX3BM2U	20297	3NKjWjBdVi1MgqYJaiwgKJXGTUJoUQgYo7qLwyc8btnitv4STSWh	1406	1393	365	12463	12633	jwDkN3Vy4ftSQW1ExEBumH84RauQ58DCw3x2DihXJyj31k7MeWp	10220	14421	14421	1618534980000	orphaned
20306	3NKgHpm7S8FG9CUhcocbtKh4rk2QjPvTo7gdD83mdYzBtpkq7T7X	20305	3NK6xgQJ75gsteHGsWJpfPHXGedbwYGuWr1hpNJFaYCkxhprUZ9D	1403	782	365	12463	12641	jwwxGRJkHbi5eKdxHPEzMPRnDAz1TMVtqZt9d7wjvRu5cLMk7T2	10226	14429	14429	1618536420000	canonical
20311	3NLwHrQiCd4DyhdrUC37zs4mFxaMujYQh694DeBbnxKPAWoNsJF4	20310	3NLe3PzMdnzZHDtmfskzsCJ4P6y5GXkS2MvUhu5pnhkwkmnfXDAc	1406	1393	365	12463	12646	jwT9ECCPGuNgYHpnMXgcjSXuYkRdqezUxMi5Vnvr6kw6mUMkMbe	10230	14434	14434	1618537320000	canonical
20316	3NLMYP7EG5kubohLBYFGtUetHYF4wrqyzjkVE6VpFtVq2mudvjMw	20314	3NKBaZGNw92ryHYFaKQQhJxtcz5LEYT16WzF4at843CqKx8UW2vu	1477	1350	365	12463	12651	jwVzwW9QB2rkNsGba7W11Hw5zTPCyFqVhXWqNY6YX5EFCMyTkqw	10232	14436	14436	1618537680000	canonical
20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	20320	3NKzG6WYg5XepamDQy2YrC9TX7sX5XBZH93C16xNjMzrURFvCQAn	1634	1331	366	12463	12654	jxYxPSs2VYJ4Ms7aYhV4cPjQ8Eqj9MpgpjpHLpqZdKeLnpExh23	10235	14442	14442	1618538760000	canonical
20325	3NL9NVNsGc4K4bF5tu1Qe37rkGLfZ9kViL94KaK1n7NiuWHesqPs	20321	3NK6CibAyJf41Bfbv4N36pQSNT6yP6cnPLnvu81jnaR9tmT6xdxN	1553	776	366	12463	12658	jwWAqzu9BYvYqY4H3ytW4KG3BftNPDjakM9S8P9Js17nsd2hk8K	10236	14443	14443	1618538940000	orphaned
20341	3NKppokMjsxFtNJmSBWWCFzAdWgguivkEWpvEx6emMYLvae1qhz2	20324	3NLrfgGHo7mKanYuqhapVpARZ9biAW1AeoPTvpxf3QJrtqgYjL4q	149	1283	366	12463	12674	jwnzgXndk9SUMmEi2gPaqMMwdp6txLMgBwJ4CUDGKjAkavFG1zd	10237	14454	14454	1618540920000	orphaned
20331	3NLSrCuDvAnRZLKUMUgCR24KA2gTzijuBSThjxGLFZHgzDo7drKu	20327	3NKzPegiiSJFPySxDSHdCWfwEz2ykrUEScWXokfyWLc1vJuXBb96	1637	816	366	12463	12664	jx9i1k5CQjD9bpLuLSVkTVHpHZCJN7fL63cqXTfzU2fU2XJbC5H	10238	14446	14446	1618539480000	canonical
20330	3NKYcMHK9tcufqn2FNn9ocxb7FSpF9NYmpzovNu6pHWf5Dupe2ut	20327	3NKzPegiiSJFPySxDSHdCWfwEz2ykrUEScWXokfyWLc1vJuXBb96	1407	1395	366	12463	12663	jwGiX6bnc3w3uMpuxJCcdxqtDn2BtQaaQds6M4EjWMAJdRoXkCD	10238	14446	14446	1618539480000	orphaned
20334	3NLkaJjpgzyv9AQQBS1KKjKWXUdKN6b14VpM1zf3he5oMYpU9Fbo	20333	3NKZXBwVXNEg3AeK8mz1RYJUdNnt226vNc2W9GSC1cGjkikh9ahx	1624	1334	366	12463	12667	jxXzpze5jzViQXVvWLuFv8qed7xjvCrWRzTKUmkDcmg2DHWyC6n	10241	14450	14450	1618540200000	canonical
20336	3NLw9dcrpajRL5PbnGRXGRHipNV8qtneTBysHiKbGQ9YVJs48nvW	20334	3NLkaJjpgzyv9AQQBS1KKjKWXUdKN6b14VpM1zf3he5oMYpU9Fbo	1542	1304	366	12463	12669	jwZSL5FVFiWEXKN7wWGyTD1bpTcexzP2W3LPXCh7DkH6t1SA5od	10242	14452	14452	1618540560000	orphaned
20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	20335	3NLof2FqxCzu4UwPPFPn3QZ6GTsxXKX5Tfhjy2kqvoz9JCyJmp2z	1670	1282	366	12463	12670	jwJ8VeDDPte6kRdS5d2ppRBwZpNNT2r1xybb31AzUpvZnLJhRgi	10243	14453	14453	1618540740000	canonical
20338	3NLwSsLQqu4VvU7aKhDeuJAKr87T5bQMSCzRTm4T4nEwFfdyr5fc	20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	311	1061	366	12463	12671	jx7o6uW9DojybQP7weDmMXwn9MFQJX6KgxW8FX7THAzTob8zCPG	10244	14454	14454	1618540920000	orphaned
20343	3NKc29aXpigPUKcyszjCYnwqmA7qRUwntfq3SM2jkGdgLpaxJC3K	20339	3NL39fL63AKZPqGNkstkhw2vcF5nGaJ4T1FvNWFoasyW8tgusWmd	1637	816	366	12463	12676	jxHCabbWjTyVxtzTKEJCr7EiZ5WhnYuBnicmp7Joxc4G4yhzBpm	10245	14456	14456	1618541280000	canonical
20346	3NLjkTo1m9iow4KBt4FjzCxkbQVWKP3w27Qk74UWR5qksMNQrqaM	20344	3NL3ZM58HFvY4mTU8nhXx6YtETFoMhxvmDTPp8Q4Kq3ohzWA8wKZ	1407	1395	366	12463	12679	jx4szPvhjYRFGxzJ3uAhgn6inhw7YMtDREV2NgZu9SsE97VhnRo	10247	14459	14459	1618541820000	canonical
20355	3NKjH3XYSs4vznaeCDpXVUcExFrTdbJteNEMS4ohV42Le3KmZJ8N	20354	3NKaShfN9T2fpHD86z5A8mHU97E9Na3AbSWqS5J6kM2NsSLgayYR	1407	1395	366	12463	12688	jwnymQAo1p7LPaLmqFpVEqpyLRBFPKjj6HvPDcmdaSet5LJNsdM	10252	14466	14466	1618543080000	canonical
20358	3NLPFfXHbBREntMatcdjywCWpAAbhj2njYtEaNpWyamo86Bye9Ho	20357	3NLQv97tBSmjQhwwAFq27dJK5VXsSHpZaQMG1gfDsg7ChwPNPpSA	55	517	367	12463	12691	jxSnRGyP1c5Vvnxpy3AeyWHWPhWNWMpGufB8kvFVZhPkqxHBiYg	10254	14469	14469	1618543620000	canonical
20360	3NKuFAwYrC98pDaN6y6dqrtWncRS8xLpdifWszLqHk2gnkMhJxV6	20358	3NLPFfXHbBREntMatcdjywCWpAAbhj2njYtEaNpWyamo86Bye9Ho	1419	814	367	12463	12693	jwssPZP61MPH3KzhJ8jmRCti5tSjm2v5ZfCGbURyHXBzWQEFpV4	10255	14470	14470	1618543800000	canonical
20363	3NLMLYLBFGMzACbAi82M94MZqsZHCE3HkPHBmTePSsdyy3UgpcoC	20361	3NLXcX6QggyJqDgMqsYCz54uXNLU87PXCos1H3Wk74ABBAFDRZqh	1481	790	367	12463	12696	jxEZdUWry8spGY84QA5UAV2MdVpgxdCmgZZGQtR3cfj2yqYdhyr	10257	14472	14472	1618544160000	orphaned
20365	3NLJ2ZUc5idnKuSSJx4Yub9kAwEr55ajSQQvBN3MKzqMMcBWLeg3	20364	3NLwq5zCHc9BxvBy1zF1Pb6D9B8BkmDVT8ZTnvywjrR4jytzmAXx	1407	1395	367	12463	12698	jxwaFHgHHvaPzWo6mSx3EMkhJagrYHn7KW3YKto5x7rBXxcwq8p	10259	14474	14474	1618544520000	canonical
20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	20367	3NLos38uPPaDu4VqpAqypHR8HZ9F3qU4AWvwsRBiLboxsrEcPGxC	1405	873	367	12463	12701	jx6zmjrEAGHkwafRbSR2MAqjCLF1GagphsgXYWAynYVLcTux43t	10261	14477	14477	1618545060000	canonical
20371	3NLuZkSfomdhk1aASgmd98jxqs6vGVVUhyXWiMCwP6CYczt5HUkn	20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	576	1355	367	12463	12704	jx2LEFDT5kBE2S6Db9xQnB9gi1Dqc9CzgBPaJ3zpjPnJEmUXE5d	10262	14478	14478	1618545240000	orphaned
20387	3NKibvANNkj8BppR97ADieJi2mpzoZKgsqGU25gLyazSxSMCuWnz	20384	3NL6fBj5bqo8CU2rZEvyBY5M2Br72anVtrBAZV9Dx9HDA5QYMyov	1500	1171	367	12463	12719	jxYzf5gMTeQ9jMYW54Wv6MbBWwrC5YasKRPUfKKeumGAdgSpDtV	10271	14488	14488	1618547040000	orphaned
26959	3NLkDmRs79zXjU2qSww6yeQXafnjSZYktJu7Ms7m7Fqh5wFofhqG	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	1406	1393	521	12463	18609	jxvqn9kqdeoAJatd1sRLQXryfEM8FyRT9rsfSSHGKSsJs1MeSbC	13328	18769	18769	1619317620000	orphaned
20340	3NKKv3ehABjnGSCwDveQYbDmPGavrXZmSWHGYycP1Cxk8MD9rhit	20337	3NKVZHqG3jVsYNSsmVRRrqMKNML5umRijWUe5tYdRHCrHRPdmDR4	1403	824	366	12463	12673	jwJCf6iGxUMDVpD3TCbLW7wn6Q6G9dmgd99kQ7LLjy7JSmuiaFd	10244	14454	14454	1618540920000	orphaned
20359	3NL2BUvdRNjHpWXbPhnPfrHmCsa5TtWvnZoR4F7ewZzhRjdWQiVS	20338	3NLwSsLQqu4VvU7aKhDeuJAKr87T5bQMSCzRTm4T4nEwFfdyr5fc	1419	814	366	12463	12692	jxWiRXzyDv4XyRrXhLJoW6yvGiQxReetyNzmEdS6sEitfYRTyQg	10245	14470	14470	1618543800000	orphaned
20344	3NL3ZM58HFvY4mTU8nhXx6YtETFoMhxvmDTPp8Q4Kq3ohzWA8wKZ	20343	3NKc29aXpigPUKcyszjCYnwqmA7qRUwntfq3SM2jkGdgLpaxJC3K	1406	1393	366	12463	12677	jw6hh18yJ2hnM8iUMiGNvyjLmUn29MuNo2N57LDpATkLAspERVZ	10246	14458	14458	1618541640000	canonical
20347	3NLa4qdgVwyHiN3shD1w8Ro2zpSthfG7pRZh9RLinh2TqtT3i4ML	20346	3NLjkTo1m9iow4KBt4FjzCxkbQVWKP3w27Qk74UWR5qksMNQrqaM	1457	1391	366	12463	12680	jwzrHXrtmdw8jCAsEUXpnveBvsPe1KV639ZMp6Kq1XtmrKq3tQL	10248	14462	14462	1618542360000	canonical
20350	3NLMNAPXn9ZjnAyjVAq3eRKhe2dWyyvLDjQRzNVaecYzkYg7hZkx	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1406	1393	366	12463	12683	jxmxbgwgHXLE6v8vAMkdc72R88HmkGBQme8Wogw6PFUJZhAwohE	10250	14464	14464	1618542720000	canonical
20353	3NLknGQDKorKhb4aNSK1pDhMibgv6wWJwGgBmhsCA2bAyKioCnit	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1631	793	366	12463	12686	jww1HxQKj7er8i6UgHw8jAPV72UUsSqL94whVm1VGhcrgDkU8NN	10250	14464	14464	1618542720000	orphaned
20354	3NKaShfN9T2fpHD86z5A8mHU97E9Na3AbSWqS5J6kM2NsSLgayYR	20350	3NLMNAPXn9ZjnAyjVAq3eRKhe2dWyyvLDjQRzNVaecYzkYg7hZkx	1547	1132	366	12463	12687	jwywY9nrdHmheDB7csoJcaZdwkCY7GE2ictvdQLAbQjcB7oKquR	10251	14465	14465	1618542900000	canonical
20356	3NK6MjrxeDerYgFoQ4hqZUssKkdni1tWjdzk5ZJ26VreZ6MKuu15	20354	3NKaShfN9T2fpHD86z5A8mHU97E9Na3AbSWqS5J6kM2NsSLgayYR	1571	969	366	12463	12689	jxiukAoKynKFf74LhkjxmA9p8AYsrt5PHtB99HH6qV8fK2zmRUb	10252	14466	14466	1618543080000	orphaned
20364	3NLwq5zCHc9BxvBy1zF1Pb6D9B8BkmDVT8ZTnvywjrR4jytzmAXx	20362	3NLYeDw7NtdSRTkKReaFYHtgxaP2JxgZsAFkQVP9HLvMfMrvxUai	1637	816	367	12463	12697	jwH1KChMFrr5gQFaM5q2ywzr2Yx7RTmYfciQ8423jkJ9SaU6RwW	10258	14473	14473	1618544340000	canonical
20369	3NLtDtBxxEVDoPkCCERjpkBacZvUSioyeeJwkNXQMRiGrYkcDHnA	20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	1516	1294	367	12463	12702	jxhV6npGXXLwmwj8JTmKgGwdo33FY3nHqNKPrp8UMGUjMKxFZub	10262	14478	14478	1618545240000	orphaned
20376	3NLMDXxV5yuf4htHer99amZxfNyfKtxBfwgKG3AcSVzCzw2o6u8w	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1647	846	367	12463	12709	jxCZKfvUHGksAVx7M4giQD3u5BDwAKW3fU1wfbSstC2oiVeYexK	10265	14481	14481	1618545780000	canonical
20374	3NKfEnHtYz3xKNLeZMYcq2ywrPnfAeyPMG2xR1KDgafkEeccwDq9	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1406	1393	367	12463	12707	jxZmLqqcZYqZEPCB32W6Z8NzNuF9WLHRhsGCyZsNHeTyKv7MFXL	10265	14481	14481	1618545780000	orphaned
20381	3NKgDivVDTxmLciLQjcCmr7pnJdJ1WT1agnjLYazwi7kvZHNqgZV	20380	3NKig7XGA4u9P2FErZ99d62DC2yAFRCwespFkHXEHNFRXEqPh8qp	1406	1393	367	12463	12713	jxNcCecwfsbhNFeaJ25jimZSFVcq7zYtR3JMSdMCASp9LFs5WkW	10268	14485	14485	1618546500000	orphaned
20383	3NLJXgSFwndL2RNWkM14ywNPf8eBg8BVWxpUVYVKVPyWZwQ9EBxc	20382	3NKUUcebqwTystWuTRX7kHTU2TbdiTzKbNrYNqxsA9UN8ZYHqnCN	1553	776	367	12463	12715	jws2oyimqovDR7T4HwMxqMUYZvXEFV4rZE7vaXToXr9Es4NvQW5	10269	14486	14486	1618546680000	canonical
20388	3NLK8CmAPwqDQhRRqSt2P3LUxUfbkVnTjs4L7WpiLjjW3VidbwUS	20386	3NLVQKDTkvDQb6YQ3uD9S5EN7qXuB3yEyYghnPQbvf8s6iBDjVnr	1577	1201	367	12463	12720	jx9vXVzVge3Wtv9HPRvDFpobDvk9EkgxLAuqmFwC4hW9xtwbizs	10272	14490	14490	1618547400000	canonical
20392	3NLGZ2xFssHsFqdnyoxt34L4TCkSN6GSZBFpRNPGSxm19C2hBSH5	20390	3NL2zMNpTNRpHRmmtURd3tEWS46iY4rH87cg1Bd4PhQd8wxzfUPV	1617	1288	368	12463	12724	jxuh3Dga84FZ9qm7rPR5ZZxMydpGqFPA9QbokjXQ2u5oRpeoRUY	10275	14495	14495	1618548300000	orphaned
20394	3NL93etus22qGAacpApWze8dqag4fg7wGaHshkp2RWbtdg65EiFW	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	58	1281	368	12463	12726	jwBMJgSkQyGhfQEX952y6jCLcCtvXHV4x86cYQ7fKESnrtuh1iN	10276	14496	14496	1618548480000	orphaned
20397	3NLQucX1BcgxnDiA1qLYG7YHjASKRseHet5pfCQt1M2cwQ9K4Qvz	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	58	1281	368	12463	12726	jxXFkDnj8vy84M76fsFi3opSK1mwvtnGWqwPDDv3TkxsZUUT3ci	10276	14496	14496	1618548480000	orphaned
20405	3NLhzzcdNSthqi1dTmRz9PnL8J46AmJHLVprXtRi8mQN5p1qhskC	20403	3NKKMUxjVFRa5qemJ7sXd2XQMLV4DpsAp6HjTyqsLoUpEKPGXdbv	1596	1363	368	12463	12734	jxDdzqNFhrhj3HL3Fom2X7svheLM3WdrXcknDqvqhxNvJFSsf7Q	10280	14503	14503	1618549740000	canonical
20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	20406	3NKs8bsAxKwmjKJkRN5wceaSbo4F3yFp9WHLaJrxeBN8aHoWkV6V	1483	1030	368	12463	12736	jxa4vAhzXR5hCVxw6za4hgJkpq9ao7bfCF4gFQaRnSNEGxZ22gr	10282	14506	14506	1618550280000	canonical
20411	3NKWGwABG97aQnWEpPZk5VKNimKLPPMoCHeC26DW4aw4hzVG8T8u	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1553	776	368	12463	12739	jwrkseU1g38yB9dLCB6KpNQVi2ZUEXaVd6VwmAgvuBem6AN9yyp	10283	14507	14507	1618550460000	orphaned
20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	20412	3NLKqG2xJMXaXSFbub1656gX2fdxYJyJUgDJw1m1yLKhPRooUcYo	1405	867	368	12463	12742	jwSA9w36Jqno3NiNH2haaWWeShAkBUPwC3XvgAucGvuy342q1f3	10285	14510	14510	1618551000000	canonical
20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	1617	922	368	12463	12745	jxzgD9fRo78XixzfxEjRjDoLGxLRSFtuSLiLv2sZ96prfs6SSaZ	10286	14511	14511	1618551180000	canonical
20419	3NLDXkkrtpNbCcVQwDdCxM77igLXQ8i6K6ogP7qSVTVHYvgm1d9E	20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	1407	1395	368	12463	12747	jwGh9LvuhAYG3GT2eq9s7XdhDJQPEvBY48Yifav4dLeVi7oKdus	10287	14513	14513	1618551540000	orphaned
20430	3NKK37DcZCbjxVcYhmqAfnpFDjX8JFH8yLBGVNmwFSZZa3ZaDR2d	20428	3NLBf5giQi1rTh783FchTeJbBBM8Xm6P8mJo42fdVeoSNyEoCiuQ	532	1303	369	12463	12756	jwFESdMXmU7knXrJZ3YwbsF8iEos8BPqz4yyuzvRZZvoBU43rKK	10291	14518	14518	1618552440000	orphaned
20433	3NL9x4No92thVksodBTgEN146J8imzACEG9skXKxaSXK5qDbpaX7	20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	1483	603	369	12463	12759	jxNpdJokgb9CKPGHp9JKQn2CzWcvWzMbjQ8XoJc3Ei1UHXmPmpQ	10292	14519	14519	1618552620000	orphaned
20439	3NLcfFNyUsEFqFv5sCfUBLFVaGJiryTQBtYYnG1dLEejSyJjoFnT	20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	1406	1393	369	12463	12763	jxffvhZ5FJFYwfVqmM2MtNAfXhDeq31ehhmgAaRLSjbsVCozAr6	10294	14521	14521	1618552980000	canonical
20444	3NLwNSJozhN2Ndb7Mstbh45hSmHegYUqz5ZasQfR9iKt72tVgBVg	20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	1405	851	369	12463	12768	jwv7XKzkbW9gdTqYva5N1hsM5LbFLF5STN6YoTvwUSQFfZwfqmc	10296	14523	14523	1618553340000	canonical
20449	3NLAhuSPk8nV7fr3CAeCMeww3AwC68ohUVC4E5iqzG5vCKHssveH	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1477	1104	369	12463	12773	jxiMjwgY3BLdQNSVC6fPjWbVJw87tF2p1fhn8GkXHfCQi2BjSdf	10298	14525	14525	1618553700000	orphaned
26969	3NKj9XEcRV2u4skgKwRFqVNctNNMNAyUj8LWZkipqkyvh25Lj2jJ	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1506	1007	521	12463	18618	jwXXm4wqWRWJUkEs7jUEaJn4cjx8gPuQguUKRVRZ6aEQPRXTSaB	13338	18776	18776	1619318880000	orphaned
20378	3NKvxGzSnpAuikuBRqqAeaHWraPvZQzvWz2wwV5czKa811U85t4w	20359	3NL2BUvdRNjHpWXbPhnPfrHmCsa5TtWvnZoR4F7ewZzhRjdWQiVS	1419	814	367	12463	12710	jw8kScC3tFxg5TqqyR3XCyK2daPZrsy2RzGRFxvJkXnMyWWZSfm	10246	14483	14483	1618546140000	orphaned
20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	20347	3NLa4qdgVwyHiN3shD1w8Ro2zpSthfG7pRZh9RLinh2TqtT3i4ML	80	1273	366	12463	12681	jwYHKweofDnabGPKZN3otVTgw5JSDd4oDyTiCvfPTEToeisEZ1r	10249	14463	14463	1618542540000	canonical
20351	3NKyrtzgBxfZrRNgQXPeh6xQmjkzxECd4MAEozR1WGpvAnjHJsni	20348	3NLuTN328R36dsF7s7STcqZhmshgvPTzf9PWSYYorCcoPhhX1xiW	1403	785	366	12463	12684	jwSfYGYUL1mWzAw7mYqdhr1C6wYRRGK4n7sr3cBtpMaHkhm62FJ	10250	14464	14464	1618542720000	orphaned
20357	3NLQv97tBSmjQhwwAFq27dJK5VXsSHpZaQMG1gfDsg7ChwPNPpSA	20355	3NKjH3XYSs4vznaeCDpXVUcExFrTdbJteNEMS4ohV42Le3KmZJ8N	1402	868	367	12463	12690	jwboDwLHesB4KZGWSsJZBtQ7Tk8XwT1Q2z7ErucbxzD3DFQaDHJ	10253	14467	14467	1618543260000	canonical
20361	3NLXcX6QggyJqDgMqsYCz54uXNLU87PXCos1H3Wk74ABBAFDRZqh	20360	3NKuFAwYrC98pDaN6y6dqrtWncRS8xLpdifWszLqHk2gnkMhJxV6	1648	1284	367	12463	12694	jwuTmrpeQLgWf5RsF6yABzX7bLoGFBYqc31dQigp4QDKSnhZPr4	10256	14471	14471	1618543980000	canonical
20362	3NLYeDw7NtdSRTkKReaFYHtgxaP2JxgZsAFkQVP9HLvMfMrvxUai	20361	3NLXcX6QggyJqDgMqsYCz54uXNLU87PXCos1H3Wk74ABBAFDRZqh	1560	1291	367	12463	12695	jxz1pz8LKg2P1KvypH9Zps1TuAbf2hpZngBQaFPkQbABKvap64m	10257	14472	14472	1618544160000	canonical
20366	3NKAjYJgJFWfzzNbAYLwozVfT4eRd8T57JMrUyHVk5iJoTm3e7fQ	20364	3NLwq5zCHc9BxvBy1zF1Pb6D9B8BkmDVT8ZTnvywjrR4jytzmAXx	1444	1135	367	12463	12699	jxabdS4ki2SctRSH2Dwvg4bmbzxGqUxTX6MpsUFDVCHeasCpHK9	10259	14474	14474	1618544520000	orphaned
20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	20372	3NKzyw9K66cARJFTr4xcCPAbRAtoUYrYkZXYcNKGnNA8FNQQUWKZ	1407	1395	367	12463	12706	jwaeKx3qwtc9XQ1bpAwSWMRJBzYDqj3MLnQceCCqMQHsfaJQWz1	10264	14480	14480	1618545600000	canonical
20390	3NL2zMNpTNRpHRmmtURd3tEWS46iY4rH87cg1Bd4PhQd8wxzfUPV	20389	3NKRpDaPaahKGrQb9ZFgRjMeuw2K77pv5wB8agRUz98K3n7Y5nef	1654	1214	368	12463	12722	jwF7XiKoSHP8B67BfMJU4XZYDMFD21WK7YzAtcZkVHy49oohaJi	10274	14492	14492	1618547760000	canonical
20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	20390	3NL2zMNpTNRpHRmmtURd3tEWS46iY4rH87cg1Bd4PhQd8wxzfUPV	596	1306	368	12463	12723	jy1Yi7nDucHV2RCUidRvuooxg7kdowLTnf4egNnrSo8H4ppFPgA	10275	14495	14495	1618548300000	canonical
20393	3NLTiMHZEisMzgVUjevWQjXyy2EJWnnCYanQPPrSUKw6BAykKduQ	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	1523	1075	368	12463	12725	jwrpn5km5rLKoTYyVoLDZx8kx7f7DJEpn4LmrTutasVCHxZkLAb	10276	14496	14496	1618548480000	orphaned
20398	3NLsKmmpEMmCimyiP1AaUWGArrS516yUfBfx4PjLBVwys4vorCru	20396	3NK7qz9aWc8yUHd19EMb1AZo6eWNRuR2PyLN7C5wN7mKTHfmTRTr	1600	1126	368	12463	12727	jwmJLrP2dNxRDSHMHSBwrUHUL4RUxFZWdyq34B54droVusxSims	10277	14497	14497	1618548660000	canonical
20401	3NKbqjiyvkHZw993qrFPukB6En9kgRyZPn6BjMxXRcCNNAFeEiiJ	20398	3NLsKmmpEMmCimyiP1AaUWGArrS516yUfBfx4PjLBVwys4vorCru	1617	1162	368	12463	12730	jwhBhtXqHL6Mthjtd3ynNMMi8jAJroBj9mAC8CpAmrm3QcNfkYu	10278	14498	14498	1618548840000	orphaned
20403	3NKKMUxjVFRa5qemJ7sXd2XQMLV4DpsAp6HjTyqsLoUpEKPGXdbv	20400	3NKpGSZroUfXf23KUgw5mhb6fr7KgAaswxcHgYTJ3JsUsAg4Su9r	1422	1337	368	12463	12732	jxq33ay6s55MAqYfNK3cDBPNBysRBFuWksqFerkhtihNf7q3PRg	10279	14499	14499	1618549020000	canonical
20404	3NKXa2mUaZHVsLrbnBa4RuhxsxWmt5aCW3A3Q3oJhCTeAtp3LUxp	20403	3NKKMUxjVFRa5qemJ7sXd2XQMLV4DpsAp6HjTyqsLoUpEKPGXdbv	1578	1296	368	12463	12733	jwmreBBtaxKGT55MLhyhhWCjQst44yxLFYrtFQce6hSaDDsgQH5	10280	14503	14503	1618549740000	orphaned
20406	3NKs8bsAxKwmjKJkRN5wceaSbo4F3yFp9WHLaJrxeBN8aHoWkV6V	20405	3NLhzzcdNSthqi1dTmRz9PnL8J46AmJHLVprXtRi8mQN5p1qhskC	1402	874	368	12463	12735	jx3gEXGdEeN8DvVCEyqpKL3x3qsvzo8jP3t6vuaRo4geCHArQeH	10281	14504	14504	1618549920000	canonical
20410	3NL7m1TzRcEPX7Q4nDe5hMPktFQjE2bBUJZoytrKCHA1esdJV2fp	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1671	1119	368	12463	12738	jwh7e1d6zgCQt4wSeFzNJE1TxizT7UgWY7yrAnZYBRUPfoCPuhZ	10283	14507	14507	1618550460000	orphaned
20416	3NLuqWGSocJzi9N6oQj5UMojJ86wm7SdEJrEpLxtDJCfCWD48hwT	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	1406	1393	368	12463	12744	jwuibR2NKwNuGggy8N8XPGU9E5DDBWUHKDbsZkt9mvg7w45ExfM	10286	14511	14511	1618551180000	orphaned
20421	3NLWmoE4SLaGW2LoT92sKj7svtn7cNLxEcsMBg8b1tWvaVa67hg3	20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	1474	1329	368	12463	12748	jxcyagmLTX2u33yVAM7m4AYPyvSsBdfd4wmm6PsezHugqAzWgpX	10287	14513	14513	1618551540000	orphaned
20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	20422	3NKQzLmmKMfbzkgRzP4yuHEYXwsD7mpKeqZUS3C9DCLQrzcGuZnj	1579	1389	368	12463	12750	jxuh6npDfKqYmciomMkrWZJUJ6fiTRAYZ8r5yHhCBCBpBp58MNX	10289	14515	14515	1618551900000	canonical
20426	3NL9YeSg5vN2tQvZWUq9r7GsVEe1DpGCgsrRLPMa5yXKZzVXkVy1	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1402	874	368	12463	12752	jw8gGaqrSXUMzmATmUJ1S48heQAgcJAzTi7njmoLPnSwskiEHcG	10290	14516	14516	1618552080000	orphaned
20432	3NK8jko7XfeBfx7sgLcajfgzGSqPhxi7542r8i4SXfafd8Pp3GbG	20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	1649	1383	369	12463	12758	jwnaTe8BRwf9bdptJUE9dXjW4R269XwBrKTQsLZiHkqjcGmaTks	10292	14519	14519	1618552620000	orphaned
20437	3NL3BocXutVAzp3NHqFamb2PMdruuZj9WuRa1kX5D4TBRCdMgw5G	20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	1540	321	369	12463	12760	jxy3hrF4XV5K2U7WoG5UwwS5DgBicpYV7bEKC8SNf8W13SkWMv1	10293	14520	14520	1618552800000	orphaned
20443	3NLTsMKrHBwu3628YBKqLnpreKtEQAKxkjbaVYXcCMSfaagDGWcj	20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	1421	508	369	12463	12767	jwo7gyz7fuMshKk41GLLJP8yMMbKejAGuBJhAoAjps8QmVLnX1d	10296	14523	14523	1618553340000	orphaned
20448	3NKnUzVtt7NcJi6rxmZn1s8xbpJ48AQhJCSpwfZsK59TBQTuMxbr	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1402	870	369	12463	12772	jxJDj52Qp4pABZPUFmaXcmcPmfSULDN35PZMmMauJpRJ5D8NPJP	10298	14525	14525	1618553700000	canonical
20452	3NKBx8iLwwHebahFqu8oDJJRHV9znsVqBbNSAnByFwJ9a4E4w2P1	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	1529	1070	369	12463	12776	jwLGmRJJdpDwQa8VDX1qytzppMgb57hjxzAw3n91M5yiXSGa673	10300	14527	14527	1618554060000	orphaned
20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	20453	3NLtP7tkcA1qiccXky1XkxLRLMDvs4Uedr8TQsfF7xgP8yALHjBM	633	1138	369	12463	12780	jwyLrPStbDo4snmxj3zrWA5PFXan2NRQW5tte7hG8TbaJMjkc8T	10301	14528	14528	1618554240000	canonical
20459	3NKwMoGucFxG7D45SX4rs2Uqw1Vhdv8EEGH57rpZcbC7xHegMpvp	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1613	1103	369	12463	12783	jxy7Rgwmpio1cNAdBZz6svfdzHNrJCDrsFwBzvLY2MAgnyeKD6m	10302	14529	14529	1618554420000	orphaned
20465	3NKoTX4EhaX1kTwM7SDb3hXA7x1Euaq7HWrtbLJzRLJzhrztjBLH	20463	3NLEjCnEv8vHrBUXvfS2r7QdrwfNctwx6KSPvrtgZxYD6wVr9D2x	1634	1331	369	12463	12787	jxZgGzs6NBzQo4TiEjktDvxBMmdAf72drxTTHWLWU42YofWUjLZ	10305	14532	14532	1618554960000	orphaned
26978	3NKsbhohhoM8zWcVqJh3WUe6LhmbksrsTBfkEiUyQX6wnKzFnfrK	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1624	1334	521	12463	18624	jwW5AU4CZ4GUzpedCVfVGtKCHZqWXkfQLHo3zvqipkMeBuX3FrT	13340	18778	18778	1619319240000	orphaned
20367	3NLos38uPPaDu4VqpAqypHR8HZ9F3qU4AWvwsRBiLboxsrEcPGxC	20365	3NLJ2ZUc5idnKuSSJx4Yub9kAwEr55ajSQQvBN3MKzqMMcBWLeg3	1460	958	367	12463	12700	jxMirFCU9G3TfPJeJiQZNqseqW9RJypKUF95XXhF8DqCESh1gV7	10260	14475	14475	1618544700000	canonical
20370	3NKUnk3AAHwGyHeW5WCEUcFVuScWAFZx55a72GSXGrfR4F2NBtqP	20368	3NLtKiRVttJTsmXfsGfntkDrxazeskWrCAksYvcp7oMA2wuDN61h	1406	1393	367	12463	12703	jxbyYt56YtvjMfVjEZGuQ52WNbDmvR3qeNsezp8YToUoj61noHS	10262	14478	14478	1618545240000	canonical
20372	3NKzyw9K66cARJFTr4xcCPAbRAtoUYrYkZXYcNKGnNA8FNQQUWKZ	20370	3NKUnk3AAHwGyHeW5WCEUcFVuScWAFZx55a72GSXGrfR4F2NBtqP	1403	811	367	12463	12705	jwzMdMcuH87V1opivYirxCRpxdHyFh1UpJPmUw4CXgUqnwsHyzz	10263	14479	14479	1618545420000	canonical
20375	3NKia33XGuGhGZaL23MU4ptfkWmY2eXKVqquj35iiWGGcVqbhrpy	20373	3NLeNBNUyFwcgAnh4DJNwQCdjb81dXryc5hAhjcYRbadY37MEEzJ	1474	1329	367	12463	12708	jws7HKT7FVGsXHRTn9Vipgp7yQSZxCE12XvJVov99jnD3trxQuu	10265	14481	14481	1618545780000	orphaned
20379	3NK5hFLFTMM5CRJb4bNRSynLe79ENipqWeMiTo1HgCQA1ALGwBp4	20376	3NLMDXxV5yuf4htHer99amZxfNyfKtxBfwgKG3AcSVzCzw2o6u8w	1419	814	367	12463	12711	jwZ9sFyABPc8GmVwUrQTpi4e9go3A1Q3wxC4AJY542CDYJY7mSj	10266	14483	14483	1618546140000	canonical
20402	3NL9ohbTzjUkvy5XXoAMdFNxBAEjELGJt8QfYLTeGHmURnCCBBiN	20374	3NKfEnHtYz3xKNLeZMYcq2ywrPnfAeyPMG2xR1KDgafkEeccwDq9	1422	1337	367	12463	12731	jxAnVUWFUUfyCzaJFbXTPBJ2rC8onv6R2iWyqWDT5Cqvt8xfjkC	10266	14499	14499	1618549020000	orphaned
20382	3NKUUcebqwTystWuTRX7kHTU2TbdiTzKbNrYNqxsA9UN8ZYHqnCN	20380	3NKig7XGA4u9P2FErZ99d62DC2yAFRCwespFkHXEHNFRXEqPh8qp	1553	775	367	12463	12714	jwceoxpzggYMWM1WZ9juDudjHtr317JVDyTHMudqnsQHgF7G5gU	10268	14485	14485	1618546500000	canonical
20384	3NL6fBj5bqo8CU2rZEvyBY5M2Br72anVtrBAZV9Dx9HDA5QYMyov	20383	3NLJXgSFwndL2RNWkM14ywNPf8eBg8BVWxpUVYVKVPyWZwQ9EBxc	1402	809	367	12463	12716	jw9j13Wnbn6Xxbn2v7bGdQVpdjEupP8Qo41BDozfbM1Fx59MhQz	10270	14487	14487	1618546860000	canonical
20386	3NLVQKDTkvDQb6YQ3uD9S5EN7qXuB3yEyYghnPQbvf8s6iBDjVnr	20384	3NL6fBj5bqo8CU2rZEvyBY5M2Br72anVtrBAZV9Dx9HDA5QYMyov	1509	1194	367	12463	12718	jx9XHChCdtCKyV13bftu5LKrEHJLVzEutgQLNbPpdFQ8HC1P2cD	10271	14488	14488	1618547040000	canonical
20389	3NKRpDaPaahKGrQb9ZFgRjMeuw2K77pv5wB8agRUz98K3n7Y5nef	20388	3NLK8CmAPwqDQhRRqSt2P3LUxUfbkVnTjs4L7WpiLjjW3VidbwUS	44	1079	368	12463	12721	jww2naWSEYXnGhRbSJesdtPd8Fr6KhdNHvP66zKnmDu4wdbF1ev	10273	14491	14491	1618547580000	canonical
20395	3NK8efytF2GtiC3Axiom6aqCVwoz3fgCxxK3e93nAMh9W7m94yMG	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	1523	1075	368	12463	12725	jwSX1zc8HtNwbEPY6jga3m3apiiTxBYi57yPENSL7kq26YaWPZS	10276	14496	14496	1618548480000	orphaned
20400	3NKpGSZroUfXf23KUgw5mhb6fr7KgAaswxcHgYTJ3JsUsAg4Su9r	20398	3NLsKmmpEMmCimyiP1AaUWGArrS516yUfBfx4PjLBVwys4vorCru	1406	1393	368	12463	12729	jwYPbfbyrcSLWGyqTG64NiE6zaVT7yzULoUWp6cUDF9WwWEVrBF	10278	14498	14498	1618548840000	canonical
20408	3NLTwQ9SPdHTthL4qcQpAK56umApZLpEeeNNtznkGrxsqNy8dc4y	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1609	1087	368	12463	12737	jxi5rr9M6o5rgJMx6QK9YGYAiBJemgXEaXNhg2goz2uDeWAdPL7	10283	14507	14507	1618550460000	canonical
20409	3NLvxkbyZZnHzoP3LPCBXDD4836bdYa1CRKjYADECphhcgVqmyZA	20407	3NLPMm7dVDVxBQJwBTQjFC3FMJkjCm9TWhHEFvpwqSFZXsFTDgJr	1609	1087	368	12463	12737	jwhYz1b6TFTRivCpFhkyGEdczyHdotonSSNfsEKZPbsMnCwmfhf	10283	14507	14507	1618550460000	orphaned
20412	3NLKqG2xJMXaXSFbub1656gX2fdxYJyJUgDJw1m1yLKhPRooUcYo	20408	3NLTwQ9SPdHTthL4qcQpAK56umApZLpEeeNNtznkGrxsqNy8dc4y	1650	1375	368	12463	12740	jwW384ae17unWdu5Uu5h2jKxWRfioHsez5Xz3jw7iHKSQ7EGwoK	10284	14508	14508	1618550640000	canonical
20413	3NLFNLRe7nMVDbn11fH5PK5ifGaAfrJ9yrk3HMA2gdz1jMadBA6h	20408	3NLTwQ9SPdHTthL4qcQpAK56umApZLpEeeNNtznkGrxsqNy8dc4y	1396	436	368	12463	12741	jwQARNUwYqgVjmtsoszmtDkK61b98pA6NTzzpVDz1ydEG95rf91	10284	14510	14510	1618551000000	orphaned
20415	3NKtENuT5U2yzDHn3fUNZsm3nVGToqp8TGvFZsxGTGUeyAcBT9Sq	20412	3NLKqG2xJMXaXSFbub1656gX2fdxYJyJUgDJw1m1yLKhPRooUcYo	1476	1125	368	12463	12743	jwzhHLCrw6qud5zvtfrWLk3W1ZpdZ272gjkhEXpCuips4vyujiJ	10285	14510	14510	1618551000000	orphaned
20418	3NKuSJ3Q56qPJutWSca9UhciK82PsxcE1VQ8gjKDBEyRZi9N8ih5	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	1581	777	368	12463	12746	jwu3gPn2spnvJD7Ev8pHxBX7YK95L8nxibnebUurihPbAvMqEcv	10286	14511	14511	1618551180000	orphaned
20420	3NLNsNDcMrkQma2iqdwbC2xxo5EtyT4bVvAXS6KXjqHbqtSFcTeP	20417	3NLi6WNWEPs8n9XfAd25QQMMZidL5G5FD8jctH2xvP11DpVKwqDo	1474	1329	368	12463	12748	jxcobKnTVL654fPd7y8frMazeJHrkYAzVvgAMFbgSSdhb5P2obm	10287	14513	14513	1618551540000	canonical
20428	3NLBf5giQi1rTh783FchTeJbBBM8Xm6P8mJo42fdVeoSNyEoCiuQ	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1624	1088	368	12463	12754	jwt7dpe8uR3YZL9LmAXuz3nMegu3eeVPjU3AKcB8vkfU8oPBpTB	10290	14516	14516	1618552080000	canonical
20424	3NL857UDGqJnd5AURfSQmN9TUx95d4RRVUNdLG1w9W6xpzEHpJjf	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1503	1277	368	12463	12751	jwWvLUsZN72FRqzz83ayz5DdUij6ESw5ioc9fMqjHaNgJxam4kK	10290	14516	14516	1618552080000	orphaned
20435	3NLsN3u4SLBjZz3PMj9bHaZh3aavpEzHuXSYBzMcvoYZGw8p7Y4D	20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	1540	321	369	12463	12760	jxJnajVFMTAjzXBixKTPuEuqYmyxvFCQBMvQqj8Xvw9BJi9ceKp	10293	14520	14520	1618552800000	orphaned
20440	3NLALYoyASkBqMdBHTCJevRVgq9RkThBFsBFYfJZRi9HV3U4LJeW	20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	1578	1170	369	12463	12764	jxqcnQEGm7BGYm1ccyKgNCxGELgZKPZTmG9RRooURLLm7qUV1ne	10294	14521	14521	1618552980000	orphaned
20445	3NL3J1bdWT4z9p2ZtJmKxyKP1EQtXMpDT9nQq7UDcvZRfjDdCnYB	20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	1534	164	369	12463	12769	jwLgfAZ4UqBdFoPQdMEQsnMpPd4ZUz915EmuDr3uSRVtp3NmWdu	10296	14523	14523	1618553340000	orphaned
20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	20444	3NLwNSJozhN2Ndb7Mstbh45hSmHegYUqz5ZasQfR9iKt72tVgBVg	1406	1393	369	12463	12770	jw7mMyZ84GQyLKRCU5eVpd9eNrqMCBmQEhrMPFhauXVb5jkb7NH	10297	14524	14524	1618553520000	canonical
20450	3NL5jBHvguWWF1jv4hgnjGUwACzftJBZPx7F9YfnnQaPPqqTVwgx	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1560	135	369	12463	12774	jxP3tuJ1SCoMiTgFMivHANDYvj5JcbzkmySXxkFc474sWRnkt2k	10298	14525	14525	1618553700000	orphaned
20454	3NLarnVYurPfsuGjGtPYyAL1txBYRENP4wYgX6k1sTYXvCg8TrXh	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	1507	1280	369	12463	12778	jww4bUPpyfZbP41KbwZwvsPfuQb9kV35fYgmN3Eb4Wj2Cmw8C48	10300	14527	14527	1618554060000	orphaned
20458	3NKHm2DY7wwjFWcj3agymsGquWsMVm3f8beDLaPMyFWjchfLqff2	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1403	824	369	12463	12782	jx55SuWyYh6KatANLt7kDx9Jpp2Bxn8ykwpBvNXUzy9LubLKDrD	10302	14529	14529	1618554420000	canonical
20462	3NLYbSAfUgti1uKr5qhK83A4CWL4HqUEdKyvvMLUiE9Yh1FS11oM	20461	3NLMxVUSQcYFGFwMsyj1SgHL8jZRt4pzX3f2eXjaGHBHgik4Ypy7	1406	1393	369	12463	12785	jxqbcsHvgzvAe3RZd7ZgbTuwpBaEtQrNjQsS7vdoCaCPgASTLVx	10304	14531	14531	1618554780000	orphaned
26977	3NL9BteEuGKjc7dkt4VQfNppDGTbuKX34KjHEozxqTDPe8GvM2EC	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1501	1360	521	12463	18623	jwD3zUKjoGJbRfiKuqjbSNUD4wMro193nwSSWF4cDkHs7vVCh42	13340	18778	18778	1619319240000	orphaned
20429	3NLJT9mure82tJryRoMc9k4hn7fHScErDcZZhViWs7stwF4pdkGW	20414	3NKXhYcJVvFx9NSvZ4zzhqBgXsurxHBe7dC8Wkegq86tbeMbsvpd	532	1303	368	12463	12755	jxG8FGsqnCo6n7foTS2okXn1AZyJu4ZNkwGn24MsXrQxWMcmpic	10286	14518	14518	1618552440000	orphaned
20422	3NKQzLmmKMfbzkgRzP4yuHEYXwsD7mpKeqZUS3C9DCLQrzcGuZnj	20420	3NLNsNDcMrkQma2iqdwbC2xxo5EtyT4bVvAXS6KXjqHbqtSFcTeP	1406	1393	368	12463	12749	jxzRk9vhDaxhAX5nkMFJvkqAYB4wwBqtwjsifipg9gHAzQ2jcAQ	10288	14514	14514	1618551720000	canonical
20425	3NL1p5RxAXKKX85ARBNgKrctrU3obebLN5fXxbeFBWpLmQLzgabH	20423	3NLrKeGLJiHSubU133LW8vY9ouSwXqBCYcBdy6GjAkKNt2YhCHh6	1503	1277	368	12463	12751	jwWvLUsZN72FRqzz83ayz5DdUij6ESw5ioc9fMqjHaNgJxam4kK	10290	14516	14516	1618552080000	orphaned
20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	20428	3NLBf5giQi1rTh783FchTeJbBBM8Xm6P8mJo42fdVeoSNyEoCiuQ	1500	931	369	12463	12757	jwymzoJkcD7rqZeE1EDuPT9cMM61T1oKERYPX5cgNCZYMrzUnbS	10291	14518	14518	1618552440000	canonical
20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	20431	3NLQ2X2aGyjcFTUDG84fLXckBeFNNVAizctr7GPsfLYBsfKfmP6f	1483	603	369	12463	12759	jxFL1fZKs3PArFXcH1FRabm1v8oWPPfF7RBzXeviUUZHDgeRP5Q	10292	14519	14519	1618552620000	canonical
20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	20434	3NKvLytwfj7zGnXm6nf3jxiyoHmAay8Xd7mi4cazpepyWhidvjKq	1637	816	369	12463	12761	jwEidcLCe9tY5MhaKL8wq6PgxK9azqE7b2pBsqYDuf4MChshJxk	10293	14520	14520	1618552800000	canonical
20438	3NKS1gNwd2MNr5EgbasxzFwicMagkzqix4Dujfz1wpLcQ2YtrmfC	20433	3NL9x4No92thVksodBTgEN146J8imzACEG9skXKxaSXK5qDbpaX7	1631	794	369	12463	12762	jxqUcUvduxT6cPmakX2CoVGePkD91ygcbetJZ3j1VSKZkgBKSmw	10293	14520	14520	1618552800000	orphaned
20441	3NLPrHRh6AtWB8HkdpM2GfyTN7Na8L4xgQ2mPXaxzdyxPPJa8EwP	20436	3NLy69smc1zELNLAULkwiQ2zoqoctAanqyJJ2P58WVwEaV5PxEF7	632	1136	369	12463	12765	jx5FB7bnhSLc19oxGDDbupL3Jo4BZ2EpqAdZSFtzKY3uaBJAip9	10294	14521	14521	1618552980000	orphaned
20442	3NKTUcr6ctnVKQKV7kUGwFxzTSgm3xhgtkARdyW36neCRXrycTfj	20439	3NLcfFNyUsEFqFv5sCfUBLFVaGJiryTQBtYYnG1dLEejSyJjoFnT	1672	1285	369	12463	12766	jxFm4tFT36AD6BouK2BnyBAt61fgSNCZdYejzkDYgSWM1PxT6AE	10295	14522	14522	1618553160000	canonical
20447	3NLrp1XZ4Qw5rS9VyeyP7dgoJqgAkNzyUvBLojQ888ANV4AKyXDs	20446	3NKUmxNRDZ5zPgygt7yqUbXYAKFGK5EP1E2U73xp9E7ZHsTDFFh4	1642	1367	369	12463	12771	jxj634iTG4LmTgfwaA33BJksHMWA2sRJPSFT8WaLJNHhfjVgMuv	10298	14525	14525	1618553700000	orphaned
20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	20448	3NKnUzVtt7NcJi6rxmZn1s8xbpJ48AQhJCSpwfZsK59TBQTuMxbr	1407	1395	369	12463	12775	jwUX5CJTxWP3TdZKQ3stbfdqskMzGyHXd9WErPhYrUWNtmQfDNL	10299	14526	14526	1618553880000	canonical
20453	3NLtP7tkcA1qiccXky1XkxLRLMDvs4Uedr8TQsfF7xgP8yALHjBM	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	1406	1393	369	12463	12777	jwkHdcQxNo2QtkNCLjwwGXSzQKdiLJEsJeJZYaoT9Ch1UTVLYGQ	10300	14527	14527	1618554060000	canonical
20455	3NLfefJY6hWd2AWMhL4PcGD6Tsj423JuwKnEZK7rMXtNLyG9Wp7J	20451	3NLmTxE8HCpUvyrsjyD4QdJ9jFDCK2T9BBJFsTwwA9Kf8rCWUd1R	684	1352	369	12463	12779	jx2k2dajA6FYd45SJzo2upmrL7jH1oHpeNkyuhhxNYnJqA2FFU6	10300	14527	14527	1618554060000	orphaned
20457	3NLAJX6fmCJk9i3FxvaoHSLhgK1QRKmicmupeziM18MKYmNVj9AR	20456	3NKP6j7PNjFWprD8GBgwJ8EeVStVAiYAXnwRZa7cZ2yK1oou9PnQ	1483	366	369	12463	12781	jxtuYpgDXti4PzGpPgos2sTNz1Zb8LMWbYcugh1gsVs512UDu7c	10302	14529	14529	1618554420000	orphaned
20461	3NLMxVUSQcYFGFwMsyj1SgHL8jZRt4pzX3f2eXjaGHBHgik4Ypy7	20458	3NKHm2DY7wwjFWcj3agymsGquWsMVm3f8beDLaPMyFWjchfLqff2	1521	305	369	12463	12784	jxQuDHkWB7zTPAReMw1zb5uu1bCaU4hY1NCtac4EtK5MKtMiVWw	10303	14530	14530	1618554600000	canonical
20463	3NLEjCnEv8vHrBUXvfS2r7QdrwfNctwx6KSPvrtgZxYD6wVr9D2x	20461	3NLMxVUSQcYFGFwMsyj1SgHL8jZRt4pzX3f2eXjaGHBHgik4Ypy7	1536	1067	369	12463	12786	jweKDZzdEThQEaSd4U3vCcTCtpc4nKfqLhJGzLMvkoMECC4dWUE	10304	14531	14531	1618554780000	canonical
20466	3NKXjD1vDM63YFfSWtN7fmhcsic8oYf9GJDiZoU6FSKmEHuhk77E	20464	3NLrrX5cSmxMkDWv56udRS1rarn7gnA9SfArfBAhwnbg5HAdaKBF	1637	816	369	12463	12788	jwyXroYYtoQHWFQozkfwYCPbHTNBukwRtH6rAt5LJTa11iFKJfK	10306	14533	14533	1618555140000	canonical
20468	3NKpYdh7ZVQfBN1recpWx4CaDphTutVJM7rqbRnq5FLe6shmWrvr	20466	3NKXjD1vDM63YFfSWtN7fmhcsic8oYf9GJDiZoU6FSKmEHuhk77E	1407	1395	369	12463	12790	jwkhMT4k2FXDF6eQqLzsKrGU5guDwFByenSUrKaoMxznB98QSi6	10307	14534	14534	1618555320000	canonical
20472	3NLtQgCWbpKRcsxnpYJPHMVAA1yHUFFkjqHrh7DYwAPfYYj1TQJP	20471	3NKPieNsmp5FVnYEFqyuu1er94eVN9vWDT7tTS3CqpiELmMvQMds	1407	1395	369	12463	12794	jxAeQnMxLVwYRNeWsRNGaPACkEZPmKX7RnHJ6QqJiKb4Geddehy	10310	14537	14537	1618555860000	orphaned
20474	3NLMYXAuZumm9oiK8UG4RSbmcnWnnRxAZKYGkgYd73sF6cNiH89e	20473	3NKgbg3tN6N6pq2B4FbkioeFRSLLj6MJeX1XLdUU5D5QJfuWeAgD	1500	1297	369	12463	12796	jxQbFtyZ9pMe4mQRoRUgi9n6EjWi2qeXX1BtXMuJQ7GTr58xNkG	10311	14538	14538	1618556040000	orphaned
20479	3NKUsjPgoHMd5y2HB9u6aPowkRRvgR8AU1Myqt2CTaQCWJwVutY6	20477	3NLC4XVbHa2nJeqjUejCeTokX9LrTtPKeMw1ax7KhNyntZquWqV8	633	1384	370	12463	12800	jx2C48rZ1wBEgYxevjhTRYMApejwN4gPrEA414mSKzznkwsBZTS	10313	14545	14545	1618557300000	canonical
20486	3NL6PxNDcsxMkUnLzjaC2xkBnd66BLEnnmkkei9H3r4dLU78dBGa	20476	3NKBhS1b9AQDvrZbZe3f6ScQABrY66gsEPyZ3QbahctqNQH4Nuio	1451	1292	370	12463	12807	jwdCpVBGTCi1DqAfgHetCz2pHX6LhkRJW8RHyCxP6MhWEhUchwa	10313	14547	14547	1618557660000	orphaned
20483	3NKdZA7Jzx4QsCW12KebAEjZ5cbuMSoFR4k8JYBebvHH4yR71eSm	20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	1668	1124	370	12463	12804	jwNUzEf5NwzUyog8pSNPM8N2KFxGjVtxDBTVqvb9jkD5NjGb7hE	10315	14547	14547	1618557660000	orphaned
20488	3NKRy1upNGSECwbtk4vZKdvaP7AjMtCHLYAAAU6wGxMnQyAj217F	20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	1647	1302	370	12463	12809	jy1pCxadLDbgP6R53J2GKJt4sJuCVwHj6sDZ9nkVAuTPKpYbcd5	10316	14549	14549	1618558020000	canonical
20491	3NKdc5onUxBimQ7qxnk76se65uHu5PCn3KZ6nspDfjs7mWLJrXA7	20488	3NKRy1upNGSECwbtk4vZKdvaP7AjMtCHLYAAAU6wGxMnQyAj217F	1637	816	370	12463	12811	jwZRd1znAugokDz3NRSos8fqZWAhuwFjyEHN93xHLkmV5JgyEro	10317	14550	14550	1618558200000	canonical
20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	20493	3NKQ3egNzjyxL8jnWSWBAH3oPZ8g4yZLNtNuJbHutSVfrKqBDfL2	1647	936	370	12463	12814	jwuMm3523sRXXnyj95cHUu9K7zytKJbhNkVydUU5Ay8xHaWcY8r	10320	14555	14555	1618559100000	canonical
20497	3NLqVNqmMMtxU2gJKkH8iQouUWfUiqQcLpxq8pyE1utrLLNzV536	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1500	1297	370	12463	12817	jy32ZQd79kL3sM6QKCFaiRmgURdfwjqYGdS23W2HEDVV5t4yU4E	10321	14556	14556	1618559280000	orphaned
20498	3NLaRMwVJ1pSqnobTznD1DNxxoa4SNCooWPWSB2b9Kj2T1d6s9Ja	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1500	1297	370	12463	12817	jwX4d8E5UL4uT3jzzaQdDQcKRiP7HDXYv5pRm36Bcffzh5hVh24	10321	14556	14556	1618559280000	orphaned
20503	3NKffJAiptH1PpGRFYsDCYywiyqwsWo46xpwoWaPZu8jg4QX4buy	20502	3NLwz3EFeVfXpTEa2ky4UNPQvMHbzXmB5YBxUfuZQ2wjcLQyqsaf	149	1157	370	12463	12820	jxRThkqRzoHCNx3zGZRKskoWbJp7UR7RiEjYnNXxCphbA6eGTuJ	10324	14559	14559	1618559820000	canonical
27280	3NKsY4kkZft7m9fMBoNnz3eHor7BhefiTfNNUZatKndL7wfd3n73	27238	3NLuD3dNN4GedmALRECb85hEvir5VqErxHq7aG9JMyi9o9kdNAND	1623	830	521	12463	18897	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13341	18975	18975	1619354700000	orphaned
20467	3NL3Y93GcAJBbvRG3yaoTDmXJY4HKTsrKcW9FaJqYdAEnpRgaZ9q	20391	3NLnMr16GTvLWwzCjYqqmVL9hAbtDkagzXeZCWdeta5L9PUyLzFM	152	1204	368	12463	12789	jwKSDm4JFPKFaYURen3LdSfFvwuCv1zqa2Te7yzAm7KdWuose57	10276	14533	14533	1618555140000	orphaned
20469	3NL3GTJVuoGoU8NZc7mzXqgrZfCCrN9tmi9zXKdUdtaTTLk91Zjd	20466	3NKXjD1vDM63YFfSWtN7fmhcsic8oYf9GJDiZoU6FSKmEHuhk77E	1553	776	369	12463	12791	jxX5rsos46E2CSZmoniDwTrxQYXVKjcq3wRXU1PWZoK9G42KcLn	10307	14534	14534	1618555320000	orphaned
20471	3NKPieNsmp5FVnYEFqyuu1er94eVN9vWDT7tTS3CqpiELmMvQMds	20470	3NLmL9d4KWaQrDj16VQbwfJ7j8SEXFPkJf8S5ivrAEmduqdFzTYN	1571	1089	369	12463	12793	jx7jvUjayBSJkE91os93Y3iy5Tjho4z4tVi3N69iH97ovZCUQY8	10309	14536	14536	1618555680000	canonical
20473	3NKgbg3tN6N6pq2B4FbkioeFRSLLj6MJeX1XLdUU5D5QJfuWeAgD	20471	3NKPieNsmp5FVnYEFqyuu1er94eVN9vWDT7tTS3CqpiELmMvQMds	1445	924	369	12463	12795	jwtQpVNne1gXE5z1Wp5iouUWWXW9qtSGdGgqSar2i1s2WPK2hiA	10310	14537	14537	1618555860000	canonical
20475	3NKJiGzG5meePhRYxMvpRAZn85vmtbSczHAeJKYLJYz9Yzv6vupB	20473	3NKgbg3tN6N6pq2B4FbkioeFRSLLj6MJeX1XLdUU5D5QJfuWeAgD	1500	1297	369	12463	12796	jwcg7ZC6zc26QmB31uN2JvZ8rcwfCKxDeQdaufSuXo1pY3cDNBs	10311	14538	14538	1618556040000	canonical
20477	3NLC4XVbHa2nJeqjUejCeTokX9LrTtPKeMw1ax7KhNyntZquWqV8	20475	3NKJiGzG5meePhRYxMvpRAZn85vmtbSczHAeJKYLJYz9Yzv6vupB	1419	814	370	12463	12798	jxkBMVkqb9PnGUgSg8JDWjPqdc4h5yWi6dZMkWwQAHpuYs3Vsy2	10312	14539	14539	1618556220000	canonical
20476	3NKBhS1b9AQDvrZbZe3f6ScQABrY66gsEPyZ3QbahctqNQH4Nuio	20475	3NKJiGzG5meePhRYxMvpRAZn85vmtbSczHAeJKYLJYz9Yzv6vupB	1457	1265	370	12463	12797	jxbXMgboTRv1F7Unq8u5Zx8ZJcL57b9JHxNWozSUW7DAYZ4uENY	10312	14539	14539	1618556220000	orphaned
20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	20479	3NKUsjPgoHMd5y2HB9u6aPowkRRvgR8AU1Myqt2CTaQCWJwVutY6	1593	1346	370	12463	12802	jwJJyak3MWxVdx1NNjJsYyYPiuKgMycotoEnwTyLQqUbP2Jto9b	10314	14546	14546	1618557480000	canonical
20482	3NKVkq5ikCYN9vCW33C92fzbYXkQ4w1YuPvGpcyuiDvNTg8c4cTG	20479	3NKUsjPgoHMd5y2HB9u6aPowkRRvgR8AU1Myqt2CTaQCWJwVutY6	1534	1071	370	12463	12803	jxmveuWyoJXseCPPdjcotj31fugUvdyeVKB5288PfgtjwkGM8Sf	10314	14546	14546	1618557480000	orphaned
20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	1673	1368	370	12463	12806	jwkGnePCpNriVPj3XdHUd2LgyL1UjW3scWurrSimnNgNWAUR48g	10315	14547	14547	1618557660000	canonical
20484	3NLt8V2AsVXVzkd7wcVdS6MfFDr4UYhQBDe1KYaWkKWKZdrV7hzC	20481	3NLhFNTEYQu2ctEXHMUBc81xCXQocxSvuoLBzwLegWMQHvhPtPjj	1451	1292	370	12463	12805	jwvNwT2HGk6tXWW8AJ7uDg7J5unC5r1JWKNnvxNLs4417NxfDfg	10315	14547	14547	1618557660000	orphaned
20487	3NLRS4StprFvd1dfC2Qj6kWjtvJaiubKuWLcHSnqgapPKBpZkxMY	20485	3NLJ2uwYRG88tiRvusChHgLGTvbMszPDXsyA16Lm2TfWD7zcgAWa	1476	1245	370	12463	12808	jwwz8eKxehrfmrWHY4vujoCtMjNLvpzH4PW3XaUj79qR3bUjrMN	10316	14549	14549	1618558020000	orphaned
20490	3NLGcR7SuDL1S8beiTpZCGyDbLRWvAoLuqSTWWfMKnmWJQVowJ4u	20488	3NKRy1upNGSECwbtk4vZKdvaP7AjMtCHLYAAAU6wGxMnQyAj217F	1646	1228	370	12463	12810	jwxJgbtxThYfPNgQNGinHHFzuSXT8Gdtvf6ZJzLhM748Zs7TKgk	10317	14550	14550	1618558200000	orphaned
20492	3NLutFnyarPh8PRu3jX6W5dC2wMczGF29t9HKuLxEAaSkM794buQ	20491	3NKdc5onUxBimQ7qxnk76se65uHu5PCn3KZ6nspDfjs7mWLJrXA7	1477	1104	370	12463	12812	jxf8QjVAiT9hKqD371PVJHQC4hHCy5U27s1QrQQw47j7nyeAfZX	10318	14553	14553	1618558740000	canonical
20493	3NKQ3egNzjyxL8jnWSWBAH3oPZ8g4yZLNtNuJbHutSVfrKqBDfL2	20492	3NLutFnyarPh8PRu3jX6W5dC2wMczGF29t9HKuLxEAaSkM794buQ	1610	1068	370	12463	12813	jxWwZ3iGzRvZepj3cPz6gRQivSPnHN6QEvKMe63GdNXgAQPRHM7	10319	14554	14554	1618558920000	canonical
20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1656	1217	370	12463	12815	jwjpY13somfPkdsMEFQdc5xvEJDMqGF7gqdRDZGyoUYFMpZttna	10321	14556	14556	1618559280000	canonical
20496	3NKTvpNDYeiF4ik3EtpgH5V1ZaBQTA3dtqPaY9UKvs7HRNouqz1u	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	1646	1354	370	12463	12816	jwEqbtiWU7FxUiifvWTNoLcwJGbS8AENKt1ytVRAshUaPDLkMEv	10321	14556	14556	1618559280000	orphaned
20504	3NKKvvWW9qjkr7uMmohCTNXQpYLYsRrG8Sx8buzHQQ9VzYGJvpnf	20494	3NL6oGuaditdqrzp38DhUKow9MSD8mMkT9VjgoXtkfJ9VYJh4CPX	149	1157	370	12463	12821	jxkgLRt7LWLTThXvLpNdzxGfRdQ2ELsfpjdFXakoqZ2gS3KzkXM	10321	14559	14559	1618559820000	orphaned
20499	3NK9Rdd6fB8nsd8atueDfUVTUsPz8SHBKvu2GhENvKtY9KAutAUy	20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	1523	1321	370	12463	12818	jwcPMpQgDqejvvhtD5KtZkjpeZk4LMnm9yHyvbWUtyys4AXbXiU	10322	14557	14557	1618559460000	canonical
20500	3NLiBPf8ZxHaF4baBh294UxZH6RRqTq5DUfBAvW512atP2Vj7r6E	20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	1523	1321	370	12463	12818	jwtXKfRFW3wFPQCudoBAxbpdqwDiFk7bMn3RZaKJVM955xZ6cAu	10322	14557	14557	1618559460000	orphaned
20501	3NKY4TeAxNxT4tgqAP1MvEdYyVnEBeV2vqimMdJ5JMKDRub6PwB2	20495	3NKV7msBbpMRsd7jhRH6ogFZM6aYVRQnJuY8aFdURNJMYzcKceyf	1523	1321	370	12463	12818	jwHeobLNvg8FHYR12vFWAk3JBLtvBcHRbFeUYb8sCQHaWp7qRdW	10322	14557	14557	1618559460000	orphaned
20502	3NLwz3EFeVfXpTEa2ky4UNPQvMHbzXmB5YBxUfuZQ2wjcLQyqsaf	20499	3NK9Rdd6fB8nsd8atueDfUVTUsPz8SHBKvu2GhENvKtY9KAutAUy	58	915	370	12463	12819	jwXtf7QKset3i6xKfzH5ka69iTp99n5sFP63coewdnXKu1W8DHn	10323	14558	14558	1618559640000	canonical
20506	3NL9dR12bskir3acHseZ22c2a6ozabBGPF5xXXqfPteLbxgo87fd	20499	3NK9Rdd6fB8nsd8atueDfUVTUsPz8SHBKvu2GhENvKtY9KAutAUy	149	1157	370	12463	12823	jxF4tyseTES6xy5XdZ682yyY6Rg51rJbFBtNX6YVA3QuY4nq1vY	10323	14559	14559	1618559874546	orphaned
20505	3NKtxz5M3G8oEF5cBPnaU7m8ZwMNXd7ESs8A6EmJMbehQM8KKsVu	20502	3NLwz3EFeVfXpTEa2ky4UNPQvMHbzXmB5YBxUfuZQ2wjcLQyqsaf	1534	951	370	12463	12822	jwp3bGauEwrgeYHm99zXk7wceHiGW8WvENVHF7h5vMPa29J5wpf	10324	14559	14559	1618559820000	orphaned
20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	20503	3NKffJAiptH1PpGRFYsDCYywiyqwsWo46xpwoWaPZu8jg4QX4buy	1675	1096	370	12463	12824	jwKDsTP4cN9PGpBrsRwJhcFXQcXL7649zkiDG2Y8b5U1SUXQ4yu	10325	14560	14560	1618560000000	canonical
20509	3NLumdBioaVGRjc44TkZLGgD75Xr3eATaTbScm3gwZiGFwNxRcNg	20503	3NKffJAiptH1PpGRFYsDCYywiyqwsWo46xpwoWaPZu8jg4QX4buy	1675	1096	370	12463	12824	jwyEv4ZR9XxajSX3FybqqLXFhdkrREw3DA8jAzCUGu855NB2mVx	10325	14560	14560	1618560000000	orphaned
20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	596	1180	370	12463	12826	jxnapMx2HcG8RMkMk3pwSZdEvRDv55VGW8mQWkwQ7QW4otQRfzn	10326	14561	14561	1618560180000	canonical
20511	3NL5RfBNjW374k8z6SqNiGYEJYbEJQiCD9LW97YsSDDKWqefuTPu	20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	596	1180	370	12463	12826	jxhUNtCBX4MM9To7imLHzJeeGdB53V1MjsJ3fHdTiJ3hRc6AKvn	10326	14561	14561	1618560180000	orphaned
20512	3NLTHiBhBNB5cAFECHeDcdBqFHteGivdZg6Z1bjrFtktLebia8uJ	20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	1483	894	370	12463	12827	jx7MofbZPmUbzECjE67GkqPJYouiyxFyFQnCzZmq6wMUpF3etJd	10327	14562	14562	1618560360000	orphaned
27573	3NLvwG3TysFfRpQWPLkCSAmaJTiEVwGjVJNiMb2Wxz8eeg8NMeWx	27280	3NKsY4kkZft7m9fMBoNnz3eHor7BhefiTfNNUZatKndL7wfd3n73	1623	839	521	12463	18897	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13342	19190	19190	1619393400000	orphaned
29160	3NKNXBEFvdnnQDk3rRa4bJNKpytqWvGt3cP8eJm8Qrirbzxq3UBa	29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	563	1233	572	12463	18974	jwSv3EYeVzQXqJGYWhKMpRFaufBLeMJ6rxaM7Bpq2Z7CoeXGR1M	14378	20250	20250	1619584200000	orphaned
20559	3NL5mb6atvf9YocoB7RXBQ1RK9BKUwgkAvPSDhCSG519Wh3W5pug	20385	3NKnkwCfYHvcyTGRdKjwYVVfAyDDU3bQRWuoMX5zLJ2kpjqeN1zy	1509	1320	365	12463	12869	jxVKsrTCkf63PFQjR3BFjCLmWxWWpomsDP7vPjGQHWXpts2NdVF	10228	14592	14592	1618565760000	orphaned
20573	3NLRaxrwvPF6mrDsvJZcUNqSG9wrFCUHfhRMNL4apGds3DLyQ7sN	20486	3NL6PxNDcsxMkUnLzjaC2xkBnd66BLEnnmkkei9H3r4dLU78dBGa	1451	1292	370	12463	12881	jwp69q2SsgLzPdNkJduAKCiH3hzgcP8KuehfGF65VRDhcBjibCw	10314	14595	14595	1618566300000	orphaned
20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	171	1128	370	12463	12828	jxyQk1cYdDjkTxe9kjEcjSqU6pafbfX9nzA8w1BPmxZ2to2Yitz	10327	14562	14562	1618560360000	canonical
20513	3NLXUajqWe1FkceA2ufY1VWhUKfkm1kNbenR2nujtGAai2AU7zaK	20510	3NLZQ9AKaBShaEejcwng5V8urj6gm5GDDDUfHKMM4wt7YKbZek5C	1483	894	370	12463	12827	jwkW5JoRaWSDVE61wEpW1QWnKBoVF2fUodcbMDTtFXYLeEsFxu2	10327	14562	14562	1618560360000	orphaned
20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	1527	1293	370	12463	12829	jxB2dtN7A2yYFGv19guePhjjV4i9n3LLQvNcdvZi6gdhpeoKBwA	10328	14567	14567	1618561260000	canonical
20515	3NLV757VpSwmjNEz1sR1yxztPXfpLobsGdKg1KqPqbtjzko5tv6K	20514	3NLXNQKnggDKhuvrEnn2TsmoKpc1hkf1vF4EURHN7iRxC14FjpxL	1527	1293	370	12463	12829	jwmB3N5ea9WQtdycF7cp2EPUxJy99nnKyBudz6vGXDQRRAeiAwG	10328	14567	14567	1618561260000	orphaned
20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	1594	204	371	12463	12833	jxx8wY6a1xPswTWfKsc1fDsFE4h3xPVtzhwy88f937ZfMB9pKrx	10329	14569	14569	1618561620000	canonical
20518	3NLj2Qad9YMe1i935agcceasqPDmAW1WDQoo62SJua4seYY9yogX	20517	3NKSjhF5ksxabPjhud6poUYJMPmKN6Sgk49d1j9GH4hn9DtQNpZ4	576	989	370	12463	12831	jxggFog6TBvVKJD1heTijqdH4sNaVDr5ccq8RKkeofLY4zJxhzs	10329	14569	14569	1618561620000	orphaned
20522	3NKPcyMKVPCbG5n4RQf5cW6TCyJG9ueej6QM72zWJZKDgo8Lbet5	20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	1673	1368	371	12463	12834	jwZ6YJjBwJsCL9PL7VPDYaV3mVCwivKR8vuLZqBWn4Lf7geFy3Z	10330	14570	14570	1618561800000	canonical
20523	3NKAfACh3h8UE3yr6tnAqipMQSH12xwJhg3nDWhcLVgEf5yCxWPH	20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	1439	1279	371	12463	12835	jwt3PK94rHUxknX5ACyQXtz8rZ4DFr5iMXfC4jPfygStND83ve3	10330	14570	14570	1618561800000	orphaned
20524	3NKfWH58bsLk42VZVd8FcuSZEXNmpGcJ9mrF33SkxQ5yCCdA2dt7	20520	3NLYQiUnSPjBWJQytzhU1RWMuENncLGrw7kDf4bBCEMsz3p3CUe6	470	1183	371	12463	12836	jwPg8z6zDd3LYtE47wx9dEQRw3z5vjnhyzjC6jmraW9GTxMyK8T	10330	14570	14570	1618561800000	orphaned
20525	3NKk57aLXdM34nhNc28UjgzXGhgjL4YfN8Xm8Td3oMEPCQNqkoPR	20522	3NKPcyMKVPCbG5n4RQf5cW6TCyJG9ueej6QM72zWJZKDgo8Lbet5	632	1136	371	12463	12837	jxg2NL4uy1xRRncd15gWFCf3HLQakWkvGyYvpzF15j8yqK3fpMJ	10331	14571	14571	1618561980000	canonical
20526	3NLjxZuSafV5jkCnZXa7AbuV917j3Qs6L2uw91YQwFn4YnywhVLk	20525	3NKk57aLXdM34nhNc28UjgzXGhgjL4YfN8Xm8Td3oMEPCQNqkoPR	1581	778	371	12463	12838	jxtE6PFuj3bexzEnhsUCTXrLo5EnyTohUgvm2Bm4ekgbXNDeJbf	10332	14572	14572	1618562160000	canonical
20527	3NKRB7wibD1sHbtbBdAj7uCbWpnAyjFd5MUENu1vpcEiLZVoKV6n	20526	3NLjxZuSafV5jkCnZXa7AbuV917j3Qs6L2uw91YQwFn4YnywhVLk	1634	1085	371	12463	12839	jwsnKJj3aLqrbfFkaZepysroFtCmyodvbjbk2WoMRbHEkpWZmkL	10333	14573	14573	1618562340000	canonical
20529	3NL1BrqjH8iJB4qwUA8xvVnnpE41V8kcG6tj6z9XFdxxSNUyJxqh	20527	3NKRB7wibD1sHbtbBdAj7uCbWpnAyjFd5MUENu1vpcEiLZVoKV6n	1406	1393	371	12463	12841	jxizXzVcADFavsnRZJnMnr4fyHfwaNvkMM5A5qpLoGpeeuowqJb	10334	14574	14574	1618562520000	canonical
20528	3NLiCivuDoqCdoqyzasyChAqfQwaHB5k112ueBGRku2Wc4WTNTb6	20527	3NKRB7wibD1sHbtbBdAj7uCbWpnAyjFd5MUENu1vpcEiLZVoKV6n	1642	1121	371	12463	12840	jwHfAtbG5rXDkGGfcaJsa573NgTgRoLdAVFpo5o2RHeVBRCAhmg	10334	14574	14574	1618562520000	orphaned
20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	20529	3NL1BrqjH8iJB4qwUA8xvVnnpE41V8kcG6tj6z9XFdxxSNUyJxqh	1407	1395	371	12463	12842	jxXeHBGcHpg28drPBWgymZGnyyiWTm8BUFiM9uL3AmaSbLmwdYQ	10335	14575	14575	1618562700000	canonical
20531	3NKkua9LZUMGq74L1NXhB4JJRpA2w2nR2Fuin4t69JiFXE38ep21	20529	3NL1BrqjH8iJB4qwUA8xvVnnpE41V8kcG6tj6z9XFdxxSNUyJxqh	1403	786	371	12463	12843	jwKbXgY2PcnsL18id5FqNF8Y8bLeKwwW26fXG1VX3U3ufhBDk6j	10335	14575	14575	1618562700000	orphaned
20535	3NLJe936LLgMtsZPnpq33VFBXmvB1QKLZfNwypJBBbg8PZR6yG14	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	1553	776	371	12463	12847	jx6kSQvJCAPojhzuGg5oB8BL1VCWbzVkys1yVTu993eUkNHat1J	10336	14576	14576	1618562880000	canonical
20542	3NLxKWGDcPgw5GbpvNsyXgsdWYuiJLnnamULPFqZ8jcuuhGfjrSD	20541	3NLp8udfHusDM3heVYVUDSgqBfqjfVC1LA5asA1kngX6UfndSWdY	1577	1081	371	12463	12854	jxVnPzaTgmuEExx4dqWErz7kveiY6YjqMZgnxoFN2MzEnb6tinh	10341	14582	14582	1618563960000	canonical
20543	3NLMfAn95Kiq3avd7gHUxk7wWzXff5HMzPoaiwX2ZCVZMZBK1GYF	20542	3NLxKWGDcPgw5GbpvNsyXgsdWYuiJLnnamULPFqZ8jcuuhGfjrSD	1503	911	371	12463	12855	jxXTNzoNUzBqxbuTwVefDhHCoKqKuJHpb2UdWhbZP3AFBDzqPRL	10342	14584	14584	1618564320000	canonical
20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	20543	3NLMfAn95Kiq3avd7gHUxk7wWzXff5HMzPoaiwX2ZCVZMZBK1GYF	1507	1280	371	12463	12856	jxU9L7ScgDvtZG6LTgB6rQjNBUXq6xRkeAhSfLdNZdE9K5uqrru	10343	14585	14585	1618564500000	canonical
20549	3NKKugy8E4yeQuAgCKcqf8jL7zGJ7Figb2u1T7VARB7LNDAvLc9Z	20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	1476	1371	371	12463	12860	jwzjnVjw4iBrt2XpBrj6rRXaRhNrnVP4JVfF3H2t5E9Ew3KmPbD	10345	14587	14587	1618564860000	orphaned
20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	1546	973	372	12463	12865	jx9FK21K141P55DaYGsS2uhkEhXXKFeJpDTKX5ZVReL68ho8FGz	10347	14589	14589	1618565220000	canonical
20565	3NLd1JqacV1hWaxxKD5JUS3PJG2UXH5BVPRZVFYNqbF8nWTV3QUb	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1407	1395	372	12463	12874	jy25s2VvaHFyNs3uM3mUoPqGkEHoCVPgx1fFVLjN8KdMkPMZaYa	10351	14595	14595	1618566300000	canonical
20569	3NLMcQsUt3xTyKGUXnq2QL4qA1t4koQEwiKjFSXT9WjbbwbCke4b	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1451	1292	372	12463	12878	jwZjJjZmoaQxYQZm3TqA7UHCNTG3izLhuW4M4Cc1cjngvYLELyU	10351	14595	14595	1618566300000	orphaned
20581	3NKfhaT8gH2Zwbx2xXtrd1CzJHJ7UumSdoZeBn6WakwB9qDmLTwH	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1419	814	372	12463	12889	jwN4ExPU1cn91ks554cqTbQJQxoqHJAKk6E9M979d81DPDfZr6h	10354	14598	14598	1618566840000	canonical
20577	3NLY6a3Cnv2LfaTh14HcenvJkbP8hDiTaTTP7thTPr4Q1KmsU8QA	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1672	1039	372	12463	12885	jwrhrWbQZzs5zat2cjo6mnS1TnTESDNzPnQ5aWcKKxuF8Ti4Zaz	10354	14598	14598	1618566840000	orphaned
26999	3NKsJbPzZfQ4MRsxG2uuLcQZauHEFotAQbu8JrtabtQZpaXkQFj6	26996	3NKYDpZeceWjkrUZdoufoMrtFHyrTYx3hDCXSiU1xn8qZoAC81Sa	1650	1249	522	12463	18642	jxcnnu1dPHA2yrhHyPGZ5FtAwQ6Ekh2BQ3LXrwD1X982Z4SWSx9	13354	18799	18799	1619323020000	canonical
20608	3NKH4xeatHH4vTcE3wDdwi48eAbujbakFrkthHTSBSMt9Msuy5nZ	20429	3NLJT9mure82tJryRoMc9k4hn7fHScErDcZZhViWs7stwF4pdkGW	532	1177	368	12463	12911	jwMyQh8QnDmrgUL2CTpRpy6CBJqTTU5zis4As4WPBZq5s3teu1C	10287	14611	14611	1618569180000	orphaned
20650	3NK8UqcGo8CX2dGAVhUdbV7PDDFHozDbCUAaDY46z6ZAJ1rxydZ7	20507	3NLae1rW5HCXmUH5E73LB4MwCPkZ1WnaNxLLpsT5aKv3tF5GTQXh	1477	1350	370	12463	12953	jwmDqC91W6YP6nWc5HLEUhTwacyksVDgz4a5UAZwPTjXNzj8ddS	10326	14647	14647	1618575704672	orphaned
20532	3NLKzDUJ2hvUAHDB7moYGp7LsJnh1ehaJ9mbe5Xdf9oxS89TH95k	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	1516	1168	371	12463	12844	jwDhtyaSV4HrgRMeRWv2w7fZ9Wx2JSN4RSgzrnvyKd5ZNCmf81X	10336	14576	14576	1618562880000	orphaned
20537	3NL3FDwUruPLs2ARLNznLKmFabjmY2gYmULvC3kwKQMMof1Q8mZF	20535	3NLJe936LLgMtsZPnpq33VFBXmvB1QKLZfNwypJBBbg8PZR6yG14	1483	361	371	12463	12849	jx8dRLi94E77TfeFMPxh8MaPvQqkRR6zr9h6hq5No7EzUVJpfEx	10337	14578	14578	1618563240000	orphaned
20545	3NLVBLFtR3ZW2rEtj8JVL8Ay6CZtTsL1LMH1kJHmVfkFCKuLbdfZ	20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	1407	1395	371	12463	12857	jwmwAGN61y5npRAKYe1uCqamnqVg6iFzoAEmJ416AoZEuoCECBB	10344	14586	14586	1618564680000	orphaned
20550	3NLQscYt3Enrr18mRBKNEsFLPGxeq8YsRaTjAozVtjQMT2mdTT4Z	20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	1508	1387	371	12463	12861	jwkAy3CXRgEKGm9gKRXqytrisg3P3tTUbmEZ9Vq7QquE5R4rdaU	10345	14587	14587	1618564860000	canonical
20555	3NKzgdcNQzRr7x9Cx4N6nWiEnCBfcqw4VwuopBH829GNufNPiihG	20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	1407	1395	372	12463	12866	jwQ5yoQcVUXte5oXPTqf89wH9uftox3rLwtB2RzmkbHTPJYdspz	10348	14590	14590	1618565400000	canonical
20560	3NK5uaFHDrT9SivUxT6mXGfUGpx4GSju6MuH5KWBXoPzdrMJb6gm	20555	3NKzgdcNQzRr7x9Cx4N6nWiEnCBfcqw4VwuopBH829GNufNPiihG	1406	1393	372	12463	12870	jxarXp1q12t9tgQ7XPryJrn2eTUxygZFgF5N9VfCxRdubtj2RQ8	10349	14592	14592	1618565760000	orphaned
20566	3NLE7uk5YpjmqMands42teWGkX6vQutHT75XBVVsxPuWes3Hy1qh	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1422	1337	372	12463	12875	jwuQwwzHbsjyCJ1wnd17DMUHEyfSbDUDesNv9efV7gbawzghbYV	10351	14595	14595	1618566300000	orphaned
20574	3NLDDqCoR1Zxz4R8ujHQVv6d2HAwskPXZB6tmDGYHchUimwYrPZi	20565	3NLd1JqacV1hWaxxKD5JUS3PJG2UXH5BVPRZVFYNqbF8nWTV3QUb	1553	776	372	12463	12882	jwkDhEymhf2tCxKD7nCekfd1HEXDFCPMpcJUdqVqD6D7K3bKqsv	10352	14596	14596	1618566480000	canonical
20575	3NLwwShaUgfxWfZHp7kcxFerPrQJjrA3xBPoqLjPsEVe4Pbsb3D9	20574	3NLDDqCoR1Zxz4R8ujHQVv6d2HAwskPXZB6tmDGYHchUimwYrPZi	1455	1206	372	12463	12883	jwJ69sbW7Y25kRZRJsNcVuUnhLWNr2CtQxNyC2Rz7vrCtquo2uV	10353	14597	14597	1618566660000	orphaned
20582	3NL3jABJoA98yJiy76Qrdhzm8WnCVPnJg2PFAHtBHct9XcHh7ZCD	20581	3NKfhaT8gH2Zwbx2xXtrd1CzJHJ7UumSdoZeBn6WakwB9qDmLTwH	470	943	372	12463	12890	jwrdxuy16bg4wpBq3XJsZU9cBRy6GjzJpSvw3XsvgwQFo8ANxXA	10355	14600	14600	1618567200000	orphaned
20585	3NK5w2gFpv9Az45awetAw3hxNZCfQhvZGXdoSE7zi4VWSUQ5AWhZ	20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	606	1049	372	12463	12892	jx4NWKn17AzrtwsK8fDcM2xyBjvr9pu8tDauxjE6YHCg15RiYe7	10356	14601	14601	1618567380000	orphaned
20587	3NLCY3qZqdTtgzEYkaG9c9FqdiKJ1h57eTFtkc8U5shyjn1zSod2	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1610	1068	372	12463	12894	jwhPQvrCE1v9qTpiUAWqdsMwTqLb9e2QRVM3iYA8sUFwFCGCQfg	10357	14602	14602	1618567560000	orphaned
20589	3NKie4NcBf1Xh6TfnevJmVo8vgcXVPfbqxDJyZav3A3QBTPwCxMf	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	369	1312	372	12463	12896	jwax1Pn8Mm8pruqNVPT9wq3CbLVAgUGfUioscDUqP5i7espVsSC	10357	14602	14602	1618567560000	orphaned
20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	20588	3NLPM5v17UkenNZCQY9TazjsASuFMBJUvShT2QcAYnh2TeB4YnaA	1647	1302	372	12463	12898	jwC2AdVJk36DRjDyL6zf14yx64mTrNewtLKZBPLKvD5uuAQpqGV	10358	14603	14603	1618567740000	canonical
20597	3NK6GX2zGvjiQRVwtVK5V7HzW8nP72hHYq1gWJWnpvHgM5a1bd6X	20593	3NKftttyQK53HpV4ghS9eTY4QoMtfdXb7JgaPisUgAzSJyNYFASF	1593	1346	372	12463	12902	jwzc3nvp9yiFzmjK2MpdA1BB1jeKU3PbGhskEhcF3gQd8pHznBR	10360	14605	14605	1618568100000	canonical
20603	3NKXVeUwFy4QTrDHXUdx3oYpnpwPRGNpizxv7qgDEofsi4SS6LUY	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1571	1089	373	12463	12908	jxzEHvdEAgab1VH3k93PSDUmPC4AJjuFzpR4nU1RsfHBKjq3d7W	10364	14609	14609	1618568820000	orphaned
20607	3NKz54H88M8nFBYHc6XqWaK1mMLixaxBEd3W8vZ5qUTr2VBbCaiD	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1613	1103	373	12463	12910	jwvHTX7Xyjh3h7t7VpsEn3ADCL8wTm5fNpCHpn8anXzqSWQ2PWW	10364	14609	14609	1618568820000	orphaned
20614	3NLZ2mg2Wt856A1N6JW8dkygaUaF3FJUR2acPjNH6vcZinV3uddL	20612	3NKe3MrJ2XYhDUmCYgXZBbPwKoTvkD6udr8i5KFhU1naVz9DvJc3	1407	1395	373	12463	12917	jwnXXS49qpyzMeZk2gabFoiFHh6cxvxpxNEqBovb59wM76Xrpa1	10368	14616	14616	1618570080000	canonical
20621	3NLXMsNv3xDd9vWCz3eCGYqarHSpr2Dfoy4nzJFewkosVmGeGFrH	20619	3NLi2M3Cd3aUmz7sW7exZ75syptmL6nwqZVMvm3s28CytvrJsd8F	1657	978	373	12463	12924	jxwTm9SUSdwH9HUap99jmBUiy5qBNdjgZNuD9gpXrAvjb2ZyKqY	10373	14622	14622	1618571160000	canonical
20622	3NKFazbru4heqGSPVJyh9dQDJmY6i2DNRHhBh8p8Tb3RcQGXVwoc	20621	3NLXMsNv3xDd9vWCz3eCGYqarHSpr2Dfoy4nzJFewkosVmGeGFrH	1627	1139	373	12463	12925	jwekHpRF17v8foFJRmuXCrkJvRrdyiYdAPZZxENvttNTear6sqZ	10374	14624	14624	1618571520000	orphaned
20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	20631	3NK37DBxrLjkj2fKgeHMBgL8YiqEPoMWQ9UtWhSiurdXt7R1xTEY	1642	1121	374	12463	12936	jxnobhzSBhcpSQecRaAVcysSpvVjn5weesz1z4D5Mxnnkia8Jvq	10381	14637	14637	1618573860000	canonical
20638	3NL7to3g2N8iL8xZFt5gDTsyqa9d1azWmpjCawQwNmqsS4UUrdsA	20636	3NKrQSxKuPs7CYD6aH1KeR9M4cWNMMHy7ngEu6b2raEoMfkRLU4c	1555	981	374	12463	12941	jxkDxNK1RGCTAGH1ZBHx8P4LZAe16Ybh8BDUEF2961qbFjhd1GX	10384	14640	14640	1618574400000	orphaned
20639	3NLXJV7gRCFAAS7wTRwiwLXcnwiRAJTpbcduhkv17gWaoT28XFaG	20637	3NKoDNWnHjMnYDnYmCaE8ng2MdYZDoC1ccd9CKgwtokQ2RY77xVM	1407	1395	374	12463	12942	jxd4uCSkZ1fx394VkGtyNbQbFML93p7dDTHTLBwxbNv5oZ4aD63	10385	14641	14641	1618574580000	canonical
20645	3NKWRyydSLvwKapNv1DaUyum5X8RG6TrN91eXdNLwgwEDoVnNpSW	20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	1577	1327	374	12463	12948	jx3KgfNRHPu9E8D5FwbRoMZmrCBVvjiJrCcoUJ8XmFXhMbmvgDp	10389	14646	14646	1618575480000	canonical
20655	3NLjfBBvgahVfdAxewR1kSemX9qJV7WjEq1xNwBHNuoq5V3uvm7b	20653	3NK5hV2Gfz7LNzRTFNdK4freUwE25ounAguUoydKTY3Cw1xirgjo	1529	1316	374	12463	12958	jwHRJBAMDrQVANs7dHFqAtquh3PXU4eVeVx3YyCabxCvQvHpLqV	10392	14649	14649	1618576020000	orphaned
20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	1673	1368	374	12463	12962	jwLa4GNUJnQhEBtj9x4bPoL44bgn5wBJYSkAyipyaQErotqK3y4	10393	14650	14650	1618576200000	canonical
20660	3NLvCoVw96zdTx3eayuyyrJuWcZVbHqhqN89aXra4quDwS4WRJuK	20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	1448	1311	374	12463	12963	jw7sTr1rnbpTWpKeRLWfhukGCi62H3TUVUWwXN5C9ExRjjwZQmU	10394	14651	14651	1618576380000	orphaned
27013	3NKnXcKFgLq32uFByq2Yoy6L2jcY7nHa6Ci5P5Zbe6te2MxVfHVw	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1542	1304	522	12463	18654	jxgbdJZcUVktQ82U44E7m2b2EaFMZxaMsbDxBV13MXwezPeeisD	13361	18808	18808	1619324640000	orphaned
20533	3NLbKNww5SP33PzfL3fD1KtqiuFKn5N7a4H4rDYp9Nom8F4Y8Tqm	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	1657	1344	371	12463	12845	jwS9sUT1cqg45KVBBPW1uwtJTKRhmq4fM6rM3TMMsBfJNHX1yw4	10336	14576	14576	1618562880000	orphaned
20538	3NKysgMHogBRsM2v4HXmwLpvfjNaoWkW1hDVG3mDExhff47ispap	20535	3NLJe936LLgMtsZPnpq33VFBXmvB1QKLZfNwypJBBbg8PZR6yG14	684	1352	371	12463	12850	jwieAFoLbRkHwz6XQEnHKufMjWrWZx8u46oGRk9T8NrVW9o7xm4	10337	14578	14578	1618563240000	canonical
20539	3NLQW81TmEhBhrqjs2UCbtFBzdwxMiEFSTqf6rvCgbWkku4YVLV2	20538	3NKysgMHogBRsM2v4HXmwLpvfjNaoWkW1hDVG3mDExhff47ispap	1407	1395	371	12463	12851	jw7fL2vuaoz4YyAgRWit6Da13ttnLpYVesdhJNmEh2mDZvn9SDq	10338	14579	14579	1618563420000	canonical
20652	3NLQdk7puDwoBqAbuLyivEXuGZKR1UGx1p4bJ5JqGKxASkSH2pNz	20539	3NLQW81TmEhBhrqjs2UCbtFBzdwxMiEFSTqf6rvCgbWkku4YVLV2	1477	1350	371	12463	12955	jwua6BFhYt3r7VopHZpjATuQVkcYAYEpaW9muekaiKcRyoGXtHE	10339	14647	14647	1618575751523	orphaned
20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	1651	1175	371	12463	12858	jwHqWwYSLCJDVJCWTpE72q7RkayKrtqRGSGue1QdCdWDW4yF8V7	10344	14586	14586	1618564680000	canonical
20547	3NKDwmwRGAtQ1obJwjP7DuD4KB9mhBXKULNVUu4UwmCsssAh4JFs	20544	3NLTkhAsBtkTyrRVL4rpW3U1LXJeU848bVekK2idfuVJwuNMWSJT	1651	1175	371	12463	12858	jxsfYyVyBWhQZSerVRKXUjh2rsY2y193w9EbbSsTfpo61hyML53	10344	14586	14586	1618564680000	orphaned
20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	20550	3NLQscYt3Enrr18mRBKNEsFLPGxeq8YsRaTjAozVtjQMT2mdTT4Z	1444	1255	372	12463	12862	jwRyZA2Yqk9pTRHXBBd2bXfj83SjiVXJVadPST36THU96AM1T1C	10346	14588	14588	1618565040000	canonical
20552	3NKk7igYEhmVUowgFsyqef2HAcRG58wEacLz4z4AESKgbon2hc9Y	20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	1503	1277	372	12463	12863	jx5MzUZKpucdiLGxcTLH5PLcLvSGiC9CZZKqLsQG9UsCqvWLi4Z	10347	14589	14589	1618565220000	orphaned
20562	3NLqqPSsevMNYS2vZxRJU1E7SeXPsEA7tNo6WwYboY3Zz2Jta3s4	20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	1474	1083	372	12463	12872	jwhVy5PKFjj7JPnbfF5m5zZRmvT6PK7xQZ7uqnGPq8A5ViSh4tb	10350	14593	14593	1618565940000	orphaned
20567	3NLtrfLmNXVnNwsuFqwf9GxhPy4QZ6SfPsiffLEL5S71EFAs3mLk	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	606	1169	372	12463	12876	jxRwUCArMRWYK5nqVxKwwGuRJwqpCP6cfQdaFKHeXmogyQpN2S7	10351	14595	14595	1618566300000	orphaned
20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	20574	3NLDDqCoR1Zxz4R8ujHQVv6d2HAwskPXZB6tmDGYHchUimwYrPZi	369	1066	372	12463	12884	jwu1NXYRpybxHRfxqFwHW3QofH8RVnLNobrsANDdgQ56qD1sbBP	10353	14597	14597	1618566660000	canonical
20580	3NKeJC8Pxhvd7g4pwVe4RiYZWu4rN8GKutz4yWJXwY1VrvRXigf6	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1542	938	372	12463	12888	jwmKZNLksRP9UFYPontvgMSqN9QjQ5iAEGBQqh86euw5NWUquDP	10354	14598	14598	1618566840000	orphaned
20586	3NKKXFucznqpi4Mtp89etrmCDYyUVLxDmM8zp17ZWum5oX3V9W1G	20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	1445	1044	372	12463	12893	jxPpXhpJBYyBQug3hEzAcMCPsuQk6FsNK7fCULhBN584NTj2AbA	10356	14601	14601	1618567380000	orphaned
20594	3NLS3kRVGokRjXMt924FMSgX23xiP2Yp9rXDEPVUY93qvVgRv8A9	20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	1458	1077	372	12463	12899	jxG4G6MrDpUi72MxJBUxE2tiUGKwKGKKshSHM2dy5xQK3zUoaTt	10359	14604	14604	1618567920000	orphaned
20600	3NKnEjYvV8QBqqk2LQaRmjQoL2WvGunToUynTN1Z4FdwA46mv1RP	20599	3NLetNCfGKNAN8ke28qT6REGNnc7naqSFCFf7DjXRVZQEWQ8XDwU	1553	776	372	12463	12905	jxA8RoKhELRfG9h3k3NFRm4cbUMjhc6uET1v8qJ6YxAmP8BaxQJ	10363	14608	14608	1618568640000	orphaned
20605	3NKzxuqXfBtBAZBu1UUVuNRkCHUzhM2PNnuHY5E6tcCQnCuYNhV4	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1613	1103	373	12463	12910	jy1AfdN5D73N1cLfVxnN536DpiD9CDw6AKnC639amfRyD1ZLnre	10364	14609	14609	1618568820000	orphaned
20611	3NLdKGc1eebgr4cLY9trVNqN1UrMp2z8sbvSYnF2DXNSXW885Xpd	20609	3NKPaVvTdPE2vg1sD6JBPMCvY4TSUzdZA9MpkdKLvpWpmD7uJH2g	1673	1242	373	12463	12914	jwwWbwPzS5MwGoqruHDGyBSy1ZXKbWccVwTMAZYksENvgW8rJgV	10366	14614	14614	1618569720000	orphaned
20612	3NKe3MrJ2XYhDUmCYgXZBbPwKoTvkD6udr8i5KFhU1naVz9DvJc3	20610	3NKbZumihZRr9zGCw1Fwsr4TxAfuftxRGu17f7PkkhrxLEGuZJTX	1656	1097	373	12463	12915	jx12zPzJZMmef5rWqtkw7QWLaCCSyL9xKtbDWvWjQWgnyHUt6Ue	10367	14615	14615	1618569900000	canonical
20618	3NKQk3NmYQraL89V1o9SNEh3BHV2FcFyCveZURPduh55o63KMbnE	20617	3NKvczktHkBriGxPtA5Dp8oAmAH8zuPYgDmKTmvnZotMetjVuWdW	1555	1221	373	12463	12921	jwV5KgMGWj2HhejEGuL5TusnjiLChsQKhmHFEpsNRDQbkZGm2Pt	10371	14620	14620	1618570800000	canonical
20619	3NLi2M3Cd3aUmz7sW7exZ75syptmL6nwqZVMvm3s28CytvrJsd8F	20618	3NKQk3NmYQraL89V1o9SNEh3BHV2FcFyCveZURPduh55o63KMbnE	1578	1170	373	12463	12922	jxqp4Xn4M3PMr3qeNL5LqC6DZhz3xNy2XfoyWXmBTd4F2KgHcER	10372	14621	14621	1618570980000	canonical
20635	3NKEEL1B4ahymQzw8iyV5g7BE9qnF1Umw3o3hi1UxJcu4JjDypwA	20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	1599	1041	374	12463	12938	jwMqo356tWVm8fNCswVqUDYc52PJr7L4hzaQPHZMpQvPR1t6Yqw	10382	14638	14638	1618574040000	orphaned
20636	3NKrQSxKuPs7CYD6aH1KeR9M4cWNMMHy7ngEu6b2raEoMfkRLU4c	20634	3NLxTGgNHbXB8E3x1zKoZ3fmVVP2e2gu1PwbygtLDbQoyHhFJwdC	1406	1393	374	12463	12939	jx3hEkkXXACD4tsa5EX3CR4HoD8TAYcqXBQCfEzwD7QNGkV8sr4	10383	14639	14639	1618574220000	canonical
20643	3NLcBXoGi7zWDY8MGc744Pjjk9n3bkigkkKGxryRQ1DaBDjpUnaD	20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	1407	1395	374	12463	12946	jwHWN4XWuYFEKBS6FSBD4SokKu6B6WBmH6tz89km9fBzq2TcaxG	10389	14646	14646	1618575480000	orphaned
20648	3NKQCCBbp6WTzuHnRZYwEeqTrQjujvQZwuxUAU9j94B6Cp6zJLkn	20645	3NKWRyydSLvwKapNv1DaUyum5X8RG6TrN91eXdNLwgwEDoVnNpSW	1477	1350	374	12463	12951	jxU2SwbcczgKtBr6MfQmZRpP2FbsjzFHPpJ7Yo8EwKFKdZMTtXX	10390	14647	14647	1618575660000	canonical
20657	3NKKscphC6xx6hbRUrQevhRPZuiB4HnvcrVCHshwnBLc4x7258ss	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	43	1310	374	12463	12960	jxHCgPzxmAFKEAy5pkvRehsU9J9d27SFmC1yHa3tJ6q1uvzze4G	10393	14650	14650	1618576200000	orphaned
20662	3NKfRB5KRkvubYmw1Y7LUEj778vSJFKDvy2HMoxrxKZ4HQ5LGo2d	20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	1403	782	374	12463	12964	jxbTQkG2PiQNoURCFa1137oFiNvYPdf5hcPcUiPcPBJYmRMWhf1	10394	14651	14651	1618576380000	orphaned
20680	3NKrZGbbc9GLcvfQPXXQett6bn8X2jR4MNVaH1HeR3Q1iTrDQ3PU	20663	3NKQE8ofq65soCPo6RXqjMCyQhgndoe9VyecgNu3zLz7KK8rJP4c	1456	244	374	12463	12981	jwoUNzCLBjvwYtd1w8qFAsMbbmycq4w7XigdYWw4DG7wQ275n9S	10396	14663	14663	1618578540000	orphaned
20669	3NLdH4R6wiqKRaXzie6MMvALXfnSH7gD1RV66Zxgcw4Vq5sAPdTj	20666	3NKXw6oDAAW6CFvXCZd5aMh9M3QBZBUVvXUEqmjNcdVtbZEmMwcY	1637	816	374	12463	12970	jx3XztGmj9zipygNpUKy5dffgV6xfW18VVc7jpgTofxeEKfRWDw	10397	14657	14657	1618577460000	orphaned
20675	3NK6foP9YW1x4WDHLcrvWQcCZzH3gRCJ7zPRgDQuu8YoKDCQ4mcu	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	1447	1345	375	12463	12976	jwLn9XvPtKPgHmtGMBX9DPmaTwzqyqP2gipd7dyTZP9SJwJgX2H	10400	14662	14662	1618578360000	canonical
27014	3NK5eQ8QVRtYxeUpC7sm2ZrM9iQ2ujTh84zayVyVRiL1GN3x7xoa	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1467	1010	522	12463	18655	jxGiZkTfyScpdVC1csAahMTpRXQgxZd34NGUv9rk4KzjmKfQWJg	13361	18808	18808	1619324640000	orphaned
20596	3NKXE6MebLtXF7jKy8rfP22GSHcU1B7WyuhTbCkyBiu5ioDS1jWu	20525	3NKk57aLXdM34nhNc28UjgzXGhgjL4YfN8Xm8Td3oMEPCQNqkoPR	1593	1346	371	12463	12901	jwo9SEJv6vqYh9h6GQ2zpkd4nJq3xj1WXK6vUf44f5ws8rDy5zV	10332	14605	14605	1618568100000	orphaned
20534	3NKn9XvMhH6e14m4YU1H47EPmbKmcCMMQvDpqfpT2uKY7CBnRmGC	20530	3NLNaq8wLUAeBqA7c6Y5gUfPUhC2HuZq7S3teJdTDqBkAqUzitTR	369	1186	371	12463	12846	jwcmEy9axpRYBxNSSMXFbHEnjr8WRBK8oCtCq11a59xAJWmbd7h	10336	14576	14576	1618562880000	orphaned
20540	3NLnQkgpZ2hZAH7jA5Fvi2o1vJwqjkU1wRgqAnfmZQCfa2NaCejN	20539	3NLQW81TmEhBhrqjs2UCbtFBzdwxMiEFSTqf6rvCgbWkku4YVLV2	1642	1367	371	12463	12852	jx7EPZd21Y86662AX1YETZihNr479wqoiJ9umSv21Vp6N4wqZjD	10339	14580	14580	1618563600000	canonical
20541	3NLp8udfHusDM3heVYVUDSgqBfqjfVC1LA5asA1kngX6UfndSWdY	20540	3NLnQkgpZ2hZAH7jA5Fvi2o1vJwqjkU1wRgqAnfmZQCfa2NaCejN	1607	1102	371	12463	12853	jxzMXCB3ZL5SoXmGHS3bG2t2DFYaaHokAYzML9KkV4b3XoKGBeQ	10340	14581	14581	1618563780000	canonical
20620	3NLsnVp424D2K6iZbmTypJzN3K7SCf8kDCGLGaLMyU7ctqvJbywo	20541	3NLp8udfHusDM3heVYVUDSgqBfqjfVC1LA5asA1kngX6UfndSWdY	1578	1170	371	12463	12923	jwo2T2V938tWWr9LtWwyVXsezy4iintm4KgXyRFSkyizZGvqCGR	10341	14621	14621	1618570980000	orphaned
20548	3NLeJgntgx9i6HKmnMTfk3DpN29tBTBGu31jkUDoChfwrhzJTuXU	20546	3NKtezPFB7HYPkpNJ7D6CuGgVotU6X4nAGGiX2pYz1MzPwHJc9c2	1460	1198	371	12463	12859	jxfoQT76RvM1bQAYrK8JZ6eczGKfQSfFgaJo4DibNVGe3nej1UY	10345	14587	14587	1618564860000	orphaned
20553	3NKFjvSwveV7UDGpX6Au4boGnzrwh2NaenWtkxhmcgCpoD3XexiX	20551	3NKN4WcbZ2rHu1H1C49H5MbpWK5mg8x4QKaoe8D1jNAReGAK7YZ2	1627	1385	372	12463	12864	jwso3AxqBgbVuPMFs1y3VQzSzJgcME1vEuTer3VsZbeHBPWGjMp	10347	14589	14589	1618565220000	orphaned
20557	3NKDgH6rEkJrPykUDpqfCwatxhjmem9HBezNf4LqsxyJPwDxhUug	20554	3NKFhGuxcNeLxpY3Vt2XQTY9nrLjMuionjTNdk9ZPTDf1PFsYpMs	684	1106	372	12463	12867	jxHay38gin6r6b9nbqnkcoiqcJvdpyUNPq7UkT3oZHxtzANghEo	10348	14590	14590	1618565400000	orphaned
20563	3NKQtR9RUa8SC7gXLhERuGEL7uGZaSLz8c5Biz9bhWh27NL8bVqh	20558	3NKYwKBw122sMRJm7g7XqqcZuyyU22LKvxPhg1pdyK7W9ugjVgxP	1474	1083	372	12463	12872	jx6x52QqeSxLRZ39a4o8ZhofzBimtSAKXmGaRGW1NW4VVVZmoz5	10350	14593	14593	1618565940000	orphaned
20568	3NLbUvdrB33dRg64hVqqcfRBh9uf4RgRcdsMTPnuRtB35JDEWpFw	20561	3NLJWBfsEfnTXnpQJPHhgMFAd17BE3YXXx78oHENWTvsP7HGgg5R	1571	969	372	12463	12877	jxhKuqKN7YYSQrvcqbvaqvvKnpVkWp59ZtR26zhA4W9QvGWJeTH	10351	14595	14595	1618566300000	orphaned
20578	3NKU2Aj98fYDK41jVSPT91hNtT7YBoyFPodSRXZXc2x4vdrzER9W	20576	3NKTjGWt6S7pDNfEMunDgNBFb8TzA5cbQENtMoqU9BtUdGtgWDW1	1490	1148	372	12463	12886	jwUyfKVdQQs88HfFKuCM7YT8CyYLLht4ik4bS7yronYi3jr4QHn	10354	14598	14598	1618566840000	orphaned
20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	20581	3NKfhaT8gH2Zwbx2xXtrd1CzJHJ7UumSdoZeBn6WakwB9qDmLTwH	470	943	372	12463	12890	jx9MyphtzhFnWgK7HJSGfS7krQLkGC5ssYRaA1d5fMS8u1Aoxz1	10355	14600	14600	1618567200000	canonical
20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	20583	3NL6Hsa8vUhwn35P8chzYoJgfFdwkuTMTvQxU66kckor74ReKfh7	1405	869	372	12463	12891	jwV4eEVXyrbd6gY145AHzMgeKadRr7VopKEkoqxyMnts2YMbtaA	10356	14601	14601	1618567380000	canonical
20590	3NLrLPZwPbtk6m4fbNHVrQ8omXAHo92SP8XiCKqA4pUsQCvgUjKS	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1610	1068	372	12463	12894	jwTnACNRdFfgwgsJM1RfymKgE3vr4ZwMCevevnq6bVvB9yQ8Jdx	10357	14602	14602	1618567560000	orphaned
20591	3NLoVkEqsSYMCR3asM9KYVqpp2V53WXmVw5ejS9UdPPjXXtMCVgP	20588	3NLPM5v17UkenNZCQY9TazjsASuFMBJUvShT2QcAYnh2TeB4YnaA	1407	1395	372	12463	12897	jxshTRUZkG8bCWxgLQcW7YN6JcWmhSryAvm3ftnBXtUwHwgsWVV	10358	14603	14603	1618567740000	orphaned
20595	3NKt2eb6XLzkEKPskCqZRFP93Q3F5xM18VeM4Ma3qfpNk3MV95Yi	20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	389	389	372	12463	12900	jx5FY8WUweXFMv7caUPhTw1eTZsYNafRGCLhThNMmFFvpmXZkix	10359	14604	14604	1618567920000	orphaned
20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	20599	3NLetNCfGKNAN8ke28qT6REGNnc7naqSFCFf7DjXRVZQEWQ8XDwU	1458	1323	372	12463	12906	jwKjec1PmwQYygoq4yB8gpSGbUUJMRHZn6DVULdLzNHMStMbxSv	10363	14608	14608	1618568640000	canonical
20602	3NKSEgwATNwCMmuH1BskNtztiRkQtZSFhu7Sf8NHeKbTicfjV8Zd	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1610	1068	373	12463	12907	jwzQ8HGJApbLgcgCH48Z95MEhrhEMvzw8bE5b9xWsxN7GFr61a7	10364	14609	14609	1618568820000	orphaned
20606	3NLxRKxZg2DyK1sp89H7pnGyyvqM6ydhxZ7vVNrZuEyRFfh1WNx6	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1610	1068	373	12463	12907	jwzQ8HGJApbLgcgCH48Z95MEhrhEMvzw8bE5b9xWsxN7GFr61a7	10364	14609	14609	1618568820000	orphaned
20613	3NL8oGJcfV6VTgk28Bd6b5QT5xS2t2Vi99YFGrcJrupYs7i8ecsq	20610	3NKbZumihZRr9zGCw1Fwsr4TxAfuftxRGu17f7PkkhrxLEGuZJTX	1403	824	373	12463	12916	jwEmKFU1xpGghxyJi4En9Qifc2kLvrGrYSprfVpK3RNkXYLkPw1	10367	14615	14615	1618569900000	orphaned
20625	3NKKDpfext8kZBxdneD5K5BkquNRUyz6Xrp8buDxsQwHYKKtveCh	20621	3NLXMsNv3xDd9vWCz3eCGYqarHSpr2Dfoy4nzJFewkosVmGeGFrH	1419	814	373	12463	12928	jxsfAhNoP7CX8UvCUiitc3U71jT8N8mJ4JoJ1zgtV2Azza2pbGW	10374	14624	14624	1618571520000	canonical
20626	3NKZN5hmo8eHGXwvzF3j7SoG7dvy695Xmx8GnDAUkrDbhjEWqdDF	20625	3NKKDpfext8kZBxdneD5K5BkquNRUyz6Xrp8buDxsQwHYKKtveCh	470	1063	373	12463	12929	jwXC3diDkagQ38UwiDyHKEw4CiJkNvJkP7UsDNN1jmLeKKFBJoU	10375	14626	14626	1618571880000	canonical
20627	3NKHNmxvpnxptDsfgsdrEjci8H2TFsCcLP7vhoLHWwCbmDnEuyCe	20626	3NKZN5hmo8eHGXwvzF3j7SoG7dvy695Xmx8GnDAUkrDbhjEWqdDF	1529	1316	373	12463	12930	jx2kqyQjEL82zyNdec566KaXynYC9z6STLaNp3ZY88hnftkHYca	10376	14627	14627	1618572060000	canonical
20628	3NLPZy7iqnzym7jjB65KaMckZUd3M8ephfbSo8B4EUJb5jVfKm2W	20627	3NKHNmxvpnxptDsfgsdrEjci8H2TFsCcLP7vhoLHWwCbmDnEuyCe	1647	1302	373	12463	12931	jwHw2BcUZ6X1sF2pXBPc22AZJv9Z9TD4cAqLRTVrSkf8TqxZusi	10377	14630	14630	1618572600000	canonical
20629	3NKAb5Jdc8Jjf2MfPK5qtkq3USARTsk7skHCZTzi6KDKuGnVhRcS	20628	3NLPZy7iqnzym7jjB65KaMckZUd3M8ephfbSo8B4EUJb5jVfKm2W	210	210	373	12463	12932	jxFgrQywvDvnY7ipkQnvtAqeELAEChbFAnU62ifWwB9b2FTG6t6	10378	14632	14632	1618572960000	canonical
20630	3NKWh74tvwifThd5tpL88BEtqur9eUz7QzMWgbWLUUfQcn6F9qDQ	20629	3NKAb5Jdc8Jjf2MfPK5qtkq3USARTsk7skHCZTzi6KDKuGnVhRcS	1407	1395	373	12463	12933	jw88sYN7UttWYwT7HqHnEJSzAGPMCLrvYHfothhsfSTeLJbgqcH	10379	14634	14634	1618573320000	canonical
20631	3NK37DBxrLjkj2fKgeHMBgL8YiqEPoMWQ9UtWhSiurdXt7R1xTEY	20630	3NKWh74tvwifThd5tpL88BEtqur9eUz7QzMWgbWLUUfQcn6F9qDQ	1581	778	374	12463	12934	jxmyiNuDusTabLxu1BkrUHsU2pcfxsHgFkYVQNCXgpY62zSfKPq	10380	14636	14636	1618573680000	canonical
20632	3NKxAxoetchsLgQvB8YGjBhYcjmGyi2twSAPy93w4qNEuvYKZUTC	20631	3NK37DBxrLjkj2fKgeHMBgL8YiqEPoMWQ9UtWhSiurdXt7R1xTEY	1671	1365	374	12463	12935	jwgEBGPaSWwxaXdTaRvv52iHuoq3Y9UfoJnQzeg46J9EhSWhuLV	10381	14637	14637	1618573860000	orphaned
20637	3NKoDNWnHjMnYDnYmCaE8ng2MdYZDoC1ccd9CKgwtokQ2RY77xVM	20636	3NKrQSxKuPs7CYD6aH1KeR9M4cWNMMHy7ngEu6b2raEoMfkRLU4c	1406	1393	374	12463	12940	jwbZxBrDh2sC8jELvtGx1H7Vp12wgyipHcKNZDBQfH1sXeuK7eb	10384	14640	14640	1618574400000	canonical
27034	3NLHB7vDFMQpC7pKMvXea7HRjeqJWSESN6TjGd6powFwXJsmbcik	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	606	929	523	12463	18668	jx243Qe3CR9ppRnMA3WeqmwfrfbGXjbE6H5nPRtFJNwnCSXZDJJ	13368	18815	18815	1619325900000	orphaned
20651	3NKBZBc6cx92qY8ndVWGJgRGPq2XEQn6ynCRM6TvpmMUTcesYhBR	20487	3NLRS4StprFvd1dfC2Qj6kWjtvJaiubKuWLcHSnqgapPKBpZkxMY	1624	1088	370	12463	12954	jwzRC8NMi12S1DDSTHCDgXcXa8c19tpUJ1wj7byyUaaEJeHtmu7	10317	14647	14647	1618575660000	orphaned
20588	3NLPM5v17UkenNZCQY9TazjsASuFMBJUvShT2QcAYnh2TeB4YnaA	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1406	1393	372	12463	12895	jx2msaxfCo2F74dGtJzFZz39W6F96narG2RGGRJ3vGzCWmAFGPx	10357	14602	14602	1618567560000	canonical
20646	3NKNZ4GpwsWfiDDzhra21DiyuWh7pmNitKej2Wbpd6a4Uu2UBy84	20584	3NKfR68Y3ABZdv69UAf6cJBrVHnBUBwiqVxRiGihoLfAmFUNntME	1508	1387	372	12463	12949	jwvbbnxnjUvh5kmMLmWmntVvLjNSyyGmR8eodokPKpHrBBN1e4c	10357	14646	14646	1618575480000	orphaned
20593	3NKftttyQK53HpV4ghS9eTY4QoMtfdXb7JgaPisUgAzSJyNYFASF	20592	3NK3oEruH9rT54g2YwYfSpowKnVwEUoWGrKzYunRjNs9eGh5fsp8	1458	1077	372	12463	12899	jwz8Qvd39R4MDozSDjSvV4ozHj2MfC2BnsyzvV16sV5qvjDY9FW	10359	14604	14604	1618567920000	canonical
20623	3NLuTUZhAJBGkDu2UVWGB9PdzzwwFSrtmgAJnvydGaJVnveBfjtL	20591	3NLoVkEqsSYMCR3asM9KYVqpp2V53WXmVw5ejS9UdPPjXXtMCVgP	1627	1139	372	12463	12926	jxZXJFMYPxcPEpJi4ibjrHemmWzqNe2F7j1ArbhSDk6t83zo1nB	10359	14624	14624	1618571520000	orphaned
20598	3NLrEmHNZnLVANNK4iF1CkNDNqNEyFhYxy5AMDCeqViZDDwuUoAu	20597	3NK6GX2zGvjiQRVwtVK5V7HzW8nP72hHYq1gWJWnpvHgM5a1bd6X	152	1330	372	12463	12903	jwHRNnXAnM6bhThavS5MYb8RHrbLzop2GMWAMZEU1pcwaDXgk3A	10361	14606	14606	1618568280000	canonical
20599	3NLetNCfGKNAN8ke28qT6REGNnc7naqSFCFf7DjXRVZQEWQ8XDwU	20598	3NLrEmHNZnLVANNK4iF1CkNDNqNEyFhYxy5AMDCeqViZDDwuUoAu	1407	1395	372	12463	12904	jwjqtKPyn5eb9T7WeBumbXiERcozSQjGnbs7hJ7TGCpsZXP84CP	10362	14607	14607	1618568460000	canonical
20604	3NL7GYCk8tZMEb23DYr97S3zG1GnvDXHuh8B2BhiT2mgtWFRLkuW	20601	3NLXcEmMqK3Kb9oXWUvU22VX2f8XZCgCWJSEyFUzCDdADuV8SAuP	1637	816	373	12463	12909	jxzEWsjcYR2gXndaXGUw2vp8DxmHhk8DkCho6AJrbiWvA6acmwQ	10364	14609	14609	1618568820000	canonical
20610	3NKbZumihZRr9zGCw1Fwsr4TxAfuftxRGu17f7PkkhrxLEGuZJTX	20609	3NKPaVvTdPE2vg1sD6JBPMCvY4TSUzdZA9MpkdKLvpWpmD7uJH2g	1406	1393	373	12463	12913	jxmxmUeebkAdnwhR5xr6tb3VoYPVNycp1KLXdosavrZJfnJxod4	10366	14614	14614	1618569720000	canonical
20615	3NKk7JQZ5vBnqxKzJPmobKNUBdXdPNDdEfvpTzr2WRbHgs5wHCGb	20612	3NKe3MrJ2XYhDUmCYgXZBbPwKoTvkD6udr8i5KFhU1naVz9DvJc3	1403	824	373	12463	12918	jwwWUiUExT1CS9zzanLGPkzZTZfxZfNcY4N2PfX492wwRYtcExC	10368	14616	14616	1618570080000	orphaned
20616	3NKctH9HkuiKWybe69bHtHm5w25SFUDERQn1X83j4UP9UVRftcHo	20614	3NLZ2mg2Wt856A1N6JW8dkygaUaF3FJUR2acPjNH6vcZinV3uddL	1426	1118	373	12463	12919	jwiAzvwWMUxUpUkGR9SJaYzfifisMBfEvTBPdz6ZVzRPPf55rcZ	10369	14617	14617	1618570260000	canonical
20617	3NKvczktHkBriGxPtA5Dp8oAmAH8zuPYgDmKTmvnZotMetjVuWdW	20616	3NKctH9HkuiKWybe69bHtHm5w25SFUDERQn1X83j4UP9UVRftcHo	1648	1284	373	12463	12920	jxY721wGmEtJEfQaMYcFCYyQNUBWVe964m5uny683ZB1z8aPdUA	10370	14619	14619	1618570620000	canonical
20634	3NLxTGgNHbXB8E3x1zKoZ3fmVVP2e2gu1PwbygtLDbQoyHhFJwdC	20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	1407	1395	374	12463	12937	jxCq1bCGQ4i9UHehCf45rvdSEQD9Xuozs4PuR2v6NmsbxPAqREA	10382	14638	14638	1618574040000	canonical
20640	3NK9BDxrhfBJgHBAuoCGxq41Zvp2d5incqUnj6RBHM3cPffGYVp8	20639	3NLXJV7gRCFAAS7wTRwiwLXcnwiRAJTpbcduhkv17gWaoT28XFaG	1516	928	374	12463	12943	jxowLB3NF3T8SbbuCersY8RujxNPRcqQNKkaDgRXq88CyRPhtNJ	10386	14642	14642	1618574760000	canonical
20641	3NLRHvSL28d433xygwDFPNf4rpP2FL5TcypBXhf8HbG418hwzoiZ	20640	3NK9BDxrhfBJgHBAuoCGxq41Zvp2d5incqUnj6RBHM3cPffGYVp8	1637	816	374	12463	12944	jwuQy9hZ2KzYTo3V95q1rMQCErMHEPBMV3bfPivhjy2mF84gzAS	10387	14644	14644	1618575120000	canonical
20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	20641	3NLRHvSL28d433xygwDFPNf4rpP2FL5TcypBXhf8HbG418hwzoiZ	80	1273	374	12463	12945	jx7PqcRX5qGn7pESxaKFhJseydH8GtV3J3EJ7P3LywgRdrZW3Mj	10388	14645	14645	1618575300000	canonical
20644	3NLdCZXeEkUnajB81vBoJW1P5KmgQxNCxnCLBov68kuHoe6otsjn	20642	3NKyASXHxMqcNUutEH2vExyCB2uoPNzkn7EtDGQDP7ziFzadx5Zw	1508	1387	374	12463	12947	jxV5sEWb2hk7hAVEgTUZgW2rW8YiuTxUsnShpoyBJ3tA8EGZAF8	10389	14646	14646	1618575480000	orphaned
20649	3NKTDfAeStGHpe4wf7GEeSGvJNnj4uUcaUUP1YxdboSsNvqquuBJ	20645	3NKWRyydSLvwKapNv1DaUyum5X8RG6TrN91eXdNLwgwEDoVnNpSW	1624	1088	374	12463	12952	jxXwLCkxPmn74NVB19FnNWiWD8TtTw2H3BgLAme1WpVaiGEEe1u	10390	14647	14647	1618575660000	orphaned
20653	3NK5hV2Gfz7LNzRTFNdK4freUwE25ounAguUoydKTY3Cw1xirgjo	20648	3NKQCCBbp6WTzuHnRZYwEeqTrQjujvQZwuxUAU9j94B6Cp6zJLkn	1601	1388	374	12463	12956	jxJ4K7ETV6mjgcxot6JGPzQi5FxWuHvPCCKcA8iCUC2Q6PdGbon	10391	14648	14648	1618575840000	canonical
20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	20653	3NK5hV2Gfz7LNzRTFNdK4freUwE25ounAguUoydKTY3Cw1xirgjo	1406	1393	374	12463	12957	jxpDLpU8egtFViyV6SNzHBjPVVrKsPJsPtZEkWeYGTR2FJnw18G	10392	14649	14649	1618576020000	canonical
20658	3NKu5WYiHxBKCwgi9d3EspWh5LAiigajZojrUzQrKLpnoCMwWPRh	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	1406	1393	374	12463	12961	jwCoCzr3vSW7spc51HLMg65rXXPyWDyfXUL2iPwobYQee7iCHUs	10393	14650	14650	1618576200000	orphaned
20663	3NKQE8ofq65soCPo6RXqjMCyQhgndoe9VyecgNu3zLz7KK8rJP4c	20661	3NKiuiWE5qofQUBnHdsE6UHCsZHuhSWi3ezBeYHJiK8paxEFPaon	1571	1335	374	12463	12965	jwdghnX3mZALsr9WS8NK2bXNTmcom52NCwVcZzQ7hjVMZs112bz	10395	14652	14652	1618576560000	orphaned
20665	3NLTkfBA1RQbH3VxdntvnhrBDkFM3hBPEwr8WKhgJfjsd3dxSYdC	20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	1527	927	374	12463	12967	jx4DurVVQW75YDaAFFkwbFNWd7wBFgymZKX5Mrjhyio13KBdaFu	10396	14656	14656	1618577280000	orphaned
20670	3NKoyEc6jTRWZ6dMqLnyjLyKLAkpxuiy8QyiGykJLLz5wMLbyEuA	20668	3NKt9WXngkgEJcwQQNvM1d3LTPcrEU7KtD9To4jiw7zVn7UPQKhe	1547	1252	374	12463	12971	jwym7a5EgFFZgRHyiGPsWTxuKpJK8cFvHz7a6DoTRHdvJ81bXAN	10398	14658	14658	1618577640000	canonical
20676	3NLWzuVfbmsV8PwAkuKTqFgXNcKnxJqJukUSYsDFg1mhJjVXoCDe	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	1406	1393	375	12463	12977	jxKXsnvYPkMJAfnuq9F3fD4AvDBuEKNBrAjKp46qX3Sops2K8vB	10400	14662	14662	1618578360000	orphaned
20681	3NLd1ni4NZDWSEjamY76BbVq3359273SGEUXroSNYovJ3bAPdZyz	20679	3NLDpGV3Vmqi85zSCAAzm1cwR6Todjqthbsg3UdktkpLSyCtRFiB	1627	1385	375	12463	12982	jwsoDNT67kNDAx1uLnjhfouTZyeTT2FvtMZuGsPfs5YTbJpLk72	10402	14664	14664	1618578720000	canonical
20686	3NKCZZ8DHKaeM6uZnMjxxyZL75uiLVqiCh6HtsxbNkFXMnei2axz	20685	3NKpot9tztVAPA93ri3WxmRDT7AKknABUDxuCFCMNAoDzsyDumZL	1673	1122	375	12463	12987	jxga8MbMy4hSFgELjmPwwcvKv1u37XxE17QWPmtvvP5EroRW3tF	10404	14666	14666	1618579080000	canonical
20692	3NLofKkZszdfAKRf9vzuu6xtVouDqDSbfsEN7bfX4YLVJ4QijfBA	20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	596	1060	375	12463	12992	jxfnVDGtiFSgDkgoWMbpEj2HvFbU4enGr9nN85xayRkoswMvpHH	10407	14669	14669	1618579620000	canonical
20693	3NKa8BkFgpGXi1q7pE6VA3XtxwY1oenGzmgMZSpAepJwpQWC45xq	20692	3NLofKkZszdfAKRf9vzuu6xtVouDqDSbfsEN7bfX4YLVJ4QijfBA	1407	1395	375	12463	12993	jxHztxj83Xq9avh2Y5X8C9GPqJEN73G7yTtbChJBvU5nvCPmNGE	10408	14671	14671	1618579980000	canonical
27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	27046	3NKQ6wviU8e1ms4vk2vHfx5zMYmgXAeVWdkjR4bmTCgef9xJudsi	44	1325	523	12463	18682	jwtinrFeCFLnDbf1FhQSrCuKvGKtfYknUuQwx5XMTTt4KxLaZvF	13373	18822	18822	1619327160000	canonical
20695	3NLpwDXu4BZBFh7CZ2EuZVcvbNAmpynn9xfpSvYcv3Fn7JMwjwqv	20505	3NKtxz5M3G8oEF5cBPnaU7m8ZwMNXd7ESs8A6EmJMbehQM8KKsVu	1654	1214	370	12463	12995	jxtSqsVc8WcCgMbKm85VSuGvbF68R2MAXpLJkpKkzJvGTbKztwy	10325	14672	14672	1618580160000	orphaned
20683	3NL18LeQsjNM9yh7PpZUZsv8gVrfH7FLnMr1SP4NWiffVUgDyW7x	20623	3NLuTUZhAJBGkDu2UVWGB9PdzzwwFSrtmgAJnvydGaJVnveBfjtL	1627	1385	373	12463	12984	jw8BJPmqyKqBJnLModEyQEYyyAz8EY9TnHd5LeRdSJtifnQZBVw	10360	14664	14664	1618578720000	orphaned
20656	3NLJRkAGRBE3UudXLPniG5f6dN8nytif288w5WcB66sZHrkR8fRg	20654	3NLMPGL6YPQRQAF74xvV785UzxPCDE3pLcJYYemxuE87boHGQXNH	1407	1395	374	12463	12959	jwcoyLom6E1krBMew89WqesnRkCo7A2vPogjzocxDgXu3oHMxTw	10393	14650	14650	1618576200000	orphaned
20661	3NKiuiWE5qofQUBnHdsE6UHCsZHuhSWi3ezBeYHJiK8paxEFPaon	20659	3NKjCPorCBKt8Tvqh2uy5Z79HxebQQ7FgMZ2ooB2QsYiTQS3Lo9B	1448	1311	374	12463	12963	jwKa8HuqKJAS9nP4P8kp2GhQnddGzxxN3DibWNGNsvXK7azuWXr	10394	14651	14651	1618576380000	canonical
20667	3NLttpZxxTv9spjeFUbyLnZ43sUbHbvX9w7RdC4X6L2zKPoQj9uW	20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	1527	927	374	12463	12967	jw8qMryhJ2kbZGMpWDoSFXSGLBb6PVYq98jCefiLpoi4KVfPi6J	10396	14656	14656	1618577280000	orphaned
20668	3NKt9WXngkgEJcwQQNvM1d3LTPcrEU7KtD9To4jiw7zVn7UPQKhe	20666	3NKXw6oDAAW6CFvXCZd5aMh9M3QBZBUVvXUEqmjNcdVtbZEmMwcY	1506	1007	374	12463	12969	jy29gGYBy6AKnKNwF1W8ZyyHvpcSh8XzdoeQgvQVHRSz3RHoDVw	10397	14657	14657	1618577460000	canonical
20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	20670	3NKoyEc6jTRWZ6dMqLnyjLyKLAkpxuiy8QyiGykJLLz5wMLbyEuA	1406	1393	375	12463	12974	jwZUDAG5we4zJ4BaFWcRcDMkPxdKtkndyKGbZ2pFfRk5C4dK5TK	10399	14659	14659	1618577820000	canonical
20674	3NLY6Qy3CMXAvZvnhZGDEAFd6vYMznwn7yroQDgW9mz28jmer4jW	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	1670	916	375	12463	12975	jxfzpRgHjSW7AdKdZr6u45S8f1KtAuXCRG2DfqxUe5gkGypFK2Q	10400	14662	14662	1618578360000	orphaned
20684	3NKJKYgifJLK9Esapz7d6GLdnpcvpxnoAVUcsy21eGyTVeNkvpMu	20681	3NLd1ni4NZDWSEjamY76BbVq3359273SGEUXroSNYovJ3bAPdZyz	1460	626	375	12463	12985	jwUpchzMpXBZL7qZ1NjyzCrspCB9TBaNCu6jrA7fzcjoqRxeJW1	10403	14665	14665	1618578900000	orphaned
20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	20688	3NL7QaF1hBbHirgWapj9XPNRcHreRyJ3kG72P8PMaRohyKHgkoQh	1407	1395	375	12463	12990	jwnoJP27KWWiVkVw5CZCKGxsmBx5rsUCaejfWh2sUAromToZWsP	10406	14668	14668	1618579440000	canonical
20690	3NLs1ZFvgQ6AFErZNza18yvvZi44M4y7pZ9cyVNWiSNpAUmbP5sE	20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	1594	1326	375	12463	12991	jxK4iCJKsiintU39wGnFEYQpLUHCyjtaSNdwdwSVxmnEzZhu3iK	10407	14669	14669	1618579620000	orphaned
20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	20696	3NLLtQyqELA5KLwFLprF72caJ5kJGmd6X19LSkUFtqSvij8Jw8fN	686	686	375	12463	12998	jx347yGRg6xkBaiPnsdgC9e78ARiNAYt551CADR5eZAL4d4aGTu	10410	14673	14673	1618580340000	canonical
20699	3NKYt4upL1Pdp94MaBuzAStd6fNHuWzrHMfdnavzeSRTYrmxTr9x	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	1648	1284	375	12463	12999	jxTrvM7d4ESPe3op3JF85zDkvoqdaN3h7NiuHfqGQgMG26uBvKL	10411	14675	14675	1618580700000	orphaned
20703	3NK7Jisw7BG6hqvKJtgZ8HSEAQ5FadWFmmgahooctcpM5F3dHXih	20701	3NKa1EjM68eZepjShwA5889SraCKpWtFYNUaQcfN3YDoo5NN4rB4	1529	1070	375	12463	13002	jxNfucYCw2EwP3ynbP1DvxnYpUUQ7Qmi3Ra3w6iG9dS3QrJWAtj	10412	14676	14676	1618580880000	orphaned
20707	3NKHhXKQLNuBUWFHXMf7dRnMWhvNMRmJMMXTXhAnazbs23EiNHVi	20705	3NKTM3xeRTUhhVNE3ikVSubYuNi7TmaoTvPjvwj9fajd9yq13wre	1407	1395	375	12463	13006	jxUhF3qXjHbF9pEvCQc3AjbKAPC22sF9xYw9ryMhNvJVyArX7BG	10414	14679	14679	1618581420000	orphaned
20714	3NKgpq1UDA4ACVH8fC5jrnuC8SvUL8y6xuQYyXyKrEbVmod7DYvn	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1585	1120	375	12463	13013	jwQ9vzGrnGsV6TbNXj47hJKaJghSEmA1RD6SZuGKNwnDN493WoX	10416	14681	14681	1618581780000	orphaned
20763	3NKaBQrPvNGEcdyyL9si6tLxw5FVqJhqjYiZy8aveqKYdUfVtDi7	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1633	1144	375	12463	13059	jxSBUoCtecQanVfd5FrxQdRca1WRLvjWAZ5sbhdLSrhsujt752k	10416	14707	14707	1618586460000	orphaned
20718	3NKtYc5LBJm74A15DEFANSoZ2XDnL5a5KRNoPHmDzeQvdWQRXXjy	20715	3NKLUPpsukJ1GtpEzkqQ35qYVvSGjMLgpdzHHRtgBSaQXczMQsbE	1542	1058	375	12463	13017	jwMr2rAsL26DyqaLiDeMCePnZpxWujTqcpqoZz8byjXxuQCGKEt	10417	14682	14682	1618581960000	canonical
20723	3NLrDDDwovKKyKq3cwViRk2F6UZTvkfmdYr6ERUhnzP2EyREwn1v	20720	3NKcp6gLyTKeQeS3gRQx98upj5x1iPmvHQsdMGQ8WKx8N5eAWkZF	1631	794	375	12463	13022	jxZoQaNLVqhtn5e8FoMGbFgHtRFSMKDdUopyoAyYg7jzDrWbKCF	10419	14684	14684	1618582320000	orphaned
20729	3NKCfiSAwiYEUAEXZjya5otve6VPrg9B6FEQFKPtsMWBdJ2ounKE	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1631	794	376	12463	13026	jxS13XmHWdpKtQVrBhmjZpviXNGUGQncD2pVxgdbkwNSLBrddE1	10420	14686	14686	1618582680000	canonical
20724	3NKRbbZDhoVb32csCpUsQiAqpZ8pwC1G2XgZeDxN9g1HpWCe4pUY	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1407	1395	376	12463	13023	jxWSdjgUccFhynzrowdKmP25UbnoHtM2riZ4okKt8FqsoBQKXdU	10420	14686	14686	1618582680000	orphaned
20730	3NKPd4V6PTBTqiY2xsmEHtJ1jViRxcNyghc1m9TXoXFUa1L7Z24t	20729	3NKCfiSAwiYEUAEXZjya5otve6VPrg9B6FEQFKPtsMWBdJ2ounKE	1406	1393	376	12463	13027	jxg4HKMDUvCpX84u1gHwwQeM8oAn7tYaxfTH3Km3EAvUtnKZh1f	10421	14689	14689	1618583220000	canonical
20735	3NL2jbFYwCrnBL5pL4p6NVJJCg8S5zq1mai8GpWRpXnFNnyDXGFY	20730	3NKPd4V6PTBTqiY2xsmEHtJ1jViRxcNyghc1m9TXoXFUa1L7Z24t	1542	1058	376	12463	13032	jwgrWn2fFuSeASJppdmf8Kn4MAWsNnaynPU3HotFz6zbaEvzZFn	10422	14692	14692	1618583760000	orphaned
20736	3NLU4Unybb3gXnUn8LpAZWM2CnHApHcZZGh99m4GAeQyvnTCnLKV	20733	3NLqtUZNsMcSZpFpmtMQVLGUoHZ5yL9rbikY2ZJmhqrhr6PhrdPM	1602	1369	376	12463	13033	jwkmyQWU4iHmFnQhzFgJzBoDNhybDYLPcz9uTWDD1s14GU6KYoX	10424	14693	14693	1618583940000	canonical
20742	3NKgMwwLhUdnymiP4yUJHRkrwmRWkersWyczoXZHzGmxGo7Kg7Rs	20740	3NKwz3Qb4cXTddAcRGYt2U8BbHY3TxZv4jHi33qUTCDn53zkbuyc	1564	972	376	12463	13039	jwXFdyE7TsXqusVwsUKarQAinMM39Gw5H9qVCoQEDuMpHB2t1aM	10427	14697	14697	1618584660000	orphaned
20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	20745	3NLuJUwzQnZtHTtKEWHzCwMfnE13pPyTLXKwevJU5d8QBpW1BanE	563	1359	376	12463	13044	jxHcKLZ54iEpVW2knnypouHRea8SFE3bqP2BE9L1PhcbiZ1pdA5	10430	14700	14700	1618585200000	canonical
20748	3NLTr2pBgLeoU5QoqAsB44e7VfSgYP3UTHqAcsYN2mxdXnAPVnDd	20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	1406	1393	376	12463	13045	jwQnzmGc8mFs3u4Xg9K6TcZ5FW1PNLjyM3uuyqyfMw9NFdHhvjr	10431	14701	14701	1618585380000	orphaned
20753	3NLw7g6e8pGzUSFgvQ9JQay8d1Hx6Rjdb9j2pi49e3etXvEeGzqT	20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	1527	1293	376	12463	13049	jw7tm41odSwB1u3fhBrzxNFZwsnM9YfTJdLiZGGoo3ezxBap86R	10433	14704	14704	1618585920000	orphaned
20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	470	1309	376	12463	13054	jxTcGmRTSq43YCpJjL4JQ5tu91E8VpgV6d9DUZuF3TUsNZW2T6P	10435	14706	14706	1618586280000	canonical
27246	3NLc8jkbxTJ4Kv8gmp2FACj8d8xH6h4BtL33AaF8e17QksoCcn7d	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1490	908	523	12463	18864	jx8rG1GL4SzFyWmCuC4czpmGUSRUmWv43pD3F8LAyA5VNHmQDGD	13382	18964	18964	1619352720000	orphaned
20721	3NLxtdH3j71TYwYMkGjpewS8jfQVgFg5dCkZ4Qk9dspkVSidMUtR	20633	3NKU95d45GyoUqYXh3VKJAmtTihM7rYwsWosv2NhrTKoyXHVywiz	1458	1458	374	12463	13020	jwwHLH4PkZfJMKj2gAT3Cw2n1jXgxoYQrrDii9oB9fwuS3AqNUB	10382	14683	14683	1618582140000	orphaned
20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	20661	3NKiuiWE5qofQUBnHdsE6UHCsZHuhSWi3ezBeYHJiK8paxEFPaon	1403	824	374	12463	12966	jxXAXvJyMDy3kVb9HWgjoo4J5GZTdr1fZkWDxj1xJRqCJ8Ftw5M	10395	14652	14652	1618576560000	canonical
20666	3NKXw6oDAAW6CFvXCZd5aMh9M3QBZBUVvXUEqmjNcdVtbZEmMwcY	20664	3NL71hndKgAAaiWG8hXeK3uUFFrURDiKrC7vM9V62f5eunzqEqUw	1426	1364	374	12463	12968	jxQmSezZSi49QWeAyx4dcDyRsbzM75bX7TLSpaVx72E5FTed47W	10396	14656	14656	1618577280000	canonical
20671	3NKrGjLKtqTjuQvoEGadoKShuk5S8Yjb2GQP8zviZu4CtYJfqyRH	20668	3NKt9WXngkgEJcwQQNvM1d3LTPcrEU7KtD9To4jiw7zVn7UPQKhe	1623	830	374	12463	12972	jxHKMDaVGsuCqxQ6M5MheRJ65c6rnSebwBj3LybkdhT8jRLu1uw	10398	14658	14658	1618577640000	orphaned
20672	3NKjYw26DueE4UYFvrDc2jdMQqvpNj5wZgJBmhUFEjig1xG5MQ89	20670	3NKoyEc6jTRWZ6dMqLnyjLyKLAkpxuiy8QyiGykJLLz5wMLbyEuA	1423	343	375	12463	12973	jxupNE3fMrfWtB5cBeon7tESh5nodutpmbMCGjXfZvXJuB6hTtF	10399	14659	14659	1618577820000	orphaned
20677	3NKKHopwcVxeNJBmX5hdKqg55B3UWxKqWUw5EuLSiaK2JkaaRZrn	20673	3NKCDtbmsySe9D6gGRqvjW17JvrvfB1H5w9ScvJQyCtui3LvsRy9	80	1273	375	12463	12978	jxmbkSUUAifqkWqroQrTpR5r7AL6fUWYM3KoBn51fFuHk9jRbiG	10400	14662	14662	1618578360000	orphaned
20678	3NKsQXDzM3PwCpxCTWArgvTkg7kubftZ5i4RY3L6cXbQrjtnt9GQ	20675	3NK6foP9YW1x4WDHLcrvWQcCZzH3gRCJ7zPRgDQuu8YoKDCQ4mcu	298	1308	375	12463	12979	jwRn2tKo4T1GdEJQF24KLru1qvi223t7hcwvbmqraKB4eHqznpE	10401	14663	14663	1618578540000	orphaned
20682	3NL7jmT1u6fHMgrYNPofCk6q7z27QRX9ytfUKx9E8gAr1tz8BFuk	20679	3NLDpGV3Vmqi85zSCAAzm1cwR6Todjqthbsg3UdktkpLSyCtRFiB	1673	1368	375	12463	12983	jwqe7v6o6XSqEMvRBzZE7oZHT6Rc1QA9e5tz4kNjbivPz9Q9E3w	10402	14664	14664	1618578720000	orphaned
20688	3NL7QaF1hBbHirgWapj9XPNRcHreRyJ3kG72P8PMaRohyKHgkoQh	20686	3NKCZZ8DHKaeM6uZnMjxxyZL75uiLVqiCh6HtsxbNkFXMnei2axz	1637	816	375	12463	12989	jwv7jg9Guh66AY6RfQsJHkmpDqfJawvoe7hWtrhSTqUeao8RuPK	10405	14667	14667	1618579260000	canonical
20694	3NLirdCZndesAkitKKwK4629FYe5HZVJLn7zf4V41Tp8AgGikmyw	20692	3NLofKkZszdfAKRf9vzuu6xtVouDqDSbfsEN7bfX4YLVJ4QijfBA	1553	776	375	12463	12994	jxzz2bA6USMVBfJNUDghukU7DB4U9geF9Uhi1wj1HAD2Pf5jsjG	10408	14671	14671	1618579980000	orphaned
20700	3NKsXw77LfPtr1CxoL8MFiyLyAQbAiNsAbe3nf5jjFEmLZD6zk9N	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	1474	1329	375	12463	13000	jwQCDr98z6rzDTwnvwgEpxiYmpiuc6bPT65N95TTqyZXdDuXU1e	10411	14675	14675	1618580700000	canonical
20704	3NKP1Wgcm7gpcbW9TJ2i2ai9eeMcCByyBN7dFqakUgmJg2GEzzCw	20700	3NKsXw77LfPtr1CxoL8MFiyLyAQbAiNsAbe3nf5jjFEmLZD6zk9N	171	1374	375	12463	13003	jxzLb7igxejgMXGEhsztUst8zVvxNqc6Ajh1yQN2uXjCYiWyZzW	10412	14676	14676	1618580880000	canonical
20705	3NKTM3xeRTUhhVNE3ikVSubYuNi7TmaoTvPjvwj9fajd9yq13wre	20704	3NKP1Wgcm7gpcbW9TJ2i2ai9eeMcCByyBN7dFqakUgmJg2GEzzCw	1501	1234	375	12463	13004	jxxFDKedvPGFSZ1DejqeJDn7wwcLGKVUCErGGMJjoF7N9EZByZK	10413	14678	14678	1618581240000	canonical
20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	20705	3NKTM3xeRTUhhVNE3ikVSubYuNi7TmaoTvPjvwj9fajd9yq13wre	1480	659	375	12463	13005	jxmSakP58DmsCv9CBX823DpyXGqRsnY44aFEftEyiAsfkr4khjE	10414	14679	14679	1618581420000	canonical
20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	1564	1092	375	12463	13010	jxJHmeLc5SLKdGyxcKysGZTUTZxJJ5mKt9nHcm8motwwJMeiwfh	10415	14680	14680	1618581600000	canonical
20726	3NLHhu8UKCYfD2mBAasKadG5k5qx1kjDRDXZcRD1ppH19xDBa27G	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1448	945	376	12463	13024	jwSRRJt9XpS1ggiPTrDWVQhAFCBuu8kzvJkiqdkVMcRtpD7FN3o	10420	14686	14686	1618582680000	orphaned
20733	3NLqtUZNsMcSZpFpmtMQVLGUoHZ5yL9rbikY2ZJmhqrhr6PhrdPM	20732	3NLYmwMaNnQFoLVvkgQ2jRwrfV5YQF8L7m3jeLA9jmUvXgjogGLe	1542	1058	376	12463	13030	jwox1BuivomALcHK88McRRu9XrAPKDLvHXUrSL3pymGeTJQPApt	10423	14692	14692	1618583760000	canonical
20738	3NKfbCLKRctAozRMj5cN13JTxiuCr2G7UEzNCR6QMWi4kXRWrb8c	20736	3NLU4Unybb3gXnUn8LpAZWM2CnHApHcZZGh99m4GAeQyvnTCnLKV	1534	1317	376	12463	13035	jy2GqcePFd8SeDf2fAEY7LKiNWBXhJjrdBhBYeH3SMVWQUYUqWF	10425	14694	14694	1618584120000	canonical
20739	3NKxTgfh2sMwS1pF2rh2MGdJobJ7w2EY9GdcHT89NxMEYueNZkit	20738	3NKfbCLKRctAozRMj5cN13JTxiuCr2G7UEzNCR6QMWi4kXRWrb8c	1407	1395	376	12463	13036	jxe49CxeUWCbGiSkEBL2qidLtzZjV3Pa9termnsuK1qYFZqBHx5	10426	14696	14696	1618584480000	orphaned
20744	3NK4w2k5q8rVeHAe59NUNJr4kmUBEq6e1zJRQSn7yGNkJvPS4AWt	20741	3NKU5VEwmhXc1FQdE2xCEs38nsAwN9sSAZ2JGZ7aYkvT6cMygJD6	1581	778	376	12463	13041	jwBPnoXZzk1Ep1JVLWPrsD89E3HFNNKDLYqnRaQys843cVEw6w7	10428	14698	14698	1618584840000	canonical
20745	3NLuJUwzQnZtHTtKEWHzCwMfnE13pPyTLXKwevJU5d8QBpW1BanE	20744	3NK4w2k5q8rVeHAe59NUNJr4kmUBEq6e1zJRQSn7yGNkJvPS4AWt	298	942	376	12463	13042	jxyovL67rprTEcSgWY9epXS9mHDh3zbMpAYASZhja1RsNYYdqnc	10429	14699	14699	1618585020000	canonical
20750	3NLNKh7yQdY3R4mA6CVCMKbCgjPzAq1GNV6T9fLWvoPuF9D4w6c5	20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	1637	816	376	12463	13047	jwua3PP7V6mN4SkBb3Y8muxj86zCBkw7LzrfznZh4MnecAz6LDM	10431	14701	14701	1618585380000	canonical
20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	20750	3NLNKh7yQdY3R4mA6CVCMKbCgjPzAq1GNV6T9fLWvoPuF9D4w6c5	1503	1277	376	12463	13048	jwuxRHVsqUv17Qo9rSM8PTt3rF93PLrL4dRbCCCTCG6L1qbhhfD	10432	14703	14703	1618585740000	canonical
20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	20752	3NK7XUZQcfXMCGxBL47FefcQ7D5UKGvVqfZfh5qZ5YyNNTjPQtTu	1650	1375	376	12463	13052	jwSFruo2ddzqVDWJbFTWboHze9JzsHGmdG53sfYXvoqkv6Lv43r	10434	14705	14705	1618586100000	canonical
20761	3NLZ23cMyYpEs9236mxhnyQj3dxsr9k8677W8UQrbxjNVDWuzmmP	20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	1627	1139	377	12463	13057	jwVft2gGXhcwdMBqzaGi3rBXdfK7b3ku6v9DeSuUgVhEiwptqu1	10436	14707	14707	1618586460000	canonical
20765	3NLwYY6sz5J7HT2uSdLvCXZoNoKrtqggZ1FhTxJtd76yfiisoqKd	20764	3NKktJQzk8VwEX2L4xPPaP3vPCt5HApjtdiseYcJRWQaeshezWdA	1407	1395	377	12463	13061	jwEbJ3L9pDxDW5E7RngGNE7CquUkZdzct3r1h1LLWK5rq4RYuY4	10437	14708	14708	1618586640000	orphaned
20770	3NLTRbhuSrwCjtWeMy4Ha5rubkjNtCNejzJApPqevZNbisn8AoKw	20766	3NKhzuR12V8ddf1m8UhBc4jSJ9yzarFPzVKyyutFKhHy5ToyhV48	1439	913	377	12463	13065	jxMc9pFJyYtceUbsMJk1NQsNb5hkhp4sMcvB6gH6qimiLq3SEAY	10438	14709	14709	1618586820000	orphaned
20771	3NLbZTKEx3y5kuHLLzxCwNhpJnG3XuVdmrEKk5qbPhktCTx1zFaA	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	1406	1393	377	12463	13066	jxRdCxZDrb1zg7cw5A6khrshKWwYAbxKzYnC7Mm78SsmhJpFhNP	10439	14711	14711	1618587180000	orphaned
20783	3NKNmibTrjWzSTAp8i1x8TgJJdCUCifu7Su68BAP718S3sD85CK8	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	311	1181	377	12463	13075	jxkGkWYNpEs32JK4CX6cdfwHBEp7mHnuhGyVsv5mToQTMpRdbHS	10445	14720	14720	1618588800000	orphaned
27087	3NK3eVNvaptbE8gQ54dF6FwdE9AR2rTHQdCpwCZYzJdSRJ9rNCqF	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1541	1298	524	12463	18717	jx6Wmu3ZWXKZpgW5PBQ3yNEGEyagBgwV4mNGnwzuhjKCpHKkFeF	13392	18850	18850	1619332200000	orphaned
29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	29157	3NK452zRMhxNDTV97yjz3v1pFEMFu9B1Qj9TtXpSz7Z2vqrzT9gz	1623	839	572	12463	18974	jwY7pFTcPvFe9vTc9nwaphnu2jetQjhbKLXwJecQVpbh82Bxrov	14379	20251	20251	1619584380000	canonical
20762	3NK52JKPChwWqpGu1ecSL3qJNAETShdJQtTvJdKeXPz48LG3g6iq	20683	3NL18LeQsjNM9yh7PpZUZsv8gVrfH7FLnMr1SP4NWiffVUgDyW7x	1627	1139	374	12463	13058	jwEwgRQoBXefJyUgo34xYDFHMuMb927QKZjYBEPMLV8qfieJSYc	10361	14707	14707	1618586460000	orphaned
20685	3NKpot9tztVAPA93ri3WxmRDT7AKknABUDxuCFCMNAoDzsyDumZL	20681	3NLd1ni4NZDWSEjamY76BbVq3359273SGEUXroSNYovJ3bAPdZyz	80	80	375	12463	12986	jxjcaoG9c7wXtPCBLpBjnQ8ySGRTXeUa1PVcaxGvCCaq9Arhpai	10403	14665	14665	1618578900000	canonical
20691	3NLU7CQbqRr1ydjxgz2gt6aK7ibhPfnrGAYnNcRPpE23eZvyo1Rf	20689	3NKbziYMb6axFJWmjn3kC2jWEYVcqU89b5UXTuhbZRY1LqhZf5rs	1594	1326	375	12463	12991	jxtpQQAAmspr5MczecbvBDxvz6qMZpWbWB4jDFs4n2iKk4BUQMX	10407	14669	14669	1618579620000	orphaned
20696	3NLLtQyqELA5KLwFLprF72caJ5kJGmd6X19LSkUFtqSvij8Jw8fN	20693	3NKa8BkFgpGXi1q7pE6VA3XtxwY1oenGzmgMZSpAepJwpQWC45xq	1483	1276	375	12463	12996	jwbU3rXhQy5VA4MRbGPVYuACmqZP1rjNc6rDoMdFuZw1wGwxEE2	10409	14672	14672	1618580160000	canonical
20702	3NLqZiXqMMJ9PmYYyHqtgUBUZr4yitcokeLrssqjS18Ds3MDxhXY	20698	3NKbBLsckzxDgPnaMguZsJDefzmTNbEzTufLSNASKJzGHZrc6Kxz	1474	1329	375	12463	13000	jxEqZP8kR74r56KUnHFVDVJxkf1amXavwMd7aVvK7dmVa1xec3U	10411	14675	14675	1618580700000	orphaned
20710	3NLoZyk4h6Fj1xi5jiZ5syGaqkJavxZncpNrv3XsF64m9ET7ycxo	20706	3NKAT2Vg8DbSVvrrVH9drvTzSQ79scJMXaiutKcsg7frq4TvFwj4	1406	1393	375	12463	13009	jx8n6cR2hKyQkV92CKxG5dXSxxv4YpqvZZJQZmJso32Atwuas2F	10415	14680	14680	1618581600000	orphaned
20715	3NKLUPpsukJ1GtpEzkqQ35qYVvSGjMLgpdzHHRtgBSaQXczMQsbE	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1476	1005	375	12463	13014	jwSsHBTBo2yagVQwvkDJ5hJYx8Wekh1Qaa8yjsMpY8Qu71xJnCZ	10416	14681	14681	1618581780000	canonical
20713	3NKThhFU35bZcxXQuqpwkBekttkSz9CBHFNdKxoKVpXvJFMNkHA7	20711	3NLpsCixYYeU2jsXenmdaUGgtMd5Mke99oTP2rgq2XRFFJMHv1hD	1527	1167	375	12463	13012	jxTRd1AkKDeQurrzHBcUqoj38FsJW3X1pwR1ei751CDJiF5LPHR	10416	14681	14681	1618581780000	orphaned
20719	3NLWL5R2nHW4YsoPKfvMcinbDjNXcZx4ryrth55xGoVsjwSJ43cG	20713	3NKThhFU35bZcxXQuqpwkBekttkSz9CBHFNdKxoKVpXvJFMNkHA7	1542	1058	375	12463	13018	jwBjec1RYnn21fvAJymh7YnjTAMNKJyHC6pw1SPMcGFVX1CbGcu	10417	14682	14682	1618581960000	orphaned
20720	3NKcp6gLyTKeQeS3gRQx98upj5x1iPmvHQsdMGQ8WKx8N5eAWkZF	20718	3NKtYc5LBJm74A15DEFANSoZ2XDnL5a5KRNoPHmDzeQvdWQRXXjy	1458	1458	375	12463	13019	jxgmNTzMQSP9LxjXtuWFsfhKbQmMXwohWAWQ3otuiTKiY9wjs8S	10418	14683	14683	1618582140000	canonical
20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	20720	3NKcp6gLyTKeQeS3gRQx98upj5x1iPmvHQsdMGQ8WKx8N5eAWkZF	1460	1078	375	12463	13021	jxDBMgFWLQTjroix6tfQkxxUvgbHjjQq5cnb7TmK8w2bgQ3Uaot	10419	14684	14684	1618582320000	canonical
20725	3NKGA8YdgAPUYypphBRUrNcz4G4UrbiK2pYs3x2Sb8He3ZGvtatt	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1448	945	376	12463	13024	jwSRRJt9XpS1ggiPTrDWVQhAFCBuu8kzvJkiqdkVMcRtpD7FN3o	10420	14686	14686	1618582680000	orphaned
20727	3NKev43kop34Qihqpea2f7gV843ShdivsALmYiuHzf4mdD3DUUYY	20722	3NK3wjdSfaiRrH5mmDXEAvU8DJgaZNCkwVT8Ame4sz3dbrkSXoZX	1448	945	376	12463	13024	jwzrC43o12NQogTDLLqWDo8DHYaoTWXjhq1HXBGc1gov17Yyt5P	10420	14686	14686	1618582680000	orphaned
20731	3NKKckZrFD7AnGZbNhpfA8g5jewekDAKFXS7KkrDpV5PZ9qe9Ayc	20725	3NKGA8YdgAPUYypphBRUrNcz4G4UrbiK2pYs3x2Sb8He3ZGvtatt	1647	936	376	12463	13028	jwWKSSJWfuAPtWhrCjckDFQLogBBCY1Cmkk2xMzr7DovJz5mdQK	10421	14689	14689	1618583220000	orphaned
20732	3NLYmwMaNnQFoLVvkgQ2jRwrfV5YQF8L7m3jeLA9jmUvXgjogGLe	20730	3NKPd4V6PTBTqiY2xsmEHtJ1jViRxcNyghc1m9TXoXFUa1L7Z24t	1457	1391	376	12463	13029	jwdTnoiGWJv4fgCqq81t9tBzbNYsZU9A61XohW7zQ7Z44AneAN4	10422	14691	14691	1618583580000	canonical
20734	3NLtv22Td5ZWw4n6yD6XZvupt57ZcdTxMXzvUkXqMdiL6B6qr4is	20732	3NLYmwMaNnQFoLVvkgQ2jRwrfV5YQF8L7m3jeLA9jmUvXgjogGLe	1403	823	376	12463	13031	jwb57Fvg6XQAZV9CPJmhaXbGG3GoLmFsDhhWUCLRXKTDUPJdZxm	10423	14692	14692	1618583760000	orphaned
20737	3NKugbLmn6wafNuQB4bCpbdCsEgNVbTAqCKLXV9uvE6Kb61gK3E9	20733	3NLqtUZNsMcSZpFpmtMQVLGUoHZ5yL9rbikY2ZJmhqrhr6PhrdPM	1646	1108	376	12463	13034	jxc8sshedFxQKVshi39DDBtdYNWqEMriiT7dPoMd2tUq6jvNsmK	10424	14693	14693	1618583940000	orphaned
20740	3NKwz3Qb4cXTddAcRGYt2U8BbHY3TxZv4jHi33qUTCDn53zkbuyc	20738	3NKfbCLKRctAozRMj5cN13JTxiuCr2G7UEzNCR6QMWi4kXRWrb8c	1613	1349	376	12463	13037	jwq78HznSQfqjaP3kU9YTF3EguCcKBdo5KS5phWCFhgTYtNrfWg	10426	14696	14696	1618584480000	canonical
20741	3NKU5VEwmhXc1FQdE2xCEs38nsAwN9sSAZ2JGZ7aYkvT6cMygJD6	20740	3NKwz3Qb4cXTddAcRGYt2U8BbHY3TxZv4jHi33qUTCDn53zkbuyc	1501	1114	376	12463	13038	jxM7vzSxfYAi2TcijxBVLvEDa1mJ3KVJ2Gp24uLHbUifpX3Y2yi	10427	14697	14697	1618584660000	canonical
20743	3NKDjiaZYhd9yWtKJpF3WsZeP5YCfvwCFfoBSGEb8whra4FuDhTd	20741	3NKU5VEwmhXc1FQdE2xCEs38nsAwN9sSAZ2JGZ7aYkvT6cMygJD6	1407	1395	376	12463	13040	jwGJVHyaMMTD9jC3GXCV9r6QTjaD7LTLQyK2SLeizBrWCMNAfFY	10428	14698	14698	1618584840000	orphaned
20746	3NKqsWH3ggyDdfmSVRYvzJgr5N2GMct9u3dmwQ1BfqFnNvGb13it	20745	3NLuJUwzQnZtHTtKEWHzCwMfnE13pPyTLXKwevJU5d8QBpW1BanE	1610	1188	376	12463	13043	jxqHFDESz9WcjuQRBrBy1zmsktwdUWWYgcfDRDMbJKEVbdK2jxd	10430	14700	14700	1618585200000	orphaned
20752	3NK7XUZQcfXMCGxBL47FefcQ7D5UKGvVqfZfh5qZ5YyNNTjPQtTu	20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	1527	1293	376	12463	13049	jxhwauZMHjddQqbSLmoDZ1SKqKyRBvp3J5ELxyvn148vctG6XMC	10433	14704	14704	1618585920000	canonical
20757	3NKSs5csrU7z51wsPYoE1fbjTWm1rTJ5sgwHxc3NqqJDS1v25zcD	20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	1423	334	376	12463	13053	jxghTYqpSk89KnLQMMduHn6wG41o1UZxaLh17UEbmy7KgjbDgtn	10435	14706	14706	1618586280000	orphaned
20766	3NKhzuR12V8ddf1m8UhBc4jSJ9yzarFPzVKyyutFKhHy5ToyhV48	20761	3NLZ23cMyYpEs9236mxhnyQj3dxsr9k8677W8UQrbxjNVDWuzmmP	1587	1231	377	12463	13062	jxYCuHddEqjESiBZTQL3To5gVjkytNNigLWSyBubwNQEvfBL4NP	10437	14708	14708	1618586640000	canonical
20784	3NLYZ1tR1yZzryU42wb5mz8eT4CAG9sbbuL4trWtt5r9rVZzHzcF	20765	3NLwYY6sz5J7HT2uSdLvCXZoNoKrtqggZ1FhTxJtd76yfiisoqKd	1508	1387	377	12463	13076	jxbw4sVYqgJdJnx9XwvZrbTK6tzpTWoRShgVSojVXdzh6jQBj5C	10438	14720	14720	1618588803302	orphaned
20772	3NKwTreLhiswbY3n8diUbThKURC44SFfkPY4thH38txaS2zcN5ia	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	1474	1329	377	12463	13067	jxi6YXFsVbKEKSNoaErDnBEeYuBFATnpqN4W8fSxphu5sr3fpRM	10439	14711	14711	1618587180000	orphaned
20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	20773	3NLbMNvSfJEtNSLsi2M9tSnoM84eSmZcztVQKrC3eQW4FGhqwY8w	1402	874	377	12463	13069	jxGXghE3oKz38cRjMr9K6s1bbw8TokHE88uZsrXspTzHmcaEMKV	10440	14712	14712	1618587360000	canonical
20777	3NKyhCsxZF8b767Ay4A8x1HYV1t37ESbUryZ3H1QtkxB6AsgcLHw	20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	210	210	377	12463	13070	jxoQ5FBP8a5LuR3bMqPkmQmzS6wAiWv3Bk3SpSMrtGxXhxRahwd	10441	14714	14714	1618587720000	canonical
27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	27119	3NLSiDvc11H32dDM95UCGcKzVh4214zUEosJTgSurAuvNnCdbjwm	1489	1014	525	12463	18748	jwxH2Swc1bxZq3hECzG7kJetVEbUG1BKcDiCdi7DTidVH5CVERG	13410	18873	18873	1619336340000	canonical
20786	3NKSUcXVhp4ozNEycE9zZJSxptyPysefZTWGSgRxvmzoKonkVYai	20646	3NKNZ4GpwsWfiDDzhra21DiyuWh7pmNitKej2Wbpd6a4Uu2UBy84	1508	1387	373	12463	13078	jwDyCsXkDT1aBnCMyNT5YetXDKSnyRdA26kRdCBNoiXBso5JSQq	10358	14720	14720	1618588800000	orphaned
20760	3NKCrhNv7D1HpbfT6FQYboXWCgDKba16ERNiTb562MwMW74VVS9j	20731	3NKKckZrFD7AnGZbNhpfA8g5jewekDAKFXS7KkrDpV5PZ9qe9Ayc	1638	630	376	12463	13056	jwQpUUhXtLLGLnRcdzSrn3tyfq2HTkcPRX4mgTu6n7RxHTkAJ4G	10422	14707	14707	1618586465199	orphaned
20749	3NKVfyQuRDLgjvaYBxVGzcSATspdRTbTAa2B7tA7eamwH2Kr397d	20747	3NK3QEL9rUCiRsXsQ4AsqSqotSep8CtHbmz6QjXVzvzzm4KU2QzZ	1506	1373	376	12463	13046	jxps5Lsr7oWzeYbjVaJQ87MeBwnvUiYn3LRcQJuYq218oEwhupv	10431	14701	14701	1618585380000	orphaned
20754	3NLMnhYznQTSQ6q962hVUE9YLG7hkHaDpvZQADBe5T7vs3umUEGW	20751	3NKCgpx6bUnpAE9iWXzk3XEnkeUs9sTRPxgMVbaGSf8kA4BUNjyp	1536	947	376	12463	13050	jwMj5jAAsR1te9nhfuoivTBkGMsPCA7TvAZ8Nv393AH19NDEWPB	10433	14704	14704	1618585920000	orphaned
20755	3NLJBVZHDC6AFSWCBysn1bgKDWKKwPh8ykkpSkopRfoBUgkbuJ9H	20752	3NK7XUZQcfXMCGxBL47FefcQ7D5UKGvVqfZfh5qZ5YyNNTjPQtTu	1406	1393	376	12463	13051	jwCQcvR6FuDCw9uczpuNrw1oAYjvqDfrfzHyUbukZauPDZvMw38	10434	14705	14705	1618586100000	orphaned
20759	3NLEHJw43VVcmnNSx5AWmTrF5HR637UK6VvucL2Rc1NqNLecKwEa	20756	3NL8fqpwdf2hW118BkVT52b3j3thB5RCDMZq25naQco5eFshkee9	1577	961	376	12463	13055	jwJfSFmWn2wavTtYZmyAEwiXiktVdz4Jc5FuTBWssGDCmviU2HS	10435	14706	14706	1618586280000	orphaned
20764	3NKktJQzk8VwEX2L4xPPaP3vPCt5HApjtdiseYcJRWQaeshezWdA	20758	3NLrbZd93E5PeDdmmXJJdHP6jH1quhxQHPkUSQnNL6gu6nq92xo8	1638	630	377	12463	13060	jweDDRuHJkVpbh86BbHtgSk5VcyDABEKxsP4oZoLLgSDNao2kPr	10436	14707	14707	1618586460000	orphaned
20768	3NKbPDKSsNLDj5VEQgGThVcqsCRRm3a2EQdmLQC9Yg7XqCLaxbCb	20767	3NKfqz8Cm2dGqJchuwieQZPqVyJg8BXRue28Au44t3uSnxsh14W3	1587	1231	377	12463	13064	jxwad3x6jT8c9frDPKgA7UBpS3uhLHGrWA5izjGb925sKQau8ro	10437	14708	14708	1618586640000	orphaned
20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	20766	3NKhzuR12V8ddf1m8UhBc4jSJ9yzarFPzVKyyutFKhHy5ToyhV48	1439	913	377	12463	13065	jwzui8PHjAq7oZzvnytKsGmMVLp6L9ABPpBT4ivBECASPA14eyk	10438	14709	14709	1618586820000	canonical
20773	3NLbMNvSfJEtNSLsi2M9tSnoM84eSmZcztVQKrC3eQW4FGhqwY8w	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	576	1109	377	12463	13068	jwuARzsSUDJrdpJjKWxumWQ9v5sbfoRJiWue6LsTerQ7S3e4gfh	10439	14711	14711	1618587180000	canonical
20774	3NKmvktR2QQ1NKE4mQGfoEtmZW7iE8aUqMyay99nbFaCrhHpM4bL	20769	3NKMa52wtm1b6m2npgcrjD2SvGzrTwH4juup2hpEDymWegCagQ5u	1474	1329	377	12463	13067	jw97BxxLTq9gfdtuwtuX7cRVDbWmYafdsdXarRwP3kqWdWiTKzW	10439	14711	14711	1618587180000	orphaned
20778	3NK7L4Gb8A7iHT7hfX9n5MkHxeQKQxNoZqYosNqHWamH8kaQ16Qi	20776	3NKqBQ1dLM29kgws6Np48RYdqfE2YPNh32JKsYWZiMMMd3CMBs3r	210	210	377	12463	13070	jwGiZNqMtovo1boqJnMkLMn7bJEHM8UQwP7jDDBaQ8rpNX7qZR1	10441	14714	14714	1618587720000	orphaned
20779	3NL7Vcoaz1ffzT4trwC1gTwnXxpebB6V3eNNQrXojV8GUK1BJBZY	20777	3NKyhCsxZF8b767Ay4A8x1HYV1t37ESbUryZ3H1QtkxB6AsgcLHw	1631	794	377	12463	13071	jwj4MNcU4QMMSdduEGrBmEYEnNy8vHM9X2ijh2tJfub4dUq4Fe5	10442	14715	14715	1618587900000	canonical
20780	3NK5uYbrTreqWtE3ruhmECPki4t6xNuj1vBqJo3z6B7qgyCDewne	20779	3NL7Vcoaz1ffzT4trwC1gTwnXxpebB6V3eNNQrXojV8GUK1BJBZY	1403	824	377	12463	13072	jwr3a3CQLHMGG96rpkocd4WQAs17e9wtD8cKBGYdD7DWrcd5BDM	10443	14718	14718	1618588440000	canonical
20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	20780	3NK5uYbrTreqWtE3ruhmECPki4t6xNuj1vBqJo3z6B7qgyCDewne	1646	1354	377	12463	13073	jwp1YyMAuqS5BqiRZaH9i2WAPybcqE9Cmt3EjQNoN5Cm5xAY5HF	10444	14719	14719	1618588620000	canonical
20782	3NKFze4ejrNWPoryU1k9HCnQNFxyKneKb3WKSzCLyM3d5gWctdy7	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	1549	1116	377	12463	13074	jw9yQEJnuKPv3VmAx2qK8H6LHkHKc9UfwCJJX7FefvVu9gUhhJM	10445	14720	14720	1618588800000	canonical
20785	3NLxjWzqAqubmMuTQZRzCcwQwpd3FKWKtZsysja1VzUPVai9WYpi	20781	3NLqRX62f1C2btX8QJT7X566vTMbp4MU77WWn2o1HQVZDVifTT5e	1637	816	377	12463	13077	jwDk2YE8B8Qfz1ssMtThAYwEtPURpBHyq2q8qCzkm134xsenfb2	10445	14720	14720	1618588800000	orphaned
20787	3NKoLdzXSgxkUdXAX5SrpgjHgHTThrbgh9qBB8yBUBSikQtVEaqh	20782	3NKFze4ejrNWPoryU1k9HCnQNFxyKneKb3WKSzCLyM3d5gWctdy7	1600	1006	377	12463	13079	jwuRyXez6jiQjVC1qQugytrCQXEnszigSnA8qMZpkGHBegMTFps	10446	14721	14721	1618588980000	orphaned
20792	3NLBdYtEw75NGdaEzpnbEsEHjct7SvYxbvsVQRSwsaRtzSNsDUKw	20790	3NKjhzyAXqTCS46CgDLdGBN4NuE3nRhJ2iUDkukFF9KtKL7ZYsYr	1507	1280	377	12463	13084	jwqJjDPXdPvc8UCMsGyno1mPopx6TRFRyKfVTxpWmh18wHmqirP	10449	14724	14724	1618589520000	canonical
20791	3NKAZH16FAAMQpPJHHDLUKMzDERLP9XVqYD3quu36Wz31qJJ16d4	20790	3NKjhzyAXqTCS46CgDLdGBN4NuE3nRhJ2iUDkukFF9KtKL7ZYsYr	1422	1337	377	12463	13083	jwCGYj8mzVZ2PtKpz7UJXXk6hs7qrrQavvxWHvBCdRNFFoSCUrE	10449	14724	14724	1618589520000	orphaned
20793	3NK4wsUmfo4TeLDBRmWFeyKLwp7Nz29XgFuLujpkJZKx6TpAfKgd	20792	3NLBdYtEw75NGdaEzpnbEsEHjct7SvYxbvsVQRSwsaRtzSNsDUKw	1637	816	377	12463	13085	jxecf3vHPH1whtuokvpY2ECXcRotBJhmCu82RXt1TPMf84rHVr4	10450	14725	14725	1618589700000	canonical
20797	3NLedLf4m4FE3dEA3vpPdSrzsDFeGJ1fiF79PJ1VMPp9N4hxDbMv	20795	3NL6VrLbrEK94MfxVKQSmaXXKE8d9Zg2dPHkM9Srd3D61DB9Hxr2	1402	796	377	12463	13088	jwwxxNWUUa5qFNNwtCaYyiN8ZoEm6h62UuKifTZXDv1CNhcvNhj	10453	14728	14728	1618590240000	canonical
20798	3NKyM1rMEGstYZJAHwKTcbHYyEyAvLD9dh1EFysg96rdf16MtrN6	20797	3NLedLf4m4FE3dEA3vpPdSrzsDFeGJ1fiF79PJ1VMPp9N4hxDbMv	1451	926	378	12463	13089	jwjt4uMK1E5ZdqY1XKLYrcwZtHC6wLf8N8g1ZRdw6vjePDNHDZE	10454	14729	14729	1618590420000	canonical
20805	3NKaBrtsxzuCJjkeZzUiCgLgxzJjmGZcfbRzg5p4XwgU881Z7KJ3	20804	3NKLR9KVUi3uJPVVmMx1twxJNqkkbtq3imezxByMvtbYThE9kLdt	1406	1393	378	12463	13096	jwoNUPMNpCDqbbSTubqakxxa3TdQN3gA6o6aGYgHd4K549missC	10459	14736	14736	1618591680000	canonical
20806	3NLEShh71VTX5FPrfENzbt2wU93xxU7BUxDfbhiyXGuHxjyP5Wmo	20805	3NKaBrtsxzuCJjkeZzUiCgLgxzJjmGZcfbRzg5p4XwgU881Z7KJ3	596	1306	378	12463	13097	jwKn6V1HLhpx8E39pZ6uuVA7U7yweNL4ZeujD4Bie6kzgqyVxda	10460	14737	14737	1618591862392	canonical
20807	3NKwhFGX8Fi52N29ySEd81tqFdUHBHafPTtXT47BqoQMccJgLLyE	20805	3NKaBrtsxzuCJjkeZzUiCgLgxzJjmGZcfbRzg5p4XwgU881Z7KJ3	596	1306	378	12463	13097	jwPQZZ7tmKxPhDf2wxaBjriaFf3QUr94yV6W6QsPKSoBcrVUREN	10460	14737	14737	1618591860000	orphaned
20812	3NLXaSkJkmid3BedGa6MeEoEBzgLe3NRKAsCpoR983uYsiKNH4M3	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	1651	1301	378	12463	13101	jwp51mxRxrJf7J3f3C2erbQ4BDR1k7mdL6SuFtC9esyW2k62QmD	10462	14739	14739	1618592220000	orphaned
20817	3NL6zRxvNPhbQj2RHQo2ZknUHSVX3M5Pkhm2Ufxii1R1hHx6zoaD	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1574	396	378	12463	13106	jw98mLYxbsCUrt5QdvuLSam7pFF3gWQg815GkD4L3gDvwy5k8Dt	10464	14741	14741	1618592580000	orphaned
20816	3NKv6NTi7i4WzMd5UWtv8Sg66ipghV53XxKDnhpjPTkqjg3LEsoE	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1406	1393	378	12463	13105	jwkDtX14eH1KoAUhxXmKfRDbqY2r8R3KcSmF82p1DHvqjKcENJY	10464	14741	14741	1618592580000	orphaned
27534	3NLfxi81t5BZkxUu1N7YZYR4UziFfE6CxLVWTuWn8PJegLBHoacj	27251	3NLqFYo3sVrzZV2WteczFYBV2fAsJRbLeXf57G1V5SyWx2Kb3Xbo	1647	1056	525	12463	18869	jxN1cypJHiUgPRtpRriYS7ZFd4c2w7KJLXSWMZoxrfD7bjaMLbZ	13412	19168	19168	1619389440000	orphaned
20788	3NKnLTxKpbBNarhzhiw42qX4w7SNY5Zkb3iR6AW1u7Hu1tQuRWFn	20782	3NKFze4ejrNWPoryU1k9HCnQNFxyKneKb3WKSzCLyM3d5gWctdy7	1613	1103	377	12463	13080	jxtVh9KbinLET4W4uef5znawoFecUMgQ8aEj5WKBbYzzPLDxJRQ	10446	14721	14721	1618588980000	canonical
20794	3NL9YqcjjyK9KmnsRR8UcPxePpaC7N1AYvsRCwLJG2EiVPzLLe4W	20793	3NK4wsUmfo4TeLDBRmWFeyKLwp7Nz29XgFuLujpkJZKx6TpAfKgd	1406	1393	377	12463	13086	jwgQMc77Ti8FsN9zLQuaGsWre3bQ6emhFfPZgPV9xHYPLayZKPe	10451	14726	14726	1618589880000	canonical
20795	3NL6VrLbrEK94MfxVKQSmaXXKE8d9Zg2dPHkM9Srd3D61DB9Hxr2	20794	3NL9YqcjjyK9KmnsRR8UcPxePpaC7N1AYvsRCwLJG2EiVPzLLe4W	1607	1102	377	12463	13087	jxXHspHb84zcGZKYhDo89rG9e7A9kZCyCzztAFUzhtDZLWjVrzZ	10452	14727	14727	1618590063495	canonical
20800	3NKfGgXkSEwdJgPcjUetBZ3LbkC5T2cc6mo7jCPoRLVQ3GLrJao4	20798	3NKyM1rMEGstYZJAHwKTcbHYyEyAvLD9dh1EFysg96rdf16MtrN6	1406	1393	378	12463	13091	jxzqKyHLMHNGe4yvmx2G3XjqNYQXbcAqDXcWvmBW1sCiaJeynhq	10455	14730	14730	1618590600000	canonical
20801	3NKxkbz9dAiCPSknR6Z8Jt7uQYfGa8VYfrk16xhpaZRaeB5NyKaG	20800	3NKfGgXkSEwdJgPcjUetBZ3LbkC5T2cc6mo7jCPoRLVQ3GLrJao4	1599	1041	378	12463	13092	jxEK7xjRsdv19wWVpPY825pWT1p9FaNqcLTwyFLaSQo8QPgvTBx	10456	14731	14731	1618590780000	canonical
20802	3NLN5WctG4HY8WDAgEvJ2zGdyBXn6oXNp1N1nMvq7pcjRGGZ4ZCs	20801	3NKxkbz9dAiCPSknR6Z8Jt7uQYfGa8VYfrk16xhpaZRaeB5NyKaG	1634	1331	378	12463	13093	jwaMBwTDSvS7M1qYg8ay92AenYEzpc69YqToKedX6NJXXnu8AVA	10457	14734	14734	1618591320000	canonical
20803	3NLgvbyEyy6MoqUWy5vvLnZ5Dx76LVBkevBbj9WGuf7y2iFzhkhp	20802	3NLN5WctG4HY8WDAgEvJ2zGdyBXn6oXNp1N1nMvq7pcjRGGZ4ZCs	1426	1118	378	12463	13094	jwHPYbB5ujut2cppuz9t9jAA4ifqUvUv3FgWjeYEDGGBHXEacZE	10458	14735	14735	1618591500000	orphaned
20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	20806	3NLEShh71VTX5FPrfENzbt2wU93xxU7BUxDfbhiyXGuHxjyP5Wmo	364	364	378	12463	13098	jwuvit4z6uKdD9DcbxpyJruciDY7FKrw7k1QsGv1gybTLjNYbbk	10461	14738	14738	1618592040000	canonical
20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	20809	3NKPyHV8bwiM32pyMatSt5iuV4hgS1uEBVXhV8NWzxpkQVmVWiy3	311	1181	378	12463	13102	jwbfV2AaQ3iaSq4Ze66SisD7ohvFhmqgF2GP7BmmBRoVj5EsgAs	10463	14740	14740	1618592400000	canonical
20814	3NLZH8sZDweybvo3izRdx2UJyH51G29VHbmkFEfTB9HW2sHvdzwV	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1542	1304	378	12463	13103	jxW5U5vwCqMMtHmiCzS85Q7yoXHegmwH1KP6h4J8XDhyXSCcVgX	10464	14741	14741	1618592580000	canonical
20824	3NKV4RzgakspGVYVQzAxyDiuwKtTRkyrn4XQrMaWm3U8amAnjd2z	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1490	1028	378	12463	13112	jwkrbfUeE5VLfu8k2yjSn3BNxUugheGKmAVTMbM1uTd4qnPHs4Q	10467	14744	14744	1618593120000	canonical
20823	3NLTtU6vdMiQohFESxVDgSeYahFSqcSiVhyy2n6JsDGazxnVm9Fp	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1490	1028	378	12463	13112	jxVSjdnGL2yejbph1gJxxEj74vZn5ZHSXSvfx4sft1dX1c9ABbf	10467	14744	14744	1618593120000	orphaned
20827	3NL9jZ8XqtAxD4mEPfSb6juyL3wEBSuKXi1mwfcQUsnQtMH6fUT9	20824	3NKV4RzgakspGVYVQzAxyDiuwKtTRkyrn4XQrMaWm3U8amAnjd2z	1617	1162	378	12463	13114	jxSKdfmq2AotrnKsz2j6LCNWMtEn2Gma3fANEcwZBt2Hpize6YE	10468	14745	14745	1618593300000	canonical
20831	3NLZPcqyP1Dkv4xaac8sYhnCemLfM6fUQsAdtueEGrnKowKVQUVw	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1439	1279	378	12463	13118	jxZmdZpR6Brvx7N3yrEdvWsRqwf8E6eNdeGqxk6XdjcQXA52XFf	10470	14747	14747	1618593660000	orphaned
20835	3NL141xiXtZ2qG1YxtdNrXtcqq14HiENP5bQNWTTszPzWkgaSF1Y	20834	3NKr7WFFYcqZy4FKLfpEux4VdnexGtQNYxM9dwYG27fd9TRnD2Z3	1405	873	378	12463	13122	jweQUCenY3cjPJU8g5RaqnbRAWku173krYX4fKv5iTYRsM2jpNt	10472	14749	14749	1618594020000	canonical
20841	3NKYsRnKvqnS3eBSfYcLs3YHL8ri1VFy8UTnyYWagnb7KC4kRtCi	20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	1617	1288	378	12463	13128	jwvqckZUwzC8JwycP5VNC6VwthdeJ1Pg3SVFi5nMdXhXfSVjK6h	10474	14751	14751	1618594380000	orphaned
20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	20842	3NKjD6tVBqsubBx78hy349vTzDNFU5bTeyxyjEhDN8NKrMndpwfd	1649	571	378	12463	13130	jxAT4CDSUf1xRsdMsCThC17E68DUM6VEkrsHrZL5GYEaC2q5g9N	10475	14752	14752	1618594560000	canonical
20880	3NKYvucHQbnwCDMfzTe9ggDfApNmw5FLezNi8RJLNHQwA2APavok	20842	3NKjD6tVBqsubBx78hy349vTzDNFU5bTeyxyjEhDN8NKrMndpwfd	484	1319	378	12463	13165	jwqhXF5UFJX1qWGg5pnzSqsUvtZkSC8eKA4bPRD63Dkn9MfpNLu	10475	14785	14785	1618600500000	orphaned
20851	3NLdbRe347dZS77tG1iaXqbd3s1cJubQBWNid2mKBsDzXkPNpo8E	20849	3NKDCyWh53aqF98nbP2K7xzLQDf8AH7mU8JD4Pg3Y57UK6wtQere	1617	1162	378	12463	13137	jwkShzYkfYrtkzRiZHHdLVBPQhqmFeAeRrqfuUWTxutps1TFDgp	10479	14757	14757	1618595460000	orphaned
20857	3NKFN3hwN92VYoBAKPZEeDw4M9qVpNZCeR2vTLDfvk1SBF5i41rG	20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	1609	1333	379	12463	13142	jwcNY7k8ogEvJy8SBMVe7EF6tNLNY48vzxUn2BokcNLC1Fm4fQF	10482	14764	14764	1618596720000	orphaned
20863	3NLiuKn5nZ7MHVXYwwjKb1W7rZZLsMtPUZoRvdougPi8TemQtHP2	20861	3NLVGq1L5ZexpZStk99MCMCvZGACTCn6zuGCcE55t45vDRMPMFd3	1587	1357	379	12463	13148	jwgEyikDL39oiFNMd97EFt4RSR7HBG1kJaxqq3ZovumyALjsWGY	10487	14773	14773	1618598340000	orphaned
20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	20864	3NK8sFNqjiPJLfWTJHUjPi8sYfSZNBxucwu1ykitgwFbnBAKiTDx	1403	824	379	12463	13150	jxx4JSYJrHEfop49ANZpgGZvV18gRjDT8JJCSFvQN6FyfLpxovT	10489	14776	14776	1618598880000	canonical
20870	3NLewBQj8W5YfFuu4ucbEiNFaMnfEr36bX8RzbPKguukbQ2wH1kS	20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	1501	1234	379	12463	13155	jx4zhKC1qMTLJoMdNFQF8tD4dgqV9JEsogzX1HoRZRjrFqauiPS	10490	14777	14777	1618599060000	canonical
20872	3NLRGUa8AhFj3CvXYTWEz14ouPsLDeq6ujeBPgPRFMK53gu4jTnn	20871	3NKEiaSx3zXYqBy5fbPoHZCYi3deBfNY6NSKsMKXAyET2QqtKLSf	1426	1364	379	12463	13157	jxRKBwjLxVJ69WML2hH6FgLx8hD63gFgvM119GrmbQ4PtJDnGX9	10492	14780	14780	1618599600000	orphaned
20875	3NLnH1gmaxG5w1W1stpvjiPnht9jjcRRpGMffzpbEPLSoq3DvPck	20874	3NKZrRpemG7V3NMXQ4M6qf4KLxc1anDXSSNMidRXVauxqAeFaFuX	1671	1119	379	12463	13160	jxKqTE9rgpxkuYJdQFVnTf9Ejzj8XHQ86SH9edVToEbD8Pe1p9t	10494	14783	14783	1618600140000	orphaned
20882	3NLWqQgDq9ChcDcNxtHFcHD94FyYiXjDtynnvx1i8MofeVwVG4CF	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1467	1250	379	12463	13167	jxzGp4HcQ8B62RBDdoudBAgF5CN7qtU5wQxwu2PHWJ59msakEA2	10498	14787	14787	1618600860000	orphaned
20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	20884	3NLk6CZLWhX2Eoxex7C8gPPNBEEPbQkoHPEYLK28Ms42JEbxKywH	1447	1219	379	12463	13171	jwSWAeV2fNehAqVPB4xDCQ71scxGbUEMvzUy2ojhQMHzmTYncKB	10499	14788	14788	1618601040000	canonical
20889	3NKDEKEVihfB7z94dodVrJBwgQQuzk3TkVU9MU37HS7rRENw8qpf	20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	1451	926	379	12463	13174	jxT3tKvQ5VZfQDyUADkX4JTMKb1RZ9c28z3eHsGnBQrh27p2Mka	10500	14789	14789	1618601220000	orphaned
20891	3NKrXqVYrPvt5GUts7DMcZWPSki6tYp93K23y47Jp3mRBEAZcypb	20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	1403	824	379	12463	13176	jwDxxNBymyY1r4KYn6ru7Nyycq6RXdxcd5nvjW3qsRsMUkN6U1s	10500	14789	14789	1618601220000	orphaned
27649	3NK8vf7wftvxPwaYyYZ67Fkha6y24zBrhmbPc2W95eceVfPpFwPc	27534	3NLfxi81t5BZkxUu1N7YZYR4UziFfE6CxLVWTuWn8PJegLBHoacj	1647	1302	525	12463	18869	jwTVz3Nobb1JvbRRUNw9Zc5z8BStj9QYeXFtCanpq26NdxTVkJU	13413	19244	19244	1619403120000	orphaned
20818	3NKrnQVxR56Ao22wEiW5pB4UdZy73E6fNXn381LpSKPuXoHQYA35	20735	3NL2jbFYwCrnBL5pL4p6NVJJCg8S5zq1mai8GpWRpXnFNnyDXGFY	1542	1304	376	12463	13107	jxFpCqhT8i4Xmd3vgFr3KiopztoxZ3mTEqETMWfj6g4FwG8XK1r	10423	14741	14741	1618592580000	orphaned
20789	3NLkkh2L3555TGsTYmgBbHs5v8yDEMhGygAnH3ovLTCfQ7bg5H5D	20788	3NKnLTxKpbBNarhzhiw42qX4w7SNY5Zkb3iR6AW1u7Hu1tQuRWFn	1546	1213	377	12463	13081	jxP12PM146bGh1kURpRdPjG9ZvkoHeXqDLEx9xm8D8jVqnd5pUQ	10447	14722	14722	1618589160000	canonical
20790	3NKjhzyAXqTCS46CgDLdGBN4NuE3nRhJ2iUDkukFF9KtKL7ZYsYr	20789	3NLkkh2L3555TGsTYmgBbHs5v8yDEMhGygAnH3ovLTCfQ7bg5H5D	1406	1393	377	12463	13082	jxJB8uPyPBLuRuCbZEbF8DGfGdn5GSCH9qb842AY62xFfb5Yv5k	10448	14723	14723	1618589340000	canonical
20796	3NKpzu6kW9rPvumc1wtxXcsDXtJRwoAmF8M9MoCsC73mkKND17su	20794	3NL9YqcjjyK9KmnsRR8UcPxePpaC7N1AYvsRCwLJG2EiVPzLLe4W	1607	1102	377	12463	13087	jxRqg79EzZC5PRPdzFveGCBsyLQdVLbaUAiytQU7jdSurVijPuA	10452	14727	14727	1618590060000	orphaned
20819	3NKTbbpLiixJiPvcD1QekqcJgaqHZG9HpPbffNvw53cesbv9QJUR	20798	3NKyM1rMEGstYZJAHwKTcbHYyEyAvLD9dh1EFysg96rdf16MtrN6	1646	1108	378	12463	13108	jwrihj1FdLxKiYMTq9gCK1D3oDa5My79i3hqvwf6WVWXP6c5wyq	10455	14742	14742	1618592766996	orphaned
20804	3NKLR9KVUi3uJPVVmMx1twxJNqkkbtq3imezxByMvtbYThE9kLdt	20802	3NLN5WctG4HY8WDAgEvJ2zGdyBXn6oXNp1N1nMvq7pcjRGGZ4ZCs	1405	865	378	12463	13095	jx2tsCxqkzTtAb88pyMWNc2E5XgNYN7h1RU58Kg2NU45MnMp2Kr	10458	14735	14735	1618591500000	canonical
20810	3NKEsnJyYFHV8sbZksNXWbLkpAeq5p8xMSUK2oUQZSRUVgYMcikw	20808	3NLYbqo6oKgEw9KedtzvaDSVbFupPaVb5rrLvZrRebbBbxj8tceP	1406	1393	378	12463	13100	jxAoQafMENjVHyFTLNHqgZrf1JnPJF842HSKdtmg9YRMJmQKRWY	10462	14739	14739	1618592220000	orphaned
20815	3NLTq8GaUroi94iJtGyX9SF9UY9KEZx4ZBwSx2E1xRwNcTx93GAg	20813	3NLgv3rHnqP3xcVgQ8ZwkvovGgKZThixMtQf4mbagvzfWTXSqwzo	1600	1372	378	12463	13104	jxhFmVDHB3SdL9NXpkwNXetqcCLTSqcQdJvYbujotCUbLMQmY6K	10464	14741	14741	1618592580000	orphaned
20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	20820	3NKT4h5zJRoxQJ9xKfkix9F4u1gZusjhryxd4VP7tLqwqCe6PjNV	1407	1395	378	12463	13110	jxavedHpFQSbBPSs7QzfqE97DoSnc7cmTDRHQrZzMp6GbhggDEo	10466	14743	14743	1618592940000	canonical
20912	3NL3JQg2xkLKSYJgQXYv2pTTpcxsEUuMyTssEzqEAuGiGP1cBBpJ	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1514	39	378	12463	13195	jwD3uVbkjFLCHhuBEjoUUsXoda3QZcMm6dtDiYG9pnqwNeANbYW	10467	14806	14806	1618604280000	orphaned
20834	3NKr7WFFYcqZy4FKLfpEux4VdnexGtQNYxM9dwYG27fd9TRnD2Z3	20829	3NK84zZTsKSfbUPVy7kodurR9cvFPX2KZU8YTrBNKjgmwzNWGhHu	1457	1391	378	12463	13121	jxW6HKMuoWUFb4tzNxdc5NAQNfCGTCCvHJYeCEhM5wg991S9e2u	10471	14748	14748	1618593840000	canonical
20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	20835	3NL141xiXtZ2qG1YxtdNrXtcqq14HiENP5bQNWTTszPzWkgaSF1Y	1589	1286	378	12463	13125	jwQWatP9X93w2HguvoicwvgUCgWxUtvcEAqUZxsASMtThDMHKwN	10473	14750	14750	1618594200000	canonical
20840	3NKaSHTgBebKg5dou2aXcP5ebQpvRowMpqB4qR6GBjvsftaUwyh7	20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	369	946	378	12463	13127	jwP8oy3zAmRYHB2YQxMWursrUPVjAviLPUyVXsxLAVkT1gPAdfo	10474	14751	14751	1618594380000	orphaned
20845	3NKbkWHQSpLXRwyLsMz7Mxo3MEtHhij25tXGWut2oWpzRwHPhLU3	20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	1402	874	378	12463	13132	jwwneH3hgqWj11W1FLFboe6YqcKMtfYyHZFU83cSti4jPN4tQy9	10476	14753	14753	1618594740000	orphaned
20846	3NKiCncspzU647S85zuC8FSXnzWqPAHM8NVqUgvWAzs69wDPDEzb	20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	1460	1078	378	12463	13131	jwGqd6VCxcbzRw637gHBz9S3naMSABDv3PJZar95uk2jH7Zug8u	10476	14753	14753	1618594740000	orphaned
20847	3NKRxgRtQhED3BYd384G4Jf1K1ENh8NMdXdWEyvAWs4EtUYN1hfs	20844	3NL1AfwD9g26UfpPc7sfMvXmiqmNYvh1pAccw2a2RCSUpUfDMcWX	1403	824	378	12463	13133	jxdiUZF9quNKVdiQZVTcYf3qXQvczsBg21zHi6tNVZvDaxretva	10477	14754	14754	1618594920000	canonical
20849	3NKDCyWh53aqF98nbP2K7xzLQDf8AH7mU8JD4Pg3Y57UK6wtQere	20847	3NKRxgRtQhED3BYd384G4Jf1K1ENh8NMdXdWEyvAWs4EtUYN1hfs	1633	1024	378	12463	13135	jwuKbeo773Xmq8jy3Z7XDJGqAAmvbKwZjDaFkytUKwVTFCsekgh	10478	14756	14756	1618595280000	canonical
20852	3NLjY36fC7TqPeJpfFFFaCWH8PsLWqdRss8XX6bEZrbeGkkhmmKU	20850	3NKEP232gDsxQCCv1QVLmfFFhyfqHXtGZuLj4zSW2XkRxTgziGsU	1546	1339	379	12463	13138	jwUMNp5Kian565fBfbQWa8hBmSYJgE8MUvEv69TBCFpdSMMo7ii	10480	14759	14759	1618595820000	canonical
20853	3NLtwNG4kdAfNLy4NSU5AedjdP1FThQSviQrUjEcTEq2bc9FS6a3	20852	3NLjY36fC7TqPeJpfFFFaCWH8PsLWqdRss8XX6bEZrbeGkkhmmKU	1426	1364	379	12463	13139	jwXAz3UBUt5KQ2s35393sTekDmrFdAD2ahKGtszCrSELh56JZ7K	10481	14763	14763	1618596540000	orphaned
20855	3NKXQQ9EEiyFTTmq942fqVT8vR2z6TH1TK7if7o4b21YkemGQRy2	20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	1527	1047	379	12463	13141	jwiydPorJEJ3PRrLHvsf2uR4nw4ke2maQWQVPKHwfmhBQrJUyQr	10482	14764	14764	1618596720000	orphaned
20861	3NLVGq1L5ZexpZStk99MCMCvZGACTCn6zuGCcE55t45vDRMPMFd3	20860	3NLNJmAmUEiDxLbLeGbtrLViuw8zkFNXKBdLMaLvdHDE4qfbt3rB	563	1113	379	12463	13146	jxABdB7WWnYoSPtFp49YGQU8ZbacBjbYwdaW1PmiN6P9meFquZK	10486	14771	14771	1618597980000	canonical
20864	3NK8sFNqjiPJLfWTJHUjPi8sYfSZNBxucwu1ykitgwFbnBAKiTDx	20862	3NLKDypYqc8hXCzZPMm8mpJGABUimvrqWWgoxtGqDsV4nxQg6JRA	1581	778	379	12463	13149	jwiTkM7q3ynUw6sQLwqCak29u5DKZASNzM52s38DUdRjUdsiBVk	10488	14775	14775	1618598700000	canonical
20869	3NL61ngUG8tTanMwcF5g4EoT7bEBVni6nyeSdSHrjCZ1rSvoe28B	20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	1460	647	379	12463	13154	jwo69gSWG9G2ajKh6njEHztZAsfqgZ3G1kWhqKvMAMcX7ygzgdN	10490	14777	14777	1618599060000	orphaned
20871	3NKEiaSx3zXYqBy5fbPoHZCYi3deBfNY6NSKsMKXAyET2QqtKLSf	20870	3NLewBQj8W5YfFuu4ucbEiNFaMnfEr36bX8RzbPKguukbQ2wH1kS	1560	1291	379	12463	13156	jwY1BSRPG4pC2dJdYMJevujo9oBgmUej9jhLQV9KszpyHQDohFR	10491	14779	14779	1618599420000	canonical
20878	3NL5EsaHabbyw93HPqtz7DfG9PNVcYdoHcrY8tWv7wcbw9qYUbyG	20876	3NK8xh49FVz47j2fzut3U1amiRDWf5zbSGWMQoBknhVKNxpv6HGP	1444	1135	379	12463	13163	jwbqGnCyYx7XfW3JUa1LjSvbGdR8MVudze2pXb33q2PQeB3eu9P	10495	14784	14784	1618600320000	canonical
20899	3NKpCtg9C7CQWz7sGVb3hb3jFYwszHdVceJ2XbSPEH7qm59cCAer	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1509	1320	380	12463	13184	jxmPFumVSFJH66xiCENCfwmszEFEppdvmwhFLLbX4GW6D46RGFd	10506	14795	14795	1618602303025	orphaned
20903	3NLhKz3Lc4xZRUdvr1ABRStFR4i6DZHxawedbFpzcPctnpQcSQxA	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1509	1320	380	12463	13184	jxmPFumVSFJH66xiCENCfwmszEFEppdvmwhFLLbX4GW6D46RGFd	10506	14795	14795	1618602300000	orphaned
20906	3NKTCV2vmh2FtoReengpgnh83h6gxJGEjNGZSqgcbTRXJgn1TPkT	20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	1668	1004	380	12463	13189	jwiUW1bcjZrXLn8tsmeM7xJ4ZLVDQTKmSBQ2yr1BAtfUPbPbf2H	10508	14798	14798	1618602840000	canonical
20908	3NLhNuj2RoeTNhC9igQNkYBywCuTedSg8HgLB8kgBEj5JwLnEAS3	20906	3NKTCV2vmh2FtoReengpgnh83h6gxJGEjNGZSqgcbTRXJgn1TPkT	1407	1395	380	12463	13191	jwSjhxasJMUMzD88vZa4jRpWrnPUnrHmuTjM73K41ji83R64Fug	10509	14799	14799	1618603020000	canonical
27128	3NLCtKbLXp1dUP4eAmepxEvybzwc8tNf8Rk4U4cnHQXie2YfJmeE	27127	3NLDPP74HBTiHPe7pdehwoY8gFH61MtSnaYXVXH9LQpsELp96iKy	1406	1393	525	12463	18755	jwASF8jyFxsHosmQJ7RKmkvRzkmLEZMJm828zBC2LpWJTWreu2F	13416	18880	18880	1619337600000	orphaned
20867	3NL4ucRdAXi6ra9Ko8ECoHiZKZNWTbPLoK7mZXDMmtPH6KuR5NgB	20806	3NLEShh71VTX5FPrfENzbt2wU93xxU7BUxDfbhiyXGuHxjyP5Wmo	1647	1176	378	12463	13152	jw8V6VFWggQgm3CfKujiz5jRtBSg3q253rDCRQcTmZnVBbof6Wb	10461	14776	14776	1618598880000	orphaned
20822	3NLc9cPgV5kRd9o4J5oPu4NvNYMpa4Vay4AtY499Us4Z4YyLgcRX	20820	3NKT4h5zJRoxQJ9xKfkix9F4u1gZusjhryxd4VP7tLqwqCe6PjNV	1402	890	378	12463	13111	jxjiZ7pP9mjqadypjayidXoTYYuYqMk8k2MdiiZdwH9a4TZ7FU7	10466	14743	14743	1618592940000	orphaned
20826	3NKygFUYiCNbhQjefTPUDwXzuVpoSVyLzfxsjUspDpVbaKGQAbxW	20821	3NLk6GoddhfWrRkasQ2ucgPsZ3wmA1VyntYqA8oQ6UTz6mVWc2Rz	1476	1245	378	12463	13113	jwa9b3m9SxqryZBuWJ9JevnrbvnnJoWXEKNmiVDkdiJ3gmQT4ke	10467	14744	14744	1618593120000	orphaned
20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	20827	3NL9jZ8XqtAxD4mEPfSb6juyL3wEBSuKXi1mwfcQUsnQtMH6fUT9	1553	776	378	12463	13115	jxXwCfk5BhPEV5zFtvLc5jGVm5qWCLtrEmtJLinXCHJfmDzD9AL	10469	14746	14746	1618593480000	canonical
20829	3NK84zZTsKSfbUPVy7kodurR9cvFPX2KZU8YTrBNKjgmwzNWGhHu	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1407	1395	378	12463	13116	jwkC3nRYTcdEXh1SEDo4bWFBP6q8g88owUhmQQ4U9qRoTDUpbC6	10470	14747	14747	1618593660000	canonical
20877	3NLfPA49omPkpWeixVdpnG1M8Sgev1PkTV16XUEXGdDyLjgpX1fT	20828	3NKiit7Ae1PFgQyPGZ4DNiFQ7pfwpHNbUQHsmVL6wD6BxzPk5M8q	1671	1119	378	12463	13162	jx8CEZ2iCEePjka5aUjpUWKspbqgSwyPUvrAD1GruzrS9KAsrZU	10470	14783	14783	1618600140000	orphaned
20833	3NLucwYoyVStjEGotnmTv97XoBjeCkFSCXciWtpQ6PfYVxwKXgXu	20829	3NK84zZTsKSfbUPVy7kodurR9cvFPX2KZU8YTrBNKjgmwzNWGhHu	1637	816	378	12463	13120	jwsZ5ChiUJMHSmCx9t1oicBAz4agrgUSUaPevq9J7vTRhkzhmDN	10471	14748	14748	1618593840000	orphaned
20837	3NLgGHY3cG3DarGqLgjCg7hqzbbEdPJ79WeKaT2KKPuuCaf42Art	20834	3NKr7WFFYcqZy4FKLfpEux4VdnexGtQNYxM9dwYG27fd9TRnD2Z3	1633	1144	378	12463	13124	jx6PBstXNRpAvLx8FpTadN1YQ9Kwh2cQdEAVtVFywJJmTMYVSxW	10472	14749	14749	1618594020000	orphaned
20839	3NLActvtpvk7D47NWzhP6UPE7NK4Bx8RgiBq8qYgMJ3ncp6mvKiD	20835	3NL141xiXtZ2qG1YxtdNrXtcqq14HiENP5bQNWTTszPzWkgaSF1Y	1403	782	378	12463	13126	jwMJnV1sWERinGNqAzu3vUk7raJtTZ5tNALrxUoXHaLqyRmfkUG	10473	14750	14750	1618594200000	orphaned
20842	3NKjD6tVBqsubBx78hy349vTzDNFU5bTeyxyjEhDN8NKrMndpwfd	20838	3NLgrg3sTfsSvd4f2ZDigLJsVARrX5L62jCJewa4od7sBpouUmL8	1631	793	378	12463	13129	jw7AG2fUXcnnnU2P4VSrTJUKv31MZL9WFqdPxLdnWwwB8MJpcgL	10474	14751	14751	1618594380000	canonical
20844	3NL1AfwD9g26UfpPc7sfMvXmiqmNYvh1pAccw2a2RCSUpUfDMcWX	20843	3NLMhwVVfzy9YxDc3GDFzPnMVnF9YLkwBwBzi5JgHQzJv825MRNh	1460	1078	378	12463	13131	jxyri31sL8wFaYXZAGSj9mK83gmUcuVHGWbQjGQienXr82ka63S	10476	14753	14753	1618594742899	canonical
20850	3NKEP232gDsxQCCv1QVLmfFFhyfqHXtGZuLj4zSW2XkRxTgziGsU	20849	3NKDCyWh53aqF98nbP2K7xzLQDf8AH7mU8JD4Pg3Y57UK6wtQere	1406	1393	378	12463	13136	jxCoNwqRumRv19xB7P1D8AwhZ6UFovhcXpfhNgNafuqj98UEEkW	10479	14757	14757	1618595460000	canonical
20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	20852	3NLjY36fC7TqPeJpfFFFaCWH8PsLWqdRss8XX6bEZrbeGkkhmmKU	1407	1395	379	12463	13140	jxPK3h4ZQQjHNQwuSs6y5HhE5hBETt1G1qfFKm4syEKzQ1PKAGW	10481	14763	14763	1618596540000	canonical
20856	3NKFLgvw1aS2yx5eT3B1ADqKR9Xr6wq47VE5vNAsN2fMgHUJ1gEE	20854	3NL8cpN7GVhFE9VvH8Q6UvSNGPSGjLBt3vY2S4Mgw4yPyYzu3AcS	1527	1047	379	12463	13141	jx9MLGpVBubjKT6Hwz94roHj4DH8ihXiSvNFKNJoTevhMp1s6fA	10482	14764	14764	1618596720000	canonical
20858	3NKoLBcNXmrBqvR3YTyt6zcwFfps2k2RywtN2MRxrsZ5QZXcadNZ	20856	3NKFLgvw1aS2yx5eT3B1ADqKR9Xr6wq47VE5vNAsN2fMgHUJ1gEE	1594	1080	379	12463	13143	jxoiZLwHXvR3kX4GQn3TVeAn5CApZgBjkmwoEwUUB9xgoziu2hi	10483	14765	14765	1618596900000	canonical
20859	3NKvsNZREu3fScfSKzTBjHaBphdb7zsge7RwRCgK952BJfj8GpFK	20858	3NKoLBcNXmrBqvR3YTyt6zcwFfps2k2RywtN2MRxrsZ5QZXcadNZ	1406	1393	379	12463	13144	jxmUkEBhij8Fffcn7Em6WHzwBWjvAwTibJMzVvWX6pHzpKuwRGE	10484	14769	14769	1618597620000	canonical
20860	3NLNJmAmUEiDxLbLeGbtrLViuw8zkFNXKBdLMaLvdHDE4qfbt3rB	20859	3NKvsNZREu3fScfSKzTBjHaBphdb7zsge7RwRCgK952BJfj8GpFK	1607	577	379	12463	13145	jxyye77WVo564Ghr5p1UnJngrRamftB1DCGo84tBhMnqcocdEji	10485	14770	14770	1618597800000	canonical
20862	3NLKDypYqc8hXCzZPMm8mpJGABUimvrqWWgoxtGqDsV4nxQg6JRA	20861	3NLVGq1L5ZexpZStk99MCMCvZGACTCn6zuGCcE55t45vDRMPMFd3	1407	1395	379	12463	13147	jwXp6RfpWWmYyXKCebingXRo86MiWAbeLUkYffvxCoxyAb1Jka8	10487	14773	14773	1618598340000	canonical
20866	3NLv99YoBNEYXWmH3eqKWCXnDfKyWjWnQSZo1MPf3yuPfaZ8KgDz	20864	3NK8sFNqjiPJLfWTJHUjPi8sYfSZNBxucwu1ykitgwFbnBAKiTDx	684	1352	379	12463	13151	jxKknQ3jBqR8qfp1e9EA4wwZHxCrKSKHFcqra2FAmDPj9pfGPoW	10489	14776	14776	1618598880000	orphaned
20868	3NK6d5wAx3S7PvWGGnGTnn2sBSrJcx6XrfSTyafDvUczyRKQuuNo	20865	3NL9mTGo2V4sQNtfb1LfU4wGcdS28veCAcnMVuQzMMY8CqpZdo6U	596	1060	379	12463	13153	jxHM7NkL3JgC7JcX6rBEVoX5gUU21vKv9nRn22Vpeh1QCWtT4rL	10490	14777	14777	1618599060000	orphaned
20873	3NLVyySuPvYRXfjYxaEyCYYbdpwwVtTG9NEK3RTQsaHyrbotYyfo	20871	3NKEiaSx3zXYqBy5fbPoHZCYi3deBfNY6NSKsMKXAyET2QqtKLSf	633	1138	379	12463	13158	jxEZywCmV6ACmM4frJm5fbrqydcn3HM8uHkHQdKFGzRYM49iEpz	10492	14780	14780	1618599600000	canonical
20874	3NKZrRpemG7V3NMXQ4M6qf4KLxc1anDXSSNMidRXVauxqAeFaFuX	20873	3NLVyySuPvYRXfjYxaEyCYYbdpwwVtTG9NEK3RTQsaHyrbotYyfo	563	1359	379	12463	13159	jx4hsbRWUSaJwqTPvZ5Zpe99VkKNhY9tG6x1Y9xoniZDrYJJk4w	10493	14781	14781	1618599780000	canonical
20879	3NLgJ1zrBwrghmxPgd52y3Hs8Fq2Q64WZYjgisGGxrLGXVv7UXQA	20878	3NL5EsaHabbyw93HPqtz7DfG9PNVcYdoHcrY8tWv7wcbw9qYUbyG	1631	794	379	12463	13164	jwX52qAToS3FHSmqbwrAHBMoHJFSkQmduBU2w4qhUx2w6GSnpvL	10496	14785	14785	1618600500000	canonical
20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	20879	3NLgJ1zrBwrghmxPgd52y3Hs8Fq2Q64WZYjgisGGxrLGXVv7UXQA	1489	1014	379	12463	13166	jwqpuXDvrZwZ6xRuF5dk9EnmS9zTsWGW6AtV7Ghv31ycENk5X4f	10497	14786	14786	1618600680000	canonical
20884	3NLk6CZLWhX2Eoxex7C8gPPNBEEPbQkoHPEYLK28Ms42JEbxKywH	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1627	1259	379	12463	13169	jwkD4nXfVtuqtSWK9ZWckCv1iyoSQW2DEZQpjGrYFa9BXamdxZi	10498	14787	14787	1618600860000	canonical
20888	3NLkUK2T3AHPwdUmVfzNbRrB3QJoncKWU36UmiuLeR6mf9yadj27	20886	3NKRbWQJ4t6hidQJfpyGCGFD9uy7eaxZWWDMYjV3zdhegxeaDxPp	1589	1040	379	12463	13173	jxzkng2ngpWkNpzktM4ZdJUaiEBXf98JiayNvPkGDRM5yAZg3Ux	10500	14789	14789	1618601220000	canonical
20892	3NK7TwipUVXaCMkJFytiowFZ7Xa5tYtkDJUfvsuCCs2pMT9wyk5v	20888	3NLkUK2T3AHPwdUmVfzNbRrB3QJoncKWU36UmiuLeR6mf9yadj27	1564	1092	380	12463	13177	jxxDAFTsHNg5wbedYAZpoYn5P7hGTP1KmvSE72rBKZg8aREadKg	10501	14790	14790	1618601400000	canonical
20897	3NLJ2DQE3g4GPxDFxLHSJNTFbxpd8SpbjJ1egBaceWL7fCHcgkpE	20896	3NKqxMrqQfBf7qCt6T2m6C9BaoY9m6HYRZVMR8Hj8wkkNLR4Rv8B	1668	1004	380	12463	13182	jwu6Egj61gdpbGsSTBM5BuMTgXXEAUNgss2WyojSWED4TYVex5R	10505	14794	14794	1618602120000	orphaned
20900	3NKqcVxCgybd9sfuoJGkZ5TiMVGn8Co7wZ6qX2RhFUbMFuHCGkF7	20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	1634	965	380	12463	13185	jxkbhhzrH7XLE6jyxfiNUvxSRugVebf53u6dz2meAB5ebc4A2vM	10506	14795	14795	1618602300000	canonical
27134	3NK5NGBjjCFtipbpRVJncA4uL7Zm4Kdnm4nfDGkWZqgSaCoE1ks4	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1577	1201	525	12463	18760	jxwnJz1at3XWi3CL1Krm5wvWV5sFAekhD5YZUfJd2uxmnPag1tT	13418	18884	18884	1619338320000	orphaned
20876	3NK8xh49FVz47j2fzut3U1amiRDWf5zbSGWMQoBknhVKNxpv6HGP	20874	3NKZrRpemG7V3NMXQ4M6qf4KLxc1anDXSSNMidRXVauxqAeFaFuX	1637	815	379	12463	13161	jwoaZHfY5VTuhVcn47vGRLxjH2qoqCpFRwfm9bxHHARd5qduHBq	10494	14783	14783	1618600140000	canonical
20883	3NKdrUKyBVbAPnYzXEFrFMTsGUqJMXrM38mpYRAaRoC5xZcXXPYG	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1407	1395	379	12463	13168	jxJ2V2kcacK1HuPFYfT8uNubFvqX3HMuc4oqA773fjQDe6L3hQ2	10498	14787	14787	1618600860000	orphaned
20887	3NLMC8QYzhxS7GZ3mtF66SwBimhh5kbKPLaSz2EWnkg8gXVLoUNT	20884	3NLk6CZLWhX2Eoxex7C8gPPNBEEPbQkoHPEYLK28Ms42JEbxKywH	1623	839	379	12463	13172	jxxMjphytd6YKAoMmD925ZAveiBk7qZTNw6ZDoRA6PjT7TFKRif	10499	14788	14788	1618601040000	orphaned
20894	3NLTJhvGSHb43ATQMYazEPTxwhnrFFFbU3TBwDPLBU4ES4iDJ7U3	20892	3NK7TwipUVXaCMkJFytiowFZ7Xa5tYtkDJUfvsuCCs2pMT9wyk5v	1406	1393	380	12463	13179	jwn5JsvChY1GLudyW9ydF9woEyQ2QsQmfNyXLWiZFc98DymfNmv	10502	14791	14791	1618601580000	canonical
20893	3NKeqfRPQ8zUJ1tBE6h7okC4rGvkEpNkb5dES2RZ2pWCe3k9gZvc	20892	3NK7TwipUVXaCMkJFytiowFZ7Xa5tYtkDJUfvsuCCs2pMT9wyk5v	1489	1014	380	12463	13178	jxu3h5LXxMDnsA4QPqWApvXazwUHKG6dV2rf8Q6ErmLMCmKGnXJ	10502	14791	14791	1618601580000	orphaned
20895	3NLrYhK4P82DppAsMxGzQQbstYFKEWh255QZ6kCZ2zCpB4FMvQUk	20894	3NLTJhvGSHb43ATQMYazEPTxwhnrFFFbU3TBwDPLBU4ES4iDJ7U3	1406	1393	380	12463	13180	jwx7YLtD8EYya7Xmgp55auHB6rT1Myk3PrfqMBLJNMKNbosrkSP	10503	14792	14792	1618601760000	canonical
20896	3NKqxMrqQfBf7qCt6T2m6C9BaoY9m6HYRZVMR8Hj8wkkNLR4Rv8B	20895	3NLrYhK4P82DppAsMxGzQQbstYFKEWh255QZ6kCZ2zCpB4FMvQUk	1407	1395	380	12463	13181	jxh3hW83xPpUjnKiBkr4b7QSxUexCH5tT17ySNH8YpWBAhQ9RRA	10504	14793	14793	1618601940000	canonical
20898	3NK9MFjAUaG3Nn1u4o2QtrsokhC7RzpFB6SQFT8xwVAyALtiwCCV	20896	3NKqxMrqQfBf7qCt6T2m6C9BaoY9m6HYRZVMR8Hj8wkkNLR4Rv8B	1406	1393	380	12463	13183	jxvMe1vtbMwLyegH1sC7sMHCMtfKEDmvUoeZFHzACapzniwRrMb	10505	14794	14794	1618602120000	canonical
20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	20900	3NKqcVxCgybd9sfuoJGkZ5TiMVGn8Co7wZ6qX2RhFUbMFuHCGkF7	1460	656	380	12463	13187	jxbTnQBVqXZhuC4r76Qc4EgqwEbjzUraeu59VXeDzicFeE3DTnq	10507	14796	14796	1618602480000	canonical
20905	3NKttxxFABiGWbnrK9hzxAvA15eW1t5syPxErW26FhyYJkREJjxE	20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	1460	674	380	12463	13188	jwtCoN5G78jncg7hYmY2sDaFFZDYc8EdoAKUkv4qdah2QXUTgZU	10508	14798	14798	1618602840000	orphaned
20907	3NKwxW9fTNeuqiYcmprS6zwBVHbZ28NfVZojRTfD8v1yvpzGyte3	20904	3NL1PxgzEqGfYLcmdNWemPVEDzKB6CHwvvKEVjsEWBHM5mFuNukD	1403	824	380	12463	13190	jxaCJTVBSRQd65c3Div5DYtUZ8MRnQKfBduM7Adr3mqwbye2dyF	10508	14798	14798	1618602840000	orphaned
20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	20910	3NLMpRZ6mDpHk5CHbSs8YRo7hy83AtqT8AgAGYY9fpFi8DDpnDvX	1514	39	380	12463	13194	jw9CmmYohmXgv6oM4jdUfHx1hsdL1jPjxkv82XLLN8reMgHd2ys	10512	14806	14806	1618604280000	canonical
20914	3NL3t3VLwZyU7JMd49Xy4CfEDg32iXGp4Y45zJf4pmjzjcRV3NL2	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	1403	782	380	12463	13197	jxVQsgdL5c773Z5PdDVgRY1QtbrWcPJ88DWGB3kLJhs7KYHs9Dk	10513	14807	14807	1618604460000	canonical
20913	3NKDD9ZvvbGjWaEVEWmXNiT2ULmVDXQVJioUSnxRntqqH2f45ZZg	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	1467	1010	380	12463	13196	jy2xPfiRrdk83Bx13Bxw1WPnf3aV6FYnGxzHuXtidD1yAHbCgvK	10513	14807	14807	1618604460000	orphaned
20916	3NLRA6D7spxhC6V9mGtZHgfSBrwHqSXsxqjeAq141vhJwL9jtzhn	20914	3NL3t3VLwZyU7JMd49Xy4CfEDg32iXGp4Y45zJf4pmjzjcRV3NL2	1407	1395	380	12463	13199	jxFGR8KFe1jZHb2nbY91Ydh9A7EmPgMHcofmbgCcjCVNdoJ2bAQ	10514	14809	14809	1618604820000	orphaned
20918	3NL3cH9jR7XiLm4rbs25897un3UPCXLg9M4v6d2b7aJfCQVQTzWy	20917	3NKwxtNXXJR3TcQdZLiLD5vTGST9MdjDM22U487dQerrgtW4Pg9Z	1500	1297	380	12463	13201	jxCoDYrr6EFV7LbHmG8wZsztu8bgY6oJSF8BpTdHL8qiwsVDtU7	10515	14810	14810	1618605002700	canonical
20920	3NKT7ogUKu4NusUyyZ6SzAHRYvKDrn7X3DKoYmjqrpUqaXCyqYTV	20918	3NL3cH9jR7XiLm4rbs25897un3UPCXLg9M4v6d2b7aJfCQVQTzWy	1613	1349	380	12463	13203	jwP2HrPmis8fnQ7hd79Bo5yEB761s1DfYxtmbqErsLvebSBYozn	10516	14811	14811	1618605180000	canonical
20923	3NLtiTCqGSa2SiHhKJCYRyHfg2jqV4k1Jv1eJ61rpPdVXeqdftjF	20921	3NLAqYDG4XXqNLTkYQq6rLbRBWkwTh3miZfvPnYvubYfgq4sD2gC	1637	816	380	12463	13206	jwhsFhqnjDYe5Hn2YSkos7fM7Pu3sFYkYFSdqKai3HzLALMSUud	10518	14813	14813	1618605540000	canonical
20925	3NK9ShFrwMaVr6n24hndJK6VysK3HrD8xc5J1YotbjGT36jWNeRg	20924	3NKLWpadLXbhUtKx2fatYj1gZreeRZt7CVB4sQ5sxtFXLaJP1y2m	1402	874	380	12463	13208	jwgLLZjkba6daiz3GPeen2qJTeioHJdWs1c4Ls2AsT68JnvS8uq	10520	14815	14815	1618605900000	canonical
20928	3NLrnRfU1KxBoEeRUmLgC8SheWHtti4vRmVoXCgKKw5kyWLBg72D	20926	3NLrncRcPthVuHe6EAwmcsUcNpzdggZmGBwqFm4n4gjdFSuSeEZB	1406	1393	380	12463	13210	jxoUi9LCZ35MaQx9bB4Hz7Dm4sQKdV3CRVmDZe4zsUuTwrgA1VT	10522	14817	14817	1618606260000	canonical
20931	3NLCN4Pa8KAHs3AL3P5LVAM9Z8Rm784gWX1hHXHhQcSKBCqEB137	20929	3NLX5Nq8pvoqXe2rsGCv56iAxy1UzwdVePY8nxDJ6MuCkhMuwMPD	1642	1241	380	12463	13212	jwykn6hChoLzGsg62zJWXjNfKf2qQpJ9ZUz8XY4UM776jDGNZY2	10524	14821	14821	1618606980000	canonical
20933	3NL5vkoAuQnJuXysmT8B36CWMSqZxGgykL2AWZkkg3GQr9nW3hZL	20931	3NLCN4Pa8KAHs3AL3P5LVAM9Z8Rm784gWX1hHXHhQcSKBCqEB137	1474	1083	381	12463	13213	jxzvYAjN7si1XQySoMtxFrKeJJBbFvwouE72j42bdopiQE66uGv	10525	14822	14822	1618607160000	orphaned
20937	3NLmJTBEypjEV9DsKTipM4MkWuoDhBYjAfdn6W7qiVjuJ21hmLHQ	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	1503	447	381	12463	13215	jw8hMJxc9Wfddf7wyGz7ubkwW3geDCdmBGUxYt2Nafeqn6962Kr	10526	14824	14824	1618607520000	orphaned
20936	3NLfQQjHyADsGG3B9K1r4uSuMk623q4ppUNbYvm1n9N5WGN1HxUv	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	632	1382	381	12463	13216	jxNM29w3ADYv7Hu8EP4f7LJcLRkFZ6H5Hb7crhGC3qSc1LKmUuF	10526	14824	14824	1618607520000	orphaned
20938	3NKcBXr3iELFSunYCJ5bejDzpCNnASc3jvkHscw5xikeWAnQCz29	20934	3NKZ1oYeLoSZjwDJAtjY43TLoxmDC3JQNuijpyz9rnC3vPfvUPwj	1406	1393	381	12463	13217	jwzi9Jf917eUHAvEQ27stR8t47r4FiaB155ZiY5jqUCRFto1YhD	10527	14825	14825	1618607700000	canonical
20940	3NL9F9cresPqLgmvLgh735M1WpHKpmVDPw399pYnJA6ayLc6oq5J	20939	3NLGd2MEoaXme5C8ouEkPVH7i2pvx9pGx4QxJ1HSvTwrXStn1GKq	1407	1395	381	12463	13219	jwy39iyn3tnAuJ2ToenV5M6khUk9hDmKKSe5FYhUTVTfcxv91dy	10529	14828	14828	1618608240000	canonical
20941	3NKck6zs7pzaKYvFhA7GY9zuhRniJsP6h3F7Ns15ABBEW5bFuLUJ	20940	3NL9F9cresPqLgmvLgh735M1WpHKpmVDPw399pYnJA6ayLc6oq5J	1403	782	381	12463	13220	jwax8oFFayaZc6Ly46xV6HirUyBivcFETaQvqbiRxFQsm9RSe15	10530	14829	14829	1618608420000	canonical
20943	3NK7GL5wgNWVDhN1xmJjPQVvyeGGfqATq5J4XyZbJGYm5jTbHD6p	20942	3NKE8wZeJerG3aqmHtrSiZkiLxHE4U4YY1bsQasSifMQJU5J8mUA	1588	1392	381	12463	13222	jwLGMxbCTjVq3LHsWtMjPs6xN1CuWByghNszaBfzns38xycpj7T	10532	14831	14831	1618608780000	canonical
20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	20943	3NK7GL5wgNWVDhN1xmJjPQVvyeGGfqATq5J4XyZbJGYm5jTbHD6p	1637	816	381	12463	13223	jxfvVRN4WQ6CBwzUc2UPTDiT4td4erEAtGgzZLSWNUmTgsvdm17	10533	14833	14833	1618609140000	canonical
27441	3NKHLJKywTKsEjEHFjWRL8vXZHBmGRYxypTrNijTVWpLEYSBXxQB	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1646	1354	525	12463	18765	jxHxjyFaJEm2PqqAXpeQAEwZ19ZwSrhrvHKijmRGBzMQuWkG7qX	13421	19095	19095	1619376335533	orphaned
20922	3NLrnbJyAGhJ7L5UUrByu9eEKzpryjPQq1txUgUtiUkLWEzTj4Mj	20920	3NKT7ogUKu4NusUyyZ6SzAHRYvKDrn7X3DKoYmjqrpUqaXCyqYTV	1571	1335	380	12463	13205	jwz8C4VrymLLr6GfNmxrARZSQBgj26XkNBdoYwXqYrGgRmr4VUW	10517	14812	14812	1618605360000	orphaned
20924	3NKLWpadLXbhUtKx2fatYj1gZreeRZt7CVB4sQ5sxtFXLaJP1y2m	20923	3NLtiTCqGSa2SiHhKJCYRyHfg2jqV4k1Jv1eJ61rpPdVXeqdftjF	311	941	380	12463	13207	jwzJ36LmpK6XL4CZiynQb5CUQzYQWpDRZ8C4Hto251sLGvKnBzV	10519	14814	14814	1618605720000	canonical
20927	3NKrTJfPub12SMSxzauMyGS9aVzBQJv13GtATdewvMARgw8Rzw5S	20925	3NK9ShFrwMaVr6n24hndJK6VysK3HrD8xc5J1YotbjGT36jWNeRg	1448	1311	380	12463	13209	jxzLpGiXAP23epXvZmLpb36S9eavDkpJ5MhpVG3tCUMPxWgkvqf	10521	14816	14816	1618606080000	orphaned
20929	3NLX5Nq8pvoqXe2rsGCv56iAxy1UzwdVePY8nxDJ6MuCkhMuwMPD	20928	3NLrnRfU1KxBoEeRUmLgC8SheWHtti4vRmVoXCgKKw5kyWLBg72D	43	944	380	12463	13211	jwFYDqsjwZukL7gCWnTtWeHMCuEFRgn9EasnUCje6YynW2foRqW	10523	14818	14818	1618606440000	canonical
20930	3NL5Gshi3JRb6QZ6jf2RhWFB9d4jpYFGFxW9YNaGtUjG2neeKeWJ	20929	3NLX5Nq8pvoqXe2rsGCv56iAxy1UzwdVePY8nxDJ6MuCkhMuwMPD	1642	1241	380	12463	13212	jwykn6hChoLzGsg62zJWXjNfKf2qQpJ9ZUz8XY4UM776jDGNZY2	10524	14821	14821	1618606980000	orphaned
20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	20931	3NLCN4Pa8KAHs3AL3P5LVAM9Z8Rm784gWX1hHXHhQcSKBCqEB137	1474	1083	381	12463	13213	jxC97bYF1fbzFbsmj9ftim5UQdgVh8PXbyGua7xqhC3KPut9zeA	10525	14822	14822	1618607160000	canonical
20935	3NKeNRAzA15NF2RCv2fdtAe9ZEZxcYL5zDSg6hQEhyJXKpAncmse	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	1503	447	381	12463	13215	jw8hMJxc9Wfddf7wyGz7ubkwW3geDCdmBGUxYt2Nafeqn6962Kr	10526	14824	14824	1618607522036	orphaned
20942	3NKE8wZeJerG3aqmHtrSiZkiLxHE4U4YY1bsQasSifMQJU5J8mUA	20941	3NKck6zs7pzaKYvFhA7GY9zuhRniJsP6h3F7Ns15ABBEW5bFuLUJ	632	1382	381	12463	13221	jxcVbEBxRYoDYvTRpBQZC1nH88Sje4rc4xFZaQQXeGLP9yDVy9T	10531	14830	14830	1618608600000	canonical
20947	3NKbhMKAmFnL5gDtF87nUZxuQwAQzVAG3qWMW56bPLi3UmTKzEhU	20944	3NKBTS3sCvuXKNH7yafraJJLsGpVvUUf9p4rF4SbMYAmPCKPa67D	1406	1393	381	12463	13226	jxbEAdmZd3uNhWBWGa2zjW7awmrofCa5FCKCS69JCti94GuQH9N	10534	14836	14836	1618609680000	orphaned
20948	3NL6j7pQuZLWkqWsMiWsrksgdmwRoJEtvH5PGWEUp6W21Ryoyqnn	20946	3NKCypok4j3uNXPDqcygLv7yNmRphXMLvfieDLhJW6PWreuTiQLq	1460	1324	381	12463	13227	jy1v38GQmg4Pd6gfrsqjiFSQmHTFHQ6oCRSULRrMZitDqFBUewL	10535	14837	14837	1618609860000	canonical
20951	3NLUUT2qUwFGB4Srg9e9TAh9BvfmsRtSKN4iHeZvRvhvDtU8r62Z	20949	3NKWMWpnMD6DZUbK1D3q6mnoLAt2a9tntjtZyEkccA7r9U9LdVtJ	1581	778	381	12463	13230	jxkgkovRHuDn77ivZRwgyJfDvFhq3EPhCsAamBs5Ce4d7cgN2nt	10537	14839	14839	1618610220000	canonical
20953	3NKgoV5REeEPYY67K1jwzu6i8BTp4WRWpry4xJNXToJD9UQrxJsf	20951	3NLUUT2qUwFGB4Srg9e9TAh9BvfmsRtSKN4iHeZvRvhvDtU8r62Z	1516	1168	381	12463	13232	jxhraFNWnpSvHXgkkEpG7sVut6LVc6wuNkN9ogV3N6epJh3w41P	10538	14840	14840	1618610400000	canonical
20955	3NLL3EhimWjLZGUdm5pDX6kD7JycXCpZNFSxgnDU7mH4y1Nx2bkM	20954	3NL2zVCYEARZ3vc5gycdJAZvTRRe5PsTontbTLgdJsu1nN44jZHN	1546	1339	381	12463	13234	jxE1GjNsTpHyQ3yw6XoeYrLA9pxYMjcDKvnw1kFUpqNHBMjmzqk	10540	14842	14842	1618610760000	orphaned
20959	3NKeaDbrJPYsVet5GyaDZBNLxML2JT1cMuEFQuJVVBPX5h4pdfPQ	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	1489	1014	381	12463	13238	jxYqXwKXuu8f7qaNnBrfbMrRKLiWzGJToqGxHo4BGcGhes65LZw	10542	14846	14846	1618611480000	orphaned
20963	3NLERiLhBsWAAi1UZiWtYkBATk71XhVC7m3FkLgtSSrkaXoGrWTh	20962	3NLaEWybBvakqmU4cFPdM5kEjnRBVDTLoRnTmnUan9dBUcicpiva	1571	1089	381	12463	13242	jxBU215NqNwLb6jaHC9vkZrF7MhTcPn7cumCzRrrDvsNsSMzCug	10544	14849	14849	1618612020000	canonical
20969	3NLrvGLViS5XyKrEiGkL83S9C28Nn11ggreWFQWeD5deeaGSnMEd	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	684	1106	382	12463	13245	jwi9FPK1q969o4bLVexYK86gnzEKTHdk1evi5RsULtpKtxAWAJ7	10546	14852	14852	1618612560000	orphaned
20973	3NLHndNSeyGbhRoCBvABmNEAUfKMoDwBiyxJ83h2g4D9WJsYvWMi	20971	3NKriKGBEEVuai6FUftstZFWic3friC2mejx3B7KdbD6FYE97fBM	1646	1354	382	12463	13249	jxeC63APHbUSzGBjLnpQkpFsexpQcJp8yayBmpWbnyPbR7LUhXf	10548	14854	14854	1618612920000	canonical
20974	3NKvP5vy7GfeBDCKiheXqHMDmFZR8h6yCWw2siNNEjbWL6hX1oZ5	20973	3NLHndNSeyGbhRoCBvABmNEAUfKMoDwBiyxJ83h2g4D9WJsYvWMi	700	840	382	12463	13250	jxmzBn6yVc7RqW5w44SzcxNW34Np99J1b8N3kdPyrgctKPEmwaU	10549	14855	14855	1618613100000	canonical
20977	3NLXyyi6EufNT6JrYP9sJKFziWdB17hzT95f6B3rZtWCCTcx16BE	20976	3NKGSrjU9BiWs7kHb6YWwAuSbvvkU1cTUVhDqbyb7L97botMkbtu	1587	1111	382	12463	13253	jwWMn8J7D5NDv9YVDeJczrnZ5zD3vkEHJZV1GftRzZd7BTwmBLz	10551	14857	14857	1618613460000	canonical
20978	3NLcPFRpfG8ce5pgdFDSg1CLCYYta5dYR7if59etchXugrCSxz2Q	20976	3NKGSrjU9BiWs7kHb6YWwAuSbvvkU1cTUVhDqbyb7L97botMkbtu	1553	776	382	12463	13254	jxsxKijYZE7jftcpscawobkExraPYMwRLh8L7zFcF8e1RRs1P7A	10551	14857	14857	1618613460000	orphaned
20980	3NKaMWgeYQohvbMwaQ2r19Q3Q33yre5BnUfc2rYLPRgpYvMei9ec	20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	1426	1364	382	12463	13256	jxSSUZofQDMC4wzyFxamiGkSvr3eWasAN4DGKHugxPx81bskeD9	10553	14859	14859	1618613820000	orphaned
20983	3NKLFuKWCgDtiu7J2DgjdHAnWyByWZoFWe3dK8PeeaZMSwekrnmV	20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	1407	1395	382	12463	13259	jwAXv68P2hmFUjVZP1u8QVPz8Z6ejjqxkcNiHwAT3j7ypApeoYs	10554	14860	14860	1618614000000	orphaned
20991	3NL7Ne1QKFjruq2bK9NrSvFQjFyDUQuAsFK8iBxYvLgB2B9XC3Qw	20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	1578	1050	382	12463	13267	jxEN8HFjXuGPjXs7gkqXMVPHteB3zpgfATqNT3nXcACLD4HErN7	10557	14863	14863	1618614542530	orphaned
20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	20989	3NLVBy4RP3HnwTnsq9uP8oTJ6fjZvfSVnAp2Y5ofc4HLGers72vw	1580	422	382	12463	13268	jwh2odaVV6segoKjT4LLf675LFMHyuCwyhyhKfE7kD6PFVFptXc	10558	14864	14864	1618614720000	canonical
21007	3NKgZz9trq9jJ3Kv6Vx6K8PgCGS5CxbxkZ9mZAjuQYNRBTGKGyW4	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1489	1014	382	12463	13279	jxjo6a3ewLeFf8WqvG6qYY4ba6RLAsHjoGPSjT7FW47L39GS9tx	10563	14875	14875	1618616700000	orphaned
21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	1403	792	382	12463	13290	jxu8A17chD6e6v3qSszS28a5Zw2jd9AtevSJuTdLiE2yDCUqP9c	10568	14882	14882	1618617960000	canonical
21023	3NLEmGfnMTVsQcJ6kTRbLRd8bamysyFYsLFKeB6q5aWtGyaFdyEP	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1607	1348	383	12463	13293	jxmkCxY5TQYsAZbZ6JBT97WAn1344qg4Aa4yaFH8BvwfCCLrjWW	10569	14885	14885	1618618502488	canonical
21026	3NKhnvqbiEcnmGmgGhk8VfV4LgfxV2vpKMCAio5j493Gk8aRjipQ	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1607	1348	383	12463	13293	jxmkCxY5TQYsAZbZ6JBT97WAn1344qg4Aa4yaFH8BvwfCCLrjWW	10569	14885	14885	1618618500000	orphaned
21030	3NLGHPWssSiSa8D4PZYg8xBoiw7e3gHL6jnjAFcSfELYLCN5ekdA	21023	3NLEmGfnMTVsQcJ6kTRbLRd8bamysyFYsLFKeB6q5aWtGyaFdyEP	1403	824	383	12463	13297	jxMnCTUfHm2uJTz5guj4TXc1sRTFTpjx3hasvBMK5x3jJ5fBi9b	10570	14886	14886	1618618680000	orphaned
27145	3NLrHxPV4ojUTWS8FDJAPPR2kBRyGjcmr22QQkGuRVPwvEv6vTMQ	27143	3NL96JL3m8aVeJs7KmvdEn2QqAotDLESkBKT2b7LSdLNr6qsgyWL	1581	778	525	12463	18770	jxSLqaQr82pLr3cBnys49G7nceUqBMTwYQWTWHcEAudtf8ieFot	13422	18890	18890	1619339400000	orphaned
20972	3NKyRSdPCJrTYbsLgVPxbmZyAGunBXfsihQkRFMNpcf4ASMFfL8v	20818	3NKrnQVxR56Ao22wEiW5pB4UdZy73E6fNXn381LpSKPuXoHQYA35	1542	1178	376	12463	13248	jwnDXUY5kGYo9DRhLkWJZvjo8o3ukUXZW6dYLj6yXMtr5TjLJ9j	10424	14853	14853	1618612740000	orphaned
20915	3NK8WZHrLcDwmtYMMqYpyV3ayZiB3xgZuNfroYYnuon26XF2nsni	20911	3NKZrWGHyxuomJCCpU3EBFMPJDXU47wzVxcBqqGMyKM7ibjwscfU	311	1307	380	12463	13198	jw8jpxbvjDHUcQ5HWVJdvfrA8GQWxaWx4ywWVyiKux3bz5DEAeU	10513	14807	14807	1618604460000	orphaned
20917	3NKwxtNXXJR3TcQdZLiLD5vTGST9MdjDM22U487dQerrgtW4Pg9Z	20914	3NL3t3VLwZyU7JMd49Xy4CfEDg32iXGp4Y45zJf4pmjzjcRV3NL2	1553	776	380	12463	13200	jwzziDZXWWpF778QDysPMZJVu5cyCFriTnwxFJ9ipYb1iz8FBgq	10514	14809	14809	1618604820000	canonical
20919	3NKehjTLBDgYLVDdF8Gb5yHyTStNT3CJHfa9dT5WQtUPBLW2mXyq	20917	3NKwxtNXXJR3TcQdZLiLD5vTGST9MdjDM22U487dQerrgtW4Pg9Z	1407	1395	380	12463	13202	jwqL1PofxNa7PdJqc2W8KiRq8h6dzvBUUf2Ty2yANaZqYZN8FMK	10515	14810	14810	1618605000000	orphaned
20921	3NLAqYDG4XXqNLTkYQq6rLbRBWkwTh3miZfvPnYvubYfgq4sD2gC	20920	3NKT7ogUKu4NusUyyZ6SzAHRYvKDrn7X3DKoYmjqrpUqaXCyqYTV	1553	776	380	12463	13204	jxb7smCmh7Gc6VS3QXazcCA4KdKyFAivJ8MiQSUjRxijuFMDJCu	10517	14812	14812	1618605360000	canonical
20926	3NLrncRcPthVuHe6EAwmcsUcNpzdggZmGBwqFm4n4gjdFSuSeEZB	20925	3NK9ShFrwMaVr6n24hndJK6VysK3HrD8xc5J1YotbjGT36jWNeRg	1448	1311	380	12463	13209	jwk48ifu6K7Qh79dwMHuyofydUaDv4eLaahm2N6sHLuF67XZN7S	10521	14816	14816	1618606080000	canonical
20934	3NKZ1oYeLoSZjwDJAtjY43TLoxmDC3JQNuijpyz9rnC3vPfvUPwj	20932	3NLsyQvzqGasux17A9ZhqjYQfrhsLhv6FiGC9a6DVmwMywAU6snN	80	1027	381	12463	13214	jwEeibLivu9e6m6LT2zA85pdiKKsD9Dv6A2U9knvD9QKjaBkDHF	10526	14824	14824	1618607520000	canonical
20939	3NLGd2MEoaXme5C8ouEkPVH7i2pvx9pGx4QxJ1HSvTwrXStn1GKq	20938	3NKcBXr3iELFSunYCJ5bejDzpCNnASc3jvkHscw5xikeWAnQCz29	1587	1357	381	12463	13218	jxpyYR8dX6QJkKy223jfMJtNVBmxwtHNkijh3ZEcPE545yJ4G1V	10528	14827	14827	1618608060000	canonical
20950	3NKmkP4vJKc5QzhELJsmSFL8Qp43w4ebsgsf6tkQER8vzVN8u3RS	20948	3NL6j7pQuZLWkqWsMiWsrksgdmwRoJEtvH5PGWEUp6W21Ryoyqnn	1407	1395	381	12463	13229	jxWr1JnPyL7KXrS1V39XUHZ4KamJKfC83zfzYq78bCM5C4aJget	10536	14838	14838	1618610040000	orphaned
20952	3NLsiNn2ZCrqnP7vBKeyVDWQYiJoGfLY1SpjLtBN44DkinSzhS85	20951	3NLUUT2qUwFGB4Srg9e9TAh9BvfmsRtSKN4iHeZvRvhvDtU8r62Z	1648	1284	381	12463	13231	jxe2P1M1NUGGrXVMhkagM8e7EAUHbQHQvxJQUBSt1EriNQ6T4ud	10538	14840	14840	1618610400000	orphaned
20960	3NKq2gFWBrTyRrVZkWDupy4fZHbrLrBYvaFeR76sfiEZsP24dc4Q	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	1624	1334	381	12463	13239	jwQb75ewMYYrnLhwsTpv7HJqrPCGgUbLupc5hZCM97aGVamnqgC	10542	14846	14846	1618611480000	canonical
20961	3NL8Vn1WUv9atpEZZN67JNVDPi8jMcSVh25ywKv5y2xjiyBcm2rM	20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	1650	1375	381	12463	13240	jwnqjHkhvAp2LDeY1YSyhQ6XnhDXxZku4ijaeMJWipjcA3Uqa7r	10542	14846	14846	1618611480000	orphaned
20962	3NLaEWybBvakqmU4cFPdM5kEjnRBVDTLoRnTmnUan9dBUcicpiva	20960	3NKq2gFWBrTyRrVZkWDupy4fZHbrLrBYvaFeR76sfiEZsP24dc4Q	1637	816	381	12463	13241	jwSaargTVLzjuEeA9PxCBsrupdBKKHq9fWfbB7RcKcDB92SzEhm	10543	14848	14848	1618611840000	canonical
20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	20963	3NLERiLhBsWAAi1UZiWtYkBATk71XhVC7m3FkLgtSSrkaXoGrWTh	1624	1334	381	12463	13244	jxfg1qyM1wozQjrwDXhwaS9kQoK4JmN6gGh4WR2H2mRnwxDvJ7T	10545	14851	14851	1618612380000	canonical
20967	3NKkwjzGYMN2poTEsHyo23jNHHnzaMHyoJ9ZjvCxjQ4sPyPtq6EM	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	1444	1135	382	12463	13246	jxgBvXPPoKYDDgpWshfS5yATGYiZnEX9ttKsssUGf1UYkHsH5Uu	10546	14852	14852	1618612560000	canonical
20968	3NKZEQTCgy7Ve8ZHdYx6J8ZG1oyNpokw4twjf1LXq6Fyof7YEMPa	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	1444	1135	382	12463	13246	jxgBvXPPoKYDDgpWshfS5yATGYiZnEX9ttKsssUGf1UYkHsH5Uu	10546	14852	14852	1618612560000	orphaned
20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	1402	876	382	12463	13257	jwNo6nVvVSZaakdATgHiBD2h1yqB4HuBAWrYV1v3draMviDjH4a	10553	14859	14859	1618613820000	canonical
20982	3NKAwM6fvM4dF2y1QvUGp2sQ4tjE99Zw9FdYrRZMFXVoFj6t2rNg	20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	1407	1395	382	12463	13258	jxJQJ2X4SCj2jEFuuAe85718DfUJiQDLZQQoi9eqT4KdPgvUisE	10553	14859	14859	1618613820000	orphaned
20987	3NLdZmpSQsJqvz2tAzSFMDN2ULLS8MiBb5CC72jDVUwECCphRaPW	20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	1619	1275	382	12463	13263	jx63uqurL2YsBUtPkUqqLbz4ih3KJ2B6FAW6hEmXAwoWGqwfERx	10556	14862	14862	1618614360000	orphaned
20989	3NLVBy4RP3HnwTnsq9uP8oTJ6fjZvfSVnAp2Y5ofc4HLGers72vw	20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	1407	1395	382	12463	13265	jwq2rUidzu88jDkovViXVTiz4SwnLAUGRASJY7kafhTerUHR9in	10557	14863	14863	1618614540000	canonical
20994	3NLonEYBPYsEsxCs34wkRh9KcWs9nRHDm4kxmCRxjaYq24t283wV	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1609	1087	382	12463	13270	jx71Wa4CxCd3PKoiFN3Tonox8p7a8g2dyiwuu3V324JNcr3WHSZ	10559	14866	14866	1618615082740	orphaned
20999	3NLMNXcBthpaYQVKfmXGRJKXEn5ZrXKSwcKJzJTmJHW1ZuRSKm2y	20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	1651	1301	382	12463	13272	jwrxf9zdR1HfKwDZCU8XBATBhdw8aqheXZYJFHVz3rdYiwyEjNN	10560	14870	14870	1618615800000	canonical
21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	20999	3NLMNXcBthpaYQVKfmXGRJKXEn5ZrXKSwcKJzJTmJHW1ZuRSKm2y	684	1352	382	12463	13274	jwmX6S79ybQDz3Dsuf5aCZBd9KmBCcvfgmgZQDGUQ3DNVmBW6g4	10561	14872	14872	1618616160000	canonical
21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1474	1203	382	12463	13278	jwnVKtsFNNQH4ex5MbDXDq6TYNdT7EN9CAXyuUJs4cTKQ3PJxzP	10562	14873	14873	1618616340000	canonical
21004	3NL2UDs7VTM1RLa3KzxmAQWcgZ3hXXbGYwnGqnsBwPRbcYRV2r6k	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1407	1395	382	12463	13277	jxqjPFCG8zsgrjJzDsn8wszQy7PS9TeGmBQ2tkD5wHBnaRTFnWP	10562	14873	14873	1618616340000	orphaned
21010	3NKBjmpw8ZHEgeKgsHUeQPLMJnPBKUYqPPiLSsfhvs4mbtSenQNA	21008	3NLZ6uC82XbGYXDyaTa8bxV6qQVT36bT2bpWjsun5JP7hd6dTKTS	1458	1323	382	12463	13281	jwE15PvqpwQXsjjAkAQb52bQCVCh2JpdVrbaNC1v6WDa7adeSBw	10564	14876	14876	1618616883496	canonical
21012	3NKx9FhNZNoSLu5Lj9hJ6BCxYtp1qXdhKi5qPoto1wjwkPScHapS	21010	3NKBjmpw8ZHEgeKgsHUeQPLMJnPBKUYqPPiLSsfhvs4mbtSenQNA	1656	1097	382	12463	13283	jwQqXWsJHwb9XZTsqz1jCptRZdTtqydbMS357S4Xig956wSPNXs	10565	14877	14877	1618617060000	canonical
21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	21014	3NLHbMQC2XnSS6zxGo7wYQhjtXGVuGm8u4cK2LLgupS9Yf1o9iQJ	1529	1070	382	12463	13286	jxAwsLR2qCmG3odNAweJwLxWDbyD8txxRWHEu5PCKDygdrbiYcj	10567	14881	14881	1618617780000	canonical
21018	3NKTGriW6vRAR2DaYmQBVkaBtZrXuqGENytWnSbJFqvikidXCuyu	21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	1654	1340	382	12463	13289	jxKkH5dUaw8EHiNEvqfsAteoNaQuRo6gQNY44gKAy48ZMHF5V9t	10568	14882	14882	1618617963331	orphaned
27153	3NLQ35jjNfTJ2WY5a29qLojH86Gfte1tQBLPrMD3nZSh57TRWs38	27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	1406	1393	525	12463	18778	jwxWDg4LUqQnCe6shsz9sCerkey73EbSq8MLtfYrQrh9w8pTbBj	13424	18895	18895	1619340300000	orphaned
21000	3NKW8kMCoQQpX71noNXJboWWgE4jXyXGZeNdRMz69iLeB9FQzEB8	20921	3NLAqYDG4XXqNLTkYQq6rLbRBWkwTh3miZfvPnYvubYfgq4sD2gC	1547	1378	380	12463	13273	jxLXpQCKXQKqtG7Rm9SmsunC63FkZCP8VTJ5kJnb1vb2yRXZn2W	10518	14870	14870	1618615800000	orphaned
20949	3NKWMWpnMD6DZUbK1D3q6mnoLAt2a9tntjtZyEkccA7r9U9LdVtJ	20948	3NL6j7pQuZLWkqWsMiWsrksgdmwRoJEtvH5PGWEUp6W21Ryoyqnn	1490	1274	381	12463	13228	jwYeuqRjj6Sdz7gMTdXuwUJrsJJLrksppCGob6sri3SR5Jpmjv4	10536	14838	14838	1618610040000	canonical
20954	3NL2zVCYEARZ3vc5gycdJAZvTRRe5PsTontbTLgdJsu1nN44jZHN	20953	3NKgoV5REeEPYY67K1jwzu6i8BTp4WRWpry4xJNXToJD9UQrxJsf	1405	891	381	12463	13233	jx4znx4hecZALeKgKyVaFzQLQ3KbfNBVKm9GzoWKHBY8VJZnXWR	10539	14841	14841	1618610580000	canonical
20956	3NLipWAi5zvn4gCfqfra2pC6s8HHiN6YrtpYo5RYTmxVP6Czt5GP	20954	3NL2zVCYEARZ3vc5gycdJAZvTRRe5PsTontbTLgdJsu1nN44jZHN	1403	824	381	12463	13235	jxmmg1oRj5ZYiyFQ9VPHM91SN5KvNMGxPCj7eXKMMq7whTtVTDu	10540	14842	14842	1618610760000	canonical
20957	3NK3ZybxXBrrNf4AKEw2ZVfcnyLxvUDccj4kwg6GZQ7B6EtUyaFo	20956	3NLipWAi5zvn4gCfqfra2pC6s8HHiN6YrtpYo5RYTmxVP6Czt5GP	1657	1098	381	12463	13236	jxwjAAJxQxKKybiuAzjkmzNSN9JunbeyG2pEvSa8WeYy6CWBuii	10541	14845	14845	1618611300000	canonical
20966	3NLSoX18rDprkNpUvyHVXYUXgq7ooNBSkFUvP8JmZzVu1ciuduAK	20965	3NKHmpdRMoVKESPGe2PPK75w4eyFBJpWWSNMsjUQSYyqUwQYna3L	684	1106	382	12463	13245	jw6yJ61RmEHrWw3kmztBz1Cz9jQ8msBXrMxhm98Vcr6UsECiNAh	10546	14852	14852	1618612562383	orphaned
20971	3NKriKGBEEVuai6FUftstZFWic3friC2mejx3B7KdbD6FYE97fBM	20967	3NKkwjzGYMN2poTEsHyo23jNHHnzaMHyoJ9ZjvCxjQ4sPyPtq6EM	1542	1178	382	12463	13247	jwHm7v9cdfM3V6PXdJfq8DKh9aGSpf128jHLpcvfZdKdoXadA6Y	10547	14853	14853	1618612740000	canonical
20976	3NKGSrjU9BiWs7kHb6YWwAuSbvvkU1cTUVhDqbyb7L97botMkbtu	20974	3NKvP5vy7GfeBDCKiheXqHMDmFZR8h6yCWw2siNNEjbWL6hX1oZ5	1419	814	382	12463	13252	jxq6TxGwdgTW1vw5dvp5cc64cRasdiv7ad5k8jntyXsYzpjZx2f	10550	14856	14856	1618613280000	canonical
20975	3NKk2D9ozbkqEB1MRN5NRZGKEyw6jrRim7cVhsghet2Kz2E2aM3h	20974	3NKvP5vy7GfeBDCKiheXqHMDmFZR8h6yCWw2siNNEjbWL6hX1oZ5	1403	31	382	12463	13251	jx5W6qgN17zp9XrFYRYepiZDCvKVKe3DSZpDuJFSuZspu4Mb7Pv	10550	14856	14856	1618613280000	orphaned
20979	3NLnrXDyg2aLDAZZrxRLFUjnwLz2LA6eCuz5mcdgsENSS3xrUxdA	20977	3NLXyyi6EufNT6JrYP9sJKFziWdB17hzT95f6B3rZtWCCTcx16BE	1406	1393	382	12463	13255	jxawMNv7Bp2MNEMHoydDPXLzUHArVKGGSQfPsX9Sz8m3Q5wCMtX	10552	14858	14858	1618613640000	canonical
20984	3NLjJC4wf8m5ojSmyqeueKNzkyLAferbM2Eg39iXG9pjyAiJpyqR	20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	1402	870	382	12463	13260	jwJcA9vXm6TEtDxSPpuAwyf9hRVVcTEbsfn6mGZ1n4VjtiWbEzh	10554	14860	14860	1618614000000	canonical
21037	3NLSi4Fix3GFppnpGrqRzZkTZrcXUjwdGwQpLGVqsPqz4u2nrofe	20981	3NKKCHNqSwgpsT9xSzNvxfNiHjXhgDm6chBXQmbE6wS5LKyEHkp4	563	1359	382	12463	13303	jwXkWpzgi3sQak2NahAYsF13i6qE8nHp6EhmQfCBJrnJ9nnNN52	10554	14888	14888	1618619112658	orphaned
20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	20984	3NLjJC4wf8m5ojSmyqeueKNzkyLAferbM2Eg39iXG9pjyAiJpyqR	1476	1371	382	12463	13261	jwQogScrGp952JZV4B9qKVx9XqUvS5MgeifnVxMdkB1c51G9Mre	10555	14861	14861	1618614180000	canonical
20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	1403	824	382	12463	13264	jxqhdN6sBZVEBDPLH5G3R3JKctNt4W5LNFetfcerrfzW4BvxrT8	10556	14862	14862	1618614360000	canonical
20986	3NL58ZMyosZquW7Jz7mXHtRXy3jQ883HhbEi1iC7vP1iHXPZxKCP	20985	3NLVhzRa1R4QqHTv9NXwdxFtRFzs5ZU79a1j8mtFc7HmoXtaQJ7h	1447	1099	382	12463	13262	jy2LPnStM5wNKjudZaiuBhNDTbeQMvZjezwQdApw6NZaKcHtNvM	10556	14862	14862	1618614360000	orphaned
20990	3NLxrJ2kWPwXi4rqwfPp9eRnngdzAcV7VPGUPTZKWeWo7rPzvM2Y	20988	3NLZ7bibNUadi69SofFwqtQNhdwEwcPgNYvhoS6Pz6M5S8v8DcYm	1423	214	382	12463	13266	jwg1g5UAeLi1eZGozr3kJgJFHBfmcA73aamJjbESTy5Szdvp3hJ	10557	14863	14863	1618614540000	orphaned
20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1445	1164	382	12463	13269	jxbz9MCKvsAr98zfWVWjsnFdmyrrhf9vxj5gmbebXZieKZVucr2	10559	14866	14866	1618615080000	canonical
20995	3NK8eF1gxbnG4ahioNDNzm3xCDn4kt1h9sPwJuXeVXFmqXwUriwJ	20992	3NKchNzPFRq8qYoxfCfBZRymgNBNMdcXPtZKomNQ3xXLUzaToaaz	1609	1087	382	12463	13270	jx71Wa4CxCd3PKoiFN3Tonox8p7a8g2dyiwuu3V324JNcr3WHSZ	10559	14866	14866	1618615080000	orphaned
20997	3NLL93DcPmqhDvH1ouuajCW8LBw6PEhc5eXA3t1dGiXnzsdgnMPU	20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	1547	1378	382	12463	13271	jxD3fZh4dLD83jaRDENDoiq7pxUi2ATuRuBoEehfu7zUt3Bgav3	10560	14870	14870	1618615800000	orphaned
21002	3NKkhgxpD9Ua8BbPAjsHy7YP4WWnxiV78f3P2MoM5cBebjKPRpbs	20999	3NLMNXcBthpaYQVKfmXGRJKXEn5ZrXKSwcKJzJTmJHW1ZuRSKm2y	1509	1074	382	12463	13275	jxbgCJ1neYa81dM5xpSLwCaVPnu2a32FBwCooPXrHkwgmFwywR5	10561	14872	14872	1618616160000	orphaned
21005	3NLeoPgwNHUn8orBLpNF6DeDoAqWXsStaNZrtLVbG69HuPRHMxpb	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1474	1203	382	12463	13278	jwJ5uTZ63QbjbY6FEyenQTLKbev4YTf52db2z8GhNNNz4Cd6bWF	10562	14873	14873	1618616340000	orphaned
21009	3NKdBjdcbN7i9GCsncen769vu4NKqp7f9VuX6NQ8tUtzPd5xUikA	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1489	1014	382	12463	13279	jwEBHNFJz3PN5uVySAi3mhEfi33WYwSNSPYp1nrVdPGG1LVixaa	10563	14875	14875	1618616700000	orphaned
21013	3NKdiHdnXVsr7skHzScWp7bNvzrG2sM72AarzaakdyVPaLji22po	21010	3NKBjmpw8ZHEgeKgsHUeQPLMJnPBKUYqPPiLSsfhvs4mbtSenQNA	364	364	382	12463	13284	jwRhnCGGcKmV6XtiQHcMJ7ZCZ2FHfhcTLL55ZwY2zuiiZEjWCcg	10565	14877	14877	1618617060000	orphaned
21016	3NKqvj8NAmQ9asN2DyxNosd15YNuWxzhKhTq3RJ6aXL8eLdpYvuu	21014	3NLHbMQC2XnSS6zxGo7wYQhjtXGVuGm8u4cK2LLgupS9Yf1o9iQJ	1553	776	382	12463	13287	jwF9h1J7LSiV7jRhxJ19BYeGCqsFv3WrkLZxfHPMqpCJonULF3R	10567	14881	14881	1618617780000	orphaned
21022	3NL3ZkddBg2zBZxCb9k8g4pgn5g9ukvrdZGCeTDY8EJCGE74Hxx4	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1509	1320	383	12463	13292	jwoFoqM6U6XsyaLpm2rmscvdqTwcAkSFjfBGiPmovD7LFyBScqH	10569	14885	14885	1618618500000	orphaned
21028	3NKRErhHvCoTVXYNBxZz1n6GkHbNgzjL8XmCq92nYioen6bWJi6C	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1631	794	383	12463	13295	jx8BjvF567S2X3wAyUUUr8QFFVXzxkba4tCjVA1aJ8Ef6EGT38Y	10569	14885	14885	1618618500000	orphaned
21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	21029	3NKGFiWqy6pP3nyPTWdWdS3Rq8b1vb376cHiEgLKfnkeEnufvMux	1451	1292	383	12463	13298	jwTQERGHuz87AC44xH1PJNzyXx8HAFhSNypuBfshrmsHDRocaPY	10571	14887	14887	1618618860000	canonical
21034	3NK6R8BNEoFSH9QntbLTKPmAimTfrdNakYdE4tbCu6QVWhTfwNqx	21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	563	1359	383	12463	13300	jwkSdEbtRGM72SbTbgpRFQi62f8jmnjsK48Ufmv5rsnHsJZc3zt	10572	14888	14888	1618619040000	orphaned
21041	3NL2gNWasjWoFfzTwtoY6pDDjV8sy8qPVnugGkXK4YYVdgwZ9mKQ	21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	1594	1080	383	12463	13307	jwjYkGJLJNe4XCURM3PKsSpojEXZazPvYpx2SXoMLkiuJxPB57h	10574	14890	14890	1618619400000	orphaned
27443	3NKG7UHT4fuDLad4KaqFr6YPSU1RXXCuou5e1AKZaSdnRjpQLKTz	27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	1646	1354	526	12463	18793	jwRHATgeAdkk3oYLtTP2wJKp9FwprYcdDHbyhJ2kpw8kJ8GvXf5	13435	19095	19095	1619376373372	orphaned
21061	3NLWHvz4bbbiuoraBWCu8cBFu2PLi9bsoN56YBUNvPjARrDSs6Yt	20903	3NLhKz3Lc4xZRUdvr1ABRStFR4i6DZHxawedbFpzcPctnpQcSQxA	1593	1220	380	12463	13326	jwtyXWmntd93bzuxJ2qX1we5z7q6o5LYDwMXHH6s6f1Jwdf46mc	10507	14903	14903	1618621745176	orphaned
21036	3NLMGrjxDJ3Dsib4cjt2ALQsg4MzM1c9AJKVCJPJ9aBbYZX8tWYY	20946	3NKCypok4j3uNXPDqcygLv7yNmRphXMLvfieDLhJW6PWreuTiQLq	563	1359	381	12463	13302	jxiiWEexiy8Sp74es6d4YbwamQr8AfppDBSViWTH6cJqtBRb1Tz	10535	14888	14888	1618619047530	orphaned
20998	3NLdyH1gPDcTDejGwSgM2xqeWffJ7vSyAArcaxU7SLWtzgnMeywX	20996	3NLa6pFV755F2iy1C116wKe7cPZdedA4xr4dSgRw7EMFvSvd8PnK	1651	1301	382	12463	13272	jxJNixesYPAEvbUmTduFk12nxMwN1w8w7jkDzpcDhRh7HouJB6d	10560	14870	14870	1618615800000	orphaned
21003	3NL2qLLyE3JscgPt7FHkNuqAgrimM8hknULLkjY8zALUw3a2PyEP	21001	3NKSobo5hGHXpajaKFAZ7koAN7vpnyUiea21mLVqh5wugL9Dq7cB	1402	862	382	12463	13276	jxLqrcec7TaPXi7NqdV5qk4XX9g1ZJmfj5JSvWFa3Crhc1yezTT	10562	14873	14873	1618616340000	orphaned
21008	3NLZ6uC82XbGYXDyaTa8bxV6qQVT36bT2bpWjsun5JP7hd6dTKTS	21006	3NKXhg2jHpnrm1SAcsz3TjJCGUgamSPekPdCLgaCBqqqyd3CQeVh	1555	1347	382	12463	13280	jwChsXArVvvHaXPjuABRF3LCxDRgF2ovsbeLUDHLg9bJHcDk914	10563	14875	14875	1618616700000	canonical
21014	3NLHbMQC2XnSS6zxGo7wYQhjtXGVuGm8u4cK2LLgupS9Yf1o9iQJ	21012	3NKx9FhNZNoSLu5Lj9hJ6BCxYtp1qXdhKi5qPoto1wjwkPScHapS	1571	1089	382	12463	13285	jxmH4cMqc8SQ4Ny51ffL3SyCF2rBzNejmok6tYyFeimm8eNyibX	10566	14879	14879	1618617420000	canonical
21020	3NK5k1fckGftcKNd1P4V6TXiG5ZHUFB7tLqthZDLTVqyuNMDoccY	21015	3NL3mqr36H1qubkkSkKZ3dJDgV1igySaWGS5rUT17AZZBVAhWXeM	1581	778	382	12463	13291	jx8BdJQaM7QSzZcFvDKMhvzG7LyU8H6zG1bRvkPGorfaXAkmDAC	10568	14882	14882	1618617960000	orphaned
21024	3NLVoBCerxR7ac7gYgETNpAtzoacEMQo4bcz8ZKwCVxnhmeVcUVQ	21019	3NL7euKQLWdoE9nBiskcRJbq5wVkK7hjGvK3WGpSMdW3kBVjAHqY	1509	1320	383	12463	13292	jwoFoqM6U6XsyaLpm2rmscvdqTwcAkSFjfBGiPmovD7LFyBScqH	10569	14885	14885	1618618500000	orphaned
21029	3NKGFiWqy6pP3nyPTWdWdS3Rq8b1vb376cHiEgLKfnkeEnufvMux	21023	3NLEmGfnMTVsQcJ6kTRbLRd8bamysyFYsLFKeB6q5aWtGyaFdyEP	676	676	383	12463	13296	jxTrbuSTDJpgiz3YJibyFkErspmm2H9cn8Lsmnqc9Jf2bXnJmMQ	10570	14886	14886	1618618680000	canonical
21031	3NKHdQtRLYyDgXkwKJmqpnsVWWwwMbbRzgiVhGmRiBi9EQWvreMX	21029	3NKGFiWqy6pP3nyPTWdWdS3Rq8b1vb376cHiEgLKfnkeEnufvMux	1451	1292	383	12463	13298	jwTQERGHuz87AC44xH1PJNzyXx8HAFhSNypuBfshrmsHDRocaPY	10571	14887	14887	1618618862546	orphaned
21035	3NLxSevxzaNVByEoPiQGqj7JoUskYMtS82YVuDqYaoPkLEfYSn6E	21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	171	1128	383	12463	13301	jxkkiBZaTmvvPJGbgRCehpj3ZSVzRsLLH9ojcbFz2H9KW31m24z	10572	14888	14888	1618619044531	canonical
21038	3NKwwfDcMkGcuLvvmaPrPaneUhD4uGkSwjcDdfepGnhAr2xsYbNh	21032	3NL2n4rhBirgjMkjsXkqWsx4ygaYt7gdKWk9adeBXXdmX828h5uL	1631	794	383	12463	13304	jxcRKVZqN5fE2HFJwED2yUGWoN3XZbtz95cDdA3AAu5ixD5Ace8	10572	14888	14888	1618619040000	orphaned
21040	3NL64KVAiYUXM8C1esv9bs4FB2crCwhRYEYPxXVLZmLtbbueZD5a	21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	1460	522	383	12463	13306	jxDAB3v16Qdg4jcWA7hLR1posantyi6xPSZo7oPdiZpXk6rbgzM	10574	14890	14890	1618619400000	canonical
21042	3NL62tkNKbuWDk1BxSQAw2iBeigcWA4T53crUyhjVvr9HySo2PUw	21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	1403	782	383	12463	13308	jxsU7wW129gEoXzeRXYN9v5NSH9xW2Dv7eBhVrkDS8MhHDFVG4B	10574	14890	14890	1618619400000	orphaned
21045	3NLiknDSwKapUebgAT8aFjb2hY72jQdFUGCjXC2eJfr8wvf5xkf6	21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	700	832	383	12463	13311	jx8QFKKWmdFDbqVt3uSsudPZ3RzdctDkdqXSagtfUZRJKiF7iTf	10576	14893	14893	1618619940000	orphaned
21049	3NLW9qXtgKeQQzAYaZActfYg2wyYEh6mWaeaojAzfJy2UxeUWbPr	21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	1581	777	383	12463	13315	jx3W83gTcJ3gvduY4M9wmwSgGNDgGxXNtVcnRJLnPoH7gKhH8JF	10577	14894	14894	1618620120000	orphaned
21047	3NKZBrWtfnUtMg8W4KMBUnoncN5rFSDeVyipq6R5V4DJyWV7KS2W	21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	1407	1395	383	12463	13313	jxwTqSW2sx4UBVUsrVw7TxnjfazH88E94fWZT3AUFi79Pcx1oVj	10577	14894	14894	1618620120000	orphaned
21052	3NLkhYg1UNjP6ssmGGpA3sPAhdjRYuv7X65HDNTmqXKxs8w8MSUy	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	1402	868	383	12463	13318	jx5emGtUmQ75FyvDJbjo3ZzNjQJLWA6QnxCMYu9yA1sDmrzV6Qx	10578	14895	14895	1618620300000	orphaned
21053	3NL17ikgZSPHkoRJ2oAikc7LTaKmuzaJeh3eSBQEL3vbSFxYiXL1	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	448	1305	383	12463	13316	jxXJ4t1rMA6sqWfbSZJQhTLXFJYC8JR1eEWAAbzhnoUCYDPnR2k	10578	14895	14895	1618620303380	orphaned
21054	3NKp11PXSyuKK8T8FMjJjSJkDz8bmPUPb8Q6G9x84UKhW55zPvt1	21052	3NLkhYg1UNjP6ssmGGpA3sPAhdjRYuv7X65HDNTmqXKxs8w8MSUy	1460	1324	383	12463	13319	jxodnGcHk68EWH1kifWk3cH7jPMFu4M8gMGaUZgsHM4rYfw7gzk	10579	14897	14897	1618620660000	orphaned
21056	3NLErh6Sw5mam6xXZ6tRAcpYCiN4Q2TZRTzstcdfoFLRNArnbB4K	21055	3NLczzTnhQ2sKNebLXHdAtkzmb9Q7UnrfvRuvNRF79ezPzkbLZx5	1648	1284	383	12463	13321	jwMHedymFQq7AtQqaniUW3iR4YD75VujSiunY8cbwcwRsa7TYjP	10580	14898	14898	1618620840000	orphaned
21058	3NK7cTKNxG6SA422N6Knc7heEz2vEEJk2GzeeoGWJtRAdgU2gkZL	21057	3NKwCkx1TVP6iemfwFsQArNipGnyMGx962m6djP2J1Wz3BdGguqP	1637	816	383	12463	13323	jwg4MSMRks4tzgQoJjLxCYRwKZkh1qGfcuE3gQJHchGRFSZzhby	10581	14899	14899	1618621020000	canonical
21059	3NKc6rjGeiV5g6zx9unSivdu7FkvyTrbKRwNrtbTU5Jw8ruKPquG	21058	3NK7cTKNxG6SA422N6Knc7heEz2vEEJk2GzeeoGWJtRAdgU2gkZL	1637	816	383	12463	13324	jxi8MSwwAmyCTp9659YFWMUUTSB6e8LDLHUY2TXvzGiR2vzdCpC	10582	14901	14901	1618621380000	canonical
21063	3NLsfYZp3o7xZwGtuFFBwR1cQG8LfFGH1sc6NnWi2Zpm3N9c95fJ	21059	3NKc6rjGeiV5g6zx9unSivdu7FkvyTrbKRwNrtbTU5Jw8ruKPquG	1593	1220	383	12463	13328	jxvvPojM7p5txWh5otv5xQijhAtf2NY36x2wrQSoRaBY4Z4ZGLB	10583	14903	14903	1618621740000	orphaned
21067	3NKwHzGdVP8cQA2b8ZHV7dicmGARPphaJ4fvETptoGDM6zEzpdwa	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1588	1392	383	12463	13332	jxESAWs6wwJRuYYeXwiWHnnLHXujiq1AYc2uipSkv4u6DVXtpv9	10585	14904	14904	1618621920000	canonical
21066	3NKVrFDvGmY9oGJeYwv99TZwJ4aorbFxbKwttD5187f3CTJPG1C5	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1448	945	383	12463	13331	jwLDpn3ZAc4z8mxQwitdL2LbGFXBvk42vA4cKR6J65ywCaEBU93	10585	14904	14904	1618621923280	orphaned
21071	3NLQW6GEL5TftXiBW62VGTSj5cPAPx7SYXLHutRbiKfLe7FiYzHq	21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	1609	967	383	12463	13334	jxmeP1CSZuWBnEmkRU87PoQibhbcQUdbtLoJN7QyGSU1zoZT2E4	10587	14908	14908	1618622640000	orphaned
21074	3NLipNnyJ6dy8rMR21y4UNozdV1Qg4ZFYFrjKLGP3QjDwDApjHny	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1407	1395	383	12463	13337	jxoVvXUFiWFLAKB2PDp2Ej8oLJNLaRV5MKwcJjZJY5ZjVvt8TER	10588	14909	14909	1618622820000	orphaned
21079	3NKdzKeMeThMGFoNDuqzYeFZRvkgCnN49FbkdeBKeC7qMfqpad2U	21077	3NKqUXoz8eSfEPn398twk4487Nn19LReVCqcStZUUAhQvHEcRGBn	1646	1108	383	12463	13341	jwKejCozLv2D1JdNqvZceBDSxryuwERW6EXmpeZbhGcKsA4xwLx	10590	14911	14911	1618623180000	canonical
27577	3NKptLPSVL5U7Bx2RXcTGRaafsXg1UBbzdPA3LHktG4fgb8RsJHZ	27423	3NLMakFKFyUL6bSXJxWhBrufshCTD45STEEaD7D1tNW9pwxVSVuc	1631	794	527	12463	18906	jxXstUsgutCFeKt87XGfA3zy91Haa1GeLjyi4EWthgUrk4cHT5w	13437	19191	19191	1619393580000	orphaned
29163	3NKJR9JYyoANLk33njNryrwwNseD7uFJuNYPxwsk3M15D9sFeh9R	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	1527	182	572	12463	18974	jwiiDeMoqgYHYq5JrYXFVMTXNTbcfsuqbXF5ND7bzheNVfkwrj5	14380	20252	20252	1619584560000	orphaned
21039	3NKPeTi7RrfF2ASj3VYBttbeYVsggUtM1Rrvy9LjzKsiCkSvkZB4	21035	3NLxSevxzaNVByEoPiQGqj7JoUskYMtS82YVuDqYaoPkLEfYSn6E	1406	1393	383	12463	13305	jwtKaqnJ2FreX39qTTNcCG6csZwviJmnUspLCnRNqqsuiEiJJfy	10573	14889	14889	1618619220000	canonical
21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	1406	1393	383	12463	13310	jw8QBF2wLsCgySd8PYTdormLjFZJS1P5qs8XpqrjyAEkrvCB59V	10576	14893	14893	1618619940000	canonical
21051	3NKiTADXHUATGCAhjuvkVBnMjAoMTiiXhJj13xnezuXYZuJA58cb	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	1637	816	383	12463	13317	jwzzDnubtwm5Lg5bco6EDFQHBoztajKWrdw7T6XeYa5qR3YJ3Sx	10578	14895	14895	1618620300000	canonical
21060	3NLruYEmX3uHusM5mFdmxMYkTirui5AMeB9tKcHBfA67T54Rt6BZ	21059	3NKc6rjGeiV5g6zx9unSivdu7FkvyTrbKRwNrtbTU5Jw8ruKPquG	1403	824	383	12463	13325	jwXYo5gLQi3eUbP4auVk4DDdzrazcBbTPUhbMSU9CauGDfdkBqT	10583	14902	14902	1618621560000	canonical
21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	21060	3NLruYEmX3uHusM5mFdmxMYkTirui5AMeB9tKcHBfA67T54Rt6BZ	1581	778	383	12463	13329	jxGKh528yHE9aaKLKKxmaW7B9xJmf9MkjxurjgPVWgrVPzSTozX	10584	14903	14903	1618621740000	canonical
21062	3NL5wruVcad8tdWNWgRLPptC9aaXDD3brxvVgznLbJsSZPZZAjkC	21060	3NLruYEmX3uHusM5mFdmxMYkTirui5AMeB9tKcHBfA67T54Rt6BZ	1407	1395	383	12463	13327	jwH3U5t2qpns6YXndxfenuUQ1tGhjtzwRdCxCyZxK2mfuiatRdR	10584	14903	14903	1618621740000	orphaned
21069	3NKvDjxFDNMW4FfupKeED3N5KqSbuvakZEgcfoVqQVySbb38Rq91	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1448	945	383	12463	13331	jxNBQEipWgh2uKVBdziV9r2soYkhVDXStUawHLFYJ2xMEMhfKwU	10585	14904	14904	1618621920000	orphaned
21073	3NK9ThfUUg7DLQZq1xFerRLAsACjUkbFv5K98x39o4dWUfSEimq7	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1648	1038	383	12463	13336	jwV4zN8CzMULym9g4cXJFe1cNC4UYhErxMNz6QXLXzeYEPNPQAP	10588	14909	14909	1618622820000	canonical
21081	3NLTtC3oWNm5E473C6VLTRxoWPCVvU1DJBzBZRnGiN88ypZwfBVn	21079	3NKdzKeMeThMGFoNDuqzYeFZRvkgCnN49FbkdeBKeC7qMfqpad2U	1553	776	383	12463	13343	jwDCAsfpzWA9hYXtp5qhH6LKSmtRWcHSynzCxWEwNffzmtKTtWh	10591	14912	14912	1618623360000	canonical
21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	21081	3NLTtC3oWNm5E473C6VLTRxoWPCVvU1DJBzBZRnGiN88ypZwfBVn	1516	1294	383	12463	13344	jwM44EcMbSsEzYEZqHP6YCpyaYnFEZwhchqayzBQFiDPQ2Yu92i	10592	14913	14913	1618623543398	canonical
21084	3NKqnVm5WYtuVdwdVDJxaFtnsHn5LbBFGLFosiqmRbpupd2Du8wn	21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	1651	1301	383	12463	13346	jxAttThm44M9jD8Z9pCpb3MRDThT3Q1FYGBN2atupS3LUy8mTBw	10593	14915	14915	1618623900000	orphaned
21089	3NL9KeRSDU51F91GU7hbNZ26ee9hSBnUvJ1LxuwP9rp9QoSYavq7	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	532	937	384	12463	13348	jxeLsXYRo1UdhC7E3dMuC9SjKQuf67Q2XjsKP6YyWLLwDqEUMJM	10594	14916	14916	1618624084430	canonical
21087	3NLiXynUfxCHmGMpRpjHzA5jYRg3Rm16T8xhk5H1kEBJuRZ2StEL	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	532	937	384	12463	13348	jxeLsXYRo1UdhC7E3dMuC9SjKQuf67Q2XjsKP6YyWLLwDqEUMJM	10594	14916	14916	1618624083039	orphaned
21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	21089	3NL9KeRSDU51F91GU7hbNZ26ee9hSBnUvJ1LxuwP9rp9QoSYavq7	662	662	384	12463	13350	jxaFMFxjRbJqNkCmcskJx89vgN3pPQ7UW7XVXToeNCJmYw2Q7DY	10595	14918	14918	1618624440000	canonical
21093	3NLb7QMw2e38GiqdqMhnPhXv9J5n17yPzgU2GBKjvQH5akk7uveb	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1523	1075	384	12463	13352	jxH6QuUebK8y2J9G2a1iomaMiH8UN9qhf7pcR9oHTaCjjGxeY8u	10596	14920	14920	1618624800000	orphaned
21100	3NKS4X6tQA8CqB2NqNJtyfQzHaQ62AifEzwiY3GnS1yCRPX7kvM2	21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	1549	1362	384	12463	13355	jxG7WDVfjKLxi4y1NJ9RPLtoxPRCCqv7wREG2YzGXD9SF4mfWiY	10597	14921	14921	1618624980000	canonical
21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	21100	3NKS4X6tQA8CqB2NqNJtyfQzHaQ62AifEzwiY3GnS1yCRPX7kvM2	1637	816	384	12463	13357	jxtRHRcuKHqaAfKWL7Eu2jV2f2yRJ8Zt4DvEY3UansEa5XrU74r	10598	14922	14922	1618625160000	canonical
21106	3NLvADqRqcpGHdbEmwPN9yLXDHbiQN5P3oCBku3xkcEaTxbccPNU	21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	1403	824	384	12463	13361	jwjMSJynZCwmVFutSWLtgRVJ4DEsf2WUUYV77EFXQDbpGT6SxWz	10599	14925	14925	1618625700000	orphaned
21108	3NKJR2T89gNcq2m2HoKp7nNoZZQmqMKtXiT2t18Zr11hbqngkYu3	21104	3NLaZVZxp9biPg1tyaKGBNPjfgknMB5e1BavwPezWMwJTW4v2Beo	1406	1393	384	12463	13363	jx9nvKFDhjuKetgaQVzoperw1oqGU1BmCrEon8E1EXY7RArZdbN	10601	14926	14926	1618625880000	orphaned
21111	3NLvKqCGUehh64B3e1KdH7WHtFcovziWtEiTSmtfdazJyNujuRUW	21109	3NKQwrxZv7S3DvT4qdddLhJyTXhu39nbYjb8Yd1xYePZnfCXHv13	1406	1393	384	12463	13366	jxRtwTTW1XypF86GcCvG9hT4GasgzUbVi47f57NbUFywGaVFieG	10602	14927	14927	1618626060000	orphaned
21115	3NKxGcWTUWwUiV33cDetAX3DZbprLgEuVMJJZHn5xtQ555ADWZs7	21113	3NKc8woWPssBLWBLVm3fQ5QqXkgxtZtsv7twszksLh6senf6ceo1	1406	1393	384	12463	13370	jxMZmrQzJCKsnfSNmjDsUWZyCKSyiNnj4nDiJgWHiPqjYQbqogh	10604	14929	14929	1618626420000	orphaned
21117	3NLscUmSzAbitXAiS9GfFT12rGzbcWNhw7JJWN62sfR75hkQL8rZ	21116	3NK9YafPiXreJ9zU6yCdk3pGzDEPB67wEKqnQhW5QjRmDkbc4KjB	1403	824	384	12463	13372	jxAGj7wckM51qhHo4cQkJ6rYSvYEEEffM6Gi1GXhy1LDzkBau88	10605	14930	14930	1618626600000	canonical
21120	3NLWxJ3MmLxx7wL89xgmQsZBcdT8USvfsaBH3iEazVqVqEDTbhqf	21119	3NLPR8hoFCxSrdSvH7PYBW7vC4qsS8mUAzN6es1gchoiydL8bajt	1587	1111	384	12463	13375	jwduQG3ceRXfa1g9Y3u1W9wHbshdk45632dNXLmdVj1NKPkABRR	10608	14934	14934	1618627320000	orphaned
21125	3NKmTBRj2SsNg52PrfqAK6Z4kMa4RGwrwXZibaMN944VdrMQNx7f	21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	1631	794	384	12463	13380	jxkXcTmeJ46yznDZVtsF57V5iFZmxZYYNz7Gv6WLJMshFZ3tBQ7	10610	14938	14938	1618628040000	canonical
21123	3NLZgPLcVh3pfVonaJmhWawYdCyd4KaD8933T2LwsqqiXepwacBh	21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	1483	114	384	12463	13378	jxcNo2H2tX3BFA6juPck6Tm17keDSPGMyrCS77AzGAdP9brk7xx	10610	14938	14938	1618628040000	orphaned
21130	3NLLjYE3fCq6oYEtQymsaSQFUPexQXrwitJJXLYkfDRfjye2Haar	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1588	1392	384	12463	13385	jxqGyRgrWeVozUSguxiMY1VK1nR1KnJGSPFhBJXyjyVm77rZPrf	10613	14941	14941	1618628580000	orphaned
21135	3NLAY9Di6aj9FJcq8gWB3MREim52k9PxTPhPqXx64umk6DyutYQp	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1407	1395	384	12463	13390	jxrkd7gBCXCYDuPychZ2HMkJ3GxzmW5b6nszhp69nuFR5FJndhH	10614	14943	14943	1618628940000	orphaned
21141	3NKq3e1fgwdZF9o35LY4zDP2JEuZtt38Taj368ys6ixTYMGjJ2td	21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	1489	1254	384	12463	13395	jxo3jwVJS1CozzjtjBaQK84BKbJuebnWVhvGafhJkozAKjrsCrV	10616	14945	14945	1618629300000	canonical
27184	3NKjJegcUcRGyXZ5tFERK4BLkAcwQvzZyMfkLsA9vX5gEBDsHUUy	27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	1483	377	526	12463	18807	jwJmCD4XBexFGCFq4E8trBfhfVP3N6apv8b77G5B48EiFtSfgjJ	13445	18921	18921	1619344980000	canonical
21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	21040	3NL64KVAiYUXM8C1esv9bs4FB2crCwhRYEYPxXVLZmLtbbueZD5a	1444	1381	383	12463	13309	jw7sTVUsQSw8c83a91R5sQ21TnJEDCXhgwUGKQGQnDy5fCExqRq	10575	14892	14892	1618619760000	canonical
21046	3NLVxxVjNH78DWta4PfdeJd7YoJXjNKYJV3VkTujj95JEZ7Mdjvj	21043	3NKqDWjJUiYd4TRvJ5tBMUDmWSxCHiBhbZzFh6qC1WrNbwTFuLnT	1631	794	383	12463	13312	jxSv7QAQj7ubRtghLh6RiR9jPotsWZQ3PPRHm3wtBYN6K4sPkLU	10576	14893	14893	1618619940000	orphaned
21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	21044	3NL1RgzB8A6PqLVKjM3XQWdyT4h4qdGBbwNAUMpuaB6BonZDXtH1	1405	1	383	12463	13314	jxKyf2F8Y8A6hL9a8ZM6uqRE3HT2A1C1uZNUM2mmwYMWDcQW6n7	10577	14894	14894	1618620120000	canonical
21050	3NKyWTbsBnfHCy3tM9Q7kf5kg6GfYiRRxGoT3V1MZ35ZZWRCroiQ	21048	3NKDsVZcyxYQCcHFDxsW5rNt4NVTGzDz77yauU24Zgv84xrB8MBK	448	1305	383	12463	13316	jxXJ4t1rMA6sqWfbSZJQhTLXFJYC8JR1eEWAAbzhnoUCYDPnR2k	10578	14895	14895	1618620303246	orphaned
21055	3NLczzTnhQ2sKNebLXHdAtkzmb9Q7UnrfvRuvNRF79ezPzkbLZx5	21051	3NKiTADXHUATGCAhjuvkVBnMjAoMTiiXhJj13xnezuXYZuJA58cb	1403	824	383	12463	13320	jwF82XP4jH6buNfsKuPjnbJVjQzL3CP5W2Xp2VYp18Rq73o2X98	10579	14897	14897	1618620660000	canonical
21057	3NKwCkx1TVP6iemfwFsQArNipGnyMGx962m6djP2J1Wz3BdGguqP	21055	3NLczzTnhQ2sKNebLXHdAtkzmb9Q7UnrfvRuvNRF79ezPzkbLZx5	1407	1395	383	12463	13322	jwXzyC5Kj9TrVndPWJsRNXJp72LYN6jaxjebkkm4z9gzBnxReDm	10580	14898	14898	1618620840000	canonical
21068	3NLhFjL1j4c4eHUoh9WHPUnabzTnewDHQdzCX5PECEumfWzBnYMB	21064	3NKvHE5pLH9xrgwqmgVzwrbj1TdH5GuWKSH4ypovyZb9mX642nAf	1448	945	383	12463	13331	jxtYodPVrphHuPbzy6XbnXh9x28icZBPjH7ETti4eMFLRkcs1vu	10585	14904	14904	1618621920000	orphaned
21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	21067	3NKwHzGdVP8cQA2b8ZHV7dicmGARPphaJ4fvETptoGDM6zEzpdwa	1637	816	383	12463	13333	jxKnus4P6DjYkseFv4ozovsT9VdRCBzvg4deURoCDjBZVT8SSXg	10586	14907	14907	1618622460000	canonical
21075	3NKbdKQibRPC3hKffW4ZAKfCFFZUUCMhjS1hWSca9vqSW7KjAp4n	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1651	1301	383	12463	13338	jxXbjCTrpY1J3hAsbC7wYaKu3wytL5Xa6S84ZR4gdyphXBYVQyR	10588	14909	14909	1618622820000	orphaned
21085	3NKnMsSRFf3PJF93VGu2gW7toHLGCJYWGRxDbQ3LAmtn6Ect6r3u	21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	1651	1301	383	12463	13346	jxidbdD5Mg1P4hNMoLEqb4fBQKYTKWiQioGQraw4hUT24qxenic	10593	14915	14915	1618623900000	orphaned
21086	3NK9smpzMuwxEnCEofW6eTTarD6UDwLXCutYuqhXPJnRVZPhWnhK	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	1546	1093	384	12463	13347	jxXa1kadU1h2zSPKj6FKsj6KFJbwMD8bG9V9CkCfYxgf1PeXZi9	10594	14916	14916	1618624080000	orphaned
21095	3NKmpMnusLFyuw8phcicheumZtbkC8nmxiiPuMLPK7LBVm9NpmXk	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1451	1046	384	12463	13353	jxztECFTwZff7NSDDTpkMPb9RWioQaSLu6xfxhxnGQuc4WMirzH	10596	14920	14920	1618624800000	orphaned
21098	3NLCtgLniVYcdAhcBWwrcPF5tNm3hjsE37JdbyMRMQqcAJrr8RDm	21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	1549	1362	384	12463	13355	jxG7WDVfjKLxi4y1NJ9RPLtoxPRCCqv7wREG2YzGXD9SF4mfWiY	10597	14921	14921	1618624983127	orphaned
21102	3NLrsE1CjXPBNRnMEkAshbpsRVkYNxBuscgisRszUUpYte5yHW5L	21100	3NKS4X6tQA8CqB2NqNJtyfQzHaQ62AifEzwiY3GnS1yCRPX7kvM2	1631	794	384	12463	13358	jwUekfm6D7pfovkBXUTBp2WxDtUWETYBS19dwnCgZcftjoX149Q	10598	14922	14922	1618625160000	orphaned
21105	3NLp2JPkDBCZJsPKH4bt8HR1jPDFxx2pLzEDUoV1sqKRLoqpkdj4	21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	1448	1185	384	12463	13360	jww25rR8pQFQxE2eQzXA7skvJumwGfVj5PZxZuKMyf5szg2NWg8	10600	14924	14924	1618625520000	orphaned
21107	3NKDAfUR6q6eQ7wFQacY2HLqoP349pQ5VpPojpw2o8jUtiRbpQT4	21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	1403	824	384	12463	13362	jwA9JLAb5ohJh7ZBeHAxPC6wLFkAMr845KJ3Az3UDrS7M3jbdRa	10600	14925	14925	1618625746358	orphaned
21114	3NKP4kwBLnJZy39pnPUWof2WX2X9PsGqyVFooFmdRtBJ2jTHLJYr	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1446	518	384	12463	13369	jxK2sJqfNH57eTRSsw66c7w7DvEhuZgs3dVQ9tdWM396bnQnQRD	10603	14928	14928	1618626243606	canonical
21119	3NLPR8hoFCxSrdSvH7PYBW7vC4qsS8mUAzN6es1gchoiydL8bajt	21118	3NKnAE684LWZR7bTcQDkjfh2skTFCJKywxABpux1XWEzUFSjkv3T	1477	1104	384	12463	13374	jwY2yGJuC8pzbxKVFEuqEtWhtMSuywgqXmren1AYY96DyAsvsY7	10607	14933	14933	1618627140000	canonical
21121	3NKsozhjWSeeD6CdAHFhSkWp1BZgUsAgwiD8duvaAWzgqvgw5vtN	21119	3NLPR8hoFCxSrdSvH7PYBW7vC4qsS8mUAzN6es1gchoiydL8bajt	1403	824	384	12463	13376	jwnAQjtrSyexfirDWzheFYoDUaJpYJ34C9Ays5Pd9W8P1V8QnAz	10608	14934	14934	1618627320000	canonical
21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	21121	3NKsozhjWSeeD6CdAHFhSkWp1BZgUsAgwiD8duvaAWzgqvgw5vtN	1501	1360	384	12463	13377	jx3uxEXurV8AhmUecpG8tM7NT9vUBkRJdVWLJzAUVUtwiALxLpc	10609	14937	14937	1618627860000	canonical
21127	3NLnrDhovCyzC3Ah9NUoH4XLbryqexsPHhLQoyv4cP2SenrD3dTB	21125	3NKmTBRj2SsNg52PrfqAK6Z4kMa4RGwrwXZibaMN944VdrMQNx7f	1406	1393	384	12463	13382	jwAMaLRBHeFckM9dcfkKZBHEbjTKkgfwGLNtANiMcmzDws9KGVd	10611	14939	14939	1618628220000	orphaned
21129	3NLPFEVKUhsraqXhxm5wkAtVrd5cwv8iNBLv9A7rRHZzxjTBW2Hy	21126	3NKjLAQkSfZHrcv7sDWVFzay4J7sS9RQHNckrGBdgsPUJModf4Ra	1631	794	384	12463	13384	jwksA69LXTxc2KHirqsbYrMnHMevpK4qBvNuy9kEmgbbeZUVsME	10612	14940	14940	1618628400000	orphaned
21132	3NLkrp8Koi1QumiePoG8aA3AdWWYdF6fK5yz5k7sEgENBD3yRQyg	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1407	1395	384	12463	13387	jxtJKEcFruqfhFXn5W4M7MPQdCgarRAgwX9La9dEYgph9BMhcfz	10613	14941	14941	1618628580000	orphaned
21136	3NKzakvyA4KFSKTUtsFUhovmcrF7ZCo5CeUQwzBHafdtX6GB19ka	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1611	1215	384	12463	13391	jwcMHJ8kaoxnKNPFTRc968ZMiUzrrmGUzrCGKQH6HR1GeMbUBxW	10614	14943	14943	1618628945082	canonical
21138	3NKngzYvbFMsa9TNaBDxebHoDumrbcUjMH8tfqRhWDiN3mknTZ5q	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	1590	1300	384	12463	13392	jxrLESu25Hw96V79v79ymrk6vQC6MzfTJwKpDBNikdw4UxGiqpY	10614	14943	14943	1618628940000	orphaned
21143	3NLNR3nt3NQ4hZjJASm95bh4dmB4rma9dp9XMTaPmLiqgZjeSe2p	21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	1407	1395	384	12463	13397	jwRa3M1xMSybunqfJDQMf2p1M8btBMcvGapP7XubCegHMjop6he	10616	14945	14945	1618629300000	orphaned
21151	3NLUJiuZVvJwYqZCunAVPMbj7KF3YMYAq8vfWPs4SPAnVPQSr1fv	21150	3NLYvtfh4Ncvqbkpd3jq6z3UAbxQQWeSM4aEYzatjAqdpXdRpvGu	1553	776	385	12463	13405	jwj1aT5CSpZr5VzK2bGkusfQ11WvmVTL3ogKn7PZ2dTZoJyS2ep	10622	14957	14957	1618631460000	canonical
21158	3NKuBZKND6TLceuLYTN4DM9bAHfdkSnM1Q1NvkUgdef6WBaR4da5	21156	3NKAFnentx5n9qPaX4n569kNN5mHrUHxpUwQZ3QHajhMxXPWVWHb	1501	994	385	12463	13411	jwk2NnJT41m3jjBouyau8MPkQpbUETZvHdPN1ha6DYX5rnt3iim	10626	14961	14961	1618632180000	canonical
21162	3NKsedDCcNRA2j8bqx6dCLFpFhNjN95FMh3nmjNy4n4m3h1k8vAp	21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	1407	1395	385	12463	13414	jxbzzkpBpTryFL9UCiEuXgF7Yg7E2UgDCA2p8SFVdrjsn2qj5TB	10628	14965	14965	1618632900000	orphaned
27226	3NLiwyywxqy9Y9dn6EZGD48duoE36rtHz7K9u2S6y75S8bhhVtWo	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1670	1282	528	12463	18845	jw7cq5ovZ4kfzN1oi85qqo3QUkPxiaK1vRq9V4xXNjsAnXArt37	13463	18951	18951	1619350380000	orphaned
21092	3NKJtatL9XPYHkNEPqg8o2U5CuQb1VexPsHbXCXasGcpSeFoy1US	21053	3NL17ikgZSPHkoRJ2oAikc7LTaKmuzaJeh3eSBQEL3vbSFxYiXL1	1451	1046	383	12463	13351	jx7JWg4PwXkVjtvQAejrL9tWR3gvajYw3A7SbSYxknvcXJYPUc5	10579	14920	14920	1618624802997	orphaned
21076	3NKb4Rn7CBWkcMJDX5qBAcQDnSzymJrDkps8GByARjBrUuod9Xxa	21072	3NKMXz9dqyWz18vCwaqvf7GSZCnUFGeK4hxRrreQ1yKHXAfPTkNC	1651	1301	383	12463	13338	jxv1xVEXRBVzSQYwqLfircLrofR16iFwfheVQ5jkzQC8Qn7c9kP	10588	14909	14909	1618622820000	orphaned
21078	3NLogQSznQ5CGqDDvnhAfJ29RiWq6erT6EmcXghQ2JPAotTHVR13	21077	3NKqUXoz8eSfEPn398twk4487Nn19LReVCqcStZUUAhQvHEcRGBn	1555	1347	383	12463	13340	jxhfpWNPPgV1WyrJaoyqD71aoyu6TX5QUwRdUxw4M6yn6UaeNV4	10590	14911	14911	1618623180000	orphaned
21080	3NLTptuiA1ymdfYRLBgB5WmGmRq2xm9pFBegtrWJMG6HScBhW54f	21079	3NKdzKeMeThMGFoNDuqzYeFZRvkgCnN49FbkdeBKeC7qMfqpad2U	1407	1395	383	12463	13342	jxKjdatCeLP7kyet18gnyXZNM6824TxDZ5if4xZLAkXPDzbvZiH	10591	14912	14912	1618623360000	orphaned
21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	21082	3NKxy5jRPKXqQU8u4BVQGTdF3F6mAww188uHVW5CRC3an3gtx5mD	1406	1393	383	12463	13345	jwMPezjMouwQUKsrRUdbjVezVLFsZHUH7PcUkPt5kdSBNqLEq6J	10593	14915	14915	1618623900000	canonical
21090	3NKSx4pCoCiCon7aHbpCzEMJnhbwxSrF5BUjezt1m4QgQNpgUKbP	21083	3NKzgPrtM5iJZXQP6MxFZvsYZcfKAsvFR6HbZ2heTxFg82qcxqSv	532	937	384	12463	13348	jxeLsXYRo1UdhC7E3dMuC9SjKQuf67Q2XjsKP6YyWLLwDqEUMJM	10594	14916	14916	1618624080000	orphaned
21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	171	1248	384	12463	13354	jxehWmjpBc9vx6SrRQKLC7EFrR5ozP9WHSJS4WU644jNXUAfm1H	10596	14920	14920	1618624800000	canonical
21094	3NKoxswBBBKGztctHP9AFywZnB4XVDdQbXdcqweUAMtDSdppPhJW	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1523	1075	384	12463	13352	jxq1SsHuhjsdgjc9vHgy3kBrTNCeF6Unc1G4dSaAfeHYwWQjz1t	10596	14920	14920	1618624800000	orphaned
21099	3NKivmwf1ghrUEREFvoyi65nmzdS5KSEkJnECfcF1MLZqXDLGefG	21097	3NLvzSp7eZFkbWcECaf7MHVGzwAQMjZpjQcKpc2v3QnppbaocdvQ	1656	1097	384	12463	13356	jxpyqcuTDoZ5eQ77oTWydTQZWgg3piNCddySXTFu6Q9t2MiJwrs	10597	14921	14921	1618624980000	orphaned
21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	1406	1393	384	12463	13359	jxn82Mje2mZggykLY8ByehrzaRpdoYpAcTVorirjiKCnqx8JDDu	10599	14923	14923	1618625340000	canonical
21104	3NLaZVZxp9biPg1tyaKGBNPjfgknMB5e1BavwPezWMwJTW4v2Beo	21103	3NKRRGcvzDYo9BjUpg3o1M65FLfhHTiPgUiaG3dzGTQzYsASGitb	1448	1185	384	12463	13360	jwPf7Lc4FMJRo4Fzf77iRHVhCV5fgcAseEAAFKyjCkXw882vqGR	10600	14924	14924	1618625520000	canonical
21109	3NKQwrxZv7S3DvT4qdddLhJyTXhu39nbYjb8Yd1xYePZnfCXHv13	21104	3NLaZVZxp9biPg1tyaKGBNPjfgknMB5e1BavwPezWMwJTW4v2Beo	1631	794	384	12463	13364	jx2v6uvpGB2eoM678V2oViLxWTvSmJdsKazx4RgBKtzpr7koxSc	10601	14926	14926	1618625880000	canonical
21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	21109	3NKQwrxZv7S3DvT4qdddLhJyTXhu39nbYjb8Yd1xYePZnfCXHv13	1455	1332	384	12463	13365	jwdcJC89oWtVqmgWhYUsMy3uV2YvGGwLpE3Sh1cW9WDuajnoJFv	10602	14927	14927	1618626063097	canonical
21113	3NKc8woWPssBLWBLVm3fQ5QqXkgxtZtsv7twszksLh6senf6ceo1	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1642	1241	384	12463	13368	jx1B54PgrxRUbNy4vETu2x1NPGkRkVNBSz35vhV47QUV7wbxfWU	10603	14928	14928	1618626240000	orphaned
21116	3NK9YafPiXreJ9zU6yCdk3pGzDEPB67wEKqnQhW5QjRmDkbc4KjB	21114	3NKP4kwBLnJZy39pnPUWof2WX2X9PsGqyVFooFmdRtBJ2jTHLJYr	1403	824	384	12463	13371	jwi4H19pyuX2rH2iHMZ4fEJgdedb3Ni35iJzHRiKvv88tZM9x7v	10604	14929	14929	1618626420000	canonical
21118	3NKnAE684LWZR7bTcQDkjfh2skTFCJKywxABpux1XWEzUFSjkv3T	21117	3NLscUmSzAbitXAiS9GfFT12rGzbcWNhw7JJWN62sfR75hkQL8rZ	1422	1211	384	12463	13373	jwpLePeQz7J86SXohSmxzfogrCcRZ5LA3D312zsdGWFYZa2Lzdb	10606	14931	14931	1618626780000	canonical
21124	3NLP3ZMANekSTMmtZcG1vW87wuqpqg2EU5HssbsTp2nAm2u67B4Y	21122	3NLm8LbvAXjhUh2eEqiJcE4KJ2cABqVvsuJwQFJuDLCuThAA2vkL	247	247	384	12463	13379	jxvcUQTvVnjeGsUz6Cyrz8ELVbFPTLncMaZL98XQhjGuP852mzJ	10610	14938	14938	1618628045683	orphaned
21126	3NKjLAQkSfZHrcv7sDWVFzay4J7sS9RQHNckrGBdgsPUJModf4Ra	21125	3NKmTBRj2SsNg52PrfqAK6Z4kMa4RGwrwXZibaMN944VdrMQNx7f	1407	1395	384	12463	13381	jwcR82jbn4osD3FVB2tCH1XvqaRq4yRdZrn6V9rispxWnMVRVBS	10611	14939	14939	1618628220000	canonical
21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	21126	3NKjLAQkSfZHrcv7sDWVFzay4J7sS9RQHNckrGBdgsPUJModf4Ra	1405	851	384	12463	13383	jwVekEcuP2f4cUc6Mg1XnPLAijUJV5v6RXWT34pdcDXAG44dYRw	10612	14940	14940	1618628400000	canonical
21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1602	1123	384	12463	13386	jxsW1sBL7r46EtQ8L6jBs3ijBT1MLyxbvnSGxbquEZTVJitMMMM	10613	14941	14941	1618628580000	canonical
21133	3NKcrKnUQrLtfpC3BH5ewZL31BXiDoY2LaBZQRMfgGxGwjSJEcCr	21128	3NKCkAomg6MNd3uHMRmaaxYM2hzW71xjBUs4K5XgNXwMnKcjhJeN	1594	1326	384	12463	13388	jx2mf8v2XQdYwRcHxY8ZNbNrSdoaazp63MUZs7HQHLxukBUNDip	10613	14941	14941	1618628580000	orphaned
21134	3NKcddiJ6WJbE3A4ytM3EukSvkrub2zL6xAa1o4ZqvrB8pu2kWzC	21131	3NKwQTmhLA9LuVuhffdLw6kkdL8BHWigbikkFZgqprtRXXK8kJnh	448	939	384	12463	13389	jy12TV6duhzBvPpE9MYe82GDJgzvWkudBCnk5mHfwRrpae27xyx	10614	14943	14943	1618628940000	orphaned
21142	3NKu1THqnGqY2VnmmfUqn9ENfmY3qbBzWwAghDRcC31oAJWksDsd	21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	1637	816	384	12463	13396	jwUgV4cxyLvkwg7BS2ivvHkHuWaJb7RP2ifWSfxmDGfLLPDBqqK	10616	14945	14945	1618629300000	orphaned
21144	3NK7nxionTD3yuF5oX85Z4Ygtiw1WsHK1RncZxCt11r7TpTfbBBh	21141	3NKq3e1fgwdZF9o35LY4zDP2JEuZtt38Taj368ys6ixTYMGjJ2td	1441	65	384	12463	13398	jwmZ2QMtau6yUcBrAG3jbbM1arQQNygw8zyLXyYDuu3vjYE9H1n	10617	14947	14947	1618629660000	canonical
21148	3NKyDnMRCzUB1bwNBarP52E3rydUcsFgmc454DYM1tebR6Dz1aUk	21146	3NLqTmS4Gp8pZr86sHLBverqQmrUYmrrezHwT2wDgZGY3cKkwyzE	1406	1393	385	12463	13402	jwHMrvWvLFAbfPjiL912d5hVWkMyVRk91d1bD1ejAnCRgs6XhFQ	10620	14953	14953	1618630740000	orphaned
21153	3NKJf8XGxnVoWVg2gLfVAcAsk7MzX4RLWyHbrghTCWYepPHZBTJr	21151	3NLUJiuZVvJwYqZCunAVPMbj7KF3YMYAq8vfWPs4SPAnVPQSr1fv	1588	1392	385	12463	13407	jxiBwUMX7J1YL37CRosCNUU4J41GmWVTmMuzxtAg1qwaFeveK5m	10623	14958	14958	1618631640000	canonical
21161	3NLvDNVQcLciZRv2Zf2gLS7NREW9Hrj5TnBm3HXrLDAPPd1Z1HdQ	21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	1542	1304	385	12463	13413	jxVjG14TnBpHg9CaKxaLMVKVAixYj6sussDD2FPWTM6m9TKvgpu	10628	14965	14965	1618632900000	canonical
21168	3NLsYKoQESEVaSnUvPDYGURXWxv7wsZZRgsv6cXSxq1we8gSZeRa	21166	3NKE8sSzQQx6Xxnq4uGBc5A45DfjthLpeeGDjYkqNVFeiVzeHkGg	1471	1386	385	12463	13420	jxJ9GfTDju2cs3AKFiksDYkjKPFEucELx5RJDoq7SLpiGbqg1p6	10632	14969	14969	1618633620000	orphaned
21172	3NLkmF9w63Fv8ErzK7c7qr1aFgXyCwAEGJ5gxEuLV4LM9xmih42Q	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	470	1309	385	12463	13424	jwDoUcXQ955AvwWMpX38i5RZa5Fnh3nfVTuTProuhpCqRd6mGih	10633	14970	14970	1618633800000	orphaned
27234	3NLDh9mn2Tsirm1RUuqNMAiXtSznhUVYE2oF1NjK6XxFMx7GkWwU	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1634	1331	528	12463	18853	jx1Jk2rn7nEwcptWYv7pGqdmABikxhrx5QPniiSx3hwAHcKVZAw	13466	18955	18955	1619351100000	orphaned
21171	3NLDjMbT1B23NJi4pV88VYWeC4oj8wNX62VHDaaPqDYRvssqPvJe	21040	3NL64KVAiYUXM8C1esv9bs4FB2crCwhRYEYPxXVLZmLtbbueZD5a	80	1147	383	12463	13423	jwo7MJpzT3vWymS5Z1wdqNHMZ69Fsfr1KLhLknKzWvXCie3utGd	10575	14970	14970	1618633803323	orphaned
21140	3NKFhf1WRqmwRWCdhYHd91oaUWV7vdS7sGArxSVcToHovPYCRZih	21136	3NKzakvyA4KFSKTUtsFUhovmcrF7ZCo5CeUQwzBHafdtX6GB19ka	1631	794	384	12463	13394	jwSMKuqiVFjH2epFYk3JEkbpe7MQYWYUvBXNUBtouVZRTSyekT3	10615	14944	14944	1618629120000	canonical
21145	3NKJtG2y3Xf3fbE6wghsHtXPDBkRozaXnfCDuZWZUgnUsHgXAtX2	21144	3NK7nxionTD3yuF5oX85Z4Ygtiw1WsHK1RncZxCt11r7TpTfbBBh	1490	123	384	12463	13399	jwuuNQdfD5TPBnFm1krr6VXTKYHNZ7hSE6qHWGAKp9561rY1Hno	10618	14948	14948	1618629840000	canonical
21146	3NLqTmS4Gp8pZr86sHLBverqQmrUYmrrezHwT2wDgZGY3cKkwyzE	21145	3NKJtG2y3Xf3fbE6wghsHtXPDBkRozaXnfCDuZWZUgnUsHgXAtX2	1407	1395	384	12463	13400	jwh4YGYami4h1fp4VrfuvQtwZrsBm2uv8P25MbhoKBd7b7oPAU9	10619	14952	14952	1618630560000	canonical
21147	3NK7sf8hehBrje4eZ9EraHxD1Rr1JSxTcLL6qvmcotZQ3wvQgwFN	21146	3NLqTmS4Gp8pZr86sHLBverqQmrUYmrrezHwT2wDgZGY3cKkwyzE	1403	824	384	12463	13401	jwUDsja8qQH88awgeEiZTmTDNKyAYbojU1wdmoyRVEcDyjuLQPH	10620	14953	14953	1618630740000	canonical
21150	3NLYvtfh4Ncvqbkpd3jq6z3UAbxQQWeSM4aEYzatjAqdpXdRpvGu	21147	3NK7sf8hehBrje4eZ9EraHxD1Rr1JSxTcLL6qvmcotZQ3wvQgwFN	1564	1212	385	12463	13404	jw845UfDqGRauRkDkxx8AdLkqVCzcSc1eX8JRNZyYn7ysD4Vm6G	10621	14955	14955	1618631100000	canonical
21149	3NKw71uSV5qfMM2ErdeSrqrD5YrRFrmnnmGcz4TW9bA3RjCs71v6	21147	3NK7sf8hehBrje4eZ9EraHxD1Rr1JSxTcLL6qvmcotZQ3wvQgwFN	1406	1393	385	12463	13403	jxNn9FuE12VAoA5GE1SwJUG6L23jrtFxRhEmoaLcacQKoHpQcEV	10621	14955	14955	1618631100000	orphaned
21152	3NLJqJ5tKnHNLnwjbpUhZaE9grtdtnBMXiq7eCzmU8BJ8b5DYFAe	21151	3NLUJiuZVvJwYqZCunAVPMbj7KF3YMYAq8vfWPs4SPAnVPQSr1fv	1403	823	385	12463	13406	jwT2q6d7Lyou5HaEr37DST7Q7BoMp9mRr6HgWZYA7qobUu9LZ1r	10623	14958	14958	1618631640000	orphaned
21155	3NLLrABT92qyYJJq62gFAbb99Ry5HM3miLF6gz9ymxwgRjcGgFcr	21153	3NKJf8XGxnVoWVg2gLfVAcAsk7MzX4RLWyHbrghTCWYepPHZBTJr	1476	1245	385	12463	13409	jwPfVmyvqtT9XTUnPzUAiRCLwtxJ2yWBP3MhaUwWeqdNYm5aT53	10624	14959	14959	1618631820000	orphaned
21156	3NKAFnentx5n9qPaX4n569kNN5mHrUHxpUwQZ3QHajhMxXPWVWHb	21154	3NLumbpzJMh9HvzE7D6arudUbctxCcC1282WhHVLuA3zPUFxqfJQ	1508	1141	385	12463	13410	jxL3suVzvfuNoJUebsTuUTfsoi7Hj4FKBLv5BK6BawUqqB9HjTy	10625	14960	14960	1618632000000	canonical
21157	3NKoYGZ8BDuUiTWKggkUqMAPzXF6AasAhjAduC9oqe8MtbQmPrys	21154	3NLumbpzJMh9HvzE7D6arudUbctxCcC1282WhHVLuA3zPUFxqfJQ	1508	1141	385	12463	13410	jxL3suVzvfuNoJUebsTuUTfsoi7Hj4FKBLv5BK6BawUqqB9HjTy	10625	14960	14960	1618632003408	orphaned
21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	21158	3NKuBZKND6TLceuLYTN4DM9bAHfdkSnM1Q1NvkUgdef6WBaR4da5	1549	1362	385	12463	13412	jxkmqJPfeAcmMbxq5LtSf2Yiw8ytYekimQCD6DVhF6FJ163Ca9r	10627	14964	14964	1618632720000	canonical
21160	3NKZ6D4HpjSRFZkK2ng2qt9HYA16UnSg6mGb5NbswR9PJfJBWfgg	21159	3NLN9MUhU9c8bjYwdt2B1SJxixsjUevejvsFQEsqgDZM8KvgN4fC	1542	1304	385	12463	13413	jxVjG14TnBpHg9CaKxaLMVKVAixYj6sussDD2FPWTM6m9TKvgpu	10628	14965	14965	1618632901883	orphaned
21164	3NKpdotoSFVcvSftYKGprmiB9dQCPiY2RXFt4gs7bUZfZvqhF6f7	21163	3NKbyH9YbYE8YQAioEPuUhWt89igY5SSx4Qy6xUNkNzW3KxR4yij	1503	1277	385	12463	13416	jw8ZqjQ46cbexqNy5ZB3Km2BxbcnBiJqy8Ljkh25Vbd2ELQPB3N	10630	14967	14967	1618633260000	canonical
21165	3NLs6nHiX8xEP82sxsMAW15HxYdv9iKm71pDqHivePHtMiHWeJQ5	21163	3NKbyH9YbYE8YQAioEPuUhWt89igY5SSx4Qy6xUNkNzW3KxR4yij	1406	1393	385	12463	13417	jwDs6fBcDjfD84cu5VVQQGvw9qJg9TiMYdWs2ThrFYJtH956MDi	10630	14967	14967	1618633260000	orphaned
21166	3NKE8sSzQQx6Xxnq4uGBc5A45DfjthLpeeGDjYkqNVFeiVzeHkGg	21164	3NKpdotoSFVcvSftYKGprmiB9dQCPiY2RXFt4gs7bUZfZvqhF6f7	1559	987	385	12463	13418	jwLWLo1NXzZYWmzBnmx6HAmdenwTkXvoqvJW36yGjDcDLFMAKeC	10631	14968	14968	1618633440000	canonical
21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	21166	3NKE8sSzQQx6Xxnq4uGBc5A45DfjthLpeeGDjYkqNVFeiVzeHkGg	1671	1365	385	12463	13419	jxwpJvGDPx9H94FZjt1Cf6bAmTeQV3jaULF2H4mFURWunie4X8j	10632	14969	14969	1618633620000	canonical
21170	3NK5qB2XRvGeWzNoMKgSMpCZgG81LwW18YvbDi6dRGt6KPmuLSpb	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	80	1147	385	12463	13422	jxYQoAn5Q3X84hncmj7NZrnQqFJV2hSBViHjKLDKWJn99wgzCkS	10633	14970	14970	1618633800000	orphaned
21178	3NLgsNgF1TpNuPJPdx4jLWtghYAFspQCXast2exkYzZzWXtTDNR1	21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	1649	1383	385	12463	13429	jw8SdtnTmaoh7Xbhq45vEwzssXaoCSe1N3UJkJokReSuuJr6SJp	10634	14973	14973	1618634340000	canonical
21179	3NLAbRKh6DxvD33NvWnxUjZb1MhWEg55FzqgMvvaKVy9Mg6ev3z3	21178	3NLgsNgF1TpNuPJPdx4jLWtghYAFspQCXast2exkYzZzWXtTDNR1	1445	1044	385	12463	13430	jwsRvsdq7a9UGRX2ahHFwhdAKuaLR57JQfCZZXKuhBNukDPgSXo	10635	14974	14974	1618634520000	canonical
21180	3NLMsadi9sZZW4nyWyKMPkDfD7KmdAyKSUn1mbxKeQk5iaSnoMaj	21178	3NLgsNgF1TpNuPJPdx4jLWtghYAFspQCXast2exkYzZzWXtTDNR1	1407	1395	385	12463	13431	jwi5F2AARWf6e8UpFzvgRxCjP5UADnqJo8sd6P9evuUscHeYVcm	10635	14974	14974	1618634520000	orphaned
21182	3NKQ6Nu7ygqCAaQkSfniLL594Fvuup9WXaLgvt976ou7ZUYF5G95	21181	3NKV2RicfQgG69TR83bor7MZX1vUEnC5uB2xiPtghw53HgeT6rfY	1406	1393	385	12463	13433	jwXkCGaKLDWQE3wSJZS5TU2LZKhXBnLvpeYtTdcBYhjivJDYjqt	10637	14977	14977	1618635060000	orphaned
21185	3NK9GvPdckEKRDsXbasbwebK3aAoSrRgcJoRap1wYpjexjnYFr4d	21183	3NLxRs9YtZtWLwXG4iSNXeHw8xswuw9gJYED6CsCcbPh4VUxNmNe	1407	1395	385	12463	13436	jxaeX9VNyZ5M3Y7jhJZtpcKEAJorZgA58c9YX4DMep8SGqNRA7Q	10638	14980	14980	1618635600000	orphaned
21190	3NKLEZeiwg9c1Davnx4a15vT7e8LtwWuCvxDQjUnopPefdyLuFpo	21187	3NLXpDt9KAACWAQ8XQDf81FasPTCytieKfeZUvEUSe5FqB3dQ7iB	1406	1393	385	12463	13440	jwSCX7KMa6G8CLsJJhBLQ6TVjiutB2QGowNVBBXjZf4NZM3qLfR	10640	14985	14985	1618636500000	orphaned
21192	3NKcccgSm78pY1j5AvWe2vtgGyiKXjF9kx4tL6GbqgaDtyhKyvB4	21191	3NLJpPLGY9TEyhVXuwmT8esxUPv4txMb3fSJvJutSgGNiQbWv14a	1529	1190	385	12463	13442	jwKAV79peF7xrS1B2hgb2AriaPiCG1W9s6GgxDcXf1kstF6nDc2	10641	14986	14986	1618636680000	canonical
21193	3NKuMbJmPnTDmR93FwxJtTK2pB9VthWAuxqSBcu8JkFnhQH8dw8G	21191	3NLJpPLGY9TEyhVXuwmT8esxUPv4txMb3fSJvJutSgGNiQbWv14a	1518	787	385	12463	13443	jx7p2mAsUzRL1yR8eu8jCz9JT166KK6bGU2Gd6UGb1zoe97MhfH	10641	14986	14986	1618636680000	orphaned
21197	3NL9VSaLDvcFE7MvWGHoMLK2Z5dKkAuWhmLhsRJJJgLPRWYBfn2G	21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	1523	1195	385	12463	13445	jwmdm7bcVqvJpixGPu8W98RneTHfHZCB2QiZtVC854PxVEHYuay	10643	14988	14988	1618637040000	orphaned
21203	3NL5Zuyg6mgNsLFATeTvURHYAq2XcfDk2f2J3QrYmJCJeHWSbh26	21199	3NLRgsTL9MXp9M2D1p9mda89bF7EG8frSZjMp38xGD7Mf8SMjpiw	1601	1388	386	12463	13451	jwc7FrbmX9j1gsQRoyScG2SMwfznyghSwfcR8SN4Kw7UiXJ9jhx	10646	14995	14995	1618638300000	canonical
21209	3NKe8vcts2VbJmk5wyzerUpjVk9FzYoCoLyzqnCVB7Q5dHbfJ6TZ	21207	3NKfxCb9iZvrF17dwNCVUjCxaHES3XbxKXXjMCZxVVeRKC25toNY	1609	1333	386	12463	13457	jwXTCiUybmCQstkHSyguSFeHHf6kJaevgVFn9VxRUyjbQ6rRFJ6	10649	14998	14998	1618638840000	orphaned
27235	3NLDmFfRBzoiWvEkkEtHecSCgbwAy6AgfQ4QZNViWLPhQCbiJ6ny	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1419	814	528	12463	18852	jwDthFufatfFLUqjB7qR4Wqves6Efr5sPi9wfSoSxk9gnG7HtbH	13466	18955	18955	1619351100000	orphaned
21189	3NKuMw5YVxWsXZWCEgmACpEhfWMCEAHenCMmyQ2fuDTLZmEp9sT6	20986	3NL58ZMyosZquW7Jz7mXHtRXy3jQ883HhbEi1iC7vP1iHXPZxKCP	1505	276	382	12463	13439	jwzrCBcNtaL4BoLa76FFWhNDurNB4avMCZr9SzPX8eNbez6yus2	10557	14984	14984	1618636320000	orphaned
21237	3NKLKW4quLaSegib2RPA3Ad77ZmLyrRu4hdchcmPgJdCrt8ErpVw	21171	3NLDjMbT1B23NJi4pV88VYWeC4oj8wNX62VHDaaPqDYRvssqPvJe	80	1027	383	12463	13484	jx4n34qFyR6mc3VgM36bJRRRZviAAxU7VfFCdVXKrnbct4UDfNQ	10576	15021	15021	1618642980000	orphaned
21201	3NKGECkGgWDah13Yuythqk85UQuEnx7xDqwRarFizDxrKy9Lkhph	21070	3NKwpz7KMXuoCrfritRaZfzrk6kaGQ9xyYMxzqB45HnpAW2WUg6K	1649	1257	383	12463	13449	jy2CXSUe2qzUecpYQy9AREzzrrUzMcwtx4zVm7P8A59sBM23bLJ	10587	14992	14992	1618637767235	orphaned
21200	3NLPX6bzatmGzyzmncnJS1q19S5eJeYKx6p3ttB776ZsPrubnKgJ	21091	3NKeVJEPgcvcSCtfohoLDSPcypNiFr3WQ1hfv97r4pSvW8wdGzAm	1649	1257	384	12463	13448	jx9wd6FwSFT9wuJCRVMEqRu2juG7DPXdDJaVbTEKcKJSpdFEfVM	10596	14992	14992	1618637812070	orphaned
21163	3NKbyH9YbYE8YQAioEPuUhWt89igY5SSx4Qy6xUNkNzW3KxR4yij	21161	3NLvDNVQcLciZRv2Zf2gLS7NREW9Hrj5TnBm3HXrLDAPPd1Z1HdQ	1406	1393	385	12463	13415	jwVH17QN59NwdVqefathqi9TA5pC1W97NybLMzwifbvspoMzbbv	10629	14966	14966	1618633080000	canonical
21206	3NKEqm6qpH1Vbi7j6r8MgteFrKx9WTehiKqm9zJZGn1aX9UcSKWn	21160	3NKZ6D4HpjSRFZkK2ng2qt9HYA16UnSg6mGb5NbswR9PJfJBWfgg	1656	1097	385	12463	13454	jwMTxGkvoibivoLzX97xqazRceMHXjWnfHBcqfZHZKsthU5yBPp	10629	14997	14997	1618638662645	orphaned
21175	3NLGp3xuAVQK1DRnskUqs9Qhyi7nEKEjpj3qVDyBr4Ehw9ZNGuBd	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	1559	1353	385	12463	13427	jwTsTsU13BLZ9cYyED2JMdvjaMaHrmmToTUyFQXAZjEYo29SfwZ	10633	14970	14970	1618633800000	orphaned
21177	3NL6XUrsrphg8w6oY1SjguXb2YLKFVkGzNwgP5fVEix8DmY84Yje	21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	1649	1383	385	12463	13429	jw8SdtnTmaoh7Xbhq45vEwzssXaoCSe1N3UJkJokReSuuJr6SJp	10634	14973	14973	1618634342485	orphaned
21184	3NLC6zGwhqQD2TS2E9eNbeXhHUoHbRuzXcR5yoHstNaFZg4Nt2Dt	21183	3NLxRs9YtZtWLwXG4iSNXeHw8xswuw9gJYED6CsCcbPh4VUxNmNe	1406	1393	385	12463	13435	jxz1eYBHWPXUWihVbmXV8w281NddD6DuPN8TbZJWeHcvfBQ5azX	10638	14980	14980	1618635600000	canonical
21187	3NLXpDt9KAACWAQ8XQDf81FasPTCytieKfeZUvEUSe5FqB3dQ7iB	21184	3NLC6zGwhqQD2TS2E9eNbeXhHUoHbRuzXcR5yoHstNaFZg4Nt2Dt	1675	1216	385	12463	13437	jxk2QEfGGhL4BS8JBqNPNC7jtYt3wYKkEyojJ62EHUoYvjM1Zhe	10639	14981	14981	1618635780000	canonical
21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	21192	3NKcccgSm78pY1j5AvWe2vtgGyiKXjF9kx4tL6GbqgaDtyhKyvB4	1406	1393	385	12463	13444	jwgjDrfFZhrwitAcPxVvA62Wr5t1g7C8SNSU1eABTbHM1hgzayz	10642	14987	14987	1618636860000	canonical
21196	3NLdqXUHSfvt4Xu5yA2M2ebp11fR7e9HoxbhZcsKPm3NxKnwDCLC	21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	1523	1195	385	12463	13445	jxQ4skGHBfNj3pBKni65w4ANJtqFVZCWr5KYw5Ai4HJPVm1pHMU	10643	14988	14988	1618637040000	canonical
21195	3NKHovuWx1p3SZkEFrAx6DRmEtTDXTp4eXTPLRb7ovoTanESCt7b	21194	3NKUpMPGsEkiTrK6KuyXAot7TD8n6yMYmfPP4rMpR6DXWZmYhJz1	1523	1195	385	12463	13445	jx9TyYqdkw5Ge55d2CvA382SVS5uxxgswxPM3HFBzTh9tYDf1oV	10643	14988	14988	1618637040000	orphaned
21199	3NLRgsTL9MXp9M2D1p9mda89bF7EG8frSZjMp38xGD7Mf8SMjpiw	21198	3NL1SzkUJL4P6hVjkwMwiNkpYg6Xfv8pgGUcYXmVHvnTwiFfZ3F4	1649	1257	386	12463	13447	jxzvksymJHXuisqyfqZdtX9vjKAQknXHgHqrRcNQ5T924X9Ebjn	10645	14992	14992	1618637760000	canonical
21202	3NLfcC3f5b8pZfwNA7Sez2bW1RhK4HjV3Nk9BrgtgA2JJLonu6Ad	21199	3NLRgsTL9MXp9M2D1p9mda89bF7EG8frSZjMp38xGD7Mf8SMjpiw	1406	1393	386	12463	13450	jwYvtCDV4vjedLKxTCdMDKmCB4eCY42ttgTFrmHFZRuPiLwAHc4	10646	14995	14995	1618638300000	orphaned
21204	3NKL1ZisDUzCYataGYP1AHmv5rKtLkD3KBdZQryzWjkPhqBP5APX	21203	3NL5Zuyg6mgNsLFATeTvURHYAq2XcfDk2f2J3QrYmJCJeHWSbh26	1447	1345	386	12463	13452	jxL28NyjcvQqCtLwvW7qxp55LjTEvMEjhHCYe4ZcdgB2dLm1vAC	10647	14996	14996	1618638480000	canonical
21207	3NKfxCb9iZvrF17dwNCVUjCxaHES3XbxKXXjMCZxVVeRKC25toNY	21204	3NKL1ZisDUzCYataGYP1AHmv5rKtLkD3KBdZQryzWjkPhqBP5APX	1656	1097	386	12463	13455	jxNgaTWN4CN8krPmbPnbXJBFMjJzhmpRbKXmSvoUZapMSM9xjGX	10648	14997	14997	1618638660000	canonical
21212	3NKEaxYyNgxFqR4soAtwH7yidc62BQfZrdifU6JGVQx3hpPb8bt2	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1637	816	386	12463	13460	jwNFmj7ym2jSNjfsUasiDUQk6My6fVmeR5rX66m6Y7Q3ETbtkBh	10651	15000	15000	1618639200000	orphaned
21214	3NLVLaGgPpbu63VEvZY2XeMYbbtTcrZQ8h5MejZWDtD13R7goTsA	21211	3NLo1x2NbEBssLoxnVV5SgACRgtVqTmwQjBVW3UmWL8bNh6kpbJd	1596	1363	386	12463	13462	jx5Fr8Ln91qrUyBkPqwdDLHdBujgkXn28DYYXMgk8HaZoaLGChx	10652	15001	15001	1618639380000	canonical
21216	3NLNeb8YqJBtJuJcdVe22AK7eLyD9hnBy4M58jrB7NWHd1WSTMnt	21214	3NLVLaGgPpbu63VEvZY2XeMYbbtTcrZQ8h5MejZWDtD13R7goTsA	1406	1393	386	12463	13464	jw7WtXXJUyFhCPS3fF5JzxK1TinE4fkTJs4pZt9hEvMRbn9a5ke	10653	15002	15002	1618639560000	canonical
21219	3NKRkzBismWZf1TgyzKtCy57q9mx4qsDkydTkZkugcGm1mCaLana	21216	3NLNeb8YqJBtJuJcdVe22AK7eLyD9hnBy4M58jrB7NWHd1WSTMnt	1555	1347	386	12463	13467	jx8e5DiuZ6yDJNMrCJZueRqxpDvvtePUXm9uKhbvNigoekSjZyP	10654	15004	15004	1618639920000	orphaned
21227	3NKo4PPg3tJ97igYoXjDL5qNY8VpAT34SZmZp3wrtMeZoqhVVgVw	21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	1673	144	386	12463	13474	jxKQ3kM4w3CSpT1TzXmEp6LqwfzL8Q7oZypfHi1RcvLW6hUXJXx	10660	15014	15014	1618641720000	orphaned
21232	3NKmn6Qk8pZEYAr9hns8yfaqY1b64NnR2GVZyhDMQTgqMq4NHmbn	21231	3NLxdomfVu9SCmhKxcViaSpjWAjHNT1gaHDjXjtG1Gb4ptJBvcdN	1503	1151	386	12463	13479	jxLinPMp3phzcTCNBJFb58VGz2XBcm9Yv3B5hQnxnrKF4LLZHDq	10663	15018	15018	1618642440000	canonical
21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	21236	3NLa1wQed6VhXofTGUqVAAwGexdXYZA7PWxcSi76nnyXppV2cGCh	1624	1208	386	12463	13486	jwWD5QDnPJPncjbVwafqtXqu4sPwQaPw5RojsnRU2JWdCRzrry7	10666	15021	15021	1618642980000	canonical
21242	3NLc7AhKVH3xFbhoVgmNe9RhseWmCuUa7HseouCT44579oPahGvN	21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	1444	1135	386	12463	13488	jxoFMkF17CXYp3ZYDpet79Xzjar91y6sv8ub9sUTfeTQi6ZdCJJ	10667	15022	15022	1618643160000	orphaned
21244	3NLJagbqCGY2EzgcKCo1yS7rD2j5D1eoAWEnijiQysB1mYQLMXUL	21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	563	1359	387	12463	13490	jwnwBMHvL3DQwxJyb53TspmWfdx2o7MDKRBMdDgqhbXwRMQo16w	10668	15023	15023	1618643340000	orphaned
21249	3NKD5iBpcMWzpUZ6VoXXEtJH1eL2FDonrdc2pSYsLQWLqJrojDxE	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	1542	1178	387	12463	13493	jwEfTGgwNUEpka8Vy6StPUJwrZZvUh8PFJHo6kSzy9pN65wH8zU	10671	15027	15027	1618644060000	orphaned
21253	3NKm6MLwkqV6h6aEbwRgMZDhd23tJBxtaMjyh5x3fFZ9edkzPnfh	21251	3NLn4YincfUkwR3pGzLKpFU2JHGcr6FEhHfS4UKBVisyPgHYC1wP	44	1199	387	12463	13497	jw9ChuH5Duus3WL8pqH4T7bCQc4YvE6DL8zhprXssNND8Fzn8DW	10672	15028	15028	1618644240000	canonical
21258	3NKM9UNdwShiL1ghuzcwtpGvojmdoCiKctFR18V7cAVDZ6kkq4QM	21257	3NLveZRn4CoZ32WWN9zUrLiEN3MFafF4kYCqBeAygQFU2EY1cfg3	1406	1393	387	12463	13501	jxdT6zEdDA8xYaUKU3q4Z7jyLpcqDRPytqVuX6Xg9kHMoA9uUdC	10675	15031	15031	1618644780000	canonical
27237	3NLdMhNXx4PKDqReDSbuNYCBN4HMqKaBx6dGit5BAt7cnW2Uo6xa	27231	3NK8WSB85tNvqbFnkwNG5AdoEdcg3WyQyZfAo2Man3oe8hjmiKqn	1611	975	528	12463	18855	jx8fWiQRySUj41s85f4Udnws3McGubtTfMyeWEoM232nR7QN3Up	13467	18956	18956	1619351280000	orphaned
21281	3NLjoDvm4WcUr6AKuiKpB8UxjpaKf66zDvfE5pSJv68KrEpQrPmt	21114	3NKP4kwBLnJZy39pnPUWof2WX2X9PsGqyVFooFmdRtBJ2jTHLJYr	1451	1292	384	12463	13522	jwW8ukufUpwmygv6kmXhFNQQ5cqimx6atrCEjaDoeKVSJnXAPyc	10604	15048	15048	1618647923175	orphaned
21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	21167	3NLrZFGBKWbyE4LDzV8fLYCgDuoUX4micE77axyg6hpnpYdgswnW	1637	816	385	12463	13426	jx7PbwSEeP4qU1ue1ZZA6P5bzt41CSosFHR4zpUQLumF5xFpL3u	10633	14970	14970	1618633800000	canonical
21176	3NLKd6hq19W3Y1zxjojDkMbbJ8Rueh6YgXess2M6FhhMgBXrf64j	21174	3NLRBRQtDyAyT4wdNiJYHFiSqXmmEVMtDyV4zXgPyVNiJNctFWDC	1403	824	385	12463	13428	jxP98s19Ljhm4EWEngTuKqk7petaeoLG7jqSr5ku2NJauqM8MAb	10634	14973	14973	1618634340000	orphaned
21183	3NLxRs9YtZtWLwXG4iSNXeHw8xswuw9gJYED6CsCcbPh4VUxNmNe	21181	3NKV2RicfQgG69TR83bor7MZX1vUEnC5uB2xiPtghw53HgeT6rfY	1581	778	385	12463	13434	jy2LvJi3HoLnzRTNPtTPmKmT7Fk2gPc7YqFZgx5gQoQcmb7TGPe	10637	14977	14977	1618635060000	canonical
21186	3NKn5ZnSnvuBY8hfXTVQ1tYHPgf1ykJQ4ZsHcezsctb9uywkDTE2	21184	3NLC6zGwhqQD2TS2E9eNbeXhHUoHbRuzXcR5yoHstNaFZg4Nt2Dt	1675	1216	385	12463	13437	jxk2QEfGGhL4BS8JBqNPNC7jtYt3wYKkEyojJ62EHUoYvjM1Zhe	10639	14981	14981	1618635783588	orphaned
21191	3NLJpPLGY9TEyhVXuwmT8esxUPv4txMb3fSJvJutSgGNiQbWv14a	21187	3NLXpDt9KAACWAQ8XQDf81FasPTCytieKfeZUvEUSe5FqB3dQ7iB	1581	778	385	12463	13441	jxehfP2oMegqvRTxxDBQSeNqoBNV8mxwkXixxgSWDRBWsY9GeXc	10640	14985	14985	1618636500000	canonical
21198	3NL1SzkUJL4P6hVjkwMwiNkpYg6Xfv8pgGUcYXmVHvnTwiFfZ3F4	21196	3NLdqXUHSfvt4Xu5yA2M2ebp11fR7e9HoxbhZcsKPm3NxKnwDCLC	1421	384	386	12463	13446	jxBrSkVBs53HDi1oz2JmxsHHyTgSMMdVEiGBZjaLBxQbL8a8tyC	10644	14989	14989	1618637220000	canonical
21208	3NLsq6fBoXxuo6ZbyYGMEpYjBFERwQhKq6ur2uZSSPaZyvhh9Yta	21207	3NKfxCb9iZvrF17dwNCVUjCxaHES3XbxKXXjMCZxVVeRKC25toNY	1672	1285	386	12463	13456	jxBqTXE7GEiXGZcDLWdgK8of2duzZWGX2WatMEQUWx7fqg2PTCq	10649	14998	14998	1618638840000	canonical
21213	3NLh92euzhhT99W335w9TVkdtQaMxhr5169mPivGDoRW3x2jyh1z	21210	3NLhddHsRbCmDCt93ri7fNt62sPpv1tyoFWFzfTRU6e9HgHHtDVp	1407	1395	386	12463	13461	jy2aTa8Vgm65zADMLkHVA5ahzCxT326rEAWWvCoJ4WBSTQ4rFRC	10651	15000	15000	1618639200000	orphaned
21215	3NLGFjnfFj33vVMaqSAkUSQ7cPDAty912zqrFSorEhQxbJFNx2do	21211	3NLo1x2NbEBssLoxnVV5SgACRgtVqTmwQjBVW3UmWL8bNh6kpbJd	1476	1371	386	12463	13463	jwTMwBJVpBvkiLhikFyNgLmXNwduhYaJysN8sEf9ta5XeENtvCM	10652	15001	15001	1618639380000	orphaned
21222	3NKs9gQaNVrYkYmxAvRrzRpbyiJvVnMzHHWBYrocX6syDhPJB2H8	21221	3NKJcfXKbCVcucb3K3qaKAYUdHH5h1eJk2h17bKmG6XExevCsuhG	1637	816	386	12463	13470	jwhmzM27nj8aaghD6NRoQYEjXyVfYMk4EJEDYhMNXGAtxzNjaVf	10656	15008	15008	1618640640000	canonical
21223	3NL7dG3AUJ4XozEwjcJ4ZpwvZ35n61Q1gzUt59veB569DByc1M5Q	21222	3NKs9gQaNVrYkYmxAvRrzRpbyiJvVnMzHHWBYrocX6syDhPJB2H8	1608	923	386	12463	13471	jwZK4h1EuUZguormhnuJCMHeStJb9Duou5PRXeA1qs1Ks6Vz2yv	10657	15009	15009	1618640822638	canonical
21225	3NLFLh7MNSzV5q5XWfS51FnLrh367dADuq3Pj4nhTqxSiJ3w8ZP3	21223	3NL7dG3AUJ4XozEwjcJ4ZpwvZ35n61Q1gzUt59veB569DByc1M5Q	1406	1393	386	12463	13472	jx57xHsCpz1juYyur2trFotdQvXdjT5Awj8E6zmXCD6gxNUVRMJ	10658	15010	15010	1618641000000	canonical
21228	3NLSRPrMjqoL7QEziaz2CNwAJHTf2C88JmCud84DVZRZmXjC3z1o	21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	1648	1158	386	12463	13475	jw8xNE5FjBKMECiCs63iSMp3Frm1QQPHSZSTABXGLY6uq6Niap4	10660	15014	15014	1618641720000	canonical
21229	3NLmPxDQ1qXNacCKiYzMrAxhFKKA89tJowyKvwvxGwUkkKRrLVUz	21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	1407	1395	386	12463	13476	jwypWb3ZwXyqs2vZA99xDKCygyNNvvaGMQRXVnYgfin8BTet42m	10660	15014	15014	1618641720000	orphaned
21230	3NLXyD1LXhF7t1AS77iNZ4UZYh9Dc8gC24jJNBhmMCP1hYSMLXBW	21228	3NLSRPrMjqoL7QEziaz2CNwAJHTf2C88JmCud84DVZRZmXjC3z1o	1406	1393	386	12463	13477	jxtKBuJZ39QyoDCmqE1fUxXtmibUqydKHZ8VGeGFHVASxpLJq9F	10661	15015	15015	1618641900000	canonical
21231	3NLxdomfVu9SCmhKxcViaSpjWAjHNT1gaHDjXjtG1Gb4ptJBvcdN	21230	3NLXyD1LXhF7t1AS77iNZ4UZYh9Dc8gC24jJNBhmMCP1hYSMLXBW	1406	1393	386	12463	13478	jwsYTRNauGqDsTAshY8iJdot4i8VR3yDSiEp1WzVqGxXy4TXNei	10662	15017	15017	1618642260000	canonical
21233	3NKgRAEeEgNsLAF6PCoiY9jcPLYpKop52uqwKkwR45uCmfxHGnUN	21231	3NLxdomfVu9SCmhKxcViaSpjWAjHNT1gaHDjXjtG1Gb4ptJBvcdN	1406	1393	386	12463	13480	jxr4S3AqyLs9Xi6tEWmpA8oo1P46Genow6C7wYWfwuMkWpqQXZT	10663	15018	15018	1618642440000	orphaned
21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	1403	823	386	12463	13487	jx4Yv6TRZQcn2P9Pm61rghNy1DrEM6vfbmJ47psjSdBd4EcivjF	10667	15022	15022	1618643160000	canonical
21245	3NL26BFLvQPjFZds2Ld8rNVK3opGhmHAUM2Abj3i3u4DcAYewvDh	21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	563	1359	387	12463	13490	jwnwBMHvL3DQwxJyb53TspmWfdx2o7MDKRBMdDgqhbXwRMQo16w	10668	15023	15023	1618643340000	orphaned
21247	3NLtT3iNyiyR2tzHLJgGax2kYhn2qKqsUvJ1WjcVx5Aw6fatq7xr	21246	3NLYMLE1LoFHDCGKNkXqWr4XqAeGNrCf72iSfCxssHX7jz5LBcfA	1406	1393	387	12463	13491	jwrnTemXUaMcwc7Z5kSBGpjAdPaTYoL3z7NStJS4npbdwbQNLkn	10669	15024	15024	1618643520000	canonical
21251	3NLn4YincfUkwR3pGzLKpFU2JHGcr6FEhHfS4UKBVisyPgHYC1wP	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	532	1303	387	12463	13495	jwqfveCti726AH79zKadw6PNfbqdDaQbN6UP3zJ92b74oTn3Fzm	10671	15027	15027	1618644060000	canonical
21259	3NLrzeEyEZAdtBpEzuToEKU45yGbzZRaJyBtXkw2iEZrAgdLGYag	21258	3NKM9UNdwShiL1ghuzcwtpGvojmdoCiKctFR18V7cAVDZ6kkq4QM	1406	1393	387	12463	13502	jwRBDnpqfnaiVVVvAiVSb5GBe6ajwteAkHdRHegJmQ1bGekLAkG	10676	15032	15032	1618644960000	canonical
21268	3NLNsT7M7jdjqybgMsiacDVMrsthaFFVscThzuqJtxSHp1yY7oKb	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1631	794	387	12463	13510	jwroi865HFP3jwUYSofWr3G3Re4rs1udFi5bzBp1zqErgV1s1ei	10679	15039	15039	1618646220000	canonical
21269	3NL8TNBN4TrJWsdvVLALEFeye3d3wYdSHjqnpTA7tDkK9SJef5C3	21268	3NLNsT7M7jdjqybgMsiacDVMrsthaFFVscThzuqJtxSHp1yY7oKb	1444	1381	387	12463	13511	jy2JgnRodAhXsFdsh5ZqAgRUjz13ktvvRyZaQj7PpiEK34JmAsX	10680	15040	15040	1618646400000	canonical
21272	3NKDmgyHzAXzbNRmLY8owns98WaszzQ1bC8EQ9JEijtf73ijBczo	21271	3NLqQofZAz836hXb9gSBhHQHdDD4y3sg8RyBdfLAoaTnL34rA7Pe	563	1359	387	12463	13514	jxnoiYaec1qkTmx6VJC7Cw37hqbeUtDFHyBZJro614u8UF1Bgup	10682	15044	15044	1618647120000	orphaned
21275	3NKsq5X4DpGu8vTfWGXT3ZogV68AJBPmxaLeNUkWPewBTkwvMn5b	21274	3NLro7VGLgVpXtYTuLgtGrEz5ZRJJsE4SjBKjzg6QPJyKzi4NcNb	80	1273	387	12463	13516	jxd4UsejiBTdBZfYzoswH9Pz3sv1vZsZ7nrmvMy3fGFdHvpwcoH	10684	15048	15048	1618647840000	canonical
21284	3NLfmSxA1J39qmcDRuSKwQ52QTnEGVbo7W1bFrMq1ALJRMmwD3Md	21282	3NKURJkNo8ob67mZibZXKQBFE6rj3xeeVKarPEXgssrbENCH94Ur	1529	1070	388	12463	13525	jxXbdeFVJUsyR7ox86qfRLDSTNezqLaznEUBYwutvncGQQe8CMg	10686	15051	15051	1618648380000	canonical
21294	3NLn6RBfm1ojvvz8wAxetus9DAtHCKH8TP2X67jpeYF5FgzbbGx2	21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	1405	861	388	12463	13535	jxafXEZdbnehyScme5MZCTZn3US68ZnRvDH5Cum187gFf29idoc	10693	15060	15060	1618650000000	orphaned
27250	3NKg6GpuwLF5rCzjZedUfP5pv18rfEkbv625DiZhwSsgyww6fQ7Q	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	1647	1302	528	12463	18868	jwN3Ntj4L2ewPYQ7yqsUb2LYQgqMXo8S8NxxUHmHDXvUmhoiByL	13473	18964	18964	1619352720000	orphaned
21220	3NKo5eEb7xsSzcqeFkpeE8fX8bNZz6NSPJozkAh2zA4LPo57MWya	21214	3NLVLaGgPpbu63VEvZY2XeMYbbtTcrZQ8h5MejZWDtD13R7goTsA	1555	1347	386	12463	13468	jxzFoucizSGx3bU3EB5BNvTmVMv7JdcumXyZHA8NywKfNpXzmFi	10653	15004	15004	1618639992425	orphaned
21218	3NKKQYqUgUjrsKwE4YF3gv1SwgUbvVHZ3oXZvpKEUpWV8PnyCm5i	21216	3NLNeb8YqJBtJuJcdVe22AK7eLyD9hnBy4M58jrB7NWHd1WSTMnt	1552	513	386	12463	13466	jwhR2eLqSoFBLn2vdNjDXeoVaPrZcN5kdS7tjX92ibqamNP3bEG	10654	15004	15004	1618639920000	canonical
21221	3NKJcfXKbCVcucb3K3qaKAYUdHH5h1eJk2h17bKmG6XExevCsuhG	21218	3NKKQYqUgUjrsKwE4YF3gv1SwgUbvVHZ3oXZvpKEUpWV8PnyCm5i	1406	1393	386	12463	13469	jxoE1ZcWBqAkHPXJHutoiwdB7Fmy27YDAtECSYNwSDiPno3XsBt	10655	15007	15007	1618640460000	canonical
21224	3NKs79kDS5H6KcpCUSpjshB3QDpvp3bsRy4dPa7Q3YQzEY49ruqv	21222	3NKs9gQaNVrYkYmxAvRrzRpbyiJvVnMzHHWBYrocX6syDhPJB2H8	1608	923	386	12463	13471	jwZK4h1EuUZguormhnuJCMHeStJb9Duou5PRXeA1qs1Ks6Vz2yv	10657	15009	15009	1618640820000	orphaned
21226	3NKf5Xt4cprfg3RSbiLZ8coAxdvToic8WKULrw8GSLnAGLhmx8VC	21225	3NLFLh7MNSzV5q5XWfS51FnLrh367dADuq3Pj4nhTqxSiJ3w8ZP3	1611	1341	386	12463	13473	jwYPsuX3oktr1pzhyESSozEtsmVyyGuGSQwLe8yX97sLWMzFpHx	10659	15012	15012	1618641360000	canonical
21235	3NL1fJypFKik7y2e15G4wd26bEHEuzdUs1tYNQfsjByLhvhZQqXD	21232	3NKmn6Qk8pZEYAr9hns8yfaqY1b64NnR2GVZyhDMQTgqMq4NHmbn	1553	776	386	12463	13482	jxDSR199zSQvuFBsEGWvtkCVTvEQU6tp4d8w1kTkzTFV2g6kK3P	10664	15019	15019	1618642620000	canonical
21234	3NL2RRmAS2xCFndzeh1eMk61njgE9E99w3ccV9nTz6KSaujnqLXs	21232	3NKmn6Qk8pZEYAr9hns8yfaqY1b64NnR2GVZyhDMQTgqMq4NHmbn	1522	1076	386	12463	13481	jxsximczQxVvKTTK9Ya2KW1fX5TKAuokciUFaETmRg5rsBtcRHx	10664	15019	15019	1618642620000	orphaned
21236	3NLa1wQed6VhXofTGUqVAAwGexdXYZA7PWxcSi76nnyXppV2cGCh	21235	3NL1fJypFKik7y2e15G4wd26bEHEuzdUs1tYNQfsjByLhvhZQqXD	1405	1	386	12463	13483	jwbktnPzbwuQcb4HXBpVDvTpwiEtXbGnv2WBvBipUXLC9UW84XM	10665	15020	15020	1618642800000	canonical
21241	3NLgLQ9AHyi7rJgWwe23AipSFn8V2MkwtSexk3RM36zXxyWaB7Y7	21239	3NKeviWkW4s4aWH8MgfgV5Za1p9yi9Z9wbBF2TGemrqHcZcEYQcX	1444	1135	386	12463	13488	jxoFMkF17CXYp3ZYDpet79Xzjar91y6sv8ub9sUTfeTQi6ZdCJJ	10667	15022	15022	1618643160000	orphaned
21246	3NLYMLE1LoFHDCGKNkXqWr4XqAeGNrCf72iSfCxssHX7jz5LBcfA	21240	3NLGeiQT93Qm4cMDkEw8eA4EK6PkNnMobTErbppMUCDUmeyMAtBE	563	1359	387	12463	13490	jwnwBMHvL3DQwxJyb53TspmWfdx2o7MDKRBMdDgqhbXwRMQo16w	10668	15023	15023	1618643340000	canonical
21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	21247	3NLtT3iNyiyR2tzHLJgGax2kYhn2qKqsUvJ1WjcVx5Aw6fatq7xr	1547	1132	387	12463	13492	jxf8t27BJMNMtxSVEmnpQjMw9E1VocT2HuafqEXpRWvTQXCwdxi	10670	15025	15025	1618643700000	canonical
21250	3NKQxFVWsw3QpBBog4HhcKU2tdtegDTT1FdEh4Xez2jG9S3wTtNo	21248	3NKBaHqLDoawzWp28Z5CNEXsUjm8GHR1g7KKTjnssHATPzPnRdoo	1672	1159	387	12463	13494	jxTNwtvd2Fy6ry6aABgmT99xdB9aAJrJmxDjAJK8aQ9TKYBvPwd	10671	15027	15027	1618644060000	orphaned
21254	3NK63pB6bUU8ztXk95L76VzYHXmwi15J5bZBCqNwLSaRQq8EMKgn	21251	3NLn4YincfUkwR3pGzLKpFU2JHGcr6FEhHfS4UKBVisyPgHYC1wP	1406	1393	387	12463	13498	jwS6hCLJwgkmzNY4VjjZniHoCsisjbW5u6RsP23wmpqKdUZanBN	10672	15028	15028	1618644240000	orphaned
21256	3NLTEM2ZVJD5YBxvLCrAnq4zEeHZS57YJav22PrkZcyn5Jid5BBi	21253	3NKm6MLwkqV6h6aEbwRgMZDhd23tJBxtaMjyh5x3fFZ9edkzPnfh	1668	1004	387	12463	13499	jwBSshx2WZjVAse5wdVpas8C1UBpXGxs4sa4fQ9FoHBgzGq8nGz	10673	15029	15029	1618644425122	canonical
21255	3NLDqGqi2jnfMDkEiiUtgEHfHzabVcN56SLVJ776KrHpasWso2wZ	21253	3NKm6MLwkqV6h6aEbwRgMZDhd23tJBxtaMjyh5x3fFZ9edkzPnfh	1668	1004	387	12463	13499	jwBSshx2WZjVAse5wdVpas8C1UBpXGxs4sa4fQ9FoHBgzGq8nGz	10673	15029	15029	1618644420000	orphaned
21257	3NLveZRn4CoZ32WWN9zUrLiEN3MFafF4kYCqBeAygQFU2EY1cfg3	21256	3NLTEM2ZVJD5YBxvLCrAnq4zEeHZS57YJav22PrkZcyn5Jid5BBi	1483	910	387	12463	13500	jxFfkCdzmnHufLWMA7dkvTA5zz5TWMhtfkYq8YwKQPSV9n4fYzK	10674	15030	15030	1618644600000	canonical
21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	21259	3NLrzeEyEZAdtBpEzuToEKU45yGbzZRaJyBtXkw2iEZrAgdLGYag	1581	777	387	12463	13503	jwMXrAswe7VcHfYQpdfMJQm9vaTE5Qo2Yxkwn2AjGAM4Rs6ZPzR	10677	15033	15033	1618645140000	canonical
21263	3NL98NgwUtYDEb7BEkhEMJG77M6xXtLujmK15ZXEhCncx6Xm2WFp	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1670	1156	387	12463	13504	jxfGLDRvKqLbuLPgERY95WDBXKr4AuuqmLVHVTq5ZkVVQnGRaEo	10678	15037	15037	1618645860000	orphaned
21265	3NLWsfv3HGGKXD1tsi2k3Nsa4FjBNcJ5GY7DW794hxznys3s7Z4i	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1426	1364	387	12463	13507	jw6z7HxdYaE6R85vpY4dN7mXkQxhEyF1g8fTXCWgWL1ZEbfUU76	10679	15039	15039	1618646220000	orphaned
21278	3NLnhvoUehAK2DNtBDTp9fMLkVSHP9UcsDz1NtUz7PiBD1tjMH6U	21274	3NLro7VGLgVpXtYTuLgtGrEz5ZRJJsE4SjBKjzg6QPJyKzi4NcNb	1451	1292	387	12463	13519	jwyaQwHgZF3SHrBCdSh7PfZLEKNe4GScn1DevaYNLVhPwRVVSHJ	10684	15048	15048	1618647840000	orphaned
21286	3NLbcPLbNfHEE24QzqNFbMuFj1E4Acw3aA4j9y18vqo5URZ3efEL	21285	3NKyZ3CidXrgK5wXTYbWyZDnXnahskVGJzwp9JYM64YFeowsCAr3	1508	1387	388	12463	13527	jxxTzAn3xnmfp4M4VY9nfjWDQemACryyj7f3VBxU2NM5a9vygVQ	10688	15053	15053	1618648740000	canonical
21289	3NL5yvj32mFNcPxpycSGCz2NiQYMRFMYtTkvDTtVX7sNhjwQJLVB	21287	3NLPA4pLrUcfZDtLgCHYtWzEmnUtiKnQEMcGSkyY3sE9KcH4gW5m	1407	1395	388	12463	13530	jxzGyqfVZWoPwvkktosPUMHtUBNL5vQypEFZKYxapmnxeZLmkAA	10690	15055	15055	1618649100000	orphaned
21291	3NLyboyUmsb8UPvk48KeazPoj9dDizS9XNm3bgc5T91iogNnnHBM	21288	3NL9YES4ZoaGUQkArSSZuM3Xz1h4XwuBzLhS6Wy8GMC1MBSTtPQh	1650	1009	388	12463	13532	jxF1AYG8tHTeNQd2bsp8MvbcbMfDjSUQiQCFKvmWrcPo6j2UX8k	10691	15057	15057	1618649460000	orphaned
21299	3NLaLw4ezQ135z5wZZkx7o8o1TSVqNX9vw4NMqAbcdZgq4TBzpy5	21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	1593	1100	388	12463	13538	jwu8HFaRtwBJk3kJfJDS2ZkZTnQvLqQcufvmJi5Fp6VFbahn2qD	10694	15061	15061	1618650180000	canonical
21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	21299	3NLaLw4ezQ135z5wZZkx7o8o1TSVqNX9vw4NMqAbcdZgq4TBzpy5	1547	1378	388	12463	13540	jwbcRaAMFYFVXRnzw2ULTWLs6Bec4gYbfgektHLRzZToJEVDtLK	10695	15062	15062	1618650360000	canonical
21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	1581	777	388	12463	13545	jwzcpTfXr6vCM9EwCtuMfk5YYZavGpEs3rgjremqzMA6YbqmrxY	10696	15063	15063	1618650540000	canonical
21307	3NLgCS8EiEyTXdppaAujUT2VkkDTCEPPXVqGnJckQM7aKnUrVDys	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1506	1247	388	12463	13547	jxcyVJmyFtayhWZ1jDTT5gKU3xem8FAfNqK6w9wjTsMCfQyeydh	10697	15064	15064	1618650720000	canonical
21311	3NKwt6KNwXig9sPyRi8vsJLY2iBxCsYg4dcTY2f2ruy7po5AG8DT	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1633	1024	388	12463	13548	jx1twTMAC3LXWPwyJxMTmEtMqA9ayHnyFxuPT4yXHJmLGHiZsVe	10697	15064	15064	1618650730082	orphaned
21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	21315	3NLi4bYiynXbKEaQsHY7y1xDpqooBfDWg8J6nY4u8bDvEU39f9Dj	1508	1141	388	12463	13554	jwzTuo98oo6dWimZc4nBXQtiow4NYrJ45xfSYGYNJvS3THAVPey	10700	15067	15067	1618651260000	canonical
27249	3NK7B89DyVMr1ud1BDX29ory42yMHsFWvrASiRmLT1LpvVLG6v9q	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	1673	1122	528	12463	18867	jwDcXY4PW9rPBWF8XXNWC9QbwAdtt9Uwkufep8o1Fo5jsEMZwkN	13473	18964	18964	1619352720000	orphaned
21276	3NKAhYt2CyLZw8pXiNdR5Fxd9Veu1ppVc1GiWuFGuGpSsVoYDehi	21101	3NLUAdPbg6aCW5hASMPFDVWnMkzxicwTHGrmEzhWzwsgEW9r272S	1451	1292	384	12463	13517	jwXSoMfds3bBZsFa9o7mTgzTT6xPFGooVjLfqNngq6Ro32hYR1w	10599	15048	15048	1618647840000	orphaned
21279	3NL6QuWkv14Hx6notNfpkP9MKRkbWbpYX4GfQ7i4AbgBn58aqR5N	21110	3NKqYiGHxze7r48kaRpbxwMte4Y7aKgDdQUko7jZmcM9C2M8qK5J	1451	1292	384	12463	13520	jwtcZC5nrenpN7HjxE2AWPF2n4anHuMBK4FwrzWXKx6VpozRNuA	10603	15048	15048	1618647880075	orphaned
21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1522	1076	387	12463	13505	jxRQf6VxkKfSdpfJGnaFxYP6EgSFvK2Lwv1bRiFun8RpfQUELcF	10678	15037	15037	1618645860000	canonical
21261	3NKubqHiNdn4Yrgn2CX8kdqF95TiSceW4j9t9JHeWuNx5nkgpXBg	21260	3NKDhyWTLUwxU5mgBf1fFdjU6eH8MPouTsXoLi7CFJcsAFUoTR7t	1670	1156	387	12463	13504	jxfGLDRvKqLbuLPgERY95WDBXKr4AuuqmLVHVTq5ZkVVQnGRaEo	10678	15037	15037	1618645862597	orphaned
21264	3NKuxZAhCPQyBMd9Yq9SECQCurKA4YiLxHWFs5Ub9m6KXicpEPh6	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1622	1110	387	12463	13506	jxeEGwJ8w3HLgVgoMWJCQS2FrtGGyQNAWNL9kV9F7J1NwpTAKA9	10679	15039	15039	1618646220000	orphaned
21266	3NLphLvv7fa1WyAx2Et2K6amKYcSmQAD7cGsog17mEYaA8n5BWfG	21262	3NLpxyKVzY2Gj9LN7ndxmdEim3j1w4XgV4tD6ZN8RVyAgSvS9cQV	1476	1371	387	12463	13508	jwnyXyhwjbUMMgcsXTUypXAcbXppjfccpdS5kkuweF96QMUa2ed	10679	15039	15039	1618646220000	orphaned
21270	3NLJvpa1kdVLuE698LCDrXHRep1dRxu2PMQPVRnUw3rWZ6dvdQYx	21266	3NLphLvv7fa1WyAx2Et2K6amKYcSmQAD7cGsog17mEYaA8n5BWfG	1444	1381	387	12463	13512	jwmeBTEkhU8smjs48pe2n8pQZJkvhLBTALWmFDnARJTDTY7uRQR	10680	15040	15040	1618646400000	orphaned
21271	3NLqQofZAz836hXb9gSBhHQHdDD4y3sg8RyBdfLAoaTnL34rA7Pe	21269	3NL8TNBN4TrJWsdvVLALEFeye3d3wYdSHjqnpTA7tDkK9SJef5C3	1406	1393	387	12463	13513	jxHhdr4ii4pWtFzZvTbqEEJBKyNg326gR67Ygm6bo9k41niPos8	10681	15043	15043	1618646940000	canonical
21273	3NKBDWzbDnyP3ZeDCwH3h6eKCW9SVVh9x55Fk4a7HQntZ8FCwThH	21271	3NLqQofZAz836hXb9gSBhHQHdDD4y3sg8RyBdfLAoaTnL34rA7Pe	563	1359	387	12463	13514	jxHB7o7s5ySc6UWFfVYwANWnmjgQt26NkMxtVFjKw8p8jz1UUxo	10682	15044	15044	1618647120000	canonical
21274	3NLro7VGLgVpXtYTuLgtGrEz5ZRJJsE4SjBKjzg6QPJyKzi4NcNb	21273	3NKBDWzbDnyP3ZeDCwH3h6eKCW9SVVh9x55Fk4a7HQntZ8FCwThH	1477	1350	387	12463	13515	jwe8AC4Z4EdqEf8xTsh1Qs8k5pJQzfShfwL7JVtoZig8ipeWFZd	10683	15047	15047	1618647660000	canonical
21282	3NKURJkNo8ob67mZibZXKQBFE6rj3xeeVKarPEXgssrbENCH94Ur	21275	3NKsq5X4DpGu8vTfWGXT3ZogV68AJBPmxaLeNUkWPewBTkwvMn5b	1403	824	387	12463	13523	jxx9A9f4TZsQsF2dDKkCG9btYkGjwfrVrpeuK8mi6KtV65pC4hn	10685	15050	15050	1618648200000	canonical
21283	3NKMtNNkMWhK6m9sywvbvjZoMDBQwCp4tVxwjnascvdsTKu2dgMS	21275	3NKsq5X4DpGu8vTfWGXT3ZogV68AJBPmxaLeNUkWPewBTkwvMn5b	1406	1393	387	12463	13524	jxq2MVduvRAZD8WPtXRYsz2rn1keKrD6GY8hTLSGYH4kmrW7awH	10685	15050	15050	1618648200000	orphaned
21285	3NKyZ3CidXrgK5wXTYbWyZDnXnahskVGJzwp9JYM64YFeowsCAr3	21284	3NLfmSxA1J39qmcDRuSKwQ52QTnEGVbo7W1bFrMq1ALJRMmwD3Md	1581	778	388	12463	13526	jxFswQCmXHKLgVNJ5L3H3HXgNnv192vbKCH1BCg4jh1pvmfbFFQ	10687	15052	15052	1618648560000	canonical
21287	3NLPA4pLrUcfZDtLgCHYtWzEmnUtiKnQEMcGSkyY3sE9KcH4gW5m	21286	3NLbcPLbNfHEE24QzqNFbMuFj1E4Acw3aA4j9y18vqo5URZ3efEL	1426	1118	388	12463	13528	jwxzzmmVXYg5kKUFVk9U4kWDQ92egeD4nbR8kD3F4M6guXT4eUN	10689	15054	15054	1618648920000	canonical
21288	3NL9YES4ZoaGUQkArSSZuM3Xz1h4XwuBzLhS6Wy8GMC1MBSTtPQh	21287	3NLPA4pLrUcfZDtLgCHYtWzEmnUtiKnQEMcGSkyY3sE9KcH4gW5m	44	1325	388	12463	13529	jwfubMLCb3V1aS2EW3ZVcLPdfae9UqAtXqam3qwoKCpN2cYnjJL	10690	15055	15055	1618649100000	canonical
21290	3NL1yviEsMLb8WUy2tUCNykXkuFUXzwgw59hvjjfXLw8SxjUdSR5	21288	3NL9YES4ZoaGUQkArSSZuM3Xz1h4XwuBzLhS6Wy8GMC1MBSTtPQh	1489	1380	388	12463	13531	jwKwKxQghv6B6VMEn6Dg6gmH7q385is23ai3yQNsiPaMD54ejdY	10691	15057	15057	1618649460000	canonical
21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	21290	3NL1yviEsMLb8WUy2tUCNykXkuFUXzwgw59hvjjfXLw8SxjUdSR5	1637	816	388	12463	13534	jwQn8NZAehB4YnfoRdJtgqsUnovaMT913cNXxtZmKPvt66m9ECc	10692	15058	15058	1618649640000	canonical
21292	3NKKoY4T8G483cBkkmakqjJEWNRgJro2iSmXoxhiq3MoPvTQAXps	21290	3NL1yviEsMLb8WUy2tUCNykXkuFUXzwgw59hvjjfXLw8SxjUdSR5	1467	1376	388	12463	13533	jwiFHQKohyvC3pe47bF4DDNHhen5SiGMnoFNh5ve2kdRPMx1ejC	10692	15058	15058	1618649640000	orphaned
21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	1407	1395	388	12463	13537	jwenqwKws3HCgiWLkuNBDmwZB5RUWcNWX8i994WTBjEN9x5ejY4	10693	15060	15060	1618650000000	canonical
21295	3NKobGstP7jLY8FgzvaZqYeHhmMTpHb9qUhpTAtCKDJ3C6umqNNQ	21293	3NLAZAuCPoVebYz4ycJUt7kZJ3xNs7x5C7BtXahsFywdyZddVfcJ	1490	1274	388	12463	13536	jxidmAvCNP9uVNr1NRHMGpN6Uabe3dH4bcJ76spv7SujgYiaagA	10693	15060	15060	1618650000000	orphaned
21297	3NKZn9gu9SDzbZKMP1wJpm7gLASzU5EGYFEwGKKUEqqHYa8wuA5T	21296	3NLtzqBFPNGiQPGVxutc9WgqE4AF5MmtrRJhwV3TowxJdmvcPPjN	1593	1100	388	12463	13538	jwu8HFaRtwBJk3kJfJDS2ZkZTnQvLqQcufvmJi5Fp6VFbahn2qD	10694	15061	15061	1618650183009	orphaned
21304	3NKP5cckRVDkwUSF3zTXFXQufkoQByTqYa46aEFyt9YgDHmF7Pn1	21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	1474	1329	388	12463	13544	jxkq545JrN1yhiU75dUhSVyQXMQuNZX8E9Vkd3DPPaHDzswDKAT	10696	15063	15063	1618650540000	orphaned
21309	3NLFjx6Qz32obiFQPZB6nyP3LSqJLbnYBFfM6MYPSZ4wJwaaDjsj	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1633	1024	388	12463	13548	jx1twTMAC3LXWPwyJxMTmEtMqA9ayHnyFxuPT4yXHJmLGHiZsVe	10697	15064	15064	1618650720000	orphaned
21312	3NKhNsHojTMoSEBYYpXTUtmzJa6xCt1v4eKrBr5ThGZBUpiVktLN	21303	3NKSMhi4wJUE3Cfb2PCkbPWNtzkYwVVDNzbLBDdA5hSKErNva2nC	1489	1254	388	12463	13550	jxfrnEiZM22SFEvWt38esutVcLppKf1Ku9c61CeZvGnQK6EqjoQ	10697	15064	15064	1618650720000	orphaned
21320	3NLBgMQ5dHpvmNKxQZF3cdszRsEQxTGkVaGcGCfUagJRZSYdF9Br	21319	3NLFyAMyYS6pyYkMhrggZYhwxtN4EUCeA6p6Jxh7yaZYV5Vb6GMg	1553	776	388	12463	13556	jwuvGKhewQVKz7CNYBDKFNR741VCZ49MubUWbShe8vCkcUwiB9Z	10702	15072	15072	1618652160000	canonical
21323	3NLnMschd7UNMWN2Bgr3NzA3muj1qWK5LWWe971918bzCC8rx2Lu	21321	3NLiJTTUWzXHhh17tn1q7nHq3WZnxJYDLkhhSEYJsXXg8r7AmaHe	1541	1172	388	12463	13559	jxnS325SKFXq4hBxK7tmCGGDhfBzpKDbazsR6xBL6A6vqmwhTjy	10704	15074	15074	1618652520000	canonical
21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	21324	3NK8MVhxAChsgzqQKy3UXU9B6Ai5ZSCMPua41XYWMBfDdrPE5ywE	1599	1287	388	12463	13561	jxFuCncr1XnT8rzuCrAq1oUmw7GzwyqtigEhjicEkYEicqUoqW5	10706	15076	15076	1618652880000	canonical
21328	3NLbkSueqqkoH9dhjLBZj1BqmrbGWiGvLFhzmgbPsCRmDDh6fm69	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	563	1113	389	12463	13563	jwB9mDrX5g5TZTdi6myGWopkSafqMryBB3xj1X1cSBNDVy3pQRp	10707	15077	15077	1618653060000	orphaned
21332	3NKjr9PgssGxaZsC7Mj6CCzD8WmDevSKtkzrSh3QdKQhaGENYudt	21329	3NKMPVGE2gRawreNBG4MYRyiV9NUz121LfyrFZ1Z37b5ShqHJStb	1522	956	389	12463	13565	jwvU3GVFDgemUdkKRAgMNrTccaQNpcy1iCUpJiTJCfa3ytbE9XU	10708	15078	15078	1618653240000	canonical
27268	3NKXQfHxxa1bCCYXSmaDcWDWWRW17dfe1ZT5HHPTq5geNio5u42z	27266	3NKm9UQ84sKVWJVvNGYdRQCuQqBGSXWeDyrmcT1M1E9oGpVDCCqo	1406	1393	528	12463	18885	jxryqm1njz5b48zD5Z2cV36SXjT8Qh7KJonvXAr1B63rLtGhbqq	13479	18970	18970	1619353800000	canonical
21302	3NKuTpJEBAYNapkAfvS7WKB72A612qi5qwwngf2YVMbL3WVFqSVf	21035	3NLxSevxzaNVByEoPiQGqj7JoUskYMtS82YVuDqYaoPkLEfYSn6E	1474	1329	383	12463	13542	jxvSPriMdmXd4mX1cgsJ6rTVdKDwPxt25QRRkPZ8LCsATbpoeAN	10573	15063	15063	1618650540000	orphaned
21301	3NLPSyZqkPdjVf3xMvitrAiRM2PADe58a5KSMVV3fgbQuqnAxU1h	21299	3NLaLw4ezQ135z5wZZkx7o8o1TSVqNX9vw4NMqAbcdZgq4TBzpy5	1444	1135	388	12463	13541	jxrzD6HQdKQjeGtc1VhF3k2MGRrgTwNZnx8WEFHpzUJnWf6t2eY	10695	15062	15062	1618650360000	orphaned
21303	3NKSMhi4wJUE3Cfb2PCkbPWNtzkYwVVDNzbLBDdA5hSKErNva2nC	21300	3NLTMkYsu2GQWWt8UzzoKAHyLi8t4u2mfymkAxnk5xNU4LvHStSU	1627	1385	388	12463	13543	jxxxW1jRVu5ynGJJztjxrCFPrxHhAcvi1gjrbXCvtQRiXNMNzta	10696	15063	15063	1618650540000	orphaned
21306	3NLVM2UhJVgBx8aKvVbhvdGswmD542R1X3gvgxESsCxEGCN1FMKF	21305	3NLhS2JJHMabfYZw41K731o1cDozWVJzF2P8Jd1xT8H1jT7LQQJD	1489	1254	388	12463	13546	jwAVcykVrDhYDyKmg6gFtizAaq7rjx5bQ5bm8UUycmpq7znXTbG	10697	15064	15064	1618650720000	orphaned
21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	21307	3NLgCS8EiEyTXdppaAujUT2VkkDTCEPPXVqGnJckQM7aKnUrVDys	1421	370	388	12463	13551	jwJd66duP5nx78Zmtx9HLEhN2ryBPuacQ1sksvCgASb8Q9UrtDz	10698	15065	15065	1618650900000	canonical
21315	3NLi4bYiynXbKEaQsHY7y1xDpqooBfDWg8J6nY4u8bDvEU39f9Dj	21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	1407	1395	388	12463	13553	jxS4eGAocerfJa9qNB2Kj56wRxsb4Du9NYL8z4aP2Xvgr21xr52	10699	15066	15066	1618651080000	canonical
21314	3NLDr1DSUrNzh3CGFEBf6S4WYv8d7iWYWQPKg8YTV99Kzz5HF3m9	21313	3NKMMqdVdCfDcHCjziQrmJ12TsRiuavxPLZPRT3qm3BY9Jx39V3g	1571	1335	388	12463	13552	jxi6QtSPRhpjBMr8mWzb3oWosEf5KXooNCaLAGJpyzLWAWd3z3d	10699	15066	15066	1618651080000	orphaned
21318	3NKQfAkPPqCAgBpuwgpjRGQ7XxW1629GLY6HFr8bWTe9h4P6mFrv	21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	606	1169	388	12463	13555	jwQpawyTkwNeUpN7bmGevWgeC7TW16g3a8yDyWkhdS492nV2PYG	10701	15071	15071	1618651984574	orphaned
21321	3NLiJTTUWzXHhh17tn1q7nHq3WZnxJYDLkhhSEYJsXXg8r7AmaHe	21320	3NLBgMQ5dHpvmNKxQZF3cdszRsEQxTGkVaGcGCfUagJRZSYdF9Br	470	1063	388	12463	13557	jwcm3z5sUwqzLPbyYWWinMwQ3ndkHb1pZDAjjJ8qAX3KihZQdLp	10703	15073	15073	1618652340000	canonical
21322	3NK3iGd7vqoGFzN1NjPcdta64hDkucr9Li9D3WnPvZAc8y9cDBDj	21321	3NLiJTTUWzXHhh17tn1q7nHq3WZnxJYDLkhhSEYJsXXg8r7AmaHe	1637	816	388	12463	13558	jy2ejPtY8m3MHNjtNEoZRTmVgetxeePsAUTBh1wV4AotT6H2M4Z	10704	15074	15074	1618652520000	orphaned
21326	3NLpnqqCuCG1WwT4RHAQBhnHH8YF242cDs1fVPPCZkNjsjfBZmY2	21324	3NK8MVhxAChsgzqQKy3UXU9B6Ai5ZSCMPua41XYWMBfDdrPE5ywE	1599	1287	388	12463	13561	jxFuCncr1XnT8rzuCrAq1oUmw7GzwyqtigEhjicEkYEicqUoqW5	10706	15076	15076	1618652882590	orphaned
21327	3NLNeFZ57mXT3dehjFT19NHa6oeQhaybTnR3TDhKmm1xRNeGm6gH	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	1637	816	389	12463	13562	jx4QLx7qp72gn8rLFGrmuhQryUmxRD3zT65kiKrqCMcFHsAXTVD	10707	15077	15077	1618653060000	orphaned
21331	3NKTW727UewpP1va4NJhZzit52MWkv7Vao1y5tAezXQcTVLHTPHf	21329	3NKMPVGE2gRawreNBG4MYRyiV9NUz121LfyrFZ1Z37b5ShqHJStb	1503	1031	389	12463	13564	jxxCj486x4httUajY3BVopVsBboUCQLDdFnWrmjHqM23iqKRsrn	10708	15078	15078	1618653240000	orphaned
21333	3NLGvjmFpfftkLscKP7RfCYpEYd7LvX8fisFP6n1wPQ6cg1KUaAN	21328	3NLbkSueqqkoH9dhjLBZj1BqmrbGWiGvLFhzmgbPsCRmDDh6fm69	1522	956	389	12463	13565	jxooYLux71RDuzn3DSNkE43WMsTnMmpDwM9xmNQXg1vmCYLnLVz	10708	15078	15078	1618653240000	orphaned
21335	3NKnREh1tgkN4gLwzUfqBXcfsK5ad37SePW6bu3EmQ3fBcup2NWe	21333	3NLGvjmFpfftkLscKP7RfCYpEYd7LvX8fisFP6n1wPQ6cg1KUaAN	1594	1200	389	12463	13566	jwhJtZvbVhps1Q9UgWGt7MZLXgZzDeRcEPWhzC93NFCoqGt2jAk	10709	15079	15079	1618653420000	orphaned
21337	3NKvq4D44xc7J9UnuLGuzjQEuBdskyWifJ8ntL9F5UweF2HzmoVu	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	1407	1395	389	12463	13568	jwby6V8rfiw7bAsnFJrvGGAtfuhwm22M3RHn6mo8D2rj74gLNHS	10710	15080	15080	1618653600000	canonical
21339	3NLPaTFzxs8Z6G8CL8FAAGEbsxkprXQMrNgJV8TVb7qB3zt3dJ8G	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	526	526	389	12463	13569	jwEQkddJrxYK4xi48Fsxee1bZijZydGxfgECEQmHYm6MHQLm3W6	10710	15080	15080	1618653600000	orphaned
21340	3NLifzHhMTMmJ5GZQgqriXMfF7YADsFgz1j4Cq19V9xPS3kY4QAj	21337	3NKvq4D44xc7J9UnuLGuzjQEuBdskyWifJ8ntL9F5UweF2HzmoVu	1553	776	389	12463	13570	jwV9FRTcF8DAEn2LjHUJEBozqZmE4LZgsKy2qKRa91Sv95mT2LS	10711	15081	15081	1618653780000	canonical
21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	21340	3NLifzHhMTMmJ5GZQgqriXMfF7YADsFgz1j4Cq19V9xPS3kY4QAj	1542	1304	389	12463	13571	jxk8q9qZ6emkeq1nHEwPAw1LxcSZ8Bjkx4DhTYBkZC6RT7Ni8HP	10712	15082	15082	1618653960000	canonical
21344	3NLUSdrXPNYiePqH5dx2XHkg4oiBx3b2LkCDPN2GqMTrjhE5iu7F	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	1405	851	389	12463	13574	jx62m1L2UW9v7SCzNu3iboqMmhquAQfRmvuBgUMDScuaN7bbZCx	10713	15084	15084	1618654320000	orphaned
21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	21348	3NLo6kkB1bTmCrvEJRcfkRVprCCvpzCsatPUpLMH7arDGZCPd4aa	1508	1141	389	12463	13580	jwHUEn828Sxi6FETsAZSrt3JQAx3yLwqUt6h27SY2XnvYJvGCZP	10715	15088	15088	1618655040000	canonical
21351	3NKky3qkPy3wWUtxYRSRdtNkG6nVr9WkvWHMoHpvsJ8jiUC3o52k	21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	1460	1078	389	12463	13581	jwHpvghzigsYmPyA4c3Dym1nqFXsULy5UavPuwzx8oLGhhZjeNC	10716	15090	15090	1618655400000	orphaned
21356	3NKJDjq17f5Rjqq29JJpXn91SkCWLA73xTqAzV1trJQWy1wiwYse	21354	3NLizNQRgFELyS1frGB1TmQawaiWDCLsmxnzPV1PEpYbCBE4YeSC	1471	1386	389	12463	13584	jwdFkJEHPT6caS8dQPBBkqa7AzPWRaWY4fRhmWLDaVF5KKdZYHY	10719	15093	15093	1618655940000	canonical
21363	3NLe9gxWRoSq6aasLHWDQaap3pgPSs3zbtHeDqhTRkYfYjpAkPDg	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1542	1058	389	12463	13590	jwsZX8y4iqy4C5ipfTieY7mut5boYjvHkJeHkdmCGb3NQt6HFNe	10722	15104	15104	1618657920000	orphaned
21365	3NKt9oeXUguaUanmdLen2GvhQhW6mNAZvzbAPcSW1q6mbPK5LsM2	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1611	1341	389	12463	13592	jwLpR146N2GWNNj7CBjoMwuD6BCPFpk9zWXh5bodTQkNbKCoq43	10722	15104	15104	1618657920000	orphaned
21367	3NLEwkwbDvYR6AFPGf9vbwWH572czkCXaHc2Ukn2LcMVmy6jRSid	21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	641	1336	390	12463	13594	jwFmViidRffQRcRdqDtYX4rX1YdGFW4E6E8g7jjefhhU8BiPRC7	10723	15105	15105	1618658100000	canonical
21377	3NLkQWNGiDaeY41XohFLN6KBWNbMvRMGa6MGD2hjsMEkmrUEGfxA	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1419	814	390	12463	13598	jxGYsbgLRa7vnqEuszzFz1BMkpD4RJ2Br8Jg5BwZRDd4aYWtzuR	10725	15108	15108	1618658646305	canonical
21374	3NKahMqVjiLyT2QP8J4WTraqBdH4QVXKgh7GgBWPZTfJ1HtjpUUr	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1547	1252	390	12463	13597	jxDq6UHHUbFwe5NJMRS8Qdwhv6xGJW8HPHJ1osNnmVpK2dvMF1B	10725	15108	15108	1618658644883	orphaned
21381	3NKVQLvu1ZS9MBh3kntd35g8zu55QDEAdGTxXCQhwZgEHfBTkaEq	21380	3NLagsxYto19Pbe58gc61D73Y2ezYd9uGzdBpePVWdFbhQTPRjDg	1559	1353	390	12463	13603	jx4k1rN1awAMCZ6gMmR2EqgtJsAP956VoSo6NYrbtux3MCQQhKF	10727	15111	15111	1618659180000	canonical
27299	3NLBR6jQEAVk1e5T2eVpPJDemprLjR7amE3gRa8HPCEAoD77no69	27298	3NKJdMFyaBUUEEJK4qDrGCKcLBqwJNzTGqyp1hn2aeEw15GjEjvv	1403	824	529	12463	18916	jxVXPXoVegtSk4kdGMdryB15WKJQ7pV75vAL9TR3GxzJsKbsiLQ	13493	18990	18990	1619357400000	canonical
29167	3NKh52CTApRd2GHUntX8JLho9g7oTg3uB2ddGywpxq44SdcjiqGm	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	1508	1021	572	12463	18974	jwQ1u88M3BpgAeHcRfUkDtzVQxmDbNCbpebaxvSvxMnYJUiVrBa	14380	20252	20252	1619584560000	orphaned
21347	3NKiE59mCF5UdXMSRyBJseZaGjLaoUA5UvKhv9nHNRpu4BmWFxPr	20973	3NLHndNSeyGbhRoCBvABmNEAUfKMoDwBiyxJ83h2g4D9WJsYvWMi	1483	1276	382	12463	13577	jwpFXgZ7mS1uhcPYFyum3hx1yDg7QTaZshpBV4kZgzuCk4cecis	10549	15084	15084	1618654320000	orphaned
21358	3NLcAHukUWaz7ttjgiXLL8ptKF5WxsYtudZuDVPGBaSmv3HKq5rw	21315	3NLi4bYiynXbKEaQsHY7y1xDpqooBfDWg8J6nY4u8bDvEU39f9Dj	1581	778	388	12463	13586	jwXcofobYfMLfR8wkH9Eg9C1cJHL2cMFbLzfrkCmmsbJgnNAcFX	10700	15100	15100	1618657205462	orphaned
21319	3NLFyAMyYS6pyYkMhrggZYhwxtN4EUCeA6p6Jxh7yaZYV5Vb6GMg	21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	606	1169	388	12463	13555	jwQpawyTkwNeUpN7bmGevWgeC7TW16g3a8yDyWkhdS492nV2PYG	10701	15071	15071	1618651987488	canonical
21317	3NK3zSMt57khQHKjRTwSydCzZDYPNwZBc5Ak8yznZhgp3GsHWRGb	21316	3NLRsJjKT7kAjP62xg36QPcDuda548C7Kgb2YGmcxt9ffpG99Gse	606	1169	388	12463	13555	jwQpawyTkwNeUpN7bmGevWgeC7TW16g3a8yDyWkhdS492nV2PYG	10701	15071	15071	1618651980000	orphaned
21324	3NK8MVhxAChsgzqQKy3UXU9B6Ai5ZSCMPua41XYWMBfDdrPE5ywE	21323	3NLnMschd7UNMWN2Bgr3NzA3muj1qWK5LWWe971918bzCC8rx2Lu	1579	1389	388	12463	13560	jwVWVUbWXXvyd2Kp5k5kyynZ6QtVudc1YwYWo9Hbc5cocQQjtFt	10705	15075	15075	1618652700000	canonical
21329	3NKMPVGE2gRawreNBG4MYRyiV9NUz121LfyrFZ1Z37b5ShqHJStb	21325	3NKVXKmgpa5Kzf3TP9fmdFPE6WUmVKwApPnaf9m6FjrTPpNWtK5M	563	1113	389	12463	13563	jxmUHgHVzfBkDPZsbQDsUmwCQwVi4KzMvW6K4zUNviN9BCBZ8KK	10707	15077	15077	1618653060000	canonical
21338	3NKrdECjt5MZjctj7viC8aAZvEAyNzo8kQmoWpiUXC5Y2Y43sCAd	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	1672	1285	389	12463	13567	jxCBY95kFFeMrf6fwDQRG6qTkr6cPy2dsP9tUL2kcyTiLhgqT2C	10710	15080	15080	1618653600000	orphaned
21342	3NKRsZgs7d1BMrgsntkchkDr1XqHpeTGXXecW7dqVbFVCyE3spNh	21340	3NLifzHhMTMmJ5GZQgqriXMfF7YADsFgz1j4Cq19V9xPS3kY4QAj	1549	1362	389	12463	13572	jwRmee4TX9brdRBu1VmdQcG5C1e8DBxHodzL29cojrcYZ72N5Ue	10712	15082	15082	1618653960000	orphaned
21349	3NLF48jqbqqP52So1tcqdioXow518G5RdBdaaWEM1RukjAmG4wyz	21348	3NLo6kkB1bTmCrvEJRcfkRVprCCvpzCsatPUpLMH7arDGZCPd4aa	532	1057	389	12463	13579	jxUjG5Nf5xvhtDhfwNCfEMWhyYvSQ4YdREL5saaP67QEXgx5xRD	10715	15088	15088	1618655040000	orphaned
21352	3NKKLAB4znymkjAiPKTGtjqmq3iFNAx6gC6g5S9zbSgyhenGLNkc	21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	1460	1078	389	12463	13581	jwHpvghzigsYmPyA4c3Dym1nqFXsULy5UavPuwzx8oLGhhZjeNC	10716	15090	15090	1618655403404	canonical
21354	3NLizNQRgFELyS1frGB1TmQawaiWDCLsmxnzPV1PEpYbCBE4YeSC	21353	3NLYpvj3pnnNkmBwkXVsmey11naF53eNn8bA3nFTEDY7ZPmkEq5a	1607	1222	389	12463	13583	jwoQKf2UskkaQyxsLUY8YEMefRtT23EEzseP35YXrsAMt8rF7Mw	10718	15092	15092	1618655762869	canonical
21355	3NKkddaNEMs1V9S84dDQ7mJSqv54LxzZNzzg3TNwfQHXEN3F4BzJ	21353	3NLYpvj3pnnNkmBwkXVsmey11naF53eNn8bA3nFTEDY7ZPmkEq5a	1607	1222	389	12463	13583	jwoQKf2UskkaQyxsLUY8YEMefRtT23EEzseP35YXrsAMt8rF7Mw	10718	15092	15092	1618655760000	orphaned
21357	3NKvPiqyPffRPyjDswS1oU117jwzgQuaCpCuMGajLkFxjyVb4Vv8	21356	3NKJDjq17f5Rjqq29JJpXn91SkCWLA73xTqAzV1trJQWy1wiwYse	1553	776	389	12463	13585	jwyqYDRfvNBZ4L9Fp4iPCSTgtW1pVtaNLSm2UWrKvaNEqa42N75	10720	15096	15096	1618656480000	canonical
21359	3NKHYHGZ114LczHBxFuygKsyL8PDgnJFcEafYXxUu4ayxqnrBCzd	21357	3NKvPiqyPffRPyjDswS1oU117jwzgQuaCpCuMGajLkFxjyVb4Vv8	1637	816	389	12463	13587	jwqUBB4wrW3VqFMHT8bPx2WN7MmRYt2UqFLf1eUTTM3du6b1zdJ	10721	15102	15102	1618657560000	orphaned
21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1542	1058	389	12463	13590	jwsZX8y4iqy4C5ipfTieY7mut5boYjvHkJeHkdmCGb3NQt6HFNe	10722	15104	15104	1618657920000	canonical
21364	3NKPUDUXbtfuSuf3m4bsHWcK58XRLg8xX9piy1PnVhkPj889zHjW	21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	1637	816	389	12463	13591	jxhyB12bkjheTTEiZn1R5dAfznwfNm6SnWAkpEjjYqSHQtiJaxf	10722	15104	15104	1618657920000	orphaned
21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	21367	3NLEwkwbDvYR6AFPGf9vbwWH572czkCXaHc2Ukn2LcMVmy6jRSid	1447	1345	390	12463	13595	jwno43cwaYqnr6zdcVGzuuAA8CLHGSU1wREw1ZfnNhsWLCtSnyd	10724	15107	15107	1618658460000	canonical
21373	3NKMv48bK2kAazoyPb2NWMF9FV6h6CRdGJzrDdqwdMCXdGXpawpL	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1547	1252	390	12463	13597	jxDq6UHHUbFwe5NJMRS8Qdwhv6xGJW8HPHJ1osNnmVpK2dvMF1B	10725	15108	15108	1618658640000	orphaned
21376	3NKLJqvaBLRZBnQ4TcybxdBACGMsnVXi7cWVS9boJKpJkTNLPQYi	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1594	1326	390	12463	13599	jxgkn1W32U2diGsNgrhR5DcE4vWCAKCtGrm6m59wyxYFAzQSEZT	10725	15108	15108	1618658640000	orphaned
21383	3NLwfYLgxsK49Wctr1PPYbGAWigM8obyKV1SCWARXkdpjF4sn8Y9	21381	3NKVQLvu1ZS9MBh3kntd35g8zu55QDEAdGTxXCQhwZgEHfBTkaEq	1402	876	390	12463	13605	jwNM2wfZKcJq6N1cdWtbXgbosG6tE7Fb1uWFJgLRjBQxidwp4PT	10728	15113	15113	1618659540000	orphaned
21385	3NLVeSvNgYKQsJJ9ZBjSD8cw8sTvrqYhfYkphWtQN49sy6FX93Ps	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1509	1074	390	12463	13607	jwdMJq5E4EQ7YnD7xLfDdjaiyApELi6c9Q4du7Jgkrf9zHbx1Bz	10729	15114	15114	1618659723369	canonical
21387	3NKy5PcnnX1wTeBabbF4JoZmN39BxPv4mQaorDYemMXZu7Jfx6Zo	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1509	1074	390	12463	13607	jwdMJq5E4EQ7YnD7xLfDdjaiyApELi6c9Q4du7Jgkrf9zHbx1Bz	10729	15114	15114	1618659720000	orphaned
21389	3NLUnw7sVe9mUJMfaJuyqPn48daSZSKFiGbgQnwbQRVSTNVrcZ96	21385	3NLVeSvNgYKQsJJ9ZBjSD8cw8sTvrqYhfYkphWtQN49sy6FX93Ps	633	1018	390	12463	13608	jwXBvnbGn7V6oGJqWhKA9KfVHf6jXKz8CZjVKrzyTSuhz4Ay9XY	10730	15115	15115	1618659900000	canonical
21394	3NL82vDTDhUtpwAu6CtAbdq2fzAmD4zqfZLGd8Wbz5jygqy8qRL3	21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	1406	1393	390	12463	13613	jwsyaXyZUAe8EuGrqJUXKXhnE7eDZMqRbQUUkHud1W9rZ3ueAJc	10733	15118	15118	1618660440000	canonical
21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	21394	3NL82vDTDhUtpwAu6CtAbdq2fzAmD4zqfZLGd8Wbz5jygqy8qRL3	1447	1345	390	12463	13615	jwh9aFyv1dV7YNNPe2dYjNKudZayXvbg3X9FYKa47VMXE4m27wh	10734	15119	15119	1618660620000	canonical
21398	3NLdJQxgyRsN7xMkgcV8C7Htkb1p8a9b5bxX6oxhnvFLri2kEpDp	21394	3NL82vDTDhUtpwAu6CtAbdq2fzAmD4zqfZLGd8Wbz5jygqy8qRL3	1541	1172	390	12463	13617	jwMQBpB5QzjcazoScFUwPmX4QzLhG6G5tpRyihrDviuNNnW9Rw2	10734	15119	15119	1618660620000	orphaned
21402	3NLrQQCDRLTm7phUdxo3wwWpgFcP6NHVzRtnLoeZFrBYBmdzThXt	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	470	1183	390	12463	13621	jwFPvcboqYwQ5MxnMtCCx6ayy4vs5Aa96WLr3NQrhWq7rHpnZG4	10735	15122	15122	1618661160000	canonical
21403	3NL53dV3Jae19h3e7iwN1RhTDG6gTm2KmKFzMVuyhinkCPYGv1FJ	21402	3NLrQQCDRLTm7phUdxo3wwWpgFcP6NHVzRtnLoeZFrBYBmdzThXt	1402	852	390	12463	13622	jwq6JtDHN8qayUPL3PR8z5WxX2FPo16LQkd2ChbkeavMMbEPupF	10736	15124	15124	1618661520000	orphaned
27698	3NL1u9VRjJ3RciCCVdnqzBqVAcrJjStmt5z5rFRrWcx7APAvfhAK	27335	3NKC6xkLNDNp3NhP4RwVcFiupt9pJwqP5nyVthsNyW8vntGB3aSL	448	1305	530	12463	18950	jxpmfwpgM7yAJtxWNHvEBUNYkGWQBgG1PxQjA3AwzUNJVfFH2wd	13513	19270	19270	1619407800000	orphaned
21411	3NKhZTCRuP4MnJziyJwdvXsWaabDvTTCo3qjv6xiwKZKMVv2fFbB	21205	3NKmuvwaKsK9mvkRLVoL45ZduHbYnDMeMNKDWXwXf5fBAUv1CrLH	1647	845	380	12463	13629	jwxT6N3o2tucX1LkUcamdJpM7x9w6snwqTHU4Q8spvihHXmawrX	10463	15126	15126	1618661880000	orphaned
21397	3NKBDJXJ884fLe3vxzLQMrNqSgrt9nsNtvS2tPBMvgMmvFLQtC8G	21358	3NLcAHukUWaz7ttjgiXLL8ptKF5WxsYtudZuDVPGBaSmv3HKq5rw	1581	778	388	12463	13616	jwQgtnWjFjNQ1QPjxudYHPpehgnnyKNQ11ojcaJZsfSTHKRjMRw	10701	15119	15119	1618660620000	orphaned
21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	21332	3NKjr9PgssGxaZsC7Mj6CCzD8WmDevSKtkzrSh3QdKQhaGENYudt	1594	1200	389	12463	13566	jy2wNBmV9YMjRnBQavmjMSAPsjSgJoSSLANKZ9VBquh9meCVDs5	10709	15079	15079	1618653420000	canonical
21392	3NKBarD2Yya69WVFyxucLaYJMUqUPUwEnSTqkSUSuu8vd5z8ZmMw	21331	3NKTW727UewpP1va4NJhZzit52MWkv7Vao1y5tAezXQcTVLHTPHf	1536	1187	389	12463	13611	jwEwN89EfmX3r16S99KumQPQbDqV6u3FTr8HMJ9Wjj76vQoX4Yk	10709	15117	15117	1618660260000	orphaned
21336	3NKisMZYLrQecdp2axTx8g37sd1Nr74bJrNvJSXtBhgwbYbtFqAj	21334	3NLwfcAW6FriPDuesXAR9Bqwcxcob8ApqaBS1Rw6SWRDCyWJCLYS	1672	1285	389	12463	13567	jxCBY95kFFeMrf6fwDQRG6qTkr6cPy2dsP9tUL2kcyTiLhgqT2C	10710	15080	15080	1618653603018	orphaned
21346	3NLXtf7wazsfUYS8C5L8fjFz6h3UcGNDp2x1nBXqPg9Ge1rs7drj	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	532	1303	389	12463	13576	jwjUJz5m1tgn893JaH1hLmA7W41RjEmtRCEQtogPw9XocL2YJ5q	10713	15084	15084	1618654320000	canonical
21343	3NKMHjqC9VbV1H5NfHFWGGrGbMwAzc2EXrSxK1RfRAHd5vgQ82uU	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	1600	1126	389	12463	13573	jx4mzFD4LQ3iaRtNb6wwF88BqkCXoqSYMdombFFU3F2dc6Nenjx	10713	15084	15084	1618654320000	orphaned
21348	3NLo6kkB1bTmCrvEJRcfkRVprCCvpzCsatPUpLMH7arDGZCPd4aa	21346	3NLXtf7wazsfUYS8C5L8fjFz6h3UcGNDp2x1nBXqPg9Ge1rs7drj	289	289	389	12463	13578	jw6pEyQuY3xVR65QV9bzogoQ6Z1geWHeS1Xt1x93rciFkkiFfpp	10714	15087	15087	1618654860000	canonical
21360	3NKE3uSgd3rBNcbxy9TKoVrZECWc1dSeJ36neqmLFWfag7LNXZqx	21357	3NKvPiqyPffRPyjDswS1oU117jwzgQuaCpCuMGajLkFxjyVb4Vv8	1402	892	389	12463	13588	jwXbgNp355VMfv6hx9xppfo4PbEVZV3ojMWNDjNh1DwpBcYXVYg	10721	15102	15102	1618657560000	canonical
21368	3NLaauqwED9nTXYh1gwgC8zYQW69MRZ9V1cZEbgP4g7ATwZSQ74r	21362	3NLTVUKZMEf36y4heFrcGuAmff4bHFfFxExrCK5qhTyLBfDJ8kfp	641	1336	390	12463	13594	jwFmViidRffQRcRdqDtYX4rX1YdGFW4E6E8g7jjefhhU8BiPRC7	10723	15105	15105	1618658107725	orphaned
21370	3NLJDGbFJhNLF5yfwpMSQ8QCYXimbQhxXi7Ue88X4kLHihBKmuai	21369	3NKFPv8X6k2jV6UwnjEtokcYJ1B4HDxQm8YWoREDMt7gXfEBx1pJ	1447	1345	390	12463	13595	jwno43cwaYqnr6zdcVGzuuAA8CLHGSU1wREw1ZfnNhsWLCtSnyd	10724	15107	15107	1618658462967	orphaned
21372	3NLSrfx7roBCwe4dNq7wFrTut7QXM54P3LPicVUxeB9ZrvvC8y1S	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1467	1376	390	12463	13596	jw99vqAPLRAX9ZjejfhwdxJraKELJ4Fr1Q64vbb4ywdWyLfY1HZ	10725	15108	15108	1618658640000	orphaned
21375	3NKivdCaWhFmqwheFosmi7XZDTHcQe1VWNszeVstjRjb8K3NZBzj	21371	3NL4VoKfETUsYG1uGBAKy3Bci7adZgLnvLXAMCnJTKDWm9RXsHhR	1419	814	390	12463	13598	jxGYsbgLRa7vnqEuszzFz1BMkpD4RJ2Br8Jg5BwZRDd4aYWtzuR	10725	15108	15108	1618658640000	orphaned
21380	3NLagsxYto19Pbe58gc61D73Y2ezYd9uGzdBpePVWdFbhQTPRjDg	21377	3NLkQWNGiDaeY41XohFLN6KBWNbMvRMGa6MGD2hjsMEkmrUEGfxA	1637	816	390	12463	13602	jwySk7hHb3McAMkNRGNSi589wezZoD3qnJBiAaVEReWnwioEP8x	10726	15109	15109	1618658820000	canonical
21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	21381	3NKVQLvu1ZS9MBh3kntd35g8zu55QDEAdGTxXCQhwZgEHfBTkaEq	1579	1263	390	12463	13604	jxm9j2uQpiu7kJAJp9DB6ywGRRLFojtKDG43s7Ez68fvKzJmemi	10728	15113	15113	1618659540000	canonical
21384	3NKmQcWpZyaZBzuVpfeSvKzMG5jGw3Mv6qGehr67jMXTH71v1HUA	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1426	1118	390	12463	13606	jw6cedpe4j3XkHrwqbviAYhJutxXa548PFTw1mk5BSowuFwwBkU	10729	15114	15114	1618659720000	orphaned
21386	3NKPFSgfavpF5NEaMD9h1bQfYU9EavS5du89bA3dvELQJm3UQxj6	21382	3NKFjEDZGzxah9ZTJmQ4Pbb4wnaS8HEtkkuHVsUUjhfgBgVaDPQe	1509	1074	390	12463	13607	jwdMJq5E4EQ7YnD7xLfDdjaiyApELi6c9Q4du7Jgkrf9zHbx1Bz	10729	15114	15114	1618659723739	orphaned
21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	21390	3NLGCBbF4Kj8zuNqnD92SXKpXHbQZypBSTViu4sUEE2mbDeosR5n	1536	1187	390	12463	13610	jxTdmcZpJUK8P6Sh4mxyB1sRYfU1z5ZhSWWwmx4kMxECfwGh6kU	10732	15117	15117	1618660260000	canonical
21393	3NKK8kJYefGk4MYUJbK4MHLwftX3zvA9d9KLmrg5hTG4WC2NiST1	21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	1599	1161	390	12463	13612	jxU4Z2JZwDdv76b8xxMuhM6TcdWHWURFb9N4E3ZXdJAvFj19yGN	10733	15118	15118	1618660440000	orphaned
21395	3NKTJYdyo7779RKz776yoX5DLEq2evgFZq9xyS4BRpdDJJiFDbpg	21391	3NKRdUW92mPxnJAaDjEU6erNPYRvmw3qr6JowiZ4vxb2RMfRWKKV	1577	1201	390	12463	13614	jxRSD8QsqRYt1PmywNdqrTf9DJysRvW9Rjnyf23E9ocTD6T1La9	10733	15118	15118	1618660440000	orphaned
21401	3NLbxk1QQ3VdyMdAnYeVLoPUS98Ajv1CnHkG24C5ePCPejx8FhE9	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	532	1303	390	12463	13620	jx7awFncy87xScc42KWmhMHyfVULb95Y5UDZ1mPEYybTPRsfhs5	10735	15122	15122	1618661160000	orphaned
21399	3NLFq1spiAXtzNUjMWR3cByFzXXDHxpy8e2SJvq9cNExPoTH5aPt	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	1445	1290	390	12463	13618	jy2MY4JcYQXfJpRTKtMAX9wFcY2govyKamZK1D8R1H5iiv2DkFA	10735	15122	15122	1618661160000	orphaned
21405	3NKWHeiHg3KkBH5wJFhe9XKorfuKyDuHofX6gAfu4cfZNpezhFZk	21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	1588	1266	390	12463	13624	jwU1GqrfAdjrwT79xBARqaNLyKqt9L8XBSvXzAB6am41NsSfid1	10737	15125	15125	1618661700000	orphaned
21410	3NLLM1PihMTu1j1E1zx5w3vURQu1LAwkdfFC4m7vUVpJH596pk2v	21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	1406	1393	390	12463	13628	jwM1QrjMYYGRAJBJiW8zyYSpAu9fJLoLUr8kasvap6PzC9B8wsY	10738	15126	15126	1618661880000	orphaned
21417	3NL14vn9DxbKkz3riPJZ17Bfz33iSpPpfRt6LfC8twjh5jmyFtNn	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1657	1344	390	12463	13633	jwAk2NzW9mHb5ZWo8UJrp1EfeQpaeAvPbhokfJk13YehY2b2du9	10740	15130	15130	1618662602670	orphaned
21421	3NK946JfNde7Wj4gjJbX9CbEnoUnZEoFVdpqcdrM67rBHWqEzDXZ	21420	3NK4pFuztgxLYYXdcXEr9qFRFLdgxLWuHiVAUJHYdqhModCKttXY	1445	924	391	12463	13636	jwFDBMyYVAjpmgcsjfceGE5JdFhUGaFU7UEJswWpofQP9XK2Pje	10743	15133	15133	1618663140000	orphaned
21423	3NKT7jmyU1WLsQrgCEkw26EaY9SkCSqhhbPsM9Zihb7SA29fLEez	21422	3NKHwnp85jP2oCtmvPLmsmP1U4d73FcVE2Zc4JSca7yeHT244hej	1483	560	391	12463	13638	jwjkogogp4w3NbdYnW56HuFFgtDoPgYn8YjCFzRjSyAgxJU9mGX	10744	15134	15134	1618663320000	orphaned
21426	3NKiJ39BGRZKo2MUengGHLjqmjdy3MR4ZD16e76Eit8FTpty2Kyy	21424	3NKLs4B7t1MRrbqoGmFqLpdqWoGFDxCWqK37KTpmv9SUyujfRU6a	1406	1393	391	12463	13641	jxMS8CZsNAgnxmh6bKEucTG6hQCcUZYiCUNwa9nY7jEmC1pNa5R	10745	15135	15135	1618663500000	canonical
21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	21427	3NLe6up2uoJvS57eh1iJ76RMCfj9nWUqHfdaKUZhwhbtLDvK4MRs	1406	1393	391	12463	13644	jxczzmiNvpAyt7oGSLTLTqhrqEtHvjR7CkH3WJS48Rvfpfjw7H2	10747	15140	15140	1618664400000	canonical
27349	3NKsJqXs1dRfsneSD6NoTxgcJFNszGm1VW7boEPBJn2okL6nGE5K	27348	3NL7BcFPA7rx3s4Xh8raiiVeB7sQ25RgrXX55kaHWirRq6Mc7drA	1407	1395	530	12463	18964	jxmv5JKMQqmjDo9Ze55Gn2jCjoCD5h9yV7omAXSsS5DcLsgkECP	13522	19026	19026	1619363880000	canonical
21388	3NKezPFcRzxxktadKUx4LNPSXHR9uRPvHKNeFN77EXDa4tmtQj6b	21387	3NKy5PcnnX1wTeBabbF4JoZmN39BxPv4mQaorDYemMXZu7Jfx6Zo	633	1018	390	12463	13608	jwXBvnbGn7V6oGJqWhKA9KfVHf6jXKz8CZjVKrzyTSuhz4Ay9XY	10730	15115	15115	1618659900000	orphaned
21390	3NLGCBbF4Kj8zuNqnD92SXKpXHbQZypBSTViu4sUEE2mbDeosR5n	21389	3NLUnw7sVe9mUJMfaJuyqPn48daSZSKFiGbgQnwbQRVSTNVrcZ96	1648	1038	390	12463	13609	jwSzEUWo32DD16gechZUNP7zGrVDuE2fNjPH6fZPF7r2YrqrGGR	10731	15116	15116	1618660080000	canonical
21400	3NLJSJyjK52vL4GRThWPxE25UE2A6c2n4ffvMdR6a4Eyq2eqzybM	21396	3NLbumipAXAU8H78BbEr8kukV7XhK5bV8DPyEhtWBZvtrfSFwt3g	1471	1020	390	12463	13619	jwi7a3gM4RsFNK6RBUbWEDodDB33tbUsuVD7pS2C26swG98wGbg	10735	15122	15122	1618661160000	orphaned
21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	21402	3NLrQQCDRLTm7phUdxo3wwWpgFcP6NHVzRtnLoeZFrBYBmdzThXt	1631	794	390	12463	13623	jxq6NUt5rBK2GQfMXL8zhxbwfn16KhcJEztWJ8GjyKQhrG8DwUA	10736	15124	15124	1618661520000	canonical
21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	596	1060	390	12463	13625	jwSMXTF2d4R345R1L6SmJeYTSaVNBNEoz5T6FoMDC3isWSUG8mm	10737	15125	15125	1618661712765	canonical
21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	1407	1395	390	12463	13626	jxZV68s5Ytg6a6Sr2MzJCz9KVsodkAwRBxAFh3TzprteoeGzDxG	10738	15126	15126	1618661880000	canonical
21409	3NLeAHyoFpaCseeQVhC8TfJRESjSyVWAXBneKdtiiSt1ezZhbLSC	21407	3NL5npmqEZNGrgeF5TXG9qqAH37kNfL677WuK3oLCzQh63QA5qvf	1408	72	390	12463	13627	jx4HGrz9UDyfEjjBV3P9bBqJy5u3fAU8JUopmdzd2JDnhSQQeo3	10738	15126	15126	1618661880000	orphaned
21413	3NKoPfeEz2gKDvVthzNymJe3YANfxKmF6fnSK5fqSfuVDMNyZrS1	21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	1673	1368	390	12463	13631	jwYtcnH1f4LPbsGbT1GsnF2LbkS2F244cBarSzkaozzJTBaLin5	10739	15127	15127	1618662060000	orphaned
21415	3NKnaEMfSMcc8aDJYbgunqZ8GfmvLn7D5fFnqiwyP4AQ2yLXY2Um	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1549	1362	390	12463	13632	jwgDqaKw1W88d4M7c3fJtr8rjqRdsxV9Hk8tkRhJTqvfYMPcGRx	10740	15130	15130	1618662600000	canonical
21418	3NKd35QPj8X3e1V31T652VYTLpF3fZnHxYr5vtoA3GQ9xbt3FeJN	21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	1549	1362	390	12463	13632	jwgDqaKw1W88d4M7c3fJtr8rjqRdsxV9Hk8tkRhJTqvfYMPcGRx	10740	15130	15130	1618662600000	orphaned
21437	3NKUyTxrFJd41yRrBMRVsmbTmFKnDta6hfZonRgFGDnTWgezVVMs	21416	3NLJhcNXUHGstH1i1WuS8RAF5pBDSTVuS9hiFmQFt8EbZZm8nGoF	684	986	390	12463	13652	jwBKWtiL1GwVn7yWoY8Ee4iYucZwcsFT3m4FHssWVZxmCoMzm3q	10741	15146	15146	1618665480000	orphaned
21420	3NK4pFuztgxLYYXdcXEr9qFRFLdgxLWuHiVAUJHYdqhModCKttXY	21419	3NLbrGs7rG6PY3PDicsJt9WoN964ogZShpMkhf1Vp6VQu9F8bfxe	1631	794	391	12463	13635	jwQAttb1ZefkTFms7T39odQxNq93ZhP9z3mdAt3v95xCYhZhirE	10742	15132	15132	1618662960000	canonical
21424	3NKLs4B7t1MRrbqoGmFqLpdqWoGFDxCWqK37KTpmv9SUyujfRU6a	21422	3NKHwnp85jP2oCtmvPLmsmP1U4d73FcVE2Zc4JSca7yeHT244hej	149	1283	391	12463	13639	jwStq9Vf8YQWxB8Y1ainhhDa9p6cW9tCax28eyvA3Ae3bqTBynD	10744	15134	15134	1618663320000	canonical
21425	3NLx8nuJogDeLfor1yRiE5QVekbXf5v1xNENjCa7pcRAFbSktMp5	21424	3NKLs4B7t1MRrbqoGmFqLpdqWoGFDxCWqK37KTpmv9SUyujfRU6a	1407	1395	391	12463	13640	jwQYLtUrWuwmfvjWbKzkQtjqamRDQhoMhEvhDm4dkkMciRbkFev	10745	15135	15135	1618663500000	orphaned
21427	3NLe6up2uoJvS57eh1iJ76RMCfj9nWUqHfdaKUZhwhbtLDvK4MRs	21426	3NKiJ39BGRZKo2MUengGHLjqmjdy3MR4ZD16e76Eit8FTpty2Kyy	1483	1276	391	12463	13642	jwK6hgNRK9KwKiQTPgCi1vikuE1g3ZT7aT6cpH5US7xsiPMNZhd	10746	15137	15137	1618663860000	canonical
21428	3NK7ZpGzhxWuRr79kxKKN9RQq2xxvRDDHDNtvSaQN9wKJKFc8ehR	21427	3NLe6up2uoJvS57eh1iJ76RMCfj9nWUqHfdaKUZhwhbtLDvK4MRs	1675	1342	391	12463	13643	jxWErMfGZkQf5BcSFVRZf85RD5KUtDyogwx6CkaPUvuHHVW3A45	10747	15140	15140	1618664400000	orphaned
21431	3NKjUqKFg85EztZABuoSvXTcj3HWRDTXxE5igsABWwKhPW8ChAmc	21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	1637	816	391	12463	13646	jxfvz8AKBaa3dR1p5xvRdn2grNLFTzhchcq2iZcZmKwbwZJqEq9	10748	15141	15141	1618664580000	canonical
21430	3NLLpsTRm75uWikaicjFEj8vwdNAx8jMzTBigf33UFH8vJwW7h7c	21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	1656	1343	391	12463	13645	jxRwg7sz7gnKBNRzGwM2hsNp266pLfp4U6uwxRAWhKtNXDaRfQi	10748	15141	15141	1618664580000	orphaned
21435	3NKKX9CZq8q8fvaCM7AY7vjfRHKHfCmSmTZ7qVFL8xadtidjkmGs	21433	3NL63xgc5uG1Sdu1b5zMVEMBuCrBnDBMdjJv3TbGosxuYTaShsVk	1541	1052	391	12463	13650	jxkrP4BrRNKZkkPN83At3X9E1tteYKeC7bkhecQPdmZFjRgy7Ue	10750	15144	15144	1618665120000	orphaned
21438	3NLwuYU6JtegiyYef9gasDL3Zph2rAF5E6jfMHPJ36FRwaiLTA7x	21436	3NKKjEcMe4d4SaXM4VbzfuBj3u86e73KGwnP6d3p1kyx9BvzM7XZ	641	1336	391	12463	13653	jx5jSDXddFSWdF1wzCedWrHpiQxfrxN5dvaK5dT7HddNX4cPNNb	10752	15147	15147	1618665660000	canonical
21440	3NLkcftT6HVhzsJCqrjVTsbWmhxzzy73ZvpQPJyNuY9pgTszLMFi	21439	3NKq9B9uUGKx73DjRWeRJ7iZ1HCijkzEteMDFPE5aB5qVpmTjLpN	1451	1292	391	12463	13655	jwEaXbtqyVJotRsNJcqYa8QoefQ698ccmGgxcoSUTwqbgFpEe51	10754	15149	15149	1618666020000	canonical
21441	3NLiXDgMVJ2eEgsNRa4dMsjApKMRZ4dnTobCj9ER3tQi7BJrk3d6	21439	3NKq9B9uUGKx73DjRWeRJ7iZ1HCijkzEteMDFPE5aB5qVpmTjLpN	1407	1395	391	12463	13656	jxJcTxE6Zn6w4MZTUWvaFrp8hAWZ417wA9TwTDk8au9U6QLrnAM	10754	15149	15149	1618666020000	orphaned
21446	3NK3vZrmvMhSxdTw4BEAoyrAoB59VUL9ffTYyoM9yjWBiUcHyzTN	21444	3NKAACarGnw7Ak3i2mUByHvAMsMb78QcQ4cHbk5JYxhgk1xx7uGo	1407	1395	391	12463	13661	jwAmmg937fxDGVQWXp6t9aXpbLKZPwZ97CnKjgKAexLamvVRp12	10757	15153	15153	1618666740000	orphaned
21454	3NLtpgYUGbCVknARsYwFkvcUDDgVjF1w7pu2yHFSofrF4uepDo6T	21452	3NK82eKFXXtTsWfb5oUsCrDbBpozMHaWLJ7Bu7QMSNHwAus3Cce3	1508	1387	392	12463	13669	jxoxiKK6Fm6wDZ3k4DA5sRwG9EgtVi9gpAT6cJoMhG36awgEQNZ	10763	15160	15160	1618668000000	canonical
21458	3NL1neg7B4qJLDF2RPMv3N1q8RYvpBQWBQnxKdVdct1qgjtX1FbT	21457	3NKKDhCjY8rQE1TdX8FFBWCQieBimNthNMMwP3s7ZTWsigvuN1Ay	1406	1393	392	12463	13673	jxSvhx7khNADGFBH1DiAsiEgW9nXpo3Z1DTtdy1GuzyqYAYjsJX	10766	15165	15165	1618668900000	canonical
21460	3NLa2rkdU88f9f3oFtd5hT8GdDgMPtCz3anBWB9VEnW4DmK1Vfnu	21458	3NL1neg7B4qJLDF2RPMv3N1q8RYvpBQWBQnxKdVdct1qgjtX1FbT	1631	794	392	12463	13675	jxEVsKHQhYfktMTPafVynhufqd4cRM1a58DJvNxS71C2REQjpT8	10767	15166	15166	1618669080000	orphaned
21463	3NKtTY8Hkpz7JEtScCz1EB3ACpaVF2nMPoz4uPrXWhPFe8Vufsrk	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	1652	1315	392	12463	13678	jwALPz3JPHZKzFcCZ8tG1fA8djgdJV9e7ZNewsEXJfp7gyKsR6J	10768	15167	15167	1618669260000	orphaned
21465	3NLx7fNGy3YrsMdMxcKXmESdi8cL3q9MDDvB2cFa2t6V75H3Pd5u	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	606	1049	392	12463	13679	jwemUrMGGrb1ZtLjrFy2Dn6KXEpFLddyQjQDWQ6AVPb19JFEFs7	10769	15170	15170	1618669800000	orphaned
21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	21471	3NLT8V7424sT5z4LTfCfLVqzX5PTSdTYtCffsYsWA7VQGs4om9XB	1439	1279	392	12463	13690	jxG5R5c13cVAmPCMeaXfWTYrcWpQcqtELW2EJwK8fZ3AcVBmDQs	10771	15174	15174	1618670520000	canonical
27358	3NLchi77wBPM3XSemkZKD8PhqrNa6bXEZs3kFCf8XS5Uzahc46b4	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1648	1284	530	12463	18973	jxEcmiD5Q6drdP45v7jW2eWHmmiWLEXfcCNzKAbUMzYRPT5Wp6x	13525	19034	19034	1619365320000	orphaned
29170	3NKMBP6djiRcvgpHnWjgiBL9NFR82pKi1Todbxy9ijXTLtQBjD9w	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1546	1339	572	12463	18974	jwHH6qMwoo6G3Es69ExL12kJicYVVVpdi9Vo99CrhTdhvCdv6Cc	14381	20255	20255	1619585100000	orphaned
21473	3NL5PH2NGUU9nQPA2hoSW6R7Toz1AJQBpK1o74KSSbnLfQEhnXqz	20859	3NKvsNZREu3fScfSKzTBjHaBphdb7zsge7RwRCgK952BJfj8GpFK	1407	1395	379	12463	13687	jxLLz7ZU7XVBGNes9yNyoBANFrr5oqiTnyH24U35FGANEW1DoEF	10485	15172	15172	1618670194126	orphaned
21474	3NK5MEn2M9zEH4K7Q2awTY5jsjjCqgR7a7ibmRWde1oFsJZ3Pwy9	20881	3NLA3miBfh9sjE3au3nx5SRcA5aXzRNfcBbPg13EPzdfJCSm3Jo6	1407	1395	379	12463	13688	jxRz8DEt1da2gahTPQhZae8NKPWs7W8PQMCnZ4YQHbFi7mvpS6y	10498	15172	15172	1618670230931	orphaned
21493	3NLrzpeKqNaKFjUUcCxDejSehqtu5jzBXQy7Zh9rPi5YTwEmiZBP	21453	3NKpntES45ktnNinx2u9zPXxsZTExmMWBKDTcCCwDgfU73d2xJV6	1581	778	388	12463	13705	jwx98R1BYHihomiUmnDdqxAqsqfYWpwqdTozKW76VyjZuRHFhXh	10703	15183	15183	1618672140000	orphaned
21406	3NKAfeccgAmCCVhKDaiHLs2MdZXUsqP5yYq7sgwsYg8ineacmhm5	21404	3NKS7sV6tG1W3sYJsDeU6YAsQofWriRWb8KeCabFJ9AeL1LE89Rm	596	1060	390	12463	13625	jwSMXTF2d4R345R1L6SmJeYTSaVNBNEoz5T6FoMDC3isWSUG8mm	10737	15125	15125	1618661700000	orphaned
21412	3NL8kdrEEpKsvxnpmaKfM7BWBcdhvjCNSUDL3XV5aiooHTTGaShK	21408	3NKDRz45hmnEDomLkaCfSiFzQHaMpUSLZ3UT8xD7kvGCeHKu4WvY	1458	957	390	12463	13630	jxM8wMg2QCQ2hCEBDLmNdUiLK7S56j5xyPo963Zq3WuzDQtrXqT	10739	15127	15127	1618662063490	canonical
21419	3NLbrGs7rG6PY3PDicsJt9WoN964ogZShpMkhf1Vp6VQu9F8bfxe	21415	3NKnaEMfSMcc8aDJYbgunqZ8GfmvLn7D5fFnqiwyP4AQ2yLXY2Um	1407	1395	391	12463	13634	jxgzafRQEBRUpaDYBsJiKoSEjR2wSdBpDLrQtb9J9SexvHJS6LF	10741	15131	15131	1618662780000	canonical
21422	3NKHwnp85jP2oCtmvPLmsmP1U4d73FcVE2Zc4JSca7yeHT244hej	21420	3NK4pFuztgxLYYXdcXEr9qFRFLdgxLWuHiVAUJHYdqhModCKttXY	1501	1360	391	12463	13637	jxJYVmGDTh1QoVCsdNpwPN4XYvQPC233kS1sFUBmL1PQM8HiZRE	10743	15133	15133	1618663140000	canonical
21434	3NKQ9DSkEZgAbu65cR6dc5CXK4WzEpXx8GLCixcbBumtYtAxs9g6	21433	3NL63xgc5uG1Sdu1b5zMVEMBuCrBnDBMdjJv3TbGosxuYTaShsVk	1623	830	391	12463	13649	jxZbidq8ieVFX363PhQg9gDkweMFZ9SpYNxCfwYYkDGZxEWAn1t	10750	15144	15144	1618665120000	canonical
21443	3NLmBRJiu6AoDLVQxDncjhZA9hJ6CLryx7uiG5FXLADKidhzMhiY	21440	3NLkcftT6HVhzsJCqrjVTsbWmhxzzy73ZvpQPJyNuY9pgTszLMFi	1553	776	391	12463	13658	jxtBsKefCBYzaJSA94rAVtazFFm8ZbYdVxEUYxoDEVwLFq97DgV	10755	15151	15151	1618666380000	canonical
21445	3NKLx6XQp4W5yKhfSzP9gXPjb73rgDXc2AVpRkq9WY3ianAi84XW	21444	3NKAACarGnw7Ak3i2mUByHvAMsMb78QcQ4cHbk5JYxhgk1xx7uGo	1445	1290	391	12463	13660	jwJc3LpeRdLHftBTaWxLEq1qDWqQPgsQnKUqP8hT5122oAq75sD	10757	15153	15153	1618666740000	canonical
21448	3NLs2t9hWVAqQQQUS8fNRQK53WHiiDA5VZu3ohq95AgbgqCQB1gL	21447	3NKKEJaoxPopUgMpPn1XxyNxETzzeKrdKccQK1qZfJLZsSJtxmVc	1407	1395	392	12463	13663	jwZEqdZ8fbTnPZ2GD1o8yTxoqNTVgQWG81v5EeCv97aeCYrfpVY	10759	15156	15156	1618667280000	canonical
21449	3NKkQuXTKiC3knW8SW3ngW14qFwX6B4hgi5X7AKzHoVDiEYySUxt	21448	3NLs2t9hWVAqQQQUS8fNRQK53WHiiDA5VZu3ohq95AgbgqCQB1gL	684	1226	392	12463	13664	jwoPk17sYS6YKne6TPduFvtGGsMaykVvBg3jxUDqiJTVGst5Yxs	10760	15157	15157	1618667460000	canonical
21451	3NKjRuhASgRYV6BHWqyhzmpchRDJtNu3a22FE8628CBu7cVVJ37X	21449	3NKkQuXTKiC3knW8SW3ngW14qFwX6B4hgi5X7AKzHoVDiEYySUxt	563	993	392	12463	13666	jwRbbtnv7bEh7jgfneCFdMz5HXXcN8Xxa3XcbaCHy7UvdktmUii	10761	15158	15158	1618667640000	canonical
21455	3NKiss7kUrzU89mZMEctTcNbsdWyVe3r15jdSsGbammm8LADTdLt	21454	3NLtpgYUGbCVknARsYwFkvcUDDgVjF1w7pu2yHFSofrF4uepDo6T	80	907	392	12463	13670	jxuXmBxKXWeUB8eJz7md6JhpuyhhobQMFtdy25MhBqeP9fNpDCX	10764	15161	15161	1618668180000	canonical
21457	3NKKDhCjY8rQE1TdX8FFBWCQieBimNthNMMwP3s7ZTWsigvuN1Ay	21455	3NKiss7kUrzU89mZMEctTcNbsdWyVe3r15jdSsGbammm8LADTdLt	1460	486	392	12463	13672	jwdD6hMn9eGRJmQ8M7defhqamS3pyqAf7xe7KaAeLc7peWDjJDx	10765	15163	15163	1618668540000	canonical
21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	1652	1315	392	12463	13678	jwALPz3JPHZKzFcCZ8tG1fA8djgdJV9e7ZNewsEXJfp7gyKsR6J	10768	15167	15167	1618669264670	canonical
21461	3NLrUwdscBHEs4yb5VQ9W4xe8APBHzXjjvCdTbRt4UEtJJQ1MiGo	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	1585	1366	392	12463	13676	jwGti296JThns66UBgDR5YJZKMLK1KSNe7HQMfHidqteMgjA3kj	10768	15167	15167	1618669260000	orphaned
21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	596	1306	392	12463	13680	jxWFTmF2zKrT3SDU7BbKGNEwo1sUWTegdkmFJXTibjyvev4zFDn	10769	15170	15170	1618669800000	canonical
21468	3NLYyBca5hyR7s6rd2zVbjveuNvdMV5REniodsSRxnXkM4ujb4L7	21464	3NKyBG6WDiZWL94VsUDttz2oVC1ZcJSkyDw5nLBTMVRMN5JHvCqT	1402	874	392	12463	13682	jwokxyBY4Vw8zXMw9SCiZQzazgkw5MFCEriaNcFPCSU6BiMGyru	10769	15170	15170	1618669800000	orphaned
21470	3NKETtgEmAWXHUYCzwse3DMt37SSAPAjVUp8DDpJPMEr47UDkuDe	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	632	1016	392	12463	13684	jy3Cfogs75aAgFNMPrLEBnz3ck9sh5xcrSXN77VEqc1oAhFcATj	10770	15171	15171	1618669980000	orphaned
21472	3NLDPisCkUW4HSLyJ7enQzm9z72NbURBKCnGgmDDKKTZrnkbDvEN	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	641	1336	392	12463	13686	jxvZ5RekW1T3rUvziPdK1jry19jx1FtdkgubkZSWwEb9dGKPVJj	10770	15171	15171	1618669980000	orphaned
21481	3NKWDpusoPxHBvZufuHUh7udXbpHaLvfGmrCEgMd5ZVnZYs2sFhL	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1599	1161	392	12463	13693	jxVGTsMRMmP3W39rM8U59YXeqjEJYYfnf9bQQ3cLpC1vUcnwKMq	10772	15175	15175	1618670700000	canonical
21477	3NLgVK3uDjsghmgEuFjscmzoKFJBgEJB1PUaZoPDrHDGmmG5npJd	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1523	1321	392	12463	13691	jxAGppf63G7eFbL38M3ZPaCzJm7PXHQ193XTwcSonkTAdr7jsgs	10772	15175	15175	1618670700000	orphaned
21480	3NKoUC1JxpVmUcuhHKV7tNzV99Qay8nSuvq6Xn15Q19Ac9uruu7Y	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1523	1321	392	12463	13691	jwphPGmbhtCQDiS8rGSJgrfNhueAB3Buz4CVJAxhvunNEqGT446	10772	15175	15175	1618670700000	orphaned
21486	3NKS5sGLpXjkp8hodCp11mdbQJ4mXoKZq2odfJs7Uz1LGEZ1QYGi	21485	3NKHYWZQPbm8uFcFxyrmt5hgMPu9hFopo755yJhaJR1fnS84WsvC	1406	1393	392	12463	13698	jwe8Bgr3P2sebHYdQScqavQ4oib7VLMQYHaP5KxCvDanjjXaDq9	10775	15179	15179	1618671420000	canonical
21488	3NKbBdwyZH7VhXPckXNKeEK6k6GrSUNpe1xx9tECQiET4HdG8No3	21486	3NKS5sGLpXjkp8hodCp11mdbQJ4mXoKZq2odfJs7Uz1LGEZ1QYGi	563	1113	392	12463	13700	jwhdkZ9hz4CWYvoJHf4PV8UzYXjBDyv6k1gaXDbucwbxeP65aB7	10776	15180	15180	1618671600000	canonical
21491	3NKvTUPnbYj7sLns8rFPDgMcnLQUYAkgQzxqPBPAA73dgw9DermJ	21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	1407	1395	393	12463	13703	jw8nkbFVk857zMicbioqMmFPt1RPaMNSH5BX5Uri5ajCtNzHCks	10779	15183	15183	1618672140000	canonical
21495	3NKC1UdFaVBvPgguutdAfag7dFFySK2owfuaMRZoSPJbUtNbSAzB	21491	3NKvTUPnbYj7sLns8rFPDgMcnLQUYAkgQzxqPBPAA73dgw9DermJ	1403	824	393	12463	13707	jxUwvWCjzqghhu6WzWH75ZRXo2AWmzw72RzRMZGCcYad51UBnbx	10780	15184	15184	1618672320000	canonical
27359	3NKfghfmtAEZVFVeym7cJT7su8sB457ezKSHkbnSzcRAaU3rbcZK	27355	3NLk1yy8WrR6Go4nX4tnXuUrhE2CrY3aNKRs3fyAi5K5DBtY7URK	633	1384	530	12463	18974	jwNrHedkjUz1u2JsMeQnxx3ryhreGsorhApjNb5yaCYCqXZwX8F	13526	19037	19037	1619365860000	canonical
21518	3NLYPuVhwyTQhkgz2jbLComDNbvjxiNCMd3kMrggeACsEYJ3hE5J	21310	3NKWjwFVZXj8GB1zRGeNGVCj4dAVHmPQyCkeFwH7FRHfzc8Kpj2s	1506	1247	381	12463	13729	jwYuyutx5qDNdvyniLXS4fGR4DxnVe2HDaPHR3NgZS49csH6kxr	10517	15205	15205	1618676100000	orphaned
21456	3NLA9Y4jjPDHTaqmPyt1DC9ebUQj3nvDEeMr84H5TfmR66pEWbip	21277	3NKEJavF4kmmfcbangvbi7MivoU8afBwLVcFHJNde37NPXMU8pd4	80	907	383	12463	13671	jxkQ3FsNevVLoV7BNY8w89R9vHXdyyfXwQ3PMcppcMB4zc36FLr	10578	15161	15161	1618668180000	orphaned
21547	3NL5W3U8eEru2eQkyDYpAQ8n6VH64QZU6t5oykbCJtKQ58LPvYXn	21392	3NKBarD2Yya69WVFyxucLaYJMUqUPUwEnSTqkSUSuu8vd5z8ZmMw	1536	1187	389	12463	13751	jwkQkvijYfnvU6R8H7ZnbBfsHs9iRwH7jZV2nMtQSHHKh5wM4pG	10710	15217	15217	1618678260000	orphaned
21450	3NLtDZeUDp7DQbB1ASK6CijmCJyjNA7V7m91YBCMsM5XXWW15mo7	21437	3NKUyTxrFJd41yRrBMRVsmbTmFKnDta6hfZonRgFGDnTWgezVVMs	684	1226	390	12463	13665	jwLdZx4xQD9NJyNUv8eSy4Js1czPBHruJ7bLKKMwc1z31dgTT5X	10742	15157	15157	1618667460000	orphaned
21432	3NKwTUUPTpfYneDvWK5qHUSv6qUe13YqvCvBTNNPdLwYcJKdrQA7	21429	3NLGUxa9seVzHNoBTk8RW5sSoX2G6PzvxZJ4ikhr6zQTUfjRuJih	1516	928	391	12463	13647	jwN5aAFtG8QxvDAF4aB7448H4ZEhG2JfaSHbccE3q4LDVU4b2Hc	10748	15141	15141	1618664580000	orphaned
21433	3NL63xgc5uG1Sdu1b5zMVEMBuCrBnDBMdjJv3TbGosxuYTaShsVk	21431	3NKjUqKFg85EztZABuoSvXTcj3HWRDTXxE5igsABWwKhPW8ChAmc	1587	1357	391	12463	13648	jwik4mgduVeacr2rcFxnZQw36K8Cty1M2V6GdECzGzZFKnfkyb3	10749	15142	15142	1618664760000	canonical
21436	3NKKjEcMe4d4SaXM4VbzfuBj3u86e73KGwnP6d3p1kyx9BvzM7XZ	21434	3NKQ9DSkEZgAbu65cR6dc5CXK4WzEpXx8GLCixcbBumtYtAxs9g6	684	986	391	12463	13651	jxpNsDb8mRuqgVBiN6VbcgLzcVinBYvemdxxEVUb4CkSnJ3jV2V	10751	15146	15146	1618665480000	canonical
21444	3NKAACarGnw7Ak3i2mUByHvAMsMb78QcQ4cHbk5JYxhgk1xx7uGo	21443	3NLmBRJiu6AoDLVQxDncjhZA9hJ6CLryx7uiG5FXLADKidhzMhiY	152	1330	391	12463	13659	jwbQfGejLH3dxYBQtAUQKCHK78APRwWyHvhYn3m5P12sZZQmrdk	10756	15152	15152	1618666560000	canonical
21452	3NK82eKFXXtTsWfb5oUsCrDbBpozMHaWLJ7Bu7QMSNHwAus3Cce3	21451	3NKjRuhASgRYV6BHWqyhzmpchRDJtNu3a22FE8628CBu7cVVJ37X	1490	1028	392	12463	13667	jws5Y2gBqsDZqberumBSyXCS5rwNr8MC9ncWuShNQeoSwoZjPpg	10762	15159	15159	1618667820000	canonical
21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	21458	3NL1neg7B4qJLDF2RPMv3N1q8RYvpBQWBQnxKdVdct1qgjtX1FbT	1619	909	392	12463	13674	jwYxHd22icxjQnDYUdnsM7DLomwfXHjV4spSGitZCFyRuGkYhpU	10767	15166	15166	1618669080000	canonical
21462	3NKzvY8j17ccPrE9J18G64EZJK6FGtupCzbsdz4cxveDzkzEtSvt	21459	3NL7BpxxMqaxkq9mhfd9d6MZUjts5ajFN5h8UKsdBL5tzNr4GXhG	532	1303	392	12463	13677	jwfR6913R4ykKafgwUfVW44Zvcc6XqqwpeFWtAY5cyAEB7X6hbF	10768	15167	15167	1618669260000	orphaned
21471	3NLT8V7424sT5z4LTfCfLVqzX5PTSdTYtCffsYsWA7VQGs4om9XB	21466	3NKbFcASbDj9Ti9vVe1ARYPv8Mzk423UL4RE4jABTKd1sJ3ohW2r	1460	565	392	12463	13685	jwemPxPovoFysxiRSMtsWDep7hptv7iS7seH2LiGjBNta8an68c	10770	15171	15171	1618669980000	canonical
21478	3NKZTFyr4cVCPZUaFuf4N9zJurih4h8en1fQbtj59Cf6y2yfdkwr	21476	3NKHMHGFeAHBvyXCfE82ADP1HUpEK9KX1K3aL2e2V4Gvk77QwBnV	1405	851	392	12463	13692	jwcMEBsHgSwevvMiTR8DMDpJGtWxUFb8Muxg89gJhV8bku7cEU8	10772	15175	15175	1618670700000	orphaned
21484	3NKarJyoHo62vMaSGQQKK1qSB35GxSm1Vuu9bCn7rxgaiqvgm7sv	21481	3NKWDpusoPxHBvZufuHUh7udXbpHaLvfGmrCEgMd5ZVnZYs2sFhL	1423	104	392	12463	13696	jxzAkQvVSNXc5LXYoFq1H625panJApaPJRifegRe6qNyGgTU21p	10773	15176	15176	1618670880000	canonical
21487	3NKhuSvHuTmqEHoTC6CijDhWcXaeUrQgS5A4Z262hFX8u8ZRjNMi	21486	3NKS5sGLpXjkp8hodCp11mdbQJ4mXoKZq2odfJs7Uz1LGEZ1QYGi	1571	1209	392	12463	13699	jwgq8c7YYRXHaNoD8W8WnoMADJLSVtcJukzmCRWMjSZun9837vk	10776	15180	15180	1618671600000	orphaned
21494	3NLP3dY2gthzYNNMhfEjaQKvLEUBkuACeK7zwWdNSuB8F6MQ5cnW	21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	1631	794	393	12463	13706	jxMSBrZTC3rGTq8mJhgKvxs9bMrRshnXDoEyXM7k6M1eBm3XDFK	10779	15183	15183	1618672140000	orphaned
21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	21498	3NKYbH3ijE2i1ttn6BePXkcBoimeaYNBdFakvxg4FsjZ7cAJxEhc	1544	347	393	12463	13711	jx32jVwimG87uJRtKCWB7JHgaCH3PFvKzzeS5d4MnhJQDFueAHn	10783	15188	15188	1618673040000	canonical
21504	3NK3wnW3sgEzRVYmcBskiwgx5a3Ww7iCrfd6H7KopKbrFRwRcJBj	21503	3NLxJvGe5yJCsEMcjN4JkhPmdaUYoBUX9T1Y3E6sGEBNgvgLpEUB	1571	1209	393	12463	13716	jxM7dxpofeSDHScbpAJZX4eyVYaPq9rUGAiW6npHi9LZF9o1Kbh	10786	15192	15192	1618673760000	canonical
21505	3NK3tMBqab4yXJMipRMpH3xZysDdzZCWhch1kW7PSnLReD1egLkh	21504	3NK3wnW3sgEzRVYmcBskiwgx5a3Ww7iCrfd6H7KopKbrFRwRcJBj	1542	1178	393	12463	13717	jw9FzwZj7LtBn3M7aDTCQnuDj63zarbcnoKu7jc9C8pxYxav5t3	10787	15195	15195	1618674300000	orphaned
21507	3NKScntDR91Gd2jG1Coux5gWq172m8LBWijfV1sHYAUbk3xSoHyv	21506	3NLuMh75jdDWs9WBtexLMtoCBC5et3Z7BCbrW2fFcTg6MaDPUGU1	1541	1052	393	12463	13719	jwxjyDPxPt66XGW6GjVg4hvrReTs8XJcQ3iwLfw3S7LTDcw6NN3	10788	15196	15196	1618674480000	canonical
21510	3NK3ytrMNhyrckNRKMhrjeiLP9EPkq2TikB4RrPrSeYXNB4KNHV4	21509	3NKY8DsDCwAouR7kBQ1nBUuSVKR58oUucG82Hmo8Me276wHG8Gi8	1445	924	393	12463	13721	jwaAgBDhrZUajUvBbtVGiGLuSNkZtfGwP6wKZpcbCo7SDNrcbLW	10790	15199	15199	1618675020000	canonical
21513	3NKaDsfvD1g3B7eGdxiWDPW9BHpTg6jE5tPXRt6hxUCu6C5vLadN	21511	3NKJJpXjWYUdW9H4hV583Sk4U2jYrPEGh7hxF8Xuk69Sb7jcjEdi	1403	824	393	12463	13724	jxfnhgA94TN1USLbcsXFgJUCt9fL4MverZg4sM1MedB8s1CyrNK	10792	15202	15202	1618675560000	canonical
21516	3NKM6HooMRtiP3PNMcFdzVbeoHXT8nhhv9yKhaHfH8dLA94HxXJi	21514	3NLQwEnmBsLSt5z8DtKfpotQj4cCZL9E6WAb48GtzFadAHVgkkWv	1440	1011	393	12463	13727	jwFJLk1cbZibdJE2peRHsuDW1dddHtcwo3LZ4Qa9QA48xjByHoE	10794	15204	15204	1618675920000	canonical
21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	21519	3NKErxSzErFy3Mumv4LRswf6beEtKrteQK7Fhy5Y81eJnhnBiftL	1585	1366	393	12463	13731	jx9Eq6nDGGZd1MYEigpzqgz9T8BvxN6XQzib9DXTAZDjSCDQe4a	10796	15206	15206	1618676280000	canonical
21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	21525	3NL2sAmLtaT28mjUr8yQzwFyMD38h8x11u2v7wU1PWy53DHAKxHw	1579	1263	393	12463	13737	jxcdfBM92nhtnaoP6sNcHp2h4KPSqXeZLUEKgPddd7SMpHUd7XS	10799	15210	15210	1618677000000	canonical
21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1523	955	394	12463	13739	jx7RNxJpBQgGNd4haRJcuvkAZ8FBQibDqg8gyWdesWsiHK6Hidv	10801	15212	15212	1618677360000	canonical
21536	3NLW1HFsc2Bag9vPQ1Yaox1mqCMZrwxwPgF6jRV1VsMH4sMRQy4L	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	58	1035	394	12463	13740	jxuAzHXUmnqW1z3duzNHUYqq4NEkNCvJg6PnHv4tLNY4LST6Jmo	10801	15212	15212	1618677360000	orphaned
21540	3NLodzuBtJ6Ho8E18nYfXu5K8rv133W1X4YxX2CHN7u8iKXtPGPa	21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	1555	1347	394	12463	13744	jwtyYqKrCC7UWoyNFDLs5gzW2sFQauMLAdoyu838Vp5QspkAE5i	10802	15213	15213	1618677540000	orphaned
21545	3NKTWxAzxProYafzjpvKvTQkXPQxNRJbo1sAMytbKWyEvEMdxUTA	21544	3NKqpdHb9gZTARrQ2wWCy58hTHUwtowhKzZvxbJtdUxHJssYuNQY	1607	1348	394	12463	13749	jw96o9Rpo84FK63SucyioqY3ELiWo4agiRquHz7poNnzVcYTbya	10804	15217	15217	1618678260000	canonical
27528	3NKkt9HXasM5oRcZc77P91nymwCLGgiiWr9u121b8S99xwD9EUNZ	27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	1555	1221	531	12463	18974	jxHV6R9nnLPch5wNbaERy1LCUV6oUkr9HYbtT9EJoNxQ4NL6jnK	13533	19166	19166	1619389080000	orphaned
29196	3NKF85bZHZZUcjVoLcRgWpFbwirUskPjdwH9jHMohkK61DQLtU2U	29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	1500	1051	572	12463	18974	jxydeL4aqBcYbSzHqSa4Kt3br2TbWddc5r7ZwBBv5Ef6pkHRSBs	14392	20268	20268	1619587440000	orphaned
21485	3NKHYWZQPbm8uFcFxyrmt5hgMPu9hFopo755yJhaJR1fnS84WsvC	21484	3NKarJyoHo62vMaSGQQKK1qSB35GxSm1Vuu9bCn7rxgaiqvgm7sv	1406	1393	392	12463	13697	jwthTqx5ZVtXzgzgbD3NuiVAni39Bf14iPU1BpxYkhkXWu2zEVZ	10774	15178	15178	1618671240000	canonical
21538	3NKKPumPSiMKsMPLdsfRdrhskeqgZT8wid3manVbYxSQbHWL8ab5	21484	3NKarJyoHo62vMaSGQQKK1qSB35GxSm1Vuu9bCn7rxgaiqvgm7sv	547	547	392	12463	13743	jxzGrMB4CP7nGLVkaZ2TLwEsZcxnvSzLG3f54qPdyGXt9iexqQ2	10774	15213	15213	1618677540000	orphaned
21489	3NL8AzM9yabHMs16M6i3NXJQ4yAMNCZtamf8wMsg3WsbdUYWQRBo	21488	3NKbBdwyZH7VhXPckXNKeEK6k6GrSUNpe1xx9tECQiET4HdG8No3	1637	816	392	12463	13701	jwQidyoJ6EmUG3w8GDYnvzpdBcCdGYpoAG4723X2T63aEztZHbv	10777	15181	15181	1618671780000	canonical
21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	21489	3NL8AzM9yabHMs16M6i3NXJQ4yAMNCZtamf8wMsg3WsbdUYWQRBo	1403	824	393	12463	13702	jwUgxQotJX7WPB97SXnYjCfrWgmF2XDVPr2U8kopqo5vvrGjYH9	10778	15182	15182	1618671960000	canonical
21492	3NKjwbN3TAgQPXT1Z2pVTRAuYVrvmj6SnAQqM848hsC9ayW4B3uS	21490	3NLcJ6sLwmLYFcZhH9ZYbLnTUknmiAM4ZhLMP8zBvL7wzbZqNpcG	596	1060	393	12463	13704	jxUfG324YfHyQRGk7wPZ1dcWwdRXmVGSQ7mcpUG3jwGdafmQ8xY	10779	15183	15183	1618672140000	orphaned
21497	3NKCq1T3L9YVm2t8jAsqCthUMPfM3TGe5919Cpx7Gqvd2ksmczXC	21495	3NKC1UdFaVBvPgguutdAfag7dFFySK2owfuaMRZoSPJbUtNbSAzB	1406	1393	393	12463	13709	jxghJGv1Q4VcHkjZGho41TpRE9bEfF3KrMG8uGo4ktpRXhbib9v	10781	15186	15186	1618672680000	canonical
21496	3NKG8j3g3pyfmvha6g8Q8LMQ5YT6dZz8HnhScfhKAXgcWABHdJzT	21495	3NKC1UdFaVBvPgguutdAfag7dFFySK2owfuaMRZoSPJbUtNbSAzB	1578	1050	393	12463	13708	jx7JznMPxKUBKSATrfsMKcY3gooBTVyK95mJidg66jrHChf7W1x	10781	15186	15186	1618672680000	orphaned
21500	3NK6P6Khpvo2zixi2DnburTwcjMu7WQPU5UKaaSN8nCsFmbTSXEJ	21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	44	1199	393	12463	13712	jwpm1R3QityFsKdbx43zr5uZ5DFZigvMR1XqJpMm4hfZzuchf87	10784	15189	15189	1618673220000	canonical
21502	3NLdQB61A6x2SsD9WkdBC49XjX8LynckEoy7QunnmPHtfG81bZa4	21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	1406	1393	393	12463	13714	jwD4zT9hbshiMg6cr8YtzApZbEp8TaWEUA3YL2LmotQ1gkLMsL5	10784	15189	15189	1618673220000	orphaned
21506	3NLuMh75jdDWs9WBtexLMtoCBC5et3Z7BCbrW2fFcTg6MaDPUGU1	21504	3NK3wnW3sgEzRVYmcBskiwgx5a3Ww7iCrfd6H7KopKbrFRwRcJBj	1608	1289	393	12463	13718	jwiA2qeBYMEP8o33q1d5wiZDvma9fYrZd3p8UviSXT21TvUaEBJ	10787	15195	15195	1618674300000	canonical
21509	3NKY8DsDCwAouR7kBQ1nBUuSVKR58oUucG82Hmo8Me276wHG8Gi8	21507	3NKScntDR91Gd2jG1Coux5gWq172m8LBWijfV1sHYAUbk3xSoHyv	1406	1393	393	12463	13720	jwoQkVMTdS76fVq6d3aZjxY2xwhzAp9pEsZRmraToeCM7e5yd4Q	10789	15197	15197	1618674660000	canonical
21511	3NKJJpXjWYUdW9H4hV583Sk4U2jYrPEGh7hxF8Xuk69Sb7jcjEdi	21510	3NK3ytrMNhyrckNRKMhrjeiLP9EPkq2TikB4RrPrSeYXNB4KNHV4	1673	1002	393	12463	13722	jxVaLd87brboSf14jDUdiSy6qTcnrfMMCPUH9QWBcFuC96PA5KQ	10791	15201	15201	1618675380000	canonical
21512	3NKG4jWbFaneuSqBWv7K8MQtgCGATRP1gv6VAQaPKELEXruqiAou	21511	3NKJJpXjWYUdW9H4hV583Sk4U2jYrPEGh7hxF8Xuk69Sb7jcjEdi	1407	1395	393	12463	13723	jwwqENseRppKDhuHSmQmyvnQ2spZW2YAySMdqkbU4xUixXutJsD	10792	15202	15202	1618675560000	orphaned
21517	3NLUoMzL4nK5z1axRhqr1XQzJQhFmubG5er7zEV3eKV29eTsR5fa	21516	3NKM6HooMRtiP3PNMcFdzVbeoHXT8nhhv9yKhaHfH8dLA94HxXJi	1407	1395	393	12463	13728	jwJVoiFs9wjPtudVwyt1mqf163dgbSsJki4B7sQvfp1XEm6E8Fv	10795	15205	15205	1618676100000	orphaned
21523	3NLMuHDfc2wNczCMmAVkxm74SVtUoHyYcJBaymoDA3GVNc8N2HEt	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	576	1355	393	12463	13734	jwRHjJ9TXZWhW5Xk5wkTbUGczLNwTsg28C2AxKhxZZv1EdFGCvb	10797	15207	15207	1618676460000	orphaned
21525	3NL2sAmLtaT28mjUr8yQzwFyMD38h8x11u2v7wU1PWy53DHAKxHw	21522	3NL3E5bSw8awMsozeLhy16URhtm9zSc95igTQR5EmqToQjWM3gJN	1483	397	393	12463	13735	jw6mzF3XbVrnpQAepAg38vGhNn8qraqEowGdA5nQ6mNTLvz5NJn	10798	15208	15208	1618676640000	canonical
21529	3NL9Nv5Q6rvahU35JU7dGrxHNiWGABgATYrz5fz117tFaFoB6URx	21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	1534	1317	393	12463	13738	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x	10800	15211	15211	1618677184520	orphaned
21528	3NL5Xrn2NtQewoC7uzmVuQoyp6iLxNsYHCtGDCKEmgqYyKxSUYF2	21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	1534	1317	393	12463	13738	jxmpz8AvjyvHLA15qZtA7WKAZiosUPKX2aU7nxRfXwKfeYTkFfQ	10800	15211	15211	1618677180000	orphaned
21531	3NKJJ4Jst37MYqp5EMRpwQqdZLQcwXSQ7rwBnDrvKH8DJxJNwx2m	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1523	955	393	12463	13739	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x	10801	15212	15212	1618677360000	orphaned
21533	3NKGTCjWEkhLphZkDD96uYnvQcMt4ocENJ8qdR2AbcuHqbr3VWF7	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	1523	955	394	12463	13739	jwZfhW8eRsdbXyy8eQPmLoEfokhrzvfF9J8kP6RSePAv2qCSAC1	10801	15212	15212	1618677360000	orphaned
21544	3NKqpdHb9gZTARrQ2wWCy58hTHUwtowhKzZvxbJtdUxHJssYuNQY	21539	3NKJBxek71YdJzvWPQuS3wKN3yBkg5AWCeRDvnvNEyxh5Pjhp5WR	1553	776	394	12463	13748	jw9ekFxkqqHkcNKWTSzUgY6pXZrQDzZ3u4BLBJtQviPwxmtNCWS	10803	15216	15216	1618678080000	canonical
21542	3NLotkPRHypWEDf2LJtV5h1EwbuiaF4bqtHTVQ7NKjVfWP2EMzCm	21540	3NLodzuBtJ6Ho8E18nYfXu5K8rv133W1X4YxX2CHN7u8iKXtPGPa	1483	420	394	12463	13746	jxZcxqEHJuVK2WGLMAkNgpEGjHkT8heEXGurTSKKf8S3Q84ZnLz	10803	15216	15216	1618678080000	orphaned
21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	21549	3NL4Qzg1iYbsxL51D54HBRS91S9rSecmb99c2JzkSZNzyH1pQqgs	1406	1393	394	12463	13753	jxZ6UC6wfV39qM2QmzwQCmyzTrGfckBoTHohHBbajVSnVWZz3LS	10806	15220	15220	1618678800000	canonical
21556	3NKsmdysKNnBQBqvUgBj4DLRJCJc14WjZHrh6TQhveh56JU15bNz	21555	3NKnvjqycAXLB5XKvNUTmSmiB9AFAgg8469fuGfWXC4xFT7wuKfu	1460	474	394	12463	13759	jwjh7G32b1dJnMu9TSbd12S5LH31HM3GbZz69ztmLs1MKk6UKi3	10809	15223	15223	1618679340000	orphaned
21558	3NLs3ySRNFMX1k4UPhXYArHTeh1s5kFfn2MULqrQBio36E2kVCwK	21557	3NLYBKKs6JZXWL7WCo8LNQeaTrXKM39KuNaf87MtrPNSEWL66WDZ	1402	866	394	12463	13761	jxanQbh8VQAmEqczU24CukMpAsPBC6EF1UBDPtwXuZM8fL5zeeo	10810	15224	15224	1618679520000	canonical
21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	1527	1293	394	12463	13764	jx9bm2zM7W6RynoCCnwN8nEZCXz1kNxnyHM2Sbr8z5MHCwTDzMr	10812	15226	15226	1618679880000	canonical
21567	3NKrq1DvGrNMEsKMxPZYXCCxQFBiinNb9Kqw5yoarjSrYuoq8Mks	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1594	1326	394	12463	13768	jx8sYAj5AtEePZeEJfqmKXrbCCcD9VqZXLrUTPiRbvJrqXv7vgN	10814	15228	15228	1618680240000	canonical
21569	3NKrgYAWwYwj9SS8arad3DFvJXhYTNPDWmE35tuiYE7e7ccdiyfV	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1406	1393	394	12463	13770	jxocbGrJxyYUfGdwbU8hcR631ZZ7n2FtoHwhuYNyYcZdMHXtbfr	10814	15228	15228	1618680240000	orphaned
27374	3NKHr7HVrarvzgxYYopdY8RHgYKnX4djP5pxbG3TPMHUMMRW4HWv	27373	3NLVop7fZMzzo6YdDaKTsq7b9ZqeEBrjCKUpo863eSxbB9r5dMYN	1405	849	531	12463	18974	jx2abpsPuSgEnAAobnqUbb6Dqxqh4fGKC19RoBc81ugRTaG798A	13536	19053	19053	1619368740000	canonical
21591	3NKnVEszeFtBgMDYuAKwV6KPkzBXzwt5o6aR6uXfzkj1DBxK8MSy	21302	3NKuTpJEBAYNapkAfvS7WKB72A612qi5qwwngf2YVMbL3WVFqSVf	1474	1203	384	12463	13789	jw7PEJBhoBWCYLhXK7ox54EwTW8VhTNZ4k5SQJHvYsTKxvqhA1E	10574	15240	15240	1618682400000	orphaned
21541	3NKq7AAwh5ppXCxws3boaYTwmvAnrXCorUmNY4ZYA5VPmiNdS4ge	21150	3NLYvtfh4Ncvqbkpd3jq6z3UAbxQQWeSM4aEYzatjAqdpXdRpvGu	1613	1223	385	12463	13745	jwPvmAiNC9UVsw2C3Cnxg26jx8bJ9DZSxvJ4n9jsVtViNKJy9JM	10622	15215	15215	1618677900000	orphaned
21526	3NKu2sV1u5tGyDGauV28Gre7hdiwiLgJUjR1qeivooPYFdTAXU5k	21493	3NLrzpeKqNaKFjUUcCxDejSehqtu5jzBXQy7Zh9rPi5YTwEmiZBP	1581	778	388	12463	13736	jxZacbnk9RAb8L1CXvw9i3fqo5EE6GAnwCencHdVdm7ULcvyG2i	10704	15210	15210	1618677000000	orphaned
21606	3NLEq7dyGgvBbQjLqnwenXc3dDuYY8gREZxhKkDoCdti86aMENQs	21547	3NL5W3U8eEru2eQkyDYpAQ8n6VH64QZU6t5oykbCJtKQ58LPvYXn	1536	1313	389	12463	13802	jxxdazJU15r3B7daGpP8DwZqrArpBsW4xz5KfSN9ZL2cpgmUgb9	10711	15245	15245	1618683300000	orphaned
21498	3NKYbH3ijE2i1ttn6BePXkcBoimeaYNBdFakvxg4FsjZ7cAJxEhc	21497	3NKCq1T3L9YVm2t8jAsqCthUMPfM3TGe5919Cpx7Gqvd2ksmczXC	1675	1342	393	12463	13710	jxucyJZvSYCdmoithjBfhViPJbE2FnpqUF6ZnkbFS37ARj8oH54	10782	15187	15187	1618672860000	canonical
21501	3NLTH2ZU65xq6Mb55d3a1LQtFyTdhweTb4RkrgdG9RKaLLbuwf9h	21499	3NKR7ctbZTi2EWQwzTF4FsGwrk2CEw6fgVTkThH5tQsm3ovNg5yf	1403	824	393	12463	13713	jxzUhBcAGAcuQ4J5dNCQhGMxxL2kdqcsSGjo6KBtxz8M7zX6uah	10784	15189	15189	1618673220000	orphaned
21503	3NLxJvGe5yJCsEMcjN4JkhPmdaUYoBUX9T1Y3E6sGEBNgvgLpEUB	21500	3NK6P6Khpvo2zixi2DnburTwcjMu7WQPU5UKaaSN8nCsFmbTSXEJ	1589	1040	393	12463	13715	jwx8z5p9vFtFwUYFrdrRsZMLmah77XPWVfE9BmmRZ7EEzNdfNEL	10785	15191	15191	1618673580000	canonical
21508	3NL5BAfkL27xWZJmP5RwYfTNYfotVrF4byHhtxwgzMcdMhLwkYHA	21506	3NLuMh75jdDWs9WBtexLMtoCBC5et3Z7BCbrW2fFcTg6MaDPUGU1	1541	1052	393	12463	13719	jwmchVNL8oo2WBBTSjUW428am21RN7ijPmFUZ9Qr1QEqViNKgpn	10788	15196	15196	1618674480000	orphaned
21519	3NKErxSzErFy3Mumv4LRswf6beEtKrteQK7Fhy5Y81eJnhnBiftL	21516	3NKM6HooMRtiP3PNMcFdzVbeoHXT8nhhv9yKhaHfH8dLA94HxXJi	1506	1247	393	12463	13730	jxZvfHJwBoLbBRzqZtzT8TQ5tfcwEsFwNumyCtWp1nfaFKaxiPC	10795	15205	15205	1618676100000	canonical
21522	3NL3E5bSw8awMsozeLhy16URhtm9zSc95igTQR5EmqToQjWM3gJN	21520	3NKnsdYaapzdgGZFi9fYfgUbsWg8CxheLvPN7MutnmyQcu5eRxwT	300	300	393	12463	13733	jxXbNKT4BjXawsbqcrGBXJs8hE7cP5gQ3wyVoxjBP2vDS7heo3m	10797	15207	15207	1618676460000	canonical
21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	21527	3NKtuvhwcEKjFLJVQ7xv6dkgdRfJTnTsg2HYQpfAJwURork1Fzog	1534	1317	393	12463	13738	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x	10800	15211	15211	1618677180000	canonical
21532	3NK9ghN1R253QYkduN8fy1iof6t48JrEuUMMRADsZXL5pRNZCxQR	21530	3NLwsbupGHE9j2UoMvXZRXg7hEXkouvY1orWXjddzj6T472ibjui	58	1035	394	12463	13740	jwJKBovumxqWMrrPruPbbupKw7WwBRmHueFa5jEnh3EAoxPo5Ce	10801	15212	15212	1618677360000	orphaned
21539	3NKJBxek71YdJzvWPQuS3wKN3yBkg5AWCeRDvnvNEyxh5Pjhp5WR	21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	1555	1347	394	12463	13744	jxhgXCDxX9hVZevuQdqrrKRRnaTyHhtjCYt68BnqEw7Fsbis91H	10802	15213	15213	1618677540000	canonical
21537	3NK38SoCVYn45fSCkRoiFmLRHWBNRLSmmfHEu73ju4PJvcgsjUn6	21534	3NLsjoXz89orbEsVKaJcfs9gPsfK2P1J1b3T2haEpxW2Bvhw4eRd	1637	815	394	12463	13742	jxmfyzjMJNfEC79fN48PLps9Wo8ktoGApfhhnTdsysWPgmt6jNC	10802	15213	15213	1618677540000	orphaned
21543	3NKze5D3sciiDMLCcvqo6U1F79VrhcArccjHo52yf9nyzwyo1uFx	21540	3NLodzuBtJ6Ho8E18nYfXu5K8rv133W1X4YxX2CHN7u8iKXtPGPa	1402	868	394	12463	13747	jx83Ga2YPn9dVUPdTTD2D2saRhk8GdUz6cwvyFiXojMLs2zjrzy	10803	15216	15216	1618678080000	orphaned
21546	3NKey3AH9wBvmNRauziS2nFsxetQhvXNYUTU1mhf1HBvS4A8T2P8	21543	3NKze5D3sciiDMLCcvqo6U1F79VrhcArccjHo52yf9nyzwyo1uFx	1536	1187	394	12463	13750	jwpeAo8zBQPGeP4yaT6H3MzVQxLZLBaQixgYxPK9UMA1c2HXCo6	10804	15217	15217	1618678260000	orphaned
21548	3NKxzWbJ1E3RoXk65FVDXiD6BqRVPor2U499878zHGtW8pJQvQK6	21544	3NKqpdHb9gZTARrQ2wWCy58hTHUwtowhKzZvxbJtdUxHJssYuNQY	1607	1348	394	12463	13749	jxN4gevd7DYXG7kNXdjqgNLSfEY3DwUmgoG2FkvMEmsKShyfKca	10804	15217	15217	1618678260000	orphaned
21552	3NKfVf5k5VoctKtUJPbK4CuN2v8gLuu9K5bTy7ZWM3EmhTUnc6H2	21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	1451	1166	394	12463	13755	jwgUocYcrvZYssbmXtUZgscx4RuL3Z9RoN3sAE4cn6dYHBWgKuZ	10807	15221	15221	1618678980000	orphaned
21559	3NKgsJgeBHJv1iJUo4kChL8Uge9MtikVQ8cvVhDfAyJDfmwLs41q	21557	3NLYBKKs6JZXWL7WCo8LNQeaTrXKM39KuNaf87MtrPNSEWL66WDZ	326	326	394	12463	13762	jx5awamRbBARU9hxUqQ7NhHyTdqRf3To1QUTqNiUZVAtjagQmRW	10810	15224	15224	1618679520000	orphaned
21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1407	1395	394	12463	13765	jxBBvoFqxYGTegjBpcbuUW3oDTVD47xTcF3w53HNSWPPbjsfw7S	10813	15227	15227	1618680060000	canonical
21566	3NLuNHjZMbkT4h3rP2Q2HDewhGYRqQBP1age4nFfyMrtkdiF6Sqx	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1547	1252	394	12463	13767	jwDCFMY24myJt9ij5ZiJyr3qe9qj9gLrwAspa8SQf1YRpEFveSd	10813	15227	15227	1618680060000	orphaned
21568	3NLveE6vqGVtpfhQTz6zydzyoNar9d4GtC84o4Kc3KonNfh2z7qC	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1516	1168	394	12463	13769	jwapfvgCU7B3Ta2qyoAE5ZGK43ikfB6e97zpAyVkwZXLPqF5ZYR	10814	15228	15228	1618680240000	orphaned
21570	3NLZERG361UuRpVtzQ2BvbyrB2PTTsttag3FDFYe5sA61ALBnTaw	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1594	1326	394	12463	13768	jxy2QGJvPxVLBeFZWejBU5GMbnh8AgERAQ7L8fP2z1NQo9pnjC1	10814	15228	15228	1618680240000	orphaned
21575	3NKB7ofoYbgdXNR8yUq3KTkvuTMtz7PmH17Fo2FLkUzXvJTqPuQZ	21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	1451	1292	394	12463	13775	jwbF2xFFEP7v4wq9zEjEqDAPqPdYVjziz6e1B47qJddAysmCEwm	10817	15231	15231	1618680780000	canonical
21582	3NLYC3JqfGBqQkKvoiLRRsNBiJJckPVGHXt9nK73oJYWubByU5yP	21581	3NLfRCYDYtsDZgnr5TE4spddv5JPtWUT2v9NXLtDAuC9CWeQVN7R	1458	1323	394	12463	13780	jx7f9FzQYmduKcUpRRXBYvJeDjfLEnspYCJFezy5kYYxZdyDj7e	10820	15235	15235	1618681500000	orphaned
21584	3NKHAr6Kb5Bzivv7Ax9NfaBzvoRGqfgynUVhKyKXviPn118CAtQV	21583	3NL1ehvpA9antfnvER6ndtABQdeieUmt63ifvKjSZALY7ZkWJVt2	1542	1304	394	12463	13782	jxLS6MNgry6uH9HfVC2yKhbeSoVfXpzzpaQUdXMaAm3CepVeDjD	10821	15236	15236	1618681680000	canonical
21593	3NLSdLLHHXDoSpcot4dx3HvRfq5N5XtTz9eyARD6UPweK4ioPqbo	21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	1443	424	395	12463	13791	jxY8fcmJFdAZvSpVFEHnnE1ZUWr24bt1aFaarYuD9kLaw1nFwUN	10825	15242	15242	1618682762326	orphaned
21605	3NKGwDnMDXcvCzg4yfdtCfSSKjHjR94K8HNnWTUzNjv1LBCdwN5n	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1654	974	395	12463	13800	jxF7UvDS4pouzPrn7rvNTkZKPzbbRzKBXbmtBenqSWh3dTokroL	10828	15245	15245	1618683300000	orphaned
21608	3NKzvBPP1hJunnPwSXFx2vsJADoijDJjSYcT8kDUjEMcckKiQCTy	21607	3NLRxyuVCtKpXj8XJSFvVnHBXKGprWdAvmiCsRYdbTCvh64xQGys	1406	1393	395	12463	13804	jwRJk6pauynDCLCTk1kJ8vMueqXKsnrsZg9RR5thnGGpzYD3jMV	10829	15246	15246	1618683480000	canonical
27384	3NK7t9PUsNaXS7TabRKjBzW9uRwt34KFbpSWC7bMKMiecMenNXog	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1529	1316	531	12463	18974	jwiFTsRZ1UNvyDmN2UbGRcdv4BZbztKVapgXfTsSCDsniZTuRUK	13541	19061	19061	1619370180000	orphaned
21554	3NLv6F2U8M6Wnv1cE39SAeUaoU1Ahg3Ps46ySo9RZGqBgYh35hx7	21370	3NLJDGbFJhNLF5yfwpMSQ8QCYXimbQhxXi7Ue88X4kLHihBKmuai	1602	1123	390	12463	13757	jxm9cugq1qFec2emrreCPg9d5GQ5Fqbjq3gsUQtYEWWXSMxb4XD	10725	15221	15221	1618678980000	orphaned
21549	3NL4Qzg1iYbsxL51D54HBRS91S9rSecmb99c2JzkSZNzyH1pQqgs	21545	3NKTWxAzxProYafzjpvKvTQkXPQxNRJbo1sAMytbKWyEvEMdxUTA	1608	1043	394	12463	13752	jxCjn22t5PWCi1XZkwAmrtEtg92LjANzdam4AvuVEJa3NrqfxGg	10805	15218	15218	1618678440000	canonical
21551	3NKTYkAZuCB1v6vd4FNstAyAzudSirXwf65JEsXetNqoUPU85eiz	21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	1407	1395	394	12463	13754	jx1XKAxHrpwiFxCFDBi6BjyvZCps6w8wqghNmT34P8HJsxa3Nbf	10807	15221	15221	1618678980000	canonical
21553	3NLFWe1q5fmGaGPX9UEgFbsKfRVnjhzWr8GyPSHpqut8kp8bYDd9	21550	3NLc8QHVu6qHepfwcjJQMAxuwY33KYGpv2WaxoDLczpv8ZN7qa6m	1602	1123	394	12463	13756	jwEZ4rmgvNssv15NQFiZ465QuxabNk8ychZmGcRSqW5eBnNSXMX	10807	15221	15221	1618678980000	orphaned
21555	3NKnvjqycAXLB5XKvNUTmSmiB9AFAgg8469fuGfWXC4xFT7wuKfu	21551	3NKTYkAZuCB1v6vd4FNstAyAzudSirXwf65JEsXetNqoUPU85eiz	175	175	394	12463	13758	jx6zbezAdHbkFjqfGYDQdipKMGjAdVeV8KQCMZ65FnYEP51H9KU	10808	15222	15222	1618679160000	canonical
21557	3NLYBKKs6JZXWL7WCo8LNQeaTrXKM39KuNaf87MtrPNSEWL66WDZ	21555	3NKnvjqycAXLB5XKvNUTmSmiB9AFAgg8469fuGfWXC4xFT7wuKfu	1422	1337	394	12463	13760	jxow21tkJLFzKN97FBHX5B1LPEgrsMUQ6GgoLhoCb5Vs1szXd62	10809	15223	15223	1618679340000	canonical
21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	21558	3NLs3ySRNFMX1k4UPhXYArHTeh1s5kFfn2MULqrQBio36E2kVCwK	1623	830	394	12463	13763	jxUvEYPieHKj2phpuh3wsAxHT8FNP8fqh2zPoFsuND98pMLEzvo	10811	15225	15225	1618679700000	canonical
21562	3NKWf3rDnu7gPcgKL3ixVnvvKVhmWHk2Sjr24bsjtjXVNpc4QmrS	21560	3NLaENHfp4iRWwbR1SN32oe4B57AHCYijKF7mjx1eyLkxs2zLFEt	1527	1293	394	12463	13764	jwbnrvGauuxkKb2SaF7qpJEsts3Lk66Z44zv2bn1LRb3bxYKoRt	10812	15226	15226	1618679880000	orphaned
21565	3NKTK7WT8jyiGpJ4YsDoCtv8j2KpCCRTJPkwWWzqKhSqrKFjTUkx	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1534	1317	394	12463	13766	jwYDvBib1wWGP6fHk2DRiSqWSn6bRFuka7HzS5kCz35aqq3kMgP	10813	15227	15227	1618680060000	orphaned
21574	3NKPUsqBSqYUCgSKTPyfX3fxiTqxPJ459BDX5JF3fUfxXioiBYTP	21564	3NK7M5vBfyJTJEy9HMEmzCAAHfxdpYArzqoQi4QooMSVX7wNNWiu	1402	858	394	12463	13774	jwpjdyuUhvV5nUvHKst6Z1GwUHbvX79UHrwfVzKDJmPg9JDryzG	10814	15230	15230	1618680600000	orphaned
21572	3NLLRokLz1haE7EvpCWs679cDD7x8iKW1Cd4rXYVXzYb9YdV7KJD	21567	3NKrq1DvGrNMEsKMxPZYXCCxQFBiinNb9Kqw5yoarjSrYuoq8Mks	1624	1334	394	12463	13772	jwWbrrkSixyW92A1BFeEcddW3NrmV3x7aCtpgW2WEyrzQfXUVjW	10815	15229	15229	1618680420000	canonical
21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	21572	3NLLRokLz1haE7EvpCWs679cDD7x8iKW1Cd4rXYVXzYb9YdV7KJD	1509	954	394	12463	13773	jxFUL29k4fP8vCQdt9PZ6UvRtYTnrmN8LMxCjUsVeYtcw2cHvTb	10816	15230	15230	1618680600000	canonical
21576	3NLLi2PpwjQKQB6JN33PTBE6DKoGSoKpkH47nTBo3EJmQpLV8Bkq	21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	1546	1213	394	12463	13776	jx9woZgPxUnfKK2woW7mDawmkmcw5HVkpwAt2Uub1DfoiEoKUFZ	10817	15231	15231	1618680780000	orphaned
21579	3NK5JjYedwsca37haa1FB5rjRKjNKDASfXTAKUbzQ51Z8tgceVvv	21575	3NKB7ofoYbgdXNR8yUq3KTkvuTMtz7PmH17Fo2FLkUzXvJTqPuQZ	1602	1369	394	12463	13777	jwWZJwdtsSqtPrP1CnLDEMAKqZsMaVYZ1oWbk45MDQLGTZ7Jymy	10818	15232	15232	1618680960000	orphaned
21581	3NLfRCYDYtsDZgnr5TE4spddv5JPtWUT2v9NXLtDAuC9CWeQVN7R	21578	3NLhRnjr88Qrx1MndAWRL9tdoUE5xZKRGdMuoeuxQFCzwPNv3nGV	1397	827	394	12463	13779	jxuzbNbmm8aqzGsaWa2LjDUoKyeMVTBWW24ZKPzzEAsQsYWh3Jd	10819	15233	15233	1618681140000	canonical
21585	3NLvD7qj7vWXttj3iBEeA8ZNohFsjgUjyM8p85adrv9wkfRgLJMo	21583	3NL1ehvpA9antfnvER6ndtABQdeieUmt63ifvKjSZALY7ZkWJVt2	1500	1171	394	12463	13783	jxjrC2Ud1nnrDSMSiZrzNiRTCSPeonUc4j7BsGuQ5X5BiQnHo4N	10821	15236	15236	1618681680000	orphaned
21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	21584	3NKHAr6Kb5Bzivv7Ax9NfaBzvoRGqfgynUVhKyKXviPn118CAtQV	1419	814	394	12463	13784	jxh5P3zaYgfTZ5SFmf58yx1Hi6sFrWZojpkphTBCogLqbmyr8AA	10822	15237	15237	1618681860000	canonical
21587	3NKvP4W2mnmQXhcWJxvaKCRwbAcAQMgjHZvQ61bQ4BE6N5jd5xdH	21586	3NKeAcnZ93LzEZAXVWDqVRnS14DEMyxDUj78ceo8QvZtNsX7cHa8	1607	1222	394	12463	13785	jwpdFaAzgQqx7aDajr3zJAKoEjvU4Nh4DeRShwtJ3TXoVJNgEcQ	10823	15238	15238	1618682040000	orphaned
21592	3NKNJxWhLuAqcoVKTrpzHa6JGiRw4U2JH3GfJdDaszo4g4eUgbgJ	21588	3NLAFU2kcMHLSoJHRniAVZwmy8CbXDvMod4StHmwmWzYNR2QG8r8	1474	1203	394	12463	13790	jxmC6hM1E3xYVdcauWUn9HKjmzo3iuxf6dAFVdyq6ZHfSuvc1of	10824	15240	15240	1618682400000	orphaned
21596	3NKiy9m6snEj44oWXfZLFRX5mtcWtYAS3XFfgfg31wgvYAPxF18x	21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	1443	424	395	12463	13791	jxY8fcmJFdAZvSpVFEHnnE1ZUWr24bt1aFaarYuD9kLaw1nFwUN	10825	15242	15242	1618682764073	orphaned
21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	21595	3NKnkyQoRh6Xouoz4dXFhTTJgzAXUENWEKFt5L5ufKWw8WPAKRSA	1407	1395	395	12463	13794	jxsQCFzEFCsFJsPjmZ6hBRRucaRzycgGmqYsSWqzz5M7CvpcawX	10826	15243	15243	1618682940000	canonical
21598	3NLZ57TXGF3ZQE1NbR7LYku73vRwGnvgsen8B1BowFgU6DgeX7RJ	21595	3NKnkyQoRh6Xouoz4dXFhTTJgzAXUENWEKFt5L5ufKWw8WPAKRSA	1489	1254	395	12463	13795	jwC2tmqYjFCPRDCVatTDFF8NKD45ZibXRy8uZofkXENMLHsuqCm	10826	15243	15243	1618682940000	orphaned
21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1627	1019	395	12463	13797	jwcfvvKs89rpX357AnJeH7VNBzMqernmoXG28ra4g7GojYDJeKS	10827	15244	15244	1618683120000	canonical
21599	3NKhAfxj2Mu5B43HSfe6r4fx7ABHhTqLAqYWdJrgKANbuHZNzt4p	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1407	1395	395	12463	13796	jwJvywAAN6ZXjRGnNCEM2fUEGDzaPvgaBugtxrWkR5MbsCRjZ2t	10827	15244	15244	1618683120000	orphaned
21602	3NLLVP325NQhGyjbTofHwompf2Ewk3cHcnp7wnGgkwuNj8Q2yvHy	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1419	813	395	12463	13799	jwz66w58a3EU5eRRUdm5oBngR79cpPRWACyzMAqwHVeehyuCGQT	10827	15244	15244	1618683120000	orphaned
21607	3NLRxyuVCtKpXj8XJSFvVnHBXKGprWdAvmiCsRYdbTCvh64xQGys	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1536	1313	395	12463	13803	jxDCAmX6fjZsUA6enQM6U8Rhcth7AsXemRnzG4MHr2c3cn7nHVG	10828	15245	15245	1618683300000	canonical
21604	3NLGQ73mUhQ4p4LaGHf4iDtX7mcYvR2BDGQGvhF32pTbp4eZ4LnW	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1451	1292	395	12463	13801	jxnKEPfjz3ua5xeVC6uL33E8Jkc1DrERm326ZzRxuFtcTucrsUk	10828	15245	15245	1618683300000	orphaned
21610	3NKXs8uZUdKQqSpX9VAw9p76C2MAsiKbo9DFR9AhL9SW1cyx78Mq	21608	3NKzvBPP1hJunnPwSXFx2vsJADoijDJjSYcT8kDUjEMcckKiQCTy	1590	1300	395	12463	13806	jxm6eh7Bsm85CL1QgyxXQNpohbbDEBLarML63UfWQtva857Jz9E	10830	15247	15247	1618683660000	canonical
21611	3NLJQrM7NbYWKkJxyhn7MMZ35aNpLXFfJrdboTcqfy2ffMJNVo8v	21610	3NKXs8uZUdKQqSpX9VAw9p76C2MAsiKbo9DFR9AhL9SW1cyx78Mq	1407	1395	395	12463	13807	jxKvsWvtTvax1wXxBNBJ5o2sXyGFfeSRdN868igjS3t5cDwdB9c	10831	15248	15248	1618683840000	orphaned
27399	3NKRr84kX9TXpGfA8JuFKPV27Gw8SzhpZyJK9BKXdgCndfn6ovYT	27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	1652	949	532	12463	18974	jwAy11brZxhP8ckerKHVRqXLSpixoUk2N62xqeHdi21HoPHMnmy	13548	19074	19074	1619372520000	canonical
21619	3NLgquCDJMexQ2CGF5oJXAQpYEUrfxULEgF6BdjPfSYpnGRPLwPb	21594	3NLihXjD6fdtDte3J2GFMzzorh8i29NoRjaASVs1X91h9cvSegNH	1581	778	388	12463	13815	jxWPf8RdLTJrTLxEide4gLLc7yst5mkq1X9T22YRtbVdBJnSGUi	10706	15251	15251	1618684380000	orphaned
21618	3NKgWSebDqmiKojcsCaRSpJd1oB1jhybctuQ8degBg3juimRo9CS	21350	3NKsY5RuY1dxgyxC4FgboRicVZA9j1UQeoKFJeqadtsSg2WBq9KL	1564	1338	389	12463	13814	jxnCcrHXTMTyvcQGwGsfvgoyFjjHojzhknetoKfo3TiKmVchbSV	10716	15250	15250	1618684200000	orphaned
21571	3NKbcoQ9rkyn93gV8gLzBE5zQqJbgDxtHhUpzEveZ6dYsdKpcY36	21565	3NKTK7WT8jyiGpJ4YsDoCtv8j2KpCCRTJPkwWWzqKhSqrKFjTUkx	1613	1349	394	12463	13771	jwN1tPNKsQBUB1Mh9dqU2faH8xPYXtxKkPjzV4nw1p4NES9Ym7v	10814	15228	15228	1618680240000	orphaned
21580	3NKcD6wWitKVff3fA6n5TcqBj9Nw8NMhpWtzNWJJxw5aDuF7Fc9v	21574	3NKPUsqBSqYUCgSKTPyfX3fxiTqxPJ459BDX5JF3fUfxXioiBYTP	1402	888	394	12463	13778	jxhChNdPAeBDCJcRamoNNJVdxjsYrF7icf73mYJo4WBNeeSGquq	10815	15232	15232	1618680960000	orphaned
21681	3NLM3KR3nrefinRAtighYumFhL7MZTctwR9cRk2ChZG9Bcb7g8Gf	21580	3NKcD6wWitKVff3fA6n5TcqBj9Nw8NMhpWtzNWJJxw5aDuF7Fc9v	1402	850	394	12463	13866	jwGUCquEfCXEorP6rrCA4sAN3TDnEXLZPoCYaGswNhM8YG2vqWu	10816	15286	15286	1618690680000	orphaned
21577	3NLK2BdZksskyk3CiZjGuDU6uHJK2vjtZGt56BX5W3sXg1fKYZXn	21573	3NKLUUnw3HBTMwiRbXa9imLDsBwEn8AQh2U6SNoMXn5Vrrag7TkU	1546	1213	394	12463	13776	jx9woZgPxUnfKK2woW7mDawmkmcw5HVkpwAt2Uub1DfoiEoKUFZ	10817	15231	15231	1618680782694	orphaned
21578	3NLhRnjr88Qrx1MndAWRL9tdoUE5xZKRGdMuoeuxQFCzwPNv3nGV	21575	3NKB7ofoYbgdXNR8yUq3KTkvuTMtz7PmH17Fo2FLkUzXvJTqPuQZ	1602	1369	394	12463	13777	jwkk3vRBdxeKG2y2cKvMZ9yxZEtQFhuo9LW3ezMQq1vxpPucGf8	10818	15232	15232	1618680960000	canonical
21583	3NL1ehvpA9antfnvER6ndtABQdeieUmt63ifvKjSZALY7ZkWJVt2	21581	3NLfRCYDYtsDZgnr5TE4spddv5JPtWUT2v9NXLtDAuC9CWeQVN7R	1609	1087	394	12463	13781	jwJHQgEvJca41CCk7Ei4Md9acGyLSm7wMdWsNjbz2ywVY3GDDPw	10820	15235	15235	1618681500000	canonical
21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	21588	3NLAFU2kcMHLSoJHRniAVZwmy8CbXDvMod4StHmwmWzYNR2QG8r8	1407	1395	394	12463	13788	jwQocWzkfgpVyUjmLCaiBZFz2reL728GdGNhxTS2bUJTxM36Goo	10824	15240	15240	1618682400000	canonical
21595	3NKnkyQoRh6Xouoz4dXFhTTJgzAXUENWEKFt5L5ufKWw8WPAKRSA	21590	3NLsYFDdKgmsLA3wpnFumF7NZxEmRKDN4GQodCm5ZNZvWxiYFNn5	632	1382	395	12463	13793	jwBQbRfDzz6g3HAPDmJapAyggCCEQxwAJyzoapaAK9QtMcG3VVw	10825	15242	15242	1618682760000	canonical
21601	3NLFE6JM3UftVE58FJ5X7eGf4KtmLsotMSxNXjpunxCgZNW2q8qD	21597	3NKkuXBvP4AKWvusqt3xqvZ3Fa7HLw1ZUW7TMzkyXcVBJ6PTb3k2	1675	1342	395	12463	13798	jwHoEiZvyTP7rqGVbB13UaZn9zn6eHUQgL1suymPapcviP46F7u	10827	15244	15244	1618683120000	orphaned
21603	3NK98zUtLteW3U3T8d6f2SK3zsT1oncAaMNNrttZFXngaevn5ZHV	21600	3NL3LigezqsPwSVuNRyWdmkBmMnD4M7uvghUjcPb6qKQQrqW9anE	1654	974	395	12463	13800	jxKYi7GznCjVNifsiYVkdyxhVXeTdBoVdz8Zd4xwB9bba2NuKTx	10828	15245	15245	1618683300000	orphaned
21609	3NLZ7kej95pjFLdsCCJWRh9DRdASeL2oezPYQJE4T9mMGzqpHids	21607	3NLRxyuVCtKpXj8XJSFvVnHBXKGprWdAvmiCsRYdbTCvh64xQGys	1507	345	395	12463	13805	jxDcopqwUKUK7uXqC19HADY6kHh6jkXaSfSfynYs1g7tA74gpNg	10829	15246	15246	1618683480000	orphaned
21612	3NKENghseqCdS8SMNQ1PKLXkZeu55LqBag8cmKe75PA6fjvaeA1P	21610	3NKXs8uZUdKQqSpX9VAw9p76C2MAsiKbo9DFR9AhL9SW1cyx78Mq	1457	1391	395	12463	13808	jwg5x92wck1p28a3HSHHpiCGTsVjSHEN5oBDpo9RfkLKSaYiut6	10831	15248	15248	1618683840000	canonical
21617	3NLASMrMmUG5e178dFvLqUYS8D2p4WBNwD84KT2mFcfEKuQZiw4a	21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	1652	1189	395	12463	13813	jwj3bEDeii9uWRuCT9kZHQ1W95z5sUQGdRkbdpf6ui1nLa9PHg8	10833	15250	15250	1618684200000	orphaned
21624	3NLF5ZV16tA4YeRd6c2ABXPCkL2gCTcJ3w7p5JaydaEQu7GmNujd	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	606	1295	395	12463	13820	jwf7vMPeJqqorK9ZVAjb6UGjGgKrfUzSMvjmEVN5XBCfBefbjJF	10834	15252	15252	1618684560000	canonical
21621	3NLoU25v2xj2eaw83wGp18JY2ikMLCRRVZah7okxTVbjcYitNHJK	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1406	1393	395	12463	13817	jxueCr1SUHLNXV9KgrRtJo8qgkCofaJWsGrNkAbe6pKytKjjmv2	10834	15252	15252	1618684560000	orphaned
21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	21629	3NLMkVorVJYmin1gohCB3zhY5jP8B5WXZ699zuza1fSdAo5XUkq2	1490	1028	395	12463	13825	jxon38m5GSSjGu88aMoZAs8nXQskEhJkoSPUDyP8zxqtb9uhcPa	10837	15256	15256	1618685280000	canonical
21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1585	1120	395	12463	13828	jwwWJcFUY4hKFMrPhEyQ8J8DxhMuf8pF1BFbB8YpgnbC52U2Qnu	10838	15257	15257	1618685460000	canonical
21647	3NKQfZosvnF6UG2rDiLUUdQghBNUQaeeEEK56PgnjQGDGzJsMR7N	21645	3NLejFuFKp3UXzNv8qqW84p91H3PozxCzw7rNBSD45etdE6TYz9y	1444	1381	395	12463	13837	jwgRbKKvmPmurYAcScp4rVdiEMjmVhiXQugqJVoUVBbxvBSjgea	10845	15266	15266	1618687080000	orphaned
21650	3NLodqGQULTxs3FkXHZd6MFxA4TVNdqRXNKFFe84Pt4vmqKKNGtW	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1403	824	396	12463	13840	jxswEHFByeiAnJgB6EqC8WUsgpp1fGATv5Y75b9ZpsupVjrqpju	10846	15267	15267	1618687260000	orphaned
21654	3NKxTsCwovULocJtgT4QZxsRF6XM2RNpic43bCXMznCPTX2t3F8S	21651	3NKxPQi8z3YHMSGHNmUXAPjZxtZPS5WNiNV4k4vFtQhUdGfe4mRT	1627	1139	396	12463	13843	jxyJkBrqTBVhfLVei6UtG4WpnEdoePiJtRLmtphZ5xfL3DoxLA5	10847	15270	15270	1618687800000	canonical
21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	21658	3NKsnk2fyeASGkEvRAdkHz1TE4LWkDNqmHGoySEdS84wxuDwv847	1542	1304	396	12463	13848	jxNu6bJThH6ir6VFDsB2HVEqFjgFfxdugyxpgQM9ZJC4JSXh7aU	10851	15274	15274	1618688520000	canonical
21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	21663	3NKJNAAJtA9Dhi4Z7FDA7TdpZpCbWdeuos7XV1Wgy5cJDvpHoTLD	1560	1045	396	12463	13851	jxfktaQTm1ih1BAVK6UaUazx23zoGGkTbb3P2CyAvif7Mifzekz	10854	15277	15277	1618689060000	canonical
21673	3NLLumDaZ6HDWFTVuLSVqkZzKNU5nsuvhqSsorjRM63sWkzpAcuR	21671	3NKgsBsPzed72iSMU29VP8FwNrqxFVZxqUJjQ6SWWuPndbEFSrWv	1444	1015	396	12463	13858	jwpwCPiZBEvqspckqAbZz5Tugr6pjcppm3Voi86cfTTogHWwMA7	10857	15281	15281	1618689780000	canonical
21685	3NKXYYvB5yH7BD9aDrwW3kHmDdnpDZGEK6mDEztXkgY9MghmMguw	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jwrYLZZrC3t5NjSVbBJiL2pUv5FQAKrKYTq47wJzu1pqim6PSFg	10863	15287	15287	1618690860000	canonical
21688	3NKbJcUrrCbKKHFUYmWxnDzWSMUyWCgwYLgPsqWBSKBuLmk8yGGG	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jxtGPQoWDcDEzfppiUwtVT9x1MnRB5R7uQUenUZvGwr56tvxnf5	10863	15287	15287	1618690926795	orphaned
21692	3NK4XBsB16ywoBLYHVovPwzYfnjyhVZDigo8JuMbw12zDc5Lc6cx	21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	1593	1100	396	12463	13871	jxkgcoo3DWUcZwPk2wd7PdyBM1JFqecThXVbhhuRrL4mDRsJkpC	10865	15291	15291	1618691580000	canonical
21690	3NKqEEdzdUxvL96vZsBAwYRSUezVRxianrHjai7TkYcwqVqvxcvY	21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	1593	1100	396	12463	13871	jxEGVq9rMT6xbfGqCyH6UsVH2mRwrnAxRi2NkFKxPTo51Kz6eox	10865	15291	15291	1618691580000	orphaned
27414	3NLDdbUtn5mzcjobztgqsUodd8mTHKKLxCKoAKrW7gQPhqPWJ5rw	27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	1448	489	532	12463	18974	jwmj4ArpLsnPGTGiZ4LRcWqyET39qwTdUbEYFqrKhBBfuAaptca	13555	19081	19081	1619373780000	orphaned
21613	3NLLSbSHAyiJaA2DExr1W9HRDtnjmxSipD66ZTdSG8VvEKT2VZb8	21612	3NKENghseqCdS8SMNQ1PKLXkZeu55LqBag8cmKe75PA6fjvaeA1P	1627	1385	395	12463	13809	jxjqBKZVoqR7Jp2pcfk6NnTKabaUiwamkWgKqKaRK6WHEww1xGX	10832	15249	15249	1618684020000	orphaned
21615	3NKjHRZ7NuByaPuWpDSTp5TwxxYVztmrMcRnqfhcdsnPNyRShJHv	21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	1656	1343	395	12463	13811	jxCN1V1Ez62GWnATFAeFS7hQywsoqndSM4bHRhbVB8fVPBRttPi	10833	15250	15250	1618684200000	orphaned
21622	3NLP1aZf6n92ocTZ3d8zhjUYxS1f6mMxs89vGzKk6GAri9Tq1wxC	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1407	1395	395	12463	13818	jxEn23hGhYeZfpwFKKaGwZfKtuFAtHvr4Eptm6xcJJ7gaU5EH5y	10834	15252	15252	1618684560000	orphaned
21627	3NLMrHoDBn9BWbwWt6EtUokzbyjMDSofg2BoVyWCLky5MT85oDAg	21624	3NLF5ZV16tA4YeRd6c2ABXPCkL2gCTcJ3w7p5JaydaEQu7GmNujd	1406	1393	395	12463	13822	jweCKzbpcQqTjovAG59Y6PWvmDr3nBwpEjKYCCDzkhsYNRmqH7e	10835	15253	15253	1618684740000	canonical
21628	3NKMmcHGBSee5bpaUZEEo7qx9uiQ34Mfeue4b5dX5aqeapLLitYb	21624	3NLF5ZV16tA4YeRd6c2ABXPCkL2gCTcJ3w7p5JaydaEQu7GmNujd	1673	1368	395	12463	13823	jx5mDzZQAYf6p5ZVTaYaCYFZF5zHb7e3UiFLpoYSH66E4UXr5BP	10835	15253	15253	1618684740000	orphaned
21634	3NKTTz1Ud8R7MVAWe99kwuVZ9z2V2z74XtB22Nz7z5at9CMdmXSM	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1536	1313	395	12463	13827	jxu5oBQRiHKWZrRopte9MehrGEpSTgZrg6d33uPWYc3CtvAND4H	10838	15257	15257	1618685460000	orphaned
21631	3NL6Adg2YfC62j3K7Afb5rGMa4HT7ANr9AVS1mRjPxL2xJZ6LY3T	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1406	1393	395	12463	13826	jwUZhygG1AYBVmUssJ3PmQ4RAoaecV5ivVSEjYKPxNj96vzw5d4	10838	15257	15257	1618685460000	orphaned
21637	3NKgxSoiwi9C7Sv2vCSGekGVRtkjbHqGTpw1s8GW613rW8MZ35qj	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	1631	794	395	12463	13830	jwkNLBxUy6HYcYR3RWE87sEU9Y5vdxHLapWSEfTpPBReizu81Tk	10839	15258	15258	1618685640000	canonical
21635	3NLEW1viF8QH8xV8GjhLHt5DApX1RMenv762SQCrpNCosXqS3cyf	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	1593	1346	395	12463	13829	jxk3n82mnCKBEUy3xyPe3kWnNEmz3fRH6N3iHPeMJsg8huWbL11	10839	15258	15258	1618685640000	orphaned
21639	3NLUvCgwbzyqb6yC2wf2KMvTChFdiK7DTKHTHsw4nQFY7ZUXbMKW	21637	3NKgxSoiwi9C7Sv2vCSGekGVRtkjbHqGTpw1s8GW613rW8MZ35qj	1672	919	395	12463	13831	jxSjSQaG1XoiRyJgDLVJvFTTWf3BT7cK4sMeVabDzToMjD2nUtW	10840	15259	15259	1618685820000	orphaned
21641	3NLyZDzZr9qSvUZ26MC2cxz2RRCY53H7D6FgLUz5XgG5TsxKKxSZ	21640	3NLFV4n7KQdAJmPpdGGQ6TPFELrn2amsy2QEzMtFAaepT5NuA4cU	470	1309	395	12463	13833	jwRyVyViNH5BnYryVVUn2mANu9zye3xZjckeL77RLMZbpvU3Wv9	10842	15261	15261	1618686180000	canonical
21643	3NLeRr31V7vwhbd8DPcqzDw4G8w53fejjn9H2fLKzVcwSvSR3S2u	21641	3NLyZDzZr9qSvUZ26MC2cxz2RRCY53H7D6FgLUz5XgG5TsxKKxSZ	1460	958	395	12463	13835	jw9NhYwAWVbsCReoZHFnXYuxXArgWT3Wh9FKnmDJshN2toDR6vb	10843	15263	15263	1618686540000	canonical
21644	3NKCXT75gHTk4HKfj7BgH1vBCjJ5EpHh7P3YQJgjg4RohB8bn4ao	21641	3NLyZDzZr9qSvUZ26MC2cxz2RRCY53H7D6FgLUz5XgG5TsxKKxSZ	1460	958	395	12463	13835	jxoz9V9VVveCrZPc6B735cxM3wPoqNZHJnfRfLnHxLk1fTLFgt7	10843	15263	15263	1618686540000	orphaned
21645	3NLejFuFKp3UXzNv8qqW84p91H3PozxCzw7rNBSD45etdE6TYz9y	21643	3NLeRr31V7vwhbd8DPcqzDw4G8w53fejjn9H2fLKzVcwSvSR3S2u	1648	1284	395	12463	13836	jwYxLsXhXuasZi4MmsowLpjyMcnjApvHCUZ7Tu6mU1zSQQAqwxM	10844	15264	15264	1618686720000	canonical
21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	21645	3NLejFuFKp3UXzNv8qqW84p91H3PozxCzw7rNBSD45etdE6TYz9y	1444	1381	395	12463	13837	jwgRbKKvmPmurYAcScp4rVdiEMjmVhiXQugqJVoUVBbxvBSjgea	10845	15266	15266	1618687080000	canonical
21651	3NKxPQi8z3YHMSGHNmUXAPjZxtZPS5WNiNV4k4vFtQhUdGfe4mRT	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1542	1058	396	12463	13839	jw93QpAL29dx1ek9JKRmbKAd72HCLxD1MS2oimr2joXQCMeV9us	10846	15267	15267	1618687260000	canonical
21649	3NLo2QziDomupNfX95pVnZ4aG2ZPxHiciBavEGAAWDXLm76at9rE	21646	3NLGiMM8q3asfbPos6GWmYiagvU9yJ8bFzP3DZKo3ETVRzTzM625	1542	1058	396	12463	13839	jwmTqmYq6VhTnTXB1tdfBRvH73QE1Bn1NJdfjn7Umb3NhrGLy5R	10846	15267	15267	1618687260000	orphaned
21655	3NKiTKkUCXytH8MXv4Wken7kT3H3HBZvjPyzfA8EHYwkcnCfZNgL	21651	3NKxPQi8z3YHMSGHNmUXAPjZxtZPS5WNiNV4k4vFtQhUdGfe4mRT	1637	816	396	12463	13844	jxxQ8ddJzjkMrhfJiS4maDwnRX2wwxSAGvjyLKGPyejsAAEq51r	10847	15270	15270	1618687800000	orphaned
21672	3NL7DBMCbANx2XJvj4fb2ZgM16hPYCz3qMjvpw3J1Y4DFkNke4dF	21654	3NKxTsCwovULocJtgT4QZxsRF6XM2RNpic43bCXMznCPTX2t3F8S	1542	1304	396	12463	13857	jx9u3Ta43iNj2Ze8VoBUUczZzLsqbeqvxfsh9E3mB8u8djR3eek	10848	15280	15280	1618689600000	orphaned
21657	3NKCV1xdzHUmQjphAKLgced8ekMZwfDh93uvZZkWMoEQuFbLQXgX	21656	3NKeZKJKjMDcXzcea6z3tUQXJ4wzqUBvQa9QZbdGKeeHPdcxRoeX	1516	1294	396	12463	13846	jwRdT2MAPrvA5R5x6fdcyD3b6XmSmJRGUPFRAxnokrqrw4xM5ju	10849	15272	15272	1618688160000	canonical
21658	3NKsnk2fyeASGkEvRAdkHz1TE4LWkDNqmHGoySEdS84wxuDwv847	21657	3NKCV1xdzHUmQjphAKLgced8ekMZwfDh93uvZZkWMoEQuFbLQXgX	80	1027	396	12463	13847	jxZSuw2D6s1vU6GEWA792VVkNxHAhMS3zUMM1CyzHWiYacKPRob	10850	15273	15273	1618688340000	canonical
21662	3NK9JAVqQnyjQsYYpDMwb1p5JrbjVQZkgxA9pedEQJ2SV99Lan7m	21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	1671	1119	396	12463	13849	jy2vbQTWYDjZgDx259XNX89pFXigmwEYY7gTkHSDjfmwnThHuA7	10852	15275	15275	1618688700000	canonical
21661	3NL1Lrh8s2PjCN25jNUr3mybAr3cvN9PBFfazEVp4uDWNcLJ3DxH	21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	1671	1119	396	12463	13849	jy2vbQTWYDjZgDx259XNX89pFXigmwEYY7gTkHSDjfmwnThHuA7	10852	15275	15275	1618688702484	orphaned
21660	3NLPmJot5jzrpjzDqKsXFM8DrduF1XK9XpVXt1Sztz6msPbjJ4Pu	21659	3NLspCyFjNmMdBJqB4TKvoM5M1wyff3kM62JqdVdv9qooVpZ7LEf	1671	1119	396	12463	13849	jwcxWKe4RHnKWenRQ6fCBqPYjWgAvqsVj6WiYE9f5GDLMMjJmct	10852	15275	15275	1618688700000	orphaned
21667	3NLe4aE4FDwurSNyMkf7rHe19WipbCoJn8vgbdzntALWV6Ttv4Cu	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1602	1369	396	12463	13853	jwNvKMNDVSdds647UDoQ6QYWpyputZPKUvXQumkJCXU41pEwGZw	10855	15278	15278	1618689240000	orphaned
21670	3NKQZMyse3H56o8ZszpPM7LtTE4wcPLAgZ2DHVRn1rN1rGuVFjYs	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1675	1342	396	12463	13855	jxnGJjgBV99jbJcMqAaxfwLtx7Fb3vYpQ9L2THFZTdPW2oSe5j1	10855	15278	15278	1618689240000	orphaned
21674	3NLc1daYvUicAxGHW8F4navEscm8khmc4JEwDWwCE4tc9VgoKnVj	21673	3NLLumDaZ6HDWFTVuLSVqkZzKNU5nsuvhqSsorjRM63sWkzpAcuR	1546	973	396	12463	13859	jwXwE4bsikLui6HzTdtY8shfJxzWsxUECiQTFBEHQB6mcciFmSW	10858	15282	15282	1618689960000	orphaned
21679	3NLNeYV3nFQ7WfmdcJESafoUJgyqQNctkKof4eZSjnvovCrAtB7q	21678	3NKA3S9w96RVuZr2Png5ccAgqx2cK99iu12ZnkoJDEvBGCS8NRAA	43	1184	396	12463	13864	jxNJ63e3DUXqku82B8b1Tb7NvhAxMVzjsu4SBJdex11sQb1SSCQ	10861	15285	15285	1618690500000	canonical
21684	3NLZapfwVQmp6w4muiLbuALho9Jbjba2sxwLJi6QLW53j2NBmG6f	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1579	1263	396	12463	13869	jwyUNEn6jvhrvqaXJHZ6A3hCzUcHRx8SvHciHJF643t5Ybvt13c	10863	15287	15287	1618690860000	orphaned
27422	3NKCBZmPbUW9N2kQNiUHt8S3zVgp9rw1hzQrpZDLATZyyVCqBKb3	27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	1448	1311	532	12463	18974	jwXimAd7TW2y89gDiKUi72njq4kfMFk2hYpVDH2BV4FqWo3G7ko	13557	19085	19085	1619374500000	orphaned
21653	3NKgeBUY9SLarVf9vZUwzrdJGwoEvxPV5FbPAP4hvPJyn1DpdsjH	21256	3NLTEM2ZVJD5YBxvLCrAnq4zEeHZS57YJav22PrkZcyn5Jid5BBi	1481	790	387	12463	13842	jwuTviAYD2Pq8xfLv6AMUKV4a4DxUgiYhpEaF2EZ22pytiPmDJV	10674	15267	15267	1618687260000	orphaned
21676	3NLKhmSE1Uzx2DZfTvkPkLMpSCSDjfpLgqksnTD5MNQPy6jqUUTY	21619	3NLgquCDJMexQ2CGF5oJXAQpYEUrfxULEgF6BdjPfSYpnGRPLwPb	1581	778	388	12463	13861	jxW4f7LmHDnveWbQm26UENS5NhQvPjS1G7VWmgssbG9pJExsYAS	10707	15282	15282	1618689960000	orphaned
21733	3NKGykXWDY8vdcyeCTJaohn58vXunLuaGaQLxqGchPNKEPNuAf1y	21681	3NLM3KR3nrefinRAtighYumFhL7MZTctwR9cRk2ChZG9Bcb7g8Gf	1402	888	395	12463	13907	jwxR17jfvG7gtq7K6HQ9PUzpBe8ZLSsd9HEzmsQW8v41dRPMtst	10817	15321	15321	1618696980000	orphaned
21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	21612	3NKENghseqCdS8SMNQ1PKLXkZeu55LqBag8cmKe75PA6fjvaeA1P	1403	824	395	12463	13810	jwPixYENY9MaSqkTgPm8rzLrHs2MBk39HUygMxLiARaYYaW82PC	10832	15249	15249	1618684020000	canonical
21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	21614	3NKmoPPgaoNAy4iPJxHf3H8b86rkquya2cs9H6rZMyAHdjZnpRcY	1637	816	395	12463	13812	jwjiMCbJGcm4Yzv5rDjbCZDtXEjVx9qDeo1MSLSmf3zKmBie7KH	10833	15250	15250	1618684200000	canonical
21623	3NKdLyS9vh1vjxavjPyK5LQMcQ6vG5jsPDmKg8qVWntk2jriFwet	21616	3NKUWQSF9iPVZYTk3bJqAG9HY3oFpNmpLJafeC5J1yzuTEFpNTR9	1670	1036	395	12463	13819	jwwf1dqSueJUGRi8v7BCuMQb11Tpp2fmdbUww742PBJccGYqmUE	10834	15252	15252	1618684560000	orphaned
21629	3NLMkVorVJYmin1gohCB3zhY5jP8B5WXZ699zuza1fSdAo5XUkq2	21627	3NLMrHoDBn9BWbwWt6EtUokzbyjMDSofg2BoVyWCLky5MT85oDAg	1419	814	395	12463	13824	jwzpDV6GFHp8RquBzdt3sQpoVxcsSgsUa37HLZJ1UVCSsKsuYBP	10836	15255	15255	1618685100000	canonical
21632	3NLPccr2op26KEyK9brEgza2ogpZ9aMMUGDFxNv7YkhmfR6Abp6w	21630	3NLYZFkFW5BH7PsEq5tuxboanUVuprmKVzW61DfDbsnynBLAiDsd	1536	1313	395	12463	13827	jxkeCBLaLcn3rrD2LMUhBQyY1arKMXUFyP3k2xNsPrqyGbmgS4e	10838	15257	15257	1618685460000	orphaned
21638	3NKfxTwQgYA4EYrfQ55Ls3DCKiddZSYvNhvChom4osGQAJ7XCEyR	21637	3NKgxSoiwi9C7Sv2vCSGekGVRtkjbHqGTpw1s8GW613rW8MZ35qj	1672	919	395	12463	13831	jwrDSotGLxcDU66ChHP2YY9866RRvnA3Ftun1WJt1D7jBguP3ZN	10840	15259	15259	1618685820000	canonical
21640	3NLFV4n7KQdAJmPpdGGQ6TPFELrn2amsy2QEzMtFAaepT5NuA4cU	21638	3NKfxTwQgYA4EYrfQ55Ls3DCKiddZSYvNhvChom4osGQAJ7XCEyR	1426	1364	395	12463	13832	jxcTheHY4vySb7wGeDVaAJjRUNbZEd7MRPCoBNbFVZUnuP5yPtD	10841	15260	15260	1618686000000	canonical
21642	3NKxvWrTb9Qu9CXUZ2pq5NuagcR5KksL6zBySgjUUyfBy2qFnBjM	21640	3NLFV4n7KQdAJmPpdGGQ6TPFELrn2amsy2QEzMtFAaepT5NuA4cU	1648	1158	395	12463	13834	jx4eLWABJJRxQsDz7nA5jXhqeCm293AqqqrSqy5q3pdk7u1nJtF	10842	15261	15261	1618686180000	orphaned
21656	3NKeZKJKjMDcXzcea6z3tUQXJ4wzqUBvQa9QZbdGKeeHPdcxRoeX	21654	3NKxTsCwovULocJtgT4QZxsRF6XM2RNpic43bCXMznCPTX2t3F8S	1407	1395	396	12463	13845	jxzDwhxrkBdFqd3UsWVjLsfbaa7QzLgrNtFTHMw26FLsGKMvHZw	10848	15271	15271	1618687980000	canonical
21663	3NKJNAAJtA9Dhi4Z7FDA7TdpZpCbWdeuos7XV1Wgy5cJDvpHoTLD	21662	3NK9JAVqQnyjQsYYpDMwb1p5JrbjVQZkgxA9pedEQJ2SV99Lan7m	1407	1395	396	12463	13850	jxCd8JivAmJuxrcrxhiggBHdv9mM3Xiv8nzqXfxhU61Rs8w8e31	10853	15276	15276	1618688880000	canonical
21665	3NKWnWxfYZDfETLEvBPkmUqwxVGFMKogtjc5fr85w99saNStg652	21663	3NKJNAAJtA9Dhi4Z7FDA7TdpZpCbWdeuos7XV1Wgy5cJDvpHoTLD	1560	1045	396	12463	13851	jxfpUYtiw8VVY3fPrMi4XkcNUzwYgdfuiiZbcEm3ZoMYjEQmVzg	10854	15277	15277	1618689060000	orphaned
21669	3NKrgzsDTW1TUK1CaU1cTkjpUQ7LMT2BhygXX6fPxcF9rWd6JQz7	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1607	1102	396	12463	13854	jxSzj5hv6DKQEX2osbxuPZLKhvakkLhDAzTLxV2yUQt4Hc8r9QX	10855	15278	15278	1618689240000	canonical
21668	3NK49XpwD9LNgcDzAJrqBqefwVDcJDoSzheSVgTfuUNYCYXM63xP	21664	3NL89qdVNq3geR1i17gD89kAazcG4Kx8mWstvKvAKYjeGHUSwbp9	1602	1369	396	12463	13853	jxThVMDxeswbfMYtSsz6uWXEsabu11ad1iJ6UFU7Fe73iQoirhs	10855	15278	15278	1618689240000	orphaned
21671	3NKgsBsPzed72iSMU29VP8FwNrqxFVZxqUJjQ6SWWuPndbEFSrWv	21669	3NKrgzsDTW1TUK1CaU1cTkjpUQ7LMT2BhygXX6fPxcF9rWd6JQz7	1542	1304	396	12463	13856	jx8RhpSFEBf2KZDYb5zhMhhTGZsvaTQvMzdR1ZjEQfBuQERoqyk	10856	15280	15280	1618689600000	canonical
21678	3NKA3S9w96RVuZr2Png5ccAgqx2cK99iu12ZnkoJDEvBGCS8NRAA	21677	3NKuSr9JiNtaqDf1kfuhLYoAgP6o8R3dFnLAYY9Gfv7mho7QnEDR	1553	775	396	12463	13863	jwUxgqbEqPSGrcnzVyY1dKEGrsW3XSwPVzuMjyy8b5XwWWp46rr	10860	15284	15284	1618690320000	canonical
21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	21679	3NLNeYV3nFQ7WfmdcJESafoUJgyqQNctkKof4eZSjnvovCrAtB7q	1553	776	396	12463	13867	jxoYspc9ppcSBbLF7b5KGj1dBnPWhso8Uf83hnXwdagZmBp1mYA	10862	15286	15286	1618690680000	canonical
21683	3NLFX3PQJf64SgCYaVpM2C7BfZYMbpbjuwiZQmyeVEjezLhMTjbf	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jwSqmFWM41YZKNMQTFikoec6htGPxiYYf81z5HGLHrfGPQ4t1Dh	10863	15287	15287	1618690860000	orphaned
21694	3NKEXUuNNsfUVQaGKzPUksqWqn4Zx1KgKakEZvEpKUKqym1H5sCT	21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	1527	1293	397	12463	13874	jwb5ts9QSiYueix9pVVeZkKGpX9F9MD5ir3caGk7nGUxWXuTdcd	10867	15294	15294	1618692120000	orphaned
21704	3NKFSLwrjeYUKvqveGWGa5JUAtWyjJ8L5MDLkRv5YAaT36DVdZNC	21703	3NKGCcAFD2z7z59EeYSjK8XGoef3qcNqcsy9z9Y1j2bNkwdfeY43	1440	1377	397	12463	13882	jx84EXqp4kB6CYARinajJM6iJq33QhuFu8YSaJdf3RWaBZ1hDJh	10872	15302	15302	1618693560000	canonical
21707	3NK9cLhXpZi25V7dwE97vq4UbjxaZ7B5xupTxaeoXWdQa1B1hoyQ	21704	3NKFSLwrjeYUKvqveGWGa5JUAtWyjJ8L5MDLkRv5YAaT36DVdZNC	1483	421	397	12463	13883	jwXX89UY68jL3vZ7hKQKU1y7Z3dYYyJCuRoyxHUgY2aq35i4XtN	10873	15304	15304	1618693920000	canonical
21710	3NLLWikKfviweLHB9L3y6um1LpgFLYeKZDmvwBSvMMX2C2AdKhjJ	21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	1536	1313	397	12463	13886	jx1YtpMV3f6HNvNMfD51XgJJbwzxWHrbvuLHVB4ntr2HZ96mnKN	10875	15307	15307	1618694460000	canonical
21714	3NK5ErbfzZswUqRGAeDDrvCvi4hrz3CZkGWkZPNRSYNuCMMkc5zB	21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	1637	816	397	12463	13889	jxLwL3gYBkqTmnXKQU7o6CxewwdXMcratgvUvLfjDaGuacyVReY	10877	15310	15310	1618695000000	orphaned
21717	3NLkf2UyzCFB5FQgWkLtAcLQNwj6qnFkL6rwA1T41RuDggAMGjRg	21716	3NLHJ1q1maQjnUsTHdgmMLii4AiPUGqtTWVe1iUMhw544FWchdhi	1637	816	397	12463	13891	jxZe1sZhpoz7sjeVuJ7uTP8noJb3gntsnGa7semJSCJe6DHsBD9	10878	15314	15314	1618695720000	canonical
21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	21719	3NKSg4C5tAaLrwfiG5NddfVxxFGwaQUcBdNSk5bVQdDyAJBDV5ur	44	1199	397	12463	13894	jxKHCYwGm5goi4dAHmCynk7tMN2wfV7qV8FMkAtmEwMaKCidzqz	10881	15317	15317	1618696260000	canonical
21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	1406	1393	397	12463	13896	jwEPTMCTEDP4MpcL5UvzwBkiYkRxTBVs6C5GPdnSrpkMZDzeyvs	10882	15318	15318	1618696440000	canonical
21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1406	1393	397	12463	13903	jxdmAjbZy29UGV3gGy6f8vLyAe5dn2dDiR6NeeCeFqirWu6Cznx	10885	15321	15321	1618696980000	canonical
27463	3NLPdMzm6T613MfgzN4T9xCwSWGQ8NoENEksfYrtdjCM9Y5GY8Ks	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1599	921	533	12463	18974	jwpDfvroAGDVFW1DHCp9Pc7Vjs5xcVoNrqagfVQRJXX1Xhz41Qt	13573	19106	19106	1619378280000	orphaned
21680	3NKG71Uk3HyaFSwy8irBj4xWmQoXsxtHqWoD7FFwYPcWoMwS5o3j	21455	3NKiss7kUrzU89mZMEctTcNbsdWyVe3r15jdSsGbammm8LADTdLt	43	1184	392	12463	13865	jwcPDLsp2SEgM73VW9THteJueNS7Zwfo1fZtcCjvfE4WmtvCVqC	10765	15285	15285	1618690500000	orphaned
21754	3NLAe3eSvtb3rfDEtXUS3Xp6QcRBgYWg4tkPHKpL6cwznfx4WN9r	21680	3NKG71Uk3HyaFSwy8irBj4xWmQoXsxtHqWoD7FFwYPcWoMwS5o3j	43	1310	392	12463	13926	jxbMX2VGw29VWxxgps9yjYeCYkp3PrzycPoVxCxgoRJL75gadES	10766	15331	15331	1618698780000	orphaned
21675	3NLYAibq6BwFC1gyKCRbGyX2TdEZxnFcuQtKQEoZtJRbjbzC9bGB	21673	3NLLumDaZ6HDWFTVuLSVqkZzKNU5nsuvhqSsorjRM63sWkzpAcuR	470	943	396	12463	13860	jwdHrbJeEs9uriCWh4FpoaneNsCvAVMAUh3gp5qHCuk29diNcZc	10858	15282	15282	1618689960000	canonical
21677	3NKuSr9JiNtaqDf1kfuhLYoAgP6o8R3dFnLAYY9Gfv7mho7QnEDR	21675	3NLYAibq6BwFC1gyKCRbGyX2TdEZxnFcuQtKQEoZtJRbjbzC9bGB	1589	1040	396	12463	13862	jwY1AtaeUecSwgvBRDhP7A8r5eBVisgGjGJTN4jXpHi6CdeuwpF	10859	15283	15283	1618690140000	canonical
21687	3NLFrUmqK2VLJz6KM5m7DepQPERc9zxp2G6ogFtgArnGmZ9K7WGU	21682	3NKjb7Z3w7cWmoxyK62LVSr21uXvegyVfskRFtJbYNxoBppiKYv8	1527	927	396	12463	13868	jw8VNRnqNfUCAv4dFMBGJ5RAbNnccPcfjAH9ZGrC68eERM6WBaY	10863	15287	15287	1618690912246	orphaned
21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	21685	3NKXYYvB5yH7BD9aDrwW3kHmDdnpDZGEK6mDEztXkgY9MghmMguw	1675	1342	396	12463	13870	jwb8uY58ppgHzffqKM58Mhf3UkAn8yspXRXmLEktPXgzP5FZhpX	10864	15288	15288	1618691040000	canonical
21691	3NKnTRJregArrLbhNtAmecjF4NnaYTe6b4M2NkyLohPeFuMR6Hh6	21689	3NLEqmZPvV7jcYsorNWtGHgvar4ApkZ8R4ru6f9eDNvehUCMLs3D	1634	1331	396	12463	13872	jxoF52KnnMLGTAFvMcKoqaJN1LMYN9CrHKVH1HDJaZJQYesSSJA	10865	15291	15291	1618691580000	orphaned
21695	3NLxfDm6TsHAmVJE3HPk9txy67vCgijuA1vMLZRDtv1rabXFnwkT	21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	1527	1293	397	12463	13874	jxLtHFd3TQvraTA3VBs37Uv8m3ZWXskUJ8iTqigXk2HqMbr42Go	10867	15294	15294	1618692120000	canonical
21699	3NLEzdUqo53HWbJNFDokHsp5FSC8Fw3L3WTT9esokurUa8cxp3aF	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1585	1120	397	12463	13877	jwca1FAk1oGi7urNeie7GGJXpzig33ANX8FDncgu73aYhfrqhSE	10869	15296	15296	1618692480000	canonical
21700	3NLFsGZumYQhDiYQZ8LdXGkvRPtCiaoZMFkP8nR7M1MvTUuGkygG	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1596	1117	397	12463	13878	jwAQh8fFnJsy2DVkFMyZxEgJosB4SYwz3gAEatGJi2oyNMZJ9uS	10869	15296	15296	1618692480000	orphaned
21702	3NLW38FdQ89HYDCxmv9uFiXixfytajdGASyRZRWEjEdjUPPb6Hvf	21699	3NLEzdUqo53HWbJNFDokHsp5FSC8Fw3L3WTT9esokurUa8cxp3aF	1406	1393	397	12463	13880	jxP9q4agFHEX95soCrFZi9SqRpzYnuiQQjR1CeJotoEbNqffUDy	10870	15297	15297	1618692660000	canonical
21703	3NKGCcAFD2z7z59EeYSjK8XGoef3qcNqcsy9z9Y1j2bNkwdfeY43	21702	3NLW38FdQ89HYDCxmv9uFiXixfytajdGASyRZRWEjEdjUPPb6Hvf	1403	824	397	12463	13881	jwEGy2BYTMdMxSdcFqvS3ZcCMm8MiDS5drt1Gx4RvDELrmB9ZdV	10871	15301	15301	1618693380000	canonical
21705	3NKkvH1mpZxYJxwL5VkBEg6r6x84UsyZcnFyfkcMnkP3z6EzoTQZ	21703	3NKGCcAFD2z7z59EeYSjK8XGoef3qcNqcsy9z9Y1j2bNkwdfeY43	1440	1377	397	12463	13882	jwPrwDpiMfKGLuVUGrTh5yynMx5DPtawygc4TSJeqrruEe6CcYS	10872	15302	15302	1618693560000	orphaned
21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	21707	3NK9cLhXpZi25V7dwE97vq4UbjxaZ7B5xupTxaeoXWdQa1B1hoyQ	369	1312	397	12463	13884	jwdr8y8EhE26us63Cw2Fa8okCJS7okc9T9vbQskc1uUM5gQK5Lr	10874	15305	15305	1618694100000	canonical
21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	21710	3NLLWikKfviweLHB9L3y6um1LpgFLYeKZDmvwBSvMMX2C2AdKhjJ	1608	1289	397	12463	13887	jxs3vPAcvuFSgChkTdoKe8LZMS2RKt6q3q82deRZp7rDvkvs5aC	10876	15308	15308	1618694640000	canonical
21715	3NKzUUUD8eD2ZVmoGpanw2LX3rjC238rYYMR77QwubX7AUHCgJur	21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	1541	1298	397	12463	13890	jxTAfU2p3fpuJiKUVYnzDC2jirAvuM8xErSe6zE25s8JD8XPGps	10877	15310	15310	1618695000000	orphaned
21718	3NKwNR2oKskvXvVPh8AknaNkR5SXXCV2LMS6NAGmbrxs8PUTq1qU	21717	3NLkf2UyzCFB5FQgWkLtAcLQNwj6qnFkL6rwA1T41RuDggAMGjRg	360	360	397	12463	13892	jwQ3cbjcV7HQHAoBntVbgmaSjnSwtRSB888J21cENNppD12XbFq	10879	15315	15315	1618695900000	canonical
21721	3NKmfNzTFaVF4diACYJymuzaJQu3NL36tSEPsuDVV4mLB6d8G6JK	21719	3NKSg4C5tAaLrwfiG5NddfVxxFGwaQUcBdNSk5bVQdDyAJBDV5ur	1637	816	397	12463	13895	jx1n1ua5AmEdXuV3wn8NtwcXMPLhryZ57Y1mhQX3eGD8poGgD7d	10881	15317	15317	1618696260000	orphaned
21723	3NLChwqedKRApjXe19XtDRYbuTDtzDJZidLDm5BtCLTsmD3f4yTd	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	1536	1313	397	12463	13897	jy3FghspqufXkeFtZNJh1YwzRzkk4Kpu4AU1f7iM6gcQpverRKQ	10882	15318	15318	1618696440000	orphaned
21726	3NK7GT6L3TUhg2Bz4Wu1yhDLB3pTXUMcs3ftTiqG3ehcTvfFoC95	21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	1619	1275	397	12463	13900	jwruWWBNv7vfG6nqTtNqbPEnNsUYgCmtmSroqkfg1TqwaU3AgjR	10883	15319	15319	1618696620000	canonical
21725	3NL6qpDFqU9pGHdkGtJRpTnxuq6E36yJMUMUoJqNXH5oLPXGtSxY	21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	1407	1395	397	12463	13899	jx1CFiNDERWsBCVTBfeAwS5TCGru1ZTLyG7xMRqZoQS8iXcQFQ6	10883	15319	15319	1618696620000	orphaned
21732	3NL2pLA5E2WRPhW63ckTWzMjLWyXHPisehs4PMZYby3Y2drQAkM6	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1506	1373	397	12463	13906	jxrFRnJLNWsdzpDrmX5ZyYXbE4dFzdJEjJkY3QvQr5jKSeC6hJk	10885	15321	15321	1618696980000	orphaned
21730	3NKbpcK3iGGbGFka2Ekgb6HF41hmtB4THQa53dnTsSENDf1EdgMb	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1657	1098	397	12463	13904	jwSihhziA65shWFnbHghzLiaMGgLXftS1oFZcFhidwFdgKM4aAY	10885	15321	15321	1618696980000	orphaned
21736	3NLvW91YzqfgyiUAhVfrVJADDDmbNkUNPatbg1egG6vu95xmE2vE	21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	1599	1287	398	12463	13908	jxaGHm1hcRmDqEq41a8VPQSbgjpoB4g2JNiXs5uD4F2Fjak2atg	10886	15324	15324	1618697520000	orphaned
21735	3NLbyYB8AzL7o8VSrTGRUkhuAFVAgwskHhKmssXEUaWucg8iveKh	21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	1594	1326	398	12463	13909	jwpjatgWSXBQMs1BLAjzG6TBS7ypUvWdhRdkUzwqooJcHmdPFKM	10886	15324	15324	1618697520000	orphaned
21739	3NKuTGDE9MFVnkypEn3f4sW2MtbQR3evVtaLnYws8G7FmZBZPPAQ	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1637	816	398	12463	13912	jx8Snm883be35ai5tpUnHkeWYoF4ixLLqhdYR7xgMBXDzR4UArv	10887	15326	15326	1618697880000	orphaned
21741	3NLSUCNX5innfYhrUd84gSKvkUA5QHNza3vbeabayfVQ6p79YHEc	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1651	1301	398	12463	13913	jxfcNLpSG7ucpPcocRwquagG8kgunc6k311qAy6zh9eoULkVxUa	10887	15326	15326	1618697880000	orphaned
21750	3NKEQcN6FV9v83Rvnr7ddYgspAw5JMbSdBZ3Vyp5uGrzriGckNj1	21747	3NL7N2QS9udJjSg7yGUeHHvtQnvAxE9mPJRdZpdSDbhAmbu1nVsP	1474	1203	398	12463	13922	jy15QF7kUQW69GFzhW12ynxf8jPEXB5484UgrE6eKKoPdJApqvq	10891	15330	15330	1618698600000	orphaned
21756	3NLKiSLKgo4dpM4JHWjaFH9dHnEnL9inz8FY7jpyTQsDTojFYzyp	21751	3NLqZ8c1UUhTBQ7iw6uVgpRhT44mR8XrxQocUGJwpi8Qqm9q57kf	1419	814	398	12463	13928	jwZPngHi9Fa1qHCTLhRcfMfuvWJvfjUQXnGmvWYkLwLaxdnKSSd	10893	15332	15332	1618698960000	orphaned
27466	3NKJp4Dt4FmDbCZdtNLVDUjEYt6rPSaMyoLtbp1vs8QDcwsxtve8	27461	3NKUxaWuNCExaAPjLX8HDrQiCTtCn6eqxiKxXMtJBNHct7utDkAy	341	341	533	12463	18974	jxmvr6DhJuS49oc833D7xGC93FBiN5s8CpaudKisuNpXmeRrv5L	13574	19107	19107	1619378460000	orphaned
21800	3NKEeosCX84ZsK6bBJTGhb2pkXgbdXJmt427VS513vKkYYeDnmum	21764	3NKYx4m76BE8SF6BwoKcTfdbGze58ncF1WM9g1TTqmaPtXUfUB5r	1581	778	388	12463	13970	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10709	15359	15359	1618703820000	orphaned
21806	3NKY7Wqk6ZNZs523FYVLfLRU6kopxkRzdS6gNUjGZrQZw2Mp6eTt	21674	3NLc1daYvUicAxGHW8F4navEscm8khmc4JEwDWwCE4tc9VgoKnVj	1560	1291	396	12463	13976	jxoLAgvHmR5LPskrSVsHYqQfKdCWB1jv8u33muq673AGWSvAS8S	10859	15362	15362	1618704360000	orphaned
21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	21692	3NK4XBsB16ywoBLYHVovPwzYfnjyhVZDigo8JuMbw12zDc5Lc6cx	1534	1317	397	12463	13873	jwqH4LxDzSaFWpTqz27YxT3V6e8zi6B3nzqbkng65oY7Jz2f34i	10866	15292	15292	1618691760000	canonical
21696	3NLT9KMHJErgb2dG89NdzX3zoKqSo44eN4D5rDUfryrxELdFrV4o	21693	3NKDZMt4qS1n8ApFNKkp5sBBGihU6VKAsCWgc36yTHpwkExnZ3KQ	1527	1293	397	12463	13874	jxRoRrBQWzALNhR24oqqDLBLWwgUvajcpDkmswu53CJBaZNYNYN	10867	15294	15294	1618692120000	orphaned
21698	3NKDmQ5Hu3VeGidRep4a3Bkvzh1ddwBuWjGAtA1PoXR4ADp35Bjg	21697	3NLj9zqJozV9aSWJaYs8Gmb6sSfH4NZD2uqD1gE5F4sSEtaayqcC	1571	1335	397	12463	13876	jxdzNT7jwhQannqtwmkXs9MXb3zxSvmCh9XSmkeZEfwXozKMAw7	10869	15296	15296	1618692480000	orphaned
21706	3NLhcGJHYHy7ygryaHxmKwNysQZiFz8dP8MdZ7LmuPr3yAjkBxnf	21704	3NKFSLwrjeYUKvqveGWGa5JUAtWyjJ8L5MDLkRv5YAaT36DVdZNC	1483	421	397	12463	13883	jxykaJ7bHjrX2X2RtNmaQ4VWSfv95qpLyax15zWwCWdNDY9uFbs	10873	15304	15304	1618693920000	orphaned
21709	3NK9SMecrzh9ZGHYwgGYuU5N9tCGKSZxgB67fQyNEJmNRnSqgVuJ	21708	3NLC6eh18aacAhupDNT2ftsZc7PEWqLLmXfsiPD7ptSfYZXGJsN8	1406	1393	397	12463	13885	jxhsZq7MNpgwp1T55mwEbDVpU5zCo17nMXu64Wv1kD5YMktw7zo	10875	15307	15307	1618694460000	orphaned
21713	3NLXod6vTEyoYSjNYHNiFdKwV6uN7zQ9AuJJ2MpkE3TR8vU2Fw4H	21710	3NLLWikKfviweLHB9L3y6um1LpgFLYeKZDmvwBSvMMX2C2AdKhjJ	1631	794	397	12463	13888	jxFYXKg9qdW46rAZcApJGBYWrmCQndxBNX7BxUZ4iMgQ8c7WJ8K	10876	15308	15308	1618694640000	orphaned
21716	3NLHJ1q1maQjnUsTHdgmMLii4AiPUGqtTWVe1iUMhw544FWchdhi	21712	3NLQBgGSe5fhU4Ps76Wj8mmLSnYKDj8ZzFiYrRLp6gLg1JcLM9Fh	1541	1298	397	12463	13890	jxKimSQMF4QEKVuA3zToy6DsNcFffQu4F7nLfooD6fNWyoeFBDH	10877	15310	15310	1618695000000	canonical
21719	3NKSg4C5tAaLrwfiG5NddfVxxFGwaQUcBdNSk5bVQdDyAJBDV5ur	21718	3NKwNR2oKskvXvVPh8AknaNkR5SXXCV2LMS6NAGmbrxs8PUTq1qU	1403	824	397	12463	13893	jwPAQoHTiwpWpozKWrv9PBrtYxoPbX9MD5RuBpZvRDb7L9236Pt	10880	15316	15316	1618696080000	canonical
21724	3NKmb3RGjjm9aHn3DbNwnVTDg9dAQ8GJ1NwGqEsyiWf1y13JC8zs	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	1673	1122	397	12463	13898	jxf9LpTb66grAadxa2e2aDtWjh67fEbmctoukwrS9wLoPTHfCK4	10882	15318	15318	1618696440000	orphaned
21727	3NKAS3Mw3rK2PnSHCqSLtB3P4BARW9sGMwgJcdH6jGzMPckr6WRT	21722	3NKekD4n9qpGrVJBVY9j39ksape5tD3AB2CcRNqtj1CLd2awbMJG	1656	1097	397	12463	13901	jwjFrpBFHy25LbNcyUzvatWRDa2JLH1BdQ9ayYFhPzBb8G5fqtx	10883	15319	15319	1618696620000	orphaned
21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	21726	3NK7GT6L3TUhg2Bz4Wu1yhDLB3pTXUMcs3ftTiqG3ehcTvfFoC95	1542	1304	397	12463	13902	jxbaEGMJTv16ML9ArtLmeUKv6GthFKUzF3Jhf31cf8c7uWPj4AJ	10884	15320	15320	1618696800000	canonical
21731	3NKWJR4iXDSx9LKAMXoHDTVwfDmZ8xvSQ1PcnpBtS9vmgQ4LjMBh	21728	3NLe8s8iAGcJVErtrEkXwuHxw5v6iFP3wFDGm1daikRsVHWqcnAP	1601	1142	397	12463	13905	jxQGGiMkL2Ujgy4VmexmK47Q3yB1hfRRy8vGBzwCrrFCx6bmdoN	10885	15321	15321	1618696980000	orphaned
21744	3NLUEFhkNgTi13cdgWtoumMKx3xLshKbhtLLjdDBZ7rvzazbZFm1	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1648	1038	398	12463	13916	jwsKNrhUKswm9EFDrfTmFfZvBHDCQYiajrL3j5vE6hWo13zJwPY	10888	15327	15327	1618698060000	orphaned
21748	3NLwCwzUmSKZGgMwFcgXeEpaGZupan1iX957KbXCqZAD7WQ6wDdW	21746	3NKjifoREmT1rxhGZUvgthxknswexzLpdNYRv3CPgeFTmko5XzXk	1637	816	398	12463	13920	jweLB1xEZhJDwv6YnLDbusA4kv7VgG6VuzwxHzMMhke7JKsvEbV	10890	15329	15329	1618698420000	orphaned
21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	21757	3NKr6nbcDZBz1BUQvmxZKuLM5ekboytDG3933kQA1BzGmcEj3RXr	1607	1348	398	12463	13930	jxsVdR4tbTEDyBHkfhzrV8Ch9TCpgesvqt9eTdNdnnAKKsdFCfd	10895	15334	15334	1618699320000	canonical
21792	3NKiG9ftRZZrRPmVhAGqQKE7YrTxkMdfpsM1E9dcrw9kyU13bszG	21757	3NKr6nbcDZBz1BUQvmxZKuLM5ekboytDG3933kQA1BzGmcEj3RXr	1617	922	398	12463	13962	jxTFTSUfUKDYoKb67EhSsY3fZxK2j8ZL3RECtuSeo2cL2pAidmT	10895	15355	15355	1618703100000	orphaned
21761	3NLoVmPsKLJiqWGBqHHQ524MNEMvcXcjtzkALpMkYVkVsrjTdQGQ	21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	1407	1395	398	12463	13933	jwXajPBmqVhRm9KeCWNp8zvEfY91auziTuoWqcX5jrAk4Fd9g2f	10896	15335	15335	1618699500000	orphaned
21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	21763	3NLvU2YeGLSb5SBCuMaZ85pmsbxE6vjmxUZMnXPeTqd4wp1FnADw	1428	472	398	12463	13937	jxyPJhLY6E4CAzsUiMTcSA63frgxXwvZJ8P8dv3ajRMKGZZwqbH	10898	15337	15337	1618699860000	canonical
21772	3NLmA41vPzJsr9sihwWjUaoE5janGY6cGux7CbQE7tc2yebix8Ch	21771	3NLLSZFxc733MXTqjGWFvF5u98xcCTPpoCJxt6ZfJ8sT6Qamn53z	1594	1080	398	12463	13944	jwBNGFdA51ESMg2R29Ute1Z2j9X15gg4mEpN5GNhFQZr1eUwTpn	10901	15341	15341	1618700580000	canonical
21774	3NLSJne9oaqCHBS8MybQBFEkCgVkNCqTnVzDCVh2uyKFmcTyXS33	21772	3NLmA41vPzJsr9sihwWjUaoE5janGY6cGux7CbQE7tc2yebix8Ch	1406	1393	398	12463	13946	jxreVzuFsUTeXhDZuhtNmQvz9q1GUMqTwBqDFwYEXAPy9DtoaQF	10902	15342	15342	1618700760000	canonical
21775	3NKqHYk8871HHorHArq9cPoVpKCBGLBrXmmCGHEVqnoQunPVAUVT	21774	3NLSJne9oaqCHBS8MybQBFEkCgVkNCqTnVzDCVh2uyKFmcTyXS33	1637	816	398	12463	13947	jwmAWPeExsE8rqQtusMQkGE1KvbiVuuBQ5jF5J2bTGjMHqXWZ3U	10903	15345	15345	1618701300000	canonical
21781	3NLASZ2vtAJNV5FCMR884TzZ7mBJhGJZjoozsGkzh1TnqCLKbJJx	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	1671	1365	398	12463	13953	jxLMzhtvhVdmSaYTf7Wu4HW2VVXt2aZqXRFbsr5Ltm9aQMjjcMZ	10906	15349	15349	1618702020000	orphaned
21787	3NKPd5nU2Wi7GrFFTpDpJMkpAaHnqNFVLYbBfmJQtsgWnDfAZ3at	21786	3NL9BoV6sb6CHnVKMFHfvJLSb6fYc9w7nam2Q6aSzAceE8EYaNJK	1613	1349	399	12463	13958	jwKaqEwHgHyuAQdaEAv4gRssFwv6sHvTe3YGV9FRh4tv2ZLsaSH	10908	15351	15351	1618702380000	canonical
21797	3NKeYsaHRHZDHpmHdV5F2XToKWLRNreRhne3UprjcJFGo5UMyRwZ	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	684	1352	399	12463	13967	jx8KUrYZSPVAiCavakSgXksmg7rQyoi9V1zndc9wJPid99cRDT2	10912	15359	15359	1618703820000	orphaned
21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	21798	3NL2bc8hk1jRxSAwqF91yKPWUjcKrW6GFrAX19v19cV9P2nkt3hw	1610	1068	399	12463	13971	jwXt8PfYtsuYdZPhcqJeAw4YRsJbXKHpRkqk29kV6XVXrhKZjYi	10913	15360	15360	1618704000000	canonical
21808	3NLFPKDaLxZwjGn5BN59M4iCD9qNoqACTDE8yZWV1FbXood5nvdp	21805	3NLuFTcXLDhuViaaZtEF4RBeJitrjyC3WmJBQRvGGx5KxnhwGcr5	1633	1024	399	12463	13978	jwtYpC3YhnESrqV4n4RNKNviHpPJcRykXt3urRmmVeZs9NY4JPt	10915	15364	15364	1618704720000	orphaned
21810	3NLmvDKibWbLrPVXwKtfMgDHxvVEvs6bkwZbTMtAw5GDhbKbHamk	21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	633	1384	399	12463	13980	jxfSmpDWjHefaxu7xmRfqm4yYsXvtDwDnxf3cP9dddXPBqmLxCM	10917	15366	15366	1618705080000	orphaned
27611	3NKakZsnHHfxYaN2GUSXkvScbeQBJCn9EseSCUC7JwoiQTEYyZLz	27468	3NLXVfAnq2KbvrxD2LnNf2BksKR9rKHZpUZCPUD3JyfBjRGcE1Pb	1547	1012	533	12463	18974	jxf8R4BBNHbfJ5XKw9SkCDd5Snn8CZY9meEng9Bqy43Y2wJL7my	13576	19216	19216	1619398080000	orphaned
21778	3NKn9v7DhYecREDN1DUyhrP2YcvQsUVQPmugHCj9uCKaPsN5FyRJ	21776	3NLTBLFLvSYRR7V6JHJyifbsAojpM4XyRPngiQJfFhZP4kom53jo	1402	868	396	12463	13950	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10819	15347	15347	1618701660000	orphaned
21753	3NKKtiuZHBPBjHAiaAENqwyXHEWt2j3AuEohZQedemh1ejqGM4F5	21698	3NKDmQ5Hu3VeGidRep4a3Bkvzh1ddwBuWjGAtA1PoXR4ADp35Bjg	1607	1348	397	12463	13925	jwGdGzUcsxAE7kjA9tBKpLrwqYCSA7zgoKYWrEbXyDiHpXXiF5K	10870	15331	15331	1618698780000	orphaned
21759	3NKVDH4HoJcGGuCuNFAaDjd5nzcZnt7DbWHoG3JvrcMoCjxMqW89	21753	3NKKtiuZHBPBjHAiaAENqwyXHEWt2j3AuEohZQedemh1ejqGM4F5	1607	1348	398	12463	13931	jxMHP5mPFPtpP1nYeCeRr9emRezyyVcGSVz5H8ahJViqTh1p7La	10871	15334	15334	1618699320000	orphaned
21796	3NLnz4rwXmvY2YFdkuywjx5Xa87BGbK57fEg7AU3CfjL4UMHWsqF	21720	3NL2bKa7iWaVhW4PEfzjshjTJ81EqvL94AndWYJK6rSHMghuej9b	152	1330	397	12463	13966	jwcgvppirHKFzbE3LdWAhpf94iFzP8BHCpkUXhdS2NYsQJuLJvj	10882	15358	15358	1618703640000	orphaned
21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	21729	3NL2kNNPxFf74kvUjFuePZERZa41QXqSqMmk1RMMSXDbDpDp2eah	1599	1287	398	12463	13908	jxaGHm1hcRmDqEq41a8VPQSbgjpoB4g2JNiXs5uD4F2Fjak2atg	10886	15324	15324	1618697520000	canonical
21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1406	1393	398	12463	13911	jx6Cx7t49fQbVWK5SqPMY39vCAGKxWVVzpeHKA2dwZRJckiHfh1	10887	15326	15326	1618697880000	canonical
21740	3NLqN1axMZPPsBCxa3A1p97GmnS1Uw2WrhneMWShcXsqZ4apYcsn	21734	3NLpRnpqYXbCPWbmWQnKiSu6YBDbb99mWyuD4cCTs1RCi97JyMLM	1651	1301	398	12463	13913	jwP3bJoZJvYhEcVgZUuduAHjFBg4demt3XHGdqeMK2cwrs3x4Fk	10887	15326	15326	1618697880000	orphaned
21745	3NKwCQ47Wn1bwBix5BcU3tPNNFQpVPnAH24H9vTjHtYNUjqkB7ky	21738	3NKcoH2w6sUBpUSsCmZU1YTHaAjnXuQJUno1Gv2CQYy1z1gdgbhi	1579	1263	398	12463	13917	jxRjjnsBpUpRe29P6csdQ9yxkATuE5bT4EJNPkNgURLqtNM2ZVw	10888	15327	15327	1618698060000	canonical
21746	3NKjifoREmT1rxhGZUvgthxknswexzLpdNYRv3CPgeFTmko5XzXk	21745	3NKwCQ47Wn1bwBix5BcU3tPNNFQpVPnAH24H9vTjHtYNUjqkB7ky	1673	1242	398	12463	13918	jwhRrWZjkfAZetzQck7ivN8mHZYKvw1mzTDzjFwQchVnDQv8dpp	10889	15328	15328	1618698240000	canonical
21747	3NL7N2QS9udJjSg7yGUeHHvtQnvAxE9mPJRdZpdSDbhAmbu1nVsP	21746	3NKjifoREmT1rxhGZUvgthxknswexzLpdNYRv3CPgeFTmko5XzXk	1403	782	398	12463	13919	jxY5EWF3p42FuE8b3EwJfrJap1g6fC9jRwhLPiarSXVPV7qXgno	10890	15329	15329	1618698420000	canonical
21749	3NLehBrXwwMLLezdJ8wLMwDibPa6Fsf8TzkjUfDHBLV4od3UxU2A	21747	3NL7N2QS9udJjSg7yGUeHHvtQnvAxE9mPJRdZpdSDbhAmbu1nVsP	1534	1191	398	12463	13921	jwUz8DG8Xm621i3LBBXDgnvqpAFnbmFBT5NuTW2Cn9Fq66kExz8	10891	15330	15330	1618698600000	canonical
21751	3NLqZ8c1UUhTBQ7iw6uVgpRhT44mR8XrxQocUGJwpi8Qqm9q57kf	21749	3NLehBrXwwMLLezdJ8wLMwDibPa6Fsf8TzkjUfDHBLV4od3UxU2A	1607	1348	398	12463	13923	jwcYPYDnYeY9cwBpF5zAvMDFCVx2nhyU4yWJA7k8VpmB6dKot77	10892	15331	15331	1618698780000	canonical
21752	3NLr7aRX46mkajYizsotGpuxNEGW3BcKxLeJCTnjUZTYEA4cz8BX	21749	3NLehBrXwwMLLezdJ8wLMwDibPa6Fsf8TzkjUfDHBLV4od3UxU2A	43	1310	398	12463	13924	jxGFG68Ek7FT1znfyL1dMephGLodwZ6CZMs8i7qiZuLHFy4ZLUs	10892	15331	15331	1618698780000	orphaned
21755	3NK5cEY9RfuANFHkMqMaZZzKPqTKXGsTj2K6qE7j45yM1jcRR4gY	21751	3NLqZ8c1UUhTBQ7iw6uVgpRhT44mR8XrxQocUGJwpi8Qqm9q57kf	1407	1395	398	12463	13927	jwutn5iWcBwkvuyT4ScxZCwkmnzPfpzPAZ5wMDZFLN28RcTz2z5	10893	15332	15332	1618698960000	canonical
21757	3NKr6nbcDZBz1BUQvmxZKuLM5ekboytDG3933kQA1BzGmcEj3RXr	21755	3NK5cEY9RfuANFHkMqMaZZzKPqTKXGsTj2K6qE7j45yM1jcRR4gY	1458	1458	398	12463	13929	jxwdD6v1kT4vwNJKbrCmQFepCimoHHxpKYBo1kxUEbS838yEVjt	10894	15333	15333	1618699140000	canonical
21760	3NLVpJvSj7RA9t1ymeYkLoq5GvaqvR4ZxUtqkNvwbAuBwDwbcbXe	21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	1403	786	398	12463	13932	jwuFmdh5EzUMa3WuTTB7PNecGd2K8eZWMMa4QHy8oCWdu6VmpKP	10896	15335	15335	1618699500000	canonical
21762	3NLUtYomjKunZNdH893JzkYjv4u9kXqMRravArCX4f1ALRuwbQmw	21758	3NKZgx7XYwRDvJycuEvkEoVC5zHcijPDCr1Zakv17jNJp1nB2j4P	1631	794	398	12463	13934	jwuWXKfwEdXYF57iTcLC9PZRasvaX54Fdn6XzrfUx1wek4miUEF	10896	15335	15335	1618699500000	orphaned
21766	3NLBPraf8uZJfRn5jBmZuV45FzP9q9zvA4efPGbaxcYbXZDmfnwe	21763	3NLvU2YeGLSb5SBCuMaZ85pmsbxE6vjmxUZMnXPeTqd4wp1FnADw	1501	1360	398	12463	13938	jwBceEwFW4MGPHZRM45hkU9C9YPrSSj6UZgVxoGXRc3nhJ54NZK	10898	15337	15337	1618699860000	orphaned
21769	3NLWabJVYxN4zhBf7LmvtoD47PGWje8WNRXhPiEMNgmnUwKiTP2J	21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	1623	839	398	12463	13941	jxdVQcVzeV2GbJkdU61ySbfPgW7SJRpvtDZG13V9tvhucaSg6AM	10899	15339	15339	1618700220000	orphaned
21771	3NLLSZFxc733MXTqjGWFvF5u98xcCTPpoCJxt6ZfJ8sT6Qamn53z	21768	3NLX2fGhDCiqJNsFyAHmoTiCpXX1WUSWZyhb5BZrzKhTE8pXDNAk	1549	1236	398	12463	13943	jx8KQi4anpuke3M9cAMSohHf9ZPY67FaEDPsqzzCFTaCzcafmNe	10900	15340	15340	1618700400000	canonical
21777	3NLt5ShMLh6HE4JmDBem3DShXEwisFG2tE4gP5DR7ukwqD7vRwN4	21775	3NKqHYk8871HHorHArq9cPoVpKCBGLBrXmmCGHEVqnoQunPVAUVT	532	1303	398	12463	13949	jxiUpeSkKh7h3gZhu8KEcZGLtUy7xHJ6dL2DGDPJtHBLMKHJJah	10904	15347	15347	1618701660000	canonical
21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	21777	3NLt5ShMLh6HE4JmDBem3DShXEwisFG2tE4gP5DR7ukwqD7vRwN4	1590	1054	398	12463	13951	jxE1xxE3mZVsRWP1NTtUcGYZHw2MamAQW7jeGXGoFGWpA3cU62Y	10905	15348	15348	1618701840000	canonical
21780	3NK8zT4AHTv9eRDRxWdzhw9q3xBbLv1qWUW51hp6TSH1Tkosa3Wg	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	684	1352	398	12463	13952	jxNnZUc5KqPzqgUbBrDj5DLraQrXXuzP95LCSeSXsUnWnC6AJ1U	10906	15349	15349	1618702020000	orphaned
21783	3NLoCYSjFQUEGRsfhpYq3jhPkziU3XhbHKJzjkiALLwE8pR9NAs9	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	448	1179	398	12463	13955	jxTyd6of67Ybd9FwKsxk6ZR7oqAyKLDcukz6KCDfc3wkAQxVeS2	10906	15349	15349	1618702020000	orphaned
21786	3NL9BoV6sb6CHnVKMFHfvJLSb6fYc9w7nam2Q6aSzAceE8EYaNJK	21784	3NLxRcVx9xZu1ZTaQz5cmbJPtWW2jHGvSVRhwB9wKsEe4KSDu8Kq	1422	1337	398	12463	13957	jxWxTnC6PmAs5NiwzcfBHvaswFsmmaJ3ccyoXqz8xymWZ8JkBR7	10907	15350	15350	1618702200000	canonical
21789	3NK7CkFttBfxcQHTf633RWXUHBZHmLB9cSnbU8isCRb5w2FQED77	21787	3NKPd5nU2Wi7GrFFTpDpJMkpAaHnqNFVLYbBfmJQtsgWnDfAZ3at	1406	1393	399	12463	13959	jwWHBNxyPrYtFcrMK5YMFieLxFeH8QXE6kvvH1wpZPtzZt8ZJDg	10909	15354	15354	1618702920000	orphaned
21791	3NKdi2Bf4C18Bq54uVzZFVGfV2zTuJtujv39HUtGkHjgE4WCDZvR	21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	1406	1393	399	12463	13961	jxZ5ggHWEAi674d1aZvEiCS1Te2p19qrbR5pmjzkMYv2MwkF9xx	10910	15355	15355	1618703100000	orphaned
21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	21793	3NKHfF6Z48b3jeZRENMLy5FRV2qXGyNiySiSMJcivaD9W4LEBshz	1407	1395	399	12463	13964	jws96TsdHXgv461XgsDoJDMukAGZmjNqyKzvaa4sLgMd9TiRAxZ	10911	15357	15357	1618703460000	canonical
21804	3NLvad21wh3Qp9qhAxjCwBEg9aYekLgPpnbt47UuuefHFvLMf2XT	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1406	1393	399	12463	13974	jxTTeVKS7BtuoToaeskzfqCkwyxg2jCg7hxNYUhJpJYk1f3yety	10914	15362	15362	1618704360000	orphaned
27472	3NKhZr1mXmRihVsCTSKRzBkvdQ8TH7Ks87DuZ9jQFPdwLuo9PHmS	27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	1397	827	533	12463	18974	jxrCX6rBaSXxrj6R2sNTt3Td7mruKu9CQQSyGtg6wsat3XYpkus	13577	19113	19113	1619379540000	orphaned
21782	3NLvewNBQvrzQN3eBLv189cdf9D8L9Sk6Pzvp3MNVfBrVNHSsb11	21778	3NKn9v7DhYecREDN1DUyhrP2YcvQsUVQPmugHCj9uCKaPsN5FyRJ	1402	808	396	12463	13954	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10820	15349	15349	1618702020000	orphaned
21795	3NKjG5tURZnzmj8pV5jx4T1UggRk7pzSoxGBQ8CKiHXm5nMkVui7	21633	3NKG2aabLEfRooVhF74G9oHo2CRRhXLDD1fmtVCBdq47GbuTVuyW	152	1330	395	12463	13965	jxn6M2UTfcb19eqytpftFdS5zpBp4fawZ2Zvb9qfaxbjW74aknj	10839	15358	15358	1618703640000	orphaned
21763	3NLvU2YeGLSb5SBCuMaZ85pmsbxE6vjmxUZMnXPeTqd4wp1FnADw	21760	3NLVpJvSj7RA9t1ymeYkLoq5GvaqvR4ZxUtqkNvwbAuBwDwbcbXe	1637	816	398	12463	13935	jx9UyaMoHUh26zUiPumvM5dperijEbbwHG81cEWNLib7iLEz9Rx	10897	15336	15336	1618699680000	canonical
21768	3NLX2fGhDCiqJNsFyAHmoTiCpXX1WUSWZyhb5BZrzKhTE8pXDNAk	21765	3NKczr3JQwJhLwvyi3bgMHLdBR27QFyT4kbNNvHcdG3GXy3EWSfi	1634	313	398	12463	13940	jwufCkQG3owQyL1BG7EPknsTgwXVMfqo9dEnPyBWNWiKXXx2TGn	10899	15339	15339	1618700220000	canonical
21770	3NKRe7BTmM5kgXUemj8Zn2KCfYFeTdzgsqGnjJtqgdhHpbi7QTXP	21768	3NLX2fGhDCiqJNsFyAHmoTiCpXX1WUSWZyhb5BZrzKhTE8pXDNAk	1559	1107	398	12463	13942	jxQbZyq18pN22yGsK9mrUwDxRLoQ5HxW7HhCtjE3Gdd2BE8P2kk	10900	15340	15340	1618700400000	orphaned
21773	3NKbwwg7fYpNXxiAPqDjRZpHZJrtNmgDQ2cjgcpinfMPkZiZQfsi	21771	3NLLSZFxc733MXTqjGWFvF5u98xcCTPpoCJxt6ZfJ8sT6Qamn53z	1419	814	398	12463	13945	jwbxdFniCHSpVsNvZsXomHoRVxGKgP83LCexiJ6JbFcwZtHC2YA	10901	15341	15341	1618700580000	orphaned
21784	3NLxRcVx9xZu1ZTaQz5cmbJPtWW2jHGvSVRhwB9wKsEe4KSDu8Kq	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	171	1374	398	12463	13956	jxk8ezsXjudZ9t1it7FSDLRy5526989pSRDbxaLZKTA43eG34sg	10906	15349	15349	1618702020000	canonical
21785	3NKCkZ9xR81pzGFYma2U5tU84jsFjGumWXTtxm57poQwFnBPP9P5	21779	3NLiWDZax1yLYQdTwr6W7WuychaEx4KFpzF2g6KGeknBWz1YqJch	448	1179	398	12463	13955	jxTyd6of67Ybd9FwKsxk6ZR7oqAyKLDcukz6KCDfc3wkAQxVeS2	10906	15349	15349	1618702025436	orphaned
21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	21787	3NKPd5nU2Wi7GrFFTpDpJMkpAaHnqNFVLYbBfmJQtsgWnDfAZ3at	641	970	399	12463	13960	jwBpdLea4g3ELCMVVGE43v11FY7AMMTbPnmbfsZUvKtDJh89KFm	10909	15354	15354	1618702920000	canonical
21793	3NKHfF6Z48b3jeZRENMLy5FRV2qXGyNiySiSMJcivaD9W4LEBshz	21790	3NLTe9nUwDKcADVSqhjDvcGbjzF4ywyDkA9x8GcqraRAioGiScBZ	1623	839	399	12463	13963	jy2TSiUzpDtcM35Y9ijd1dKKwFh7HoMBdgyH63DWfXysjEbhoUW	10910	15355	15355	1618703100000	canonical
21798	3NL2bc8hk1jRxSAwqF91yKPWUjcKrW6GFrAX19v19cV9P2nkt3hw	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	1407	1395	399	12463	13968	jxfM7cV1xXo6o2iV4DBUjCAUZfceZtEvvQRaDGhjJa8ZDJpzfwW	10912	15359	15359	1618703820000	canonical
21799	3NKtJQzZFe83Nbini3eor4h6J6WSVinSDRpSs5tqbNMayL6g132Q	21794	3NL5H1EdhqJhXYXsHuENTCQMFT4pnwAQwSuZ6zxJTspBZsbroimj	311	1307	399	12463	13969	jwYdVBFNTYvJbaA2NyYKxCEzeCD8cJX58npVykv3PYQvVaGwZ4q	10912	15359	15359	1618703820000	orphaned
21805	3NLuFTcXLDhuViaaZtEF4RBeJitrjyC3WmJBQRvGGx5KxnhwGcr5	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1560	1291	399	12463	13975	jwtjPzBmGHM1yQjKm7PMaVmXuhWCkZ91NRmcwgZ8GuHk2g3uwEG	10914	15362	15362	1618704360000	canonical
21803	3NLZzcvDJtvnQhjY97uMffY9wKvk18bB6J6JhJmGBwV1jUfGtat4	21801	3NK8Zz2ey4Eva7SJkamXooV9X6fJo2a7Da6iihemHEsB1wAKV4UA	1403	824	399	12463	13973	jx2EshKQD9hogVZmCFeDmszTTbfMSdirjd1KYJcNZshi1coJTWi	10914	15362	15362	1618704360000	orphaned
21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	21807	3NKPcBZJVyPs9kfq9PV2G39sSGuVremZpNtaVJg5DBLzXApksch5	632	1382	399	12463	13979	jwgNKV5AcpAbTGAwptioA6BCMy5KP9z9cLRAMd6MBcvbrHvH41B	10916	15365	15365	1618704900000	canonical
21811	3NKQwA8dvbFVuFGNYrG5ynuzkUfYehJF9fco5YFRdxzUg2mYsBte	21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	497	657	399	12463	13981	jwABkrCZqNZv8wxGEhTxMQJ5AVq1Gim4AZsd8YN8j7dTckSe7f6	10917	15366	15366	1618705083816	orphaned
21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	21812	3NKKg5nEikD4cpw8Rxw78FNTbje28MrJCB8L8gR1dPc2BXNa1Svn	1593	1100	399	12463	13983	jxPh8eUN67ERjFCsyoq7HedsCpy2XNrpK72AedV1yAwbUQHE3FA	10918	15368	15368	1618705440000	canonical
21813	3NK7QATzMsLE4AvkGX11BHktrfppynfQjTZ9Dmwxi2wcsHjiZWob	21812	3NKKg5nEikD4cpw8Rxw78FNTbje28MrJCB8L8gR1dPc2BXNa1Svn	1407	1395	399	12463	13982	jwCK14F6zkX8sfN4JQVj33XcGVoyqSueo9miAfhUinKdvnyob3u	10918	15368	15368	1618705440000	orphaned
21816	3NLtJ16ZdWaTpwihGbytwjp5fYpXW4kAvU9BtjgmjTjm72fxRcL3	21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	1406	1393	399	12463	13985	jwa7L9rEXdpiEZP8h32nqpqCamYaVVyDLGDUHFqAYPjsZewmknu	10919	15370	15370	1618705800000	canonical
21819	3NKn6Xao6vMkQk6exNzgec9eRoNLRdBDRKYTiCEaWcCcs1n1NNGu	21818	3NKBPDyGfFpkEp6iag9ePxzF4knAoh75vP7sXTNFvP9sdSd1JYKA	1405	851	399	12463	13988	jwUcyykTSxBefYdJEwPpfHkVb5EdLWCZJQC11qLipoKbTDJAXbr	10921	15374	15374	1618706520000	orphaned
21822	3NL3vRyez7RZoSGuT8BMmh1E6erK4ETvG76GZsPLTQC7e1FmdK14	21820	3NLtwWErFXTG6pigXs5nRx6N4zoZQEE2QKaLiNDaMHLuCiqP5Dai	369	946	399	12463	13991	jwEVz9aRYAyV3V7RUBXod6nEiKXFMBjhFnAaJxDHgmrLPXXGCmT	10922	15378	15378	1618707240000	canonical
21825	3NL6q7uAtsRuQ4vJHzZBSdoAqNRpYRACQPmgQnfLDthw5T79uzbQ	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1529	1070	400	12463	13994	jwvcgg1WH91v7mtpmo7cGHMryWkJoZYASHPDuVtSedCTaWro5zC	10924	15382	15382	1618707960000	canonical
21833	3NLnMSP52roRt6rDYcaYsU8Ndbe954xm2uF9bp3i6CjL8rbWujoM	21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	1407	1395	400	12463	14001	jwBsfBBeHmrSus3vNsdbn5cM2Dtuj2ZfF1wFHFnQY7pnV3EHrNS	10927	15388	15388	1618709040000	canonical
21835	3NKK7GMttSVrmfN1CLWPqPde2STSEEuRWWWCfVB77cV5jX1C2LYv	21833	3NLnMSP52roRt6rDYcaYsU8Ndbe954xm2uF9bp3i6CjL8rbWujoM	1483	390	400	12463	14003	jxVfCGDsVy3qtr5KJzUQJLpD1Derfw6QZ9qXgPxQ9rzyz1Y2ywg	10928	15390	15390	1618709400000	canonical
21841	3NKgrWy4v7xoYDW2jfgNc5Rg6PHxGLnqDyq7WFqeuRX399gmhfwS	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1448	449	400	12463	14009	jx9K8z8hQFpXZqUUi6ECE8h28woBTcBucJAdapT3nk213a3rrTF	10931	15393	15393	1618709940000	orphaned
21845	3NL94fWjHC7vQAeDcfZ2qUyX2HeZpjQFyZr7DvBPKiNb1MRme2vW	21843	3NK8f7mcP1DjvNgj9viJ3QdAWdcD48keKuaVtzjJCNfDaA8BAL2D	1555	1101	400	12463	14012	jwcvwPxtB4yKBUKnm8B93dzDQuSUZAHaZMdpFk2teHhUiwJsons	10933	15396	15396	1618710480000	orphaned
21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	1631	794	400	12463	14016	jwWz7GvFRKDq6vtXRgBwrN8C7KiVfjCNqb3v4Dj1z1UUEixZnjs	10934	15399	15399	1618711020000	canonical
21847	3NLH13CbfPsn4DnLhGGNZPEPzyWFHLvUJ5VZNYiLhZrN3uQFsGLU	21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	1403	824	400	12463	14014	jwXhTriZzen77CH4TdUbwS4QRfLb78m6MiVmNXh5X1LxDBu5XsP	10934	15399	15399	1618711020000	orphaned
21861	3NL5M8kDbWN1NQ4LK6hwovcvujt6KyqXyc5KikX1goGfBXbTeYqi	21860	3NKMsWWoVpLGauc95CMsxTkV3vuoFR2BH4yjX6kWqpNc51XEVrhz	633	1384	400	12463	14027	jxV3w39FcuwbQ1bJZUsjccWC5n1Dt7VqY8Pgvwexag2nUhkodGj	10940	15407	15407	1618712460000	canonical
27496	3NLyXSNzpcPuzxjht2PY72XAibrWgYajdxdg9E2g2V8zX2zb9W3H	27495	3NL4Drtse78doQK5NdNmeiZ5UpEWh9Hiq85bSCJdnzdy2RJbQLGu	152	1330	535	12463	18974	jwLv1Q2QtYfMFEV8SJfoZYFTWrcm9qMdJzNpjPHDdLcWy4TEK5c	13592	19136	19136	1619383680000	orphaned
29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	29195	3NL96aJSJQBPdbUzLTNY6x2jsgb4XTszCerLZr5DSRTexURK1ELr	1457	1145	572	12463	18974	jw9TcfQ79dYGCxSCq9g8tRCUc58FECd8chjih1roede91x228Zg	14393	20269	20269	1619587620000	canonical
21836	3NLLYp7he2TiTYUeTRdnKqj6fdbkhiy6EZK4P87BdmwFMMYbo5in	21695	3NLxfDm6TsHAmVJE3HPk9txy67vCgijuA1vMLZRDtv1rabXFnwkT	1476	1245	397	12463	14004	jwKw5tjaBYPEXpqvHvhxn3fCCjcQWGGgX8mSLMSUX2jqjSVGz2G	10868	15391	15391	1618709580000	orphaned
21807	3NKPcBZJVyPs9kfq9PV2G39sSGuVremZpNtaVJg5DBLzXApksch5	21805	3NLuFTcXLDhuViaaZtEF4RBeJitrjyC3WmJBQRvGGx5KxnhwGcr5	1623	830	399	12463	13977	jwH4RJdEgBoVLECwSKYmDpwG1dz2CF55i4CBStyREsKnxsh23Ke	10915	15364	15364	1618704720000	canonical
21817	3NLZZGudAJAv8dnhPwPSq2VXx87BLgcezK5bTwYhWSkrvGM4k9eh	21814	3NLvLAwQQmDrt8izGAV3SBS1ftvofze7aNe9tjDqhvJTub2M9Ru4	1589	1040	399	12463	13986	jxd8GMzh8HK177a2eByPDJgeCBJUtYuUB6UMU8XB3jsAjQst1Sh	10919	15370	15370	1618705800000	orphaned
21818	3NKBPDyGfFpkEp6iag9ePxzF4knAoh75vP7sXTNFvP9sdSd1JYKA	21816	3NLtJ16ZdWaTpwihGbytwjp5fYpXW4kAvU9BtjgmjTjm72fxRcL3	1609	1333	399	12463	13987	jy2VkUrVCEkKtiaw397zqb25JJBEYmr4EFmsjfWCJoCJjt4Tewb	10920	15372	15372	1618706160000	canonical
21823	3NL4uXEJzZdSByuFEWqwpazjCa4erswTVC2UUhQGgk14WEVHwx6B	21820	3NLtwWErFXTG6pigXs5nRx6N4zoZQEE2QKaLiNDaMHLuCiqP5Dai	1407	1395	399	12463	13992	jwzCwehWLKm31hUNb9u9MQM1kwQM7NSbsVMSnqEe4tMCKvE8SUZ	10922	15378	15378	1618707240000	orphaned
21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	21822	3NL3vRyez7RZoSGuT8BMmh1E6erK4ETvG76GZsPLTQC7e1FmdK14	1503	1277	399	12463	13993	jxzaFDu6WUVfQmLS4VGM9PHd4kGKc9SoUJ5QXxLQjRRjyJpkc7q	10923	15380	15380	1618707600000	canonical
21826	3NKArhZ6uiAXEkYWRk9tNmt6RmUMCq9RBmEuB4h2Tw2GPhndGZ19	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1541	1298	400	12463	13995	jxeqRv4r6sQvBteJ4rYqXf3hpp1ugp7b9iRpwwZqxdQqJ1noFcD	10924	15382	15382	1618707960000	orphaned
21828	3NL8x85YyazBiwhE83zBrYNg9FqgReNsZfe8qzL5tP2tvywkpihG	21825	3NL6q7uAtsRuQ4vJHzZBSdoAqNRpYRACQPmgQnfLDthw5T79uzbQ	1637	815	400	12463	13996	jximf6KqTyQEBqGrpvGgbQvPHRX4yFLzs3wcCK9pSYgsx22axf5	10925	15384	15384	1618708320000	orphaned
21832	3NLDy43oe5zwoHJVpUR9X5cGvDA3emh8zwoPnbaH455RcuERwxUW	21831	3NKGD2t4A4y43pbeY1ttEr5zTfnMSFVxpezbAVC1ptrcWZpAci2z	596	940	400	12463	14000	jy1g11eMEr118zocTWBbNYJUVCMm39siViHH1baM5a5rkdCdH6n	10927	15388	15388	1618709040000	orphaned
21837	3NKhwTWSS5TFARFmntMK27r7HuUbFWP5jVi3LozyBAiHjWMEtfNt	21835	3NKK7GMttSVrmfN1CLWPqPde2STSEEuRWWWCfVB77cV5jX1C2LYv	1476	1245	400	12463	14005	jwBGdKy98w8wubfPNLG2Zo4DRnE7qEDhADJrAb852VXQMqhDYsK	10929	15391	15391	1618709580000	canonical
21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	21837	3NKhwTWSS5TFARFmntMK27r7HuUbFWP5jVi3LozyBAiHjWMEtfNt	1594	1200	400	12463	14006	jwdrxrq5NYzgrM22uK74hgS3RC7Yg9csJGfwjsY9HWx4rLuSnvP	10930	15392	15392	1618709760000	canonical
21840	3NLEGaehaEEEcUeYCZgyCXwpKZHfPTM7oL2cyJscZg9hNbKsUX2W	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1637	815	400	12463	14008	jw8GkaNrU7enpGvHUrDkz9mS2FgefGJYbXmY8Hnk8gB68YJJasq	10931	15393	15393	1618709940000	canonical
21842	3NLR28ooFTceju3PtQVYgZTE5SKNTwKLbo6oBZip8HADxbDHzEis	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1448	449	400	12463	14009	jwX6NTxXECyGJJKyg7rLN7N2BkKtxqgD8cfbS9zo4rSJaJ2soAe	10931	15393	15393	1618709943959	orphaned
21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	21843	3NK8f7mcP1DjvNgj9viJ3QdAWdcD48keKuaVtzjJCNfDaA8BAL2D	1419	814	400	12463	14011	jwxBjhg327gsytSm12MtjyYMMQU5U2MjuG3ttn5AGBvfZZ4W2Yw	10933	15396	15396	1618710480000	canonical
21851	3NKmVdycXPm99Q5rXd8uinr2LJLnRYcio47yXuxvBXGTt9UW1JpP	21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	1501	148	400	12463	14018	jwBCUKq2C9WVQna8FXZomFb78CmFmxBFzE3AoNTgkzGpvCibbuE	10935	15400	15400	1618711200000	canonical
21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	21851	3NKmVdycXPm99Q5rXd8uinr2LJLnRYcio47yXuxvBXGTt9UW1JpP	1578	930	400	12463	14019	jwyiBvrpFHxAhZQf5gLU9KFjigJ7mPEotQwukhFBsrYkmcameCt	10936	15401	15401	1618711380000	canonical
21854	3NLDEWmfYVE8bL4c89UnukWpZrqZUTdLmcKYPPigTRp8Hp9FaJow	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1668	1004	400	12463	14021	jwQUH1oCm4nwTkm9qVoLpPvwYgRjr1Vxc5capL6idZMkHnpKJ7z	10937	15404	15404	1618711920000	orphaned
21855	3NKUVL5Zx12jANU3CVHhnUM7bcM2C5BSC64jEb7sCLUUS2R6pqov	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1541	1298	400	12463	14022	jwuiSmoLvbPgVCtHbUPc3zybC2RzHHVjNB1nkazo5ypZCjFHbnD	10937	15404	15404	1618711920000	orphaned
21859	3NLvUsEcyBYmiRZsJNhoF99RDGt8urmBGBcLkxMn1z37koNeHEaP	21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	1611	1341	400	12463	14025	jwoRFXFtLz1VWL3J9gwRA8u1YQVigzAx1NYKYDC7pSqf8ssVJdU	10938	15405	15405	1618712100000	canonical
21857	3NLud3PunJtvkUpi298Gq4erGNYEif2czce2vRHSSsx1higfitdR	21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	1406	1393	400	12463	14023	jxS7J7urkC3yHa4rBB5TKSSFpzuXDjtC3rziDnyXTVLiXQ5iVPi	10938	15405	15405	1618712100000	orphaned
21860	3NKMsWWoVpLGauc95CMsxTkV3vuoFR2BH4yjX6kWqpNc51XEVrhz	21859	3NLvUsEcyBYmiRZsJNhoF99RDGt8urmBGBcLkxMn1z37koNeHEaP	1650	1009	400	12463	14026	jxF7sTxEXWdudzoLcSsizTjEN9VPaBXB2Trzv8AK45jRamckdHA	10939	15406	15406	1618712280000	canonical
21875	3NKBg13KTBjdFTbKj697E8hqj91XKUNbYiURKXdTrXRWpgqQiBiM	21860	3NKMsWWoVpLGauc95CMsxTkV3vuoFR2BH4yjX6kWqpNc51XEVrhz	1577	1327	400	12463	14037	jxzxoaAEWfmyxyasgYbRzR2DEbgSUoBEhbLXGCHRVcxpDEbXyj6	10940	15412	15412	1618713360000	orphaned
21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	21862	3NKMMu4tMqKRFSFWAGF4pXatfUHCF1SGoRdJ6YpKPViPXEjnx5Up	1483	373	400	12463	14029	jw77oBSMJUJwMkR4qYb17Tv2G7TdpsycZrEFP4qAuqmakUvtabc	10942	15409	15409	1618712820000	canonical
21865	3NKsWTGLP8jnXrnaksmcyLyvPEzxcw4nZodbegveAZtEWwV7uuvy	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1477	1350	400	12463	14031	jwLwLjuRNPEude3pVNGrmAEs6bfDuDuKQ4xP4RNpYvaZXuJSHTh	10943	15410	15410	1618713000000	orphaned
21868	3NLkUa9ir2c5gsRqAA3QvBXDXkwBks7fSQ7cSb1S3N9mxi3ytiTe	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1460	1324	400	12463	14030	jx6Brd5c6wDKVuG7Emrak1na16V3Xb8WzBsK4154URYUXq9aEop	10943	15410	15410	1618713000000	orphaned
21873	3NKRdugrAfPpXZzkein9bL2rhXSJT4QGDPdVoq1D72MmMmr4BCNH	21869	3NKMouMjPMetQk82EnVyAVsDosFrZmdwqyuV5NBYH4jFdr3uzF9C	1471	1386	400	12463	14036	jxVYBtxaUyJ89jLPJ5u3iVSeCHAmBDBcgBUJXAa8UBnxoKiyfDL	10945	15412	15412	1618713360000	canonical
21883	3NLUufKLCV2oLUAd9PNUvKhhEEZG3jt4jCib6gWdsc3Jw77WQuMd	21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	1407	1395	401	12463	14044	jwznM3jKfrqDLQsSwu22NnZJEeBj6wJjVYaBMtFVZ7UyMeZo3Ma	10950	15419	15419	1618714620000	orphaned
21885	3NKA58GVcavJR6DkThwuJ1qNUfje9vcKcGTmKDybivusYHnAzrxx	21884	3NKQdYQvuJVqfK98QuDnDNhtifAuf8B148GZBGk9c9bRutzE8fan	1608	1289	401	12463	14046	jwp6zZgS9EMSsvgqd4K8iaPzVWxNCA5BZrf2Y5LYDxybF6ECGHi	10951	15420	15420	1618714800000	canonical
27512	3NLeCUFdYb9vd4uDf215d8WFaABNmwPcMF3vWg7cT9GpCc8BrHkK	27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	1578	1050	535	12463	18974	jwvm1hQcMHnWbVZHnRAoxrA9owZzk3ZF61nqEhzMBrctrZNcpsJ	13601	19153	19153	1619386740000	orphaned
21890	3NKvibaZJLmxFLXcbVtwBHR7dapDF6emor69C6WzBAbU5fPdEc8e	21881	3NL3pcQnt8Wu87t15eDffTfqbftKxpy7amNny1P9UkbTjSzQWGtj	1581	777	388	12463	14051	jxqxkmh74dbv91yFiW1DTJvLNkUCJ91VmgFF8FdFbQL4hkqSfqB	10713	15423	15423	1618715340000	orphaned
21871	3NKQZe38RcnYze4BbV2QJ6DDJ5dNPpY5yXEZLYTVSX2BtYiGhQ8Y	21870	3NKFyaLZCaVsLEGfziTw8FBN69vF5Tmanx8UuRpbH1sAD1B5Lbug	1634	313	394	12463	14034	jwgnwXxrrMYgn3L5JLPq9TQrkn9iMqSc42wj8vQwsdQBmuSjb69	10800	15339	15339	1618700220000	orphaned
21815	3NLuHQo2rzAZRBZbJAtZuB9BZ7JaZRRffKX2hYJWPtJnBmFPRqdP	21782	3NLvewNBQvrzQN3eBLv189cdf9D8L9Sk6Pzvp3MNVfBrVNHSsb11	1402	868	396	12463	13984	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10821	15369	15369	1618705620000	orphaned
21922	3NKvs2Hy5NGFpjKK9d15mY6sM3bvANMeuLzcyEAjiLtkeczxG2pK	21815	3NLuHQo2rzAZRBZbJAtZuB9BZ7JaZRRffKX2hYJWPtJnBmFPRqdP	1402	852	396	12463	14078	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10822	15443	15443	1618718940000	orphaned
21935	3NLfjteRX3qTL6CtXYMj2KjyJ7y5D5FRGBkCopQngwsjHPcpAj7R	21922	3NKvs2Hy5NGFpjKK9d15mY6sM3bvANMeuLzcyEAjiLtkeczxG2pK	1402	882	396	12463	14089	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10823	15455	15455	1618721100000	orphaned
21812	3NKKg5nEikD4cpw8Rxw78FNTbje28MrJCB8L8gR1dPc2BXNa1Svn	21809	3NLYyat5Nr88iL6qZSxUX4eA2zbhBubW8JcuewwFZD2PmCjUQy8u	497	657	399	12463	13981	jwABkrCZqNZv8wxGEhTxMQJ5AVq1Gim4AZsd8YN8j7dTckSe7f6	10917	15366	15366	1618705080000	canonical
21820	3NLtwWErFXTG6pigXs5nRx6N4zoZQEE2QKaLiNDaMHLuCiqP5Dai	21818	3NKBPDyGfFpkEp6iag9ePxzF4knAoh75vP7sXTNFvP9sdSd1JYKA	1652	1189	399	12463	13989	jwneQM1yYmRjgu56vAmW8vEzmZdns188E3r5qES26jQp4LXujym	10921	15374	15374	1618706520000	canonical
21827	3NLMTy1ZayKQchizLTdvZy7XjJdULvT47MtNu8CGFUayBFgzyHdy	21824	3NLU3Y7EFyjwUAQT8muXBEFgE5SZzKT3xHSZ3pQCHR5wmrnTBiW1	1541	1298	400	12463	13995	jwij566i4T5F2mifAxToiC4S3eXx95X2NjQdo6fQPwKARCiGYmZ	10924	15382	15382	1618707960000	orphaned
21839	3NLZzxoN4DDfEzb28Rw2r65fRfLk8aHB7H16ioBu6P8NA1zYwAYn	21838	3NLWV3YtbCnMM6mUBGtKyZCSDJMmte3fNB6nykvKjo86QURXqVw6	1407	1395	400	12463	14007	jwdgG6WDfSApzSVemS6Gyiatc2oTWAUhx7s1PoRypyQXEcT9dfz	10931	15393	15393	1618709940000	orphaned
21843	3NK8f7mcP1DjvNgj9viJ3QdAWdcD48keKuaVtzjJCNfDaA8BAL2D	21840	3NLEGaehaEEEcUeYCZgyCXwpKZHfPTM7oL2cyJscZg9hNbKsUX2W	1508	1141	400	12463	14010	jxiFjxUgmfu6sCktsYHZpmY8Az3i1jg7QpHntUDWgBKuWSZHFt7	10932	15394	15394	1618710120000	canonical
21848	3NKdCyTqw214AeKypi2f4QcRXAxh2E3b68BPvtGzpFSD73akbHXK	21844	3NKxv2A9oAwb6UbBVUH6qPXFtEgu36ACEjSYDkXX9A7CisfTFx8X	1447	1345	400	12463	14015	jwokSYnygt9RVy626zXaNQzEAMpg4BmJKmVoD6EcQNPCNRxg8n3	10934	15399	15399	1618711020000	orphaned
21850	3NLUHjbX4Bs4R7XfCwXcp5hjtWAHwsT12WokCYKJ1RHVKGQXaNvG	21849	3NK5FmycdFRPMPXtaUvdze6UCaMRwo6TEeqB1YnpGejHkvYd9K9D	1578	930	400	12463	14017	jxdsN5dEjxsiYtRYTtEE8wuiE6Had1Knm9M12VjG2NDsiyqQ4u5	10935	15400	15400	1618711200000	orphaned
21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1406	1393	400	12463	14020	jwsBRnBCBwQxtFzaTve5CCmqM5Dt2JrGz8r3MDdU6xxPsVi9vQ4	10937	15404	15404	1618711920000	canonical
21856	3NKX8Ncgqb9pR3m7sBvWaXFSshGsMo6ZRvDbJg3ro15LLJqyy64R	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1541	1298	400	12463	14022	jxwtCQpVKabfcFTuPKHLhKiUtcNAFxuXWnY8ojpgFgn3rqcAXCS	10937	15404	15404	1618711920000	orphaned
21858	3NLdivPKsD8BsKePszYJPN62A7Lpze9cFWH8WbAmr1kkU6CZ7gLB	21853	3NLxvjp4kSirQdF3YY9VNgWveXKjXH1NEE39iEmgpLSDdbUTFKwa	171	1374	400	12463	14024	jwniZYMz5W2RarJ72F3ZZFfWsX9opJgoHiJvP82pQgQoUX44huZ	10938	15405	15405	1618712100000	orphaned
21862	3NKMMu4tMqKRFSFWAGF4pXatfUHCF1SGoRdJ6YpKPViPXEjnx5Up	21861	3NL5M8kDbWN1NQ4LK6hwovcvujt6KyqXyc5KikX1goGfBXbTeYqi	1675	1096	400	12463	14028	jxAbcbgttAg4Gt2W1B5H3vkhn7rtoDfQ9HmBGpW6itrGcfS1WS4	10941	15408	15408	1618712640000	canonical
21867	3NKaJbairQbngo4j7CBLr1TaG7rvbFcHWHDnSkCjeL7Tr4KwmAiJ	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1460	1324	400	12463	14030	jx6Brd5c6wDKVuG7Emrak1na16V3Xb8WzBsK4154URYUXq9aEop	10943	15410	15410	1618713000000	orphaned
21879	3NL1GJszHpjDGf1FGNFUDmKQf5zyz3D29AGq66XEyJ5qkuKVs9Dy	21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	1541	1298	401	12463	14041	jwvVN1kn7qv1LczjU28d1ByjzS4bqz1NqEWHhZryLbg4MbfC9BM	10948	15416	15416	1618714080000	canonical
21891	3NLs8EB7bWeMKiPJ9Q84BkNeSc7P7YpUdTrGds421yWNLg2J4aKX	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1671	1365	401	12463	14052	jx17dX7RmyUt73pyjyrTRiqVhurskMKEKSByeTBUE5zbUwkWCiZ	10955	15424	15424	1618715520000	canonical
21894	3NK9Jon1cnJAYNwdrG6GFUBFY6HDtnuBUMfnNqMovs3dL5qB8BCD	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1637	816	401	12463	14054	jxM4jvc29u4SkdP3YkX1NvfQQ72WSMUj6bWTonxm6dxfzS4Vx6Y	10955	15424	15424	1618715520000	orphaned
21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	21897	3NLg2XVdye8odFeY1W7JDs6E4sFsEUnnjP3oR5efTzRawcKceRBw	1457	1391	401	12463	14058	jwFrgskUPV4v5Kei5k1nYR7woSo2M6hQFuDPYQpTGHcvppfcRjW	10958	15428	15428	1618716240000	canonical
21920	3NKTZrGjrWmZks5XV4th7jhBKS6gNAakxdTNrmijmBwsN1yyivrQ	21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	1403	824	402	12463	14077	jxqbBkvHGenQoTbDrPpFhENQe23qb4vZuGcxLXbLZ9WJZgWBxQN	10969	15442	15442	1618718760000	canonical
21926	3NLTLzCEZarcfBcbRb9yjyjjg1wkiK8YDp22hRGNXGZf31EHcbMr	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1447	1099	402	12463	14082	jxfbau4F7QpNvxkm2uLPx64TAn1X86VwnSP2PoxpqBax1j62TKu	10972	15451	15451	1618720380000	orphaned
21930	3NLV1nVJ2CKLPRUmmEnj1B5xSYpcT5UgrDJVnSWnSctSqGiHPViK	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1651	1055	402	12463	14084	jwVuuEWvwWRSgoYxZVDQXBgcbFinXyMcFFskCgq49f35phxp1Ap	10972	15451	15451	1618720380000	orphaned
21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	1637	816	402	12463	14087	jxG29TYaYbswRzUAfv1GJCS9MBrHJdtuHi4TwHGbt7UscDDi7Hj	10974	15454	15454	1618720920000	canonical
21938	3NKZwxG2dmbHdbMMjrvtEcDR1R7V3iaVbw14XWoCSwExDsLL5iQM	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1448	1311	402	12463	14090	jxq6NPcrFfA6U3uzuH6LBZSR6p3t4hD37UdeE2LpsnGDMtznzpf	10975	15455	15455	1618721100000	orphaned
21939	3NKL5Fc1fY2bXz126NgmD8gdUwjoPUJnscQT4PaetYnFHCTe21dq	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1651	1175	402	12463	14092	jxn3t894Z6wejzc6fvGR3bLwR9uYRjUpgzsp2YDccs1o7TuDmxG	10975	15455	15455	1618721100000	orphaned
21941	3NL1rpB1pTo1rcQCdLjoFah9HwFB7xATRTnjDiB2NbatB7wp6Ew4	21940	3NLQ1cBg3wd2LiwWyyKsq876uM94CWNbV6QENTUDDmFB6G5m4nmV	1407	1395	402	12463	14093	jwZXeXsStD5iW3THjAD4WYWnUm9Huc7BcexhYsm8t7XzxsXKVVx	10976	15456	15456	1618721280000	canonical
21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	21943	3NLdgNmKJveEUecip41RG1Wxh3NsGLRcoc9jYkBhFRCaoiNtipg9	1631	794	402	12463	14096	jwxf3ouezzWHsFuy9JFxwDzwXoTGi532Z6Umzqgrojb1mCMG2cg	10978	15459	15459	1618721820000	canonical
27526	3NKqAj5oeDXToD98tkxdKN9E6JseSwD4f8TxVJPtnQQUaZzBusd9	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	1407	1395	536	12463	18974	jxAxSqzop3XZjjEmdbgGF4jftezfTZxSDFrGtEhoQrjw2qtbECe	13609	19164	19164	1619388720000	orphaned
21870	3NKFyaLZCaVsLEGfziTw8FBN69vF5Tmanx8UuRpbH1sAD1B5Lbug	21525	3NL2sAmLtaT28mjUr8yQzwFyMD38h8x11u2v7wU1PWy53DHAKxHw	1634	1331	393	12463	14033	jwTw2ZYRHey53iER61f6QreYQJc2EFYDcJsT3Uhx2HK8sDrsHV5	10799	15291	15291	1618691580000	orphaned
21872	3NL6v43YrYUNiNkRwZB7Qwc3rzyndcEWWQJeCHTUxhbksMdSpLjg	21871	3NKQZe38RcnYze4BbV2QJ6DDJ5dNPpY5yXEZLYTVSX2BtYiGhQ8Y	1634	965	394	12463	14035	jxj7ZePMbs57PgYWV7e729ByNERaQzvtAdLjKX18pY29wt1vr9n	10801	15411	15411	1618713180000	orphaned
21905	3NLLUpLdaHd4r92KNswm2MuV5QLznQzcAKsCq1oqwKJMXqQhSouo	21792	3NKiG9ftRZZrRPmVhAGqQKE7YrTxkMdfpsM1E9dcrw9kyU13bszG	1617	1288	398	12463	14064	jwgKPu49TTh3wcnsPUce3SzTiN5jeRu5Vyi5igHkDuc4Ymbb998	10896	15430	15430	1618716600000	orphaned
21866	3NKcX8yb8au3MmvC3QjczmcwHyhYSe32YgBtpxYmmrWKPkSin1gs	21863	3NLdqXYbLNGssnxUvkpoULBPk3WuTTwu5wjU7oM5Y8SxxFAtDGRm	1477	1350	400	12463	14031	jx2PvWKv2wXqgSxTcyB1HkoDPWguUVZcNGBFE5Siga3p9S3Fp1A	10943	15410	15410	1618713000000	canonical
21869	3NKMouMjPMetQk82EnVyAVsDosFrZmdwqyuV5NBYH4jFdr3uzF9C	21866	3NKcX8yb8au3MmvC3QjczmcwHyhYSe32YgBtpxYmmrWKPkSin1gs	1634	965	400	12463	14032	jwXYewRpjfh1oQJxCvwEFyNAaessWzvxVo2636KuDvAYoHCPGS9	10944	15411	15411	1618713180000	canonical
21874	3NLH4d7jrU7Te8zUdPVs8J12vxCJQA24SJZc88KwAZa1cVDA1it5	21869	3NKMouMjPMetQk82EnVyAVsDosFrZmdwqyuV5NBYH4jFdr3uzF9C	1471	1386	401	12463	14036	jxVYBtxaUyJ89jLPJ5u3iVSeCHAmBDBcgBUJXAa8UBnxoKiyfDL	10945	15412	15412	1618713360000	orphaned
21876	3NKLWfmA4jQ8WUoepNNrdy3fqc7arerRg15XZqFHhc1XmUJ4fipv	21873	3NKRdugrAfPpXZzkein9bL2rhXSJT4QGDPdVoq1D72MmMmr4BCNH	1406	1393	401	12463	14038	jy1bNRSZApooDLn96CrCvNi7Cu5EAmjVqV4d2X6sp9kqJs8K8vZ	10946	15413	15413	1618713540000	canonical
21877	3NLoyCrR2JPa28Zxh8DCE8Xn2sapaqNyApUPEZzrGiCSJyhAy7Dd	21873	3NKRdugrAfPpXZzkein9bL2rhXSJT4QGDPdVoq1D72MmMmr4BCNH	1666	85	401	12463	14039	jwwo3NTeia8f8PGbBZABuEGdZXpEdnTFRNpyKyEbCT9stSWXVDt	10946	15413	15413	1618713540000	orphaned
21880	3NKQmPkj7DZuAoRZK7Kgw1LntupMJ81aKgwYvhpU8Jo54QTqfaJu	21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	1541	1298	401	12463	14041	jw9TPZPAYLaEGYMezBhkSXgURtDwGWbcnki3nyjVbayBKQdg4N8	10948	15416	15416	1618714080000	orphaned
21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	21879	3NL1GJszHpjDGf1FGNFUDmKQf5zyz3D29AGq66XEyJ5qkuKVs9Dy	1549	1362	401	12463	14043	jwGhwquudKAqjepEWRPie6tZLwp59Aa6Koz6922X259SytSd6W4	10949	15418	15418	1618714440000	canonical
21884	3NKQdYQvuJVqfK98QuDnDNhtifAuf8B148GZBGk9c9bRutzE8fan	21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	1637	816	401	12463	14045	jwFicnRkLy1x7TXfkMyHMGZmNtrbUt5oE5ig4PJqw6PR9rrzGct	10950	15419	15419	1618714620000	canonical
21886	3NKi57a9Ms6MEa2qfC4pKXJEGbTP75Cm466JSNeVy7UGFT3BRWEm	21885	3NKA58GVcavJR6DkThwuJ1qNUfje9vcKcGTmKDybivusYHnAzrxx	563	1233	401	12463	14047	jwHbz4rAipcbtNumcTbdr9mBA6cH3utDjcoaDe9yrCM4J61pNcT	10952	15421	15421	1618714980000	canonical
21887	3NLMr61xHkCH9fUmCntKYaxEwT5VyPvHK8EzJg7t62xQvahEDYeM	21886	3NKi57a9Ms6MEa2qfC4pKXJEGbTP75Cm466JSNeVy7UGFT3BRWEm	1573	1318	401	12463	14048	jxqXHJMBeyGALSSz7QG8vAGqr5zVpyJKGXKHwgMNx1p3z9z72uR	10953	15422	15422	1618715160000	canonical
21889	3NKWkeEqVbmTsErZriVfk4bo7Ku8LH2DoTnAQkUdCjmMwL2Q7xwD	21887	3NLMr61xHkCH9fUmCntKYaxEwT5VyPvHK8EzJg7t62xQvahEDYeM	1571	1335	401	12463	14050	jxw2q6K89sEZFiqexSCHz6XM19LkQfyuGQQaSH1FhNFV3Vf1LzF	10954	15423	15423	1618715340000	orphaned
21892	3NLcmBAETzdcfLgPhpMiu58CCAPjUihFkv4ajVaiLRb2kVaDbrZq	21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	1671	1365	401	12463	14052	jw7R27Ek6s8ZA8974Gky5bNxm8cQULrMjc7nRU7ZyQUrQDaT3Eh	10955	15424	15424	1618715520000	orphaned
21895	3NLKfFERm2CwCU3VsGya5crQFz3kopGwmcAzpWSZ3mvtnHpNaFUL	21891	3NLs8EB7bWeMKiPJ9Q84BkNeSc7P7YpUdTrGds421yWNLg2J4aKX	1423	343	401	12463	14055	jwsRqHRCh9W1BCbTp1eKP8yzRrZPfzXV1JU45uivw5QWBUrb9ch	10956	15425	15425	1618715700000	canonical
21896	3NK4cYrLR5GLwthRk1v7c7QnYfHzcnwipP3Txtse3UoAxQZo5eZd	21895	3NLKfFERm2CwCU3VsGya5crQFz3kopGwmcAzpWSZ3mvtnHpNaFUL	1406	1393	401	12463	14056	jwxJ9N2KLknRZc8A8f3eBBGN6i43yRmmiVPLDnsizVVgSRhv7yT	10957	15426	15426	1618715880000	orphaned
21902	3NLEYJAoTA3JjAJjfgmz6hcnbwrsE9SnAb5cnmuDJK2BhfiPP94Z	21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	1585	1120	401	12463	14062	jwo8RaQ56TUB79U1KzY1vQUJECVmX6yGG3gRckk3thUyqL78Pam	10959	15429	15429	1618716420000	canonical
21901	3NKcfRgyzufpgc7zYPj81otrD4WK8yWsySi58evbX3MPn3KdQjwp	21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	1419	814	401	12463	14061	jxS4Hm4NFy1Eu26HXtPndAZpBL4ap1LNRAWX4JWEurbTBDw45qv	10959	15429	15429	1618716420000	orphaned
21900	3NLdHN9LAD8xB9qVyzkvBDNPWSqD5x6wWA5QWsTFTcKLXxSdpMJM	21898	3NLdfDGWiQrSwNGdHXwsGi1YFywgP9KVD39jEVyuSHTLQQz4BsWG	1403	824	401	12463	14060	jw8L7GwyBm2erHavfPjhBPWoeP2HLXWybV5pg44JhT6zhTYjx9W	10959	15429	15429	1618716420000	orphaned
21903	3NKkSEuAH382FGerPYMBQ22nMmUWupFKykwgrdoqdNyJnzASS3js	21902	3NLEYJAoTA3JjAJjfgmz6hcnbwrsE9SnAb5cnmuDJK2BhfiPP94Z	1649	1383	401	12463	14063	jxNcA8PLvEEpCfrbuLLWTjvFLnfsqEK3BZQqcQSThEvtFwVVMRL	10960	15430	15430	1618716603445	canonical
21907	3NKhJRC3SGmYnYnPn8o8XbeR9BLTHv3mRPrkwieELJMG7Y6FJWJ7	21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	633	1018	401	12463	14066	jwLde4ikiGRmeamw5n43wmihRvmPH4KjQ7y82TCB4h35M5Ezw16	10962	15433	15433	1618717140000	canonical
21908	3NLgyS7AavDti7WxoHCcnGhWeDrjwn2nU5pv6Vtrm8tB9ng9iwwi	21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	1541	1052	401	12463	14067	jxGXcUXPN8vktY9zyRaDGDnNaPLxHyi5oPkLirEf7QBeSKNMFZN	10962	15433	15433	1618717140000	orphaned
21910	3NLGm4hmYudCjRnL7FjeA9kWsZr6ZS4XWQcrM2ZU5tf5zEcVzbL3	21907	3NKhJRC3SGmYnYnPn8o8XbeR9BLTHv3mRPrkwieELJMG7Y6FJWJ7	1631	794	401	12463	14068	jw99uMSGWP3Vgiys6P8u7cD6yKLKBHYjsMZNZRUo1mpTPRM5UHK	10963	15434	15434	1618717320000	canonical
21915	3NLXSTSacvBrKyqqHFiVYzeYYPvPMjKnDSHG3RSB18gkSvjs9bPi	21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	1458	1077	401	12463	14073	jwNiiJXNVB4iqHv5nVE6EhNehwksyWece5ghV3N2uZQQ51E2XoY	10967	15438	15438	1618718040000	canonical
21917	3NKMXdmc8dE2SuLSu3a4Xg7p6tcGBWceEm2HqVThTLcyMR6zNejQ	21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	1553	776	401	12463	14074	jwUaeSEDHuPkJAME6KwzMhD4k1n1GmwGKSEW1RaFX4EsBs3eME6	10967	15438	15438	1618718040000	orphaned
21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	21923	3NK7WXWx5YSHUB2dUQk3SLTmAuUH1t4mTR1eeGtcTeP9TouHFaem	576	1229	402	12463	14080	jxW1VF6cBqQvjnSFr616ibpysmUY5kJKMfuiK7Qyg7KWXf2LdNx	10971	15450	15450	1618720200000	canonical
21927	3NK9U5BGvVxJzTgew1M6SZ6d99B39awBoudktzPvqS9ov8oP4UZd	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1445	1290	402	12463	14083	jxcfdo11WmFziXtaFH9nY6rj7xfpo2TzRUrqoEucLz4HzuCJ2YZ	10972	15451	15451	1618720380000	canonical
21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	21927	3NK9U5BGvVxJzTgew1M6SZ6d99B39awBoudktzPvqS9ov8oP4UZd	1501	1360	402	12463	14085	jxpVUCLWYSZaHbgBoUoNHWAG7nQHvkz9APcr5AGfWVThi1FMty9	10973	15453	15453	1618720740000	canonical
27527	3NKmqQpMoSSoCpBBWYqXoMcxbPZats5xeG6SfUESp22t9RdcdgVA	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	152	1204	536	12463	18974	jwLxFFxNYVwFvXVZYSBWWhptsNHVRrVEHE8i1f2AiXuTawcfam4	13609	19164	19164	1619388720000	orphaned
29202	3NKjWeFHC6pvbUYnEeLbSe5GMUraZVWg2zz6qgqJ5acSw5HvZ5EF	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000	orphaned
21888	3NL7VQrGZGpUcGktt4gAxjVPukCPVrL6afeXsNHKWCKhs4KUeMir	21887	3NLMr61xHkCH9fUmCntKYaxEwT5VyPvHK8EzJg7t62xQvahEDYeM	1407	1395	401	12463	14049	jwwV21sQnqzY8QqQUF3vAge7mQAWq4NyUPiyPhymwgT3Y1zTG63	10954	15423	15423	1618715340000	canonical
21897	3NLg2XVdye8odFeY1W7JDs6E4sFsEUnnjP3oR5efTzRawcKceRBw	21895	3NLKfFERm2CwCU3VsGya5crQFz3kopGwmcAzpWSZ3mvtnHpNaFUL	1637	816	401	12463	14057	jwjaHYzydTVBbVr4v5KQVFkQ4FrJTeDi8GVnyGAGPP1CsirmBQe	10957	15426	15426	1618715880000	canonical
21899	3NLF7k5i6zPbTqRd2fJiGh2MeEuBxX2M8TwrnVRrcNKooZCa9QM9	21897	3NLg2XVdye8odFeY1W7JDs6E4sFsEUnnjP3oR5efTzRawcKceRBw	1648	1284	401	12463	14059	jwwYFkz9T3t5t7prwU1N5zviZYXJt7tSGMigwGrnUdbymY2MeZx	10958	15428	15428	1618716240000	orphaned
21904	3NLsWWMeKGTF62EqCjGRRHQc9NmvzdTwStYgkLKQDD7q29s4gArn	21902	3NLEYJAoTA3JjAJjfgmz6hcnbwrsE9SnAb5cnmuDJK2BhfiPP94Z	1649	1383	401	12463	14063	jxNcA8PLvEEpCfrbuLLWTjvFLnfsqEK3BZQqcQSThEvtFwVVMRL	10960	15430	15430	1618716600000	orphaned
21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	21903	3NKkSEuAH382FGerPYMBQ22nMmUWupFKykwgrdoqdNyJnzASS3js	1483	217	401	12463	14065	jwephPu5bNF3Auvv5qrjSNm55uEz2qncFaY1ErHTadUcvk3n42g	10961	15431	15431	1618716780000	canonical
21909	3NLTwjsVrqE91biGA95qmpr4rLpSXuojESexVU2NzhGBEoSeb4eG	21906	3NKivyfffVtQvx2L23boRKoHred9W9S5RTQERaqkao7kusbKWpt3	1541	1052	401	12463	14067	jxcUd6bjDyzducsokhUGiejjoJgbZBZ1Vc7Fs8Ximeo9TCTBbzP	10962	15433	15433	1618717140000	orphaned
21911	3NKLsPGE6mMj29u4zYygNZQvsP7hTaUVqupZRAdAEUcVxXVbLP4A	21910	3NLGm4hmYudCjRnL7FjeA9kWsZr6ZS4XWQcrM2ZU5tf5zEcVzbL3	596	1306	401	12463	14069	jwnXDhcNCmDQJAWRr48KX4S4myQQVy1H4oG3r36pQbvDPJba9mJ	10964	15435	15435	1618717500000	canonical
21913	3NLLNdGLXUMh1ZAH6r4nN5zWiLetUCaCykiBkrhCJzDHBnLbfXsz	21911	3NKLsPGE6mMj29u4zYygNZQvsP7hTaUVqupZRAdAEUcVxXVbLP4A	1460	664	401	12463	14071	jy2UAoFr4VndAByw2AkiejCsLxobVrmEDjNqhbZz2Y552t8mrnE	10965	15436	15436	1618717680000	canonical
21916	3NKykqAQKT4yvwzpnzSFBgE5uHsy3mdyjY62w84ZZoQezk5DxWwk	21914	3NK7aN2NJpQ4Y7QmewzWB1Ab4vA87M2bVJ1rodHnVdz4v1CX7tYH	1458	1077	401	12463	14073	jwNiiJXNVB4iqHv5nVE6EhNehwksyWece5ghV3N2uZQQ51E2XoY	10967	15438	15438	1618718040000	orphaned
21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	21915	3NLXSTSacvBrKyqqHFiVYzeYYPvPMjKnDSHG3RSB18gkSvjs9bPi	1587	1357	402	12463	14075	jwibH2N5AT1Y8ZKnRFKH88hxigQmZ3b77gPjm8tfFz7n6TJ7djm	10968	15440	15440	1618718400000	canonical
21919	3NLTtuYWzLjrRuMkjjzY2QXN1LJ5sbuZqBRyEVv2yNh6CeqogFA9	21918	3NL6Dba7sF29s7DRFkN8sSGt9vxVus1vtgAUXJ8u4Z58VJ9PDZR7	311	1181	402	12463	14076	jxESW1zroonSYLW6avDsmUDLWpDJSA9i4qzDDAceMjqeVS8ksGw	10969	15442	15442	1618718760000	orphaned
21923	3NK7WXWx5YSHUB2dUQk3SLTmAuUH1t4mTR1eeGtcTeP9TouHFaem	21920	3NKTZrGjrWmZks5XV4th7jhBKS6gNAakxdTNrmijmBwsN1yyivrQ	1579	1143	402	12463	14079	jxQRuLdEQRFR16zQRhjLnajbP1JEGzPvvw11AvzkWBXvU4bAV9K	10970	15449	15449	1618720020000	canonical
21929	3NKyLkzb2DTA6GtBcZNpC5UQRox6jLWRqnqq63P2MCvrrwvqYK4u	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1445	1290	402	12463	14083	jwyGTuqNfPcUitkh8ZpQcTQYyH5498ckfGVqtKddF8fKfWU5wGT	10972	15451	15451	1618720380000	orphaned
21925	3NLd6Hfm3JKQ7ApQVBTURnjnDFCarbCmCgaqkHFxGaXAsKU4PCVz	21924	3NLEK4k3vMQ2TK4L9oRnGxuHGV9Bf6X8MYcxsovNK7jxYa5TdeFB	1406	1393	402	12463	14081	jxNyMHqqZMmt4Exwqf4JiKb1u1ggwyMKrnYEMoVi7X8T35TiCA4	10972	15451	15451	1618720380000	orphaned
21932	3NLfb9Jh2vqUJ7MTixG9AjJMumhE7zQTcjf3iUBaE22TAitAYZ61	21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	1406	1393	402	12463	14086	jwdY5jGJMZ6Qk3tRdW3iD8qdbcS79UY7Y2W6BH6J3URZ9B2rq91	10974	15454	15454	1618720920000	orphaned
21937	3NLQcfAo1Nu2iVMkRVjsyY9uX1HFnUc1fk3QzchGnsHofGwgGdPD	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1421	136	402	12463	14091	jx25qcS8cW4EDvfzptPhf4jbbfqVjcykrDwbsqzj9BFz26Yvebg	10975	15455	15455	1618721100000	orphaned
21943	3NLdgNmKJveEUecip41RG1Wxh3NsGLRcoc9jYkBhFRCaoiNtipg9	21941	3NL1rpB1pTo1rcQCdLjoFah9HwFB7xATRTnjDiB2NbatB7wp6Ew4	1637	816	402	12463	14095	jxaxCirCEyrEpprycFJoZM59wLVTMy3m6RvUe1PR2AEcigJTtne	10977	15458	15458	1618721640000	canonical
21945	3NLH5mXXceSrgsBrWJHfnicscZXLCRiBLgtTK2d4Svc1RzbbAAYK	21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	1407	1395	402	12463	14097	jwDGFnVnx1gHDZif63FD9zZdAeT3PPuAGsmYRhWd44wsAMQ3W5P	10979	15460	15460	1618722000000	canonical
21946	3NLJ3PhMeoJ3x76F2Jp6kgDC8Kg6CMA5vL2Zg1hgXMCN58EbVjMC	21944	3NLN4g9446ePuX2LU8b4Kt39ZfXwaHgB7Wc2hsYMZwNp3QeU4XQg	1500	931	402	12463	14098	jxsznNff4K8NH2m7875bNYaxgYejCLXDYAfDytdx1VatGUK9K1t	10979	15460	15460	1618722000000	orphaned
21948	3NLGrH71xG5UMfnbfBm6cFZPuVCVEQtMdbSbBbeGURren6HaHYzb	21945	3NLH5mXXceSrgsBrWJHfnicscZXLCRiBLgtTK2d4Svc1RzbbAAYK	1579	291	402	12463	14100	jwFY3gwg9NBygGi7DX6VVvfb1TiEb9iWjZcQVReaXTGgzwnkBgc	10980	15461	15461	1618722180000	orphaned
21950	3NLHNvQ2T251nbwWEWz4rpr2oRKDs4o1Bb4TBP52N6qScZuzHhyP	21949	3NKiiY5wFjqxGjMz4gP55ZTLVDB9wU6QGP58gNi3eGo83UTabWvy	1406	1393	402	12463	14101	jxd1eAiGh4oQvbSoqwRqgt1cMCoCaTUXheZ4FpdfXxydWSkMDCi	10981	15464	15464	1618722720000	canonical
21952	3NLLxdqFYe6m24RLyJHvUcKJuzsttDuhHYzppy9CB4QA43LUy2gw	21950	3NLHNvQ2T251nbwWEWz4rpr2oRKDs4o1Bb4TBP52N6qScZuzHhyP	1403	824	402	12463	14103	jwpdrZYycCACAr2R7unuhXbGXim4CvUkk2dUkUPu2Tbo11zYCVi	10982	15466	15466	1618723080000	canonical
21953	3NLWBrMXzt9SQx4hjSxZeJ8gKVbmgZ1sLPaWnqtsLporqRj5Qgoj	21952	3NLLxdqFYe6m24RLyJHvUcKJuzsttDuhHYzppy9CB4QA43LUy2gw	1406	1393	402	12463	14104	jwsXKr1MqTNsA1rhJCPeFtdYoX87GUbMA3teKqufrnSj6uYjUvY	10983	15468	15468	1618723440000	canonical
21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	1403	812	403	12463	14110	jwvNWZPr4JRqY21df5YX5zP29VAG8qX66UZQ6QanEP6DdMsgYwA	10986	15472	15472	1618724160000	canonical
21963	3NKWxdDuxBrRkjj3nmGoYSCaQEG1Rngd44DsHjLKcVNB87j7xrvr	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1610	1314	403	12463	14113	jxKejHsc7W7zAuJidRLk8JxDKZBF9txBJaetiiRvKiinw2FkuBf	10987	15473	15473	1618724340000	orphaned
21977	3NLY891i5HZkrUZYjBJx6noi1XEiUd2Qb1QnaZRxwk4Mjzhn29ZX	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1405	851	403	12463	14125	jxq755HCk9VQtgrMj1dUtnxHxtU4Rj4P6RGrQA6jkSjtodYzdzn	10989	15476	15476	1618724880000	orphaned
21982	3NKWBVi6EW5TdKQM1GEbv9JZPf3sTV18dSBCqpScTLQ8i63sFmpq	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1541	1172	403	12463	14128	jwchTprZDfaDwGqiqHy4YXgjwLPigvM7XXdNi1jWBGTs9kJZraD	10989	15476	15476	1618724880000	orphaned
21984	3NKX8TfE2tfkfQqZUyLb8zXJBfGSj4PPe6FD44enZktYsYxGfsNy	21983	3NLqj2j5mJtEYxZXuASCn98kx6TFDvghMed8oQ9ja3WCmtsN4DMR	1613	1103	403	12463	14131	jx6kMW3W6Nc7pi6fvcEVV3wCupLBE4dmzwo4Ytf5bV4MzVNuSq3	10991	15479	15479	1618725420000	canonical
27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1407	1395	536	12463	18974	jxZzFyjNZVQaLh5MVHZR4sZCYtbdCz3Wbq7nCNwe7crPbCSQQ3q	13615	19172	19172	1619390160000	canonical
29812	3NLUMun5cYgKUEhis1tRFAjQu88wnNF3ar8ezrWRp6psD4gsNzuZ	29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	1619	1275	573	12463	18974	jxV5oZWxtn5ZsA1fpoeyd4hDJ1Ct4Z7vXQZLmEMR9Mw3FSEzKjG	14403	20684	20684	1619662443560	orphaned
21970	3NKXCnx1nh8fqCp9ZdraN5uny3gN49Ya4VuNJwf9nXT3oiCejDeU	21341	3NKBmh4VJ248dU2BXpXYGdnGpZggufqQrT6drqZP2pMCr3s8GA9N	484	484	389	12463	14120	jwuAArTiMxAyWKAzJhoWn1cpv6ewdrDxJnzRVsHJVc3PuEAaidu	10713	15474	15474	1618724593767	orphaned
21971	3NKPgc5J7TyjbWS2SaPiGL2LuT5NNGht5kk4EeBx9v49sKCDsm8p	21377	3NLkQWNGiDaeY41XohFLN6KBWNbMvRMGa6MGD2hjsMEkmrUEGfxA	484	484	390	12463	14121	jwNMvWvGtnYvKQZSxwhgURZVu15trLMmC2vKDf7L2uKb5o3epaX	10726	15474	15474	1618724629754	orphaned
21981	3NKzdxKeGn3Kg2bi6pHF59C5aKP2HrtwvMzFYuo4xT6CydoVubd9	21563	3NLvU33f8XbK3gSbTZJTXobSRCbfPeXs8Usrsd5a7Y7TKSZHLL4i	1522	1076	394	12463	14129	jxgzbhQLmJSwtbTgrxLASARLcAmzLDzKLr7EG91HbYXNCt18pfJ	10813	15476	15476	1618724880000	orphaned
21999	3NKZ1ab5n6vUZEpyEwRErhJYk6hAoSrTAJV3Z1NXMNShj97wCaVV	21905	3NLLUpLdaHd4r92KNswm2MuV5QLznQzcAKsCq1oqwKJMXqQhSouo	1617	1288	399	12463	14146	jwoQxr77PM3TWtzUiPNdcuHCiXLxqmKNSje2SiEUXEiVwgZpQhr	10897	15490	15490	1618727400000	orphaned
21934	3NL84ZLLzfN7Kbs1rjQWrQEsiwXNRfRz1qxP6UZFwjQQ4WUvTGvh	21931	3NLxS1C8t5GFbTZNzhPz2vbUCCwgcPMk3pz95SVZjJLaty6bJxEK	1601	1142	402	12463	14088	jwheNUsjTN4ebheF9BHstbXAaU89et99bY2zqiHvaBAp2fQbVao	10974	15454	15454	1618720920000	orphaned
21940	3NLQ1cBg3wd2LiwWyyKsq876uM94CWNbV6QENTUDDmFB6G5m4nmV	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1651	1175	402	12463	14092	jxQmk3Pue3BncU6HoRg186iGPthFBP7MzV5qgofzJHyUyq6rBPh	10975	15455	15455	1618721100000	canonical
21936	3NKxkxzWQBqPmffKXCoebUZi7fBqRc9bENdSYkHZ5Qxz99Z9ro6y	21933	3NLbdZbzdCM73EmYZhRFyTf9V5kNgcm86GERgXPUWG1p5PiCsHsU	1448	1311	402	12463	14090	jwcEv2QqDfobVAFi8vZHxP26PYZ9UjxF3w6PCiBm69yr2fgyTCd	10975	15455	15455	1618721100000	orphaned
21942	3NLpjFw4ws2vC5aJJtuDVDXNP3WVMX5rjY3wNnf7evXMMrHW7nh1	21940	3NLQ1cBg3wd2LiwWyyKsq876uM94CWNbV6QENTUDDmFB6G5m4nmV	1406	1393	402	12463	14094	jxM3NEGmWYASe7ooGC9gJhHSP4FEPbnws2outwUvFwTRNtQsbRW	10976	15456	15456	1618721280000	orphaned
21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1631	794	403	12463	14108	jxoZ5TkWNvgxNwp2EJKf1vcHpKdMUt449Bpa2o9LdLhSSYKr6Ge	10985	15471	15471	1618723980000	canonical
21956	3NKrqF7kpwSqyX2i7MZdTpV8o1ssvUcWrfLnnoy7Sh3sZ1vfWDUN	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1483	1276	403	12463	14107	jxZGJCyTan1fL8weDC3NcPxCbKYVoSnhUffN8tSL6q2irRaMWuv	10985	15471	15471	1618723980000	orphaned
21968	3NK7f6Q7vA1idFB1DC9QsiuHuboUGASoCJkTUqUsKEiWUMM9S7bM	21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	1445	1290	403	12463	14118	jxSosoHDTfNM79fAUmy6daBzoA3wCTCUEjDmhRj8fYTaqRzRXWb	10986	15473	15473	1618724340000	orphaned
21964	3NLJME9rMVyAKkSS2WiqvYqMnae99ycrpAgsrtPUKdQ252ACbkNg	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1403	782	403	12463	14114	jxkmmx4KxFEPyfUEhBExDm37o7mJMKab35LQA2LBJbmQEDUkenr	10987	15473	15473	1618724340000	canonical
21965	3NKMk2c1cTetZhj3hzaMnSUc7uiMmUcPLPj5XWjhk8c6jLpB3EPq	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1445	1290	403	12463	14115	jwDA8SwhRky54JBMMnZSvqqpFQC31c8zxg24brsmnsSmkWqKysX	10987	15473	15473	1618724340000	orphaned
21962	3NKG8XP7jQndVcnw7jMXrGk8xVjZBpzU6iQJP8pE7rT71yJEHeTa	21960	3NKS2R4ntL7dcbWgNRMdSa5w7xepo3oCoGFiN2QkSv5MgBQBKvyR	1405	867	403	12463	14112	jwnJVCVE4t5CVngrco8oWz2bJsoWgqjAPkgx8XefFwX9VyzzfLE	10987	15473	15473	1618724340000	orphaned
21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	21964	3NLJME9rMVyAKkSS2WiqvYqMnae99ycrpAgsrtPUKdQ252ACbkNg	298	1308	403	12463	14123	jwqTLSMWtWJ358SGNVts8RBycS41ZipGjLgwPLHwwkS81j3U4Vj	10988	15475	15475	1618724700000	canonical
21976	3NLv2Lap4SDKdHpUrubhqdj3oC4xkdssestsTcqNyzMzKfcQ4MJ2	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	298	1308	403	12463	14124	jx2MJMtmh5sBkBTUGuFuMhFk89dnBVVQwcuuzgqaP49tFng3PiL	10988	15475	15475	1618724700000	orphaned
21973	3NKAACUPCYXRu7nTTBAgaNoZD8AfN3otvisJJcj1E5AivtZVFLU7	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	1527	1293	403	12463	14122	jxmBcdp9kcqFzb5QW5YM6XVoQCcZjNfvXJoVdSj2p5E8ZuQSCai	10988	15475	15475	1618724700000	orphaned
21975	3NLXFJi53icAhggVAsBnihWzDjHywq7DrQbpEWeK9Hf9vZCX98z7	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	1527	1293	403	12463	14122	jxV14SBmUJYe7kbsExgSZ3e3vto8Zj7hvd3o2p3VzQrGfc9cabm	10988	15475	15475	1618724700000	orphaned
21978	3NL874JVkBKNDDuP13BnGfM8iSShwYeX2feWUAa9YpSdzq8jwzuy	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1522	1076	403	12463	14126	jxqSfHRCYDji7JHL4D7rHqaRLx2QkrmpyMRAD5UnSieiPNZrinV	10989	15476	15476	1618724880000	orphaned
21983	3NLqj2j5mJtEYxZXuASCn98kx6TFDvghMed8oQ9ja3WCmtsN4DMR	21980	3NKitouaCsXx8UGoXQrLK9ZzRcseeRvJNmHaxAz5zHmDTuehrZd1	1619	1275	403	12463	14130	jxJQtZYAXPmMpR9UyEXV9JtJtRa4EqeMPCrGe9x1oZs6Nyz4fUR	10990	15478	15478	1618725240000	canonical
21987	3NLGoo7PKWyf3dEDve5smZFrFZQJ54TV323kkMqfR7cakfM9TSdq	21986	3NKvYWwAJuLt6mSmRhsKiG4kMFjCzSzCFK5xRNmjPkGhGeTCxuja	1594	1326	403	12463	14134	jxAH9XEzwBc2yM8GaBwnfUrQC2D3SsvX2QK72WaHhYGKzQJwdSJ	10993	15481	15481	1618725780000	canonical
21988	3NLyJiS1ZHbFQNhkcQZ82QkN6cqdMvb6xb5ukwUaTGFVPvgdV8qY	21987	3NLGoo7PKWyf3dEDve5smZFrFZQJ54TV323kkMqfR7cakfM9TSdq	1403	824	403	12463	14135	jxHJLsgeWxXfWAh3VnXUBd5kkv8SFLQbkVPNSBAy1LiwAwEiLm9	10994	15482	15482	1618725960000	canonical
21990	3NLMLSFFn9co6EAJoTX6bC3XMoJDVHJzASdEHePf8qc59RG4eKCm	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1654	1340	403	12463	14137	jxKVseZhk6T1CfRRAzbpCivMERbXBA8eahpcpDXDfPMMEM83aF7	10996	15485	15485	1618726500000	canonical
21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	21996	3NKAvnFHxRWrk1fZA6LXZtzxfeZuGTCM67Dotyapp6ypVrpGViUB	1406	1393	403	12463	14144	jy2CoUZznDihVkTgiTu9xauN7nm7nt9pQFF1x2zWVYpQfTNQ8TE	11000	15490	15490	1618727400000	canonical
22004	3NLsRrQ7TCmbaEMbgiWZvnndNH2tJTnDQs7TxS1PE6tbzooYUNVk	22003	3NKYAPFRY8uZgbCi15PBpMGG14uwJW7SdKz12d4zTtAUUhXxG1oU	1553	776	403	12463	14151	jxsiRD1WLvhhofhFi1hRcWWZWefQNcX1zvJJiv5QAfwWnNFdAyp	11003	15493	15493	1618727940000	canonical
22009	3NL1qwzXZZYR232EMXbMhMyi6XBcHCbKVz42bPrtbW2DuUbBeXSx	22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	1405	881	403	12463	14156	jxYqAozcawW6PNkbYYnouY1JDxNe6TJSxXyphunpt3fxzzSM8Zp	11006	15497	15497	1618728660000	canonical
22011	3NLNwud62oK1pqUpxAbiFRdE6wpKoP6332NGCn61omgbaNR57FPu	22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	1419	814	403	12463	14157	jxhKNh7sNF13QJair7aGef1TXPn1UHgaLXCrfhXvbZKkgxXuyMw	11006	15497	15497	1618728660000	orphaned
22018	3NK4VemKYt9Sp1qxvo256PTtKhfPAz2SgdFZHYXBjoBzCaipuYaX	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1448	1311	404	12463	14162	jx5f71V9tkYnyoU6gz1t1EuyV9Vf2e5wyYsccNtQs7ivTQ4gZNK	11009	15500	15500	1618729200000	orphaned
27544	3NKHmhpcfUQL8s7VWahoQEgU8asFAMJyFRgZYPZMqm391ffx6qbm	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1489	1254	536	12463	18974	jx8jCm6yi9QpMmDKw12k39AB9QYgcXZdy6VPW9BSQq1qCEYTsnD	13615	19172	19172	1619390160000	orphaned
29238	3NKyFGguywc7XXArbsv1W5AmqNYfRFHyT7rTPkYZYMZ1BNK654u9	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1523	955	573	12463	18974	jw9RAUMrBEsDDhyEfq2YQQkfkhGzAXjXYmgyWiWS2Usu4nN1Zhg	14408	20289	20289	1619591220000	canonical
21951	3NKFTUasC2ahtDwXb8xPdLoqn3PTiNYnGYP6qxPBF8iVr3U33Efd	21949	3NKiiY5wFjqxGjMz4gP55ZTLVDB9wU6QGP58gNi3eGo83UTabWvy	1516	1048	402	12463	14102	jxw8KrDTD5agouSdGqvK2u9FdvEKttA9shX9LqSXGkomxkw7CX4	10981	15464	15464	1618722720000	orphaned
21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	21953	3NLWBrMXzt9SQx4hjSxZeJ8gKVbmgZ1sLPaWnqtsLporqRj5Qgoj	1588	1392	402	12463	14105	jwbHYwGJnjjW6fws5LUxsc3TbNmXH2156cRzAEgpTaaonQKb4DW	10984	15469	15469	1618723620000	canonical
21957	3NKotPcyZVMWLtLuKZVFgp9J6Mz3et1KuyNtjNwsAiPTjqTFNfrw	21954	3NLZPnuVTp4x45zaKbhuSN37FCFV9iT6RmBtFPFJJnaMvkLfjvz4	1483	1276	403	12463	14107	jxZGJCyTan1fL8weDC3NcPxCbKYVoSnhUffN8tSL6q2irRaMWuv	10985	15471	15471	1618723980000	orphaned
21961	3NKm1mfE9VHCuvBk8dPptfhhiBo5CizGU8CzR8SgQHK4qYiVTAE6	21958	3NLKKbNVYT2MLk1sXZSVVTmV32jbe2QiQ78QfqzqVkPk12dorEEW	1631	794	403	12463	14111	jwn2QfcVvdMNQoN4aFM7rAWw6f2bWCuodKxmU6wQDBCroVxR8xe	10986	15472	15472	1618724160000	orphaned
21972	3NKVXtPscxSFmoK9tYDFKzcwNtBvsuqJdKEv91HGoEjdEeXMumw8	21966	3NLfrwZsNAPEYnjzYNXoNqwXkiAknAPJRyPaYC2p9dZoZsNW2aaK	1527	1293	403	12463	14122	jwAmhdkCsJMnU3c7te4iNiCKsspg1tBD1LzQokcTho36cazw1zE	10988	15475	15475	1618724700000	orphaned
21980	3NKitouaCsXx8UGoXQrLK9ZzRcseeRvJNmHaxAz5zHmDTuehrZd1	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1541	1172	403	12463	14128	jy2fPKzmJhquVsgxMo7x6JMEuH1WHJi22UpETywPo8UwGn2NY2W	10989	15476	15476	1618724880000	canonical
21979	3NKSHXY5cHZRovDJmjfXBP21vaqhRQNUaVVtmyCYybnKCRuTzLGm	21974	3NLJjQ8JyW78EUJqfwPGEU26Smsksht9E38SznwSkjE1fWCMbRWs	1675	1216	403	12463	14127	jwVjCACz9tEMcUYu6b96yCXRCoSCz8qe6amm3zxGgmjCY7MY41F	10989	15476	15476	1618724880000	orphaned
21985	3NL9sSbWwXF2ouE5GVQDoi6hZTk4B3zzsFK1fqBMTv3aGuJjAYsE	21984	3NKX8TfE2tfkfQqZUyLb8zXJBfGSj4PPe6FD44enZktYsYxGfsNy	1422	971	403	12463	14132	jwUTRTZi57uQyCuDmNxnTRLErAcHCQbc7ZVqMUk91Ja7aXZbuts	10992	15480	15480	1618725600000	orphaned
21992	3NLdpbZaGAdkqWg8r9BFkCWTqHbzBzVC6kLAsLK9RzMbTqSkXPjh	21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	1406	1393	403	12463	14139	jx9MqhhqxQ3uXy3mk8wMWKkjgrCSvZZ4PEDtopx692DeLazktee	10996	15485	15485	1618726500000	orphaned
21995	3NK8DS8HXa4dzT1VRCAku1QFP3dEc51RBWvC3VjEZ83A2nvaciwx	21994	3NKTrVuzao3deswkSQPLwe2APbVExoSKvaNawnKizTwhXdExBbpu	298	1182	403	12463	14142	jxV8k8hcMfzvZyPwHVWcS9JvCwE2p9L7ca7SDSfbqu3JpawFrBy	10998	15488	15488	1618727040000	canonical
21996	3NKAvnFHxRWrk1fZA6LXZtzxfeZuGTCM67Dotyapp6ypVrpGViUB	21995	3NK8DS8HXa4dzT1VRCAku1QFP3dEc51RBWvC3VjEZ83A2nvaciwx	1573	1318	403	12463	14143	jwMHo48LQLAkWfs2HEZ2n6FYZ9bDRFvQ3B3Hd9eKTZNoE1GKXk5	10999	15489	15489	1618727220000	canonical
21998	3NLJLttopLjCh9csDjozxQUp36NNiD9nqhHbMyEG7LmQCiPoTMy6	21996	3NKAvnFHxRWrk1fZA6LXZtzxfeZuGTCM67Dotyapp6ypVrpGViUB	1673	1368	403	12463	14145	jx2KfYpko7WfbfJFeZurtc2wNYcE6zfi5w7v29yAmS7ZtnvzT1s	11000	15490	15490	1618727400000	orphaned
22000	3NLLnPLXAAciyiAjKN223UjJcjzqUSQTNm8fXxpbvwcxr9h1TUf4	21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	1457	1265	403	12463	14147	jxeE1vcmRnUK993SHCxoPAmDpZfnj442h89jBLkdgZHajndZBWW	11001	15491	15491	1618727580000	canonical
22001	3NLKUYk4fb1WL1vgp6WivLrzMH35YBzmFUHM7ZBKoYGwzFZBie8Z	21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	1406	1393	403	12463	14148	jwpHnzvPNSj1p9LJY7Sm2CRGZcgfrhgy3GjFyZSs1ckXjPdsZ9B	11001	15491	15491	1618727580000	orphaned
22012	3NKdcMyTwmi1YxnLZr3TmyEosYK2wya1cx5G93ME9A6SyivnH2Ke	22009	3NL1qwzXZZYR232EMXbMhMyi6XBcHCbKVz42bPrtbW2DuUbBeXSx	1407	1395	404	12463	14158	jxmThEwU3AN92Hh8vh7aFNs8Ubn2W3vB5TrkpJXkj8huVRnZ1Yc	11007	15498	15498	1618728840000	orphaned
22015	3NK8ugQCKjWimZuVVnURAyPfQMTei7qC1xYRRT3BB2cpXDky3HsD	22013	3NKJteNDSPk7LXE2zQ2ns3eWN4P3vdQHDsnwLfd839BavXQWqbid	1445	1290	404	12463	14160	jx6t5FEi7HXbg9BdMQiGCHzXUZkyhPb6zEijzGpgKhnoeWravKy	11008	15499	15499	1618729020000	orphaned
22017	3NLM1VUj4MYVEos1v9vD3TSVfKicFBUTfAuXrzvpciWQd1Vq4Roz	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1448	1311	404	12463	14162	jx1P43NSnoPLoNLpPbVkcJUa1q1WFF4fTU5mswuCYnwNgem5d33	11009	15500	15500	1618729200000	orphaned
22020	3NLRx6xrTB5H81Cw8CQpvAwdA2L1oNFtKSUBj5ogR5QwJJrz4YYf	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1541	1298	404	12463	14164	jx6jjoPapB9Tt6sKB6TfDWAiK5RKGyCFFaU91bhKjW6y5ykySMG	11009	15500	15500	1618729200000	orphaned
22025	3NKPiupwUE4mNTx1J3Bdafvf6FnXb1YruPgNyMBWvRrBDXFLhuu5	22022	3NKXhVMrHsw4AhLZoxAfb2YstUZgPKJTz9qgdrtTMvsmFBzZByrA	1440	1011	404	12463	14168	jxwNREg6Yf3gV2uvM76hvqgLUVLn6kHpEtjHdkV6XEPHp4VkQhz	11011	15502	15502	1618729560000	orphaned
22028	3NLFmmmuLuWvGNa7njj1Sb8opwDvxEK7BfnjuQkef4oFbGEaGT2z	22026	3NKzfQept3CLuU6aWpv4Q5zbwGuiAbEcDDfqtCtSjpFuVnmrtjw7	1672	1285	404	12463	14171	jxLXSj3qFDd1Sr1rk6rDnGojvdKoA9LKkcUyRzBn4QXLKHnL3Ro	11013	15504	15504	1618729920000	orphaned
22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	22029	3NLgEMTVB8T6tUcwjXTr7wvmQwUfunF9euXi2icJ7BFzzN6tmUHp	1654	1340	404	12463	14174	jwySwHhxj1NM2oArmqh3fzMsh6S5N2PPTZfhr6s7XMW2DcxEQnY	11015	15508	15508	1618730640000	canonical
22033	3NL8a4HJ7tqYgnDR8YNRyzgmzEVhLpiAm166WFkijnU4kh2zBw9x	22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	1601	1262	404	12463	14176	jwmPfMoK2bBBNkjHwWRcqPqobwJ5CcLF5L48KvgUGCpfdJ5whBn	11016	15509	15509	1618730820000	orphaned
22035	3NKJ33awbyiKUfPsv3r5bncjGtWdL8UgetsyCoKKoHatCCiTmhoz	22034	3NLUCL8XChdzHygcnbmEAJiJFQp2hFJzfpRrrujn3aDkCNL9wCJy	1670	1282	404	12463	14178	jwcVj8SA9pUaPfFeVkKYFFxYFKxqqRddULWVbuvenaPS9NnNCuY	11017	15510	15510	1618731000000	canonical
22040	3NKFxhYNcHSHwgaxFEKQuam2WmfVdDxhnSUjkLK9CVnmNcJpoFBR	22039	3NLsnS45rKMQP5xp2uczDYrFWaHSuqyD7hx1oy7xVjXfxQnBJndY	1578	1170	404	12463	14183	jxb8YrUkcsxAXRzaEZN7vQBg5GNECRwtfsYmoexWPYHBzAEJ8AJ	11021	15516	15516	1618732080000	canonical
22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	1672	1285	404	12463	14189	jxAT515hv6R3sDfQgC7nay7NTnNAVvmvjSBjG69mVvBmHLsSYxP	11025	15523	15523	1618733340000	canonical
22052	3NLY4xqRM9bj29RMGPG7YgAoiBxtPTyi9QXehxhcsPobWXu36eyy	22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	1503	1151	405	12463	14192	jwCAc14do5YaQNeCCEZCKEfAYq22mWYkBZaRA4WSL449rGvPQsB	11026	15524	15524	1618733520000	canonical
22051	3NK4ZuAFGZy7AvyL4hu21cwbp7TPF8rQcjiwkGzsbV81j11vHBBB	22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	1503	1151	404	12463	14192	jxyXQ5AMAoPT6rhLodAD98Pc1oCXTJggYg86HBWtix8gEpdapj3	11026	15524	15524	1618733520000	orphaned
22055	3NLavmfFrhFbFz6mCBvM6VF13gXUdDScMQx1F1PEGdGemriEayaP	22053	3NKxb7w8tksto3y5tLrPW1a6ZMTY51wuLpkHK2dDQEVobwFNxmto	1646	1228	405	12463	14196	jx3JequkXA5ngYqHBHCzQJsvXBQCrpy9j9cL4pFNtQbghxJogKq	11028	15526	15526	1618733880000	canonical
27554	3NLPg8fy7uvkHgTTjXy8TzQLxeWvF6o3TGDzes63WwgFRpwUB5sx	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1506	1373	536	12463	18974	jwp5YQPn2T8kQhrmLnmPGt9dN2rduznNbmSXtru4mFXgcVCzXYv	13620	19180	19180	1619391600000	orphaned
22050	3NLfcQDxWT9rQBLg32FEXxJD6TUAbtLh4pNwkh8u4HZ1pR1etqkA	21935	3NLfjteRX3qTL6CtXYMj2KjyJ7y5D5FRGBkCopQngwsjHPcpAj7R	1402	868	396	12463	14193	jxkwCXjBevCvQyoNC1tnEgyqvZuHuxB1M3HES4rUr7Qjgg7tHPo	10824	15524	15524	1618733520000	orphaned
21986	3NKvYWwAJuLt6mSmRhsKiG4kMFjCzSzCFK5xRNmjPkGhGeTCxuja	21984	3NKX8TfE2tfkfQqZUyLb8zXJBfGSj4PPe6FD44enZktYsYxGfsNy	1623	830	403	12463	14133	jwN4NjxiRh6zijGCkm7G3Sc2vwSM45MyTrBfW7smez35UMNG7VH	10992	15480	15480	1618725600000	canonical
21989	3NLkDPSzHGGCWUaNgtKpQWsZPGasRJ2LNPgiMGyThim7wirDvRmN	21988	3NLyJiS1ZHbFQNhkcQZ82QkN6cqdMvb6xb5ukwUaTGFVPvgdV8qY	369	1066	403	12463	14136	jx2i7U8z3UfjTUjYYUw9TzcwTXTm5DxTswchQ8CQCHFXmLqMeKN	10995	15484	15484	1618726320000	canonical
21994	3NKTrVuzao3deswkSQPLwe2APbVExoSKvaNawnKizTwhXdExBbpu	21990	3NLMLSFFn9co6EAJoTX6bC3XMoJDVHJzASdEHePf8qc59RG4eKCm	1406	1393	403	12463	14141	jwbdRVqR3umdNM3wv6Hm37CJvCyaEz79NeqzrB4rMMQd58fZqHp	10997	15487	15487	1618726860000	canonical
22002	3NK7RHs9KFaMEwqE6Ra2r2DkXnYL9eW4nG46wnRyFKibrtD7HMsa	21997	3NKp3dMKJVe3ZvFQTwtukGrjovqFpJfZ9jucTabt4Wd4ktpwxuNc	1559	1227	403	12463	14149	jxrJ4vNpEE24Ae6s7gqHe97XiXpAd2TW4m1WvWnyajf8ySftdEp	11001	15491	15491	1618727580000	orphaned
22003	3NKYAPFRY8uZgbCi15PBpMGG14uwJW7SdKz12d4zTtAUUhXxG1oU	22000	3NLLnPLXAAciyiAjKN223UjJcjzqUSQTNm8fXxpbvwcxr9h1TUf4	1623	839	403	12463	14150	jxX7HUNKWMbGbsDGbtewS5UrWdcJg1G2Sr6ZrZZnDHASLeJDoWv	11002	15492	15492	1618727760000	canonical
22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	22004	3NLsRrQ7TCmbaEMbgiWZvnndNH2tJTnDQs7TxS1PE6tbzooYUNVk	1529	1070	403	12463	14152	jwbb5majSSQnQuLsPmku7C454BNwMRTQYQhxsBiMHiqMxUULWWX	11004	15495	15495	1618728300000	canonical
22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1555	981	403	12463	14155	jwvqAcKL8xYQBX9JeRnHfR1N61wg9pt8TkB5RkmCNyuLWJhcXuj	11005	15496	15496	1618728480000	canonical
22010	3NLnWDQbbSzqdbqjrFEbfHq2BNSd7yxMGtfqDFZapw3FoQEJ4DqJ	22008	3NKEB5QrigyZfsJ8QQXwHWtEAzPGzTXYoNoS6WiEWEhBo139z7iX	1419	814	403	12463	14157	jxAbUxEtUF8ch5guZBZCz5LF6pw4WRjsp9Vcy3W22bVUYhBGWiG	11006	15497	15497	1618728660000	orphaned
22013	3NKJteNDSPk7LXE2zQ2ns3eWN4P3vdQHDsnwLfd839BavXQWqbid	22009	3NL1qwzXZZYR232EMXbMhMyi6XBcHCbKVz42bPrtbW2DuUbBeXSx	1406	1393	404	12463	14159	jx8GSzQVtCN9ruFAfA53QAQSFouYrRD2bZu6sKXMbgrK5VxwFNz	11007	15498	15498	1618728840000	canonical
22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	22013	3NKJteNDSPk7LXE2zQ2ns3eWN4P3vdQHDsnwLfd839BavXQWqbid	1445	1290	404	12463	14160	jwYDW9Zqwo8TsQUbDy9UPzuo6wFb9gVZasKuQou9DK9fqUuWuY2	11008	15499	15499	1618729020000	canonical
22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1406	1393	404	12463	14161	jxbBbjmDFx5rLby7ucCTkiDTLKBpfq6mtULMfyNidyqjvNB88Dv	11009	15500	15500	1618729200000	canonical
22019	3NKgGrWEtYaqMeai44nLPSeCes3ooNAZqyjHERj6fSQBMyvPdz8p	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1559	1353	404	12463	14163	jwRJRA2tgomydQ8dkpK5FLa7t4j5JPjTKhdpqNJ67u2Pt1Wsqgu	11009	15500	15500	1618729200000	orphaned
22021	3NKgXi9qfqSyK2xcj7QNNyPtQtzCTAxU4VaiN4DNEtHPTz8mkqsN	22014	3NLGdvLUzKbXcBhg7FaMigbUxLK46eRuvSaZqgHQeJKi9VwUGmAw	1541	1298	404	12463	14164	jwB9ahGrhCxYDinP8Vevk9DRXRrBYa8Vj53bmu8rV2uezZdyWma	11009	15500	15500	1618729200000	orphaned
22023	3NK5S5ufdAQnKsvAuboAHyvHogZXEM8SSg8fku8YLzgLaXT1GCcm	22016	3NKe5pCRpKs7d96fbBxRg65nyfN1kE3MFxKBYfKMsFcPDiimknz1	1458	1323	404	12463	14166	jweEuBZ1BbsvTvncW5egv8cctXwpQ2cpAiN7g6mqAC9n4TL5bEe	11010	15501	15501	1618729380000	canonical
22026	3NKzfQept3CLuU6aWpv4Q5zbwGuiAbEcDDfqtCtSjpFuVnmrtjw7	22024	3NLuiTew7c24JS1Grc9Ygh7gssraUyyD7ttGcvhcwbx43kJ4Ekgu	1610	948	404	12463	14169	jxKZJQTVHhYFLjdYhVPeP5m6g9mLvkLFfdD9aQT41bGbHAqtd7A	11012	15503	15503	1618729740000	canonical
22027	3NLiPGZz7W1ubmMTa6zibegJwYrerNmKBLVSfn7tzUPmisR5TRQN	22026	3NKzfQept3CLuU6aWpv4Q5zbwGuiAbEcDDfqtCtSjpFuVnmrtjw7	1407	1395	404	12463	14170	jxziggXCjxb4oSgeyDuXhrcUDcYqoHRzzwiHf3SZfoVnFzBoSYo	11013	15504	15504	1618729920000	canonical
22030	3NLGPeD6HgjViB1ScZb5h3N4uipQEXv6JnDuwvq35B6VGNayoR2D	22029	3NLgEMTVB8T6tUcwjXTr7wvmQwUfunF9euXi2icJ7BFzzN6tmUHp	1406	1393	404	12463	14173	jwaPFGdV8QHETAPoWTjbiVfjwz84jWzDVqY2NRdGM3TDd7ESzuA	11015	15508	15508	1618730640000	orphaned
22037	3NLZfjux31VgG5W21CGkzeEuehGBfgBJBpTQccyqzqMH8wzLCSax	22035	3NKJ33awbyiKUfPsv3r5bncjGtWdL8UgetsyCoKKoHatCCiTmhoz	1534	428	404	12463	14180	jxTA9AVAjUQzxxysNKVgipVXozqMmz1JT9kB5JaFy1hKLzEEKT7	11018	15513	15513	1618731540000	canonical
22038	3NLwJqdgVizc1FCeXsogLqRawbqaf2WK7JUN15bMctX1mE9uM8py	22037	3NLZfjux31VgG5W21CGkzeEuehGBfgBJBpTQccyqzqMH8wzLCSax	1638	630	404	12463	14181	jxEwCYpYAm183D6M5CmF4xmLiwGHwpQW3omyNuNw2YrRfbx6bfn	11019	15514	15514	1618731720000	canonical
22041	3NLtRy12dorjVPmBb1HuRQaYJuiyxnKU82EjKMSpy1BLnD5mU6Yo	22040	3NKFxhYNcHSHwgaxFEKQuam2WmfVdDxhnSUjkLK9CVnmNcJpoFBR	1611	1341	404	12463	14184	jwibxeip4DbhdE44pfE9yJWAMxbMbSbXtQJ4XSZsXQWBFnzZGZ8	11022	15517	15517	1618732260000	canonical
22043	3NLZbvKDeAQ3Q7AeBi6NH8t4djapzGUXYEaD6SpkBmjKTqjDuqbg	22041	3NLtRy12dorjVPmBb1HuRQaYJuiyxnKU82EjKMSpy1BLnD5mU6Yo	1406	1393	404	12463	14186	jxdCZRedcsXsn6yw7DvDUZrhuh4FafHMNkG3tdAgMdso5Dwc9vK	11023	15518	15518	1618732440000	canonical
22044	3NLhRmfGyK54ZFR2xY29BacJmfZCpgynMjj7BPcCMbBoHd61RNtj	22043	3NLZbvKDeAQ3Q7AeBi6NH8t4djapzGUXYEaD6SpkBmjKTqjDuqbg	700	840	404	12463	14187	jwxcHx3dU7FqMaFrceHodrbz6GhJRkypPr3rY3riLpRpog1z7Sb	11024	15522	15522	1618733160000	orphaned
22048	3NK5zmWPtoVbxKpKCCeJW4nxmhE8yweD1ucPF2PDoR5Am867a6pY	22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	1601	1262	404	12463	14191	jwe49gW82EoMR3WTi4bC3fK9Jgr9pVc2e8y66kPZ4zt4d9xUpjk	11025	15523	15523	1618733340000	orphaned
22054	3NL1TjSAozerckbpoasFqU3TNb9htLXALAjkSQZvwNDTBP5RZzfm	22053	3NKxb7w8tksto3y5tLrPW1a6ZMTY51wuLpkHK2dDQEVobwFNxmto	532	937	405	12463	14195	jxwJZBv8nvH9UbtzJuQyBXqtvD9Hi59baCWrDtAdbNAfykYzSs1	11028	15526	15526	1618733880000	orphaned
22059	3NKTzokvUGaq8JqkwjmDZqp6t3AWL4axN28boTPnev1iiWxWYuk7	22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	1594	1200	405	12463	14200	jwFQxi2cmG2u3UfysAPQ1Z9HFkwKMU6H5TvViMpn9YnN83wk81d	11030	15528	15528	1618734240000	canonical
22064	3NLrqNvLSSJKkidZVjgcfwaKY1MrDSNTjGTpsZgBjqRZ9ZKLVa72	22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	1637	816	405	12463	14205	jwci1ykwv2rXbNcPdE5vr8FN4adXMfdjVXcHSRh7YYo3zUfCC3R	11032	15532	15532	1618734960000	orphaned
22066	3NL3CpWNiPmtK551t3LD2DEbYYen97PunMkJBASTGuu4bjhdVxpu	22065	3NLqy7KduwjGaubYMvREGbAActxBFPCTDkLAVrSEcTfYhKitQTZV	1587	1111	405	12463	14207	jxnD8uddwtJfqyNUBjfGnpJXXYzpeorC3sUPfCLsCRKNBB43vAu	11034	15534	15534	1618735320000	canonical
22069	3NLMXvxm8dNtREax7ULGKEpmvhdyEMe4Zp4oGMTqAiZA5XUh7Bdu	22066	3NL3CpWNiPmtK551t3LD2DEbYYen97PunMkJBASTGuu4bjhdVxpu	1534	574	405	12463	14209	jwnwVLbndak4Pdd4ismh4LjhFw3obkguUkDG5t35a3WzSFMhgCg	11035	15536	15536	1618735680000	orphaned
27882	3NL6zgiStznpxKTxconX5S9YLvzkznaJ5iifh9UpoBv6QT6EbMuJ	27567	3NLEEfFZRJdtdC6Takha6pjqRSTubzgCJqycqnkB3oRxnwnQhWx6	1654	1094	537	12463	18974	jwDoDzGFdA9FTJzSPa7y914q5JZd71dNxTcFHZNNwC2ppNQDLs6	13626	19422	19422	1619435160000	orphaned
22024	3NLuiTew7c24JS1Grc9Ygh7gssraUyyD7ttGcvhcwbx43kJ4Ekgu	22023	3NK5S5ufdAQnKsvAuboAHyvHogZXEM8SSg8fku8YLzgLaXT1GCcm	1440	1011	404	12463	14167	jwq1GeziftPPDmTUS92xawTgbCSXZryzF3DuiMPj3sg9pgWKM4A	11011	15502	15502	1618729560000	canonical
22029	3NLgEMTVB8T6tUcwjXTr7wvmQwUfunF9euXi2icJ7BFzzN6tmUHp	22027	3NLiPGZz7W1ubmMTa6zibegJwYrerNmKBLVSfn7tzUPmisR5TRQN	484	1193	404	12463	14172	jwkasyyFHrXcKT8DWHjng3VuMhMPLyF8FnNMPg3SzVsd6oX68AW	11014	15505	15505	1618730100000	canonical
22034	3NLUCL8XChdzHygcnbmEAJiJFQp2hFJzfpRrrujn3aDkCNL9wCJy	22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	1631	794	404	12463	14177	jxLzUHLLx5NZGZi3wCSY6efiwtjrNWWvSX5xecsAzcLGCmV1pni	11016	15509	15509	1618730820000	canonical
22032	3NLgrtyngw6yJa5NFwr2UhNtbTcikpciSjTjRoGTxfDFYw4f4h15	22031	3NLYAujVU4tHd3W4e8VMqCQqPhC7rfPbvR5sUkuGktR3eDLtcML3	1406	1393	404	12463	14175	jwPAiGSXjV8ZhpSmwhLs5Z6FtwHAyw9bL3H4BFNZHVR3K2YJhuC	11016	15509	15509	1618730820000	orphaned
22039	3NLsnS45rKMQP5xp2uczDYrFWaHSuqyD7hx1oy7xVjXfxQnBJndY	22038	3NLwJqdgVizc1FCeXsogLqRawbqaf2WK7JUN15bMctX1mE9uM8py	1406	1393	404	12463	14182	jxbaPLxtZknUCwCMUdVXxydPamwcs1CCb7HGPvcWZA6QahXV6LT	11020	15515	15515	1618731900000	canonical
22042	3NKmSboToWQU76FKzJXfC1XuA4myCEq3g5zHWkAV9XYV64D2wiFS	22040	3NKFxhYNcHSHwgaxFEKQuam2WmfVdDxhnSUjkLK9CVnmNcJpoFBR	1553	775	404	12463	14185	jxtCDKTRHHjhE1zXur6fCHzaGUPZcVb2yMrLfZatHF9HtQ14Moe	11022	15517	15517	1618732260000	orphaned
22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	22043	3NLZbvKDeAQ3Q7AeBi6NH8t4djapzGUXYEaD6SpkBmjKTqjDuqbg	1581	778	404	12463	14188	jxnSTueZkGLpi37DDrfc26A7jpJU1NCRk8i4Mg7Cftm964tYuLC	11024	15522	15522	1618733160000	canonical
22047	3NLp5374KttN1vuRzFiFpwwfnrRQ4r7ZhnSxAnm3whwPHyw4BRbd	22045	3NLSLyjAXR1S5EaLYvKwTceMgb19S1WzMWXpTrwHBYi4YpHct98i	1403	786	404	12463	14190	jwvymqRxAetJe7ycFJt1Aj9XyULPRzPmDYroWhukDNtXiwmwZMF	11025	15523	15523	1618733340000	orphaned
22049	3NLHafsP9ay8AsH2ftvxfvGRQa1jeqBjdttiHXP3dGDjvCvoUsbn	22046	3NL4H8fRLGuHTXJ1Xpmo4PagcWmQPbAm22KSb5NS78ijAeEPbRCF	1503	1151	405	12463	14192	jwCAc14do5YaQNeCCEZCKEfAYq22mWYkBZaRA4WSL449rGvPQsB	11026	15524	15524	1618733520000	orphaned
22053	3NKxb7w8tksto3y5tLrPW1a6ZMTY51wuLpkHK2dDQEVobwFNxmto	22052	3NLY4xqRM9bj29RMGPG7YgAoiBxtPTyi9QXehxhcsPobWXu36eyy	1623	830	405	12463	14194	jxFeFaXmtCnNKw1jT65uYn7ZUYohjNymepRUk1W4YmFtH3fDiGt	11027	15525	15525	1618733700000	canonical
22086	3NLB1xogpehJie1MpjBngYtRsZo3t5QA89Ubw2BfQA98xSpu7Dm5	22082	3NLj69q9bnxe8Mr56kg8ehWfqNqkmfT48hQKSfx3v17KXd9DWb6V	1553	776	405	12463	14222	jxRr8j9HGui9RqyG3ZmM7mnPxtR82rCdZ6ne2Lknue2frC9Ph9c	11028	15545	15545	1618737300000	orphaned
22112	3NKrf5ddtKjruWFW9sQWna9gg9acdWfN1AR3pqx3SFozkFFN4LDf	22086	3NLB1xogpehJie1MpjBngYtRsZo3t5QA89Ubw2BfQA98xSpu7Dm5	1553	776	405	12463	14248	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11029	15569	15569	1618741620000	orphaned
22058	3NKt7NXFYHVb4xRKpyxPAesBFyVcfqBiURiVkBf7obEmQey4nLpj	22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	1407	1395	405	12463	14199	jwV5Ccz8HznU3RWMDh1L3JSFVihKt3zhUd5QFpku5WNsdPGNNhJ	11030	15528	15528	1618734240000	orphaned
22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	22059	3NKTzokvUGaq8JqkwjmDZqp6t3AWL4axN28boTPnev1iiWxWYuk7	1656	1343	405	12463	14202	jwnMcVaFMBfYMBM2VWGKJLWP2gjq1GjnRcqyL4AjNT2QNWXHzmv	11031	15531	15531	1618734780000	canonical
22063	3NL5j4kivr8kz1y1r2YJCNPqUPuQNAnKxpRCmkeonAjgTUsDSa2H	22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	1403	823	405	12463	14204	jwvjnKVHxqqSUSVRnd7SNWDvufTnc1P4PAcogqkiqziLitPBVja	11032	15532	15532	1618734960000	canonical
22065	3NLqy7KduwjGaubYMvREGbAActxBFPCTDkLAVrSEcTfYhKitQTZV	22063	3NL5j4kivr8kz1y1r2YJCNPqUPuQNAnKxpRCmkeonAjgTUsDSa2H	1405	867	405	12463	14206	jxmT698UH8iJesiaJ3g63SVCePw6HQDeXMXE2ToPJCJYQeZ7mt3	11033	15533	15533	1618735140000	canonical
22068	3NKtRNZcUuN4zqJ3nAAZJWnqXpgUnVTxj3FyEu8cLXjRBCeRhET6	22066	3NL3CpWNiPmtK551t3LD2DEbYYen97PunMkJBASTGuu4bjhdVxpu	1405	867	405	12463	14208	jwpHa4tLqtrjBtmdLhn6sDXMSJrAcF6nH9T1zyFB7S9H5HA88ik	11035	15536	15536	1618735680000	canonical
22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	22068	3NKtRNZcUuN4zqJ3nAAZJWnqXpgUnVTxj3FyEu8cLXjRBCeRhET6	43	1184	405	12463	14210	jwvsL5xMNuF6eHzopbri6PFocrnQR64CuZLbZUr5PPN9fTMDNQB	11036	15537	15537	1618735860000	canonical
22072	3NLqHczR4pzZX5uKEDC4SsFt7nsvJzvnUYWZdxR868FkQewBEJUp	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1406	1393	405	12463	14212	jwmm7qjkT2mP4vT5vMzVQYzTQo4AtykzA4yY7LPszQJsdL9Dzqg	11037	15538	15538	1618736040000	orphaned
22075	3NKTzQRNbEDcxKVYuGDQTL6hSzNDFNrv5mQLnNH3JQvoJ56Lmwwn	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1523	1195	405	12463	14213	jw8yZ7CYYQ5aTsnTdzihUUS8xCg3ZRxmC6u1EdSvBuCquzQW4hK	11037	15538	15538	1618736040000	orphaned
22079	3NKBH6Ah9QAewDvoFb7ikwa5VrtCpgZ6jgbFvEnixCvaFbXBTd3B	22077	3NLWsZMQkiR4jaLyyoVisfPZ9dsKi2ceHFt7ZbtnvqDUpabo1cTH	1646	1354	405	12463	14216	jxsv5HDmpgSxRpfsAFXWSUMXPNPpYUibGJBfwiDWt9sKycUP8qS	11039	15541	15541	1618736580000	canonical
22084	3NKvi1MKb6NBBunXvWrLNwwySQ183FMpcMED3J7LABGLDjUvcT9j	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1613	1349	405	12463	14220	jwUeGr57DEw5TZWdWCJ8Zf5aEuAfsJh87P9ZYxuS38pdH2XWdVQ	11042	15545	15545	1618737300000	orphaned
22088	3NLYzd6rZnkmoEbxuPMhS51jnVgfNtvfmZDMmLSsHD1uzU9pvhVq	22087	3NL3arfJET2o5fZqiG7nofdy9TfxohdDsV5cWDpHGZco9TeVdWeM	1406	1393	405	12463	14224	jwkSJF1BdgsxfTDqMdPNzWEtR6AoTejs9itz43evTNBX7nVeX2w	11043	15546	15546	1618737480000	canonical
22096	3NKniRuUb2hdwXcxT7vU8JkUwTr3XYtp3UmYaffnUGJofepqgku8	22095	3NLQJMPJYbbrxD8Tu7vJE6zKybaJTZCiXdLGus21ddKVeW34RvWY	1542	1058	406	12463	14232	jwD4bKPZERjddzZJ6rPwbCDm7eaw7htm9SWYJuDhAj3zAmt3zrn	11048	15554	15554	1618738920000	canonical
22101	3NKYTJbV93hutDMn5pLzCc28HwcdZi6PNvvddaZZM7ixeqDU3e69	22099	3NLdHHLYugudL5GrtP7fr6djecvYSNmtB9D7UsZeYG37mVcSuKXG	1546	973	406	12463	14237	jxS67ga1PJFnMWgiJdAnwF1VjDRrWAv1pt2mHzvEUXbAX7ZQU3C	11051	15558	15558	1618739640000	canonical
22105	3NKvS1udRHrXXDgYoaDai24VBQ5rTLCgY1BU7SV5nhn7qXF9DJ91	22104	3NKavUHRa433qqpqPpJyFkzSiYShymXyZ3soUQHwaAPDmccikadq	1403	824	406	12463	14241	jwL1NP7NV1FMRDBhm8FngFN5srgYBYxRSN3HunqqnAqb6Y6rp1U	11055	15565	15565	1618740900000	orphaned
22114	3NKJ8V2H67zySHYoRDreW53GNNGLor7aBzEBM4iYBPDNHhLEmwsJ	22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	1542	1304	406	12463	14249	jwB34riFoCvdaKi4DFcnR1VoCWEesqFqFS74HMRpjPkKXXQdweq	11059	15570	15570	1618741800000	orphaned
22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	22116	3NL4UHWapG4Byi9QYskeXLHhQQdUn1XAybDXbR1vqDeaf3tdm53Q	1474	1329	406	12463	14252	jw7jf8ojv5v8WDhRCKyN84jLHgWCKhLVtNzgRbx9CwBVHx5YTj9	11061	15574	15574	1618742520000	canonical
22120	3NLjdxf3CcYeCP5aB2X2wLgPMbF6vzk5EKxNhaSPhmzgXRa6knw6	22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	1503	1031	406	12463	14253	jxi3bjR9ygyxzKNSd9qt5TXrWiUakribpHF2Q9XFBA1e6FLM14E	11062	15576	15576	1618742880000	canonical
28050	3NKnW7hMAyKaL21Uqct3pm7ppUzkqTHvcpu9LLSvDiLNH6wXZ6Qm	27882	3NL6zgiStznpxKTxconX5S9YLvzkznaJ5iifh9UpoBv6QT6EbMuJ	1654	974	537	12463	18974	jxdMeLG5CtfmGTMYsFNa8R2qdDHbtEgtTReCACGscKsogJ53sWQ	13627	19553	19553	1619458740000	orphaned
22057	3NKc8gnJ5xQgG1ccB185j6TbHkrZxRqohDZEyqokVF2GWnwaDCX7	22055	3NLavmfFrhFbFz6mCBvM6VF13gXUdDScMQx1F1PEGdGemriEayaP	1631	794	405	12463	14198	jxbpP5n4uXKimam2qfCzZNEPojDXyqyRcU6wgNp8Z7YinDw1Lwa	11029	15527	15527	1618734060000	canonical
22062	3NKsgsoVeDcArXPW2ZeTV8QBLBdivSttp5TUz2g69c1wWZ1oS6em	22061	3NL26r3zKUCoNFNzYjfz75i4g8VA8VRjfQyQrX9PcK1gwjwFfSi6	1407	1395	405	12463	14203	jxfqUHc19gUu6cwfo6zejEUuR4DLmxWL1AXpYtGfDKZrsExVC7g	11032	15532	15532	1618734960000	orphaned
22067	3NKSvsc2sJAibPWRf85yoRRD9E29ovucKCcHUAuQigDytjYc8jRz	22065	3NLqy7KduwjGaubYMvREGbAActxBFPCTDkLAVrSEcTfYhKitQTZV	1587	1111	405	12463	14207	jw825u8mMQ6hd3dzAr1WQ5pAYaLjoYYz1jxejcb7WACbT6CV9NX	11034	15534	15534	1618735320000	orphaned
22076	3NKMNmDmuZx7EHNxWvAy2UAH7UtAyLDXekVMnkciCLMcWETQZnR4	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1673	1002	405	12463	14214	jweAaXU8nEy4sLtbfJwYoXXB22BXRAu8sJKxTfSsxCC7nh1PNaL	11037	15538	15538	1618736040000	canonical
22074	3NLBba7CXbPXnyYe4q933rnMK1nmTy84gnDAKnkgAQnwiWwhkx4r	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1523	1195	405	12463	14213	jxT8hNpaoBw1BEzoJgNEm9AZQ9F6rqHf5ga8awzk6g44XQy16XR	11037	15538	15538	1618736040000	orphaned
22077	3NLWsZMQkiR4jaLyyoVisfPZ9dsKi2ceHFt7ZbtnvqDUpabo1cTH	22076	3NKMNmDmuZx7EHNxWvAy2UAH7UtAyLDXekVMnkciCLMcWETQZnR4	1637	816	405	12463	14215	jx5a37e3cZ7PQ29WvA3eHXzUjnQ552pSDrbHMB9k1iF6FD4xEus	11038	15540	15540	1618736400000	canonical
22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	22080	3NKyZsfniwPakq8Qh7i9xzoHWMFubyX9W5pZYf1xC7W4b6kAeBe7	1403	31	405	12463	14218	jxu1pdCGZMJYB6YhGjJ51Pq2hutuvLFbNZrtcZvQ5ifoDWK6KrV	11041	15543	15543	1618736940000	canonical
22091	3NLrUsPYDrKDtqQs3V5pdSMwSymbwuao79gB9FjcurJzgrLhmpam	22088	3NLYzd6rZnkmoEbxuPMhS51jnVgfNtvfmZDMmLSsHD1uzU9pvhVq	1555	1101	405	12463	14227	jxBvocTYJ3aaVWhPs2zRF8sbhQyUWxvrGuXLQiixC5PJfHaDhyM	11044	15547	15547	1618737660000	canonical
22092	3NLHVRzmSNs9YXnRMTrZVzeS6B6GWpicyaGvwe2Nrh2XRSEoUCvW	22091	3NLrUsPYDrKDtqQs3V5pdSMwSymbwuao79gB9FjcurJzgrLhmpam	1579	1389	405	12463	14228	jwqG48GCiapdXxDuttDnvo6SHAEMF5qmV71GTJ2vZYV3CsKrzUd	11045	15551	15551	1618738380000	canonical
22093	3NLSobSK2E88aU7bqQgLEfPjs7Cjh4NEUGuEvwknhJmcoeiuQigt	22092	3NLHVRzmSNs9YXnRMTrZVzeS6B6GWpicyaGvwe2Nrh2XRSEoUCvW	1607	982	406	12463	14229	jxpuVpkUaRqKadvE5PbSeqr1VLc6ufvVFaRa6qkykYwqNVMTmtf	11046	15552	15552	1618738560000	canonical
22094	3NLC3NL2wn8ZE7oT3hgYDL7yT2ypWANsWNhHndGAAKandP7XxZZh	22092	3NLHVRzmSNs9YXnRMTrZVzeS6B6GWpicyaGvwe2Nrh2XRSEoUCvW	1637	816	406	12463	14230	jx5cJWn27YrUdQFdQpSY1Pu1g2JR1efpi2YrkWjVcrTg8AauZRd	11046	15552	15552	1618738560000	orphaned
22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	22096	3NKniRuUb2hdwXcxT7vU8JkUwTr3XYtp3UmYaffnUGJofepqgku8	1458	1323	406	12463	14233	jwEP637chjTe5Scfo9uSHkswj9YjvRyjBQ3D6NY64jVvKpVdUVs	11049	15555	15555	1618739100000	canonical
22099	3NLdHHLYugudL5GrtP7fr6djecvYSNmtB9D7UsZeYG37mVcSuKXG	22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	700	840	406	12463	14235	jxRwG9FMX7kXNTRfiJRxmeawWo2XJ2USA8UxJ2MDcocApz3smCu	11050	15557	15557	1618739460000	canonical
22100	3NKLZBysr1RAcDvrkEKYFHCrqGeJQTVR1BuMYbFMJcJ1w4Tm1GFZ	22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	676	676	406	12463	14236	jwPSZeadaMLnyhQo5sovL3xJTt1ywtqPdhGmoqeLPbQ8kK8exkB	11050	15557	15557	1618739460000	orphaned
22102	3NKmHQp6fGQD1vRCSMBWi8PfuDgd5h4SdYNseS5ky4KNaHdEFYHM	22101	3NKYTJbV93hutDMn5pLzCc28HwcdZi6PNvvddaZZM7ixeqDU3e69	1637	816	406	12463	14238	jxCX2cAEup8NDKvGz2PPp73d1Xr6S187k2EfDrL1FjaAaL5HEVb	11052	15559	15559	1618739820000	canonical
22104	3NKavUHRa433qqpqPpJyFkzSiYShymXyZ3soUQHwaAPDmccikadq	22103	3NLst8tdqE3PzZo9VcNo4dpks7yAgnPTv7HDeQ7rcZx1YfMa9w2G	1593	1100	406	12463	14240	jxDud6yEvu9UyNZxSetExvMPLi8zn8YBV9n7yCk6NdoDBEzuaVY	11054	15564	15564	1618740720000	canonical
22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	22106	3NL3XsihsNvjzM9Ss1z9CqdUzzJ5tqFf8S7grDGYddHA9BF5pApG	1501	1114	406	12463	14243	jxmgk7ynABDvANd8UfNP8HEn64FjxNTDf6rtuPAxE2FQVNrPeYj	11056	15567	15567	1618741260000	canonical
22110	3NLM8QpEt9sw762omGZFFox5SeM5RDag7hLWnwqt8HrB39AQ8yz3	22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	1549	1362	406	12463	14246	jxvhEKmGEUGuozy5Ru5RtJUYszmhpz4rBvGpY1HohV5s2NYnRPN	11057	15568	15568	1618741440000	canonical
22108	3NKVN1jSK1KErZbb2uhd12nopmmBi6uBjABnwrSQVCoBo9L9DnTE	22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	1407	1395	406	12463	14244	jwA6363gEsYRSiR1YaKLSxtSAjUyaKh7ZWH8EgAABevZxrpJRV7	11057	15568	15568	1618741440000	orphaned
22116	3NL4UHWapG4Byi9QYskeXLHhQQdUn1XAybDXbR1vqDeaf3tdm53Q	22113	3NLnspbBXp1yHvMscQdW4dB9Gxh3TAmpxsBFKsHLSNxPhVVcXuSV	1407	1395	406	12463	14251	jxP5ftxrhuazgmu3xRrJryra6trtxhfAzzxh25hNMD9DoVzCMEU	11060	15571	15571	1618741980000	canonical
22118	3NKtpku1dkamJfwVg3Cn2Aumx4GSo4P48x87v7TpnVXaMffhs1hC	22117	3NKKtz4s4QuCsHra8YZTdyRa3y5jsiWBF4PrYYVrJqTzzmE1YHAf	1503	1031	406	12463	14253	jxi3bjR9ygyxzKNSd9qt5TXrWiUakribpHF2Q9XFBA1e6FLM14E	11062	15576	15576	1618742880000	orphaned
22123	3NKcr3jEvQ1GHdRYBo8mMsjKbUvsjqiPJ8WwNYae32MF5vqK2deo	22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	1407	1395	407	12463	14256	jxok2to5GwYcbuN3m2KHcEALDLe1MTgtg6t789qCNn9o55sVUso	11065	15579	15579	1618743420000	orphaned
22125	3NLNeXcNtd37ZjSpTbsYjNoWMSmKAexkAusV8EJTcdio9a4R4uzC	22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	1457	1145	407	12463	14258	jwZskNQHLX4yn2jmFe3t7KyVkVREwv4V3mMpJCk4367hMHrVE3X	11065	15579	15579	1618743420000	orphaned
22126	3NL7H3VBfDam2DtcXyMLibfEx1ohyqqBpfSh4d4e7kSU49sE6bPD	22124	3NKmjf72fzaK4v8udBoLPaXfcW7UZvkZ1xYFEETUMCkN9wM36Z2d	1432	109	407	12463	14259	jxyxn5KLkvpBKAH4PPM5Wv85EBreqsXRWNp2hjhQ7qj71D5RE2s	11066	15580	15580	1618743600000	canonical
22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	1559	1353	407	12463	14264	jwdVaAwQaRvoU1fNFmwwj9y5Nqr1joeiLsBtrdus1AKjp1Q8mWq	11070	15586	15586	1618744680000	canonical
22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	22138	3NLqke11Q51emhSH9Fi1sAu7LARckvQTaofpzYWYZZfz6eEdxeEn	1610	467	407	12463	14270	jwWqoDeoyQ9bXdqAF8PbkXbp3Ci2QvyaHT32uBKPrv6BsQs2RGN	11074	15593	15593	1618745940000	canonical
22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	1636	140	407	12463	14273	jxSWT3jtDy6eZZvPrRp3wJyYi7K1Drn8e3d8cEXvB2L4hiHaDYA	11075	15594	15594	1618746120000	canonical
22145	3NLK329hcgGvaetDjMXgq6BMUMUQcA9Th89E9Cmw8gryuujZ43Zr	22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	1426	998	407	12463	14276	jxgwguTcwRmPPBwYUd4m6jy7fjBGb3GRoKbEreBMK5y6BfGGBLY	11076	15596	15596	1618746480000	orphaned
22146	3NLeYuRpoeYuZeXLdwUEDcENxcqKoUymewSLM9Az3rAsPwkw9uKT	22144	3NLazNGdkDiKpGVC8HV35ArDFP3mrk4ScK3KNiY6hxarj3hnFtqi	1406	1393	407	12463	14277	jxMdy65W2c6ZCLhU3PE9yxRvxGahzwLkXatsCdzzyv2iTF2qRRz	11077	15597	15597	1618746660000	canonical
28073	3NKZ7maZtwXnCULznN1Ljos8iENuddc9bWy6VeQ48ptRKNvSSqC4	28036	3NKqjiASLo76sqtv9edRwMgwFujTh7u9tSqyaWLAEK9eshYkTBE5	1564	1092	538	12463	18974	jwtches28tYeScseFadAahDueS8cyonk1eDV9Pa6HkqTVZYso4o	13639	19567	19567	1619461260000	orphaned
22156	3NLGV5wtFgoituCLJME3KnSrBZbEfmgzVueyTqwoi6LzyESgHFrc	22112	3NKrf5ddtKjruWFW9sQWna9gg9acdWfN1AR3pqx3SFozkFFN4LDf	1553	776	405	12463	14286	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11030	15605	15605	1618748100000	orphaned
22073	3NKx1uCBE94e1rwRV4DUkPr6sF8hcH6NhyseGyBMMnxnFbjmpMGA	22070	3NKMVrM6u4S8KZWAGRUYAmWkn7BstFteXZn4k8Y2jttLoXigUV5G	1523	1195	405	12463	14213	jx3bNWjjCpYxi4qxWTwkGm7e3q7yd1nXfnfSvHmNpaDdjntocTJ	11037	15538	15538	1618736040000	orphaned
22078	3NL1H6BvhCw1W8BCB16kJgSeHajvVNXDy9sSHujxD2AmbeNeggWJ	22077	3NLWsZMQkiR4jaLyyoVisfPZ9dsKi2ceHFt7ZbtnvqDUpabo1cTH	1646	1354	405	12463	14216	jxxrkzfQRVYsg1SkG5wvwQ7tJqWMTMdQ8ZBfhvuY5Q1q6EMxZgh	11039	15541	15541	1618736580000	orphaned
22080	3NKyZsfniwPakq8Qh7i9xzoHWMFubyX9W5pZYf1xC7W4b6kAeBe7	22079	3NKBH6Ah9QAewDvoFb7ikwa5VrtCpgZ6jgbFvEnixCvaFbXBTd3B	1407	1395	405	12463	14217	jwKMChZNJRkuRkWew2fmSBnPUgHLc7YXgda93uqyFpCouZpP7zP	11040	15542	15542	1618736760000	canonical
22087	3NL3arfJET2o5fZqiG7nofdy9TfxohdDsV5cWDpHGZco9TeVdWeM	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1474	1329	405	12463	14223	jxT8jpAEBumbBJ4iSxEmeRbeRZxQTSXiXANdynV6iebp1ZVKCoA	11042	15545	15545	1618737300000	canonical
22083	3NKZEm6x5Qcs1yHXmZYLiXfJ42nTcS6ujUdZkP1syfdcCBMjzavP	22081	3NK87Hhtk3CKLJawwDJhoH5Xhnt6Hs6f5EXRv9i3CW3PNVJSv8ha	1613	1349	405	12463	14220	jwgu88ymd574vL9wCXBUQAT2jgriX433v8R4xtPQbbLZG3nLQH7	11042	15545	15545	1618737300000	orphaned
22089	3NKqYvfjZBc34r9CiPLEY1kqBQXo5xkVYzxzTGYmyurPxuXhUqLo	22087	3NL3arfJET2o5fZqiG7nofdy9TfxohdDsV5cWDpHGZco9TeVdWeM	1631	794	405	12463	14225	jwmoUDL97vTmoWDA7xQK8pAEyGoRTKXnZP2aF55Bh8J5TRR4scf	11043	15546	15546	1618737480000	orphaned
22095	3NLQJMPJYbbrxD8Tu7vJE6zKybaJTZCiXdLGus21ddKVeW34RvWY	22093	3NLSobSK2E88aU7bqQgLEfPjs7Cjh4NEUGuEvwknhJmcoeiuQigt	1406	1393	406	12463	14231	jx9tNMKTwudgoPgSwMaDz4sP7TKzGnabbC4p1yeJaDD2F5kS6q4	11047	15553	15553	1618738740000	canonical
22098	3NKb2aGwWSGKRq8SpG3nFdWvUJJ1V8ovQP4DboDD25XG1v4Mpb1k	22097	3NLcmr4tmv4jCEqYaENgzurThKz9Nb5323QSeNRjsoHistTx9wYS	1610	1314	406	12463	14234	jwv8tpxmUAgswFG4rSZ2wVkfmK5GKkjb1MFteMk9aPgBqMNmd3d	11050	15557	15557	1618739460000	orphaned
22103	3NLst8tdqE3PzZo9VcNo4dpks7yAgnPTv7HDeQ7rcZx1YfMa9w2G	22102	3NKmHQp6fGQD1vRCSMBWi8PfuDgd5h4SdYNseS5ky4KNaHdEFYHM	1509	954	406	12463	14239	jwMgVCoKQg46zgyjiCN9Q65KgTnoZSxahPdvEMG5fZMHiXKTyxD	11053	15562	15562	1618740360000	canonical
22106	3NL3XsihsNvjzM9Ss1z9CqdUzzJ5tqFf8S7grDGYddHA9BF5pApG	22104	3NKavUHRa433qqpqPpJyFkzSiYShymXyZ3soUQHwaAPDmccikadq	1509	1320	406	12463	14242	jwC6aEFRwFbxMEo8LLpkJ9xD3sD6AcDmHv98FuMRn2hiMUEsfnK	11055	15565	15565	1618740900000	canonical
22109	3NLMozLAP3cqoqnwxxDRptRSse29k7H3GCnACTzTTJAnaX7DJarf	22107	3NK7s3RYhZKg71e2pcszJAqFtYFy2cb72nw8bM3q8UDsz771a1tJ	1501	1360	406	12463	14245	jwwWfN5M47QdfzXRK5MyNLjrswrvDZvZd6f9bJbPtnxH73ANBuj	11057	15568	15568	1618741440000	orphaned
22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	22110	3NLM8QpEt9sw762omGZFFox5SeM5RDag7hLWnwqt8HrB39AQ8yz3	1405	867	406	12463	14247	jwWLAJiXYxaVfTaiBNiTvzNQZtyhEoBpnhJMDCSbJhZdAvuvCSP	11058	15569	15569	1618741620000	canonical
22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	22128	3NLAw17fUmxtPtd5NakrQBWXsmj37QTqzB9HKgE2agv6WFv5t8Nu	1631	794	407	12463	14262	jwqWGiV3vUJcc2pUvat8GjT33DNqRjiZtyASDkrMpKzYAZbnyn8	11069	15584	15584	1618744320000	canonical
22132	3NKviuJ2qoSbQh6g7qC9KHEyAZ7wQE6s8zi27BAeXJJ7gEQqbGZ7	22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	1634	1205	407	12463	14265	jxvMDRpCigKjZmXfGciUzSCm8xUDkW69f4Mk5715BN3kjvnSLp4	11070	15586	15586	1618744680000	orphaned
22135	3NLFxPaTDGFNSEr7zrs8toLbctfw4PGKkt8JpdDbzfb3rAxsPr61	22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	1523	1321	407	12463	14267	jwj3zNBaozC3ocMzDHcRmDZJJn52dKFytv6Cek5XH4WhmCvSS8h	11071	15587	15587	1618744860000	orphaned
22137	3NKeTFjFJkDpT6obmT1Ff1SKRpRTErqTxwYJ9rr9mzZav6yPgcvy	22134	3NLXot8YVQC967AtxomkmQs45r75whQM3XF5AToxYSBnE4CQrnPW	641	1336	407	12463	14268	jwY5aAzp6xJnZrbJ4XJAV8VR2CWCEDBQ9nVYPWYhxDUwxjFgxBR	11072	15590	15590	1618745400000	canonical
22141	3NLhj21sk8UPW2LAa8SCxw7JDUjFnS8tvAEBuuVa2SnbM4Zps9Dn	22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	1426	998	407	12463	14272	jwyHxFu5oqKQMukeKFEn14Luatw8QDtSF18KxgoewvEah94zbym	11075	15596	15596	1618746480000	orphaned
22147	3NLLwWNhLVkvcTJ6yhtnoyoSpAzB1nSoavFpjgGPSMPBgvG1AeJP	22146	3NLeYuRpoeYuZeXLdwUEDcENxcqKoUymewSLM9Az3rAsPwkw9uKT	1501	1360	407	12463	14278	jxkt24v8jH56GpH4ACamTkskbxkzYXjJUwjaF1VEj2yNobobs6p	11078	15598	15598	1618746840000	canonical
22150	3NKL9RxDdsjKN37rkrp2KWxDCwhy92GNWn6396Y1nCEQouKPCLH2	22149	3NL5Tii8LD277dw1pyNsshyrMkfCGemvdSrHXzoNBnQuUbp3ai5B	1460	1324	407	12463	14281	jwMCZLdoEVEveQrJPPjiMjWJmNqaW92cYBzE2YRg4gQK7XPnfx3	11081	15602	15602	1618747560000	canonical
22154	3NLdNysP1Bt3u1mKLC13vLGn7yZgb3N1LYhcRKi7xTeQvTEFhjFX	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1615	459	408	12463	14285	jy1qk37u4gzFSaFrmrSxkQLpUbVnbgpGGVx161BSSMdpgSALxM2	11083	15605	15605	1618748100000	orphaned
22160	3NLj2oFpZQXRd4H32WUGamk41XBPgfdS5Xk1EKmEoFuxU43uGVAa	22158	3NKvhkHUuDV9nCRomu3KcHtyDeur2232Y35WphXQJ6XCsspQ2F1R	1637	816	408	12463	14289	jwh4gLyNuoeQ7TsMYju71pTcWjHVxQr5zQNKd3GytUSADoAvMCq	11085	15607	15607	1618748460000	orphaned
22162	3NLWC3QXoDGLMf1m8K5Jv54fNT3YL6VUGAFA2u9Seq6Qh2gX3vnc	22159	3NKNHtthKZNvoo2JkgS9u1yjSeqik3vfx5kFA1bgh4jCC7muxDGK	1637	816	408	12463	14291	jwqjrwkZEkEK5zSHMBhDHrkgz8HtcSwrqgaKhBYLp4EWRyku4bH	11086	15608	15608	1618748640000	orphaned
22166	3NKhd5yfmAtqQDWB68yU75L9e7Rtio7j6EzM644Fn28eNdQZLQhd	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1405	855	408	12463	14295	jwGgqY9hvq44e5XZXMVU6m65vcaegM55wtizpbyAjydc8esYKzJ	11088	15610	15610	1618749000000	canonical
22171	3NKsuh6rGs3Hj5hBqyKs6PLJqdKCMNBrt1xZg4nqghW5zoL671Do	22170	3NKWrJvsQnGem66ZupQPsnjcNk1ZKU5Kif9L5XGLNpySTsSB8Qo2	563	1359	408	12463	14300	jwhxTyXkMW9yAPLyePpyPXP36mnehSXaVnN66vha24QBcZrL4vc	11091	15613	15613	1618749540000	canonical
22174	3NLQ8F4zzEpBvWWupF5EyxpY3x9su1bBJrLvcUxYm5XzsNyBuh4c	22173	3NLrmXUK4dFWhQwi73YGXQY5tsdypcRvZC7xKw2CGpZAmgfJ2mSy	484	1193	408	12463	14303	jwHoJMMdHydcQ37WAqhnaELCKNgdzAxNB8Jqexjm25AWThkHF4c	11094	15617	15617	1618750260000	canonical
22176	3NL9qBu2n9ADyrFXr9qRL9Rro7jDpBVrrszFEo6kaocPnx2f1f6E	22174	3NLQ8F4zzEpBvWWupF5EyxpY3x9su1bBJrLvcUxYm5XzsNyBuh4c	1455	1332	408	12463	14305	jwDKDZzLxeby5fpJounYqePLtqDLmX9HufV4xECiXBi7KRzQgoE	11095	15618	15618	1618750440000	canonical
22182	3NKEDgL7BZNw1F38LMRUkeDuQLpzdQRPjDCkVDhhDipME54f2tKU	22181	3NKec9TQrPYxRR5nrbXiFiCTCBHffatSbMoVvRjep4W5b1GMR9i1	1403	824	408	12463	14311	jx5Ek5J7yKhSzWZ6ma3i2cT3CC73bHKg7GToBpYaawfXfwiySaB	11100	15626	15626	1618751880000	canonical
22187	3NKLYn93sp5K7bnJLaDXtruJHjikem4pou9na9SMuEta4kSELSsF	22186	3NLhE2J5UNbVut6JJphzSweUqi4mMrkUDKSQpHceyUniczB2yvim	1406	1393	409	12463	14316	jwUrJsosdJwXRGuwEeNvenudTLZMxvJU6neNPUJ8vArhfCmonEL	11103	15630	15630	1618752600000	canonical
27601	3NK5uK5hhrR89LTmALfqTo4orjBrGh4zSZWPAhtofW8ghbMWenLe	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	1445	1290	537	12463	18974	jxjtCVCFoSH2DJ7t7q73tdjJYNhQ4ZtEvAxnDbcJh2vEK1tzevh	13641	19209	19209	1619396820000	orphaned
22113	3NLnspbBXp1yHvMscQdW4dB9Gxh3TAmpxsBFKsHLSNxPhVVcXuSV	22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	1542	1304	406	12463	14249	jy38gD7R81YLWgwJkLP5wCUe74EqKQyCz6VmUr5v1ABPgp7DwEA	11059	15570	15570	1618741800000	canonical
22115	3NLdpX6BrCgEUgs7M9xvdKbcxXjoSUPfYSKkcqt2AFspVjM9RGXB	22111	3NKjCighB4oBqoDPmo3tAnnomguG7NWjRdYts468Lp78gBaK8PYs	563	1359	406	12463	14250	jxc7SPM52Sztc51yQYYfs5ddpacM4s7xknvJoV7t2CusVxXPq3R	11059	15570	15570	1618741800000	orphaned
22121	3NLVzg7FL7uavC9vaqohRkJm4bFcytfemsEZRJAdqZWorpeqXxtJ	22120	3NLjdxf3CcYeCP5aB2X2wLgPMbF6vzk5EKxNhaSPhmzgXRa6knw6	1637	816	407	12463	14254	jx413Gh2EFVnZyCsdcgkGvJHE2gYTEDtQZsYu6ctMvU8UuwZ57N	11063	15577	15577	1618743060000	canonical
22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	22121	3NLVzg7FL7uavC9vaqohRkJm4bFcytfemsEZRJAdqZWorpeqXxtJ	1407	1395	407	12463	14255	jx7s4vMgi5zDEFjhGgBMPfycVnFtGc3FmZ4dBPraW5T5oEg2gNn	11064	15578	15578	1618743240000	canonical
22124	3NKmjf72fzaK4v8udBoLPaXfcW7UZvkZ1xYFEETUMCkN9wM36Z2d	22122	3NKhZvwYwtheuanX9Pwx8ZYgY8MzPRrvP27pQjoLCpU1boDPHSNG	1406	1393	407	12463	14257	jxQN2bqpoYEv64Yy94VvVhezhZJtftvPJgdCqsEPBkJXDxX3zWV	11065	15579	15579	1618743420000	canonical
22127	3NKaeVhfxM7L3xurDmYvHzfas7uHE5WQi2TB9ZnFMk6is7Qr85u2	22126	3NL7H3VBfDam2DtcXyMLibfEx1ohyqqBpfSh4d4e7kSU49sE6bPD	1631	794	407	12463	14260	jxfLEDzQYnUAq3hBAYVgtBvUq3xd6DqE5oB1tpRC7prmkMweL1L	11067	15581	15581	1618743780000	canonical
22128	3NLAw17fUmxtPtd5NakrQBWXsmj37QTqzB9HKgE2agv6WFv5t8Nu	22127	3NKaeVhfxM7L3xurDmYvHzfas7uHE5WQi2TB9ZnFMk6is7Qr85u2	1587	1357	407	12463	14261	jxRpj3ut3pBFpDtdbLVD8iCsBUDQch5ra7aC14Vj7DhJqm9899G	11068	15582	15582	1618743960000	canonical
22130	3NKtzVCUofwQQQTNfSfDCpvzcwP6gqH4ZV5aky7fhdZBPxiaBqxd	22129	3NKSrdaVycmRF72tJxxuSryrYZ2siMadyNxZkfiTQ9BZm4QhF39o	1547	1132	407	12463	14263	jxBxkivxZXQVQRJBypS7zs5igKaYUtae3MDkvJjfejQ8dWthEQT	11070	15586	15586	1618744680000	orphaned
22136	3NLHWKCeage6K3KGvbNLGctDFfXNfouriUbiaGvXfX3tTs3RPtvM	22131	3NKPdauP8ZkufEbvxQSe5sHSYpzuEwdmtn9MAVoqq57W1ekVy6ds	1523	1321	407	12463	14267	jxWxDBmVaiUmcsN9xCH1EXuuq4UMmvgy7rwLrQPVZ24rmvBihEM	11071	15587	15587	1618744860000	orphaned
22138	3NLqke11Q51emhSH9Fi1sAu7LARckvQTaofpzYWYZZfz6eEdxeEn	22137	3NKeTFjFJkDpT6obmT1Ff1SKRpRTErqTxwYJ9rr9mzZav6yPgcvy	1474	1203	407	12463	14269	jwHEywJ2CBdrFjJiDpEspnSmUVB69RGLgMXn45SLvhnm7GLBNww	11073	15592	15592	1618745760000	canonical
22140	3NLGPyZquCDd5xt8yeLb4GVqbFXDeQTkg8ALYgPAZxUMezrzas1L	22139	3NLZsR9QK1nRuP4UFbz9sBiHofgbQHYKDMXMjqehHmNJTEfMdFoB	1503	1277	407	12463	14271	jwyQ1wEBaRMN2Xmuy1TE7pTwt4x6WPY3McGN1b4M9D7b7H5DUsb	11075	15596	15596	1618746480000	orphaned
22144	3NLazNGdkDiKpGVC8HV35ArDFP3mrk4ScK3KNiY6hxarj3hnFtqi	22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	1503	1277	407	12463	14275	jxuAXZedGc8s4hFugnkzEgahQwdATXdAYzymJr2ap7ozvjHvXvZ	11076	15596	15596	1618746480000	canonical
22143	3NLScdaehFGypNruQgtqbBmRHnVTf8ZdhjCoMWoXn4LhfgKzHqTn	22142	3NLMGgNSt1MKSxKRUDEhGept4fkgUb7P2am5gbqBoXiGAFPdcVvt	1407	1395	407	12463	14274	jxXkRTDg55sXwt6zH5doeeSN3ib8LQXwiEvF6Mcw9w6hupnPFGr	11076	15596	15596	1618746480000	orphaned
22148	3NKNd864qnR1Bq6AXg9TGphqmmjBsp9SqYyD9RnunoFxpZT54yUT	22147	3NLLwWNhLVkvcTJ6yhtnoyoSpAzB1nSoavFpjgGPSMPBgvG1AeJP	1474	963	407	12463	14279	jxtEPorgERpKA4FvXRMHZHP6zyytHsrbyya3YHPqXFBpDvbZxpZ	11079	15600	15600	1618747200000	canonical
22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	22150	3NKL9RxDdsjKN37rkrp2KWxDCwhy92GNWn6396Y1nCEQouKPCLH2	1406	1393	407	12463	14282	jwmGsBYGLJARNhZzb66jNiPCkby8WtjKb3ifn41oDzA4obS4bTa	11082	15604	15604	1618747920000	canonical
22153	3NKuTAkMViyyQkAF2oupr3vzt8vD6mT4cMLYxi1UmejbS6tjJa22	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1555	1221	407	12463	14284	jxpvJJUrr1RxuzTV2cZZFrMLKBK8HbstJgCrL3qvp7TR4QvWHPV	11083	15605	15605	1618748100000	canonical
22157	3NLhVMcJPhQ5MxeEmLMD8aQRFHX75Q15vRTZc5tpEZBMoP3ZBQcJ	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1555	1221	408	12463	14284	jxSyEkM4r6jZDK2epB2G9oodbU91LsxaqcJ9y3gK5L3jkGCH5XS	11083	15605	15605	1618748100000	orphaned
22159	3NKNHtthKZNvoo2JkgS9u1yjSeqik3vfx5kFA1bgh4jCC7muxDGK	22158	3NKvhkHUuDV9nCRomu3KcHtyDeur2232Y35WphXQJ6XCsspQ2F1R	1407	1395	408	12463	14288	jwnR44rNjTwJN6z3fDaDomvDEGppRKSQDtshn9tXfneBRsbkiEN	11085	15607	15607	1618748460000	canonical
22161	3NLUTbnwkzqLsP6ttbncbtSjUuQ81BCJ64vBPbnEQKgeMy45qV9d	22159	3NKNHtthKZNvoo2JkgS9u1yjSeqik3vfx5kFA1bgh4jCC7muxDGK	1405	851	408	12463	14290	jx3QoCCiDPErzWypv3Rhk4HyNXFck7sT64tfBDRsKDDTWx9zdu2	11086	15608	15608	1618748640000	canonical
22164	3NL89wQn2aTw5p6sma2KBKMVQwqzqCiL55G5pqwCscZtsL6TFJB6	22161	3NLUTbnwkzqLsP6ttbncbtSjUuQ81BCJ64vBPbnEQKgeMy45qV9d	1649	1137	408	12463	14293	jxUrQdgJua4836GhkAvhi4ihC3CTGYJ7uV28dLxD4uqLkceEKgc	11087	15609	15609	1618748820000	orphaned
22167	3NLCPqbSq9XgHNwjQ2GspwuHs6Z9vTojHazvDYGmqaZWzwugL3Fd	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1406	1393	408	12463	14296	jwcdNdjnK5f3SXLt6cLX4PNcj2uAyLWb6pgu2oBy7NQ6TNb9xYk	11088	15610	15610	1618749000000	orphaned
22169	3NKPuNAVzvd8KutT9Cc4mg4ofEgbZ1LxZJwq3jTqUE92NwGK6TBY	22166	3NKhd5yfmAtqQDWB68yU75L9e7Rtio7j6EzM644Fn28eNdQZLQhd	1611	1341	408	12463	14298	jxDAQsJsixDsPYEvkhNAA2ysJkSVeM3y84SgHypAERy9xoMJrUV	11089	15611	15611	1618749180000	canonical
22170	3NKWrJvsQnGem66ZupQPsnjcNk1ZKU5Kif9L5XGLNpySTsSB8Qo2	22169	3NKPuNAVzvd8KutT9Cc4mg4ofEgbZ1LxZJwq3jTqUE92NwGK6TBY	1589	920	408	12463	14299	jwLH4Cx3HSHZtbixgj9WhUAgBapVYhyUALysoQGjdLGhedTM26g	11090	15612	15612	1618749360000	canonical
22173	3NLrmXUK4dFWhQwi73YGXQY5tsdypcRvZC7xKw2CGpZAmgfJ2mSy	22172	3NL3c5BDaUFwxYSZpHS59fvEVxneRpyLE9CyuqaNmwZRbycHYqiU	1407	1395	408	12463	14302	jxufRrFsxNT27AAapZjLzZUAebPRVmoSyLdN4eeE4Gb9BVvr8P5	11093	15615	15615	1618749900000	canonical
22175	3NKLCX3ji34d1nDrsb9dfdvAWyEyQYjKEJofGi8BMg24sT3pHCRr	22173	3NLrmXUK4dFWhQwi73YGXQY5tsdypcRvZC7xKw2CGpZAmgfJ2mSy	44	959	408	12463	14304	jxjCYiabyZnBFRQnur47MnmYvAmefGSYyBtCzjMurPUppb3VV3V	11094	15617	15617	1618750260000	orphaned
22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	22176	3NL9qBu2n9ADyrFXr9qRL9Rro7jDpBVrrszFEo6kaocPnx2f1f6E	1407	1395	408	12463	14306	jxkAfvP5S5ZBW1xnoog35N1RpB6w6Pj4ZiGKqHdxQzq7qWMnqYq	11096	15620	15620	1618750800000	canonical
22179	3NKVBqMdHeQKFDcc5p12MEj8pUB22Pu2HXVa5ybhCratzpgcP9NX	22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	1637	816	408	12463	14308	jxvG9Rg7XY3gekxGZ698LrVuvrA6TfvrvpwmsVXDvsgK9ZGkUWZ	11097	15622	15622	1618751160000	canonical
22180	3NKNAwMkTjtxWvRViDHzqdf6WrwioosBb4UpJm79jCCZjPAYuTX3	22179	3NKVBqMdHeQKFDcc5p12MEj8pUB22Pu2HXVa5ybhCratzpgcP9NX	1637	816	408	12463	14309	jxbZgFbwRzEvDh3ExpTtAhHivmf3YWNL1X1nqD1YqSdSMFwCszn	11098	15623	15623	1618751340000	canonical
22181	3NKec9TQrPYxRR5nrbXiFiCTCBHffatSbMoVvRjep4W5b1GMR9i1	22180	3NKNAwMkTjtxWvRViDHzqdf6WrwioosBb4UpJm79jCCZjPAYuTX3	1522	1076	408	12463	14310	jwa3ZJZ4AKAyzbovitmSiKTnavbvERTGF52aceXke5q2pHPEw9u	11099	15624	15624	1618751520000	canonical
27619	3NKTfzJ6tX7BMWcADAbaoREgG2h9yvDbhHx7yPNEtTiAjqZkgiXf	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1585	1366	538	12463	18974	jw7zUuuwdDBymrW7KS54QRL2VrfeGGo9GuFPAvxSuGWSbddSLHV	13651	19226	19226	1619399880000	orphaned
22245	3NK9aygjK7biqZEsqES9RzrY7mVUdgxGU1Z5zYqPtHD4d1rtMS2F	21980	3NKitouaCsXx8UGoXQrLK9ZzRcseeRvJNmHaxAz5zHmDTuehrZd1	1501	1360	403	12463	14370	jxsTutZGgtPkeXqSP2ieU9r65Sufh4MNs1PXtJHPLxdshzhYxKD	10990	15673	15673	1618760386622	orphaned
22199	3NKYNZdhxtLJ8DMgLRDKgkDP8DvcSf1ViZfrWEqEJP6fdQes1Ac5	22184	3NL2UCFpjuxjWkgqZK8sw5mFLYjmtapQpFEczfRjWWqUbS53kDJ7	1516	1294	404	12463	14328	jwGnsYi9fJF21JPCqBtqQLeHgF9McxY483mH15r8M4L6wcTkrEp	11006	15641	15641	1618754580000	orphaned
22208	3NKmytjCofzjiuvyYK1q8RGYxXHbhqZTEYeeVrrgNxWFqL6NP5U9	22199	3NKYNZdhxtLJ8DMgLRDKgkDP8DvcSf1ViZfrWEqEJP6fdQes1Ac5	1516	928	405	12463	14337	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11007	15647	15647	1618755660000	orphaned
22149	3NL5Tii8LD277dw1pyNsshyrMkfCGemvdSrHXzoNBnQuUbp3ai5B	22148	3NKNd864qnR1Bq6AXg9TGphqmmjBsp9SqYyD9RnunoFxpZT54yUT	1406	1393	407	12463	14280	jwXCZ52y63vt4ZWD4vEyowpGeoT7yBS53sgUG3FgaCQSu4EvHjN	11080	15601	15601	1618747380000	canonical
22152	3NKe1crY4gSP8VmL156Jmqv765kviFPSvSqimFASNLwpT26urwPr	22151	3NK3MhLDvDs651zytpg6p6zq1k7AE2LB7Dck7nj94imL2LZzMWq2	1654	1214	408	12463	14283	jwDcte4JgaVKoAUudvycFEPSKwxqeHqAaUJhHwa7ahNg5u6LcpK	11083	15605	15605	1618748100000	orphaned
22158	3NKvhkHUuDV9nCRomu3KcHtyDeur2232Y35WphXQJ6XCsspQ2F1R	22153	3NKuTAkMViyyQkAF2oupr3vzt8vD6mT4cMLYxi1UmejbS6tjJa22	1406	1393	408	12463	14287	jxggSkPtkkk5LbBqJRzQ4uv78Ssh82d26RitBd8b4Bik5deo27u	11084	15606	15606	1618748280000	canonical
22163	3NKvwEQJ6GaJdeynqA8QPs7HafzjLGSLZ9V2SyGFnfG8e7jTaxh7	22154	3NLdNysP1Bt3u1mKLC13vLGn7yZgb3N1LYhcRKi7xTeQvTEFhjFX	1609	1087	408	12463	14292	jwohVqT84iN38RV7SaYyHgAYBEfJCd5xKpp7TXfXgTw9CKXMGG8	11084	15609	15609	1618748820000	orphaned
22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	22161	3NLUTbnwkzqLsP6ttbncbtSjUuQ81BCJ64vBPbnEQKgeMy45qV9d	1609	1087	408	12463	14294	jxbg1jBihkVivEhBZddzmrmefbZ7qrAJnqhN2TmC4rHruBbEMQE	11087	15609	15609	1618748820000	canonical
22168	3NLQVFyHToXZYxVdootZ96Dri9NyhSyYk8tznCsnPCvQHJsJADpz	22165	3NKbx4U64XsUTR8o2xTj37KRDuPv3JrFPeELEvEhyFwJ7nJMmK9e	1457	1025	408	12463	14297	jxeUHVRQXvwxLREc1jBQNJVyoSsNggwGnBS6JT1Yrb6War1ZNzm	11088	15610	15610	1618749000000	orphaned
22172	3NL3c5BDaUFwxYSZpHS59fvEVxneRpyLE9CyuqaNmwZRbycHYqiU	22171	3NKsuh6rGs3Hj5hBqyKs6PLJqdKCMNBrt1xZg4nqghW5zoL671Do	1471	1020	408	12463	14301	jwQiB7ksxiT6xhnHh3oVRE9NRDkx4Nek7qjwE1Kdsgy7wYRZU8p	11092	15614	15614	1618749720000	canonical
22178	3NL7kDwFHYKTfQLsKbtAtbg9gSStdsoe1oLPFmK7oFiZ1TYWGbaf	22177	3NLxE6ssdGFCa4Uh4PbZRYe3YcD2SXuv4SXDXq26EaseBmQF1Ncb	1555	981	408	12463	14307	jwxfhqRU8gGcNBtVG76gbwxb6XeMppp9Ze8Vz8o9WEaVhUdRxoT	11097	15622	15622	1618751160000	orphaned
22185	3NLhFKsRM5SWrNQtVEABw5dMbJzrC4i2WMUQQfkwSj57XqWhJfvJ	22182	3NKEDgL7BZNw1F38LMRUkeDuQLpzdQRPjDCkVDhhDipME54f2tKU	1611	1341	408	12463	14314	jwG2TcAW4WZYu11AxdMK2x9FfXhf2FQ1LkzP73V3JajAFamX8qc	11101	15628	15628	1618752240000	canonical
22186	3NLhE2J5UNbVut6JJphzSweUqi4mMrkUDKSQpHceyUniczB2yvim	22185	3NLhFKsRM5SWrNQtVEABw5dMbJzrC4i2WMUQQfkwSj57XqWhJfvJ	1578	1050	409	12463	14315	jx4GehgPJqMJfHj6VycU7wRn2NbHxTSVk2tr15GLcRTCJPQauoC	11102	15629	15629	1618752420000	canonical
22188	3NLF7o9sJ8ky1rSwZgfuKM9wfuBWusxtV3QEaacZwtSr1CmqsyEY	22187	3NKLYn93sp5K7bnJLaDXtruJHjikem4pou9na9SMuEta4kSELSsF	1581	778	409	12463	14317	jwzKR923rkEzXLqFZtcqM6BaPG7YDkBHaJDBTTQiAxRR6wU8hMk	11104	15631	15631	1618752780000	canonical
22191	3NL8tQt6C9Yoe32W57miKGZYME6quXpnJSsjbqxELRqWAKniMppM	22190	3NLYPGkvsuKD6ev4KPoe8J2K4vXXVCLLnmzAgwKKNoop57q5uKGi	1403	812	409	12463	14320	jxAURe2sh7W5jZeYVLB8XW6mLakAugbH7zi8pv2uwbPvZkLBLrW	11107	15634	15634	1618753320000	canonical
22193	3NKZXExZSVaGyeDofNSXwEfhqkLcZ4nXP1yYuLGJ8EYNLnhPLsrv	22191	3NL8tQt6C9Yoe32W57miKGZYME6quXpnJSsjbqxELRqWAKniMppM	1608	1289	409	12463	14322	jwZzSp6DrjcbMMmwKidgPs1tq2nmP6eDN2cfm4QqRGq7tcqenku	11108	15636	15636	1618753680000	canonical
22194	3NLNfnWLKq5Q3zCQyz3vuj1rVX4ERDCz6k2BfEDttgYWaAS3u4t2	22193	3NKZXExZSVaGyeDofNSXwEfhqkLcZ4nXP1yYuLGJ8EYNLnhPLsrv	1406	1393	409	12463	14323	jwxozPbWvXbN8hA5TnPigtf2yyKgEFjDweDJYJkEeQ9W2un6bw2	11109	15637	15637	1618753860000	canonical
22196	3NKkVKkCAph6UcvVpbjStYbYCzN3DAQvecX8oSVYeXqhAkNbMQpe	22194	3NLNfnWLKq5Q3zCQyz3vuj1rVX4ERDCz6k2BfEDttgYWaAS3u4t2	369	1312	409	12463	14325	jwoJTeLaREP5r99FqwdFGwpo474bkvdZwzQS2RmNGezZt8nhcfj	11110	15639	15639	1618754220000	canonical
22198	3NLBua5SD7JnwSRTnFcdiP4WzXHptB1SxqxE8zyDKJQ6vWYpCSJu	22196	3NKkVKkCAph6UcvVpbjStYbYCzN3DAQvecX8oSVYeXqhAkNbMQpe	1631	794	409	12463	14327	jwn9C49rEeQmnuzfUFGpdsHVjaHoavuVWzBcqFQeQwdSYWg4tRX	11111	15640	15640	1618754400000	canonical
22201	3NKJZyevCSrWEegJmLFZNWFJa4nXt7tSnNi4XKGtYtYfv3oQ7kWQ	22198	3NLBua5SD7JnwSRTnFcdiP4WzXHptB1SxqxE8zyDKJQ6vWYpCSJu	1607	982	409	12463	14330	jwPmSqZuRW6Ro6adWVhrDGSbgomgwamZNCYYNLw5FVc9v91GUNR	11112	15642	15642	1618754760000	orphaned
22203	3NL7KyG1nD1cTGGpF8yKLiRiSA8a25s99N2whr1ZXfThzYZyTyTL	22202	3NLkCR9x1pP5RL5AyFnfUyZ1JWDiBhERw17HS2aAK83SgDYJFSpA	1426	1118	409	12463	14332	jxx4GnYs3eqsZabQgP8gozn47tCaoq936coALRhdHMTBSHQrd3B	11114	15644	15644	1618755120000	canonical
22204	3NKeVyWxKMW8xZyXQ8scxS5Tn1fSeCsrnMbT5mBhGatVo3KUH9nz	22202	3NLkCR9x1pP5RL5AyFnfUyZ1JWDiBhERw17HS2aAK83SgDYJFSpA	1631	794	409	12463	14333	jxdWQ2LsM3Hi2QfpRxxqw2p7vcwpk9RHDdydhtSHLLfnDied3fv	11114	15644	15644	1618755120000	orphaned
22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	22209	3NKioVenpyQofejTEu1MRTUPN9EYy2VUW21GXPo85beUyLsgn7mp	1624	1334	409	12463	14340	jwxVyDFog8mgxvUzhhLRGGzYSkFVMCNgpThVTXcVnoLeNMDWKSW	11119	15652	15652	1618756560000	canonical
22212	3NLSBpaV8jaBiYcZ7WND6UVa5GonVdDsjwCsJ1vhM6Sq5PoJSmwq	22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	1578	930	410	12463	14341	jxoDGSrRy1ws2GyLpBWZLSaRk97C7yZKNt81EQMGQ7zerWrcEZ3	11120	15655	15655	1618757100000	orphaned
22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	22221	3NLa1BsjxMwxXpmaNmy8jMuFDuE3ghRbGsPVWCzdXpZmaxSgTq9A	1611	1341	410	12463	14350	jw9PFG72Wj3HB8gMRsk6sgoHbTLhuVqHLsQLaEp3QT8xXbDQcNt	11124	15662	15662	1618758360000	canonical
22232	3NKmXJR5b7ALPkUbJbt7QMxuY2pXX3Z9GZyyZu7WjdFaXCzngKBq	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1619	1029	410	12463	14357	jxgDepEzPG5aGoW7yu4utSYt6esyZ1EBqpc3MGRPvfJC92xfb1j	11126	15664	15664	1618758720000	canonical
22229	3NLSrLYJALX94Q4mi5cBX8vmFVFg2jCJYVpnhvHc1oCj5mCXv7wN	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1587	1357	410	12463	14355	jxntNMT6Czg9oZbCGaQCgm8QH5geD5W21WRcxmotRR6VLtUR11v	11126	15664	15664	1618758720000	orphaned
22233	3NLWt3BbgVNQAZEiV9CVcyBRA2Za4HnJFq7q4FdGaY96rm4bMvav	22232	3NKmXJR5b7ALPkUbJbt7QMxuY2pXX3Z9GZyyZu7WjdFaXCzngKBq	1634	1085	410	12463	14358	jx9JqQT28eitfrRUWk2Mbc5mRZGpBkee8FGkK1FH2n3oHo35rY6	11127	15666	15666	1618759080000	canonical
22238	3NLxMdsBCKgxTpJvmnPQeqd7BbnPBV9QRWnLzprjEqLCGYMAniag	22237	3NKNPyMhhnm2hPv6JXDeUByJM5T3rFcRUFETjCB5hvp8gWgCBjkD	1579	1389	410	12463	14363	jxy5pZe9xcG4iZSBDxkV1yVZtDbcUT3qLWBtRjBWA2BHJ3rM3d9	11130	15670	15670	1618759800000	canonical
27621	3NLZkh3v1s26WmuWE3CZsS4ezbFwoL9X4iLaDjKX2vqzztsrPwUa	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1624	968	538	12463	18974	jx8RgPVQsFCTH9HyngKXowgFXAmy5cwDHkpWdAwX7wETtnjPfnd	13651	19226	19226	1619399880000	orphaned
29236	3NL4RA7SDRRKqkmgAy8A3SuJ5rkfPKWe74c26AYPEKwXYKfVsrom	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1406	1393	573	12463	18974	jwCBgDFhDu5RvrmGJh13gYqxguWAsuTQjXdF6y1SDuobTtxxa5s	14408	20289	20289	1619591220000	orphaned
22243	3NLpbwAnecsxPy71ay6TMvRcLeFrNoGjizzdT8UvYU3ovxo83NiV	21878	3NKFhM1jC1x1ESoLX3UAAGgPibBUFSkE5gyi68FWAmJyMoRu11rR	1501	1114	401	12463	14368	jxG8WrnKKNyd78gGdZ2zSF3V3aZS5BYLfVLs3t8v3LKFjvkhkYc	10948	15672	15672	1618760215681	orphaned
22220	3NKCbHEjTSMT2eMxYLoBzLoU1LVgyJXquDgN4Uy7To4eVVyuECoZ	21882	3NLe3EiWH7a4tQ6abdt16Stfmow8kawmJpU3Emp4cWCX4xZgdW44	1403	824	401	12463	14348	jxYf99NKePj8fZ56yLvEThMVF5PVPVBkRLPkoJ1aaDkSree3GSy	10950	15659	15659	1618757923991	orphaned
22184	3NL2UCFpjuxjWkgqZK8sw5mFLYjmtapQpFEczfRjWWqUbS53kDJ7	22005	3NKpLynUY9jxjbqKDNWwRoXMX45nkdk36TU6T8cbDe67scRgumCg	1516	1048	403	12463	14313	jxLk2vbHFPntqgTGFRYDt6vnyxFbpNqsAU6ZtRb1Kxk2G7uVPRq	11005	15628	15628	1618752240000	orphaned
22197	3NLj3wFLC4WAMm824EJmgURZ6AkC3jrsqR2fyDYZEXQS77GhCy7f	22156	3NLGV5wtFgoituCLJME3KnSrBZbEfmgzVueyTqwoi6LzyESgHFrc	1553	776	405	12463	14326	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11031	15640	15640	1618754400000	orphaned
22189	3NLdcZLtt51bJhYYx6XsWqRE5fwWqHKXAXZjBYgFKbGeywaNNmzS	22188	3NLF7o9sJ8ky1rSwZgfuKM9wfuBWusxtV3QEaacZwtSr1CmqsyEY	1445	1290	409	12463	14318	jwT5Tt3DEWy3VR89kPyoBuVV2gasHuAatM5ZBNo4JQ3km29gL2k	11105	15632	15632	1618752960000	canonical
22192	3NKB5noQnzVKRZ3EbGy1pX8fwpmuMQmsNTEaw6DJnu6g19RAUhzy	22190	3NLYPGkvsuKD6ev4KPoe8J2K4vXXVCLLnmzAgwKKNoop57q5uKGi	1613	1349	409	12463	14321	jwR8TaKeaSbu6VGUrdR6XMo4pUqY6dtmQAV6EK7aLwEtAE9uotS	11107	15634	15634	1618753320000	orphaned
22195	3NKuPyzCPagFeFeVEe7WV2zjMNSbt8RyY1rW9WystpcBnhLyZbx6	22193	3NKZXExZSVaGyeDofNSXwEfhqkLcZ4nXP1yYuLGJ8EYNLnhPLsrv	1637	816	409	12463	14324	jwUXE2rSYcMLdMwePYHSB7QGg6ZpZuq6uLSwDvK66rvakYVZ7Cv	11109	15637	15637	1618753860000	orphaned
22202	3NLkCR9x1pP5RL5AyFnfUyZ1JWDiBhERw17HS2aAK83SgDYJFSpA	22200	3NLuPPFQzakSVAXD6sjXuqtGp6aUsaxXF2gydvLPAJuzexPG8wF1	1407	1395	409	12463	14331	jwsFDgTeVi9dQPivLnXGn6HY5ZGZLEvT4ncUqtvji5yCPdGqst2	11113	15643	15643	1618754940000	canonical
22207	3NKDuCF5zV1WdFmKQacrLcfGFeywqserbsFbWhKoBhPXA3uFLGXY	22206	3NKyrJULJmYeExyHzG86LnHrt8fDY1kEr5kESMYiruzzfy5Cz9Aw	1403	824	409	12463	14336	jxKDW385cmo6cM9ePHXagu8r3TSf6xGD6UtowYnxVsravsE3oFT	11117	15647	15647	1618755660000	canonical
22209	3NKioVenpyQofejTEu1MRTUPN9EYy2VUW21GXPo85beUyLsgn7mp	22207	3NKDuCF5zV1WdFmKQacrLcfGFeywqserbsFbWhKoBhPXA3uFLGXY	1407	1395	409	12463	14338	jwan1nyYc59eT2SwoAHDpajP1yDwojrLYQnqXjHbpUKnKGzPAPv	11118	15650	15650	1618756200000	canonical
22210	3NL8DM2Y4d4kVgvV1Q28BQSt2RHegsS7VqJuW7p11TMRtCBKXGzX	22207	3NKDuCF5zV1WdFmKQacrLcfGFeywqserbsFbWhKoBhPXA3uFLGXY	1672	1285	409	12463	14339	jw78za7t5dEAtgLfsmkdVdfMZKYZ4PaDArfHrFxcqCzY85RrT5Y	11118	15650	15650	1618756200000	orphaned
22213	3NLLZ2K2GGr53xKBbi6CUYiL5bUH29dNMBR2XyskwCDuwkKijnKi	22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	1588	1266	410	12463	14342	jwfS4HVQRH4Av6jS7ofNCPDbTjbY3dTgNdhX9xHvHNuyX6wan1d	11120	15655	15655	1618757100000	canonical
22215	3NKW8M7ZNimVzMVNeZL7A1mFBTe4FgtALxjaeo2GebeN1ePb5irN	22213	3NLLZ2K2GGr53xKBbi6CUYiL5bUH29dNMBR2XyskwCDuwkKijnKi	1617	1288	410	12463	14343	jwJS149QBbVgnyfbHnXoXpWgpXVQ34TMrNJicxvyR3n5pA6ygrg	11121	15656	15656	1618757280000	canonical
22221	3NLa1BsjxMwxXpmaNmy8jMuFDuE3ghRbGsPVWCzdXpZmaxSgTq9A	22217	3NKUbFacwH2osxH3U1YQxLa7L6BRKkC6kXXrQZ3MsgrYtiSYj4UP	1471	1260	410	12463	14349	jxfYRPs9yeUZJQbSTG8MeWas6deZyXPCD79jbbiswBQg2HXGWV3	11123	15661	15661	1618758180000	canonical
22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	43	1184	410	12463	14351	jxYzV1TvmmMVCBKqergR7VVjRxarvkrGmdDreTHmPN8gyDL3qNV	11125	15663	15663	1618758540000	canonical
22226	3NLiCqMejuJErzksQkqBvky9r7yGkYsFGRx8qUvm2jn7hbFsCcAa	22222	3NLW9LZnzrdYWnq3GUaBQUrMaVx2h6NqfhMSKBt6qTQj1BVAxoc5	1577	1201	410	12463	14353	jxvTuKmfq42ogEWFntV7VhnJ34Mw69e9G91fXj6YV2eBukq5dzY	11125	15663	15663	1618758540000	orphaned
22230	3NL9v3WqbpkD3apevAkwYcdxsSXR8ep6ueRBwAfPZ7aVE1HK6t2b	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1587	1357	410	12463	14355	jwxQxrPQASabY62S2tpR8ibpAW4eG3PEHnc2jR4qzTMHzqd2sXd	11126	15664	15664	1618758720000	orphaned
22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	22233	3NLWt3BbgVNQAZEiV9CVcyBRA2Za4HnJFq7q4FdGaY96rm4bMvav	1501	1114	410	12463	14359	jxRC1jBjbyHVspNYYUndZGuy2VrRstuAWvUkxyj6XKsTQFDqW3U	11128	15668	15668	1618759440000	canonical
22237	3NKNPyMhhnm2hPv6JXDeUByJM5T3rFcRUFETjCB5hvp8gWgCBjkD	22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	1624	1208	410	12463	14362	jwDrnQQakA55NtWdder1MEEybboYSeJdee5Bvdiarm2hQySaQsS	11129	15669	15669	1618759620000	canonical
22235	3NKzyHRbaEFbGFRfYNuqxDVRX1y3aR1JDjRHxaXq449hKHt8uRu9	22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	1617	922	410	12463	14360	jwEDefKNV4iJJxeWBib2gyWxZUYcwscTr6x4hgg2gLptymRGehx	11129	15669	15669	1618759620000	orphaned
22240	3NLVSR8eNirKdhCxnyVNseaaUAipTj5WN6SSQcxRy7seByfa1db1	22238	3NLxMdsBCKgxTpJvmnPQeqd7BbnPBV9QRWnLzprjEqLCGYMAniag	1560	400	410	12463	14365	jwyyWsrhmZ8gc2qd31U3xDo4nxjGUYjSAyD7rhMMbZy3TTJo3FP	11131	15671	15671	1618759980000	canonical
22239	3NKxyDEbGihtuqpUxw9cSFrgPwEGu7xNSiezAhfDmdcUPkQ4HXRS	22238	3NLxMdsBCKgxTpJvmnPQeqd7BbnPBV9QRWnLzprjEqLCGYMAniag	470	1183	410	12463	14364	jwfg4UwV7kmdDJsEWRvrt2WtzFaQxEMdtVbiRhizLHiWzj213jY	11131	15671	15671	1618759980000	orphaned
22241	3NKpBSkEriU9LiXvdzo6SDy3nRwT1NojiosZSQBTsc25PmguCXga	22240	3NLVSR8eNirKdhCxnyVNseaaUAipTj5WN6SSQcxRy7seByfa1db1	1501	1114	410	12463	14366	jwsLdFFMXEDuLzmrP8KDXes8u6ebuPA6RpNgLYbFwAYeGdFXeXx	11132	15672	15672	1618760160000	canonical
22248	3NK5B7uQHxwxoDzhunTkG5aVRt4NMi33HhaNSXqBUiTYM6xVYP3J	22244	3NKagRuRqCeyjPw2URv4X6XK4vRuDCyhWmQjbmqUMprjbfbDrz4h	1445	1290	410	12463	14373	jwqsyZi5WBeixR1ihPdZkicjUQR8DeAm21JYKvpdTE3J3GZ8Ntf	11134	15674	15674	1618760520000	orphaned
22250	3NKU3AiKbCKyukScXhuXEKdzszeP8LhxMMA3FNAZD2UukaWrLo1c	22247	3NLR5wZHFC4FGG6riqJ9P6DMYPxiFE9CnXeUHVbgKEgSEdnNJkt3	1507	1034	410	12463	14375	jw8JSGbmkS7DK8yXiAF1cXJh6myWasnGENDY98px8iSc5X5vthv	11135	15676	15676	1618760880000	orphaned
22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	22254	3NLkM59maxrrEozcCC5xqcu9AZ44NL9TkDwkAoqyAEvNwdxePPPW	1403	824	411	12463	14380	jxaRGwBtywuguuwrLMmjgtMwDZaKR5Mcr9rVicNCBMAyCDZCm7y	11138	15680	15680	1618761600000	canonical
22262	3NLNL7WsznjqwtBMWeucsuYtoe48tuoEKZ4icqE4Ut5yjQzzzHv7	22260	3NLqHkETiWfjL4oa2d48LNwc45ckBbY8YH6E2wNxcjMSGJN7Buga	1670	1036	411	12463	14384	jwRadTYzUJscCaURa914gHiGdwjXAc4JLdXi26jmnNRhVk4JRkK	11141	15683	15683	1618762140000	canonical
22264	3NLk2cLJ3jj51nkArY1MUuTF7Eo7fbMitjfVwoA4mCxYJ6GkaiqY	22262	3NLNL7WsznjqwtBMWeucsuYtoe48tuoEKZ4icqE4Ut5yjQzzzHv7	1637	816	411	12463	14386	jxibcdBD7jT87DzWrS7oxc46cLS5LGf62UyRK39wT7MgV3NkR8X	11142	15684	15684	1618762320000	canonical
27643	3NKZE35DsvaZiJ54qcN7wZPuT7jZdjU6Wrdvwb5muGBkdCHNSp5P	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1506	1247	539	12463	18974	jw9uZyfXSTNV1sgcDT9UGexXFCmXXGQoGfxJEYVbrGPUyEUt57x	13660	19239	19239	1619402220000	orphaned
22219	3NKuKDSoZFX8AQ35xEe1ue29Np4xyEhWqTP2oZqcWXPs5xuHcUDr	21852	3NKeAbKStf2TSuCPZkV5om5xceFFoMeZv4a8MyUHxXtZ82gKjfxf	1403	824	400	12463	14347	jwfFBu4KXBKVBag9Fb5pdsj8JeoAnyd6tfyZwA39pMg77AyA6HQ	10937	15659	15659	1618757887200	orphaned
22246	3NLe1kJj6cpZ5dZsfgJezxUUn4Ei3fa8eW9LFbvtNsHfAGAfKbaD	22003	3NKYAPFRY8uZgbCi15PBpMGG14uwJW7SdKz12d4zTtAUUhXxG1oU	1501	1360	403	12463	14371	jy2q5Zj1rmbQEiCjPTMKC9ns3XPn1WtVfXM6r9fxkg95kDoE7ES	11003	15673	15673	1618760442713	orphaned
22249	3NLGkhJ3SgVUbXieh68gobTU4aT8qBVu9Ge3cAY157Q8M7tqMNra	22208	3NKmytjCofzjiuvyYK1q8RGYxXHbhqZTEYeeVrrgNxWFqL6NP5U9	1516	1168	405	12463	14374	jxRTBSbkeW2NW5Gw6yBgjSj3ZmX8P47EYBjMQekPqyQYd6rxjLr	11008	15674	15674	1618760520000	orphaned
22200	3NLuPPFQzakSVAXD6sjXuqtGp6aUsaxXF2gydvLPAJuzexPG8wF1	22198	3NLBua5SD7JnwSRTnFcdiP4WzXHptB1SxqxE8zyDKJQ6vWYpCSJu	1405	873	409	12463	14329	jwBgKzuRcRUXdnmQzQoRi1H9JA5tQLXjzekSd7mEfGxUfRvuGUd	11112	15642	15642	1618754760000	canonical
22231	3NKvV1EycPkYD8cNkjPULZT18Weq4isQoWjMT2AkSHPBQKrbR9g8	22201	3NKJZyevCSrWEegJmLFZNWFJa4nXt7tSnNi4XKGtYtYfv3oQ7kWQ	1619	1029	409	12463	14356	jy1AQgEYr2jaDhQW2C9cZvczvLWwA2YAVsi9JUbvRQELgBMVsXP	11113	15664	15664	1618758720000	orphaned
22205	3NKVBAu1upsM6z42XBrZvVJKJQCrxtmvbE9ruwwZF1B9sQX3gW6d	22203	3NL7KyG1nD1cTGGpF8yKLiRiSA8a25s99N2whr1ZXfThzYZyTyTL	298	1182	409	12463	14334	jwrQYzPs8q9WFRDdzs5XyTppu7STL2LNcXQsicEooT8TApis32g	11115	15645	15645	1618755300000	canonical
22214	3NLLEcFaLyymAj54keQK3erapXuCk8aFcCMMByCy2JhE3d4F5hhY	22211	3NLruLdcnKfEcvoxtuThbQ1w4yn5LBAnMFhLGFYQEkuumJrvnxKy	1578	930	410	12463	14341	jxoDGSrRy1ws2GyLpBWZLSaRk97C7yZKNt81EQMGQ7zerWrcEZ3	11120	15655	15655	1618757100000	orphaned
22217	3NKUbFacwH2osxH3U1YQxLa7L6BRKkC6kXXrQZ3MsgrYtiSYj4UP	22215	3NKW8M7ZNimVzMVNeZL7A1mFBTe4FgtALxjaeo2GebeN1ePb5irN	1599	1161	410	12463	14345	jwS9eJ7WqBWXMXzXJWovdXPXzTP5hEXn82MHYvDbcgoPdMuiLQv	11122	15659	15659	1618757820000	canonical
22228	3NK9CkYofZbrRoJiWLuzMtgtGKNEYxzPXgA75W8XvVQhf3jAvhaP	22223	3NLcZ2kSy5CiYA4FmxgMPqoVJ5qHdvfcWabKfqppHq2hYo2Wdkpn	1407	1395	410	12463	14354	jxXHaTPiD4u5bokAMSqqNXR6JZYnrQQuowTQDVmTMSF2n6ixFMJ	11126	15664	15664	1618758720000	orphaned
22236	3NK6JMctD7tr67GFiQJX8ugfkFyo4RofJKLCXENz3NYXVBhoSjVe	22234	3NKeNnVJ5prpgYsCGuTpSX5XZMuJQCirNuVXHQ5cdsbt5wPN415y	1422	971	410	12463	14361	jx4Dm4SXVtvyPxRa6Ld1oCqghnnoq21BzgvQVSm2TDGjmCH8CXW	11129	15669	15669	1618759620000	orphaned
22244	3NKagRuRqCeyjPw2URv4X6XK4vRuDCyhWmQjbmqUMprjbfbDrz4h	22241	3NKpBSkEriU9LiXvdzo6SDy3nRwT1NojiosZSQBTsc25PmguCXga	1501	1360	410	12463	14369	jx5UaxKBWvwzsS1mAMtoSJxfgjMtHS19XLyHxB5Nx4gupegdpGj	11133	15673	15673	1618760340000	canonical
22251	3NLgbtA7h3UdUSpZ3myuS5RsdZYKmwfvfZsbpvXX2PA9NoDuEP8d	22247	3NLR5wZHFC4FGG6riqJ9P6DMYPxiFE9CnXeUHVbgKEgSEdnNJkt3	1631	794	410	12463	14376	jwVGnpLLu7sJSocKCu4ntAihVyWqLE9J7s65ZB7dSHfY9TzWLig	11135	15676	15676	1618760880000	canonical
22253	3NLMPeH8urxUSmKsAfaUg9AP5qvvSkBP6Cb8Xb7d4swpwVHK45uX	22251	3NLgbtA7h3UdUSpZ3myuS5RsdZYKmwfvfZsbpvXX2PA9NoDuEP8d	1601	1388	410	12463	14378	jwVLZzk3RJymeREjjETBsDmfHepQ4LhSFVKLw4VyAYXhmN9fCZt	11136	15678	15678	1618761240000	canonical
22254	3NLkM59maxrrEozcCC5xqcu9AZ44NL9TkDwkAoqyAEvNwdxePPPW	22253	3NLMPeH8urxUSmKsAfaUg9AP5qvvSkBP6Cb8Xb7d4swpwVHK45uX	80	1273	411	12463	14379	jxh2nH3fULcPRQyAzWRbH3Sbf9nAL4E4mcTwnrwcueQF1mc9SZo	11137	15679	15679	1618761420000	canonical
22256	3NL9rpCsH2KmoRt7hy9cfJDCUYbXeS4LYSGWqqkrHjGgqDYBfNv9	22254	3NLkM59maxrrEozcCC5xqcu9AZ44NL9TkDwkAoqyAEvNwdxePPPW	1637	816	411	12463	14381	jxEuQCbrF89jvYnwPGWTwxr7sKRZa52i51K4vh3BrSPMM5bH5rx	11138	15680	15680	1618761600000	orphaned
22258	3NKrhL82hy5hYzVN3sML86ppvbZiok4Rooo3RU4S458Y2nemcg2e	22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	1527	1167	411	12463	14382	jxX17ded5MhTxdBekcdaygx7uKrrw8JtmqmdMZzf27RgQPuYZht	11139	15681	15681	1618761780000	orphaned
22260	3NLqHkETiWfjL4oa2d48LNwc45ckBbY8YH6E2wNxcjMSGJN7Buga	22259	3NKi2YKfbSSgRnFYZnYiQqJBvP3Htv3RYL3b1WfjouS15anNHGLB	484	953	411	12463	14383	jwGBAQz4ciXbxXbE956Nms37JBUReBDdKF955B9aoYtYphGBXsv	11140	15682	15682	1618761960000	canonical
22261	3NKDdwbxTtzRHtsJCGuEz32Eo8XzeCFXscMMNUgr39vSZT1DiJLR	22259	3NKi2YKfbSSgRnFYZnYiQqJBvP3Htv3RYL3b1WfjouS15anNHGLB	484	953	411	12463	14383	jwUxqrhq6FBoorPfx52AgTfn5RHFBwwvdfYD29goFekbxRDahQo	11140	15682	15682	1618761960000	orphaned
22263	3NLEqs9Sm31HqHhdXXd7gUym8JvnWJpa9CHbzCxEgrJHR9mkj17C	22260	3NLqHkETiWfjL4oa2d48LNwc45ckBbY8YH6E2wNxcjMSGJN7Buga	1522	1322	411	12463	14385	jwH5MTubbWzgqG1Karb2V32SrK9wZ1vFM48n4ui1cbPEmzNYUF6	11141	15683	15683	1618762140000	orphaned
22266	3NKDcE3vzS3bqyLHkrDLPJtFk9AjZHrbnNE7mqZQekKoqsrtreYt	22264	3NLk2cLJ3jj51nkArY1MUuTF7Eo7fbMitjfVwoA4mCxYJ6GkaiqY	700	832	411	12463	14388	jxYHYKxXLppxnrxpUi4byKRUi2UtcrssdnLnr2qEf273xVH9r5t	11143	15687	15687	1618762860000	orphaned
22269	3NLPq7Ud2wFpkTy94SB18pQJXaYVyjcTvH3hhLjqB4Jdd4S9b75A	22267	3NLgpU8uZKwHy5Rcqp6MzTjay3TpVT6r7LShfTxkqVeMERMam9FK	1406	1393	411	12463	14391	jxmGXWnU1eYbRfn3wCQa6XRMaSJ2wRjwNK59rD9f1Ysss7je2Fu	11145	15689	15689	1618763220000	canonical
22268	3NKq8rS2ibGVydzuPVrMUpnuyEmJdSoWgS73qKNvp529H3SpZKaN	22267	3NLgpU8uZKwHy5Rcqp6MzTjay3TpVT6r7LShfTxkqVeMERMam9FK	1407	1395	411	12463	14390	jwDtZq4HKQ54LJYqbvQRj8xKZsJSz19zppCGETVggTpzmyS63rD	11145	15689	15689	1618763220000	orphaned
22271	3NKy8yoC7TgKD7uy9BTZfFBnfpTHa9H3vwH7qZh2ru1YuNtjyjhy	22270	3NL6ZAQEmNeJnVbNyGhomRdH1yZ49qz7h7ZsBhFHpWhUZKvzAqzW	1406	1393	411	12463	14393	jxDSjmoTJeAWsMzy3hkXNu6h1NXsScRMRBESgwLGc4xC6no8Lmp	11147	15692	15692	1618763760000	canonical
22274	3NLVZXr4fufrFfxJrUdevZ3kXopvpioVhBQu5tRkCJuUMQE2N5FH	22272	3NKYh5BgM5rHWYvdmRtrZSoitLX48Jee1dhZf1bWMY5TgaMCjqEm	1406	1393	411	12463	14396	jxY5c8SPU5fMxPRarGqKEoMZaMANNM7uSAXwk9n117bhMWxAFRP	11149	15695	15695	1618764300000	orphaned
22276	3NLBXkm7QA1yQgbV1egwkJKzvA3ZWVgRZKyM7vGSV45kCm1hmyYB	22275	3NKuF61ogpML3ioTrG9oUzsSSJ3QcqVuhTEs2wPkJzByBfo2eSQx	1507	914	411	12463	14398	jwKZMUC52qTBknBnLxFWMSRZXEptwRdk8ZrCnAqnJw2hFXayutJ	11151	15698	15698	1618764840000	canonical
22281	3NKRT2cTL7QAe8LExev2CKoTunUELwFhfefrTdR6P7Bb6mQZE6wa	22278	3NKSq6FdcLn9W9azDytNQiSvYoAw81EKZpGhXa78f5qzbsGxrY8g	563	1359	411	12463	14403	jx3kmHtZf8gMs77dpU54PsoJsA3G5mgGTQS1epLpugxBoz1gdTk	11153	15700	15700	1618765200000	orphaned
22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	22282	3NK3Vpidzv4Fk2xdzdmgHNuPdWNRN9JC94eXvPSNM1pEWaLnFuVJ	1670	1036	411	12463	14407	jxHTRDiJo3XnMWK8VJXuHj95LeiFqjxKtb1FnedZEswVAuAbkjQ	11155	15702	15702	1618765560000	canonical
22291	3NK9UEsxVcP6G1WhEY4uwofpeSxxF2fHQc2hJJ6hPnyQNdwupEi1	22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	369	1312	411	12463	14411	jwEDdEauCR2aUiN2KSQ2u5qdAkGoqJ1GhVpNZtqg9mAGzbGnEKB	11157	15705	15705	1618766100000	orphaned
22292	3NLDrjAHNg2q6MEpPDGdSTKZecQYnSggqKpKgfhexzXh677M2pfK	22289	3NKNjfU1rpALzgm7UEnSvnwAW7ZYFEpnZUQde3YuEE3tzuFAUzQX	1457	1391	412	12463	14413	jxxgPHrLFCNR9XTu8v2aVtEneWFvfxenfVBXDewsfJZCWGsoPUm	11158	15706	15706	1618766280000	canonical
27645	3NKdE9SVSxWXWNauLZVdVj4Ti76xs1ZhFYWgvoGUtELaL4uPowTr	27641	3NLTsfpbgq7jq9gYeGfpV5HdUjbFQPbPbyBjnwFFUNimMKaFt1UC	1406	1393	539	12463	18974	jx9QNhYsyRpMcQeMR7BjvP6vfcui4i85DWW91GcT9kn2x7aijbA	13661	19240	19240	1619402400000	canonical
29239	3NKPYTuCHMtXzFdR72YzF43RAWVuASMD9GvyqegoVx8woFrEWzMj	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1623	830	573	12463	18974	jwkEz58wy1Y5aa9hsXWVnwdNCxbMLQDYQaM94EU4g29hVZPdxvf	14408	20289	20289	1619591220000	orphaned
22279	3NLTaQxWMaHywW3A9UgGShnmjX4AE8C5pBsNozrAwLFRTFZ2H6wj	22197	3NLj3wFLC4WAMm824EJmgURZ6AkC3jrsqR2fyDYZEXQS77GhCy7f	1553	776	405	12463	14401	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11032	15699	15699	1618765020000	orphaned
22315	3NKgUhpPju6FqZ9BeaGAfmLyFCDHz9QtJE5iDeke2R9mSxUjnCDB	22279	3NLTaQxWMaHywW3A9UgGShnmjX4AE8C5pBsNozrAwLFRTFZ2H6wj	1553	775	405	12463	14436	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11033	15724	15724	1618769520000	orphaned
22296	3NL32rVqn5weF8rYSsM31HRUhMihMPT37oPjX7SWUrcd3tFTYGFv	22171	3NKsuh6rGs3Hj5hBqyKs6PLJqdKCMNBrt1xZg4nqghW5zoL671Do	1509	1320	408	12463	14417	jwBWGD8sRzpNbqRDfbb2xXh7qgMkFAy3i2uQMQ1QEspvWzH7GD7	11092	15709	15709	1618766820000	orphaned
22252	3NLVfpDZdcyG1TcKA2X8DMYgPNEaXLmsZN1hmjmm5VHz5i7HARkD	22251	3NLgbtA7h3UdUSpZ3myuS5RsdZYKmwfvfZsbpvXX2PA9NoDuEP8d	1522	956	410	12463	14377	jxwygatZKyPx37qhr16YimxTHtkjTS6whZQP4WUwazEsta1cYPA	11136	15678	15678	1618761240000	orphaned
22259	3NKi2YKfbSSgRnFYZnYiQqJBvP3Htv3RYL3b1WfjouS15anNHGLB	22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	1527	1167	411	12463	14382	jwVJW1q93AnVoKmnavfWspmDckr1tR4SC736c2Fe6KCUUrfVErm	11139	15681	15681	1618761780000	canonical
22257	3NLYKi47qVxtCRyVDy2WRevcVSwXrBATVn4XR8bCM3y4RmKpoMhA	22255	3NKjxdczMKHfmi27wBpmjJduCyo5UfZJXAWzRGvQvsg9pZ3V6H5b	1527	1167	411	12463	14382	jxAHPk67d6hSVBrYtbBHRFhWL1wkmZrenUryZgT9DNd2HHUgw47	11139	15681	15681	1618761780000	orphaned
22272	3NKYh5BgM5rHWYvdmRtrZSoitLX48Jee1dhZf1bWMY5TgaMCjqEm	22271	3NKy8yoC7TgKD7uy9BTZfFBnfpTHa9H3vwH7qZh2ru1YuNtjyjhy	1627	1259	411	12463	14394	jwzPt5XNUTNMJCrh8osCo9rYn8gExiU2bWik1NPz4GaYLhZynq9	11148	15694	15694	1618764120000	canonical
22275	3NKuF61ogpML3ioTrG9oUzsSSJ3QcqVuhTEs2wPkJzByBfo2eSQx	22273	3NK4sk5MDDGwCfpe6kLS27cHm4Gk9E514YMiuRBD7JE3z9JmMBVm	1471	1386	411	12463	14397	jxJ61V7vgkGAKpeAT6QQ43XAMDwvMMCPbaWuXpyGxjK3g3jaFYT	11150	15697	15697	1618764660000	canonical
22282	3NK3Vpidzv4Fk2xdzdmgHNuPdWNRN9JC94eXvPSNM1pEWaLnFuVJ	22280	3NL5YfbvugjpAp5rzYAKiMFLRCypBvz7KW8s3NjsGFgjTJtkS498	1406	1393	411	12463	14404	jxB59LcWKBESBvAucJpWB3EGKhvhqwKfaycGWYA5yoEyDSR1TD7	11154	15701	15701	1618765380000	canonical
22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	1406	1393	411	12463	14409	jwZ4o14f32rSjxtPUYujhUweNuVedH3XVdAm4Rc3PwfdWibizZF	11156	15703	15703	1618765740000	canonical
22286	3NK8oJJqX8mibayMT5LfqA9WMoGX7PbQDnaf2RwFC6mfCzxPEsTe	22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	1405	865	411	12463	14408	jwts6xyxQ5kiAEDzQ9sP1QKjFQsMdXmNpKQgQzGygS7cbJSfAQx	11156	15703	15703	1618765740000	orphaned
22289	3NKNjfU1rpALzgm7UEnSvnwAW7ZYFEpnZUQde3YuEE3tzuFAUzQX	22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	369	1312	411	12463	14411	jwLKjzkw1iCL7NRz4Lrmd2bsgyqvSqSexHcHFy3yMNT6L6iY9X8	11157	15705	15705	1618766100000	canonical
22293	3NK5q2jdWfNtiFbrDAPmC6zhY3HzD4qPBwM2FTEVdnkjySLYEZCY	22292	3NLDrjAHNg2q6MEpPDGdSTKZecQYnSggqKpKgfhexzXh677M2pfK	1406	1393	412	12463	14414	jxAYir8Ubjos4idu46jn1qiJPEtUMSoZ85i1cgsxQwX99zoRMwK	11159	15707	15707	1618766460000	canonical
22294	3NKfV1teVUidgULeRy6y5fW542coyX3R674FuVjzURfWEc5k4E8W	22293	3NK5q2jdWfNtiFbrDAPmC6zhY3HzD4qPBwM2FTEVdnkjySLYEZCY	1509	1320	412	12463	14415	jxQiVjDxwvgvJsMLFFuKiiHpLyE3SKHCyt4PnACx7gUkvX6A99S	11160	15709	15709	1618766820000	canonical
22298	3NL8ajehK9W36EpxHSoWxvzhbB6YSQdTFKFsjEEaiZQrvhiftXfs	22294	3NKfV1teVUidgULeRy6y5fW542coyX3R674FuVjzURfWEc5k4E8W	1406	1393	412	12463	14419	jwNVToMK3GeonT4kMRCNKdJxSYFyGEfCtWYZBhViRjfXDs82HGB	11161	15710	15710	1618767000000	orphaned
22299	3NL2xLE5CxE1uPNRhmKqkc2H5siFSxNkdyHSyqxAft7dtJK8Gct8	22297	3NLaQYfPqsUQoHMkYNmRmaUrMkKGbW2qfA6q7efsqgumuX4nsqGm	1571	969	412	12463	14420	jxj3CftLCnrBRLHCQEKScYkyjSHDQuodwUPkBv3S29AitcX61ma	11162	15714	15714	1618767720000	canonical
22301	3NLPJGBJfti8SLngmjyvbnP7pmC28sJ9c1W3ritMrfuni5cViqsk	22299	3NL2xLE5CxE1uPNRhmKqkc2H5siFSxNkdyHSyqxAft7dtJK8Gct8	1581	778	412	12463	14422	jx6NspMULFJAd3DECUB3rjk6gVVXThoD5r8jat6UkKgMZBtFR5b	11163	15715	15715	1618767900000	canonical
22303	3NLXdRjZX8bjNBtkXkwRW5LgqAhpB1du4tSUnrRdWAfb4SqCYiU2	22301	3NLPJGBJfti8SLngmjyvbnP7pmC28sJ9c1W3ritMrfuni5cViqsk	1513	1379	412	12463	14424	jwzKLULysagtGeNYouewSHv9xqJLvHPj6QnxavUsN3jS9BiwvsG	11164	15716	15716	1618768080000	canonical
22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	22303	3NLXdRjZX8bjNBtkXkwRW5LgqAhpB1du4tSUnrRdWAfb4SqCYiU2	1467	1130	412	12463	14425	jxBr3FKmMPfC3vkqvVUZTtnAh4NbNdiFMMggyQDV8v29fxbD8TL	11165	15719	15719	1618768620000	canonical
22308	3NKAudcJ2j2sJwYnS1Sjqdk9x5y9fPZCsoXHRt8g5zZezTtqNE2s	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1631	794	412	12463	14429	jwq6N9A2VTDWn2BAVv6fLWmiFaa61N2Aqaw6hwdht4k63rDBhd8	11166	15720	15720	1618768800000	orphaned
22311	3NLMUhAcMvdE1ny1xuRSm39XVTna2TrTrgLb9tnFg2XMmxbb12eV	22310	3NLjkje3EYgc3ZDk3641HA9MLKBH1mvQ5hSMZHHFNtxmhjLjFW1o	1406	1393	412	12463	14432	jxZVM8iuCk7qYE7mna9UsFv9BpkvgX9CKwqsdx9jZLZHenviuoF	11168	15722	15722	1618769160000	canonical
22313	3NKx8FcPo9efJ76vyXS2hdqkmvXKkwvu4TLcgKwSSHWTbXhYDoA6	22312	3NLNChTxXZwCHHSbwxuvaWEdKBZoU1wMZcpub1bLwmzhkoQdLmjN	1490	1148	412	12463	14434	jx6LwbUT1wfdo3LmjDWnTxnaRVceV8EcrR6wdiG4pwunZdw2iQT	11170	15724	15724	1618769520000	orphaned
22316	3NKHhpfjG34gDtjZDfx6Ed6EeZ2YqG2Vg3tkVJKhzx4sgerkscwC	22314	3NL9GF4JiFSf3L6Dfn1yGCzY6dUrkHM3GHcUoSmnTX5CNj8kZNRT	1642	1367	412	12463	14437	jxnw7wYBVieZPDHbFrtfFJtUDGU4SJYHZ6kBBjeCSAHNTAChqny	11171	15726	15726	1618769880000	canonical
22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	22316	3NKHhpfjG34gDtjZDfx6Ed6EeZ2YqG2Vg3tkVJKhzx4sgerkscwC	1646	1228	412	12463	14439	jxhceMBUgD21yL1Ct29dZYVtSkajXVakMPbZStxMf2REqhYy5Ya	11172	15728	15728	1618770240000	canonical
22319	3NKsvjXBWaMVPQfKYMKJ2o3diXH39eV37qgwisoGy47LATZhHjPY	22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	1420	403	412	12463	14440	jxagik14qcoDWNPdrckeFhyNKNtVJLEhiUPNoqKbJoBFMq6hxVX	11173	15731	15731	1618770780000	orphaned
22324	3NLfafGG7vcD4oo8UoRyQ74n4fqPVthKqgbde4dbwnobuPoxpGmS	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	484	1319	413	12463	14444	jwzoZoxYhd1JUnMBNsjRaFovFt9FeD8w2N8CCdonM1jGJz5Ruoz	11174	15733	15733	1618771140000	orphaned
22330	3NLvh9pMsDdGy5k7qE5kdBkMUGrZRhAra9ZJ1ctCqPtQHw2A1K3X	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1649	1257	413	12463	14447	jwYVUrETJe42MXLSVSkSHF1ZcYK9pK7injPXEVS7cz6mdJJ1k6D	11175	15734	15734	1618771320000	orphaned
22338	3NKTdtkoV6AqrDihx6ZvM6uPHRUrYDG1RJwdWB6cEeCT9c5Zps1T	22337	3NKuZb5pGAvcJP45dPKPrK3NcsCU9VHVAZCw6bA6QRuKkUjatH8r	1405	851	413	12463	14454	jxVdtbwbYhGCTHS3CofQT3XNchPtxd24YV3BCxzyYwfLge2555X	11181	15743	15743	1618772940000	canonical
27650	3NLcUA6u2hpPrarm3iZHhsqkiQa9uJBSTjXbC1n74eqJKB3GbR6P	27648	3NL5zauadf8w3bZusGrfP9aMepDoXNtiBvQcXWGpfGdD6R2k6Asa	1675	1096	539	12463	18974	jwxhsn1HGvwnSwGE65CQYMZDQU9uuaHmSP7iEE2riWj2rDNpSrL	13664	19246	19246	1619403480000	canonical
22267	3NLgpU8uZKwHy5Rcqp6MzTjay3TpVT6r7LShfTxkqVeMERMam9FK	22265	3NLbbT3faH2kyLfGi9Nw7ELBLWj3syBbqSWMBdaBDE3Fvu7LwURt	298	1062	411	12463	14389	jxV1digJYMp1yYy9CMhfEWaSTkqWZx5BDVrDDWSj1wjTnNULdJB	11144	15688	15688	1618763040000	canonical
22270	3NL6ZAQEmNeJnVbNyGhomRdH1yZ49qz7h7ZsBhFHpWhUZKvzAqzW	22269	3NLPq7Ud2wFpkTy94SB18pQJXaYVyjcTvH3hhLjqB4Jdd4S9b75A	633	1138	411	12463	14392	jx2pgmbGs4gmc4JmQhZavWYkhDehM66cDCJJCFoRjsZe9vXiZcL	11146	15691	15691	1618763580000	canonical
22273	3NK4sk5MDDGwCfpe6kLS27cHm4Gk9E514YMiuRBD7JE3z9JmMBVm	22272	3NKYh5BgM5rHWYvdmRtrZSoitLX48Jee1dhZf1bWMY5TgaMCjqEm	1407	1395	411	12463	14395	jx56oP6P5DRcR4LUQc6njFda96oai9q9ApDaW1UkrjmUb5QVU9o	11149	15695	15695	1618764300000	canonical
22278	3NKSq6FdcLn9W9azDytNQiSvYoAw81EKZpGhXa78f5qzbsGxrY8g	22276	3NLBXkm7QA1yQgbV1egwkJKzvA3ZWVgRZKyM7vGSV45kCm1hmyYB	1406	1393	411	12463	14400	jx58Kt2iSbST4bRUBHZCdqqZ731CQvpqjsu8uYnMMpvNoxSDCSz	11152	15699	15699	1618765020000	canonical
22280	3NL5YfbvugjpAp5rzYAKiMFLRCypBvz7KW8s3NjsGFgjTJtkS498	22278	3NKSq6FdcLn9W9azDytNQiSvYoAw81EKZpGhXa78f5qzbsGxrY8g	1406	1393	411	12463	14402	jx84GGRSqaDuWxmDQdh7mJmwanzM8Ap24hYnntAhBQDMcXNuBSj	11153	15700	15700	1618765200000	canonical
22283	3NKeTG5e6VZJgqkQZM9Z1Hi6QdfD29Hr3D5tQxJUyBNTxPjssBY2	22280	3NL5YfbvugjpAp5rzYAKiMFLRCypBvz7KW8s3NjsGFgjTJtkS498	1506	1373	411	12463	14405	jxLvkZqu6c3yiaWaPyZ6KFTdXsRZwNyGkmFBETNMgzVpgZjVvF2	11154	15701	15701	1618765380000	orphaned
22288	3NKSuVxpR374ZRumNtYPzDymkwcSPEnrZZ5K3rnxBxfgEKJuNZfh	22285	3NKfAkUi7eZRfJ1kxYnUQNfAZoCoAC7S143BEjZ13di84oCtSUTU	1594	1326	411	12463	14410	jxbfUxUpGynJr48xWxVJX5tVGnx5FocgBBwtnESVtaqvrGhxaF6	11156	15703	15703	1618765740000	orphaned
22290	3NKcExRePeUaWZiQxvSVdKDMUVb2MTm9pJYuSVMNgVrDsnTQCobV	22287	3NKRQpVNHds4p9LHNsYpTiwKc1YYCtruY5RH5oxx6YvA6RX8uGFd	1406	1393	411	12463	14412	jxPagAsxfdDrs5w8RmPGqqy6MjMLhvCuG2evjmYfhRgqMrWKSu6	11157	15705	15705	1618766100000	orphaned
22300	3NKHPKi1D9f1u595qM7AxK5zXURNGanj8y7EmSemncoQF2bt5Zh4	22299	3NL2xLE5CxE1uPNRhmKqkc2H5siFSxNkdyHSyqxAft7dtJK8Gct8	1406	1393	412	12463	14421	jwhzi8ZeGZTcyxRdM4ZjiVh69FjHjKF3qZAHqBy9SV47U1j3PLM	11163	15715	15715	1618767900000	orphaned
22302	3NLcj4ofBsUpJt4YHfgWdo5SUhpoLR2QYszPYYtxUShYuau3HiBZ	22301	3NLPJGBJfti8SLngmjyvbnP7pmC28sJ9c1W3ritMrfuni5cViqsk	1483	453	412	12463	14423	jy2fdzTcKiZWEnw6yYK4Uc2ASVEYsATJJfN3XFzBoReRfGwgBuo	11164	15716	15716	1618768080000	orphaned
22305	3NKEJwtNgd5nEJ61iiwte1wqsjpeVEPJczrj6G9D1pf1gV1fenhA	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1467	1010	412	12463	14426	jxNFrQf2NwLHGYEG2DFqGGjBx2bpGYLQBK6dKFRmyJDCDRV9ifQ	11166	15720	15720	1618768800000	orphaned
22328	3NLT1J5LsKazhmc7uUnxFKHxdaEVnZN9uReSaMxnMWnnUEL1f8S3	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1648	1284	412	12463	14446	jxM1ScJTFbMwgiQRYC6XJT9Gq2WUvwj85rkjV1gLVnLDvyHJUp7	11175	15734	15734	1618771320000	orphaned
22333	3NLAsPvVWTuRJM5rrveKWgj1WDr1aQC8Ep1ztVETwFyJpYRXpnKs	22331	3NLP9qAySETpNFrN7MSJXYan2zrTytSzu5oRHtEU64fHGGQuYByZ	1611	1341	413	12463	14450	jx6S5WSkKawZmD4kd2nuboJF8yAVFR9dnNGj2m3wqP94S6Put9v	11177	15737	15737	1618771860000	orphaned
22336	3NKVk1S89LDH46cWMRFLLQdPLNmu6JJRpv8crVWyFHosQD4M99NA	22335	3NL92WfeFymjGKxpvDs7csPVjG6Gv6QiWQP84BjYDwb8KKtssZqT	1651	1175	413	12463	14453	jxm4ZbCk1L8KR86ShQkJZiPPLMdXRFHG627ksaZSYTQo4umCmyw	11180	15742	15742	1618772760000	orphaned
22347	3NLjvX32i24cTgsBYZXtAuQvUReXkHpycbidVWLwMxo1AqMzN8ZT	22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	606	1049	413	12463	14462	jxNtNKhox2Vz5HSLUAEzqjjJUmNAqSVNtLEAMp5KFnTsnEhUWEa	11186	15751	15751	1618774380000	orphaned
22351	3NLSAhErBFEw3kh8YLyCaXvRMEAKZRopQrHXEubYZpyr366vVWYC	22349	3NK4YsHD7f27evqZ79mQYAkVYNZQMn7ysWti3HKtS8chzyTTCxpV	1594	1326	413	12463	14466	jxtRxHPNZDhDRZdtRJkPS9AepXaKHbBXw9NgqcAYAopH8nCTD2L	11188	15753	15753	1618774740000	canonical
22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	22351	3NLSAhErBFEw3kh8YLyCaXvRMEAKZRopQrHXEubYZpyr366vVWYC	1406	1393	413	12463	14468	jwzFdws39pwjiojzVLiBfgEDGY2xfdB3wK2rzkgAfavd6i5PWQP	11189	15754	15754	1618774920000	canonical
22360	3NL7c8RvjK8EgHDoMrYfsXf9g6SyPsApG68xqbmqH3jxsZyad235	22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	1405	873	413	12463	14475	jx8cBiZzVUX4ZQYPabLPfmYraWaVR9b6n3rimQPZ3YrRZ6aF3Md	11192	15757	15757	1618775460000	orphaned
22368	3NL2HopYXULN3F7patqM5xCbFTf4xTEnXeMBpPHEamttbuznoJUH	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	1476	1245	414	12463	14483	jxbP3wZA84UKvVKYgQTGUPaqWPTvVpRYFkzcJsVG7ordrjbkHtm	11196	15764	15764	1618776720000	orphaned
22372	3NLQgskBBr7k5JNG6bfvBFxbje3WWWwPkCL717feAz48S1NHe6YE	22371	3NKM4bacwZ7q2GHj3NAN2V3bv3bPD5JMabE7ykEN6LVQXqWgLyTF	1407	1395	414	12463	14487	jwd5cu86JEyub61Mw4vyff1TPmFuNCkfwUobsrTLfTfkL2HhdUC	11198	15766	15766	1618777080000	canonical
22378	3NLKv3ZrVdJUFB9CFhRBu6SLmuNRgxmkTdMmGA6YBWK8hmjj4HhX	22377	3NLKfi3P4zEMWAFCqPfTvXWcnE8qPCADfstK5u7rCYaYt9rHoty5	1631	794	414	12463	14493	jxsd8vxgB8anUgG3cdYux2h8nqMHDbkSaTnVxgSJTEYYiXKaDdB	11203	15774	15774	1618778520000	canonical
22383	3NKZ4J83LssQihtBg5P61PbNzeT5nmZkHCsBaD8DA7xg9zxkskoD	22381	3NLHgBdvA5eNkqmJhLoYyCXPT4zqqe1bRXGU85eyWDFBkqFYvhpK	633	1384	414	12463	14498	jwpcLphEhXA7TBEAtM9JFXHH7yMNdWJT2yWLLBXS9v3ZdMEWKXv	11206	15777	15777	1618779060000	canonical
22390	3NKW9CUrTfHNDgTAnT17pE32KGPo4yF6b6YpNZbhuxx4P69V7Jzk	22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	1407	1395	414	12463	14505	jwSF3wKYgRSsz8q2Vbyn2ja51aEtSC9Ky27k4cUZRYPQSV5wpVW	11209	15780	15780	1618779600000	orphaned
22392	3NLU5zaAxV2vFtpwPC7uxwtAD78CxM3n9qG9vjd16uAaCdvy42vf	22391	3NKiWTfPJKo5qPSswcCEQJJdLxgMKeitNMGtiE9XzZFaNcBjTrsE	632	1382	414	12463	14507	jxrdm8dDcnb8DfRjondb8TL9v4xXtmmhGRuHeM93Qyg26k8Jmfh	11210	15781	15781	1618779780000	canonical
22394	3NLUcbWiDYv7c6oBoXy8NFuJcFJFf4q1mVCL6RPxokzJVnRuzEi3	22392	3NLU5zaAxV2vFtpwPC7uxwtAD78CxM3n9qG9vjd16uAaCdvy42vf	1594	1326	414	12463	14509	jwymBjT3uuPxA6hFyXJLezN74mwhqSZ3H5SC9zn2ZvJ4S4smibe	11211	15782	15782	1618779960000	canonical
22401	3NLJwuLUP4fExngcLXUWdt3SY6ixJPYi2eeXGMnxmcVQVHAgQK1P	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	1573	1192	415	12463	14515	jx6CEXaHw1cxyuUbbTJqHVFK62YXh1xG2bAHiZ8e7QYSG4oxP17	11214	15786	15786	1618780680000	canonical
22397	3NLFAQuPHb8v7AJhVZwowLWpGDQJdWCgAdWJY6LQUwkwx7i1HKbg	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	1448	1065	415	12463	14512	jx9o2qvf8sKkPfcpbZaXzxs7yEz67pNTaPBywJBZkE3Pr2qBYvT	11214	15786	15786	1618780680000	orphaned
22400	3NLnnytvrPiuoPhdb57gsfxjvBM9JT4pFhCjtEUq4PMhz96C1z5r	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	1448	1065	415	12463	14512	jx7Gpe6Dxz7TdYfQsHiW6zd67tohuVx7LDpw3wtd9X9w9NsCaHZ	11214	15786	15786	1618780680000	orphaned
22409	3NLfVcPjbf6fSBRgNJz19QU4zeUNxX65CXqNi5uMx39a1V3cw6cZ	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	369	1066	415	12463	14522	jwQDjHfHdYmegX4Vci9XyFkXgc7zUByuJFmpyiPR7jhEcwnbhCi	11217	15790	15790	1618781400000	orphaned
28026	3NL4YPyzvAQRTpgEpvYjtCVsDH9JbWGrtcNa9GsZ8kRmGTFFQxr9	27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	1671	1119	539	12463	18974	jw8U4oAFNiv1y5m5P72bRD2oH52VP29Y6trwsN8bE67thjJfc6V	13667	19538	19538	1619456040000	orphaned
22309	3NKr84ueCwbPCPfjL7QiU6na6UbQzNwxo89h8MJhQebhBPKHUd14	22269	3NLPq7Ud2wFpkTy94SB18pQJXaYVyjcTvH3hhLjqB4Jdd4S9b75A	1607	1222	411	12463	14430	jwPbSXbGZrWUCEgkHEXJP78vQv3PKqePUNKZWJNzVP8MTkjhrpA	11146	15720	15720	1618768800000	orphaned
22354	3NK6GYjJzBK1SULhfqCfVFhrG1UcNCgXivazkpUPwjFrYi8Hb24k	22297	3NLaQYfPqsUQoHMkYNmRmaUrMkKGbW2qfA6q7efsqgumuX4nsqGm	633	1384	412	12463	14469	jwKctvyx3Uk2WbfN5W7J1ZDiKVAE1sYMp8ELtv2LWbhaB69GU7p	11162	15755	15755	1618775100000	orphaned
22306	3NLuwdGgDZMy2WcmYYLgThAAT32tAwuC7y1D2r9Q3Xn7sgzWLeYj	22304	3NLAg7XQUoCBytzkaKMRXhZAhLTMT4Yjw51sT2jv6kR6JbdhVqwk	1607	1222	412	12463	14427	jwFgbc72uvHHaZzjLotx1rbZ7LbAY2cwse4UXiUrfB1zRZTs4MT	11166	15720	15720	1618768800000	canonical
22310	3NLjkje3EYgc3ZDk3641HA9MLKBH1mvQ5hSMZHHFNtxmhjLjFW1o	22306	3NLuwdGgDZMy2WcmYYLgThAAT32tAwuC7y1D2r9Q3Xn7sgzWLeYj	1406	1393	412	12463	14431	jxrVw4t8o4qycoZZLrms91zPiF8Ru9NAjmgCyFKEzpqVG25FCUz	11167	15721	15721	1618768980000	canonical
22312	3NLNChTxXZwCHHSbwxuvaWEdKBZoU1wMZcpub1bLwmzhkoQdLmjN	22311	3NLMUhAcMvdE1ny1xuRSm39XVTna2TrTrgLb9tnFg2XMmxbb12eV	1403	824	412	12463	14433	jxSnfjtzyonn7Soh4Sng6uQQXB2oBjLyHkYQxbC8pyiATxMVU7D	11169	15723	15723	1618769340000	canonical
22314	3NL9GF4JiFSf3L6Dfn1yGCzY6dUrkHM3GHcUoSmnTX5CNj8kZNRT	22312	3NLNChTxXZwCHHSbwxuvaWEdKBZoU1wMZcpub1bLwmzhkoQdLmjN	1634	1085	412	12463	14435	jwH8hZ1KwAVnbjvVAvuC87RrmrAwYGc9LRDVisrkkFuYHYjjY19	11170	15724	15724	1618769520000	canonical
22317	3NKtBkr7cTCWNi6AjKKGaj9sXWhu6KiUGRNVTY9EKsYA9MkgXf4H	22314	3NL9GF4JiFSf3L6Dfn1yGCzY6dUrkHM3GHcUoSmnTX5CNj8kZNRT	1623	839	412	12463	14438	jx8i7q8mhpui1NtFu1xJkV427VKbGL98r3HkAUiPq8t5Pih5dr8	11171	15726	15726	1618769880000	orphaned
22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	22318	3NLoC95SyVW7LdWNkdw55kGMrdyvxWXCFhpvrnF9DSdPTsCvRA5o	1403	824	412	12463	14441	jx5NCoPauEP3TMLPphogBFHbx85dRc2uhPma6Eq6ZADNnjk8wjc	11173	15731	15731	1618770780000	canonical
22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	1477	1224	412	12463	14443	jx7HrJXZhDdSzgy6HaxXJ5HLr9DvK3j8YRSYsWhP4JCcnR5kcB6	11174	15733	15733	1618771140000	canonical
22325	3NLnyzHTAdDh3723UBmY1Rvt3Xywc8jeBoPnWbnwdJEecQs2t949	22320	3NLKsPT43B3sCPfJAV4iYpxedbR652wCrPAua76o6ENkgSyuLBHv	484	1319	412	12463	14444	jxDkYZHBu7JjJURrNkJNp9S1XvqHmBq89RGAHNxeAb66b5pM8TV	11174	15733	15733	1618771140000	orphaned
22329	3NLAAoqWW2Dkd2ZnBVH6RUPjABXoqc4psYDhXZzwpSsedsfH47Ru	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1649	1257	412	12463	14447	jxsymKjJMP6BKChFBjqd6c1hmBdMQUg4n5Kn5ygEUtFe14uawQ6	11175	15734	15734	1618771320000	canonical
22331	3NLP9qAySETpNFrN7MSJXYan2zrTytSzu5oRHtEU64fHGGQuYByZ	22329	3NLAAoqWW2Dkd2ZnBVH6RUPjABXoqc4psYDhXZzwpSsedsfH47Ru	1647	845	412	12463	14448	jxJVoZbzqN2Mw4YQKGYFJce1bWsg1G9g8CkkUXTAiK8YAvoiQ8C	11176	15736	15736	1618771680000	canonical
22332	3NKh9PUA3u1kbJZ9TjgQb627eCb6563Ku9BgwvP9maUVY89Wfnew	22331	3NLP9qAySETpNFrN7MSJXYan2zrTytSzu5oRHtEU64fHGGQuYByZ	1457	1391	413	12463	14449	jxH54YsriHLDWPEzXzBknnk9hmDdaAXJa966crMf4iVskCddEaF	11177	15737	15737	1618771860000	canonical
22334	3NKY9uciGyTjiHSWNaWFz7q1Vs1LWqvnW84iuvDfpzR8bEumnbqS	22332	3NKh9PUA3u1kbJZ9TjgQb627eCb6563Ku9BgwvP9maUVY89Wfnew	1617	267	413	12463	14451	jwDsc2Eje6jwUuLVapNkqQgCXDobCAkSSPQuCaQDQgvFPR5Xg5m	11178	15739	15739	1618772220000	canonical
22335	3NL92WfeFymjGKxpvDs7csPVjG6Gv6QiWQP84BjYDwb8KKtssZqT	22334	3NKY9uciGyTjiHSWNaWFz7q1Vs1LWqvnW84iuvDfpzR8bEumnbqS	1536	1313	413	12463	14452	jxRMyYs976xhURNtmJfmnovpos8gMo699tRjNQ9rLgJ8f9ShdbD	11179	15741	15741	1618772580000	canonical
22337	3NKuZb5pGAvcJP45dPKPrK3NcsCU9VHVAZCw6bA6QRuKkUjatH8r	22335	3NL92WfeFymjGKxpvDs7csPVjG6Gv6QiWQP84BjYDwb8KKtssZqT	1651	1175	413	12463	14453	jxbecxtVpeWkFk1KNja2893nQhVGNkMn4s8s9YJNWa7SKdSM5Hc	11180	15742	15742	1618772760000	canonical
22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	22338	3NKTdtkoV6AqrDihx6ZvM6uPHRUrYDG1RJwdWB6cEeCT9c5Zps1T	1406	1393	413	12463	14455	jxS642kvgpubF627e61ufyrR2Q52sGZRftyBeQGgMvrLSobfgaR	11182	15744	15744	1618773120000	canonical
22342	3NLnRoidFepBbx7h1CWU2yCEfXdigAUgpBNyzM5XS4x9KF1qBtye	22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	448	1305	413	12463	14457	jwPFbn8oBDbRU6nAXm3zYRn9QQNfzHvmb3fDgjAcT3CK8Bs5Qxb	11183	15747	15747	1618773660000	canonical
22340	3NKKGWmwz5HRmQo3ZsuYQ7wP2e3uaopFPCygLYDRjTC7M42Dubxk	22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	1627	1139	413	12463	14456	jxbv7obC1CpijHxn7DcPWbHLuWWHxzZdrjdZxptELWEVM9SpTq7	11183	15747	15747	1618773660000	orphaned
22343	3NLApGk52p3yjkW2b9eRtabDyzQLQQynzUvJAA8hC5XzyxWrBJxd	22342	3NLnRoidFepBbx7h1CWU2yCEfXdigAUgpBNyzM5XS4x9KF1qBtye	1421	375	413	12463	14458	jxW6UAdVGUkfSudAHmJG1Sz4V2XwMeMzcxCSQw7W28Vbf1WqnzB	11184	15749	15749	1618774020000	canonical
22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	22343	3NLApGk52p3yjkW2b9eRtabDyzQLQQynzUvJAA8hC5XzyxWrBJxd	1637	816	413	12463	14460	jxiREwL7EiGKx6kdhWXZ1HrJCW1ZcR4rbNYPQA6py5X8ArgJyrY	11185	15750	15750	1618774200000	canonical
22349	3NK4YsHD7f27evqZ79mQYAkVYNZQMn7ysWti3HKtS8chzyTTCxpV	22348	3NKGh3L9PC3dExigr9jmeEKLF8dCn6GJ8xRjgnQkWdhyugp7P7by	1624	1334	413	12463	14464	jwfv5SFH7sHAn26QMq87EYDMKnVrKPb3Hg4L3T4z4BaY3LmscX7	11187	15752	15752	1618774560000	canonical
22357	3NLXZtMgDUeJ7HrMkA43oCShbBGuJJvfymHDvvxu9offusT5Xhjr	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	633	1384	413	12463	14472	jwvWJ87WvPsBC5nfqYMnwWz2gN1BsDwJAZtL2rxkEMvpr38Mviw	11190	15755	15755	1618775100000	canonical
22356	3NK3NYX4Uh3A9qqt6byNZ4SzNSMJM2Pr8DDvU41KGpCZnmymCUj3	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1529	1316	413	12463	14471	jxnjJgZ6B6M2y8xTNh68FEft6TaQVb72xsTk9LXUpWCKn2AjbHn	11190	15755	15755	1618775100000	orphaned
22361	3NKxATZVMuCsKdDFxp9yr34kJLgTM9BNRaFrFYRFLdK2Mr16gde4	22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	484	1193	413	12463	14476	jxJmHwRNH26v8M8pg4j5dfmhUmxpGknnSSscQ44qcTZzSbyaSmf	11192	15757	15757	1618775460000	orphaned
22364	3NKhJ1pQ6rV6DsKcPnCLMN2PHgYEiJGqjQwkLTVy9XXUji6Scsij	22363	3NLriWpM51ieFcQ764uKTLkcVUggbqf93QW4L7Ps1JtaEB67SGWc	1407	1395	414	12463	14479	jwq5mAbD8txUpVDUyagFqvEQZbnenzLxZfnteCHk2gNZpWCQ3Pq	11194	15761	15761	1618776180000	canonical
22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	22364	3NKhJ1pQ6rV6DsKcPnCLMN2PHgYEiJGqjQwkLTVy9XXUji6Scsij	1403	824	414	12463	14481	jxMwG9iD4potpJUwgKFBSKt7GBi1Svf2Q3tTjN7MXWjNsMjcCsU	11195	15762	15762	1618776360000	canonical
22371	3NKM4bacwZ7q2GHj3NAN2V3bv3bPD5JMabE7ykEN6LVQXqWgLyTF	22367	3NL5g8gVA9ZNHdD3CwuqkL35N5L36etq2mRTQH8khcc7HQaC6SRT	1460	107	414	12463	14486	jwDUVspFnomnxMzq6UintG7bQtP55aDM6atXy7JBSEBfH2LEfnM	11197	15765	15765	1618776900000	canonical
22374	3NKepU63bCpwkXWEeC11dmR39dRRxy3zAZsMjyzpQXV95yBou6Dz	22373	3NKRZb8NviMHjBSqYTE5hVw4uaheiCkTQEZYoGVbZvpDF71adfUp	1522	1322	414	12463	14489	jwoiXCDwy774F3NtA19K8Mqz9CBQs3kNrE8YKd89X5gJftBijyD	11200	15769	15769	1618777620000	canonical
27675	3NLnsULpPE8NHVxC2TjygRS4uUNGvVCTkimyzFctkshgxQkcJnur	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	44	1325	539	12463	18974	jwkDpj1bVRdcgBmfaHv4tHZx9RbYsy2bhfY6G9ENrs3xnKw5v52	13675	19258	19258	1619405640000	orphaned
22382	3NLtKvd1ZuPUEKNF5Dz71nxaVVFKN44czw2THyVMw8jEw4bLNTD3	22354	3NK6GYjJzBK1SULhfqCfVFhrG1UcNCgXivazkpUPwjFrYi8Hb24k	633	1384	412	12463	14497	jxYyn31LUxwCLhTCqFMcAeBWjoQW3UdcZvjZQwJmYksNJGPehxu	11163	15777	15777	1618779060000	orphaned
22350	3NKiELNcXctH6BTUN2HsnMzcqc77xfQs5NdvpGPmyaDSJVAreezk	22323	3NKyXVeiEbZC6W7JyetpaRzzqSox7ypqS6p8j67DLwqfWqXGw4rW	1624	1334	412	12463	14465	jxHcQqLq8aQ6AWyco1DeYxok3aqwQeS9WgKJAQacFEiMW21waKe	11175	15752	15752	1618774560000	orphaned
22435	3NLxZkcBEmeLSU96YHUFEDxyTEbd8A7CESsJ877hEhuSG8B4Y8ie	22350	3NKiELNcXctH6BTUN2HsnMzcqc77xfQs5NdvpGPmyaDSJVAreezk	1624	1334	412	12463	14546	jwn6zKJaA4SDsaanra46UhZ9aP7Hh2SQ3onKQqA7aUkcfE5Pccm	11176	15805	15805	1618784100000	orphaned
22341	3NLTjapkcLs9QbaxKoJjVxpU6wVvxm23HGgMV9cjkj1bXEaokmGj	22339	3NLtCANTr84RKiqedRKGccwnmn82XJYp1SkT8gKYKbnjpgaUMjqZ	448	1305	413	12463	14457	jxrH7BTk7UfD3z4tobzRGccz96wvqdF4wjCyYgVZBL2z4K6UfBT	11183	15747	15747	1618773660000	orphaned
22344	3NKGkRj5AsAYKmq3W4TvXMGXjL5Eq1H6SiJfdsGFY2U67JAYTRhj	22342	3NLnRoidFepBbx7h1CWU2yCEfXdigAUgpBNyzM5XS4x9KF1qBtye	1588	1392	413	12463	14459	jwz5oqum8dAhZ3Bw4EvrpgLMBcXWSCtTTo4NixdwkgUnxJecxXE	11184	15749	15749	1618774020000	orphaned
22348	3NKGh3L9PC3dExigr9jmeEKLF8dCn6GJ8xRjgnQkWdhyugp7P7by	22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	1507	1034	413	12463	14463	jxU1iAPDdczkCcCAuZGhiKAcvo2X8RRxD9aFCK3AaR6fz2EDJgp	11186	15751	15751	1618774380000	canonical
22346	3NKCpNW5w8n9bHCPCKywosz3F1pL2FDXrPhVzJ3wP3kwgxLW1xqf	22345	3NKRwzCvCPojARXo3J4JEpDLhZUHf8MTjognbe6oKufvGfYna4WB	80	907	413	12463	14461	jxRTnbKvjgEphWPfHCzRpYygbatXYCyBvbkvoyc3mdLBzyuZyDm	11186	15751	15751	1618774380000	orphaned
22355	3NLV8Vv32rScpPLdDvjfwewgppCF4srjy4bvM4B5CADVAcmymf1u	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1406	1393	413	12463	14470	jwYoSSgGuToHGkCvh2BM94fHe8mJFgUUuR47ut5gc5PVcGEc2CB	11190	15755	15755	1618775100000	orphaned
22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	22357	3NLXZtMgDUeJ7HrMkA43oCShbBGuJJvfymHDvvxu9offusT5Xhjr	1501	1114	413	12463	14474	jxJs1ha1JBbgeXwc2RQ7WRtFZkHfA3xQCUeYZdbFHmVraPiPD7V	11191	15756	15756	1618775280000	canonical
22362	3NKPyG2zbG14XR5687oqCSAjrSJ3FFh5zpJ4fnmeUzQN8Ryky8xX	22359	3NL9DFU2PjCRvCgSXVHvimWFQxr4rbzP5FhKJrXJLCghVkywi6fS	1593	1346	413	12463	14477	jxfHJ9AgkEWvxV3MvGsXWcQxjEJmaykkAzn8hNiZ8UskRJZK7Dd	11192	15757	15757	1618775460000	canonical
22365	3NKe1ZG33gHjeZfvLpzRiyoAaCkpvG8S9vNGczenaxZokNAa1yXB	22363	3NLriWpM51ieFcQ764uKTLkcVUggbqf93QW4L7Ps1JtaEB67SGWc	1559	1353	414	12463	14480	jwWhnGJ6rFBij3FgzKtEiygMLVQdggzoPdToYFh8tTGaiWoifxG	11194	15761	15761	1618776180000	orphaned
22367	3NL5g8gVA9ZNHdD3CwuqkL35N5L36etq2mRTQH8khcc7HQaC6SRT	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	1403	824	414	12463	14482	jxeVznro6dyMbFQZS5Zh2Q4qz45da5JsC4637VUBmpHh26uLRmu	11196	15764	15764	1618776720000	canonical
22370	3NKqbhs7GLG13UcRhk1cXN2h6Cckd2yy9r6yiATCooa5pFjaiiRf	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	1581	778	414	12463	14485	jxySNvUp6ZArKCarbWYRLRHSNeS8ZTuKrAYVKmQhGsA8SuFFQwQ	11196	15764	15764	1618776720000	orphaned
22375	3NLCDH63xbvyruT9e5NubM7VSLXunHwixJ8McSMS5emaLHVpFJKX	22374	3NKepU63bCpwkXWEeC11dmR39dRRxy3zAZsMjyzpQXV95yBou6Dz	1457	1025	414	12463	14490	jxagmzqC9aZvFMJ26aTQZdf5Hg1gNeukMZvvwWMy8iV8wTZad8s	11201	15771	15771	1618777980000	canonical
22377	3NLKfi3P4zEMWAFCqPfTvXWcnE8qPCADfstK5u7rCYaYt9rHoty5	22375	3NLCDH63xbvyruT9e5NubM7VSLXunHwixJ8McSMS5emaLHVpFJKX	1425	184	414	12463	14492	jxeBhS914cbEyjqJKFpKLP3H8UYh6JNUnGiaxvGDDJRCjPp6wGg	11202	15773	15773	1618778340000	canonical
22380	3NKBLWRtV25Yg1BD4kkhDJE8zffZUVxc5L6QYtxH9X7gfYvnpekU	22378	3NLKv3ZrVdJUFB9CFhRBu6SLmuNRgxmkTdMmGA6YBWK8hmjj4HhX	1460	1324	414	12463	14495	jxytRkygwLu97sYfX51k1PCoYsJA2eekW77iFhbGzLUCxMSnYNH	11204	15775	15775	1618778700000	orphaned
22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	22383	3NKZ4J83LssQihtBg5P61PbNzeT5nmZkHCsBaD8DA7xg9zxkskoD	1649	1257	414	12463	14499	jwazZ7isgiz35n3SWsH41HMg2SzuwTcxkhATMjsqC92YAf4Ftpx	11207	15778	15778	1618779240000	canonical
22387	3NLD2zLnF1xjJeBSMjqvgWtkVPYEe8YdvwPt8HxQARSpoxCS48iL	22384	3NL27sRKnKorzdfxcHo7Fp6RmhZVhRbGdhTFNjNaaAH81h8FcWFX	1623	830	414	12463	14502	jwMWBtHGEu2kMTZg2FnXFisatZ9iJ6aJr4neSJG3WXjPqGFDZYe	11208	15779	15779	1618779420000	orphaned
22391	3NKiWTfPJKo5qPSswcCEQJJdLxgMKeitNMGtiE9XzZFaNcBjTrsE	22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	1560	1045	414	12463	14506	jwEjJ7c2xJP4GEDfNvzAiiSBBZxziZXe3cGcyNg3S4jLyZc3tiX	11209	15780	15780	1618779600000	canonical
22440	3NKy9kMb3Zd1L71bwCNYBJsP78qqCA4CdNeit6XgC5qoKCDZ1SqY	22385	3NLRbd61CMu32ngBq4QXPQD7soViawAGohwySQDtJDysCYaLYne9	1601	1142	414	12463	14551	jx8dCuSrQJjyd4ipAzDQLeoaJFyTyA15D4dZNy2FagVbHG2dSoe	11209	15808	15808	1618784640000	orphaned
22403	3NLMkPJUStGcggxAR35CVeNNLUNreZmdE2jqVbUj9REDRqj7VDF5	22401	3NLJwuLUP4fExngcLXUWdt3SY6ixJPYi2eeXGMnxmcVQVHAgQK1P	1637	816	415	12463	14517	jwVFnWaWkdWUqskhHziHK31MT3JgEiYvC9verdCGVzQcWxsN1DT	11215	15788	15788	1618781040000	canonical
22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	22403	3NLMkPJUStGcggxAR35CVeNNLUNreZmdE2jqVbUj9REDRqj7VDF5	1405	851	415	12463	14519	jxZcNNG5vkUoDZKwKGCWZQeEEAMB4hedXHsmHQoN1bTFZyPyYEe	11216	15789	15789	1618781220000	canonical
22407	3NLy4NRym53qoJixy5sQ5oLNc8WqK2oxP9W6RHrzmeUwSriUZP8p	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	606	1169	415	12463	14521	jwVK85YZ6QRFn92pY1iyCfCwVc9SGZXcNTMjnT9i26reWV1EZ4v	11217	15790	15790	1618781400000	orphaned
22419	3NLh5tW8UshFAY1E2N5s7DTzhdvMy2XMk3W6JMDnGLyxmxNXcwos	22417	3NL5VL3B4bHFUTojLDDNXuHHR5QuXFbeeXqXBh5r563G3hwPdKf3	1406	1393	415	12463	14531	jwFtn46WbqKw9ASBLZwaN2hmSdbGZWSX6onscBY2UCVF9KaPGqo	11222	15797	15797	1618782660000	orphaned
22422	3NLSTVqiTLvGxWd9anb9CdFYsNsGR3Bd3Pc1BfAYVSoRUBCVXWZa	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	1503	1151	415	12463	14533	jwKAehaKVB7hC3cnk4vT4hbdxpoi2YV5bVLbD6ZQj1o6DvbJQya	11223	15799	15799	1618783020000	orphaned
22426	3NKvdv7mRSYTMadqi4oUnVdo5AmG6U6fTGtuVnSMUxGtaJ1ucZ8E	22424	3NKdZMq5b8G5UwqXFoutFxZPsjk4uTRYFsYjEAmKdmeiMY9qwpAC	633	1384	415	12463	14537	jwvsgWVEVtre3JV7hx6aRv9V3L8upK21HXVFyYrp6LPRJTq8y8s	11224	15801	15801	1618783380000	canonical
22434	3NLACG2eg5D7H1LWAomeoM2s2rykS3BR9yEgmdPm43SSHjXArVzA	22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	1624	1334	415	12463	14545	jwB2GsRCNBZuvvyYDJqofZaZW7T6xjg71uEhhqGSfc1cE4Jw7F4	11228	15805	15805	1618784100000	orphaned
22442	3NLg31YFB8c7NzYy3RQbjNQypA3kps8UWREKr32GvRHYD6q6M89G	22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	149	1037	415	12463	14552	jwZeVB324xuR2sKYYuG9rrvZAxKvd1gEWqj9qnaAdWuAQ7zd8ce	11231	15809	15809	1618784820000	orphaned
22444	3NLvHJ24bGxuLZ3JYHYUTr36vBv8eqAe6oACfdnG7KNwDLV7RHEM	22443	3NLZLUYciJ5GUrQ4ijV48HdEy796tKNjztnijW4y9QwthtVB6gLB	470	1183	415	12463	14554	jwY9CzFijkGwAjz22T325RyBhbGtKxRsX91iLgKYyaRUsFQce2k	11232	15810	15810	1618785000000	orphaned
27680	3NLqfdfg1WTiFokse7WmBGwNvEaniDTKPezqj3sqo4nVhHndpcbx	27678	3NL2kDTMXVgkNa3NLEkyjXei8Q6qNomzr7JQWKkUshK7evYvpFMD	1407	1395	539	12463	18974	jxtRW4T81Yk98GupGxyCbrUXoqsyGiQPZCTzCcynxzKMbwV6Y58	13677	19260	19260	1619406000000	canonical
22388	3NLW7LVMAAhWSab13U3s2Q9vyaNgCHH4e6f3cpeMxJP81ptn8mJz	22353	3NKDNZjTSxkDs39HWNUHLCvi6uRZfXuUr59JL1gdhy3ofpupaHRR	1608	1043	413	12463	14503	jxafMUY2VRqM4WoHenP1Yc5EATVUa6Q81FEt2KndNHPDxHWayKq	11190	15779	15779	1618779420000	orphaned
22404	3NLyNpJRGMGDX5TCHdcjQJRuscip7hM7yopSJ9w59WSpsmpJV75z	22388	3NLW7LVMAAhWSab13U3s2Q9vyaNgCHH4e6f3cpeMxJP81ptn8mJz	1608	1289	414	12463	14518	jxNSaFPmxPTTrWaDpgFYUKuiaAjUJgFpCqvZhYQqzLU9CVEPzZA	11191	15788	15788	1618781040000	orphaned
22363	3NLriWpM51ieFcQ764uKTLkcVUggbqf93QW4L7Ps1JtaEB67SGWc	22362	3NKPyG2zbG14XR5687oqCSAjrSJ3FFh5zpJ4fnmeUzQN8Ryky8xX	1419	814	414	12463	14478	jwpmeSLycRQJ49FSuiaAiC9uQ9JiZBsn4D8GZXFtTxUjAq2ZZMU	11193	15760	15760	1618776000000	canonical
22369	3NL5dnw9rCuASfWVpqboauNBcSFw7JijVnRqdcdhuz81pE28LUy3	22366	3NLcxcPN7fJ8tFBwfqXH4GadY1AFfzoRqRgAuSgiydVZ8wxVtjiK	44	708	414	12463	14484	jwhHBAMY1uLUQNuiwqAw3yuUUWHkNw1HagbKQqRo6ABCGkzf2Jt	11196	15764	15764	1618776720000	orphaned
22373	3NKRZb8NviMHjBSqYTE5hVw4uaheiCkTQEZYoGVbZvpDF71adfUp	22372	3NLQgskBBr7k5JNG6bfvBFxbje3WWWwPkCL717feAz48S1NHe6YE	1407	1395	414	12463	14488	jwtJYbiHzu6Ggri8GEBSZFZBu3Sek7QxPBmFx67caT8hTcD4QJ8	11199	15768	15768	1618777440000	canonical
22376	3NLwAuwUdZG76hxCd66uLAEd6kUxCZViVWzEMZNKUCjDPoGoEgsZ	22374	3NKepU63bCpwkXWEeC11dmR39dRRxy3zAZsMjyzpQXV95yBou6Dz	1646	1108	414	12463	14491	jwV2uyUQFf1Q2BJAm4PyBvggShY2AESj7yWxcegoRKBim5LZ5N5	11201	15771	15771	1618777980000	orphaned
22379	3NLn9gCXH932NegHwstmeZxJZCgTfrtfbeCUd3BqCVy5EqAdZ79y	22378	3NLKv3ZrVdJUFB9CFhRBu6SLmuNRgxmkTdMmGA6YBWK8hmjj4HhX	1407	1395	414	12463	14494	jy1uhfiJ63n6memBWxU3wKq9Dz1E578L5XnJzHaAEXn3Rs1ttku	11204	15775	15775	1618778700000	canonical
22381	3NLHgBdvA5eNkqmJhLoYyCXPT4zqqe1bRXGU85eyWDFBkqFYvhpK	22379	3NLn9gCXH932NegHwstmeZxJZCgTfrtfbeCUd3BqCVy5EqAdZ79y	1536	1313	414	12463	14496	jxPWG4VgVMJ99hVkJKHd1ZW5ephXyWXq1q48X21jbhNyH4YxWtu	11205	15776	15776	1618778880000	canonical
22389	3NL8MqxsSbhK2K4dYj68Y6vKnLsNhAHYj13dT3mCa2kWXq6oYdQR	22386	3NKGcenSjRTvd7718mNAkriHEX5LG8D3Qc54hpt8HADG5DUXm6cc	1588	1266	414	12463	14504	jxZ3qsnT3mnDMDWHZC9Ha2EyKkADtw7wmiQmt3xYBZv5wy54Cmf	11209	15780	15780	1618779600000	orphaned
22393	3NKQJsMw8gYzF41p58rt4DEk3zXbfH8uScasVpEVfjrpMMQg2GJR	22391	3NKiWTfPJKo5qPSswcCEQJJdLxgMKeitNMGtiE9XzZFaNcBjTrsE	1581	778	414	12463	14508	jwUfP83AiaWR6kJLM8Pip9jZWiVSUg5gSrtXaJ9XjscizKru2Ju	11210	15781	15781	1618779780000	orphaned
22395	3NK9JYo5eVLYnorswqf7qxtLQWkTG7TR9Y772TfB5rnK3ufLJi7n	22394	3NLUcbWiDYv7c6oBoXy8NFuJcFJFf4q1mVCL6RPxokzJVnRuzEi3	1458	1197	414	12463	14510	jwAeHi89Pm7yKJTy4PwiTWzGEmJcHfyKW26vXgFxU6JL45iC8UC	11212	15783	15783	1618780140000	canonical
22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	22395	3NK9JYo5eVLYnorswqf7qxtLQWkTG7TR9Y772TfB5rnK3ufLJi7n	1633	1264	415	12463	14511	jwM39h8zW3pEF9xDvR8fxmKH87UJzAwzmWMXQ7g7Vb1c1dKB2xU	11213	15784	15784	1618780320000	canonical
22398	3NLBvZdJr3rm6knhUwy8LKznBYB1h6Dg3BR86ZDHTCSJqmmNx8Mt	22396	3NL6MmTwV26dpftz1bpirFexjzpDgrLhxd2BKyqpBdsLfMwwmkP8	80	1147	415	12463	14513	jwdKfxHjvN2LKpLRoa7HBU7nKThXs3gZm6QfmWocVPZQkrarJ53	11214	15786	15786	1618780680000	orphaned
22402	3NLcvRs7kaEGTG71FBRuWMBcZq37D1HcddCgjLiZ4LeBsKzKWWcj	22401	3NLJwuLUP4fExngcLXUWdt3SY6ixJPYi2eeXGMnxmcVQVHAgQK1P	1608	1289	415	12463	14516	jwx8iXNAC5RBdp3NCGzo8jVEt21WzD7z58Bz76oZfthfJFzowN4	11215	15788	15788	1618781040000	orphaned
22406	3NK4pkcNmEqbSsekBMWmnVy8zmrff5Vt6aMQi1dC1i893Cb3mvsc	22403	3NLMkPJUStGcggxAR35CVeNNLUNreZmdE2jqVbUj9REDRqj7VDF5	1407	1395	415	12463	14520	jw8DxyZqpCqU6hGv7DqWRQ9MCDGfT4KL72kBhDF5raDQAZpo9WH	11216	15789	15789	1618781220000	orphaned
22408	3NL2P17N6Pc7JJWHThq9Mr3qyKRoNQbGJ1ZGw5YXxHGZgqi6tPKv	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	606	1169	415	12463	14521	jxqsuoYjGd2jpKTVTBanCGo8a1nWcvFzWEtEQfwbL8AnihyaCgJ	11217	15790	15790	1618781400000	orphaned
22412	3NLKBbw8c2LngKFAsifC9t5A7MZijkQgVvmhgpYp8setAshGHvAf	22410	3NLCfgBRvVVXUv8wT9Rg2ezgS1asZKV3qaKJC1P6atRno4ktNLxH	1406	1393	415	12463	14525	jxAWK4sJbuQ2RuXmPW4qpNzt9DSiwQN2FsKVFwaAWsZzAENEP1S	11218	15793	15793	1618781940000	canonical
22417	3NL5VL3B4bHFUTojLDDNXuHHR5QuXFbeeXqXBh5r563G3hwPdKf3	22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	1590	934	415	12463	14529	jxDVBdTJwQLhXUoXx6CcdxVhM9vcPeo2bMQTVHK23KFs6fEYAZo	11221	15796	15796	1618782480000	canonical
22415	3NKscSMBzJRnUQpgADvQYVzFskvdt22Le1tTMf9yVjh4mvz8xshv	22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	1547	1132	415	12463	14528	jxJkNx1QQqRH3RzG1F2SPCg9mYRfDgK8eDNrzGQ6HtzMAPwTuDD	11221	15796	15796	1618782480000	orphaned
22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	22417	3NL5VL3B4bHFUTojLDDNXuHHR5QuXFbeeXqXBh5r563G3hwPdKf3	1617	922	415	12463	14532	jxRcxrndfa8oqrhMYvtt5ZJNsj3PB7SyFUzZ3FVu8arnrYup7tV	11222	15797	15797	1618782660000	canonical
22424	3NKdZMq5b8G5UwqXFoutFxZPsjk4uTRYFsYjEAmKdmeiMY9qwpAC	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	1559	1353	415	12463	14535	jxG8wVpX8DivsKchjqmUfRqghVYJR1PMKmW6RD6kSVnpuH3e89k	11223	15799	15799	1618783020000	canonical
22423	3NKxdKN6ueZPTQDotzHBF2oLSbGJkPpM7fSBEZpAhzeNQ5xyL7Dv	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	369	1066	415	12463	14534	jxtzygjmoqKkbm6pVxuy1YoqbodHgHsbWY3oqcovTWMNBDnHAxD	11223	15799	15799	1618783020000	orphaned
22429	3NLV7PuHuGNFamWbQUgVq1GekevoqQgGRc8dTvDA7WW6DeomzRqZ	22426	3NKvdv7mRSYTMadqi4oUnVdo5AmG6U6fTGtuVnSMUxGtaJ1ucZ8E	1573	1072	415	12463	14540	jxLziEZF4Xj8s1yfQUgzJWGLfVhtyosF66YMp6SaaFw9Bciw4WX	11225	15802	15802	1618783560000	orphaned
22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	22430	3NKfaLndFdc8cajJ3gGkMBqBR7v7yFQLSqBazu8eqQYzTdsEhMvu	1654	974	415	12463	14542	jxymFzrSZ5STv76H8ijeoXXF8rLYAMwBXaGDG1ktZFJGx98VxhL	11227	15804	15804	1618783920000	canonical
22438	3NLhjtUbyjuYeWKJo8i6Wo9yMFFqgkYfynNhwE4vUKYrVipsVgGa	22436	3NKHEaqk4qUYr6y9jHUemGouzqdamBxr4rjfAcUyB5JrostFBVFZ	1506	1127	415	12463	14549	jwBgkxnYb4b2ZuSJRkp2KEJPux6xBD3bqRsQZpWvzHWMQ2miMeT	11230	15808	15808	1618784640000	orphaned
22443	3NLZLUYciJ5GUrQ4ijV48HdEy796tKNjztnijW4y9QwthtVB6gLB	22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	1652	1189	415	12463	14553	jxBZC9wkqk8cJhvxrecqVPNjULkS3kqDC1dM9LouBsB3TwKfeyp	11231	15809	15809	1618784820000	canonical
22450	3NLtob9pVQWm8zFL7r4HNfj383cAtkJQCU4VgjSF3FWrRAjS1wTs	22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	1637	816	416	12463	14559	jxmMZ6EVjC7VY2HG4PovXaFscrr8L6zsYiRKvyoZvbn9WXSgT7R	11234	15812	15812	1618785360000	orphaned
22452	3NLqpBar2wyxeoWrYD26RowJWy8uaTPbDuqGdARbd5HT8qEU1G1q	22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	1407	1395	416	12463	14561	jx4H3dpYxFZLSLdKUKPUagvBhSQtoPmzxeAPQhMrev1C2QAfFsD	11236	15815	15815	1618785900000	orphaned
22459	3NLHMZuNuFPNAoNm4a1Zgis97ecNH4RU4kpeQ1rs5u2z7C3sNDi4	22455	3NKBxTgspXsgHNUVct72HGHjnog6RWLQNkkKJ2rBjkiPRtNLkQFm	1441	65	416	12463	14565	jxFgRPMXeYFopjtk9GaZGenigy6EQFTRdvyuXtbKmPWPfBEteJY	11238	15817	15817	1618786260000	canonical
27702	3NLGbJEMaCtmouL44CCTMHeeow23CDTEfqqHwfiQb9oK5PyXyyLT	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1611	1095	540	12463	18974	jwPbA581XTwsF4Qc2Fbq6fcYB6N7QS6rVMo9H9AYjaX11HLeq4j	13687	19273	19273	1619408340000	orphaned
22467	3NL7Yn9C2CJp1VEiJFYNRz2hiSxnctAC9FuBmgPUHhehwKUsQ7Mi	22296	3NL32rVqn5weF8rYSsM31HRUhMihMPT37oPjX7SWUrcd3tFTYGFv	1509	1074	409	12463	14573	jxfPuQh6yc7zXaJEVAtNwgNePkCrjjWzD72pHYoCNGYJ8T56tyV	11093	15821	15821	1618786980000	orphaned
22425	3NKyywxxN6KqSiXdQVsPium6EN4R8Btc43AuBh5m1XptZN8CuuGq	22382	3NLtKvd1ZuPUEKNF5Dz71nxaVVFKN44czw2THyVMw8jEw4bLNTD3	633	1384	412	12463	14536	jx6jdWcZryF2EpxsgVw1muyu55Fo8TeN5wJiAf7mH7moE2H4JvQ	11164	15801	15801	1618783380000	orphaned
22410	3NLCfgBRvVVXUv8wT9Rg2ezgS1asZKV3qaKJC1P6atRno4ktNLxH	22405	3NLn3v32QAxaRPrhoVJtw46MSVf21LpUzU1NL4Ccyz6YSDbFXwJy	1406	1393	415	12463	14523	jxyAE7wHBHSE4FJFGr58JWjDSYaVUHmDoJRGMLkkLvcevt1iucf	11217	15790	15790	1618781400000	canonical
22411	3NLEtwFY6B4VJMjxoK39sQhzERXvakri6QrkKgfparmFWxGQgxJx	22410	3NLCfgBRvVVXUv8wT9Rg2ezgS1asZKV3qaKJC1P6atRno4ktNLxH	1542	938	415	12463	14524	jxcfYRPUpa3Xu89W8NKQn1zu5y1RDVKDmVDN8Nr54uP8KPPdbxD	11218	15793	15793	1618781940000	orphaned
22413	3NLuq9HhHZV8w5KuRX3x8ZKKXDHqfmbu2N7UdojhzUCTtj7ayWyA	22412	3NLKBbw8c2LngKFAsifC9t5A7MZijkQgVvmhgpYp8setAshGHvAf	1476	1371	415	12463	14526	jwfemQACbPRGA5vmDER52Tc3PQDg5HCAUAwhYZVAJAfSk69aS6C	11219	15794	15794	1618782120000	canonical
22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	22413	3NLuq9HhHZV8w5KuRX3x8ZKKXDHqfmbu2N7UdojhzUCTtj7ayWyA	1534	1317	415	12463	14527	jxeQCyga5b56acAzdRYdcaLSiW2WXTKzj7a6MkLdAkTb6JWoHYm	11220	15795	15795	1618782300000	canonical
22416	3NKoKdXuagGjKYPcN9qZSNboocPnfDKwdEMs81co7REXYqdEiYQ2	22414	3NK82dH34EEzc9K9fr2QUMoPS1Y7BHXh16fmAFbMdKptN2sxNHqk	1547	1132	415	12463	14528	jx9EnD2i1yeuD9aGdPWRBzrF1r2Etp6HLWsH8ywR4zymwsM45Vd	11221	15796	15796	1618782480000	orphaned
22421	3NLq1jWN6utTMzqq7CAk3aFBn6iTDBUQByKnjQ9Ra1GEAW9JidML	22420	3NKDdwToFchFNyw2neuh7NRP6a7WG9VU3ALXYyifNhCQBz2aNVHt	1503	1151	415	12463	14533	jy31R37dUmkN6Qp2FBNRGMFUHsib5Eh5ttBzhPH8y9ZPuH83Syf	11223	15799	15799	1618783020000	orphaned
22428	3NKAyYcovZM8Yq3nFT27y7CMHf8tV5pmSAKk647bqGyDVJ4iB43E	22426	3NKvdv7mRSYTMadqi4oUnVdo5AmG6U6fTGtuVnSMUxGtaJ1ucZ8E	1406	1393	415	12463	14539	jwnx4BQUscCmgMsXUUTYCseTax7XJYL6AB5dyw4ZtkaL6qJzCDP	11225	15802	15802	1618783560000	canonical
22430	3NKfaLndFdc8cajJ3gGkMBqBR7v7yFQLSqBazu8eqQYzTdsEhMvu	22428	3NKAyYcovZM8Yq3nFT27y7CMHf8tV5pmSAKk647bqGyDVJ4iB43E	1654	1340	415	12463	14541	jwDbvgP1aRLiKLS1Dnu2NnJQQ1E3hYPEk9RqeGxMqPY4XgWJVmi	11226	15803	15803	1618783740000	canonical
22432	3NLWyTpR3HGKrjL1htCXVjnHSt9ZET55aC23scxQEpqNR8n3asnu	22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	1589	920	415	12463	14543	jwq68CKshrhQ17wSKG9PMMNsS5XDgFS5gqaVR94qvfmf5BdqD6H	11228	15805	15805	1618784100000	canonical
22433	3NKWyphEV9P6Zs2WAoLhDJ8xannPqUQecbwmaG61cYnFPedFs5YP	22431	3NKTaXc2N1sZ9G4o93faNvhyaErXmcjRmUX9K8CYwDTzro2QEcxf	1675	1342	415	12463	14544	jwgcFzMQxfGNjHDRkfeqXyunUWvWMeGFJEYgVTisMdEq9aoyDUd	11228	15805	15805	1618784100000	orphaned
22436	3NKHEaqk4qUYr6y9jHUemGouzqdamBxr4rjfAcUyB5JrostFBVFZ	22432	3NLWyTpR3HGKrjL1htCXVjnHSt9ZET55aC23scxQEpqNR8n3asnu	1607	982	415	12463	14547	jwr1xjaVJAV9aQWj8uAYEzTLzFRnpXzU11ebpFNv7vaXVBVUNou	11229	15806	15806	1618784280000	canonical
22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	22436	3NKHEaqk4qUYr6y9jHUemGouzqdamBxr4rjfAcUyB5JrostFBVFZ	1601	1142	415	12463	14550	jwU3F3drFASs7d68Xtiuo27waNad9tE93xcknfctNuz9UGS91ox	11230	15808	15808	1618784640000	canonical
22441	3NKk9wWHhKMVNGUrr5Eq2A3uLabuthPLrhsRVqKZj12cr6i5K8HB	22439	3NKTcRLLrbNRRBS5RxSsEzpgXJX6UrjrHr1azSzRha8eWRza4Bjw	149	1037	415	12463	14552	jwXkZ62Qhd6S6cGTzB99yvdnn5EBHuGJunzA8gtJPjJHTvw5eLf	11231	15809	15809	1618784820000	orphaned
22445	3NKv9Xbb53o17d7gJWQPPgkyrgrBNEiwWbmg1s4E3PHM3z3qYBDQ	22443	3NLZLUYciJ5GUrQ4ijV48HdEy796tKNjztnijW4y9QwthtVB6gLB	470	1183	415	12463	14554	jwY9CzFijkGwAjz22T325RyBhbGtKxRsX91iLgKYyaRUsFQce2k	11232	15810	15810	1618785000000	canonical
22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	22445	3NKv9Xbb53o17d7gJWQPPgkyrgrBNEiwWbmg1s4E3PHM3z3qYBDQ	1654	1094	416	12463	14555	jwhm1CQjhfTPGf2nzJw94YZ2tj59GoNCbmfQKgzuVhZUm8KnR8Z	11233	15811	15811	1618785180000	canonical
22448	3NKK238jfhHtEr4JQw3d1GMTUdHAEka7at79dwzUo5MjzXcF21vh	22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	1407	1395	416	12463	14557	jxyKg2pqibb4XBL1HnLUPVMqDuesb7rWzPtR1z9h7cP6EGpJUqX	11234	15812	15812	1618785360000	canonical
22453	3NLRL8RHgXPT8USbBgewTzL6aGkppZrNeEWKHwQDZeUfSBB8D2dm	22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	448	1305	416	12463	14562	jxmF4NMzX3sb37ZMnKoL3uZTjYcwfUXG4E5ZnLDhB22kuqWaT48	11236	15815	15815	1618785900000	orphaned
22455	3NKBxTgspXsgHNUVct72HGHjnog6RWLQNkkKJ2rBjkiPRtNLkQFm	22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	1527	1293	416	12463	14563	jxs9LQnUDRwj7FayBsGie2NKqNKUeMiFFDfiTptLYWcpGD4FWDE	11237	15816	15816	1618786080000	canonical
22457	3NKr2A7KmJmMzKwQydapxPWLDHWhqM6PtKkD5SWc9n5dqHrVpc3j	22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	1527	1293	416	12463	14563	jxsJntsfB2Yune3vbQM1Hsmpj4NHmyBrdtm98carMsbzkuCiETq	11237	15816	15816	1618786080000	orphaned
22462	3NLwpcVoMDKCBTxfdHWwPC4w8NCh9DMPoa6oivpLqgdhLLmkBdTJ	22461	3NLToKjKZspubwehCYkxXdFzCZW1gBMrpHX2RHfXwQSA4tXWQUWe	1650	1375	416	12463	14568	jxbCVuUtaaBaBdPsieeuH2zx3Cib4wVdCmm2EteAzok8CQM3uaW	11240	15819	15819	1618786620000	canonical
22471	3NK9qei8qV1aFPw9AaDrwyZhHJMVAohi6S5a3MQWQ6MXwDNfNNeB	22470	3NKiV7T56H26xMrU4Rc97wHRdeMgjMGyTzGnU7HrvoX9EaNiFSsi	1471	1386	416	12463	14577	jwNGd7gyGBY81cRxhm71YFU3Lz7XMdKcnxPsr3r75NN5UbvENVa	11244	15824	15824	1618787520000	canonical
22474	3NKx71K8j92ufyK1S7PdHbdqaRgZDbfrFiWEQj2vWGfCVVbsWf45	22471	3NK9qei8qV1aFPw9AaDrwyZhHJMVAohi6S5a3MQWQ6MXwDNfNNeB	1406	1393	416	12463	14580	jwYW4XQwr5zsn7fPM4kLDsnDtwmsQEKKf9iTDAcfaLUsBFNWfU9	11245	15828	15828	1618788240000	canonical
22479	3NLcpdo8f5EdVosugPWL5PFkqxLCJG1KVUJqKXXhA2bkSWs76VNc	22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	1585	1120	416	12463	14584	jxHj2FGfVJW4LgaUKXP9Ms3Tz1qNMJNSoidMBBfT9vQLALMQFX9	11247	15830	15830	1618788600000	canonical
22481	3NK6kysJvQEbPp6Mz8zXKWsrdCznx2G4ZfhEz3Ta9hWBa9PB1tb4	22479	3NLcpdo8f5EdVosugPWL5PFkqxLCJG1KVUJqKXXhA2bkSWs76VNc	1406	1393	416	12463	14586	jwybBaivCp8assPd8WKpEr6XNLZhWvvwjfA4fK4xk8zWSv7Abnp	11248	15831	15831	1618788780000	orphaned
22486	3NLEuWt6utDdxVEuSYPoUiSaqAYBEyddFBaaK52tK5wnQEqhEowp	22485	3NKSxszhvje3HsEGj5svV682JHCtnV3yLnSZc4SV1T8FThh9uxsr	1541	610	417	12463	14591	jxPpLn2EZGwCLz76rhAj9FBA9VWygsx9t46CRwskuh3BsEf2fJq	11251	15836	15836	1618789680000	canonical
22489	3NKNzn4YDCmp8uoCFTt8d6gcSETcjVDUQUnEGwMbw6ggne5Z5EqG	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1670	1156	417	12463	14593	jwNnF7rFdCQ4NvU37t6Y8cYZ8n2S3fJARZyZwxxnwC3wW5LAJY6	11253	15839	15839	1618790220000	orphaned
22495	3NKX9gwga7aubRE3hAhe4J1kzEL82PbpK63Lp5zCZcJkxeCY5bP2	22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	1439	482	417	12463	14598	jwKESLaXJE9EgAUQh4kVSFRRsehkrLSYXvLWm9QZz4FxN8r5cjS	11254	15840	15840	1618790400000	orphaned
27722	3NKkC2oaqQH2STLCV6VbW9Zo3NJX7hHwswAT2J2KM2D7YWXKQ9ic	27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	1673	23	540	12463	18974	jwd4NzUz58NsPRF2XiHNjPw366LW9WhRojK7qawN3jwXtTfTT6T	13696	19291	19291	1619411580000	orphaned
22526	3NKnJVnBEhbUYG1NjgCkZBR9jWLf7rYtwfoGXEzDJX5XjCc1HUtr	22513	3NLhL7hFVeyB4kN65nfBi3qDWeUctnDJqNcoGZSo5iE3FWS5exvA	1553	776	405	12463	14624	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11039	15859	15859	1618793820000	orphaned
22447	3NLv43T5ws6twguVsYVrNkRWBEoSXPv7RXUrvp5xtHcgEpb6YfWZ	22445	3NKv9Xbb53o17d7gJWQPPgkyrgrBNEiwWbmg1s4E3PHM3z3qYBDQ	1637	816	416	12463	14556	jwjejnmS1nk5XErNUfjWHPnpwzXp3B4Q8WydrvxrxJvbNXENERQ	11233	15811	15811	1618785180000	orphaned
22449	3NKyeMf9DM9cCBWGojUDjubswXnZdEBnGWwKme6e9k3Vzj7WmzCB	22446	3NLCtjJULgsgatfUWKsAR4JbwGM6pQ66Ks4No8UW9c644osQETBm	1602	1123	416	12463	14558	jxLRJMBVaf4cxhkU1N3vbz6WnK69ygi4zapi6oqjUsCbwfVRMJi	11234	15812	15812	1618785360000	orphaned
22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	22448	3NKK238jfhHtEr4JQw3d1GMTUdHAEka7at79dwzUo5MjzXcF21vh	1407	1395	416	12463	14560	jwvWhjtkWccsBYsmRLLeiEZNoLe4gDs995JbZGCweD2VXPDB7Fu	11235	15814	15814	1618785720000	canonical
22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	22451	3NKaXufyyPT4WemZkfYqL6qafu2hLWcZWp8kmsG9pVXRykKXa1nt	448	1305	416	12463	14562	jwqC2c8qrSYP8YhJFE5WMQGEvMrs7DTn4uUdJTLxTGJLYRxjTde	11236	15815	15815	1618785900000	canonical
22456	3NKHSHps4LFuLVVWYc3u3rkciT2g6bdaw58idVXYVKX7xxA7oJQZ	22454	3NLvFGvZMsCSAH2Lax5bFbPPRJrvJ62uafjNy8VAdpTBL4qeNQxn	1527	1293	416	12463	14563	jwe5Ke2DPRsiWGm4Yfx1xHsAfXo1odRWFhPE7AY1rb8MNJ5RyLA	11237	15816	15816	1618786080000	orphaned
22458	3NLcEiYteN8p5MyoMvK7xBAxpTuR81RbikQrC1ZoJ2nx23noreyx	22455	3NKBxTgspXsgHNUVct72HGHjnog6RWLQNkkKJ2rBjkiPRtNLkQFm	1407	1395	416	12463	14564	jwbVCu2xyhMby74ZS1Qv2BhETjDVbMZyJhAC3dEh8YFqYaLk8Br	11238	15817	15817	1618786260000	orphaned
22461	3NLToKjKZspubwehCYkxXdFzCZW1gBMrpHX2RHfXwQSA4tXWQUWe	22459	3NLHMZuNuFPNAoNm4a1Zgis97ecNH4RU4kpeQ1rs5u2z7C3sNDi4	1581	778	416	12463	14567	jwq5zXNyN6j9znMpdBfDgrJB5QYYNMSVKkGgX6RsxSoyXxkdzhp	11239	15818	15818	1618786440000	canonical
22464	3NLrmTbMwZGtc1zwadRuUfE1fzKBxvbcUWS75d95VgLuHeJ5Tvog	22462	3NLwpcVoMDKCBTxfdHWwPC4w8NCh9DMPoa6oivpLqgdhLLmkBdTJ	171	1008	416	12463	14570	jxzt2RDfWHeqtzWfFYqDMChsAX9ksye3ypCxRsQsejT6W6Hwr1K	11241	15820	15820	1618786800000	orphaned
22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	22463	3NKqRjLGKaSxYYh9hicXnFLHUFr8idVQ6TDE7pgKaxJGeR9aWGPh	1406	1393	416	12463	14571	jwmN5zfzn9uPtfbrbuvRDPx8vtUK8opaZ7QV5SEqmETyEugjpbN	11242	15821	15821	1618786980000	canonical
22468	3NLi9jHWPp8T6jgaWvFDMWBWLLMiTvzvZcNrHu94gs98iUj3vhJE	22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	1422	971	416	12463	14574	jwcsman2GY188AqoBds3D6gLmPFwbPToKwuNfgQhVoHCXaZGKi2	11243	15822	15822	1618787160000	orphaned
22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	22474	3NKx71K8j92ufyK1S7PdHbdqaRgZDbfrFiWEQj2vWGfCVVbsWf45	1406	1393	416	12463	14581	jxQt5qgPvqjqBe8AcT6UN4deHZCNKugWx5MxopAwv6m2yXDhZ6g	11246	15829	15829	1618788420000	canonical
22477	3NKUYbwV5dBajXwJfPTKXM6uiJLYyAYF85ndCp5fmfDkYtoFwnk2	22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	1547	1378	416	12463	14583	jxSCzkhmjJNrfSHRsNz4WHSAWLZJKZoaR3ck2nY8ybfV9HaJRuB	11247	15830	15830	1618788600000	orphaned
22482	3NKxc6u3AuVe3kfsSs5Z3KLFDZQvVYxdENuSPGRnoJY3KEARBDrP	22480	3NLoX4G4sUsTE9WEphtaFo3Q7A14FBshNw7EvRRn84vrYQgct2Tw	1513	1133	416	12463	14587	jwVysD2QQLs5WdQBM5W9J1AjqTXwA3CqK6M6TcCs1NhPmD51WNT	11249	15833	15833	1618789140000	canonical
22485	3NKSxszhvje3HsEGj5svV682JHCtnV3yLnSZc4SV1T8FThh9uxsr	22482	3NKxc6u3AuVe3kfsSs5Z3KLFDZQvVYxdENuSPGRnoJY3KEARBDrP	1406	1393	417	12463	14590	jxPFHySAuzq9fqF7KN2iHLCnydfD6AjKP8RBPn2fWyNPvg4eJHY	11250	15834	15834	1618789320000	canonical
22484	3NLr9mWdUB546CiG7tbcBkGA8La8HtUNsy31Fupa7YcvNVapNH2z	22482	3NKxc6u3AuVe3kfsSs5Z3KLFDZQvVYxdENuSPGRnoJY3KEARBDrP	1403	824	416	12463	14589	jxDuANJNjknLcF6gssueWca52rLywJBuc9BdC76r4wg4VjAygZP	11250	15834	15834	1618789320000	orphaned
22487	3NLR73oWZnKNAucGSpjo3J2fVaA9D8QRnkDQZRWZFMKJCe3qahYN	22485	3NKSxszhvje3HsEGj5svV682JHCtnV3yLnSZc4SV1T8FThh9uxsr	1541	610	417	12463	14591	jwDpTZwAnWqWRfmMwfFZ4qNQZwPyV96aVdMd7nL8LeQ1yLbRHzb	11251	15836	15836	1618789680000	orphaned
22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	22486	3NLEuWt6utDdxVEuSYPoUiSaqAYBEyddFBaaK52tK5wnQEqhEowp	1477	1350	417	12463	14592	jxdJMYt6eaPk3qJzCuB62USTcTEqXjgzSoCgGN4Qr1TyLikvCAk	11252	15837	15837	1618789860000	canonical
22491	3NLSiiaGon24aYAfPgBoRsw83e2VV6ZRM1paMyu5yJvAxkAqQm7C	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	1406	1393	417	12463	14595	jwbSgMWYmZZMoF4ueGSA5fLxeDjSzyefMxTDLUADCzVBWXPGe9B	11253	15839	15839	1618790220000	orphaned
22497	3NKZaURfvwXtfCrHWzaR3xzvftHzS4MSaQmoWCdU587UyVuUAoc8	22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	1460	958	417	12463	14599	jwPyZsXMikVNbkWdAkc7h4vRxxgGy8QL3Xyo2WQwpHYq1JoFagm	11254	15840	15840	1618790400000	orphaned
22502	3NLrzke2MhFBuaYm4Sb2Trn5QipW3DKQmpvUT5PY47fC4yR5pU8L	22499	3NKLewxamKZJzMwHfVKrgVr3z3f71TyiSjxCxURzVgtTrHzTDv5D	1541	1172	417	12463	14602	jxVCsChRePtVs818HLF1N63uTRBT7rSoWTdBCn4HQ2HLZnDWYX5	11256	15844	15844	1618791120000	orphaned
22504	3NLArnNcB7x7vnEmjKRugzvgooxfShYJi7N3UpCnSzmShdrXQJcB	22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	641	1090	417	12463	14604	jwCgXxSTK49kD2H9RFRkjCGNh21hQYDfigpzhD3uMZkJrAmuST4	11257	15846	15846	1618791480000	canonical
22509	3NLDTBvLLi2aPgpNGdYJzhWkHPAxAMenefmLVmAekoDTDsYv8a7C	22506	3NKpYYHj973ZqCChYLAifiB3aj41wJ7YaE4hNei8DqJbH6TRSb7x	1555	981	418	12463	14607	jwQq7zbz9QwrNUUp2GdE3XuhqFyizuPWCJ83ZSpzZPaKv9gJLRg	11259	15848	15848	1618791840000	orphaned
22521	3NLTkzgdKtQ6kfRjvq5xcjG9e2VjCYcfx2nxyUs5VXiGK6KxRu8x	22520	3NLd66PJocbPgyJhr6dU2LQPAmxYKAHnVoGvMu9QPKHbGZEjTQoh	1406	1393	418	12463	14619	jwH5xjQ4AvYYEJ64YSv9GdK7pS3eP5FmdXb9LiAL2cVRN4J4jhQ	11266	15855	15855	1618793100000	canonical
22523	3NKn9UfRc65cbL4ie3EwJNLz9uCzv8nZgSf9xxMtrBshBquHd5s4	22521	3NLTkzgdKtQ6kfRjvq5xcjG9e2VjCYcfx2nxyUs5VXiGK6KxRu8x	1581	778	418	12463	14621	jxK3sGnt38CpuhwX1FVw1rSDoEuiAvczDy8DnfBfpNZ7v2XoFKv	11267	15856	15856	1618793280000	canonical
22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	22525	3NKszBtzfQM4XZ24sX6iLE7P4LhPTdsawB7ApnzBHUWwQwwUwACc	1483	877	418	12463	14625	jwKjm2geWyGvraHwnnqRo7jpzS5ac9jfnGScGWRrb8w7w3XRC7G	11270	15860	15860	1618794000000	canonical
22534	3NKpE9F1NzDVQnzJXKDYKVU73AiCW8XzLLtVkByWXKyuakHKjAgt	22533	3NKVjjijf4mHcAc1s7miiPVgKkXXn5dw5iYYebnWZTAvVYL9vzWY	1656	977	419	12463	14630	jx4DBhPLQr2v7BGBdt8EmRcbMKvoqAdeeapcZ8xo1sihpBxTWjk	11274	15868	15868	1618795440000	canonical
22537	3NKWnUZGwJYqZV2RkdCvx3ZyoPxjrvp44xopiHqhUS5pm2wVfFiu	22536	3NK7npzBi8MiSxbmnWRCcJN5nzjVPv879sKp1ermeubsLBz5chjT	1581	778	419	12463	14633	jwSpggJ4cbPeuiHChjJBH46SFPrbc6yd2JjppZq9jiKKxtNDZ4o	11276	15872	15872	1618796160000	orphaned
22547	3NLD6sK6EHEuM7z6pYKbWMhmSAxdeFmcQzAaa9CxhB1zmhtNBifn	22545	3NKKpDM8pMC6xewZ7dN9xs5Ugr4aCoHeRYWtN2Nrdg5P9w9uM4Bo	1670	1156	419	12463	14642	jxYyZsqCPatYo5Q88fYHE22CWvWQQfFWdNL64PU5kk6KpLURqyU	11280	15879	15879	1618797420000	canonical
27725	3NLdPaFTwcTTo9U7JAk3Rwk5QWn8q47pEuLFFLNi7qufn2S95ynY	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	1503	1277	540	12463	18974	jxMX9C3hfw6GdyFHRfnxtGPZ8pp9YVN4vx1hcMn6Dyors2kSMdk	13698	19294	19294	1619412120000	orphaned
22483	3NKuvJc7NtGX11dkf9Wpd6et8StuZ3epQdbgzK9qXu4vU7esmsjE	22352	3NK6K998PNu4xXzVHU1jzxDcXi9K1pSGXEf7pcgqR1guyZ5qPyM3	1553	776	405	12463	14588	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11035	15833	15833	1618789140000	orphaned
22503	3NKuavwNyHvSC7yNXHfVRzAZmhZpY1wX4zdWoscNiReQEPfPbrpW	22500	3NKQY3wYTrAGvSufsEhJeCb3ikLHYh2dghpJLJJz3Djg4Krna89p	1553	775	405	12463	14603	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11037	15846	15846	1618791480000	orphaned
22466	3NLmfuyeNmqSkDnYQL4jTULpMtXiJzSua6WSGuRFRm6b1t4Zkvmj	22463	3NKqRjLGKaSxYYh9hicXnFLHUFr8idVQ6TDE7pgKaxJGeR9aWGPh	1509	1074	416	12463	14572	jwutSjRVm8hqHvXCX5hRvwnNYmQE3p6Pd1B82DU361UStErsvN4	11242	15821	15821	1618786980000	orphaned
22470	3NKiV7T56H26xMrU4Rc97wHRdeMgjMGyTzGnU7HrvoX9EaNiFSsi	22465	3NLtdRV6ohMMrcSZfyBmso7n3y4t2YR9tjZgzpV9tgXoEj9B6Z4j	171	1008	416	12463	14576	jx7arnnoXPRnwWNDzf2BJVUM6UjPTsLdL71JJ55Ryyi6LpaWNq9	11243	15822	15822	1618787160000	canonical
22472	3NKXX63KgjUn95mm3DSydRqNh5FfiwaNaNjHvE1xxeMbU1nCX3qm	22470	3NKiV7T56H26xMrU4Rc97wHRdeMgjMGyTzGnU7HrvoX9EaNiFSsi	1637	816	416	12463	14578	jxBidokciBQZUHpp9L9E4gancwtBZbMW8BcumzxrKnkCw8fyAwp	11244	15824	15824	1618787520000	orphaned
22476	3NKaeApJoTokVCsuPWGB8zRYgqTmDdFNg9RC4fTgZhwv6Ny6WiWN	22474	3NKx71K8j92ufyK1S7PdHbdqaRgZDbfrFiWEQj2vWGfCVVbsWf45	1594	1080	416	12463	14582	jwPLNgt5TrYSifiKnthLre2pBS9f3H9ngsyLsQUtyikqNov3Axz	11246	15829	15829	1618788420000	orphaned
22478	3NLtCURbaLVhddho17oPiMf9zPv4LQaDcieWg5kkXBErDuWaDxY5	22475	3NLBWS5zgNTTrqvWcBSruJaFjaFUv3JPqMyasCoRKs4NdErWUi5e	1547	1378	416	12463	14583	jxs1DHUDcL5DEVCSkoV7RYpdk6yKHcjHs1ejPqWANrZPWzmugTP	11247	15830	15830	1618788600000	orphaned
22480	3NLoX4G4sUsTE9WEphtaFo3Q7A14FBshNw7EvRRn84vrYQgct2Tw	22479	3NLcpdo8f5EdVosugPWL5PFkqxLCJG1KVUJqKXXhA2bkSWs76VNc	369	1312	416	12463	14585	jy2MWm8XHuTcJkss133YqQAP5vopTVKRHXCsZhtpWcU2fhGowiz	11248	15831	15831	1618788780000	canonical
22493	3NKAwCSuByctVR9KdiKna1ETZ5toC4H3eUQQvqB8e9jY5w4iqgLs	22488	3NKtTLK5iH8YbbpN4nRzBQb4y8d2bHqHBy9faNUpLEVv2jCwQZjs	44	1079	417	12463	14597	jxHFWg1ewargjKwwCSPeSdLVoCQLKdKprxPVUf6vZe9ZUJqcpA2	11253	15839	15839	1618790220000	orphaned
22496	3NLU557yapTEhvgixdWrZGnMPRVmDX5eBqVEnymkhTbNEUxNvPzu	22494	3NKyXhBf61KRTc9dKiFdhu7qTZaqvPUtTZcPReifXmgQvQZeh2EX	1460	958	417	12463	14599	jxHSJuEZbGDKnmLPCynakUyWNQhpY3zk7Tihu4omT5ZgSjQ2VPu	11254	15840	15840	1618790400000	canonical
22499	3NKLewxamKZJzMwHfVKrgVr3z3f71TyiSjxCxURzVgtTrHzTDv5D	22496	3NLU557yapTEhvgixdWrZGnMPRVmDX5eBqVEnymkhTbNEUxNvPzu	1407	1395	417	12463	14600	jwras22ztPmUF443KoqLpnyTDyLyuK1UxDPpT41m96xsoqMETsw	11255	15843	15843	1618790940000	canonical
22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	22499	3NKLewxamKZJzMwHfVKrgVr3z3f71TyiSjxCxURzVgtTrHzTDv5D	1541	1172	417	12463	14602	jxpPxX3u48b1ZzG1UMbPCYW3ZdZdsNTAcS9aCY7eK3RzGGDLzQD	11256	15844	15844	1618791120000	canonical
22506	3NKpYYHj973ZqCChYLAifiB3aj41wJ7YaE4hNei8DqJbH6TRSb7x	22504	3NLArnNcB7x7vnEmjKRugzvgooxfShYJi7N3UpCnSzmShdrXQJcB	1403	824	417	12463	14605	jwZRsfppszEh5fsHwbidsreTH3QEdD4nW3uahkhgheQeiDufU2L	11258	15847	15847	1618791660000	canonical
22508	3NKZi2hEPU4wjTSJtcXKdtaz1W5dK6115LwQ1AoezEwPBpNztvoY	22506	3NKpYYHj973ZqCChYLAifiB3aj41wJ7YaE4hNei8DqJbH6TRSb7x	1555	981	418	12463	14607	jwQq7zbz9QwrNUUp2GdE3XuhqFyizuPWCJ83ZSpzZPaKv9gJLRg	11259	15848	15848	1618791840000	canonical
22510	3NLa1AnV43fx9ReNtXthFrT1HABDrXQgKYb7JvcEVwnYmtxqNQzq	22508	3NKZi2hEPU4wjTSJtcXKdtaz1W5dK6115LwQ1AoezEwPBpNztvoY	1589	1040	418	12463	14608	jxSDQov7Gs7uAJRpvAD1FKV2S5ei7HefNM8pEy4doBJ8632K5T3	11260	15849	15849	1618792020000	canonical
22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	22510	3NLa1AnV43fx9ReNtXthFrT1HABDrXQgKYb7JvcEVwnYmtxqNQzq	1642	1121	418	12463	14610	jy2wGYZ9QUFiG8LBwjbiDsLxcfpn3tLrLL93ichZUMRUkRdH5Sx	11261	15850	15850	1618792200000	canonical
22515	3NL13R8SwaQ9S1gVFZfFyXYqbb6d28yq4cvdnSoovV53k6fu5zLM	22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	1406	1393	418	12463	14613	jwXsw5bqyX9XNYm2jbto5ALCA223kMosEieJqghCgnDHR2ThxyW	11262	15851	15851	1618792380000	canonical
22517	3NLNxq5GQXu1uaCVqYi1EzGoQVxaoCz4VzWrPtMDrvyMw2ruxrWu	22515	3NL13R8SwaQ9S1gVFZfFyXYqbb6d28yq4cvdnSoovV53k6fu5zLM	1657	1344	418	12463	14615	jxHgLhnFHs6MTWidxr9SBLWpMpiQ5X5YGmDdg5oVSDWvvdzbCJn	11263	15852	15852	1618792560000	canonical
22520	3NLd66PJocbPgyJhr6dU2LQPAmxYKAHnVoGvMu9QPKHbGZEjTQoh	22518	3NKdbpFtD4yty5R7LLAbzHQmV69tFNmCwd9cV1EJQHDU8RM9QdDJ	1406	1393	418	12463	14618	jxUJ19bFeCeFhfjGCjg4izQYeUh8w2RddWi3ApVLLCscCKxswyf	11265	15854	15854	1618792920000	canonical
22527	3NKocC1pg3VHdBwwo844NcLRqGPk2PStqyJwmPDwmuEjMmQnsWa4	22525	3NKszBtzfQM4XZ24sX6iLE7P4LhPTdsawB7ApnzBHUWwQwwUwACc	1483	877	418	12463	14625	jwEQG81cZmXk252ct8XAq3HPxj2DDjhv1EPPny16FJrLU8Poxab	11270	15860	15860	1618794000000	orphaned
22530	3NK7UYakdwHdtWBxwuNavNCmjmnwWfwzzyqyupBXqzPQ8fa5jfmA	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1651	1301	418	12463	14627	jwydjhuz1jCNfr8KH7Q3qvuwQUdRdS7XsBvq8VaDnF1qWXib4qW	11271	15862	15862	1618794360000	orphaned
22532	3NKRadiJ8c5A5q5qYhByLNF2RTQTrb2PM26PThcsZwZ9o5hnTdRT	22529	3NK4ZB5Ppz8eSNWEWmEP23MM16rjwN19wGZP78fskyB4yDoGrrsr	1406	1393	418	12463	14628	jxoaDLVgqZzDjGFmmrw4b23C87QFoKp7DKChNdkkhTJkUFPbBg9	11272	15864	15864	1618794720000	canonical
22543	3NKCBAVDz6ptYHbxhVF2pZM27aHUxCR6mwEJDZQpozSddqSZhDVK	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	43	1064	419	12463	14638	jxsE1tyf4QpTrEdgw1MgJUqKQfP3oVVXoKR689f6og7c5XsHDK8	11278	15874	15874	1618796520000	orphaned
22545	3NKKpDM8pMC6xewZ7dN9xs5Ugr4aCoHeRYWtN2Nrdg5P9w9uM4Bo	22544	3NLiCGfJg4URkm3TJHFx5kpfGgWY8o2pJe4tQPsdPeRmD1QnDU6A	1507	1280	419	12463	14640	jxgzdiBWsHmk4VdDZPuTSThgQR4k2bN6mpfT6dS4SmZB2MrW582	11279	15875	15875	1618796700000	canonical
22548	3NL4mX42ZhTEWbUMntac88uezXnMtbH2rg6Ja8BefAGCPMhDKHe1	22545	3NKKpDM8pMC6xewZ7dN9xs5Ugr4aCoHeRYWtN2Nrdg5P9w9uM4Bo	1406	1393	419	12463	14643	jxwFLzH7362ZueoSDkt115cEz2q4cgPdgRhi3gnLbEDngKZ4yQW	11280	15879	15879	1618797420000	orphaned
22551	3NLMn8SgaK5pyxYBMgBkZUX7SA2qwjRtXNvfCQmmFKbLSy6wviCV	22550	3NKRFnvFqSgvLhB4KJxwPQyEFn7ZYxfZTykaRiyy8ZDeHMiW1QtZ	1656	1343	419	12463	14646	jxHxZB7b62o72CwK61awR5HeBbBEN6DXdgosSmoWSbSeCGSoaif	11283	15883	15883	1618798140000	orphaned
22560	3NLEc9feZCBXJVRLvynMfLUB3qEMxfnh1UhM8Xkz6KGSjgexHqFW	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1631	793	419	12463	14655	jw8QosBQ18UbviLydheT7owy9PwgN2soHFZHvAJAW4CCpD1QtAd	11286	15886	15886	1618798680000	orphaned
22565	3NKJpouKoxkdrSBjK2HEY7HLdcxaKuyF4MaBtdPgmeDsa3NKiL5w	22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	311	1061	420	12463	14659	jwx3vGKe1AU2M8JogYnqtWEytDQo1TM3LJGGo2mBzPVVLm55xWU	11289	15890	15890	1618799400000	orphaned
22568	3NK5W1oxS6BYvQMh1ZjngdfFjrSzA71mjthZjdX7p1dT7aWejqex	22564	3NL3TtEBwrqv4vBaNAXXC3tcvsg2mUasa28B7mnt8EnSuXwdjTrB	1647	846	420	12463	14662	jxxmmnwiDFA2yY5pBjRkgn4T4jFDWwwLRQZpRABikpUrGVwNQgt	11290	15893	15893	1618799940000	canonical
27729	3NKF4aXDWycrQTxgtkiy6PbJyK79ZnXtcS24SfFYPtiXaorbPufW	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	1634	1331	540	12463	18974	jwBUNFaDbYfR3fBKXzmcDqZXUto7VpJCPMVSCPpwmynUmWUYNes	13698	19294	19294	1619412120000	orphaned
22546	3NKy3y3SVR2StjxQxTsHe3rYcQDChobAt79L8YeFRRkoxoc9yCwD	22526	3NKnJVnBEhbUYG1NjgCkZBR9jWLf7rYtwfoGXEzDJX5XjCc1HUtr	1553	776	405	12463	14641	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11040	15875	15875	1618796700000	orphaned
22590	3NKgScheu67KYBMWiSGqK53jjVYC35kQpSAvN8QD1LCTiaZCEG3n	22553	3NLKkoNbnWyw8LN3EP7jbcVbRxsecpme9QprMBgNmgCMprbQS3AB	1553	776	405	12463	14684	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11042	15910	15910	1618803000000	orphaned
22498	3NLYdV196Z27c4M3WAm4ibbChmZieT3mpzsRZreDjPfQyHMBekbo	22490	3NLBt5BkoocAGhdqf4HFZ1UMRK327p2G6GhRFg5cukAvvsVsYMCQ	1439	482	417	12463	14598	jwDHbYBWiKApBrjdiF1nkfMLf7L9evQqMNMTKEqgiQSfqHMJUc2	11254	15840	15840	1618790400000	orphaned
22505	3NL99PrWTZKXfx7iBkJEZ4SeXsQpf4tnjDGoURmEQuz2aYsXSBCV	22501	3NLsWfdzjXhDJFSnKSg2aK7hktS4bwaL7wJAYstV3cpc2UJEjgpz	641	1090	417	12463	14604	jwDuMpkRWeERnRcJzxAusTHZsPhJwn83v1vosLZpKLYbj4mUejb	11257	15846	15846	1618791480000	orphaned
22507	3NLNgSRPRhSasUu8DfRcnAk3PBggXGLGvjtFUCLJtavh8H3Nwnas	22504	3NLArnNcB7x7vnEmjKRugzvgooxfShYJi7N3UpCnSzmShdrXQJcB	576	1109	417	12463	14606	jw6cbgtLbcem6PgdRrDqho1u1n3YTa97TpZubnh4XKuXev8yN7p	11258	15847	15847	1618791660000	orphaned
22511	3NKAgCECtideStMRWkMuoBJFNSVsRaR3Xk29QaUtrj71qb9GWUhW	22508	3NKZi2hEPU4wjTSJtcXKdtaz1W5dK6115LwQ1AoezEwPBpNztvoY	1649	1383	418	12463	14609	jx1oAPSu2K6cV34iV8CPCr53UMAtiNV2VX9Rwo3cVB8tqYKmfMR	11260	15849	15849	1618792020000	orphaned
22516	3NKq2Zcj2AJR6WSkToe44KKPaVCeYZZQUZD9tBqYPKnnXxA5qD5U	22512	3NKP1XmiRd6MpcGbE2wNdxkmWpCptPz6jUXbP4yBnFXCzjG6hPuM	1585	1120	418	12463	14614	jxDfUd5Wq6a3v76Gtp6p1dkzCivRzeP75hnWD4r8BwKRiZM3Z7G	11262	15851	15851	1618792380000	orphaned
22518	3NKdbpFtD4yty5R7LLAbzHQmV69tFNmCwd9cV1EJQHDU8RM9QdDJ	22517	3NLNxq5GQXu1uaCVqYi1EzGoQVxaoCz4VzWrPtMDrvyMw2ruxrWu	1508	1141	418	12463	14616	jwQWXXbhBuaER9Vz2s9uWfN817LiGKwVsgt5AcxnNrgrcUujReT	11264	15853	15853	1618792740000	canonical
22519	3NKsoqTkZmt4wGMnoVcozA7PPD4PKUvNqdkFoJxtddgnRx6VU8vT	22518	3NKdbpFtD4yty5R7LLAbzHQmV69tFNmCwd9cV1EJQHDU8RM9QdDJ	1407	1395	418	12463	14617	jxQvLFtZbyEF4RD1x1ihTKxo6C7paGraYyJqwgMP9XLRwcKL22w	11265	15854	15854	1618792920000	orphaned
22522	3NK5hRkznWhzyZVhwLzoo9BTqsjXBJYQX86qxFaTGB1XvoTQHNVb	22520	3NLd66PJocbPgyJhr6dU2LQPAmxYKAHnVoGvMu9QPKHbGZEjTQoh	1637	816	418	12463	14620	jwxvAF33TdJAudHEF5DH4m9872FUcjd6215nYEJS34BFDECJ3fs	11266	15855	15855	1618793100000	orphaned
22524	3NLqhw5zPTUgZhxsTtsUGMMhcRP3rPLNzDVhmxRKP5Psjtj2i46a	22523	3NKn9UfRc65cbL4ie3EwJNLz9uCzv8nZgSf9xxMtrBshBquHd5s4	1648	1284	418	12463	14622	jxotSVYgjvWZQNk4aSMrny8gMApWvXhZMSCmQmXS2MCrmBj9YpC	11268	15857	15857	1618793460000	canonical
22525	3NKszBtzfQM4XZ24sX6iLE7P4LhPTdsawB7ApnzBHUWwQwwUwACc	22524	3NLqhw5zPTUgZhxsTtsUGMMhcRP3rPLNzDVhmxRKP5Psjtj2i46a	1609	1087	418	12463	14623	jwap8BRQPX5AJ6xHhPH2JPM4imPhCiWs15oSoscTk71SnSrrUfM	11269	15858	15858	1618793640000	canonical
22529	3NK4ZB5Ppz8eSNWEWmEP23MM16rjwN19wGZP78fskyB4yDoGrrsr	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1406	1393	418	12463	14626	jx1cYBM38DMeJkAsv4pA3Hc8VobSCVNZxxwqBRPjRVz3DGRPtBc	11271	15862	15862	1618794360000	canonical
22531	3NLnLDsKXf4h5KRSzsQ8ZyKorQGYbf7mhXcsmeruBQexJfqgTuc1	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1651	1301	418	12463	14627	jxmdG3eifzxZuNmc8rDpiANRmD8exFtZG8LdcKeLLHXR17Zfqcc	11271	15862	15862	1618794360000	orphaned
22533	3NKVjjijf4mHcAc1s7miiPVgKkXXn5dw5iYYebnWZTAvVYL9vzWY	22532	3NKRadiJ8c5A5q5qYhByLNF2RTQTrb2PM26PThcsZwZ9o5hnTdRT	1405	1	419	12463	14629	jx1mKrVPDjgfLDv9tejLKsbRRTS8qJ3opw56V4jecZaSMHcEkdh	11273	15866	15866	1618795080000	canonical
22536	3NK7npzBi8MiSxbmnWRCcJN5nzjVPv879sKp1ermeubsLBz5chjT	22534	3NKpE9F1NzDVQnzJXKDYKVU73AiCW8XzLLtVkByWXKyuakHKjAgt	1419	814	419	12463	14632	jxnNJgeUeewBTD5UEPTNQ2kbDEaZ5WfyNe9ZERJVum8LoQQ3Jgr	11275	15869	15869	1618795620000	canonical
22535	3NLCgC3KLZDPECzFKSEvuqcKcxh2aSuGwfdA6uQJJr7eCGRXTgqu	22534	3NKpE9F1NzDVQnzJXKDYKVU73AiCW8XzLLtVkByWXKyuakHKjAgt	1407	1395	419	12463	14631	jwqCW67p1btTJcapaqJQZvtT9x6SHHcxXK4L3ok7HPcMxBCkeKv	11275	15869	15869	1618795620000	orphaned
22538	3NKcQgUmHyjX1nvyV5jVcrEsc4ESDf1NopeEMi4mbt3u8gNuHfbe	22536	3NK7npzBi8MiSxbmnWRCcJN5nzjVPv879sKp1ermeubsLBz5chjT	1652	1189	419	12463	14634	jx2EpWKEz9198XiUbKQbDrCgU1NE5xhdjKZzcRCvaQU5PBL7U32	11276	15872	15872	1618796160000	canonical
22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	22538	3NKcQgUmHyjX1nvyV5jVcrEsc4ESDf1NopeEMi4mbt3u8gNuHfbe	1529	1190	419	12463	14636	jy2LsccgHvHrrEruZervHER71Q21nHGhQ9A7mPcA9gmDTMhbrKq	11277	15873	15873	1618796340000	canonical
22539	3NK9Z6DuFzYUro2gLH4nNggUuHU4HpknXTt5tKbTtY4c2V3WuM34	22538	3NKcQgUmHyjX1nvyV5jVcrEsc4ESDf1NopeEMi4mbt3u8gNuHfbe	1406	1393	419	12463	14635	jwcvaELVuWmZeXdrsFtp6TYzqaxeVMmUYRE6G79UdHGWnPRiVbX	11277	15873	15873	1618796340000	orphaned
22544	3NLiCGfJg4URkm3TJHFx5kpfGgWY8o2pJe4tQPsdPeRmD1QnDU6A	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	1577	1327	419	12463	14639	jxEbyWTPsxPAQFc2YQLywparqH5caxi5C8JKZFTpTUdpn9qtFK5	11278	15874	15874	1618796520000	canonical
22541	3NKmGN9emPPZNuAJUnng6xcZwd7bpdBE6TsFcbZPmLiLcW5sQSLL	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	1602	1003	419	12463	14637	jwqdF4mnZWCrCUPudvqRaZSjn5R6ip9hghxdr144MKYAZsqczXm	11278	15874	15874	1618796520000	orphaned
22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	22554	3NKh5NgqRw7LGjo47SBAADqoBUhGgt9ysNapcpMuWDXTwZRaPs47	1633	1024	419	12463	14651	jwd2zb6dQkzbFNqYd43qcqAkKsVYZ9SCwq9KpFEYAGPwBJ9n7ka	11285	15885	15885	1618798500000	canonical
22558	3NLNj3dcTisKdCDGn1x91YddfKZTLgJ445y4oKDV2Z5pDXVLZyp8	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1637	816	419	12463	14653	jxY4rQBbW25g7xZucNuXsVT59GFXwPH8x2M9YSsVrsCK41sFkqc	11286	15886	15886	1618798680000	orphaned
22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	22561	3NLtUuVVCMPXNKcYM4zza74eA3XCp4gPB3KyCzr2KAwHvbCCvXQ2	1467	1376	419	12463	14657	jxZhGqQhpNWy7szc11BwCVEWU2i1ejMas6jTE3L8YSY8cGdn74V	11288	15889	15889	1618799220000	canonical
22566	3NKG4VvSrem2Re2r5kAi7jWo55PGzg6KgNpFopxH4FC6t2rqKyqx	22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	1460	1324	420	12463	14660	jx9ZzcrCtv6qffx6CgXkjs6RkSzrRQyNrrE8bdYdLUG2iKutVbg	11289	15890	15890	1618799400000	orphaned
22575	3NLUeEQTU9oDpZ2ChADvgKBezLZqZofHs2roByBtSWgcpjLL3Cvu	22573	3NKhDC3Jzb1Us5dvqnFPF8taE5JpuFpTDTsdb3GY2ceEhaF7ZrPd	1650	1009	420	12463	14669	jy2VNfCE1FhEy8ZvvuXnQo7GHMUpFfSpHxUrNtP6YTJTSJrM3rc	11294	15897	15897	1618800660000	canonical
22580	3NKDxE4prk3bCPbhKH38nsBC81Zg5vst4WtPGj3tDRs52X4G3iJU	22579	3NL2cUGxzzvJjUy7z2gZnNA7jCnbB7feECQ6QZRpBTyjRbYQPu7h	1601	1022	420	12463	14674	jwFNshAr6ZCm6BPBFRNrJ3bjyvE7QuvmjMepAquhwgvJQKfyoZ9	11297	15902	15902	1618801560000	canonical
22585	3NLDq6Ey7UsUG85EcV2j6d9Ai3uizBEGBkwkipoxRT2x4gHXhzdb	22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	1483	499	420	12463	14679	jxaYUcTpii66GtLvwWF8b19LkDjifNUAUX6WZPDbVuKBFdxTPAt	11299	15904	15904	1618801920000	canonical
28031	3NK9u4SQdRL4kJrDxY6SPQu4z8yDFYCSL9f3R1NTUvMgoApSY1Lp	27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	1671	1119	541	12463	18974	jxZSEFgbTo2XxGd8GqHCcHCXzrmuTQtHpYLcqgDPURrrUaSfKNn	13704	19538	19538	1619456143584	orphaned
22581	3NK9ahL18GhdDrtJVsKQyvUksRbaAvQU4YC7zGipXt3K4UiuL9oq	22440	3NKy9kMb3Zd1L71bwCNYBJsP78qqCA4CdNeit6XgC5qoKCDZ1SqY	1601	1022	415	12463	14675	jwwvw1udD4komqxgoRptcaDunAauKvmHaABGeLFn7oehq9UPRzo	11210	15902	15902	1618801560000	orphaned
22592	3NKQHfuidAgwggJmMRKwFK9S41rQQCMsKu53PLpyK538qmpWvFYj	22528	3NLmuHrsp7x5cJXP7BYWnozDq2o9Ms4qNUWztuVFcDMGwUgBnw75	1451	926	418	12463	14686	jxWYGJxwyUPS7ZJt8fNxgnfqnYfc4ErNuAuhVwDdKz8hBCruCNi	11271	15913	15913	1618803540000	orphaned
22549	3NKcZP2osxUEzwg8cJJMyTYqdjpZn2huvjARxJrsA3kBwUDbRQyA	22547	3NLD6sK6EHEuM7z6pYKbWMhmSAxdeFmcQzAaa9CxhB1zmhtNBifn	1596	1237	419	12463	14644	jxBYPkxkc6qM9Jf8ms8gtnNdwmRVQRRYcpjPVYDT7MVg42n1cPV	11281	15880	15880	1618797600000	canonical
22550	3NKRFnvFqSgvLhB4KJxwPQyEFn7ZYxfZTykaRiyy8ZDeHMiW1QtZ	22549	3NKcZP2osxUEzwg8cJJMyTYqdjpZn2huvjARxJrsA3kBwUDbRQyA	1507	1280	419	12463	14645	jx8atFSLMV17CwEt9R5NiF15M69RcJgqyjuMhQiLjQCcPRvjs2n	11282	15881	15881	1618797780000	canonical
22552	3NK5dUqLvjKZf1EjtUABwBowLusNFi6ed93pJpQu9vtNigRFbKg2	22550	3NKRFnvFqSgvLhB4KJxwPQyEFn7ZYxfZTykaRiyy8ZDeHMiW1QtZ	1444	1381	419	12463	14647	jxW2qj2ouLT6Po8s9byjvak42X9V7QAb4dsSSAQFdd8GNviPR3k	11283	15883	15883	1618798140000	canonical
22554	3NKh5NgqRw7LGjo47SBAADqoBUhGgt9ysNapcpMuWDXTwZRaPs47	22552	3NK5dUqLvjKZf1EjtUABwBowLusNFi6ed93pJpQu9vtNigRFbKg2	1578	930	419	12463	14649	jwk4pnLCQAeKEguFgpsc9pvjH7Zjw28MMF8BgBnTTc59ZyTibVv	11284	15884	15884	1618798320000	canonical
22555	3NLkmtaBzV2D7wM8PGcvT1ST4PvJQJhRCQVrwBCgxdXLKHMraKNw	22554	3NKh5NgqRw7LGjo47SBAADqoBUhGgt9ysNapcpMuWDXTwZRaPs47	1607	982	419	12463	14650	jxRxoiVDBwNQCoZqf8tgFgkF95RRJRwDtiBBebr5kpDZnXr8Q7R	11285	15885	15885	1618798500000	orphaned
22559	3NLP6DkyfnZwt9K7m5rLxTZTJjFBi9gmnNTzxhVfWK4RhXwCqL9L	22556	3NLyU3VkuoEDHXYEGzgVyFeh5bN7kUnfSzWRyTbAn2h4PxxxbCqT	1406	1393	419	12463	14654	jxuGHsikmD65uGXdRGtw5TZJ38tEvQEhMtAwo7p1Qovd1WqFLjH	11286	15886	15886	1618798680000	canonical
22561	3NLtUuVVCMPXNKcYM4zza74eA3XCp4gPB3KyCzr2KAwHvbCCvXQ2	22559	3NLP6DkyfnZwt9K7m5rLxTZTJjFBi9gmnNTzxhVfWK4RhXwCqL9L	1407	1395	419	12463	14656	jwWoW4NaVSknQG4KNZQ7JhghUfdEq46Hrn2o2UrpfkujjPECf1e	11287	15888	15888	1618799040000	canonical
22562	3NKmC6iDBRhjeVZFrfZQuJUvQf4C7efBqXm2aucvZCvhezMPv4nn	22561	3NLtUuVVCMPXNKcYM4zza74eA3XCp4gPB3KyCzr2KAwHvbCCvXQ2	1467	1376	419	12463	14657	jxZhGqQhpNWy7szc11BwCVEWU2i1ejMas6jTE3L8YSY8cGdn74V	11288	15889	15889	1618799220000	orphaned
22564	3NL3TtEBwrqv4vBaNAXXC3tcvsg2mUasa28B7mnt8EnSuXwdjTrB	22563	3NKFBbhYEuznHsWBE2o59RvuLmzk9eRz2TMA6P2xEiBw9sYwp8tJ	1447	1099	420	12463	14658	jxoCHYTXxYYDpoLLpDYDeBXvqPajDEAovjEPjb9MBq9F2KJBVQs	11289	15890	15890	1618799400000	canonical
22567	3NL3LkCzvvvTwYWvNkBoCsKRL8q7Y7e3wtpYyzyaHiz2bxwFcXQ7	22564	3NL3TtEBwrqv4vBaNAXXC3tcvsg2mUasa28B7mnt8EnSuXwdjTrB	1405	865	420	12463	14661	jxCEUpiBnAGsiU45fGdbWgvkRSrBZNY8PuTtFraVz1TuSUfAv1k	11290	15893	15893	1618799940000	orphaned
22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	22568	3NK5W1oxS6BYvQMh1ZjngdfFjrSzA71mjthZjdX7p1dT7aWejqex	1607	372	420	12463	14663	jwwPAomThifzoja3XCUsNoTFZeQ3UjrgBhVNGmx8YUTn16UKJoi	11291	15894	15894	1618800120000	canonical
22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	1536	1313	420	12463	14665	jwQdZ5262qZtRjQRdMnGoEw1AZ6Ypp9HNvBA7tJFDPNCPPn6dXK	11292	15895	15895	1618800300000	canonical
22572	3NLCaWVQuDZ2gKBAN4ekuZ6BpZxXBapMVupm9x6Q3jUFc3D1Hupr	22569	3NKDBkj1TDiPV1BHiShab64xyr4iiHgwzziSJJJqRpke17J45eWX	1669	378	420	12463	14666	jwtVUqcCAgvXyikUHmsNkouCjpCjrVumuMH7cvn4vyNc8oSSHM4	11292	15895	15895	1618800300000	orphaned
22573	3NKhDC3Jzb1Us5dvqnFPF8taE5JpuFpTDTsdb3GY2ceEhaF7ZrPd	22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	1407	1395	420	12463	14667	jwPcTKx1mH7fh7v9S3fd6BdBx9B9kpSGp9GuEGe1TZYcBwnHAbZ	11293	15896	15896	1618800480000	canonical
22574	3NKLEAvHPSNxdrtnvYTFc3N3D9VyQ2G8kFmMaCDCnrXdpHjhJ9Bk	22571	3NKetCukRrk3YyLgMGoc1LG6KeSdAgjSE7JWTvGun1NibFPgZ5Gh	1555	1347	420	12463	14668	jw9RZzJ1JjA15xsqVfKXvZJ23mM2jWzmUCp9itkARPxuCT1J6ND	11293	15896	15896	1618800480000	orphaned
22578	3NLDryha4KwH2rk42zfsif18MzUFmRF4WJxLjhQPnY3ojjMaNrLa	22575	3NLUeEQTU9oDpZ2ChADvgKBezLZqZofHs2roByBtSWgcpjLL3Cvu	1590	1174	420	12463	14672	jws3fjA9B2evGFddTUc2YvSZWVqhkXmkQejAdpPVBY3E4q33BiX	11295	15900	15900	1618801200000	canonical
22579	3NL2cUGxzzvJjUy7z2gZnNA7jCnbB7feECQ6QZRpBTyjRbYQPu7h	22578	3NLDryha4KwH2rk42zfsif18MzUFmRF4WJxLjhQPnY3ojjMaNrLa	1419	139	420	12463	14673	jxk9NjatkQpDgfheS6E4XwPSKdS7ErWARN4hmYWGzTVFj9z9GxY	11296	15901	15901	1618801380000	canonical
22583	3NKUYcGK8YbkJYCoBdxP7ULrnH8nJWRKk9Z3r198m8p1H2c3K54D	22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	1543	695	420	12463	14677	jwAhbYzgKHesaZCTVugTURRCnYCtRRq6wWv2rYAi4we8DbFJnK1	11299	15904	15904	1618801920000	orphaned
22586	3NKkLZcQRggZ5cjjKExz47FWepb1HX5WxRv6BjYYxaxMBvq6pnSz	22585	3NLDq6Ey7UsUG85EcV2j6d9Ai3uizBEGBkwkipoxRT2x4gHXhzdb	1536	1067	420	12463	14680	jwJ2KB32eLBNbTos7xhnpT1DyRX1dgzH927us1N2exT3ypGg5HD	11300	15905	15905	1618802100000	canonical
22588	3NKAquGUk4YHxapa4fHkHpf8zQHVD39G4zB6MF2DGU3969nBXoFw	22586	3NKkLZcQRggZ5cjjKExz47FWepb1HX5WxRv6BjYYxaxMBvq6pnSz	1590	1300	420	12463	14682	jxu4QvgBXPaLLgZvzRwzEyyerAWefCVrq8ut9EExsF9WpNQuj5R	11301	15906	15906	1618802280000	canonical
22589	3NLvgCv9aru7dmrq5S54AYkLVXno8HFhFjTFs9UqvQZ4mDf1gbL5	22588	3NKAquGUk4YHxapa4fHkHpf8zQHVD39G4zB6MF2DGU3969nBXoFw	1403	824	420	12463	14683	jxMoK8LUSijgexVvi24rnneiLwPfQfMt9y2ofW4njHYN6Etdtpk	11302	15909	15909	1618802820000	canonical
22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	22589	3NLvgCv9aru7dmrq5S54AYkLVXno8HFhFjTFs9UqvQZ4mDf1gbL5	1648	1158	420	12463	14685	jwQ9fBUGpujhku4rD8pUKGSz18zhfUcxwY6zSGeANFFQzJ55mpP	11303	15912	15912	1618803360000	canonical
22595	3NKmpfvaYHXYXfe7vJ4JaQaGFypRLHjQj6o3GHpfw9yPPSXANCCv	22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	470	1183	421	12463	14687	jxYhSiY33RsFbZ5EEU2xDqNA2sCmMyGGU9soSuBe9D189hKQKez	11304	15913	15913	1618803540000	orphaned
22594	3NKj8nqS7AWqEfqFTxEC8dLHGuu7ZNFA5vem5gSMu2V5WYPPKzU1	22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	1451	926	421	12463	14688	jxSmhsvX14JnAwAz8p5to2eztFGgdtRrcLbuv5mAN2Ahu8wTRY1	11304	15913	15913	1618803540000	orphaned
22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	22593	3NL9khcA1QZwzLbUBQUnU1suarPqfjcy3mKcqg95H51UmTcGHLNa	1426	1118	421	12463	14689	jxTUmFm3p3mr9LiGnpMBtU1CjSckUy2pYdf2g6mXrWHmL3r7Gda	11305	15914	15914	1618803720000	canonical
22599	3NLU7wmfLCT6UdAYgc1iivB1tEkneVHeGUVMUnuU8gWfDSJ2FnHH	22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	1639	250	421	12463	14692	jwZY6AJpyeGMKSXFU4G32P6dzTf5CeaSkn3Au6amtetbb5JBY28	11306	15918	15918	1618804440000	orphaned
22601	3NLiK8XNAxFqx6nMuiFfiimgEK7NBgP1UCfoKaGcd161bdjAG9w8	22598	3NLNFRT4toGbDE938TUsyu88xrpVrKsQtXF2NfQvvTxK3VvwvDvj	1403	824	421	12463	14693	jxonD5cSfrcNtK7WoNT3KQrfxBNGJUwpisCH5jq6gzsrnncNAqB	11307	15920	15920	1618804800000	canonical
27742	3NKjY5cHLbQbwpDD5dLH2jrWRTybXaYmBa73itHYDC6RZaUe5MGV	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	1523	1195	541	12463	18974	jx9PiGX37r864bV3TnXamsjATsqiMrPx3UEo7LMAg73KVNVbbRH	13706	19310	19310	1619415000000	orphaned
29279	3NK7DWRoaR9RDrXXWpPkA3qg78JsFRpubA4kx1bxJczyTGRbmTme	29277	3NL4i1s6S5vd7LrCfzNiUxsUst6t9o1Ryj77QNy3ZvwupcUDXDpP	1601	1142	574	12463	18974	jwQJdH6xwJfqXHDT2MQ5scpW3Lcwer8W5964GmddZMaN6fKaCfp	14429	20320	20320	1619596800000	canonical
30209	3NLg5Vi8dvByWhwE8s8aKHa38E3Nb9A2Uup6vDS3dBXTXi4PYw1j	30185	3NKWJWNbD3St9YoCccuLdGsYLcLb7rdxtCojL4H86CCVcNY1WAE7	1634	1331	582	12463	18974	jxLQkC2M6wJZgijnNVyTVF3MVbn8SuMPqz8m9pAB6aUsZE7e25d	14588	20916	20916	1619704080000	orphaned
22577	3NKwxTJzWN7MF8nUh1E7y9pa931mWsvRbpkJ9nmvDUULCSC1sHWP	22575	3NLUeEQTU9oDpZ2ChADvgKBezLZqZofHs2roByBtSWgcpjLL3Cvu	1444	1381	420	12463	14671	jwaNSQAxap1XEqRgruhMGHu7kSkVSpZEKzxDnruh46XnzmvBxWR	11295	15900	15900	1618801200000	orphaned
22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	22580	3NKDxE4prk3bCPbhKH38nsBC81Zg5vst4WtPGj3tDRs52X4G3iJU	1407	1395	420	12463	14676	jwXYtqRgD9SAx2tQ6PCC2277u86zuf95QqJ7XfqJqjYgoAYbAef	11298	15903	15903	1618801740000	canonical
22584	3NLjT6SEn7dXtV53pCoqwHkfncU2sLoyERMNQqMtkCZUoszmoySz	22582	3NKcpDREER94nhcC2PwmEN2xnX8g67UyCyd7828hgDS74i5aggZt	1619	1275	420	12463	14678	jw6h2aM7rDUiBrXpSLS54jf7epj2Dzh1BthrtYwbnKvjJ4pRWx1	11299	15904	15904	1618801920000	orphaned
22587	3NLMfcZnp4N6jPTdXQaeq736UmpkSJzodQGawUprpmrG8NmQ2XSd	22585	3NLDq6Ey7UsUG85EcV2j6d9Ai3uizBEGBkwkipoxRT2x4gHXhzdb	1611	975	420	12463	14681	jwYD1TTiWJ2rSn823wDFP7NBeQvH2m6tXea1kwJ2PxQ5ccVDMq3	11300	15905	15905	1618802100000	orphaned
22593	3NL9khcA1QZwzLbUBQUnU1suarPqfjcy3mKcqg95H51UmTcGHLNa	22591	3NLYuxqm1NHjDK785oN7TEiKgXtAyWFMp8RT7M1MptdNQV9VjCWu	470	1183	421	12463	14687	jxs4jtXKydKTVTyLPc6oriiU3hvUxQm6acSq7H9KpNkCSJNSZLy	11304	15913	15913	1618803540000	canonical
22597	3NLDo5qSWoSHN6huMmogLr5hNARE3LbMoXWhwQzEj5minXovptFA	22593	3NL9khcA1QZwzLbUBQUnU1suarPqfjcy3mKcqg95H51UmTcGHLNa	1589	1160	421	12463	14690	jxGNFPDdZxZu2Gz8NRWAGaKJTZ1nG1wVhMdM3HemSSHHw2WgBDi	11305	15914	15914	1618803720000	orphaned
22598	3NLNFRT4toGbDE938TUsyu88xrpVrKsQtXF2NfQvvTxK3VvwvDvj	22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	1406	1393	421	12463	14691	jwGarC2KoyXLACPAPspJswEK43hh4dpvz98zftn1ooC8M7Wu5nc	11306	15918	15918	1618804440000	canonical
22600	3NLqiPj5ZEXAcQruJ7rwY6VdJykQu9vPREwbNgSu7EYcpJt6sd8Y	22596	3NLDqE193w2Tb2XVy8DvEKx54zxiv7NmBzJSmozw4B94nin489iz	1639	250	421	12463	14692	jwf6ENVqfmEghVcm7wtPJhr8GhdvJkq9VkbkMef8Qk2XVxcjQUe	11306	15918	15918	1618804440000	orphaned
22602	3NLRT2vLNygo8MyYN1tC78GV7xadtsk7B31GwGWeiRX7XkYF4dNN	22601	3NLiK8XNAxFqx6nMuiFfiimgEK7NBgP1UCfoKaGcd161bdjAG9w8	1613	1223	421	12463	14694	jxiv514E2F2emhsbGStuzTBLJoWqhVq6cE5eAFqCpGJJnvB2R7w	11308	15921	15921	1618804980000	orphaned
22605	3NKkxT7cKasr1kPgzKUByuGerdA2kBG7v5gM3SehwDhCT9nxqrez	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	1599	1041	421	12463	14697	jwZsLnhm9q7K78yF4LuPKgkRnpExAmM2oXf9sBu6dcb38aZVAXM	11309	15922	15922	1618805160000	canonical
22606	3NLQtvD44b5KbzU9PKpSnBqoGDsS92uoDmN6RdyjbKFdn7fNWFZz	22603	3NLD8W3DjPNnMEswyHkZQRCCfx5B92oYxbPqUbkicLYhJY1Co73X	43	1184	421	12463	14698	jw7saNcvM8oe5hLZxk9ngKaoaZ5zxW6ETjezeAPRLd7PgxMGTnN	11309	15922	15922	1618805160000	orphaned
22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	22605	3NKkxT7cKasr1kPgzKUByuGerdA2kBG7v5gM3SehwDhCT9nxqrez	1646	988	421	12463	14699	jxrco7DaFsLm97qrXYzGeZ3czHgr8pnw3iCKMRvxwnG1YEsPJaS	11310	15925	15925	1618805700000	canonical
22608	3NLAB4JBUoZWvgXfFmakyj8pHJkaQ44aZHAkFxd86oBW2CEVor51	22605	3NKkxT7cKasr1kPgzKUByuGerdA2kBG7v5gM3SehwDhCT9nxqrez	1646	988	421	12463	14699	jxsYvr4ugc6WmJnG4EwjEcvuZubytdoA9MyijfnrcwRAaVvVV4s	11310	15925	15925	1618805700000	orphaned
22610	3NLpoRmJFv9Kb5Ry2hSNgtQmjgAag2FJypv6r45x4uvWpbgvVwmN	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	1403	824	421	12463	14701	jws44X29mwPqu6tCr66j6Bs4WTtPVHQS1YrPYhJby788qV2wDPf	11311	15926	15926	1618805880000	canonical
22609	3NKtKE7HNrBaHvoJRSjJmX3sPag6L2Jt26DwPoxYDgoeo4LJVGnA	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	1503	1151	421	12463	14700	jy1MccvLzZoGDxzkxJA9yuKLkSfkaFeG3Zf3epjCZwMer8aHkQP	11311	15926	15926	1618805880000	orphaned
22611	3NL1K3pPePoc9P3HQTeBc75ftjGgYSCziZgDHxn3mZaejp1WaaZZ	22607	3NLxzACTGidkFaxuPnwodrX3hdVkAgPTnUKdAteMBw51FkMKJAtM	44	1325	421	12463	14702	jwmxPPsWbbw8VPktpo2DcbCQkDwtHaWKWhXhAuhrvR5FD3Y47Zh	11311	15926	15926	1618805880000	orphaned
22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	22610	3NLpoRmJFv9Kb5Ry2hSNgtQmjgAag2FJypv6r45x4uvWpbgvVwmN	1407	1395	421	12463	14703	jwS1RCkZJQ687tAa1r4raDme6PBerLBFr5p4xTcLENFNM3pAQbD	11312	15927	15927	1618806060000	canonical
22614	3NKWd3D13oBUTXueSYRpUcpaMaAAYVidLqycrhXnFzSTmyy93JiC	22610	3NLpoRmJFv9Kb5Ry2hSNgtQmjgAag2FJypv6r45x4uvWpbgvVwmN	1581	778	421	12463	14704	jwk6SRQGMad6WCjJUrscg43RAWs4s3p9LeUH5peGfwEevs4XctY	11312	15927	15927	1618806060000	orphaned
22616	3NKUc8RoGcMhM81Z1TRyQeCeBCD5HauTYv14Nn5PVufmbFd18gAL	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1624	1334	421	12463	14706	jwvsrnJK9cQ34ZEmbFSB7YvFqqQaXgRfxWBqTRMhBhms9h8M9Zi	11313	15928	15928	1618806240000	canonical
22615	3NLmpJeDCdV813uFboknz4gLNTeib9X7a2M8mNjR2fQPxaDhLGWo	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1483	593	421	12463	14705	jxe9akgdbCWRMruq4cksaFrd3SzwhicxScXkH8q5ePDEkYVkceF	11313	15928	15928	1618806240000	orphaned
22617	3NKWoxUaWxYJUx2cjb6VrscNXizJaevGPLnHPoinRqJ9wrd67S7P	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1624	1334	421	12463	14706	jwXNNhQf6cWpfchJP45YxzEe1CTyt56BtHFYoaxSpnh86HGdEXz	11313	15928	15928	1618806240000	orphaned
22618	3NLUXzHndqEJZS6kCppu78agTKP9g1TLVkQHeQ3CKJ7u6Ef71edS	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1624	1334	421	12463	14706	jwCNP8vsjiUnPjfMAZ3rjvLiHgbn7hZmCER6tP9X7vWCRLPgfXr	11313	15928	15928	1618806240000	orphaned
22621	3NKiFZMpxY7czS4QgPKyoRgidAi22U4hWCwTX7A99ZkHwiZ2cxGD	22616	3NKUc8RoGcMhM81Z1TRyQeCeBCD5HauTYv14Nn5PVufmbFd18gAL	1656	1343	421	12463	14709	jxWbpvhUAtP3XLyEYWDheBdgCAQx1Ds8V3dMPWRjGz8v9gghfkJ	11314	15929	15929	1618806420000	canonical
22620	3NLUJc43hzCDNdd2ofGyv42G5y7Jbz9uECQbwnQ9SUbsccBEgoGy	22619	3NL7PRWGVDAQoBAxvpUKe3HL6brYzcunVbqWuYXDcomatjjsE9kb	1656	1343	421	12463	14708	jwW3cJvxLiJ3uhE1ocLpcfFLAMDfnT9nc7TtU3PKZ44CkC99kEL	11314	15929	15929	1618806420000	orphaned
22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	22621	3NKiFZMpxY7czS4QgPKyoRgidAi22U4hWCwTX7A99ZkHwiZ2cxGD	1503	1151	421	12463	14710	jxsV7a4VqZvGyypniok9uie2ajNpf726KRUERCjYrM1EVgw6EaG	11315	15930	15930	1618806600000	canonical
22624	3NLTyXz6UPA6qyqJdGVVRNoiux5RbEHRmL7qdNTZa1WW97BYYoYV	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	80	1273	421	12463	14712	jwNVUeLrVTKmNXPYs8V7c9QiUSP6byGgzj7MH6g7gC9BHFo2qxy	11316	15931	15931	1618806780000	canonical
22623	3NKHDKgmW4WQNJBPqy6pjM2TfXhPHhRyyjNF3QvfqYeFqWBAh5Qv	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	1483	402	421	12463	14711	jwrP8C8A2x4VWRrFJVsysQPM47NcNV3t5PVCcNXaCgK6NHTHMr1	11316	15931	15931	1618806780000	orphaned
27767	3NLZAzs9zbcvkkggMXstdW2zEN6LCnnMzXjAZtkVHxpVWP931BJ4	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1546	1213	541	12463	18974	jws4eW6tb8T7gfRqwNTiN1egxthnBt3GPw6DTxtWgSoUo8w8fg5	13718	19327	19327	1619418060000	orphaned
22625	3NKySjDkiAvZNxRKpBxAAf8GfRU4sGDQYV6zy4nkkg31fo4wo5Wm	22622	3NLDh9CLTYekWQN8dbPEQvQdQqF9dhKeF7U2XPfWZL6du5vtWjF6	641	1210	421	12463	14713	jwyCBuVFWLt8pqBA9C5csoais9vGg7ghHeeYvH3SewaSQmn56ve	11316	15931	15931	1618806780000	orphaned
22627	3NKF1smFbmnDH29jLZ33R5naGswcJnsadZncuqGMuiKx9vF6Uwfz	22624	3NLTyXz6UPA6qyqJdGVVRNoiux5RbEHRmL7qdNTZa1WW97BYYoYV	1668	1124	421	12463	14714	jx52Yj6taBc6tGoaZyPhydWL5Qk2Mbwvhy6rtHi2sYQaxDQbATj	11317	15933	15933	1618807140000	canonical
22628	3NKn74dcCBtFVPvLNP8Z64ftFH3KsiJZmtrtfjZbrF28HGBahsiY	22624	3NLTyXz6UPA6qyqJdGVVRNoiux5RbEHRmL7qdNTZa1WW97BYYoYV	1637	816	421	12463	14715	jwqUDUvc8mwhVkTNYNvUhVcWFxAVATyYK28NzS5pWQnXjuqyNes	11317	15933	15933	1618807140000	orphaned
22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	22627	3NKF1smFbmnDH29jLZ33R5naGswcJnsadZncuqGMuiKx9vF6Uwfz	1457	1391	421	12463	14716	jwGat6NDPmNTQ5wGgV9JhcHvSEKcXAAjReMhMDwKL8VMJ1iDTFz	11318	15934	15934	1618807320000	canonical
22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1503	911	421	12463	14717	jwGuDjpMY2oq73x59RjPks5LbE2wC5NY34hqFquQESAJoQQps37	11319	15935	15935	1618807500000	canonical
22631	3NLUfxyZec49Dxo7YwxMYAe81rbwH8MYBPAuVR9ZnU5hNxtKde8n	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1671	1119	421	12463	14718	jx9qYRbM2KjtcidsCbhBB4QE8ggSMMRMKNQu28CSWkV6DoBetco	11319	15935	15935	1618807500000	orphaned
22632	3NKgYPg4pRHm5VUjyZRxo1vMj8d5mK2W5Co9zmv8p3ufAwnM3Yoe	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1541	1172	421	12463	14719	jxu1pymMG92abwBnvYd1qjDzVpPY22SEBE6nBcgnhLGV9CUMmyV	11319	15935	15935	1618807500000	orphaned
22636	3NKMKNopsVBK76KJsboDsQMnLesKzhQ375oiRLBGEGaPjEUExDof	22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	1631	794	421	12463	14722	jx8SurRHzGZZ1JHiPg5Ek8bJZ9dVv9YGvjoXTDzLEtMGQvi7aSh	11320	15937	15937	1618807860000	canonical
22634	3NKDkapEHuhP8e1UL8VKJNGkyHiC93m55LAYhsymP9yuZuseFLCg	22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	1619	909	421	12463	14720	jxVmbypjA498S1CwLMs7Dx7Sbhcii5ym9rn8rr3SMrJMQPdoS5P	11320	15937	15937	1618807860000	orphaned
22635	3NLWxB23bkBc7W46achYcA6bQqrdycPmarhxhtX5mN5qJUm3qZdu	22630	3NKhTcU5nZUJybUemt29DN7aWbq2Dx5uddcRdJwBPvHHq1Y9CyC4	1675	1342	421	12463	14721	jwcvb7fkvhVuYuJKPfsWUFvauPN7fGikdTpk7XsyhK8cuV3uAos	11320	15937	15937	1618807860000	orphaned
22638	3NKNVB1MQnRXpSXzCdtBnWiAW9DBNLhunU6YHPQUdMdRQdcEJNwK	22636	3NKMKNopsVBK76KJsboDsQMnLesKzhQ375oiRLBGEGaPjEUExDof	1588	1026	421	12463	14724	jw8mYcZuPScufg4mQAzzAxMAp7id7WnEwUEmTo1624fKgo8W1X1	11321	15938	15938	1618808040000	canonical
22637	3NL8PNHHpkepKWeWWp5pwFM3mEYgEFrDpPvixQHBPi1YR1gq1DYC	22636	3NKMKNopsVBK76KJsboDsQMnLesKzhQ375oiRLBGEGaPjEUExDof	44	1079	421	12463	14723	jwJcL44DoyLkcvCVWos9SCKKViyAeSkL3GhsYGc9hqwt7rktEQZ	11321	15938	15938	1618808040000	orphaned
22641	3NL7FjKZcaz8JwkqhbH9mQrsmgVYLUQYekUyCWcWBxzAek8Zg2z1	22639	3NLe9QvHK9YYAcGZCQHw4gUfJJS2cXSeYpkxgvGCDmyuxhFmzT7P	1573	1318	421	12463	14727	jxZEb3qxRNP1sCCjsF9i2ojNMq9QnCwMgEBBm45n2QARCJFQ46Y	11322	15939	15939	1618808220000	orphaned
22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	1588	1392	422	12463	14729	jwd1hzJo2mnWLUXkLMqArnKGUGgmQrfWgca5teFzWEgE2Jq21pn	11323	15940	15940	1618808400000	canonical
22645	3NLhKiYryocYfqpPtcBYH2kxWZ6xs8ajkZZzT9yHTifAhmJDZ3KG	22641	3NL7FjKZcaz8JwkqhbH9mQrsmgVYLUQYekUyCWcWBxzAek8Zg2z1	1588	1392	422	12463	14731	jwGGmXHFtsXxg4h3H3Mj2jwwMc1TLykMPLM6vdgdQdemHJGSBcR	11323	15940	15940	1618808400000	orphaned
22656	3NLEMwmeNarJWUYHX8YWu1Qxesk4fnc9EW7QeMqYXZB6dHM8jaUb	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	311	1061	422	12463	14741	jweg77W3RXGLN86TWQmYkJj4kJHgfzYxNa7M2FJAvWcSvdh8BBt	11328	15946	15946	1618809480000	canonical
22659	3NL4NzDURP1FVh7eW2veEmcWJHrSs2sS1dvpZbjCsgWDWf9NAJxD	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	448	1305	422	12463	14742	jw9TYMnWhGmRq1oMh1JQDVK4RYLhyT7GRFZoeYdXUHVFzEzUU8D	11328	15946	15946	1618809480000	orphaned
22671	3NL84M5EMLoCGiEGyhpbomyM8qiHyKYzwDTjN8AWqMebUeCTZyzr	22669	3NKdyxhLMxDaG16ekxEx8h2yhEH2WetYGmdQFbPe2VvNK35eX8sS	1600	1126	422	12463	14755	jxFHARPhn2dB4WPVP5bR8xafutgLu6sQ4XnLALWrbofNV9HGecS	11334	15958	15958	1618811640000	canonical
22676	3NKVGt4X4hX1ay2wSqQK793KXCHXno2FzZZxAPQmiYkg8rHnAiWv	22675	3NKbhswqSETF5JxNxqZLBhP3GbJrifLjnsB7xAXgAjWczDoXLq8n	1407	1395	422	12463	14760	jx9wPuEiPqZVz2f3FwiRUPbTUvsxahyo75q313dpZmVkfFpbj8s	11338	15962	15962	1618812360000	orphaned
22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	22680	3NKawWXDyrMRKb9vfMc4HrxXNf4noCBzJatMJEVdnJR3UgGXJfwi	1503	1031	422	12463	14765	jwJqsGGDsdEn7NdwhUwbw8TrpX3RKvUS3nBUQLL1UT8cYMtn9rN	11341	15966	15966	1618813080000	canonical
22688	3NLQnv9gfMW3pccejAPrwUG5nctxathQD7nAZ9XgKZCni4Hu2DuC	22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	1577	1327	423	12463	14771	jxhNDDyUhXRes7Y183rBYvBiuoHuNCRAxad7WXvHte9w9VodZiv	11343	15968	15968	1618813440000	orphaned
22691	3NKobTUBvKDyZJTwqFFzqnejVbYMKMUafCAJVVc6ahuB9UPQXTAd	22689	3NL3vVYbs5Wdr2Wd1GKiUYQFDwAGocfgW8zLWHxiRqGUYBxtJieb	1507	1034	423	12463	14774	jxAnzhSYQ9S81vzBCJYK4q7mq8uLsPkw3HHbKkPyuK7exWygDUN	11345	15971	15971	1618813980000	orphaned
22693	3NLs4iAc7UNLUbRVGNfY7NKpDrGrDngE3xG4yaMV6KZy14yLGPg5	22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	1458	1323	423	12463	14776	jxQwD7jUc9xjaUbzVA2eCM2MqPDtrtz86Q5oByNHaivA2hZCWDW	11347	15973	15973	1618814340000	orphaned
22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	22694	3NKL3wdNmDhd2c4rCFHnodkx7PrPR7nMBriQhWJcgk3bFo71W5kM	1406	1393	423	12463	14779	jw7BEotrqWW6qJR7f55Ykif9GC15Bw6VdpHwZBpd817fWK2jQSu	11348	15977	15977	1618815060000	canonical
22699	3NLZu8TCFFo1xDmEdYM45Yd1y9e1BzFQug5giqk6YZMC65nkwmcY	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1670	916	423	12463	14782	jwVrN65951ysBntPpnAM5z8FFpwKA5gyiThQqB6MmrzBNgfTYd5	11349	15978	15978	1618815240000	orphaned
22703	3NKF1uZsEv1ZHKanGeAiHvaj6mxNNrtrubBrjX2DW1BFHWd7jtCR	22697	3NLZHVqRWARr7XXyN96fv2CzF3qHJuwUxp3vQssNt2ipbXo6Wvu3	1477	1224	423	12463	14786	jxqwaA3auhmHqV1VsPZiJ82ytNFUApgWTpFQQV6hxM18u8EnKNp	11350	15979	15979	1618815420000	canonical
22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	22708	3NLDz1HFPcYdZC9JTFRceUGW7JQNBSzqUU3FwHcGbUnV66FxhMkF	1577	1081	423	12463	14793	jwANEM57r5XD4hqUcNz6VuCjYQxKrPSPQnd4oHDRE5tMBKaaLDP	11353	15985	15985	1618816500000	canonical
22718	3NKvSzeDYwSTL7Svu7W53qzYAN1WVE5BgjQ7koe5EVvijeo3BdHi	22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	1406	1393	423	12463	14800	jwkzvxJ58yU8vU4vaDFfEqad7jGy5zguH2VcQT6h5JUhdJ61icN	11358	15993	15993	1618817940000	orphaned
22722	3NK7zji9kxitk7chi7xVe8aQ8qc5x8ZMEixJmM6vrFQQ73aTT1SX	22719	3NKHBTcwCmJv2x5FJBQ4EjdgT1YwYtXZrVCzkuz9PkHdKgvkbYhs	1651	1055	423	12463	14803	jxBSPCWaqpr4eeZ8rzT53RaVBgaFhtxgUq6fUMpWBVbmehmDG28	11359	15994	15994	1618818120000	canonical
27768	3NKeUU9rzsAop5Xs3kHFpNKG4zJBHw2bZSoMHgmXvqY4tWxTMJ3G	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1648	1158	541	12463	18974	jxij46UA72Z4FLWkYx4nwvK5DFNS78tW58R6Ntyab1QLu2DUJeV	13718	19327	19327	1619418060000	orphaned
22639	3NLe9QvHK9YYAcGZCQHw4gUfJJS2cXSeYpkxgvGCDmyuxhFmzT7P	22635	3NLWxB23bkBc7W46achYcA6bQqrdycPmarhxhtX5mN5qJUm3qZdu	1588	1026	421	12463	14725	jxAH7h2dBE8k1BQ4smVa4GZxkfagMhZ7xysbXcvgXFBe2zstp4b	11321	15938	15938	1618808040000	orphaned
22644	3NLZuNex8QdkYoxSUGXDAbuggHwseixrBGwFKPSiU87vd7d1UpFQ	22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	532	1057	422	12463	14730	jxtJAiVDVQRHN2oSLVZ3SkfoL2WBCCmURm159mdoFpaL2HxjMZg	11323	15940	15940	1618808400000	orphaned
22648	3NKsn668qxNi8sjr3AN9NBdYdjSn22QGNrPukFSh44o1zQhKs7mH	22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	1631	794	422	12463	14734	jwmuc6Hcihp538RbJc3MBxkV9THYjZ51TcSZwAC8eMzAQ3xiK2E	11324	15942	15942	1618808760000	orphaned
22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	1407	1395	422	12463	14736	jwdSbxz98RuLbuvzzVTzjwhGuqibmPmrzmWf7yqQ3NkUD6rbszC	11326	15944	15944	1618809120000	canonical
22652	3NLXXtuFptGA2sh9Qjk68zPBZUpRB78ctDwRSGVehLZpWiWdE2mk	22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	1474	1083	422	12463	14737	jwVzsRCGhP8NWKXHm4g1tonjJ8rqYeENJniJrcKPMkCGHaV1YLS	11326	15944	15944	1618809120000	orphaned
22657	3NK3U9p3p83LXoprAwuGbBKDw7eKU3pm1BL1ZVrSwNvy29QYDjPt	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	448	1305	422	12463	14742	jxGhtwmf4sAGL7yFH6z8Yt6kDLki18qHxkE6zz6HQwgcqd2NLMP	11328	15946	15946	1618809480000	orphaned
22662	3NKPwU2Jh2KfWUUngmaBNas5HdiCCu7jZ2pP8vFoqjzPqG3HSCmJ	22660	3NKvUkHfTqHjF868NYNkxpvfL2Rqyxp1ZezgmgzmN2VVtGpfqKSP	1611	1095	422	12463	14746	jxrbtdyrKeUAbPfjUVD6TRUF7p6ozh3kN2e8xrBxyvcRMbrZbha	11330	15951	15951	1618810380000	canonical
22667	3NLxnQkd3bQiHngKvn9JpeSmvE1JtZ3p1uPfiXQtFamjLudSYuDa	22663	3NKFDiNLBnpHTtgtvavHkA7SFpJsGBzbzh8xSJuweQd2XNPLBbhd	80	80	422	12463	14751	jwcpWxwcPVEnHCTKoD6qvM8RVQ2Lhnwh9sBJWD4uwvKXN2WyJkP	11332	15955	15955	1618811100000	orphaned
22672	3NLi552Uh4UTGBt59BWa4335vsuaM34rZGFdzTrggTt6Q6qb7DcQ	22671	3NL84M5EMLoCGiEGyhpbomyM8qiHyKYzwDTjN8AWqMebUeCTZyzr	1407	1395	422	12463	14756	jxqGiZUCCks1Rg73mzdpp6qAC9urXNPWj7gpr7dzFjTGtQy7jw6	11335	15959	15959	1618811820000	canonical
22674	3NKGZC7e5JC62m3Fk39vabnCS3Lw2YsfEk36CpEoKuJDpMTnz5AB	22672	3NLi552Uh4UTGBt59BWa4335vsuaM34rZGFdzTrggTt6Q6qb7DcQ	1646	988	422	12463	14758	jx7bKcK7gGeiqsZ6quRuDRKbYCk8dCaQwRXzEbuX1rfwFY7yePB	11336	15960	15960	1618812000000	canonical
22677	3NKGUbPeDRKmP87FRVVrYytFtHL7mG5rK1dPgPRm7hjUeitpuMkv	22675	3NKbhswqSETF5JxNxqZLBhP3GbJrifLjnsB7xAXgAjWczDoXLq8n	149	917	422	12463	14761	jwNZEAZDSx7oeRrrhnar26R4F9zgfsdYERaXkQb4o4RcRvsPjoa	11338	15962	15962	1618812360000	canonical
22679	3NLbg7wnTMYwGgfSmDiFgevKy2sz9Cn73mfbeKUzqSASERrVxDNe	22677	3NKGUbPeDRKmP87FRVVrYytFtHL7mG5rK1dPgPRm7hjUeitpuMkv	1648	1284	422	12463	14763	jxAh5rJTBmmu3M5R7dcV2x1KM2p8zieMvFuwzbhEMj1Qh3iBfji	11339	15963	15963	1618812540000	canonical
22682	3NKN1RDVGJSzddFQBzaTfUMqsMUSJd7eHtwygAvEuoQsNZt5u5ef	22680	3NKawWXDyrMRKb9vfMc4HrxXNf4noCBzJatMJEVdnJR3UgGXJfwi	1587	1357	422	12463	14766	jx4bi665pqk8FkRyvgA7ccM6pEvfgmxZNsL6rLXFVeLYDcqT4B3	11341	15966	15966	1618813080000	orphaned
22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	1617	1288	423	12463	14768	jw98shV9xbLwudbWZjuUNkebtQZ4aRZiMNLVbckMcwiLBZQcjFa	11342	15967	15967	1618813260000	canonical
22686	3NKFiErzZXrk7QCEhfznLrX3eaLBYR8VLCFcoQAhyzge6J4xASbg	22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	1403	824	423	12463	14769	jx4JD5MGSjbWUjtujQXKwZLArCt5KhujRkGDsbADYrkYLSH6J7a	11343	15968	15968	1618813440000	orphaned
22708	3NLDz1HFPcYdZC9JTFRceUGW7JQNBSzqUU3FwHcGbUnV66FxhMkF	22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	1536	1313	423	12463	14791	jwVyj4LuyEH62vYDDmNcs6CEc7pAimsi5hCje994evC48NZVb1h	11352	15983	15983	1618816140000	canonical
22706	3NLDQ9KeXzRdAJVy7HifeGSpZNox5YnqGQqEjSjG24x2cuUhzgo8	22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	1637	816	423	12463	14789	jxUFuH3Z66oxDDsjrQXxyWiKdjVNmtpGMoJHnQFUr9zketaaxQz	11352	15983	15983	1618816140000	orphaned
22711	3NL3513y44XpQZhYLUgWxwEpmAmatmS4UBky1Y5RV513h51Hmikg	22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	1448	1311	423	12463	14794	jxYUCb75bHEJ4qGkft26fpSfJjXgsWnoNXYe9V6TvGCsVLNEsQM	11354	15988	15988	1618817040000	orphaned
22725	3NLHTYS6W2Qha7HAMDzt9QR1qjmhW5p9xUGZQEyRYedBg2cnjmfX	22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	606	1295	423	12463	14806	jwf8KFHVKtomC3Si76JauXGeP2V6ThcXj3CwaYbX7ye3VCNySTQ	11362	15998	15998	1618818840000	canonical
22728	3NKHKioA4TEwjXNoGhnS5ASavQCPa4AQbKWyktCrgC7tyB4seZ3M	22725	3NLHTYS6W2Qha7HAMDzt9QR1qjmhW5p9xUGZQEyRYedBg2cnjmfX	1602	1123	424	12463	14807	jxviM2Nktgt7yv8LW5tS9ZX1SbbeBJn6XBuCiPon5C1dNYUkhPP	11363	15999	15999	1618819020000	orphaned
22733	3NKfn8dXJHJrUsqvAQsLnwj5L9SVWk3BW34mF9Wts7dCHmJd5pwK	22732	3NLRyX7ymBmpWjCVfuqrdz73tH7puxNH5GtuXMLY52CKQLTn4ESi	1637	816	424	12463	14812	jxEw59rSgRU1AHipeoTDQF35Tzy6QQAaUn3cXGC6Yh4ndL3cmg6	11367	16004	16004	1618819920000	canonical
22736	3NK7WWftPPsYvPZRhuWZsu9dn593grwGGCr99X8wNDYE179JjUNg	22733	3NKfn8dXJHJrUsqvAQsLnwj5L9SVWk3BW34mF9Wts7dCHmJd5pwK	1589	1040	424	12463	14815	jxFq9qXm3TzxV4nQnQEj95ioyjbTWDqhZbazNoYYMJ9M4bHbyz7	11368	16008	16008	1618820640000	canonical
22739	3NL3XV9dCCvT7SWn1DVnsqoL7bogr2dQ2NsYFYTc78j3QNTuCYC9	22738	3NL554jbofuda3a3hw8uJDtu5AR3niY25dRS37wgVwruKLdqExce	1407	1395	424	12463	14818	jwWczS61JTCFeWyDxDuzc5eVyfHqGuStCnQzbg8rQnXpZ585k18	11370	16011	16011	1618821180000	orphaned
22747	3NLHm1WFcB32s6bLt5f9aC6DYMsx5yWZCWczCu45Hsb1XscXwyL4	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	149	1283	424	12463	14826	jx4xcztYCg1a4YhaZDoJsswse887enpMwrXCuHoeqJ9sXtPraHQ	11376	16019	16019	1618822620000	orphaned
22750	3NKWv8kXQrWyogZogh8MPzDXyapUELy66ri5iY1szF2B6kBaRoLG	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1440	1011	424	12463	14829	jwa2JjGT4ptRAHh2cQUjNRiRiEAUYBWMC5r6UfCcMnhiwGf8a4D	11376	16019	16019	1618822620000	orphaned
22756	3NL3STGZAERN1DqfSDqrkLrukzRo5vcHDMyCE8vv9cFLwofw3Phg	22748	3NLD3WaHRzSPjjNr9rPMvVvaotbFoakYGaYAMJfU4dQdUUUqhkS7	633	1384	424	12463	14833	jxRU5TVzCGPzHPizQAZQJEdySrW4bdKrBxdHa9zmHbc54uw82JS	11377	16022	16022	1618823160000	orphaned
22758	3NKCzEu6GQeUwP3WPwzEW4p2v5sUTQUtmARyfEABuPvLurqx4jW7	22757	3NLib4kFNpi2nY6gHyedc9ALX53sQS8BWexBS6zQ1cvC6kjrN3QQ	1637	816	424	12463	14835	jweByEY7cjyQxoRDrS7rC9bVZzernMk378HJay1J3phTMpuAYCD	11379	16024	16024	1618823520000	canonical
22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	22759	3NL1XPk835EMx3d5roTFoXyPX5HwmJM4BYFKP1ufhkqDK1yseZhs	1581	778	424	12463	14838	jwVooKvrFfbyUdnPw6uptxSVb7k3idbeT3GNUo3F5GorX8DpLiw	11381	16027	16027	1618824060000	canonical
22763	3NKjUnfuKagg1vNqEGhsr7rb542iRyuQu5SrXf8aXcgg4GEuD7oy	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	1440	1131	425	12463	14840	jxyNA49ysNxWDRnsUMqZpV7FY5FBnsxNvYsMZkV9YoeDbJDKPh2	11382	16028	16028	1618824240000	canonical
27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	1549	1362	541	12463	18974	jwwpG22WwvjKojmtAsdE3FSDjoqPxd4qEdqZNknPtuADku16ugU	13725	19338	19338	1619420040000	canonical
22754	3NKsDKmjDntiyR54vbi9xqhsK9JSYLDkenkrwTB4X21M8YHX2bkJ	22425	3NKyywxxN6KqSiXdQVsPium6EN4R8Btc43AuBh5m1XptZN8CuuGq	633	1384	412	12463	14831	jxPDL8gha7K2DNvfYpndwtsExLQX6NFiejLA4Z4HXMuwZbchD68	11165	16022	16022	1618823160000	orphaned
22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	22638	3NKNVB1MQnRXpSXzCdtBnWiAW9DBNLhunU6YHPQUdMdRQdcEJNwK	1637	816	421	12463	14726	jwTP2Zyo3RynxiomVQoMoWEVq8CQGc6QVCeRtHkkaJQpSXDAePW	11322	15939	15939	1618808220000	canonical
22647	3NKo2h9HUwQEUzsgwmAyfKgo9keTYEv99JZkf4YvrLvMjdHY57U8	22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	1637	816	422	12463	14733	jx2NCZ9XN5PevnTE8jtJSs1nHg9gRAZbhikTmdq8fMnK5GQGqVp	11324	15942	15942	1618808760000	canonical
22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	22647	3NKo2h9HUwQEUzsgwmAyfKgo9keTYEv99JZkf4YvrLvMjdHY57U8	1585	1000	422	12463	14735	jwuHQFYqg2HW9coBWUN2wgYhWAnxxR9bJJcAXERZ6MvoRkVDUVc	11325	15943	15943	1618808940000	canonical
22654	3NLD28QvMaM8fzWpnkWNchNCPJ2ni7rafdzt1Z8yvUo9ZDUJmdeK	22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	1406	1393	422	12463	14739	jwU9fm416FHXEyFVncJ31cV5roHK9qs8hh4ffntKpgdAFJz2tew	11327	15945	15945	1618809300000	orphaned
22660	3NKvUkHfTqHjF868NYNkxpvfL2Rqyxp1ZezgmgzmN2VVtGpfqKSP	22656	3NLEMwmeNarJWUYHX8YWu1Qxesk4fnc9EW7QeMqYXZB6dHM8jaUb	55	55	422	12463	14744	jxDZPQE6KZpGHPyAbUfrqwMxWiw89eWZL5AxjYuJdyg3C3Z6yoS	11329	15948	15948	1618809840000	canonical
22661	3NKpB1KXbp7L139AiTzMP45jQJsyfR7xkjK9zN3mQoEpZKCBqLSX	22660	3NKvUkHfTqHjF868NYNkxpvfL2Rqyxp1ZezgmgzmN2VVtGpfqKSP	1649	1137	422	12463	14745	jwvATik6LCucxkuW55DC7DQfpCAt4tkJYFyetbYg2hBGtb78XHd	11330	15951	15951	1618810380000	orphaned
22678	3NK8uqVkgJD3GNPE67Qx4rAdwtqpvaxT9y7dxX6HcEHFaDH2aVEb	22677	3NKGUbPeDRKmP87FRVVrYytFtHL7mG5rK1dPgPRm7hjUeitpuMkv	1403	824	422	12463	14762	jxmpEvP2adxwr73ngmLq4rf4ySqbR16pwTbD7HPifKxzsTXpTMr	11339	15963	15963	1618812540000	orphaned
22683	3NKcjD99fx9ccAWpVnHfj11BHLtHBEqgprTEvN1KSx3yw5NueZPA	22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	1580	423	422	12463	14767	jwJqsGGDsdEn7NdwhUwbw8TrpX3RKvUS3nBUQLL1UT8cYMtn9rN	11342	15967	15967	1618813260000	orphaned
22687	3NL7x2RKMWDtZYKN8hrovUm88oGjMkK7keFjS6iDm7U9NCHMvqYC	22684	3NKnTMpEnkhJHTeoavH8XC93isF9MWYE7UaT2vSpWvW5TyUfEiC5	1648	1158	423	12463	14770	jxP5HwFqkBL68bxDkq4Yb5KwE7bTUchRT36E35o2ZtNiQAHJzH9	11343	15968	15968	1618813440000	canonical
22690	3NL5AE8AQojw5otk8vC3UM1kJ8YEpaZ61igBtZUYN1hTCLLiupuC	22689	3NL3vVYbs5Wdr2Wd1GKiUYQFDwAGocfgW8zLWHxiRqGUYBxtJieb	1467	1010	423	12463	14773	jxyR7Q2ybpQPcT2DhvZhSKajMYrTQFvAvQiSyTjD8bCvLYNArGV	11345	15971	15971	1618813980000	canonical
22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	22690	3NL5AE8AQojw5otk8vC3UM1kJ8YEpaZ61igBtZUYN1hTCLLiupuC	632	1382	423	12463	14775	jxdzP635ZaDXKw1b6guuhdP74codrJ72x7ooeCGbiUQ7LeyP6qr	11346	15972	15972	1618814160000	canonical
22695	3NK6JRadXmX9F7cxSo8h1cE4YGvYhrxzQgchQkwHgn2S1Fh9tp4R	22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	1581	778	423	12463	14778	jxyd4ZkcwpACS8EDN6QrKAqSqxGLW4sE1vCQ5NseboueBwVuFLc	11347	15973	15973	1618814340000	orphaned
22698	3NLKUWHhqqZXPvrKcn252E2NXgxtw1j9c8gjxuQc1Y9fNhLtM8zw	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1406	1393	423	12463	14781	jxQwGeKTRdT6uHJ2qBucNSjTsNEL7dZv8pdd8gQXg2v5yTKsQot	11349	15978	15978	1618815240000	orphaned
22702	3NL6E5GSJ72ZjftaWfFox1rvBaDqnkp8z9rBX2coYXhMCZQShxy6	22697	3NLZHVqRWARr7XXyN96fv2CzF3qHJuwUxp3vQssNt2ipbXo6Wvu3	1599	1287	423	12463	14785	jwKh9WxNeyWuMGa1RqtYhTsVMobv29K2FmBpMK3kM33ZRguwdDB	11350	15979	15979	1618815420000	orphaned
22705	3NKZt5XupwVghpZoWvPkGY1ZNrL3QhdEXRVvzhEMjqLfrSARdnNM	22703	3NKF1uZsEv1ZHKanGeAiHvaj6mxNNrtrubBrjX2DW1BFHWd7jtCR	1406	1393	423	12463	14788	jwKNUQjsfdxkucWKfE87s7SNp1QqMXcnDFfR1jWD9Lt9mZakSkC	11351	15982	15982	1618815960000	orphaned
22713	3NK6sdTtigVRdvqDwUtocwwW39pn9kehStbzFvRMM2PXStyhMSuE	22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	1448	1311	423	12463	14794	jxiUZxTEUoWqAjgR27F8iyFfX3p6SVKaPenYjv8W6CkpjnUUHwY	11354	15988	15988	1618817040000	canonical
22715	3NLV5asTkSc91wT8mjU3sK4YfaXKPatVx29GV1x8ZjBkrjHJmV94	22714	3NKfj2rvEy1uMxzVFFCFn9shXkmRdrY7XX6iTzES8rtCgsUGwQr8	1471	1386	423	12463	14797	jwnW6K1iPniTyDLgP1XyyNyWzS8LzxGggTsbU1BdVT8SBnsspjB	11356	15991	15991	1618817580000	canonical
22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	22715	3NLV5asTkSc91wT8mjU3sK4YfaXKPatVx29GV1x8ZjBkrjHJmV94	1648	1284	423	12463	14798	jxc49PSbhScVQvpHyvG4oXLbcrAsmS3k6XJFAztDXMqTq8FFKAf	11357	15992	15992	1618817760000	canonical
22723	3NLg5kqLN9VBt2ueW2amvequCgasqaDyGuAW98cDywQhp8G4jJty	22722	3NK7zji9kxitk7chi7xVe8aQ8qc5x8ZMEixJmM6vrFQQ73aTT1SX	1405	883	423	12463	14804	jwrnUr9739g8CSuGw7yHT5ZjEmuWkU6K8i2muPzmoPPaEzQ8jQC	11360	15995	15995	1618818300000	canonical
22726	3NLCCH9Rc81srpEfy9pFWpCJvDr9qeSauFxu3VSnEHAh3rwvhnzW	22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	606	1295	423	12463	14806	jwf8KFHVKtomC3Si76JauXGeP2V6ThcXj3CwaYbX7ye3VCNySTQ	11362	15998	15998	1618818840000	orphaned
22731	3NLJKbK9nrrDPhfuvWjhsL4kRKMmqWWZfZwwRgAgvrQpuxnGauSG	22730	3NKBtVuWpzNmksRnc6Fr4u4EAsjXFSXqFAxiVQcmRP9ABFUiuMs4	1551	437	424	12463	14810	jxGd84htj8AUcznusRi9xXf4UVDG7dsdi6ySFaSUhN6YA4v9drd	11365	16002	16002	1618819560000	canonical
22737	3NLn4qCaMwSQLqdLp3ExwtbzFQdExz6puJEGre8cV3d5XLddCXr6	22733	3NKfn8dXJHJrUsqvAQsLnwj5L9SVWk3BW34mF9Wts7dCHmJd5pwK	1513	1013	424	12463	14816	jwv4Bhpp18EUKm1JoGKUo5zwxW933p1RVkjZNQtta9CqNa3Z5ZN	11368	16008	16008	1618820640000	orphaned
22740	3NLsuNo7XvCipabU4vnpoMbv9aLoFZaeFG5dnFuJaNbVAMNxfQhU	22738	3NL554jbofuda3a3hw8uJDtu5AR3niY25dRS37wgVwruKLdqExce	1406	1393	424	12463	14819	jxHy9fZiXf7M8NXidiLLREEMPLsGxFRQYveweCZ7XKHvzYiKRuf	11370	16011	16011	1618821180000	canonical
22742	3NLvXvkkgz2Gma5BTfeE2Ux57UnKSCsrcRcFSVVtzk6kdDC8s2VV	22741	3NKB1D5aw5jKVo3oMcAVMRySqF815MEH9ga8LuVRLSEBCk6JWKKh	1637	816	424	12463	14821	jy1EjmvPF7knnwJdav1FGa3dBp17sY1BfedzjBQ3qHeYkFqqPY4	11372	16014	16014	1618821720000	canonical
22745	3NLnqfmjNUsMoqM5yph7JJtCLUYEbfCYtq2zDoGeCLMuwvRwtYf8	22743	3NKdoHSN9PkUpurM3RxeeeNdzwhd65GzYu1uij4JVrc99nR7tHCE	1578	930	424	12463	14824	jwz3E5Au8hrm52ha6eP4jTaoJJXzH7dVN24p5J9tehBA6XZKepE	11374	16017	16017	1618822260000	canonical
22751	3NKjibZHoqdvyPyxPUVk68gA61eZwTU78K44JhN4rAb8RqjN762B	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1500	1171	424	12463	14830	jwdo7wEyXGwZppQkESmeVcWQbbfihUEN2ir646vNQJY7zTZdwZQ	11376	16019	16019	1618822620000	orphaned
22759	3NL1XPk835EMx3d5roTFoXyPX5HwmJM4BYFKP1ufhkqDK1yseZhs	22758	3NKCzEu6GQeUwP3WPwzEW4p2v5sUTQUtmARyfEABuPvLurqx4jW7	1407	1395	424	12463	14836	jxHgKh34oppqyFaVDKg1pkWJf4ZYCLkfk799SsyTQwdX7htmX2s	11380	16025	16025	1618823700000	canonical
22764	3NKiCBr7xkc43q23idYMfb1aaRFCyKh8hbpxNVzcd17LvBMbtxAz	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	563	1233	425	12463	14841	jxPxziZyN4s7Hum1gTxj6UW5A1yj6qdtvskvrxUR1TQ3MZ1eCgx	11382	16028	16028	1618824240000	orphaned
27778	3NKdeofp4iF7ou5uS3cEBEacihu1UEm1SpUbsVoiE8Xpk8iEMCQ9	27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	1407	1395	541	12463	18974	jwzuoHCd2PM9ATfNrM2sbqDev84stFYEqksL1UFKhSw4vqGaKJA	13725	19338	19338	1619420040000	orphaned
22642	3NLCK9pDnw1T7Ce42Sq8Syosg7qXrvbwapd6FEYCm4RhopTw4YE6	22640	3NKe5MFWL6tmSR6FWSofA7i8S56GsurSnXGt28n9rAxNEupTmJjz	1422	1337	422	12463	14728	jwV5WuHN6Mwh1u3fzdbJ6v8wnYquiBmZ92wYAHwvYaYk878jJyC	11323	15940	15940	1618808400000	orphaned
22646	3NKo5jUjD5YfBwoXaotYHrGAj8GX61fpcG2721DU8SsqUEW7x5x2	22643	3NLeN3AjRoFekcptK8QD5D8d4jvT2JMvJXA5mYn2VVnCNhT9U9ih	1559	1227	422	12463	14732	jwc5kdwD3TvW3EcdeY6iSPJPZaBDZjw8Bw5QXMacfdqCeMnY1pS	11324	15942	15942	1618808760000	orphaned
22651	3NKDFZobnxDbatpVvDvjokvogF8crbEzTPiStZAU4kuxycW8NboV	22649	3NKyGhBnKSphzHWobf2ZPAshc6mMPTYi819ntybMkHUq3BQhsgdD	1474	1083	422	12463	14737	jxFrFXAKn26yUo9NjmNWwYuvYQ8jfdWu6gg2DgCESK4kCJqaCq6	11326	15944	15944	1618809120000	orphaned
22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	1445	1044	422	12463	14740	jx1fPENbZRfr3vmbq8SxySiLZVnADBAg6XVeqWf4KYm9FACwp7r	11327	15945	15945	1618809300000	canonical
22653	3NK6smG4gkDhrDRVyPSd5o1dCeceJsQXN8qXntme3xJMzfb7cM36	22650	3NKpc9oYQKR9k72jEj4eP5cwYQLgmksnJDseUWD22iPoVpHVHPbF	1471	1140	422	12463	14738	jxAnpZYqUZF48WmQuB4LLdpDaYw54Hz35HzyPEQaPGrYakikQJh	11327	15945	15945	1618809300000	orphaned
22658	3NK6jSAhWnbpYug8YkkjMG9ApBfhgQpo13PAyvFPqNxk8Mqw9ALv	22655	3NKaFRY7ZC9MRGoP1WPvb8qr2LKSYEwokztEuXVkfvTsQpmqmG7a	1637	815	422	12463	14743	jwPqstWdzPdWBTcRADJatKYm14YzLNiLM8A5852faSkQhUd4LzZ	11328	15946	15946	1618809480000	orphaned
22663	3NKFDiNLBnpHTtgtvavHkA7SFpJsGBzbzh8xSJuweQd2XNPLBbhd	22662	3NKPwU2Jh2KfWUUngmaBNas5HdiCCu7jZ2pP8vFoqjzPqG3HSCmJ	1422	1337	422	12463	14747	jwFRD1QgYrSNc38nFTaT893JCPDB5Po5n32Pvo6fRBbJDg5WN79	11331	15954	15954	1618810920000	canonical
22668	3NKLy6Hx7RP77JYwgZSxka6K9wup4MwMVSjJ9KEwBD1Jz7edLvB8	22663	3NKFDiNLBnpHTtgtvavHkA7SFpJsGBzbzh8xSJuweQd2XNPLBbhd	1403	823	422	12463	14752	jwgDaBf5qvR2d6eUfZ4F1uS6rcMvBZ6xdZfXaAm4zkv6qDUn3Gw	11332	15955	15955	1618811100000	canonical
22673	3NKcTNgxt5S5y9a1hj1mP57hS649GMFMGbivEriBEUsJvseaXTGL	22671	3NL84M5EMLoCGiEGyhpbomyM8qiHyKYzwDTjN8AWqMebUeCTZyzr	1601	1142	422	12463	14757	jwLPD1LZR9dKj6jRouH2JX78ZYafX7nQCPqCpsqwymcJGWPZW2Z	11335	15959	15959	1618811820000	orphaned
22675	3NKbhswqSETF5JxNxqZLBhP3GbJrifLjnsB7xAXgAjWczDoXLq8n	22674	3NKGZC7e5JC62m3Fk39vabnCS3Lw2YsfEk36CpEoKuJDpMTnz5AB	1458	957	422	12463	14759	jwe3zkhva24y2hzDSiwZ7sJ7XYkXvvNRq3vFHjcbPX6N7n24Jk5	11337	15961	15961	1618812180000	canonical
22685	3NKSYWtnreLRvh6ivoXyea3rLZAR3KREZRECBonvZRpim2xQpfQG	22681	3NLZ4kWK6oLxxHtVfTnpfoogsNVzsuSiiuKNmG8EUsMDoDCGXVZa	1580	423	423	12463	14767	jwmJwFmskFhDeH1F1oHVHbRLrnFkCH6wt7pBcjHGwHqDLbsEEe5	11342	15967	15967	1618813260000	orphaned
22689	3NL3vVYbs5Wdr2Wd1GKiUYQFDwAGocfgW8zLWHxiRqGUYBxtJieb	22687	3NL7x2RKMWDtZYKN8hrovUm88oGjMkK7keFjS6iDm7U9NCHMvqYC	1405	891	423	12463	14772	jwWRcdKBpYu6owkqbchyiZds76Ce7b6VVRw8gTTZZ49NcRGTqr8	11344	15969	15969	1618813620000	canonical
22694	3NKL3wdNmDhd2c4rCFHnodkx7PrPR7nMBriQhWJcgk3bFo71W5kM	22692	3NLAqjSq6kLrMx8eRKGGSJYyopkrE3CNEFWAVFVJVfHoZbgmKEJJ	1407	1395	423	12463	14777	jxCjHaayuf45rzLtA1TnqNUWiCdibRtDJ8Gv2aQtoKTaMni5b14	11347	15973	15973	1618814340000	canonical
22697	3NLZHVqRWARr7XXyN96fv2CzF3qHJuwUxp3vQssNt2ipbXo6Wvu3	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1602	1369	423	12463	14780	jxt4hAYDz6HMDyQpPxJdUFTDpNSPyBVaQ6GpzUjJvdSs41UiPh2	11349	15978	15978	1618815240000	canonical
22700	3NKhoasTzLLPtATzGnnhRmwDZK1Vs9rprBgfYG6DN6A3kTCBw6qC	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	405	405	423	12463	14783	jwRWdJk1Kvk5QgnjHqaNPdL1RXHg4JeJLbwDqGN7L5hyA9h81iJ	11349	15978	15978	1618815240000	orphaned
22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	22703	3NKF1uZsEv1ZHKanGeAiHvaj6mxNNrtrubBrjX2DW1BFHWd7jtCR	1521	305	423	12463	14787	jy1JhoKptLDHKWCZVq7o6R6aKxC2EK6fbzbQTywsX3hCwqkxmmQ	11351	15982	15982	1618815960000	canonical
22707	3NKbCjTs7brkXWiBkDQHTG4ozwAt4DMaGpqZK8otuF4HANnCmBPB	22704	3NKQVGW4KXeN8uymjCg6pDivn72c9kf6UwqoGxmtDCguNJWnwUsy	1407	1395	423	12463	14790	jxrKHUAUME2kuCuLv6LEUA8r7c3n8c5b5vKbBDf2Xg3pepYKMAM	11352	15983	15983	1618816140000	orphaned
22720	3NLtx1uUYs93RYiRjdBizzKdw8L3iCqwxB7egGxKy8hBKT97g1un	22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	1489	1014	423	12463	14802	jxDPF1mUpqydp58SVh2KJKD4rTz5imJYSRmaDxLGoTp4bQFHZxT	11358	15993	15993	1618817940000	orphaned
22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	22723	3NLg5kqLN9VBt2ueW2amvequCgasqaDyGuAW98cDywQhp8G4jJty	1650	1375	423	12463	14805	jwMXjDWPzgYsz3EFEfYr5RC576xEASYGpaTPMhfS8yuwvm2NM1J	11361	15996	15996	1618818480000	canonical
22727	3NKy47aSPwwVkET7WEJppViR2Kay3rdJWsSTQiRoAqKHhhocfP6Y	22724	3NLgvgWcBXvVd7EyAMsNNNaPMRGukVt62Lbd741p2U7Um4nzqepS	606	1295	423	12463	14806	jwf8KFHVKtomC3Si76JauXGeP2V6ThcXj3CwaYbX7ye3VCNySTQ	11362	15998	15998	1618818840000	orphaned
22730	3NKBtVuWpzNmksRnc6Fr4u4EAsjXFSXqFAxiVQcmRP9ABFUiuMs4	22729	3NKGxrmBMcRMTtbnUagSmXVU9Np8GmxGs8a3ptL1VhEwT3vdHAka	1623	839	424	12463	14809	jx5seqJw6Ho764SPziSYSkDV5X6cYGan3NMqKGdfGnm5cD63JpZ	11364	16001	16001	1618819380000	canonical
22738	3NL554jbofuda3a3hw8uJDtu5AR3niY25dRS37wgVwruKLdqExce	22736	3NK7WWftPPsYvPZRhuWZsu9dn593grwGGCr99X8wNDYE179JjUNg	1405	867	424	12463	14817	jwstqPZtFkCP7peMWST5AJrpebez8sodBCtMXp3NYMGo4sUx62a	11369	16010	16010	1618821000000	canonical
22744	3NLEycfRiLRZ49Yrsq7pEiQHsEiA7gbkMNFWh89DnkVuRE75cndk	22742	3NLvXvkkgz2Gma5BTfeE2Ux57UnKSCsrcRcFSVVtzk6kdDC8s2VV	1588	1266	424	12463	14823	jwdUeqovAUbYuuH31m9v2aEwkSiVfZwwcFfijXaCC1kXdof6HrD	11373	16016	16016	1618822080000	orphaned
22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	22745	3NLnqfmjNUsMoqM5yph7JJtCLUYEbfCYtq2zDoGeCLMuwvRwtYf8	1631	794	424	12463	14825	jxtLViWjcLrmWAoeZTjzEnKTDWp8hHXac9McErVcUTX2qsaDFFn	11375	16018	16018	1618822440000	canonical
22749	3NKSeieFEN6aeqbdUurEtAWA4uZ1MMvviMymXq8usvTVreo2XZkC	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1579	1143	424	12463	14828	jwGqmhTnKeaQXTYkb5ZqXgrPsouaGSxDtHR6ofd2ZLsoXB9B4pq	11376	16019	16019	1618822620000	orphaned
22755	3NLGfoFb35GAiBAGGkz7REYhtoBx43yV11PN8z5bb67W2WWtWoSb	22748	3NLD3WaHRzSPjjNr9rPMvVvaotbFoakYGaYAMJfU4dQdUUUqhkS7	1406	1393	424	12463	14832	jx8NF6sMbJdPEa6ekXssvs7Ldgj8SaZ1AtN97jXQviqyu91dzQn	11377	16022	16022	1618823160000	canonical
22765	3NKr2Pt3JSjXRjnfkXS9rYPmpqmUcKFdSmLURxcLmkKBQCewiK85	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	563	1233	425	12463	14841	jxPxziZyN4s7Hum1gTxj6UW5A1yj6qdtvskvrxUR1TQ3MZ1eCgx	11382	16028	16028	1618824240000	orphaned
22767	3NKzw7wrcHftWgCF6BavkGnbuZ94DBzUuKXdUHvrwNXPDjmGPLX1	22766	3NKZ3uLdG3dnPViJWLKVWdBAtPp7AkjnZcQxxaY6rayuscd8gFaj	1451	1292	425	12463	14843	jwmxwXoVUXtKCpL6yzyj88rBxNTtRBFvsqbsLJADafKww9q2Av9	11384	16030	16030	1618824600000	canonical
22776	3NL8Hvr21mPvFNSX5XCuVhQF1fk5PFbXE96bv26jFZSfoC2LxGrZ	22773	3NKM9ZcaMReiaya1gbkAP8aX5vzXpy4vggMAboipjLoZVGfA4hFz	1440	1251	425	12463	14851	jx2B67tJwU9NgzGZ5ifEdJP2Wq82uAxNiVccQcZVT1VyNZwkmWM	11389	16041	16041	1618826580000	orphaned
28250	3NLvynfpPEyKq6YePPZAka77REE4CDW3cKqwatT1pT9Py78DXkh2	27785	3NK5oA3fC9MHwNY1JZq1m7YJLGx3gPHaT1rKvqHDfmRCzvhJnjQk	1440	1131	542	12463	18974	jxiBNXz5n39Hfpdy5AkwkzyNg1LUn8PStBEeFrkrAoGydEprK3e	13730	19684	19684	1619482320000	orphaned
22709	3NKHjxUanjZF8k5sHfJi4odXooCWDzEYpCZNUrjDfSK1j3Jpkz2M	22708	3NLDz1HFPcYdZC9JTFRceUGW7JQNBSzqUU3FwHcGbUnV66FxhMkF	1406	1393	423	12463	14792	jwyH53ub4tnUoafHDMh7tukREWT2jPBBLh4KvnWDJHfQCCffhtM	11353	15985	15985	1618816500000	orphaned
22712	3NK7L3rRc1oVhEiVFHk1hkJAmqs4CTpkhChT4nhn6gMFCGSuLQxB	22710	3NLJVzePAaH5AgH5zJoMwgxrmQS5T1xKtyTegtnQDCAmpjP2ndbZ	1633	1024	423	12463	14795	jwkmYUekKdNqdKZzKbuP3Wzkv8zCLVg7uepQ8myn18peJLR96nt	11354	15988	15988	1618817040000	orphaned
22714	3NKfj2rvEy1uMxzVFFCFn9shXkmRdrY7XX6iTzES8rtCgsUGwQr8	22713	3NK6sdTtigVRdvqDwUtocwwW39pn9kehStbzFvRMM2PXStyhMSuE	1447	1345	423	12463	14796	jx1nLUU5UneY4xEFQVakg7WpMSu13nFtmqcVdJ9wyX7oSQq9nF9	11355	15990	15990	1618817400000	canonical
22717	3NLwRq2kcroLgcMC6Jns1cjxCDyqhFXwNgLezFMJfagJu89VQUAR	22715	3NLV5asTkSc91wT8mjU3sK4YfaXKPatVx29GV1x8ZjBkrjHJmV94	1627	1385	423	12463	14799	jxJB3xMWaJuNixEbvhjmZWXiJwY7REWM9cvHtkS3i7qQs4ZiYUh	11357	15992	15992	1618817760000	orphaned
22719	3NKHBTcwCmJv2x5FJBQ4EjdgT1YwYtXZrVCzkuz9PkHdKgvkbYhs	22716	3NKfWJH5f4EeLzhAQMu53bAVUXwUSFMaJ3e2modqkYK2WjFRZ4xW	1506	1247	423	12463	14801	jxLgEckZBjDyUzvdR3JL8x66Mc125K7DX8UMcYdcC9VqnmHWEoR	11358	15993	15993	1618817940000	canonical
22721	3NLa1nyBcWvEUfyd4AhW7RSVmG5d2tQKgGAiowjAxcuYzHXpfizH	22719	3NKHBTcwCmJv2x5FJBQ4EjdgT1YwYtXZrVCzkuz9PkHdKgvkbYhs	1651	1055	423	12463	14803	jxHfr3vB5Nv3py4G4czcKUV1UhYtCe5FTCAZgs38sjLVfWxndTm	11359	15994	15994	1618818120000	orphaned
22729	3NKGxrmBMcRMTtbnUagSmXVU9Np8GmxGs8a3ptL1VhEwT3vdHAka	22725	3NLHTYS6W2Qha7HAMDzt9QR1qjmhW5p9xUGZQEyRYedBg2cnjmfX	1406	1393	424	12463	14808	jwEgGtQrGEqnVfWhWaZyX6EziAVKevJ8YYjK4da8qTDvaSmMx78	11363	15999	15999	1618819020000	canonical
22732	3NLRyX7ymBmpWjCVfuqrdz73tH7puxNH5GtuXMLY52CKQLTn4ESi	22731	3NLJKbK9nrrDPhfuvWjhsL4kRKMmqWWZfZwwRgAgvrQpuxnGauSG	1461	1271	424	12463	14811	jy2MBty4PEcV25vdaf2f8SthjnUeDLzYGbxvqnx725NTbyQzkLo	11366	16003	16003	1618819740000	canonical
22748	3NLD3WaHRzSPjjNr9rPMvVvaotbFoakYGaYAMJfU4dQdUUUqhkS7	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1617	1288	424	12463	14827	jwwSp44Lep5a4fkdJjtGQdnibc8TjsT6ruFjbcE6Qj9gCfdxzJA	11376	16019	16019	1618822620000	canonical
22752	3NLt8E2HRh2edkcvTYjAAdwVgfspQvb7nftSLY5eMXRQjMixDgMV	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1500	1171	424	12463	14830	jwPsybDaMXNN6DD6nkR9j114o38Xeo4MeemBX3YWjqZ5tqbNijh	11376	16019	16019	1618822620000	orphaned
22757	3NLib4kFNpi2nY6gHyedc9ALX53sQS8BWexBS6zQ1cvC6kjrN3QQ	22755	3NLGfoFb35GAiBAGGkz7REYhtoBx43yV11PN8z5bb67W2WWtWoSb	1407	1395	424	12463	14834	jx81KbTHcDEwfuv4GZnHd26nFipaQzybRksCie5uQDD2QEZMCxS	11378	16023	16023	1618823340000	canonical
22760	3NKFj53MUToe1V7kQSTWcoDK7mzT3HArDWuHvi1uD5C1zBvkXjUG	22759	3NL1XPk835EMx3d5roTFoXyPX5HwmJM4BYFKP1ufhkqDK1yseZhs	1637	815	424	12463	14837	jwk9MdVuSEy143BkKHKsu5tZWxeaZ8TbFemuAqFRBrZKEqk567E	11381	16027	16027	1618824060000	orphaned
22762	3NLRAG1d4Xg7prxUwkdcoH9M3wCB3BsEahPT8VXQWcWjkqrBVovd	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	1549	996	424	12463	14839	jwgADjyGGDVSUa9ysZipxqsGx6jmiaPcfAsJycp1mGR2QUDXuBe	11382	16028	16028	1618824240000	orphaned
22841	3NKRgMNZMTRsZDf53Z76EeiNCygbziFD3KmCsKgcKLx12t76b1W4	22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	1509	1320	425	12463	14908	jwMqzNVBJiZmNEanhxRmbvtd8jwhZK9QsS1YrZfEnGruHKWLqXq	11393	16084	16084	1618834363395	orphaned
22786	3NKjUkA88cZkXAiPsTYthyezde4UWAEQ2keKxgLWRMowaZxUERre	22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	80	1027	425	12463	14860	jwn7vXLtHpAzi8hQDr1DPYPjs91FQLRsZ81z7hXNNZfGSfAvwjw	11396	16049	16049	1618828020000	canonical
22797	3NL4RmzUVp1NwAvz91fvGTTC768qGamdJN6bfn8LHJSfm2ntW8mu	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	700	840	426	12463	14869	jxgW6bmBYueHfC3KsDhMkrBs1SpAT2WCDaddZCQrwHtnUbuXfmb	11401	16058	16058	1618829640000	orphaned
22824	3NLxZwPh5PN4vhH8vzxMA779ccUiyfbeeK4vw1EBy9s4UvUQauPn	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1507	1280	426	12463	14894	jxgXpvhuSicSxCdCfuYumqzgZhurrbKPVqRv1L6N3xFQhfAYkXk	11402	16073	16073	1618832410041	orphaned
22803	3NKnH5yAXkoByQZ7hT1bJcTrBuVvcysQ8Bff89o2oyY9kEw7n5NF	22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	1501	1360	426	12463	14875	jwv3yNnNqy9k5BmZ21q5WoU2qNg7JsD3LkVkd61fxucunLZwNtE	11403	16060	16060	1618830000000	orphaned
22805	3NLLvjfxQoopGqBxzyTF7Qw7AKy9NcNW8o4vz15hyQLcwPgNnTnR	22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	1609	1333	426	12463	14877	jwyCRVjw68oTMPiJDjX17J7dYem6n9EfjQGuuamwiMYFFFrJWxV	11404	16061	16061	1618830180000	orphaned
22807	3NLN8QMQHrK9ERkezzBvmQYEgitHgNkR5fCYqarKLFnhqgTdSsBq	22806	3NLDBVS4MfRHVpd1mRWHuod1FEBNjrUxX1p751HnzLUgFDV8qaFT	1447	979	426	12463	14878	jx23RW8iuvtYvTHdNyeMViisgrPG4iFCQZmu7N8cQMoc8kJAqAr	11405	16062	16062	1618830360000	canonical
22810	3NKruJdkY7jgW272fxr9Lsc8bjYbdKrWxbVubExfFGCyWGhMhUNE	22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	1671	1365	426	12463	14881	jw9NKcRUXqKsi9HsqzqgHbhabgeXQiQ7oEtVysk1QrkhcGUwAEE	11408	16065	16065	1618830900000	orphaned
22815	3NKTWnXJuJu2kqiZEyRJ7iTS6EQrfUVG2vFjCKHXZnUWKTNfcm5w	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1541	1172	426	12463	14886	jxVbcPKYqzzxNtSAZmo6bxf1V5kXigwGwc5U9UNqqnpGSM4XSjy	11409	16066	16066	1618831080000	orphaned
22819	3NKYTJegQrHb5MDEVo4KPDVT4ruQSpLTmEAyKjhHa9ix4iisFcYB	22818	3NLGb91UfgoPUeojV8xCugcgQsEjHFWLzSEo9ydzNnW3p6N7zz5o	1407	1395	426	12463	14889	jxAon9nUe3841GJw9zFTrynXEPhdX67h7Fa118fCrV391Bs6Z6D	11411	16070	16070	1618831800000	canonical
22822	3NKfyo5dRe7ws4iKxC9EBxAD6dCyyMsWK2TUqmbFhMSktvJ9zope	22821	3NKA6dyh8rUKjUNrYz1iTRxisXssm6wGp1fLTB9o2U6TZ9wQXQhF	1642	1121	426	12463	14892	jx95DCpVdrugtj79pwfJLMT1PksAjsP8L1hiZrNyWaGqPFzCSHr	11414	16073	16073	1618832340000	canonical
22827	3NKU9xa57St5eBjYCxbXmBUKcufTUZATmrssAtAiiSp5Js9mkVbw	22825	3NKyxELqnKDYm7cirHrnBAVhyodepbrjS2xHbxQHy8TNF69wBxf8	1637	816	426	12463	14896	jwYejEyhPtS7nB8XotwHvPsi68eQouY5225yrhrHQuaRRhB1oEo	11416	16077	16077	1618833060000	orphaned
22829	3NLPx8ED3JwekBkWnoRzGru44K9ajkR9G9dswHo8hvbHFpvWmnew	22828	3NKgPhXLqbLVm9zn9MVhqmDAWHHZNby3AUdEDZv9Nc7CLpo2WLTC	684	1226	426	12463	14898	jw928HyEpZy7F5wakAdhYP2FGRsgkkzf22aAw5vEBtn9xaVhT2x	11417	16078	16078	1618833240000	orphaned
22832	3NKLWuMquXKGAGGJPaB4gkb1iHt55QDREqKS8Uo3pmyMPSTKjahv	22830	3NKhvLKc1dibFnMX5QYnwWdVfaNBgsgPG4hGhhj9cg57sithSBzf	1624	1088	426	12463	14901	jwp7Wxrrp6m8AiLuX5upyK2eo95ENFk7GZG2eLwWVzsoT4MuAAv	11418	16079	16079	1618833420000	orphaned
22834	3NLKzf4yUf76Qwy9S3jrms14mmAKWDCVqkzxDzHCiPh9x8DzP5fp	22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	1546	1213	427	12463	14902	jxQuV3pVCcB3VJsfcZvMSDaQmtWF1pQuqPAtKmJZKZ87t8uzvK8	11419	16080	16080	1618833600000	orphaned
22836	3NLycYwGCuvoLuhz2s6dymRHkEWLPezwkQN8rNhtuGH5JV3Vb7Y6	22833	3NKLMd72HY1dgJ7uWjwuobULAeeKG7UA2q9DZKqJeQXhjMsFpfzG	1403	824	427	12463	14903	jxP3UxqtuUr5R9rA1dgtg3F2m4fExJ2RG7yPVKsjG6AzwdKuH73	11420	16081	16081	1618833780000	orphaned
27788	3NKaKU5V241GuGyEFaxofqGvFjbBLKpUC67ANurqJWQZXFo1vfXr	27786	3NLSVtHDn4hewct7z5yg1ooEXPdHkZAoxZgNm8appkzRWqUiRD6w	1407	1395	542	12463	18974	jwAEiRGiSSWXN3kJCMQYVwtojn9hRSnywewdmGGPvj9Ns8se5iJ	13731	19350	19350	1619422200000	canonical
29291	3NKJaGDoXTKV6URtLxSxGy8vpeztp7ycUUnbKBEDiRkog2HC8eXa	29289	3NKXiuDxYCnx89ds77oFQc6uHXLoxxpuoC3mggMXnFVcWfyr2ssL	1407	1395	574	12463	18974	jxH3mgjPf2zNGF4vvyhHLZjsTKf3N5pW2FeFPDqhiSHS3fnEyJM	14434	20327	20327	1619598060000	orphaned
22769	3NLr5j8TMLfnR9dcqd63x7XoyA7Sctkw7yM2Gu39f8LuuH9U8M81	22767	3NKzw7wrcHftWgCF6BavkGnbuZ94DBzUuKXdUHvrwNXPDjmGPLX1	1651	1175	425	12463	14844	jx7KA7ZfYNpYdR4RTSz2mVh8vgm5DjfDqXNDGSVvGPrmLC3ERBA	11385	16031	16031	1618824780000	canonical
22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	22770	3NL3fsmbaEMH2GAPyNbUmM85ndZLBzuq5nKKVYBLHWBA6Qxat4ZJ	1405	849	425	12463	14846	jxJZZQ5uwiyimUsPYtZsqYVQGGmK8wEu8c3S6pJ1xy6u1DfDinN	11387	16034	16034	1618825320000	canonical
22773	3NKM9ZcaMReiaya1gbkAP8aX5vzXpy4vggMAboipjLoZVGfA4hFz	22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	1406	1393	425	12463	14848	jxizWxk4rvjHuN7woU5dyzuMcKetj2FvRAah1iF4dABm15SQVXT	11388	16040	16040	1618826400000	orphaned
22775	3NL4GbcDg1TMiv1wjfg93EsEytghjj334ochcS2uWzLneAJ8C4qJ	22774	3NKyJC2qnSHY8RQJevSX7Pf1cY3P6o59bHAGyTL7JtwczbFKotCe	1440	1251	425	12463	14850	jww3sP6WfeJmNFpBizNN5Q1sDZZZ6ZEsyiUeVnNzG5yNcNiMr21	11389	16041	16041	1618826580000	canonical
22778	3NLN7PotE9yVdmb5TeVJVKUPLn5uPjVgBMbySDqPmJAqs23SbZSr	22777	3NLik5voCQzVY2y6L7i6Nov3RywAznMLM5FZBQpzuVjwKYbo38TU	1406	1393	425	12463	14853	jwD17Cy7eCo3RrcbtuPQVnwyqohqc3NdyFAQT6wKhoFz2ExJNac	11391	16043	16043	1618826940000	canonical
22781	3NKiTptBxJu24W9uCG4oCEBhfK5cP3P3tfGoxHZ5w7s3upNJkoj2	22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	1406	1393	425	12463	14856	jwtGBgtLt6MU4M16hehSiELtFmFfponLpJUDpWMigrLyCfKwA7v	11393	16045	16045	1618827300000	orphaned
22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	22784	3NLnWNuhvGTmFL3FGQRTzmMpBRHPGCoREymNMqz7VLxBW2n2Bhbs	1461	1271	425	12463	14859	jw8gQC5fgZPjw99JRnzA4bpQdXBLDU1GV7yiUDM2s8xtbnW11AA	11395	16048	16048	1618827840000	canonical
22788	3NLTGx1Ld8hagpYEZxeRQCJuEtMByrAMJW5v4PpUZtdt6Z6QCXVA	22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	1675	1216	425	12463	14861	jxGRx7M2XrJcS5kHJrCEjms3SJ31AQ6o7kMmSkVfEMruP1eWBcK	11396	16049	16049	1618828020000	orphaned
22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1422	1337	426	12463	14867	jwGyfYhVGbWi5rmFNMWLMVBoYq4E2VBfMqtBwaJYEzFUGLvQQGq	11401	16058	16058	1618829640000	canonical
22796	3NLvkEcCEQHFj4hrdF5k3vH9BSUdLQbSeidqupdLHL32zwfsaeAo	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1422	1337	426	12463	14867	jwygpsCED6KJyfvyj2HL6rBbocNXSzwkZ1Pygq6Rjvwh7VRwM5w	11401	16058	16058	1618829640000	orphaned
22801	3NL1ZxmSARu2DjqddoPrQJqtfF4aHo3CSGa2P73DC4L3dEs2pX3h	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1560	1291	426	12463	14873	jww2TX3U9iXWUinky8FL9XpvuawACWuRYs2vjEPMdL8f5dwwvYd	11402	16059	16059	1618829820000	orphaned
22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	1407	1395	426	12463	14874	jx14f2gbCK6LpafMeWmjUyzkkyAqK5ULSMCZL4teXShRQrnYUSu	11403	16060	16060	1618830000000	canonical
22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	22808	3NKjejCv4MZVWJL8cVaX6UxQmdBx8pGvy8ETurh7qEgVbq6UrHgP	416	416	426	12463	14880	jwEmeUPHhLdgKZBMVyakVQNbu1yzBRfN71Qq6MWa1D7WhBo9PV1	11407	16064	16064	1618830720000	canonical
22812	3NLG6tkcp8kNTod1y1i8nrAkwZsvsN7Hi3nJ6ZV4eaKrmyRC3pyb	22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	1631	794	426	12463	14883	jxaopB4NWsFQxqhRLuhgkUCafYMBmeLMEk1nVhfrj6VZjD9umpR	11408	16065	16065	1618830900000	orphaned
22814	3NKBpWx15YTnCXZiCsDuA3K49knwXax23Nd2XFDEJBGn9jbJfVJf	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1637	816	426	12463	14885	jwT4KVk4om6jQxPKGkRhpmHyUMg3BpMnUC9kwDKoftSLvV8fiSa	11409	16066	16066	1618831080000	orphaned
22821	3NKA6dyh8rUKjUNrYz1iTRxisXssm6wGp1fLTB9o2U6TZ9wQXQhF	22820	3NK478rt7ioWi9Q5wYYVFfMUz3VQXvyQhdfL9ev2hCvaao5fSKy6	1647	846	426	12463	14891	jw7nLdET6bMsQmJS3cLNxBcBzifu5xrvvbEmoB9QVRwmfH3atrU	11413	16072	16072	1618832160000	canonical
22852	3NLxrAyxwZvmpmMvGJ2WCjCuxk56fzxaxwF9Lgw11543fcFesSSD	22836	3NLycYwGCuvoLuhz2s6dymRHkEWLPezwkQN8rNhtuGH5JV3Vb7Y6	1509	1320	427	12463	14919	jwPvzvuSL5N27sgci59JnsxRnQPH38AKYjv6eoQRYKrjsSyU2WC	11421	16084	16084	1618834492799	orphaned
22849	3NLbbriAxpwJK3m6UgXr4urZMjpPLcMvyHTjnUJsq9kM6WYY1mGs	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1406	1393	427	12463	14916	jwdouxb4mQkTzTV5yzo7TC5rCbGopskQYNpBtgYuaKgJPgRVW3H	11426	16088	16088	1618835040000	orphaned
22858	3NLPJ77UMVrrVuwgHhTDYuo2zeH47VxpBpXi1bdtqzxTTYYE8MAa	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1529	1190	427	12463	14923	jwtfrdNxsx3WF5t1WNwC7gLMvajLF8z9jLxmq6cimZ43BHGwGP7	11428	16090	16090	1618835400000	orphaned
22863	3NKiP9itavKnums9QjEeD3v1TgNdddCQ2fBP6DBGs5XShXCVf23h	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1623	830	427	12463	14926	jxhBpNu9C2GCUn2tRqsHkZme398YmA9nxWs6VpKUrhZCJQ97Yvb	11429	16091	16091	1618835580000	orphaned
22864	3NKAspjBHBtrYf8howKcs2ib3mdV2TmgpU6ocDHUHpToE3smYKhF	22861	3NLrjx7g2U48vyiSsJuXVYs9D9vCW8dWtpTzCeUFXPX259U6T5uX	1506	1007	427	12463	14927	jwKtR1W6ppxU5uUWi2uGpNXyAdZ3qcyCwjjEAUoAXVc3KVPn2sF	11430	16092	16092	1618835760000	orphaned
22869	3NKvFpULEQ7HnvGX5YyzAje9eTCofcSbBXErM16QAf46Xx5s16uy	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	470	1309	427	12463	14932	jwAUt4PhrtbmGvBrUX6WYQ9DyMUwM3ZfEJwXzdGoP86EybHpGB8	11431	16093	16093	1618835940000	orphaned
22873	3NL1DcR2pGeFYn9Apj8QbDjmWs9j4ef5PFCrkK4fTkJ9oNuuGRQu	22872	3NKDiiV4jRj5MMcMsfpSqx6uCCGXg9KWBdHewaD2DPe6yh2GezVu	484	1319	427	12463	14935	jwkrZ4vKuoGpmFQWNC4V73HQs3sPUaedqzy914oWskgpSJHBWkm	11434	16096	16096	1618836480000	canonical
22876	3NLQPwbkivCfwci2gqcAXNeaLUt8Af6aFAaohiYVYhSvYorx4AZ1	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1405	867	427	12463	14938	jxJ42qUKqadbubYVnzRmDf3YKMSPHjmopx6F2VvkPzf1brvLbFp	11436	16099	16099	1618837020000	orphaned
22878	3NLmpmqRmiuWQeG1o6b7F3mA7CoBkv7giK2CUGrdbBA4MTiG5Ts7	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1596	1363	427	12463	14940	jwbhVVBmMGrxp7FHuUS1biJYHADoWfAVooDjZUAQ9uXwDfCuCv2	11436	16099	16099	1618837020000	orphaned
22883	3NLpwfDUP5yPwbRCz7jDAx2m3ajaKQdFzqCoTksAjk5H8S6jGGeh	22882	3NKtJQMQj9WSu2pb46cPy5jXycXDMoxmznAcLcgz9HBbpdDYAFWQ	1492	346	427	12463	14945	jx2YWEXm8LqTRRp6RGWuqiq5nMU3MPBa5VWDp1F5cmPy3AMKHaP	11439	16102	16102	1618837560000	canonical
22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	22884	3NKCBSoDtuDwDALPecA4HTtLZ7wrwK1eDcaCDdkMtQf9BFNtQ3Jf	1637	816	428	12463	14948	jwnJJWRbJ9SeZZaNbUiX3GKzrq6AsybQLb4aPzDrrtEo8ACQWKN	11441	16105	16105	1618838100000	canonical
22895	3NK7GH95xeE58KwBUgwH9Ek5mn5t3LVr1B4ijwhTvdyPoE9AhpDR	22892	3NKaxd7WWZSCHLZyMCyuceUfVWgrEfTZha8oUj4vc41F2q5sBQo3	1474	963	428	12463	14956	jwweQWw5AS2XfWLAXr7moyUoTJZQHtmRFmMtwWR6SxtJA89k3DJ	11444	16108	16108	1618838640000	canonical
27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	27788	3NKaKU5V241GuGyEFaxofqGvFjbBLKpUC67ANurqJWQZXFo1vfXr	1406	1393	542	12463	18974	jxdbpiwdkmaaiaaRANQDtUSKfuxiT1pKTDTpBkmtdrcpnpAeZLU	13732	19351	19351	1619422380000	canonical
22770	3NL3fsmbaEMH2GAPyNbUmM85ndZLBzuq5nKKVYBLHWBA6Qxat4ZJ	22769	3NLr5j8TMLfnR9dcqd63x7XoyA7Sctkw7yM2Gu39f8LuuH9U8M81	1406	1393	425	12463	14845	jy286es85fF4Mo5Jvdf9mG3wuazr4f2rDRbXQ1fKVSgEi9oM5Gq	11386	16032	16032	1618824960000	canonical
22774	3NKyJC2qnSHY8RQJevSX7Pf1cY3P6o59bHAGyTL7JtwczbFKotCe	22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	1581	778	425	12463	14849	jwsYNm2ACwcwiYidvCSmSdnjj4LpmD8UDFubY5JbzQGSWAPPDGg	11388	16040	16040	1618826400000	canonical
22772	3NK5StqYGqbzbsQ3PLe8T1TZFmJUxZzmqdT48SHyPZqVL1N5ZP8s	22771	3NKkMh7s8ajpzJEeaqgBmoNZ8qp7YHoD9WPvfwp2PZh97dg5JNfo	1403	824	425	12463	14847	jwK2FMXGVyxqq5CT3hKXMoZGWpm7ybgLX5XbyatYocZLDapBoF4	11388	16040	16040	1618826400000	orphaned
22777	3NLik5voCQzVY2y6L7i6Nov3RywAznMLM5FZBQpzuVjwKYbo38TU	22775	3NL4GbcDg1TMiv1wjfg93EsEytghjj334ochcS2uWzLneAJ8C4qJ	1589	1286	425	12463	14852	jwJXTphknapXY6oNskMRe7hzeJMWK4DJoAT6YnR4mQ9A4C2pjkt	11390	16042	16042	1618826760000	canonical
22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	606	929	425	12463	14855	jxpMi15t2c5DJ1Bhm52BTqZ3VzUXz78LZBdM15dj3q7p2ZYjRtK	11393	16045	16045	1618827300000	canonical
22783	3NKKZa7Ma2vGaEp5fxghTdfFMoMy6M8CKVxiun2GfZ7gDNNPQqRJ	22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	1529	1316	425	12463	14857	jwvqEdhjroKS1eRsp79QGUGwnReEc2W8CAUPfw2vf3pchkJJfJc	11394	16047	16047	1618827660000	orphaned
22790	3NKfkrYjmrrNH7ouBxnQSS5q5p8sVse364NyiJcxSxBVoLnhC7rm	22789	3NLgM7Khzi7BvN3HRsAb37EnMfeFbYYr4xM9NAmTy9BURbpErEzL	1631	794	425	12463	14863	jwhxjQaKQaFXrVNqC1yM33y3JEwA1HUCyafviPLndXWRyY2gTUf	11398	16053	16053	1618828740000	canonical
22823	3NLU4ZLFpTXekL6KRQG6Au9fH9qUFjR8vphdxktWnuMAJxosbsqb	22791	3NKHegWnLYijTJNHd7oYXnfQ8oDK21FJ881e3xatoUHmKaG59dwp	1507	1280	426	12463	14893	jxSRB9PXMc7Fru5CSDSxK4ifZAveDv3bq7iUrguwAsS7995CoVw	11400	16073	16073	1618832340000	orphaned
22800	3NK6Nocu46bK1fFkyK2CMaBJFd5o68AADeB9fqS2twbJ6uW5dfcd	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	413	413	426	12463	14872	jwSXs9XZ1ou7Cy9obe6TcXQLmDdaoQbepNAtaEytwH7SH3n7khU	11402	16059	16059	1618829820000	orphaned
22806	3NLDBVS4MfRHVpd1mRWHuod1FEBNjrUxX1p751HnzLUgFDV8qaFT	22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	1609	1333	426	12463	14877	jwhnDVsF5rXuvNq3T1isxDCjZ4EBhUQ7RsFUUaGdKGb12qNHtqK	11404	16061	16061	1618830180000	canonical
22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	22809	3NKjBJNqvUQiof2cUnQdugTogR21HDattMXxx7diBkwv3aRYZnvu	576	1355	426	12463	14882	jx9hx89X6TUtMpEwHSptKRMKavFKwTzSvXBkodz8ZLKQTaxgmo4	11408	16065	16065	1618830900000	canonical
22813	3NLFtG71pXGgrW9kvX4fPup5WdYk9srJES59TVDQFCGCXkN5vQgG	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1648	1038	426	12463	14884	jx27UfgVe8oscw4ZZEqBuWrtT7WrsJr6DceYxE35NchzcRSw4Eg	11409	16066	16066	1618831080000	canonical
22816	3NKbwncHHbz6fSBrJJnKnzkPaQUvmUqa5JTxn3JFSSumXfD4BD1T	22811	3NLaqfStC1EXBN1Te4XjRJLK8Lo9vmmyGJmVveQXA6CugdrEAh7A	1541	1172	426	12463	14886	jxgJ47WLBxE8hAMQaF71ZttjEHbe9KTgJwMaeH5R85BNXxfr46g	11409	16066	16066	1618831080000	orphaned
22818	3NLGb91UfgoPUeojV8xCugcgQsEjHFWLzSEo9ydzNnW3p6N7zz5o	22813	3NLFtG71pXGgrW9kvX4fPup5WdYk9srJES59TVDQFCGCXkN5vQgG	1406	1393	426	12463	14888	jw9A5mxunuNx74gSqybFySL8Ak4dNr2VDRcJATGwjBFbyz6hDAM	11410	16068	16068	1618831440000	canonical
22826	3NKtv21TbNTg99sa3s4zGxiZZRLgp94HVf2LeYnu1P7G6L3LADqJ	22822	3NKfyo5dRe7ws4iKxC9EBxAD6dCyyMsWK2TUqmbFhMSktvJ9zope	1474	1329	426	12463	14895	jxgSExgwrCb5t27mCMWtpmqQSpxnzYJ6en6UCCb1izxhHDmkGRy	11415	16076	16076	1618832880000	orphaned
22828	3NKgPhXLqbLVm9zn9MVhqmDAWHHZNby3AUdEDZv9Nc7CLpo2WLTC	22825	3NKyxELqnKDYm7cirHrnBAVhyodepbrjS2xHbxQHy8TNF69wBxf8	1657	1218	426	12463	14897	jxoPEqYpFGKfs384ufTWz2CHcZ9XdKEoj7W1FaUMqX3zaLgfaYv	11416	16077	16077	1618833060000	canonical
22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	22830	3NKhvLKc1dibFnMX5QYnwWdVfaNBgsgPG4hGhhj9cg57sithSBzf	1637	816	426	12463	14900	jwZB5zfnXjV71L6PesjEBQhqcawU1FdMej6zjWP7aGnyBxvNWSB	11418	16079	16079	1618833420000	canonical
22833	3NKLMd72HY1dgJ7uWjwuobULAeeKG7UA2q9DZKqJeQXhjMsFpfzG	22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	1546	1213	426	12463	14902	jwqykwaB3YvDropASTVuis8HYbUgxFa5LBrL5kUPs6VCY3czCje	11419	16080	16080	1618833600000	canonical
22837	3NLbFbXnmFQiERkcQ3uuWVHRzJrJb44JEgrQHwpbmJshMtGJyQUv	22833	3NKLMd72HY1dgJ7uWjwuobULAeeKG7UA2q9DZKqJeQXhjMsFpfzG	171	1008	427	12463	14904	jwEhCmKhisyDzpbbPiu4eRAFAYBM9vBjMVm7epMcXbp3u8haA89	11420	16081	16081	1618833780000	canonical
22838	3NLs8FArCcR46ktb6DcEkqoDY1WDkPSnGUqCGCSrxqHMho2Z6eGN	22837	3NLbFbXnmFQiERkcQ3uuWVHRzJrJb44JEgrQHwpbmJshMtGJyQUv	1637	816	427	12463	14905	jwcZf4qEx28pPV4zEsna9WshaMGgMvgKs9EQSfWdypugrFMfu3A	11421	16083	16083	1618834140000	canonical
22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	22839	3NLJG4U2Phzw7AHzxwSJAEPafrWcqtiU9baHu38gTsETZFcXHaiD	1637	816	427	12463	14911	jwBL8i2YTwsbCUzrfnWjcCwmN84RMxEf7ggjpdenJCcf3zhKzSk	11423	16085	16085	1618834500000	canonical
22846	3NL5ywLUH3ehTpaHnpWNjBcXpP2ozs7iAx77deMS6Q1DC9JQ7SE6	22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	1406	1393	427	12463	14913	jxnpT7dtcohtqRLFbCokAZkJoqWSNB8gAnHaJQnvcHBHJj7mmBx	11424	16086	16086	1618834680000	canonical
22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1529	1190	427	12463	14923	jwjuu21uBm44qqjieWMUFyUHHyiWJZvsJXzGVyaBN7tVfY9KiSZ	11428	16090	16090	1618835400000	canonical
22862	3NLrgqwGFrpUDoAWv55Vmju1Pc8g8es8Dg6dVJsGg8CKxn53AFY2	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1448	1311	427	12463	14925	jwErmJWCUJNLY8Emy9RCez9V1Gngjt2ycCgaahhhrJDbwt4M84u	11429	16091	16091	1618835580000	orphaned
22868	3NKRmRnWkM2xnjR4QvGejxUvpejfG7yvM1L5ffpbHv333P5sQy21	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	700	840	427	12463	14931	jxXWn9xXaX8Wmnn3GtXehKp9GmgyJPnLsjrQ1X9YRYsmhQT33hr	11431	16093	16093	1618835940000	canonical
22866	3NKu3RzQFk1y5cKdUKdvc556oUErNW44wuNMYFKbnWPZL5qjhZkh	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	1542	1304	427	12463	14929	jxfGNoRZ5NdBPskvSMfqgoghhP4V2HorxyZmtrWmAstcUxgtMVE	11431	16093	16093	1618835940000	orphaned
22890	3NKRVrJ2EFWL48rZfhF5B2SR8k4cE3oStohbyhSZotc2usNVF7DP	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	298	1308	427	12463	14952	jxVwJxSpu8Frq9CLePzNuZqwSNFzHSYkrW7Zvh8pvkZ69ao7nUu	11431	16106	16106	1618838280000	orphaned
22888	3NK7SSvvovCgmb8hCwAf7K1Av7H4CSfAuu1Gt6yokcFvEyLcfceb	22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	1534	1071	428	12463	14950	jwrBXaHtkpSsHSaA1Uy2GLtAJmvdouyQY22NgdKwApBcyvUYfLg	11442	16106	16106	1618838280000	orphaned
22892	3NKaxd7WWZSCHLZyMCyuceUfVWgrEfTZha8oUj4vc41F2q5sBQo3	22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	1541	1298	428	12463	14954	jwEL78Lo6zygRf4uKdDqz4aDQHRBGCsbBDxRoRg1pynbyRu9BUv	11443	16107	16107	1618838460000	canonical
27792	3NLgKroAk2i951aXtGxT287o7HVKrZdkoVrE4Ttoc9wx4V1EJZeY	27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	1581	778	542	12463	18974	jwJgj94Ac3cwAKxNxiovRBUUurpq7WT8BvN7F57n2o8WJc8GNF2	13733	19352	19352	1619422560000	orphaned
22779	3NLvnSgQfWpfcYmQJCJkdnD9WMTpyn8oDnx7fH8gBxUm2guBmB3d	22778	3NLN7PotE9yVdmb5TeVJVKUPLn5uPjVgBMbySDqPmJAqs23SbZSr	1581	777	425	12463	14854	jw9P5cnBRgsL94TUox2dV5rxf19ML4qDzExSWfDrHkzSSSHPzPL	11392	16044	16044	1618827120000	canonical
22784	3NLnWNuhvGTmFL3FGQRTzmMpBRHPGCoREymNMqz7VLxBW2n2Bhbs	22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	1672	919	425	12463	14858	jwSLXuSn1HhCS8ngjN7BCVRqpobhxNJ9WZgBjXiJNrQ3ec5PVWV	11394	16047	16047	1618827660000	canonical
22782	3NLEz6VEqzjQEvU1yAkMoWmCo3Mqoa3N6ERTU8DAtjAA69BU52i8	22780	3NKTkZNfNopvT2bAVLBMtp6bGwaPd1swh2PhHvntgRkZt1e8Mrn4	1529	1316	425	12463	14857	jwoek8oWjuaRnqfS9TawfrAKVSaXUB46ibQ5k6RePkpeKKXxgqz	11394	16047	16047	1618827660000	orphaned
22787	3NLenMu6FJFWkLbn6RfZ2skzxNe2thiffLERJ33Zam4vMozNzZNc	22785	3NKg9TikE15wU5bd2L9SHewMuncWiMoM8DyfXbpzKE7CcpdhL168	1675	1216	425	12463	14861	jxe3nLCDMXxwhqjifxhD4facgzbdBsZ19ZCEZS9Y6txSegocpV9	11396	16049	16049	1618828020000	orphaned
22789	3NLgM7Khzi7BvN3HRsAb37EnMfeFbYYr4xM9NAmTy9BURbpErEzL	22786	3NKjUkA88cZkXAiPsTYthyezde4UWAEQ2keKxgLWRMowaZxUERre	1407	1395	425	12463	14862	jxnPt5imb1s5CVby2SwjTxaDnXMK2CHEg93Re5M1GDv2yxQtkGM	11397	16051	16051	1618828380000	canonical
22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	22791	3NKHegWnLYijTJNHd7oYXnfQ8oDK21FJ881e3xatoUHmKaG59dwp	1403	31	426	12463	14865	jxCS4X7rF6aW6s8FRN2FGNjcp1tXCU2sisFgVhpAuDMVgH9aTmz	11400	16056	16056	1618829280000	canonical
22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1407	1395	426	12463	14871	jwZmzwHuQdP2JpVy7huyZrbQbm8Xp1EnXaEJCncz93rdo3aBKuu	11402	16059	16059	1618829820000	canonical
22804	3NKXkUddXTLvd3uFcTm7mUa9sZziZX2YxE3fmMtfPMR1N96JxMRc	22799	3NLM359hzxpJLz4pj67KzJKh6KtanWHQ2RuDPrkeCphfgnZZAe8i	58	1035	426	12463	14876	jwd47DEsfhUk8h1Pz6UDAKAn3paAVVZvNi6QScPSymdBXjttVsR	11403	16060	16060	1618830000000	orphaned
22808	3NKjejCv4MZVWJL8cVaX6UxQmdBx8pGvy8ETurh7qEgVbq6UrHgP	22807	3NLN8QMQHrK9ERkezzBvmQYEgitHgNkR5fCYqarKLFnhqgTdSsBq	1406	1393	426	12463	14879	jwT5Q5KBYgTRDdmieFepQqJWH6d5sTkWyDFBZZq2aWozWtMoij9	11406	16063	16063	1618830540000	canonical
22817	3NKV4zCG9m2L8ucZb4dtBGVYdqKQr4aseG3vU8i3P2zAAVYagt9W	22813	3NLFtG71pXGgrW9kvX4fPup5WdYk9srJES59TVDQFCGCXkN5vQgG	1407	1395	426	12463	14887	jwNPuTFEGuGYugGBsn1XiRvnXX32Qr5WR7SoScMcHZdFWYSZP45	11410	16068	16068	1618831440000	orphaned
22820	3NK478rt7ioWi9Q5wYYVFfMUz3VQXvyQhdfL9ev2hCvaao5fSKy6	22819	3NKYTJegQrHb5MDEVo4KPDVT4ruQSpLTmEAyKjhHa9ix4iisFcYB	1588	1146	426	12463	14890	jwPUe5RpEp7zneLhhSAiSxrw7VYvM5BGbdBDpuQxgw9ZzPN1fMy	11412	16071	16071	1618831980000	canonical
22825	3NKyxELqnKDYm7cirHrnBAVhyodepbrjS2xHbxQHy8TNF69wBxf8	22822	3NKfyo5dRe7ws4iKxC9EBxAD6dCyyMsWK2TUqmbFhMSktvJ9zope	1474	1329	426	12463	14895	jx42JsRQPkKFyM4wDR8wMboZu1TjADVAFeVN3HVwdNr6bqKxNwQ	11415	16076	16076	1618832880000	canonical
22830	3NKhvLKc1dibFnMX5QYnwWdVfaNBgsgPG4hGhhj9cg57sithSBzf	22828	3NKgPhXLqbLVm9zn9MVhqmDAWHHZNby3AUdEDZv9Nc7CLpo2WLTC	1571	1089	426	12463	14899	jwLXym7U4yMZchCZmnkveDxoHWtBeDGxSRCgW1fSJMtQ8TuRdJ9	11417	16078	16078	1618833240000	canonical
22835	3NLVBsrJLKKozAETNXnv1mzmmyQ998YjKXYLv3uQFZ6HgajMKxLV	22831	3NKtZArPpNQMrJ88nNUVZGQD2JezAHk5Mj6DstPfuV77iUWjWxHR	1546	1213	426	12463	14902	jwcztmkRhKzqdYyJqaLfcxDesZ4swiTs2YJ5Tvzed93Uc3Urvp2	11419	16080	16080	1618833600000	orphaned
22839	3NLJG4U2Phzw7AHzxwSJAEPafrWcqtiU9baHu38gTsETZFcXHaiD	22838	3NLs8FArCcR46ktb6DcEkqoDY1WDkPSnGUqCGCSrxqHMho2Z6eGN	1509	1320	427	12463	14906	jwL2ANcGLL32yTkW53W7nVDLDQVUfrpuzYifx4sRgqioAqfiqU5	11422	16084	16084	1618834320000	canonical
22840	3NKfFoB5Y4a58rYyZspmXkmB4rips4CfnQuTWsj4tBWqwhuhopAa	22838	3NLs8FArCcR46ktb6DcEkqoDY1WDkPSnGUqCGCSrxqHMho2Z6eGN	58	1281	427	12463	14907	jxD84qajaMpMKK8wDjcQhPUioGaoZ5GTphAPxBnR85MsiHLBNPz	11422	16084	16084	1618834320000	orphaned
22845	3NKiasL8LTQ1itLnGVRM4BBGYRcfUvSbmz3KBbrV7Zpy6ugfkvWY	22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	1403	824	427	12463	14912	jxAecfrjg6QmmRcQJ3Su2bi5NP4ViyCguMARuxhzT7rJnCPAmnT	11424	16086	16086	1618834680000	orphaned
22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1509	1320	427	12463	14917	jxsn96aLaLpGZoB6RUsg5JdKjECYZxPjL3d3ZKGDEZp9Ndh7fwv	11426	16088	16088	1618835040000	canonical
22848	3NKTApTRnpZ5m2xJpDGp8GBsUEUDjdK4tLzNaKpUMm1GrRazeXct	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1637	816	427	12463	14915	jxTD1LMFKN8d1EYQmpbLjfuyE3aPZgD1e7jNJgfdwtjZDXUS9kA	11426	16088	16088	1618835040000	orphaned
22851	3NLckmaftVVJ3vKKoWdcM6kg4H2qMt3mx2oun4ECBX28PkrgNYWH	22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	1500	1297	427	12463	14918	jxS2PUcQ8tEg81fdGVVbsZessqZ2tt5iq3YUkxxCUdYmUh3tHw4	11426	16088	16088	1618835040000	orphaned
22855	3NLHmN4ZbPA6nSdvHh4d1yCPx2TinLhshDUt9yzNBRCngbdT9cEi	22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	298	1308	427	12463	14922	jxTh8FmLMYWdgf4jDNRZFLoUoD9hsHkRwZnqjiHNQy3TaM2gCk2	11427	16089	16089	1618835220000	orphaned
22860	3NLKwXZD71vM8Hzn56tFhBsVsfBjPcxd9s3Dig9mYBTHDtTjUeBL	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1529	1190	427	12463	14923	jxE2F96VBb2rHgFK77wMRyLsJf3k6ufk6jcT4rPVwj2TKqEgYeF	11428	16090	16090	1618835400000	orphaned
22861	3NLrjx7g2U48vyiSsJuXVYs9D9vCW8dWtpTzCeUFXPX259U6T5uX	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1448	1311	427	12463	14925	jwbLKWw2kcXhtiypve5swR4yWaHKZU9GFyG4qrzGF5a4aUX5qvp	11429	16091	16091	1618835580000	canonical
22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	22861	3NLrjx7g2U48vyiSsJuXVYs9D9vCW8dWtpTzCeUFXPX259U6T5uX	1445	1290	427	12463	14928	jwcXjUsLR6YNneXCx2rpHTXuhdU3KboDZ7BihEZMNT8F8jKLb3v	11430	16092	16092	1618835760000	canonical
22872	3NKDiiV4jRj5MMcMsfpSqx6uCCGXg9KWBdHewaD2DPe6yh2GezVu	22871	3NKuZQZjSxqicf1SntcYCeGSQxzaZRQzLreHL7ztE3NVcBvn96MZ	606	1169	427	12463	14934	jwBk3WDYnrjwCZKzuuSAPX6HFqBjGwdjUb7e5vuzxGA4819yuAy	11433	16095	16095	1618836300000	canonical
22875	3NLYC5qRzAqCNR19X14ASAH1CdPcFG4ZTxZvokqSG18JB2KR1m81	22873	3NL1DcR2pGeFYn9Apj8QbDjmWs9j4ef5PFCrkK4fTkJ9oNuuGRQu	1650	1249	427	12463	14937	jxyop8fvBXoKvFhqSMJo8Dk1Yh39EKxnR5o41FryFE8mZ1Dz2nq	11435	16098	16098	1618836840000	orphaned
22877	3NKHJqUfnNH5TycJTbN9A3VJuQjwebzHFwFa6ou6kiuwQEBvYTER	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1406	1393	427	12463	14939	jwm83wXAhj8omxCGxP6qrizccM6JehHnFfTUFeNU6k2kcorWVxN	11436	16099	16099	1618837020000	orphaned
22882	3NKtJQMQj9WSu2pb46cPy5jXycXDMoxmznAcLcgz9HBbpdDYAFWQ	22881	3NKHBouqw71aDZyr2GJfEUVmQ8DB7DWjP8EP41GaYkqU5cmYNYAp	1407	1395	427	12463	14944	jxj5J1URZswt5KvHGMdJ1ciqxSCAub9zyFT7gZGj57YVQcWMD4g	11438	16101	16101	1618837380000	canonical
22885	3NLx3XTLmHAbdG7m1xW1wwYnmAFiGtjWEqFJ7VMvLMtMMGvzAfkV	22883	3NLpwfDUP5yPwbRCz7jDAx2m3ajaKQdFzqCoTksAjk5H8S6jGGeh	1600	1372	427	12463	14947	jwnxNhTZpqCyycR4HDvuisjP5ayRpa9wJ6euJ5xuBzJXnLozA2V	11440	16104	16104	1618837920000	orphaned
27806	3NKXxZejBJdGPbVDZQ5bjHyBNHDXPFeMgDrEpUp8TL3w7y5yi1GE	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1523	1075	542	12463	18974	jxWSCNDEXkx1eGrkJ2Chxz56M95NkDwMbRBVxnzENqVynZNBJYz	13740	19362	19362	1619424360000	orphaned
22854	3NKbpdjthuMthuQPF3K1DhgXTRD9fWkiryfHiEngRzDamHWmKpFn	22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	1407	1395	427	12463	14921	jxan9A5Zk8d6thXQkKhwxn2yg2aN5pyAQNKKzvnUiir4LV8RyjZ	11427	16089	16089	1618835220000	orphaned
22859	3NLNzBKwDuM6gynqLTgHtcnBrHsuZKDJ732ChjvhmBJK3LmqNPRo	22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	1406	1393	427	12463	14924	jx2i5XRCts2VQ16XLHtGju1fXYCW3WZjwhtNon8eE7aPH3NWWYh	11428	16090	16090	1618835400000	orphaned
22867	3NKfd6juqhdZpMT8isydbJaHYwaYWx2TnTarmNVcPnncxvQjdbar	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	1613	1349	427	12463	14930	jxiqRnEqHq549JrD2XK477DfcrjksyCKYo2PPBJkzc72PZiJDY3	11431	16093	16093	1618835940000	orphaned
22871	3NKuZQZjSxqicf1SntcYCeGSQxzaZRQzLreHL7ztE3NVcBvn96MZ	22868	3NKRmRnWkM2xnjR4QvGejxUvpejfG7yvM1L5ffpbHv333P5sQy21	1406	1393	427	12463	14933	jx9f7w72khQR4TzA6whh5irVV466eE6YrZ8tDrAuL34fgrM7p65	11432	16094	16094	1618836120000	canonical
22903	3NLCYw8tPL1oxKM3qVRpPYPUBEQoF118RnNXrhv6RLGq77sXbUMk	22890	3NKRVrJ2EFWL48rZfhF5B2SR8k4cE3oStohbyhSZotc2usNVF7DP	1579	1143	427	12463	14962	jxyrnfqemtAwKf2rwg74mAjm2NyWcYFdQAb7NEXVCG69xbc3j5p	11432	16112	16112	1618839360000	orphaned
22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	22873	3NL1DcR2pGeFYn9Apj8QbDjmWs9j4ef5PFCrkK4fTkJ9oNuuGRQu	1594	960	427	12463	14936	jwPTCdTXXbu54t515pGecLj4jemAX1vVoK1X5eMbVBkQZ1QBnNJ	11435	16098	16098	1618836840000	canonical
22879	3NKkPKKoMWLHENtbW9wzG2re2eZW9vejXLopfq2RrdFFgpSEnCiM	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1419	814	427	12463	14941	jws4sx5YoYMNir3qC8k3BvZg9qUNaC6rCKpST7rSnUJ9qkT5KjA	11436	16099	16099	1618837020000	canonical
22881	3NKHBouqw71aDZyr2GJfEUVmQ8DB7DWjP8EP41GaYkqU5cmYNYAp	22879	3NKkPKKoMWLHENtbW9wzG2re2eZW9vejXLopfq2RrdFFgpSEnCiM	1397	838	427	12463	14943	jxEaHkkxG5zd5vTKykDXc2W4QLPjgYQQMKA1TDA2iX35b5QXHMo	11437	16100	16100	1618837200000	canonical
22884	3NKCBSoDtuDwDALPecA4HTtLZ7wrwK1eDcaCDdkMtQf9BFNtQ3Jf	22883	3NLpwfDUP5yPwbRCz7jDAx2m3ajaKQdFzqCoTksAjk5H8S6jGGeh	1455	1206	427	12463	14946	jxbPPEFWmF6iLm22xvwFuSYGsvkrsBwYhsSdnZEexbtdkk8mVut	11440	16104	16104	1618837920000	canonical
22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	298	1308	428	12463	14951	jxFA3AkveWyN1VBBpAPXDoJivUQacG4raBseRh2S7eKwUkriMFu	11442	16106	16106	1618838280000	canonical
22887	3NKdQcwQR9UrUz8LPVU4veVsETDBkHyTWd61YVeptUx7zqMwJZNy	22886	3NLgaWThPzDeCfZhnzeNwGzKsxzFfmEP24TuBQmPWRC6VGRsdDuA	1406	1393	428	12463	14949	jxpheMvE2KwM7QJ3iVD1DPENJL5bGpJtGzTKEtmh2SdDgVKtBE1	11442	16106	16106	1618838280000	orphaned
22891	3NLV16Z2JrsP1naLQo9W566kvN8hsVTYh1CLZue41ostTpkYR1uN	22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	1578	930	428	12463	14953	jxpUUSJY3ZziEXGH7ikPRKKJdSu5hQjcyQxCGRhSmrjxRU5uPbw	11443	16107	16107	1618838460000	orphaned
22894	3NLHejteSrhn3YQDtUzH2ronRXsTLgC3pikzecR1U16oCTWKCuSA	22892	3NKaxd7WWZSCHLZyMCyuceUfVWgrEfTZha8oUj4vc41F2q5sBQo3	1637	816	428	12463	14955	jweZKkQwaWLgMagNurWxw6Hc6JMasZxEqfzYHPZxkJtCydL1fiV	11444	16108	16108	1618838640000	orphaned
22896	3NKsMGDydcDu2huvs76bG9PfJP4JJZJ5335eki5fv7c5nyWmsTAP	22895	3NK7GH95xeE58KwBUgwH9Ek5mn5t3LVr1B4ijwhTvdyPoE9AhpDR	42	1115	428	12463	14957	jwmR8AYKzSTTGDTcJFqcAgANXoJGBZfCVZYXUjokiDGwSQG9Hck	11445	16109	16109	1618838820000	orphaned
22906	3NLsMVs9NuEw9kRxAAQfL5WqTxrrWvy1H3rVZbUbXsd27mP8DPXj	22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	1637	816	428	12463	14965	jxnVyA4RTA3Eykh9GTQ5yfrikbKWaAGMSnBbANnE2WkXM6qumDv	11449	16113	16113	1618839540000	canonical
22916	3NL1xfCKTUp3u6R7cLW7msjx2PYCLVPm778EuRh6Mi1CpSmkN3gy	22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	1474	1329	428	12463	14973	jwkLYQfHKcVw59gf6GGsTp9xvrjM2GkKQnpKtutuMsgGvY8N9zz	11455	16123	16123	1618841340000	orphaned
22923	3NLBJPcVTai7ooabNtmXGyEYbH2ao4gDRzYfRAybVTC76Mntuqv2	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	43	1064	428	12463	14980	jx7pYnjtKYdAkf9eXiDRZJxwXRXbornwU7P2Xg8hBLQL14ji9TP	11458	16126	16126	1618841880000	orphaned
22925	3NKZVa9NJZM83MDs9sPNELwQPVDU2HniWRvruAYhmRD8vKSHHZhM	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	1593	1346	428	12463	14982	jwNrGNRj2cfUYZUpfGFybLZ7oWfxjVvcWBJA842nMgkHDccKS62	11458	16126	16126	1618841880000	orphaned
22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	22926	3NKzdFpYp5o2iMk2z9Qz1hc437J3STK6T1EbBbask87wdsPQxHDz	1406	1393	428	12463	14984	jx8J1EuwCAhknywJyfP8sKLKsdAHyAcSfcayhqCcZqPp7kEu3xC	11459	16127	16127	1618842060000	canonical
22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	429	12463	14987	jwvhfkTMfhZdyxfdMoy2KyiFm4XZJYWZeYvtGXkAzcWv9EWUmmZ	11460	16128	16128	1618842240000	canonical
22931	3NLjEEMHUwQXHiUtGCvnkBeAmphTnZhVAhQgYFDxPM7uk2FG6MFV	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	428	12463	14987	jwQAb6HW3qLkRFY74G3uLHWtib7biXbZfNnXtwwjLVRxVsnvoAM	11460	16128	16128	1618842240000	orphaned
22937	3NLwtaWBmWpGFhtFrhTNeBeby5ckRn3tq7Dr7qhuRoWJdyMTeYpY	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1406	1393	429	12463	14991	jxPzLcRetcJUsii73jW3ePkULZgkPm5mYJr9uHTfuBvBsUVcMDs	11461	16129	16129	1618842420000	orphaned
22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	22938	3NKb63mnGByZ8w6zEcNjYgXnRbiHgFAhQKiM7e78rPFjcPZ8hZU9	1675	1342	429	12463	14994	jxHJCJpv4gkP3Lgs8aMtCPGZLpK58BqvYo4j2t5UH76CZh6U3VK	11463	16131	16131	1618842780000	canonical
22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	22943	3NLDDT5gYz7wvUvUjfjFQS9xrS3mzBdmcThwKP5FvAcLP1uhhkPh	1560	1045	429	12463	14998	jx1mFhrQhWHpv9YifDJaTBuTzj4q7Z6vAqbcbJuqigjZ7Wgc4Dg	11465	16136	16136	1618843680000	canonical
22948	3NKjNRS8JeYVXVcJcjAMfUdo3ZKuo5vLnc7HFJ1ZYbEyaYkC9wk9	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1508	1387	429	12463	15001	jxYEiKJThZ5gW6fUPwakatcVNkbKx53EykH3b6pHJNWYKymjoJq	11466	16137	16137	1618843860000	canonical
22954	3NLx6E47LrZsYW6YwiGhhU3LEMaWfXJ9j4gxvtZf5GDP9PcwePxA	22951	3NLYAUKYSoMyY1oLrjB1BGFiLriEU1piZj3YBP1hgqMULNqe7361	1593	1346	429	12463	15007	jwCMYcHJVd3E1vGzDGPr9U5JYzBsryARuqkXHmonDkKNya3468H	11468	16140	16140	1618844400000	canonical
22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	1426	1118	429	12463	15013	jw9BjtKoMZzrTcyva38JRVDt4Uqv7aDdHVuZxMrnoFPddvCqAab	11471	16147	16147	1618845660000	canonical
22958	3NK7p4fiSTqeXXd9WedRKHGdStc3KiCUjH4zWXHG2igiNde4ckid	22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	606	929	429	12463	15011	jwBTvKZgbAgFmAfdJ42VK87BWXy8iAiDannWmBwDD29sSpDwLo4	11471	16147	16147	1618845660000	orphaned
22962	3NKwB3kyTjo1DnrV9fGTsLXcYPiSsnbrk4WJ1wigbQz22APDatmS	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1406	1393	429	12463	15015	jwUqSsDzy6iQfgGnqGWYafPDgNvabPdzTepXuFwTnWiQNaCjZ8t	11472	16148	16148	1618845840000	orphaned
27809	3NKuf6hE5WRnz5nbK1yzwpgZSzsdfVSMhcYkALcLcxp8Vd3euNgt	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1476	1125	542	12463	18974	jwyVjWzaJ2tJu5XYUwdXG15RmHKzjtiKaRiwpsZSukyXtugPzrY	13740	19362	19362	1619424360000	orphaned
22897	3NKmmExXmy4bvUfXy6WdERv91AoR51jwLGLzJHmwgT9Rgac3F3kd	22895	3NK7GH95xeE58KwBUgwH9Ek5mn5t3LVr1B4ijwhTvdyPoE9AhpDR	1642	1121	428	12463	14958	jxWUgf9agsC5XG2Db9S8Ve5JA9VWdfZX28F4uhvyqTfcaReAvCx	11445	16109	16109	1618838820000	canonical
22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	22897	3NKmmExXmy4bvUfXy6WdERv91AoR51jwLGLzJHmwgT9Rgac3F3kd	1571	1089	428	12463	14960	jwiMQj5vf3Hmajzg1XM7YqmWJ9KwjyKnYNgjEKnrb85WqnazPR8	11446	16110	16110	1618839000000	canonical
22902	3NL1RjTrwykrVFjYRocvV7vu7UgAKiunmh5QKRUniTjgM7dm81D1	22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	1527	1293	428	12463	14961	jxLRQ6dvomR8yjEoacquscKD3LX3tad7SJfczuyBBDzHo8mY22F	11447	16111	16111	1618839180000	orphaned
22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	22907	3NL8iU5xZnabnhn6NcvoftL5xkgXd7LiFrcfSrgFnLehiVasHp1q	1637	815	428	12463	14967	jxZrhuqZfLU3ufsMDoJA9E78MTbe3tUU7a2hMVpWNxoP2sGe3WY	11451	16117	16117	1618840260000	canonical
22911	3NLCrAJyv1BFkwn2xJnSZWgywMywuKodhE2jjqN1KD4ikbLtqXka	22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	1403	786	428	12463	14969	jxATqK5cf2z6o5FPtwekkW7RAGD5FHg7EJC3Wj2qf46qav2Mvck	11452	16118	16118	1618840440000	canonical
22919	3NKdhYs7VpTAWAzhqCxxZUxifzkert8iNzSiPAcWqC8uXzkT9pUC	22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	1593	1346	428	12463	14976	jwH4f8voatSCBzSPBCwsfZXPh6KYoYHkNa23coS4AUJoWV19YVY	11452	16125	16125	1618841700000	orphaned
22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	22913	3NLbPEsBbTMZxkcypkBaredQexnS8q6794pXcWnnf8kzrbsdYg4F	1637	816	428	12463	14972	jxNnXXLrzzxCBpQYZyKis6475xHHYDvHGwcungXGfuFCHJC2Fpn	11454	16122	16122	1618841160000	canonical
22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	22918	3NKUrcF8z8tM3Pavy3j3sQAMZtRw3VuGgw7fEcJBQELVoNudBYww	1593	1346	428	12463	14978	jxRwHyF2tJrJaJtVWdwoNsPpZVtjkTZrHRFTAKoCqxDxU4pGX2i	11457	16125	16125	1618841700000	canonical
22938	3NKb63mnGByZ8w6zEcNjYgXnRbiHgFAhQKiM7e78rPFjcPZ8hZU9	22934	3NKT2gWcqVhF6VH1sSYPvbtc5HW1KPUMkp9PwEB4Y4FtrYp38vCG	1405	873	429	12463	14992	jwXBQobqmsuUoQYibjijv6BYjnSU6hneXzMKP67BC6fQAXCaedw	11462	16130	16130	1618842600000	canonical
22943	3NLDDT5gYz7wvUvUjfjFQS9xrS3mzBdmcThwKP5FvAcLP1uhhkPh	22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	1607	1348	429	12463	14996	jx6jdQPHr9cu1Z3MvhM7oV9zafQbcK7dyqSYQkkP9Pa6wr2DrMz	11464	16133	16133	1618843140000	canonical
22946	3NK7hAxmwethpvXH8EQz2FDrAxTCQ1xScotLWcniWGTyq6sFzh1S	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1656	1343	429	12463	14999	jwaoobPf2nhTUdmQJ6hqJYTNpACe6ARfzDnVkmZALjxdF1Qb7iU	11466	16137	16137	1618843860000	orphaned
22955	3NKvGgmrh1ihPEKkoNuweXnUiq4C4fR9PonsJC15h3cXDD4uzW3K	22954	3NLx6E47LrZsYW6YwiGhhU3LEMaWfXJ9j4gxvtZf5GDP9PcwePxA	1675	1096	429	12463	15008	jxkYufc2JndXRa4CbCTWLNLZ7sjyQ334pehnHi1JdckApqQLaTH	11469	16141	16141	1618844580000	canonical
22959	3NL5dvkEunkNgVRj2GdGt5XC4Hpr1ehmeYHFB38AC64rLFA2DrLK	22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	1553	776	429	12463	15012	jxXUKzUhjKjRGHh1eNArS3JAsoR7go5Js2rcbfD3br4eiLkaeHR	11471	16147	16147	1618845660000	orphaned
22963	3NKMMahYggfpM4ApJm4zNZ3q76B4EH6N5rf9eNVWZ5z2NQQN54mw	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1607	1348	429	12463	15016	jx4vPDC6D5iQPCjMB8r7BfGZjLDai2Qbt2NSePWt2gVQra3Hi9E	11472	16148	16148	1618845840000	canonical
22964	3NKJZDLmebduDaKN1KzXMJxj9p5skRSxPkEFDFq7C7RDgeuskD8r	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1560	925	429	12463	15017	jx4jZqPutPPrNh8UKF67ya3sKaBKg1MRAy5j5XEPvktbLw48dy4	11472	16148	16148	1618845840000	orphaned
22967	3NLF8FsDLLwy4z4ynq7UnkUJDFFNjWBi4ExPBgkzbtCm7CJm7r5B	22963	3NKMMahYggfpM4ApJm4zNZ3q76B4EH6N5rf9eNVWZ5z2NQQN54mw	632	1382	429	12463	15018	jwHtKjVb8Py4keHg22WYGndPxTuwXYsfFX3VXwo35KgZBCjMJMn	11473	16149	16149	1618846020000	orphaned
22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	22966	3NKKqSuQ9df8fXYH2iycrrpXfhoSQQa6vdfGm8oCYpdeEbBjejxM	1406	1393	429	12463	15019	jwkN8obD79Ze3o8QgVNF4ihyWkV6D96C9XwF56nvhzh7u3VGMiL	11474	16151	16151	1618846380000	canonical
22969	3NL3az8GoR9fNQ3ByNFN4ek1DAttAuUyj84QnaFbWbq5FjpxbhUp	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	606	1295	429	12463	15020	jxUweX8RMyuFZwy7b9rqKR5rKReHoXbqiCecFGfqsS6VfoibcMH	11475	16152	16152	1618846560000	orphaned
22971	3NKZQtLExfTVChCfKDDKGXtz4e1aixL4TMHfdnLUPZucaY82kaoq	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	1541	1298	429	12463	15022	jwGcoBVQ7JeVs15SWyNzyoBfzjn9r4ZYn79ZV7DRn3nkAoMBviC	11475	16152	16152	1618846560000	orphaned
22974	3NLUhb6YvvfBq7pzAZ92QLRQFEdZAvXGp7ChvThoUUiEN761BBom	22971	3NKZQtLExfTVChCfKDDKGXtz4e1aixL4TMHfdnLUPZucaY82kaoq	1559	1107	429	12463	15023	jx65hFUzfJU5oPumtGZzHFFJpmCYwVsfVQLgoP1T5LPMRJAWubB	11476	16153	16153	1618846740000	orphaned
22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1566	318	430	12463	15026	jxhV7auArSJ1fnV9YBhdEeMpmnKe5igeQW6nrx8FptNmpMKTvoV	11478	16155	16155	1618847100000	canonical
22981	3NLaaah3oxPpmqb5R5PrFHgdmJVvBJ3LWUsveKGzu6uNxUD9JRqg	22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	1553	776	430	12463	15029	jwWYNAnnwrbFLCG9GL68LrtZWMg7gfyNiPGGewFHm7zmhucbLbe	11479	16158	16158	1618847640000	canonical
22986	3NKxJLsGNtUGC4zkZLP7krZExB53np37LwojvFda44SHw5Vfn8NP	22983	3NKtDVAPeTkAoJfceavgXbkmDaHzyoEKDMDBBZBm7gevxjnVPLjg	1607	1102	430	12463	15032	jwUytJkBsG3N4ZcpE1zARgizpMeBpLMGBkWq5wes3T5yfguLUqW	11481	16162	16162	1618848360000	canonical
22984	3NLNPg8L5Bv8j9GJm4a29GqKfA3KeWh2aeVcWcPbb8RDLzmVhhGZ	22983	3NKtDVAPeTkAoJfceavgXbkmDaHzyoEKDMDBBZBm7gevxjnVPLjg	1607	1102	430	12463	15032	jwA6F1JHuNKouzNCZincyp5ksGnUGVz57ws9WHQpjPRUUbgiP1C	11481	16162	16162	1618848360000	orphaned
22989	3NL1PXQkqvXtmkeq7FXUoFE63tDCgjNuvdx92U3FkzodxbGtA6pa	22988	3NLrBFHZSrybb6yAZpFVpf2HDBBntmniME7941NybHXvDAxKHiEs	1467	1376	430	12463	15035	jx6u9enZJSnfGh47NaqXgaphSSRmiotezs7fJARqJHXmdK6nrMi	11483	16165	16165	1618848900000	orphaned
22992	3NL6ZWG4rNcwzypvTLt4Xj7u4AoTK6d69F35byMrqCeCwnMMeN4C	22990	3NLGAZv8eD559BtmCVCykx3HACnYuSR2NJgRiux4EmV5uykRwaCA	1581	778	430	12463	15038	jxoS8UaHCjFdTsqoALFToHYKhPFggKinDmQS9oJRxa2H1cCe7VN	11484	16167	16167	1618849260000	canonical
22994	3NKeDhBYfY33a5KAw62vSr5vVozs13YBwa4HuJVDgyCWXMgCT5bo	22993	3NLQLKZKFUEWxpNYAceG5u78t4Pt2j464aUP7YdJRW5EEE7o3qrk	1406	1393	430	12463	15040	jwwjSkRgYyNew5aeyf6wigN8cqZDEHna6MdRUUwo2cGqZzL7bhp	11486	16169	16169	1618849620000	canonical
23001	3NKgpfdUbAWay6bsyXAuxxX2CyTsaocrtGgQ3A6VxNBM5as6W3nF	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	1406	1393	430	12463	15047	jwngutEbCGCZNiWZu14p9MgUMVM63Qm13nw4pceyq615zmAJeM6	11490	16177	16177	1618851060000	orphaned
23010	3NK9puE2SDfwgdEUtYrPAkZEavrQWTDdPE4MDemUFfwrkJm32kwq	23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	1490	1028	430	12463	15054	jws6WEvF1rxY6TS9MvFKRKnkYPvWtfaPo21gXBUb7Lmj7T1X6GJ	11494	16182	16182	1618851960000	orphaned
28223	3NKBkPFPLPmTxSre4EF7k1soaYuHpsnvVRRhLANbyvFJFArRvt5W	28009	3NKcVFuLD3DQD4VmXs6ho8z7jewBSr5n96BSrvT3zQKyDMATAV8M	1560	1045	544	12463	18974	jwQ7hTVkJk2Gkb1d99mxtocjbgFrjRtqAWMpSAAVAAXESPrCeC8	13743	19670	19670	1619479800000	orphaned
22901	3NL4eAGarsW1tW3iE2vZQmV81DhEi1mfuk3QoFurK9vbiXLu9rQN	22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	1527	1293	428	12463	14961	jwMXXqUPtau4QT8oB4XLfbVabY76fa1PMyj2orHkr9BryZo7iw9	11447	16111	16111	1618839180000	canonical
22929	3NLxfdAu1cCdtfxFVMmMAdNocA4eAcrbJvsBxiXihvtiTmMbfiwo	22898	3NLAhFTZmcLNECsGjEp8BMHPi9PQ33bLmWqR4VBthSyAAzoAvWyn	1569	485	428	12463	14986	jx9T9DLqn6AFCUu5Qs6fEZ1HNzemE8DaM1NNF4G8sc1mSzQEWY6	11447	16128	16128	1618842240000	orphaned
22905	3NLxtJExKmDCJ3tQ9SdRnxNwpssitp8UkHab5hryhWMbgQcbMZKf	22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	1407	1395	428	12463	14964	jxRg74LhfZQheTnW3tYL6hUbJrAXATU9x6FZ59bYvY7Kop3q1qu	11449	16113	16113	1618839540000	orphaned
22908	3NL8A46C43meFErR1sVfi5ve6zTYHJrcddA87EkPVpvsMsm1psmD	22906	3NLsMVs9NuEw9kRxAAQfL5WqTxrrWvy1H3rVZbUbXsd27mP8DPXj	1419	814	428	12463	14966	jxRrVHJsCUPU4C16EQHHcyBmjGhodSmXgbsZQo35BkWtvcUhTe1	11450	16116	16116	1618840080000	orphaned
22913	3NLbPEsBbTMZxkcypkBaredQexnS8q6794pXcWnnf8kzrbsdYg4F	22911	3NLCrAJyv1BFkwn2xJnSZWgywMywuKodhE2jjqN1KD4ikbLtqXka	1407	1395	428	12463	14971	jx18LpYYwxQbmPqfNKoaqMY2FijXsHFBo2Akm6uxpfKmmDib6X4	11453	16121	16121	1618840980000	canonical
22922	3NKJWvBSYvwtZoPEdkv89H16LuG4866n3qG5dmo6ATAVd6cw54Ft	22919	3NKdhYs7VpTAWAzhqCxxZUxifzkert8iNzSiPAcWqC8uXzkT9pUC	1593	1346	428	12463	14979	jwFZyu6QxzLAYU5kqeHPKnft5qxjo6YnWR77vURxxSH2tiMf4Sg	11453	16126	16126	1618841880000	orphaned
22918	3NKUrcF8z8tM3Pavy3j3sQAMZtRw3VuGgw7fEcJBQELVoNudBYww	22917	3NLyMocCmnq9yPkTxPQg9bJgPUyNt8PijRqNGgxZY6s2ndhitNse	1648	918	428	12463	14975	jxkAFJtmdxLGtD1RjWzxkpnDq6QijyfP9i1ogmta3CN1oq6ksqV	11456	16124	16124	1618841520000	canonical
22920	3NKZ8Esc5961aRZwwQD5tdhTCDuX72WFQNAJpDfzLGo4aAq5BqMH	22918	3NKUrcF8z8tM3Pavy3j3sQAMZtRw3VuGgw7fEcJBQELVoNudBYww	1637	816	428	12463	14977	jwLX7m8EujY7u7G91fFv4kckFTx5AeLMiueaF1fWuPshesyYkGE	11457	16125	16125	1618841700000	orphaned
22924	3NLBWekPB8HeP7FHuYXCV1E4KnjSwYd275ob4LpkU2ye6aARjAEC	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	1649	1137	428	12463	14981	jwW5Cx3qa6zgCjKkTL1JsJibLqDC8NwJ1xFcQxA73tprJejEYVV	11458	16126	16126	1618841880000	orphaned
22933	3NLaerbVtjvRJ1TgbxpQ8kkCsw3dbQaortDgrev5Secdo9geXB7y	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	429	12463	14987	jwEAzTD5v1jaD7w6WdFcNnGdG23rL6rYiXmZcZCZfHfCpYxNryp	11460	16128	16128	1618842240000	orphaned
22936	3NLHtZ8H6JCY8C5Jmoc2D9xoGuXEwspMzZ6cvTF7ijBhm9aBJpws	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1407	1395	429	12463	14990	jwMbcZg26BjMKtj6J8RtcVCzvDc16CgN2XWf1z6D7Ci4tvQB75Z	11461	16129	16129	1618842420000	orphaned
22939	3NL5k4AGG3LgAAUUUoVukKPvyfcfWrfeBWr1z3BVJ4fSPseSNUMV	22934	3NKT2gWcqVhF6VH1sSYPvbtc5HW1KPUMkp9PwEB4Y4FtrYp38vCG	641	1090	429	12463	14993	jx8LCyZh1yqBtFJ78h2946VXKtQZy5ABFtorBfvvZ5BdeF85sMA	11462	16130	16130	1618842600000	orphaned
22942	3NKyVzfQCb3g16iTzUH8dHHUYPmTJdA9wNJoXMkWVZhV6qmsKFPB	22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	1607	1348	429	12463	14996	jy1eGHGMYq88VPihnhwSc1qd3pEXnYnZK7tBT7MPSNXohQbkjaK	11464	16133	16133	1618843140000	orphaned
22952	3NLEgAaHh6T4TL1f3CdDxuv3B5k5cR2ivW9VhhzqrGUaJsH8Vqff	22948	3NKjNRS8JeYVXVcJcjAMfUdo3ZKuo5vLnc7HFJ1ZYbEyaYkC9wk9	1553	776	429	12463	15005	jwmXD3Gka9rmYQ2MHXDZMSwEnU3wRtftziZMXM24jjpVzBbCXmA	11467	16139	16139	1618844220000	orphaned
22957	3NKrFdEh5NjhMciUKstqG67WcQSSBN81kQineRyDqaFydC8a9bwf	22955	3NKvGgmrh1ihPEKkoNuweXnUiq4C4fR9PonsJC15h3cXDD4uzW3K	1407	1395	429	12463	15010	jwmvwcGfTsG99gaeqoAkShYar1NyhpSumhZ8jaoo2JDwpgt4MMP	11470	16146	16146	1618845480000	canonical
22966	3NKKqSuQ9df8fXYH2iycrrpXfhoSQQa6vdfGm8oCYpdeEbBjejxM	22963	3NKMMahYggfpM4ApJm4zNZ3q76B4EH6N5rf9eNVWZ5z2NQQN54mw	632	1382	429	12463	15018	jwiFWaPufk5M9XUogW5KYA55AqPhtcTeKaxWwmNmKwWuctn2uem	11473	16149	16149	1618846020000	canonical
22973	3NKWnhQMDEpvLBLHcmn9AkspaPTHNEn5Ym1mkzbLL95yyPTQysE4	22972	3NKAjNkBVYynDUUF8AMK26Q9TKgVRLxDGfCvuampUuB4VfVYuNQd	1559	1107	429	12463	15023	jwUvhyKqc5Bf76sGibVJCNG3AMXZ16337WALKe5pwiHTByygAgb	11476	16153	16153	1618846740000	canonical
22976	3NL9WwLU498Vk8xTXzz5ugpSimaJHkzF8tPxffntUY27VYagSF3z	22973	3NKWnhQMDEpvLBLHcmn9AkspaPTHNEn5Ym1mkzbLL95yyPTQysE4	1476	1371	430	12463	15024	jwDm9NjweR6hNxqyfnYvC1My3yCXtNwUxMqrWnaFPLvgJDmgPd8	11477	16154	16154	1618846920000	orphaned
22979	3NLUtT5HB3kxEPPr6TCcSEXtQkssF4t4bMnapB7xURFzzWTmn6wV	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1646	1228	430	12463	15027	jxqxjTj8ypiRAsYXaR8jCRNed8Q5c3grzMnKjC61pR8hM2eq4Qj	11478	16155	16155	1618847100000	orphaned
22982	3NLWo9Vij7YaXcw5Z4Ueo1bniRntfg9uea5ba8ksDcd7qVXyAoi8	22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	1406	1393	430	12463	15030	jxU7T2VAx66rvp2an2jsAYzdHC2FDRS6yAhowYYbJu3NQVwwg8y	11479	16158	16158	1618847640000	orphaned
22985	3NKS2tj5jxt5ftSw7kEXVdyw1pepkVu8DX9J91txVZLPBzVSX4oz	22981	3NLaaah3oxPpmqb5R5PrFHgdmJVvBJ3LWUsveKGzu6uNxUD9JRqg	1607	1102	430	12463	15033	jxD6hZDMwEuRAMUCFCFmN1FqAC59ZM8H5PEY9qhd9bVFpj5E8HB	11480	16162	16162	1618848360000	orphaned
22987	3NKAeHnL5zKEdPXQjvef64aerFHKTT4my1yvZtGjFPr43RpbeUcJ	22986	3NKxJLsGNtUGC4zkZLP7krZExB53np37LwojvFda44SHw5Vfn8NP	1439	1033	430	12463	15034	jxmF6fLZGvR9hU4AGvQRNaLjkzeZUqeDBdoayxSD3eTVQTi64v4	11482	16164	16164	1618848720000	orphaned
22995	3NKmDLEnJGr3fJsdVkqVKzvHnNJsjKe3AgtFFBmbUgXHGRmxga1A	22994	3NKeDhBYfY33a5KAw62vSr5vVozs13YBwa4HuJVDgyCWXMgCT5bo	1642	1367	430	12463	15041	jxThb2K3YMd1yBNsxoFvyJad1y5R9Q64V4ECT2WvWMBZNB3VTic	11487	16171	16171	1618849980000	canonical
22996	3NLH2YDU5uaMJgxKNt4XwANbLBiSD7UrF4iodqPeGpG9udX4JJn8	22995	3NKmDLEnJGr3fJsdVkqVKzvHnNJsjKe3AgtFFBmbUgXHGRmxga1A	684	684	430	12463	15042	jxArLWRmFGp9cDVYzweh34GPMuWaLkAp2YYTgwRkivY6BQgzMQo	11488	16175	16175	1618850700000	canonical
22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	22996	3NLH2YDU5uaMJgxKNt4XwANbLBiSD7UrF4iodqPeGpG9udX4JJn8	1405	1	430	12463	15044	jwmyQA9YfmJ9nD8TaQgZybmyJztscHDJCWcrLSS1vgJbt5WAuXb	11489	16176	16176	1618850880000	canonical
23002	3NLaqJJ1pYZBcyZTar4567QJ1VxFydbGLzHQ6evevob4XRGfhZa5	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	171	1248	430	12463	15048	jwiN5iuXr2gqUtfZpXDUpLd4RRZQ96W6319PT2ug3WnLdm8jKqq	11490	16177	16177	1618851060000	orphaned
23007	3NKYRnYQmSatrRX34DqLnfeMgg8VibAEdY31cUS955oP86LZpC4H	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1444	1381	430	12463	15052	jwtaovKHvZQdG5rtpZyffYomXVDBXf5yeXxMzVSiFANKUvk4MHA	11493	16180	16180	1618851600000	canonical
23005	3NLi54FBZzA7DWQtkRG1fupbdLdGsAPTv2sV4M3tDmTurrEpA4E9	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1440	1131	430	12463	15051	jxX1pJftAtboCTU8q2UfFwqBHJyKbUqB2XWGQEb87yoBNGgX8DC	11493	16180	16180	1618851600000	orphaned
23011	3NLyJ1DtEBmaAr4VYPVtUySFz4AtQN8xYQuZBwYxghX1VbJS8hfC	23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	96	96	430	12463	15055	jx19ZcGr3Tk2hbBsdhMp9rjKiwMyeqxxp5Nb97wJKQjpRGbrp4o	11494	16182	16182	1618851960000	orphaned
28104	3NKCEXT3RtpqczoQeDm9xpunchYmscxqzV646oNV191PbujD6cDN	27835	3NKY28VPqMBqkjC6efPSzjVjSgTzyP3rtznW1h3ERJnueBQhLaW7	633	1384	543	12463	18974	jwL3d1LeUuuB48VsfM5Tne54XdqYMwcPTJC6dxfXTUK7AFLVaEr	13758	19590	19590	1619465400000	orphaned
22928	3NK8DdFE6TU97RQ3ecyLvHMfA3L2ee7utJQV1A83YwvHXrxuw3Xe	22796	3NLvkEcCEQHFj4hrdF5k3vH9BSUdLQbSeidqupdLHL32zwfsaeAo	1569	485	426	12463	14985	jx5Db9a5sSLQroeXi7rfynoCcrcaZeyF3ucR92v7Ps28MZvwF8w	11402	16128	16128	1618842240000	orphaned
22956	3NKHVmapJLmwpjjPjAmiEb6DiJGsxhs5raFim3o796rbiecPxWT2	22941	3NLcp7sRGGmcVBhKd2gwjVpUEizV8wfzurU19WwoXJHcabcUXxn4	1675	1096	428	12463	15009	jxUR8tEex2hrk35FqS3mr9igkasMQKKjiChNKXH698vp88PeRQc	11442	16141	16141	1618844580000	orphaned
22900	3NKcMxYT6gjjyN3Uz4HuZ3sUGfKae3YFTRt9RzrvWLnf7ojGnjh9	22899	3NKKjTNAzpWZay6Yb5XP6jtn7eKwnaaveiwzy8LeGRrtYvJANt3J	1527	1293	428	12463	14961	jwz93G3Fd6jAjo57PGVKJ4gVBi1ZfquTGQMyJ64WP4Do7kxmnGy	11447	16111	16111	1618839180000	orphaned
22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	22901	3NL4eAGarsW1tW3iE2vZQmV81DhEi1mfuk3QoFurK9vbiXLu9rQN	1579	1143	428	12463	14963	jxMK1pxUyvKxLxpTtnaKigTn8LF85eH6otso58MTZFdjwK4m4XF	11448	16112	16112	1618839360000	canonical
22907	3NL8iU5xZnabnhn6NcvoftL5xkgXd7LiFrcfSrgFnLehiVasHp1q	22906	3NLsMVs9NuEw9kRxAAQfL5WqTxrrWvy1H3rVZbUbXsd27mP8DPXj	1419	814	428	12463	14966	jxHQbJK1YffkFQvqB8TzcWcuBJMimFnL48DDKXjKhxERq53kBiY	11450	16116	16116	1618840080000	canonical
22910	3NKyBxwFAGy4tP8TGAk337NvHM6pLj1jKzPWwU2iLx3N5s9KQjsc	22907	3NL8iU5xZnabnhn6NcvoftL5xkgXd7LiFrcfSrgFnLehiVasHp1q	1458	1323	428	12463	14968	jxwHzKMmVhKquQcJHyJL4gzFT9PYddu8o1oy4ogghiXWQjoL83C	11451	16117	16117	1618840260000	orphaned
22912	3NLFyBE6z5cqgMXPTpCKTcJKtZLEfip3wKx9YUKnZqXRpBVG8WZd	22909	3NKvWL4qLzDQbyJWCSDj91kbU5ZN1r9EzgfncccLF2tWtAv9DoL6	1406	1393	428	12463	14970	jwfcDfJbZJW9TYJmvV9ir2RtVMw3gPANLXQcK9fYxBq8wMNwR8H	11452	16118	16118	1618840440000	orphaned
22953	3NL66TPvbhbeqw9MvumQQiJEogo81kebQaJ6wMKm45ytbKBAAaTM	22922	3NKJWvBSYvwtZoPEdkv89H16LuG4866n3qG5dmo6ATAVd6cw54Ft	1593	1346	428	12463	15006	jwmqdNBVXUaW59cZvo1XZD5TzmjgW8je7kz6v2Lz6LmBQQ6wymh	11454	16140	16140	1618844400000	orphaned
22915	3NK86ZUdHgpgXgSfrWPqFb4qDdyn2wwpVZsWosCjno8r9dQipJCB	22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	1474	1329	428	12463	14973	jw8G9YLLh3jhoWD3VAXXpCM7n3PwRN4k3QK37B3mwvKF4daVTMZ	11455	16123	16123	1618841340000	orphaned
22932	3NKnE7QnDAV6ggNwhEqacBRpBKdnUDRmVQdT33NFMKaux8MepDvT	22927	3NLwiAjV8HnB8KUCz6oKEHdCnoBXpdc2WckuXpW1MDoYBFkfD5YV	1569	485	428	12463	14987	jwAox4cfkXwC6P2u1GWrBL4JCLHn4Mpa6GWGeUEdHXPGVMMwD5Z	11460	16128	16128	1618842240000	orphaned
22935	3NLLmhz6EqhbNGyR3j3z6GBPA3wQKSfhvnbQwkZNAu8TQt3P19KZ	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1668	1004	429	12463	14989	jxqc2YAUbzG335WCA7atctEPRbEW1aeNv2zjqcVYaXGQJtSdJYm	11461	16129	16129	1618842420000	orphaned
22944	3NLtQ7RkSVd7zGbwB4BAotkPmm1BWef4E4S7ruBhbGMYPSrB2UPg	22943	3NLDDT5gYz7wvUvUjfjFQS9xrS3mzBdmcThwKP5FvAcLP1uhhkPh	1406	1393	429	12463	14997	jxiM1iy5aUqy8yCSaDYvzKUMzDhNdSQJCsnFHw3E3Khto3f5pPB	11465	16136	16136	1618843680000	orphaned
22947	3NK88VbJSDb9PrvrtWVotLUAQC3mUw7AKotm68rUvv8zhAkCLGGG	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1406	1393	429	12463	15000	jwcc2vHgo5LzfUxigRP7WSDc3XUnro3FQQ1vZEVgQu4PfACr11S	11466	16137	16137	1618843860000	orphaned
22951	3NLYAUKYSoMyY1oLrjB1BGFiLriEU1piZj3YBP1hgqMULNqe7361	22948	3NKjNRS8JeYVXVcJcjAMfUdo3ZKuo5vLnc7HFJ1ZYbEyaYkC9wk9	1406	1393	429	12463	15004	jwxPQbfapt64brxRQt9rQpN32ZZE4RwUZRLQZ4jaR2tQiqE74B7	11467	16139	16139	1618844220000	canonical
22961	3NLExU48oyQ47PPJXeRuEJUk6zG3YR5dABHNZbJM7CBSKcbyrggG	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1599	1287	429	12463	15014	jxwUeu1iR7hnCq8tS95QVRfQuim9EK8NtTpGP7EnkDE1utDM4ar	11472	16148	16148	1618845840000	orphaned
22970	3NLKLXKemKURoxyTwTC2V1HeoGgqUsZju9BcoZerZgndQf9nxAAW	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	1447	1099	429	12463	15021	jxEV8Qx4RiS3vussoMjRhU6y4RuZhxaQCWSJAmbmcmDHckURrFn	11475	16152	16152	1618846560000	orphaned
22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	22973	3NKWnhQMDEpvLBLHcmn9AkspaPTHNEn5Ym1mkzbLL95yyPTQysE4	1476	1371	430	12463	15024	jxAETA8NAu7vtN7XJMQXMxhWdF1REw5EpEkhUJQwZTbVtSPnokR	11477	16154	16154	1618846920000	canonical
22988	3NLrBFHZSrybb6yAZpFVpf2HDBBntmniME7941NybHXvDAxKHiEs	22986	3NKxJLsGNtUGC4zkZLP7krZExB53np37LwojvFda44SHw5Vfn8NP	1439	1033	430	12463	15034	jw6uLqyUAYupMtiqz7JE9eeAYS1y6X75aH75znLHSKXFq2863RN	11482	16164	16164	1618848720000	canonical
22991	3NLsfywwWY3gLxiBzCtPgwxVPStm6EhfevPAE9mirUxRT9Y6Pgwz	22990	3NLGAZv8eD559BtmCVCykx3HACnYuSR2NJgRiux4EmV5uykRwaCA	1500	1051	430	12463	15037	jwwUwhSRroxcVT6xNF9eD1uPUQTv7TPsK4hkyfcPi7J7Qaq62HU	11484	16167	16167	1618849260000	orphaned
22993	3NLQLKZKFUEWxpNYAceG5u78t4Pt2j464aUP7YdJRW5EEE7o3qrk	22992	3NL6ZWG4rNcwzypvTLt4Xj7u4AoTK6d69F35byMrqCeCwnMMeN4C	1553	776	430	12463	15039	jxDhSvyJphRuxoTTAnNzY22qLte8TwdJaVyCMaB6Jfi6GMEAxky	11485	16168	16168	1618849440000	canonical
23023	3NLJri4Sku5XdDKQ6RPzVQZvCESP9w1Pu5x6YgLKjkPp6pr4xHoQ	22994	3NKeDhBYfY33a5KAw62vSr5vVozs13YBwa4HuJVDgyCWXMgCT5bo	1407	1395	430	12463	15063	jxiUzmTHXSrP6F2GdRKVzNe6jCir6JNM3v5pAyhjPDeiXUepoRG	11487	16188	16188	1618853076095	orphaned
22997	3NL2fHe1PzUU2crRG4h2ZVV6CSEX8vGV8PFpggs7h8NKFBNHUCAN	22996	3NLH2YDU5uaMJgxKNt4XwANbLBiSD7UrF4iodqPeGpG9udX4JJn8	1403	824	430	12463	15043	jwBisduuzJYpTjeCEWjJ7jeWgBaLSBRgbAchD54qR7qbwDc4ayg	11489	16176	16176	1618850880000	orphaned
23000	3NLyGDGfz784dnWP7xVfhEfo1rCx8Q9uKEm8XdwLMbnskoETwrpU	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	1405	875	430	12463	15046	jwYrb2JhXQaz9THfhDH6qJShTSf6sSnaQAqE8dkwhfvbXFrWrWA	11490	16177	16177	1618851060000	orphaned
23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	23003	3NL7yWAkmLQ6bpXUwy27hKWsWwkmtBpDyNqzgWxNwvCT1kwdSEge	1634	1331	430	12463	15050	jwijshnUm4Q6uGCDtFsN2iVLQRjwYhSfvxSEENEYue5U6Ufqmqp	11492	16179	16179	1618851420000	canonical
23006	3NLLdESF8CPGugpdEWKiWGNqZgThyNejSU1rqMPXrrQvS9AbfERK	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1440	1131	430	12463	15051	jxNsKJsKZpUNeD8Yhfgf5ieSBimYjTrgbM6gb76v3ksgC2arxAH	11493	16180	16180	1618851600000	orphaned
23012	3NK3fA1ZagCTTsVB5Cu48iuygNBZt4me1xxxS1skyWMvp1SdwaQd	23007	3NKYRnYQmSatrRX34DqLnfeMgg8VibAEdY31cUS955oP86LZpC4H	1490	1028	430	12463	15054	jxHQARWqmKezEJbuS5UuaqFbkBsqxbQEAsVLVAkqmMf7cQbwWty	11494	16182	16182	1618851960000	canonical
23009	3NLt3WbGrGWcBqLyHCvFkLPsBvqFgPXNtsYbo5CNLy5M5hk5S8QW	23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	1403	824	430	12463	15053	jwv1frRL8HVotPzKQb4rm7sd9iLTbnWhvw43GThTMACLviCuyqY	11494	16182	16182	1618851960000	orphaned
23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	23013	3NKw3KEKgUhdgiDcUGZSghX1ZkfTQKzHjESEEfQ9VnK2a7JxicBC	1406	1393	430	12463	15058	jwCLvQ9fiYYKXzZdgvTAziciTrUwSmuuDs48Ja21k4y2ux1r8VD	11496	16185	16185	1618852500000	canonical
23026	3NLnezWiXT5jcRpvY3kYNZDPv3dqBCVPuF162xMco8pKAv147ZL4	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1593	1346	431	12463	15066	jx7Qe4pgaFT9vDHmrFvbxMpJ7CDtRrngiJ3PoNa4z94JgoQCFaC	11498	16188	16188	1618853040000	orphaned
27849	3NL3ZuUay7FaFyr13LJnyJ9czTHu8dqSPUzx11QzXReBE6St1SPr	27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	1523	1321	543	12463	18974	jwhGnqihXkojQnCJTTTdzzTgYsAfXZchwCHHqR4w94RLo2AuRne	13766	19398	19398	1619430840000	orphaned
23069	3NL9pnf3CLRQuWwKu1G6krMcgJLMgziZMDRoqr6Exsjox7Vb9hWC	23057	3NLSkaoCEGxUN3N3KWPCi6aSR3QWRhnyP6EiG9do3GGSnBybdzuL	1522	1322	427	12463	15108	jxoA6kLyPyqAg8r8kDLrVLLuCWhKVu6JvEJfemLNh1sZHbC3cZj	11426	16218	16218	1618858440000	orphaned
23020	3NLKSBk3iDPq95NoFVsH6Go1pckxZtDQJ2YvSLqH9Gjz4gu6nuMS	22953	3NL66TPvbhbeqw9MvumQQiJEogo81kebQaJ6wMKm45ytbKBAAaTM	1593	1346	428	12463	15060	jxJYYXtzG1b3zc77pdAbhBGpT1SW9WM7bZPGirj1N1y4tZ9nYrP	11455	16188	16188	1618853040000	orphaned
22972	3NKAjNkBVYynDUUF8AMK26Q9TKgVRLxDGfCvuampUuB4VfVYuNQd	22968	3NKDnYAuj7338C7pssFtGtf2wna2FoDWPA2z7Rfgfjo141Dp3ShQ	1541	1298	429	12463	15022	jxWDSpzhjkDrmJPGuKXp63nEjrRPTXD3epn4kPGJK4eBciZKnYR	11475	16152	16152	1618846560000	canonical
22977	3NL1krQMb56bZfTuY5ZRH4Na6RkVKtGzeVTLS4DnahRa9J5qwAfx	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1553	776	430	12463	15025	jw7W3PzZMLmPvACpptGUZyTcUEvq8QcL8qDdBwFRrr2Bfp6Nftx	11478	16155	16155	1618847100000	orphaned
22983	3NKtDVAPeTkAoJfceavgXbkmDaHzyoEKDMDBBZBm7gevxjnVPLjg	22981	3NLaaah3oxPpmqb5R5PrFHgdmJVvBJ3LWUsveKGzu6uNxUD9JRqg	1650	1129	430	12463	15031	jwaWm8sG5kBMKUdW7oogot7AMdkxz7fF5asQ6NqGbjkWjKAs2C1	11480	16161	16161	1618848180000	canonical
22990	3NLGAZv8eD559BtmCVCykx3HACnYuSR2NJgRiux4EmV5uykRwaCA	22988	3NLrBFHZSrybb6yAZpFVpf2HDBBntmniME7941NybHXvDAxKHiEs	1673	1122	430	12463	15036	jxAYV71ag4Jkva8vM9hMAujrMghLDj72wLPpdxGjekJNYoJG2Fb	11483	16165	16165	1618848900000	canonical
22999	3NKmLEv9K14SYHTvg2x1J3HW5gh25KLsTjuYeb3WH9cGNjJxfbh4	22998	3NLiYBV4bCLLdUrpBtTAg7HBx5s3tAob4pTH7HoU7bK8oJodRJBq	1503	1277	430	12463	15045	jwafzs8UtwrxRF6h33wtDaBZaaRN49U5ZVCXd81AKPM6YFu5GAN	11490	16177	16177	1618851060000	canonical
23003	3NL7yWAkmLQ6bpXUwy27hKWsWwkmtBpDyNqzgWxNwvCT1kwdSEge	22999	3NKmLEv9K14SYHTvg2x1J3HW5gh25KLsTjuYeb3WH9cGNjJxfbh4	1407	1395	430	12463	15049	jxkJUdRocB6Qdp5cHVT2GYiFo6WikmVvAop5mz4YdbKxkp1SRby	11491	16178	16178	1618851240000	canonical
23014	3NKF99APmCXERASYdAZPU2FGvKqmik3ZkWGgfRazXA71nAxFX38t	23012	3NK3fA1ZagCTTsVB5Cu48iuygNBZt4me1xxxS1skyWMvp1SdwaQd	1559	1353	430	12463	15057	jx3x8sfcwypy4eKqwcwkZa9LbkZt7wzRxc2vMVmVmr9KfdDxQyp	11495	16183	16183	1618852140000	orphaned
23018	3NLKozXWWpvEu9EYmrCfzYBqrQryu3PXgiv68mvMWeqgeZX967c1	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1422	1337	431	12463	15059	jxEKt3FZVnrg8Eee9wiy6v1hr41sHJxkndDYhVCu5GdCMWXvxuc	11497	16187	16187	1618852860000	orphaned
23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1406	1393	431	12463	15062	jw89itJoVMdJMUtfDHbuvkx8NNsk5zkfKXjwWvHfanFdp9bQr19	11498	16188	16188	1618853040000	canonical
23025	3NLNsMug5ZWzDwexCXj8qRcUr8FozwPjHP7D4LuEioc1PFhetVaL	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1651	1055	431	12463	15065	jy1EA4897jzpe8KzyHoR4LgqtBUzUPaVdX5KtFH4rsUSuebLxGe	11498	16188	16188	1618853040000	orphaned
23032	3NLxdudQdApL7cuuT7oMUAsf48YR82f8DB8Q9LfpeziHUDtiWuce	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1581	778	431	12463	15071	jweTNfbS2XaMUpc4hYmkRjYKXjSapUwwcC2D6s5jurncpUwWVAu	11499	16189	16189	1618853220000	orphaned
23031	3NKKkjXiHGR4WYtYzxzgNCqYBBm7LvDveBL8XQ51YP1YWYbdiwV2	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1553	776	431	12463	15070	jxiAPNsSAMc9aVnxFXcLBQMT21CVvucR7wzmpZ7ZskvfYFfnt7b	11499	16189	16189	1618853220000	orphaned
23033	3NLVDPovZJzTpnqXF1BXLqeAq3VKpDGrfuxQkfqQ2Uvryb2iDAeo	23029	3NKLFNS3GVBA4gvJzp3p6sfPC1j9b98csYRT4KcgMjhgJyoxWU7k	1671	1119	431	12463	15072	jwqaZXjRkT5QsoovhCx7UgrMRiA57rJBwV21fzWmme7Cp4ywQv4	11500	16191	16191	1618853580000	canonical
23036	3NLHzrMonZk6Za1VjT5cxzvr3A76ifGr1Q6Xc4RjiBHi3VoqtvN2	23034	3NKKQRpimTwRT8c5uSQqdtzyCxZkMuJU4KQzxm7dg6uYKDc7m9LD	1654	1214	431	12463	15075	jxnzysJteMSS3S6Ca3VovLYcMcw1ReDLKYXr8YvXzSE7zh1j6gQ	11502	16197	16197	1618854660000	canonical
23039	3NLTwkfVLa4vUXqegfttCf6eRQgHRknnHByShPFrmAwXn8Q6rT6r	23036	3NLHzrMonZk6Za1VjT5cxzvr3A76ifGr1Q6Xc4RjiBHi3VoqtvN2	1406	1393	431	12463	15078	jxJZaycGUVntxNu1QLBqjx71hJBqnkewjiu9DXaFrDwye1pk5tf	11503	16199	16199	1618855020000	orphaned
23041	3NKf75fSrickbPguBX2bup4LVrkooRPEkB2HCJ96RwuHMHpu9Xwb	23038	3NKR7haLZrRVjqZeKnaWAPPQHTf8ZinGve97nFzC9eVyP5m866eH	255	255	431	12463	15080	jw8aocpvrYXHDcRMvTa8MDbNu6cbiLcSbcRd5FAG1HDvAAxzxVN	11504	16200	16200	1618855200000	orphaned
23045	3NLNZnMLqBDrYPSNqkFP1nbgUBHuR4qtqGjoXDPNxavp4M4foB2u	23043	3NLon3JoPNKHxRWR6tEkMPvicPopbLUK2PwdXHp7ehvbLFdJZxhL	1406	1393	431	12463	15084	jwup61B1s6cAuYaL6jAWy1ijWVwFxRaU4gYG7jRV7BeKR1qjv1V	11506	16202	16202	1618855560000	canonical
23046	3NLXDNt4Ts388um3CBCU89GTUYWS36oTZDagqoWfUCw3XdXMtQwa	23045	3NLNZnMLqBDrYPSNqkFP1nbgUBHuR4qtqGjoXDPNxavp4M4foB2u	1631	794	431	12463	15085	jxboSSz3VcNg25ypgbyh6v2Dm7R3L4nydXhZUyi7jcgStpyjFK7	11507	16203	16203	1618855740000	canonical
23048	3NKXwcaFaSYTaQ7RYWRFuF5CX12ZadLi6Hj1UsHLWhJUq2bxXVhK	23046	3NLXDNt4Ts388um3CBCU89GTUYWS36oTZDagqoWfUCw3XdXMtQwa	1642	1121	431	12463	15087	jwcUXJYTmLxJX2fbvnnEZRxrALh19a9UvBsWNg3vRDj2wnCVC5S	11508	16205	16205	1618856100000	orphaned
23050	3NKLEP1i8i4rqBUYeKHFwy7r13Uht8MXLzdbNLh4xTo4QbyBFZoT	23049	3NK4Yx2E9LtLSXosTFP7Hbc3oSdAsJcHQYsmtkjhTWVR4W6cK13y	1407	1395	431	12463	15089	jxqNnR66wk5Fhc8HcwJwxrrfvFrGnAqxSdh77yuX3uaErM4c96g	11509	16206	16206	1618856280000	orphaned
23053	3NLCDvWUeXfSyBqpTQXSGbCDbWEP8Gtf6HnQR7syJPgQ8ybDcbge	23052	3NL3hEZsA7wetfGSvvcrVqYR7gDM3bMsfN4EhpSP46zAu9AVENKG	1507	1280	431	12463	15092	jwGziFF4djJyMCg6Se1YbWpXpzbBDsKY8NbaTY6VnoYurgAZkQ7	11511	16209	16209	1618856820000	canonical
23055	3NLJnxkiC2PScsqB35z6C2YpfDqWBwgh2a4YYwHUSnCwDFdjrrnb	23053	3NLCDvWUeXfSyBqpTQXSGbCDbWEP8Gtf6HnQR7syJPgQ8ybDcbge	1637	816	431	12463	15094	jwMv97n2KFSfwtdK1kjxakdXkysLzvNv1mDPZk14ZaWKQ354mys	11512	16210	16210	1618857000000	canonical
23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	1476	1371	432	12463	15101	jwXAHn5GUdMh1vw11vFPQ1ctwBcMh4ozpvtBG2jiQ3kA36HENAB	11515	16214	16214	1618857720000	canonical
23065	3NLigHUD6Wd1Xdkny7SCECsKnuqZR7KLfoCBBmR3ygtAzt9bYqL6	23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	1489	1134	432	12463	15104	jxdpuA9PjZaxLYb2pc1wgiwVCRj2pzAsUQtxMf2qS77F8YxWEvD	11516	16215	16215	1618857900000	orphaned
23067	3NKYXCnrjTy22jjAx6WQ7skfCcGg2FJHuNHyp2Q2KEAxXqB8tRRL	23064	3NLH3eVSaFszUj6ATs5iZWKHae8eYw25Yvd35Hx5tgHz2UYmmiyv	684	1352	432	12463	15106	jxeg9yCbTfKUbNQUWHotFRewtbk488jcdwH4T6iXmuoLxphUjqF	11517	16217	16217	1618858260000	orphaned
23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	23075	3NLkzsGVsonVqsJm4X3zj4Jr11HHJnnTioP5aGWeC5V8qRvbeszq	1634	1085	432	12463	15115	jxTcL1j5fVwRrs7vJ7e1PLPrbY7uW8uU2GNuh7vwxmeP2rroWEy	11521	16221	16221	1618858980000	canonical
23079	3NLjffg37LDVa5rnNsaAj6SFySYqcMwGyGFzcEYWse4New7Xnzm5	23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	1440	1131	432	12463	15116	jxiAtLKjmeJNpMuZuzV81NZkzx6pfXdnLeStXamHtAb2FQR1Kqb	11522	16222	16222	1618859160000	orphaned
27859	3NLroXRe9JpCKQpsypg22wN9H2zdouu8wt4rMLZq4QJigUeDSJDE	27858	3NKgoHxUrnPPLnB7GrN74esidpyPNiHrB7GJqMQBEPCvU67Pzp7K	1407	1395	544	12463	18974	jwnKLnbERs3GQhN1eZezZifHWk4q85yVYK83SefyTd2FTb7cqzE	13771	19405	19405	1619432100000	canonical
23021	3NK6yjef4nbWBXFHMjyBQTUoua69kNNcMzq5Q2RGWtYUjtVbaRu2	22966	3NKKqSuQ9df8fXYH2iycrrpXfhoSQQa6vdfGm8oCYpdeEbBjejxM	1407	1395	429	12463	15061	jx9EHuqcMK99K1tvfRSbSUXgepeMcp3nKzQ96P8sMBh9yc3ev8W	11474	16188	16188	1618853040000	orphaned
23114	3NL8qpz7CSEbtEvrxHj9zgDYbT8v1PJN2xs7wDPpdNUAKjVtJkqY	22978	3NLrRKEEFGSmVAS3ZJvbvrwS872V2AFvThmz1yGkNPBmP6FrASMD	1611	1341	430	12463	15147	jxsLXuSyTDiRwhF97DzivhwTBeMAFQZxyYgb7tyjRTmBiHJ7LtB	11479	16254	16254	1618864920000	orphaned
23015	3NLEnpci3akbgawbrVnBkyPDda18MgNMNKPJVjRXENNTn7SLPYmj	23010	3NK9puE2SDfwgdEUtYrPAkZEavrQWTDdPE4MDemUFfwrkJm32kwq	1559	1353	430	12463	15057	jwCbKcj2viqtCSjLjPqvk1caG8dMh8owfkUyKnBYZXv9CJpcPjM	11495	16183	16183	1618852140000	orphaned
23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1422	1337	431	12463	15059	jxEKt3FZVnrg8Eee9wiy6v1hr41sHJxkndDYhVCu5GdCMWXvxuc	11497	16187	16187	1618852860000	canonical
23017	3NLcHhKxFetFPjriohrPentYor12LTbbirEi3zygKyYf1pEshHwH	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1422	1337	430	12463	15059	jwb61LyiBZ7pNhGL6eHkpN9LJucsYyMDUaSd29sc7T82QeJryE7	11497	16187	16187	1618852860000	orphaned
23024	3NLo1ZZPPeS3fNXZdeHKgYeLQyNbvCT1sjRXWqJz8T6XG2j1zbfZ	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1581	778	431	12463	15064	jwaC5ZKx4ZJ4bzh7YxDiJvaaPRnb9dh5syCHb7WNF5wG6ZpkVc4	11498	16188	16188	1618853040000	orphaned
23030	3NK8fE8H2CTcg5jyhQTxZifVtgMv9Mkzbz8Zuvr1cxR5tSTzkHru	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1627	1139	431	12463	15069	jxXeB55a9hhQoJFq35NRyx7z6ZwgTc15HXFtTR1QjFntoSsD5J2	11499	16189	16189	1618853220000	orphaned
23035	3NLtArZzqgciWALTDdTQjhzUAKdgaKfnhirC3y3FSPpdcDA9XZcZ	23033	3NLVDPovZJzTpnqXF1BXLqeAq3VKpDGrfuxQkfqQ2Uvryb2iDAeo	1634	1085	431	12463	15074	jxAAQmPaEU5uZ5f7CHoAvmhPhSgZozC58A1uprmaUugE5byRpEW	11501	16194	16194	1618854120000	orphaned
23038	3NKR7haLZrRVjqZeKnaWAPPQHTf8ZinGve97nFzC9eVyP5m866eH	23036	3NLHzrMonZk6Za1VjT5cxzvr3A76ifGr1Q6Xc4RjiBHi3VoqtvN2	1649	1383	431	12463	15077	jxMDsKQR9ypKQfwxvZ6qszyWdJT9ZJg6jHgZyLgiG6HgXxLLBkw	11503	16199	16199	1618855020000	canonical
23040	3NKQ7dFaYBkfyDzPj3nh17Hzgp3v5kCX4wV5eoH9at22kgA3M4AE	23038	3NKR7haLZrRVjqZeKnaWAPPQHTf8ZinGve97nFzC9eVyP5m866eH	1407	1395	431	12463	15079	jwvmEKLsCyiDTBnAXCWvd5HP2uVVZqvpWZr1vnokE33FhekJkHC	11504	16200	16200	1618855200000	canonical
23043	3NLon3JoPNKHxRWR6tEkMPvicPopbLUK2PwdXHp7ehvbLFdJZxhL	23040	3NKQ7dFaYBkfyDzPj3nh17Hzgp3v5kCX4wV5eoH9at22kgA3M4AE	1613	1223	431	12463	15082	jwBycJXe1PCS9iUx6bEsr9KoAVnAZLMcMmX6UFMCmbA5acSS8qo	11505	16201	16201	1618855380000	canonical
23052	3NL3hEZsA7wetfGSvvcrVqYR7gDM3bMsfN4EhpSP46zAu9AVENKG	23051	3NL976V5GpV1UDt2oXNVuyecwFe5Fn8WEULMLyo9aNx6REs4iGEc	1454	130	431	12463	15091	jx2ZZ28TEPFTRRWAk49Vg5MY44REuWm9Z2y3okQhzs2xVVgkQuL	11510	16207	16207	1618856460000	canonical
23060	3NKjP5H4vgXWobfW9TD5uY1DzHqb9n8eFQt75V2gZJ5Wo9Zj5EXm	23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	1405	849	431	12463	15099	jxVfX8gmPxQHoBgyqzu9fGoc4YPvP7sCxKbCyjJKUR5qSAhh1C3	11514	16212	16212	1618857360000	orphaned
23089	3NKHgN4VoSAoZik5YxckkgZ6unrYpkiAKwL5DwzPB3MbUmZYcHrZ	23060	3NKjP5H4vgXWobfW9TD5uY1DzHqb9n8eFQt75V2gZJ5Wo9Zj5EXm	1623	830	432	12463	15124	jwWifpT4JMTM7Pc9ZoQCvTXtQukTrPTuCNKF52MgBnuFfpUM4q1	11515	16234	16234	1618861320000	orphaned
23064	3NLH3eVSaFszUj6ATs5iZWKHae8eYw25Yvd35Hx5tgHz2UYmmiyv	23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	298	1182	432	12463	15103	jw8Tr3VXkW52kc7QipxQqEFBomsZbqVNyTNhdBe3yH3HYvAW88k	11516	16215	16215	1618857900000	canonical
23071	3NKbdn7BsdM2UiDGCxEMTABJLGwj7FL28sAAQQDTjrf9sUb6Fhae	23068	3NKW6mkKCKAqq6H1EZQZJsj5sHmUpW9Ao1LcPUnbAuPgv2pbTbKS	1522	1322	432	12463	15110	jwnvNtBXhizodmHbNNd63RNSiSxcAPBzNgHbiTY1ctGCnzAvETh	11518	16218	16218	1618858440000	orphaned
23075	3NLkzsGVsonVqsJm4X3zj4Jr11HHJnnTioP5aGWeC5V8qRvbeszq	23072	3NKaEM3jkCyf89TkypqBafGGuMGEoELA9yt32puN8sxrHWs75Lqt	1637	816	432	12463	15114	jwMzpsYaHbSXRaL8Vy8ipMC6mUcGyQtgwq8htpgiaUeTXrLcUDG	11520	16220	16220	1618858800000	canonical
23078	3NLwRTTGE3114DQtNpgj5283DXaU8W7KGHVNPypV8SHX275nGJT8	23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	1440	1131	432	12463	15116	jwnVhziHEJL1a58pFf7RB4kqtbmeU51XXMBffYeoJ41GnqfXVpK	11522	16222	16222	1618859160000	orphaned
23080	3NKKxdaVG8mBvPtQxLvGQzrkviiCDHFSKnUNQMgoyymjU3cs6qAs	23077	3NKSZkNEMtYqEcTZdr5sDVk7AdZQfuzS1txN5k1JRvscApuvwykv	1451	1292	432	12463	15117	jxbCm8Y72wGvYuRdzLCMLW93Dzq7mgN39pBJBPZHhq2cHGHgYNJ	11523	16223	16223	1618859340000	canonical
23117	3NLDQXcXKMu5N9HPXWcS9aaqh59KmS5TA2hXpNcge4oK8Yg5qiKF	23081	3NKB4sbNmG7beWZUiBPs3bQRtEpFYQhjda7ukoN7ZjjAKGsYJkF5	1577	1327	432	12463	15150	jxZRctuaQxcbLYmTtNTg3DKYGWaim24G3JQowhGE6uZuyXzfy8J	11525	16258	16258	1618865640000	orphaned
23083	3NLb1yGqJBhHvBQLU11WYExCjBgAC1p6VHXoCwkfnCj69Kog6Q5r	23082	3NLqq8e46CGA2Ubtw2jqjdio2ZAge6jNdp5fUNp4Nh9jEFmLBQQQ	1637	816	432	12463	15120	jwjLvH4PLzZ1qZq2SyGbyrdceuEH7x8oyxisjArcTXEegqjJYXN	11526	16226	16226	1618859880000	canonical
23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	23083	3NLb1yGqJBhHvBQLU11WYExCjBgAC1p6VHXoCwkfnCj69Kog6Q5r	1403	824	432	12463	15121	jxw2yMhx45NdWykwpMYzWTDYpfkoHjzpeXrt3zFJG294Ra8pJ2g	11527	16229	16229	1618860420000	canonical
23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	23091	3NK9YA7RhA7kPyQJ69bbmW6T8ctCc88dRt2X7GRGf5xt5Y3cZ2ah	1654	1214	432	12463	15127	jwgF4RyxBtrF71B9twZu2DEUZ6ihyYELGseDLvQ9msctcTrmbG5	11531	16237	16237	1618861860000	canonical
23095	3NLa4uZM5EBqmW7P6LLWrYWQtTz8tYzhVsXNq6qp1y1CzTMq1n98	23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	149	917	432	12463	15130	jwxFhwwyttkhYJ2nu4QybrwssyU4L9Dq8DQ1n88QThKbcsqpHpr	11532	16239	16239	1618862220000	canonical
23097	3NLoSDx58QWDS1MX2L7DikfZ72GM3brE6n78dbxgZfuUPFE5ed1n	23095	3NLa4uZM5EBqmW7P6LLWrYWQtTz8tYzhVsXNq6qp1y1CzTMq1n98	1474	1083	433	12463	15131	jxA6RbfkwJRQxbGgQJibBy7tJ2fh3vuL4QLgsEsWLnT8g1kBkwp	11533	16240	16240	1618862400000	orphaned
23102	3NLDGppV3488Lyzdm11Syrv9oZUzWshratJDKazgSX8p1zeUYm18	23101	3NK7thHh9puDnRBojoE3thd78yUuJvTTNz8pfdbM5jjw7EAFBsDi	1601	1388	433	12463	15136	jwMd1vdA1AWMoQj1RdYDUHg7wDJo66aXgRtUjEthxVuf458zbAV	11537	16245	16245	1618863300000	canonical
23105	3NK5WiRdrL7MpWGFX1zVTXCFxFvuECUNRkQZhddfAqJ9PLFw3tkt	23103	3NKGJ8WEH1NgV9Ca2yFEkq7y1udZ5iCndQJhhCo2F5fxUXagXXWZ	1474	963	433	12463	15138	jxWkjKNkWbQNwJF1BFyzVziyZotHk1UUoyqLCnM9FMroT9uUkEH	11539	16247	16247	1618863660000	orphaned
23107	3NLLnKAxaz7KBJAFL1rUUNrjCDjmbDzkVQ5BWPzCEb4SHs4s8CrS	23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	44	1325	433	12463	15140	jxYpchZMKivFcKDoB719HBM4ovFrDzHccZC9495gs97AYg2NpQf	11541	16249	16249	1618864020000	orphaned
23111	3NKifkMtzUtFyjr9DC53beiSG4o5BJEJH6rvYisg3saebw3rGrDu	23108	3NKDEJQ5z6eCZSYp1NK8b9XXfBpbv62ZgxkH2wVZvzXMjLR8aAgg	700	840	433	12463	15144	jxMDy6i95621qvnzrQmu9cbyZ2gmygMNejuFZSkXTE6j92rPTic	11542	16250	16250	1618864200000	canonical
27875	3NL5igrMxismx4itCpmJLtw7jR1kQ61NqUbz6XyDsrdFn945uiSr	27872	3NKMDy7DFcXdYRWFXKSd7QV3dCWas24Xp7mxgToMsB2cgFmZXzDh	149	1283	544	12463	18974	jwAHhUHTjiC8ojiTsqPxyxsJQ5N6yW6XqACBwTu3TyWZDt25Dsq	13781	19416	19416	1619434080000	canonical
29295	3NLWQrtzEkN4sepxTn81y8RRLXp3P6bQxKptFfzGvSs1wuEGgBC8	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1471	1260	574	12463	18974	jxa69qiffQ3GRREDsytWzJc67vww8EL53b8fogJfNa4szrfXo6j	14435	20328	20328	1619598240000	orphaned
23029	3NKLFNS3GVBA4gvJzp3p6sfPC1j9b98csYRT4KcgMjhgJyoxWU7k	23022	3NKieeQ4iGyg5CE4dSVt4QQ1h8PD1ydHUHUzKWL4cvMdmbEyYpS2	1407	1395	431	12463	15068	jxLPpvhcD7hCSynxzRg1Mb4C7XdrGvQdZSTs1qu4nSXw6K8Gnk5	11499	16189	16189	1618853220000	canonical
23034	3NKKQRpimTwRT8c5uSQqdtzyCxZkMuJU4KQzxm7dg6uYKDc7m9LD	23033	3NLVDPovZJzTpnqXF1BXLqeAq3VKpDGrfuxQkfqQ2Uvryb2iDAeo	1617	1288	431	12463	15073	jwXX34GtuAeh5VvrxF9VBX7TNkLiQnBSovuL7ibPSH1HQiXjRZi	11501	16194	16194	1618854120000	canonical
23037	3NLEFWMNwSFF4Zs2VNpKaE7RuuBfbsCRnEck8KVYBibVZh4Q1Phw	23034	3NKKQRpimTwRT8c5uSQqdtzyCxZkMuJU4KQzxm7dg6uYKDc7m9LD	329	329	431	12463	15076	jxNiAvKqHvU92sAzcdYzDvw2U99pHmSoxwA9rLj1egkKmp2LrjS	11502	16197	16197	1618854660000	orphaned
23042	3NLNXLcwQHRvX9cq2nFozxxARWo9652hATHTn9rSW8Wt6Pejjpwk	23040	3NKQ7dFaYBkfyDzPj3nh17Hzgp3v5kCX4wV5eoH9at22kgA3M4AE	1439	1279	431	12463	15081	jx1uQCAmrpstj7jPasoXdtVhDEbFVSruKGECtr8br1pqQvTTNaY	11505	16201	16201	1618855380000	orphaned
23044	3NLngcrmCCHNjYnDFR35yAEX59BxRCz6AN1B8NccpEicxjLhJrZV	23043	3NLon3JoPNKHxRWR6tEkMPvicPopbLUK2PwdXHp7ehvbLFdJZxhL	1627	1139	431	12463	15083	jwyVAt3VMBA7iBBgnUECs8K4p2vkFCSYnPAmq7PMxZTkfkpHtR7	11506	16202	16202	1618855560000	orphaned
23049	3NK4Yx2E9LtLSXosTFP7Hbc3oSdAsJcHQYsmtkjhTWVR4W6cK13y	23046	3NLXDNt4Ts388um3CBCU89GTUYWS36oTZDagqoWfUCw3XdXMtQwa	1522	1322	431	12463	15088	jwybmLL2yqRNA2UdPgQDYYDBGYEQnYTYUdBddNqzRDL3hkgZB5d	11508	16205	16205	1618856100000	canonical
23051	3NL976V5GpV1UDt2oXNVuyecwFe5Fn8WEULMLyo9aNx6REs4iGEc	23049	3NK4Yx2E9LtLSXosTFP7Hbc3oSdAsJcHQYsmtkjhTWVR4W6cK13y	448	1305	431	12463	15090	jwjRoSoWaJkQAzzWLNiy3Lg7376gA78YQ6h7AgencsVafLKHnfJ	11509	16206	16206	1618856280000	canonical
23059	3NK6SXHZA2bsnzXLBLZ4kaR1e7gjMh6PK2FKqyV4ZMiHo6jnwvXj	23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	1522	1322	431	12463	15098	jwbMhyvq3qX9YMHRAYL8EnwCXmgq8EFTufD91aX9VT4fDeFZ8zT	11514	16212	16212	1618857360000	orphaned
23068	3NKW6mkKCKAqq6H1EZQZJsj5sHmUpW9Ao1LcPUnbAuPgv2pbTbKS	23064	3NLH3eVSaFszUj6ATs5iZWKHae8eYw25Yvd35Hx5tgHz2UYmmiyv	171	1374	432	12463	15107	jwGpEYJQaB58XYWjPhdF9aaLeWndCqSfP2RGcmy85H73FH8JqHh	11517	16217	16217	1618858260000	canonical
23070	3NLoq18neqipLpSHggwpTbxMTY9Jn9F6925AiVaPLof2kYRWrW52	23068	3NKW6mkKCKAqq6H1EZQZJsj5sHmUpW9Ao1LcPUnbAuPgv2pbTbKS	1627	1019	432	12463	15109	jwwPezDBMsWgQ2vhLwop7USyKRWo5oSQxPyMWaUG6igsKvgx2Jk	11518	16218	16218	1618858440000	canonical
23073	3NLC3uTopUVM3dS6Hn1E3thkEDJJZqYv9gdkdiogqr6cdL4Nvrdn	23070	3NLoq18neqipLpSHggwpTbxMTY9Jn9F6925AiVaPLof2kYRWrW52	1419	814	432	12463	15112	jwTJ3TA1J4cXbcxNMnQAN9N2aACFqVXjQowjKwYKfrqNKghx3Lh	11519	16219	16219	1618858620000	orphaned
23077	3NKSZkNEMtYqEcTZdr5sDVk7AdZQfuzS1txN5k1JRvscApuvwykv	23076	3NKeD8qJhphxNW67pV3WZb2mzJKiw6dirfWDjbXqE4NgAfRQD7pU	1440	1131	432	12463	15116	jxvwHZxua8u7LmZeM65pgEAUwRuKvW2JDaPrd5hpeAftUPRa3RJ	11522	16222	16222	1618859160000	canonical
23082	3NLqq8e46CGA2Ubtw2jqjdio2ZAge6jNdp5fUNp4Nh9jEFmLBQQQ	23081	3NKB4sbNmG7beWZUiBPs3bQRtEpFYQhjda7ukoN7ZjjAKGsYJkF5	1407	1395	432	12463	15119	jwbfPQwVC8VFiaGvDz2sou4offkSf16KYBbVVJRchpTK3ASmogs	11525	16225	16225	1618859700000	canonical
23087	3NK5brhqsWUfR7wKTMkgPfJxea5mCHvQjnDgktjUJP9inv1n16NH	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	1651	1055	432	12463	15123	jxgz2V2K2WWZjurq1jJbTbtDF6tgdbnSaRsw7VuqhrkFj5nf3cs	11528	16230	16230	1618860600000	canonical
23086	3NLs1qkvFabiGfXgCPTNvbPb4uvKPEtw6nVnXpCseTDeMnnYrexc	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	563	1113	432	12463	15122	jxcmdr1oPeqzN1CJsdDBL4ToQYDd2UZGQ8DzxxiKnCUPUWUt1zW	11528	16230	16230	1618860600000	orphaned
23091	3NK9YA7RhA7kPyQJ69bbmW6T8ctCc88dRt2X7GRGf5xt5Y3cZ2ah	23090	3NKeaBtVTZnanj7YA4iET2LqX1oz98Huj7CNTbvL61doPdPD28eC	1610	1068	432	12463	15126	jwAyYmDSTbfQhbsnj4AhUH7rsc9aGvNKTk3G9rNPG4U8i7T4xxp	11530	16236	16236	1618861680000	canonical
23094	3NKxhuNEgqz3csG9tcgXXyqSespzxs4Hbcf8DGQs1JzQ4SYfrduc	23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	1405	875	432	12463	15129	jwn5Ka9J99LyoykeppqB2hNrkdcCduzrWyuBw98K3TAiCSMYcZs	11532	16239	16239	1618862220000	orphaned
23096	3NLZVWn2qER5g2Gwe6q2kNYqEnWgsiR5uhxzTnAytxAiEBoe1RCc	23095	3NLa4uZM5EBqmW7P6LLWrYWQtTz8tYzhVsXNq6qp1y1CzTMq1n98	1474	1083	433	12463	15131	jxUxsHqEdgoS8g9aqJVQWJ2AyE1MrPSUZGkPvtiDR8DBKGnNGyG	11533	16240	16240	1618862400000	canonical
23098	3NLf42BGmfATmVmtq8SwFBBoSLodqHGkYjgUKZfTopxtDtVazt4B	23096	3NLZVWn2qER5g2Gwe6q2kNYqEnWgsiR5uhxzTnAytxAiEBoe1RCc	1637	816	433	12463	15132	jx2mdpfFAENwGLAbGqjSKSd4EqbdXEc9LiJU8NqCzAbt8nwP7hg	11534	16242	16242	1618862760000	canonical
23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	23098	3NLf42BGmfATmVmtq8SwFBBoSLodqHGkYjgUKZfTopxtDtVazt4B	367	367	433	12463	15133	jxiUMdWQgZwrisUFjqnLdL6fguYyoBhpMirag4i4N7e5E6fHfZM	11535	16243	16243	1618862940000	canonical
23101	3NK7thHh9puDnRBojoE3thd78yUuJvTTNz8pfdbM5jjw7EAFBsDi	23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	641	1210	433	12463	15135	jwejnaBFS76ZKgfdXZYNuXLCm6RY2cjkidgMi7m1s2HCKFPKpzX	11536	16244	16244	1618863120000	canonical
23103	3NKGJ8WEH1NgV9Ca2yFEkq7y1udZ5iCndQJhhCo2F5fxUXagXXWZ	23102	3NLDGppV3488Lyzdm11Syrv9oZUzWshratJDKazgSX8p1zeUYm18	1406	1393	433	12463	15137	jwLoRKJMna1nfbc9X15PB3sLu83LnWvheEgzrdsP8JsjfU3wYXr	11538	16246	16246	1618863480000	canonical
23104	3NL6R4GTnYqCcuKfxhHW8DxJPz5ewxyVjffEdZof5Qdm7XTp9pSr	23103	3NKGJ8WEH1NgV9Ca2yFEkq7y1udZ5iCndQJhhCo2F5fxUXagXXWZ	1474	963	433	12463	15138	jwzuW5ijj14YXDn243VLipLKkuSGztziKN21rQk5Gj66sSvxSUa	11539	16247	16247	1618863660000	canonical
23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	23104	3NL6R4GTnYqCcuKfxhHW8DxJPz5ewxyVjffEdZof5Qdm7XTp9pSr	1403	31	433	12463	15139	jwh8px7hLWFEK7mhqbo84bDacPnC4YQThhqP8F4C2CDVgTFA13f	11540	16248	16248	1618863840000	canonical
23109	3NK8FtUfomftuVP2HngnUpDRzTfojZrzYTWt8x4BuWbzdU2QbpfR	23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	1637	816	433	12463	15142	jwvA8mRNmF6UJPPUaqyfFKD1FUzvX4eNe5FDRJmwH1dmMnufm9T	11541	16249	16249	1618864020000	orphaned
23113	3NKNcRWi2iZnFaLvvJQwQ8SVY7PXBuiiEACRuc19sC5L2r5DAL3A	23112	3NLoHYLmQP6xpFpVsL9Q1XBFFghq3uXfNsLJy327mxGL64zRTuFg	606	1049	433	12463	15146	jw7Rr98EtYrgGgWxFW6MCYrep4Tm2XnuXFnkgpE5LgJjWkEHHbN	11544	16252	16252	1618864560000	canonical
23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	23115	3NLm7Ay58sU9Kyjpoj2xX9NwuGMEcYFv7EDi1gkaMhbp96VGTqoz	1407	1395	433	12463	15149	jwXrrYKsGvK7H5iuejCbwnXRpQjf63tBV7Uw1Gt97U4dWG96d3L	11546	16256	16256	1618865280000	canonical
23121	3NKXEhBCwVp3wQKi2Cv98xVMdypN8rWTsWMwqkCmY3Qz5RUZqrmf	23120	3NLnH6tW2GQgqaQrE9bC93S3YHkkV3PaJXhBucWWu9cBoNeAoruS	1555	981	433	12463	15154	jwEetcWh2ZqHJ6cE4pRQxHHYFPhhoKXsGvypSLtZ1sWzWE7zQR5	11548	16259	16259	1618865820000	canonical
27878	3NKPuTcdBsfwq73Tyys8zR3grVLoT6QV7PAsR8g5D6v8miF8Z6HT	27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	1406	1393	544	12463	18974	jxRvZoZ9uTYd5tK5grQAWY4WbEZfujYph1KuzrAmwWA4iV9fJvk	13783	19418	19418	1619434440000	canonical
29302	3NLseYX3ARtfp8gRivCK6Mhw4tts3RJ5xZCZYrWgkg35MfhUbtrT	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1407	1395	575	12463	18974	jxB3CunCvsk4m8HiQ2fg6CeHHxXF44V1bKuevMgF8Qu287YHGTt	14438	20332	20332	1619598960000	orphaned
23063	3NLETEujrUuciXAGBiNN9316Y22iaC8QqYSD2bTWFPZ8YPpj3oe4	23020	3NLKSBk3iDPq95NoFVsH6Go1pckxZtDQJ2YvSLqH9Gjz4gu6nuMS	1593	1346	428	12463	15102	jxJYYXtzG1b3zc77pdAbhBGpT1SW9WM7bZPGirj1N1y4tZ9nYrP	11456	16215	16215	1618857900000	orphaned
23054	3NKRPApmNgNdNEeUsMYZr4Dit4L2Z1W7yiiQaz41WoPW8LpZbhs6	23052	3NL3hEZsA7wetfGSvvcrVqYR7gDM3bMsfN4EhpSP46zAu9AVENKG	1577	961	431	12463	15093	jwzUNd6A6zv1hA3gu1R6aeJs1WAFNHupbXhWCMFVcR6jvVQxLHN	11511	16209	16209	1618856820000	orphaned
23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	23055	3NLJnxkiC2PScsqB35z6C2YpfDqWBwgh2a4YYwHUSnCwDFdjrrnb	1649	1383	431	12463	15095	jw74UACcq5A8fHX15BadunTg3nG1ryyC2b8kXM3cQnxRaSNC1XQ	11513	16211	16211	1618857180000	canonical
23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	23056	3NLoJzKdsc2osswt8VWiLHvMaP2Xue4LBNwJKuzbdPiVQEjumkQ9	1406	1393	431	12463	15097	jwKdmuHYEMvvpTwsuVR5gG92HFmgC4RC4KDfuPXzXSvNr3rCFiT	11514	16212	16212	1618857360000	canonical
23066	3NL2UvQcqjK5q8Xm7hozxEMYmfEafLAMCjjPRiCVmMsjECei1gk9	23062	3NLD8ZkgiF1aLmcZfyYZQ2hHfjqcVdYA3t71vB2yGGWt56ni3niZ	1593	1346	432	12463	15105	jxEjxBdrFR3qDtA6PLKAuAc19cFrPbnms1q79YuBpELSzuLNKqA	11516	16215	16215	1618857900000	orphaned
23072	3NKaEM3jkCyf89TkypqBafGGuMGEoELA9yt32puN8sxrHWs75Lqt	23070	3NLoq18neqipLpSHggwpTbxMTY9Jn9F6925AiVaPLof2kYRWrW52	1458	957	432	12463	15111	jxZAqbb1shLz7aAzPFpnqAPaCxwjBUYAF78NZWZTeZNE2gQJrNu	11519	16219	16219	1618858620000	canonical
23074	3NLrQ4jFp8PCB9C3nQ1HFbBsT2sTe4RHN1cAN3sWrRSqgAaqv4mx	23072	3NKaEM3jkCyf89TkypqBafGGuMGEoELA9yt32puN8sxrHWs75Lqt	1406	1393	432	12463	15113	jwqLxfzmTGNvPY67guxguKAqsTRAJtd9m97MZxDDfyVeb9vBKPF	11520	16220	16220	1618858800000	orphaned
23081	3NKB4sbNmG7beWZUiBPs3bQRtEpFYQhjda7ukoN7ZjjAKGsYJkF5	23080	3NKKxdaVG8mBvPtQxLvGQzrkviiCDHFSKnUNQMgoyymjU3cs6qAs	58	1281	432	12463	15118	jxoksMmQeX4KsEvyj1EKMZhjCe7sVti3Y2c7msH1fXHRKcHMpZ9	11524	16224	16224	1618859520000	canonical
23093	3NKeXwj9ct72PS64oKw1hjxauLtVAdDFPH6HE15uZ5bUxXYoVboM	23092	3NLSeF3w6QNcHTgwqdVYzsjPrRKAGdyjCWea6BNbEUYaSFNdPfc7	1407	1395	432	12463	15128	jwaM3YsgShTUrfBwpCNZuqj8FdK4czUH6wA2aczkoKX9HHCaGsP	11532	16239	16239	1618862220000	orphaned
23100	3NLczyaqbcUWdaeK7XYmvQ2ZRotZteGNyYrgHArwX3A7eUPzLnxj	23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	1581	778	433	12463	15134	jxdmcrnZLZk1HbFnZ2a815qu2hbgoMSACxBZCHMkxhvoyEou3sV	11536	16244	16244	1618863120000	orphaned
23108	3NKDEJQ5z6eCZSYp1NK8b9XXfBpbv62ZgxkH2wVZvzXMjLR8aAgg	23106	3NLt8UtFGrsA1dZckXUbUUFDHqwLZW6FzwT2Ho47arMzUvCdQx5e	1672	919	433	12463	15141	jwV8YAjzgKkmLcr5WqKCbQ6WMguYSykG6UPVd4GoQRwQ4zMdgFu	11541	16249	16249	1618864020000	canonical
23110	3NKT7paja4NFwAAh3DU7RAocegxkpQvMDZWDjBTQz5xtED2B3ATD	23108	3NKDEJQ5z6eCZSYp1NK8b9XXfBpbv62ZgxkH2wVZvzXMjLR8aAgg	1553	776	433	12463	15143	jxP1ehQBZEGx3gxyhCvaG2QqHCDqkmo9HTCpxABZRXwoeReG8Ys	11542	16250	16250	1618864200000	orphaned
23112	3NLoHYLmQP6xpFpVsL9Q1XBFFghq3uXfNsLJy327mxGL64zRTuFg	23111	3NKifkMtzUtFyjr9DC53beiSG4o5BJEJH6rvYisg3saebw3rGrDu	1406	1393	433	12463	15145	jxBib8m6Yox587oZhRvHz4p27coyz7yr3GM3QSD8duneZsoznbm	11543	16251	16251	1618864380000	canonical
23115	3NLm7Ay58sU9Kyjpoj2xX9NwuGMEcYFv7EDi1gkaMhbp96VGTqoz	23113	3NKNcRWi2iZnFaLvvJQwQ8SVY7PXBuiiEACRuc19sC5L2r5DAL3A	1624	1208	433	12463	15148	jy2xnWLF1rXzyumZyNQTavUKy2SVfCq6r538Rp4W9PK11qYhDB3	11545	16255	16255	1618865100000	canonical
23120	3NLnH6tW2GQgqaQrE9bC93S3YHkkV3PaJXhBucWWu9cBoNeAoruS	23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	1577	1327	433	12463	15153	jwcUjj2ih14a7AQty4w1teWzJsdmHpjJxGsWMnXCcYiTggNHmoV	11547	16258	16258	1618865640000	canonical
23122	3NKJhLi5faRRKoJSz1Rz1f4Vb59Uhbfohaz9fM3t8VxPiRfaiSvX	23121	3NKXEhBCwVp3wQKi2Cv98xVMdypN8rWTsWMwqkCmY3Qz5RUZqrmf	1633	1390	433	12463	15155	jx4Mzrp86pyCB5zPZTy6X6pPy4eWZ15LKVwEqeEimnpyUYjBTcW	11549	16260	16260	1618866000000	canonical
23123	3NK3FCy6veNJYy9Mnj36gBZsBE61zMDLBqQqKb9yyCS5MM3Av69A	23121	3NKXEhBCwVp3wQKi2Cv98xVMdypN8rWTsWMwqkCmY3Qz5RUZqrmf	1650	1129	433	12463	15156	jwoHjuGnfkponxWFMGdp1fHHdLbEFAZ4eRX83vwbE21v5wkvfoE	11549	16260	16260	1618866000000	orphaned
23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	23124	3NLexbgzgbB5Bph6TTUmRDDjm3PpNCVNNNLFsmKUzAaA5RYswUKH	484	1319	433	12463	15158	jwb14afwT7TsJcWHDaYu3ueTz1fQ2gcvUzZ8a3H5zU7zyiJJ7Hx	11551	16263	16263	1618866540000	canonical
23129	3NKQcGMAMg3Jc4detmD5qEejgcYQWyEb8JPkhAvNWusvtc3kdgsc	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1483	570	433	12463	15161	jwK2GKKFMxPnvXF23FdXqHnCtmijNqScWDSiacx6nVcrSfFh5G4	11552	16264	16264	1618866720000	orphaned
23128	3NLQck9qJwEVvyn2c2TpGnpipsJJLBVoQt6P5LtesiHkxgPzaM9E	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1579	1389	433	12463	15160	jx5JV1CsZCnuEQCnoiRW9Y6qVSJyyvmSPaqae59vZeNQb3xNdnE	11552	16264	16264	1618866720000	orphaned
23132	3NKzDaZUNQC7rHWXfd3HdURSyhJz4uYC8uXftEjx6w2RRe3pKEZt	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1460	430	433	12463	15164	jxpUnKZDGo6MaJyTQEhhpZCcJDqRLsCd6YY9rai2VAre5rCoaZN	11553	16266	16266	1618867080000	canonical
23133	3NLvK3AXkKcrC77ZxEfsdXth2NQqNfSCdxmsN55uNvaQuWxxyovW	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1460	430	433	12463	15164	jxeHkWGnyFqz8cHbCegLbBtLRtBVuqbJzWpLASbQoGfusjTx879	11553	16266	16266	1618867080000	orphaned
23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	23132	3NKzDaZUNQC7rHWXfd3HdURSyhJz4uYC8uXftEjx6w2RRe3pKEZt	1490	1274	434	12463	15168	jxLcTKUT674ZzR9TzV9r5vizr6q3zp5VKQsLwyunSMgW8AuscJh	11554	16268	16268	1618867440000	canonical
23137	3NLcSBEPfWCN37fsVvnQ1sTPKps5Euks33c8dxHoAtv4ATzBHXj9	23132	3NKzDaZUNQC7rHWXfd3HdURSyhJz4uYC8uXftEjx6w2RRe3pKEZt	1637	816	434	12463	15167	jwG8JfHtGLQ66qec2sNCfEv1kQw6DTdJCwQKWjcT31SJ36dD7Hs	11554	16268	16268	1618867440000	orphaned
23139	3NK5gSDscV6Qkh6HTgNimWN9tpBehE85rb1ChovbgjMm7H317AYx	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	684	1352	434	12463	15169	jxK5XCQeeDvyiwwFAKbgiQb4usKP8zdAT72Aot1ZgZy7UQgtDFW	11555	16270	16270	1618867800000	canonical
23144	3NLgYGkHkbR4wayj6vTsSSSsVUKsr22KpbeDETe8jECpyc9kLcNR	23143	3NKUPMieVFLzgXo3CqCQWLCC4YdXuYoCvt8ALj35gEXHXyk8ztWp	1407	1395	434	12463	15173	jwmdYWuKAhVDM5cjAR1t7t5m6A498v2Rci63Np4RtMm1PTyN9Pa	11557	16272	16272	1618868160000	canonical
23145	3NLkeTw3PUnJ5AWCvJCAexQg9ZwSyDk1ZjM7wCJy4RnZTYXFzyvM	23144	3NLgYGkHkbR4wayj6vTsSSSsVUKsr22KpbeDETe8jECpyc9kLcNR	1407	1395	434	12463	15174	jxqDHWMM18Ff91Vx4aTQLJu2qYkjsZvBEoXSExDboQtunzC9bgc	11558	16273	16273	1618868340000	canonical
23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	23146	3NKCkQzpvpRjstVqW68Zr5uzHqT7Xfg7xajKTkSZTnFcvy3c5HNH	1407	1395	434	12463	15176	jxxoA1vzpotjMvQDrSNJJ5W5NNGGQceyTScekq6ywCSzCSG2wd7	11560	16277	16277	1618869060000	canonical
27897	3NL1Lft6wdVcfGrDWAB5XyVrpzcqenYpfGmAunjZfja7WbyMqRgF	27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	171	1248	545	12463	18974	jwSVVpu9qrEDak1xzkj2jqwkZcuGr17j6x9Vii1J8vqEKsUQWnF	13793	19435	19435	1619437500000	orphaned
23179	3NKmLio2WkwcHBhVb4JFBEwLLMXD3ePjccirFHX6nSYJe9VLdbaL	23102	3NLDGppV3488Lyzdm11Syrv9oZUzWshratJDKazgSX8p1zeUYm18	1518	787	433	12463	15204	jxr3Xpx5SDDq5ipnwAcGNZvwZVinzu1NcbHiRwPm6mSnBA6Xgod	11538	16296	16296	1618872480000	orphaned
23124	3NLexbgzgbB5Bph6TTUmRDDjm3PpNCVNNNLFsmKUzAaA5RYswUKH	23122	3NKJhLi5faRRKoJSz1Rz1f4Vb59Uhbfohaz9fM3t8VxPiRfaiSvX	1631	794	433	12463	15157	jxnZYt12LpdbfZ1KX8YPUrEnBL6BjnzT4aRk1aoC2QmqxYcEE4d	11550	16262	16262	1618866360000	canonical
23134	3NL6LPgoiWGMd9KjQgVL8UZq7dYZLdKYhE4ZZucHVfYE2pjH457N	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1460	430	433	12463	15164	jxeHkWGnyFqz8cHbCegLbBtLRtBVuqbJzWpLASbQoGfusjTx879	11553	16266	16266	1618867080000	orphaned
23142	3NKomskqHonzfnX48gYzJKFmEBpVoUmHsEcMJCR1x2U5xEHCMsUt	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	1651	1055	434	12463	15171	jxrofKMhUKKj3bT8WSVtm21fUAiJz2ibZyt1udq3jRwfDXTiTbn	11555	16270	16270	1618867800000	orphaned
23143	3NKUPMieVFLzgXo3CqCQWLCC4YdXuYoCvt8ALj35gEXHXyk8ztWp	23139	3NK5gSDscV6Qkh6HTgNimWN9tpBehE85rb1ChovbgjMm7H317AYx	1476	1125	434	12463	15172	jwtvcj3vLfXV1LqzCp9ypedD5Wsfx7gN1pXfS1YdkYaz3Xwbr32	11556	16271	16271	1618867980000	canonical
23146	3NKCkQzpvpRjstVqW68Zr5uzHqT7Xfg7xajKTkSZTnFcvy3c5HNH	23145	3NLkeTw3PUnJ5AWCvJCAexQg9ZwSyDk1ZjM7wCJy4RnZTYXFzyvM	1405	873	434	12463	15175	jwo5uEA1yFin5VuxV8zT1i6FsGHFyoVVN4avyTCzVQ3KgDwimDh	11559	16274	16274	1618868520000	canonical
23150	3NLGNqreEkiDEoViyseKD2ksYC7rSGU3D9MENVnkwZeWZj6VRwfN	23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	1419	814	434	12463	15179	jw7jR5oPt1dj2JRLtCsziDMFXnat6SPT9iygMUYfK5sbi5TStsz	11561	16278	16278	1618869240000	orphaned
23148	3NKXuwBQUVGmdCoM2bHoA7ywmXjMsHZ15PEqa2sDaPKUKGAkdbQP	23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	633	1018	434	12463	15177	jxqjTPD9pzYRiy5ZTKVFRkE6eH7uUvkiEwv31H1NF2aTbGpnCNp	11561	16278	16278	1618869240000	orphaned
23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	23149	3NLVGwys8CN2Uud1Xk52r21sJCitKc7C4mYDgaX2RSqNyiUq1bej	641	1090	434	12463	15182	jxTGzPHxanBnnotorbPfZuvr1CH3XQKGyPhjveGnrpdH9mEiDft	11562	16279	16279	1618869420000	canonical
23155	3NLZo2T3jizCGBGirqYpkHHD2HdNWkbf7NTnUZqp5sQ64bpzTBJ6	23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	1633	1144	434	12463	15184	jwHDMTL8i5f4w83yjemQA1kNsv31uxgP6BQDgxyhaUVujGQwVZ8	11563	16280	16280	1618869600000	orphaned
23158	3NKn9KqxsaJT2us223smZHNs1YKLyUQpofRo5dWeg7CcTGnp5DCw	23154	3NKVCnpX9p1tpn5NrTsJ2YDAG1e5bzRPEW4fwb69PubveY17bKkR	1649	1257	434	12463	15186	jxutQ88YN3A66ci6dMHyWRKNZMLDUPTTJF3cqysxBvm3RvKoqc1	11564	16282	16282	1618869960000	orphaned
23161	3NKGGg9tWY68LsBbEZKjB6v3uVSU8Vzy52ew7s1nho4WHaLSG4BK	23159	3NK45j61ynPXfTefQGpGa7ipd1kb91TPyWKnDxfSFPUFVrw76Y3M	1440	1377	434	12463	15188	jxsLyC5ZBfbQ752uvae9rzvzhYZodJxGbh1FhcWp9oZrCBQ6Q6Q	11565	16283	16283	1618870140000	canonical
23162	3NKvWUCV1hnwjkEuEHX9UHztfueejMaaovM29zoFySF1sbNVFag1	23161	3NKGGg9tWY68LsBbEZKjB6v3uVSU8Vzy52ew7s1nho4WHaLSG4BK	684	986	434	12463	15189	jxFBfbCR4q9wye1F3emqMdJdzyvXdYNeNrmFjx81BD34EeQhm4u	11566	16285	16285	1618870500000	canonical
23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	23162	3NKvWUCV1hnwjkEuEHX9UHztfueejMaaovM29zoFySF1sbNVFag1	1506	1127	434	12463	15191	jxL6BQGG6ePV6MvM24b5a6GHjY8bcM7zWgDsAbddXGxF4P16bpg	11567	16287	16287	1618870860000	canonical
23167	3NLW1R1DYh4xPZZAoWa6vRaz3o131AVz6ePQsJ9uNvc3jBeikSuA	23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	1520	48	434	12463	15193	jxr41PZV1upxJyzwnZxGetm2SuGsN3YgVkoiVrztvg2kGxbXJAA	11568	16288	16288	1618871040000	orphaned
23172	3NL4qGKX9ZwjuZgfp6gNL3UGrEHhi3V1PYADAnY87sXZJ6rGYFcn	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1406	1393	434	12463	15198	jx6hpd3zw7CsVm7D9W8egJWmU3jsKyWB8utt3i8XaEjCR6Hm1S7	11569	16289	16289	1618871220000	orphaned
23170	3NK8xD7cPgHJL2aXVUGKkDNF3MAvgePuyvEua5WiX33Adz6pyTj4	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1403	824	434	12463	15196	jxDYrnJSA2yMR8aN7CeeiMbeM2Fg6o4DhJhA3Y7MpstY7f5HEhE	11569	16289	16289	1618871220000	orphaned
23175	3NLvbq6xjib2RS8Yudq8dWZuY3s4j2ZrCxRW2WuVLBZaFuXrTnrn	23173	3NKD7wqEemVsjtJ9g2FnMbfyMXktmEADLCGxSSRwnBkzWxahcBXa	1460	475	434	12463	15201	jxfA69pJ6SCht4MfVunf14EuqXNkha8xngLF1fFXu6vnEwRd1tm	11571	16292	16292	1618871760000	canonical
23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	23177	3NLbADm8GnP4viS5kVfqc6yBqJbbGMquGy2pYLw7TC7AA8UH76KY	298	1062	434	12463	15203	jwkdiAe1Y88LH8vx935X34zSpxD8S5J3JzNytx4S8ZDo4F4fCnw	11573	16294	16294	1618872120000	canonical
23181	3NLP5i7o7SxFpjnNCJ8JERQJ3syyZ3D2P5pEK8DXZYoLuMTot1GB	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	1460	1324	434	12463	15205	jxNwKXtBpTXkLRKsFt5uDUhdAzbK7Cp34bZ1zrZwSaze7ftJ7C3	11574	16299	16299	1618873020000	orphaned
23183	3NLN2mnYgGr3c7yVFVYdjmLsuH6Y7ySNZxtoLWxFFS3gUASbwkDk	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	80	1027	434	12463	15207	jxoG859ixHLnDZhXeeiCh4H5khEuKR3qikFEUDSfY3HgCqimsQx	11574	16299	16299	1618873020000	orphaned
23185	3NKG5cjy7rqp1xaGY6QhBaxvytLmx8QFK8vWbXBQp6rWxvm387Hx	23180	3NL7DVSnRP4qbhNF6j7UrX2AT6H8WuxhVXNnaS3eq7iZYMeXLygr	1405	867	435	12463	15209	jwqqxAweSScMrEovvku4bvC1JGP1owo4LGwp4zTEkDDWCycqtCs	11575	16300	16300	1618873200000	canonical
23186	3NL9pMsTwcbhsrG9K25t9p7UbLdfV4RYiX5VPFVyuT2DKsW863CP	23185	3NKG5cjy7rqp1xaGY6QhBaxvytLmx8QFK8vWbXBQp6rWxvm387Hx	1608	1289	435	12463	15210	jx1Q3TPFpcKMVEgpgjsqpNLvsfQJie1V7apa91HJ1ih9chB9aMu	11576	16302	16302	1618873560000	canonical
23189	3NLy2hfZqF6sqoGcEhqEAk3BkgsPZEjfADqJxbmviBdFDUPh5Gaa	23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	684	1352	435	12463	15213	jx6jXUcRMPZJmTsoDRbEW4eFVqJLP81EHZAVUnSenb66xoszPii	11578	16304	16304	1618873920000	orphaned
23194	3NKNvy988pPihhFMqzqtJ2D2mvDq8f3DUaiDESsQfQfWPp2Tdzgq	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1406	1393	435	12463	15218	jxBGa9x2R83KdmWmCPv1r226pmNo2TVKMt48W534Ft96MnvDnPS	11579	16305	16305	1618874100000	orphaned
23198	3NKFovacUvB4xwyyoefnBzCURB8YNtZW8FfbWtWBHaxJDfZnv4ep	23195	3NLWEVS5S2nCQ5yyhA8CvcRNomj95A2YS7PwPH2MBtRfvbqkg4QA	532	1303	435	12463	15220	jxPXAvnyMsTfnp3q8Fz4MAnRgHWeLEFEkk17SydhmUWH35HWcMz	11580	16306	16306	1618874280000	canonical
23199	3NKAKAVmWgV9iuk1rnoQvA82ryttB7iDf8bfknii969e7GvTXLuD	23198	3NKFovacUvB4xwyyoefnBzCURB8YNtZW8FfbWtWBHaxJDfZnv4ep	1560	1291	435	12463	15221	jxpQTuP8dCVd7NTB6jupu2U7HbgFma1ibAfigU6txgaKZXGxASL	11581	16307	16307	1618874460000	canonical
23205	3NLDY8idqe89fiP7Tmq2zpbt4VJVC9i37TpiY7NrHMCk1XeDhJrZ	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	470	943	435	12463	15227	jx8p8nYLJmt4UYpvTDi6FvsmHmMVZXvDYCV7SZ8uQEmKAsrv5KJ	11584	16311	16311	1618875180000	orphaned
23209	3NL28e4P7VwRuWE6WdxhRw4dz7GMwpFeW3oxJS7bGcbosDbXibJJ	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1457	1391	435	12463	15231	jwUncP686FoYA2N2NMaxptxJ8gVbKUDaa1UkE2TXTdBJLvvQFq4	11585	16312	16312	1618875360000	orphaned
27904	3NKVhGiUce8y9sZjvcrnGToaREa1fYw86hPSuWgcrttWXMmYDUVK	27903	3NKj9G3kb76cRvDmYvNPhkN5V9AEELDyZGSzgP7FaKWgYQ4f17cd	1589	1160	545	12463	18974	jxHyJDWYUUsqKiNwGTxBeuEC6katLZKvmmeyCPUiAcaAVATDvES	13799	19442	19442	1619438760000	canonical
23184	3NLEZiDKFenwna9o3kEaAQnBEQxcBtTQQJgaoXXnepTimydTMQ46	22806	3NLDBVS4MfRHVpd1mRWHuod1FEBNjrUxX1p751HnzLUgFDV8qaFT	80	1027	426	12463	15208	jxfQMzW9XEYCBuDxPyp8F6Yyz4PkANtPf7YufzkDce127cCgq1L	11405	16299	16299	1618873020000	orphaned
23130	3NLhhEyBPRJvpkWiM27dHAdAP58VdyJzCUQsm2Fm5rfhe9utFxfK	22903	3NLCYw8tPL1oxKM3qVRpPYPUBEQoF118RnNXrhv6RLGq77sXbUMk	1579	1389	428	12463	15162	jx8QLhh8JqyM2KxV8y4FbDF1aGBHZmzumf8MH7RRmizBNoDrf3z	11433	16264	16264	1618866720000	orphaned
23250	3NLj3phz3qfczqxBG1SoRLg6Kmfcu8cuxMazHNxKgswEMJgdRCgz	23114	3NL8qpz7CSEbtEvrxHj9zgDYbT8v1PJN2xs7wDPpdNUAKjVtJkqY	1611	1341	430	12463	15270	jxxYh6kJSypJd9NntD3sRGzzRzNwqxCZuUYMHUEFvWa2ZXyNjDz	11480	16330	16330	1618878600000	orphaned
23214	3NKNnZZVhS6WBT9zpPuAazXwGn3uQpacsJ39PhoGE3Rn4kvobN9t	23089	3NKHgN4VoSAoZik5YxckkgZ6unrYpkiAKwL5DwzPB3MbUmZYcHrZ	1623	839	432	12463	15235	jwoW32XN8i6m9NgoiNdQfkMU2en37nmq2FVMQYNrhAmH9Tteb8w	11516	16313	16313	1618875540000	orphaned
23219	3NKpvZ43nGmkGJyycdwAS6ZsdCNW4KtnvVTDdeBHsi8nY7qMC1o1	23117	3NLDQXcXKMu5N9HPXWcS9aaqh59KmS5TA2hXpNcge4oK8Yg5qiKF	1577	1327	432	12463	15240	jxLcq2wj7N95pKQNd1U5r7Wyowun9zNpnSehUHEYZZjzgPMztCX	11526	16316	16316	1618876080000	orphaned
23125	3NKRX6HrvnqcVXWJ6pR8Sh84TeaBbmYUstLDMV8mmm1VjrZRydNz	23124	3NLexbgzgbB5Bph6TTUmRDDjm3PpNCVNNNLFsmKUzAaA5RYswUKH	484	1319	433	12463	15158	jxEJsLwwMLckLwbb2Ht6KPV3m6boRYDgioxUAAE4mf2xTLpXeC9	11551	16263	16263	1618866540000	orphaned
23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1602	1003	433	12463	15159	jxv1TCVWKZMh6vapE75aKw7ZwfNkBxfNNCGJgnWRMZGQfoSXS5R	11552	16264	16264	1618866720000	canonical
23135	3NLiiLZQmyeMRAE93cssBHogW8mW88GaE6JJ3Xs5gYvfbBTuDzoz	23127	3NLivimhQKBbBctYqfByE9oq9tKvswcecKn3xC7Nf3CsRkZqCgcx	1444	1381	433	12463	15165	jy2eCqqcxCCTyBaGyVenAoKKuGeaeQc9kU7ef79eCfERGpS5hZY	11553	16266	16266	1618867080000	orphaned
23149	3NLVGwys8CN2Uud1Xk52r21sJCitKc7C4mYDgaX2RSqNyiUq1bej	23147	3NL8r7sqT5yy6Kf6UDDCpw4dVQ2UTfjDZyiVyxC8RcFrppohK3rs	1672	1039	434	12463	15178	jwTpx6NaiNCRsfAkygMAmhF32Z1eeuBnjibC5sjZ8xfSMUXWjXR	11561	16278	16278	1618869240000	canonical
23154	3NKVCnpX9p1tpn5NrTsJ2YDAG1e5bzRPEW4fwb69PubveY17bKkR	23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	1444	1255	434	12463	15183	jwScG8LinV4PtExQUYNtFKSX1wNC3H7JapQZbSViDhsNUjm5DtY	11563	16280	16280	1618869600000	canonical
23159	3NK45j61ynPXfTefQGpGa7ipd1kb91TPyWKnDxfSFPUFVrw76Y3M	23154	3NKVCnpX9p1tpn5NrTsJ2YDAG1e5bzRPEW4fwb69PubveY17bKkR	1406	1393	434	12463	15187	jwGM6DhXuZpuAPKkgk3vvnqtqEvbthQACkjGDfktWn6Nc7M7mJr	11564	16282	16282	1618869960000	canonical
23160	3NKznaiyrVB3Hs43HyLgUEuhtYKit7H38orbWUuxJ4quamzWForr	23159	3NK45j61ynPXfTefQGpGa7ipd1kb91TPyWKnDxfSFPUFVrw76Y3M	1440	1377	434	12463	15188	jxcH1g56dXDt3ruiZYFo2FmJDTbYBsvk6tepQFxqJo3257ZW3qz	11565	16283	16283	1618870140000	orphaned
23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	1447	1219	434	12463	15192	jwxVsaU6xfj54GPcJrBPEDEeTZh2XBmE1E33xq2t1yakWUqL6ba	11568	16288	16288	1618871040000	canonical
23171	3NL1CbjULtdMKq4QB8NBWxXUXV1Ec3J6s4LC5Gzzy4249o7DBCDu	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1642	1367	434	12463	15197	jwrYa2do6ZTnkvZP5BH8wS7z7r8xSVCdiRh7Uxa9Yx4cssKpsNj	11569	16289	16289	1618871220000	canonical
23176	3NKPFvyCiTpa4dijDf1yJY2iG5fmxJhjuMJJGk5Jc58bkbjzUYcd	23173	3NKD7wqEemVsjtJ9g2FnMbfyMXktmEADLCGxSSRwnBkzWxahcBXa	1460	475	434	12463	15201	jwkrZTMXe8pgasxPkFEKN6GBMWrVRohZZ91F7qemjSeRH479sjP	11571	16292	16292	1618871760000	orphaned
23177	3NLbADm8GnP4viS5kVfqc6yBqJbbGMquGy2pYLw7TC7AA8UH76KY	23175	3NLvbq6xjib2RS8Yudq8dWZuY3s4j2ZrCxRW2WuVLBZaFuXrTnrn	1407	1395	434	12463	15202	jwryj26RhbTxpoKZdJU3JCpZxo4x56Y8qrRm6sU9BCtd8MCYYr3	11572	16293	16293	1618871940000	canonical
23180	3NL7DVSnRP4qbhNF6j7UrX2AT6H8WuxhVXNnaS3eq7iZYMeXLygr	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	1460	1324	434	12463	15205	jwT4dLV4JNZ8R7jje6KEKpwb5ySntP2Uu8wzfMtCyEiNiM8kz7C	11574	16299	16299	1618873020000	canonical
23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	23186	3NL9pMsTwcbhsrG9K25t9p7UbLdfV4RYiX5VPFVyuT2DKsW863CP	1501	1114	435	12463	15212	jxDp1vTLSXwQD2Ric9LuBpqhuUvRjrKZ6zhRcc7iynQqbViLXtM	11577	16303	16303	1618873740000	canonical
23193	3NKkHE23c7WYFEMBZj2hmKSXi5xPrHtqgJxT2otzGiSgNpQb4ETU	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1407	1395	435	12463	15217	jxoP7vq6FowRA2YkCjCPV9dHSZawZU1wAjXHJe4L7zhgqoD93Cb	11579	16305	16305	1618874100000	orphaned
23204	3NKrcWoPEoCVJpoybYDbUMaVu9F4rERpVR27RAjhsiqnKQi4tzs5	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	1571	969	435	12463	15226	jwBCWZYXbvvgyrZzp6t1i8KqnXNJYrMFdLx8noBV7KD8xaCb7nD	11584	16311	16311	1618875180000	orphaned
23225	3NLPsxpcXXFzrbXKtaQ97j9zAit9b4HsBSvkxZ2gEFABEkwcYbSG	23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	1405	887	435	12463	15246	jwiJT9kGcHNqBSTXfhrGWDdXA74QBdbyoV8iHCnLqmBghiakabH	11591	16319	16319	1618876620000	canonical
23234	3NKmUFGe487TWWmG1VeEVeuk7YoWrnRaFHVzGKBHkj1WqzYxYhk7	23233	3NKDuHMVicctQh4fPRxZL8ZnJZdpwuEsR5BxHi1Vaw6EMFNdcXV8	1406	1393	435	12463	15255	jwcAeTwzpDWuLbX7BxdCxDdPt4pMaBNWLTZC6Reie9WboNzMdK8	11594	16322	16322	1618877160000	canonical
23235	3NLRg8jERJEeggnXRRkR7Zkduhq27dBviNbU9o8b9DA5Wr7YoSur	23234	3NKmUFGe487TWWmG1VeEVeuk7YoWrnRaFHVzGKBHkj1WqzYxYhk7	1403	782	435	12463	15256	jwf16kFZD3Vf762kvVkrpoTM5bgUfdR9N39RimzLNT6bnrRj5wb	11595	16323	16323	1618877340000	orphaned
23240	3NLFWvbAR3CpZayt3Gvqxr2iLfGKPQzWqVy9YeXpGQgyS4cYLZxN	23237	3NLczDuz4yQideqNB86haQDtRAPQVJJk8RmQ5Yfbzp8MmSUuXAYZ	1440	1011	435	12463	15260	jxGEHRcYXjnWgLZSa9gDQWQK7jRPxVekWkQSnKocnwTXQuXMHWN	11597	16325	16325	1618877700000	orphaned
23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	1489	1254	435	12463	15266	jxbgqpGYpZLxqKDjUtp3AuT5APjVjSjRySjjXUpQ8pj6G4PwSTm	11600	16329	16329	1618878420000	canonical
23255	3NL2prAjDzvkAvtuvetDQmA5mYkudxf1PmSUnNfy1HHfymMYNjrm	23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	1647	1176	436	12463	15274	jxKdAQnAc9FTHjdokMnKuHWVAxZnD1RhnxgST8Ckvzod2WUEpvR	11602	16331	16331	1618878780000	orphaned
23260	3NKrge1Xjov1M4mHCyLZ2hvJAomvkXNFfibE5pMWDNWmU5Vwm6SL	23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	1631	794	436	12463	15279	jwEcP4DBACJ6sGNN7q5qLsMoJgLyCqKrzi9dAobBkDu6wc6UG3t	11605	16334	16334	1618879320000	orphaned
23261	3NKs7RQJsFjXGZ4ifaMJy3rpcB8c86wmzfWUWqJjTWquEv4nvJrj	23258	3NLX3Lb62eBvoSU54JvEtXmijbdAJbVuPNj9y3rAeHdiXa9i53xp	42	1361	436	12463	15280	jwbREyMGpNyD5yfp52zQxZQ8ZhifR6pbkPiqXyCYbBBbhS9wfAS	11606	16335	16335	1618879500000	canonical
23266	3NKnkLDLQFtUnSCDa4XSH6VPjoJncy3hUoZyutZnuK9ZHfpWW4Md	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1527	1293	436	12463	15284	jxZy6EwTCpy3bafDo9oS4BZLmyAQ5bkp5Bbfb4Z5LuZnHQGv6G9	11609	16338	16338	1618880040000	orphaned
27929	3NLwYsVYnzT542AEjMhptn9yUen3MZaqgqYyvMiiBBarmzLw9AtU	27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	1541	1298	546	12463	18974	jxpLtHfSaoaBgnLdoZGNbuf6Mvas3MeVQJ8W4GRkPXQqGy8vCbU	13815	19465	19465	1619442900000	canonical
23151	3NK6tx433x3aRfbZQBHyZP7RaQ6Y4nvKZVimpzFcrQUCFiUgkYJL	22989	3NL1PXQkqvXtmkeq7FXUoFE63tDCgjNuvdx92U3FkzodxbGtA6pa	633	1018	430	12463	15180	jx7XQGjeaRBuyXNogvVRhTHdptxmVCcR6EnRVex49Ef2aWBBiM2	11484	16278	16278	1618869240000	orphaned
23223	3NLSyhbqHsbUi8PHXeLgYL2pNNHU8dbca8jW1oKuw3QnTUBuNL1j	23151	3NK6tx433x3aRfbZQBHyZP7RaQ6Y4nvKZVimpzFcrQUCFiUgkYJL	1461	1271	430	12463	15244	jxwBoGgZ4WcrDkyDm3JkhsLM9VWWPKKHKGufyCPzDdRYarc4sWS	11485	16318	16318	1618876440000	orphaned
23228	3NL7GT8c5CHrVuWfhkeng7aur8ptRAS3soSrEcDpYU3Yex9mfYFX	23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	1547	1378	432	12463	15249	jw9wXMUshiwhpAiafd3qCKmbLphqhxS1CXsPexnk2sutj7PwDEX	11515	16319	16319	1618876620000	orphaned
23156	3NLw2UA1unfvrHAkieZTGUa66tisQvLd9nrZbRoKKX6JWnvRn58T	23136	3NLLW4rnhqupr8VEXp4XRTph5aUkjYSiM4cA8u56J6QDiGR13GZs	1444	1255	433	12463	15185	jwkXR3gvhK9FpuXXW9qPknnL2vGYDWxMztiZHpW421KT2637KHp	11537	16280	16280	1618869600000	orphaned
23244	3NLfN2EHZXxhBbmk1zJphYcKjpMdeRrVVTfzGAb9jJG2Ev3L7WXr	23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	1581	778	433	12463	15264	jxj2Ah9xahZ3FResYBWcjT86smbJsbPFZQ8tJL8R5j7AcwBK1VY	11547	16327	16327	1618878060000	orphaned
23152	3NLQ276Z9tPtGxiKQQFNLjvcBAVVWSS3wVk8RZihw2f31zugCjuK	23149	3NLVGwys8CN2Uud1Xk52r21sJCitKc7C4mYDgaX2RSqNyiUq1bej	1403	782	434	12463	15181	jwtFX7S7S4DrwXXz2NAE7rJsEuAKg8SFkPAPXWSZVVhUu814zwT	11562	16279	16279	1618869420000	orphaned
23163	3NKhzGB73dZzYjVMc8FdZkxBhYHA7ieY5axLtBnEXGVxMk3o4guD	23161	3NKGGg9tWY68LsBbEZKjB6v3uVSU8Vzy52ew7s1nho4WHaLSG4BK	1513	1133	434	12463	15190	jxhk3WkuYsCHLvbXAq3fJRgFMgzmq2tMHrpsCi7E39HC3efYefo	11566	16285	16285	1618870500000	orphaned
23164	3NKjMZ7A9EDqepQMk6ZNzjbvbJcG94oHKNzDUAno5FYbrxC31giB	23162	3NKvWUCV1hnwjkEuEHX9UHztfueejMaaovM29zoFySF1sbNVFag1	1506	1127	434	12463	15191	jxjuaKjNxKCctEQ7sfwMdHWDCtQpELQ736zFVXN6dq3cw66eTRH	11567	16287	16287	1618870860000	orphaned
23169	3NKi6aR5g9KswbdeCqmVm5UUZSxFvyqaAALdPYzcLkNN9fS4ZFWZ	23166	3NK3uB9m4VST99EJJvKP2aZHmTjTHjNPSDmMSBULAxoo3zzjgVnj	1407	1395	434	12463	15195	jwvEcaBHYYWjXeHhEPjtebWvPMBgKcvj7QWgamEAoBXWjrWCxXA	11569	16289	16289	1618871220000	orphaned
23173	3NKD7wqEemVsjtJ9g2FnMbfyMXktmEADLCGxSSRwnBkzWxahcBXa	23171	3NL1CbjULtdMKq4QB8NBWxXUXV1Ec3J6s4LC5Gzzy4249o7DBCDu	1588	1392	434	12463	15199	jxCKG3ohQuWbpqafxayGHHraErhof5uiCQA7wXqLXBHyQR72RKL	11570	16290	16290	1618871400000	canonical
23182	3NLb4889d6tbRcweyA8ZxL4yssHxXsNSXRvxm3RpVgDDUB6VsVNc	23178	3NKUsQEncuET2hFt2fQdJBaWhzXekdNwxoVC7P8N8Ggvmw54aswU	1406	1393	434	12463	15206	jwup8YdW5YZiDrGWcKV5B82X7c2boeuyjY8mbp4Bm38w1x8jLdT	11574	16299	16299	1618873020000	orphaned
23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	1406	1393	435	12463	15214	jwky6pEUQBevHHikAGfk1VxdWwc4uV7HcMd9ZZjp3fYfyvikjVj	11578	16304	16304	1618873920000	canonical
23195	3NLWEVS5S2nCQ5yyhA8CvcRNomj95A2YS7PwPH2MBtRfvbqkg4QA	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1529	1316	435	12463	15216	jxhZZeY69tBnYqePtZfqyBCrUD856UXzsEvTrFem7Hftu6HF5xN	11579	16305	16305	1618874100000	canonical
23200	3NKZRMm3ip3HGi7Q2qtuiqYJvM6yHqEAotvxZbXpTRZby9rwQzCf	23199	3NKAKAVmWgV9iuk1rnoQvA82ryttB7iDf8bfknii969e7GvTXLuD	1560	925	435	12463	15222	jwGoxuCN2bLErTUJzfXF2ZcTEUXTc6ZWvvnBGk8ZJBJ44m2d358	11582	16308	16308	1618874640000	canonical
23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	23200	3NKZRMm3ip3HGi7Q2qtuiqYJvM6yHqEAotvxZbXpTRZby9rwQzCf	1589	1286	435	12463	15223	jxzQSDhHeAcMbb7spU6p1MVjz6CpQ7XFJ9RfaHnS8QUiHhbjzYC	11583	16309	16309	1618874820000	canonical
23202	3NKdhVB6o85tfZpLyLznemMBtSf9dLMVLv1ayiRQjG1FMtyFZ8BE	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	1406	1393	435	12463	15224	jwzTDBZcVSZ4myEy3hLHg1onyBTKnABEprZLhjnMoHfgvVayvym	11584	16311	16311	1618875180000	orphaned
23208	3NL2rNMeaUC4ypCH3WWQ6x76daWjkREvPTrwgDGCcK8UPFEnYTjf	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1483	84	435	12463	15230	jwuD6Eikqc7nfkD6mYvbMrhswGaCpxbZdhz9YbfnEAmQiLjCDHY	11585	16312	16312	1618875360000	canonical
23206	3NL77ciTL7PhZQJXti9Gmr8VuLmcsVR2wybj6bsqKh7Mz2xQLhEw	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1671	1365	435	12463	15228	jwmupjHUTMLVB66gbMBUYB6xALvyTgWtqcGQqMgyvn64ixtAPgq	11585	16312	16312	1618875360000	orphaned
23213	3NLMTvBTQyPYgpncUVGwJ36wnNhZDWW7xmyu9393VXiqA9KWomEd	23208	3NL2rNMeaUC4ypCH3WWQ6x76daWjkREvPTrwgDGCcK8UPFEnYTjf	1406	1393	435	12463	15234	jwaWDccj2TW3e1stVDRVC7yxRLs3772q1D4DYBbdtZTBrmDwkRX	11586	16313	16313	1618875540000	orphaned
23215	3NL5bxn7abcSSCDuLDtce9bWQREYoSGKPeeMzWVXuSbLX4gqQ1Q7	23212	3NKRiJK527jx73NeY3ebLKr1DPsYAfH7y6hwJbuxQXdQaP9QozNf	1403	824	435	12463	15236	jxfzT4z2DYZNVo1GVsvDmLfLwjTf5sKEXepuqF7PUQ3bU9WzwjN	11587	16314	16314	1618875720000	orphaned
23218	3NKPPtMc3z7ALSRiufP4ynxNfToRaJXVq3BnJCjzsd3umATBekFb	23216	3NKBX1JdcTV1ywKis3HsnVQKC6hpfe1HPaHuUWFE8mBYSh3xU8JQ	1624	1334	435	12463	15239	jwRf24ELv8Bp8GQjbGEKuDQHYwBK2E3McqEbmVLSDwRwNLkpSsn	11588	16315	16315	1618875900000	canonical
23220	3NLfsTPMTJbcxgE1d9NpH7BNqEQZv7aVKuGU6ZuWgKcnJDDsGJpm	23218	3NKPPtMc3z7ALSRiufP4ynxNfToRaJXVq3BnJCjzsd3umATBekFb	1577	1327	435	12463	15241	jwTdM9YNY8CoPFWWC4kgZ6UYyk9VnUXMPyumi6qWqcavW2oSqXn	11589	16316	16316	1618876080000	canonical
23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	23220	3NLfsTPMTJbcxgE1d9NpH7BNqEQZv7aVKuGU6ZuWgKcnJDDsGJpm	576	1355	435	12463	15242	jxWqMorzW1zfSGHtv9x51UD9RgzA7XUbtKXhykmcDqpZFr2A7Hr	11590	16317	16317	1618876260000	canonical
23233	3NKDuHMVicctQh4fPRxZL8ZnJZdpwuEsR5BxHi1Vaw6EMFNdcXV8	23231	3NKhvMDFWVFKLYAMXbzoHU94kZfFw3cEZcqNaKwfwSGq5VzDuET6	547	547	435	12463	15254	jxsfEnGU9dtCnwYC33ywMjTfiagzTRAw5oLSXpgp1aKW7w1gY46	11593	16321	16321	1618876980000	canonical
23238	3NK7ZS565qda4fcdz9SfML58Be9WYjH2Uk6YAg8xeJSGAjJvmRpN	23236	3NKUBd4L6rUA61DDUdzBJysXUM7gDxFNUrv7RMo3WYvib6fAhSEe	1406	1393	435	12463	15259	jwzyvDFFFWG5YdRfTgWxGzRePmLvHU3EXrdHKaArHV2RpTMD7b7	11596	16324	16324	1618877520000	orphaned
23239	3NLjH9k6TCPKiBvtizzyKFC2XU5HkqfxLuFcEhrbKMxNdNYLzYbk	23237	3NLczDuz4yQideqNB86haQDtRAPQVJJk8RmQ5Yfbzp8MmSUuXAYZ	1440	1011	435	12463	15260	jxYyDFFmVVuZmu1gBf3vqWfT18hKT3CjQCLcKASoXmDWsuwWx27	11597	16325	16325	1618877700000	canonical
23245	3NLJfWjvvynLWpMtdhi77yFuJUuHM1sGb28PqiooP1UNufXLm9Qe	23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	1509	1194	435	12463	15265	jxnMJ2odQs6VSbk2yjVogKtZzswzaPXvMaG2CoHcaQ2nqRWbSr8	11600	16329	16329	1618878420000	orphaned
23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1447	1345	436	12463	15269	jxi6QjRfXhPE7uBrucJnt2pr7tE2RaN66NoabinZ7miqz2nekx4	11601	16330	16330	1618878600000	canonical
23254	3NLAs4VBCyG7wGKGaPxWB2qNcjRmdQzu57esST9yiascBfpd9Sbu	23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	1637	1637	436	12463	15273	jwQ3x1JwLr2z9DhWZPYh1ywKksYRshZQkL6iXzU41EuHQKTfhVg	11602	16331	16331	1618878780000	orphaned
27942	3NKsVJz8UzStvmyxCUcjWToUeufSpjL5eThAyCuz4f7L6DNmZ3tA	27941	3NL3diNeXvVnq5pBPZgb1TUksJGPaYSDST4AqipYojJ8jGWbyqqL	1627	1259	546	12463	18974	jxF4EDxi21qoeh31kEK7zSXKoHKeFZSCYe21yC1Y8CgxD1tctoB	13823	19478	19478	1619445240000	canonical
29325	3NKw4DrpRkXuREp6BzZu2vgtfTuAQxHR9g7VcMDG9L6H6ApdRRyM	29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	1407	1395	575	12463	18974	jx92T75cexoLqPKVJD7j1X28Duai6ZM6qKRxKQoaMUSvRBVB55M	14451	20347	20347	1619601660000	orphaned
23187	3NKvVN4VdxsSZpAQroqXtW1izKhTfDMJM3z4DHjVF2W5drn1a7Gz	23186	3NL9pMsTwcbhsrG9K25t9p7UbLdfV4RYiX5VPFVyuT2DKsW863CP	1656	1343	435	12463	15211	jxMkgsHaxzsCJYizd41EG98Jw596qbXMVEvyX4qs57KbjY8PoJw	11577	16303	16303	1618873740000	orphaned
23191	3NLSPMgKP8ttDBRALv6xqpRM7tg2J2vc7MmMZNnMVa9Cvzbf9ddt	23188	3NK6V45PQrtanuxVe8Y4EKAqzxmx5QETXmvir7E8NdgZDT83Pvmc	1555	1347	435	12463	15215	jwmQ1zGaXZU5hBKxfZ7PRDJLcv2zWUjbwxMS16tZGCyChwx6P7b	11578	16304	16304	1618873920000	orphaned
23192	3NLdotzH2Chda1U9t2G1UZjUV3t7QLs1dL7YHW2GDqy6KrdJ1gx2	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1529	1316	435	12463	15216	jwmHv2Xx6S6z2C7NNA5sCzaPJfSdkFtUHSADy6aG9GFqvadFiPP	11579	16305	16305	1618874100000	orphaned
23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	23201	3NLTfS39ELQXw9zb4Fi3oF3bUhhnwXAgzcEAxERuQuc9mzNnUMvU	1553	776	435	12463	15225	jxxvwAgkxHafcK9BiC4GPqhExTSNXNjmw4eJVV8yTCHDpUZfayR	11584	16311	16311	1618875180000	canonical
23207	3NKrBhFjGdTiWKjkuW9LsLHz3Nc4idDNCyiQ9ixegGavbtG66stZ	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	563	1113	435	12463	15229	jwUqGJnUyRH4XzfA1xWexi3vZkzd9hj3UUKMZApviv869gg6Akw	11585	16312	16312	1618875360000	orphaned
23211	3NL1BcVA9sSwqBQGBKbA8kzqKnoxX3pBGbi3ZM2k6dXtdwaZ2mMi	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	563	1113	435	12463	15229	jwEgAecX655BU1oyaqD6twGAep8sxSvaKDZAoZ1zBxQ3axv6uLD	11585	16312	16312	1618875360000	orphaned
23212	3NKRiJK527jx73NeY3ebLKr1DPsYAfH7y6hwJbuxQXdQaP9QozNf	23208	3NL2rNMeaUC4ypCH3WWQ6x76daWjkREvPTrwgDGCcK8UPFEnYTjf	1407	1395	435	12463	15233	jxf5CD4Z3dSZ9VHQKSVZu3AqY8vArNNydR7ozjkqoETjC5Cvv78	11586	16313	16313	1618875540000	canonical
23216	3NKBX1JdcTV1ywKis3HsnVQKC6hpfe1HPaHuUWFE8mBYSh3xU8JQ	23212	3NKRiJK527jx73NeY3ebLKr1DPsYAfH7y6hwJbuxQXdQaP9QozNf	1553	776	435	12463	15237	jwBtRQuEBa2LYfAnVTu4rD6r2yYmzpbpEkoc5HJkpPzPvA4gt4X	11587	16314	16314	1618875720000	canonical
23217	3NK7g1jicKqaFw1EdJAveTwTGrqqqbeq25cKidMAAXZeg7Jn7aBg	23216	3NKBX1JdcTV1ywKis3HsnVQKC6hpfe1HPaHuUWFE8mBYSh3xU8JQ	1406	1393	435	12463	15238	jxCL2aVdyjnZuAs4fjmWhVT3ux51ZzSKkrmg5rwxLfJ2nT5S86z	11588	16315	16315	1618875900000	orphaned
23226	3NKL4DuSGAiLXZcpyoeQpnqG2wV4hhA4jA6Uo4ZAWUkaUHpJAQhT	23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	1547	1378	435	12463	15247	jwLXsV6i3T2LMNEoBncMJH3b79u1WNj2pnRC6QsbK7n4qY5dvaL	11591	16319	16319	1618876620000	orphaned
23231	3NKhvMDFWVFKLYAMXbzoHU94kZfFw3cEZcqNaKwfwSGq5VzDuET6	23225	3NLPsxpcXXFzrbXKtaQ97j9zAit9b4HsBSvkxZ2gEFABEkwcYbSG	1403	824	435	12463	15252	jxy5DEmEJGteb3hxZxUY59keih4tj9St5EezdR9Mqps2Roz1QCx	11592	16320	16320	1618876800000	canonical
23230	3NKWzXRUcvquvZcrvpUx8kLNyQiP6JbT1b6RxS6zKw2aprLtQi7y	23225	3NLPsxpcXXFzrbXKtaQ97j9zAit9b4HsBSvkxZ2gEFABEkwcYbSG	1608	1043	435	12463	15251	jy2RU5MzGS5KgCdD83g7uMJxHT5EVdMB5WJb5ZmevtJwPzLpNHj	11592	16320	16320	1618876800000	orphaned
23232	3NLb11w2ZHG7M7XN3FB6QpU8rFGYnuCcnivz5TeQ2tC54Ry5u747	23231	3NKhvMDFWVFKLYAMXbzoHU94kZfFw3cEZcqNaKwfwSGq5VzDuET6	1622	1356	435	12463	15253	jx4aKAQ1AZbt34cFjz6DyRXgTkof5NJcNHrzcGK4qqyQe6zjD3R	11593	16321	16321	1618876980000	orphaned
23236	3NKUBd4L6rUA61DDUdzBJysXUM7gDxFNUrv7RMo3WYvib6fAhSEe	23234	3NKmUFGe487TWWmG1VeEVeuk7YoWrnRaFHVzGKBHkj1WqzYxYhk7	1406	1393	435	12463	15257	jy24KPtDejLDBbXPNc8YWf8QZMuLKHZy6sVHB79VJqy3YcmbWCF	11595	16323	16323	1618877340000	canonical
23237	3NLczDuz4yQideqNB86haQDtRAPQVJJk8RmQ5Yfbzp8MmSUuXAYZ	23236	3NKUBd4L6rUA61DDUdzBJysXUM7gDxFNUrv7RMo3WYvib6fAhSEe	149	1283	435	12463	15258	jxNycpocAFHCVJcQkzYRhDY3skWLPPvn7cappZbdWLqNsYbGUTC	11596	16324	16324	1618877520000	canonical
23242	3NL45GJmtp6c3JFBArxdCczToFWvKRoesFSkmGerR6AfFEfpk3nw	23239	3NLjH9k6TCPKiBvtizzyKFC2XU5HkqfxLuFcEhrbKMxNdNYLzYbk	1657	978	435	12463	15262	jxxt2Z5sbwyjDf91rt4Ft4QbXRanEU6g23P7iTJPdrH19c7bkmD	11598	16326	16326	1618877880000	canonical
23241	3NK6KpiBuabknieCuCrgQQvpyXwpnYjQrxUMXpUk7yxdAUhx5KMc	23239	3NLjH9k6TCPKiBvtizzyKFC2XU5HkqfxLuFcEhrbKMxNdNYLzYbk	1406	1393	435	12463	15261	jxKUyZNRbYFsoc1xHogNUdiNQa91QvLVMqbFgb8B5mYNv1JBdAr	11598	16326	16326	1618877880000	orphaned
23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	23242	3NL45GJmtp6c3JFBArxdCczToFWvKRoesFSkmGerR6AfFEfpk3nw	1405	855	435	12463	15263	jxu9wQ5dQAssHRoGj3rY2gpyxpmae6yQ2GuKPCEBBNVcWbMVni6	11599	16327	16327	1618878060000	canonical
23247	3NLHqs6QtnaE414RDrsfRtRipFa2rVyUeBFd1RkJewt1J4TYttfH	23243	3NKS2K9RXapDBaUj8hFzBXvgVWe3Q9gDo45J3gJeL56i8xGCMdfy	1637	816	435	12463	15267	jxNdFwatXoY5vXbjuQau6h7KTzrPVQa6N9ETxCiSzDMHMSY4MuY	11600	16329	16329	1618878420000	orphaned
23251	3NKshjZJQ1D6nBTXGPmgdqCMb7f3UBhWztqz9a5y7KrzgDWV3kPK	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1656	1343	436	12463	15268	jxKqM4jjCgfpzsuVo73mDVGmhSCVPTxhy3BUhLYWzUfdUzEmY2o	11601	16330	16330	1618878600000	orphaned
23248	3NKTvNyxDFBVRMWXhAtot4r18Lj9pdE2g2QEG1RDzo22dwUvLgWw	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1656	1343	436	12463	15268	jwsyUgvY89c7bP7EHiLF9pd7LrnZFdRA24Ne72pGTQ9XJdF95sb	11601	16330	16330	1618878600000	orphaned
23256	3NKT47YnbGtocSbbuNqY5bhSrEdppCEbDazCpmdP8ZRhFAJe84UV	23253	3NLLtjqtacZX4TgYr84TPNP7CTP57xvurNqhAhGMN41xdhZmKHYe	1637	816	436	12463	15275	jwsKKJ3VpgKtKJyB2nzRaCMRneF8DrFQBZX54KMDGey3tiDVSA4	11603	16332	16332	1618878960000	canonical
23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	23256	3NKT47YnbGtocSbbuNqY5bhSrEdppCEbDazCpmdP8ZRhFAJe84UV	152	1330	436	12463	15276	jwweeht9YJHZyMdYNdg6DAuSo8oE5JzaRqdnroTF8bHgMYNRqcx	11604	16333	16333	1618879140000	canonical
23262	3NKb6CSUFa1wbkAsNHiFGrCjj5mq9obGP5RVgxbUBmpkeXeGDQPK	23261	3NKs7RQJsFjXGZ4ifaMJy3rpcB8c86wmzfWUWqJjTWquEv4nvJrj	1564	1338	436	12463	15281	jxnou1MKDjDEQMr3U64rmtyUDstrpgfzi6k9RgfJcQqrdwiQZBc	11607	16336	16336	1618879680000	canonical
23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	23262	3NKb6CSUFa1wbkAsNHiFGrCjj5mq9obGP5RVgxbUBmpkeXeGDQPK	1406	1393	436	12463	15282	jwupGoWyCKHoCDjiVVRX7GVLgtBdbedadPeyD1WyL4g1kMBPyzQ	11608	16337	16337	1618879860000	canonical
23267	3NLxCYbXvRqijxhMmpearYPyKW2Z7EnUvZa6HqYwnvagfF3MjH5d	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1527	1293	436	12463	15284	jwWPWjUQMgjwM8ztthbBAnB6zP6eW1kHJzJ1BhUryoMkBsw9wCj	11609	16338	16338	1618880040000	orphaned
23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	23270	3NKcsFi7DCc7ttrqSZ5CHYVrvBzBhBQ68a7aMj23jQzYJB7L5aoV	1506	1373	436	12463	15289	jwsWzF1YTY85yqJTw3hb1Vuy2k6DPgVkrfzrkDvfLXAeJSFjYh8	11611	16342	16342	1618880760000	canonical
23274	3NLvZR2zwH5rsXkKWHs2dvywb5crnCK72QPyGihUDWi1LK8krAoW	23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	1671	1365	436	12463	15290	jxQEvz2K7aSJ6VKyevSYkqHnUh6amJHSb79JRfCfz9zzALubo8u	11612	16343	16343	1618880940000	orphaned
28377	3NLSqR7kCykK1ajCG8SRn3AorTrSfe5Pz84p2qn5BxfUCoiKVgC8	27942	3NKsVJz8UzStvmyxCUcjWToUeufSpjL5eThAyCuz4f7L6DNmZ3tA	1508	1387	546	12463	18974	jxeFZ1XSGn6rSzFqEL53dW9idEjKvpThBvPfj317yPGELVzecdQ	13824	19771	19771	1619497980000	orphaned
23338	3NKfK6XgJAf1zXs6aVJNiVL9Xjzos9XCNQQoZ5YnxwyNiMFGgxUg	22911	3NLCrAJyv1BFkwn2xJnSZWgywMywuKodhE2jjqN1KD4ikbLtqXka	1483	1150	428	12463	15350	jxUmBrsz4PQtx4iUSM1LKK5NkqPtcmpreuL5CT59DAdAFZ4QuTh	11453	16387	16387	1618888860000	orphaned
23333	3NLLZZCPQ4b3LBDrmXQjML1MK2xHbksgSnoZhhe6UxGJK7NZrU3V	23063	3NLETEujrUuciXAGBiNN9316Y22iaC8QqYSD2bTWFPZ8YPpj3oe4	1481	790	428	12463	15345	jxG7v4tX6L3QKqKvDiQdBpWWpNb1uSvR27LmnNFQP26MoZw5HqN	11457	16385	16385	1618888500000	orphaned
23332	3NKhm6JGzYzvLkh1TCCFCuv9W3ypaWJHp7xtqVMcq63Sb8k5dv3R	23074	3NLrQ4jFp8PCB9C3nQ1HFbBsT2sTe4RHN1cAN3sWrRSqgAaqv4mx	1458	1197	432	12463	15344	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11521	16384	16384	1618888320000	orphaned
23253	3NLLtjqtacZX4TgYr84TPNP7CTP57xvurNqhAhGMN41xdhZmKHYe	23249	3NL6PyrKsyZTufm76XwcmnZE6M3J7C7ZgkueHkuUc2Gb4AeXbHyn	1406	1393	436	12463	15272	jxCEuEGqNQg1QoAjLum7bWab12ZaJyNFLdmsTSsUVhmnAHbA65z	11602	16331	16331	1618878780000	canonical
23258	3NLX3Lb62eBvoSU54JvEtXmijbdAJbVuPNj9y3rAeHdiXa9i53xp	23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	1509	1194	436	12463	15277	jwafUucCeNmj6T1MWSjr4K4iAkhcN4Pxe6YR8pFeqAQMMgnUZ7z	11605	16334	16334	1618879320000	canonical
23259	3NKYdreKUSN5D5EoWq6xKwcyuT7vDTwfcWuSVuMbtPVM9TVf5pE5	23257	3NLZBYwQg1e3VV2v6My8LFoaNVJn28q3zh1VL383vLPELoSpr2uA	1673	1368	436	12463	15278	jxmjuSJgvFbBnvFGPNTqAUMEkKyXemJwp8gSZvARGUSG47CyyJA	11605	16334	16334	1618879320000	orphaned
23264	3NKVC2wjMS5hhPVGsRt8uRaCkgAAhkxLx8u26g4aZKn9uvQL3ZyP	23262	3NKb6CSUFa1wbkAsNHiFGrCjj5mq9obGP5RVgxbUBmpkeXeGDQPK	1631	793	436	12463	15283	jwHEa7Knv54pp5RxnhGMx38pY69CSbCpY9Y7rnT1RfYLDEbHtqs	11608	16337	16337	1618879860000	orphaned
23265	3NLPkFw4aLXwdYCf1XZQy51z1RWEmq4UXM16EHiCANZDGPbFkYCT	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1527	1293	436	12463	15284	jwNU8FrMAiz1xrrJskZcrMkgj1yZ95PZ8HntPa4BotZxReBKNbn	11609	16338	16338	1618880040000	canonical
23270	3NKcsFi7DCc7ttrqSZ5CHYVrvBzBhBQ68a7aMj23jQzYJB7L5aoV	23265	3NLPkFw4aLXwdYCf1XZQy51z1RWEmq4UXM16EHiCANZDGPbFkYCT	1460	376	436	12463	15287	jwW7cmVmLammK6jza7ovNKj3uX4KWM8pCHovdVhUQta6rTPkWKa	11610	16339	16339	1618880220000	canonical
23269	3NLeRsuS9NT34NgwgjHKXDL55uWzpgnRbmGmh9Ffi473xeW266av	23265	3NLPkFw4aLXwdYCf1XZQy51z1RWEmq4UXM16EHiCANZDGPbFkYCT	596	1306	436	12463	15286	jwNieM6MZx8EMWwFYFXNMRewRz7Ln6y8wh7XSizSRfwKpdScF9S	11610	16339	16339	1618880220000	orphaned
23276	3NLL1cjwdMxc5BnAgyZnqaaQ4YPnYtJjVzYAb1KZDPom2sWCPGEU	23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	532	1057	436	12463	15292	jwaDBjfiqcyLL7vCiK2QaCq53zufNFgM2XoGfQ7ASPMbf5rD6gZ	11612	16343	16343	1618880940000	canonical
23275	3NLaf7zM9TCTv2Gk1ShVzQiJaEYBPieDKaqJGWZPjDJz1LC29a1M	23273	3NKSCXT2SaGCtmeYJ5BAdpRZboH2nQPmiHYC9Rq9TUmpdj8BJJib	1403	824	436	12463	15291	jxoUTSvJpUSEWKsXvdAGZHs5CbwVdAPdK4r4ZbMwxr59EzfHQ4V	11612	16343	16343	1618880940000	orphaned
23277	3NKKFkzf1sNGuNuCcUzDwLBQMkJvjCy42wzJV3kdi6LSkqdYtP88	23276	3NLL1cjwdMxc5BnAgyZnqaaQ4YPnYtJjVzYAb1KZDPom2sWCPGEU	1633	1390	436	12463	15293	jwYdX9b4QLRrv4erpFcXnM3eskMcPVU6K38S1NpN9KnNfhYFjM7	11613	16345	16345	1618881300000	canonical
23282	3NLaPaDwkgWTHQxfsvsFXV4HVuVtGnXVaN2nA3Rv4QGFbXvCFWmX	23280	3NLk2ojMNVYNZURnBKFieS3eP8njP2mUnHfiiNYP15FmrxG3Q9YK	686	686	436	12463	15297	jwwrxrtu7BAEfMDzfB76aVbnKZ7ybxxP4M2prh5WsrCBAb6ubK5	11616	16348	16348	1618881840000	canonical
23281	3NLfK1PADkqqJMBiCzk2TavPwyMC2Z6stKxku2L4KC3mDvFRNYNU	23280	3NLk2ojMNVYNZURnBKFieS3eP8njP2mUnHfiiNYP15FmrxG3Q9YK	1407	1395	436	12463	15296	jwhGGjKYfKaJDFV24ugt7tRPN2YYXWRe6AdJNe4qttRtVdjVcyk	11616	16348	16348	1618881840000	orphaned
23283	3NLPvCEGGd2ggHP6PHtUYhunzBMgkPKXongmJaH5U8CQ49hi4ha5	23282	3NLaPaDwkgWTHQxfsvsFXV4HVuVtGnXVaN2nA3Rv4QGFbXvCFWmX	1476	1125	436	12463	15298	jxX9RfpZnJpV2qbdixsbftg7JLVRfGntuDMihd5wPfi3hH8FiQV	11617	16349	16349	1618882020000	canonical
23289	3NLu7GhZbwJymniTD3Fu4retBfGjg9iTZU8LTen1mTkvGfrouKWC	23287	3NLwBRGm66CTv5FVgyoH4brGAtMNYF7ixR3Y54SfJWwpSvLw9VkF	1477	1350	436	12463	15303	jxJtDE5rQAqjZq49yfoMTYpwuNGweLfiqcKNuZwyWtwURSAq6HL	11620	16354	16354	1618882920000	canonical
23288	3NL5J8gJupAHrE8r9T5VnDQCVUTejDd9ZikAi83Zw7qTVvUSLuyo	23287	3NLwBRGm66CTv5FVgyoH4brGAtMNYF7ixR3Y54SfJWwpSvLw9VkF	633	1384	436	12463	15302	jxPcAbduaPfMhEAheL7VHfabhSzasr8BmTHaG3HQ91T5ZEyXYGy	11620	16354	16354	1618882920000	orphaned
23295	3NLSWvYM5Yt5VSXiMRWcjc8k9ahfbLyVCbXxnsVg8Mou74VbTcqZ	23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	1406	1393	436	12463	15309	jxKgPzV7Hz5LCh6VHyAtoXobMX8JmgRaUgd8Q8t9cx3h2am2yf4	11623	16359	16359	1618883820000	canonical
23296	3NLbsztEk6CDsToPeJHuV68k1CthpDdgThxZVVuHDcCUre7ze2Nf	23295	3NLSWvYM5Yt5VSXiMRWcjc8k9ahfbLyVCbXxnsVg8Mou74VbTcqZ	684	1352	436	12463	15310	jxUwHRLo14WomdNLFLrZkdANptSiNd6BBD61gCqL1PjtZ3aw5qP	11624	16360	16360	1618884000000	orphaned
23306	3NLm1ANuGQRuazdTnLEEQYUECYdFijUo364uXdGkxZ6GTKQHYHD9	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1445	1290	437	12463	15318	jwbCkYRfxcvcut6qbxaM8CCMhXm194AaZ2jymMvZ4efEJa3R6hq	11629	16366	16366	1618885080000	orphaned
23307	3NL9Gqzt2mJQ2J5WM2LNp9SazsKx8rQtbeUZ1hh3L9PzQo3KCxum	23304	3NKwobmnyaEjQvY719wF8PtZ9a3a7Fyukmdm1ZyZDk68FeZ1go8N	1553	776	437	12463	15319	jwAseBo138AsJZnf3ZSKZZimGKHJkwmr1UZbpptHm8SenZTGxe4	11630	16367	16367	1618885260000	canonical
23308	3NLtNXhnG7pKmbpky4C3VTj7D1X31Np7YkNQ6KAH3FiZDkedo7di	23307	3NL9Gqzt2mJQ2J5WM2LNp9SazsKx8rQtbeUZ1hh3L9PzQo3KCxum	1593	1346	437	12463	15320	jwD1RQ3iebG8nSy2hWLFVYWeVkkbhKJAmv6J8g3X3U6paj9iMPB	11631	16369	16369	1618885620000	canonical
23309	3NKk9bdJJVxMWYXt5DdnPMkMnaYHZvSRqUNpxosiPHPsEJEKTFj5	23308	3NLtNXhnG7pKmbpky4C3VTj7D1X31Np7YkNQ6KAH3FiZDkedo7di	1407	1395	437	12463	15321	jx7tihQYxcLJCE8ziXEgxgZ1BH5m3g61UkKha2K5aNjZkaRgr43	11632	16370	16370	1618885800000	orphaned
23316	3NLMAHkytwAQCDis5K69YgsATE2pf3m7bqPXqrpJyB9jESVLt7aU	23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	1397	828	437	12463	15328	jxcuwYbVYUXT5HuMst25ycsWKFjjgvFLRsTuM3grStrauGAgzUs	11635	16375	16375	1618886700000	canonical
23328	3NLhZntpxZbSr7ws7qprDu4oiAKMyk6XiACrHsdNjtphzoudEUFB	23316	3NLMAHkytwAQCDis5K69YgsATE2pf3m7bqPXqrpJyB9jESVLt7aU	1651	935	437	12463	15340	jxMun7hV4fiBwp7SNWQDSW7GJ18WVYd1kY8Fc6XGvK96C4QG5m3	11636	16383	16383	1618888140000	orphaned
23322	3NLyBQJdGyDFQxZckT56xhFKt9nTmEwSJfbkXA68WZLUWscPT3gi	23320	3NLt5cySyuGyHXdSymsS8oqYDS5W85RRjbg16kgxXWk19a9LJGG6	1439	1279	437	12463	15334	jwbxUpScBigJe75C2A2Rdh6BiEsxukhtrUFXBydcmoDYPBwFMyA	11639	16380	16380	1618887600000	canonical
23323	3NL1v3YMLjg4EC3BYMpXXj6mMTZuaKGmkMkDBzvLjSm5dtpodygD	23322	3NLyBQJdGyDFQxZckT56xhFKt9nTmEwSJfbkXA68WZLUWscPT3gi	1460	1078	437	12463	15335	jwR8cvG1LnLWAkvGEcGumJbdGf8datY6EFZM1TxtvrLrLk5JJUX	11640	16381	16381	1618887780000	canonical
23345	3NLrjeFaxqR7Vm8hU1yZBfhaxadMgUNpY5GEvDvT9ttyKk4zZ8WT	23343	3NKZCqrdsXFsxCsreKwN7fHuTm57Uh7B2nQH9CEhSqpVn9A1gmYy	44	44	437	12463	15357	jwnvXoiahD7TCPuR7BiNJzn4CqbFNopjfmkRQcDVnToJ9xDnQb8	11649	16393	16393	1618889940000	canonical
27946	3NKmpdwhdKBQNyv5GKNNvyCbDWFJrPbSoJx5Npit368QyshzbeqK	27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	1403	824	546	12463	18974	jxJozfsk46d24QR6PRSz97Eg9vo4Z7bqHBfSkAutraXyTgX5Le9	13825	19482	19482	1619445960000	orphaned
23284	3NKUtebvTNi5kwZXBDf2gCRMPqLHuDzWc7XbCudbcGrZMvX5SysG	23214	3NKNnZZVhS6WBT9zpPuAazXwGn3uQpacsJ39PhoGE3Rn4kvobN9t	1623	839	433	12463	15299	jwMzm69TmMGcY5Cr1SscU9MGgCi2ubyXS8tvzcPg9fryhdDXbHA	11517	16349	16349	1618882020000	orphaned
23324	3NKksuE17wBkCzWBJ2vEVVxwf7exya31Po3qvN9AafQd37KoYXmY	23244	3NLfN2EHZXxhBbmk1zJphYcKjpMdeRrVVTfzGAb9jJG2Ev3L7WXr	1581	778	433	12463	15336	jxz9yxZ4yvw1Au9Y5CmAPmoYAUGjk3NXXfm3uUaVCKTuenpghQq	11548	16381	16381	1618887780000	orphaned
23388	3NKTEEyNws1Nk1nzmp921c2gnRVkMkcL9iMk5KMgvyNFjQz3arbE	23327	3NLixR6wXTXdmLK6ww5agBpKS1QfJYmFRyZsZmdY5CBncbYoHcQB	1581	778	433	12463	15396	jwFux6pTLN44LeL2MLNEajBKGs3VP8M7rAewSAVbNb4YXviS4VF	11550	16423	16423	1618895340000	orphaned
23387	3NLmMbam85dtqmWgQVeEazxAhSFL9vcPi9wToVpiWVTHRDykXkCx	23169	3NKi6aR5g9KswbdeCqmVm5UUZSxFvyqaAALdPYzcLkNN9fS4ZFWZ	171	1248	434	12463	15395	jwEwqcvt4WWhdqUVqqpnpEzXMaAUhrM4ovQUoEiq7GSEapED3Lx	11570	16421	16421	1618894980000	orphaned
23271	3NKWX29Ugh32muXYh3QFResHqREJWtcrvgjBCFPAxNQbrPMKefpW	23198	3NKFovacUvB4xwyyoefnBzCURB8YNtZW8FfbWtWBHaxJDfZnv4ep	596	1306	435	12463	15288	jwMSRhd12DynVT1RNFgJPEyUnQ3NsgnJn4GNNmtbAGd4nEBFq4d	11581	16339	16339	1618880220000	orphaned
23272	3NKbqsz6JygoJALJE3PYhuLKCnpXJRkjBCueNdEzDAZietUWMsKP	23270	3NKcsFi7DCc7ttrqSZ5CHYVrvBzBhBQ68a7aMj23jQzYJB7L5aoV	1506	1373	436	12463	15289	jw8JX7cvMZaqcdoKhDQ2DVFEm7FBv8YRcjQDJd7EXYLs6DTbYyC	11611	16342	16342	1618880760000	orphaned
23278	3NKpzyCe39nWev2xwUNGu6119FZUMc8auuj6ZShtistqAjcd3HqB	23277	3NKKFkzf1sNGuNuCcUzDwLBQMkJvjCy42wzJV3kdi6LSkqdYtP88	1406	1393	436	12463	15294	jwBb9FnLBYYvP4FkDiCkF87gyFb26HSREHG7igXAuCc8tLTBT1u	11614	16346	16346	1618881480000	canonical
23279	3NKDQqx5g3P5sHgrP4wRkBtvtsLDhdAx4Xv43cW1Cwx4d82zA4TW	23278	3NKpzyCe39nWev2xwUNGu6119FZUMc8auuj6ZShtistqAjcd3HqB	1541	1052	436	12463	15295	jwJ6bbt5vKiAHhSMdW9xBBjGTdbi4ef6nQpWLzPqdanBY8Y1wbw	11615	16347	16347	1618881660000	orphaned
23291	3NKckMHjRt9qsyqwSfDkDVoxXecfqWdc7UzuDET5APpwjsFzjQV4	23289	3NLu7GhZbwJymniTD3Fu4retBfGjg9iTZU8LTen1mTkvGfrouKWC	1610	1068	436	12463	15305	jxxK3QZ3j1aDjaVj7wMvMH95wbUE2V1UCS7hP3n1bYivohn8sry	11621	16356	16356	1618883280000	canonical
23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	23291	3NKckMHjRt9qsyqwSfDkDVoxXecfqWdc7UzuDET5APpwjsFzjQV4	1553	776	436	12463	15306	jwdJ8MmhFGFsXXwHAaURYZu34jPD99YXk69AKtzNm3vY54EChQG	11622	16357	16357	1618883460000	canonical
23293	3NKphptFT1f8PGoreZLwU83Lpx4kB1XMgihJMjn4oAkFE53JNecq	23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	1439	1033	436	12463	15307	jwqGv4JFP3xCPqXSMcEmsnMxykT7HfijZPCh1vL5GmGmfHJCxNp	11623	16359	16359	1618883820000	orphaned
23297	3NK67xsFFoHHczoZV3WSZt9vCiziChRFEEFELg2PZQk3MznMATQU	23295	3NLSWvYM5Yt5VSXiMRWcjc8k9ahfbLyVCbXxnsVg8Mou74VbTcqZ	1671	1365	436	12463	15311	jxhRGgneSZ2rHAnxmbps5E2763XZgstskJjEePNharYWeEmQe8k	11624	16360	16360	1618884000000	canonical
23298	3NLhCvp5A3Xa1AaufKiYg2zhYq6X6p3ZP8DVWRQqhpBjFD8zXV8g	23297	3NK67xsFFoHHczoZV3WSZt9vCiziChRFEEFELg2PZQk3MznMATQU	1637	816	436	12463	15312	jxr1yNkDCB2CoUq5jWwZomG3bPDedzVpBN1jiKyBPGiBtTVxLVK	11625	16362	16362	1618884360000	canonical
23299	3NLCReMd3ZdwckJwr4BwecMJtcNyxLtzGAz8LudJSfUvaawyVdzd	23298	3NLhCvp5A3Xa1AaufKiYg2zhYq6X6p3ZP8DVWRQqhpBjFD8zXV8g	1407	1395	436	12463	15313	jwhKVaf5s1UFc9BgL2QHnhwkxvB2UKwtVJVdUGi44vyEgPeGtKj	11626	16363	16363	1618884540000	canonical
23304	3NKwobmnyaEjQvY719wF8PtZ9a3a7Fyukmdm1ZyZDk68FeZ1go8N	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1445	1290	437	12463	15318	jwbCkYRfxcvcut6qbxaM8CCMhXm194AaZ2jymMvZ4efEJa3R6hq	11629	16366	16366	1618885080000	canonical
23310	3NLRMByJH17h5HSbSBhAp2oeh4vXt78uPeMcQi18F9RCB9tARZB6	23308	3NLtNXhnG7pKmbpky4C3VTj7D1X31Np7YkNQ6KAH3FiZDkedo7di	1406	1393	437	12463	15322	jxH7fAJuDoce2kCD5LCq2eiz4XmZM8SVjdT3sgM6KAcr3JovvhF	11632	16370	16370	1618885800000	canonical
23311	3NKttqw356xNngj9n4yPr2yS89Q6Vwoqf4qYhErSxv1joyKz1dbb	23310	3NLRMByJH17h5HSbSBhAp2oeh4vXt78uPeMcQi18F9RCB9tARZB6	576	1355	437	12463	15323	jxgKZK9qvoBJ7TbDXmy3HeqgpKeGE84h3krvnJLGQZB92vczoQR	11633	16371	16371	1618885980000	canonical
23317	3NLP9gzfRkT24HsWCDBbABFzv962g434KUWv6ehi7ueCdGKPVFDT	23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	1637	816	437	12463	15329	jwAoWfwtGL659oMz6akzYziFm8CHFxi2psesEVR2dtQDEVNPnD9	11635	16375	16375	1618886700000	orphaned
23318	3NKGUayTsvAEQWR5P1GGx4w5Nsy8LNYnKDkRLRHPg3XiKLaX6J4R	23316	3NLMAHkytwAQCDis5K69YgsATE2pf3m7bqPXqrpJyB9jESVLt7aU	1534	1191	437	12463	15330	jwpbao3zfHEa2o4AX7sV6DqL2891uaxg3pvjHht8EfdLt768i2A	11636	16377	16377	1618887060000	canonical
23351	3NKqTsp4FDcfyg9rqcSkJK6zFF78sr2rLXKuxgcFP6mSboAd3XbW	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	1637	816	437	12463	15363	jxJHFY4FzW4vU4ZYwx3cgA5ocTsSbqgm1aaVgaVLgpZLzY4vLL4	11652	16397	16397	1618890660000	orphaned
23355	3NL7yN5oHUgMS5f3v6mWsMfetfCVKGKTrfuYd7LFb6fPr8kYm68y	23352	3NLteZwhjyZst2FY9Erxw9NbKGEYwd8zC52Z9WrB7oKNNJuiWJim	1594	1326	437	12463	15367	jx9Sz1RePNeYMA5RzD3ScHQkHwGYPma4gykL9PAiv4cbLResZvJ	11653	16398	16398	1618890840000	canonical
23356	3NKRUuctLdujQbiAyePCvcRSHdyNEq7UjCmoRbmtfWZktVDkiZVL	23355	3NL7yN5oHUgMS5f3v6mWsMfetfCVKGKTrfuYd7LFb6fPr8kYm68y	1617	1288	437	12463	15368	jwPd1exaJwThkskhj8osJKUjHfNU9AvdBiKnS5FYnmWRjfMUiTj	11654	16400	16400	1618891200000	canonical
23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	23356	3NKRUuctLdujQbiAyePCvcRSHdyNEq7UjCmoRbmtfWZktVDkiZVL	1599	1287	437	12463	15369	jxgafMUyLfKpYBxrGhj3yuNY1HRzJoPAvM8itJfbcuETsbPhvN7	11655	16401	16401	1618891380000	canonical
23362	3NLCN6eTVNDoiBTUKv3sKvZ8QPXpa8XcnfMHPWFDktN5udMZyQk7	23361	3NLGXrGAUhtcUKpadhv7YfFTGzj1E9ejSg44Hi5qtXmPat7jAzz7	1564	972	438	12463	15374	jxxXDNnpjhpja6vtMncRr9HgfpmhsSFwt7f5Sso7DYgD85VN9pR	11658	16404	16404	1618891920000	canonical
23363	3NKwPdJK4TBy2sDnvYYEkABig6EEsCX7eY4NgVVcTyLmtezRaqEh	23362	3NLCN6eTVNDoiBTUKv3sKvZ8QPXpa8XcnfMHPWFDktN5udMZyQk7	1500	1171	438	12463	15375	jxpx6QjSmZVP2oZCb6KwWNfqXcmGpyFQYbGW2K6k328TCRZfPLm	11659	16405	16405	1618892100000	canonical
23370	3NLFMq6iXWxFja4b6eqCL64MaD32eHopCf1e4S1dfSTAhVKUepYA	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1509	954	438	12463	15382	jxTsKByLAoyrfUM7MBayrWsHHgTX6fFf1EWhW3zsfPAb6prZqWU	11663	16412	16412	1618893360000	orphaned
23375	3NLi2Aig3wVyL6khJs6AMj7fpvHXN4wNtWQpnhULr2mMK5gaXb7k	23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	1523	1075	438	12463	15385	jxtCoFc7PHYLM8wVwZ2tcAjsQNhDKcM5UsNy9fSjmiVhDs2fCQb	11664	16413	16413	1618893540000	orphaned
23380	3NKLknE9qRaR5mQ3ePniwf1dqGZN9DK8NT7nYoCPwRhLAywfHUYt	23378	3NLcQbqSKpqA68dtqbJuHKF3RJR1pus6hsT9TRdPjbvbuU7D2wff	1617	1162	438	12463	15388	jxNHSUtsEXH8tnRz2rapZmHCAGX7FP6MdAY3i6yhWWo8GCezabd	11666	16416	16416	1618894080000	canonical
23381	3NKMf7uW3LxAEPxEcQifkNhK5V9KFZH5e7w2YLcPtQgfwhgy6zNY	23380	3NKLknE9qRaR5mQ3ePniwf1dqGZN9DK8NT7nYoCPwRhLAywfHUYt	1407	1395	438	12463	15389	jxRL7PcfzFwQZkJZ4UTxFzBGgM1P6R5E1Yr2f9bEUKm4oECRz4S	11667	16417	16417	1618894260000	canonical
27963	3NLmV6iazh6zfCP3dRkgmmcyZYJgswdEt5S5mwStgyhRL6rr4sug	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1581	778	547	12463	18974	jxUCtBFgTonNvctiLUFPykgTYogm9kKWQ1aEc7eFj99MfSaYs93	13832	19493	19493	1619447940000	orphaned
23280	3NLk2ojMNVYNZURnBKFieS3eP8njP2mUnHfiiNYP15FmrxG3Q9YK	23278	3NKpzyCe39nWev2xwUNGu6119FZUMc8auuj6ZShtistqAjcd3HqB	1541	1052	436	12463	15295	jxSubmxKywfPfbgZBtjxdWbxMBSgfZn8GPwsyroipXHP15gBuVe	11615	16347	16347	1618881660000	canonical
23286	3NLsnV828WN13GTm8kQFACo9YE6huPqN4UYpgqEPeyH24efmZnQZ	23283	3NLPvCEGGd2ggHP6PHtUYhunzBMgkPKXongmJaH5U8CQ49hi4ha5	1529	1316	436	12463	15300	jy2DwvY54akYpGdj5kW8C5Ask8b5ymTCvpB6ixBnvxHk5rHStv7	11618	16352	16352	1618882560000	orphaned
23287	3NLwBRGm66CTv5FVgyoH4brGAtMNYF7ixR3Y54SfJWwpSvLw9VkF	23285	3NLf8QYgWzCdPqFMriCbXKxfCr8bL1Q1VyHxi4AGSNHMXXhFaMoe	1509	1320	436	12463	15301	jwbxe3LPbJBeyyvcR68UAzYUAJFKrhe3rLZCGDyDKXya3jn5wL3	11619	16353	16353	1618882740000	canonical
23294	3NKxMeTxe7sE513H7QGiJcECS9g9vmeKfBsRx1DiUy76uziz9shc	23292	3NLBwRgbc7PZKLVSPCLmt7TVGgQ9cM2RWBfCzam4bC6G9DKjW1iy	1672	1285	436	12463	15308	jxLqHnAFERbTqJ5NNwouyGTUTiMvbsNy4S3XSY8APfy62v9dDMt	11623	16359	16359	1618883820000	orphaned
23300	3NKWdthsH5MsjcpUz5RbkBDiBbjX2MRJmzcxrEA7RNhxjpH4riuy	23299	3NLCReMd3ZdwckJwr4BwecMJtcNyxLtzGAz8LudJSfUvaawyVdzd	44	1325	436	12463	15314	jw7Cd3Fa5kSDT79vsCcM1MmzNc7GZb6JG3Jd1Kp5uCXnTSEsAMA	11627	16364	16364	1618884720000	canonical
23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	23300	3NKWdthsH5MsjcpUz5RbkBDiBbjX2MRJmzcxrEA7RNhxjpH4riuy	80	1027	436	12463	15315	jwKHK4X1rjsRSQgkptwFSyzW2jwar1HcNrQkn6jXCz36d9BH3xZ	11628	16365	16365	1618884900000	canonical
23305	3NLPHeUS5aQQae4A2WzQtzwarzc6SnqMeTcDHTpzbddbMctwHRE5	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1460	483	437	12463	15317	jw79LsoUMNi9YQpqx4Jm9PwqM2AX8qjD6ze8pnSvogEWdwaUSCF	11629	16366	16366	1618885080000	orphaned
23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	23311	3NKttqw356xNngj9n4yPr2yS89Q6Vwoqf4qYhErSxv1joyKz1dbb	684	1352	437	12463	15325	jwpZGnWu7PF1iFtEkxHane6oBFZeE9KLL6owFfrW63SeL5AruLT	11634	16373	16373	1618886340000	canonical
23320	3NLt5cySyuGyHXdSymsS8oqYDS5W85RRjbg16kgxXWk19a9LJGG6	23319	3NLh8LebVgzycGpjb6hntmdpnRfeHQP4Hfcabsq3JcvZSQQw99Xm	298	1062	437	12463	15332	jxVLizaUVV47A23wwqJQ6NyU5hpE7aav2dHcUBYDxnbGAkPFUQn	11638	16379	16379	1618887420000	canonical
23325	3NKhWXB6HWvmgbYLnFRYt5MQLhNvChkubHWEKRNpLXX6t7epTWPP	23322	3NLyBQJdGyDFQxZckT56xhFKt9nTmEwSJfbkXA68WZLUWscPT3gi	1631	794	437	12463	15337	jxkcRfx5sR3ypzeTdu27fYpxVvqSk8trTNoDjK7WWBxB87vRZvs	11640	16381	16381	1618887780000	orphaned
23329	3NLRkZSzDvdqUGvPFXfg5CGaq3G69CpiezSmy54DjKk7Dk7jEpQg	23323	3NL1v3YMLjg4EC3BYMpXXj6mMTZuaKGmkMkDBzvLjSm5dtpodygD	1651	935	437	12463	15341	jwzUgWMTapweyKG62QZWjusz6xe3Mwm9DRnunwYPa7FXmKBopL2	11641	16383	16383	1618888140000	canonical
23326	3NLo6nXK4Wyi2pfobgBirMz1aeegzuqvMXaBPXTVpouC13HNF5pG	23323	3NL1v3YMLjg4EC3BYMpXXj6mMTZuaKGmkMkDBzvLjSm5dtpodygD	1403	823	437	12463	15338	jxrZQp8j2wNfg3cHzo69eT1p2s7YS7UR3obHEymbrvXEtJKNcgw	11641	16383	16383	1618888140000	orphaned
23330	3NKgptAuTRHieaTHgrfym2Lpi29qmanoNtgjNNSrFaJnng13RTXy	23329	3NLRkZSzDvdqUGvPFXfg5CGaq3G69CpiezSmy54DjKk7Dk7jEpQg	1458	1197	437	12463	15342	jx7wCeiSdc8NHQCn7wYxFFmZS5NGTiDGdhbDz3MshzdqxdktKAg	11642	16384	16384	1618888320000	orphaned
23334	3NKS5d7C6FPBaF2WHqziLmPoJRNw3D5rRR1WTDA2tNwSYMBAcf6P	23331	3NLPE9SUz66h5cxmamMA9TgW24nuN9DBkwLCkkErxZ7DNvoZnesU	1652	1069	437	12463	15346	jwzasJyoHd7ZPdmUzyXh6jB8bkWaJEfRY52sK61VtGD4HYTwoNn	11643	16385	16385	1618888500000	canonical
23335	3NKW3i3jHh1mXrordxZwpXqbgowz9CcitPNoptVqAv1wz3HwCSyf	23334	3NKS5d7C6FPBaF2WHqziLmPoJRNw3D5rRR1WTDA2tNwSYMBAcf6P	1447	1345	437	12463	15347	jwdgYjP86gcyxLwF81v14zZzEG9moydsoBf1AC527wvsiTS5Qh5	11644	16386	16386	1618888680000	canonical
23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	23337	3NLGVZBu7gv3eHghBsivowe8NQs9MApq25kybPUxJGu9xF8EhhrK	1460	483	437	12463	15351	jxFVbyZwjZF6geXGJKwwLDueChmCswCK3y1X5LZ4UtAFQkYrmpP	11646	16388	16388	1618889040000	canonical
23341	3NLtmxYhcQQ4RipvkiCRuvfg2uFA3S5nQ5q3NboDFXKxYFMCf4WH	23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	42	1361	437	12463	15353	jxr9KBVRQJU2ZPedYTR1QcubdjypXCho39FbBTUWPdtK8SZyCfE	11647	16390	16390	1618889400000	canonical
23340	3NKTU9jV6uSM1skvdy6xHzFazLXzZbmviGhYD6BuT1iCrD9QWthw	23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	1553	776	437	12463	15352	jxt94mixWkR7W8YwZaE1utkJxJkKbBpv1cx8yRdg2pARwWpyeTh	11647	16390	16390	1618889400000	orphaned
23347	3NLvoPkbVdssdHsJYsbGaWekN4XrQsKFyopcEhE1do19SyfxJQDw	23345	3NLrjeFaxqR7Vm8hU1yZBfhaxadMgUNpY5GEvDvT9ttyKk4zZ8WT	1457	1391	437	12463	15359	jwL19KPovcHwSGWihf26EB3nDMe2sgUT6qzoqnEB8NqH2UhizQf	11650	16394	16394	1618890120000	canonical
23346	3NLmTYkNh7im7wndiUCPsxxU25hcAKvQ37z3BfHFCzvVp1UPLFr8	23345	3NLrjeFaxqR7Vm8hU1yZBfhaxadMgUNpY5GEvDvT9ttyKk4zZ8WT	532	1303	437	12463	15358	jxuMq7LjE453267tD3FCAY7XhG5H3wwSySHofS5SzTRxNxwdCz2	11650	16394	16394	1618890120000	orphaned
23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	23347	3NLvoPkbVdssdHsJYsbGaWekN4XrQsKFyopcEhE1do19SyfxJQDw	1471	1140	437	12463	15360	jy252XRh2ZpyB9mj86i4ZF84XJmAaBzvUFHzs7zb7EuwJUJUGMD	11651	16395	16395	1618890300000	canonical
23352	3NLteZwhjyZst2FY9Erxw9NbKGEYwd8zC52Z9WrB7oKNNJuiWJim	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	1406	1393	437	12463	15364	jxYduY2EJFmGJQGZmuaR1DaA2JKbs17YcX63XW65XrtmoPbs8gZ	11652	16397	16397	1618890660000	canonical
23349	3NKu5SDCM76bEV9WvRSxPvsSHkRwUzBGxKhc8Rv51K5jdqCCrb9p	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	1588	1392	437	12463	15361	jwdJffzWJ5zw7evpTUy8y8CyMp9gDdq5FSAfvEwEaVGuEbAEwRS	11652	16397	16397	1618890660000	orphaned
23358	3NKHdYeciFcoe2pxKVu1usWRATHXoep5KwdTCXV6Qj9uPYfTDLUb	23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	1405	867	437	12463	15370	jxJPkpc8XcsmnzeoPa4yzb7K43Np6H9j49iEKGVpGb7BJibTuBt	11656	16402	16402	1618891560000	canonical
23364	3NLD9uwL8YHUE6BEe4BTahgA5AkF2HKgm7VVQaCDudTrCYXtgg8b	23362	3NLCN6eTVNDoiBTUKv3sKvZ8QPXpa8XcnfMHPWFDktN5udMZyQk7	1600	410	438	12463	15376	jx6GVsDJ5FjPzmotLdAsZwJZuqK1xKFjN4d9ksBZDQfhUmnUabw	11659	16405	16405	1618892100000	orphaned
23365	3NLTBsyrK2fWkU2Y4Kydea4UT4wXAjmLTFgBpkh2Kroifn8ttnSb	23363	3NKwPdJK4TBy2sDnvYYEkABig6EEsCX7eY4NgVVcTyLmtezRaqEh	1406	1393	438	12463	15377	jw9X6y3BQW8RTgvD9yeAKEmBYLf9Tps2g6FSArFjnxHVYkhN1RK	11660	16407	16407	1618892460000	canonical
23371	3NKBmKHBivKYXkY6SAH3GaM8Whm4fkwLgh6tbU2rfmGVoFcNip7C	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1509	954	438	12463	15382	jwyKXjYuGBAJiZQBdbVZBCAMxvtX8VE5ZGDvwsZ8nrsBYcwXSr3	11663	16412	16412	1618893360000	orphaned
23376	3NLUuqayNJbp1ZKySjFEx6dctX5KxCuynwCAhyEVy4q1wGYbvakU	23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	1523	1075	438	12463	15385	jxKxpaUX8hiAr6HpaQi4LojBBYQb9p8xvM7swzuje9W6Q2cr9Zu	11664	16413	16413	1618893540000	canonical
23377	3NLnSf4Fwjev3UbMQta7m6fyWq1TtSdn4eWUp81dA4i2MGBTGu3a	23376	3NLUuqayNJbp1ZKySjFEx6dctX5KxCuynwCAhyEVy4q1wGYbvakU	470	1063	438	12463	15386	jxoGhZK95nVGDY3zcHZ3j25qVrTdZndwmVDT333WggE3c8RDiUw	11665	16415	16415	1618893900000	orphaned
27970	3NLKeRmoFvTz38CACBDaXzc61qWjGiyMd1aFSTr7m6HVWGUZsoWQ	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1439	1279	547	12463	18974	jxvLiBTyJY932sXVhFKgZ9TzWHcQsPtqoBrBzUtJEdwoTT7gqkS	13835	19501	19501	1619449380000	orphaned
23314	3NK6sUhW5MaDtbLqYfRvC3M9uXG5WoNYkJTetG5kGCRaABrdQmaC	23290	3NK8fNUMQ2cwX9dtwFUybSap9ZpHDG4Qfn3CLo6Ty1zq37M1zvWC	1461	1271	431	12463	15326	jwuP1XpXiE6Gec66HYy3uKBiQzaKh9UsMFfaZdFWTLh3nBLhjcV	11486	16374	16374	1618886520000	orphaned
23366	3NLGTCZVbANzdrcHsyeqT4h7vLJMpGNdNEuHXH1kvxDAfhb2VGuE	23314	3NK6sUhW5MaDtbLqYfRvC3M9uXG5WoNYkJTetG5kGCRaABrdQmaC	1461	1271	431	12463	15378	jxWfSXfPUKxSTFwihcEF8WaM74setMUGtsJy4zqzHbsBgec7TBw	11487	16408	16408	1618892640000	orphaned
23327	3NLixR6wXTXdmLK6ww5agBpKS1QfJYmFRyZsZmdY5CBncbYoHcQB	23324	3NKksuE17wBkCzWBJ2vEVVxwf7exya31Po3qvN9AafQd37KoYXmY	1581	778	433	12463	15339	jxyEBUsJKMjKTzuRj3mn2Bj2PTdMfWhBzQdoxMsgQyBmJP2JFcJ	11549	16383	16383	1618888140000	orphaned
23315	3NKzoFR3MvX9e1J3k1gwfzxcNSxFo4vxcYxWRBbR9EgfpPSE1pop	23313	3NLQqdpvqrJMB3BbdprQJD34ptnTk2H3Ek2NBieLM4DRM1d4XBFc	1610	1314	437	12463	15327	jxkoEAiSVT7cBdzvqfeNJ9FrZNXZBSU8hrHyp7shZJ1TZgH32Zs	11635	16375	16375	1618886700000	orphaned
23321	3NLNqDnGaNEPKhdMWdSEG6pHQZNHq5fAB9z6a2UsZhy2tCyrxDh2	23320	3NLt5cySyuGyHXdSymsS8oqYDS5W85RRjbg16kgxXWk19a9LJGG6	44	1079	437	12463	15333	jxBi25ReTCEUcjWdrrK4YFL7PBiCoJt3SgNoB3RjCMNtsgaaZNL	11639	16380	16380	1618887600000	orphaned
23331	3NLPE9SUz66h5cxmamMA9TgW24nuN9DBkwLCkkErxZ7DNvoZnesU	23329	3NLRkZSzDvdqUGvPFXfg5CGaq3G69CpiezSmy54DjKk7Dk7jEpQg	1406	1393	437	12463	15343	jxfVj7dMi9S765qVjmnhjXLu1qzHFVKqzgnbJXyausKdMsVAWNg	11642	16384	16384	1618888320000	canonical
23336	3NKyKHZALLSXWXjcRyTpqRs7ScNeX42Rrk7fMRgTKHdsH6tapFiV	23334	3NKS5d7C6FPBaF2WHqziLmPoJRNw3D5rRR1WTDA2tNwSYMBAcf6P	58	1155	437	12463	15348	jxWzA7D21y45jca7tEhK5GXy1LkjCsinrH9oN319XEq7mvS4fV5	11644	16386	16386	1618888680000	orphaned
23337	3NLGVZBu7gv3eHghBsivowe8NQs9MApq25kybPUxJGu9xF8EhhrK	23335	3NKW3i3jHh1mXrordxZwpXqbgowz9CcitPNoptVqAv1wz3HwCSyf	1483	1150	437	12463	15349	jxAHGFHvuTjhKLpEBHNSwBrDhLDw9iLEFP8rPmcVZfm8XUDG1gQ	11645	16387	16387	1618888860000	canonical
23343	3NKZCqrdsXFsxCsreKwN7fHuTm57Uh7B2nQH9CEhSqpVn9A1gmYy	23341	3NLtmxYhcQQ4RipvkiCRuvfg2uFA3S5nQ5q3NboDFXKxYFMCf4WH	1591	281	437	12463	15355	jwDTgpjxTP2m1ucCVy9kNEqxeH9J2An3FNe6HgXxmQ4kubejcRM	11648	16392	16392	1618889760000	canonical
23344	3NL4t6y8PQBvpGVCcPKE2VpNKMZEtJvFfe2bjdi9UwT22uLswBcf	23343	3NKZCqrdsXFsxCsreKwN7fHuTm57Uh7B2nQH9CEhSqpVn9A1gmYy	1422	1337	437	12463	15356	jy16yP973DJAizJ5WiNFTa7kb1LQAtzP4Ko1SfxSYyXGiCMKqDT	11649	16393	16393	1618889940000	orphaned
23350	3NLCnTVEGUr1pYMjX5c1VEQS3U8GbpFoJ1MA7ddEwW9J66k4HwBb	23348	3NLUJeu7mWWMh5yZxie6RpG3McLrxQXSSYB9gfNNsRg6K7RmkhQw	80	907	437	12463	15362	jwsBJfx7bS1Mh6joYjHofBFW34LCvPWJCawddHD7PBHT8jzc3VW	11652	16397	16397	1618890660000	orphaned
23354	3NKSNz2wwrgeaCaBnpg1XUsVM4TKkCnhoVNiUcq1Nsn5iE4vrRhf	23352	3NLteZwhjyZst2FY9Erxw9NbKGEYwd8zC52Z9WrB7oKNNJuiWJim	1593	1346	437	12463	15366	jwTnw7rMZ4pgpa284bEu5NmRuqFuZ2NwTfDHuzmyzfLBmDhbcyp	11653	16398	16398	1618890840000	orphaned
23359	3NKALnG2E9pLQUzMjnbYkTLdLr3ew1gKVarjYKZNCYegmtaWmP8T	23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	1407	1395	437	12463	15371	jxh5Y1c4qwSA5Q4JLKLp4zpovTSUZxfDCdfoRQR2Ke4yg8FNR8W	11656	16402	16402	1618891560000	orphaned
23361	3NLGXrGAUhtcUKpadhv7YfFTGzj1E9ejSg44Hi5qtXmPat7jAzz7	23358	3NKHdYeciFcoe2pxKVu1usWRATHXoep5KwdTCXV6Qj9uPYfTDLUb	1403	824	438	12463	15373	jxDekGReGNmpZ6342s5RYcMfuyh2PCzjtWdu4D77koe33Lutryf	11657	16403	16403	1618891740000	canonical
23367	3NLhGAJuPk5QVpsknK9maPn63MXVkDmxBjJ33okPHgGL1awZr6x2	23365	3NLTBsyrK2fWkU2Y4Kydea4UT4wXAjmLTFgBpkh2Kroifn8ttnSb	1623	839	438	12463	15379	jxNCRmg8dXdGs6D43YhXbCfpFaFfgxtiK9HWFbZyuS7pnDToBCq	11661	16409	16409	1618892820000	canonical
23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	23367	3NLhGAJuPk5QVpsknK9maPn63MXVkDmxBjJ33okPHgGL1awZr6x2	1547	1252	438	12463	15380	jwdVnLmaxsJkzsstnEdsAphhggAWMFgkYX4JDVv8xDbsc5L2DLq	11662	16411	16411	1618893180000	canonical
23369	3NKvHv3oyC83L6n85u58Bnk3dEC8UHemUu1ZbWRtaYDWHCZn25ma	23367	3NLhGAJuPk5QVpsknK9maPn63MXVkDmxBjJ33okPHgGL1awZr6x2	1406	1393	438	12463	15381	jxQvyH8BajgfBgBtxGEqrUtmnWJgnLodZVPUvzkyRPkjzjZMrkn	11662	16411	16411	1618893180000	orphaned
23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1406	1393	438	12463	15383	jwPqtdAtwgjeFXVAVuTfEtEUEWkZi4nxD3ZsFf4QMFNGHEEK6Mw	11663	16412	16412	1618893360000	canonical
23383	3NK8i6wDe128n1vSdA2xxrtYmW86v2mm2QwHx6NP4YFpEefVT4fi	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	75	75	438	12463	15391	jxzDYyqodAWv66RJqZAnXDHC7Z2751Cs9U4iK9Ft72s8WVm6LYf	11663	16417	16417	1618894260000	orphaned
23373	3NKxMyLNaZBVeUHMbGfua5skFyVq1dhAKm7Xe3WTMeN8SwvCemaV	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1634	1205	438	12463	15384	jwUUd8PeiBWzEYDxwkBzppwtc6qi3yoLSggiNPmmR51o25cbvaG	11663	16412	16412	1618893360000	orphaned
23374	3NKFYpFxVGL1fpEx7rfqxZZt8j5zxwCZxNnABpz6mdUfAc9BkFLj	23372	3NLBojQGVL53Caus5nXys7wmTDPKMDrMg9DimTEr5DfC2qTtH56W	1523	1075	438	12463	15385	jxgfujZPXK32MPCusRZ1K2GpMCQg84PrYDZR3PtK7L1ZwPGys65	11664	16413	16413	1618893540000	orphaned
23378	3NLcQbqSKpqA68dtqbJuHKF3RJR1pus6hsT9TRdPjbvbuU7D2wff	23376	3NLUuqayNJbp1ZKySjFEx6dctX5KxCuynwCAhyEVy4q1wGYbvakU	470	1063	438	12463	15386	jxCmiWQSGj5tx1TgnbiRRjKQWU4dbSYdAgfjUP5s18c1yLzecbS	11665	16415	16415	1618893900000	canonical
23379	3NLNu4MSQ5v25t5TPw2VKY3v5RrQMB93eaTwNrpxnwiHqzo89jt6	23378	3NLcQbqSKpqA68dtqbJuHKF3RJR1pus6hsT9TRdPjbvbuU7D2wff	1403	800	438	12463	15387	jxcBvYwWJQWAxshGQfMm2A7E7GWoBRKNyu94ZhqswmWS2f1htCp	11666	16416	16416	1618894080000	orphaned
23384	3NLjNLSLBCpRo8G8dnjsxMZCezrQ6UrqKwzJz8idt2EQyTSUYZPk	23381	3NKMf7uW3LxAEPxEcQifkNhK5V9KFZH5e7w2YLcPtQgfwhgy6zNY	1599	477	438	12463	15392	jwVd9LVTDnCfXBZs9SEHcxWhtNE13Ek8WsWDQRH4ihRiAoQG861	11668	16419	16419	1618894620000	canonical
23385	3NLsWf2q1uD1ULTxPuRr3xeBmNp9hqcK2cATYg7mCZR8H5oK7GDK	23384	3NLjNLSLBCpRo8G8dnjsxMZCezrQ6UrqKwzJz8idt2EQyTSUYZPk	1594	1080	438	12463	15393	jxZqy1q7D5hdPY3XeYsLgrbrAMyqgsvb96XUugezLxEdyup3oS9	11669	16420	16420	1618894800000	canonical
23395	3NKpWSD9oqcrv1LWSDGRsQW6xYoh3PbS5b6j6WZ6ntSb1MS4kTzo	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	1483	893	438	12463	15403	jwcPJdayw2WYiJuDnDS3RxrahrvbjCPPANusDCuwrKpnGwtZAiF	11671	16427	16427	1618896060000	orphaned
23398	3NLsFqjmPqtxATh9iiGGTUb8dNWGWFx9Dty6Qm7QdHpYbzt8zunA	23392	3NKQskzJwTyvsCxLVcbHc55tqwt9Rx6kc7Esk7EpTQutFf4CPpqf	1403	824	438	12463	15405	jwbZuuoHjuCAHUsBv1fsbGJxpnjaHPCbbNheg4GgcrzhzkVusBb	11672	16428	16428	1618896240000	canonical
23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	23402	3NLwmyRjXuHR5vxruGJJZ3BdNntzcAmXXCAZanK5THGVEZG8Gdqp	1637	816	438	12463	15410	jxffyjxMmU4TmL4NAwsBDYJZdetoh78pgfz25DnaQi8GxKr1CNa	11676	16432	16432	1618896960000	canonical
23404	3NLd5LxYW7jKmWrMziJAimk35FRCchEopbf7RfWXGDa8Ck83tb5u	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	1477	1350	438	12463	15411	jxPbYfoLt5V8NXTYvhrJCuK4pvqNejUpCAydG89hNtJbWju2Ys7	11677	16436	16436	1618897680000	canonical
27973	3NKspcLaosp1MnXS6AXpxTEZwDA8Ap4qmpd6yUn5iagEKKpHEizK	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1529	1070	547	12463	18974	jwhvUWBaRyGFHnMRmUztgA66BGEVbRaLrVzhWnLaNbhJvhWeJpw	13835	19501	19501	1619449380000	orphaned
27968	3NKhwD5pUpodjjCG6bsdPYLGysiK87eczwSUZeZXTDMDmSVGv1U9	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1588	1392	547	12463	18974	jxfrffc18RjEhz7XuVh8T7iUsceb3MfMTe8KzmDi3mgKyHBcCEh	13835	19501	19501	1619449380000	orphaned
29360	3NKwbhGLwAn5Y3mxZgEcKSq7ctRj1DiEF6y14GQoNzffPVijDYVf	29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	1646	1354	576	12463	18974	jxHiyY6emMmuBUWmwHX5y1w5BamfC8jrCFyZ3SdtF8LkDVwojLx	14469	20370	20370	1619605800000	orphaned
23397	3NKBUddCjDjysbX8VgHUSHxSzZPeLtaf5jwZujxyNM8FYUa45s3S	23290	3NK8fNUMQ2cwX9dtwFUybSap9ZpHDG4Qfn3CLo6Ty1zq37M1zvWC	633	1384	432	12463	15404	jxwT1aFw18jtvYYfJrkFZQTh42NuvipFqz2zLuRGFmW5k7xXfNS	11486	16427	16427	1618896060000	orphaned
23410	3NKEULYugW9NFZzmGHmJDycAnZ3hh6iQhKMURphLfR2gPdeukVNg	23156	3NLw2UA1unfvrHAkieZTGUa66tisQvLd9nrZbRoKKX6JWnvRn58T	1444	1015	434	12463	15417	jwcCRfzKXYizTPT92KpiqGjJbU5U9RqLtbKvmkwZaGmd9N7QmLf	11538	16439	16439	1618898220000	orphaned
23389	3NKGf9Bi7kJrrkUR5fNAaySjA7LNnuCTU9iCjWfTsCapY9zgoLSv	23388	3NKTEEyNws1Nk1nzmp921c2gnRVkMkcL9iMk5KMgvyNFjQz3arbE	1581	778	433	12463	15397	jxYKykwh54TPKQwTSkBacn54EYCicBwVwHWaHDv3HxZPfoa6EuD	11551	16424	16424	1618895520000	orphaned
23392	3NKQskzJwTyvsCxLVcbHc55tqwt9Rx6kc7Esk7EpTQutFf4CPpqf	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	633	1384	438	12463	15400	jwG1Vg8AsvAFaAPqXeRU4HsqTR3zqtp48dAmvg2z53ipcVe8g8W	11671	16427	16427	1618896060000	canonical
23393	3NKXsNydThGNcAmJGoPsaheTZ6jWRnVxytjkK2KRuEV9HGD9kvJj	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	1503	1151	438	12463	15401	jwR4cn2NHvFpKYqfgXCq4vSt1rmaXf9TQNc5FYTXV4gDWQWyzDn	11671	16427	16427	1618896060000	orphaned
23399	3NK9reipQLxRaXtiQnR3LgZJDQsvxgNUBoKY1YThFcVVE8geUAwQ	23392	3NKQskzJwTyvsCxLVcbHc55tqwt9Rx6kc7Esk7EpTQutFf4CPpqf	1406	1393	438	12463	15406	jxPRP9SPQvwryVi1RWJzdMg15bQtAynPnYA29Zi64eRTrb8X84j	11672	16428	16428	1618896240000	orphaned
23400	3NKw9wDx2WiFqVT8rXySoNdFft6GVM4ZWNDPuQ6Nqk96JdhMH6wS	23398	3NLsFqjmPqtxATh9iiGGTUb8dNWGWFx9Dty6Qm7QdHpYbzt8zunA	1405	849	438	12463	15407	jxvf2TMqZq76v9XUehFHNV8MhQh4WwwDGCmckrNjd16E3RdcDpZ	11673	16429	16429	1618896420000	canonical
23401	3NLstXoXMtsaqGQYXGfHKfovKPmhLNd6CZu658SNyb7FL7TJqTXD	23400	3NKw9wDx2WiFqVT8rXySoNdFft6GVM4ZWNDPuQ6Nqk96JdhMH6wS	1600	1372	438	12463	15408	jwtoy9k4ssDsHs8QoK3YXya34Eytua4ADgx4ZwjVFYGmXdDvpjh	11674	16430	16430	1618896600000	canonical
23405	3NKTm7pA1ZSWcrphzTnknXaYaszZ5Xx9tKdGc4doR3ZLSiQZue8M	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	152	1330	438	12463	15412	jxWhNc4KQabfShGgKs7jVvFGThnWSSo5ja3hSKHLWHKRxKpCntR	11677	16436	16436	1618897680000	orphaned
23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	23404	3NLd5LxYW7jKmWrMziJAimk35FRCchEopbf7RfWXGDa8Ck83tb5u	1407	1395	438	12463	15414	jwHf48wb4uTGCgczYgZErwVzKAz1hSKbmfkLvriQXRxvdd9ZcG4	11678	16438	16438	1618898040000	canonical
23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	23411	3NL8JXzPS1MULMYE6gMxxSPE7FtpvNnSpitSqwS12Fd8gLPraA5U	152	1330	438	12463	15419	jwckiK82y7P5vSx8oHNPNQokXPPWVF3zM9vb9NxqKLvd4pPneLi	11681	16441	16441	1618898580000	canonical
23414	3NKv725dsdgiVvXGgK7swLf98pLRsZ4USdSvfcmdiQSNTxKfspvw	23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	1587	1111	439	12463	15420	jxfhmqsojffBHfN5JrRFvioyRhkL5JUwas1Tbdh6VyhabHoXT7Y	11682	16443	16443	1618898940000	canonical
23418	3NKGWGnHDjjksvZUjLR5v89dNnP5pFEWhwX3ZLEAB9wSv8BCfAZz	23414	3NKv725dsdgiVvXGgK7swLf98pLRsZ4USdSvfcmdiQSNTxKfspvw	1529	1070	439	12463	15423	jwZ57aFvawGQ9e2jzgFDsSN17Xf4uepfh2xE4FyK7HVpVzc998M	11683	16444	16444	1618899120000	canonical
23419	3NLyQGWqA5ZLAZhe1oVLyteLA62U5sbkHK7S5QP46hXt9fLQsJDH	23418	3NKGWGnHDjjksvZUjLR5v89dNnP5pFEWhwX3ZLEAB9wSv8BCfAZz	1553	776	439	12463	15424	jwDv5m1DgaGK2KandtiPjmLhRNjeYnm9hf2YYro2b9knGeNmGGa	11684	16445	16445	1618899300000	canonical
23420	3NKHtRFDVYxywvyzzJn4ZddbbDvgUaHDSAzArwrijbWT1CXNMicU	23419	3NLyQGWqA5ZLAZhe1oVLyteLA62U5sbkHK7S5QP46hXt9fLQsJDH	1483	562	439	12463	15425	jxELMwjyFFPYPRAq6wycvuhY9y9ZQRUDciCQHjWXUFKeC4R3kS4	11685	16446	16446	1618899480000	canonical
23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	23420	3NKHtRFDVYxywvyzzJn4ZddbbDvgUaHDSAzArwrijbWT1CXNMicU	1631	794	439	12463	15427	jwgaaFEkPCpiyEcvam4goaedMEjK84WMwMWcqMhHRr16hWPJPLt	11686	16449	16449	1618900020000	canonical
23423	3NL73PAhNrFc57J7uEohFE3a8JmVpX7tc9XcbkV9z6rYNqnimmip	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1445	1290	439	12463	15428	jxywM97VzaYejsyid2fuWcdZJePyek6MJDr6q2ecciLN2TpTA79	11687	16450	16450	1618900200000	orphaned
23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	596	1306	439	12463	15432	jxWMroofisfgvJ8r9xUtUkLaf59Vq1YtN95YVPe3vS4tjukDnAH	11689	16452	16452	1618900560000	canonical
23431	3NKRuKbyCAWzmujFrd9drHMSSUAfK8RcHsX9ER54fQBMhZt5WZxD	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	1506	1127	439	12463	15433	jwNJahLx7bF6xpV1CRcAkG2Jspc5mE7A5juxfVfjqjwHX3fVYux	11689	16452	16452	1618900560000	orphaned
23432	3NLt3qz61fDixuXmRDrm1jLdgrQpwdXjtY4sDi6sRsAarTsyHnvM	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1608	1289	439	12463	15434	jwK8sxvSsatMpXZMxp8XipAVxNvumGg2KAZu6tMVunyXGL9ymfc	11690	16453	16453	1618900740000	orphaned
23435	3NKGAKHjWXdvxmJ3H6oc3h3whRHrfuFAx16bA1FnZx8MwChSwRTa	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1541	1298	439	12463	15437	jxD82hHYvWF1XKBPGcGyD6YEEWSYcwH2Pdj2pb9abfpLqLFYemt	11690	16453	16453	1618900740000	orphaned
23437	3NK7MZ9yToaZa4scshyd2jE8hoBYiRq1XEKbj9jfSX1NFBLNYK39	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1405	851	439	12463	15439	jxLq6RxoqrbXi8nw4U1BcaCbd9cSJiYSwJY1hCtSXTYkqeS3Mgh	11691	16454	16454	1618900920000	orphaned
23441	3NLoQ4ugpfPRjWmbFmBZpvwXLtaXtQiu4XZxiuEy3LLRoGT2nJyN	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1406	1393	439	12463	15443	jxpTVJFYyPig1UY3mNT6ycaREuxKyCbuZa2boF7mcuB6M47GYJe	11691	16454	16454	1618900920000	orphaned
23444	3NLUrQcvmVg88FJVP9ykwZWXURyBWA5YpgSsVwRyf3JrgZgrECyQ	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	404	404	439	12463	15445	jxhavBddsXP47wE1GwEeTYcCGENSYhfoSQ6tTPsHNzjgG6dTFUd	11691	16454	16454	1618900922976	orphaned
23448	3NLKxKUy3E4PR2jDGjekLR9DMewPEtoHfaBiBLNNzPHd81zFMb65	23439	3NLoGNL2q9jeGdZrVJyZ35txUpiVVe8hiR7UE4QYxxVZsPGe3ibi	1406	1393	439	12463	15449	jxoPAN4SbYi5R3pCDCCLLeEqySXcVZqtbRhBwf8pRoxd2LwdRTy	11692	16455	16455	1618901100000	orphaned
23452	3NL7FdGoLmFGLhVDEazszUwUFFLkpnfhb65QCmujcgwrKTbLaM1v	23451	3NKbFpGgmuFRtSCJoPivRA597pVrQuuWunvH194b4z5oQAo6c1wQ	1460	1198	439	12463	15453	jwNqoXZ8s7GmipwHAkxRLqfTSanQKBBVunWUXD9ckT55hEebNbi	11695	16458	16458	1618901640000	orphaned
23457	3NKjteTEt4DrPVbkyTtFg2EkgrR3VFk8Ka6EwLLWE8Ebyo94onqH	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1458	957	439	12463	15458	jxpQkxtx2DMLbkin95D2w3gc4Udw47nWH4gwERBHPYAFHrPR5RL	11697	16460	16460	1618902000000	orphaned
27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1397	827	548	12463	18974	jw9Csfp7w7g7qmfnyXKQs3iTieHb3Zb3k99TTyow96qJaFUxMAA	13845	19517	19517	1619452260000	canonical
23391	3NKn6xRvM9aPbk2f9stQHny3RQ7V28YK6UXV969UpwotvrGBFDJH	23385	3NLsWf2q1uD1ULTxPuRr3xeBmNp9hqcK2cATYg7mCZR8H5oK7GDK	1403	824	438	12463	15399	jwLJ9J2tkFEXDoMEx1nTHFAqEXbLGVmCSrsrY6VdvHcL3GHaMwi	11670	16425	16425	1618895700000	orphaned
23394	3NK9axSMmWiBGK2auTvXSJCSUVragUeJvmHfj4odQLs8aNE9BDko	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	563	1359	438	12463	15402	jxVzSEGDU4Qcmdptae8tdNcUDw4epmqQKvLSNWxR3spYQwFqEtB	11671	16427	16427	1618896060000	orphaned
23421	3NLB2SZVtBsLwAHsSqWY3tb7NKhFYEfSP4yHqTNV57sJRxL1WY89	23398	3NLsFqjmPqtxATh9iiGGTUb8dNWGWFx9Dty6Qm7QdHpYbzt8zunA	1483	562	438	12463	15426	jwwvpJzqRNMjDr7tiimjiSDuDz1Qc6Vt34j89EMkU6d6TDdvuGE	11673	16446	16446	1618899480000	orphaned
23402	3NLwmyRjXuHR5vxruGJJZ3BdNntzcAmXXCAZanK5THGVEZG8Gdqp	23401	3NLstXoXMtsaqGQYXGfHKfovKPmhLNd6CZu658SNyb7FL7TJqTXD	1647	1302	438	12463	15409	jxXHTUQv36NN2fK7dRbJGxBZ6qWNveNAp3M1s4X6KCtrmfDksa3	11675	16431	16431	1618896780000	canonical
23406	3NK8yMRf5iSkkbnvnoSSpV6hx6oRDy1J53WZQxHz9gDSTDsfCm7j	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	1559	1227	438	12463	15413	jxFsk7c4kCDYZikkvsEdirVvpbdFNZJiZ5mkXKisUeLhgEReqmm	11677	16436	16436	1618897680000	orphaned
23408	3NKyedfBXT8DMFk1e5tpFUdHj3xsfBM99rFVJBgfPVkkPNE48XaF	23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	1471	1140	438	12463	15415	jwgdCE3u8kPnwChUqdVgLNgeHQasaxC3AYCejNV8yQLXDyvN3vH	11679	16439	16439	1618898220000	orphaned
23411	3NL8JXzPS1MULMYE6gMxxSPE7FtpvNnSpitSqwS12Fd8gLPraA5U	23409	3NL3CEHP4z85gbXdrzy4mYgqC5ngjrEGBtCyW2MrVzQHisAVvpKu	1490	1274	438	12463	15418	jwK3Xd33LHMgKrfwZgpZ5wzvgaokbun9aXTN2sn4uzSrxt8B3kV	11680	16440	16440	1618898400000	canonical
23415	3NKMGCTZvphib13HW2J2vYvrVMEaSZsHWwRfc5WUGp4dh8jVuoT3	23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	1553	776	439	12463	15421	jxnBG7qm8qU43Lk21G3uRg1szGr5HzugoPRhzVBheL6bSjRoPwK	11682	16443	16443	1618898940000	orphaned
23424	3NK6ECghT89r2CaG9Hjrntfkdt94TPEespqjXFZYduANituACt2c	23420	3NKHtRFDVYxywvyzzJn4ZddbbDvgUaHDSAzArwrijbWT1CXNMicU	1445	1290	439	12463	15429	jxF7S4xfSePU7LGfTTQLrsz8aYFFLCPYttfHWA9jL4v9N5V3xsJ	11686	16450	16450	1618900200000	orphaned
23426	3NKPTrmyHknVvXejNZhrYLjotq9LbLD6ctpUkuJ1uHbZUm6k7NrN	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1445	1290	439	12463	15428	jxm3LgBh5n88ZNF3oXfMmoxT3YrTjpy5Y6Q6e4AEZVReXdUNacy	11687	16450	16450	1618900252147	canonical
23428	3NKXHLHZb3cpFkfNEyjXsdfHcKetfAS5D82GwKDuaS4Pm2Rwa38T	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	1405	867	439	12463	15431	jwQL9CTabsoYsHYDwkzyMv5u5uBaas1cxUoW9LSRNHq7k9dNaHC	11689	16452	16452	1618900560000	orphaned
23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1490	1274	439	12463	15435	jxBXUKSQQ4r2rTwB87tJyGatmTiZMBey96f3hCjfdLL2Ux7dBxM	11690	16453	16453	1618900740000	canonical
23440	3NKFpYiXGoxkFmiznaDX2EMP8SFM4rTMJGNUKow21mNrp2ePm6L1	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1602	1123	439	12463	15442	jxEEFDimyo3dPYAbxPVMeAi53p8KxxwEGU1NTayEnszaDV4rV2Z	11691	16454	16454	1618900920000	orphaned
23447	3NKwgm212Y45QiovhjVakF8YCGL19EHqmD52knqLz79taYKjurtP	23439	3NLoGNL2q9jeGdZrVJyZ35txUpiVVe8hiR7UE4QYxxVZsPGe3ibi	1407	1395	439	12463	15448	jxhUwbNURMwRApqR5TM1btsBRThxHaqbTrJ2sPQK7fvR5NDztpx	11692	16455	16455	1618901100000	canonical
23449	3NK85FGcLKcB3qjsapz6fxhEGJzn2TA1qcFvrPih4WioRJgAbrSt	23447	3NKwgm212Y45QiovhjVakF8YCGL19EHqmD52knqLz79taYKjurtP	1483	578	439	12463	15450	jwYK5JnsCZS7P4LGXAp2gCpE9ginzEdM4NEakp3WQvkPCVQyjM3	11693	16456	16456	1618901280000	canonical
23456	3NKn6UnLQxwKBPfKApxSJP6r1ZqK9tRrB6PiRaebFk4Qf8bLwjFh	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	80	907	439	12463	15457	jxUdnAvKYQM2rKvNofCZNReoiXPxGCbshF55YpWk2hkpnJQZZQV	11697	16460	16460	1618902000000	canonical
23465	3NKBdQyYCaQxxQpZMUQp1fokQgRtYprUmzEqkmh5b5aT8eGBoiwg	23464	3NKuCP7RKNQgSwVq4TTirPqi6xvgBz9TsavSsciCK8zctsHSJnzF	1571	1089	439	12463	15465	jxt38JQ8fAkDh427gEKYt5ACNGJ4tAwz58NZbkzjpRNYc97cZSJ	11700	16466	16466	1618903080000	canonical
23468	3NLboa3WzjLSf9QknCne7nbDu3fCsCvVXtXzvn69dsM5JAT5spjE	23465	3NKBdQyYCaQxxQpZMUQp1fokQgRtYprUmzEqkmh5b5aT8eGBoiwg	1406	1393	439	12463	15468	jxCRgjFAqnjn4CVCh9f6yRYVMMHj5SEVcPCjxPDGE4PQHwvymRL	11701	16467	16467	1618903260000	canonical
23467	3NLRiKUFxZ6rui5D8sQzPdLxuL5c3KvvzNTgSGbdug2dnshLNqrt	23465	3NKBdQyYCaQxxQpZMUQp1fokQgRtYprUmzEqkmh5b5aT8eGBoiwg	1407	1395	439	12463	15467	jxiREiYs14wJ19CnyGsBHF5L26Nzran8ByTRxo1gjBnnfAfGoZ8	11701	16467	16467	1618903260000	orphaned
23470	3NKq6AuovBWm1CauHxiAGkznqHZxxAVV8tybN4Mds8pHGXiMMmns	23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	1407	1395	439	12463	15470	jwMkdyZFeBVFBFbLqka6wToYw6ntTdWk933zsZgNWHJRgP66crj	11703	16469	16469	1618903620000	canonical
23475	3NKbkoHY4KThE6peCBsLk6XrmKKXcSD955Hc2dbXHjCmJ6GEmE9i	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1523	1321	439	12463	15474	jxVHaK1HSimGvTpG41K23mHLaKmttfcJnQbrJ3T8EAXJt2s6RxF	11705	16471	16471	1618903980000	orphaned
23484	3NLuLshKwZ45hBkPBoHSgbF5GB1HLUf45s8q7teuS3KGSXFM9H8y	23483	3NKFrVMcPY5FpvdiMWYLFYi7KT7yZTtZxdEtgriLjdxVfhkkFb5d	1406	1393	440	12463	15482	jxFBjNsGSd2vNa9vXPWbDCQFMNYv1yPwTP8xC6kfaDRuciftUho	11710	16478	16478	1618905240000	canonical
23491	3NLsZFCKTD9FVQgEZzN3oR8yPUDetwm86HMvrYgG2ZuZ5zvzzKu3	23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	1611	1095	440	12463	15489	jxtEgCoLDvSyvpaiW38qo3EWCkN3J2BeqonYPae77n8sC6okasd	11712	16480	16480	1618905600000	orphaned
23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	23492	3NKTVpsS2zmeFjeKhMjPnezTmnsKH3kDhKgfkdJJzc6t8Y4NPta7	1534	164	440	12463	15491	jwE7emyLWqncDgWbJ83E9AWtYPR9RskRsy3W5QteGMqamLiUVvJ	11713	16482	16482	1618905960000	canonical
23496	3NLkEkscrsxwK4sdyEiwsJ3JbFxdGSpnqYdZW3TifvncAtMbWidj	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1654	1340	440	12463	15494	jxrpBvy8sTUo6w6uxteTYTmjmMC68fgHiS7LjhvH6j2tDPfEBCM	11714	16483	16483	1618906140000	orphaned
23501	3NL7aPqrdnBNS58TPMGjDEymhCQrQa8Woms79gpgxKjHhNZXFUmi	23498	3NLb2G1NN1jyJWtajJPRe7Ara7kxehQTCqUcMR6AqLaUc22nTrXM	1611	975	440	12463	15499	jx3Tz83BJegXWt27u8cZne2VQz5SsZLEUCFCEN4Ljso1s6HHrmn	11715	16484	16484	1618906320000	canonical
23504	3NLwLh6TMWtjqu9sUHW4EfR7HUsPENFLzCeUjRCwg77Qpnu5SaER	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1403	824	440	12463	15502	jxgy2Hx9QTiN7Yt6sMMVto3tLtmrCjn5nUNdMTxz4a9gQbYqLKw	11717	16487	16487	1618906860000	canonical
23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	23504	3NLwLh6TMWtjqu9sUHW4EfR7HUsPENFLzCeUjRCwg77Qpnu5SaER	1474	1329	440	12463	15506	jwjsRxRbFHJvGf2bumByU59AFadkw6mpaJGAugcChyap6PpMcL4	11718	16488	16488	1618907040000	canonical
23511	3NLLXMq8X4QkHD9jUWMZBkZLb8DFKxHDK8mUP7ne9t73FbETsAX3	23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	1651	1301	440	12463	15508	jxMyTgMULqhvVW864uqkWYcN7qYK6DmBw38pkUpTVtms4ucyJyx	11719	16489	16489	1618907220000	canonical
28001	3NKmRTQJJG1JC4d6YWFNvJhrydKefS5as4mkE7je1WCyFZx9yR5Z	27988	3NKVaChVRmy5VfEqGHF9DPUdcrEebABkYDZuTDE7V42SrMe1ZCmE	1559	1353	547	12463	18974	jwe2WUH5L3GkcAQ8vjKfKmmBhd8qnXTAzb9YJb4hXFtsDGg3JSz	13845	19519	19519	1619452692054	orphaned
23462	3NKGvz8AAAbquty8zEyci75Q3rDQPkqCFiBFEMGYKK6mNLkAGBnd	23410	3NKEULYugW9NFZzmGHmJDycAnZ3hh6iQhKMURphLfR2gPdeukVNg	1444	1015	435	12463	15462	jwAsbWeMMoauksnjWAXZcxP6wyWBtAs4qmwggKgMNPQAg75geiR	11539	16460	16460	1618902000000	orphaned
23479	3NKYGYGeyxnW3X9zBfEiPRVbvT529FQbuLhBW6iGbF4N6WEVfWN7	23389	3NKGf9Bi7kJrrkUR5fNAaySjA7LNnuCTU9iCjWfTsCapY9zgoLSv	1581	778	433	12463	15477	jxxyD3qZ1onA6DQ4DRXzLCVfBvvpbLg9om34PNxdLEeYL6obY18	11552	16473	16473	1618904340000	orphaned
23450	3NK8c4GbLH5y5vMBWmiYMp5ohu822NGThkLKJtJ4LUxzBq8ioMgY	23421	3NLB2SZVtBsLwAHsSqWY3tb7NKhFYEfSP4yHqTNV57sJRxL1WY89	1483	578	438	12463	15451	jwvuh124HBfLbZ5iyXNGwBjxKBt5xRWAA2zqSjtMpUkFhTmGwkV	11674	16456	16456	1618901280000	orphaned
23486	3NKNYUydqA7ntKZeAAenThkeRt7Mu7To6ec4ptGi7NRVQYrGDeKm	23403	3NLSxV9mSmXcMCZF58vp2xtkyCp7GnnrKzVVrZCe4YTVSiTQqAKd	1460	426	438	12463	15484	jxyu73C9ghNVyQ8DKvQmetXJXtTMQPGzu8q5VxvJQ3WUts2SrY9	11677	16479	16479	1618905420000	orphaned
23409	3NL3CEHP4z85gbXdrzy4mYgqC5ngjrEGBtCyW2MrVzQHisAVvpKu	23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	1444	1015	438	12463	15416	jy2AGCALwv8Vhxr6zQ1qnFN3ud97drkx4uxF6izPjQ4rYtN6uHj	11679	16439	16439	1618898220000	canonical
23489	3NLJoNbZKTjeDu3si9swqwEskJCR5nPbydyGP4qpgptgjYyvHjs6	23411	3NL8JXzPS1MULMYE6gMxxSPE7FtpvNnSpitSqwS12Fd8gLPraA5U	1460	426	438	12463	15487	jx4MHekWqU1tN5MeVcAnFDGhmsTA3akAru79oW4ffFKBKr3634P	11681	16479	16479	1618905502854	orphaned
23413	3NKvfoykb6FUfoBcrPjVJF1kfZ1i6WonbDvLxq89S5KpN4sS4uvQ	23412	3NLWNKXo1MVgXHweiXD22GHC1VbFvV2Z7NmbfVCXTbPbVMGdCZ6d	1587	1111	438	12463	15420	jxdLCHmYuRmfrFTjfrzzWv1fDo4M9BFn96K7fXHBJ4AMVWe8JM4	11682	16443	16443	1618898940000	orphaned
23417	3NLfFFt41WdQi2uuaYT3Q2iFkmBMtSL6tNWKXBLm11NZAmoPqGVF	23414	3NKv725dsdgiVvXGgK7swLf98pLRsZ4USdSvfcmdiQSNTxKfspvw	1529	1070	439	12463	15423	jxeKfmEkSd4yEm52Q2eMsB9DvmN3FYu3N5B5juHhgHXaB9didKM	11683	16444	16444	1618899120000	orphaned
23430	3NKPgf185ofEftn1RNTbpyQBHSAgSiUdyGndF2B9tE9YMSorri8F	23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	1506	1127	439	12463	15433	jwXtsiskLckmZKjHW8NGt2VkEUM3whrcr4L529XqAkiApbmriD5	11689	16452	16452	1618900560000	orphaned
23442	3NL9GEWABKgB3iaetwCD1C7uB7NucUx5tzjKEnb2RUTytRLP8Z9u	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1529	1316	439	12463	15441	jwqXcJHPuFcaGezYdcm1haZsuydTpuQWKYxivjhNoGa1eLBFHrV	11691	16454	16454	1618900920000	orphaned
23453	3NLjEVYUAUwdu3ZBySTuCsDRTQvq7SBECqjzmiDqYxGLUPBGaADQ	23451	3NKbFpGgmuFRtSCJoPivRA597pVrQuuWunvH194b4z5oQAo6c1wQ	149	1037	439	12463	15454	jxqqeFSCDo2cp9D2crN6jjKVkK6izqLhjcHtoj4Zk1ARogjpdRE	11695	16458	16458	1618901640000	canonical
23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	23453	3NLjEVYUAUwdu3ZBySTuCsDRTQvq7SBECqjzmiDqYxGLUPBGaADQ	1536	1313	439	12463	15456	jwZfDf9h4zPDBa9bWHeioGmVB1PcyGSKHjpGw169txJ9YAsYSUy	11696	16459	16459	1618901820000	canonical
23458	3NK5PosmbMUTbE9pYmCgCpW32B8p9hwKK2CBRHNnJkRnoKT4sAwY	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1440	1011	439	12463	15459	jxN11Xt9QByJ8KeHL9qFBrdwhncCivAPYNee4cet1vGuTVgw3Ln	11697	16460	16460	1618902000000	orphaned
23463	3NL9rgXVY6hk6EcrtZgPAFFzNGH4jsnv9Ge2sMW45q1JbqXFjFFW	23456	3NKn6UnLQxwKBPfKApxSJP6r1ZqK9tRrB6PiRaebFk4Qf8bLwjFh	1631	794	439	12463	15463	jwZTbuGDCBfdKqbty7zmnYormvx5wS6mktry4MmuJv2ML9vZruD	11698	16463	16463	1618902540000	canonical
23466	3NLfD1qPPvSgzC8NGW4dzPPBTHusrgQefu4EEyJofcmEGpLYZzWC	23464	3NKuCP7RKNQgSwVq4TTirPqi6xvgBz9TsavSsciCK8zctsHSJnzF	1608	1289	439	12463	15466	jwEccdzsz51zS1MSGcQQYu6T7sjyc8iBrpgs92VuvT6cQPRGBfn	11700	16466	16466	1618903080000	orphaned
23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	23468	3NLboa3WzjLSf9QknCne7nbDu3fCsCvVXtXzvn69dsM5JAT5spjE	1406	1393	439	12463	15469	jwX9jdfogRbn4zkK9LCYxsv1jyZq67iYfJahJBPaUVPVEQrCCBD	11702	16468	16468	1618903440000	canonical
23471	3NLo4WMtfY8bxXUJpA2sGZ8qps6Xb1QFS5jyQvMM9tL8ViHN37X1	23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	1553	776	439	12463	15471	jwigmAs9VjqupNdxTuZS3qfgn6FTk94zGHN7rwtJezwsfuUYvga	11703	16469	16469	1618903620000	orphaned
23474	3NKcPpUvyMivSsAytuK7bXkeDxxPwrsMttpL4QSduS7dVyEJEuL2	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1523	1321	439	12463	15474	jw9Bf4w9yWkbFfonZbW8kP4zR9nEau1rKQC3WdvN2dqB3q3u2N1	11705	16471	16471	1618903980000	canonical
23476	3NKNtfoWHLUt7242ywMXsYHvqjqqrSb55HCnJp32reGM5fPuUWMV	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1523	1321	439	12463	15474	jxenX82UTNNAZ11FzxXGr8C9kkWq3acqdAQciA86wrF1PpLXXqk	11705	16471	16471	1618903980000	orphaned
23481	3NLa8E96fvNZtZuTwa8k6ywQuJ66WBYm4wSCscbcY9Qa2J8SfHvV	23480	3NLvy3bW6pPJWUrm7MQ5JGxUY7uCDRT63v3uVW23ccr25ApvTkyS	1555	1347	440	12463	15479	jxcnd76HUzU5xPbmQguFZGofkKgPzmtpQc1uACjMQvX6kTj8D7v	11708	16475	16475	1618904700000	canonical
23482	3NK8JNwjngzso7rSBMv1sk7dHDbmTJRdJfWiwrJrYrd8QQZ7sCme	23481	3NLa8E96fvNZtZuTwa8k6ywQuJ66WBYm4wSCscbcY9Qa2J8SfHvV	684	1352	440	12463	15480	jweuLHcREuUHuWk8StUcdKeRYrTYv4aUaUmG7PFnb9zMxJPqZup	11709	16476	16476	1618904880000	orphaned
23485	3NLWU5rsJDcwBxWZzgugUVJkByK8AhRJQo3ZdtShCcUdmEdn69Qt	23483	3NKFrVMcPY5FpvdiMWYLFYi7KT7yZTtZxdEtgriLjdxVfhkkFb5d	1601	1262	440	12463	15483	jwSeA6j7B6CA6V4DazEtrBBp7MpPautHCgzCuhip9Q2Aa13YnVK	11710	16478	16478	1618905240000	orphaned
23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	23484	3NLuLshKwZ45hBkPBoHSgbF5GB1HLUf45s8q7teuS3KGSXFM9H8y	1460	426	440	12463	15485	jwdGeMvKXrf8pnMs2Qxf4ZHCNo1w8EswCQr1udJ2Gnc8tHe13Ne	11711	16479	16479	1618905420000	canonical
23492	3NKTVpsS2zmeFjeKhMjPnezTmnsKH3kDhKgfkdJJzc6t8Y4NPta7	23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	1555	1101	440	12463	15490	jwYJmqyNXy9sbzicZCSbgRGQEg3Q2HYepsaffhNBZ8Kjh34QMkt	11712	16480	16480	1618905600000	canonical
23494	3NL69i3B54xFQoNFWXyZ7RyFk9DC5FYaxRzNBWHmFG7Dj5DaH6ni	23492	3NKTVpsS2zmeFjeKhMjPnezTmnsKH3kDhKgfkdJJzc6t8Y4NPta7	1623	830	440	12463	15492	jx1kA5eFdz5WS5iMC7HXqPsQYKxhoMP3VWwiNNaWE9KMQdji7qW	11713	16482	16482	1618905960000	orphaned
23497	3NKrm6gknPnfRuiqYahcYQHAGRf4HV7R7LcnRdYPRv9LfyTLygRx	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1406	1393	440	12463	15495	jweo8aT7gdiSfYG3sUY7ZDaKzz31NhMzTqrDzs1REw1nYR45kTz	11714	16483	16483	1618906140000	orphaned
23502	3NLx6vZZj776M4TeesGhF2bT3RYCnxh7ykqjee8rm6f3ZA1XAWE3	23501	3NL7aPqrdnBNS58TPMGjDEymhCQrQa8Woms79gpgxKjHhNZXFUmi	1445	1290	440	12463	15500	jwrb34KTdNbGxazBEUCUJDxFeaCaHVUvpDS92hsis5ctkNWj6vz	11716	16486	16486	1618906680000	orphaned
23505	3NL6DVC33FtYZYtsibPUAeFyLnHTgupc5yeshYhRRYQoJe8FMGFr	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1406	1393	440	12463	15503	jxbi5YqnJAqPvfTdaugh9ZbuBiUm6Z2v3Wy4YyGAXYsHWoQvD5w	11717	16487	16487	1618906860000	orphaned
23509	3NLsJMd48it5iUQKryTF9iPrG6AC87U7bFymRu6V7e6rjetuAVYz	23504	3NLwLh6TMWtjqu9sUHW4EfR7HUsPENFLzCeUjRCwg77Qpnu5SaER	1474	1329	440	12463	15506	jxb4roLNQN4hghyeAcEZxwEGHqERSaDYZgjMt6SnKjXR9NLUbeE	11718	16488	16488	1618907040000	orphaned
28436	3NKgnUKx1cTry5RGhLPSaUKEokzhkZGxDyUwd23wjPfAAvSyfjA4	28169	3NL9qNrjbKdnt8KtDv2rxoVzDAdZyPnyXBwATifSPuHYZVJMkVJr	1513	1253	547	12463	18974	jx2XZ9cYuLyzersFYsLgbuBu7gWEN9wZsCyhxCtn6Rsds794N8u	13847	19810	19810	1619505000000	orphaned
23446	3NLZp3aZ4A6sWqFvpN2Y4WNggEXwScRsahyzzHdDSLujqVHBYNxr	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1602	1123	430	12463	15447	jwMN6G2uLKozxw4zSLBrttM5bPSWaR7ecRZYpT6BD9xBRLnrymg	11493	16454	16454	1618901047827	orphaned
23460	3NKjhQx4YWCWS7V66x884FxCU1dxveUyqpQtMH5E6VTqCacjd8Qz	23332	3NKhm6JGzYzvLkh1TCCFCuv9W3ypaWJHp7xtqVMcq63Sb8k5dv3R	1458	957	432	12463	15460	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11522	16460	16460	1618902000000	orphaned
23500	3NKoedTeGXzDFeobhEKxvKd9rAditqRAKn24MTJxjZimLLedpL2L	23460	3NKjhQx4YWCWS7V66x884FxCU1dxveUyqpQtMH5E6VTqCacjd8Qz	1458	1197	432	12463	15498	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11523	16483	16483	1618906140000	orphaned
23499	3NL5ujHbLymajhxbhfR7xVg8mw5HgHU8sn9LAUJUrDGV2PQWrfQp	23387	3NLmMbam85dtqmWgQVeEazxAhSFL9vcPi9wToVpiWVTHRDykXkCx	171	1374	434	12463	15497	jwYoN9xLh1tGy6yny4Tf8gXqCT8CS3FybnLpmAducymLgBFTJ3v	11571	16483	16483	1618906140000	orphaned
23454	3NKSsaewnKNxxQvhsNifb6njyd3hge8Dd4dwtzS4pfMGwyMcG17U	23368	3NKBY3vcoc8cT4fwxqdAmDvfkNgKhufRamrFAbn2EHFuDddg1Feo	1460	1198	438	12463	15455	jxNSFuUXcWN9m61ePdhYDeh2bMFomXkeu6vnALcpCBksEXVVxWU	11663	16458	16458	1618901640000	orphaned
23488	3NL31wg8gWDaDpZwzbU1mTUzAZBKtdReJAuUcchwACb3qw7aym1Q	23407	3NLoYY6yi78a8VEsYHKSFdkXZ9ijHt9oEFHFV5pyREm8ZHB5Aw5g	1460	426	438	12463	15486	jwS5Mg85VqHpzT8Gyp6h4PyxwU4Mdj2SvN3avvEgpnnjQRRp994	11679	16479	16479	1618905462340	orphaned
23439	3NLoGNL2q9jeGdZrVJyZ35txUpiVVe8hiR7UE4QYxxVZsPGe3ibi	23433	3NKKPd8Yu9ktoS53SUYKrFczkj5A8zigXx8LyA47jN1QFhg3phuv	1529	1316	439	12463	15441	jxkPRQgjzpdQmRzz3nMTHHTGhgb1BSu9pbD8U6UEQQtdR6eDsom	11691	16454	16454	1618900920000	canonical
23451	3NKbFpGgmuFRtSCJoPivRA597pVrQuuWunvH194b4z5oQAo6c1wQ	23449	3NK85FGcLKcB3qjsapz6fxhEGJzn2TA1qcFvrPih4WioRJgAbrSt	1507	1280	439	12463	15452	jxo7bUjxvWPhCJd5k1dg97Hpi2oL9ogbgf1kJn8VUi5JCU4w6Yw	11694	16457	16457	1618901460000	canonical
23464	3NKuCP7RKNQgSwVq4TTirPqi6xvgBz9TsavSsciCK8zctsHSJnzF	23463	3NL9rgXVY6hk6EcrtZgPAFFzNGH4jsnv9Ge2sMW45q1JbqXFjFFW	1407	1395	439	12463	15464	jx2tWK9dAjdyfPRioBiHMRLH1CEmsEqbukXP8Vp5Ls6J2Syq5wg	11699	16465	16465	1618902900000	canonical
23472	3NL7Mvd3LqTfu2kn131MnZZnJpernq6PepuZbDnifgXynK8Qw2d4	23469	3NKgW4CTSp5M5F8xz9RmiKZzAW42Ak4tBZHstoqkfZW5u2wH4yZn	1647	1302	439	12463	15472	jwgB4xCuXkMxfhcQkKFqBQrvsBHxayQzpf76w8rVGgi9tpStNHX	11703	16469	16469	1618903620000	orphaned
23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	23470	3NKq6AuovBWm1CauHxiAGkznqHZxxAVV8tybN4Mds8pHGXiMMmns	1536	1313	439	12463	15473	jxsvMSaVN3wz2ynkrtDmCq5GatM2JrdG5mMaawXv1QuifCzzdVU	11704	16470	16470	1618903800000	canonical
23477	3NL5NTYuhwVVHmuWZbBFmPcF6qsugRcfA4i9N8Lz6xeqP2n9BHYZ	23473	3NKqsKikzUUnbzyoKbRTaBWSrBa5i49gToFE8LGsxPQUCQh9sY6Q	1670	1282	439	12463	15475	jwF3CjDfzWXPzW8mDBiAA3QkYCdLBJPpXxUKEH83t2pUwgj2ubC	11705	16471	16471	1618903980000	orphaned
23478	3NL4JXFqvfZGZBk2ttPw47pAFqHtiTjVuSTztqqjCHH4wcjwmPVn	23474	3NKcPpUvyMivSsAytuK7bXkeDxxPwrsMttpL4QSduS7dVyEJEuL2	1672	1285	439	12463	15476	jwyviW33UJzbNSJ8BdyT2auUr76o9ssT9ZHynSkXZyz9Emhgdqf	11706	16473	16473	1618904340000	canonical
23480	3NLvy3bW6pPJWUrm7MQ5JGxUY7uCDRT63v3uVW23ccr25ApvTkyS	23478	3NL4JXFqvfZGZBk2ttPw47pAFqHtiTjVuSTztqqjCHH4wcjwmPVn	369	1066	440	12463	15478	jwVsFUMgMCVWaf2jh7pQYKVHRrZjC33LirJTnohstbzUyomLW9v	11707	16474	16474	1618904520000	canonical
23483	3NKFrVMcPY5FpvdiMWYLFYi7KT7yZTtZxdEtgriLjdxVfhkkFb5d	23481	3NLa8E96fvNZtZuTwa8k6ywQuJ66WBYm4wSCscbcY9Qa2J8SfHvV	1580	423	440	12463	15481	jxJ7H7DaW4ffZTch8137uBBRUeA6XCvqR1WRbRrEXftH9oTMv7k	11709	16476	16476	1618904880000	canonical
23490	3NLGg49gRAK4GYvfpDSP5Kyht1nBuTmaY12KSeSdhdqXfLBJx1ai	23487	3NKtXFS94uY7rzmY17iwQYKfPAm3V3Nwgc2iKcdxBKjJGyTcuE5f	1403	824	440	12463	15488	jwMYGwnyxPiZng69YspLcjpHvhv1tiYyzAsbNtDBVdfAJTssc1K	11712	16480	16480	1618905600000	orphaned
23498	3NLb2G1NN1jyJWtajJPRe7Ara7kxehQTCqUcMR6AqLaUc22nTrXM	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1458	1197	440	12463	15496	jxD738xJshknJ9Wz9iQZqDS84DcxvwUxB8AwUazwN4me4BNHd6K	11714	16483	16483	1618906140000	canonical
23495	3NKB2g1jEK1bEvjWa6credF8gGZYrW8AC4swM3RtLFbWkao7JQeP	23493	3NKTH9x7AaSmmRepKTqtP6yyL7xNy1h8svfhkVoq5aL9tSUpUVYE	1672	1285	440	12463	15493	jxBUEmxhoAK1UdujCKyt1QXyoWrc5QEXmxSKmsNR9oTaLLh3K7Q	11714	16483	16483	1618906140000	orphaned
23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	23501	3NL7aPqrdnBNS58TPMGjDEymhCQrQa8Woms79gpgxKjHhNZXFUmi	1634	1205	440	12463	15501	jwA68rc9b2nQxAk6Q7EZmZhomXn4Mv9GtGBQYVptY6nTkrErnGj	11716	16486	16486	1618906680000	canonical
23507	3NLjt8MUhf5gKnpHM5Fo9PrYTAyShx5Q45oqR6DUEomSmhUr8FAi	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1560	925	440	12463	15505	jwrUxCk4Wu3veJXE5exjqiSvupSnGm7p1woqcEAt1HQ99omFpii	11717	16487	16487	1618906860000	orphaned
23510	3NKhmkJxvMinT7pKtQyojxDaDWNouAnPbUenv5BQyJgT7cSZsgbR	23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	1407	1395	440	12463	15507	jwWuoNMVDfY5eDJymdUQ3GKwbMBf6frHrs9bHwzRQ2GjuEF5uGr	11719	16489	16489	1618907220000	orphaned
23512	3NKVYkWaatWkTMYivP2GWFTDbV7JA7fpoGrPGS5zcgexLCTHyZDV	23508	3NKUsfWxwA4TknZ9d58VRrLfUfMzsyj9XfWqnw4pdrCRmLoJksZ7	1651	1301	440	12463	15508	jwru48f1LFda6VwVM9KUvivP3pYzf7tihySARFgncfdhyDBDR1L	11719	16489	16489	1618907220000	orphaned
23515	3NLr9E7SHCPnxdqjAXtn6hmPMHNdQ91Y879N7f9G7NkJjJbd21Hs	23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	1448	945	440	12463	15511	jwTkvxeFByuvxkU7ApGmACFu6Sz59dTvggr5z3GbpDiMt3hfC7Z	11721	16491	16491	1618907580000	orphaned
23514	3NLHMAUz6B8UJxUtNSWjYLUJiaqbBVwLh9ziUShQ5s1zKsMZPsLt	23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	1501	1234	440	12463	15510	jxVLuXvB3VC1Aj3uQCGpty2CKxboeCofppE5WgQrtF2uiTkU2w3	11721	16491	16491	1618907580000	orphaned
23519	3NLjFCLhbRVm6QjPtXguZNgPwGtuxg6osehNS5yhuhharZBrB7MZ	23518	3NKC2SHtH2cbGoBV53e7EeUzcBr1PmdmUU7hvrM9sZcHDE9LP2rM	1445	924	440	12463	15513	jxUU9nKe9CmvAes8wDnctUa87tCCTXCmKGVvdPE7yo4WdsaedCF	11723	16493	16493	1618907940000	orphaned
23522	3NL15ng7XkNqJGYKX43tJ9zmAEN3wEayonDwbi8ZcLTLMxrGwLBw	23520	3NL8MDkmWLTVf7SXizYdF97bxghLpQcSeKp2JczqdyxpTz5pQjto	1407	1395	440	12463	15516	jwik5MJRsSskKxTFQcKt38Pic566TpoVGtqigWM3q6CG1F6tpEg	11724	16496	16496	1618908480000	orphaned
23526	3NLgLYSzg2dUoXCnfEr2mC8G93VikemXtnezSi8FnxPB1nKArvU4	23525	3NKBea8BWQ8ZbNWU2EgU4Sc1aVTBCv1cbWp2X1wyfC6pH4E4T1tQ	1403	824	440	12463	15520	jwVvtvnhrsfWWSi23bGpoVWeQAZeHDHyVnVW6DrJVuQS3tgSNrc	11727	16499	16499	1618909020000	canonical
23529	3NKycxTTqTuNEtXrXczPjXVoMe2iWMCok93nM3ju9A9XuUWWQoBV	23526	3NLgLYSzg2dUoXCnfEr2mC8G93VikemXtnezSi8FnxPB1nKArvU4	1577	1081	441	12463	15522	jw8Qf21LyTCCk3S9LJbAPeohAvumaqjXuz4zHdb5bfyXhu7Csr7	11728	16501	16501	1618909380000	orphaned
23531	3NKtBPCbyGpbPkHbzzx9ZVQNGE9i7W8j6dx7tDpmTwMi2RWaBmBQ	23530	3NLjeyZCv3ejCuxhHFNuWZi5ua5HsRpc1i2CnGvJS87aqbcR18sN	1402	882	441	12463	15524	jxCdL8EZPiYtV3Xg4GkTK3usKzAr7aBMiyVQaxF9qNEtGs3WCq5	11730	16503	16503	1618909740000	canonical
28542	3NKgR8u4NaEcNAVTQZTSoyCEG9PL8wxjRUGjaFobMUdyC2M6VW82	28436	3NKgnUKx1cTry5RGhLPSaUKEokzhkZGxDyUwd23wjPfAAvSyfjA4	1513	1013	547	12463	18974	jws4ts7jCRjaCbf5ju1EYGqyn3Lj6ERDUrm67KvjKoitAVkx2oG	13848	19870	19870	1619515800000	orphaned
29540	3NKqsbQWrAdYqKvac2FtR48bfZFXGqRYF57v7ETbdYgdB9uygzUi	29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	1610	1068	576	12463	18974	jxDPo8nZDHzPfTyWjNDphPM2RwJvNcQq9suT4oRGQZwnQaa27t6	14475	20500	20500	1619629282165	orphaned
23523	3NKqLXWhqH1zEusimLYHZ2BMBT3DPT3LdV1ySzk3gTfjjCvAEb7H	23349	3NKu5SDCM76bEV9WvRSxPvsSHkRwUzBGxKhc8Rv51K5jdqCCrb9p	1607	1348	437	12463	15517	jx3tiD49XTdcunovXbkyeZP5ADTksDWiUcdqVXbdkjiKKbtkymV	11653	16496	16496	1618908480000	orphaned
23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	23511	3NLLXMq8X4QkHD9jUWMZBkZLb8DFKxHDK8mUP7ne9t73FbETsAX3	1578	1296	440	12463	15509	jwUeHrhYfPQXSPCkccxpWThL8UTC1a9wuW9dWdP2xXKzjbvNQM2	11720	16490	16490	1618907400000	canonical
23516	3NLqPDMZujETmkTgTb1XkAmBWw1D24AJrH3yDSarVnvEBqWFJq2H	23513	3NLNqXRTevwfd7LaJBk7W26AGnsk6ewMb9PD8MgikBncDgiMiLLx	1448	945	440	12463	15511	jxXVR4wkKZhRSd4ohezUtMFcewpwZjYsMm3PGYwbryVoYH57yqF	11721	16491	16491	1618907580000	canonical
23518	3NKC2SHtH2cbGoBV53e7EeUzcBr1PmdmUU7hvrM9sZcHDE9LP2rM	23516	3NLqPDMZujETmkTgTb1XkAmBWw1D24AJrH3yDSarVnvEBqWFJq2H	1447	1345	440	12463	15512	jx44trBLZGTXfGRYwE7NHoMrRrTgdEtKU1TCdSDF3KtMvZWymmm	11722	16492	16492	1618907760000	canonical
23521	3NKR6J2hv3kWVfd6xFpdx7ixSPzhNoZzR7tuBUH6PaAys4izkw2u	23520	3NL8MDkmWLTVf7SXizYdF97bxghLpQcSeKp2JczqdyxpTz5pQjto	1607	1348	440	12463	15515	jwMfaNSZju7ZkT3L6UnKn2NkbKHuwE9VVVdajXfTgTAwTywcQwc	11724	16496	16496	1618908480000	canonical
23525	3NKBea8BWQ8ZbNWU2EgU4Sc1aVTBCv1cbWp2X1wyfC6pH4E4T1tQ	23524	3NLYmqY3ryGQzSVnu1VJX7aDJ6HQ2EBqN1tiW6Ri5RdMyVkJ3GSZ	684	1106	440	12463	15519	jx7DoXfEJNhFrxiJETaVFMmVMNht6Z96eC6ydEvvm78uz3NAXuC	11726	16498	16498	1618908840000	canonical
23528	3NKEWyVpkN9SEgSWaZvCKAy4YiHosc6Ji5NvR16Ff9fzLYvAHwnk	23526	3NLgLYSzg2dUoXCnfEr2mC8G93VikemXtnezSi8FnxPB1nKArvU4	1577	1081	441	12463	15522	jxc4fTeibP9ofU9BhHv4jkRxBMHGk2tFiQR3dBSYsjAQhT9fqc8	11728	16501	16501	1618909380000	canonical
23530	3NLjeyZCv3ejCuxhHFNuWZi5ua5HsRpc1i2CnGvJS87aqbcR18sN	23528	3NKEWyVpkN9SEgSWaZvCKAy4YiHosc6Ji5NvR16Ff9fzLYvAHwnk	1675	1216	441	12463	15523	jwCHhVv5aX3menCLjtWzJNk8EKtjKDMZriYLjxRTZtLVKmz7Afz	11729	16502	16502	1618909560000	canonical
23541	3NL9ihE9okVKpxuzoA6soSLh6XUVJU9d7Y4djjfASgFfZ8p1ZZ7E	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	1406	1393	441	12463	15534	jwMAgBUqGZw44AdSRKhToCBnSD4jowxMetCTpX6K7ZMjzMZ6uZN	11734	16510	16510	1618911000000	canonical
23540	3NKWZWAQcPkkrEXQz6kzJB2zBby2FhDgzb8vjJaYqbzYM1DAya9f	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	80	907	441	12463	15533	jxZtNg5uXUUGAnsuVsZWxvH9C9PjKgFjGBnQA2qUBWyM9Tx93SK	11734	16510	16510	1618911000000	orphaned
23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	23544	3NLSxhiqc9RFDuguAysDb6A4ZiWUmT9XUoDhzJXww7qbrDoqdaXE	1560	1045	441	12463	15538	jxQcETaE53kUcoUPptyPTrP1PfKZHesTWQ74AHbo3mVUniKJcq8	11737	16513	16513	1618911540000	canonical
23548	3NKYrapcBkao1SgzcQwKpPbJUZbC1SVb4bg1f4Z1TK8ZL3ynXfBN	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	1670	1282	441	12463	15541	jwFcmmvJQT7DSumYrcv9maLUg5WM1SBcbbehvtAd7DjHXFCBxmm	11738	16514	16514	1618911720000	orphaned
23550	3NKEU6i6eZhLya9iDZyMjRbv7ctLPyNho6ZDyEB471FXPJ3S8JqQ	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	1506	1247	441	12463	15543	jxsbY4TBgubCXX7gt2jnSzPgjJyfWrq947tQCdfzkPXMQ7nSWu1	11738	16516	16516	1618912080000	orphaned
23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	1406	1393	441	12463	15545	jxcLEds716xTfcoM2HAKmuF1rpd5SNMJQaJ6A8wNvdmuv7hJUyi	11739	16516	16516	1618912080000	canonical
23555	3NKVusg37yvdvZzstKyjYYBq8NaL2uVeUMbvZY5wyv8LMoELLfAv	23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	1624	1208	441	12463	15548	jwFpzwjCdWMMmphZohHYvJ9vT1NfypafPRSTsUosmVewM1LXczF	11740	16518	16518	1618912440000	orphaned
23553	3NKFFZRky52A9AsceCFSzsxmZ6UygfeUar6YHMdqC2a45uNjUGwk	23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	1587	1111	441	12463	15546	jwXWyj6WQEbGYuVFs5M7AaZyXWDLjjLFQZzkHi72j2fzwNVYeVC	11740	16518	16518	1618912440000	orphaned
23557	3NKkX3b23eWfa2ezciDv3SiZ5BJB6Nfnm6FydMSVottyoqdZz78Y	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	1668	1370	441	12463	15550	jwJ6TF9apCFzu5P7FNxShQnsfVudBdwPVpWiVw83rZW1ZrP8YvT	11741	16520	16520	1618912800000	orphaned
23559	3NKwoCoTjzbhoyWtWNqi3xFQwoW3o1Ms9Fy2nzb5pJT8m15khNjW	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	448	1059	441	12463	15552	jwZDxa1KHRbM6D6iNoNCdFtm8QTNca7tkj1TNkvjnJn6Tkvxp1M	11741	16520	16520	1618912800000	orphaned
23560	3NKLGqUB13cpwSxWFRokGd3EVCzddWgyZEeFGgu6SMrsNbStQM78	23558	3NK46YQchyGuFJmiZL4XfM34a4Bc4y8C4RoBwdsbxfkosr3WKgfZ	1637	816	441	12463	15553	jxo4UHW5Qf9N3o6eYass8SQaA74aZP26zLw8dhTsq5EhV6VqLVU	11742	16522	16522	1618913160000	canonical
23567	3NKRktaSiWeNzYbt4qa9NUFDpM1pTq4g6e9g7cJLwnuyjSGFHM4z	23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	369	946	442	12463	15559	jwggyFJdZA1zzJVGJvJG5qEK5cFrVaX2tiJw1NAhWNymaEh1itg	11745	16526	16526	1618913880000	orphaned
23572	3NKCoWHhUb46diBnVhMyRLQLDDj39ao9LVivo2R39NvUEXWJFMvi	23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	1474	1083	442	12463	15564	jxJF7nhDAMNJbCK4nJswYxmn5cwzcJwvYngiHZwtbSe65kjhTPd	11747	16528	16528	1618914240000	orphaned
23574	3NLRahazwDRFcKLods169WHB7h9ESayXohhrJpLq8U4uYtCs6NrF	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	369	1312	442	12463	15565	jxAEcRg1pVkmwbeXmeQPTiPUzNDUE3v4oaLsaW6mbuATaPiQiML	11748	16529	16529	1618914420000	orphaned
23577	3NLvYm2SLFRhjzpZqCY9nVVcDx7n4qVa6criNw8ARy6jqUdG2YAv	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	1634	1085	442	12463	15568	jxhNrHL7gX4TSYwLMC5ar5eGLxUXMH56WuAXVSXCyv1sY4TyQ4D	11748	16529	16529	1618914420000	orphaned
23578	3NKMkZKY9gJWbw9aZLmXcVQ4A6sPa7THZRiUqVZG7A1uyJpEN5gE	23576	3NK4Dfp2csaG2yCdDoi6T7i8EdNQerV72TtHBWqNyDFP6t81JVYU	532	1303	442	12463	15569	jw6k3ojWDGejPpHdgz1u69BotTmortXebyZ6rt1zrrG2J9xxALd	11749	16530	16530	1618914600000	canonical
23584	3NLPYjGWbRSfjJqMRwr1ZHKZku7V3Fz8tXqUKSBev9Agj2vXsd7T	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1527	1047	442	12463	15573	jwtRhFnFGgvsqpAaDpcseq7AaqtH8t6fqUdVDhAfovPJiaFH3RL	11752	16533	16533	1618915140000	orphaned
23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	23588	3NLC2LX3NbavXJMtQWGzg6maywbTofABjtsanDmoVFdM3yjufmeM	1553	776	442	12463	15579	jwY2LPcZutqbg3esdpiBRJ2nVT2VEzNpJ62trFzS18HBo7V86Fd	11755	16536	16536	1618915680000	canonical
23593	3NLocqZ4eX4xW7S2AxhcJjsGQScESiJRtrWxsXwK8EVEAmmFPtH1	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	1407	1395	442	12463	15582	jx5uuNZosuDUghb3J7J8ozUFYGRnPF3T8hrPjk8Q4AmW6YUQAHm	11756	16538	16538	1618916040000	orphaned
23597	3NLtJ8MYhKYBpfiNm6BgN9kj4YeGHwiKSpFuBvXXusWDPAizEixM	23596	3NLNf6Fc4JKsymfVbLkKDdsDxzhV2CUuj9CMtyDCoUhpYRGQ6GDR	1407	1395	442	12463	15586	jwVfxo1zAr5Gg8Y7CFLhP47mDH3zcGCzyLw5Y4RfxFGeerZa9v3	11758	16541	16541	1618916580000	orphaned
28015	3NLgBz3Sowx3doLS9EJxHeXYCSN8QrBM9DKysKWiUhPZycR9GHBi	28013	3NKf8MwCWitidk2CTScTAnqYVKQQVeX6XcuaiiA6shje6gRVj4JQ	1528	692	548	12463	18974	jwUuk8Liv4fXRdtddoNJsmGBFZYxch9izYtBMBedQpwM5XUUF7b	13855	19528	19528	1619454240000	canonical
23524	3NLYmqY3ryGQzSVnu1VJX7aDJ6HQ2EBqN1tiW6Ri5RdMyVkJ3GSZ	23521	3NKR6J2hv3kWVfd6xFpdx7ixSPzhNoZzR7tuBUH6PaAys4izkw2u	1406	1393	440	12463	15518	jwjF9LyVWNViWaPM2UNNkVxNCBrg4oJHCbUxPvaEVwixwSwAkH6	11725	16497	16497	1618908660000	canonical
23527	3NK7NkG4U7LEinUhTqyfPkGubPrK1LDUR4oFB1cKKbyj9qGQmHbv	23525	3NKBea8BWQ8ZbNWU2EgU4Sc1aVTBCv1cbWp2X1wyfC6pH4E4T1tQ	1598	514	440	12463	15521	jwmSySRKBUePsbJEqxJbwukFmiDA2iaFJKSDmuShikpqcnu1eZU	11727	16499	16499	1618909020000	orphaned
23532	3NL8ComdX1bq214TWh839WC4Qmad79wd1iyXyBe3Lr7avaX9Qo6P	23530	3NLjeyZCv3ejCuxhHFNuWZi5ua5HsRpc1i2CnGvJS87aqbcR18sN	1406	1393	441	12463	15525	jxZMRjFrSqZVjBrJBg2sT2mK171N73T4MMVfUUtPT57yf58zjiZ	11730	16503	16503	1618909740000	orphaned
23534	3NKEVmxNFkgmwsmUuTiYonduympzfvLt7kZ3BoM3ASDjtKgHEHqj	23531	3NKtBPCbyGpbPkHbzzx9ZVQNGE9i7W8j6dx7tDpmTwMi2RWaBmBQ	149	1283	441	12463	15527	jwVNK3XmuKdYy7jB3QQkkbyjNt8VoGW5SkeaGh4PdsZdTfQns4F	11731	16504	16504	1618909920000	orphaned
23536	3NLH1LrqC5KQW9vheBaf1DCA4vfpmMge4upaWQERtK31csSENnpP	23533	3NL8DkbQosVVASoLA5AN6UvHQ8J5JHqaJrvyFdRRYybNAqk2AK94	1627	1019	441	12463	15529	jwZCVzvYjk3Tq1tAEisiALxJywkzpa3MNLyXf4Rvg7k2PzviWWp	11732	16506	16506	1618910280000	canonical
23537	3NKkPK1YCnpA7yMocuF1wNyWhMCh3prvjZG1PKghBaD3BYWmLn8a	23536	3NLH1LrqC5KQW9vheBaf1DCA4vfpmMge4upaWQERtK31csSENnpP	1602	1243	441	12463	15530	jwGzJG7nFX6roTXWSPBkesk2H8tC8fVLhj58u8N7EK8P1pbFnsg	11733	16509	16509	1618910820000	orphaned
23539	3NLcuoqmzge7YeuwVzrYKFsxySVQEsNVQN7wnTAP55hCn5gy1gwr	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	1619	1275	441	12463	15532	jwskbfHmrMxDwbYJKKPbRg2XcsS8p4pkM8BPotsecGWDg3HSvPk	11734	16510	16510	1618911000000	orphaned
23544	3NLSxhiqc9RFDuguAysDb6A4ZiWUmT9XUoDhzJXww7qbrDoqdaXE	23543	3NLMYXJNU34r5wUCF5fHCKvD4aSaLThaG5t5xf2KQnuX11F8HRpW	1406	1393	441	12463	15537	jxs7YSPbds4t8t66nPpYECfjnGHqDJDRCsvBFi9NAGwwjhQ1PnZ	11736	16512	16512	1618911360000	canonical
23549	3NLWpJSq5MWvVSBNLnMF87mKpu72CJPxLYBs4QspLnhCxa18x8hp	23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	1542	1058	441	12463	15542	jwbruZLg3vg3APxmRaQ4hThgjM2PPgeCteTtbQxy4mHwrbCLPnX	11739	16516	16516	1618912080000	orphaned
23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	23552	3NKF2Q9hkc4oFgFd6oCC1LovXZAbRFYiD7z6ULBjiYDEZzyTmzF2	1407	1395	441	12463	15547	jx9XDKJX7BEuHvDJKausW7iCNbF9aP7YSbyRWK5sYNjJvXoKtrm	11740	16518	16518	1618912440000	canonical
23556	3NKXUjn5VMNGff7M1pduKXKZV7cQBESKoA8qEZAYAyPHZ4FpbYn4	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	1646	1108	441	12463	15549	jwCBB5UHPLPbTZdMfvK6tV98xgfnwgtMgioJ9qct6NFKpGi4grr	11741	16520	16520	1618912800000	orphaned
23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	23568	3NKECUbCBV7TNo96qgM2GxG5wdCrScc1HUtH1FCsZBRAMyPKBKLX	563	1359	442	12463	15561	jx6QBTBHA7cmvzyZaV8FxV7Xdw7ocDZjPesCHPgkRWer2QHWfzq	11746	16527	16527	1618914060000	canonical
23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	1579	1389	442	12463	15563	jxJwNV3c6kAHbcR2m59exa3seq3xC9TpKNeGVG1c9UU3AXEFph5	11747	16528	16528	1618914240000	canonical
23576	3NK4Dfp2csaG2yCdDoi6T7i8EdNQerV72TtHBWqNyDFP6t81JVYU	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	1623	839	442	12463	15567	jwwg6vzgQJ7Ve9VxfWkbfwPsLAEtmdqgW1USmgUjWVVskwu8auC	11748	16529	16529	1618914420000	canonical
23583	3NKBNiErAFhjjrzRNeenz4L7YfJ5eW1E7sBbyEzs6WsU7gETWUz3	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1534	1317	442	12463	15574	jwnha44BEuWr6gQsTN8Dzic6sS5EDfKsPCEMKjKQgEnFR9Hk6Uv	11752	16533	16533	1618915140000	canonical
23587	3NKS9iFz1zFJYTrTwvNYCJxMAqLmK1WRZpg8S5ZEPfm7rdEK4tqS	23583	3NKBNiErAFhjjrzRNeenz4L7YfJ5eW1E7sBbyEzs6WsU7gETWUz3	1403	792	442	12463	15576	jx5gFJduiWw9KUEQrb9G5Q6fqp7scr9ByRSiomZUCwCJszFLHHW	11753	16534	16534	1618915320000	orphaned
23589	3NKhPhf7ujFjuSGyx696TRgsdhTFECrhmJCeZAtJ4Dd52DmJwztj	23588	3NLC2LX3NbavXJMtQWGzg6maywbTofABjtsanDmoVFdM3yjufmeM	1407	1395	442	12463	15578	jwLhsfK5SffCJcCX25gRWQiXgvV1DDNVqX7sUma3havnmTewMjb	11755	16536	16536	1618915680000	orphaned
23604	3NLE4NR6nv78sNBBuD4ECHRmRAdBC6e3ara2VAtr479eqRCGF332	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1546	1339	442	12463	15593	jxkou6Di5kHSwwHE5wSCfyFXGANYdaCPhuYjhH9ryVB7CTiAGTp	11761	16545	16545	1618917300000	orphaned
23616	3NKYmgXa22akwDQwS7rPJXfHBHRpbUWDKX5PnwKSRYcGGVStKYL5	23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	1670	1282	443	12463	15604	jx7CrUPaa5EA2hFG8b4PApootqFEi3tvS3jpRUoLTyKLzRcfbVQ	11765	16551	16551	1618918380000	orphaned
23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	23619	3NKf1R86BGwdmGGsPDfD2g6L6hKL65b7jJW75eXJavBT3Tjs6K8m	684	1106	443	12463	15607	jxLf9ztrajtKGjTrufBD5DV9eawaoScD1ezJ8CMumkBrpxGfuJr	11767	16553	16553	1618918740000	canonical
23623	3NL48GJMMd4zq4bNJqthagc1kSoTvHxDudNDuj2d5fpf53rVcrpz	23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	1490	908	443	12463	15610	jwdtSiCFhtnXWhu1pzoGqHk8Tjnm1xBYsPs8WngMcQV35K2LKXV	11768	16556	16556	1618919280000	orphaned
23625	3NK5gj3USLD9dwF2x6fPnFk4j8TNPHjp5CudYZNzmaNUE72UFHAx	23622	3NLJ4p4Kv8MscH8ooxGNx9fqSD3UmQtaje9QfAJa1ET2HgmALXk4	1406	1393	443	12463	15611	jxncWHv84XWZew7M4JKPGTT3kcuMvQh99tLGiXfasqAf7kUzm66	11769	16558	16558	1618919640000	canonical
23628	3NKSqjwNXJwaZ5bUGoT2GZPMQgfFptGNT8wkZWP1zUfXei9YzoRQ	23627	3NKYrG5618QVFHHPKfn99L4ThHepTbav1pBidQ9pYzqiKe41eR6p	684	1352	443	12463	15614	jwve9ZJyecR3ksw6w6thePe4LRWfoUYGZYGbjpS1JuyPCmKXiqM	11771	16561	16561	1618920180000	canonical
23638	3NKGJv3a4jHceeU96uPM1miWjr8BiCADruJBR52i6avA7r4U2tV7	23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	1549	1116	443	12463	15623	jwFT1bGa7AdeEW67L1HZpdhER6zTg1ykERmA5LHc8AqSPDR7sjH	11776	16570	16570	1618921800000	orphaned
23643	3NLAfdky1n13fJuCJwvsgKcEkmZGHjo1rxjDggNhfGiCQ4w1WqsH	23642	3NLc3ceHPCbx3v6XFHGVr19BzdEDAfXJsk4eDAcTeodwyc4Wzu5J	1587	991	443	12463	15628	jxuXWbR4ymT1n9B1cJRP74gMS1d9Essiti6Gie3F6eW3tNx2noH	11778	16573	16573	1618922340000	canonical
23645	3NLeemn2RDBD2r4pnpCbiZVF4zkBbdghLH7b2bLM9hAzjpfVWTEi	23643	3NLAfdky1n13fJuCJwvsgKcEkmZGHjo1rxjDggNhfGiCQ4w1WqsH	1536	1313	443	12463	15630	jx9diU29gRUSPcyqzfsbgRfVNrXVSv9RkW2qhVXa6YckfsK7t7u	11779	16574	16574	1618922520000	canonical
23650	3NKWSrZzg9havLx5uQLAXjmZ2PpTYrTLg4jd9bSV1LDTi5AZ3k5Z	23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	596	940	443	12463	15635	jxVakY4JkPdZYGJVuDWwNYunXnyRcWZ6EhwTGbTVDAAUDDKPKf6	11782	16577	16577	1618923060000	canonical
23655	3NKDmEbVcVtPmqbcmWDrsXbKEL8F87wJG6D4qUUReCFN3e7xgTb3	23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	1506	1127	444	12463	15637	jxkPqvsFaP57vkmPPvrhRsyhtgPzkE4SASJr7zArzWEFGvvevL5	11783	16578	16578	1618923240000	orphaned
23662	3NLWCMYTJCT6L42v25U8tLWUUWMNBKCCT4PhUctLZTbxWJKLbn5B	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	1407	1395	444	12463	15644	jwVZN9f7wBGj1PL5gwi8qf3xb9GmuCDfxBZKQUC8iJ3TZeRyKkK	11785	16582	16582	1618923960000	orphaned
28045	3NKyK77JyBEm74PNc5UzFvXbbtZy7TQMAa8vueQakAXwZxxKscVh	28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	1509	1194	548	12463	18974	jxYE5n53Kx2SNCZuqdZ4txo5DKM43M3VpC4Q2xspHbZN9tWGAza	13864	19551	19551	1619458380000	orphaned
23533	3NL8DkbQosVVASoLA5AN6UvHQ8J5JHqaJrvyFdRRYybNAqk2AK94	23531	3NKtBPCbyGpbPkHbzzx9ZVQNGE9i7W8j6dx7tDpmTwMi2RWaBmBQ	1656	1217	441	12463	15526	jwAcErDtvkfeP289KMpsgggPHYch4FdHHYjMcVvCwRVxG5KnQ2Y	11731	16504	16504	1618909920000	canonical
23543	3NLMYXJNU34r5wUCF5fHCKvD4aSaLThaG5t5xf2KQnuX11F8HRpW	23541	3NL9ihE9okVKpxuzoA6soSLh6XUVJU9d7Y4djjfASgFfZ8p1ZZ7E	1407	1395	441	12463	15536	jy14ETMoT89t8TQiKgfvKahaQaEr9o1xWMZRJJtazQeTrHycwpj	11735	16511	16511	1618911180000	canonical
23551	3NL9PXS4HSzQcN59ZUs8voiVTofdXxJ7A1HwhCekNLwXMfKAZo3E	23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	1506	1247	441	12463	15544	jxFeokxN5uSifw1BwHcfzwADhtwRKuPpWEMmXRsDuKeY1eL7qJu	11739	16516	16516	1618912080000	orphaned
23558	3NK46YQchyGuFJmiZL4XfM34a4Bc4y8C4RoBwdsbxfkosr3WKgfZ	23554	3NKZNWTTfsUgFmMyzYymRUhrTaSPpnHoESiteKm18uBNatT2Ma9z	1406	1393	441	12463	15551	jxGVKgCXah3qj6SLpVqsPqY2eBaN9F7VKztyBQyEFLGX9obXpPu	11741	16520	16520	1618912800000	canonical
23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	23560	3NKLGqUB13cpwSxWFRokGd3EVCzddWgyZEeFGgu6SMrsNbStQM78	1579	1023	441	12463	15554	jwHQ777brZ2QQQomRj4NFNVRBS5LktTkrxhKCwty9M71uMdua5Q	11743	16523	16523	1618913340000	canonical
23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	1647	846	441	12463	15558	jwtbSehy4hdP1w2vXAvo3cVoKoddgC3dtxTbEoMPAkFLeUG85QF	11744	16524	16524	1618913520000	canonical
23563	3NLMP9Rvrbi4nXZjuatA292eQMsFKTi7nRLbDmvc4NqgV1Cgev9g	23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	1402	868	441	12463	15556	jxQNEEVLnUmffQQREtKfGsDHt623XZxMgALw3e6DAChkrzbGeuY	11744	16524	16524	1618913520000	orphaned
23568	3NKECUbCBV7TNo96qgM2GxG5wdCrScc1HUtH1FCsZBRAMyPKBKLX	23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	1476	1371	442	12463	15560	jxA8YvtM3LbCCombQ1QC7UeNQWMKyxCS8CWAotJ1LTcq1w8HAcj	11745	16526	16526	1618913880000	canonical
23573	3NLKmsPc4kDL5Ac6gAMntugmB5EZZXnBxwzxeivvHB1NEHUGiBgK	23569	3NKMpiFrmdfyHHHQMs6C3Je1PZ7ZKKTXgSfrWpsdCnPaoTVyWG75	1474	1083	442	12463	15564	jwM68NAbPci95HZx6yDCcmJJS3sQmogc6sGtsDW2mSukR7an5Pk	11747	16528	16528	1618914240000	orphaned
23575	3NKyHyeuuEcYjfQYQZoQb4BGoTMAo8xYedbRhxZkRyZWULrAWmtA	23571	3NLo3gdBXu1MukwR91ok5z9KVFh62Buv15kUj78mJxLPe6Ku6oyQ	80	1027	442	12463	15566	jxK6yBFsw44VAndmfceaGaLY9MkmUdHfgQ5rn15ppSfWh4iCKj1	11748	16529	16529	1618914420000	orphaned
23579	3NLqaXtk54pmcgS7ihrM2J6J8nK5YQTJEkQw3rmAU9MJEpUNxUWq	23578	3NKMkZKY9gJWbw9aZLmXcVQ4A6sPa7THZRiUqVZG7A1uyJpEN5gE	1500	1051	442	12463	15570	jxHTrqPqsNhcmbkSzoNMFPFrqhaWiwf8ZxnjbETbViWXk5hxLB4	11750	16531	16531	1618914780000	canonical
23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	23579	3NLqaXtk54pmcgS7ihrM2J6J8nK5YQTJEkQw3rmAU9MJEpUNxUWq	1541	1298	442	12463	15572	jxzyQqaPG2XLK2eVHN8rXyg3uRb5yMwuC2aW8GYkAcah8rGmU3A	11751	16532	16532	1618914960000	canonical
23598	3NLJCbMBdJMH1ooiM65jC4koatrHMTNJFmo8o3Rps8NeWHrT9gTW	23579	3NLqaXtk54pmcgS7ihrM2J6J8nK5YQTJEkQw3rmAU9MJEpUNxUWq	1559	1353	442	12463	15587	jxxVKyDs1wnoFVMEgMrpXERtBVBmEmZb3gHXywVCwfzE8EjkWv3	11751	16541	16541	1618916580000	orphaned
23585	3NL6xBUV1v1irdRYeJRhjyj17sJduYdTe3LqSw8YJfBxex3i4PJL	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1527	1047	442	12463	15573	jxgQBnDniawU5o4uA1DzcmxLahTWBkDtcVCwAoWsLikYTiRsCrt	11752	16533	16533	1618915140000	orphaned
23588	3NLC2LX3NbavXJMtQWGzg6maywbTofABjtsanDmoVFdM3yjufmeM	23586	3NLVGq6pvqy34FkEaEAXGFzMG7Jiefcuzo8x1oPV6SPdU8ujz2EU	1610	948	442	12463	15577	jwSZ5q4558cAvohvyhckvYqLK9WhgXL2qM7UxfZn3zGocqFtwEw	11754	16535	16535	1618915500000	canonical
23595	3NLgExJaFzN19xnt2MuqwW656bQ8sAHDJP81sh8EqhA8vRQdiec2	23586	3NLVGq6pvqy34FkEaEAXGFzMG7Jiefcuzo8x1oPV6SPdU8ujz2EU	596	1306	442	12463	15584	jwzW9ZxdPo1gguoHXx2AYkSTQhdSvPQZvAhGCUemWuhzkskfk3u	11754	16538	16538	1618916040000	orphaned
23592	3NLod5DZXp4ZbkDKoKfW68LZR3MNC5Y5h2u5CodVaM6KEjcCUiAn	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	596	1306	442	12463	15581	jwqRWN34ZC71tsDn7j1dJrmqB1FhFvuw5jwYEEQf1oHpo64t7nx	11756	16538	16538	1618916040000	canonical
23594	3NLL93KvhEfFUNP4UPo3vyguhAGxbCaAHBSRkdF3XZzyEouswgMU	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	1406	1393	442	12463	15583	jwPs88T4qaWh9uF1HjM3KnNVnbbzMAxsh2BuoB6uL4EKUEVjh7i	11756	16538	16538	1618916040000	orphaned
23596	3NLNf6Fc4JKsymfVbLkKDdsDxzhV2CUuj9CMtyDCoUhpYRGQ6GDR	23592	3NLod5DZXp4ZbkDKoKfW68LZR3MNC5Y5h2u5CodVaM6KEjcCUiAn	1631	794	442	12463	15585	jwtMyipFoMcPj11SXpGCon2Y8pEEEzFBMWd6ckUaUV2iX6vCYNn	11757	16540	16540	1618916400000	canonical
23600	3NLc6x6kh9YRx2ae8E5cKDAeHQfh5hm3z6sQntnVCMi7YcAvTVFV	23599	3NKPDLxw7CJ1QCNH1LY6djDqncsQQzJ3n1gMMTTLtyZcznt5XWTW	1587	1231	442	12463	15589	jxRLpGAVB2L4BFGquRak9CusdSgbM4ooGrgyeEVzswHGNpn7wbn	11759	16543	16543	1618916940000	canonical
23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	23600	3NLc6x6kh9YRx2ae8E5cKDAeHQfh5hm3z6sQntnVCMi7YcAvTVFV	1553	776	442	12463	15591	jwCMxVVkp5Wk1TMdtsQB4vVHLDfFzSpfA6wWRso4sznGk2oGcG5	11760	16544	16544	1618917120000	canonical
23610	3NLriJT3TGcPLaAxGbg2nTTsgbFMYBDMxc9UximjmG6qoHmpBCS3	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1546	1339	442	12463	15593	jw7nRA6xTK7PKascUBCZUpVtHH6vbLSZfqmvzyPYSHzziQS6KQW	11761	16545	16545	1618917300000	orphaned
23613	3NLrZGAWnki791ojvCan8KiJVnknvZALEM2JsRwtVeUrgmxu5Kjn	23611	3NLhHs6EYFkEmzbAPS84Tw3vZGVXuGLEq2httBYTYkiTYTt74Yua	1406	1393	442	12463	15601	jwZyaT7X5dqXwHfqDrfXrSAvm46w7RVER2nsEJZkCcp4Z5gmxn6	11763	16549	16549	1618918020000	orphaned
23615	3NLKhPi2K3UFP3tmUtZQM79nXeDVSQzyKVwBZ7bCwWftW5uQaCgr	23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	1627	1259	443	12463	15603	jwsd3X4pSQZ7MNw9FX8b6tG8Ur1WKiCAfcv5XYkWe1XxNYthCkg	11765	16551	16551	1618918380000	orphaned
23622	3NLJ4p4Kv8MscH8ooxGNx9fqSD3UmQtaje9QfAJa1ET2HgmALXk4	23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	1546	1339	443	12463	15609	jwxzqbpcjEUYXgAYJbXMc6LTyLJyf55Shatyd6res5DgihLMpFL	11768	16556	16556	1618919280000	canonical
23627	3NKYrG5618QVFHHPKfn99L4ThHepTbav1pBidQ9pYzqiKe41eR6p	23625	3NK5gj3USLD9dwF2x6fPnFk4j8TNPHjp5CudYZNzmaNUE72UFHAx	1406	1393	443	12463	15613	jwv54kbY487F5wxQvrJPqeuKJCpcu2GQ4Hb8mTEpJsdys9RPcir	11770	16560	16560	1618920000000	canonical
23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	23628	3NKSqjwNXJwaZ5bUGoT2GZPMQgfFptGNT8wkZWP1zUfXei9YzoRQ	1602	1369	443	12463	15616	jxJznGvCvFMFgbXtNwRwGv5FyRvfCh6Y4sVhT1Y3EtEUgJMTXfK	11772	16563	16563	1618920540000	canonical
23633	3NKWRERPfkvZLXjNGFT7mZQmfkeSxNP3dcoPjMbxLi8Q6nPoRFYU	23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	1403	785	443	12463	15618	jwkUg9m6WMwt6Z2oUHx1qx4xpE4ZAcnzKBXtYqnxXyFvp7uQtEx	11773	16564	16564	1618920720000	canonical
23635	3NKWju6hjouUkQQ3caJMy2qymCcNNv8DFrYFcL7VCQ4BiMg6jAic	23633	3NKWRERPfkvZLXjNGFT7mZQmfkeSxNP3dcoPjMbxLi8Q6nPoRFYU	1553	776	443	12463	15620	jy1vi9xXZQyMNRQq7neQqRh3L1zFyHau1r4cXJLe6vohrLmZDCC	11774	16565	16565	1618920900000	orphaned
28054	3NLAMCRwf77hVK7xhrApKU16m5T31geqHdG2en4JgQzskjgnWtnH	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1451	1292	549	12463	18974	jxKii5zEkZpQc3eyQaTPpu5y5Q7aL9StQfYkszKDy3matekJQq8	13872	19553	19553	1619458740000	orphaned
23562	3NLmUsKYG7cUyds8g4iYecpC8VgEXsBoXsmTYbSdqGW5GRrSTEWy	23560	3NKLGqUB13cpwSxWFRokGd3EVCzddWgyZEeFGgu6SMrsNbStQM78	1436	87	441	12463	15555	jxJbBapokHMK5jPBh46BJxQfMSYNNN45gKsfHfH2ZtYmvAB7N13	11743	16523	16523	1618913340000	orphaned
23564	3NLANyTFedSLu9TEtdU4G4FpfvohXfr5T8SMYZyiaDAg3Dw8LawZ	23561	3NKCQW2nx9rsZV2mvYEuKNmYbvxDuKHAbM7EL1pJpXoHKzfqEf6z	1403	824	441	12463	15557	jxuuHGQkQDHyGpa9bfna1aMPbHNEk3mV1ddEbHjJcZkSuyASCJK	11744	16524	16524	1618913520000	orphaned
23566	3NKme5yhxyTK2UGaehAKHBjkXX5zf3deTNivtxySvqXzQa5VpxEa	23565	3NKgSWwGaz1vwnfCrW6APk8ptQgzDWytEAKTRyAKXNaiW6r1r88m	369	946	441	12463	15559	jwtbSehy4hdP1w2vXAvo3cVoKoddgC3dtxTbEoMPAkFLeUG85QF	11745	16526	16526	1618913880000	orphaned
23580	3NKB76YfMaW2NQK9GupGrq1W6EWqn2ZzedvhwFypE5ptJ1Lh5cc8	23578	3NKMkZKY9gJWbw9aZLmXcVQ4A6sPa7THZRiUqVZG7A1uyJpEN5gE	1579	1389	442	12463	15571	jxNzbcvye7oEW8sEB7fdNHc5bWZHhLLo6fUxjCjv6iJ23n6u1K4	11750	16531	16531	1618914780000	orphaned
23582	3NLkXGjSUKv32FNVyo7mhgeMcrtxiBowrS978YfvEbnNh33HfQi2	23581	3NKjTv55Y8d4zwUvZRqgCMuYvaQChoeCg2RWMoEyc5MpdVXiwZP3	1527	1047	442	12463	15573	jx7StTiYFobq2qyRBYcmwtYZgHC5km6hryGK2N42qW4MQrcwfPz	11752	16533	16533	1618915140000	orphaned
23586	3NLVGq6pvqy34FkEaEAXGFzMG7Jiefcuzo8x1oPV6SPdU8ujz2EU	23583	3NKBNiErAFhjjrzRNeenz4L7YfJ5eW1E7sBbyEzs6WsU7gETWUz3	1609	1333	442	12463	15575	jxmLLjQcNRQx9a6gEQMziTDwz3fcY38SF8BHP4TBqmn7MNNbCuV	11753	16534	16534	1618915320000	canonical
23591	3NL9N7dNJHxKSh3JuEXUN25M1jucZMmppnuXEqE6LHUDqq7G8Ldh	23590	3NLnBDe1Ko5qyUk6Yx8zKYKsXmaZW2wHT2fDsSW1C4boP1Cj6qXZ	1445	1290	442	12463	15580	jw8FYgxqLJo37MyfgvmKNSnjbUbZSoJfw753rijrouY6g4ayJzX	11756	16538	16538	1618916040000	orphaned
23599	3NKPDLxw7CJ1QCNH1LY6djDqncsQQzJ3n1gMMTTLtyZcznt5XWTW	23596	3NLNf6Fc4JKsymfVbLkKDdsDxzhV2CUuj9CMtyDCoUhpYRGQ6GDR	1559	1353	442	12463	15588	jwiqbmPudLVSRerPQ8u74UPb6tKf3p1UyeJ9g9LxFFBSU6ppENQ	11758	16541	16541	1618916580000	canonical
23603	3NLca9zofva22M2chRihsYWo1muYo3ETaphYtMQtjhoZQdpgLeZW	23600	3NLc6x6kh9YRx2ae8E5cKDAeHQfh5hm3z6sQntnVCMi7YcAvTVFV	1406	1393	442	12463	15592	jx1bGyRiRUR5xqhRLareKnPBhoyLpEqk12KpsLz29GrRPicLAXA	11760	16544	16544	1618917120000	orphaned
23606	3NLKydaRv1V4fcuLEKArd358i3tXDHSooiAxYXLk6WWgb5hUgr1T	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1627	1139	442	12463	15595	jwDnbX2J2DFRe4JgdcPvdmc8AXn4WdZ383SDsinK2Wb2zinDzSm	11761	16545	16545	1618917300000	canonical
23605	3NKhtdxFu15GgsnBVpXRtUC1jtfMT1pTcbkFBvJg8LpMTL9MGrAs	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1489	1014	442	12463	15594	jxvvK5nnxqW3SkDTXbyGEvsu6ZCMEW8S5FeBP9ZKYeJC4akVnZb	11761	16545	16545	1618917300000	orphaned
23611	3NLhHs6EYFkEmzbAPS84Tw3vZGVXuGLEq2httBYTYkiTYTt74Yua	23606	3NLKydaRv1V4fcuLEKArd358i3tXDHSooiAxYXLk6WWgb5hUgr1T	1448	1065	442	12463	15599	jxkXMpuMVTKeXrPdasNb5o3Y5xmNfwpCoBfefpKbjkbHXVjwL6E	11762	16546	16546	1618917480000	canonical
23612	3NKduyvbmeB6K8pn3pyKuKrKE5QuWeM4yTebkJCrEvMDpb15ZTyY	23611	3NLhHs6EYFkEmzbAPS84Tw3vZGVXuGLEq2httBYTYkiTYTt74Yua	684	1352	442	12463	15600	jwgXreyVUnWkWYvS2b281nGGy1dTDxMiNKmNbRt3uJcUurWh5B5	11763	16549	16549	1618918020000	canonical
23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	23612	3NKduyvbmeB6K8pn3pyKuKrKE5QuWeM4yTebkJCrEvMDpb15ZTyY	596	1306	442	12463	15602	jwimWTPJfhrbKUAJ4DegXehCJKBDuAW3UJi3VXFNDdEXjBZdx4r	11764	16550	16550	1618918200000	canonical
23617	3NKj34dEjFUiUYFkZy9oQ4U4qHYDLdG7drN6oZVmFVH7E85FQBCH	23614	3NLQoAxGaYEqVV2e7MhsPTuoaZpCmkwFyhgDRdH8KrwFMhje9gbe	1670	1282	443	12463	15604	jx7CrUPaa5EA2hFG8b4PApootqFEi3tvS3jpRUoLTyKLzRcfbVQ	11765	16551	16551	1618918380000	canonical
23619	3NKf1R86BGwdmGGsPDfD2g6L6hKL65b7jJW75eXJavBT3Tjs6K8m	23617	3NKj34dEjFUiUYFkZy9oQ4U4qHYDLdG7drN6oZVmFVH7E85FQBCH	1474	1083	443	12463	15606	jxDonaFomMimxJ63RSNdDJpXgDzyd52LMVsQyb9XJz7KQuyXKvn	11766	16552	16552	1618918560000	canonical
23618	3NKMyVZWLi2MxvJGuHVqzCrW7WCmmZCEHeg3pV8Fjve9yJ6G5yH5	23615	3NLKhPi2K3UFP3tmUtZQM79nXeDVSQzyKVwBZ7bCwWftW5uQaCgr	1474	1083	443	12463	15605	jwdqkicd91XHbai5ojMb6xWzgR9SiwKwZVnpy7hNfHNo1dePxaG	11766	16552	16552	1618918560000	orphaned
23621	3NLAipJdgFQrkcUJ2aVBBeqEiXYV2UARwMVRdGUvXXyCCh8cgDG3	23619	3NKf1R86BGwdmGGsPDfD2g6L6hKL65b7jJW75eXJavBT3Tjs6K8m	1637	816	443	12463	15608	jwQHzRbx6CbcibD9sC9HLk4k41asyFrm8vaRx9XFY9PVrkbpyyf	11767	16553	16553	1618918740000	orphaned
23624	3NLCfMdvkDmuccQkrQypEJkCiyQuRPTSmHczo5PCe9k1uW65LR6K	23620	3NLXTUwY5XFuwYudjGETDv6TkkCnTggR6xh9V7oYaRmWNtYFRqkU	1546	1339	443	12463	15609	jxu88S3bg7KoSVensJYaUWfqc45ug5VWp8iF9558sHjzQ89DyXH	11768	16556	16556	1618919280000	orphaned
23629	3NLKCebE3fv2amgxjN59BDBrZMWqcciPNddT5WX4Am8uCNawpgW2	23627	3NKYrG5618QVFHHPKfn99L4ThHepTbav1pBidQ9pYzqiKe41eR6p	1406	1393	443	12463	15615	jxtmMx8Y1H5gmBhXMbp8wRgJqUruduKQB4RZAdHAt6kJBQHCbSx	11771	16561	16561	1618920180000	orphaned
23631	3NLkdeSrBk38KjTt7cjtuNaQcmuxzFRFYn9hMDsSdyvfuFKgAg5A	23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	1480	659	443	12463	15617	jxmhTJ17eUZLJGJPVf9H9g2HfTpwuMqPSZKX2pQMqZrVjT6xHfJ	11773	16564	16564	1618920720000	orphaned
23632	3NLmgiU71xfK3KSjfMPN4xZNBWynkvXsbyhbLvvXWfhyFfjvP2oE	23630	3NLd7NTrJsTHGVKneGgVvB7VMopUajEdM45pmkdyJzJjVKHFo77y	1480	659	443	12463	15617	jx8h1NGztZGxSh6rhqC9PaVELXmp9aYHUukrph83Fx9eVeuE12s	11773	16564	16564	1618920720000	orphaned
23634	3NKkEUo8Jr7Nm4rm6NPFexLqHJKxq3JxsoWyjfPL9Efua3xzie2H	23633	3NKWRERPfkvZLXjNGFT7mZQmfkeSxNP3dcoPjMbxLi8Q6nPoRFYU	1407	1395	443	12463	15619	jxvYnBebj1MKjPYuUFwRvdUzP4TZsaHjKBZhJKHwv9oTemH3qzh	11774	16565	16565	1618920900000	canonical
23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	23634	3NKkEUo8Jr7Nm4rm6NPFexLqHJKxq3JxsoWyjfPL9Efua3xzie2H	1656	580	443	12463	15621	jxtBAhrvNXL7AJH2eB5MaWrpEBF9wKuLtVMg8jCetf2d5174J9n	11775	16567	16567	1618921260000	canonical
23639	3NKQNxLd4NHCru7M3o5wuitYBw49beSCCWvMv6sfmQL6MLHtWtWc	23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	1406	1393	443	12463	15624	jwRQCj52FVxZzzsyAUthuo4qEZUMtvBYYqts6Ksv6Vka9HeyPt4	11776	16570	16570	1618921800000	orphaned
23641	3NLY12S2jEULUeNGk4H5yxo4A67PFoCn1fNCzUY1gyUvMfgr36ef	23640	3NKvLJMvtXYnMTo2TqZUmT3G2UHmeHsXgbVJaNB1eHMz6iuHemMW	1600	1126	443	12463	15626	jxAn5ihp33K22aj2XRmWkVKQXKwtm73p9UKM8myknAm3ZH9wPFZ	11777	16571	16571	1618921980000	orphaned
23644	3NKvXG9eTn2G75dxE3uoYw3itGrSeo5zDCXSEofZN2g1dDRdZqyt	23642	3NLc3ceHPCbx3v6XFHGVr19BzdEDAfXJsk4eDAcTeodwyc4Wzu5J	1406	1393	443	12463	15629	jxDr5rUP872ZajcAoXa2nh9wrdLWbYjd2vxEgJgaf4fbgb6tTe2	11778	16573	16573	1618922340000	orphaned
23646	3NLiAskyFSYEJiX5REsH8kbeRwfvMkyiy1iiAxSpoMK5SLDtRXVF	23643	3NLAfdky1n13fJuCJwvsgKcEkmZGHjo1rxjDggNhfGiCQ4w1WqsH	1406	1393	443	12463	15631	jwz3xXuvF6P7UJuB9249rMHjvehp11hDsc1NddFPiYWRW29ix7s	11779	16574	16574	1618922520000	orphaned
23649	3NKUKRQhwVqefvzNDobRg2HSCBe7HFMbqhff5PR6XoPeD1SS7A6q	23647	3NKhttHNbkCXG8imvoHxiiHakbmhedSc7o2LKckFCSBZjCdSZaz7	1406	1393	443	12463	15634	jwt6MKiU7QAqSNE4dNaQZL3k9JsMpatwKuhT8rtsqxg9kG1icg5	11781	16576	16576	1618922880000	orphaned
28146	3NLToj85vZU5rvafQZingfVkRhCWYswCx5BfLGckd8QsqMJWF4da	28078	3NKhtQikGaeivZnRH5cSPu3hmpouFJthhVLrF2wK4UhHFLWZszMu	1553	776	549	12463	18974	jx6fiN7Q3PnAvCoy6RPghcUXZrbd4UGmnnS2sjzTF6tKZM9Zhm3	13873	19617	19617	1619470260000	orphaned
23642	3NLc3ceHPCbx3v6XFHGVr19BzdEDAfXJsk4eDAcTeodwyc4Wzu5J	23640	3NKvLJMvtXYnMTo2TqZUmT3G2UHmeHsXgbVJaNB1eHMz6iuHemMW	1508	1387	443	12463	15627	jxYutVKefGg9UqbZQ2UwswY1A1RM7WQqzdwAcuWyFykpKhqdDF5	11777	16571	16571	1618921980000	canonical
23647	3NKhttHNbkCXG8imvoHxiiHakbmhedSc7o2LKckFCSBZjCdSZaz7	23645	3NLeemn2RDBD2r4pnpCbiZVF4zkBbdghLH7b2bLM9hAzjpfVWTEi	1585	1120	443	12463	15632	jwrmASmnwtL4u2YwU8Tm3kyBFREA3qNcWJN1FHodWEuyCL3D8xZ	11780	16575	16575	1618922700000	canonical
23652	3NKq9XRG6NirJKRcWEJ7vfys7g1QrSGUtUaMkz4xsUiMg3CZXBA2	23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	596	940	443	12463	15635	jxn67ScJuwa82TdignVENMK8eJ4EJHFGxFEz1qGHWMPjN9z128m	11782	16577	16577	1618923060000	orphaned
23653	3NLj9VsQEnkeW5zzVWCY5itWCRu4nASMkJNKxETbzzw9Fe966C3y	23650	3NKWSrZzg9havLx5uQLAXjmZ2PpTYrTLg4jd9bSV1LDTi5AZ3k5Z	1403	31	444	12463	15636	jxwnCF3Xqd41tXNqkLuoZiRENzYjy6PnBq7UeT5gfrcCtH4zsC9	11783	16578	16578	1618923240000	canonical
23654	3NKbFTniSaSR36U1vUKJ1JqtJHFu6RzmavXfxrc1aUcb2aGWzRoe	23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	1506	1127	444	12463	15637	jwW6yJZ5WCzfyrK9wvtx3aZDeViGphmZWXFaC1kRgHjTPoYcD7E	11783	16578	16578	1618923240000	orphaned
23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	23653	3NLj9VsQEnkeW5zzVWCY5itWCRu4nASMkJNKxETbzzw9Fe966C3y	1654	1094	444	12463	15640	jy1tJvCMMGwW8MsKNFZF53bxCn3cdSKb7EkXSZmCW3yzns7BwRU	11784	16581	16581	1618923780000	canonical
23659	3NLHmPG8YgKMVWeyUsaQiRtrAUVgs3v1T6JAQjZzBC1i3x5PmZDw	23653	3NLj9VsQEnkeW5zzVWCY5itWCRu4nASMkJNKxETbzzw9Fe966C3y	1403	824	444	12463	15641	jwHZJHAhEmoXMHWXdGU1A2K3MPReAnwhpzyrs9uJq5mkByCdWuC	11784	16581	16581	1618923780000	orphaned
23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	448	939	444	12463	15643	jwxur377A6djJ1iPeVCSwnf6BVduiveSkvYfU9bDkNt3tY2AvFk	11785	16582	16582	1618923960000	canonical
23666	3NK7myoNBpB9D9vb8SoV3TDcn413zrjmFxNXtpGtE1EsFpPP9AnF	23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	1611	1095	444	12463	15647	jwp7PEJjJoyfDrQNtgckzzgqK27D65P4MNAPKbAj3jBYL5HoZSg	11786	16583	16583	1618924140000	orphaned
23667	3NK4y2NYYnKcScbg9YMguim4bBwR6VNJVj4Q8mr6jpRA3uMdxLC9	23665	3NLnWuMRMyrijy4bFkAT6oNfyu3antm3yTDsQkfrWi2hPgws2UHW	1560	1045	444	12463	15648	jxVXexXbjT39H5VuHxKPsikgamVWff13y5azDdybkxvqZmzsFwN	11787	16584	16584	1618924320000	canonical
23668	3NLaxs1VA9miS4s4vBdNvPbRjK88k7ZJ81AHFmLvD3yWBthjdxG1	23665	3NLnWuMRMyrijy4bFkAT6oNfyu3antm3yTDsQkfrWi2hPgws2UHW	1560	1045	444	12463	15648	jxekMrbo6T6YsdsgAjKYJsCFCp4hiivBQipKMGR2Da4aH4UURYr	11787	16584	16584	1618924320000	orphaned
23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	470	1063	444	12463	15651	jwWfLVTvXZKLQ28pvQuLkoeeshX4C1svAogePv77MAtW3phC23K	11789	16587	16587	1618924860000	canonical
23670	3NKQSeyhfF4cWr2MtCutEVGMXkUeCsNdyDpM3aNJ9KMpSx2TiSe1	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1656	580	444	12463	15650	jwXvFw9RidTjbmTTDmevnNVHAhBS49MnoKFKtsSPeDZbCLfGfoG	11789	16587	16587	1618924860000	orphaned
23677	3NKEWhvk59kJ88GJJnDLxJFPcLhLvFrNgowHJZVLdcxf67VBpEuK	23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	1560	1165	444	12463	15655	jwmUGgj5LGMEKTDQ5o914rTXbsXbABAuvrPDAYw2YfRX9cWrcJQ	11790	16588	16588	1618925040000	orphaned
23679	3NKnTS7zvAahdVbZBXMCCvsNNFtauc41xd6rTuBzFWxGvKiiQnRY	23675	3NLfrzLVqta5pbM9kRMCe3f84jaawLiZettguGbi9ByyWUzPa8pF	1448	1311	444	12463	15656	jxvjEib7jeuR22KsMMvmb3f6UAGE6Z5B96uShU9FinbKDbxT7QX	11791	16589	16589	1618925220000	orphaned
23682	3NLUB8h6X4XdmmZkyDgxmbec4G3PZ4zCMUB2ixc1D175FbEM5fgE	23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	1458	1323	444	12463	15659	jw7reXqB7PiQ43YUGkrWsNuo9gmTuCmhzmCgQ9TKabCshNDFAMo	11792	16591	16591	1618925580000	canonical
23681	3NLwnN8bf3YiD6Bb5Pfykz3bGVQ2DMsfvZWHduj6qw6p5XTYbxbC	23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	1571	1335	444	12463	15658	jwJFr45iZa7zKcRN3mcqc9E5vwLN1mkiUsbdtecDerUoYnDgTZp	11792	16591	16591	1618925580000	orphaned
23685	3NLtbp98TXrgCdJ6iJbB29xxN6pdMd1M2MTKHXrGLEyB2fkuYGAL	23684	3NLVRMJdsiGYtGE4kfqarcfE1HRdEXb7EiAScuTdV1YphUJM2QA3	1553	776	444	12463	15662	jx1C9ygoiXC9RXoNP63K4ZiHEakxK7AXCDAcbWaQoi2XQswPSx4	11794	16594	16594	1618926120000	canonical
23686	3NLTcPD8g7dDjGj2em7w7ij93iwB6rLbn3c1A2fWvQ941HP8Dih9	23685	3NLtbp98TXrgCdJ6iJbB29xxN6pdMd1M2MTKHXrGLEyB2fkuYGAL	1589	1286	444	12463	15663	jxHdF3axDEEJVBHfDVm6iDBEYM9JwP822ExpAcJMv867pCf8jpZ	11795	16595	16595	1618926300000	canonical
23688	3NLhSZ6iDQ22WTxfhnwRmK8msXqkgmsY8RMadytXiZxNQzS1dUGq	23687	3NKdRGPBYRUDUFNu1keR5PpJNk1aitmPDxCUWLacH4unTyKHNE4M	1419	814	444	12463	15665	jwfdQhmSNv6bRMNV1CMnPwvMBuwGuWXdtizxZvTC6Lf5cqq5NNR	11797	16598	16598	1618926840000	canonical
23689	3NLpMPze1JzpXFVdCQgvAvXZ4spu1A3546XzGh5HvvSjvrQ5bekV	23688	3NLhSZ6iDQ22WTxfhnwRmK8msXqkgmsY8RMadytXiZxNQzS1dUGq	369	946	444	12463	15666	jxFujooZ6ZA8QPMxxB1KmnZHXrcaiHEHjj6f44XHnQ4vLb3CYGU	11798	16599	16599	1618927020000	canonical
23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	1589	1040	444	12463	15668	jxWgU1MSufTS8B7GbhXfqKj6H3WMNhffiPUKsRbGBgLGMYjzsGd	11800	16601	16601	1618927380000	canonical
23692	3NKbefyBoUAhp77Rc95h5LEfySYHuG5USEygL3HYj8mKv5xcvaML	23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	1407	1395	444	12463	15669	jxuHdyMRP1UGSv4kj7W8kSB61zamabA9aQ4d44qemoDjHfq4bJs	11800	16601	16601	1618927380000	orphaned
23694	3NKJwTCufTw46Zd1Q3d2qRurPaQTs81hSEgbfqwis9fLQ3R1nziJ	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1397	828	444	12463	15671	jwXxaQhb7NJrx4y4vNDULyepShD38nQiat5HQjosFWC3deHvpET	11801	16603	16603	1618927740000	canonical
23695	3NK8y6sEXHovT4kZPc9KiYNzK1jqTbHBnpowQd4vZbPBizR9TjNb	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1471	1140	444	12463	15672	jwkTiJHq2NRj4H1BswdGugqiDgHqNcZVQsSNBQZrjugxeTGCUKF	11801	16603	16603	1618927740000	orphaned
23699	3NLtRUh1w1oSigL9Y3QRmEwSkNm9L2MspTfcdMUJ2hyZkf3J5KWv	23694	3NKJwTCufTw46Zd1Q3d2qRurPaQTs81hSEgbfqwis9fLQ3R1nziJ	1483	660	444	12463	15673	jx3scnB6hMYtqSyMikxbqj6fVVBFeGyc9XSa5ryazGKrLGoTB5s	11802	16606	16606	1618928280000	canonical
23698	3NLD33U4YcfVnUr57iDhfbR2jE2ngLYszyzDUPDX9JgkiQXJnjVE	23694	3NKJwTCufTw46Zd1Q3d2qRurPaQTs81hSEgbfqwis9fLQ3R1nziJ	1483	660	445	12463	15673	jxjnrPrEBLss6XMek5kfYtt9txBk1AiurFQTtwNYYEWBb11Sxo6	11802	16606	16606	1618928280000	orphaned
23701	3NK6cWL7Y8du635TvGBxXQBwchgu3EfSaQNQEuFoZnSvCxyqFxhn	23699	3NLtRUh1w1oSigL9Y3QRmEwSkNm9L2MspTfcdMUJ2hyZkf3J5KWv	1602	1003	445	12463	15675	jwMbGX9qK3Qmk7VDCE4gYxxTFhC6u1QU2ecFqiXMv3HFEi11z4u	11803	16608	16608	1618928640000	canonical
23704	3NLtax9uEDAagjy5WfdwEgjUtXMh7vSyaWRwnYZXRxXU7PDuHpcj	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	1445	1164	445	12463	15677	jxVtho7KPQ3xKx1ZybrUmKKav16PV62pkVe1v3NsRBPL69iaW7M	11805	16610	16610	1618929000000	orphaned
28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	28060	3NLWkC1WBruzZtM9hyMfSoLmNMBAkEsUAn9rJDh8ZaaNAy3aWT5V	1402	868	549	12463	18974	jxKamrpCh5PTAjZpm2BrPVT6WnhJBy379EmNFdreKk2hmH2geyJ	13875	19556	19556	1619459280000	canonical
23657	3NKp4XNfGDrTrr3cQD3QmJS9FLt87zyAUyPGnae94ZAmZqkPWWGS	23607	3NKzF5vDdmRLDSAqTpp6kwwjUn85ooefJt841kVfKtRJc1ZboNSA	1581	778	433	12463	15639	jxwEc4Kp3mmxZhcYibbcVYqRN7PUDB2FG777fMb5zAi7ufU7GwS	11555	16579	16579	1618923420000	orphaned
23680	3NLQC3Sc6ERikXCBvrgW5Exhn5AJfmgXZd4oymD1BULWEG8SfYZd	23657	3NKp4XNfGDrTrr3cQD3QmJS9FLt87zyAUyPGnae94ZAmZqkPWWGS	1581	778	433	12463	15657	jxJfDaq69PcV6RvLZ3fo1hYbEojv51HcfvUgVGen8TdizDyWTnC	11556	16590	16590	1618925400000	orphaned
23700	3NK72ZSixw3sU4KrTuA9FwSKhpgM4Nvxbp8uiGnAvnmVUJ6q18jT	23680	3NLQC3Sc6ERikXCBvrgW5Exhn5AJfmgXZd4oymD1BULWEG8SfYZd	1581	777	433	12463	15674	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11557	16607	16607	1618928460000	orphaned
23721	3NK9j7RgRBo6GYLCmxtqDBuEoQYg4fxr2o9xg6f8mDZMxZSAr6cM	23700	3NK72ZSixw3sU4KrTuA9FwSKhpgM4Nvxbp8uiGnAvnmVUJ6q18jT	1581	777	433	12463	15691	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11558	16620	16620	1618930800000	orphaned
23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	23647	3NKhttHNbkCXG8imvoHxiiHakbmhedSc7o2LKckFCSBZjCdSZaz7	1403	812	443	12463	15633	jxmjvwxMKgdTCvnpkrhsHrgLT6fZNwrUmhxgCeH8YT1Whjm7LMa	11781	16576	16576	1618922880000	canonical
23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	23648	3NKbWDMTbK63J6obrN1B4GcDjaiG7Gu8nUM83QZsWDSvahSuqVWf	596	940	443	12463	15635	jxVakY4JkPdZYGJVuDWwNYunXnyRcWZ6EhwTGbTVDAAUDDKPKf6	11782	16577	16577	1618923060000	orphaned
23656	3NLqv3vK5aPp3yMriVUNTdMq5tTTDPZqbtvj6EUsBFHeHTAzTivR	23651	3NKZ4jVuTbmZQrGzkY7XqhwZnf5tJCiVyiMoNcZMpmEewPhqGAMe	1652	1315	444	12463	15638	jxRBnv66gehHWQJUMn1qmovM8wX8sa2W4y4Gb1bJ8XYYvGrMntm	11783	16578	16578	1618923240000	orphaned
23663	3NL9DpspGX24w5NqNM3NJQr2pDXpqZrAhUXfxw92EsgeQNA9Tfp8	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	448	939	444	12463	15643	jwyP4M8pTPmHcNDkm5Bg5qEanA1LASerjrukVF6Wu2YcjbNYhT2	11785	16582	16582	1618923960000	orphaned
23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	23667	3NK4y2NYYnKcScbg9YMguim4bBwR6VNJVj4Q8mr6jpRA3uMdxLC9	255	255	444	12463	15649	jwqx6FBhATd9WwiNovfwBwA9aPXDBdvU8SokT5RcwaStspnthKV	11788	16585	16585	1618924500000	canonical
23673	3NKFAGktpGfWJtMQs7r7BaxyxCenDgED7XUUkfbpmX9dSf2CoUFm	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1651	1175	444	12463	15653	jxvGDy1UEEduo7N8qYVvimhuHtLdyowaKLYY2QqwT6KwTWzer8L	11789	16587	16587	1618924860000	orphaned
23676	3NLrzj3WCfgC9ZtyjAMD2qnvZcSpfQhv5s7vgQKzHSoahUApxZkj	23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	1560	1165	444	12463	15655	jxptaMP8q8nP2LdX4PYyW14w4mgRcTvgjWeofy7RoVibicXbe1F	11790	16588	16588	1618925040000	orphaned
23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	23675	3NLfrzLVqta5pbM9kRMCe3f84jaawLiZettguGbi9ByyWUzPa8pF	1448	1311	444	12463	15656	jwaatwk68hkz4hNdvgiEj3ZTSX4sef1cMX4FV7tAKwycnf95bCx	11791	16589	16589	1618925220000	canonical
23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	23689	3NLpMPze1JzpXFVdCQgvAvXZ4spu1A3546XzGh5HvvSjvrQ5bekV	1405	879	444	12463	15667	jwK3qqHNqzvQisFvTrmQvaAR2XzDRQ3cSy2HpX4VPZKbREQyyw8	11799	16600	16600	1618927200000	canonical
23693	3NKXx1PAYTvEQp1puK46Cub5cgwrT3e5iZQeMo8HxYLCAQsZqF9s	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1549	1362	444	12463	15670	jx8tc8qF4cNvDEN7BqeMFSXXbqquek86REVbJxGkhPpFLd2sEUg	11801	16603	16603	1618927740000	orphaned
23706	3NL2qrSHy2yobMkyYz5cc96rizuWSvhs9Aht2UDF2jM4rRZ3XQXo	23705	3NKJsidJ8PP2zckYyMzTj7e3FTkmiHkg8fEfySBHKHSLQHbyKjT5	1623	830	445	12463	15679	jwE9U27j4o1Ahic5DdvoEBFFa4EgttMSuu8YviWbxRnMt1sfyVW	11806	16611	16611	1618929180000	canonical
23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	23706	3NL2qrSHy2yobMkyYz5cc96rizuWSvhs9Aht2UDF2jM4rRZ3XQXo	1657	1344	445	12463	15680	jxKNLxQW9Z1aLm7QX9YqgnbtypgW1Yj85TnWBwQCtBdNiBwR6ao	11807	16612	16612	1618929360000	canonical
23709	3NKgRYapxvN3T8QugypSkGK1oMLhN5hsD97u8MF6S9mG6ivuGd4N	23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	1460	539	445	12463	15682	jwHMPxSGGWfKoiz1FUHXxaHYNxgQqGcVZ3x9GC2x9GaenmDM4E9	11808	16613	16613	1618929540000	orphaned
23711	3NLnbFXEjKkJQpuaZ1m6cddse8x3ytWooxDcBcfTojWAeAUHbRmu	23708	3NL8sYrCbiCcsdef1EfCnoEZAQykJwyRyc9TXZ2Fp64EWWwXQ83t	1571	1335	445	12463	15683	jwUqxTvUGdqqZpbxXQUgkjfv37cVoD6cFd5TxLuwUeSqbQ64wpL	11809	16615	16615	1618929900000	canonical
23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	23711	3NLnbFXEjKkJQpuaZ1m6cddse8x3ytWooxDcBcfTojWAeAUHbRmu	1407	1395	445	12463	15684	jwrBHYsmm5bR6BNjLPF9mG3xHVQsABJH4LQADxoqPDsPExDgRLW	11810	16616	16616	1618930080000	canonical
23714	3NKonT34vR7TqUySJx1uTvAYZUQ76GvpAjEPRCstMRF5z2MqvF7w	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1599	1287	445	12463	15686	jwmJFKgcSZAroxDi7UDFhCZRXvtF3CavbiZFVdvqZfKVBEoFSxS	11811	16617	16617	1618930260000	orphaned
23716	3NK7NVEv6o5Z2omHT1FgJcrM13GogiEgsi2nGyJph98csffs1iYT	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1599	1287	445	12463	15686	jwWJQ4UT4vVWWS7bc7XTenChbPAsZr2hAKotnLcfLBnd8bm5raT	11811	16617	16617	1618930260000	orphaned
23723	3NKV8VNPq8dtKWTSPDQPrgGCkXAnUdrjMAZvro1ZDEHNwQo5MLVQ	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	1406	1393	445	12463	15693	jxMSH2HWGTrK9KLAJz7UZqTj3M7UUxh5VA775iZXMsKbms7C4PL	11814	16622	16622	1618931160000	orphaned
23725	3NKPrXWUmZxPN3DSky5LGf58P5a8gUt8xGgdvuYk35BaPiVP3upA	23724	3NLq2P2SwbHAM9yc35ixQNjywmaQKhjEuuEA5eLVDKHzLHJBeSff	1483	499	445	12463	15695	jwTWKQ96wAhiTR2qiyf1H1FVQjvT1dmbpvarugjQgfNatpwm3ne	11815	16624	16624	1618931520000	canonical
23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	23731	3NLqtK3S8mV8vMd7khfiEufW6H8tDiwCr458Qp1aA1Vvm4ki4hCW	1588	1146	446	12463	15702	jwoF3a6ysFKjyUADnDHBHr2ypqg1L4zisLVJCWoEfBDASTrChqP	11822	16636	16636	1618933680000	canonical
23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	1406	1393	446	12463	15705	jwSXpAEfi4mXwHYJJyVeSmBj5P3xYPfDySRTLYJwt3pmQKRrKNE	11823	16638	16638	1618934040000	orphaned
23738	3NLcfVGcBWkYmw1JkopExiiGtZwUBcYVz4Kygqu4ZnMUz2rPWenk	23736	3NKzVFkv3GjaANBgxCGGH8aFAswHRKMPqJdnemJVgYa9Q72yP48w	369	1312	446	12463	15708	jwWoG7boNEQyqXjaDQGgav1hnVEygJk4aUKYP9YiHJdfDaMwdqx	11824	16639	16639	1618934220000	orphaned
23744	3NKgfQT9sUM1UMMJFDefuq1M3xBJm4THD9j4U5NeHuaAdqaFyuXM	23743	3NLqHJCAYZjkdbFi4afTL7vos6vudqDXhWc7xunqL6bscbUgZ4wA	576	989	446	12463	15713	jxTmj64s2o4YbpD454ftSGk5CSte2MT8qK3cwYNxs97jCp3EDKn	11826	16641	16641	1618934580000	canonical
23752	3NKoU42A9X3beq96gKRuFp8GqyxMWuCzDpfCf52g522GJBgU4qVY	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	311	1061	446	12463	15721	jwjQwsK3VXRsP31s7bvwTSCBxvE6SXLZk6Z7GTh2cVdQSZLhd8b	11829	16651	16651	1618936380000	orphaned
23755	3NLtiptvJWLWx23xU5P7tZbpDvW1caHMhHq4wKJoutT1QYc98iW4	23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	1553	776	446	12463	15724	jw7KAN3Qwxw1uoRzVupcpzNQhSW3kUPQdrjaoMG8StK94BQqgER	11830	16652	16652	1618936560000	orphaned
28064	3NKBJhA3P9tgL1t5H6vKpM7wvr16ew2twWoLL3bWoJFM1fAEKdPr	28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	1624	1334	549	12463	18974	jxF1DYSmiAXTjrfa4Aku2TaHHSGdbAfaozSaGubVv4UFJFbhEdo	13876	19557	19557	1619459460000	orphaned
29378	3NKnWoJw4ESsrjTgEcb1QYL5A5kMyTz6pME6idAaWNbsMsfwna3c	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1419	814	576	12463	18974	jwbuGyHXt5qiyBwAAUVMw1WGjd4DAtZhuxeGZXgcj2jKRjXM2ek	14481	20384	20384	1619608320000	orphaned
23733	3NKhBgeabypoGeehUkAQtXbZLMWPa1pbFmqd7tsRKnsnxUDQHrxW	23582	3NLkXGjSUKv32FNVyo7mhgeMcrtxiBowrS978YfvEbnNh33HfQi2	1455	1206	442	12463	15703	jwUAoRyWw3W14RupGvafeTr8PrVtSrximmQiR2qmdHB2L2pDJnD	11753	16637	16637	1618933860000	orphaned
23762	3NLbVtxr3VhXq7WVXXmekERndMRq4nJQvtydzMneJ8ugkbtMPsUS	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	1593	1346	444	12463	15731	jxYFCW8LJv2kNC87VPUeG5cFBTfZgdnCz8yHKQouFXNBCcU8cQ6	11785	16655	16655	1618937100000	orphaned
23664	3NKChzgMNgDoKVxphwU7mbi73wCUufQuRZhUFzNuKZAXW4AyVtGF	23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	470	1309	444	12463	15645	jwVeopWafhFbdrwYCVdbMdtJikeszbqyWg4DS6T7tYTRu2AcJnL	11786	16583	16583	1618924140000	orphaned
23672	3NLMPUZ9Trd3zF8U4fQRmDGdfYvgdSfzWQoVmVYPgdeiC5GbH4YA	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1407	1395	444	12463	15652	jxdtiZzdnV9BWG754DSW7KaUpndm2MNj5jKpwyyR936Dptw84QU	11789	16587	16587	1618924860000	orphaned
23675	3NLfrzLVqta5pbM9kRMCe3f84jaawLiZettguGbi9ByyWUzPa8pF	23671	3NLL7SQH9wwA8ZSFre48et591ZV4T9unZYbcaCaoQ49ddmVkuEzr	1654	974	444	12463	15654	jx6kcZhXb8ABCTosdi9CNLz38igWh62JqRw1ij3GpEycQjjeN1J	11790	16588	16588	1618925040000	canonical
23684	3NLVRMJdsiGYtGE4kfqarcfE1HRdEXb7EiAScuTdV1YphUJM2QA3	23682	3NLUB8h6X4XdmmZkyDgxmbec4G3PZ4zCMUB2ixc1D175FbEM5fgE	1536	1067	444	12463	15661	jxHxccfV7ZEELADbHCkTjcn1ekiRnCWwgJWjqxxDrPER9Ua88NJ	11793	16593	16593	1618925940000	canonical
23687	3NKdRGPBYRUDUFNu1keR5PpJNk1aitmPDxCUWLacH4unTyKHNE4M	23686	3NLTcPD8g7dDjGj2em7w7ij93iwB6rLbn3c1A2fWvQ941HP8Dih9	1406	1393	444	12463	15664	jwsfEZy7DgvMvsremY4r6ZnG261U5UcLPoCBMoHU5RSDrfZtzpr	11796	16597	16597	1618926660000	canonical
23696	3NLNaxUmksV7o4ouLu3QgvMpS2HAEiHx7HzcC9gQ1jEfoyhp1DzZ	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1549	1362	444	12463	15670	jx8tc8qF4cNvDEN7BqeMFSXXbqquek86REVbJxGkhPpFLd2sEUg	11801	16603	16603	1618927740000	orphaned
23705	3NKJsidJ8PP2zckYyMzTj7e3FTkmiHkg8fEfySBHKHSLQHbyKjT5	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	484	1193	445	12463	15678	jxkpEakPogQ9ujdemrQUJWmH2dz2Y9e8gpdA6ZNxSAKqRUo5ADp	11805	16610	16610	1618929000000	canonical
23710	3NKKQNDEnbA67ZkannyEChUEx9rvCnUnRxob5ZMNPY7ANYBAoe33	23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	1460	539	445	12463	15682	jy1x7WUFUzxgmyx3LyqVeRbWH4ixQwv5UN2epuGkEnR37XTB1gu	11808	16613	16613	1618929540000	orphaned
23715	3NKNLFjGEj2cSXABRMMWAzT273rDPqexAQhHVXopsHv7YL6S6tZx	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1607	1348	445	12463	15685	jxqjd3x2VuwBECjeJ3RayKh4rRes8XKDzBNf63ahTQvJba7W9Zr	11811	16617	16617	1618930260000	orphaned
23717	3NK5CqqNX1Wd6LmmSZHXncmwzFqT6DeR6EUeCiaTHpMvq8hAMJ1c	23713	3NKjHhrujk9jBWKw4TxgbDqsgqoML3tfjtVWbowhFENWCf3gRFP3	1471	1260	445	12463	15687	jxBRw854MQZFqPgFkdsz4EABCx2pRhBW9k8jePn1PCRiLbdEE2y	11812	16619	16619	1618930620000	orphaned
23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	23718	3NKtk117Ga3o99TJcwjYnv8a9jftW26eU2iZoNTa9atXuAAiAVAC	1439	913	445	12463	15689	jwmuJZ7pxS4cHSXbSH3jWRaQd5wboZkCroyTtezcBSmRkMDKcdK	11813	16620	16620	1618930800000	canonical
23724	3NLq2P2SwbHAM9yc35ixQNjywmaQKhjEuuEA5eLVDKHzLHJBeSff	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	1670	1282	445	12463	15694	jwDWUiNZMNKtwoYjW9ybh3KNbd7WCZTMEACt8qFZpwkoEGzthVY	11814	16622	16622	1618931160000	canonical
23726	3NLV7tgGGYDtGS3aPvuvs2wVoE4WjEQuLjZ4LKdoh9ERCTGEwBKL	23725	3NKPrXWUmZxPN3DSky5LGf58P5a8gUt8xGgdvuYk35BaPiVP3upA	1571	1209	445	12463	15696	jxku4PX7eAkd682sD4xXMWMkKao8K9GkJykq29pf6rXco3r6FYj	11816	16626	16626	1618931880000	canonical
23727	3NLnsCMJBM6Mdz4aqTHmfhaoQYZg76PkNMx3uRsabQGvavT8iEUz	23726	3NLV7tgGGYDtGS3aPvuvs2wVoE4WjEQuLjZ4LKdoh9ERCTGEwBKL	448	939	445	12463	15697	jwGCCUn7bqV8MzVNBMGr7UTsFiDKLxJRyfvXBWjCpfoBQNUGa35	11817	16627	16627	1618932060000	canonical
23729	3NL1SfaWY81aLXp8rG13tE8qXpVGem2MCyAdSNykisjLsWwEt5ay	23728	3NKcbcpt6g2bJ5ejc9CJdwXu5EHqTfu1usUSXkbRv2owfHd9KNnG	1406	1393	446	12463	15699	jw9JPV1gzSSMAFAWGaDbQD4KQusoGmYvncPkCMLiFey8xbJ9PDf	11819	16630	16630	1618932600000	canonical
23730	3NKAKuS7PDF2gS8d8QTNJk2KAqiUC1W3rzEuYcwC3zuDro9cNvgE	23729	3NL1SfaWY81aLXp8rG13tE8qXpVGem2MCyAdSNykisjLsWwEt5ay	684	1352	446	12463	15700	jxk7PpUWpSt5Gj1mACf64kVgCNLRREEANTLAwkoxhq6grkQrwHJ	11820	16633	16633	1618933140000	canonical
23731	3NLqtK3S8mV8vMd7khfiEufW6H8tDiwCr458Qp1aA1Vvm4ki4hCW	23730	3NKAKuS7PDF2gS8d8QTNJk2KAqiUC1W3rzEuYcwC3zuDro9cNvgE	1489	1134	446	12463	15701	jxTCgSi5oV6uiqQGPwYSrxv9ucHPcMz62vr2hf6gKQLNt33JrMg	11821	16635	16635	1618933500000	canonical
23736	3NKzVFkv3GjaANBgxCGGH8aFAswHRKMPqJdnemJVgYa9Q72yP48w	23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	1631	794	446	12463	15706	jxg22D8uHUr3aeqPQDx9RAZS7gH5wx28ZqMXof8fbKD9keJLsLN	11823	16637	16637	1618933860000	canonical
23740	3NKEDqGfTFeAwcYnSwQja1kbrishvJwqTH1mjET1TF7FdfBSz8ZT	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	1448	1311	446	12463	15710	jxzNuPJsZPSf9KFzQkQCvPXXerUHNevZ7Twu5j6nLySAjbjUMhJ	11824	16639	16639	1618934220000	orphaned
23743	3NLqHJCAYZjkdbFi4afTL7vos6vudqDXhWc7xunqL6bscbUgZ4wA	23737	3NKQiouoFsfe5nuQ3ziump8WVb2fuUjUQDpxxsjGJU4Su76kni8e	606	1295	446	12463	15712	jx2L4PSefMGtnwCdoLLvBNdqZ5RaQpAYQmQUJ8pGU9Hh8PEBuah	11825	16640	16640	1618934400000	canonical
23746	3NLwwTLy6pEZL8yx4RQopsdcifsqkp2cSCqiURFaxfKudttiqKcT	23744	3NKgfQT9sUM1UMMJFDefuq1M3xBJm4THD9j4U5NeHuaAdqaFyuXM	1458	1077	446	12463	15715	jxEvRHNwdH3Qg4Efxp4Uati5hGstf1PEsnMVASuWRkAmjHZhKF2	11827	16648	16648	1618935840000	canonical
23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	23746	3NLwwTLy6pEZL8yx4RQopsdcifsqkp2cSCqiURFaxfKudttiqKcT	311	941	446	12463	15716	jwrfdg5aQUo6RiLV5ikXbjsYcpmaZb7N1wy9vVDS3eLapo8fHbj	11828	16650	16650	1618936200000	canonical
23750	3NKYgh8DET3adVutoxH2YZR6gRCAAXYpE6GS6ewj5NZfUYgXNuNV	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	1406	1393	446	12463	15719	jxwrSbbEXjzgY9XJtcbUrzMF92vbzButK6mSbYJ9n2qrS4EE1in	11829	16651	16651	1618936380000	orphaned
23749	3NKvJq828d3DgeMdjrmre92QdchBrtyVQagERcev4jHv13uSKin6	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	1497	654	446	12463	15718	jwNhSNmb3fNSSPbYsJ8gT1AwuKh9LpEhF99oeMWJ1GUcBVex6mQ	11829	16651	16651	1618936380000	orphaned
23764	3NK7chHzmEZLjdVr6NFihz6Pu7rinwjkj48rNeiMF9GqNxEf9wR9	23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	1501	994	446	12463	15732	jxNyHRs59FocHEdRUutLEZ71YtqwA3oZwenX41h845rsdCp5fXS	11833	16657	16657	1618937460000	canonical
23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	23771	3NLMnovL7DnFeJb3eZAPpXBgkwQ6VKEgCNM8FYPqVxaiFaqW3D1z	1476	1371	447	12463	15740	jx4PQ2pDRnhad5Ej3dSKhj9FyeCFdHWnL1KeetwV1pXmwhKAtfR	11838	16663	16663	1618938540000	canonical
28193	3NKchsZmaaqeJS9wxtrzsWqqBV5Mz4Y8bb7Jfi1vnt1mVM9RmvLk	28191	3NKgPb7HgwQP5j2f3zvXRz9A8iXiV7UdGYjMRHyVr4ip4DocGvsg	1553	776	549	12463	18974	jxvHG91kjT8jiPg6FZnRnAaLkGrm6dEsUBig4CzhZZ71gbEeGJt	13877	19652	19652	1619476560000	orphaned
23779	3NKLcgrRSKncDGrBEKvcG79Ap5XuZqaPu5qJdKqm5zh9CP5UKFoS	23499	3NL5ujHbLymajhxbhfR7xVg8mw5HgHU8sn9LAUJUrDGV2PQWrfQp	171	1128	434	12463	15746	jxSFXkxcNGmrTQKFURxo3sdtN1RF5vnDKAcMVaSPertcj13vVka	11572	16665	16665	1618938900000	orphaned
23759	3NLMPTecUvnkn45vsTNDkdDejmoTYvTxRDS1GPgYVSYq9TTTB5ta	23733	3NKhBgeabypoGeehUkAQtXbZLMWPa1pbFmqd7tsRKnsnxUDQHrxW	1455	966	443	12463	15728	jxUcBryjYUjQ51ijfM3MKJBfVNAiyxjeEi2NKkyaJZxfDJxA3D5	11754	16653	16653	1618936740000	orphaned
23757	3NKYGuUNY4xyacf9DXRGDs9mkkHjZCGZzxRvNoRQyqDaAxhVaBj2	23631	3NLkdeSrBk38KjTt7cjtuNaQcmuxzFRFYn9hMDsSdyvfuFKgAg5A	1578	1296	443	12463	15726	jwRfzq9d5Aq9ShQXpXu7Wr7ePKUEh4BwQG9eCj8PA4Zf4zMwDpw	11774	16652	16652	1618936560000	orphaned
23703	3NKgMXEjU7qUJaCRuGy2jYoZEZH71E8uZcSR9FvH6bKwFyxCdvRQ	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	1445	1164	445	12463	15677	jweDBdZmdHMeX4tTMPKggd4mczPKHP2yecnK6XwrGw3QG56mqsz	11805	16610	16610	1618929000000	orphaned
23708	3NL8sYrCbiCcsdef1EfCnoEZAQykJwyRyc9TXZ2Fp64EWWwXQ83t	23707	3NLRkb2jA5YjrRFhkqQbfJDazdFJvbeJtuLic3jou6D8gEfGpsMq	1402	906	445	12463	15681	jxr5vPEmsfcU5kWAKEjRrEdAmMi9m3t4jZp5auvVySPqtUynZjU	11808	16613	16613	1618929540000	canonical
23713	3NKjHhrujk9jBWKw4TxgbDqsgqoML3tfjtVWbowhFENWCf3gRFP3	23712	3NKQ1cacqUDWN6qNrTw53qx76gXzcdH7fGvZufm7zDxVwzP6UxeP	1607	1348	445	12463	15685	jxyhCZESY7eoSfVLQVeJigHt8Ugghs78WVZAWEckwy5i6VoWKJA	11811	16617	16617	1618930260000	canonical
23718	3NKtk117Ga3o99TJcwjYnv8a9jftW26eU2iZoNTa9atXuAAiAVAC	23713	3NKjHhrujk9jBWKw4TxgbDqsgqoML3tfjtVWbowhFENWCf3gRFP3	1406	1393	445	12463	15688	jxGABKn4sbTfq2dwT4k3i8kvU4W9vPBUMYVxjZxSJRBSYeB8qN9	11812	16619	16619	1618930620000	canonical
23720	3NLr7VnB9eF6ivsLfV5MMAyUeRRyV74vYuMvo1h2uagcDz7hSYMo	23718	3NKtk117Ga3o99TJcwjYnv8a9jftW26eU2iZoNTa9atXuAAiAVAC	1579	1023	445	12463	15690	jxfZQfjMY2dceUfhYNWmYGSVVd9kPdjLAeK4E1MjiBkFSGEoSQ9	11813	16620	16620	1618930800000	orphaned
23728	3NKcbcpt6g2bJ5ejc9CJdwXu5EHqTfu1usUSXkbRv2owfHd9KNnG	23727	3NLnsCMJBM6Mdz4aqTHmfhaoQYZg76PkNMx3uRsabQGvavT8iEUz	1675	1342	445	12463	15698	jwki1i3DyQNtypA3MJNf5wLR6Y2hu5h6MRQwkhadWpv5RZbnT42	11818	16629	16629	1618932420000	canonical
23748	3NKJMtiSAPZGS7fW4VLi5dqeMKSpxvB7Gtdqy84gGornuDkukpZ8	23730	3NKAKuS7PDF2gS8d8QTNJk2KAqiUC1W3rzEuYcwC3zuDro9cNvgE	311	941	446	12463	15717	jwiqmj8FBpjzq6WTfMNzd8i2PQvHLfPhGwDRyT6NeFVJ5QQjhKC	11821	16650	16650	1618936200000	orphaned
23753	3NKNLARe1funaity7xAgRhSnDjxqgUJof5Zz3iaDMuHFgpzMQpkk	23748	3NKJMtiSAPZGS7fW4VLi5dqeMKSpxvB7Gtdqy84gGornuDkukpZ8	311	1061	446	12463	15722	jxnrUbS2tbsHSf3vt47Ef9vmEbSWQZQwzNL8Arh7dHZHPTyjZ3u	11822	16651	16651	1618936380000	orphaned
23734	3NKEpg1Fq3622Z2Qx1eA5LroYr76B9s8dPiecuKS2bzYJYtaGy7m	23732	3NLZR1tjwT5sZSMRKjtL7g24oBQWiJmfBHPwEvDHjt2yJHcRGPVn	1627	1259	446	12463	15704	jxKkt8JGsR6x7GpFAYA95Vmpz3JSBsmEjUkNakdpmN22Dtie7yQ	11823	16638	16638	1618934040000	orphaned
23737	3NKQiouoFsfe5nuQ3ziump8WVb2fuUjUQDpxxsjGJU4Su76kni8e	23736	3NKzVFkv3GjaANBgxCGGH8aFAswHRKMPqJdnemJVgYa9Q72yP48w	1448	1311	446	12463	15707	jwFC9wdgmubUsXZHJGDL6eFSisa8A5MYDjwByZmWqUFr4K8zZvG	11824	16639	16639	1618934220000	canonical
23741	3NKwfsGBMp6BUGDpxNa54xBTsSTYy649Ax4vgq9RxrJMYrtreCkp	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	1406	1393	446	12463	15711	jwzLmV7pRx4YMdtZJ95ZngcmKbRBmx5Y9inVWSovKmVbxFGLb7n	11824	16639	16639	1618934220000	orphaned
23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	23747	3NLnDAyWyvvFzfHtorUpFG2wE5Bt1cLbqRJW51qt2h1SaahfusPt	1656	977	446	12463	15720	jxiCxtzvLqo9sq5Fp8wRvuPShFUthE663qXfXH6qSwcvLnwPV6X	11829	16651	16651	1618936380000	canonical
23756	3NLi6VSx5iMfP4hK8PfvQDKC3BcFWje6gan16PeJhYk6DZD7bcua	23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	1578	1296	446	12463	15725	jwGsca6PBxfwXBw6mq7qTHJQg4FAmXzv44ggX3zh218dwSZQHEn	11830	16652	16652	1618936560000	canonical
23754	3NLpaFT24eZHj21Uink7wvaqjxgkPtAKmyqcMngC8dv8hTSR2EBr	23751	3NLG4rTEY78n7s7ZkDpqFq6BVMkssjGkTywvu5ytGrn5MX2ywbKR	1668	1124	446	12463	15723	jwV6fnak8mG1VFC7GqWNC1Te1iJWN9FwxXsyRwLNxai9zfGM3RB	11830	16652	16652	1618936560000	orphaned
23758	3NKnBCoZcwPm2NFeVMjY7xuRAZSKDysUoTqSqi1vzscFjysU14B4	23756	3NLi6VSx5iMfP4hK8PfvQDKC3BcFWje6gan16PeJhYk6DZD7bcua	1671	1365	446	12463	15727	jwNqvuUdjk3cwjEtkjW4ajsziBU4pXZaHeWw66s3ErE9UjVmcJH	11831	16653	16653	1618936740000	canonical
23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	23758	3NKnBCoZcwPm2NFeVMjY7xuRAZSKDysUoTqSqi1vzscFjysU14B4	1553	776	446	12463	15730	jxRrqUsK8Ngkxg2tyg2FB2J9AArqwJ5FkQq6SAmpm4kPyA8Q3SP	11832	16655	16655	1618937100000	canonical
23763	3NLWNgMsx2QW531TB9tHbEfryen2ZUBke2VZbsZnfdKK3mYtmnaB	23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	1501	994	446	12463	15732	jy2FLJ34dPzcGHXq2LZKskSyLskJbUXqX5hPksbuR6jyfNPn6nM	11833	16657	16657	1618937460000	orphaned
23766	3NL1eyN2hhbuDzT8NXs6HwiSfPdicUrzQT4nKwohdhptufvYCAAE	23764	3NK7chHzmEZLjdVr6NFihz6Pu7rinwjkj48rNeiMF9GqNxEf9wR9	1589	1286	446	12463	15734	jwsQxdV5RajPF7V6jztwPejvhevQR4YiHLx8xs6oR1X5kQdDAfi	11834	16658	16658	1618937640000	canonical
23769	3NKyeGkJnP186w2tMZUtcdYAJhcZrRub2Giu5HQbe18SdE1pRSx1	23767	3NLnKCnbRdVPEHLs9MHTn5VxhvaXQxGcWWtYj9b8tc8emFKibHBs	1403	824	447	12463	15737	jwPZcdhHZC1zDKHFjjUYjY2h4YqUBhuHkFxfArBN8qX7btcKBDC	11836	16660	16660	1618938000000	orphaned
23771	3NLMnovL7DnFeJb3eZAPpXBgkwQ6VKEgCNM8FYPqVxaiFaqW3D1z	23770	3NL8o4JHGaZWsNVbMj1FXg9VTEoCubp333NNj2XcD529Pqm4DTbu	1483	1150	447	12463	15739	jwKkrjeH1KgxnESGaj7eoAocNZiNNettn2xZYB1wfGUSN68xtUM	11837	16661	16661	1618938180000	canonical
23775	3NK71jnSjzbL1BWEuRVKkyrWUTA1jAESCNgadaCFSfTU9iVtvvAW	23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	1587	991	447	12463	15742	jwyUp7sxjFWeASruAFq7sqqE2jd9Stt5rgPqthwWBnduscnkj2X	11839	16664	16664	1618938720000	orphaned
23777	3NKx6jZQ5qowhBpnqVqdiErzMhAAhd8WVcgw8fEvHXgFZUZBGgH6	23774	3NKGXEneYFCmBcnFCaXBaw4i5pPbRRrh7YWtHVaRjD3Qmw2rM6Fn	1444	1015	447	12463	15744	jwpEys346rFcWcyJLsWYAhKgNA9RXoUipUiUuGq5dieMRKyQ1dm	11840	16665	16665	1618938900000	orphaned
23782	3NK894KrtSXoV74k9h3GdpCXJNYsMQinT5VrrkSktRNLWSs7Zqpm	23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	1451	1166	447	12463	15748	jwKGeSSYJXXFqXn8dmt2eHFwmhPpScy1Hq2o8Ppcm1PH2i7xgTq	11842	16668	16668	1618939440000	orphaned
23784	3NLSfCR1FMHv6BME8sDiMBJnkvejngTViSFvZiZwH1RwtUcveSgo	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1675	1342	447	12463	15750	jxyBzNcjDKMxpt3G2Kr6u8SwqWg8sDhyKQJt3rXw4XMgVCqJsPS	11843	16669	16669	1618939620000	canonical
23788	3NKYbYq1CsnQQy5EktBXPBmdJ4VFJvAxtLrNMBubjYP4FZgo3Cgf	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1577	1081	447	12463	15753	jwpKgGvfhtDwsUQuskHvcLAEdhKSs9VBQWz6XpW7B69uEGhXzNY	11843	16669	16669	1618939620000	orphaned
23794	3NLkrcxnQrhL1V8BtDTbz2JFYZTwj7bhaZQ8V3hggg8CmgbE6HPT	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1527	1167	447	12463	15756	jxj2394bDY9kVMBHorjh2apjhw4CEz1DSgKau8uXEjmp8jj2pwi	11845	16671	16671	1618939980000	orphaned
28348	3NLEmeiGQJ22DUFJGU6bZQ8d9dwYZmioZSiXSPixLbkW41np3sL3	28268	3NLQbsocT1FnSzt8JHsYYvP4sMr66xQZvM4aD4KWFQ8oRk5STt3k	1553	775	549	12463	18974	jxggTwHi8TxY6TiqzuFW1hdVdtKpQ9cNWkgQiuNq2bxpnsxqWW1	13879	19755	19755	1619495100000	orphaned
23765	3NKcA9hrLYfGeC4CCFS4Cs7o1y3TvtDifmPdbzBhMfZs1Abm3anm	23761	3NL2pCkkkDQ2X4GXFwnPHzggJgXARvdXEwy1Mq4oJ7UNe9c6cSRg	1590	1300	446	12463	15733	jxHGbLUpftbutKPBH4dzLLGajsS8oXQW8eZBJYf6Z37SPzL3phE	11833	16657	16657	1618937460000	orphaned
23767	3NLnKCnbRdVPEHLs9MHTn5VxhvaXQxGcWWtYj9b8tc8emFKibHBs	23766	3NL1eyN2hhbuDzT8NXs6HwiSfPdicUrzQT4nKwohdhptufvYCAAE	1403	824	446	12463	15735	jwhfefAVJaXC3TuQ9rPwAwB2MbADnpAbB7ANid8QWaUpDGoWpBV	11835	16659	16659	1618937820000	canonical
23770	3NL8o4JHGaZWsNVbMj1FXg9VTEoCubp333NNj2XcD529Pqm4DTbu	23767	3NLnKCnbRdVPEHLs9MHTn5VxhvaXQxGcWWtYj9b8tc8emFKibHBs	1508	1387	446	12463	15738	jwLeT4DuPS7o9ny5zkGumyGD8gbuez6kMaNxanDTS3FmMvFbdYM	11836	16660	16660	1618938000000	canonical
23772	3NKQ2Qv94aaSeM7ERHhEE3RTd5k6NuFLDnLh9RrAwETbfWwufqf3	23770	3NL8o4JHGaZWsNVbMj1FXg9VTEoCubp333NNj2XcD529Pqm4DTbu	1483	1150	447	12463	15739	jxuneSbzWcv2G1rmYk7uvQDwCj92NbrkJgeZDAwKUNonyZsRjhp	11837	16661	16661	1618938180000	orphaned
23774	3NKGXEneYFCmBcnFCaXBaw4i5pPbRRrh7YWtHVaRjD3Qmw2rM6Fn	23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	80	1027	447	12463	15741	jwx8FTyFxCcnFSMHX673ZLsYVuKcQopZBavhFpk8UgzagcJVfhs	11839	16664	16664	1618938720000	canonical
23776	3NLCYqY4A7KLiZkBv6ZZxX2BVbNo6RSZ3QSA5KZJ2xzRADeR3iRw	23773	3NLF5zEeXP12rM6F4W3e8GJPtcMXLkZvg1yZ2AjMkkbKELksRF3z	1631	793	447	12463	15743	jxW436Arzbo6DP7hvDii4UvMKerzQm8HwF1D7BRMj2iwPkVN3SD	11839	16664	16664	1618938720000	orphaned
23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	23778	3NKyC5R5spSjo4cZL4xxXtUDu3zZhtZ8kaTGiY1wi4xVrWB2zmb7	1407	1395	447	12463	15747	jxtkHTjcQpGqFpp7F58BhNuhnUKSFQ6u1Fy2TY84m5wGhaSCwme	11841	16666	16666	1618939080000	canonical
23781	3NK9wXqTj7p4GFKWTeYeptUTEyWDHg6mf3LrZgFQpkAqGWktT86M	23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	1451	1166	447	12463	15748	jwMEQfqCxxKMqDnPPm6xDaBeexEQ2ujkwVEG7MRnsYSfTrxz5Xt	11842	16668	16668	1618939440000	orphaned
23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	23784	3NLSfCR1FMHv6BME8sDiMBJnkvejngTViSFvZiZwH1RwtUcveSgo	1402	810	447	12463	15754	jwRmjkdrwsGJxVySfbqtXG2kqiTSqnRFbkZQ4duUtqhtpTEK9rD	11844	16670	16670	1618939800000	canonical
23790	3NL3a3JjSSTCc6Y9ZMNcN4d78RUZrd8dtQat4bD4n2JpW9MuNyJc	23784	3NLSfCR1FMHv6BME8sDiMBJnkvejngTViSFvZiZwH1RwtUcveSgo	1609	1333	447	12463	15755	jxX1CunLBeksLa45KD54sivGw5MJAtHdgrmKtpWJWUEgmYXZ2p2	11844	16670	16670	1618939800000	orphaned
23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1654	1214	447	12463	15757	jx6F3kremXH7hBixZrG5pPvXjrDNTtTzidWqjZxQ4YJvGVuyepW	11845	16671	16671	1618939980000	canonical
23793	3NKpRVdyWeAdR1Hi6TtBf8TMKLF2gyTVNCqRaoAGmU4G2VLYySHC	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1527	1167	447	12463	15756	jwoEehgB6Vas5EKqzxxoKwM53g6Gd7f6L8gRt38ej1KEQx7ZYCT	11845	16671	16671	1618939980000	orphaned
23799	3NLPwds6ByMWUjujqvfLSQt3Qt79cNy5aeZbVfBp1jiGmwcsGLME	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	684	1352	447	12463	15761	jx4DKqXwfMUZWTdJddrxd8P3fW1NR41jzmSRG3CSHeayLgivnFY	11846	16672	16672	1618940160000	orphaned
23796	3NK52M9JVNwCTiso8RocfVbxbrU282NuNbWuHP7qz6Mu4SGKV8Ud	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	1602	1369	447	12463	15758	jwaHAk8kWPLA3sNRBvcvpSa217Vrk8b3Gu6xzhuwckLwVDmAkhB	11846	16672	16672	1618940160000	orphaned
23828	3NLqC9gfLToVVK9jiK6mL2dmy1QiCGJxFAyMbJUPmpJmbn9dKLmW	23798	3NL73LMEo29BGVJnWYAxAshqjbXYnzjNZtfCbtU92HXKYN83Jw8K	1471	1140	447	12463	15786	jxJDhvRomtFsGX3f6CGkWgkLW7F4r5dGCbiamcnpdbgHVU2hoSp	11847	16694	16694	1618944120000	orphaned
23803	3NKkTTzARFVmxQoTQQrSBBTvQwSk7yqidvFrYeWHyvGmrb6RCDtw	23801	3NL1RfUWy8V6bZRdF8qn9v1N7Ew4bnB6ePqPh7PfpeevFKsY7eJL	1589	1040	447	12463	15765	jxTw5R2kPj7h3SZpKVi44MkUvTTNNHhC6uRwe6ZtBxFN4PeexPP	11848	16675	16675	1618940700000	canonical
23805	3NL2a3dZSgPCyy5yrL4o4iDLDDoKKnRufewNAqqt54tMBfhEvDsw	23803	3NKkTTzARFVmxQoTQQrSBBTvQwSk7yqidvFrYeWHyvGmrb6RCDtw	1460	1198	447	12463	15767	jxG7wt1NAbimxeSaa9aUcSQwhLXSFARJTbQYEhkdK4LMJkZufGS	11849	16676	16676	1618940880000	canonical
23808	3NK5WByHHCVz1V6mRCCq8eiQYWquSahtwpJEgQXSDquVBQQp8a7q	23806	3NKMaDRVqs8GhVwMYyKZE9FtX6TP3P974ZmixoeBzAwC7qAazPZy	58	1035	447	12463	15770	jwMJbAwSHqHTN88Z1AkiyNrFznEo1vpCLBnmmDmwTD2zX57SvWf	11851	16679	16679	1618941420000	orphaned
23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	1637	816	447	12463	15773	jwgVXiPcDs3rgKLyBqZDUeDtz5cb3u7sGsNhvJgajcat9QQC2on	11852	16680	16680	1618941600000	canonical
23810	3NKnmegY4qa9Lhk81oMUJFyHxNzebQcLJ4A21AhRGhvMcfRXzqMZ	23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	1633	1390	447	12463	15772	jxX7Sxq2F5RoyRHKurocsj8H1nNLcX9vBiAizcbBd1bVWr9uZ7T	11852	16680	16680	1618941600000	orphaned
23813	3NLw2g4NCL1YFVMSE31GzKpoMhVLvwmoS8fD24q1ik6PunvM6af2	23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	1573	1318	447	12463	15775	jxZUb4US88Xk12E39H41SDcMiQBYKW7tKp4zHwM2WWrY8sDR1qo	11853	16681	16681	1618941780000	canonical
23812	3NKG5QM8XgJAaLEVSh7W43Likf51L9G42trqjbzjco96XE7rtMiW	23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	1406	1393	447	12463	15774	jwiujnoCz9skr5uL2nTjZufCFuyTYkknn12oX5RKKDGYb1u7JN8	11853	16681	16681	1618941780000	orphaned
23817	3NKeri5HFH2U3PgdUVxgZt7SiuDyc4tQKJLpgmjnsmYznHT3jXY5	23816	3NKjH8bpneVw8X6iFfJ6812sKhRVieG6fxWMbfZpynFoVVj8An89	1476	1371	447	12463	15779	jxRDH6THWDe7MPahWooTUtHqjKevWfQkGYBDzfdrbRiSLU7eSkc	11856	16685	16685	1618942500000	canonical
23820	3NLbhqGRveEgKh3Ty7vgFVo9V6yeFqgN7okjLoWA7hAAnLShNxdo	23817	3NKeri5HFH2U3PgdUVxgZt7SiuDyc4tQKJLpgmjnsmYznHT3jXY5	1541	1298	448	12463	15780	jxWoQeDJ8VkB3n7tKvZ8bNpFfhPXRaLr4WSVtw8ayXYsyYZLvmD	11857	16687	16687	1618942860000	canonical
23822	3NKQDk3bD88MeneWMQwSF5Jecp5sZWTNW9fLwnYkArMFdj8yXMFq	23820	3NLbhqGRveEgKh3Ty7vgFVo9V6yeFqgN7okjLoWA7hAAnLShNxdo	1447	1219	448	12463	15781	jxHSfZMecF66rtYMqpxkAmgmC2HfRAPZw7BHE2m9xWSdyHmLxHD	11858	16688	16688	1618943040000	orphaned
23823	3NLvoNKF7BxAjLKPF5RKRnHfpcTQJd829N9UP3cUmcQAreC7Z8ZL	23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	1447	1219	448	12463	15782	jwvWP8kdXZBz3neyXbjDrtgqJDbSwF7TkwiRFbZorkR6diR2iM9	11859	16690	16690	1618943400000	orphaned
23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	23826	3NKYcfFit1Um9AwKRXC9QzCYAyYU2HVW7Lv1LnrfA6GzedTR5YW7	42	1361	448	12463	15785	jweKEfCGbZzfrJbxpwrW9C22vBjfvsZK5bip14BfecYdS5hUrdN	11861	16692	16692	1618943760000	canonical
23830	3NK5veqxqVQfTwGSoJXb67v74uMvpGo2PtwhEJCHeupjHst4sp8L	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1610	1314	448	12463	15788	jxpjm72fmGDtrkBx1iMbsxNWFT5qvchmJCUZCM3na75ifV2K23g	11862	16694	16694	1618944120000	orphaned
23834	3NLFLV8x1GESm3VRCaMzfWxxFbbZK4c48nHm8VLM5bpbx3SErthq	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1451	1046	448	12463	15792	jxCCF1gdx9YwrBYrwDiTQbfHxshEwSVpKnhTKfT2wTqK7C6xQ4S	11863	16696	16696	1618944480000	orphaned
28075	3NKeDH1Xk1iY89xEUaHLZjJKiPdB2XLTAq8AMXY6wsJsmoTRyruG	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1622	990	549	12463	18974	jwpWuafAvfBDwAd3TvUSEzEXqSCUjs7iSvbV252SBGNzBJuiSJ5	13881	19570	19570	1619461800000	orphaned
28468	3NKNrGaha9h3hBdTtshhimtXZukPXzahhHqTGty88nXW6SF2zT2X	28423	3NLLGeUBZiVgfvQinziJ6ikqRJ2yrhvU51hpJGX5PPoUvtCEHbC4	1553	776	549	12463	18974	jwBeFWWje6i8cvW7LggGh9ReNaCsE83JxN7QZqLjPsb2Vhsd9fN	13881	19828	19828	1619508240000	orphaned
23874	3NKW9GwiCtHAcAcCxjcboZfkQhFVwoqS6MbeMqXmUepcS19DENFn	23690	3NL528a43cykBJNaS2T4QVUvCnPMfq2EHxWrTBpMeG8NwujTKbJV	1406	1393	444	12463	15827	jwXrVqwgyCCngdVwbSQJEJAkD2wyR5bMGUUdEUAtht74tgamGVU	11800	16724	16724	1618949520000	orphaned
23778	3NKyC5R5spSjo4cZL4xxXtUDu3zZhtZ8kaTGiY1wi4xVrWB2zmb7	23774	3NKGXEneYFCmBcnFCaXBaw4i5pPbRRrh7YWtHVaRjD3Qmw2rM6Fn	1406	1393	447	12463	15745	jwW96FuEuNvximUgTL8X4ibE1zvjpKKjcF8hFcJcRQp2U7Dw8yo	11840	16665	16665	1618938900000	canonical
23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	23780	3NLX6zftVjJ741kbYK6NdbD9HCiRHUpKT4BXEDbNDA2YET6qAPWy	1637	816	447	12463	15749	jwqPEBZeaBjefeRL1PWPUMszZ6dvwswvKGq3ymnqjKbkM5G4dPA	11842	16668	16668	1618939440000	canonical
23785	3NLosNiAFtY7QUkVbDsHy2r46wa15MofLp6hmdX25dHTwE3eJmd1	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1405	887	447	12463	15751	jwk9AnqdzRnxCzGDPkrdQ4K3wKTGesmVE1EKLokm8FiwFUAGqHb	11843	16669	16669	1618939620000	orphaned
23791	3NKmX9YebGWWkkPrSvVK8Z18knvjJR2KMvsctNVkiDPF18u8oNWM	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1527	1167	447	12463	15756	jxhxCxgr6TDkdhwqcE9VynDc5XKgaoBdHuSkEqpkBwafpFFvP9n	11845	16671	16671	1618939980000	orphaned
23798	3NL73LMEo29BGVJnWYAxAshqjbXYnzjNZtfCbtU92HXKYN83Jw8K	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	484	1073	447	12463	15760	jxRz8pRSG2iT8VVWvf34Ezf3bHqYp9yZ3Sfu1jzqmXoqEsin6dZ	11846	16672	16672	1618940160000	orphaned
23802	3NLTw6ji53MRLghhDgfV4SsyUx5sokeVMzPaV8z3qHWgKjnCVxye	23800	3NLXL5LcRGg5XBM1xxB6qYTWzeT8ZdLoyHo673msUWfU2CnwaD5x	42	1361	447	12463	15764	jxdBQsVpLJjxMbeHPaQbwUu37S9SAZoKmaVuga5dZNqWxGk7xug	11847	16674	16674	1618940520000	orphaned
23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	23806	3NKMaDRVqs8GhVwMYyKZE9FtX6TP3P974ZmixoeBzAwC7qAazPZy	1602	1369	447	12463	15769	jxFGwRgLbrq3z8yTeaaAe21SN7PoXcxbxG2oxAQJsqsnE2EKpCn	11851	16679	16679	1618941420000	canonical
23809	3NKmJk7qY6djAhQdpUkhfaFN2cRT9LnXpKcmGrYhVzfgDgtUfmGo	23807	3NLRB6QNQncZWLV39smkEdAKwJzZs7vwyNJ1xUGXUp8pH6ugp4oM	1405	867	447	12463	15771	jwUpSqrDruqXc5h1qGeDCUij2fa5t9WxaeWwVc14F4H6gsj6sDn	11852	16680	16680	1618941600000	orphaned
23814	3NLZkj9p3kbdmtg3qtktmt5V1DhRSQLP6DGGF47uRxK8YmkmRW3T	23811	3NKC7VPqJ3syBCBgWz2dJsRQ6b5kapUqRTdXehP7MZKufBZdMsx8	1458	957	447	12463	15776	jx8NTEFFDxighNfgynmr4VUjtTYYqWnkozbyJES2sKnZmmPHaPu	11853	16681	16681	1618941780000	orphaned
23816	3NKjH8bpneVw8X6iFfJ6812sKhRVieG6fxWMbfZpynFoVVj8An89	23815	3NKgzpNmCmzXkgGoXp7azqL3JvjABcLHkt44pdqyx474DbWHELAT	1577	1081	447	12463	15778	jxQ6ksPpnC8TWvKb4BG81oMUgz7KhVH7nz8RT6tk5abpA9ELfiy	11855	16683	16683	1618942140000	canonical
23819	3NLSnCDpD3zd634PDHKXx7EEfQBwPGJCRCmaniqnkKbq25BuGY8Y	23817	3NKeri5HFH2U3PgdUVxgZt7SiuDyc4tQKJLpgmjnsmYznHT3jXY5	1541	1298	447	12463	15780	jxRtugzWBfK4xgTdcgJKoG78mC1CfhiZoWV5vytN51aaasfTTXw	11857	16687	16687	1618942860000	orphaned
23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	23820	3NLbhqGRveEgKh3Ty7vgFVo9V6yeFqgN7okjLoWA7hAAnLShNxdo	1447	1219	448	12463	15781	jxiRFYs8CtCLXtMmfsNGHbcgN9QLgTrk14JNxK1D6XKb2c5AFyT	11858	16688	16688	1618943040000	canonical
23825	3NKQc5u2yZVFBbA7PjFxT34g8wqXvgZgYFpe14cGLRphp2jgWsEi	23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	1447	1219	448	12463	15782	jwnWnpwQMxMfpt8z5MpK9a1XRKUH7ct1MZajsJAC94Wvr8CZZYr	11859	16690	16690	1618943400000	orphaned
23831	3NLegAfCHKWaF9vbJSwcKyPd4iM3FcJdFACEMs3iSf8eXrnBBp3C	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1407	1395	448	12463	15789	jxzSDegdFvCxgvpRjgbXxCUcbLzuTYjVkBn1S6g9NXQTmbB9jQW	11862	16694	16694	1618944120000	orphaned
23835	3NKmxSYYCimzSoT8CqvTzMKoiJnmUsenurPzU4xkixmfdtJmNtkh	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1451	1046	448	12463	15792	jwkMXK1HYz7yQZNYSUMWsmYvGPtH6gPoQmunj9EgqA1oTG2gWum	11863	16696	16696	1618944480000	orphaned
23838	3NLZFfcu45iLghNJEHu5sFk6MCmqdCjWqXWGtGj7gEWaqJpx6rpq	23836	3NK7n2Fm2nP4LAUsCnc4GX3ErVkn8BhgMYvkSXRjV4LK7ZEgk6hd	1536	1187	448	12463	15794	jwRn1frnUopkn2dhKebG59cbqtGsDRH7jvaUHjCRGr4ww4hkxpk	11864	16697	16697	1618944660000	canonical
23840	3NK8mGzAfbFLRVCfTW1kxRD5vwcX3EikXywYxUVeScDBSfsG9mRR	23838	3NLZFfcu45iLghNJEHu5sFk6MCmqdCjWqXWGtGj7gEWaqJpx6rpq	1631	794	448	12463	15796	jx9zzVehZ4MnyukgHDhBoFB48MNZppw1mAWXdx3pZUdthfCqPJC	11865	16698	16698	1618944840000	canonical
23842	3NLdYhtsDkGk2Dw8VcWnHUhkUayTbZWViVAvW3Qn9876vgVXh6HZ	23841	3NLMsk61J6rKe4erdMuMdvDAm8JjTubuoKBQ8hpZbio3dJRgVBvE	1553	776	448	12463	15798	jwENuSAtLLUX5QumQWfMG3QQRGX3jJEgwYUHMEsJj2HepdTx7jV	11867	16701	16701	1618945380000	canonical
23846	3NLYU4rtwj3QqB35xNu8myJAk4PoNZ3QmQM7rofyB2cXbfqG4q9P	23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	1585	1366	448	12463	15802	jwF9B9u9mZJbNKfmnuriUYJkqo78qq8NfD1bbTvXnMWyfd1qup4	11869	16704	16704	1618945920000	canonical
23845	3NLWhAqqNmfZth9ubBqFiMGPyY1feb9yCUdeMR9Hz6BRiUoWSvAt	23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	1675	1342	448	12463	15801	jxdKukrtvxXJhxTHMUCk9gFTWrDxGDeHLaJYXPMgGh3EXCgwUxq	11869	16704	16704	1618945920000	orphaned
23850	3NLTDiVYmMwzBUtJKXzRjHVPXprBs96A82Bms7QBmegee19gKYGx	23849	3NLBk1mZWgieD1yNSVKbhyUCL6TrMCSV4VuVgzkpZou4qyVkVZRS	1403	824	448	12463	15806	jwk6PTCohsPi28X2BsqJfrSHngVcYrc8r4G81QmNySav2ru6MYo	11872	16709	16709	1618946820000	canonical
23855	3NLbTjFTHW716AQCenrUk3HkD9f8AMJf6TZTrVT85sjAJrgwm3Dk	23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	1599	1041	448	12463	15811	jwy4pe7P2zQGyaeRRT715kSRZWJgsEWTXMRYus7z3Ygt8rwQ4Aq	11875	16712	16712	1618947360000	orphaned
23861	3NLFct35mqfAbMBi3YBeCqgwpWwNDCmrzvsGokWFbZV16fKYGpBK	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	446	446	449	12463	15814	jwLxJ6idvofNVFUqDUfcJmhPn33cBHixo7kC1A5EXHV9ZFgDRrV	11876	16713	16713	1618947540000	orphaned
23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	23862	3NLdjBh9LbUd1TS1qyBjrwrqVbNrEaGJw82LPCGb7tEEbXLgAHAq	1407	1395	449	12463	15819	jwNYFHZ36nnTdKFWqQybncgR7bYtT1eZETPbEq2c7bgYsr1fbib	11878	16716	16716	1618948080000	canonical
23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	1673	1242	449	12463	15822	jwsgn7XYQGG5pjZY9uwTSR8fGLmzoDPhvR4G8gLZUJimB25ZbBd	11881	16720	16720	1618948800000	canonical
23879	3NK3aVCgzHf5KE3oNsHJSxwYoAJLbEeurx3jZp7uvgkiGQFUX7LT	23875	3NLJkR2y4rE5KjeqKrKu45seejXKeqvtZecQhYGDh5AfXyFuVnwk	1631	793	449	12463	15832	jxRjFnjDUPqzCW5mfoN8QzgZaJ5gXy8A3k53ic4BxdEdXzceAWA	11884	16727	16727	1618950060000	orphaned
23883	3NLfoqxBE4NF2TeBPXUq2JuzPk7oPXEGuJZn8dBJnv8YYuFoU5tD	23882	3NKALUqmNTSMV4wMv1KfA4rCPZs1dKy3Gd9UduLz3gSfftZB8kJt	1560	1291	449	12463	15836	jxmaeTYS6V5jQSTmNwGPR8bTJ4Vmdo1vT9oMQgo41g3KNcMt7gc	11888	16735	16735	1618951500000	orphaned
28569	3NKsYQ9XtP9X391L5iq74A7aaaH4zet1HB4X2BeRMEFpdjALStiH	28468	3NKNrGaha9h3hBdTtshhimtXZukPXzahhHqTGty88nXW6SF2zT2X	1553	776	549	12463	18974	jxrSyyppNBvwfC2FjF397LwqCv96GqGhKzdWAf67V9Sk2WiKEHx	13882	19886	19886	1619518680000	orphaned
23800	3NLXL5LcRGg5XBM1xxB6qYTWzeT8ZdLoyHo673msUWfU2CnwaD5x	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	1564	1092	447	12463	15762	jxL1WFm3dFkbMoHfGYXq6NNiXVF9dxzr3g1nm1oPARi3j34MVRD	11846	16672	16672	1618940160000	canonical
23801	3NL1RfUWy8V6bZRdF8qn9v1N7Ew4bnB6ePqPh7PfpeevFKsY7eJL	23800	3NLXL5LcRGg5XBM1xxB6qYTWzeT8ZdLoyHo673msUWfU2CnwaD5x	1406	1393	447	12463	15763	jx9MYtD784RKWdqCc5qyRkA2fscem4gC4L7967VNXa2pPPYEKa4	11847	16674	16674	1618940520000	canonical
23804	3NLNDzxu9MD78qdVvbrWLCGGZiGk7e5ANnXVQzpYXe2KNNvCEWw7	23801	3NL1RfUWy8V6bZRdF8qn9v1N7Ew4bnB6ePqPh7PfpeevFKsY7eJL	1646	1354	447	12463	15766	jx9csCvb5TSdX1qFnaGM3tc3CaYhWJQkRSv6edYWZTBBHeZZYPh	11848	16675	16675	1618940700000	orphaned
23806	3NKMaDRVqs8GhVwMYyKZE9FtX6TP3P974ZmixoeBzAwC7qAazPZy	23805	3NL2a3dZSgPCyy5yrL4o4iDLDDoKKnRufewNAqqt54tMBfhEvDsw	1642	1001	447	12463	15768	jwt6SjP3wWQqCdkfSAsRExLtrmxuyMUTGnAdWCdodJD13CZT2Tr	11850	16678	16678	1618941240000	canonical
23815	3NKgzpNmCmzXkgGoXp7azqL3JvjABcLHkt44pdqyx474DbWHELAT	23813	3NLw2g4NCL1YFVMSE31GzKpoMhVLvwmoS8fD24q1ik6PunvM6af2	1403	824	447	12463	15777	jxpP3tCaVxmd4RZtUDnbAV6RFFk1EBMsCDtDSQkGp7dtFZG65Fr	11854	16682	16682	1618941960000	canonical
23818	3NKgBB4QHXDiuYPnmNmJi5kFDAqLWSnY21pMMVzARcJNrxRqygtC	23816	3NKjH8bpneVw8X6iFfJ6812sKhRVieG6fxWMbfZpynFoVVj8An89	1476	1371	447	12463	15779	jxRDH6THWDe7MPahWooTUtHqjKevWfQkGYBDzfdrbRiSLU7eSkc	11856	16685	16685	1618942500000	orphaned
23824	3NK3wW56rk8FLjCLzXkUJhJYMhhhXKitc5Nes4PnK9nVmMtDkeuS	23821	3NKd2g5uv45QbWWhMhonVFZE1EWZDWRd9539yPtXehGcuNZmhbxB	311	941	448	12463	15783	jxZsD4SvwGVHfje7NMz6w7P5DrHvKQCFcc9e77ECpA1jDdLEGG2	11859	16690	16690	1618943400000	canonical
23826	3NKYcfFit1Um9AwKRXC9QzCYAyYU2HVW7Lv1LnrfA6GzedTR5YW7	23824	3NK3wW56rk8FLjCLzXkUJhJYMhhhXKitc5Nes4PnK9nVmMtDkeuS	1403	824	448	12463	15784	jxsUbvb4aFYJgzDL9P9YGxbeh6fMHzgAwKoVo1mXBwMeTyRTDSY	11860	16691	16691	1618943580000	canonical
23836	3NK7n2Fm2nP4LAUsCnc4GX3ErVkn8BhgMYvkSXRjV4LK7ZEgk6hd	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1500	1297	448	12463	15793	jwxzMAxaVeCKmFSXyJwygPVGKFGfmBuTUB1echdUiwQhdjf32RK	11863	16696	16696	1618944480000	canonical
23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	23842	3NLdYhtsDkGk2Dw8VcWnHUhkUayTbZWViVAvW3Qn9876vgVXh6HZ	1642	1367	448	12463	15799	jxsJrnJ41Ne8FyAfr2cEDoK6ugWNUvdUGkZkUKVwto4C4PXULRH	11868	16703	16703	1618945740000	canonical
23848	3NLPcaVBNfAfr54FtLZwxVrxyAQUdj5FskKukNTAs9GXRKEeyV37	23846	3NLYU4rtwj3QqB35xNu8myJAk4PoNZ3QmQM7rofyB2cXbfqG4q9P	563	1233	448	12463	15804	jw7fsEXwLqKaB8ywMgFkeCXnmCHV1ZtXtxKTT14UKfrpfwLgbyL	11870	16707	16707	1618946460000	canonical
23851	3NKQHSa5H1giudNeLM2wxQbXYz8w1WpYYP8rgB9b5TvABHBt8dhF	23850	3NLTDiVYmMwzBUtJKXzRjHVPXprBs96A82Bms7QBmegee19gKYGx	1407	1395	448	12463	15807	jxQRNcFhikFwXdyAkpYmTuKmbdvd7LPZjh8wiBD2dsLN2zJEpFP	11873	16710	16710	1618947000000	canonical
23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	470	1063	448	12463	15812	jx6nccfzCQLL2ZVtXiWsNXxiiuqaSPVSUhuYQxETdSpw8kiJ18y	11875	16712	16712	1618947360000	canonical
23858	3NLMcZRG7HymPEDxdmU5SPeL9eFTT3zURfv6FSafWvzb9yEfAfDM	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	446	446	448	12463	15814	jxGCYexxh4w3L5LCxoWURnKo1XXcLGTd89kDzbevqnDbyfEuuF9	11876	16713	16713	1618947540000	canonical
23860	3NLMeiAoRnfMpuWDVudwcX4ZAya52C7FphbMSVRX4SKioc12CpD1	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	1553	776	449	12463	15816	jwRQYysFARWJAm89FGhqg6smpUuZH2MTp7dbiXuSdnwjY2sPY6m	11876	16713	16713	1618947540000	orphaned
23862	3NLdjBh9LbUd1TS1qyBjrwrqVbNrEaGJw82LPCGb7tEEbXLgAHAq	23858	3NLMcZRG7HymPEDxdmU5SPeL9eFTT3zURfv6FSafWvzb9yEfAfDM	1503	1031	449	12463	15817	jx6Ams1sNbFNcMAQ64RVaPLsgca2KLuXh1yqpMfEkX7SQyMvEng	11877	16714	16714	1618947720000	canonical
23865	3NL2AGywJwU4aGDasTtTWni7BcY7GYp9uZTJxxkVdRTJPbCiFakF	23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	1523	1075	449	12463	15820	jwRqDpD53L8UWWL1GnPQY8eBW6e9eJhTEwmpnHRq6yPELjJqtFt	11879	16717	16717	1618948260000	canonical
23867	3NLMx6Lr1uXPAq2zjsZUBgHNAG96eiwsTSna4E9Ea61ESecQ1kGn	23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	1523	1075	449	12463	15820	jwVGfmRMpDBV3b4XLeLFNsDK48BSitApXnyoSyatZZg5eM73ouh	11879	16717	16717	1618948260000	orphaned
23870	3NL2j1eheevViyBhq4xgj6MUJ8cnvEKTn4SV8wW5RCeTXoUd8qbd	23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	1402	868	449	12463	15823	jwthc1nL6bg4Wve5yHVCvCV1qWWfde7r9s5B3oQg8D9XvYBKygZ	11881	16720	16720	1618948800000	orphaned
23872	3NLMTerzi9zPh4qLq7uyEq9jDxxZZXJCbtrbZe7KxPdA6dpsfHVg	23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	1547	1252	449	12463	15825	jxUSsdMu1XnpDAosf7EogFKUzXxjnP98nFQUQ6BNMG94naHV3Xn	11882	16722	16722	1618949160000	canonical
23876	3NKZJHZJZftwtKJcdpCrh9VbN6tN4miVUeoQ7xeDjda6TEKSmrkp	23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	632	1256	449	12463	15829	jxuXCkBc8Eu7rpxSor61J1JjyPeEkad5XEKmzkxrzYFgdSGZ6fW	11882	16726	16726	1618949880000	orphaned
23875	3NLJkR2y4rE5KjeqKrKu45seejXKeqvtZecQhYGDh5AfXyFuVnwk	23872	3NLMTerzi9zPh4qLq7uyEq9jDxxZZXJCbtrbZe7KxPdA6dpsfHVg	1631	794	449	12463	15828	jwhfPuMgY7bHQuoRSjVhgFYxjzemTKTNqePDKvCxMCaA9xVcqSa	11883	16725	16725	1618949700000	canonical
23880	3NLcSd5KxnD1N1MZj717hkrvdhCMNarjqCJXBHkcZrTiMd7qGRvU	23878	3NLvd8BgpgHh4UF4hGEC8khx7qCeFYFqvKtq6ZdsGmfcHtBHZBRW	1637	816	449	12463	15833	jwDVwjyUQdzK1zUWHciwiWYGeb4DPgn6XjPwbWwvgtDFnbLaMzT	11885	16729	16729	1618950420000	canonical
23882	3NKALUqmNTSMV4wMv1KfA4rCPZs1dKy3Gd9UduLz3gSfftZB8kJt	23881	3NLF296ySkawQdHmGLpgt1io5e8apajQhQy7YEa6eb5JeU2sWthz	362	362	449	12463	15835	jw9exUFfZADY4tQWur1a9HmCmGzTyoEjSKywjt9XjU4p3G9Vr5j	11887	16734	16734	1618951320000	canonical
23884	3NLGMez9zc96AN1NKwh5Uuob9jkKMsAwfaYk5sYezhN1hYNf2MnK	23882	3NKALUqmNTSMV4wMv1KfA4rCPZs1dKy3Gd9UduLz3gSfftZB8kJt	1553	776	449	12463	15837	jxMq6rhU4qTEw6BDsd96z3SEFqQkLHd24fbEC6QDVioSpZpGkpS	11888	16735	16735	1618951500000	canonical
23885	3NLBsj14nuWsG75Spmk3Crzcvt3PX9aMMyFp5vQGkVRmjHsnWo1g	23884	3NLGMez9zc96AN1NKwh5Uuob9jkKMsAwfaYk5sYezhN1hYNf2MnK	1633	1024	449	12463	15838	jwXQuHTPb5GajKfQPkgo8s7Njzfd8zzRLhL8rDrqXFHLhTyKwJc	11889	16737	16737	1618951860000	canonical
23886	3NKgkNqWXHxFSVF2JgnZVmbnrMvzpNaseJ5kKsH5zF8tNaJuzGLp	23885	3NLBsj14nuWsG75Spmk3Crzcvt3PX9aMMyFp5vQGkVRmjHsnWo1g	641	1336	449	12463	15839	jxaFS9AiNG5dEmYUKja3XW8ydQkrsyFSuxMGQdma3WGYBGBUfsS	11890	16738	16738	1618952040000	canonical
23888	3NKtHd7SidCddA2PHyVpVwjz3ZMDcebRhgi1mBbikpEaQyMVaMXr	23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	633	1138	449	12463	15841	jxP88xEY9EWD8PxUK4fSvTT1K7HvGv9RQkvsdSQY4dz5a2ztKYK	11892	16741	16741	1618952580000	orphaned
23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1577	1327	450	12463	15844	jx98mkTKL5RgrmUcq6FddmyBRURPUVr5phG39gVUYb6N6A3bboH	11893	16742	16742	1618952760000	canonical
28579	3NLi9KR9qNMApSH9srxxbteBB5eD1D16Da3kwPwVGuGsori8sJJN	28569	3NKsYQ9XtP9X391L5iq74A7aaaH4zet1HB4X2BeRMEFpdjALStiH	1553	776	549	12463	18974	jxiEc6syNXQbSkwbzPGmudpjs8kiiY6Ycz3ewxjK5bZX7mSzB3r	13883	19891	19891	1619519580000	orphaned
23837	3NKuURKXsJHPqG5REg9BtSBnsfmY1xQggMzzPW6iEjNR5TXZ6Tdz	23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	1500	1297	448	12463	15793	jwf6x9MKnzqpwpwjFrBVcGfW4FgybF1tpcb2tQsy4UzPRJ8WTKz	11863	16696	16696	1618944480000	orphaned
23839	3NK9oVuyL1FJiooz3VLz1xmK19khBvDc2NYUFJqoTS4EVMqSBVbi	23836	3NK7n2Fm2nP4LAUsCnc4GX3ErVkn8BhgMYvkSXRjV4LK7ZEgk6hd	43	944	448	12463	15795	jxUsVc4432MYYkCUZTmBSeFGo8inQA5i1Wt5jc3WgunPRkf28hJ	11864	16697	16697	1618944660000	orphaned
23841	3NLMsk61J6rKe4erdMuMdvDAm8JjTubuoKBQ8hpZbio3dJRgVBvE	23840	3NK8mGzAfbFLRVCfTW1kxRD5vwcX3EikXywYxUVeScDBSfsG9mRR	1642	1241	448	12463	15797	jxyd6giKp4h7YvoAsZ2VoRbf87bBBTJfqUCgjxNwRmWGrXHSXda	11866	16700	16700	1618945200000	canonical
23844	3NLmx3S5cL5K8QVgB4SK5q8regR9ms9gUT9dKQBYuDf6YovHi7QM	23843	3NLuACfN18Emr4YBborTVjwjS3VWdYM76Tf5SKeuNZQUebtbCPPx	1406	1393	448	12463	15800	jwevZ9W7Qyd9S8urddFgLi5CKLJRVWicPffZsbc7dfDgXZui3bE	11869	16704	16704	1618945920000	orphaned
23849	3NLBk1mZWgieD1yNSVKbhyUCL6TrMCSV4VuVgzkpZou4qyVkVZRS	23848	3NLPcaVBNfAfr54FtLZwxVrxyAQUdj5FskKukNTAs9GXRKEeyV37	1536	1067	448	12463	15805	jwXGqzkxSAL58dedBwDYAPpRUtJN6WeXfm8htG5bHhDo2WyZT7b	11871	16708	16708	1618946640000	canonical
23852	3NLrYuL9TYZSkn35aQH9xPJFCbisaxiUEfGLpe6A2srHcvJxGUsc	23850	3NLTDiVYmMwzBUtJKXzRjHVPXprBs96A82Bms7QBmegee19gKYGx	1553	776	448	12463	15808	jxHVZ7sw5Jmo5VC1pjoepe9cAye45tFT5Q1Lv1rSeisEkov19yw	11873	16710	16710	1618947000000	orphaned
23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	23851	3NKQHSa5H1giudNeLM2wxQbXYz8w1WpYYP8rgB9b5TvABHBt8dhF	1402	796	448	12463	15810	jxUh1tGJL6PEJK9eGprqda8F9whN8e282xvxPBGUzsgbw7MVSxg	11874	16711	16711	1618947180000	canonical
23857	3NKn52a9VPX736RkSd4rBd3PWmTGYJwWgycZGyYg1pzB2hg4n4ZE	23854	3NKiGBhic7PrGXLurwuswQoi6JEjbHWh4W9atWo2nJAWZduK7ykN	1577	1327	448	12463	15813	jxCoYZwmU7KWiKZC86pSKYCux7VVywDMuY2osr77MmNkD4p8fNe	11875	16712	16712	1618947360000	orphaned
23863	3NKYU94KNns2FR92RsCXWdSB6xkm8jqm4QawAq1evpVCXAYeAJL7	23858	3NLMcZRG7HymPEDxdmU5SPeL9eFTT3zURfv6FSafWvzb9yEfAfDM	1403	823	448	12463	15818	jxaNGrETydNQnxPNSmNthBewVbFDTwTZFN24VRec8LZUYnfWphL	11877	16714	16714	1618947720000	orphaned
23866	3NLGjXkEccDLP5qYHTMMPfMmA9BHT2xZE1wRPEectqjvqiD9M9nz	23864	3NLncVZEy7Hj5Xcf5Cneq8PKJqNeh388cJ3UZpYv66etFqxH8Qs1	1523	1075	449	12463	15820	jwZ1fLAyHY7o8wfz6Wee4WM9wxbrgM9fZRG1Py3zgLdAF35ppWd	11879	16717	16717	1618948260000	orphaned
23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	23865	3NL2AGywJwU4aGDasTtTWni7BcY7GYp9uZTJxxkVdRTJPbCiFakF	1654	1340	449	12463	15821	jwcyWKCGhrJT5SZGCyvEPyra7TJv5dgm5V3Lv178HXvya6dRyGS	11880	16719	16719	1618948620000	canonical
23871	3NKPksFGjY3gSra28hEhz9fqeSysJxMf895dJnHkdUBT5wfzWYn2	23868	3NL5yiwkAVNWPSjrx9KgQTkHGJh8Kjz5c49A1HxMt9c2jy9Kwy9K	1458	957	449	12463	15824	jwctKBucMF1q5gghjDEbtV8WUpX1SA9mXyMQh6sEKWJZ9TjCjY4	11881	16720	16720	1618948800000	orphaned
23873	3NKeKBwEVeb5dcMJohBCdCrSP1McX9mHk64wq311v2c8VYhPjiq5	23869	3NK9KoGSPYTZ6xWP54ZjDdKDdKYjBNDL62JsX6ooYLVKhLhZdb36	1648	918	449	12463	15826	jwcLjm3q8Q7pZMAjrJFXYSHBLHi6EPpGX2PTKA9jQcAeUmXHPR3	11882	16722	16722	1618949160000	orphaned
23878	3NLvd8BgpgHh4UF4hGEC8khx7qCeFYFqvKtq6ZdsGmfcHtBHZBRW	23875	3NLJkR2y4rE5KjeqKrKu45seejXKeqvtZecQhYGDh5AfXyFuVnwk	1406	1393	449	12463	15831	jwL2hLZPMMyyhVZy4jYrvMH3428rwaQt5houXZoZGVkE1wY1iaz	11884	16727	16727	1618950060000	canonical
23881	3NLF296ySkawQdHmGLpgt1io5e8apajQhQy7YEa6eb5JeU2sWthz	23880	3NLcSd5KxnD1N1MZj717hkrvdhCMNarjqCJXBHkcZrTiMd7qGRvU	1447	979	449	12463	15834	jxfAa8e9vqBt2CYKmpTGGq2NBLfnAj3itpx12vjzjpqp9FeGuWk	11886	16732	16732	1618950960000	canonical
23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	23886	3NKgkNqWXHxFSVF2JgnZVmbnrMvzpNaseJ5kKsH5zF8tNaJuzGLp	1407	1395	449	12463	15840	jwd7osuW5rYyT3WXhfgTJLrgX2x1DJCVRv4KVa9Y9BueaevtzYG	11891	16740	16740	1618952400000	canonical
23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	1601	1022	449	12463	15842	jwtoXSqABLNQu2U91mxpxpt3f3he3vdEBarc737bcYKwD9NGnsN	11892	16741	16741	1618952580000	canonical
23896	3NKnrYWTtA99Laj4Rieu4aHCAB8pdzzGRKRg6YDHgivSuwyNrqcu	23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	1490	1148	450	12463	15847	jxN9NNt3oqZV5uc3eYmcFMa93ZtT3QGCTW6H3eHaoWrkddDaN8t	11894	16743	16743	1618952940000	canonical
23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	23896	3NKnrYWTtA99Laj4Rieu4aHCAB8pdzzGRKRg6YDHgivSuwyNrqcu	1507	914	450	12463	15848	jw7YrjgkB9SyYsTGpehFKyxqCewJMZyA6A3axRa7JecVF1yABnU	11895	16744	16744	1618953120000	canonical
23902	3NLwdEuRNjDMpnPkiSXM8r7vzMbVnbvJM9NZtF8rQc2J23WVgUE7	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1648	1038	450	12463	15852	jx9wjk6UHLFUiqwa72n2Cz7BGBBoG8AFbtcW4yymx6mpVsYpthb	11896	16745	16745	1618953300000	orphaned
23905	3NLsddWyCaLDiBtrYawBVivptYWGNw8WfLF88sZZvEvgnJHChMm8	23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	1489	1380	450	12463	15855	jwyZ1zNErACxm4skV33KUKrkS5kSSTSGNqvNKb8zPUdvQ1FPVtL	11897	16746	16746	1618953480000	orphaned
23910	3NKdCqyodH42r8EEVin1zcKS8quwcwJ4ihMKxu9w1GXnjACvPvE7	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	1534	1191	450	12463	15857	jxC53kGas74Jvd7XHyEXTY4rxS7UuUWXVtc8ec6xqBWERLp8uqp	11898	16747	16747	1618953660000	orphaned
23918	3NK2yYxKqBxDyVQksjCLzWziuHvAeNxDjoj4YdkDaLTCS8sUFELV	23915	3NLdLYGvHhmAxZipjVe9xhiKDCsELv7jgsC5EKoukEnpbboSG7Mq	369	1066	450	12463	15864	jwqfWen53fQ89R8zJf4ZGZcb9NoVhqAD8my4AaQff9kFqhuTuU2	11902	16757	16757	1618955460000	canonical
23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	23919	3NLFqhPGjXRx6sF1fRBErjz5sD7V3E4x8vAjysJW98AG6FpEnceg	1675	1096	450	12463	15866	jxjj2jCSvz47rWQTKDckNf35cSfA3Ad4CQoMuM1H2d5mUBW2Whg	11904	16759	16759	1618955820000	canonical
23923	3NKBoowXUcCQZfG4KyA7Hdu8Da21zbBQFxRWdnZTcvZg5SjaxSyY	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	1439	1033	450	12463	15869	jwZQ9uEFck1Zqbgf3ZeLQXFwvFKkmhAUcQWeggGU9XgJcDvYs73	11905	16760	16760	1618956000000	orphaned
23925	3NKPywcFw5kaBjNnbyHcE96tWZykydphAfqKpj8r7b2Ys33DfSkJ	23922	3NKhScEc8DvP9Z9VVZg62Fk7vcko9q9CfD3zcrK16dka6dLuyi4U	43	944	450	12463	15871	jxp18xUuQxuFcxASdDqdxsU3aNBLdAqmASUCyPiJX1xePByebqT	11906	16761	16761	1618956180000	canonical
23927	3NKKMjG2jS3VaxDJCi5dmgc7pEkMDafamA8qq8mgeNAxkAHeeZcj	23925	3NKPywcFw5kaBjNnbyHcE96tWZykydphAfqKpj8r7b2Ys33DfSkJ	532	1303	450	12463	15873	jwmkssZG9Njfto4vZ5pR4wq8ooaLfkDGJqcxXsmum9H9i25hTWZ	11907	16762	16762	1618956360000	canonical
23931	3NKYxGH3BLuKTQRx1XQfqWtF6RVr22xr36McAAQmHJomLmbvrkb3	23930	3NKJjLWpLRp42J98tdBGxnJHhbZrFN1FP4Vt78C1uGJaC31LbzmB	1668	1004	450	12463	15877	jxxTL6WMuxFqKXABiJxYY1wUThKBqcsZBtJF86ZHwTw4yR6CRz4	11910	16767	16767	1618957260000	canonical
23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	23931	3NKYxGH3BLuKTQRx1XQfqWtF6RVr22xr36McAAQmHJomLmbvrkb3	1477	1104	450	12463	15879	jxoZu33rVMJ3qxuW9FvsNamnqcm1dhXqUH7UnR4yKUNp27xSC9E	11911	16768	16768	1618957440000	canonical
28626	3NLhusdXsL3iJR7S7qWMcj6tVGzfHNtuMZs9ZwDaExqshEMVJn1u	28579	3NLi9KR9qNMApSH9srxxbteBB5eD1D16Da3kwPwVGuGsori8sJJN	1553	776	549	12463	18974	jwa5J7fHEfD2toJYuFRAvH6yqvo6bwwGikneQzijpuGFGFgZ2i3	13884	19916	19916	1619524080000	orphaned
23891	3NLQ7G9dJCmhtb1YyeNGHcsuaGeHPmSNAYwQbMhURCYyQfk8enTJ	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1536	1313	450	12463	15843	jww71mBD1RtRarrUNg2xsbLsbgMnHHrHipi1hTgH5PRtQkjFsWw	11893	16742	16742	1618952760000	orphaned
23897	3NLFNPaQBACCoEsZ4sZEtyNTaARfCV5tkdgNmhAkiKeHqL4Qt85w	23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	1490	1148	450	12463	15847	jx95QxNnF5gxy27JNaqg6XmEKKedCAWWX7jVM678NhkPc6BVxqN	11894	16743	16743	1618952940000	orphaned
23901	3NLWsi1cyh2pWyWJXP6AKagie2yc12Hn8o8rHXcYcdKqTERgA4ud	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1670	1036	450	12463	15851	jwRvXsUDnPS7Zgc3HoV2GkvwraKdL9JYXzEDH11knexro1gjtf7	11896	16745	16745	1618953300000	canonical
23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1673	1368	450	12463	15849	jwfCZz9RRrj7zsfdcKWSz8jDZSG4Ywbhds3r4quu2ozuvdBKDgZ	11896	16745	16745	1618953300000	orphaned
23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	23901	3NLWsi1cyh2pWyWJXP6AKagie2yc12Hn8o8rHXcYcdKqTERgA4ud	1585	1366	450	12463	15856	jwipkwEce7wU15Cd2KjxFGzfjkUEyWdhG9rpTDezxfiKgJft8yS	11897	16746	16746	1618953480000	canonical
23904	3NKKEfZvYsv7eCG6uuaJWrcpHaoDUTysYQ9EcTrmg1Cr5fEJTrLA	23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	1402	796	450	12463	15854	jxo3XnDVhJytwbvaDUFac5a1FBxaaj9QVTMkXtMNG3LrV5KSSaj	11897	16746	16746	1618953480000	orphaned
23906	3NKxTV9x4aiDgvag9SLidKCVUXC9PakarsTEWaKd2cN8C1VFFisn	23899	3NKo2pLHtvmibWG6nGGv4YEWZrGy6bCEgWw8GLa85fpHnTjPYAxh	1489	1380	450	12463	15855	jxYkPwUAgV431nBvWBVvWYbtCvhC7a5FEUkLuW8eyY7fdNh13qG	11897	16746	16746	1618953480000	orphaned
23909	3NLC5om7sQvkyPJAtLyyiGMyBhGxWetAwXPDvSRiM8Z16JtUDz97	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	58	1281	450	12463	15858	jxwz2Tp92SWPijEJs5n7hqp5fJj1H4RqggdGA6jnEVFa5nEHLZ6	11898	16747	16747	1618953660000	orphaned
23912	3NLQWBQLXBTiUEBpFvroW1arZeLpKxeHx66a2vGnn3XVzBd7qnB2	23908	3NLQLfoZCqmZhbFGaYQmgMURpakKxSmtVd1XcVrYHdhHrPyY5fK6	1448	1311	450	12463	15859	jxCdxZvWLMd49T8nFQeXnvDczbKXptCifV8yogdyhqrMdu57DVA	11899	16749	16749	1618954020000	canonical
23914	3NLXVCkemW3GFh8zNLYVt7dx7S7HMyQ5ZthJRo2Fu1NFrqohuaRz	23912	3NLQWBQLXBTiUEBpFvroW1arZeLpKxeHx66a2vGnn3XVzBd7qnB2	1588	1392	450	12463	15860	jwBCzFRidpwRsqVDm5iNZ3QDBsds4t6SzhDkeN4HXNrbH43Nfjg	11900	16750	16750	1618954200000	canonical
23915	3NLdLYGvHhmAxZipjVe9xhiKDCsELv7jgsC5EKoukEnpbboSG7Mq	23914	3NLXVCkemW3GFh8zNLYVt7dx7S7HMyQ5ZthJRo2Fu1NFrqohuaRz	684	986	450	12463	15861	jx5XtNe4nG2u7pcjLxY2teRdCUJw545k89Jjf8W1ZTHUPBuR2KT	11901	16754	16754	1618954920000	canonical
23917	3NLrbQ1oinBmhbGZLkwU5b3RzjD7AS3U7B5KAgLSxFhGCP6e9qUu	23915	3NLdLYGvHhmAxZipjVe9xhiKDCsELv7jgsC5EKoukEnpbboSG7Mq	1599	1287	450	12463	15863	jxZhJ88g4V6EsYqEk6MdukyuZ3u5JGC6ZFSa2Uq17QVjg8wHJ4a	11902	16757	16757	1618955460000	orphaned
23919	3NLFqhPGjXRx6sF1fRBErjz5sD7V3E4x8vAjysJW98AG6FpEnceg	23918	3NK2yYxKqBxDyVQksjCLzWziuHvAeNxDjoj4YdkDaLTCS8sUFELV	1646	1228	450	12463	15865	jxBFfGkEQyNhbPkt5Z7keRqxDrEhvtDofsbjFebNR2nCVcaKsuc	11903	16758	16758	1618955640000	canonical
23922	3NKhScEc8DvP9Z9VVZg62Fk7vcko9q9CfD3zcrK16dka6dLuyi4U	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	1546	1093	450	12463	15868	jxxRycBwNigLKaaSsTe8J9YV4MXXqhAywz1CDXntjTfjb3wih1T	11905	16760	16760	1618956000000	canonical
23924	3NKVdDg8aFzqSGRrAEJHkrumskHSuMQi8aZHVPyPE8J6LQDvgwwq	23922	3NKhScEc8DvP9Z9VVZg62Fk7vcko9q9CfD3zcrK16dka6dLuyi4U	1407	1395	450	12463	15870	jwPA2shBJBN5m466YxHUvGZP1eACBbgnMj9RNoRWpYKnAruj6q6	11906	16761	16761	1618956180000	orphaned
23926	3NLaRmWKggThociur2s9iXTjqKKrA8B4VmjRBNX8CrQZKM8sHqMp	23925	3NKPywcFw5kaBjNnbyHcE96tWZykydphAfqKpj8r7b2Ys33DfSkJ	576	1355	450	12463	15872	jx8xEQprAhMFW5QXwCmdirXn6eket7oJwRZBy9qsS3RAdfVppAh	11907	16762	16762	1618956360000	orphaned
23929	3NL2mUv6fuzdVTDjihQLbXS5RoihMwhBqbmtdJtTgSVHP553S9Bt	23928	3NKaxzpyjdrGPZ63MYvMEj6fxQUxMK3KbdzcFa2AHat1k2sNs1Y1	1406	1393	450	12463	15875	jwwvPL1eJwDQ9tLqk7bX9w6Um5Rbg9Dwqq2GzFiAfAYEiTx7WBD	11909	16766	16766	1618957080000	orphaned
23932	3NKTfLGNyUUnVmNtdmjGWCDXWQqsVTh6dA4PVrKu2wF4QY73V8tE	23930	3NKJjLWpLRp42J98tdBGxnJHhbZrFN1FP4Vt78C1uGJaC31LbzmB	1483	663	450	12463	15878	jwJJszZ173jrwTUhg1FGVPravuTYGWmrscP4ZS8jjRxa2pTEMFc	11910	16767	16767	1618957260000	orphaned
23934	3NKyip5qTLGQoidXANxpB6yx9WFq1NVggQRytACU9X1bgnnqixys	23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	1581	778	451	12463	15880	jxJQLoc9pPFm9uJRxXudtnkANBDDihsLKAZ7Uo77H8HzBxiAwSk	11912	16769	16769	1618957620000	orphaned
23936	3NLg34SdZnb3oU2mT5dfLDWj6ZybxpbsXKYyy25xLKVYjWpTZV9x	23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	1590	1300	451	12463	15881	jwM9q4AZoUaoNq5U5NLkoS5eb8iXjXRf9diivTHgWdFvSKJKF4E	11912	16769	16769	1618957620000	orphaned
23938	3NKcMg3ZnaS1yjdeDxQzQSTt7YeNFhqLXtCda2kaHMibA2Ts7oWF	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1646	1228	451	12463	15883	jxTngHQB5RSt7GST3gsTLgpe1vvdBx8nhgtdF4FLXYhjWvMn7oX	11913	16770	16770	1618957800000	orphaned
23950	3NKt75PbumixsWgzArJc1ToHiK2Q4BEzLd3H3vWXHMQyYbNN3uFX	23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	1617	922	451	12463	15894	jwvWgsnDFXYzgn5nSaoV29RfuNDxt6XiWxAcydUveBgnGWe5Rp6	11916	16775	16775	1618958700000	orphaned
23951	3NKM44oibe8HyPFGpBYT5Yd5FCakUK6H5gPRGFfBvMNtXH1EBqRA	23948	3NKMuSjX9T5pbMLAS47gJ1idJubYLLxwARxgMB2GJxWSQj8S4433	1624	1334	451	12463	15895	jwvnC6i61pgaTpJGZiaXzMqqXdvA44HaNZys16K8fDxHYscnLdZ	11917	16776	16776	1618958880000	orphaned
23958	3NKuUtdUC65ZYNZNbLgv2d8ZSnLmqyv3DgVTSc74q6BdjkY2L1JY	23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	1560	925	451	12463	15901	jxFLu9WkAmb4mUHH8n49BfSRfNb4YdrPDLXtd6o6QWk2NjgWnzj	11920	16779	16779	1618959420000	canonical
23960	3NKj3Fx67HwPLyUnapCfp7mbo644zMvJdcMK97RNhR2cHPX6Lxjr	23958	3NKuUtdUC65ZYNZNbLgv2d8ZSnLmqyv3DgVTSc74q6BdjkY2L1JY	1623	830	451	12463	15902	jxv64SQttLM5DRPn3DovmV18MozNZUsB8Vkk7qKRnQZvmY4FBJq	11921	16780	16780	1618959600000	canonical
23966	3NKGTZ2ZEypjweBQvCspSjvzWLHuW94zbK6WpVT3EQ3BFFEoQwEx	23963	3NLioacmzEHZMYinwav9m29X7Ve5DRVQhcciGgt4my5G7LqmHtGc	1590	1174	451	12463	15907	jwXxsRzimHBNMw4Po4GWRyZqYMiUwTy36xpTcmghwngSacLa4ak	11925	16786	16786	1618960680000	canonical
23968	3NKbzs9fH6TRqjf7hoXmxXasa7ZwzZYfy4t7vokeN2eFSm5CukAh	23967	3NL9Pdq6VjnFAwD6yfn5CDaU1zdwEw5EZ9P4PkU99KkHt7dp26cB	1406	1393	451	12463	15909	jwQRTK1y65C7BgDc1ZumJZ2ZffbKBxPozSFhQthyZVXrTFACFck	11927	16788	16788	1618961040000	canonical
23971	3NK3Winx3FWQML9r3wJ8b6C72atRtR7MyKMQBd1FMkNZmFHGwUqS	23968	3NKbzs9fH6TRqjf7hoXmxXasa7ZwzZYfy4t7vokeN2eFSm5CukAh	1407	1395	451	12463	15912	jwJi5kEHKpmQQk54jxWgWVWKUWKk3f4CaftkVBP3xot3s913AEZ	11928	16789	16789	1618961220000	orphaned
23973	3NKwbc36K4eMNCmmoz5x811tBSXWyVE6yLqNgpohL7i4gbQdr3nC	23970	3NLtzpQfgFWnknndp5S4XasoRVSZ4xnYwsSCo3HyqZbSzF4nYQ3w	1403	823	451	12463	15914	jxuGXuz2qwvApR9AyybJHks7btrcwW7VYbV1nv1V6DxM3StUFxA	11929	16790	16790	1618961400000	canonical
28085	3NLxeLyghmSoAFR46sKQnSLfhzvvf5Gokhd3FquHN9BPFmJ3mzhX	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1668	1244	550	12463	18974	jwzBxedzpfzBieEuwmmZRKpjp75zws9erGzK8b6hhA22338QzRf	13885	19579	19579	1619463420000	orphaned
23916	3NKy8yYtkyVKP5oTVzCiMKjmpLzduVZ1SASnQtrbDPhbYGyh86mM	23759	3NLMPTecUvnkn45vsTNDkdDejmoTYvTxRDS1GPgYVSYq9TTTB5ta	1455	1332	444	12463	15862	jxXjBxwCa1mSvCfEtyhqa39VMxzS56PuzcR36tfHe4S11Be55Wh	11755	16755	16755	1618955100000	orphaned
23895	3NLA13UQMJUwRMrFFWszA8tbVCzb8A2ckd2ACeWKVMBAzRw1XYDL	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1559	1227	450	12463	15846	jxe6uvYEfQK4rSBxpWKTtaxWVpVEaGtrFF4CtV1nnBKXNdprq2v	11893	16742	16742	1618952760000	orphaned
23900	3NL9s3u69x5erA8Vzy5uTk2k3E36iDeZrWEUmTLuy81n5G65E3Ty	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1607	1348	450	12463	15850	jwx3rzzYtcr4ydp4k3F53r1rDCwJaCcJ4viTy8f7XFsUXAw5ssD	11896	16745	16745	1618953300000	orphaned
23908	3NLQLfoZCqmZhbFGaYQmgMURpakKxSmtVd1XcVrYHdhHrPyY5fK6	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	1534	1191	450	12463	15857	jwASxx2rNreeHdaRqWqHg6eUN3aC2heCBPJrazHTV2iE3fkBSfb	11898	16747	16747	1618953660000	canonical
23913	3NLRQ6R3B2sR4TCSSBFbusRgnLYu9gEZvnLrxXB6xnddZMwG9VYc	23908	3NLQLfoZCqmZhbFGaYQmgMURpakKxSmtVd1XcVrYHdhHrPyY5fK6	1448	1311	450	12463	15859	jx59mPCnXgMhd8H7gMqr5yRc9eXza8RDD7jUzCvAENXPBvg71uR	11899	16749	16749	1618954020000	orphaned
23921	3NKTSytieUZ1kCGajoD7qg16xAqMvShWZyvpJqTfDoSb9JXwRAsm	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	684	1352	450	12463	15867	jxG74u7BsT2Q2mFNQktXoYKJG1bxGvsrq4TLP1uguWXtbvVM33s	11905	16760	16760	1618956000000	orphaned
23928	3NKaxzpyjdrGPZ63MYvMEj6fxQUxMK3KbdzcFa2AHat1k2sNs1Y1	23927	3NKKMjG2jS3VaxDJCi5dmgc7pEkMDafamA8qq8mgeNAxkAHeeZcj	1600	1372	450	12463	15874	jwEx12JYAuvbKxjxVCDrngLh8dVDGW5nVdkCRLmTCuBd3k6HE78	11908	16763	16763	1618956540000	canonical
23930	3NKJjLWpLRp42J98tdBGxnJHhbZrFN1FP4Vt78C1uGJaC31LbzmB	23928	3NKaxzpyjdrGPZ63MYvMEj6fxQUxMK3KbdzcFa2AHat1k2sNs1Y1	1671	999	450	12463	15876	jw8sTiV1xgTVH6HcJ2Pod5cz4dWpZpBtb71QrW2x9ZBkFFGcgPu	11909	16766	16766	1618957080000	canonical
23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	23933	3NKbGRgJMsnZHTHXQACCgiPyVENZemBYQG7uCtDKpa5e46jBYGk6	1590	1300	451	12463	15881	jwKjy7vttodT6dJqwSBdL6kWsN3L44hatpSU75wnwioUCLA9Se4	11912	16769	16769	1618957620000	canonical
23937	3NLkju7PQ1wPz2SMAEQV84tRP1iaVqkLLhm9cEp1Zp6yKCQ52fqf	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1471	1386	451	12463	15882	jwRzrLvTXJqSQ6HXU9UUxQLLaWZSQ3ovfzVdVPJqx8nYwxkC91P	11913	16770	16770	1618957800000	orphaned
23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	23940	3NL54b1xtWj5uGcZBkuFtDZADreGXiLacXhBUgG419s7ypQPj2wQ	1560	1045	451	12463	15886	jxTGZgY3kVMj5DEVhzcFQAVADgpPb2PdyE8ssNYquyzcinWf5rK	11914	16772	16772	1618958160000	canonical
23945	3NL3frwNJAgZTrrLhjBzTBLHZWEw51gQ8CYeww63d8ffRYVEmbv8	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1405	851	451	12463	15889	jxzoLFuaKGEonDa5P2p1JYToEBrBNGPU47nYBpaaBCozEcv1Enj	11915	16773	16773	1618958340000	orphaned
23980	3NLYthha78PRaVdgarqQDwDikBLRgS5biW3cfvvJq4BLqP32Dqoz	23947	3NKXJtG3JbW7VbVZfuT2iBd9rnwNM3b1aCHHm4xDvEm6in1P8QFb	1500	1051	451	12463	15920	jxwRRaYg9PkfKKGrti9NwLTVf391WBYPoGNUa2xwR22MU2EA6jq	11916	16796	16796	1618962480000	orphaned
23953	3NKN5QnWLFcKCzB2qmMxB8JWeE9FdCag1xfS7JvPd7YkoV1PSBWj	23952	3NLjb4TDR4xi7JgYiVQqDwa7yQhUBLcG2GY8GwwRVrQea8KgZpvJ	1447	1345	451	12463	15896	jxRKP4zARSHXgVVE6wpFuhYio8qVvWg1FKCVQTZwWvNprh8BMte	11918	16777	16777	1618959060000	orphaned
23955	3NLZVi7YQZ6D89YHMwVkRoWY83iVRzEz9wWdRQ4uyC9PExeTmyM7	23954	3NKfZQ1twHY67G3HL6ReqmeCmSTuXAdV8zg8QF7hLVB3K8d7pRdJ	1602	1369	451	12463	15898	jxby9pwEg2cxSDjmaRyBzU2ntoD5AtyQuQSk8gWy27a8oyoGLwh	11919	16778	16778	1618959240000	orphaned
23963	3NLioacmzEHZMYinwav9m29X7Ve5DRVQhcciGgt4my5G7LqmHtGc	23962	3NK7JSkpmhfDf2vcx1VSMxM1wPpecLVPwQBX25t3poKVn3btf911	1593	1346	451	12463	15905	jwB3JB8bnhcVLhcgQCrB5Sd1uVFYTR8QcXeEHmRmmWyNBzvTXcG	11924	16785	16785	1618960500000	canonical
23965	3NKjywnhdVv5KrDvpZ88jtd92BhUE3Wc5YEaT9EPm8uRpa2huUjG	23963	3NLioacmzEHZMYinwav9m29X7Ve5DRVQhcciGgt4my5G7LqmHtGc	1590	1174	451	12463	15907	jwVLVWef4tyJWiZmTsy953PdnACAoombEYvTk8zh3BFdDt1w9To	11925	16786	16786	1618960680000	orphaned
23970	3NLtzpQfgFWnknndp5S4XasoRVSZ4xnYwsSCo3HyqZbSzF4nYQ3w	23968	3NKbzs9fH6TRqjf7hoXmxXasa7ZwzZYfy4t7vokeN2eFSm5CukAh	1516	1168	451	12463	15911	jx3aEKHdkaszZqHZb3jBvZdSUAD7hpUPheNx15znSdvP8fa2Psv	11928	16789	16789	1618961220000	canonical
23975	3NLSwqmk5H1dUYwQcemPGGGr64P3z6jcejv5eztNXBnUo7VAZJHY	23974	3NLGEH39BQwcUwypsLoSVy8PVcrAGEWhMqH2Fxk3TV7U8ejhL6Xi	1422	971	452	12463	15916	jxVzy7dxJxRVTAWvmVqXixTGx8cEpkLgVHB1Yo6FNHE2i8FcmTu	11931	16792	16792	1618961760000	canonical
23982	3NL55Fm5iQUcsGyjPAoBW9km1NW2JnMZgjNBWY1HSUecLEkivvEP	23979	3NKh49P6oQakpT2PPERPXcVwLVvFJKTRNqDkt994zLnUJVPYHNru	1500	1051	452	12463	15921	jwvbi4byfxJjxr1R4y4JG72QraiaHxFE7PPgwQbTHLn1FfeW6z7	11935	16796	16796	1618962480000	orphaned
23987	3NKQ75ufanFdWbRTXMLa7SR4bqbFRGY9Q2w4v12Hu6oqHvE1uHqe	23985	3NLpYtVmVY8DEWfnKEoGvga5cuvBzDfdGHoVZbwnq9MwULTt57bf	1426	1364	452	12463	15926	jwtnMMpch3DMN5HNPNsnv6yqUdiWkT3zw3KeyxFgHxr1gQpmWUB	11938	16799	16799	1618963020000	canonical
23996	3NKoTJgXyce8wsiSBkdBqARivs8DgLb6NNS7xnEgUp1hS1MegSvG	23994	3NKoxNvRLhRzdyK1KrGq5tDqQ4B4745FxaqjBUBAuf9gN517fPuC	1622	1356	452	12463	15935	jwiG4Pk6gC5BFJPcAZzSuvMm2evKDJDczSSQ4RyUJS6zRfHDLJB	11942	16803	16803	1618963740000	canonical
23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	23996	3NKoTJgXyce8wsiSBkdBqARivs8DgLb6NNS7xnEgUp1hS1MegSvG	1589	1286	452	12463	15938	jxmucMNtVxLpUGmBR9TvuhXbNiouAn8jJ4oCBxrSYtAoNxgFvot	11943	16806	16806	1618964280000	canonical
24008	3NKDc7MZgFHYn2ApaW2tX2vEuEt4cSuLdYCj4hQy8Ki8Z6CeUA1L	24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	1623	830	452	12463	15946	jwwU6iLqzbM4AD4VbeBuxD4pBi1FF9AQA6SXb6ZFfnAUWapDpKi	11947	16810	16810	1618965000000	canonical
24010	3NL2pAPB49rp7R7P4rr72SULuZ74ufSMSUzNk21HJWnNsZmezLC8	24008	3NKDc7MZgFHYn2ApaW2tX2vEuEt4cSuLdYCj4hQy8Ki8Z6CeUA1L	1406	1393	452	12463	15948	jxqh1CEhczhHzyXUENvP3cg7KpQmku4qEpeGbL55rGEXc7zsv9Q	11948	16812	16812	1618965360000	canonical
24013	3NKUh7whZtFCq1PsXcGRnSpksGFQNNVFKrAoBX2xeyUMew1f2o9T	24010	3NL2pAPB49rp7R7P4rr72SULuZ74ufSMSUzNk21HJWnNsZmezLC8	1637	816	452	12463	15951	jx3F1sUZQaxzJGWPqyCKm8WUZkf8u4PGFQLDwM22fk7GKY4rF6N	11949	16813	16813	1618965540000	canonical
24017	3NKPmsnEvYEDLoEMTKnKLhZonq28ye1RqZLbab5UsNoULHtakCEG	24014	3NKdJ9dHd6J9qJNZoUPW21hAbzvWpygGXgW2UrtZwkT47S8uQq7R	1571	1335	452	12463	15955	jw89qgnfEUae97CTQsiBQj8u4romP7rbjcLFE85CXenjFNR4hTT	11951	16815	16815	1618965900000	canonical
24030	3NKYC9k6DRPfUzFMFLvjoNeEdi1C8rstn6wsdW9KRbs2r6aFN4ou	24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	1637	816	453	12463	15965	jxX87PbvU4rR7F8NZ1C4qMJyFxvFzP2THLdQPDptDq7W1r3FBy5	11958	16823	16823	1618967340000	orphaned
24031	3NKoRjt9ErnPA9A9Az5NiNMaRc79XMCHVnukyBCPGG5W3pADv4TX	24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	1642	1367	453	12463	15966	jxRe5CwVM1JUDv3X3k3m2Q5ap8SDAHt445fRExV6MekHVtUyVVo	11959	16824	16824	1618967520000	orphaned
28677	3NKnny9sMGLGRwm1TL6fH7uds3xSMEcih77yRj9ng8wjR2L5Bb2U	28630	3NKV8Y8Yks3suBZAeU2pPvRgiooSZTnMLaDqKZAxtVqraHgCa11J	1553	776	549	12463	18974	jy2svANo6QtJBzwz4GJ4eoBtFAwFLVnB3GnMDxVDwFuh1b5Xibn	13886	19952	19952	1619530560000	orphaned
29399	3NK9krJkZgpBWbg9dit8NC8XM9B6cryotjUEimCtrM1dz3wVXfNj	29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	632	1016	577	12463	18974	jxqghTvC66bRpZGbVBnghoz7tUSNAWFjyeQPx6X2N66vTCaLavR	14494	20401	20401	1619611380000	canonical
23940	3NL54b1xtWj5uGcZBkuFtDZADreGXiLacXhBUgG419s7ypQPj2wQ	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1407	1395	451	12463	15884	jxUqucWk2DpyKRtJcZ5oFtoXHR3ssB3FSxyt54T89zjfu6FNaP9	11913	16770	16770	1618957800000	canonical
23941	3NKZC5FxSgNyAvxc9wZeGPAGnqLAnySKXkVjFBxcCRCGydVJ3DWr	23940	3NL54b1xtWj5uGcZBkuFtDZADreGXiLacXhBUgG419s7ypQPj2wQ	576	1355	451	12463	15885	jxUWoWdN14UKJ7wkXZcs6Jx5PLJrX3JYFmJNdxFVrysgzJbe3Vb	11914	16772	16772	1618958160000	orphaned
23944	3NKJyyADWGYjGy3ea9qZRXEn3LEv5Z2akPp1k1ejNkTycyUevzk7	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	621	621	451	12463	15888	jxmToHxcNByk9B4DFteDT3PFbpFjtAgtEyMcNizTuBEsqnZyzrT	11915	16773	16773	1618958340000	orphaned
23948	3NKMuSjX9T5pbMLAS47gJ1idJubYLLxwARxgMB2GJxWSQj8S4433	23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	1588	1392	451	12463	15892	jxWXEa2JEuTYoGc2YAmcrQeBrFWJQj3mY4dKgzFc2mRpK8rQF6N	11916	16775	16775	1618958700000	canonical
23957	3NLFCysNVfmwDFhG5kauy5zmLnPFrArwRZp5v8VAeW9rfsy64YZ6	23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	1402	852	451	12463	15900	jxawEE8sYmaxSoJbM6pmBTTBbYsFXrv9WfuTWiFjfWff39aHPjW	11920	16779	16779	1618959420000	orphaned
23962	3NK7JSkpmhfDf2vcx1VSMxM1wPpecLVPwQBX25t3poKVn3btf911	23961	3NKZqUFhjtfjgDNJcGn5PM4XWdXq5mfu3tudUzSB8EQ4FfsWnr8L	369	1312	451	12463	15904	jxUaQJavXjFt5mcgwf59QS3cyFCVNBxFsbUDifQAYJTuHyobbdJ	11923	16784	16784	1618960320000	canonical
23967	3NL9Pdq6VjnFAwD6yfn5CDaU1zdwEw5EZ9P4PkU99KkHt7dp26cB	23966	3NKGTZ2ZEypjweBQvCspSjvzWLHuW94zbK6WpVT3EQ3BFFEoQwEx	1407	1395	451	12463	15908	jxws5qb4N7CRg5fc75KghvktD3ZqpsFCWpEV39xuGed2KFGacWP	11926	16787	16787	1618960860000	canonical
23972	3NKMmmuteUvNgQTMRgY5EiFUe9svSsvUtwRHX7iu9K5vFYTWfmk5	23970	3NLtzpQfgFWnknndp5S4XasoRVSZ4xnYwsSCo3HyqZbSzF4nYQ3w	1407	1395	451	12463	15913	jwg3uXmNefKgNwMsxd4APc1LAQZW4gjvDwKS5V4LVSctLotpmUt	11929	16790	16790	1618961400000	orphaned
23974	3NLGEH39BQwcUwypsLoSVy8PVcrAGEWhMqH2Fxk3TV7U8ejhL6Xi	23973	3NKwbc36K4eMNCmmoz5x811tBSXWyVE6yLqNgpohL7i4gbQdr3nC	42	1115	451	12463	15915	jy3AsDst1bGVEZuNgRJFan2ufsbJmZfgNShDkeBdEeV5iTJc2Xe	11930	16791	16791	1618961580000	canonical
23977	3NKzbvdZ8CR8EEBcKggqpb5gyaj3WeuaaZiRwqzdPDHPwvjkrVJz	23975	3NLSwqmk5H1dUYwQcemPGGGr64P3z6jcejv5eztNXBnUo7VAZJHY	1672	1285	452	12463	15917	jwju4YgqTyK7KhPT53UsKfWdG3vsE34MhsJUz8qGgoTFb84uY6V	11932	16793	16793	1618961940000	canonical
23979	3NKh49P6oQakpT2PPERPXcVwLVvFJKTRNqDkt994zLnUJVPYHNru	23978	3NLcznzQqEgtBycripkWQ3t2FumzPkdGxFavtDLgSUdNgpdqW2VW	1611	1215	452	12463	15919	jxEejhUUpuJM7untM2BxWxTji11fVcTo1jYs8SeeSb84i4oKw4d	11934	16795	16795	1618962300000	canonical
23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	23979	3NKh49P6oQakpT2PPERPXcVwLVvFJKTRNqDkt994zLnUJVPYHNru	1500	1051	452	12463	15921	jwis9MxEa4emkpLJceJjA4223qVfdcjQetxEYNDvMiCL1SGHUEy	11935	16796	16796	1618962480000	canonical
23984	3NKnBfonCjahp666axomHuP3TeviRiGo48umqC4G6SB9PeBE7fh4	23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	641	1336	452	12463	15923	jw74Ej3ghWvgRLg2TaUs7R5Ac9CRNwhKmB9EbxoB3SMHcP3SAFn	11936	16797	16797	1618962660000	canonical
23986	3NLpVVwf7JgEgfKGJYuXRG9stVEVwzDzEtyp7F2f8qVFBfEYKkdt	23984	3NKnBfonCjahp666axomHuP3TeviRiGo48umqC4G6SB9PeBE7fh4	1403	824	452	12463	15925	jw7Q6dGsjU2oGbPXSYqZuXe7j3Tqe5u1aLbF3LKpNTcmZ4Nm6Jv	11937	16798	16798	1618962840000	orphaned
23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	23987	3NKQ75ufanFdWbRTXMLa7SR4bqbFRGY9Q2w4v12Hu6oqHvE1uHqe	1642	1121	452	12463	15928	jxZNPdVfBaojkwLXNYXj9cv8LZZEabT3mGato7CfLohB7P2bZfo	11939	16800	16800	1618963200000	canonical
23988	3NLfXBbt3HTARxR27q13eQdKuo9L2aVg2jgKBVdF24HRQxoQLumv	23987	3NKQ75ufanFdWbRTXMLa7SR4bqbFRGY9Q2w4v12Hu6oqHvE1uHqe	1522	1076	452	12463	15927	jwj5bUibwtWEeL5Qzy4G82v2A9ZFNcLf8noZWLWDBgfMR5g95eE	11939	16800	16800	1618963200000	orphaned
23991	3NKZUzA9TsT5UHAbSSZY1DNuK1QopM6YJzLz5iNEbMVKGHmGuMY1	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1654	1340	452	12463	15930	jwBivFsHG2qnBWKxVwLcVdicQUCARW55xueCTtEGyQEMmhZxVKb	11940	16801	16801	1618963380000	canonical
23992	3NKrAgqRViHQ9nzQireSdAnqkJgedRYSbPv9jnkNpGnD7sXtbMVt	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1403	824	452	12463	15931	jxG3SwZ7bDWYyDCm6e4x71aL65azoN9EKtEizc37zbAUbkPxF9j	11940	16801	16801	1618963380000	orphaned
23998	3NLoSsHbEUYPcPuB95XnnioBYXzycnA2wGZfmzmVfAVFNNLG6oT4	23996	3NKoTJgXyce8wsiSBkdBqARivs8DgLb6NNS7xnEgUp1hS1MegSvG	1670	1156	452	12463	15937	jxPuCwXrfuakxrcYMo9xv49qK9WUrTj6udytNtv6iqysvP5QKL6	11943	16806	16806	1618964280000	orphaned
24002	3NKTkya5SFTBPokZycC26jgkhgjCfZqR1MvSk3A1MfPuge4fgc8k	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	1607	1222	452	12463	15940	jxpKidegAcm5QbuuEzfpfX8aiz5mEC6KQy8mh6s86GsBhG2fYSh	11944	16807	16807	1618964460000	canonical
24001	3NLMTEwY3MJeyuXmCpnGBYftVk9WUDUNKkXptkqFGvGmUpaHgj7i	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	1607	1222	452	12463	15940	jwKxK5C4BLYNgpWBKJKsQByq9HXE4d3QnUMXB7D4fgm6GiwGpfp	11944	16807	16807	1618964460000	orphaned
24003	3NKz1ydVFyMoNe1ftQ8V18uDBrGCQ7wbEJygpYCkzGZYQGvN79Cu	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	576	989	452	12463	15941	jwimdkEtc6VdcgkX5eUnQAu7vu5VsuaQ38Pre8BbBeobk9y2Xky	11944	16807	16807	1618964460000	orphaned
24005	3NKGWiC4nBxJSyzr8e2y1G4KHsJbQp6ciidZuNp8tNhta7YGZ9BG	24002	3NKTkya5SFTBPokZycC26jgkhgjCfZqR1MvSk3A1MfPuge4fgc8k	1483	108	452	12463	15943	jwFfC3FfxRj8M1tq7TYh5HMkio9ewdNyFuLYKuCDkDw4EY28Hog	11945	16808	16808	1618964640000	canonical
24004	3NLL8wJob24GH3jDMPxPQNioSy88fbd15cvP4DAqzwN2msdFztHy	24002	3NKTkya5SFTBPokZycC26jgkhgjCfZqR1MvSk3A1MfPuge4fgc8k	1406	1393	452	12463	15942	jwezTPxvQq1G19qzw9EQgkn22i4D6L14rVJYyvDVpJh95umFRFb	11945	16808	16808	1618964640000	orphaned
24007	3NKjmZpmHrCTBJc9Y4mDNsWcbaN5WTvZzc2PuEhkrWfeWYjiD9tJ	24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	1406	1393	452	12463	15945	jwDNQGeFB68wLfbBmwnHCZY6bQCJzsiJ2d6oGHvxHoGfeQCKVCm	11947	16810	16810	1618965000000	orphaned
24009	3NLWVLM3Q314pAa2evzEgtWscpTgowzPs2rbpC2cLm1g3x8Vi87o	24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	1633	1264	452	12463	15947	jxNSGw7XrV47XqDTW3cJUVVcTvKpF6ED1JEupgbzZoSVHXVar8B	11947	16810	16810	1618965000000	orphaned
24012	3NK4yMuDbT5X3NmM9WtNznXYM1jgVZiSKv8FTuAaTP3daXJrpm4s	24010	3NL2pAPB49rp7R7P4rr72SULuZ74ufSMSUzNk21HJWnNsZmezLC8	1573	1318	452	12463	15950	jweU8hongnfoFAC3eAzToiqVJy72p7bzJZM8CaRLe6Ma8Hb4dij	11949	16813	16813	1618965540000	orphaned
24014	3NKdJ9dHd6J9qJNZoUPW21hAbzvWpygGXgW2UrtZwkT47S8uQq7R	24013	3NKUh7whZtFCq1PsXcGRnSpksGFQNNVFKrAoBX2xeyUMew1f2o9T	1534	67	452	12463	15952	jxw9NSJrjYqkAfkqV1dmehmNh69LXVnfV7bHJQiheWsfDW2dkgm	11950	16814	16814	1618965720000	canonical
28100	3NL2bveucAkkLPiMvzaFWA1WeE6MLLKTqLC5x99RZUNhACuEsLne	28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	596	1060	550	12463	18974	jwqe9ucSH4qM7Q9MmgBCww5n4zqRZnxcrzx3wGbRxYz37P9m837	13890	19586	19586	1619464680000	orphaned
23993	3NLWMNJXL23rqUa1bx2MxtBP5vrsZ8NCjYxEtBj97uJXEzr3giCp	23891	3NLQ7G9dJCmhtb1YyeNGHcsuaGeHPmSNAYwQbMhURCYyQfk8enTJ	1657	978	450	12463	15932	jwzWoTT54JfJ1RJzBuJrte5wdfrvi5TVGt7YNB3KfAfSHTAumaD	11894	16801	16801	1618963380000	orphaned
23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1602	1123	451	12463	15890	jy3AcihFxhmuXVopxAxGmSDG9EMYR2moUzKi49aVTQWW5Apw5ai	11915	16773	16773	1618958340000	canonical
23943	3NLxY13cu34Z5PvMx39ZLKWAyfSS4sjQi89km6PCihHk4aQLsgNa	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1571	1335	451	12463	15887	jwFtQxB8PQ82w59iZ6DbXSPWavxqavUNBgQpvH5WF7Q6iVTWjCp	11915	16773	16773	1618958340000	orphaned
23952	3NLjb4TDR4xi7JgYiVQqDwa7yQhUBLcG2GY8GwwRVrQea8KgZpvJ	23948	3NKMuSjX9T5pbMLAS47gJ1idJubYLLxwARxgMB2GJxWSQj8S4433	1624	1334	451	12463	15895	jx4k4wabX87JtGzdEESCZQ2pQzgSmUHbu4QL1aQ1Tjush6fhzbB	11917	16776	16776	1618958880000	canonical
23954	3NKfZQ1twHY67G3HL6ReqmeCmSTuXAdV8zg8QF7hLVB3K8d7pRdJ	23952	3NLjb4TDR4xi7JgYiVQqDwa7yQhUBLcG2GY8GwwRVrQea8KgZpvJ	326	326	451	12463	15897	jxt8rZ5hVPXmvjewPff9YHpqGdwXSDGof1m1zzYdpqMZ3SNdfnf	11918	16777	16777	1618959060000	canonical
23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	23954	3NKfZQ1twHY67G3HL6ReqmeCmSTuXAdV8zg8QF7hLVB3K8d7pRdJ	1559	1353	451	12463	15899	jwkBvsi1rtqctvimj2B3cLiFDxPenZKAygvRnBDTXtTKwSYquKr	11919	16778	16778	1618959240000	canonical
23959	3NKs1pb3JS6ZwuhEkGw2pwLsvroTkFKwFbSRLxrGrVYQLyBZo14y	23956	3NLKubXct4s35wdD4iD4ZQJtSYwt8rTGLv5BCJW82nnsFzm63kAY	1560	925	451	12463	15901	jwvvLqsN9wKVudN4dkp6XmapW1ggKN4C3bGy8UJt3LZbnBv4vjo	11920	16779	16779	1618959420000	orphaned
23961	3NKZqUFhjtfjgDNJcGn5PM4XWdXq5mfu3tudUzSB8EQ4FfsWnr8L	23960	3NKj3Fx67HwPLyUnapCfp7mbo644zMvJdcMK97RNhR2cHPX6Lxjr	1670	1156	451	12463	15903	jxgfELknSiaHvG6gocJ1frBEwQKc3ud49FUpdAWpdavAE5ePQ1e	11922	16782	16782	1618959960000	canonical
23976	3NKpH46X6vWSHdq4zAv4gbapMoM4UxW3NLZb9aGGaEHzxVupjQVs	23974	3NLGEH39BQwcUwypsLoSVy8PVcrAGEWhMqH2Fxk3TV7U8ejhL6Xi	1422	971	452	12463	15916	jwjLmEBCPid83vuRn783pCPxSnkFp8ujeqX2CgmH331McDCHADR	11931	16792	16792	1618961760000	orphaned
23978	3NLcznzQqEgtBycripkWQ3t2FumzPkdGxFavtDLgSUdNgpdqW2VW	23977	3NKzbvdZ8CR8EEBcKggqpb5gyaj3WeuaaZiRwqzdPDHPwvjkrVJz	1467	1130	452	12463	15918	jy2hdpnt975PCaeUuR8VL95kjq8NkDV7jRK45deEC1E5j3R6Y6o	11933	16794	16794	1618962120000	canonical
23983	3NLJsgWvVBc5C4r1ionQDnMuri75tG6BshD1DYY3wp2mGAwdKatF	23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	1422	1211	452	12463	15922	jxJckLLWSDLMDc8xygyxR4JhdYCrEmCKuh9BjZ1RGHwzFrkXdji	11936	16797	16797	1618962660000	orphaned
23985	3NLpYtVmVY8DEWfnKEoGvga5cuvBzDfdGHoVZbwnq9MwULTt57bf	23984	3NKnBfonCjahp666axomHuP3TeviRiGo48umqC4G6SB9PeBE7fh4	1608	1289	452	12463	15924	jwZraBc9KMR1RZqMyZyJEjDnm7Vb18NkdfxqvqmbmgRrPEyL5Cy	11937	16798	16798	1618962840000	canonical
23990	3NLede134BiH6iYocuZ5Fnga74tna78NyMiL4g2mFtPD87ZRi9W3	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1657	978	452	12463	15929	jwtFe5HuPCWb87XXEP4pxdG2qLTyB8xRxv3FyZ7PQgXUHVbvUdd	11940	16801	16801	1618963380000	orphaned
23994	3NKoxNvRLhRzdyK1KrGq5tDqQ4B4745FxaqjBUBAuf9gN517fPuC	23991	3NKZUzA9TsT5UHAbSSZY1DNuK1QopM6YJzLz5iNEbMVKGHmGuMY1	1406	1393	452	12463	15933	jwW6CC91NYTMFr3Cbj3LYy8h1AYXMuMusJPKtxcKqYaQ8oAhVQP	11941	16802	16802	1618963560000	canonical
23997	3NKYmCNtisUvcxgtSfY6hmE9VynqTqtMBtyCMAMhGEKXsygt2zTv	23994	3NKoxNvRLhRzdyK1KrGq5tDqQ4B4745FxaqjBUBAuf9gN517fPuC	1624	968	452	12463	15936	jxvRrPSyEiwioiPHQwPXyUA4gEZUTWj4zwVn5Nic9NeMSazXc3e	11942	16803	16803	1618963740000	orphaned
24006	3NKAKtYHdkmVta6vH8pAQ1B28DGJXRrLBBRn5dVJQCGXUd4mUipF	24005	3NKGWiC4nBxJSyzr8e2y1G4KHsJbQp6ciidZuNp8tNhta7YGZ9BG	1419	814	452	12463	15944	jxfMxaFvCgUaeThjfCwQgQmKLX3UGhfz7BpMVsdFdMg1WfKFEu2	11946	16809	16809	1618964820000	canonical
24011	3NKrVWpR9XM86nrMpNUgMyxqH8L1XksuBADn5FiQ1ntkCdSgsNo4	24008	3NKDc7MZgFHYn2ApaW2tX2vEuEt4cSuLdYCj4hQy8Ki8Z6CeUA1L	1631	794	452	12463	15949	jwEW6eBEDctM7HWKE6qB5dw12NKrPAMHDFpRS5mpUU3pCvU3kz2	11948	16812	16812	1618965360000	orphaned
24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	24017	3NKPmsnEvYEDLoEMTKnKLhZonq28ye1RqZLbab5UsNoULHtakCEG	1671	1119	452	12463	15956	jwnva31rtAHHtXZckLFnqeDVor44RfwZCU2ECpB29kPLvEZvUGi	11952	16816	16816	1618966080000	canonical
24021	3NKWuMXas4gF2Xen8VkgoucPdZes2XtYovKwxZiw1b38Q5kJqRAd	24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	1508	1141	452	12463	15958	jxmJU6r9nak5isbB8a7wR4nyCMtaw4WZxgGNdutfuDYqyDnCyHZ	11953	16817	16817	1618966260000	canonical
24020	3NLxY7LdZceErVFdi9cwJLMaehhwjzJ2yBZppBqK7pJJDSt6Zwhn	24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	1529	1316	452	12463	15957	jxSxxg4gNPYmRa7Wh9LxDxXdhu6yTGZEnVw8eyc2BCZQjYHbv8Z	11953	16817	16817	1618966260000	orphaned
24023	3NLddehUvV1qaNW7cv2ESxFZtR8hK1rh8ZafKUECvASU6hBcAwJm	24022	3NKK8pFfT9wqRfFcdGC6hYUpZNuv14Sfwp2qdFYRhS21BkNkDoei	684	1106	452	12463	15960	jxRKBUL6Kmxyt72YQfNJNQMYm4oZ27Pzbge5wJprw9UwMgmKRnj	11955	16819	16819	1618966620000	canonical
24025	3NLERdybXDg7qsEfoyaTqhuMHbb4F3BwM2urhRKymKCvYJkttLst	24023	3NLddehUvV1qaNW7cv2ESxFZtR8hK1rh8ZafKUECvASU6hBcAwJm	1579	1023	452	12463	15961	jxsXMyUqXVRu1HLN5ugK9viCBQ4ARtekc9BzkNtjn87b94KjHuz	11956	16820	16820	1618966800000	canonical
24028	3NKXw39kLQ9V8jdCX3ZMu8yC2Z28NDiKvn1KrKUYmQFMkFXKfYZW	24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	1587	1231	453	12463	15963	jxBNecmfkwGpNmwMouDtGYKeFBRgWHhw8igB5sqUY8bwQKXUzjk	11958	16823	16823	1618967340000	orphaned
24033	3NLH3opjV6RMgdXxSVND3q8n22zbhKq89i2G3djk4CqRCC8qJoP8	24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	1675	1216	453	12463	15968	jxCqLmEv1BHN1wfAtd8NfctoMedWhMU7mj9tBhdZTgCQyWKw1p2	11959	16824	16824	1618967520000	canonical
24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	24034	3NLMWpJSYtX1r4ufuXzXZR1skPo7b8jhfSMiTdhZfQWaEWs2Qukh	1407	1395	453	12463	15970	jx1H76bPcbNLAFsHqGmAzHg9GuJ9J4kWGB4C5jhRT4gSHbkYjn2	11961	16827	16827	1618968060000	canonical
24037	3NKV7aC2wi8HhELjMGEE3ZdukSkPSw7QGYFNvA7w34XScVgWocKB	24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	1587	1357	453	12463	15972	jwRemuseVcAiyAGUEaZrVmTgwLfv1R6avc4nzhdw3pYf39tn6Mi	11962	16828	16828	1618968240000	orphaned
24042	3NL2ubwWMLMarjQ2RMfdp8xa6rKoC4sGxPwZQAwvJhWeQc1k6yHR	24039	3NLnGbH8yQevz55ZXuNNkUVfp7zmvSVKfYf7nGaNpBuANbrhyoZP	1407	1395	453	12463	15977	jwn448DFs9wakmzmUu5osPnhbocsVuGpfPGXdr4FktgHJ1u9dyx	11963	16829	16829	1618968420000	orphaned
24044	3NKchGciCZBq63qiJ6LxA7WtjMRzrq9B7r1npKUViwkWmRqyneGX	24043	3NK9jvY7Y6SQNdoZNaBNRWq4Hd6SzEUgCqQGYToXsnpTeSJVTtkx	43	1064	453	12463	15979	jwBzXrbCTMxDrgiztd4WSeQdFjyeJgqob8ewiaT1XF9DQq697yA	11965	16831	16831	1618968780000	canonical
24046	3NLpFsBzonUd63LDfcrf1Vu18BqnHY4HbaDLCtzRZrHW4sDfApRt	24044	3NKchGciCZBq63qiJ6LxA7WtjMRzrq9B7r1npKUViwkWmRqyneGX	1588	1392	453	12463	15981	jwfWZoYgc7uUs74Matfu5AS3genYkVeosSjEJE5TPK7HrND4UBV	11966	16832	16832	1618968960000	canonical
28746	3NKHMeEAuwN768tPy52VfP1uouGvYUXCLac8z959XPXmZVkdS2Z4	28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	1553	775	550	12463	18974	jwje1vu9hVA5vCEMUZpPUttWaDDhCV6zkjsvKK7Fp7xpHpGpvPv	13893	19979	19979	1619535468008	orphaned
24019	3NLnKekKxHNRTZPSuf9y5ngKHdwWyWMZRgtUUwyEmJJcaX6xy5h1	24018	3NLnXxpLsMW5VgaYLYqSXp8k8VcFE5PSagmShYhDri5gVvY2DMLB	1529	1316	452	12463	15957	jy1qGU8VJsbxGwKvY1kvsGDxnvtUejG4oYc743T2AEjpmbpT6Ro	11953	16817	16817	1618966260000	orphaned
24022	3NKK8pFfT9wqRfFcdGC6hYUpZNuv14Sfwp2qdFYRhS21BkNkDoei	24021	3NKWuMXas4gF2Xen8VkgoucPdZes2XtYovKwxZiw1b38Q5kJqRAd	1406	1393	452	12463	15959	jww4VmkWasQkAsaoe4LBdqGf6HmvGqJfpwy8XwsvZqqvquVi1eS	11954	16818	16818	1618966440000	canonical
24024	3NKTY3oZ22h2UbhcdeFjxizPT1X7RMBU3AKgXYPK2Z1aVUqqwGny	24022	3NKK8pFfT9wqRfFcdGC6hYUpZNuv14Sfwp2qdFYRhS21BkNkDoei	684	1106	453	12463	15960	jxfEjT9V9sdyErDBprbvv2FXchpHNaULDsJUDhjbyz9CBaQBQJL	11955	16819	16819	1618966620000	orphaned
24026	3NKW32bP8HUNXxxhLhPUXUwYCuSAPHVDBfPYPB3JTCq9BiumConF	24023	3NLddehUvV1qaNW7cv2ESxFZtR8hK1rh8ZafKUECvASU6hBcAwJm	1579	1023	453	12463	15961	jxvmQRXemvc796BpM3vVF13hbJ3vVs85fXRVArtRv6cT8JP2Ubr	11956	16820	16820	1618966800000	orphaned
24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	24025	3NLERdybXDg7qsEfoyaTqhuMHbb4F3BwM2urhRKymKCvYJkttLst	1406	1393	453	12463	15962	jwwkVK7GuYYsra2FooXwJBzDxiccLzxu8UbGpFpLFW7YmdYxLsm	11957	16822	16822	1618967160000	canonical
24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	24027	3NLuheVoTMcuVnDPUSeB8t1iXk8AFfLnkYTcvaz8Zee4yfQdMNob	298	1308	453	12463	15964	jxH1bsuScCisKwjapzH3gKxgcT1fcjii2cZmfdoqPtHWY1qwnke	11958	16823	16823	1618967340000	canonical
24032	3NLJrB9bw8Y5yed2b11BjUgCjCdPZ2gu8EG4PFP6xoLQuRqQg8Lp	24029	3NK36HmhFAvec2kKkPyX8t3Pa3uUoAxayQxd6qmJMr4iHEhXyxxY	1501	1360	453	12463	15967	jwcHvZJmhuNJhVi1yjrExDfdvWAfcGteWMaNvBza7zd536b3i2m	11959	16824	16824	1618967520000	orphaned
24034	3NLMWpJSYtX1r4ufuXzXZR1skPo7b8jhfSMiTdhZfQWaEWs2Qukh	24033	3NLH3opjV6RMgdXxSVND3q8n22zbhKq89i2G3djk4CqRCC8qJoP8	1647	1302	453	12463	15969	jxGD5N6EkB7KtyHuLBZpS6HvcmcqFp9khznAhZCUEbkXucPbpsR	11960	16826	16826	1618967880000	canonical
24039	3NLnGbH8yQevz55ZXuNNkUVfp7zmvSVKfYf7nGaNpBuANbrhyoZP	24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	1522	1076	453	12463	15974	jxSFoyoJT7uQpgVsrtMKoH9XdY1Bs92bx9fK7WLVQAuuXFG9bfd	11962	16828	16828	1618968240000	canonical
24038	3NLXuDFs2tC2FimpzjLcfR2m4p7pMdwhNSNdHedTFoHUfZ3N2MP8	24035	3NLodZ3dpwaJN27pSbvvaNpPRVT2DzMERMiu2ytHRCgHEV3yowbp	1406	1393	453	12463	15973	jxTvAjzkpAJukbFgKsQuUn2LUNSrQyRdah4VXRY7RiwrSbwvoEW	11962	16828	16828	1618968240000	orphaned
24041	3NLU9FUiknF9KWuqxcbxRNSN9Zj88E9myizUiZURz7TxrgHUfbKS	24039	3NLnGbH8yQevz55ZXuNNkUVfp7zmvSVKfYf7nGaNpBuANbrhyoZP	1402	902	453	12463	15976	jxLggCW5CxFxwRRtFm3baaaptWz27qhbsb1bef9rx7y1vPnRRGP	11963	16829	16829	1618968420000	canonical
24043	3NK9jvY7Y6SQNdoZNaBNRWq4Hd6SzEUgCqQGYToXsnpTeSJVTtkx	24041	3NLU9FUiknF9KWuqxcbxRNSN9Zj88E9myizUiZURz7TxrgHUfbKS	1406	1393	453	12463	15978	jwekkZSxRuRbHiMdpp7SuB59VqQaGvBRDj8K36Tk5Vz9sSsDqzE	11964	16830	16830	1618968600000	canonical
24045	3NK8Rh5NDtT2scxC1iKGYnS389sYTNZ3KwJNePQPdt2yQWxzmEgn	24043	3NK9jvY7Y6SQNdoZNaBNRWq4Hd6SzEUgCqQGYToXsnpTeSJVTtkx	1403	824	453	12463	15980	jx7JZ6xGMw9GmMLA7C3eP1n1ajQL7MQdVXhRLR4Jtvwmm9EYNmc	11965	16831	16831	1618968780000	orphaned
24047	3NKdqfBGy9XFUa4tPXt4cp9YUGS68VMB4cNPWj3uhTN4Vo3TJMxc	24046	3NLpFsBzonUd63LDfcrf1Vu18BqnHY4HbaDLCtzRZrHW4sDfApRt	1445	924	453	12463	15982	jwtFVc9zg9jeDcUrSuZZWLtueWqtdo8wpKy2pT2LabGUxu6H7XE	11967	16834	16834	1618969320000	canonical
24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	24047	3NKdqfBGy9XFUa4tPXt4cp9YUGS68VMB4cNPWj3uhTN4Vo3TJMxc	1529	1190	453	12463	15983	jwdeLyDczex2nf5MjudHzwLP3DzpfBCGpsj7gMi3oqvdqKfRz5X	11968	16836	16836	1618969680000	canonical
24052	3NKNRJAhcEr1woRMNyW6kJPpQH7knEnvcfMoJZDFU1Fs231nnJ6r	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1483	1276	453	12463	15986	jy2FoaNTLgy49z7AvPw5dKhKnL2P1JkWUfTZmyKydpXvxNrpmW8	11969	16838	16838	1618970040000	canonical
24050	3NKhkZs8D8aCnXkEyURsPLnWqFFsQura2xiybthLtFAbx8poVzo4	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1406	1393	453	12463	15984	jxmHVk2srXixzsXWYXpyL8WdNA7GkRCkZ9Nib4UJyuqyTMu8pSY	11969	16838	16838	1618970040000	orphaned
24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	24056	3NLmPwfg5wmM51geY5kPTuomPNFdTzbsWkhqXgWbJ3RwM5Uijrxx	1623	830	453	12463	15989	jxhEcgLtCkgmnthdLSsD36fpyDgfjTZrgj7kxpxF87H7xxkFLwX	11972	16841	16841	1618970580000	canonical
24058	3NLMuFDhLyznjWMiLotzt1j18EbCvQ4NyKyfGNX5fgbQUYZ9iADq	24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	1406	1393	453	12463	15990	jw8EmHFJRK9tSPH5pynGnnJrJ43FQkVcdzxk7TBnp6j9neXBPWN	11973	16842	16842	1618970760000	orphaned
24062	3NLM5Ndz5chcjkdk11zKRVDagZpXg79YQSFqiWJcaC1FGxaWbT8U	24060	3NLUEEcWJQuszYyJKDMeZJfkvyiEkkWq1iiopRtof4gatbXgYKXE	1657	1218	453	12463	15994	jwW8FSHaayZNccSBEhDCexUfSHG3rgmidcFopJ7rmHvDzAdAupd	11975	16844	16844	1618971120000	orphaned
24064	3NKyD3kg7ZmcoSFDDDEzEyP3rgEhkvK9QeEFYsd922mBqoZFicen	24061	3NKLz1XPsTMiogD2YXrtKWmmZW16Qy9poVXLKsErxTMdTHUiQ6gp	1516	928	453	12463	15996	jxHp1nTyXsmK3UYkMHePP86ok7o6mRoQi82Rh7GDnbdXJsBovkL	11976	16845	16845	1618971300000	canonical
24067	3NLny7nnZrU86MCFy9e6RmGkBr6btTSu8qVzXvGUdAJpZV7iWG1a	24064	3NKyD3kg7ZmcoSFDDDEzEyP3rgEhkvK9QeEFYsd922mBqoZFicen	1422	1337	454	12463	15998	jxsSBiQUiwPWFebmcGCUrEXyMU7FvGu53iYPwNLkeiMjx6LsUfp	11977	16847	16847	1618971660000	canonical
24069	3NKgt1YuqCvZUszUBVV4hjEyQw399Efvazu8nZa5gEWLiqEcKueZ	24068	3NKsFjBmjVJ6Sc8WN4hu4W7CvFGbHLJC4fZbo2JvKntt9P3UsgaU	1596	1363	454	12463	16000	jxPn5PYXBf8MJdi432AYo7uxd3PLiPiyDFwCX9wBTNDaHAuZmuz	11979	16853	16853	1618972740000	canonical
24072	3NKRYvFx2y1GYvJjfpGsgZgmVZeCeeR5DFW37fENyTtjqe5Agdzq	24070	3NKSQ7xpXrUREwigsZ6TowFeQew7PYZcXRE7eFSk79QZFQq3o83v	1405	867	454	12463	16003	jxLNMotpJ1pnPGFkMtzdMzxzhLieFDEBqAuZmqMW8v2e89yAvhf	11981	16856	16856	1618973280000	canonical
24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	24072	3NKRYvFx2y1GYvJjfpGsgZgmVZeCeeR5DFW37fENyTtjqe5Agdzq	1652	949	454	12463	16004	jww8iTQUNXGBeJbboQJAnsvLPur7pomgXaUFCaZHNWWM82NowEH	11982	16857	16857	1618973460000	canonical
24074	3NLP1xPe6YokwrkieLgo2yuPvFQ4Ae7BVe3tFbNQmzYZrMrBayhJ	24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	1406	1393	454	12463	16005	jxtKyk61Sd34T99F3uAAeUyY6QcDboA8zjRFmCBzPZAf1hTC5vh	11983	16858	16858	1618973640000	orphaned
24079	3NL7vAHkBJc5Q76xb3AcBxdsgubQVt8h6BDSzyXK8GoLnPUFNLeh	24077	3NKXPiyrzvW72bJpjpQEs9SDG54iFD1S2dXZFF3qxSzPLixa4wDm	1483	408	454	12463	16010	jxvd3EsBQLPYKpwrh4m4xbEDGHPBiJCzbunp88pPSGV2nJjLu1W	11986	16863	16863	1618974540000	orphaned
24081	3NK3deUPG26RSvZN6LQWoJ5ar8KF2g9SKSyNz8rwimmvAN9SmqjN	24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	1546	1093	454	12463	16012	jwgSBR1kHYHEp9EC7sMmxfu1YWeSgdX9vhTuZuwgdTHbwMpNtzC	11987	16864	16864	1618974720000	orphaned
24083	3NL2zLrhKdRgzJtSmQB4pEjPZ5VdWeHobm6tXkYDuV8uM6p23Ztf	24080	3NKK9BasjMrUQf2jJHEegBsRGaUcVvLqy9gyokLFYEdXvT3FyW4j	1406	1393	454	12463	16014	jxXVgyuu1xXU7fhArJZTw5KXdBsSu9C8943J2XWbNg1SbLcBrA6	11988	16866	16866	1618975080000	canonical
28122	3NLjLfefDmy9PbFLBaGiEWh7BqHEr8xkHJ8S2j6U5kf1guk6KXod	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1522	1076	551	12463	18974	jwaRxunrSLvwNVdiU2GQNiScZq5tR4dmi2dvBKz915gF5WRqG7s	13903	19604	19604	1619467920000	orphaned
24109	3NLE5p69uJCejD5UJjUN2mGY9sqV6BVpDU374ziJuTmwnPwaAi1R	23893	3NKdJAqydpGkyf2115YGmXHFeAwc8mAtov9cPXh5i5nT9swaQYBD	1647	845	450	12463	16036	jxbnNZMR7jZeYksVvaRRjFdWrmHEQMDDGpDSKTjKk29dQC9EyEp	11894	16884	16884	1618978367193	orphaned
24110	3NKzKkZ5HEYFgFUuUhzdQcNUiJkVc7iq4dFs6rpBp7Pqok5hB7em	23920	3NL95mq3vbpDqqHWt3SVuZHc6KXS53MYovWLHE1SxK3wf1Jdbubz	1647	845	450	12463	16037	jwK9efMzSBmF23q5EyQYuR3GC4QZ1a4YRb9Ldhv9cTpC19joEuV	11905	16884	16884	1618978413727	orphaned
24048	3NLuwtQBM1dPsRsWZgUfjgCxsmmDKiuioaoArjGg8o7Vsc6AuRhE	24047	3NKdqfBGy9XFUa4tPXt4cp9YUGS68VMB4cNPWj3uhTN4Vo3TJMxc	1529	1190	453	12463	15983	jxTbNCnZHHzduibL1jnkx5MMSQBCxBCJefNptkqcmazZmCyzqNf	11968	16836	16836	1618969680000	orphaned
24051	3NK4CHu8xo57PXR3jwHcRYJuEHMpkxa5rrWcSX7QEmXzGkLRDUPX	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1448	1065	453	12463	15985	jwJ31Mc5EPn2ecfE11f2ta7oUW1gMhXxN4RS3EVSQH1yZkViQQW	11969	16838	16838	1618970040000	orphaned
24055	3NK88zXqZHUuL7wyziwChLp5Fin2cqDE38kxCrY7gVuUSyDiZCF6	24052	3NKNRJAhcEr1woRMNyW6kJPpQH7knEnvcfMoJZDFU1Fs231nnJ6r	1407	1395	453	12463	15987	jxAwBBeqGYWAGaiVtJfavTvXugCrygTxSPYXTMcx7S73A5ebKHp	11970	16839	16839	1618970220000	canonical
24060	3NLUEEcWJQuszYyJKDMeZJfkvyiEkkWq1iiopRtof4gatbXgYKXE	24059	3NKGBcV6LhKFQ4H98JbrM8TUGFdMQmfaXyEsxrg6EBWTZLpHuKhS	1426	1118	453	12463	15992	jxNbez3HVcsfwyG8MWNTiD5xBo1Ec4sButjDovfNF4nTUP1dsWX	11974	16843	16843	1618970940000	canonical
24065	3NKL3aqn6PmRtwpSSKnubTGase8f9pVk1DP7dt9wdQpfxQEtLj7B	24061	3NKLz1XPsTMiogD2YXrtKWmmZW16Qy9poVXLKsErxTMdTHUiQ6gp	1637	816	453	12463	15997	jx5fonvuPgZBgLcAPG2TRUA7pzrAduu7j16UkxhTfCnGQL3otmm	11976	16845	16845	1618971300000	orphaned
24068	3NKsFjBmjVJ6Sc8WN4hu4W7CvFGbHLJC4fZbo2JvKntt9P3UsgaU	24067	3NLny7nnZrU86MCFy9e6RmGkBr6btTSu8qVzXvGUdAJpZV7iWG1a	1492	346	454	12463	15999	jwNEA6MehsAkMGv13kqP3iD5A2tJNpNNpf4FuK9o89KDzz1nt7A	11978	16852	16852	1618972560000	canonical
24071	3NKPy8frSidTcFPMSEUy13gAKuseLcvjyKSkaFVj14MUbbfmyXX5	24070	3NKSQ7xpXrUREwigsZ6TowFeQew7PYZcXRE7eFSk79QZFQq3o83v	1501	1360	454	12463	16002	jw9esged54NbRHqfCavvc4ETyRakND9wCrXzzo6DZxeBPaSoc3o	11981	16856	16856	1618973280000	orphaned
24076	3NLrsLmCXr9VmKbLwiVkKMBmZ1pZWP5SuDFN3HdqTQ6UVkqWpq3P	24075	3NKQf8TjH4vgVjVFoWV7m8B2MYZnEjdE66atstxhxLRtAFMNeACA	1671	1365	454	12463	16007	jxDG16VN7v19RSmfHLJ7vcuUPeNQaQZt23aEtDKoA1QxdpdRxZW	11984	16859	16859	1618973820000	canonical
24082	3NKuSm93YPnArwm9FWcQCirkxd7v8TQNiZWfrPxCG5guZmiRKcsd	24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	171	1128	454	12463	16013	jxPJq8ttan8G54kg9Gt3MWfwk3LwhHvCacoffLraki6o3nDa5p5	11987	16864	16864	1618974720000	orphaned
24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	24083	3NL2zLrhKdRgzJtSmQB4pEjPZ5VdWeHobm6tXkYDuV8uM6p23Ztf	1652	1069	454	12463	16015	jxFB3LkdTszYddbNcH22GcUEE4GLiEefWRKSfEZZB81gGcgZgB6	11989	16867	16867	1618975260000	canonical
24088	3NLb1mViXZ1vvk7HyHfMqcUbdseLbnxCwXjNio17PkMVN9ihFeew	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	1523	1321	454	12463	16017	jwFbFoTN2pXdwjZrqUgAmBpnPXsExCdnbYpZLsfkiBPxdXx5a8Q	11990	16871	16871	1618975980000	orphaned
24091	3NKQkYwQhFSvhU8UMr8MWWZ5HDRfqU1PXjQ81y5m4gHmSquXfJnn	24090	3NKtYnoxXrx7iKbadSJVq76sm5v7VYYB9NB3HFRP5wKSAMmREqHf	1637	816	454	12463	16020	jxsvSi7nvn79sFJFJiNxUxF5QLKy69ezphZ3KHosRCSpdSSXxqt	11992	16873	16873	1618976340000	canonical
24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1471	1386	454	12463	16023	jxjLGygJh3aavKPSKJRV9YBnt61MiEVFgWxZFDUxyhuzXczzXao	11995	16877	16877	1618977060000	canonical
24095	3NKDM1XDmESy8B77PSDZrvgWKJVCtkrfAfvfrnLmooYVuZmCtS7y	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1407	1395	454	12463	16024	jxAkdbEiQzsgLdmHgoZC7Yc6KwccBYDhzcxRYJmK79hmDqyFmxw	11995	16877	16877	1618977060000	orphaned
24099	3NLXNZ4pYU53nGffApD9qGsJjjTy44pg3DijzpLT6mCbG4ieGd4s	24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	1560	202	454	12463	16028	jwYUt4Ca9WKsybPe3t9NDgaU88i2JbAAwPQhbya3AndTkonPsHe	11996	16878	16878	1618977240000	orphaned
24103	3NKw1vrWd6XcoZoXBeHSwG51rn5jKR9oXfzayn1itFzLXCQzsFwj	24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	1651	1301	454	12463	16031	jweVdZHoinvGptRGs17ewRiAH1JRJSLJ4SitGjQ7z5iWNLaLgPw	11998	16880	16880	1618977600000	canonical
24101	3NKukqALASwvVPoEXtyU58EFvLY9ar9K2xy6qj6gLCraqU7WovdQ	24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	1546	1213	454	12463	16030	jxhk3MeRchfTwF62sEc29Nba67o2NGnNiZujf554CPaTGEYTGc7	11998	16880	16880	1618977600000	orphaned
24106	3NLiP5QnxmjRpwH3XV158PoJtdUSU7gH8JtY6tWnQif8ErpmPmCz	24104	3NLeeXTM3zoErgLTruuoPtQXbAsKvXpCrnNgGPbSKADuhoKQUapb	1631	794	454	12463	16033	jwYCpCuAK6hHscJgDPk8gf2nZgP9gCEZphJaFgtEa23jxordpuq	12000	16883	16883	1618978140000	canonical
24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	24106	3NLiP5QnxmjRpwH3XV158PoJtdUSU7gH8JtY6tWnQif8ErpmPmCz	1647	845	454	12463	16035	jy28QFTcry3YEZVcvgr9WYNKaqQ4wCvszqAvtqRg5DGwjzp5MwM	12001	16884	16884	1618978320000	canonical
24111	3NKmsHcYcsaH7NRpzGX1YqvmsHJnT9i7BzavAzxzMihDPwbYUPEU	24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	1649	1383	454	12463	16038	jxwxC6TVhtp3hSa6r8dZkYdyVKFoWwqad9D2mftFf1TNkqbazBb	12002	16885	16885	1618978500000	canonical
24115	3NLFyhRznPiowQ9W6yoAkHznh2V84ukRauSmgdxyByyzecR1rS1K	24114	3NLMxorT89txhNeKWi8eNYZNjQtf2CP6zQMhYfn2JMvQy8BmeeZv	1589	1286	455	12463	16040	jxWYt38BGMjYbxff8sVQwdSRkFu6dFpAdv4NyzYYo7SMdHMCkv2	12004	16887	16887	1618978860000	orphaned
24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	24117	3NKGhCYDcpJSTDdfLTnLkNNL1yHiXzSx67KTgdpb44PEJDwQG244	1607	1102	455	12463	16043	jxVbBAQnDAV1VrgfY48pFBUxqr3A6eSVG6Mh9vTTo7Uswq6LqPj	12005	16891	16891	1618979580000	canonical
24119	3NKNHoQvKnv3wm64yjXg8DHcz8eAjH8JWVLk9VfynvSguXURg5te	24117	3NKGhCYDcpJSTDdfLTnLkNNL1yHiXzSx67KTgdpb44PEJDwQG244	1403	824	455	12463	16044	jx945kgmm9a82destrVpS1qobSQdTr5tyAfbxAQcU33Fhkf42zd	12005	16891	16891	1618979580000	orphaned
24121	3NLEFLSMLdjKgr5uCQEmECYwUJDXEcm2HWgTmbo3HbJPLaXpPw2b	24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	1527	1293	455	12463	16045	jxA834dP47UJrUNhnoiGgFZF5XtcHuw7WWwjDTCcLVLzDZTRFAm	12006	16892	16892	1618979760000	canonical
24120	3NLemyNXBgGc4UpskM4hwzxsrUNJBx3KELSPCqEk6VURJSafxesG	24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	1527	1293	455	12463	16045	jwzKUyVKzzWo7kXTuPhkFzTLk24yVH38gdNw3oLHUxSoriVVpPD	12006	16892	16892	1618979760000	orphaned
24125	3NKLwmq883bsp9EvyxP2FcyY5Gb892o1kfTVieEYyfChakkh5ELc	24123	3NLFhyvND753XruxuhodiuzmzJosnQyNC1NWSJggXCxHQ7JVYgRK	633	1138	455	12463	16048	jxNyq8P52AypwrC54X8FP9DD7vxnpngFhgcRwgpCvcVY2xs2sN5	12008	16895	16895	1618980300000	canonical
24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	24131	3NL3pbePUkPutxbZtVdnb4Xwn7hWmF6CeYjzptDGwYgC5qYQhwN9	1546	1093	455	12463	16055	jw9XyT4hyVdTBNRk6V3RaUS5gEKfJTL41ZWFZgXSga23PQw4xGX	12013	16904	16904	1618981920000	canonical
28124	3NKPpX2fdES3F6vLFsnpqTkgW334ZvECU1EmB9Uv5VZiXjjnLZtp	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1675	1342	551	12463	18974	jxetCHSCytNvn7vZZV4E59dEquqFjR39syi6b1UfdCZmvW1mdtV	13903	19604	19604	1619467920000	orphaned
24056	3NLmPwfg5wmM51geY5kPTuomPNFdTzbsWkhqXgWbJ3RwM5Uijrxx	24055	3NK88zXqZHUuL7wyziwChLp5Fin2cqDE38kxCrY7gVuUSyDiZCF6	1434	642	453	12463	15988	jwfZ8Ab8QR2jYs1p2QApoVzNFjm5wdbiPksDauJDTEE2xFhLB61	11971	16840	16840	1618970400000	canonical
24059	3NKGBcV6LhKFQ4H98JbrM8TUGFdMQmfaXyEsxrg6EBWTZLpHuKhS	24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	684	1352	453	12463	15991	jwYdddSbxeKMyxLpPRiqhSaAUGuvLsPC65n4ejbdmK2yuvKSpEN	11973	16842	16842	1618970760000	canonical
24061	3NKLz1XPsTMiogD2YXrtKWmmZW16Qy9poVXLKsErxTMdTHUiQ6gp	24060	3NLUEEcWJQuszYyJKDMeZJfkvyiEkkWq1iiopRtof4gatbXgYKXE	1406	1393	453	12463	15993	jwtkt82LexA6yfrcwgFt1QKGehzFhycp4KtpdNWRVjQXuy2RW4K	11975	16844	16844	1618971120000	canonical
24066	3NL533zpYGwisLSMazSSAJUnsz6hqNpztRoGUaEpWroSUEQMzcoQ	24064	3NKyD3kg7ZmcoSFDDDEzEyP3rgEhkvK9QeEFYsd922mBqoZFicen	1422	1337	454	12463	15998	jxsSBiQUiwPWFebmcGCUrEXyMU7FvGu53iYPwNLkeiMjx6LsUfp	11977	16847	16847	1618971660000	orphaned
24149	3NKSuimUqfErpAKt3TuaC55cn3M63pNGFQLKPvFjgDmPhFXVULEB	24067	3NLny7nnZrU86MCFy9e6RmGkBr6btTSu8qVzXvGUdAJpZV7iWG1a	1657	1344	454	12463	16069	jx9DfTSDUTSbydECjZFz4sS4PhKgxxi9CpLfXjBr4pUe9A2LFjJ	11978	16914	16914	1618983767389	orphaned
24070	3NKSQ7xpXrUREwigsZ6TowFeQew7PYZcXRE7eFSk79QZFQq3o83v	24069	3NKgt1YuqCvZUszUBVV4hjEyQw399Efvazu8nZa5gEWLiqEcKueZ	1652	1315	454	12463	16001	jxijEiYoqNRKCDE5WDDyBbNPHvE1uytZEzXJb8fAj3UtBMeXm6j	11980	16855	16855	1618973100000	canonical
24075	3NKQf8TjH4vgVjVFoWV7m8B2MYZnEjdE66atstxhxLRtAFMNeACA	24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	1460	426	454	12463	16006	jxoNKb3CJt4LxmgcA932ggC8Jx2Z9tbvCd5YogtA3yghfST38Ak	11983	16858	16858	1618973640000	canonical
24077	3NKXPiyrzvW72bJpjpQEs9SDG54iFD1S2dXZFF3qxSzPLixa4wDm	24076	3NLrsLmCXr9VmKbLwiVkKMBmZ1pZWP5SuDFN3HdqTQ6UVkqWpq3P	1648	1038	454	12463	16008	jwKhfsu6Fwi4fZRtoAmty88XBo5c3hbvSajjwmJoE77aRWYZWMB	11985	16860	16860	1618974000000	canonical
24080	3NKK9BasjMrUQf2jJHEegBsRGaUcVvLqy9gyokLFYEdXvT3FyW4j	24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	311	1307	454	12463	16011	jwWASbYM9ofJqCFrKH7gv6BDeBK1jLRnPGW4gFXQ7FKqTzvqPWq	11987	16864	16864	1618974720000	canonical
24086	3NLwsJsLF5L8AsL7xfRgcEA3dnAXdGPW3f2q8scJwEA7hAjNzPPR	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	1523	1321	454	12463	16017	jwZDk6AyzyMbq9ggKrpbWncEDD6UyCM7H1mwqSBReeUPgoyCvei	11990	16871	16871	1618975980000	canonical
24090	3NKtYnoxXrx7iKbadSJVq76sm5v7VYYB9NB3HFRP5wKSAMmREqHf	24086	3NLwsJsLF5L8AsL7xfRgcEA3dnAXdGPW3f2q8scJwEA7hAjNzPPR	1564	1338	454	12463	16019	jwm5BTqVgSYASqrdTT4DuxyKxC4vNpT66bJuoKdc3jpC5NrZ4LQ	11991	16872	16872	1618976160000	canonical
24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	24092	3NLkBDv8EuDxRdhnaHTGKENj79ZR4rh27vJSgrqUeH8UNEA67qxc	1654	1340	454	12463	16022	jw9iqzrczmyHwz2VpxqyeAWQzPzgmYP9a61dsDFSNGtEYb91hUM	11994	16876	16876	1618976880000	canonical
24098	3NLXySyFVtsALm9S5uRyMTVMMsVoPTCioRpRYEQMBFjpuMwb1yEn	24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	576	1229	454	12463	16027	jwHX2jc6XETFmM2HenW14XcgbPJfLNMTb6RJL4iWSprP8vdKpsz	11996	16878	16878	1618977240000	canonical
24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	24098	3NLXySyFVtsALm9S5uRyMTVMMsVoPTCioRpRYEQMBFjpuMwb1yEn	1533	455	454	12463	16029	jxVRTiPEQXp8QemwfTKaofD339MmU6GhiQjxqK1UX4L2R7sLtZj	11997	16879	16879	1618977420000	canonical
24105	3NLsDjPHkwFuYY3wY6BymrrxCQp9RH2pWqsw4wBMLNZEzA2u7isb	24102	3NK3MPx6D4L47MYDb3qpcpQ6Mr9pzm9o5RFbJad2AvHSsWkAkHeZ	1578	1296	454	12463	16032	jxK4y4vtg8WQbvkXnGJWMMGY1EsG3VJTLdVR5fkZyzGy3F8cqoE	11999	16881	16881	1618977780000	orphaned
24113	3NLjiE5pUyqrJe4XigmuCv4T8dH15JQQAePu7JX2SXbxbBqy6mdo	24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	1649	1383	454	12463	16038	jxwxC6TVhtp3hSa6r8dZkYdyVKFoWwqad9D2mftFf1TNkqbazBb	12002	16885	16885	1618978500000	orphaned
24114	3NLMxorT89txhNeKWi8eNYZNjQtf2CP6zQMhYfn2JMvQy8BmeeZv	24111	3NKmsHcYcsaH7NRpzGX1YqvmsHJnT9i7BzavAzxzMihDPwbYUPEU	1489	1380	455	12463	16039	jxeDnt5D7jWEN1jHDPzhekkkGDsKPBjaRjpUN4QbkE9JKdzdHBd	12003	16886	16886	1618978680000	canonical
24123	3NLFhyvND753XruxuhodiuzmzJosnQyNC1NWSJggXCxHQ7JVYgRK	24121	3NLEFLSMLdjKgr5uCQEmECYwUJDXEcm2HWgTmbo3HbJPLaXpPw2b	1675	1096	455	12463	16046	jxEWepYmRQdUcY16EYi65yqJ1KqhFBioNpvva3eTkxBKWzgbvpJ	12007	16894	16894	1618980120000	canonical
24126	3NL9djuqdx1i2h1e8HySuJHU8hpdrgC61STcDVtJDtzisZwjkctw	24125	3NKLwmq883bsp9EvyxP2FcyY5Gb892o1kfTVieEYyfChakkh5ELc	1403	786	455	12463	16049	jwCMQuw65GnHU3yCh7mWvbrirXno8UoyzRVtHvvce4mKuKCpS6x	12009	16897	16897	1618980660000	canonical
24127	3NKverMy3x4r1roCbW9LXonWpMrSp3khWoawaBVpDF8VRGj1m6wA	24126	3NL9djuqdx1i2h1e8HySuJHU8hpdrgC61STcDVtJDtzisZwjkctw	1422	1337	455	12463	16050	jxqRQU7GDQGWENzskPhe25jncYuSM5DnhnEoKbTB1yLY9a9MvHt	12010	16898	16898	1618980840000	canonical
24128	3NLTjBo8kisqbVoNj8XvcbcJRBxAG2B4JMLQoASRwvw6BoafpTef	24126	3NL9djuqdx1i2h1e8HySuJHU8hpdrgC61STcDVtJDtzisZwjkctw	1585	1366	455	12463	16051	jxLn152WsLMFeqP35jnWw6nVucTzpkcfbqui7mviZBAbKTQx1s3	12010	16898	16898	1618980840000	orphaned
24131	3NL3pbePUkPutxbZtVdnb4Xwn7hWmF6CeYjzptDGwYgC5qYQhwN9	24129	3NK3yVPgRdDqaZRa2dbsNDc1N3oRPdCU6PSbLTMMD3Rt2xLuYrG4	1506	1127	455	12463	16054	jwXUdWisUwJHGfmpeKjZMvmQYSvXDwzETsDC7kXWaz28xvjR68Y	12012	16902	16902	1618981560000	canonical
24134	3NKfpCnMyyKAhuduS5h86WawobgRUky2JscsdtvfbE7jD6WwD3gQ	24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	1406	1393	455	12463	16056	jwNsSpHWYNKaC8PPRGGyPV2HoKsBxZHFszqnRWTcBRE39GDDWDf	12014	16905	16905	1618982100000	canonical
24143	3NLEucEQhYBM2jrafirfGnKNj1kxT5ZwuPnSw6bBds8wktPYeRHv	24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	1458	1197	455	12463	16062	jwEVdeTphdEMwT6dQMvRkdk4tFBmcFQiAzUfZnriUCZFMcT3DEp	12018	16913	16913	1618983540000	orphaned
24157	3NK3SFU9JvTXw6xJudFeQAb2wmJorksdHGgRRs4JrMUbcHSQiMbv	24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	1402	890	455	12463	16077	jwETUUoHGgVmQbTfcUsffrHunnwkQc8pEvKurCDmdeVvkjaGkBw	12024	16921	16921	1618984980000	orphaned
24161	3NKip7N8Zp5Du48FXSMoQefFLJVG5aBG3cMG5xtZj9sC1HuCRvww	24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	1611	1341	455	12463	16081	jwiKv6hUDUcBa7zcXKDCvTHMiTBLcJ6yM4KToJeJ1BsL5uJu1g9	12025	16922	16922	1618985160000	canonical
24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	24162	3NLtqBDC456Pe3iVbfphPy3ejnWKrEn76EFZmoYnbqXaYwakyo5q	1613	1613	456	12463	16083	jwMRP71mMG7dDKFz7kcuo5RmgXTaMb8XZPDApHuE2PQEDR34c4W	12027	16925	16925	1618985700000	canonical
24166	3NKt77wKrs7D6Lh9jnoPUhf6Fbxo6vVua5rrd1ZKCjRrCRCXrLbX	24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	1403	824	456	12463	16085	jwFPzys9ppn8vtFjVdxq4nayuSct15oCHP9LVLgjyDLys4NK5Mk	12028	16926	16926	1618985880000	orphaned
24171	3NL7rKXeAjkfEADJLUvb1rhd39MfMjHoTFGdnBirvS6quEgvZrRV	24170	3NK9qr7Kz6Zw6VjVqeWLARFvR3qorMg6JNUW6JnYNMKLaYYZK91K	1647	1056	456	12463	16090	jwDDuq7CmFog6HHiZL1oxDNDcaWsQCYTKQhnMGUkreJ9jCksGh8	12031	16931	16931	1618986780000	orphaned
28126	3NL6168pwEZnU896AXqjuhwhKqAVeWVNP71w9uJquFnQ3Kiwicff	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1522	1076	551	12463	18974	jwaRxunrSLvwNVdiU2GQNiScZq5tR4dmi2dvBKz915gF5WRqG7s	13903	19604	19604	1619467920000	orphaned
24107	3NLQE463wBG3jCX4a3inVvWjqjbrkQmNFC3fCsQWoJ4BrMv8DKQz	23872	3NLMTerzi9zPh4qLq7uyEq9jDxxZZXJCbtrbZe7KxPdA6dpsfHVg	1647	845	449	12463	16034	jwdatvRfoqZdBnA1GENweWUpFXQ7s8mXJ4gmipdVhJkfvS5xcyF	11883	16884	16884	1618978320000	orphaned
24085	3NLuDHEtBjhBMd8SxV2V23L5D4xozLiANBMc7KrVBgagotfoegGS	24083	3NL2zLrhKdRgzJtSmQB4pEjPZ5VdWeHobm6tXkYDuV8uM6p23Ztf	1573	1318	454	12463	16016	jxAFPU7HQvev7EV9ZAGEmwkhs86eZYB5fEXSEc5K1yTDGx3xbrU	11989	16867	16867	1618975260000	orphaned
24089	3NLCD53xWwEoTjnZLQ5X4qJSomSqyzuq1ZuAKHWF4EDwwrueTy8b	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	596	1306	454	12463	16018	jwPAByi13n7YhMXVsxnNUkkMhSPt5v5rt4ohSgdfsxXSuHGQtgx	11990	16871	16871	1618975980000	orphaned
24092	3NLkBDv8EuDxRdhnaHTGKENj79ZR4rh27vJSgrqUeH8UNEA67qxc	24091	3NKQkYwQhFSvhU8UMr8MWWZ5HDRfqU1PXjQ81y5m4gHmSquXfJnn	1406	1393	454	12463	16021	jxtdB7ZLFee5BWLMLD76rYZMRTYSG6XVqFSrkzadmsrDcaQSD9T	11993	16874	16874	1618976520000	canonical
24096	3NKN9gDXC6FHK6VEhhfGQvpTMdXMk74iHN1Po2RkvftiENBUDH4F	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1581	778	454	12463	16025	jwA1nd6d1sTj5n3DFPKrGxrWKGGHWz585fP5B58DHsrfD9NLSny	11995	16877	16877	1618977060000	orphaned
24097	3NLiHw9yV7a5KFLNj7HhSQXsguidKiJc6gMA2Ma484kxW5edzZs3	24094	3NL3vgCqr2nFpUpHNjsfv1pmH5Sc4JtoBqW8dB84ZVsiZX7zvLGo	1613	1349	454	12463	16026	jxzTfPL3hGkkaEymQUndMKAfFhN4Tzi6afkJWA6iGnhcjDbWXWy	11996	16878	16878	1618977240000	orphaned
24102	3NK3MPx6D4L47MYDb3qpcpQ6Mr9pzm9o5RFbJad2AvHSsWkAkHeZ	24100	3NL816Z2LZnQGdRuDjWnkaeTUMD7yZghkv3XmMiSmtMDwDDsKZMx	1651	1301	454	12463	16031	jxSiFXjn81Sq39n3sbQSJiQq4NmG8emTiUppg8WYUoBSs3msWq3	11998	16880	16880	1618977600000	orphaned
24104	3NLeeXTM3zoErgLTruuoPtQXbAsKvXpCrnNgGPbSKADuhoKQUapb	24103	3NKw1vrWd6XcoZoXBeHSwG51rn5jKR9oXfzayn1itFzLXCQzsFwj	1578	1296	454	12463	16032	jx9xrVTUDDXZM36RnyvZqGyb3zPxvNqwSdWSjZJbPXJQLHhw65u	11999	16881	16881	1618977780000	canonical
24117	3NKGhCYDcpJSTDdfLTnLkNNL1yHiXzSx67KTgdpb44PEJDwQG244	24114	3NLMxorT89txhNeKWi8eNYZNjQtf2CP6zQMhYfn2JMvQy8BmeeZv	1403	824	455	12463	16042	jxTeN4Th794nDnqhBHk66bpTMdRrTAVEiUQoMjSdWh1X8eMy8Pd	12004	16887	16887	1618978860000	canonical
24122	3NLEFNMvoVpqTWBKNxVw22cWD9NzNKNtY3XPCGFNbXgqLZqRxUza	24118	3NKi3N3bGEyRKVRRsuCrGnmf9Cy9NehswbLxjeLVXdwmPviC2XHQ	1527	1293	455	12463	16045	jxqgS3YVDRbMuzLvaER7rTUmsYe98Ct6wgV6xc713iT4P7d5998	12006	16892	16892	1618979760000	orphaned
24124	3NLUipsMTYVno1LLk5vDjz5sJqQj3RGy54nvhB4MrXrT14F6tqK3	24121	3NLEFLSMLdjKgr5uCQEmECYwUJDXEcm2HWgTmbo3HbJPLaXpPw2b	1460	523	455	12463	16047	jxTFV4jhiKpET1NKu2Zrsp5tdcT2efxMavnfRvKtWsmFfbXqK8h	12007	16894	16894	1618980120000	orphaned
24129	3NK3yVPgRdDqaZRa2dbsNDc1N3oRPdCU6PSbLTMMD3Rt2xLuYrG4	24127	3NKverMy3x4r1roCbW9LXonWpMrSp3khWoawaBVpDF8VRGj1m6wA	1656	1097	455	12463	16052	jwas8xmya5awLFjGsNggSC6vgVqeyxDQhe1vqZ7EqAnAn2BuxVd	12011	16899	16899	1618981020000	canonical
24130	3NKgovKZqN1fGjRdXJNxpVas54SQEAc3Q5jyFeWSAmdEDPAvJhsy	24127	3NKverMy3x4r1roCbW9LXonWpMrSp3khWoawaBVpDF8VRGj1m6wA	1403	824	455	12463	16053	jwchKMV2S7p7scP3XMEFRJqdvAdoeEGU9djRE5QX6MaiCEsWsCF	12011	16899	16899	1618981020000	orphaned
24132	3NL1x2QyccbcH8hEvL5rPjxpqiyC6a973E88GJx8gxq5GyyMM421	24129	3NK3yVPgRdDqaZRa2dbsNDc1N3oRPdCU6PSbLTMMD3Rt2xLuYrG4	1506	1127	455	12463	16054	jxgz71Ft8oAxS9D9ScAKuuUWCer7ZD9VNqF27hpym8CTi6Y3ryR	12012	16902	16902	1618981560000	orphaned
24136	3NKxkTwyou9Xmt9TCXb4FhZZhtWeW8CbGPPdHqcC58pqJqnt9TKM	24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	298	1308	455	12463	16058	jy1XmnatcvnxKC6Ri4fJWKE2SSrQ9VXvSnmvwmtui7LxLEaUD3M	12014	16905	16905	1618982100000	orphaned
24138	3NKNBwd3GP8Ntf8y9UYDrjVrDYpRvdhJ6JvtLzDmns9DfoKz3324	24134	3NKfpCnMyyKAhuduS5h86WawobgRUky2JscsdtvfbE7jD6WwD3gQ	1483	1150	455	12463	16059	jwqdC5Ewd4YyPtCsHWkqc5gcym7ZqXXJLTcUNUZnz2AYCHibjbM	12015	16907	16907	1618982460000	canonical
24137	3NKkWwnt64q89JTayfefE9UQCGyhbmBPFESCZsFms8UraaDZWuuQ	24134	3NKfpCnMyyKAhuduS5h86WawobgRUky2JscsdtvfbE7jD6WwD3gQ	1483	1150	455	12463	16059	jw79pRowYJoLaGbKqxzTjpVP7GNsAVQT9urbcjhTbQCsnWpjCEY	12015	16907	16907	1618982460000	orphaned
24139	3NKrkKSnMtE4ZRi9hZzJ51oEpE6Ag3bJK8fmrSXHMaeepouGjH3F	24138	3NKNBwd3GP8Ntf8y9UYDrjVrDYpRvdhJ6JvtLzDmns9DfoKz3324	1405	851	455	12463	16060	jxuNb6hB7jNpXk2QVFap9ic3xPfjVSnVVdbzyxRo7v5PkgLXaBf	12016	16908	16908	1618982640000	canonical
24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	24139	3NKrkKSnMtE4ZRi9hZzJ51oEpE6Ag3bJK8fmrSXHMaeepouGjH3F	1602	1369	455	12463	16061	jwTcuCrDcWCcZo4L2ufttMaBhvpUTQi7wpMenVdiow6GrfjK8Dd	12017	16911	16911	1618983180000	canonical
24141	3NLM53q6Di2TP3u9GAnJknXyovNJZ2ArSS3UxwZtnEXikawbZUX5	24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	1458	1197	455	12463	16062	jw9LeL4PLVHF9vzmoB7mE6ijft2Ng8fCDTyB1sdf6RJpGPxRf6x	12018	16913	16913	1618983540000	orphaned
24147	3NKcMVHgSAnoXpTTFyFpPHKHpBKdUcKhDSonkDegtS9fKvMWUw8b	24142	3NK3xKJFGxqQTzLMoqGcJF6H2j3hM9WVSHTJMgGsKYWZNDK29jaW	1553	776	455	12463	16067	jwmzMDeyYykPyizfYXaqoLfVC8gpL18Ucyp1z1QMGjGQd5tHgpC	12019	16914	16914	1618983720000	canonical
24145	3NKFEUQdePki6hywBp1vUX6BSP9dTHcPXBoZc2eBSYjR5qXGbrb3	24142	3NK3xKJFGxqQTzLMoqGcJF6H2j3hM9WVSHTJMgGsKYWZNDK29jaW	1405	881	455	12463	16065	jxSp6XNH7EfSgCRN3FkqE7YBfq9yQgF2ZF3z7DNQ12igBherKX6	12019	16914	16914	1618983720000	orphaned
24150	3NLYqh3ioipDgpeh5J9WyjgbZyT444YDbjgLNpkUX7XuSJVTPoGk	24147	3NKcMVHgSAnoXpTTFyFpPHKHpBKdUcKhDSonkDegtS9fKvMWUw8b	1490	1274	455	12463	16070	jwdUzNfWbJV7HariCqYr5AUSPoVX8XuFjcPTp2zPAT6TwYNEBkC	12020	16915	16915	1618983900000	orphaned
24153	3NKKGzjZBptwpWPDTWYN8MraAE5Ypo8FfJhG3e867cqckqiDXgwm	24151	3NLwzFRcmXu5yaJuwnVwvRmW2wwnazWRsZpWZk26tiDpSk14GLER	1623	830	455	12463	16073	jxaMMQhRyvU9k4N9Cs37QfSR88g1zWLzuBzLB4KLtyqPTrVTBdG	12021	16917	16917	1618984260000	orphaned
24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	24154	3NKqUW1uaQAEbVaJZ7UqXvYaFLsM4gBC3q5okMWJDik4ucRyoKZr	1581	778	455	12463	16075	jxzfxbUmLBVa8ZqQJeF6SNyaPp9gZifpJBHHSSzNHbjTmBnFK9Y	12023	16920	16920	1618984800000	canonical
24162	3NLtqBDC456Pe3iVbfphPy3ejnWKrEn76EFZmoYnbqXaYwakyo5q	24161	3NKip7N8Zp5Du48FXSMoQefFLJVG5aBG3cMG5xtZj9sC1HuCRvww	1402	882	455	12463	16082	jwhYys1jQSC6Rt8QAMDXYzZiG6jY18VNa9ms3GkTN6qc7jsghML	12026	16924	16924	1618985520000	canonical
24167	3NLhvND2RtBnQMGgUg4SsB6zgi8nwHZBRhcTwkrjMYXTDMNsPKQ4	24165	3NLvmt3wwFumY6heZxyXySiobyjK1c1DwjA3PxDUDJMTYRHQGYfp	1483	1276	456	12463	16086	jxycpaRp5ndNrjucKZC6URUPPMzRpAzo3hJYuEnz7afmfnfTGaX	12029	16928	16928	1618986240000	canonical
24170	3NK9qr7Kz6Zw6VjVqeWLARFvR3qorMg6JNUW6JnYNMKLaYYZK91K	24167	3NLhvND2RtBnQMGgUg4SsB6zgi8nwHZBRhcTwkrjMYXTDMNsPKQ4	298	1062	456	12463	16089	jxThKv88rrqeEjTRHaPGNNtU91upHVZwD8n5kpdY4Y6W56YvHhQ	12030	16929	16929	1618986420000	canonical
24177	3NLVcxx4khpK5qF16E9D7XVSdCucND3ZfvsGkWzFmJSSNYHTkxXd	24176	3NKFcE3CThHQgM5rpY8ryNcfd8Xssj8VAf2krimN7U5uXrpzsJ52	171	1128	456	12463	16096	jxK7Ym97EW9AvuovXoe9tws5bVYk3gV3bCzkpn5jDvxUG3KhsSu	12034	16936	16936	1618987680000	canonical
28160	3NKpHwyL9fb2E2r38KuchY4L9payHUYRz5D67VbsvEsnuimwWVit	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1594	1080	551	12463	18974	jxdNFy2QUPiMQzJmuSan1dXb32iz5mvP4NcG8CLbVHAfn8vGfTX	13925	19635	19635	1619473500000	orphaned
24187	3NKZN3bR3REsBjtroYsyo7LNcKd3ZrcbwqKwfiXUkjryS321u95P	23981	3NKCwg8aRNCp1BcVxtyjaewrrmku2CQgb3ETMy3u4Ta9GDa1Fc81	80	1273	452	12463	16105	jxMpyyGg7bPnnuoShmq7BUXGw3J2csfQpJsLv12jabzBodvZZ5E	11936	16945	16945	1618989300000	orphaned
24146	3NLC1tjCkBu3mJ7zvx4kyMbbkEurDHEMSj5hBAHoNbAuUp5jj3Eh	24044	3NKchGciCZBq63qiJ6LxA7WtjMRzrq9B7r1npKUViwkWmRqyneGX	1657	1344	453	12463	16066	jxZoZQ4yTCr5RsbxcpErs8Nti4boXS3vJP9DuHdtXd15TugoER7	11966	16914	16914	1618983720000	orphaned
24151	3NLwzFRcmXu5yaJuwnVwvRmW2wwnazWRsZpWZk26tiDpSk14GLER	24147	3NKcMVHgSAnoXpTTFyFpPHKHpBKdUcKhDSonkDegtS9fKvMWUw8b	1402	852	455	12463	16071	jwxYtKo4cpR3thZqcwJTzBrZcTqrTx4a4J8tu1TesZVcLHuDNss	12020	16915	16915	1618983900000	canonical
24152	3NK9nrc15jXMJG61Zf1xXSnNkPWq9euhY3bwoCPn5D5No5EDPR8E	24151	3NLwzFRcmXu5yaJuwnVwvRmW2wwnazWRsZpWZk26tiDpSk14GLER	1619	1149	455	12463	16072	jwJyLU5MnKS1cKH7Rg1hKhF2FD4SAUrVNVpSeJHpGFP814c5a4s	12021	16917	16917	1618984260000	canonical
24154	3NKqUW1uaQAEbVaJZ7UqXvYaFLsM4gBC3q5okMWJDik4ucRyoKZr	24152	3NK9nrc15jXMJG61Zf1xXSnNkPWq9euhY3bwoCPn5D5No5EDPR8E	632	1256	455	12463	16074	jwZnhmhcgxnWNNo35Vva6taQ5gBP7txRKSCQdiRm9ksKnLhZU7L	12022	16918	16918	1618984440000	canonical
24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	1672	1159	455	12463	16076	jwH2vxcnMvdC19aboVjk2SoxY1YRRs876k4RnizSXuQzjGpLjYU	12024	16921	16921	1618984980000	canonical
24158	3NKaqtxrgkjTobw7spLVvhM5jrDzV7J27LDea46y5aNWoC5uuyHp	24155	3NKJJv4Snk5eR6KsjEfvp5Y5hJVwLHXqksFp6H1xw4vgY6zjVAa1	1581	778	455	12463	16078	jwhXr1RvVgQjZ1zw1zTLx6m3uwdfKt9AiyQZ6GpmzVr2SfMCvsp	12024	16921	16921	1618984980000	orphaned
24159	3NKxhrytV6vfGexdfeaWyZVCLgVgaPTLv2AT1qTmg92joEis8Nhj	24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	1406	1393	455	12463	16079	jwTUGUDAnKnBUxnTvqzcCkziY3RtYGzoNT27MHs3U4DnE5VZjKb	12025	16922	16922	1618985160000	orphaned
24163	3NLiS6WSpV61Hko4fdd5yVGofmNyonqBZtUNDkAkLgPNhHn4rKJg	24162	3NLtqBDC456Pe3iVbfphPy3ejnWKrEn76EFZmoYnbqXaYwakyo5q	1613	1613	456	12463	16083	jwMRP71mMG7dDKFz7kcuo5RmgXTaMb8XZPDApHuE2PQEDR34c4W	12027	16925	16925	1618985700000	orphaned
24165	3NLvmt3wwFumY6heZxyXySiobyjK1c1DwjA3PxDUDJMTYRHQGYfp	24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	1458	957	456	12463	16084	jxNT5BAjGFLh7jXxCKBdmBcWmZx2W3tU9NASHEE7M29hoNbRfdg	12028	16926	16926	1618985880000	canonical
24168	3NLfSoqNAEyWZhGqfCQwrAjNMpUAJn7jaRvXLx2oDmiye8cyENh7	24165	3NLvmt3wwFumY6heZxyXySiobyjK1c1DwjA3PxDUDJMTYRHQGYfp	1407	1395	456	12463	16087	jx4NUvUyEuJfrqA3NZLxSw4WogoZNpjgMoVcV8mHC5DqBSdPXxr	12029	16928	16928	1618986240000	orphaned
24169	3NL4A7vfHS8Nz6MUDA2WfEt8LyGtoK1GqnvxxanGuhUAuHMSUVRR	24167	3NLhvND2RtBnQMGgUg4SsB6zgi8nwHZBRhcTwkrjMYXTDMNsPKQ4	1547	1378	456	12463	16088	jwJXBTdfZ98FY8hfJA5mZDCrwmnSFejToBjSTX66Arm7p8fYnXo	12030	16929	16929	1618986420000	orphaned
24172	3NLT6PANSrVwwg3qPDrozEnRZtUppaFSxEGhqE3CAAP4ANoqHQ7v	24170	3NK9qr7Kz6Zw6VjVqeWLARFvR3qorMg6JNUW6JnYNMKLaYYZK91K	1594	960	456	12463	16091	jwQxQUNoodTxRpqwaggb9tRDWoZE7c9oW1ZHBCWaCDtoLQ1rQA4	12031	16931	16931	1618986780000	canonical
24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	24172	3NLT6PANSrVwwg3qPDrozEnRZtUppaFSxEGhqE3CAAP4ANoqHQ7v	646	646	456	12463	16092	jxaodssJRyWR987T1XLoo79qfUD8VrsQArC4L4a1PKYJGk9jmEm	12032	16934	16934	1618987320000	canonical
24175	3NLJ43NHuHSgA9bPnxtZUCJBJ8G8UWV3GY1onosmZvgrk82YqZ27	24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	1601	1142	456	12463	16094	jwe4gBa6BEh7PsnhMRJ5gaxU9kJBT1jVzYJp8xf6EMdx252Lw4L	12033	16935	16935	1618987500000	orphaned
24180	3NLGaRWZSJSf73oTJ3xpTh8PMN2qDmUUHWZsdwdagLQoA1d6FnEi	24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	1637	816	456	12463	16099	jwUAmH35iFv3NpD5H6FehHtuhzYob5ZUCTzZrbPVuuBKEz23DWP	12036	16940	16940	1618988400000	canonical
24182	3NLLZxj256cWeH43a9iUNBJzAKzzj1J88qCRCXjDuzWMVEipD8Ad	24180	3NLGaRWZSJSf73oTJ3xpTh8PMN2qDmUUHWZsdwdagLQoA1d6FnEi	44	1325	456	12463	16100	jxF3FNngmEc3i1NydcinDHQDZjEjmT5CrPGSRG47bjqh6om2JYc	12037	16941	16941	1618988580000	orphaned
24184	3NK4EysMtN1FufbfQu16HWpCAqC7d9g8SYwqT76UnzcbtgsRdU3t	24183	3NLec4sQrzarD8MJBcEB1wsEus9ykyuXvv5K2kVzxdRA4BtJZcQE	1407	1395	456	12463	16102	jwkECy39X3DQAd2gLazKVFKbPJCkMythECyfj4Dyg4dNi6AJpok	12038	16942	16942	1618988760000	canonical
24190	3NK9DuYpUHzTto8vBBnuthmuDBZqFqUcv8te6WYbE4RSjgHyBp9k	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	80	1273	456	12463	16106	jxotDFDNBPFZ4k8sPdcF4VbQUznw2cyYhXihGWdRzRd63CZTdtg	12041	16945	16945	1618989300000	canonical
24192	3NKhS9s5q5pN7gTmS77DHSCXuMfdGVEd2gCQC6peCD7CJNGVbxxH	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	1560	1291	456	12463	16109	jy1F33dNQosxM6h1A9wp9BJb817k39aYSxNbowWKozBEkrQ3DMX	12041	16945	16945	1618989300000	orphaned
24195	3NKG6DiUbpPbfMwwcML15r2D2ebV8eHkWDJb6s4TiN5UXujCcHF8	24190	3NK9DuYpUHzTto8vBBnuthmuDBZqFqUcv8te6WYbE4RSjgHyBp9k	1419	814	456	12463	16112	jwPaNKmMfMuFiNjVYSzD5tFMhQ6yPaizENC2ZnPLZVRpnCP9v95	12042	16946	16946	1618989480000	canonical
24194	3NKHp7v3emunZbWuF6WGRNaiiG3rcXo31bwuWb9kPBD8L35NtFPE	24190	3NK9DuYpUHzTto8vBBnuthmuDBZqFqUcv8te6WYbE4RSjgHyBp9k	44	1199	456	12463	16111	jxdJ7FtYGbi8cdsBq9dTkZon2EhBaFqoLGtFebPaN2Jmw8pUyXz	12042	16946	16946	1618989480000	orphaned
24197	3NLdxWV4mFRmU61n6nVDrUYviWJ1wWBUZRag247tKeM5ggppuDhw	24196	3NLAnGwBA7PkUUfzzjkJH7U4pAVSZeDbc48FHefxJ8Vn948qE5hg	1406	1393	456	12463	16114	jwckyL6ndHd5Le1oEsR8aKyj48CcxXi95QfyhYBFdJzTvG7uEad	12044	16949	16949	1618990020000	canonical
24200	3NLc3njByoRLHNFypzKXY3JmJD7WJPLcW3BTUvALKcdCiV3mfurX	24198	3NLJh2MchyWQoHC277hcF1dtQwLoYdziMSZvRuksgLXGgmTkeRHz	1624	1334	456	12463	16117	jwk6xfsFwaVKUZK5ygo5YgfbF2XUq3eEQpohTkE1GkiAALAQ7KK	12046	16951	16951	1618990380000	canonical
24204	3NKXXZQRS7tdehVeFgKduk58XMtmzFVMWaAEFo3VdUeXY9xfmgch	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1439	1279	456	12463	16121	jwx9F65f9VhgGjYNfCoXo4FpQoccHPQJLhVMdwUWoDrq4gZ53XF	12048	16954	16954	1618990920000	orphaned
24209	3NLN2vKad6YS854uxAjMQPXC9cm25fEoRfnot42DmEya6K5NpzeP	24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	1593	1220	457	12463	16125	jxZKjYbvjomeeTtDQ7wMN7RW5QnUQWDPb6TKvo7Lg6iPaLrECHB	12050	16957	16957	1618991460000	orphaned
24214	3NLhQbNdkrB95pS4D6KhR8ScwqLN72n8nzrFiPTdkHm2tNhWseeR	24211	3NLo8J1671pHTgU4nb73rQLiyMxhhybeTPwm5cm6BGT1HTw3sYim	1402	852	457	12463	16130	jwGcdFTwefikoZJR1XEW82zZD8e4rCYq4BkDLr51UJmm9C1JnWo	12051	16958	16958	1618991640000	orphaned
24223	3NLZqV7wupkhg25PVUhggjz63NcSALvmFew4iQLZ3uE6bHqoPTYt	24222	3NLduknb6xkVufBKQHaBbevMjoa6yxMHEPHofS3RGu4iTczvFF9v	1648	1158	457	12463	16138	jwfojVNwJGNW7v6pENCz1JKw3jDRA9DzJbLcoWsWRZqNpUEW3HM	12056	16963	16963	1618992540000	orphaned
24225	3NK84oJ15fLrEWhRiPda3a7FNnbqjE1CEuyqMWy4oitvrVSaAfSN	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1657	1344	457	12463	16140	jwga3Vt9MmTGh5wnKzkeMLtVY7QTgkbLxCYWE31sgr7z2aEpJR9	12057	16964	16964	1618992720000	orphaned
28163	3NKw62jn14DfGpKWQuJQYmsdBhYk63sAwTT8yXiHpdSuAQJcWMgU	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	641	970	551	12463	18974	jx8cBd6Nsu6wcojr2D6D8HAbxFU85iHs81C2vfbQ3YZQNTPXQao	13925	19635	19635	1619473500000	orphaned
24245	3NKo9S1vPZYwYrJ51nuZoYNQ8pJ2M44xrcWrVqddcAqVyS9S3VCc	24201	3NLnLcyfR42rFd8pT8TeT5PEYnFYuj6yB3uE1NP7bUv6xgW1YACQ	1500	1297	451	12463	16159	jxfEstvoabBWSyFa26F8CPegrJGDaRUs3S8E2WkWnGyNdWAhky2	11918	16972	16972	1618994160000	orphaned
24239	3NLTZb3xcZbN75qWdLVr9SUzMEypz6FNQ172vHZ48PBNkFFNq5XC	24103	3NKw1vrWd6XcoZoXBeHSwG51rn5jKR9oXfzayn1itFzLXCQzsFwj	1448	945	454	12463	16154	jwG5NF9uLnxW1pTfp5ipR5C4EvZsD346isvS97rXWASX4tmBMkD	11999	16970	16970	1618993800000	orphaned
24176	3NKFcE3CThHQgM5rpY8ryNcfd8Xssj8VAf2krimN7U5uXrpzsJ52	24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	1581	778	456	12463	16095	jxNaKUgbJLsaxAGqduFjEaQZ3VDWqahSCcKgSHr1kcWGoZURzH8	12033	16935	16935	1618987500000	canonical
24179	3NKoSBQNJBEATb6SFmW5EMxU72nopcjLX1cGMSxB33FjMJXGHFzF	24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	563	1113	456	12463	16098	jw8FUYFxaCL2BUQjCeJEUd6N6GvjW2JyPJnKpDmkV7vGZ37G7QF	12036	16940	16940	1618988400000	orphaned
24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	24185	3NKPffUtfkjkSt3H5GyngtJnnQvH7ZXw5okNQuMeh6NwuNW2xHkf	1579	1389	456	12463	16104	jwoxSmXWSF7fTP4HiSGyE9xoAJAozo56uUZYxMzx7zZoppcTbnp	12040	16944	16944	1618989120000	canonical
24191	3NKZhgUnCDjxpUkA556i46AWkDz4iGqcfi515547PsDo42hhtAzr	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	1407	1395	456	12463	16108	jxQm5nej4B9M8ng5cdCZa4nnnqkrpqV8hxKCer3vBQdWLBEtmWu	12041	16945	16945	1618989300000	orphaned
24264	3NKQWf3mqmFSnXHasHiGUjHkkf3QxwKztF1eqekRdjU93Q6AZWuo	24197	3NLdxWV4mFRmU61n6nVDrUYviWJ1wWBUZRag247tKeM5ggppuDhw	1516	1294	456	12463	16176	jxxAJXhFbK2CPzsdjA7yyT5gxKGXtisziVQMZhHJT4wLo5vW2h4	12045	16989	16989	1618997220000	orphaned
24268	3NKMs5fJVp3LVJSkV3vKKnUQZLZcM5kQD9CZDzgL6Qwzx4VfBjuB	24264	3NKQWf3mqmFSnXHasHiGUjHkkf3QxwKztF1eqekRdjU93Q6AZWuo	1516	1048	456	12463	16180	jxe65TFahfLRHA3ruFRQwNu65TLM9JSs3ARfhCg8NXNwg53hhss	12046	16991	16991	1618997580000	orphaned
24205	3NLrUacir5M1SUX5Bk1APKEDhJxBhdw8Akexg7GYZxGTgpjmkkae	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1402	852	456	12463	16122	jwF8nZFt3TcAby9JKHJuvW74EoSkLcRVvNn6X59PiSkdpyQ6vaA	12048	16954	16954	1618990920000	orphaned
24212	3NKRJa3R7V63KtjExgMKbzebKSQWmdk6N35MkK2nRHDh5tViN6RL	24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	1631	794	457	12463	16128	jxjZmJyjY4T53AoFh49sFFNUt1qP1j2Xkt3eSq4EoTvu2767XAq	12050	16957	16957	1618991460000	orphaned
24219	3NL2tLLur6JzMRpphfLynDzCULs7rH8M1vbPKgKYSJZYpmNVGq8U	24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	1490	1274	457	12463	16135	jxqdRRHTjHrkojEEbvV14yrXtcZn2CvTXUJUUtrkt7uv3JeFGtQ	12054	16961	16961	1618992180000	orphaned
24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	24222	3NLduknb6xkVufBKQHaBbevMjoa6yxMHEPHofS3RGu4iTczvFF9v	1406	1393	457	12463	16139	jwMFf2ZLRv8ksYVaT91NgExFUvDdbR22PnxKks5zJP8YCV4a7CM	12056	16963	16963	1618992540000	canonical
24228	3NKMpukqDXnPZkSCio1b9M65jdPN26CCxLSTKm28BW5sMLnKBB5n	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1609	1087	457	12463	16143	jxk5ae4xWHN1irmHjT4vVTsNiW7wCi6tDuKfxcHWPVSWDpZ6PFP	12057	16964	16964	1618992720000	canonical
24226	3NKEKMyQMdicXf6bz4bbSSyh91h3oaq7dtN3rLxR1Q5EEjw4HJNo	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1406	1393	457	12463	16141	jwdDyocAxheNXRSpgYkjQHyyuNV48bjXXtRut2Z9pLE8ZJbQV12	12057	16964	16964	1618992720000	orphaned
24232	3NLNHbPpqPHnBNu99PPsqRre5eXHYbPcXdVfdzyvG5vw8EUF5MnL	24228	3NKMpukqDXnPZkSCio1b9M65jdPN26CCxLSTKm28BW5sMLnKBB5n	1581	777	457	12463	16147	jwBuhfkm6bZkdS5P6YfzBSNsXwuGvqgGPUm5yRkbNES5zpYw8cL	12058	16965	16965	1618992900000	canonical
24234	3NKHCpSVZe59p3hjATjueUckL2H7qmZYK2cRE69aQcn7F2WpdxUS	24232	3NLNHbPpqPHnBNu99PPsqRre5eXHYbPcXdVfdzyvG5vw8EUF5MnL	1407	1395	457	12463	16149	jwf83rhFjn8MzPF77dZ8XEEE5coJ8WtRP7TMvNgRBm9xmo1Azvr	12059	16966	16966	1618993080000	orphaned
24236	3NLEHw6RtekKqG6Yhi871FhWQRfdz3iQSqEte5QCSzZJWdupmQMH	24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	1403	786	457	12463	16151	jxTie5nb9jW7bL7X4ye63PJcewjfBpCjxL3sW1zA7vpysjSmgwK	12060	16967	16967	1618993260000	canonical
24242	3NLxJD4npbUD61tD3vC6nshcA3e8CF5Gsn2f9hVP6hvChDPC3cGg	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1448	945	457	12463	16155	jw7wzc877TetbFfqRyxhq4TGu3k6xieFTJ4mMrFH9JkQX11cjTd	12063	16970	16970	1618993800000	canonical
24241	3NLD1HybqC9W1zs8stKM8ASnRoYhfS57EZESiGKmcgM7XnpTgDB6	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1406	1393	457	12463	16156	jwcWfunygMTFNAWSvKkdPuXZp2WXVx8wUq5JizEeGvPs7ZCFPcP	12063	16970	16970	1618993800000	orphaned
24248	3NLXY5FqEowhoodHJMp36WaUMH83F3B5y8J7AMuPGDFF8eFLFXVL	24247	3NLFLxpvwWzrdbDHHrZWmeVKHS2FW6XHTzuQhLXXehmLbBG3RJj2	1627	1139	457	12463	16162	jxtMEtYzNTn98xuAEumCw1UEZ48PjegCzMuojzMyS6oyX2qC9ZN	12066	16976	16976	1618994880000	canonical
24249	3NLgs38RFg8zbYcGeiGQpNG78hkxBhpV71Rn8Z5uTJwwRDKbnXri	24247	3NLFLxpvwWzrdbDHHrZWmeVKHS2FW6XHTzuQhLXXehmLbBG3RJj2	1581	778	457	12463	16163	jwKMBZKp1j75tbj7cgU2K9Hv2HFwLw7sfowDpwFsjhjLWaLnDnc	12066	16976	16976	1618994880000	orphaned
24251	3NKbLHbkt9gVDsSMhM9R28whghWptQke3k5a2prJ5XTBj7o4joye	24248	3NLXY5FqEowhoodHJMp36WaUMH83F3B5y8J7AMuPGDFF8eFLFXVL	1483	108	457	12463	16165	jwqstk99pP17BmSfJFFaxG6kHUwVyCB4tp8DQTa3SqCLoHUHFzZ	12067	16978	16978	1618995240000	orphaned
24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	1406	1393	457	12463	16170	jxQjE75enjsm35ecqFiGDea6yek63fp3d4HXQBgZNSDQLTtdPxV	12069	16980	16980	1618995600000	canonical
24261	3NKJZsgEN7AE6uY1AwufFuSobg8xMEVPoGFWz2TiTZTL6ytj9wy4	24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	1553	776	458	12463	16174	jwjjPbL49xfy6aYLbsvGEwFTfDEXeue9CRhPi3oPAH7KqzktUax	12072	16985	16985	1618996500000	canonical
24266	3NKdAkKe2LWVQZ1vzZDynMUBcZFczSENKzPJnY1mPsN7hqRwekRB	24261	3NKJZsgEN7AE6uY1AwufFuSobg8xMEVPoGFWz2TiTZTL6ytj9wy4	1634	1331	458	12463	16178	jwipsnFE2DaFEeVriYe6mQktZXuzVqQi128UzZm6ikVAnGD1uqK	12073	16989	16989	1618997220000	orphaned
24271	3NKkWvnnZPwbLMaU3axYAEzQkMXHqdFtAXtZkyUtA1bmuhMU9aMc	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1611	1095	458	12463	16183	jx8Wyy6sgt8yUSmcTMg3K2f2PXLaVfonHg5whn6jYpEBkHda3re	12075	16991	16991	1618997580000	orphaned
24272	3NKBfxqhJpBheFwrqJKvqUjyb918npB4SoBqvzHvw5Ttez2skdwN	24270	3NK8JfPWbZ6BHfyXhaujmbE4HKsr9rSjy3JppBEFuuT5LavKqezA	1483	206	458	12463	16184	jxgWghawox4cr1ZX5RXpDc5nd7h4MnC19g3qLSVah5UaqR33rKp	12076	16992	16992	1618997760000	canonical
24280	3NKUNJFdFF8CZ4vSC5W39PhES8RiYi2V7SFsdkxxZvE31dYgmR3p	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1637	816	458	12463	16192	jxzakEndhm6K6M6TwUnoQwLetnvHRwFf6TtKjMrLJ8kY6qWeyi5	12078	16994	16994	1618998120000	canonical
24277	3NKThGX9u6s2ojXvFSyCF3kzjwFfxW8hdbHyNSXdHkatb2usSGLB	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1508	1261	458	12463	16189	jx4Npq6aiYTvpKzQpVan3h29W2Q7q1ZAD2NQKPWeCkxCGTXK19o	12078	16994	16994	1618998120000	orphaned
28168	3NKdYTzycaePUwgnCoWCRg6xgE9y5yFnXHQgp9fQPyqiyqV22Rsb	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	80	1273	551	12463	18974	jxRGJgYZQkEYMzaTUoNBa9DkNhpja2vBrVJoiEHcDLB1KymStLG	13925	19637	19637	1619473860000	orphaned
24286	3NKZgqUWXZM4kqvUwso3BTJSqSiNX7mPm1yDuCRPDC7h1U3QnbnE	23726	3NLV7tgGGYDtGS3aPvuvs2wVoE4WjEQuLjZ4LKdoh9ERCTGEwBKL	1405	849	445	12463	16198	jwjGua4QcJpFTywpRRWgtgBL53mTypkrWCqw5x2qDxqgHvX5pQu	11817	16995	16995	1618998403257	orphaned
24201	3NLnLcyfR42rFd8pT8TeT5PEYnFYuj6yB3uE1NP7bUv6xgW1YACQ	23980	3NLYthha78PRaVdgarqQDwDikBLRgS5biW3cfvvJq4BLqP32Dqoz	1500	1297	451	12463	16118	jx1f4wnbzNhaMuHgWJn9pZJUUpYaXhhUDpMBTw68Q1XaRx4TKUH	11917	16952	16952	1618990560000	orphaned
24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	24177	3NLVcxx4khpK5qF16E9D7XVSdCucND3ZfvsGkWzFmJSSNYHTkxXd	1406	1393	456	12463	16097	jwh9ETjco2XQ13Q7coNGwdG8GCvdom7zWM8Urn6Yx2TXyLyhJM9	12035	16939	16939	1618988220000	canonical
24181	3NL3Tztogcfo3yCRJBp3UvFPi2wNc5RhypJ7woRLh5LzAvybfP4Q	24178	3NKcajPL8qMFHUPm3jFZhXLqH2VJgovRZ6otvxUXSfu19Uh1hd3f	563	1113	456	12463	16098	jwomvPfJqkYE4wd7BrKek2vz5dw2jhnnVkoyYkbneBBVuDPCUjt	12036	16940	16940	1618988400000	orphaned
24183	3NLec4sQrzarD8MJBcEB1wsEus9ykyuXvv5K2kVzxdRA4BtJZcQE	24180	3NLGaRWZSJSf73oTJ3xpTh8PMN2qDmUUHWZsdwdagLQoA1d6FnEi	1447	1099	456	12463	16101	jwFLH8yZf7wgsyfWt34d4fssZ8Ez4WTsDWwX3BwGBcyaeEDht4i	12037	16941	16941	1618988580000	canonical
24185	3NKPffUtfkjkSt3H5GyngtJnnQvH7ZXw5okNQuMeh6NwuNW2xHkf	24184	3NK4EysMtN1FufbfQu16HWpCAqC7d9g8SYwqT76UnzcbtgsRdU3t	1587	1231	456	12463	16103	jxRUv7odNVcFc8jURbJa8Wk9hKeFU6sf6DALjncd5Y6jWNGK4yD	12039	16943	16943	1618988940000	canonical
24188	3NKaq4JgdVoyxGqDVrZQUKWParoEUpG8HAkMo1HhBT5pedfHnxu3	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	80	1273	456	12463	16106	jwTEJvb2jeaunHgUGun6XgrB9Uf2oG1vWdP86URAwnvjjHYzDXW	12041	16945	16945	1618989300000	orphaned
24196	3NLAnGwBA7PkUUfzzjkJH7U4pAVSZeDbc48FHefxJ8Vn948qE5hg	24195	3NKG6DiUbpPbfMwwcML15r2D2ebV8eHkWDJb6s4TiN5UXujCcHF8	1670	1282	456	12463	16113	jwd27Vh5FmraHgbtL4GKzQtAQpKczekKUvkoug9G1Es6fRXDygW	12043	16947	16947	1618989660000	canonical
24199	3NKofke8vVPCXodxPUra2kPorD8eZVRmJ9aw6iN9Qb7HyJuvjEAY	24198	3NLJh2MchyWQoHC277hcF1dtQwLoYdziMSZvRuksgLXGgmTkeRHz	1402	892	456	12463	16116	jxLxNsZB6bKmC71fqQ8Kjs3bKs8WZm3e4v5Qvoii2u5dg2T4qE3	12046	16951	16951	1618990380000	orphaned
24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	24207	3NLQSyUbSkhrq4Nxa4LwWjBWKcw4NvfBiAisMJs6ijor77Ca65ix	576	989	457	12463	16124	jwBexrJTeTv9HRdrbatKEMYT2u2NTKYzsHAnXjSv9wwrLv69TVP	12049	16955	16955	1618991100000	canonical
24211	3NLo8J1671pHTgU4nb73rQLiyMxhhybeTPwm5cm6BGT1HTw3sYim	24208	3NKKgUiVZfoHK6bgFzLM9pSwPfTXTJ9X4XPia4MhijZrr8FCehEc	1407	1395	457	12463	16127	jwXBFAFKyirQq2t7kSL1fc4eCjnwtphraCkqeaANRVR7Aw4qRU3	12050	16957	16957	1618991460000	canonical
24213	3NKLHvD8G4Ni24Ee5mRzL4XeybKGFwTmXcRS778oRg85a7giqqV9	24211	3NLo8J1671pHTgU4nb73rQLiyMxhhybeTPwm5cm6BGT1HTw3sYim	1471	1386	457	12463	16129	jwokaU7PTLpF6uBN1aH1FY44htzqhSdGt6DPqc8Df8YZ3hMe6D2	12051	16958	16958	1618991640000	canonical
24216	3NKLutWnWNs71UzQyzGrRLRRHosypRSi4kXVmw37iUD3y6uLryT8	24213	3NKLHvD8G4Ni24Ee5mRzL4XeybKGFwTmXcRS778oRg85a7giqqV9	1403	824	457	12463	16132	jwWkbsjSEz6BUrMXh1vz9MrjkhkX6SagnRmHUh3m8G9XVYgc7bK	12052	16959	16959	1618991820000	orphaned
24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	24215	3NL3sf7MtybtrqANMmcGbWzM49VJxFXEpLuPAShzfSLcQaAh4iWK	1560	1291	457	12463	16134	jxJFFDMngKY8YtTnQd1cdXAo4Zhc8FDMAWMwxCocu4x59ptVrby	12053	16960	16960	1618992000000	canonical
24221	3NLsR9e2jVmWxmtTgb1KRYuxGoayVVjHHbKZgTZUUQMhLRfcnNqt	24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	1490	1274	457	12463	16135	jxrgsgyX71ZoCWaeHGHRzLMtF5LK8mZHA1diJSffPbNmF9qBRkG	12054	16961	16961	1618992180000	orphaned
24222	3NLduknb6xkVufBKQHaBbevMjoa6yxMHEPHofS3RGu4iTczvFF9v	24220	3NLKRf74F36STdzRHmEeUz9hFkkSbP1nxKXGKz2aNTV3UZZdaufF	1637	816	457	12463	16137	jwbMex19tdHfypbakhhCYRPQpWPXiCcf7BrYoxbzC131KeS31i8	12055	16962	16962	1618992360000	canonical
24227	3NKuB8DyofUd49H4FdfXa3Ns3yNK5WZaWJ51t5SjTuZK9KxygzwJ	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	484	1319	457	12463	16142	jxYVXG8Uht6iNKwmnGcmWBaFcNoBaSVXE6eUjb9nJ7YBXyCLJcs	12057	16964	16964	1618992720000	orphaned
24231	3NKChKcCNDNRV9w19KQkGUDahWQe1PJEkfzq3gbZSVwo56TMxr9o	24228	3NKMpukqDXnPZkSCio1b9M65jdPN26CCxLSTKm28BW5sMLnKBB5n	1406	1393	457	12463	16146	jxRtoaBm4wvf2wkczoLY8pux4PUwm8hAg3ypPNNt6HL7gZ3LGeF	12058	16965	16965	1618992900000	orphaned
24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	24232	3NLNHbPpqPHnBNu99PPsqRre5eXHYbPcXdVfdzyvG5vw8EUF5MnL	1617	1042	457	12463	16148	jwyZMTSkzh3agZVrudjowURb3ZD3j2Rf54nH8mmssWxvkNJZcVL	12059	16966	16966	1618993080000	canonical
24273	3NLUzyyGu4CCcz3CVL2tKvkXMuRswCw6XRouvKkbamdHYhb3LMpx	24270	3NK8JfPWbZ6BHfyXhaujmbE4HKsr9rSjy3JppBEFuuT5LavKqezA	448	1305	458	12463	16185	jwXKD1QJswQzVjhphCj8Guj2f7rd5zj2tzuTwRDQxWtDR37UyeL	12076	16992	16992	1618997760000	orphaned
24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	24272	3NKBfxqhJpBheFwrqJKvqUjyb918npB4SoBqvzHvw5Ttez2skdwN	1631	794	458	12463	16187	jxAtuBzw17GFcmuBmYe6viVAbc3WLxXeBrpMBV8LUaRMDqsBKyR	12077	16993	16993	1618997940000	canonical
24278	3NLWw5uDWjppL3kCrDv3VuHBW9NM9vtFy3RzhAE7CGtNCLFpdBN7	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1419	814	458	12463	16190	jxpDLehdDU5Da8HMMXCj5nWoykDZddRmEDBo7nSUK593LY822qN	12078	16994	16994	1618998120000	orphaned
24287	3NL4ovbFYkoU6oBBg7DWFkX4wLud2A7DkCYFDNtjWunJByGB4hSt	24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	1490	1028	458	12463	16199	jxzbVUaaPpkB6xoaH66sSJo75dY1neKfx6sHHgPGLAZ1ns95DBx	12080	16996	16996	1618998480000	orphaned
24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	1403	824	458	12463	16203	jxbVee1dHNvisFK1xz6X4u4Lynd75EgWtbR5PncBi9KJ1YfHjST	12081	16997	16997	1618998660000	canonical
24289	3NKRQTRKuHXseWYJzyA8Bg3oUJPMaUDeafHZE1Md5ikwp1yiETa5	24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	1467	1130	458	12463	16201	jx4m7dJMCjVuntG87NGno2jvMaEmRE6UEBywQtAWwRWLomQYA5Q	12081	16997	16997	1618998660000	orphaned
24294	3NLaqmNw8VHiKAxscfoi4WMKM9zPqWHMn4ELzTQGyLxK3kq59z7x	24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	298	1308	458	12463	16206	jwqXzGLDmauxwWQFFBAXuVhrmxK1qfXT6puXrgk8cHwwJey7o5t	12083	17001	17001	1618999380000	canonical
24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1657	1098	458	12463	16212	jx5AikytNiZKJ5PnuM2BdrcZ4n2rCDf4MghhK4fFhmH9a4dF922	12086	17005	17005	1619000100000	canonical
24306	3NLxbKTMiPXASXmg3HoNGzq1pPtQXRToa5A2WNxBghstEpzovF85	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1668	1244	458	12463	16216	jwvRt5tgpE3oBzaBxiUJB84YWdtoZD8epPX3BbCX6kjR6kyhsdo	12087	17007	17007	1619000460000	orphaned
24311	3NLRYu6bFEahfJPd8s8YsRNRAMBXNr3EtaF8q2Tf2BurQFGKez4z	24309	3NKn9itBn8gHHeqBfVQLVQNuAT6gqNpASmFNpqaPWJx1k4mGz72C	1623	830	459	12463	16220	jx2eeuHmVdE3e9EM9y77U1ELuW17p7XLiW2jpo6n4KSdeMbs1L4	12089	17009	17009	1619000820000	orphaned
28159	3NKYyQ89fT1uu4mmfQAk4WAiUu4KLe8do6Bfx3XAzdiSk4GGNv3n	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1402	866	551	12463	18974	jwbbpyhfjxEB1B62uKfAVRpGCWPMNV8puiNawqc8dEhxaWiUyvE	13925	19635	19635	1619473500000	orphaned
24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	24200	3NLc3njByoRLHNFypzKXY3JmJD7WJPLcW3BTUvALKcdCiV3mfurX	1617	1162	456	12463	16120	jxBryEmT9PpNpaqWbkCWbq3sWHPz6gmfo8MCm92ncNP6pSyJubk	12047	16952	16952	1618990560000	canonical
24207	3NLQSyUbSkhrq4Nxa4LwWjBWKcw4NvfBiAisMJs6ijor77Ca65ix	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1581	778	456	12463	16123	jxfveNLicMsNADVcFCiwiF8e1gBDESAsSPfj88N6RWG8j8YEyhn	12048	16954	16954	1618990920000	canonical
24206	3NLfuW9Z4hwqv6fyYA1FkyV6MosFU2AeKNjf9bqfFi1aPqaTan1A	24203	3NLknMjC7Xse5SDwJzL6YSmib2zZod89UtabF8vsNVLkJyUvnJPB	1439	1279	456	12463	16121	jxtWcP7G7Cu4owfuUAYC8idGVxRoRNzv7XEX1tYtjdmx4cP9XQp	12048	16954	16954	1618990920000	orphaned
24215	3NL3sf7MtybtrqANMmcGbWzM49VJxFXEpLuPAShzfSLcQaAh4iWK	24213	3NKLHvD8G4Ni24Ee5mRzL4XeybKGFwTmXcRS778oRg85a7giqqV9	1588	1392	457	12463	16131	jxfkbQDhbbrxSex75MLE14Vm9twvHxpRfJ18FDtpgDuMGZ1kuYU	12052	16959	16959	1618991820000	canonical
24217	3NKzKHZNw8Vrxcv5iFkUAeYktPZ14WTc33FVJJFNVgFqRWeR3UcZ	24215	3NL3sf7MtybtrqANMmcGbWzM49VJxFXEpLuPAShzfSLcQaAh4iWK	1481	790	457	12463	16133	jxB5yuuUfBtjWjiP8qNr9jb4LM41y1YSQoJPbz2S1r9VTAsTNE8	12053	16960	16960	1618992000000	orphaned
24220	3NLKRf74F36STdzRHmEeUz9hFkkSbP1nxKXGKz2aNTV3UZZdaufF	24218	3NKgep3mA8HZNuc6F9M96eYB9NL8GVx6jFE6pG26iS2BYvmvjBeV	1407	1395	457	12463	16136	jx5BBETVhH2r6YkHjCQw4VBgWyv531V4PkQfM6EVTWYX6oKFuHm	12054	16961	16961	1618992180000	canonical
24230	3NKyJ45XDAwH9XnLnpFLjVXz8MzHj3W4uipk56KZUKvmUnBRxuG6	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	1407	1395	457	12463	16145	jw6uTyVTbySWd3GvcrAv1wfr67saQFbcAABysybQEb1KdGsVyae	12057	16964	16964	1618992720000	orphaned
24235	3NLawNPwSeY4AKVUn86hbFJXWgaijbeBDiugPnp1xTQnL1YRfy1b	24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	1402	862	457	12463	16150	jxGyx6UWajcFTKWH16DXMzg4rM8qBbA13mwdU1yYgWGZf1cui2u	12060	16967	16967	1618993260000	orphaned
24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	24237	3NKqeNvVy1mKczabz9m7CmX4bL9yQryrh7rtMNm8N5rwej39w6Bb	1601	1388	457	12463	16153	jxc9UtoKsQsdggRtPmShtZTYoQQ9THRimgHwQggqGCPuuLTXwCU	12062	16969	16969	1618993620000	canonical
24240	3NKdR8eEye69WEqDbwuv14cXtY4KWB5S6XZzk6SfjibRYahuWs27	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1448	945	457	12463	16155	jwvDp6irZR8E1R195PyXYHmZEgje7o648ZdrY63CbLCzxHANuUb	12063	16970	16970	1618993800000	orphaned
24244	3NKLFBuzmQt8wuAgmbpFjXPMUxY87pDiedNTGSVYdo5QnR9xLn1x	24242	3NLxJD4npbUD61tD3vC6nshcA3e8CF5Gsn2f9hVP6hvChDPC3cGg	1407	1395	457	12463	16158	jxSTZDjCkWKeatCiYWCRvsFQkbdUxUDPpR5ww5XF9bVEXCkfbeF	12064	16971	16971	1618993980000	canonical
24247	3NLFLxpvwWzrdbDHHrZWmeVKHS2FW6XHTzuQhLXXehmLbBG3RJj2	24244	3NKLFBuzmQt8wuAgmbpFjXPMUxY87pDiedNTGSVYdo5QnR9xLn1x	1461	1271	457	12463	16161	jx3sqQ6p54dQuBDJ4xKS7yUkoo5TmirGLYUE7sVpCmugLd7zXXr	12065	16972	16972	1618994160000	canonical
24246	3NLbLQesMpSWJRNqbhSfgQVqCAGtF9J6NuXiwZPBuATDvWJLAvQn	24244	3NKLFBuzmQt8wuAgmbpFjXPMUxY87pDiedNTGSVYdo5QnR9xLn1x	1500	1297	457	12463	16160	jwnBA6uGmUgY6R1r4E9j6wgq53EhsYkDcmvUARhuDiNft41KW8a	12065	16972	16972	1618994160000	orphaned
24250	3NKJ3NcPnQU3bbfD8yo2zy5EyCKkV2x3ckRehDh5tsGkfvwYKNDi	24248	3NLXY5FqEowhoodHJMp36WaUMH83F3B5y8J7AMuPGDFF8eFLFXVL	1447	1099	457	12463	16164	jxsUymKrNbD9Vwp6v5RkgpCa59LWUrHiV4c31ckR8qmy3LqayrW	12067	16978	16978	1618995240000	canonical
24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	24250	3NKJ3NcPnQU3bbfD8yo2zy5EyCKkV2x3ckRehDh5tsGkfvwYKNDi	311	1181	457	12463	16166	jxADmyAwcA42yxmMyGKVJyYvSz83mRs2pNdqy7eeGxEwFpWu5kr	12068	16979	16979	1618995420000	canonical
24253	3NLsSCm9tLyJY7ApTJJu7spsAVmNNwqrWnhGCFgnueoE3YAFCnWV	24250	3NKJ3NcPnQU3bbfD8yo2zy5EyCKkV2x3ckRehDh5tsGkfvwYKNDi	1406	1393	457	12463	16167	jxNcCpZExMVd8Qoxg3wCSW8sAb8rCuLS3295u5D64LKkFrbLpuu	12068	16979	16979	1618995420000	orphaned
24255	3NKkdZazifcePiUQYJyQ3TfnxEwyRgxQTxwdgoUAnqeMupzVCann	24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	1642	1121	457	12463	16169	jwYZR5FxbVv9QgE6CyY4rUyacuETrdqgWFZWpTQNsb6V23bzkGe	12069	16980	16980	1618995600000	orphaned
24254	3NKhhDXGYfzeaSNh71dTv3iRmBB9mb2EpVTpBFAk25Rn4RArTzQ7	24252	3NLQbYcLcvZi48Ljgtf1kd3uhKo3X6LTxWCpN22gtUnjvnmtRaif	1456	244	457	12463	16168	jwMQTRvSDGziDjkxxNjrZ7mCEUcxWC7d5MhXEj3877nAgTh8gu6	12069	16980	16980	1618995600000	orphaned
24257	3NKjrSxk2XPHNXv37ZPTRr9m5zaysYKFRwVB2EBJ3mCrp6ZkjhJz	24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	1437	155	458	12463	16171	jwr9bitEoZRU5kBKuSZzYPezR5WJ8xH4raRGKGPj6AWiNr96ks7	12070	16983	16983	1618996140000	canonical
24258	3NKoU1mWJTZBghYhgpDJVEvQgbXfz2LrE1vnbYXNgGuqSec88xyc	24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	1623	830	458	12463	16172	jxHaErCKZtmqHRkZqEUoP1NArP5eX3cCFjmjLbVuwxMpSBsw4pS	12070	16983	16983	1618996140000	orphaned
24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	24257	3NKjrSxk2XPHNXv37ZPTRr9m5zaysYKFRwVB2EBJ3mCrp6ZkjhJz	1448	1311	458	12463	16173	jxi1QxtFFdzrBBHAZeMBQHkKe7QH7PXRFUFL4YKVfBeevETiwUz	12071	16984	16984	1618996320000	canonical
24260	3NKrYycH7P2p3JJD9PABwLXshzPeSDgcqNDzy4SBbtpc5a2f2EAZ	24257	3NKjrSxk2XPHNXv37ZPTRr9m5zaysYKFRwVB2EBJ3mCrp6ZkjhJz	1448	1311	458	12463	16173	jwWNJYM6rN8qzaU6ZEkbiSaoj1NkF8yx7gxUoE6zXxE7CvTevnM	12071	16984	16984	1618996320000	orphaned
24263	3NLxsKATgLZUoxjN7FhQmkRpLUCX2iRu61pWpYSA3uRRN1HGVZyG	24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	1440	1377	458	12463	16175	jxiYzr795AgPN158QE4aYtBUcGr2gnKT7Z4153YwN5H4i6rAgWG	12072	16985	16985	1618996500000	orphaned
24262	3NL4HTcD8gXxT51kjbpvmxeRi3BNCP4rqHzCr7NCrUaU5PH8Ds3Z	24259	3NLRTAJpkSHmmWSvjSYZwWXMS4e5NBnkwpFCYTTfYzJGMTqBhekS	1440	1377	458	12463	16175	jwtqKJ3bVbMg939DKDQk461sT4udhNLvvNDE2F8zpAeZWQbFPWg	12072	16985	16985	1618996500000	orphaned
24265	3NKBRHJZep96hCoFMWFEgJdLtHocCN9ajDabQVHFDCA4uGzrC2TE	24261	3NKJZsgEN7AE6uY1AwufFuSobg8xMEVPoGFWz2TiTZTL6ytj9wy4	1522	1076	458	12463	16177	jx2Si39ebkYiRQSghZ86XTPvmPusDs2AR6j6dYz9Gec2jwsNg1c	12073	16989	16989	1618997220000	canonical
24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	24265	3NKBRHJZep96hCoFMWFEgJdLtHocCN9ajDabQVHFDCA4uGzrC2TE	1407	1395	458	12463	16179	jxNychWmsCKb9AJ3vBUhfjDyHaPxWNJPo1NzjiucsUbdj8zVZ8S	12074	16990	16990	1618997400000	canonical
24270	3NK8JfPWbZ6BHfyXhaujmbE4HKsr9rSjy3JppBEFuuT5LavKqezA	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1476	1371	458	12463	16182	jwGB3bDNhg5Fgk2apK5RhGDfjPPpsvYKsMx16RVinq28CNMCL6J	12075	16991	16991	1618997580000	canonical
24269	3NKZL6Tbqh4yMqDZCK1zJvBAruykskqS8skHuP9QUoww3M28BZg4	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1599	1161	458	12463	16181	jxmtgEUAwwkmSEN9Syicgotw9fSUqCng5qyK19jJ3YuahYn9fif	12075	16991	16991	1618997580000	orphaned
24284	3NLFkcn8hG5wsjFM7MS4qcYVkc9GbnBBCDEjEDbRni4SPng3isXA	24280	3NKUNJFdFF8CZ4vSC5W39PhES8RiYi2V7SFsdkxxZvE31dYgmR3p	1542	1304	458	12463	16196	jwzzWcqf8i3TcYs7b5fYHEeVJdYWv6xhSGJzCA5UxRbCC8Yj1Jg	12079	16995	16995	1618998300000	orphaned
28162	3NK4Akk4sZCnjd8vK1dKFZX4jQJhM4o8Ddg2sY3CZM9mKa3ns4Sz	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1631	794	551	12463	18974	jwLpVS21R9t2iBCtjyFNs4r1s6vLb2EEtBAc42uHXbrTLBjtWdD	13925	19635	19635	1619473500000	orphaned
24285	3NLn2FtCaCvnJ7FfUXuHKugLcy58Eti6PdKfPhfpZDMVf8AxS3Kn	23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	1405	849	445	12463	16197	jwfASrdSLB34Wq6cB9jNtXYkwSFQ9kiVJTBZ5GPQBbbjkmN6m4U	11805	16995	16995	1618998369469	orphaned
24297	3NLfBAnBmD5WhTk6V4Sy5c92vNQKvxyMqq69NCS2wUFc2gk9mqiz	24216	3NKLutWnWNs71UzQyzGrRLRRHosypRSi4kXVmw37iUD3y6uLryT8	1594	1200	457	12463	16208	jwMZ3QdwH9SfMLPdGHCSDeWgidXnUmNCES5Yzs1AgnMB23v3U4K	12053	17003	17003	1618999740000	orphaned
24274	3NKNWFiFcy175UPudKLtG5GJrKG5Eo5f5BhfHcBjrqMutuzUrpd9	24272	3NKBfxqhJpBheFwrqJKvqUjyb918npB4SoBqvzHvw5Ttez2skdwN	1507	1154	458	12463	16186	jwwW9tZ7A4QofFwK59B5VnRXgz9LGBfVs4LXFL2PuN7BSyYGFu6	12077	16993	16993	1618997940000	orphaned
24276	3NKxCJvTaWV5hNBC2SusRYm8jdPaJJUceweTdihDaYXbQ5AZKj2V	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1406	1393	458	12463	16188	jx1PXhWZvkQivkeDjm3Qs4dVzX3hxY4FcDqzv6JPh29id6gwK7B	12078	16994	16994	1618998120000	orphaned
24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	1406	1393	458	12463	16200	jxTSQEHoVfbqUtDoxaLVhM93KnvLjcSJWBEfRHrCB437oaFqVfh	12080	16996	16996	1618998480000	canonical
24290	3NKa5mxTYLR6BNeZmDh9eDwudVKqNdnhvjhobiU4JNWDygyD7Aqy	24288	3NKB2joSi6Eudiw7L94UhpaoBDZ6aq1hqNvNhdf8xopPnHUpYVrV	1426	1364	458	12463	16202	jwRthuhfneRF6uBUjiVZoiB5vevBrb8vgjwhTiMN3zDXDc5EbSp	12081	16997	16997	1618998660000	orphaned
24292	3NKvzzjTik3NPaet8KbkqDYXHZ4BRPjoAF6jdZU3tT5bfCZvLerb	24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	1406	1393	458	12463	16204	jw8uALZSAVm4xhK27ukizCSpB7muY7HkbpvyfRzB7U2fwCMH2rK	12082	16998	16998	1618998840000	orphaned
24295	3NLdM9cm82jo5H6Smc4x4ztZ8FH2Vaw2ue5ifSjfxPWdx777KmHG	24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	298	1308	458	12463	16206	jwHopecgvVndtwwcD7F3zYPWpAwLvLBjWtf2rR6KdrLheFJyd9m	12083	17001	17001	1618999380000	orphaned
24298	3NLowPCP6iepueVKSuc9BTqdZqrqJmws7VBZTXLigH6ACfCePjVZ	24294	3NLaqmNw8VHiKAxscfoi4WMKM9zPqWHMn4ELzTQGyLxK3kq59z7x	1402	892	458	12463	16209	jww1ee3a8aJgHsFzfw8oet8C794sgFfWmpUqwJJUKKzNxKFYRNR	12084	17003	17003	1618999740000	orphaned
24302	3NKuQUTpyEHUabJ2GX9EfaDczRTznaH3feEQBMuPwkbQJeQS9gWR	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1670	1282	458	12463	16213	jxfBVhM3nPGFPRyMRGRzH26Z3XmTZEzch9tkJ6UsZXhrFfiCLJd	12086	17005	17005	1619000100000	orphaned
24303	3NKRH5LL1Vdmzk7udzF2PzB1naF1oMgBXm9E1CtQ5VZTPWjFvsBp	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1501	994	458	12463	16214	jxzi7FecLEW8p8EV9rAyUDCCXMKhi4v1YStFC44LpuitxxbQRpU	12086	17005	17005	1619000100000	orphaned
24307	3NKPLSxsvbjL64MH9LrtpjB7mM9CjRBAC7uGKDnNdHk5GZW5g2gN	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1637	816	458	12463	16217	jxXkndmfkUdBBvERccVdMUhJ6BDqKaSBNux7E5QxeVTqCgXGngy	12087	17007	17007	1619000460000	canonical
24309	3NKn9itBn8gHHeqBfVQLVQNuAT6gqNpASmFNpqaPWJx1k4mGz72C	24307	3NKPLSxsvbjL64MH9LrtpjB7mM9CjRBAC7uGKDnNdHk5GZW5g2gN	1406	1393	459	12463	16218	jwfmXLzmGnjeNusr1571fKpdj8jUa3yCX3R8FrKFAgCST64RFDv	12088	17008	17008	1619000640000	canonical
24312	3NL5ho2u5FyeJv5rC9Ewa6N3k9cV7MGhNP7hkiK4YbvHqQXwhFNa	24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	1406	1393	459	12463	16221	jxJKyLvhE23uKPXxGamaeQ746mqn8ZGRTgQXDkopBQPy8iLtF3N	12090	17012	17012	1619001360000	orphaned
24315	3NKwepMPi29rT6R767vJmLgETUhA2Cyx85TBgJDU3wmNFavzQaaB	24313	3NKpdH2k74zqKSNAjeG1P2goqFALnvqWYWmTSzYtKnHS3xaaNH1U	1458	1077	459	12463	16224	jwzWBBxN6TzmpmNPcrXU18nY1DtPMcm8rpjJf2j6Vhk3tpj5NkU	12091	17014	17014	1619001720000	canonical
24314	3NKFprmLkfXFohJMEYFbffW6HLkA1HGRpP1hdnkMvpX2v6ax7Mj9	24313	3NKpdH2k74zqKSNAjeG1P2goqFALnvqWYWmTSzYtKnHS3xaaNH1U	1503	1277	459	12463	16223	jwxQau9hznnB2553SoBMk2p9a7CJwjNJ5qZSczfxq3n7bwstyCo	12091	17014	17014	1619001720000	orphaned
24317	3NLYVs8qGPLTkmvbdknrt5C5bYYppUfxX2Txqw9GjaEooZr7Qgta	24316	3NKJSbEycg12JJhbj91YPLx7DT6Y2saFnHVQt8wy2HAcZ5v4LMU3	1631	793	459	12463	16226	jxjb9wzNcue8my3eDwxyAsTQai2Xjaqu3zHqtRt8tGCT3vcRyGA	12093	17017	17017	1619002260000	canonical
24318	3NLDXVNWr16VYhWsvMhPnsyTeqVaTFFhfGasriXJuxvH1AD2hk7x	24317	3NLYVs8qGPLTkmvbdknrt5C5bYYppUfxX2Txqw9GjaEooZr7Qgta	1422	1211	459	12463	16227	jx6bzZFG443ffmKGkrA4CPehoPHM7ny5M2AvfxcPbWrHiupFAhF	12094	17019	17019	1619002620000	canonical
24319	3NKVvzte2NhGGn3dmUt3amP1o93uPqN9PjV8WeCi3Evw9HU7d4B2	24318	3NLDXVNWr16VYhWsvMhPnsyTeqVaTFFhfGasriXJuxvH1AD2hk7x	1541	1298	459	12463	16228	jxFU8ZAgd3NQJfvejH9PejGqSpu62B3ni7Ya1gy3J5cqhEtd68N	12095	17023	17023	1619003340000	orphaned
24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	24320	3NL1BxK886pvX6M97H7JZbK2WDFCNS9mUXXE5fXmN6creVNWZNjv	1403	812	459	12463	16229	jwQdBJSRq1iNTADERULZUm1koVSjHxwqVpVmaqLdRWngGB2du7w	12096	17024	17024	1619003520000	canonical
24323	3NK9ogQV4bGZdZAH9kBYFevqGzuxJvLxZce8C9iqwukfEcR6oakY	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1672	1159	459	12463	16231	jxc7EBM6D2qGoMweQcCyyBt1GpyU2J7UjFFqscRFz38y9Q8xvJL	12097	17026	17026	1619003880000	orphaned
24329	3NLod6Zv9TbRq4RSmT45uFTatpEjv7pGWTkDGXijpf5veu1MWH7B	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1637	816	459	12463	16236	jwAGPB8HbzP5NLswdMTBjoLmKKABHeW32Nbn4eJ8n8nGs2hC92x	12099	17030	17030	1619004600000	orphaned
24327	3NLuHJgeDh7YY8Tpm3zyDuXdBJaX9EmPXYufsa6opWqZEXJyyBFU	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1440	1377	459	12463	16235	jxzAHfU4s1V9y1WZAuHEurfNxCCU9yVeT38SZE4ED4wq4R8r53k	12099	17030	17030	1619004600000	orphaned
24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	24326	3NLP3Ek59EKmUMU93nRVFcHGqhM1cptTYgxYf3MaikeUs8Y8muTs	1483	1030	459	12463	16237	jw8jKinufkKQ7EjnNSkbhA7ETJdxhzXQbhM35zAsNvMnf8xZkJe	12100	17031	17031	1619004780000	canonical
24335	3NLGw2n6J7YffQgoSgvx3BB91yB7kPcZ7qLZXhuYoybqmjgJeAoL	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1501	994	459	12463	16240	jwgHwfe3T12v94aG3X8Cn7m7j6tQ1nKAguEP99rZCfgdcwk4JxZ	12101	17034	17034	1619005320000	canonical
24334	3NKbvznXXnRLXBQQ4p9t1ZZFUriTwb5ZD6g1CCkwwgyZD5xKbrnA	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1402	874	459	12463	16239	jwfkUorBiDq1D7PMxJFfprJQrXB724P6NCtBMq18XYKozT2pwem	12101	17034	17034	1619005320000	orphaned
24332	3NLh1cqX7XrCdmdkwFLVRs6MriPvhLmzPeqCv81LNFNHz7ip3VQ5	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1523	955	459	12463	16238	jx2G3pgwrwdvWNfsDVaGFRV234hURGXeozasDaQkzr6n2TJW5gq	12101	17034	17034	1619005320000	orphaned
24337	3NKHs9KvDSCuJWyawRnwHbeganACfXjcrjukfo3RewEzSwsrzU8J	24335	3NLGw2n6J7YffQgoSgvx3BB91yB7kPcZ7qLZXhuYoybqmjgJeAoL	1406	1393	459	12463	16242	jwd5k1wQaN9k5vtifEnQja1SWzcJzPZg74fKd2XLTUhqj6KUZVH	12102	17035	17035	1619005500000	canonical
24339	3NLtUcLTD1bMQ6nUSNuioT4hGW8CYR1UCW9wdXT5j3QDaLkcubzg	24337	3NKHs9KvDSCuJWyawRnwHbeganACfXjcrjukfo3RewEzSwsrzU8J	1406	1393	459	12463	16244	jwQ9YEr4FduyDqsq7rCyGG9VdJuxDUDEraoZTB6L2BQgzYV4uv3	12103	17036	17036	1619005680000	canonical
28177	3NL7r2jNDDDgCwBc2uB3CMpiSUytmTGpeTsdbWaeNBG5jcpW3RAY	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1527	1047	552	12463	18974	jxeq6UK1iNgo1x6NXdQQYgPL34tWLDHK7jGKPJBrLr54oSU5r4H	13929	19641	19641	1619474580000	orphaned
24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	1624	1334	458	12463	16205	jxQSKzSTDzTxAqnR14zrS9ex8LYQJFGrgVM1jrsjNPAyHro6bvF	12082	16998	16998	1618998840000	canonical
24299	3NKqXKzVSxjfvpaVRzLJ1M63hfoU7D1ziuNbzUDYafJCBnJqwnsx	24294	3NLaqmNw8VHiKAxscfoi4WMKM9zPqWHMn4ELzTQGyLxK3kq59z7x	1594	1200	458	12463	16210	jxDx2gWbuZ5ddCfBw3NJNNSZoDRDDGZWmXzM3CtG5D9paiYf5ww	12084	17003	17003	1618999740000	canonical
24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	24299	3NKqXKzVSxjfvpaVRzLJ1M63hfoU7D1ziuNbzUDYafJCBnJqwnsx	64	521	458	12463	16211	jwV58guhC4G1EQrXcfH3pEWE1cCwwt39FNf8kKAevE822E6extB	12085	17004	17004	1618999920000	canonical
24304	3NKSk5WUzuEzDGwUMhLt6qqb5eQDJsKWxHygwd9mhBBuWRctuP3u	24300	3NKqX3MCFjDvd9bftB2b6kPVNRadWTJ6Gnb3GXmBRuj1DhtkrNJR	1560	1291	458	12463	16215	jxffngtQFsuprzKd7BYEx9vihsfCbVNSEE8GGBLunJZhCam1S7Y	12086	17005	17005	1619000100000	orphaned
24305	3NKULhKKPYa4KBKErWhhQLV1BtLsen3W3nxMhknKLSjjori2RCdb	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1668	1244	458	12463	16216	jxTuLMmQaHgtMiPYU4qmWT88r2FwE5sgAbpv38gwfxP6dKzFDXA	12087	17007	17007	1619000460000	orphaned
24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	24309	3NKn9itBn8gHHeqBfVQLVQNuAT6gqNpASmFNpqaPWJx1k4mGz72C	1602	1003	459	12463	16219	jxjapAJWUuN63ksatLEPNvdAnyqr6JSRKSD6eYcrKwsBNCcRt8o	12089	17009	17009	1619000820000	canonical
24320	3NL1BxK886pvX6M97H7JZbK2WDFCNS9mUXXE5fXmN6creVNWZNjv	24318	3NLDXVNWr16VYhWsvMhPnsyTeqVaTFFhfGasriXJuxvH1AD2hk7x	1541	1298	459	12463	16228	jxhx1m7ixGiPaWf4ZDxsEBjxdjTMbHienRL8JGBQ9QRhsLUkpDK	12095	17023	17023	1619003340000	canonical
24322	3NLe9rGmzTG8ZE5CqiFRL2tfgPrvAUuKJnHsya9A31LEv1cpbpqc	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1522	1322	459	12463	16230	jwB7hsmBPcU1Uh3dV78746oVG64k5goZhWfLgfmDLRZUg9tGVdR	12097	17026	17026	1619003880000	canonical
24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	24322	3NLe9rGmzTG8ZE5CqiFRL2tfgPrvAUuKJnHsya9A31LEv1cpbpqc	42	1361	459	12463	16233	jwCuuYB9o4rugDHEdcMdPUqYJgE9bpQqCL2ycQ92hoj5h3ZPW7V	12098	17029	17029	1619004420000	canonical
24328	3NKgE3FLY496v5dGuRm73rFQ9Tzd6xL7hbMjV4BapnbfytpZemyZ	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1440	1377	459	12463	16235	jxdwaFt86aDC2eSbfrteFUp2Gv8qxxTQFifZVKXh6uqbeFmKixX	12099	17030	17030	1619004600000	orphaned
24333	3NKt6h8tWgNrYPzzCNtfmwButfJJcrJsRzQ6MiFyT4BPA3aptZkT	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1523	955	459	12463	16238	jxC7M2ui2LT5MPUqc7U7yK1DtLDCFf5xL4KeqKfn7t9Xh4Y8HqF	12101	17034	17034	1619005320000	orphaned
24336	3NKfhVxEdjTbqaC1mzs7sFTTiAscXufPF65ABf2i2ZZ5dU4J9CxS	24335	3NLGw2n6J7YffQgoSgvx3BB91yB7kPcZ7qLZXhuYoybqmjgJeAoL	1671	1119	459	12463	16241	jxRFnHpeNuQqVSYpbPeqLCqSetdtW6S48QPpMzxKVPF659yDihP	12102	17035	17035	1619005500000	orphaned
24338	3NLNEE2EYaiUKxkT5JtyoreKEcZzf6xYPoyYeZAxm6Vv9WCjdkSH	24337	3NKHs9KvDSCuJWyawRnwHbeganACfXjcrjukfo3RewEzSwsrzU8J	1608	582	459	12463	16243	jxUrNMVkqdNfuHN6Er4LkrQ9GRfjwJCHxgdQdQvZG4wPryCaD3q	12103	17036	17036	1619005680000	orphaned
24341	3NLNarX1g39y39tyUXLFknGMHNPnM1VTjmUiH3zvYHjHEa5ndBEq	24340	3NLAQQEA3YwG9Vtbk1MjFiPpbXFXovMew8Mxh3D6eRVhaf5gBSm8	633	1018	460	12463	16246	jxPeTm8EYqgzgeF8Wosou6Aq653gbiuDzTzKk2A8Y6QqEVvw6sj	12105	17038	17038	1619006040000	orphaned
24343	3NKB8Bq51Rnetkn8SYgbqyCiJXJJnvJq5hVMBubcvPFDecH66BDR	24342	3NLkP9Bnsywvw8oWLpeD3VHgkmiQbdEWZWQJ14hVHuyLj1K13mdC	1406	1393	460	12463	16248	jxjvmZ8ki4mpSnvDLZGs4AghS9Fje2vVmWRYYXqAL81Ug3Q1Erc	12106	17039	17039	1619006220000	canonical
24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	24345	3NKoQji1u5gY5Y6tv7cJHi93Zm8jdQh37NjUNiddyq9X4qSgUniS	1668	1004	460	12463	16251	jxM9EVHvgDWqSCTQYpE7xEgCNB4dcjeVnR85cifuXXKVGuZs4WU	12108	17042	17042	1619006760000	canonical
24349	3NKKGcNuAznukXAqRTxoonZXkmr1S7adDDPPW4rrv4uU7wpgnDrc	24347	3NKJtX4hk5bgpLpd5DxbR3i7ZKEMthGfqVhHAeLgH1eUirLGLwWn	1489	1014	460	12463	16254	jxwiQST4PAj6HfbEnENXkhmEEQ1AwdMFwSBVA4s2M1LV3FT2HMM	12110	17045	17045	1619007300000	orphaned
24353	3NLVWBTgzebhqrD4sRH472wB36Q4gvgGsA2F9okAqfYvs93NNNC8	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1523	1195	460	12463	16256	jxWs4CEvA2N6RzzWn2Wk2cu4YSDBmnRceRS1A4S2hixfpHCUX6Q	12111	17046	17046	1619007480000	canonical
24351	3NKonqEHReJFessXYDyXaR1TuxYybqdwSuvwDF5KDzNswboJqgV7	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1523	1195	460	12463	16256	jwwWeBg8yGuyyx6E9giDyAZVk6FH3s3n1eTofoqUfyEyNbmaNwz	12111	17046	17046	1619007480000	orphaned
24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	24353	3NLVWBTgzebhqrD4sRH472wB36Q4gvgGsA2F9okAqfYvs93NNNC8	1407	1395	460	12463	16258	jxiZh5fVEgksVwbV1o8mQXnMTiVFQN8zRdPsbPgWSWu1y9yH8dv	12112	17047	17047	1619007660000	canonical
24373	3NK3WKxVoKY5ocywvFhNxkB1KE34xQNuTQzTAcSNrMmxVFZZqha4	24353	3NLVWBTgzebhqrD4sRH472wB36Q4gvgGsA2F9okAqfYvs93NNNC8	1602	1369	460	12463	16275	jwsSK4NP1cVsNsTUFGa8QZRogjmv9xi3UpDGbe4wTqpx4f2seu6	12112	17060	17060	1619010041887	orphaned
24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	1651	1175	460	12463	16262	jxvMBqoet4VxGF3ijNCwYuzFvUTWT3L32v6SJAnGUoNhdHcErrh	12114	17049	17049	1619008020000	canonical
24358	3NKvz6iTsJeeMQ9u2e8wTMneVrbxmzSv3K2jNgAzSR9HYVHWCyyz	24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	1627	1139	460	12463	16261	jxMcxz5sYQGpmq4fL9k5bJcZy8NxgBhnh3Bqgi6GyFKqrvEMHzZ	12114	17049	17049	1619008020000	orphaned
24362	3NKm5ZoEgBrmbCf7KjzCnPkDQQ5zzbDX5fXuXP6HwDCeqtfAjmsY	24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	1637	816	460	12463	16264	jxic6cqRH2kL9XM45CTXrtxMdSc7MwTVXmfpFGaNKxpAhCnhWJm	12115	17050	17050	1619008200000	canonical
24367	3NKViy6ifMAcL7SU2avjipWWWopBJGUPLdkMXbspWYk5H5VHUG2n	24366	3NKTyrfAZGkrTcwyqiofY3t8WaJNwoswaKGkKJu5BKuwYPgQWUPJ	1673	1242	460	12463	16269	jxiMUqiVUgEBjakdm3HV3Cmvu6CWtiPbewLCtCP1AUdEEdMDUdd	12119	17056	17056	1619009280000	orphaned
24377	3NKPqR1xyg6cZpGFmRLTdGvCbvEjS7kk3LyGXzj4pLbi8Mt5HANv	24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	1652	1189	460	12463	16279	jxj9znqQ8VAQBktFToM29CitC7qx2RNtxUaGpr8jah9zaAyh7uL	12123	17062	17062	1619010360000	canonical
24380	3NLdhY1aUzrJgU25wpaZDxJfzrizQrnSz1fwDsfEyj5Y5CWQznHu	24377	3NKPqR1xyg6cZpGFmRLTdGvCbvEjS7kk3LyGXzj4pLbi8Mt5HANv	1637	816	460	12463	16282	jxShuChidcdgcnjbCrmQgnxD5Wruts83FvQqPuMQsuYtSRy7Zd7	12124	17063	17063	1619010540000	orphaned
24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	24381	3NLwE8Gu16k6qJ4oSjqfeca2r5MR8QcahCaKZwjq6ti9XBqCRYoq	1608	1163	460	12463	16284	jxZc1reKzEgfDNeWVebjqEAf8p68rAwPsk7cAx2ZiYYbZAKf75s	12126	17066	17066	1619011080000	canonical
24383	3NKz5engbaXWvkh6Bb7hE6MWuBSjHziBCEcyrQnTyxJx9igbXM2z	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1419	814	460	12463	16285	jxZc1reKzEgfDNeWVebjqEAf8p68rAwPsk7cAx2ZiYYbZAKf75s	12127	17069	17069	1619011620000	orphaned
28179	3NKaTStpetkiFCsfM4G7vZLZCT2gHfKbXdGnvG4RLP6tm675xy5s	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1607	1348	552	12463	18974	jxxBJPQgXKEvXfhGXcRe4kuZbryUvn7g3ep1P2GYi3GLD4Q1KdF	13929	19641	19641	1619474580000	orphaned
24316	3NKJSbEycg12JJhbj91YPLx7DT6Y2saFnHVQt8wy2HAcZ5v4LMU3	24315	3NKwepMPi29rT6R767vJmLgETUhA2Cyx85TBgJDU3wmNFavzQaaB	1536	1067	459	12463	16225	jxmTF7gH3ZbLksxMcXqDEdCfixp1sj6GibHNFoBbAq71VWT1N2k	12092	17015	17015	1619001900000	canonical
24324	3NLWow4MfqNLPVrDZ8k9h3HNYXr9TPa2zSWMym4JUzxFsvJW4PQB	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1594	1326	459	12463	16232	jwpvDWKir1ApZ683ZfLrvK41yvQLrYmAxC8JzkpFnsvJNktY3BM	12097	17026	17026	1619003880000	orphaned
24326	3NLP3Ek59EKmUMU93nRVFcHGqhM1cptTYgxYf3MaikeUs8Y8muTs	24325	3NLUU1MVuK6fb4KJVEbuQqeAuYZHJQhAEwt3KbQyrzF9JMnQzuw7	1503	1277	459	12463	16234	jxt4qaiSuXQBurzwsQUT9w3WDis4Kyhr6EJDe2e7yAiSCzUPRfA	12099	17030	17030	1619004600000	canonical
24331	3NLrQjb61HuHGUo56CwaQB2fgR6rfpogn2wsQJEjKcZ1GpuvJXgG	24330	3NKCTBBR65zj4pE1R7wDmNJQjnixBBdVTRWb8tyyaoAbWZofRMyQ	1523	955	459	12463	16238	jwRfcBqHU82S3kKfkBE4FtGver5DmfPkMBS2UsEb1C8vk4pQUZ8	12101	17034	17034	1619005320000	orphaned
24340	3NLAQQEA3YwG9Vtbk1MjFiPpbXFXovMew8Mxh3D6eRVhaf5gBSm8	24339	3NLtUcLTD1bMQ6nUSNuioT4hGW8CYR1UCW9wdXT5j3QDaLkcubzg	1637	816	460	12463	16245	jwT6WnL1rMEJj3R7eZ7PLJssRJCr46hmk4zdw8qc7TXnsTLovZq	12104	17037	17037	1619005860000	canonical
24345	3NKoQji1u5gY5Y6tv7cJHi93Zm8jdQh37NjUNiddyq9X4qSgUniS	24343	3NKB8Bq51Rnetkn8SYgbqyCiJXJJnvJq5hVMBubcvPFDecH66BDR	149	1283	460	12463	16250	jwLpVZ6ZCi58JHn49PprXhry3tYAETUfqLaAGcsz1Wpt76ufG2x	12107	17040	17040	1619006400000	canonical
24348	3NLYGfbtkrXG5mpt1wTmScFVt7UXPqr1osKuUPVug3xca3BwNWBx	24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	596	940	460	12463	16253	jwbe9UXNpDjgqL9fTL9yCkL74QiZNcBEWsv2pBQkfyTSLgeDhLp	12109	17043	17043	1619006940000	orphaned
24357	3NLQGPtTZGNieMaChT4Ta3r3jQZ84gDKAvobLGZSk6VzeuPsuzze	24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	684	1352	460	12463	16260	jy28b5hcxrnaKaNwChYiAhsxh7EWSAjonEbakBBspadWtDpbAGa	12113	17048	17048	1619007840000	orphaned
24361	3NL96AFsnRzsuoCBerEBSsG6RfhjuYccdEJ5wYBRqcUKZUxGjPK4	24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	1581	778	460	12463	16263	jwS36dzxhxNZQKFAMyZrXA5mPvdfErPotgHohMtS4QdKVwBUs58	12115	17050	17050	1619008200000	orphaned
24378	3NK82LixrAXsTaD63Z2L6ECEhvJQfvCdPj8BxTbrYN3hDhxwMN5K	24361	3NL96AFsnRzsuoCBerEBSsG6RfhjuYccdEJ5wYBRqcUKZUxGjPK4	1476	1371	460	12463	16280	jwpos72niAuSy2h8nCRamZTRfmTZtzsH43EE33BZVc4mD9uc3Xv	12116	17062	17062	1619010360000	orphaned
24365	3NKedrjVSS2d7PFhh1VbGyR6h1DuhMvcy8YqVtsQwRDHD5PfznpK	24363	3NLLWwfT8p1Avjuah1HaPrSsFYg2QADXC2pDkVSkECYwh5fcdtbs	1581	778	460	12463	16267	jwFYhtySXcNvnQGnGQ5N5zEx66oEgfLbConkWRN7UQf2TzshQNh	12117	17053	17053	1619008740000	canonical
24368	3NLqX1YiimvUAqeQEpg2ggNgWL1efeJZr1S1jXyvNqfaYJHRV8Fx	24366	3NKTyrfAZGkrTcwyqiofY3t8WaJNwoswaKGkKJu5BKuwYPgQWUPJ	1406	1393	460	12463	16270	jxUsYK6sLA3wmNp6PzhVSNkArL2FB6rotge18nx5QS58hbVQNbv	12119	17056	17056	1619009280000	canonical
24370	3NLMRJy76A6xW8povCt6Z7Je118bheZFdvDzY9znTVhMa79tCrED	24368	3NLqX1YiimvUAqeQEpg2ggNgWL1efeJZr1S1jXyvNqfaYJHRV8Fx	1623	1623	460	12463	16272	jxfLzvhHTBsDV7kGBq63xmdz2HGtnjrdtB5Y3rMWjW3qaqefs2K	12120	17059	17059	1619009820000	orphaned
24372	3NKNyZqXxoMaDrS4VWzBvNeZbauUjBHwAEAsyt63Pfsce8AwxAnM	24369	3NK5Dzm7vZ7MkQTA32J1GGDEBrnjdxsohg34v152n7VLF2p7F7Rx	1602	1369	460	12463	16274	jwebUt9TJcwNHNvoQqVVFEYqtCVZejbs7ztbY1HAP6mJHQbVAxW	12121	17060	17060	1619010000000	canonical
24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	24372	3NKNyZqXxoMaDrS4VWzBvNeZbauUjBHwAEAsyt63Pfsce8AwxAnM	1652	1315	460	12463	16276	jw7cDJszZ6p2ryufRGSnbJ1KDFts9B5tYdfZLy12YmBSHAbf3M1	12122	17061	17061	1619010180000	canonical
24375	3NLizJF9aMaiU88fj8MhHCRUE6Z2fTHnRUAeKJ699WPMdgs3t7MC	24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	1406	1393	460	12463	16277	jxzEb5VKw5WErKzx7UGDHKjRvpjWezMY3amCksXXqEqKxuECUzW	12123	17062	17062	1619010360000	orphaned
24379	3NLcSZsMEPPm5Vxkwb6PFJN5ZcZ9mU2ZzW8hfgLQs3ibpkYn9zgj	24377	3NKPqR1xyg6cZpGFmRLTdGvCbvEjS7kk3LyGXzj4pLbi8Mt5HANv	1483	82	460	12463	16281	jwvpQK4nNWhYrjhnCxgEtwUmTK7RmWTQXdbL1n21oTi9WSkYvYw	12124	17063	17063	1619010540000	canonical
24381	3NLwE8Gu16k6qJ4oSjqfeca2r5MR8QcahCaKZwjq6ti9XBqCRYoq	24379	3NLcSZsMEPPm5Vxkwb6PFJN5ZcZ9mU2ZzW8hfgLQs3ibpkYn9zgj	1656	1097	460	12463	16283	jwRH2RBSvNQ3ybzPBgfqeBvRbK2bG3gZdhrL8sqnFLLLPb7SZxW	12125	17064	17064	1619010720000	canonical
24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1460	273	461	12463	16286	jxiMUTLPK5o4tLbLfEp6xcPUpLs4CA77UZQX93xwJfKT2bmuyPX	12127	17069	17069	1619011620000	canonical
24388	3NLVoeYErL9WMvsGKQwuqA4CYkwiBKfnRemWL8vX38rvpp3takXb	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1439	913	461	12463	16289	jx8h2uasRunuLzQ6VFqzxtG55MSaRLBh2nLLDoPbEoBHuooPTTQ	12128	17070	17070	1619011800000	orphaned
24390	3NLb7PKeswTR13tHKX8Ysr5HnrErv2G1ScJUiWscMjTuKFsVR2fX	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1637	816	461	12463	16291	jwE9CemaREt8ABeJT18nHPMMpMwKW11QntVmniV5o478QfskJ1D	12128	17070	17070	1619011800000	orphaned
24391	3NLLYhtDPo4P3RqAL5Yog4o95ZwKYejcAtc7ttm3atU3gNc5Utd2	24389	3NLiEHJuZrcNPyUQJA1kQ2XiroqVgXAb5XyH58bnMn9ESoQFzE3m	1608	1289	461	12463	16292	jy2hiV2sBDDoa9D35gDPqzoBczZ3Zqz1GwTccv7Z1pe6Euz9nfm	12129	17071	17071	1619011980000	canonical
24393	3NKiDCboghXiFxezKT6StbvFTiLFvhdaJXtnAfZZHmjtCjXkE2Gg	24389	3NLiEHJuZrcNPyUQJA1kQ2XiroqVgXAb5XyH58bnMn9ESoQFzE3m	1403	824	461	12463	16294	jwmYV3uVhe44Qf4ib4EKn9GNmHvDmPrmdAg8LH4gs4jNJ1a83xy	12129	17071	17071	1619012068195	orphaned
24394	3NKUPQigwb2AXahcmyahsHMoj1uZr8V4mRu7sYeHuep3eyZWa7Yu	24391	3NLLYhtDPo4P3RqAL5Yog4o95ZwKYejcAtc7ttm3atU3gNc5Utd2	1490	908	461	12463	16295	jxMkNFSMHkkHNh9WMqywt87uyY2krd742vLJ3mDXpJd9oPzwv7L	12130	17072	17072	1619012160000	orphaned
24401	3NKd9qfHhgKZVLMsc3TgcgKehr7nHHp32cq9hzQnDjSesPVbfMTq	24400	3NLkbSoCo3Ha3RxGYPYKjJtGC7cbekqmpPuMaahPd1z66jHXzi2D	641	1090	461	12463	16302	jw9BBC6NUt3g5UtupoSDookbMxF62P9uvhwE3y74EjZCgh9ExHp	12133	17076	17076	1619012880000	canonical
24404	3NKJA8AobEMpm8YtCVSWjHAyH1inXFGy2qaFNs37qmBLgD2NHs99	24402	3NKcJis3RPxcRK1QdXMXtYi6r1orBwo544pRN21NYRkX4UyV3TMK	1581	778	461	12463	16305	jw76RtB41X76dMWVa6DZoXULxwDDnqiBsrXxtbG6kmq5S7mCMGa	12135	17078	17078	1619013240000	orphaned
24411	3NLyS9UhXs9HhxMr1zsVW1fAizM1WMHcE8k4VVgy174JYBQLLxV7	24409	3NKBS49x1pxPyUxMoC7WAMDHqjTTvac43wg9LwR9yhSECrix2GF6	1406	1393	461	12463	16312	jxqvgsvm1USF7cVp7DbUVBmx5sEgpoK5XHTSUa6hWXK7TEgmdqj	12140	17083	17083	1619014140000	canonical
24419	3NKAxw4sYdfAvVP7mdicjkM8fxhcXq9JfT4TwcLt7WECHwtZYNNE	24417	3NLNtH3ob8mCwLqtxwUh6tQrcANCyWdCXtiNLsFrPg2GuRryX66g	1581	778	461	12463	16320	jwRQfKWeYgCRgkJb8nCSjWYyANctvqwgznbdEXERNoueurW6T6H	12145	17090	17090	1619015400000	orphaned
24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	24423	3NK8L9V1SSs7N3AV5SVjZEgxnVV7cynpwvQNfS83GMuMRvDKzT5Z	1650	1375	461	12463	16325	jxfxTmcQraCKP5Ytd8nTGRrKoS4KXb9mTkaWqPtAjLvb694qxMJ	12147	17096	17096	1619016480000	canonical
28186	3NL6NctReexZqt2tKYGQiPxvWV37qUKKN6khoHcitcb6SipAesd5	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1637	816	552	12463	18974	jxkQhXyGQpH4PVmQCFCgkaPztYVM4bQhUvwqELcdxFjNRZvyfex	13932	19646	19646	1619475480000	orphaned
24342	3NLkP9Bnsywvw8oWLpeD3VHgkmiQbdEWZWQJ14hVHuyLj1K13mdC	24340	3NLAQQEA3YwG9Vtbk1MjFiPpbXFXovMew8Mxh3D6eRVhaf5gBSm8	1407	1395	460	12463	16247	jx7DVaRhVAcuqshrYLqbrrMQZ4MgthPpZUjXk3pbKZLyejTcZDr	12105	17038	17038	1619006040000	canonical
24344	3NL15i4TxuPHDjREPSfP9ccDKestx8MKJx5iZiPUigtmWp7vUwty	24343	3NKB8Bq51Rnetkn8SYgbqyCiJXJJnvJq5hVMBubcvPFDecH66BDR	1406	1393	460	12463	16249	jxf9avrZ33jd1K2BnULnkDLH8PXw9LUb1txr5dT6TajcSwnF172	12107	17040	17040	1619006400000	orphaned
24347	3NKJtX4hk5bgpLpd5DxbR3i7ZKEMthGfqVhHAeLgH1eUirLGLwWn	24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	1646	1354	460	12463	16252	jxBzxV1GfBgiHBEc6kPUEwiRMJYARHJBJi5VHYjBgxiqM92vzhe	12109	17043	17043	1619006940000	canonical
24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	24347	3NKJtX4hk5bgpLpd5DxbR3i7ZKEMthGfqVhHAeLgH1eUirLGLwWn	1536	1313	460	12463	16255	jwPktDZuigjLt7LREyP23kjeakMCZPEV7pVdSz7QZBXQ21pKTAG	12110	17045	17045	1619007300000	canonical
24352	3NLYkEaQkuotSdHVKbYsJ7Wd3bVNsEXcuzMVLCwEAH4Ksa5QCGkW	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1523	1195	460	12463	16256	jxY1nsHpyfZSJggzkZCiRkDoCxAuKVP5LkF3hZeSb7Zp4NK9jTD	12111	17046	17046	1619007480000	orphaned
24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	1483	327	460	12463	16259	jwp3ebs7cJNbUiJbTMPNiWLjGe86f1wnkBRSnQmdYnAyGY68wK4	12113	17048	17048	1619007840000	canonical
24396	3NKCZt5gDCsZaXXFSrpdrLi5dqh5Dc9Y88RtAqpAfs2mjK5LnFik	24355	3NKqXk12qv2jE8ziMKnRkKAmhLHcWAYRiUTRz1F45YcTmG8jBi5x	1573	952	460	12463	16297	jxT1jj3SqoqmakJtoMFruyibaFie1yPS4shqMpT3ft8ejmwB38F	12113	17072	17072	1619012160000	orphaned
24420	3NKR21VxAw6JC8uvtfzTSNjkUCrPvuCMCv7EPVyxPzYkfkerZ8Hd	24396	3NKCZt5gDCsZaXXFSrpdrLi5dqh5Dc9Y88RtAqpAfs2mjK5LnFik	1559	1107	460	12463	16321	jwNMKcmeswpXr7oarjrPDiiLADLXmEVWtR3SA264oC6phAK1MjX	12114	17091	17091	1619015580000	orphaned
24363	3NLLWwfT8p1Avjuah1HaPrSsFYg2QADXC2pDkVSkECYwh5fcdtbs	24362	3NKm5ZoEgBrmbCf7KjzCnPkDQQ5zzbDX5fXuXP6HwDCeqtfAjmsY	1553	776	460	12463	16265	jwhkmg34eWXtc55EpG1yAiXuDc3v7ZtXB1zdavRVEPjcw5mr66D	12116	17051	17051	1619008380000	canonical
24366	3NKTyrfAZGkrTcwyqiofY3t8WaJNwoswaKGkKJu5BKuwYPgQWUPJ	24365	3NKedrjVSS2d7PFhh1VbGyR6h1DuhMvcy8YqVtsQwRDHD5PfznpK	311	1307	460	12463	16268	jwvSiLNLJvFC4F5Mvj5Lu1kusPRk2Rr68E9HcJ6yN94N5aJKftb	12118	17055	17055	1619009100000	canonical
24369	3NK5Dzm7vZ7MkQTA32J1GGDEBrnjdxsohg34v152n7VLF2p7F7Rx	24368	3NLqX1YiimvUAqeQEpg2ggNgWL1efeJZr1S1jXyvNqfaYJHRV8Fx	1607	1348	460	12463	16271	jwUezu7NWMVhVgu8Hzo5LK6a8rm81UouTeHawSyUw772GWEoH2x	12120	17059	17059	1619009820000	canonical
24376	3NLrnYwjvkcBP2J1RKomcew42PaiLCjPHXKJvMwwRKSsFPfFoMKJ	24374	3NLTugEpQNmqnN5fPcpusCheP6EbQETVsY9CTeSsFXi5NSN2JfBE	1476	1371	460	12463	16278	jwNUL8FsoPFHPou8uiGir9e7L3UZWejVBTEg7D7evQ7S8vAUcjv	12123	17062	17062	1619010360000	orphaned
24386	3NKcjHyN7ffgM6jJJrM6V3vApy3GZeH5H8mJR1gDgFbohZgabC1n	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1419	814	461	12463	16285	jwBnYojMFtJTSf47x7WmSnY5skHZUQUtVGzoxT9PQWAPBm3bhs6	12127	17069	17069	1619011620000	orphaned
24389	3NLiEHJuZrcNPyUQJA1kQ2XiroqVgXAb5XyH58bnMn9ESoQFzE3m	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1407	1395	461	12463	16290	jwFKGqpQqVfDg5Riq9uRzDPHmskCDM27sVvFP4SpZGf5VvjcRQz	12128	17070	17070	1619011800000	canonical
24395	3NLS5LGmFWBrB6GjxC6tk3ySD4CMPDuRv55iLAhFbLafbcpsnBsX	24391	3NLLYhtDPo4P3RqAL5Yog4o95ZwKYejcAtc7ttm3atU3gNc5Utd2	1564	1212	461	12463	16296	jwiqhYDeKkeRLpBJjSHKhu1i6nGUiMaWxj2WThdMH7RBEdU8Xxj	12130	17072	17072	1619012160000	canonical
24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	24395	3NLS5LGmFWBrB6GjxC6tk3ySD4CMPDuRv55iLAhFbLafbcpsnBsX	1536	1313	461	12463	16299	jwg9J7Epsiqd4cpVSJySF77ZxrvWYLfMEZ1RziVF1JEtUJweQ7W	12131	17073	17073	1619012340000	canonical
24397	3NLsYGgWsurzMmvgacS2ipz3yXEnhfvP8Bd9jmXdGGsfWE5GZg5d	24395	3NLS5LGmFWBrB6GjxC6tk3ySD4CMPDuRv55iLAhFbLafbcpsnBsX	1422	1091	461	12463	16298	jwGtfe8PPADc2xviA58UHSs3sqQvTZokE5taRBdTRoiwfYQ5YQR	12131	17073	17073	1619012340000	orphaned
24399	3NKbRmdZsnUPpEv2hKJ5zUQyEztEDNje2aWTXjL4YQ6a2LKaoWBa	24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	1652	1315	461	12463	16300	jw9Xz7s1d8vjLV4BEqFrMhPz9M5dN5g6W16g2QjgyH633Urx9dY	12132	17074	17074	1619012520000	orphaned
24402	3NKcJis3RPxcRK1QdXMXtYi6r1orBwo544pRN21NYRkX4UyV3TMK	24401	3NKd9qfHhgKZVLMsc3TgcgKehr7nHHp32cq9hzQnDjSesPVbfMTq	1407	1395	461	12463	16303	jxXg8Q2pW42hmWtgZM5NusQyPEihQuKki4UEuS9PQncXjCRVb6X	12134	17077	17077	1619013060000	canonical
24405	3NKNAAYwqxZYo8MSLcp6ZoEf2NWypDxhyGWRaS2zq7zm2fzhDT89	24403	3NLJndU862yGgh3EhbMSmhWKUC588D9AEXPEHNu4bAuWz9Dbaj7D	1444	1255	461	12463	16306	jwzcRF4RXdgmTzghD7ztRQiR7E4eL9VGpQdMfmcAKxXqiZ7UPrR	12136	17079	17079	1619013420000	canonical
24407	3NLG2S85W6oW1UpeMLVvZ4x3XR6TeYK51kUNEQPw71J2wNABnaw3	24405	3NKNAAYwqxZYo8MSLcp6ZoEf2NWypDxhyGWRaS2zq7zm2fzhDT89	1406	1393	461	12463	16308	jwspYKxSxQ7xdGvQ5c9gpGMZhJTUz1QP6NHsYHZMEV2yQEkrWMK	12137	17080	17080	1619013600000	canonical
24409	3NKBS49x1pxPyUxMoC7WAMDHqjTTvac43wg9LwR9yhSECrix2GF6	24408	3NKUvgQBYwuLxZ45mQZYuWExBj3nZsgvrsRmKBKeuqMpZz6ftiB8	1553	776	461	12463	16310	jwfwu9kU1VTzARaRU73hjq8HcSnaz7CR62NgEbXJVKm3yoiC2An	12139	17082	17082	1619013960000	canonical
24410	3NKDhsVDv9ti1Yn6CHT9dUhAiWnRj9gGDbtTnEbycRWoAunVm8G3	24408	3NKUvgQBYwuLxZ45mQZYuWExBj3nZsgvrsRmKBKeuqMpZz6ftiB8	1407	1395	461	12463	16311	jw9Heyvz6DwaxiHMHxnzWssAZvqgcDpM7PCSSxYsJmunxkk5qSf	12139	17082	17082	1619013960000	orphaned
24412	3NKBVEGR87huQ2rqAVJZ9TbRxxMf3qQ7H4GmwRbyMgQEHHdMm6iR	24411	3NLyS9UhXs9HhxMr1zsVW1fAizM1WMHcE8k4VVgy174JYBQLLxV7	1542	1304	461	12463	16313	jxiRkQ62KJLZ8jq4wwwBLvZXtsAWSroviQgnC5sjTMwx13CKjfP	12141	17084	17084	1619014320000	canonical
24415	3NKTC8n7rtLP3G6BVRoQ53XT8fhXVDhEujBga4Tj4v9sjUs3jz3V	24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	1547	1252	461	12463	16316	jwoDqRGMxFnCmEEc7RGxKgqYu43tRdVof4nffdMy5BtsFL1oaVv	12143	17086	17086	1619014680000	orphaned
24423	3NK8L9V1SSs7N3AV5SVjZEgxnVV7cynpwvQNfS83GMuMRvDKzT5Z	24418	3NL4dJMKanTVP2YCZYosLUfj2q1Y25w86xJ1jKDXT7c6GKDbhoCo	1501	1234	461	12463	16324	jxkLBKmk2Bf7CzySJHkakfpXdwZDG8wjih7waVHn75wtExcZL3f	12146	17093	17093	1619015940000	canonical
24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	1582	619	461	12463	16327	jxqcPUidfxzitCfhuod7o3EKB92mvp8PYLFKiK4xeRtrxLWvopp	12148	17097	17097	1619016660000	canonical
24431	3NLjnWtDS8j8R1WYSo1xQHBsGct2vYLTvg6x1UqsDYy4DcU3jL94	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1613	1103	461	12463	16332	jwcJGiUJ1LEyLuNqd8ohktFkmBRsV6AWEums39gLzV43Lm19axu	12149	17098	17098	1619016840000	orphaned
24435	3NLT8YLqvd79gyNMKxRcoFzbEV6VZouuYA9Hqn9EqaNSXJmUHsVm	24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	448	1305	461	12463	16336	jx637VFgVtMAMPnGyoVEzTsNzGdT3nsLhHXyJM1WHjyF7Gn6NoN	12151	17101	17101	1619017380000	canonical
28322	3NLihba6daaGLK4mT1aeWq3zNRVGdyUvjwc8HQBXvBn2GTgtoPfc	28238	3NKiK82utVXSmsGkyKkBJQwgDgxbennUfeiaqfw4z6dy6Xy9TnNW	1623	830	552	12463	18974	jx65BqpNG6ibdJXKkLWnu5Znk4sQoLar9B4DasszVCQvCTTyT39	13944	19733	19733	1619491140000	orphaned
29401	3NKVTK79SxzWqgx6V67LJg3PRQepWpwgjZSBkEdWGwNmgnMx5qfY	29400	3NKXKEDVtXUaQGEDeKrk66Jt2bhPrt3SSxfHgwbA3uu3oN2vHMap	1407	1395	577	12463	18974	jx7jjcr9S9Ccw8NiXa2yEhbjUD5umk5itYxWjKFHMxKX6ZwuptB	14496	20404	20404	1619611920000	canonical
24400	3NLkbSoCo3Ha3RxGYPYKjJtGC7cbekqmpPuMaahPd1z66jHXzi2D	24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	171	171	461	12463	16301	jwXHHqPFo5uE5YSV4Bue6H87L5KxsfBc7naycjQ57gh6u77AeJG	12132	17074	17074	1619012520000	canonical
24403	3NLJndU862yGgh3EhbMSmhWKUC588D9AEXPEHNu4bAuWz9Dbaj7D	24402	3NKcJis3RPxcRK1QdXMXtYi6r1orBwo544pRN21NYRkX4UyV3TMK	1589	1040	461	12463	16304	jwv8HUn5qsLYdxXGYwgMpJNGjLAf7XjSyRNYVeVuM8e6LPyuZ4x	12135	17078	17078	1619013240000	canonical
24406	3NLaE35t79kVAu6CZbpeSDW97PSCEWvjsn1gFanwwHkaZfXiMGgF	24403	3NLJndU862yGgh3EhbMSmhWKUC588D9AEXPEHNu4bAuWz9Dbaj7D	1596	997	461	12463	16307	jwMTTM8BTRvTQVxzd1P9VK9Md72VUTMsqtJj7BPcVAPpiByvjgY	12136	17079	17079	1619013420000	orphaned
24408	3NKUvgQBYwuLxZ45mQZYuWExBj3nZsgvrsRmKBKeuqMpZz6ftiB8	24407	3NLG2S85W6oW1UpeMLVvZ4x3XR6TeYK51kUNEQPw71J2wNABnaw3	1402	874	461	12463	16309	jwirrcBGKg3zsgkxyrEpVxhZC9nBPJYh56VahEWB2GRRW9medKj	12138	17081	17081	1619013780000	canonical
24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	24412	3NKBVEGR87huQ2rqAVJZ9TbRxxMf3qQ7H4GmwRbyMgQEHHdMm6iR	1589	1040	461	12463	16314	jwtwcJwATuBUPWjL91HzbrNYgQkzSePbJ6Htk495xSkiKySsz9R	12142	17085	17085	1619014500000	canonical
24414	3NKnS5Bqnnrx6jKGmDsrP8BGmPM8Bn4KFw9WjU1fDvqMgEN8MVTM	24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	298	1062	461	12463	16315	jwfgp19N6kyb5CpoLo1PAkPkCRGkcRbNPLEkRYYdLp9fS2FwdqQ	12143	17086	17086	1619014680000	canonical
24416	3NLdwqmXxgzizpzafRUJWcbf3Cbg9g2hLbYMkVntdTejTeSGRxem	24413	3NKhnwj5Me5MQsiKfLc9WeHQrcJMBGsEjn3kmNzTm3Y52GkPdyHY	1481	790	461	12463	16317	jwEb6cZMdeR74HEGo6MjCMNPt7Hgbiqmm7KGgMUJvBRMDs5yAsu	12143	17086	17086	1619014680000	orphaned
24417	3NLNtH3ob8mCwLqtxwUh6tQrcANCyWdCXtiNLsFrPg2GuRryX66g	24414	3NKnS5Bqnnrx6jKGmDsrP8BGmPM8Bn4KFw9WjU1fDvqMgEN8MVTM	1671	1119	461	12463	16318	jwFWjQ2BmNWMujyGrcS1VNMHPy6qyXbGTME3EpbH44kkFHV7LBC	12144	17089	17089	1619015220000	canonical
24418	3NL4dJMKanTVP2YCZYosLUfj2q1Y25w86xJ1jKDXT7c6GKDbhoCo	24417	3NLNtH3ob8mCwLqtxwUh6tQrcANCyWdCXtiNLsFrPg2GuRryX66g	1600	1246	461	12463	16319	jwJgsGX7hPqkAPzPZ9cb1qYUJ7KzPyqFeYuWKrso2mQyRn2dBJx	12145	17090	17090	1619015400000	canonical
24422	3NKGmpEm4r8seb7coPii7aHh37npEHYYXvccgVVqMtyFfTHvCx7m	24418	3NL4dJMKanTVP2YCZYosLUfj2q1Y25w86xJ1jKDXT7c6GKDbhoCo	1406	1393	461	12463	16323	jwGoBZ8wGofMa6bwfvTK7ggRhH9n9nFmHMa1PNSvc6J9vQz9fqp	12146	17093	17093	1619015940000	orphaned
24425	3NLHeLukyEcTxfjA42ayhgm9PB7HmQpMz1cRUVcPRE98rnZJAnNW	24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	470	1309	461	12463	16326	jwXVFuwezpE8TZip8R4rd8K8a8oR8THQveKCamTRy8qxv3beJ29	12148	17097	17097	1619016660000	orphaned
24430	3NKW5c2BBxR5y3ChxudAbqqJUR89ShcZgyCbarmASnBrAZyyvHU7	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1547	1378	461	12463	16331	jwnJR2HfaTAiGhqzXxNxKZowQuJYen5Qj8385EoydQuEE2su6vL	12149	17098	17098	1619016840000	orphaned
24428	3NKS6z4pyJUFE26T7Xaz5SbPsFF3MeSor4Jx8sAVYhzdWsjCaHnR	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1549	1116	461	12463	16329	jxk1dFjbjs2edKEcNXU1BpYG6rSvUygqMAamBf7xQNBkVMP54dU	12149	17098	17098	1619016840000	orphaned
24434	3NKpPtUTFQpAGrENdT43CHgnPecRBHDPwMSNvvuDfgwXYmmPg2R7	24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	1553	776	461	12463	16335	jx5XSdFwPAcLM9seL9VEdbr8okWnCKAEFwN46pTsxz3K1YmRcQd	12151	17101	17101	1619017380000	orphaned
24436	3NLJ32TS9Fu8ZS5pB1qyfqGyL63S1kMu7o6A5jQgyM6aepcDxzsu	24435	3NLT8YLqvd79gyNMKxRcoFzbEV6VZouuYA9Hqn9EqaNSXJmUHsVm	1483	1030	462	12463	16337	jwjbhpmpeQkeugiZbPk5Y4tibdQTxPKJBjT2xXZuby7VKcGP2qB	12152	17102	17102	1619017560000	canonical
24437	3NKFBLTxZ9GRhKU7hTghj87DiSLSa2eeUH2xVKVH3PwLVpaVgDpQ	24435	3NLT8YLqvd79gyNMKxRcoFzbEV6VZouuYA9Hqn9EqaNSXJmUHsVm	576	1229	462	12463	16338	jw8iwe2LiHdogYe4f84AqFgeSzME3i5XrZqkCHZtvFLP1xzMrK4	12152	17102	17102	1619017560000	orphaned
24440	3NLdQsuyoNbFsMqCGV6Y29xVixyoq3vWSqGJPPnB753GCoEzx2Eh	24439	3NLnMVFLkfzNP9jLnh1X1tJFs17uMMeaGTUPSZnBgZnG8bXxfZfC	1407	1395	462	12463	16341	jxXNkhcd8YLscdqF2iP9EsLDywGbYq1MqFJfJUckE5eRdHqgEvZ	12155	17105	17105	1619018100000	canonical
24443	3NKzvhcaW7ZVyHdqGybykpEJhB9hiEF1UpTbmpuA5WHJjNF1N2zP	24439	3NLnMVFLkfzNP9jLnh1X1tJFs17uMMeaGTUPSZnBgZnG8bXxfZfC	1403	31	462	12463	16344	jxM6aABB6fZvKMVutzBTEGdUJV3S9YtiZRUY94neeW1Bx66JjeS	12155	17106	17106	1619018357700	orphaned
24441	3NKAz5k4SRJ1u9a7GQSy5LDuraJQWfpsZbtEnKSteTcikWyyPsBp	24440	3NLdQsuyoNbFsMqCGV6Y29xVixyoq3vWSqGJPPnB753GCoEzx2Eh	1406	1393	462	12463	16342	jxQzYE8euDSAvfPrQAZRWGXPf9Yo1T1Jb3sTxHxahGRigp4b6Bu	12156	17106	17106	1619018280000	canonical
24445	3NKreGycR67L1Fua9xkV275ap29u2Y8v4RtwtCujvJYa95VtNFtk	24441	3NKAz5k4SRJ1u9a7GQSy5LDuraJQWfpsZbtEnKSteTcikWyyPsBp	1407	1395	462	12463	16346	jx9U3hUkvDsCoDBTTNNf5tK2uUmuwYyRRaG542GnX8gYSyAFbb8	12157	17107	17107	1619018460000	orphaned
24448	3NLdqYTHptRPQTzkwAj3GP7uqja87VQ3fdX2iX57NRPPKvs3tBWh	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1536	1067	462	12463	16349	jxfPdY1Qu9Lust4GeFpjCTVPqUzF49ADttDyD11oJX1maXFbJUh	12159	17110	17110	1619019000000	canonical
24450	3NKTDiJW9i21igwgRFehPLLKZjpPQkj916mfKo5EvgvobXQVhSGr	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1529	1190	462	12463	16350	jww7fBGFmfozEG2RPzn3JMHvsd5kwQjnLkGSYTqthyXefe3qW2w	12159	17110	17110	1619019000000	orphaned
24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	24453	3NLDLYmPRX33gwqhsBU7CUvk6BNKDcLSBLHWDqxmRgoutGNgVeD8	1593	1346	462	12463	16354	jwwToiVbpDuZZ1yUTh4NXqo8U9kqP7Z5B2qXWTb1XhjUMPRWpew	12161	17113	17113	1619019540000	canonical
24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	1546	1339	462	12463	16355	jwjLy9FWTMvmpvSsu9vhAXWEUKcjYjgVdXSyjN5hiUkEENJKYJi	12162	17114	17114	1619019720000	canonical
24458	3NKVJiAjbDoMJvA9crNyjzYmUePSj6P34fk5RgCgnT6wVDGUbcws	24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	1405	851	462	12463	16358	jww8dpKQwZ4Ph2MWK1rxKAisGqRey9Dg6kPJ8b9natDKsvtkyu2	12163	17116	17116	1619020080000	orphaned
24460	3NLWNoGaS7rng1PHHFyKktnVo238MAjXgVSCxExkcvDzbNtVT6Px	24457	3NKtiMVzGWPpyVoH8eNHAckcB3Wgyf4Lu3v16rqPgffVL9Ze5Rgy	1405	881	462	12463	16360	jxdTsyfb6UQh3Y87fxUvCdgAtJxq1SFtkZSwCc24sR9R2yxaLMv	12164	17117	17117	1619020260000	canonical
24463	3NLU5hgfdoB7Jap9E8AXJMU58kSJKhvWwbSXgqh8RnanGKETSrML	24460	3NLWNoGaS7rng1PHHFyKktnVo238MAjXgVSCxExkcvDzbNtVT6Px	1426	1118	462	12463	16363	jwrnj6MrY3hpyW2u4YsW1acNtiWUMYCAq7892q9cLwMgBFn53yD	12165	17118	17118	1619020440000	canonical
24464	3NKfrhv9Wka7x9xJvwABd6W96SrrAysH4FX5F2CqjTWRxNEFutyE	24463	3NLU5hgfdoB7Jap9E8AXJMU58kSJKhvWwbSXgqh8RnanGKETSrML	1534	371	462	12463	16364	jx3dY7dZnoe5f7wuhzU29BwTfXD7GXW3FLYFNJoxnt1g4555MHi	12166	17121	17121	1619020980000	canonical
28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	28214	3NLVNhg75JxYSprQjwYNFiud97u4952ZK6sAhthEA3pc4tRHTySq	1476	1371	552	12463	18974	jxbbQ4p8Z9xYVG7Yvgafyqr1JM72wqs6BbJAz1HgaeCmy9xxaPe	13951	19667	19667	1619479260000	canonical
24482	3NLyBPv4MR1QNRhQYk7bc4VsvKmverfhVgRmtmnaLRW1vRvd2cFW	24073	3NKQFwVkkzaiXQAmV7WozyAvmwyGLEpX3XQt6FEs1MFeQGz4Krvd	1445	1164	454	12463	16381	jxspqLF75YLkaabFCTvaCaY1DMXhz7zSVsgVCNwcj8QbDfkzUxR	11983	17131	17131	1619022837079	orphaned
24429	3NLgSwJjyhcEceXfLWUPYdCsRQrKJWESEDd6W1y5hEisg6oiGtQh	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	1402	810	461	12463	16330	jwF12hmNrH4TMJkXoVomVuHGKW5LUXGBT6eNgdSTzAjsjft7rTm	12149	17098	17098	1619016840000	canonical
24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	24429	3NLgSwJjyhcEceXfLWUPYdCsRQrKJWESEDd6W1y5hEisg6oiGtQh	1611	1095	461	12463	16334	jxnnT9exQ8yX26k8X32m5UCRoqQweo13Jnc3nxh1aWHVm8f1AYX	12150	17099	17099	1619017020000	canonical
24462	3NLi5SdkKYQaVbEQq2mTBAkeeV6mWgjAeExcaMqZJyouvXw7zgbE	24433	3NKB8RvLn69LbPjJzjeb7ozAfpyCUJEinDQKxR7nhdaij7SnNvBj	1426	1118	461	12463	16362	jx8M1FAiePmWhfScnNhkvMiBKTYjpzfLHDX6bun3Q7hkXE8kVjB	12151	17118	17118	1619020440000	orphaned
24438	3NK3ggzzku7cqf2xDmEbskEiZA2mUMbyXTaN5xFUjHq683rEgxcx	24436	3NLJ32TS9Fu8ZS5pB1qyfqGyL63S1kMu7o6A5jQgyM6aepcDxzsu	1611	1341	462	12463	16339	jxUUrD26HUgVdnCbnDAuWsHsCpijCgK97FdcUm7rnnRdxboiWEa	12153	17103	17103	1619017740000	canonical
24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	24444	3NLa7518CqyqG5s8B5LrzMAnj1mzWSxabA1vcsgufJxgCoJFDTHw	563	1113	462	12463	16348	jwwvF3iMKEx131xNFR6xWcZBd51vYYMRMYccjDX2JEKkNbszgzN	12158	17108	17108	1619018640000	canonical
24505	3NKaBxyutF9gFE4TvidGSaJcZnWUCgVWxqrTVYZBH7J1A5E6pkWn	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	58	1281	462	12463	16403	jwy5RZhemZ2NRq4HZiMBjjL41gV6vt34tbzfvxDqM4EMGyn7kpZ	12159	17150	17150	1619026200000	orphaned
24453	3NLDLYmPRX33gwqhsBU7CUvk6BNKDcLSBLHWDqxmRgoutGNgVeD8	24448	3NLdqYTHptRPQTzkwAj3GP7uqja87VQ3fdX2iX57NRPPKvs3tBWh	632	1136	462	12463	16353	jx2qHyekB23WdpVVpch3qxuBFZ6f1mQPfBgx9VyeqmpXoh4ufC8	12160	17111	17111	1619019180000	canonical
24456	3NLofD2dgE9rYcPbZRJKeAUeWiSsd5xNpSruGcAbHmNJUY3ScGi9	24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	1647	1176	462	12463	16356	jxQHWwc5SFMwvmE6x9QB7qr1HQYvtt3K6Vn9LNXTPSbfeQaeTaR	12162	17114	17114	1619019720000	orphaned
24459	3NKKTiGeLEfwDMwE4MyfsA1ZYX8H7WiNet57bNHH55BoeP6jvntA	24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	1407	1395	462	12463	16359	jwGX8JRwTuyrdBLsNQy8cv8mk4Z9Te3Ay1qcKAcbZMfCzeTSorc	12163	17116	17116	1619020080000	orphaned
24461	3NKK3hb29zwzV3hi7PVCp6Q4Y3skK3Gmn15hAeDZ1tekKP1etsLn	24457	3NKtiMVzGWPpyVoH8eNHAckcB3Wgyf4Lu3v16rqPgffVL9Ze5Rgy	448	939	462	12463	16361	jwtsBax5fudj7zSQNi7xsAd1fhiDPx4MVfxqF6bYLrJDy82zHVg	12164	17117	17117	1619020260000	orphaned
24466	3NKnfHMg59k9ogQV6LXEMbrQhRDDjpBUaaAJzuc83QEM2YifUymm	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1507	1034	462	12463	16366	jxGs86SAkGzC7mFvY1MsS1MS7BQ96ns6AMPRy3kMPRYq1no5HDh	12168	17124	17124	1619021520000	orphaned
24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	1406	1393	462	12463	16370	jwxZCaHXzdmDuaze6QAKdNEqp6nf1jLLVhyJLF8rXW5yJKXo8Po	12169	17125	17125	1619021700000	canonical
24470	3NLeW3u3ed1e2GJdqdqpoQ9KR84pyohh8qnZcyGvK35HSwZrFiDW	24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	1483	295	462	12463	16369	jwnUKUdR3sCcLMoqUWrmR1pcxEA3WXrXDdU8yuBrcuXFBGWkzSP	12169	17125	17125	1619021700000	orphaned
24474	3NKnfNEks9eh8NWGeMCvP6pfDkRCgNnsrWEiq9XbNtjbjNYNuTVw	24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	1546	1213	462	12463	16373	jxVpxjcYVTXMj6GP8RFDoP6F6Y4bAZ9rs5reC1pnq3meU29M3Ri	12169	17127	17127	1619022060000	orphaned
24473	3NKUu3HMhTRGyk92Kds8XqvLVQw3rGy9ParEHYzyoeTVbYpNr3Be	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	1403	782	462	12463	16372	jxgA7pEdCv3GSBfCwJ94Hgvn9TCQodRiEC9WmmnjModsqRK8rHH	12170	17127	17127	1619022060000	orphaned
24477	3NLGi1cxdEPKhDzEro2NpHuuZ1v9XY5fhDgGKCriVbnDTCr4U8Lw	24472	3NL42MidpVStUNoFTExmP6xFMcb3r6vsE5LVjprrJUcQGfTiXAma	1483	894	462	12463	16376	jw9aYpoytCKLrJhddR75gs6sVPphxa6U2fb6ihjZtzPkKJVKTKy	12171	17128	17128	1619022240000	canonical
24479	3NK8FiFj95bJtNvheYBv6MBVsmseqzciYHzT7DkdDxcAYEf7K5Yp	24477	3NLGi1cxdEPKhDzEro2NpHuuZ1v9XY5fhDgGKCriVbnDTCr4U8Lw	1407	1395	462	12463	16378	jw8Woo8x6bftDHqWarAr8tZYRcyfGNc12RerYRnJdn25KxCwK8o	12172	17129	17129	1619022420000	canonical
24484	3NKGWec7woCuRtBT6m3jt3Low5kPUWSSdV1RGbrCvDBya5VigptD	24481	3NLmQGU6TFKYmXcQwgYgA1Z4d9ArfXka6eVcwFNYe87Wwr5BMmb8	1656	1097	462	12463	16383	jx5ruESPsjfkCCZV2zvsywuPogLvtHndvRmquzX8E2U3sspyMbP	12174	17132	17132	1619022960000	canonical
24485	3NKWzZthr8nSsPseTqKc46j93o7558gaprNTDrxpxtX3E2ggf7i8	24484	3NKGWec7woCuRtBT6m3jt3Low5kPUWSSdV1RGbrCvDBya5VigptD	1419	814	462	12463	16384	jwsf18bnhhWtibs2qgvAR9dV3RqsKe8QYRooUueSKanR6VaMWNv	12175	17133	17133	1619023140000	canonical
24488	3NL3Y1gfuhsFWWSfkT4LWQ2Xh3saSN6JKxKtrP4g1m2iLbyqbuSb	24487	3NKHXLFi4h5VJcUEhoPmWuTz5K348NY5PKu9feuNRs5sLNhmKcWo	152	1084	463	12463	16387	jxZn9nQzHz1kygEyjJvnmTWfxPoU8HkLZMWRYbfBssqX1nHoTCj	12178	17138	17138	1619024040000	canonical
24491	3NLYZrPBSTgZjm5BgQhR7PsZeS1W8AdRDq2SiXDCmY7xWp2cDrWy	24489	3NKHCfooJEGpqgRNoDPyNsTQUZXNjxyD5imZicgsf6YTWzfn9DX3	1403	824	463	12463	16390	jxxWy3mxztt9hrLioJvh6Y9B9qkAgdNGu5zpCTvrXr3kV9fuGcp	12180	17141	17141	1619024580000	canonical
24493	3NKGCiv78ThKWPuGvcTtK7PwNEvycNP36z2WHw738HbVPmJUCLr6	24491	3NLYZrPBSTgZjm5BgQhR7PsZeS1W8AdRDq2SiXDCmY7xWp2cDrWy	298	1182	463	12463	16392	jxwnS2Lgf1Tbt3G4Kpnp36WKeoEtZ75amJ7k6j3G7oURoKKX57h	12181	17142	17142	1619024760000	orphaned
24495	3NLtv9GM7t1JhkVqbtbZ4ug8pc6WQQs2R9NTqrUgFiN78jx6gByu	24494	3NLp54pYXuFhw84yMrjNXBNK8JcHiV5B3FZvzZgGyfgTAmqnrnwq	532	1303	463	12463	16394	jxkY3EwFYXmMtXGvK8pz6EL7zqair1K2adnMGVhVP3TsCZ7gyX5	12182	17143	17143	1619024940000	canonical
24498	3NLgyCiR4YgcEwwa1Vd4HbBZqz6qqEAY3RtqXf959zoQXG7gjq2F	24495	3NLtv9GM7t1JhkVqbtbZ4ug8pc6WQQs2R9NTqrUgFiN78jx6gByu	1581	778	463	12463	16396	jxwCpC2iP1vqHzdd9qJxKH4NoaJHUPYGtJdNPyFvCEVwF6oaZ4L	12183	17145	17145	1619025300000	canonical
24500	3NKquk95rTJP1QufXnTQUB9KfVCMAceDsGTZfrJS2sqTHsZFmE6Q	24499	3NLcMyhFCynzBPp8eh8cQyRLujTpvMcMRNTEKAYDM6KwEswFTaFr	1422	1211	463	12463	16398	jwu2fnwgmBd4zyRX43VDsVBvX3usMkTUmgVTkkDf6jsYsSbsbLw	12185	17147	17147	1619025660000	canonical
24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	24506	3NKnAwqMQz24ykEEJ1XREuhV6n7g2v75QUwVphhCf19iyCWsxR9x	1617	1042	463	12463	16405	jxCDKwNMapoGSev1yEdKRKsaDosCjd1EJggv1THCdLzYsQgWFJD	12189	17152	17152	1619026560000	canonical
24512	3NKdLFKsngTG1N26cPiZ23D6WCPq2JEmZDCndqC3Zn7fk2DL44qP	24511	3NL7F86QZQ3VysbLGzWKTrN7jCDHRUNAPywijtajNhcyfTpHAztv	1406	1393	463	12463	16410	jwbSRRRxe8AmPX9FE8HUcSZoyLE5TiAHvxs1xumNEZLUXvUAtca	12191	17155	17155	1619027100000	canonical
24515	3NLeJ4Kn7HaovH6oq1BXShgPGghd6wAec8WVk74GVFTUw8qUa5wu	24512	3NKdLFKsngTG1N26cPiZ23D6WCPq2JEmZDCndqC3Zn7fk2DL44qP	1631	794	463	12463	16413	jxwExoD9W7LHcgYd8mV14ZXdf7rSae378gGcLPHzAMLcrWz3nLQ	12192	17158	17158	1619027640000	orphaned
28222	3NKGA5soHkgeVgMUeRw8ed8Lotb1RhXfMXrodL17Gce4NdcFwpFZ	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1549	1362	553	12463	18974	jwRVR78DUssKf23JtESJK1FtCzJjDnizXxUyd7fh2f8e6r97P29	13953	19669	19669	1619479620000	orphaned
29407	3NLyaMyrkMC8EPPHgC8tz3Rb9G7dUjEPrNwNmFYW43evhuZcgJvU	29406	3NKUFDThmpoEdtUPtWBH1fNjqeZ9piQF3yfx3eznjqVpUtg669oV	1637	816	577	12463	18974	jwR8L8HQeAHQyLYC56gHT2Pmze2CYR4FgBiBtLwdrP1xZbEYkdg	14499	20407	20407	1619612460000	canonical
24502	3NKmTPgiCXBxVVcS1LivruUqTZjoRmjJYNNdsqYyH36Lv2b1mfTt	24164	3NLCF8Kaekoxe6Tm2z2jipZ8CGhGXnQrZezLRE55USVSgmgQWUmA	1654	1340	456	12463	16400	jxCX2CdAUijhF99jtPhDfW4y3gf7b7teiLZKgaY8a1VWK4FLinj	12028	17148	17148	1619025840000	orphaned
24544	3NKGCSTMUvjZnG7zfejrTZb2goxbk4354XEtpnAqmyLikhAASfo7	24256	3NLEG9WsCiykZa4ifgQbSEPQqfKBq5sxbaFd9T9LaFG29LeRdsNa	1571	1089	457	12463	16441	jxQjE75enjsm35ecqFiGDea6yek63fp3d4HXQBgZNSDQLTtdPxV	12070	17174	17174	1619030554802	orphaned
24525	3NKkEddLi8pinGdR7s93h6mLUNn3WKTQFSx6UrhfF7uWnweaLGUg	24291	3NLN1xv7gN85ycSWo4Hpwo36inCfJ3M2KrP7GUD7yDagj7aVSAcf	1675	1342	458	12463	16423	jxrDAwMepXEcBKVRf15A1vXjAcf9Mdx5a1mHGYTZVoy8gB1yWnz	12082	17159	17159	1619027820000	orphaned
24446	3NKJhM3Q8TeivAiZTKechF6zpvacnHuJUoAv15NcXNDXsVBMuyfq	24346	3NKLkRstSBAhUEdJHSrLPyBxk4rnHhVC1ZGGBiCYgy39VxVdDS7v	563	1113	460	12463	16347	jxP46rjEMgboboxeUmcTbyhgUUBWarnxbJy2cnPTk8ky1kZRwBk	12109	17108	17108	1619018640000	orphaned
24442	3NK5jJFBhAQ8MGgWwhuPVRLn6WGYZ7H9K3mN3jHvquvP39C1967q	24438	3NK3ggzzku7cqf2xDmEbskEiZA2mUMbyXTaN5xFUjHq683rEgxcx	1403	31	462	12463	16343	jw9zyzg19RgWRviip3j3yv2tcjF48DmpFyMB9SA7oZ4VWqK6XkL	12154	17106	17106	1619018280000	orphaned
24444	3NLa7518CqyqG5s8B5LrzMAnj1mzWSxabA1vcsgufJxgCoJFDTHw	24441	3NKAz5k4SRJ1u9a7GQSy5LDuraJQWfpsZbtEnKSteTcikWyyPsBp	1589	1286	462	12463	16345	jwajNRLpkEYFjtwcYSrXSYFqA9VVPhDQH87z2NaHjMApdow9dkv	12157	17107	17107	1619018460000	canonical
24449	3NLKJFRhor29WS1MEgX31ccRrrkspBrjF5khvx5BC6LtNAJg5141	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1529	1190	462	12463	16350	jxZ2mSMUaDUNMv5avBr8F1qspK8QvwGMcAWMAxvjaSV4za5M64i	12159	17110	17110	1619019000000	orphaned
24452	3NLRudYC7sTwZjVzZVkfRFd8A3sc5dDkT5YPX1Lc6fEfg2vXyKUG	24448	3NLdqYTHptRPQTzkwAj3GP7uqja87VQ3fdX2iX57NRPPKvs3tBWh	1447	143	462	12463	16352	jx29sAvjhLXTv16WjfCCgtujdyrZU4oonPWGyB22mon5hq8w7UP	12160	17111	17111	1619019180000	orphaned
24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	24464	3NKfrhv9Wka7x9xJvwABd6W96SrrAysH4FX5F2CqjTWRxNEFutyE	1588	1392	462	12463	16365	jwgQh1Go5mKMftZiMu9M4nfCDNvRaK98Yn8QjD3rwQiATujtL6F	12167	17123	17123	1619021340000	canonical
24468	3NL6S7FtR24KGVzv6udjjkE9c69QMvqnK7Na9fZa4rBvKSm24AoZ	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1476	1005	462	12463	16368	jxNtDACyF9DQBoudzbtVoJ4pJFRB5hgZkkDWATo6ysmgoi6YUxb	12168	17124	17124	1619021520000	orphaned
24472	3NL42MidpVStUNoFTExmP6xFMcb3r6vsE5LVjprrJUcQGfTiXAma	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	1546	1213	462	12463	16371	jx7ygaRTpYvdUXRJZDBiY1f12L6Gq6n9QmrMKRpiMiSUBeJxT8b	12170	17127	17127	1619022060000	canonical
24476	3NKG9Di7KY4PhGmuPgG6xCjinLVaL2Et2GQsX1SQn4drhrJJtx5z	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	1637	816	462	12463	16375	jx8P46Trkdr8k47Gu2tKnSkgz8Ks95xTH2whunK79x2WJRPzdZ8	12170	17127	17127	1619022060000	orphaned
24481	3NLmQGU6TFKYmXcQwgYgA1Z4d9ArfXka6eVcwFNYe87Wwr5BMmb8	24479	3NK8FiFj95bJtNvheYBv6MBVsmseqzciYHzT7DkdDxcAYEf7K5Yp	1445	1164	462	12463	16380	jw8gCC664V5HCshBHrua7VYXrnk3LrowBqu5Vp5KxtMQxhzN58u	12173	17131	17131	1619022780000	canonical
24487	3NKHXLFi4h5VJcUEhoPmWuTz5K348NY5PKu9feuNRs5sLNhmKcWo	24486	3NLf1psCSmKYeoaSi8EokEsA8QDcUdwXBiBy42WRAVSz9ngkaiW5	1637	816	463	12463	16386	jxyWNfTFAiqRUTdBeEHZ3mhGGwCdJMQCfyQVsXVmwYxy94Mpq4h	12177	17137	17137	1619023860000	canonical
24490	3NKRC6BuejvsXrEZZRnqDThwXcaqWv32TMXNVgxAxfTs3byvTb12	24488	3NL3Y1gfuhsFWWSfkT4LWQ2Xh3saSN6JKxKtrP4g1m2iLbyqbuSb	42	1361	463	12463	16389	jwPwQZurC8ghXdmtp2HL4FyBuosAfKvPCG1a9BNgbVreLTVN9b1	12179	17140	17140	1619024400000	orphaned
24494	3NLp54pYXuFhw84yMrjNXBNK8JcHiV5B3FZvzZgGyfgTAmqnrnwq	24491	3NLYZrPBSTgZjm5BgQhR7PsZeS1W8AdRDq2SiXDCmY7xWp2cDrWy	176	176	463	12463	16393	jxumxTQHxtb93hTbJjVgT3xF8SBESqpiUjE6dS7BckjTxoWCcYq	12181	17142	17142	1619024760000	canonical
24496	3NKafY5gEqb4cUeKFXbPT4bRvqG9i9zwr7LZR1fWWVTVE1oRmRmC	24494	3NLp54pYXuFhw84yMrjNXBNK8JcHiV5B3FZvzZgGyfgTAmqnrnwq	532	1303	463	12463	16394	jxe1p1E9WD94Ad3s8aEhmV173BgW6AgpxJxWji9VkJyUMepKByo	12182	17143	17143	1619024940000	orphaned
24497	3NLVF1g8b6jsajvJseRkScph55ygFZ8B4zcYBT1w1AN5aVr45uDR	24495	3NLtv9GM7t1JhkVqbtbZ4ug8pc6WQQs2R9NTqrUgFiN78jx6gByu	1553	776	463	12463	16395	jx6SKZsiNqNhjrff6FfJVNMMRTKdaWnpReDLkJE5dQArEPZJMnE	12183	17145	17145	1619025300000	orphaned
24499	3NLcMyhFCynzBPp8eh8cQyRLujTpvMcMRNTEKAYDM6KwEswFTaFr	24498	3NLgyCiR4YgcEwwa1Vd4HbBZqz6qqEAY3RtqXf959zoQXG7gjq2F	1610	948	463	12463	16397	jxcx2AcZsGmp4kYmCmfMccFsztz1NaPfv3SkUPCzvNGSupGeoev	12184	17146	17146	1619025480000	canonical
24503	3NKTuyPKhfwsusbUmpswp5we1wVZchSqZTt2rwcZgvmaYcq4RekB	24501	3NKhPgGAkDUdA7o94C76gvXoynhYYNbqZyiwQH6QhzHVifZMb9oT	1403	824	463	12463	16401	jxSp3zsxEtvoAwo93WKqe5Fj9BtnXucfUiJk4w8vjv18LZxVkFQ	12187	17149	17149	1619026020000	canonical
24504	3NKSTCaw7Mg1xvuwWrTW6VzzYRxcn2zqBEcbdfhAgK9oU5EaQWn8	24503	3NKTuyPKhfwsusbUmpswp5we1wVZchSqZTt2rwcZgvmaYcq4RekB	1406	1393	463	12463	16402	jwy8DXh8bDNkChcqomTBRPuijAuuwKxwgGpgnJdSwEc7igZqDGq	12188	17150	17150	1619026200000	orphaned
24511	3NL7F86QZQ3VysbLGzWKTrN7jCDHRUNAPywijtajNhcyfTpHAztv	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1623	839	463	12463	16409	jwHs5RkvjyKgNPsbg1YZ7s6kCooFGXPtFX3y6xfajCLaMgo5auX	12190	17153	17153	1619026740000	canonical
24508	3NKw3BZtKD6sXtiZ3ZTDZLvTxVgZtDSLVBBuqEk1uHYajcCjEB44	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1542	1178	463	12463	16406	jy2TeFfqG4ShakEmy66uLGK4WmGESPsk3mwadG7pE7BdSyFs3Zr	12190	17153	17153	1619026740000	orphaned
24513	3NLcn5Lvv1P7Qgj8bq4QXMELN2mGbtP35fjgXpkfF7Bh5RwqvdCf	24511	3NL7F86QZQ3VysbLGzWKTrN7jCDHRUNAPywijtajNhcyfTpHAztv	1407	1395	463	12463	16411	jxUUyGecvAeLWXDtUxUw1ASBzJaThgtRzazRfw2LwFZj8uWrtgf	12191	17155	17155	1619027100000	orphaned
24518	3NLBHtx5BkzaU5MPXbuNPnVQY4qZAgDEiUCZJVpVGj7eDfR762KC	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1405	1	463	12463	16416	jxYc35KgwWpdBg4Q9aqK7yZN1gx9WjfvQXcTB2GaBo2X3uufgHs	12193	17159	17159	1619027820000	orphaned
24529	3NKePdyvU5chZwFQmH8rr9pbZMNmYd1HbQTTTQ1h8cDbUNkUH587	24524	3NKeaZ6bj82BDwNyb6t63kwzRVACMEpFT4CXRvSNBu1oaUd7ZoCa	1406	1393	463	12463	16427	jwwnBFQUfTgUgEf7F2mSTn7aHTm7tJyJLfeFMMmr1X4HSMA1Dzx	12194	17161	17161	1619028180000	canonical
24531	3NKHGX3aN8YuSMmbj6FWsgFL7R2Z1GVHE3wHESsRVzP5VXQdyWc7	24529	3NKePdyvU5chZwFQmH8rr9pbZMNmYd1HbQTTTQ1h8cDbUNkUH587	1426	1238	463	12463	16429	jwDv7k4zEoTuEBEf3tQn1U5uDR4sQBq3G3nsmmA4CwoVAfsFa1b	12195	17162	17162	1619028360000	canonical
24537	3NL1FU7hi1NhTxh1hRhQgWwxfts7uDTdNmmvyEeFkL5HbKuvJTac	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1403	782	463	12463	16435	jwofEK56wqZwDPw33S2H3PXAmQ9tE2WsVqGrdiqPP3kYhGiZCFi	12200	17170	17170	1619029800000	canonical
28240	3NLkshjxpch5shHqaAyAL5FjbS2ohfHLFAfGZmteetVB8ARU2MNN	28236	3NKK7Nir9ZDi1tpchbdZw2wjYe6H5M4bSZ6FTcknkhq9WFFcnXiw	1670	1282	553	12463	18974	jxAmn1xkCrFBTKjvUNZRx3oqiRFL1U6VooSc3osvfqGZjXTd5GY	13962	19679	19679	1619481420000	canonical
29410	3NLpikT9FTgTdvi4JTSfXVjunuAKEusxEMg8gAsJf9d5x1MWLndG	29409	3NLjVZqckbsL6GPHji5KZdauzXsrz4gTMw8f42AsE32KFqSqi2Ly	1553	776	577	12463	18974	jy1nhRAKfJs1uRNWo1SiAxZgu4N3Pdope2FXAaDEvs8iMAVQWSR	14501	20411	20411	1619613180000	orphaned
29878	3NLH3eNkmb2X7mtHL9L1FW1ZwX5Sxfya4nqhQ2A5HdQ7D8JqT63s	29593	3NLSQTFPimdvQLwM58WViEmFfxjGmuLVfepqGxNgin8SgJasVHRV	1516	1294	582	12463	18974	jx385gvpSp7qgUfUNVZZkkYRTh3QMQ6vJg5UkkkTgqVGdETeYit	14592	20734	20734	1619671320000	orphaned
24543	3NL9pcPk9dh77J6fivKRrUNEqzJMT9CuGQZu1KsXjsArnU4gpbpF	24233	3NLhTtZQRsP3NhYRnicnn7x5JLMZ3XnQW9QxK2oVzuwNDc4uC8kt	1571	1089	457	12463	16440	jwxzEvxxe3BqdR6RGS8QryVKiEcsMUPyQPTebbfw2cu29FChjCQ	12060	17174	17174	1619030520000	orphaned
24545	3NKzb6ypGkGYvG1YuANGUd8ifD9ieLuPd51uv6jgrcNB7sbZGWfq	24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	1571	1089	458	12463	16442	jwhXVtRadvFpMGp6M6AqWayhjuTXDedauntt2fbmqRoP3hYGfti	12080	17174	17174	1619030590250	orphaned
24514	3NLwoEoFRLtyqvW5YgUqQhf1HbzJpLPY9952qeUnnBJJQrmA49QB	24319	3NKVvzte2NhGGn3dmUt3amP1o93uPqN9PjV8WeCi3Evw9HU7d4B2	526	648	459	12463	16412	jxR1juJ8ovdBtEJKzkqP2k93ajVinQKS34Bbs9Fxpj2CNd6RC6a	12096	17158	17158	1619027640000	orphaned
24530	3NKiTCKD7GS4DsAhFxJQpXJAc63XtSnXaN2EV4b8aF1QWmRevSDp	24462	3NLi5SdkKYQaVbEQq2mTBAkeeV6mWgjAeExcaMqZJyouvXw7zgbE	1426	1238	461	12463	16428	jxrxAd2L4pTPvu8GjkcCeV7fHYtTg2rHVC6G1Dz1obyCtKCCwH6	12152	17162	17162	1619028360000	orphaned
24527	3NKpZSWWDCZoDJMXj4rqSgd7x27TKFr6LRgsF14xDjKNVsMDpqGc	24440	3NLdQsuyoNbFsMqCGV6Y29xVixyoq3vWSqGJPPnB753GCoEzx2Eh	1458	1197	462	12463	16425	jy2JS9YF39WJf9rpM8eP1LGPzxK5n7RrcyE5fW2cttjohT7goG5	12156	17159	17159	1619027820000	orphaned
24467	3NLUiWM483dAFQqHvHxCV1AeDnLbkTwDC9xVoqzZZQutxBKKTrKd	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1648	1284	462	12463	16367	jwxEVK8V1AqU8LJTQS4w1tnnPqEP6inywRNv1WiGU8dDm97uZgc	12168	17124	17124	1619021520000	canonical
24475	3NL4J6nBFeKfPNNcjbMRQ4DnXLFGMDPtDeraz4f5BeU7EcbBJXVs	24471	3NLRrP8BjecBoqewdVE2VZpWcstEx65hfcXQ5ijgMAw7TzqQJHDc	700	832	462	12463	16374	jxZkys7eYqxQRMnN4un1vcBVSsk5QR5ZSxhsvzVioanZXmtDK4n	12170	17127	17127	1619022060000	orphaned
24478	3NKpNkNKTS9MXw4DAVcz2saKstDcJ6RwJp1gnENQVR7NfyWb6wFD	24477	3NLGi1cxdEPKhDzEro2NpHuuZ1v9XY5fhDgGKCriVbnDTCr4U8Lw	1623	839	462	12463	16377	jxUPNbAB1v3qdnoDapr8jysBjKM8YMYeMw6jmwHtd17W36ennhG	12172	17129	17129	1619022420000	orphaned
24489	3NKHCfooJEGpqgRNoDPyNsTQUZXNjxyD5imZicgsf6YTWzfn9DX3	24488	3NL3Y1gfuhsFWWSfkT4LWQ2Xh3saSN6JKxKtrP4g1m2iLbyqbuSb	1668	1124	463	12463	16388	jxav8JEKYCq1QZhUKx4vBTn1toLTtQemydCWJSUUvRwtDE1t367	12179	17140	17140	1619024400000	canonical
24492	3NLaWJXSAkBCeKiBPeeL5hJgQj3dYGyJspnZDhkvch8JjrHkjAwA	24489	3NKHCfooJEGpqgRNoDPyNsTQUZXNjxyD5imZicgsf6YTWzfn9DX3	1483	361	463	12463	16391	jwD8K4C3mSsuPH3oWoaFYUfH1SWhPFFbPu8PpfQ5UJdQyzRTkZc	12180	17141	17141	1619024580000	orphaned
24501	3NKhPgGAkDUdA7o94C76gvXoynhYYNbqZyiwQH6QhzHVifZMb9oT	24500	3NKquk95rTJP1QufXnTQUB9KfVCMAceDsGTZfrJS2sqTHsZFmE6Q	1654	1340	463	12463	16399	jwuh9MXB6Zfhxbsz8bKcUHCd2sbLDpb5P7bzSEauPEZNLMefNJe	12186	17148	17148	1619025840000	canonical
24506	3NKnAwqMQz24ykEEJ1XREuhV6n7g2v75QUwVphhCf19iyCWsxR9x	24503	3NKTuyPKhfwsusbUmpswp5we1wVZchSqZTt2rwcZgvmaYcq4RekB	58	1281	463	12463	16404	jwbMdDZToQ1LQSfYsjeNBSF8mxQeUUnaPgW69irCKiA1sQtp7dL	12188	17150	17150	1619026200000	canonical
24510	3NKgwHbKdFvswPopS3pRvmKv1nG4zpkJKXtevdgH5dN1hMjKVKVb	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1602	1123	463	12463	16408	jwvxzQf9LBkkqEV5yF9fSaGt9yHyvHeagaSYjdW96nu6GeQ95Ze	12190	17153	17153	1619026740000	orphaned
24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	24512	3NKdLFKsngTG1N26cPiZ23D6WCPq2JEmZDCndqC3Zn7fk2DL44qP	526	648	463	12463	16414	jwf8t4mKU7BvPP8WAhyHxybp4M3GVWzzpPQSNzVhDmDyTeo38bj	12192	17158	17158	1619027640000	canonical
24520	3NKHnZWVou754BJmYbKkasFnaxnPCyZkfmHKf2TemyspRsyBP8tA	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1458	1197	463	12463	16418	jx2mhJ4Xcs1xoVyM6dZxq29wN8EBVyNyyfpY4g7tCx3QsJP5ALh	12193	17159	17159	1619027820000	orphaned
24523	3NK9Tzt89aoKbov2Xf6sv9aNCvkyeiYf3m1MJeJGZErE8V9BHPmn	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1500	931	463	12463	16421	jw9kWL7PcgLDqTfmB3bGoQwLLoxwxM7Ri2Q5AMM6gNRFsQeFkRX	12193	17159	17159	1619027820000	orphaned
24532	3NKVmMFhcdWyshuVXZzHqBaHr1fVhcgZvfNm44yW15GjayKQsx3R	24531	3NKHGX3aN8YuSMmbj6FWsgFL7R2Z1GVHE3wHESsRVzP5VXQdyWc7	448	1179	463	12463	16430	jwK9H95FrQEMv2Cg3iQ5k5A63yTrbB87sDKqeZiwbgz2ddgdfog	12196	17163	17163	1619028540000	canonical
24533	3NKmB44Wftf9aY78JUjUVgnJRXJco1XJS7TtNfAF3h4FmpeXnqgM	24532	3NKVmMFhcdWyshuVXZzHqBaHr1fVhcgZvfNm44yW15GjayKQsx3R	1444	1381	463	12463	16431	jxrBasxhVXZC5ozRTtzFSpMvWFveppTUk4ShwPr7XsBqYXwh3RP	12197	17165	17165	1619028900000	canonical
24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	24534	3NKYZMuP9x7Dt9YWGBr28MBKLSSuR65TCEJUzSJavSwvQYySux5s	1646	1354	463	12463	16434	jwEL1eAhgnqDRNvaraq14LjnCLr3Hcci81CG6wtGf6qtQPCTCm2	12199	17169	17169	1619029620000	canonical
24538	3NLhadjTDHKV5LqogmJvQkQWai2b4JoaBSuWPNFpa3TwXxEZNuiE	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1541	1298	464	12463	16436	jxxet6yYWJPE86gH1sH97jvdaF9SHD9EbxM2ri5UvuBff3vEDAt	12200	17170	17170	1619029800000	orphaned
24540	3NLoEsXNQwyo7vzDQkYgHboQekZ5sEH5Sr5KAagMzESesiFJvJ4e	24537	3NL1FU7hi1NhTxh1hRhQgWwxfts7uDTdNmmvyEeFkL5HbKuvJTac	684	1226	464	12463	16437	jxGjTdQirH8rDb2KRN89FUciowajfWBiKNv6kMHSe5gAC3W3Wgz	12201	17171	17171	1619029980000	canonical
24541	3NKv1GQpbzkdtA1LcWszLs6qAPMhrj5Pcp6R14dvfhMLm4QfSvYe	24540	3NLoEsXNQwyo7vzDQkYgHboQekZ5sEH5Sr5KAagMzESesiFJvJ4e	1406	1393	464	12463	16438	jx2boYR4dQG3QXuzixLUdmyC1DpkpJ479gjnHtg89aohHaLWjop	12202	17173	17173	1619030340000	canonical
24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	24541	3NKv1GQpbzkdtA1LcWszLs6qAPMhrj5Pcp6R14dvfhMLm4QfSvYe	1483	1030	464	12463	16444	jwSRcSxEh7RtYRMJEph5Hr3EGHUxtFYxBzZcTWFSVrWa4EpvVeU	12203	17175	17175	1619030700000	canonical
24550	3NLTqvQ4NyFgUaZ6QCU1gTgXKz6digb9BsUfmZyqUHHCA3Bm9fa7	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1633	1390	464	12463	16447	jwafnVBbJqxjuVUiQadC8PL2D9UgVD5MU3spJ57jk3hWjyaPiXM	12204	17176	17176	1619030880000	orphaned
24554	3NLQY1rrZXVFotpu1VsRi8xt4XgXRCEhrMygtGkHa793UL61iyCL	24548	3NLeNbtaeT6Vp5U172G1735MySNxvSyieatpkvRGw7ve1o58WGvc	1581	777	464	12463	16451	jx2phZRSb1MpSDnKKsfQV3AMeHqAtKRmNobTtMqy3gdVhubrTaC	12205	17177	17177	1619031060000	orphaned
24558	3NK4p4SZgMSErbVF7nVDj36Gex5SptaeKr4TVRwFqjxY1L5c58ZV	24555	3NLYNYWChzWZcC2kmYvxmVMPkawWeHg4JHimyWcx36ffcJiV84U6	1617	1288	464	12463	16455	jwzpC1Jv3Mw3R6gH96qx8d4EKqU8GDvFeh1nXqV6sBXhgUJVeLu	12207	17180	17180	1619031600000	canonical
28262	3NKktibwiwHQ8MTx1r2jfHTkJsCYmkSbks2ojq6LFWF8B6fCu8Fw	28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	1481	790	553	12463	18974	jwqkBffsoU4JBk1np5DYEXstBquHPpwK11TQjduPrpiQ4ixJXtb	13972	19690	19690	1619483400000	orphaned
29418	3NLTNtvx9rkq1n8QB2R6x236MrVMpDktw4JXc5G2aZisFbXeCHSP	29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	1523	955	578	12463	18974	jxr2TeY2Zj3BT9s2aPDCSfNBwosijCkreQLFtXi9mht8j7SKMS8	14504	20416	20416	1619614080000	orphaned
24524	3NKeaZ6bj82BDwNyb6t63kwzRVACMEpFT4CXRvSNBu1oaUd7ZoCa	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1675	1342	463	12463	16422	jweSLCkLBV51h5Hc9dq9JEMiqs2gFji5tuhLHWrKHpvby8iXKjk	12193	17159	17159	1619027820000	canonical
24521	3NLC2zq2ESKte1gSKw1zREA25jBGaeSbvwASaGvarapkxhPug5XF	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1402	852	463	12463	16419	jxERQ4AChgDkxZCtRgX9XjiMuLP57F5bbeRwSf4uyZaQ5EVhthy	12193	17159	17159	1619027820000	orphaned
24534	3NKYZMuP9x7Dt9YWGBr28MBKLSSuR65TCEJUzSJavSwvQYySux5s	24533	3NKmB44Wftf9aY78JUjUVgnJRXJco1XJS7TtNfAF3h4FmpeXnqgM	1477	1224	463	12463	16432	jwh6H59uhbjxRxQ7oi9vuPGYncoiyAAXHMDRyJ1BD2yfCX7ute7	12198	17167	17167	1619029260000	canonical
24539	3NLwECk8iVtvaAKuSf5nKpy9sfjuLVvLFXRH4RhmDxcEETcTXWd9	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1541	1298	464	12463	16436	jxSEPYGa7X8uBe25g4GjDkv53qyMupLKtZmwb48SG8ps2AcVzAh	12200	17170	17170	1619029800000	orphaned
24542	3NKQTnSF2DU5eZK4g11tjx11R4zp2gZJYAUkGTGkV3Tc7hxSeA8H	24540	3NLoEsXNQwyo7vzDQkYgHboQekZ5sEH5Sr5KAagMzESesiFJvJ4e	1460	376	464	12463	16439	jwJMhvoQxoUPb3JGMdWmnw1PGv9uaG1EAJkuLNEACbFbJwZ9s4C	12202	17173	17173	1619030340000	orphaned
24548	3NLeNbtaeT6Vp5U172G1735MySNxvSyieatpkvRGw7ve1o58WGvc	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1406	1393	464	12463	16445	jxJgHuQbUCBrWdgmqb8GhmJDgu7nqWNrxCehf8Wvwiw5PvU8mXn	12204	17176	17176	1619030880000	canonical
24555	3NLYNYWChzWZcC2kmYvxmVMPkawWeHg4JHimyWcx36ffcJiV84U6	24553	3NLT438QQxjWmfVSQpqEqTZc6KwsZXyFoBnSXmLpEg8p2tJ4AuaL	1547	1378	464	12463	16452	jwxWjPTZ28Cd9GQUsQt6ZVQUqVavxKvqEGCFYkK6NkGnqFHhws1	12206	17179	17179	1619031420000	canonical
24561	3NLCYEvL8UbmNT55h64B33XhSMpSALAE7pNQaTT7b5r7fwXPCy4R	24559	3NKWQSRozh5MtP6jQFzRJ3JsNj7hy1fF54f1s1eKCbLqCALrFF3L	1594	1326	464	12463	16457	jwfVcQN6zJonAeaxY2RBWHipAVX99tXM3MBWDHdJHcVbffZaYty	12209	17182	17182	1619031960000	canonical
24562	3NKHW3rNF1TRnSxESmxpfubLtmamV85iaSjrDiD8Kc2MyM17EGn2	24561	3NLCYEvL8UbmNT55h64B33XhSMpSALAE7pNQaTT7b5r7fwXPCy4R	1406	1393	464	12463	16458	jxRK8LSLfREbHYxYR917e5XL5qvAVgMmL64t8oP5XaYQ1LzqzCj	12210	17183	17183	1619032140000	canonical
24563	3NK6xWJhPzSyC5LPJjRmmzNmXat3wNYddiKrZSu9zJvWKmJrkViH	24562	3NKHW3rNF1TRnSxESmxpfubLtmamV85iaSjrDiD8Kc2MyM17EGn2	1581	778	464	12463	16459	jwohsRda5RAruuf2G5BG1rGdg6ZfCCwwwQSMBDBguDTXZ5EZqXn	12211	17184	17184	1619032320000	canonical
24566	3NLk2NqZgwk7arL4VFCaygE8yALsgkyHxDWGzrNisuUPHSHCg7Gb	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1578	1170	464	12463	16462	jwQ55P4HPNyJEyD7acvEdwnpLwWMU2xcqp2oeRDCbY9nArAYvYQ	12213	17187	17187	1619032860000	orphaned
24571	3NKC4sgDyXNY21LenF2MaWMRbNs6EyttvzFmijpXASk5SWuwcKLH	24567	3NKZhmCSiQErbjcsVz4qPMvNgBGNYv8o2cFST67iKSkCPnWGGMRs	1534	431	464	12463	16467	jwYMrhpemf2cWAJDe7uuZw61snagFTTita7JaPViNxS6iYvRs1x	12214	17188	17188	1619033040000	canonical
24572	3NL38UGQUjQudo4jBEtjgYA83B779bNUXS6CgreJj3rycwQaSboi	24571	3NKC4sgDyXNY21LenF2MaWMRbNs6EyttvzFmijpXASk5SWuwcKLH	1541	610	464	12463	16468	jxmu6SNVnKy3zDBh2VeVW9UJAbP5tBnRejnLtbzkcGYuvNa4i1z	12215	17192	17192	1619033760000	orphaned
24575	3NK6Vr7qwyf5gVfVc6xjeatB9utT47pXBqrePYkdaz2vHfGH8Pxw	24573	3NLsG2Z5fZYn6tkDFbj1bFnjBExHknvdhrGhhhypi9yXsUAi6Nmr	1402	810	464	12463	16470	jwHmqmYu3nEqatt4KybbBvxzCCW4Th1qqPRXPZZ6TidJuLC8K95	12216	17193	17193	1619033940000	canonical
24577	3NLX9P8v5jRhy611aHp5QbhSMK6MkQtmNJ41VqZrxmcPz5XbCTQY	24575	3NK6Vr7qwyf5gVfVc6xjeatB9utT47pXBqrePYkdaz2vHfGH8Pxw	1531	294	464	12463	16472	jwPaH63A2hB6xDGpnBCCjgmd7EimnFbGxXEmzcutsAMH6pPuR4L	12217	17194	17194	1619034120000	orphaned
24578	3NKepamcLV44GXUi7qTXHqpEsTCF7ikizB5Tre55oByyNAs7xDnq	24576	3NL36Ho5mKGoM69GM3y4nGjNacacqC9uiqHuiEZKzTT3CcUZLoFm	1402	868	464	12463	16473	jwxNXQ8PWHKeFHdGUYzekT3aY5zFd5H7xuvde2VRAxy4jxM9PkJ	12218	17195	17195	1619034300000	canonical
24579	3NKG5RNXeYwuGwRaM1rLidUom9FVj51HRJkrAoMz8YnSKAiBBKB6	24578	3NKepamcLV44GXUi7qTXHqpEsTCF7ikizB5Tre55oByyNAs7xDnq	1406	1393	464	12463	16474	jwUd4sUoKoyShhvhQW5N6JSDegEk5qJYahLHyRznjTjURSb71SZ	12219	17196	17196	1619034480000	canonical
24580	3NLcuk4e9Qfc2fbSpw84kJT418uLzwt9rSA1HtpoAyYfMELz4q7D	24579	3NKG5RNXeYwuGwRaM1rLidUom9FVj51HRJkrAoMz8YnSKAiBBKB6	1460	627	464	12463	16475	jw9UxErm1rSnPmVjeLfGx5ZZi3vXQe3w1hKzzsEvTS58BkScs1d	12220	17199	17199	1619035020000	canonical
24582	3NKAejuZFyrjhQtkUtWWwbTt3MGyxhB2AfwF4gXzbSDdwzz5KyzG	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1549	1362	464	12463	16477	jx3xZ6RDHqhARusfFBc3WBZwd8kJMobWwUs47qJdKotNUBqWMVb	12222	17204	17204	1619035920000	canonical
24584	3NLb5Bpd8Q1PRpkqC5uU2G8e93irwb2oeinpZo3vUcq8dDnBvEqo	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1613	1349	464	12463	16479	jwTq7T5vsDH147yG6hpdoe5gUFbUxZPeYz3ejnTWegyDJwANk9s	12222	17204	17204	1619035920000	orphaned
24586	3NLTVoLL46Cwu8pwp39qJDRSTudtorrnumsFRVfWDnLATwS4PQY3	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1549	1362	464	12463	16477	jxs8REcfiKMzBfr9PsMS4fFYjeBDAgVbH5xgnnk6S2MAbuUv55m	12222	17204	17204	1619035920000	orphaned
24593	3NKagtPbbnWZVBDpU2n3N4NAM9Pb3YTeSJvD1rT4momnTUBkZugT	24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	1426	1364	465	12463	16484	jwMZ8Vg1umXJB2orQ8R9PsT1wSwMaAuuQJ4nSUbzCRH4cLvU4uM	12225	17211	17211	1619037180000	orphaned
24595	3NK355cxb2MKRf3tvnRwQJvsNksrmqSiz5YirkprYakwdELHP15j	24594	3NKLNH23kNEJ99jL3fjBHmwWPq9dBP7HAMZaQAhGSmpKyVEoEesh	1403	782	465	12463	16486	jxMsr4AFmHnC5LPkP4QV7tCQDuzky85hUKkoJYBm1ZSr2ws1iSi	12226	17212	17212	1619037360000	orphaned
24597	3NLgtgo2qGCz11vUFbgL7prC7bgzHmLY5HctX933ukwrk36R7Fc9	24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	1609	1087	465	12463	16488	jwgUA7RtBEuN4fMos4XE4SN1V4xJWuLddBPNS4phz9B6sGchJqV	12227	17213	17213	1619037540000	orphaned
24602	3NKupUJKRYFSR9ypLyXNaMheYAB7ioziXTgUYCvXP35ddJVQve6t	24601	3NK8T3cnLq9U65PQ76Z7drCwSeQvmJ7vwUGmFCNiDJK1f8sG8Vue	1406	1393	465	12463	16492	jwEvpemEdV76KDSpjnsR1KtRtHhm6RuUTLMBuAdLBATarCoLoh6	12229	17215	17215	1619037900000	canonical
24604	3NKbkSQoPhaNRKTUxj1ER96ob1JVeK3R9EutBBZw9EXPpCfbLa74	24602	3NKupUJKRYFSR9ypLyXNaMheYAB7ioziXTgUYCvXP35ddJVQve6t	1483	1030	465	12463	16494	jw8adeCWBwXG94GcjAE8oBLe5Zs2sYZCc3TqoAXmauek7hJsWX1	12230	17216	17216	1619038080000	orphaned
24607	3NK7a13buuLBjRMmf8htXvmaU4qRhYGvf4qa48fLWjNgLwLtYpm4	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	152	1084	465	12463	16497	jwAD8iECvmfaaofsNkSC38yJZsEPienRPLwfqKLKTxmEZSLX22p	12232	17219	17219	1619038620000	orphaned
24613	3NK8XqzeyT5QWgNYcaQAxURA65SxGAs5uyN7ftNePwVhLEAWKAJo	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1560	1045	465	12463	16503	jwDQnMoQfqJGSHtUSQyGMGqsyiDBFDLeUcoHagHSJuzA9kBw5iq	12233	17220	17220	1619038800000	orphaned
28752	3NKaVitQkwkiyjo8z2Fsfiafy6ERrWKcoYVv3LhfAug4eNi6jUvY	28261	3NKDkuLK6dnuGKeRs3QwySiFSCkVLbzmMws7kdvLpVnp2feSbeXv	1553	776	553	12463	18974	jwoFKFYNYLc6TmvJFyLUN6FQLVjUYWqnkWNAro34EyEpCxTAjoS	13973	19981	19981	1619535780000	orphaned
24549	3NKvnv8kSWnqwQufvzYiVx3wjh4a7RuMLRhaxwGgdrNpynArXJzv	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1553	776	464	12463	16446	jxfGsGM1kxvRD2JSBtQDrJadR8J2d5eHrTHVWQWpDu2k45KKor3	12204	17176	17176	1619030880000	orphaned
24553	3NLT438QQxjWmfVSQpqEqTZc6KwsZXyFoBnSXmLpEg8p2tJ4AuaL	24548	3NLeNbtaeT6Vp5U172G1735MySNxvSyieatpkvRGw7ve1o58WGvc	1600	1126	464	12463	16450	jwrumf3vbyV2RxQDGVMJf6kSVEK7jWPbL7FTqAdJ5YTZ6asFYno	12205	17177	17177	1619031060000	canonical
24556	3NKDuseYsANq58iUvj6nVbSDtw6zyp7UjJWN9FSP1KJw6W8oYEoN	24553	3NLT438QQxjWmfVSQpqEqTZc6KwsZXyFoBnSXmLpEg8p2tJ4AuaL	1654	1214	464	12463	16453	jxHycjsJCwctCdbYdeq1MzmGobeBUtQi4EVVdHctkWJU3tknRD7	12206	17179	17179	1619031420000	orphaned
24560	3NKxN8oZkySQU4H56eqySztBoybpjeN1SopM1PCuNE73aiPUhDPw	24559	3NKWQSRozh5MtP6jQFzRJ3JsNj7hy1fF54f1s1eKCbLqCALrFF3L	1594	1326	464	12463	16457	jx3vcbUBcX9t22vKn9T2eSLsoPXbxGAvGvmHFS2BnsHiHuKwJbh	12209	17182	17182	1619031960000	orphaned
24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	24563	3NK6xWJhPzSyC5LPJjRmmzNmXat3wNYddiKrZSu9zJvWKmJrkViH	1402	852	464	12463	16461	jxv8LvfjGorkpc5pCZ12p66Rv4n1UdAv4jKRhKSrZViJgskiLu2	12212	17185	17185	1619032500000	canonical
24569	3NLQtdM6ntWFzpg557VYG1xyQ1ReLpcmmd4udoZhaFtRW4M4FBgY	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1460	1078	464	12463	16465	jwDH1DApV7zpP6FNmFyTDgosD933iv2dQwCcLyazh17V7P5PkH5	12213	17187	17187	1619032860000	orphaned
24573	3NLsG2Z5fZYn6tkDFbj1bFnjBExHknvdhrGhhhypi9yXsUAi6Nmr	24571	3NKC4sgDyXNY21LenF2MaWMRbNs6EyttvzFmijpXASk5SWuwcKLH	1541	610	464	12463	16468	jxo5JMMfGGqhEbkUWKxgrHq9LQSyDyz5MijKwfPdVkUxYMBbngU	12215	17192	17192	1619033760000	canonical
24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	24580	3NLcuk4e9Qfc2fbSpw84kJT418uLzwt9rSA1HtpoAyYfMELz4q7D	1406	1393	464	12463	16476	jxj8Nvkp34ZhFd67XYFvscJAtMAbrwgub49L2dmR7U8dsSTBdDe	12221	17201	17201	1619035380000	canonical
24589	3NKwFYeSJV7ZY1cpZ9V1ssHaBL1Z4FTceGQStCdoi2W5CCTQ4DJe	24586	3NLTVoLL46Cwu8pwp39qJDRSTudtorrnumsFRVfWDnLATwS4PQY3	1668	1124	465	12463	16480	jwf49WQQdQKmwk6NuVkFA736Uy6ooVWUL4jRATxujx1icYqCXf3	12223	17205	17205	1619036100000	orphaned
24594	3NKLNH23kNEJ99jL3fjBHmwWPq9dBP7HAMZaQAhGSmpKyVEoEesh	24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	1589	1160	465	12463	16485	jxdQEDD4Ph8V8cMj2uYWgMAqnM87EonmkW6xmztHjYA1c9HSMKU	12225	17211	17211	1619037180000	canonical
24592	3NKyQQ7ZrBmvXvx3XYoQeLdnW8AJSPrja7T6o5uCXeyrtNXH6GUS	24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	1609	1333	465	12463	16483	jwfZNujVq4ehMfyr26A2AbtwomyALS46jLZyCnJUAeCL2afBqk2	12225	17211	17211	1619037180000	orphaned
24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	24594	3NKLNH23kNEJ99jL3fjBHmwWPq9dBP7HAMZaQAhGSmpKyVEoEesh	44	1325	465	12463	16487	jxXtX2xWAuGPsZn73XUw7ZMfvkN8vYvZqvv5gbRokuSUMP7bnYo	12226	17212	17212	1619037360000	canonical
24598	3NLMmEqoufm9Zt1SXgrvCD5qxfb88iquSq13REjnPfMUMjvLXsxN	24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	606	1295	465	12463	16489	jxyfH9wRoK9ZoAfhTy7KJhjMQgRnPzj7NfR1qL9VKnbmGJ4zz7e	12227	17213	17213	1619037540000	canonical
24599	3NLAzUssXUXmFMdexMr48mD3g6tegpL5Y6tDQfunJquc9ZNhbCfD	24596	3NLDTnE9rRCxakGFGY71BbJmE1zfDD3phyhRMFXtU5jtcwpD5Cjo	1609	1087	465	12463	16488	jwnzq3SdpsLRPWMCoDNDdaBiPmw64TTPSbqnCfu1BXB8jNsLBsi	12227	17213	17213	1619037540000	orphaned
24601	3NK8T3cnLq9U65PQ76Z7drCwSeQvmJ7vwUGmFCNiDJK1f8sG8Vue	24598	3NLMmEqoufm9Zt1SXgrvCD5qxfb88iquSq13REjnPfMUMjvLXsxN	1406	1393	465	12463	16491	jxQaZcCcYKbahXuKawJmPVMu6qEjyBhXxaae6nFGrgY44gGujJg	12228	17214	17214	1619037720000	canonical
24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	24605	3NK6hVt3d4rTRXgVrphhUhStv1VK6x3HHWvnrGD2uBvjyKMfuT15	1402	852	465	12463	16496	jxZFuCxjY2z1mHnXxKoV4cNoQJ5BkCNaZhp7mYsfAafmykfgjzb	12231	17218	17218	1619038440000	canonical
24609	3NKk6AzzWAntyyAN1f5hm7nnZi6zKwvC98V3dz71DD4ZDoJ22Rim	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1406	1393	465	12463	16499	jwfF2ksRrX9U46FCrumnHGr9hn3vfvrWCM5WCbc7Ud6mNN4bdez	12232	17219	17219	1619038620000	orphaned
24611	3NKtkuJGgesBuK44SVMhjD1RtCXyotZB91GJ7GMYwm9HZwkgZnGY	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1445	924	465	12463	16501	jxLk6RT2aaQALVyH47W6ZKMsUBnaAYRSiE475TKuA1XRtiXY8Tv	12232	17219	17219	1619038620000	orphaned
24615	3NKAqpfteTPMEDnzv9MH18WdGDe8nSmuH1xGJMTrakxHZm2wruop	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1637	816	465	12463	16505	jwYtCwmx6mruwkbLZDFGfRPtm3UNGWVy3ZTnsBKcL4ciKd3wUNA	12233	17220	17220	1619038800000	canonical
24626	3NKoLVRdj9f7pEH7s4o9fCfAZRuP6yxeYNvR3ohqt9pfTde46Qnc	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1581	778	465	12463	16513	jxSKGWihyyjNZDf4ep3d2GVWP3mQccpENSfRdaVChige8Mkc7xg	12236	17227	17227	1619040060000	canonical
24623	3NKvhZDzkt8LhR21P961WHXGWTBrUgxn62hMmrpEAMwiEeVM2FZa	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1527	1167	465	12463	16510	jxrkxnNmdq6KHtvk7cQ57Q5btR2GckwcPEVSgyv5T2FAmSPfa6w	12236	17227	17227	1619040060000	orphaned
24621	3NLTUcAMRDHLowb4HN2AF6HaZqNetxbhL18JCRkfm82oY9emgsmi	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1527	1167	465	12463	16510	jwu7G1kFLHnCmZAWD9yg8BMr7yotuf9m84Moz5ukW7jdHptBpfZ	12236	17227	17227	1619040060000	orphaned
24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	24627	3NL9p2VvGsoNazcrAz3Kp3qPciaQwZHZEF8LCmEHCPKmqNEHUdMe	1585	1240	465	12463	16515	jwXtuUVGT91DDHFMgiaPqjRa1sntpTYYqdEzRLpmgaCGR5QgLr5	12238	17231	17231	1619040780000	canonical
24630	3NK78TDdqWp6UtE412B4TxTrsc9zp9K9ZcrFCB984w8aQXiFei2d	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1406	1393	465	12463	16517	jxDUkwZ9ZfFmNcvGBsy2WfauMX8n817c4rndBDCxs4HEKGRgQaU	12239	17232	17232	1619040960000	orphaned
24635	3NKHxjicyUaupZJRWJr6n5qi8AbVombkQoMy88ahqb1M5KEhKHFF	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1483	1276	465	12463	16521	jwwLHVj3yu6p9Y2S5kGcSUFj7DXgqhBAssvbzM924EvJkNMLh8a	12241	17235	17235	1619041500000	orphaned
24641	3NLcENnR1LQJiooexENTr7X3xbTSHnWp5fa7eCBQ84SGkzd5EhG2	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1489	1380	466	12463	16524	jwzBbhRpGA6dDyiJMkABXBBqNf5Ly93RkuMPoMALJUYnQZfRhBw	12242	17236	17236	1619041680000	orphaned
24646	3NK5oqC8Zihpxrfq7EFoC88M4khXQdZmciRB9TfXuHfGKFqUdpVZ	24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	1549	996	466	12463	16528	jxq9hWShLhCTnLaYwAcMAJD6r67hMFKU8vB93BW2VPRZkBagX7D	12243	17237	17237	1619041860000	orphaned
24648	3NL6e6MkWMKb4uUuSX6NpzYY3ompkx44U6pfziCggJ37kHBxuTaw	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1448	945	466	12463	16529	jxCGs6WDpyzQFEkU5H2wdMcv9kFSjVp5P6TeBhMc2T7Jfgs3767	12244	17238	17238	1619042040000	orphaned
24653	3NLmUGP2eyvaR2vQCc1ffLYb7iWWxbprwAgBXJiVs5mEdyJZ5PQ9	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1506	1247	466	12463	16533	jw7gNNXeRNhuoeowTw26uuDaoWHL3DY3oLZM6KRYc9YgmXB4LCg	12245	17239	17239	1619042220000	orphaned
28271	3NLLzpFRP5ttry4bfaeTNFdvwp53XD1GVviRiwmDC6y4fSoNfq68	28269	3NKgYnDiLWJg6VW9efWoBzdia4FjSNGXeZb7QQAs9zxWRkaYJ2gU	1649	1017	553	12463	18974	jwXAHRTFL1Q6wnNHVLn9mZDLxSEA5wYSKauqPGpqQwBZcaKcjzz	13977	19695	19695	1619484300000	orphaned
24591	3NLwey7uhKSQBBrfH4kLihktrSUrMaakbeeV6qxkXc5d9raXPC8h	24530	3NKiTCKD7GS4DsAhFxJQpXJAc63XtSnXaN2EV4b8aF1QWmRevSDp	1426	1364	461	12463	16482	jwbHmq4mZpLSXyWE9Ep6sa7UhWR7XUqzPfsGnE55FAqrZ6PRn7t	12153	17211	17211	1619037180000	orphaned
24551	3NL67oXzX7qfeqYvJXYikLdGUtJB6nqnoJ9DP1pxWT2xnySnDnuq	24547	3NKqgreLuicXH1GunkqAR6yvi7E4ApxVQ2yZDrwJUPtQtybyWZy9	1631	794	464	12463	16448	jxbaepSkQ6U5pjZtXQ9FnEFj6bT8koyt97Gu7P94PC4GVvqHzkb	12204	17176	17176	1619030880000	orphaned
24559	3NKWQSRozh5MtP6jQFzRJ3JsNj7hy1fF54f1s1eKCbLqCALrFF3L	24558	3NK4p4SZgMSErbVF7nVDj36Gex5SptaeKr4TVRwFqjxY1L5c58ZV	1407	1395	464	12463	16456	jxCdajxrgdukZqMpaiJR7fvz4eaUmZ1d1MHz4rdnxKJWnvwPcsC	12208	17181	17181	1619031780000	canonical
24564	3NK58iAebpTuQu2iF4f5dwTrXkPkHPpVpG8ybXVy9Pmi95eAWEjm	24563	3NK6xWJhPzSyC5LPJjRmmzNmXat3wNYddiKrZSu9zJvWKmJrkViH	1588	1146	464	12463	16460	jx957sgLfcwUj9NTUs38BsScgstiDsJYyrGtNBtGiiaoxxRx3mX	12212	17185	17185	1619032500000	orphaned
24567	3NKZhmCSiQErbjcsVz4qPMvNgBGNYv8o2cFST67iKSkCPnWGGMRs	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1405	867	464	12463	16463	jwjUiewjQt3EiW5Hgf1V6D9EzJufnKFC46cr5rk2pNT2XHFX6Ae	12213	17187	17187	1619032860000	canonical
24574	3NLbsWCgjwcMDhtCu8pUcQyLDEfA39THJDc9kYahmH3qzNMLdpYG	24573	3NLsG2Z5fZYn6tkDFbj1bFnjBExHknvdhrGhhhypi9yXsUAi6Nmr	1403	824	464	12463	16469	jwV8E43449GPfmTsVJwbeS5TTiMW2y5Vj59kENH2VspRNze1KPg	12216	17193	17193	1619033940000	orphaned
24576	3NL36Ho5mKGoM69GM3y4nGjNacacqC9uiqHuiEZKzTT3CcUZLoFm	24575	3NK6Vr7qwyf5gVfVc6xjeatB9utT47pXBqrePYkdaz2vHfGH8Pxw	1447	1345	464	12463	16471	jx2XLSYUHrkUDdhDmryePDav4JELQotEDVNtomD41f1r16zcaTw	12217	17194	17194	1619034120000	canonical
24583	3NKVYeEZ4PNeGiCF6huRXznFq8i3sVGRqthB8NSi5A4DmnnCmWSK	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1440	1377	464	12463	16478	jxTvo82LrmBtWiaG9NXPF6pughRNoVABryrB1mJLCn77R3HjktX	12222	17204	17204	1619035920000	orphaned
24590	3NLUuKGLePexFYMTqyd7FXtwxgouRaYcDJuFQTy2uquehMEd8nhm	24588	3NKmUgiVaKLDCSAoJeJq7YG6Hd3oL9pasYwwEmNRxjky1bavAmD7	1402	862	465	12463	16481	jwmsTYwiQhfRd28AtTd4ZPYVT7dDx3RAikTV18pwGWtGovqfEQa	12224	17208	17208	1619036640000	canonical
24600	3NLNjRHCoZtmSs5TYrgAtfcNWhnxNiKP6mE3meFmpi7GX1bP7ebN	24598	3NLMmEqoufm9Zt1SXgrvCD5qxfb88iquSq13REjnPfMUMjvLXsxN	1648	1038	465	12463	16490	jxWPWNxAF28uoP1e7foG7B3QXuhqKpAh9v9r4cGMhJYf8gzpXoQ	12228	17214	17214	1619037720000	orphaned
24603	3NKjCikms9rDREvb1FvJEHyTnDCTmWr4wRhWxqYnkKYcvdCqzPq8	24601	3NK8T3cnLq9U65PQ76Z7drCwSeQvmJ7vwUGmFCNiDJK1f8sG8Vue	1624	1334	465	12463	16493	jwceRwLZXLKfvdbj5HN9yVXLuLjJUiihWCaQHRNf4XiYcFwtMrC	12229	17215	17215	1619037900000	orphaned
24605	3NK6hVt3d4rTRXgVrphhUhStv1VK6x3HHWvnrGD2uBvjyKMfuT15	24602	3NKupUJKRYFSR9ypLyXNaMheYAB7ioziXTgUYCvXP35ddJVQve6t	1476	1245	465	12463	16495	jx5dzZ1qtkEqtj6g8KmUozKKLYGnummKhFWpaEAMxAF3c5URQA3	12230	17216	17216	1619038080000	canonical
24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1585	1366	465	12463	16498	jwUG2bkN9WB2pPmGAD2nrEyfR252H6W9Jz4pJRrcBrKAZ7Rs117	12232	17219	17219	1619038620000	canonical
24610	3NLWd8TmxMYEagnQzTJFH13Xw5ERRWXYZcjKZnXk3hG7csAUfhVh	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	606	1049	465	12463	16500	jwbhiiM7bsyVP4vMcQ7UbgFtRHHVFo5VoAtyuugZRDhtof462R5	12232	17219	17219	1619038620000	orphaned
24614	3NKPWzZkzgCwKxUbZh1HLMw9RG2Qgzyp1ixEQdXmkyjTNqdnN8je	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1587	1357	465	12463	16504	jxNWk4hG9NAqaSSjFFCtSrJr1vUkMK5SwzEEsJuFScLxJwKQ2BW	12233	17220	17220	1619038800000	orphaned
24616	3NL25PAnGt5eVnH9JnuHBKy4GH21bG2e9uLsnKAfCWN8XM5BVdUH	24608	3NK89Ecsn9s2cmfzPmtwTNbpojV3MXjzYULKdwSeQpsYDfuhfCBM	1560	1045	465	12463	16503	jxCm62cBCZDGAZX3zuAgQ6DwriD8GxkpopoQtyMoLUX4KtzsNpb	12233	17220	17220	1619038800000	orphaned
24618	3NLDWydD4EA2qKfRKbp1v9JVma5SA44JtMPrTXiMdKPEHfM6AHHd	24615	3NKAqpfteTPMEDnzv9MH18WdGDe8nSmuH1xGJMTrakxHZm2wruop	1402	844	465	12463	16507	jxBd2QKtTHhXtb6nB3TsxbrYyijBRdXeXgnKLkHtZmYpZYvGsZX	12234	17225	17225	1619039700000	orphaned
24631	3NLYBpHzaYV2HEhEYBccARNpUs3JQbFyq8qx6S6Tzd6vYGBw5RJx	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1651	1055	465	12463	16518	jxVhS1bZwYewD1eS41oyqLiNhTkeH6b6w8FDSYYhJ5pCaWAhuMn	12239	17232	17232	1619040960000	orphaned
24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	24632	3NL51qEQZZdc3cpDAnGWws1f2buNeEuNz5MWhr4nM3nAYEiDpLPw	1445	1290	465	12463	16519	jwmk7osKbdBkYzKxyRrf1472PSWv8JdkNzNt12ze8gY8uCNmWvg	12240	17234	17234	1619041320000	canonical
24636	3NKrZT75CphPTjzewC35LR5TZtbBKyELfoBZnUMqippNhv2sH9PD	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1483	1276	465	12463	16521	jwwLHVj3yu6p9Y2S5kGcSUFj7DXgqhBAssvbzM924EvJkNMLh8a	12241	17235	17235	1619041500000	orphaned
24639	3NKJEL7FVYTcMVrRjGqeQsvz54LkuHzuMWJLwyGt1EvyefNqUNE5	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1549	996	466	12463	16522	jxNxaALNZoxiTdpLs9JSHKWsqFwahzG6299aD2jmQzqtxqY5TEH	12242	17236	17236	1619041680000	orphaned
24642	3NKUQr27xYxqmWfgmmhU5iqYUGqc8aWuVsmuz97gKYJ38xkVfB5m	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1489	1380	466	12463	16524	jwQkiVh7d6YMr3NEaf2CC26Hnc7x6qe5b9fnXC9CGQkSDAag6tX	12242	17236	17236	1619041680000	orphaned
24654	3NK4u2ynZjLWMzFoe5Jx5zzyYxAEYyYM1TWuWzY9YBYhrBxScVZS	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1637	816	466	12463	16534	jwMaDHS5CteherdDwhuTQDQ1TeUsM8iYW9gHnpUno8UonLRgcuc	12245	17239	17239	1619042220000	orphaned
24655	3NLQiaraNGxVFq1yRwNR5EegP8uXLn51W1Ci8tSYemXak6YnLdSN	24652	3NLDTCTVWL9URLz2Bdvj9npFykNN21YV7LamWdX6TK1ihGGCVfTv	1585	1000	466	12463	16535	jwUGaZkgyubMZqVXA54KNDjX6UB19Dw4Uc5vJShHaYjXkiaWc8b	12246	17241	17241	1619042580000	canonical
24657	3NK9qHEM7npeGQJNbNEgTguCxqfedZVHikxgNgHBRsJ9mMjbWE7v	24655	3NLQiaraNGxVFq1yRwNR5EegP8uXLn51W1Ci8tSYemXak6YnLdSN	1508	1387	466	12463	16537	jwvUxSBKXFUTT6tSrUcDdYLQNESqiT2JYcidXqdZUZFkdKZNfeG	12247	17242	17242	1619042760000	canonical
24665	3NKVyeCKxoMwhG2Wj8aC3wBzbzzYuFDKMjBZ5KSCs8fNt2ZQZkCP	24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	1600	1372	466	12463	16544	jxRWGkaA9FNhBiSKQ9fSTc42EEj4WuhHy68bz8k9UuwM1BrdsW8	12251	17246	17246	1619043480000	orphaned
24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	24681	3NLYBbPaLCsD4n6qdPZFYKjZ81MaTT4gYuydLGiQBwPTA3pUMPjQ	1407	1395	467	12463	16562	jx5QV7CP6ACiq9GQBwdJpU7c4PV98n4mTDHbHKS33zCe6vUdDyy	12261	17260	17260	1619046000000	canonical
24684	3NLJzpTKPN1L8BM7EStbtaav1nYitLTuaQLQkAwRkYwVV9NyzMen	24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	606	929	467	12463	16563	jx7osrD5ipjz1JwW7MrD86wZuU9pijqzkTzz7BhTXSSSwBNTtTT	12262	17263	17263	1619046540000	orphaned
24691	3NKFPYV1YZ2UaxZcUPk7rDQxDEHKx9MdMhaAHn8hj22GL1bPABPa	24689	3NLub4TsCqhMGPkJfbFWPBmQRhkqUCk5kCRc7hP5GEyu7YUFYwZD	1406	1393	467	12463	16570	jxuYoZMaphRuzcLSRjWtcnUDkuqr6qNWeVvti9tjwzQB5nzR2QC	12264	17265	17265	1619046900000	canonical
28277	3NLSNWbq4zAwbprPoiusP6pMfp4wUvvepF2jtiSzgZEyhwj3AuyW	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1651	935	553	12463	18974	jwje451HLgH5DZPXLXmGVpBv5MDreStZ975oXELmgpbEraaPVKR	13979	19697	19697	1619484660000	orphaned
24617	3NKhMeP6q2hYWkoTkY9bd42RsKNr6ypMRTSCV9x1LtZYA5sEWYhH	24615	3NKAqpfteTPMEDnzv9MH18WdGDe8nSmuH1xGJMTrakxHZm2wruop	576	1355	465	12463	16506	jwcdBAPmJhfMd5kRtc5Gv8iH6jjnRtcgXUWSoL2CXqMF1xi9tPt	12234	17225	17225	1619039700000	canonical
24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	24617	3NKhMeP6q2hYWkoTkY9bd42RsKNr6ypMRTSCV9x1LtZYA5sEWYhH	1599	1287	465	12463	16508	jwB8zLZcyySnmgFd285dtNB7xQhH59fCiiv8mgukQWUety2puNR	12235	17226	17226	1619039880000	canonical
24620	3NKNwYTEvoZ95jqqt7atapwHM4EyK1Vfvnw6wuXHQQK77TocrfDi	24617	3NKhMeP6q2hYWkoTkY9bd42RsKNr6ypMRTSCV9x1LtZYA5sEWYhH	1646	1108	465	12463	16509	jwNmJYTfPYiarL5r1U3PTW4c9mLWtAZUmhXPKMvfe9BVynhvv2f	12235	17226	17226	1619039880000	orphaned
24625	3NKsTFHjjpJ4kYZLXDkhoxtVWwTjdgfcBRXJoHpe4yfZCNTavb1J	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	563	1113	465	12463	16512	jxh4FX5SBPLmh7VyBLgg6riStQGkddJtQj8mueT9ebK3CsrndAQ	12236	17227	17227	1619040060000	orphaned
24627	3NL9p2VvGsoNazcrAz3Kp3qPciaQwZHZEF8LCmEHCPKmqNEHUdMe	24626	3NKoLVRdj9f7pEH7s4o9fCfAZRuP6yxeYNvR3ohqt9pfTde46Qnc	1555	1221	465	12463	16514	jxEkoLCCBDKEzHeDRAKYWnENeBPN7iwigCQVFNWZzo1H5caH6tQ	12237	17228	17228	1619040240000	canonical
24632	3NL51qEQZZdc3cpDAnGWws1f2buNeEuNz5MWhr4nM3nAYEiDpLPw	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1651	1055	465	12463	16518	jxovquAo5CHzcGE1aizQuqfpstfyi1Cxb1siY9BUdeoJ3MWdTTS	12239	17232	17232	1619040960000	canonical
24629	3NLGgjUcchdi4XWu9rBTe9AmkoJeAEctks5UQbS9iVR4EbDvp4jH	24628	3NLRrQ2s1GbPnoGFxs4DTP8zBSRcKH2twu33eHVpdisvuKPoW4Z9	1403	824	465	12463	16516	jwLAwKypmbZPZAUNnMsKKoTQ5WqVyACGkBnwTLMp62eWpdrqq9p	12239	17232	17232	1619040960000	orphaned
24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1649	1137	465	12463	16520	jxgs3ZWtkQgn7qystmWhPmsrEM55fz7DaTAJKG2H3esDxyNCroT	12241	17235	17235	1619041500000	canonical
24638	3NLLBY8dr47Wuxmeb1wqMdDJ2jCNRYLUHZhscTidTZwgRDKr69TD	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1649	1137	465	12463	16520	jwhUw3rj1DVJAhnwQoTajj4iRh93XReZ7AWobk22bAKZgQAFn96	12241	17235	17235	1619041500000	orphaned
24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	24634	3NKb643WBTCjWCuk2B5NYHgy9XK31wmyAFiLPtqGznPrWamY1Xdw	1403	824	466	12463	16523	jxM3ZS1E5CxfsnqVTmWniVSeoDTto3CVsmw93wtQRgRgLYiKtHu	12242	17236	17236	1619041680000	canonical
24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	1406	1393	466	12463	16527	jwvJDsDQ5y96VrMA9fCRc2L4UCJDTZqumwkM7HnmL5HRVvDVXjz	12243	17237	17237	1619041860000	canonical
24644	3NLDExJndjNfDFkB5hvucHE8PT3vBK8fRsZNZpoaY3rvgbJ9pXkp	24640	3NLrAS6bKDCCgcJzn4CWeRGAHVf1vNgbwWPempxoffD6DZvLH9vD	1403	812	466	12463	16526	jwQzAopXntCFSrwvHVvb7v3m2M3LTAPo1Dr1eU5aHGpvHXQpoPA	12243	17237	17237	1619041860000	orphaned
24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1627	1385	466	12463	16531	jxdWM679kmXYys9ngMaGQqabiEBtck3ww3rFfJonT9ZAqzD13rA	12244	17238	17238	1619042040000	canonical
24647	3NLobknQny5TdBYHKnTK3DYHGdDqTtr7S5jSjWYxdoyDBhQueR7u	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1448	945	466	12463	16529	jxLK1XHxRdtSKEP544VN7csh7WehwByrnLRtBMzfPjgWBQneUfc	12244	17238	17238	1619042040000	orphaned
24649	3NKixajDVqqFYWCvipC7W7RLNjMrqeTsQjaZ3fDeFun2i9ytP7nv	24645	3NL9A2WFw2YqEsbA6duQ6p1fFyRx6Zaxk5e6SPrNr6n8KjvWV2Z3	1406	1393	466	12463	16530	jxFYhrYPwCR9CvDosPDqQzRBGmS6FwBZsECcxywEPuHUUpwmv3K	12244	17238	17238	1619042040000	orphaned
24652	3NLDTCTVWL9URLz2Bdvj9npFykNN21YV7LamWdX6TK1ihGGCVfTv	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1506	1247	466	12463	16533	jwbnViBjHfkmoQssYTVEaRcgKsaxvjDtJQ2Zdsek2NdbUQCC9rT	12245	17239	17239	1619042220000	canonical
24651	3NLRBHARoDbtk6zFnx79a6aXNBSPRQ45Mu4NDCcYS3nQCjid1psV	24650	3NKeXvZfekaGe7Y3HWvQPytV5K6YqrqVSbW2o97kztQkcejXdZCo	1607	1348	466	12463	16532	jxRWsPEHhab6AYJZkhZAx8jgC5u2cAAunAFp8BJa3LWksbPeFkx	12245	17239	17239	1619042220000	orphaned
24656	3NLssdUekiUhoJqMZcHmCCTccjxmZGJrTzJ4ypK9o9Tp72jk5Z3d	24655	3NLQiaraNGxVFq1yRwNR5EegP8uXLn51W1Ci8tSYemXak6YnLdSN	484	953	466	12463	16536	jxU4e6fnvNqA1udCLXQTFwcLy9xP1NpojDctWNy9Fx2i5t29kLh	12247	17242	17242	1619042760000	orphaned
24658	3NK9KSTR6WFho3nCHKHZ6xbZJsPnw4UPt4VzCx8v4X4wWa9vTSdj	24657	3NK9qHEM7npeGQJNbNEgTguCxqfedZVHikxgNgHBRsJ9mMjbWE7v	1599	1287	466	12463	16538	jx7nSCsdsFAhkY5cemes16AQ4F4nquwBU2be2hVyC8Rbea9ahrE	12248	17243	17243	1619042940000	canonical
24659	3NKruhu5BnsvQ9MXCBke4Touex37bxLkhELDrjbLbdAjDFDzjxqt	24657	3NK9qHEM7npeGQJNbNEgTguCxqfedZVHikxgNgHBRsJ9mMjbWE7v	1406	1393	466	12463	16539	jxgntpDB5LHzRQQwet4HvUL6soLpraDPxmpMN8zeChQgZzpmTg4	12248	17243	17243	1619042940000	orphaned
24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	24658	3NK9KSTR6WFho3nCHKHZ6xbZJsPnw4UPt4VzCx8v4X4wWa9vTSdj	1507	1280	466	12463	16540	jwuGxQNfL3DeHpUqfCkjqfHHYJgdcAAoZ7g6KPuFfZwus212KQq	12249	17244	17244	1619043120000	canonical
24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1493	614	466	12463	16543	jxUwhmTqBzMpxtD7aAHzgCgYtGNNXbXrDPcVAdm3A1fpYyeECYv	12250	17245	17245	1619043300000	canonical
24666	3NKMMFVgdveZCDDi94UJKAQb2RbaJY4xNT5hUYFp4cSgaL9oTRBV	24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	1622	1356	466	12463	16545	jx3EkqwzYk2sXp4PqFy2o3z8ZBB2HvCBFAV1wAhEux8gDJCTZqR	12251	17246	17246	1619043480000	canonical
24668	3NKec2C88b3KaYcNsnztgMTj4tEch7hmegzWZN3pZSN47fxU38Ce	24666	3NKMMFVgdveZCDDi94UJKAQb2RbaJY4xNT5hUYFp4cSgaL9oTRBV	171	1374	466	12463	16547	jwPnp6QPTwf7t3WDAiA5U9hKbHW3Wzv3VHTQLrZAuzrBSUCamRw	12252	17247	17247	1619043660000	orphaned
24670	3NKuzE7WAPBQJ6wZPFG26qyGW9oTgTmzDXn4dAhLR2ghYqiHn3rP	24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	1642	1367	466	12463	16549	jwsd9g8ajzUBDm6GH5ZeXoxTPQRXLZEeKLSrHTTDLgAVevWLLDh	12253	17248	17248	1619043840000	canonical
24673	3NLcqX4YEamMadFPNBo1jSBwvDWKqrbnKuoAW3AnR6Y4sixeZyQj	24670	3NKuzE7WAPBQJ6wZPFG26qyGW9oTgTmzDXn4dAhLR2ghYqiHn3rP	1668	1124	466	12463	16552	jwo7ASuPdHCKyeVMvBm5b4UUHEhUpBoZVf8hQACxZ7zd9eDdRpw	12254	17251	17251	1619044380000	canonical
24675	3NKdRjk29cRZ6bBEFVJ8LcfX1P7TT3mV8Gx1DLtfTkf6NxgG3QCp	24673	3NLcqX4YEamMadFPNBo1jSBwvDWKqrbnKuoAW3AnR6Y4sixeZyQj	484	1073	466	12463	16554	jwKxFSs3AEE2P6HuhVAA7o1aFeNPuiFy86raTn8fyrC2y5QFBLC	12255	17252	17252	1619044560000	canonical
24680	3NLPj9rriR6gbd5PWwue1y7LKLPRkGwSKwcQeXMgMkjUh7DFLFFk	24679	3NK5k3oNkxeUhV8PR59oWmAYsM5D3mq6NAkA6YqAbzUmzk2obNCU	1407	1395	466	12463	16559	jxx4EF3Ug9vpCnbKNAoa5Dzrod4cXSCh1kT2LPrgtCf7Pf6Mehv	12259	17256	17256	1619045280000	canonical
24681	3NLYBbPaLCsD4n6qdPZFYKjZ81MaTT4gYuydLGiQBwPTA3pUMPjQ	24680	3NLPj9rriR6gbd5PWwue1y7LKLPRkGwSKwcQeXMgMkjUh7DFLFFk	1407	1395	466	12463	16560	jwY6wzc1mXqq5Zj5kqGf84u1V22E9yst5VR9XA8bb7AswamUPSs	12260	17259	17259	1619045820000	canonical
28276	3NLB8wXsnkioek16fMk1BHJqcwqoTgMB8trtgp93abMVnf6T1tDw	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1651	935	553	12463	18974	jxjKN1NP85qWeQ8yF2uVPaVnTV11CYYqHuHrsSpGdaHjZSYzr4Q	13979	19697	19697	1619484660000	orphaned
28753	3NKCq2xLUvd1k7xWojTX9dBxZ6irQHnfSz56qVbyLCAW8j1NVxgG	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1553	776	553	12463	18974	jxq1d4PuMgvFav1rBizpQTjTb9JYEZ2EjHjifzdoWMb8ifB5XSi	13979	19981	19981	1619535834719	orphaned
24661	3NKBgZCxiG7nmpru9Rpv7HBqA6owzLXFiAZ1F6V9NsPcGDdy8CYU	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1406	1393	466	12463	16541	jwGVH8ZEbFWagdSgSJ4vGJkLMowuMeDhZHG13Ya9v5ac4FKS5kb	12250	17245	17245	1619043300000	orphaned
24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	24666	3NKMMFVgdveZCDDi94UJKAQb2RbaJY4xNT5hUYFp4cSgaL9oTRBV	1407	1395	466	12463	16548	jwjGxhHSeHhKXcQEp7rgmQGWtxmosWAKB3vBzVtNfdERo5ovvrH	12252	17247	17247	1619043660000	canonical
24671	3NKNU7uUyEnzV2cPYeT8Aso1LUtxEoGT7QtjzqFxSwGsyf7b4f6W	24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	1406	1393	466	12463	16550	jxo9duGcgKkofEcqT6JjtatC8Mwj66CykghNMKv3uoFn2SP67KX	12253	17248	17248	1619043840000	orphaned
24676	3NKgKarjrGxmusY98kNTPxU9Cj41TDDjfMXmNzTjuo7AB6Q1qTS3	24675	3NKdRjk29cRZ6bBEFVJ8LcfX1P7TT3mV8Gx1DLtfTkf6NxgG3QCp	1656	977	466	12463	16555	jxw4TuNYTUqxegVGvubLGogEFfrCpLLEnYAHETveLMe8cJydvgh	12256	17253	17253	1619044740000	orphaned
24678	3NKy7mzGc8wfq2VNQwKjYQxQN1jGBAKpF9g8SEMjaX9eQUSmVEDt	24677	3NLJaabuGRM91EuAgni6h3ngecvtx6mQdZbgP4soishtPZQhsH7v	152	1204	466	12463	16557	jxd9np5bfavbaMq1dvEBhWhK3yMu1SVtesASuy5CaCkog68DrmZ	12257	17254	17254	1619044920000	canonical
24682	3NLh9mPk8jtmZ3kYKtMsytcQcEGKfUsFkZRtokSmkJZEZYtXxcfq	24680	3NLPj9rriR6gbd5PWwue1y7LKLPRkGwSKwcQeXMgMkjUh7DFLFFk	1631	794	466	12463	16561	jwuwhQ9ymTatjVnqSybXJDby79LfLAFYwTCWr2oAfcx1q523Vic	12260	17259	17259	1619045820000	orphaned
24685	3NK9ika2EN2gX9WS8MQzf9CCnotR4rGSJDDy5gg4qgZ3FY87VXXy	24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	1490	1028	467	12463	16564	jxphSxdSjUxgyeymrsJsKd3948dnsDitnwN3zUVc9zhanD3M6tm	12262	17263	17263	1619046540000	orphaned
24689	3NLub4TsCqhMGPkJfbFWPBmQRhkqUCk5kCRc7hP5GEyu7YUFYwZD	24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	1439	1153	467	12463	16568	jwkLCxuczByaKdThYLQ3gEwpdszLR1f1tJ8kyeLFRA4wdeDFKfM	12263	17264	17264	1619046720000	canonical
24687	3NLgdL76foGpvX7cE4MVGqeU9ML3Qeo6LvMyd8xRLJiqZaReYKpF	24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	1602	1243	467	12463	16566	jwGLQZxY7wSs93fp93vi871AXBT8rqsLpKS1SV2zq8mtCWjTFtP	12263	17264	17264	1619046720000	orphaned
24692	3NLW7szmuijUpUHJqZWLGrSCwwroY3yWCsRjSvJjvgQjojFtYCD4	24691	3NKFPYV1YZ2UaxZcUPk7rDQxDEHKx9MdMhaAHn8hj22GL1bPABPa	1406	1393	467	12463	16571	jwvbYFoQn8W7HByGrBWcnh2bVQtSH1SAwXVEPssU6cn9GxTG1ZX	12265	17267	17267	1619047260000	orphaned
24697	3NLuSNkHKKVnpVZSjUAbLLsmcm62UBNh6GTMdnrenrBRcKJG4mM3	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1627	1385	467	12463	16576	jwEhqTJxXxHbEUZhTtVN3sM48Zo58mLupXPiK5uzETF7PVTZ4pc	12266	17268	17268	1619047440000	canonical
24694	3NKiF8NUjghsZk6DcgsxudJ81Ue8jzkLbGfFhaHF7avtrnqJE3XT	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1403	824	467	12463	16573	jxSg8wt8xMLThuVH4qZnzNNyFeUU1cvza5qSwBtKLDnfuPVa5z9	12266	17268	17268	1619047440000	orphaned
24698	3NL9SmGgUMY3CHKa1h7ku2oeGfninJANqWHGrJLeN3pjPdQBWRTC	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1529	1316	467	12463	16577	jwxeWww73VLnkzhjrobu2UURppW2hDuafx7JQuEVUL2toYxmQ6p	12266	17268	17268	1619047440000	orphaned
24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	24700	3NLvi8C3djharFyVgK6SXGPbLCP7d2yGphn87hSCRDKY38qWmMnJ	1406	1393	467	12463	16579	jxSznf4bx7behvoykmvoUPrYgDWnmjYmwKX5sJNiZoks56QDin4	12268	17270	17270	1619047800000	canonical
24704	3NLFnb7CLBVkVpztpDojphxL9RPEYCorXhhZZWGguaebKr4iQ9YL	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1529	1316	467	12463	16582	jxsrs5XHvGvXF3DyWeCfWqVkbEHkKakxvyj1Gw25LT1HtEoMCya	12269	17273	17273	1619048340000	orphaned
24702	3NKdtDuMRGrF5xjrVwq9eXseKu2vdHcjTSv3waVRtDV1vrwDGREB	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1457	1391	467	12463	16580	jxHwoYyipzHcHs45HysYzs2sWjq58GJUo8brNpHTYhFn6oxavA7	12269	17273	17273	1619048340000	orphaned
24706	3NLeSAtkbCuuFegBnctwvsWxJ813zyZxNjiUe7mVu4pQNBGsZSc7	24703	3NLVgA8FvL5bBZ88Tqhe2gb47WiZ49x4ouw718qSaE62Go3szVde	1419	814	467	12463	16583	jxi3SPga3cb9WuqCcwv56VdgCqBZnGJHvWC9D3bX6T8E7UhJgjg	12270	17274	17274	1619048520000	canonical
24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	1444	1381	467	12463	16585	jxoq23FDapbPWPAYMmVUzxVcdAp6KdRfmarUxdtk6RpwN7fcaDc	12272	17276	17276	1619048880000	canonical
24709	3NKRYFZbH5HkYNZW6aeuCGJVtjiMKanTxX59UupdgZjN4bZYayKU	24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	1444	1381	467	12463	16585	jy1DSWsMmsGgHzo6DjzGmN1aCbpj2VJCeWzt951gwyYVV5NCmqd	12272	17276	17276	1619048880000	orphaned
24711	3NKcWYdv4vW3yY3JBgQY9XpRWVoCahjC3g6Yt4MyBYabFvb8kJcG	24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	411	411	468	12463	16587	jwLvhUovmSt1B5wQYRkBpuhWcKz6cgXgfnK46mgX8sqh9Q7iDMW	12273	17277	17277	1619049060000	canonical
24713	3NLF7L6W1KqjJ8Y5z1iYBVDRgg7HTuhurkXTizyuzEx3iHvnfG76	24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	411	411	468	12463	16587	jwLvhUovmSt1B5wQYRkBpuhWcKz6cgXgfnK46mgX8sqh9Q7iDMW	12273	17277	17277	1619049060000	orphaned
24714	3NLSfF8G95dn6hMvYok8uwNnQBvNTf3weNkBxp22xzTEbTjd5PNf	24711	3NKcWYdv4vW3yY3JBgQY9XpRWVoCahjC3g6Yt4MyBYabFvb8kJcG	1476	1371	468	12463	16589	jxWkLRJ8r5c3aimNmzLgVG44uGGo2Jk9HMYNEXvRZMoxKNZQy4o	12274	17278	17278	1619049240000	orphaned
24716	3NL5hN2WQgtSMxSaYvTtDVijaH2XSb5WPDboVEqxcbsiEwX1c3SV	24715	3NKen7UxBu2ZVYqUVjdse6URoU8X9L3ULGmLN6Vf8k419uA25RYi	632	1382	468	12463	16591	jxKnKHyxVM2btWxbk3Xxtm27HUu6WbjuUgnAMix1KnSzWh2mLfa	12275	17279	17279	1619049420000	orphaned
24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	24717	3NLRoQDMdWdN7pXGtZ9suTGYFjaR3xvDn4JrB7NPtK3KW66oYe8c	1581	778	468	12463	16593	jweb8CkGaVmVrzv9Vx7swnrXZC3KxSxbxffQcf5PjmZN5uBhk1e	12276	17281	17281	1619049780000	canonical
24721	3NLafE9s364Tbi7AG6umJFPUd3geimSK2PFji3LgA6PcMLvLcGNx	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1536	1187	468	12463	16596	jwUyYyatVwSweBqxZxE7MWQQoNCe4xGx9WueMFfC7BQGUKVrC6W	12277	17282	17282	1619049960000	orphaned
24723	3NLRh9Xmgz6t1sc4b86ywZvNaK8kworyhvoDtg1cdSrNsHThtBQT	24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	1483	322	468	12463	16598	jwaZ5Q5EbQZUyYawZctFwXr5L9SjRLYTyLZfXBSWKjgYszMEPGm	12278	17286	17286	1619050680000	canonical
24724	3NK7LJtabirtH87dWTKHbQ1bKHaJPgTLpjKTEZhNAFtZYmT7wqXH	24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	1594	1326	468	12463	16599	jwBPPmmU1V2QQhje9jsphGVkJq8HGbUhtrfuNqpFj1EqmU4Be4x	12278	17286	17286	1619050680000	orphaned
24728	3NKLPCSHu7WZz2XCVk467zJ2duG14gbdmLHiCeLGBrKnjPDZ7CTt	24727	3NL99YLudunDhzGPNpfspETaqSeQWkoTfi2Kr4uKWLDcPuQV1dnq	1483	910	468	12463	16603	jwYTJa4cdzJMcEtgSv2Fp63WcGc3GAVzh3HDF1C5Kq2RE2Q3GAN	12281	17290	17290	1619051400000	orphaned
28389	3NKfdtHQMmvxARsnEaKzRD7YQvxWyhppVfyvg6gM6gEiLtfpGiS3	28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	448	939	554	12463	18974	jwzhJCtzhXMuvY3GAdt2dyqRy2UTeVKJFKkUkMqknpzVPqZeq8K	13989	19776	19776	1619498880000	orphaned
24662	3NLGcF3SjPMnMybtum331TBb8g94shebUAQZvGRueHdzsFPpH1c6	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1474	1203	466	12463	16542	jwd5PUnyFUPJJNStjoM9gjNRVYCgJVW8CrQkRRi89U2EUDiFjTH	12250	17245	17245	1619043300000	orphaned
24667	3NKgfcZEr8zuijrNqHh3wr8KEQBr72o98c6CCmSJpDEPFs9qtvUU	24663	3NKRcumuLDKtqJpwBexNU5EaR1oaxFQy5pupyinYG9En8hb9NB6s	1553	776	466	12463	16546	jwBd26tokJ81BfdK4ArrHUUrrupvyjqGZEgDL31LchWGA1ToiaS	12251	17246	17246	1619043480000	orphaned
24672	3NKLa7N3SH1wyUUoGUUZFxMgXH8hdMfPeLHihNH3L9GirzLQQspJ	24669	3NKe5x59871hhiCXtHWZSnPgvPXe25NMY6dMZji5ebf5EQ8d3Qno	1581	778	466	12463	16551	jwvSUPBBL9kuK2814sCKYoS9iSjY5qY3FVuNRNw5AXfLNX56dJh	12253	17248	17248	1619043840000	orphaned
24688	3NLZeaXtwaVK6syZWxKka8pNHVCy9wkyVGLGxoXrSsXevrxy63of	24670	3NKuzE7WAPBQJ6wZPFG26qyGW9oTgTmzDXn4dAhLR2ghYqiHn3rP	1652	1315	466	12463	16567	jxYyMCs5hoP1L9U5BLJ9tN14dBEqquqBE3jcfVewFEtr3iwBfyK	12254	17264	17264	1619046720000	orphaned
24677	3NLJaabuGRM91EuAgni6h3ngecvtx6mQdZbgP4soishtPZQhsH7v	24675	3NKdRjk29cRZ6bBEFVJ8LcfX1P7TT3mV8Gx1DLtfTkf6NxgG3QCp	1471	1386	466	12463	16556	jxaJhpWtZLVvfJvFwerLevfxmtzxbBHG81VPiHZTUUxbFvooJk6	12256	17253	17253	1619044740000	canonical
24679	3NK5k3oNkxeUhV8PR59oWmAYsM5D3mq6NAkA6YqAbzUmzk2obNCU	24678	3NKy7mzGc8wfq2VNQwKjYQxQN1jGBAKpF9g8SEMjaX9eQUSmVEDt	1407	1395	466	12463	16558	jwmhiJWjipoFSqJVRwRNA6hqGWnhMQbHRbvrvybmc8hH5oNzDBc	12258	17255	17255	1619045100000	canonical
24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	24683	3NLQMgXqBuH4rzRLPNcUCgmvTxzSCuyq2JLtaR3s7e83DR5e6P4s	1637	816	467	12463	16565	jwNH6h5w3wGxjcVwPQhzVAvHxyMbn92aPZJ1GGogbV3Bd3K2Suq	12262	17263	17263	1619046540000	canonical
24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	24691	3NKFPYV1YZ2UaxZcUPk7rDQxDEHKx9MdMhaAHn8hj22GL1bPABPa	1407	1395	467	12463	16572	jwr6XNMNfgg9LSVdEGuNR48w7JY8PdzKMozxHqkQepwFq2owkER	12265	17267	17267	1619047260000	canonical
24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	24706	3NLeSAtkbCuuFegBnctwvsWxJ813zyZxNjiUe7mVu4pQNBGsZSc7	1542	1304	467	12463	16584	jwpw519pkC5bHm2dC9RyyAdyDzv5c9ftRd9WBuYdaBMHbTHPRHt	12271	17275	17275	1619048700000	canonical
24712	3NKD2aXPntqLh21NDX2kkWjoUJ64uKMrKmetxpS7DXhbYz2sSVok	24708	3NLNSBQZUHhbAzsAMkTR8cSakdwyn8FfxmAF2u5TRyFuixUGkabr	1439	488	468	12463	16588	jxn8yGoFXoqKTjo6gKJGzecibD7gV3DKQ74XQw1HnKnR2HJivhw	12273	17277	17277	1619049060000	orphaned
24715	3NKen7UxBu2ZVYqUVjdse6URoU8X9L3ULGmLN6Vf8k419uA25RYi	24711	3NKcWYdv4vW3yY3JBgQY9XpRWVoCahjC3g6Yt4MyBYabFvb8kJcG	1407	1395	468	12463	16590	jwfz38AAsCRooSrq5vLdi266UNUHmjDYm4xBG5MeF8afE5DpA3L	12274	17278	17278	1619049240000	canonical
24717	3NLRoQDMdWdN7pXGtZ9suTGYFjaR3xvDn4JrB7NPtK3KW66oYe8c	24715	3NKen7UxBu2ZVYqUVjdse6URoU8X9L3ULGmLN6Vf8k419uA25RYi	1637	816	468	12463	16592	jw7ukpF1gt6jEUmcPMAbmgVWP2R6PLE4Ka8jCgyNBXxnUjqrf8y	12275	17279	17279	1619049420000	canonical
24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1553	776	468	12463	16597	jxZ51xwg3ZBmmMKAUPLz1yckPiCU6Zpoof1L5CirEtfcUQqZ8wn	12277	17285	17285	1619050500000	canonical
24719	3NK5vV116ti3fnmQhRqNX9us9yNgxYXDKGGMzA9jNXsq5JSuV69F	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1403	824	468	12463	16594	jx4FiSZMMHEDyZsokA49zsozaRdCEpJjrsVYamZiEfhCuGuP6Zt	12277	17282	17282	1619049960000	orphaned
24725	3NKRnbBagjgyiDmyGLfmiGXEwE7VT4TQtP4JEseuH4pFnyUWjvMP	24722	3NKabRoJVEhCsP7TJU6SC831wz3S76tyEKJvSHDWEfLxwB5n24jK	1445	1044	468	12463	16600	jxKyTw51roJCiCzMcbHfaw32A3jttpYTp4jn7vhUQsKT1J7ghUt	12278	17286	17286	1619050680000	orphaned
24726	3NLtadeJvBeWczmkH9U51vpxYydpKeU9VG9gwM9A9jRCU3USRycB	24723	3NLRh9Xmgz6t1sc4b86ywZvNaK8kworyhvoDtg1cdSrNsHThtBQT	1406	1393	468	12463	16601	jwyuncrBB6keYefsvkCcicLBYzLB9Y2pBNXjnTp5JHsFBUb3qro	12279	17288	17288	1619051040000	canonical
24727	3NL99YLudunDhzGPNpfspETaqSeQWkoTfi2Kr4uKWLDcPuQV1dnq	24726	3NLtadeJvBeWczmkH9U51vpxYydpKeU9VG9gwM9A9jRCU3USRycB	1406	1393	468	12463	16602	jwMKne2DfnpHnt5v6yYujneCRCY5x4Eo8bv6NWmCsh4FcTGtpPB	12280	17289	17289	1619051220000	canonical
24729	3NKZv7nRZActzS1ZTXvX5dPvRR59MhZ4vn68taJ35p5AZxf1y2Ac	24727	3NL99YLudunDhzGPNpfspETaqSeQWkoTfi2Kr4uKWLDcPuQV1dnq	1522	1076	468	12463	16604	jweMMiZ3j8c8XbZcJ4938SuvrqWyYNfrrBSKxgPN7Rjr1TvyUQ6	12281	17290	17290	1619051400000	canonical
24741	3NL776sJLLcSJTmw5ETgAVaeCqAV9xecW6vTUyo7mMqxnDrZHDFi	24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	1419	814	469	12463	16615	jxewNkAEVi6q2WvXLqNmrLjcW2VWuctK7fN1CazDNU8DtBX4F1m	12286	17296	17296	1619052480000	orphaned
24743	3NLaP3r3bQYSKyDvgtyvqoJYsGEneKkPQkj3jXCv9dRAa83UeAY9	24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	1460	681	469	12463	16617	jwn1n3uL1PfPbLpkR9cC4HJcaDq8mXhamjVTvi9cmE7hXPBV523	12287	17297	17297	1619052660000	orphaned
24748	3NKRgk9WpxGsBWYZ7FHq5JzvzPKLBmwxoB7fTQ3s7jukck5BoFts	24746	3NKjL2UX4LbPQj46o88T86ki1aJXWBpZPcqyhnMEo2uMHE6u8BaA	1407	1395	469	12463	16622	jwt9TRzpnrYCiTGFykyHW7gAXuDUiDUq4fTPv3MG4LhZD3JS4Qa	12289	17300	17300	1619053200000	canonical
24751	3NKbyyXuFXw1NdBnrckVaZcnzK8sNKhiHffDPbHDfPK2bsVXLfqf	24750	3NL39Bfe4upDPcBHhSWu1YRFYR2FkkBa5TRetzeWz6jMM4rN6Uec	1403	824	469	12463	16625	jwcPAaneHjxixJhAdbxNyMdFzPtLNr61QBe9YNmcmDYST8XuktX	12291	17304	17304	1619053920000	canonical
24757	3NKktvY2K7Nik78xmPC75bwS25vTPJWJ6fxh4QkLoMKJR8ppSfyd	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	606	1295	469	12463	16629	jxKBqbRG23LecLiLKqnUjv72Ym6otaEu2ZvVBntt2xamtTsDoKi	12293	17306	17306	1619054280000	orphaned
24760	3NLmiVPPxWJAdfpsdSZCuMUjGx7cseHHN91vqtvcSRuZoAaJr2st	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1553	776	469	12463	16633	jxrgTwZsmBs8TwyeSHan9REg5JQB93DqLVpnKZwZ8TsypsHEapk	12294	17308	17308	1619054640000	orphaned
24766	3NLdd6gah15oUVXjgB9uHmE4FBHBAhJHxgkE4XmDgqpypc4oFv6K	24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	1588	1146	470	12463	16639	jwSSzLS2mJiA9FEBr11ZQGYcdHzbfqzxKfoa6qWAqLEnWW8Emz5	12297	17313	17313	1619055540000	canonical
24771	3NLjvUmZ9sfWN9BCpqZK2rSvFAgWhfJgPtjgpzbXQBD4eJfTGbyZ	24769	3NL9SFJbgaLVeuKPhczEEYJ1re38qLabFbMpWSPUqWGQZ3yDuNvS	1673	1122	470	12463	16643	jw78zfgu4Q6K4uarEbHKWe2JJUK7aoX7fYiKs8X8zq58saeVENm	12299	17315	17315	1619055900000	orphaned
24773	3NLPEC1LFup8AurdvMvvdu6xudfeFDNmY1YvrmhFAiMWoEGefoi8	24770	3NLvgAtnSv8rnoKVpmfFTPAR9juL52PuSQsp9ap6AgiWB7c7gwsb	1631	794	470	12463	16645	jxfcT8Xji1NeWcrTwBEDiKQdmnAZUEJUWpdfkQ1ah7aDFX54fEb	12300	17316	17316	1619056080000	canonical
24776	3NL38rc2MyH7CZ8gEs5h642zrGDcsYSHdbenFqF2S1cy3VWph2Ni	24775	3NLtd3ymh5qwCAp7swoqaaFZb3ZjNGunX1B52834NF98eWYEw6gE	1406	1393	470	12463	16648	jwC84HrutktYTFDKFCzWXT9tvDp98CBhWmTZeKUpjMrG1d8tbvA	12302	17318	17318	1619056440000	orphaned
24779	3NLoHjbGGm99jK4B3KsqDiMNFRvMzn285sNCxQaY7DUp7a9c4xwG	24777	3NLZ7TZ4AE8sdy4Lmjvj8fxKH6N3iRVYmfgVNKFy1JnymrRSL4Hj	1406	1393	470	12463	16651	jwSEZqUsqbfdGhjJSWpncAtqijV9MNPfSgWJSRNWZpBxfv6MPpq	12303	17320	17320	1619056800000	canonical
28311	3NKBH9HCkJoywCAsBb6vzGWZc6eePk9e8iUPAjWMeRfUsMyZJBPp	28310	3NKVTMkaZXB3vb4TSQZDYCNci3hMqahZxrFPgEK5uPc1tdJStEAt	149	1037	554	12463	18974	jxB2o3nCjWDXCfdUkRdctDLozTesQ2z9caJxzDLwFSH9GskeTbo	13997	19724	19724	1619489520000	orphaned
24696	3NLisQ14rvtPJqea9YtXCRTc7XV2EJQTLusB7BZmQygFdjswxXnC	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1407	1395	467	12463	16575	jwnm17bSFvVCExZn2CKzC5K2TNWetZjRivaG4AsDFL8UtBf9ayZ	12266	17268	17268	1619047440000	orphaned
24700	3NLvi8C3djharFyVgK6SXGPbLCP7d2yGphn87hSCRDKY38qWmMnJ	24697	3NLuSNkHKKVnpVZSjUAbLLsmcm62UBNh6GTMdnrenrBRcKJG4mM3	1581	778	467	12463	16578	jwaX9QEbeDVwGGBRJva6e85f774hyhJRUzr8i3o8kcYnF4W5E6u	12267	17269	17269	1619047620000	canonical
24703	3NLVgA8FvL5bBZ88Tqhe2gb47WiZ49x4ouw718qSaE62Go3szVde	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1406	1393	467	12463	16581	jwGyCsTRP3er9xDGGCyYGcCeFCFf6SV2oXd56yiiNmKrz8vqJbD	12269	17273	17273	1619048340000	canonical
24710	3NKUhSgpepP2v7zi4RF9WWkZ8rEoELBxo7QCS76CDEct8EAoPY6h	24707	3NKnHVo8CR3xxJu2oD21hpiMbWFdxeENbFqoo3jT3MQHTeJQJtEm	1407	1395	467	12463	16586	jx72Rzvd6Y4rPBM7qoySCGSZfjE5pAVzUTkdn7MKbEFA5THuKD3	12272	17276	17276	1619048880000	orphaned
24720	3NLe27HaoQKS9nEqkxJnh8esZfM2bUGpiLohaj17hvJx6nbVbrRW	24718	3NK3cL9QJj9ycnCNjqKWnpgfJTzBs4pwWz1mcvLfbTQyXi5uiZGg	1405	887	468	12463	16595	jx1gscrV5YCR7WA4bD2oq3jEpdEDd9KcwBCWLqSALKEPbftokUz	12277	17282	17282	1619049960000	orphaned
24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	24729	3NKZv7nRZActzS1ZTXvX5dPvRR59MhZ4vn68taJ35p5AZxf1y2Ac	1581	778	468	12463	16607	jxjZfJZVfgEFVM4wEU7pjqyD6uS38EAEE5dYWBNi8rzXHQTRkSZ	12282	17291	17291	1619051580000	canonical
24736	3NLEpjLzahk76FSNFZZgdm2gS7tBW6JcjKvJJFhTUEDxVgNQKMQH	24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	1672	1039	468	12463	16609	jwHoWo4HUnPavw5arcGmwz7HwMs5ZziSLWF8cEvzRZ8d5Vs4VJP	12283	17292	17292	1619051760000	canonical
24734	3NLFgGC9oHWHsGtFVh2uSfGVCB7BVY6D5ZKuUV41K1dfGsWVofvN	24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	1672	1039	468	12463	16609	jxA5rwiWyAaX7k7t1TesgwVi4TLQZthyuq5GoTAjd3f5S5KEA6u	12283	17292	17292	1619051760000	orphaned
24737	3NLE1qjxLdppupscmvGodrEGUtRBXvRwXrjV8jPXCMnv8WpwZfUR	24736	3NLEpjLzahk76FSNFZZgdm2gS7tBW6JcjKvJJFhTUEDxVgNQKMQH	152	1330	469	12463	16611	jxpXGR4FLPfFRe5gPZc1QMBHEgzh6qS8wZsUJFiS2KJPLZEZxXS	12284	17293	17293	1619051940000	orphaned
24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	24738	3NKKwScjLjHKquaHiA4cxhvsExgBzbdpH8QEb9B3pP7qvrSDxgLa	1406	1393	469	12463	16613	jxU2Ka76wyU6JGEuwVfPuJq4tE4WEqVhiHQKdq94EzN6WhXakXw	12285	17294	17294	1619052120000	canonical
24744	3NKEaF3CHnXYSLxXgSv8Y7ULoCFUkX2rVETvCtB8dMrQfqQFTmKK	24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	1471	1386	469	12463	16618	jxgnqFsqxuhcvmSvsaNuNu5ZeisQwGdi1qy8EdDGojQQUqZLHuh	12287	17297	17297	1619052660000	canonical
24746	3NKjL2UX4LbPQj46o88T86ki1aJXWBpZPcqyhnMEo2uMHE6u8BaA	24744	3NKEaF3CHnXYSLxXgSv8Y7ULoCFUkX2rVETvCtB8dMrQfqQFTmKK	1588	1392	469	12463	16620	jxLPNHHXmqY4KkxQ8r2R6ghat4sz1pCv1GPn8FVtkvAFSNs8cUM	12288	17298	17298	1619052840000	canonical
24747	3NL2GHaiDzh4vpvJg5cUnT5cwP5zowrFfjFUJbKNpgUfQjD79PRm	24744	3NKEaF3CHnXYSLxXgSv8Y7ULoCFUkX2rVETvCtB8dMrQfqQFTmKK	1564	1338	469	12463	16621	jwHJmzdraYc9yRYkQrUNgbmwqsNDvcmbrEJ1vsEk8kE7B6YRBMs	12288	17298	17298	1619052840000	orphaned
24749	3NLr2sH2TksMNdXoKJXBxNdTYn5esWFiuJ8WhHqCEce1fUDezcuM	24748	3NKRgk9WpxGsBWYZ7FHq5JzvzPKLBmwxoB7fTQ3s7jukck5BoFts	1671	1239	469	12463	16623	jx4Lx4o82qLCFQrTjQWtdwMJctiHbT3fBP9tBGphoP472gbhtww	12290	17301	17301	1619053380000	orphaned
24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	24751	3NKbyyXuFXw1NdBnrckVaZcnzK8sNKhiHffDPbHDfPK2bsVXLfqf	1544	347	469	12463	16626	jxzxmrxnJH4YgYwbihDLQo2yRt8d6FDoKi7UamFjJkKTNTVZgCX	12292	17305	17305	1619054100000	canonical
24753	3NKKooC8KpfrjD4TiufRrAarn6AT33vAc3FgqYuzXmtXyQZBB2gH	24751	3NKbyyXuFXw1NdBnrckVaZcnzK8sNKhiHffDPbHDfPK2bsVXLfqf	1542	1058	469	12463	16627	jxTDxrNeHUD7eaHg8KXwvzzE3MPUnfgsFJPrtgamTay67uDnLra	12292	17305	17305	1619054100000	orphaned
24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	1455	1332	469	12463	16628	jwmt8HBx12R6cHRSwETaV2nQWydQbke3GYFjJfLPwFwErGt9bGn	12293	17306	17306	1619054280000	canonical
24758	3NKWToQ9TxAQJ9wvY3UufPK65YY5ANZRoUZK5YQpCPSC4W9aYqnn	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	1631	794	469	12463	16631	jxELqS3cFCBkZ215fp5Mz4X2qHmohLedapyEqHkxhQc8CQHWzUC	12293	17306	17306	1619054280000	orphaned
24762	3NK7hfLG7bKdcjb5yWN2fpybMdJGy9foaJbTueSro5wtP8D6tv8C	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1407	1395	469	12463	16635	jxDbRWpEJWcEsTYWfJDmaYUcB7C5RLsMck6ANr8FoxN8Myr2JgM	12294	17308	17308	1619054640000	canonical
24761	3NKiLCDcJfn6kwx4t2fEnE3641mTYFH6sF4t73bJyutZzXZfzhja	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1673	1368	469	12463	16634	jy1gFQQBZZHN1ydyRQWdPVvukgywnwiw7HewF4JZY1djHCejCr4	12294	17308	17308	1619054640000	orphaned
24759	3NLZX2Q5Ne5LUSuD9hQ9hrCCVZUfv7Xbd3eo3jL1pXfPBFzLZ819	24754	3NKMiYX8RAXXbhYwyJXuiqDZFMXRGcZqgVMDeWLnedmUwoAxQkGS	1547	1378	469	12463	16632	jxVn32FFtN9AWyT8rBhp89BHDuVyHBGJPqrM6RNTQq2bRzowpuk	12294	17308	17308	1619054640000	orphaned
24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	24763	3NLgmyrdfzJq8dqxAAzim4Mkw8NbKCpCosJXf35mwor7kzFY82xe	1627	1139	469	12463	16638	jx8yX4TbqvNSJcYkWcFfC8po3ATk4DCuwtUT4GWAmC6goKWANUA	12296	17312	17312	1619055360000	canonical
24764	3NLTVx69FBL9xYXa9SRv2xGn2pju5BarJkec1hTNsgTDMTM7vCLE	24763	3NLgmyrdfzJq8dqxAAzim4Mkw8NbKCpCosJXf35mwor7kzFY82xe	1406	1393	469	12463	16637	jxTNWkmz8HjNAwVxtRzekAXqMJaispYTkommcq6wGh8CPG8uY7h	12296	17312	17312	1619055360000	orphaned
24767	3NLW7EAoyYfgbSmwa1TR8PD4MeHiTXrj75LpHc8CkoBG8hPha9sw	24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	1483	266	470	12463	16640	jxTbGiiUwKcULwoA8kcgVgoD4eSiSPa4wFQUCzduQj86MQ5FLqT	12297	17313	17313	1619055540000	orphaned
24768	3NKMK9FV134NiSnyfvZa1HoHj9VZbN99kpA8ZhDmcjckWgXwQMKJ	24765	3NKw2ikyPHrcXj9fbyGc5dC9CjfRDU3xaTkSiFhofMhBYLe3QBAQ	1483	266	469	12463	16640	jxdxo4WUVPRe4GXyJ4NJYPMBSicCSjYXQhnrvBHgoCEcVeddzdi	12297	17313	17313	1619055540000	orphaned
24769	3NL9SFJbgaLVeuKPhczEEYJ1re38qLabFbMpWSPUqWGQZ3yDuNvS	24766	3NLdd6gah15oUVXjgB9uHmE4FBHBAhJHxgkE4XmDgqpypc4oFv6K	1467	1130	470	12463	16641	jwXLnPXoZBjA2L5gGnZ9srKDpxEj71T713hkESQcyvMpDfzvxSF	12298	17314	17314	1619055720000	canonical
24774	3NKFosBnPQ1QyzbgKCha933K6GeaDtLEML3P3MWTSkDYCWmHnPVE	24772	3NKspXip2grP4QTNf2p6fze4htMgPCPA4ie6LWMY28p8i471vuKH	1633	1390	470	12463	16646	jw7R9js8qNp7yRFfbrH73ygLu6YZcnoZydrPzAzhBhrhyJYXTJX	12301	17317	17317	1619056260000	orphaned
24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	24786	3NLShnhs7shCTXrF8LApnQ7Yg4Kp8joj3FsY385tukKTzLxH1mMb	1426	1238	470	12463	16662	jx8aHJ3Arziyr4D4PBrYsY9zwBpAUm1N6A6DQuxF2Y1LubZ5x5c	12309	17331	17331	1619058780000	canonical
24792	3NKN4Vb44Czzq4w4Z4DV19p7gMPebQaaCLWM2NjcBw16ZnRLpBvA	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	1623	830	470	12463	16664	jwaz1ZVTY3GedEEAzPY4wh91XheX8ySGeXCbfZaGsmi31GseyAm	12310	17334	17334	1619059320000	orphaned
28352	3NLMhNTaUpoFgyurQ564FUHDSXnd7dRH6pHzU6E7h9EDcuz9Fvcj	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1481	790	555	12463	18974	jwBkEPDkSj3EHEeLkzc5Zm61QfoPm8MaVxLX1TUpnVgZ1r9nDVM	14015	19756	19756	1619495280000	canonical
24781	3NKQKo4JmpriBM2CQxbsjC4YzKcsyp94BYFTRxepJJx1tD5ywpbs	24527	3NKpZSWWDCZoDJMXj4rqSgd7x27TKFr6LRgsF14xDjKNVsMDpqGc	1458	1323	462	12463	16653	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12157	17321	17321	1619056980000	orphaned
24791	3NLF1KA5RTCv4WeFNUFn7njXBHbZ8m2hrgZ1WDUYjv7g2XQJw6cm	24787	3NK5khUJxjT5erbdfRAL8wMrEXzJY8j6fqoqT57zRFTarvTHwcJ4	1458	1323	462	12463	16663	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12160	17334	17334	1619059320000	orphaned
24733	3NLh646jwY37NNdFfo8Jh7C5RSqZARw6rdFLN84TFJUJKjykfw5V	24534	3NKYZMuP9x7Dt9YWGBr28MBKLSSuR65TCEJUzSJavSwvQYySux5s	1461	1271	463	12463	16608	jxU8oPxcQbQJXTJdmRmGQx1jWf97NpgVrmJXS8EQbhBckqY8J7E	12199	17291	17291	1619051684511	orphaned
24810	3NLGHoZU7DGb2XiJ1NWZkvwhvgXX2pFJfkfs4vyrdYsERJ8rfrPy	24682	3NLh9mPk8jtmZ3kYKtMsytcQcEGKfUsFkZRtokSmkJZEZYtXxcfq	1649	1257	466	12463	16682	jxURQ4J6u6THbzNuNUBcS7HCqz8xpbbNGKbF7m4gBoSGJn3rMKr	12261	17345	17345	1619061300000	orphaned
24738	3NKKwScjLjHKquaHiA4cxhvsExgBzbdpH8QEb9B3pP7qvrSDxgLa	24736	3NLEpjLzahk76FSNFZZgdm2gS7tBW6JcjKvJJFhTUEDxVgNQKMQH	1613	661	469	12463	16612	jxmk9gHaC7MWcpidd3FNm7dku8nmWHNdXaCmCjLv6PFyif3zous	12284	17293	17293	1619051940000	canonical
24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	1555	1347	469	12463	16616	jwqx8Vzjsx33J3yuNGHEuXcLV25p794kUs2AGWFUtGxsnbCqUfg	12286	17296	17296	1619052480000	canonical
24740	3NKRQFFQTeMjyBFD653zihmq2hcBgPJiUooFaiyACPD3hXYAuU3i	24739	3NLnmPG2TzkWP6j3tDzoBSkYDdjBrTX1ogRNwdSQsK6eahXWpNoc	1601	1388	469	12463	16614	jwQsXsU4MTpkJL5N8ayqPkButKXyAVo34pGxWNkY4PkPAH6FzKp	12286	17296	17296	1619052480000	orphaned
24745	3NLdxEoBcrJcdMY37Noccuu4TZT9VsnAefgsKPBHYrDXqPEXV4Y3	24740	3NKRQFFQTeMjyBFD653zihmq2hcBgPJiUooFaiyACPD3hXYAuU3i	1460	681	469	12463	16619	jxFSdR82SumV45jUFYmrZtLTTwHe9xefrHJpMhdS7Fw8BKSH1GY	12287	17297	17297	1619052660000	orphaned
24756	3NKPWHRKGYCpALo77qTxhJv2ueSLbqRjKRDkKt8nymhF3gXJzV9F	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	311	941	469	12463	16630	jxNFkSX2UEWBq3z1bfiy9ntnAQ5GYjD64xYNEW7m44wQmw1LXMn	12293	17306	17306	1619054280000	orphaned
24763	3NLgmyrdfzJq8dqxAAzim4Mkw8NbKCpCosJXf35mwor7kzFY82xe	24762	3NK7hfLG7bKdcjb5yWN2fpybMdJGy9foaJbTueSro5wtP8D6tv8C	1599	1287	469	12463	16636	jwhXNmQ61qkXj5P4Ry5L87cxpncgABzQFtw1vrsUF1Hdvd6rC3J	12295	17310	17310	1619055000000	canonical
24770	3NLvgAtnSv8rnoKVpmfFTPAR9juL52PuSQsp9ap6AgiWB7c7gwsb	24769	3NL9SFJbgaLVeuKPhczEEYJ1re38qLabFbMpWSPUqWGQZ3yDuNvS	44	1325	470	12463	16642	jxU44auUXa7n6o6CBULUGQMGJnqSmiUvk3NmouhdLMQ8XXaD8bU	12299	17315	17315	1619055900000	canonical
24772	3NKspXip2grP4QTNf2p6fze4htMgPCPA4ie6LWMY28p8i471vuKH	24770	3NLvgAtnSv8rnoKVpmfFTPAR9juL52PuSQsp9ap6AgiWB7c7gwsb	1481	790	470	12463	16644	jxq29oiMyNMcCSinAqqXs7M1cQdyeLKxF1dBRdzFjECQ85YD8jp	12300	17316	17316	1619056080000	orphaned
24775	3NLtd3ymh5qwCAp7swoqaaFZb3ZjNGunX1B52834NF98eWYEw6gE	24773	3NLPEC1LFup8AurdvMvvdu6xudfeFDNmY1YvrmhFAiMWoEGefoi8	1555	1101	470	12463	16647	jxamy3gkTnF4SJgu3wz4f1YjAMK7YsnU1svcvFBp5UQTgEgJMqe	12301	17317	17317	1619056260000	canonical
24777	3NLZ7TZ4AE8sdy4Lmjvj8fxKH6N3iRVYmfgVNKFy1JnymrRSL4Hj	24775	3NLtd3ymh5qwCAp7swoqaaFZb3ZjNGunX1B52834NF98eWYEw6gE	1501	1234	470	12463	16649	jxnkVvK4GXf7Ra9Tm3mVSKkpR7jcm95xuLPzasgBb9yPGkZ5ktx	12302	17318	17318	1619056440000	canonical
24778	3NLQR4ebhrfHZcwZHDgUReCjkQWBWVa3yaJ6DcyubBAnFDGhV1vJ	24777	3NLZ7TZ4AE8sdy4Lmjvj8fxKH6N3iRVYmfgVNKFy1JnymrRSL4Hj	684	1352	470	12463	16650	jwzHNaUuaayCREGVhAehrW1DutFqmLC9R3ASqvbCwEjBdCGkRiV	12303	17320	17320	1619056800000	orphaned
24780	3NKSdYYU4gMNgWceAYgZ845TiT4KFFxfbn55rEswgZYUJtjtMqwV	24779	3NLoHjbGGm99jK4B3KsqDiMNFRvMzn285sNCxQaY7DUp7a9c4xwG	1458	1323	470	12463	16652	jxXdgrvUW33XEFNJ9B1tbtyrtUSbwkG6JAHuHXHWQnMCvxmNUFG	12304	17321	17321	1619056980000	canonical
24782	3NLkfn2uWopoTarLrCDWZDUzd4vRrh4SR6JFeEtAhLY8yzNq96cq	24780	3NKSdYYU4gMNgWceAYgZ845TiT4KFFxfbn55rEswgZYUJtjtMqwV	1458	1323	470	12463	16654	jx9xwFfc4gqKMsLDjbNt1kqADKQ651VN3ewitborJ4z1fhsuqFR	12305	17322	17322	1619057160000	canonical
24785	3NKJUVqibK8oBV7HHXmUz16zEbzFwk5BLoaFqJZaJLyFBTuVTjCR	24784	3NKnwYtgP2BHRk8XwviE2j8kMQ2cGBNS6Ykr4t47FHmzKbwhJvDQ	632	1136	470	12463	16657	jxevzgU1yUomijdg3DnuHwqsPnsoxSbGYQV2P4Mcj47iJ9TmFCg	12307	17328	17328	1619058240000	canonical
24786	3NLShnhs7shCTXrF8LApnQ7Yg4Kp8joj3FsY385tukKTzLxH1mMb	24785	3NKJUVqibK8oBV7HHXmUz16zEbzFwk5BLoaFqJZaJLyFBTuVTjCR	1458	1323	470	12463	16658	jxxDT4rGEYrzDhDrXcW5pQnNj4NZfz7LM3uYSgBgG9wq3cd2GFx	12308	17330	17330	1619058600000	canonical
24793	3NKuXrsyqvCWvXiK1fFZ78g6R1fFtpzfgCnASZxBCJH6RNNfxurT	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	1455	1332	470	12463	16665	jxiRvLv1TE1d5N2yDqhEqXJYDuwPpcWFxFMQCogAEC9WXLGqC8C	12310	17334	17334	1619059320000	orphaned
24795	3NK6jN1ASb7vi2ReFJxQP854UMHnPC9n5yiyLKrgT4h2H6qJonPz	24794	3NLMq2G3PvTMU8C4eDeGRVTEB4vkA45quKzeUFFLbmt5fUGxzyQj	1617	922	470	12463	16667	jwcJyXpktTqK6ZYbBCp7goPmSemY4bi4yrWjMTjYJXECCN2GUty	12311	17336	17336	1619059680000	canonical
24796	3NLJLSfshr1o4qR17WHCF2prqLKUftK4PABpaYEzA5LfP8Pda3ED	24795	3NK6jN1ASb7vi2ReFJxQP854UMHnPC9n5yiyLKrgT4h2H6qJonPz	1637	816	470	12463	16668	jx32uq6xpk78Gjd8N8gH8sWydEEuqNxAVxnJiNXA9bYnviC6mG6	12312	17337	17337	1619059860000	canonical
24798	3NKCHTvjp4ZaGsGyZrsk1FjTp8Vu1P1T8vMhdjS9YVQyFBDidGRt	24796	3NLJLSfshr1o4qR17WHCF2prqLKUftK4PABpaYEzA5LfP8Pda3ED	1553	776	470	12463	16670	jw9NwPXZ98e3GAanxSWyGQ6FF1jk5HGejW6a87uAe1Um9PNCnDP	12313	17338	17338	1619060040000	canonical
24800	3NKUtK2UJxuPMmprYL6uDvYPjzQqGg3JiWpL25FCRTU8og8FKiWx	24799	3NLQcuwYwn71ja3NZweBoKuBn36wescQHvoQ1j8JKk24XzaUPTQM	1589	1160	471	12463	16672	jxd7XqzL6A9P88oe2KmqG4hxxbdNw2sbvZcEsG6iEdjmCgMgWer	12315	17340	17340	1619060400000	canonical
24801	3NLJ4z3qgsuZ8Ba12Gxdd3Ex4gVrauTTv5d2BT1d68L9nWwiqBAE	24800	3NKUtK2UJxuPMmprYL6uDvYPjzQqGg3JiWpL25FCRTU8og8FKiWx	1403	824	471	12463	16673	jxQJ2N1gFFzimjr4K2jzWNVD797aRhd6qKEWpqfRXJQyCsq8puS	12316	17341	17341	1619060580000	canonical
24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	24802	3NLgRgwNeGbCamAy4Hybd8Bk6fL1nw95mbn4fo2RjwPqGwGDWvgK	1668	1370	471	12463	16675	jx7DvAzEsritux9XSzY7Y8AyPXZ5sUtPiFVhJRRUf9Pv5nBeRJW	12318	17343	17343	1619060940000	canonical
24804	3NKRtReuVLjbw65EA62QnTuM2Nk5XdkhgGpk9d7GsjwAeFVbCCgr	24802	3NLgRgwNeGbCamAy4Hybd8Bk6fL1nw95mbn4fo2RjwPqGwGDWvgK	1585	1120	471	12463	16676	jxBJ8ENAyEihi3zk5XdYRNxtnCcb2n74cXeVJCGoM6hJj7fZhaE	12318	17343	17343	1619060940000	orphaned
24805	3NKUXF9i5r41Zi9KZtB5GfQVrb7U3AJmJV2SPrcvgxS5czacpJYN	24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	1593	1220	471	12463	16677	jxZcskCH8dM7TWemnZo4GtuENte6KfcN5tEEFXtKdkc1GQNBZdZ	12319	17344	17344	1619061120000	orphaned
24819	3NLRPGvtzKKCuh6Ngo8mYikUy5L3qXLFkbeUXiz1qZqqbNkLttnH	24818	3NK7TAtLtT2kQWHwEhBdG94bUbRcsi6YYbvUzRaKztwubSKNcXKe	149	1157	471	12463	16691	jxfZn4sxSppYWU2wm8adUR1Rgns3BZfnLNLX9Jwr79nuPhSidAo	12324	17349	17349	1619062020000	canonical
28353	3NLkinYNyErKVX52bBjQu1fhwhXw1CtNrDpSqg3MJhzQGUuRMeHH	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1590	198	555	12463	18974	jxU6b7VZon5wRM4ZndR9AgMRCsjxRsXt6XPkXxzCZUprUDCKRma	14015	19756	19756	1619495280000	orphaned
24787	3NK5khUJxjT5erbdfRAL8wMrEXzJY8j6fqoqT57zRFTarvTHwcJ4	24783	3NK7Q2KVE1YWdMqe5kbnSAL7uaNTZX3f3JfhqmPQw58XjnU4WxJY	1458	1323	462	12463	16659	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12159	17330	17330	1619058600000	orphaned
24784	3NKnwYtgP2BHRk8XwviE2j8kMQ2cGBNS6Ykr4t47FHmzKbwhJvDQ	24782	3NLkfn2uWopoTarLrCDWZDUzd4vRrh4SR6JFeEtAhLY8yzNq96cq	1578	1296	470	12463	16656	jxvZGPCXT4gJMryiot1nQRXxnfJNMjfsc6NUCAXcmsoBfYtDhby	12306	17327	17327	1619058060000	canonical
24789	3NLV6bX797d2FxT637Hmuzy5zQnmdXfd1Z141Zs36tGBuQjN9iZ9	24786	3NLShnhs7shCTXrF8LApnQ7Yg4Kp8joj3FsY385tukKTzLxH1mMb	1593	1220	470	12463	16661	jxXUHV1aXhKjHJ78hGZ9avFJ27GNSt5rBT3DdjV5PK9cMP9eh7g	12309	17331	17331	1619058780000	orphaned
24799	3NLQcuwYwn71ja3NZweBoKuBn36wescQHvoQ1j8JKk24XzaUPTQM	24798	3NKCHTvjp4ZaGsGyZrsk1FjTp8Vu1P1T8vMhdjS9YVQyFBDidGRt	1637	816	470	12463	16671	jxb4Mog93ngrUum7yLLKH5ptmWTqtAAXwDqLb9ABzWf5AsWTZKR	12314	17339	17339	1619060220000	canonical
24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	1654	1340	471	12463	16678	jxvPzXR7uBtmLrdUZHDZDyjc9hoMjz8JweUxvv25nE2e9tuJU5a	12319	17344	17344	1619061120000	canonical
24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	1507	1280	471	12463	16681	jwLyWHQirVMkyg471cj9sWupqWicMSBN33dUnfLTfx8eReHr4dj	12320	17345	17345	1619061300000	canonical
24808	3NLsoXNayajTK92A5aZsTwXeG5f5Vhm7Uchayj7bFL6vF4ACEn2j	24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	1649	1257	471	12463	16680	jx1bq2se9ZUmrgjTMpcZ68uHgNnzY5JJgNCVrvCyh93kK8yuiMn	12320	17345	17345	1619061300000	orphaned
24813	3NLEQULBeLfZSo2g714aemEayeUzitPAiBCbTwZXk1Mss5drr7qy	24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	1675	1342	471	12463	16685	jx2TdpRtQVb13CL9xowqcVPd42AgEVVygLoBNhWhjGoRneMcoPY	12321	17346	17346	1619061480000	canonical
24814	3NKWLBK1bkFcrsjvSvbVVJpUB3pDBuXD8ppyhaho1BoojFXNfopb	24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	641	1336	471	12463	16686	jxA1aZYg85xfWnjZzCVjFW3z9ckumMwntrhAYHYQu4F1ZiwWHSY	12321	17346	17346	1619061480000	orphaned
24818	3NK7TAtLtT2kQWHwEhBdG94bUbRcsi6YYbvUzRaKztwubSKNcXKe	24816	3NKXKTP6ZKaUBgzUHth1L4L4tNGxYkaesp49SGSqNvy6AUsytd2Q	1406	1393	471	12463	16690	jxjX2WEqkY1krMVwNMUscEfZnyqHFcmMkmEHM9QyNhDU2kfWSYS	12323	17348	17348	1619061840000	canonical
24817	3NKWkvVfkQmA8CYg21JEUTaphQACj2ajyy7tHacSHDjMmaTgXkzF	24816	3NKXKTP6ZKaUBgzUHth1L4L4tNGxYkaesp49SGSqNvy6AUsytd2Q	1405	873	471	12463	16689	jx24ueZoHEeKVXVChE1XwkomGC8LMKVvmap2LpgHpeB6DB3ivx3	12323	17348	17348	1619061840000	orphaned
24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	24819	3NLRPGvtzKKCuh6Ngo8mYikUy5L3qXLFkbeUXiz1qZqqbNkLttnH	1402	852	471	12463	16692	jxwCiPgbSYA5TZ2WJAZDFwh3JGsh1pbqbz9RpYu3yCAbHbbuuZ9	12325	17352	17352	1619062560000	canonical
24821	3NLcRuadesUf4nGv9QeX1wWkCuAnop6a65DXy6f7WdpPgo1cinf6	24819	3NLRPGvtzKKCuh6Ngo8mYikUy5L3qXLFkbeUXiz1qZqqbNkLttnH	1406	1393	471	12463	16693	jxrVee7PVBZFNRRP6PJsZ3vSRu1WaBNLo9VZyEmerGjD2yqDuLy	12325	17352	17352	1619062560000	orphaned
24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	1419	814	471	12463	16695	jwdBvrXNbBcA2psq6QTGCVAFD5HYUaq9NAjMCUex3jKDuC8xy9B	12326	17353	17353	1619062740000	canonical
24825	3NKbwRCydPjdKd7MQjFPbDADXMG7jZx3eXvhazJWZyX5aeQTGfiP	24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	1467	1130	471	12463	16697	jwytXEsZtzyicoadJQAmHM1jaNzY7FKgpWizc63AkAvANcmH6Ux	12327	17355	17355	1619063100000	orphaned
24830	3NKc4ygPnZBK5Db7FhJqrJGKCXPsMJFk8NN54ZacEVT6JBkeqnV7	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	1527	1293	471	12463	16701	jwDN1r7nWia6XMvP6Hd53renneRQrBBK38RE24EiRtT2XNH6ryf	12328	17356	17356	1619063280000	orphaned
24831	3NKFLaWvLRLJToCa3FEvGa7T862eFUwreWFUngQLvjE9oUv9BstN	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	1527	1293	471	12463	16701	jwqQ8ZfLHpi8s2aLefceqAwviQ8svdSMqE7MVZzX9rURPcP8Ndm	12328	17356	17356	1619063280000	orphaned
24832	3NLPCmVTStjYB1WzSuhnaXVAwYkwxQm5ZDECat4YQLH7gvQNSzJZ	24828	3NLmnjXojfsZTimbraDymg923ZH9nTxMM7pUsBbuiG2MogbSyjW1	1402	874	471	12463	16702	jwvk6vWhz3wvQikEgXhDYAY3UBUwLvx9evTh53GxjCPCpiWUcu3	12329	17357	17357	1619063460000	canonical
24834	3NLLfPHv3PW8jbnfhSPbPW2DiuRdP5eKRjguJB1g5eWCeAV1Bq2s	24832	3NLPCmVTStjYB1WzSuhnaXVAwYkwxQm5ZDECat4YQLH7gvQNSzJZ	1585	1120	471	12463	16704	jxJKCJEKRAoZddje1LsXJQW8nCiLeCMD1bCsA3p6ViQaZHb3CYj	12330	17359	17359	1619063820000	canonical
24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	24835	3NLDUUFM2vHDPjv2HevqtmKpqTmyTcuQwvdJzaanmafFhzhHH6Hm	1406	1393	471	12463	16707	jwGvQUM7MuFzue81UGRwuV1vrLScGyjVL9vo631ceGuBUwqA8gN	12332	17363	17363	1619064540000	canonical
24840	3NLeLJk9WwuPvFszFgWLGzSLFPjMqUMPWKvENeKztqvS6icY3up6	24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	1407	1395	472	12463	16710	jwioq3JZ56eTR9FThuAkdJmQfhs5vR8jK45831JTBvRt2jFjPNU	12333	17365	17365	1619064900000	orphaned
24838	3NKD973XAt7HEgGkrX7mXPcqc4BSwqEyHywsBBbfBxKRZg8ZD8aL	24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	1670	1282	472	12463	16708	jwQRBzGZu6uN7G6VcbywvV98wCYFBAU2zJVH3VCAHSDTCRFxpZY	12333	17365	17365	1619064900000	orphaned
24842	3NLupmLCT55wfSQHu1yTYyCjMb7QMmgNnxnSUBvu2bGtCvYkb3WH	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1675	1342	472	12463	16712	jwZJdrPSczXYb1fhrNWSMLwsFCjAFF63Q1Umqef2S24kHLwhEmC	12334	17366	17366	1619065080000	orphaned
24845	3NLZv14ypRYutszB14xyhABy7JxgPwdLA2s2NVrfSw6dzBFrbLBn	24843	3NKrXGALgwV3sbsPkbe2vXUQbGP83ZyHb5kkn3L1YPAkPhMqt8fx	1646	1108	472	12463	16714	jwgRj5ooxF5FQCxZwFpn9tMQMcYjEpUz3dNj9u7ahpoD2U1my9g	12335	17367	17367	1619065260000	canonical
24847	3NK6tBt5xj1i5sv6bo35BHpTtjj4K2uX6vdSCqSNUTbVNypxqEHF	24845	3NLZv14ypRYutszB14xyhABy7JxgPwdLA2s2NVrfSw6dzBFrbLBn	1608	1163	472	12463	16715	jxfGkdAXe4qyLGEqqcBNNdeZ3jhbKigWNyYkyD7YAbZcc2XVVE8	12336	17368	17368	1619065440000	canonical
24850	3NKCMsmV9VHfwoPQjmSAst8qs6AKs9vtBt6m28NCXrzY2mCfwYL1	24849	3NL3W1P9hKAf8iVta1PoR11eeoqRi4GEYQkqTAWXAGSHhXPnqfDG	1406	1393	472	12463	16718	jxPf4octsZhox1mQ3qj9m2kPfgDLBwKbv41Q9nKRRejWxB9JZcv	12338	17373	17373	1619066340000	canonical
24853	3NKAY1ACrJyxLBmA5TFAr7pCP66CTi8eGFpmVxGkgNPDiY8wBK2L	24852	3NLM4iE6iA11ZyWb3HtWkZhRrfdeDZrDkPNV2yPEDqR3Sqeav6jo	1553	775	472	12463	16721	jwCBmdkFfYweFcHtJ5YyiMmwmdb9ej6hGHgo78D2Cfk6CLEzQx7	12341	17377	17377	1619067060000	orphaned
24856	3NKzpNoANre3kzAfHSCo9L9FhC7tkWvZCznq4kWdVJfgDLgknbpg	24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	1447	1099	472	12463	16724	jxmrUFRtf2q3rKbcS9dycSr88HpDaYVnKJMrdJz7MbjSmt7dX4n	12342	17379	17379	1619067420000	orphaned
24872	3NKZGWJzPj1VJXAJk3fvDP4MYp4ZaKMv12xRPoDR7rCrDY4PxYzj	24871	3NKeLxz4fiQKHvoikD4UVUbCCZdqPwLookdJKfixCVJ82EtwJDhD	1536	947	473	12463	16738	jwtZTJ48oDxrmBoWiizPmA81EuaByrj7UvYuxC3UyzDeqHJeJSp	12349	17391	17391	1619069580000	canonical
28371	3NKLBp1DdXTYjkb2YQoEe7kqzbegpCGBEh2Mc41r6oYH7h9uyog1	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1611	1341	555	12463	18974	jxNcmQbDBgJrjFoVGKYarRBGtwBpNjP9cePHoraf7HrtELrmqxi	14025	19768	19768	1619497440000	orphaned
29434	3NKJZSu2KKLuGDpVwG1XX3MyPEjgn5pvVyQrEfBFUTpZra1Xinfe	29428	3NKmX1CyBahfjz3B1BmJXQdE54LWougctczGEYa5qWCBxgzZJYSL	1522	1322	578	12463	18974	jwi3RYk7bzFEFq2JDpN8X3fwPczjSNAbYrgpXci2MtHJxicGLuD	14510	20422	20422	1619615160000	orphaned
24794	3NLMq2G3PvTMU8C4eDeGRVTEB4vkA45quKzeUFFLbmt5fUGxzyQj	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	1458	1323	470	12463	16666	jwDMhrccZPvNVsC1x9W6fEoPcL65HGs55gQeQDj4z9rfs6AU4zL	12310	17334	17334	1619059320000	canonical
24797	3NL3cTmJH5cTNPFDQSvF9sjRnPjoLXLJ7dPo34gLghwbm4SbgPSQ	24796	3NLJLSfshr1o4qR17WHCF2prqLKUftK4PABpaYEzA5LfP8Pda3ED	1594	1080	470	12463	16669	jwpSG8hvhcJbZhxuf9zNK24W61qSJxTL1Tjs4WAshgWdTTYdXvy	12313	17338	17338	1619060040000	orphaned
24802	3NLgRgwNeGbCamAy4Hybd8Bk6fL1nw95mbn4fo2RjwPqGwGDWvgK	24801	3NLJ4z3qgsuZ8Ba12Gxdd3Ex4gVrauTTv5d2BT1d68L9nWwiqBAE	576	1355	471	12463	16674	jx2Sx4eJ8mSqYznUzEJCvWGeKgsgrSRzEAAqjFtiztiL3dM8vWX	12317	17342	17342	1619060760000	canonical
24812	3NKQ4RxNPk5jBUNcHN8TGntA4FBVscPvUEWzXQ8Jyn3fHDCPz8iK	24809	3NKqWvtQTTm2d4wNqoy6eeF6t1fGLEMHzMnDPP1NjQiXMoiyNbXW	576	1355	471	12463	16684	jx3hGCYrWf4rdGbSnBpBQpQ4LxXHfcRauW1yk8U56xo2pvHALM3	12321	17346	17346	1619061480000	orphaned
24816	3NKXKTP6ZKaUBgzUHth1L4L4tNGxYkaesp49SGSqNvy6AUsytd2Q	24813	3NLEQULBeLfZSo2g714aemEayeUzitPAiBCbTwZXk1Mss5drr7qy	1637	816	471	12463	16688	jxQKvp3VX9xF8Q7jqHGZcmDi2xqkSPmvVGXTnWBLt1vTAQ9Ua99	12322	17347	17347	1619061660000	canonical
24824	3NKKBZvFmZ3LwrWJzQy2iHiobPs5ewFkusDLZ2Twnv5p78B4tUD6	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	1634	1085	471	12463	16696	jxjWxcnKWDRBRfNoTEmWgUKwcDezytoz52TWDup5U8x2EfydirG	12326	17353	17353	1619062740000	orphaned
24828	3NLmnjXojfsZTimbraDymg923ZH9nTxMM7pUsBbuiG2MogbSyjW1	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	606	1295	471	12463	16700	jy1oxNb7XMP9xm7xbUT1NUrz78gjHWtwTCgB6jhNe8QRvouhXNY	12328	17356	17356	1619063280000	canonical
24833	3NKF34ZtMEBYZxG7L6UEhskycc1m6Jpc3f6rQdocE2SCJnzLpnHV	24828	3NLmnjXojfsZTimbraDymg923ZH9nTxMM7pUsBbuiG2MogbSyjW1	1406	1393	471	12463	16703	jwVA4dthmDTTx8RV8KLJupGpGrf5KjqWVtNHyVJ83eSY35Mgx2F	12329	17357	17357	1619063460000	orphaned
24836	3NKQoeUhZFvCGeHnkijM9jbey2vvJKowZDwdYThpuP2vSCGfgiQo	24835	3NLDUUFM2vHDPjv2HevqtmKpqTmyTcuQwvdJzaanmafFhzhHH6Hm	1546	1339	471	12463	16706	jxSRMTRi3XwWgQCa9pcDN87pCuw2ivK5Jow8CnmBi4oxdBLyqkR	12332	17363	17363	1619064540000	orphaned
24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	24837	3NLUeuLASvz2AvMR4DbgefGQejLAq33ZzX7kBnAwhpPQefKzdf31	1406	1393	472	12463	16709	jxAQLbofAYbcsCndNGydJpn9VMmQFuXLVeSA5uaMX9whB3fRxYu	12333	17365	17365	1619064900000	canonical
24843	3NKrXGALgwV3sbsPkbe2vXUQbGP83ZyHb5kkn3L1YPAkPhMqt8fx	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1637	816	472	12463	16713	jwdKuFB6fnrqenMcKWoeMRuenu59qZ8YAeHa5isfLDZR6DKqvfs	12334	17366	17366	1619065080000	canonical
24848	3NLpC5pQdPvCBc9iK9S92WVxf5KLMmc6UL7hsJeSJZUCm6wCLNgZ	24845	3NLZv14ypRYutszB14xyhABy7JxgPwdLA2s2NVrfSw6dzBFrbLBn	1406	1393	472	12463	16716	jxMSSJEiwhv3abjSNTWg4rgviF6EqqDCKMqe1GfB8vCzsb7CNDC	12336	17368	17368	1619065440000	orphaned
24851	3NKB8U95kgK3gN5Ja3spuESASkFMiWtxtkisGG5eKqkRfUwMbkLt	24850	3NKCMsmV9VHfwoPQjmSAst8qs6AKs9vtBt6m28NCXrzY2mCfwYL1	1406	1393	472	12463	16719	jwZtgYLMPzofud4iCcwwsqis9jw7r9r9YQjdwMQxva7Rg7nokiC	12339	17375	17375	1619066700000	canonical
24857	3NKbQzd26S5Sm1ABzn1F7mqCCfGLPN5Q4vbCkvnqyPdsG1jsUF5o	24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	149	1037	472	12463	16725	jxh2NyKbm9KvFXydzfgbpoGm5MxniHg1irvM7Q9AwKYzySsoEsB	12342	17379	17379	1619067420000	orphaned
24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	24855	3NKvxgsQN54RD3KdkQmMRewFc3kq8m1Br71mDckjKZyQdkkxyqXj	1407	1395	472	12463	16726	jxXRJnEU4rP32gUthSxVUgBsBKevFwXPWcSpvFMojZ1J5WRXwUR	12343	17380	17380	1619067600000	canonical
24861	3NL6bjabuyvv6jouPGB4EKQdB1T8phj2J5UB3bk6BXe1jvKoSXCu	24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	1402	868	472	12463	16729	jxgr9oT4q6JFHh9GQxcJ4rniEPLxi5vGRoR4wbn2gAAGt6Ki3pP	12344	17382	17382	1619067960000	canonical
24864	3NK3k5HK3FzNBv6dVEzgDW3rSM5jMpYvHEZUKW9PC3CTeMPJR6qJ	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1542	1058	472	12463	16732	jxvQHitJJ8DKp1wwh84MnWaCdZMk9XMaDgfxDqTYaanXQPwe5vE	12347	17386	17386	1619068680000	orphaned
24875	3NLUDvAJasxKWZBYv5e5tU8mEyfbGCzutzCZ87wWhb8xhtiSpPDd	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1406	1393	473	12463	16741	jwF4q3WJURTZWnDFKfv7eZD2Tg8A7qYFpXUC4CAafcnx3n6ZXb5	12351	17393	17393	1619069940000	canonical
24878	3NKd1Smvs6iBMQmpxfQAjUFtLuLwguCA8qhsNSYdMPc9Fkd3sE2o	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1506	1373	473	12463	16742	jxWEm3Lt6BQgZ1Y6RnTwAXjU5yjTuaRkeYNMhQpzgkvsVhtNWn6	12351	17393	17393	1619069940000	orphaned
24879	3NLcjR7jC9DiimBcgMrrkThfwt66U6vJ126WVK2m1b1HmyK9hyXL	24875	3NLUDvAJasxKWZBYv5e5tU8mEyfbGCzutzCZ87wWhb8xhtiSpPDd	1587	1357	473	12463	16744	jwseTDeGJb2om8CYXfL4zWebUikQMvihzArNf4pTpaps5RxazqT	12352	17394	17394	1619070120000	canonical
24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	24880	3NLDGSaMuhmy5issiH3yEmGbvsA7Zj8ajHGMmXPAZpJiCkpZ1f6n	1646	1228	473	12463	16748	jwGgTrLyQnABuPbBukbifnakWGLYcDtrnKYWvacNu2p1iMbUi4Y	12354	17396	17396	1619070480000	canonical
24884	3NLNathS47TWdzMAzz4aEdicvAquBaAMuKmEaiq6BR6d6cRW2TVZ	24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	606	1295	473	12463	16749	jxELPDFMCW6MSjbtvNb15bFaFvDUJ1gBm1tJsJsxvmZR5SApZ1c	12355	17397	17397	1619070660000	orphaned
24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	24885	3NKyXijPcLeDaVvrWijhCqeL7twkU9C2dJDSN5BCvTa4EJHKf47G	1406	1393	473	12463	16751	jxijecDe7rR48nYCkhEbTkcwhqATbvmiCPb38XqR66vsy4GTSKL	12356	17398	17398	1619070840000	canonical
24889	3NLjm376NLxK2uebnVmjyjNZzcvCxhz7q1Gp9hjZjxNBXa5Eu9vt	24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	1587	1111	473	12463	16754	jxSzwA35TWvNy5YuApHwFx1Dh51r829dE42f1vCriAvtxRiojxy	12357	17399	17399	1619071020000	canonical
24890	3NLxrfbsPtKXNSqX2LayQENPgu61TrBjFYMswvGcLuZRUiYuTDEL	24889	3NLjm376NLxK2uebnVmjyjNZzcvCxhz7q1Gp9hjZjxNBXa5Eu9vt	1623	829	473	12463	16755	jxUg21MLcaREo1xxmhPVDqzWfp4guVA1zcmi5rA9SUacvAy6M7v	12358	17400	17400	1619071200000	orphaned
24893	3NLXa7FzRP6zf63Vn52GsoB8bxXvyKvEpQUDqWwuiyBJTkGZB9JK	24891	3NLMTUUVCoCL2xvydXFm8WVyrFSo41QPPjHzbn28EsWb9ufMgQnt	1673	1122	473	12463	16758	jxUwrKYuENm87vUodePcf4EZMYnFzACsQN6q9sRLvvVPJWXHgby	12359	17402	17402	1619071560000	orphaned
24896	3NLvjsJjvmyVmEUYeH7wMCbnd3LA23wkfiCvJb4iWB3EQLZdP5Sx	24894	3NLHHrYMp5V1x4HTJcJCVZpqSHVnKSe3PoABQjxyA6tbSTn4UEuk	1542	1058	473	12463	16761	jx9ndUe1Zo7g9BbD77k7YVxrpQ7UiMekF3Du5erVRszeKtt1bUR	12361	17404	17404	1619071920000	canonical
24909	3NKvemPDNSCXgmjnZVPoLbyB9EyU2vgRUuV2bKttC5AziEuZ7bT1	24906	3NLKJ8CNwWEK5TBJAE3LNP5KkMisTVwdQMsTYxTkBZ4rqvLv1Jiq	1549	1362	473	12463	16772	jxxzc8zf6frdm89Vv5xVhY9vtj279yFPgC3FrFcB3zUfi7r9VV4	12368	17413	17413	1619073540000	orphaned
28374	3NL7hXGsK2EPBBRCMvC7KCL7w5DVjdvP1WaXuEUKzaGX7Nm33tDU	28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	484	1319	555	12463	18974	jxk7K3SVuWDjPekPH4JyQ5EY5BRUUPBQbKznoRT4nnsiSfaqiDF	14027	19770	19770	1619497800000	orphaned
29435	3NKbbDmcEPfcFQnaYhEbNssNz6YX2RDaCDeFSYshebv9iH4bnCTo	29431	3NLCE2yZd1XMWMyYeBiFvQVXFa2ujMuybYVKVX6aNPSF93LwfXGg	1594	1326	578	12463	18974	jwgNY7DGTtBDz35JJfGMBFs7FpotDAiM2udiui5x6jCdd69axRy	14511	20423	20423	1619615340000	canonical
24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	1406	1393	471	12463	16699	jwdugWpnVBPZ4mPg1kg8SBJLkAy6MqXuP6PyZCjtkDCTVL6Njbd	12327	17355	17355	1619063100000	canonical
24829	3NLo3zinfwPkr1UCd6YEXuTdJwq6PuHZfMaikaPrxtKuLVKDCeVb	24827	3NK96aV426AiYce5iPg8VSqgxepbNjdS3XDMiTDeWQdoBJ8oehQA	1527	1293	471	12463	16701	jwjxHXgszd9nZnkn7p6LSYvUPZwJLLXzb1CnT1DymGf4aGzS9XL	12328	17356	17356	1619063280000	orphaned
24841	3NKDvqn88AE9uoQzgECDipuc3BUEmBSHxj8G7NC4iCvLRTPRq577	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1609	1333	472	12463	16711	jwVXATWKJhKeqTD2mHuv2Mxpnaa7FQTWtWMXfFATaJUGvwTEeKg	12334	17366	17366	1619065080000	orphaned
24846	3NLZHbLaWmWUqfhvLsmwueb6qMBhQ294i1Qoy5Qzb3b6AKMdmUtZ	24843	3NKrXGALgwV3sbsPkbe2vXUQbGP83ZyHb5kkn3L1YPAkPhMqt8fx	1646	1108	472	12463	16714	jwVyjg82crPca1eDEFKtqagv26oCyKtZXBCXuqKLGEoB4Ft3mjK	12335	17367	17367	1619065260000	orphaned
24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	24852	3NLM4iE6iA11ZyWb3HtWkZhRrfdeDZrDkPNV2yPEDqR3Sqeav6jo	1613	1103	472	12463	16722	jxV4uprcbuX2vPHmX2PB9oidYoma6oaXjokWcZ8DMDHvRnpMfhm	12341	17377	17377	1619067060000	canonical
24859	3NKxR2y61iBsSjU6Y1iKGmTRYEETS21rfHU3eWCDtpyEB11VJiJG	24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	1457	1391	472	12463	16727	jxGBV7HpVYRUgM1UjeUtYPtcapd6kCneUJfFRFyS2XWZiAnxb9L	12344	17382	17382	1619067960000	orphaned
24862	3NKTytJwCqRgYxsANKUdzdJbetXEhahM5ATHHqxm461xG3QD3bSK	24861	3NL6bjabuyvv6jouPGB4EKQdB1T8phj2J5UB3bk6BXe1jvKoSXCu	1573	1192	472	12463	16730	jwqGD2EJF6EAPsdmbSQ5zHPC5cJzKow8ZRkgKTbkfY21DGpZyp2	12345	17384	17384	1619068320000	canonical
24865	3NLc25vMGxUv2TcjDNjoTuGGrjmU4FwhDqdUoDaQt3vvr8qsdRjM	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1589	1286	472	12463	16733	jwiZoCNgGZ6JrQA2Mwf8tAYkFDNR9jmjzyWhjnyEmKDWGaZShvE	12347	17386	17386	1619068680000	orphaned
24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	24872	3NKZGWJzPj1VJXAJk3fvDP4MYp4ZaKMv12xRPoDR7rCrDY4PxYzj	1564	1338	473	12463	16739	jxj1u8NMRHY7ZmNp5m52UrFJ8WoVFE31FBfmyxztroBAa71xKsz	12350	17392	17392	1619069760000	canonical
24876	3NLg4dfhRSqiAL9trStQi11AET6K8wmL7k9fS1Upa1VfUu2e2ZxK	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1506	1373	473	12463	16742	jwLxztBGqSii3mBZ7MjLznYMXKMmtQzVCSZTFh2Ew7qAGcgSai2	12351	17393	17393	1619069940000	orphaned
24880	3NLDGSaMuhmy5issiH3yEmGbvsA7Zj8ajHGMmXPAZpJiCkpZ1f6n	24879	3NLcjR7jC9DiimBcgMrrkThfwt66U6vJ126WVK2m1b1HmyK9hyXL	43	1310	473	12463	16745	jwCFwm88eZYFEdbg6QKuz4johciCbodLzMwAvep9zBxcGRXraNu	12353	17395	17395	1619070300000	canonical
24882	3NLEzUrgqydmP2Sa5SEg9CMtL6MZjVHMHTzwpPy9WJnRdSFjvYay	24880	3NLDGSaMuhmy5issiH3yEmGbvsA7Zj8ajHGMmXPAZpJiCkpZ1f6n	1406	1393	473	12463	16747	jxtGLKUigK5ZedJ1MX1VmF9hivsgGm9HJFWPG1Wa5nvwX2rYHKB	12354	17396	17396	1619070480000	orphaned
24887	3NKTiK1UHXga8XTJZ2MGt4QmqD2SUoqBbiPU59uP7mckjEVy1dTS	24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	1406	1393	473	12463	16752	jxQXjxUyBokSqhaVzfJYLt6R4RZWi4DyVqLW4qJ1vnQrqfhhpQP	12357	17399	17399	1619071020000	orphaned
24891	3NLMTUUVCoCL2xvydXFm8WVyrFSo41QPPjHzbn28EsWb9ufMgQnt	24889	3NLjm376NLxK2uebnVmjyjNZzcvCxhz7q1Gp9hjZjxNBXa5Eu9vt	1407	1395	473	12463	16756	jxvsWnxWTnvC6i4ndCr6wcwGJCSiwdpRyWsxdp3S4faxVT6M9Nh	12358	17400	17400	1619071200000	canonical
24894	3NLHHrYMp5V1x4HTJcJCVZpqSHVnKSe3PoABQjxyA6tbSTn4UEuk	24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	1637	816	473	12463	16759	jwm2vzgtVMmrbGhmiGuo3cUgvtCRtriFg57tZpC88MTFBLrPabp	12360	17403	17403	1619071740000	canonical
24897	3NLXGM2q36LMqZqWzNqdEtQ8DMwTTYJN8j3yRZShdeCrhmTj5zWA	24896	3NLvjsJjvmyVmEUYeH7wMCbnd3LA23wkfiCvJb4iWB3EQLZdP5Sx	1402	866	473	12463	16762	jxY9VfQzVQBAj7tvzFgGvQa7hFPKdShypcUo635uUdefyT2M7fQ	12362	17405	17405	1619072100000	canonical
24901	3NKJCPYrbzGpi4zibDsJC997xKb134xXzfqsFvYQ1H7QJgCgtz3h	24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	1553	776	473	12463	16766	jw8Fx1G9PqL2UF9jTY4crwssxgL2DQJy21hKBHeopnBDSe9xdCf	12364	17408	17408	1619072640000	canonical
24899	3NLeFnSNmJmYQ6dwF66MDS9J5bnEPiXGYmMvuHdZQXeKt66YKEwo	24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	1422	1337	473	12463	16764	jxnYw2EQUgpnbKxZ9o5tpYfzmfGA6dDdLgWyvLKHEexu6j4cGFp	12364	17408	17408	1619072640000	orphaned
24900	3NKuLn9wvycvcpmXmmpSsX9JrM8jCF4CqjfmYoZTh7pHtgbSssCS	24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	44	1199	473	12463	16765	jxogHJCBVKkJoHeVKFZMWSJDE25jBzRnJL6pwB69JBrA9XD5osF	12364	17408	17408	1619072640000	orphaned
24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	24901	3NKJCPYrbzGpi4zibDsJC997xKb134xXzfqsFvYQ1H7QJgCgtz3h	1610	1188	473	12463	16767	jxypF64jm5BpXDmpdESPTruKWsFHsxQGJCLos2vk7jh6WP2URDb	12365	17410	17410	1619073000000	canonical
24904	3NLP8uKo9X934kwsZif2LQBucQ7jSmSbxGMY4B9k69bwCoyfoTfy	24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	1578	1050	473	12463	16769	jwwk8Q1iTboexpnQSf5SQdP1TzYUPT4GS1LFEwAvMeNwHZ36rMN	12366	17411	17411	1619073180000	orphaned
24906	3NLKJ8CNwWEK5TBJAE3LNP5KkMisTVwdQMsTYxTkBZ4rqvLv1Jiq	24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	1523	1321	473	12463	16771	jw9agC4yXhinywbYcGCuSym8gMJgeRPTRRjfACvvLaUvXvvkN6H	12367	17412	17412	1619073360000	canonical
24907	3NLE84QZvw9RpqLHHJBEXHY5BXaQKpBdqsrtzGsD1eWSec5RYrgr	24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	1523	1321	473	12463	16771	jxRyyXPLUPmcGtrRJrcvDhRxbzw2kMtA2EALkeaCQTpKXHNG5WG	12367	17412	17412	1619073360000	orphaned
24911	3NLghxzktdWkVk3Z5yKmJj5LkBSN95deu6NFvU35MavP6Rmz9udm	24907	3NLE84QZvw9RpqLHHJBEXHY5BXaQKpBdqsrtzGsD1eWSec5RYrgr	1549	1362	473	12463	16772	jwgzTWi9i6rAkFEP53SHsvxsg6828kwTdhCYjH9w6oXYWYvZFZY	12368	17413	17413	1619073540000	orphaned
24913	3NLQZGDcGNZ3nR9h4ZBNBWTwBvG9nU6EtzZS8NCwTjiGQA9hsfb5	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	1440	1377	473	12463	16775	jxXGw2qA1Yh7WhZcimxjfAfscLYDnqxPyM3amU9Z9fYLPfzo7uh	12369	17414	17414	1619073720000	orphaned
24912	3NLjGyPUCGcz3PJbC7qPcKQ13QrjVbWxApUfKf3rVfEef2B5Nnn4	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	1571	1209	473	12463	16774	jwBQffcuAZTHbvG1nowdmzUfJUKCUhj2NTyL52D7RnMa9Rt2deE	12369	17414	17414	1619073720000	orphaned
24918	3NKtc9PUWRMo3Gi6gf8B9VjDoJxUH7ovtv7SizALR5SjTXS6VxQR	24914	3NKD4pacZDMiuiugwgxPPZxh4G7eMp5v7M95txiCW923UvGT5X57	1656	1097	473	12463	16778	jxHTUbbtzTi74ueYuHjsN4YgJYMhjH7swBwp694jsNx9ohigo5Q	12370	17415	17415	1619073900000	canonical
24920	3NLteZA7Lou3HGfo313LuocNYQp7RXj6dU1wEwwUC5pNcMfCSFMt	24919	3NKkanDP7qgR2jSvU8Zj7puKqMghN5SUShbUd3LQHyNPAoJkHsgw	1585	1120	474	12463	16780	jxmx9idyPx5KBWqvAA5SNQGMHu3NgXaiDubVE4S15xtDiWhg4ey	12372	17417	17417	1619074260000	canonical
28392	3NKnstvEjhXgVGgjN6xNvs7HsY84U9VGt8XShYqyRLyqL7wFuTx9	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	448	939	556	12463	18974	jxCA1v2zkGnmGtU6drAuUzKT3qfsaBY2bLo8UpvhUALGrPpW5nV	14033	19776	19776	1619498880000	orphaned
29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	29455	3NKW7nNoLnXy6GBbKNVENq4KJSYS86Gtf5HErY6mu3nY4VK4qUhe	1553	776	579	12463	18974	jxAEsq9aDoux277bz4T9YNZNy9L2dudpYgydJiyop2PRRszjs5U	14526	20444	20444	1619619120000	canonical
24852	3NLM4iE6iA11ZyWb3HtWkZhRrfdeDZrDkPNV2yPEDqR3Sqeav6jo	24851	3NKB8U95kgK3gN5Ja3spuESASkFMiWtxtkisGG5eKqkRfUwMbkLt	1671	999	472	12463	16720	jw9VWYcar2dJS9nwwn7sXDsKucG46cXfqnDY4R6iJoobiuy8VwG	12340	17376	17376	1619066880000	canonical
24855	3NKvxgsQN54RD3KdkQmMRewFc3kq8m1Br71mDckjKZyQdkkxyqXj	24854	3NK7FG25Cc4ZD1FPPDdPuMDysKXbekfT2WhLkvJqtVZxd5wx4y91	1542	1304	472	12463	16723	jwTwDPqe3pcw76DsnskKZCqptYGmDtftJ2BxQTwfC9tSQqgKUzH	12342	17379	17379	1619067420000	canonical
24860	3NLvNwDYE6Q795abqsuSGPuezRh4bn8UPxp7qidQ9GaDCcpM54yJ	24858	3NL663TYC5gqXY81Az8FoGioxbr1YfVccyi3cN6FAgZgSwutyBqt	42	1235	472	12463	16728	jxPiozfVTnz8FTfJXxMGy3E5tvXYKBB9jqhJBm7dwt5f2xBD3TV	12344	17382	17382	1619067960000	orphaned
24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	24862	3NKTytJwCqRgYxsANKUdzdJbetXEhahM5ATHHqxm461xG3QD3bSK	1634	1331	472	12463	16731	jxEVmeqdewQ8dt8nhyGV6kuidp3wU19vhDft4kDYk9hVKMaMdgq	12346	17385	17385	1619068500000	canonical
24868	3NLTTcXgViUYaQpmBjNuLhtZTgruKzLouxxARaeA7VgkRmXCoywc	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1648	1158	472	12463	16735	jwXDG2Qv3pHpSCPMsA4rWehAA2KFd6GcKHbmL87GbF46X9Bp4Wb	12347	17386	17386	1619068680000	canonical
24867	3NL5imcsDc1stfCrkgDeixHPLXVwgT6Xyr5T63uEU145vYME7XGJ	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1619	1029	472	12463	16734	jxfY9WwYvzw9YptEnEAevQYspkDPUi1BnqN5KoPH7PjtA9SJARR	12347	17386	17386	1619068680000	orphaned
24871	3NKeLxz4fiQKHvoikD4UVUbCCZdqPwLookdJKfixCVJ82EtwJDhD	24868	3NLTTcXgViUYaQpmBjNuLhtZTgruKzLouxxARaeA7VgkRmXCoywc	1594	1200	472	12463	16737	jxjKKAotb4WqV95rjWbgU1KvHbNqqmmr96K8DX4NfALvkwnazUR	12348	17390	17390	1619069400000	canonical
24874	3NKeNcqChh1gNwTW6pnCmLoAgDeBfKTDGnfWyC5Q3MBEyDJwsXC1	24872	3NKZGWJzPj1VJXAJk3fvDP4MYp4ZaKMv12xRPoDR7rCrDY4PxYzj	1577	1327	473	12463	16740	jxcWNqLBUmvGawepBaSFNQBn5ZXoee5Gj9Cydvd8N1Tvv2bWwfy	12350	17392	17392	1619069760000	orphaned
24881	3NKTLcpYLAgpertbt4XXv1hJrxpRwwvGnKnDAnrW3nbmnTWNPuP4	24879	3NLcjR7jC9DiimBcgMrrkThfwt66U6vJ126WVK2m1b1HmyK9hyXL	1402	868	473	12463	16746	jxBVyKHYjQFhFRBtpfatd2VYq5x3ujwr2anQgvJVUfMmc19Z4my	12353	17395	17395	1619070300000	orphaned
24885	3NKyXijPcLeDaVvrWijhCqeL7twkU9C2dJDSN5BCvTa4EJHKf47G	24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	149	1283	473	12463	16750	jwm9zoKu3nzrLdcTBGQgiSRWKeMnULYA3nSnRp7rynA97KXQDUt	12355	17397	17397	1619070660000	canonical
24888	3NLuiXjNEChj3sXG6CxYQQi49e3A6o3umwusw8s4hfkofmNdxbtH	24886	3NLG1Sc1UpmRyZZiq8v2PCLRRpJF1Q278kiiWStxVRhpLgPbVXy4	1461	1271	473	12463	16753	jwH6QZFSfzYCy8VBNHRcNnHz9wDKt8LVv9HgQ482izMbjTn7ykN	12357	17399	17399	1619071020000	orphaned
24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	24891	3NLMTUUVCoCL2xvydXFm8WVyrFSo41QPPjHzbn28EsWb9ufMgQnt	1406	1393	473	12463	16757	jxuzsEjaeKNAfgwGT7w7t7M2WG5775nfgGibXYCmCEWkbGcWvBi	12359	17402	17402	1619071560000	canonical
24895	3NLVZgP45n9t6Eg4fGydwqXrTGiaDDrDnJfroEnkobegmwK3Ev2F	24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	1650	1009	473	12463	16760	jxJbT3A1LrmNTtEk4YpVQVSgD83o5GQoRdPRC73DnzGFpL4Hd2R	12360	17403	17403	1619071740000	orphaned
24898	3NLrk83QhNMgjx8JBteTWdmpBFTRUFCjFLeN6igpNppzmGoa3gEk	24897	3NLXGM2q36LMqZqWzNqdEtQ8DMwTTYJN8j3yRZShdeCrhmTj5zWA	1406	1393	473	12463	16763	jxbkThatEEwQbMW8SUd2NjZVJbKsQnxihCJpGXqYCnX5htMJEWj	12363	17407	17407	1619072460000	canonical
24903	3NKjQS98yF1ahL7XV5zFpiT9TSDNv5vW7CcVAhuDPers3mnkc1gx	24901	3NKJCPYrbzGpi4zibDsJC997xKb134xXzfqsFvYQ1H7QJgCgtz3h	1490	1274	473	12463	16768	jx5PiDuLBMgDc55kep8Qmp9uk5EKWJtY69CQrWcvcL9ZhePnLQM	12365	17410	17410	1619073000000	orphaned
24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	1506	1247	473	12463	16770	jwebnfuLkdew8kY2Eqr43qtgafirsHUZzBwu3h43zbDvrQHC3CA	12366	17411	17411	1619073180000	canonical
24908	3NLGN7ag5ZFnqAtegxnfSbBMhrFk1bnXkRMm2mSpaZAiU5wVuSHc	24905	3NKVugmcHeRmu5XEkat51QDczfMqukxPdUfm3K3zdNqWyozeEuP8	1523	1321	473	12463	16771	jwaBd8J5UYwsqZtsmuRzV4D33sHe3Ak1i3zNLPEjxaKH5J3zhSu	12367	17412	17412	1619073360000	orphaned
24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	24906	3NLKJ8CNwWEK5TBJAE3LNP5KkMisTVwdQMsTYxTkBZ4rqvLv1Jiq	1588	1146	473	12463	16773	jwa16ZH7PV74ySDXBxrBZbrXkTXZCXw1YBvFqutbjwGnTc7MXq8	12368	17413	17413	1619073540000	canonical
24914	3NKD4pacZDMiuiugwgxPPZxh4G7eMp5v7M95txiCW923UvGT5X57	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	532	1303	473	12463	16776	jwNTF9JAyKqhWReXeDx1Ppo8cUxjAMDUHDinXZN9MnH28t6KfNq	12369	17414	17414	1619073720000	canonical
24916	3NLXASHWLZDFzbM7QDy8BNA4QAd5gzu7t75zekCkxnafgkpNtboj	24911	3NLghxzktdWkVk3Z5yKmJj5LkBSN95deu6NFvU35MavP6Rmz9udm	1440	1377	473	12463	16777	jwU9iX86TxAfwUn4F2HxeaoKceb2xm4wncr1cgymWoYAuuk9BJ9	12369	17414	17414	1619073720000	orphaned
24917	3NLtYwXooMGCcMbSXmThzuu1y9NoptJPFLN3E2z7ySzoWaNnTbAz	24914	3NKD4pacZDMiuiugwgxPPZxh4G7eMp5v7M95txiCW923UvGT5X57	1656	1097	473	12463	16778	jxHTUbbtzTi74ueYuHjsN4YgJYMhjH7swBwp694jsNx9ohigo5Q	12370	17415	17415	1619073900000	orphaned
24919	3NKkanDP7qgR2jSvU8Zj7puKqMghN5SUShbUd3LQHyNPAoJkHsgw	24918	3NKtc9PUWRMo3Gi6gf8B9VjDoJxUH7ovtv7SizALR5SjTXS6VxQR	1637	816	474	12463	16779	jwKewLTfxF4NPH68GrF8P6SEy4PzHoWruYuBe1Ae6qK5wiYMPU4	12371	17416	17416	1619074080000	canonical
24921	3NLJbjrLs5NoJqTktpoR8riiWuimizvNBeqnUgwRHzsNx6kbUeEZ	24920	3NLteZA7Lou3HGfo313LuocNYQp7RXj6dU1wEwwUC5pNcMfCSFMt	1596	1117	474	12463	16781	jwHoGRrmEEEMQxefJE1AxNbQfUv4sduLmiA8EVrpVsSAxwFxcFN	12373	17418	17418	1619074440000	canonical
24923	3NL8QXZ19Dv28iiSjgwsPTTSyS2hH7gmLtXyqZ6iFDFBudKnLQYg	24920	3NLteZA7Lou3HGfo313LuocNYQp7RXj6dU1wEwwUC5pNcMfCSFMt	1560	1165	474	12463	16783	jwWqbyp4foAU2S5UcoEQ56YWmE11ZVxWwB7QnDibptuXGi7QEXq	12373	17419	17419	1619074620000	orphaned
24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	24921	3NLJbjrLs5NoJqTktpoR8riiWuimizvNBeqnUgwRHzsNx6kbUeEZ	1407	1395	474	12463	16784	jwDPb8DxSrwLCBerUnVLEg18HQX2DSRkdT3qDwwVdK3xkLkCyx3	12374	17419	17419	1619074620000	canonical
24922	3NKoANfynqHYX4sL4gHRa7QDdSCceo7em7v6Fn48CcuYm3pr6h8x	24921	3NLJbjrLs5NoJqTktpoR8riiWuimizvNBeqnUgwRHzsNx6kbUeEZ	1560	1165	474	12463	16782	jwWR335gMDMLXMJA87yFGrtaYf9FEzwoaKwDnnDkRUSqoBZAZ7W	12374	17419	17419	1619074620000	orphaned
24925	3NLkX8MGFCqB7KZ61S3gQRy8XvePTuYQV1JkgmvJXPitAo7HWyhr	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1406	1393	474	12463	16785	jwnzhon1uNA1XWP6A1v6qZWwaawxxTfzQ2s47xjP4sRLXioZyHX	12375	17421	17421	1619074980000	canonical
24926	3NLBaeLPwE3SPMi6128SsFpjweiQe5725KtqFKViS82i8TuTDzS3	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1642	1367	474	12463	16786	jxTtx2YQsDEX1YVwTLqiKUUHKizP1Nq8KGB2F8MV6AWWmdm3hfL	12375	17421	17421	1619074980000	orphaned
28413	3NKozPVSP1Ebki5YvNndxs618aTfDP54PhsyM2RKKw5xtP7Mpov8	28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	1631	793	556	12463	18974	jxiKvSRij3vv9cHQSn1u64XsWACxcakvHAXpUx8toT3np6czfGk	14041	19785	19785	1619500500000	canonical
24942	3NL5MXg4bcKRXcu7xSsjUCr1Q1dbQuFdLaA7PPS3zEZoNiGcHhch	24398	3NKog5vnLAmgWWe4s3FLgpVd9jCnaZhjRRpQhZ87NEggY5xt1dA3	1672	1285	461	12463	16802	jwwbYQScv6EDj6MHfMwQodt5tMd1scc1MLyymm7VjgNbPFGkfP6	12132	17427	17427	1619076096788	orphaned
24943	3NL9FLcCFWSGWFChU98dr2bVtQ9Yy6kK6aM6fNR3U7ntSic1ijMz	24423	3NK8L9V1SSs7N3AV5SVjZEgxnVV7cynpwvQNfS83GMuMRvDKzT5Z	1672	1285	461	12463	16803	jwgvCu237xwZrBnCrFs9toPqrwoYgnJPARDtEDhDPP6VE4Rowi7	12147	17427	17427	1619076131050	orphaned
24944	3NLmJPB41SkVgj3ELbdQd6Sn8qGNxLBTJdyKU17ZHf9AKpbXNWeR	24454	3NLsfny2QkiSvgP7EcyvQbpGkT2fWsrPQkMtAgszkxsvP4FXSRb3	1672	1285	462	12463	16804	jx9VSGVHkgp31R7mZDQvbup18V7NRiHfLzA1Wj6fWLFqPM3x3Sa	12162	17427	17427	1619076168040	orphaned
24930	3NLPY9JkVNVqFPmUFa4TT1dUUr3mkq89eCkNEr5WxJrovtx2wm8J	24767	3NLW7EAoyYfgbSmwa1TR8PD4MeHiTXrj75LpHc8CkoBG8hPha9sw	1508	1387	470	12463	16790	jxuthE98MUnzVVYE2Y1FKFB4w54YtpueR1YMnM5QQ8m7sCc3x7U	12298	17421	17421	1619074980000	orphaned
24946	3NKgJSBwzvSZzFdrDyBaEkMrUe4vEWgJ3uZ5qHd4eKmyk4ZHJHLt	24790	3NKpnTF14cMmumSLX6btBEYwC96oBpAwMRnMboYXYMKQ17aDW3kL	152	1330	470	12463	16806	jxeZJX1bK87gM5BMUM4mCxKxbUeso8cYy7s7c9jhHbQVxJrJojq	12310	17429	17429	1619076420000	orphaned
24949	3NLRquojm4gNM3mehmexh34aQkBFv4qQzDHxTm9VHYiY86qLU1Pi	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	152	1330	471	12463	16809	jwe5w7JhqYegEiFwCPS6kayVjQRuEZRCr3jyDMowGFSbgMX3wjh	12326	17429	17429	1619076457331	orphaned
24950	3NK7U7hUyUR99CM3ebN89CzSWwoaPemm4taj6riDYFyE5MYnH5LX	24851	3NKB8U95kgK3gN5Ja3spuESASkFMiWtxtkisGG5eKqkRfUwMbkLt	152	1330	472	12463	16810	jxiPjJo1nFVfaKFZHujsQvywSX2RpahDfuD946LnrVzekNJ8wph	12340	17429	17429	1619076490992	orphaned
24951	3NLx1TrG3YpCU1GEW22iBiR34qYMgcGePPxxTDk7MtvPb83CG48t	24883	3NKHhiECbv3d5Aag5YK5K5g8ahKHaAY7SYfDrw9c9ngU2xRN2hCX	152	1330	473	12463	16811	jxiAxUwC5jUbDAeKzjixDCfxJjP8SafnsYgK2SrWX3s4aZhhDeu	12355	17429	17429	1619076526698	orphaned
24953	3NLbcEeCxBzJFEX4FjpZq1Ui1buVRQb6SYjtV4L9nzFe6p2QM36G	24936	3NLhNN4iPbEjgT8vKcqyoJ4oC7p18mZ71HLnzjF36wtfhbhvJvZy	1549	1362	474	12463	16813	jwFaHVpEQDDwxJf8r7oDrJN9g68hmfoLLCB8qAAV4VrRA7JzW2R	12370	17430	17430	1619076600000	orphaned
24929	3NL1kFDhdERQs2Sf7z7yrSTyj3EqNUzJdVYyH6NcKnRNuLP5boKU	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1407	1395	474	12463	16789	jx3fXFoP8XunLLB5tLUxvN9PzNHbisZvT8T6cV54tC6mBMwMNgE	12375	17421	17421	1619074980000	orphaned
24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	24925	3NLkX8MGFCqB7KZ61S3gQRy8XvePTuYQV1JkgmvJXPitAo7HWyhr	1503	1277	474	12463	16792	jwETZ9HKaujeSoBNTb7WMPAv8QuvgnimZt8rD8RhqBuEj2fexrH	12376	17422	17422	1619075160000	canonical
24935	3NKgcMt8Bf2YeicMMkxQuEX3Gf5MaNEUFx5BwWuv6Tzg8h5RyqNL	24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	1672	1039	474	12463	16795	jx3eHjhrCm1oudHudgrVzpFdVjXZfTx8qtMSN3yZAZen5vT5h2S	12377	17423	17423	1619075340000	canonical
24933	3NLkA4N2Aqoqh2C3hPK5WrvTnzSApcC2XXWBH1Pjp4Ha7tBx1air	24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	1549	1116	474	12463	16793	jy1ufPgABC9CUaWzsPaRgD7yJkm2wthHXmjeSvWvcu6bmJwUns9	12377	17423	17423	1619075340000	orphaned
24934	3NKJ8QfjLnAyTi65a9DA7xy68BNM7A2Ne5oZZ18vY1i2qKsCC44U	24932	3NL9tA8m85vpGpCVt3erckMjA5j5ZPYpkxQPKcSL8RimSYwdUE2p	1476	1125	474	12463	16794	jxH9QsPoYezWpNQ2bQaJY4YxwU7p3o5v4VjSVNqenDFUVXXELaW	12377	17423	17423	1619075340000	orphaned
24937	3NLEPudn5ShaLShVEATMuhkD8TGSw3dZn2m3ehnTTff7ZLZYVDPY	24935	3NKgcMt8Bf2YeicMMkxQuEX3Gf5MaNEUFx5BwWuv6Tzg8h5RyqNL	1646	1354	474	12463	16797	jxsX9BBK8YD8YnDY4FMgn4aX3ueWK6MnzBnnv8ejmmFHMezEUjQ	12378	17424	17424	1619075520000	canonical
24938	3NKhbLaoEvv2Bgq4Vnwx93VtYjtjAcqaZMguFfTrdyZ8HRST2XrA	24937	3NLEPudn5ShaLShVEATMuhkD8TGSw3dZn2m3ehnTTff7ZLZYVDPY	1460	681	474	12463	16798	jxiyp61Kt2JSZRVksLRbCLs8hcwVtpT6Qh67HPRqSurjB7Nv6Pe	12379	17425	17425	1619075700000	canonical
24940	3NLt9REjwX7NrxexaMRtj6uFJe5FKhiz1jv16q7fqihgqZxDA78a	24938	3NKhbLaoEvv2Bgq4Vnwx93VtYjtjAcqaZMguFfTrdyZ8HRST2XrA	1534	256	474	12463	16800	jwgbqYpUTRf9S1Cb1nTDSvC8hXuzcaoPRQyWGPZhtaPrdRktieB	12380	17427	17427	1619076060000	canonical
24941	3NK3FH9Ltuyk9vjxueTZQRYvwEKyKYSgnR24LxW8zvKTfFVLUkUK	24938	3NKhbLaoEvv2Bgq4Vnwx93VtYjtjAcqaZMguFfTrdyZ8HRST2XrA	1672	1285	474	12463	16801	jxN4SNXEVsH8LzsFZ5K3JwCDtMV4j4StKUpwpe7199cJEWeQfww	12380	17427	17427	1619076060000	orphaned
24945	3NLGjwC1W18c5rcb7WKFygRQPmRe7NH2A521deLhXbhTAsUj2TRS	24940	3NLt9REjwX7NrxexaMRtj6uFJe5FKhiz1jv16q7fqihgqZxDA78a	1405	905	474	12463	16805	jxjCsjkYwSx36NuGugqhzcjW2zhUzb9iuJD2xCeF9u7Ytny8n3j	12381	17428	17428	1619076240000	canonical
24947	3NKtrD5pLKQcHvuyZAU9BdVeEB15WCYSyNPR9soKVET2dSzhwVL6	24945	3NLGjwC1W18c5rcb7WKFygRQPmRe7NH2A521deLhXbhTAsUj2TRS	152	1330	474	12463	16807	jx5zTHDE4qp5gsDCFhWPef27HH2UoWY5biiLL1Meb2objBFFZp6	12382	17429	17429	1619076420000	canonical
24948	3NLxeVHBGNnCuEwA7bPpHLigrhGhemw5xWL2CYiSPDDSUESCuSQ9	24945	3NLGjwC1W18c5rcb7WKFygRQPmRe7NH2A521deLhXbhTAsUj2TRS	1407	1395	474	12463	16808	jwia682N2YzkB7RPr5sAx1U2Ur2dBKyXwUsDHeEYSdtP2KCKCeU	12382	17429	17429	1619076420000	orphaned
24952	3NLDe4QHsb9dsV4aCdK9qXD1nupVZDdi8yfKpYnwQCiq3W4oR7FJ	24947	3NKtrD5pLKQcHvuyZAU9BdVeEB15WCYSyNPR9soKVET2dSzhwVL6	1549	1362	474	12463	16812	jxUJqpHabsmfjUouaPerpQH5hd1fnbLhDphhwcunT1pRhVDcAGc	12383	17430	17430	1619076600000	canonical
24954	3NLNxjVmn9kKjHTRPNJc3f3fFiT8ng67mUFYvR7kTzU7gUcQJdjy	24952	3NLDe4QHsb9dsV4aCdK9qXD1nupVZDdi8yfKpYnwQCiq3W4oR7FJ	1507	1154	474	12463	16814	jxKZwgfDik5y38qkpKhNZ6XhnVVXYXiB3TN3y9nHz6bgLHmjx7e	12384	17431	17431	1619076780000	orphaned
24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	24955	3NKe9H61sa1uW8WMpJaea38qg5EE27hrFH1cSLdjbpLKCdy56WC9	44	1199	474	12463	16816	jxujHvxvruLJvBGAteT9TxNnZnTJ2PKY4qNmjoF6Wd19Cs1DbaV	12385	17432	17432	1619076960000	canonical
24959	3NLC2zbRNGegSxe2qcMaeN1EBQyybPeNdQvjwY8CzemcE7DFaTUo	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1613	983	474	12463	16819	jxVHtmXa3fE3YK6iSoRxWEg1HHJ1TAu7W56fy8jwEQVPuHhGcH7	12386	17433	17433	1619077140000	orphaned
24966	3NKz1nSpmJvUvJ5P9PH5BWCdkZ2XaFbGT8iZVb15TSc5Q6UFFjQD	24965	3NKvM3FrBJNG25ysVD9c5vaNTPDaxhrp3FoLKcQVdQd7X7e9aJgp	1590	1174	474	12463	16825	jwo3LDCL4Zg2sEAtXi62nmrS2iyhhk27ocBtqb31MBLv1Y4vrc4	12390	17440	17440	1619078400000	canonical
24972	3NLMDENXLhyNedWwSRfsvqT57w75aisC3C8oQERv3Fm79HhkaGnT	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1623	830	475	12463	16831	jwXupQm1c47TkqT4g7VP2pLr37ADXJmtPfWRN4jnSxZSDGULSKe	12393	17443	17443	1619078940000	orphaned
24974	3NLddWHgaWENCWqivZmDZUsPgMKjcy3c4vf26jW7jGSLMp9VZE4z	24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	1588	1266	475	12463	16833	jxk2jfQDC6E1TyXjqPqdiPi9NEr68jZnvVWn9aBfh2oS9fNCUqY	12394	17445	17445	1619079300000	orphaned
24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	24976	3NLGzNLWDZXb5yLDq7UYCFYKRoYp4PaUaV1eSXLP27Js1DFs1anc	1406	1393	475	12463	16837	jxysNFHy9DJm1ScpDVnMFa6FWBQ6gnMTYYNirWgn56hLGNUo19y	12396	17447	17447	1619079660000	canonical
28422	3NLrVyRWArZmwBhhbF86x5LKxQULK4nQpC3jFvCd2EWm6Tbn2YkD	28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	1573	1318	556	12463	18974	jxCaYEQuNeY1W71yxHantzrAMSCjF6sh1aWDhhkGMXkHoDFQeYX	14047	19794	19794	1619502120000	canonical
25038	3NKZhXVtKtU7tSjGzAnk9WT6n7R7mZKgj9uVo3GHCR7P6Vsbcbgo	24902	3NKJm83hMxN1XzgbBTLm3PMRd6Wa6rCJN1XXA7PLdaX89DtkQydr	1522	1322	473	12463	16887	jxp6z5FENTQYa31LrMtaDi6c8cc4hSC8wRQfzws77g1upbRPkeA	12366	17484	17484	1619086320000	orphaned
24955	3NKe9H61sa1uW8WMpJaea38qg5EE27hrFH1cSLdjbpLKCdy56WC9	24952	3NLDe4QHsb9dsV4aCdK9qXD1nupVZDdi8yfKpYnwQCiq3W4oR7FJ	1445	924	474	12463	16815	jx4TNZLy7aNrQyvVhhqamJKjMhfSAGhPAqZBeexNGghQCJdyoYj	12384	17431	17431	1619076780000	canonical
24957	3NKykQVkkiVj5fx1JHMtHdkBEdQt6Ux4S641RdAxFNMvNn3meH8e	24955	3NKe9H61sa1uW8WMpJaea38qg5EE27hrFH1cSLdjbpLKCdy56WC9	1407	1395	474	12463	16817	jxdBHusmTB7JHJiToRB1QzT9bRTBm37fGMGpH1pPefQVcbtsgki	12385	17432	17432	1619076960000	orphaned
24960	3NLTj2wa3c4Za7jmgzLRfLPpuZs66r7AGVMFnc2LPpfHWkYyGNQ1	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1613	983	474	12463	16819	jx7u8xKvxo4qWg8ie5ahTTiGJzWvfei7GvvV2Lo7Y32LxUNxbDB	12386	17433	17433	1619077140000	orphaned
24967	3NKjpDFYDJMVXKNYaSKjMHLhbnzqXssQxEr5oDCsehTWEud2aMqk	24966	3NKz1nSpmJvUvJ5P9PH5BWCdkZ2XaFbGT8iZVb15TSc5Q6UFFjQD	1406	1393	474	12463	16826	jws5NW6pVSpWyw8FjmHLobmDWr229ehSX62rbohJm5BkgyVYJs4	12391	17441	17441	1619078580000	canonical
24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	24967	3NKjpDFYDJMVXKNYaSKjMHLhbnzqXssQxEr5oDCsehTWEud2aMqk	1581	778	475	12463	16828	jwBkGszKXmSK3RYA45c4mGKc1TX6DC4nELoTrpVyMkmrqwHNkMZ	12392	17442	17442	1619078760000	canonical
24975	3NLZrVanoPTbZQQsfLNKBcHYPfqYvxvV9zp7WjFN23az2HLE43Hd	24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	171	1374	475	12463	16834	jxBMMcuZdmLMAU6kAUh6wVijn5xobAhE33RGWiZq9QWLXVsyxfM	12394	17445	17445	1619079300000	orphaned
24976	3NLGzNLWDZXb5yLDq7UYCFYKRoYp4PaUaV1eSXLP27Js1DFs1anc	24973	3NKQGUSH8LVycgpnzKFaFmbZoUhrRe19jeatacyF9SxjaQrqJwqr	1585	1000	475	12463	16835	jwFEd9KgwbPYh9PioVFz7VAnsskNAGG5skYXSaNQYLCnmjfNrYj	12395	17446	17446	1619079480000	canonical
24989	3NL9WjpfejS3dYioi86VnmPFi4Gvagkq7fvAc9zbHcjRXvqLA4tT	24986	3NKWWidBeSzi67Qb5X3QNU2cGJZ864huWYzetvKpWJXumsZi2Zcv	1440	1251	475	12463	16844	jxtVgseFmE4dm3guX8nAqjN3xbpXdirbvEkpL89FTQ86TfSnCkW	12400	17455	17455	1619081100000	orphaned
24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	1607	1348	475	12463	16846	jwjeHBSnCUTsphz8vzCoZX4BYLq3XpHWZTSUqoYDN8XsFQjdGnQ	12401	17456	17456	1619081280000	canonical
24991	3NLQi5QwaTGGu4BN61RX2nmrgs7c5i2nrhmJs5GKJdkP3jpLjNvQ	24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	1546	1093	475	12463	16845	jxHJmQdBMM6QqLwCmuQGhbccUJjMRBzW52775dnukHHFVzDWAz8	12401	17456	17456	1619081280000	orphaned
24998	3NK6YkVbAs7PvqeejP9NptBfhSWRqKPEdfVMfw6YcqBLfhNyXzK3	24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	1547	683	475	12463	16850	jxMEN6jtawRhdPsoWavmB9HyXr8PqEtPbKM11LFykMG8jAq8mn8	12402	17458	17458	1619081640000	orphaned
25003	3NKCNAwqRwgmcCN715gqAjJTNJLHTsgkDULvQJVnbxN4UyzM5VUA	24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	484	953	475	12463	16854	jwCgLm8Wv6exU78QR8zTnhaYXTAmFCtp8oPKKxzKY9FRdEqkjW7	12404	17462	17462	1619082360000	orphaned
25005	3NLuw7anpYWCiduMrBXX3jARsqb4mjgcRvTcqp5bsrUyM2hTmwjo	25002	3NL5punPcrSrNmFKSbNFLHhxdpw8aSMTdQKzE2QXv3yVkfaSdtK7	1594	1326	475	12463	16856	jw7CVwfmrfWo9wQhqgE9Dixi5Uvs1TXL1y9gXAiM5wqMMuZND5s	12405	17464	17464	1619082720000	orphaned
25010	3NLJLByb1wnYExaGHqMZ9tWbjyKBmasyQtrdN8x6YdeoKq1FTUpa	25009	3NLL5hXMzXLEkpdDnL8UFBCZGtVJPWvCwcbnPyvYz7aXifK4JnhX	1613	1349	475	12463	16861	jwBX7652Vx7QRzWbNszAZ6f1mKhKvqsJHLCh6bZK45Ft4WX5GNy	12408	17467	17467	1619083260000	canonical
25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	25012	3NK6cFYBjte3xjnWwEcP4cAioGcA5M1GeFvdpCB3wu1cncsaTJYy	42	1235	476	12463	16865	jwAmNCoYzVWxp2jYa74CW9324oUnTPFMhB6jEJpfGVyaS293xEA	12411	17470	17470	1619083800000	canonical
25021	3NLtxh9S4XpBp2WrSJ3Ay54aQnWuZfDE6SNpjpL8Wu8iTCGPbMn9	25015	3NKExRW2n2E8y6HR8UbSB5s3SWMvYGmxErPKav46SaQfyUuKzdKs	1560	1045	476	12463	16870	jwX2DUnCytsi8e993uNykm8vh3cRC1c8a5Ywz6ddPBYkU7ByD4G	12413	17474	17474	1619084520000	orphaned
25023	3NL299CtUXVgvwzQshFSLJfQUMVQamghKopULjDjSQGgU1ST8BNT	25019	3NKA7fGL1SdZiJCG7vXfYaJ6zUdbfhC95ZN8nrVhkG4886vzj8ku	1407	1395	476	12463	16872	jx95VTYEnHfaQW4JsWSzY5FeJqoB9xZ7N8QsKEXayZTZqx4iqdz	12414	17475	17475	1619084700000	orphaned
25027	3NLPqGdV74KAGW8v1iNktzBtiJm4a3GmVXh3Q5Pcgj93e1F4ScH7	25025	3NKQzUFbW1igMoyaqh7a33jiNFKZnfjFSnV6csrtPfMtSBinnFin	175	175	476	12463	16876	jy1UUBbA2y3eUCPzKrCeLLfQHuXuf5zfucSCJr2TbTrqTvm6ToQ	12416	17477	17477	1619085060000	canonical
25033	3NL5J38gUdwoXFXPXgBTVnCTbrHw5m8KnUFchUVHhxmNNnjt5PC3	25031	3NKHabCTcuRMBisnwMVBp127KU7epkGzGzZq4R9ZYyLMbnHjqQ4Q	1407	1395	476	12463	16882	jwGVvDTqeAjk8bNngxwi9dzSQse7LmV2XRLsGe2G2Cf36NzSBqT	12420	17482	17482	1619085960000	canonical
25034	3NKyaf4htGyDVojrntCR9tuYRm9Mtn12bJcn5jeZfKHpjdFWy2YM	25033	3NL5J38gUdwoXFXPXgBTVnCTbrHw5m8KnUFchUVHhxmNNnjt5PC3	1402	874	476	12463	16883	jwQ4i813EeU6ow4wSwmqcDGGJakw8WmCULH6BNAmxLLXUFGRRYW	12421	17483	17483	1619086140000	orphaned
25042	3NLVFGfE2hY7BR3DuZq2ZqagiBHjqDDGnK1HCkUpWSVxGxbxNYNx	25037	3NLaSDanjV96SkESUm8eeJKC4GY2wYdfLRgws2Lwyt9ZFqFK2wN2	152	1330	476	12463	16890	jwvSs1kkCp2jpV9QpY2p4Vaz1FnuxkKgqxeqE7GUX81wJRsmLib	12423	17486	17486	1619086680000	canonical
25045	3NKXav5g7RAM4gPnUuri3ia1Bunhqy9AGhcjxv4zG9WQnH5PusGu	25044	3NLs5qwYpWxpUjkayVnixuhH8uKDYpGfjpiNJLkKKQp489TGDAm2	1637	816	476	12463	16893	jxzik1Ugz6L8af4HvmQ2Aab77BBsakriDF6eTUPASBNxY2grC7G	12426	17490	17490	1619087400000	canonical
25053	3NLtcFHhjSrmjfMeRc6JccHbsYS5mLW78rqywK4WzpwsEVq6sxh2	25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	1474	1329	476	12463	16900	jw9EKiBze7QwHtTeY7xdct6DTAWZ29PqNEJFWcEJiMY99cd8FxE	12431	17495	17495	1619088300000	orphaned
25055	3NLfbKk9D1JLFqEoJTjtxvj3ejz6sMUAojRXPrrXFdmKerLHXixD	25054	3NLjGnf6qaDhkKms4U5vmC6TcQ235XjDWexRXcN98FjG2KKgbNwp	1407	1395	476	12463	16901	jwTUoe3yqDzjgDYmoH2rNHnt1igA8xqtANEMzqx2DjFxX1vb6Qq	12432	17497	17497	1619088660000	canonical
25058	3NLwtqx2F4PZbTW7GQUgq5bAUPgf8WdiYvthSUuyNQc4ytMaDwg5	25057	3NLGafcb7kotmMRZ3bJnZyAD7rABLtZMHGg5C54yAEVzKj9nkJgV	1506	1373	477	12463	16904	jwMAtFufwQZ3EnJn6omStPGPNPhUMi5YERsrDzuS4kVupFMXp9Z	12435	17502	17502	1619089560000	orphaned
25065	3NKAXBZ8Jogzg61DZhGmJSKHbW4sHojvNqCWuWk4vFXJgWWnXinF	25064	3NLjpvzepLzS8R1vXds4eTYPK6JSFu9Gk7TXb2apqSuNMN87FY4B	1553	776	477	12463	16910	jwaFE9Z4zuoMHx1wLyuE9qu8RcWD5azbjmB9QMzqiruxnDwDsuH	12439	17506	17506	1619090280000	canonical
25068	3NL8cRJMmMdN13qJMcayZ1W4pYSAFZiNEpQXgLwBU1seREmghBEM	25067	3NLSzvAFJfzpaZXj39WPhBHxqbgyptCCgLRY1KWv9pEBrjEQEn8C	1467	1467	477	12463	16913	jwTtFeR7pyVK1oT33c7XMGu4vamkYWcYHVHmfJ1NRLngYJXxdfV	12442	17510	17510	1619091000000	canonical
25078	3NKJKmVEx9CaaU66UJAfA9MBXAYA2EpwKq11bgbKGMU1U2duZnQV	25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	1649	1137	477	12463	16922	jxfvBvjyn5wDndHWnetQfPB2X6UmRg8cCwh5fcLVuD3LhsjPT9v	12448	17517	17517	1619092260000	canonical
28439	3NKwue6qSw3FfnwzkdM3S2E5tdvUYRb33zHjaKxsAvJSjVgXMzW7	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1651	462	557	12463	18974	jxBF9puXsvDCY3o48EmDaTe3BCQAPkdMVZ8pGVsFGktCL2zQnSZ	14054	19810	19810	1619505000000	orphaned
24963	3NLaqwi4n2FBiRDkS4mb4QmDL5uA9x8jSm4jh5GEbZjWc1cwr5iX	24961	3NLGD9AuKtNm8CjaZ4EM1XQpC7zRaCdHpkDvfTKEbACRT7M92f2a	1407	1395	474	12463	16822	jwuQaH6mG8ZQVQEC2Vxc8W3vZj3rVyTuQRBtFJohY6xBEXgb1VK	12387	17435	17435	1619077500000	orphaned
24965	3NKvM3FrBJNG25ysVD9c5vaNTPDaxhrp3FoLKcQVdQd7X7e9aJgp	24964	3NLf5pYHeBAwid1uo2RjviiHuz7TZJRc594tSrv1Xt5Z565XoeW5	1403	824	474	12463	16824	jxsP6LwprGhVfb1vx3AN1e7EvZ6KxiGeEHHZjspHenqAJJY3uWZ	12389	17437	17437	1619077860000	canonical
24971	3NLRP2kuf2Tp774P8gkFmHrnTRMSjuBpLy6ETXeGR6og5kk5pnix	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1534	1191	475	12463	16830	jx5dqou5SqX1sjazfGKEinESfJcKYC5n3N8KUEptisirbKLcxrS	12393	17443	17443	1619078940000	orphaned
24973	3NKQGUSH8LVycgpnzKFaFmbZoUhrRe19jeatacyF9SxjaQrqJwqr	24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	298	1182	475	12463	16832	jwKRttevvR7W9dxpt5MLQFYvN7GUPYyZhysLUCweQT4G8UuTQE9	12394	17445	17445	1619079300000	canonical
24980	3NK7PCnAcbGCHbKHkakZMPo8Zv6ZYLhgYu4gPtygMh3Q9EUzRCqf	24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	1527	1047	475	12463	16838	jx4deaDgJkE82R9eCUh4NoZz8d4GFiXaDTerhyrb3WCd2qyzZot	12397	17448	17448	1619079840000	orphaned
24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1405	873	475	12463	16839	jwK33hJkCKfKmzrQDSHNgpLqstSMGmF61tsqd4WaUxvkLi5zFuk	12398	17449	17449	1619080020000	canonical
24984	3NLYWBA4263eySAfHa8jhVTcgdPLJqTJKKMieHPpwsKcZHUWaLoX	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1527	1167	475	12463	16840	jwy36NcWkbBn9qhmeMj7K48sCYadbzVxsmVSiC9qH8NdJf5Gck2	12398	17449	17449	1619080020000	orphaned
24995	3NKhUnSxC7uTpRKBywK2DDXGR4qZiqbQV1FijoJPcsBSP3JHHwZb	24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	1649	1017	475	12463	16848	jwNGL8ERxWDwE47gifpbnWGNdd6a9hHBkieYWQyK4Nz1EeAhq35	12399	17458	17458	1619081640000	orphaned
25000	3NLVykyDQZA2q86xuCAyYmRiyjPJYV9KaqJNhbmLmsca4pmf8HfP	24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	1651	1301	475	12463	16852	jy1yepm9fGAAEk97G6MLP1GdC2xzKN1ufrajZyt3Z57cTbjLRcf	12403	17461	17461	1619082180000	orphaned
25006	3NK66WovPj6jRmqxKjT4wH3tXEqjQpmT6rmGMPf5U1c9hri4Q7AY	25002	3NL5punPcrSrNmFKSbNFLHhxdpw8aSMTdQKzE2QXv3yVkfaSdtK7	1560	925	475	12463	16857	jwkLDAi5htDE56D93so8Aip1AtPBmauptGMSQW4vEpHdMQaFivG	12405	17464	17464	1619082720000	canonical
25011	3NLT29faMWXP1Wv8QbqKuHRojQaEKrVVMCHEing4LwTPXDjx2Ftj	25010	3NLJLByb1wnYExaGHqMZ9tWbjyKBmasyQtrdN8x6YdeoKq1FTUpa	1546	1339	475	12463	16862	jxepSkRqkmBWTg5VReiCE7g1xSTUb7rBhfPh7ukY3K1LAngh9es	12409	17468	17468	1619083440000	canonical
25012	3NK6cFYBjte3xjnWwEcP4cAioGcA5M1GeFvdpCB3wu1cncsaTJYy	25011	3NLT29faMWXP1Wv8QbqKuHRojQaEKrVVMCHEing4LwTPXDjx2Ftj	1623	830	475	12463	16863	jxnuSiWzeGnRBSD1JEVksczJ2vt9kxPdTBKUgXr3ddU5usGVdt3	12410	17469	17469	1619083620000	canonical
25016	3NLVXBJbJpiKZ2cCEeGFD5nUzZogYEM4cdAVHcUAtrpwH7yL9LA5	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	369	1186	476	12463	16867	jweNwMAoBsR91NXTftjWrsUE6pMmXPkKuAqKvDgHrD2Qydqa778	12412	17471	17471	1619083980000	orphaned
25019	3NKA7fGL1SdZiJCG7vXfYaJ6zUdbfhC95ZN8nrVhkG4886vzj8ku	25017	3NKqC87YMrWTXTyaMUzRGJ8DXqvhqaB7yR8Pr92oBzhEA8ZtaHxU	1439	1279	476	12463	16869	jxD8nXbSZUctaqndWtQhZ9yCGPhCsZfsF3q3jXyY1yJYWGYeaq5	12413	17474	17474	1619084520000	canonical
25022	3NKWyAvu3WvyHjoMyPeNRNkqgDm62od31bz3YpfCbNSzkCLbwd7B	25019	3NKA7fGL1SdZiJCG7vXfYaJ6zUdbfhC95ZN8nrVhkG4886vzj8ku	1601	1388	476	12463	16871	jwttX3UrohiabmpqYJ1fHmAX1oNWbNsbZgBaCKcXCBB6Ung1tbF	12414	17475	17475	1619084700000	canonical
25024	3NKQ4W17KbbsaV68VUYdzQvmxRtswGuWaoSfPv8xgPXwbg5f5MXb	25022	3NKWyAvu3WvyHjoMyPeNRNkqgDm62od31bz3YpfCbNSzkCLbwd7B	1671	1119	476	12463	16873	jx114ZMuGHQFL1H8AfsVHxU4J2oCA2SwGzR9ptiFiV36SE7eVob	12415	17476	17476	1619084880000	orphaned
25030	3NKwBtR3FYNZEtPEXUpDb1tJq8FTTkCV5foe3EoP2vBHPCLmK9Ko	25028	3NKK13QfxL1uFyfjAfCKFrebBeETS5wuRcDjcthzE2q1hfG76TLz	1587	1357	476	12463	16879	jx3ctaHhNWWf5c1pTUN8YqXdcGgAGjoAzFsZyeW364LQfvQRk3N	12418	17480	17480	1619085600000	orphaned
25031	3NKHabCTcuRMBisnwMVBp127KU7epkGzGzZq4R9ZYyLMbnHjqQ4Q	25029	3NL9NDCH7goSNH6p2DFr7mcwQTWEBCfKkhifuEYpiYNRN7bsFyzf	1631	794	476	12463	16880	jxrKYZ5wixMkT1DC3KXnm3H4YZdjEHRFeyc9myHF8idzLdXGH2C	12419	17481	17481	1619085780000	canonical
25036	3NLVG94QTD983cu7E1aehqfTrvqFw1g6A9dup2FwJ9kLf1YiTNSp	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1522	1322	476	12463	16885	jwEsL8JBguwbWH3Z59y3Fv9JCKPF5jkWuBcKoK2jvQKavsDEnz6	12422	17484	17484	1619086320000	orphaned
25044	3NLs5qwYpWxpUjkayVnixuhH8uKDYpGfjpiNJLkKKQp489TGDAm2	25043	3NLBoZJv9vNdTKVoafDs9P7XQaRZb44L5q5xLBSfg6xi8Y9YCgMu	1594	1080	476	12463	16892	jy1mz6BW8gyyLxYS1yaizq4yr7MoFWEGd33HujSjxxkbSmwWZUV	12425	17489	17489	1619087220000	canonical
25047	3NKSB2U8F7NmMHgRz8CTG5JVDesvya3Me9d7Pb64SKC6v1dUx4Sy	25045	3NKXav5g7RAM4gPnUuri3ia1Bunhqy9AGhcjxv4zG9WQnH5PusGu	1637	816	476	12463	16895	jwisgdrtUiofUrGQCZokeYwGkneziFTs6735GF1oVENeW5NRLXQ	12427	17491	17491	1619087580000	canonical
25049	3NLedQZYhyNEFiFKidrNYNDBaR6BRkokur5rhf4TreWCdSAchUTY	25048	3NKDea2DknU8mqK18yU52oj1d5vYG3w6doMMiZuPnmADWX7gnDUg	1590	1174	476	12463	16897	jwZF2tUFB5zzKY4d6HzicfmftJWujE4jQcLhjh9AtsrY9J7NR4J	12429	17493	17493	1619087940000	canonical
25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	25049	3NLedQZYhyNEFiFKidrNYNDBaR6BRkokur5rhf4TreWCdSAchUTY	1507	1154	476	12463	16898	jxKvUKrHaWpzfmGAY7t3V8nWtUmfCpLkX3tWnZ645sfJusjcQ4e	12430	17494	17494	1619088120000	canonical
25054	3NLjGnf6qaDhkKms4U5vmC6TcQ235XjDWexRXcN98FjG2KKgbNwp	25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	1474	1329	476	12463	16900	jwFVmsvSivcoAkDCoyDt89PjehosKvzXYpHYBTABbaw8GPNhwg8	12431	17495	17495	1619088300000	canonical
25064	3NLjpvzepLzS8R1vXds4eTYPK6JSFu9Gk7TXb2apqSuNMN87FY4B	25063	3NLaQymgKM5SQKwDbZ5BSCRMGvcaJpzhNMEaxSHZrCQne62ygDun	1501	1360	477	12463	16909	jwcc92DWBZkEMMj7XzwnQdGi48xWsdcHs72AfAYKQoPQJEQAV1d	12438	17505	17505	1619090100000	canonical
25072	3NKWvDFUgVAmu64v56z9SsAnBJ1WpGW3fVwk5D9B9vopQEBKdzkt	25071	3NLoYDsb2iqxmg9PM4AUpseSMqaKqsmkV8V5Rw24sHQXsfnosfkp	1406	1393	477	12463	16916	jwSZqrgWjBKcDaxetDdZXySqYb7Aj4PsLieVPVh6hSVjjabEXNt	12445	17514	17514	1619091720000	orphaned
25075	3NLAF3G48d7MVxkmJQ8gvTevTpESjBhFFeVnRZF1myXisbtQLwUF	25073	3NKrjrM5o32MBoqdWUpGaRG5VGEL31HQ8c5YpzUvTxX4HSjXLyhH	563	563	477	12463	16919	jxXu7iDVFcMjC58euvY7Fs4tTGABdXah8qYNEkCu76Dc6yit9Vb	12446	17515	17515	1619091900000	canonical
25077	3NLnF7SoCtvLCwn8c3UgbFTAZSBzEW5YUvg5o1uTREwtJrZX7YZt	25075	3NLAF3G48d7MVxkmJQ8gvTevTpESjBhFFeVnRZF1myXisbtQLwUF	1600	1006	477	12463	16921	jxGL4aY1g5zpGz3NFKufETbwAQBhwaR8mEj9ABKDCAbbrhuU9nf	12447	17516	17516	1619092080000	orphaned
25080	3NLvdm7sA7qEyf8t3a5ddPQb8LjEojuLf3HxE5jkAQssgfuTKYhs	25078	3NKJKmVEx9CaaU66UJAfA9MBXAYA2EpwKq11bgbKGMU1U2duZnQV	1536	947	477	12463	16923	jxVjdou9qxzMhRW7WZ3jCyHGefUxPBNpWR1MYyCJRieNKZC4vkW	12449	17519	17519	1619092620000	orphaned
28460	3NKx8wQCdds3n9Qse9CMYosYjjyv8USwprm5J6GhGLAF9UjWpjaA	28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	470	1309	557	12463	18974	jxmZRTcWUgNHQeAPbxmpLJHRGn2Sn4ApQoeAiffZQQy9EH8oeXv	14064	19824	19824	1619507520000	orphaned
24962	3NLQekP9G35FuA2E7pavLasyMtrBh6fccrQxazXfC6FLzovMekKK	24961	3NLGD9AuKtNm8CjaZ4EM1XQpC7zRaCdHpkDvfTKEbACRT7M92f2a	1447	979	474	12463	16821	jwQFQZBmUSFu7ZjZZmFzxiswpeGLCkXapXJmGj4SR5A9wRzhdLA	12387	17435	17435	1619077500000	canonical
24964	3NLf5pYHeBAwid1uo2RjviiHuz7TZJRc594tSrv1Xt5Z565XoeW5	24962	3NLQekP9G35FuA2E7pavLasyMtrBh6fccrQxazXfC6FLzovMekKK	1564	1338	474	12463	16823	jxMTyVDEeaHttqZupfXmSpSJsXYPJEsv7PEe7WM2pFdXv8dod2Y	12388	17436	17436	1619077680000	canonical
24968	3NLhSvnF7Deeuq475zhhoWtYhRrjVmyUymRYaPHy9CVjjBsWkPbZ	24966	3NKz1nSpmJvUvJ5P9PH5BWCdkZ2XaFbGT8iZVb15TSc5Q6UFFjQD	311	1307	474	12463	16827	jwybvPLoUTEKeEwfb5NEjNwRS5XP9uzHYdR69YNiDPmaGZQB2KY	12391	17441	17441	1619078580000	orphaned
24970	3NKhSN1HgxX2hqvUwAYygH6EUJMCXLC59QNDDiL3ZDyGanTKGjwr	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1608	923	475	12463	16829	jwXSyrTBVs9v6XwECSgnz1VyGB9o7a8qJbNJ7px4eSx8sdxzCmz	12393	17443	17443	1619078940000	canonical
24977	3NL63CzNadaYyDCdwdypucSmsCCPSZk86hrRheh24d6qJuizHwuv	24973	3NKQGUSH8LVycgpnzKFaFmbZoUhrRe19jeatacyF9SxjaQrqJwqr	171	1008	475	12463	16836	jwwX8Q7AKnAWWFP9WuctwkxtAmyLVxHm8RYiTAfXSUaJSYNG59J	12395	17446	17446	1619079480000	orphaned
24979	3NLNnWrQrnvsh8kqQAetDbhF6pmGPbPcLFrfTSjEPKxJk5UEKwg6	24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	1527	1047	475	12463	16838	jwezTmcaiKPhxybyRZpQkng1FJpjN8SWeY1yXtJC16g71mcys2Q	12397	17448	17448	1619079840000	orphaned
24987	3NLRAWu3yBbXuMmb83disK6uFC2NoLqB75cNeMKJQ9NMLTwDPHux	24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	563	993	475	12463	16842	jxhVaLLrVQRSSiPLaZjErPiYP2qouTiN6vFknAbL9dzwhjwZV5G	12399	17452	17452	1619080560000	orphaned
24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	1547	683	475	12463	16850	jxEjAzctRXP1YVYQ7BzbRwyC2sK7S6FXLgn1Ngwggwyw1ivBxvb	12402	17458	17458	1619081640000	canonical
25002	3NL5punPcrSrNmFKSbNFLHhxdpw8aSMTdQKzE2QXv3yVkfaSdtK7	24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	1571	1209	475	12463	16853	jwaczTGvGmCDu42fLVTA8mbJ7PZZMiGoJsrvm6CANR8La8Re3SN	12404	17462	17462	1619082360000	canonical
25007	3NKf945CKX92yxZguiyKX5FxrF8uA92KEFq52CQM26AWSkp56vtg	25006	3NK66WovPj6jRmqxKjT4wH3tXEqjQpmT6rmGMPf5U1c9hri4Q7AY	1546	1093	475	12463	16858	jxaC3jcQ8n7p53LuaR56FtiU7khGFTLnLFb9WLsMLTLe8kFGuAP	12406	17465	17465	1619082900000	orphaned
25009	3NLL5hXMzXLEkpdDnL8UFBCZGtVJPWvCwcbnPyvYz7aXifK4JnhX	25008	3NLuNJyKXhWLAV341tVnPHLb5ViwG9F1my5ayzMYXzES2GUbXGyY	1483	1030	475	12463	16860	jwLFiX9CduVjsj8NE92sEoRQQB5KjMT4CbKef4mcTbhcJLN3nq9	12407	17466	17466	1619083080000	canonical
25013	3NLVELLQfiTm4QYN9BRXwgFP4QAUwxCbTeNsouSCr7Sgo8DoSzXS	25012	3NK6cFYBjte3xjnWwEcP4cAioGcA5M1GeFvdpCB3wu1cncsaTJYy	1406	1393	476	12463	16864	jxCCwaWxETjqR11yyuEtkLxsgaYcVLy1Mh6hogin2Bxyhwd6jhX	12411	17470	17470	1619083800000	orphaned
25017	3NKqC87YMrWTXTyaMUzRGJ8DXqvhqaB7yR8Pr92oBzhEA8ZtaHxU	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	1609	1333	476	12463	16866	jxp6LPcchFveJNAqa1YpTfq1c7JKu6qMZTjzvviM8XTffvQL7E7	12412	17471	17471	1619083980000	canonical
25018	3NKcjkg5AoxNP5493hgRqbtLHvin867to6YRtKYeEEzCMZ9k3ov7	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	1597	274	476	12463	16868	jx2b9Hor9xUZ4SJpSCD9y5AVmCTvHzMs1nm5puHwysCHrCRkzZh	12412	17474	17474	1619084520000	orphaned
25025	3NKQzUFbW1igMoyaqh7a33jiNFKZnfjFSnV6csrtPfMtSBinnFin	25022	3NKWyAvu3WvyHjoMyPeNRNkqgDm62od31bz3YpfCbNSzkCLbwd7B	1406	1393	476	12463	16874	jx8APFmv4MUBZDyZ99qwsjsTp4G9cpihrnouwxY2UqnfoVhrX4S	12415	17476	17476	1619084880000	canonical
25026	3NLNqPSqHaSEwjCeGvg8JNNK8ByFRobjebQax4ejW2J5AbYq8HZK	25025	3NKQzUFbW1igMoyaqh7a33jiNFKZnfjFSnV6csrtPfMtSBinnFin	1403	824	476	12463	16875	jxW8NrhGJVX7ru5tEe11zW5e4LdsCCTWHsPwt335aCm6wbsgQQs	12416	17477	17477	1619085060000	orphaned
25032	3NKJ5NrthAggx5JrQdNPG8125SkCEGoauCFzhHbDbLrakEYHZYhF	25029	3NL9NDCH7goSNH6p2DFr7mcwQTWEBCfKkhifuEYpiYNRN7bsFyzf	1650	1129	476	12463	16881	jx63KZ2DyUTgXVJdQj7pr6Jv321FfWcbFtGPPqAeaYxRVjoX7WV	12419	17481	17481	1619085780000	orphaned
25037	3NLaSDanjV96SkESUm8eeJKC4GY2wYdfLRgws2Lwyt9ZFqFK2wN2	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1406	1393	476	12463	16886	jxipCTeTTbRTbnUR6QPtcAU6WUdofVtiCiXjJGuyCz9mHBRocYT	12422	17484	17484	1619086320000	canonical
25041	3NLGVzfVJVGGj8KFrV3AJwMrrCfrW4kYDM3Pp3kxav2A9ZGqsPao	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1578	1050	476	12463	16889	jwXTG34TcrzEmfUmhup7aLBdoAB8qGGrqzH1cwRpEkvhpaMta9b	12422	17484	17484	1619086320000	orphaned
25050	3NKnf6GgBpUa4cmgftve1bzVq59aZSFfBmcdAtdLnjxDS2LiY1AR	25048	3NKDea2DknU8mqK18yU52oj1d5vYG3w6doMMiZuPnmADWX7gnDUg	1590	1174	476	12463	16897	jxrEfR6i33EPmWyrZAzQDF36m6TvFGVV159RXdnyfFsGGoo9DJV	12429	17493	17493	1619087940000	orphaned
25052	3NLZ6mF8kz4DvWFCvNH8SL1J1AckQacsUphGXs1iXDZoXEHPgDVj	25051	3NKV3X7kqkGvevBymPQfoHTMPsJhrJ1mNPzQEqYy5cNepPwE7SSQ	43	1310	476	12463	16899	jwx7ZWSvrvBQ16oCbvE7NSWVWHC3iN8W8JbQWN994591e3QYcsh	12431	17495	17495	1619088300000	orphaned
25057	3NLGafcb7kotmMRZ3bJnZyAD7rABLtZMHGg5C54yAEVzKj9nkJgV	25056	3NLqRCW5neugttzPBnSEc7wy9PDL2z9fC4up1MhLuenV9B2tUyPk	596	1306	476	12463	16903	jx3uZwR4Ja89fVZaXoJBRQPVj2B2hgnhHbANWm5vpewcZP5qo38	12434	17501	17501	1619089380000	canonical
25060	3NKGA6ksb5tXQ1w7U9J4kytpBJ5wiPYmxuRfEYmftMVbinPUyEnW	25059	3NKUf1NTEBK69bqJP5LsSWV1zoQm5FSozBNS4uHa9uTjdQycJKBH	1447	1219	477	12463	16905	jwi7UBNYR4MeoZfmM5iNQhbiG81hiLmSLjDsoYEDdMVYtLxQgNW	12436	17503	17503	1619089740000	canonical
25062	3NLYSTiSyegYV1Jt8qteFcbfQHH1dLeq7GDxbpSp9eqfWskdySSc	25060	3NKGA6ksb5tXQ1w7U9J4kytpBJ5wiPYmxuRfEYmftMVbinPUyEnW	1596	1117	477	12463	16907	jwPkFFrSZ8cecKjePeLYVQs3D4Qv97V3cSK2xDCdFXmTpXg5bKa	12437	17504	17504	1619089920000	orphaned
25067	3NLSzvAFJfzpaZXj39WPhBHxqbgyptCCgLRY1KWv9pEBrjEQEn8C	25066	3NL5jg19s45F5QoyaSTZUSvHSZbY9siFs7imu2GRziLprDYhJ3rB	1406	1393	477	12463	16912	jx4oycrGPdceoF8QKV2FsbtXCzexgW16GZhudK6e8bD7ChaVniJ	12441	17508	17508	1619090640000	canonical
25071	3NLoYDsb2iqxmg9PM4AUpseSMqaKqsmkV8V5Rw24sHQXsfnosfkp	25069	3NKsKUXhdhgJdYWErWzV6B1xJUwaYKCrDi73voxYPENJrzcsEyA2	1500	1297	477	12463	16915	jwnBmVykRVE8PiAaqNWuv4NaJgcfWdJFRtChS5NDqp73A5bX4du	12444	17513	17513	1619091540000	canonical
25070	3NLtvXdRKEvpSzBvbBosEb5iSB61jfSxwyEyN1JxoW4YTV56t2fB	25069	3NKsKUXhdhgJdYWErWzV6B1xJUwaYKCrDi73voxYPENJrzcsEyA2	1500	1297	477	12463	16915	jwdKDdDCVhmN6XF9bmzCsmKpGjihh9GU9JpnVQiDShjQowv6JCj	12444	17513	17513	1619091540000	orphaned
25073	3NKrjrM5o32MBoqdWUpGaRG5VGEL31HQ8c5YpzUvTxX4HSjXLyhH	25071	3NLoYDsb2iqxmg9PM4AUpseSMqaKqsmkV8V5Rw24sHQXsfnosfkp	1516	1168	477	12463	16917	jwu4svwWN4E3HynquokiJQhzQWALGyh3f2SKfyT1HQfFqZVTo8n	12445	17514	17514	1619091720000	canonical
25085	3NL3n9Me4KK7xMoySKAaSXzkQrm4e3fXkxg3Z7kup9JhK32Cu9b2	25083	3NKc2tkHiFxUK3XJtCs3q9xUumhmpYkLbJCcykXE6Q9zp8ptsvwi	1501	994	477	12463	16928	jx2yFErYsgfJgSSoSDZ8nz88BJXbiMEzJWAyLCmQ37Bb8G5P3iX	12452	17525	17525	1619093700000	orphaned
28473	3NL8y6SYobShNCkKP5GNKDcyfPJ72fpXHkiYKgy56WhGZeBQugKB	28472	3NLrSpS1GK6XAjfQBFM6dRaBhzH43YkP45UG48KKYoBRTbCNSqV6	641	1090	557	12463	18974	jx8Q66ods9tUSouEtQinc4vEE7kzgzw21F35xHoob3L8hTsKV2H	14071	19833	19833	1619509140000	canonical
24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	24978	3NLZdXV8EZTng9UiqP76yQPStp6DvgLzMdyUpNGsXCAoQEyZzvcb	1527	1047	475	12463	16838	jxBN8G6MwbfJohBrg28KMo3t2jQhNtLoA4oy1Z3zr29ReVzgZjZ	12397	17448	17448	1619079840000	canonical
24985	3NKKM8GNCzZqrwxG8KatGCyDnBobRaLFc3wvVVA5Y194nj8CFDxy	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1527	1167	475	12463	16840	jxCbAhNd3V7JbwD6wcN7JENHdsxMTa9BL2rhH1feWyKsWRoHeKb	12398	17449	17449	1619080020000	orphaned
24986	3NKWWidBeSzi67Qb5X3QNU2cGJZ864huWYzetvKpWJXumsZi2Zcv	24982	3NKajEkC4VMrEiYZ1h4Auf3MaGHjiz3vnuCsNdobE8f9WBDR2mJm	1405	875	475	12463	16841	jwC5Zhnvz62Cv8MYSqR4nDsE8iixXMMns8hw1iXGDEQ5tioqC3M	12399	17452	17452	1619080560000	canonical
24992	3NL2cwNPtJamUatMmZW56iCf8TJCc6FMMuHYrv7azZG9k6fq7NWJ	24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	1607	1348	475	12463	16846	jwcr3KFJMx3rsJW9hofXU7zVVD5dzrZhCkV84AK6pDX3mTV9cs1	12401	17456	17456	1619081280000	orphaned
24996	3NKWjJybbkaHFBm18XEQrY4s4qsLtsdnrUQZ2C7zVFGLH8ViTEJA	24993	3NK4tVKRDhzeTa8dzVVyxw1xeHkg84Fqp1qyENDKicTyg2YZhP3u	1649	1017	475	12463	16849	jwoJCR4jFSXsS3BNkuQ262Nvtxw38ExADBGn3ADDgww9KY35jzf	12402	17458	17458	1619081640000	orphaned
24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	1588	1392	475	12463	16851	jweuJ9oT6R9sQvjUg8GNT1CbYY8eWagWrk6wTq1VbsqKTdzDYQV	12403	17461	17461	1619082180000	canonical
25004	3NKi2NmHBfwiQdnK42qyULF161cPG5AXTtyx3g7V6D6JwhUsgfzH	24999	3NLxvQJRpskZ4Gpn93sbye1gctT48t1P2ayixSs4Y9J6zpY7o98Q	1657	79	475	12463	16855	jwVppGGnusrzkSDpwEWSavTzqR3auDLJ95QSZkNaEBxMYM2FMYH	12404	17462	17462	1619082360000	orphaned
25008	3NLuNJyKXhWLAV341tVnPHLb5ViwG9F1my5ayzMYXzES2GUbXGyY	25006	3NK66WovPj6jRmqxKjT4wH3tXEqjQpmT6rmGMPf5U1c9hri4Q7AY	1675	1216	475	12463	16859	jxp6Jxjk11397pp97Qm5W5GsfeeexQfxX9Srn1Y99enEKdrVeqZ	12406	17465	17465	1619082900000	canonical
25020	3NLi4udPcGnu4hi4GHrRc7gE9EeganxtSZ2RFqodtfWcQi9npeq8	25017	3NKqC87YMrWTXTyaMUzRGJ8DXqvhqaB7yR8Pr92oBzhEA8ZtaHxU	1560	1045	476	12463	16870	jwz4Qj1kcoTjMbVRhxAENrPdTpoSxXoAuNoi4awBEJZg3qHQxYP	12413	17474	17474	1619084520000	orphaned
25028	3NKK13QfxL1uFyfjAfCKFrebBeETS5wuRcDjcthzE2q1hfG76TLz	25027	3NLPqGdV74KAGW8v1iNktzBtiJm4a3GmVXh3Q5Pcgj93e1F4ScH7	1402	874	476	12463	16877	jwXThwpCTVVbjksfx5HCyoVQf5g66Don4oQoeDEckFAmx2dEJUR	12417	17478	17478	1619085240000	canonical
25029	3NL9NDCH7goSNH6p2DFr7mcwQTWEBCfKkhifuEYpiYNRN7bsFyzf	25028	3NKK13QfxL1uFyfjAfCKFrebBeETS5wuRcDjcthzE2q1hfG76TLz	1406	1393	476	12463	16878	jwoRZZpzBrYTMuDyoinBgVNq3ZZEDU65PEFeL8uqTRKgPsxhtQT	12418	17480	17480	1619085600000	canonical
25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	25033	3NL5J38gUdwoXFXPXgBTVnCTbrHw5m8KnUFchUVHhxmNNnjt5PC3	1471	1386	476	12463	16884	jwdbQFPEUMZHA9cw9HfeY4AVoAE63RLGUbPRFcSpJFK7DqiYpcs	12421	17483	17483	1619086140000	canonical
25039	3NK62VmM3T5jExPSdhkgNQL6yCCA1bBwbmW6PrHXCD8MgZH6MNHN	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1451	1046	476	12463	16888	jwwRDL7s7bsAQ8YMVGz8bz6m7NooVLJUe3JwhRpoCy3PcdXxNdj	12422	17484	17484	1619086320000	orphaned
25043	3NLBoZJv9vNdTKVoafDs9P7XQaRZb44L5q5xLBSfg6xi8Y9YCgMu	25042	3NLVFGfE2hY7BR3DuZq2ZqagiBHjqDDGnK1HCkUpWSVxGxbxNYNx	1457	1391	476	12463	16891	jxKTPRB5YNFqpnVn7PASmjo9fFQi4CbwEodDqrHN5MeXzmFd4He	12424	17488	17488	1619087040000	canonical
25046	3NKx3xdqiU3MfJjpKWLvJoVQjQEjG3PwKRfxYHci1YZSjjFW2JTF	25045	3NKXav5g7RAM4gPnUuri3ia1Bunhqy9AGhcjxv4zG9WQnH5PusGu	1634	1085	476	12463	16894	jwaWocGvSPnaBtpTtJ69jEJ8BaYSBb5Azu9Z5KJuEyfx56fkX5P	12427	17491	17491	1619087580000	orphaned
25048	3NKDea2DknU8mqK18yU52oj1d5vYG3w6doMMiZuPnmADWX7gnDUg	25047	3NKSB2U8F7NmMHgRz8CTG5JVDesvya3Me9d7Pb64SKC6v1dUx4Sy	171	1128	476	12463	16896	jwLXnmiGMeU6zC3UjwpzAUtYezs2rhhwg9GeTmYn8PAiryNZ138	12428	17492	17492	1619087760000	canonical
25056	3NLqRCW5neugttzPBnSEc7wy9PDL2z9fC4up1MhLuenV9B2tUyPk	25055	3NLfbKk9D1JLFqEoJTjtxvj3ejz6sMUAojRXPrrXFdmKerLHXixD	1403	786	476	12463	16902	jxXxKPWJVPCZSDe2SbxSbVadfSZi5SgN9XJEJhNtAuKLBCkUjb6	12433	17500	17500	1619089200000	canonical
25059	3NKUf1NTEBK69bqJP5LsSWV1zoQm5FSozBNS4uHa9uTjdQycJKBH	25057	3NLGafcb7kotmMRZ3bJnZyAD7rABLtZMHGg5C54yAEVzKj9nkJgV	1506	1373	477	12463	16904	jxGDAZN2fWrGH8oZJ7atiDzVbinnDMdD82t4zz89jZyBGm3Jbjo	12435	17502	17502	1619089560000	canonical
25061	3NLNg3W2Aa8Y7pCoH9yKPkiCgTU7teYUvN2GAJ1xaLFAQjGevgbG	25059	3NKUf1NTEBK69bqJP5LsSWV1zoQm5FSozBNS4uHa9uTjdQycJKBH	1637	816	477	12463	16906	jwXAqCHTwPbxhSZPo3n2CEkVtdqNkoBEzJebegS6ofSP9iv2ZSW	12436	17503	17503	1619089740000	orphaned
25063	3NLaQymgKM5SQKwDbZ5BSCRMGvcaJpzhNMEaxSHZrCQne62ygDun	25060	3NKGA6ksb5tXQ1w7U9J4kytpBJ5wiPYmxuRfEYmftMVbinPUyEnW	1581	778	477	12463	16908	jwkE6UCj96Tu4NxDoqSoN7XxRKY3NSDWdm7JeV7BezF8tnXRZyk	12437	17504	17504	1619089920000	canonical
25066	3NL5jg19s45F5QoyaSTZUSvHSZbY9siFs7imu2GRziLprDYhJ3rB	25065	3NKAXBZ8Jogzg61DZhGmJSKHbW4sHojvNqCWuWk4vFXJgWWnXinF	1553	776	477	12463	16911	jxF3811vbhTffKkZnVYv2KZm15TxSCPTBScw1HZMCnEDCvbNJwo	12440	17507	17507	1619090460000	canonical
25069	3NKsKUXhdhgJdYWErWzV6B1xJUwaYKCrDi73voxYPENJrzcsEyA2	25068	3NL8cRJMmMdN13qJMcayZ1W4pYSAFZiNEpQXgLwBU1seREmghBEM	532	1303	477	12463	16914	jwP1exf1Ds5mXLG78GxZFQcqserkG2qfQeMMXKB963naUXaoogq	12443	17511	17511	1619091180000	canonical
25074	3NKEjt11rpCopeKbpJPaCb1WmWnGFDVbLpKmwdMbxN2U85j2eu1w	25073	3NKrjrM5o32MBoqdWUpGaRG5VGEL31HQ8c5YpzUvTxX4HSjXLyhH	1516	1294	477	12463	16918	jwU7iiuK2xXzxXjPXksfyY7n3SApNe4HvZ4qdF6xktB5WSb7Yse	12446	17515	17515	1619091900000	orphaned
25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	25075	3NLAF3G48d7MVxkmJQ8gvTevTpESjBhFFeVnRZF1myXisbtQLwUF	1536	1067	477	12463	16920	jwri2zeXQEKroFKFbqZ4bmMKrxmRL2U1ri4NXbyuohyJauhUFCr	12447	17516	17516	1619092080000	canonical
25079	3NLLAmBg5AED328gv1aZy1VSDYkUetKA8ykDjHEiKRaSziWm7h6A	25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	1649	1137	477	12463	16922	jxnm5DyVY1At6QKpw5XzjXytVUnJwdEtczzpNN3zZqCxd3Ekzik	12448	17517	17517	1619092260000	orphaned
25082	3NKd32HyRiGmoJLVefTYV69HsCQsaSmzV5SAeZKaDf1wiwXj5zvU	25081	3NKETd15uP5Ke57PP9GRbtY9HUaUwqTH3ixCSZZNgA47vBH1Ny24	1633	1144	477	12463	16925	jwmv3GNkrynMghAxfDY2BCSMa7HMo8Tme45M7W7PaEpTXfnXuBK	12450	17520	17520	1619092800000	canonical
25083	3NKc2tkHiFxUK3XJtCs3q9xUumhmpYkLbJCcykXE6Q9zp8ptsvwi	25082	3NKd32HyRiGmoJLVefTYV69HsCQsaSmzV5SAeZKaDf1wiwXj5zvU	1549	1362	477	12463	16926	jxNp8unJjeRrTooVBNHvf7MFMMVBJ6sLtCJE2XFSMkhLiRt1VnE	12451	17521	17521	1619092980000	canonical
25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	25084	3NLY7XHNHSaxJGTBavW1FaZNeNuBwyAgPXjBmzvhpdVPFuoR4KwZ	1539	325	477	12463	16929	jwFUCa4hQgYabuL2L6NKSmgGTHBYYTXcMwWzPk9NY8XL2uh63Z4	12453	17526	17526	1619093880000	canonical
25091	3NLEuY8xhseZxncdxTV3x2YWE8Fr8AC3eschysyQRXVYrFwm4hUt	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	1534	1071	478	12463	16933	jwN5LdjdrV8L1QDtcH7MhyyZsPErp6jCnZmaugMZmDRRTZLspgM	12455	17529	17529	1619094420000	canonical
28487	3NL2g2SCLChcYm1Nb2gMhEVLi9aWDz9aRL93cn85AUmFSXcWSk2Z	28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	1637	816	557	12463	18974	jxqzqeYENSzQfr8j6QoyN8pHU7QeNF3TjyxkKDVX1baBd47MLq5	14077	19839	19839	1619510220000	orphaned
29460	3NKtG3D3KfJE3XXNs97KEWZxSPTAf3mYsjmr1BWCESbhJcZZB7q9	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	1541	1298	579	12463	18974	jxh8mNSy4r7k3RGn9gDDpAX9Qoqk2fHUneivCgS85XwyFkmhVQt	14527	20446	20446	1619619480000	orphaned
25081	3NKETd15uP5Ke57PP9GRbtY9HUaUwqTH3ixCSZZNgA47vBH1Ny24	25078	3NKJKmVEx9CaaU66UJAfA9MBXAYA2EpwKq11bgbKGMU1U2duZnQV	1513	1133	477	12463	16924	jxCvswS4DRjzkau8aNJQSR9fYwjXMjdQgPrAGkJwzQw3dMx9B7W	12449	17519	17519	1619092620000	canonical
25084	3NLY7XHNHSaxJGTBavW1FaZNeNuBwyAgPXjBmzvhpdVPFuoR4KwZ	25083	3NKc2tkHiFxUK3XJtCs3q9xUumhmpYkLbJCcykXE6Q9zp8ptsvwi	58	149	477	12463	16927	jwifNhhGNovumNRVV57DFHiTdZY4MzMrFgPt8WW928sLmvtkCUa	12452	17525	17525	1619093700000	canonical
25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	1542	1058	477	12463	16930	jx1SZVVj4bZstWLMFJJb8RDiosyYpQAiPSVS9ZbW5fkKw5Kkogw	12454	17528	17528	1619094240000	canonical
25087	3NKJ6jVB6YoqDJTN4SVZSKrMwW7wUbTmwjcLUpBtFi8H9kMs24cX	25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	1542	1058	477	12463	16930	jx1SZVVj4bZstWLMFJJb8RDiosyYpQAiPSVS9ZbW5fkKw5Kkogw	12454	17528	17528	1619094240000	orphaned
25200	3NK9ku42NcsFFTE7m9zLARvzTvEE2BkESj7gPtebbQUHuVmFLeyN	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	470	1309	478	12463	17025	jxA297HYhq9LpujCnYHsCdMMoXLBC7rrePMwm4gQYb5Qf4eKwEQ	12455	17581	17581	1619103780000	orphaned
25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	25091	3NLEuY8xhseZxncdxTV3x2YWE8Fr8AC3eschysyQRXVYrFwm4hUt	1541	1298	478	12463	16935	jxLdKzLbPCAyqeWDixfEAiRi4DSHhczNt4DA7rGHYLjrY2QJ9kV	12456	17530	17530	1619094600000	canonical
25095	3NL2FrWm1M3Ys7RHw7SkSeK6nZtj6GQkhQWdfsSCzSLtFHU19okV	25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	1541	1298	478	12463	16935	jxaREmYqD1jq2kQf8XwvftkpsuP7H2bEq8H5xq4grF2H5AWXAU4	12456	17530	17530	1619094600000	orphaned
25100	3NKFhAtdSb29X1B7DBrfGXmWHNxn62gkaGZ7uHjkm36N4yYqxuAX	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1402	862	478	12463	16938	jx2Bd4J53sKkhHgiEKvwPqmJvvXWmAvskgdCEN38n3Ek6mcah8w	12457	17531	17531	1619094780000	orphaned
25108	3NLu2d1HryoHM1FdRdxcbJGL7ncbzhdrLBYKYTDG2TgcsDSt2Xee	25106	3NLX59VxVJhRp1vHDKvEmFg9HnLYfYeHuQqVAh1TwsRMtts1nyKY	1407	1395	478	12463	16944	jwd3o5qE1CYDVRBSy6jzUnaX5Pb6qAxoXsSifzxpj53PLvRUwWt	12458	17534	17534	1619095320000	orphaned
25113	3NLpoM7LbXpFbdrp7veTkCLuUdhb62XMkKnQYbcMfRemFjf8Fm5e	25112	3NKnpSygjRoJf3QmmmvEZNwS6zVt8VhL91ffw3XKtSsHS4xumnkd	1402	858	478	12463	16949	jwBoPgvQSibQMDtvN7NoFhTGa7ZaaUxc5KHpJq4VHqP3gMP6ZEp	12462	17538	17538	1619096040000	orphaned
25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	1571	1335	478	12463	16952	jx6K1L1837u95tZJ8U4GzH3SAyq3sBD24ckXWmTFNxFpiRY4kAF	12464	17541	17541	1619096580000	canonical
25118	3NKZ6r27rcHqfeFHQoFNdqpNLDpBcaWJBPnYB2NDNdboVG7aXiHZ	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	1407	1395	478	12463	16954	jxfHBxT5XSrXHYWcrNz2JxmXurTybYdpi8RbnZNXnNvWjbKbxuG	12464	17541	17541	1619096580000	orphaned
25121	3NLca32nZyoio1tEzKyzCuSatHGG4QxEP4kQRFEvr2oQ8qrfoPnA	25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	1406	1393	478	12463	16957	jxGKPV12XiNUN7m1Lbk3F7zNz98W7VogYB8xsNcfXDdtUWvpMhB	12465	17542	17542	1619096760000	orphaned
25128	3NLbhM96XeN1SWu2pP6WRY3oqSyjLkJndBvrQEdTCsJxmss2H4ow	25127	3NKkZsyBCvWKxSeb2QSH9HbsN9kGAXjRthkejWtR74dMJqQnsR8n	1406	1393	478	12463	16964	jwPoQNt9syE6dLMrQhjac7Xk2Q1QZBYgZcF8ySTS8fFbEHRv9AJ	12469	17546	17546	1619097480000	canonical
25166	3NLh6v7xgiqHM5xbvqopHPYaNAok6rHeQ3vwB43sggrFqKFzj88h	25160	3NLjvrxKBtMSjraCRgSnKNkYMEsR9FYxWDqX3HSZefpCkbz2N5Hn	1637	816	479	12463	16995	jwDwqTJg755DweQHx71cR6AaQgG1JF7E6zagjetJ1YhTCyTgFts	12470	17562	17562	1619100360000	orphaned
25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1523	955	478	12463	16969	jwqhS8cCyfzqKZBMSXMsAeTEFTNjoMyevxyWWFdDX3w4V1CojGP	12471	17549	17549	1619098020000	canonical
25135	3NKtKxgZCWoSpUn29bDnUjyV3Ff74mEJnN6VAe2bBEKsJUVrQQji	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1523	955	478	12463	16969	jwhCk2SEWQ5uRGcMnq889SS1cV28DugCJWQHbKP3mi7XzqK7LYL	12471	17549	17549	1619098020000	orphaned
25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	1507	1280	478	12463	16971	jwXmXzrAZQyh3Ho1DYLkdVQDhXm44D2JdmTMYL26Bptwq4D44iG	12472	17550	17550	1619098200000	canonical
25139	3NKBbr6ytGoQ1m24XkTmNe88nwFEaaU5F6AmiAz8PFZ8b4meVs2Z	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1654	1094	478	12463	16973	jxbXVBB7sYzuh1AUH63Z9vnutmA2cHNueU9k646fCWX89g5mzYE	12473	17551	17551	1619098380000	orphaned
25144	3NLZ9dFKjFuhy1yoDkCkLgnRK85FSbd3nJ9ccao4Rqye1RUKPaFY	25142	3NL2M2D3xmmFNF5dpMoT6GLuHVrPeMUwtK4L8nFTx7N65fMJb4pH	1407	1395	478	12463	16977	jx4Gg9tgjFpei77WRz4mWKDCE4qXTe56PAHue34cmqGSt8Ar8X3	12475	17553	17553	1619098740000	canonical
25146	3NKLKfH6jD8nXWC1Vd65F66fRztZ8S5eR69UzKUxrCR9o2cwQrsw	25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	1588	1392	478	12463	16979	jxSSTxeEqnWknLTgcVyPv2KYbugQs2j715JyRmxVJZpjmrcPyrm	12477	17555	17555	1619099100000	orphaned
25162	3NKzxgegV8RH8PXMEs2QVHfdDs44N3Y9nmSGcTB6SDEicahUTU49	25159	3NL25h4LxELzV4Y9LAFG2znejmPdZBJzs6SJc49mXgBgp5gv9tJu	1407	1395	479	12463	16993	jxhY94UKZBdu4DvUP9zZEN1ifF2nZpZp6yghCdDNvd3eCMbvNS5	12483	17561	17561	1619100180000	orphaned
25164	3NKGKgzzgT6w83kqqS9r7yX25WMVgWWQRCmbZGam2BSomiu1cexW	25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	1527	1047	479	12463	16994	jwLmeCaqP2HjLoJS7CaoSrD1YTwVyUTSCDJWHHb5hqF82Qb74cA	12484	17562	17562	1619100360000	orphaned
25173	3NKnheJLpdszYo5dgD55xvi8GDFDgCkoUMgy6tEdzSxSJg3z69zd	25172	3NKTE4MViCYeTEeiQFtSi8vV7RWRBLJJ25nay5XT8GwcAgF6WmvN	1406	1393	479	12463	17001	jxY3KJApw51onQVcfLYFGhzESNyA7Di5gXFpJPEWSVSbYFZxMcH	12488	17566	17566	1619101080000	canonical
25176	3NL8AG8ExrKzAXLazeE8hgt4DbTVAhS7d1cV6e3v5HEUG7j6bCyc	25175	3NKYZ18zaCU2YHhsbZ98djhXtoE4TL7218iEsRC3sAZrgNz2dGM6	43	1310	479	12463	17004	jwpaDHj928yJGV6r8t1Spr31AwXkk8gGkyosRjDMexUB9hb31b7	12491	17569	17569	1619101620000	canonical
25192	3NKuhLNVuCCRAnzPWvCWMH2WQeNDroivsjNWr7APf4ZvgWLDSdix	25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	1406	1393	479	12463	17018	jwRTPaf6DJwB71o3u6tPyT5xV6YUiDN8fxfRJ6HGA5pFfRb8bUY	12497	17577	17577	1619103060000	canonical
25194	3NKk8im95ZRM1GwaYuUe5Xf4JWcAefJ46nLEGBtJC8R641ZmNmG3	25192	3NKuhLNVuCCRAnzPWvCWMH2WQeNDroivsjNWr7APf4ZvgWLDSdix	1500	1709	480	12463	17019	jwqEyaWGmqX7xHbprscAE66CoQwpzzSGZUiQejQdwyvzhkyTz8h	12498	17578	17578	1619103240000	orphaned
25198	3NKXAiTirb7pNUf7Kmbi8AeRuEAbq2bDaAFtBayXfQ8wyCASnz3H	25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	1564	1092	480	12463	17023	jwY7vRBQ57uqRu9xZNT6PmEjhPrx8jePuVeN7njvk2vfWopbW5q	12500	17581	17581	1619103780000	orphaned
28515	3NKgX81Eh6VrLFSZtbfMZJkBfr3GZiLSrqkpqnf5xzAMzEmdGjxE	28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	1402	892	558	12463	18974	jy2BCar2NPpiYDyEempmSMrRQgmxCh8CQ559hrXoBEzpT1Q3ynN	14090	19856	19856	1619513280000	orphaned
25104	3NLaeC6en9dmwXbQuarNtZg8iMAGbKxr2J1nSZy6zFURivTivccg	25076	3NLE3hzbHCvWYdCpMrdibRQ6FvW98eR5QtwCjMsFaQdhoZB4ZNk3	1474	1329	477	12463	16941	jwfZFfQpA8pdcoxAG2dQHQGjSExN2Xb89RNVeKvRw2UkUgeBPKh	12448	17531	17531	1619094780000	orphaned
25109	3NKFT9psHsJZwp2kQ6z6RBZ4RWNA9NtWuVXYTGpwF17QVmPNsujr	25104	3NLaeC6en9dmwXbQuarNtZg8iMAGbKxr2J1nSZy6zFURivTivccg	1474	1083	477	12463	16945	jxZUJX5eWVDGKLdrmUgs6H2NSK2Sp7aTnChd952yh5pq4EDaCzp	12449	17534	17534	1619095320000	orphaned
25094	3NLwG7xGd1xCPJvkV9oia94UeeEiGMznYo2Ju1EPf84pPnUgEE9u	25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	369	946	478	12463	16934	jwE2vQLwnzCZ6pdTMXcDhtR1CmQtKQKTD6WKazrPjco3q9ctKKC	12456	17530	17530	1619094600000	orphaned
25106	3NLX59VxVJhRp1vHDKvEmFg9HnLYfYeHuQqVAh1TwsRMtts1nyKY	25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	1407	1395	478	12463	16942	jxtqwE2fad1wyQowW8TntWA3VDKCACSy8W5F8poRJpeC6DmxsvX	12457	17532	17532	1619094960000	orphaned
25099	3NL73Kqhycwynizvn2Zi6CYq6hEdgMFvrmzCmtuSM1zy2kbhrszL	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1607	1102	478	12463	16937	jwFi7i6N82F5DtGxNTkYEQRsLevPsoiLG9yXyzzcEeuzyKqaMuF	12457	17531	17531	1619094780000	orphaned
25107	3NLR7y4WcNpbmVM7JNCxeRqmysVnq59BQdaPzhFNCSYhnwdE14vw	25101	3NLjgt1713cY42d6Vh2whHquw78vWZoanLmA6dRdh1q9DkzDiaUz	42	1361	478	12463	16943	jwqmGvWXnDtVRUmvcqKMQ8G7JHc8Kkj3R9BL6zGxHbAVM91hqic	12458	17534	17534	1619095320000	canonical
25111	3NKe1qfhNQMa44uA5GoUKySkaguKQputQ9fXmKgswd5Eote7T4cs	25110	3NLNDoUbUmJBBJqB4tYyMEuHMPHT5Y42LafiPbrYFaR2B4g2Esvz	1589	1286	478	12463	16947	jxFR9Qg1hANYGnj61ipH8rHdbTPaNZZZqsBRYzwE5KYfstXYGbk	12460	17536	17536	1619095680000	canonical
25112	3NKnpSygjRoJf3QmmmvEZNwS6zVt8VhL91ffw3XKtSsHS4xumnkd	25111	3NKe1qfhNQMa44uA5GoUKySkaguKQputQ9fXmKgswd5Eote7T4cs	1571	969	478	12463	16948	jy1H8MBBQLFiaxeiLrPHvX4qyeD4KWnPjDr6RNRQEeSLvqyX2KV	12461	17537	17537	1619095860000	canonical
25114	3NKbBvXzSmAufLWfJ5w8pxCsvrcB3oNrtBSjrjof3AT7dqAfhUTV	25112	3NKnpSygjRoJf3QmmmvEZNwS6zVt8VhL91ffw3XKtSsHS4xumnkd	1627	1385	478	12463	16950	jwDczzUt9o9o8noDQhuPwM8oBmGwr45SiYJF8b8cAeTw9LhtLTg	12462	17538	17538	1619096040000	canonical
25117	3NLcmwVL7JUYLXChCofGEmn2pE184EudXVP8jJDaGbNZjFpraaWx	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	1406	1393	478	12463	16953	jxpi78StfWcQFkv8e9HZWKGjcemnm57Hd3WXu8xqS5gBBYERi5t	12464	17541	17541	1619096580000	orphaned
25124	3NKnpG9HHMizu1YhxkuTyQDiXugtU31rUvH4UecFEQgbYDs5QnHH	25123	3NL1KPvymZNGd6fCx5887DSwu6HwhEJrc4Bb9b8r5BEw4t2sFE7M	1553	776	478	12463	16960	jwes3iNS4135sE8frJoxU2TRS15t9egWn6SNmEGP2mrHAVS4dnB	12466	17543	17543	1619096940000	orphaned
25126	3NLDpbAreVke1VYahDFfpF17arwkk2LbBcPyt8MAhNyyifsTABmZ	25125	3NLiouYgN95LwbG3D8pmkbigrmkNxCQ6fesY4P9AU3MEntjmTsGY	44	1325	478	12463	16962	jxYBaimDzCn9UmACUdeKP6RXGEXK32ZyyuqdAJdoyjZS2LUNKL8	12467	17544	17544	1619097120000	canonical
25160	3NLjvrxKBtMSjraCRgSnKNkYMEsR9FYxWDqX3HSZefpCkbz2N5Hn	25150	3NKU2zLeZoq1NDBQgL9hrpkegnGGPVzsPuFSHLpq7SEpvGuBbf4s	1637	816	478	12463	16991	jwzeXFtHDwhHma3p6CERZE67fvFpakoGro3LioU2VpBwVvLnt9M	12469	17560	17560	1619100000000	orphaned
25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	25128	3NLbhM96XeN1SWu2pP6WRY3oqSyjLkJndBvrQEdTCsJxmss2H4ow	1599	1041	478	12463	16965	jwUMF7fhmigA8Ki2FQrEvPiSJYUBRXtSohHBfH2xFiUHDXoiRS6	12470	17547	17547	1619097660000	canonical
25131	3NKakTHgZDbrrdTWegRpzXzpo9FyaQMrNyiASyQQG7tDfdvtynYt	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1444	1255	478	12463	16967	jxChR1QzQu16pAnaSx1BTMpsWG5aeeRKMrHD864B3eQijzjJRvx	12471	17549	17549	1619098020000	orphaned
25138	3NLEWMSnwKyKdS8gKir7Ex48g8vzDzFFisJMhJRF4v7HMdMXn54D	25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	1646	1108	478	12463	16972	jxR575a3HcpWAE8YXs6UsHUf4xeTjNDnp9HXG315Sfmh4ftzHfx	12472	17550	17550	1619098200000	orphaned
25140	3NKPEAcHxJyYNS53KB68MfepdejFPCt1XQujJEvoV5hnWCAwFjvL	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1529	1070	478	12463	16974	jwcKd2NpiHBxU22UVfLDUtfS8Zgb8yvcWLcFcpRoBnTPsvSWhrb	12473	17551	17551	1619098380000	orphaned
25142	3NL2M2D3xmmFNF5dpMoT6GLuHVrPeMUwtK4L8nFTx7N65fMJb4pH	25141	3NKoDH9Sh8xGDHscJ7fGvsFMHS4vowRnbVApwZuuhX11scDnrBvT	1403	824	478	12463	16975	jx15ahxs7V9uLaKtprQCVduuKJR5aUNeE6ZThrBiD4434MVEtSA	12474	17552	17552	1619098560000	canonical
25147	3NLo8ZjmdRJ3rn6kdUHqQWLY3aNhxGrecAPGVLjtj7bBnZE6EfbU	25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	1560	1291	479	12463	16980	jxiyrbFyjx4719LJZvtbByWepjXLqC4D1se33Pa8TKKcyVnX1BE	12477	17555	17555	1619099100000	canonical
25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	25147	3NLo8ZjmdRJ3rn6kdUHqQWLY3aNhxGrecAPGVLjtj7bBnZE6EfbU	1553	776	479	12463	16981	jwtzaNKfBwAYCaLe8QtcqyWucvbsdoveN81SEseEync3Q5H9y9j	12478	17556	17556	1619099280000	canonical
25151	3NKjLgS8PA6fxCdpZfTqociaqnLniDjpv7KVYcUwdfYBEYNBovsb	25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	1622	1356	479	12463	16983	jxWFyerXvZDZUqWqwWNjm6axefBGPk3Vnk9vFwrQFaKiGoGJW3X	12479	17557	17557	1619099460000	orphaned
25156	3NLkb81aHNruDmQoHCAmggGNDSbiK81kmgcUgQoBgazUbc1wCWye	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1457	1145	479	12463	16987	jxkBbcfGHRp12AFSfT4cuPNHZC5TfDW7vX8Xhb2T2qagZywfBwc	12481	17559	17559	1619099820000	orphaned
25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	25163	3NLSaBQ7GRksBhSUzEZ7i76Vi7HMaaG1xegprFGvgoV4tL4nyb1y	1642	1121	479	12463	16996	jxvyLX3wsxjKGjBkyYVWqRhgAEPA96rtaxFPq1YeZ6eNE6ag9Rd	12485	17563	17563	1619100540000	canonical
25171	3NLGfftNwdpTZhLBStnEpW96wDyqQn5wmuP1XYQqvKtscLygEac6	25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	1590	1300	479	12463	16998	jxCWrktHN4myMAewyiVe4zDjctGKob75kQpbMAjp697VWv433kB	12486	17564	17564	1619100720000	canonical
25169	3NKakbbZLUoER48LFWp57qMcZJ3hmTwtzJTJbDt5bAjA8NCpy8FN	25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	1590	1300	479	12463	16998	jwkqPvh3iCPingBAtu9KKCMWgbEFgJSVrmyxnsXJnNMfytiDKjn	12486	17564	17564	1619100720000	orphaned
25174	3NKRFvZvf6RcQzoCiBeKN7mmG8B5XqM6mXftCkHCoUsyZMRxHJMS	25173	3NKnheJLpdszYo5dgD55xvi8GDFDgCkoUMgy6tEdzSxSJg3z69zd	1403	31	479	12463	17002	jwVEjYrhNgkrcXsaAhtNyUTNdZCBSNDSdzjZoCgGAbN6S8cYjbS	12489	17567	17567	1619101260000	canonical
25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	25178	3NKpybt78x88gnSAd1xbtPDTkHHW8LjJPqhQzHDLEqQaPaux7S3J	1601	1388	479	12463	17007	jx9YEVigNKmK61hyXTYdpKo1ub4stGHiueoV86Ns1FcKFHUE4Z6	12494	17572	17572	1619102160000	canonical
25184	3NL3d4EXUnFgMUNyAnXf87KMXo2i4fsWPfzCWYYwgGSbBQpKVUSu	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1617	1162	479	12463	17012	jxPfvQFuGVjyrjWik2cLQKgMTwZV52sPwjRzipS3Ex44SttcqST	12495	17575	17575	1619102700000	orphaned
25186	3NLsTpd1Pzo9cmp5u9nNHkKWfJacxUxfXo5eCt8pDqtzFJGd9MFD	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1529	1070	479	12463	17014	jxa1XFERWwksjVVt7JPkX2H4AjGtZJVFBJypiyKKdCPN7iVMd4Q	12495	17575	17575	1619102700000	orphaned
28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	1599	1161	558	12463	18974	jw84ECHWCpwogmmMjvAjZ8zyX4eKd79U4uB4hLJokZzAfPwq1gf	14092	19858	19858	1619513640000	canonical
25182	3NLkP42vdsV4EXAwXUTSE3UX1qNpq99E7gyeYFLSR3M4F8mrt4f5	25044	3NLs5qwYpWxpUjkayVnixuhH8uKDYpGfjpiNJLkKKQp489TGDAm2	1553	776	476	12463	17010	jwoaRt9wdVfnn5oXFc6iMsr4qVnFwuL5nNDbNitGsh483MNtw8C	12426	17573	17573	1619102451120	orphaned
25101	3NLjgt1713cY42d6Vh2whHquw78vWZoanLmA6dRdh1q9DkzDiaUz	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1474	1329	478	12463	16939	jx6UH8dsGqzML1EKTgTmdt96MQCnJhLwBsthdi5CexfRkgVpSwp	12457	17531	17531	1619094780000	canonical
25103	3NLCyqPermAz2vQXL6kdcsLyXKBkTEsh4aTwWKq4VA5wyAGygTMS	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1419	813	478	12463	16940	jxzQpbHbFwe5ykzc2XygckxJ7GNd9KqhdAY5SLwV5nfkg2x29eT	12457	17531	17531	1619094780000	orphaned
25110	3NLNDoUbUmJBBJqB4tYyMEuHMPHT5Y42LafiPbrYFaR2B4g2Esvz	25107	3NLR7y4WcNpbmVM7JNCxeRqmysVnq59BQdaPzhFNCSYhnwdE14vw	1406	1393	478	12463	16946	jx7FjwpdctdY1vthCvjz4mRTVjmRmmPaGqqMGra58gzWY6xkqvd	12459	17535	17535	1619095500000	canonical
25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	25114	3NKbBvXzSmAufLWfJ5w8pxCsvrcB3oNrtBSjrjof3AT7dqAfhUTV	80	1147	478	12463	16951	jx1ipsbCw92RbcfWNejR7UDWapaqAp6M9L7Xi7zUyDo635qMuVZ	12463	17539	17539	1619096220000	canonical
25119	3NKtcyQRGZNFX6mZ9tUdbrM3TicxTo7myi55WkPt4zzNJ2cvU86r	25115	3NKfaHWyY3qovSEbGLivBnMk2d2gv87BEaaDbyp5hjMVCDnEAP4p	641	1090	478	12463	16955	jx7tcrAQfz9mSeiPZgswtVPTcLHm29qXRo4XUzZwKtiSMKs7wzm	12464	17541	17541	1619096580000	orphaned
25123	3NL1KPvymZNGd6fCx5887DSwu6HwhEJrc4Bb9b8r5BEw4t2sFE7M	25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	1445	1290	478	12463	16959	jxr3muUZzFFMZZycnDfHoUt2qPr4EQwRakSMK9Rvxxyki5LNcg9	12465	17542	17542	1619096760000	canonical
25122	3NKyw1g8Xw6rhhp8HsHf9s4xg8TyUhfzeDSLyiTRkLea2a6evpHE	25116	3NLnGWEPgW2MJSaGnVJMdUYk56tDcEs6n4Y9ueDf9wGTYm2Xrryk	1483	361	478	12463	16958	jwnBnZMaKLiNyyWUgo8ziQm8NrgdegBD1hRYwfPiiLpt39XFjRo	12465	17542	17542	1619096760000	orphaned
25125	3NLiouYgN95LwbG3D8pmkbigrmkNxCQ6fesY4P9AU3MEntjmTsGY	25123	3NL1KPvymZNGd6fCx5887DSwu6HwhEJrc4Bb9b8r5BEw4t2sFE7M	1419	813	478	12463	16961	jxssoWQqs9P67fHJWtnsWptZT8DZ4u38fh6fTnw92XydT8LN4MW	12466	17543	17543	1619096940000	canonical
25127	3NKkZsyBCvWKxSeb2QSH9HbsN9kGAXjRthkejWtR74dMJqQnsR8n	25126	3NLDpbAreVke1VYahDFfpF17arwkk2LbBcPyt8MAhNyyifsTABmZ	1407	1395	478	12463	16963	jxkcpgWWz1pkYfdsr1HFaPqRguyjFVCjQX3FWs5kLJKhMXuQt8G	12468	17545	17545	1619097300000	canonical
25130	3NL3J8UGhiWKazRrDhfKxfrzMiKnSittd6CYrMsqLxaBmfzkHG8P	25128	3NLbhM96XeN1SWu2pP6WRY3oqSyjLkJndBvrQEdTCsJxmss2H4ow	1553	776	478	12463	16966	jx4wwasUQvm6t6uqJApvjpHaW2Mocw2bAuvrQPZSKdmsr18iHaL	12470	17547	17547	1619097660000	orphaned
25132	3NL1DyCykCCdfXBzDKVmfcuKt2SWmmMXrTxnu9rWqK3wsif1bAph	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1602	1123	478	12463	16968	jwcHM9CcF4kN5oiDzrJYxx7wfm6hgdem2THqLm9ShHyb3U6zXqM	12471	17549	17549	1619098020000	orphaned
25136	3NKBCpuSPw2KRUTQihKpQmdUYzbjJC8Bt8QJpefuE7UtXaGzSJxU	25133	3NKpusmXvnxBS6h1vzRh8yBcC5Nfrn7RU43moPYFoEwLBex9ZNXY	1672	1285	478	12463	16970	jx5uUTtt5FKZ2KSyYUTaeQNUgJ8VEX5wZ3hnWxPoBPqPYP5AYiN	12472	17550	17550	1619098200000	orphaned
25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	25144	3NLZ9dFKjFuhy1yoDkCkLgnRK85FSbd3nJ9ccao4Rqye1RUKPaFY	1596	1237	478	12463	16978	jwk73YVU7tbL8uX2VG3Yw28WCZGthxuWdn4xReYBxiFsBsUXmrF	12476	17554	17554	1619098920000	canonical
25148	3NLq4MhjUTrcFvGyGDDZXYk3ior6fHoM5DqcKN2vkhfWTqman7pL	25145	3NLvwZmY3WxGR65yTFmcQnyv3oAKJW5p4DZJf4FY8Apm1VAYSo8M	1560	1291	479	12463	16980	jxiyrbFyjx4719LJZvtbByWepjXLqC4D1se33Pa8TKKcyVnX1BE	12477	17555	17555	1619099100000	orphaned
25152	3NLMYedC1LR3RJkpYkyVJxkKixB42pLE82Y9yQTTZwtUXnnmW7rm	25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	1439	1033	479	12463	16984	jwbomkDzZXo87aJ2PA8ufiTc9kjvvDpX93z4BYAuRKUDNWvn6SN	12479	17557	17557	1619099460000	orphaned
25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	25153	3NLXNZG1rkjtxzhCvnM5mVqZ9K22jBSqDJLVJNGmFffNL2X9bFvt	1553	776	479	12463	16985	jwr81w6KiDYgXXyTJ4xBmaKrjjcsf94CHArqHkgKdJtp8i3zec3	12480	17558	17558	1619099640000	canonical
25163	3NLSaBQ7GRksBhSUzEZ7i76Vi7HMaaG1xegprFGvgoV4tL4nyb1y	25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	1527	1047	479	12463	16994	jxEKECRafvLwhdBMeipPAypU8tNRu21spdTdoq2RZ92Nco5VkXB	12484	17562	17562	1619100360000	canonical
25165	3NLtFsC5axz9wgJ4ABktLL8qgi8kXdeaoEEZpQU8VAbuYGQ19SC6	25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	1527	1047	479	12463	16994	jxQNrAA31gE8WLC6bxE3CmuF8oR6qje9ZcTzqJVNF4AHxkZQEmS	12484	17562	17562	1619100360000	orphaned
25168	3NKMVjNbma97frXRx7o9A52WRoTTpAs43QTb66cnovQdeja8Lzjf	25163	3NLSaBQ7GRksBhSUzEZ7i76Vi7HMaaG1xegprFGvgoV4tL4nyb1y	1649	1383	479	12463	16997	jwfxZ9mHfjBpdEr3kZ9g3Lq4dCGCKn9QnAZ673ymgNDbnhTSUt2	12485	17563	17563	1619100540000	orphaned
25172	3NKTE4MViCYeTEeiQFtSi8vV7RWRBLJJ25nay5XT8GwcAgF6WmvN	25171	3NLGfftNwdpTZhLBStnEpW96wDyqQn5wmuP1XYQqvKtscLygEac6	1457	401	479	12463	17000	jwrFXYwf9dzRjPJvCMPzwvFiJdtybYrq4bt6uQn6E3eCsYN41br	12487	17565	17565	1619100900000	canonical
25177	3NKV3vLePtvAJPQiH2xsmzVTeNJA7AQ3BzYRUAL4EQypZUJUubi5	25176	3NL8AG8ExrKzAXLazeE8hgt4DbTVAhS7d1cV6e3v5HEUG7j6bCyc	1402	850	479	12463	17005	jw7MrYHk2xFeSGUkBbeqrBZYYJtcw2b6TtgYxr8nCsr6JBRaAyL	12492	17570	17570	1619101800000	canonical
25185	3NLaJMPeJbv3qNuwLrDVksd9LyqTEXkgKpcDQhFHQj8gHcEiiZM4	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1590	1300	479	12463	17013	jx6ywR6AjeyquBsyj9Y9aYDJoeKauEtEv2fJmM9QNF393DyxzFM	12495	17575	17575	1619102700000	canonical
25191	3NLTP8X7yWKUZqEQSsZssmVjgjSfKxGzasgkEP2sZEhXwjHReKE2	25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	1670	1036	479	12463	17017	jxN5zU9oYA2Lda29ha5ttVu4PKu3YKo5wquvHwXHz5z37VrPUHK	12497	17577	17577	1619103060000	orphaned
25195	3NL3QR3NyjhDzzgeb2gHerGMp2fvChfD7exzAGZAXq2tFj5GLQ9r	25192	3NKuhLNVuCCRAnzPWvCWMH2WQeNDroivsjNWr7APf4ZvgWLDSdix	1477	1350	480	12463	17020	jwWu4RY3Vaf5AjCfmUCTxMoVpCpDh2X8mZD6S82e2X3ro3qSZmj	12498	17578	17578	1619103240000	canonical
25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	470	1309	480	12463	17022	jxdEfogyoBkTVNtM4SWxAvPGtJfuy5yyhwSiQY3ax9cPkKXGiUe	12500	17581	17581	1619103780000	canonical
25202	3NKPwnNaraszB1bYmV81NV8xsR9zBPFSDyYAq95HbkexU5macajN	25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	1553	776	480	12463	17027	jwRGN7m4iXoiwci7S5Xatkh82QKgec8avZC8dDkjLVCCaMDdC7e	12501	17583	17583	1619104140000	orphaned
25206	3NKWyLmq4VFMRCYhH8nTww3JgDXYfFFvc5joePER3DwocazxQYkr	25204	3NKbyaRkJSQC4KiXa7gQL8KLdba9cX3Chr9DofAiLXYp1aaAQ5YC	532	1177	480	12463	17031	jwKF8V7aMNKGdtkepQYhXYJ1uM4Yig7gVYFf9GoThVE5xSY8YkT	12503	17586	17586	1619104680000	canonical
25213	3NL3LpDTUYwKjhuJvHguicmwYnsTJYxC3AXpugSWGt5uJ3bbbBSc	25211	3NLEWbj1LNwbFZbWwp5cHVLG4houqzYw27kBDyBqLKx9Lu5wYEQB	1500	1297	480	12463	17036	jwxJhYPbmcnkKFirqjEYtA6zMzjQqUyMhze23zzyYM2n65nEBXC	12506	17590	17590	1619105400000	canonical
28520	3NKsSzdyyx7FSdZEz238KCn6mhG29rcKPv7BVdfE1v7YZ3Akjxdn	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	1483	240	558	12463	18974	jy2ptrKMv8AxepYHN3jmhPZbmgL4eEqMrzCrfpX2ZGqNbmj8dVa	14092	19858	19858	1619513640000	orphaned
25141	3NKoDH9Sh8xGDHscJ7fGvsFMHS4vowRnbVApwZuuhX11scDnrBvT	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1529	1070	478	12463	16974	jwae1d4H2LzjxzQkZVFmMsick7a3vkVeob4hp2wSs6v7cxzQjGB	12473	17551	17551	1619098380000	canonical
25143	3NLPDdfeqLoYqiBrNKwBZmTfgjr1gZqUuUMDVajo5Qt9ccsh6D7Q	25141	3NKoDH9Sh8xGDHscJ7fGvsFMHS4vowRnbVApwZuuhX11scDnrBvT	1560	1291	478	12463	16976	jxXxwmHLuF7uKu1VFu3M5G9LkkbM44rWtwKxj1iXa9D5KPnjc7e	12474	17552	17552	1619098560000	orphaned
25153	3NLXNZG1rkjtxzhCvnM5mVqZ9K22jBSqDJLVJNGmFffNL2X9bFvt	25149	3NLG3cn5bGsRzR3hFyn24mDqN95uN9k8Sw6kVBz39pGGQd5YfxWp	1622	1356	479	12463	16983	jxnwcrzhbdrvCam6nGHGRTVGy5fqFgFJkNn3k4fwbwVn1ceqxpc	12479	17557	17557	1619099460000	canonical
25155	3NL94PeGBnZnoAY9tkpHqhwUTtQuD1CzEMkC333UbDVrLtXEE3BD	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1671	1365	479	12463	16986	jwe9y8VtQWGuFucLsJFUfqExN9M59jnw4K6vgZRyAHgb3YVwFjn	12481	17559	17559	1619099820000	canonical
25157	3NLrkwtQwvDuVxVzdrcvjJiRvMZ8PNXTikpmL7FcNT4i4sFhtrfF	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1577	1201	479	12463	16988	jxR96KTbiDiyCghphxuMgMiRDESqRUxYuLDBZuNVTKvYoFShSx9	12481	17559	17559	1619099820000	orphaned
25159	3NL25h4LxELzV4Y9LAFG2znejmPdZBJzs6SJc49mXgBgp5gv9tJu	25155	3NL94PeGBnZnoAY9tkpHqhwUTtQuD1CzEMkC333UbDVrLtXEE3BD	1406	1393	479	12463	16990	jwvcriFTdfe5svtSYZQpHadJKjejgUU1W4qzG68NyB1kFn2S7Le	12482	17560	17560	1619100000000	canonical
25161	3NLW8sCT9a7C8kL9bLAG4zztUKmkX4QzGcK4vHeFe6xn8hzzdAbR	25159	3NL25h4LxELzV4Y9LAFG2znejmPdZBJzs6SJc49mXgBgp5gv9tJu	1622	1356	479	12463	16992	jxPgQGfaNvd66Negsv2Zn34nfPZ6z3o9Y17f4SANNdsAwzguxvL	12483	17561	17561	1619100180000	canonical
25170	3NLM6irZWgJMSBcJvfKonGvqCMotwgcSk3NRjmUf1jB6AxMAMScp	25167	3NKjQzSyrS3RiBogvMTUMEbif5r37aP9Cve1U3VZ5kcZxVE5G1zv	1407	1395	479	12463	16999	jxuw7UX3RFRA3d5muqxUDaTy7jomxFo2zsdpJRoF7z99fg745gQ	12486	17564	17564	1619100720000	orphaned
25175	3NKYZ18zaCU2YHhsbZ98djhXtoE4TL7218iEsRC3sAZrgNz2dGM6	25174	3NKRFvZvf6RcQzoCiBeKN7mmG8B5XqM6mXftCkHCoUsyZMRxHJMS	369	1312	479	12463	17003	jxhMS1mrBwR8gPp37YUgSuoeRzP6SYHkN34me2BBN22Wgyid6e5	12490	17568	17568	1619101440000	canonical
25178	3NKpybt78x88gnSAd1xbtPDTkHHW8LjJPqhQzHDLEqQaPaux7S3J	25177	3NKV3vLePtvAJPQiH2xsmzVTeNJA7AQ3BzYRUAL4EQypZUJUubi5	1648	1284	479	12463	17006	jx2u72TbF1x3av9vZfFCffHDAWS72HDNroENvN8icNUnb9E6x44	12493	17571	17571	1619101980000	canonical
25187	3NKX3pSFFTJh1eV5DCfocCrd15BrUR61kWajMWGMVACw9vPXeEtK	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1529	1070	479	12463	17014	jwpn2mA3QUHJp22NGhHFkG96LKLkEzrNeQ9Btcn1wtpyTWv1qPv	12495	17575	17575	1619102700000	orphaned
25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	25185	3NLaJMPeJbv3qNuwLrDVksd9LyqTEXkgKpcDQhFHQj8gHcEiiZM4	1477	1350	479	12463	17016	jwTQmERhrYdaKQ5cu75Tst8LRCdhKSC1r5aWBXVkuuf2Psjxwdy	12496	17576	17576	1619102880000	canonical
25189	3NKEjrKmmKzmRe7FXuJGzdYKq46S9FxU7JcJEg2vS7pFfd6jwPzp	25185	3NLaJMPeJbv3qNuwLrDVksd9LyqTEXkgKpcDQhFHQj8gHcEiiZM4	1397	828	479	12463	17015	jwBcF436fgqdAL7mtacZ7hZsS74inwDSTHamrfz5FJhh61NxhPV	12496	17576	17576	1619102880000	orphaned
25193	3NLUuwNgNa81abW7Ta5tLEL1BwR36TojM7z2LnoHTCw947LCnVVm	25190	3NKJffFdLQeKUZbekw4TDsKpNh6LY7V6VNmh92pjgJL4Q7DpegKE	1670	1036	479	12463	17017	jwfN4RN8kNGXMRuQJ5oxcAZRj39kZKE5mtqDqeSsNmfbwYn9Le8	12497	17577	17577	1619103060000	orphaned
25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	25195	3NL3QR3NyjhDzzgeb2gHerGMp2fvChfD7exzAGZAXq2tFj5GLQ9r	1581	777	480	12463	17021	jwvhpUxnyLf4F1h9iVHzWvmgdieFpmorPS1LsyRf1WmMojHGHmK	12499	17580	17580	1619103600000	canonical
25199	3NLa3aYg6zpqqQZuzhgaS8pJjHftyT4NSAyezgxKMfCARsRekdLp	25196	3NK6WWYXsWeKqkjfQF3WRU4tAEGtt85VLR1cm18xF7JPVzoqbMNM	1403	824	480	12463	17024	jxbyoVvrREEyjpYzYbrH2NXUtdKkkXiGw4VUHTkHnaxQo3PG3dJ	12500	17581	17581	1619103780000	orphaned
25203	3NLoJJmmGUi6e9SHvhQQfn1Myyn1purcKnyLB1qQWBVpPXj5deUi	25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	632	1382	480	12463	17028	jxxSFXF9dNgQDckQ4qduJX6KFUiohAXZgRf9KFycpzvkBvbV3sp	12501	17583	17583	1619104140000	canonical
25201	3NLGNorjsMsmrMAQYfCcSaR3nCaLLp9rVuKo8CKo5vHPHqwk3iXj	25197	3NLo6WuGuurfM8Rd2hrErB8sXEV4USRiEUWkhyu6SkRMPUVuTVKi	311	1181	480	12463	17026	jxPFXuAzFdoUprJaMFKXqxtzT7afW39yLXfZCPPyX577hQy7c7G	12501	17583	17583	1619104140000	orphaned
25204	3NKbyaRkJSQC4KiXa7gQL8KLdba9cX3Chr9DofAiLXYp1aaAQ5YC	25203	3NLoJJmmGUi6e9SHvhQQfn1Myyn1purcKnyLB1qQWBVpPXj5deUi	1534	1317	480	12463	17029	jw8VubLAQFDMj6N6HC6xfeSURv1pj3g6B6Yc8R17DPPFG7VtqPJ	12502	17584	17584	1619104320000	canonical
25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	25206	3NKWyLmq4VFMRCYhH8nTww3JgDXYfFFvc5joePER3DwocazxQYkr	1593	1100	480	12463	17032	jwyWeBRqXpUzs4Df5W5YRJmetC4HVyHSgyV83f6sWRvWUutzmBW	12504	17588	17588	1619105040000	canonical
25211	3NLEWbj1LNwbFZbWwp5cHVLG4houqzYw27kBDyBqLKx9Lu5wYEQB	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1541	1052	480	12463	17034	jxe5myRfLyPP7AmVFnDDWXPMaEV54Tsygj5mq5j1GAMuynwuGND	12505	17589	17589	1619105220000	canonical
25209	3NKuxonv7rQgNNnzRYXtYaY5euqjxfbmJMndErYVVqhGvpRAmk6R	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1541	1052	480	12463	17034	jxevLdwrWTWbndEtShkpdJypXWzuSaJJV5FCiTo84nYqAJJfMry	12505	17589	17589	1619105220000	orphaned
25215	3NKSFs2y8LCz9HRDgzeGLw1CjQn3qkVhSqiJQecF93pRX17tGWcG	25214	3NKHd2cR3yoM8m3MBpiCa8itxbpLrECWSMytAPsSntemDWsE6s9c	1553	776	480	12463	17038	jxW34RY1ndp1eZ3Wi8KdL1QBiucrwyE9fk4xfGbx1iuou2t1vBo	12508	17592	17592	1619105760000	canonical
25218	3NKhDv2D9ys56ToiXJ56sB5Z6Yfyp2oLdYSstLbg5mGpxudPqd5N	25216	3NL9YQHuRx9vesR28LbYzeyA2B426KQLGijQxpNcmbHXmd1FraCw	1600	1372	480	12463	17041	jxn5g2ow1Bcf7pUrpNvjVgekcAiZJEqQR1A1RaYHCauPHAt5Zno	12510	17594	17594	1619106120000	canonical
25220	3NKmStdaRwM6wAD7iAX7FhXtUMmZtBFBPSUmrVQQ1fnbenNaMFCN	25218	3NKhDv2D9ys56ToiXJ56sB5Z6Yfyp2oLdYSstLbg5mGpxudPqd5N	1581	778	480	12463	17043	jwv19G7BdPmjhjtqapuiRw1pTzPy2GDZx1Jda2rczG7phY8e2vG	12511	17595	17595	1619106300000	canonical
25219	3NLrPReN7QFq4FGx2aiXhzifUyQYnVSM5RP6xSQCsEz8c4HBFfs2	25218	3NKhDv2D9ys56ToiXJ56sB5Z6Yfyp2oLdYSstLbg5mGpxudPqd5N	1403	824	480	12463	17042	jxnLi2t1uLoHnEkEwPDj2WSbmvgRQ97U2UCpesYxcW8kYLnYwA6	12511	17595	17595	1619106300000	orphaned
25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	25220	3NKmStdaRwM6wAD7iAX7FhXtUMmZtBFBPSUmrVQQ1fnbenNaMFCN	1476	1371	480	12463	17045	jwBa2ffXWGEpsmsnPJsM7LEDkNEwgmvmyaYgpvJHQhp7HtM4hTG	12512	17596	17596	1619106480000	canonical
25221	3NKPwswT4w9yJ3rbXuybZ9aDgQQGpkESqKhVCSgorwHxM1FWqgVi	25220	3NKmStdaRwM6wAD7iAX7FhXtUMmZtBFBPSUmrVQQ1fnbenNaMFCN	298	1308	480	12463	17044	jwNa3k3gBzmEk9BMoMPVoG22a6rxpQpQdonDhkzidQtjhhjX1tJ	12512	17596	17596	1619106480000	orphaned
25233	3NKLYKMJgZXBybHziX9HpzxGUktHKkrYTvUYRpXnUmER2L2ZtdjV	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1406	1393	480	12463	17055	jxUHnkBXAgzyx26MArQ7Gm5mBokGKCzieq42HVDaRYfo39wgtmo	12516	17600	17600	1619107200000	canonical
28524	3NKiud5SmMy6uvFRRJpUkeEBHsXoPuSNfYdEP6auhhtuMKnRMeBz	28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	1651	1055	558	12463	18974	jxMLJNcNxDYJgTTmGbgjnHVDSFWAfay2SqWoPZpo1oN2NMj1Wp4	14093	19859	19859	1619513820000	orphaned
29159	3NLpgnqFnuDW7Rq4SnyDAGWFnNp8of7q1eJaeLuMnj2GdJ4qmE5K	28660	3NKX4eKc38W8kFWFSeooQhzb9Jjsy8K1VwpekUPMCMYcHiXLMxJ3	563	1233	558	12463	18974	jxqPSanz3tg3ioxLKVPNs1gHPigzVDTj5gxDp44LzWbUKRhCACr	14093	20250	20250	1619584200000	orphaned
25296	3NL1y4izR1pj6fkMD88oxT5ssYys4p4eqrbGakg2yQRbLoSk6Vnm	25137	3NKXqsTAKsgZC2gkN9UgDCXzd2D6Kt65AbTvX1gQAhug5r7f3sh6	1509	1074	478	12463	17112	jxAKhfKutMrf82PFK2bbbFtTogs7c5s7dTf8pjVjhLDFNDZsxW3	12473	17647	17647	1619115660000	orphaned
25208	3NKFv8xPV1K4fbsMNpSczPQQvTqLeV4jU3KqWhN9PFv5y3RuUfw4	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1402	34	480	12463	17033	jxVQd8dL7mVYMBBrF1tvSoYnQ6rWCrT7npK8SRMLCEp4fosQLMb	12505	17589	17589	1619105220000	orphaned
25214	3NKHd2cR3yoM8m3MBpiCa8itxbpLrECWSMytAPsSntemDWsE6s9c	25213	3NL3LpDTUYwKjhuJvHguicmwYnsTJYxC3AXpugSWGt5uJ3bbbBSc	1406	1393	480	12463	17037	jwmcah5suNHwUnZEV7YPTusBhHBvQvcdrbwKVQ4PccDosdLzwv6	12507	17591	17591	1619105580000	canonical
25217	3NKb1mbo6jFm2x1sSTFs23abPPH8u3ziofUDPNrmkgq2FmaVBaBw	25216	3NL9YQHuRx9vesR28LbYzeyA2B426KQLGijQxpNcmbHXmd1FraCw	1522	956	480	12463	17040	jxFGU961gKgDzpiHfvQgKLSB9iDZX76pZzPgESCgnyt57X9od53	12510	17594	17594	1619106120000	orphaned
25224	3NL4N1C9A1P6TtAi3Tj3ycK2R2DPuz5JjTXsXjbeJ2b6xkC4kELH	25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	1542	1304	480	12463	17047	jx8zFXS1LizgeaDZwC28chBr2AW5RWbLo4cYGFN6UsebnJG41wF	12513	17597	17597	1619106660000	orphaned
25228	3NKyxo1M5qgn1S3n3VhKBEubcovphXYKgLgVC7LVrsQKNC26eez7	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1534	1191	480	12463	17051	jwcot2kYMcSkhZTvuNEXano5GEvjdTMCSVJZjW1xeTeHuxTJ5ZC	12514	17598	17598	1619106840000	orphaned
25226	3NK4AQJqYWwxo2bBU9EmvARYbeBGnfiYitghrPAsSsXhAvwhHcUJ	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1608	1289	480	12463	17049	jweyjVUtXLx8wWC8C87n1NSgguW21zG7ArV8SSToZyk4wwvdPWg	12514	17598	17598	1619106840000	orphaned
25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	1622	1356	480	12463	17054	jw7LE8NKudDtxFK8iEmuAFWbm84hDzu9CaJHpwBHN3vDuCj5Lb5	12515	17599	17599	1619107020000	canonical
25234	3NKLZ8LteLQs9SzrRog14io8qKW6EHXQX32UgYJi5hFPMosDYmwd	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1657	1344	480	12463	17056	jxxQwjeKX7EktxQuEhvuWzAhMCU3v6JbdXVb1BqHqaGD8XvHo4E	12516	17600	17600	1619107200000	orphaned
25236	3NKQwTsVEspe3pw3SJ2A2PtF3ELrZncE6d8TZVk7XmFwmYgk34Ts	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1634	965	480	12463	17058	jxSHPZbTMrKgwkkxJPu5ErZkY8dPUkKCy7jsdwsDg2UC5ZhcrYJ	12516	17600	17600	1619107200000	orphaned
25241	3NKgZtFJ9ebSfh778Wr2GzE4tPB95xzKSYTmMzSMYBaCEKizH7zq	25240	3NLgsmMYR6BwBgyYRMpi7XgPHEgT41NUXHpBsjXdkHRgVDWMy83j	1439	1279	481	12463	17062	jxxDPP7i7XnQ7zEPzebNuoyyrnXW46f5FDaaMcjroV7EUWqAFF4	12519	17603	17603	1619107740000	canonical
25248	3NKaFkGBsZQn28CDiumVTKBYqPNotRjcErAbAy7DZmYLyyRvFMiV	25244	3NKFZ3U6Qj42ufhwVkL3ttBL3wY1jKYt8atXbHLS7KybDdqmDz4F	1407	1395	481	12463	17069	jxtAYWxStRoAnRHMxvLP8FDQTcrmq5xiGE5ZWwtPBS89MPVxn3k	12522	17607	17607	1619108460000	canonical
25251	3NLKxqz31v3eWpgj74uCsUYuHfKqwT5E4gHHQJdUAN998EDtz6R7	25250	3NK6D3v5Hmg7fAfX9fqBEqCc8rWP8VU8rpd2REopbRruAxVBZTRy	1407	1395	481	12463	17072	jwVmwkTTiEctA2KBnMKonTcHFGZDohbGCwUvF5JqxVECSEvEnKr	12525	17612	17612	1619109360000	canonical
25252	3NKRCCybTW74L13vvSSmdFLibyy1r1cqA5GbDxQYqQbt3qgEzhV3	25251	3NLKxqz31v3eWpgj74uCsUYuHfKqwT5E4gHHQJdUAN998EDtz6R7	1471	1260	481	12463	17073	jxwUDU9YpUMGuRFuhs4Drmv7Y3FTyCZDbzcykbf2WBmghR1C8QG	12526	17615	17615	1619109900000	orphaned
25254	3NLizXjhtD1toRpZL3G339fcVSC3r2FfnnruRDhjuY8Ww4CYZxU2	25253	3NKiiRLgMSjQEYV8NrwZuPFA3bXZAfEyo18pZwTeZAswtVF2NFVS	596	1060	481	12463	17075	jwDVvw9vrXUcApumRaED2mfUqMtjQzLLNymN48KDLGF6G6EJEyf	12527	17616	17616	1619110080000	canonical
25256	3NK5Mg6ZCneGvwws7hbgAKxbBGNcGDne3PcSxhM6F64Q4NnDzHtv	25254	3NLizXjhtD1toRpZL3G339fcVSC3r2FfnnruRDhjuY8Ww4CYZxU2	1406	1393	481	12463	17077	jwAyCJbYScfVPcuft7Bm533AAVtVsVwHEPtkFbgc2ksFYEGtMZo	12528	17617	17617	1619110260000	canonical
25259	3NLQrXEX3qSWZ23hGhBtRzQGC4vacX3dV3FQEQF5nd8GeatAxkkE	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1590	1174	481	12463	17080	jwaifV1cfM2n2hNFkj3bnqRkjy9seGn6cWHpopUdyEDjMFnkEkD	12531	17620	17620	1619110800000	orphaned
25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	25266	3NLswNzAMJHwFUWv967LGkAc72tP6TWTgrW138zdiKfWPu1WhSYb	1402	888	481	12463	17088	jxcsZ94tvimnQFouNsH1QX1HvqwnuN6sUDbxxCE217x1jDubaCv	12534	17628	17628	1619112240000	canonical
25272	3NLs5TLEWd58bxtHY4d7FVC6sg4nmcBCu85iBULwcupvpKBdYghb	25269	3NKDkEDHGu8WvrRDVSNJirGH3yRCsArney7S5SYSkxd1Q9Ze2oMm	1581	778	482	12463	17092	jxciWvYFihw2XXR7MV12rXYr4jNAGB5rwnpPgNcJjPpHgHb4uik	12536	17631	17631	1619112780000	canonical
25275	3NLsuiu86kdUrjCg5eFc7JF6w2pug5KYCYPtrJFwbw3sM8AvpowW	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1523	1321	482	12463	17095	jwzSqZ59trTtPQtKvmXV1vQjtayfEu2hcxFuPKHGppSaHvjwV4L	12539	17635	17635	1619113500000	orphaned
25277	3NKRFUigGyoYxF1wLnho9CUaEQAbXNtQsHjP9iyb9AFverHwUkMG	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1523	1321	482	12463	17095	jxWoQyRsKRMSz5BF7Qp7ypy1QRw6qDgHbVS3iPSeQfj5LyTPCkS	12539	17635	17635	1619113500000	orphaned
25284	3NLmCuBR6R1rkCk2cKCH7LUSwGWnoctEL2enzNxCcUT6B74XiGJ9	25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	1527	1167	482	12463	17101	jwTdWBQKGtV74amGeGY3neGEuSYxAgRNShHLunf7zFm93RQtDfk	12542	17639	17639	1619114220000	orphaned
25286	3NLZjEEqqpVwq97H3Yn2aKymcWTHxxeZGY7CdRCNkxAuUF6zntjk	25285	3NLafXCReLEqK8eSQFnJNVbW1euApGhfk4SX4uxRuqtHKPsBMMQ9	1455	966	482	12463	17102	jwqQQGyB8Rmdwu21Seu26MyQq68RSa47zzq1zC1iXkMNKa979hQ	12543	17640	17640	1619114400000	canonical
25293	3NLMmhxibyyoZrxtphgUm6Ghbm9ByKSAc9HZpfxZnz6tQbrfQd63	25292	3NLmK9d1cHQotsuemKTa4XgDene8xHqfBy6BW7X1HWCJg5SrmjAW	1402	874	482	12463	17109	jxnrYXFJf2UHgxkBywfcijBXszqG8SGtceU8PiPqEaNojtou4xT	12547	17644	17644	1619115120000	canonical
25298	3NLggb9Q3ZycMvqxJZhM4z5JRXS9zwzzyvEFHXmbpFtZhvRaJSS2	25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	1509	1074	482	12463	17114	jw6mrWj24Yuqti2Kw9HLvcHHsqQFFHJhjTQ1x1Zd1aTMpXRXBSz	12550	17647	17647	1619115660000	canonical
25300	3NLrCgfuP27kWdA5TBQdF6vJXzPJBETkNVNJQhNUYccUj5Thn7VH	25298	3NLggb9Q3ZycMvqxJZhM4z5JRXS9zwzzyvEFHXmbpFtZhvRaJSS2	1447	1099	482	12463	17115	jwZqqt815dE3nHGRBGXoPcGUweDf2i1V7eSBJy9upvBCEmXnaG1	12551	17648	17648	1619115840000	canonical
25305	3NLPwfbTXScYTYFc5HrQYmsWmUyDmvLdCXc7egKU1DWiE47s5BWQ	25304	3NLhBhdLyvPp5ycfVchfiGdq6pD4pYrp8sGKWKbZ8YEr4S9X7oWz	1464	591	482	12463	17120	jxpkHrVd84gAs4DnnX1HVLRKJfiTNFbA4nj3JdQ94LgPcgihUMq	12555	17652	17652	1619116560000	canonical
25316	3NLW91y1GwK8jTC8QsjpDYxjCL1EX8SBQKEmPXtdL6dSyY2hVpLn	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1610	1188	483	12463	17130	jwW2S1G4W26sK2UjD8V6qj4iRBkf3XT2knd71ETbDZWiMuBasJn	12558	17655	17655	1619117100000	orphaned
28535	3NLCkonCroud9SuUYvq5ZWKETirBYUWxK9xELBx9yu4rcVb4yWD9	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1419	814	558	12463	18974	jwLDdobCCA2RiyiP9HQFokTkhLM1J1gTRqFWSEZenvwpC8t9urR	14098	19865	19865	1619514900000	orphaned
25216	3NL9YQHuRx9vesR28LbYzeyA2B426KQLGijQxpNcmbHXmd1FraCw	25215	3NKSFs2y8LCz9HRDgzeGLw1CjQn3qkVhSqiJQecF93pRX17tGWcG	1600	1246	480	12463	17039	jwz4QVD4UxJen4qBoxtafemzgUHbV1SrgdejeSVfmMDe3GFXNPw	12509	17593	17593	1619105940000	canonical
25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	1611	1341	480	12463	17048	jx4kRhpSKYpRskGgjSeMJDMEgtG1iVPmTFVYAxgAuTocYu6BpJY	12513	17597	17597	1619106660000	canonical
25223	3NLKTgjawHdTXSZiJ4dXSQybFFboUb6TgR3QvzCw8zyWCJHih6Xj	25222	3NL7btcHMvVxf91zMfXDPCq9S9w66hKF2GZ1eNwYvrCGEBzed82h	1627	1385	480	12463	17046	jx13BfPg2HmKyswKNzZs5eEw7HUtGpqNdDU8ZgrEp8gpKZT8WLL	12513	17597	17597	1619106660000	orphaned
25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1623	830	480	12463	17052	jxMiWuZXDMKxAZxNxfoK6yATywe8bfWpgWLSXnKg4BNxeCEceDK	12514	17598	17598	1619106840000	canonical
25230	3NLdYWvheRrKy6ukesQFefh3mbZMyCWDvjxvEh1j2t9vw6PYe6Tx	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	1534	1191	480	12463	17051	jwb7Rw3MDPRAEuAMumX6EsK7Y1N3Ux2pzKTC5zFxctKWyAq4BBb	12514	17598	17598	1619106840000	orphaned
25239	3NLmc6MSdMhcxSAaNsKNPfLagxPegdK4MXbrP2ymCvjcmjUgJfpL	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1483	327	481	12463	17060	jwtagLU1F8uPU8yA8ks6eF1GcAPa9jk3uVxPLDmTEjJgxeqyiqc	12518	17602	17602	1619107560000	orphaned
25238	3NLA5ENM2JtMB4o7VzhKuUvb1vBCdKdPyqQqvSVy6WfBQ6m8YX3g	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1483	327	480	12463	17060	jwFBXZxMGebL5SPQYhWUzFAEJTeBDPKzLPSAEMoxwjMSdDyawsN	12518	17602	17602	1619107560000	orphaned
25244	3NKFZ3U6Qj42ufhwVkL3ttBL3wY1jKYt8atXbHLS7KybDdqmDz4F	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	1406	1393	481	12463	17065	jxUjXMqrcUmiT7Lvy76mwDhBJe47LLe83HxkmFDmMth1MKpzEsv	12521	17606	17606	1619108280000	canonical
25246	3NL4NTE8mcZHprR9xscpRfayRDvoCd6DHbvePT5J63UqM5BxTo4C	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	689	689	481	12463	17067	jxWbTTUTs9SNvYLmBTWTjsvzR34767cffhd9eSEe3qtmGoNdmbd	12521	17606	17606	1619108280000	orphaned
25249	3NKVNJota9WvCRHe5ThFKioySHhYhBvCsiAWWiEDbcSFemk1UAKn	25248	3NKaFkGBsZQn28CDiumVTKBYqPNotRjcErAbAy7DZmYLyyRvFMiV	1555	1347	481	12463	17070	jxXSUxWzWLLc2Wg9aVE9qkf54f3qRJaWhoZvv1DfDjN3xNzuPSw	12523	17609	17609	1619108820000	canonical
25253	3NKiiRLgMSjQEYV8NrwZuPFA3bXZAfEyo18pZwTeZAswtVF2NFVS	25251	3NLKxqz31v3eWpgj74uCsUYuHfKqwT5E4gHHQJdUAN998EDtz6R7	1675	1342	481	12463	17074	jxMidv8YZmJg8F8b2H11t4wPeKmwQDSMEeXr3gygTN3rYQsyN27	12526	17615	17615	1619109900000	canonical
25255	3NKchzY6Vm5wAUzre4msqc8vV1zvKdqDvwua3E2bfx13JASk6rhk	25253	3NKiiRLgMSjQEYV8NrwZuPFA3bXZAfEyo18pZwTeZAswtVF2NFVS	1657	978	481	12463	17076	jxGsqxBCMLYqvNcLad82Ug5F8aT6xvvhcKharUoHamFSicWjr2R	12527	17616	17616	1619110080000	orphaned
25257	3NKk98jhEcyRAn8fcReGE2q4mzhzudyQV1YZ45b7GomZZvcGsUmq	25256	3NK5Mg6ZCneGvwws7hbgAKxbBGNcGDne3PcSxhM6F64Q4NnDzHtv	1407	1395	481	12463	17078	jwRHVYBNtd6xWnjDbVBEprUaNynf6m9Dava6rSpAbSuU4eX4sNy	12529	17618	17618	1619110440000	canonical
25264	3NKyUfHmcR2zqkqp3MXZGbz8RC64W5ppiUy9jy7kD4vVibrWAAS5	25263	3NKCX87K6xxQiKt5FXE5DA82yWDWDKL99UXERDL62Hh2EyNFCDHr	1581	778	481	12463	17085	jxAaqmyZnExxLADkVxpEKjK386p8KwJ35dQaS9uva4TyGV9jRm3	12532	17621	17621	1619110980000	canonical
25265	3NLJ833ALKcZMUUs3ECXmQFHZtRb686ssk5SHXvkJGJgGfdmFZYf	25264	3NKyUfHmcR2zqkqp3MXZGbz8RC64W5ppiUy9jy7kD4vVibrWAAS5	1609	1087	481	12463	17086	jxoRkwmjLfN1wsye4Qn4nYgmVG9TWm9eLBUjTLqVoFFggX4uJxp	12533	17626	17626	1619111880000	orphaned
25268	3NLNYGZRin3UAPVKQVPKfrFtSHF7kcyVPUGHpuf991WQjPAEetCJ	25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	1523	1195	482	12463	17089	jwHbxtGBsNmd7hXW4r37AsHfVs5MnsctSzhJHPAjPgSGcfiVeP2	12535	17630	17630	1619112600000	orphaned
25278	3NLStcf7DtxkfxboB6T8ffzAtkRxqNUDuB6j877ZeCAjvzuAML4i	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1523	1321	482	12463	17095	jwEFfUWxTgnY9GX8MeyJrfkB9iKyCNoq6Z7PhjjEH5cxcgehGQY	12539	17635	17635	1619113500000	canonical
25276	3NLiiDSRyoakTPNxRooYVxyeZoX7tucX6xFFGVEJ9NPTd9U5jBSV	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1587	1357	482	12463	17096	jxiVeV8h147Wd1sR8wqFiN1V5QLttdbiNe1P5baLXu1bAzxk4D1	12539	17635	17635	1619113500000	orphaned
25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	25280	3NKF6pk9BKNn1MzZ3ieVF7dwnrAWgJ5n8BbAXThZJgAEYx5Kq5kF	1553	776	482	12463	17100	jwtfYXNhmyMUfrh1EGMWQFxScDb6oJNfRyDMzwQqTgxGeCm5SrX	12541	17637	17637	1619113860000	canonical
25285	3NLafXCReLEqK8eSQFnJNVbW1euApGhfk4SX4uxRuqtHKPsBMMQ9	25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	1527	1167	482	12463	17101	jy3AXX8eunpdPzkWPmNtpFwBJwnyHmpo6YegnNtKyvt41zhiDqU	12542	17639	17639	1619114220000	canonical
25287	3NKbM38sgzZ9FadQYXckUqkLhHH7DDcCedvV8Q6wzwLAyA713h7a	25286	3NLZjEEqqpVwq97H3Yn2aKymcWTHxxeZGY7CdRCNkxAuUF6zntjk	1405	851	482	12463	17103	jxyQTv42dQCYCJbsM4tRqeyCxfE572xLCkLq8tFXbBi7xpvzGiV	12544	17641	17641	1619114580000	canonical
25289	3NLd95fkAgM7gbfThKz8rds9i1ZM3DhuxpyWs3TreBEZimxJ48T5	25287	3NKbM38sgzZ9FadQYXckUqkLhHH7DDcCedvV8Q6wzwLAyA713h7a	1402	1267	482	12463	17105	jxK3iNJDncwZmE14Cv5Cc3u5eD9q4H1CgLB9JBFdoRq3Tob5T36	12545	17642	17642	1619114760000	canonical
25294	3NKPw8PivuMvVmPhyHQZCqmzduiBY2G4Q2TKo5ojRsgzkfWPAzdD	25293	3NLMmhxibyyoZrxtphgUm6Ghbm9ByKSAc9HZpfxZnz6tQbrfQd63	1405	851	482	12463	17110	jxfFq2CcARq9LnrTR16KuQS1kEFd4LqtDi3CVH3SFjybuffdYwM	12548	17645	17645	1619115300000	canonical
25301	3NKCx92XRyRPzr8DjcvF6DDz8g1kcsfBQqveog6787YvryLh7qYE	25300	3NLrCgfuP27kWdA5TBQdF6vJXzPJBETkNVNJQhNUYccUj5Thn7VH	1642	1001	482	12463	17116	jx5p5q7tJaeaCaQGe47TQyfUZiNMjac9Gz7T4PJWavWNTTvqvfe	12552	17649	17649	1619116020000	orphaned
25303	3NKZNdqSU64cYtXyjaLGJypNB6oszLCZqLyaSmRiQ8A91abJEnVt	25302	3NKwomK8hmqibSRNj9RMUA7d2Wviyq31mCe5rEu9XT15uxwjf6db	633	1258	482	12463	17118	jxkcA5kRAVEodzLHyKoWCsQCZ5XHYQqQsdjJfFCdekvvhzhjM5a	12553	17650	17650	1619116200000	canonical
25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	25306	3NL3yWJ2DGKPhRGRkdMS1EdHJLkHM5qARGj3XRw7gi1FHjhahtvX	1523	1075	482	12463	17123	jxyBWuFdpGRdLLFGhhga2AFW2tENQUJdTy5vWGrVpMDD6d3JM5a	12557	17654	17654	1619116920000	canonical
25310	3NLViRz84yMKVrcKWY1j5KXLuudV8pGpqPL4zrgirBJ8se31x1xF	25306	3NL3yWJ2DGKPhRGRkdMS1EdHJLkHM5qARGj3XRw7gi1FHjhahtvX	1523	1075	482	12463	17123	jxDbeZpXgAyW6EBXV34RcoAdxzLM8MRNposCHEaiA6athuPQgvg	12557	17654	17654	1619116920000	orphaned
25312	3NLiJWhdUfPiEotwf6UXcF3P3avUgRNBgXUnw4yorvWRuWcj1Hjy	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1407	1395	482	12463	17126	jwkzFwNeurcMQEBfUUPaDsyLXmiCHBUKkK3bEgDeBzagfM8oMqq	12558	17655	17655	1619117100000	orphaned
25324	3NKW76Wos4AyzzWXAsfWQHMHboDJcYPkozQStJPYdtZn2ECKjJRz	25323	3NKBsrKV7BRtNXxiGThkEVUBvtunH1f8yBdHKyEWh5Fu9SFBEYne	1670	1156	483	12463	17137	jxdkMZVKb1P9X9hAANW4i2CTkow29WCRM8vydwAQLCsSrUYQNew	12561	17662	17662	1619118360000	canonical
28540	3NL2VTDMfZG7jgoqhpGeuv7n2wHkBbeeWv35DePrjDE9ZQLKJmPM	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1523	1195	558	12463	18974	jxeD6H1bH2Dc3MJEndVK3fQKRGyZcmt6eJBYrP2qiH7owcmCpfa	14100	19867	19867	1619515260000	orphaned
28538	3NKd6CNfn8kEes9TbPpW2Lq5wBKX9muj7eW3xGqVR3QDXM9dUV19	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1405	891	558	12463	18974	jwbid1Uat5MZwAJMYDY8DiLx1k1QyKgwpLA8gYeQJXKoN8f2yyy	14100	19867	19867	1619515260000	orphaned
25235	3NKqa397MXdveReuvFqTtm5eQQxYTXsCzRMFZEJ2xuADvModJ8Bj	25232	3NKYbHJwgCRLYFhtqUn3Q9vsgeifCZ9mKr7oRGwWHF3wZKntGvt9	1402	874	480	12463	17057	jxHD95uoLTdgqhBr88nnErNu2NLLf2XQvrRAZWsnGrpPuN1yEZh	12516	17600	17600	1619107200000	orphaned
25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	25233	3NKLYKMJgZXBybHziX9HpzxGUktHKkrYTvUYRpXnUmER2L2ZtdjV	1406	1393	480	12463	17059	jx2aAJVP1iCS8zofmp1o963pBdysmRsvChipkXQHu2tEaCJSZ3N	12517	17601	17601	1619107380000	canonical
25240	3NLgsmMYR6BwBgyYRMpi7XgPHEgT41NUXHpBsjXdkHRgVDWMy83j	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1403	824	481	12463	17061	jxT5fm4epueeGijkYwFxinRey46UcuK7h2z1pmiGqPH6RVJdkGg	12518	17602	17602	1619107560000	canonical
25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	25241	3NKgZtFJ9ebSfh778Wr2GzE4tPB95xzKSYTmMzSMYBaCEKizH7zq	1406	1393	481	12463	17063	jxAu2TkQWNYs15U5Bz3R152nUatogufLmqjxND5wf1YVzAfCNws	12520	17604	17604	1619107920000	canonical
25245	3NL9h9jxHgzaPuAdy3qoHakVkTykPh76RSEw38PGRpf4biEwihZf	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	1536	947	481	12463	17066	jw9KDnqbbbk6iYT9nMFut1TcBwjHBqPzz4ACy7TYZ9y1tvJgKYE	12521	17606	17606	1619108280000	orphaned
25250	3NK6D3v5Hmg7fAfX9fqBEqCc8rWP8VU8rpd2REopbRruAxVBZTRy	25249	3NKVNJota9WvCRHe5ThFKioySHhYhBvCsiAWWiEDbcSFemk1UAKn	1406	1393	481	12463	17071	jxZmhw1vZUNSkiiJYsWTMhojneSwbeov9VcvRsLwV6MEmuLzgix	12524	17611	17611	1619109180000	canonical
25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	25257	3NKk98jhEcyRAn8fcReGE2q4mzhzudyQV1YZ45b7GomZZvcGsUmq	1670	1282	481	12463	17079	jwVxKPgMo2VTyVuzepeHx3AXq8piWiVNTAFSScawHTwsgqAvSpA	12530	17619	17619	1619110620000	canonical
25263	3NKCX87K6xxQiKt5FXE5DA82yWDWDKL99UXERDL62Hh2EyNFCDHr	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1555	1347	481	12463	17084	jxixqwPHWME3VxfUpPEnDd6UX4LBndLz5AujFsToJR4y6scuFUp	12531	17620	17620	1619110800000	canonical
25261	3NLMegQVEcN6jm1kk7xPH1tYFmiRuig8MhwVVcxaXN4RdB4SmCFg	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1419	814	481	12463	17082	jwNqU15sBizRaLMNHRqNiiPbh3eCJ3rprwN6T9dPHZA1ppgqagh	12531	17620	17620	1619110800000	orphaned
25266	3NLswNzAMJHwFUWv967LGkAc72tP6TWTgrW138zdiKfWPu1WhSYb	25264	3NKyUfHmcR2zqkqp3MXZGbz8RC64W5ppiUy9jy7kD4vVibrWAAS5	1553	776	481	12463	17087	jwUEtohHGEAN89nE1v8Ye71ce9DqhezGPhJYCXiWvmhyhSREZCA	12533	17626	17626	1619111880000	canonical
25270	3NKGSM4ng4MAQvfNc3vijzP886s4jAPrV4MaLXqYrofdaXbu3SfL	25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	1523	1195	482	12463	17089	jxk9kCPaAAM17VSoViXmNdTfczpYV59LgCay6zafcmxyzynLuse	12535	17630	17630	1619112600000	orphaned
25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	25273	3NLUZjbtB6WuzwrYJdr3R8CPegcLpDNnoMnx1vui8L3d5omH9Y75	1458	957	482	12463	17094	jwcjNcFfWtoHXieRUivNNCGc9VFZC2mHsZbK3dLZXLeagg6Ckdt	12538	17633	17633	1619113140000	canonical
25281	3NKujZrZZpHAqs16jaGp85Bb31fewcTktnq68A9L6Vbyd8NqxQzP	25278	3NLStcf7DtxkfxboB6T8ffzAtkRxqNUDuB6j877ZeCAjvzuAML4i	1447	1345	482	12463	17099	jxi3MYBCWAdNkAdu9rti5CnbY2wzsNaMwUQCWP8XH47ZoyAyDmc	12540	17636	17636	1619113680000	orphaned
25283	3NLrCofxxkb7Lj9MXQbNzDYZNMa4eqJzdCjpUDngRAZaHCLFAoyU	25282	3NLR78hAj2jR5cmC1sjwwSydKDZkokUby8RSE5CP7Bra2qCHPErd	1527	1167	482	12463	17101	jxHR4tdgKyJm8sd2tqhacSTQof2gPti3x7soCwBnfHEEwqppJa5	12542	17639	17639	1619114220000	orphaned
25290	3NKGiATf6iGVqwtzJDkFgAPrrPiKxSmN7fL88qbBpzeeKbpBZZy5	25287	3NKbM38sgzZ9FadQYXckUqkLhHH7DDcCedvV8Q6wzwLAyA713h7a	1617	1042	482	12463	17106	jwyBEo2XFep6U8idqTuj7Xn3NPbUr2Y8CFJ5Vqn8sN8dmyDBFYb	12545	17642	17642	1619114760000	orphaned
25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	25294	3NKPw8PivuMvVmPhyHQZCqmzduiBY2G4Q2TKo5ojRsgzkfWPAzdD	1560	170	482	12463	17111	jxXZN1d3CSR6oZ2ecyzHUpsgHPZcG6swrhLthn3mrQiehbtHcAN	12549	17646	17646	1619115480000	canonical
25304	3NLhBhdLyvPp5ycfVchfiGdq6pD4pYrp8sGKWKbZ8YEr4S9X7oWz	25303	3NKZNdqSU64cYtXyjaLGJypNB6oszLCZqLyaSmRiQ8A91abJEnVt	1474	1203	482	12463	17119	jxPJFa3j1CvZzLpYTGJkWhGBqpinAwykhjcmD1Y6SUVn9Fkzr3v	12554	17651	17651	1619116380000	canonical
25306	3NL3yWJ2DGKPhRGRkdMS1EdHJLkHM5qARGj3XRw7gi1FHjhahtvX	25305	3NLPwfbTXScYTYFc5HrQYmsWmUyDmvLdCXc7egKU1DWiE47s5BWQ	1407	1395	482	12463	17121	jwYje3KHD2Z1en1v5Bs8jxCvsE56QKbWt6Ds5LZF1anSW9sWkVx	12556	17653	17653	1619116740000	canonical
25315	3NLToFYmM5HiPLVfyKpbzi8oUQMAFEC5Y1p7gUEQ5t2R3s94n151	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1599	1041	483	12463	17129	jxYcmDRf6aCQvzCmZTPYdyzsvh4sanrAHiDp8fPMWyGQkwtJ34W	12558	17655	17655	1619117100000	canonical
25313	3NL8p2QNf7qusNty9pW7qczuJxv6EpZhZMb5Ea9PErdGpydHFLho	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1594	1080	482	12463	17127	jxL4drbCa8q4Hkn5trzZ3ganEoKuTHXEb5FQ4LxYgJUuBmy4eBV	12558	17655	17655	1619117100000	orphaned
25317	3NLFQmxMTQpxRfu9aUPQ5ehoraizssYfP4yK9womFiLU575ohGTs	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1513	1379	483	12463	17131	jxzDPiHyswtVpTbTExSNKuoyhF69n5rp3VVNKmj24Dc6Lg6qQPX	12558	17655	17655	1619117100000	orphaned
25319	3NL9ZqPjEBFNR5yZRJ7Rqtp6QcXJxCGw51J51Lyv1GRu5VtNcWTp	25315	3NLToFYmM5HiPLVfyKpbzi8oUQMAFEC5Y1p7gUEQ5t2R3s94n151	1406	1393	483	12463	17132	jxHoFNmHHbLAeJrYVQgz5FRX6EuCES97UtR75MuujRB4ZFAkBRe	12559	17656	17656	1619117280000	canonical
25321	3NLXbqLBarCmyU12oTruB1QRo2VKB7VxVDx26sT8UDUfRAL4LZ9S	25316	3NLW91y1GwK8jTC8QsjpDYxjCL1EX8SBQKEmPXtdL6dSyY2hVpLn	1607	1348	483	12463	17134	jwHhU6o6ELQkp6tLyCKRuCDC24mDKT5p4GLfiJgC2F7qVVWVzE5	12559	17656	17656	1619117280000	orphaned
25329	3NLRNyKngUascfkh7nLUYBr1MRASaVEE4UdzR63QQpwLSLaeApEx	25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	1631	794	483	12463	17142	jwDFdt8ZMk8Bj5PbKTKKUjmbJ4pLkMjFFPt1zU5emGnpoLfxfg8	12563	17664	17664	1619118720000	canonical
25327	3NKKRt3jx7gkaDHPbfYqxj4yZiDNq3iQ899UKeKgQXovAPovGYg8	25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	1455	1332	483	12463	17140	jwynxqQcaVV9Xehincs9GKUQtC9jh4gYbtQtqy2XkPs5ALttec4	12563	17664	17664	1619118720000	orphaned
25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1609	1333	483	12463	17147	jxgtXaeSFqT3Jasj4oezbeGEk6AJKbaZxP8w8JSJQj5t886idbi	12565	17667	17667	1619119260000	canonical
25334	3NLpqLCgRTJGVA2FwPSBjZKyMWSvA4JHyufYxPQ1GjC1d37EnA4Z	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1609	1333	483	12463	17147	jwyPgS95m6k11kZYQ61q8vqn1Q27uo9eno6o5Gi5iiwWu7zUQ41	12565	17667	17667	1619119260000	orphaned
25341	3NLvGpCVVDAHRdwYqqSHg8Cwv4K9h5kpnsrZ5jA2zCf4EaHWSoEx	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	448	1305	483	12463	17151	jxH5kJLReG51rp2UPvLvVb5KDTqkUDqgaeCgbHSW9hTELDt9gmb	12566	17668	17668	1619119440000	orphaned
28566	3NLwcfvQTCyRoSXEWQsBzhgcSL1Ynkd1ByjC6xek6dT3TPSqJKQa	28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	1631	794	559	12463	18974	jxjYvaWA14xYTsaoYA8iVvZ7nMhkKigfAPxFUmSF4TDpC1YGVBj	14111	19883	19883	1619518140000	orphaned
25307	3NK5Y4YVpinYRZmLq5tPq4WucxqjZpRWM7X8UVPcQKDRag9URgLX	25237	3NKadZLywa7gq4gDsf4Ez7TEgzyjDe4iTsZw2hV1YcZygACRy94n	1523	1075	480	12463	17122	jx2aAJVP1iCS8zofmp1o963pBdysmRsvChipkXQHu2tEaCJSZ3N	12518	17654	17654	1619116920000	orphaned
25309	3NLrPLqQB3EcZtCAmML1w62ZLBrgAUmQwJQhJgDkAHWASwkywbNi	25263	3NKCX87K6xxQiKt5FXE5DA82yWDWDKL99UXERDL62Hh2EyNFCDHr	1523	1075	481	12463	17124	jxCDQR2bW3YHXgMtaDBtD2T43hbk2vFigPJWqskGzkYiTfjz5BL	12532	17654	17654	1619116950710	orphaned
25269	3NKDkEDHGu8WvrRDVSNJirGH3yRCsArney7S5SYSkxd1Q9Ze2oMm	25267	3NLcvchTRgYuwfTSbXgqhKbM56PkPUkjWVTnN3Fezt4xUBFS6Nbw	1657	1344	482	12463	17090	jwdAeJ2rD9dr7DzGMAR9tcraC45JRCUEkmUG7f46PUokoUu8hUF	12535	17630	17630	1619112600000	canonical
25273	3NLUZjbtB6WuzwrYJdr3R8CPegcLpDNnoMnx1vui8L3d5omH9Y75	25272	3NLs5TLEWd58bxtHY4d7FVC6sg4nmcBCu85iBULwcupvpKBdYghb	1623	839	482	12463	17093	jwB9Q6hpo7S3o38Mygvqr3URqd81K6HDLmMzmrbu6JMXV7wupJ2	12537	17632	17632	1619112960000	canonical
25280	3NKF6pk9BKNn1MzZ3ieVF7dwnrAWgJ5n8BbAXThZJgAEYx5Kq5kF	25278	3NLStcf7DtxkfxboB6T8ffzAtkRxqNUDuB6j877ZeCAjvzuAML4i	1587	991	482	12463	17098	jwPuYRcecf1HfjRWYuxphoeWVSxe7pUJ5eVnCWz1bqsYFWhf3qZ	12540	17636	17636	1619113680000	canonical
25288	3NLRnQrTSX7nL2TQEoavMDZPJkrGHXEtNXqHDnTEAYEbF4RCgMk8	25286	3NLZjEEqqpVwq97H3Yn2aKymcWTHxxeZGY7CdRCNkxAuUF6zntjk	1403	823	482	12463	17104	jxeDLmMqaLZfJiby8G5yKD52HsTYudbcu5RxBdRQw6WiXR2dLyJ	12544	17641	17641	1619114580000	orphaned
25292	3NLmK9d1cHQotsuemKTa4XgDene8xHqfBy6BW7X1HWCJg5SrmjAW	25289	3NLd95fkAgM7gbfThKz8rds9i1ZM3DhuxpyWs3TreBEZimxJ48T5	1471	1020	482	12463	17108	jx1uKpcYRqoBBCyi18G53UuggqeFo5G2zKoratnhuyJ5W7pniCJ	12546	17643	17643	1619114940000	canonical
25311	3NKxTLbGKzeUooT7iyUzLa8SXhXgXZEaPtqp4KWsZ6L6wxoVK24g	25289	3NLd95fkAgM7gbfThKz8rds9i1ZM3DhuxpyWs3TreBEZimxJ48T5	1523	1075	482	12463	17125	jxVrEn69L3XkzvsGamn1QNv9rfy6jxyV4mrQY2kdWRsHR4KaHUn	12546	17654	17654	1619116981608	orphaned
25302	3NKwomK8hmqibSRNj9RMUA7d2Wviyq31mCe5rEu9XT15uxwjf6db	25300	3NLrCgfuP27kWdA5TBQdF6vJXzPJBETkNVNJQhNUYccUj5Thn7VH	44	1079	482	12463	17117	jwzeimVr41XVbbJ8W9cZfwSZ4QpfCgRpawZdZyTyZr99qXAZasB	12552	17649	17649	1619116020000	canonical
25314	3NLeYN6qVNXXQLHzouXEhcAXzVz44hnHTTTZmpYTKDvuQDhTgfPF	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1608	1043	483	12463	17128	jx9Ec8f1PX9rrJFJBLMAFWEqWA6HPaaHQGnCWKB9TBwYLXJn69e	12558	17655	17655	1619117100000	orphaned
25318	3NKC6xTh7dxMMMAaQ5GCVhMojN9kyAhA8fpApsgtMaZ89sRWT3MN	25308	3NL4xhW6hyQJmd22xpjhmPzHm5tqz7Fawvf5jj3TQDN5NmHgZgEP	1594	1080	483	12463	17127	jxUfgmzEgVETU4Zo2NbAcrkdvKhWt2Q8g31SBGrdMPPYQpBUU8C	12558	17655	17655	1619117100000	orphaned
25320	3NKz1SaUN86eF8AKEQRDtVceh37jdnKMxE1PnDbfgzwgizPJHiTG	25315	3NLToFYmM5HiPLVfyKpbzi8oUQMAFEC5Y1p7gUEQ5t2R3s94n151	1607	1348	483	12463	17133	jxjNDcLGUddNZCFk5MdLdSUfh2PU9Y1JK4u4RwACL1D3qPTWXRE	12559	17656	17656	1619117280000	orphaned
25322	3NKjy4kiFT7d1eWEYrhfPqvzxjyRasATNRGKRuPzrMEipw3AxP1i	25313	3NL8p2QNf7qusNty9pW7qczuJxv6EpZhZMb5Ea9PErdGpydHFLho	1607	1348	483	12463	17135	jx4SyZ4Bw3N1J5cUkgcehFdoWRmgu6JJdfmAGeGX8GWtitxHf9v	12559	17656	17656	1619117280000	orphaned
25323	3NKBsrKV7BRtNXxiGThkEVUBvtunH1f8yBdHKyEWh5Fu9SFBEYne	25319	3NL9ZqPjEBFNR5yZRJ7Rqtp6QcXJxCGw51J51Lyv1GRu5VtNcWTp	1406	1393	483	12463	17136	jxQdLjzg6B42nKpFsJwCDpeuVJjiP8S8XAjP6BqLvHHqeLJEPAc	12560	17659	17659	1619117820000	canonical
25325	3NLFzYX8HA78uuyDefgLYoija3Fx8YEq8oZn2TiLGWrj451EDG3o	25323	3NKBsrKV7BRtNXxiGThkEVUBvtunH1f8yBdHKyEWh5Fu9SFBEYne	1406	1393	483	12463	17138	jxYwAA8wyFqBxfYWeLuYMv8ZD5D3vajKGJcJNJEBUbxqiN9qbpg	12561	17662	17662	1619118360000	orphaned
25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	25324	3NKW76Wos4AyzzWXAsfWQHMHboDJcYPkozQStJPYdtZn2ECKjJRz	1476	538	483	12463	17139	jxGNxaYradL78d6V3N8qtEYU9vACg1G2fSt3ujft1SujCUoCUVf	12562	17663	17663	1619118540000	canonical
25328	3NLDhHGGtXUH7nj4ciWvKMMHUej7noACa9nye2bSPHTtsTb5AGMi	25326	3NKYqKutn85zqgVoJW83ViLThTCehJbcF2VeSspPUGLVQrMc6j9b	1578	1296	483	12463	17141	jxcQHDgdHgJYYs5cx1DEANNW8XPZJqNFp79iazdznkdFniQ1LB1	12563	17664	17664	1619118720000	orphaned
25330	3NLJApXcJ3UeBKrFi1rS5qCb3CWCP4o2L6wGcCoRQ8qE5hpgTicu	25329	3NLRNyKngUascfkh7nLUYBr1MRASaVEE4UdzR63QQpwLSLaeApEx	1460	1324	483	12463	17143	jwdjjmPUbVBu2D3osaTGEVD3J6PH4PjKkekChtXnaeesgXhF832	12564	17665	17665	1619118900000	orphaned
25332	3NLv83SXu3v1vC8mSaEawBkLXZsRPinaHdn7Sh4bg2aNoU6AgUDq	25328	3NLDhHGGtXUH7nj4ciWvKMMHUej7noACa9nye2bSPHTtsTb5AGMi	1460	1324	483	12463	17145	jwfPibPYSGMhZ2aziMoGJxTgeZAj9F3LFsjKGj8mj5nFZb96uuc	12564	17665	17665	1619118900000	orphaned
25335	3NKakiG79zFRHiQXJGaYgccdjGDao4RyT1jE9CuC6nC4nS8FF33g	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1406	1393	483	12463	17148	jxvfEQDrXgTfuxWV3KheygD5vxo8ENk5GeeUepX3FfG9wbZryxu	12565	17667	17667	1619119260000	orphaned
25339	3NL9cg27JhsiM5GQ9kJQq4t83ncZFBTZC2CJofUD3yDnnfTykL7c	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	448	1305	483	12463	17151	jwaYLmArzATcWWr7wET1anvtYqsAAxBBgcfL6DJRDS5pi5rCH5m	12566	17668	17668	1619119440000	canonical
25345	3NKdoFb9jQKqExQ3aYPm9grv4D7Qr9WxvrcmViUinHEabUBDJ3sP	25344	3NLAdZjrJ1An2xR5nk46227pgrSfHYuUmzut5ED2sL2EUbafbtpq	1407	1395	483	12463	17155	jxvcoVbJATyAqmDnMR2Gkmiyp9P65hRLD5wsL4piPZpZ7Z1NgPT	12568	17671	17671	1619119980000	canonical
25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	25345	3NKdoFb9jQKqExQ3aYPm9grv4D7Qr9WxvrcmViUinHEabUBDJ3sP	1643	1173	483	12463	17158	jxYB1M6863viTYvZVABFPziTSTfKa4qCfSgrMVyHjQndJ5Dbiqk	12569	17672	17672	1619120160000	canonical
25352	3NKQvwxZoRDzUEBWykNpuksnKkwfSn2XVQHdU8ZWScpSgTW77y9s	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	641	1210	483	12463	17162	jx66TqsFnUCEWbjqCrL6UfW8g8gM5B8Hapn4DWywADEHweBMxT5	12570	17673	17673	1619120340000	canonical
25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	25352	3NKQvwxZoRDzUEBWykNpuksnKkwfSn2XVQHdU8ZWScpSgTW77y9s	1406	1393	483	12463	17163	jx4ydt6145Xuhu2m8gDPkoPTdXA6LnxQZMQA2rfz4TDyhtm89WL	12571	17674	17674	1619120520000	canonical
25364	3NKH8CinkKwVVCM6qGskkoeu3cUK5BpmMkfefmTKpzTRSgvCR7wq	25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	1559	1227	484	12463	17171	jxQT3oBaEnN4hcDFyN9dfE6gtVZ3x823mWHPuacxv6RU5tammyP	12576	17682	17682	1619121960000	orphaned
25371	3NKMuz6Q5Z3BEmLqzRQkLmMkDpdcF1UbKA6mBM7mwzegtPCnhCvw	25369	3NLf8TNnoVKMf6h6LSUpwUQiQZ9hLdj2GRt1wL79jx3n86ywuvXo	1601	1262	484	12463	17178	jwW28ucRmsmrYFNUE6zJexsPBi5BZHGTTKvUR8rqitCqPyRCXJM	12579	17685	17685	1619122500000	canonical
25373	3NKTxjVL4EQ9rcFmjXsjuMzB3eQH3vdy23xFWJTWP9kF9q3hnJaG	25371	3NKMuz6Q5Z3BEmLqzRQkLmMkDpdcF1UbKA6mBM7mwzegtPCnhCvw	563	1359	484	12463	17180	jxvT42xU8zfmP8SkauYDF4z69nViE8QScncghSqwJEVhvB9pcFQ	12580	17686	17686	1619122680000	orphaned
25378	3NK9gURinP1LVPGUtMnpksxrySCwts96FUpbXyECMxSqy1x3H8kS	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1522	1322	484	12463	17184	jxR9hP1b1B6kpeFfjTPHfsYosXbQUJ836WMYSZZrCJpW54tgjWk	12582	17688	17688	1619123040000	orphaned
28594	3NKozTc6djWtYo8eDegmw855TQuthRgsCU2AoaHLMRmKnqRE9VsY	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1541	1172	560	12463	18974	jw9x9KaLZpTYy4HeAymvR2GPAdszNJHvPWJ2a26nr21jrE3jJqd	14121	19901	19901	1619521380000	orphaned
29490	3NKQQB77z8s9gtk1drs4ds51XKMQKXzwuX8pnphDUCSg5tfX7Zy1	29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	1611	1341	580	12463	18974	jxqaCsJyHMX1a3EeoajrQ4sCProVY7BXpdL4Enk2mpPGadvN5Gw	14541	20469	20469	1619623620000	canonical
29607	3NK3kNSQcPszYbWvzPGgdJGfBKorKphDY1gDmcBzXeUQLFXAWv5b	29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	632	1382	583	12463	18974	jxKGemXsqZVEBp6n6WJg4BC56qVpnudcCRpqRqkjh27t8Uzq6WY	14601	20554	20554	1619638920000	orphaned
25351	3NK9cGq1bR8mxbpdwFPhF67vf2UbbSTURd17TcWd1voSodEUkonr	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	641	1210	483	12463	17161	jxSzjAJGdpYTuajuzP39VkMg4qy16wzbq41nVnGvnjQ6eHMpQzp	12565	17673	17673	1619120340000	orphaned
25337	3NL7VP6rpqMYdRJaRp1qj88HrP2ouozmcZTZ3D9R3EFmsXeyoNxk	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1405	849	483	12463	17149	jxiGPGw3dWJcVkvtHqao3J9ZHPS6FLGkSatP3BzEoMk5h7gzU8E	12566	17668	17668	1619119440000	orphaned
25340	3NLqq7rJzEC5C7h7QW1XioaWGzH4Q2gBWx8bU24ea1Cp9r4tYyzF	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1457	1025	483	12463	17152	jxE1fd3tNhYPJqCuCu8jFcoLbeg3tKrRh6eKL4Byr3vU4xqeoHS	12566	17668	17668	1619119440000	orphaned
25344	3NLAdZjrJ1An2xR5nk46227pgrSfHYuUmzut5ED2sL2EUbafbtpq	25339	3NL9cg27JhsiM5GQ9kJQq4t83ncZFBTZC2CJofUD3yDnnfTykL7c	298	1308	483	12463	17154	jx8zMDDQTxoA4LqMfCjuRsoM9pEpb34AfNVBZP3GsKi6MGeWsnF	12567	17670	17670	1619119800000	canonical
25346	3NLB1Hrzz2fSW31AkECLLG7TDsPFLMQseyD5Xypyec8RfYV18q7D	25344	3NLAdZjrJ1An2xR5nk46227pgrSfHYuUmzut5ED2sL2EUbafbtpq	1402	874	483	12463	17156	jxyvx2e6r6ogHp2Ppg9oXkwbPQwtTy9xNHFvjbLRnMY7J7qCdrA	12568	17671	17671	1619119980000	orphaned
25349	3NKu9nz1UhBMFw9EJ9JSqr9vZbCEGR71Rs4saDV3vzsY5LTPjMoT	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	1642	1367	483	12463	17159	jwoBWvQ3mCrDZ2U5z92bVMjMzANz1o2ThYcknVh5TfFjHNFazG6	12570	17673	17673	1619120340000	orphaned
25353	3NKWbCuRAebFGNZ8JuyoWB6CfHXuhSbPg2vPrgevht9ruvWvATSF	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	641	1210	483	12463	17162	jwC92umhH3WqCK8J8GzZWZfsenhAFKtUV2bSLh4SZYshcYDx1V1	12570	17673	17673	1619120340000	orphaned
25355	3NK9EKyNtsbgd1RTi4f8YGVzDuc6hjWtEDASJCXYbp4KYJR1YnDg	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1522	956	483	12463	17164	jy11TVbMoTEvfx6FECZdkcNipuEHqmuDp8G2swd3FMTW5NG7jWB	12572	17675	17675	1619120700000	orphaned
25356	3NKCFce3N9VpGto1o3yaqYK4YSFDcsrMWpijSjQq21V41TGp1pv7	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1522	956	483	12463	17164	jxRhmP3y9ZiFEeWEK2P1EvLvCYq6jdTsFH6K2xH29nkc7uFShzF	12572	17675	17675	1619120700000	orphaned
25359	3NKQg7kGwK2hFJmSWxMY8h3E4o3FAqXj2HEEH6k1r4aVVj6QctCB	25358	3NLqg1cmT6HxaeLWZiZ6xsDZjn4G1CmUH9GY6VCrzLhg8A4JBDz6	1581	778	483	12463	17167	jwZySwXVPnUsJV3GE6r5U78SyH7jghZpEoWZ64hzhvT5rbiQyDK	12573	17676	17676	1619120880000	canonical
25360	3NL4bBJT88ezdwijM2PoAcmhjmCdadP8ViJPtja4V7xook1bTzik	25359	3NKQg7kGwK2hFJmSWxMY8h3E4o3FAqXj2HEEH6k1r4aVVj6QctCB	1406	1393	483	12463	17168	jwTiP9qfcyRFi2M2DPhmqBp4UoDrfDKCyyccXSPpFHvFPXLNC7X	12574	17679	17679	1619121420000	canonical
25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	25360	3NL4bBJT88ezdwijM2PoAcmhjmCdadP8ViJPtja4V7xook1bTzik	1419	814	483	12463	17169	jxPicfJGW2P6Lh7GwReZJsmhN8CYX9N3DSW8j8Y1EYRz4toyWcs	12575	17680	17680	1619121600000	canonical
25369	3NLf8TNnoVKMf6h6LSUpwUQiQZ9hLdj2GRt1wL79jx3n86ywuvXo	25368	3NKNdjeSwpuoXjXkdZAVYviM1t5mQg3Yo2ZBL2pCwTPT8a9UpvrR	298	1062	484	12463	17176	jxEBLDcpketR7UAkG1iQ8yTixNr9EGWGeGnSzXF973UzJeJxVb9	12578	17684	17684	1619122320000	canonical
25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	25372	3NLF2NiTNGiyizGzV2fnx6s9ZygTAdp6ZcxPAK9VS2G7xjEVSHBH	1403	824	484	12463	17181	jxpC8Wt5vpfBQaPVLAhGR3sYa2UnWwT8cyxXBAvSN4EV4uKNtZk	12581	17687	17687	1619122860000	canonical
25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1448	945	484	12463	17183	jxwizm1QqCdudaxVH4JBpmFSdRSVStjReWwLUxXs8iwp4PgAAQ4	12582	17688	17688	1619123040000	canonical
25390	3NKqpHX7jocL66L62mfXZ1GGHsSzRfxPJ7otCLwchLw6eFyD3aq3	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1675	1342	484	12463	17194	jxajc9D2dhcgnWoRzM2ZsSrdrUQnFSRXTwFpEAc3582k7izRcq1	12585	17691	17691	1619123580000	canonical
25391	3NKFqynH5kAbAjXeEPN9VpAETCMboUJwn2giS8ajVWCriYowRfPo	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	576	1355	484	12463	17190	jwfq7EktNGdPTJ82W77svdGnvtT7UAB4cKM1YECm8djceJwdVrZ	12585	17691	17691	1619123580000	orphaned
25428	3NLm8iEBiEe8AhtWrDVbMD5Joi7aNFD7EmJMjhjwZxySJohVbjVm	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	298	1308	484	12463	17227	jxF1f2QJnX5huEhuCuDUh6pJNu1sUMSf21UVT946MKPVh8XxqQq	12585	17711	17711	1619127180000	orphaned
25393	3NLSxpjmw1vGmG7CcvyjbWV5Yyf4VnsEKh91sUTGF3JD3EPF5JMC	25390	3NKqpHX7jocL66L62mfXZ1GGHsSzRfxPJ7otCLwchLw6eFyD3aq3	1407	1395	484	12463	17196	jwE6vuptCPWj4R7M8NPboa9zy69SjEr813BXh6kivQ52WRCiwzG	12586	17693	17693	1619123940000	canonical
25400	3NLvKig621KSciPq24kCdbzzZ4jZEP7GReUiUs2jC9bLkg1virv5	25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	1403	824	484	12463	17203	jxaoqzEqLkbuCXUGnX5rDuiBWjopMzkmVxQh8yTRSgF5g55DykM	12588	17696	17696	1619124480000	orphaned
25423	3NK3UGjZaipuPxUi9FNeste1tojCw7mgdoAs7x4JNsEtJYtdWAxQ	25422	3NL3PCaZeq63pbQTsEQSMUB1aKU9qJWggrWzxL8vtaVwSeMFwWnc	1407	1395	485	12463	17222	jxEB8nRTwNDhJ9Cc2otpxkkT4JzyQo7XNRg6fG9L1yUzQz5sbj7	12598	17708	17708	1619126640000	orphaned
25430	3NKasDyaYYF5RK8HCjt8cCHA1FmuGLcLQNLWdPw7Wp32tSZZSZUB	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	1498	353	485	12463	17229	jxMBi2qw1t3f8rCE6zSNXVbFakAL7qXpACaYiEczzcuyE6vvv6m	12600	17711	17711	1619127180000	orphaned
25432	3NKHqDp6qB1nRqKV7WhuNwuNPYdRD4VUpEQT3YC2MTsgi4yGSpEr	25429	3NKLnBYLdzRN6F2S53uBVMUHUVd5giA3vyJUhsfrbpReZXC5h587	641	1336	485	12463	17231	jwcSGXS5PFecCWYcETWzhd1h6hxfip3wGLHbQTpeHB23Mt3RUkE	12601	17712	17712	1619127360000	canonical
25435	3NLS7CRG2ZNE7RaYhRTuk4gGeE8UobTpvQAsZCtwWUn7m5AU8dTm	25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	1587	1111	485	12463	17234	jx8mXFwDkC5QH2XFn7d3AjP4HW3oK4FAyHoAdKzVzrVVWSWe8fs	12603	17714	17714	1619127720000	orphaned
25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1541	1298	485	12463	17238	jwuU3FTjRBnwK8yn5L4JfvaZmxUpPGnKYptV3Sg2uj7TwZ6dsyF	12604	17715	17715	1619127900000	canonical
25439	3NK9FPeTdyZPzTN4sWhGFkRhvJMbLkanzZWb4aVRyPd5fd8nQGpc	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1541	1298	485	12463	17238	jxMSjd7Gzz3MKutSfJS2rjg3fZM6emwR19ymRXcFW6WF2aaJjJ2	12604	17715	17715	1619127900000	orphaned
25443	3NKgQLLshGdGAsMmdtfQ1PGsBEhekGP1JJniMLLykqgcS6YjWDGj	25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	1406	1393	485	12463	17240	jwj14FmZY3Azexv8EQRuaUnLHdffnoPJw4LQuqrCjVMVDqutExv	12605	17716	17716	1619128080000	orphaned
28620	3NKoXgDvBsXE41XrQRukFdL1in6acVPJURMVU7usDZNgUpGEYEyK	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	1675	1342	560	12463	18974	jwVx2pbffK8muQPF7CVtnppJQcCE5aLNxgBG8LnfjC78Wz5uWQA	14132	19913	19913	1619523540000	orphaned
29522	3NL9KpLXLyFZxoNVLB55g7AFnvgNHcZKesPEa6TuEv1ywavZj9Li	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	1564	1338	581	12463	18974	jwxjRw8uEjQzaBtqoPw69BX6o7SkNmbcBfL3GCCeF7njnU1VjDo	14559	20494	20494	1619628120000	orphaned
25347	3NKxLcAkDsuejrJ1ZJSYfaDsJ3wRQWcS5mAENpdaqo1cok1WHQ99	25345	3NKdoFb9jQKqExQ3aYPm9grv4D7Qr9WxvrcmViUinHEabUBDJ3sP	700	832	483	12463	17157	jx6fmdNiU2SsxccDSKiTAEeAxEdf6W2f88c1uTcFfGaHZfHwf4N	12569	17672	17672	1619120160000	orphaned
25350	3NKwRjLJ2UyH3hZtg5GXGkrL8Aj2qdNT8u8uveru1m6EjGuh8iRR	25348	3NL4bxBjTA1f3wCUAAKc68TQMPyhqka8ytfoCpC1fizzJUZ2Apyp	1648	918	483	12463	17160	jxCy4hvnayKCXyXgxWS3jRedExjgdwMEUdeQuWTNsRAqRK5tczr	12570	17673	17673	1619120340000	orphaned
25358	3NLqg1cmT6HxaeLWZiZ6xsDZjn4G1CmUH9GY6VCrzLhg8A4JBDz6	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1581	778	483	12463	17166	jwHkWago9uisi946aAAQvo3DaDpEXmKv8yuNT8d4uYxtXseqsFV	12572	17675	17675	1619120700000	canonical
25357	3NK6wTRKMNYkUSg6HN8YbvGTmmwkCL8j1pdB2jviTDV4UfiE67Fz	25354	3NLrJPpe9Fvr8eqRev5fu5P8RrndvEQ1QyT3noYkm5YEcErnBBFS	1670	1036	483	12463	17165	jx6MsgWQszBEodbYwwWDmgs5xv9bmRvNbBFW6pa3YQ9f4ZsKczf	12572	17675	17675	1619120700000	orphaned
25361	3NL6TLQbWX87E8kfWeFbiSSKth8nSFfNEm8CntyCTWFt3u4p3xvL	25360	3NL4bBJT88ezdwijM2PoAcmhjmCdadP8ViJPtja4V7xook1bTzik	1419	814	483	12463	17169	jwBNG1mZ1Np3srjXRcri9GmhmQpzBxeAuah6WHZAqwXCtk2HCdG	12575	17680	17680	1619121600000	orphaned
25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	1406	1393	484	12463	17170	jwFJRGaC2X2sJ32puowF44oNFtocSWqVMwMbUnAipAFrsqXNNw1	12576	17682	17682	1619121960000	canonical
25368	3NKNdjeSwpuoXjXkdZAVYviM1t5mQg3Yo2ZBL2pCwTPT8a9UpvrR	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1599	1161	484	12463	17175	jwVyYk2yoEyhcDQG3x3nUHES8XS79KmfsMSnV8UpneEqgAi4Gg8	12577	17683	17683	1619122140000	canonical
25365	3NKFbR4CQpuPDYfgW4cu8VacGdSgTj65bXh7d9HXm72kRsE76U6q	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1407	1395	484	12463	17172	jwgRfvKcxWEYNsePicgC31vLCp1eFM8rwGMQtFpQm7qdQBfmbvp	12577	17683	17683	1619122140000	orphaned
25370	3NKVtUJuTFY9JSLWyydx5NCygXpz4HXPUUbUKV6YKg7eWjEf9Qpo	25369	3NLf8TNnoVKMf6h6LSUpwUQiQZ9hLdj2GRt1wL79jx3n86ywuvXo	1553	776	484	12463	17177	jwz9S4sM5w8JqVwLc3KtFruDrjgJ74P3PhLsXKnM3yHJsatB45y	12579	17685	17685	1619122500000	orphaned
25372	3NLF2NiTNGiyizGzV2fnx6s9ZygTAdp6ZcxPAK9VS2G7xjEVSHBH	25371	3NKMuz6Q5Z3BEmLqzRQkLmMkDpdcF1UbKA6mBM7mwzegtPCnhCvw	1406	1393	484	12463	17179	jwvvvnjM3guDwisSXJVFsV8LK4efefsAsPCFHhpDVz4yfMxXBJW	12580	17686	17686	1619122680000	canonical
25377	3NK6jLvYd6iVqxUqEW4o99Qf8D2P1G83bzRvPNFGMrEJRvgUtVmD	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1522	1322	484	12463	17184	jxuYRZV3FhuPfBDihWPKwroVCJ3g6qwsKCqfLAL1QMsviJhio7e	12582	17688	17688	1619123040000	orphaned
25379	3NKtuGeC9HmbnWHaBTH9VhSPCf8KcxMG4vfU1pxYqeXeFVGUvegN	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1448	945	484	12463	17183	jwrCGpJ2Ycnvky6gEXndgtt8rj894W6kfQeCQq7eYQVusDSSEJz	12582	17688	17688	1619123040000	orphaned
25381	3NLEgtrZtMx5Px474KedGA7o3wPLipb9iXrE16PbB4RsN9wUC7Bq	25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	1471	1260	484	12463	17186	jwKLLRDX8oubV6gtppHqbv7PxAxDeysQfJAJBaawfb47kPzMid2	12583	17689	17689	1619123220000	orphaned
25383	3NLq6aYWYEb6QMdWrfcwrXw4BkETKSPWqwRdF17156sVBVSCJ94Q	25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	632	1136	484	12463	17188	jxUT5it8sKsKVEKouPw9Qj9BHpPkJoJmpupN4VvwMebancPCStK	12583	17689	17689	1619123220000	orphaned
25385	3NLhXjSvTUGH6aV7fv1xR7aohz4KT5q8dt4jRxF4MpzRM6tnPAjF	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	576	1355	484	12463	17190	jwWWTCiFTWSFpAenJkoRjXWtfY2pf3kTtdpXWFw4P4kSW7nphha	12585	17691	17691	1619123580000	orphaned
25386	3NKa6ahGLv4TFeJXQ9yeT7iKAsxatffVTH3ihjtAKJqju12QSDhK	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1529	1190	484	12463	17191	jwKKGoTmCBxb5ubRZ8kGccwK9fYTMwHakM9iaEfcsnqKHULdsg2	12585	17691	17691	1619123580000	orphaned
25394	3NLUL44v9549SQ7dBdoh9crU3CaPpX924RAFZKvqd4bVx7wRJYHs	25390	3NKqpHX7jocL66L62mfXZ1GGHsSzRfxPJ7otCLwchLw6eFyD3aq3	1507	1034	484	12463	17197	jwK2EthQ1nXJuPGxPPjwKw4SWRDkWLaRoAfy3wobyqnEZsmQbdN	12586	17693	17693	1619123940000	orphaned
25396	3NKe3BMLqbATYrH6JpM1DRPRk8EamL994rtK9e63RgPdrYYcqSqX	25393	3NLSxpjmw1vGmG7CcvyjbWV5Yyf4VnsEKh91sUTGF3JD3EPF5JMC	171	1374	484	12463	17199	jxaVRUfUGKoGxM462UeUuXJAPeTNWy6KbdBQaC5P1d2LuH3UsHv	12587	17694	17694	1619124120000	orphaned
25398	3NLvEvkc4FfunFo4XvdhNXknLzF38UBjq7ELjosfnMLZSyefehJG	25394	3NLUL44v9549SQ7dBdoh9crU3CaPpX924RAFZKvqd4bVx7wRJYHs	1578	1296	484	12463	17201	jxTiQa9WumgUVqHqeGDuXGZKQ5pNWPuMX1y1o69EzHFZG7CaZEr	12587	17694	17694	1619124120000	orphaned
25403	3NK8fsfdbXNA4kUwVw7BuuMtrYZ2XQnxD5Wia2B6hBz1rdmu2fz6	25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	606	1049	484	12463	17205	jxR2Lh6b4FhjWLwBi29nmr9ZGD535xZ3a4LhPBcZ8ecdr9TFLfE	12589	17697	17697	1619124660000	canonical
25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	25407	3NLH9Ja6GPYeupd6d86UjhD25C7LQoTjzyzTBD6LUp8YsVk87Svc	1647	1056	484	12463	17210	jwDX8V3hT2HqFAahMozJQsgaHekwJHGm2nqfqpjmPatas1rHNv7	12592	17702	17702	1619125560000	canonical
25411	3NKuxgcpX1scF63Pz6oxvCv3jqMPCnX8eTPjzLuzFTBhX1cqg641	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1673	1368	484	12463	17213	jxkZMSfHMiGg97MLn6tFxvv3XdgT5fL24jJcRB1UXkGc8dfTipj	12593	17703	17703	1619125740000	orphaned
25415	3NLEzD8a1EMEm9yaGHshzoRhSdRnLvPqk6sqTkKdFagHVfgNZ8vL	25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	1501	1360	484	12463	17216	jw8ea2sJxEuiSGtpAnP3aszTCLHZy6C5PeU2Py77r5pCx4jRv1p	12594	17704	17704	1619125920000	orphaned
25417	3NK7Mf7JDzJx3CjjhqDhicwihZ5iPTy8PRTCxQJJUsrW8RTKCCZ6	25413	3NKAfT2yEsKxhourbvNtN3gaAmK7ptDpUthnLyq4x2UuSzFAkPM6	1439	1033	484	12463	17217	jwuC8EdeGw9ZzACH5BV5EGBfAg1SAcjeqQ7HHdvDcih3zM92aQJ	12595	17705	17705	1619126100000	orphaned
25419	3NKq9GfbEAjBGkxv2EH75a8XtYa1AdZ2nokQGccP8TCGoCZPeZE1	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	526	526	485	12463	17219	jxVrmdtnZy1z9VYXC9NJHSdX5oWdSAt9g8uCgU6WNWV2JHxPhSH	12596	17706	17706	1619126280000	orphaned
25421	3NL6dVeSnguEgEZ27AmHbqKrGxvKHqTZJWSEExxmjm5yZpNp8Jqt	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	526	526	485	12463	17219	jxVRCDiDd6UaSPVUaRjAoWAZnsrm9W1kJnGVbsBSj16sHSXygFY	12596	17706	17706	1619126280000	orphaned
25426	3NKkrPFux3dgnAV9bASYs13sHWKvhFqgSL9dtfiZjS3bunG5sdq6	25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	298	1308	485	12463	17225	jwqHV1QGFJsoaoe5qRMcbCoBbHWN3GJLzsoZATZ5g6qtZP4GWj7	12599	17711	17711	1619127180000	orphaned
25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	25432	3NKHqDp6qB1nRqKV7WhuNwuNPYdRD4VUpEQT3YC2MTsgi4yGSpEr	1675	1342	485	12463	17232	jy28YrGjvnVJ9uUoVq5Q6NWFREGotkxHmPr6iP19Nx9ot5FxZGU	12602	17713	17713	1619127540000	canonical
28640	3NLEHafGSGuu3s1D56EiYG6KsgdKRfYipCXedLrGNwr5YywXMreA	28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	1406	1393	561	12463	18974	jxiEk6aVmcV4BL7USEndEFZAHHU7rhuC9FZL15S3KR17nDFD6xJ	14141	19926	19926	1619525880000	orphaned
25397	3NKUuACBS6BsVSm7vdSyAe3rpoTjNkcKESoYSqzj8X76kiW1tGhQ	25375	3NKNdXBeeAWpBz2B5GubkQcHwJYFjiQz2N4pjJkPhQpkKf9F7JFx	1637	816	480	12463	17200	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12474	17694	17694	1619124120000	orphaned
25458	3NLqMobDDCLrsnWRYVJUApLmnXTYeuQAKJkr5VxGWggULBdSELrP	25372	3NLF2NiTNGiyizGzV2fnx6s9ZygTAdp6ZcxPAK9VS2G7xjEVSHBH	1419	814	484	12463	17252	jwE2ph8CcWjCtXr828xukMj79cPbnVQP5kTQ9h1U6xfpWpeZbbJ	12581	17722	17722	1619129160000	orphaned
25380	3NL64YqErMrK8APAknKstBghKSRYvoFqYHHA96JFf9oWG5vomsGY	25374	3NKttoboEE4ta6eVo5S4yS5ARYZnSfdcFd4r4paYgNALDgCCmfT9	1455	966	484	12463	17185	jwhEVotyRvFftdEKbPG4boT4nAjA8vVvHn2DipjgVJpwPzNqHrz	12582	17688	17688	1619123040000	orphaned
25382	3NKvvS6DnYhpWc5xPrQGX5bESnztbTA7N2UYPcpz3JLZUug8MHTg	25376	3NKzamb5S47wu6e5FUbWpktB1FhCqSCwD9ayUeEJmN4gKdDs8vig	1553	776	484	12463	17187	jwmvSwSSgRq43TVqPvz8ej2Au9L3iT1pcaFo2k5sq1QS9EvEJ4D	12583	17689	17689	1619123220000	canonical
25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	25382	3NKvvS6DnYhpWc5xPrQGX5bESnztbTA7N2UYPcpz3JLZUug8MHTg	1403	824	484	12463	17189	jwhFM43r486uAanME15UCzwCPFZDtKyqYDnfVuzCur2cYrhoFoj	12584	17690	17690	1619123400000	canonical
25387	3NKuCGJVmgK6q2qzs5JhuYwnisZYhMiSfLFQpyqFTdRbyqUrUjXU	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1483	443	484	12463	17192	jxYmfdb8H4MNtz6FUZWomr1CMqkXkFU8nPvgMH9cif2NSzgfEW2	12585	17691	17691	1619123580000	orphaned
25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	25393	3NLSxpjmw1vGmG7CcvyjbWV5Yyf4VnsEKh91sUTGF3JD3EPF5JMC	1578	1296	484	12463	17198	jxgNK6Rh5XMdfwoJQBKRt4pVWZ98KzBrEyxm56vVFM2h3DrL2ew	12587	17694	17694	1619124120000	canonical
25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	470	1309	484	12463	17202	jwyiCX5pSnb9TJMGQBaN1wgBJfSmQhiGL1H24VzYBGmrRzrHJsS	12588	17696	17696	1619124480000	canonical
25401	3NKfp5VQDNi6AK1oB4vCCs2xrNBdStGH5rd6hNpsnx8tjGRq4Q2x	25395	3NL8q4risaBbrwaq2tvnAijtyUngytfjMLxQh9QgN5gUnm76pvP7	470	1309	484	12463	17202	jwSzQptWqe4gNiR77JF9ck6ZcQ4jYpy6x235gTdDwrctBUogERn	12588	17696	17696	1619124480000	orphaned
25402	3NLe4sWdZSqZraBNk2DMGWbX8eXNdzWinY1rpfhuH1XyAAZvY2ZJ	25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	1602	1243	484	12463	17204	jxtqvhCavWRdnzx2dpJPHM9erJGChAkmTLra6WatxkyfxbH5t5y	12589	17697	17697	1619124660000	orphaned
25404	3NL9GLK2wD5soUv5qhdxx1HQk7X9BenhNsaigmtELAxS456sxAPF	25399	3NKfEz5mdnD9V2DjPGyaBW5RTikH9R7e1WPj4ytW9VAtKKJYzNGi	532	1177	484	12463	17206	jwjRajhxrdLxuZav3s2Esmc6xafj5nAhwp9T1FWxXP9jmeoxbei	12589	17697	17697	1619124660000	orphaned
25406	3NLJSGjzmh6niehqiGhEvpvxAsSQHHtFH2uEPsVwzkqYwjFoEHNM	25403	3NK8fsfdbXNA4kUwVw7BuuMtrYZ2XQnxD5Wia2B6hBz1rdmu2fz6	1406	1393	484	12463	17208	jwy2b1vux6Vm2HZ27fuipHh55V8mDLi3erXsUH1WasYGi2EX5ib	12590	17700	17700	1619125200000	canonical
25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1599	1161	484	12463	17211	jwdKMy11trugNED1euTzhphx3MCDH82q5Zd5hxxjKA6VW6ngpYg	12593	17703	17703	1619125740000	canonical
25412	3NLajTnDgfQernYc98EwirKcwpjJ8c8WKBaWePHTzHCk9qytrNN8	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1647	1056	484	12463	17214	jxhCappsWpwGy8xyAX8vsisDA17yDZYuhQ46Asm611e8E3q7tzz	12593	17703	17703	1619125740000	orphaned
25413	3NKAfT2yEsKxhourbvNtN3gaAmK7ptDpUthnLyq4x2UuSzFAkPM6	25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	1422	1337	484	12463	17215	jxXVAWswnHydzXzb1BS9rC8GJ1UuDnWr7UmHrG44bQqPLgx9Xkq	12594	17704	17704	1619125920000	canonical
25422	3NL3PCaZeq63pbQTsEQSMUB1aKU9qJWggrWzxL8vtaVwSeMFwWnc	25420	3NKdud34BZ2zm25BNfheaCjywrNrpFZeQ9w1fB1tQyCpkYYmtuRz	621	621	485	12463	17221	jxHdJdcSCTLFUKzzZD3qTUvQKzpmNwFGRYLEcwVRZYvn7o6VCo8	12597	17707	17707	1619126460000	canonical
25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	25422	3NL3PCaZeq63pbQTsEQSMUB1aKU9qJWggrWzxL8vtaVwSeMFwWnc	1403	824	485	12463	17223	jwx6gxtNpUzJXexsxaTvb9U33BDwQXWkhQyZupr7Bozm8JRJJHD	12598	17708	17708	1619126640000	canonical
25431	3NKBwCHhLdbmmWC6HFnx4oT72AUfyGPhwbSh8dcbSiu2MbRMmf3T	25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	1481	790	485	12463	17230	jxwYjFstWfyWx3DLHVKxJbXGpZetXD9chcYcgMjJ4pvXhCy5jeL	12599	17711	17711	1619127180000	orphaned
25429	3NKLnBYLdzRN6F2S53uBVMUHUVd5giA3vyJUhsfrbpReZXC5h587	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	1596	1237	485	12463	17228	jwAadrV4RRMSeMDJsUJCrbzSfyL4e6zDSFwXKh3hZqb7M8RmeFM	12600	17711	17711	1619127180000	canonical
25427	3NLCxHZdMEmHF5JYSazxmb6WWGVwy1ZYzresjNpC1Jg3QfbE3zGP	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	298	1308	485	12463	17226	jxVx2Cj4Y5dfk5pv9bajnssaHQ1tD926duy41PAhQLTCprYzuDP	12600	17711	17711	1619127180000	orphaned
25438	3NLqtPSiPhT43iv7JCzrYj6RPeo8RG5o52s5uf9t52rrEZpZxqMr	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	80	1273	485	12463	17237	jwdPLLrbCNtmeVcNLzKzUkxK5wQALUCF4uxSVvgpNvcCLBN3mzr	12604	17715	17715	1619127900000	orphaned
25440	3NLNwSH16KgMxPzdzaaVPnry2UWeS83jK9pAwGGYp6aXyp2q6syX	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1581	778	485	12463	17239	jxACx9xAZxy9kbx4Sw7yAxzWAFLGovSVxh9syzaKJuj8wDWuH5L	12604	17715	17715	1619127900000	orphaned
25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	1489	1380	485	12463	17241	jw6owJTdxHEU6gC6px9TxjKNZeTjSChMmNVZSuYYuBWoy6RR7Sk	12605	17716	17716	1619128080000	canonical
25447	3NLEc512xQbbhxmsb3W4sfyq1iJtCUdKZaWFTMitex7i6MPMAgUX	25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	1607	1348	485	12463	17243	jxNh8chHCmXJckBdE5pASRqj97idkAQTdzcaL6Nedci3Ko5MZLx	12606	17717	17717	1619128260000	canonical
25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	25449	3NL9teLvNTbpQFx8FsCMHwuBUZYrNi7zMnwAspT83gdgGgoXKjFu	1489	1254	485	12463	17246	jwxdGSSUBHnwsRPfKhNML43BaDzKCEWwYp4FypYE5ARUoufuod3	12608	17720	17720	1619128800000	canonical
25454	3NLm4jf78C86y8UgCPeACHj44wtfGHTND6EoQVoac2yusU7DgyQv	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	596	1180	485	12463	17249	jwwTQ8JiDamnnv157bwLYGDnoXbez2kAmQp6sipMAUGFwj9SGq3	12609	17721	17721	1619128980000	canonical
25462	3NLh9XEdzJeup2LeQH3NCDZU3Hp9sWJNoVRcjRJGTVvM4JJPDZZT	25457	3NLFs6rgaeZrVGJTjxuSZ9KNQs9p2vZvoxuQGsjsRTSW53oSjsCu	1647	1302	485	12463	17256	jxG36AF7JvConik9WwPZSkMDRBy47UJFzUiMaM3hkReXxzsqEhQ	12611	17723	17723	1619129340000	orphaned
25467	3NLZ6ti4eRgTKaySrZSpxbQ1AnVpgNnCGtk83gxpE2s1TFyKByKd	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	606	1295	485	12463	17261	jxTifjgLrTWB53eNYpLrfn25FuenPB4FuLtpMT6aDxv9XFRQKqk	12615	17728	17728	1619130240000	orphaned
25471	3NKd4BUnNtoo9GXaSx3UcdhxadLzBqd1BkhnaU63JaaL3oP1jrCX	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1646	1354	485	12463	17264	jwQCq2JxtJRw63mxV2r8oXVrW6waHk2frsvaVg96rBEGKRSuuVw	12615	17728	17728	1619130240000	orphaned
28645	3NK3vjcYyBphaN4tvwAM4WFyHfST6t5CUpy5oaDGetDkXCsKj3NK	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	1670	1036	561	12463	18974	jxSxwqqVLmJbR2Srm6Zear9vhUC9SSNiuEFVSM2ip5v48YUmiUM	14143	19929	19929	1619526420000	orphaned
29526	3NKCksyjwq9sqryuTSHjMAcD5YqAaidMbWabwNPZtrCPRUVduTKu	29525	3NKUrpZp5wo8ubHTFRpjAbsmQ3nZ69maUG5LoynKxj54rKMVePpd	1407	1395	581	12463	18974	jwFwRss6sUSuTKDhiEQUUdFVggzrGdiyaT7GSgeDHjhJ88jAhja	14561	20497	20497	1619628660000	orphaned
25407	3NLH9Ja6GPYeupd6d86UjhD25C7LQoTjzyzTBD6LUp8YsVk87Svc	25406	3NLJSGjzmh6niehqiGhEvpvxAsSQHHtFH2uEPsVwzkqYwjFoEHNM	1406	1393	484	12463	17209	jxvgFyQRL1ynQ3Wq5E5KR67Ekx5bew27tmKhGZnfpNLb8HboMuq	12591	17701	17701	1619125380000	canonical
25410	3NLa7D91y5bM3nwWChqGV3xaxbdk6Njg1rLHch7MQDnBSg2mX2h6	25408	3NKvBj4wZFmsNfyVAKFon3K4jkEtSKaAtW3B7g96SgPpsPkYUWeF	1457	1025	484	12463	17212	jx2DXH7BZdf9cPPHWRk59UKZURREFV1P6d2JfWhbSmmKK1MGJxM	12593	17703	17703	1619125740000	orphaned
25414	3NKVTAGZ5yGyrQWEw7QyuM5z57EnmMxoZpKi5NrnMu4k5JQhjgne	25409	3NKZKieuBSUKJDWRW3jNjL4EijjbuCJT67GAhARiWEke78kyQECm	1501	1360	484	12463	17216	jxow6vKUaCTRGqdi5GHztUvp9kEDeKRKbtQ72JyPGW2z2oP8pge	12594	17704	17704	1619125920000	orphaned
25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	25413	3NKAfT2yEsKxhourbvNtN3gaAmK7ptDpUthnLyq4x2UuSzFAkPM6	1439	1033	484	12463	17217	jxweiLXdWJpZwhiJcdegc7bMXe39wJY2c7Z2eD3mCDvHonsDDsD	12595	17705	17705	1619126100000	canonical
25420	3NKdud34BZ2zm25BNfheaCjywrNrpFZeQ9w1fB1tQyCpkYYmtuRz	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	1581	778	485	12463	17220	jx8JyyCQHTQkpbtc8VT4FHtKgfk68RNFawkd5KxX1o7YmewGurL	12596	17706	17706	1619126280000	canonical
25418	3NL8ftW6wbGr9SbReuyZtzeaBjqY6z9WhQxmNQEX6PagNKS1gz8n	25416	3NLeNr9EdB9a82zqXxgM5XMY7wPd7TL8zP8Zyq6DJbex5jnG3yRW	1549	1236	485	12463	17218	jx62zKhZ6gtHvH4ZPrfiV1uSXzkSCvAujEYsM8TcJpcU8AavNmr	12596	17706	17706	1619126280000	orphaned
25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	25424	3NKfV4oTnZECtgBpaqShh8V5U9vSPTZqLSHUVFLUzNVPL2MLmQUk	1631	794	485	12463	17224	jxfzh2yZjp6w5SXjZAVSxPLWAB6DAydEmXSpHbHMyEor5ands9V	12599	17709	17709	1619126820000	canonical
25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	1407	1395	485	12463	17233	jxvgJemDfcqx7YGNbDQZo68mtqheDQjJNHkSxMjLtud7jC5kQ8g	12603	17714	17714	1619127720000	canonical
25442	3NLg9sQCxYEeGLT69nijDSUit32ztHgaFcaaVD3hndrAuHkxphXc	25434	3NL1YmBWVSy274vnZfE6q6tGch8Ni3A3Uy5fsXz9CsVRWDaSrs1q	1541	1298	485	12463	17238	jwtcmPebbNzUNFPWQ62ErAwfPHEAmSDDud2PbK9KZXsNZcJvxJ1	12604	17715	17715	1619127900000	orphaned
25445	3NLxWCxv6QFfberogWd33svrtLzA4PW2jzpuhnT2wfa2XnG2gZUb	25441	3NKdqsF1W42FNWspnzMhfsxGD7h9abQ5pLzX6w778ZBw7N5hXd3X	1489	1380	485	12463	17241	jy25792Tk21MF9Z71rAC7Qn69WthMC2YWDD53XbRzJksf6PfHgh	12605	17716	17716	1619128080000	orphaned
25446	3NKV6m6wzFq5hQTQxUgDvCQgtMp9QSiZfUKTfcT7hG4RVx2Lw8qW	25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	1403	824	485	12463	17242	jxyQJwtTFHBQyMe7DWyxSCSNp2AgpqnJ5QmvgzfSyMQXBdvyUwj	12606	17717	17717	1619128260000	orphaned
25449	3NL9teLvNTbpQFx8FsCMHwuBUZYrNi7zMnwAspT83gdgGgoXKjFu	25447	3NLEc512xQbbhxmsb3W4sfyq1iJtCUdKZaWFTMitex7i6MPMAgUX	1407	1395	485	12463	17245	jxNNDPauHfi4CWJagjR8Er22uGVaeBveycJejJpkW1mRj4uD226	12607	17719	17719	1619128620000	canonical
25460	3NKEKt3gbDGJJ66ybU1VvExmAantx5zAHNiHyjy6kjPpiNKkmiRn	25447	3NLEc512xQbbhxmsb3W4sfyq1iJtCUdKZaWFTMitex7i6MPMAgUX	1419	814	485	12463	17254	jwwoKPNtTjqci7VGo4edQmCAM4Ei5KnJ4GEfePdnVvphtNm4ndk	12607	17722	17722	1619129239482	orphaned
25452	3NLjuRUqxMKKnY7HTZzAuxDGiu4HQ2Nthx9s1Fevg1cEe9Ld7ozT	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	1406	1393	485	12463	17247	jwcP1mg3N7aisHAPn6NVER6VKGCHYdUsDfvJ713JdzXccggtieD	12609	17721	17721	1619128980000	orphaned
25456	3NLr4juBwWzesC1AdMSV8DJcy17wc2d521zB6ZnbbMpJNRxUecoX	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	576	1109	485	12463	17250	jxFz4qs6njvkN3onDDq4JbSa3DcbSLcUt525JuL7dBN1fLXuimi	12609	17721	17721	1619128980000	orphaned
25457	3NLFs6rgaeZrVGJTjxuSZ9KNQs9p2vZvoxuQGsjsRTSW53oSjsCu	25454	3NLm4jf78C86y8UgCPeACHj44wtfGHTND6EoQVoac2yusU7DgyQv	1406	1393	485	12463	17251	jwsd7FbFC24YANMQ12yKa4kob22zLbc8FLwwUdBcEzi9igdACeS	12610	17722	17722	1619129160000	canonical
25463	3NLbHzfVCbA8n2QceGJRmYoi3dxtDMeY21nVG45UKhqCWmhdsGhL	25461	3NKJ4zw9ee7pHidZ9pXmuV3pv9zBB8wgHi6dp8TtYW5jzLTncHNh	1492	542	485	12463	17257	jx6gHugrEUEVm8VG3raYUUaCTgHyhWmEzmYEemdnafAKEhQs3XA	12612	17725	17725	1619129700000	canonical
25465	3NK36hqMgznG8XawdvGHV265Wmi3ZcfK9cPt71p6tMBPEYJhSLgT	25463	3NLbHzfVCbA8n2QceGJRmYoi3dxtDMeY21nVG45UKhqCWmhdsGhL	1547	1012	485	12463	17259	jwNgd5cnMdGX9gT3eJcGsFCZrHL9RfdqudB5VUJZJLdYyUiUG2M	12613	17726	17726	1619129880000	canonical
25468	3NKJrWF5UyErXrzaRfrNJiobqEjydp1xdkniaC49GyXdkCap97Bu	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1403	824	485	12463	17262	jwsijx5CsPtfJ4Aosw1WRfzfKkEJqSZ3N9yTp8LkT1rXS2NAfaV	12615	17728	17728	1619130240000	canonical
25470	3NLAUhh3c2eLuXseCHf6xgL5M8dn357hsg9qcnFVtkDgPgXme6Wc	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1646	1354	485	12463	17264	jxztjq2v8CVUic9stsDGzKnQunyZLXsnpKfXXRjP4YA2jYZoJgc	12615	17728	17728	1619130240000	orphaned
25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	25468	3NKJrWF5UyErXrzaRfrNJiobqEjydp1xdkniaC49GyXdkCap97Bu	298	1062	485	12463	17265	jwgvgL1jSFUYTjw2dRms585pXwXkdWGWpwA3vZbiPJGBvSrMQqT	12616	17729	17729	1619130420000	canonical
25476	3NKTyB5QsaBYqtYdY6XQrqf9UsfaaZbxM7s35CsSkE4jDH8DXaZ7	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1581	778	485	12463	17268	jxZneB35uxvdoT6wyKfNDoydnnYWXi2ABVH1ryKcW3w65NNJR5S	12617	17730	17730	1619130600000	canonical
25474	3NLTdPAE47YzFrjzKxJZBVRbD8QUSUtNB7z52rMqeSs7Ln8LRmVi	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1671	1239	485	12463	17266	jwb7hSzbhJrCVTdAfgoNhCXSKqQXyLB33XtkAsFWu8sE42RD1eL	12617	17730	17730	1619130600000	orphaned
25483	3NL1b8FWpEp9GfiGuNauDrqidKZzipnwYUXpGHX1EXZAE8n1t6yh	25479	3NKzH9FA2yCnjaLWtgBz4Uj4gt4Ry9mF9AptVnpuoHWcZmmD5vxu	1509	1074	486	12463	17275	jy3DLt3uUwKuDk43YZTfnJt9yHhmLudLHk1pcjvShFeoUEHeq6N	12620	17733	17733	1619131140000	orphaned
25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	25487	3NKePtGZ58cXCQXh6af3w42chKGPz416KkoFqgoKB2UfJmAxwuPs	1402	850	486	12463	17281	jxJQYXMmbrdV5pxsDCCjRN56dU1jD7hsFEAFdgKATYp6fqEuhbc	12624	17737	17737	1619131860000	canonical
25497	3NKpGP4na1SKfRuUzYUgWnLGFuySPa6maAYzYDdELWTYr2t1nwsb	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1523	1321	486	12463	17285	jwnQXVKVDojdgZApEPGDt8vG4GrSZdAUeBq8eXtX23byuZWBkPH	12626	17740	17740	1619132400000	orphaned
25501	3NLRKyo3yhjmEQ5B1Wf6iXsttofV7fKJeRnNEziwHmXuZ7TS28Wu	25500	3NLy1draEM82kGiykezYnry4Uk9NUJh57EVouk3phrQnbuCkqBqC	1622	1356	486	12463	17289	jxzmQHYABaGpJtfdvfq7q1XUrL2wWeTjoY52EPZhjk5ej73WdVz	12628	17742	17742	1619132760000	canonical
25506	3NLYgy7VqVTU57vKBUSeZKrQkZQvhYTfJ8M24oKD6GzKCvaiwpsd	25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	1534	951	486	12463	17293	jxhdSaVNEaYFSxsXh1yJ1zNrhDNmiCD3jLWNSSZvoPnqjXWn7pW	12631	17745	17745	1619133300000	orphaned
28684	3NKDSsbmrsrqCAf9mVKKhvCWg94Xa6bEfr8rsFT9fjxzrXP7bPzg	28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	1444	1255	561	12463	18974	jxbstDqTubRPRnUyQAdhB5svCZNKvKEkX18noVR3depjJesyuWJ	14150	19955	19955	1619531100000	orphaned
29532	3NKiuQtgR3bdAfKvtwEjZmg4aD6UPcV1RvWan4jy3ggLYa8BZezm	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	149	917	581	12463	18974	jwtPU9NX28upN3pE7ckkFZnMGqq4So8wd1nZB7RvZijAybthvhx	14563	20499	20499	1619629020000	orphaned
25559	3NLN841T4YThWpvcDM2EN5bZEDkG2WJsCTpg4SEuem8Lv51zrtGU	25553	3NKnY1JiWciaiUscXvc7SNg3fP3F4HT9JxZFe5pYJKs8f1t6DurC	1637	816	480	12463	17343	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12479	17778	17778	1619139240000	orphaned
25542	3NLEfCE4tQygwayF1nkGSFrQQswWbhJsbsSvp7b79x9nprhxswYG	25458	3NLqMobDDCLrsnWRYVJUApLmnXTYeuQAKJkr5VxGWggULBdSELrP	1419	814	484	12463	17326	jxLPnSpX9AteNfXDVTPHEqzoRM4AGuDhkntwEVuneWA9TcPab4z	12582	17765	17765	1619136900000	orphaned
25448	3NLYgKNsFZcNVRTWgop3m7Mir4xF1PGFWt533yHqiUHYqANCV4yi	25444	3NKCjFWunHFXrEH3fAsmhwbq7WhbXEzmP6m2XznKE7fjYJXWeeXw	1647	936	485	12463	17244	jxd2F6YgEX46i1pvacfVMPKHQ7Y8ffou8S7YdTnxUb7YVq3peLP	12606	17717	17717	1619128260000	orphaned
25450	3NL9r1tfEhsCnnBpiRGWg5aPnJ8qvaVeCZLXcgxYXB2oUAodQPU6	25449	3NL9teLvNTbpQFx8FsCMHwuBUZYrNi7zMnwAspT83gdgGgoXKjFu	1489	1254	485	12463	17246	jwchVnQrvbBj14fExAauyP4hGi7bEXVBsYsA9NztEgSjTj2dVF3	12608	17720	17720	1619128800000	orphaned
25453	3NKHoDCx6pUSTETqjs4Arm3wGV1UTKKCnVS65PDWjW3Xrze5R4EQ	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	1467	1376	485	12463	17248	jw7uXqWmbbF6Uu4JeSZ2mEqVFTJXySSXJcxeJkLv1LhyqCbfzBL	12609	17721	17721	1619128980000	orphaned
25461	3NKJ4zw9ee7pHidZ9pXmuV3pv9zBB8wgHi6dp8TtYW5jzLTncHNh	25457	3NLFs6rgaeZrVGJTjxuSZ9KNQs9p2vZvoxuQGsjsRTSW53oSjsCu	1460	1324	485	12463	17255	jwuQUCBZvyzQyWHxrF6Y4ssxMgjNHTFA4GrDmE2aaiWib5RqMX9	12611	17723	17723	1619129340000	canonical
25464	3NKAhhvUKSSL8XYSWFyZV4Eap414xhcRFzK65AMrMiD7x5scUpvq	25463	3NLbHzfVCbA8n2QceGJRmYoi3dxtDMeY21nVG45UKhqCWmhdsGhL	1589	920	485	12463	17258	jx3Utq7Bqd211CQG7xL8mvvHuoQDGd5o1E9gSseYoecGwDMLu2s	12613	17726	17726	1619129880000	orphaned
25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	25465	3NK36hqMgznG8XawdvGHV265Wmi3ZcfK9cPt71p6tMBPEYJhSLgT	1631	794	485	12463	17260	jww3RMdhXnuqEqNVYD38K7VGwMvQPjuy2DhymzGm8ppd7vexqh4	12614	17727	17727	1619130060000	canonical
25473	3NLjNTmXxz3nMWiZJCkSUzjLpRmxjZ7t4RLRbz2WLZ9dQhVFZVEQ	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1671	1239	485	12463	17266	jwb7hSzbhJrCVTdAfgoNhCXSKqQXyLB33XtkAsFWu8sE42RD1eL	12617	17730	17730	1619130600000	orphaned
25479	3NKzH9FA2yCnjaLWtgBz4Uj4gt4Ry9mF9AptVnpuoHWcZmmD5vxu	25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	700	840	486	12463	17271	jx5CARQS36FHMxfNNE6SAGCxw4gLeqFV4gSpxsi51PmiwyiVHPR	12619	17732	17732	1619130960000	canonical
25585	3NKFCoQCTdpY5cQfPwrDCiTqrr7W53LaK2CL57jZ1gFa4CbxJcgE	25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	1671	1365	486	12463	17366	jwY7BmHiYrU1Q7Ypj9NMEvbw5R8qePb8NrTGgRYrTnGRzoFSCvn	12619	17793	17793	1619142046012	orphaned
25484	3NLo2egZbFZpYJPXsTRpVw78Y2BkZpW6oPjbD5xoXHcREbXZjPzi	25481	3NKcHajabF5sCRKosfcgSf3xjKRBRhUo5K5aazQ4JzEEcRvpKXmP	1619	1149	486	12463	17276	jwJPaVoR8qZmNrZTtp3Wr94gCvz9axF5KKNgvt3mrfpC4kArj3T	12621	17734	17734	1619131320000	canonical
25499	3NKQ1RnUUt8mr1Din5CVmgpt4TiBct1fRhNobETLFrouD1Kj4Ey8	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1523	1321	486	12463	17285	jxfMpzLsJsVg5KVwzRzvr1w7Q5cwnbWtCQSXvSccmaXAJri4DGy	12626	17740	17740	1619132400000	orphaned
25500	3NLy1draEM82kGiykezYnry4Uk9NUJh57EVouk3phrQnbuCkqBqC	25498	3NL7iHqRBviLzHMGgLweGoheez4RKRwv8ZZKTEEpK5HbCVT4Mf9W	298	942	486	12463	17288	jxegmm44CDX9ynJoZqWvrD6hKYjEAH2vdXsxaNCnCfUW97nYDCt	12627	17741	17741	1619132580000	canonical
25507	3NLUR4rGsPCb4hDfvejxpJiH5JjxS6CgKPBbtetDzbCtNuvxtCji	25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	1631	794	486	12463	17294	jwB5HuzM2gzKxsHPFe8S93CpnQR1aaBk7woeCoX2aBVszS8qxN5	12631	17745	17745	1619133300000	canonical
25522	3NLtsuQD8UcQHaTF4T7pi4woJxiVe3nvKqPiEJ25qf9G5m8xeK9R	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1476	1371	486	12463	17304	jwBp5UsamQ5ayYSgoeJiJoVNrtyFU44BAhie9T3yNWicL1pRiaF	12635	17749	17749	1619134020000	canonical
25521	3NKEu9HswYKreWDmX6BM1DQ7GrFeB95ABx3Uf3sNNUQmcM7pJqbo	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1403	824	486	12463	17306	jxahZFz9NLSNBdAiAWKiYH4v7S7QKnCw6ySjxho2fC4QDfjTRsk	12635	17749	17749	1619134020000	orphaned
25525	3NLMfyvXsVZ2HkRxiS9WNhPrSPVDiJriSGFJ1fBBpPSpQkp5Zaym	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	1406	1393	486	12463	17309	jwSw81MVMoNPJUEaHqrLaqpypqRaYW5cq4iJ3qMfbdbgcdP6hLD	12637	17752	17752	1619134560000	canonical
25532	3NLPm8ugddec2bViaXmDxuUGPHev9MUDM1AkVT7RGawFsaPQXEU3	25531	3NKRiEAjAqMDBWDZ2GXKFe79QPXdkhgepfCk5PHYUV3PXc3VcQZT	1589	1286	486	12463	17316	jxycR57YfyXLWLWz2dw248gApGMFzZz9faDfF44q5QhJtmFCNrL	12640	17757	17757	1619135460000	canonical
25534	3NLXGqcmagoHVU6zCCGLEjyMmE3QhwiRs73vuS3qHo1K2VGqqw5m	25532	3NLPm8ugddec2bViaXmDxuUGPHev9MUDM1AkVT7RGawFsaPQXEU3	1668	1124	487	12463	17318	jxM6jn66eAHYQhADLE2AUmpKCATL75mZSDqaz8U21g38NRfYe7K	12641	17758	17758	1619135640000	canonical
25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	25536	3NL8MxprYccx1cFTHDy4ifMazxdMd9RhEo2xAwhCbXB2eikR2c2E	1627	1385	487	12463	17321	jxGnymBiieWitiXKa8jntBAegrg8E59w8QtDVYiqKmXKVt2pWqX	12643	17761	17761	1619136180000	canonical
25539	3NLRgkFgE2YPEWaAQWncScycPrbUN5HiLV7i1AVTEwdM726JE3GX	25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	1581	778	487	12463	17323	jwNri94smrMatu3cbFSsdo8k119yfiybEUQu6DgkciV3gV4YMqc	12644	17762	17762	1619136360000	orphaned
25544	3NKRbeoMgFEYqV3Dt7RF1zYY5ff5YmG1Y5Bmi7AQeGbVzr69nrPq	25541	3NKhDX4NfMfSBepTVqExiZxUFJmKRvsUkQTk6gqgjKZkjw7QJwT6	1407	1395	487	12463	17328	jxmVwSeC3a6ZHYKX1G9CjsAxDfdMzF4KTL1Rgq7UQuNByqUnzb7	12646	17766	17766	1619137080000	canonical
25552	3NKd2ofSKdGVinmFci9Gu2utSJBpff3EwuvXzNKQtRTWfNMLf2bQ	25550	3NKjLbEecRBHrcFHYC7NtzJQmcKUR9XxX6qUex5JeMBvewatHxKy	1501	994	487	12463	17336	jxXV27QaJQeKeDaWTS3ZXAGtLRWiKWrbkV63drnHNka8Jj7ZvFV	12652	17773	17773	1619138340000	canonical
25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	25568	3NLj29vq85DSRKG39JxymVLoUhhYq9JbrLXvhhTZGZ29ie6KLtot	1655	682	487	12463	17352	jxEEiSExSJgwB2kvMh318i3T6WaFagcomoVLL22GL9nmnZNuJfm	12659	17785	17785	1619140500000	canonical
25572	3NL3cTBqe7wRMZz5RhX8Lpwz27Nixkm77iaBvcAkJWMCm43ivU2n	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1460	681	487	12463	17354	jx3nPEkJpDDGhyWBTiEjTc1HxPHNcb3Dr5rBTuaePQEdKhgdmbG	12660	17788	17788	1619141040000	orphaned
25581	3NLhA5G4V3j4WUmDFjDqcFyZpQS3oqWgkPpsGLTT9rsVdGQnbFHZ	25577	3NKdQ1dGi2YMG7gi1Nu35QzPC28FKuBeKFiLVWWESxkpX4PaR7eU	1600	1006	488	12463	17362	jxHFPsmmbdTf2nZDX78WFXEMzHLxQfom2RTW6WdtCymCs1P49rx	12663	17793	17793	1619141940000	orphaned
25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	25583	3NKqmrPWudi8wKKT9dVQUnj5hh9DfUBU3r3t2nmTvSRJKDNn9M4M	1440	1377	488	12463	17368	jxrTcobyGujsbDbrRLrTN8SL4HkWrxhBjicsqwTtbNMkHkhMBAq	12664	17797	17797	1619142660000	canonical
28669	3NKGDBkq9USykPU8Euw1LhrkesDfUuPEDdRKgZETZfPVZF51Aice	28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	1457	1391	561	12463	18974	jwX8E54kMRTPEy2CbfMYtoPDSFJjvGbe1ev4aa2AePAMwei6gN4	14155	19948	19948	1619529840000	orphaned
25528	3NKJWyxritHZx6BnwB4RRoPM7SZ8RHXY7x3Rg9Pi8zwthgv2KQKE	25491	3NKet6gukUEDmYVMp6MGa9BUBJuNbgAtK7mMyHHsrKSck8JR2WSt	1637	816	480	12463	17312	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12476	17752	17752	1619134560000	orphaned
25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	25476	3NKTyB5QsaBYqtYdY6XQrqf9UsfaaZbxM7s35CsSkE4jDH8DXaZ7	1536	1067	486	12463	17270	jwQBZPY99WcoVXWhqfn4tPg5AWh8QirgtSVCfsFtQGYSgktrjs9	12618	17731	17731	1619130780000	canonical
25480	3NLnaRzHRji1bMG9vKZfyqeprctw62hqG8m9mN3gDiXs3jwUB6R5	25478	3NL6r9QKyihSbVE2jbdWhd3ry9J2LJDsaLxw8bkuiCjmHbFNgWB3	1559	1353	486	12463	17272	jwWdFBCP8iJaqVh3iYJ7ojtg1pUgKQd5WLoN2dnaUZMKQ3AsmS1	12619	17732	17732	1619130960000	orphaned
25481	3NKcHajabF5sCRKosfcgSf3xjKRBRhUo5K5aazQ4JzEEcRvpKXmP	25479	3NKzH9FA2yCnjaLWtgBz4Uj4gt4Ry9mF9AptVnpuoHWcZmmD5vxu	1444	1135	486	12463	17273	jxFVGJRt1vUGbP1mKxeyjPNibyB2DQfaPpMpsWakanH3xh5bqnQ	12620	17733	17733	1619131140000	canonical
25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	25484	3NLo2egZbFZpYJPXsTRpVw78Y2BkZpW6oPjbD5xoXHcREbXZjPzi	1623	839	486	12463	17278	jwtCiqXWrC1pPwWQJqYzWJMxPjr6CLXQg2SWcN1BH6i5AzesrmH	12622	17735	17735	1619131500000	canonical
25485	3NLeRwjVYyVPd31LpNiWJncjyPzBFfR7KCrKvxnbV3PQwesed8jy	25484	3NLo2egZbFZpYJPXsTRpVw78Y2BkZpW6oPjbD5xoXHcREbXZjPzi	1406	1393	486	12463	17277	jxQ1mxQSRakKCLz6qJyf6ksLquJvRDm1NmPfZHBdTrQFt77DQf4	12622	17735	17735	1619131500000	orphaned
25487	3NKePtGZ58cXCQXh6af3w42chKGPz416KkoFqgoKB2UfJmAxwuPs	25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	1406	1393	486	12463	17279	jwAr3Py7vC6pgDt9HFvPvPhW5paZcHojVJ6LEukdgiSshD4kq7R	12623	17736	17736	1619131680000	canonical
25488	3NLQ5ftiQJcS3KwLWPGADfnwVMDN378h5jEN6Wppx6p8eNj6JYgJ	25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	1560	925	486	12463	17280	jwArifztMKJFXRNnnxrUDKJ43DY599sTwt1F1wVWbDFxWS8ByUw	12623	17736	17736	1619131680000	orphaned
25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1448	1311	486	12463	17284	jwveJUyA7fLrA8XvsfRPYzrX3BwZtYNC6QHoxkCw8ADhWP1JCd3	12625	17739	17739	1619132220000	canonical
25492	3NKp4nkycw1taq8UXn8uR6YLtBn6atveaxYEWQFokLa9kgYuDjc4	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1460	958	486	12463	17283	jwkDPdLKB1CybfnyxEG8upxAgzGiiJSgHu1MY8ZUpJF8qwsERM7	12625	17739	17739	1619132220000	orphaned
25498	3NL7iHqRBviLzHMGgLweGoheez4RKRwv8ZZKTEEpK5HbCVT4Mf9W	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1422	1337	486	12463	17287	jxmpeXqnkGbhvLKJUq9vj7QyZqBmgxBbSw1MdimHhwJQRkjmTr1	12626	17740	17740	1619132400000	canonical
25495	3NLktW9rkU1hmUF7HdDhJDEDt6z6neV6LYLRLxrX346Qg6yqeWgG	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1523	1321	486	12463	17285	jxmpFqLXfxiTGzWGHLTLMfkG4LGU6QNbhYJ7jtEUkeYhTCNhJqF	12626	17740	17740	1619132400000	orphaned
25502	3NKNjh6NJPczMVAtU2juXUnxxsF95YfnD7h75TaVMPh7o94ZzGH9	25501	3NLRKyo3yhjmEQ5B1Wf6iXsttofV7fKJeRnNEziwHmXuZ7TS28Wu	1445	924	486	12463	17290	jx7YotzBzdysqyp8TAvicecFV2L9oBZMCq9bcRsp1dPmUgUYw4M	12629	17743	17743	1619132940000	canonical
25504	3NLQr8hyyGZrQYEmZwRanEi521pezPhZjPpPzZopFKa7d8QiN2oa	25502	3NKNjh6NJPczMVAtU2juXUnxxsF95YfnD7h75TaVMPh7o94ZzGH9	1651	1055	486	12463	17291	jwVQdAdmKrLfSZjo7jV9wovvpm8cuLbamNqr3MttRvvCWhRPF7h	12630	17744	17744	1619133120000	orphaned
25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	25507	3NLUR4rGsPCb4hDfvejxpJiH5JjxS6CgKPBbtetDzbCtNuvxtCji	1581	778	486	12463	17296	jxU1nB5ZARfmTSrqjGb4jK4Z4diRp5wFgTG3chkw7jjBugjGWYW	12632	17746	17746	1619133480000	canonical
25551	3NKoDtJCZNsknvgjq4QLbuHeDvhGpk7znpY9ELLgxpy1pnUUtu3z	25505	3NL9oXQ6anes8YEVS4tXwqApVPX2DdfxtBwD5Ue3Z5BUG5kKSadv	1555	1347	486	12463	17335	jwarAX1qp7rSt3ntCyLm2sdmebfbf51RoNRb68PgEZzEQBghMTm	12632	17772	17772	1619138160000	orphaned
25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1406	1393	486	12463	17298	jy2bce3T4TpA7o2pt1t2iXAWKbePr9kqhNecDeUL7J1aLgAAT6t	12633	17747	17747	1619133660000	canonical
25514	3NKiJhRb23YPZVHahjFEqYYx9MNCu4Y4usLMv5bohcM9LfTeGmVB	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1501	1360	486	12463	17299	jwyZ7po8ma3LeXu3oiPtQNvbpwtYQHG272jA1bNzt4iqX4yQNo3	12633	17747	17747	1619133660000	orphaned
25515	3NL4pj13UDtbJA35XdeL27BenG6xuGRrYyZZGVJ7Tx8D9g76qvma	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	606	1049	486	12463	17300	jwKrV1L7ax9zrF47BhhPx21E2qwefxu5gDrAX2bBZ2o75Z5uPHV	12634	17748	17748	1619133840000	orphaned
25520	3NKu7o5ad2xeYzmrJ73LVGV7HsEYs4Fuu3YABHEm8HF7znGrTEFb	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1654	1340	486	12463	17305	jx8YZJmsCp2o3oC2HDvfiAA8E1Mh6JA8o9SUWddToaEJFhpfYjH	12635	17749	17749	1619134020000	orphaned
25524	3NL7HNFpsoa591EaHuaa9xmCAKjo8WB5ejiRdGJkmjtURpNgCKG7	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	1407	1395	486	12463	17308	jxUZeHzwQDQwFHU5z2LNYWAFmmgSGrgaFCxjbUd5HkY5aKNj1YW	12637	17752	17752	1619134560000	orphaned
25526	3NKkP5nRZigKb5B43M6mzpLsaRBMaEdgbaUYoBQ4srdavAPTTfAV	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	633	1384	486	12463	17310	jwex5orDdEn4ddDqAcsEZJnUP6VD4ZhSkQijZDhQ332xtNC53f8	12637	17752	17752	1619134560000	orphaned
25529	3NKb8Ju9Hf5E2K2vypN8qhutqFRnauU3rDEiA8F3XiCP6sTVYTMd	25525	3NLMfyvXsVZ2HkRxiS9WNhPrSPVDiJriSGFJ1fBBpPSpQkp5Zaym	484	1319	486	12463	17313	jwsurLdBW42k5rU7dSyP73J7ruDpzNEqaHLFCMdeneRdjnStN5z	12638	17755	17755	1619135100000	orphaned
25531	3NKRiEAjAqMDBWDZ2GXKFe79QPXdkhgepfCk5PHYUV3PXc3VcQZT	25530	3NLFwixm3sxmYrZV5FtcFP5MQuBP5ntvs6xZm3RAfmFRWBfCWn6a	1646	1228	486	12463	17315	jwXSxgLLLjCRx6qZB7iRxD9B4i94YPrSNyqx1rNqzfeSsBRv4FM	12639	17756	17756	1619135280000	canonical
25536	3NL8MxprYccx1cFTHDy4ifMazxdMd9RhEo2xAwhCbXB2eikR2c2E	25534	3NLXGqcmagoHVU6zCCGLEjyMmE3QhwiRs73vuS3qHo1K2VGqqw5m	43	1184	487	12463	17320	jwTpowP6LSFL9dGcdDKmGbQFm9BcqHB8xbSBppoD1Fd9KWWjeD1	12642	17759	17759	1619135820000	canonical
25541	3NKhDX4NfMfSBepTVqExiZxUFJmKRvsUkQTk6gqgjKZkjw7QJwT6	25540	3NLK2dzcGKdYHuDvc4pf1JhLdVy25z7ijiQ78Hz2vafEvxC1d34h	1672	1159	487	12463	17325	jxeqK7GvtcRTnagBR6DByeP1nrCSbZBRTFNpHf3h2zHouDgQMSe	12645	17764	17764	1619136720000	canonical
25546	3NLCbz4ijvJYLVatkUtNXWkgnEVgTVo4KyVyXHfxoJzo2RzP2ZNi	25545	3NLrrXE7QHmqJfUvo6BLtAGFeq8Y1WStnjjnZ4zmWuNKaaFYT9ru	684	1352	487	12463	17330	jwUDKYX2tbqHKipdUPGS5911djiEAn6XAZKTbauUxUQdASWsK3y	12648	17768	17768	1619137440000	canonical
25549	3NKTeZfDzicPajXmH6jwDTYMQjT1jW4MEEK3CF1bnmhguaHUBV8W	25548	3NL4gaT97tgJ5uJRNBE4gc1PGQBgkLNEw4M5kGC1ygWUi6c4GH1m	1622	1356	487	12463	17333	jwzzRaBw2j5UpWTHzNmmmZbgWyWhWW8fcvLanv6WUmmMeWqjCkW	12650	17771	17771	1619137980000	canonical
25554	3NLiSjjwiFZVbDjduanteSZZALtbtu11NKxERacbLqxbeCDPBrTZ	25552	3NKd2ofSKdGVinmFci9Gu2utSJBpff3EwuvXzNKQtRTWfNMLf2bQ	1546	973	487	12463	17338	jx9ZWEL9PvazjCPf7zHq5eqDvGC7VrbBbHZbcGtY4bGtTGvXVRr	12653	17775	17775	1619138700000	orphaned
28676	3NLrCUqRknG94mWvY8eW9JpdSx7BB7wspRerX4RFrkEoUZFr3pWp	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	298	1308	561	12463	18974	jxDACmD2aNacqssx69ce6oKbstehj71CnHbXc4qpkhbJoMkfJTT	14156	19950	19950	1619530200000	orphaned
25586	3NKzoCcSV994P1mVBgHVpVaLTPdrDxgHFJJBdZWo2PtAdyCBit6V	25580	3NLm6aecJkQ2VrxY9jeu9fmtYLocnBen6i284RpQBoPXq6F3jsyv	1440	1377	484	12463	17367	jwVhcb3DSuDNWdoBSzHZkWpAvYRzQyBarCcTBbN7CLGfH8rYmP9	12591	17797	17797	1619142660000	orphaned
25496	3NLCLx5YWnxAtb3Toam5NbVsPbHVJz1NxrqmWkQuE8zcfb78anaB	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	1500	1297	486	12463	17286	jx5yCY4y4bDTVBLX2CmYhFKJWRgTZjZDFAvDq1gVH7FWQwZD7u9	12626	17740	17740	1619132400000	orphaned
25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	25502	3NKNjh6NJPczMVAtU2juXUnxxsF95YfnD7h75TaVMPh7o94ZzGH9	1651	1055	486	12463	17291	jwFmCHQmwXnCq8PjpqjexXSRAgckTBj75Fef1ez9G6LSGEHRKjK	12630	17744	17744	1619133120000	canonical
25505	3NL9oXQ6anes8YEVS4tXwqApVPX2DdfxtBwD5Ue3Z5BUG5kKSadv	25503	3NKCTqsbhQpSWhk4N8uf3JT9jZwKayN4NaMUUmPgUwSieMgXMPJ2	1407	1395	486	12463	17292	jwWWLc1C2drSwn7E97YmuqcrpJoHcLLh4HyBLhKiVbFRHAh8cd7	12631	17745	17745	1619133300000	orphaned
25508	3NKAaNb8CTCvBNfdTKPERedEdEFfMQFWXSPBRX622sh5XsbB96RS	25507	3NLUR4rGsPCb4hDfvejxpJiH5JjxS6CgKPBbtetDzbCtNuvxtCji	1627	1139	486	12463	17295	jwvCJP4icEMbdXCYDAkkbvQGkgE8tffMuHwzXioTBqDtXcXFLmS	12632	17746	17746	1619133480000	orphaned
25512	3NLwqcPv2zePsSiXDYSPVtQmyt6vp6SHWfDfE3MnatdzJagzMYJx	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1527	1167	486	12463	17297	jxiLZ7uh5SEMFAXcRLtnWiZRhGpaje47sZa8ZPwTpm3h8a71htp	12633	17747	17747	1619133660000	orphaned
25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	1581	778	486	12463	17303	jwuAjMbXgPpoescZxWmXeuo66oVHPw7c2JonNyjsZq8sGtgffhS	12634	17748	17748	1619133840000	canonical
25516	3NKyQqGkz5ETADfrchHyr4SjJp9dN7KxBCRMTs8fa36gUmwqAFix	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	58	915	486	12463	17301	jxtVNNrLVgGg9NTYRNJCbPWEimRuGpdfPVbrMiv6UbSdfdCSKpz	12634	17748	17748	1619133840000	orphaned
25517	3NKqRCqmnvQxxPhR9kjz9CbHjYy4qgmW1dKd4LB2fHGXLH3K5WBt	25511	3NLqFDn19Q3nWUqvHuM4ZhHPthUvvg2mqcuGc4qrmCsukQ3VJS6r	1656	977	486	12463	17302	jxH5TnWn3PqhGGwBkBJBrA9o1ttFt3BUFK97Xf79Mi8rxvR1mdL	12634	17748	17748	1619133840000	orphaned
25519	3NLEbt9HURxoQ6cjaEK2VZuVuxok4T76v6fK4tRXCe3o9UUccakx	25518	3NLk2YEMo3tDDUpkPWwpz1NDmRhjQMUT8WsqhjiDc37bjfyUitzR	1476	1371	486	12463	17304	jxA4eLMKhkZUx1kA6BZHPuSgHymD4S1Xi2E6S7XjJhrPCJeqioj	12635	17749	17749	1619134020000	orphaned
25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	25522	3NLtsuQD8UcQHaTF4T7pi4woJxiVe3nvKqPiEJ25qf9G5m8xeK9R	1668	1370	486	12463	17307	jxjrbmjmbiDUK8rM39Sb1xg7Gv1ezSX5KswRodjHxrFYMKsRkzd	12636	17751	17751	1619134380000	canonical
25527	3NKiuNdAPDbud8UKBXKAzz98WvQZqDyK53W35s6Li8noTVaofuMW	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	1553	776	486	12463	17311	jxX3HRgZDNdJyZrY5e5ia5eaS96rz2ondteYHUURjNs5P8VganY	12637	17752	17752	1619134560000	orphaned
25530	3NLFwixm3sxmYrZV5FtcFP5MQuBP5ntvs6xZm3RAfmFRWBfCWn6a	25525	3NLMfyvXsVZ2HkRxiS9WNhPrSPVDiJriSGFJ1fBBpPSpQkp5Zaym	1647	1302	486	12463	17314	jxyuwMwF7ChhySQTN7A8dxTGtAZySnHe18DoH9W7BqUFQEkFMZE	12638	17755	17755	1619135100000	canonical
25533	3NLWR5MvUyLQ6NMsLVHMosxteGNmQYNe6vnaq1oqEzKahW2Zuryt	25531	3NKRiEAjAqMDBWDZ2GXKFe79QPXdkhgepfCk5PHYUV3PXc3VcQZT	1403	824	486	12463	17317	jwm6DNkEsmDxt7181jKknUkzrrJDSbiYuzWXrQkbQYPvzW2c6n7	12640	17757	17757	1619135460000	orphaned
25535	3NLWRDkhcMQaUBCJvsQCBvvDkFXtgicVzpEhJXUG2hYBKpQp5rz7	25534	3NLXGqcmagoHVU6zCCGLEjyMmE3QhwiRs73vuS3qHo1K2VGqqw5m	1406	1393	487	12463	17319	jwZxQV7f7QTvCyXve1DYqxFxN14rSGJnpzGXnS1YUJ5jh8WtUzC	12642	17759	17759	1619135820000	orphaned
25540	3NLK2dzcGKdYHuDvc4pf1JhLdVy25z7ijiQ78Hz2vafEvxC1d34h	25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	1561	74	487	12463	17324	jxzoCVTHrcuM7szzAMAP8AwgD82jEQNM1D8VfzkxNDimi72rUzk	12644	17762	17762	1619136360000	canonical
25538	3NKzHpGgesvyCCDD8WApCUSNpNBv7v1RDQQErnd2SD3K9WDB56wG	25537	3NKA9hDGKisEjjzPBfska4NFZPvQ2XcENvdNve3n9vRjA5VNzyns	1407	1395	487	12463	17322	jwG9MS47rRzspJEsu7DAqk6c3saLTQCtZUAAfLBoF7AnSikk29M	12644	17762	17762	1619136360000	orphaned
25545	3NLrrXE7QHmqJfUvo6BLtAGFeq8Y1WStnjjnZ4zmWuNKaaFYT9ru	25544	3NKRbeoMgFEYqV3Dt7RF1zYY5ff5YmG1Y5Bmi7AQeGbVzr69nrPq	1403	786	487	12463	17329	jx4zbPjz8jPyrADJo3pfy7j19f2in92vaom8BZttS1c3nioQRFo	12647	17767	17767	1619137260000	canonical
25550	3NKjLbEecRBHrcFHYC7NtzJQmcKUR9XxX6qUex5JeMBvewatHxKy	25549	3NKTeZfDzicPajXmH6jwDTYMQjT1jW4MEEK3CF1bnmhguaHUBV8W	1555	1347	487	12463	17334	jy2EwGbxsZP1p43MSB1icsaPkw7gvv25AvhwrVHYdtPHRjRd2t7	12651	17772	17772	1619138160000	canonical
25555	3NKsX9uDTL9zqYe8PDU32tW9Mmau1ZVh4aDRGQwSfCbNtQK8hsJ9	25552	3NKd2ofSKdGVinmFci9Gu2utSJBpff3EwuvXzNKQtRTWfNMLf2bQ	1564	1338	487	12463	17339	jwSVX7ihkyvFtcfsZoh1yAUti7miyCmCjcmUkfMi5236apDqRyr	12653	17775	17775	1619138700000	canonical
25557	3NKun6SvVuRXXi68ggySHJsFojT2nunNTAUNDhsYC3XCUwg8iyps	25555	3NKsX9uDTL9zqYe8PDU32tW9Mmau1ZVh4aDRGQwSfCbNtQK8hsJ9	1489	1134	487	12463	17341	jxMiQxPczp265LV6MqzfZrAk5ffWwSm23TQB4vqyitq169w2Dh7	12654	17776	17776	1619138880000	canonical
25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1581	778	487	12463	17346	jwSrUcYo79fy3c74DTfiTwcHnBwJ1DRfKaMEe3J6Xfr5JfpSRu5	12656	17779	17779	1619139420000	canonical
25560	3NKqxW7rup3Wt732aBTKnMeDxBXKzrSKEi4KABX3me7r7QFKv5hD	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1423	282	487	12463	17344	jx4XTZUvbPnamVj5da6qst5vDqufjYB3b9wNm4y6vjA9Bc9cUNd	12656	17779	17779	1619139420000	orphaned
25564	3NKy4VzLhKDgMUa1zfdmLRidThASwLN6Frx5WTbi5eWJKxjWFage	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1651	1301	487	12463	17347	jwDr7ASVt6bg7FztXWcWm9dQrhqWEvJkQryAhbBrxBPpC2HPzZE	12656	17779	17779	1619139420000	orphaned
25567	3NKWA18doBsZ68stQeNhXAns815sbTfG1b4u9xnBLPiNxmDDyhjt	25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	1585	1366	487	12463	17350	jwKrFBiH6jwxdNLRmSXkZEZdZBFxakht8bwh1zm2GUyeVk96pRz	12657	17782	17782	1619139960000	orphaned
25570	3NKsWDkEAD12Tj4pfg1rtNwMP9eB5GbHEFxwjT1HPbsmVnSLBFTb	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1613	1349	487	12463	17353	jwDCZBTEwSk5F4cifEqCLxpg2Du8Ax2nyxqh2iM3ewmV29uWWbR	12660	17788	17788	1619141040000	canonical
25574	3NL1wWrK8V4kdm8KtTEe3spg89NTfmZan7WY925n5UzkoLWQwfPy	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1581	778	487	12463	17356	jx5nQ5rmj1vZJZhU23RzG3fW6edk3DmSSAhVgyjDfpFh8jxcniF	12660	17788	17788	1619141040000	orphaned
25577	3NKdQ1dGi2YMG7gi1Nu35QzPC28FKuBeKFiLVWWESxkpX4PaR7eU	25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	1406	1393	488	12463	17358	jx4fseZwoQAivcWPoiSJEPYsB9XrW8fMraa5QCAks52fWcyd5ig	12662	17792	17792	1619141760000	canonical
25579	3NLwesic2nWCKCmGNRCMzXBED3Dof8gvLFj5xaZoVX1erYL8dJkZ	25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	1581	777	488	12463	17360	jwk6aVnGvGYAmyJicDwDNShEDnnqBLbHLpSW8ZvtU2uUeRqhMyr	12662	17792	17792	1619141760000	orphaned
28844	3NLfXZ5va3bJNY8xFK6i4BbysWVDvtGHHLD22FfNnu75321YDKPq	28675	3NKGSQtra5UsVnVGMVybTpZQ4DXDaNTYsvagNCiFUcfeiVERVEWT	1602	1123	561	12463	18974	jwywFvEca6fXkW53CYAzjp5V4PbfxwBipmXM6Dad66fja9cTtu9	14157	20039	20039	1619546220000	orphaned
29534	3NKukAeDBRhd4vCZd3JVvUf4x9abMBhn4bj4Zu5VnFXKxCcbYsv4	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1527	1167	581	12463	18974	jx4QPT7t2ebxmoNvG39N69LykgMR2zr2HK7JAsr84mXpzdmR2Xi	14563	20499	20499	1619629020000	orphaned
25620	3NKwpzsdTjEmXNBwJuZNASJBMM6nXUs3HRkuffHDrA4fuHJYLwvM	25362	3NKk41hu85hRN7XgJnTM8rwTeMQsbodh5yPqeuJ22gY36xvmHGVq	1483	217	483	12463	17396	jwugWaNa8vA8EZEtfYEfnHSK3z12aY6WHCQUe4GRqUWJ4bThU19	12576	17818	17818	1619146440000	orphaned
25582	3NLdnhDczShwvKQoWLDwtkCQVgZBaXmHGC2y6dyv946QekVDC253	25425	3NKDRCdKm7aML2DMTNmoyvhkVfyR7gFG9KhoPtfgDmznLvTBAnYk	1671	1365	485	12463	17363	jw8N9tmkhNk4aCeU1N8t6K3WN8WMSkHsCX2oL49ueQQb6B6V7HT	12600	17793	17793	1619141974732	orphaned
25556	3NLm9M1dC5kmbwnfhHexRc47YAQdW4GqU4MwcgYdDntP8ZZAPeu2	25429	3NKLnBYLdzRN6F2S53uBVMUHUVd5giA3vyJUhsfrbpReZXC5h587	1546	973	485	12463	17340	jwmb5BUvydEzVtcm5rD9J4Z1qtmZpvpmiDGPNdm1xZQ99amAaYE	12601	17775	17775	1619138700000	orphaned
25543	3NKPJiXMNiHgaPPK2yXzKWgY8JdoCCod7wgodQwu82MR5hHdH1Up	25460	3NKEKt3gbDGJJ66ybU1VvExmAantx5zAHNiHyjy6kjPpiNKkmiRn	1419	814	485	12463	17327	jwsd7DaHvqvZrAJ8xA4ptECb4mzCQXEtf2dn77kfZAYsX87y4gv	12608	17765	17765	1619136900000	orphaned
25598	3NKNCd4GCpx5HYsbBWTTagK3BpK4bEMuT4oFAiTFHFrKV1Yd14Zi	25543	3NKPJiXMNiHgaPPK2yXzKWgY8JdoCCod7wgodQwu82MR5hHdH1Up	1419	814	485	12463	17377	jxxYrYEijmQwWfk3eEirAN5A8KZwwCYKFcfg6pXXDRKyvhjPiiE	12609	17802	17802	1619143560000	orphaned
25584	3NLqnFFKEBBq5iNfLxueC3BvSbRiMVFY4RR4Zgh8jedz7eExBmbM	25454	3NLm4jf78C86y8UgCPeACHj44wtfGHTND6EoQVoac2yusU7DgyQv	1671	1365	485	12463	17365	jxiimXeUpRVnEw53MM2TWkFvwPCKYNkz9ocTqg3broqDYUgBg7P	12610	17793	17793	1619142010706	orphaned
25548	3NL4gaT97tgJ5uJRNBE4gc1PGQBgkLNEw4M5kGC1ygWUi6c4GH1m	25546	3NLCbz4ijvJYLVatkUtNXWkgnEVgTVo4KyVyXHfxoJzo2RzP2ZNi	470	1309	487	12463	17332	jwBbJrenSpeNXRezxapU2dPjb4BcvJka4KrNkRLeRRNWNAtZTyg	12649	17770	17770	1619137800000	canonical
25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	25557	3NKun6SvVuRXXi68ggySHJsFojT2nunNTAUNDhsYC3XCUwg8iyps	576	1355	487	12463	17342	jxdaMij3EnGdVCGxHSYcoQqnEybUHb1YjNB8ymEB1kyakipsurh	12655	17778	17778	1619139240000	canonical
25565	3NKxfy55n3V1TQ6gdxz198CgShuk5s3rHeh9oNMgvSMSqbBxaURH	25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	1602	1003	487	12463	17348	jxTVDrLHquup3YYtkyo43d8KjY8Nj9HifAVdvGx52SePFTZqDFL	12657	17782	17782	1619139960000	canonical
25566	3NLQuw1GCRDve4EbnUY1UFvNqjpww7YzhZKWvVNkvXsAhbGgUN98	25562	3NLDGws2FxzNVTQhQSibSkNF4y8g6ad1wrKpWt4a7mNv55jWNBMB	662	662	487	12463	17349	jwMYAzKsKH5knDTJyCBMA3X9sh4jgRE8euVbkUzvA9buVSySrDX	12657	17782	17782	1619139960000	orphaned
25568	3NLj29vq85DSRKG39JxymVLoUhhYq9JbrLXvhhTZGZ29ie6KLtot	25565	3NKxfy55n3V1TQ6gdxz198CgShuk5s3rHeh9oNMgvSMSqbBxaURH	1671	1365	487	12463	17351	jx28EzyUy5otuPr13MSXUBgJLuRqTCzUfV35yaqjbjihwvNbF7q	12658	17784	17784	1619140320000	canonical
25571	3NLDkk3e8QXcnzFqeGB6wMPFWeFukuPSEcgVtgaKuW5oCFpK2CW2	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1613	1349	487	12463	17353	jwm68tuXt3H8DSNGscijC6PxA7xFY1JoaBe4utvVrfMuSGLgvHZ	12660	17788	17788	1619141040000	orphaned
25573	3NLoBmHKmexHj9PEnzJTfEm2NhMHikwWzPYHAFRTVm7ZxM7n5mYr	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1445	1290	487	12463	17355	jwhMjGqhhUGS3SaeMYZBgMkcaGi6KDHWx91nKsdUNKH7CuXHHt5	12660	17788	17788	1619141040000	orphaned
25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	25570	3NKsWDkEAD12Tj4pfg1rtNwMP9eB5GbHEFxwjT1HPbsmVnSLBFTb	1581	777	488	12463	17357	jxCsW4GPf2YWA9Pwi9tM8AhMy7EH69QMefda51TaVLdHjJrYV9U	12661	17791	17791	1619141580000	canonical
25587	3NLuhEc3jPPg4nnymoU7jKobE9yTaTZYyjrRfyhEVVWAhzKtZaL4	25583	3NKqmrPWudi8wKKT9dVQUnj5hh9DfUBU3r3t2nmTvSRJKDNn9M4M	1440	1377	488	12463	17368	jxDpuSpK4gnHvBUjnvfx2Z6SyALfQSKatHy3Gvig6Lq9XmN1g8E	12664	17797	17797	1619142660000	orphaned
25589	3NK3wFbbeewwAqUej8gUH7KkkrHRJVJSRxTkoQSrfFJACMRrxUkm	25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	1407	1395	488	12463	17369	jwyyRUjEAKXWXzhTBcG7rLVdH1KqUpZm215nEKHMnFmQtenkxc3	12665	17798	17798	1619142840000	orphaned
25594	3NLYT8ufdxXg6yULw5s2yWj2qpcGXhcw8evTro2km2zuJCWsmaxH	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1607	1348	488	12463	17373	jwwZBPndh1TcmLw4spi9ARQPuoTeer7ravs3usdteKHCfffZge4	12668	17801	17801	1619143380000	canonical
25596	3NKQVCha5HqtEcfq2fQsgrBS9FpqASNcqVxUXttwNbSunVzzHL7Q	25594	3NLYT8ufdxXg6yULw5s2yWj2qpcGXhcw8evTro2km2zuJCWsmaxH	1637	816	488	12463	17375	jxFyfTBK6MXaT8F18ZDdMoAzxzSUxSHShRTs3GyPznneChSKmrN	12669	17802	17802	1619143560000	orphaned
25601	3NKhcFaFnhSRsFdudv1eELPNdZWLdntAPiwr2hNNKjpiUhXPHTx6	25599	3NLQPbZaZoq27vzU3KEjyRGjKm5enuTbKcdZMVV1XRpdFesY8f6r	1656	1343	488	12463	17380	jx3MKur9fA9YzL171xZ2b8zUv8VtRNmZgjmvcr3q9bb3NNJMzTt	12670	17804	17804	1619143920000	orphaned
25604	3NK7uGZ179Ewg9BRD4zSZgYwJ9n7zM4EzGApME3n66ECg1uApv87	25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	1523	1321	488	12463	17382	jxyJuNcXGqocM4DttrSPGetVi1gV7FESbu2nZhoDAVSmSDazLYw	12672	17808	17808	1619144640000	orphaned
25606	3NKFhjf333dHNUbwHHnECiLkDFDeavujp1hMqqXUK2AUAw9e6PdA	25605	3NKrqAKtHAErgGWJjcEepHb8wrJ9tt63F8HjVcPvDyNWysYppuk9	1405	865	488	12463	17383	jxr4JJxmMBcYfyQFBKxkTU5rYCyshXEcC455p6z9n51aLyKLmst	12673	17809	17809	1619144820000	canonical
25609	3NLRP9o111jhs21AGPrkP6jSydzYz8S6xzdrBdzUVtYN2fnpMdap	25606	3NKFhjf333dHNUbwHHnECiLkDFDeavujp1hMqqXUK2AUAw9e6PdA	1440	1377	488	12463	17385	jweHaXDiyzduBMZeapbsXEFyKUFHbntZ2Laox7yW92W2cqTrtuT	12674	17811	17811	1619145180000	orphaned
25615	3NLGAqJvT5qVHT7AUu9bVVwrBdwRGEx57HFyGLjxU1keLWSK6w1b	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	1671	1119	488	12463	17391	jwkQbs3FQmqJrojuJpBZtu3LY3HbW5vn6Cbup2psvEzfA7KKWRB	12677	17814	17814	1619145720000	canonical
25625	3NK9pwaU4McmaEXPNSSMzH1UxKmwALHzoSEbSyYMZk2caFS3133a	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1637	816	489	12463	17400	jxh5TY1WMjGmf64pKoFMQUbbZgvwP2ZSQxMZALnsG2Bk2D34KZN	12681	17822	17822	1619147160000	canonical
25627	3NKxvbYEYysLyin6UNUVUpQaNCixnvng1dKvryoBsu4gPYo1p6m9	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1643	1299	489	12463	17402	jxPD7rBMTV35kRbNWBVLEhDVxUZaNbUaYZB7XPLQesob9CrLQ42	12681	17822	17822	1619147160000	orphaned
25631	3NKQcxJjs5gcikm7zaMtcHaDPabEZaZwtDjob1meTY8zvBamETpQ	25630	3NLddWhLgYwbpav9QfBgCpKQCQBmhBQRc4Ro3Bqa4myYhAghrfHD	1587	1111	489	12463	17406	jwnbRAAtKndtmYiZsf3EYCHappsZgpiK56sp6K5CVo2FN6DAk7e	12685	17829	17829	1619148420000	orphaned
25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	25638	3NKJ9ubfvjEv9Y26C6yivto34ecPYwDCGGteiwAgKr33T7F1X5Bv	1406	1393	489	12463	17414	jxwoLX4BtwpP1hCqvGFmCCxKzjZLRPG7bycN9pYgX6c4qcw6CK6	12689	17837	17837	1619149860000	canonical
25641	3NLbpfm4zjiHScgt4wsxDM7unPd36ejtds56uXp1W9pzPZrqTq1k	25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	1555	1347	489	12463	17416	jxtBCerQoaoX5cvkBRMQ3VFLnww1YVagkbxWnWq6hAQyzU29Nsw	12690	17838	17838	1619150040000	canonical
29193	3NKqrAQvvGwwJW8V7Vcd1fEj2CieJdcJQ5fhoH9DbjJcpRvWKzrv	28823	3NLGNa3y2QHBrGAh1Bo2zhRAMtWimrbjca1jiYdKZsEkqoMGTe7m	1500	1051	561	12463	18974	jx1ysVKQ96kLTnqyzbBwigwfwEezChJQw5DGeVgp9QZAsvBKwRH	14163	20268	20268	1619587440000	orphaned
25580	3NLm6aecJkQ2VrxY9jeu9fmtYLocnBen6i284RpQBoPXq6F3jsyv	25403	3NK8fsfdbXNA4kUwVw7BuuMtrYZ2XQnxD5Wia2B6hBz1rdmu2fz6	1671	1365	484	12463	17361	jwb5n7Vv4Yuue7CjEYG6YRHxcGWtY3FY8wiDyjhi14keX1yhHwx	12590	17793	17793	1619141940000	orphaned
25607	3NKsRfvADDdPgDBvUzycsCPjQKQ7LArLosYLgZ49mWhJnsVDtbb8	25586	3NKzoCcSV994P1mVBgHVpVaLTPdrDxgHFJJBdZWo2PtAdyCBit6V	1440	1377	484	12463	17384	jwZEpBGJQVa7HJAq3HTzjRSwcM1dWtr9zw9sXgFE22sEfCmMwug	12592	17811	17811	1619145180000	orphaned
25578	3NLPWV1VhahvmSEin2ytsGXzB8YE6iaMCyFpSQUBpwJXaFXEQWv2	25576	3NLU9W6i7bY99UHasyNYcLw3RxkFoWuDRikJQihyNHMmW6qSC7xJ	1534	1071	488	12463	17359	jwvGe9KKqNTJG3t946mQTQmnz5AP3jGKTPcWCxErCSxrqrH2qTq	12662	17792	17792	1619141760000	orphaned
25583	3NKqmrPWudi8wKKT9dVQUnj5hh9DfUBU3r3t2nmTvSRJKDNn9M4M	25577	3NKdQ1dGi2YMG7gi1Nu35QzPC28FKuBeKFiLVWWESxkpX4PaR7eU	1671	1365	488	12463	17364	jx78zw2vxkh8FEHqwBAwU3oqXiVpPbBgPZ9cj7UfChERDELi9Ux	12663	17793	17793	1619141940000	canonical
25590	3NKNYwJdyd3LokgN1uXXA5mAJTBKpHgJnHyvSmNGqUVxgtuRXZN9	25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	1406	1393	488	12463	17370	jxUxKpeY19bNNFRVkQaqU4rxLWqUrVuePT2co8Lg3zZMuT9ioDr	12665	17798	17798	1619142840000	canonical
25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	25591	3NKUgVViUsDHtEkhy3jBG4TVEYxjMSdGcq4CLnR2Bcx49exNSBoQ	1462	471	488	12463	17372	jwfZSCATuRgtGyC9fJhD3A2ysPQEZyd37eQ7zLu33W1GUATSx4d	12667	17800	17800	1619143200000	canonical
25593	3NKMFf4DCrgzyUAGU6EZwpUPbsa1t2zQQzsA6NoanquWkhLg24mo	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1607	1348	488	12463	17373	jxwbTNyUGEEFttWZaR1Zm4j2s4Z4coCmFy5htZXUrptM7sN6pFX	12668	17801	17801	1619143380000	orphaned
25599	3NLQPbZaZoq27vzU3KEjyRGjKm5enuTbKcdZMVV1XRpdFesY8f6r	25594	3NLYT8ufdxXg6yULw5s2yWj2qpcGXhcw8evTro2km2zuJCWsmaxH	1553	776	488	12463	17378	jxsPcUDjco9qbCKx71Z5LX4cXtCvuyQQJjYVzFtAE1QNboZLc2B	12669	17802	17802	1619143560000	canonical
25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	25600	3NLPEcFvjqmQFBXBKZM4LNzSF1i2dvHnEBi35qBzpXZGWJ1herek	1642	1001	488	12463	17381	jwLKvQetTmchyB18ojXwW3bAkmpPdAo91Yot7LUaVot2qvqtJBN	12671	17806	17806	1619144280000	canonical
25605	3NKrqAKtHAErgGWJjcEepHb8wrJ9tt63F8HjVcPvDyNWysYppuk9	25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	1523	1321	488	12463	17382	jwgvB88mf8cvcWAxvs2UemQwBthiaKq1s3WPrucx61K4c1hPeqN	12672	17808	17808	1619144640000	canonical
25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	25608	3NK42WPrReG2arPk2A7i9KZgBqMuDHDSmCFpcN1K3bgJQext9Drp	1471	1140	488	12463	17387	jxfXhS2mrCTTGhCwEGKeXNAojsDmivfKzkRHohSfjGmCT7As9LN	12675	17812	17812	1619145360000	canonical
25614	3NLJjAekPP5koCKQYXmBp9CaySeAtT7zMuraCjdPEbbGKYFqu25t	25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	1601	1388	488	12463	17390	jxv5NRUC1eNbuKg9W5pRfG6mUnEXofw31fyeNWMKi3kAMZDzBUk	12676	17813	17813	1619145540000	orphaned
25616	3NKPaQdi3DbS67qC8WfSy7KnQSs84Ympu1LHzvN2a4shPEeqofPN	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	1406	1393	488	12463	17392	jwfsJPH5zqab2iXmJikChidtBYoGJPeJD46ZkFGvzCjmdZ2N4V8	12677	17814	17814	1619145720000	orphaned
25623	3NKW5PXAHwAeU9YMJ21CaY8uCfYFNX1vnCv2Sjet5oMuuuSg4buZ	25621	3NLW7osD87YBdRkVykkeFQfyRgRFrNKEtM89LnG7CbB9X2E1RhCq	1460	615	489	12463	17398	jwT5wfqm94SgLBjgs4wh2siM1CUiZ6PcWD8Wx5rWq42iPCLzCG4	12680	17820	17820	1619146800000	orphaned
25628	3NLTdoniCiqDHw5LUheyBia8vpLxPwc1qAB4J3LmPKvMRSWh4u48	25625	3NK9pwaU4McmaEXPNSSMzH1UxKmwALHzoSEbSyYMZk2caFS3133a	1609	1333	489	12463	17403	jxfGwVExrDZrhepbH6oZrKuVfjzqJ26BGEutMz2r85udYeJ1av8	12682	17824	17824	1619147520000	canonical
25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	25633	3NLkSyWEzsuCwhTHv7YNyT4aYmEqWYBbbWqwyDCuQG65ASzFQzuh	1624	1088	489	12463	17410	jxgUTsDiSZAbdR8My5VqTt32Xa9CZqVSM3fsY8BVzrSFmv2sPto	12687	17835	17835	1619149500000	canonical
25637	3NKei4PoYVHLCYFH7Z3AnHkuuWKsPKPK6PkSJZRvn6akfdj5xsyj	25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	1614	315	489	12463	17412	jxxw2NCc5akn2cGrWv2o51tS67go322MZBFMXL4Cwg1fm9nVLsx	12688	17836	17836	1619149680000	orphaned
25644	3NKjcgTKC8YUiB8fUykRpeLS2qMk1zgutBMwCxyVPuM3WfP8fKqc	25641	3NLbpfm4zjiHScgt4wsxDM7unPd36ejtds56uXp1W9pzPZrqTq1k	684	1352	489	12463	17419	jwxBcckv6s8XeDVvDkrEdKW9JqEW4H2PrMfkf9xWk9mAZAsz3wX	12691	17840	17840	1619150400000	orphaned
25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	1523	1321	489	12463	17422	jwSQqA4ziwpmS5Aszuj4zN7ineykDuzxPSJMaNZqZff334gLR1i	12693	17843	17843	1619150940000	canonical
25649	3NKCxbjwAaJtWjc6aiKwdbssfDmeCyr2C3sviWn4hhhnuGc4MvBf	25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	1523	1321	489	12463	17422	jxrScWC5hddg7gKBGTpHoPPsPBngGsRCMvE4JmK4q5SZu1TfsXr	12693	17843	17843	1619150940000	orphaned
25651	3NKCRBsuGjvCjeKYMNrw2WKTRshgo3E9U3jEJe7vfs9v1tHLmSZX	25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	1590	1174	489	12463	17424	jwnfccNf5XpKt7eskVJqHxL8hnvjFW9DYeQQG7Gq8nSQ9Vru7bj	12694	17844	17844	1619151120000	orphaned
25656	3NLwQ1bfHMGFTH6XboF1GV2oikuu7K1nrd5zK5oiuVYrKiX5a2PV	25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	1523	1195	489	12463	17427	jwgCzUnaw4A4b5BSUz66JpTiQb4GPtMfx3tcfHyMDAc4DD72ZDF	12697	17848	17848	1619151840000	orphaned
25669	3NLX6jWFFz8jXMqfPa7eGrxFtVzDzBwmWRev26q718sSozhEKpK6	25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	1631	794	490	12463	17436	jwseU81snWhPDhf5GCuNL6CeA6zwVbaCnDEUBqncRsBDUrCUwrw	12703	17859	17859	1619153820000	canonical
25667	3NLMrzymnXV5gxpsVTULjoPJWKbwuGDYDN5TCq4EM5VxPrufKiJc	25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	1406	1393	490	12463	17434	jwmLGecYuinZYzXvn3s6GYPGeAKR6XfcnUPg6N5gkYN54S6M8PJ	12703	17859	17859	1619153820000	orphaned
25677	3NKNpzokoguE2dHkcDHRmGJu2bEocwKpufxCFyTA4SazbwK7R2nK	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	338	338	490	12463	17441	jxda6WnrPk9S288X59q1kcpxqxdk9dh9Me1MrQkiyFdM7Ww9tt3	12706	17862	17862	1619154360000	orphaned
25681	3NKT6vUkskzyApvfvL1vHxLpNKXnG6zcxVkvQNoRgZPrhSqNNvF2	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	44	1079	490	12463	17444	jxUmZGXpDsiPvJC5FNqcdjFgfmYdkgyaSfjfZxMHjjaeSCqqbBt	12707	17865	17865	1619154900000	orphaned
25685	3NKKP2GVvFubGu3AiuFmVZdj41U1k3ejXMDbSxXhW4dUYxvUbyZ3	25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	1406	1393	490	12463	17447	jwjm1pokjNgexsBcCFWKA8eB43ebtgkEguKwk48fgx3eUSN1imE	12709	17868	17868	1619155440000	orphaned
25687	3NKUfmBpKK43X3TnYZpbQ65vgfwhxofD6WQixCtACCFjQ18WEv2P	25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	1501	994	490	12463	17449	jx7b84MHjkUfLxZoxZiiSRUzktpSAe23ZtGgn4t5eoWankwg1mA	12709	17868	17868	1619155440000	orphaned
25690	3NKkwu9NexKQAQKhWurZjwGgJXT8xk2aFdPb1VVFCYmjxBoVsQHW	25688	3NKCDCe2KopxeMwHtqa4N2B1zKRx8Tt9XvgziuDhk9utujsTLsg7	1405	1	490	12463	17452	jx3sTGqcd8NJyGSc641SpwYDvVFHCMgc6Ey9W8JNMmoZpxStprq	12711	17870	17870	1619155800000	orphaned
28707	3NKwSBDf447wEwcUBJQYGEXtTUYfjXBYnhnmBXvJwU7gDb89fRxS	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1527	1047	562	12463	18974	jwCNmyuwBDm3x4JhdwqRmVwyNTqxiJ4eQ6JJ5JgQgDUQDvjuRzR	14173	19968	19968	1619533440000	orphaned
25591	3NKUgVViUsDHtEkhy3jBG4TVEYxjMSdGcq4CLnR2Bcx49exNSBoQ	25590	3NKNYwJdyd3LokgN1uXXA5mAJTBKpHgJnHyvSmNGqUVxgtuRXZN9	1637	816	488	12463	17371	jwJNAn2bfzZ5G9CFHrK3gU8dv6s8FG3BFrVUMkwdbtqSYPiTHvT	12666	17799	17799	1619143020000	canonical
25703	3NLuah91PXz8E5EFwi7HSXCPRyTnCs7SS57a1X1LYXcKv7vsn8uZ	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1513	1253	488	12463	17462	jw8E3P8SiBXa9UeB74bNd17J2TQsFNUdkrHjwaHwsUUaYH1pov7	12668	17879	17879	1619157420000	orphaned
25600	3NLPEcFvjqmQFBXBKZM4LNzSF1i2dvHnEBi35qBzpXZGWJ1herek	25599	3NLQPbZaZoq27vzU3KEjyRGjKm5enuTbKcdZMVV1XRpdFesY8f6r	1609	967	488	12463	17379	jwk5qJg3ChRrPHTBPTfo5ZsAfAjy7cJFpUZUizE4qELwunE26TK	12670	17804	17804	1619143920000	canonical
25603	3NKsY9qkuVtKswhswfvM9Z2h6gawkKyaVeQ19XLxFNBh5KVg3iX8	25602	3NKjsq17oqDnyDM5AkH52z9fDdHQj71TawdDnYVSQ7my5CKVprDN	1523	1321	488	12463	17382	jx2LUkHUxatFjSJV14smnEwwgG1JaH71qz6z3zbsWkSfy67zAY9	12672	17808	17808	1619144640000	orphaned
25608	3NK42WPrReG2arPk2A7i9KZgBqMuDHDSmCFpcN1K3bgJQext9Drp	25606	3NKFhjf333dHNUbwHHnECiLkDFDeavujp1hMqqXUK2AUAw9e6PdA	1440	1377	488	12463	17385	jwsPR3KbSXnRPYo8Jvi5oaUP6J6KdtCBMidoua9kEugVQVnh6KL	12674	17811	17811	1619145180000	canonical
25610	3NLkNzxBqUPgbQZ27sbhY19kvzvdTzCFgyyZWuFQbptHHVTNf1pN	25608	3NK42WPrReG2arPk2A7i9KZgBqMuDHDSmCFpcN1K3bgJQext9Drp	1407	1395	488	12463	17386	jxzpzwYuAzYkyoafAE8iv7qLvXXdMWAu5fwtesT3rRxNbWZyq1u	12675	17812	17812	1619145360000	orphaned
25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	606	1295	488	12463	17389	jxeZpysVxXbEtSuo9wQYCPeREWhDTSasN17YaYmqfVeXUXyTPwP	12676	17813	17813	1619145540000	canonical
25612	3NKvAime9Y1VV2MA7rVEJb4M14qHncCQbbbJzRYdLGBxPQ4paP4E	25611	3NK5Ykk4AATopFrNjFEyFwMats5oeiCoBNewreLpVTZ6NobgmUsj	1407	1395	488	12463	17388	jx8MGHkLxg97h8EwGkLPK9ih3nSVLybknWtnVFjNHUGZ2bmV5SG	12676	17813	17813	1619145540000	orphaned
25624	3NLtviEr5zd3NszXWvZCp2TkJRynciYBZXVE4DuNaeUEBtAjmxdT	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1406	1393	489	12463	17399	jwWVM456Mv2fvEG5ViJYggAPAFbSuMJ47M2Xfop9yARGASRqzcj	12681	17822	17822	1619147160000	orphaned
25629	3NKFaHeANheQJh2Tc4kFJdfRHACDvDpvfS8pnPHve6aGmGvaBdNA	25628	3NLTdoniCiqDHw5LUheyBia8vpLxPwc1qAB4J3LmPKvMRSWh4u48	1587	1231	489	12463	17404	jx5U2ZGouDAXwWanEW2XziBzG6DFK7Qs49rQ96ikaTNinXbs3Wc	12683	17826	17826	1619147880000	canonical
25632	3NKT1brzMj6nCT9NF7fEamjbqyVFJEGFKf8sjS9NgdBSf3Pr4VNk	25630	3NLddWhLgYwbpav9QfBgCpKQCQBmhBQRc4Ro3Bqa4myYhAghrfHD	1501	1360	489	12463	17407	jxcx44KUVTL4Nph2wiD5kEhwnwPWhMTHyTXbhEZb7441MNeBBVP	12685	17829	17829	1619148420000	canonical
25640	3NKB9AAtjeWYj7PH7N6YZsDr2fY6PX1hS2qLQyivYVv1NjNKuYYf	25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	1444	1381	489	12463	17415	jxuUzvhq7gZm5jqUMMzLUrBmPsx8AJuY9EgzZSxMw9yx9TKY14o	12690	17838	17838	1619150040000	orphaned
25642	3NKNX1ZG8orEGK3AbmmoYLFd1EQPz8nQheNHtTQjteoHayLWNjTJ	25639	3NKYmUkq7kuYagibcCBLuqFtMixYzAtVY1DGaMBRwSNwXQDXbBa8	1631	794	489	12463	17417	jwJ1be8KgBvz13fqWSRJfudEfDkYaJnaVF9x3jWoyQ7BhrAcEK3	12690	17838	17838	1619150040000	orphaned
25654	3NLqaxgXNhTJr72n57FGJttZvt3hHknBM7UUVZ4Y2W66it9qwJmy	25652	3NLQFZj7kCxLbZE4czoN6JtQKsYgvWvBnwm7E4U8Jbxbmx4Bm6Xh	1460	1324	489	12463	17425	jwTxrb3ijudARM4gPTGBTTCEuLX8ArgpL4TqUfT8Fu9WMLNk51Z	12695	17845	17845	1619151300000	canonical
25657	3NLHV4Ux8BVSp5ybJfj32dN12U9BKod26DQspH4fihFKdErG1xD1	25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	1523	1195	489	12463	17427	jxnbkC29yfwx33bzBnqqZuF8TmXHMKKWEcdX4GydUWpdY13MsqG	12697	17848	17848	1619151840000	orphaned
25659	3NLLusDayRLs4cDL6uhv7e7BdmXQUsDXqZQcjLKFz35KBkMWiyEf	25658	3NLfQFvtSbkKfG4vfhoHGsNbpE1Lcf6zB6hBpjysnHvdLTUpQnsr	1623	829	490	12463	17428	jxwhrcpoXppS1a9JXMeiEmdXxc1oYz6RnPrUR61AZAqJmZigfp3	12698	17850	17850	1619152200000	canonical
25660	3NKuqnwyED1gRjdMXnuBwZ92dvnULVUMRSLuk5PeSdrBzPcFsmHM	25659	3NLLusDayRLs4cDL6uhv7e7BdmXQUsDXqZQcjLKFz35KBkMWiyEf	700	832	490	12463	17429	jxxovMDxUFMs8iUDXAgi7skss7FmYRURUTwYBmDfsujuvmxjUne	12699	17854	17854	1619152920000	canonical
25663	3NKupZNZtguhQFvuJNHNkPzF1RUNyPuJEVdVv53evn76Jr6Q5L1n	25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	1647	1176	490	12463	17432	jwPsM1SS7p2Bv4qLQPAVNZoJRQj29fw1dGNRnFmhKzGGYZCqbLY	12701	17857	17857	1619153460000	orphaned
25665	3NKhj2g8LztFX1w6vMb9wivDKAMiMo667jLzQ8dpJaezUmfUXdzm	25664	3NLLvaRPQM6bT673gmhWYAZKeErwv9spkaZTdsy36yAGaKtcWuhP	1536	1187	490	12463	17433	jx4XLXPEQyh2NgEKhgbhV6sxPAXNouNLBXtFzfcaw2EQZaQ3NgL	12702	17858	17858	1619153640000	orphaned
25672	3NKGXFonpRxWYjaurDDiiKiiZqHuZbgxi55Hv4pP4JWyosStP3b7	25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	1590	934	490	12463	17439	jxS31YteaGX9GPpfuPfBaiUxbivvu1KACxSooniGCntGfCgKB8F	12705	17861	17861	1619154180000	orphaned
25674	3NKoLHBsCvcSm73iTT9uUiD2z591fqgkxjBQwJLG4xyTR2g8ycAC	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	1448	1065	490	12463	17440	jx7ftAJGaLe7FPaXPFxsnYrjrLL57TzubLsYvrfQouVpKaURkjd	12706	17862	17862	1619154360000	orphaned
25678	3NKmyGaUPLoYytUHRWvDTxVKBjDVKFtr5nX7hAUXcMoeYN8bVYkZ	25672	3NKGXFonpRxWYjaurDDiiKiiZqHuZbgxi55Hv4pP4JWyosStP3b7	338	338	490	12463	17441	jwR2Gj3g6UCrt8oCUA53QbVanXhfuGjNvFeEEiVnPJMpECik8y2	12706	17862	17862	1619154360000	orphaned
25683	3NKjmNrzpw1SXJ1qCFdj4gxU5DUcZxE1AHWuyWyjNtfmahsZy5fU	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1402	868	490	12463	17445	jwQstVT9GxHo2k38HZQGLR7t8DHvrZiAPBaKhALuSJRuitZnMSm	12707	17865	17865	1619154900000	canonical
25679	3NK8XL8BTy2yN9jRURoU9jwXK6atCKaC2LVW6zP61LDMsNVbMcsi	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1405	1	490	12463	17442	jwawMoQbZjiwEkReBu51nZTaFnndG7C7t1GrCVaN82ASm4MxXdV	12707	17865	17865	1619154900000	orphaned
25682	3NKZRSMhmbhkNK9waosenpmcqZDBH8ijNfHqUyQtQQskNmK8c9RX	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1579	1389	490	12463	17443	jxhNh8eocGzUmdskAq5qdYAm2NTaXBNjy3iYoZPq8LYM69psrwf	12707	17865	17865	1619154900000	orphaned
25688	3NKCDCe2KopxeMwHtqa4N2B1zKRx8Tt9XvgziuDhk9utujsTLsg7	25686	3NKSS2fxqsP1D9LjoJnxi6y4kYVQQT351bkLcE9Y4KBid5sR4cty	1483	397	490	12463	17450	jxh3TfKpZjbPMLwZ32ibF6uiSM7mCj1ShCPs693uSQoEwvBRVFR	12710	17869	17869	1619155620000	canonical
25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	25695	3NLZ1pw4gwmzY6E9oB6trn9mTspBVMPfsmE9UL9hBgcY3yQyHZrq	1509	1320	490	12463	17459	jx8k4b2GHDndgXBPEk6wPKf2AfJXRzARMjHPhfAgVaMimvZk7m7	12715	17877	17877	1619157060000	canonical
25700	3NKaumR3tTA2aMSmBXfV3fsV21q7SgveQLRK8QmV45HmMQekWMRY	25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	1675	976	491	12463	17460	jx5MBXCCqj6eiy4VmEJRTGiQxKb2aAEfaRiHqDCuaXp7D6ffLKV	12716	17878	17878	1619157240000	orphaned
25712	3NK6QHv2FcHCjUo3Lu9UuwBtwWvuKW26R3ZEEpJjskMepU2XyhZP	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	1422	1211	491	12463	17468	jxFFDF2ct5qAVVyQCrmpihC6iKV8osr8XK1HhKBJfPPmDcxefFX	12720	17886	17886	1619158680000	orphaned
28711	3NLibEJPpK8pQTPaeajSM2T943kGQ3z3N3T4hHnPffJ4wuGEWJGG	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1527	1047	562	12463	18974	jwjuP9kAn7r8kwgLAg88eHFJ6ou55j19rM62m3vybG7t3Kc9qaW	14173	19968	19968	1619533440000	orphaned
25617	3NLFYrGTUAoXWnJjhTmgGgYku1u5KpvPmv89AJShfMRuymXVPQfc	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	44	1079	488	12463	17393	jxpqwPNGpd9uDaZiyFYbCEiWtzNaZDwnbRNUs5H5okZyn6y4h3W	12677	17814	17814	1619145720000	orphaned
25619	3NLZhSNyfyF8T1NUw6jSdgQwVRE52weEbCiEF6FcJHAZQqp5v9WH	25615	3NLGAqJvT5qVHT7AUu9bVVwrBdwRGEx57HFyGLjxU1keLWSK6w1b	1671	1119	488	12463	17395	jwKrz77GAnM5x3uGQzDbBqXMiiAh4hPQgnRik7MAVZuiiWduPpy	12678	17816	17816	1619146080000	canonical
25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	25621	3NLW7osD87YBdRkVykkeFQfyRgRFrNKEtM89LnG7CbB9X2E1RhCq	1460	615	489	12463	17398	jxo4A9BefFxkaNQXwnFXFQzPbk6enJviJKYBGcBSXc9mQ3Vrhgt	12680	17820	17820	1619146800000	canonical
25630	3NLddWhLgYwbpav9QfBgCpKQCQBmhBQRc4Ro3Bqa4myYhAghrfHD	25629	3NKFaHeANheQJh2Tc4kFJdfRHACDvDpvfS8pnPHve6aGmGvaBdNA	1403	824	489	12463	17405	jxAz23Lve3Q1ThKFR1tyHxPN5c91c7ExNXMMpmZC8gMQUs4j2JJ	12684	17827	17827	1619148060000	canonical
25633	3NLkSyWEzsuCwhTHv7YNyT4aYmEqWYBbbWqwyDCuQG65ASzFQzuh	25632	3NKT1brzMj6nCT9NF7fEamjbqyVFJEGFKf8sjS9NgdBSf3Pr4VNk	1534	1071	489	12463	17408	jx8ifDPzeKDN1gHTwmkN2UCSqZwkHsRFy5JxdPu6ecAThbAXBpo	12686	17831	17831	1619148780000	canonical
25634	3NKCLYiHFpQeqRDByqUu8kLRp3X2gnEuQCdTPykKZfRbe93Kqkhg	25633	3NLkSyWEzsuCwhTHv7YNyT4aYmEqWYBbbWqwyDCuQG65ASzFQzuh	162	162	489	12463	17409	jwZ395F28fXeDySqJQc6doWPtLuosHrA9dsxRUgV6ZSd74qUGqM	12687	17835	17835	1619149500000	orphaned
25638	3NKJ9ubfvjEv9Y26C6yivto34ecPYwDCGGteiwAgKr33T7F1X5Bv	25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	1631	794	489	12463	17413	jweGCu5hhv7AdDSByvXiuspuSygviMxZxrx6obakGDeSR593Fkk	12688	17836	17836	1619149680000	canonical
25636	3NLjBp2i2srNZAxnnkJMoVJbUKn6nbyShQGLgnscnQQz5pw4fVnz	25635	3NK7RfC9xt63NdVPrZJ7ZwQNUdbLW3fB5gPqmnwx1c7yGSokLjxy	1490	1148	489	12463	17411	jxoTRpvZNmzAqcC2JtnSsFUnC7KqR3F5dcV4QeEKo5B2mxsckcr	12688	17836	17836	1619149680000	orphaned
25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	25645	3NLB9kKXPxsrrn7L7xwDjUFYYQpx4ki8ZZ5buUuXMx1niWnWXmW1	1407	1395	489	12463	17421	jxKcoEUq446KQ6mQUojUQpPvAMAGuXwdLRhmYBhQrNryjUd3meB	12692	17842	17842	1619150760000	canonical
25648	3NKWLUF74MHc5HV2JYPmMPiFj3SvkjnXCNunHLzpho3ELghRdaf3	25646	3NLgS6RUyxt4jEsVoF5YCN6F8jNFyPt993XCskbc5RxWQgHn6aq5	1523	1321	489	12463	17422	jxqLu2ZCZ36raD4i8iJjdZVaEUBNZG2tPSLPDmbYEx5CbFhHXZf	12693	17843	17843	1619150940000	orphaned
25652	3NLQFZj7kCxLbZE4czoN6JtQKsYgvWvBnwm7E4U8Jbxbmx4Bm6Xh	25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	1590	1174	489	12463	17424	jwqw86CkVjPZj1stT89CPYsR4MrMKHZ4egTHy47arPtfyd1KnBe	12694	17844	17844	1619151120000	canonical
25650	3NLsJ4rxiUWJ45DkgJSXuQyZtGAgtitphgYRLFfaUBeY66A3MRny	25647	3NKdb6hch93h7us4Pa6xcTPSYKwVXkeFRCG9PTmVtq8D3A6UUwRq	1581	778	489	12463	17423	jwKkaqsJnvDvuAocBMhJkbtGejLgxVxEtJ1ArrGR5YveiYMMkEi	12694	17844	17844	1619151120000	orphaned
25653	3NKManhtTVN7TnHDVsnVZNPvUMH6Quc2MWFppYG3PB72YA25hXYh	25652	3NLQFZj7kCxLbZE4czoN6JtQKsYgvWvBnwm7E4U8Jbxbmx4Bm6Xh	1460	1324	489	12463	17425	jxhwhW4upaY3MUk1NgtBQe8TK982ZUoecfTVskqfwQ4VuYRXRPy	12695	17845	17845	1619151300000	orphaned
25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	25654	3NLqaxgXNhTJr72n57FGJttZvt3hHknBM7UUVZ4Y2W66it9qwJmy	1406	1393	489	12463	17426	jwFhHCRbpPz9YcworjS6egr8tRyPsJgtHpYi8KCjkC15UvKmDPD	12696	17846	17846	1619151480000	canonical
25658	3NLfQFvtSbkKfG4vfhoHGsNbpE1Lcf6zB6hBpjysnHvdLTUpQnsr	25655	3NLKibvEJpQStdQh2fefGzTxvxVGKXkEEHEUEfx5hUTcKnxadQjL	1523	1195	489	12463	17427	jw8R7mMR8NFsEQH8T3eY4Djb1aJD5PUaSzNLeSXiQpmqGuEnTq7	12697	17848	17848	1619151840000	canonical
25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	25660	3NKuqnwyED1gRjdMXnuBwZ92dvnULVUMRSLuk5PeSdrBzPcFsmHM	1622	1230	490	12463	17430	jwRHmvskPAb5Rpo98XEqMLsmWDbcmSSnR4KeciitQWkUGWRnvQc	12700	17856	17856	1619153280000	canonical
25664	3NLLvaRPQM6bT673gmhWYAZKeErwv9spkaZTdsy36yAGaKtcWuhP	25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	1647	1176	490	12463	17432	jxYN8KxzkzY3YaADNVT31ufTQaZX1uN9MS5y5VfVaVVrQZi1U1y	12701	17857	17857	1619153460000	canonical
25662	3NLTPoTc9zxtmFoexKSVzUFkpfWVM6etwurffnLoPc6XKyXxWZ9x	25661	3NLhMwDogorGcTAbT2ZGFVUko3XdZ5KDdwFXjYkwxMmHRYsXqc2V	1588	1146	490	12463	17431	jwBT6hS6dzZjTpiAbNgbMFj17rXBCn6EAmk2Q8WRjoghd8Me4FS	12701	17857	17857	1619153460000	orphaned
25668	3NKJQ1iZ6BwZK3QLJcvyrybCTMxcoB3SWtpAbCe12Kya8b72z9Ev	25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	1648	1284	490	12463	17435	jxQ3kHe2rHVJC5U5g5Mj2Hyg3bBu4naMfcfE9u7pitcFz2P4qvZ	12703	17859	17859	1619153820000	orphaned
25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	25669	3NLX6jWFFz8jXMqfPa7eGrxFtVzDzBwmWRev26q718sSozhEKpK6	1553	776	490	12463	17437	jwsQXAqGvoXVwtygw5VkXLL4MznUAKXBZWCA1Fvr8ZRuKhHkY5j	12704	17860	17860	1619154000000	canonical
25675	3NLFGyNPQkCH67jVRzfEt5WXGZDGC7Vzk6VuLCzAreKQeHmFYhwJ	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	1448	1065	490	12463	17440	jwMKpWyZhG2kuV9mjQfhnxbBscinJMcw7h7hwu67t1yWRK1WzCw	12706	17862	17862	1619154360000	orphaned
25680	3NKaU98EghtDXcPutDdqFmoRo2ncEebSui6Lfgh1SiPyCme25QD7	25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	1579	1389	490	12463	17443	jxAKAxSijUeJLnPsTSR7SKftzv7m5Ycb5dvuCiB7VtXupBo8chN	12707	17865	17865	1619154900000	orphaned
25686	3NKSS2fxqsP1D9LjoJnxi6y4kYVQQT351bkLcE9Y4KBid5sR4cty	25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	1637	816	490	12463	17448	jxFtWFS5W6Noy383zSnuH9SzA4192qX1kJpubZCupAF5xdkGeo3	12709	17868	17868	1619155440000	canonical
25691	3NLVNWvZBMPCfLdR7PFQANJsvWMmfnsA85FDYw3r82F3QimHz947	25689	3NKvRQ4dfjkiQFLSg2pC996dryEFY28tMWK9XHSyuAPsEXoNEP8Y	1672	1039	490	12463	17453	jwxALCW8Tqu5mSyH73aPc7UwEGiDp9grnieK2TeGuLrUW2dudao	12712	17872	17872	1619156160000	canonical
25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	25691	3NLVNWvZBMPCfLdR7PFQANJsvWMmfnsA85FDYw3r82F3QimHz947	1610	1314	490	12463	17454	jwD358uhcJfDqhjHTbTteTdLCsZBTjTWT1s6cMeiqqmXwSZCnx3	12713	17875	17875	1619156700000	canonical
25694	3NLJgU2e9pb1ayGnMHfNTeKBX5vtiPWi8u31tjh1yyYkt3c78n5P	25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	1633	1144	490	12463	17456	jwAvLXeqhxxMaho7x4JYaSSmFabiD8mcfsE9tTywQ357kspPNcB	12714	17876	17876	1619156880000	orphaned
25705	3NLEfD7GpwzvGD5jPgQuZqzSD7KtcMHVJQ8ppRH4gTjYPg6X5EW3	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1541	1298	491	12463	17464	jxTimBL2jwH6EJ1rXu59Ji28MpCBpKkr5B5bCaP5eJyCMjKCC76	12718	17880	17880	1619157600000	orphaned
25710	3NLkWY8JTfiCGTAHEU61M3xuKj4fNLerQ4ubUrfgUN6nmwxRSnnc	25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	1651	1175	491	12463	17467	jxxaVrWmHhGXWRxcXUSGm7FK2fJ1f15zAs6uBaea5c5mzWzHddd	12719	17883	17883	1619158140000	orphaned
25717	3NLf3TcZFhyq67E72Ae3fMYrxxwP1znVwPwJqcUJ87oYazBKNVTd	25714	3NLAtN1e8ZZHjCYVh2dKnUHw2BLSknsxF1oTHFHBeAC1B3GWkJGH	1631	794	491	12463	17473	jwSJntTvYGgE1PLxZpkWPna1jciiuqtW5rNgVQPv7UKCh1AMNgZ	12721	17887	17887	1619158860000	orphaned
28712	3NLRiaDrmjKw4tkeR3m5wbx4ztcuDBhopNWTTW6PyRRfrteKPCeY	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1527	1047	562	12463	18974	jx7MHQc8Mv91doZxx93XmEB7nVCWKKQ87zcDvQW1QLQbtNmAtDk	14173	19968	19968	1619533440000	orphaned
25666	3NKDkMy2NwtwDY1f1MNL5fiuXXD4vLt1uuCGWb3oHiJzpDZriHqj	25664	3NLLvaRPQM6bT673gmhWYAZKeErwv9spkaZTdsy36yAGaKtcWuhP	1536	1187	490	12463	17433	jwnrJMKWaZFVR4cg7gxFmUH4pZ6yYUGsWXywZhKCjKJJSE8nWQR	12702	17858	17858	1619153640000	canonical
25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	1590	934	490	12463	17439	jwi6D2UKj4YVgUjMLU9XfUnJc3TMrwX2f1ye8TuUdhCg1CwRr1C	12705	17861	17861	1619154180000	canonical
25671	3NKYX4xrupeHZ3NW6CKMJWPM3Yp1Q8ZnqSWApULMeu7pL39Q7s75	25670	3NLwg8kzP7ehxbNbQaDSsXgjqRsmbtRga9FM4XRhCfWQaovj5eZv	1627	1019	490	12463	17438	jxYsQ4647dJBsoGVfgHDmDoRqFKmTubkim2mnqitZsSYs1MymBw	12705	17861	17861	1619154180000	orphaned
25676	3NKo2zzZ8U1YPs83AzDPXFiS41kL3yBCj6EsabxdG1HtpHTGLBxc	25673	3NKw8Ay5Ed6xerqaghTb6ksZL188UhskYtQKNbTPZpxxgevJWT6p	338	338	490	12463	17441	jxFdmZyPzJeWqsw1jbDKcdavyCTQxVk32quLn8hUZEcNjtgXmsQ	12706	17862	17862	1619154360000	canonical
25684	3NKsKgLArfE7erZFgBgB8RA4K2kqD9q5LqLefXZVyQosxmEUtY6d	25683	3NKjmNrzpw1SXJ1qCFdj4gxU5DUcZxE1AHWuyWyjNtfmahsZy5fU	1405	873	490	12463	17446	jxCC9cLvZkbAS6BgyXofEKnJVDiv7fDGVK8XLWxZmRMoS3WX2bD	12708	17866	17866	1619155080000	canonical
25689	3NKvRQ4dfjkiQFLSg2pC996dryEFY28tMWK9XHSyuAPsEXoNEP8Y	25688	3NKCDCe2KopxeMwHtqa4N2B1zKRx8Tt9XvgziuDhk9utujsTLsg7	1451	1292	490	12463	17451	jws6wmFtqKppe1iQjo9T6hwo4nTgWnb6E6DHHtbhFH8jhYomJ4q	12711	17870	17870	1619155800000	canonical
25695	3NLZ1pw4gwmzY6E9oB6trn9mTspBVMPfsmE9UL9hBgcY3yQyHZrq	25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	563	1740	490	12463	17457	jwQKAhDGgyqrVLpHFHMBpc32Q1jArS3trJVuHLFxj94ypde3v8L	12714	17876	17876	1619156880000	canonical
25693	3NKvFxqYpNKjTNgcaaDfniJ6EGJRgE3ppi4CqAPw4VSX8eQcDn1u	25692	3NKr3tAhoQ4YNiNPko4EPP7o4SzPDKeoKUrGKSbUDLFCi7Dy2XcQ	1619	909	490	12463	17455	jwyTLKSQfLmSEp3cmtxZ5DHhoS7Tufw4BrHQjfzLzZDhHJSHeAh	12714	17876	17876	1619156880000	orphaned
25701	3NKiQffWiaHW6DxjMx1XpK2MZSZcuxzrQ6G9xebp5VGfS1Rjs96d	25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	1675	976	491	12463	17460	jxgpGwEuJG8yFutLriqQffAQEsCRiQvLdkKE7b5afbpuExSWkdy	12716	17878	17878	1619157240000	canonical
25699	3NKLo4VEKHe7QTVentYri4PHkSvnf1eKx91AcmtRekwqiVMu51K6	25698	3NKdfQQXRe1kBgyouxr2bHzVfADKgshTe8HU4HJyExEGLxdexK46	1675	976	490	12463	17460	jx5MBXCCqj6eiy4VmEJRTGiQxKb2aAEfaRiHqDCuaXp7D6ffLKV	12716	17878	17878	1619157240000	orphaned
25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	25701	3NKiQffWiaHW6DxjMx1XpK2MZSZcuxzrQ6G9xebp5VGfS1Rjs96d	1402	842	491	12463	17463	jwEL7EEUHPvZJE1Z5HFmRiuLgns9TzjABtrXJr2zk2oUn4ynUJY	12717	17879	17879	1619157420000	canonical
25702	3NKw831dEMFazCvtLdCNDN3Bxwtd1cQa95Hrq3wV8UU2hCU2T5jw	25701	3NKiQffWiaHW6DxjMx1XpK2MZSZcuxzrQ6G9xebp5VGfS1Rjs96d	1637	816	491	12463	17461	jxxCu4HJ2vFcFLRmLP4uwkvGfYHuinBEhRqnX5qG5vd27TgnrXZ	12717	17879	17879	1619157420000	orphaned
25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1627	1259	491	12463	17465	jwbG7zDGecQf1t4M6cwhL4hn1uZ1B22yqBh8Rior4BxAx2NxQHU	12718	17880	17880	1619157600000	canonical
25706	3NKxUSHRJZmyrx1uqQPxwbg3bwYC3Vt7iD1nFD5iMfLwcCwhqpmo	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1541	1298	491	12463	17464	jxPnXbV4BV8CC52fwEBnNGUQYdjTTdKw38y8YMkg8Jmz8AqJnNS	12718	17880	17880	1619157600000	orphaned
25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	1407	1395	491	12463	17466	jxWSrHGRtXC3zUPjFyJSBuy7eyViWcbYFibo1f7GhdKwBqjXhZv	12719	17883	17883	1619158140000	canonical
25711	3NKpeKtWzB7jNWpo8kSdbP5JPP3gFRhSMWssa7XqrpXaNstJZRmP	25707	3NKSEjBMWF3tLEsWePgUwyozSWAZfdYqosj6SJkGpwJ1r7BwuzRn	1651	1175	491	12463	17467	jwWGnM8rPouG2Zcsmp8vTFZZBwnxf84eo7RJJSbtBWKXNkp7r5u	12719	17883	17883	1619158140000	orphaned
25713	3NL6FvaRHTdLzGRPzc163KP1tqhUMicnbYEKYRnxYAndgVDM6ZUf	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	576	1355	491	12463	17469	jwJP18isXqp3Wh93oAEgSxtCSqadACjvgC8N7JW8WhHHvaGSd7n	12720	17886	17886	1619158680000	orphaned
25715	3NKrSEELmcEWUFtMEmbuDZ8rbJyd37PNf751fXacxtxqEcwW9Ypk	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	497	553	491	12463	17471	jwyfj6sPSjrqnr8mDpekovAKNdx5qdYYyUUygtEWYSiTXGLqx2e	12720	17886	17886	1619158680000	orphaned
25720	3NKmiiay2ohZPSXMmYtY47giYSgD3y8V6uxYVRMnU1iamGJc8uEC	25718	3NL75GBVptvzpp8r4CyvCPSfA8gq7e9xva3GZ8WW71X63Bjbq3Nr	1471	1386	491	12463	17476	jw7vYsx6Zt7Z2MreesUFee57nwC1yP7eurGDgkwDSjSFe4SEjvD	12723	17889	17889	1619159220000	canonical
25725	3NLiSGMoHy6HRmwyYCViMECD6jyYGASrNwZ2fR8GD3Hfm2vxK5hp	25724	3NLEKfhpNmJDY991CWa6Jc2LsuhW11YyzEbpVrtJGq4SaDeY1yKa	1581	778	491	12463	17481	jwrJtbyk8CHkdw2m7qBXRMNdABwovQz7j3CVzqYekGQ35mXtPkk	12727	17894	17894	1619160120000	canonical
25728	3NK7ZkRR5g9VBQ3PbJ8KQ9okX2JZ2KkcD9oHQnfUeBrKSyGzUQvy	25726	3NLAnz6mPaMA4YvdAL6VZnmgei1wu4auZswQyVPgq9zsYA1qVNVP	1631	794	491	12463	17484	jwjqrkhu3JFmidp1i4pvp22rKDuZzGn25TLik4dL5jHrsEihb1Z	12729	17897	17897	1619160660000	canonical
25731	3NKpgp2V2QBqzX4GU3KG92y8XqynRkLe577CtVT8d1BYGxWCLFrP	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1651	1055	491	12463	17487	jxqdqMH34fLLsU2DLJ7yVv7fXoaCy5tscdvgMRSbxZ28hswX439	12731	17901	17901	1619161380000	orphaned
25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	25732	3NKRQHvJocn7hju48B8PAvuT6G9aRGGUujrn2dRv5CjY6VA5EfRJ	1474	1329	491	12463	17488	jwxUuBqduRnENPfc9AbcUyhfMuUJQjyer3AqgWAWD1MdF3SXME9	12732	17902	17902	1619161560000	canonical
25738	3NKUGBJeVSWHMyWrLc1Q4hJJQ7Ep6A8qmNnWrFNTxMLhfx9XbDTn	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	1536	1187	491	12463	17493	jwtKmRDz9HGDrWw74myRWRMLNNskbz5WpxHqT3GmZStE5jX6hCp	12734	17905	17905	1619162100000	orphaned
25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	25749	3NKdb6q9WiBi4ec2zojueRXy5nvdbVvXphSkZs9tRr5uLjBDXVHz	1587	1231	492	12463	17505	jxJnL9bxT6MfU8bA9vUYd6Qokg9KYTFDbvKJTLwsbSzFc7ZFP8a	12738	17909	17909	1619162820000	canonical
25763	3NKD7mcy3MY8SLxMuGaxeW73cpCEVq2cwByFEXojstCwSPdu8oQQ	25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	1523	1321	492	12463	17514	jwTLPivzGQwgcZxwAVm4oX63M8kJCbFSo2trQdwCu1aHPAuKNd4	12742	17913	17913	1619163540000	orphaned
25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	25762	3NLHnz6XfkuTYpCqbbfX1fmvUd6ksQKDqw7kygaKxaZcvU8cq3nu	1405	889	492	12463	17515	jwq4HCUzSa5aVTXa3J6YCksbm8hLb52MexSydt3gcRMFRzfdivs	12743	17914	17914	1619163720000	canonical
25773	3NL5C5iLcK9XKBzAkoPvQdFQH2o1QbnVkCLRN5Te2yvmrs5T7t7V	25770	3NL86CL4hE967HQpY1yMYfj8NJjRYhzUhe9wEBJcbiUN4PyTDqBm	685	685	492	12463	17524	jwogPqi87ni4zLD7jwJXSi3KC7DrgjKppgcUhhhhiVV6jAFwo8Y	12746	17917	17917	1619164260000	canonical
25778	3NLV1B8eaDpK6VUUAX16EXJLUmhLJn6gta6eaF41wxNjao3XFH1m	25775	3NLnoNLSwKZCdj2XC625q2TZCau4imMQdX8jjLq5UTXbFFiV5KYj	1506	1007	492	12463	17529	jwg3qKkb8ZL8Ufp52UwnSHqfyVDgGcThmSvKm6kGMCKX77avfAX	12749	17921	17921	1619164980000	canonical
28713	3NLfcPmhNUUMUBh3654PM86ppqtmajTEUi4VikFQuJj3Zx68Ay7n	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1407	1395	562	12463	18974	jxehXgNHSDY4eeANVMUtjRACAFqpCde2pog9cU5p2GbeqtZFXQz	14173	19968	19968	1619533440000	orphaned
28848	3NKwgF9wHJUKupWZj7qdPJYnkoSFAd3hZaRNCzGQQAAKWtB1Ac69	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1602	1123	562	12463	18974	jxz3289vEWcmbLvpy1ooKKALAi1t3AX5oSq94xWBzMcLKfqRzFX	14173	20039	20039	1619546260852	orphaned
25714	3NLAtN1e8ZZHjCYVh2dKnUHw2BLSknsxF1oTHFHBeAC1B3GWkJGH	25709	3NL1ZoMKnKqhsUKKAHkE3t1rjrC5V7SRPyQ28gCYB9sS9RyCbux4	58	1155	491	12463	17470	jxXySJetAQx6M5HVfYDFmn9sj7cG7XWAyoY54RjcDWXAj7LgFQh	12720	17886	17886	1619158680000	canonical
25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	25714	3NLAtN1e8ZZHjCYVh2dKnUHw2BLSknsxF1oTHFHBeAC1B3GWkJGH	1474	963	491	12463	17472	jxeobutmHYJ4HtvZmq9MHgvPTSwXB5EX6AHam8DCqswfYTemfxu	12721	17887	17887	1619158860000	canonical
25718	3NL75GBVptvzpp8r4CyvCPSfA8gq7e9xva3GZ8WW71X63Bjbq3Nr	25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	1426	1238	491	12463	17474	jxXLN6qhSVHggA5PwCq9ePjcRUXHwztBz6RQwPQaXgJoe9R7CQf	12722	17888	17888	1619159040000	canonical
25721	3NLiqMvhFfXeXRWRFomn7nceehiT5LNhKQV4JzvJbVCqbjwFos8T	25720	3NKmiiay2ohZPSXMmYtY47giYSgD3y8V6uxYVRMnU1iamGJc8uEC	1402	852	491	12463	17477	jwA7bQdeA9ERbBS1v3RdXm6eRiMHxWMNs1G1qznyjSGppB41VVg	12724	17890	17890	1619159400000	canonical
25723	3NKZw6DZ25pRBzukAjdpjMx79raQnccaq2mJnEXEaZzka7FMtByH	25721	3NLiqMvhFfXeXRWRFomn7nceehiT5LNhKQV4JzvJbVCqbjwFos8T	1631	794	491	12463	17479	jx82DW8j9q5AAi84CXkvVVUEs8iq7Ej86YqtCJJjA3YphxmfDJr	12725	17892	17892	1619159760000	canonical
25724	3NLEKfhpNmJDY991CWa6Jc2LsuhW11YyzEbpVrtJGq4SaDeY1yKa	25723	3NKZw6DZ25pRBzukAjdpjMx79raQnccaq2mJnEXEaZzka7FMtByH	1407	1395	491	12463	17480	jxA9GUg5SQ5jDnS8M3uDNzCffhZQvmaL5CVSD3E54wEznfgxKte	12726	17893	17893	1619159940000	canonical
25726	3NLAnz6mPaMA4YvdAL6VZnmgei1wu4auZswQyVPgq9zsYA1qVNVP	25725	3NLiSGMoHy6HRmwyYCViMECD6jyYGASrNwZ2fR8GD3Hfm2vxK5hp	641	970	491	12463	17482	jwYfEGQRPQw1mcaq4eKnpMppwWeRQj4u2foawx8CbDPwoq8uYPA	12728	17896	17896	1619160480000	canonical
25727	3NLv6zYtAvNaBPXnhGDHgKtZcfBWvrXvQWUJjNTk78qtemp1Nmyb	25726	3NLAnz6mPaMA4YvdAL6VZnmgei1wu4auZswQyVPgq9zsYA1qVNVP	1406	1393	491	12463	17483	jwvWoXuuYXokh9Xrqno7g8PmSpeK3iGCVTM1q6iV7q6VTf9HfbR	12729	17897	17897	1619160660000	orphaned
25732	3NKRQHvJocn7hju48B8PAvuT6G9aRGGUujrn2dRv5CjY6VA5EfRJ	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1651	1055	491	12463	17487	jwZNDjgZyJVN7H7eqWT9mRBnX2Z9x6pfzLqT3wPoPJUZppwgUf1	12731	17901	17901	1619161380000	canonical
25730	3NKToajWrT9mrcFMKtCCe7Pa1QFRAdCcYaY69eekF5zi68XdhMhz	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1507	914	491	12463	17486	jwGT3pZW56QFqTSxJQajFFwA8CCDPjz9SRvqVhisyd8K5Py1Pru	12731	17901	17901	1619161380000	orphaned
25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1671	1119	491	12463	17489	jwdTA7axEFUsm9mqmvn4HgApVYtqetGXTYeDh8S1yBpU41VEou6	12733	17904	17904	1619161920000	canonical
25736	3NKvVx3eP8C7nriDtzLnH3sKRiWVq1t8NRnehKxgboLFWDWUva4Z	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1631	794	491	12463	17491	jwZqtDpZ3qQTwvSePxvrC9iv7pE6BhjozVqfsQQcCMUuqZJnAwm	12733	17904	17904	1619161920000	orphaned
25737	3NKiPDypSCTTgPB2f5AHB6jtHCUf63sCy38YFc1xwyHekmTh1SDM	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	80	80	491	12463	17492	jwiqC32aGMjSaVH2Q2WcPUvy8eK3MbuwuMzfyEHN1HN3PL36dkz	12734	17905	17905	1619162100000	orphaned
25745	3NKEtiLi2XMJa2DwDcqPQbH6dwtfdwY8Hzk2doG1Z7sQprc54Hoj	25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	1448	945	491	12463	17499	jwdrzVPcQouZQVsGbKSDuZG6r6pnt1ZbEkYt2HHBEBrUfigFSWS	12735	17906	17906	1619162280000	orphaned
25747	3NLRi3e82nRHbP9PYbv4ZDRCKeppEF3LeZ3z3AfKaPeMYT8JtsmX	25743	3NKfNNGjEE1WGdXUXQY2KVa3PYvmmG1Jn1WSZF8XuqVfZngHpYGz	1407	1395	492	12463	17501	jwd6bBf3jBMdPGiQQZWsUkoJ8wCsyah2k9RhwzfFyd8AuthbkKw	12736	17907	17907	1619162460000	orphaned
25749	3NKdb6q9WiBi4ec2zojueRXy5nvdbVvXphSkZs9tRr5uLjBDXVHz	25748	3NLQzqEVG9fVrc15STtX27iVXCWbLzbrE9HiBgvfP8szhrTNTdUg	1617	1288	492	12463	17503	jwNJGUDaXTC8cDJxWUPRGFBgeUE48jbcD4G6xfv8wEHbSUiSqkH	12737	17908	17908	1619162640000	canonical
25756	3NKRJdkW5Q83hrhyXTpsvp72cAeUYqRw1BCuGbmrfSkSC816BBcp	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	1579	1143	492	12463	17510	jwEHXsrpRyfDiz9eqANUvhpjjZoXvqwKyTpkarHRRg53DgqePMd	12741	17912	17912	1619163360000	orphaned
25771	3NKmSsKMKYeDvgK6b8PLxqt8kd4Cd3rHsA3EniC18ZF7zbTzQnKq	25762	3NLHnz6XfkuTYpCqbbfX1fmvUd6ksQKDqw7kygaKxaZcvU8cq3nu	576	1229	492	12463	17522	jxry3o75LaGnnsU76da1N8YxmcMLTSY6VLg6TGwiVSe1fs8ddEm	12743	17916	17916	1619164080000	orphaned
25769	3NKrdYESkiPcR8cnfFNmWE9oq4y4CiSQKo6SJZJELXTKsJGyNt5R	25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	1624	1334	492	12463	17520	jwdZZhLLH5ie3Ldm7A77jPPLigGCp7ZQhDDFreGBYeX7qbPSBbV	12744	17915	17915	1619163900000	canonical
25767	3NKC78RLptL63FipyttWoMNbcJeZ8rohhZYSYL6WiX6yzkgKeuqd	25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	1439	1279	492	12463	17518	jxehTUN2faoSG1cnozTt9Kb13AL4tw3RDs3yjGG7RUkkJqxcwf9	12744	17915	17915	1619163900000	orphaned
25776	3NKyH8rRwRAPf3G3faFMnYNjWvCAjLndJHEepxyXuniF28usexYK	25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	1617	922	492	12463	17527	jwx7WRrfUkwe1cq4txKtWMeNKeGhAbA7hq5E7zSWTt5wwAW2FiQ	12748	17920	17920	1619164800000	orphaned
25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	25780	3NLt914tJBX8xRbS2xRHYN1f5wGAEdV82qUnhb9jkpc6g3Xehs3P	1483	180	492	12463	17531	jxk24aqTiqUe3tQNgSsXxHwk6hPBjrYdw22vcCzVdEZqbghY2DL	12751	17924	17924	1619165520000	canonical
25784	3NK8nxjkTUWghpWrWr7ibGtt61DWHYSFm4xqtzFHjtwzm2JkPedx	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1541	932	492	12463	17533	jwtUSrRzAxvRioF6x2TfVfKsoCRWui5maimaCTG6LkSVt2haA3i	12752	17926	17926	1619165880000	orphaned
25786	3NKQ12hSAKjuuPdRz6QajXQVXaYspZbH3Bd9a8RB3MzpDi2Fr61a	25782	3NKMSD9t1fDXN5U4cD2kr9wEs7TE1iV3fHtwD4THXTFpVUkWVAqb	1467	1010	492	12463	17534	jxQc2NTRJNnn67pVMo6K7s8wXLNgBxuQ8ge8SDPRQ8kaPDwbuPK	12753	17927	17927	1619166060000	orphaned
25788	3NLfEnF8MutbxKwuvAiKLGx6Vgpqiha1QQSxK5CchV1ornhtfCeM	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1451	1046	492	12463	17536	jx23iGobgWASj8LSimHAjKBP1q574Uzy3xUnKWhckAMDKC1kCWN	12754	17928	17928	1619166240000	canonical
25796	3NKVsz7tsiYMvWHwFkDyWazSB2kmG9S8FfvSstFLjNWGKHNBz4wt	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1523	1321	493	12463	17542	jxSYD6tnzrsJDtseX5dftMenvFQD6r7922PrDEx5MmuGfw89vkw	12757	17935	17935	1619167500000	orphaned
25819	3NKwb5g42ZPEBpc68MGp98DhUAY6HuiGX5wiuiNVoie8FVKrg46k	25817	3NKvmCGukReQ2hiDjPgsABi16f1QHpv1B8cCHNUguUQTd6LXD2SA	1598	398	493	12463	17563	jwFtHML6thc9HjKaww4AbAPcULGe8X7jUYvV3Lgx1r1egSR59Tx	12766	17947	17947	1619169660000	canonical
25827	3NL7h8zeopUqEHCqfPkc5AHuJiL5DBagY5WMj6ojkFEuorK2Zv5j	25826	3NKoLEJ2Hyc57diF1yjU4ksUnZQmadoBZoeGxyh7oR6LdiJtTVeT	1627	1139	493	12463	17571	jwvG3wF4bmWjimcJimdgsySZ5cWnjBtbwuA1jhn1gEDEMyrEWyp	12771	17955	17955	1619171100000	canonical
28745	3NL8PmZTXxL8UBnhRGQJYNC5Xg8UyQWhxX5m6SF6x9hyXm2R6q49	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	1506	1247	562	12463	18974	jy1eqb4KJV6mtatTmia4imtFFnZpMbZJKiZ1afZ8huFm3FUDLFg	14182	19978	19978	1619535240000	orphaned
25722	3NKJxLto2AJaKc9RzyVR8FgMPVtC7LiQLhfE963Ke8LGGyFo6Y9j	25721	3NLiqMvhFfXeXRWRFomn7nceehiT5LNhKQV4JzvJbVCqbjwFos8T	1520	48	491	12463	17478	jwhCZXPt6uhEG6W39wAm4WaqdzK9FxxQWzjizdXEhXYL23yN8Re	12725	17892	17892	1619159760000	orphaned
25735	3NKuthy7jy8nupUSPW5KrbDrm8f3W2ALnSvZ6ruqJo14MY6vc8MM	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1657	1344	491	12463	17490	jxvVDGrzo5tnKWsfpQqweETkNmCk8hHZe4MnRdRQjgUYgSEkBRA	12733	17904	17904	1619161920000	orphaned
25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	369	1186	491	12463	17495	jxdPdTHTaQiGNWEdN1ZvTUkSg9g464nyQ2zoLKiEAxMX8VeNCY4	12734	17905	17905	1619162100000	canonical
25739	3NLtGX9Pfni5v52aEVfH84C4hxQjCjVyaCn1D4f1vVy6xNuc1eeV	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	1553	776	491	12463	17494	jw94TzBLTPvqw7bV8RPseBFKWnkDG8LuFnvCU3ZxniX6M59fFbd	12734	17905	17905	1619162100000	orphaned
25743	3NKfNNGjEE1WGdXUXQY2KVa3PYvmmG1Jn1WSZF8XuqVfZngHpYGz	25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	1553	776	491	12463	17498	jx35D2RrUmu4Z9K6Cjs3g8J3GRaUr4ENbHn8CNkpwxS3KjXwcQD	12735	17906	17906	1619162280000	canonical
25744	3NLwFnZNdk1d38gnAUGmuM92BGLBtJoEcmuWjA2mTbZfxpejiwEo	25740	3NL7px4iPi6kXW8UoBP5vByrPvhZM4R6SX5mbDsETFrr1TcP1qs1	1448	945	491	12463	17499	jwLWfS4BkEgrXX91QnAuMnphckc3jozMtcyia4FhUJmavF51YfN	12735	17906	17906	1619162280000	orphaned
25748	3NLQzqEVG9fVrc15STtX27iVXCWbLzbrE9HiBgvfP8szhrTNTdUg	25743	3NKfNNGjEE1WGdXUXQY2KVa3PYvmmG1Jn1WSZF8XuqVfZngHpYGz	58	915	492	12463	17502	jwrJXRDDHPa1sDLaKA7qr81gdyT2TMPr6WA7TjCt5T157oZ9b3c	12736	17907	17907	1619162460000	canonical
25750	3NLi8fN5wUzDhD13R4t9RNqDHfTVhoueci4HDa6wYMmTY6EcEGSs	25749	3NKdb6q9WiBi4ec2zojueRXy5nvdbVvXphSkZs9tRr5uLjBDXVHz	1407	1395	492	12463	17504	jwQeELqNCLyZFS9H13VhqqqBk6VJWn1Nykxf6ag79rJeMWLSe75	12738	17909	17909	1619162820000	orphaned
25752	3NKQBd59AkgW6FMvrUHXWeXjLQWk7YJVD63hsLtXLtwz8DRKJ7fC	25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	1483	1030	492	12463	17506	jxticykRuoCLws3S3xaUMT56dM9TL8BmXj6nm3v5fppGw774w68	12739	17910	17910	1619163000000	canonical
25754	3NKij3vC4sJpvWMBWSRd2Z1RuaL8dSGeU2Yvc943HANxbc4pP9s3	25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	1634	1085	492	12463	17508	jxYTcqRHoWgdNRrXzDGJd8ewa9iscW68Nacb3toezRH7m5oiqaK	12739	17910	17910	1619163000000	orphaned
25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	25752	3NKQBd59AkgW6FMvrUHXWeXjLQWk7YJVD63hsLtXLtwz8DRKJ7fC	1590	1300	492	12463	17509	jxaXfxsPkzTH5BMjCQrSYXTPbTtfLPfb5PpiU7rDqn9Av6mKdAc	12740	17911	17911	1619163180000	canonical
25757	3NKtjfSmt2zxmrpchfnNs5RYh8eQSRz4FdszQj4CwEm4Jg7kTDBt	25752	3NKQBd59AkgW6FMvrUHXWeXjLQWk7YJVD63hsLtXLtwz8DRKJ7fC	1560	1291	492	12463	17511	jwFBRqkvNs9qbW8eZY6gYgQzRCt6kfxnMRsVSkGzYSKVGx8Xmh7	12740	17912	17912	1619163360000	orphaned
25761	3NKtaXirnLgj9jtCmfrRtsig9uyhQ5w6xaeANFwC19VxXHFmxuv5	25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	1523	1321	492	12463	17514	jxjYbYBdXB6mBA8iW1qcWNqMRx6NZjJwPEaSQRAXs9nPykxAobq	12742	17913	17913	1619163540000	orphaned
25772	3NKzJweiSZU9h6zMAJkyzArnEpnX2J7oGRVbi8Lbj3FvFYNyQGWE	25770	3NL86CL4hE967HQpY1yMYfj8NJjRYhzUhe9wEBJcbiUN4PyTDqBm	1656	977	492	12463	17523	jxgSSu8a6X6TQnLibQN1LD3k9M6GtvLTfK8XVqvWfjwEYtZSH1T	12746	17917	17917	1619164260000	orphaned
25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	25773	3NL5C5iLcK9XKBzAkoPvQdFQH2o1QbnVkCLRN5Te2yvmrs5T7t7V	1623	830	492	12463	17525	jxAFmjVMv1urcsh8k4BB5rsuZYAyhCioLFd1zshnPxsvYCUid9F	12747	17918	17918	1619164440000	canonical
25779	3NLaeyYkQSDHv9zVUWwJyWaiAH4pp1p8V6PXrM8PU3dmn67oWa2L	25775	3NLnoNLSwKZCdj2XC625q2TZCau4imMQdX8jjLq5UTXbFFiV5KYj	1506	1007	492	12463	17529	jwG8Lhdu759bLikNLYiccVFM23cmQnDC6xNpZikNJiiv2UKnXMr	12749	17921	17921	1619164980000	orphaned
25782	3NKMSD9t1fDXN5U4cD2kr9wEs7TE1iV3fHtwD4THXTFpVUkWVAqb	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1608	1289	492	12463	17532	jxPs9pP89T8vUMweWNhFwuE1n8Yfjbi6iLj9V3Xp1SuE5m1uQZn	12752	17926	17926	1619165880000	canonical
25785	3NLTMTfqQRuREdL1uQq6NYp4D47TkSwTWcmGewtUBmgFRAvqxYpZ	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1541	932	492	12463	17533	jwzcE6Qz4DkwayQasv1kMuZmsDfj2EDYQGerb2ngP19h8qSNR8v	12752	17926	17926	1619165880000	orphaned
25789	3NKMUXeNoBBwWWo1ghSfWCB2XMMh2WUTwtD6D4yRqPxj4J8p6sd1	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1451	1046	492	12463	17536	jwEhLRqPmaZxhPnfSNqJAkrScje7ApN81kgpfKVaNx8CDy3PbLk	12754	17928	17928	1619166240000	orphaned
25791	3NL4hi3vZuAzqTLvq4bSd8PirqYZTWgHumUbs8iqbKtggRYY7e4C	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1451	1046	492	12463	17536	jxfyqVKXpAtdnLDPxs5FyfKoHkNk7rJHH2JsXqM6raJfPWRSsDE	12754	17928	17928	1619166240000	orphaned
25793	3NLvxaAruq6c6yz1E3s4uDc5YeJZa92W816JFL4wwEpwn3QUhNWk	25788	3NLfEnF8MutbxKwuvAiKLGx6Vgpqiha1QQSxK5CchV1ornhtfCeM	1407	1395	492	12463	17539	jwpXt1chjbgUcpZ7dRbasncKMsXY7uVjBMnUkQrHqffr4urLGEg	12755	17929	17929	1619166420000	canonical
25794	3NLMsFNbyZkQQEsJCt4nGHw2JwXD1ZufacVzLoPLBrXwn1TeTZhc	25793	3NLvxaAruq6c6yz1E3s4uDc5YeJZa92W816JFL4wwEpwn3QUhNWk	1608	1289	492	12463	17540	jwQ2cUeRH6h9eL5KVxKr5GEjM3e6hD2bTR91xrhEj9SBDyk4813	12756	17934	17934	1619167320000	orphaned
25799	3NKh9q5xAHcuwcrhAb8tRUUvrML8at9SQkrNAZBmJniqvqQq7T5H	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1406	1393	493	12463	17543	jxrU9B8YVtYZejoCFHMXTrmp9rwkQzwcQhZ2Rd38xhjaHxFafrf	12757	17935	17935	1619167500000	canonical
25797	3NKNZBeMMnUirfURtCkh5r7hwc5Mk7giAF5GEuUNVhJZ3TWchZ9P	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1523	1321	493	12463	17542	jxcLoNdMbdaWYyH69EkwTsj99MsCeUeZeqhM8wrAvypq4u9m4hk	12757	17935	17935	1619167500000	orphaned
25803	3NLxDRwWHUgqvsebGP8KcZJCetZkrZMKyLDtZ3Mj5VKydceHATby	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	44	1325	493	12463	17547	jxvGTdW8SZdiUUghyTWqHz9Z6i2T4ubjGak4DVc5sXNQMmknRcL	12759	17937	17937	1619167860000	orphaned
25805	3NKFLHTpNGXzRXuQyXNpVeKUR4RWZsftjstXzN7hmm6PD2KhvjW8	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	1611	1341	493	12463	17549	jxeKk5pAQtk3QF9BxKgvmuqgtR2Cjj1LLsmuHrhiR4vXVTRHf6S	12759	17937	17937	1619167860000	orphaned
25810	3NLWhNbTEgWoNuUVTp62AajHRtnX5WuC1GLPjjNR37ZNirNpSCmr	25808	3NKmT1fG7Sv6QTt9RPHJ9yx1WRCcgQwXyFzZ8U1XRo51aiQrPQXm	1407	1395	493	12463	17554	jwBe8SXXQbHiqoWiCLb8f38ATyDYdxxEW2ivfEmEFhU19Z5nbVn	12762	17941	17941	1619168580000	canonical
25812	3NLF8jmzuNztubLj7kKzctp7pn2ap8o1oWFSDxwoD22rjn8Z65g4	25810	3NLWhNbTEgWoNuUVTp62AajHRtnX5WuC1GLPjjNR37ZNirNpSCmr	1507	1034	493	12463	17556	jwZ6kaCjyvnoxAWjE4BKT45mjDMAYe1KeMBAVXtSRLYTvHMRLdD	12763	17942	17942	1619168760000	orphaned
25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	25813	3NLf5fzjRVfJ763QhrtWA99VnaYN98CRye5vtzLw1SXSVWDkk4i1	298	1308	493	12463	17558	jxRc3j5pnqByvgM9e4JBdJB6aXQjwxC2prPHzYVRPZ49oUQPJ5y	12764	17943	17943	1619168940000	canonical
28849	3NLh8YwYxtCkfZpE5RC8eSxyx9iGzsnBk7i1nXKj8Dk7no9eTyJJ	28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	1602	1123	562	12463	18974	jxkua65HPrMSrLrUbKStYwE7M399u8atxHQw7XRZ9JtWXHzSNNC	14189	20039	20039	1619546304099	orphaned
25777	3NL3KNpBpxEXtyjV2J3GgBnvUZfskjRUsP15z9yZG5yFw2VqSav1	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1506	1007	486	12463	17528	jxU6RUkdUKNVwS1XVT5uJW3MiK9fkMMxQYrxrTAbyhWGu463uJe	12625	17921	17921	1619164980000	orphaned
25835	3NLaZxCQ5o39qxMEtstVrUT7ksSTBvHUKG1R7bxMFVZXLdEEXymp	25703	3NLuah91PXz8E5EFwi7HSXCPRyTnCs7SS57a1X1LYXcKv7vsn8uZ	1513	1379	488	12463	17579	jy3DBnwtNa7w7e26HdfHLapreap7aojB8cs7UNmnNmn7JGfBNEW	12669	17959	17959	1619171820000	orphaned
25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	641	1336	492	12463	17513	jw937CuzJQpEPz9fx3YaCjkkTfkkhuyWTo87o1FPch347S5EJVX	12741	17912	17912	1619163360000	canonical
25762	3NLHnz6XfkuTYpCqbbfX1fmvUd6ksQKDqw7kygaKxaZcvU8cq3nu	25759	3NLF41CbtuAJA11z7Ua592ipa1x7mQgZ919Vj4MzLn5TRmMEb8cy	1523	1321	492	12463	17514	jxruFXLwTBjQshBDki4UzMy9xZ88mq9MMh5CVftz8ftyUQxP4Yn	12742	17913	17913	1619163540000	canonical
25766	3NKB7prweAm9qMUVCn9NsZScgYyX1k9ypQUrm718LQDrJXrkAUQs	25764	3NKHjE7Jj3LhUrJfheHk5qFX7YW8hQ2TvKqFoks5WeACKN7x9J2b	43	1184	492	12463	17517	jwcKAE8SH17mx1CneyRu7BrhczgXRQRMMFkPZ4g62hzkydd8eZG	12744	17915	17915	1619163900000	orphaned
25770	3NL86CL4hE967HQpY1yMYfj8NJjRYhzUhe9wEBJcbiUN4PyTDqBm	25769	3NKrdYESkiPcR8cnfFNmWE9oq4y4CiSQKo6SJZJELXTKsJGyNt5R	576	1229	492	12463	17521	jwxhSZVNdLzpTfcZtL7c5q4MqRxqLVNX8ExcJar716xyiRQJigd	12745	17916	17916	1619164080000	canonical
25775	3NLnoNLSwKZCdj2XC625q2TZCau4imMQdX8jjLq5UTXbFFiV5KYj	25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	1406	1393	492	12463	17526	jxN74kVW341Wyu2Sp1FtA5gPKZSEaHGra39x8BsmuNk2Co5AyKf	12748	17920	17920	1619164800000	canonical
25780	3NLt914tJBX8xRbS2xRHYN1f5wGAEdV82qUnhb9jkpc6g3Xehs3P	25778	3NLV1B8eaDpK6VUUAX16EXJLUmhLJn6gta6eaF41wxNjao3XFH1m	1406	1393	492	12463	17530	jxqNyQemntNSY4EGSnmbmeQjB5gZttJabejXNhYA7Tfb8icUtPh	12750	17922	17922	1619165160000	canonical
25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	25782	3NKMSD9t1fDXN5U4cD2kr9wEs7TE1iV3fHtwD4THXTFpVUkWVAqb	1403	786	492	12463	17535	jwgEczqsVFsGjYnuYuJ1MdkMeLJFrdo7LNQeX3PHQKPeHozMC7k	12753	17927	17927	1619166060000	canonical
25792	3NL7cVYHJYp3QSH2v6xReWDQnFmDR7DzPMcvEQWdEKa2EwK3hS8w	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1602	1369	492	12463	17538	jwtoaDkpTAZzxc7wdf5JXkzvqnXP9ZbrL23eCVT3DohaGKxekxh	12754	17928	17928	1619166240000	orphaned
25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	25793	3NLvxaAruq6c6yz1E3s4uDc5YeJZa92W816JFL4wwEpwn3QUhNWk	1601	1022	492	12463	17541	jwkde48Cz7K8gB7UUR3kHgrDJ3NffANU7riX5vWAiKr5hHzHLKf	12756	17934	17934	1619167320000	canonical
25800	3NK3AKqdquyshAbUYEc5tZDyawkhYj891r6GTujV3ryuEa11r1xu	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1402	874	493	12463	17544	jwgMjXSTQvAajNM7vnts8P5qZdaZoiW5rkM9L8KwjRee6PhdFCk	12757	17935	17935	1619167500000	orphaned
25798	3NLYg7yJBQ94fDyKAzND1izehn1aeq11HGYmdgKTcrE6PexBvYa8	25795	3NLyLHCGMxBYMaUmRtieHNFUh6BdkzmmVwqCk9rdborF34udPAR6	1523	1321	493	12463	17542	jy39aMRdLipX4CVU3Fgx43xVaA9aSAJYFK4daXPFygPRLv2SDSt	12757	17935	17935	1619167500000	orphaned
25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	25799	3NKh9q5xAHcuwcrhAb8tRUUvrML8at9SQkrNAZBmJniqvqQq7T5H	1648	1284	493	12463	17545	jwiVt3iFBk2izFbZk4eotDDD5sP6tD3iser2oAbRLwPdCFuZ8HF	12758	17936	17936	1619167680000	canonical
25804	3NKMhpnZw1V7KfA17brTJtsB2e1JYQx9jxFytVX8uec1rkyuAKD3	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	1402	876	493	12463	17548	jwfXamJUsj6XYh8WN69c6kUmoeS2Av3KLbyBWngoLNPeWTddYmv	12759	17937	17937	1619167860000	canonical
25802	3NK7a2wD4EQpvtkS5sT8W31nH8KJf4N2FXxcQZihoQRcPFTdKDEw	25801	3NLjzmEwqb3HR6RMQ5MDtFXPWMrFzaQ7GTzkzckswqx8KF1kLLkB	1460	1198	493	12463	17546	jxiHPpe1wanLYtAmpQ451hoJVgzDxaysNZEqaiCGh8z8hYxF5uh	12759	17937	17937	1619167860000	orphaned
25808	3NKmT1fG7Sv6QTt9RPHJ9yx1WRCcgQwXyFzZ8U1XRo51aiQrPQXm	25806	3NK8uLwTgn8vwPGGPc2kyJ2c6Tg7B3GWDWQYTxgytiDjmQB986re	1668	1370	493	12463	17552	jwWBQszMWUpG5rKmsGSJiVcUBis3M99Wb1yZdFHMJh13ak7oNJB	12761	17940	17940	1619168400000	canonical
25811	3NL2mnF4pqbmMW2nH5eyWxMzCzoMspUWkS52KoC2S5m1wz3xXqEz	25808	3NKmT1fG7Sv6QTt9RPHJ9yx1WRCcgQwXyFzZ8U1XRo51aiQrPQXm	1622	1356	493	12463	17555	jy2g2ZStTmTEyS56jiFYkFme19C5DGDjnfR9Y6kvpu5V6UAm98D	12762	17941	17941	1619168580000	orphaned
25816	3NLcHczr4ZscTrMxMUgLeoqb8kvWphTK2Vg85b6fTkpY3S62y7z3	25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	1555	1101	493	12463	17560	jxdTnFNLWfzNwCB3f1znKxQSUn6CPUygYfqnEzMKJfFZhY1nNtv	12765	17945	17945	1619169300000	orphaned
25818	3NLZ6e4Hf9vpnbsN6LBz9HaFJ6Lskzp7gpZNNiX4eh8ymQw63wTi	25817	3NKvmCGukReQ2hiDjPgsABi16f1QHpv1B8cCHNUguUQTd6LXD2SA	632	1136	493	12463	17562	jx1AoYEb7WrdCKep7cu3Jj1osyoDfmzrgdygyEhqhsPwFj7dEXG	12766	17947	17947	1619169660000	orphaned
25820	3NKLQvpC14URYx2T7TzHKJHZhHiztJ5aWzPvP1pLoo4M7sgYjW99	25819	3NKwb5g42ZPEBpc68MGp98DhUAY6HuiGX5wiuiNVoie8FVKrg46k	1631	794	493	12463	17564	jxvMc4jBR3j8owtcpe7o3PJWHrJCvdczw9ZmjCqtAhKdfmxh7yx	12767	17948	17948	1619169840000	canonical
25833	3NL4sTHuVCuiTKPgjiNHWzxXiDnEoEYusMxEBSptvfj9fXXcfvCb	25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	1406	1393	493	12463	17577	jx6Fw3tLp57J8H8Ejii48DJZqGy1kJKT1Bfkm49d91LfxZnC8Es	12774	17959	17959	1619171820000	orphaned
25839	3NL73Vapw4i3pA5pFVfsgE8euZDnjBxtLYorqTF7JjkqUAevC4SY	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	1403	824	493	12463	17583	jxtaCp42cXcacQc9a59aFH2aXVh2q8H7eXgRk9FP7cLwUM1nh8c	12775	17960	17960	1619172000000	orphaned
25842	3NL4VnRYSpWsQXMF4ZBnoJJYUTCHysgTKf9AVwtN2s8Nks1crU6A	25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	1651	1175	493	12463	17585	jwgzEyxy2TyVAHxM51aB6WnKXuSDUDi8pB2rbmUTfXzChw7xe9V	12776	17961	17961	1619172180000	orphaned
25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	25840	3NKsDUDBNEEcBx6AcBhbfej57XQSt1SzzzGh2JUgeDZ6mnJga5Ek	298	1062	494	12463	17586	jwYNGsvVn1SQM37o76fPVXcr9fV8ESpLS2XGdccEwxqwYAgnLoE	12777	17962	17962	1619172360000	canonical
25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	25851	3NKwezX3ZNmbCSkFWVB76ijRw1UoCJfEBVRsTBuRd1Whon4mmbxq	1642	1367	494	12463	17594	jxAevzkvHx9mtHWPCeRUBX7Dr86S5P65fTNSnFwTPqcJPPitPid	12782	17971	17971	1619173980000	canonical
25854	3NLfijTNeZvaH3S6sPs3gnE7NLQBvf5M28MmHmR8VPYyzzheEyR3	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1523	1321	494	12463	17596	jxbta2rtydCP3kbixFjqBNz33UMYJqyUaJB52rSGmrjTz7KCD5U	12783	17972	17972	1619174160000	orphaned
25857	3NLHandjFbj7a4hJKW9EaaKQs31HauAoGVxr4ZqDyo1RrcuUaUYs	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1403	824	494	12463	17597	jxg7xm5qj4YKtuvzRVpmaPNfw6n39orw9SdoB8VwW2U5hK5JpfX	12783	17972	17972	1619174160000	orphaned
25863	3NLpPezZ8BxcnJ1Yzm6ygQR9UqHwW8L8euNVCAhduQN2N9x9gr7F	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	171	1008	494	12463	17602	jw73jDLHNutrWLywqTdK88zNFvWcBZMyn9JyvTrmNwgHveoLhXa	12785	17975	17975	1619174700000	orphaned
29098	3NL8UqfGY5Jztrf193abyv7TkzLzRwpNSKSmLTdJpbpFi6cvQocy	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	606	1049	562	12463	18974	jwNkfjUtTEDPKtDcPJvBEkjS6y8wci4PEdWV8fWF4RuxvFEDdJ4	14190	20193	20193	1619573940000	orphaned
25807	3NLrCAYT3crNBE8xrDPWsNhfH1Jcf7SwuNmw7jRA5MCrP3qsE61u	25804	3NKMhpnZw1V7KfA17brTJtsB2e1JYQx9jxFytVX8uec1rkyuAKD3	1405	865	493	12463	17551	jxR1jQXNA4rTbB2qyTY2cg2UjtqpyMGN4Tc9Dug4uid61vcfTd8	12760	17939	17939	1619168220000	orphaned
25809	3NL9CwWTfoB1WcA4n7oq5RiUhNNLKQVUGjZSKRBHNrPP2sh6Y6U9	25806	3NK8uLwTgn8vwPGGPc2kyJ2c6Tg7B3GWDWQYTxgytiDjmQB986re	1474	1083	493	12463	17553	jxiMwTciGkwkxfm9VXeozZnRywLdsxZjsuqQp7PmmDjyFxqqM93	12761	17940	17940	1619168400000	orphaned
25813	3NLf5fzjRVfJ763QhrtWA99VnaYN98CRye5vtzLw1SXSVWDkk4i1	25810	3NLWhNbTEgWoNuUVTp62AajHRtnX5WuC1GLPjjNR37ZNirNpSCmr	1623	839	493	12463	17557	jy2oGMrCQAtdwM6CrfggPJgZm9TqP7bPW6f24jKeyfZNcmQKjiH	12763	17942	17942	1619168760000	canonical
25817	3NKvmCGukReQ2hiDjPgsABi16f1QHpv1B8cCHNUguUQTd6LXD2SA	25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	1623	839	493	12463	17561	jwyfHw9G5NGGZBcsuT83e9e9cAmuHLDrAidyeisBtpAFFeRaNvi	12765	17946	17946	1619169496856	canonical
25815	3NKg9GMggQfX1boN3mXsvCwinPgBRjxjPeffi8zbfRqUXyTB17sG	25814	3NKfuj63hTsU2oH9NFncpqUjeTGQazWciNfrsk1Rp1KuFcMjEfSG	1483	1150	493	12463	17559	jx7Xft1SLAM8aXSbsnGnLxYhudwHztgWsefjd1jemqBuKDEZsrZ	12765	17945	17945	1619169300000	orphaned
25821	3NKL6vwpQW5mG9eFi9NHA6z4QGMo33RLWxKCN8USZqPiorGM77eN	25820	3NKLQvpC14URYx2T7TzHKJHZhHiztJ5aWzPvP1pLoo4M7sgYjW99	1609	1333	493	12463	17565	jxoy9XCKRyZpnoe5zGT46Wj92zdiwxhuHBTHrT7eAVfDtqFtV5Z	12768	17950	17950	1619170200000	canonical
25822	3NL47ki58hzTdAPDPTaQMoU5zYZzcM8CbCEBid6zU8m13pqPqZdM	25820	3NKLQvpC14URYx2T7TzHKJHZhHiztJ5aWzPvP1pLoo4M7sgYjW99	1560	1291	493	12463	17566	jwAdh8ttpbZgk8xi6cn7joTk4b6mbkBNdn9FWVvzGUmnh812UB8	12768	17950	17950	1619170200000	orphaned
25824	3NLANFZLjqSRC5NZFGyJFK9KvQvPUG3Ze87Se1DzEn1c8YM1VpV1	25821	3NKL6vwpQW5mG9eFi9NHA6z4QGMo33RLWxKCN8USZqPiorGM77eN	1590	1174	493	12463	17568	jxuxDWMTL5UWkGAxdH4xnGre9RDxGxP2KaoY11Lnyo1FqZNvyUA	12769	17953	17953	1619170740000	canonical
25826	3NKoLEJ2Hyc57diF1yjU4ksUnZQmadoBZoeGxyh7oR6LdiJtTVeT	25824	3NLANFZLjqSRC5NZFGyJFK9KvQvPUG3Ze87Se1DzEn1c8YM1VpV1	1650	1129	493	12463	17570	jxy2eCzgXZGPxPnDm9ZpASzSV8JX7QPNxF2vYQKTUUoSaramaKn	12770	17954	17954	1619170920000	canonical
25825	3NKicKkKkzdXngKCHx1mz62bn6CSbXGApN6kRkEa64DVTmTqv9vM	25824	3NLANFZLjqSRC5NZFGyJFK9KvQvPUG3Ze87Se1DzEn1c8YM1VpV1	1405	867	493	12463	17569	jxULcpqJmsDevN1JP6oVCaAGcACmh8z8L1LuKuzVzRBMPE7DPiM	12770	17954	17954	1619170920000	orphaned
25829	3NK9nTHaLdZGn5hb1dWHgnWQxDyKS6369Z81o7hGsvYuBxTwAYCk	25827	3NL7h8zeopUqEHCqfPkc5AHuJiL5DBagY5WMj6ojkFEuorK2Zv5j	1406	1393	493	12463	17573	jxkoXkmoru5AsADZxZvGp1j6LJ21dAUkmrNXBnSLWiufpQLDBen	12772	17957	17957	1619171460000	canonical
25828	3NKSSpbpb8KXwYduuCN7jUwvgV6pQVkXW8BkDfqcZazqUDp7s9Ud	25827	3NL7h8zeopUqEHCqfPkc5AHuJiL5DBagY5WMj6ojkFEuorK2Zv5j	1407	1395	493	12463	17572	jxW31v6T7UfKCVC4W8yexu7Q14FUu6zY7uq2bDA2oL52FEU3G9R	12772	17957	17957	1619171460000	orphaned
25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	25829	3NK9nTHaLdZGn5hb1dWHgnWQxDyKS6369Z81o7hGsvYuBxTwAYCk	1403	782	493	12463	17574	jxTcJrYjJn2a2VGzPZrrevMupaoXaQq9c5hzZ5zF2XuArRtSPvj	12773	17958	17958	1619171640000	canonical
25831	3NKcUuoYGizu2Le5ptJkYWTJgY1jjnAYagRvPKvyHgF4pBTj1C5D	25829	3NK9nTHaLdZGn5hb1dWHgnWQxDyKS6369Z81o7hGsvYuBxTwAYCk	1601	1388	493	12463	17575	jxZVNFexp5kZ3dt1nepUjdDm1y5iZnZoQvQS8XjsEMg8qvW1jhp	12773	17958	17958	1619171640000	orphaned
25838	3NLhoPdNd5ND8W2NSHA3CgiSiTq9EtecdyPkb2WacBqk6NqWPMuC	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	1419	814	493	12463	17582	jxvTXw5cnKvVWDZjk533VujeJz8saRdpFgydkYGSm4uZY3wczUu	12775	17960	17960	1619172000000	orphaned
25840	3NKsDUDBNEEcBx6AcBhbfej57XQSt1SzzzGh2JUgeDZ6mnJga5Ek	25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	1405	851	493	12463	17584	jwwJCrfWyv1TJRM1j6LdZ5XD8MfZSwvgpats6iiMXs6TVz4XV8p	12776	17961	17961	1619172180000	canonical
25847	3NKAXEXAAj6AeNLGvVPvFnY4wSnuZdRfRLK6WoRetQNeTfqLinsh	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	1647	1176	494	12463	17589	jxcsQiuKXEhBm6zn3q3fEEYPoJ4MmBdhZJDS99DHBarVwrfADxV	12778	17963	17963	1619172540000	orphaned
25849	3NLMws488Ymzx6Sassk9k461SJ5DNVNPHuT44Zr2y5X3SftPxURr	25845	3NLfWUq6BSyWzgC1626MVFTvHmFSDPVNHH9cWc8W4BT3LmGkMjgY	606	1049	494	12463	17591	jwpQK4bF3ZMvNXR2iQEYXMXw3aTs9MYgfvZp8ampusALU9n6Sb5	12779	17965	17965	1619172900000	canonical
25855	3NLMdwSk3EHfPce4WQtR4J6m1tE5CZzAve1V7rUURtGgkimriFaq	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1523	1321	494	12463	17596	jwyCJFLrvhJN2jTg2BjpAGLhDNPEzW2umvhKL1ixri2QU1Rhnak	12783	17972	17972	1619174160000	orphaned
25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	25856	3NKANPjqR8yhbsiwX68uGfypPisMjLkTh1XjM2Me9xMSst46x6qQ	1579	1263	494	12463	17598	jxb1kaXGpbK5qFjuNVUiFFiJt4JN5LBSJvLFtGSm5nNEJ7Qf54S	12784	17973	17973	1619174340000	canonical
25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	25864	3NL4tcn9CGMKQ9fn3RM4SCqViMRXk5KLdkhP9YHTJFUAAvmPWtnM	1646	1108	494	12463	17605	jwdi8TD5uPvVNApWGhXn1svbCQNQQWyUJCeCc9LNdZxDJbbRNWa	12787	17978	17978	1619175240000	canonical
25871	3NLEut8HgLjsUNK7rgmhBQDXtcmpi1fq2eaiaTmV7uE8A2k6noJe	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1534	81	494	12463	17610	jwwcv4AgutZfs6p4LYGsfh74yT7YsudfmRppfVxTqzeA2s7ULq9	12788	17979	17979	1619175420000	orphaned
25873	3NKrmu9DTXF3HMUQqqENk6UvJMAK3wBh9L87We9NjgHXuBotuLkX	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1523	1321	494	12463	17611	jxm7hRjSnyaBXJyX6PwGoazKjWYvNoXuAqbnGH4kXBAYmBUFHHB	12789	17981	17981	1619175780000	orphaned
25880	3NKre2mfADT4tWZR7dJosAUNBzLz4tfLsp2cfdDBnUdJLbYfKXgX	25879	3NKrFuKAqbpJqXFUjbw8j66boGdR5QTnE7dYhdxU4egs7F6AXQT9	1445	1044	494	12463	17616	jwr5Kgn1tnnh4x48Vspsqw3hiSLRB7NVvCDp7YUmNLs36A1hFyt	12791	17985	17985	1619176500000	canonical
25882	3NKLwnhunmnNuMz5SsgT5gsYguuz24nNP8TXxwxaYhWTCep1zqGE	25880	3NKre2mfADT4tWZR7dJosAUNBzLz4tfLsp2cfdDBnUdJLbYfKXgX	1507	1280	494	12463	17618	jwuBcQmvvZRhiq5LEsRSiQ1Dp679YskuGPgyscnT3n9zgiJGsGc	12792	17986	17986	1619176680000	orphaned
25889	3NLcNxC2iqhmrTPS3cEgkiKAu6iXMnPXPXPQUPqtBX1wSe9KHq2Z	25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	1553	776	494	12463	17625	jwZEQ349EygL9CEbGhaR4XjECq3drc4Mukxa8MjJopZLRfNTmxw	12795	17990	17990	1619177400000	canonical
25887	3NKWw3JT82tr8Jy9k9oArY4rNK69qiXi9SYCgSioHuxLbfTgChkZ	25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	1564	1092	494	12463	17623	jxjJKkjV2YxN5CG5Mbt4StGfTAgtNSuegdZZLk7cSorpHVbgU7g	12795	17990	17990	1619177400000	orphaned
25894	3NLJdKPyJVd314WJtUq3VR74SU49mqS1qRvxrML7LxwyZ1jc4rgp	25892	3NKhyxuzDsmX9FGarA9E2zvmKXaQgx1dzubLzV6eH29SVqDeX7ur	1406	1393	494	12463	17630	jxrvEjpSHwRcxYbKyFL6gkziT6MnYtudgXKBT1hHiTfjoBhDnFZ	12798	17993	17993	1619177940000	canonical
25898	3NKXNEdAP6ig7QT9ame7qsfNdRidePFUCD3WFfmgxewdajXzNAzg	25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	1445	1290	495	12463	17634	jxrNfvJDjmbMTkdCRpwk7FFUwtAcmtBdCkZSA8FWr8bmzq5H41e	12801	18001	18001	1619179380000	canonical
28775	3NKuWWvJyjUBTddbx9G6eTjfcsuvYCW3HPUQAHjnYfGD7i2mFRcx	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1522	956	563	12463	18974	jwKkvsAmoGDfZiVvUHXMgNBzBxtBfoNzEBWgtxr1YgoHQKkgscF	14194	19994	19994	1619538120000	orphaned
25944	3NLffgXbpdPUmpLFXseDFvVtE4NoikbmzMY5NNw58NFwqCn1vFwV	25432	3NKHqDp6qB1nRqKV7WhuNwuNPYdRD4VUpEQT3YC2MTsgi4yGSpEr	633	1258	485	12463	17675	jxfAgupAp1LYrKpY514NwhLwpU5NQbCEj4sSgfEfVjGw6n5XjC6	12602	18037	18037	1619185860000	orphaned
25947	3NLjk4nfA1ucfCNtctyB4nkXE4BK4tmjB5kH272sznNe39YT4T1V	25465	3NK36hqMgznG8XawdvGHV265Wmi3ZcfK9cPt71p6tMBPEYJhSLgT	633	1258	485	12463	17678	jwehfj4ayrvhhXxUQEtf5hbXuz5w9CyYMSKW8sKgjnot7c9k9F4	12614	18037	18037	1619185899958	orphaned
25950	3NKFYpunjLXNgfbaB3Afu6ut9QNbituDizzGojHvb1UWVdi7RSAF	25523	3NK6bMePuY81EY4xRoAoDKQNGo4irp7aCTThzUmgNHNmEZRgkCkB	633	1258	486	12463	17681	jxndfiNzcjL48Vh1W9vrqKuQpENYHT828nQA2R5t728ktVmqSbM	12637	18037	18037	1619185977372	orphaned
25865	3NLovBAwwBL6tjrcrrS4Ln7ToyFMDBbQFKMTJQa5YCC91GMa6k6g	25766	3NKB7prweAm9qMUVCn9NsZScgYyX1k9ypQUrm718LQDrJXrkAUQs	1646	1108	492	12463	17604	jxGtWA9yKAkBfHXUzkxUUjRKmhDzUW2wNBwf6C9bKps2EPjPfWi	12745	17978	17978	1619175240000	orphaned
25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	1489	1380	493	12463	17576	jxgX7eLYJFuGFsAGWo5ezWhFYuHLWw94ubFPmP2tVKVzVu9bS7E	12774	17959	17959	1619171820000	canonical
25834	3NLwWWVJWhBnqTdBFFWbMhTPEp43uZcPLxjswUDAyBfRCrVmYSzh	25830	3NKAcSR5km63y2kENu5i6RKegMPTevtSf2SyunYgtNt8oSDWPfzT	1405	851	493	12463	17578	jwzo6WSci944JRCyQ5HLooKNKtCRpCReByrJuXrZgxTTNM8msLm	12774	17959	17959	1619171820000	orphaned
25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	1637	816	493	12463	17580	jwfMaCkAMUVeUmsfziGYDHJPuY58GT2M2xsNNqiR6j5nZ1dAHNU	12775	17960	17960	1619172000000	canonical
25837	3NL9qoXKJS2EsLZwxev18AH1Sj1WeXBceEtT2acostqDkVe1adwB	25832	3NLtLJnRNC9PHJW7PCxqWgi63qUcFQeAAqPSFtzgqNTvTCep8SCd	470	1063	493	12463	17581	jwVxudn8FVc6fCV92ofV2ELGYEFz4ctMoWFD2hKX9gfX34bQidu	12775	17960	17960	1619172000000	orphaned
25843	3NKE2C9V9ZBehvbHgY263bQu1Aei8Vjy76miQtdf7Ub63TZT3tzW	25840	3NKsDUDBNEEcBx6AcBhbfej57XQSt1SzzzGh2JUgeDZ6mnJga5Ek	298	1062	494	12463	17586	jwYNGsvVn1SQM37o76fPVXcr9fV8ESpLS2XGdccEwxqwYAgnLoE	12777	17962	17962	1619172360000	orphaned
25845	3NLfWUq6BSyWzgC1626MVFTvHmFSDPVNHH9cWc8W4BT3LmGkMjgY	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	1407	1395	494	12463	17587	jwy26RSFrHaShKmUGheax75zoXSLhXNi8C9SJLYx4jhLmeG6qJc	12778	17963	17963	1619172540000	canonical
25846	3NK93fL1o1cR11Vceko8xj6MQXmbo5ZCL57kemmCBx6UU9HXWmWT	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	1637	815	494	12463	17588	jwWnqfjwjgkFMJ5Z4QxCh7tWybZH2G6ZJo5HtgWpS4y1Crb2dq4	12778	17963	17963	1619172540000	orphaned
25850	3NLS8UtkENVTbwLwS733d2oTUdBss9wqFZXoLJgpnCE17dsBF5PW	25849	3NLMws488Ymzx6Sassk9k461SJ5DNVNPHuT44Zr2y5X3SftPxURr	1402	868	494	12463	17592	jxkE7BbE9uWNtNy33XTi96dqrFtWjnybSrAm2eVoXkwKNJuqseX	12780	17968	17968	1619173440000	canonical
25851	3NKwezX3ZNmbCSkFWVB76ijRw1UoCJfEBVRsTBuRd1Whon4mmbxq	25850	3NLS8UtkENVTbwLwS733d2oTUdBss9wqFZXoLJgpnCE17dsBF5PW	1407	1395	494	12463	17593	jxf2x1cjyPwWqjsbUSJJWhuH4mGFJAXuiVexhFfteUiwdH4QtZ4	12781	17970	17970	1619173800000	canonical
25853	3NLamhQsKRJo9oXXXimShxjHdaD4xAderXDknkzoHz8nfcEgnsNu	25851	3NKwezX3ZNmbCSkFWVB76ijRw1UoCJfEBVRsTBuRd1Whon4mmbxq	1403	824	494	12463	17595	jxBafS8kr6FMuTZqjwkXVeY9tRBYaDZJmC8vCDQzLa7Y7YKwqbX	12782	17971	17971	1619173980000	orphaned
25858	3NLMd1SkZ8GQ1bi17CSK8TZtU7h9zLE19MFX2VN7FgBnmAdGBLYa	25856	3NKANPjqR8yhbsiwX68uGfypPisMjLkTh1XjM2Me9xMSst46x6qQ	1579	1263	494	12463	17598	jxwso9cJHz5WezsceKQQKFdufNEKFMKzoh5sLozidJgTtfDF2P1	12784	17973	17973	1619174340000	orphaned
25861	3NKZExTzBz2uhfPSagbaNAswBkTYWuZbfZ6xd9jk1AN1Xg2KLTK6	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	1588	1146	494	12463	17600	jwwhsqgRxaeT7DY8ieoPCwRJXdx5LWfNpVBzeNXddJkt7kZvj9g	12785	17975	17975	1619174700000	canonical
25870	3NLdtKXkbjdY9Wz5XCGc7aDvvAxGpKeBzVZU24s7W661XS6NN6Ux	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1402	850	494	12463	17609	jwjVWACXb9iZbWqSHq9RQjGZzs2DsvaNkRqfeH5BcFoXEQaKsum	12788	17979	17979	1619175420000	orphaned
25875	3NKhyxQRHLxbAyJd3sWdQHf2T75AGqKvyV3x9zfnHn52PevyzimN	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1523	1321	494	12463	17611	jwAMNvheoJvmBciGrY1Ebt7Xz1m2iFDw5HqGYGqb8deVn6eCEsK	12789	17981	17981	1619175780000	orphaned
25881	3NKrYZzyTTQiLQge6ZhHovYAmWBft5GXV5VTz6tFyijCW8fEQhG3	25879	3NKrFuKAqbpJqXFUjbw8j66boGdR5QTnE7dYhdxU4egs7F6AXQT9	470	1309	494	12463	17617	jwkQQULtTw6dEpnZqj3xPt1CkJKePb6mCSr4k659j9ooFQ5PVum	12791	17985	17985	1619176500000	orphaned
25888	3NLp2g66v8Po6LzWpo1udwoYNu6poFPQepHyCp2EteYZ1pKTYRuN	25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	1406	1393	494	12463	17624	jwXscCH1sN1ebHuED2xF365Z9Mqgjd2h4DY7V9A2ZYAHr74XidA	12795	17990	17990	1619177400000	orphaned
25901	3NKcaG6rJzNRxNDKL7QdP9vmAi6NRTEcimKYCjjRv6EUy5pS28mm	25898	3NKXNEdAP6ig7QT9ame7qsfNdRidePFUCD3WFfmgxewdajXzNAzg	1546	1339	495	12463	17637	jwdx5hAUc9uqtEgURaAr8CmXnZwV5bGFwxaByZhY8MseJH3VNF5	12802	18002	18002	1619179560000	orphaned
25906	3NLBXQqHdbZHoYTFBHv2GMv23AhjvJjpBGsxZPuTP2XLhoNZwMmM	25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	576	1355	495	12463	17642	jweBftKmZ9T8F1uym2TNpjhSEwRUX9vfRr9Lr8ffRjTwvUE299V	12804	18006	18006	1619180280000	orphaned
25913	3NLVCw7WYujiaTS7k1DkVr15RE8dwr715x8bTqYu6BCWxAXyR5sK	25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	1407	1395	495	12463	17649	jxBZnbHwi1TBSbo78oijQVX668xNctYwgvHQLrUSs198poGaucK	12806	18008	18008	1619180640000	canonical
25915	3NKB1ZNGRt87kLCBa57X7XB24D3MwyP5HwvJcBYKxhoPRzJuTMMT	25913	3NLVCw7WYujiaTS7k1DkVr15RE8dwr715x8bTqYu6BCWxAXyR5sK	1578	1296	495	12463	17650	jwzPi6AQgxdaRetfND6PgdBb5YSG15CpJPUevRViCNtFvMwgUcW	12807	18010	18010	1619181000000	orphaned
25924	3NKtkiNL3PhZvKSyaJ8W5uZNhUETLGjnUWpEHGSCFtPsbzUVUFyy	25923	3NLFJFj8bftQS8hnMT4HHyx7QUuRqfStpyeTnJcuANDQxHheVEX6	1623	830	495	12463	17657	jwjKgqQse4jqzmTcvpA2cMYyy3JtGKPT4oppJ4fuNG7m3pmYSdf	12810	18013	18013	1619181540000	canonical
25927	3NKa2rgzWjEsjDBp8nK6QKJyiiDJev2mm3Q4EDHnjWycNTch3uLH	25925	3NLHfnbBmXevHbqTq5anMfvJsD6uRMHauCccCtwAT48Bb85xeTbU	1481	790	495	12463	17660	jwmm3UJqsxgHN7zwdbumze6N7KrJNUd7uepnBkzYzKDGnH5TS9d	12812	18017	18017	1619182260000	canonical
25935	3NLUWPyFvxHn1Vf62e4tnoJGCX6UD74xPp1XHPx2poS5Ld1Aa9nv	25934	3NLTZDcRDea2ZHzZzs2KDPMUZrH7sEyemFSu2jSTgx9ZvUybt4rT	1542	1178	495	12463	17668	jxuw7bn8xwg1vZgnuQPyA66D2PYM2di9qg9dGgt51c2oEDhZRqJ	12818	18026	18026	1619183880000	canonical
25936	3NLuZA7W1hwiFyKHsLmvSwzNuEPvUAYWG3vZVdog5Vo61CMKj2iQ	25935	3NLUWPyFvxHn1Vf62e4tnoJGCX6UD74xPp1XHPx2poS5Ld1Aa9nv	1631	794	495	12463	17669	jwvhd4jvMh6BCNy9YYQL6p1GxooWciTXuaa8steEHRCyjEdX17g	12819	18029	18029	1619184420000	canonical
25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	298	1062	495	12463	17673	jwffMHnTG2HAr9n7dygUiaVKesxD3XFJezKVE5vydiQmtqpruWF	12821	18034	18034	1619185320000	canonical
28810	3NKSnFhhcT31Az8Nt94f1AKeHX1feKMJAsNy7T7F8cgeb1QUhpBL	28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	1434	642	564	12463	18974	jxvKrncPaUSerJ8EDE85PkpdoH22HRxzJ99mf3ehrfnti8WFWtq	14210	20017	20017	1619542260000	orphaned
25860	3NLjkf1YJbrm9LrvceBB17KBXiARwRQo8Uqv5yDzidZi3PKSJmLD	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	1407	1395	494	12463	17599	jwaCPX8SSE3rnmRKMtcTa8DifgvR7GCY3WsSEUv2QD8anbiSNx6	12785	17975	17975	1619174700000	orphaned
25864	3NL4tcn9CGMKQ9fn3RM4SCqViMRXk5KLdkhP9YHTJFUAAvmPWtnM	25861	3NKZExTzBz2uhfPSagbaNAswBkTYWuZbfZ6xd9jk1AN1Xg2KLTK6	1405	861	494	12463	17603	jwL6XRW2VhbfxUgMtXc5S6JqAUdscpbcUbG6JXDNt7u3z1UsNKh	12786	17976	17976	1619174880000	canonical
25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1587	1357	494	12463	17606	jwCrdkKBHTcYMae9Kv87kTZj1Fb2sGmB4Sp9PnFqjS9zGxzQPTM	12788	17979	17979	1619175420000	canonical
25869	3NKqURnsu3ho9Ziqf8QfiWofebSMnBDyKY19tpoXKBD1qtVoWuTZ	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1406	1393	494	12463	17608	jxagRugDDBY4sjF79qvpAJTURw4fmd7WeHGtouBw9Us3oVjQeFP	12788	17979	17979	1619175420000	orphaned
25868	3NLpGo34FzJXjTVCXYMdWTefQDNaGSG9Z2RbLPQPEjefxKkYYEsc	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1637	816	494	12463	17607	jwnHxfbuuFB35sJ4FSh6RhJdHrHetQ6eNbTD9vWJJxsjTj4wARL	12788	17979	17979	1619175420000	orphaned
25877	3NKh58ZHivyroMbW5iQZpoASnjazGft9Rz2rsVrNSjes2pEShUE6	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1587	1357	494	12463	17613	jxdGd13XuG1Cjctns4A1AawFL1k9To3jLsE7xc1xePCFtspj7ao	12789	17981	17981	1619175780000	canonical
25874	3NK8GT8S1bCmGNDgz74voy3MMwX7RuKQ5faYKw3cr4SJxizjBkN9	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1523	1321	494	12463	17611	jxjkPnpnTEK4RJwi3taGFYBr7SgqRdZ5d81d9g8cxZmbuh2oqCB	12789	17981	17981	1619175780000	orphaned
25876	3NLhLr5FyDkmBhnB6LQ9zS4bChZqC9tST3v676bJNTUTQD3htvpf	25867	3NK4jHKiLoXxZKv58bcP7BjAGe5NtwgYBQ4WdvkeisVqfhpVm673	1406	1393	494	12463	17612	jxMYD16Z3mvrcKZ8UYyMAL6G3NLttbZTauqmhomeBNYHV2civYG	12789	17981	17981	1619175780000	orphaned
25879	3NKrFuKAqbpJqXFUjbw8j66boGdR5QTnE7dYhdxU4egs7F6AXQT9	25877	3NKh58ZHivyroMbW5iQZpoASnjazGft9Rz2rsVrNSjes2pEShUE6	1657	978	494	12463	17615	jxhrXpeCd5PT4kbnPhmJEzEhhthStrP5hEgkjtagb5skW7s98aw	12790	17984	17984	1619176320000	canonical
25878	3NKM61q4KsppEqb1JHoLJpdU2XkeHQPeChmZwWx8kFcbXG8oJw9s	25877	3NKh58ZHivyroMbW5iQZpoASnjazGft9Rz2rsVrNSjes2pEShUE6	1406	1393	494	12463	17614	jwzpdwVAhd4kges7Fu2QP4YHwF4x3fbgKAzv95AhW27etWYYDvo	12790	17984	17984	1619176320000	orphaned
25883	3NLJg9y3xRJCpNuxGgtC2L48p4UuWoVRBVQ3GN3iqMQa2ZUjVE6J	25880	3NKre2mfADT4tWZR7dJosAUNBzLz4tfLsp2cfdDBnUdJLbYfKXgX	1455	1332	494	12463	17619	jxk157FwBnpsB4SRRhAPyZ8BHiY4tiwrUWzSvvWaWtKXKawEcV6	12792	17986	17986	1619176680000	canonical
25884	3NKS2CSKN3aiAoQoKiubrUgGwd3bcxF1hnSYRbY5fqLZdMEoktC8	25883	3NLJg9y3xRJCpNuxGgtC2L48p4UuWoVRBVQ3GN3iqMQa2ZUjVE6J	1406	1393	494	12463	17620	jx9k5KdKPJiuVdA1Qe5EdtC2XUhTMVSfC9DCzNn37LBDrAz6rAx	12793	17987	17987	1619176860000	canonical
25885	3NLWzfQhqoz5ykiepEZZLSWHs7Vfx6MPdGnxdDiRBywTUuAZ4QLB	25883	3NLJg9y3xRJCpNuxGgtC2L48p4UuWoVRBVQ3GN3iqMQa2ZUjVE6J	1403	824	494	12463	17621	jxGGUJLc97bEXLwUFAgfoZPs4m1WP4gEVP3UxRECdHzruQZPhdX	12793	17987	17987	1619176860000	orphaned
25886	3NL9bpuX4Akc7mpyso9UKefsYZgAvmEcXMjRkscfTh2ZrnABA6Dk	25884	3NKS2CSKN3aiAoQoKiubrUgGwd3bcxF1hnSYRbY5fqLZdMEoktC8	1402	906	494	12463	17622	jwrGKFoqpvy4mtfGDmbCcTHmtgrMxg1N98hQf6xz7wMLE44rFLm	12794	17988	17988	1619177040000	canonical
25891	3NL8j1A7kCbP9tyQLQy8n44UcqqHy7qBehscxtWmTXbAngSeEMCM	25889	3NLcNxC2iqhmrTPS3cEgkiKAu6iXMnPXPXPQUPqtBX1wSe9KHq2Z	1634	1331	494	12463	17627	jxeuwHgq48WSPCcJHoLugiBki6dJ5LkeKYWT5TECZC6Sbcp35XH	12796	17991	17991	1619177580000	canonical
25890	3NKVz2JDjUrcDbQJU9Ghw6sopEkYYXFnT1QR2aZ3w49qMtjwEaJG	25889	3NLcNxC2iqhmrTPS3cEgkiKAu6iXMnPXPXPQUPqtBX1wSe9KHq2Z	1406	1393	494	12463	17626	jxauui33NrMKQRN4oX1xtLWG3j8nechYWNFc7Pw5raK18MrrZUh	12796	17991	17991	1619177580000	orphaned
25892	3NKhyxuzDsmX9FGarA9E2zvmKXaQgx1dzubLzV6eH29SVqDeX7ur	25891	3NL8j1A7kCbP9tyQLQy8n44UcqqHy7qBehscxtWmTXbAngSeEMCM	1460	1198	494	12463	17628	jwDdD1BbqPsb9S7EvTFHfWD4RowgWHV3vNxh7xDktbQZbo4XWNc	12797	17992	17992	1619177760000	canonical
25896	3NKfGtMrVxWEkiGs5XFhvSJk3bHX3SXoZ1iNQC6SXoBqKsfeWoPM	25894	3NLJdKPyJVd314WJtUq3VR74SU49mqS1qRvxrML7LxwyZ1jc4rgp	1402	870	495	12463	17632	jwj7kDsSqr66LyKWCWY8AqUriAQXXLycyB6rYvjU4MjBdhkWUBF	12799	17999	17999	1619179020000	canonical
25899	3NKkXt2LHs4NPwatzEywDHbZvUzkRMTd5Rx5hrgVK7horRqdQ3Hk	25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	1406	1393	495	12463	17635	jxnMNsJ2k6CGDEm9SkaqEucxADWd48wvL4evjSEH34PdHo37Nzv	12801	18001	18001	1619179380000	orphaned
25905	3NKWcATfYw1AUKJo9HR8bjpXGczseiS8nM8hrS9Do7wyApAQYyLA	25902	3NLVyozckDUMLUsxvr5WtTfQwREXu5gNNDoMc2rjM53sLHWrCD9n	1455	966	495	12463	17641	jxm8PUVtqKDzLdXcnAeEBizqVbPrkeNdJ5Wsv47jvpvQZ8w8nYV	12803	18003	18003	1619179740000	orphaned
25910	3NLikrtJSYHxLJs7D4Z7uMhtpyc3kihCbRmcejao87HTv5a2fXL4	25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	470	1309	495	12463	17646	jwRsEovqWNz1qFNaBGoYMkTqHqF2mFX1LDsdFHFANVdDiMzfoSP	12805	18007	18007	1619180460000	orphaned
25912	3NKrcAwibNb8kEBvgmH9wmZFeYWsrgXk582ToSVReAzQEz8bc9zY	25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	1542	1304	495	12463	17648	jxK96jCmVb2c1hyabkXCgp2DzMApxXCjfeFDZyksqpN1GyBVEbc	12806	18008	18008	1619180640000	orphaned
25914	3NL4HRzw4DQd4nUy2KzZdjNwU2f6VQbXTPxvSms5bZp1nqaHbMUh	25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	1542	1304	495	12463	17648	jxLydKKR8J4SoN4ybM4DPyQnHVYdy7aYKRQav5uNNfTiSTjuaDg	12806	18008	18008	1619180640000	orphaned
25917	3NKoFQrtiYZXgnBbBVLvToszg73rh7QnNBoS47j5MXWuxEGLDJVU	25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	1588	1392	495	12463	17652	jxnWbTaqW2BcUd9yKWNSt5u6i7Wrb9BTkqRRny1xiTG3B4jdCu9	12808	18011	18011	1619181180000	orphaned
25919	3NK49SdDPpc583a8y8tmCicP9RZpt6hePwmsATTT7xizWJqHra8R	25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	1403	824	495	12463	17654	jxuYv9HxQuYFnytXxf8FL1KJe88AaSc86L2v6ZUjSHPD2oc4zEH	12808	18011	18011	1619181180000	orphaned
25923	3NLFJFj8bftQS8hnMT4HHyx7QUuRqfStpyeTnJcuANDQxHheVEX6	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1403	824	495	12463	17656	jwJUT23CTGVMBfMQ9PHgyQfmEFDTyJ9NLXUdZ6PUFsW4w9zvAPm	12809	18012	18012	1619181360000	canonical
25921	3NKeWvCkbt9vK1eiDn7Z1dst8YgMrqy3ej68U5dnY6bmxRkeQRJi	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1527	1293	495	12463	17655	jxQTFwZqa95UcwVFFEvNpFmF9CWCyaVqq2jVHTma94CpTbMc1AB	12809	18012	18012	1619181360000	orphaned
25929	3NLBHdeQfyQ77zMXJubVRPXFuowDs1GNhamm2jPtAXuY1hamjKoX	25928	3NKHzaSW3SRf6fNzxd772NB78UE2VeR9zMe8pacGRGxRECNxa1wT	1656	1343	495	12463	17662	jwwu93pRLADDVLrcYYCef4tPMP5JvpJabU8hKTZJFEKmfWZjwqm	12814	18020	18020	1619182800000	orphaned
25932	3NLpPCqnVNy5yUbFM6qunwHrKNTugcDnGsdUvge7sKvNTgArrHNa	25931	3NKP3tnzhKycrxRVHSCSxhT16XHS6hsJtjTBFCkMExcbBUjZgCZ7	1503	1031	495	12463	17665	jwtVuVoMtuy3L3Q5pu12dsphy8fEALQBh1YxgffeCm63dbPPeLE	12816	18024	18024	1619183520000	canonical
28807	3NKcXYavR58TadWgYsRMQreqhXTcDfNVtTFk7HVYAwkvDyfoYevL	28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	1656	1097	564	12463	18974	jwsoHCUychrbJjJQBn12VFqS5TzE6uZwXdBvgGsJsN9TFbaf2UC	14210	20017	20017	1619542260000	orphaned
25895	3NLoK7p5ottZnuwt5uhcYofDcaYPZ5CJ3mZ72AqEjisMSH5VxDVC	25894	3NLJdKPyJVd314WJtUq3VR74SU49mqS1qRvxrML7LxwyZ1jc4rgp	1407	1395	495	12463	17631	jwiuh3ei9Rkpba7t1FqYMGYjv8r2ziwVnz5ABvs1mZ12A32QCPA	12799	17999	17999	1619179020000	orphaned
25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	25896	3NKfGtMrVxWEkiGs5XFhvSJk3bHX3SXoZ1iNQC6SXoBqKsfeWoPM	1471	1260	495	12463	17633	jxw7Pz4BwHogBD5QJWVHuRKotUmqnGD9xRPWyN8miZAP5prWrmC	12800	18000	18000	1619179200000	canonical
25900	3NKxez2ikmmvCmThpwwEaVomRxwT7kpr9iqtFLEskaCRoqSuW1nT	25897	3NLuAT1hfbQ5gGKyCHzPUbXZH1YUzWgCDC3GX2pkqkB6SzX6eB86	1627	1019	495	12463	17636	jxdHP6q5Nbih9JZR57KqxUrghVJeJBCbFTp8RaN8dF8aBdikawY	12801	18001	18001	1619179380000	orphaned
25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	25902	3NLVyozckDUMLUsxvr5WtTfQwREXu5gNNDoMc2rjM53sLHWrCD9n	1407	1395	495	12463	17640	jwRs8L47nQ8Fbwsr4WQK2En8yvHo4exZ66i3No9qQ786noyJHqT	12803	18003	18003	1619179740000	canonical
25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	1406	1393	495	12463	17643	jxzfAHuEXTqCP8V9DrSdukD1CEZo2ZuakyhhKXUCtb9cvbzwu57	12804	18006	18006	1619180280000	canonical
25908	3NKvCELt9F7WCnJGzjnp3doHseEmcRuVzuNBz57A1qZFir8Qde6v	25904	3NLQjf3VhBkAwK9Ab4Zkqs9qYNRS4hW4qXjaW195w5y7gFcr1sio	564	564	495	12463	17644	jwRvSKHZWb9E9o2Depd27z1sAEhHaNbRrbZZ6ZwrmxvZRcYZ1w8	12804	18006	18006	1619180280000	orphaned
25911	3NLRUo8vMTUo9sgnJt1dWSUwwJToU5tw1jZPsVoWKdSG3z4W9jJo	25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	1581	778	495	12463	17647	jwX26QKL3s2b7Nue8o8UDc9ni1do5sTJtcXUs5ZoQsdKkK5p2c1	12805	18007	18007	1619180460000	canonical
25909	3NKwx5vQDgPnt98ugSX6J8Dt7eGcGfM8GiCgYmVC4Qzy9rPiXLcj	25907	3NK9Cr6jt9tJNV2oJbKQXMCgr8ECTK1MLNZE9NZoJSoKUwpVpfRE	1406	1393	495	12463	17645	jx7FVRT8XE5HXJGRSFkAYpXyqg2uN2wnrHTS7yRRenyZNBCWTrg	12805	18007	18007	1619180460000	orphaned
25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	1406	1393	495	12463	17653	jx3cBY29uCFdsbLFXVUtXULbnfvzCbJTNqV9jzbQp8bjvdEwF2T	12808	18011	18011	1619181180000	canonical
25920	3NLRahBr6vFHvTQVfmoSEAfLyavjocZEUnkehdBq5ax8FzKgrtqE	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1527	1293	495	12463	17655	jx7WBcrtXbwfjHfCw4EYxvifXzWRwSw5MpzeSkCQCnnNcLhjyCG	12809	18012	18012	1619181360000	orphaned
25925	3NLHfnbBmXevHbqTq5anMfvJsD6uRMHauCccCtwAT48Bb85xeTbU	25924	3NKtkiNL3PhZvKSyaJ8W5uZNhUETLGjnUWpEHGSCFtPsbzUVUFyy	1406	1393	495	12463	17658	jxUupa3eh6hr3uHZWwNY39R7rY26z91o6RJvKxz55z8Dr2YXGXQ	12811	18016	18016	1619182080000	canonical
25926	3NLRyPXKpZnsxNpabMawAccNqEdMeivPDwPxATgusrfhkp2QAUiU	25925	3NLHfnbBmXevHbqTq5anMfvJsD6uRMHauCccCtwAT48Bb85xeTbU	1457	1145	495	12463	17659	jxC4VHU8Ah8aJ1hZLzYpDifHFKE5w33orH8b1Pizqo2fVXVa16v	12812	18017	18017	1619182260000	orphaned
25928	3NKHzaSW3SRf6fNzxd772NB78UE2VeR9zMe8pacGRGxRECNxa1wT	25927	3NKa2rgzWjEsjDBp8nK6QKJyiiDJev2mm3Q4EDHnjWycNTch3uLH	1600	1126	495	12463	17661	jxsrL6wVdmXsKEPNEjRpCvQoDfMW4tTeLE4U3wR1bjTTZ5RiasQ	12813	18019	18019	1619182620000	canonical
25930	3NLBBW3XtSG78XHN47DNrBE2kZe965W5ijjyvohDkBYxyLStAMem	25928	3NKHzaSW3SRf6fNzxd772NB78UE2VeR9zMe8pacGRGxRECNxa1wT	1581	778	495	12463	17663	jxnj2SxV3mAUVXspq3SYkyiYViSCjVAnratqX1cvy4WGUzz2fkX	12814	18020	18020	1619182800000	canonical
25931	3NKP3tnzhKycrxRVHSCSxhT16XHS6hsJtjTBFCkMExcbBUjZgCZ7	25930	3NLBBW3XtSG78XHN47DNrBE2kZe965W5ijjyvohDkBYxyLStAMem	1403	824	495	12463	17664	jwWYgbLkLuSYUdp6hZBMy2Hm6sKBzyPDfnTmbtjskmJb3JV3Xob	12815	18022	18022	1619183160000	canonical
25933	3NLBeU8wKj5JGuDuFR9THK4siG3VWQ6yKcwKVeZxJuTja6QDUdDX	25931	3NKP3tnzhKycrxRVHSCSxhT16XHS6hsJtjTBFCkMExcbBUjZgCZ7	1573	1192	495	12463	17666	jxUraRLhE7kPvAopqMH7oyjWQq7gQZQKpA29ERZQCUVUymj1KBM	12816	18024	18024	1619183520000	orphaned
25934	3NLTZDcRDea2ZHzZzs2KDPMUZrH7sEyemFSu2jSTgx9ZvUybt4rT	25932	3NLpPCqnVNy5yUbFM6qunwHrKNTugcDnGsdUvge7sKvNTgArrHNa	1536	1187	495	12463	17667	jwQHHjLbbLEygKrZ2FoAWUT4YbENaVz53BehBhB9Cddy8C5B2BQ	12817	18025	18025	1619183700000	canonical
25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	25936	3NLuZA7W1hwiFyKHsLmvSwzNuEPvUAYWG3vZVdog5Vo61CMKj2iQ	1403	824	495	12463	17670	jwhVgEaUwmhguvTNvTgbrf21poa7mtVNrTYceZbAGs3RWZAdhfm	12820	18030	18030	1619184600000	canonical
25941	3NLtcJWQB79t9wUeSYkeSn2TKBjWhL6ZtBCJdJ21MBFwV7MTvoPT	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	311	1061	495	12463	17671	jx1Jdx7nM1tLhpKtVECs1ZckiEzSuZAS5HNsWK64UGR4fmBKwYx	12821	18034	18034	1619185320000	orphaned
25938	3NLAByun3UNUUpY954JyoJycifGqZgrHpwbg8mqjtHmuSGb6x8tM	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	311	1061	495	12463	17671	jxQcAiK3szWctPY6G6MvYCt4fijtTrL7mPWN6vPWeWyS2hJxjF3	12821	18034	18034	1619185320000	orphaned
25945	3NL1CtA8bdx8uozEs8o5CG4jP2ZNcuStwkTbrfEcsEB91MTh4cMt	25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	633	1258	496	12463	17676	jxygd4X8QKn67hgnwPMDkddyBuNSuu5FuD3pfS43YrAGwzfvSBX	12822	18037	18037	1619185860000	orphaned
25951	3NLXcamYETeHHPEvdb4hcZjFvfU8LeZEWfUWneY5nEMdGVoRYiqL	25948	3NKQa8PzfXx2pjikiFD4cihcMkUg3BxXwRbCdHS1SHjd5rzKNfc9	1670	1282	496	12463	17682	jwRrFQovepDJqobCtT8GQWoWt4Tdd1LtKZbS4kaETz2Tc4jChcQ	12824	18039	18039	1619186220000	orphaned
25953	3NKwx24dccjmvxoaQwPuuPXQARRAeoZX5uuBkNkviBCZteCMfunq	25952	3NKHsR9JXdL3n4HctQJXhGzw9WdeFTjAMGb7bZfcU9t3JBeeY9Z3	1607	1348	496	12463	17684	jxrMM1mxC7TJdjoLvu64wsbhmUyttG67RaDuPafwmz1PWeMDDPE	12825	18040	18040	1619186400000	canonical
25958	3NLKYe2byDwjVe9kNQdAbvZ3sYbmBkjquQG4NqAoLRdV27dA9XLi	25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	1553	776	496	12463	17689	jxLrXg8TCHEc5z8VzrWCfhvR7bZzc1FUXfxugKyNf95TsRxexCx	12827	18043	18043	1619186940000	canonical
25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	25958	3NLKYe2byDwjVe9kNQdAbvZ3sYbmBkjquQG4NqAoLRdV27dA9XLi	1509	954	496	12463	17691	jxU6EL2924BC3dofheFZLJhMHemU4fQbLpx5m6HyVTZMs9hY3nh	12828	18044	18044	1619187120000	canonical
25963	3NKXedbAqRuKTPpmKa7zPBtTiP5B1ntQTGUTjBGKFtxpiGxRbqEi	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1407	1395	496	12463	17694	jx3QSgL61yE8a2BZtb4m4SfzNT3fpmTycR99F1FQQnZnWBvTkNs	12829	18046	18046	1619187480000	orphaned
25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	1426	1364	496	12463	17698	jwy5AVHSk38TfrnE4cV36HjjkkruSpfDJ7dzy6iEk19GefByVBt	12830	18048	18048	1619187840000	canonical
25974	3NKsnivDATghCFjMRXcZezv3bVQoGEUs4iNVKWLd3ymA3dJYjExW	25973	3NLePP191qMoR6XCQyDSE8Azd7qq6ReJeXRdDsQnQVJFJo9rEp6A	1623	830	496	12463	17705	jwU5JK42a4AmyLDuo6ALRg3isW3683AVc8SxgvhWn4jAWgU75E8	12834	18052	18052	1619188560000	canonical
25977	3NKwoUnkNbGqDuxuDQ22BM6hw5S3ESM3rUzjXEq7GTgk3NfxCjxd	25974	3NKsnivDATghCFjMRXcZezv3bVQoGEUs4iNVKWLd3ymA3dJYjExW	1405	867	496	12463	17708	jwMTAscuSaDuozZ9rP17poLwc9kvYj1mvPwrvgEEzrgRkhFsdpg	12835	18053	18053	1619188740000	orphaned
28819	3NLtdoKJwTgrCmLtofVQaX9HpXJ28A1EoNNQ4cgQp5SLAFmtMxD5	28817	3NKah9NZ962Uwo9X4CqPXsjMkVSyuLhLtP8QJnqDaJ3KidvjQtaL	1402	850	564	12463	18974	jxqfHwtCzscfx2PEABPDv6HdeKDA34msY7a8UC2ad2sjL9ENU6P	14214	20021	20021	1619542980000	canonical
26014	3NKoGwdwVSRQ25NewfTHZ6ght6CxVwHH7B5RUmwwvrRTaaKUoaxJ	25588	3NKpZTDijBjwDGAf6eCKYxkfbtgkQFqbgkjcRhQhdgnWdwuSY3Hc	1423	559	488	12463	17743	jwAhiTZ362W4CSgTYjmRikrEnnkLxPy5MZmqFzxE466GzHLQQWm	12665	18082	18082	1619193960000	orphaned
26033	3NL32Pxg4JoaMFWngRStW1rpha8yczSF2aHF4pWhmqpjAn6sLsgH	25774	3NKPTuKrFzsa9czz5PzWgQfpofP5EdDCaXagjhLZpoyxm5oakNSR	1671	1119	492	12463	17760	jwfDbNLajSjiun16CtofAzUCQD2rhsZpnppNVgTEiskKv7zR3Np	12748	18088	18088	1619195040000	orphaned
25954	3NLVYBrGa7MNoKvrkfLKFDCgg24d4DCn9VmLz767dwekMuAEcxgv	25905	3NKWcATfYw1AUKJo9HR8bjpXGczseiS8nM8hrS9Do7wyApAQYyLA	1637	816	495	12463	17685	jwbvdGSrCnxEuNTK6eqDjoHvePb4ki7saJbL1szDmLFrbDBpwH3	12804	18041	18041	1619186580000	orphaned
25942	3NKjAM6HyqiGPhwt2XsW7u5QGpkL1ToEJ9Jn4LGAmKgBeR4yQ9Xu	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	1537	227	495	12463	17672	jwEPTGQruBSXLJtNNY1JqihWYdRFMuxC4zpdXi6WJbnvZaVYX9k	12821	18034	18034	1619185320000	orphaned
25943	3NLwNMXpZvd3XVwgBrszBzu7W8JB7oAzUxR6rb8iMXwpJUcyWhuF	25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	1631	794	496	12463	17674	jxz65VnQwvUN1JXerNceCfGKDRYBBaVyE3xuoKdyBehMfkzR8ym	12822	18035	18035	1619185500000	canonical
25946	3NL6uJyVqUwJ8gVPNpTJaFVMLbRcvJaobvz3Cxemvr4uZ7USZmku	25940	3NKFMsQitouj94LLyF7Uc2orW3b2YUveDE5ggeDSuQ8sSBY2NbXZ	1521	233	496	12463	17677	jy2dt2AnVAbzDRLPj7HkiibdfMR9A6uvH5jWANXsNLDmxXxme7r	12822	18037	18037	1619185860000	orphaned
25948	3NKQa8PzfXx2pjikiFD4cihcMkUg3BxXwRbCdHS1SHjd5rzKNfc9	25943	3NLwNMXpZvd3XVwgBrszBzu7W8JB7oAzUxR6rb8iMXwpJUcyWhuF	1521	233	496	12463	17679	jxYcmq2kMnFpyuVFEh23mEyxW42ynvzfNabkq3kqiN4dqJXBXNN	12823	18037	18037	1619185860000	canonical
25952	3NKHsR9JXdL3n4HctQJXhGzw9WdeFTjAMGb7bZfcU9t3JBeeY9Z3	25948	3NKQa8PzfXx2pjikiFD4cihcMkUg3BxXwRbCdHS1SHjd5rzKNfc9	1587	1357	496	12463	17683	jxGvBopDAdtHRKsADHrGP2d86K68T38Kai26YE7L36wXC5V9hDn	12824	18039	18039	1619186220000	canonical
25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	25953	3NKwx24dccjmvxoaQwPuuPXQARRAeoZX5uuBkNkviBCZteCMfunq	1573	1318	496	12463	17687	jxF2Wi4drXkL7KTg5UsjLXXgr5hTsibQCCfRDgD7osU4CerFoLf	12826	18041	18041	1619186580000	canonical
25957	3NLxH766fMwSM55ASLp2TG6iDDfW9hfoPwf6a1W92GPY8W44BUCo	25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	1407	1395	496	12463	17688	jwANS4aYN4bbknGN5XJxAnHrKGAZUk5hFyAubjE5a7d5soTJHYE	12827	18043	18043	1619186940000	orphaned
25964	3NL7tTgws7GL3eeA92fTxVkpSUXkEYm9mPYiYpLVsJHvhT2uxo1M	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	152	1204	496	12463	17695	jxBtCxxWZJqCDk9NgF5D9MeD8rMduxca9v8JkdhXYCqfFZdZnUx	12829	18046	18046	1619187480000	orphaned
25968	3NLEFgLA8iWjJKDJFu8vzjbei8NPmvua3q1sAr1zger48fmG7XoU	25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	1406	1393	496	12463	17699	jy25mN6PtZEyHgfyoaUNfLwGmtbMBUXJbgWkoZdWZTU54eFrZoP	12830	18048	18048	1619187840000	orphaned
25970	3NK6vLEueaLdgRAHhPjPxtctjvnBP1EhQg9ZJ9uo3hP4NeiNRNjq	25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	1407	1395	496	12463	17701	jwXZe1Bd5fBfXx1bicyJaJQWP99HZeLqg1kcBSfNWsMQMGK8z5i	12831	18049	18049	1619188020000	orphaned
25972	3NLLpdnfv2Epjc8j8zPWxNMiPhq5yXHFgtuavcRV9HzjjDooVTwe	25971	3NKUJ6NhY6x9JZL22hkVjFHCYRa6fpccCWvtojRtLKnTihoBqQ7D	1561	3	496	12463	17703	jwW6FDVAe1vYPjP6PGbKnBGjdx1q3Mwa44ftteJjcTs9RrgNgnX	12832	18050	18050	1619188200000	canonical
25980	3NKAYiz17juyW9zR6mjQ8uNxJNr5dpVBGiitBK1YgvCLXFW45KiC	25979	3NKbL1PJAC4remdM3W2pWCm7uJwRbmsqLDUECxKjsrALsqT4jfEk	448	1059	496	12463	17711	jxKM9w4HTB72sAo86RWcVGkiyuaKCu7CwHzzuBmbfqxrSDZzYt3	12838	18057	18057	1619189460000	canonical
25985	3NKnieiZzZ3dvdy96G7EXixRLwbmj2qJRfMp8T1fXssEL4uXnanZ	25982	3NKii7RXMezkYiww7JDsfFedDwdke78MAvA7MKQtEKZtVWFH3yMC	1500	1051	496	12463	17716	jxcrGDaQgC7bejpJy3UYxn2Sivct7Bz9g1YgUbqfMQGGwJAZ4YY	12841	18062	18062	1619190360000	canonical
25990	3NLFevyz4HSawk33oFz6hUhvCZGPAsYb5GsWdfN4BVtY1YLyusvJ	25987	3NKjQdH3L17muWhpUDM2w4X7J7LYdLcxE9vPiWnekEfUFhQ84U19	1631	794	496	12463	17721	jx5yGqNZFzhmHqeDkJr7xoyRCab8CcApADma5Ey1SRz3GXWq2nb	12844	18065	18065	1619190900000	orphaned
25995	3NK9b6trwjxQPt7wJ6NzD2ZxVtHSSoX7sXsvz32itAHCjLx1upyg	25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	1564	1338	496	12463	17726	jwbzDcEUa4wVrXFPeLoSKmkofDP9Y9Kuz3BALWySsMygG7r3Lrk	12847	18069	18069	1619191620000	orphaned
26004	3NLUuyjxRDLsvrSK7BYhcgR7232aCNdijicSdko4YBDo22eZ6CLF	26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	1651	1301	497	12463	17734	jx76SAn3P7iFqM8AQMHF6xwXyBN7WSqeiMUhgDEGjvzfzKc1FQ8	12851	18073	18073	1619192340000	canonical
26012	3NLV5sAsswPLtYmF8RyiSA9pfYuxPddoPnDTc1MP9mS2RvPTtVeS	26010	3NL73UScVFdDvEYF2mPDtWcYLdqsuQLHakbEn3tv68PvxD93J5X7	1602	1369	497	12463	17741	jw79vaprjFb9vtaZ6RG38FNJxiKRjETJwyUQUz3uerB3hcRwuQ1	12857	18081	18081	1619193780000	orphaned
26021	3NL9Ez6gQbTFTjAQhs6uq3j618P1fYuKypp2eP17Uy7A2qoBQ4fq	26020	3NLLvCoLHEHVtxqLtHxpbEhjX7x5mnhnWnEkvvqA8h6uT2w5aHgS	1657	1218	497	12463	17748	jx8uj2PSVx8RfrytCSnjcjpq4Yb5stn1SXDPztTCJcDmQbxjMGq	12860	18084	18084	1619194320000	canonical
26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	26021	3NL9Ez6gQbTFTjAQhs6uq3j618P1fYuKypp2eP17Uy7A2qoBQ4fq	1403	812	497	12463	17750	jwqDT1XnyXUkPpdM8QPkGELQ2gV8qVHDP4Z9ZChUohaxHQkZn25	12861	18085	18085	1619194500000	canonical
26030	3NL66GQUpKfHiLvDzubowacJ3KA7XSZ3vKnPJpWjXVvFjcMzgzTP	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1407	1395	497	12463	17757	jx93dU8K56B6WK2qZQe9MxCNu1ZiPprdM5nE6mp86HP2FiUZ4Jh	12864	18088	18088	1619195040000	canonical
26028	3NLCidKmnpGU3wtDe3BhQGTgkVoWqLSQ12Fn8XL7k63X3CLmKr6u	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1503	911	497	12463	17755	jxNUQhkEJ2JHdJ1v9XixQMfM5CZ95tsv2PKnWe8DjfHAzwWJwha	12864	18088	18088	1619195040000	orphaned
26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	26030	3NL66GQUpKfHiLvDzubowacJ3KA7XSZ3vKnPJpWjXVvFjcMzgzTP	1542	1304	497	12463	17763	jwugHtiXt7NHUUifphF9LmVtWA1n78eTvBhQb79XJqyzaRTFoXT	12865	18089	18089	1619195220000	canonical
26039	3NLGwLdzctufeAMKUoMnFbqE4Fgv2EBRFJzXzpLJNvD9aEEpQFGp	26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	1555	1101	497	12463	17766	jxXRqDR3D7HjDDaLDsLCTQpRRxzWJUvLv15HcciPiWrQ1YX8MQY	12866	18091	18091	1619195580000	orphaned
26041	3NL6A8AC6zroUozFkR4iJ8bQsf9Z9k1p8rRe9VjbwTXKkP6f2qtQ	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	1407	1395	497	12463	17768	jxc994V9FZ6EKCsGqU5zzwweDfmBzgyCk95tRgm66vpVBxqHo8U	12868	18093	18093	1619195940000	orphaned
26043	3NL9x7H9d1xiayxTeQWkHb8gZkWZoJM4mKnXqGoD1wi4jq52Zrto	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	44	959	497	12463	17770	jxmBehEgMPLtxUGtfMNEBTY23ZmGqDawsDEk5jVfuzgam5DjVWM	12868	18093	18093	1619195940000	orphaned
26045	3NKFWcAgVP8xsQM2utSkiUiMGfHm9muQp8Smm2ddJPNcoNPw9Mvs	26044	3NLVPbqC97rSNeeUSJuuXpRjhWVYCs2zHbPPDaYWqUBwGgvEK3yf	526	648	497	12463	17772	jxidUnvMWAGy7H6sy98mUbovAcGD9FvoLjwJ32oVjbXiyUTHdbf	12869	18094	18094	1619196120000	canonical
28832	3NLMmj5CcVrBK5oXxpSL2WkKmu5pMhKduir5Drei3DD7QtUKusQK	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1652	1315	564	12463	18974	jxi1V6t1pg9RaMSRzaGce1nWEM6mV6h4rMv5K8aeaFExRo3AEg7	14220	20029	20029	1619544420000	orphaned
26034	3NKydv6eCfzhFrdRBgc9KEN5YKfK6o2UeokmjFvLCpC1AiPpdssq	25733	3NKGNhJtACNMh6GeLSqwReBsZbQid3m2khZNNM3RpkxBYsNF7t8o	1671	1119	491	12463	17761	jxyXm9L6apjpg2iU5fjG6F3NtHFkPWPXr6qW1hV8ts4bCCRz9aq	12733	18088	18088	1619195110624	orphaned
25975	3NLVCd7sSw937uwshEftkyE5nPu8SurhZXsQVPU6tM5Ljsqgahjr	25954	3NLVYBrGa7MNoKvrkfLKFDCgg24d4DCn9VmLz767dwekMuAEcxgv	1637	816	495	12463	17706	jxifuGyQSD3btu1CSMhcXaTHwSo845WKDqYMt4RHLjWQQNZQYXz	12805	18053	18053	1619188740000	orphaned
25955	3NK87NdfXKBt9kQzdygexk9ZBjes51G6NwHnM7d6gzQaidRwNoxm	25953	3NKwx24dccjmvxoaQwPuuPXQARRAeoZX5uuBkNkviBCZteCMfunq	1406	1393	496	12463	17686	jxb6CkCwJR35kbDu85uAbEkNC6HJj2SkHNq5uYHiZRhzKfcbRTv	12826	18041	18041	1619186580000	orphaned
25961	3NK4pA4JmPZgkdP11hzQB7BRehD6c94ncEG3y5KcTKtNQCUFfzdV	25958	3NLKYe2byDwjVe9kNQdAbvZ3sYbmBkjquQG4NqAoLRdV27dA9XLi	171	1248	496	12463	17692	jwhhuomhyyC2eQiYSnAiUVNYSynHqaGk3NkS6vhbUzC7aKGdbjC	12828	18044	18044	1619187120000	orphaned
25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1611	1341	496	12463	17697	jxmEmtZbJxKAoYpRSzwAauPgiaxo8kxVFTUEMV8pqRBAmqn7ohU	12829	18046	18046	1619187480000	canonical
25962	3NLjT1PbVZy8bfaC9xYX8xVvsVriAfkfBTJTmW2TZpw7snzVEuNt	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1649	1137	496	12463	17693	jwUJwR7MQgtRWMLSTPCt43g42SJF3JAaWXeiEu4sqXYcj6xFcL6	12829	18046	18046	1619187480000	orphaned
25969	3NKgpwDmrzE9vjrWBxy1xSdJ2TXYwvBbEjpUVvPHoh9JAd1oSjLR	25966	3NLdG8xskDVreyU5iL3iFoT5joEKsujhHJL4JQ5GZCY5Sfv9i5AV	484	953	496	12463	17700	jxbh28oVBZxaXcXsZGoR8hhZVYrr3uMY18LeEHAQfhfYiStm4Wy	12830	18048	18048	1619187840000	orphaned
25971	3NKUJ6NhY6x9JZL22hkVjFHCYRa6fpccCWvtojRtLKnTihoBqQ7D	25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	1402	796	496	12463	17702	jxGYvENCwdJj5wZxrAYTsKnkbUMjMbakj7Qv6kh99qeiGbakXzp	12831	18049	18049	1619188020000	canonical
25973	3NLePP191qMoR6XCQyDSE8Azd7qq6ReJeXRdDsQnQVJFJo9rEp6A	25972	3NLLpdnfv2Epjc8j8zPWxNMiPhq5yXHFgtuavcRV9HzjjDooVTwe	152	1084	496	12463	17704	jxLNe8foeDNridJA2MVRxuXzSKWvU2seBrgLQV2GKDzwymLSfgN	12833	18051	18051	1619188380000	canonical
25976	3NK4HnMcBFDGjuFyJ2Lik4Ft83RbV6JSV4XahkWcZZzeMTedxacn	25974	3NKsnivDATghCFjMRXcZezv3bVQoGEUs4iNVKWLd3ymA3dJYjExW	1600	1372	496	12463	17707	jwPeA5WpuKpJ6Bt8TiDkd1E9FWcGpiBMcoL5Yx8cxsHAPRVvrbk	12835	18053	18053	1619188740000	canonical
25978	3NKr3dTcRt2gMHRDaAvRxtmmYHN4VihkxyPq1VGGGAMoNBpvEK4V	25976	3NK4HnMcBFDGjuFyJ2Lik4Ft83RbV6JSV4XahkWcZZzeMTedxacn	1402	852	496	12463	17709	jwCj91nCfLuAH4cQaEozuvLGYwZEJ6f9cSBq6X5vc1fc9tegN44	12836	18055	18055	1619189100000	canonical
25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	25980	3NKAYiz17juyW9zR6mjQ8uNxJNr5dpVBGiitBK1YgvCLXFW45KiC	1406	1393	496	12463	17712	jxgsN2SyHs3Biw7WD4vRj8Pr4NfwRmMQ1qqzkmYzjZ1PbE9yK5T	12839	18058	18058	1619189640000	canonical
25983	3NKZGAjcJdjnxfnsiRvTXEmsvfDDQg2o8cNRrCJ2oExRoWnwpM4z	25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	1490	1274	496	12463	17714	jwfKGzGDP5Bq1zZZ4WiKgv7zY11uGUC9JFZS4FKLJxX6r2znEQt	12840	18059	18059	1619189820000	orphaned
25986	3NLhUA4PvYeLJhoFMprZ7GeSxy8PyyZJQKW94v6aMtgTg7i3trCQ	25985	3NKnieiZzZ3dvdy96G7EXixRLwbmj2qJRfMp8T1fXssEL4uXnanZ	1602	1369	496	12463	17717	jxDM3EH6XMyRCaBZNWF3MxHkuLHHS3SyspDAb9pzapJDCTAffJR	12842	18063	18063	1619190540000	canonical
25988	3NLcCfmvpr67wsn4Wn4LkmnrE61gMQz6tNU17msqKWVD2HRYBx3N	25986	3NLhUA4PvYeLJhoFMprZ7GeSxy8PyyZJQKW94v6aMtgTg7i3trCQ	1585	1240	496	12463	17719	jx2arjpVJ42V9SwxBzNy5ZjsEHmwaXdikzRYCurktVDwf65uF3Q	12843	18064	18064	1619190720000	orphaned
25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	25991	3NLa5gduEj3x7TytRHKPt8z2fEwP1DiCt5thZhSGrKMrmrgM3RDv	1403	824	496	12463	17724	jxMhKcU3f9ZRFYeDyb5oypi2LmFEm6gwWVoxoR9daxjwSaFXHUJ	12846	18067	18067	1619191260000	canonical
25998	3NKHVji6CQHXDqUXGQMHxZ6y2gHihHJLG7pZvY7jXs64NisEkK8T	25996	3NL8HUzuvKwhD3CJQ8vCPDXx7FzA3z1tdisJyAmrGh3eLxdzmHRi	1471	1140	496	12463	17729	jwdDinFVyWVMaQ3ZS1r8rvzEYYezRtrKpW5y4tbvaBp7SqV2mKy	12849	18071	18071	1619191980000	canonical
26000	3NKaHTpyzkD9KH3zF1mW673fpGoRP23Hryu38DiCraLQTYvorxxB	25998	3NKHVji6CQHXDqUXGQMHxZ6y2gHihHJLG7pZvY7jXs64NisEkK8T	1578	1050	497	12463	17730	jwpjZGhpHgBw5Wf5HdLhWXs34ZvkJij98m3PJ8b3SozWDEZNohY	12850	18072	18072	1619192160000	orphaned
26005	3NLNrZgXB6khdPfcqj8qP2UviQ1z9j8mhuBNZvTyoh5sAQw3YeZB	26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	1651	1301	497	12463	17734	jx3rrfNbKaQAdKNsASgBt4tfLcd6zn9uwsW9jUzhgZ3JvwMfPmC	12851	18073	18073	1619192340000	orphaned
26007	3NLEoQdd2GDQguBj1uvE1nwzqGEEpvq3Erq47GiEnXY4AkBrce7L	26006	3NLtgGE2Y5G9xioHkL1UKEPrc93oSD4PvwmztghLHMRGZWGJX3mj	1402	882	497	12463	17736	jxZ2EUVaBwFkUrhtTr1CmxCELTK8dASGyq5Z4eHQiUywEPtntEc	12853	18076	18076	1619192880000	canonical
26010	3NL73UScVFdDvEYF2mPDtWcYLdqsuQLHakbEn3tv68PvxD93J5X7	26009	3NL8C9fkn55ikTCExDvu6kYLB934RiuKggDLwFPdsSQEQxuqkK1N	1507	1280	497	12463	17739	jxkLuUcNY1hZUMapBFUXvDTnBbvcdqmieg1hksHa6zF66ermtog	12856	18080	18080	1619193600000	canonical
26017	3NKLxDX9qAyFDkHftCG6DCpjm964U7sRENf7aqEN3jAmiVVE7V7q	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1476	1125	497	12463	17746	jwvz92mcu4DSHzu2AhmVjd7oPqtwGvrnVsjhYYThEHxwEkjhY4G	12859	18083	18083	1619194140000	orphaned
26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	26024	3NK42J2Rei9B5XZLVZzymT9bRDobZp7hQr53YWbLEEATDDAmJdAZ	700	832	497	12463	17753	jxEJW8ncFwkvHofgcPZk7aHDZDo4GWYhpqyxYchYmT7qrskiJzY	12863	18087	18087	1619194860000	canonical
26029	3NLdbV7NkkDFMSVrB15GqNGNKv5kTTSQJabhutR3PTVq3t6ZRKzq	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1671	1119	497	12463	17756	jxJ3ebh8Djs7DAap9TvRZpDXvxNk4Gee7E7L4xxUtZFKndia7T5	12864	18088	18088	1619195040000	orphaned
26037	3NK7Z7vYkcmLW3d2fatJPRF4QiviMqcHzQKjBs6pKSjbjs6rhnJk	26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	1460	1324	497	12463	17764	jwtf8u9xBETeLqNAuATp46o4ou6rRhUabK58wecNPVVfr15MRrz	12866	18091	18091	1619195580000	canonical
26046	3NLhpwqTdkEDqpM3pfm6DwvR8mxEqexJEb9LdKEvyJYiDRZFEjsu	26045	3NKFWcAgVP8xsQM2utSkiUiMGfHm9muQp8Smm2ddJPNcoNPw9Mvs	1634	1331	497	12463	17773	jwmRQkFjbW8m3n5QsABis8bYt1Dgg9zoqQMWEoZRqFScaLBADeP	12870	18096	18096	1619196480000	canonical
26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	26050	3NKHCS78Duczs48hcqSL8iAJijpKusDAJMgLUCi5rs2AuuUAVMZj	684	1352	498	12463	17778	jx1Cj9dZ1RRTWcbtmhpTzUoeMczB3Pkowjj5dqnGKgM4sbPdPSK	12874	18103	18103	1619197740000	canonical
26059	3NKmKPCXYpLV6evGtuNUHMxdQJCJBPjHUz2B9TaFfFRS8ZSbqHkE	26058	3NLcBpEu91r98yaNFECWU59PWqJtD5Bm4316m2hLCMPVk92XntJb	58	1281	498	12463	17784	jwKtpFP6mrYChMekoFTXwkocC39Q32r1SsinXs1ZExbbpG9bUYs	12878	18107	18107	1619198460000	canonical
26061	3NLJugEnJ4eo1HJgw6htQ9HFG6ctqfk3HWpdTTat2nsYsZgZfeKY	26059	3NKmKPCXYpLV6evGtuNUHMxdQJCJBPjHUz2B9TaFfFRS8ZSbqHkE	1509	1320	498	12463	17786	jwmoLNr1swXgPsKFn6oxCqH8i7SE5y88jQA1ZFWUuxykk44fMqN	12879	18108	18108	1619198640000	canonical
28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	28834	3NL83ambGEVK7cVb2ABHprNtV347zkPvD6nmoZimbrodZ4niFGKA	1402	874	564	12463	18974	jxfoUvyGFF249roJ8RTtR62RPJGYpUcbLqHkw4nyL26apr2wDbg	14223	20034	20034	1619545320000	canonical
26035	3NKrTugi3V7keLzRMxGkDqsKHiwgrg2CzzEKCuK9PhkRsZLs7UGT	25769	3NKrdYESkiPcR8cnfFNmWE9oq4y4CiSQKo6SJZJELXTKsJGyNt5R	1671	1119	492	12463	17762	jxbrsN9PYbDuiXyRL5BNjZGUD6dCX2WvQQUpUSuN3mRJDBBf8hN	12745	18088	18088	1619195146466	orphaned
25979	3NKbL1PJAC4remdM3W2pWCm7uJwRbmsqLDUECxKjsrALsqT4jfEk	25978	3NKr3dTcRt2gMHRDaAvRxtmmYHN4VihkxyPq1VGGGAMoNBpvEK4V	1581	777	496	12463	17710	jwMwRx6b7qMFDgRkR6yjRfuTA6prm6yZCeFx4UKvc2x2iocg3aj	12837	18056	18056	1619189280000	canonical
25982	3NKii7RXMezkYiww7JDsfFedDwdke78MAvA7MKQtEKZtVWFH3yMC	25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	1406	1393	496	12463	17713	jwXy3BTFtUbJJrazVUHL653yDdJxeq92PMpk2NivhGuafykyCuy	12840	18059	18059	1619189820000	canonical
25984	3NL6u4SYr2e3DTK6LkGPnqxmxNVCL819SNKWYvRhSoqfrfL4rQv1	25981	3NLRRdPki5wuMBrsw46hH4AJ2RuXPMxF8qhUt5CfdJ5x9tVminuu	42	1361	496	12463	17715	jxLPv8z12cFLMi7uA5fW6iFF7vzBYsXYrbhJwgCNiZu6t2vsrBH	12840	18059	18059	1619189820000	orphaned
25987	3NKjQdH3L17muWhpUDM2w4X7J7LYdLcxE9vPiWnekEfUFhQ84U19	25986	3NLhUA4PvYeLJhoFMprZ7GeSxy8PyyZJQKW94v6aMtgTg7i3trCQ	1406	1393	496	12463	17718	jwQxQSTfZLrg4tWV8kATozt4TBwRBZVW52kJWvVzRnFCycjDd3C	12843	18064	18064	1619190720000	canonical
25989	3NKPt783ueyfFNKbzwdYcgJETqbEU81N3JCJtxZqq3BvQuyji5Lv	25987	3NKjQdH3L17muWhpUDM2w4X7J7LYdLcxE9vPiWnekEfUFhQ84U19	1553	776	496	12463	17720	jxCdr73jwrLpwSPqcPzkPXaJMqahuiasMHtAgKvy7XoCRkrCawG	12844	18065	18065	1619190900000	canonical
25991	3NLa5gduEj3x7TytRHKPt8z2fEwP1DiCt5thZhSGrKMrmrgM3RDv	25989	3NKPt783ueyfFNKbzwdYcgJETqbEU81N3JCJtxZqq3BvQuyji5Lv	1672	1159	496	12463	17722	jwheaEgDYLvrUWkATEn1jdscuG7iL5N8NQNr4tbD6vFWJQxnkwJ	12845	18066	18066	1619191080000	canonical
25992	3NKTnYu2NLwDr4QDYGr2KhwyFxz3X5y1drAjZXEW3yiYLzrvVdap	25991	3NLa5gduEj3x7TytRHKPt8z2fEwP1DiCt5thZhSGrKMrmrgM3RDv	1607	1102	496	12463	17723	jxAeKYLeJxRwDwVttRBZewVCsRPWMTceiASE4wVEsiwiv5hUpJk	12846	18067	18067	1619191260000	orphaned
25996	3NL8HUzuvKwhD3CJQ8vCPDXx7FzA3z1tdisJyAmrGh3eLxdzmHRi	25994	3NLV9on3htGfcsYU82VVbrVUDrjXVT3L466HTLs8KLQeyh3eC5hS	298	1308	496	12463	17727	jx1JWegiStQviqnfHKpLXT6xhvBjtu22VMVMJMRQAeou1awAcUU	12848	18070	18070	1619191800000	canonical
25997	3NLcwRNtg3LkgW8wwRvsQ83cqidoQM66DNVy8ioa5UqaLrpDvTga	25994	3NLV9on3htGfcsYU82VVbrVUDrjXVT3L466HTLs8KLQeyh3eC5hS	1579	1389	496	12463	17728	jxUGu5n1LWMqumoBuM5wSfx5RoNDhHUdkPqsuVzCA53tC6GSUuv	12848	18070	18070	1619191800000	orphaned
25999	3NKkmhZAFpkxS6R5n2JVS4K1QcPEm5HzGqhTLqufY7AFFvPBQEjc	25996	3NL8HUzuvKwhD3CJQ8vCPDXx7FzA3z1tdisJyAmrGh3eLxdzmHRi	1471	1140	497	12463	17729	jwZXwWWt1zoEchz6W8uzpt7Ritnh6hS16uqBmYDT1m4zdcuoa65	12849	18071	18071	1619191980000	orphaned
26008	3NLaLZc3A5PWEPakbA2AhUyYeYi4YAqfVpcWyJkh1eYNCxr8ycbY	26007	3NLEoQdd2GDQguBj1uvE1nwzqGEEpvq3Erq47GiEnXY4AkBrce7L	1407	1395	497	12463	17737	jwigUNbpoa6ebEAu5VF49mdZi7Lgzy8nkr3tgaSfwam64AoC2zU	12854	18078	18078	1619193240000	canonical
26011	3NKeTCok2U5saSVPU2a6WEaNpmxjejPhGG68cYcwnmzfYWe98Q13	26009	3NL8C9fkn55ikTCExDvu6kYLB934RiuKggDLwFPdsSQEQxuqkK1N	311	1307	497	12463	17740	jxnHNjtvDpZvNKqQKDeFdUJoMqGN9RHCbp6sf56UUo13y5Sa3oY	12856	18080	18080	1619193600000	orphaned
26013	3NK678kwvioKVHBR3gy28jZicssgh9Fo3CU1VQCY3eZKbgiBq9Wc	26010	3NL73UScVFdDvEYF2mPDtWcYLdqsuQLHakbEn3tv68PvxD93J5X7	43	1184	497	12463	17742	jwZ85rnHM7dqzXvaVzax8pxUygdgQCWcGNhHQAQv9fyPcsuoqqK	12857	18081	18081	1619193780000	canonical
26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	26013	3NK678kwvioKVHBR3gy28jZicssgh9Fo3CU1VQCY3eZKbgiBq9Wc	1423	559	497	12463	17744	jxrQiiFudc2AEXiSctQjEfpBSWbzRfzfpEDG6ngmLiEsenzdhqs	12858	18082	18082	1619193960000	canonical
26022	3NKnb59zvBwCNDv3Ht4XaEkX4fhUxMSsXdV9y8FkQb1YVVh2Njc1	26021	3NL9Ez6gQbTFTjAQhs6uq3j618P1fYuKypp2eP17Uy7A2qoBQ4fq	1585	1120	497	12463	17749	jxcw4S59hZ6jBvusWBaAWjZj4kxhQWF7AUuiiZaczquz3wiaATh	12861	18085	18085	1619194500000	orphaned
26024	3NK42J2Rei9B5XZLVZzymT9bRDobZp7hQr53YWbLEEATDDAmJdAZ	26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	1407	1395	497	12463	17751	jxTiizKwL27dLXDEimVpZEy2boisbGGHSFYJYJWGXFDnY9DRErA	12862	18086	18086	1619194680000	canonical
26031	3NLmRuJEooNuuBDiBnCKXGTKFZatn4yLX7o1iPUYZynBUC9o5yVJ	26026	3NKoFaaiBSu99SNpVYfYmFcjDmN6An2D2XDmP3yLhCHqyQ2vfSka	1600	1246	497	12463	17758	jwuktej5jFxeMuzYWkT6bbYNd6436EZbfqR8gox6vcGrKZZb653	12864	18088	18088	1619195040000	orphaned
26038	3NLr1nao1J67pqTXWxFGxyRL3PBtScrBNhiwfxvwAHFW68QX7F1N	26036	3NL38FnDhxynBp4H8qvS2i7Gqdz5FRggYKj5hpiiKyBomVUYJZ6f	1637	816	497	12463	17765	jxpYZq5LcFAsvC5BsiUhjM5piE6AtAdEC1XoiTwzuoCyUpnr3FM	12866	18091	18091	1619195580000	orphaned
26044	3NLVPbqC97rSNeeUSJuuXpRjhWVYCs2zHbPPDaYWqUBwGgvEK3yf	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	1403	824	497	12463	17771	jxwmKKJG6A9Uff4XyW9pZaCqZb7h3dkwHWfnr9f4jm6WFccqUiq	12868	18093	18093	1619195940000	canonical
26042	3NKWwSy1CGipRwsbjxURpe7uj9cKLSsJHwnbBQnVkEyHGu1BuPhB	26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	1522	1196	497	12463	17769	jxNgb2KJDukmSSrioLbQXi9bDQk5wubxdH7VDipcuhsYgdYKjRh	12868	18093	18093	1619195940000	orphaned
26047	3NKXLwkQVzkjSsgj9wUQXimXY86QXHoBPFcbQU2NoD9mjyvZXpvj	26046	3NLhpwqTdkEDqpM3pfm6DwvR8mxEqexJEb9LdKEvyJYiDRZFEjsu	1637	816	497	12463	17774	jxWPaaYFTLqT18McP8Nbv8kZugcDJS4rzaxGERuqJo1Kd21MSxn	12871	18098	18098	1619196840000	orphaned
26050	3NKHCS78Duczs48hcqSL8iAJijpKusDAJMgLUCi5rs2AuuUAVMZj	26049	3NKtWaZ33P5keD3U6TgdnTfmyaEMbpgy7dD1kiuemRDD3kkwkgto	1555	1347	497	12463	17777	jwMwc8r6N9YPHK3AEJfw9fBoiJYHAfT1WzZzjn1h52WC5kSCQyx	12873	18102	18102	1619197560000	canonical
26055	3NKsgERA6DMYMiJ12LqtNpk1gzC1Dv1zaH2BnugK9SYuCXUuPHXr	26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	1560	1045	498	12463	17781	jwKnFhn2kBV13N6FBLYjf4JqjhNrnDpeUrKagmgJA7TwmdTwELN	12876	18105	18105	1619198100000	orphaned
26062	3NLX2mDaC2FmeJfzN8QmBwnxBNfJ7XVfMKRZWtQFY3axeWF5CcC8	26061	3NLJugEnJ4eo1HJgw6htQ9HFG6ctqfk3HWpdTTat2nsYsZgZfeKY	1406	1393	498	12463	17787	jxfCtbcit7JH7j535W5m3qhyufonKmfFPRnM4w3qutS4kraUfVe	12880	18110	18110	1619199000000	canonical
26066	3NLxyyEZEmfnitTdrLgepbdTPJdYypuMq3Ckcb2xwbiRSbSqectK	26064	3NL3T1mhwtkiStYGWz6chbuLaEQUocXi5aNyevTWaTie2dLScQV6	1631	794	498	12463	17791	jx8UUmWX4bqrY8Qgy6QcqdY4z8eY7zPz45Rz8WsBwMnUH1h5xUk	12882	18117	18117	1619200260000	orphaned
26074	3NLrnsRJ4iiSfsdTzGEXegLd7GE2zCbjmKbXGVN4VwBK2V2GGjwf	26071	3NKWNiwACcr1bivSAJDgaRRNjwNsAsrxCxBygYTGTZoo5pA9fgYm	1403	824	498	12463	17798	jxT2N5nKMuhGb5JEYSdKw8j7m8v7PZjpDJXpguRV5wEwLSfQ5r7	12886	18126	18126	1619201880000	orphaned
26077	3NKkBsikXT3N5UyYTDTpTNH8h8tbPr3LzuXkLicMVg1gdU2ySgs5	26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	1523	955	498	12463	17799	jxDUJAUb4rXnC1ESs1cieysahr1gFbjW4R2X9JznhhrTCSGmfHx	12887	18127	18127	1619202060000	orphaned
26081	3NLV1wZfJ9ysXLV3ew2NKeto73dnK1f2q7rmWYHfu8cyVG2DDkgA	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1541	932	498	12463	17803	jwSGNwmWBM6HYnQ5bWG4tasUsVjpffoxA6VuTp7624fiPRhvojp	12889	18129	18129	1619202420000	orphaned
28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	1627	1385	564	12463	18974	jx917U1HAKYJTcLeUr78zWNeoXCjtDygrudAr6Adz9vTuSGPXzC	14224	20035	20035	1619545500000	canonical
26032	3NKN7ApfHB35kxsGVE9qSmHBy8iSR15VBfMnYFxdtYNeVaqAWecB	25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	1671	1119	491	12463	17759	jwu7jq5VrLsmX6FDmwLfZifNhrfQUjvQPpT3y52LBLxKXmPsbZ8	12722	18088	18088	1619195074604	orphaned
26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	25998	3NKHVji6CQHXDqUXGQMHxZ6y2gHihHJLG7pZvY7jXs64NisEkK8T	1594	1080	497	12463	17731	jwyFArkoKbZq7Y8tnybww2VH75RGKYLKNyGeYkECmYNXutPJQvq	12850	18072	18072	1619192160000	canonical
26006	3NLtgGE2Y5G9xioHkL1UKEPrc93oSD4PvwmztghLHMRGZWGJX3mj	26004	3NLUuyjxRDLsvrSK7BYhcgR7232aCNdijicSdko4YBDo22eZ6CLF	1407	1395	497	12463	17735	jx7AD92vghebUJP3yEUQ7qbahCQYeVTvCV48sYzphccUZd8ijeD	12852	18075	18075	1619192700000	canonical
26009	3NL8C9fkn55ikTCExDvu6kYLB934RiuKggDLwFPdsSQEQxuqkK1N	26008	3NLaLZc3A5PWEPakbA2AhUyYeYi4YAqfVpcWyJkh1eYNCxr8ycbY	1501	1114	497	12463	17738	jxtLHresrc55GwbTgu11JuyNVokWPEA7dQzzh9WcPFMpX1NmuRJ	12855	18079	18079	1619193420000	canonical
26096	3NLuvLQoyCKBSY3EkwzZQWXGd7Td1fo3N9Tmy5Yzz7WSNstJdaBJ	26008	3NLaLZc3A5PWEPakbA2AhUyYeYi4YAqfVpcWyJkh1eYNCxr8ycbY	1675	976	497	12463	17816	jxcXqrADVT5naDuAvgbF5CWJnb7NNaL9HQRAY7iidZwHgv67z9r	12855	18140	18140	1619204400000	orphaned
26016	3NKRCJUaEEfFT1UFvvDYZCRYNL5fVDvERK8SfMSYLM8hp9zTa77y	26013	3NK678kwvioKVHBR3gy28jZicssgh9Fo3CU1VQCY3eZKbgiBq9Wc	484	1073	497	12463	17745	jxtBdmqY5sg3dBPHbV8Z16arnvD8VXH8SYDMVnQ1kKvVyqxSVs4	12858	18082	18082	1619193960000	orphaned
26020	3NLLvCoLHEHVtxqLtHxpbEhjX7x5mnhnWnEkvvqA8h6uT2w5aHgS	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1581	778	497	12463	17747	jww5CZHFW815sM7oxGc5iWTEpn2qwJ99vvG8gc7ib2M21fyPcs6	12859	18083	18083	1619194140000	canonical
26018	3NLhwNGmpbnJGCEDKWsidPRtGyMS3pvpeVo9tsPS5rAtDoZSk7iu	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1476	1125	497	12463	17746	jxcL4PUHVnqM63ymz225iiAWuEMY3tuKV7HCAoUTBf5BRRup58y	12859	18083	18083	1619194140000	orphaned
26040	3NKdiRKcu65P8oMn6n1SXeNtP7Ef6PGeXpcdVHZbKJ1XCSmTv92W	26037	3NK7Z7vYkcmLW3d2fatJPRF4QiviMqcHzQKjBs6pKSjbjs6rhnJk	1407	1395	497	12463	17767	jxuoabKfS5xe7YUnYVbBhykhtHsQs88zfoYB7VLMpGo1VbV67ji	12867	18092	18092	1619195760000	canonical
26048	3NLc6JPRYmi45dmrqtqDcgduqJEcoW4LkL7ff5zaCMH62ZozSTJp	26046	3NLhpwqTdkEDqpM3pfm6DwvR8mxEqexJEb9LdKEvyJYiDRZFEjsu	1553	776	497	12463	17775	jx7j7szoiBctt6bMKgyqN52VVe16ayVLVNgLK5su5EK1AMcsTZQ	12871	18098	18098	1619196840000	canonical
26049	3NKtWaZ33P5keD3U6TgdnTfmyaEMbpgy7dD1kiuemRDD3kkwkgto	26048	3NLc6JPRYmi45dmrqtqDcgduqJEcoW4LkL7ff5zaCMH62ZozSTJp	1581	778	497	12463	17776	jwTFW3BA4feABg8M8aYNZd89oShZN3k1MGNcevqirZW9F81M3r3	12872	18101	18101	1619197380000	canonical
26051	3NLX6D2TQoNZQ3nokg5axdYja9mC8ScyGNRVpkhBrwmPo9ZGPwc6	26050	3NKHCS78Duczs48hcqSL8iAJijpKusDAJMgLUCi5rs2AuuUAVMZj	684	1352	498	12463	17778	jxLBosVuuAatWbAkmKEWAPLE2RJ2q6sncq762QQKFymeSRkHHcM	12874	18103	18103	1619197740000	orphaned
26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	1439	1033	498	12463	17779	jwyj5UY48pU3gxP7qgjs6SvymmsnJbqyaV6xYefnENCQgAjH35t	12875	18104	18104	1619197920000	canonical
26054	3NKLdsmEwvwRnizBEyLfdtVYZNnmtmPoySYWYzsT9qjQAdG813eZ	26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	1577	1327	498	12463	17780	jwvc7WAXHJHdykXhnGYudBVsq1aF29tPVg4nKvc6wQc2qTU7ESP	12875	18104	18104	1619197920000	orphaned
26056	3NKrJBSMKNNMvVNwGKP2jqJjpZwXMMBug17au6oL3Ted86psqcBd	26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	1444	1135	498	12463	17782	jwyBvLdVJRpHFubUN6jm4Xi4b8x3CfnwXYkVVUXor7H72Lws8uv	12876	18105	18105	1619198100000	canonical
26058	3NLcBpEu91r98yaNFECWU59PWqJtD5Bm4316m2hLCMPVk92XntJb	26056	3NKrJBSMKNNMvVNwGKP2jqJjpZwXMMBug17au6oL3Ted86psqcBd	1581	778	498	12463	17783	jxpnyuC6udk2ZE95ENs4dXqhGFwzL8QVj8taDEPahbjWBswV5vC	12877	18106	18106	1619198280000	canonical
26063	3NKteDnyecPfGJwoNUkW6Db3UW5S1Bi8z6icNsRvY951GQrSGpYe	26061	3NLJugEnJ4eo1HJgw6htQ9HFG6ctqfk3HWpdTTat2nsYsZgZfeKY	1623	830	498	12463	17788	jwXqTA4PTbHuVHy2g7ravdY8KWjUQ9MoqptscZzwgDfhDrushiL	12880	18110	18110	1619199000000	orphaned
26064	3NL3T1mhwtkiStYGWz6chbuLaEQUocXi5aNyevTWaTie2dLScQV6	26062	3NLX2mDaC2FmeJfzN8QmBwnxBNfJ7XVfMKRZWtQFY3axeWF5CcC8	1564	1338	498	12463	17789	jx4pTngAnu57BGpqyghEK3wgjRL9WLUbVLcpZpCJbBpCuw1bcYX	12881	18113	18113	1619199540000	canonical
26065	3NLT1ztxtJ19vaCo1hNixGawKcZ4yVSSVuF4CWdumbqB3qxhLQud	26064	3NL3T1mhwtkiStYGWz6chbuLaEQUocXi5aNyevTWaTie2dLScQV6	1580	423	498	12463	17790	jxyy2eNKs7wUdErqeiL64P24gCoVwezjfrewhFj7mfvbL4Dixnb	12882	18117	18117	1619200260000	canonical
26068	3NLnjbPittE4nf42pdMU2gcomXrNTAhaVdYqVtmrrqSzKvECsbrq	26065	3NLT1ztxtJ19vaCo1hNixGawKcZ4yVSSVuF4CWdumbqB3qxhLQud	1650	1375	498	12463	17793	jxPAqeTyMg3YhUBZm5AF5wQCgtddLqhHZiKTiDBSvrimgfFedTB	12883	18119	18119	1619200620000	canonical
26067	3NKmoGCVJr5oi8VVZVnkAVz9vrWDbyiP372ZdzMgF9qBdLEJC1v7	26065	3NLT1ztxtJ19vaCo1hNixGawKcZ4yVSSVuF4CWdumbqB3qxhLQud	1643	1299	498	12463	17792	jwCGRBXHVJq5NZMs2qCqTPsQ7gw5KmC72ZXBmAFNBLJ9PKX9ZSJ	12883	18119	18119	1619200620000	orphaned
26070	3NLHUvYL12JP3qxkCeszzq3Rcj35QDNkuCLZhY7QPUMbNERagg3D	26068	3NLnjbPittE4nf42pdMU2gcomXrNTAhaVdYqVtmrrqSzKvECsbrq	369	1186	498	12463	17794	jxJdv4X1eGVk19ueWAMsh8AHi3UKRA7PDsKph1GF6QfKg7mKoxg	12884	18123	18123	1619201340000	orphaned
26075	3NLZKgB7pdxttk7ZTV9TZzb6aKFtDEfzT6tpAZpKuyt8TNFwR7SR	26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	1523	955	498	12463	17799	jx1XxyjDJXHSLaN7N5kTXU3MQfevK72YrXykcnWK8m4EXwybRJc	12887	18127	18127	1619202060000	canonical
26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	26075	3NLZKgB7pdxttk7ZTV9TZzb6aKFtDEfzT6tpAZpKuyt8TNFwR7SR	1406	1393	498	12463	17801	jx6pa5WQ9Ls6KqVBYRobt2EjDL8vPUhubiRXz8qAunU2PbkNHV6	12888	18128	18128	1619202240000	canonical
26087	3NLKunub5Dnr1dL9DiT7gz3arMqpSEh2qAfhCCG1LcuFLkrPwfX5	26085	3NK4p7CrNjdPFWy2doujdd1tspoz4RpjY8z9vnwusFhAC6FYUhPM	171	1374	499	12463	17807	jx7p1ZqHSL2hqKDPF7WJxJ1S9CVaemPyuLhRuNtmrKUz15w8Goh	12892	18135	18135	1619203500000	orphaned
26094	3NKpwd6ZhxYLbY71zAoyZT7qMrgQj9PNuiXztK1ktLiq6Hb9h3Zp	26093	3NKVtka8UJPg2M9LCs8DwL8icQiDLo7tvVfNyVafpb1JNy4JDkBq	1406	1393	499	12463	17814	jxMrirZVMEwbns3VnKVZEpe3PtXcd3e5kKJyrg1ZWUJgcSfBH9g	12896	18139	18139	1619204220000	canonical
26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	26104	3NKCuUeUJC1bVZVjob2dYn3ENWbug1UQEdKtNYTv2iSHd9zg6mjr	1406	1393	499	12463	17826	jxwAisucBJxFG6d88NR5veeTUQceHZ3cR1fTQDnRWFQjtuvhi1n	12903	18148	18148	1619205840000	canonical
26111	3NKVfMwvrprHtYP3JBD78EDdqukfme8CKLBaJwpZtDyxhB6tsr6q	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1474	1083	499	12463	17831	jxMVmrWAjeZjxSARnknx6K45whWxhnTAh4TPd1FUUPQqVqccV9R	12904	18149	18149	1619206020000	canonical
26109	3NKf5QggLb1QvS7qyeqYXpC4egpioMa4QsBtpXQZhfagVEsUSSq3	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1460	627	499	12463	17829	jwVUVWtR3ZUhmcCJBqtGeGtW1zhjUo2MooCRAcDF2LqJP1DKhYe	12904	18149	18149	1619206020000	orphaned
29126	3NLXbsrcujTWMCrQ9MS5DmCZ6GJVf3UTbZvS1TZFh7akaTtFcPHe	28861	3NLy3BRndwNuqg6fAneJGfXpU7ZR1q2zyP28hxnMHBvtKusuX1RU	132	132	565	12463	18974	jwrrWnTrFcibAbNcgvdi4sH9WxUwo6V2WHq46WQyRTUmnXnTgh3	14235	20216	20216	1619578080000	orphaned
26071	3NKWNiwACcr1bivSAJDgaRRNjwNsAsrxCxBygYTGTZoo5pA9fgYm	26069	3NLnwKkwzgJnwyke45zcBBdkpzoXgo4orB92wfE4oxPyyKPV7FMC	1637	816	498	12463	17795	jwNQ9mNvAcsPq2jueM2MSU6erUEs77ocRupGBr1bqQZ9sGEfZzN	12885	18125	18125	1619201700000	canonical
26072	3NLsUqivcjdp8PFjZgDnyoiLgy6L6rzbHMq4ttnnNdDA4Jr83Ke5	26069	3NLnwKkwzgJnwyke45zcBBdkpzoXgo4orB92wfE4oxPyyKPV7FMC	1403	824	498	12463	17796	jxht2V4mhffwkQhk8FvQKND5nPr2NCBgMjPcQprX339vrWTcn5e	12885	18125	18125	1619201700000	orphaned
26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	26071	3NKWNiwACcr1bivSAJDgaRRNjwNsAsrxCxBygYTGTZoo5pA9fgYm	1455	1206	498	12463	17797	jxJV5a6f6KEK9VjNR4XGRgHjq6pQGa2sPtGPRbdZmzXcNByNGi9	12886	18126	18126	1619201880000	canonical
26076	3NKg2EgMgJxbtEWcJJBPXoe6t2Ne32rvzm4Ld3xHsEh9FPW8vkNW	26073	3NLDD8MVjXiNYdetKNbQfJqpamqiFkzyxPd4WbYsEJ9fau3BUs7H	1523	955	498	12463	17799	jxyDimmyNPJP9dorqGRwgtZbb9kfcKWcVLzYVrSEreEb5U2bUVM	12887	18127	18127	1619202060000	orphaned
26078	3NL5mnX8wiepgjvz6UBRTEGGkCpHZuKS3Nw98uxrjkwFxFiCDpmY	26075	3NLZKgB7pdxttk7ZTV9TZzb6aKFtDEfzT6tpAZpKuyt8TNFwR7SR	1509	1320	498	12463	17800	jwcwd3gsfvnATDo573vzqFnijZ7avepKaSfr5sNsCAY6N6Mb5hc	12888	18128	18128	1619202240000	orphaned
26082	3NKsJC7gC5XBjjYfxRmAGVXxrKbzDXH1g9abBfbxcUBbMeuSi7Tp	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1541	932	498	12463	17803	jwCVawPT8pNmk6ctDZkt2fGLHdQ4Kax13LksQKRpqGHjVttDFWD	12889	18129	18129	1619202420000	canonical
26080	3NLBejGLJ5ChkSFAg1KtfMWAXJbfRDzJ9RNyAKtifGr7x17HwNWD	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1585	1366	498	12463	17802	jy2avqyiGoeAM1YST8c1VESzfJTPmxMWEgDN8RR7p7wWnCTT5aB	12889	18129	18129	1619202420000	orphaned
26085	3NK4p7CrNjdPFWy2doujdd1tspoz4RpjY8z9vnwusFhAC6FYUhPM	26084	3NKtPMSAMqZ3CXTQDAt4HuoDpPjmpszHupZQjVtwcT5YHSExce8j	369	1186	499	12463	17805	jxCjZbKQp8Tr1Ud4byKeZSK65T9Q4eGYJVU8VyxLERhsDdLFDTc	12891	18134	18134	1619203320000	canonical
26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	26086	3NKk1UrrsuAkKEKCZTDdGApMbjqpZFBKRjbrCGcqZesE7vELN2ou	448	1059	499	12463	17808	jwsFt1NUK6Xnk1rvVGi1XFqqdh1Tgw7djfdtyibmEvomTi5NZkz	12893	18136	18136	1619203680000	canonical
26092	3NLKYwRhXg2no1KxZTp4Zau45Tpian6tnWaQED14rGhBshe7LBMc	26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	171	1008	499	12463	17812	jwFupnbv3eDAyRCrB2XhMTTbXwptL9Y1f8muN8eCXPXSWzrFbLT	12894	18137	18137	1619203860000	canonical
26090	3NLfyAYVFYdTNXqmfdnseVTJ5J48FF88txaxzRtme2V3D8FRwKv5	26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	1637	816	499	12463	17810	jx1PxJhJRdNiAL5KgqMsHuzVaRWuW6KVEHvJvLgBB4wcM1CWuJc	12894	18137	18137	1619203860000	orphaned
26095	3NKwDXqQYB4YRWEXN94s7d5DKpRDzCw5BrZsD4C9A8w2xjHUVVzo	26094	3NKpwd6ZhxYLbY71zAoyZT7qMrgQj9PNuiXztK1ktLiq6Hb9h3Zp	1675	976	499	12463	17815	jwpA5LmANkjKurfjueFju5Y6b1Dw8RXn1cvSR3e5WaknrUtBsD8	12897	18140	18140	1619204400000	canonical
26097	3NKh7Xbkx9cr2b2WNHgYNRdKGaAsCwiYEcGHpptAr2g9pezFzPas	26095	3NKwDXqQYB4YRWEXN94s7d5DKpRDzCw5BrZsD4C9A8w2xjHUVVzo	1607	1348	499	12463	17817	jxE2nXaJS5tjCiboAEqnbERTR45sNu5cPiacxQjYsxAVXmrUQWf	12898	18141	18141	1619204580000	orphaned
26099	3NK3cgrVKfvEYk8iMNUxggmYLuLw3prtwrNDRgCjqyKXsr6okzr6	26098	3NLvv6i6Qoc34k2NLYQYDM2FR9QR6GTB3WoFQi8rLrieYv7d6YX4	1403	824	499	12463	17819	jxZczwTa8i1ASVnhaCCr8iiS91QfByPiQ9XBMGuhkgHADnLwKtT	12899	18142	18142	1619204760000	canonical
26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	26099	3NK3cgrVKfvEYk8iMNUxggmYLuLw3prtwrNDRgCjqyKXsr6okzr6	1643	933	499	12463	17820	jwGHejCKWZCNtVcJiPdLDb8r7AwPFy2L26uFPnHuKHMwjmvYSCb	12900	18143	18143	1619204940000	canonical
26102	3NKt4uUE8JbJ4aWRHtEZLMLWNuvTw14xXZ5XBXWKzpky2pCNSazz	26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	1598	514	499	12463	17822	jwzZJ5KWRzE9RYMMQV3q6ZAmGu1RbtP3QTfVvEv5Fz8v7SwpAMx	12901	18145	18145	1619205300000	canonical
26104	3NKCuUeUJC1bVZVjob2dYn3ENWbug1UQEdKtNYTv2iSHd9zg6mjr	26102	3NKt4uUE8JbJ4aWRHtEZLMLWNuvTw14xXZ5XBXWKzpky2pCNSazz	1656	1097	499	12463	17824	jwdyf1D9T4WgMeGxQk5LwJnnerkHL2id3mYRUhKcbgRzNPhUFAw	12902	18146	18146	1619205480000	canonical
26112	3NKctKG5rXoJNziAHxkHG1jZuGvVDj953Gu2qhvgL8JfcNrEBnp3	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1506	1247	499	12463	17830	jxias25uUFE6MS7jUK3vyM1ioaKWE4uPbSFk6nVk35FcXfcwToB	12904	18149	18149	1619206020000	orphaned
26113	3NLSeimqt3Ds2aVXueknDEMZ8YYztQ1FukKWriEBHkL4DrxErgbn	26111	3NKVfMwvrprHtYP3JBD78EDdqukfme8CKLBaJwpZtDyxhB6tsr6q	1405	873	499	12463	17832	jxTRCt4yzKDQiLZFbhGXwvZLum7CJzDyKYtnAyQJBeYQLEZaYNS	12905	18150	18150	1619206200000	canonical
26116	3NLGsU9T7rcESZxpk2BgXHswL2eNC63qYzv3mij7j5PzgWUzvqpU	26115	3NKjEbMU4A6Vjqz5mVqoBYdUsGRvz5REMBxjH33GniAGqSgV5VEM	1406	1393	499	12463	17835	jw6jpg9nWxHpgQWbeZb6dUdVvVVRHF6WZeHJhtdHVz5wuuuenYe	12908	18153	18153	1619206740000	canonical
26122	3NKoaGYxa49D4C69mUPtCC2dEPhYQgokAte9ZGpY6QjBCHnMX3me	26121	3NLAv4gPhupq1tdDoFAmuD5rShP2SueKeXRiP4UJYYF3HtxMJJWN	1406	1393	499	12463	17841	jxcyMjg2ah6vx1WkuzvMT1qA6cCgbr8Uwp2bV93sSEdoQyYDM4L	12913	18162	18162	1619208360000	canonical
26127	3NKXWDHu9Bx3DdofnuBhpydE1pG4FsE3M8pN9bjUiPHVnV8ihBjP	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1423	199	500	12463	17846	jwGdBYt3wuxDH6u4CirFB5t5xWBGLNYmXhot9SFr2AYLcBrqXFq	12917	18166	18166	1619209080000	orphaned
26134	3NKbkSYkokysrQhx4CJs8yxpavTV1jd5TxTzGwcsunyNwLkkc7WD	26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	1623	830	500	12463	17851	jw9LnTWwgtBKLpkL6dn67mUVJiqRJQakXpJzMT6kp2ChrQykSa8	12918	18167	18167	1619209260000	orphaned
26145	3NKTj3ZyVcQY4pws8y2j1vBTL8B7Uia4b5jSL44oHkLpWAeY77GU	26142	3NKudP2CNMbRKnAoNiUxqU2d28enbFzKKLQ9kJPHEsXkDWxaqKGb	1406	1393	500	12463	17862	jxAAVb1QsUrqN2LBcqWUoefVVHJgHjzYbfpa1mznnwvfByo1cnP	12924	18174	18174	1619210520000	canonical
26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	26147	3NK93C585FsVqWwN6xPqvXdQ64LqvPka6NAfNPi3hBk86Bq2BjWo	596	940	500	12463	17865	jwxTjMJycqvYkxyGrJwicPaENinaZrkJoDmk8VupyuK2iHGjDVB	12927	18178	18178	1619211240000	canonical
26153	3NLZNtnaRbf3GQo9ZruS1RQ4Qe5vCmBbKC7JfjyFp2Y5ZdgRmTrW	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1406	1393	500	12463	17870	jwcrEdUC8fkgwAdvdWRDYA8B28XEMz2K6a2xdT8rZmE5pPNML86	12928	18180	18180	1619211600000	orphaned
26155	3NLTCKtQ9fJgEHsLNEFRwk9xuA54rgPipnZGQ8kVqhLtfzsRKPuf	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1407	1395	500	12463	17872	jwux54PZwMcyqUqLPiXaDHQHj44PXmvBnc8K6rxHom1BFHRwFEu	12929	18181	18181	1619211780000	orphaned
26158	3NKKgMBbXzdAojeQvEM8CPu7FsLFWA5fZT6xHnNqyziCRqPHawQW	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1623	830	500	12463	17875	jwQfE97Kr5AnohuX2Z7RzA17HfQdHaHbGLQj9MBaDmuUhtsgGy6	12929	18181	18181	1619211780000	orphaned
26162	3NK9Z7dCx4ZjU8AUGAtRJhhFoVagZwYDuY2xz8PMtAAFwty1eLbH	26161	3NLJbZQhZ6nvQBFh9XbUw7nZtsgxhJPYadXBmxtBYpcPsPEuFbAu	1406	1393	500	12463	17879	jxZ6NjZgApQQM7Qmz6AawXeybiH4hnZg9sgpY6PELwDe8jweNnR	12932	18185	18185	1619212500000	canonical
28870	3NLmuYBUy4gRovkPsX5J5d8keSDm6JtCZ85JL2iDVMVJtYMDfRyc	28868	3NKtTKaiGq918jZYZJmxYfFv1x91NWD71QahsrEpDWGbPiGtV7PT	1508	1387	565	12463	18974	jxvoqMysXz8EPt3crULDoweZqQ7SNdhoi15BRMYk5E6dgk1MJHD	14240	20061	20061	1619550180000	orphaned
26083	3NKYQS7fg7MpoSkbDRRcmiyCxVLGd8D4K2W2uhm2QKRT3nCrS6Wy	26079	3NLTxCYPihBS9dVidX73jDFadAsUXxrtEp5d4NZDCZ4FCbeCTWFE	1541	932	498	12463	17803	jxazsDvcFmYpphRDHCkRCkL8oYr6XaringhuqKX1YVxoKAHUpJ5	12889	18129	18129	1619202420000	orphaned
26084	3NKtPMSAMqZ3CXTQDAt4HuoDpPjmpszHupZQjVtwcT5YHSExce8j	26082	3NKsJC7gC5XBjjYfxRmAGVXxrKbzDXH1g9abBfbxcUBbMeuSi7Tp	1559	1107	499	12463	17804	jwCc4TfpccJk9cZfn6MmmTzzZE2iQQVfo7LEe66mAoGsy8zyKq5	12890	18133	18133	1619203140000	canonical
26089	3NLNrbABJiBrUrd6aFVZyjttWXbx2siyJYYVJGTYvuzt65SznbiF	26086	3NKk1UrrsuAkKEKCZTDdGApMbjqpZFBKRjbrCGcqZesE7vELN2ou	1501	1114	499	12463	17809	jx1tL1LDdQAkLKr8kEogD7RgpEyPrxavvTVHiCAxuF6PNkzAKsf	12893	18136	18136	1619203680000	orphaned
26091	3NKhGfZ5Ni6DR5MW2iX7zCFCyEv3yog8BFVbAxMs9bFMreKaDLib	26088	3NLeFaUncSf9d6Jv3iXpb6ta9mujmrHc3PZjE6kYDSEyVBgGCBp5	1405	849	499	12463	17811	jxueeAJm3u25Z8Njact7vYDacs6F6HGaaJD7GkJzLxfD9bnHJxm	12894	18137	18137	1619203860000	orphaned
26093	3NKVtka8UJPg2M9LCs8DwL8icQiDLo7tvVfNyVafpb1JNy4JDkBq	26092	3NLKYwRhXg2no1KxZTp4Zau45Tpian6tnWaQED14rGhBshe7LBMc	1406	1393	499	12463	17813	jxsboW6WkKZipzccBH7Q8JPBTeJeQNqG6NGtC8Jw8Af6RtX7xDa	12895	18138	18138	1619204040000	canonical
26098	3NLvv6i6Qoc34k2NLYQYDM2FR9QR6GTB3WoFQi8rLrieYv7d6YX4	26095	3NKwDXqQYB4YRWEXN94s7d5DKpRDzCw5BrZsD4C9A8w2xjHUVVzo	1406	1393	499	12463	17818	jwGKieWHz11s3DiFf5P3QztMRK83i7inY1g7VB51uVhRpnSWWeE	12898	18141	18141	1619204580000	canonical
26103	3NKnjJ6z8FvvfEfah4kvUTdU5RWjx4Fzy6qhtBnpU9Zk6wDzUED3	26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	1589	1160	499	12463	17823	jweVhx1c7fpMArRyyE9P1n4GLzKTNj3GbRTtQsmhY8VecZ6xAXJ	12901	18145	18145	1619205300000	orphaned
26110	3NK7QzEXboEZ9wGeNGwErAQBKQ2bdhw4MB3eCnVoeRFbrWhNxE5h	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1506	1247	499	12463	17830	jwzncMtZpCtLfGGeyyQWiww9v4PqyYVuQGdNnbP9YCMeDAvRhKw	12904	18149	18149	1619206020000	orphaned
26114	3NLDniV9CZHCTQmAtwPeMh25Gtj76hLfEXDwFduAUXhuJ2FewTTP	26113	3NLSeimqt3Ds2aVXueknDEMZ8YYztQ1FukKWriEBHkL4DrxErgbn	700	840	499	12463	17833	jwjKgBfBLyYn9s7n8gkmyD1kyMWpKETXGetcRa8s9wk2U8suVkD	12906	18151	18151	1619206380000	canonical
26117	3NKNQLtN1BAZcHyYA1fWaYSeNwLdaDVWDRzL5QkF8ogpFutXtZwC	26116	3NLGsU9T7rcESZxpk2BgXHswL2eNC63qYzv3mij7j5PzgWUzvqpU	1406	1393	499	12463	17836	jwQRo23omp1VHRbDQynjB2G1nLuio6BBM8uTHZsDdJdidJP5ZSS	12909	18155	18155	1619207100000	canonical
26120	3NKWo4YqQB55P3eJjie2vdvqLf9CDDCSatagsywgPwD7P8NeDWem	26119	3NLrRJ7ZYBKR7TusG36Pvt9YCRZTMZ4HmoktwihUN8w4rNfof3Lg	1406	1393	499	12463	17839	jxNHrfYDBe8jWLy4mNFicx1cR3bkL4sKLUswb2NDgBc2SQLxiZ5	12912	18160	18160	1619208000000	orphaned
26123	3NLvzc8hZsDuqHXaaQVNFb2ek2VLzKBCDaPdoAn7tfdYhQyXvDi7	26122	3NKoaGYxa49D4C69mUPtCC2dEPhYQgokAte9ZGpY6QjBCHnMX3me	1500	1051	499	12463	17842	jwPw5SauKH8eoPzsLQQiZzL1BFgHPVnroXSqo9jgStWBH11RXSw	12914	18163	18163	1619208540000	canonical
26125	3NKYKcpYHcDxxQKJwpJFXivWYxgXFtgKv7N63AQ8PLrvu6kies3Q	26123	3NLvzc8hZsDuqHXaaQVNFb2ek2VLzKBCDaPdoAn7tfdYhQyXvDi7	1407	1395	499	12463	17844	jwpYgWAtxoE949ezJjquK2dembdoic3BXBca9PF4NRpWaYLrSU1	12915	18164	18164	1619208720000	canonical
26132	3NLrHrrEZd7ghtsrN2ScS1ndxrGrjdisR51J6xHXugTH2PFCudSs	26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	1406	1393	500	12463	17849	jwsgj93Qf34U55gHGWqBNppHoijjjQVrjspBWHUtXEm2d8TDGPm	12918	18167	18167	1619209260000	orphaned
26136	3NKCZDCE8LUMCQUsSd8D6BUesMiUC2dEdSi2FpWcW8oPWucMfStE	26133	3NLuYbQuQe48qEnxx2CZfppopfXuLjDdHK45cVESBvfwWnBYfnJM	1657	1218	500	12463	17853	jxBGfRmKfxSWq5gFoeaQveEtXQLb46jk8137C6tHNpGSvBYgdn1	12919	18168	18168	1619209440000	orphaned
26139	3NKD1oKbEKFuqAgsErm6ZDeiWcVgfnBWCkGTdcAsP8kGnogKH9i5	26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	1419	814	500	12463	17856	jxmVydFnWuShFbPvj243VvFdNvhsUmnWTPR6VRY2dsCr3SQxeq7	12921	18171	18171	1619209980000	canonical
26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	26139	3NKD1oKbEKFuqAgsErm6ZDeiWcVgfnBWCkGTdcAsP8kGnogKH9i5	1564	1212	500	12463	17858	jx67jjEbnFiANBndQmyr2D7SK4zx6Nf5vuU9VGSdxATdyy3vE6p	12922	18172	18172	1619210160000	canonical
26144	3NLaUgdbB6WUiqageRdmwJfgjESvsnyD5kQbsaAsz1E2Gubmt9y3	26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	1657	1344	500	12463	17861	jxaA3eT6fAQRXBCYFzhqDEfGFdMpTw9f9CpHwBe4aNYNEpakkc6	12923	18173	18173	1619210340000	orphaned
26146	3NL6K3ZRqmmMUnojXmkdqT42b7gMQxcRUGu7PpnhaNJ2kFnT3hPj	26145	3NKTj3ZyVcQY4pws8y2j1vBTL8B7Uia4b5jSL44oHkLpWAeY77GU	1477	1350	500	12463	17863	jxANSg7qbRuX9QXzS1MFHrFD9NaYF9DzdcU7kRQsGqpvbVvDoF8	12925	18175	18175	1619210700000	canonical
26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1471	1020	500	12463	17868	jxdwjFsEX2xdLYzRiwBxHpfoaGguBR1WLDfekAxRzrsv5YDk25Z	12928	18180	18180	1619211600000	canonical
26156	3NLfL4UxMYFKVd2VSigXRMLfNgwea8N2Mi2KBGG3orG87RYpd6T2	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1593	1346	500	12463	17873	jwYcuQaqjcx3hdEQU7ngHdtFWJLXYT16uPskxZcpiDEqYSGWsNV	12929	18181	18181	1619211780000	canonical
26160	3NKByhK8gdbzvqn11uABCMoCASFVSi1NfQQqvsno9nitoLxNUVCa	26156	3NLfL4UxMYFKVd2VSigXRMLfNgwea8N2Mi2KBGG3orG87RYpd6T2	1646	1354	500	12463	17877	jxZtCvFa8EM7uzJP9yLqf7hqsXqyJ2Aqgdwj2Qmqm6VK8W1JWXp	12930	18183	18183	1619212140000	canonical
26165	3NKDwogyidLh5A1818jfReU5VB65Feo3UQaamP3h3inmyHKdaktb	26164	3NKBHHZUXShECd4daGWYJ2QXjrJ6NCsEh4Euuo6MrrZMKK4BvXiP	1670	1036	500	12463	17882	jwH4E8jV9SF3Sed4PvK3t9vvgBEofb2q5g5N6VVhvB1ybWrB6xJ	12934	18188	18188	1619213040000	canonical
26168	3NLBhhFWBSWYdvNjZZSYb6AjBieqcHTuLFyHveg1bhDnSCboPsw1	26167	3NKRo725MRw9yLnBTfmPe2tqfanCXum3ZgStCAY8U3tTJWkiWTzE	1608	1289	500	12463	17885	jxU9QFkgvEhrUVxyjSaD5SRXFRP3u51SFt3z4UNAfQbeAje6qbL	12936	18191	18191	1619213580000	canonical
26173	3NLxyy2AGMWpezpZW2phpbKDDytQsJtD6GaEwtr6roMXvqeZwmsz	26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	1581	778	500	12463	17890	jwvthLc9SVhA8xDd5o4ZdvTQRcTvVVnd6jBZPTSMJcFAdFEyXen	12939	18195	18195	1619214300000	orphaned
26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	26171	3NK3g3HT4yAAPWC3wRtM1sWvQXuKncFX3PwDgF8psv4FkMduvHy1	1490	1148	501	12463	17891	jxQVPuTPo2x7nQkkhpXHRK6Ebc7uQeh2VcEsep1afomkjBJQYCn	12940	18196	18196	1619214480000	canonical
26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	26179	3NK49WZWgMTURaEtb1s1iLJCmRsVASRdq2VXtm9yktadSobXYqBE	1455	1332	501	12463	17896	jxF7yazJfLL7xXF3sDVmzL1s18aifku91CeUKq9k6Sf8ks6wdgW	12943	18200	18200	1619215200000	canonical
26189	3NK4XcWL9k2an3NSNpL8pdVgyTMybgzwH45LwhfJNRZbQej9a7W6	26186	3NLBQCjJLYY1CdPZ1BxtQ5xL4KCvwkRCoX77KVbMTTmGrj69UEbf	1585	1120	501	12463	17903	jws6hCdXLRQfzxSKqut7aWXBjxcaF1pqnvPs2YJzpBCoWddGw3m	12946	18203	18203	1619215740000	orphaned
26192	3NK4gJFtZp6vWUcsjBAfdtZaAVpt2k3X9vrCJWEBPVerPzggiK4S	26191	3NLrgGx5kfh5UT4UE25PjQBMnBfZR3gNfrW4tWQh3sXHAHZGxr3E	58	1281	501	12463	17906	jwhUNyCr5sRdKtEAPvvEZR8V5164EZpFnvBPGRzHkYkq15gb5Y1	12948	18207	18207	1619216460000	canonical
28905	3NLcYQ6DccXAwrFjEmtv6k5qnGHW9KciJUFvVFvE5uGMdvXDEnsG	28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	1650	1249	565	12463	18974	jwuoiyhu5B5vNvmmG3XgzBhAS6jA4Q8FhpATXR168T9jCRHkGy5	14242	20081	20081	1619553780000	orphaned
29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	29537	3NLR8A1E8MfH8CmJkacS1SqhgiikTc4FgWymEb72rtXj2X2NWX5x	1403	824	581	12463	18974	jw85m3QPQVCeNrWqsJC6gWVabXYiXEXaaNUsKSLazpKMLugswmQ	14565	20502	20502	1619629560000	canonical
26105	3NLhZes8SgNDPfEj7PAm1kb7cw6YtT4m2hviVNmYwogiMPDbym1N	26103	3NKnjJ6z8FvvfEfah4kvUTdU5RWjx4Fzy6qhtBnpU9Zk6wDzUED3	1656	1097	499	12463	17825	jxggVR84v9BUG2bcSiWS9GEgq1P4hNUgSXmYK4sFshM6zNPQHLF	12902	18146	18146	1619205480000	orphaned
26108	3NLaSwZLrShDgHVaqRqCduDdquEtz89DS22m5uQmiz12KXRaWyZn	26106	3NKSi2WiFK8GCJmpmUYRJVidAsUzrSs7mH61TQTKrBrVTisuSTnp	1500	931	499	12463	17828	jxE5C5uABtD2U1qPBzyKLNpqLchUhUdvRUwPy3kxz1PBiHjnHHj	12904	18149	18149	1619206020000	orphaned
26115	3NKjEbMU4A6Vjqz5mVqoBYdUsGRvz5REMBxjH33GniAGqSgV5VEM	26114	3NLDniV9CZHCTQmAtwPeMh25Gtj76hLfEXDwFduAUXhuJ2FewTTP	1608	1289	499	12463	17834	jxRPPUyau1N7XrkrVn38vNfYaGUPb71zssQUWQafZ3gQcAVrsZR	12907	18152	18152	1619206560000	canonical
26118	3NLy7wWezCTfnBBeEdS3b1MncVHxSHDnLi2AK8eA8YDCfF5Jsouc	26117	3NKNQLtN1BAZcHyYA1fWaYSeNwLdaDVWDRzL5QkF8ogpFutXtZwC	1402	852	499	12463	17837	jwigcpLhdgewBUYAhgTUbZEZ8zeAmYqU6mEWdwcuynbdUgGL9EV	12910	18157	18157	1619207460000	canonical
26119	3NLrRJ7ZYBKR7TusG36Pvt9YCRZTMZ4HmoktwihUN8w4rNfof3Lg	26118	3NLy7wWezCTfnBBeEdS3b1MncVHxSHDnLi2AK8eA8YDCfF5Jsouc	44	1325	499	12463	17838	jwsFqwzTtpSW1cbARiCoZM8xsMcubgFAzGTqqrFakZYtw29RXuc	12911	18159	18159	1619207820000	canonical
26121	3NLAv4gPhupq1tdDoFAmuD5rShP2SueKeXRiP4UJYYF3HtxMJJWN	26119	3NLrRJ7ZYBKR7TusG36Pvt9YCRZTMZ4HmoktwihUN8w4rNfof3Lg	1403	824	499	12463	17840	jx2JTY57B9hijH8F139xDbMvKYU4n4r9USSFmv2Q5fSAcsiwDVa	12912	18160	18160	1619208000000	canonical
26124	3NKhRrLDiZsNN5jd9Nm4tFSFsKb3eEYCHC2z87PzvNm6Pi1Ttqkm	26122	3NKoaGYxa49D4C69mUPtCC2dEPhYQgokAte9ZGpY6QjBCHnMX3me	1637	816	499	12463	17843	jxbx44iY2gFT2g8bQZsdt8Veo3pEJCy8eRBv3WSYrG3ACWKcEt8	12914	18163	18163	1619208540000	orphaned
26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	26125	3NKYKcpYHcDxxQKJwpJFXivWYxgXFtgKv7N63AQ8PLrvu6kies3Q	1406	1393	499	12463	17845	jy2JZvQUJzzRxiFatqeQUNrm16QGu2nHVg1Abmb7WtQx1HHdiiZ	12916	18165	18165	1619208900000	canonical
26128	3NLkMtcZ2KvS4n3y12zEMiZ2ixWrJ8aQgShoPR3dwxF7j39NPLrA	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1489	1380	500	12463	17847	jxyA8Lurv9QDVsABmPg9yx1sFr9CZGDjftuxqZH6SMz396TyeK9	12917	18166	18166	1619209080000	orphaned
26133	3NLuYbQuQe48qEnxx2CZfppopfXuLjDdHK45cVESBvfwWnBYfnJM	26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	1405	873	500	12463	17850	jw8GRWPq8JJt3Pbmj763vobBv4hLdqCisXYHief7WMJLR6Ddxg2	12918	18167	18167	1619209260000	canonical
26185	3NKaLoMTEZ9764r44LeRe81E2BZSgq7JChDsCpRQVAMKRXXVSBm4	26149	3NL1Ak7NaDS473QEieQW5enXmyFfwVkTtBBUcv7qwebyjcVwkLRt	596	1060	500	12463	17899	jxoFgQkUc848w8DWKdooVuSWX6bC5uGh8nM77db6mGKiSszYDoH	12918	18201	18201	1619215380000	orphaned
26135	3NLy2gawAiDLa2Bx5aL3cuK3rh1cX9s5uL4oHr5b6gpNt11cuFjc	26133	3NLuYbQuQe48qEnxx2CZfppopfXuLjDdHK45cVESBvfwWnBYfnJM	1536	1313	500	12463	17852	jxAKFCx34dmBVpDMbCDL8ti7t7W7B1HzXnDq5fbn5YcPKNwq1bL	12919	18168	18168	1619209440000	canonical
26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	26135	3NLy2gawAiDLa2Bx5aL3cuK3rh1cX9s5uL4oHr5b6gpNt11cuFjc	1608	1289	500	12463	17854	jwpzGzRmMm2saPrrW2Y5nnsMjEBAghZHQdALkkgVHRa1TbYbVvw	12920	18170	18170	1619209800000	canonical
26138	3NKSHUanVLrHPMXjYooWkrSeRwWyks2V6tJWZL6hRWxReb4RgGiC	26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	1476	1371	500	12463	17855	jwDDF9sJ7o498gZ9ZRVwxS6qzsTEMaRDDNbVtw4VhRX1gDK4FYJ	12921	18171	18171	1619209980000	orphaned
26140	3NLghg3eQz9iS9noUfkBVQZBRQz3ZkZs2gSJ27TD3RswCfBHk1HW	26137	3NLLBxwPm1WWsoREQx7RTfHLTjoeoKtRjBG7ctdHU3DNomqTqxud	1402	810	500	12463	17857	jxJsz8475dsk2A9Pc7Sh5jM9KRcVgxnbNUz2WCjF6eUGkw11dq1	12921	18171	18171	1619209980000	orphaned
26142	3NKudP2CNMbRKnAoNiUxqU2d28enbFzKKLQ9kJPHEsXkDWxaqKGb	26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	1407	1395	500	12463	17859	jwhDi9yv8LDmfwkbg6Hx3ucay1LHCqjzL2HUH5LHGJGvKoHNwLd	12923	18173	18173	1619210340000	canonical
26147	3NK93C585FsVqWwN6xPqvXdQ64LqvPka6NAfNPi3hBk86Bq2BjWo	26146	3NL6K3ZRqmmMUnojXmkdqT42b7gMQxcRUGu7PpnhaNJ2kFnT3hPj	1407	1395	500	12463	17864	jx51C6nPND9QZkVh4MyLGik9g2uD6SnvXBmcZkvjwXFAxBP5xqG	12926	18177	18177	1619211060000	canonical
26154	3NLKaY5yEnvgkTcSd49b4f97DEGJBLT2758UnFrQLieoKqWFnafb	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1405	857	500	12463	17871	jxnbffm5rEYTByYiLBBnyk7TCae8Rt1KeN1tXNww2PaXAVejoQQ	12928	18180	18180	1619211600000	orphaned
26163	3NKQu282r7zBLssGB2cJ4XHD9WcJuhGDZXXzmfs3naJ9v5bsJg9e	26161	3NLJbZQhZ6nvQBFh9XbUw7nZtsgxhJPYadXBmxtBYpcPsPEuFbAu	1581	778	500	12463	17880	jxfmGh1G17GQJZGzotBdVZgg3gjPwByXqy9Pv2ReinZJMHvPCuf	12932	18185	18185	1619212500000	orphaned
26171	3NK3g3HT4yAAPWC3wRtM1sWvQXuKncFX3PwDgF8psv4FkMduvHy1	26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	1636	140	500	12463	17888	jxHc1YZ3p7uVzqP4TWB3yz24GcpZDodsMATKyochFgWLdAQAkVh	12939	18194	18194	1619214120000	canonical
26176	3NKjTXCmSyw8s24QyXEst5zsf9HvoxT8ahej9SyQAZ8SgfvAYRZN	26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	1549	1236	501	12463	17892	jxWsZnHNrcuavmqDHaLTuzDKjPpUJGyMv6P3RPqLQXnmfRcEaqo	12941	18198	18198	1619214840000	canonical
26178	3NKY35cgWZ3y5v8fHx7jwWAxNt63iRc7yFYxRgLCzHBRSenE8HFg	26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	1631	794	501	12463	17894	jw8Rt6ZH9VmvmfrBanwiKLXpfv9Z8RPeFzH5SY34dfZ7s1MNQDp	12941	18198	18198	1619214840000	orphaned
26181	3NKktHBoZHKpksDGC5mo2YdLDoH8qampFGvh4RuWnGiGH3cTtLXV	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	1527	1293	501	12463	17897	jxP5cnWMVnQ3ymEUeSxGffdvKRvkFD7J2ZnHJmCjJeK9sEs55pL	12944	18201	18201	1619215380000	orphaned
26187	3NKHgkSkKPvDpawRFho56Kf6mbRE2jhCDfW4eCC8CsJvXRyaXnFm	26183	3NKxzLeU8o2U1hNKzDPEM8rc4sDBxKpejVy7QrR1JXmxRXaanivG	1654	974	501	12463	17901	jx7nmHitmEUeAfU5aoDvs3L8LFHvyHhsvPwF9pDCYSceCGUby9d	12945	18202	18202	1619215560000	orphaned
26194	3NKbijS8wurSymQdNT6pg1JArJ35k2footDGJSSVe2VPmwZQbFg2	26192	3NK4gJFtZp6vWUcsjBAfdtZaAVpt2k3X9vrCJWEBPVerPzggiK4S	1419	814	501	12463	17908	jxhvRvE6nBF2LkcHQzCBwsDcq7DoESg8eshWSYBuHarGd3o5Ps2	12949	18209	18209	1619216820000	orphaned
26198	3NLSons743q1uBRXz4tnRfEgZzHRPC1oY6924JTBiG3sLkFURHef	26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	1654	1340	501	12463	17912	jwUfEWfv7uddEiY2sc2QPDXfuWkZYHuKSq7ZvGVrn6DMDsStz93	12950	18210	18210	1619217000000	orphaned
26199	3NLiMXFXHfPXucTJJdwVqjCUNHvoi17fHCsHGNu3inZbFzinSCn7	26197	3NKpwbYTB6SADxF92Vpjkiwhd6AVKgvDCR6vdrVpQcJ32XTFZeQd	1646	1354	501	12463	17913	jxiRBeQ87kD1KFhEMzdWkHNTrCH5kgCi89ia5QkLpchAx9AzXy9	12951	18211	18211	1619217180000	canonical
26207	3NLycKUoPrjNeEy3qBZvwie3frEWeY81ASWr3Cb6tkcT8TNewB2d	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	152	1084	502	12463	17921	jxwCcYbaP2RBd5xD9BwKQHXTziiQVuFrW3oDamay4KZH2DLEf8i	12957	18220	18220	1619218800000	orphaned
28984	3NLHnzvksiVS3f75B2SBSCcgGcJ1RwhEynepwE8Yy7ffzyAGYUkG	28905	3NLcYQ6DccXAwrFjEmtv6k5qnGHW9KciJUFvVFvE5uGMdvXDEnsG	1471	1140	565	12463	18974	jwz16VHzaeVocvZzSHKqxenyT9zgsK2E8d81zNdWvjoodZv4YbJ	14243	20128	20128	1619562240000	orphaned
26225	3NKGdU2FtivFq9nC3MPU6QwEonsH4WrsL5sngvKK7TEA6tbLmewu	26190	3NKeHWCFwiVuURuZAmWzfCJwzxx1j33P3fLCgpknmK2n6qDKKSVU	1617	1288	498	12463	17937	jxeJCcVyfJkFGSSsAsG8JqUKh3ZrxUoKnqV4yosakCp9qWzH7zR	12852	18233	18233	1619221140000	orphaned
26143	3NKMKYpGxJWMYiiPtYXmAFN9M8rqxozK9HP6i2xKeYYZSmu6cdCL	26141	3NKCiFT5gr5Ux6MNcu9dQ7oGVLXktipbi6gv8JULauHF4YbBpMBZ	369	1186	500	12463	17860	jxpoXiASKQQCZpQQXSwNa7wZbb1ykanMGppvvdgX7U29kWDMgai	12923	18173	18173	1619210340000	orphaned
26150	3NKtPt1Xz7LhPdJWqdDPB25Fo2qk5QEm5Qz6uKG4ye2fQuB8ZHEC	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	1671	1119	500	12463	17867	jwPoxXCAXTmQeFMZ4FjGGcAjDrzLVs11JGuhhJHxdLEZ7BBmozE	12928	18180	18180	1619211600000	orphaned
26157	3NKWn84oihS6TKheq6QDrN2NXhyDQhwxccsmQj7cADQWzZWYzb3F	26151	3NK9NGxR1rGFBkKfZSCQTofyqe7dpFvz7j7aqxJj8ZA7YTnZyxWw	1500	1297	500	12463	17874	jxK2DWFcbdrnBtonF5nE48wffHzv8ue3iyhFy4BRY1y16TSJtbc	12929	18181	18181	1619211780000	orphaned
26159	3NK84rsL4kxxZF82AtgFZoyr5zMrLmM5RZaAJweqQA5HRVFYEWNo	26156	3NLfL4UxMYFKVd2VSigXRMLfNgwea8N2Mi2KBGG3orG87RYpd6T2	1407	1395	500	12463	17876	jxZjv9WYrXbNyMELNXes8xvTE9Mr6ctK3fF3dA4X2RSGGUP5yUZ	12930	18183	18183	1619212140000	orphaned
26161	3NLJbZQhZ6nvQBFh9XbUw7nZtsgxhJPYadXBmxtBYpcPsPEuFbAu	26160	3NKByhK8gdbzvqn11uABCMoCASFVSi1NfQQqvsno9nitoLxNUVCa	43	1184	500	12463	17878	jw9xx83FqML6GSo9M24qk3cYRg2ane6dQVbr5DpP54tqbhsjJCu	12931	18184	18184	1619212320000	canonical
26164	3NKBHHZUXShECd4daGWYJ2QXjrJ6NCsEh4Euuo6MrrZMKK4BvXiP	26162	3NK9Z7dCx4ZjU8AUGAtRJhhFoVagZwYDuY2xz8PMtAAFwty1eLbH	152	1330	500	12463	17881	jxdRjHR65VEqkQeD6fVxQijt2GF7PJjxk12RmutmnJEzDpsuQ1Q	12933	18187	18187	1619212860000	canonical
26166	3NK7YJ8rzSDvd1wKxDA6sYfPbyZzA5BNLpEwGoHz8gPLgQXdtqnN	26164	3NKBHHZUXShECd4daGWYJ2QXjrJ6NCsEh4Euuo6MrrZMKK4BvXiP	1609	967	500	12463	17883	jwE72rXmK8vERV4JBix4h9nH8WLpVsAjZQ6ioANnKibwnSpqPHP	12934	18188	18188	1619213040000	orphaned
26167	3NKRo725MRw9yLnBTfmPe2tqfanCXum3ZgStCAY8U3tTJWkiWTzE	26165	3NKDwogyidLh5A1818jfReU5VB65Feo3UQaamP3h3inmyHKdaktb	1406	1393	500	12463	17884	jwFPDDxasXc65YsENN5nvSYJeCmMQLDcyQTYfSwCRtCrsUVTCGt	12935	18190	18190	1619213400000	canonical
26169	3NKHyveujSK6oBtnh8VybKadphaiDtSguWCjFSwzWjYB9KLmXgWc	26168	3NLBhhFWBSWYdvNjZZSYb6AjBieqcHTuLFyHveg1bhDnSCboPsw1	1631	793	500	12463	17886	jxqoDSCTcYQhmfeFsw2BE7snANxpSgH4mJnqEDezgo95Z124AKD	12937	18192	18192	1619213760000	canonical
26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	26169	3NKHyveujSK6oBtnh8VybKadphaiDtSguWCjFSwzWjYB9KLmXgWc	1637	816	500	12463	17887	jxcDaVRLFMuwMmgxn5v5W6uCvwDohL7FT1CnTW6rrLh8NWKDm2Z	12938	18193	18193	1619213940000	canonical
26172	3NKEicG6CDCvjhzZ5v3juRYnCXSH9aLiSEDR91rJMiMm29E9F9Q4	26170	3NKDxDjzp6di2o5MtkZcoeSKLarwWkwigRBRyN954Hqs8YcXW7mT	1642	1241	500	12463	17889	jx1sPUa8wEH1T2ChjM7ukvzqck5M6JNUJEMmwkKS81SB1FonV54	12939	18195	18195	1619214300000	orphaned
26174	3NLPdqvFNUi7yzsykn7WT76N4E4Z8gPQPrWqYeDZtR6TfF7CEhUP	26171	3NK3g3HT4yAAPWC3wRtM1sWvQXuKncFX3PwDgF8psv4FkMduvHy1	1490	1148	501	12463	17891	jxKG7TTNCqFRJR499QqA5mtLhV8Udm3rfdZgvZC65Jrkjorg65v	12940	18196	18196	1619214480000	orphaned
26177	3NLgDXdRVkB7uZS6Whs6sxE2TizQAkv92EjJroq18P7vLCgYfKRh	26175	3NKX48GGvsh1Q9z1HYBR7CcNmWhnmrRN2FmLFGcqY5WWHuyZzdow	1406	1393	501	12463	17893	jxMq6HSfcktFAAVPHkmo1Q7zXz7TAPHLLAaWhjcnMDtkuxPLmUN	12941	18198	18198	1619214840000	orphaned
26179	3NK49WZWgMTURaEtb1s1iLJCmRsVASRdq2VXtm9yktadSobXYqBE	26176	3NKjTXCmSyw8s24QyXEst5zsf9HvoxT8ahej9SyQAZ8SgfvAYRZN	1403	824	501	12463	17895	jwcjckotbyJYvf946Kek73EhVqyQgcWff9V3gF5DanaV6nxj3Ga	12942	18199	18199	1619215020000	canonical
26183	3NKxzLeU8o2U1hNKzDPEM8rc4sDBxKpejVy7QrR1JXmxRXaanivG	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	596	1060	501	12463	17898	jxFeAewSDCPJRsftfxL5omqm3opf2BhwTZMXP7g1rBrtJCXFMcx	12944	18201	18201	1619215380000	canonical
26182	3NKRnyXfYFgh1NSiL1FEt2qym7FmUcdJBedK7Du36z6dc3B1jMVC	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	1527	1293	501	12463	17897	jweqXgbzf2mPzNWioDRt9apd52QACjMNRxwSdjGd4Uz63e8pLrp	12944	18201	18201	1619215380000	orphaned
26186	3NLBQCjJLYY1CdPZ1BxtQ5xL4KCvwkRCoX77KVbMTTmGrj69UEbf	26183	3NKxzLeU8o2U1hNKzDPEM8rc4sDBxKpejVy7QrR1JXmxRXaanivG	1542	1058	501	12463	17900	jxUcPGd6a4usgXC4ch7ZdNpZsJsTpPMBCdhkpmPkhf3k6Lrk35L	12945	18202	18202	1619215560000	canonical
26188	3NLieNTaJSzcpFzJutKhZnmtAE2Le56iVXgnN7T2pWsQqQThsgtX	26186	3NLBQCjJLYY1CdPZ1BxtQ5xL4KCvwkRCoX77KVbMTTmGrj69UEbf	1476	1371	501	12463	17902	jy2Hr3Jk9GgSgXxGcjRpDUxhU2WbC4WeFFqGdvgkHYgsvvkj55x	12946	18203	18203	1619215740000	canonical
26191	3NLrgGx5kfh5UT4UE25PjQBMnBfZR3gNfrW4tWQh3sXHAHZGxr3E	26188	3NLieNTaJSzcpFzJutKhZnmtAE2Le56iVXgnN7T2pWsQqQThsgtX	1579	1263	501	12463	17905	jxnhzjKWd8W8oE7iEdwfgJfeAKsuTxuhpMUeWhbxgsQ1hxrxgYE	12947	18206	18206	1619216280000	canonical
26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	26192	3NK4gJFtZp6vWUcsjBAfdtZaAVpt2k3X9vrCJWEBPVerPzggiK4S	1652	1069	501	12463	17909	jxQKuBzGqzjz2d5sgMzZYVYwpKvJuAZy7jpopGdekPdW6L66HX1	12949	18209	18209	1619216820000	canonical
26196	3NKxWMNhWaYJsVcFDagnGDhxFgidpXTv1mt7HZXdshuZxs5YNmM1	26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	1467	1376	501	12463	17910	jwFsiM1249M71t69QMQXV3JcyBMLoFiXjcsyfQgzw8dN6fBNS3L	12950	18210	18210	1619217000000	orphaned
26204	3NLktc5aRRbyNUXemdV7UYP23sHRsnBqcgFgomHmueAN1krBd6kZ	26201	3NKX9QoX1zBnNFtfBbPJxirj1i2JQSr7ouesFuwfUesqjHPpnEAT	1406	1393	501	12463	17918	jwhrFzCQ48P2bTSTq551TnfPv5zSw7qNAtTTMdjVW97dscyBdRd	12954	18214	18214	1619217720000	orphaned
26205	3NKLNhWP8bQ74FDo46w3w5cEmVMPxmJQPRmesLCNUzjtwx3t6UXH	26203	3NLLdZruqPFNCKv5LBc3Pz4GiWAAFPXPt13w3eBDaxBW6Jzym21u	1407	1395	501	12463	17919	jwbaq1sC3FSvZdQgK4DZEfddV3qCFWTod72V8WTLzYLnxKgCDzX	12955	18218	18218	1619218440000	canonical
26212	3NLeiUaeFmgB9dDttxS1r9ZsF5ik5jc5Bfggmozh1T19228YXCbW	26211	3NKkG9QaKAWFyWwB2pTyxqYsPkbnezAWgNnfj8TNoMW1oKsXY4MB	1406	1393	502	12463	17924	jxtrRXXaVkBbPDcdz8d18ZKZWNThViEV63ZLm4BfQESQsgUh4rC	12959	18222	18222	1619219160000	canonical
26215	3NLUysbjE2mhTte5DRLJRbeyia8ACYSQgCVVq9MPFw1ympvq9gaE	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1407	1395	502	12463	17927	jxjhd5EB7imccZJpXjuxFtHs4vbgE8LUQ3UVq1mC6Eu2VaMJFCE	12961	18224	18224	1619219520000	canonical
26217	3NKQxz35BGyyK4o6c2jFWJzAwUaf8t1rbReUfDPRVu2QdqX7MzeZ	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1579	291	502	12463	17929	jwYWs7J3DKkgZYeNS9yUezBGG11iiEGo7BQ3X1wD17CQTJSRAwx	12961	18224	18224	1619219520000	orphaned
26220	3NLUyBs3BQmBy2xorZUidSR8VxGhnVQrkmnjM4dmhBqH6ioFJqbe	26218	3NK6v2RKmZVxZ9ozFPhMzxyGmz6cRUE3ocSSxMfvmUvfFKC5rZjn	1642	1367	502	12463	17932	jx9kFWR8dhmecdML3HqYqLoXxZdRyHucz75Qt9uJ4seGu3wg3iE	12963	18227	18227	1619220060000	orphaned
26222	3NLrRAcYL463vCgj77Wh3DfopWK8nqKyP283v9PN18SuBWtQYuXX	26219	3NKFEfoQ3mL3BsTmQygoc5iqkWxZvM7CPpWViVfh8Cbev6gFMRkb	1407	1395	502	12463	17934	jxB6ZWRiyAUpMV41adAa66xteBj9H1bRf3WA6bp1Gvkne78B4WG	12964	18228	18228	1619220240000	canonical
28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	28877	3NKM3HNe7f73pgdNAqp1AWhvZ6VdM6PMYBnTkYFG34wZBm8D6tAY	1407	1395	565	12463	18974	jxQr1wVee9Cr8Z8n6jmzJqDjjLG4bGLHE562ygNPK4fgBkxDqAv	14245	20066	20066	1619551080000	canonical
26239	3NKTVDPYHLTdMqxmCGGXqeLHw6PJ1ga6LN2EpUaMqm9Aq32LEQdD	25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	633	1384	496	12463	17951	jwWb5iGdAnvZzpXxkMJkuGLMF92Nr6h5P5wwuXaCAUDQFje6TuB	12847	18245	18245	1619223339165	orphaned
26200	3NL68bjiLDPX2kMqvKs6LAWNsbTNecBmpXR2vcJqiHRvGgceiJde	26199	3NLiMXFXHfPXucTJJdwVqjCUNHvoi17fHCsHGNu3inZbFzinSCn7	1406	1393	501	12463	17914	jwZBXVp2mboA77NH1zLXbUt5zXkaUDbgmrmYajzbn5gRMkUD9Nr	12952	18212	18212	1619217360000	canonical
26201	3NKX9QoX1zBnNFtfBbPJxirj1i2JQSr7ouesFuwfUesqjHPpnEAT	26200	3NL68bjiLDPX2kMqvKs6LAWNsbTNecBmpXR2vcJqiHRvGgceiJde	1402	868	501	12463	17915	jx93nqUd4i5jrZ28vsQtCXg4kcTh9UxJhHR6kPAELu6t6UWyfxJ	12953	18213	18213	1619217540000	canonical
26202	3NL6CxfTAnfU6gCuxKYpSUptvGfUfrxs8Zr34yBt3D2UcD9cUaZT	26200	3NL68bjiLDPX2kMqvKs6LAWNsbTNecBmpXR2vcJqiHRvGgceiJde	149	1037	501	12463	17916	jwLEVSRZJamBDNUEYW2sVq7W9XnhFU9R6wtRNs6kHQdyJJrrs5V	12953	18213	18213	1619217540000	orphaned
26203	3NLLdZruqPFNCKv5LBc3Pz4GiWAAFPXPt13w3eBDaxBW6Jzym21u	26201	3NKX9QoX1zBnNFtfBbPJxirj1i2JQSr7ouesFuwfUesqjHPpnEAT	1407	1395	501	12463	17917	jy2Yv85y6HTErGNuUfCSD3qLgf6zDgDsETBmgkk7PXHrzFg3SDR	12954	18214	18214	1619217720000	canonical
26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	26205	3NKLNhWP8bQ74FDo46w3w5cEmVMPxmJQPRmesLCNUzjtwx3t6UXH	1549	1362	501	12463	17920	jwwbPts4kPoj4xaZFDFicEo5yoe4JkhKzXfskfDD6KbtbsShdue	12956	18219	18219	1619218620000	canonical
26208	3NLSySAKd54jtJ5N5fzP8wXC12LsgEp8vfB1sNCvwbQiyxFCuTdn	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	1610	1068	502	12463	17922	jwYzQqU2Ht8QyCi9uj5wzLsnqPtAzuEViJHXFZhiAfzoiTHWYdB	12957	18220	18220	1619218800000	orphaned
26211	3NKkG9QaKAWFyWwB2pTyxqYsPkbnezAWgNnfj8TNoMW1oKsXY4MB	26210	3NKHKjfDEuK1ZxV65zbz1bDxxPJXxoPfLfsaZCKaqHkvM3JYoJGc	1407	1395	502	12463	17923	jwjZNZiVgACPSDb13D9swajwTaBdcEMTp4GhzhyBGqUaCscw7Pg	12958	18221	18221	1619218980000	canonical
26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	26212	3NLeiUaeFmgB9dDttxS1r9ZsF5ik5jc5Bfggmozh1T19228YXCbW	1560	925	502	12463	17925	jwNN42WW541NuRroWz8PzaxV4VeH4XfM7MQ8ozkpf6CUoa6pHs9	12960	18223	18223	1619219340000	canonical
26216	3NLBg5HexSbzVhZGyiv8m6H3fuaFTHoD9wzcF2544hBZWJcLtaUU	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1553	776	502	12463	17928	jxhDpdGk1WC5Q3RBG6hDjZfh6qxTx3B82W1rtfqQxd7zq8hYQm4	12961	18224	18224	1619219520000	orphaned
26218	3NK6v2RKmZVxZ9ozFPhMzxyGmz6cRUE3ocSSxMfvmUvfFKC5rZjn	26215	3NLUysbjE2mhTte5DRLJRbeyia8ACYSQgCVVq9MPFw1ympvq9gaE	1403	31	502	12463	17930	jws2bVzGKssECBUVKNuv2mdjoKvZvMbM7ykCChvm9Dq2EzfKN6N	12962	18226	18226	1619219880000	canonical
26230	3NLHuHVvirfyQq4UFatgh2iZnEi6VsYBM9SFDP9NRjNABqrTpPqU	26229	3NL4e2he5M6HV4ifvc4yJSN6BuyATs6Y3cb6DjCiU5YgzVm67txb	1406	1393	502	12463	17942	jwZhFy3yzr362KrXXEqVzL4ebWQQYitFjhm1zRG5h5KvWbDDdzX	12969	18241	18241	1619222580000	canonical
26231	3NL1hEnWhqPW1wGZEfPLk979gMaTkBoCdfHcDnwVgp9b4VttBqmb	26229	3NL4e2he5M6HV4ifvc4yJSN6BuyATs6Y3cb6DjCiU5YgzVm67txb	1405	851	502	12463	17943	jxtLHga338opYNZ5tkVhqjEsQ1Z3nnyf5NkS5Bw6JJ16Fc1rzTX	12969	18241	18241	1619222580000	orphaned
26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	26232	3NKeBzemoSC7v6aNjZocZYqH8Q8WAziTdT1B1gpg9Hh2f2XoTtm9	1406	1393	502	12463	17945	jwjPpufP1UNfwoNSvbLnDGMUCZyr25gwV5rExTRJb6DTz2hsYgK	12971	18244	18244	1619223120000	canonical
26246	3NLWneb3Ei4k72s8U7vSFb3aadWzGGFPcafhGvv5ow4kFuyBnA4N	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1460	673	503	12463	17956	jxkjk1aJdMVchWDo54SUvEimkK1NMyPnbQgxxJgup48RUPsj75S	12975	18251	18251	1619224380000	orphaned
26249	3NKNTmX5PnxBwHgzKLJ1xLjbUFcXAYCxwjYTvSi9q2UimzHerHhf	26248	3NKaPVYmFNX8PJVe9AWEAV2EjW9Z5EnEg6Ydu5HQY14ww98mXi6M	1483	910	503	12463	17960	jxhrJZzZe5vZLWKcHT4FWZKruqeXiyesqCXm1zyxwSEK8scWUHk	12977	18253	18253	1619224740000	canonical
26253	3NLXHwgFcuBger3Z8s64AEwXnPajg9cUhZav3UBu8tSfe9V7fWwu	26252	3NKR3LaCSrpcW14xCUhV6MerqNWbAHAhCC6GLZ1byhUDsdAfppkB	64	64	503	12463	17964	jwpgvQp4qzUEx2ywf5wgTvAvzit9pqaPFGKas3kq9B11osg3Xg7	12981	18260	18260	1619226000000	canonical
26256	3NKZZiwHGCEgPQZjJW9PGZfuteAkKgMz4MpERFNz87hQRkfvrGAu	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1402	854	503	12463	17967	jwkPzNQWzPFbB9AunZEQJcPn4C2sR63U8cfEzeK8VYKinFiWFFN	12983	18262	18262	1619226360000	canonical
26266	3NKpGgLCSP2ToUU121k4tRZj9WvEPk592G26TqcAbLU194UYveyX	26265	3NKfk4xo8jgDEmA8WCFJ3o6gEjPhwKLkbA4BDaaKQk8Fzvodw5bP	632	1382	503	12463	17977	jxbbV5DGW9nQ5sz9JWHUeiWDkf92EzBRRVKUxQorf2mra7uMCt9	12989	18271	18271	1619227980000	canonical
26268	3NLuXNMkwfkrBEhVpsTNJ661QScNJwHmjrmYwrnFAPnJzwyxsoik	26266	3NKpGgLCSP2ToUU121k4tRZj9WvEPk592G26TqcAbLU194UYveyX	1559	1353	503	12463	17979	jxkwogr5Fuq6cmegUi98p4UKaAvErM4yqar8NoUqT4xaVGkT5Rj	12990	18272	18272	1619228160000	canonical
26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	26272	3NLVRTtyx6XQPf6kM9LNyHiYqxvHn7kUkU55cPL79vXKZjwANR2u	1406	1393	504	12463	17984	jwgc5zcyE9ZTXqCLtGinHczGsPQbHjZpcsRviG1vKab7N554eWf	12994	18276	18276	1619228880000	canonical
26278	3NLWezkBBKhFophGbiQ6Wq7sT8r8iYBn2Zk7fNNJBPchChTt5KHi	26277	3NLbUCdj2wjH9en2z8s9eJz7Q1kbHkDg3ksAs13x3GgKDmeTGm4o	1642	1367	504	12463	17989	jwCqSSHUB3q8n9KnDbVAr6RY35Xtr8x4xfDUFTwU9geUBdCDscv	12997	18280	18280	1619229600000	canonical
26281	3NLHFfRF3jbVZiGdtGsQdtn76XZa77egmg7SMM8LCsYkf6WchK5X	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	1609	1333	504	12463	17992	jxx1k2ikPMQhtbqva5zWXrHZNytyS8ogpvSTN7F5bgLpqguqxJJ	12999	18284	18284	1619230320000	orphaned
26291	3NKQe3Rw5NovE8ixkLeLQAdNURGwz31eqnC49gQo6QQnyhT8XGJ5	26290	3NLu7Cv1t3zCtg1XWVSEmnfJgdqZouMensYCkNKKgKZCmpytEU46	1622	1356	504	12463	18002	jwYLBhW3aeJhWX6QKsxysxcNRXWfUdzyRucJq3vnxm4TuKJiECJ	13005	18292	18292	1619231760000	orphaned
26295	3NKPJstpxbB42PN5tC7Ynf9UL5LACoYEVhgLJVdBDdTU35wLybEh	26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	563	1359	504	12463	18006	jx5hFy4nGrjsUJjf4HvJmoRdf1vhSpJZ1TTogfT8Ex8W6Q2x2zq	13007	18297	18297	1619232660000	canonical
26299	3NK5khr1zMBcgnZJtuCwZwYYxpyt5smx71qdaDRmjy5HLVnYw1EW	26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	1503	1151	504	12463	18010	jxgTF39Y3XeKTRuyFZukTsXWcZNjtD5iagH2VZVFiV3RrizyS9r	13009	18300	18300	1619233200000	orphaned
26302	3NLtAmBBFWAnYUgpJ8aipFKYeGbY4xxCYHKiKypvUVnWmd75k5QP	26300	3NLuTohSyedkR8H7BqpUTv9cq1HBAGmVkMiTizMghxXpQKYib9dL	1500	1051	504	12463	18013	jxVPwTnUV7pKQgtf72wgA4U1Bz3PtyuxSS288WhTfnktn5NSiar	13010	18303	18303	1619233740000	canonical
26305	3NKThyERguMnBbrbY25kkCtok2AM4SCoGTjvNoztxwGmw3kgR5v2	26304	3NKR9LELZvAq3L5QxLVujwZbFLeKb8hAy5LFAMG9wf71m3YMxgG5	1607	242	504	12463	18016	jwhniUn3dHdcGPXiWYmyJ992EgEVQrjkBeFVC63oN5Uj1NgaN7R	13013	18307	18307	1619234460000	orphaned
26307	3NLHSgmMiLfNij8pPD3WtL2yNGr9DiNQgqhHGY2r4TL2CAQ7HrsS	26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	1407	1395	504	12463	18017	jwQjLpEwYxAKco3XR1o4J5icfRQj3DYEf7D2LJE5pPqaGvNtQM4	13014	18308	18308	1619234640000	orphaned
28989	3NKbnEW3L4eVYqtuFAvYU4ohsyCq6P9kYG2ZB2qTK9R6L1kRkH6B	28883	3NKWErFrp7iENdFKZsrhuvLFfkmJuLinkUCEaNqcs5QgzUQfZdeZ	1637	816	565	12463	18974	jwCyGkB1Fr7SAXCSM1uy31vLL3AiWpu9B5Tsd4pQj3zztJ4APYq	14248	20128	20128	1619562240000	orphaned
26210	3NKHKjfDEuK1ZxV65zbz1bDxxPJXxoPfLfsaZCKaqHkvM3JYoJGc	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	1610	1068	502	12463	17922	jwYzQqU2Ht8QyCi9uj5wzLsnqPtAzuEViJHXFZhiAfzoiTHWYdB	12957	18220	18220	1619218800000	canonical
26214	3NLZT4zX9XTsAqzxZsjMtzA4THtHpjj8LEg2kkqCUfV6JvsLLMLU	26213	3NKs3e345XPXQmQSM3vfbcVaVyUjyLEqwnEzCz1WhjGqftj3sSaY	1483	366	502	12463	17926	jwGJF2KsaNYEhSyTnzffzet3RhSmNMi3v6exmbgdFksDiWeQ6sV	12961	18224	18224	1619219520000	orphaned
26219	3NKFEfoQ3mL3BsTmQygoc5iqkWxZvM7CPpWViVfh8Cbev6gFMRkb	26218	3NK6v2RKmZVxZ9ozFPhMzxyGmz6cRUE3ocSSxMfvmUvfFKC5rZjn	1489	1134	502	12463	17931	jwLFYPxPVrxBUYkMJbXG36i7nosEhtwqspcuvuTiJQHnwyoYgJR	12963	18227	18227	1619220060000	canonical
26221	3NKgqUMxbvMCBy8mEGnepz1ymBykVc4LEkZ5MSy3DE4Ky1GxBze9	26219	3NKFEfoQ3mL3BsTmQygoc5iqkWxZvM7CPpWViVfh8Cbev6gFMRkb	1406	1393	502	12463	17933	jwoG1rozLzCDPMmTDZax67WQBE8DxmHNgPeojR816p4qFTTUqjn	12964	18228	18228	1619220240000	orphaned
26224	3NKV8S9ByncTHyFyWJBkGHCytuBZTfyunqvLp82LtJaNait2uE1f	26222	3NLrRAcYL463vCgj77Wh3DfopWK8nqKyP283v9PN18SuBWtQYuXX	1406	1393	502	12463	17936	jwKHTUhLp2ChSEVJqtRN5G3AABGcUPEVnmpRxoMn9MtZHVMgqYN	12965	18230	18230	1619220600000	canonical
26223	3NL3LDiZtVKifPpTiFfs9cdRLqyhpduDcuDQrFJ46fVDKVvNGv13	26222	3NLrRAcYL463vCgj77Wh3DfopWK8nqKyP283v9PN18SuBWtQYuXX	1483	1150	502	12463	17935	jx9hUEsPDJpMppRwEyCT7fZnepy7JeQ2RqWPakbXWbrmB3BTyec	12965	18230	18230	1619220600000	orphaned
26226	3NLvknuZkc24DX5dGm8kzgMgqkYdUFgEJzMkU4XDHRFV1jq3TgHv	26224	3NKV8S9ByncTHyFyWJBkGHCytuBZTfyunqvLp82LtJaNait2uE1f	1599	1287	502	12463	17938	jxgsHfSutBpFK1pq2Vva3Txy6zJ51tdGancVCaoHSYuVxLaSyM3	12966	18237	18237	1619221860000	canonical
26227	3NKLcYARND64LBL1oXAqGHwgziqKvmw8KFWPLpoQQjRxqzVreWVV	26224	3NKV8S9ByncTHyFyWJBkGHCytuBZTfyunqvLp82LtJaNait2uE1f	633	1138	502	12463	17939	jwoAE1m97QiA3bwT9PSSMUPRyZV46LhnPyuHPL3Ce8ySNRLPv2N	12966	18237	18237	1619221860000	orphaned
26229	3NL4e2he5M6HV4ifvc4yJSN6BuyATs6Y3cb6DjCiU5YgzVm67txb	26228	3NLv5EA4AqQMLgiNm63zHoX1twqzQNE2CGgaYkpK9pqS77ML1Cuv	1406	1393	502	12463	17941	jwKV1SUYMpyfGsHgJuaB3keRF4pFrYF46NcS8L7eZxMqHCgDHVH	12968	18239	18239	1619222220000	canonical
26234	3NLGrhtK9rCQ31yPQdzAP7htGbevhFBgmkjijNxBXXwudDJnNvcf	26232	3NKeBzemoSC7v6aNjZocZYqH8Q8WAziTdT1B1gpg9Hh2f2XoTtm9	1594	1326	502	12463	17946	jxSpBKC3urkgJezKGmwnRnSsxx1jEbMYDdrdWw3iWm5cfByTVtf	12971	18244	18244	1619223120000	orphaned
26242	3NK8KZy7xjXe6tJB2Lf87cKpfT4AqNTTRTjvMHdtwx9egmQyM1wW	26236	3NKBxzwmgs7Jm761uhsaakdU5xGSkYN5HkLdd79j484D89yuwkm2	1407	1395	502	12463	17954	jxrEs7SvPEmUpZwkLazq5tE7rDuKU2Ljq7QUACdhDXUpf3ijygE	12973	18246	18246	1619223480000	canonical
26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	26242	3NK8KZy7xjXe6tJB2Lf87cKpfT4AqNTTRTjvMHdtwx9egmQyM1wW	43	1310	502	12463	17955	jx2BYvQyw5uXEHDkxh3qM2a7G11RB1harxVRk1SkQSCpfnCfkUg	12974	18250	18250	1619224200000	canonical
26250	3NKEBnZrJtZweGmKytgV2agXu5Fhu6Pwh8S19spcnRULLCCFZTU9	26249	3NKNTmX5PnxBwHgzKLJ1xLjbUFcXAYCxwjYTvSi9q2UimzHerHhf	43	1184	503	12463	17961	jxarfSoyfJ1Dy8nJi6XnYCb4dCPt1kpi4QVH4AxdHr1sGWo39rM	12978	18254	18254	1619224920000	canonical
26251	3NKSWG86Tx9LQqZDKWoqBt2CjDtg2hFUvuPLfuGDdBbLw1Gms6CR	26250	3NKEBnZrJtZweGmKytgV2agXu5Fhu6Pwh8S19spcnRULLCCFZTU9	1407	1395	503	12463	17962	jwpW168mJCMMgT3RG492kY3gdA4MTqdp52qAiJH6s4E4iAEr9xd	12979	18258	18258	1619225640000	canonical
26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	26253	3NLXHwgFcuBger3Z8s64AEwXnPajg9cUhZav3UBu8tSfe9V7fWwu	1553	776	503	12463	17965	jxBJwGc1MLXug2SyhztZvNryGMZhG7NFB43mYsq2eGiqs7F8djr	12982	18261	18261	1619226180000	canonical
26261	3NKnsabLzdmfCeRcZfdvJWdnGenFPY6dUqQirRzWZEKo5aJFsSAB	26260	3NKsNjAwUEbfB4gkMURfWukvzaz3SdtGNTcdCrkUbgM13DW6Qcye	171	1128	503	12463	17972	jxA3LuFJuzdjZVboJ8U6CrdtWio2E2dhEPtKWcUHhQuuG23iiqm	12985	18265	18265	1619226900000	canonical
26269	3NLW32pzsK7joDSZryxe58rsA1gieqtTyASUX4D6ycScYjeR1Ecf	26268	3NLuXNMkwfkrBEhVpsTNJ661QScNJwHmjrmYwrnFAPnJzwyxsoik	1405	857	503	12463	17980	jxJfjCtHdm8uAciYr1YPi5Bo3HuwikDZxx8XJrhJjvUjLFnH14H	12991	18273	18273	1619228340000	canonical
26271	3NKGSbJ5hx8ZkBykcYxDHY8ckCP6x2vmwkEPJ3avfJVtA2top4h6	26269	3NLW32pzsK7joDSZryxe58rsA1gieqtTyASUX4D6ycScYjeR1Ecf	1405	873	503	12463	17982	jwELcCxSwie97xVY8ysjqkMzPzCbnoS7jdQXzrfZAi5aRRx4LGx	12992	18274	18274	1619228520000	canonical
26274	3NLZkfy4qs5UxZor5TKd8o4nPbdMfdyNrhY3d1nCLAmP5mW61KSd	26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	1407	1395	504	12463	17985	jx9jj8wvuXd9R9K32LwMGK8K255Pnfz8o1ybffG5c1BSw51evzC	12995	18277	18277	1619229060000	canonical
26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	26278	3NLWezkBBKhFophGbiQ6Wq7sT8r8iYBn2Zk7fNNJBPchChTt5KHi	1608	1043	504	12463	17990	jxd2UhKjr3KZBAKhFeVBtmT41Bw6SDBuebxc2zvhhVW44KN6pgQ	12998	18281	18281	1619229780000	canonical
26282	3NKP7kbEk2SaVEBYLf8vPFkrgm51eWfDazZKZppJ1RqHY2M7fRAj	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	684	986	504	12463	17993	jwRgDmng8SWgZ5V2KeFNStXgA4t4RZM3DDsjLKgL47EuPZs7Z6K	12999	18284	18284	1619230320000	orphaned
26286	3NKwvPFMoJHQi7c7JmwoVZp5xNw6eqd3uY2f3rfaeEd2KJnKwxry	26283	3NLxcJo5nnPHt7udi4UmyopC2GytQeFdttHjXGBze3rxvtrVS2ai	1634	1331	504	12463	17997	jx2FfCKgGQgAGicc5zCfKRxQwUDYA8uHLdVqqjs8rRnEB3uxiU7	13000	18285	18285	1619230500000	canonical
26289	3NLCNVzCLBL4Uobw6dsXcFThJnfmyCKbSEFAmv9J2q9KyL3JG3KC	26288	3NKbrA7acUp4WXPLzmEePa5UrPtUwKV5Ei8WpRGYv8nZuunfTpX7	43	1184	504	12463	18000	jxqBjgisAm8GEtbka8mZ9Pie4tdhLzTNjbNWsE5u9Nko7metd1P	13003	18290	18290	1619231400000	canonical
26292	3NKK4Fm78n7Pi49L4ZHwBRGKDQpntwReDUnFcggpfQLbYWXBYy9E	26290	3NLu7Cv1t3zCtg1XWVSEmnfJgdqZouMensYCkNKKgKZCmpytEU46	1522	1076	504	12463	18003	jxhoxVprcfJs9ZuucCyfR2QVCDALuMvDuWnFwLNg7KhGEzBbszc	13005	18292	18292	1619231760000	canonical
26296	3NKheX4TUPa7Y9NaJWRFJjscyVFDkHWXQSCNfoQfjmU92MWe53SQ	26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	1403	824	504	12463	18007	jwmByqwwYN5D9nGyMknZ4i9Qa9RXdtW3S5eKSSsaqnpnAZoejZZ	13007	18297	18297	1619232660000	orphaned
26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	26295	3NKPJstpxbB42PN5tC7Ynf9UL5LACoYEVhgLJVdBDdTU35wLybEh	1406	1393	504	12463	18008	jxUg8tP5tkRg2qrMNSwmThjqJMfLNDNp5iPwhtwXJ8LzaETwWNL	13008	18298	18298	1619232840000	canonical
26300	3NLuTohSyedkR8H7BqpUTv9cq1HBAGmVkMiTizMghxXpQKYib9dL	26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	700	840	504	12463	18011	jwMfxQDgf2zumK5h8CySkhQKNd2gxs28t54fyS5nQz2kjDQiey8	13009	18300	18300	1619233200000	canonical
26303	3NKrKu2kdJjw8VnVqza1rv4dR9BgQvChEMGWq8szN84bgdSyARfR	26302	3NLtAmBBFWAnYUgpJ8aipFKYeGbY4xxCYHKiKypvUVnWmd75k5QP	44	959	504	12463	18014	jwAXcQivCr15kS6LiqWwQLM7x4EQYoXX45P49DmE1bNoMBxsT5z	13011	18305	18305	1619234100000	canonical
26308	3NKq81VnVfdC8z5G724DkU4zmCm4ALa6HSuM6Kf7AugTdHA6R6UJ	26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	1637	816	504	12463	18018	jxAvLcw7GJAzxfpKYiaKSo3ZKVeDAjxeSF5SsvYCCSAA2D145Ee	13014	18308	18308	1619234640000	orphaned
29271	3NL4bKJhuS2NJ1pqzsMbxvoM3ykrxypBLozxjxNRUeDRpAfBRKDF	29162	3NLwXVzZfBoSVMrfVXzFcYpS8u9Q2LHwYLkwDFsNKWPdhgpvhjoh	1455	1086	567	12463	18974	jwbZXYSztMyTSjVQFtSUPvwEBc3aeJw2jT8Qn41QY5nXR3LHMTz	14248	20315	20315	1619595900000	orphaned
29544	3NKQgzRCXaQ232copghGcpC9Q8HYH1FxR3sUEhoUfKYLwE5Tw27b	29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	1553	776	581	12463	18974	jxTXQnS98gLN3s4xbeRhNonx5NYPzVuM8w25Pr8CvzPj8EUCY6q	14566	20504	20504	1619629920000	orphaned
26241	3NKeksPrM8ZJLEdGH5rX874WEPtejXUunghFvthe6CF1zgsP3GYA	26052	3NKxujfWbiU9YiBc97f2a43RxAvAAvm8gpP1ZTphVqP8Az7XiFBW	633	1384	498	12463	17953	jwmAuUtFL6yGUitB1hycgjgE6CrkBRNHQtfwuVMzkv28VQ3agzF	12875	18245	18245	1619223417333	orphaned
26232	3NKeBzemoSC7v6aNjZocZYqH8Q8WAziTdT1B1gpg9Hh2f2XoTtm9	26230	3NLHuHVvirfyQq4UFatgh2iZnEi6VsYBM9SFDP9NRjNABqrTpPqU	1647	1302	502	12463	17944	jxsyhSL5rQucW4ejoDk6biJRizjzXZeTHwCE79T4cqAwqsdVkhU	12970	18242	18242	1619222760000	canonical
26236	3NKBxzwmgs7Jm761uhsaakdU5xGSkYN5HkLdd79j484D89yuwkm2	26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	633	1384	502	12463	17948	jxAR3RJBXNGe1Lqp4hMMR1MWa5WtFwX6djmDzfXhDXYDuPzE4SQ	12972	18245	18245	1619223300000	canonical
26237	3NLgKHkAjNc3KMyUk97WRym5PWqXBDW5hYux9yAWjMjZCCnM8Et4	26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	1406	1393	502	12463	17949	jwmVTihFycWwQdndFeC8TMo7w1NFJw1xFoD9aKazffx9wmMx7qE	12972	18245	18245	1619223300000	orphaned
26244	3NLxRT533FKG1JNRZiyrjyzgG6ZrpoWud4ou23axXPFx2VqEisvw	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1460	673	503	12463	17956	jwoqLMSZQ69SYmjYDdb5Tyw8SLUJ9oRmzpkTbGiBxKtJr43fqiQ	12975	18251	18251	1619224380000	canonical
26247	3NKpxAKFVKbzRjgzLzSF35yXPFFDyZWi3qv2NL1u2a1a7XpaamS8	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1647	1176	503	12463	17958	jwvNi5H3uE7D8QuDmZkx6HmVkTj45qANY5xtHX5MPb6F24WrgPU	12975	18251	18251	1619224380000	orphaned
26245	3NL8iKbCJRrAdxbpa6NEWF5dVmxdCcryLfTzqSgs1jrkPMZWXBcP	26243	3NLGB7pt6fWWDLjTYwxAU2XetopN9Hpb8PPmK7soak4oVSsEE7R2	1675	1096	503	12463	17957	jxTqriv6dK39zY3quQjoa95SiSw1fFAAuiMMbPHvXqo7ZpxEoCx	12975	18251	18251	1619224380000	orphaned
26248	3NKaPVYmFNX8PJVe9AWEAV2EjW9Z5EnEg6Ydu5HQY14ww98mXi6M	26244	3NLxRT533FKG1JNRZiyrjyzgG6ZrpoWud4ou23axXPFx2VqEisvw	1542	1058	503	12463	17959	jwJXvFRXf6xZnHCemanUFZaVPMpHpfVZbfYcm4CW2E69oopChS7	12976	18252	18252	1619224560000	canonical
26252	3NKR3LaCSrpcW14xCUhV6MerqNWbAHAhCC6GLZ1byhUDsdAfppkB	26251	3NKSWG86Tx9LQqZDKWoqBt2CjDtg2hFUvuPLfuGDdBbLw1Gms6CR	1643	1299	503	12463	17963	jxQHPVyHSxreSKMBHW1kpNJjzPVrawSoW6JAZ3mvKCLeoUeej4i	12980	18259	18259	1619225820000	canonical
26257	3NKYCoTG1Dk5SbRZkRWzX5bYBevbCiELFYWbg2ygoN437xbVFHMQ	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1647	1176	503	12463	17968	jx4GyUkyDPP7EbqjmybmC8vQtdMGVA4nsTtCw8n3DuZrSZ3ZfRM	12983	18262	18262	1619226360000	orphaned
26260	3NKsNjAwUEbfB4gkMURfWukvzaz3SdtGNTcdCrkUbgM13DW6Qcye	26256	3NKZZiwHGCEgPQZjJW9PGZfuteAkKgMz4MpERFNz87hQRkfvrGAu	1581	777	503	12463	17971	jxNeEckq5deNF5F9kvgKD86HbMjCPLdRGzN4Gywi8U3ETuJpyrw	12984	18263	18263	1619226540000	canonical
26259	3NLKQNUaooqt3zdytAh8D1eLYBdWrVHdgygxiMN8FALUk3akWjTN	26256	3NKZZiwHGCEgPQZjJW9PGZfuteAkKgMz4MpERFNz87hQRkfvrGAu	1637	815	503	12463	17970	jxxeJ2rw7Ve1v6A6YHgX3wQ9SvNjY3sqgdhpjs3qYJcXAhGZEBp	12984	18263	18263	1619226540000	orphaned
26262	3NKgY9w9zHAJwmjm2sr5dFf7PxJCdwFn7KdTqvZo6R9siiFSjb7U	26261	3NKnsabLzdmfCeRcZfdvJWdnGenFPY6dUqQirRzWZEKo5aJFsSAB	1402	874	503	12463	17973	jx51MAvt5M5csSSHvyQpRDYsXHvs9jbw1CK4z6s24MoLQyfCaWm	12986	18267	18267	1619227260000	canonical
26264	3NKdBzK4TRYmpgdExMum3ALw8P25wi4s9uJogScP7UBP5epaCuf8	26262	3NKgY9w9zHAJwmjm2sr5dFf7PxJCdwFn7KdTqvZo6R9siiFSjb7U	1507	914	503	12463	17975	jxhUK21yJ6MGY9CxHdouquFVHqGTQJ1iofasrnEqyfEBHaS6t3p	12987	18268	18268	1619227440000	canonical
26267	3NKTYRz5dcL96RShh2L2TBqAJBtrQjVZ2y6P5RdtJr9k88W3awJb	26266	3NKpGgLCSP2ToUU121k4tRZj9WvEPk592G26TqcAbLU194UYveyX	1406	1393	503	12463	17978	jxPLrrjETzWHPSgeb4W6G9K8js4y6vhertqV3poTLgJefB6SfxA	12990	18272	18272	1619228160000	orphaned
26270	3NLXEMVU8CoEJy9Lj1x9Uo8dMhFwjvw7zKUkoZoomTZGgDpDrSBQ	26268	3NLuXNMkwfkrBEhVpsTNJ661QScNJwHmjrmYwrnFAPnJzwyxsoik	1516	1294	503	12463	17981	jxwUeUtjwZiyDTzehbG34n9QTPrtignTCj2ih4eyEa8x8jM1HEq	12991	18273	18273	1619228340000	orphaned
26272	3NLVRTtyx6XQPf6kM9LNyHiYqxvHn7kUkU55cPL79vXKZjwANR2u	26271	3NKGSbJ5hx8ZkBykcYxDHY8ckCP6x2vmwkEPJ3avfJVtA2top4h6	1403	824	503	12463	17983	jwsnQAr1Z5Wxx5gtkXY3wcsjdJnACowQt4iQ4kAyfyeEn7V78pZ	12993	18275	18275	1619228700000	canonical
26275	3NKWQzczcPGZ8GCMutisMWBEnubfqxdhPvoeo1Au2PpUZm8BRSru	26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	1406	1393	504	12463	17986	jxhAVhcPSXfA3w9cygUS7pbavKcVv2f3Y5basJoWvy3zzWVgwmW	12995	18277	18277	1619229060000	orphaned
26277	3NLbUCdj2wjH9en2z8s9eJz7Q1kbHkDg3ksAs13x3GgKDmeTGm4o	26274	3NLZkfy4qs5UxZor5TKd8o4nPbdMfdyNrhY3d1nCLAmP5mW61KSd	1406	1393	504	12463	17988	jx1jpP5CXK21qYLiCE9M6e3ZwaZpGqzU13JabbvhokxEPLuQXsb	12996	18279	18279	1619229420000	canonical
26290	3NLu7Cv1t3zCtg1XWVSEmnfJgdqZouMensYCkNKKgKZCmpytEU46	26289	3NLCNVzCLBL4Uobw6dsXcFThJnfmyCKbSEFAmv9J2q9KyL3JG3KC	1407	1395	504	12463	18001	jwHAnWcnf3FABkUbcAGjnauLmTeaUYa9ioNFHtMExcZWna7SRDq	13004	18291	18291	1619231580000	canonical
26298	3NKnrKtRB6ihuksQqUWcRi7BzCRyzkq4wxQ7gHKZGcSwwmEiXPMA	26295	3NKPJstpxbB42PN5tC7Ynf9UL5LACoYEVhgLJVdBDdTU35wLybEh	1403	824	504	12463	18009	jwMz5VUBJWhBLY6xdj5gtDTa3KTk7mqZNZ2b5krKw1c1UQKtput	13008	18298	18298	1619232840000	orphaned
26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	26304	3NKR9LELZvAq3L5QxLVujwZbFLeKb8hAy5LFAMG9wf71m3YMxgG5	1607	242	504	12463	18016	jwXMA9yAUxmAAJqjKfH6ArkdCEF3tdMAXi54xnTgFNLnGXyDbVQ	13013	18307	18307	1619234460000	canonical
26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	1529	950	505	12463	18021	jxZPK5AQCqPvwJ1dKZxMwqKijqCQhXwkQ3pZ36CMKRbhSvfoaoT	13015	18309	18309	1619234820000	canonical
26314	3NKvZzbL7eALsswq8QecSK5N5oz577VA6R8PDTEGXiN9JczqG6U3	26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	576	1109	505	12463	18022	jwcvMGB7JcVddYxZeL7cuimgwviBpSxFyiRxzM2TCQh4LaF5zva	13016	18310	18310	1619235000000	orphaned
26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	26323	3NLjidqAeqVAhMn2bZ2uPSinwePDLTtwqUDssURDYHTmdEcNdKMD	1460	612	505	12463	18032	jx22gS3DsEYncQ9zXTndTkQuRSZDUST34Q6Dyg51VVRYeFfccvm	13019	18315	18315	1619235900000	canonical
26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	448	1305	505	12463	18034	jxQ17aegXGspZ4JUAwCDz9PJJuv6WLi127DkoDG5DVxKQNh6HzV	13020	18316	18316	1619236080000	canonical
26331	3NKymasTtKpptE6dMh2sfibYAzLeXZ12DQeWu7hZJS8Cas3hBiPL	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1670	1036	505	12463	18035	jwPztTvLe5mdd93tzz3Gd4wQW97qttnAMEAgCmrXXaaLjF4qfXr	13021	18318	18318	1619236440000	orphaned
26338	3NLTvndsZZB1Y98PW5tuUUXinySAxRmyvbu1JecPshYccCfHS9Qi	26336	3NLv9hhdQdQ4rh7BNHDbXLBQStbZ4ZeuvynqYKMbo4YHib5pEXz7	632	1136	505	12463	18041	jxiBdSkH8f7s2YL5wpm5xqSxZqeNZULw5WDxAa1QxKAjwsfCt9M	13025	18323	18323	1619237340000	orphaned
29412	3NL2UzeHA6QVYfDgjdj7Bouz1GUVdYDDygmn4sHiQnT1gK11F6Ep	29271	3NL4bKJhuS2NJ1pqzsMbxvoM3ykrxypBLozxjxNRUeDRpAfBRKDF	1455	1332	567	12463	18974	jwbZXYSztMyTSjVQFtSUPvwEBc3aeJw2jT8Qn41QY5nXR3LHMTz	14249	20412	20412	1619613360000	orphaned
26263	3NL77Gh5h63JXtRjX8FRfuMcd26hSuxTYvaT7uhjRXLXHwoNNFDi	26261	3NKnsabLzdmfCeRcZfdvJWdnGenFPY6dUqQirRzWZEKo5aJFsSAB	1647	936	503	12463	17974	jwsSrYMocEwtXBGdmnGmaSK3j93aYReqHZtVL5Zah9aPCod3RMe	12986	18267	18267	1619227260000	orphaned
26265	3NKfk4xo8jgDEmA8WCFJ3o6gEjPhwKLkbA4BDaaKQk8Fzvodw5bP	26264	3NKdBzK4TRYmpgdExMum3ALw8P25wi4s9uJogScP7UBP5epaCuf8	1406	1393	503	12463	17976	jww63ij67VZJfV3GJbHU9kkGbuSJZ2GZn21nuBZsbwwymH4PSnx	12988	18270	18270	1619227800000	canonical
26276	3NKzpZbiikH8pCBQJvheEEYFRa3zMEQrTDAWJhEZ63LND7Hfn3sd	26273	3NLE7qGW3D96D77UFbfqEFkrqKYXt9U1t2JyjgHn8ud57Ln2EgEh	1600	1372	504	12463	17987	jw8i1NDcASiXWcnBTHQ9WnfznRR6os2NK5gRgGYWGZbAg9YFmso	12995	18277	18277	1619229060000	orphaned
26283	3NLxcJo5nnPHt7udi4UmyopC2GytQeFdttHjXGBze3rxvtrVS2ai	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	1457	1391	504	12463	17994	jwrs8kThNgknPp3HvmdF5g8bCc58GDkbFdP1ZqGtXJxgrqMb3av	12999	18284	18284	1619230320000	canonical
26285	3NKAxbsdhuGyKgsue62VzxbSxv4DeMsAtoyUE2qm26HtLTsQiyt9	26283	3NLxcJo5nnPHt7udi4UmyopC2GytQeFdttHjXGBze3rxvtrVS2ai	1542	938	504	12463	17996	jxEU9huwCJX9qza6HhXYZnSu5pzMuKF1ZgN9ees3isL9TVE6QxP	13000	18285	18285	1619230500000	orphaned
26287	3NKZXqqvxNKWcRuVGKYxegYsZxqTCDecZhUcr8tBwZXREdymCFqa	26286	3NKwvPFMoJHQi7c7JmwoVZp5xNw6eqd3uY2f3rfaeEd2KJnKwxry	1460	595	504	12463	17998	jwKREoHe87yMnptEtEAd7LBmTw8yqrPo36Az6r55KiyFeKXh3D5	13001	18286	18286	1619230680000	canonical
26288	3NKbrA7acUp4WXPLzmEePa5UrPtUwKV5Ei8WpRGYv8nZuunfTpX7	26287	3NKZXqqvxNKWcRuVGKYxegYsZxqTCDecZhUcr8tBwZXREdymCFqa	149	1157	504	12463	17999	jwC1dB8HSUann1iT93ckS2pTHGfVLXuqbjHic9wrhjsSSjEv8ni	13002	18289	18289	1619231220000	canonical
26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	26292	3NKK4Fm78n7Pi49L4ZHwBRGKDQpntwReDUnFcggpfQLbYWXBYy9E	1406	1393	504	12463	18004	jwNcKPHpq5LpvrzZUnoeASytTde8b1tC8ZC8GbEeBxCNvU3m5FM	13006	18293	18293	1619231940000	canonical
26301	3NK5cuktPuXGMjQDiu1XhqHJ3KCAhpLx8W1yeHBZZwnzWvJo9ias	26297	3NLr44cdh2NqaHako3A96KW5BJD4ohXjnhbWh3iYPSMtqnsst8Fo	1590	1300	504	12463	18012	jwgjPqBB7eAEUdjXnfTRk394H48AMUfEcbUdcm1BuMMc1fyR1sk	13009	18300	18300	1619233200000	orphaned
26304	3NKR9LELZvAq3L5QxLVujwZbFLeKb8hAy5LFAMG9wf71m3YMxgG5	26303	3NKrKu2kdJjw8VnVqza1rv4dR9BgQvChEMGWq8szN84bgdSyARfR	1477	1350	504	12463	18015	jxav1JwUxkkyZi7V9odCiAmGbYWVb4qLJE2xFAVG7u8Lwg9RD6w	13012	18306	18306	1619234280000	canonical
26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	26306	3NLdq9YCUmStr8TwM9e9n8L3gEpotjR3LVQKb84NF7iFTHJndCsb	1555	1347	504	12463	18020	jweJWuZ17chq9SM5fPxZuiZ7kvGznmqeCBbUwubXgWNF5LQT8ia	13014	18308	18308	1619234640000	canonical
26312	3NLxMNM3ydyU8YCive86cicQkLpCAvBoWMdVvChpAfhQfiUAGy9S	26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	1529	950	505	12463	18021	jwxZsj6HdnH1GFqRAohKBPD7tWQBWvXtwUqvR4Dk6jm6uyAw4x1	13015	18309	18309	1619234820000	orphaned
26315	3NKbBDdoEsyb5aLjb8TJ391vQevRN59dwQVcVkHBDRKaue6VMmz5	26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	1483	163	505	12463	18023	jwuqTGiipCRLRcy77SFDSQ2rMCoDzDg8usygNQEXxwTtcy7MqFZ	13016	18310	18310	1619235000000	orphaned
26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1489	1014	505	12463	18027	jy3GxLzF6uPAH6TwCHG9e9PBKASpP55Ypwdcf9S7ifeZJEThBzX	13017	18312	18312	1619235360000	canonical
26317	3NLt1oTqm9ky3HYpYYXdfdSfYDcZdMR5jw23ztPhB9Hq3DAdXj3G	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1460	637	505	12463	18024	jwzFMi55aDyjFBL3pvQQt5svDqN4L59BoBhTaV8bDNYW5aPEwXC	13017	18312	18312	1619235360000	orphaned
26323	3NLjidqAeqVAhMn2bZ2uPSinwePDLTtwqUDssURDYHTmdEcNdKMD	26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	1637	816	505	12463	18030	jwG1YvxVGEMjpLtu6z3fR15DsvZQR2Mt3vJDSbcryipsvfka1e8	13018	18314	18314	1619235720000	canonical
26324	3NKRARWh9rxnXzTczvF74vJzuaVrCYybwS2MFy9enTkH3yspckAq	26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	1652	1189	505	12463	18031	jxBhpXoHpapMEE8M8akzpMLrEN2FbiXa1epL6xGqT6mgNjnoh4L	13018	18314	18314	1619235720000	orphaned
26326	3NLnD69f7vWtcbKGh4nhXMzVja7R4RbqwKitaezyifH46gDDrJxx	26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	1407	1395	505	12463	18033	jwmuk2nb66eA4kF3rPjm7BEygQPspjrfBsp9n7un4W4ccu5PNXf	13020	18316	18316	1619236080000	orphaned
26330	3NLY33eAj48sRBtsmGrVPS86W2B6WjVspodvNN2bMNe2FeTq8xFV	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1619	1149	505	12463	18036	jx3YaHrLEGj6irtR8DhaARWDNi1qrZFNptrQsn2bgwMWXDtNLoK	13021	18318	18318	1619236440000	canonical
26332	3NKuQxhrEwByFYLqUH8XsToErFFpZASjBcVBpwjUxZZBD2Me5TaR	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1619	1149	505	12463	18036	jwH9xB7xyXgwKPykrZLUKfiwgoenLSpG2upe7zhSSqRXaKDq4jn	13021	18318	18318	1619236440000	orphaned
26333	3NLJ7J2XGM4JSJZJeh3yBnjxfPKHuMiW4VtpJ1WqAL7qvvE5aSor	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1513	1379	505	12463	18037	jwNT51YyTDcwW3BWS4Rzyfqba9ER4begmLiioHLbzzRswnCHfv3	13021	18318	18318	1619236440000	orphaned
26334	3NKNjyXJxgj7axRLWQaMXgVpx2R348hTjXH89sFWnJnxcFistkrR	26330	3NLY33eAj48sRBtsmGrVPS86W2B6WjVspodvNN2bMNe2FeTq8xFV	1627	1385	505	12463	18038	jxoDxyPYoog5P1csSMrKVAEv1fREBHvCyHuBfxtQrb9pRqmMWTU	13022	18319	18319	1619236620000	canonical
26335	3NKmy73eM6U2UYbyYpDxzRNbfh1j7ie1tH4akwje2VUg1jmj4g38	26334	3NKNjyXJxgj7axRLWQaMXgVpx2R348hTjXH89sFWnJnxcFistkrR	1406	1393	505	12463	18039	jxiKgxeU7y8tMmUZNjeU1heug3eyyGnJtUBXeLL53LsZu6TvBK8	13023	18320	18320	1619236800000	canonical
26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	26336	3NLv9hhdQdQ4rh7BNHDbXLBQStbZ4ZeuvynqYKMbo4YHib5pEXz7	632	1136	505	12463	18041	jwsU3qwtid7GctKgTBRib7CBYsVegi9jnuBAobLRVvqjjHhW6fo	13025	18323	18323	1619237340000	canonical
26343	3NK7udsrdgH5ggBspVzW1DhowSE3XGFoqW1eCo9YpcA4smvsfAtP	26339	3NKmR7dq8hNbju54LE17qK9WeoX6KNnQedkXzEfSMCu55oTDt4j1	1516	1294	505	12463	18046	jwwFGd45ExfjbTrv1AFqXRgjJEaswTPbddwXuarNj4fQuj3xuyx	13027	18326	18326	1619237880000	orphaned
26346	3NLWaiQdRctKUqaARzQGyEdjZdfUvsQevuXnzDG1P9yCA63T5kq4	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1590	1300	505	12463	18049	jxKFvrMRy5Bf8dTTDM1gbbzCLPtgiKiS5TULurAtrpSdq9evhkm	13028	18327	18327	1619238060000	canonical
26348	3NKjP5yGD8yHEdYjYSyXzzgg4zbc8mxbCTeKG3WGYyw6NErZkzfh	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1590	1300	505	12463	18049	jx6SzLLiC3ML18y49Kjubv4f98YSYJMPUVjaKb1cBvtqBiVmdCr	13028	18327	18327	1619238060000	orphaned
26349	3NKRi9FSE7QyEowCEkFxKPXjKdNwj2HemxDZQQqz5UQCzNZ8DmAe	26346	3NLWaiQdRctKUqaARzQGyEdjZdfUvsQevuXnzDG1P9yCA63T5kq4	42	1361	505	12463	18050	jwUY86nhigwqR93UvqsikQ3CDNbVCDcCgSA384Mkkxqc4kjEGsL	13029	18328	18328	1619238240000	canonical
26362	3NLhzH9ksbiarSWW5GVzdCKtRCgXBJ596JkHXsvRTNrGotWhR53x	26361	3NLE8Dj2Rq1AKay4UmgT97AZRmK9z2Ppg82KHCByD4Ajj65odyKN	1407	1395	505	12463	18062	jwbtfBZTtqp9tBewUJtXTxj3Pdo7V2GAPrNaTMatnqXMEW49bUP	13037	18340	18340	1619240400000	orphaned
28904	3NLikYpMe43DTeWqs6HCMoRAFkGZR7kVb1rQKoTMuKfohMSHSBr2	28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	1623	839	566	12463	18974	jxa2i4qSqfhS7sQFMem734aUqGmDpmkDRwQvk6nor2Qwagyw1fp	14256	20081	20081	1619553780000	canonical
26358	3NK9e6FZuCQeJi3DZVr5HmntowsDRaBANTrREd9qJ1jwTJYQLQot	26147	3NK93C585FsVqWwN6xPqvXdQ64LqvPka6NAfNPi3hBk86Bq2BjWo	1534	1071	500	12463	18058	jwsRa3n9bHMkVdyGeDm2en1zyw8zUVfKW9YYJ9482rzxFmefJJe	12927	18336	18336	1619239680000	orphaned
26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	26313	3NLAwpZ8MjqMpGgDwYDC5CwD8kFeViFydZg6U1HbBLSrJBfu3bGT	576	1109	505	12463	18022	jwXX6AAXGAuQAJ8dan1eMahQrQKaLrbqfur3p46R2MmPg8D3arD	13016	18310	18310	1619235000000	canonical
26318	3NLmdoqu3bzeSJqU2CCrjC7VvBZ21C6A93xaDes7d8LTrUV4nbYN	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1407	1395	505	12463	18025	jwX6iymLUXYoSAcBBAanbzwmVMPPLdUdv4ndKmpvPMeWdZgPHz8	13017	18312	18312	1619235360000	orphaned
26322	3NLFLM7NHb7TcjveRGHteXXbs4SnAhf2UJQ4vtyyd4uFoqc6agvZ	26320	3NLsWbS5RmzdZt8PrLqA2K9hewh24Uv4n315PXsBeYbhRwtE46eK	1407	1395	505	12463	18029	jx7yF8WCRG7ANrP4iE9qkeBppmmrp43YQWfhwscUkvWFmCswQx7	13018	18314	18314	1619235720000	orphaned
26327	3NKHUz8tkHvNQVTigLgFuf2K9g82xSxJyHLLwALVtZew84fCJK4m	26325	3NKHNncarGKSRjVac15UJLR3jkSd5DwbFSvFm9kDJ72hpGrNJCze	448	1305	505	12463	18034	jwc9NnmhSo6nK6HHzkULqEXrC2zt1oXrU2N83wbbt55aQXu6iYN	13020	18316	18316	1619236080000	orphaned
26329	3NKnixH3vEmpgZfiaFJVZDBCWJX6qw78KWSYkdLxjJCfmCxtqUDW	26328	3NKEkeEWgdrBxFRV6JeB7kPHzEworirTWXvhUGqAA67Jhzk968st	1670	1036	505	12463	18035	jxYRWekQyay91intKh4dD8G4S6uKpapw5mUbBPQLHt7hCsAtyUe	13021	18318	18318	1619236440000	orphaned
26336	3NLv9hhdQdQ4rh7BNHDbXLBQStbZ4ZeuvynqYKMbo4YHib5pEXz7	26335	3NKmy73eM6U2UYbyYpDxzRNbfh1j7ie1tH4akwje2VUg1jmj4g38	1403	824	505	12463	18040	jwFajyD4s6Wf8YAh4hNX8PagnZzx792RXU5RKCHqH1G9Jd8PE3o	13024	18322	18322	1619237160000	canonical
26339	3NKmR7dq8hNbju54LE17qK9WeoX6KNnQedkXzEfSMCu55oTDt4j1	26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	1649	1383	505	12463	18042	jwvBL6xCXqKHGRiEAgYpD7obo6YeNKfMqMrHHHHoo5VWtec9RGx	13026	18325	18325	1619237700000	canonical
26340	3NKq5czGPUeGVk11uWFi48zWpUhu6TMJogdb5GrLoqcSsH6KQMpg	26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	1581	778	505	12463	18043	jxALmCvrzdaMZrpAshtUEG7ajx1E3QEwthMS6PzgCpYpt4kMf5X	13026	18325	18325	1619237700000	orphaned
26344	3NL9ma2BzhiQEYxsWnSR27VLd5mPForejo6budyRWLm9RAoHbDCs	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1406	1393	505	12463	18047	jxi6DaobU3vyyjgWBUf4NX25LUSFBURRYJtvyHyCENovLMcFURT	13028	18327	18327	1619238060000	orphaned
26350	3NL9wGsDb9pUJCgrmJpGMnq9DuaakZCDmHaxKyRPjXqdF1Q5SBpQ	26346	3NLWaiQdRctKUqaARzQGyEdjZdfUvsQevuXnzDG1P9yCA63T5kq4	1634	1085	505	12463	18051	jx4sU5t61hMeDES63hcX7jsbU4B4sETV7gmNMEquLygwL4a2qpc	13029	18328	18328	1619238240000	orphaned
26351	3NKH2cZMJWdtJs4NAv1x5Lx4Sorqqocwp51EXVukHkcQUVNagEmc	26349	3NKRi9FSE7QyEowCEkFxKPXjKdNwj2HemxDZQQqz5UQCzNZ8DmAe	1406	1393	505	12463	18052	jxxR9rpDE3BatWinWvLAMS4k17V5boo5gGnxGXWt2dnCJdAUWbg	13030	18331	18331	1619238780000	canonical
26353	3NL1isb5fLgAuyJWSKngwtvFK8LFPDey2AZMzQRDvrGWz32xFc4Q	26351	3NKH2cZMJWdtJs4NAv1x5Lx4Sorqqocwp51EXVukHkcQUVNagEmc	1506	1127	505	12463	18054	jxX88CUG55UZJBzriYzudwFrjGS1jJf2sPr61iaJYAhF1yFanRK	13031	18332	18332	1619238960000	canonical
26356	3NKt7q27LGa9jSApy5K6Yv7ZWvv1FUjPGd2ciybtjxYpEwf1srYg	26355	3NKDDwa3WG66e9oNY1KVfMx6rh38wDjPMEfSU5EtVBhc45SkN35Z	1405	849	505	12463	18056	jxgNqMbpZ4ABREafXZ7UQhBZLyUgT8eTkxk1VvMXityAmz9fLti	13033	18336	18336	1619239680000	canonical
26361	3NLE8Dj2Rq1AKay4UmgT97AZRmK9z2Ppg82KHCByD4Ajj65odyKN	26360	3NKaNCas8t722ymGPafbeTaxoe5prW3cSZYvsv6LGFJFw76eZjx2	1637	815	505	12463	18061	jxh2fkHoib9fMhhD1SnkfXNVjPABdqsFbiVUnKdAkh473yCm3UR	13036	18339	18339	1619240220000	canonical
26366	3NLUteRH1dBDWrhGRvhmEv6GFpKDUbKxrbPYvQUZm4ZvqdhpcCyR	26365	3NLB6vV56iDL4u8xbcHU7X6KpXpeNND49Bwk7YbzdaCzwu4GzfNg	606	929	506	12463	18066	jxGBWNiKPtyZkLKLjNbWYMiM166c7tVrvbu6B9qzU3Nb3NDpiL8	13040	18344	18344	1619241120000	canonical
26372	3NLGPK2ZN6EgTRfgxyD9juHNzXxLyEoti2xGbXjdo1EFZAbLkpQU	26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	1460	426	506	12463	18071	jwxeP7YV9Mm9Yrk42LjMMhicKLN5b28zXucBqU74XC3heQWDKek	13044	18350	18350	1619242200000	orphaned
26374	3NKhpcey4BFHh3VEUXLLXAnFo2SL8MhDCnvi5iACAMRULRWPSBHx	26371	3NLvSrYwWN7prvsdBPV5ESVoecspwoydroTRq25SfQam1vHMi2ZP	1474	1083	506	12463	18073	jxBGzsiQokTUjpG2bacoxzmAuNGbTvE3bn5dPV99sQ1wLMRSQsS	13045	18352	18352	1619242560000	canonical
26377	3NKfppuWLAgt1YYT6zWJvs6N8Cq4bNgDytiBCTAptqAtEEcLwDDZ	26375	3NKNu35v2EiXEUCpSjNNNaBFatuP8yVXvfowudq7Fknag9SFwRyY	532	1057	506	12463	18076	jxJ5HjttUgLsbPcU3nd9nM1Z6kjfRkZz1GqAr4JXqqVfyUCndhg	13047	18355	18355	1619243100000	canonical
26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	26377	3NKfppuWLAgt1YYT6zWJvs6N8Cq4bNgDytiBCTAptqAtEEcLwDDZ	1406	1393	506	12463	18078	jwZx6QgvSw6eWSVeeSt9gDeNRuZ2pjT8X5ywG4oh7TGn8KzcjWK	13048	18356	18356	1619243280000	canonical
26382	3NKYAR69ExToc8bHaJ5gEBWCSXQXfwD5e8e3rx2XZdHRvTYV3oPb	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1406	1393	506	12463	18081	jwBzXCQNTDc7Tu767VtL4XreWE4pndjhM5bPEMx6F8zortxHHVA	13049	18357	18357	1619243460000	orphaned
26389	3NLW9zXpCpDF9s92nV5kPGLMEHFZWMsHP62cDNdmzA1ie8PmJf9U	26388	3NLhG86LTxr1xyPxMLvETcJiSNsB53ufXCXMAhEujVdnuwaCB7Pw	1642	1241	506	12463	18086	jxXdWdFhxuKCqspRqeLqXv6MTT38NzMsn881ztHY42tymcoVMxh	13053	18363	18363	1619244540000	canonical
26395	3NLvQFCytDU7tPZ86Mq8qNE9jTWGXQwRzvs51b3Ay5VmhsCiRoYc	26394	3NLs4vqcXqJViGLjbXVnjkbnaPaApSQ7s6BPuqvYaTK3SNWZtUL9	1406	1393	506	12463	18092	jwP22SyAxkmJEhpAgsjxunWn85m3qbqnsdSzUKNJm9EKiNkR6ax	13057	18369	18369	1619245620000	canonical
26400	3NK3EBgtFWBSadCHKvZ6oYMoyZdG51zVmdeqfdFQzaT7z17VeN9b	26399	3NL4uV1fLXuCaYKe9Nkz3GjXsMzjJGP5pmP8tjD12diyGotVXNjh	1559	1107	507	12463	18096	jxiPAuB2CJ3rEodgUFLFU29VfeUiLwcAhMk56t59nkMcByiPUBN	13061	18374	18374	1619246520000	canonical
26403	3NLigw26LLafuNp1Mz9E7hT2jHC8t7NkiMmjyTwaARRyhgqiX6Bq	26401	3NLdRSTBdFNEBmp3xWRYb3PhGXAwfe1NGmdiL62zwKJBxLmJ85R1	1553	776	507	12463	18099	jwAzE7HHLL41hBAezVKrKABKx6MHc8ZyLdh38cA3Qh68XyAb11g	13063	18376	18376	1619246880000	orphaned
26412	3NLEdqi3cwipvitSZEPg27L3eYntiPxSfYpF1UXjfVtnL6vTS9Jy	26411	3NKh17j2RvZEbq76hofosnUtorGFqx6Tzf9ogVzxi9eij9bPHJot	1406	1393	507	12463	18108	jxLChydfcbt6YKNXbWxB8xQTvGSXiWBMdzqE4W9oqmWWz95nTee	13067	18381	18381	1619247780000	orphaned
26421	3NKbi35rnpHPUvXHhStzjfMpfgNMqEeZgt2VJ6NZdPTWC2p7Zc1X	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	1646	1354	507	12463	18117	jwkAAQzNc2RahtKJm3hQFC4g42ptcr4FH9bca3B8ah2ZGyP5swc	13072	18391	18391	1619249580000	orphaned
26429	3NLLzFqEZcNXDbwDxqRg6U6MxAGyCgx8BQpDySyh4SAVaVraTPpA	26426	3NLqPrdUakdp3vkXLmEtZ7D9zPZCiFKvDMdFyeY8hG2QqX7eWuLn	1571	1335	507	12463	18125	jw9UUmbVaSxoKDg2sfGg66idk7cRbAuuKLPwAne1xLBwx6eQUHm	13075	18394	18394	1619250120000	orphaned
26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1407	1395	507	12463	18128	jxbb84yctHTiSXgbNh9GSiYQg955yormkV8ir7maRg6BqZNvvmY	13077	18397	18397	1619250660000	canonical
28915	3NLsWnFPxJSN2cEz2tAAvDenCaKoGfDGosRgfhvm8Ya5KzGtzitT	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	1642	1367	566	12463	18974	jwPvaG3qn6QcdHZxhui2iazwNCNWavF2q6SysdP42YbUaZQYYmE	14262	20088	20088	1619555040000	orphaned
26424	3NKBQANwVgGXFZsV4jvH9qTf6tEdCw9dzPmKjNx4P9kCvWBnzvTn	26358	3NK9e6FZuCQeJi3DZVr5HmntowsDRaBANTrREd9qJ1jwTJYQLQot	1534	1191	501	12463	18120	jxujLauXSkwtN2jVB1Vd986TNCB1E7aGdYWNyq1LYfhUK4xAeBn	12928	18391	18391	1619249580000	orphaned
26341	3NKJSLCyJ4P8DCfmaT5DKaMGwKYfgxKcHubYMVAgCkjR9N2ZfeWH	26337	3NKJCUS3Z11w57GRLxgwvVAmnAiWDTX6drGPND1iy8kzq6fPg9tp	1403	824	505	12463	18044	jwB34ZQHckXsNQyYtkpmNtkmXAMm3rvgUh8bs4Uy5qRLyjav3yt	13026	18325	18325	1619237700000	orphaned
26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	26339	3NKmR7dq8hNbju54LE17qK9WeoX6KNnQedkXzEfSMCu55oTDt4j1	1402	882	505	12463	18045	jxHotzEcP4JMC2VnQDw1hexoePVrWdMmFJvgCatece6otyCzaep	13027	18326	18326	1619237880000	canonical
26345	3NKzWqis4fQCTyoHKN2nDKpofWFCKnRMDZK8QzsTsZ7w3pibXjhx	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1624	1208	505	12463	18048	jwS9qpXQfCjoZoWLYET9KzvCzse5FCFL1ekf8UnayhAxA8mPfhH	13028	18327	18327	1619238060000	orphaned
26352	3NKwELwGhdwNpRrWVoa7sK4vw845amQALZNbcWWBaGsosQ61f2B8	26349	3NKRi9FSE7QyEowCEkFxKPXjKdNwj2HemxDZQQqz5UQCzNZ8DmAe	1765	872	505	12463	18053	jwNWYx8TK2pU2UVS7ZD41Gg4Y4HZ8XMJ7dGtRHVLm7rQrtRPqsg	13030	18331	18331	1619238780000	orphaned
26354	3NLZ1xyPcwTasBFdKttnCHpTvGTCENokVjXthQJTJjDJv1bpFn1M	26351	3NKH2cZMJWdtJs4NAv1x5Lx4Sorqqocwp51EXVukHkcQUVNagEmc	1506	1127	505	12463	18054	jxwo3eSZLGGRdB9Pk4MtTd8LJf6hmk5VGdxTaiNvxUa7K8UFTxY	13031	18332	18332	1619238960000	orphaned
26355	3NKDDwa3WG66e9oNY1KVfMx6rh38wDjPMEfSU5EtVBhc45SkN35Z	26353	3NL1isb5fLgAuyJWSKngwtvFK8LFPDey2AZMzQRDvrGWz32xFc4Q	1593	1346	505	12463	18055	jwUP7CMPSDyVLr1xRwQSVjG7vqCjpc86oGfDvHrCqywgYM3rGDC	13032	18333	18333	1619239140000	canonical
26357	3NL64THRBojAmPYPhYbdMx93e35ewjcE9tZ6a9jiJgvPguaiBMhn	26355	3NKDDwa3WG66e9oNY1KVfMx6rh38wDjPMEfSU5EtVBhc45SkN35Z	1534	1071	505	12463	18057	jwPZG9Mfr8TLwvuCcCzPe4cpzc1kDTHQxTW8V6WKEUiapNBzCV8	13033	18336	18336	1619239680000	orphaned
26359	3NLJqv81J8ejoeBE61r4qEfgKtLjurJWvu17Xq7Ce9GnA1h81E7m	26356	3NKt7q27LGa9jSApy5K6Yv7ZWvv1FUjPGd2ciybtjxYpEwf1srYg	1406	1393	505	12463	18059	jwzaj3UV4DrurJKJLCxQ56a21B2J9JTp85MMBwynTmuVLfEzEdN	13034	18337	18337	1619239860000	canonical
26360	3NKaNCas8t722ymGPafbeTaxoe5prW3cSZYvsv6LGFJFw76eZjx2	26359	3NLJqv81J8ejoeBE61r4qEfgKtLjurJWvu17Xq7Ce9GnA1h81E7m	1406	1393	505	12463	18060	jxeJuKvySgxX1WyS58jutSsVJpyPKtdGjmeFm178rDReKLYU9Go	13035	18338	18338	1619240040000	canonical
26363	3NLCrM2m9mhNtGFUSxePj5kYDTZbjDQFx8pDCmiHZz9rEEZjyg1t	26361	3NLE8Dj2Rq1AKay4UmgT97AZRmK9z2Ppg82KHCByD4Ajj65odyKN	80	907	505	12463	18063	jxRYQzfmXU2zybnjUTXk2DTupLnsSYb86wXF66sxcyCVhRQTCCm	13037	18340	18340	1619240400000	canonical
26369	3NLWt14nG4ecUPjibebjCzX1LoyB3NvMutZ2o54L8AgoxAUajQj7	26367	3NKykx6HS2Vgpg2fBtZiULmumVdsk4NtovwwswcwHm7oHT19c4Lb	1619	1275	506	12463	18068	jx7QHkomJLMq9DLTs198sRsBp1RgfjSZxGhva61GnJAYHwJEHwT	13042	18348	18348	1619241840000	orphaned
26371	3NLvSrYwWN7prvsdBPV5ESVoecspwoydroTRq25SfQam1vHMi2ZP	26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	1578	1170	506	12463	18070	jwdKk5MTyyXQu5mADqCUbH2uFBN4Gi1DzgmSKpwCYuiM1c8nKay	13044	18350	18350	1619242200000	canonical
26373	3NKEZcedpQs2Ews2sACK71jztHcJoBAY3APPPB8vtZnCfRPhjjNx	26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	1631	794	506	12463	18072	jwM82VuMehS6B3aGFznodCAhwJ6SWxgbiRQvmCxGjpC154xrMZk	13044	18350	18350	1619242200000	orphaned
26381	3NKbUWvqFsPo1neobEZSyuduJYAF4tNH2EmVDNcs8yahR1zV4HJg	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1619	1029	506	12463	18080	jxAfmDzuihuPBguAMgJWF3bMLAzhc3eDkJXwBii2bgAD4ioEFmY	13049	18357	18357	1619243460000	canonical
26385	3NLeMjj6F9i1wWvv1irE8g9GJLwRx24ANCeBd7CZFV4H56d7mYJZ	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1527	1167	506	12463	18082	jy1BtqBY6sD1z1PRba23nyRzpdn2kNKypupTLPPiAkiFqxePEUT	13049	18357	18357	1619243460000	orphaned
26388	3NLhG86LTxr1xyPxMLvETcJiSNsB53ufXCXMAhEujVdnuwaCB7Pw	26387	3NKYzaL5Hd9DtirMq6wGYsFG1WEcCVTZB4JEn8P2wY84MZZprveA	149	1283	506	12463	18085	jxN4nrYu8zA6FPVUFyWXyoSNStLrGeBUsd3gDdt3Q7LVoSuHF3X	13052	18361	18361	1619244180000	canonical
26394	3NLs4vqcXqJViGLjbXVnjkbnaPaApSQ7s6BPuqvYaTK3SNWZtUL9	26393	3NKPJyV5wKTUhFu4gsG755zQUdLjtPA3FDyPTo1WxebSrKSPkNnm	1407	1395	506	12463	18091	jwSJnqWLacMyrNk4LxVbDYruLPM8BUQkkUMdxDHdKAKTsLMMQ8z	13056	18368	18368	1619245440000	canonical
26397	3NKp3BhpwsLX6cjMrDpqUanRFMwiWJ97fQGd7h5EdMDJMqw461UV	26395	3NLvQFCytDU7tPZ86Mq8qNE9jTWGXQwRzvs51b3Ay5VmhsCiRoYc	1546	1339	506	12463	18093	jxXneZK4hEWwakUY6zG48qgrbmMUxUcedpNGXCgmrgR1zbz3tRo	13058	18371	18371	1619245980000	canonical
26402	3NLHUHm3XNmkqW77NVyMu995BMMnqe57kJcSA3g8d553BfGBjc4P	26401	3NLdRSTBdFNEBmp3xWRYb3PhGXAwfe1NGmdiL62zwKJBxLmJ85R1	1406	1393	507	12463	18098	jwo6FhFznpoygpKmRhxcu7k8b4LievxfxSEEuREDcBod2DzzAA1	13063	18376	18376	1619246880000	canonical
26405	3NLvJ4wTmsn8PcPjNcTnCi7XVguR7QCrRcejodf7zLpjCpHKS1Pt	26402	3NLHUHm3XNmkqW77NVyMu995BMMnqe57kJcSA3g8d553BfGBjc4P	1536	1313	507	12463	18101	jw7r4Ei5e5uLB54saW6wsZVR5tkV7GRd7a2oQf5EQRy1yBTWibV	13064	18377	18377	1619247060000	orphaned
26407	3NLQhsePyDA43UKGYgr38ZQq7bYRa8kUPjZzkSQHY5qHyQCfoa5w	26404	3NK8ot4HCJHX7hXvQM85xUivR8uLgm1S6uScH29nwKofCeqDBEnV	1405	875	507	12463	18103	jxE2y4viFwfJd4JGR5rS1Aj2FDsuigb6FW3gKyxxTRfiy4XmPx6	13065	18379	18379	1619247420000	orphaned
26411	3NKh17j2RvZEbq76hofosnUtorGFqx6Tzf9ogVzxi9eij9bPHJot	26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	1637	815	507	12463	18107	jwJH6vVm3PAgBTB5MUnnFcTfTZrnox1gYo2KHjDGYb4VsYKi5s4	13066	18380	18380	1619247600000	canonical
26415	3NLVxng6RV6eKWMMRZwPomFF1SvhqghbzjhKSgh5ZDjDyprymzpG	26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	1610	1068	507	12463	18111	jwhnnyBsscdDEVX82YHa7Rcrbuq887gPLAYs8W2NNk8inZvEHQC	13068	18386	18386	1619248680000	orphaned
26420	3NKC1K3LquAKN8HrAsJ6fW7YzMjGPWzMqdQt32y5bgg7h1jxyN2J	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	1534	1191	507	12463	18116	jwBSKRFMcjuJBZQMqixtFrcJ2sA6VNX7ykTRAGV28qG9HLMu6uN	13072	18391	18391	1619249580000	canonical
26427	3NLejkG7TRuha19e88UdmmzxQf9UqK5Y5vURdFvHmiCASKCVkRYu	26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	1406	1393	507	12463	18123	jwd44XF2JA1UC2wk3epCBRXjZdLdavApyu5TbTbpz63mHk1fuvf	13074	18393	18393	1619249940000	orphaned
26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	26430	3NKtmnH889QMHg66wTXb3pqRWbF93UW4ei4ppTYFMb5hgw5AP5PK	1655	682	507	12463	18127	jxJmXrxLoA1AHwG4PcBxGbgLtFu4Cfge26tEA6Cz1CSHKpfTMLU	13076	18395	18395	1619250300000	canonical
26434	3NKCoAT5wHacPztkhaXZUP1f5Wa6fWBGK9pqiGnHpxCnhiVerM5G	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1419	813	507	12463	18129	jxiGFLBx3JEqZ3bBa7mUDAgph49eXPFKw7yPGeVHonefzLMm2hN	13077	18397	18397	1619250660000	orphaned
26438	3NLVcd4ouxexedZhTQV6pvDZhaU6oKJJzVL5XVausNCWSS8CVQgo	26437	3NKFGF9J6gsdDFGU2AjjL9fHX7uXUqZypATnKn3FsRmfm47Va9aW	1547	1132	508	12463	18131	jxaBVpvLUrUyQAiKioM5i9aZf5wQ9QKPEv3r6asCbvTEvrrSaXy	13079	18400	18400	1619251200000	orphaned
28918	3NLfjJ41RTMuQdmKSpHRk9vfB4DxGn4eHgcX2jvsCyF2j3QiMWvj	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	171	1008	566	12463	18974	jwy7QqbB1Pbp7SabBjh9cWbJxDsTgoDWkb7WH93yWDviMgXRNgT	14262	20088	20088	1619555040000	orphaned
26365	3NLB6vV56iDL4u8xbcHU7X6KpXpeNND49Bwk7YbzdaCzwu4GzfNg	26364	3NK3fHzmmqsGbhbMfR2JCsXZfRPizuDjJvxVkHgcVwirqNhGv1yK	1407	1395	505	12463	18065	jxWU7mAp5UCrYMjjBErYQeWE8xiJ8ATvX2YmXAjnTFyqoNqeSPN	13039	18343	18343	1619240940000	canonical
26367	3NKykx6HS2Vgpg2fBtZiULmumVdsk4NtovwwswcwHm7oHT19c4Lb	26366	3NLUteRH1dBDWrhGRvhmEv6GFpKDUbKxrbPYvQUZm4ZvqdhpcCyR	1406	1393	506	12463	18067	jxpRuXcpVZN4QhR9DA5z7CZePZTYVkFn5Mq8q9ZBiDUw9dY8CEB	13041	18346	18346	1619241480000	canonical
26368	3NLZUA2ycjW8Jj6LWvCSa8seonhUwwWKnS9LaKs7kEVTRv2iFdtA	26367	3NKykx6HS2Vgpg2fBtZiULmumVdsk4NtovwwswcwHm7oHT19c4Lb	1619	1275	506	12463	18068	jx8GLJYdk3Xvr5GDh5rzssykMtxYR6C5Cv3esRwgrdD3piQuhRQ	13042	18348	18348	1619241840000	canonical
26370	3NLMtEfh6k7QADVZhqkDowkc39kDdKvgUESMQA6uj5kvujN5aRqZ	26368	3NLZUA2ycjW8Jj6LWvCSa8seonhUwwWKnS9LaKs7kEVTRv2iFdtA	1439	1033	506	12463	18069	jx9WLzyJdAbfRmz58BxVfsVj6S1dpBTYzU8rYdTYCBRhK9qSxuH	13043	18349	18349	1619242020000	canonical
26375	3NKNu35v2EiXEUCpSjNNNaBFatuP8yVXvfowudq7Fknag9SFwRyY	26374	3NKhpcey4BFHh3VEUXLLXAnFo2SL8MhDCnvi5iACAMRULRWPSBHx	1467	1010	506	12463	18074	jxtbtxEqcKUxB6gdRaAhieVi5kVzdBdeir1RdQV3L7chbGJyR1u	13046	18354	18354	1619242920000	canonical
26376	3NKUxhWiz14amt6qc86crVthwGWv2ki1S8qwvAM4U1qyuFhvP3Dz	26374	3NKhpcey4BFHh3VEUXLLXAnFo2SL8MhDCnvi5iACAMRULRWPSBHx	1622	1230	506	12463	18075	jxNoRyHigMcKM4SgyTPDf2NbtWssrQajQbsuxskiT8SjgG9BYZP	13046	18354	18354	1619242920000	orphaned
26378	3NKLxFvskjfFCFmhsNcCJYtL5SuZXCZjS62cbbr9JeV4VfJ7Gpfs	26375	3NKNu35v2EiXEUCpSjNNNaBFatuP8yVXvfowudq7Fknag9SFwRyY	1631	794	506	12463	18077	jx6BRu6Mn64DcbfR5XG9RujGCjnc3iqg1vzZrqkHEUydGJFeNof	13047	18355	18355	1619243100000	orphaned
26380	3NKWzvu71Uawdp42XqHKd3gubGSBpDTbaE4hDVTofvH3hrmP7Sgj	26377	3NKfppuWLAgt1YYT6zWJvs6N8Cq4bNgDytiBCTAptqAtEEcLwDDZ	80	1273	506	12463	18079	jwceVvJY5T5w3CkaK45NfADDD7gf8Y6diTQxF8SiJdkPkgZ2qfP	13048	18356	18356	1619243280000	orphaned
26386	3NLfY8EmCoZTqKNq7ciandgvMuWJqDqXafbSTNeReLZpxAPGAYvj	26381	3NKbUWvqFsPo1neobEZSyuduJYAF4tNH2EmVDNcs8yahR1zV4HJg	1613	1103	506	12463	18083	jw8h7vGU5dkheVxsMnb5KyCH1z3tcRdyJbixbSWj6dPYhaQuUsB	13050	18358	18358	1619243640000	canonical
26387	3NKYzaL5Hd9DtirMq6wGYsFG1WEcCVTZB4JEn8P2wY84MZZprveA	26386	3NLfY8EmCoZTqKNq7ciandgvMuWJqDqXafbSTNeReLZpxAPGAYvj	1642	1241	506	12463	18084	jxioZoKkqW4ttdEJaJwuFZA6jmgESiQ55mpYangc87mjmayfdDu	13051	18359	18359	1619243820000	canonical
26390	3NLeTJ17fUc7D2MujHPXxvpGjHz8jXfLzwTbi1Ukc9RE3y4DcjKX	26389	3NLW9zXpCpDF9s92nV5kPGLMEHFZWMsHP62cDNdmzA1ie8PmJf9U	1407	1395	506	12463	18087	jx87tN2PG91T7tGzGBgBLLe9TKW3KGodZUKfxHcYaPPKLhLoThp	13054	18365	18365	1619244900000	canonical
26391	3NKkdBRNkMAT6AenaxpCUEoZexScQsS9d2XGLrRrcwKHeh2DakgP	26389	3NLW9zXpCpDF9s92nV5kPGLMEHFZWMsHP62cDNdmzA1ie8PmJf9U	1602	1369	506	12463	18088	jwmwmb9eB28ZFPseB38eVqqFpVQ8udUe4S3r4cDhxXtAZu5isTf	13054	18365	18365	1619244900000	orphaned
26393	3NKPJyV5wKTUhFu4gsG755zQUdLjtPA3FDyPTo1WxebSrKSPkNnm	26390	3NLeTJ17fUc7D2MujHPXxvpGjHz8jXfLzwTbi1Ukc9RE3y4DcjKX	1501	1360	506	12463	18090	jxSC3sMBNaJt5NusbhyLDXRJRQLcBmq7c47nZm3XyHfzjvNDFSR	13055	18367	18367	1619245260000	canonical
26396	3NL9ytEm3t6JmZSLudb97ex4BLjnmEiPRRtNdPJGWqh7zKzqZTCz	26395	3NLvQFCytDU7tPZ86Mq8qNE9jTWGXQwRzvs51b3Ay5VmhsCiRoYc	1546	1339	506	12463	18093	jxXneZK4hEWwakUY6zG48qgrbmMUxUcedpNGXCgmrgR1zbz3tRo	13058	18371	18371	1619245980000	orphaned
26398	3NL5f3tYKj9LAhQyYSKu2svCGbdphP6FVqRShdeCyQwNZP1gtphd	26397	3NKp3BhpwsLX6cjMrDpqUanRFMwiWJ97fQGd7h5EdMDJMqw461UV	1516	1048	507	12463	18094	jw8ody5jiiDHamu6kQ1FHKAknv5nFjtM5gMuuCgpZvazX7GbfHX	13059	18372	18372	1619246160000	canonical
26401	3NLdRSTBdFNEBmp3xWRYb3PhGXAwfe1NGmdiL62zwKJBxLmJ85R1	26400	3NK3EBgtFWBSadCHKvZ6oYMoyZdG51zVmdeqfdFQzaT7z17VeN9b	1637	816	507	12463	18097	jwkzTjzwen6ew7LLVT1X6bXaMhhMSPDnu8259c6rvo1f7CUZwdK	13062	18375	18375	1619246700000	canonical
26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	26404	3NK8ot4HCJHX7hXvQM85xUivR8uLgm1S6uScH29nwKofCeqDBEnV	1623	839	507	12463	18104	jxBH3HxRjNDkhsw3uuUpnYVHQffRYh2QjoTDKgsPuTehK7KxL6k	13065	18379	18379	1619247420000	canonical
26410	3NKWGCLCRUZN1cLZJ2yG31P1Bw8keeKJnFiWJwcqswD6yZ86JhT1	26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	1407	1395	507	12463	18106	jwLQsmiGjX9Wba4p238NWQQvHcUQ3gg5Yi3pJvyX1AtHMo5vDQC	13066	18380	18380	1619247600000	orphaned
26416	3NKgKLAeMdVkC2uv5zXNX2suV9Uq796RvoErWLpWi2pTRuEs91KN	26414	3NK9PUJfVPTa9ZFdWzeHDdWLo9FYQrt3wHLuLamey5VmumjBERGA	418	418	507	12463	18112	jwpEKnkLzTP9FMw5ECA99uqXP9uA8dEiJ28Q3KobhYQCwNDXHiz	13069	18387	18387	1619248860000	canonical
26418	3NLDAd5SdWipdjv6kwSFhWTHsfURpaKgDH2JtfndwB8PGUDgS1NF	26416	3NKgKLAeMdVkC2uv5zXNX2suV9Uq796RvoErWLpWi2pTRuEs91KN	1406	1393	507	12463	18114	jxuNSERrbHNJWcFPYLJ4ob465yp7dsWUn7HPSAn2soyXy7oTUbJ	13070	18388	18388	1619249040000	canonical
26422	3NLGfyuaxTPjArPdBGYhPuFqVpXDGwKJYkCAhr6dreTXucs1dQ4D	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	1471	1386	507	12463	18118	jwLmqwdYUZnkF2qjrq9uq9sSB65AfdUc4qgvsaBopnTZogC7NG9	13072	18391	18391	1619249580000	orphaned
26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	26420	3NKC1K3LquAKN8HrAsJ6fW7YzMjGPWzMqdQt32y5bgg7h1jxyN2J	311	1307	507	12463	18121	jwxJ7JrntE6D9kpNJngykrqNaBavav2K4b4xdGZEwuLCuo474EP	13073	18392	18392	1619249760000	canonical
26430	3NKtmnH889QMHg66wTXb3pqRWbF93UW4ei4ppTYFMb5hgw5AP5PK	26426	3NLqPrdUakdp3vkXLmEtZ7D9zPZCiFKvDMdFyeY8hG2QqX7eWuLn	1407	1395	507	12463	18126	jy379dEaaJzYVHoaLkdKhh87yC3z9WhG1NELsCJh7BN3LZekXu7	13075	18394	18394	1619250120000	canonical
26439	3NKY1tVsuwXvUKTVvTiyrHEJ9cHP1NumS3jQ7qrpwvn1sT5mh5H6	26437	3NKFGF9J6gsdDFGU2AjjL9fHX7uXUqZypATnKn3FsRmfm47Va9aW	1406	1393	508	12463	18132	jxtsDCqK5YXuJpbATnymTUZCH39A6Q5JgeNgkS2f4qMe9EardJm	13079	18400	18400	1619251200000	canonical
26442	3NL2KeHCHMPXRMB4hZy8aPLbki85kXXhfS9SajNgqXbkX5bsaPdJ	26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	1637	816	508	12463	18135	jw7be3xLh3KrzxJYmRjQe7v4boX3sZfatrSrPmw8BsxftqmfHAW	13081	18403	18403	1619251740000	orphaned
26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	1588	1146	508	12463	18139	jwM21m8xxo44JHyAQsPX2vH3ME6bMYPQDWmshfLYfFDcUVx22ka	13082	18404	18404	1619251920000	canonical
26457	3NLuvcAuE96b92A2zSPCLzStdS6VajyXYmm19SUwUL4qAj31Fb7y	26456	3NKaGF5ZKXCtSzcjRNmMD96FyDb9bchAJfRLjp5erwrxo6jpbyBL	1553	776	508	12463	18149	jxDB9gjSmaeL1MjgUKvbAHtWhCNdxy6YcaKToRMc34fsofyvi9p	13086	18408	18408	1619252640000	canonical
26460	3NKfhoBxHtPuLRJi5eZwFpgrJ94mBKqTLoi2kmYL91Eoc73K5msT	26458	3NLvTE7vn3EnprmXANQibqa49dBRoMr9DoQdwbGj3dEYgAdNL3P7	1656	1343	508	12463	18152	jx5hFSuRooZAULH5SvFkTfa87tMj2GTEKNwZJhcwicxV6BcY8Lp	13088	18411	18411	1619253180000	canonical
26463	3NKQbQheRXeFiBgaVCvpxT1u9eUywEUsoWxXptVWz6yL3wXLzdoy	26460	3NKfhoBxHtPuLRJi5eZwFpgrJ94mBKqTLoi2kmYL91Eoc73K5msT	1623	839	508	12463	18155	jxY5QgjFyenAJsYdS5kUF6hoo58NWaB1CCRdiU5MiUs1C3FQYMa	13089	18413	18413	1619253540000	orphaned
28917	3NKfH72DF8Q4tui7mSmJWMQKudTz4bFwYeKLcK8YfGs7jc72Jhur	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	1599	1161	566	12463	18974	jxf6ejmeuscRrd35hGEmPxrteFy3YducPM5dAJcpVCKPWbGTuHW	14262	20088	20088	1619555040000	orphaned
26406	3NKPHJZAAAZYUxH9jtRDVgWhkcrU36Y9uhzHNgE8fDuJxoWfcYoH	26397	3NKp3BhpwsLX6cjMrDpqUanRFMwiWJ97fQGd7h5EdMDJMqw461UV	1648	1284	507	12463	18102	jwdkqWsUsrszWnaiVbcbDiowVEs4HAg6AV6FnkJk72FZu8bNT9v	13059	18378	18378	1619247240000	orphaned
26399	3NL4uV1fLXuCaYKe9Nkz3GjXsMzjJGP5pmP8tjD12diyGotVXNjh	26398	3NL5f3tYKj9LAhQyYSKu2svCGbdphP6FVqRShdeCyQwNZP1gtphd	311	1307	507	12463	18095	jxLokazfkQwWcH8AYVGTmXaizXVdG6hGwhyYykZtvKwW2QmuiUu	13060	18373	18373	1619246340000	canonical
26459	3NKvTunpsUJ9SeNbRuV8KvZ8j2oBjCPGCevUhx9a2pTxmPryGv2J	26398	3NL5f3tYKj9LAhQyYSKu2svCGbdphP6FVqRShdeCyQwNZP1gtphd	1468	147	507	12463	18151	jwvuZ9XvE5qKynYet6X361rKSTPjMWcBLxy7TctQDj9VhFuHVmN	13060	18410	18410	1619253000000	orphaned
26404	3NK8ot4HCJHX7hXvQM85xUivR8uLgm1S6uScH29nwKofCeqDBEnV	26402	3NLHUHm3XNmkqW77NVyMu995BMMnqe57kJcSA3g8d553BfGBjc4P	1422	971	507	12463	18100	jwyaLFzJiKyCd4dpVJgybTJETXCNhvr9gTzuQ3V8xaE5f1CXkRe	13064	18377	18377	1619247060000	canonical
26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	26411	3NKh17j2RvZEbq76hofosnUtorGFqx6Tzf9ogVzxi9eij9bPHJot	1623	829	507	12463	18109	jwG6xVUnpiMaSC4UtsW4bWzbtbQG7aUm5WbHQtqwrzU5GBrbnHE	13067	18381	18381	1619247780000	canonical
26414	3NK9PUJfVPTa9ZFdWzeHDdWLo9FYQrt3wHLuLamey5VmumjBERGA	26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	1476	1371	507	12463	18110	jwxz9W1fNhf4r8aruBHgfdCBRsLrpB8jTnCHPyKfWuHSnUuvP8U	13068	18386	18386	1619248680000	canonical
26455	3NLsm8LVSebP3ya3ouvczK2DG7FZ6JSKep69yZ7SKUvswKzSH6cw	26413	3NKJr9sLxUSnRx5foUoT4UY51jvCm4i2L9eptdjt5C44Bv1wPeAm	1402	906	507	12463	18147	jxXxmCVkF3HwgKUmHH2S5BuXywdqzkejpptYefcJdtYY65e7nkL	13068	18407	18407	1619252460000	orphaned
26417	3NLvsU9dnTN2WCKixBRoh68ej53xEDbKJMZ3mHpY2oqWisbceCTj	26414	3NK9PUJfVPTa9ZFdWzeHDdWLo9FYQrt3wHLuLamey5VmumjBERGA	1643	1299	507	12463	18113	jxhFoufZQpk977A5umiAj4rjbexanDFUr6RYaLvJwZvA57F2Ssb	13069	18387	18387	1619248860000	orphaned
26423	3NKzcBrPMaWsQXiuJT9XwMYaptVpS3sMfyZr5fZsDiZA5G7qWtRn	26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	606	929	507	12463	18119	jwJ6BNoCHv8PaYxGLf8bwCdo3sS94aUGY9BV27NqdQSmkKWxbhR	13072	18391	18391	1619249580000	orphaned
26426	3NLqPrdUakdp3vkXLmEtZ7D9zPZCiFKvDMdFyeY8hG2QqX7eWuLn	26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	1501	1360	507	12463	18122	jwax4t7hmuwtgvC5VvNME1bPaLVNcrGWC9jJEae9zxM16Tet61X	13074	18393	18393	1619249940000	canonical
26428	3NKvrcZAmYvSMSC7gcb4tP3S4nei2FseKBtKzUY4EzaUZtWZQ2S5	26425	3NKR4D125CQNH2TnNaLfE5eg4m8QAufvYLeh2eMXKB71ViNSJsHB	1631	793	507	12463	18124	jw7vAdjzaoakPU2bUrpPLDxdCVXh4faWaJ351MAeqyoJfFM4A4K	13074	18393	18393	1619249940000	orphaned
26433	3NKmySfd4PegLWoxGpiMqhTs1VeS9d47VZPm1kQ2pZZBZhxVpQmP	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1419	813	507	12463	18129	jxiGFLBx3JEqZ3bBa7mUDAgph49eXPFKw7yPGeVHonefzLMm2hN	13077	18397	18397	1619250660000	orphaned
26437	3NKFGF9J6gsdDFGU2AjjL9fHX7uXUqZypATnKn3FsRmfm47Va9aW	26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	1444	1381	508	12463	18130	jwCfEorMjtZxHECTZkmDdh9K5okrsaq9ohzNPr3jfP2r61knq9o	13078	18399	18399	1619251020000	canonical
26440	3NKATvak41hxUGaUmvvzEUtGumTpHjihENyivqC7ZyQRoyW7fNPn	26439	3NKY1tVsuwXvUKTVvTiyrHEJ9cHP1NumS3jQ7qrpwvn1sT5mh5H6	1407	1395	508	12463	18133	jwMQgZHmw37zfVHKqzmNM76PB4ut5soySrByg3j83D7GaUcUfxN	13080	18401	18401	1619251380000	orphaned
26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	1553	776	508	12463	18136	jwuYvtPE4QjHeycaQvRxpjpcnPEsdkXyU7pwMK7w3Je9EFPB66c	13081	18403	18403	1619251740000	canonical
26444	3NLYfmehkuZv6JJMQ2vsqueG5pL9WHmPT45tF3GrL8P7ng8xdLVx	26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	55	463	508	12463	18137	jxnm8dHwsh4XGmWc4i4KQHfSm5gq195efRSdUygYzFtS2kQVjBW	13081	18403	18403	1619251740000	orphaned
26447	3NLAYUGoR91s1zvptRrZK82U8Ybpca6d3pCT6tCLcZHaZUYWzcy6	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	1637	815	508	12463	18140	jxFbmhHr9y1rnPctPhkMR9Ku6HsXntvRR5hm7Wf89sffJKRoq8z	13082	18404	18404	1619251920000	orphaned
26448	3NKaiZGbRJLaG5FaVc5KspXRz2TQcEtzbFA551a4SDTJNMicogyR	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	684	1106	508	12463	18141	jwdpgjFAR4HcJ1sas5A9NR7g8bFLWRA9LV7J7Q236omX2wtYjFA	13082	18404	18404	1619251920000	orphaned
26451	3NLqCUnmbhMN1kNtoBZfKFKiRjJPhqpvAQEYeiGT3PheuvWaEeQi	26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	1646	1354	508	12463	18143	jwp138XmryoMdnDLkAKhRcfDo1ycf8AeqyjuJvA9s2QRyQtnfN9	13083	18405	18405	1619252100000	canonical
26450	3NLk3R174uLQp9SJe5J6Vu5hvKWP8oJ38DeszWapX4nR13v9MvGP	26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	1467	1376	508	12463	18142	jwa7VQZhuMphAHfXU76TGSfxkPTb1sJvUAvbPKiv7Bq5frR8j4t	13083	18405	18405	1619252100000	orphaned
26453	3NLqrEwEzKxuPCR64iTi1abD4Zpoq5qSafd4J5j76h42Q6qR9VKM	26451	3NLqCUnmbhMN1kNtoBZfKFKiRjJPhqpvAQEYeiGT3PheuvWaEeQi	1407	1395	508	12463	18145	jwD6LGzAHFBu9udFDYZxEvFFCTigQSuPTtVVNUpaVoPxqdEuW6y	13084	18406	18406	1619252280000	canonical
26456	3NKaGF5ZKXCtSzcjRNmMD96FyDb9bchAJfRLjp5erwrxo6jpbyBL	26453	3NLqrEwEzKxuPCR64iTi1abD4Zpoq5qSafd4J5j76h42Q6qR9VKM	1516	479	508	12463	18148	jwsvb4EGrgtrvZTDCj6ghqYx1buEBBXW32QjXQfUwTSw1xAkXKE	13085	18407	18407	1619252460000	canonical
26458	3NLvTE7vn3EnprmXANQibqa49dBRoMr9DoQdwbGj3dEYgAdNL3P7	26457	3NLuvcAuE96b92A2zSPCLzStdS6VajyXYmm19SUwUL4qAj31Fb7y	1657	1218	508	12463	18150	jxDo88bCvPWDQiaF1ZFeX5bE3rs97X5r6yYEqS8wFFxp9PtEitz	13087	18410	18410	1619253000000	canonical
26462	3NKjxudFAqYX6vPhWmUyohEjDgutqbP8rVgywLUTnRC9yesmtGYh	26460	3NKfhoBxHtPuLRJi5eZwFpgrJ94mBKqTLoi2kmYL91Eoc73K5msT	684	1352	508	12463	18154	jy2jNrqJaVeQ2WWyXQfdScYXYNe6geXHDQPYRkFxA7z7T8FWJoU	13089	18413	18413	1619253540000	canonical
26466	3NKMztx6QqNHqaZXz1FsRZM5giq9nz8L83uBbA9TTXUFPUYm7xrk	26464	3NKyRSm1CWzLCqhiyjiuUhvzPN8SQw3KQDNsNbeMmAfR45XrU97a	641	1210	508	12463	18158	jwytrweWBGVqkfMJp8JbKxf3ggWCdeXHJ36jkcQ7TSM9dLGDpdq	13091	18415	18415	1619253900000	orphaned
26476	3NKQr5oKjkD3hKzNAL2MJBK4SVJp1qZa72wqa5xQRGWdpDVhbFpZ	26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	1447	1345	508	12463	18167	jx1e1MrVvim1AtZjMdNc5Wu8Nw4rqTZFEVLiTGHAj8FDuebSUbj	13095	18421	18421	1619254980000	orphaned
26477	3NL6k1rKDA6smVYesKyV5VCXqudojNDZzfudDG88JXcyBKnUWJwv	26474	3NK46mgb3wZHekjtsyDucdYAdiicywpiUjuCk4Vth2VQ7PDfKxYG	1553	776	508	12463	18168	jxNW9etuf1pbdhpgkUViShU3beCFzGaDk24XWcUxYPFRfs7Md4T	13096	18422	18422	1619255160000	canonical
26485	3NL5LaKG6We5cMoV43UFqC9EeDBZgQ8JAqdCc7dvCjdgXvExY81o	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1406	1393	509	12463	18175	jxS64yV5UreY2NuDFcn1wBqQoydi29xoGNC9yBBYBmYK8KrqsRc	13099	18425	18425	1619255700000	canonical
26486	3NKbehCTHtbBkcu1wrFHEWgeMopP5aN4FTmSNUynUdTzxDtEtXLJ	26485	3NL5LaKG6We5cMoV43UFqC9EeDBZgQ8JAqdCc7dvCjdgXvExY81o	1406	1393	509	12463	18176	jwSZXMNbJZhJjS849NvFrUKjAY4icRY2yxy98UWpvB4XcPtmoac	13100	18426	18426	1619255880000	canonical
28933	3NKg8RNoWPoxsPu5jN6dKkoXmyZk6vpR6mJmkktVnZoYzwHwtUY9	28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	1555	1347	566	12463	18974	jwJdvqkGi93zrxsTK1GCh62qpnc8BitLw4Nhqsg89abXtCYMG5Q	14269	20098	20098	1619556840000	orphaned
26445	3NKpKS7B38hCHKQCcq32nZUxiaZYZmcxQQ6hmod15uGgx5gL1fy5	26428	3NKvrcZAmYvSMSC7gcb4tP3S4nei2FseKBtKzUY4EzaUZtWZQ2S5	684	1106	507	12463	18138	jxCSe7HqSTTha5WaWzNFnS8Dvdtd3SMUdYTpz1VGJXR9rTNPWix	13075	18404	18404	1619251920000	orphaned
26461	3NLDswjAY5RdMksty9sKzcgaafooMxNPriZ5RCKAv8jMJMusLSnX	26445	3NKpKS7B38hCHKQCcq32nZUxiaZYZmcxQQ6hmod15uGgx5gL1fy5	684	1352	507	12463	18153	jw7T9eAFBWbwmqscCvMhE9ib4ojCbYbo6Pb23E5HaTTSySDxYBu	13076	18413	18413	1619253540000	orphaned
26449	3NL6iMmavYwJrrkmkvnbrkan3xjseTVLYeMzcjTrZdCBqsdGitQB	26443	3NKTcnCaeAB1Rru4s6wv7x3MWKcRFKJggvCDuATr8BwCKNbVZ8uu	684	1106	508	12463	18141	jxXbZ3EVQPqoqK9DQeagJTBesrYMTLbcwcJDqppwcDNdfC239KF	13082	18404	18404	1619251920000	orphaned
26452	3NK9mzVP8ycsNJGHE6d2iHQmnZdBJnp1UsDhq1vET5fNa5iX5Tip	26446	3NLCfY4HxN5Uux63uakHz9uyr16LWz8cj1LReaMkxvpQ6gjbxugZ	1765	871	508	12463	18144	jx8gzKikusGYZi6Z59zSV7ViNXBWZ2NRiL5ASpCM2zDVitZkgez	13083	18405	18405	1619252100000	orphaned
26454	3NL4dAwLwZvRpQKofvAnHsh7Q69aPFDnSKHghoj7vWXh8ChJVrQS	26453	3NLqrEwEzKxuPCR64iTi1abD4Zpoq5qSafd4J5j76h42Q6qR9VKM	1637	816	508	12463	18146	jxeJGznYzLMfZXCTgteZp6kXG5GAtewrLPBNPdFdh9FaRvUPbZP	13085	18407	18407	1619252460000	orphaned
26464	3NKyRSm1CWzLCqhiyjiuUhvzPN8SQw3KQDNsNbeMmAfR45XrU97a	26462	3NKjxudFAqYX6vPhWmUyohEjDgutqbP8rVgywLUTnRC9yesmtGYh	369	1312	508	12463	18156	jxZ22Km3u1nxs5f4CrmzixyW851DkNyxYu8c1Se2TqTvpZUfyEX	13090	18414	18414	1619253720000	canonical
26469	3NLtYg99Hm7mtKRpuQthFAEfwJCiAA2ub89kMLEcAk7Uz5NnnxMW	26465	3NKXebYLes8GFXKhKFAydR39V6K3ZaWrXkiLzUNrcJREPR7bGHNo	1654	1214	508	12463	18161	jxA294oqhdHyhuTjP5wj3Py8pferAvHYB5nh8uJWmCVSBWMv5hN	13092	18417	18417	1619254260000	canonical
26471	3NK7q97DfZCon2d4oPjqmdScM3kNiQkVAZhFcEMWkJer9yKh8ysk	26469	3NLtYg99Hm7mtKRpuQthFAEfwJCiAA2ub89kMLEcAk7Uz5NnnxMW	1448	1185	508	12463	18163	jwqoMX98LaBwg7dEwCpiEiHKVREwKm5Rk5PjYsaMSHvTgHK45hP	13093	18418	18418	1619254440000	canonical
26478	3NLPCgdcw4HEBxMWfuxjVYhxE2yDmP3KPSwvif7qXXj4BbWgtBbK	26477	3NL6k1rKDA6smVYesKyV5VCXqudojNDZzfudDG88JXcyBKnUWJwv	1675	976	509	12463	18169	jwbRJGrfWom5gvYG1kLpKeRGETr2KREtRCG2or8MLEYHtB5e1hM	13097	18423	18423	1619255340000	canonical
26479	3NKCrrDfEkBQNYsmkGEtpV1DUy4FNFhnPGcbQGGKKPy9Yzw434LL	26477	3NL6k1rKDA6smVYesKyV5VCXqudojNDZzfudDG88JXcyBKnUWJwv	484	1073	509	12463	18170	jxXrKkAibHT3T2f3m2wjphaXsomGHWyoww9YL8e1dsPqUfUAmgS	13097	18423	18423	1619255340000	orphaned
26481	3NLySyguphKZRaLak1569QZtHmVKWF7zmGDMGz7hHRwpYUYr4sWR	26478	3NLPCgdcw4HEBxMWfuxjVYhxE2yDmP3KPSwvif7qXXj4BbWgtBbK	1553	775	509	12463	18172	jwGbSze1B656Crr1fN8EvqWpXAMrQYbFoDtAmvkj19VEAkqoFAy	13098	18424	18424	1619255520000	orphaned
26493	3NKYiuSjS61UxC6d6bURBPYkbxbT57kXFQV6Y6uqGh1LfWvmrtpS	26491	3NK5vECBD9wD6LXqhCvB4fWvDKoTLs9HHmzqhJerm8tS5qmZ9k3w	1460	440	509	12463	18183	jwgakUwLCNNMecwgh8ZWZLnys5mvMuzG4hoy1bpqR3KFG6TephG	13105	18432	18432	1619256960000	orphaned
26498	3NLGN8h859BFyMgZB6YNVgU5Z5nauxidMQu4aaJ9W8jSKwdkdFjX	26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	1631	794	509	12463	18188	jxY6adksdEBs2DzyMZSp8aAPBGUj7xFNNLNyedncBi8EMg888iv	13107	18436	18436	1619257680000	orphaned
26501	3NL3uJdF2t7DKLKi5tFaA8K28UodpMFFQFHcmMCuD6XwonMdVyBg	26500	3NK5EiF1KDhLcDZq4vjijWrZ7ZZBkP9ZK9yZRGdBznDZFzSy2vLE	1490	1028	509	12463	18191	jxhkhw3ue9ts5t9SqvGLjqATHEXav5RMca86U1tYBemR57VNsxR	13110	18441	18441	1619258580000	canonical
26503	3NLGdtRakDofiodSSNnhUy8NXHfNZxyoqaSbKJyqPJRFhYte5cxD	26501	3NL3uJdF2t7DKLKi5tFaA8K28UodpMFFQFHcmMCuD6XwonMdVyBg	1643	933	509	12463	18193	jxwPwmmdmwmuiJhRdckv8sW4j53bUVFeYMbFNa9mGBYHNCqHUj9	13111	18442	18442	1619258760000	canonical
26508	3NLiHJRMjwYjNLttoM9Di929CyNZWihTFuiXh4yJMjKd8vDsrfKC	26507	3NLZUZqJyhwjzSnhuxgWPAYrRv6ktZR4FUduspbz9arNSv6zDwDF	1501	1114	509	12463	18198	jwXr1UotnH2ec9AtjM9aAz4HJCLXk3GDxgeFsKYmTppUWUG8bZd	13115	18446	18446	1619259480000	canonical
26513	3NLML21uYdbn1NXEbiDXcTCyVsHYHJEmK9J9Eo3Ja13XtyYyuJiv	26511	3NLxfNT7PVaGBWxZRsq1SoAi4o2vaGU1R6NoxEhvanbsfiYZM8cX	1444	1255	510	12463	18203	jx3s1UorJoCTdXxaP6Paovh3SvpQiCnyo4eUErTBCAJtV2XvGUX	13117	18451	18451	1619260380000	canonical
26516	3NLQhAKkQWZj23wpFcsSAoak5FpBFChSGmwhQXbsTz2EjePX7Ag7	26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	1406	1393	510	12463	18206	jwFrntBHUUcK6WM23BQbksNVdGEEUDw2w4gMxCWxi1we8NX6TbY	13119	18453	18453	1619260740000	orphaned
26521	3NKABPH9ZDECBDh7prC1s225rNZk4KyeNgrBakD6FtuVAsrVBDTh	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1451	926	510	12463	18211	jxir9p83ctn2jqWN4EzHZjHx7NiyD42uB8Zt7NPhhFkmfoytfNg	13121	18455	18455	1619261100000	orphaned
26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	26526	3NKxk4k8hmUms7o8sG5hPHnZoUKLRZnAp7xK2qnB3tHu9N4QxMmM	1406	1393	510	12463	18216	jwJLsc27ZjdJJLpCQZffb4aY9w9LYPdVeE2vcqSyDB5m4LRkoP5	13123	18457	18457	1619261460000	canonical
26532	3NLnXZCM1dT6AKsVecvLtncYKzjLQCfYcX3tmdBvLgYuQU3LUfbq	26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	1654	1340	510	12463	18221	jwCsMNKS6EFaU5VESLzr7pkpvaoPz3t6zJacEPrxrHR1pvEvam8	13124	18463	18463	1619262540000	orphaned
26536	3NKmqBNMXZWZauffZTjGCbQPNuWtSMJGHMNQ6bHzfaWNGjtqXsUK	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1651	1055	510	12463	18224	jwLj2woUD47TrcVEi966CKWVTFpMyUurxo4GvyifBgHkmvAVYk2	13127	18463	18463	1619262540000	orphaned
26537	3NLvsCBzYHgPNdJfiwbHijXpjoUNYdkj3dyX1UE1kp1oahhdaS6E	26533	3NK7DbdErjZG1hQs3SdkoEcMFpHS5Hmoh8bnRVJM6EQkSP7SmK5X	42	1361	510	12463	18225	jxYYr1tP2Juk8vHkH9ogmgduh1riCTP5JndZLCza1S3avigayCJ	13128	18465	18465	1619262900000	orphaned
26539	3NKvio6d9sJGxhXrWXpa64Rwg6gX3HEjESTsGoBf7dqTpHRe8PUX	26538	3NLT3BRbj9jVwoeFB5vSGxCJyRiaHp4RS9fkfQmXekVwHWD54gip	1553	776	510	12463	18227	jy3DZXRaxuwDmQANmhugvZaQsayTBi8hUZti5X16LgYHpxmqejG	13129	18466	18466	1619263080000	canonical
26545	3NLY1FXfahBGP4KV1wK6EtTUiWSkrwJWkUbmRiPJBFh7j17TU6ah	26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	1637	816	510	12463	18233	jxyWyHfDtKVXVMVdmezmaEM1MGFXoVKCnSqT8stRVXWG3ZJHkRd	13132	18471	18471	1619263980000	orphaned
26548	3NKHL3jiCBkttWm6LdAb2o57TDTHruM87xEkK6FKbkoE1niNjdVg	26546	3NL3svQunzJUNzHuLJL51W6n1ksD9gjh19UJm5fMQEE9WreND74J	1588	1266	510	12463	18235	jxJ4FmHJEFtQW9ZDgZMgz2jiyf3tHLn1gSMsUYToiepXqh7UNDT	13134	18475	18475	1619264700000	orphaned
26550	3NLJ9tLeKDoP6aWQDyS8LdgY69VEN6f236ARanErk2TrcMrvsdk1	26549	3NKu6wN3UpXJtS7mkVFdLn9Kr11atYEvU5RH6uokq5Dc5Z96rBex	80	1273	511	12463	18237	jwsNaSb4CSkdVYXCVU74Vy9PgtyuFCHKiZ9KSEHVCU194Um8QVe	13136	18477	18477	1619265060000	canonical
26574	3NKTqCWzeAPGwYJWMjrpdUhphaA5vkeVzZCUetHZ7fKuc8gojVs5	26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	1590	198	511	12463	18261	jwFk9UeM6sqcfNFfXwgcimfJ5GnZAhZfY7RoqG9Epniae8RB6Rc	13138	18493	18493	1619267940000	orphaned
26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	1407	1395	511	12463	18243	jx1QsqyjAeNBfRLk9NWdPSDDdgH52c14mbhQX3mKZT9iabhNVW4	13140	18483	18483	1619266140000	canonical
28943	3NLLRkVfQ4Laa8fSAuiE2aNfBSMTTrg5EsXMstwmsvRBKQ9jyc5P	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	641	1336	567	12463	18974	jxswi7eqhBh7mcTj8ygnGtpfAa1XXqMZBXVbx743VgRoV7ejvjX	14273	20102	20102	1619557560000	orphaned
26465	3NKXebYLes8GFXKhKFAydR39V6K3ZaWrXkiLzUNrcJREPR7bGHNo	26464	3NKyRSm1CWzLCqhiyjiuUhvzPN8SQw3KQDNsNbeMmAfR45XrU97a	1406	1393	508	12463	18157	jxEoA4sa7SnqSQ1f4QZaq7bC9BXTokQrxaugGyH1EjqDQ44k5vb	13091	18415	18415	1619253900000	canonical
26470	3NLMLaWxzm5veTvsdi2XeZizL12FHCXibhk33yCSzAYDKjxH67tQ	26465	3NKXebYLes8GFXKhKFAydR39V6K3ZaWrXkiLzUNrcJREPR7bGHNo	1407	1395	508	12463	18162	jwPgbSKQvjNq5kwJ2hg3W6RNYTp8fD8z5XGAwEozHGyo8Afp9VC	13092	18417	18417	1619254260000	orphaned
26472	3NKKY59Je5219KcAWfpfUM1YdycJmeb3ZbRN3nu7u3hZ1ezzC3wj	26469	3NLtYg99Hm7mtKRpuQthFAEfwJCiAA2ub89kMLEcAk7Uz5NnnxMW	1448	1185	508	12463	18163	jxzuBk693PMfnu46txcLJqt5upztGSQeLSyKSCC8kLbNcmCwNhp	13093	18418	18418	1619254440000	orphaned
26474	3NK46mgb3wZHekjtsyDucdYAdiicywpiUjuCk4Vth2VQ7PDfKxYG	26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	1423	559	508	12463	18165	jxrYupYb69Yr6WjRRCRtX6cQwmfzwkmiPSoVUZ1DttpGFDusKgW	13095	18421	18421	1619254980000	canonical
26475	3NL1ynKyStF41XAYFYzQYtXwNygZbcDQhWjr9Z4gzD2pQrcMwjSs	26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	1407	1395	508	12463	18166	jxPYn1ET5kokViKXXxsjwD3kzMxCdJLh7oBp5KRp4r5mxpnC9cu	13095	18421	18421	1619254980000	orphaned
26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	26478	3NLPCgdcw4HEBxMWfuxjVYhxE2yDmP3KPSwvif7qXXj4BbWgtBbK	1637	816	509	12463	18171	jwFCpfn2ycYcEPxGpkU3kuCtmmYZczZSPo7m49Vpqq5rT8sBEtk	13098	18424	18424	1619255520000	canonical
26482	3NK6cyMu1uEska6TrkamnTJcgaZ4nF4qRNHdYP2xXSDfGESYJ637	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1671	1119	509	12463	18173	jwbSw8SBe5qaL8VzcKMszWVJJ9mf8YrCcGAJX3RGv1uLMycJWgW	13099	18425	18425	1619255700000	orphaned
26487	3NKw7SE1D8MeBJLMGhh5UCBsFhYEDWrX6zcYykXgajyokZhY3cnr	26486	3NKbehCTHtbBkcu1wrFHEWgeMopP5aN4FTmSNUynUdTzxDtEtXLJ	311	1181	509	12463	18177	jxMKP1YAsuQebzGRUYXB6DRvBMhYet2jV77ViJcGLdrJz9bChUW	13101	18427	18427	1619256060000	canonical
26490	3NKnVcMcNCZx1ZjwnWVFW4okdhS1fBdf2JhE2aJf5nTJJ4BaYSLa	26488	3NKasExo3TaTiUT5AoN7MAxhUiDq4igvg79fH8ztfixvkb7pEPCB	1397	828	509	12463	18180	jwPvjL48boGC13EsHmAhV27e7cmDLNujM4emQR158EEvq4aNdwV	13103	18430	18430	1619256600000	canonical
26492	3NKF5ce3C9DTF4XR8cMvKsMhiJPHcPXLo21RuVSK6E5ot342J4oe	26491	3NK5vECBD9wD6LXqhCvB4fWvDKoTLs9HHmzqhJerm8tS5qmZ9k3w	1406	1393	509	12463	18182	jwb9sJ5MENZBExFpbmRBYYBtKNzQZG183NhTvh67uNQVUyNYCnB	13105	18432	18432	1619256960000	canonical
26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	26492	3NKF5ce3C9DTF4XR8cMvKsMhiJPHcPXLo21RuVSK6E5ot342J4oe	1407	1395	509	12463	18185	jwtZxnQcKb6PJ9grn3EJQd4Dc3RBFUgyq7QptT3kaDbwYt8hes2	13106	18435	18435	1619257500000	canonical
26497	3NLw9J3FUb8uBE8URyT6Foj9vdoykewce6B3aAhbKJRdc4oFw42v	26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	1627	1385	509	12463	18187	jwNnKqqvySzZ9oaATGH4yBpbX8z7z4vWZgBS7dCdCuz7Qmi6jXx	13107	18436	18436	1619257680000	canonical
26500	3NK5EiF1KDhLcDZq4vjijWrZ7ZZBkP9ZK9yZRGdBznDZFzSy2vLE	26499	3NLJCCcu59nAjYDpjWzFcMhdLUCXDr4aSFtgjErYGEBRmv4Vn6zH	1406	1393	509	12463	18190	jxu7DvzivC1DhMjjVJHRDRxQ7zKuix2injZy9NBL3xxS79iHLMf	13109	18439	18439	1619258220000	canonical
26505	3NKW3MqB9Tf4cYZqazRZ8zx2XLpwk1Nkuqk4akttaUXQeSykF1Rb	26503	3NLGdtRakDofiodSSNnhUy8NXHfNZxyoqaSbKJyqPJRFhYte5cxD	1474	1203	509	12463	18195	jxJRTvY3kwGGxfVe6SWpsWk9mCNVqqQNhU15pBmbJcURjZLT6as	13112	18443	18443	1619258940000	canonical
26511	3NLxfNT7PVaGBWxZRsq1SoAi4o2vaGU1R6NoxEhvanbsfiYZM8cX	26508	3NLiHJRMjwYjNLttoM9Di929CyNZWihTFuiXh4yJMjKd8vDsrfKC	1581	778	509	12463	18201	jwVMictsnXmjAW8TmfghrbxHKVn1gtsLSduFg7tX4R5dV4Wnv8T	13116	18449	18449	1619260020000	canonical
26520	3NKHsgEfiCBP2NBBccHtDDjPQGJFrWo8Pjreny8wwgWrXDRpyaSF	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1458	957	510	12463	18210	jxCHWkoFizxckDKGbuTUZuSsPE1sCf38FfZTeYmeKrZVCYTSphM	13121	18455	18455	1619261100000	canonical
26524	3NLqxBrJc1trjHchnDRgiQH7KNrXfiuJGJhek91UtJm7NbNpPuCk	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1637	816	510	12463	18213	jxTiTYgvJJLq8uqzdfhdbMQG5uS49XHCgYeYvJUeqM16rzFZF1p	13121	18455	18455	1619261100000	orphaned
26526	3NKxk4k8hmUms7o8sG5hPHnZoUKLRZnAp7xK2qnB3tHu9N4QxMmM	26520	3NKHsgEfiCBP2NBBccHtDDjPQGJFrWo8Pjreny8wwgWrXDRpyaSF	1602	1369	510	12463	18215	jxwoeow7sXWC43HqdVDFMjXw4pWxXtWTNoenGyjxfo7baF7AvFE	13122	18456	18456	1619261280000	canonical
26529	3NKdAYLWg53GLnybrGcCDt53s2npWuMLkPWijRZXNptT8MEiFum9	26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	1507	1034	510	12463	18218	jwSbVQov1KEWgad6RbHSkUDWMKopKv3ubMYYEo1WZdu4GceqjHY	13124	18458	18458	1619261640000	orphaned
26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	26530	3NL3BwdsQGzewx38A7bY2dKBNQ4b71M3TjNwTshvKWxJMHEVnwMA	1585	1120	510	12463	18220	jxt7PHNYZurYCdkm4SxuQnqVrWqKjv4CagWCthQEJiKCyC4UMTt	13126	18460	18460	1619262000000	canonical
26535	3NKKbNx5QqS5p4WYnYe4M9x953x3e7cYfBZKB3L4cZX2WP5wjX99	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1651	1055	510	12463	18224	jxWtQsAKXq61fLJVsAk3Gu2hAYj5vGfGYuNWe72wjsS4hjEQ8jN	13127	18463	18463	1619262540000	orphaned
26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	26540	3NLKAno8MTkHEjyT2CJDrzDMxfsvBTxPz4QRauMokTVu2EdZk2CU	1581	778	510	12463	18230	jwAu1FPne6tLiMw3Wq9nZX3XGKC9NwRou4au2G1E4cLwxRbMeGT	13131	18470	18470	1619263800000	canonical
26547	3NL4Vmt22P4MFGisfgp6hG3vpyQcuYSKpSzefNx67HZGSwqRMswi	26546	3NL3svQunzJUNzHuLJL51W6n1ksD9gjh19UJm5fMQEE9WreND74J	1588	1266	510	12463	18235	jxJ4FmHJEFtQW9ZDgZMgz2jiyf3tHLn1gSMsUYToiepXqh7UNDT	13134	18475	18475	1619264700000	canonical
26549	3NKu6wN3UpXJtS7mkVFdLn9Kr11atYEvU5RH6uokq5Dc5Z96rBex	26547	3NL4Vmt22P4MFGisfgp6hG3vpyQcuYSKpSzefNx67HZGSwqRMswi	1403	824	511	12463	18236	jxz2ngJgaJiksWTXGsoF8SfeaAgvz2Lp2MWUfwJnBpoP9ciswgT	13135	18476	18476	1619264880000	canonical
26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	26550	3NLJ9tLeKDoP6aWQDyS8LdgY69VEN6f236ARanErk2TrcMrvsdk1	1471	1386	511	12463	18239	jy1gTFM1VyLBJ3jeC6zJwgKSMHi4DHEAi6MbHG1Ap1y2FGEtFeC	13137	18478	18478	1619265240000	canonical
26555	3NKj2ATean9LwBtpL8dMmsGG6HFuW7T6AH7qLyyuDenWFeEtdS2o	26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	1656	977	511	12463	18242	jwXbreqvAuKRfH6TGDgKdkqrebVVyEVofNNS4jkmxvfuYeCwiJc	13140	18483	18483	1619266140000	orphaned
26560	3NLPb9YXDZautFyNWRxxWiAfKc6tZDLLdDukrcs3MGWYgr8wtEwN	26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	1406	1393	511	12463	18247	jxxVQhqQEzRdCy8bCAzrWgjSmQRzZotx4wQDc12P13baR1AbMHH	13141	18484	18484	1619266320000	orphaned
26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	26565	3NLCzvue3QFykM2SZ3nkkjxAJTF7PXGmV2KNuv1pGBBQDQBVmFsp	1403	31	511	12463	18253	jw9RTxqbuc6Pg8k7kuNZxyuRJggx5xNiMFft5bPFvLCWGg8YGSy	13145	18488	18488	1619267040000	canonical
26576	3NLiXmZFpe3J4RYn7iqvoDJoZJBnhX4BrGJPLfjXcqkLqgY8csPJ	26575	3NKb7aBzYYhS5fq3QMsVEzR6APJLkPE944XeZz4AuLSstPiKBwHC	1622	1356	511	12463	18263	jxcVKTRSi8Zoqy53KTypJ9zpo4L2xQxxQwp8cmHsXHijZNzKCZq	13150	18496	18496	1619268480000	canonical
28983	3NLcBPNH27JTsZE3VAXuAsVcnqyydcj53ZAngpofQ56aP7PeNsFP	28980	3NLcNySYzp2oFsFuuRxeSMisVbjeKbFTAugaRepDue6pEy79JZty	1407	1395	567	12463	18974	jxetXKmao3vJkyAw3cyp5SsEbVCChcHm2mRS9sJDN72siZecZDm	14292	20127	20127	1619562060000	orphaned
26509	3NKgnT8eZ5uaa6xytyNdNZSuosHoa1bew95V4X5cDZWEUzJJxoqV	26494	3NLbk6vnEQEaBgk5kSoFngC99uavwBgXbW7Ux8Eptw7PxjKmnms7	1648	1038	508	12463	18199	jwbj7cyNzuXfWnGe9Rs7EAp72PMCBBsMygjsiecSe1kKEKbqHMq	13061	18446	18446	1619259480000	orphaned
26580	3NK5yWc6P1iLuEoepqymQMmpDmULbjy8FsQCcXSQW4LXTZ8oVGkp	26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	621	621	507	12463	18267	jwkk1NuAJwaFup8UQ1kwSimeZeYKfXbPiBXb7FzS4EjRWPacZQN	13078	18499	18499	1619269020000	orphaned
26488	3NKasExo3TaTiUT5AoN7MAxhUiDq4igvg79fH8ztfixvkb7pEPCB	26487	3NKw7SE1D8MeBJLMGhh5UCBsFhYEDWrX6zcYykXgajyokZhY3cnr	1407	1395	509	12463	18178	jxt9tFBrxPD3mXzb9BPiZe1BjvMpLpY6NyoBLFSUQ4ikase34Bq	13102	18428	18428	1619256240000	canonical
26489	3NKUkWhcmphQXcUnBBJxGcs4tgUyrrJHSdeqeRDSDBpSndLCTL2m	26488	3NKasExo3TaTiUT5AoN7MAxhUiDq4igvg79fH8ztfixvkb7pEPCB	1406	1393	509	12463	18179	jwDy6Kz6rmhf6kXDigBv5a7Xw7VwTqxhS9JqyS3w123Zts6ZRBr	13103	18430	18430	1619256600000	orphaned
26491	3NK5vECBD9wD6LXqhCvB4fWvDKoTLs9HHmzqhJerm8tS5qmZ9k3w	26490	3NKnVcMcNCZx1ZjwnWVFW4okdhS1fBdf2JhE2aJf5nTJJ4BaYSLa	1407	1395	509	12463	18181	jw6ek2LVgE2iYNqZ2aK1MNrwX7E7dSwvwTaxpiwHSZg1j4PwaXy	13104	18431	18431	1619256780000	canonical
26496	3NKTTQRPmsKFr7cdDxXg8Nww1pnrRrf71GugNB9o6gd28VioAriy	26495	3NKtTK6xrLajquRMaNDhMVDZhxF5MYuQWdGykgyhQFnD8pyft8Ki	1549	996	509	12463	18186	jwgJHbwmzNHRQAvqusGmAB754khnkEUjQ8fEn8X7g6apyC64S9W	13107	18436	18436	1619257680000	orphaned
26499	3NLJCCcu59nAjYDpjWzFcMhdLUCXDr4aSFtgjErYGEBRmv4Vn6zH	26497	3NLw9J3FUb8uBE8URyT6Foj9vdoykewce6B3aAhbKJRdc4oFw42v	1476	1371	509	12463	18189	jxRJjDij4uVRDfS96XSfcJsuBC6mNHA7UNr85nS5nzkHuJ7Mvkg	13108	18438	18438	1619258040000	canonical
26502	3NL5JTDuV3BZm4NydmfdkLYZD2ynUjyX25oR8MP2mFo2EPv1osq6	26500	3NK5EiF1KDhLcDZq4vjijWrZ7ZZBkP9ZK9yZRGdBznDZFzSy2vLE	1634	1085	509	12463	18192	jwryowSUG6urL5koXi7riuKKLzs1qCzQHGc3zLkrLiqJmLmdGEc	13110	18441	18441	1619258580000	orphaned
26506	3NK45hK5PkVUwQLLyrnnhYMFWV1BVB15r7t5rXtn4UuzUF9JENiJ	26505	3NKW3MqB9Tf4cYZqazRZ8zx2XLpwk1Nkuqk4akttaUXQeSykF1Rb	1508	1141	509	12463	18196	jwE7bBGGb4F9fbUHNaSidtwApDi3VHwE24iPGbkPFxt4x1hWm6e	13113	18444	18444	1619259120000	canonical
26507	3NLZUZqJyhwjzSnhuxgWPAYrRv6ktZR4FUduspbz9arNSv6zDwDF	26506	3NK45hK5PkVUwQLLyrnnhYMFWV1BVB15r7t5rXtn4UuzUF9JENiJ	1483	894	509	12463	18197	jx3xQPhDdqcy6bSwht6ezt7gXbGPWQsWLJQhkACDw1AkziYZmt4	13114	18445	18445	1619259300000	canonical
26510	3NKPh15AFjhbhVgsAz3M4kZxqqTAxYqrXJc4STJEqHenH3deZjy8	26508	3NLiHJRMjwYjNLttoM9Di929CyNZWihTFuiXh4yJMjKd8vDsrfKC	1613	1349	509	12463	18200	jxp2cmhz1sMz94fnjjgSgxwAZVeS7vynTj9Nu5ECmuiufCdiBhV	13116	18449	18449	1619260020000	orphaned
26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	26513	3NLML21uYdbn1NXEbiDXcTCyVsHYHJEmK9J9Eo3Ja13XtyYyuJiv	1467	1010	510	12463	18204	jxipSLZkBdjDianVFTjdPQJiJFKXcZjAMh4Wi1rnpcFggxvJAs2	13118	18452	18452	1619260560000	canonical
26517	3NKCZLHviHy4G5LW6a6HsSnpjVJzG3epsrjWvfiLzk6xs6D9TD23	26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	1581	778	510	12463	18207	jx7euHNT71BBF4nTbXik24u8yzpuAwrtsyNzTrNWVfp7YNZLrSg	13119	18453	18453	1619260740000	orphaned
26522	3NLcNoBytQN1qabcb9Yfmx49iCwYqYyEddSAE8e7u6DA6oqZx715	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1529	1190	510	12463	18212	jwiERm92vFzH5SqY7w1kyE4ZDJdjP1isKJVT3shGzeGDVnbaS7t	13121	18455	18455	1619261100000	orphaned
26530	3NL3BwdsQGzewx38A7bY2dKBNQ4b71M3TjNwTshvKWxJMHEVnwMA	26528	3NKs3tEN5wLP7zTHwcGTv2ugkJu1SV1RksGik8FFPJoLKqtmBMSx	1483	520	510	12463	18219	jwgCUrhSZ77UgnjYpM35Uj6TBhyABAnZmCBbG1jWBMZM2FA1w5L	13125	18459	18459	1619261820000	canonical
26533	3NK7DbdErjZG1hQs3SdkoEcMFpHS5Hmoh8bnRVJM6EQkSP7SmK5X	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1654	1340	510	12463	18222	jxxcD4BUTKJw5F5c9r5SQG56i1e76qMTZdedP3N5KxCa714XpMo	13127	18463	18463	1619262540000	canonical
26538	3NLT3BRbj9jVwoeFB5vSGxCJyRiaHp4RS9fkfQmXekVwHWD54gip	26533	3NK7DbdErjZG1hQs3SdkoEcMFpHS5Hmoh8bnRVJM6EQkSP7SmK5X	1406	1393	510	12463	18226	jwQfZAVnqBdGKWA8ecG95YBovyg6VEE71LcRnEr4439p4j59cit	13128	18465	18465	1619262900000	canonical
26540	3NLKAno8MTkHEjyT2CJDrzDMxfsvBTxPz4QRauMokTVu2EdZk2CU	26539	3NKvio6d9sJGxhXrWXpa64Rwg6gX3HEjESTsGoBf7dqTpHRe8PUX	1588	1146	510	12463	18228	jxasagDVCPe8n8mkog6o97EAMB1jFQKDdg1qhyYCEYASUHpoQDp	13130	18468	18468	1619263440000	canonical
26543	3NKgNw6tBFKWMnZ8hh4bsapnyGWwopvht4NCypVjfEwa1cQ6LPkv	26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	1501	1114	510	12463	18231	jx8GpBG8wHNRmxeJwYTjaBUpoFeya28vQzjz6jCvp8e9xfgTr5T	13132	18471	18471	1619263980000	orphaned
26553	3NKZFes7rG3vunMssCp1HAHxtvka5NhMYCNhtsTagXkUHH9yUsxq	26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	1405	873	511	12463	18240	jxQRVshDzZmXjDtPswTXKPYYEi9fFMcpeUuvATTVBXBteT2F1Pe	13138	18480	18480	1619265600000	canonical
26558	3NKSnxZzs7kpvG9qU8PUKtNAHHoDjXE4WNGhjHxEYj1wU7kqMZnB	26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	1672	1285	511	12463	18245	jxoWSrqNo9LzjYZpj8Rs2YpdotQ4ez6uA5LKEpSCS74z8ekMJoM	13141	18484	18484	1619266320000	canonical
26567	3NKe517uga5Jz1aK5UiKJE5VT7gEs5VTR1K2QdeJzP8VaYw1YGSd	26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	1589	1040	511	12463	18254	jwaxZLcV8jK3LR863qNoKmzig9i4L9mesT4vtGjALGbyniiU9KR	13146	18489	18489	1619267220000	canonical
26568	3NLJopwp6JYw2VzPancCkqLzxVQhe7qFDY5H8uHCqRCCpqLgP8Ty	26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	1637	816	511	12463	18255	jxTsE3U8Ybx4T1fnPwLJTMt2HZ8Qo2WC77v3UDaCf3jUHHsaWVM	13146	18489	18489	1619267220000	orphaned
26570	3NL8teiQrx5KoaxPh1N7Wu1WiW3rMkK9Dvz6DsWpVHT8veY2nkAq	26567	3NKe517uga5Jz1aK5UiKJE5VT7gEs5VTR1K2QdeJzP8VaYw1YGSd	1500	1171	511	12463	18257	jxmxnjLYmKo2JiBn8DvXpzgpaTAGfde7QnsSyfdGLhCCAZ2tWCh	13147	18491	18491	1619267580000	orphaned
26572	3NKS42HLCyCJyMDiNc8KMHcQB4mcrVQu9cjADXD8WH94N8pGLZiZ	26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	1406	1393	511	12463	18259	jwJgcGwKYKdXJFtwatRanVpX4ZAEKJGjYm6vWaeNdNgQgEP3L3H	13148	18492	18492	1619267760000	orphaned
26575	3NKb7aBzYYhS5fq3QMsVEzR6APJLkPE944XeZz4AuLSstPiKBwHC	26573	3NK7Xd4DWnULgH93KonMNJ7j932foqVUhnSGB7vADwemfJJAtHeb	1590	198	511	12463	18262	jxcBk9NfCBLFPc4WBAQvNBDZVJQRGKUfoyFusVzxVTsxZooTqqh	13149	18493	18493	1619267940000	canonical
26583	3NLEXgkqWvuooBpQUREh8GoxmuD8yfrLvwgXYXi3ywk98RMn5YoK	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	1426	1364	511	12463	18269	jwuGtHU6kDrNz42TnD1kwuTH7Fqu1Z46sR4JqAHAq9in9onXCCq	13153	18501	18501	1619269380000	orphaned
26585	3NKKkZArgD5jYvvxehmp9t4bwRXJ1RWxHBEWT4NSbXyv2UymPj74	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	684	1106	511	12463	18268	jxcCok7W93v8j8PfpWwGtCkg9JQVH5rgWHudLCdvts5t6jBRJAW	13153	18501	18501	1619269380000	orphaned
26587	3NLTjVibjXn531PLJBGMsJbQMr5HzJ6AeKA9RV92UVk2aixuh7oM	26584	3NLgikXRjZVebUfzK1Yv7WE8HE429eScesxuhykb1ezqE3a2xAqV	1406	1393	512	12463	18270	jxNC7mnhYZCxqfFsz8EzSpPH65jxDndvMgNSpHjTKBPhanHrs7X	13154	18503	18503	1619269740000	orphaned
28985	3NLxi1yEDGE2kUVmE19Hbo7SS3HeA3A34z5w7LZkF2LMxXyXYKwJ	28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	1471	1140	567	12463	18974	jweVDgzqTESgVakzgGiiVv5TYTXBJ7TyLfEaFgMkd39X1PeSeto	14293	20128	20128	1619562240000	orphaned
26515	3NKQo4b9cgofw9n7heghHucoaUTzSB5N18hh7CEkngtj9Rdw5crg	26513	3NLML21uYdbn1NXEbiDXcTCyVsHYHJEmK9J9Eo3Ja13XtyYyuJiv	1553	776	510	12463	18205	jxUFxynpMm1mERCvUZQCDdzwgLSfgZMLer2FzKQHXvVdxuu56eV	13118	18452	18452	1619260560000	orphaned
26518	3NLTCc89cic43MixgUh5JiioLdjAoYDwCy33AuMz9Dt8NDe1Juv9	26514	3NKLYRSER4aj4eZZUkBXXLsK8GoSck3VbAwz15WaNwUoEuQJAdtE	1508	1387	510	12463	18208	jwf6z5TV8dfvnViC9ADR5ryeuGQbfxjzZjav5JXsSivsuZEJ54M	13119	18453	18453	1619260740000	canonical
26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	26518	3NLTCc89cic43MixgUh5JiioLdjAoYDwCy33AuMz9Dt8NDe1Juv9	1406	1393	510	12463	18209	jxCtqAkmEn4accf5Q34tBJ1RxbYq9JGEd7W4XjFKdb5jPgGDA8Y	13120	18454	18454	1619260920000	canonical
26523	3NKfGWZCWQYEf5BVDANN9UYXdyekiLFhx1soBKwSxszANk4B8fac	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1529	1190	510	12463	18212	jxGPVcmYW9cN4rNYuz3PhZDk6dyW1S9ZW9MxmHV5uHy6K1pYk52	13121	18455	18455	1619261100000	orphaned
26528	3NKs3tEN5wLP7zTHwcGTv2ugkJu1SV1RksGik8FFPJoLKqtmBMSx	26527	3NKMwwUvA6XxM899ikSZoDcDwNz5FqTXXkW9tJumFBEo3NDFyQ17	1565	142	510	12463	18217	jxQBKh8TYLzCuUGsKYXsn4CcerjmwKpjBxzj9Lz6DjcZz6PQZDx	13124	18458	18458	1619261640000	canonical
26534	3NKmt3s45fwxKwaTWyRGJKG74tu2wohkFgjsp9dDsnxotKLNVxjp	26531	3NLHEBfvy1kng58XR2WJCPp3zZJNueLfYoQMBF5BqKDJ4tAq4ZLz	1403	782	510	12463	18223	jxvCBjqYauM9ocDtj83nWUsyMvEuYkMyrwrSQrmgySX9HaLCt6g	13127	18463	18463	1619262540000	orphaned
26541	3NLfyLKrrsKUzMLgPS3266ffs5XCBcoPPDbFXyUGadsqPoRgt9hu	26540	3NLKAno8MTkHEjyT2CJDrzDMxfsvBTxPz4QRauMokTVu2EdZk2CU	1637	816	510	12463	18229	jxbo4vzQExQHJ3Cu13HjGasE2JpAVH9dmygAZJ5QDyhekQa73xZ	13131	18470	18470	1619263800000	orphaned
26544	3NLj1c3Bx9LNfnh2RqxQyGLP9dNAmXdnV21qSiePcwQV4wphNVcJ	26542	3NLMRK4VypgATdbpqhTVsw7pDUoMBQdL2BG5bzbFd8TyncFLrBxe	1587	1111	510	12463	18232	jxK1dUiPA74BWExKaKiXNA5S4FJBjvRod7giyDUf2J5cj5MNFhw	13132	18471	18471	1619263980000	canonical
26551	3NLPSuEwJxrggsBYnjPGwbKygvNcLW1ZqkFBqFv1cPypytjNUmPt	26550	3NLJ9tLeKDoP6aWQDyS8LdgY69VEN6f236ARanErk2TrcMrvsdk1	576	1229	511	12463	18238	jxJZxRt3dP2b36D3b4BsobqEfuF5FQC2QJa6rgMKC4V4wdvFRxd	13137	18478	18478	1619265240000	orphaned
26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	26553	3NKZFes7rG3vunMssCp1HAHxtvka5NhMYCNhtsTagXkUHH9yUsxq	1637	816	511	12463	18241	jwqtmAj7EmXtPaRk1gHeuZ2LR1ngcfLYpFS4TjSEK9JpFWEiV12	13139	18482	18482	1619265960000	canonical
26557	3NLTT7pNMnaGPpBwWsqUxQryhKjKEAZirF2XnFh5vrJVjhcZyGEj	26554	3NKPPfsrw7HoHNbfHAD6qfgvSWZeSCHHbXsayzfjDWegCCfN2VSD	1581	778	511	12463	18244	jwb7otmnbxKCvTa1QoaWySpQJnuWPuXiSJE6Uhy3QanHruRTqDy	13140	18483	18483	1619266140000	orphaned
26559	3NLvbhQvtYFA7iZ15i3SvKiVk5knqcgfJqTXRwChhgQabYEDbr44	26556	3NLK8zS7NG1S4HEBPFuUzsw35bt4LfTLxM3iHjP7ouRJmTSaVnV3	1587	1357	511	12463	18246	jwDDGJwfjoyFnihMrNgCeuSywop6Em5xfLThbMrTMkwoNvYWMLs	13141	18484	18484	1619266320000	orphaned
26561	3NKRvHnG43eSV1Epy8wzULTtbKuxUT757RdWiubeJLmss4egHrtT	26558	3NKSnxZzs7kpvG9qU8PUKtNAHHoDjXE4WNGhjHxEYj1wU7kqMZnB	1596	1363	511	12463	18248	jwt1RESRAVUkKByQfRTPsCZiGZ86XKLsCdnnxSGBcJXpuDNwpUc	13142	18485	18485	1619266500000	canonical
26563	3NL8zv7fNYoeA4oyznAgVJJtdJaM4MtTfXbuzNTKGNQq63iSK6Fj	26561	3NKRvHnG43eSV1Epy8wzULTtbKuxUT757RdWiubeJLmss4egHrtT	1652	1315	511	12463	18250	jxz3N6ncRRDGxXo1ZfhQhJ222itTNoBnVWbLAaP1CmssvdPuoPh	13143	18486	18486	1619266680000	orphaned
26565	3NLCzvue3QFykM2SZ3nkkjxAJTF7PXGmV2KNuv1pGBBQDQBVmFsp	26562	3NKEWamVwbHfXUAMVnwy4wFXwx8EXmfZGbphLJtc2Yw8CZBPVrUR	1673	1242	511	12463	18252	jxCs9NHgJvvLSEGsHunfwkqjAMgYsz1MKo8ZmWYunPMdVCDxdSM	13144	18487	18487	1619266860000	canonical
26569	3NKr67AcEFn7LJaHERxCPx3P6TDCwdgME3ddhyJiFLgo8GotNV1W	26566	3NL8a6rNDKY69hu4EEzRYqHqHW3eWMsWgfRjdVM4AYtBkbXCg7LW	1613	1349	511	12463	18256	jxtJNeinyeF8PYq5LMLSdTYbAJayeDDVJEtrrDvboNT3StuBs6b	13146	18489	18489	1619267220000	orphaned
26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	26567	3NKe517uga5Jz1aK5UiKJE5VT7gEs5VTR1K2QdeJzP8VaYw1YGSd	1637	816	511	12463	18258	jxoEvDckfgKaxp2tPQfxfJeHtiQWaSU8aiDBPW9HYmNtLT8rscj	13147	18491	18491	1619267580000	canonical
26573	3NK7Xd4DWnULgH93KonMNJ7j932foqVUhnSGB7vADwemfJJAtHeb	26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	149	1283	511	12463	18260	jxB76owEDqScTR1qopXypjew5P35vHBpBkygk6Pu7vL1NBmve12	13148	18492	18492	1619267760000	canonical
26577	3NLNDaxjQtyXAYuDZjNc8BtVunq4bSZTDsYWzTPoCqT9SCdEr2oG	26575	3NKb7aBzYYhS5fq3QMsVEzR6APJLkPE944XeZz4AuLSstPiKBwHC	1406	1393	511	12463	18264	jxyD21Tc1mdLEjHaAziMk4G2UTdjs5qyy8g8XCL5ztQFGSjLxeY	13150	18496	18496	1619268480000	orphaned
26578	3NLnCzzhWRF6Z4kdKKr9v6jCBd3dyWN9D6d91PKUdNZEjwS5hAkY	26576	3NLiXmZFpe3J4RYn7iqvoDJoZJBnhX4BrGJPLfjXcqkLqgY8csPJ	1509	1074	511	12463	18265	jxfnHafLXjdCJBjStgymNdicZhoRzzv6EYjiSPguVFb7wKwvj9H	13151	18497	18497	1619268660000	canonical
26581	3NLshQoXQMwgmSd3gdJ3coYMhNmFAbhPxgUBm816CkFsyqXwcc78	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	684	1106	511	12463	18268	jxsUBedUSAdndXGz5vrUCT3XyzgqFWqpHcMa12TrKEnVwVaGKvU	13153	18501	18501	1619269380000	orphaned
26588	3NK6u58DrbZYwYNzggKFuVsgU7Y5jeqjvJxZrm592ATiJ5vaAkAg	26584	3NLgikXRjZVebUfzK1Yv7WE8HE429eScesxuhykb1ezqE3a2xAqV	1405	849	512	12463	18271	jxE5mpsntyTVJmaMTmnWmNWKhZEifbXtyTof3DnLXV8Vot8Vvh9	13154	18503	18503	1619269740000	canonical
26591	3NLV6aNRvVkaLxUUPXAqmNcWFKp2y3rzKtJpfxKsn3JEWKTCEQHh	26590	3NKxGZkxvDvgMCmRMhhtdLBLLkMuaduhZ3tU2v2rJ6aiN1YfbuWr	1406	1393	512	12463	18274	jwFhRaVRZM59m9yLmenWtZeZrfLXiDwrxibJPy86UMQGcDK821k	13156	18506	18506	1619270280000	canonical
26595	3NKudnK9q8AW8dA1MrfqRfFRyo7583zaNPuhK9r4H9pcZcvpX4pC	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1607	982	512	12463	18276	jwa8L2sqjoCH3fNxdQNuFeXuyqxezGdVAcgaevwkaAyRhmir8nQ	13158	18509	18509	1619270820000	canonical
26593	3NKKUzMg94MXPXxzoc5vxCXKTpxAWPz6snC9GF3XMaMt3GCLuDpd	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1607	982	512	12463	18276	jwhpfx2gKY61bFBJ2DjgcyATiAS4sdb5bGH24MQMN6XA3XRqUz1	13158	18509	18509	1619270820000	orphaned
26598	3NLBi1mFEeUSo5kgF51hDDRzuZx57Ua6t3b6K9X1T6HyMaohJDGb	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1541	1298	512	12463	18277	jxgd4hYzekWGyX4JPZY5whWYrJzvS9TBDnDRYkfDFXmzudu6RzM	13158	18509	18509	1619270820000	orphaned
26599	3NKs13q56gMEYb4n2pMBgYbnkfUw4GDSr7PveNfasFtDKLXTPPP2	26595	3NKudnK9q8AW8dA1MrfqRfFRyo7583zaNPuhK9r4H9pcZcvpX4pC	1406	1393	512	12463	18279	jwVWBGxV19N3X2YEQJoZW7RScgyDARCKPnqZMoHd6nzaYwpzmor	13159	18510	18510	1619271000000	canonical
26603	3NKD1URM93TiqHyJugbYPvcCLfGvp7qURLSeodjgktDxifPWLKru	26601	3NLZj7zfjQdi1HSrJnK3D65VQr7okvpKKHJz7ZcQM8rtNgH5SupE	1406	1393	512	12463	18283	jxYGLZ2cp9duyZL4hvNyFougmM3yUTrq34bhkUwrPPav9P1kV39	13161	18513	18513	1619271540000	canonical
26606	3NLSp2Jk3ZLsCxEunB6TAX8NUyY8qNrmMgR53d4etRCMdAm18idi	26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	1634	1085	512	12463	18286	jxQQP66YVg9LaPKZ2rvQmhqcSV9crtBfww3gEMR83HorHUpdZXS	13163	18517	18517	1619272260000	canonical
28997	3NLuPm9MAWmsLhzH4AJMC66FFRRuuUfwQPUcaEZCYqC1t4XSRZnB	28994	3NKrEQ4tDJ1m4DcvMGF48KjcEb9JHfeuLbUXpgkY2bSYvtJmi1c9	1646	1354	568	12463	18974	jxb1NyaSbg5zAJmetZG8ELVPAoq4mVF9CERPFwraAtbMmxGWJXk	14296	20131	20131	1619562780000	orphaned
26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	26578	3NLnCzzhWRF6Z4kdKKr9v6jCBd3dyWN9D6d91PKUdNZEjwS5hAkY	621	621	511	12463	18266	jwc5zcMQYMz1aLehwwYvdGr3dmAgVp2BMwBqywDTXuxwsy8MnGR	13152	18499	18499	1619269020000	canonical
26584	3NLgikXRjZVebUfzK1Yv7WE8HE429eScesxuhykb1ezqE3a2xAqV	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	1426	1364	511	12463	18269	jwuGtHU6kDrNz42TnD1kwuTH7Fqu1Z46sR4JqAHAq9in9onXCCq	13153	18501	18501	1619269380000	canonical
26586	3NLnTk9gCT9nf5GLxzhC4u9wy1Wb3Xk9gQU5inNQvryfjJAFm4AM	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	684	1106	511	12463	18268	jwSizsg5JaG171U6hdFhddsJphgTYNaVJRGk57YEAKw94JFMxHe	13153	18501	18501	1619269380000	orphaned
26590	3NKxGZkxvDvgMCmRMhhtdLBLLkMuaduhZ3tU2v2rJ6aiN1YfbuWr	26588	3NK6u58DrbZYwYNzggKFuVsgU7Y5jeqjvJxZrm592ATiJ5vaAkAg	1507	1280	512	12463	18273	jx7Xjxg9R8P1uBBhjrgaPQt3YfWoKrNshkTy4Hfc7ubKLQkBxra	13155	18504	18504	1619269920000	canonical
26594	3NKCaEqJCRWxFYVRCtxdJaXqNZuYqgfgdxbQ7Eq34QEQipSiafUZ	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1541	1298	512	12463	18277	jwFfStT1UJ4YjCq7yRn5pf5QLLQZzqQeqUW148aSmrQX33U7Vbb	13158	18509	18509	1619270820000	orphaned
26600	3NLhzjVqgKEWLMYiBAsytq6jdpzeYFv2ZhcXN98Rv8JH2o7mvrj7	26595	3NKudnK9q8AW8dA1MrfqRfFRyo7583zaNPuhK9r4H9pcZcvpX4pC	484	1319	512	12463	18280	jxSFH7BFatq2P6Jx1UxtcfwcXEXifBhV4fJ1tZ9uarrijeTX3Hg	13159	18510	18510	1619271000000	orphaned
26609	3NLTMH4ZnJUv3QbdeZjYM1sPX3ikGzJRinMYmBQWpL87jnm75Zvh	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1406	1393	512	12463	18289	jwyFw76qVxb92MwWv9DSHDmuBYemyvPqg4coqgoS7gLVX2vpAKS	13165	18519	18519	1619272620000	orphaned
26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	26612	3NKQjRmQ4E5yyfZfBXjjffWHogVczJiwLJKmRwFk82C98vqC6eFR	1649	1383	512	12463	18293	jxXiqZSepM4AGoChdKdEJkdXkKLRXS6p4cxKm9oPVbSwhtucdhG	13167	18522	18522	1619273160000	canonical
26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1619	909	512	12463	18297	jw6upHEnSqQYEHN7DPDEuVArRV5uo1yfVnNNRjUA3eSjjqjSfQb	13168	18525	18525	1619273700000	canonical
26614	3NKGbsCyGiy3F9QAfSmQKn8YhxsZ2gjAPmM8Njxx1S9p19GmnTkM	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1529	1316	512	12463	18294	jxVitdSXAD1gij8PiMrfkv3TLVZdxswiSNdeCnbVdRK8mhXM4t1	13168	18525	18525	1619273700000	orphaned
26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	26625	3NLjhni18oHacg2H5iwhLFKXZ4H14m7jDYFM2HvA6TLF5mq8ZmoR	44	1199	513	12463	18304	jxqj5eoj2TVuZgBCHtzZm7JVmnBXdPhijXt9H5zkQ8mqj6tBVJE	13172	18533	18533	1619275140000	canonical
26631	3NLEK9G1bKJgA7ef7Tks8Dy2YQ8izBscZED3qEYv317WPLBcPJUv	26630	3NKhr2qAZy6roj8PMKosmCsQkpYK15j5b34zLSwErqsFhS8F1pef	1406	1393	513	12463	18309	jwknvsoz5iVcQZstZQhvcVjmp5NJaHYW3Kw3HRL1rTSNiVib3TQ	13175	18537	18537	1619275860000	orphaned
26633	3NKT57AL3g98bwa4QSdUf7dPpSDp5JCSu1zMKXtWV5KCDQeeBZRp	26632	3NKomHEFrgwyJZdweo1NkCnLZE3Ehsr1zpedZxjZVpiNbgGdkDBV	1405	851	513	12463	18311	jw8XfY3hrA4pDFiT1Xu5ba7ji8c5XAWU95yUssJwocKsrQ64jPJ	13176	18538	18538	1619276040000	canonical
26636	3NLoVZfszfmCzeoRKh9J6ywfuR5MxmRL7JUfgdwhA43jyBam6BWp	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	1406	1393	513	12463	18314	jx2fPjZizDx7EovxmvCcvaUg6CdYHw7ms3YA6wDfCsgBbvRn9sV	13178	18540	18540	1619276400000	orphaned
26641	3NLLZMUTdD2QEHa39b4qzB9rdcMcMjZf2zqc47CyHYgemrKkkSqK	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1523	1075	513	12463	18316	jxGYNdQdzsXNnbTHbC94FKGE6LjipFxVF7FcR1aBbo2hmBu93ee	13179	18543	18543	1619276940000	orphaned
26648	3NL185HwmG9d6XmwuLjARz8dBS9EBfYV5UFMwChPQvDqgcDsprVQ	26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	1646	1108	513	12463	18322	jxYGu9oJjv5CkCcujCxVk5a2B3jfiAaZgwTZKSirHjuYjGvFxFW	13182	18547	18547	1619277660000	orphaned
26652	3NKNG6aXUpvFeM4pFUDCLQ6yAz48jMDpX7bYg5jFMcdCPpE56zLF	26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	1648	1158	513	12463	18326	jxWgDtxFSQaNHAcgVARFRFskCGBj9FEzp1FMAGPsXnaG7fRgNX5	13184	18549	18549	1619278020000	orphaned
26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	26657	3NKY42pqiB4QCjdx9YvQaYpq7XVnHLenDZfqje7VHofAGvjKdMYg	484	953	513	12463	18332	jx5N1p9kNRjqHKP7AzxXTPcVPZpNzddRSvK2NLscc8jMJMDy9Bb	13187	18552	18552	1619278560000	canonical
26662	3NKy4U7Fr88zpDvVMq65ASrKgF96GbQdLcnu7Zd45Zcbg88rPJXe	26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	1624	1334	513	12463	18335	jx2LMNDqLqtfsK9vMYJpeS77wC22pEeCtZdSagwSEFio13tLBWS	13188	18554	18554	1619278920000	orphaned
26669	3NKKjzUBz8nThoEjyuHPYB1Ve8yZa7ERwsLBuz5qzqgcSii6FTgR	26663	3NKceh85RvhS56S5nrP5KPsWbEqhcwrHuCJggVQYzCex1ND1TsP1	1527	1293	513	12463	18341	jwc9RD6EbfWmRtNEzjgBrQWof2Ra7fPos45T8bF8T1MmT12EdQV	13190	18557	18557	1619279460000	canonical
26677	3NLVSqqc3WVczhDt4ZXFvTdYaePsYb85KCCoY5p5PMD1uaAYfKXh	26676	3NKurcQuVj4yfuMaaSiVq2sVZqtYWeKX4K8Gp78gyMHgsnQupEPC	152	964	514	12463	18348	jxeb7sHWk18JqNE8SkALifA27zuFHPLHDfhDRF6SnvJH8mi8JeZ	13195	18562	18562	1619280360000	canonical
26680	3NKiYakp5YkHpmGXCDG7m8dS4gbjiqBxmZW97C6dGK8cZF6ZnLh7	26678	3NLgMQWbfVfMtKtpK1sp2LN8n3pTzEeHjEAoebEUXgzPxGk9pNjb	1407	1395	514	12463	18351	jxc6Ug8MUFVgAdc9tciFXBv92fVTe2UfsBu2Ba6VzBZE9SVAApM	13197	18565	18565	1619280900000	canonical
26683	3NLpyP3iGK8FtSfNcno81FbjufvZbPk9boAzVP2R1L6FFQvsKewc	26680	3NKiYakp5YkHpmGXCDG7m8dS4gbjiqBxmZW97C6dGK8cZF6ZnLh7	1407	1395	514	12463	18354	jxv6EPdjL94kthHvY7abJZfVtPjAKLiFSUDgxTQxwyxzcTCSr78	13198	18568	18568	1619281440000	orphaned
26687	3NLCqD4V4KQeoGuvoYxeRsdPzRCdnCT1WUXNqy381s7Fb1nMo5V6	26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	1596	1363	514	12463	18358	jwuhDKo5KN1SEL95WJPUHXGVyBy44HPaA7zn4nUY8bzcJrD4dXz	13199	18570	18570	1619281800000	canonical
26685	3NKYebyVqvuYizyukHA1kRZq6X6FmqJGNw9oHS54x3gArERfybK1	26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	1503	1031	514	12463	18356	jxMSPKGEjeCYCqRn6GXEjCnqJRG65cB4GQPxo8u4tvtmhWydPYR	13199	18570	18570	1619281800000	orphaned
26690	3NLrhbQ2znzkRJpYCoQL7oa9BmRGu7LUqanfNnZi5DdQBvHNvVdr	26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	1503	1031	514	12463	18361	jxMoiyi2Ub2P6VyJa5WKHRksqrjV8iSY6LXAUU4KzmqEt6BWFd2	13201	18574	18574	1619282520000	orphaned
26705	3NLkbkzDU5q3WmguKc7HRcFg1jLm4x53rDZKd5Dc9gxJAQkqapbj	26704	3NKEuigeinxxa37kKxizmXCpUB1ruUJdktSY55TZFtH2TrPXppHK	1522	1322	515	12463	18376	jwDRdGCisqbnDPPZ27BxhnRJ55QyHYrjruY9FPBnKhvcxfRoXUV	13209	18586	18586	1619284680000	orphaned
26710	3NKGTxjjM5vFpJGEzeYGNkc51y8t4aWg473Wm3yWqUxbCwoiof1y	26708	3NKV1JDk57QJhUNNTZ9pin2HQPVx5dVXWsisQTkuuGUkrvckPoDi	1490	1148	515	12463	18380	jxpJZqQaEGKteELkNdnf54Q3TSNTr5o6FZyrJkf8kqJEEetwxd9	13211	18589	18589	1619285220000	orphaned
26713	3NLcRQ5egLTC7MLHhjS5jKKTGWjaSoVRafsGWPyCr31kzAdZn3vF	26712	3NK7ZxfWmSTsH4SYwNYJwvrN1gA9gzNLD8nrn9bn2P9Bzhz5D5XS	1406	1393	515	12463	18383	jwSja3ew3VotnBwCBavLoVeBWxFCmMiJhLoyiyRGzuzpRkJ2Z2p	13213	18593	18593	1619285940000	orphaned
29274	3NLuZZ16K3NcW4RevA8jtfKoYDheUyH1Tm2RXzHxk1ihEYb6Yq4z	29004	3NKS7ZyhAEJ1Vszv2PSX6SQMTKyAijBuj2iNzMjwyeYGwfbcrgzC	1648	918	568	12463	18974	jxfgabLh9ZF5cAsjwL8UKibvvfxotsvmZwQeYVWU3Lc381bNuCs	14303	20317	20317	1619596260000	orphaned
26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	26591	3NLV6aNRvVkaLxUUPXAqmNcWFKp2y3rzKtJpfxKsn3JEWKTCEQHh	1476	1125	512	12463	18275	jwgvdfUx6yscBrHYYdn7kPrEwV593kAssEQe4xbodGDqazpKxCe	13157	18507	18507	1619270460000	canonical
26596	3NLGwfyDw8nCJKQBYDjj57VYf2GHm5Fy4cpUyHP2VmkpA3ZjUK9J	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1541	1298	512	12463	18277	jwNRUrz1zp1Q7kQ2UrYeQX7rXLu4BHvKRgxxJCGTuJQ7CZwNkTy	13158	18509	18509	1619270820000	orphaned
26601	3NLZj7zfjQdi1HSrJnK3D65VQr7okvpKKHJz7ZcQM8rtNgH5SupE	26599	3NKs13q56gMEYb4n2pMBgYbnkfUw4GDSr7PveNfasFtDKLXTPPP2	1483	1150	512	12463	18281	jxiU1aGHRa2ivi6QaswpG5311S4SLNjvpfSJs1uThQwXAvzx98Y	13160	18512	18512	1619271360000	canonical
26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	26603	3NKD1URM93TiqHyJugbYPvcCLfGvp7qURLSeodjgktDxifPWLKru	1656	977	512	12463	18284	jwvG5G2ZBHCGgxjUsnQ3gWXFACm4taDPZEmb9Nq6hqRCsP9nuTf	13162	18516	18516	1619272080000	canonical
26611	3NKkPzS3oPWwaY6jojhRm7SU4j7tXEBVgXYeNs39nuHbpQpy7mn3	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1553	776	512	12463	18291	jwEhJk4H4Who3zf2Xfwt6KfM4bG3ESAvZdSyTiSEPm342remTxY	13165	18519	18519	1619272620000	canonical
26608	3NKbmhwDhyt1LkZdmJwnPVbGt84X8b68odT6CUL8fcSDvgrrBTSu	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1560	382	512	12463	18288	jw9Y9yX4d5xXjWge3zMzbDw1kCThyBT3tVmh5Xndj5KfGLutNCK	13165	18519	18519	1619272620000	orphaned
26616	3NLazuHbyzYuL6p9Mt7WSr8YaTkNd2aFcASn6WZKgPi8bMyHPijN	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1407	1395	512	12463	18296	jxjjoEnbNoTAXESUZ91ZPknbVj8DjcRD41d5Fhxp1xdPYcJdEXM	13168	18525	18525	1619273700000	orphaned
26615	3NKKu4yHLBzDrGAoeTQJuxUgo9AxgimA7z8zY97Lb3kmiaVnVWkg	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1406	1393	512	12463	18295	jxroNZ9k44LqWCYLJBf7W2K1cZgvLTofTvaY6SvBDptfFuSDdag	13168	18525	18525	1619273700000	orphaned
26621	3NLPy87Q8bNTFMSMdxUKmvqeCinb8w2614FtJRBHsffSC835Ab98	26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	1440	1377	512	12463	18299	jxVANGwmdNPACKjTy7Z9NsWGC55q8QCvhSPFQnG85MBg6mdy1qU	13169	18530	18530	1619274600000	orphaned
26623	3NLZnZNr4URh9utcKuNuc6zF3h8yNTsu66RtANJ5dMpWfAbq7AXA	26622	3NKATbii6DaWqf8NuuMUukT3y9KA8pwa7saQZgErHNEQgWcL43GH	1642	1367	513	12463	18301	jwwfvDwfykRvrto2eAWP2nxmMkHjuk7y7UVNBkdEMXX7Ap7ymEP	13170	18531	18531	1619274780000	orphaned
26625	3NLjhni18oHacg2H5iwhLFKXZ4H14m7jDYFM2HvA6TLF5mq8ZmoR	26624	3NLRbW8tLUAYDDSMiGfiBGshSzWStZTSQ4nEtRYtHjVccorP6ZZz	1406	1393	513	12463	18303	jweCzc4d1WX1uVf4EyCrV4tUZvbRHMuB5QvF3cQkbaFRMvbu5h2	13171	18532	18532	1619274960000	canonical
26629	3NKBrSb34q8oruc9mv47AtwvNdSEFFww1AiJ4EaryE7FN3msLq7E	26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	1637	816	513	12463	18307	jxkTCM7Qg6tvgm3cQwxhnczqBJ5p5K9rcsrquHG4A4KJuywTULP	13173	18535	18535	1619275500000	orphaned
26630	3NKhr2qAZy6roj8PMKosmCsQkpYK15j5b34zLSwErqsFhS8F1pef	26627	3NLeiNbNGvodiK8RfpM9pDSrHo82VMgdbzKYYsxvDsmMsMuBWTxR	80	1027	513	12463	18308	jwQdiCkqTDUSUgvCHeRKZGEsFkaWBWdrJ8RPk8neqPQBEGMCWCv	13174	18536	18536	1619275680000	canonical
26635	3NKE85DMArQM4gQt6nRoM2kEYhqCLk69AMC9qCR8tsgEU1ZV2uyi	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	1448	1311	513	12463	18313	jxi2UUYyH6SsXHKXZn7Qjh4x1k47sDZcLjujjNHCvoMB5AMwZ2S	13178	18540	18540	1619276400000	orphaned
26640	3NLb73Mn7pR17uZdpDfRdfVqGP7kKuuJrX4y7CEqapENFzim32PP	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1406	1393	513	12463	18317	jwJE9gfcXHc4Pq3qbBYPecr3dSnCu7XJN51YzquErk8WXXSK9Dj	13179	18543	18543	1619276940000	canonical
26645	3NLh3bL6E6DRDfXCjPge9ewqH3xWqkRQAGeesgZpbW9v8dLTPoin	26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	1534	371	513	12463	18320	jxw2HKtj74pG54mRz4aVSvYm7phqc6uReQ2Hpn8mpJDHVo4R4E6	13181	18546	18546	1619277480000	orphaned
26649	3NKfPESFsuoFTuS2fCb1tcmJdT6KB6kGHWyj2FU2PVu58kdjKyVM	26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	1579	1389	513	12463	18323	jy1qSGqtmWND6h7kEmSxiE4YAXhoVgkxg7LWRF1zC8rdwD3oa67	13182	18547	18547	1619277660000	canonical
26647	3NLRqAPmLckTpFzxzpNakEGsTVguvVZUvtS3WeemZ5xN6GgLnRcQ	26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	1500	1297	513	12463	18321	jx4e1Q957o6gPiGqkxXieq4rWAi5ZmXLHmd3dq1SbTZv23Ef7XT	13182	18547	18547	1619277660000	orphaned
26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	1406	1393	513	12463	18328	jwQTcVTmz5EyBwqx2PA3RP9iMqhVBSYtPkvi9N3VBfKkd4Ahkjd	13184	18549	18549	1619278020000	canonical
26656	3NKW4dwY27ZvRRMpJFeRUS7fXUVRwsFEezgjHWXb3uRHntihuKxn	26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	1634	1331	513	12463	18330	jwPWJncqsmjctTC55ALysMBAf7YozttshDBKvS1drXvNWHEWF4s	13185	18550	18550	1619278200000	orphaned
26658	3NKSrNwZXDBVBahfV65hqHq2Do3repK6KUT36QrfaMwk8N4P9wBP	26657	3NKY42pqiB4QCjdx9YvQaYpq7XVnHLenDZfqje7VHofAGvjKdMYg	484	953	513	12463	18332	jwWU5KRi2HeM8ZupYWEBwcnDNvzkSiETueNDifpKBuGuVEzatCL	13187	18552	18552	1619278560000	orphaned
26661	3NLdzrJnrmG1Lr2QQEbaLs8opa8KMoJriu2k73SNLanS4QMJg77a	26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	1637	816	513	12463	18334	jw6fztGnJ1doYp4yy1fx9wwFCPks9jhZjzLz4byhRkhmHT1RF77	13188	18554	18554	1619278920000	orphaned
26663	3NKceh85RvhS56S5nrP5KPsWbEqhcwrHuCJggVQYzCex1ND1TsP1	26660	3NLRcbTWtHgdhzWMJRTPTDQXQoLKK22zfTGi75jaqXmssjRvsAGT	1406	1393	513	12463	18336	jwhT8pECoGXxyc1k2y9ZyHtcqc6KrsKZtKax4zEmU3ZKDUt1QGz	13189	18555	18555	1619279100000	canonical
26666	3NKepyzXFS3h2BAbCWxnsQ7s2NWGZYLm4YjCnFrjigSLJoD7dn66	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1668	1370	513	12463	18338	jxSLvTwBZiX9x9MaBZZLFRP2KajVSfE7DbnXfcbPStNSTyN2qfi	13190	18557	18557	1619279460000	orphaned
26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	26671	3NKtpAvSqHbt8zMnw4tMGJeBPce5M8EkM31dx2wvXRNPPAxhyc2x	1602	1123	514	12463	18343	jx8QMwvRz78AudcxkFjycKXfqrr9StRaufjtSgeFxGRaepKDR2M	13192	18559	18559	1619279820000	canonical
26675	3NKFL7LyWBuJMKwJmurE4ZUFzvpKvskci84gn65pK3iFuHYr61K1	26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	1407	1395	514	12463	18346	jxP53cJT5gUveyfCyGQfMcLJ8AvksyJLVJ8TckvcAtt9gpwZrPc	13193	18560	18560	1619280000000	orphaned
26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	26680	3NKiYakp5YkHpmGXCDG7m8dS4gbjiqBxmZW97C6dGK8cZF6ZnLh7	58	915	514	12463	18353	jx2qMTtzvqHhYFQjFYcmvzpX9EKEfSJV4wXCav482pFmStJDFyp	13198	18568	18568	1619281440000	canonical
26692	3NKCXWtzz92BMDmjgn9RuWeCz6dy9Ddsy6yXFjgarqEx85xbbHXN	26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	1637	816	514	12463	18363	jxj8aCQadaiHvkmfweDQtuFLvYQzrUfy8f2kyK5bkzZXiwV7MqA	13201	18574	18574	1619282520000	canonical
26694	3NKf3YWqPbCp87NPtmqBL7pGwnTMPxsMEGrLAWtFsfNzkst3nAsr	26692	3NKCXWtzz92BMDmjgn9RuWeCz6dy9Ddsy6yXFjgarqEx85xbbHXN	1405	851	514	12463	18365	jwqjhanpmdje1QKuDw4T9RPLsRYg3nnozMqg4tBDe3T27RTn8Ay	13202	18575	18575	1619282700000	canonical
29331	3NKwjMKpr6cruhfPy8WmJ3SzBRGTCGRC96tRA6tTeA9YW2CDMZjM	29274	3NLuZZ16K3NcW4RevA8jtfKoYDheUyH1Tm2RXzHxk1ihEYb6Yq4z	1648	1284	569	12463	18974	jxX3wJhSHvFoZE5RwoBG8ZvRQysd1rs29bqXpVKLmhjEmeNQPbj	14304	20351	20351	1619602380000	orphaned
26602	3NKcsczDHKjWNHKUPcDqzXgSfL2c2by3xKAx34CD4TakQDqbZxEE	26599	3NKs13q56gMEYb4n2pMBgYbnkfUw4GDSr7PveNfasFtDKLXTPPP2	1581	778	512	12463	18282	jwiikxKaVAYt5tPhAtTSHQo5JW9zVju2sWqrK99UQwCabFDxPwH	13160	18512	18512	1619271360000	orphaned
26605	3NKFR8PzRN7kJxDDcn7dWhTiEGaQKb5nhmiJLLdpHHzsT5zxTPEF	26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	1483	1276	512	12463	18285	jwdVHwbEKmkDCex8pkrDML4Voufxa4ddFhnD8GkX1m5VTctnQ89	13163	18517	18517	1619272260000	orphaned
26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	26606	3NLSp2Jk3ZLsCxEunB6TAX8NUyY8qNrmMgR53d4etRCMdAm18idi	1483	6	512	12463	18287	jxg3j7bn4aHineBoKa5dqPYoFYcKMvcESL45RABeGhxgg3RAGQa	13164	18518	18518	1619272440000	canonical
26612	3NKQjRmQ4E5yyfZfBXjjffWHogVczJiwLJKmRwFk82C98vqC6eFR	26611	3NKkPzS3oPWwaY6jojhRm7SU4j7tXEBVgXYeNs39nuHbpQpy7mn3	1460	1324	512	12463	18292	jxWF4LdZgeGdDYmnxxS8CaL7Notg6fgRCJxtzpd6LJhqXwCDVmB	13166	18521	18521	1619272980000	canonical
26618	3NKeaPgtiqXYpCtSigLmtGm8js4C4czfTQZzUayYcQYa3fYSqHop	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1529	1316	512	12463	18294	jwVSMcq1HoWUJ87rWEd4eX25Kpck7QpPYxTBTezNVB6i4eiGest	13168	18525	18525	1619273700000	orphaned
26622	3NKATbii6DaWqf8NuuMUukT3y9KA8pwa7saQZgErHNEQgWcL43GH	26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	1406	1393	512	12463	18300	jxn91rVXmQfFm2QmNnbgA8qQgG3aQweSyJtp3kcFXnKjSKCLM5C	13169	18530	18530	1619274600000	canonical
26620	3NKwxrcin7LsNqHkg4Um7SCHk7UUY4UMu99WS7ASKZ9dyzcKGA1R	26617	3NLUZqHJ5ANktQLn8N3tRCXmR4KHNZE5N7n1rFkdpU67H8Bnjv75	1440	1377	512	12463	18299	jx5j9doSsAWPrzHU8CW3EE31R5oqDBgavB5vCTUUPqb3x6UybXA	13169	18530	18530	1619274600000	orphaned
26624	3NLRbW8tLUAYDDSMiGfiBGshSzWStZTSQ4nEtRYtHjVccorP6ZZz	26622	3NKATbii6DaWqf8NuuMUukT3y9KA8pwa7saQZgErHNEQgWcL43GH	1581	778	513	12463	18302	jwTuryRt91eTQd2JDTNdePyTQqTARQd1tZSfPgP5mBJrmgbJ1Km	13170	18531	18531	1619274780000	canonical
26627	3NLeiNbNGvodiK8RfpM9pDSrHo82VMgdbzKYYsxvDsmMsMuBWTxR	26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	1602	1123	513	12463	18305	jxk4qKFT5g6y3Wwh4xub91UN3XxX68vW2wJxfkBGQhcQrbCrLPX	13173	18535	18535	1619275500000	canonical
26632	3NKomHEFrgwyJZdweo1NkCnLZE3Ehsr1zpedZxjZVpiNbgGdkDBV	26630	3NKhr2qAZy6roj8PMKosmCsQkpYK15j5b34zLSwErqsFhS8F1pef	1403	824	513	12463	18310	jwFdCz3rvugmNtAJ7V5UDtdWgcNBEpum6jYiaJQPX8QdPnAHfB3	13175	18537	18537	1619275860000	canonical
26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	26633	3NKT57AL3g98bwa4QSdUf7dPpSDp5JCSu1zMKXtWV5KCDQeeBZRp	1503	1277	513	12463	18312	jxEx7yCtxmSfPMpuWgpGtjRyhRpUU8v41AsNejEEqzTaW1x736E	13177	18539	18539	1619276220000	canonical
26639	3NLhQ9s7TNKtWStn8y5GVKrm3gxx6QNUEWFFUQQ2eU5e87C9NZbo	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1523	1075	513	12463	18316	jwDVW46cVH2y59FRuwqL7iDtCG6L4H6PuvqnZbD36qHznzZZJT7	13179	18543	18543	1619276940000	orphaned
26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	26640	3NLb73Mn7pR17uZdpDfRdfVqGP7kKuuJrX4y7CEqapENFzim32PP	1477	1350	513	12463	18318	jwETmm3dd2SBX2fQMYFdAPnxGZCj3V32jDkVB69aiM9ac4oJzd9	13180	18544	18544	1619277120000	canonical
26646	3NKtPWNhG8zS1fzkBzoA8XpnMgLuYmQCZVKhViaBUosSTSJRVanb	26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	1534	371	513	12463	18320	jxvfzbw7nfKUKsB6QNxwpQNzGdqQ6uLKS5uSYp7R8PRTMEmfTpe	13181	18546	18546	1619277480000	orphaned
26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	26649	3NKfPESFsuoFTuS2fCb1tcmJdT6KB6kGHWyj2FU2PVu58kdjKyVM	1406	1393	513	12463	18324	jxsk89a9SoR4wZ8i7mDPPpBCFvzPc1fVmxw5EaLe8e4i34vyCrG	13183	18548	18548	1619277840000	canonical
26653	3NKa7ho81H9XVACjDXEE1ijyj2Y9T1CrR2LU4MKDf855cUSCpuUA	26650	3NKmDeNJRCp3mY5RM1Lw8zz6t47CrkviS89kAtgpLSDk9mbjmYpT	1619	909	513	12463	18327	jwf771Vi71PiZghw3nMX5Xe3x6G8MxxruoTxaXCPZM2xvx1bYNs	13184	18549	18549	1619278020000	orphaned
26657	3NKY42pqiB4QCjdx9YvQaYpq7XVnHLenDZfqje7VHofAGvjKdMYg	26655	3NKEQP4ze2CmfaNCjWEaerdyn9F5YfWzqkbtv5aQxRLi48VNR4LQ	1623	830	513	12463	18331	jxk42fzvhCFwuiqxEXJYsN9eMiNW3oJuR4L7WJPtmu2oXhHCvRZ	13186	18551	18551	1619278380000	canonical
26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	26660	3NLRcbTWtHgdhzWMJRTPTDQXQoLKK22zfTGi75jaqXmssjRvsAGT	1650	1375	513	12463	18337	jwAqNqQSMv1Raw7rbyu61ebdWhHCNaFKZgGpVYuVWnqAQPTMz8d	13189	18555	18555	1619279100000	orphaned
26667	3NLCUR2HZUBtUZhi21gnH18SyePkuijDyfcF4y9fiuG65M6SA9qS	26663	3NKceh85RvhS56S5nrP5KPsWbEqhcwrHuCJggVQYzCex1ND1TsP1	1668	1370	513	12463	18339	jxBx7so8pFkFNVhisbMUZ2iDYDkQK6AG48JfTgySomP82Ya7KZU	13190	18557	18557	1619279460000	orphaned
26670	3NLVmp3ccwLjiKMS68koihgrynxDkY1srGbDKL2nJ1ZteVGCP7Kv	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1527	1293	513	12463	18340	jy2Vz2kzUE43gQB3g9T5GVwSLT5jRRYdoGA5x3UwjpRjN18RTpg	13190	18557	18557	1619279460000	orphaned
26671	3NKtpAvSqHbt8zMnw4tMGJeBPce5M8EkM31dx2wvXRNPPAxhyc2x	26669	3NKKjzUBz8nThoEjyuHPYB1Ve8yZa7ERwsLBuz5qzqgcSii6FTgR	1637	816	514	12463	18342	jwcQiE9VK2hQcbnPp8MBaZntpnkYFTEMVKwgeLiBkEiHMGPEeGK	13191	18558	18558	1619279640000	canonical
26673	3NKuRTGqbNCeSNExGocteYnXP7vgcLwNzZuXHpWBGx9g9YTpoSGy	26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	1490	1274	514	12463	18344	jx7aivQaDbqVt1MbYVHKRDTsRxueG7BDHnW2pnDaHhoB2wPL7vL	13193	18560	18560	1619280000000	canonical
26678	3NLgMQWbfVfMtKtpK1sp2LN8n3pTzEeHjEAoebEUXgzPxGk9pNjb	26677	3NLVSqqc3WVczhDt4ZXFvTdYaePsYb85KCCoY5p5PMD1uaAYfKXh	1503	1151	514	12463	18349	jxXdyNQHjvkMorasAfBYjK4qZ4sVUCLn4YCvYpjUCHmpqrto2qT	13196	18563	18563	1619280540000	canonical
26686	3NLaFnwXgAqAVXRTgYtj5ngKLmhXG9xB6dzDFrKteqH2Ch2dvV7S	26682	3NKpkTaELjxywPQDAms7pjGZxpDjncWb392yvieoZHqf3CBMoW1x	1602	1003	514	12463	18357	jx4Toh5osDn4QTbHXPpodD32kt6vJn9VHARSJzVY9y2SHvcseHo	13199	18570	18570	1619281800000	orphaned
26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	26687	3NLCqD4V4KQeoGuvoYxeRsdPzRCdnCT1WUXNqy381s7Fb1nMo5V6	1403	824	514	12463	18359	jxXXiUZq5Z8DMm2vC92XBUqwyqaDSgJuzJC3kLUEQHTV67c8x9V	13200	18571	18571	1619281980000	canonical
26691	3NLsiBCup3hwQUDp543rjKzCtTzxu2z4RoC1XUTMFg5SQHLm3yGD	26688	3NKkdNEYD8t4WXUrUsv6APveVqBhay5KA1957SirnXYdty6sLkHZ	1490	1274	514	12463	18362	jxuH8bzkmREhH2HMbzLBiwqtXSehGBssAuLEJ8HfBWoxAJLnwvw	13201	18574	18574	1619282520000	orphaned
26695	3NKnAQsYBkbDBPgPFDJdU88geoFMaHmFaQKTUTDTHyXmCbJx7tUA	26694	3NKf3YWqPbCp87NPtmqBL7pGwnTMPxsMEGrLAWtFsfNzkst3nAsr	1637	816	514	12463	18366	jwKgsNmHUKLPznkczVQzydtvEzYfy9SyCw4nrqcFuCuozPJ2Mdz	13203	18576	18576	1619282880000	canonical
26700	3NKU2ea6msf5vo3A2zHaL8UKcYtWnruU5sApBugxGrEsxnmmttmQ	26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	1406	1393	514	12463	18371	jwDbmzSYhUBkWCoeFzPSAogqiJHELVabDc96ubdUFkYDRwUk1AM	13206	18579	18579	1619283420000	orphaned
26708	3NKV1JDk57QJhUNNTZ9pin2HQPVx5dVXWsisQTkuuGUkrvckPoDi	26707	3NLyXaTGPDWrYjaemfJjdwnJdhovQXnnKaULyvCS4gTEP42QvyLn	1476	1371	515	12463	18378	jxCuA49qGMt86PnyEqgLXcYQJfBbHqGdZX2B6b93AyyaQU9v2yp	13210	18588	18588	1619285040000	canonical
29011	3NKoj6PuPVV7TCncsN2FJp3XsbQSUhoYNxWA1SEFxeR9mvMLs8ZC	29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	1405	873	568	12463	18974	jxN2RHhPwE5cBMpi1zFi6FTqXSkbi2tWyA1TbescGp6HQunZPnG	14305	20143	20143	1619564940000	orphaned
26681	3NLSs6A9cs5G9man52ALr3YVDZxHYyUXtn5YH32M4atrTn9UHsBX	26651	3NLqRvvVqns4MZUSM3fV4A31492HuqZPTk3NAzfzBCzhcLg2gP3j	1402	900	509	12463	18352	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13071	18565	18565	1619280900000	orphaned
26684	3NKBSCd4VehufdKHGb3xyWhqBtwuXpRvpTL6V77UqQ4QMuEouPMa	26681	3NLSs6A9cs5G9man52ALr3YVDZxHYyUXtn5YH32M4atrTn9UHsBX	1402	808	509	12463	18355	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13072	18569	18569	1619281620000	orphaned
26689	3NKyBoQMktbcqyrbVHQkYar7Tde9YPwVTTQaiTgcoESPoFeJVGvb	26684	3NKBSCd4VehufdKHGb3xyWhqBtwuXpRvpTL6V77UqQ4QMuEouPMa	1402	852	509	12463	18360	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13073	18573	18573	1619282340000	orphaned
26723	3NLVYuCeHBnKmNao47SuBPDN5nxynnTCf8cigVMEmqcRFkCv9zGv	26693	3NKhDrTDVW18s9KToKvgsKkocM9DeydXRKUQ8SqkRixCaHAmhrp2	1402	882	509	12463	18392	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13075	18598	18598	1619286840000	orphaned
26709	3NKZ8etyeAy1tQUVFGhMx5rPA1zP4SS2i2BMs6ruY6w68PEoEpd2	26604	3NKamZuN5eBq9rfve3kzLpwrk1HQHsxSqNEFMS82ky9rYRSVwx9t	1476	1371	512	12463	18379	jxYnkJ3FtExjBVEDZyWsPZfyAJn9sWee1XFDz4Y13ZHTXVMhQWa	13163	18588	18588	1619285040000	orphaned
26628	3NKv5sh3F7YZKzwhbvnSCxwvvn3GSYgVLRqGqVnsMdho5Ja5AUZu	26626	3NKMmCdqn8muAsvYrK3fFst7Ls3yVTsmJ8ETcthbrgv74FzCaqhz	80	907	513	12463	18306	jy1qWtW1Hkszh7BLLigrsE8QjYNrfiTHKaKS6SpJUW1sJUJo931	13173	18535	18535	1619275500000	orphaned
26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	1448	1311	513	12463	18313	jwycTsEC3dVBqGX4fQsC6Ndg7qDTr2wfzo9h9ZTFdx8kPSk3QLB	13178	18540	18540	1619276400000	canonical
26644	3NLwDcUjYoxzULShnV1LdGEz37HgXxRjHsFpVNZKFQaMnBtvnRVb	26643	3NKQaZ7FdHzceZUKYfErGHxJ7rMJr3EcpCuMyabrpH4Z7Zh6aWRy	576	1355	513	12463	18319	jx2Lz2aqveaaRDcaLPrChUMJdBz3Ugdbji321ktWQogFXSRzgWo	13181	18546	18546	1619277480000	canonical
26660	3NLRcbTWtHgdhzWMJRTPTDQXQoLKK22zfTGi75jaqXmssjRvsAGT	26659	3NKiTSHEdMT2xaPoyTTjV4TLUfpk94A7poRXvP8FiiuGc6kVsKDW	1490	1148	513	12463	18333	jwxH1eSg45EuythNFKMfDoxmDxB4YSFpCxSTYceVQSHosm27RZQ	13188	18554	18554	1619278920000	canonical
26665	3NLa2fA3mV5eCU5vbuHaiJnfVVZwECMdKXQ4ixQJGjD4dFUgzXBD	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1668	1370	513	12463	18338	jxrWYtZqyhgU7fg3ToDvoPYhZh9yfZzRx8FkKjTUbXMLXaW3KzT	13190	18557	18557	1619279460000	orphaned
26674	3NKPpgKDcR9CseQSWZ1j7bhysYishGXvgUNkRH6DWmh924awRYG2	26672	3NLhrUKHx6WymZh7AQotk89D3nzDCstKoCrqazmKpwNH1QA534wQ	1405	883	514	12463	18345	jxHGixA7ioy5qfSsa8ra7EJCSttqFERrNdYRPVLRrweZAykZ3CS	13193	18560	18560	1619280000000	orphaned
26676	3NKurcQuVj4yfuMaaSiVq2sVZqtYWeKX4K8Gp78gyMHgsnQupEPC	26673	3NKuRTGqbNCeSNExGocteYnXP7vgcLwNzZuXHpWBGx9g9YTpoSGy	80	1147	514	12463	18347	jwuXksf2rgrLXnRDgceyDotqUFsDrqEZWUKMLtv4hgMY4KUMb6X	13194	18561	18561	1619280180000	canonical
26679	3NLnjjd9iQZworaCapVdRBNCmUrBtMFH9Y1wDmz7B5tP5TTEQmro	26677	3NLVSqqc3WVczhDt4ZXFvTdYaePsYb85KCCoY5p5PMD1uaAYfKXh	1407	1395	514	12463	18350	jwUZbX28PhSGZaFxxU1kv7UmusX1K2my4cKCPGUS2NUxSPwDYwf	13196	18563	18563	1619280540000	orphaned
26696	3NLCT9t5kEneqaJa2wMZhPGTdji71CRYqfLiR7xVtuaSqVNs3zcu	26695	3NKnAQsYBkbDBPgPFDJdU88geoFMaHmFaQKTUTDTHyXmCbJx7tUA	576	1229	514	12463	18367	jxa4aD4T9Zrwn89FDdTu1So3cVW7p4v72wPkLucwDAJgXyhYUqw	13204	18577	18577	1619283060000	canonical
26697	3NKZUgPKHU4NgWuq9FxgpnBPx4XrCAyKTwPEmmkBvZPFSiQDf8k1	26695	3NKnAQsYBkbDBPgPFDJdU88geoFMaHmFaQKTUTDTHyXmCbJx7tUA	606	1295	514	12463	18368	jxmwiZX81BN5TRE1iFGu96pX3n49JDaisbuUE9PzMMCULKLJXqe	13204	18577	18577	1619283060000	orphaned
26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	26696	3NLCT9t5kEneqaJa2wMZhPGTdji71CRYqfLiR7xVtuaSqVNs3zcu	1637	816	514	12463	18369	jwp7HzNvZtJggwCMPvfuqfMEDeSbep3BZWDMMw8ne2txDd32YdN	13205	18578	18578	1619283240000	canonical
26699	3NLDYHohotPFH2BmPHiuJQdM7PUKc4BJSMYi9MaEhNgMr62by5wj	26696	3NLCT9t5kEneqaJa2wMZhPGTdji71CRYqfLiR7xVtuaSqVNs3zcu	532	1177	514	12463	18370	jwLmMg5bmx3RnPzrpy1RnvzKDxawASsNET95s54Tw2YYUJQ6BbE	13205	18578	18578	1619283240000	orphaned
26701	3NKBNn1kXDeYdaMgkvPU7ndNo97DQWDq5T3nphe3obWiFQSPAYL5	26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	1405	867	514	12463	18372	jweJ5JGcDed3RWR3ptEi2TQVFK3i3QKPhfW45YWERdWVS34JA3e	13206	18579	18579	1619283420000	canonical
26702	3NLTpob5WzRoiBpUHwau52hdTwUMhRY5uxA9j3JwqsBoNxXYAji5	26698	3NKEzw7Px8AQnFcwE6b7CQMPYNA4rNkFH3gJjUTeRor4Gc8DE9v1	42	1361	514	12463	18373	jwM1UbBQxBcKR7sg8nvdgoSAUgKKR7M9JGgZdCjRrNf5Bi4SDuA	13206	18579	18579	1619283420000	orphaned
26703	3NKoxwrHwwqPWehTLABJyVpf2QzYZSBr7BdJBaU5dKbnCp5NQkVC	26701	3NKBNn1kXDeYdaMgkvPU7ndNo97DQWDq5T3nphe3obWiFQSPAYL5	1403	824	514	12463	18374	jwt8XXQKSvLc8jFULAXfctaX5TJe68ExJcJW6S9ob51LBMa9BRN	13207	18581	18581	1619283780000	canonical
26704	3NKEuigeinxxa37kKxizmXCpUB1ruUJdktSY55TZFtH2TrPXppHK	26703	3NKoxwrHwwqPWehTLABJyVpf2QzYZSBr7BdJBaU5dKbnCp5NQkVC	1593	1220	514	12463	18375	jwWt774SdEUwFBEt7v4Lw9qbsxwFzj2Q5puEBXp8SBC2Zz7nWpV	13208	18583	18583	1619284140000	canonical
26707	3NLyXaTGPDWrYjaemfJjdwnJdhovQXnnKaULyvCS4gTEP42QvyLn	26704	3NKEuigeinxxa37kKxizmXCpUB1ruUJdktSY55TZFtH2TrPXppHK	1522	1322	515	12463	18376	jxB99LvGMNjx2hWVA3NxfPY1YmWKVJTXwppqMPaWDd7dRPvzosG	13209	18586	18586	1619284680000	canonical
26711	3NLTwoHu2T4zR4ddou3STjnYEoLXoVFsPWA1Kbw6k7enKtkYs8ZG	26708	3NKV1JDk57QJhUNNTZ9pin2HQPVx5dVXWsisQTkuuGUkrvckPoDi	1613	661	515	12463	18381	jwWhbTXTRjgBY7sSsLhuSXWRg17BFagPPJDw8nfFzijAQNF7sHL	13211	18589	18589	1619285220000	canonical
26712	3NK7ZxfWmSTsH4SYwNYJwvrN1gA9gzNLD8nrn9bn2P9Bzhz5D5XS	26711	3NLTwoHu2T4zR4ddou3STjnYEoLXoVFsPWA1Kbw6k7enKtkYs8ZG	1619	909	515	12463	18382	jxigQKx8cpWXcNe4Y4YNnnW4nas9Ldvu4ikyNR3uagjcz7SfzQT	13212	18591	18591	1619285580000	canonical
26716	3NKRBkjAd3Cx6SuUA9kDpRQ1zrSUN45mVbp1HQDpSJ68QMg3wLNi	26714	3NKiACMBvv2WxpUk7WZh8tFwkyFrFAFxt5hU1e9eBWj7FdnRazZr	1434	642	515	12463	18386	jxvo98SjNgxoNyCKpL85foAvWAp5KaeUm3kjHaoq4GrdwxW3ko1	13214	18594	18594	1619286120000	canonical
26717	3NLjSBKgQtekXyxCYEr1pa3fFbDNMNpuWmtU5pFJJFT4XHmHqbsf	26716	3NKRBkjAd3Cx6SuUA9kDpRQ1zrSUN45mVbp1HQDpSJ68QMg3wLNi	1637	816	515	12463	18387	jwsJ6LnnxtqQCKWoqyJXNfxAZWuub52zuN5ghF5Pg9YLLkC1ati	13215	18595	18595	1619286300000	orphaned
26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	1601	1388	515	12463	18398	jwcetvEbbDW78wVMLafWoGHnj4dKPdJBmX5RKbLwfLN6XDV43Lw	13221	18604	18604	1619287920000	canonical
26728	3NKwfHWbuZ2JsXxiapi1UBXDdqDE6SJjSoFbqb4y7HqRurSWAUeN	26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	1407	1395	515	12463	18397	jwnxs35bubtbw4UygD3m2yoMmHw3E3FpcWvipxvaa6K5tieciAE	13221	18604	18604	1619287920000	orphaned
26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	26736	3NLpPQig6E7ZL7am1Y3UvcMxjQLc2yDwExnA8Vpjmn6SveEdojxW	1403	823	515	12463	18406	jx6tVznmFXuMkJsRSzh4G2AK2HkhcT6NVys6D6XaGKvwFh9m8LC	13226	18610	18610	1619289000000	canonical
29413	3NLsinr13bKsg7FnNjCptH6Aj8Cy1P5AmL2Fhkz8pF9BioTPou4J	29266	3NLVqk7Y8oMaQgYG8JzsXbR9cbhfahmvPY3qCQ5o5gCCD3FWqX2j	1481	790	568	12463	18974	jxt4xspUMUQ6CpxPxezf3Pu84aCy3J9CK3d8eGrxDQQKFkNsjQd	14310	20412	20412	1619613360000	orphaned
26753	3NL1xX5NZEUDAwEosHLnk5hFF1PjWRYqGRToxKuJxNoJV7YJiAhN	26552	3NLrrwq5xrsSJ4fEcCMA6XNtYQdr2uCJdo4yHpRtq8FpED3dy7Xv	1405	889	511	12463	18417	jxVtTuR4YXvh2YMwMR96vMHbH3zs6k6biJRNo3Tv9GxMqt5prmo	13138	18617	18617	1619290260000	orphaned
26757	3NK5SRhbx3uekVY5a428a1ZNW8riE8xT4APuZ1SfCjnTDb9d1SXG	26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	1405	873	513	12463	18421	jxh7DRmcBuLapMzytdJpk2qo1xWpavr2PMLoFuqKR1qaxXVBwiA	13185	18618	18618	1619290455441	orphaned
26714	3NKiACMBvv2WxpUk7WZh8tFwkyFrFAFxt5hU1e9eBWj7FdnRazZr	26712	3NK7ZxfWmSTsH4SYwNYJwvrN1gA9gzNLD8nrn9bn2P9Bzhz5D5XS	1474	1203	515	12463	18384	jy2cwjWkUFHZNq1SHQ1jyRm15NGQ6AD9nbDGNHrkH7JZrDBQLt7	13213	18593	18593	1619285940000	canonical
26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	26716	3NKRBkjAd3Cx6SuUA9kDpRQ1zrSUN45mVbp1HQDpSJ68QMg3wLNi	1474	963	515	12463	18388	jxjVtTrHZhuZ9KRgB7gHwzguDL1V9muM3k7HYjs3xb5Zr46zM9N	13215	18595	18595	1619286300000	canonical
26719	3NKHFYBGPv33cGFwjMZKWb3cYkBuHWCKxUJJpsBNh3GyrWTQTpeg	26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	1633	1390	515	12463	18389	jw8nqSjPG8Up14oYZJwmCLTdJXZDcTU5MoMDSj1FJcmdj51B1ox	13216	18596	18596	1619286480000	canonical
26721	3NKXptWhDjgD3t6eemYoVpPmGhfdrNDfgFocTCtmY1D3pSLDbAhC	26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	1633	1390	515	12463	18389	jxntUQWxDsK3kvEGdSKsAZx9SEa4ibERD7gD8o49U13vvWBvjs6	13216	18596	18596	1619286480000	orphaned
26724	3NLwg2t9hWDg3KWGjiEf2wTc8fE92FitNjxdDiVbGsmrbNkS8SKk	26722	3NLjeFVCjgx6WtPM31TVS5bgWrFDSiLwnC7vFyTpmhQXiB3CSban	1406	1393	515	12463	18393	jx63kmLnuKAjbefWLUYuQ8UeLmwpLrAj1vqyG8J7mRBwRiDKseN	13218	18600	18600	1619287200000	canonical
26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	26725	3NK92DHiLk3t1eyNeR6L4jYDmSpUwJGYD4NRP7396Lfv5cziucn9	1406	1393	515	12463	18395	jwGLyZGZv5vafhpEtghRHdMPq3rWPMSFD2ei3nSwuDyUzgwrwMU	13220	18602	18602	1619287560000	canonical
26730	3NLcD85BdQu3AC8pA11noxciS1t41EwEfRCEVEi7LMkFhJbv4mu4	26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	1668	270	515	12463	18399	jxV2a95hq3jzJmm7KKrYyKeXp4GdZ8ES255SZK5HXdgbSJnK57k	13222	18605	18605	1619288100000	canonical
26732	3NL6EQLYDq8bVSNhdz3xgR546Vw7aDGP5ioeiMKXuNHS17cqCeRG	26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	1406	1393	515	12463	18401	jxsDEjiDKEiGxTGP1kaVasp1Zvi9uSExpjtsMQzL8U4PAn43bPt	13222	18605	18605	1619288100000	orphaned
26733	3NL6tKiibdpkkyob1soUJJSyMViLPxwMv9GxxN2EtvWEzfCi9RFd	26730	3NLcD85BdQu3AC8pA11noxciS1t41EwEfRCEVEi7LMkFhJbv4mu4	1406	1393	515	12463	18402	jxgKN9TiWuASsZ2U1JUJDEZM9caxMfkf6BDyoenKfRfjscf6ZXY	13223	18606	18606	1619288280000	orphaned
26735	3NLwjYj4T9GxyxHMZ3QEedUfcnXCmRz3KuBAMU9T49HCXyGy3Xzu	26734	3NKNcc9MBNExpQbfpXw8Cz7rks2VYq7KRhZHEundETBAM2ZqHdhX	1407	1395	515	12463	18404	jxtEyUbX5ELDi79TsP5wrLURVFG158HWArXj41mjU7LYhq96sqT	13224	18607	18607	1619288460000	canonical
26738	3NLc6MJfDiYLfsXnsTVrZzMFVJebpi6EDFMxaa5Kg6BqBVK65iYj	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1560	264	515	12463	18407	jxbYUC1uBXvwgeD2hVGMoZaVwxJ9SBdCL7MBgZDTLamURin7iRQ	13227	18611	18611	1619289180000	canonical
26743	3NLCSgUE7vyqcbx7KQc8Qyk1dRHutiUxes3ZTLPaEnqZQYiKKy8h	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1546	973	516	12463	18408	jx6euMseGAz4865Ehi2Uz8kDadrP3pNzLygeTfYx6FQrT4KKfQA	13227	18611	18611	1619289180000	orphaned
26745	3NLdTpGHkD4cqEiJozzwb5EbQJ76UyqqUr8L5TgaWfVNjvcJXwie	26738	3NLc6MJfDiYLfsXnsTVrZzMFVJebpi6EDFMxaa5Kg6BqBVK65iYj	1637	816	516	12463	18411	jxRkh6EzZgMhp2JEZG6Qfg7tFEy6U79MTGuv2abXSjxaYF8Mf2g	13228	18612	18612	1619289360000	canonical
26744	3NLfo71SW7zfuShL2LxZyJVjRwdec6ZvBTVhFNw6mJ6rzbSiMdHA	26738	3NLc6MJfDiYLfsXnsTVrZzMFVJebpi6EDFMxaa5Kg6BqBVK65iYj	1407	1395	516	12463	18410	jxwKZjDfAY8ja6t22QvreuM5HEWhD8zwjTEQc9ZsrVghWkcw6rp	13228	18612	18612	1619289360000	orphaned
26761	3NKcRxTbKmsS1krd7MrVnjvuMvPjjpXVzL3pVexKryQQnRkT2BSU	26751	3NLNnGJsyZHVLB67qDhQ74h6xhR7BiAtYo98Lonwu6uJsFAubuG2	1405	841	516	12463	18425	jx9Q5gDddQfXhztT1V5NoNqzH1J4mAuj2c7t6C2LBLQvE9vBKJu	13232	18619	18619	1619290687386	orphaned
26760	3NLiAYYvRKxjxzbyyJonKxLz8opqYESGCTxWiNE5U2wvaPwjYzUx	26755	3NKjDB8zU2wjjHZLsfRCEm9JWR2FQG7Hcx1bCYwHW3DRjv5DUPQd	1534	1191	516	12463	18424	jxp1BTQg5M9fnaDqNt6wLnf8EtJHdf2bRKMzatu1VqofVZNw2HE	13233	18619	18619	1619290620000	canonical
26764	3NKzNNDdbyaRHbQchJ3cgm1v8Q8zzaENQA8P2RvUxktTdQF5Vjtn	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1422	971	516	12463	18428	jxaQthMun7j51K8rqtc28Uw7X1QQjcTRdHNnuwsqYJEZUwRPQQ1	13236	18624	18624	1619291520000	orphaned
26769	3NLqsfZz3Q7JzpcRvx6QRppLxLVgDzf1dtuWhBduaNpj8PJpGsu9	26768	3NLXSEuPFW7obE6UYgdYNArR7oQ994WcoRyaUYKVyrAe4d9mHCFZ	484	953	516	12463	18432	jxqsDkP21nyzCAwa3Waj7zysxXu842N3bF83mFzCBBuCwffdvKf	13238	18628	18628	1619292240000	canonical
26773	3NLAUiPUNJHdTjyFmcMmZdQ3xkxL3R2QxZDe3GpwwC7kqeTnCCdk	26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	1666	85	516	12463	18436	jwZxENB8p9hnnSA1UAtnhFwxs1ibtnFtkgi1TU4zGCY9t1cDAPP	13240	18636	18636	1619293680000	orphaned
26777	3NKkdQ5UMVkBUidTcTExMkvXCyF4se5Hp5Ls9FwDKsnxX7ECqFGg	26774	3NKEXpi2DHkaausmDzb9Mw25grnvRzD2Ehy5axydpy5oTeQZtPcR	526	526	516	12463	18440	jwhijh6tmvavjqhJaH3RNrEUrLg7AykAQy6U5iXiN4o4JzdUE5q	13241	18637	18637	1619293860000	canonical
26780	3NL4MMVkf1g3h6qAVhapJMJMPB9sW6kWMBEJUfmHpGc7q96UMhMZ	26778	3NKnd8Q8DPi5xSB6LanSMRoGCsFDC1V1hnecHDqqwrkp466PWKmS	1631	794	516	12463	18443	jx7T4PDN7veB6XY1hGy1VE4ZGTQpA7f3fyCZ3Fpo36bTZGjV7rE	13243	18641	18641	1619294580000	orphaned
26787	3NLg7hHzWJiBwAXXtbFM4tPDghg64ExX1ogBdaGazY33MygPgfpf	26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	1506	1127	517	12463	18450	jwgZkmSJLkj6bRhQRdXHqbqpqLaSJXS2kA5yfXdKrRaGJ4eiCmU	13246	18644	18644	1619295120000	orphaned
26789	3NLyWF3QLZp581Z1BcaiQHE7ebo7uY8FWQDBEa1z4LFu1iDfWfVx	26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	1407	1395	517	12463	18451	jw6tDMpB9KtVAe7vNCjNAbusnvKMsdRv9n2QYuPffX69SHWmdGm	13247	18645	18645	1619295300000	orphaned
26794	3NKY3wsZZm95uwYrCvbyVzYiFQ2gEHS1Ku8GnjjKYnfvYwPbMQvT	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1523	955	517	12463	18455	jwex46nnxYpZEo3QjMXmjhrAqrLgTDgvw6ctFxWhcsULwKtTFPA	13249	18649	18649	1619296020000	orphaned
26798	3NLn6zy7zS7nHD5uU47N6MnrdqBMy4TmeA9hC5LoQASaESEZvcb5	26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	1624	1334	517	12463	18458	jwWv3Lv5hfGKp76DejP8n4og9y15ctgapddXb24NJbzuAjAFL4h	13250	18650	18650	1619296200000	canonical
26801	3NLCcqYaHts4qtZ8F3nmf1qtx5u6irTs8qMBTaeXPRSJ7VQwTaHV	26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	596	1306	517	12463	18461	jxtAhLNDUbmcv7BjbMj5oBxwD66vS1ain3QZ2HnXoHVgZbJXTdR	13252	18652	18652	1619296560000	canonical
26803	3NLBTnwxrphSZwBrSo59ujZqZbkn4LX6nBaVtn4EF3CGfACcfosU	26801	3NLCcqYaHts4qtZ8F3nmf1qtx5u6irTs8qMBTaeXPRSJ7VQwTaHV	1599	1287	517	12463	18463	jwP2FwBrhgK2tPCLceShwhrkMtVqdWyqTMsh1ue1rawXoM8j1Ec	13253	18653	18653	1619296740000	orphaned
29038	3NLJ2n8JLvXmPpQAxaxbDZHEsQtmdPphzUpXdd8H6sV1JNjHR6U5	29037	3NKqGus58AkiFaxZ24ipw4nRDtfwbpeitDh5Qxk6er1avNjdFBvd	1403	782	569	12463	18974	jwkT1SvfnDSRhm2XCs4KsmM2Xpt3uXtjLMKbE1fxnFQcm4D4KEP	14320	20163	20163	1619568540000	canonical
26784	3NL21aN8H5uV2wS3WFWNVLjzbpybfAudsSFjhYSApqpwF4oQany7	26471	3NK7q97DfZCon2d4oPjqmdScM3kNiQkVAZhFcEMWkJer9yKh8ysk	497	657	508	12463	18447	jwmEGM9tYYWb8TxaUpV2cwaGz5Vvj3wPYoQNXgac1M64et2qkh6	13094	18643	18643	1619294940000	orphaned
26747	3NLFM4waNowaokNBNLARxPrpjdFZoxrzrFWGLsYwLqf1pSKv1SEY	26532	3NLnXZCM1dT6AKsVecvLtncYKzjLQCfYcX3tmdBvLgYuQU3LUfbq	1654	974	510	12463	18413	jxuH5y8NvQnhCv2PSQGTGva6g9p22ymjLq8r2LNLX1WjcehcmTR	13125	18615	18615	1619289900000	orphaned
26756	3NLAhABCfxUX1FfFrNm2NooGHJvs4Rp2Pfrc6BQsVwXixL65VDVM	26591	3NLV6aNRvVkaLxUUPXAqmNcWFKp2y3rzKtJpfxKsn3JEWKTCEQHh	1405	889	512	12463	18420	jxg5k9kGYyS7rvzjBkxs3smrnnZxRezaYA8vLYb8F1wHZnMtxrs	13157	18617	18617	1619290336935	orphaned
26720	3NLLK8AfEmRPw1kyF1WgTbt9ZseXBJmAmGjgWeGSFANMhuWFrMKZ	26718	3NKEd5v2pWyL44C5jxim4diyPUetEFmd1diwEe33JnAkkhsCEDxT	1650	1009	515	12463	18390	jwtiJkZ4Jwys6gzbZCU27YHzWDU15VfxV8QAkjRsKMQSroSipRi	13216	18596	18596	1619286480000	orphaned
26722	3NLjeFVCjgx6WtPM31TVS5bgWrFDSiLwnC7vFyTpmhQXiB3CSban	26719	3NKHFYBGPv33cGFwjMZKWb3cYkBuHWCKxUJJpsBNh3GyrWTQTpeg	1406	1393	515	12463	18391	jy2gjxfKbVHx1swnAZkjGVjt1x6wAVxxyWfWYcYWwWVxGAKZBLj	13217	18597	18597	1619286660000	canonical
26725	3NK92DHiLk3t1eyNeR6L4jYDmSpUwJGYD4NRP7396Lfv5cziucn9	26724	3NLwg2t9hWDg3KWGjiEf2wTc8fE92FitNjxdDiVbGsmrbNkS8SKk	1623	839	515	12463	18394	jxYVhWm2qCJktdKrf19GX2MohM2wz6Av8yhnWbziqYrw1W9UYVL	13219	18601	18601	1619287380000	canonical
26731	3NLDa79MQt3CRVvDpCQhNDS4J56GxgWfusSMzTiQGb5MdrVm9iLp	26729	3NL6UxGdViwXyKdxYHGS4T2RhMbnEi1Wjon4t1HyYPjk1RkHNCQS	1445	1290	515	12463	18400	jxYj1thNJvmNSX95WtJLX72Kh3rhFq1pdhBVwRwLMr1q2CHeCVU	13222	18605	18605	1619288100000	orphaned
26734	3NKNcc9MBNExpQbfpXw8Cz7rks2VYq7KRhZHEundETBAM2ZqHdhX	26730	3NLcD85BdQu3AC8pA11noxciS1t41EwEfRCEVEi7LMkFhJbv4mu4	1403	824	515	12463	18403	jxByS3s7CBiHU5o9Kvo1pyLCGF4sZUzU1GQFacE1xh9ZwDjjcbS	13223	18606	18606	1619288280000	canonical
26739	3NKp7vNqTrvfv29dgE5oHvEar1GtMLLDE3SPzjiHAQ9QmTfMRCHn	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1546	973	516	12463	18408	jx6euMseGAz4865Ehi2Uz8kDadrP3pNzLygeTfYx6FQrT4KKfQA	13227	18611	18611	1619289180000	orphaned
26758	3NLZZq7kLhB8tgNh5KNeb8gFu1UzX9p8cCn3uukd6bkf1cDHbJRM	26755	3NKjDB8zU2wjjHZLsfRCEm9JWR2FQG7Hcx1bCYwHW3DRjv5DUPQd	1613	983	516	12463	18422	jx1WVTD1JJA5SidZkrfipi1Y6sDZtzEuKjkXsFbdnQdtoio8uej	13233	18619	18619	1619290620000	orphaned
26762	3NLyDTwey9mEiF6uq9CCQHi59n7naizcAaUfzzPxvB1118qLH4xy	26760	3NLiAYYvRKxjxzbyyJonKxLz8opqYESGCTxWiNE5U2wvaPwjYzUx	1406	1393	516	12463	18426	jxn72aq9Gvjx3LM6kmSM9z8yDHhAK3h8vqpGCugGyZ5RhUnfumw	13234	18620	18620	1619290800000	canonical
26766	3NKeFGhsXAMFCNm3ysWXcS7TpWFY4ybHtqErsAGHEP4jJVAVp4dS	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1649	571	516	12463	18429	jw8hrCJdhxkt8LmMEt4vQwpL2ahiUNBmS8eT28MLJzUMgMQK2bP	13236	18624	18624	1619291520000	canonical
26767	3NKtJC1Q1ZEGAh2ovssk8ghueBFSz9wV5J4zZLjFfi6LMEWvHBqA	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1643	1299	516	12463	18430	jxHf1VdXpmNucY8eFNTqfhLKmBcqaQZKd7gdvXKoScBSCV2APLS	13236	18624	18624	1619291520000	orphaned
26772	3NLw98D1MscZL2tR9d1PTtsdmNMmhLHHVo7nbJGK1TkgLjd5gFP8	26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	1602	1123	516	12463	18435	jxJHFtBBTw195TYtCKATM5LEonZzriaXAecDY5SEjaFC8AM9zY6	13240	18636	18636	1619293680000	orphaned
26778	3NKnd8Q8DPi5xSB6LanSMRoGCsFDC1V1hnecHDqqwrkp466PWKmS	26777	3NKkdQ5UMVkBUidTcTExMkvXCyF4se5Hp5Ls9FwDKsnxX7ECqFGg	1406	1393	516	12463	18441	jxHDHdgsGmZLKrfuGZeFF9gJqRXjMeNyn5PcqwgjmYPxhijgtgU	13242	18638	18638	1619294040000	canonical
26779	3NL5YFwEBDQFtPP2H4aska65a5V27TMdTjVL8k1of66Zzo5ZQZXZ	26778	3NKnd8Q8DPi5xSB6LanSMRoGCsFDC1V1hnecHDqqwrkp466PWKmS	1407	1395	516	12463	18442	jwLAAxm8YXmRBuLSiNxuoN8vrEx84gyaT7w9KBA8VmH4ZS9zLGP	13243	18641	18641	1619294580000	canonical
26781	3NK5KEqUmjGHTF3cFqMSyrk9JceFwhzMUCRsbK8AQUJdnDjncC2B	26779	3NL5YFwEBDQFtPP2H4aska65a5V27TMdTjVL8k1of66Zzo5ZQZXZ	1419	814	517	12463	18444	jw74aMQiNULi6VLiNmhG4QBhQYBFojYcLPoPWM6SQukt1tx8ik2	13244	18642	18642	1619294760000	orphaned
26783	3NLcQmmN7M5penBaF39eugJo5yZpVSeQMSAz8jQhqPs4FudaErML	26782	3NKVgC3syGgUbfyXsAtKXgQFpv6yukb6VyDthFrZyprNWdKcyRgf	1607	1348	517	12463	18446	jwfTS2AS9ZgNG4B2tm3fESzfSJxoULuyx8nY5PtsDEZ2MUNUw56	13245	18643	18643	1619294940000	orphaned
26791	3NKKrhJ6Jeexyr4PBLZC76sK71LsF8kSBY442cRS6GC5CnvqZrTA	26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	1406	1393	517	12463	18453	jw7S42qeUo6C5psXky34XXa8m3U33G58PY1P3xG54raNm4AwxtA	13247	18645	18645	1619295300000	orphaned
26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1458	1323	517	12463	18456	jxm8PobAV3VBHTFe71dCAD4yLWNJ9MwhqnhaPjYCGTKzxtAnZQm	13249	18649	18649	1619296020000	canonical
26795	3NKoYiqYS8ik21afJ5AYvq1wxkkQAVX1gFzDYxkEFzTgWtx42X8e	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1523	955	517	12463	18455	jwDfy6mt4cDLkewFwmAW3YivbY48zTKZZZZW5HvPfLCySgHXaXQ	13249	18649	18649	1619296020000	orphaned
26797	3NKYzqAT6QYAkSehPgTQcN2PL7HQS99zpvWyGyC78NHcoU8mYF2b	26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	1673	1242	517	12463	18457	jxBPVK4DJW9cAYmR9N63yA8SmuM4giuCSmA5qYLcULZ2mYmdYy7	13250	18650	18650	1619296200000	orphaned
26804	3NLRXLNk7187sKyCM8Cu1zmxUano6EXWzK89MFLfyqGgy3KXXUwD	26802	3NLLkVxLveeFwZHGJsG52ZDviJJvutFMHHsuhfwg147iCCx2n3Xy	1460	595	517	12463	18464	jxe2KynDVATw9hPnUrhzSeiVFqpXFkCEGzjNgFJJFdz3JkYoMAs	13254	18654	18654	1619296920000	canonical
26810	3NLoLsXYjeSHv2mL8uHXAMxypeNEXmxx52bA5vRhYwDANsmAF3z2	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	1406	1393	517	12463	18470	jxmDoBmFFvHR63RqGsr3PAD5o4ymkm9E96P599Qb582XqGDwS1c	13258	18660	18660	1619298000000	orphaned
26812	3NKRdiDTazwTSxFbyyD5g7YHA3yLx1oo8XNy682cjAp1wP9a5GAT	26811	3NLZQ6RUNCdFrPJDLJ7wY94BQ2KrdezGoznoJwakW2prYMBMmZxJ	1522	1196	517	12463	18472	jxidSCrMkYopLDNMFGpgFuTp4sv9AcpL5zjjPCHxnCXpXJcutpb	13259	18662	18662	1619298360000	canonical
26816	3NL8myMwemRGhAW4UVGzuR2Lzx6L2Px58bdsArQrWsRNpPW8bEyE	26814	3NL1UWc6xqm7EmDLycSnWuFtoJngifVGXqZmi9REPKxLPn5wHDT6	1406	1393	517	12463	18476	jxGTK6L8Ke1dYsQgApPfYY5SRxGYQRqY9DyyrcYHdZh8YNFnZkf	13261	18667	18667	1619299260000	canonical
26818	3NLheLrwtd2P3D6YKTkR5KyU1hZocnRNbJowrDKcnC7qKF8g48LA	26816	3NL8myMwemRGhAW4UVGzuR2Lzx6L2Px58bdsArQrWsRNpPW8bEyE	1670	1282	518	12463	18477	jxcR2K4q29wySpapvaaau2j718xBAxSZEvc6tmvAnYiH3RAzBnk	13262	18668	18668	1619299440000	orphaned
26820	3NK6T2kkSekAtPh3K5Aja9uwYeffv79CU4HAHS9ubEWUETNQjVzh	26817	3NLVHx7sduMFX81VV9z2aqpv6gD8hXV99qsNDx5D26FzKgaJ6EsL	407	407	518	12463	18479	jwqFSxMLi769zmRRh4axw92bUwkgcR6YRrthBbaVDMv1a8ZAEiA	13263	18669	18669	1619299620000	canonical
26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	26820	3NK6T2kkSekAtPh3K5Aja9uwYeffv79CU4HAHS9ubEWUETNQjVzh	1405	887	518	12463	18481	jy367E8uQnTg38jeafVttnzekdBhr1RyiR6J2Es1vGDhdAKyDY5	13264	18670	18670	1619299800000	canonical
26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	26846	3NL2T3kxMhAR2DjDnKybHLYrNRckQLcVcVjUs4JJpaDi8fEnhYUG	1406	1393	518	12463	18505	jwBghwvkpGnv7gmReYHipkWkvnRQXbRXuNbnp3sJ5XRAhWvf4ea	13279	18691	18691	1619303580000	canonical
26849	3NLoAUapVGMshGLMpCNUcBmGVnmFkeJ5Hx5VWWRkA1VY8E78nA6k	26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	1474	1474	518	12463	18507	jwyRmY5e5YCqSJtZroK4yrjgE4N31x5QcFNL8JkxjHGTDYftZia	13280	18692	18692	1619303760000	orphaned
26854	3NLu5jjRWLPFrBPQUhpfvQ3z35MywpuyNTS1wuVsvT3BGmdgaCfy	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1406	1393	519	12463	18511	jwqbgufTthRjCLSvb8nZTPmTqsnQExthEuhVsxonTte4RKZTf8k	13283	18696	18696	1619304480000	orphaned
29047	3NLbmYaYpWVSYFezKcZSxGyjDFxiyDqN6SjXRGVX5bmrGfKd5mW6	29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	1448	449	569	12463	18974	jw9SnZDGTwW3emXgvsNdsWMFh89JLDJiPkRhaAFMd8nSPpC24qR	14325	20170	20170	1619569800000	orphaned
26741	3NLsGQ5zXZLwZx6nKDjkvVzD97Fe76aPZcKaX5GCAMAtrXo2cNhK	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	64	64	516	12463	18409	jxT5RFCQSAUBbKzZF3JgYFGxF634RaEy9BJuMDCKuq4VxZMNpNn	13227	18611	18611	1619289180000	orphaned
26746	3NKwc6C2d3CxnxpoxsM9zbMkWCRa3wezKiK5WH9yQvTWTfMibFwL	26745	3NLdTpGHkD4cqEiJozzwb5EbQJ76UyqqUr8L5TgaWfVNjvcJXwie	58	1035	516	12463	18412	jxEmsQV7J962SHx95VekB9SeJxd65F6otJtKYZz68GXinaB4LQY	13229	18614	18614	1619289720000	canonical
26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	26746	3NKwc6C2d3CxnxpoxsM9zbMkWCRa3wezKiK5WH9yQvTWTfMibFwL	1624	1208	516	12463	18415	jwm1nHNV9SYbDVXucrGZ3KDHS8pBkVhTLhbApmyTYsYc9u2eXXu	13230	18615	18615	1619289900000	canonical
26748	3NLFkap2XQXxAUfWowxuUqa6LwuRfTsQwAAA33gp2xxKxG2xEvuK	26746	3NKwc6C2d3CxnxpoxsM9zbMkWCRa3wezKiK5WH9yQvTWTfMibFwL	1654	974	516	12463	18414	jwVexptiru3MqBDP2LEVxbxZpBYyYua4fdNC77xnUx3j65JnfmJ	13230	18615	18615	1619289900000	orphaned
26751	3NLNnGJsyZHVLB67qDhQ74h6xhR7BiAtYo98Lonwu6uJsFAubuG2	26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	1506	1373	516	12463	18416	jwLUWRA7fixCunprEojdF7juLxfe8c9pKBVofApUrAuQcpfhRaJ	13231	18616	18616	1619290080000	canonical
26750	3NKa9QDWSq6vPdubkstzSdex6doK9qS2Z7HnmgjKAyt2TAviqpB4	26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	1506	1373	516	12463	18416	jwVz4SzosRSD4Yi38p9hWqhMv6uQaMEQmVaAKiqsQFyGc83W8zY	13231	18616	18616	1619290080000	orphaned
26752	3NL4u14WPcWK4hA55Ko89uk9iBVdm6tWs4C7bcvbKZW6AFUXE2cg	26749	3NKVu8iSu3D84AiuWcopKoXvtD8dWC6tvpuEHSZPvGZuqyRjDrNM	1506	1373	516	12463	18416	jx2FEExWGwgLkh14SujqpeE5WehPzeatUu4nXxL22a5EvFupB5F	13231	18616	18616	1619290080000	orphaned
26755	3NKjDB8zU2wjjHZLsfRCEm9JWR2FQG7Hcx1bCYwHW3DRjv5DUPQd	26751	3NLNnGJsyZHVLB67qDhQ74h6xhR7BiAtYo98Lonwu6uJsFAubuG2	1419	813	516	12463	18419	jwc5dTQ8eMjfvKz7xf25Bii4x8uvT7MkNAWMoLB1REEnPNYAmi7	13232	18617	18617	1619290260000	canonical
26765	3NKpbokjXhwbKXDfwcyp7BcekY9mB7G8brNL1SLHfpWYA7v5iwmR	26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	1422	971	516	12463	18428	jxk3SjQH3bok5ShnBMN8zGWzWmRwLwPKfszha9fKxzFDBk6VTiN	13236	18624	18624	1619291520000	orphaned
26771	3NLvJLu8t8QRAcJhV4MujHm5qZ4ZD32abCVtDDAY7KyucNWbmYYc	26769	3NLqsfZz3Q7JzpcRvx6QRppLxLVgDzf1dtuWhBduaNpj8PJpGsu9	1406	1393	516	12463	18434	jwMYrAY2f1LJLEM7yUJa51YGMP3dL33dS84s86npw7YqHBt1BfB	13239	18634	18634	1619293320000	orphaned
26774	3NKEXpi2DHkaausmDzb9Mw25grnvRzD2Ehy5axydpy5oTeQZtPcR	26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	641	1336	516	12463	18437	jwH3egsjmsyuQ1vTSB1HZPBMg5Hj1VS1gfzhZmiJHn8Ft4Q8Mtj	13240	18636	18636	1619293680000	canonical
26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	26782	3NKVgC3syGgUbfyXsAtKXgQFpv6yukb6VyDthFrZyprNWdKcyRgf	1406	1393	517	12463	18448	jwnyhp93B8yPFEtrWXynP2VeStUcyDjHmteWRbUni53D7qE55W1	13245	18643	18643	1619294940000	canonical
26856	3NLTCQpTLfi1oVXjTYoP7m3pEurQz4ssyrGU3MuW4qcVXXvT3tdZ	26781	3NK5KEqUmjGHTF3cFqMSyrk9JceFwhzMUCRsbK8AQUJdnDjncC2B	1553	776	517	12463	18512	jwbW6dYiM6Xtdk6vwNrKui9ZMeeu1DVk9o4WttVT7v6cGs9ZtgP	13245	18696	18696	1619304480000	orphaned
26790	3NLuDRpwAHf18zA9HtPpi91DqRejLjuHvACoxbMksCVakma3Ynro	26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	640	640	517	12463	18452	jxCVjSp1d11H5zAUqB8MXcvabSBhEV5q7mKt3xp1NC38iSA3nKq	13247	18645	18645	1619295300000	canonical
26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	26790	3NLuDRpwAHf18zA9HtPpi91DqRejLjuHvACoxbMksCVakma3Ynro	1445	1164	517	12463	18454	jxeQrb1TTQnyjukQdp71n3Tnnd4z7NvAjwvohpHt2pWnqx28tKN	13248	18648	18648	1619295840000	canonical
26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	26798	3NLn6zy7zS7nHD5uU47N6MnrdqBMy4TmeA9hC5LoQASaESEZvcb5	1650	1129	517	12463	18459	jx1Ezhmha81asVQPdhLzdCKVJXfTVABuoyTyY5uA3W8HJC7SpFX	13251	18651	18651	1619296380000	canonical
26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	26806	3NKpnMN5KMksu3FE7av6K7mfBbhms5kHBeSmDqf7DuemZ27WCznk	1406	1393	517	12463	18467	jw7FUuqek7zc6x8EpCEZR6w6k9ceoxgQSF5TCMBoUcqPw27iqXT	13257	18659	18659	1619297820000	canonical
26811	3NLZQ6RUNCdFrPJDLJ7wY94BQ2KrdezGoznoJwakW2prYMBMmZxJ	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	1407	1395	517	12463	18471	jwTfkDMWUJAxpJ5sF5Ef1cAJwLzgwVH9JKRCs7KUCVUJbLGrLDy	13258	18660	18660	1619298000000	canonical
26815	3NLbxdrFzwfbs2qRSeWKn8Kj2FzSCVrGYw7nX6L8UH8RmyeJioNq	26814	3NL1UWc6xqm7EmDLycSnWuFtoJngifVGXqZmi9REPKxLPn5wHDT6	1407	1395	517	12463	18475	jxeCLte716LV92JBE1eNiem7V9nShgZmTs9wqKsRDpnD8LEauma	13261	18667	18667	1619299260000	orphaned
26817	3NLVHx7sduMFX81VV9z2aqpv6gD8hXV99qsNDx5D26FzKgaJ6EsL	26816	3NL8myMwemRGhAW4UVGzuR2Lzx6L2Px58bdsArQrWsRNpPW8bEyE	1670	1282	518	12463	18477	jwuD9owLrMsgVuZHMuGeVszEv8UuH1DvwaMCiBuFJfy8WWp3ohW	13262	18668	18668	1619299440000	canonical
26819	3NKTgWodxxJijW6WH3M9CSpRrpiVbwLUAE85uKiBdq5yfARizSim	26817	3NLVHx7sduMFX81VV9z2aqpv6gD8hXV99qsNDx5D26FzKgaJ6EsL	1397	838	518	12463	18478	jxR5f2VV8qhaQMjV4YvcHhodDtu9xui3HsjhUpoW96MAoU2dbH6	13263	18669	18669	1619299620000	orphaned
26827	3NLamj94d7H8he5CHmfsXJEDNvrHaoBRMDAcXjFUMvuNtnS75X4G	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1654	1340	518	12463	18485	jxvTMzbtJkCW4TbpPQg9Y7e9YenJojrFHUzLY4TEaKgZA6ZS11m	13265	18671	18671	1619299980000	canonical
26828	3NLQPfdVfDWNW3McFcctfEyBsfzgqwx4BsXKtf7tCdk8Ngg1h6qE	26827	3NLamj94d7H8he5CHmfsXJEDNvrHaoBRMDAcXjFUMvuNtnS75X4G	1406	1393	518	12463	18486	jwJsahqWzJLNb6bb8Nbw4U7BXBfNwcdA1y5ZUv92JDdetL1Hr9B	13266	18672	18672	1619300160000	canonical
26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	26829	3NKbZg6JcDtNGCdMkJC3zwCA4JBcLdi98qxANZFp84mLLueat3iZ	1406	1393	518	12463	18489	jwNzqYEErTn6SHuSV1TFU7YPhseUk3cHjdqsXJkVFtRKshnjHwL	13268	18674	18674	1619300520000	canonical
26836	3NK4n1HjJXSythSEtmTECw5Hcx8HRTDseAyNLXTJVjo4LD3PiFYE	26835	3NLEkYJ8LUE2sWpjWTSFPWEYidifTRczoqNmqHqVg7ik6zKK16CW	1547	1378	518	12463	18494	jwApzCba7Sh9csWY7C3EfmpZ46FjJxZhWouVS8G3iULMQrXWCRs	13271	18679	18679	1619301420000	canonical
26843	3NKRVVhqwyaMt89xrP2nD4JifiwtCznDQxCsfy81ZAtcXaXB8FHS	26841	3NKFhftGUAhUH4V4oxQ5NGc31J1haf3fxqbhqoyqVykEL87GxK3X	1406	1393	518	12463	18501	jwFokuS79rqMoSwv4BrUMEpXQjvobEtU9kRc86KcU3us7eiy4XW	13275	18683	18683	1619302140000	canonical
26844	3NKYLsG5vkxkT2f2QgQCK8Ura5wuzKQLi1xeHkuzbqvWkShcbf8i	26843	3NKRVVhqwyaMt89xrP2nD4JifiwtCznDQxCsfy81ZAtcXaXB8FHS	1406	1393	518	12463	18502	jx5K4wwh7i7GmKon7nnvw7Xm2e761ouLBzZ62K6AZ8CbQ5UtU3B	13276	18684	18684	1619302320000	canonical
26845	3NLdzrSwufXdHcAwYhznFtL13vkRWWkjchqFc9RDEtS6aKDkpPLJ	26844	3NKYLsG5vkxkT2f2QgQCK8Ura5wuzKQLi1xeHkuzbqvWkShcbf8i	1623	830	518	12463	18503	jx8h8hpaycx22GJTvXYHA6fpRKPreAZDxDapryfRPB5u87diYTu	13277	18688	18688	1619303040000	canonical
26848	3NLWnXvTHkqhsXEeXVPTC6HQ2kpyjqXoCTE3VUPC6b1G3BC5KdJP	26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	606	1295	518	12463	18506	jxKXMVGxiptG2AvTh1JiFvugsHaXWq1vkr2VhQVhQQ5uZq9F3GY	13280	18692	18692	1619303760000	canonical
26852	3NLyCyWKJ8RX8o5BKSFcSeNryUEzpnQedhDksBLq37XBhAgXnuYx	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1527	1167	519	12463	18510	jxvG8kvvhTAdCssWFN3vFKueXdMKZpdQV7jaHcsLzf5YtMrzAGd	13283	18696	18696	1619304480000	orphaned
26855	3NKsRGHCc7sGq9cdYGpNTTWSJupw436SB5A76hjnYJDfAnQdSW3E	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1527	1167	519	12463	18510	jxywive9MdFAhguJJCVWucoBmJQ9WHcGTWGt1C4S9gLNfvv5pZr	13283	18696	18696	1619304480000	orphaned
26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	26853	3NLnQyG2s7Paov9KRWPWMXoRKwNq2tNdEByU2udVwJNxxiGh1x1W	1457	1265	519	12463	18513	jwwJvqNYQTPUAA8LXWADpxdXNFb3pyUvQzrHWhotKZSHvJPRrX8	13284	18699	18699	1619305020000	canonical
29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	369	1312	569	12463	18974	jx5BR9Z3uC11vRehaSB3d1Sbd1LXVYM9CLG5NQ4VLRe5FostFNV	14330	20178	20178	1619571240000	canonical
29571	3NKZuqTFPL5PZm2U3CiVTUHRL5nwRmSzisS8EpuMoU7TYfLGyk8A	29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	1664	545	582	12463	18974	jwoGaAQZtNE2rztrsoEjobiZWsx57g8Z9mGmtu3LMH8imqZuSR4	14580	20524	20524	1619633520000	orphaned
26821	3NLK1AsAU5xNpS7qtfPrHJPFkWxo8QQE4BNGegtbVRc2e8v4jDgQ	26562	3NKEWamVwbHfXUAMVnwy4wFXwx8EXmfZGbphLJtc2Yw8CZBPVrUR	407	407	511	12463	18480	jwZBdzFH7PqK5VykBynjVxwJb87RaSQK889XRAufgErSpp67iu1	13144	18669	18669	1619299620000	orphaned
26759	3NKN1eUKMR31cQLi1j6H9yr2VaVYcmNQdX8KAYRxYtuC88NMMWKi	26745	3NLdTpGHkD4cqEiJozzwb5EbQJ76UyqqUr8L5TgaWfVNjvcJXwie	1405	841	516	12463	18423	jxbHFyjf3irnFXRmnz8JJwr3U4LcSjCUSSkwmXHTKxfTKBWAR8r	13229	18619	18619	1619290652668	orphaned
26763	3NLJCuhBeenf42bRqSSzibUV3MpQGeu6vpphb1Di7b8ymDPRLJWm	26762	3NLyDTwey9mEiF6uq9CCQHi59n7naizcAaUfzzPxvB1118qLH4xy	1652	1315	516	12463	18427	jw7utVPEjwC3uFdZ1ohpJZ8nnkEAY7ptediFA1JFbxCsy8gm8B7	13235	18621	18621	1619290980000	canonical
26768	3NLXSEuPFW7obE6UYgdYNArR7oQ994WcoRyaUYKVyrAe4d9mHCFZ	26766	3NKeFGhsXAMFCNm3ysWXcS7TpWFY4ybHtqErsAGHEP4jJVAVp4dS	1675	1342	516	12463	18431	jxazif93J5ckKrR6psr6Wf9ihy6qcsq8hRF7fYwK5r5MuiiiDQ8	13237	18626	18626	1619291880000	canonical
26770	3NL4JxWZaK2sZ68vedjE5f7GKBwJC4Kyt9eR5NVskrqTrqCrWCHn	26769	3NLqsfZz3Q7JzpcRvx6QRppLxLVgDzf1dtuWhBduaNpj8PJpGsu9	1490	1028	516	12463	18433	jxWwjXnFFzofuFbFT145GBzLGupUAxAp8YcCB1EmD1C9WvrFS28	13239	18634	18634	1619293320000	canonical
26782	3NKVgC3syGgUbfyXsAtKXgQFpv6yukb6VyDthFrZyprNWdKcyRgf	26779	3NL5YFwEBDQFtPP2H4aska65a5V27TMdTjVL8k1of66Zzo5ZQZXZ	1601	1388	517	12463	18445	jwzyH226T3fWAmabWQrUPuEJHZqRnZu3ZNo5C2zgXywacGu44e8	13244	18642	18642	1619294760000	canonical
26788	3NKtyRLZV59nj1EbcSxopR1b1dWLE32CWhWRvj5xBBYUi82ousbC	26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	1506	1127	517	12463	18450	jwGzbTF2G1T2P6qS9v1wMyvWgzb2dytobgQWrKYnhhZWnekxvFu	13246	18644	18644	1619295120000	canonical
26786	3NLVDVm2Mmeam5x7MQg5TTtWknarSrg68ftsi3E29AgYRDqPKt2P	26785	3NL34pdasn1VFfZwpX8sr8a2tVw6MabttTDGqgsgM9h6MBUuG5aA	1672	1039	517	12463	18449	jwQMmDueoKusihkKDS6vAALFHVpm62hCJmJYRRBTT51rhhU1pet	13246	18644	18644	1619295120000	orphaned
26800	3NKd4r9UPQcV4RK4L9HQA5f3QSMX8kXqbmfgGhkYRGG9uPYKUwWL	26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	1403	824	517	12463	18460	jxvPtMsbAGpbcrWUx1efgyHWi2FR6gpk9XiS45hnJ78fJEC8PDm	13252	18652	18652	1619296560000	orphaned
26802	3NLLkVxLveeFwZHGJsG52ZDviJJvutFMHHsuhfwg147iCCx2n3Xy	26801	3NLCcqYaHts4qtZ8F3nmf1qtx5u6irTs8qMBTaeXPRSJ7VQwTaHV	1546	1213	517	12463	18462	jxWPiJgtwesqSmKxhCsZcCiLJpHmkwvManQsFpC9BAPZHawWqBu	13253	18653	18653	1619296740000	canonical
26805	3NLW3h8FE7fZiyhzgLJdPuud2F2j34Rz7HHPFqZb183oFGcWPoET	26804	3NLRXLNk7187sKyCM8Cu1zmxUano6EXWzK89MFLfyqGgy3KXXUwD	1637	816	517	12463	18465	jx8BDLuWLMSVnCJzEoGkudhXBvFwQxS9H83MRQRdMMCMtQz8cmu	13255	18655	18655	1619297100000	canonical
26808	3NK6vYYfAsbeRiZsG1W1gwSdzoHesvXuDQP7JyP4ZzQrEkH8Ewvz	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	1668	1124	517	12463	18468	jwpR1W7gKEk5SAA3z5sQBtpgJ1RykgprCfHt3vZ9i7PrJypTszx	13258	18660	18660	1619298000000	orphaned
26813	3NKEMp9uGEh5mRp1g9SCm2NWgSwHXbZ9ysFy5M4ocv2Gi3qryhGp	26811	3NLZQ6RUNCdFrPJDLJ7wY94BQ2KrdezGoznoJwakW2prYMBMmZxJ	1637	816	517	12463	18473	jx99zMH7zv8EjSaJ2SsEBMgVU3mYpeRj6opx2xsfMb1bFLMMP6d	13259	18662	18662	1619298360000	orphaned
26814	3NL1UWc6xqm7EmDLycSnWuFtoJngifVGXqZmi9REPKxLPn5wHDT6	26812	3NKRdiDTazwTSxFbyyD5g7YHA3yLx1oo8XNy682cjAp1wP9a5GAT	1407	1395	517	12463	18474	jwVje88BjF4aPRXeQUGSGuqXtp3y2KB5BbnFYgFiRipteTbMq9R	13260	18666	18666	1619299080000	canonical
26825	3NLtAN6MYd19yNHZCVwm2z7kdY83ooTCKindUbtYX4vcxGkbURh4	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1440	1011	518	12463	18484	jxbG6erkkKfwBEp7dGcQ4pVFoKRMxu1ihk9LYnSFcnxMdCCxdQo	13265	18671	18671	1619299980000	orphaned
26826	3NKPJByXdTTfAiZRbJugWzUAuH9faZVCi5DKfxLh4Kn3AmqsCpXP	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1440	1011	518	12463	18484	jxn7ooPmkKVK5Btq26LyZdBtD7WpWFGVpzgk1SbMWasypKoLReJ	13265	18671	18671	1619299980000	orphaned
26829	3NKbZg6JcDtNGCdMkJC3zwCA4JBcLdi98qxANZFp84mLLueat3iZ	26828	3NLQPfdVfDWNW3McFcctfEyBsfzgqwx4BsXKtf7tCdk8Ngg1h6qE	596	1060	518	12463	18487	jxZZuU16YZmsFhQDFCeGFzg5L7viQWFPArdMv8FxjCS62QJFAm4	13267	18673	18673	1619300340000	canonical
26830	3NKphSE1FMyhb9XKafUSbeQZpnz7dRYmvjiXJhZVYWpaByZ4d5xn	26829	3NKbZg6JcDtNGCdMkJC3zwCA4JBcLdi98qxANZFp84mLLueat3iZ	1637	816	518	12463	18488	jwGbLJT4heGD299XNSqTdjHaypVibSzK9xT4wszYvd8zeEdS58k	13268	18674	18674	1619300520000	orphaned
26833	3NLmJNWD8EHTuxzg9tsBocCyxd2NGX2qSQbZ8SBLDMHWfs4qL8DF	26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	1585	1240	518	12463	18491	jxA7UxcpwXvkVWrMCFTGFD7q5BPpDTsZTBPC1GWyjBQf2BgkhcP	13269	18675	18675	1619300700000	canonical
26832	3NLZVBYGsXdZPnMDY65U2CAnmrAXVu6Ddq3JoRKYWSXDuRdVZfBf	26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	633	1138	518	12463	18490	jxCf15xdVAeyBu4KcU8JghLiK1xqCW8QsLfMno2DBrFgvNsPdjn	13269	18675	18675	1619300700000	orphaned
26834	3NK4d9CbZ7bB77gD2aeu3B7AYy2d8dXmH7ssNeG1NHHFZRzRtQnP	26831	3NKEZ3U5bCKFdHnFVNjw3TVyBEfzucyq9iD8QKtW9o4dCRBMj8aX	1631	794	518	12463	18492	jwfHvQNkEgPeXnB1CciQv4YsUUxUuLgJyjKYJM8y2Yux1RkHHKn	13269	18675	18675	1619300700000	orphaned
26837	3NL1Zs616DtZX4KNwSvKA7msoTy8yz9FniqSetBApcppUEfX7Xqd	26836	3NK4n1HjJXSythSEtmTECw5Hcx8HRTDseAyNLXTJVjo4LD3PiFYE	1467	1250	518	12463	18495	jwKZJuVKJNb1w18zoCPYEWXwBuhBJcdbccc5KVdRrKvE3gD12oy	13272	18680	18680	1619301600000	orphaned
26839	3NLfjPyzXKkPNHX7Hj8sDigy6tDPrXJfaWCT3v3k7pTyWA7CkBPW	26838	3NLQovMK4TrDpeh7Ca5boCBNn1nxH7CG3mWp62X5cpcrFQmeGeLA	1403	824	518	12463	18497	jwWdjrxUAoXPcqaiQVdvUUBabiFLfDUeBcsEWyh6u7f4Psvp7gs	13273	18681	18681	1619301780000	orphaned
26842	3NK9QmMYEGCZBu1VwdvknWPLGHrfKwhoUXhMExhhfrky4hqh4Jgn	26841	3NKFhftGUAhUH4V4oxQ5NGc31J1haf3fxqbhqoyqVykEL87GxK3X	1403	824	518	12463	18500	jwTuiUG2CSqN4VJhoqtjevBUHtgpyqmKNY7T5WzyK7QtqFSKtwW	13275	18683	18683	1619302140000	orphaned
26850	3NLYfvCLF2dXhr6eyJSSDveGSSz4Gyj57k8dYuPQ7spSnttXqW92	26848	3NLWnXvTHkqhsXEeXVPTC6HQ2kpyjqXoCTE3VUPC6b1G3BC5KdJP	700	832	518	12463	18508	jxr3K9zPF1obbnbhcFPVgz4XY5WbYLCy8GyYgGgYzAN5Ji4CTvS	13281	18693	18693	1619303940000	canonical
26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	26850	3NLYfvCLF2dXhr6eyJSSDveGSSz4Gyj57k8dYuPQ7spSnttXqW92	1403	782	519	12463	18509	jxNNPKdQTCuto5YqaUHRMhRoFnz2jwDkGBEyonWGDvkincgCrHf	13282	18695	18695	1619304300000	canonical
26838	3NLQovMK4TrDpeh7Ca5boCBNn1nxH7CG3mWp62X5cpcrFQmeGeLA	26836	3NK4n1HjJXSythSEtmTECw5Hcx8HRTDseAyNLXTJVjo4LD3PiFYE	1403	824	518	12463	18496	jwccT6mqEZ6VR6xRZKGixYJAnmetVT7C4h36rSUZTyyHN6Ev2Lv	13272	18680	18680	1619301600000	canonical
26840	3NKc1rUAj7zL3HdcRMLcwTTKYZKN1mpeJgyf6vTDxLq18qPU11zx	26838	3NLQovMK4TrDpeh7Ca5boCBNn1nxH7CG3mWp62X5cpcrFQmeGeLA	1407	1395	518	12463	18498	jwWfzSMi1nRpNrxVWFpHuvzKrF2w49edrGQp2bd58rdwyn9Yooi	13273	18681	18681	1619301780000	canonical
26841	3NKFhftGUAhUH4V4oxQ5NGc31J1haf3fxqbhqoyqVykEL87GxK3X	26840	3NKc1rUAj7zL3HdcRMLcwTTKYZKN1mpeJgyf6vTDxLq18qPU11zx	1650	1375	518	12463	18499	jwnQtdEzHokTTPkQei4HZ8Bygx5dBfkK2xACGfeEkviZK2JrF18	13274	18682	18682	1619301960000	canonical
26853	3NLnQyG2s7Paov9KRWPWMXoRKwNq2tNdEByU2udVwJNxxiGh1x1W	26851	3NLQKsVoHZsSXN3kP6RJ4Z8VH7LapEMfsQd4aHr4X3d1YudtbNy3	1527	1167	519	12463	18510	jwXWL2gzPYqrCZbB3h36GBjsVz4pj4BR8TatgYTLk9xGKbJTmy9	13283	18696	18696	1619304480000	canonical
26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1607	1222	519	12463	18515	jwZrpqnukSgW5i3oLMTH7zshHzDBHSCy2ykfJkQDJxrJr4s7JUf	13285	18700	18700	1619305200000	canonical
26862	3NLXra3V2ny8116xBGFmn7G8ACwoaFQndmpsK3m2nd34qynTQyQ7	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1407	1395	519	12463	18518	jxEKvNkgta88AAsZCPPkkgeani29A8yijj3PrXn9SrLGrswvfXg	13285	18700	18700	1619305200000	orphaned
26863	3NLBa7y1SFSCycH7QKhYxFhJzoHon1KqVn3zgwBRKhc1dd7oUaoa	26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	1588	1026	519	12463	18519	jxZFr7xQxvbvyqiw2mJ6b4bQshcWEnPqRVmC1vPsaZKejoZwPpo	13286	18702	18702	1619305560000	orphaned
26873	3NKTUcEHQxKtHeSiUyNyxT6A5VkebNXXFKwsv3XwTuurEsAA8PW7	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1652	1315	519	12463	18529	jxSSJbYPT1RfaVXc4md1FhZaH86Fpj1PJLK3NEPLMfHxoT799DE	13290	18706	18706	1619306280000	canonical
26870	3NKKyAyfuRfRhf3JXjRj82ATi6kZxwPihAbjigC6zt98KZEacReC	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1403	824	519	12463	18526	jwonfj3qpfwn66xMNgdkEFM9gkJe6sSVJCVvDkNX2yCVTPL9FhQ	13290	18706	18706	1619306280000	orphaned
26872	3NL5vAMkAjbq1aPmDfWsnbj6L4B4gR9oc2WVdjL3LMp3RiUS1LyN	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1501	1360	519	12463	18528	jwS3pLCn6tEr9fdm7QPkUkjJpzU56YX1HJK4tFMw1KT1cExQEmX	13290	18706	18706	1619306280000	orphaned
26879	3NLWyzyYK9i6eHGq5AcvgyrTJwVAcxEYHRmdkSRENu7vhGiqByQR	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1402	868	519	12463	18534	jwZ3zu4uBVb9pfUtec2zAyARgyZLNEyW8pkmdKqcdj9STriSAot	13293	18709	18709	1619306820000	canonical
26878	3NKmHbtkJWVnzHRbMA71YACafeLxzKsX4YYPg7UnatdznWDpFV5B	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1523	1321	519	12463	18533	jwhvThA6uUt8o8yhie2SnGUJDura7XWjCFMyk5vz7cF4zfc5pBK	13293	18709	18709	1619306820000	orphaned
26886	3NKbaEUvKnPDpwcbLbEPerNU9j6jYY12C7hqoHJXt3R5r3zeGSHU	26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	1600	1372	519	12463	18540	jwVZGuo93g8uy8ogU6XEaeEYFppZ6Pn5tfUQxDGhhvVhkUTnq7a	13296	18714	18714	1619307720000	orphaned
26891	3NKfRSPSKnMoZA5LHhq8w7mdDeii9zqxeVY2mKatqp1qazuxPoHg	26889	3NKHpBdNQfvgKRc1yiE31NeCJyApAZRfQPEwr1XWH8qiHCdBMtPF	1406	1393	519	12463	18545	jwLHQbYmGuN5JruNW9yVufvHPNQ7TrZweBtkkzGmBHASFChHyg9	13298	18716	18716	1619308080000	canonical
26903	3NKY1HnEeB6FN852c6un4fu2doCiFtJctH493SW9wfJJkKgANNkS	26901	3NLcq2us3ZdkmxSTDXCvxd4x4tThTVfkgtsMuUCBPUTqCWej5ZPM	1643	1053	520	12463	18557	jwfvxmFWBu6xKC3LhAmHMxFeQSjAuiXRLEp1sjdLiyaWTLrW4XQ	13304	18729	18729	1619310420000	orphaned
26908	3NLNKTHQcwVZSPiRNi488MpDGKuRZV3DjVU6Nz4N4uPYiWLGWrps	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1476	1371	520	12463	18562	jx4Gg6ABNvxNRgJy1kvajakBFN6pWne9epLYUrS4wQ55c9ucRQV	13308	18734	18734	1619311320000	orphaned
26912	3NKfJqLasA7U3ueLiZZPp3QZZjkcWAG9Amn4GZwaf1nXpEuC2CD9	26909	3NKY7x439L91krJ9K5nQdNy8jBraPMRUZongyXRHrbt8TTMnGPP8	470	1309	520	12463	18565	jwK1o3iqupecZXYzWPkFLBWNSJUwzWzMDV1fe2QPdecSReHhw6Y	13309	18735	18735	1619311500000	canonical
26917	3NKzmwyyh9BeDdGbG9EkKNURPWndKEkpduKZzT3EnVR2ygrwNafF	26915	3NKKtTLQfXzkMCYF5rKqP1xPjywJYd3ouceUucWRm4uUc1V1UEp6	1474	1329	520	12463	18570	jxKKdWDV5k7FHPB1Nf5KHkRhQwK3VMnKKMRFRw8rjdcXQ6yTYh4	13312	18738	18738	1619312040000	canonical
26925	3NKCZxjYDDeJTkh8GjSdsQ5V6usvqm4z5RhWkFWbPNyi6givRNCf	26923	3NLrWo8e7LCtVX8ttowoxvVLseWUXCxouP8MQentfysE7N8GpWaE	1407	1395	520	12463	18578	jxVPou1DLZYenXemD8EwseNg9wbzrt5BJf2PuFXwCbAXYdtNyep	13317	18745	18745	1619313300000	orphaned
26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	26928	3NLpjQztVF8oSZGLGhVoKS9peFe4JXzYkyDjuBqiLH45KFJYUtqe	1581	778	520	12463	18583	jwGRoFEkmEepqPijEx5xUATzvuC7Vx12DyanPofofutGqni1qMS	13320	18750	18750	1619314200000	canonical
26933	3NKgmEbx1PwtMsatRERsofEDGPyq5gncrefiiUuTE2VVFhvAcU44	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1448	1311	521	12463	18585	jwC2rszB4f1PLGJrxLZz8AaGagdw4chyFg53hBCTUpVTAowcvbf	13321	18752	18752	1619314560000	orphaned
26935	3NK5RdFNp6Pywo5P9cXAWi9Sa528sv7gTdhhSyth8rqncc3qx1Qv	26932	3NLeYZbwuWVMYbF6HJxxPabvm1WGXLHzXQ3RN2vU8yEyux3a1qxk	1609	1087	521	12463	18587	jwtX7Uh2NJG1DYF7pY1YBnuNBvj4YMw9b7Cj3HahMNHd2zbvWpt	13322	18753	18753	1619314740000	canonical
26940	3NKnj4u8TFXDwC9XLjPfPY1nB168pumkkpbDaEkk56wVnxffxmqx	26938	3NLZNpXCDUwky8pyBajfbQR4jC3fi9CdS3pUR6TJssPHHsbsAhG1	1406	1393	521	12463	18592	jxwbW71PTWb9B4aJtirYZaV2Wx1wjCrYGmv14d5y43Nf2VxXfvu	13325	18756	18756	1619315280000	orphaned
26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	26947	3NKgzUX89HTL4n8AaNonuZbawxopZTZHWoC1ohzqSUApnwLsAN4o	1440	1377	521	12463	18600	jxajR84y9JvQWFhRA28vM23JYhD4xTJJ7atMeD36mV6HYHUJHyj	13330	18766	18766	1619317080000	canonical
26950	3NLbnui5bBiNYbMXpNjtfTvdtBiKq5ctEKXm9h9bqYHgqfdEidNr	26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	1403	824	521	12463	18601	jx5DnqYEgt1bt9H4uSknkgTcdxwoGwKMugKPyNDmgMfg6EqHs5b	13331	18767	18767	1619317260000	orphaned
26956	3NLMSL5cmbYQU8Wsc9gdaWa3FsRRAqi3g1GnjVeDfJF9BpfGyCET	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1648	1284	521	12463	18607	jwxzFThUNjTdUPtVumWVrTo7mWff4wdBqx6esqsRsg3DPbEqXfT	13332	18768	18768	1619317440000	orphaned
29063	3NLb2uCBUQTNJmWUdmtXKPysrSQaFLD7ntToUc7YYACoYC5NjxAb	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1508	1387	569	12463	18974	jwSYWjRGJSE1XkMCM7VmvZAJg5izVq5GrcyBbefxAaF6EMLLMYs	14330	20178	20178	1619571240000	orphaned
26858	3NKofA4BgGYzDS1DWJeXZWW8nkhXJAvjcMxbLw961ddfJetCMgMC	26857	3NLMsc4cMfm5yucFeLYYcrETxLQsYDz1YM1AFXy1HnemKr7BCDKE	1403	824	519	12463	18514	jxUGkRGyzSuJwX5mTr82jyWJPfoZSMNDHHsyRwnfELagZ5rAqU8	13285	18700	18700	1619305200000	orphaned
26865	3NK7DMe77iULxPjcVg6MGrhdRLrD6X9LYuLFcGezVeAJBC3K7acV	26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	1634	965	519	12463	18521	jw8pTnQueR9itFjQkGKjcoRSnjFK8VGtWkwZW5DuUzY4XgKUtme	13286	18702	18702	1619305560000	orphaned
26861	3NKHBG6iZ7EALdpAFYvht1QPsLCUwLTe6o54T9KiQJaCYp7AHzSj	26796	3NLa8cKs6YJGcxFNjoM5L5Fj82GvL3Cs9eNJtKyrhmF2HicEjSdC	1607	1222	517	12463	18517	jxSKFWCsvqnGv8Qu3AtfaLLDKxFeMMZwLPGjY6pN5nb9Y76Qx4s	13250	18700	18700	1619305200000	orphaned
26867	3NLRcpiwX17p4HBmemaaj6TXkGzBZKE8cuLX532A9p2qejKadiSf	26866	3NKdnkc5HGg8ZNr7r2UyUN8SKAgnG8uaHf3VtMuPN9RsGXiDoUUP	1639	250	519	12463	18523	jxroLb4z9ZNn6ztBhRQ5hjmfpmo8xJYcDg9kL8sw8U84CYzzkCf	13288	18704	18704	1619305920000	canonical
26874	3NKfS55GTBsGQx8PThyf4VEQrKRa57sNdKWEdL7oK6Bwfg1sZxPx	26873	3NKTUcEHQxKtHeSiUyNyxT6A5VkebNXXFKwsv3XwTuurEsAA8PW7	1577	1201	519	12463	18530	jxjyrBU4Cqk7yCZ6Ujhto2K8qg1kfqSM6VKZa2LnybfMBN6yLAe	13291	18707	18707	1619306460000	canonical
26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	26874	3NKfS55GTBsGQx8PThyf4VEQrKRa57sNdKWEdL7oK6Bwfg1sZxPx	1637	816	519	12463	18532	jwFksn8i5wth1R49NFHazuZMHeRR6e1yFceU7XEXiH2ddmDoCWE	13292	18708	18708	1619306640000	canonical
26883	3NKJfTwpNDr8yXcrzKXSC9okfkLVQgZPBf4vRqWyXz6W37EGfe4M	26879	3NLWyzyYK9i6eHGq5AcvgyrTJwVAcxEYHRmdkSRENu7vhGiqByQR	1657	1218	519	12463	18537	jxo4VKxW1bHk19D3VYDzYifEXZR8PsJgEUna3iXiyA9VKkN35bj	13294	18712	18712	1619307360000	canonical
26885	3NKNC5EjGvPKQEssouVQbQtAhfWDndew8zRjzyGSQbG4gZj4GYDA	26883	3NKJfTwpNDr8yXcrzKXSC9okfkLVQgZPBf4vRqWyXz6W37EGfe4M	1460	958	519	12463	18539	jxFautUrxDMaHrGwWjSvVaikUy97mciaQi6zjEbHKzqV22Fn1G9	13295	18713	18713	1619307540000	orphaned
26888	3NKjb17DthVRgdf3DZ1U1znvjzMZKrtBws5PaHfuomT89PytXoGy	26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	1519	1519	519	12463	18542	jwM2yZowunoGTCxnVYNDvY55M6ZZMf9YtgF9ngg1HRsgGjzgpFS	13296	18714	18714	1619307720000	orphaned
26893	3NKH9aHRjPXdBH298upxkd1kQpG4gneN9LKXDXfPfuEpBaN8wsQr	26891	3NKfRSPSKnMoZA5LHhq8w7mdDeii9zqxeVY2mKatqp1qazuxPoHg	1397	838	519	12463	18547	jwgv58TSo7CPtNWDFD4T5t8jKTCVrcckE1b5JaQ55MizfATBmdH	13299	18717	18717	1619308260000	orphaned
26899	3NKynasAzS3vcPH9weU7fxzzuMTb9ycFjEVNyo88U5ufpa4intHr	26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	1500	1297	520	12463	18553	jwmURTAKAmq96wEUSbnZG1a2wdvyodCf7z57uZ7aRFhggmWsPtw	13302	18726	18726	1619309880000	orphaned
26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	26905	3NKq9MTofg2HdjG54Y6csifPhqgsdDgFBRNwhApVgPHPZMo7wu6f	1447	1219	520	12463	18560	jxpgopjxNA4VHfgWr58yyPQSiQPoUXL9Rrnota5g19f3mdLuFsx	13307	18733	18733	1619311140000	canonical
26910	3NKTbv3h5jcXpSjfuTiLSEEG8Z7Mgid6HkeFDHzuQgrc4yxKhcgd	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1448	945	520	12463	18563	jx9gJ63QcJ5NLZMMXLfUAz5GaZDH9pQBx7wxP11Q9WHSZ7uUvPZ	13308	18734	18734	1619311320000	orphaned
26914	3NL2iXYJmHXidD7n1JT9XHAstn2LCFoJQzTxiVL7jHEqb96j2nPz	26912	3NKfJqLasA7U3ueLiZZPp3QZZjkcWAG9Amn4GZwaf1nXpEuC2CD9	1508	1387	520	12463	18567	jwArVJgYGeaNdiGjEVSasoaan8PZXCJELVrUhrLr8kKGPLBQboE	13310	18736	18736	1619311680000	canonical
26916	3NKnAWB3YNVPpG1ee443DpxjAEaJymcwDV8YLp4SJsD52ChJEFt8	26915	3NKKtTLQfXzkMCYF5rKqP1xPjywJYd3ouceUucWRm4uUc1V1UEp6	80	1273	520	12463	18569	jw8HS6DBALpKBwkVMo2deK4ToRAHvN2p3LU81N9QAfqC2dyc5yX	13312	18738	18738	1619312040000	orphaned
26919	3NLMsvZpSzWTd2zyPCutwkwa3hLHrzZq8kSEXYmoHqzLg6YRyGwp	26918	3NKXgSMZY8zUa8YJgLaBPBTxqjQyrfkff1CdAvyxomfimExp6tuU	1406	1393	520	12463	18572	jxxSWxZ9p979uhBd8g9iqp6cUoeSRyPqRsqdNHdENckxsrGsEF9	13314	18742	18742	1619312760000	canonical
26922	3NLN5FJ1JVhSG3dtzqyWhEzNeTNqizTJN4aan3Bn1cWg4vyPCSEA	26919	3NLMsvZpSzWTd2zyPCutwkwa3hLHrzZq8kSEXYmoHqzLg6YRyGwp	1406	1393	520	12463	18575	jxxZ75dECVMhfAsaVHBSbcyJY9A9paJXDDkW5yxG2H5CWWAb2bx	13315	18743	18743	1619312940000	canonical
26921	3NKYxFgWGJqZD94AQn769AtoT6xBeyMuSBBiifHqeADfkCPS9PN8	26919	3NLMsvZpSzWTd2zyPCutwkwa3hLHrzZq8kSEXYmoHqzLg6YRyGwp	1587	991	520	12463	18574	jwGUv3aeNZcs1JekX4dgoa5GrxXMJyS8AxiLobfRM2FUpUMCgQJ	13315	18743	18743	1619312940000	orphaned
26926	3NKXwYZf18paQVb1UgP32XKRctuL6VMPqjxFVprPmivVRBtwfWsq	26924	3NKoFfdjz6cZdNgNbjHFP9ajsbk823Lpc2a5TNS7k5cpoWQJsYmb	633	1018	520	12463	18579	jx2BExpP3TVz7TU3VyGboQr51ryG5KerBqmAubneThCVdwXM9A8	13318	18746	18746	1619313480000	canonical
26928	3NLpjQztVF8oSZGLGhVoKS9peFe4JXzYkyDjuBqiLH45KFJYUtqe	26926	3NKXwYZf18paQVb1UgP32XKRctuL6VMPqjxFVprPmivVRBtwfWsq	1407	1395	520	12463	18581	jwB6YSfnrZM8FMGdSwYiNjhE9SoNKAwK569rZ8YADuY4QoE6Z8t	13319	18747	18747	1619313660000	canonical
26929	3NLkfQamYvca1ezhr1aCCcskuV1od3v1QjeWS9hQ5Tqh7B7e43M5	26928	3NLpjQztVF8oSZGLGhVoKS9peFe4JXzYkyDjuBqiLH45KFJYUtqe	1458	1077	520	12463	18582	jxyFoXebk4hfZRRs4udiKDJbu3eGSfHXLBonWUpLhz5Az74Fd4z	13320	18750	18750	1619314200000	orphaned
26936	3NLnkLyGKAgpaeiuAqiFgv5NBtyPeVsu1rG83k61HKr5W7EA9YVe	26935	3NK5RdFNp6Pywo5P9cXAWi9Sa528sv7gTdhhSyth8rqncc3qx1Qv	1403	824	521	12463	18588	jxHCEy8gQUrJkmnWqHotrM2d3iorFyaKnRphB8G9mvDKxrHgBjp	13323	18754	18754	1619314920000	canonical
26941	3NLyWbLy3TcBuNqytePRkrVK6WNfxGCEeSKxP14V69mHYCTmkX86	26939	3NKLLTHgHwVe5L1etoWCdc7rFRjxJiamCrnT8PuqZMiEw79ACeQr	1675	1216	521	12463	18593	jwAfYJhJFQ2hxzTMR4yZniTU9EQZNQKjFWZteC7F2msBuKQxNbL	13326	18759	18759	1619315820000	canonical
26942	3NLTDojuHxUj2NF4mvSW7KofJ42ZNid2ksMBBENY39vjUiyMU8kK	26939	3NKLLTHgHwVe5L1etoWCdc7rFRjxJiamCrnT8PuqZMiEw79ACeQr	1406	1393	521	12463	18594	jxNPJx1Uj9ByYKPKtagg2cfjx4vdEbhtY7qcXUHYdrijQnKhNRa	13326	18759	18759	1619315820000	orphaned
26954	3NKBoGQGmuviRZudMbc3SYW3KzcyXS4qZX7TdUvm2K2qD1tCCqqX	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1483	1030	521	12463	18605	jwW7V9R4Mut2vey9R1FV9feuWG8t72vp6H4iXLLPsD3dBdevRok	13332	18768	18768	1619317440000	canonical
26960	3NKyq89eJnPvfkgMiCBJm3VAN2SoRSfL9aDRPzwDZ5NrTyJCCCh7	26958	3NLmJhoW6uGfLe9xY6N6X3r5KeqbDpm829zJbfYRfxnZd7JZa4kz	606	1295	521	12463	18610	jxQgVPSbJxg6g34VFyacTNe4guZs1nQRvXUQ2XJyGEskvYADzpZ	13334	18771	18771	1619317980000	canonical
26963	3NLvw3w5qZ1iBsebYV8e1MPGdgEWZoNMGhxW91EJwvo5PoAUt1ng	26960	3NKyq89eJnPvfkgMiCBJm3VAN2SoRSfL9aDRPzwDZ5NrTyJCCCh7	1627	1385	521	12463	18613	jw99oN8EtkxNxnGbE4aPkpcd6QGVs1yWfku3YfCvYW8bv85qYBi	13335	18773	18773	1619318340000	canonical
26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1527	1293	521	12463	18620	jw7itEsKLtqwRJ5WUaNG12z99LEiesGDuvaXK3NVF9A85nrepMH	13339	18777	18777	1619319060000	canonical
26976	3NKKWrJzCTYPhmh79RbiTec9D5Uj39yMQU2NaD8EYMP35Xmnmzfq	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1593	1220	521	12463	18622	jxDDBFUp3c9LHD3rvFLgneh4H4BFhuEYuC66FiTpLAEJFsitTvT	13340	18778	18778	1619319240000	orphaned
26864	3NKaV19o65deYHXpyaZ9kASkRC1LPUrLh66478Bn6CRbdd7ZF9Qc	26859	3NLu28eeENjfGxCrZjetWFPNdxbGMJ8WTdJ6Bz8mduXE6EGEFZj8	1460	293	519	12463	18520	jxNynz4odwXBvnCkzvJQiR9hfa5Rxo5XAyfoGqsJGRVbesiyA9k	13286	18702	18702	1619305560000	canonical
26866	3NKdnkc5HGg8ZNr7r2UyUN8SKAgnG8uaHf3VtMuPN9RsGXiDoUUP	26864	3NKaV19o65deYHXpyaZ9kASkRC1LPUrLh66478Bn6CRbdd7ZF9Qc	1407	1395	519	12463	18522	jxXpu72FYK3rtRJMgXQwoMCqVijKtSFgu1hKUkDFsmo4eNHrddE	13287	18703	18703	1619305740000	canonical
26920	3NKEAgc6rQVF3xVooe5Gqw9wwppGJC1a1VkCJKsRxJ3NVsfzZTmP	26894	3NKAKDVSSshnVjWiC7YZAW83S2wBiHjHX4mXdpRm4MR6kqLb62Rs	1553	776	519	12463	18573	jwsqzBjXaZVzabdbSi6PH1VLYJ6xb5YSJhGxfUif8nhxfXV8omD	13248	18742	18742	1619312760000	orphaned
26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	26867	3NLRcpiwX17p4HBmemaaj6TXkGzBZKE8cuLX532A9p2qejKadiSf	1600	1126	519	12463	18524	jxgMv9mKuMoKNSb9jKfZmCuCJjZrHJRfVt17DSmyRHEMmgszMMf	13289	18705	18705	1619306100000	canonical
26869	3NKPcpQ2KC2xdd3QmYzRTR141JmKF2r1QGG3Ck1PcEKuw4pDFWgB	26867	3NLRcpiwX17p4HBmemaaj6TXkGzBZKE8cuLX532A9p2qejKadiSf	1560	1291	519	12463	18525	jwjv8o4WShrL9S9zCnQBucB6JTBWt3i1dVnbQUHcgyZGQpsak36	13289	18705	18705	1619306100000	orphaned
26871	3NLKo4J4cXGRSZvc4qSv6fVfRPDQnwBSoErVfpoYLJog5x6nLSGs	26868	3NKG5dGa3hV3LVCFnbvTQpJayETFWZtc1NcPhkHHHyEFgHMfVHS6	1668	1004	519	12463	18527	jwLQbHkGNLhMMqR7g18m2PQnbcLb4ATR8qEzpKSMiWku12ts29x	13290	18706	18706	1619306280000	orphaned
26875	3NLrEw6VRxL2ZYNCYow8BucsLiaKwmT1cGfRTT2UUjVbXq99DHj2	26874	3NKfS55GTBsGQx8PThyf4VEQrKRa57sNdKWEdL7oK6Bwfg1sZxPx	1559	1227	519	12463	18531	jwNWsYELJRhfd2SMKw9B3ky8sP6M8pdGqTgrr8SaJmRWpcgnJfB	13292	18708	18708	1619306640000	orphaned
26877	3NKEJhMVKT3gYWznhebaep1bfnzRFpPnR7KAaRHH2ZsgNm4DGyMR	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1523	1321	519	12463	18533	jxuDtnCmgnPe1fYVx5FSnNxSyuqpVATAKZgAqRX3SHK9rkF7SA2	13293	18709	18709	1619306820000	orphaned
26890	3NKnNyS19jfnbkCM5JeAk14W4wL3tePNDbQESsU9AruJD8a56DfA	26887	3NKpHWsCbtLZPKi9naYgfN2nCgXSZ56YARMhp9iUaK9mj9tCmAvC	1407	1395	519	12463	18544	jwyJP9tYahky54CDxugkSr4NFPnzcoh992ftXduBeMrEbPAozV6	13297	18715	18715	1619307900000	orphaned
26900	3NL7RoXWCqMTdwM6N2UYzLGiBbHXtQoYsCNZBhiXMLQTHN9wZFPf	26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	1406	1393	520	12463	18554	jwse5FDT1ShW2rQg1XLsr9TopiQ2UaWZs9fik54SZ9RGWZaVwg6	13302	18726	18726	1619309880000	canonical
26901	3NLcq2us3ZdkmxSTDXCvxd4x4tThTVfkgtsMuUCBPUTqCWej5ZPM	26900	3NL7RoXWCqMTdwM6N2UYzLGiBbHXtQoYsCNZBhiXMLQTHN9wZFPf	43	1310	520	12463	18555	jwWMZ5acrQy1NH3oUekxt4xYDBfAQtKJFyUfVnksGVtdjDANMJS	13303	18728	18728	1619310240000	canonical
26902	3NKFYPv4bjtsijANhkLwKA6UaVf6nEVp5KW1obD497e51u2pxjYB	26901	3NLcq2us3ZdkmxSTDXCvxd4x4tThTVfkgtsMuUCBPUTqCWej5ZPM	1608	1289	520	12463	18556	jxk1a49DvuNCa27z8EcAtchPPecgt6mXkRBVbXjoBtVPpYi3WLG	13304	18729	18729	1619310420000	canonical
26907	3NKpzo1MRsEDv66xeomgEHUvy6frABKwVGJ1ygPPgM8atGjHJiYC	26905	3NKq9MTofg2HdjG54Y6csifPhqgsdDgFBRNwhApVgPHPZMo7wu6f	1649	1137	520	12463	18561	jxCvTVEWCKQcttxSKxAQ8Va6DcZkMT82WeQmd55F36upasy6aeH	13307	18733	18733	1619311140000	orphaned
26911	3NKWYh5dTn6gRgxQM8EUxJiCtxoZ5UNE7cG4gMfXy5knYVgUNpYB	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1406	1393	520	12463	18564	jxZxQCKkx6cX2mzb3xsVMjipu9f2PoYN94gCCbGdA6XAn2Ebyz5	13308	18734	18734	1619311320000	orphaned
26924	3NKoFfdjz6cZdNgNbjHFP9ajsbk823Lpc2a5TNS7k5cpoWQJsYmb	26923	3NLrWo8e7LCtVX8ttowoxvVLseWUXCxouP8MQentfysE7N8GpWaE	1622	1356	520	12463	18577	jx2f2atPLoJLMLTLhDuQXPjJW9Sf8sDtFkNqQSePKLfne2BX8jH	13317	18745	18745	1619313300000	canonical
26927	3NLSeJHnkb1zQ3ztF4u89fNbqYhS2ssa9n2jfZbE2sGfnDa2Nor4	26924	3NKoFfdjz6cZdNgNbjHFP9ajsbk823Lpc2a5TNS7k5cpoWQJsYmb	1406	1393	520	12463	18580	jxW77ghTkZrZod9x9i5VU8bwwzFar8hiKtSSUwWoo5xo6Mmjyby	13318	18746	18746	1619313480000	orphaned
26932	3NLeYZbwuWVMYbF6HJxxPabvm1WGXLHzXQ3RN2vU8yEyux3a1qxk	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1448	1311	521	12463	18585	jxcqUmRv4Y83dNJfkQrryuewdSLUpk9raARJ7B2YwjbKpHpjH32	13321	18752	18752	1619314560000	canonical
26934	3NLMYrTyDkp1ZeB8jsZ5qYfY3PwKQGmPFnVTqRcV6s4NGYK9RtwW	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1581	778	521	12463	18586	jwGuMMN7pQJnmCoEUzNqykzza8Z1fqRS3qa3vX5WRi2r4RzyEo6	13321	18752	18752	1619314560000	orphaned
26937	3NKcFoPMrGhGt4ZEUBMxM5t1WoSrqtLLAfTpPvyDYBG3RmnC1Szd	26936	3NLnkLyGKAgpaeiuAqiFgv5NBtyPeVsu1rG83k61HKr5W7EA9YVe	1619	909	521	12463	18589	jxk4xDfU2BQRrZJ5i1ST1xY96K8W2JSDinj417X2mfVYksDX1ix	13324	18755	18755	1619315100000	orphaned
26939	3NKLLTHgHwVe5L1etoWCdc7rFRjxJiamCrnT8PuqZMiEw79ACeQr	26938	3NLZNpXCDUwky8pyBajfbQR4jC3fi9CdS3pUR6TJssPHHsbsAhG1	298	1308	521	12463	18591	jwKWw9KQPL74xUmFrxKikyG9f1AAuvrTjconENTchduqohDRGfX	13325	18756	18756	1619315280000	canonical
26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	26941	3NLyWbLy3TcBuNqytePRkrVK6WNfxGCEeSKxP14V69mHYCTmkX86	1406	1393	521	12463	18595	jxUSW8PSgGyM4H3o1PhUbxzz7jjCuMJ9t7HxEvNbmpSKmYz6sV6	13327	18763	18763	1619316540000	canonical
26945	3NKLbEp6Md8BLzYoZdvKkBMQenEcDghr4unrsiqbif5CkW2zYCMF	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	448	1305	521	12463	18597	jwfMCrX93WAc3EfGjmRK29jv6MgzznZxmvyQsufsx4QwPwWQHCJ	13328	18764	18764	1619316720000	canonical
26947	3NKgzUX89HTL4n8AaNonuZbawxopZTZHWoC1ohzqSUApnwLsAN4o	26945	3NKLbEp6Md8BLzYoZdvKkBMQenEcDghr4unrsiqbif5CkW2zYCMF	1593	1220	521	12463	18599	jxLAmCorALgH82gA8qoxv94LRZzg7A1FG44QYheRGbrjTskEBVZ	13329	18765	18765	1619316900000	canonical
26955	3NKM2Lrw4x53UmXjGSBG7ihyQSuTC1MKhYBSe1jxquE55LBz5Y7X	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1547	1378	521	12463	18606	jx7H5J3FEzTQZk854ECD77TN88isXtcK6Yn8gwoAMFbH25iNHCB	13332	18768	18768	1619317440000	orphaned
26958	3NLmJhoW6uGfLe9xY6N6X3r5KeqbDpm829zJbfYRfxnZd7JZa4kz	26954	3NKBoGQGmuviRZudMbc3SYW3KzcyXS4qZX7TdUvm2K2qD1tCCqqX	1509	1320	521	12463	18608	jxF4cdN8Qio8HncbEVi2bgHCL6RxD6tTd63aFcBeAFt7AXbFDLw	13333	18769	18769	1619317620000	canonical
26961	3NK3mK1Y5aK6yG55QNY7n6XjBhNutkBbtYXKawLUBBd8bQjVszGo	26958	3NLmJhoW6uGfLe9xY6N6X3r5KeqbDpm829zJbfYRfxnZd7JZa4kz	684	684	521	12463	18611	jw94CERf8miPMZ9PoWsjcCeb2VrTEY8XQGkP4fCaF4Hm8kq9Ng9	13334	18771	18771	1619317980000	orphaned
26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1402	862	521	12463	18616	jxi1SmW7Ra8JDCZr3SU82qMXudJRzS1FJzTtmXsfHGiKAMCo87e	13338	18776	18776	1619318880000	canonical
26972	3NKS97mEQBqdKF8grx64uP5CLPNMe7tvEsw8wRM1pDs5gThpH9jw	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1527	1293	521	12463	18620	jxX5fWNEjRaEn6rubVc36YcrwWMqiGTjRJqxWB3QUrMvA6tM5Ww	13339	18777	18777	1619319060000	orphaned
26974	3NLjNCrnDCtCobL4qZvfmAFzckBvrdiv2C4rPV6dGy1aFjzvG5J5	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1483	877	521	12463	18621	jwFrBtCA5cpajm7v4q8WAgrSJBKrHyaXKy8ZLxxPuGR1FdgJAdr	13340	18778	18778	1619319240000	orphaned
26880	3NKmEpYKPsKVZhNK7uub6io4C9deEDEYHXdHfBWS7eq7Uv2dGSxa	26876	3NLfVHydz1E66Bru8ruhv6pXQDaqggerWNfWWQC9o7QMELmZP58b	1523	1321	519	12463	18533	jwuxVhNaoFTeAQ9LRXvd1wgUwWCU3NUGWUtzv8CH9feQBg9jqpm	13293	18709	18709	1619306820000	orphaned
26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	26883	3NKJfTwpNDr8yXcrzKXSC9okfkLVQgZPBf4vRqWyXz6W37EGfe4M	1403	824	519	12463	18538	jxJcCbRYfss5iqpyQ5nDeVMmVnnaVzoN55YGNGu9XPppYepnUMA	13295	18713	18713	1619307540000	canonical
26887	3NKpHWsCbtLZPKi9naYgfN2nCgXSZ56YARMhp9iUaK9mj9tCmAvC	26884	3NKrAEccn7kcdJUY7CuRfjqZoXfaHDNXUvpD3z7jNQHT5G2AoXdt	1406	1393	519	12463	18541	jxZi2WuCspzUo2adDEtXyx2X8gowoGZFwoJdCGhXYdPPB8MF2rk	13296	18714	18714	1619307720000	canonical
26892	3NL6gAHRMvaqQNSu7MpYxaMGiKkbPdQx7HtT2w3NM1BqKB8CdUdu	26891	3NKfRSPSKnMoZA5LHhq8w7mdDeii9zqxeVY2mKatqp1qazuxPoHg	1542	1304	519	12463	18546	jxAnbsZZyaEn9hfhAmfXpqujQB6sLWvPQ4aCjVU7iKFJRdYCvho	13299	18717	18717	1619308260000	canonical
26895	3NKrAYMrPVqUugbzzQMVPwSJpTKKRyX3bzD92u5aMtyVrfC54EV9	26892	3NL6gAHRMvaqQNSu7MpYxaMGiKkbPdQx7HtT2w3NM1BqKB8CdUdu	1589	920	519	12463	18549	jwzByknJ4um57rZEb39KdPmmhRCgfUMnnpQnepWcDahFzAvDNRi	13300	18720	18720	1619308800000	canonical
26896	3NKn6C4aK3stDW2ib8NX1e8wtEJLgLEg7MLGp5vyqV1kCdAXUKmd	26892	3NL6gAHRMvaqQNSu7MpYxaMGiKkbPdQx7HtT2w3NM1BqKB8CdUdu	1579	1143	519	12463	18550	jxEUbAWfNrBNz3ndVdsKyUWRUsi4b3UUajHGTqEwEJp1usQ3Tfo	13300	18720	18720	1619308800000	orphaned
26898	3NLJY2xTMoNtjrY291y8Uo22B8c2ddeiCKM7qxjXXP8NpmSgRKaX	26897	3NLW9tkdMToZQBdgdnJFJSTa8FULSaqjeEazmJgcEKPYx2qWVYHX	1444	1381	520	12463	18552	jx3641cFZeny4biz92MzURgrmM3XPejiRishYfmitf28N3q8zzD	13302	18726	18726	1619309880000	orphaned
26904	3NLumVj4KQGygPwnFUiU3d95PEtzPBV1mZkwsQEqrADE2NCkH22g	26902	3NKFYPv4bjtsijANhkLwKA6UaVf6nEVp5KW1obD497e51u2pxjYB	1407	1395	520	12463	18558	jwF48uHuYq7Fys7ssHG8jw6C8xF1XDjqs3LswhQAto3mXp2HjwH	13305	18730	18730	1619310600000	canonical
26905	3NKq9MTofg2HdjG54Y6csifPhqgsdDgFBRNwhApVgPHPZMo7wu6f	26904	3NLumVj4KQGygPwnFUiU3d95PEtzPBV1mZkwsQEqrADE2NCkH22g	1642	1001	520	12463	18559	jxZWLodCDJp8vYx5CDYxmDDuPTNmsQoLMFbFjWYre9EMqieLVwF	13306	18731	18731	1619310780000	canonical
26909	3NKY7x439L91krJ9K5nQdNy8jBraPMRUZongyXRHrbt8TTMnGPP8	26906	3NK4oYNNBKYT9kXDn3RzijBfXKgw3MdFMmACyHpUkbbhHUueNmFN	1448	945	520	12463	18563	jxpkqboz9uMCGyLgWyNciUBEd3n4obSVmY8zAAHtq2xWPETHgdE	13308	18734	18734	1619311320000	canonical
26913	3NL6M2HmVSfxL7xdPqzVNUHKBXheTVkfu7ggbvwhketHDUQCbsYK	26912	3NKfJqLasA7U3ueLiZZPp3QZZjkcWAG9Amn4GZwaf1nXpEuC2CD9	1489	1254	520	12463	18566	jwPiTkEzq3mgDYi3sKrYRbJjwqaHCQmsFgHyTuy1wfP4SKSiyrd	13310	18736	18736	1619311680000	orphaned
26915	3NKKtTLQfXzkMCYF5rKqP1xPjywJYd3ouceUucWRm4uUc1V1UEp6	26914	3NL2iXYJmHXidD7n1JT9XHAstn2LCFoJQzTxiVL7jHEqb96j2nPz	1671	1119	520	12463	18568	jxQhSBaMj4RdKVMqd7Krmu3WpujPYcZ7cbGkYz3EiXbDyD9Xjp2	13311	18737	18737	1619311860000	canonical
26918	3NKXgSMZY8zUa8YJgLaBPBTxqjQyrfkff1CdAvyxomfimExp6tuU	26917	3NKzmwyyh9BeDdGbG9EkKNURPWndKEkpduKZzT3EnVR2ygrwNafF	1460	1324	520	12463	18571	jxNiAZQjxT2LwZRtgexN7vpkzEZh21nWBMoGJjP7bhjuobQeE5K	13313	18740	18740	1619312400000	canonical
26923	3NLrWo8e7LCtVX8ttowoxvVLseWUXCxouP8MQentfysE7N8GpWaE	26922	3NLN5FJ1JVhSG3dtzqyWhEzNeTNqizTJN4aan3Bn1cWg4vyPCSEA	1406	1393	520	12463	18576	jx7DRoYSS9prZfC64HHfVvczBmucqveb6ThnneLLXm8HXRzwYYz	13316	18744	18744	1619313120000	canonical
26931	3NKCZT4MVp5kxGPReTGJ7JwXiBAm7o8oB2F5mgEf5Co2JpGbjC4e	26930	3NKcakHhPVwCBXRpAb4cf1AhvNQGk8xLZxGEkfWc2ezd86YBWg1X	1403	824	521	12463	18584	jx3xYPzQbNDSSbbUhycbLM188bSXbeQDZ4TckXzr22GddiwLbAG	13321	18752	18752	1619314560000	orphaned
26938	3NLZNpXCDUwky8pyBajfbQR4jC3fi9CdS3pUR6TJssPHHsbsAhG1	26936	3NLnkLyGKAgpaeiuAqiFgv5NBtyPeVsu1rG83k61HKr5W7EA9YVe	80	1147	521	12463	18590	jx5neuVWDW75ET21DWV7pw61a4f8xVXWD9jLWGwtVgTXW1Gv6ic	13324	18755	18755	1619315100000	canonical
26944	3NKUHe6BN8Apjsxdnerfx6PbxnwzYJ7jn75BZjRqXQaYYfHKY6wf	26943	3NKXP2YHieaUUpHrbfHykJdb66f4ByBSyCCoY7HyoYzm4ECUHerX	1607	271	521	12463	18596	jw7VULYkmvnaCwoBEaxj2oZwSkasHTwZUQY5hCz3fWSxDsJk9sa	13328	18764	18764	1619316720000	orphaned
26949	3NK9Zp8HBmoUjiYNQGCUjrLxHQ1THrzeJ5SYPAdyhDBTLGCVdCap	26947	3NKgzUX89HTL4n8AaNonuZbawxopZTZHWoC1ohzqSUApnwLsAN4o	1440	1377	521	12463	18600	jwV7KDwDsuvKkZqzdCnro2VG5jPPBuYBwJy1BDzmmDheRbeRmmc	13330	18766	18766	1619317080000	orphaned
26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	1501	994	521	12463	18602	jxHCVj6CAzjvs84WP7jWr2EdbeWUHdGbvCFwrmvDNMBzbZjPCkb	13331	18767	18767	1619317260000	canonical
26952	3NKy2ivm2ZmEXpXhrPkdMxraUTWB8B3abRV87VETtbQ6jSya3CET	26948	3NKUy1LctLUHLHGr9qQdEv25VwgtUi1GZxnpDk85xjT5SbEmf4c4	1637	816	521	12463	18603	jwmpT3NsUag8roD5CUVQa2ihDqTPkzVDBFAsVLquoCfrxbhwBMV	13331	18767	18767	1619317260000	orphaned
26953	3NKwYprqYHJQ4hFx7hyKwsU17P1ZFdVRje5CCYeBkhgbC2rBvtwB	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1403	824	521	12463	18604	jxaja7NrgTMfWVDRYxfgVPPpgZi7ygLiTzUD7XJqx6abSZEwrWp	13332	18768	18768	1619317440000	orphaned
26957	3NL4Uj8sRbnFF8qSBPUfiAnPCry7nvuFDnd8sQ58W8RsdNLy9mLS	26951	3NK6AoNdgsYn8BJn59DYcvUTUZfn277zjEzLvtwhoJNoKynLd5dr	1547	1378	521	12463	18606	jwRusqneBYV5DniwRryc2HSPkGmUwBHvDZUi7mYz2mF2436zoRe	13332	18768	18768	1619317440000	orphaned
26962	3NK6kpNik24wnKcV8xWfyfjFi1b1e3YrLFMaZWt5tn8z9YPNSG4h	26960	3NKyq89eJnPvfkgMiCBJm3VAN2SoRSfL9aDRPzwDZ5NrTyJCCCh7	1476	1125	521	12463	18612	jws7JsmyFJfMVpEmyQ5Jncv2XqSby4e4pvoMDjVu5JabFXhEFFR	13335	18773	18773	1619318340000	orphaned
26964	3NKJrHatYQmbKkuEhEGHRbQw2S3Ag29rMWC1veBxtnEGhvYE7dN1	26963	3NLvw3w5qZ1iBsebYV8e1MPGdgEWZoNMGhxW91EJwvo5PoAUt1ng	1607	1102	521	12463	18614	jxWgpHpVpMDZuejQcZ5DfFcCJ7R14u3NuKitVBUri4DTxfFMXEw	13336	18774	18774	1619318520000	canonical
26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	26964	3NKJrHatYQmbKkuEhEGHRbQw2S3Ag29rMWC1veBxtnEGhvYE7dN1	1637	816	521	12463	18615	jxH7bnTsYQp2FAv1DsSVcoz34Uh9Gebr78WVuVRNbqtbxYn9Z4C	13337	18775	18775	1619318700000	canonical
26967	3NKYAG9bP7KXZchgVQ9oJktia7XGrSQLAmZcak14BD6AcK3hMf24	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1407	1395	521	12463	18617	jwVc8ATKAcECdaagXtrLfUJ8eYjaVavDqnaG33uQk7eU8rJprNy	13338	18776	18776	1619318880000	orphaned
26979	3NKzJjrZ8asfUFcPtkFV61ktZGJCae97o9ioay6bupaGrGts4Kkg	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1564	1092	521	12463	18625	jwiQoB6MxEdGuNNYBjNiZAm6p2NFSvGwRvaKvE6eQspdAP8r63o	13340	18778	18778	1619319240000	orphaned
26982	3NKVEwCTxoab2pT5hKpNGicMSninUFiBk8yd77Q1PjniERkw7XEJ	26981	3NLZQcZEe1ULuhPcjJUTbfd3H2JYccqEg18b26wSzBeutx5pRgzG	1559	456	522	12463	18628	jxHGohLCPDrnSWm59w99b2T9TSjZ27D3jmg6sgNtfarZi6NuY9W	13343	18784	18784	1619320320000	canonical
29080	3NLX7iBMbXdpBMR3gDe7G1dn7JmxDtEhuhJp12j6pdQnkaLi7kKX	29074	3NK9frKLLbKVPBxVxr99g52CaH43ph5szoJJgea8ALAKvAnFVMD1	1407	1395	570	12463	18974	jwEDyWqvY7YGegJuiUnLQbeBQqz9daQbaLYtS2ad6qKzKgLoud1	14335	20183	20183	1619572140000	orphaned
30185	3NKWJWNbD3St9YoCccuLdGsYLcLb7rdxtCojL4H86CCVcNY1WAE7	29581	3NKfYucc7FGU2Eswkz4bA9dVW5aUQqvmDdAMQWJebyw4jWTW3zgw	1634	1085	582	12463	18974	jwHfMJfyrYmzmPxCmEpLJPXWEicZFYXT1GRnR8X2fQNwCmjLHFW	14587	20902	20902	1619701560000	orphaned
27053	3NLdzNrbuAcKpBXHxnH1Ei3pAoqFULVtXtAHQ5x5iMAYEbDAmLYT	26925	3NKCZxjYDDeJTkh8GjSdsQ5V6usvqm4z5RhWkFWbPNyi6givRNCf	1670	916	520	12463	18687	jwo4zP2VsntLs2iKqs3YBU6XNNe2JXHSkKmH5YLD8rLCTXqvTKZ	13318	18825	18825	1619327700000	orphaned
26968	3NLSBJBrLsLDWQfcNHTJkayYZv15LyG2Yvch9dgj2392fyhFQCfz	26965	3NKExawyxxxaXCYZzsJCQnf44KRpaTp8xiYkTERexVkPtypHB5yg	1506	1007	521	12463	18618	jxngWBiiGfGh831bV2rg5S3eYYbG3HUU3FRiqXg8GQyKYSSMGCw	13338	18776	18776	1619318880000	orphaned
27041	3NK85ucFQGDUr7D7vmf46wjwTqYbip1jjRKhk5WoYC7z2dcWaVpi	26920	3NKEAgc6rQVF3xVooe5Gqw9wwppGJC1a1VkCJKsRxJ3NVsfzZTmP	1553	776	519	12463	18675	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13249	18817	18817	1619326260000	orphaned
27080	3NLC5meqe5PdZZ8X2bcAt2NycriLu4PwkCUdMj3zuQHQitCuNa4k	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1623	830	521	12463	18711	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13339	18844	18844	1619331120000	orphaned
26973	3NLXzxvGewus3BziehgBsyub7yyNYd7CLHFDhuoAHA7eT1of5bEs	26966	3NLe6JS6MnM1UQR6LQi8oDSzxiDsCq3BqSYo9XPuiAXT4WZxXQPj	1527	1293	521	12463	18620	jxkiX247SceSqhynNSX9oLp19PmRrrQTTUBkkttA4wqsQveefBS	13339	18777	18777	1619319060000	orphaned
26975	3NKvyoSZ5T948JgX5q48RVrtnz7L3JCvxRNahh9embwxPprqoWvf	26971	3NLovhdb5cfhx77GjShTSe2hp41cERbrBYX6tf9ioPS6XHzpomdG	1483	877	521	12463	18621	jxcrupZd56mH3Rqjf1YJJwCQEChrZ8RaauhrJ33TSbfhe9pinTw	13340	18778	18778	1619319240000	canonical
26983	3NLV7AYJ9MeN5p5XHxktXsiDcW23KStDPshrdwddNUnyaHSTeXTv	26982	3NKVEwCTxoab2pT5hKpNGicMSninUFiBk8yd77Q1PjniERkw7XEJ	1419	814	522	12463	18629	jxaACCnT67ZBuanR8wig3efbhHH9wqfUQwbEzGRRWqisSNdW7oQ	13344	18786	18786	1619320680000	canonical
26987	3NKb6RVKLotqbKbpYS9CT5oSVxoXzDo6b7m1ScRGNEATbUCzTfbp	26986	3NLDMxJ4t6X6iv9qAoDGypWsvC3xTjewqUjPzQS3tnJamPN1fo3M	596	596	522	12463	18632	jxXRdnxBk8pPLdE2XTTZwHV9AZL9RMNDUmigPxVEoZ3PMy83he1	13347	18789	18789	1619321220000	canonical
26988	3NKXREeuaTNeZy75RBRdsrsQV2rfVaYeowWh8oGQCic3JbP2F1b2	26987	3NKb6RVKLotqbKbpYS9CT5oSVxoXzDo6b7m1ScRGNEATbUCzTfbp	1477	1104	522	12463	18633	jwGtmf5zXbK8JXVoiR7GXv3K2rxHEhR2ECcbwQNubyB9V7vaDpQ	13348	18790	18790	1619321400000	canonical
26990	3NL9ZQ69tGCDYJAd5zAcTWkYyyHMkRJmiDLfbNRK3dxwTCQd3Nok	26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	1523	1075	522	12463	18635	jx1EJw2bwu5iKApukwpiSrh64LPssSEYa37Xf1wbyJ7UavieCvD	13350	18793	18793	1619321940000	canonical
26991	3NLL8ctN3xJ19X3Y3si3jUxmVJgTkue3M3hKGwJrvgHxmjsmNgdm	26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	1523	1075	522	12463	18635	jwQ7kzzh4wK7kQsnvo424mfsnTKF3ZJHR5MVHA4tkzdvyAnfMEL	13350	18793	18793	1619321940000	orphaned
27000	3NLfEE3L51cRqxn7NzULA3HRro5d4wLV4NmRBLamGb2vW4nSPpJy	26999	3NKsJbPzZfQ4MRsxG2uuLcQZauHEFotAQbu8JrtabtQZpaXkQFj6	1578	930	522	12463	18643	jy2x6P5Eq3LWBVi7UtAjTU6xRXZg5HBfJdmsE6aqec3XfTzaSbV	13355	18800	18800	1619323200000	canonical
27002	3NKuMvMMUEsLUTMWSERjDaTLwrc2QQCTgDBY5BRSqX6EmY3APcBF	27000	3NLfEE3L51cRqxn7NzULA3HRro5d4wLV4NmRBLamGb2vW4nSPpJy	1403	824	522	12463	18645	jwBCXo1Z7nPw1tdbMqLVQFxmM85YBVDojcxxHain7n4XF4jzQEF	13356	18801	18801	1619323380000	canonical
27005	3NLJjBgcgyW1Y7VUYQe7njbSbnBAM7yHnU9ZsHTEzvajj3prR6Yz	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	1406	1393	522	12463	18648	jxzqJTVuWqdc131qx19MkAu6833TtnySEbpF5pAzDanehq6iwRa	13358	18804	18804	1619323920000	orphaned
27009	3NLBaBtx4jXL1SMoK4BaMey7JmiSh71eZ6itJ9Bfpj6aCXTFMkV4	27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	1406	1393	522	12463	18651	jwadw73XSfib2DdKxtCEqgjRrpBcdcQptNp2r6gPjNkcArLZEqe	13359	18805	18805	1619324100000	canonical
27016	3NLVHrpBPURbrKXRcKwU1msqDVc3gUfQKdCCVp97jCyn5AQ7v2y1	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1542	1304	522	12463	18654	jxgbdJZcUVktQ82U44E7m2b2EaFMZxaMsbDxBV13MXwezPeeisD	13361	18808	18808	1619324640000	canonical
27023	3NKoEFWpe2XJib7VByFSMaJw1BAeDN9eALczKVrhAv6yNDkN1iwQ	27022	3NL1adyKML4JWy5PD2jWwoGx23y65BRS9Ku9di2d77SNePAwJJGv	1549	1362	523	12463	18662	jxmaiXBP2LNNpNBvWgpL9Y94n6UrW1ML3kWKUVAKNoZapq6BwUV	13365	18812	18812	1619325360000	orphaned
27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	1405	849	523	12463	18669	jxopr6gSJu98hQJpMm2zRjUV38wARSgnaNpQGvGbhBSmJUgFQy1	13368	18815	18815	1619325900000	canonical
27042	3NKDt7WDwKxYfWcmjpkN7P36pFiPANULmdwjMBNn6ezLqsGAWUqM	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	364	364	523	12463	18676	jwzZxBckrBz8RjuqoHUhoFNyFuC8bfhqEDmeoSQ5UBuh2TGtv8S	13370	18817	18817	1619326260000	orphaned
27046	3NKQ6wviU8e1ms4vk2vHfx5zMYmgXAeVWdkjR4bmTCgef9xJudsi	27045	3NLWqYWjQ8ht9H3CPDrgG5nLzB6ayo8x6jy8mNVhKaLt63D9sSVH	1406	1393	523	12463	18680	jwSkre9SCAsJLg5wQ2tmHncZQqM72Uyp6dSMmBzXiM7oE2J5aHw	13372	18820	18820	1619326800000	canonical
27049	3NL1Fs56DkeQZ5uVMGbzBekGPHHcKYxjx6BK5Un6qeVutuSB1z1R	27046	3NKQ6wviU8e1ms4vk2vHfx5zMYmgXAeVWdkjR4bmTCgef9xJudsi	43	1310	523	12463	18683	jwdnXCAnVDuXRVRR6tfZGsxNtkGtxh1kkUdA5u8GoPu7LV5T6if	13373	18822	18822	1619327160000	orphaned
27051	3NLg7s6fXUtkGA9pUhzNB4UBmKcXgf7XCD7j61Uayj8hqWwu3RZ8	27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	1407	1395	523	12463	18685	jxYYYZtpk199RHHFw1GSb2NK4K6NKL7BWP28BtKZttGKFw4vwPp	13374	18823	18823	1619327340000	orphaned
27058	3NLJHuY3aG7e7ZzbAP7LChDmPaKdhw24TeY6tMHU3zJkDWFXtxn1	27056	3NLkp2G7fHdLSd88dkEFkiVikorrJbnHXYsDdgLws7c7KuWMYgBp	1671	1119	523	12463	18692	jxKxjaDxnAoTasWfBZ1UXcCotGVcH7bDPVHdHn9U9YgE5FBUBNz	13377	18828	18828	1619328240000	orphaned
27061	3NLTKSd9Q1tetCqLkkfeAfijcYJceCuYidQDhB2v5QpCxuuxF1wM	27060	3NL7w23RGrtoJF8sMSQvNQZVYE4udRnUjtmhu7hVgdfLdxR9VkQu	632	1136	523	12463	18695	jxEEnvjEVpaJfCM5ATAiPKaLACnZpun8jgKJ6csiatVpJDGo5bM	13379	18831	18831	1619328780000	canonical
27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	27062	3NLPi6ywXzm9BSKeE8ycKTqFK6JC63vcZgQ2NfCJPDRXSdL3ndvs	1406	1393	523	12463	18697	jwGe7Pf1vFC9vzfH4R5dGE4K1EEDF9cRNh4Xwzv6TaBeQU2dY4e	13381	18833	18833	1619329140000	canonical
27068	3NKu4cShxcp7GEsXGnGbhUTJb53hhLdUZow2ntpEGPeASfkSXn61	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1637	816	523	12463	18701	jxrci6Ls9DBRt2vZJEjZrynHYUxY7axbaMfGcKaPPAUumjG7421	13382	18835	18835	1619329500000	orphaned
27071	3NKwG4MGnCQ3DMpYvJVzYU9pPbihXCgCnLf44YhFfjVMHyk18f1U	27066	3NKdWgBy8y157dBQoTpHqh7fxLzueZ1oFPapjSEHFsESRFyQSCrY	1609	1207	524	12463	18703	jwsBsN4JB89YpmDcu4SY4nWnFMVKBGUTW4bZPu7QqxZzm2FG5kj	13383	18837	18837	1619329860000	orphaned
27073	3NL3oRp7uPDUkouoASmMQ1WGm3XStEqRNBgNqCQWnFRCZn7ovpng	27070	3NLrofK9ZDCFwHRx7kJA6mbs3yBSa9NSQaWGDYY1rmuhD6JsaoDV	606	1295	524	12463	18704	jwQ4sD9aCMG6vw63Cv5zmKmaNBF7Au14LHzaQPxA9oZBzcjnWJY	13384	18838	18838	1619330040000	canonical
27078	3NLZXNB3xvQKdpjrsrnSa2tQfuRVNsD2BANj2nkWxzrQePs5RArF	27076	3NLHtBgFLpvtiGadEGuGUubNLaehtYojZLipr21srgNTMJVNah8n	532	1303	524	12463	18709	jxfYngk67a5p3nwDj5AynSUDqh5TJCwjDxSjVhrM76D7bNhAhmE	13387	18842	18842	1619330760000	canonical
27082	3NKuSGUTWKv1NH7CH1u2ambZKuNTRqnTPdR92us2NuYq6gg3eDhW	27081	3NLEEZhVoVaEYdhzp4TbqRX1RQpARDzVKwXzAjwXyUgoQRqXJoNG	1406	1393	524	12463	18713	jwrjxt8sPgm3nsvLw6pgSsB6Nk6a6XuAkP415iYz97dnX1152ry	13390	18845	18845	1619331300000	canonical
26980	3NLok4M63D2kikpYzMRYRSSufaVRBmbPZSkrdoSuTSUi9ZfAWeZF	26975	3NKvyoSZ5T948JgX5q48RVrtnz7L3JCvxRNahh9embwxPprqoWvf	641	1210	522	12463	18626	jxRJa4gCJr5n4RHA4mP2i1yHxHq6R4E8nSzKA3sXFFJe6NQ4ehC	13341	18779	18779	1619319420000	canonical
26986	3NLDMxJ4t6X6iv9qAoDGypWsvC3xTjewqUjPzQS3tnJamPN1fo3M	26984	3NLSGCYPBNmfBFwimMmKE6faJkygcGJ9zYLsGztZBKDAVuX6YQmx	1406	1393	522	12463	18631	jxU6yBRnB2wcN1L8cxbGKuG2uzcedqyB2mqPDKcJeASW5MVQL7f	13346	18788	18788	1619321040000	canonical
26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	26988	3NKXREeuaTNeZy75RBRdsrsQV2rfVaYeowWh8oGQCic3JbP2F1b2	1671	1239	522	12463	18634	jwHqQpmdkVfbL84woQKgjboJaDNdwpC7tDWjm3D6yTLof8FKjbh	13349	18792	18792	1619321760000	canonical
26992	3NL3iMZMwtMAC78QnofHNEdH5pU5ha3DF7gcH8J7MJmX6bHtDE5a	26989	3NKN7BJgyTKWSuMWygbJRf8gwfL1gwnwSot22Uoms4gvbq6DhhUE	1523	1075	522	12463	18635	jxJwRH7FC6AtwrhPZspuC8yoXJyoAvVnmFUypE5tALM2uUbC2CL	13350	18793	18793	1619321940000	orphaned
26994	3NKy9umi8TSqm2LLKpoiiJdqbPPpptsiTcMqwiCsigGxYP2af3Q5	26990	3NL9ZQ69tGCDYJAd5zAcTWkYyyHMkRJmiDLfbNRK3dxwTCQd3Nok	1656	1097	522	12463	18637	jwTUQHDFsUZuxCYJzku77psHuieEK52i4LG2YUMo1XeuzzfuV74	13351	18794	18794	1619322120000	canonical
26993	3NLLfntSzwsyZyFQ1prjLA84bo3v8v6F3pun8UFQSK8aDdrGLxQC	26990	3NL9ZQ69tGCDYJAd5zAcTWkYyyHMkRJmiDLfbNRK3dxwTCQd3Nok	1406	1393	522	12463	18636	jxPGsRZvefJbMMih9S5okG3EPv6MEyFM8ihPYn4zGdCQxqJ5fuW	13351	18794	18794	1619322120000	orphaned
26995	3NK6ZDeCGNCSkbCnvdX1cHLQNYxpGPACwPg1jieUrDxL1THWzG4X	26994	3NKy9umi8TSqm2LLKpoiiJdqbPPpptsiTcMqwiCsigGxYP2af3Q5	1406	1393	522	12463	18638	jxEZLv27rzFtL5KAYfC627w5LQir6TBhxE3wD2eFYRK8MWNKtxG	13352	18795	18795	1619322300000	canonical
26996	3NKYDpZeceWjkrUZdoufoMrtFHyrTYx3hDCXSiU1xn8qZoAC81Sa	26995	3NK6ZDeCGNCSkbCnvdX1cHLQNYxpGPACwPg1jieUrDxL1THWzG4X	1546	1213	522	12463	18639	jwTLg6BAjBfDGE1sE1wQV5mwH9GWRdvNZpahiySPPeNtpTASZJE	13353	18798	18798	1619322840000	canonical
26997	3NK4Y1BijdNsZDBF3WvFyPgPtjZYWGfnD8w2gBtwu93VCgjgLGLZ	26995	3NK6ZDeCGNCSkbCnvdX1cHLQNYxpGPACwPg1jieUrDxL1THWzG4X	42	1115	522	12463	18640	jwnwGATuAojbQ65QZkwzrVr3Utb3rynwUeGm8xYzKWN7LpuDR5h	13353	18798	18798	1619322840000	orphaned
26998	3NLvRwCTuXNNKMMrnUFjCQCQQp8Ki2NfqtjNeZwvc6oWGpxtWxq3	26996	3NKYDpZeceWjkrUZdoufoMrtFHyrTYx3hDCXSiU1xn8qZoAC81Sa	1542	1304	522	12463	18641	jxQaAFArnAgXng3KowsndVcic5itvBM2DMUx8ucq2Fy5RVk19ZP	13354	18799	18799	1619323020000	orphaned
27030	3NLussrw95mTNKVbhXQ2co5grJ6x4BT4qzdEJFDg3gzhHAcz8qEt	27000	3NLfEE3L51cRqxn7NzULA3HRro5d4wLV4NmRBLamGb2vW4nSPpJy	606	929	522	12463	18667	jxXH2tzYNHnF77cjzG9bXixicUAahEbyh78p1Qe5suYY8dXhjYy	13356	18815	18815	1619325900000	orphaned
27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	27002	3NKuMvMMUEsLUTMWSERjDaTLwrc2QQCTgDBY5BRSqX6EmY3APcBF	633	1384	522	12463	18646	jwzLCBZbkmGQhPAbf6WGTxZypVdgqemJsL7TBLnh7KbsGWydeer	13357	18802	18802	1619323560000	canonical
27006	3NKgx3zSmfTomQU8aFuUNj7PmE5xvjfgUE5yrZegYKageUbduFyV	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	1529	1316	522	12463	18649	jxnR3cdfeVdYscxgm61UVPRxE6y4FD3MvFmMggu4UjWzesGwZfY	13358	18804	18804	1619323920000	orphaned
27010	3NLNFnJk5dwBJRoXJemuCaEZrkTkfGTpa6RLmrE5j7rF29dD9CiM	27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	448	1059	522	12463	18652	jwVnTzZmwXtLiHnnwxfaUGrCdTwNJqVqoWs3mGUb4Ka2uPGzFWu	13359	18805	18805	1619324100000	orphaned
27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	27009	3NLBaBtx4jXL1SMoK4BaMey7JmiSh71eZ6itJ9Bfpj6aCXTFMkV4	1407	1395	522	12463	18653	jwCv5kRJMgVSNkgMiTwxbq9XNSndy3awkCskuWNZcxzhYvnzdDW	13360	18807	18807	1619324460000	canonical
27039	3NL5EYQEwwrLqKBTGcx7gcRNSpNQhN8ZgXFaXRTy54vzt2HN6DgF	27009	3NLBaBtx4jXL1SMoK4BaMey7JmiSh71eZ6itJ9Bfpj6aCXTFMkV4	364	364	522	12463	18674	jxpp5VYKur6k6DXpMXQiDgAMN4fhi329EqunDPRZitYtNkCDnsW	13360	18817	18817	1619326260000	orphaned
27015	3NK3qQ1LCT8S73SUzKM5amjgdJJiForRzMhJ2VFqfUt2djuhQHg1	27012	3NLeVteLwnMfQANkwMKh3granNpGhdMH2WtgPEtdCUG5mnYtLay3	1624	1334	522	12463	18656	jxkstehfi7iE5VXmwnu9LnYZ2jP4MvZqBvuA5mJnFtACJdT1LVr	13361	18808	18808	1619324640000	orphaned
27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	27016	3NLVHrpBPURbrKXRcKwU1msqDVc3gUfQKdCCVp97jCyn5AQ7v2y1	1407	1395	523	12463	18657	jxfV75cUDunsSVFpGgauBip9yqjT9tNb1BDw99HXHHrWU7p1UZY	13362	18809	18809	1619324820000	canonical
27019	3NL9n13HPRJ58QpyoiKg9WtTjtnaspcbtLxdAw7s72FhJeitSYhq	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1522	1322	523	12463	18659	jwxbf5bp3cvC152NtXWdxa54DL2zuKvushfLhH7WCnEV7bqryaP	13363	18810	18810	1619325000000	orphaned
27024	3NKoqxC6c8LuU7oYaH9jszCSzMGYjzyUt5nS8vocgHCCTPPNQs9f	27022	3NL1adyKML4JWy5PD2jWwoGx23y65BRS9Ku9di2d77SNePAwJJGv	44	1199	523	12463	18663	jxhvN2kBRo7K5dHkBkQoTVZTYXQ6aBPxYeXYP1DDU2kzWHGJ9WR	13365	18812	18812	1619325360000	canonical
27026	3NKhQX7bbc4FNsApkr4oDY2NrBgMwNvRpK6xYdbav6yNVAdRvSCi	27024	3NKoqxC6c8LuU7oYaH9jszCSzMGYjzyUt5nS8vocgHCCTPPNQs9f	1534	432	523	12463	18664	jwHBSSppSmFQGbgDaxyNQC8PsAAqFyVM3sBBmSnay45dHfn8C7e	13366	18813	18813	1619325540000	canonical
27028	3NKPrGhGyL6nA7qhLrv5ktKdY5aBTqC2ouU73vrA2CoStRQoP3H8	27026	3NKhQX7bbc4FNsApkr4oDY2NrBgMwNvRpK6xYdbav6yNVAdRvSCi	1651	1301	523	12463	18666	jx7iruQcPh1cGPAvXttnrZEnBCn4atn55So43YJh6rhtzkyRacW	13367	18814	18814	1619325720000	orphaned
27033	3NKqU7WEEwp8zoyKSomABpXEYYj6mS678Lbejf8MFXnVj8qotisU	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	1594	1080	523	12463	18670	jxb1Km5JEzJTLkcZ7oWPe3WxpxYHebHinUnAWZnASky4fsAgxSH	13368	18815	18815	1619325900000	orphaned
27036	3NLaECB8oPJzwJcRMucf9AkDx3gM68NrtDnR4qZzyBHuPMsEDt1e	27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	1652	1189	523	12463	18672	jxoo1ZmLbbd1mnJB4HoJ87X2aUMf3ZJkEhrgEtCVAQGmjZkzmAx	13369	18816	18816	1619326080000	orphaned
27043	3NLH5qE9kvU5Wn9T54CN1k5mYKmsv1Jpvcxqz327MH2QVHbxHd3f	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	1637	816	523	12463	18677	jxS9biYS8QCuAKCvJZJCo7EpEWJSxQokRDv5p74rqBqyk1SLCMX	13370	18817	18817	1619326260000	canonical
27038	3NLvmk5vh3vPjvH4VRhUjnMQYwdzdR7GaMq73GdiUQpSR1pCxtMX	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	1440	1377	523	12463	18673	jwwsjEJGS2YRC9YHGhZmgai4WYhMxFjvYA3k1UuCYDKAjsEY5UJ	13370	18817	18817	1619326260000	orphaned
27056	3NLkp2G7fHdLSd88dkEFkiVikorrJbnHXYsDdgLws7c7KuWMYgBp	27054	3NLaSkeupg7P1HzaP13EueMXedeT3JEdxyjJfag3AcPbEAFbpN6a	1406	1393	523	12463	18690	jw7Nw365xB2SGsghkVnwJExw5naqzoYRVUueJNDbHLuyVHo3zw9	13376	18827	18827	1619328060000	canonical
27059	3NLMAoXDmfGwdDDV8euxW2vh1zboQSnmDB6upYfTHoWSsg9Ro9BN	27056	3NLkp2G7fHdLSd88dkEFkiVikorrJbnHXYsDdgLws7c7KuWMYgBp	1573	1318	523	12463	18693	jxH24aoAyEbNLuefP361agXq5VBvtEUDu8RXtpWxmsufubNwqEt	13377	18828	18828	1619328240000	canonical
27084	3NKTnxjXVMDhXb2hEFC1oLibicCVvSEmM68yqj8hCqBvNYQQ2QVU	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1402	796	524	12463	18715	jxgvYzxBJSsMADjktohWjkt9RsKAUAcPeN8KiRfcG3gseyNd3Vu	13392	18850	18850	1619332200000	canonical
29529	3NLToFcRTLpMjLqW2yPx18KWKrJoEZRss5pqDznjPQamGiBrTTid	29088	3NKzZqV5CSBWquNqnLbt7rUCS66xwFFhxR5QfAzMwPT3CZUGao8C	1608	1043	570	12463	18974	jxdWmd8Tz8Ggi4zxcwCC7qA5y4vBYSiUGBBPuyivNucERn43cRx	14341	20498	20498	1619628840000	orphaned
26981	3NLZQcZEe1ULuhPcjJUTbfd3H2JYccqEg18b26wSzBeutx5pRgzG	26980	3NLok4M63D2kikpYzMRYRSSufaVRBmbPZSkrdoSuTSUi9ZfAWeZF	1675	976	522	12463	18627	jwAKK6SfRasA4zCkAQCwdRt68QFN9rGsjKK2vSWB5gwsE6zUqBX	13342	18781	18781	1619319780000	canonical
26984	3NLSGCYPBNmfBFwimMmKE6faJkygcGJ9zYLsGztZBKDAVuX6YQmx	26983	3NLV7AYJ9MeN5p5XHxktXsiDcW23KStDPshrdwddNUnyaHSTeXTv	1458	1197	522	12463	18630	jwWKKBmg21JdVN39EpqjQBNZ1wXiFMHbrj96VZao7RRnWSg46QC	13345	18787	18787	1619320860000	canonical
27098	3NKcesUvdm6ZyFdVrkqSdvpKwbteMyshpY85bcc3Tmdg3ZhMY4Vb	26799	3NLesDu7XDK7JGxd6RY11GHiQeLhDXLh2oPdst72GZLHgfhu7pzU	1507	1280	517	12463	18727	jwxreepnwThDovfcRTJX4nCi66SRmaPReLQmh1k8AwAUaQwv7sN	13252	18856	18856	1619333324442	orphaned
26985	3NKA7SXtm6nT6CzhYrbN4i8vtBcSPsFEV296iCMZRjzatcquZrp3	26983	3NLV7AYJ9MeN5p5XHxktXsiDcW23KStDPshrdwddNUnyaHSTeXTv	1458	1197	522	12463	18630	jwjLY4VuDpFCcZR8jKztD5eenfF1PziWEu5n8V6wJGJsyW3BTHD	13345	18787	18787	1619320860000	orphaned
27001	3NLbG7ubXDJXFYnTyye4yZvGEUQZqy2W4SpjPWisnYvCwzpQoCzU	26999	3NKsJbPzZfQ4MRsxG2uuLcQZauHEFotAQbu8JrtabtQZpaXkQFj6	1633	1390	522	12463	18644	jxBmoPcaRvVgFnAADcEq8fYoxxzo4byJx6wdGjja37R4ZL678mY	13355	18800	18800	1619323200000	orphaned
27004	3NKz8KvxeauKyQn4xVUss1zm3nTVfQcPShMCz5JvEMFz2Yu3j6AD	27002	3NKuMvMMUEsLUTMWSERjDaTLwrc2QQCTgDBY5BRSqX6EmY3APcBF	1483	237	522	12463	18647	jw97itCextAQi7QekxTP76VqaSkVR8gdy7N9eDRahi1kL2krwK5	13357	18802	18802	1619323560000	orphaned
27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	311	1307	522	12463	18650	jxHW1VwAEJzAD6fSTirK3tY4fEEPuEi3aV4RhGc3ace43gciW83	13358	18804	18804	1619323920000	canonical
27008	3NKX8FRx374jBpMzi5nuF6Azk8qffFKbMETt6wn8x4SFkAU7GNbV	27003	3NLDp1kJmVwLwgPtMUac3NSjKg6jVNmLZtuJViCZhQWm53K3ffDY	1529	1316	522	12463	18649	jwU8W7eYSZKVYPn2gBn262CiwEktZHM1bdpZknmKfy5QEUvckQL	13358	18804	18804	1619323920000	orphaned
27011	3NLhAagD34Fzkq1usxuroNvTwG5fzgTgtyh49ZgYWZvbk5R8shAF	27007	3NLPRVkcfuMKNKjEiJo93UM4DbZRf3nnvReXaeugU38ivpE7jPh8	448	1059	522	12463	18652	jxvvcb23x9KcA6Nor2gJa3iAnezHrsgdvP27od8Rz58PeU3igk8	13359	18805	18805	1619324100000	orphaned
27020	3NLwFNMjPHtox1Lcn6vwXas92niPTBoK74SHXTJPwiGnmroQTvaK	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1522	1322	523	12463	18659	jwaTezGUaoc7oaZ6q2eWwiAq4ZiQxBAQVEV29ABpi1EzDowfhsq	13363	18810	18810	1619325000000	canonical
27018	3NKz4Xxi5s5Zi8F66TdNiFg5pn23RqNZNeqcHHxao6HLgkDVsGrC	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1406	1393	523	12463	18658	jwTmVcNSg4W48Hacj5fqaRxgbjc5vYbffJpBeFp6G7aRpqvbxhV	13363	18810	18810	1619325000000	orphaned
27022	3NL1adyKML4JWy5PD2jWwoGx23y65BRS9Ku9di2d77SNePAwJJGv	27020	3NLwFNMjPHtox1Lcn6vwXas92niPTBoK74SHXTJPwiGnmroQTvaK	1407	1395	523	12463	18661	jxpXsvDq94UZFqrv2PJBQo6LYhoMAAHKoRt7Km8haariRxjMbJS	13364	18811	18811	1619325180000	canonical
27040	3NKcB4Yof12UQfn2QHaSzZwk9Yz56Wz4AN3crBXXmKkTR6AR4uK9	27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	1440	1377	523	12463	18673	jw6fcCcPqj1gHDf2VZjKFRJ4FBvccDWoQ5UjeBr31SGVPv9jV81	13370	18817	18817	1619326260000	orphaned
27047	3NK7GcY8QdrCnmzGYDBfvK7B9oAVGtaNkhQFdLZr4f3TYLcdixhx	27045	3NLWqYWjQ8ht9H3CPDrgG5nLzB6ayo8x6jy8mNVhKaLt63D9sSVH	1631	794	523	12463	18681	jwtFJ7sWVVet69MpfjZ2kaThwtYBE7uRokmRb1HvhHmEDPNoiyn	13372	18820	18820	1619326800000	orphaned
27052	3NLE7PTLdvs3aoktjeP2ZS7YCVkwNzJEgWynLDyw9p2sGr4oDqjF	27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	641	1210	523	12463	18686	jwBjxzJPgs9ciMJg5eXTx1cXQ5M8XfL4d4fYvqTg9Hq6BnwfnBq	13374	18823	18823	1619327340000	canonical
27054	3NLaSkeupg7P1HzaP13EueMXedeT3JEdxyjJfag3AcPbEAFbpN6a	27052	3NLE7PTLdvs3aoktjeP2ZS7YCVkwNzJEgWynLDyw9p2sGr4oDqjF	1670	916	523	12463	18688	jxP1YYWMTufHox7vYdkMbwKoK6Nbak3jrS2wyQhoBG2tdHUTtox	13375	18825	18825	1619327700000	canonical
27055	3NLtpxRjn4GRJABztuCRZsmdZhWa8FFeqiaHho6NuPTBeefj1BmR	27052	3NLE7PTLdvs3aoktjeP2ZS7YCVkwNzJEgWynLDyw9p2sGr4oDqjF	1555	981	523	12463	18689	jwQiMxYi89fMNsJgdU9rZeSjfNT3ixu7zjBRF4ZngW4GKY2TWF6	13375	18825	18825	1619327700000	orphaned
27057	3NKhK7gYGMTWxmXtXjtF3YU9KkcUJbGKWAupW34KKzRHXt3oTTqc	27054	3NLaSkeupg7P1HzaP13EueMXedeT3JEdxyjJfag3AcPbEAFbpN6a	43	1310	523	12463	18691	jxhpB1P9gxGLJPBemA9KQva33AD3K8wEN11NkXtW5KemTqyAyLg	13376	18827	18827	1619328060000	orphaned
27062	3NLPi6ywXzm9BSKeE8ycKTqFK6JC63vcZgQ2NfCJPDRXSdL3ndvs	27061	3NLTKSd9Q1tetCqLkkfeAfijcYJceCuYidQDhB2v5QpCxuuxF1wM	1589	1286	523	12463	18696	jwxnLvQPm4RRQLFTf9egXAG11eXEwRqKiWLxX1siaTQ9CjsbQ7G	13380	18832	18832	1619328960000	canonical
27067	3NKbPkDi7mqYiEefHpXGUALfZjjNNWLeUW5CBBcJrbBRVcH8NkeQ	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1506	1373	523	12463	18699	jxBUveunHG2BAWcqRJVEh4bTchNFeFxscJ9bMy7vnrmHSER9oWe	13382	18835	18835	1619329500000	orphaned
27074	3NKFhcWpqVxHrJ9pc7CiZM2Z4zMdFRMEw44oMR4sBukFFcBRREzw	27073	3NL3oRp7uPDUkouoASmMQ1WGm3XStEqRNBgNqCQWnFRCZn7ovpng	1407	1395	524	12463	18705	jxC3VQsP3aptLXnz1JvVZF1ksctijFgN8AEmrk2jKHLExD7MHCT	13385	18839	18839	1619330220000	canonical
27076	3NLHtBgFLpvtiGadEGuGUubNLaehtYojZLipr21srgNTMJVNah8n	27074	3NKFhcWpqVxHrJ9pc7CiZM2Z4zMdFRMEw44oMR4sBukFFcBRREzw	1672	1159	524	12463	18707	jwt3zAiCBZUpSjahJ4BjRHPFFqbEhR9dzRVFHqepUMLQDrusca4	13386	18841	18841	1619330580000	canonical
27079	3NK4A1MJjH9CsAXjbd6kVxMfabL5iPhgpmDuRL5ADdcVjy2yZadw	27078	3NLZXNB3xvQKdpjrsrnSa2tQfuRVNsD2BANj2nkWxzrQePs5RArF	1648	1158	524	12463	18710	jwMCQcCYddXUD9gwfhCaRY9k3ZThuNzCryHXEfYHCrUU5Nw5zTA	13388	18843	18843	1619330940000	canonical
27081	3NLEEZhVoVaEYdhzp4TbqRX1RQpARDzVKwXzAjwXyUgoQRqXJoNG	27079	3NK4A1MJjH9CsAXjbd6kVxMfabL5iPhgpmDuRL5ADdcVjy2yZadw	1581	778	524	12463	18712	jxvuNhT3dC8ZSDv4RHaME7hg44pSCbBN8Pz9DCvJJyk2jkUKCaa	13389	18844	18844	1619331120000	canonical
27085	3NLDuv9e2crXZ1sa4JTuKWoqqtsnPKTj7enfGNP1jYvR7694Zqvn	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1675	1096	524	12463	18716	jwHiqVTTGWUEyT7ofooiUkGiSPxidmA6VfacmtZzPonnqAhzKSo	13392	18850	18850	1619332200000	orphaned
27091	3NLf9gcNMcxDUPr8vqrmxA8uynMZ9ziWrxa7BiF6EWVbgPWBxeWu	27089	3NKVCX33k4nNtC6Rbb4abYJTB13sKgDcBsKTaSAEeaP5uA7VZ8rU	1581	778	524	12463	18720	jxMJeH5f3gytMx5VjDRRBsLZpE2ZjH3C5KQaoSXpLn3JRTGnzjs	13394	18852	18852	1619332560000	canonical
27094	3NL4axEgCvuKYs44b73jrn9MABfML6aPntEbLgxaLmgTKhqfLSBi	27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	1534	431	524	12463	18723	jx6UCYG6y4ZjMVv9ChRUprdXk8XyzromJwCMVdFRjeALBRamDdT	13397	18856	18856	1619333280000	canonical
27101	3NL44UzXJs4hr8guZ3zkTZPx5XB3mMGXX6a9RVSRJWDkLEXMVGS9	27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	1406	1393	524	12463	18730	jw8zfnLKwys7Vo9gys7RYQJMzr3k4ydCZnW9jnqX9nU7zfAuLJX	13399	18860	18860	1619334000000	canonical
27104	3NKgCmPW4nLdCoqZJgT1AzfANzgZeE1teH8HmKCshFY8z9g9vG4H	27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	1406	1393	524	12463	18733	jwFFR3i4me5fLbAjtNC1yBxAAXxGaijxX7MM4g4kpDU3yNBgqAW	13401	18863	18863	1619334540000	canonical
29103	3NL3ryScuzQwSeXPDrejT4MwnRHukWDD1pFG4HR5kthrZYkZAxAw	29102	3NLwbyDz4eVPum2EU7KuthN1C2CH4KbEphG6rW2RuG71vAVj2Auh	1406	1393	570	12463	18974	jxZAGvCqbWFRftLPEMdFpx8UM8kTB9iFTtZm8cA3636SPug6ppK	14347	20198	20198	1619574840000	orphaned
27027	3NKVY72fKVNJzNMRcHp2Fezu9gsWYvaCWqcR6AspdDY38eL3Q6De	26914	3NL2iXYJmHXidD7n1JT9XHAstn2LCFoJQzTxiVL7jHEqb96j2nPz	1516	1294	520	12463	18665	jxNSHWtgGymTHRKc763tPs3d3Wq2WnVwZQUk1Cn3v5Q4kXXHxmc	13311	18813	18813	1619325540000	orphaned
27021	3NKUiBwE8zJePZ2vDYjicevUXsU3TA2R6SFe8pnTsmHdinnScumE	27017	3NK7uZtEuDBbJKiMETXZLVQsAvVqXuC6idM1HNxejZ4od74ri4s3	1407	1395	523	12463	18660	jwNGeY1JcAgJzsWVWJru6VRc2zuUfen5BugA24jZDwHqot8LCXo	13363	18810	18810	1619325000000	orphaned
27099	3NLSCoDx58SFTfjggSoCXCaUSL5nvWnL1bZtCQikPQNfiQf8ppus	26827	3NLamj94d7H8he5CHmfsXJEDNvrHaoBRMDAcXjFUMvuNtnS75X4G	1507	1280	518	12463	18728	jxpEReS6pNG7k4BQJkyN2fgrXUjDjDbsQzRFBh7rwZKfkQWHjsf	13266	18856	18856	1619333370455	orphaned
27025	3NKc7CbvSESqEt6JdEfSN9a59qSjpec1AXD5TWLUiKbweytBNH6T	27024	3NKoqxC6c8LuU7oYaH9jszCSzMGYjzyUt5nS8vocgHCCTPPNQs9f	1534	432	523	12463	18664	jxij7ZprPfhCrTC1z78S3twXnVjqBkh8CeYfRfC5cBajCHo1fVA	13366	18813	18813	1619325540000	orphaned
27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	27026	3NKhQX7bbc4FNsApkr4oDY2NrBgMwNvRpK6xYdbav6yNVAdRvSCi	1651	1301	523	12463	18666	jwXHDyRqFiHARRhrRUCLXMDfAwKMSApxnoTTHtiQrtE6EYC2xid	13367	18814	18814	1619325720000	canonical
27031	3NLjWhonMwvvrmcsPcTgD9chULYNgm8we1ima5sgNhZPJc6QZzvr	27029	3NK33ijYoWx3xSe6qhEJWFVpH6HDCsTLory5edh83PHFBtnosUtV	606	929	523	12463	18668	jxeiGvmKr3n6hS926sk44QUXK9qWPzCrhPM5gvtGpBVQAwfk9Cg	13368	18815	18815	1619325900000	orphaned
27035	3NLVoXM315X3vShzfdAvL5638nB6MsxwVdQ6r4n4EnYZFnXAadDp	27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	1403	824	523	12463	18671	jwf1QEanojZ58LsGYPRJmwThWwrWsFGcMVZChHzS6JR2WGoNW6k	13369	18816	18816	1619326080000	canonical
27037	3NLY3jpSeLbG3mLSThdWg8Aifm3b8WzafcPKbGvtfeqWwy36ZuLx	27032	3NLWFbXqa7RfwSeXMf65XNXLssDicMn5qmC1tqYMVnfN9vxNfdzn	1652	1189	523	12463	18672	jxqYKMBWBXSB8WPH8XTaGnPKPv3LkW8ivRRzHhDPmDNy8Prmw1D	13369	18816	18816	1619326080000	orphaned
27045	3NLWqYWjQ8ht9H3CPDrgG5nLzB6ayo8x6jy8mNVhKaLt63D9sSVH	27043	3NLH5qE9kvU5Wn9T54CN1k5mYKmsv1Jpvcxqz327MH2QVHbxHd3f	576	1109	523	12463	18679	jwVmp9jSjzMJ22HwqYPCWQs5Q7Fnt8Divo3QbXRuhcGvtSSJFKr	13371	18818	18818	1619326440000	canonical
27050	3NLTUjgtKnJxv5nxsKjE29UCo6U2vVmqUvUPighmQgFsXNBn3SR3	27048	3NKizW1CCB4TEqfCtnAvRsVxpnmpfGsahfQ7x6Ennb6zTT6tnA9j	1403	824	523	12463	18684	jwfT82sjCgdP7jn3uQLXmJu3rp3k2x3oKwdHe6CDEbbPyNCuXnU	13374	18823	18823	1619327340000	orphaned
27060	3NL7w23RGrtoJF8sMSQvNQZVYE4udRnUjtmhu7hVgdfLdxR9VkQu	27059	3NLMAoXDmfGwdDDV8euxW2vh1zboQSnmDB6upYfTHoWSsg9Ro9BN	1646	1228	523	12463	18694	jx6dheokj16tQX94jceGkgLuKCd1N9k6sqeQFJiwFtqSCrwEVzs	13378	18829	18829	1619328420000	canonical
27066	3NKdWgBy8y157dBQoTpHqh7fxLzueZ1oFPapjSEHFsESRFyQSCrY	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1571	1209	523	12463	18700	jxw8Dvx9SrYZAj3pYv9CRhiuzmP9Rvog95iJf5C4qn4XA1QZn5f	13382	18835	18835	1619329500000	canonical
27065	3NLjGp7Ph98GwDpzx5R7kZMuVyLxWd4eFXTmRoKgUVEVDw9NNKqp	27063	3NLYzgztYKWcJYzrHBZC6zQB7nqmrwVKJbpBvzamPhSq7MhCQg6n	1506	1373	523	12463	18699	jxn9DoLUrkWKy44a9pUQgtXa9EQQv6iPS4kqQzwMETXFfKPYvCv	13382	18835	18835	1619329500000	orphaned
27070	3NLrofK9ZDCFwHRx7kJA6mbs3yBSa9NSQaWGDYY1rmuhD6JsaoDV	27066	3NKdWgBy8y157dBQoTpHqh7fxLzueZ1oFPapjSEHFsESRFyQSCrY	1609	1207	523	12463	18703	jwsBsN4JB89YpmDcu4SY4nWnFMVKBGUTW4bZPu7QqxZzm2FG5kj	13383	18837	18837	1619329860000	canonical
27072	3NLdq7RJmi1RZ7jZ9jf3EVxUPfgtdqjSHd6ZqnkUoff5vxxWDg5c	27070	3NLrofK9ZDCFwHRx7kJA6mbs3yBSa9NSQaWGDYY1rmuhD6JsaoDV	606	1295	524	12463	18704	jwqwYCtTdcKwAbGLw4LkEtasYjrV6tTcRnBdboTq26DKn7j7QDq	13384	18838	18838	1619330040000	orphaned
27075	3NK6wQ2AGVDXbK2s5SnsEwcZFHixMZMNfLNmnH43FgNYvbJY4Fp6	27073	3NL3oRp7uPDUkouoASmMQ1WGm3XStEqRNBgNqCQWnFRCZn7ovpng	1507	1034	524	12463	18706	jxVjEQegoUGDK7Vdx4nM3H6ERoY4V3jmzXS1RCDXDbzqrX7Ks1c	13385	18839	18839	1619330220000	orphaned
27077	3NKgwUeiVTH3mAVmDAHDCyfSDD7godnTxJkuqiPS43ox8mct8qaU	27076	3NLHtBgFLpvtiGadEGuGUubNLaehtYojZLipr21srgNTMJVNah8n	1407	1395	524	12463	18708	jxEnZkhg8PXTyBUr2wY1kqgiM8HRmBbmEHfRfk8iRxviBhGXqcy	13387	18842	18842	1619330760000	orphaned
27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	27082	3NKuSGUTWKv1NH7CH1u2ambZKuNTRqnTPdR92us2NuYq6gg3eDhW	1634	1085	524	12463	18714	jx3VDKmS1N8PxEZRSAVTDa6Vt3Uv8xaoX82gD5hrEnqXj25ZQE5	13391	18848	18848	1619331840000	canonical
27086	3NKCXJsRvy5biDHcnRxo95VZeN7NHxvvk7HtuAqnz7sK9AVZqavT	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1541	1298	524	12463	18717	jxYGQt8Zk1QYAkZttuxUoQyTNdQietEqfvqwtiDgtGkbTV56LBT	13392	18850	18850	1619332200000	orphaned
27089	3NKVCX33k4nNtC6Rbb4abYJTB13sKgDcBsKTaSAEeaP5uA7VZ8rU	27084	3NKTnxjXVMDhXb2hEFC1oLibicCVvSEmM68yqj8hCqBvNYQQ2QVU	1402	850	524	12463	18718	jxJuedxfLMqxVieQgnRhwY54rUh6A7J1TW6QkEzwQ65x99MiGCQ	13393	18851	18851	1619332380000	canonical
27090	3NKYEg4S9wr3v8uDqn14FuW1pn9wV1YU8WvjQSMywkiihk6nQ6tg	27084	3NKTnxjXVMDhXb2hEFC1oLibicCVvSEmM68yqj8hCqBvNYQQ2QVU	1500	1051	524	12463	18719	jxrNTfES43jsuU4PfqSVL2frMQ81qhH6WK7uxiQUEtG7FBLZqbN	13393	18851	18851	1619332380000	orphaned
27092	3NLfB93tTkiWE5p1a22BW2g7YgjQT6VbxcMmYHmrcL449nPdVxch	27091	3NLf9gcNMcxDUPr8vqrmxA8uynMZ9ziWrxa7BiF6EWVbgPWBxeWu	1501	1360	524	12463	18721	jwiVhfU9iSrmtBKYZgkNGU39Lrfj8X7fHHcJPgnPrSvF22dFiBa	13395	18853	18853	1619332740000	canonical
27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	27092	3NLfB93tTkiWE5p1a22BW2g7YgjQT6VbxcMmYHmrcL449nPdVxch	1581	778	524	12463	18722	jwjXED9nZLBk15n9nksgEgswbN5DrZvmeUdW5bPSdXqNrT2gdVk	13396	18855	18855	1619333100000	canonical
27095	3NKn6pViNTPN4Gj4fsbfkSZTQnAXoKPZ7NzfEbkxP7rcmBLZosuJ	27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	1522	1322	524	12463	18724	jxQ8qAAL4UyGmjnweuenUtTMDbaZm7SfrB6HhzR8kp7UYCTeVq1	13397	18856	18856	1619333280000	orphaned
27096	3NK8dvYegosbtDXxJgQmuAPGUeK7C1GJ1AKyUJRgYGtggRmAsqkD	27093	3NLq5o9tNFvGFtvfBFByt15HS6C9DtUj39pMbcdjyoBUPKtkNDtN	1407	1395	524	12463	18725	jxpeReDrA2fVxRPNzGDh6RT3D3EbhCqmU8TPbAmcqvn1YXTkfUa	13397	18856	18856	1619333280000	orphaned
27102	3NLgs6iWNNEiiTBaFLLuSHmnQud9MSSkJAfYYN7WEofbpuktfvh6	27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	1447	1345	524	12463	18731	jwqHWFixQqSwLgwT6ahdn4atiSQJz4eaUAk4XTi17jBqBFsNc1i	13399	18860	18860	1619334000000	orphaned
27107	3NL3oMP5YpQoJHbFE2qC4hBSrrXQdLDGXxMraqzgqXqhbzH5EtFq	27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	1646	1354	524	12463	18735	jwaV46aEcYAMaVwwwVK9bqzZAoC7sLdqYeKjWyF4o5fphK3dGa3	13401	18863	18863	1619334540000	orphaned
27111	3NLjZSrgfXfTQ5FBXcSzRv6WYA8C3sEwrQJoyggrUyWk1L52hKHq	27109	3NKAaiNCkaDoJG4ji2Nn2F3ojiwAecKvZDV7S7WJBjQ6JKeCTTz9	1622	1110	525	12463	18739	jxn5L8dWJiAn4Jm3fJqnr6wXPh4QTb3oXZkFD5BMsddMJymDH4n	13404	18866	18866	1619335080000	orphaned
27113	3NLdPuTkNtox6mi3gsW6cZh8Hhqwunbz1nMoPS2HJmX5F1wzFLqt	27112	3NLRbAFo72JogFCXAtTHSxfhri5pXWhuRBfGAqJ1oAPQuDaQUJXa	1403	786	525	12463	18741	jwet8TYSDtWF9BENPLhgEEDVWbWURMijqiW9QNnNkEBVm1xmTq5	13405	18867	18867	1619335260000	orphaned
29693	3NL752Bv27rMjfSFQJVfeReQnyHMRqNAsE2mBwNKwLC7iUcy9XK3	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	149	1283	571	12463	18974	jx2Q7KcxfX4RSAovqXbuZsh7xdCK1ZB3uFxYJxAWeMJvHjUFWRv	14357	20623	20623	1619651354772	orphaned
27110	3NKm7aQU3qmr7xxZamft7vFRyhUmwNta2et4c2fZBHVzc9XEPruX	27027	3NKVY72fKVNJzNMRcHp2Fezu9gsWYvaCWqcR6AspdDY38eL3Q6De	1516	1294	521	12463	18738	jwpFUtm9irxK3jkXu7UiaLLtmsd54TUf2mf2Bg5g6mTQgZgz5vW	13312	18865	18865	1619334900000	orphaned
27088	3NLFwkSY8SKaU5pVkjfLLdriCCW2DEJTNyJU5sVnBnv8zuixK6D3	27083	3NLCAikxpnahHFwUjcSVyXrigDaeYmvcfocedeJn75uG5YhsmbqN	1541	1298	524	12463	18717	jxgvBKhWBRYwemVhvE4DawFGNJEU3gRu8W8ABbeBz3meatNiB94	13392	18850	18850	1619332200000	orphaned
27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	27094	3NL4axEgCvuKYs44b73jrn9MABfML6aPntEbLgxaLmgTKhqfLSBi	1564	1092	524	12463	18729	jxnVEMRYvhwP5hwye4nGVPyzT5kL6MPcZX6ZqKtdVTDuw8vSeTJ	13398	18858	18858	1619333640000	canonical
27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	27101	3NL44UzXJs4hr8guZ3zkTZPx5XB3mMGXX6a9RVSRJWDkLEXMVGS9	1444	1381	524	12463	18732	jxvmMZRA1KvzvnTYGdEBNHkwfET6heaFL8RusWZ6naDPX1oEmr8	13400	18862	18862	1619334360000	canonical
27109	3NKAaiNCkaDoJG4ji2Nn2F3ojiwAecKvZDV7S7WJBjQ6JKeCTTz9	27108	3NL7u1MNbNMrYq1Go6BURVt8ATUvunNoKMBr3DMsLN46zh23XxC7	1406	1393	525	12463	18737	jwgiqutUGtwtsdeva8eowEUy9rX2HAp5n5BGXdGAProLmsPFeeA	13403	18865	18865	1619334900000	canonical
27112	3NLRbAFo72JogFCXAtTHSxfhri5pXWhuRBfGAqJ1oAPQuDaQUJXa	27109	3NKAaiNCkaDoJG4ji2Nn2F3ojiwAecKvZDV7S7WJBjQ6JKeCTTz9	1611	1095	525	12463	18740	jwebVxARByH3kAmv3Yewmw8YundW8JHN9i1ig65CZBcFpVbsP6D	13404	18866	18866	1619335080000	canonical
27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	27112	3NLRbAFo72JogFCXAtTHSxfhri5pXWhuRBfGAqJ1oAPQuDaQUJXa	1637	816	525	12463	18742	jxNKFEcTtfyVbbkpaFXxspWUtznn5Y2CaDX1zuYHRgEKe9yB54k	13405	18867	18867	1619335260000	canonical
27116	3NKkJnrkcaU6DMAjuvKpJTayAJHadQBvkMUx2GUMFzPHkXhpnoYj	27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	1610	1068	525	12463	18743	jx3EQFeeDgbssBdioXQQXHgVpPRFaTfML7jeMqQdBNhjQVp7zS7	13406	18868	18868	1619335440000	orphaned
27117	3NKX12qyX9caUmZ4KyNYuEFzB7dh9apM74staY1ihUYAx3pXFCWa	27115	3NLj95CwrWfop3oiUjv6V237C1HmT7D8MYexGvU5hU68kVvTC3oA	1646	1108	525	12463	18744	jxvTVDtW8swLWf68MeGHob5LV9d41meXPxrG8W7cwQ3bbJwzeYm	13407	18869	18869	1619335620000	canonical
27124	3NK6jATUQAkf1WH8j2WZ2vQxBuXmwAwPt1jyCd3UuoVfcJUUvgNW	27122	3NKzfMJ2dMkaehiYeFX7eoYoDiav2GGizYSEVv7WbWat1HNMsVvC	1403	824	525	12463	18751	jwmUPyBUNjHr8QDVGGBgcrGmqp9Dw5DDPT5uwQywTsrkU9cH6tv	13412	18876	18876	1619336880000	canonical
27132	3NL45AVr7UYVry8LhRq957QL6JahZmnywu3CGy3wLA6bBymEWGmp	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1671	1239	525	12463	18759	jxa4C7wwcs8vV3rRmK5wKRszrSn7frBHBNH5SdfoGbZcXXWAadn	13418	18884	18884	1619338320000	canonical
27195	3NLrHLbrG9a5gu2Fc336CWJ54f3aaxMic2QGWCpoiEwkhSFKBx3B	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1457	1391	525	12463	18818	jx53y1qS9VRfCaXymJ4g8jKX9rixUSZYDWFdQ815pUTEh5eHiTL	13418	18928	18928	1619346240000	orphaned
27137	3NKVSy72MhTdW1bDx14PzkJRiYFfJaByhcpaUajM3Hi9WmqnnavQ	27132	3NL45AVr7UYVry8LhRq957QL6JahZmnywu3CGy3wLA6bBymEWGmp	1637	816	525	12463	18763	jx7VtS1b4Nh1SvSe17JMJNdCp9n96jcFTNyvJYr3VFSWN3dcW5v	13419	18885	18885	1619338500000	orphaned
27143	3NL96JL3m8aVeJs7KmvdEn2QqAotDLESkBKT2b7LSdLNr6qsgyWL	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1637	816	525	12463	18768	jx1HpFfsyWa4nVM23MJrRwj74LhWYV63tVqDkdTugeqBxhvaMzT	13421	18887	18887	1619338860000	canonical
27141	3NKXaQsQAsVc9XctcSmmX65aH2PtE6HSN85qprdgvwPA7Chs4c1N	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1440	1377	525	12463	18767	jxe7Vdfb3U4VMGk97JR6o3SdDwYZiKhSbFsG26tL6nfYJP6gCEo	13421	18887	18887	1619338860000	orphaned
27151	3NKu3U9ookYhSyUQwUbJ45DymuMNsFNw2N6X5btGntYkWxwUkFhM	27149	3NKQq8mBsvwzHrAUZmdUVb9SmPGjXHDTT3rQHoUEv3BZFewWThpt	1631	794	526	12463	18776	jxbb2Ee7hkGLF3nShq8WEMBhiFf3nVxmUuSKSJAvkC3FpGVmLDm	13425	18894	18894	1619340120000	canonical
27154	3NKBXCtHyfXEKaugnydGLdh4WYEqkLuFyHZiNsiSQFTbkwGiXreZ	27151	3NKu3U9ookYhSyUQwUbJ45DymuMNsFNw2N6X5btGntYkWxwUkFhM	1406	1393	526	12463	18779	jxGn7jwVLLSccQ4HGEEMd8HmTUPLHGkdFfQH1G4KHvTRrbwuYeZ	13426	18895	18895	1619340333519	canonical
27155	3NLBRsGwsysNfwXkZU94Mcr8jafGwgN8t57ghdgcyxvMnNmdopaP	27154	3NKBXCtHyfXEKaugnydGLdh4WYEqkLuFyHZiNsiSQFTbkwGiXreZ	1407	1395	526	12463	18780	jxX8WudQKJ2WSmDPbtLRVcqpa2oX8ajs5WHbZkbex6ReC95MCmX	13427	18896	18896	1619340480000	canonical
27158	3NLjuZRor3Rio2zm9nVBJNjK2msWpAZ7hKWbXeogS1wZAZFaoFAw	27155	3NLBRsGwsysNfwXkZU94Mcr8jafGwgN8t57ghdgcyxvMnNmdopaP	1403	824	526	12463	18783	jxgowPeqx2LS2VSknF7SdyCCYr8zyPkNvSYJShx2THbngKeu4xo	13428	18898	18898	1619340840000	orphaned
27163	3NKTLyXGU2cmQ4XmNQMCZTu5WxCW84uBSz32r7GSA9obqZPibALL	27162	3NKCv2NbNwpvzCNpMmAFLpQtuxoWQsPQTBi75YgoPfQP1zUQ5qVM	1406	1393	526	12463	18788	jwoge2ZPCZhRxKXewDNWxG5BGRbRpkDsh2RZSym1UKVmTCyxuoX	13432	18904	18904	1619341920000	canonical
27173	3NKCR3mxmyDULKFTdvxj2DdWTkSoRfvwAQu8C3TrxM6EUrnBZPNH	27172	3NLheaVwn5yYGL1tpcpB9ghxP1DqXv1fnZkEG59MSoCE1wJcmySw	1549	1362	526	12463	18798	jxG358atmtjWF9E1YbEBs8dFsTUsY9XhkMTAwGefM8a4DUpLXCZ	13438	18911	18911	1619343180000	canonical
27179	3NKRGiE97VwxFH2JphaUb7BbQ4HPDYy3fkQX5xNRcZSM6FR1SUmx	27177	3NKjcmw2wFWzcviBvsA7JjFMEdxLH2WAn1aXQkiQsTCmYeUY6Att	1637	816	526	12463	18804	jwS8gMh5metrphcyXJCnv3PwjWMPa3o5x45pJSQv4j9vXBGUFXt	13443	18918	18918	1619344440000	canonical
27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	27179	3NKRGiE97VwxFH2JphaUb7BbQ4HPDYy3fkQX5xNRcZSM6FR1SUmx	1501	1360	526	12463	18806	jwPL5pjyDjhXJ1AuHdRBSLPYYbGVt7fuaGA1xkhwcB83VGTT2Fd	13444	18919	18919	1619344620000	canonical
27190	3NLKbZJPCPUTtc25e3gCkzz5Mz4hrxHiNGJesN2jrfCMSHXJqP8k	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1610	948	527	12463	18810	jxoRY3kgBJgLWjm3mXMPzG1hAxBjjXnJx3zXcr8mtCm2HykuKiE	13447	18923	18923	1619345340000	orphaned
27209	3NKJffbkx4RZf29KhEMUSWGrukqVvadD32ATzCJ2y9tMP6aR4Pq9	27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	1529	1190	527	12463	18832	jxCKvT865LpH7uLXn9MdaZtiWfsMLu4fWqT6ck8qvfLZsZT5sXB	13458	18938	18938	1619348040000	orphaned
27214	3NLJiDpHcDVM67cZQoE3dN1emuHE5PWqrbWodBXS82FZsMbA3q2A	27212	3NKLUAcrbJoHBidPMFvxkUmXH6Ghk9ST75xABh6NixMW2pZYA21e	1402	892	527	12463	18836	jw98LaYejHm2baEhYBcPVwnNb2fWK6rN9spyXRd1YinWTFupQB2	13460	18946	18946	1619349480000	orphaned
27219	3NLqRwA1FTaEEBupcptLoQMGqYcpX79ACGkSZvY2P6EHqXqyY4yf	27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	1550	434	527	12463	18841	jwfp4RRwWXYy3RZLVRHV2C3MyhNra5FDxTsZSH45K1izujC89So	13461	18949	18949	1619350020000	orphaned
27223	3NKaEq4pTXyHUxvey7hJjiAiopsRJ9K56Nhg7Dus9k8Ed5U6hmjF	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1406	1393	528	12463	18844	jx49DjZL2s8Soono6KLYgiUbc3bFZHN1XBa4oXcXUeyVX5fEnwJ	13463	18951	18951	1619350380000	orphaned
27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	27229	3NLNXRrcy89fAVawh4vziRLPLDmRSyQ859JnhC9VdprywsiZ5Hnj	58	1035	528	12463	18849	jxNv6msNw1b6k7RbBcaG185oftnvgCNAijTLdYGtpZWTxQ4Whka	13465	18954	18954	1619350920000	canonical
27106	3NL2qye95xzcfrUHN6AMLCw95FMLozqx91CGZ8vyzQAZUjy36gFQ	27103	3NKk7M3tFkH2LGPkEpaoEVKtaF6s1hH4r3vBdiHmp4w5T2AuNKbP	1646	1354	524	12463	18735	jwLdDoaG3qd6iy2pfGoSuW6Uk6qYsnTnPajSpZ8M4hdWGvWHy8N	13401	18863	18863	1619334540000	orphaned
27108	3NL7u1MNbNMrYq1Go6BURVt8ATUvunNoKMBr3DMsLN46zh23XxC7	27104	3NKgCmPW4nLdCoqZJgT1AzfANzgZeE1teH8HmKCshFY8z9g9vG4H	1608	923	525	12463	18736	jxFHiatS74sbhSPJzLmh9Ju7PkUqVnhXjbGjJfp2uThQbfFUb7R	13402	18864	18864	1619334720000	canonical
27115	3NLj95CwrWfop3oiUjv6V237C1HmT7D8MYexGvU5hU68kVvTC3oA	27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	1610	1068	525	12463	18743	jxH1vArJpWFFLSdAMAkQd4oFetA4txsnWcLBwG3o3GNNNqiCzRf	13406	18868	18868	1619335440000	canonical
27119	3NLSiDvc11H32dDM95UCGcKzVh4214zUEosJTgSurAuvNnCdbjwm	27118	3NKwz6fare6DuHqczN11KbsoaYGxzkPi2B6swPTr3JFuvdAzP7Rd	1445	1290	525	12463	18746	jxFu7ZeLGim9TNmn7LNC9A3KgJitRrXhQaPrxUrhBDmiW7SrSLm	13409	18871	18871	1619335980000	canonical
27120	3NL5r9oUAHi6ahZGnq9DHLS8sdDTpe6Tt7X1Yz4gzHS5heMArwXX	27118	3NKwz6fare6DuHqczN11KbsoaYGxzkPi2B6swPTr3JFuvdAzP7Rd	606	1049	525	12463	18747	jwufmAvi11zLs3quTCtruD9BkDhTg9PPZZADMfkj8mPDMgBfK8F	13409	18871	18871	1619335980000	orphaned
27122	3NKzfMJ2dMkaehiYeFX7eoYoDiav2GGizYSEVv7WbWat1HNMsVvC	27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	1406	1393	525	12463	18749	jxQ31Qu8VZaL3sSVxwHEaMtTdUcTg8L695gdt24fPp98qCroLAF	13411	18875	18875	1619336700000	canonical
27123	3NKybjp8VyrFEznAn3ZXTBifVHr4ijHR2NNvXWzZ3fHiRSHqJrmr	27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	1407	1395	525	12463	18750	jwF8EzbX1WR8jpdk4ix6mxgXXGwq68o5rPrXe98Tdcif8AxSbP5	13411	18875	18875	1619336700000	orphaned
27125	3NLmA8woz7f6CwYYQwo4cBFY13fTJE7FnBT22rPQMrc9mrtNAsh8	27124	3NK6jATUQAkf1WH8j2WZ2vQxBuXmwAwPt1jyCd3UuoVfcJUUvgNW	1447	1099	525	12463	18752	jxGJogL8ydENdDnP4vANq1ErzHFYY68rLHfnURVjpe4cvtAJWrs	13413	18877	18877	1619337060000	canonical
27127	3NLDPP74HBTiHPe7pdehwoY8gFH61MtSnaYXVXH9LQpsELp96iKy	27126	3NLihsNjaaSHgnPfXxVJQqogQa3BhKVBA2JS7tiB68UwwABxnTZ2	1642	1001	525	12463	18754	jwH52EuKBnNebsnkUk3oBnUS2Q7c79KVegF9JAF8RFenVWghuNS	13415	18879	18879	1619337420000	canonical
27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	27129	3NLSVmyr772j1ptMDdi16xxgoMTpWUzM6mXM5jcwP5zn2ShLtq3A	1406	1393	525	12463	18757	jwWbaA9AqpnReJUPRWDvzSPQFJTc7vP2dhMLT1DvuowTRpjw7Ba	13417	18883	18883	1619338140000	canonical
27131	3NKRMezq8bcL51xSXwY7CpksdoFpm9kuSyJFSDHoFEPTC2bTqRPW	27129	3NLSVmyr772j1ptMDdi16xxgoMTpWUzM6mXM5jcwP5zn2ShLtq3A	1522	956	525	12463	18758	jxtyJjvAiKp75e1WehJWc19zbfEspVPY4WRKrS5c6Q7yMf22GG3	13417	18883	18883	1619338140000	orphaned
27133	3NK3mg3UJk5Cpkysu2k7NBevihcgyh7iAU2XTo7hxJe9i71AzR2C	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1577	1201	525	12463	18760	jw8r5x1RmCbp7B49A3BSRCuQUpfTqyDPsPorFYKmyWMeHtSB5FJ	13418	18884	18884	1619338320000	orphaned
27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	27136	3NLQkNqdk27vN6d1UB9vU5r3N5D3f7povQ2gvvfsV8isAGo22fXH	1406	1393	525	12463	18765	jxKWGFuRrrhc1tVJZY25YVVZBbJrZ4B5fKNKcxhMFc4Edp44MSw	13420	18886	18886	1619338680000	canonical
27142	3NKaxc7wsAuGfhrytkcisAdqszMYHgjN5TqVXDNsiBkiQHJDgRiG	27139	3NLoyuPYhTGjn1UEURuWJJx1HLVnWAGGeTLQoTF7GuME4r4GW7As	1440	1377	525	12463	18767	jwzi5YyDSZh6SzcrSNS6QpjfGn6M3AJtc5bbKruWdxDMVjoZXo3	13421	18887	18887	1619338860000	orphaned
27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	27143	3NL96JL3m8aVeJs7KmvdEn2QqAotDLESkBKT2b7LSdLNr6qsgyWL	1421	384	525	12463	18769	jxtdYCgq87CMuNrpe9sjeADeTv23yCqctAPgJQKXN2sSYvkEcRu	13422	18890	18890	1619339400000	canonical
27146	3NKoHXNrTiaRamEUGJPykEsyfL83B9i5hEKxm7StDrzDU73cEb13	27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	697	697	525	12463	18771	jwT4Khv58FLHsEqCGZe9Yg46AJsa7bRoiPxLqeRom5kjTjw8e5R	13423	18891	18891	1619339580000	orphaned
27149	3NKQq8mBsvwzHrAUZmdUVb9SmPGjXHDTT3rQHoUEv3BZFewWThpt	27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	1631	794	525	12463	18774	jwxTU2zexLbfbKbXwBzGqQePi5R4KX8nfQvaGEaQQL6NN5TJZNH	13424	18893	18893	1619339940000	canonical
27162	3NKCv2NbNwpvzCNpMmAFLpQtuxoWQsPQTBi75YgoPfQP1zUQ5qVM	27160	3NLN5qG2TKu4SFwYpWbgGnbZywDvEt6i6Fc8ppQdrWm9CyqLumAv	1593	1346	526	12463	18787	jxWqLtDrhr94sexncMaqxVkybmNyTgoLYnXXS9cWYXjLvfCBy64	13431	18903	18903	1619341740000	canonical
27161	3NKCQibxvH1nSrBv4Jwbycq1wqnJXXn4TXHs5VbCCYoP6T1nnXX9	27160	3NLN5qG2TKu4SFwYpWbgGnbZywDvEt6i6Fc8ppQdrWm9CyqLumAv	448	939	526	12463	18786	jxHzzy3A88gNK3Bqbdh8xhVzNFMP6GPPTjYqBHRkShChA41tufo	13431	18903	18903	1619341740000	orphaned
27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	1643	1053	526	12463	18793	jwiWGvCq3SkFBsSXoccRkHmL838AkEGAnABZn52N1ThUrn2B6wV	13434	18906	18906	1619342280000	canonical
27166	3NLWNJmbT3e9jzeRSZ9fSuH56DSYF8vvWErJiNZ3LQW66KtrLV5f	27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	1672	1159	526	12463	18791	jwGwG1Vc9uFTrMxge2Frdz5hZyVip9BsBFM3QCMET4m7ZavHmXL	13434	18906	18906	1619342280000	orphaned
27176	3NL16dTqRXTHXiMa7TVUC5aKGvRmvdWRdVCyZSPJGpMrZp5UmtkB	27175	3NLuMBtpq4MGi1XmGqQKm2Te2rJnZ9JnQedGy1ym38FdESckHefy	1610	948	526	12463	18801	jwZvkmycCqEFNjrfUL1u4GBhJsYVUgnRoDD6gjdJ7FzfYsFtL96	13441	18914	18914	1619343720000	canonical
27182	3NL9FKYGJK699rSyoBUXKA4f4fuBZ5G5xaB1QCYxmTxLGGEesPVV	27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	1483	377	526	12463	18807	jwJmCD4XBexFGCFq4E8trBfhfVP3N6apv8b77G5B48EiFtSfgjJ	13445	18921	18921	1619344980000	orphaned
27186	3NKikYxZ3EbDAUd96cEj39QL4tbKJTKgFamuEfqgDSxJHUoGAiSb	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1610	948	527	12463	18810	jx4Xmn82EAVtocP3MevTDhxEMkKADU2MCeqbykh6HVswA61fENe	13447	18923	18923	1619345340000	orphaned
27194	3NKgDVTyCQsq87C25Xg7HccrbXvDnKTH2V8KBQym5TPoQBS42isS	27193	3NL92MsPtphU9wLXbQR7ZKi9T4hddjv1XVqkfWapUdBkqKVsWoJJ	1403	824	527	12463	18817	jxshGyeuLY722N3YKcwFntRnkyHu9sjywowvdm3LFhx9qqdxJPo	13450	18927	18927	1619346060000	canonical
27198	3NLaaEhBcXEei6Dy8C8CamnRnhfGS2NCrPbbizXWWjdTMQXFARCg	27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	1426	1118	527	12463	18821	jxqwpEfZgntuHojoCjB1ze8HSguvSzo4KG6GvaRmWLxWBnFex8U	13453	18931	18931	1619346780000	canonical
27200	3NKi314nCC6bD5EH7Re4n3i5B66GCzVJyyn64u4MFGTkcBiriDWC	27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	1634	1331	527	12463	18823	jx21HPT1wzpTCCdpZkqfCRAo71HeU82cLWYZS5xGL8KZ9A8kHRD	13453	18931	18931	1619346780000	orphaned
27202	3NLmziS2spcyLbQY3vwovYqajcdn99JRbR2LwU5Cw2UDPNSZUjha	27198	3NLaaEhBcXEei6Dy8C8CamnRnhfGS2NCrPbbizXWWjdTMQXFARCg	1407	1395	527	12463	18825	jy2b4CgyfTpJeUKdKocXoy4RSiFeWS9qYaXfat5pYfpVadPgo97	13454	18932	18932	1619346960000	canonical
27205	3NLwuwkeqXHHugR6nCQTC8m2j2swVcubLDQPBRS47rr7w6GUhjvH	27203	3NK9WyCEG2yzaqVrDA4RHdindgc9TEJzDJLjjsNoB6J3sRZEbafm	1483	122	527	12463	18828	jwCJUQvwQksXEkXdP3L67b9XPNSVLziTvogtvqxgfNFmL3B83Vh	13456	18935	18935	1619347500000	canonical
29700	3NL3r6rmKhFRF32tB6rbSWtZFSqqht4DKoEJjqv8v1gUAVZVfny7	29123	3NLCMnDprxyXjkWKfMeF5NavZtK66eD8pgW9FecamSWfnPPM9Q1Q	149	1283	571	12463	18974	jxds5q2eS8qFZs9FnpXEjWoyupWP3inetiXM265ff5vjMWGVq1W	14358	20623	20623	1619651396504	orphaned
27208	3NLCEfRSedkthbgqNkP6AQxeF8qdTxizAshdiqHV1eiW8TT9vWMe	26847	3NL2kgzcD5N5pifsYV7UAVDVZy4BeLHjqFqauKTZfxYedX4AYRvR	80	1273	518	12463	18831	jwSRraBsDFJKch42c6jDy9j9GuL7Gu4NovTgF12w7LBjn1tm8ym	13280	18938	18938	1619348040000	orphaned
27138	3NK4cWuP3cRyG9QkQdJZxP6dLZHsv5HV395YXMwWMVobnD3mwYry	27053	3NLdzNrbuAcKpBXHxnH1Ei3pAoqFULVtXtAHQ5x5iMAYEbDAmLYT	1670	1156	520	12463	18764	jwvpzE4TucxZBNZKk3DfWazcgUdcZSY1jDHjiwPfJyt5S4fDMoy	13319	18886	18886	1619338680000	orphaned
27164	3NLDcnoD3VvmhrmV2pKeJ97TF3eTDhzAYgyrCBMN3Zq5dDxc24Cm	27044	3NKCCiQ792J77zznv9XDHYUmYRXyS1uL3jLGSujYRwMzUgErYaFf	576	1229	516	12463	18789	jwSQtH432rnneMgKqth8ZAC1H9yQn1BsReByLAW1oED4bGwieJ9	13234	18905	18905	1619342100000	orphaned
27118	3NKwz6fare6DuHqczN11KbsoaYGxzkPi2B6swPTr3JFuvdAzP7Rd	27117	3NKX12qyX9caUmZ4KyNYuEFzB7dh9apM74staY1ihUYAx3pXFCWa	1406	1393	525	12463	18745	jxeu1tC7FNjewQsiBsUTkjMcohwLRQ529Upj3Dyo9UCHaFm6uC7	13408	18870	18870	1619335800000	canonical
27126	3NLihsNjaaSHgnPfXxVJQqogQa3BhKVBA2JS7tiB68UwwABxnTZ2	27125	3NLmA8woz7f6CwYYQwo4cBFY13fTJE7FnBT22rPQMrc9mrtNAsh8	1508	1387	525	12463	18753	jwvBNXGCfPZcRy6Gz6iAiqbdTZSte4RrM43dTfAK6DdgY6NNitG	13414	18878	18878	1619337240000	canonical
27129	3NLSVmyr772j1ptMDdi16xxgoMTpWUzM6mXM5jcwP5zn2ShLtq3A	27127	3NLDPP74HBTiHPe7pdehwoY8gFH61MtSnaYXVXH9LQpsELp96iKy	684	1226	525	12463	18756	jwHyQMCrNutqRcpxoVvppXCpcoWUDjJH3oz2vVUrncfJAmHTjEH	13416	18880	18880	1619337600000	canonical
27135	3NKAXZktJiBzUBGhwkq7VZZPqbb7MNdA22YQxgvihgG7byXWpGc4	27130	3NLtnSiZhqLVnUToVMUKxzxSsBjaAhfK43dMaGG3HydJGUKjSXf2	1581	778	525	12463	18761	jw8nbwMfzcyuG8raaDKhHBwSTMgRVTDXUqEGGqCe9TqYQT2gCRh	13418	18884	18884	1619338320000	orphaned
27136	3NLQkNqdk27vN6d1UB9vU5r3N5D3f7povQ2gvvfsV8isAGo22fXH	27132	3NL45AVr7UYVry8LhRq957QL6JahZmnywu3CGy3wLA6bBymEWGmp	1407	1395	525	12463	18762	jxzgDYRLcpdsENX2a6zNg9fdoKcQ78ok7fvxufShQSwCmExh8Gc	13419	18885	18885	1619338500000	canonical
27140	3NLKhor2aCL9N1eHasdHqoevL88kUgfYMjKmmiEaC7Gxf8sB7s2A	27136	3NLQkNqdk27vN6d1UB9vU5r3N5D3f7povQ2gvvfsV8isAGo22fXH	1670	1156	525	12463	18766	jxDuYZHAGqwyysiNYQDLZ8hP5jAGJW9AYBaiCthDv1535ketmHj	13420	18886	18886	1619338680000	orphaned
27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	1637	816	525	12463	18773	jwbxFxNesyCTJppUobtYVkt51xESXGuQvWAa74mXvyxaVnH1PPm	13423	18891	18891	1619339580000	canonical
27147	3NKQPcVhwt66SqR7bSor5G12WZT3Q574moppbtiEsqtTJRabnBSZ	27144	3NLhuTLL2DT7Wd5P193yEKz4yp2as6JfSGBvSFFdWcg7cyodQy1G	1668	1124	525	12463	18772	jwD5WLshRjkK7tt9HypgHRGqzmBdEW1P3exK6rZP3C8d77wKF7E	13423	18891	18891	1619339580000	orphaned
27152	3NLECqvVXJxkL2SoomgWor9PPxzTXWfiURbJxfZ94Y8GicMpgCqu	27148	3NLxfATXfBoLbiY4Dz9Nhzpy6Kwhy67HTQtT6VefZvK4DRE9pvzz	1425	184	525	12463	18777	jwK6rXwpTeBwSjs26TuR4d2ezheJTMY6Pp6R42C7JeSZ3BGy3yd	13424	18895	18895	1619340300000	orphaned
27157	3NK51nKnW5nczQT87ZbLksxjAkd1XXnff2PtNzHLX5oXu3LvYXyB	27155	3NLBRsGwsysNfwXkZU94Mcr8jafGwgN8t57ghdgcyxvMnNmdopaP	1406	1393	526	12463	18782	jw8Cjt52V36F5RUhdmoqFtqhHT3ETHS8eBfRLK1YsGn9MQ1H1s7	13428	18898	18898	1619340840000	canonical
27159	3NLJMUr6eyQ3eTv3hqzrkVDw4rVqQTZdJZi67KWQb53dofVH71X8	27157	3NK51nKnW5nczQT87ZbLksxjAkd1XXnff2PtNzHLX5oXu3LvYXyB	1483	1276	526	12463	18784	jxLfm1LfDM7tLxbwZ1NiBM41qdhvMge8CfadTgAYDjRurTKBGPn	13429	18899	18899	1619341020000	canonical
27167	3NK33BEZo7cUVDvusGSGiymasuUs25rnXFE3nNiECof4X6PB376B	27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	1577	1327	526	12463	18792	jwanRCuS55BpJUkyFr5chLQNMcczC3fLn3RJSEv3rPELMynRBED	13434	18906	18906	1619342280000	orphaned
27169	3NKPTj3zGcTia3RUZeWuzqg6bbRtLidUVSKM4mYihXRxy6qgGr4n	27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	42	1235	526	12463	18794	jwtbvpn5e9KGPQC3n3XoEJ1U4ghvsB1LN5sj8dZFEg8xAxvwcEp	13435	18908	18908	1619342640000	canonical
27171	3NLumYbgeaZvqVjPhcTEqRMwfvicmFqcXxTqerGq3mdAs5otv5DL	27169	3NKPTj3zGcTia3RUZeWuzqg6bbRtLidUVSKM4mYihXRxy6qgGr4n	448	1059	526	12463	18796	jxfSLYYFyNgHDpBYWRgrrQQsg9MHc4j4FNghr8DCpz5moLiRsfp	13436	18909	18909	1619342820000	canonical
27174	3NL1HyvTqiaA72CBTokX4ejeV21swrEaDdNwHKTrVdhMLV21pyfn	27173	3NKCR3mxmyDULKFTdvxj2DdWTkSoRfvwAQu8C3TrxM6EUrnBZPNH	1406	1393	526	12463	18799	jx6gSeCj6VvV7BFh1utrqrbTFiQyFKXufb7fyYie23ybcbzJMKh	13439	18912	18912	1619343360000	canonical
27177	3NKjcmw2wFWzcviBvsA7JjFMEdxLH2WAn1aXQkiQsTCmYeUY6Att	27176	3NL16dTqRXTHXiMa7TVUC5aKGvRmvdWRdVCyZSPJGpMrZp5UmtkB	1403	786	526	12463	18802	jwxVDZ893UaNY821Phk9XfoEdzyhaMSRDe7JtJuwR367XFBCpEM	13442	18916	18916	1619344080000	canonical
27183	3NKbLtvcCCaVA9jTs7B8MvYVuz3fdhERXGSdDuXt2kF8n4NekcF7	27181	3NLdzwBBkhmWB9jgonS3ghisCUZmDSNnuRmM5NsTaMTvxDjjvQou	1407	1395	526	12463	18808	jwGzHW5qkrXXcGMJjhkkti8pESRgJUKuaZDNYiULBEzNSALyinA	13445	18921	18921	1619344980000	orphaned
27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1646	1228	527	12463	18812	jwiGeKqPcDtAHvK2UEffhoYJgo9FSLPESJiAE4oiPJ1sKir2XAS	13447	18923	18923	1619345340000	canonical
27187	3NLHZQrbbQNNqPdhBm2nV4z3GKCruL1wsU6fUZbd6oZ7Za5tdpun	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1403	824	527	12463	18811	jw9vM6b95T8Sz71Lghqv3p398ESFom9w7K3CVrqt8Vr4EvosmXS	13447	18923	18923	1619345340000	orphaned
27189	3NKY4HpDGZykuY73iRC618pTj7T5wWG7P1TYw859pBtJn8Adxsb1	27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	1643	933	527	12463	18813	jxR8tzsMBCZcfsy7V6C2i6ofnJVoe9LyMcVfyfLFoX4dDvkd1LK	13447	18923	18923	1619345340000	orphaned
27191	3NKttdtDe6PmyD5KogVGj7ZKi2hoY2geoERVWXHpv6F8Jm9s648F	27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	1422	1091	527	12463	18814	jxiP5co5d3FCvp79GAEte8NG7QkdCnN4ZGYgQ9F1e4BkUs36PrR	13448	18924	18924	1619345520000	orphaned
27203	3NK9WyCEG2yzaqVrDA4RHdindgc9TEJzDJLjjsNoB6J3sRZEbafm	27202	3NLmziS2spcyLbQY3vwovYqajcdn99JRbR2LwU5Cw2UDPNSZUjha	1571	1335	527	12463	18826	jwcdoFWW9kyZ7ku67ACL7zUgkDSkPmrao6g4TP7znWAnwFF1iH5	13455	18934	18934	1619347320000	canonical
27206	3NL6FiqASVYj5WfeYdoqSJxQrUNhE9o33iSvxTgbiv9rETzFjaDD	27203	3NK9WyCEG2yzaqVrDA4RHdindgc9TEJzDJLjjsNoB6J3sRZEbafm	58	1035	527	12463	18829	jxBidfSnG8ZB26Y2ciwDrMA5TDz4Ag4XSk2soo4MgSNCHRRjaSJ	13456	18935	18935	1619347500000	orphaned
27211	3NLYBUxgVpyhfqcxmChstwH1Np6Khqn3poPX6L2E7EMVKiDiYsBH	27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	1529	1190	527	12463	18832	jwc5hYtmMotBr6bRUCae9fD8VbKPca8PqNcmEf4t5oaoedD9TC5	13458	18938	18938	1619348040000	canonical
27212	3NKLUAcrbJoHBidPMFvxkUmXH6Ghk9ST75xABh6NixMW2pZYA21e	27211	3NLYBUxgVpyhfqcxmChstwH1Np6Khqn3poPX6L2E7EMVKiDiYsBH	1500	1051	527	12463	18834	jxZcFNCTK4D8h1wXgjeMBsYZWhsrANn2gCGLJy5FybuLdqdPAXx	13459	18939	18939	1619348220000	canonical
27218	3NKzYNmT6PDaG8Qtz41Uy4GN8EtPrpfYBbFDRyqjqi45LsCtD5K3	27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	1407	1395	527	12463	18840	jxP9Gjwz5LKkz4pzaEFCBERMefoKRZoNZmWUkAE6AkvQebqFXDn	13461	18949	18949	1619350020000	orphaned
29589	3NKLJWfmP8wisPhr7SmPkijMwve2zx4igRc2j6Lv9JuGt13wFWPU	29555	3NKwtGS3bGftja9MXaYQBRNq24vJPLe5okVdV9ADkAMvH2Ynj3Ua	1513	1013	573	12463	18974	jxShAtHXRvas5wbTL8HyZ19Y4NP7JTR9GK3vpiNWpP1purXZPVD	14363	20537	20537	1619635860000	orphaned
27213	3NLZqx4NT4Cn8wk8Z4qT1FxwEXo6q23kyAm2oXTWWaunNDJoGuFu	27110	3NKm7aQU3qmr7xxZamft7vFRyhUmwNta2et4c2fZBHVzc9XEPruX	1516	1048	522	12463	18835	jxHG7ECEFSdASXUHi1UHMHq2iZ4aTKSZvWPLUy8TcG1J3MwJXKa	13313	18944	18944	1619349120000	orphaned
27201	3NLtvkoJWXc9egNz36jBLTTTUvHAfTDc5q3JrCAD5Eg5v1EigUwe	27100	3NLd96dCbEPY6rA49hku4Qj8bKciQYkuKoJ8QiZR61NkzgNRw9FS	1633	1024	524	12463	18824	jxaSQXj1iAD6dkT7G5zH3kvqE9fu33ubxQ3QPKLmfGki6P4v5bX	13399	18931	18931	1619346780000	orphaned
27216	3NLgXywWAorSEW8QxfEVdnHwvYhptp878G7drMWUQecWf2Jp8fWw	27195	3NLrHLbrG9a5gu2Fc336CWJ54f3aaxMic2QGWCpoiEwkhSFKBx3B	1457	1145	526	12463	18838	jxuze2n3E4RViTKvRseLHpHftrp9WSGVuFedHos5553rvxGiEa1	13419	18948	18948	1619349840000	orphaned
27160	3NLN5qG2TKu4SFwYpWbgGnbZywDvEt6i6Fc8ppQdrWm9CyqLumAv	27159	3NLJMUr6eyQ3eTv3hqzrkVDw4rVqQTZdJZi67KWQb53dofVH71X8	1407	1395	526	12463	18785	jw92577SDSmi7mx9K5ScfTM9qm8Zq3fb4xoLgKDKYX9xmdoAuPx	13430	18902	18902	1619341560000	canonical
27165	3NLsMZP5WaarfVj7Xj8dFEjU3Ajc8m4kQueEL58ob9yjUJnHaxyr	27163	3NKTLyXGU2cmQ4XmNQMCZTu5WxCW84uBSz32r7GSA9obqZPibALL	576	1229	526	12463	18790	jxwXnZcEqVYtEBjrxuCkia7aQevm2dPdKUBd3F2tZ1wEHR5Pmsc	13433	18905	18905	1619342100000	canonical
27170	3NKc8YfBXzUcLUchxKkJUkyk6T8u6Nr2gvQznAXwerRQ65V9M8G5	27168	3NLrWUmPDbVK6Pc7DCKtpgfBcBVvQSYRzkAGFQ4pxwUQiFdYLwCf	1477	531	526	12463	18795	jwhAUkGsGbhxT2qapCTFQ2TCUNcMhYGeuMrDSmEEe9TCZsr91rc	13435	18908	18908	1619342640000	orphaned
27172	3NLheaVwn5yYGL1tpcpB9ghxP1DqXv1fnZkEG59MSoCE1wJcmySw	27171	3NLumYbgeaZvqVjPhcTEqRMwfvicmFqcXxTqerGq3mdAs5otv5DL	1675	1216	526	12463	18797	jwDZVt33kyW12rLw5JvrxtXt38PufURqvtYynQPHzNm6BeH3Ump	13437	18910	18910	1619343000000	canonical
27175	3NLuMBtpq4MGi1XmGqQKm2Te2rJnZ9JnQedGy1ym38FdESckHefy	27174	3NL1HyvTqiaA72CBTokX4ejeV21swrEaDdNwHKTrVdhMLV21pyfn	1596	1237	526	12463	18800	jwfzaGkbH1S3bXtREkGQj6dZTkmidu2EWPkkNucdM54Ue5gYLWB	13440	18913	18913	1619343540000	canonical
27178	3NKwM3ovJAyLnQ2t5eqPr8k3ZHLLtUF2jHLNExCFxtX54RXfXkm8	27177	3NKjcmw2wFWzcviBvsA7JjFMEdxLH2WAn1aXQkiQsTCmYeUY6Att	1407	1395	526	12463	18803	jxp7sE6o6eFJfX8T5jyZBCfXNz3tttdGot8yEmn4wDD2zsVGfqX	13443	18918	18918	1619344440000	orphaned
27185	3NK4d8Aq3ZwY2ChTLvBL8n8v8xntRvVJgiG79ZJUH73pforCBXNS	27184	3NKjJegcUcRGyXZ5tFERK4BLkAcwQvzZyMfkLsA9vX5gEBDsHUUy	1403	782	527	12463	18809	jwGqcteLTxf3JRg6QkJMcE6yygM2VVWZahzvGkwrqFHcZKPnoya	13446	18922	18922	1619345160000	canonical
27192	3NLx6LMJV54hCxdUEapt4HuK78ik3eeLb1Gv9MTwCbiwPiUxfSaY	27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	43	1310	527	12463	18815	jxxUxKR5NCon3uQnoytCBtgB4ktojuB4VdLU8MbNx8V2m6Ysopf	13448	18924	18924	1619345520000	canonical
27193	3NL92MsPtphU9wLXbQR7ZKi9T4hddjv1XVqkfWapUdBkqKVsWoJJ	27192	3NLx6LMJV54hCxdUEapt4HuK78ik3eeLb1Gv9MTwCbiwPiUxfSaY	1607	1348	527	12463	18816	jxBa8LRnuz9zW1S8dhn4hHibw1hT45EEbtXiXdNmJ26eJUPUPpy	13449	18926	18926	1619345880000	canonical
27196	3NLbQscxNz4fGBKtqoTcbpDQSy62rpXCZsFoGdKVzW3KXEZJzSR3	27194	3NKgDVTyCQsq87C25Xg7HccrbXvDnKTH2V8KBQym5TPoQBS42isS	1581	778	527	12463	18819	jwYXh9yy4cFjD7kkQWsgKTTt3LEUz1uiz44m9Jx2Ps9Z176j8pp	13451	18929	18929	1619346420000	canonical
27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	27196	3NLbQscxNz4fGBKtqoTcbpDQSy62rpXCZsFoGdKVzW3KXEZJzSR3	1406	1393	527	12463	18820	jx4BWxifuvEcvJeFVKQxEm1X2Gp6dU5qmsqRaJzAJ4vTqpCc6hN	13452	18930	18930	1619346600000	canonical
27199	3NLhLBZwjiRd9Q4Q85Gz3NDzPtv1Tajb1WF3JUVv7d2EL6D1f81k	27197	3NKLphJbHoksy22NBegLQ4qGp6vEVM7UdCF5rgHgnzyB9TyXEAXD	1633	1024	527	12463	18822	jwNPvhbV23eEAHaNvx5UrQjv982dS5SViBzCQV6xEvQV2TGRFBz	13453	18931	18931	1619346780000	orphaned
27204	3NKuwLtkkDKYafnsUN7u87tixJ72gcSptB2kbDH2Ha46JaL9odmK	27202	3NLmziS2spcyLbQY3vwovYqajcdn99JRbR2LwU5Cw2UDPNSZUjha	1534	574	527	12463	18827	jxzSdRtrhUW5i8tQMTB7eQv4fUQ1Up3FYrbKsiPBcY9NyBMkEYb	13455	18934	18934	1619347320000	orphaned
27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	27205	3NLwuwkeqXHHugR6nCQTC8m2j2swVcubLDQPBRS47rr7w6GUhjvH	1403	824	527	12463	18830	jwEEydHVSnthrdABPmM77t2YK3vE5oeUkvY9Li557KtwEpPJoza	13457	18937	18937	1619347860000	canonical
27210	3NLAs6uP1K3Yi9YdN2fmeRDdx1g7cSB1Vfkcb4cGfEjyJziuTHQn	27207	3NLEYDtmUDoPZovaxPDWBhpySdGQBz6ffSLVXKCSRq2yMLabj13i	80	1273	527	12463	18833	jwUpnvU4yFyxrN5FqGngBWawziDYyCv5tYCHppQkANWKVtYHppW	13458	18938	18938	1619348040000	orphaned
27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	27212	3NKLUAcrbJoHBidPMFvxkUmXH6Ghk9ST75xABh6NixMW2pZYA21e	1407	1395	527	12463	18837	jwnYYYH9Hz3RVRAJ39T2jmnYgGRNGnGbTEFhby4n9Lsb7SHRSPi	13460	18946	18946	1619349480000	canonical
27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	27215	3NLaV8cUXpkMAqSwsuJUBVeaDWxH3KfJxzweujQnKHrXuJnQGKtb	1406	1393	527	12463	18839	jwsfQLe4fK5PBBmiPW8C14sYZrhmZ5wgVjohxAhfGQsgZiDWi7n	13461	18949	18949	1619350020000	canonical
27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	1671	1239	527	12463	18842	jwWGYebNZFYgDfdCkGaT4inToSomuQvHXmXN91Q6e4zNj6qpS2y	13462	18950	18950	1619350200000	canonical
27221	3NKuYNaujeosiCjLN2NRh1RWU13NwN1fcvSsAyr4be8rfhLG1nUV	27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	1596	1363	527	12463	18843	jwtzDFCG6j5occMSHXahXworiMNiVBsquo6ZVzQ8F1C7hSciCKY	13462	18950	18950	1619350200000	orphaned
27227	3NLqoQY3UngGmgRDc77AtWxQSWc2C4SnjoeGtLwygjuB7o82aKdm	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1546	973	528	12463	18846	jw8z31vJmWzQ2hKS1kMLW7pS5rkipfRzuPrZwdHGYRMirk3eJ32	13463	18951	18951	1619350380000	canonical
27224	3NK3wkx9v9tKwt9Cb6zyJqcw9Bv9vKN8PukiW5UCPg6WTsB7wijE	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1670	1282	528	12463	18845	jwadc1wqE1Pe3Y9wF5ZU6rougEc77i2kqdY8rVqTAKU1WqFYx8u	13463	18951	18951	1619350380000	orphaned
27232	3NL7AEYWAx1HuYTyKk9xcLV4EgiErtCQtEmYB4gvDPi4tAPwQ89i	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1610	948	528	12463	18851	jwwFyGka7Zdwt3wqdzA7rPogyg2aFFe4sWzWEaDRxTbHUfu9tD5	13466	18955	18955	1619351100000	orphaned
27236	3NLqmPgBPgNVKystgb54N5BQ4cy21nJGpsXHfuWY4qtGT3v5nRKX	27231	3NK8WSB85tNvqbFnkwNG5AdoEdcg3WyQyZfAo2Man3oe8hjmiKqn	1402	852	528	12463	18854	jxZZTQfU8TPfSEgD2MEMBohkuCTT47umpUsr3ry5B6KADJJWAb2	13467	18956	18956	1619351280000	canonical
27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	27240	3NKXLf27fhPCterZxFcWXKP33HCFLzjG4HySbkMCiRZxXtLketUv	42	1361	528	12463	18859	jxVpdgWJ3cpvgcQz1Fy1NUw1mZLN3zxgCXGdaYS3hNiXHfENrcJ	13470	18961	18961	1619352180000	canonical
27244	3NL9cfBrh4T5WCjppf6DLUswiCc2tjYJwkeU7G5VGWxJXPjByQFT	27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	1407	1395	528	12463	18862	jwfar2QpEtnwWhiKVoDsdSjS25vJfHbdHkQVVqChjNnQmBfuR4t	13471	18962	18962	1619352360000	canonical
27248	3NKwxtRTkUcc1CfoZoH9YPwBRb8phhCehPimp4Vy5c9p6E57oiR1	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	311	1307	528	12463	18866	jxHCkqGKkK3RehHg63srXPuHJ23VhW3t2NY8i4yrk929RG7CRdv	13473	18964	18964	1619352720000	canonical
29631	3NKvgVQ98gTALMnRgPx47yvQNXsV4p4sWgaWyKn9FK3kt455Psid	29589	3NKLJWfmP8wisPhr7SmPkijMwve2zx4igRc2j6Lv9JuGt13wFWPU	1513	1379	573	12463	18974	jxShAtHXRvas5wbTL8HyZ19Y4NP7JTR9GK3vpiNWpP1purXZPVD	14364	20577	20577	1619643060000	orphaned
27238	3NLuD3dNN4GedmALRECb85hEvir5VqErxHq7aG9JMyi9o9kdNAND	27080	3NLC5meqe5PdZZ8X2bcAt2NycriLu4PwkCUdMj3zuQHQitCuNa4k	1623	830	521	12463	18856	jy3Di9Ve8RxH24FFEfqRLVJ5XuL8iM8fLLcHHH6xWDZTuTpTbrD	13340	18957	18957	1619351460000	orphaned
27284	3NLVAniznUe7XtkT8exCMbM5rwyiN2pKLxJfL6H9UaqZtfHDKHXz	27117	3NKX12qyX9caUmZ4KyNYuEFzB7dh9apM74staY1ihUYAx3pXFCWa	1461	1271	525	12463	18901	jxNFJQJEqjn96pwbrRuCkU7Z53kn9cPqvGWMzbuC3UkeKBg7keb	13408	18980	18980	1619355600000	orphaned
27313	3NKGBxRuFy3Jh6BqrBKsCz4Jv4AmGgBh6Ase1LT67WmJmsiLB5t5	27272	3NLsLMhrHPEmgNpAVGs1nHty2P1kv1nqh4i1tG1o66eisWLjDFqZ	1553	776	519	12463	18930	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13254	18999	18999	1619359020000	orphaned
27269	3NKqEePjLe4cCGezp8LBSjt7CsSXpJT1pBtnW4wnXMc4xVYUTya5	27267	3NLpJbDpsdS7k3pip9pnXkJaxhBxuNkYVjMg4Ch2yTgw1gdLgbLp	1631	794	526	12463	18886	jwdyxGizeS8pyAyNRHqNZZ9u3ewTvCHeq7kHHHdpDeDgLVbRDou	13431	18930	18930	1619346600000	orphaned
27220	3NK35ZK4FKAFQarjEsbHpdfffghkRmvwhwkkap7wR7h5WuvRgt1F	27217	3NKeTSdYa6NtyyBw8TLYKAcsuvD4Qv9kmEDmdeJhoU2tatoxzYFr	1671	1239	527	12463	18842	jwWGYebNZFYgDfdCkGaT4inToSomuQvHXmXN91Q6e4zNj6qpS2y	13462	18950	18950	1619350200000	orphaned
27225	3NKpVFc82o5cv1Wit1WEzNsimLXTSESkqj8E8m7UTwfzd6iL3N6G	27222	3NKoqFsJo3XFNFVMoNqVuMSGC5etVn8Ng4c5DyghRdg4Bt4iZP4u	1546	973	528	12463	18846	jxjDbufEyUQQD8o7r1V21bPnq6e7SVzrfRWp1vr8KnKjdFFzRH2	13463	18951	18951	1619350380000	orphaned
27229	3NLNXRrcy89fAVawh4vziRLPLDmRSyQ859JnhC9VdprywsiZ5Hnj	27227	3NLqoQY3UngGmgRDc77AtWxQSWc2C4SnjoeGtLwygjuB7o82aKdm	532	1303	528	12463	18848	jwqiNwPyQRGKvypMBVHGMq5hEu8zuACpUWCZpb6FJk78o2d587M	13464	18953	18953	1619350740000	canonical
27228	3NLRG7b6Csw3wQD84wR2DoBKKY7gYWcYcXM8FCD8b3SP1t3xdLFv	27227	3NLqoQY3UngGmgRDc77AtWxQSWc2C4SnjoeGtLwygjuB7o82aKdm	1403	824	528	12463	18847	jwAQhNEGDeyaNE2TPJbgnZS3i88bbohW4znZH4R91iS4xDHRhfj	13464	18953	18953	1619350740000	orphaned
27231	3NK8WSB85tNvqbFnkwNG5AdoEdcg3WyQyZfAo2Man3oe8hjmiKqn	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	633	1384	528	12463	18850	jwWMpgnnnama8GHd1YPHFddaU8rbCNVzFUF2eoUvqQhW3d4zfGd	13466	18955	18955	1619351100000	canonical
27233	3NLdhkzd3bX7bL7TQEwLChRpLfwZA92QsnVYgY6h33ZPWwbu8UvV	27230	3NLvvtnwmYq6vJTozWNj4snTZnX3KHooMJcdKVA7XioPJz6aiNZw	1419	814	528	12463	18852	jxgofSQdeiq4vTy2mQxBHCGruFFizHbtdu6LWaBWPZD9Qkmi12P	13466	18955	18955	1619351100000	orphaned
27239	3NLh4YmMeYkWTDp2Hx7y5YpkdMoAa2N71gU4ZrrYNhwG77jxihh6	27236	3NLqmPgBPgNVKystgb54N5BQ4cy21nJGpsXHfuWY4qtGT3v5nRKX	1406	1393	528	12463	18857	jxoH3S8PgiKUzjXATCvTBM6vC652rzmdZbZENxw2P8A7aq9cCSJ	13468	18959	18959	1619351820000	canonical
27240	3NKXLf27fhPCterZxFcWXKP33HCFLzjG4HySbkMCiRZxXtLketUv	27239	3NLh4YmMeYkWTDp2Hx7y5YpkdMoAa2N71gU4ZrrYNhwG77jxihh6	1646	988	528	12463	18858	jwHsh9xp3AjTnXWF7UpGXGj8eeGxEWpoLbr4XvxS47HB4w6o7mY	13469	18960	18960	1619352000000	canonical
27242	3NLCJQypm3MVkX35AVrKhiG2bJqS133n9cw6spMGrTHvFP3oFSaV	27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	1406	1393	528	12463	18860	jxDP7fmKWrSmUNANNb2GYvr6kf46H5tGcLNd5hwa4JeW53MMWLc	13471	18962	18962	1619352360000	orphaned
27243	3NKfbdbg6NKTX4mfr24t5fFnYS94NxNfemkDXMVpntpDh7xechRG	27241	3NLQ9FGB2Enp93VrMvtJqwVVY5SnTsbu7zbyVS8HE9MtBYgDfTff	1402	868	528	12463	18861	jwPnRmfKvnaWGHrxoM2bCPL1zAgrPWjM95q6KVJhZt85ZvvDeDW	13471	18962	18962	1619352360000	orphaned
27256	3NLuQHqCCJxHH4hiHUSRsnEwRZvBHk7L82QnUZ7V2WdBcjHoPoFj	27254	3NKwKJDWqbvEEfnuQsddnKa6oEh3H1UrRpd7wDfWtRWCxV1xiD4h	1483	261	528	12463	18874	jxkE3fEdeEdzkeYMpHh2cRW22h9yvLXUYDmSAdKNj4G3KhM3NJz	13476	18967	18967	1619353260000	canonical
27264	3NLhP8k9ybrUMt3nrwyVNLGuW5ptFbRbfVMHH2r7JBbZFSkyLBGE	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1529	950	528	12463	18882	jwDSYHCNZag76g2tR3Fg2gMbRQF133H48U6UYGhZqx7Dcg94YW9	13478	18969	18969	1619353620000	orphaned
27281	3NKdrm4wCtSJMzzb24coKaRaFcWZYF3M2SGnLHf1hnCZHi58BtLa	27279	3NLk5FDzFapLo3FRUWnXoKKxU4EXJVE5tgQkaX8Y7rXmTi15yykH	1571	1335	528	12463	18898	jwnSz3BGnjas4KvHmnkwhsbofCJWyLqaGQkz2EskSBm52Fzivaw	13484	18978	18978	1619355240000	canonical
27287	3NLPBdrCNAFia5kVumgqVHHQuszi64ecJv31d78DWUqS4rr9afDC	27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	1587	319	529	12463	18904	jwNFeQBEEXQ6FHFZtgEpUyeF5MSZCLC3afQNL4B4bPdp99y9xWn	13487	18982	18982	1619355960000	canonical
27296	3NLn8375HrHvcQW2zXsYtw58iwqfoZwvcEumB1d4vn1jLbiPGM19	27294	3NKoCRKRnBYE3AMNZNMJ3KTqTBn6N7cPEUPxwuiRE5vViM9s7NLB	563	1359	529	12463	18913	jwigzcpwV1SZ75Tu1dkErLJDL1o4uKMRYUnWDjpwFsvUyVvG4Uu	13491	18987	18987	1619356860000	canonical
27306	3NK8hjzVTwz6KJxra9zZZAxB7jR2UvJFXeiwMr3JFe3u4CRqbSpo	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	633	633	529	12463	18923	jwCUTFrp8aJSWLTuaxV8pRuuzqkENuPL6AL7zuSAsGWf2J2PSBX	13498	18996	18996	1619358480000	orphaned
27318	3NLmiLv63jsytDCwCmDtE4uvza9Sf1vJFwbTFMFRn2XC8mYC4Acs	27316	3NKoAuQUtL1YWV8x9qrMVfvWZUUsZ3NmFRM9veLbNiuSj3c8JvaM	1406	1393	529	12463	18935	jwv4g4vbZCfL4RGMR7GYQY9Ekj6mrVUEDefw2WfiAaRBQks4dQ9	13505	19005	19005	1619360100000	orphaned
27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	27320	3NKbdpnWtQFnVDe3XnJo8yz5wE9F1HVEWh8fLLbCQ1bMVKseVM8a	1555	1221	529	12463	18938	jwrHRQY8du57knfvBGJv83wLRCmwkbMJnnRFsFCuME61i8boYkX	13507	19008	19008	1619360640000	canonical
27323	3NKTv7DpkeDjAfUyQGbeDh1sigFJrDvjCJ8cHbsiSyxGZQAtrkw3	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	298	942	530	12463	18940	jwoyr36ZKGhokNvcNjgatPXDHVco9V7h32XUhP7MrvBzZi4jSr9	13508	19009	19009	1619360820000	canonical
27324	3NLWg96oDdJzhr2AqD1kZ8acw2jzQeXjQJxsuE8xX5C2BUiuqfXv	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1589	920	530	12463	18941	jwgvVWfssjyhxpGac8Ady2gMJbF1zQxJGXkicithWq4f2wbcys7	13508	19009	19009	1619360820000	orphaned
27327	3NKmGcPSetX4fsF7x9hPm6CgjEnmHFAsLK9TQMJAUkm5TtoyLXDd	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1652	1069	529	12463	18944	jx1a7BKNBQVErSABgLqe4UFL4LSp7Xj3WLQWXWQ7tShqD8ntdbU	13508	19009	19009	1619360820000	orphaned
27332	3NLRzueXZsRGANhZjzhnnGr4jq9QMR3rtUJYdGgmTroUkbNsNiN7	27330	3NKtUsgiujMwE2cSQ3v3grW3eXuZ4QQ3bJY7hQYhhtEc6RfkUtao	1571	1089	530	12463	18947	jwtre7iQbSA3xannAbn1cN9Cyg5TXc12DeXNjMk1V6Pd2nTL956	13510	19011	19011	1619361180000	canonical
27337	3NKWxch3fDP4vaJZCEb4B77KbJgSnkMgSPXcYTdi9GwgYpkwPf1H	27336	3NKGQNJLeic7ZZfL7198kWHjh8EM5Cm5qsvqnXpbba8KWLdC6XG6	684	1226	530	12463	18952	jxTzfXFiyv4bdBYrYMZsuxhYJVEEhemxM1wyX99DqCgyCghShDE	13514	19017	19017	1619362260000	canonical
27341	3NLH2fJo6HLmkhEAy7G72z9Bahw6FJ7WfDujsPXkSCyygY2BrgQU	27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	1673	1242	530	12463	18956	jxfrpeeFjJwgket5kbsJcZ66xncDZYAzVaBCKLx3eMqDzt34y4h	13516	19019	19019	1619362620000	orphaned
27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	27344	3NLd5PCsm6g3WTE7RuK5eov3GaTLogbqtHUEKBBfrzr5ULTcw4We	1406	1393	530	12463	18960	jwXEs3NWmpCFtpajzeGHugbXU8L5sX5yv39kRceizEghiwjqk35	13520	19024	19024	1619363520000	canonical
29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	29136	3NKr4K32nviZfnfp5rwkRSbo2MFPXtDB9UvdCbzwD6E4mdvXQgue	369	1312	571	12463	18974	jwGT3h1EBDT1GtSr5fGPKh7yK78JWkzMQ3m6raNSUjNs977TaX3	14367	20233	20233	1619581140000	canonical
27257	3NKhDj2UKMkkN2Fm3Vo6Wfe2ftpLku7AEfJm8bF5qw8zFW64fQ5J	27094	3NL4axEgCvuKYs44b73jrn9MABfML6aPntEbLgxaLmgTKhqfLSBi	1656	1097	524	12463	18875	jxWBQawXGHxnfU7iAGnSHtEkiCXcwnz55ZkR5W4ybM6KUBFCbRo	13398	18968	18968	1619353440000	orphaned
27251	3NLqFYo3sVrzZV2WteczFYBV2fAsJRbLeXf57G1V5SyWx2Kb3Xbo	27121	3NKPJdQhL5sUpptyrQsiMtetnDvct2476akuzRM8MkfLKRySeuP4	1647	1302	525	12463	18869	jwU1WEvECouj9gnpdcKHJzGhksqBRemH8cUEoBxaMCP1kCjp4G8	13411	18964	18964	1619352720000	orphaned
27260	3NKAcwnJyKbxZtEfhqmuKEeVgQFxmXrtXYwk72adgdFsKxuZM59Q	27124	3NK6jATUQAkf1WH8j2WZ2vQxBuXmwAwPt1jyCd3UuoVfcJUUvgNW	1656	1097	525	12463	18878	jx4U7UgSGxa2cC6awKazHknFqmswSdHcdmYZqDGuNK7pt6fCxCu	13413	18968	18968	1619353480001	orphaned
27261	3NKTq2Ro5TPJkPHwkgbvo32kbAptpyCfAxAQWEhKsxTb7nnvpNjA	27151	3NKu3U9ookYhSyUQwUbJ45DymuMNsFNw2N6X5btGntYkWxwUkFhM	1656	1097	526	12463	18879	jxe9hzSWK1wKtuwsNmAqyCQwxLaQYHstXG6srwDuvqbBGAseBuz	13426	18968	18968	1619353514115	orphaned
27267	3NLpJbDpsdS7k3pip9pnXkJaxhBxuNkYVjMg4Ch2yTgw1gdLgbLp	27159	3NLJMUr6eyQ3eTv3hqzrkVDw4rVqQTZdJZi67KWQb53dofVH71X8	1631	794	526	12463	18884	jwpJyextC2V4Gock8JmK7gDo6xFk1AjpSvCMGpauWHD2BMABgyZ	13430	18902	18902	1619341560000	orphaned
27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	27244	3NL9cfBrh4T5WCjppf6DLUswiCc2tjYJwkeU7G5VGWxJXPjByQFT	1407	1395	528	12463	18863	jxjL5fUqhD5hAWQCh5pr9KTPsH4krHA2RyxYDuiyNMKfCkCDrJY	13472	18963	18963	1619352540000	canonical
27247	3NLUGFCHZDJRy53xY5MEP7FouWJSYzFrKr9eJTFEjexcopgt6YZT	27245	3NK8sxYYDMeWZqCjPW8yqiP2yVcM9KsVpKPjGmGAHHCeCcGFmkv7	1490	908	528	12463	18865	jxhe95w3zPnNybpre6ijKeiDaQsCybSjPeKnQ8Y1aeDFCxYpa72	13473	18964	18964	1619352720000	orphaned
27253	3NKjhdrn1iTCqBrBAY4UpGsxnovToR4q41rtEpJ8xQGQ4E7i85tQ	27248	3NKwxtRTkUcc1CfoZoH9YPwBRb8phhCehPimp4Vy5c9p6E57oiR1	1403	824	528	12463	18871	jwpicN6mEMZcakWA16zUhFUupHzA1aouMrqdEoyMipAFUH8peRq	13474	18965	18965	1619352900000	orphaned
27255	3NKX6mW5KqVCWLeaJk4eVfm6FX87sGEe1ZCr3kEbkFx2vsF5KfEL	27254	3NKwKJDWqbvEEfnuQsddnKa6oEh3H1UrRpd7wDfWtRWCxV1xiD4h	1403	782	528	12463	18873	jwQmafzfmK4bWsX5MNadrmkeftG5AxaGUZcsHd4Te9qYv7gZCYc	13476	18967	18967	1619353260000	orphaned
27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	27256	3NLuQHqCCJxHH4hiHUSRsnEwRZvBHk7L82QnUZ7V2WdBcjHoPoFj	1407	1395	528	12463	18877	jxyXBhL78oxbWoVtNprYzjiRroTdgkzGnaeHF7htzVGrfzZNP8G	13477	18968	18968	1619353440000	canonical
27263	3NK3Kk1cTG6zvsLsoWq1aMEVkYhvGV929TPqX3wDxaNHjxLz1DLr	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1405	857	528	12463	18881	jxr5HxpihxBQq4sWfT4cY7b71Y3Fa2MGtqSNBxrg68Cr1Tw7yC9	13478	18969	18969	1619353620000	orphaned
27271	3NKgJQpZk9gNMTCJm23Y3xSUEvx9hGbgbt8smNeXwxt9Hz55JZF9	27266	3NKm9UQ84sKVWJVvNGYdRQCuQqBGSXWeDyrmcT1M1E9oGpVDCCqo	1500	1051	528	12463	18888	jwj3jnrJ55bUy5PsCxtvhuXqQwKfBnEB9zeaXL3DnrMMJTAU7ar	13479	18970	18970	1619353800000	orphaned
27275	3NKAafxnyC7YM3MmYXov2p3KZX34LyBXC5zv9Ba8JmDqBvuVhPzM	27273	3NKQvHhZ7NemS66TiVBTPeQ1QhYJEUTWMNRmPnbfQ7YCksUBh6LH	1507	1034	528	12463	18892	jxh6U7kWgnX2PsVRY3opFDRQtjeEyFpUxi5bSo3wEv6HACmW5D7	13481	18973	18973	1619354340000	canonical
27277	3NLeMWnahZF6B7YEr1g8baSST35ZozmUYCrjFpUiivXT3Z4FYDK2	27275	3NKAafxnyC7YM3MmYXov2p3KZX34LyBXC5zv9Ba8JmDqBvuVhPzM	1476	1245	528	12463	18894	jwrGGhHdxKynrCSooMnaTE9GJ75mbdejftkTPQrbanrf5XSfGqV	13482	18974	18974	1619354520000	canonical
27295	3NLhrSArqHwk2FUMeVDWQnG2oyDEALr6iSPG2AExbpVKFqfMVi6y	27286	3NLmv1sGnoGU78AXbjoxXgvL9VVgKZY2HyHt9czTvkcTT8gss18S	563	1359	529	12463	18912	jxDNpjpkNxRBbv8pCYbH7TVmuG5FtzrMafDz4kaUWpvyZRkZecZ	13488	18987	18987	1619356860000	orphaned
27292	3NKz6XfMmtpcTjC7FucnfuuhZ1VSaMLjzd1kFxsvgBXr4SL2ei9b	27290	3NKexEdVrUZeW2qjWMvxKTSsPxRdhYp4axdZ7ra8EEub1waKRRrf	149	917	529	12463	18909	jx4zjwMR8MkiztrE3GqcdMZWMjSS49PbFrRtoAnp2goDDoz41wK	13489	18984	18984	1619356320000	canonical
27298	3NKJdMFyaBUUEEJK4qDrGCKcLBqwJNzTGqyp1hn2aeEw15GjEjvv	27296	3NLn8375HrHvcQW2zXsYtw58iwqfoZwvcEumB1d4vn1jLbiPGM19	1555	1101	529	12463	18915	jwR9uSowGxwMRKerHwgEZyAN66SWov2AkRT15JjSF16nG8sFn58	13492	18989	18989	1619357220000	canonical
27297	3NK6hR8Ccf5MeB2xiJc5FZ68kYsgMJbc1sXkmv3y897yYZU3PnEK	27296	3NLn8375HrHvcQW2zXsYtw58iwqfoZwvcEumB1d4vn1jLbiPGM19	1627	1019	529	12463	18914	jwKFckg8xvW4NrvvBKZjicFDY714f7yqCJyvZVWJb8fQP4CEMJb	13492	18989	18989	1619357220000	orphaned
27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	27303	3NKNVz2cb1TC36hzaapyrsxnvgd8QmyVAzRE1wPS1UFo6NSpViHg	1559	1107	529	12463	18922	jx93p3E8aksWPfq6ioD4EaJk1UfCueEC4SSES2YW2VgUAhM6kw7	13497	18995	18995	1619358300000	canonical
27309	3NLEYutwb8b2TNZ392boZyRphTh4Fm6KY4Z7NdyD9Mw7DdV6xHS2	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	1579	1023	529	12463	18926	jxkpire9cn4ChXy8hqZVAqDEXKwNko4jhch9dUfnRm3FeKgnekg	13498	18996	18996	1619358480000	canonical
27308	3NLcTTb8NkjWDk1NkrWBNiptHga8SraLKUYW9a4qSy4FWx9zTJ1F	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	1589	920	529	12463	18925	jxYgXdAgU6fyjHChMfwHNFTttE5JrpRGKJs1X6XXfPhac2V8EDH	13498	18996	18996	1619358480000	orphaned
27314	3NLMXrwz2G8QSQ8XYJsrhfvc6TueDEHRoEK5Ey8oT24zK7T49GDy	27312	3NKaHduu9G7dvmfnaT7mW9noRy9JdvfUcBqDBq1tboUnM5Qdxudn	1668	1124	529	12463	18931	jxaVbvGqPeNrbrgqAyUZybxv47pyMfBPATvoh5HGuL8b4K3poeH	13502	19001	19001	1619359380000	canonical
27317	3NLaLzSpkzxeuqKeDmUQ9p3bWE5vrakf6R6s9DeidpAU4oTK47Js	27315	3NKK3QM8sqU1FgpyZ6UQZft6Er7si5B6cet9cYRj95wf7fV9NVHr	1406	1393	529	12463	18934	jx2pEZ5nmtgq8226zUE8cecp2zqYAwfPpCEjAxLghmwrJ1t3S3d	13504	19003	19003	1619359740000	orphaned
27325	3NLUu8UqMZUGg1raLwCUFX22rLg7jtPhgwcvudQmEXbzQRsXZMgY	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1513	1379	530	12463	18942	jw7bbhVPV5h2dW7Fzww6ysDU9xSQRohCA8R7AgP4C93Ve1Qsq5M	13508	19009	19009	1619360820000	orphaned
27329	3NL3LhBaKDnZC9VmpD43EmZqFvBeNNhkGFJaoesPcdjLRqmgkiU3	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1508	1387	530	12463	18943	jxd7xJMadBZYYR6GG1gg3ZxxeSWb5zAMs6U9E2WqCKjytCj3Y6Y	13508	19009	19009	1619360820000	orphaned
27333	3NKvmKAdL8CfXE1DG6JbfkSTdpJg9N7XYH9acqZwB25594nswEVA	27332	3NLRzueXZsRGANhZjzhnnGr4jq9QMR3rtUJYdGgmTroUkbNsNiN7	1403	824	530	12463	18948	jxYhsX16phgpmUgotZSifMXb5Fz8bQSgwVw531L6FXAPmNWNXDm	13511	19012	19012	1619361360000	canonical
27336	3NKGQNJLeic7ZZfL7198kWHjh8EM5Cm5qsvqnXpbba8KWLdC6XG6	27335	3NKC6xkLNDNp3NhP4RwVcFiupt9pJwqP5nyVthsNyW8vntGB3aSL	1483	308	530	12463	18951	jwSJpYkhuNBGptYeHaAupTLGMhMevpkQ2AZHG6YvWg73NrwGNX9	13513	19016	19016	1619362080000	canonical
27346	3NLHv5q3QYAe8qpafr1CKBs9hZKSFYkFHHGVkG2tTRYJVc19iDCv	27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	1405	867	530	12463	18961	jxi4YaHnr75QskyQtmcivxDk6tcKy9kvNUQjF74SZeKxjpoS164	13521	19025	19025	1619363700000	orphaned
27347	3NKYfdZG1sWW4ypQqTKn7w4i5dsGpxobH1irNQ7Qt3ifYT2C9qwB	27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	1402	852	530	12463	18962	jxg7NGv4iTumkBbKLuMv5rzpoFuJGMUgvHEXeufy1o8nSFXD2K3	13521	19025	19025	1619363700000	orphaned
27270	3NLeCABMvFEnsXGBp5vZk92ZaZQUexXhiQQp9mURtjWMKuQpwAQF	27269	3NKqEePjLe4cCGezp8LBSjt7CsSXpJT1pBtnW4wnXMc4xVYUTya5	1631	794	526	12463	18887	jxFsTBskskrr8KC3rNFTZVAjW3dAfVqDGg39XunD3c9qnTPS3Ui	13432	18969	18969	1619353620000	orphaned
27283	3NK9WigKTFYajPRiduFjkth8JQABsMbWVJ4isi4P7vLQ7Xk5enPC	27270	3NLeCABMvFEnsXGBp5vZk92ZaZQUexXhiQQp9mURtjWMKuQpwAQF	1631	794	527	12463	18900	jwjo9aMuybVwnd8yMFpTT1fPkdBARapMdHqqPFpvdEg5UwedMER	13433	18979	18979	1619355420000	orphaned
27262	3NKhcaXCaps8WMSvkK8zVJ8y542QQDLVn87t6y1rfPf6r5nUdA7m	27173	3NKCR3mxmyDULKFTdvxj2DdWTkSoRfvwAQu8C3TrxM6EUrnBZPNH	1656	1097	526	12463	18880	jwJLLoZUfNZiAEbqNCsUAoyN9unVYjUJXUjB8a1jUpL64MBKmeP	13439	18968	18968	1619353547055	orphaned
27252	3NKiAeoWKHRdoebXdfo3xjHG88zbtnhA81zHVdf8Hsis6MsAk26f	27248	3NKwxtRTkUcc1CfoZoH9YPwBRb8phhCehPimp4Vy5c9p6E57oiR1	684	1226	528	12463	18870	jxmp2iVsYv32Kjx7gr5vmhVT2sJy5Vpzb17eXLp8oqxaEHMpogV	13474	18965	18965	1619352900000	canonical
27254	3NKwKJDWqbvEEfnuQsddnKa6oEh3H1UrRpd7wDfWtRWCxV1xiD4h	27252	3NKiAeoWKHRdoebXdfo3xjHG88zbtnhA81zHVdf8Hsis6MsAk26f	43	1310	528	12463	18872	jwx5WSsWij3wPzLaPZMDYtqTUzFRUv7X74zAooB1qJnPoZMdgjK	13475	18966	18966	1619353080000	canonical
27258	3NKX366nCRBKKQpiBHJF6qVFG7hU7QinJVfoo1usaauQduZUjMWn	27256	3NLuQHqCCJxHH4hiHUSRsnEwRZvBHk7L82QnUZ7V2WdBcjHoPoFj	1656	1097	528	12463	18876	jx82m6Y3QN325Uw5LotDKLinMjygSohENjuARzNUftpk2KYCrmj	13477	18968	18968	1619353440000	orphaned
27266	3NKm9UQ84sKVWJVvNGYdRQCuQqBGSXWeDyrmcT1M1E9oGpVDCCqo	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1407	1395	528	12463	18883	jxYLqWsrSdkjXDhEoBPEde2fXXc1SVqr1kkLyMMtVaUrumr5tGx	13478	18969	18969	1619353620000	canonical
27265	3NL8b5b6wUrRrpWBjCain661Rp4ESZBkTnTrZzjjhMeqUUBW4pSL	27259	3NK3UXyB2Pq6er6LUNW9AL7JnpwQwQwfo4mmiM56wHtrKhUbLr1m	1529	950	528	12463	18882	jxARaWG6gV3CoRvnzEMQXePiJ95qKxmk38BXxKmLpxkWE6pZvcg	13478	18969	18969	1619353620000	orphaned
27273	3NKQvHhZ7NemS66TiVBTPeQ1QhYJEUTWMNRmPnbfQ7YCksUBh6LH	27268	3NKXQfHxxa1bCCYXSmaDcWDWWRW17dfe1ZT5HHPTq5geNio5u42z	44	959	528	12463	18890	jwpyESdWvtGA9Pb7vAd7LoVW76y8iMQGiaXK3UG77QLuBJbAnyw	13480	18972	18972	1619354160000	canonical
27276	3NLcWc5JV9bngaRrvo8xtmNNDJC4fFTcvpN6SLw48kubGHFca851	27273	3NKQvHhZ7NemS66TiVBTPeQ1QhYJEUTWMNRmPnbfQ7YCksUBh6LH	1407	1395	528	12463	18893	jxDLGtXk6ynXkjJKh3ak6TLHkK1vLRAh14fGZH5agYuPYdprRK4	13481	18973	18973	1619354340000	orphaned
27278	3NLetHgpnqLHbS6DEFdkcGgZUwZrMy92GGGboxBp5H7tBsxQnweJ	27275	3NKAafxnyC7YM3MmYXov2p3KZX34LyBXC5zv9Ba8JmDqBvuVhPzM	1489	1380	528	12463	18895	jxJw7pLEwEYedLY3moZzbokRYXLCYjzWi94JTSECoztdKgzSGCW	13482	18974	18974	1619354520000	orphaned
27286	3NLmv1sGnoGU78AXbjoxXgvL9VVgKZY2HyHt9czTvkcTT8gss18S	27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	1406	1393	529	12463	18903	jx1MtUuvS5iw6X1diVPjahS2ua7nKDEtPodTaKjPDBEc69MQ5mP	13487	18982	18982	1619355960000	orphaned
27290	3NKexEdVrUZeW2qjWMvxKTSsPxRdhYp4axdZ7ra8EEub1waKRRrf	27287	3NLPBdrCNAFia5kVumgqVHHQuszi64ecJv31d78DWUqS4rr9afDC	684	1352	529	12463	18907	jxoF8YC8jGXVo5LZVv8muksibmgB5fGK6wZMQ7b98tKWUqZvcSG	13488	18983	18983	1619356140000	canonical
27291	3NKYjXkLHZWLrb6LujMY8vpqToQaSviASSC8g4D3W87nNm7GfjTY	27287	3NLPBdrCNAFia5kVumgqVHHQuszi64ecJv31d78DWUqS4rr9afDC	1445	1290	529	12463	18908	jx91ZRjBypYd5FbTvMHMz6T1abfDBM9yvHDRSZLvaj2ZgqptibT	13488	18983	18983	1619356140000	orphaned
27293	3NLo61N2DyPU4ubNqUA8ftzQrta5YkwpvKxy9RTgox1gAekNyGFj	27290	3NKexEdVrUZeW2qjWMvxKTSsPxRdhYp4axdZ7ra8EEub1waKRRrf	1403	786	529	12463	18910	jxb6CjG4MGPQWgKizTjGSSKAwpWxs326YRFhC6NCfVco4pCt1mm	13489	18984	18984	1619356320000	orphaned
27301	3NKJSxC4LuKfAps2gKhesf3BUVSHNybRP1GDXped72kYkgkULDYj	27299	3NLBR6jQEAVk1e5T2eVpPJDemprLjR7amE3gRa8HPCEAoD77no69	1508	1261	529	12463	18918	jxvZn4bwtHnMtPaTfr7zXiLVtpGFjyXxrruEedJyVe5aLGEbe3F	13494	18991	18991	1619357580000	canonical
27300	3NKZNprRnsKe3e36PaYjgi5AbZaUFxwY2arGTgGnmwj2NGUxRYvr	27299	3NLBR6jQEAVk1e5T2eVpPJDemprLjR7amE3gRa8HPCEAoD77no69	484	1319	529	12463	18917	jw9u2aEbXPJP1DVqQAdGkVKXPrtiRVipMWdWZiRm3MPs36PQ9K4	13494	18991	18991	1619357580000	orphaned
27303	3NKNVz2cb1TC36hzaapyrsxnvgd8QmyVAzRE1wPS1UFo6NSpViHg	27302	3NKkiS3dN2fUpT8t9FEojTsaqZoQSTFLTJpnBp2LXQkBd92HKGnL	1673	1368	529	12463	18920	jwbSWxNWQMhCjwEmQTUGN842BJucxob27LTjybMZY3mAqkaA5TQ	13496	18994	18994	1619358120000	canonical
27310	3NLXwXcDEL4MnfUzyVrxczxFhjTbBqB8EG5xWpyBgKFQy6Prhp9j	27309	3NLEYutwb8b2TNZ392boZyRphTh4Fm6KY4Z7NdyD9Mw7DdV6xHS2	1403	782	529	12463	18927	jwPezuqav5Z5gq2TacPg1LtdDeLxBenywQp6FxVnr6MVXr2hq7M	13499	18997	18997	1619358660000	canonical
27312	3NKaHduu9G7dvmfnaT7mW9noRy9JdvfUcBqDBq1tboUnM5Qdxudn	27311	3NKM4nb6EkeyJmhhmdMcjx3E5TeDTCymzMVUKmsRaVu5dH6sL9UX	1405	905	529	12463	18929	jwVHAbGsCJ2joX94nsv2YRZJmEZypTebkkERHeTjUBSq7i1rGBW	13501	18999	18999	1619359020000	canonical
27315	3NKK3QM8sqU1FgpyZ6UQZft6Er7si5B6cet9cYRj95wf7fV9NVHr	27314	3NLMXrwz2G8QSQ8XYJsrhfvc6TueDEHRoEK5Ey8oT24zK7T49GDy	1406	1393	529	12463	18932	jxi77191sNWoXYmXcTJSNLS6zeGXmKk3QVyFdFqDGuCYt8q87RQ	13503	19002	19002	1619359560000	canonical
27320	3NKbdpnWtQFnVDe3XnJo8yz5wE9F1HVEWh8fLLbCQ1bMVKseVM8a	27319	3NLMg1sVZGUeJxKrcDuau1bi7885cm2w6QhPnKiKBwPhpwqW7pJq	1581	778	529	12463	18937	jxwt8q6aENs6EkZZkZgCmkvf7BS25bWPQt4DmiQCsPnETsKdepR	13506	19006	19006	1619360280000	canonical
27326	3NKXYYyQgrv2U4WKaP8Kt1KFNAaj8yTVpyD2qTJkJygteuFTC9cd	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1508	1387	529	12463	18943	jwmjro27sUP1FWkGtCRsL8rAYCeUufbEMrqsyErLUBQWBe3GdLb	13508	19009	19009	1619360820000	orphaned
27331	3NKaXakmhkUs9Xxxufrhzc4ypPTAVLRJL9FwebpRw7zRTp937W61	27323	3NKTv7DpkeDjAfUyQGbeDh1sigFJrDvjCJ8cHbsiSyxGZQAtrkw3	1594	1080	530	12463	18946	jwsWWMAkxhwtMu6S95vf1PQx4hxgHKMJwYAZVmzrbTk4fWqHhyo	13509	19010	19010	1619361000000	orphaned
27334	3NLEyzD1XBER65RF4VGK7KR2rUxWHEFrktEFwKiakbiaBuwfbwnm	27333	3NKvmKAdL8CfXE1DG6JbfkSTdpJg9N7XYH9acqZwB25594nswEVA	1403	786	530	12463	18949	jwQsjDUvUs9pp1Lrpof3tuoh8UYYkR6boHen1UC3892pvaCaZnx	13512	19013	19013	1619361540000	orphaned
27339	3NKfRP1ZF7LZv9Xc5CCHP1vhmsqrbqjfv22CEWodUFvNkYDH9PgC	27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	149	1037	530	12463	18954	jx2gQc5fUfgSSbgbXPsikTwFSiPoPmXNuVAg8V3DVMfvJQsi1ha	13516	19019	19019	1619362620000	canonical
27340	3NKfYazGJuV3NojrvrSSXJ72cTbnCfpG8ftGyQchaP4vURo5Xq2Q	27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	1675	1216	530	12463	18955	jxR8Bbssc17bJun7siD4RPC9UQt85LcDyPrWM7XkZa4D7qXERCG	13516	19019	19019	1619362620000	orphaned
27342	3NL6APWLWdTgSbg9mCVxYofGjPhTJ6ArAkg2i75LqXAQn445ndMt	27339	3NKfRP1ZF7LZv9Xc5CCHP1vhmsqrbqjfv22CEWodUFvNkYDH9PgC	1483	1030	530	12463	18957	jx5tGKvnVhyBYrSTzGaJquUZmiLQ6qgdJvNhpDmCytYAKXpaQjP	13517	19021	19021	1619362980000	canonical
27344	3NLd5PCsm6g3WTE7RuK5eov3GaTLogbqtHUEKBBfrzr5ULTcw4We	27343	3NKo4stPJNJbiF3gU9adpZfdw363VpbCF4Rge2WsPDuEupix3ph8	1405	851	530	12463	18959	jxmZoiEEd1XGKhUqGkdMjYti8bkeaDQcacmuZKLu1JAvPUgCStN	13519	19023	19023	1619363340000	canonical
27289	3NKxGRhM4kxdy6WEzLf9xU543MRcQJjLxJzaNCoD3W17exHWn1D5	27283	3NK9WigKTFYajPRiduFjkth8JQABsMbWVJ4isi4P7vLQ7Xk5enPC	1631	794	527	12463	18906	jwgqJ2QTaiVG5WKa5qU94RBcd4vuZv15CeBZBVGstEDuKrNLDTn	13434	18982	18982	1619355960000	orphaned
27367	3NKX297iFaZ2TRsXgMrySafTqCpNiktSHLp2fy4YoNUo3XjRvSp6	27289	3NKxGRhM4kxdy6WEzLf9xU543MRcQJjLxJzaNCoD3W17exHWn1D5	1631	794	527	12463	18906	jx83p8sfm4X6xapc7HU6fyw6mQ2XXD7qbEoE9A6ZaaMs6VFkH1r	13435	19044	19044	1619367120000	orphaned
27274	3NKDnahzKkUxs3T1C2395x6WF8Cz677YBb3vTNeXrdqBFgwuDygi	27268	3NKXQfHxxa1bCCYXSmaDcWDWWRW17dfe1ZT5HHPTq5geNio5u42z	1474	1329	528	12463	18891	jwR3wQ7uFvAZYo8ZuDnYQRZrcR5UJMo1iGjDPPLpiEYZKvazrCs	13480	18972	18972	1619354160000	orphaned
27279	3NLk5FDzFapLo3FRUWnXoKKxU4EXJVE5tgQkaX8Y7rXmTi15yykH	27277	3NLeMWnahZF6B7YEr1g8baSST35ZozmUYCrjFpUiivXT3Z4FYDK2	1445	480	528	12463	18896	jxJqNHLBsC6GrKg6Vf3z8j3nbuUKeZ4yCfkCBR5wm7jM5EgAd1q	13483	18975	18975	1619354700000	canonical
27282	3NLXhnsUM1crxc6VDk4p7wENrzeEhg3HrGZQP5vbGDr9hQZBJAfS	27281	3NKdrm4wCtSJMzzb24coKaRaFcWZYF3M2SGnLHf1hnCZHi58BtLa	1594	1080	529	12463	18899	jxptcDkBnRgP92MAXneV1rGLyA3h3ZHa7zV7WygG1DEep74SNM9	13485	18979	18979	1619355420000	canonical
27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	27282	3NLXhnsUM1crxc6VDk4p7wENrzeEhg3HrGZQP5vbGDr9hQZBJAfS	1603	444	529	12463	18902	jxxeRdESQFasZ3s1VNnQERj8iyg335o8RKjr6SxzNAUKgHMk1SK	13486	18981	18981	1619355780000	canonical
27288	3NK3hheCKfttchkGkomdZJQyWbYZdbs5Gsju7taqE9zY31iJ4SaP	27285	3NKv34o5bVWq3tRx7rqd3EGpHvCR3LCN1MG3gWxbx6MNgpCVh6xf	1555	981	529	12463	18905	jwTPHo9kSYYYsq9AYyRfUL51wzY3gMEUALz5vTTJ3AWoF5oKDJT	13487	18982	18982	1619355960000	orphaned
27294	3NKoCRKRnBYE3AMNZNMJ3KTqTBn6N7cPEUPxwuiRE5vViM9s7NLB	27292	3NKz6XfMmtpcTjC7FucnfuuhZ1VSaMLjzd1kFxsvgBXr4SL2ei9b	1407	1395	529	12463	18911	jxsWhb6oNhmX8d1Jg9TWyEYxb4fZshDKEPS19z2co5XXgDSgQgc	13490	18986	18986	1619356680000	canonical
27302	3NKkiS3dN2fUpT8t9FEojTsaqZoQSTFLTJpnBp2LXQkBd92HKGnL	27301	3NKJSxC4LuKfAps2gKhesf3BUVSHNybRP1GDXped72kYkgkULDYj	1407	1395	529	12463	18919	jxA8gry3Y97xtJxnVqEK4zp2P8j52G1MG7r7kd6CoMfcKWGYwi7	13495	18993	18993	1619357940000	canonical
27304	3NKUjg9nJMRG2RqCGp7Mxi7dZsNHszHUSk43nu35xZMXEQ9Mh3pJ	27303	3NKNVz2cb1TC36hzaapyrsxnvgd8QmyVAzRE1wPS1UFo6NSpViHg	1542	1058	529	12463	18921	jxT63JsTihvbJ9F1niX5puje2sgE9WhGVtQwqQtFMadUgruJkqN	13497	18995	18995	1619358300000	orphaned
27307	3NLYovErBeJQwPLHe2WmT7qsZYCxyXvEY1VMtHMQmch5VDtdmFPs	27305	3NL8pC9WEzxB1f3WAY3UnakepFy89V2TFF75FcB8iSUxBjJ1NH3J	1657	1098	529	12463	18924	jwudYdPPLu1SL2oJZSkanSoFKEV6yU3H5JLjeR5WeiVJrE5djDD	13498	18996	18996	1619358480000	orphaned
27311	3NKM4nb6EkeyJmhhmdMcjx3E5TeDTCymzMVUKmsRaVu5dH6sL9UX	27310	3NLXwXcDEL4MnfUzyVrxczxFhjTbBqB8EG5xWpyBgKFQy6Prhp9j	1405	873	529	12463	18928	jxNtC56fXdmvdcwTkU9Y2ZtoPEMcCMZqmgNkQAHkMjLLpPp3ptE	13500	18998	18998	1619358840000	canonical
27316	3NKoAuQUtL1YWV8x9qrMVfvWZUUsZ3NmFRM9veLbNiuSj3c8JvaM	27315	3NKK3QM8sqU1FgpyZ6UQZft6Er7si5B6cet9cYRj95wf7fV9NVHr	1405	873	529	12463	18933	jwVp6NATLkuQ12o36ehwPojTZNKMbrJD3abgFbNS1L7QjUNAtGt	13504	19003	19003	1619359740000	canonical
27319	3NLMg1sVZGUeJxKrcDuau1bi7885cm2w6QhPnKiKBwPhpwqW7pJq	27316	3NKoAuQUtL1YWV8x9qrMVfvWZUUsZ3NmFRM9veLbNiuSj3c8JvaM	1610	1068	529	12463	18936	jwWhxhDtMWG8AVcRs5FRE1KkiyNpxMQz73EQwzSxULSyQ1ibBeA	13505	19005	19005	1619360100000	canonical
27322	3NLNZFig2JSxKjqA9rm9XVFEyoYjfnCnDBHrSZyPcPMVTMP1KBkn	27320	3NKbdpnWtQFnVDe3XnJo8yz5wE9F1HVEWh8fLLbCQ1bMVKseVM8a	1599	1287	529	12463	18939	jxqQUC7emQsEt8hyVGUYNtsaxQXHWqGVBS3mfghUyy4ofXNH6VK	13507	19008	19008	1619360640000	orphaned
27328	3NKRCuz9k7QWtEpTSc2Jqyf75H4HsPYMLiVDuGYS5MHQDfKH1mHi	27321	3NLYjCzTiVBR91H8gkfMoCVjiUUJMxj6WySjgtV3ZB8Ffr8j3j6B	1652	1069	530	12463	18944	jx2ACAv6Yfh35NhNenc2kKeYCtHDuc5TNGFk7Di816wapsfpLFg	13508	19009	19009	1619360820000	orphaned
27330	3NKtUsgiujMwE2cSQ3v3grW3eXuZ4QQ3bJY7hQYhhtEc6RfkUtao	27323	3NKTv7DpkeDjAfUyQGbeDh1sigFJrDvjCJ8cHbsiSyxGZQAtrkw3	1547	1378	530	12463	18945	jwgukVrbcgyGDFmet6RvoZ93U6xPBry2h5c8vNvqzXjHZ1ZfueR	13509	19010	19010	1619361000000	canonical
27335	3NKC6xkLNDNp3NhP4RwVcFiupt9pJwqP5nyVthsNyW8vntGB3aSL	27333	3NKvmKAdL8CfXE1DG6JbfkSTdpJg9N7XYH9acqZwB25594nswEVA	1590	1174	530	12463	18950	jy1Ky6Qq9sy57WgWL6adM9i1bBKPH2Ec8TJKvreiBPDXaKPpDop	13512	19013	19013	1619361540000	canonical
27338	3NKYZjXCw55EAMCB6M38FtBLmTgTwBAaoh9YFw5o266cM1EUMpKY	27337	3NKWxch3fDP4vaJZCEb4B77KbJgSnkMgSPXcYTdi9GwgYpkwPf1H	58	1281	530	12463	18953	jxqYA6ShK1FAT9BdapKm4Uw4znk9MqwB5wSFJhvwxvprT4ogoNU	13515	19018	19018	1619362440000	canonical
27343	3NKo4stPJNJbiF3gU9adpZfdw363VpbCF4Rge2WsPDuEupix3ph8	27342	3NL6APWLWdTgSbg9mCVxYofGjPhTJ6ArAkg2i75LqXAQn445ndMt	1407	1395	530	12463	18958	jwW8DL2ukwqPtBqfEHmk4Lueuk3wMjZGmGbLw5spU4JvFsaSLSN	13518	19022	19022	1619363160000	canonical
27348	3NL7BcFPA7rx3s4Xh8raiiVeB7sQ25RgrXX55kaHWirRq6Mc7drA	27345	3NLTKutJ3RAhqjgMr95EaabLW2E7sZdj9re4r26xoSswjSP1cFuo	1474	1329	530	12463	18963	jwKSxWWnzifWyPZh9HWSdyN1qzRasBgoBycsV6xwqXLowKaPhn4	13521	19025	19025	1619363700000	canonical
27350	3NLqdwoFhrK7CkpKi5ceVGP2HL3Dzua7YdAKtjPmk5QHHJ3FFJP5	27348	3NL7BcFPA7rx3s4Xh8raiiVeB7sQ25RgrXX55kaHWirRq6Mc7drA	497	657	530	12463	18965	jwXDQpXfzcRj8KH8AAHTJyRPR7udmG5GC5Be8NuvQiDheneQgfL	13522	19026	19026	1619363880000	orphaned
27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	27352	3NKEz9zz51W1TePkFGpf3qU6b66CKCvcZzJikDMrHfy5HNAeeHGR	1402	850	530	12463	18968	jxZDuunTwcBW92y4f8GW56CZNvQX6mwRLB37kksKX2kK96FJAzF	13524	19031	19031	1619364780000	canonical
27354	3NL9YE9ELjCE8qsKyXDm7M42GiJTtfhSLjS5ArVForJaKkJhYHM5	27352	3NKEz9zz51W1TePkFGpf3qU6b66CKCvcZzJikDMrHfy5HNAeeHGR	1613	983	530	12463	18969	jxZgap68qcNGdynpaL3TePMBZfof7EPGL93b9yMS1yK5YsFvx5Y	13524	19031	19031	1619364780000	orphaned
27357	3NKwxn6ewAgBmuMw5M3rPqopnZuJYzTJbuBfKGGreYgr9VqDV8D6	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1619	1275	530	12463	18972	jwih9jdBu8Pua5Kj95QY5Y3BKDpoGRm9XPQwNw3SMtHhtYbpGta	13525	19034	19034	1619365320000	orphaned
27360	3NLjzFQudUhTgxrXGvTADG2MmaV4TUo8151G2doEn59ockBH66AS	27355	3NLk1yy8WrR6Go4nX4tnXuUrhE2CrY3aNKRs3fyAi5K5DBtY7URK	633	1384	530	12463	18974	jwNrHedkjUz1u2JsMeQnxx3ryhreGsorhApjNb5yaCYCqXZwX8F	13526	19037	19037	1619365860000	orphaned
27365	3NL66VacYdWNRifHzmX56UaMNFYkS6KLM7YAjYn2TNzFrNHhgs2H	27364	3NLVLLXjyTXwtbHqrDjfheta5hVcUmsJBKW1qz8K2vmEZXwuE9et	1662	219	531	12463	18974	jxtWvSBhtnmbcTfmeb6ToPEgFibKjAaRHWMGnabbyh7AXPiuB2d	13531	19044	19044	1619367120000	canonical
27370	3NKeUBhasExp5U6jtouibTEcYxTVL9EesKPRFpbGziy2kxenDb9X	27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	1448	945	531	12463	18974	jxNZ5UE2JTneGAhkbaY2YgDYDYBBJhBjkN6pwggCNr6YoarEy7U	13533	19046	19046	1619367480000	orphaned
27376	3NLTLkWSKh1tzD81WQjgFFdDZJrEnWWb4coEDWTEUaSFkdYxzvVo	27374	3NKHr7HVrarvzgxYYopdY8RHgYKnX4djP5pxbG3TPMHUMMRW4HWv	1617	1288	531	12463	18974	jwQAftf9xcUGCxuNdKDHSPma5XTngW8K7ghEybFwUgkuDmedKMV	13537	19055	19055	1619369100000	canonical
27438	3NK6k8AFjTVBxTNLmcQ9MNy7ofYnDRBGSzMC41mCRwvbVGEEHAS6	27114	3NKv6eMK8R2A8Cfv8XRj4g8qb4D4QTUy1HpdmbEBi9PLHqWyepuN	1646	1354	525	12463	18742	jx7utqW8CnFqHjBUxVbhkCg7pmE45SqeWuWhkbQtECum1Xnm2Qn	13406	19095	19095	1619376300000	orphaned
27444	3NKGXcyzBrqMeAX3VtxRuMypeNU265GhRVKLRoYhEYxEUSUkAbPb	27188	3NLa8cCesMjZqqZy7NWXxXA19c7bUkYV8id3eW2jh8yVS9axrnWn	1646	1354	527	12463	18812	jxYMbvjYF5SqVFpba8UgnqeeXacd6LKe43aqVweG6BhuKt2BTGi	13448	19095	19095	1619376409118	orphaned
27352	3NKEz9zz51W1TePkFGpf3qU6b66CKCvcZzJikDMrHfy5HNAeeHGR	27349	3NKsJqXs1dRfsneSD6NoTxgcJFNszGm1VW7boEPBJn2okL6nGE5K	1654	1214	530	12463	18967	jwRBYc2y9oPhdjAc7EbCcCdVbLEutsGBZSJj9Meae6k4LxLh7n3	13523	19029	19029	1619364420000	canonical
27356	3NKzdoCDpeZe8mbBno1espYaFVnoVTCsV4SkNUKZ8xz8qeEys9U4	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1490	1148	530	12463	18971	jwKJ7XXHvo3MYUpYNWNuJq8bzmufqf96bbP2Q37VfAws14YmnK9	13525	19034	19034	1619365320000	orphaned
27361	3NL9q8pof69XAkNYxjVhzniaTGKyVF8XLvKWS9S2ud2dCRG2zP7G	27359	3NKfghfmtAEZVFVeym7cJT7su8sB457ezKSHkbnSzcRAaU3rbcZK	1634	1085	531	12463	18974	jwzBDADcJQaF895Q54YMNt1zDJRj8C1XftwsRnWPF7JiqSWvzQ5	13527	19040	19040	1619366400000	canonical
27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	27365	3NL66VacYdWNRifHzmX56UaMNFYkS6KLM7YAjYn2TNzFrNHhgs2H	1403	824	531	12463	18974	jxyPtnf6iHdTEmLpR1FeynAcyhhtPLtvZbZ7pyC4cjzThNcQFHr	13532	19045	19045	1619367300000	canonical
27371	3NL5chXvsLBo74j7gJUZj9X597ULiJ1tVpTwiXxtEZm3n292HGy7	27369	3NL9bMMD4ArW2QePqLFZcfcKMZ2EDNZnzrezaJcvVCd3NyLCcvYQ	1608	1043	531	12463	18974	jx39LcWeWjGBpuhPJnR6D6jLnz6kYb21nXkWCffAPmfXH34FHcY	13534	19047	19047	1619367660000	canonical
27373	3NLVop7fZMzzo6YdDaKTsq7b9ZqeEBrjCKUpo863eSxbB9r5dMYN	27371	3NL5chXvsLBo74j7gJUZj9X597ULiJ1tVpTwiXxtEZm3n292HGy7	1637	816	531	12463	18974	jw7jHbziFNw5euKh7Jdq8JA62z9CAcCRuk78vbvV4naNRhqYzoo	13535	19048	19048	1619367840000	canonical
27378	3NKG8m1KUkTJ737NrYGMwZpDE41z4TrZJFszhGvdZ8B2Q5Cc6wVf	27376	3NLTLkWSKh1tzD81WQjgFFdDZJrEnWWb4coEDWTEUaSFkdYxzvVo	1419	814	531	12463	18974	jxKFXJvvRY1ruUwDBTDX5hy8JgH6QT6rZah4Lmmq2RQF4wESmGd	13538	19056	19056	1619369280000	canonical
27381	3NKop3yChPYBDUHPLVkCbiU8S5t8kuqRJ5iFJ6fwZbG4cwzePUqM	27380	3NKxPc19mLegsW4whmqpvdcy2CQjrhYqjNnW45gaP8KTXfnYiNCW	152	1204	531	12463	18974	jxJ2s71gC1tggjLme5eaaPkBsZfhkrx13sqBKx1qZoTp2q8a2ZV	13540	19060	19060	1619370000000	orphaned
27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1651	1175	531	12463	18974	jwVc43vDGVo26NZ916h45SKrhjzMDACn6Kmy7V4J31LgpGXz6m8	13541	19061	19061	1619370180000	canonical
27383	3NKQBwLJMFQKQbceu4XuPNsnJzb6QowYFLBo3Nk9aCh8d1QktgQv	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1529	1316	531	12463	18974	jxumUbVW9N5PFLZUEhWRAKxLeJLJfKFXN3YLDMQxF5fmFtHyH2K	13541	19061	19061	1619370180000	orphaned
27389	3NKLzyLSRUvtD1f1guDL7VDZPnaHg3g5cuzRfpworxdLaCCqhihh	27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	1675	1342	531	12463	18974	jxgUEjnWxLSsUXEDgrKZwyvKvj9zBRKrniASt7fvQSFBofL6Ltq	13542	19063	19063	1619370540000	canonical
27388	3NLDdJaYB6ZPvoab5khJXFU55TJLsaoCTWifX8QacsYkEJkgPccL	27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	1406	1393	531	12463	18974	jwL6RqtHqkKqDkzcszgBAfC9pESDLQAcVeTqjMEETHNGj3U1Kt2	13542	19063	19063	1619370540000	orphaned
27390	3NLjCUrkDHfSgAwHy5x6D1ABcUf3ZexT1NLNUAD9CXq12iFS37Xe	27389	3NKLzyLSRUvtD1f1guDL7VDZPnaHg3g5cuzRfpworxdLaCCqhihh	1637	816	531	12463	18974	jwAjxsudr6dJxebp9s7B3NYABAghmS8CRZei2dgKKAqEMjvv1ZT	13543	19065	19065	1619370900000	canonical
27401	3NLhqEsGGvctPwxVJfFezZPsGifThDpkhWZKGRzc581cnz5iPb5t	27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	1407	1395	532	12463	18974	jxKCQgnVXLbzEwc4ieQCVoGQUGpQsrZhBHx1EkbrCMqYaaQe7KS	13550	19076	19076	1619372880000	orphaned
27406	3NKZ1siAD3KnasqvQ6KZFYmseKPkR8wowoHRe4Qz55zUjXMayFpK	27404	3NLnjXTY2JZRKtzjBGoDhzxHHUVLBxhgQTRYmeZCEFxxd69FB72Z	1501	994	532	12463	18974	jwmTVPcv9wy18Yzqk4mfmiUS5VaeKNpFdxjwZfpUzhJrG1fgtFn	13552	19078	19078	1619373240000	canonical
27413	3NKj7sKDj7zoDiM5K8khxb7Cn7zWfk7d8KNSorq98vV1Ckp3pGwf	27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	1448	489	532	12463	18974	jxSFhcLizCSn8fXCQQDyrQ9X7N3TMTrpgA1PkjhUPFuq9b8WqDc	13555	19081	19081	1619373780000	orphaned
27415	3NKomvJ2vcT9LQtLFQYmn9xbY7BFfBbGQpfVkivKvHYitWnwe1Z4	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	633	1138	532	12463	18974	jwx8oErLiDvsJW1aSAmUnRYwkQQCDyJBxknQ6khA24TY9CU8NaS	13556	19082	19082	1619373960000	orphaned
27419	3NKbPy7BE7vHGGcMmuRRTdAnNGGvkjfNBSiKveaNS6TvtH6QAA7B	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1439	1033	532	12463	18974	jwnh8CBa3RYb93AcAi7nj8jTLDg8UhyanqbZU5V3vxdjZW4achc	13556	19082	19082	1619373960000	orphaned
27425	3NKGS8apNEU1BV6SVBdNECbrPGJGkq8FKySKtfujBuH3GhFenMC8	27420	3NKDh3iVpcfEiHHfnU3FzTii4fobFWSL9b98UbVvBrc6RJU4Msgq	1651	1301	532	12463	18974	jweLfhKWUD9Q7bddwPuxKG7vAoh4MVpWAZTNeBWeDZ7PpcS5Kh6	13558	19088	19088	1619375040000	orphaned
27427	3NK6jUtowtSnM96gvWE5xqRMb6gBWZ4q3ZR9ok63gVM8itHa77vZ	27424	3NKL9ewFqF1uSMctzabQgTUSadWTLVvghmJ8KEdLgBQxU9nPuBzW	1529	1316	532	12463	18974	jwPLpnKiSwiXtiuYELV3FK9MfaaXgVpnAkKom26iTL1i51sPdrW	13559	19089	19089	1619375220000	orphaned
27430	3NKV69yVwK9rUHxVtBYVwtsbPsF1bapWx4YghT6GghwmrjPtM56c	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	1599	1287	532	12463	18974	jwEBnC2YnzojmqPqEDTkYbeRcgSuRbubukWggbbyod1G4h5UcKK	13560	19090	19090	1619375400000	orphaned
27434	3NLdYvfCwhkvnGTnAp6tth3DRVyAcYAJvKBic4z7E7WMzuzcqgUB	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	1407	1395	532	12463	18974	jxAMir1fwLyfP1jAw2fq9EPgsSuzPs3eEX9HzYVZaa1qWTMwq2j	13562	19092	19092	1619375760000	orphaned
27442	3NL7oJdoqVNkMT9iC18yajYDktXvza6EkTSKxDNZgWX8EPjmt6C6	27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	1646	1354	532	12463	18974	jxw1Rr8udLqXLhm4vkvkRipfwNu2M9g6VqT54Tocwxucqe4g2Tk	13564	19095	19095	1619376300000	orphaned
27448	3NKtnhL1GAmcppqwA9pSPSnzDzko43ZMuPYLYBsWgrds9TiJPjZb	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1448	1185	533	12463	18974	jxmM5xeM7ytCqqo8PBskE793v4ArirGijvzsd8fxoLZubW1RLUW	13566	19098	19098	1619376840000	canonical
27452	3NKwbTBTs4uMBrfxaeTXXccJo9Txb1ymqrNmNeGDmia4tvn2CVrw	27448	3NKtnhL1GAmcppqwA9pSPSnzDzko43ZMuPYLYBsWgrds9TiJPjZb	1648	1284	533	12463	18974	jwagRormBZcSNJNr5CNLnFDmmc1JTx4TkA7rjrp2zM8XUDdFaBS	13567	19099	19099	1619377020000	canonical
27456	3NLxmoQxuhLw88JoXdRoh5n9ZUwGPfFmmrnh9q2NFfknrFSrKFDn	27454	3NKfoDQDt4F75fdTjUCEk6PUt3twsBUd2yr5BiCuHo9nzpmMqqVW	1648	1284	533	12463	18974	jwmBFTiJXob8rz9vkeQ6Zwm4mjgdnjvQ2PmmXTnAG7En6vPgJBN	13570	19102	19102	1619377560000	canonical
27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	27458	3NLGjyC88oKxSDtz2rjG1eATQdxShvxMqpi37kxZZEUNaKemdDpr	1581	778	533	12463	18974	jxLSpj4t9szRv3P98H4RfpMzK2nM3UJs54f4gpgwmu7EeBgQdUk	13572	19105	19105	1619378100000	canonical
27423	3NLMakFKFyUL6bSXJxWhBrufshCTD45STEEaD7D1tNW9pwxVSVuc	27367	3NKX297iFaZ2TRsXgMrySafTqCpNiktSHLp2fy4YoNUo3XjRvSp6	1631	794	527	12463	18906	jwfuNiPyzQJs46aGtY1X5QiShdZsF9Af3AijMAvoPTZdDYVZj2D	13436	19085	19085	1619374500000	orphaned
27355	3NLk1yy8WrR6Go4nX4tnXuUrhE2CrY3aNKRs3fyAi5K5DBtY7URK	27353	3NL8A7xYeMu5bXy45CGv2f1az9N9S3ztXs7HeESs4EU5HpJ2GWv3	1405	873	530	12463	18970	jxWco24dyFJGSsQvo3QpfecQywMyMagT1K2hZVCdK4CFTay1B8Y	13525	19034	19034	1619365320000	canonical
27363	3NLaYjagcwMSazohDrR1hZQMoECc8XbKpeKPRKY2HE46pprudsYM	27362	3NKsLXNbh1ZrvTaXueskCCr63y9atDjYEVfbHzqS4x6kvSYiGqWL	1549	996	531	12463	18974	jwRZXuesqi7Kd54batRu5fkGoGCaChCE8xnvMTGPUFKCMVYZHqx	13529	19042	19042	1619366760000	canonical
27366	3NLEwQvdk6BceYk4QYHYrdgsThygHGUGLiWcszLQuwJqBSFocPzd	27364	3NLVLLXjyTXwtbHqrDjfheta5hVcUmsJBKW1qz8K2vmEZXwuE9et	1587	1357	531	12463	18974	jx4FXfErxQjfgPjEfL4ABVDpuGDxwT9nZUnu5XRYAtNDZkXSHQv	13531	19044	19044	1619367120000	orphaned
27377	3NKubHjy35HgMF5Y3P1Y75zBKHG3EtVqJyw25VBTBbo7DWEerehj	27374	3NKHr7HVrarvzgxYYopdY8RHgYKnX4djP5pxbG3TPMHUMMRW4HWv	1407	1395	531	12463	18974	jwwRjFbE5GgjmYkJHxuHcSXMPmGb2bb92Fnsd1hc5EWivBvw4Gy	13537	19055	19055	1619369100000	orphaned
27379	3NKTwHzetAGHMYbwaHEwivcbdhABuh7mTLMmMX7XZAJSYCzUXWjp	27378	3NKG8m1KUkTJ737NrYGMwZpDE41z4TrZJFszhGvdZ8B2Q5Cc6wVf	1406	1393	531	12463	18974	jxen43iCawnkcEVNbNxx7dVkfLJKE4VUpH5ZD7AENdbWJxUAghA	13539	19057	19057	1619369460000	orphaned
27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	27380	3NKxPc19mLegsW4whmqpvdcy2CQjrhYqjNnW45gaP8KTXfnYiNCW	1581	778	531	12463	18974	jxvTkiijZDSDP9cjppx2etJZsu2e5bqJPfL46W4eYp5t8rGSBqA	13540	19060	19060	1619370000000	canonical
27385	3NKTm64ESQ85aDkcZxq2asaqAAviw8FPh2qAjgtNVksz5kHvWZ17	27382	3NLWKtiYmU33y8e6tyhFEoTXuDYYHz7DYqBUuZNfXrB7JNNUJwMy	1651	1175	531	12463	18974	jxboRdvvF9RqkQx4tu3Ndgi32RhDYj9ueu4uGF6EmuPLEJucxJq	13541	19061	19061	1619370180000	orphaned
27391	3NL2kKKdDx2fTgKo3cr3VSU1bBnZj6YYRyJx3zFkeDEYdHfGBzUa	27390	3NLjCUrkDHfSgAwHy5x6D1ABcUf3ZexT1NLNUAD9CXq12iFS37Xe	1649	1257	531	12463	18974	jwnBvGSxV3ztRJx66AeR6UjvJug7EWahSWM1LaFWfZ5L1kKUc5j	13544	19066	19066	1619371080000	canonical
27392	3NKmaDmWcTdMA3MNbfS59XUx9yDqbc7ygXEjH5HPwB6KSdUbqVNA	27390	3NLjCUrkDHfSgAwHy5x6D1ABcUf3ZexT1NLNUAD9CXq12iFS37Xe	484	1319	531	12463	18974	jx1kHc983BkVn8rvKtTehZLgSq4cZCUrhPU1MGYykVzENYar7z6	13544	19066	19066	1619371080000	orphaned
27394	3NLijwwxZob88FWbjdz1dPNG3c4XzNQ6BdsgdRj2Vpce6J5ZBQby	27391	3NL2kKKdDx2fTgKo3cr3VSU1bBnZj6YYRyJx3zFkeDEYdHfGBzUa	1589	1040	531	12463	18974	jwmhag88GziRyiudKC9HwLv76XvEWyFQTZe8puzhSVqQS6cuHif	13545	19070	19070	1619371800000	canonical
27395	3NKNaMbK2TJVRdJxPzFNwNuQciSDNqoLRB8JPgLcMzeVNVvHszRy	27394	3NLijwwxZob88FWbjdz1dPNG3c4XzNQ6BdsgdRj2Vpce6J5ZBQby	1402	796	532	12463	18974	jwahXJJKPkfsj9nFfdKXZFJuCFwi2nsmt6DENAEHu57Uf9kCjtb	13546	19071	19071	1619371980000	canonical
27398	3NLJwaQR2HFdmGQ2KNSzFARF4WGgERvuoFsdZFp7yfaJszJ2QWja	27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	484	1073	532	12463	18974	jwhWbQudp38TTjb2H7GWqz5rmEnnZn2wASrnuqeJgRvaT2gmddg	13548	19074	19074	1619372520000	orphaned
27403	3NLJsQzdsASXXKwDxnqn1uaUzDxtDDTBjXsN2B3ehdhahPv3g56W	27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	1617	1288	532	12463	18974	jwhg75sofWcymFUYFdan7Bm3CU88rjmrcNvYJJXmkdVp58G4Fcc	13550	19076	19076	1619372880000	orphaned
27405	3NKQcpBkAXsbSNJgUKHMC4g4m5pJdGpQAyQvi7kWxGsg3iwUH3Ey	27403	3NLJsQzdsASXXKwDxnqn1uaUzDxtDDTBjXsN2B3ehdhahPv3g56W	1633	1390	532	12463	18974	jwgEERTR2zRojVdokHN2hm8ocosqg5tm3qD8TmVHnXD7jAmoCX5	13551	19077	19077	1619373060000	orphaned
27408	3NLUSHssZn7L2W74CNuf4JX1uEwgYrYYFTeqe1iWwePjNpD6C2fe	27406	3NKZ1siAD3KnasqvQ6KZFYmseKPkR8wowoHRe4Qz55zUjXMayFpK	1448	1311	532	12463	18974	jx7n9NMmGwV3rkVYLDFnBksihsvLjn2xECmUr55ZJb9M1RPKCuc	13553	19079	19079	1619373420000	orphaned
27410	3NKmvSrLV1AAhUkTxxnzBxCVquHEWBG2sgpuSC8vRQ3op7JrXAaj	27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	1419	814	532	12463	18974	jwNazK47QFZGhZD3ep2ob872uRVRy7rLZURXe5QrqaePCCzhA84	13554	19080	19080	1619373600000	orphaned
27417	3NLYz7bEm2RLCXnRinsBFtB8n3ZWbJZVPmydVaGP8wgbuaGoQQ1N	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1447	979	532	12463	18974	jxisJsErpK1nKTbs2Dk9M7kgbR53mKgu7Ej5cLkw8kdo4Xkoqpp	13556	19082	19082	1619373960000	orphaned
27421	3NKhioQUNbVjHUU4oDBfMMSgJEh4foGqho1SBB2Uw2ewCdRk9JTm	27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	1448	1311	532	12463	18974	jxgKQuNHpBgApwhxcUEWKM4g74zJ2EtTUZDnYKj4prXMKwriRpp	13557	19085	19085	1619374500000	orphaned
27428	3NKtWSK3okGk5hYMpjgmieQzhcGrS75JDf4FyMCAN1pvhohsCi31	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	58	1035	532	12463	18974	jw7ZW8wD79Ya9ALizmc8TG4MofcqcSvoZKDLXYgVouyWKJ6DHdK	13560	19090	19090	1619375400000	orphaned
27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	27431	3NLUp1iWgfVcKm2X5KfHzfKJrVMciw2V2N8XsKT36CNTnAwNuzw3	1406	1393	532	12463	18974	jx7t1CwdchH388q8Ku2LWify8YCZ3ag7KzL1sGzYF51XqpU3GRV	13561	19091	19091	1619375580000	canonical
27436	3NKkjjkkr82GqffeFmwTZUWV9xPrw9TW6ByFiS9Dy6Qx62FWoAv8	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	576	1109	532	12463	18974	jwvENuqRtP1KKbPXFjrxkcUAHqoKQWUo2N1Yy6tcda4KPhVV3F9	13562	19092	19092	1619375760000	orphaned
27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	27433	3NK938q2wdqbExDiDhUQWaGqvUm1RULiLFNnPBYRuUNArDEXj6PG	1507	1280	532	12463	18974	jxdgbKFuaBroMkXZJU6SuLdrNc5CbbFx3NhCwGJWgHyKQ6qoHRD	13563	19093	19093	1619375940000	canonical
27440	3NKdQFyDB9CyajgRftewHpTpFEuC2Ese6YAfabMPCaisHbxGriWt	27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	1506	1127	532	12463	18974	jxVsEeTAC2Kp7B1uh9GPaMbYBwzSKLQrX14dJpuYUhEpRnqHVhW	13564	19095	19095	1619376300000	canonical
27446	3NL4gCsMTukSJX8xssoqoXunB3Vd4fguGBSNbN6W2bnpYtTKtGEB	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1406	1393	533	12463	18974	jxhQMTkvhmnaEFPtorCqnLTnNLbZRS5cKajb4KfxaGiwVeqLzR7	13566	19098	19098	1619376840000	orphaned
27450	3NKXzcoJx5aeuodsetELWmgdRyntCQ96ukYEscT7CYRP2pqiNgwW	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1448	1185	533	12463	18974	jxJesEtPfb1xCLSrMoXhAPFVMJEN72KF5N576bPs3fdMM8SuzJV	13566	19098	19098	1619376840000	orphaned
27455	3NKMVZGUUBFMDkYuEaUq7rgs359cjAAgn3uX3yATUujGgBF1tJAf	27453	3NLtSgXWV1oFr3ofeBunJPc3eQZp3kActcrDjVCtuqeRBuwHL7zu	1403	812	533	12463	18974	jxr9sVDGCmhgv2adUziTMZwC35Jpv3Ve14RskbFomAGYgiazvWY	13569	19101	19101	1619377380000	orphaned
27457	3NKKwxtZz8YnB9Xw1SK3eprVtusPFuMqKW8Nfug52fS1rDN3m3sn	27454	3NKfoDQDt4F75fdTjUCEk6PUt3twsBUd2yr5BiCuHo9nzpmMqqVW	1474	1329	533	12463	18974	jwsJWpKd3osWB256nh2D1WhVenBAVKT4kbqH2sc1ABAetBJ8r6g	13570	19102	19102	1619377560000	orphaned
27460	3NKrmoJMnaj8HvdW8q2ozN39kohpLTRHkhSWUK7FT5iYLnSkjjLL	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1406	1393	533	12463	18974	jxMZJcAnT4c9fWPG3aPNaJrU94JVtJg1epmCDW81BsR4MfBprpv	13573	19106	19106	1619378280000	orphaned
27362	3NKsLXNbh1ZrvTaXueskCCr63y9atDjYEVfbHzqS4x6kvSYiGqWL	27361	3NL9q8pof69XAkNYxjVhzniaTGKyVF8XLvKWS9S2ud2dCRG2zP7G	563	1233	531	12463	18974	jwEHTTmSEHDiSVpPH1pe2m1JxYgbgAjqGLh8hK3pk19SG8frJaJ	13528	19041	19041	1619366580000	canonical
27364	3NLVLLXjyTXwtbHqrDjfheta5hVcUmsJBKW1qz8K2vmEZXwuE9et	27363	3NLaYjagcwMSazohDrR1hZQMoECc8XbKpeKPRKY2HE46pprudsYM	1610	1068	531	12463	18974	jxcTJrz2pxwN7hayGWVd1Gxr4MxpHWxb1AhReWj7en4H9KxTS1H	13530	19043	19043	1619366940000	canonical
27369	3NL9bMMD4ArW2QePqLFZcfcKMZ2EDNZnzrezaJcvVCd3NyLCcvYQ	27368	3NKgy5sx6QrcJdQYbs7mHmGkEXoAp4Edq5dz3GaYLX2daN5gtbDa	1448	945	531	12463	18974	jwE6GygVJu12AXxZHYriSvha1BWxhXUcZxXM6Gsd6XpodWmvP8C	13533	19046	19046	1619367480000	canonical
27372	3NLCbocvjJp5BodcFBGR6Rt6HGyHQh9Frxk7bzgR7vFLzAUGtZsr	27369	3NL9bMMD4ArW2QePqLFZcfcKMZ2EDNZnzrezaJcvVCd3NyLCcvYQ	1407	1395	531	12463	18974	jwiG5izELLBkDRAvSdbb63V4CbKGfSdhhVWeqbh4jcJr8j17j2y	13534	19047	19047	1619367660000	orphaned
27375	3NL9zQ5XuqUyewYxu5f7nwGZpJRrj7irUcz9EXPa1ehRskkSwyUD	27373	3NLVop7fZMzzo6YdDaKTsq7b9ZqeEBrjCKUpo863eSxbB9r5dMYN	1500	1171	531	12463	18974	jy3AMCHT3J8MgtJ49tHpYGtKs2do9s5LGu1iqBgZWftCD2iQ2Ua	13536	19053	19053	1619368740000	orphaned
27380	3NKxPc19mLegsW4whmqpvdcy2CQjrhYqjNnW45gaP8KTXfnYiNCW	27378	3NKG8m1KUkTJ737NrYGMwZpDE41z4TrZJFszhGvdZ8B2Q5Cc6wVf	369	1312	531	12463	18974	jwKfSYBFRvXFjYt3zFucqb5E6EHWATtaAnQYAJ91jQqZU3LLD47	13539	19057	19057	1619369460000	canonical
27387	3NLTqn6AeEQixrQP4dxPDN8C7ASWVGAykCGwcYoGKkGAVzd1fFDe	27386	3NKWwqN8XpJmv8Y4yVJkSNRwqAUDTT4uAD3taPjZeQZJSLyetDFH	1405	867	531	12463	18974	jxhuKPsTAZpXs62Qdps5jjYc6C5KyTHgwr2H1K5RBh1WgQHrkVQ	13542	19063	19063	1619370540000	orphaned
27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	27395	3NKNaMbK2TJVRdJxPzFNwNuQciSDNqoLRB8JPgLcMzeVNVvHszRy	58	1035	532	12463	18974	jwJPSAR5FBghGHNtyw6qUhgE1KuGRhevHoyNmvq8xxuC2JzaqdF	13547	19073	19073	1619372340000	canonical
27397	3NKrRyY15NNbmKdLqKWsw7P4B8bqFnHFyHTgA1C1P2h5quAR3TxV	27396	3NKpsAV6omevJdgjZZVBsKmCPmZZrUaYQm1tS29xHCzzXPk5ZKT5	623	623	532	12463	18974	jxfVm9w9zVzzFPjpzPRLWSzRKdGS9d12oknHBKyToUQ4Tv2oruE	13548	19074	19074	1619372520000	orphaned
27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	27399	3NKRr84kX9TXpGfA8JuFKPV27Gw8SzhpZyJK9BKXdgCndfn6ovYT	1407	1395	532	12463	18974	jwd2Y9wZXnordMDAM5pbywCdBhm5JUfatUnjN8sMzWPgU8TdLEf	13549	19075	19075	1619372700000	canonical
27402	3NL3bwsNCD1k9VDRMJPEwDcMiezUDmfm8H6dxPXDtqBHFqgQVo8s	27400	3NKcWxgim1pczPswtdXLmVtiMxjLu3rBBsvVgEQQL5epR1ZPrmPN	1406	1393	532	12463	18974	jxv3A3mRTsFRa6hMTYSDuLHqM7JfJxNUe4qoeXLP1wKPCRiHw6m	13550	19076	19076	1619372880000	canonical
27404	3NLnjXTY2JZRKtzjBGoDhzxHHUVLBxhgQTRYmeZCEFxxd69FB72Z	27402	3NL3bwsNCD1k9VDRMJPEwDcMiezUDmfm8H6dxPXDtqBHFqgQVo8s	1633	1390	532	12463	18974	jx9toPbxqABCMjdpkgLrroCbNwaWWSKWKQg1jQ9GdXFCAQwy33V	13551	19077	19077	1619373060000	canonical
27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	27406	3NKZ1siAD3KnasqvQ6KZFYmseKPkR8wowoHRe4Qz55zUjXMayFpK	1448	1311	532	12463	18974	jxTRuQEDmtYcWMnmk6xd8cX7MyyEaGRz8NAzHMyDJBqPAVHdKxN	13553	19079	19079	1619373420000	canonical
27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	1585	1000	532	12463	18974	jw7hDf6aoqkaDx3ve5gBu6Uj4sCSvLK72R4BYx5ioqMfHFP33st	13554	19080	19080	1619373600000	canonical
27411	3NLgA4iYWtH7mQ1zSSBssVpyviaoGdB3HmSag4nFzQU4LsBtV4Kz	27407	3NLSbdSwGyh9W6qBbYqC9w8eD1n1C8HsTNBf9QGFrDkLaMyRdapo	42	995	532	12463	18974	jxD9iCXK9PU9BANfSyueKxnVedQWZqnyDFq69m21TPVGMHkwPpX	13554	19080	19080	1619373600000	orphaned
27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	27409	3NKFb2izECGLgfsm2QCZuXWoFeyukQCZJqrsyG9hGNKYJSQA7eiK	1426	1238	532	12463	18974	jx1Pyxbf5NJT9NEWzXbjUcwn6gyzMa15aiTLR5qrXehn4g4oyYK	13555	19081	19081	1619373780000	canonical
27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1407	1395	532	12463	18974	jxJ5oQLtEjkq9kDZR8UL5qJycN3wxTeJjAov3GphWq1HkEuuxUB	13556	19082	19082	1619373960000	canonical
27416	3NL3xamaHCA8by4Thduty5EPpFUuBQpELy4vNizjkuhcb2RrfWQo	27412	3NLjyiDrPDw1A3SnQ7XuDbxT2noNf3Ha7KfSmDmwFs4kA9DStPpM	1406	1393	532	12463	18974	jxyHBeYzbSYS23t3W8h11hocDHLDzfjuAAGarEH6fEwpqxCMwmR	13556	19082	19082	1619373960000	orphaned
27420	3NKDh3iVpcfEiHHfnU3FzTii4fobFWSL9b98UbVvBrc6RJU4Msgq	27418	3NLVNMA8s6VYpLqYUze5qgc6NcEx3LNvRDGMQgfshF9iYFQuNg3v	1406	1393	532	12463	18974	jwTKu2jBVJ7vwC53PW35P25RTKqA4j6gBmcTC9SLtp8UrStz4Hz	13557	19085	19085	1619374500000	canonical
27424	3NKL9ewFqF1uSMctzabQgTUSadWTLVvghmJ8KEdLgBQxU9nPuBzW	27420	3NKDh3iVpcfEiHHfnU3FzTii4fobFWSL9b98UbVvBrc6RJU4Msgq	1651	1301	532	12463	18974	jwivDbAaUKLdsUfV76xt4F98kDK9PjQ3363xdgPxccUg5eyGhS9	13558	19088	19088	1619375040000	canonical
27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	27424	3NKL9ewFqF1uSMctzabQgTUSadWTLVvghmJ8KEdLgBQxU9nPuBzW	1529	1316	532	12463	18974	jxrzhcoP7MCyoUG8DZPxHNr4MCSzpVfjkzngXJ1SXRQbiUXRLJE	13559	19089	19089	1619375220000	canonical
27431	3NLUp1iWgfVcKm2X5KfHzfKJrVMciw2V2N8XsKT36CNTnAwNuzw3	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	563	1359	532	12463	18974	jwzkc3qLxK7HexfCKTgo9WjpHzZQEMYjvr5urNkkfh68DcrsL1u	13560	19090	19090	1619375400000	canonical
27429	3NLayJggTF8pDKyg4e7qhhp8ayxP2rKAmbRnLPRXvh5y5TMvRUvQ	27426	3NLo3SfTLpYriVd1iqFxAspNR4hMwSGDJf8aLn4xdNEdYwmTQ7ET	1406	1393	532	12463	18974	jwit8ZPje6PjbQ36hAvog98DbaAZLj3ZdE19iSx7T8C7gPrUXMB	13560	19090	19090	1619375400000	orphaned
27435	3NL8ycnA7HJnda4HbTYGkpEaBFQx4yBkbpVDxtQNv3en1Q6Ufa4F	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	1589	1286	532	12463	18974	jxPzSLoxkvTP9k5UtRnXKT93wVhghnekqdQ2QoXKkApL19m3JmT	13562	19092	19092	1619375760000	orphaned
27439	3NKwxojS6HwuNKoZoPEQz8eSGF9BaW4TGphnAf5c8qpHLae4rnbE	27437	3NLwWuqquzShMnVFMbdp9vi7XMhDWteqsK7dXB5Be1sdYHD9C6g9	1506	1127	532	12463	18974	jwxMhuvivDkK7uV3oS4FZ6PzKHSTa94sZWSAGQ97QYPUW7bGaEh	13564	19095	19095	1619376300000	orphaned
27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	27440	3NKdQFyDB9CyajgRftewHpTpFEuC2Ese6YAfabMPCaisHbxGriWt	1627	1385	532	12463	18974	jxZ6AzGQUU3mNHLAJKLt5seXueMGFBionijucVZzExGyy4xxR85	13565	19096	19096	1619376480000	canonical
27449	3NKw88AYxkPqDuiDaCbfpWDwwHAYgSTxpbAzyDQfKXx73bkdjNkV	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1483	327	533	12463	18974	jwyFufoePa3BmDmiYjYjj78vThf1cjXDHqKCM8h4nyX1k9cJMRj	13566	19098	19098	1619376840000	orphaned
27454	3NKfoDQDt4F75fdTjUCEk6PUt3twsBUd2yr5BiCuHo9nzpmMqqVW	27453	3NLtSgXWV1oFr3ofeBunJPc3eQZp3kActcrDjVCtuqeRBuwHL7zu	1406	1393	533	12463	18974	jxRmGqSMBdH29KWXLGuzeUfry5aLdbJdYmZYQjBSngQ3X5SAKbN	13569	19101	19101	1619377380000	canonical
27462	3NLvbdXJKchGq3k4QY6weLnZozHeZhU3Xi9K7S3LtjKMYWRFAkVw	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1419	814	533	12463	18974	jxGUWm77v6d6bBcyqQ2MnQZAeJjnwJknyc2WH2ZhtNakb6jxehT	13573	19106	19106	1619378280000	orphaned
27433	3NK938q2wdqbExDiDhUQWaGqvUm1RULiLFNnPBYRuUNArDEXj6PG	27432	3NLaPkcatedL9fB57tPsWjgz4GofUDwJefhYTfUNtsisbdaHhUiP	1406	1393	532	12463	18974	jx7gGqDRK4jDsXn4xr8k6vTjeM2Bn9o5mSpfjvxwMqL9CeauGZR	13562	19092	19092	1619375760000	canonical
27447	3NLTyLDXz6QkTkfjVsNomoYeaLbqSckCzizDhhcQqhoBBnkYuH6q	27445	3NKFh1XxrUQ5PDa18yyxEixc5VKPmQx4rhsgM9BTVGLDqRGp4Lzz	1637	816	533	12463	18974	jxTnPmRvWz6QswBtu71AKutVZaaWkZZ8R8aFqLWzSLhMbjxChRk	13566	19098	19098	1619376840000	orphaned
27451	3NKo5KZzpsDnVWp5MhJzSubUrfqyVtouBXu1ubzs9khyU7bhymJq	27448	3NKtnhL1GAmcppqwA9pSPSnzDzko43ZMuPYLYBsWgrds9TiJPjZb	1403	824	533	12463	18974	jxf3ymYhkSQeuhush7MSWZouY5pGHbBBT7BX2paqRxoQN7R4oAP	13567	19099	19099	1619377020000	orphaned
27453	3NLtSgXWV1oFr3ofeBunJPc3eQZp3kActcrDjVCtuqeRBuwHL7zu	27452	3NKwbTBTs4uMBrfxaeTXXccJo9Txb1ymqrNmNeGDmia4tvn2CVrw	606	1169	533	12463	18974	jwdbwEznHeyH2hdcUsTpft8CexyYGQV3ns6kf9Rwthbo55dMhnt	13568	19100	19100	1619377200000	canonical
27470	3NLpMXsGgYanQrnB8diHaYUKMCTjx5pz8mQxZr4g2dfSKzJPbSpS	27452	3NKwbTBTs4uMBrfxaeTXXccJo9Txb1ymqrNmNeGDmia4tvn2CVrw	1451	1046	533	12463	18974	jxHZwU4SFr6FSTCFy8g6XDYJK4TMdu2CZszyknypbbVoU79D7Eg	13568	19113	19113	1619379540000	orphaned
27458	3NLGjyC88oKxSDtz2rjG1eATQdxShvxMqpi37kxZZEUNaKemdDpr	27456	3NLxmoQxuhLw88JoXdRoh5n9ZUwGPfFmmrnh9q2NFfknrFSrKFDn	1594	1200	533	12463	18974	jxRhSdPVzJSSxSU4QX8ctFVQc1CpsLzcuz274Fx5s6XpHPUvUKN	13571	19104	19104	1619377920000	canonical
27461	3NKUxaWuNCExaAPjLX8HDrQiCTtCn6eqxiKxXMtJBNHct7utDkAy	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1599	921	533	12463	18974	jxviCc4ornEyxEiJ8tNTXKrh68eyJS4HtPmD99u57hWt7SNLEr3	13573	19106	19106	1619378280000	canonical
27464	3NLEjFGcCbDvPivNjQ85cCznjbTB5UGYfPMiYCwwCG5PKHigdf7N	27459	3NKahu6aJQdSzEsa2QjnFKFwmDAAQD1kQfs8xPTbu9sREc3f4Gpc	1419	814	533	12463	18974	jx4uwmZQfx6VT3Uefszrh7dacx3Tepe9zZax16fSM2N2x4MeSSP	13573	19106	19106	1619378280000	orphaned
27465	3NL32hJ8TxrMhuN1QjXfQCd4Dy73ky77onqFnqioZmHy1vJP3Zip	27461	3NKUxaWuNCExaAPjLX8HDrQiCTtCn6eqxiKxXMtJBNHct7utDkAy	1426	1364	533	12463	18974	jxKiFeGCxs5ZVrtMvw21e9jjh4GhZGBe9WxeMcDd85K9j1LGqgx	13574	19107	19107	1619378460000	canonical
27467	3NLF8T7uGSpUzahpiAKXCTs1AxGs8Xv5D3QmZgzzcoiqJwu8zmJf	27465	3NL32hJ8TxrMhuN1QjXfQCd4Dy73ky77onqFnqioZmHy1vJP3Zip	1406	1393	533	12463	18974	jwihFogo1cbxHUdmAZZQNLmFA9s46y3Ds3jWpjsD3eptaJW4LXU	13575	19110	19110	1619379000000	canonical
27468	3NLXVfAnq2KbvrxD2LnNf2BksKR9rKHZpUZCPUD3JyfBjRGcE1Pb	27465	3NL32hJ8TxrMhuN1QjXfQCd4Dy73ky77onqFnqioZmHy1vJP3Zip	1622	1230	533	12463	18974	jx8pZkb3HbofRaba85snidJ14dcgi1yaQwaxGEL8L6Xr2pB9Ewa	13575	19110	19110	1619379000000	orphaned
27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	27467	3NLF8T7uGSpUzahpiAKXCTs1AxGs8Xv5D3QmZgzzcoiqJwu8zmJf	1460	681	533	12463	18974	jwA7GRkF3Zw4XKCLWpsH1UrA42XTKTLXX9PVpTDNtKo21yQRx9c	13576	19112	19112	1619379360000	canonical
27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	1451	1046	533	12463	18974	jwFqV7gaHUSqp6Vry6StSLUrBxrvPD8v2srtN7fmCWymkdWB3AU	13577	19113	19113	1619379540000	canonical
27471	3NKaqYFaKhBKeeWwZLcwotpwGM3hhLd4SRchWq1bwjpdhW16Sc7Z	27469	3NLd2GPeW4HVZGRFFUSvvm3f3yqiUX4K8gLvXf1xx5Xb2mMBS7GL	1406	1393	533	12463	18974	jw7Aam1zNnmB3J6hnSe8EYJkLehdYeFGAM9C1Zi5tyTCE9xwCEK	13577	19113	19113	1619379540000	orphaned
27474	3NLA1d6QCb7vAv2PrhUKoRe2YoxmtteZar7iT9mYxQG9RaRhK9cT	27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	152	1204	533	12463	18974	jwjm5r7Jx9BzsTMVpVpXwsDZiapz6gxnPPXeH1dRRGmwA7WwtXi	13578	19115	19115	1619379900000	canonical
27475	3NKGMhhStMBHDa9WAeVZGJJEJKkb12DTyRhxZw5yRznr434poZaM	27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	1648	1158	533	12463	18974	jxvpj6x7BdciCeaZvdMfTURnZSBxKEDgieQcTnGkY2edCkpfbGV	13578	19115	19115	1619379900000	orphaned
27476	3NKrvH9uquiXJ8quohnhcKrxoj3jQkxBKGrBL2ULQ7tjc7Quvjg1	27473	3NLNUt2MDjujndctQK85eioDDwfVhfoWFaN9FEkSzt6tGTgVdfER	1577	1327	533	12463	18974	jxques3hFpPVwvKj8sqMqxJLeEDzRVcWuWHnrV8PBhJZ69Mgz9z	13578	19115	19115	1619379900000	orphaned
27477	3NKTrmt1dKa6ynVWKwKcunUFmz8BRtyHegZyebKt9rCYcn8BFKon	27474	3NLA1d6QCb7vAv2PrhUKoRe2YoxmtteZar7iT9mYxQG9RaRhK9cT	1406	1393	534	12463	18974	jxe6Rda8Voxf1iyLRh95MBTHSyd4y5YGbP4v3e6bP7JNSNbZwfs	13579	19116	19116	1619380080000	canonical
27478	3NKTCDJqNJoVFHqcR7k4xRji8ah8x4QdfayMjhTTVQ1Q5zYXo6Ca	27474	3NLA1d6QCb7vAv2PrhUKoRe2YoxmtteZar7iT9mYxQG9RaRhK9cT	1444	1015	534	12463	18974	jwTF9vNm7prjtDKyLo1CeapVsrMnmH8AfMvukim1gHEeE24iX1P	13579	19116	19116	1619380080000	orphaned
27479	3NLoRN8FyU6YM9e9xL6gD5U9pZUsPjgmQy8okpoR9hT4wmyjS2QR	27477	3NKTrmt1dKa6ynVWKwKcunUFmz8BRtyHegZyebKt9rCYcn8BFKon	1406	1393	534	12463	18974	jxNjaP53JLUDZBrwN7LTdUTESPeCvk1dBhNcXcsXjDR4DEwMqYk	13580	19117	19117	1619380260000	canonical
27481	3NKsSgr25RHksXMCGTxLqQRubqbBfHJyLmFB5ZW5oVpBPEvavvtW	27479	3NLoRN8FyU6YM9e9xL6gD5U9pZUsPjgmQy8okpoR9hT4wmyjS2QR	1610	1068	534	12463	18974	jwJAnNJ8u1F17GQ7x73huiz2NtrUna1KNxcPu6jSqiEfHWHdtBT	13581	19119	19119	1619380620000	canonical
27480	3NK61WeUu1oYvXDkjLWbUMBK7WNYexJmze7e6LtVALHCn6X5t4c6	27479	3NLoRN8FyU6YM9e9xL6gD5U9pZUsPjgmQy8okpoR9hT4wmyjS2QR	1407	1395	534	12463	18974	jwG6z9b7K6F1zPSGSeu6QCirG8mwCc23hn2AnXdwpT33oLbwbvC	13581	19119	19119	1619380620000	orphaned
27482	3NKGMbxTacz5qTcCFzfQVPv9ZswKfe3JEAU9WsFezsAu2uwZL1Df	27481	3NKsSgr25RHksXMCGTxLqQRubqbBfHJyLmFB5ZW5oVpBPEvavvtW	1406	1393	534	12463	18974	jwW4rh2JtvQLVK7ZnLm9ZXFgoUhNSZGEeCyE6WEGUKNSBhyimT9	13582	19120	19120	1619380800000	canonical
27483	3NLBoj64pJ69J1viHGWnkNksaa5Q31knmZH8hbzmfDqeAVCwc91u	27482	3NKGMbxTacz5qTcCFzfQVPv9ZswKfe3JEAU9WsFezsAu2uwZL1Df	1607	1222	534	12463	18974	jwRTArQdsHGRDbjhaZpmqx2UxnDv7ogdz7xG5qnBZbs2wuwwuEX	13583	19121	19121	1619380980000	canonical
27484	3NLmfJe5euFhXNPoahYH3iEuUUZmpkQDGZdtGzURzcro2mvwedPZ	27483	3NLBoj64pJ69J1viHGWnkNksaa5Q31knmZH8hbzmfDqeAVCwc91u	152	1330	534	12463	18974	jxeGNWYwafvGMuwUiesMXJXJZSbmiyERVZFsgb6AEzm5WunybRb	13584	19124	19124	1619381520000	canonical
27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	27484	3NLmfJe5euFhXNPoahYH3iEuUUZmpkQDGZdtGzURzcro2mvwedPZ	1402	906	534	12463	18974	jwqnrEfQqETrw7NpNr8hif68He8rq1AHjUSUDiPuLNxn7i17puU	13585	19125	19125	1619381700000	canonical
27486	3NLhkhhWTDgQfh44edzuDB4Cw3RKDiDUbbJS4omPfuWbkt4dwZ4r	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1489	1380	534	12463	18974	jxNhECfdKuBhPSVD7wT23Pa4jWgqo6fPoYfr9reAJuqbTJxC8xP	13586	19128	19128	1619382240000	canonical
27487	3NLutytx4HmvcoUsXWVirdqPeCukbz55dcS2zNwz6bKvuf5xXKiH	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1522	1076	534	12463	18974	jwJrMZm6rmUUh3RcSgNpiomCqQcm2AWyfrnsobgEVCi7yUDra4z	13586	19128	19128	1619382240000	orphaned
27488	3NLfYk59HekNW9rvZS8WREqeCXBkkfQFuuYzcdA77dL1WgH8Uoam	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1403	786	534	12463	18974	jwrwMv4UcB95LhJiu7WKfdcxn4HEDwQkZGcKRaUwD3aiZZzQsUb	13586	19128	19128	1619382240000	orphaned
27489	3NLnNqXyivYDnt4A8joZpxaLfVe5oYoghg7bbmTtPpt2FnZtDKY9	27485	3NKLtYFSDCRyy16K41VrfXhZ7d37HNaswFGEf8q4zBjKSgvPWNon	1522	1076	534	12463	18974	jwJrMZm6rmUUh3RcSgNpiomCqQcm2AWyfrnsobgEVCi7yUDra4z	13586	19128	19128	1619382240000	orphaned
27490	3NLrMc4tNr7NiKyp2oSaJk6reS1jQzpRaeWSfeyG7eaiVQcHaGLB	27486	3NLhkhhWTDgQfh44edzuDB4Cw3RKDiDUbbJS4omPfuWbkt4dwZ4r	1649	1257	535	12463	18974	jwg6BKspCGep1v4nPfzKWMvcRBN3hxMn4PkzB293poGs65VogE6	13587	19130	19130	1619382600000	canonical
27491	3NKtaBB8AkQsfh7xuYWZXNc7xVEEXTKhVwXQsSBq5P1UwGJ4ruxe	27490	3NLrMc4tNr7NiKyp2oSaJk6reS1jQzpRaeWSfeyG7eaiVQcHaGLB	1407	1395	535	12463	18974	jxB7SmBe6kLaV4WZcBLbMY3uYEBeYUYdBpnEhayh5EvsxA9MwZM	13588	19131	19131	1619382780000	canonical
27492	3NLKF7Ep5Mq4bsJfUG3XXtqVCnjXQ97jkyLLKYDGuV4B7MvNU867	27491	3NKtaBB8AkQsfh7xuYWZXNc7xVEEXTKhVwXQsSBq5P1UwGJ4ruxe	1444	1255	535	12463	18974	jwcSvKTpQXyc13ubnghWfYvTMPHkBahbvsMapkjjvnofBe52qT4	13589	19132	19132	1619382960000	canonical
27493	3NKSMH4Hjw4w4KRcFU3eiQqm2bUCUmXGAu9pV3w1G7vPKjQknwdE	27491	3NKtaBB8AkQsfh7xuYWZXNc7xVEEXTKhVwXQsSBq5P1UwGJ4ruxe	1483	680	535	12463	18974	jwTNaUcYuSF8dvQSmZRxkAZYHQNAz6LKSELRoKGvhJgPoNSybpR	13589	19132	19132	1619382960000	orphaned
27494	3NLtczJPeN7xTZ17EzWCqZmWk62aBAZgnBG8QN5UXHiEnZkZT3xG	27492	3NLKF7Ep5Mq4bsJfUG3XXtqVCnjXQ97jkyLLKYDGuV4B7MvNU867	1406	1393	535	12463	18974	jxgVQaXqnWrWLyFUqZs5gfgvbmTHJ4qwEvT1T2253AziA46p7gn	13590	19134	19134	1619383320000	canonical
27495	3NL4Drtse78doQK5NdNmeiZ5UpEWh9Hiq85bSCJdnzdy2RJbQLGu	27494	3NLtczJPeN7xTZ17EzWCqZmWk62aBAZgnBG8QN5UXHiEnZkZT3xG	1589	1160	535	12463	18974	jwLE6F4eJxTrZNBfG8E4rWsH3prQ3yZdPpAKdC6q8bUhEv5oRXc	13591	19135	19135	1619383500000	canonical
27497	3NKPfQ26MS7cpRfqM43tphKwBzC5sxMZMh7x2gXKVc9D9NWFFGMR	27495	3NL4Drtse78doQK5NdNmeiZ5UpEWh9Hiq85bSCJdnzdy2RJbQLGu	1579	1023	535	12463	18974	jxia8PBgR8CoedB9JXBVjZHEnQpYmMt83q155Dep3FyA6ZooAX2	13592	19136	19136	1619383680000	canonical
27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	27497	3NKPfQ26MS7cpRfqM43tphKwBzC5sxMZMh7x2gXKVc9D9NWFFGMR	1501	1114	535	12463	18974	jxaE1QXXEo1xtzbaxFqTSZ1554s3r9RdfYgXmuhC64HEyPuQj7n	13593	19137	19137	1619383860000	canonical
27498	3NKN7np1mCP6zA3sYfE8PgtqPtj9BUZV2bFNv4nUqquMRfE3Jy2W	27497	3NKPfQ26MS7cpRfqM43tphKwBzC5sxMZMh7x2gXKVc9D9NWFFGMR	1406	1393	535	12463	18974	jxidT8tyQEU2fz2Du6SLbBs9Twcx4uB1RQ9tZ2KkgXMYsA9FVnW	13593	19137	19137	1619383860000	orphaned
27501	3NKTnD1wp2UfVE4bGskDUQwVtYgXLMNqPPqgwGWKJyRBv7KCjXkQ	27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	1407	1395	535	12463	18974	jwAmdGspVcu1Vd7cVnr9P2htEqy4fuJ63ZSxuQuw1ao5goWAQPE	13594	19138	19138	1619384040000	orphaned
27503	3NLNn2maRSoHigBKiizWeSyhoJs8KDDcyfmsfwWdWWFqMVJfyGSg	27500	3NKuDvAk2sWR3W4726xucaj4sJZBiimGxqt3BjgGJsUYwRxzhv1A	1610	467	535	12463	18974	jxmWeyj2ZbbhyxU6KFjP2mujaBFMnSSiqW3dtU3ucxvtQgdvjoA	13595	19140	19140	1619384400000	canonical
27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	1578	1050	535	12463	18974	jxwFFgs9M6Q9mwH2YSoV8VWqp8nD9hRZrsuoZAmzgSjLjYLKZSf	13601	19153	19153	1619386740000	canonical
27513	3NK7rYt2xWA4YJnDMiTXJpvk5aJrsTvdheRVDSo3bqN5atauVT7Z	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	369	1066	535	12463	18974	jxhJNjtYGy7MTK3qqMGeBCQ7Rix2Bc8YMF8qmHfagfMEgrWNwrQ	13602	19154	19154	1619386920000	orphaned
27517	3NK6LxpXcXgFSZMeyAVCy7sS41yfc4pzr8viuJXvhhgsSQVHH7op	27515	3NK7XsZ6HnBbWJtyYSECNPmsun9yCiYk2EqAJ7iBtRLb7rLqaFaY	1675	1216	536	12463	18974	jwshYFukmj2ycd4yBsX7XADqZEba1JyZcaLfjt1r9jEdTaevYR3	13603	19155	19155	1619387100000	orphaned
27520	3NLLJCEEeagN53cjhdbhmLoQQtxw8xCeSziaqh7uebEBea7XtLny	27519	3NLy6bf5t4VAFgHxCjYK5o97iiJ1XQzjFYGH2JS5BoBicPySQp9B	1672	1285	536	12463	18974	jx7cyqkd69FuVfU5no7C3EZuA7RrDb7XGHua8rVyNBZsELnF36f	13605	19159	19159	1619387820000	canonical
27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	27522	3NL1DvEgXxvXbQiKmJj3EUUeL9gZCWWfUDPBRGsUNHFh9uDhE9fm	1637	816	536	12463	18974	jwFWtmQMt1VyGPnUhSmPiYEFL1xPACbbjo9jSdhDUgLqB61L5m1	13608	19163	19163	1619388540000	canonical
27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	1407	1395	536	12463	18974	jxYbeV8jRNEPufW81YvFCQkTXkTtGjbXVUwdyrSAto2WJuhdk2M	13614	19171	19171	1619389980000	canonical
27541	3NKdHYxgHUkUa8MbZNja8Ad4XhYhmiWyT8tM11Z46xqqQaR8X5G6	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1422	1211	536	12463	18974	jwwkgMRBmvvtzQ64gW5yiVS6p3xaog65zyzN7TrTqH1WsmDXF1D	13615	19172	19172	1619390160000	orphaned
27547	3NL4pNRuhESjAXGWevnKzJRDXMNxHeh9bErKddLmRf1X6TWJvBPQ	27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	1474	1203	536	12463	18974	jwRotBwdn2589qvMtDr4QFfb4yVQYbpLWMZaBA8WnSFxduJ7rF1	13616	19175	19175	1619390700000	orphaned
27548	3NK6Gu64Ry7ot7nYC5q2XisjyywURZGWieZaigf1BcbT1i9JJXfP	27545	3NLZg8MXLhgEfE5mwbemAz9P5QHMHaCrR25JjWY9tWaE7zRTwjhL	1406	1393	536	12463	18974	jxC3FrCd4qP9A7X9EtxkAPZhFumb1K4TLHSW4f7gJE3YpiHBbi1	13617	19177	19177	1619391060000	canonical
27560	3NLnA9DnJXDQ2wNRWPcowkAUxGjrTvRvyHXHFjXv5uEZFAg4cj42	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1397	838	537	12463	18974	jxzUq4dLEvoNMBD5J4GRuYXB1feNmGm6Qss3Z6CzMwuEVsp1KcZ	13623	19183	19183	1619392140000	orphaned
27562	3NLy6yGX9TKd2TGjXtCPv8djgR9dhXugAPfw1xtLSPBsWaQRJuov	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1508	1261	537	12463	18974	jy1Rnq8HzKtArGpAbNa1tftrffKdEhAPTFs3Wi4td8YzdFDiQEQ	13623	19183	19183	1619392140000	orphaned
27566	3NLdSJ9QSrGy5qT6TaJfakv57GvWcHT5kgNRUUsooToUrWVrzokp	27565	3NKYgY8uGMUidcJC95xPaLFC7MGZ35mT991JY8zhAHYpHmi4HCPy	1406	1393	537	12463	18974	jxJ7z6xP8R7AHLkLrGFmwBMMv955hXjqAnYL3taZncgdAW5x1SH	13625	19185	19185	1619392500000	canonical
27569	3NK89KrumqXWrwwUL75xXjX1qKbCrJpekcky8Eq1fxbTBA9898Yt	27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	1608	1043	537	12463	18974	jxYRzmRSkYRHDmF7Y7RCFup1yaCKR63XYrg4X33Xytyn4qXdw35	13627	19188	19188	1619393040000	canonical
27571	3NLMzmbs1Tey7JRo2UB6j3G97QptrqNb3cd3nrcdya8eCawsbSYn	27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	1559	987	537	12463	18974	jwyPxuc1vYbxmqVtedqAWFdqKfEHUF42FMLn73Gv5MzfXPwBVHd	13627	19188	19188	1619393040000	orphaned
27575	3NLUGWiFJLmm4Qs1U414Vt6KjcHNAqds7UGXPWvsDPZfyqsM3zaU	27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	1403	824	537	12463	18974	jwnPNNCKZ98W2cfTsiwnKLGP6Z7dpqvgPyo6xo9SvD1ei9iv1Q5	13629	19191	19191	1619393580000	canonical
27574	3NLWrYTMxqedeHzFB3fwirGsqbVA6inxM5pvjcntzVzUHmEMhZcq	27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	1460	1324	537	12463	18974	jwjQD8oiibkzdNmtV4jrqWFbjgrtcuDrqaNKz6ZqgvecYviw7hT	13629	19191	19191	1619393580000	orphaned
27587	3NLZG1Fp6R2Vng3GSHL2SCLNsaosLHXXMWqpQjSk6fUrNPoN2JJ5	27586	3NLbAMGMADfVGRWtM7zvbndJVZx7nkeZnUm3MHSXdnbijiLrsQpi	1426	1118	537	12463	18974	jwyRDWLLZWesYogaDMBFCRQKZjkA6tX2npFUFiLxrY2w6KDX8sB	13635	19201	19201	1619395380000	canonical
27610	3NLqbD3YHCtnUmSVCFj71yCEgCd2p5YrZkNp2fH9ebtB5R4eArET	27460	3NKrmoJMnaj8HvdW8q2ozN39kohpLTRHkhSWUK7FT5iYLnSkjjLL	1547	1012	533	12463	18974	jwKnhUWEwXSFbWFBJziikeVvvsYeQxjHQT7PUa8xCwfd9HuRhgJ	13574	19216	19216	1619398080000	orphaned
27500	3NKuDvAk2sWR3W4726xucaj4sJZBiimGxqt3BjgGJsUYwRxzhv1A	27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	1406	1393	535	12463	18974	jwQfjfQ9ejrJVviEqAVKKbPWF2sC9CuhXTAfu2zen6WUnckedxZ	13594	19138	19138	1619384040000	canonical
27502	3NLE2adpX8SgJbUcWbKwL51DQEfA6kNvPGrjJUj1hbMdNwsXsZ18	27499	3NLjt7WH38EX6P5xLtbEqnAWzNzZ49HtefiMTXz5EXZbFj7UBPco	1634	1085	535	12463	18974	jx2ZkNG2k9YKAp2n8nLdnW62R6pyRFowFgicLKTYAcHWkhMnnno	13594	19138	19138	1619384040000	orphaned
27505	3NLqCJGJJioGaTHz6mkbEaE7yqeAxGnceY5dKXtiNhFH3Nefh27G	27504	3NLV4UNjeL3nGoVw3yZk8aknnHAfrjhGMkepEGJG4NBz1bwyKNeb	1503	1031	535	12463	18974	jwhjdr4Aa2aMuDhefBi9w2GRRereu52AoTyPJHKG2EuEfGLgU9r	13597	19143	19143	1619384940000	canonical
27507	3NLbZAitNf4cTtPTiH4fn33kKD6xTL5MQ6sLqvdFtromgTMxkUor	27506	3NLqbG2BNKL4XSrtxADvEnRLkVENcfmnhvRQ7vh8PDCyDXUpbDoi	1522	1322	535	12463	18974	jxCiinaxhAirv6DUeDceftYGqERCH7p21u8AX5H6iygFfkrWcg8	13599	19149	19149	1619386020000	canonical
27508	3NKz9XLgFLSnLWxZ2FnSoHyZBmXX5zuC7wz31PsXDuEKR4ikKHN5	27506	3NLqbG2BNKL4XSrtxADvEnRLkVENcfmnhvRQ7vh8PDCyDXUpbDoi	1403	824	535	12463	18974	jxHbAJW3VjKcaVxyWky3Za953f6xCLPPXkWdtDF6Q8nu4zzQrRw	13599	19149	19149	1619386020000	orphaned
27515	3NK7XsZ6HnBbWJtyYSECNPmsun9yCiYk2EqAJ7iBtRLb7rLqaFaY	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	369	1066	535	12463	18974	jwX5sxHYb7jAxP8XWGg1QiFtBBLbxzCRBeYoGvj2J7cT38Qmxcn	13602	19154	19154	1619386920000	canonical
27519	3NLy6bf5t4VAFgHxCjYK5o97iiJ1XQzjFYGH2JS5BoBicPySQp9B	27518	3NKBV8oemtpt67A5SUbuqhU5EDi1d3pU4oNrLB5SwXbDhh7w1LN7	1627	1139	536	12463	18974	jxmt7qi59CD58aAcAKLLUmoPQRWKQ2qJ8zDVM7wQ7nKr1mETwya	13604	19156	19156	1619387280000	canonical
27530	3NKB3xwwmMgsR5UPcKAnroL8NfaK18akgA19ogmPZ86kGoWB5TDN	27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	1581	778	536	12463	18974	jx6vKn4BnEi58j5cffYY2MGE13jxWRz6XsPxRftiNZmVZntQXAp	13610	19166	19166	1619389080000	canonical
27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	27531	3NLv4hehWbR8CdHwFG3itJhtJrFkAuVrWdnTjHpfLC2VE5e5d6sv	632	1382	536	12463	18974	jwBmQ1LrLgcmLh2zM7uATRFNNi5EdpfCvX9oqbfvCkfCDXAzkvJ	13612	19168	19168	1619389440000	canonical
27537	3NKYEg7uJVgWLS1GtEtDjM5LP71QmJBm4kpstYUYSsrysYFuD6ew	27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	211	211	536	12463	18974	jwsawWVuprzcyiDJHXfTjn3mPx16oWAetH8CecjuDHuWzVVC6cc	13613	19170	19170	1619389800000	orphaned
27538	3NLkbopEPAWC5dNRb7kQ1kkmAuTGfx1fQVRiAvFyiVX3u8PhtJad	27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	1403	782	536	12463	18974	jwAsfo4jphP8qhsKj5hVvuVJfYmH6H4ZLWZDbmtAAKTHBo9fcBv	13614	19171	19171	1619389980000	orphaned
27543	3NLHJRMsUbE4J3N6CzcWaRcHwJZZCh7DfoGcqb5ncm9kLMjGrEdm	27539	3NL661kGSD1R6rAHJtmnTNiTBa1bWtsJMN7Bkx6TAgTtf4qamTiq	1447	1099	536	12463	18974	jxsC8FqXgvKS7prUoxE7JpcrP8JEwW96Hx4axFZXdBvWZF8SmWi	13615	19172	19172	1619390160000	orphaned
27546	3NLVyn8owacqz4sPLPTpzDh9GW9FCvrrWJ6wb2VqX2bsh2U3yp6K	27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	1634	1331	536	12463	18974	jwymEDC1m8Phw53r4re6Ljg4eu2MN1d2FX3HdUfUtjneTa6c9pi	13616	19175	19175	1619390700000	orphaned
27550	3NKKqCAnfGC9pNV3jU9xi6MiPmLJmpv3pi37CmkPLcGCzRM8atWE	27548	3NK6Gu64Ry7ot7nYC5q2XisjyywURZGWieZaigf1BcbT1i9JJXfP	1579	1143	536	12463	18974	jxdxGycMYYaj1TB5Ckc1P13nzEuYb8jxm4vH4vRDTBnhYFF67gY	13618	19178	19178	1619391240000	canonical
27553	3NKR4Yvcv5mFRQnPzhrBgALXCwM2gHtQiN1A97FXPq8NXLEtbTK6	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1506	1373	536	12463	18974	jxc4CoLm7md4TkuxFcLEM29BbErfgPsHmg1dni6fp7oaKFL8uBF	13620	19180	19180	1619391600000	orphaned
27555	3NLKH12z8SBgvjZGU9EZ8WqK53hbqb8mEPxR74981SViAxpPk3Ff	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1440	1131	536	12463	18974	jxNwDKj82ZQChEmbhM7qTHMZ8joQvrF9LViunwpZqeJQvndabAo	13620	19180	19180	1619391600000	orphaned
27557	3NLiKjrgDH1pmHbHjD84UujQGpXD8nfqcTrfW6HTLPuMQgot6kEE	27556	3NKJKiV916rKpPHwet4k6sGtJxR4FXBFKsdU63ZrRmSj6V7nUHWy	1507	1280	537	12463	18974	jwqmWc1jvHWY6ae4MmtgG3zhuzxk1uFU993vxwo1hWCBVR2R4aq	13622	19182	19182	1619391960000	orphaned
27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1406	1393	537	12463	18974	jxfR7iNx3gkmWEhR31jGGq8pdHZB3NSds9T9xoz1p1yYzwAKG3q	13623	19183	19183	1619392140000	canonical
27564	3NKFYg8vcsAmQpGqdnufsjZgVVeUURQNwFE9s5z91in9va3MUoRV	27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	1402	882	537	12463	18974	jwVmCwqMk5NebxoKhx54URJRSePw3z2yG4A1grzyPiBtkTg89KF	13624	19184	19184	1619392320000	orphaned
27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	27566	3NLdSJ9QSrGy5qT6TaJfakv57GvWcHT5kgNRUUsooToUrWVrzokp	1619	1029	537	12463	18974	jxzxrmFB3XyFtLNLjLstZberB35MauhVdeS9URU2QLHz2Qrv5Xe	13626	19187	19187	1619392860000	canonical
27594	3NLLZGvjLTXmHaruSgpnFoGNcTqc3v4X8JeLH34G6wuB8SNvwmEg	27592	3NKR7CTdJnT3SZeJvJiBYP2gsPDnMTXG5smQqP8wKMgw6Cx4s1Wn	1455	1332	537	12463	18974	jwmofAWrx9hMCYbGUXKyk2aTSD6FT5NRFiKTbejgB6yAwid6MZd	13638	19204	19204	1619395920000	orphaned
27597	3NKbRb7Q5KsHuA59eKoZ99fid9bL7UDrnFVtPEjP6a7EMYqugL9W	27596	3NLQtucjvBktwFBJvgp6XkLr4jWBEv9ESqKPyTXxcFLf5QxdL9kd	632	1256	537	12463	18974	jxZ8ssxLTnDaxw6iQTU1tCQguXY9j3fmJQyjrmYuCThNtDBvEXG	13640	19207	19207	1619396460000	orphaned
27599	3NLofscFYwuMFBKy7Qs3CRCL9o63WgZiKApST8kTcGBhzSNdxmfX	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	606	1049	538	12463	18974	jxKh3hqUHsgQeoTZCqDy5Gt4cGCRkee5nu9FnafGp2RjY3xDGPT	13641	19209	19209	1619396820000	canonical
27606	3NLn9jexJ52iVw6SbdgyhNbaJUMFsmKuS7raMKfbwD8d1aRgUL68	27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	1617	922	538	12463	18974	jxhX6AgoV9RPRocFcjKq3bvuyu4nkkWGa7x5AQNi3VGvCrbeo5z	13643	19211	19211	1619397180000	orphaned
27614	3NKNBzgjxqmjQdWfV6isBRY48e2hCHYhv9ua4ikUS7m1sw8RhL9M	27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	1578	1170	538	12463	18974	jwQMFxW73ZQ1paEp5Up3LyjddEqdmSxPBipqAyDcnREeaPMCGgf	13647	19217	19217	1619398260000	orphaned
27622	3NLmw2YK9thd5QUMSycUBWL6GWWNjwr1Ei36BT4rWchX6sDL14Hc	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1624	968	538	12463	18974	jxZRGMNr8p3wRZucUp2enFsvbdyAMjK9ij6nVKsquA8N2zoGFuj	13651	19226	19226	1619399880000	canonical
27620	3NKCRU8vZ7tcBgga5aMhksoD615YXKF6khbmZWLi5wjSzBzrD5TQ	27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	1419	814	538	12463	18974	jwRPscS3K8yZynJt31G6xLAN1hdu6netzPUQfhP1viK2WfMYDV2	13651	19226	19226	1619399880000	orphaned
27625	3NKTQYZwDjSiayw143RXvjnRWhzESJdA4uQCsb1vfYv6fcRQJjYM	27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	1407	1395	538	12463	18974	jy2Nf1EguwtWv54ETWj9pKXhsPxZ7WG8EtwWPLeTU8kvqBJoidG	13653	19229	19229	1619400420000	canonical
27504	3NLV4UNjeL3nGoVw3yZk8aknnHAfrjhGMkepEGJG4NBz1bwyKNeb	27503	3NLNn2maRSoHigBKiizWeSyhoJs8KDDcyfmsfwWdWWFqMVJfyGSg	1571	1335	535	12463	18974	jy2c4JnWG16W5h9bzDxGraWbMBry6FtZZaUEUknwaAhnoqGRALe	13596	19141	19141	1619384580000	canonical
27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	27507	3NLbZAitNf4cTtPTiH4fn33kKD6xTL5MQ6sLqvdFtromgTMxkUor	1460	429	535	12463	18974	jxrAAmEFhYr8PtmfZVbPrS6TXRmGox4UoZ9YWSc8X2kESp3EgNN	13600	19152	19152	1619386560000	canonical
27518	3NKBV8oemtpt67A5SUbuqhU5EDi1d3pU4oNrLB5SwXbDhh7w1LN7	27515	3NK7XsZ6HnBbWJtyYSECNPmsun9yCiYk2EqAJ7iBtRLb7rLqaFaY	1675	1216	536	12463	18974	jxNcJYQDBJRzf7DhrXoG6NQPSAaPhMKzgg2RhjXC1VpYtoczMn4	13603	19155	19155	1619387100000	canonical
27521	3NKib1yyfMYo2tUvrxttBuouUWz87DyWyJA6Q4yMAVFH96ehPejy	27520	3NLLJCEEeagN53cjhdbhmLoQQtxw8xCeSziaqh7uebEBea7XtLny	1406	1393	536	12463	18974	jwBY19WHxQZjR4bPBcj6JnHpSvrfTGxwrtcK9KYvJKKXV1Es6NY	13606	19160	19160	1619388000000	canonical
27524	3NLraWLvHaatZj733EqLoiEDjxNEcgM3ngZHgutvA2xgPm3b9XZn	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	1602	1243	536	12463	18974	jy3FH2ye2RD1pjCnx1JYXXVszFopioUFL6ZeanZFmpmDwbjLEH6	13609	19164	19164	1619388720000	orphaned
27531	3NLv4hehWbR8CdHwFG3itJhtJrFkAuVrWdnTjHpfLC2VE5e5d6sv	27530	3NKB3xwwmMgsR5UPcKAnroL8NfaK18akgA19ogmPZ86kGoWB5TDN	1406	1393	536	12463	18974	jxwc5ThSd1dnWEDtqDb7TY1XNFCuKNuwcNJ5Dvnw8YkA8VeDfVs	13611	19167	19167	1619389260000	canonical
27533	3NKgxptbwNDHV8WwWgjCxPEjRdtb6tXYEyjZgUKiigztzMGzVoNR	27531	3NLv4hehWbR8CdHwFG3itJhtJrFkAuVrWdnTjHpfLC2VE5e5d6sv	1647	1056	536	12463	18974	jwsTyDXADHHgBNXKfmKKtoaqBYLvUbC2r2zQXjFnpsUQ7nPFRYZ	13612	19168	19168	1619389440000	orphaned
27535	3NKXYHzQsNfHMMaq59PuRjKz5w9F73yk258Z8Ndaqy8SMmSm3KAQ	27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	1546	1339	536	12463	18974	jxLoUbASoZdcrRWRLpgCY793v7iM6m7hmskfMNczgETqtTWsMGB	13613	19170	19170	1619389800000	orphaned
27549	3NKUyRpvfwygVrhz733hYfykRf9BYyCgCyuLquX6erEVNYF97Jot	27548	3NK6Gu64Ry7ot7nYC5q2XisjyywURZGWieZaigf1BcbT1i9JJXfP	43	1064	536	12463	18974	jx4DEtZsUeUBCBJV7BAVysSPdZe3MeG6qMiG93AvdZtWEHWXb69	13618	19178	19178	1619391240000	orphaned
27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	27550	3NKKqCAnfGC9pNV3jU9xi6MiPmLJmpv3pi37CmkPLcGCzRM8atWE	1451	1451	536	12463	18974	jxY8KcWL9aJbdPNCmJfhgMz65udXtYTiKCF4wyW17K6r6DX9ccm	13619	19179	19179	1619391420000	canonical
27578	3NL7Zh5Q11DgNpVyNVV4JLrYUW2FmgRiMKx2EwtLKHGYV8UoEaVk	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1590	1300	536	12463	18974	jwu9DnJtuB3XhigMAs6zjRnob7CY1ZN3JnQS9EjRxiJu9KQATE9	13620	19192	19192	1619393760000	orphaned
27582	3NLuxttxLuLR8qLzueJdVeDVB9p3brbWZVonVr8iUomkH7GQcb4e	27578	3NL7Zh5Q11DgNpVyNVV4JLrYUW2FmgRiMKx2EwtLKHGYV8UoEaVk	1590	934	536	12463	18974	jxcxzf94KSmbwzUJC2ghhTTwCZPcqmttg7CKT3scKe1vpZYnQ6z	13621	19197	19197	1619394660000	orphaned
27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	27556	3NKJKiV916rKpPHwet4k6sGtJxR4FXBFKsdU63ZrRmSj6V7nUHWy	1573	952	537	12463	18974	jxG4MCzu2u74JZnxKqsCzdFgHGEGXPbj9hHJdkxhZV5tEWqThG6	13622	19182	19182	1619391960000	canonical
27561	3NLd1biLtoCVaGJoBfRuNkrHzZxfn9LfvBr4hTRUiFMznT4dx3Dh	27558	3NK3nBrW2XaDBH9uPnU8btdpgKMJbrzLNGvhMK5W23KjHz84vTxV	1542	1058	537	12463	18974	jwf2RAcfdSQnovZRo8oogBotBfU4UfNJmGwb1pyziitw1LNvG86	13623	19183	19183	1619392140000	orphaned
27567	3NLEEfFZRJdtdC6Takha6pjqRSTubzgCJqycqnkB3oRxnwnQhWx6	27565	3NKYgY8uGMUidcJC95xPaLFC7MGZ35mT991JY8zhAHYpHmi4HCPy	1513	1379	537	12463	18974	jwfuhrjj7Ko3hhFvWzA61zaPzn6zNPcjJzwjTDhx4Yu1qc5PC2T	13625	19185	19185	1619392500000	orphaned
27570	3NLnumh7j1Mxjgb6yihz6eCqMdD6dmsoy84kMUEXwTD4TQmKuFdu	27568	3NKs6pF4Tbj11VHSPrp7fMT7YMyQd2zZ3Xyu2TYSimAs7kofapLd	1522	1076	537	12463	18974	jx1Y9hgz5eM3AnAFx1F5MVmAKdxbFKgek3MPbQzbA7m7uNLz2yN	13627	19188	19188	1619393040000	orphaned
27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	27569	3NK89KrumqXWrwwUL75xXjX1qKbCrJpekcky8Eq1fxbTBA9898Yt	1483	361	537	12463	18974	jwxU6myKJqFBDthpjTTavKpUny4r8Y5F7JKT3H4Cadeve7D3tHk	13628	19190	19190	1619393400000	canonical
27576	3NKWa6AuiWZwjogSrSgrpBoa4FV18uiMoqp5n8NFSNATeWdXS276	27572	3NKoLfHQEv2cwBETmRJZRA3zXzwYDDm5V1rpM9sy2oUKTQA4NRzp	1560	1045	537	12463	18974	jxqR6cPpQ8SdTCDHW7kY5nEqBLpXGmBVkXAVo8Fw87ga93rtxP6	13629	19191	19191	1619393580000	orphaned
27579	3NKWppxRC1js7Ec17RmGsTdF8URJ36EwynEaiBV86JymG7MBNkRY	27575	3NLUGWiFJLmm4Qs1U414Vt6KjcHNAqds7UGXPWvsDPZfyqsM3zaU	1406	1393	537	12463	18974	jwGKc6y3PNghpoAEnYpSXhic5DnViYRbwVqCm7CnERMKwmSUtAG	13630	19193	19193	1619393940000	canonical
27580	3NK6UtkweXpzbYT1UgM6jJrPDW7F271FcrvDVwztcsemB8F1HyXm	27575	3NLUGWiFJLmm4Qs1U414Vt6KjcHNAqds7UGXPWvsDPZfyqsM3zaU	1581	778	537	12463	18974	jxkZ9ufSCykQZZUmyQbQ1gPwg5Kh9ScMDZLgqnc8JnvW5wzgsLi	13630	19193	19193	1619393940000	orphaned
27581	3NLQf7YZdKwAQX8DvjEysayssaEkVcgAzMqoA8xu25pjeZ5a3xTR	27579	3NKWppxRC1js7Ec17RmGsTdF8URJ36EwynEaiBV86JymG7MBNkRY	1402	808	537	12463	18974	jwqDEX1yUavkjroXb7FNgyCoUqaG2issh1Ktns2Z6QfNAAZRT7G	13631	19195	19195	1619394300000	canonical
27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	27581	3NLQf7YZdKwAQX8DvjEysayssaEkVcgAzMqoA8xu25pjeZ5a3xTR	1590	934	537	12463	18974	jx2MZpGgTdULsQNnm3v2cs7pmcV2ticWKRmKhPxUHN1epDAey7j	13632	19197	19197	1619394660000	canonical
27584	3NLPPy82ucmJ3yu9tzKY7zYWHhXqNGCA8PhgjNmj1KTkPrBBs7Ze	27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	1447	1219	537	12463	18974	jxp6ypo7jcgejvSFkXhHM7mvE2WqRA436t2ZreBXo5DByQcohG8	13633	19198	19198	1619394840000	canonical
27585	3NL4nDrZEV5SETrgr1fVe6qbKA2DyWT8EpjsnzmyZXD5n4TNXvXc	27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	1474	1329	537	12463	18974	jxwLhix5ifgL2iiKsYAaRpMeYBxifTvx2gJkWWVHFi4yQbAdyt6	13633	19198	19198	1619394840000	orphaned
27589	3NLf4gtU1WUJVsW2tcuodB1h6oovypvG6rGtGzyHh2t2jd4YkovT	27587	3NLZG1Fp6R2Vng3GSHL2SCLNsaosLHXXMWqpQjSk6fUrNPoN2JJ5	1407	1395	537	12463	18974	jwCLMn2DXa2phYNUnzJ6QJWYmap5zgQcmyMxR5hGtFrQ1yqAvo6	13636	19202	19202	1619395560000	canonical
27590	3NKV4iFAoryYL6KWWDVBKASCauryqpSyAnejWSADkGKaciR8tU3s	27587	3NLZG1Fp6R2Vng3GSHL2SCLNsaosLHXXMWqpQjSk6fUrNPoN2JJ5	1534	1317	537	12463	18974	jxcTF2eLEEt1t4HkvxQh9jToQWwnmB9kEPyVJ1zAaScrp1K7hG2	13636	19202	19202	1619395560000	orphaned
27592	3NKR7CTdJnT3SZeJvJiBYP2gsPDnMTXG5smQqP8wKMgw6Cx4s1Wn	27589	3NLf4gtU1WUJVsW2tcuodB1h6oovypvG6rGtGzyHh2t2jd4YkovT	1448	1065	537	12463	18974	jwonNy2DonuSPx7zbhqXTfRDnSBbp826cCRhukiBr81tPH6FjZW	13637	19203	19203	1619395740000	canonical
27591	3NKCe6qFQbiTBiRBXD4r6SW9XQUTM2CJg1fRNRwzFzm5n9Ze3FxC	27589	3NLf4gtU1WUJVsW2tcuodB1h6oovypvG6rGtGzyHh2t2jd4YkovT	1448	1065	537	12463	18974	jxvoQuoi5CFE4gZGdd3M2XSYqH78dtafEeqnMP5cB8RRG2xmYLc	13637	19203	19203	1619395740000	orphaned
27596	3NLQtucjvBktwFBJvgp6XkLr4jWBEv9ESqKPyTXxcFLf5QxdL9kd	27593	3NKdLZmoKHcUbFs9EApvbysoXoQ4waiB2kXBCRQLCpgKjy76EWCx	532	1303	537	12463	18974	jxAizwP4zJz69KXTq5VtZB1yM4qxXbyYM6MCyeTVd7bCQ5n6DCD	13639	19205	19205	1619396100000	canonical
27506	3NLqbG2BNKL4XSrtxADvEnRLkVENcfmnhvRQ7vh8PDCyDXUpbDoi	27505	3NLqCJGJJioGaTHz6mkbEaE7yqeAxGnceY5dKXtiNhFH3Nefh27G	1406	1393	535	12463	18974	jxWi4zvZv4P6c5NpRJrrtJSagywdfyTjonoYN5m81wHgnPsV6JZ	13598	19144	19144	1619385120000	canonical
27510	3NKX6hzL5EZNneRz8UhDWtP9K6HHmNkiBK2tr9VhG4Mh3PLpywHq	27509	3NKY1t7tsSPHJw4x5oEyP13Y6og3o3fE8asxLBA25MwUii8mMhfN	1662	219	535	12463	18974	jw97XeKKwQwtfBnGoJvVkDWixRJ73BdtBCLEHY6V8nVC4TpvMoi	13601	19153	19153	1619386740000	orphaned
27514	3NLNZfUrxa3kGneiZJzG5CXgUSgiPmuzCqTQNEcqxybXKeJuArzY	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	1407	1395	535	12463	18974	jwvLHFqcA434EziVwCxUNX1yRUYu5VkP8FWbaV6VTvr1gFTiR23	13602	19154	19154	1619386920000	orphaned
27516	3NLfNPA8zanrXCHyVoetWtDH4aqeWqQFykoTLNvLv6Pi5jveUPf1	27511	3NLyGDhTmCK725S85fq7ShFDe2wes4bfx7RVf7iBszHKYjZWEvaK	102	102	535	12463	18974	jwtTvbxXwXDQKf6vHKAXMY3meKxXVKrepJofS7Rh96wqUAi6V2Q	13602	19154	19154	1619386920000	orphaned
27522	3NL1DvEgXxvXbQiKmJj3EUUeL9gZCWWfUDPBRGsUNHFh9uDhE9fm	27521	3NKib1yyfMYo2tUvrxttBuouUWz87DyWyJA6Q4yMAVFH96ehPejy	1611	1341	536	12463	18974	jxD8YouHJw4GbY7RZErSfMD2KN2TFSRwWX3pyVQ45SPzAvKq9r4	13607	19161	19161	1619388180000	canonical
27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	27523	3NKF9noQbWpppyKJf99zmXA9wK18p7AHkD4p282jKnFXYRbPXJtj	152	1204	536	12463	18974	jwpD9KYdHD3bjeG4i1dUWfgVAR7Pbr1LAunfbxcu2FDaZ2AvcAC	13609	19164	19164	1619388720000	canonical
27529	3NLSi3fppUdgJY8wsg4abiwv4zn1VWGWTDZsZV8nDwCBKcv6AzVT	27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	1555	1221	536	12463	18974	jwoKesQCEwRt6J4vbK3N6c5bvcK4Ng4BWvaPGTvKPbwquZg5BXu	13610	19166	19166	1619389080000	orphaned
27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	27532	3NLsNKZbfdn4aHR7wHzn6PvjH9VouoPnLgJiTQ6MsLkZzzJuKewk	1405	875	536	12463	18974	jx3QRzYTAcqsv7666QMBpZi1jT3gaaWEXzTbSmaQHUS7F4kWNmz	13613	19170	19170	1619389800000	canonical
27540	3NKBwgPrNskrVvxhpbsufcWN3ayAGtNE5env5JZMg4YKHpFawLHm	27536	3NLrRBh8VuDajp79GNLwyfYP1srB7b2kfH7c9NjodxjfrUryF5GV	606	1049	536	12463	18974	jww2isuRp3qvzmB8RXpdK9wJgBoHMpoPSTQ1fCEv3AHkYzdc3F1	13614	19171	19171	1619389980000	orphaned
27545	3NLZg8MXLhgEfE5mwbemAz9P5QHMHaCrR25JjWY9tWaE7zRTwjhL	27542	3NLoP1WAJTCnzJEjdh4To5RreZYhjMsrpqtaV6NtsS2fA2CMJAGa	1581	778	536	12463	18974	jwYsQvYhJs4kdx5gyGeZnMcCrXF9g9U4usQPyYTQPBVFP3NrK8f	13616	19175	19175	1619390700000	canonical
27552	3NLPBVVZCvuUYTvNT6VUYJnyoZYZASsZMKuf1yKNRnLAYBz4HgrC	27551	3NKR76Qf3prJmEWYKvHwKLB6tgsCjugUcjUjic8kE1EMxGr6m8tk	1440	1131	536	12463	18974	jxC4w1c3Cs4Mb2oe9iGdd1neKakKReN8CUWw7brZaTSdhjpLifj	13620	19180	19180	1619391600000	canonical
27556	3NKJKiV916rKpPHwet4k6sGtJxR4FXBFKsdU63ZrRmSj6V7nUHWy	27552	3NLPBVVZCvuUYTvNT6VUYJnyoZYZASsZMKuf1yKNRnLAYBz4HgrC	1407	1395	537	12463	18974	jxLQ29YYQiM6ZHwBntqDc3ohbYSZtAoSVkNdt5mTBWpH5iU5hpw	13621	19181	19181	1619391780000	canonical
27565	3NKYgY8uGMUidcJC95xPaLFC7MGZ35mT991JY8zhAHYpHmi4HCPy	27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	1559	1353	537	12463	18974	jxWZZ5j5ghBPZ6wHSq66RHgbDR3wzQyWceTwZo7AmJHkemY9cnZ	13624	19184	19184	1619392320000	canonical
27563	3NKrMdxM78RFL67gn5NwstKi5wJBsqq2jCS2wiCorutMLaAYQBpF	27559	3NLptbiHKKQUHB28pPNGn9HpNJD3pT3sMJhan9yKArrTJjxkABFa	1406	1393	537	12463	18974	jwBUCJe7n34YyWsV4ydMESwiHiUvJq6LreZx95A8Ck9zsoWtHor	13624	19184	19184	1619392320000	orphaned
27586	3NLbAMGMADfVGRWtM7zvbndJVZx7nkeZnUm3MHSXdnbijiLrsQpi	27584	3NLPPy82ucmJ3yu9tzKY7zYWHhXqNGCA8PhgjNmj1KTkPrBBs7Ze	1581	777	537	12463	18974	jxVoPwXnK5S4EXax4M82Y2SPyKQm1bFa2MafnJ1yzfhpdwoUDha	13634	19199	19199	1619395020000	canonical
27588	3NKyUsxJ3gwzhax9AA9FdkfBcJR6jpBqBC5mA9EdFb9aZsZemCKR	27586	3NLbAMGMADfVGRWtM7zvbndJVZx7nkeZnUm3MHSXdnbijiLrsQpi	1426	1118	537	12463	18974	jxksN9eBn97cAPD13KAvnvoEUFtVdHoPcVkXQ1rty8SNkChadKt	13635	19201	19201	1619395380000	orphaned
27593	3NKdLZmoKHcUbFs9EApvbysoXoQ4waiB2kXBCRQLCpgKjy76EWCx	27592	3NKR7CTdJnT3SZeJvJiBYP2gsPDnMTXG5smQqP8wKMgw6Cx4s1Wn	1471	1020	537	12463	18974	jwd5JaBKDQQntZmZxNmN1wZfFU81TQx9g1j8PHYY1sHitniVVdB	13638	19204	19204	1619395920000	canonical
27595	3NKcnWZPEHCNdjX2N3asRTyftFxdfjkbLcvTRf95R6e6NmVxDy6R	27593	3NKdLZmoKHcUbFs9EApvbysoXoQ4waiB2kXBCRQLCpgKjy76EWCx	1447	1345	537	12463	18974	jxxssfZEE1K9kLFpeAiXkziLjKy2zQm6RDQ2mB9YzsYucqcUxnK	13639	19205	19205	1619396100000	orphaned
27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	27596	3NLQtucjvBktwFBJvgp6XkLr4jWBEv9ESqKPyTXxcFLf5QxdL9kd	632	1256	537	12463	18974	jxZ8ssxLTnDaxw6iQTU1tCQguXY9j3fmJQyjrmYuCThNtDBvEXG	13640	19207	19207	1619396460000	canonical
27600	3NKo3fHScQuQnY5yjja73UoZLTwaVfbsFwRtRdLcoE874MAivehh	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	1445	1290	538	12463	18974	jwYDGhs63L6ojvsupyP44SUQ28MgnwNwXtW3GxnDYS4NsHJEb9X	13641	19209	19209	1619396820000	orphaned
27604	3NLqftvvBndL54BpddAG3P7xE64SEtGh15oSxeagDPUvh4VrLHSp	27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	1406	1393	538	12463	18974	jxYgpeW8gPQs9q9iYc4N4JgPxbVt3VnCYZKLR1QrjyR2mRULn1r	13643	19211	19211	1619397180000	orphaned
27607	3NLkf9PNoPZo4rDsYcefYngjk1SpxyCBQBx3dFujcKCGXMTByckW	27605	3NKDUK3RDpH5m7KQeP1tFXuD4HbfnPutzLhgTUoenPP71szZ8A4V	1402	868	538	12463	18974	jx21VxKdB4cD75TA84Q3PQ5ATnZ7BGs1wbG7CU4zitFhW9CGThi	13644	19212	19212	1619397360000	canonical
27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	27608	3NLG2GzDpemxTyc9xEwWiSXq513YqwV7uRpYkMGJ6TL9P2kFMXbj	1547	1012	538	12463	18974	jwdseiffdWZXoUHk3KYQkS7M123PsW6dpRKqjsXHyxjdM2b5GB1	13646	19216	19216	1619398080000	canonical
27613	3NKTGQz1f9PQRMcoAvk8u3XHde9Y9j54DD9HZpfKLyQaNjLFg4WY	27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	149	1037	538	12463	18974	jy257LNPv9yrDxUaJy6FZTAH9zVQpNs8jz1apALLia97HpUhyWx	13647	19217	19217	1619398260000	canonical
27612	3NK9S6ixcz8fNwSHX9jF3ifo7jp6g3MZLR4obyCp9KcWLBrFuzA1	27609	3NLt9n4izPoEUdNhAMy6RgWXEHqqnUECEyMiDsbk7WinMJDBneuM	1489	1014	538	12463	18974	jxf6xCKBjw7vsZkLp1soPucjTRqXkpDxesZtjWxYX81qywEEnCU	13647	19217	19217	1619398260000	orphaned
27615	3NL2wXswEcx4X2Er3k8ygY9CUdVpj7qTXkxHuFpAUnycXnyX7PAg	27613	3NKTGQz1f9PQRMcoAvk8u3XHde9Y9j54DD9HZpfKLyQaNjLFg4WY	1406	1393	538	12463	18974	jwqXqxuiqtPrEDgvQKhocVbFbF6v7aJtFS82ULAedn1o686E2bZ	13648	19221	19221	1619398980000	canonical
27618	3NKCEoLSbfxDRVRkZUfRmFu1iTAo2SwJtEHC6dKm1mhpbeNAZv9R	27617	3NL4CTzNuysgroYj8zx51XjsGG2AsE1UxXThqvprKQykxKE7Tv5y	1593	1346	538	12463	18974	jx6BW5cTwKNEvboRt99vBpcNSZY4uU62pX2zi4fRdbdZaCPFtC2	13650	19225	19225	1619399700000	canonical
27635	3NL7CgUbpxjpkp7JaKUAkvx6DVy8jLV38gDmVHQAh8Vu6mTJ3Hnc	27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	1573	1318	538	12463	18974	jxMVxC7FRjhUcnWEoWzvjZp85r3yxySiToeqhXeSZpqz9VYE8Ng	13658	19235	19235	1619401500000	orphaned
27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1407	1395	538	12463	18974	jxRqwZ42D8Wtn8zMKA6sccF4bfstBXRBpsdHMus4sGZwoR7phf8	13659	19237	19237	1619401860000	canonical
27651	3NKxTNn5vy63UahFX4GnP1oZKWH2p7qaxij5SpekuHhDChbhu1sj	27583	3NK8Yo5dsHJCMxqFpyGcqckNFceSQpHD5MZzygNZ3eQGJzeEJNRc	1675	1096	537	12463	18974	jxsYd9MfeeqGdoUNLEY8zoWsDowHLKF4efr6ftLyQJaswWY3fGu	13633	19246	19246	1619403480000	orphaned
27683	3NKT4S6R392WnHzoX1AVkwosvV5Z9Pm95LWRVCwsEKjkPY1wdjnS	27651	3NKxTNn5vy63UahFX4GnP1oZKWH2p7qaxij5SpekuHhDChbhu1sj	1675	1342	538	12463	18974	jwTGARNAa5aB7Cy1yWNSgDH4gKBxi1GrR5hZQeKemvFxK6v7B3F	13634	19262	19262	1619406360000	orphaned
27602	3NLLy2XW3iGSEfsgZSdjYRYcyQJc5uWP7Lf9iApB72HonNAHX67q	27598	3NLMCuLnhQ1LMoRyq8MK1mKoGHBoaNh6BZfSbHmn9uSrnGpnKF73	1439	1279	538	12463	18974	jwtCCXprfXaYo71bjVKoqjoYDzHgAUv8Vzn7mnFgZ8h23pKqqk9	13641	19209	19209	1619396820000	orphaned
27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	27599	3NLofscFYwuMFBKy7Qs3CRCL9o63WgZiKApST8kTcGBhzSNdxmfX	563	1113	538	12463	18974	jxgWfvTBf8c288EZ1k32rghLDkY2sUai5xYXtHSvjCWFWi7Mao7	13642	19210	19210	1619397000000	canonical
27605	3NKDUK3RDpH5m7KQeP1tFXuD4HbfnPutzLhgTUoenPP71szZ8A4V	27603	3NLPB6SK692ZMs3BzxPgZqh6Up3KLEFrdu1oPT34ygxuVybXLGBz	1444	1381	538	12463	18974	jx29FPNQWrkNUqovfAz9ZQd4nzJuHY4jR4MKe6rHb5wJC8yNZun	13643	19211	19211	1619397180000	canonical
27608	3NLG2GzDpemxTyc9xEwWiSXq513YqwV7uRpYkMGJ6TL9P2kFMXbj	27607	3NLkf9PNoPZo4rDsYcefYngjk1SpxyCBQBx3dFujcKCGXMTByckW	532	1177	538	12463	18974	jwAcN6AjQJAurbx5kRAMAxi382BEqKL4ceMWtW6vV8Cduoy8B8g	13645	19215	19215	1619397900000	canonical
27616	3NKsJfTDNyAZUmtviwPC1ac1Jm4o8bt1SFycDsePzuqF9oJv4yuc	27613	3NKTGQz1f9PQRMcoAvk8u3XHde9Y9j54DD9HZpfKLyQaNjLFg4WY	1649	1257	538	12463	18974	jw9pUbZk5KLqmVvrMm5bSsmHG6HbsiJut4w85vp6rQwfRJhPM7g	13648	19221	19221	1619398980000	orphaned
27617	3NL4CTzNuysgroYj8zx51XjsGG2AsE1UxXThqvprKQykxKE7Tv5y	27615	3NL2wXswEcx4X2Er3k8ygY9CUdVpj7qTXkxHuFpAUnycXnyX7PAg	684	986	538	12463	18974	jxZDMiw7GSxpFyEBrEqYdTRouzTEd6T3LYYvsaLcfF5GtA2xwn9	13649	19224	19224	1619399520000	canonical
27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	27622	3NLmw2YK9thd5QUMSycUBWL6GWWNjwr1Ei36BT4rWchX6sDL14Hc	369	369	538	12463	18974	jwyBsFkAqx61thKyCUpWkFpuhiTQexwoovBW2zAit7ZCdFpZEXE	13652	19227	19227	1619400060000	canonical
27624	3NLaEeGDjFeye9Hzh4af9ASCUbqjA36hMR4Tp69ozBfem68X14BP	27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	1546	1339	538	12463	18974	jxPUbUU4ZTrJRiDAcnAfRGJxz7wewh3LEma9CBj4s1QAhYHimvN	13653	19229	19229	1619400420000	orphaned
27626	3NKPhKBmX31e64hYNdKwde63uAge9CrpEe1NZki8LwVcUByLtnbk	27623	3NKpQ1q4BEU78v2XNi5Din4tGrUkDMh3gDNaAMbXU8cEQS1djzE4	1637	816	538	12463	18974	jxLhi8a8dJt3n8zPL5FuR36bscRo7KxSARb86aqPt1ieFHX7u54	13653	19229	19229	1619400420000	orphaned
27628	3NLY3Fcpct6L9qQ1PGJWb2BfSS1PwLrPfpFwEZJwkdGGsZ9ZWHro	27625	3NKTQYZwDjSiayw143RXvjnRWhzESJdA4uQCsb1vfYv6fcRQJjYM	1581	778	538	12463	18974	jxv4egQLukMHMPL1YC38SeUYTzm4aabgk8zkoXNuPft74w2297X	13654	19230	19230	1619400600000	orphaned
27629	3NKzwmRpJ6N82wADh7cCRan3GazfqdNkEF7KArHGYgokhwRDikjL	27627	3NLj4bY8xfbUsRa1V9PmzbP4yPHcrvn6ebuTP38NnuBJAtzjCfVb	1407	1395	538	12463	18974	jwsN7Gbr58TuFZMgDHXoKJMYPhFEYrnM9bPMUCZrzLCJuUiYBA1	13655	19232	19232	1619400960000	canonical
27631	3NLSdNqvv8iL35WgpFjqjuWTn6vEDvC8axqUVQT1cYRqMyENNz2M	27630	3NLfwaGKGri5RaYuTVy46xefZsi5MP8DfaLxgGthkQyv9zjWMfUR	1406	1393	538	12463	18974	jwiQiNRnd5jY34JE2o4vsAN6suXXxZoBfoorTZVW6N6xuyjaUWR	13657	19234	19234	1619401320000	orphaned
27633	3NLWQ47xNpdxsg9sg1m2zPTarKo45Y6SZBxGCXChTXmMJppCofxN	27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	1406	1393	538	12463	18974	jxD69yNwzFr6gGPF3xS3VXWnZ1q3hLpWTkDdMBVpzRs8cEwRQ15	13658	19235	19235	1619401500000	orphaned
27636	3NLbJvRY5jz4QH68XdQdj9C3BdXGXvQg8KEobsSx7zV4gXnPAgDx	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1523	1075	538	12463	18974	jwMhQtiDD75eLKJ1k2hRE3RDYg3QckCZVFEj3pUKH5tf2tX76Mj	13659	19237	19237	1619401860000	orphaned
27639	3NKS9xyvAgEUFjXdaB3AFzY6aAbv4SgBrdNLTJCDwRH11zAjELVN	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1523	1075	538	12463	18974	jx7cAgSQgZuBRkFBpajs31rnqrgzzRjMw3xFc48rYSW9FDCt3Nu	13659	19237	19237	1619401860000	orphaned
27641	3NLTsfpbgq7jq9gYeGfpV5HdUjbFQPbPbyBjnwFFUNimMKaFt1UC	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1506	1247	539	12463	18974	jw9uZyfXSTNV1sgcDT9UGexXFCmXXGQoGfxJEYVbrGPUyEUt57x	13660	19239	19239	1619402220000	canonical
27644	3NK5kGFW4jgAy7gabsJHK9H1aNXZoQ9LHajeuswzpzUVGwXybpQ8	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1506	1247	539	12463	18974	jxQJ2z3oqeEbpKM4brR4mZmtLh6nsto4KxXck2wmABc2iyDwaAL	13660	19239	19239	1619402220000	orphaned
27640	3NLMnR8BhS3ikfgAqnKmKRtP8fCcXKjoRQE4izVC83NFnqdGPvZn	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1407	1395	539	12463	18974	jxkoGi8EitUnr4Yw3wmegEQXxDWzZaC4bz1VWfkVsSZH7gGReH4	13660	19239	19239	1619402220000	orphaned
27647	3NLqaWotFS6igG1zyBxSFXaDdjqeYWK9gm3BEZ6PGnffQuQUnQuZ	27645	3NKdE9SVSxWXWNauLZVdVj4Ti76xs1ZhFYWgvoGUtELaL4uPowTr	1503	1277	539	12463	18974	jwHYwensdw6bAFvRn4op4L6pg4iv9mYrCGQs7MTss3wLu3xCASW	13662	19242	19242	1619402760000	canonical
27653	3NLivUazFC2X8Z7kSR5fwUbSg5UM33j4MjbY2ERmPeGpe2Z4fk2z	27650	3NLcUA6u2hpPrarm3iZHhsqkiQa9uJBSTjXbC1n74eqJKB3GbR6P	1407	1395	539	12463	18974	jxE8ukBnzjQhEmYD94SiVDqzaRyr8Cqyf2GMWKoRzA4NLq5s7Yq	13665	19247	19247	1619403660000	canonical
27658	3NLssscgusjmBih76RRv23wa3emK4UdpKqjH6CFLpztpKELhRRDa	27656	3NLMUo9WS2X3dKnqsNGeVkkqaTNnfDLoBFVhsbPHjW61vhBdXVWn	1657	1344	539	12463	18974	jxJ2bD7i7Z5GtNwP3bAXMe2RMVyAZJVcXHjpGRUPdQodxj3w5zB	13668	19250	19250	1619404200000	canonical
27676	3NK7mrDRLwAi4gtUkd34STVZEvideXvnT4vXdAu1nbB3G2Ldd2WX	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	1501	1360	539	12463	18974	jwZxaPj8B3LEPRaxtviDPgvpgyi5idR23dXnRZKzM7K9s4cYxAr	13674	19258	19258	1619405640000	orphaned
27672	3NLtSaT43c7VBbYyAvYEBUwysqHNU7K4ccibEKzHDsPXrgTZymVg	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1627	1385	539	12463	18974	jwW2f9CdCVTPNMUAFqYp8gmHGrgpdrU4MXTjg3DFLwtubdfQrbW	13675	19258	19258	1619405640000	orphaned
27678	3NL2kDTMXVgkNa3NLEkyjXei8Q6qNomzr7JQWKkUshK7evYvpFMD	27677	3NKUiAsMdqYLfjT5whnTA1uXgjWEjWh7gPsFAxASxfSH6LUKXrnM	1406	1393	539	12463	18974	jwQAJgvk28vgQkBVJVrD6nYVrUhrd5WPBUUh2VVKkhAnjZK3J4q	13676	19259	19259	1619405820000	canonical
27686	3NLhDndMzRuWsZnczEwvTC2ppc4Nf8xJiXqVkPQkHqqCLbQMovXe	27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	1541	1298	540	12463	18974	jwbR8aW2reFegjK9vR4UxnDZUfYjNV7X7hJZRHg7BAAC9aHYjyR	13681	19264	19264	1619406720000	canonical
27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	27686	3NLhDndMzRuWsZnczEwvTC2ppc4Nf8xJiXqVkPQkHqqCLbQMovXe	1637	816	540	12463	18974	jxiFzLe7AZqSda84wrSnqyTRwnBZmfaheVSJbA4BdD6jzUK8CgT	13682	19266	19266	1619407080000	canonical
27720	3NKaS6TBRbAQbcB2tba5FUwYM2KiAGQgRBp2ixBj2iA6wHRod3Nr	27525	3NLPG2WfLxtMWgPCkY7bYMwPX6uz6PAfDD7pthR4Sr5JMcZB3TLA	1613	1349	536	12463	18974	jxQUpKH9sm7gV5JuHuDHGGyMzhxjRoLjuuduiN95Guk4jfAW1eE	13610	19290	19290	1619411400000	orphaned
27627	3NLj4bY8xfbUsRa1V9PmzbP4yPHcrvn6ebuTP38NnuBJAtzjCfVb	27625	3NKTQYZwDjSiayw143RXvjnRWhzESJdA4uQCsb1vfYv6fcRQJjYM	1607	1348	538	12463	18974	jxgM3CihvxMPy4Juia9wRMuw5xq3Qsav7Fh9VphPBPDoajsN6YV	13654	19230	19230	1619400600000	canonical
27630	3NLfwaGKGri5RaYuTVy46xefZsi5MP8DfaLxgGthkQyv9zjWMfUR	27629	3NKzwmRpJ6N82wADh7cCRan3GazfqdNkEF7KArHGYgokhwRDikjL	532	937	538	12463	18974	jxWGjB2ofB6T8DGyCxjKbHVxM1AmKqBsUTVLxKUyVcdwUD5Nttp	13656	19233	19233	1619401140000	canonical
27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	27630	3NLfwaGKGri5RaYuTVy46xefZsi5MP8DfaLxgGthkQyv9zjWMfUR	1460	565	538	12463	18974	jwZWTBZ55cBHyUXHvccpzTSEgTQwzpmECrxoq2Pbcco3bVJX7Xt	13657	19234	19234	1619401320000	canonical
27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	27632	3NLXfGGLU8vmfQk57z2JdXZqaeuSgXBg9rH9Ra4fksaMqt1XiN6G	58	915	538	12463	18974	jx4tn8P92wHt12e6P8wjidzGwLL73QTp3FrH21P2UJtTHvnqR3t	13658	19235	19235	1619401500000	canonical
27637	3NLrJzXicNg4YoBQ12fA9QzZ9wt6aFp9GaZDDCVMY8ZVUhwD2EeB	27634	3NKPcbiCoefKu5KW713TNmxtjyUforY5PSeFaDDt87oTUNeP1gG4	1523	1075	538	12463	18974	jxFhTUMgtFJ1ButSt3cc9N12F3TKMyoJqs68W9Gs11wXVNCKRkR	13659	19237	19237	1619401860000	orphaned
27642	3NLPEPJPfAkTeN5nvrd4HNUHxCbWhTY1ZkirJAaZgKLz98GNmouq	27638	3NLoRkeTxTiLTENdvMd7mGYzh4wmYSdAT6jEuoK9C6dobbguq5W8	1403	31	539	12463	18974	jwvrhmTTt2PtVCDjxyLLRPG6efCfQvFgNYU5SEr5eMAV6iWKiWh	13660	19239	19239	1619402220000	orphaned
27646	3NLMasZFX5jtVG6sw8ckDpg8t6a6feZR6WKHNR63TJsmYA1VVonM	27641	3NLTsfpbgq7jq9gYeGfpV5HdUjbFQPbPbyBjnwFFUNimMKaFt1UC	1649	1383	539	12463	18974	jx9GYUXDHkhatZkQZ3PEsFpG9jHtZAJLBNzvQfMP41yd45exw1m	13661	19240	19240	1619402400000	orphaned
27652	3NLA1gzY1jkvzb5PFsh9ExBtfqHLW26MBZCUZcJ84aE5GVGf9YCo	27648	3NL5zauadf8w3bZusGrfP9aMepDoXNtiBvQcXWGpfGdD6R2k6Asa	1650	1375	539	12463	18974	jwvHm811JznaBC1ymqKWZDANC6XFyVAo79SwCwn4hkj9FnhWpvr	13664	19246	19246	1619403480000	orphaned
27662	3NK627jgb9ZLBauFoAPZh8uqQMS15ZVqfvniW7ZcGbs9j8oeGLLs	27661	3NKyYVkZbNpKQcvDrBkEVN9vXQqP7zFiazCj7jvCi7Zo71RH7gFD	1403	824	539	12463	18974	jwGYxCyBndp9p5TjysTf3gZNB99FZUJ9CNUdjx1xeN8no9eseFU	13671	19254	19254	1619404920000	canonical
27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	27662	3NK627jgb9ZLBauFoAPZh8uqQMS15ZVqfvniW7ZcGbs9j8oeGLLs	1671	1365	539	12463	18974	jx2CFo9Tu9QFoQgyxnErxPZK1jr99mXmEByK45yuZVf8WyKRkbv	13672	19255	19255	1619405100000	canonical
27669	3NKU4ZyXCXiQrnpxvWGJRVykzdzEpzZXBzL1ogJywrchSFkk4gRP	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	149	1283	539	12463	18974	jxTJ7e5Arhx3EbApinuLZRs4z5F7mW6ygqZ45SMwgMNZbFdDx1S	13674	19257	19257	1619405460000	orphaned
27677	3NKUiAsMdqYLfjT5whnTA1uXgjWEjWh7gPsFAxASxfSH6LUKXrnM	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1501	1360	539	12463	18974	jx7rJj68fL4YuUU9MniDZGYT7oSQncGmLM5B8AvB6UXeVLkaZ5a	13675	19258	19258	1619405640000	canonical
27671	3NKACnc76jWYYiEUEDRMd2Ji1Sj1LUXoP6pzZKEaiHq97epRiPwr	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1406	1393	539	12463	18974	jwL1h7HbEU3hrNAAD7gEgjydwT9cKQZW3V6TymnnnNQ8zn74x9V	13675	19258	19258	1619405640000	orphaned
27682	3NLTsaqo3bkadXNEyN9MBSNWWWn491VcT1FtdGacJawV7Xrj3sS4	27681	3NKjxZrKhbzW2AbdhFNw2SuPbyc2izaeayvgHhJ3iZtpHfFMguca	1675	1342	539	12463	18974	jxneqAHZFnCMGwzjqddUtQchsKRQ58TWcUL1rTMf5Nf3Ko4JqC3	13679	19262	19262	1619406360000	canonical
27687	3NKbxFjoJnCLVtGmZ33xx4RKHA9xuYLvhbgovopHJ9haWCsVYTxM	27686	3NLhDndMzRuWsZnczEwvTC2ppc4Nf8xJiXqVkPQkHqqCLbQMovXe	1402	884	540	12463	18974	jwchVjuLcH3DfSEhExPdxRigBNDFgYnPxAgbSNuQPuTA3dvbXxn	13682	19266	19266	1619407080000	orphaned
27689	3NL5ExH59CBubuscrZrWY7cnuSbUKiGQ1KmCP6WXjeh8puysd8dC	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1511	903	540	12463	18974	jxybvxb6Q7vpNmLhaS4cEbNB27x21BEkyjsg8q7P9aKRggW6MGG	13683	19267	19267	1619407260000	orphaned
27695	3NLbmEN3GLzsLsh29gqoya9xv1hCmxckKZA3dSARamDXoeNTKcL9	27693	3NKubvozw8WV6iok377chQaDEyEcUTw6LZarGyGoPfKHbYrMkyJS	1483	893	540	12463	18974	jwkQ1mPyntQtxBroykdtaEy6BaAcuXtsg8fx5ecf2GxvmwPkVoH	13685	19269	19269	1619407620000	canonical
27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	27695	3NLbmEN3GLzsLsh29gqoya9xv1hCmxckKZA3dSARamDXoeNTKcL9	596	1180	540	12463	18974	jx62ZACJEun7eSYsjjpAxvfneCaf5tkiiNtuhZ38mWGzmnqPrpo	13686	19270	19270	1619407800000	canonical
27696	3NL7C3oek2XpQM3DQNAQraZD7eDycT9MzmLg77Vt2v8NAvMssX2V	27695	3NLbmEN3GLzsLsh29gqoya9xv1hCmxckKZA3dSARamDXoeNTKcL9	448	1305	540	12463	18974	jxNmwNU1s46AB1YwqyANKJhhE6u5JGG4AFDEZsGY82947MqXrVz	13686	19270	19270	1619407800000	orphaned
27701	3NKruj4E1MmAjAzL3YphNkzsfNPuX3UuLKYTHkJBHzPyzmoxbNJe	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1477	984	540	12463	18974	jwzWGq4j4mf4NBgXae7gXHve7r3CRiijKY2jASvU4NwbpZ1QHTv	13687	19273	19273	1619408340000	canonical
27700	3NLFQMnDN3DFydVTSXHnLV53cpH7ZMSMFMBcxntezKUqE2XvPP8A	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1405	857	540	12463	18974	jwCc9fxtWHo5UHWM79xVB6sgaTqVCgWZPu48PtY48ksKFpRw7cM	13687	19273	19273	1619408340000	orphaned
27705	3NKaRxfjUfHdoMmcmjXvaKZWj6muWoMFpZHNj6VX24WgzqBYsqrk	27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	1406	1393	540	12463	18974	jwXNLYGme2jN8ozNGL7hmu6dxwdJfkesyfpKZ4fU5nfEZxG1TRf	13689	19280	19280	1619409600000	orphaned
27707	3NKqLAYUzpNrnM99cpXGWHaK6VfFe5jDJ3dSxAj3TcaVqwksgVw1	27704	3NL2spwMnvm95hbade2kDa85tkzYk8Fy1JNwMmQAvmKkymDCeGA7	44	1079	540	12463	18974	jxVkEnfLR2WN8R81XHtw63HjuDq5HcvDknnfNo8upC2NVmf8WRN	13690	19282	19282	1619409960000	canonical
27709	3NKAcSCxPgg6WkHYdERT7C6ckSBQrah6q6XAaUjGB8AFpd7HshxL	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1406	1393	540	12463	18974	jxTN75tRUGHuFJfpZXMGnJPPvn6Czrp4NvnEKqjWbTtSKuztAAw	13692	19286	19286	1619410680000	canonical
27711	3NL59SVe1hvEQWAeknv5zMe1EtszGuNQbP9sC1bnwBW2d3jzRmBG	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1651	935	540	12463	18974	jw8qELsuD9R9ssQHd9kj2f7aibtJqtvA8YXGEUkMaqsPBftrgUU	13692	19286	19286	1619410680000	orphaned
27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	27709	3NKAcSCxPgg6WkHYdERT7C6ckSBQrah6q6XAaUjGB8AFpd7HshxL	1407	1395	540	12463	18974	jwsj33zmgcv8kNgCJucae6q8HtZBZ29W1At5yAy7ydXdFXk6xmq	13693	19288	19288	1619411040000	canonical
27716	3NLfY6oR2kuGT6NUXF85eHYTvG88NyJQPz7kttwNEeriLkG32dok	27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	1624	1334	540	12463	18974	jxvqX2mriPdWjxoNWpECGhNnpFrqvyFk4n5cJB8tibiDFnHmred	13694	19289	19289	1619411220000	orphaned
27718	3NKjTRnj5B6YAuyDSZfnHcbq9z4FcFpwhUdLFZ3fqWqatFewGSRV	27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	1613	1349	540	12463	18974	jxQFFbK7r1wax2weN4ssWhmxyVyuV66cthLgHzyEQRb4P4sDtLZ	13695	19290	19290	1619411400000	orphaned
27648	3NL5zauadf8w3bZusGrfP9aMepDoXNtiBvQcXWGpfGdD6R2k6Asa	27647	3NLqaWotFS6igG1zyBxSFXaDdjqeYWK9gm3BEZ6PGnffQuQUnQuZ	1647	1302	539	12463	18974	jwKdREAifwj6MvLHXFXXUXxQd3QSomqtbPrxbMgPrXCTR3i48Lc	13663	19244	19244	1619403120000	canonical
27654	3NKt3LYDMXW1qw6NvDfAcCU5weKwDiWhATjHn7FpenHVp6SEmWYx	27653	3NLivUazFC2X8Z7kSR5fwUbSg5UM33j4MjbY2ERmPeGpe2Z4fk2z	1444	1381	539	12463	18974	jwPFU5yyTgw9vABayjRUFRdiFo8GiLKJ4FEt6nE8z9SFy684jsb	13666	19248	19248	1619403840000	orphaned
27656	3NLMUo9WS2X3dKnqsNGeVkkqaTNnfDLoBFVhsbPHjW61vhBdXVWn	27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	1405	889	539	12463	18974	jxaTVyXSrEGgczcD1nigkcUPJU5gzbi1p7r9uz5qBHWGLj1F5BD	13667	19249	19249	1619404020000	canonical
27659	3NKhNoDa9xvcgyzwagGrRqaDs9NmLk34MyYrkCwF8LPc24p6bury	27656	3NLMUo9WS2X3dKnqsNGeVkkqaTNnfDLoBFVhsbPHjW61vhBdXVWn	1668	1124	539	12463	18974	jwX7n9Qa9xYpirMtx2vWqmJAeN8AKM979q5qwwScSUZHe2pQ1x2	13668	19250	19250	1619404200000	orphaned
27661	3NKyYVkZbNpKQcvDrBkEVN9vXQqP7zFiazCj7jvCi7Zo71RH7gFD	27660	3NKK9dNTktgF84463LawaJY5wehXTtZMbMiUpsrai5BrxBCTpwZB	1578	1296	539	12463	18974	jwpJS5YbrUtWd6cpRyXU5BgaYqUwARmFwMk4xzFMwBpLTBMyv6v	13670	19252	19252	1619404560000	canonical
27666	3NKLqbcChVVzW8XsveJsRpitc1EJ89w2AfEmtLYjehka19w5b9mU	27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	1652	949	539	12463	18974	jwCfgep5zhUjkUYcJGnqBVcc6fLUgRbBCU9Sx2EytzZygR8vTcL	13673	19256	19256	1619405280000	orphaned
27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	1445	1290	539	12463	18974	jx6g3xwkVfbdWkNax8q2wvTKfTFhREiQrF1LqFv929o61yWz6zo	13674	19257	19257	1619405460000	canonical
27673	3NLVDRR4zPcx44eKu8LUUACr4AZT3L2tStn4AgJZF1N6diXf7XBm	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	1405	873	539	12463	18974	jwb2FNkXyx3sFaMyUwg46Vh3k7Avt19Ufkj5zXqoJ6GmoxptDas	13675	19258	19258	1619405640000	orphaned
27679	3NLLjJ6j14iqcHoC3RVK14jQmdxcpbCNUiVJjqimeRZvPJBG9h22	27678	3NL2kDTMXVgkNa3NLEkyjXei8Q6qNomzr7JQWKkUshK7evYvpFMD	1447	1099	539	12463	18974	jxE47xogyvFo3FzfMM4AdY2bxjACbofwJJtYcGxvDsYfUu4xQmL	13677	19260	19260	1619406000000	orphaned
27681	3NKjxZrKhbzW2AbdhFNw2SuPbyc2izaeayvgHhJ3iZtpHfFMguca	27680	3NLqfdfg1WTiFokse7WmBGwNvEaniDTKPezqj3sqo4nVhHndpcbx	1490	123	539	12463	18974	jxeXPWNpwj9eosz5K4ZPzJdWuNGTa1qAggnsMr9daJAuApieH1Q	13678	19261	19261	1619406180000	canonical
27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	27682	3NLTsaqo3bkadXNEyN9MBSNWWWn491VcT1FtdGacJawV7Xrj3sS4	641	1090	539	12463	18974	jweh84pktWK8P4EVzBHcyUdbFLtSFvtbBYEwzkDfpVsGBThCezx	13680	19263	19263	1619406540000	canonical
27726	3NKB7TMRthAfkBhFJP4wLr51nJS4WSZusttocyguZ3iCmSXJGmez	27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	684	1352	539	12463	18974	jweh84pktWK8P4EVzBHcyUdbFLtSFvtbBYEwzkDfpVsGBThCezx	13681	19294	19294	1619412120000	orphaned
27691	3NLk4m1EJCPtwZgP5jcrFFfHNhPvT6eEhJ1tfJvigkWVuwam8xAY	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1511	903	540	12463	18974	jwCMQEtFYVPp2wXKdqvqkQWs7SB6KC7FCGPPrHTj1S5kGC55amF	13683	19267	19267	1619407260000	orphaned
27693	3NKubvozw8WV6iok377chQaDEyEcUTw6LZarGyGoPfKHbYrMkyJS	27692	3NLZwQqQs2pmzVXdhfGdEBuUAHo2hsjM8x5eXThULcuryno9mi3E	1483	600	540	12463	18974	jy1zG3BXmD7iic8evWBmdrCUYY6DpRWKUo9nGZUBcDzKKhQ7K2S	13684	19268	19268	1619407440000	canonical
27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	27701	3NKruj4E1MmAjAzL3YphNkzsfNPuX3UuLKYTHkJBHzPyzmoxbNJe	1637	816	540	12463	18974	jxQAGrZk95fx1xSvXCtMGqPxUUtPMBKHA72NcwjgKbWiyCeAutU	13688	19277	19277	1619409060000	canonical
27704	3NL2spwMnvm95hbade2kDa85tkzYk8Fy1JNwMmQAvmKkymDCeGA7	27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	1407	1395	540	12463	18974	jwsupRDNJuViZHiQvQiTm2tP7pdmpojVC2QdQLr91G27DMCUxqY	13689	19280	19280	1619409600000	canonical
27706	3NK5NExtiNSjmgt45mNdFp5eEkVoQvmY92dKvyCFiNKyuiADTLDa	27703	3NKhowZj3XWYfCoGpxATRxPJDdFVuCm4ZEEA39tfW3vqk96qmJLg	1559	1353	540	12463	18974	jx4sPcyaEqXaYu9PbPvC2zJeSrY4z31nGuBsVi98QcwcPS1RJLE	13689	19280	19280	1619409600000	orphaned
27713	3NLTqzNPc2bpfGHewSktgrzMRTWeXRhagYyJhHMVGHCzEngMQxkh	27709	3NKAcSCxPgg6WkHYdERT7C6ckSBQrah6q6XAaUjGB8AFpd7HshxL	1483	878	540	12463	18974	jwTdjCQb6dJEHEAJ9cz8eNv69qUX2rCBwwC34nE3bshxiFRf6dv	13693	19288	19288	1619411040000	orphaned
27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	1403	31	540	12463	18974	jwEz5s2Ert8LvVhgNqx9d9WaC2SavvbEPdLU3rFoFSQD19QnFZL	13694	19289	19289	1619411220000	canonical
27714	3NLLuGysUXsJ7a5HXokTkkuyB72VsH6rY5Gkm3A3HGbsuW5stAaM	27712	3NKhof68MVak4DS31AYQSaC5o3XnmVpxJSUjhgAJBwm4aq5JJWSx	1405	905	540	12463	18974	jwb3N9hvWESBAZVtWaunpGMyL2kL7g4EAC5XSuX34iRGtXbJm2m	13694	19289	19289	1619411220000	orphaned
27723	3NLuMJD4f5srRF7FV9dwqaGy1bB4nRNBYz25bXQQCNvuDBW7EEUo	27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	1633	1390	540	12463	18974	jw9yvdRKADLxVSf5uF6tuFX9S8ZR3oReZNVG3kG6pUX4gyZBtK7	13696	19291	19291	1619411580000	orphaned
27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	27721	3NKBwa8paxJYsSRLNt6fc19KGnUdx53rmRct39jS9Q7tUabt94w5	1406	1393	540	12463	18974	jxYi9q5aKNJdobpcDasya72EmwrrYFbb73VD88t3PHDSNWWLBHA	13697	19292	19292	1619411760000	canonical
27731	3NK4mULKF3LzvnW9iw2yAtqvxfutpPX9vg2DeD7BbHDdiL5QD7mR	27728	3NKf7Fguo9CA4iAdvb8zvidh6dyhsUAvpHWNtHP88GHsoWnxm24A	1637	816	540	12463	18974	jwLppqfRMBaaWuwS7NVD5NRazbLxp7mA62cTiJ2nhdtu6ujkDuC	13699	19295	19295	1619412300000	orphaned
27733	3NLJ1ET6feDptgcu21EwcwpwizD3FmqFCKHXdgaWrvSuoBrvJNfi	27730	3NKVwW4cLX9d1TR8To8yoSsookrPJQCVe4JomV8dSXRqYDdUEDAd	1624	1334	540	12463	18974	jxAKcJ2kDR13G4XJEpYRLLJvjQvX7FTfM1MyaatW3ox9UHRHLkP	13700	19296	19296	1619412480000	canonical
27732	3NLVFk6UmC7JbXiWt4Fnz3q6Ph9ptu63ewN7MiGspysctxn67Vvi	27730	3NKVwW4cLX9d1TR8To8yoSsookrPJQCVe4JomV8dSXRqYDdUEDAd	1407	1395	540	12463	18974	jxfYBNM5GtRKztWUSswgzKothnp1d6giE3apt5uApsAHgLouxzN	13700	19296	19296	1619412480000	orphaned
27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	27734	3NKceus2pFNtFFvNSnvtjg4N6s5zMZMP5FEsS6RqdkvuGfme7vgb	1637	816	541	12463	18974	jwtQWoGKqxfKy4jGUjQJVRJkg2urriGx1ughXvevUMpU7qxA5H5	13702	19300	19300	1619413200000	canonical
27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	1590	324	541	12463	18974	jxB4kQUSPRsmK8dMm84PckS3kKBHG5MEYxhSsy5kseRL7k96rJV	13703	19301	19301	1619413380000	canonical
27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	27739	3NKUpVPxEjjb25u5hKZYkKVn1YrGAsYZQTQWK3krKFpEgdBX2GNv	1445	924	541	12463	18974	jwtxbjZPaBpsmgoewkhVhWeyUbQFt2iHpBSEh9dgdKadzoyUX2p	13705	19309	19309	1619414820000	canonical
27744	3NLp1LXChyMWtWpSPx5UaZ8kJrhSV58JmB6ewGsgqnKNzKamjuiM	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	1523	1195	541	12463	18974	jx1Ru1vcuBkDQYyKK1b1YXvbaKGPeeQ4Go7ovRuEZYAq1oyhwZb	13706	19310	19310	1619415000000	orphaned
27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	27653	3NLivUazFC2X8Z7kSR5fwUbSg5UM33j4MjbY2ERmPeGpe2Z4fk2z	1490	908	539	12463	18974	jxjonvw3U5hjYoBWHn8wsEqABHwM1mvGAGn2Y8MbUMtKFVwuu1h	13666	19248	19248	1619403840000	canonical
27657	3NL2kTPbVMccxdGGS8pGb4ZYGnTR99Fet8gFKt5XjcTJbiiJb4ag	27655	3NLxBqNwYeFAgFnjP1W5eFPBbThVw7NmMV5Zq4PNoeqREN5C3sky	576	989	539	12463	18974	jxv7uaiVfS1bMhhsEufiJtsY1dyd27kVoeyjsWdd8YvDg6AJm11	13667	19249	19249	1619404020000	orphaned
27660	3NKK9dNTktgF84463LawaJY5wehXTtZMbMiUpsrai5BrxBCTpwZB	27658	3NLssscgusjmBih76RRv23wa3emK4UdpKqjH6CFLpztpKELhRRDa	1513	1253	539	12463	18974	jxysU4nDiqHVXy37sfJDX7WnYVMeKVYPkuYmJgVvg3WrJNwBMa5	13669	19251	19251	1619404380000	canonical
27663	3NK4gu3vLDZemgxWF9dmwLBts4JSLWbUF4X3QXyU6J2TeHM11a3K	27661	3NKyYVkZbNpKQcvDrBkEVN9vXQqP7zFiazCj7jvCi7Zo71RH7gFD	1483	1030	539	12463	18974	jwqn9QRkgJfvkVUdgcgLwmgDh7BUzKiJn9g5rsShaLfNJdiS6XK	13671	19254	19254	1619404920000	orphaned
27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	1407	1395	539	12463	18974	jwL3Rx4eF7GXgAz7FAp4RgxmAFxAq53zUkeR4dAD7LLcC4kgrpF	13673	19256	19256	1619405280000	canonical
27667	3NLjMLPBRNZ5pEht1D2yF1yDEaabnszptiYfNChtcaHQ5xVyzxh8	27664	3NL1aBdBCzQjJd4o1eFXx6XgnTzCdRTGf3T2fgAg4zAdpSmHteeD	1559	987	539	12463	18974	jxUk4VDU9s6kBZfM3jDzeAEhqiDxKJYq5LSzKLQQ32Rb9BuvesS	13673	19256	19256	1619405280000	orphaned
27670	3NLvQek82r2ry5kjEo1PxYG1evz3QnpzEHEHFEYaGg1wbfGDpnQa	27665	3NKfKDswxfteJ1wZYX96sXc1JZhQmiye4ncfR1ud8qJMSeYmqdHj	44	1325	539	12463	18974	jxEX3XvoixqDfUquZPwGxAo1ZVWx8yq6HaiozdEgMiW61XuKgon	13674	19257	19257	1619405460000	orphaned
27674	3NKeLnaq9tbrNJ7n9CshKhDCTmMtoWkGup6gMtEorTTR1X6ujGDb	27668	3NL4V772bXMbYSjUtrisgyypzXJmSDBXq3DEnkgo9ezdjzVvw7W2	532	1177	539	12463	18974	jwidk1pCwAXDqwVgW6WizuvWSA8o3TbbD9rxVnqREWiArLtPKrb	13675	19258	19258	1619405640000	orphaned
27685	3NKsmZhdifhbVQVu8WfEABNCHGym11EXtqg7ZJkMSiKBixAGbJJ1	27684	3NLbRmFhJFh2HTAWqAFrTkCdWpoBjPHPej3UpQ7g3eEEGumfHZ3E	1541	1298	539	12463	18974	jxX4wCGBq2douMyHs31F8nApvYWakAs2cbRJPti1iMjDMAgnbXV	13681	19264	19264	1619406720000	orphaned
27692	3NLZwQqQs2pmzVXdhfGdEBuUAHo2hsjM8x5eXThULcuryno9mi3E	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1581	778	540	12463	18974	jxMbuZUBUGb4K7rY5t4gVovQJsoUfkPTq13BpXU355nqqZ25xF6	13683	19267	19267	1619407260000	canonical
27690	3NLobKgybSshpofCX5dqgcUWL5QiBy6d1xZckbnwPgiDUAbSV6J8	27688	3NKDGpgGieDS5iapTBQRWwcnC9AtJQdP9qXaXWdwV7kwS9JoCKS2	1599	477	540	12463	18974	jx8JdwAq2azHPTChuouk1Xmr9LwGD1syNzU9TNQbuv24DwQzcxR	13683	19267	19267	1619407260000	orphaned
27694	3NKUeSg8Ktr7FFSMWG3SqfMjKUEtyrD5wGuPQqfxgqck5tmkj8T8	27693	3NKubvozw8WV6iok377chQaDEyEcUTw6LZarGyGoPfKHbYrMkyJS	1406	1393	540	12463	18974	jwr8qfwMo1VFA87XKb9Bce4CFPGE1vyfRoUwqp67k83YX9WVjYz	13685	19269	19269	1619407620000	orphaned
27699	3NKjRHqYJicWXRZGezSiQXhx9FdXVnsztT9xB1gPYxShex4CGkT3	27697	3NKwgJfMRxk7hmAJTwETDn5y33Mb2ACWsCWMyZ5sxzNqiH7PY2yE	1657	1344	540	12463	18974	jxReaL3YEkXCPDU3FAkbrDBpF5xkvKY9aseuFdetXycEkMHiUiL	13687	19273	19273	1619408340000	orphaned
27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	27707	3NKqLAYUzpNrnM99cpXGWHaK6VfFe5jDJ3dSxAj3TcaVqwksgVw1	1546	973	540	12463	18974	jwoRQLL5upEUUBcXx4YcmyirXxh77ZwDhN6wc4AdghuKF4zHKji	13691	19285	19285	1619410500000	canonical
27710	3NKVRB9ovL8vTDEotrdP7zBKzroAECec9f9Da9WRDygoWrDMEdve	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1651	935	540	12463	18974	jxwH2yiuJugFdF8ZN21mEtd4ZkXz99mTHKJBHMzjW23MGSWu2bj	13692	19286	19286	1619410680000	orphaned
27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	1406	1393	540	12463	18974	jxMHNTB7HusHjFrc8s5pZPwxZLBzWPDmBZt1Bz97nowPYeHyMLY	13695	19290	19290	1619411400000	canonical
27719	3NKc93MRCkT2wFVaBWeZxQ7dM2M1fZmpkppuzLTMd4QU9ChD72MY	27715	3NKLywuMaSG4tqRTxZmRYEMCzuUNJpnyVptZ8U38eFHf3ooMP8YR	1650	1009	540	12463	18974	jwqi7LsZtPxpC4QBfU9YBxQqHEXZyB1tfJdw3TaRKDBAJXVr4h1	13695	19290	19290	1619411400000	orphaned
27721	3NKBwa8paxJYsSRLNt6fc19KGnUdx53rmRct39jS9Q7tUabt94w5	27717	3NKjfw2kSFShZiq8kXXAwyuHpbRJ5W3eo1Ehoc8JFgfgZHNLPh6M	1451	926	540	12463	18974	jwR5h2CqLGsGC2ksrbHYBFgiZM5ag3mysaFzky6TEwJEwFjYs2m	13696	19291	19291	1619411580000	canonical
27728	3NKf7Fguo9CA4iAdvb8zvidh6dyhsUAvpHWNtHP88GHsoWnxm24A	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	1508	1141	540	12463	18974	jxcrWKf9CSWdPeNoTpCeMLpvQmAUDkC1SwmSkQt3qv5m3fv21Lu	13698	19294	19294	1619412120000	canonical
27727	3NKJoN1dtuRbUBoVdPjAiRt2aTHDvokarBN1fRXEMMKL7z2oc6cs	27724	3NLfRqcj4hgN8hJ3iWQWUvSYrZJZGrtMubp6sLg2JFTtaUZxmn9A	684	1352	540	12463	18974	jwsKv13YKML4HiKeUrWiwjp5Sm9eDENhc64zj6AsnoqjCqG65Mt	13698	19294	19294	1619412120000	orphaned
27730	3NKVwW4cLX9d1TR8To8yoSsookrPJQCVe4JomV8dSXRqYDdUEDAd	27728	3NKf7Fguo9CA4iAdvb8zvidh6dyhsUAvpHWNtHP88GHsoWnxm24A	58	1281	540	12463	18974	jwejLNpGQESEmZqhW4CrXWxvbLZ9dxCNnHLpr56czv3eiKiQZ9T	13699	19295	19295	1619412300000	canonical
27736	3NKKiLQwnS5aGAmVcYR63P82Pard1QMhyq5EGiTNt9yegxy7H9os	27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	1440	1131	541	12463	18974	jxee3MJ2yfDv4YDm4BA44d7oL3QL8HcbqwWH6J8m7Yf7uUDMhgx	13703	19301	19301	1619413380000	orphaned
27740	3NKnANaWbGYurteMryGAA5KPaWERNLdbPbRKmNZk4Ui4nFra9EV2	27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	1593	1100	541	12463	18974	jwuagzKdL1LsyN6STd7eUrgiPrP5yaeCKnXhU11xX2xxcr5Q9kc	13704	19302	19302	1619413560000	orphaned
27745	3NKEvzfZVecDNdM3pghx8ALqqFpAtABqMAoWCvhxXRBxtYdUWAaa	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	632	1382	541	12463	18974	jwxmibkUcZD1U8GJd6iQ89irNSN79jgoHCo57uR3PSQJVKsmEoq	13706	19310	19310	1619415000000	canonical
27743	3NKHNZzfLYMUq7HrHfginSYmY9k3SFRstC8HEv6p5zoWyKwq7BKp	27741	3NLer7feCEfjBJKv8Fo5LR117dabNdstYyuVpi3hCfTMtPnDHeCJ	1523	1195	541	12463	18974	jxV69HtcgD2vDP1h2TVJyQPN74rvGrJdhP62yDjgkUc1kdoFopa	13706	19310	19310	1619415000000	orphaned
27747	3NLesd3tWwnE16YuBvwXzuF73F8vR45F6AqawKCXXPoDgrXHda6L	27745	3NKEvzfZVecDNdM3pghx8ALqqFpAtABqMAoWCvhxXRBxtYdUWAaa	1617	1288	541	12463	18974	jxsaBj4Dohby9MNFF8zHXYsEsFndW4VjqqQ5FUB4nrkB8vnEn7F	13707	19312	19312	1619415360000	canonical
27750	3NK4jRQWMDQroKXr5t2ptAR32b4D5b9cM7rgaje2EFK6XJYpjV9F	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	1499	515	541	12463	18974	jx9MG5vpFsE86arTyEu1DdNWDTuJECaHFNyqsxXZmyztkmu78dA	13709	19314	19314	1619415720000	orphaned
27754	3NKUef5bLcBPxXYDfrUH4pVe15rh6um3bcUb4qNJK8e8ozzH6nCu	27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	1590	1054	541	12463	18974	jw7o74kwDTefXbaVLL9PAdx4MZ2yW6Nbjo8BMMAZgnqDaRxop89	13710	19315	19315	1619415900000	orphaned
27756	3NKprA9HKLa2KXNBj8aJH5mPDeNTJGd3eXwKtUxBdxAv1Tz4WQUu	27753	3NLrym9AMQUykY5FLDahTmuQRMU46LcvzorHcaU9nRXNsfT8Qme9	1587	991	541	12463	18974	jwPcKp9pL8zxHHK3hxruNtNUWWWXeJ5McCWsDXsA4Wt2gebxHV6	13711	19316	19316	1619416080000	canonical
27734	3NKceus2pFNtFFvNSnvtjg4N6s5zMZMP5FEsS6RqdkvuGfme7vgb	27733	3NLJ1ET6feDptgcu21EwcwpwizD3FmqFCKHXdgaWrvSuoBrvJNfi	1406	1393	540	12463	18974	jwYr1adWuoaUe56xUhmF9XMJJhaScVEn6hd1ZkGZEBgf3QyHJ5K	13701	19299	19299	1619413020000	canonical
27737	3NKQQQSgXBjfd5a2x7sufekxfUUqpkKVyUKX9tDv5f45vf1K66RG	27735	3NKqyPd8CRWiNEy2sdUqkkzPWDD8S4vygCmj7jE572J2gUUnPqq6	1440	1131	541	12463	18974	jwQF6F3Gz4HBZuVtcAKLrjYuzXAvEnrTu6hJxbdyaRSkLDAtHwv	13703	19301	19301	1619413380000	orphaned
27739	3NKUpVPxEjjb25u5hKZYkKVn1YrGAsYZQTQWK3krKFpEgdBX2GNv	27738	3NKhVbKAA4Xu3KLgzcCBAoCwTReh63dfByoUhCXgxYQRCgDRJ4WP	1467	1130	541	12463	18974	jxxqRUQVahXymtmgx2Qu7sr75T8bqfmseg1Jahapm2bQmfZoH9w	13704	19302	19302	1619413560000	canonical
27746	3NKGM5q6v3ghjoCJn44cueqTYLmDDB5NjiGKvG6uAd6x2Ge5SyKK	27745	3NKEvzfZVecDNdM3pghx8ALqqFpAtABqMAoWCvhxXRBxtYdUWAaa	1458	1197	541	12463	18974	jxUDg2rCN1vH2yrmXb9iwrTaDHMFmvcpnQWoSgsxhMptK4rcMeD	13707	19312	19312	1619415360000	orphaned
27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	27747	3NLesd3tWwnE16YuBvwXzuF73F8vR45F6AqawKCXXPoDgrXHda6L	1600	1246	541	12463	18974	jxhzoYPRRBvmu1swxziBTjRqF2Tj4XjZgXPXn5gWd3PCgYAT1GN	13708	19313	19313	1619415540000	canonical
27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	1581	778	541	12463	18974	jxQHQt4QrT7LauXwxWphafUTM5cHvSUxFSt2AyMpcSkMwXJ8nh3	13709	19314	19314	1619415720000	canonical
27749	3NL5377j2m6nxKBJGqKaU6TcLuS12s2ukVk4v4iUYJTajq8QebgL	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	1608	1163	541	12463	18974	jxr8nFn4KeauyzmH3tC78oCyRcYcY5g3z3ULrpAQcXcuLhEKZRx	13709	19314	19314	1619415720000	orphaned
27751	3NKphQeJ7o9AgiKkYNr26jPaqWqve2Y8ucchJoGw9M9C5Ar8uiyp	27748	3NLeqQvk2V1JyciHXxv5MkfkunMpPRVD35yL2gH3v3zSsMgCgdzH	606	1295	541	12463	18974	jx8km3D4FEt5EZPk3abr8epagzmRebzV5iVZi2cNQMgxbj9hgau	13709	19314	19314	1619415720000	orphaned
27753	3NLrym9AMQUykY5FLDahTmuQRMU46LcvzorHcaU9nRXNsfT8Qme9	27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	1407	1395	541	12463	18974	jxQVdU24BZ21zRcadP4qXuQYmQqqwFMugBuvLiBVQdbmt2YxDvJ	13710	19315	19315	1619415900000	canonical
27755	3NLSDQiBDh3PAq2XshG1CT8dDvBiW6aHG9g1hiPrBCjvGVtYN6vw	27752	3NKTf7xfiU366YDcsbhGpcxKTeBDBtHVvYqFznDQuARbeERSHZsN	1590	1054	541	12463	18974	jxc4rw1USarmbR7s9qGLueBmTT4Nwy2CzskzUPvKmFn7HbhNA8D	13710	19315	19315	1619415900000	orphaned
27757	3NKEvF9mGHMc4JB6SU9aCizsB1RR2tn63ttk2sLEiMtiWwpDfaP7	27756	3NKprA9HKLa2KXNBj8aJH5mPDeNTJGd3eXwKtUxBdxAv1Tz4WQUu	1447	979	541	12463	18974	jwRYbnSGPKo7rL1u4a52eQxm8pssfHd4dk3n8w2FSaGwCQQaW4Z	13712	19317	19317	1619416260000	canonical
27758	3NKRhYA3aMVfVWFcudrFVSKYttodopBKXxkv6VMoxoYRWupKLyff	27756	3NKprA9HKLa2KXNBj8aJH5mPDeNTJGd3eXwKtUxBdxAv1Tz4WQUu	1407	1395	541	12463	18974	jxmJVxreTouSt3Jg6aQkB8Hr4NLcs7EGEiNH6peDFZEEkiqxvaN	13712	19317	19317	1619416260000	orphaned
27759	3NLdu3W3GL61eL5pJ7BeFo9cgdCVnDnLCiV5iHp7BbJbhZ1NZojw	27757	3NKEvF9mGHMc4JB6SU9aCizsB1RR2tn63ttk2sLEiMtiWwpDfaP7	1617	1288	541	12463	18974	jxRuRVvMHfqXSHRPy7C5AFyybXYaZLai9kkzs1Yma58A2kGsQaC	13713	19322	19322	1619417160000	canonical
27760	3NK5n6HaTzPkG3usV5d5K3GBE6U447uwd6g2pijT41WwKs3nHS2K	27757	3NKEvF9mGHMc4JB6SU9aCizsB1RR2tn63ttk2sLEiMtiWwpDfaP7	1579	1023	541	12463	18974	jx1FBDRC2YHmoeN2KLyKJy2KWqubQfwAAh7KWpsp5DaBM3PQdEB	13713	19322	19322	1619417160000	orphaned
27761	3NKbno6G9ZkFA7NE8NorNyC8F3yVvkGvrNgQyhsLSRHhWq7g9kFp	27759	3NLdu3W3GL61eL5pJ7BeFo9cgdCVnDnLCiV5iHp7BbJbhZ1NZojw	1406	1393	541	12463	18974	jxVr6h5P4BNDESTmmvd37r6fNxTf68bsZ5AnXe6yY92h9sabRVz	13714	19323	19323	1619417340000	canonical
27762	3NLn3qgg86oWSan3VWztpS58rEVPuMUsMRvnwnYwLzZnJkJYWSL5	27761	3NKbno6G9ZkFA7NE8NorNyC8F3yVvkGvrNgQyhsLSRHhWq7g9kFp	1506	1247	541	12463	18974	jxCvsiGvV5ej4g96n6ATJPyHxxiDnrosxDVRKQKWAEEstzDBwLM	13715	19324	19324	1619417520000	canonical
27763	3NLL6ZiVSH3ivcTWGjJCtR5emsGTqoJuYbEahcggnFVNKUvasPtk	27761	3NKbno6G9ZkFA7NE8NorNyC8F3yVvkGvrNgQyhsLSRHhWq7g9kFp	1506	1247	541	12463	18974	jwjisd77XYabmWPcWKbKrXqurknXqSiKkq3kRrtdV3NBomPepUL	13715	19324	19324	1619417520000	orphaned
27764	3NKvUvjRMDh9VFLtXvC1AqfD5HKxkYJiwwu197S76Xaytc3gizwt	27762	3NLn3qgg86oWSan3VWztpS58rEVPuMUsMRvnwnYwLzZnJkJYWSL5	1637	816	541	12463	18974	jwt1SGV99FQn79R5dRYwhb1eoJ2D3Shsg4CXXCkgLPKToPXu35M	13716	19325	19325	1619417700000	canonical
27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	27764	3NKvUvjRMDh9VFLtXvC1AqfD5HKxkYJiwwu197S76Xaytc3gizwt	1467	1376	541	12463	18974	jxyvoxCh2mP7fFgnHKeendHmyKCGwPiW2zGTnBwionE23EFAHGD	13717	19326	19326	1619417880000	canonical
27769	3NKYRHKbG8UeD1L1zT1RxN4BmvhMUPxg4gdVna3Cs7XBYAFsEcsK	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1594	1326	541	12463	18974	jwSMpGsWB11b5L9Z2HkA1TV2BdV78HJXTuSA1fjxDRccuSqxDCb	13718	19327	19327	1619418060000	canonical
27766	3NL5MhtyWshF4T3fyMDvMRCV85gAqkXjJqZvX5fXCkwefLXGsSUm	27765	3NKkK6t4xwEhXS8SKd4aSGRsd4NBjYuG8HSDPW6QGRBC92MnUEA1	1406	1393	541	12463	18974	jxoj5rThtA5eucVAhcdHEzFhZuPxHZst4hMJoGW6GcMQ7aNuTeV	13718	19327	19327	1619418060000	orphaned
27770	3NKQjHaFhZhfyHx7yssNt2zMG1CskFRWB9tf4bBFH9VsnQ39SXTi	27769	3NKYRHKbG8UeD1L1zT1RxN4BmvhMUPxg4gdVna3Cs7XBYAFsEcsK	1649	1137	541	12463	18974	jwaDDHaYmY8FijRqPXF2wnkAd8LoNUCtDC8yfiMfKPspjo1VR9b	13719	19328	19328	1619418240000	canonical
27771	3NKURmxWR6g8zyjALfpE8DASMAu4UVbemDicwtNmV9Lhep8CwEof	27770	3NKQjHaFhZhfyHx7yssNt2zMG1CskFRWB9tf4bBFH9VsnQ39SXTi	1547	1132	541	12463	18974	jwRY91XYNkeTJUJSHC1RCqWvvznqiZZb9Jf296rv1NDk8xYXmL1	13720	19329	19329	1619418420000	canonical
27772	3NLKZu1x1D93aCbueHGgiEWbxo1a6qebNy8nDzujtD8psLRF1gNs	27771	3NKURmxWR6g8zyjALfpE8DASMAu4UVbemDicwtNmV9Lhep8CwEof	1508	1387	541	12463	18974	jwyQSCTp1zieWx6FySsUv8yL1dBfb3CcTHk3yhrCmcG2oCZRBsB	13721	19331	19331	1619418780000	canonical
27773	3NKoYXgdmzEKBwKYyA1zHVRucwZtackhexTr9QWn5J6rEcz5fhu3	27772	3NLKZu1x1D93aCbueHGgiEWbxo1a6qebNy8nDzujtD8psLRF1gNs	1646	1108	541	12463	18974	jxF4bjhW7NdSjLFuuAR7mCwy7UbH5SewagzZhhJYLZ5dRMKE3uM	13722	19334	19334	1619419320000	canonical
27775	3NKSQfRqshqugrzsV6poMHM5no5B42EeLK8Dr156KZ8g8RsQXFi1	27773	3NKoYXgdmzEKBwKYyA1zHVRucwZtackhexTr9QWn5J6rEcz5fhu3	1637	816	541	12463	18974	jwT1YPuCuy3biMNrhQgg1595hz81xE5e5juBy5gnguDjrfmZ8Qd	13723	19335	19335	1619419500000	canonical
27774	3NKAmPi986VwzXFdVSn6zzd7S23jBhjJ55nVBBUsPNpR3imGRkAb	27773	3NKoYXgdmzEKBwKYyA1zHVRucwZtackhexTr9QWn5J6rEcz5fhu3	1439	1279	541	12463	18974	jwMVnHHkJfFeqfE6Bi9yZjXyQB9UR7XoHvbhBFkdpzPKEZhsbF9	13723	19335	19335	1619419500000	orphaned
27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	27775	3NKSQfRqshqugrzsV6poMHM5no5B42EeLK8Dr156KZ8g8RsQXFi1	563	993	541	12463	18974	jwdvxGhg2Y35VDM5qSHKFzpx7pQ1p7PupXQ1ynNXe6wo2ZN8yrM	13724	19337	19337	1619419860000	canonical
27777	3NL2R4FVtxNZ5hDgqC6sySm5YPPPhgLUiBkmVvXz6rxLR1Ue3QxV	27776	3NL5tVf6zoSHZsxiHRGszwx7o65hjCmf2j8JST6SoyQSGp3XkfB6	58	1035	541	12463	18974	jxoJByhCHZYfSDkqWjT3333qSD7jfPWxnjyvAhoHqoKpeGadBZQ	13725	19338	19338	1619420040000	orphaned
27780	3NLZbZunBdsYEiHPqpvzByaNsR6MZC5w8Dkn9bZuEBcfHmu7fKES	27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	1527	927	541	12463	18974	jxHf5bXYbRDQgRyTG8mqWtFVUxdXEVaAb6xnVngARasUCnokLY3	13726	19340	19340	1619420400000	canonical
27781	3NK6QFxABiouz9R45YXJvqgrFMNeweSLnzSFXGDpKFki2ujYkb1Y	27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	1527	927	541	12463	18974	jxobzrbjS7HCg86AaP1iXj4ZdgDzZzrGN5qw1T9UNqQ9mkBPb5E	13726	19340	19340	1619420400000	orphaned
27782	3NKxbsm2rAE8ejzps3sKBctEZToCN8h3QzsjniGmBNEypyjbmL1i	27779	3NL8AvJsvJdhVfAnxw8BPFRH1DQxozsTPzqmg5ExNV9YK6jYR4ud	1527	927	541	12463	18974	jwbJgpf7Ek9r775ce3K2qi5P53JFoqaaHeBSLMkauGw52vS1QJ3	13726	19340	19340	1619420400000	orphaned
27783	3NL1e3n2ztP9s3dZ1FGwBYpmzpRrw2bDcSAfNx85coexG1q4xXY2	27780	3NLZbZunBdsYEiHPqpvzByaNsR6MZC5w8Dkn9bZuEBcfHmu7fKES	1445	1290	542	12463	18974	jw7RZcALKSAd3wCZQhBAoXDFBh7S8Sk896oV7vBCubaoh1vKFEZ	13727	19343	19343	1619420940000	canonical
27784	3NK5F26XYoJKg6mtmRrRCZNptS83y4yRgbYqDkC797zEar34armV	27783	3NL1e3n2ztP9s3dZ1FGwBYpmzpRrw2bDcSAfNx85coexG1q4xXY2	633	1384	542	12463	18974	jwYpdTPNcrHPpBh3UYw2LbnFVmSVpGBf8CJeXRDfiUencEYDvok	13728	19345	19345	1619421300000	canonical
27785	3NK5oA3fC9MHwNY1JZq1m7YJLGx3gPHaT1rKvqHDfmRCzvhJnjQk	27784	3NK5F26XYoJKg6mtmRrRCZNptS83y4yRgbYqDkC797zEar34armV	1406	1393	542	12463	18974	jwtNqwJ9XSdRu4tfrnDza4QYiDdaUSLQaAmtNYMQgHraC1KGPGt	13729	19347	19347	1619421660000	canonical
27786	3NLSVtHDn4hewct7z5yg1ooEXPdHkZAoxZgNm8appkzRWqUiRD6w	27785	3NK5oA3fC9MHwNY1JZq1m7YJLGx3gPHaT1rKvqHDfmRCzvhJnjQk	1471	1020	542	12463	18974	jxmAd2ocH9Mm8T9NHCRxMHp92awmZnJ3s4Y5p8Kx5tz2wYFNVLj	13730	19348	19348	1619421840000	canonical
27787	3NL6gKdAiAGFfZ6nMkQSjJprRp4qxhT5GKaQME73sjE2CzJZdRBm	27786	3NLSVtHDn4hewct7z5yg1ooEXPdHkZAoxZgNm8appkzRWqUiRD6w	1622	1230	542	12463	18974	jxN6e1o2cZP6JQiDv39u1EvseFRpbnsCRaLu3hKG4TnHQ7d7LYu	13731	19350	19350	1619422200000	orphaned
27790	3NKMj8KernQX8zPPi9Kd2mHKtkS5QXX3Z6cFiNFHoKuc5q1d1zHn	27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	1536	1313	542	12463	18974	jxNqdQo7zwmWTSHS1S4z9UzrdDRhnCAtrtRskNrdqQBgtSBNCa8	13733	19352	19352	1619422560000	canonical
27793	3NK48M2z6WifsdgExFEM5Cd3v5WiTuesoC1YeTB5EPojmbZqj4a8	27790	3NKMj8KernQX8zPPi9Kd2mHKtkS5QXX3Z6cFiNFHoKuc5q1d1zHn	1501	1234	542	12463	18974	jwZ1EBsXbGCes4EaniCEztqufspZRFT1eE3ymh3uMjYih8ispnZ	13734	19353	19353	1619422740000	canonical
27797	3NLWiEMiTw4RnnEzhMJNpneD7EYag6QwLawPa5R5j3gWFHMZ4kjU	27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	1506	1373	542	12463	18974	jxNvPY4cLomHrm5MgBhE1qULivefXMyxmete85XEjn4kxNqPZb3	13736	19356	19356	1619423280000	orphaned
27802	3NLQ9e4HZvCs3JcuXTHW7QBA3osFNSuTZmxtmeWBDBu5YUMi3s4i	27800	3NLiW9Mq74G2EmxJu8MVhpS8Kc47MwvJxN4ffBWjgdEs2kZVYdHU	1489	1014	542	12463	18974	jwZDYHb5RRuVuh7iEfucZw2QrpCwq2qw3PtJ9npahi46tswqPNk	13738	19358	19358	1619423640000	orphaned
27807	3NLVEZCFs799UuwDhbNVmMSUzRNCYqCpPRzcPVcUHAjPpZACecJ2	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1523	1075	542	12463	18974	jxNafLqvUXkLf8onMMWvDZakBowpS4t5RP24L1defestFthsnXw	13740	19362	19362	1619424360000	orphaned
27811	3NKU6wdJenzAvXPAfXtczC2qJh8aNNTyr7Rvxf8vD262ECg3FfF5	27810	3NKQm1SaCuwHKVtNFJ7CxXX2wVhNeL6Px7KAwniRsD2AW6xvSAqx	1407	1395	542	12463	18974	jxMhZymXe3u7pfhrPSNMpnYqeTByH4RVsgjyJAFWXXNjsRC5s62	13742	19365	19365	1619424900000	canonical
27814	3NKDiaFjydwL7tmd7k148zBNKuqo3ZCW8aaiadov5FpdoBhmZxX6	27813	3NLwFdubyyQ6eJ9GJPcFvJGytXX2o7ZEMXe7c2DDjpqgJzdDR2Fw	1599	1287	542	12463	18974	jwDc273dUL4NXYPZ69kSsj5ybQdypPQFaivx1LoDGMaVHJeJHSM	13745	19370	19370	1619425800000	canonical
27817	3NK6URgPj8N8R4kYpFE3eUgUijMXNHyim4pwdqUowoweT9n6Y3ZF	27816	3NL3XdTZq1SVFKnHp1kid5YqCgE9X4Dp9oni8kahTYbqwpMgB3Ug	1587	1231	543	12463	18974	jwuLTByUpLDeTP4vqq6cqmt5KSMR3FQfU3GjVeGFksX2DgX8KGC	13747	19372	19372	1619426160000	canonical
27820	3NKhPHfdMLfNhDAV1qWJcDxpHJCevAqyUEQQ8xLXKcUmHewdGLuH	27819	3NLsoeDSjBVJ8npYxDF7yCetbZ5engcpnpAf1GpZniyvKuU4Rw3o	1406	1393	543	12463	18974	jwdGFKWxsV1PvSR7bLYAEjiZoGURiQh73AtNL8hyr4cAfLhgxBH	13749	19374	19374	1619426520000	canonical
27823	3NK9M1meZmUDHWqCw9FXxDWRD6T7FkKoLuUcNJBi7HiLhdAVKc6y	27822	3NKMRk2dBtBrgXZx8ci3d6S4QT78vDKXFKTHW87p2JQNuRZ35j5K	1637	815	543	12463	18974	jwnm7pDUqAm7PnKbHDf8TTGwodfbhjes5dfxrkffUra86B3eAZ1	13751	19376	19376	1619426880000	canonical
27826	3NLU5NPpV81V2BmmjAGRUoC4kU8ozs1DUNDQSbDWknhh6PZZegnY	27823	3NK9M1meZmUDHWqCw9FXxDWRD6T7FkKoLuUcNJBi7HiLhdAVKc6y	1637	816	543	12463	18974	jwQPZ7zUnWvM3DEKojRj7Fn7y6auSCkkPo2d1JEdvqVAmNA7RqK	13752	19377	19377	1619427060000	canonical
27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	344	344	543	12463	18974	jxpjhqTvJS3PJvRLSfhrseCaTCzyrBDem1MKZdce3wYHkWZtKEx	13755	19383	19383	1619428140000	canonical
27831	3NKCCco66FQ4UXScWZfrGaMHy9bnTtwZ7DQ9XdMLbrJurXRdfTF8	27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	1624	1208	543	12463	18974	jwi55BTntY9Rk1t1kJSsoNbMutYAYN5SJnNN6zEo6gFZT3jyM1y	13755	19383	19383	1619428140000	orphaned
27832	3NKACDaFGNph7RL4GDEmpkZTJWR7RpSq1ytuX5baYJjhZ47y9ot2	27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	1598	543	543	12463	18974	jwKbumLWje7eNcNbKeyKND72UUmtfrCHvKH9j3edFKMihy8jBEw	13756	19384	19384	1619428320000	canonical
27835	3NKY28VPqMBqkjC6efPSzjVjSgTzyP3rtznW1h3ERJnueBQhLaW7	27832	3NKACDaFGNph7RL4GDEmpkZTJWR7RpSq1ytuX5baYJjhZ47y9ot2	1403	824	543	12463	18974	jwVonpS2QTUZ5NCmW2mHG56QX5KupeHyjLp4vTXWEDmSRK8yHjp	13757	19385	19385	1619428500000	canonical
27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	27837	3NLAoYnWuRgQmnNatUEFANf7nmRgnV9b6Gob97s6DX8EDEtCvqbX	532	1303	543	12463	18974	jwNpzqCweKTrHgWHPMnDm89RSUko5AXNcC7WZruFPwqqaSp4G6W	13760	19389	19389	1619429220000	canonical
27840	3NKn9VPVSpWkLuhYUH7ew6jQzM4n3X2nGNFzJowSCUhW52HAmb6h	27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	1646	1108	543	12463	18974	jx4cB45TiVodabTBGJSAVHj5JRYGRKhENPG5rxHyXLeziGrLeym	13761	19390	19390	1619429400000	orphaned
27844	3NKaswkoyUSfWo9opiKFmGJNz3r5sGMAicHth8zi5zoUwtRVKYRG	27843	3NKJWNc8YrF8H9ZYp4mySkce4Jtr1UkHhhB4Ed8wy3GpLWXWgfMh	1581	778	543	12463	18974	jxTxc5Kbtpo6xiYGgUMHM8SJ5RqeU5dQreEneiUrABU6TXMwewT	13763	19395	19395	1619430300000	canonical
27853	3NLjz4fMEQSfzj31pepy2y75kRhTLPesxgfJwAAjRxCKbJHg5kvC	27852	3NL52PnVtD8moqNfGrVG1hQSfqcTacu7wRaYA74gvxoLQYLRn6iV	1599	1041	543	12463	18974	jy3FN7J8bPT8j2d15qaKZemtFW41FMb5xEUWbApwCaGZVeqMohG	13768	19400	19400	1619431200000	canonical
27856	3NK7CfyDxemAPS6oLFKnRiM2XCy9NxPjXFN2W2SN2UWXR74sm4FG	27853	3NLjz4fMEQSfzj31pepy2y75kRhTLPesxgfJwAAjRxCKbJHg5kvC	1403	824	544	12463	18974	jxJC9XyrKq6DBYyeaRSPX717pfA8L8DEhmZ1LswThcTMD8mThkw	13769	19402	19402	1619431560000	canonical
27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	27793	3NK48M2z6WifsdgExFEM5Cd3v5WiTuesoC1YeTB5EPojmbZqj4a8	1601	1388	542	12463	18974	jwiLeU8KPF9SFKaNsGTXBbj2F1MkUyM9GVrWWGbQSA9xXFjcLUh	13735	19355	19355	1619423100000	canonical
27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	1506	1373	542	12463	18974	jwhqrXd44w1fHPfMsxEDTUA2p4Q4GhYkxhvhonzzq9J9ypXWacN	13736	19356	19356	1619423280000	canonical
27799	3NKAST5EPm3VrVwMvuozFaS4rPSpZiTuMgrq5vyQ4PVHvFaV6ASL	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1589	1286	542	12463	18974	jwACn3vxeCBBzPTC1QfGTq61aS2dcpHD3trBdP8g74Bkt9oCnEc	13737	19357	19357	1619423460000	orphaned
27803	3NKiQEjW4BknvdsLw1jGUea8tDHuza9DLpzGQKx5ij41C49tctAh	27800	3NLiW9Mq74G2EmxJu8MVhpS8Kc47MwvJxN4ffBWjgdEs2kZVYdHU	1534	951	542	12463	18974	jwq6b5Laq4LbiYP8Bu1TtvY29QXCqEbwebswfLQdmAJyiNHU8Yv	13738	19358	19358	1619423640000	canonical
27805	3NLGT3op2BSE56j5aHZAgKMJZu3TXXBNrcMsDJ3WeXkV1gDEpFLS	27803	3NKiQEjW4BknvdsLw1jGUea8tDHuza9DLpzGQKx5ij41C49tctAh	1601	1142	542	12463	18974	jwQwVwAXaKqJX8gdzvwxgwAdsF81DzuzybMU5X7yEk1HycRrLZZ	13739	19360	19360	1619424000000	orphaned
27871	3NKis9LVvg64XUvc2MA2dBYTEJk5qFU2FLMezdZ5AQPcbVHBntfF	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1560	925	542	12463	18974	jx3Dk2JWMzyMv3wDwHaugezRznvcPhQvwEm6MZFxCR5EnoZzC1C	13740	19414	19414	1619433720000	orphaned
27812	3NLA6ftCgWznGwwhXPhbNL8Qfgagnkvvu3zKfon95dnBJffAzqDn	27811	3NKU6wdJenzAvXPAfXtczC2qJh8aNNTyr7Rvxf8vD262ECg3FfF5	1534	1071	542	12463	18974	jwS5cgVvDR6DYdf8sqwQJzks5xYiD6hqBK622VDczaWxtTGeNwV	13743	19367	19367	1619425260000	canonical
27818	3NLpQ6qPm5vfk5QyJ5rsv6STbAzdk1EVTK6zKyDc6hwaa7YZT48B	27817	3NK6URgPj8N8R4kYpFE3eUgUijMXNHyim4pwdqUowoweT9n6Y3ZF	641	641	543	12463	18974	jwt3yevhbVzakJsoegoeL5J9azYP3VqcZAAYqn2ewe5ubMFCeya	13748	19373	19373	1619426340000	orphaned
27821	3NKL3FjJavsBGN4M9N1TufzeQzzoyLxY8KtLszvzqRqoc6gB4LXv	27820	3NKhPHfdMLfNhDAV1qWJcDxpHJCevAqyUEQQ8xLXKcUmHewdGLuH	1555	1347	543	12463	18974	jwyE4mnKnAnhH7DyzM6JdBxskdT5Mhyy98K3LKhNbRyt8R8Cwj4	13750	19375	19375	1619426700000	orphaned
27824	3NL4Z6VDKRyohRQUqFKGRNZTQu1uwv4TDcC2S8EmT5gNwErsbbrD	27822	3NKMRk2dBtBrgXZx8ci3d6S4QT78vDKXFKTHW87p2JQNuRZ35j5K	1650	1375	543	12463	18974	jxW9LEMRyazJArBAm8oVas9C3bbM2epUoxju4PZ9MpcSTPxHPPw	13751	19376	19376	1619426880000	orphaned
27827	3NLBMX1M72TKX6CqyNNFVna16amoye6wRYoWuP7QjBCg6Edm7iz1	27826	3NLU5NPpV81V2BmmjAGRUoC4kU8ozs1DUNDQSbDWknhh6PZZegnY	1406	1393	543	12463	18974	jxStvdym5BqWhvymyUTf8J9Ga1JNqiW2KX4cTJQ1Net1GMuHNAc	13753	19378	19378	1619427240000	canonical
27834	3NKq3yzp9MYgNsF7kBj5PSUaSe4dXdcWKQrb8ovVHR4Wj7wY4hir	27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	1541	1172	543	12463	18974	jwqaH3DG8v5tjtN8WockXT8qA1NuBQdgFEA7Aet1SfpBguZrUJo	13756	19384	19384	1619428320000	orphaned
27836	3NKeSGcgDEBF9pgG8pNJ4dYz3dJK9sbfnuxGeTTCW6nQ6RqeXFSS	27835	3NKY28VPqMBqkjC6efPSzjVjSgTzyP3rtznW1h3ERJnueBQhLaW7	1406	1393	543	12463	18974	jwdyMWJrUvwrYPtZULpHnBTohUxmGrXqM6E2VmwZiGERY8YLF4J	13758	19386	19386	1619428680000	canonical
27839	3NLmyPQQ9JGNP4tupxoLuFKNdjc2bf71cfzvkaDVnmYfvx7uYsSY	27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	1402	874	543	12463	18974	jxn7HRKETcYdDx5VMwoSnU6y5ZPYLcLZ5EXTVw2EiEUkThsps8i	13761	19390	19390	1619429400000	canonical
27841	3NKHSP1dwXMZA97XPzd2YhEPdVR7TZr2QmxfqTKDf2uhXgLKefLX	27838	3NLc7nc5K8WcN6cFLpFypxm9UGs9sNB7cN9uw5zk5rkuYG16WXVV	44	959	543	12463	18974	jwiBrbbfxFHVQEyS1ootexxTUjdPaTKud8GCvUdKqbj2AgoARSy	13761	19390	19390	1619429400000	orphaned
27842	3NKxCekCoJ2kkYqpJnUdMsqYqDTBSU8ezQhVp3otxYAhC3AaAG8d	27839	3NLmyPQQ9JGNP4tupxoLuFKNdjc2bf71cfzvkaDVnmYfvx7uYsSY	1402	874	543	12463	18974	jxXVArLcufUFr8zADHUBsNeyju4T15m4E7XbrcihMmpwj6aCK4f	13762	19393	19393	1619429940000	orphaned
27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	27844	3NKaswkoyUSfWo9opiKFmGJNz3r5sGMAicHth8zi5zoUwtRVKYRG	1624	1088	543	12463	18974	jxwvWh9hHcCXMmsAxg7QHm2QiqQwaeU8tAzV5ZnoioZDgm5W2ac	13764	19396	19396	1619430480000	canonical
27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	1406	1393	543	12463	18974	jwycMFTCTnhEDNCyRTppabE4taBY58tbDSXJXHhJgvKQtz6Yvx6	13765	19397	19397	1619430660000	canonical
27848	3NKHQQNSeN8JgEZbE7Las4AwzV9tCAnnqov6oacQtN5SyQm9V4Xp	27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	1551	437	543	12463	18974	jxjzMR3PL5w3TkgespDq6PTvBNJtiQgVKu58z52828ADaAXJoLt	13765	19397	19397	1619430660000	orphaned
27850	3NLhjXoxYMabAARuABcTmcJNMV86CJn6Xi4PcWGXvqJbUegxtbmN	27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	1523	1321	543	12463	18974	jwthUVcwswwRjUscJ4XZjBDBx9q9HZWeHnJdWyGijhGeRASf2ay	13766	19398	19398	1619430840000	orphaned
27865	3NKHmgpzyqZSvbyqXzKbDAMDn2jWYfsRCXEAboRSQKxbQbgyFQWA	27864	3NKbGYDuqEk62KBc9PbqUn1gMQdqu5pXZMBgFe5sxzgfVzTHBUpc	1403	782	544	12463	18974	jxjY773BwrzxvhTj8bPEuVDd7abY44JwTWTz5SGzeRuF3s5ixjy	13776	19410	19410	1619433000000	canonical
27868	3NKKuaH8vThoPusp2Zn3pThcLdFsv1VN2G1uuy1V72roLyHRUSm5	27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	1499	515	544	12463	18974	jx5MPYXY4ZAMuMZPG9c6a6kUQ6LaiQjpngrF2H9DQ5ZeQRtDHSx	13779	19414	19414	1619433720000	canonical
27873	3NKVw4iqceN8Gyiv3Eak7CXM2ZoLjJtDrRVvCTKC4H3yRdH73hzR	27868	3NKKuaH8vThoPusp2Zn3pThcLdFsv1VN2G1uuy1V72roLyHRUSm5	1407	1395	544	12463	18974	jwGXhdEZRdXZBazkH5QiuukQeU7KxJmQRbCGZ2irQsWPi1J2D5F	13780	19415	19415	1619433900000	orphaned
27874	3NKGCnpAeWVFPLj85KmD2aF1ufHcvhgMwQTVaB9zs7qapwPuVPKU	27872	3NKMDy7DFcXdYRWFXKSd7QV3dCWas24Xp7mxgToMsB2cgFmZXzDh	1476	1245	544	12463	18974	jwpRjT76NA5TpFmiKbXqrL7q6rPVhhZgikA7VhzwnpsaZfRRGvT	13781	19416	19416	1619434080000	orphaned
27877	3NL45uiauT6Bvoi1qvoq2LpDszKyRTFSALnuuApEjEgCLi8C62C5	27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	1536	1313	544	12463	18974	jwaoYjpLtaAFvrDLTCGc43XKpEevZN3AcCDEjYUPudAtxjVoWwR	13783	19418	19418	1619434440000	orphaned
27880	3NLoczdsF2Qk6541bZCsa2VTA8LWqM9At4W3TBa3Nd3VxfDh7xoM	27878	3NKPuTcdBsfwq73Tyys8zR3grVLoT6QV7PAsR8g5D6v8miF8Z6HT	700	840	544	12463	18974	jxm63UREEz1f81HatyswZVp28Zz2rKTcNVZNa6jStNTHRKAWnjR	13784	19421	19421	1619434980000	orphaned
27884	3NKtoVoZcXQr7ZG7uewcuwQ52YaQVCEKeYgtvXjxExCs5qKoKhhU	27883	3NLbNhZq1BfZTbY4cojFQgFwMjABhvQNnPzEShWxjCXkn8PX7eVk	1489	1380	544	12463	18974	jwzZvqupZ36raft9Zp6YQ6TWFzo36UqzW3CPgm9FexkaCgJeYms	13786	19425	19425	1619435700000	canonical
27887	3NLmF4XPSfcr5VkraT67nZYfBJNbarm6Q8Xcy6jLBx5cuMtoRU2u	27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	1521	166	544	12463	18974	jxEXDxtt9Xx7BoykUehGD1WBctvWm5nvHyJki8vTEXu5j5YqSUq	13789	19430	19430	1619436600000	orphaned
27890	3NKfT8wFLh21277LNX4s7NzwJhR8jEmPEGyWJnLoamdfFCgTznbY	27889	3NLurDvvFqvgBoZm5dtPHwVgfb3RD5wL8NyuFd5TfQNStd9DVFoW	1406	1393	545	12463	18974	jxVARYGD5QVX56szkbDsv8ozydKqEscKg5eqnVtBb1dVzgYgAvZ	13790	19431	19431	1619436780000	canonical
27791	3NL3dxVwdNjtHzU6G86aGaYumq64zUL1Y8GiuTCHz5mdutGyarrQ	27789	3NKJwaJjAfuyDCYMAMCTnqWffuEZ9X8qxMqQuexiLvkgLxtsmDZ8	1407	1395	542	12463	18974	jwiZQW5TDGwR3CQuBvK19oTgYUKmciw8gEPBGX8CQTdy798bcL7	13733	19352	19352	1619422560000	orphaned
27795	3NLTa9aBEaysjthHQ3WfuwnyFbA2hGsZ6Ep6W2UqNgLbRqpm9HTf	27794	3NKDWFVwaa81cLquHU6eZUVJifgpw9vr36Ek23wBkGFvNSUNNJmt	1474	1083	542	12463	18974	jxz7dhb3yos8FjESJhV2r7LmTpxpCwyC44nGpsTwkfBbe3CXfQY	13736	19356	19356	1619423280000	orphaned
27800	3NLiW9Mq74G2EmxJu8MVhpS8Kc47MwvJxN4ffBWjgdEs2kZVYdHU	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1587	1357	542	12463	18974	jwzovt7aFF5Ud3gnxP3eEBefknhEU8k5diEHRLpXiKWyKUWX9cF	13737	19357	19357	1619423460000	canonical
27798	3NKVsU1VY1F1p8Fx56NQGtQ2koTLiUb75XaW2Agig5nG3a3fnwaD	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1675	976	542	12463	18974	jwH6Gm1YuouxSPc8rVtKxxGr6r3U2tQSJ2SuavHzEmiHGvfnKEt	13737	19357	19357	1619423460000	orphaned
27801	3NKnV9d6c2Yt42EHufcjiU4tnqxK7ZgNoVkSjKoVHSXARG1UTEgz	27796	3NKHKk6n3uEe1vVruo2hvvHCasFPYMky23mFszVWZLsfRFJNUfEM	1611	1095	542	12463	18974	jwYZaRiV72AXjpUVoVBZgXDvzZyR6QsMpLjha4eZBe3PpQBtzmr	13737	19357	19357	1619423460000	orphaned
27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	27803	3NKiQEjW4BknvdsLw1jGUea8tDHuza9DLpzGQKx5ij41C49tctAh	1637	815	542	12463	18974	jwATMWUzkm5b9iH8rsAHci7x7JdB1ZL4Rn2ba6C15DzoFmzDd5q	13739	19360	19360	1619424000000	canonical
27808	3NK32f2hzshV3JJNsU8eGAL1MQt4bt2zzyKzhmQ1QzmY9Xh4thAG	27804	3NLZifFodpg5UVd9dv1DJ5Lo7MyNvQF7c5eU3qeJp4r8oN33bWQi	1523	1075	542	12463	18974	jwVekxxRxLCZTaCA75fMhdHhfWEbDM2qeUMb6vtG8mjw4d7rKiY	13740	19362	19362	1619424360000	canonical
27810	3NKQm1SaCuwHKVtNFJ7CxXX2wVhNeL6Px7KAwniRsD2AW6xvSAqx	27808	3NK32f2hzshV3JJNsU8eGAL1MQt4bt2zzyKzhmQ1QzmY9Xh4thAG	1403	782	542	12463	18974	jxC2mUe7rjHkSgcKEDkVBBPoVtqmrWVKGFXJyP5fheGJTopuJb3	13741	19364	19364	1619424720000	canonical
27813	3NLwFdubyyQ6eJ9GJPcFvJGytXX2o7ZEMXe7c2DDjpqgJzdDR2Fw	27812	3NLA6ftCgWznGwwhXPhbNL8Qfgagnkvvu3zKfon95dnBJffAzqDn	1581	778	542	12463	18974	jxLfCjuLPYCa5YjGvFoqo72oHTVAuKTg9RbMzAatJtvSKyYuX1i	13744	19368	19368	1619425440000	canonical
27815	3NK5dAce49am1iBW65SEtJkwidxnbHoxbQSJxnmBeUu8jeziTFHs	27813	3NLwFdubyyQ6eJ9GJPcFvJGytXX2o7ZEMXe7c2DDjpqgJzdDR2Fw	1577	1327	542	12463	18974	jwn4LdotUWmELUhugCdg2hmz5Er6f3mttGroK71yzZD5Wj7gqqS	13745	19370	19370	1619425800000	orphaned
27816	3NL3XdTZq1SVFKnHp1kid5YqCgE9X4Dp9oni8kahTYbqwpMgB3Ug	27814	3NKDiaFjydwL7tmd7k148zBNKuqo3ZCW8aaiadov5FpdoBhmZxX6	1647	1302	542	12463	18974	jwsHFKzGBsFThMi3WUmVB7rQWcHBifRAccZ8pzg34vNaA2FRyWd	13746	19371	19371	1619425980000	canonical
27819	3NLsoeDSjBVJ8npYxDF7yCetbZ5engcpnpAf1GpZniyvKuU4Rw3o	27817	3NK6URgPj8N8R4kYpFE3eUgUijMXNHyim4pwdqUowoweT9n6Y3ZF	1623	830	543	12463	18974	jwRqfgewoUJxN1pkcf6DYzwRaDiHz2Jwjg7mwS45vbrW77NXo6N	13748	19373	19373	1619426340000	canonical
27822	3NKMRk2dBtBrgXZx8ci3d6S4QT78vDKXFKTHW87p2JQNuRZ35j5K	27820	3NKhPHfdMLfNhDAV1qWJcDxpHJCevAqyUEQQ8xLXKcUmHewdGLuH	1522	1322	543	12463	18974	jwmviUdhevkXF6keWMcvnWWEn8NDNmWFm27cDmoETMevAsVTT7H	13750	19375	19375	1619426700000	canonical
27825	3NLGakQH4YzZw8Rq4KGaiaxtkc3cdF8kZazUiDsVkwUorgMtKfg7	27823	3NK9M1meZmUDHWqCw9FXxDWRD6T7FkKoLuUcNJBi7HiLhdAVKc6y	1600	1246	543	12463	18974	jxSv5QBtqAtoH9Sv3HqowqYSxAkdLdXPrSHs7GTZJFY889gTDFB	13752	19377	19377	1619427060000	orphaned
27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	27827	3NLBMX1M72TKX6CqyNNFVna16amoye6wRYoWuP7QjBCg6Edm7iz1	1483	504	543	12463	18974	jxN4Jt88kU3oLUhjdFi6qzYUQrLkVNW6ygQtEGLe3sanT5kW32o	13754	19379	19379	1619427420000	canonical
27830	3NKLSriDiX24fFceQrHcF4AXCaR9mMgCpJ5SoLCCgjtaDMoaXNyx	27828	3NK9JZg9AnRdCaJ3tFtdCJwTqDkW1KjggfgtXs3UghTXaiTbvh8h	1637	816	543	12463	18974	jxpbL7GbG4YDumRBZ6Go2GNfxY84WkB2cKXff1dGxqRS1z8kLou	13755	19383	19383	1619428140000	orphaned
27833	3NL3cd21iuDoKqQ7K62kkGBNpq9hzFSKuP3JR6ggCVX95xEHNN8U	27829	3NLobg2BsZR23F78gLECRQrihmGN6Ex2XerYrJi5EZg8sUEkemVJ	1541	1172	543	12463	18974	jxf9agLQs3Q5xCgg6bKd2YeQfZXn3CUtEcwLxsAGc4iAbqMNrK3	13756	19384	19384	1619428320000	orphaned
27837	3NLAoYnWuRgQmnNatUEFANf7nmRgnV9b6Gob97s6DX8EDEtCvqbX	27836	3NKeSGcgDEBF9pgG8pNJ4dYz3dJK9sbfnuxGeTTCW6nQ6RqeXFSS	1623	830	543	12463	18974	jwV9AuiujcnJzDa2SSyXUa35dn97dkKLqZmfjVhNRP5gwCZQPwA	13759	19387	19387	1619428860000	canonical
27843	3NKJWNc8YrF8H9ZYp4mySkce4Jtr1UkHhhB4Ed8wy3GpLWXWgfMh	27839	3NLmyPQQ9JGNP4tupxoLuFKNdjc2bf71cfzvkaDVnmYfvx7uYsSY	1406	1393	543	12463	18974	jxR2aoh8nNiuJitUuy7QzkZpbrUoSNTjjFJUcFbV3cRX2vmEEUB	13762	19393	19393	1619429940000	canonical
27846	3NKx4xszujQh16tpQNte8bxccuKm39uHWU1CtEk7YnTTrQG3pasM	27845	3NLVo7hpBd9fg12wMBsV31iEX1eqaDiTvuo77Z1X1HzziLMRbcJV	1407	1395	543	12463	18974	jwtmLHJ2A8FNM4TrmUvBHxftN5fHPW3RViFJjnZUM5hS7v6fbtf	13765	19397	19397	1619430660000	orphaned
27851	3NLHK4WsaQ3Swi3EgYSAMQbdftAU8uoMbLSfU88pVQ8XSGDz3zZp	27847	3NL6t9fFQQ8Qqgo9sHyi8jsRLjPtqu43fywkN5fXLZE38ynCaQRZ	1523	1321	543	12463	18974	jwUMMVa4FbaBZCTVg8gLRZpQ6PVJfP2aQAeaMNmZxeKDhK4Z9oT	13766	19398	19398	1619430840000	canonical
27854	3NLYegadXuSqRLjtTAeYuXnpfTpRnpwx5fjapeM18NwaRjQU53XQ	27852	3NL52PnVtD8moqNfGrVG1hQSfqcTacu7wRaYA74gvxoLQYLRn6iV	1599	1041	543	12463	18974	jy3FN7J8bPT8j2d15qaKZemtFW41FMb5xEUWbApwCaGZVeqMohG	13768	19400	19400	1619431200000	orphaned
27857	3NL3SGuNdcssGksSwveiBUmihaQRzWfs6zqLEs1hBA1EbNKhCJfg	27856	3NK7CfyDxemAPS6oLFKnRiM2XCy9NxPjXFN2W2SN2UWXR74sm4FG	1406	1393	544	12463	18974	jxXVqaSHoRwmoc3krMzpWCcqG48rNG78ceHWL7cnVeihx8xVY8R	13770	19403	19403	1619431740000	orphaned
27860	3NLfdNfjDvwNUgt7zNEkPtHExyD4KZXL5Vsr1VBrAVv4Kxiwxknx	27859	3NLroXRe9JpCKQpsypg22wN9H2zdouu8wt4rMLZq4QJigUeDSJDE	1406	1393	544	12463	18974	jwG7pm5fsd6389K8goM8XPtjRfpAVEgyc3FNf4sWuNqgMbfSp6D	13772	19406	19406	1619432280000	canonical
27862	3NLwfjcnpkv3RiyCYCsCcdsoQMYg72kwbZWXpj3frAESMUbi19dy	27860	3NLfdNfjDvwNUgt7zNEkPtHExyD4KZXL5Vsr1VBrAVv4Kxiwxknx	1407	1395	544	12463	18974	jxacK2NQ2AGWkEFzX6TFSo7R5Nz7HffVt1MEZDQA8pvu693dQPo	13773	19407	19407	1619432460000	orphaned
27863	3NL35N2dXkYSZSvSiHxFQXu6D6PiKx1BhVTVw58UisRmACXPgHod	27861	3NLZTjKPNSFXaTvthmbbCnPuuYsP1TQCwgohPx9TL2VZgNrmcTwA	1407	1395	544	12463	18974	jxBmAfgBVqSKAM1xKgk4LcTNBtPdPihR1aQNgM7Dq1QnMSAkPGx	13774	19408	19408	1619432640000	canonical
27866	3NLGdWAKeCXSCpHWYHsJtaw2g8t2uDmGTGPTrq3pbKDuRWP9JnFv	27865	3NKHmgpzyqZSvbyqXzKbDAMDn2jWYfsRCXEAboRSQKxbQbgyFQWA	1406	1393	544	12463	18974	jwB71AbLT4vzwbN6cVqi3rPcJy5YrM7LC2VsLGdUeYiQBn56SGJ	13777	19412	19412	1619433360000	canonical
27869	3NKZYJqjFD6L1dHky52t18iZvA8TPwFsU827KxZnQ1YWdb2Fp9NC	27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	1647	1056	544	12463	18974	jx5nCeHghAbPPx4PhK9eZvuQMQ9HPGrmA4g1WB3wRhdxyGUqsCS	13779	19414	19414	1619433720000	orphaned
27872	3NKMDy7DFcXdYRWFXKSd7QV3dCWas24Xp7mxgToMsB2cgFmZXzDh	27868	3NKKuaH8vThoPusp2Zn3pThcLdFsv1VN2G1uuy1V72roLyHRUSm5	1622	1230	544	12463	18974	jwK4Lc634psvidNqnCYnTK1QLETnqHVkaunVq9G1oUVteimUtvs	13780	19415	19415	1619433900000	canonical
27852	3NL52PnVtD8moqNfGrVG1hQSfqcTacu7wRaYA74gvxoLQYLRn6iV	27851	3NLHK4WsaQ3Swi3EgYSAMQbdftAU8uoMbLSfU88pVQ8XSGDz3zZp	1672	1285	543	12463	18974	jxYHdFQ8BLxbXeVKTfRNKRESzGe1a7JuNC6QLc28yfGUc4uNwwe	13767	19399	19399	1619431020000	canonical
27855	3NL7uCjzz5wHqcEkX5B4WH623SZVQWWhVTstjSy1MxMRYPxLDE3L	27853	3NLjz4fMEQSfzj31pepy2y75kRhTLPesxgfJwAAjRxCKbJHg5kvC	1460	440	544	12463	18974	jw6dmURZ8un7r7DVmvx87F7XVreuc7TRJ3ewXZiCtYEHsArjaHU	13769	19402	19402	1619431560000	orphaned
27858	3NKgoHxUrnPPLnB7GrN74esidpyPNiHrB7GJqMQBEPCvU67Pzp7K	27856	3NK7CfyDxemAPS6oLFKnRiM2XCy9NxPjXFN2W2SN2UWXR74sm4FG	1403	786	544	12463	18974	jwTVbimHkzTQZarZGeqhAjdH1Bqa7DFzpaEQQsWX9hT5G3t4WSa	13770	19403	19403	1619431740000	canonical
27861	3NLZTjKPNSFXaTvthmbbCnPuuYsP1TQCwgohPx9TL2VZgNrmcTwA	27860	3NLfdNfjDvwNUgt7zNEkPtHExyD4KZXL5Vsr1VBrAVv4Kxiwxknx	1610	1188	544	12463	18974	jwaVv3zgY6WkSKfPoLUsV1Wg8ZV7fMMCrAqdtVWhVv1WvLR6WzG	13773	19407	19407	1619432460000	canonical
27864	3NKbGYDuqEk62KBc9PbqUn1gMQdqu5pXZMBgFe5sxzgfVzTHBUpc	27863	3NL35N2dXkYSZSvSiHxFQXu6D6PiKx1BhVTVw58UisRmACXPgHod	1623	830	544	12463	18974	jwXjmnvfFBk7mN8Thgyti5uzwTrP1BRGqiJhnHU6b4CsbN1wgrR	13775	19409	19409	1619432820000	canonical
27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	27866	3NLGdWAKeCXSCpHWYHsJtaw2g8t2uDmGTGPTrq3pbKDuRWP9JnFv	1536	1313	544	12463	18974	jx822MZyiDoY7uigp94bpdhmRUNL9RhyKCh6NxQiaURvDt1XjGb	13778	19413	19413	1619433540000	canonical
27870	3NLxDNabviqikNbtecEsX1AooSezv4ctEKgr9dDcqGLJNsaWtR2a	27867	3NLAhSDbNL4Qv9VyBu2zkhPrzEWKUV4bUVmHNdugob949Q1yhctk	1560	925	544	12463	18974	jx1JcHWvPk6rVqid8PqpNHHBTUkPkNMmsPqdnRaLCAEa9JMkoGo	13779	19414	19414	1619433720000	orphaned
27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	27875	3NL5igrMxismx4itCpmJLtw7jR1kQ61NqUbz6XyDsrdFn945uiSr	1611	1341	544	12463	18974	jy2GpPSfY9aRYCnyUrJbkVeaMhAhFDi21DYrF8DBiiVTuFxf4PT	13782	19417	19417	1619434260000	canonical
27879	3NK6AVaet9LjUM9pPmco26GKgu6267a6y8q4rbzwCcpcrvzoJrKL	27876	3NLAvhJpMqY3W5AwVKyGELtxmWDj2e2unM1zfPuco6DRJFR22yi5	684	1106	544	12463	18974	jxfzAuNFFwM5sxMzaavN4U5pV95ZXVtdqYbLtmA56wTvePup7BB	13783	19418	19418	1619434440000	orphaned
27881	3NK5wjZ9ENsxoQXyiqL1Ecuf3PqNbJnYwQ64U5cL9xwJGPdnKk4m	27878	3NKPuTcdBsfwq73Tyys8zR3grVLoT6QV7PAsR8g5D6v8miF8Z6HT	1513	1133	544	12463	18974	jwcJQoaNWY8THY4HukPD4TdPzUh4HoHJC7mVXLqSjdYdVXHSs2f	13784	19421	19421	1619434980000	canonical
27883	3NLbNhZq1BfZTbY4cojFQgFwMjABhvQNnPzEShWxjCXkn8PX7eVk	27881	3NK5wjZ9ENsxoQXyiqL1Ecuf3PqNbJnYwQ64U5cL9xwJGPdnKk4m	1654	1094	544	12463	18974	jwXJBTVA9YDr2thwm1uTPASfUDzcuiTAH1GW8RSwhWUHoV7rj2p	13785	19422	19422	1619435160000	canonical
27885	3NKE4m9MPFZnH6CwNGauPiDPtSZ5dbi2aQg8tYigjryT9jXJ7qWD	27884	3NKtoVoZcXQr7ZG7uewcuwQ52YaQVCEKeYgtvXjxExCs5qKoKhhU	1406	1393	544	12463	18974	jwb4Fpjot2xZkKAgNPaa2weNaKVjADwuN2twrgBHV21Eunu1QHH	13787	19426	19426	1619435880000	canonical
27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	27890	3NKfT8wFLh21277LNX4s7NzwJhR8jEmPEGyWJnLoamdfFCgTznbY	1406	1393	545	12463	18974	jwXKk9Q9i5fYFLqwQfG78Rvg6rVJ3vkA9T1fuh7SEqWHesY8iG8	13791	19432	19432	1619436960000	canonical
27893	3NKqXfbnBgzNuVzspZDKXEzTjLJH34F5ZgzLsU8YXkHiWgTYuemz	27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	1602	1003	545	12463	18974	jwihBAs7TtF4C3Q8sDauNPprfSnqTTnufh8xavuSXZQ3RirrLyA	13792	19433	19433	1619437140000	orphaned
27896	3NLMnmmcdM2qrzbbxZvnXxdHbMeeH4JV5nUxzzPTvLRkU6THmncf	27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	1673	1368	545	12463	18974	jwS1yhD8HFUdyiRoLjuBV6x76WRptPDbLUWg4ELaZ6G6DdMTnQU	13793	19435	19435	1619437500000	canonical
27900	3NLnJuykYEU94sQFXL23nAnsJkrwhaeTY5aX6V66yyzX4sZqzNn3	27899	3NLmtJXjA3YsyL7BPQNShxdPurTCkKar7FKZk94DtEBLHjpKBv4J	149	1037	545	12463	18974	jwDHAZCn6mGeShvTaXTXfi8mKa2VngVtCzvUwGEGwv5VfkT5jFi	13795	19437	19437	1619437860000	canonical
27903	3NKj9G3kb76cRvDmYvNPhkN5V9AEELDyZGSzgP7FaKWgYQ4f17cd	27902	3NKSSHjYn1LxdfmcJNJDPsqX73Z57jFciK3rMsCUYqepcar3XRsR	1672	1285	545	12463	18974	jwQUMPe6Gm88qz3Hm1aRcNJRWNDH3EjAbMwZZfHX5RKxd69TrtD	13798	19441	19441	1619438580000	canonical
27906	3NKyBee6sDUcZEnXYgbY1Y5Ux7fpHtANfQ9nVpNHgKKvzqdvJ8Jj	27905	3NK9WaUBZdtLHeRerszx7oVtQfJHkiWD1LMTJ6hoxnQdrpdsgB5u	1619	1275	545	12463	18974	jxuhLTZBSRAgJH4braJBroXD5MXxjYBcKZDRhsYdwhfVcsB4RYm	13801	19448	19448	1619439840000	canonical
27912	3NLyQdiCtvTTKUadBRZy6X7EHCF3kwWEESFhGpBVWosX2gBptGBz	27910	3NLb1wYiMGEoBwYp5riunKoTDd5KKW9Ktp7ZwRT6AFVxFCssP2mf	484	1319	545	12463	18974	jxu9mb5xepPkiDCr3sMt2RfFVbpbuLXRKzEVZGZHgYo6vURCFVp	13804	19453	19453	1619440740000	orphaned
27915	3NKFhqkJ2F8u6GN6fCKqSK9DKDD4sp9473kEz6W1DjiS6Hif9ALF	27914	3NL2Uw3P6C2odAsnXCabgrqEuHHVnKUkDc6nadS6gbqWzcGUsntr	1634	1085	545	12463	18974	jxtStKc2dzYpSTsarkpKkExEYzriQHAxeu7STcwspJhtQ6M387t	13807	19457	19457	1619441460000	canonical
27917	3NKbPmm6MYo7BSD71NcFCthhD5gGCmGdCURAEQbD77LnmLRTTFHH	27915	3NKFhqkJ2F8u6GN6fCKqSK9DKDD4sp9473kEz6W1DjiS6Hif9ALF	1609	1333	546	12463	18974	jxzbca7etCZBEpWRsY8VjQogHuWFoWGivKk2zanYJd62RTAgdCD	13808	19458	19458	1619441640000	canonical
27920	3NKoxRSQX3iK8QTzvtZb95wLhs5iTAjSQSBi1eiwTBgErkCup6sb	27917	3NKbPmm6MYo7BSD71NcFCthhD5gGCmGdCURAEQbD77LnmLRTTFHH	532	1177	546	12463	18974	jx6WRoj9fdLgT2LbX1K2j6aDYbewFRff5weeQxrVscb2Bv3EJuF	13809	19459	19459	1619441820000	orphaned
27921	3NKzgvtR18bGJRtWbXP1YFU1VV2u3tB5u4ZiCYK3kgx6Duv1PUsD	27919	3NLU78DeZcpYToMXhEdQaoUogMwJCszVHsp1N2xc8iKdrJVnwZWT	1581	778	546	12463	18974	jwGVFhYxkEB5E6wsTCdGNph1BKxHZbso3ozVLFnEkqfwWhBFbwP	13810	19460	19460	1619442000000	canonical
27924	3NKngGJaGpBirdTi7iNq9yizE85ABdJmAzgWhEP6vApWuZkUNuaP	27922	3NLbPfdNJa3Rr26sYfnPjGMg8B9DnMdVyx6Bh4T4ncU55ueVtH77	1513	1253	546	12463	18974	jxCj11TuMThqCFNAbnveUCc4KDTu8LX724ySye9AYradtsvaf5M	13812	19462	19462	1619442360000	canonical
27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	27925	3NKuJ8Cmand1Bf6mgnX2SotjvQhzn5mYENumrWVx3gkr4zTQFPxG	1672	1285	546	12463	18974	jxco9hUQntkLYs2TcRdVzgKnqZXRoBXwSkAfKLEbqsE8KZmBwKN	13814	19464	19464	1619442720000	canonical
27930	3NLwqH6B6cBWrJbhopuvYREx1w9AsiMuPbVLg19XR3beMX2utwHe	27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	1541	1298	546	12463	18974	jwekMNnsRQzoTzuqNKfBNmHkJxeyzsi2bYcwX4ij4YMyPbiUNE6	13815	19465	19465	1619442900000	orphaned
27933	3NKG5du2FV3SmW7sSfibw4qTSzvK9WZXou5mA6ZqoFLNadngVuu9	27931	3NKaRHzPXcDkxfuxDMETGbypajGputV6zqNAEqskouARu6WtdkvW	1578	1170	546	12463	18974	jwACDF5VqaUikKWDPW8r6vUaSgFMqS8aj8qebMHxB3YG2sAXiMd	13817	19469	19469	1619443620000	canonical
27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	27934	3NLZrPiSkf2hb46J2aT9FfdWKUSoJQut2isozCNYEP3sq6SG7ekk	1406	1393	546	12463	18974	jxovD2ZZhY9zvFZ3DM7Jjna2m2QJ66nLuNeCNYGx9SmGe1ythVU	13819	19473	19473	1619444340000	canonical
27938	3NLS1Ae81psoy3xK2CAssrpnD4ptXe4n9y1tFKUviRHHMkze9nkz	27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	44	1325	546	12463	18974	jwBdyg2tSJ4XgkXi7q9hfhy58o96ExUnuNtxz3YPEY4hq1xM2Qb	13820	19474	19474	1619444520000	orphaned
27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	27885	3NKE4m9MPFZnH6CwNGauPiDPtSZ5dbi2aQg8tYigjryT9jXJ7qWD	1407	1395	544	12463	18974	jxfX4145fB4kSNkSaUSSfw6kmpdxYLobFjzEVHr2WagRKixTunY	13788	19429	19429	1619436420000	canonical
27889	3NLurDvvFqvgBoZm5dtPHwVgfb3RD5wL8NyuFd5TfQNStd9DVFoW	27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	1521	166	544	12463	18974	jwACccACe9YDDnbE2FBYTKiVP62LVwbsyNDgqB9HRzhVfDoMkmT	13789	19430	19430	1619436600000	canonical
27888	3NKXyxVqNPL7oP3oGwqQecPhFTL7bRoS8a2g1vjsiwkHDokx2Pdp	27886	3NLNHSh6e4JsfSProdN2h9THuhUvVNwPT3W7iaGoRZiFjvejAPoW	1521	166	545	12463	18974	jwe9amUVFS3njVZF85Ayr5LwRURsWnUaA6PMT1Ri3P5oGgV4PnH	13789	19430	19430	1619436600000	orphaned
27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	1407	1395	545	12463	18974	jwaBbCo8kMf8MGH4nNijes4mqjNcL8drcXvGpH4uLPEFXXV2Kou	13792	19433	19433	1619437140000	canonical
27894	3NLVXtWtcDjvwFgjcyAUJ6pbavHi9XNjFgXdaZUJBMqdDz4dLpuw	27891	3NLojDfhurYacdweak6bGT1iZQE6iqdR5jzTu2UcHXBbEYZE1YdP	1571	969	545	12463	18974	jx2FTq1xeW9LwGJYH3hrPXEbqpkiWmf7MDavajJk6f7qRABzjRW	13792	19433	19433	1619437140000	orphaned
27895	3NLr1dt5hFivvnkRsKXnUjhCxzjpT5VdVJZUuNUbDP1tBPf3huQP	27892	3NLyGHKP1ihaKSwoJieUSFZWuLwiTDQ6kieeAnC1kHm3unxBcAeF	1406	1393	545	12463	18974	jxZsJGxiYTXxrLHu8jkRzkyn8G2WkvH4LRiVPg8Jj34LufLf9Bd	13793	19435	19435	1619437500000	orphaned
27898	3NLfxPGEr2LjUVugUWyQCLhsZDLoHyvEU3sJ42mEp61w3NBNfvjX	27896	3NLMnmmcdM2qrzbbxZvnXxdHbMeeH4JV5nUxzzPTvLRkU6THmncf	1406	1393	545	12463	18974	jxzSEwv7Mq4jx41SjRPXQ4gcWr4DxJRWxV2isFYSYWbZh42fdEY	13794	19436	19436	1619437680000	orphaned
27901	3NKb65e9YEcvvFdGSDWHWzt1KmjWfDmovnxrmQCFkFirKgjB7kSb	27900	3NLnJuykYEU94sQFXL23nAnsJkrwhaeTY5aX6V66yyzX4sZqzNn3	1406	1393	545	12463	18974	jwPm9E59yGsTDDbUMhpgQiBAF5GbrThhPjfz3zLmFCpSHbo6MWC	13796	19439	19439	1619438220000	canonical
27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	27906	3NKyBee6sDUcZEnXYgbY1Y5Ux7fpHtANfQ9nVpNHgKKvzqdvJ8Jj	58	1035	545	12463	18974	jwQXAQJYWJyLDKSmtQF6RDTesZS85muE4ShXYDmasHZLqa5jfAn	13802	19450	19450	1619440200000	canonical
27910	3NLb1wYiMGEoBwYp5riunKoTDd5KKW9Ktp7ZwRT6AFVxFCssP2mf	27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	498	498	545	12463	18974	jy11AuxDf6TirU6kPg94W8kHBNV13sFpDSTnkNTD9gTpq35Dcco	13803	19451	19451	1619440380000	canonical
27909	3NKDsqAMqa8yfuvM6EaztENtMGKqMAVNHX1FzE1u1R2YggUnYy2Y	27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	1407	1395	545	12463	18974	jxP21XDNuLXoG891YhgQii8rV4S4ute6YzdtLFvWd3yFtDbdRd9	13803	19451	19451	1619440380000	orphaned
27913	3NKG7YLaQrabgP6urJp88KEgosgU3R9ZmFGTFymQFsCkeCeKhjig	27911	3NLmCNAsC23ZFaquxFcAKtqqXbVDmrzxAhQzEtSMtRcDCS49pLP2	1581	778	545	12463	18974	jwq7snC1SpnoPGSUB2nSeEKgHn5iNQBDm4ANet2v4yvmTv6Pe8S	13805	19454	19454	1619440920000	canonical
27918	3NLXMoJSELmByCcxgUzRQtadXdKrB6cJxHBWp3xJYDAX9TyFzyg2	27914	3NL2Uw3P6C2odAsnXCabgrqEuHHVnKUkDc6nadS6gbqWzcGUsntr	1637	816	545	12463	18974	jxjAVrJA4FTwjMkD5HKGqQk11a9owgLHMHFCNBaryTKZUmevG8v	13807	19458	19458	1619441640000	orphaned
27916	3NLDnYCSvAzaTrbwZtcv1uzJ5Aby5DMVmN8z9e4imjLpkgC3Nxwi	27915	3NKFhqkJ2F8u6GN6fCKqSK9DKDD4sp9473kEz6W1DjiS6Hif9ALF	1609	1333	545	12463	18974	jxnkw26wfvWyv4feZWDkTDxoRaXF35E2tBNBdzdHvrDrLpLcgSz	13808	19458	19458	1619441640000	orphaned
27919	3NLU78DeZcpYToMXhEdQaoUogMwJCszVHsp1N2xc8iKdrJVnwZWT	27917	3NKbPmm6MYo7BSD71NcFCthhD5gGCmGdCURAEQbD77LnmLRTTFHH	43	1310	546	12463	18974	jwzAJpbj6ffAbBrxidk2fDzRrR4RXSykRwDUqhYj5GBQFo1aGNP	13809	19459	19459	1619441820000	canonical
27922	3NLbPfdNJa3Rr26sYfnPjGMg8B9DnMdVyx6Bh4T4ncU55ueVtH77	27921	3NKzgvtR18bGJRtWbXP1YFU1VV2u3tB5u4ZiCYK3kgx6Duv1PUsD	1483	562	546	12463	18974	jwnCKrj7nJ4356A2R3N5nfzBDSZbqcezX1QJoNC3Js5eRnio45C	13811	19461	19461	1619442180000	canonical
27925	3NKuJ8Cmand1Bf6mgnX2SotjvQhzn5mYENumrWVx3gkr4zTQFPxG	27924	3NKngGJaGpBirdTi7iNq9yizE85ABdJmAzgWhEP6vApWuZkUNuaP	1675	1342	546	12463	18974	jxYAipkseSTiLq3tUaSjodfeUXpQXAGFaoxYeD5zJHPW9kBaoCj	13813	19463	19463	1619442540000	canonical
27928	3NLU1Yq4a8kUHd2wf1mUoNFgJVp4qo8dejkzmeSkgvJJEUaWoUCh	27927	3NLTUTFQTeDGn7vp4ALWF61GB5NhSi3pqJWgbXBp17yN1CU8nNSA	1406	1393	546	12463	18974	jx9WCYrJ7sW4LYvUrUnDZeFrnQmzEt1CDpiqTU6eaAfgjpogtuA	13815	19465	19465	1619442900000	orphaned
27931	3NKaRHzPXcDkxfuxDMETGbypajGputV6zqNAEqskouARu6WtdkvW	27929	3NLwYsVYnzT542AEjMhptn9yUen3MZaqgqYyvMiiBBarmzLw9AtU	1407	1395	546	12463	18974	jwsksxtidRgUWx1z7YmdnNejSFDj6SUfUdjf4wtwgPFqtFqECQe	13816	19468	19468	1619443440000	canonical
27934	3NLZrPiSkf2hb46J2aT9FfdWKUSoJQut2isozCNYEP3sq6SG7ekk	27933	3NKG5du2FV3SmW7sSfibw4qTSzvK9WZXou5mA6ZqoFLNadngVuu9	1406	1393	546	12463	18974	jxWXq1QRBWEYADUXA47pgQJmgeCfzXcnSJPuD2nMhZwEJn62JXC	13818	19471	19471	1619443980000	canonical
27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	1407	1395	546	12463	18974	jws7dwew437YcB5z4kmc3p42MMACkcXVmuPVetEA4JF9dF15NAN	13825	19482	19482	1619445960000	canonical
27948	3NLCxSE44LEbsPFxuRtKBc49pLesL872XDmcJBPH7NKgppCmFCLy	27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	1673	1368	546	12463	18974	jw7qQjExzcLTFWTEmU3pWePoDqf9RWxStLQgsjbfxKPwM82bEnZ	13826	19484	19484	1619446320000	orphaned
27951	3NKs5c7YogBNSCbXRu6uGrauxqN5tUxKSjL5dbK83MYxts34gspp	27950	3NLVPsCjMtAu2zChuhcoM9csbTGqiHaERZm7DMyr611JU75w7W1C	1555	981	547	12463	18974	jwfPsLyjk2TjKiDSGfMMeaEZUwPBJ2kCJpXFN27KYV5YRqfG2tL	13828	19486	19486	1619446680000	orphaned
27954	3NLHTnm9tmGNxuCKiH6oJwfhYswJ7Dk8yFe5fcschMoxKwbPhdW4	27952	3NLk6HJe4oryhDQGZBZ7yoNiF7ijxj4TDakzbRezj5VQpNDY4zpc	1637	816	547	12463	18974	jwjdCyXCQ3dZ2EjfGjT74SqhdYsmpKF2pm6FERDtekyP6SC9h7Z	13829	19488	19488	1619447040000	canonical
27957	3NKdw6PXhERsRmRXkZsVa3rMLQYzkkeGsBn9ky34xCLWKVHbzY4T	27956	3NK7ZTMg23gjUt9XrSoUzvY2bFZoBJoHQsoWhJ6Ne8ErW5up1k3t	1483	1150	547	12463	18974	jwgxuipMoAFegijK8hAxPJZ8FCUbw54SUrDTmijQFju82Mgcsok	13831	19491	19491	1619447580000	orphaned
27960	3NKkgLPiAMWkVxHwm9svE4SDcftgAuZPhuMB4ziAi9iYf1mJjrnu	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1541	1298	547	12463	18974	jwgu2NCFw7YvrjHAme2CMr7rasCmZJ89mJPurQkSmyFwdu2QUNs	13832	19493	19493	1619447940000	orphaned
27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	27965	3NKJaaVCQvYdffjLvxzNuLJP1ovHkpPGNSwDvmTCt4tDtGTzaxDA	529	529	547	12463	18974	jxieVYDddzYUD1JANBHyjrgJVLYHmJYNz3GJFfefm2K4cFW1DAB	13834	19498	19498	1619448840000	canonical
27969	3NKeA3oCDGhvfdRikBceD3MBkZLWShPsDJuHjFyJ4jTKzSKsxKp9	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1407	1395	547	12463	18974	jxviK7oBp4xLG6NUvzEni1GWr72QtwUMR7XoB1kZAV95EsGoYzU	13835	19501	19501	1619449380000	orphaned
27972	3NLZ73t7t7iBouaz5PWjaYuh6GTomCGRp29BfBNh7QuYDRhZoZb9	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1439	1279	547	12463	18974	jwVfPrchqDZkA3Yggv1X21fKb5nUSqovycgYK1Ng4ki1VLnjtqU	13835	19501	19501	1619449380000	orphaned
27899	3NLmtJXjA3YsyL7BPQNShxdPurTCkKar7FKZk94DtEBLHjpKBv4J	27896	3NLMnmmcdM2qrzbbxZvnXxdHbMeeH4JV5nUxzzPTvLRkU6THmncf	80	1027	545	12463	18974	jxZ9k9gH7RoACjLrkU4a6FhwZY24FjgvkmD8jFq4kYLsBgAdHcZ	13794	19436	19436	1619437680000	canonical
27902	3NKSSHjYn1LxdfmcJNJDPsqX73Z57jFciK3rMsCUYqepcar3XRsR	27901	3NKb65e9YEcvvFdGSDWHWzt1KmjWfDmovnxrmQCFkFirKgjB7kSb	1668	1004	545	12463	18974	jw7H3JcNKQEzCiPMq1cbiqCY4WnyPdhsUGjzb5iHby4B61EsgrX	13797	19440	19440	1619438400000	canonical
27905	3NK9WaUBZdtLHeRerszx7oVtQfJHkiWD1LMTJ6hoxnQdrpdsgB5u	27904	3NKVhGiUce8y9sZjvcrnGToaREa1fYw86hPSuWgcrttWXMmYDUVK	1613	1349	545	12463	18974	jwGL9pPkBzSSbHoTxS2bJ3HrsK7pqZ8CCBGW3APg3NivScvtiia	13800	19447	19447	1619439660000	canonical
27908	3NKNTtQeA53bkdovz4sSUL5RzqfrYuNDnSp4BspQJn1oppXX54dh	27907	3NKeTPCofLc86ZUZTBfNQzBooF1tmbb3JPMCPovsTf5vG4E5NotD	1460	624	545	12463	18974	jxiQoXitKGNjZb6evB6ugrJnvWzkn46xTyQFYhyaTCoh6fKwnSb	13803	19451	19451	1619440380000	orphaned
27911	3NLmCNAsC23ZFaquxFcAKtqqXbVDmrzxAhQzEtSMtRcDCS49pLP2	27910	3NLb1wYiMGEoBwYp5riunKoTDd5KKW9Ktp7ZwRT6AFVxFCssP2mf	1406	1393	545	12463	18974	jx4NhPvfDZZqTdofzpc3yowX385z3GTXRWikE22YjYVaHq1AhZB	13804	19453	19453	1619440740000	canonical
27914	3NL2Uw3P6C2odAsnXCabgrqEuHHVnKUkDc6nadS6gbqWzcGUsntr	27913	3NKG7YLaQrabgP6urJp88KEgosgU3R9ZmFGTFymQFsCkeCeKhjig	42	1361	545	12463	18974	jy2v67KSAmpv1Refj5oPb9QoFRTKhZPwnY1ppb4fQfDLx4rzLFN	13806	19455	19455	1619441100000	canonical
27923	3NLAT8rDs1zm89uNPFp4PyEFb9tZBay22M2DzBdq32c5TUsfBsBH	27921	3NKzgvtR18bGJRtWbXP1YFU1VV2u3tB5u4ZiCYK3kgx6Duv1PUsD	1483	562	546	12463	18974	jxJs8qhaMQ2CKCyuA4JYWkinkLpWT8nr2SHxryGQGjP6mMmpDSm	13811	19461	19461	1619442180000	orphaned
27926	3NKKm32jnaH3aDj8YbtviNDscBEd54axBG32gogSrsb8t2jGqGBr	27924	3NKngGJaGpBirdTi7iNq9yizE85ABdJmAzgWhEP6vApWuZkUNuaP	1617	267	546	12463	18974	jxK6fcFxuTrApnNLnDQJRS1dXBU3FKdgQyGxziz2BDRkp9w9yAz	13813	19463	19463	1619442540000	orphaned
27932	3NL98s4SvaJQrCw2i7NLYg1ETLTri1V4W4WNunoDahEBvdc8FvDp	27931	3NKaRHzPXcDkxfuxDMETGbypajGputV6zqNAEqskouARu6WtdkvW	1406	1393	546	12463	18974	jxvKULhSeBBAHrWM5c2k8vCXmknakAjDFsBiaT5xp2sjNBwocEF	13817	19469	19469	1619443620000	orphaned
27935	3NKPAtecwzTtSDQE7Ja6hrK82gGXKkysG3j1hfsNsPcrYwtzro6L	27933	3NKG5du2FV3SmW7sSfibw4qTSzvK9WZXou5mA6ZqoFLNadngVuu9	1476	1125	546	12463	18974	jw8WjdQ82woTKu296mBhZBSFNwH5UMm9jMaUUQCGcrnYBEnrypP	13818	19471	19471	1619443980000	orphaned
27937	3NLF5ubWy3KBsCdmYta8fdEvmZpdbiGGdY2j1rhLwMvkzkM8wFfH	27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	1402	874	546	12463	18974	jxuGZwN17NcSP6ZWcJGH331D8T6eXGvP4PbTA1jWdHTQEp3u95Q	13820	19474	19474	1619444520000	canonical
27939	3NKBn2B2MTpWaBJX5LbTU7ipWuzQHM856Se3UY45x9HHydxbncHR	27936	3NLWhmLV4oXUckrBFsDHJVYtkCCRuBs7ypx3ATT77cuxqUfiGo4W	311	1061	546	12463	18974	jxuRhooWYoYaxrjZfgmQj95oa6TNtyxL9UEbpK2rmz3cFBCtL96	13820	19474	19474	1619444520000	orphaned
27940	3NKF6SbQcS12kbEQc8EXjodce9cG6SVG8mRrAvR62gaaPaMZ3yCg	27937	3NLF5ubWy3KBsCdmYta8fdEvmZpdbiGGdY2j1rhLwMvkzkM8wFfH	1406	1393	546	12463	18974	jxt1Ea72v6rMzqz4EM2aQX4ZaiV9P6gCpfnkWZZLmLumPxXgzdJ	13821	19475	19475	1619444700000	canonical
27941	3NL3diNeXvVnq5pBPZgb1TUksJGPaYSDST4AqipYojJ8jGWbyqqL	27940	3NKF6SbQcS12kbEQc8EXjodce9cG6SVG8mRrAvR62gaaPaMZ3yCg	1630	655	546	12463	18974	jwNdKgLnK7yoQ85cLkEQYkiGpLU19sedVyGpxAsKNzViknwENdE	13822	19476	19476	1619444880000	canonical
27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	27942	3NKsVJz8UzStvmyxCUcjWToUeufSpjL5eThAyCuz4f7L6DNmZ3tA	1407	1395	546	12463	18974	jwcp4W8KFGUgDgTP11KxJjBRKhD16g4j8FLARCyA3QR2aUFm9zF	13824	19481	19481	1619445780000	canonical
27944	3NLDgPp3vehDAUvETpQQQVZ7j6K4kac3u2kV82Hx75V7Hhgj7xNd	27943	3NKhRbH5sdUsv5TxLzecAtdehFKrKzZMsgcUnbXimEH7vsKbHzCc	1406	1393	546	12463	18974	jwGh8zqXdhdRphSnzhtwgVxRdtUeZBxTkFK8ZkKRx8Vo2ui2KeB	13825	19482	19482	1619445960000	orphaned
27949	3NLnHCLB1j5jUMi8SeCCBg4peunmDTPU4pAbrFgqNn1pbEFzTFVa	27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	1581	778	546	12463	18974	jwtakXaTvSfn7qFadCFuJR8S8HkMvaHpjWYB2JSuvYf3jwPhrJo	13826	19484	19484	1619446320000	canonical
27947	3NKyxdKCV9bNuowG2XPJCWJrrLs9r3gwwSf2ZhJQgwKdzW2tdSmD	27945	3NLrL6tQ8bzgkcsw1TGqbiQwW6H6re9YmFTLissyzwUiDmV8jo2K	1406	1393	546	12463	18974	jy3Fef1RBjZ9iyT1DiC1Vxif5MSh4mgmpMonQjwKaABJg6hb1bv	13826	19484	19484	1619446320000	orphaned
27950	3NLVPsCjMtAu2zChuhcoM9csbTGqiHaERZm7DMyr611JU75w7W1C	27949	3NLnHCLB1j5jUMi8SeCCBg4peunmDTPU4pAbrFgqNn1pbEFzTFVa	1407	1395	546	12463	18974	jwnixvANHGUGy2hsvYws8zBDSQT4yyTHA3VAXcDFEQTXryx8zBw	13827	19485	19485	1619446500000	canonical
27964	3NLxcWf8j51yt9soabD1TeBz5LbDzvmgyQJCDQegnp7zb7veEJmB	27949	3NLnHCLB1j5jUMi8SeCCBg4peunmDTPU4pAbrFgqNn1pbEFzTFVa	1633	1390	546	12463	18974	jwa4GyRcK7iir9EwfsJoLCd2yUbtaHS81MpNiAqJe7fD7aWGses	13827	19496	19496	1619448480000	orphaned
27952	3NLk6HJe4oryhDQGZBZ7yoNiF7ijxj4TDakzbRezj5VQpNDY4zpc	27950	3NLVPsCjMtAu2zChuhcoM9csbTGqiHaERZm7DMyr611JU75w7W1C	1555	981	547	12463	18974	jwfPsLyjk2TjKiDSGfMMeaEZUwPBJ2kCJpXFN27KYV5YRqfG2tL	13828	19486	19486	1619446680000	canonical
27953	3NLkqkYjdd1pGr1tTSPoPeAbjG47PbUdzE4KWc66QPHWJxsBB6YB	27952	3NLk6HJe4oryhDQGZBZ7yoNiF7ijxj4TDakzbRezj5VQpNDY4zpc	1407	1395	547	12463	18974	jx3ESNTZPd7PPztAiYmXoEVsxAHbj5ubxqqEoGy5M5fYA8B5deP	13829	19488	19488	1619447040000	orphaned
27956	3NK7ZTMg23gjUt9XrSoUzvY2bFZoBJoHQsoWhJ6Ne8ErW5up1k3t	27954	3NLHTnm9tmGNxuCKiH6oJwfhYswJ7Dk8yFe5fcschMoxKwbPhdW4	1407	1395	547	12463	18974	jwETbvBQHSM54kJPyGRUEXCz7jVisuVRDz91cb5vGoELD86pQZ6	13830	19490	19490	1619447400000	canonical
27955	3NLWZcATPPr18ZNaGqSMKJZ2MvDRw9c59xCbk4mcvhdS8e4PCJwn	27954	3NLHTnm9tmGNxuCKiH6oJwfhYswJ7Dk8yFe5fcschMoxKwbPhdW4	1406	1393	547	12463	18974	jxmSfPe1dFLpGXgURn1K8EnzuCrJkQvPPTBNcwJtpqQt54x8S6q	13830	19490	19490	1619447400000	orphaned
27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	27956	3NK7ZTMg23gjUt9XrSoUzvY2bFZoBJoHQsoWhJ6Ne8ErW5up1k3t	1483	1150	547	12463	18974	jwUgSk8TW79XcZx1hp8xi512GAhiqE7uWZcpQc17YbeYZqQ14cU	13831	19491	19491	1619447580000	canonical
27959	3NLwQKnixEVCYLgSR5m87VHsvoJJwdttTsoBRoNp8v33NknJyCEB	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1600	1006	547	12463	18974	jwZkZ6v5bg6zgUp7cvfRxH7TtGgkqqFG7BKWqkfeVpL5RhsHSSW	13832	19493	19493	1619447940000	canonical
27962	3NKvZLcizeJtDsdzoSFEF57Jq8wmF7Q3tLvhw4KhEnus9vjfvgpN	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1541	1298	547	12463	18974	jwV7XNprkY6W6k8ywxWnrg8owadGomKykp6R3AncuNmHyLk1Czo	13832	19493	19493	1619447940000	orphaned
27961	3NL5m3NkNRWgWc9Wu7mTh8o8sXz9mHiRutnHnK3sQKZn7YydGeMG	27958	3NLTEzcPwsvWBAYA7itUiwyB2qeBsMBV9ywAczVoKgCAhvSPUAda	1541	1298	547	12463	18974	jwwayGjePxMGr85rXDwbEUP4BXsaL6CZvV1KKNtZ4ifGq7naMCz	13832	19493	19493	1619447940000	orphaned
27965	3NKJaaVCQvYdffjLvxzNuLJP1ovHkpPGNSwDvmTCt4tDtGTzaxDA	27959	3NLwQKnixEVCYLgSR5m87VHsvoJJwdttTsoBRoNp8v33NknJyCEB	1633	1390	547	12463	18974	jxCSurC566tHrGnYNsN2LnJpQhkJ3yQe34od6wTEMmZHg1R3cor	13833	19496	19496	1619448480000	canonical
27977	3NL4NTbA85dSfQWfmZitiCoaFxJF1vHwWFzeFQZEgZA1iiKAAk7h	27871	3NKis9LVvg64XUvc2MA2dBYTEJk5qFU2FLMezdZ5AQPcbVHBntfF	1560	1291	543	12463	18974	jwCBf5YVoAMJUuqk4g9rTmyT5dPA36Uxg4293ZBmC9rfqQGka4z	13741	19503	19503	1619449740000	orphaned
27971	3NKYBwWFRpFbkwYACvSM3NU4LXZDmdFcqqbci2unTDjEP13zcuqa	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1529	1070	547	12463	18974	jxWuqE7hjV2pHVyz9DjXAg1YmTzShDASFxUewUffekBJRpivAGD	13835	19501	19501	1619449380000	canonical
27967	3NL3AvtEeoWFXC45Atkr12HzTJL7STpGJS2sopZ13EkZ48jQtjDS	27966	3NLFCdzKPLuuQFCtLyUXd6ZZMhcTRXP6JL7BNAMTBPgmgN7yNevv	1423	332	547	12463	18974	jx1CEPvuXZGNMbvLgmKZBzDd8XbbRR9nbiYE6zu6evuBPZ8rRYY	13835	19501	19501	1619449380000	orphaned
27974	3NK3dnDEXaCPQykuBrHiVxApxyCXE33osX4zztf3Kb4qSDoYdgkj	27971	3NKYBwWFRpFbkwYACvSM3NU4LXZDmdFcqqbci2unTDjEP13zcuqa	1407	1395	547	12463	18974	jxpTwtAFEo5bDYxDjeEZ6fpf4qfC7GqsMdk3Q712fpt59j23mKX	13836	19502	19502	1619449560000	canonical
27976	3NKwx71DZQbZ6mGmcVdL6ra1sCJ8UyRALfqCVFcrbkTvBmGiYanp	27974	3NK3dnDEXaCPQykuBrHiVxApxyCXE33osX4zztf3Kb4qSDoYdgkj	1560	1291	547	12463	18974	jwAm2hiiy9RmXEiDMmojEpLQ2FcC3KZvQEFLvXrL5TeoPjzvbYi	13837	19503	19503	1619449740000	canonical
27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	27978	3NLHJ2Su2NhZd52ETYPnm8VWRAG5QziSk33PSBfxVV1nf2ojboky	152	1330	547	12463	18974	jwzGXhxBjiwBeFW7UjMtWJmCh9DGY6ygcL4eTmLwBFzBYnjKZ9V	13839	19507	19507	1619450460000	canonical
27982	3NLKMmgRfQHkzUoNyA8bGjdkZCc5NfV1NS5eoyA2ArP5JebuXo65	27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	1406	1393	547	12463	18974	jx6LWjni15JWQGVtBrGBoqcZ9SLsSvTHFBLFgTzvFQrvjmPep2s	13840	19508	19508	1619450640000	canonical
27980	3NLvy7BvQq1Tgaov1ATNy5oirarWDYNE7r2ZNLfGYL8gdvst8hLT	27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	58	1155	547	12463	18974	jxCmhkfgqqnndQ2xTJsDLALbhAjVb3yCBYkx22DKSdYsA2sF7jr	13840	19508	19508	1619450640000	orphaned
27983	3NKu2DinaUwqU2vD9hmkwCPFR4DQ8MrfjJXcMsK1Bau3EAzibRe1	27982	3NLKMmgRfQHkzUoNyA8bGjdkZCc5NfV1NS5eoyA2ArP5JebuXo65	1406	1393	547	12463	18974	jxUQFXS2Q9krDSzpuTw3sFH5k5BGyDRyPz2LRbwTvKcW9UiXCPQ	13841	19510	19510	1619451000000	canonical
27985	3NLPTr5zTkm98XJQnAzxQqrrFnvcE8xKixom2RAS1TNS3uxS4QqN	27983	3NKu2DinaUwqU2vD9hmkwCPFR4DQ8MrfjJXcMsK1Bau3EAzibRe1	1578	1170	547	12463	18974	jwyAGqyp4GVhJXTvCHzcAtc4Toy9frwgmqkQZoQTHrBMURNe8FX	13842	19511	19511	1619451180000	canonical
27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	27985	3NLPTr5zTkm98XJQnAzxQqrrFnvcE8xKixom2RAS1TNS3uxS4QqN	1407	1395	547	12463	18974	jwiVq7QbTCh1qpeADNqQCc9m56jevM6zXkkxuMYkeA426FU2Y1b	13843	19513	19513	1619451540000	canonical
27988	3NKVaChVRmy5VfEqGHF9DPUdcrEebABkYDZuTDE7V42SrMe1ZCmE	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	44	1079	547	12463	18974	jwbNA7PGwhehY6d3dS6aiZFXQewiaWZ8hczcuansMhkT4jCkHHs	13844	19516	19516	1619452080000	orphaned
27989	3NLX6WvwbNEb5RQc7wKXA7YgVG3mzxMqrR6XxBNK8aSDLAEMKDAr	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	1529	1070	547	12463	18974	jxgiV8wAmuPmDGvErbFoFbquMaCup1JnNKbDvPGngASJXK8fmWb	13844	19516	19516	1619452080000	orphaned
27991	3NLe8yaAtinow18Wo3N55vxEqryCgwdmcutS6MS5i52CSqpG7qUa	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1549	1362	547	12463	18974	jx54MDxyPMoweAPm6RVU2yXyuqM4aU59LK2hgRuhE8CjgYWimZm	13845	19517	19517	1619452260000	orphaned
27994	3NLD88Sm4EMQ1vFzkZ7o7U4FJK1LNJ5scHzuJJzoa56NWcraAzQg	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1549	1362	548	12463	18974	jwpLm4EuWiPb1UBLiFkY8jkHnsVB8mV6uiL2FS7FcgpZeS4nAnB	13845	19517	19517	1619452260000	orphaned
27992	3NLiaCNYrzc59xYvhWgL2uF8e3h1t7PsyX4wWBYQvZCDHBNZhUt4	27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	1406	1393	548	12463	18974	jxYAkZKni4dWzcc5pnDJHWmr4xZZEmjzpVf5Yu6nbE4bFdn34oN	13845	19517	19517	1619452260000	orphaned
27995	3NK6BbActwJfNUP37WbQyAyTmXcRbjGZV3onN7CWgXbNaQTKXA1n	27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	1523	1195	548	12463	18974	jwu5swX9h3F37RKWk3MAWDD5bcLiXVSaGqTBg36PvWviUox4fhY	13846	19518	19518	1619452440000	orphaned
27998	3NLuApFnEJqU4fphEC3Qgg1CqvrJoVMz3KdNtoWqbipMxHjeEtW4	27997	3NLmxGvPmsJYdCteq2mikbi6wXUnYBPMf4uHAEEvr9ixA83f9YYh	1406	1393	548	12463	18974	jxSAbHyGi3cMTBcxRdgQiwsMYFzjfgjpajcjRjVzs41aVHGebUg	13847	19519	19519	1619452620000	canonical
28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	28003	3NLHYosimxTMmf4mchBpeFhfWMekv2V8v6QL8XHAXm3fZzfyJrLh	1501	1360	548	12463	18974	jxaLHEYP54NFfcy5bqLRoSwnjrv9v7WZnqrw1eRQS95ok5u9h2h	13850	19522	19522	1619453160000	canonical
28010	3NKxskNX2kKR6asFLNTLMNHDdnd1jTxgMCNmSRzSYTsBPWFaJWJP	28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	1560	1165	548	12463	18974	jwtK6KGtHGF8rPgWxY1Xe81FKZPGEooM284JGoYmof4Apx7qaKW	13851	19523	19523	1619453340000	canonical
28007	3NK9cQgcPqiVQxgLpY4eRpsf59jpv4DZo7TckoAWZwpMryqHEM6g	28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	1467	1250	548	12463	18974	jxkxyJ1ugYCPDhrsMs2rZND4RBhfxpTp7aKfSwdvtfeYSc5D841	13851	19523	19523	1619453340000	orphaned
28013	3NKf8MwCWitidk2CTScTAnqYVKQQVeX6XcuaiiA6shje6gRVj4JQ	28012	3NK5HzLtgSy6HBHjYDcUog6vgA5bpDesk2E4T1MojWRZMjfERQ2f	1608	1289	548	12463	18974	jxxxHpcp5AMzvJLpYDmYE2e9PWvFKH2ZMfVECypCLx4WscQQXMD	13854	19527	19527	1619454060000	canonical
28016	3NKuhbS2jHGZtAtM4XK9eF7GqzXtCwvnnxFFAE7ZRd7mjGejhWm3	28015	3NLgBz3Sowx3doLS9EJxHeXYCSN8QrBM9DKysKWiUhPZycR9GHBi	1579	1143	548	12463	18974	jxxBatYqZtKKn9NqGBPLet1sdLUA4ame59NgoH2NhdEwdDscukZ	13856	19529	19529	1619454420000	canonical
28019	3NLqYHjAUZWvYGWaHEUDtrwMzEppiTakyPZrgBYF51TjGT63HpAj	28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	1546	1546	548	12463	18974	jxuXeswGVX9g5NXNGabVCcWR6sfK3eZL7iNZe2NxH2TggLFjEgC	13859	19534	19534	1619455320000	orphaned
28022	3NKAhT1HRPsYGEwYgFqPzgiNReftW1SrYgfGTB6NwDs5etc8HCsQ	28021	3NLmjNVYSxzPA6ZoBgu9gT2wy45fhxhFxEpBfRhH7CBfuBfSi9nK	1406	1393	548	12463	18974	jwiyHAdu2pbvSW7SnKa1f3obK4tUSZVP1WoFzfE94N39h3cjsNA	13860	19535	19535	1619455500000	orphaned
28025	3NL9KjxLMQDCcoJ3H4sGXh3gitdrUEP4yPHfqmVXNHgdK3nuP2H8	28023	3NLUQPcYzt6re6cKEs4s7tLjYhxgomwCvnqSWGdKcQfyVGpUWg9u	1460	1078	548	12463	18974	jxfXMybnxQiN7i8xsrRVj7FTLKfJxdxaKzeQ2XULP2Zb7PbJUDo	13861	19537	19537	1619455860000	canonical
28028	3NKMaZ4NMeEbZuBXBX8oCGnpe1pq4rsi8SkRpTVKL9ReUUygpoz1	28025	3NL9KjxLMQDCcoJ3H4sGXh3gitdrUEP4yPHfqmVXNHgdK3nuP2H8	632	1382	548	12463	18974	jwCckuQff14LK8AnJBd6ZWy2BW81sRtgKYCTzALhRfztA6MTRPc	13862	19538	19538	1619456040000	canonical
28029	3NLFs8BjAAHAanDnLgybghCv5SAjWQ4vZyKErAtTxQtFu7VXYvZw	27681	3NKjxZrKhbzW2AbdhFNw2SuPbyc2izaeayvgHhJ3iZtpHfFMguca	1671	1119	539	12463	18974	jx3zUpX2aGmphELhMUDMWq66BsDRzdk3hmSXh6n9wfTqLvUiovo	13679	19538	19538	1619456074285	orphaned
27999	3NLwe8nkPi3UtXwR1VEfGCeiWFxFWirr6dAbRZoMLLdte5wZst31	27959	3NLwQKnixEVCYLgSR5m87VHsvoJJwdttTsoBRoNp8v33NknJyCEB	1559	1353	547	12463	18974	jxPcHCbaZujNd4q42MSXRjdqbvY5xe6i3EpzTWDRBLmQzUHGUaq	13833	19519	19519	1619452620000	orphaned
27975	3NK4LkViw5H9UFsMV7X14otZ8GBTgZJmjNz3aee4NFuNt6gjBrUT	27974	3NK3dnDEXaCPQykuBrHiVxApxyCXE33osX4zztf3Kb4qSDoYdgkj	1601	1388	547	12463	18974	jxvWLMJxJkziMtLFSqn3Hebs9nu5cGUjyJPtR5QwLg6TybsMnBT	13837	19503	19503	1619449740000	orphaned
27978	3NLHJ2Su2NhZd52ETYPnm8VWRAG5QziSk33PSBfxVV1nf2ojboky	27976	3NKwx71DZQbZ6mGmcVdL6ra1sCJ8UyRALfqCVFcrbkTvBmGiYanp	1675	1216	547	12463	18974	jwueHU8BcboAjQe1i6nrQAbGeXUcCrpazgYBzGSyiguvaEWbyaL	13838	19506	19506	1619450280000	canonical
27981	3NKrSj7ByFKpe7Z8Habx1SCoRWS1HvPEXKBppubMp9ZdvnsPUG7X	27979	3NKGGsZ48hAyafrbWtAWFhx1kRhQiZLNFDoTANrkjeh1V9mM6r3r	1407	1395	547	12463	18974	jwtSssNcopr7RS1ChAsotTu7Zvjp7fy7ToRWsD8gisRRZdprViy	13840	19508	19508	1619450640000	orphaned
27984	3NKBtEwRX3FaBdXQqoDJJRa6KY9YMeWnXduzgToiKKzVQXKULmTB	27982	3NLKMmgRfQHkzUoNyA8bGjdkZCc5NfV1NS5eoyA2ArP5JebuXo65	1546	1339	547	12463	18974	jxRL6LT3mNGvYoEwiDDdfteHvEpB3q9x2s5YDN9eazjNJsyugqw	13841	19510	19510	1619451000000	orphaned
27990	3NLQQX32duNidYW15tL61Y4GwdfgCqGoLoRa5ts1ieYHUyCaGqFo	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	1529	1070	547	12463	18974	jxgiV8wAmuPmDGvErbFoFbquMaCup1JnNKbDvPGngASJXK8fmWb	13844	19516	19516	1619452080000	canonical
27987	3NLTBKYhVhMSYAcMijGzhiCCyUMqgdJFpUhzHttSMX9AjNSJbPq3	27986	3NKV5h5DpUnVjTiTLWXdsbuP8mAivGterGdTCgyfQrRtFfANx9hj	1529	1070	547	12463	18974	jwLKpNWWFMnNqho6keLou6rE1xXoBXTsbJr4bdtdykqALmj9zj8	13844	19516	19516	1619452080000	orphaned
27996	3NLfA1kXMhyKZuDiqfnToqC46mqzhbTcjBogrbe7jLhxSJeRbV1h	27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	1523	1195	548	12463	18974	jwPSyxAMmpjLjgkRjUJUessDjkoGmgacu1CEJNiTBg26xXnjyJy	13846	19518	19518	1619452440000	orphaned
28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	27998	3NLuApFnEJqU4fphEC3Qgg1CqvrJoVMz3KdNtoWqbipMxHjeEtW4	1581	778	548	12463	18974	jy19afECchDrBXXeSdRpajy8rar1RYx2cLMZ21fVmkijqghTKAZ	13848	19520	19520	1619452800000	canonical
28005	3NLdEhwNoV3ogkHAfaDodRDoW2GKZZ39BrE9KMsKhcM3hTDpttpz	28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	1501	1360	548	12463	18974	jx2JVaG4gucBo4RBjnumTNF1hrrv7mRvLULMrgawSQCBT7kT6KE	13849	19522	19522	1619453160000	orphaned
28008	3NLVauighhohop9Wm1dB7zSBdJRzNqydqbCge7TzchKLuiaqwc2b	28004	3NKYBcNDWhgFsR4Q1BiUh82QSXGhnVPr24J1hkTDVAjVydUKSM8S	1407	1395	548	12463	18974	jxYEAMgB8uyqLE7QbMZptrUFfCgBHzTcjTHc86ZePHpfjRTh8Sk	13851	19523	19523	1619453340000	orphaned
28011	3NKWVG8V9fUkjAhjqsGuadLG61tEuMBP3Jz8WmAiu1RUxRv5QQr9	28010	3NKxskNX2kKR6asFLNTLMNHDdnd1jTxgMCNmSRzSYTsBPWFaJWJP	1455	1206	548	12463	18974	jxVhzgUac1caEXCxxQfv4bXd4USWtbZFKcmK4vvJDXh8QrfQCDq	13852	19524	19524	1619453520000	canonical
28014	3NLJmmxK44rQLhxbH4n1GVG8FQ59hNbvxQjHXCYdKNWum65QwCon	28013	3NKf8MwCWitidk2CTScTAnqYVKQQVeX6XcuaiiA6shje6gRVj4JQ	1542	938	548	12463	18974	jwfossMYcjkWwG5poBSgEFpVQL6QEaZ53vUrVEAvGVnZr8RN6F1	13855	19528	19528	1619454240000	orphaned
28017	3NK4X3T1Kx7yBLoJf9fk3mYNwy4DQmGLUNpbygf7DEKqVZmktNB2	28016	3NKuhbS2jHGZtAtM4XK9eF7GqzXtCwvnnxFFAE7ZRd7mjGejhWm3	1588	1392	548	12463	18974	jxtt3ak5JHAFZ3XaoNfjJXowZpemiCQqnr3VTWB3nnQoBKN6975	13857	19530	19530	1619454600000	canonical
28020	3NLgHYLW7HBPyWupEp4yWFQDuxSefKcgXRPYG21JyZu5PQCC3War	28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	1546	1546	548	12463	18974	jwmxmm1Mbcwbr4w5pjUPQvCAzgRJagkLderwVjqUMyCQHDst44i	13859	19534	19534	1619455320000	orphaned
28023	3NLUQPcYzt6re6cKEs4s7tLjYhxgomwCvnqSWGdKcQfyVGpUWg9u	28021	3NLmjNVYSxzPA6ZoBgu9gT2wy45fhxhFxEpBfRhH7CBfuBfSi9nK	1587	1357	548	12463	18974	jx6g7bueK1n7FGnkPxJKw6DYoeV7sfbuSGTu1hD5LJEeV4XjkfL	13860	19535	19535	1619455500000	canonical
28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	28028	3NKMaZ4NMeEbZuBXBX8oCGnpe1pq4rsi8SkRpTVKL9ReUUygpoz1	1623	839	548	12463	18974	jx8VDJ1hMqvegH7BAgFkq2NBoQpu7LACksKbk6vYGjn5vmFFZLG	13863	19539	19539	1619456220000	canonical
28034	3NL6vqJWosHLWqH2jhKT6P9sfeE39YDuYNuyHP9ZaNuZvXfMyiRg	28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	1601	1142	548	12463	18974	jxkJJ2xu1G823y9yQD5j1XRZ33MUMA5FxXdaTpQjkL7geQejEzp	13864	19544	19544	1619457120000	canonical
28035	3NK845mmL5vEQyKWcZJNywXMttjSaDz5D8gAuRHzUSo77UqHfKZj	28034	3NL6vqJWosHLWqH2jhKT6P9sfeE39YDuYNuyHP9ZaNuZvXfMyiRg	1637	816	548	12463	18974	jxkvMN4WY7QQiSKXKAjB2FkbN6zbfB7RKTNym2Tda9rHWjF47qu	13865	19545	19545	1619457300000	canonical
28038	3NKcAzfPsEmr5Xd9gD5AX7k1XbPYDPrKu98Fp91nrEijP2355Fmj	28035	3NK845mmL5vEQyKWcZJNywXMttjSaDz5D8gAuRHzUSo77UqHfKZj	1624	1334	549	12463	18974	jxcCm1WhtcbVc12Ks49ebQJ9x85ioPBjkCaYSBbyH16HSn1zjBn	13866	19546	19546	1619457480000	canonical
28037	3NLZJg1ZVWLT8bBr9ED5dBL9HDJGqaLRhNSa1TapuiYdd17TSgEs	28035	3NK845mmL5vEQyKWcZJNywXMttjSaDz5D8gAuRHzUSo77UqHfKZj	1647	845	549	12463	18974	jxRG18a1zWc9xk4YdtSVbKeUnueqeBGzjUzRr4JpNtyZRGb2uXe	13866	19546	19546	1619457480000	orphaned
28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	28038	3NKcAzfPsEmr5Xd9gD5AX7k1XbPYDPrKu98Fp91nrEijP2355Fmj	1483	1276	549	12463	18974	jwz2HxDnhiuD8aG71qn6b2q2sumKjnsQg22orMFMbfEfRX2VNnh	13867	19547	19547	1619457660000	canonical
28046	3NLB3VPzp1QjneUteLJgqp6GLixFrLmQKjHRvYXs2KviyJc9Nm39	28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	1509	1194	549	12463	18974	jwPzeo8Hfy7WLdUQMNpKLYpJS1QmZPiAFqDvNMNNKoV1RVsgMtk	13868	19551	19551	1619458429881	orphaned
28043	3NKbY74e7edGCGKYJsSRUkpCK81d9oCnqSbUBPP1qWHc7PupZsnE	28041	3NKLEhJZchxZRD5SA6HTo2UoWKBo5dZHYkZFqRbE5eDUwra5xYbY	1407	1395	549	12463	18974	jwKVZ2J8SR2HBc2JrK7WsnWM6DmyH34X3CJzqUfAFf7zTGbjE9Y	13869	19549	19549	1619458020000	canonical
28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	1506	1127	549	12463	18974	jy1b4kUYU1p9M1tJDgPGizKxVSNZvArhEa3H7HySjGb4pcr1X3v	13871	19552	19552	1619458560000	canonical
28052	3NLLdi46KrLAPxm7iNwdsbcM8XFjMwdzkAAi4x38qCrixhq4LJUt	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1406	1393	549	12463	18974	jxzusoCkMYLD9FV6CQpWGqdNaqWSv7hXPRaYRjUhttaARgePVz8	13872	19553	19553	1619458740000	canonical
28055	3NKJvjNvUmJAV2hNWGZUkPigscJxaqj9tMF2bNvcxwrv8cAcUQDr	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1654	974	549	12463	18974	jwn6fUcDURSxvdvTEAwdGhvkxrhQXCUYS1XaEFMupp32C5rHTLf	13872	19553	19553	1619458740000	orphaned
28058	3NK9UkcXiD3ZCHcPTiY1JsSB7LrQyJNTuyfBr93PiKmfpSJawAst	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1523	1195	549	12463	18974	jxwcnev67nBr1fR5kuhEWWLc5udk7ST12iNKkRe19aHezkAnRkm	13874	19555	19555	1619459100000	orphaned
28036	3NKqjiASLo76sqtv9edRwMgwFujTh7u9tSqyaWLAEK9eshYkTBE5	27591	3NKCe6qFQbiTBiRBXD4r6SW9XQUTM2CJg1fRNRwzFzm5n9Ze3FxC	1564	1212	537	12463	18974	jxEu5maB6oWtMRVGC7ZQVjcWo3aADP6FMzvhNPd1wVzkYTZfSF4	13638	19545	19545	1619457300000	orphaned
28030	3NKiCmLWZXstobyesHoNZwbETdyHySUNwhnRxNd3ni7BLX3x6zBT	27708	3NKiTXgoPBjjFqm5ujL9c7K8iX348gzqYg1gPnrSXLicYvg7igTb	1671	1119	540	12463	18974	jwJJ5mskhZPkUX7BZ7CoSe2j1BmxM1NkoSxDcneSMfue3h8A7M4	13692	19538	19538	1619456109505	orphaned
28009	3NKcVFuLD3DQD4VmXs6ho8z7jewBSr5n96BSrvT3zQKyDMATAV8M	27977	3NL4NTbA85dSfQWfmZitiCoaFxJF1vHwWFzeFQZEgZA1iiKAAk7h	1560	1165	544	12463	18974	jwQ7hTVkJk2Gkb1d99mxtocjbgFrjRtqAWMpSAAVAAXESPrCeC8	13742	19523	19523	1619453340000	orphaned
27997	3NLmxGvPmsJYdCteq2mikbi6wXUnYBPMf4uHAEEvr9ixA83f9YYh	27993	3NKu2zZUvwSHXWrBMtBxxvVDdVjr3yMGXYcZGdoRbtxvu6RW4Vqz	1523	1195	548	12463	18974	jxyPVEpziUvvCjaXViPADzLhkMsm7HTMou9DGxYWw7UWGESoEJ6	13846	19518	19518	1619452440000	canonical
28000	3NKL1jmHWeZPPV6y6txmk9Mz1AyAxeVq1mpCz12NwnubK6c8oMzj	27997	3NLmxGvPmsJYdCteq2mikbi6wXUnYBPMf4uHAEEvr9ixA83f9YYh	1559	1353	548	12463	18974	jxzkZEUpGG1iDLyGNtkCtreTJAKhzCMht47YkksuPSbKEa3jE8U	13847	19519	19519	1619452620000	orphaned
28003	3NLHYosimxTMmf4mchBpeFhfWMekv2V8v6QL8XHAXm3fZzfyJrLh	28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	1634	965	548	12463	18974	jxJPXfZT3tstj9hj1CJ6zhHtytQNgqWuLR1Fg3y1GBHqgvQmK4u	13849	19521	19521	1619452980000	canonical
28006	3NLYRqt4buEbrjSpH8nysLCraegTmNrZQErXSjQd2JdjkUkVy1Gf	28002	3NK7aS2RgQfn4C2vL142fpRv2GBfHagEmxXgZq7FMRZLA6Aqvums	1581	778	548	12463	18974	jwzhD9Fv3XPx8MeGjMhfkc39TKmn9XJSwoN2Z35eaAQStkBePqP	13849	19522	19522	1619453160000	orphaned
28012	3NK5HzLtgSy6HBHjYDcUog6vgA5bpDesk2E4T1MojWRZMjfERQ2f	28011	3NKWVG8V9fUkjAhjqsGuadLG61tEuMBP3Jz8WmAiu1RUxRv5QQr9	1668	1124	548	12463	18974	jxoFdfUezv94dL27xmqjTjo9hpcQYi17nZG5tQmM7M97LXsKySm	13853	19525	19525	1619453700000	canonical
28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	28017	3NK4X3T1Kx7yBLoJf9fk3mYNwy4DQmGLUNpbygf7DEKqVZmktNB2	1585	1000	548	12463	18974	jxreJz72KVuuWUAyir8Hv3qhPGoVwzGHFzxF1crPKfB9SyrqFc9	13858	19533	19533	1619455140000	canonical
28021	3NLmjNVYSxzPA6ZoBgu9gT2wy45fhxhFxEpBfRhH7CBfuBfSi9nK	28018	3NLmVNAcKiRL93GUDJ34B8SnYHLj3H4c1SiVuYTFeFyxT5TNgTN1	1407	1395	548	12463	18974	jwh66mBADP2nYMNWWimwHBbDYA3YyYK8JaaGRgGMLYs9EpWACVi	13859	19534	19534	1619455320000	canonical
28024	3NKRHngiwhtpPdRaYbQLyy9FBS4BB64KsxnXSMeoMVqaxyMHqVZa	28023	3NLUQPcYzt6re6cKEs4s7tLjYhxgomwCvnqSWGdKcQfyVGpUWg9u	1547	1132	548	12463	18974	jxekVPk4mk4QxYdSd9QHC2JAoyCphkCT6iRMygaz3zy6fDmsrax	13861	19537	19537	1619455860000	orphaned
28027	3NL5SxJtS2RUQM8dd6PCAQERqXj6NbVbvB4qkDLY73iPus94kNUC	28025	3NL9KjxLMQDCcoJ3H4sGXh3gitdrUEP4yPHfqmVXNHgdK3nuP2H8	1671	1119	548	12463	18974	jx6sTPtLvPwiTH2z1zYXDEXKCDkrGc6p2RwWK6fGHMKHXinKr5R	13862	19538	19538	1619456040000	orphaned
28033	3NKwkA4oENWEFeF6gPiiR6E8Xq3fMrZvRqhjvbLVAohL2yGZ5AeN	28032	3NLt2LxKocuLzRvuGbvB6YfDUjg88NkkfWD7Sx2SBdJQaraQvetk	1402	808	548	12463	18974	jwYVSgrnSKzEHkFCCQTJY3WKUieDyUfWWEDxbVKcy4rxfCTPGHW	13864	19544	19544	1619457120000	orphaned
28039	3NK8Khj4LygU16E3QEaMYRSX8rAYyhZqeq7qGqc8E5FqZ5Kh9VRp	28038	3NKcAzfPsEmr5Xd9gD5AX7k1XbPYDPrKu98Fp91nrEijP2355Fmj	1483	1276	549	12463	18974	jxeMjnoPVQWmv71B8tR6E9BcGwTiMXgFgoMvUfVsJq643ga353b	13867	19547	19547	1619457660000	orphaned
28041	3NKLEhJZchxZRD5SA6HTo2UoWKBo5dZHYkZFqRbE5eDUwra5xYbY	28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	1590	1174	549	12463	18974	jwQrAACd5Z6cPQCRvPRXGazZSYVkddjsnsgPF26kSeYXTzbME9B	13868	19548	19548	1619457840000	canonical
28042	3NLVAEp6G6cDX4DF435HxZh1A6MmHqMno358W2yJxZnzsNwTUMK2	28040	3NLbznr3C7hG52kzdwegkzF7cQE4QUQ8G8M7mgZXXsGsUys95H12	1590	1174	549	12463	18974	jwd84CgDXWSXgeom63uku4DW21qSjqapVggTsnDLtQgj3hbcGbc	13868	19548	19548	1619457840000	orphaned
28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	28043	3NKbY74e7edGCGKYJsSRUkpCK81d9oCnqSbUBPP1qWHc7PupZsnE	1509	1194	549	12463	18974	jwjfeXBAMEfDv3vovThTfPXSbo3dLwGzPEgPFMVh5JKdyqtoFj7	13870	19551	19551	1619458380000	canonical
28047	3NK8HmTuACAVR7z22vgzbsnJBPzvV1mMLUK5hT5jajBBZ8NivEeL	28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	606	1169	549	12463	18974	jwcCHVHKwMhnVLRzmevKUbpLhqbtRpFFLYAjTkFVNoTmESK931a	13871	19552	19552	1619458560000	orphaned
28048	3NLkjoBiHWDivhSgmvtHC5XHTA13FMx6wV6jyqU8XF3bLvijuLTq	28044	3NLjJLp6zDjKGFwGgohpUcNWfJM8CC2TGbnfpBeLd54Av4g7or9p	1506	1127	549	12463	18974	jw9PMzw2HULZtNty35gR5jiL7RLAqVcEx5yBfKWb1Dm4JDj97Hc	13871	19552	19552	1619458560000	orphaned
28053	3NKQLb1gdCqPCmgmeyHLVUyGnP1wXaCbXfuQY74Q6aAzx65fCWMc	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1451	1292	549	12463	18974	jxvTGoHs8bY247GpR31k8YxZf9ZNDuFDnsKRL9nupd8UCTwjbc3	13872	19553	19553	1619458740000	orphaned
28051	3NK9sUzM8iEd8aFmLJoJpGwT4v63ZPCBtwUYdFHUE8yhgxya9DxY	28049	3NKzbVhSKBmfdHfZEYwatqqJzPGwvZnTwyAsHAPX5FzZ6oWfVBPo	1451	1292	549	12463	18974	jwox82UianwvHexQKfFkstX2nVTeYScPaZBatCY44ZCfRQX8HBK	13872	19553	19553	1619458740000	orphaned
28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	28052	3NLLdi46KrLAPxm7iNwdsbcM8XFjMwdzkAAi4x38qCrixhq4LJUt	1578	1170	549	12463	18974	jwrYiXdeCPwrx1w8PdDNTBoq4qbxxn3jCRmAgLM6yjSpkeHd5LY	13873	19554	19554	1619458920000	canonical
28060	3NLWkC1WBruzZtM9hyMfSoLmNMBAkEsUAn9rJDh8ZaaNAy3aWT5V	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1455	1206	549	12463	18974	jxgMTzLuAPyJo74kZiPEGzY8pTxWe7VVZCSVqKUoWhJctAup8Yv	13874	19555	19555	1619459100000	canonical
28059	3NL6jEydZHNpgHHd3ZyrhKY2jtWQ9H4MsAG3EHRWLCKNCpUgpf4h	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1523	1195	549	12463	18974	jxERfVpPi2M4E99STHBohtCbzwvark3k7oNLjP95LdiGJ5myUAn	13874	19555	19555	1619459100000	orphaned
28057	3NKpX9XuBnNPapWZCRPySb4zkRBmRM5za3Q43uUZ4uBnAMAMAztA	28056	3NLuGqpvdQPGWue9rSnsek9NdV8daxZ6HajYmZ4T5hRvKxBqQqL1	1523	1195	549	12463	18974	jxg6shZdARbKDEf7V4Rv5QFEcYMdEHrn22ZF46kmdtYgJBmdvnE	13874	19555	19555	1619459100000	orphaned
28062	3NLGXkF4BoGQ6yJVGeHn1h6z2MPEU4znwqfW5sptrmwCBnNVNYAz	28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	1588	1146	549	12463	18974	jwoAysgmRG2boYtBrm9wM3WKS7w2vNi1w51s11NTTpwNMiTsUKB	13876	19557	19557	1619459460000	canonical
28065	3NLW7Vfekj24ua8Gje2h5EDbNhctQr2CsYSnUSQi4ozsdSUjAFFi	28062	3NLGXkF4BoGQ6yJVGeHn1h6z2MPEU4znwqfW5sptrmwCBnNVNYAz	1407	1395	549	12463	18974	jxnoibsJNZFQVGC6eerdM3T18KnJgsJGv6UHQikv7e3P2D71uYf	13877	19560	19560	1619460000000	canonical
28068	3NKPMJzyWgggy2nN4tcEUJPL5HcWCcEMfTesBnuVeWVncjGKMBQZ	28067	3NLLrda3YiWD5D9VzXAbP2JQBAf9qVEbvheN9ykBCYz9S9bvHTDw	1419	814	549	12463	18974	jwmui31VjV7w2Rnoei1JQ7FZjqVTNWDxKydUHjw2JSjvRBkdn38	13879	19563	19563	1619460540000	orphaned
28078	3NKhtQikGaeivZnRH5cSPu3hmpouFJthhVLrF2wK4UhHFLWZszMu	28047	3NK8HmTuACAVR7z22vgzbsnJBPzvV1mMLUK5hT5jajBBZ8NivEeL	1553	776	549	12463	18974	jx9FKs2EeyCTPxSAqdTt29Z88DnJzyRbsBA9g62hUdcTXx3PP3F	13872	19573	19573	1619462340000	orphaned
28063	3NKhepzgwU3e4zTmrc61fsE2CUdaJ49eZT7VyJJUKj9S2Hod8gXE	28061	3NLKzvN12xhBMocqy5ULjRJNcwwYR4n9eoRBj5ePtWqZeCtWLTCb	1407	1395	549	12463	18974	jwkVjNwwG65JZo1wvWb5i96uKtbiBbCg69XdqBqfwg3FUKwQsfg	13876	19557	19557	1619459460000	orphaned
28067	3NLLrda3YiWD5D9VzXAbP2JQBAf9qVEbvheN9ykBCYz9S9bvHTDw	28065	3NLW7Vfekj24ua8Gje2h5EDbNhctQr2CsYSnUSQi4ozsdSUjAFFi	1490	123	549	12463	18974	jxvxNhTDXs9J1qbDCDLKtttjdYQBTQpdtuiixxrYCDHXL65sZtN	13878	19562	19562	1619460360000	canonical
28066	3NL6sBv7x6KnRGEHFW54A6SEPfzy4us8wNm7vgXw4hFtuDsjgrgg	28065	3NLW7Vfekj24ua8Gje2h5EDbNhctQr2CsYSnUSQi4ozsdSUjAFFi	1406	1393	549	12463	18974	jwfhwjVjbjCd7rxb18gG9HFcBntKhNyjAoBSExKYnThmZxyycWh	13878	19562	19562	1619460360000	orphaned
28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	28067	3NLLrda3YiWD5D9VzXAbP2JQBAf9qVEbvheN9ykBCYz9S9bvHTDw	80	1027	549	12463	18974	jxjjo6a6d9cDGFpThxb3qrQVsuXhPYhGzKbFkMcKkNj2jyZPLCM	13879	19563	19563	1619460540000	canonical
28072	3NL1VoaVZwmWNTFK8uPmJ1peHVyKyyDwV5qd5PsQoktNsbdopWrc	28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	1675	1096	549	12463	18974	jxSTqUgHjWob7saQkSBhUpbri5vb5WM82NHkETkwCr6FXpXtwaA	13880	19565	19565	1619460900000	orphaned
28070	3NKbJjyBPSVBCKa2tQdHwfTh5rua6dp1hN8hmrc3ioNxuiweu9NP	28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	1657	1344	549	12463	18974	jxxs7eoTmuBc64X8aNknYEeJH6Hdo7Vzm9xUFfoECHafj9m7Rmh	13880	19565	19565	1619460900000	orphaned
28076	3NKWwx6ZC3PtXgiHNan8qDekzzsSEa6j7qP6knX5BiPdGGTmZ7Jt	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1622	990	549	12463	18974	jxwJHJDmWyLr4931v3YLzMqLt9Qgew6qVVxSTZ92rJkKjxKhGxt	13881	19570	19570	1619461800000	orphaned
28081	3NLCZS8nhSXGv1oJefs9Wy8MFkMynVE1vJG2FHQa7teKrxTDGbze	28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	1623	830	549	12463	18974	jx5xRWY5p9yX5FW8RAyUan3ydeBDRghHTW7KBZyMyuMxzZTKrQC	13882	19573	19573	1619462340000	canonical
28079	3NKzetVqFDFFyH7er9LgMSK1h2VNqjNYAGRf2aLbrvnesGSXBsNB	28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	632	1136	549	12463	18974	jwaf6txxkexMNLS5kVBCKrfhtMyqPfFJ9RJ2WvdQg9yGozQkToz	13882	19573	19573	1619462340000	orphaned
28082	3NKoK2hy9FCeCn5r6epyW95ymNSh9EMjxCK8tpZPJsrgCfBUfBjG	28081	3NLCZS8nhSXGv1oJefs9Wy8MFkMynVE1vJG2FHQa7teKrxTDGbze	1518	833	549	12463	18974	jwXHNAgBRbKa85aMU4xqAFqnQuDWta15DD6Tjwu67CNWkcmmJxb	13883	19574	19574	1619462520000	canonical
28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1527	1047	550	12463	18974	jxULndMLz9dxeUi9Pj4XYse73EnbSUgpuLLAiXn4Gds3d7uyRZf	13885	19579	19579	1619463420000	canonical
28084	3NLu17mwRSg2SknzbrpS7aGLTmKSEE9HooHQ3hgMWz8vSeyhehzZ	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1527	1047	550	12463	18974	jxhCqRC3MZJ3LYLeBwdDUFzUyr9dDsYynPzvwkTP4M8P18xkHAq	13885	19579	19579	1619463420000	orphaned
28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	1448	1311	550	12463	18974	jwdZc2JfKdrWQJQZEgcWYc8uj56HMCYUsxCesgPFcr6VBZSN99h	13886	19580	19580	1619463600000	canonical
28090	3NKx9fSm8MjpxgXW2BHCDwXTwhcpzhJ56W2XwtL53JTX8i2jqAa8	28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	1559	1107	550	12463	18974	jxceRdBChcEFxYKDZYMeNjdd4sbhpWgUG6qMpJhcmtwdfw5k8oT	13886	19580	19580	1619463600000	orphaned
28093	3NLd7MiddMvWSGxr2SEqPUW51bzMs63LFaMULNcutUiXWY8fS47Y	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1407	1395	550	12463	18974	jwept72ywyWcvSjweBTG72WMBKJH2DNNyQaThQQhRG43wyd3TbF	13887	19581	19581	1619463780000	orphaned
28091	3NKAdCPdHFi9d1UyxEvQZtLSbhdWZT4YdyJFUHu4qMivA8gHDpQL	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1403	824	550	12463	18974	jxC7JYm2QRo3N5rwphhU4KKHFA9YyivdF5w1AohzYoVPQFfNW9M	13887	19581	19581	1619463780000	orphaned
28099	3NLmAro424FjPWmUSMui8vRb75He5iGEuC7SKJfsQgu2pimiaNnn	28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	1403	824	550	12463	18974	jwNHgn8oysUgkoGxdeCFEDDVBcDpRx1YkDAd1s8mdKUTaK6YFkc	13890	19586	19586	1619464680000	canonical
28102	3NK48GAN8HsSQz28W7CdDb8SWqmvXMhjwwNQhjCPSwQ7kZBuoYBu	28099	3NLmAro424FjPWmUSMui8vRb75He5iGEuC7SKJfsQgu2pimiaNnn	1637	816	550	12463	18974	jxQK7LCUDSg1ztTDLodAX5uVYsxXyb4h4uZ4Z2KNvhey2xUhbFu	13891	19587	19587	1619464860000	orphaned
28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	28101	3NKotBdfZ7p2bHqHCswQZ4N8vJc2Uxw8nsz3MLDba3XvW9or65uz	1613	1349	550	12463	18974	jwKQtRs2ocP5bPf2bCUQXuCCjXkERmcwZdbH1o48EcE3KfyaWCs	13892	19588	19588	1619465040000	canonical
28109	3NKimwYFN5S582emDyP78LsyLtXmUgqmmQLgFM7ABiHRAQjYRHt3	28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	1601	1388	550	12463	18974	jxgh2DDnaDkRXtABLiuFzTXH2Wkm361zXeYm7nUMLCgQFJNYSpT	13894	19591	19591	1619465580000	canonical
28108	3NKePPzScxYxKf5EyfirKsRxVE7sCtcbQcqM4ZZwitvwWdQePmrz	28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	311	1307	550	12463	18974	jwSabfLVizvSfD48Cf1jpdzBj4HGecbMC7Lcy9d8RxYr6g3RX8a	13894	19591	19591	1619465580000	orphaned
28111	3NLRHoPoKGDga1VmuoCifQXjeMvB7KprEUwfe98SWwNR644Z5SKC	28109	3NKimwYFN5S582emDyP78LsyLtXmUgqmmQLgFM7ABiHRAQjYRHt3	1631	794	550	12463	18974	jxRiP3oo6w26fb3Xnvbku5Fax4rmyRSD23GtXeSijXpsDUT3zG1	13895	19593	19593	1619465940000	orphaned
28112	3NKdXMYFBzCdheXVZYxS1vc7izm9LHvuDEkmZi3vxVnD2ip4v9MZ	28110	3NLoWDW66CAzSiiAiQ8FnkTKZC6LTjFo3vXpk9uwLk98bts8PxME	1403	824	550	12463	18974	jxXt7Zob996jKwCLB8cq2nC3mHDSfJWNpFxNDMWyiigGR6HEuhb	13896	19594	19594	1619466120000	canonical
28114	3NLqxMg1KyCeVwEk5XDprUAp4k7juCQstmzEPxTe6FQKmQrAxPCy	28112	3NKdXMYFBzCdheXVZYxS1vc7izm9LHvuDEkmZi3vxVnD2ip4v9MZ	1406	1393	550	12463	18974	jxCHnCNDbD1654HmbQo8qHAgttCuQ1sBjMgsUNLtcBodVYuw7VG	13897	19596	19596	1619466480000	orphaned
28115	3NKcCajheT215v5Kqc9Ni9df2RYxn6MvJAUsjgxtwyfWcDW8RqUj	28113	3NLDJt4mjj23awTCByrV6Qr6HonRrXBj2QWJDskiPSHFuTAAjdhG	152	1084	550	12463	18974	jxbaJftfQNsrvYT5nR4yzaPEchwduvJJMJWCM1faUqxZWe564ux	13898	19598	19598	1619466840000	canonical
28117	3NKBRv5B4c2KaxYBEdjRyPK5zjtFtxZUj9a7Y8k9VyxcEsNdm5e7	28115	3NKcCajheT215v5Kqc9Ni9df2RYxn6MvJAUsjgxtwyfWcDW8RqUj	1607	1348	550	12463	18974	jxzWTd1NxptaUbZk2NH4poaFYbNguA6R8d8zXVD3G9qwajXLsZ4	13899	19599	19599	1619467020000	orphaned
28118	3NL8ARjuhTzV88KLB3CVrfpjsWiEShto9u6oqPLarUazpZTZNytc	28116	3NKmPpPkxCkTcidJzjssSEAaMw31rBrCutvxanChpCv8QWqphBvK	1406	1393	550	12463	18974	jwynoJqqgMsp7DjK19WT4fD3YQmqKfkmBir9JhMrQQq3kwR3R3m	13900	19600	19600	1619467200000	canonical
28121	3NLdxfeQotUnCUQBTqvQebdd8JKTtmpbGt8QKez55zDfaSMte3A2	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1522	1076	551	12463	18974	jwaRxunrSLvwNVdiU2GQNiScZq5tR4dmi2dvBKz915gF5WRqG7s	13903	19604	19604	1619467920000	orphaned
28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	28069	3NLyYjuxttSZiUMbep4992ETubipd7YntBAQsgwKFZq5Xvt2SoGQ	1657	1344	549	12463	18974	jxzHPcUJU8Rqm5NHQwmvEboUeQBa34n9P8gFb4vhyFL7dCra59A	13880	19565	19565	1619460900000	canonical
28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1520	48	549	12463	18974	jxUPw9CXPheHnTz272RqnPEQmnzkvGaz8yubphEC8zGEZKHVaB4	13881	19570	19570	1619461800000	canonical
28074	3NKaaivAbanSfY1fcFg5MzXjuXquueAPkxXkBVvnEEN1kvhJevqn	28071	3NL5eNYfTzN4kUTRWXxcanyWN9f4mSNG2eeSGkwdNJFEXVNtGWx9	1520	48	549	12463	18974	jxsDTJPJPNxTkcpxNKFworkLGwLjZFCpCweK7p6uJ73UrXeE3Wo	13881	19570	19570	1619461800000	orphaned
28080	3NKppXEZ8Dju8uscDiSaLuD2qooYzXZmdUmgDZ8gJWi77nqYxMXQ	28077	3NKrdDUp6Bhu3fGr926VibiG4Bf65zzj3hSrRG8pGXSdnqcGSzSP	1455	966	549	12463	18974	jwvUQLKRmENvgwsU4wRfmXYYbUtPTM52gR133j5gJZnTy9RDwc2	13882	19573	19573	1619462340000	orphaned
28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	28082	3NKoK2hy9FCeCn5r6epyW95ymNSh9EMjxCK8tpZPJsrgCfBUfBjG	1490	1148	549	12463	18974	jxcNnRNbR6wLsgdhzGek29XuZ2nTCDfgnasK7XojGPB6V4XpurG	13884	19577	19577	1619463060000	canonical
28086	3NKY88uS81aVt3HGnjY1N51G3fp26vViYiHB1uziDYXarWc5QfnC	28083	3NLbh4n1ZFfMLTjkfP8DPvT2KUSYTmbYKvbMsf3ZSS6V8Z1rwC93	1527	1047	549	12463	18974	jxczizNV4c8khyPYBZ3zMZbVkjozKaBuS4c2ti7d1dcFRftUstm	13885	19579	19579	1619463420000	orphaned
28089	3NLezSf5dRAa7peQYgmc5DfoXr9hMSf2Gw2zyapkHr9zGLBueibr	28087	3NLDcgrkcG93U8TmNCqe9dcSddf5G94zanHP7NtQ7h1ZXApDEnKH	1448	1311	550	12463	18974	jy1Mns1UiDYACzMGoDBN6FFmcsDqncaN3pZv7PyW4K4AMTcdQqC	13886	19580	19580	1619463600000	orphaned
28092	3NKY4r1agh5TngBs786XLqyVtNjcNNETCN9iR6QyLwWcp2nixDaC	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1637	816	550	12463	18974	jxBmWDVtoA3aRfyZ2oEiMk44sVeuCR8m8dMQ6aKtTgJ6C6xeNtU	13887	19581	19581	1619463780000	canonical
28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	28095	3NLEKB4Lqz4AMKA46KYxyZvh7nKQD2wVU6dqJkPCUFTLzYrAqAi7	1646	1354	550	12463	18974	jxftTTH6vTQ5pwP8fueNs5WegGcb2FB8d4PwK3WAX94EPtWHjTr	13889	19583	19583	1619464140000	canonical
28105	3NKejeeVWciqJyNT2p1YAbX9gE5cPcSVwH3LTHGAGUNBYtAgTqP3	28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	1590	1174	550	12463	18974	jxRQQU32z7TcX7iEAfhRAVjsyTLYM37zwhq2fmhyZ6wJfBsUT33	13893	19590	19590	1619465400000	orphaned
28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	28119	3NKRFT2E8ZBehY7mbcvVHwC6pSryM3ztc9ngTUdCH9YjYFZbJc1Q	1461	1271	550	12463	18974	jwuS7K9ToYzmF4mZztTkGgea7hiV7PWQTpktXEdx7639rNYjM14	13902	19603	19603	1619467740000	canonical
28125	3NKjtjDok7C5bYArhhsAJVELddSFBFmopqs316WJmDLWexCrn8Qb	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1675	1342	551	12463	18974	jxetCHSCytNvn7vZZV4E59dEquqFjR39syi6b1UfdCZmvW1mdtV	13903	19604	19604	1619467920000	canonical
28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	28120	3NKdayJGuMw37tfcBpGku2NaaV5wYKM8MDaYEef6VN1KJxJsAUQr	1675	1342	551	12463	18974	jxetCHSCytNvn7vZZV4E59dEquqFjR39syi6b1UfdCZmvW1mdtV	13903	19604	19604	1619467920000	orphaned
28129	3NLbKJ6ADL3xCqiymQNfG6mqkgqbkBfpompKj29Kr2St4kMxYyNJ	28125	3NKjtjDok7C5bYArhhsAJVELddSFBFmopqs316WJmDLWexCrn8Qb	1474	1329	551	12463	18974	jwZtj9SBtWqVxz37PqA3AvwF28By7Mgmwaar4RowVVpfGDUjZJF	13904	19605	19605	1619468100000	canonical
28127	3NL2Zm9Gapm5YyJuAQ8VNxUx6oVJj822QPp4gCaLNVh3hJMFjSdT	28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	470	943	551	12463	18974	jwZjWzsJwC3ManiJZMEpiXFFYguoW61cmmDtpLZjdYMPPCx6JGn	13904	19605	19605	1619468100000	orphaned
28130	3NLHM7x7mVKtbP9Sau2a8gRmXayo8f9jNvRxpWQWwJyoYFuUfo4D	28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	470	943	551	12463	18974	jwBmwzuyz4C1ZXGo4fmnq4q39b89mXHLVuiYNe9V1GwnMHR96rL	13904	19605	19605	1619468100000	orphaned
28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	28129	3NLbKJ6ADL3xCqiymQNfG6mqkgqbkBfpompKj29Kr2St4kMxYyNJ	1657	1344	551	12463	18974	jw9H6tvJ1oWCRESQz979QLVYeMwMwPPZwnpLTfzSFGZWSR2pD3U	13905	19606	19606	1619468280000	canonical
28135	3NKhH3W1WHRjWGt974SUBmr1kpFqsm4HAhV6o1YWd7igAEjT2tb5	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1599	1041	551	12463	18974	jxGEvRuyjeeThGZHrx4cqF53xn7E4YdLx1fVRpGCr67tHEBuzNZ	13906	19607	19607	1619468460000	canonical
28133	3NKuifNMXAs5sevAU9nHvMnnd8QGZuxMM1QVsPo2oX2KtnbPnM4T	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1522	1322	551	12463	18974	jxQpQcPWtmpSujey2Cryf33R7sKNL42o594Prr7G3AagGw2eeqM	13906	19607	19607	1619468460000	orphaned
28134	3NKukhdQ9JJTjPPu2RJLK6QjhR5EpxfX4TzGiNfqvCjCm4Gi3L5z	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1590	1300	551	12463	18974	jwNjYQzt76dHKbfQBFX8ixvjS48h4oDwThyZyMat6HLaer64Ehz	13906	19607	19607	1619468460000	orphaned
28136	3NKBpzVTRwJsA6pBnoEb7hBVZWjV7Sh3H7wQUzGMyYt4mwr2qQaT	28135	3NKhH3W1WHRjWGt974SUBmr1kpFqsm4HAhV6o1YWd7igAEjT2tb5	1637	816	551	12463	18974	jxLHWnmXeGiRuBjMUsAkJ2jbhcZZmKBnqp93HNLTj7sQiKgoWm1	13907	19608	19608	1619468640000	canonical
28138	3NKG6DD3mYe4rThdM9MS8sgZiLUFZMng4xHf2HAjvCHMAbEdwWSR	28137	3NKyu6cH7WgpD1f4JUMHcsdYUQ4HPiUu692fT6we9bXswwngE8Lw	1447	1219	551	12463	18974	jx6ZEKziDm7G6nJGDbmKaAXLCQFFMSs2BznyDT9iX55KuXJhUQU	13909	19610	19610	1619469000000	canonical
28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	28138	3NKG6DD3mYe4rThdM9MS8sgZiLUFZMng4xHf2HAjvCHMAbEdwWSR	1481	790	551	12463	18974	jxcwFStLmSYSgiDjc8td8Nv3h7HscJmtyvf17B9yaE33soMLWw3	13910	19611	19611	1619469180000	canonical
28141	3NLQ71ZhauDdQdGgGgCrLUZvRgSMb5v9evfyZ9aksSctgDWAH2U4	28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	1454	130	551	12463	18974	jxAXhoTy3C4ufK6LwG3nbrJqAmdcvmWJ4Dh948s8UvG23pN5N1C	13911	19612	19612	1619469360000	canonical
28142	3NLjCoSspbk81VpbAVBp7nJhn7i4A1aunW7qMtZ58v5YyUjtFcP9	28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	152	1204	551	12463	18974	jxye3A8HK8Fz1uz2cRX1z6Jyau25aCgKqBQtuyx3adSrMUeHUcB	13911	19612	19612	1619469360000	orphaned
28144	3NLfS4UNLHmdk1qHC4vQ7hmp3Enwx65Jwm1nZVFCaC2BWART5xtt	28143	3NKTFSVv1VYwESJhi5fZQ8w5uiPLMDucx27tdBsuc1JQs3Wkkkzc	1617	1288	551	12463	18974	jwsNMjZZKRZHf6qfVjX2V2qM4LYtR5TYcpEE6ZSmfq4xtLaVmKW	13913	19615	19615	1619469900000	canonical
28145	3NLw8RCbVf8PcVLijakwPUdD4GCnJe4CfwQfakxytbgtcd9G97KU	28144	3NLfS4UNLHmdk1qHC4vQ7hmp3Enwx65Jwm1nZVFCaC2BWART5xtt	1420	403	551	12463	18974	jxFFYuVFT6sjSptM8Tkt5nd6Cuy8KZ1CQ3wMiawcSi1QUVr3dQf	13914	19616	19616	1619470080000	canonical
28154	3NKTvSAFtFzeG5HWqL5akhiyZHx1iqwQs617fZN7JVAZYLFmq3y3	28146	3NLToj85vZU5rvafQZingfVkRhCWYswCx5BfLGckd8QsqMJWF4da	1553	776	549	12463	18974	jwEgdRVDNaYH2br7NBXSD8vSMzLkpwMiVNzV96iqnQDrG44H5ei	13874	19626	19626	1619471880000	orphaned
28094	3NLcFQ3MJ86EjgspKTDfKdU54iKYw1j3Y3Wyse7xSqitggsuZavb	28088	3NL6hGsLQZTB8xQ6thJC9zQ5fTYU4N9y8KwL7ucUChv6XgRhSHAd	1581	778	550	12463	18974	jxarhHNXsbGvMrQs3Moez51uhpfWiJfsJ3kQfFFwDNotFsvKW4n	13887	19581	19581	1619463780000	orphaned
28095	3NLEKB4Lqz4AMKA46KYxyZvh7nKQD2wVU6dqJkPCUFTLzYrAqAi7	28092	3NKY4r1agh5TngBs786XLqyVtNjcNNETCN9iR6QyLwWcp2nixDaC	1406	1393	550	12463	18974	jy1qytuz3tfi3G5VkPexECnudoveHGpjdC6UAEjVNHvJKzVsH8d	13888	19582	19582	1619463960000	canonical
28097	3NL4B1pRjMB1RnyFYXMp4RbkiMnzxXPGiMtsvemS32QDfUFUabBf	28095	3NLEKB4Lqz4AMKA46KYxyZvh7nKQD2wVU6dqJkPCUFTLzYrAqAi7	1476	1371	550	12463	18974	jwiX3EbH1aYzq9CBwJgVwQYHABoy5Yi7G397LDaxtE7YKBXFVUf	13889	19583	19583	1619464140000	orphaned
28098	3NLdhXzUfy1FoMR1NyoZRPruTYkwku1D8gsvnaRxoRWV1gJmHJL8	28096	3NKP7vNancSZ1HK2S5vYUYoSpMpah8weVbM6H5paFhwqAYkexjXQ	1407	1395	550	12463	18974	jx9hsg5aYF7LQ4L8pprKHgibc5cY4RopPbE92LDxgPmY1R2ZGt7	13890	19586	19586	1619464680000	orphaned
28101	3NKotBdfZ7p2bHqHCswQZ4N8vJc2Uxw8nsz3MLDba3XvW9or65uz	28099	3NLmAro424FjPWmUSMui8vRb75He5iGEuC7SKJfsQgu2pimiaNnn	1656	1343	550	12463	18974	jwKnmGq6zwvm9sNKeikhpqMJfJcXG7JTv1hbyrNMTudUtu3imyB	13891	19587	19587	1619464860000	canonical
28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	28103	3NLoenxk3TQWpMB2QM9vbMg7bzp8NR3Ryffukr38EG4kjWZMmbP8	633	1384	550	12463	18974	jxYMMXjFtiB3ztTMGNxjjJcogiw66qPcS2Ea4eSC1fhPt5SGYzg	13893	19590	19590	1619465400000	canonical
28107	3NLmwahCK9eoCy14oCQz4UvK1WP4H2WY1AA4hiJkdWEqxiXofBcy	28106	3NKyF97RCxcF5iGHScvG6JALLqHwDaNWD2HKfA3ZN9psTAPBpWwg	1490	908	550	12463	18974	jwakTSX61v9QaTgiwuTXDyq3cqbHck8QJyjEVewoJNc4FSktWBz	13894	19591	19591	1619465580000	orphaned
28110	3NLoWDW66CAzSiiAiQ8FnkTKZC6LTjFo3vXpk9uwLk98bts8PxME	28109	3NKimwYFN5S582emDyP78LsyLtXmUgqmmQLgFM7ABiHRAQjYRHt3	1419	139	550	12463	18974	jxziykoUYgJjM4L11wRwsotDp8sjx9PaCv7oeMynEYYXsKHNGEo	13895	19593	19593	1619465940000	canonical
28113	3NLDJt4mjj23awTCByrV6Qr6HonRrXBj2QWJDskiPSHFuTAAjdhG	28112	3NKdXMYFBzCdheXVZYxS1vc7izm9LHvuDEkmZi3vxVnD2ip4v9MZ	298	942	550	12463	18974	jx1oPwFX1DFYeQSiWN4TUfvEcfWn7M6orwM9F8hj88QrDeWbqtU	13897	19596	19596	1619466480000	canonical
28116	3NKmPpPkxCkTcidJzjssSEAaMw31rBrCutvxanChpCv8QWqphBvK	28115	3NKcCajheT215v5Kqc9Ni9df2RYxn6MvJAUsjgxtwyfWcDW8RqUj	1483	520	550	12463	18974	jxzVhWqavFZtXQnQcxtmrRqJL2CfjubnKsWVUvy92uZMeag3pem	13899	19599	19599	1619467020000	canonical
28119	3NKRFT2E8ZBehY7mbcvVHwC6pSryM3ztc9ngTUdCH9YjYFZbJc1Q	28118	3NL8ARjuhTzV88KLB3CVrfpjsWiEShto9u6oqPLarUazpZTZNytc	1637	816	550	12463	18974	jwWYCK1NNy4TQcbZrA749mgUaTFGFiCakU8uvSLkSy76yJiWp7a	13901	19601	19601	1619467380000	canonical
28128	3NKosAeLmePRwbvr1D2vqvk4LN9TF9ZNXVxci7xPVySz4BLUbNWZ	28123	3NLuyHqToQzY8RjUAW75gxgC1ynABERGgubtzkqGnqzGQxgBwHzu	1648	1284	551	12463	18974	jx9UVhuBxvQ1d8A6dxxQyMQvXxYBw4z9E68kmC9V2NiaDRbyD9b	13904	19605	19605	1619468100000	orphaned
28131	3NLEq3T3mG99HLgbvtYswa9nQ6ChxzyKztECeTV5odEp5D2hKZ5y	28129	3NLbKJ6ADL3xCqiymQNfG6mqkgqbkBfpompKj29Kr2St4kMxYyNJ	1657	1344	551	12463	18974	jxPZSdUmRLVUsP1GR9W2TdSh4A3LrGRgoC6Mpocyo2bBpT3s5dq	13905	19606	19606	1619468280000	orphaned
28137	3NKyu6cH7WgpD1f4JUMHcsdYUQ4HPiUu692fT6we9bXswwngE8Lw	28136	3NKBpzVTRwJsA6pBnoEb7hBVZWjV7Sh3H7wQUzGMyYt4mwr2qQaT	43	1064	551	12463	18974	jx2i1tVcTFSREbWH8dwdq7yzmeSLngSHuKbbacmbFrKPR79ZMkp	13908	19609	19609	1619468820000	canonical
28140	3NL6Pgqaq5MuqjfyiBxJF3P2rxumRzLCybkezVsV1UzK6d5D4Em9	28139	3NLUUPQQW2ZN5vCTgZqJ8wSfPAKcKjytKzc2kAMFf1TJCnUqHMgy	1460	597	551	12463	18974	jxLnrnQ4cNQWGSw5emvvdGmB8VJ3bQqeymEHcNpemyCFmGJCK1y	13911	19612	19612	1619469360000	orphaned
28143	3NKTFSVv1VYwESJhi5fZQ8w5uiPLMDucx27tdBsuc1JQs3Wkkkzc	28141	3NLQ71ZhauDdQdGgGgCrLUZvRgSMb5v9evfyZ9aksSctgDWAH2U4	1668	1370	551	12463	18974	jxaiezfJyBevmSi58aF9MkEpVc1x9hvdar8E1yvYpnsu3rZMQPV	13912	19614	19614	1619469720000	canonical
28148	3NLYZ2LQZmenyVPqEFfnhxRocDkesoyCNBV3qAkR3pHpYdaVaNxu	28147	3NKDocauqcuoJb97f9pmp7jeeKidvaQGyDJrWywZVDapBmZCKqxM	1507	914	551	12463	18974	jx1DDemNP2kS6x4h4Mc3mpVcvarbbXw1Nc22QTwwpLWwqSzsgAe	13916	19618	19618	1619470440000	canonical
28149	3NK3sE6WDbHhBdScfyqrr6dtCghKmGJBnzUQotKQNLwjeueenKA4	28148	3NLYZ2LQZmenyVPqEFfnhxRocDkesoyCNBV3qAkR3pHpYdaVaNxu	1652	1315	551	12463	18974	jwgF21eqZF6CJWGc5GnAPZcLi2QWMHK8zjUeJKMa6CQP2T3qbVo	13917	19619	19619	1619470620000	canonical
28151	3NKj7qaBLvg6cV4z9vRrJbBLk9DH5Xc8JvZMQBLs7bFU74nrsKHY	28150	3NLLrfzCk7eXezRFmqoC4nizwkCQ8j6adkPzdUCZdSfZsi8ioszB	1675	1342	551	12463	18974	jwH5vQYoTYrf7oTSksE1NYUSv1E4emybizithbtQsBznr8yVGeT	13919	19622	19622	1619471160000	canonical
28152	3NKPwujiTy44irFfQqfNUgFNeREC48ibbDmv99hUnpcssUnib8LB	28151	3NKj7qaBLvg6cV4z9vRrJbBLk9DH5Xc8JvZMQBLs7bFU74nrsKHY	1594	1200	551	12463	18974	jxySdWZMdrwGFrmHmjiHxJcpgcVVf19BJbCWe1n4BbBaGKMpLh4	13920	19624	19624	1619471520000	canonical
28155	3NLs9GEaEebFFw6tmaS9b29cU15TcpQid7UPzkKAErkvB9AZ9j9U	28153	3NLRFJUUbsa249fvS6xA6Dz5p1dyt4jSQNbc3mo4G9iXTv7KnGrK	1403	782	551	12463	18974	jxBJbn2jmWFT1A6zPy9zYCpJiMRGr1DXvmuJHDoYCvu5repxGNE	13922	19626	19626	1619471880000	canonical
28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	28156	3NK51EPWT3A9XtQ9BeZrckfVFbZqa5XwGXNuTJxTncaWtyUba53z	1403	824	551	12463	18974	jw8DsTrkxke5aiCWviyepuHc4DJbQKZcWx1uPaRN8DUnhNqPVCC	13924	19632	19632	1619472960000	canonical
28158	3NLwvfCQmyVMtE5BW1XFwTRrUqxWcLK7okCQThw1Qp6hvAmVkYPg	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1675	1342	551	12463	18974	jwtUE5p1GPrqb7dAq1zvcWNcwuHitUkRM1WZXXRPLTyDeWnjc43	13925	19635	19635	1619473500000	orphaned
28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	28161	3NLNN1yh5Zij4UdscRKv7B98Voq2q9FUjjCGGdGVwUatdQKRMiXE	1407	1395	551	12463	18974	jx11mkTqvGTvV9QFAJUA5JUzDHs4XPbPw17MjAcKD1tvp9KeqJ3	13926	19636	19636	1619473680000	canonical
28166	3NLtK7zNZgT8iEe5JAR7ybwL8r9pyMz2J4upGvNBDY5jkUZW73c8	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	1509	1320	552	12463	18974	jwNBi4kjvcCDDGhLkjpZgFoGyU1yV1MD51SteNDubxTAz6ydhxN	13927	19637	19637	1619473860000	orphaned
28172	3NKomX9tHZe7EeUCXSosyWca9bRFhdhind8XfYgDvkv9kLMpv8SG	28170	3NKBxaN976ETqQZCNFdS5z1dp3z7o2WV8SQ3jhhxiT11aQmaUYNw	1646	988	552	12463	18974	jx7LmN2k66FNPoZveabo6tMTxdZLhDWRKEgpKBqCLreCHRwBNXx	13928	19640	19640	1619474400000	orphaned
28169	3NL9qNrjbKdnt8KtDv2rxoVzDAdZyPnyXBwATifSPuHYZVJMkVJr	28001	3NKmRTQJJG1JC4d6YWFNvJhrydKefS5as4mkE7je1WCyFZx9yR5Z	1513	1379	547	12463	18974	jw9EeU9K1D6zaVvsuxCQJKv5j2TxbLA6fXdVM1seo8Wo76ReKV5	13846	19637	19637	1619473860000	orphaned
28171	3NK8qhT5W1Y93mnmXA9WXYDBs8rSZGemkAmBiTGebwUW6ZErkKtx	28154	3NKTvSAFtFzeG5HWqL5akhiyZHx1iqwQs617fZN7JVAZYLFmq3y3	1553	776	549	12463	18974	jxHh4zdTfnCY5m89WrvcyajiMfQUsfevtGh7xwBwVaxsSxoQ8Rv	13875	19638	19638	1619474040000	orphaned
28191	3NKgPb7HgwQP5j2f3zvXRz9A8iXiV7UdGYjMRHyVr4ip4DocGvsg	28171	3NK8qhT5W1Y93mnmXA9WXYDBs8rSZGemkAmBiTGebwUW6ZErkKtx	1553	776	549	12463	18974	jxt9sUjeLniCvQx67jRbf7kC6x7yKgtqKRLuteBGEG8MYeDrhvB	13876	19651	19651	1619476380000	orphaned
28147	3NKDocauqcuoJb97f9pmp7jeeKidvaQGyDJrWywZVDapBmZCKqxM	28145	3NLw8RCbVf8PcVLijakwPUdD4GCnJe4CfwQfakxytbgtcd9G97KU	1631	794	551	12463	18974	jxcf82PXrkTFXaLe3QVgYrL8Pm3mBW2P1zZETamAcSo2FWt5nYt	13915	19617	19617	1619470260000	canonical
28150	3NLLrfzCk7eXezRFmqoC4nizwkCQ8j6adkPzdUCZdSfZsi8ioszB	28149	3NK3sE6WDbHhBdScfyqrr6dtCghKmGJBnzUQotKQNLwjeueenKA4	1657	1344	551	12463	18974	jxTEQNye7DjxUojddpfHaXqgrzrtAAnBYWKngaCvnA4q2rPy7HY	13918	19621	19621	1619470980000	canonical
28153	3NLRFJUUbsa249fvS6xA6Dz5p1dyt4jSQNbc3mo4G9iXTv7KnGrK	28152	3NKPwujiTy44irFfQqfNUgFNeREC48ibbDmv99hUnpcssUnib8LB	1657	978	551	12463	18974	jwdpSb6DyWZ38uNQszvRBSNdezJgSn7USFe4Zh1yuM87zcz4bBJ	13921	19625	19625	1619471700000	canonical
28156	3NK51EPWT3A9XtQ9BeZrckfVFbZqa5XwGXNuTJxTncaWtyUba53z	28155	3NLs9GEaEebFFw6tmaS9b29cU15TcpQid7UPzkKAErkvB9AZ9j9U	1631	794	551	12463	18974	jxvFa5EXaQbtrEYuGM28QeW3Zck5aDnjruHk8ryDARCJPw9JGpx	13923	19630	19630	1619472600000	canonical
28161	3NLNN1yh5Zij4UdscRKv7B98Voq2q9FUjjCGGdGVwUatdQKRMiXE	28157	3NLNmxr4KHfwFCeoHTo8FMHx6fBqCedKEjVCKgKAEcGVvEbAMdMe	1623	830	551	12463	18974	jxEf17oTnQmGGo4AMPP1DdwK8NMK61nymUGHgNEW6sAFvrfJAFJ	13925	19635	19635	1619473500000	canonical
28170	3NKBxaN976ETqQZCNFdS5z1dp3z7o2WV8SQ3jhhxiT11aQmaUYNw	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	80	1273	552	12463	18974	jwLSSfVsMXYKub8R5q5HkG5385jAPiwPjhJNLZTzqQD3pYHiEZ6	13927	19637	19637	1619473860000	canonical
28165	3NLVvfpjSVbSY4g3hsJVE4gHUckEihVftdCMhPxHgmNJibvr8X8C	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	1509	1320	552	12463	18974	jx87rqRmjn7APSCaVJMyBgBxiX3om9dhcmajYFqarCbbmeEmN31	13927	19637	19637	1619473860000	orphaned
28167	3NLjcFboqvQCnSg7CqYpUpe8d3EfuWm4Fxze2nBbQB2zhg7Twh28	28164	3NLKzZ46zg9Xmy7ach1aXj3yQXfYGQgR6XMf2GDgzcYJZSozAvqa	1406	1393	552	12463	18974	jxnZ2EGjYMdMaGgNLUFUTJHLixsj2pYqQMCYAnLobQvmxA5hAqP	13927	19637	19637	1619473860000	orphaned
28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	28170	3NKBxaN976ETqQZCNFdS5z1dp3z7o2WV8SQ3jhhxiT11aQmaUYNw	311	1181	552	12463	18974	jxhPcLJ9DsxrxEdUiJPNnMifdebQea4GvWvuTwZoZ9Mh8aqnxRn	13928	19640	19640	1619474400000	canonical
28175	3NKN1Nwof6pYKnMRCzpTnQrtYnfiCuMyBBnnBCaYLd6ExwZj4Uco	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1527	1047	552	12463	18974	jwZusTPpEpKiFy3Dh8LasAMDWQxSrtqkSnWmQYgLWqG8stioRqB	13929	19641	19641	1619474580000	orphaned
28178	3NLvCjp9V7kAEHQvSfWFbkxgNVt5ZLSf7ht5cfYo2nZD8DVDtGdH	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1527	1047	552	12463	18974	jwrSCKmaLGyNL3XiyPtPTH6hMpcg2TFetQQks4DoBFXviA6ELqU	13929	19641	19641	1619474580000	orphaned
28182	3NLAkLsu8jxMMtLGaXdN4Coi9F3Mrwezgb1CPPkbYuLGiNrKPGPJ	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1656	1343	552	12463	18974	jweHo9w17KjrfxFpTYcp99dNXv1bKnfYqTdRYdbiP4fYpXQhWq2	13932	19646	19646	1619475480000	orphaned
28184	3NLkX4yMLkG43X9isnRHvqVRrAYHbgq3y1rFanq7fPwLAyDauft8	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1523	1321	552	12463	18974	jwaqBn3NM9NJQxEg2LKQcTW5R4k5PSoeNEYyw1EbhocyYR6dxYp	13932	19646	19646	1619475480000	orphaned
28187	3NKzviQD4Wh8Gq8ezvci34U6igqt5YxjG3EGGc2GUsZsw1aGY3uB	28185	3NKHEtdiHhakoz3m4vhbQJgWUEG43cBmMhHWdLGwxEC1Diji3FsW	1406	1393	552	12463	18974	jwXwcvpUdkwzrgjNtGc6oqMgfSRvGhm6S9RpeBNYizCQnkZMxsP	13933	19647	19647	1619475660000	canonical
28189	3NKzBXmvq8424Q74bNVzn3bjKxpxFbhif16aEv7x8mDBbwfAa9SU	28188	3NLsk5auQ4PCoCFS3apr156S2UAErQFGJDx1PBa6Fmx3whR8rTaG	1406	1393	552	12463	18974	jxUC4nCDbqFTmKJwM5nB7qY7TUE48AGkSUXu3egHq6rHkts6GkK	13935	19650	19650	1619476200000	canonical
28192	3NKAnFsmX7gFJ5K1UNPJAzv7xxM7HnnesKRnArafri39uu5GCWEB	28189	3NKzBXmvq8424Q74bNVzn3bjKxpxFbhif16aEv7x8mDBbwfAa9SU	1439	913	552	12463	18974	jw7duNAtAeMtz7Nk47sQqM7yFjButpT8o619Auba9KxBR4kS8oX	13936	19651	19651	1619476380000	canonical
28197	3NKLoQ9D3dTxR7rBZCXM2irPVYKCnhkhg6MmegHYSNJZ8xVKoE6f	28196	3NLtLWo3ioKi1vTUEHh1ZUMLTv7jYSjikHKmvntTFQfqBsDGD4Rt	1406	1393	552	12463	18974	jxFGnts11viiRKTvsUfMdLJ3Bq8reZA3EC9Yhte8Q1Nd3PS9dxX	13940	19655	19655	1619477100000	canonical
28238	3NKiK82utVXSmsGkyKkBJQwgDgxbennUfeiaqfw4z6dy6Xy9TnNW	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1623	839	552	12463	18974	jwhaWFdtE88JGECTyGcmSthxXxJJ6j5s1P9PEoTuLcwfENdxBnS	13943	19678	19678	1619481240000	orphaned
28207	3NLKQcMRAXk6uvhR4NxopL2siEa7oLDZi9WuHiSx1jFeoZw9j33q	28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	1407	1395	552	12463	18974	jws8ejBRviQ6pPTsggJWZ99CK1dEKfwFSjvU8sNVeMoUFSWkA8c	13945	19661	19661	1619478180000	canonical
28209	3NLqn4KYdyakPASxhB7E5i6CMUNmGP5LmXGiadGsbt7TtBH83JRL	28208	3NKoQYrfkg3HCbdK2FvBEFWFYwArsJENhzFVcCuzdxsyNvNFBQZR	1662	218	552	12463	18974	jxuGTSTV4vBErmZ2uczmGvU9kaiA1rBWxtbmUDBM5CytAUMHzBp	13947	19663	19663	1619478540000	canonical
28214	3NLVNhg75JxYSprQjwYNFiud97u4952ZK6sAhthEA3pc4tRHTySq	28212	3NL5YqST5u2Bq5wP5srsRSyp9mS1foDU7eCYFLaHW2sWHFyrydW2	1406	1393	552	12463	18974	jwJpDNd5xDRSp5dDk545gzAJKgpyT8Buce98uhLFFiN92yuCRaK	13950	19666	19666	1619479080000	canonical
28217	3NLqBB9NSW1qSpgr2cQ2LzvDou2WNq59rJhFEgNQobJNSwUKkTo6	28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	1445	1164	552	12463	18974	jwKUjhqwu7HRFgGZ9X5auxbJYqLufwSyYpmHVBuQyZ2Zs85MPpS	13952	19668	19668	1619479440000	orphaned
28221	3NKdZPizzXsUxN2P44PpSLEaDfhD2M6QYUDUW2z8ypW6DQESspvv	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1403	824	553	12463	18974	jxR2AHLsSrCxnwnjhLZbKb5uJHJDUC3R6YGi1vN7zFuX9JHP9KV	13953	19669	19669	1619479620000	orphaned
28228	3NKNV7h5Jy3raJ6a5htiDo1CVGDUKucK4ZTPwyoWALG1xUs22JYg	28226	3NLAibBwKtVpvCsUEmLLF2yFAeZS6MXz3Q9f8rD6jxrJxhtC7YYb	1599	1161	553	12463	18974	jxudC5xc3S5zvV2b3dBmGmZFZQMsrFbZ1Nbwgj28oguS1Zm38Rp	13956	19672	19672	1619480160000	canonical
28231	3NKBUeFaS9HHiLy5eLHC1WJrRFfeFt6EjrGaacWfEBhnXEAeX3ou	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1534	1317	553	12463	18974	jxhdqqm454gsJefPVNPfpCm5EWZ6pHiPvKzQeDRPqRdEfFNxHAy	13958	19675	19675	1619480700000	orphaned
28174	3NKXxRSTmJJQst2p7gm76EsRhQwSQEzwG9tevbn7mA1VwBsFNkhy	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1671	1365	552	12463	18974	jxFDwBdCvu5JQr7NadPZLFEV8dkcZXyCNo7JC1LnWo2USgn7SoU	13929	19641	19641	1619474580000	canonical
28176	3NKFBG5rxkixMGmjBdLQ4AKAN1JESQdwNzs1suEFDTbG8z5S4bQq	28173	3NKGENv7SSTsxx6HKfcg6eLpKRjJSh9TV36qEtq59xzkmvZxNzE2	1407	1395	552	12463	18974	jwEsA7kTk6inwdKnApvTMJT3Sdb3FqjedPc6uwBwfHJkU9RFpog	13929	19641	19641	1619474580000	orphaned
28180	3NK8YPDgtQVeHTjDRoEva4qm9AERiaW78ZRtAFY4qYBetcXZRrfi	28174	3NKXxRSTmJJQst2p7gm76EsRhQwSQEzwG9tevbn7mA1VwBsFNkhy	1648	1284	552	12463	18974	jxShAuJSuaKKYht9gEtuu7LHs54JTgEG5bMJLCtdGq71k2ZeUiC	13930	19644	19644	1619475120000	canonical
28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	28180	3NK8YPDgtQVeHTjDRoEva4qm9AERiaW78ZRtAFY4qYBetcXZRrfi	1403	824	552	12463	18974	jxiiEoymhm8xmjSsv83y8eyJMYSM6EtxUWpHois8dUEvtsrNXbY	13931	19645	19645	1619475300000	canonical
28185	3NKHEtdiHhakoz3m4vhbQJgWUEG43cBmMhHWdLGwxEC1Diji3FsW	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1523	1321	552	12463	18974	jwUBDrYmKdXPuaCP8uFjm9CtriLtScQgWJWgJabEh9KQaE5uNRW	13932	19646	19646	1619475480000	canonical
28183	3NKxcBcH6abx96pcjzPg4NS3rUEeZSyi9q7oJ8G5w45L8u9Hu4zA	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1523	1321	552	12463	18974	jwBgVfQyZUM6bdfgCu7cjSeSFgF2f3iqpu7TgGVvY7R2wNUfrRS	13932	19646	19646	1619475480000	orphaned
28188	3NLsk5auQ4PCoCFS3apr156S2UAErQFGJDx1PBa6Fmx3whR8rTaG	28187	3NKzviQD4Wh8Gq8ezvci34U6igqt5YxjG3EGGc2GUsZsw1aGY3uB	1646	1354	552	12463	18974	jxP2r7mc3Mrnf2PUR1vnBmQHZkAwrnBraWPeBwPdfmS1r2aqeiq	13934	19648	19648	1619475840000	canonical
28190	3NKqXWnAdBv8Zi1rFpeeSMCHEdc146jfe14VH5GuymGHNgksxFvQ	28188	3NLsk5auQ4PCoCFS3apr156S2UAErQFGJDx1PBa6Fmx3whR8rTaG	484	1319	552	12463	18974	jwhcLnK3uC8dXLTzgq4QPUbFboVLxAKr9wE2pJ6oQgEaqjRJHBf	13935	19650	19650	1619476200000	orphaned
28194	3NLLXaSEjCW3cdaFaFRYcSQAkzNagjGpS5iqfBmbkB8pvXF48tFk	28192	3NKAnFsmX7gFJ5K1UNPJAzv7xxM7HnnesKRnArafri39uu5GCWEB	1526	290	552	12463	18974	jxTnyNeV4DvC59nBwGgbLA71sf3cxatPUiH9pHLspakVECLuNT2	13937	19652	19652	1619476560000	canonical
28195	3NKDvvYg6SyTDuhrsRzqeFnGDtxQQ9SWZupmthScVtJfvP3vJxaR	28194	3NLLXaSEjCW3cdaFaFRYcSQAkzNagjGpS5iqfBmbkB8pvXF48tFk	1422	971	552	12463	18974	jxHUMDc8RyiqqsvK57tVgBpKRufLJskY8dA4GCUWRyqtnra9p5g	13938	19653	19653	1619476740000	canonical
28198	3NLmFEAmeVHYG6qniMr58yYfVMEtw7pcn1QjBsfL28Bjv5y2Rap3	28197	3NKLoQ9D3dTxR7rBZCXM2irPVYKCnhkhg6MmegHYSNJZ8xVKoE6f	1471	1386	552	12463	18974	jxezcXpQrRA2dWJNsNHLZw4Y3XbJZ4xmdKVCsJjyak2kS1bBarp	13941	19656	19656	1619477280000	canonical
28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	28198	3NLmFEAmeVHYG6qniMr58yYfVMEtw7pcn1QjBsfL28Bjv5y2Rap3	470	1309	552	12463	18974	jx3r1BQW3GueR9mQ6rCsA2pze1y4KUKEXMXnq5ismh7Z5Tuc2gR	13942	19657	19657	1619477460000	canonical
28200	3NKPZXCf1oVrcZLcyTsQP6ainGX3DzV5XNqMakhaBUGycMWruT7n	28198	3NLmFEAmeVHYG6qniMr58yYfVMEtw7pcn1QjBsfL28Bjv5y2Rap3	470	1309	552	12463	18974	jwHzrh4K9W4Hen53XGhbYvto9Q9sQMaZHYTwCLakKGm96GcKJrB	13942	19657	19657	1619477460000	orphaned
28202	3NLV8NdXjsT4ptNsh1XCBrbeFSmpwF96Nt4tAT7aX64iALMemvza	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1406	1393	552	12463	18974	jxETq5QtfHMbUrqzebHq2SKGCrKb2snoT3yvxugEs93wL3MQTkT	13943	19658	19658	1619477640000	orphaned
28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	28201	3NKtPHvJQ87ECuueoNQW1gWZM5o2W7Z8TeLjvx3px1wDnfesf2xE	1637	816	552	12463	18974	jwnomGz97LFR7CPhfu2UGjv2PtWG8BabrEpK5Xate3SnDWgnNmC	13944	19660	19660	1619478000000	canonical
28205	3NKaAdFGyY15AyjSH75QbCwVq72DK1yfJEhhSt4d4VSqK9fhkEFA	28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	1642	1241	552	12463	18974	jx8o3hf5xbiGDSCMroxqDeGWPdhtgvfEYfQxGF8zr2SywGwLjK2	13945	19661	19661	1619478180000	orphaned
28210	3NLp5szkAJo48pQKkQAfpp4x2pU7mr5V42zEtsyCNcU3vigrGC8u	28208	3NKoQYrfkg3HCbdK2FvBEFWFYwArsJENhzFVcCuzdxsyNvNFBQZR	80	907	552	12463	18974	jwtei6jzdps3KqZ6eiz7aqZN9teCk4bf1e2cbDapNbXekLQ3Fhk	13947	19663	19663	1619478540000	orphaned
28211	3NLwUgWBCsXmaj1vK1CmrjLkMxneLyXi6ndfbJ1DY5CVpydRRA53	28209	3NLqn4KYdyakPASxhB7E5i6CMUNmGP5LmXGiadGsbt7TtBH83JRL	1596	1117	552	12463	18974	jwyeopC8aqjyrRmikPa5mWxCAmFmetG6z4wajRHRbyfmZ7xnGcP	13948	19664	19664	1619478720000	canonical
28212	3NL5YqST5u2Bq5wP5srsRSyp9mS1foDU7eCYFLaHW2sWHFyrydW2	28211	3NLwUgWBCsXmaj1vK1CmrjLkMxneLyXi6ndfbJ1DY5CVpydRRA53	1589	920	552	12463	18974	jxq8ciWgbFgScFwwfUqL7pHmL2pjq1jHfbQijcbPZRTNxdLU3Dw	13949	19665	19665	1619478900000	canonical
28242	3NK7h9aBEFAbVreR5RoWXmb3L5HeRZEuqYoRovRFcz3FE4nhNWRy	28240	3NLkshjxpch5shHqaAyAL5FjbS2ohfHLFAfGZmteetVB8ARU2MNN	1407	1395	553	12463	18974	jwn359DLMePNqn5Fv1QMBBBe5CwRryVhTNstLRT89teqMAQe3hv	13963	19680	19680	1619481600000	canonical
28247	3NLJ4Q27r6EAbBV74A7Mfkn9hGC3bpzdouJ5qUEpHoyR2r2LgXkd	28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	1407	1395	553	12463	18974	jwGwhipw9AmF8w9PDBAWZzZigiUiGGbNoKrGnL9u86U1kjuzEzm	13967	19684	19684	1619482320000	canonical
28249	3NLgAbwyRyiojL1Kh9wSgdTDbh1PpCZPt6usWPp6aoeK2Q4eyDWC	28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	1440	1131	553	12463	18974	jwyTYMFs4zDTwXXfY5BEB9HNjPThuURp5KGjkcxkWrBW5QuhJQg	13967	19684	19684	1619482320000	orphaned
28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	28253	3NKCSsojsUGDDcFGhiH4ASzwYw9X8vGy9KvXWow7axNfBcpJWKfD	1668	1370	553	12463	18974	jxxnJornY8xtsFZWTkpmCKFd5Hf3NRzZe4rD5HSA55Vz6Tt4DAo	13970	19688	19688	1619483040000	canonical
28256	3NLsP8NYHw89PbUzTwsqnLuFsfCdN61sXxbRxb8evUYUeuLMfRzV	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1406	1393	553	12463	18974	jxii59HdXqztN1vr7snrdDN1dizQ2K9XC7HAfq8ez3Eb2e2GzfZ	13971	19689	19689	1619483220000	orphaned
28259	3NKALd5Ub9CkJ7txUsKbPsjD2h13VxKfzZhj9BZYyd88Nb1uyHFN	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1542	1304	553	12463	18974	jxCjFWnVsu3w1wyzy6ncQgUZ8dQHrdJdbUqfBxKgNgqpGgxbi9C	13971	19689	19689	1619483220000	orphaned
28261	3NKDkuLK6dnuGKeRs3QwySiFSCkVLbzmMws7kdvLpVnp2feSbeXv	28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	1406	1393	553	12463	18974	jxnesMHATGUCrnDwmENNPPt53pzBxLYNVXwxeUreds6B7Fs4NWR	13972	19690	19690	1619483400000	canonical
28267	3NLdbeTQSaviTiyzpMKkXPCxuJF6Xd4JuMdK3bfG5c18pm51cUDW	28264	3NKy1jgpnBBUebNWN5GverytCZCPgNRmruLhTj9KFE4hja6XE7Uo	1407	1395	553	12463	18974	jwxdtxc6CYYJK8gVMdsRC4GuVPySZzKe5BMw61LaJgzx1VPgDxB	13975	19693	19693	1619483940000	canonical
28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	28270	3NLFTGAagyHaYZcdMqWvsYNsEvveYf63PSxG71awMbtpfJSKHzm3	1646	1108	553	12463	18974	jxNGUifPgSnLF68hyqY2LkD8oVWY38XdZSuUYNy6e2Mu9sktWxj	13978	19696	19696	1619484480000	canonical
28279	3NLYjMXYkUcrVVjE9kyfVN24nnWpGW8ArbyG3WkUJ5qgxgDZo79T	28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	1406	1393	554	12463	18974	jw7ksD5o57vuNWBFPHddenZMCBcHksZT9omPU7k3ZaX7dbXgHKn	13980	19698	19698	1619484840000	canonical
28268	3NLQbsocT1FnSzt8JHsYYvP4sMr66xQZvM4aD4KWFQ8oRk5STt3k	28193	3NKchsZmaaqeJS9wxtrzsWqqBV5Mz4Y8bb7Jfi1vnt1mVM9RmvLk	1553	776	549	12463	18974	jw82wErrcPDebo23s4PdNo32BRcRLQbFjpDSsbthvwXDgKRrmig	13878	19694	19694	1619484120000	orphaned
28225	3NKr4NQRaMA8bsBhQuo1feUHaoikTEeqz7kTsdFnM8UPvKhiXnJJ	28181	3NL223NcNCX29uXmRPqxcRNmLkkuYG8nYVmpJsRMTCSgAmdXRN7U	1426	1364	552	12463	18974	jxo8n4pKy2JxpehrLV6ZEUwX3kkLCFETBDEYLkcbs5hHYVTfPBK	13932	19671	19671	1619479980000	orphaned
28196	3NLtLWo3ioKi1vTUEHh1ZUMLTv7jYSjikHKmvntTFQfqBsDGD4Rt	28195	3NKDvvYg6SyTDuhrsRzqeFnGDtxQQ9SWZupmthScVtJfvP3vJxaR	1403	824	552	12463	18974	jwbc92xcrrnS74VgVQzdk2LL6Hawe5T7xwDKV4mBs5a7CuPPjaJ	13939	19654	19654	1619476920000	canonical
28201	3NKtPHvJQ87ECuueoNQW1gWZM5o2W7Z8TeLjvx3px1wDnfesf2xE	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1467	1130	552	12463	18974	jwmQFpcrngQM11rHbb5Gu6uwxdu2PF9cjBMPT1dao5nPu7r4TNU	13943	19658	19658	1619477640000	canonical
28203	3NLCzmi7VxzPLUyXH4AMfaLmFRyVVGKNKPGdQDV9CvxDFd6S3qMR	28199	3NLkApaXhFXCTxcsW4yZKAW15N8syDsXqou9ptcdnzmWHeTGFPAo	1555	1221	552	12463	18974	jxyqFnmVbew4hDjQmbH3zb4mEgrP81nBX95EnmDKfbthCX9P3aV	13943	19658	19658	1619477640000	orphaned
28206	3NKLY9NTbByzv1T9mtbbaeuXMPCy4n7nG2E3pKDZAbwjo93qM5iZ	28204	3NLfQRkMz7ew9nB6Ttj5zCV9d2Qc1jEYJxtmGuvRdCXhWdWp3e8c	1656	1343	552	12463	18974	jwcz4dxdC18wJJxTpzPd69vy3HMkWkWtAFZiwTAwUqJoQxSackA	13945	19661	19661	1619478180000	orphaned
28208	3NKoQYrfkg3HCbdK2FvBEFWFYwArsJENhzFVcCuzdxsyNvNFBQZR	28207	3NLKQcMRAXk6uvhR4NxopL2siEa7oLDZi9WuHiSx1jFeoZw9j33q	1406	1393	552	12463	18974	jxAWbZcpAETnPu1dQVEkqLnHSuZS6rs1MqsDWvsfdD3mKuu6VWE	13946	19662	19662	1619478360000	canonical
28213	3NL14ne2EVngNsUthWMhckSEk4Vpni2FrcP2PKdLpcAkSMQthXZK	28211	3NLwUgWBCsXmaj1vK1CmrjLkMxneLyXi6ndfbJ1DY5CVpydRRA53	1593	1346	552	12463	18974	jwd6c5LaFaKktL2y1rDFrjd7Pxw28Vk3KovGgWjJ7XF1mjD37PJ	13949	19665	19665	1619478900000	orphaned
28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	1445	1164	552	12463	18974	jwKUjhqwu7HRFgGZ9X5auxbJYqLufwSyYpmHVBuQyZ2Zs85MPpS	13952	19668	19668	1619479440000	canonical
28218	3NKFgSGukVqJUS9spvzxb9coyT9CZ9BHqokznRLN4K26FyXtPc6U	28215	3NKeLCH62sfTRidkzEmjqtuXtxNscCXSnFWdetUAa7kZ4URy6YSs	1445	1164	552	12463	18974	jwKUjhqwu7HRFgGZ9X5auxbJYqLufwSyYpmHVBuQyZ2Zs85MPpS	13952	19668	19668	1619479440000	orphaned
28219	3NK4md7wnNG9dQwD2GG1EYVUwctRKEvndL2LAT59BU4R69aJNw5g	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1406	1393	553	12463	18974	jx5at5CVm9mpuqVtjuE5sEqQTrgQ88UwZTMtyHttFDUQEABw7e5	13953	19669	19669	1619479620000	canonical
28220	3NKJXRusTDozaHyZvtsdPZYt1o9P72x6gH6zCQxkLSYhrYvnAKfz	28216	3NKbvvbovKuWZ49NhgxV53T8ErxwrKRcmiJaNLbsb3a1Lty62VEA	1585	1366	553	12463	18974	jxWMP9vnUj5AvrvwecakgNcvkhkAKbQEPkZRFF5bxfV3ZCkKGnL	13953	19669	19669	1619479620000	orphaned
28224	3NKd8rzswzBvTXBSsE8eX1tb6Bx8nqQjBQueycFTGUqU1N3ZBzHa	28219	3NK4md7wnNG9dQwD2GG1EYVUwctRKEvndL2LAT59BU4R69aJNw5g	1560	1045	553	12463	18974	jxMMF4h4A2DHMCHAuAsry1CShXuPAVTSMihjNM33qcL6PyzdiK7	13954	19670	19670	1619479800000	canonical
28226	3NLAibBwKtVpvCsUEmLLF2yFAeZS6MXz3Q9f8rD6jxrJxhtC7YYb	28224	3NKd8rzswzBvTXBSsE8eX1tb6Bx8nqQjBQueycFTGUqU1N3ZBzHa	1426	1364	553	12463	18974	jwVbFs8fem3237RHYBFodyR2BBJ5zuUqoYvcGZdipfbiPaXvKSv	13955	19671	19671	1619479980000	canonical
28227	3NLFepbczgXy9Bsy18E2MYTqLfMwvC5KrRzL6yyckf9yZZTMMVvY	28226	3NLAibBwKtVpvCsUEmLLF2yFAeZS6MXz3Q9f8rD6jxrJxhtC7YYb	1476	1371	553	12463	18974	jxYJTVKEvWvnKc6La92L1bG6ukoAQT9JyKnR724EdY4FbYCrK6w	13956	19672	19672	1619480160000	orphaned
28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	28228	3NKNV7h5Jy3raJ6a5htiDo1CVGDUKucK4ZTPwyoWALG1xUs22JYg	1536	947	553	12463	18974	jxRi3bNtrY9YFcPJi8MtbMZ1tf2DdguzyUqQ65Swi6Vni3rNEKP	13957	19673	19673	1619480340000	canonical
28230	3NKSMpz9EGjjBJEazqUzEQF3LcpkBFGdK2ihC2c77ecHYht3e1yx	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1501	1234	553	12463	18974	jx1BrSoF4vR6AJv84eWeoet1573k8hSDaNicem4NCQCWfoh4sJp	13958	19675	19675	1619480700000	canonical
28233	3NL5eEmsxb6ij2VAZg6h2M9ogyczZH89pbT8jMJfJo2RXo1HZ7JG	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1577	1327	553	12463	18974	jxqs8JmUoJCTQYBx6dv9xyzcj2F4dbvzfesNTtfcVrmmoznowen	13958	19675	19675	1619480700000	orphaned
28232	3NKVx9GK1usGvrT4rGYN6jJBu2CwmhYMFHHg2wpZh3Yiph4vxyaV	28229	3NKcoaCj7jutCijcgUPEb9AFd75b5SGW5GqUEckv928fdnj8rC4G	1419	814	553	12463	18974	jwYw9B5MDCPTFHgkNKLDQMP2SPVdoswfo3WJxkof9i3vV5mnULc	13958	19675	19675	1619480700000	orphaned
28234	3NKAAc7E4aRAF9g7epFqJ2f2dRakxM19LtmyZt9KsdoCNPa8btYV	28230	3NKSMpz9EGjjBJEazqUzEQF3LcpkBFGdK2ihC2c77ecHYht3e1yx	1500	931	553	12463	18974	jwRR6PRf7f6rxCcHgLJs1QUhXg8pfa8CRGHArKnDzXFZcLVqb99	13959	19676	19676	1619480880000	canonical
28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	28234	3NKAAc7E4aRAF9g7epFqJ2f2dRakxM19LtmyZt9KsdoCNPa8btYV	188	188	553	12463	18974	jxysZ2bXX6f764tv5xLhsNxDdmPP21hxhEi5iYVmjTZK8yeZbKg	13960	19677	19677	1619481060000	canonical
28236	3NKK7Nir9ZDi1tpchbdZw2wjYe6H5M4bSZ6FTcknkhq9WFFcnXiw	28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	44	1199	553	12463	18974	jwGgxZ2a4PzWmFdmWdXedp7ja56f7FNL8mjqbjZcHCBFDQ6QQ3E	13961	19678	19678	1619481240000	canonical
28239	3NL7QVYnTLkMdG3KVikbzrLMq52JzjU9NjTCn9aqpQEKA2bsSuM8	28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	1403	824	553	12463	18974	jwDZ7VDG4EFE1puGMDuCYgqgfvuRQPdo9LBmPXZhewsEW9gSUCv	13961	19678	19678	1619481240000	orphaned
28237	3NKvGmsGsv7sfSV7Vu6Be8xn8ZkgxNHLn63YVvTT5QJ43SVctveP	28235	3NL6b6PEJ9EyeZuizLBTfSBQA1RTDfKMrqbHhPwvBuXuD3CkAHwz	1406	1393	553	12463	18974	jxFYUSUffmD6hh9v2UAbCVMtXnHRW8M7HUAnGJBtN7xCsXTx9iG	13961	19678	19678	1619481240000	orphaned
28241	3NLs1VbsruiuJUNYkdEmeJdWG4XSaGNnVKKPfU3pV18qddSMvtHr	28236	3NKK7Nir9ZDi1tpchbdZw2wjYe6H5M4bSZ6FTcknkhq9WFFcnXiw	58	1035	553	12463	18974	jwcYctpXsbtSHj2jNcJUACuDY7K4pkk4cYuyjASf82Kta8aAa61	13962	19679	19679	1619481420000	orphaned
28243	3NLT2cSmrBEEcncgv7efxFXpTqxuCwHpP35ZM23jzcvHBoAEJyJi	28242	3NK7h9aBEFAbVreR5RoWXmb3L5HeRZEuqYoRovRFcz3FE4nhNWRy	1467	1130	553	12463	18974	jxN54J1eDmE5qtZXoZYNWKJSvMyjPkadafRWS3piB4iboHHQZHE	13964	19681	19681	1619481780000	orphaned
28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	28261	3NKDkuLK6dnuGKeRs3QwySiFSCkVLbzmMws7kdvLpVnp2feSbeXv	1637	816	553	12463	18974	jwHUDjV6dxwCvDkCaeY5YAL9da5oBXNSQEMYJDUK4MzbV17zedJ	13973	19691	19691	1619483580000	canonical
28266	3NKXjMnG79uBqf7nU1AscmtFFGgvUAFhyvGXhnQADpWoe9JAm6dP	28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	80	1147	553	12463	18974	jwsJVByY3A5cmFbzMpJ9R9YvuVC6sZpqBvX8otsoXCAk4456iFb	13974	19692	19692	1619483760000	orphaned
28270	3NLFTGAagyHaYZcdMqWvsYNsEvveYf63PSxG71awMbtpfJSKHzm3	28269	3NKgYnDiLWJg6VW9efWoBzdia4FjSNGXeZb7QQAs9zxWRkaYJ2gU	1546	1213	553	12463	18974	jwDceQM7soConBS8SRR9rGVouudY7gcCGVdJLy7rcBdVp6enDHH	13977	19695	19695	1619484300000	canonical
28245	3NKjVsUYG5eumYGrT9RrYrVEuExo6SdqumMVumrqXfTAvk2na6YH	28244	3NKPRKPwkmqGajTDxYxoBCg1KCCnGqTvoN1Z3W7Zemrwj1fNbvEv	641	1090	553	12463	18974	jxdXowx6Jf5Po1ymx9qBJJJdzc6YNwttKCQLVZihvR1N5e3NYWR	13965	19682	19682	1619481960000	canonical
28248	3NKFWCMKMgJGWBbnbLJpvsfpfoc9DpHuVy2kyFZgXTf8vVQYPXGR	28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	1440	1131	553	12463	18974	jwvwCAmUCTmiX2SXmM4EMyFcWBRf3XPscf4VDBq7sV92pUyXbzp	13967	19684	19684	1619482320000	orphaned
28252	3NKPnFQtXgfMiQzq3sXPWjZ1k33gAybMMPy1UyrVJzqZEqakCPud	28247	3NLJ4Q27r6EAbBV74A7Mfkn9hGC3bpzdouJ5qUEpHoyR2r2LgXkd	1403	824	553	12463	18974	jxVKJpAgteMuewbLGjCoY6zpyQ4MBwKhJZKZk73vyofcDLFiHXX	13968	19686	19686	1619482680000	canonical
28258	3NL7KbXbhX5fJ7r9KQ4dFMwARbhMY6pEWSvbQVFkGwxcJNj6ptCu	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1477	1224	553	12463	18974	jwZSdSwvgzhQvBDtaeFjoFs8juSCV6shcsQuWYMPHwM6Fnuhdtb	13971	19689	19689	1619483220000	orphaned
28260	3NLE9SZ1MLZbSjwZu8okPZgxv5KiKfNcA9mgMu7nt5uhHth46Xwu	28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	1483	320	553	12463	18974	jwqTALnsct2VcYpbMD2SEBRT7Pgw9dbbW3LeDDujfG6YuNp5Sng	13972	19690	19690	1619483400000	orphaned
28265	3NKaab5Kp5ybZ8M4BqGLn6FMq3SWkyPhLPQBBXi63rtN6h15eY52	28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	1581	778	553	12463	18974	jwYeHDNG4mjd4PBCCRjZBmzZYRDcG4mhkahgTjZr6BMxUaB5eqS	13974	19692	19692	1619483760000	orphaned
28320	3NKDrCML2LVfqEeRa7EjHYmMdvp7EGs8Hqxk39SJ9ZtsJr5kYUbJ	28267	3NLdbeTQSaviTiyzpMKkXPCxuJF6Xd4JuMdK3bfG5c18pm51cUDW	1547	1132	553	12463	18974	jweSwbQt2n4j4U8bHtxSdtCo8wrxnT8Gs1Uh4VvWtojYRXvXbYr	13976	19730	19730	1619490600000	orphaned
28293	3NK3p9oYE6VPZkJ8jEBGCLsjZ5pVqiMD9dpNpYbAjn61JaEYbCie	28270	3NLFTGAagyHaYZcdMqWvsYNsEvveYf63PSxG71awMbtpfJSKHzm3	448	1179	553	12463	18974	jw7V7V3V4NGsBSxJF3sbTPvVde6pEFAm8hp6s3RYsZxa4U4MybJ	13978	19704	19704	1619485920000	orphaned
28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1637	815	553	12463	18974	jweEuDHmEHvxBk79QaMv2sXr4rGNiC9Ukr3UUS8RwYS2SZidbNc	13979	19697	19697	1619484660000	canonical
28275	3NKjH5iKPr5VEFbr7mQNb7SmedA8UBQQtb9URHXM4Cfm4iXSuvjd	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1613	1349	553	12463	18974	jwGCxfgsrioCCc1hwkghbpCp48svVVkjAXHSBkxz4QfjyZMdJ2g	13979	19697	19697	1619484660000	orphaned
28278	3NKKggvwUityPpT4vd2PXGfHPBQaX5qEZz1mxtPScYD3H4fTEYTE	28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	58	1155	554	12463	18974	jwipfJq4zs2eQeJb1jFQaJKvgGErm1v6PJ8fMhTi5ENCRi4wL2e	13980	19698	19698	1619484840000	orphaned
28280	3NKwVdXjZuHeXraHriuCiPb95DYParhEnwshdCsYE5pctHLG1irs	28274	3NKmJ47cJ6xnFke6wFmsCLvu9GWoGsE6WRwSuJ25p3dui6UYY5Np	58	1155	554	12463	18974	jwipfJq4zs2eQeJb1jFQaJKvgGErm1v6PJ8fMhTi5ENCRi4wL2e	13980	19698	19698	1619484840000	orphaned
28281	3NK9ABnARZhBADLmb5vqbfqDqcdkwMMaafGRmZDXJ76PXEAYrwo5	28279	3NLYjMXYkUcrVVjE9kyfVN24nnWpGW8ArbyG3WkUJ5qgxgDZo79T	1407	1395	554	12463	18974	jwGkWd7vRsLL3MyNpcB87DXMHrZxWbfUKWqUstV7EScx2ck3k2S	13981	19699	19699	1619485020000	canonical
28283	3NLmrGqP4XfAtx7iZH1rrCUDMMxUSDSj7N3uW4EYWoW87S23gw6q	28281	3NK9ABnARZhBADLmb5vqbfqDqcdkwMMaafGRmZDXJ76PXEAYrwo5	1532	253	554	12463	18974	jxFvQ9BpZ3FjRDYShnfWDUk9M7mMKwKYTvdKRyMdV1RW4DcEYeV	13982	19700	19700	1619485200000	canonical
28289	3NKfL2n3vFxn5ada9gyVQcwqbW9HUbo7Hhr7jHCqaPi6DpheFqB5	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1599	1287	554	12463	18974	jwzLTTNLRkQJgdQXMzx9LutewuYgWXPFGA314nwskPrA4FwcdBa	13984	19702	19702	1619485560000	orphaned
28285	3NLqHUfTNBCGMNtkVKexiJ9V2nAKn4F7KyoYLpYkuKM7SoaNVzwT	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1406	1393	554	12463	18974	jxuDMpZ31VcGY6kGamsEiHnwWWxTPPEQ14woWsx7LwUoguAmgoM	13984	19702	19702	1619485560000	orphaned
28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	1559	1107	554	12463	18974	jwtyuEnfKQx9GwvJocqQ59Zw7MXJ6j5omRhgceyy9EWyJdxvkHq	13985	19703	19703	1619485740000	canonical
28290	3NKdt7okqZBhXhEmdikXv3GQtJszuaGc6pPnDeCf9utjhbNwvAF3	28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	1407	1395	554	12463	18974	jxpEXzKVS1mmJ3JUgkqxUXYJJjW5xha6xC7PJvK2Ww8C5oNx7bZ	13985	19703	19703	1619485740000	orphaned
28294	3NKDucvNKQy1WeSJ9hntFJ5VQFwAKZmEddxyTnncAVf1WVPGJt44	28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	1509	1074	554	12463	18974	jxYjG5ppQ8avxjKFBCHN9Vzy9dQrSoL4wkAUmzBGGNqdvPgj5Wt	13986	19704	19704	1619485920000	orphaned
28296	3NL3XKQtkLT8pikcoehBY8k8BYmvRDF7z8Ftt1AwNv1eiYp2aSkM	28295	3NKAewWRxkPKGriamD7m2D77Ljfi9nm6q1ffpfbSKyxPnxUw3rQr	1405	881	554	12463	18974	jwJSywN3pKPkCk7j7t1HSowmFe4x9mk3SQJyUZg3FStVzDNkDck	13987	19706	19706	1619486280000	orphaned
28302	3NKQ6ZSKaT7ER8kotqP2uVkEXMXW33Z8ektT2EuPwaTwLD9CaPSp	28299	3NKZUkPEmUcbN4qhipmcwscKRTP9GjK4N6o1zrYNDomQZuT7DBHQ	1419	813	554	12463	18974	jx6JXeD5cN8J44FW9wmo2VNCx5fnVAV1JYFrbVgCfSXqZ9v6GuD	13990	19711	19711	1619487180000	canonical
28301	3NKVm5RDsZLhbqpq67UB5vVMGDNX3AW8aZs23LjtdxbAr7xZ5XWi	28299	3NKZUkPEmUcbN4qhipmcwscKRTP9GjK4N6o1zrYNDomQZuT7DBHQ	1403	824	554	12463	18974	jwxxGDEcAtdcfgStcVsPcH2c5Ezv6N9GVWvcKBqDFbpT7jcHck9	13990	19711	19711	1619487180000	orphaned
28306	3NKsEpRLgWb1d2F5S1frvzRvz2YWau7dnBytqt85EY9oF4paRoZ4	28304	3NKHmcoUZ6NfLDsQWK4DJhZsif8kpDpeoWbQjm6kmZyJ4DRNAPQw	1651	1175	554	12463	18974	jx4yoaurqxMZiyjG7PsW3vxJ9eGPU3F4WnEJCL7reNcj1szDTdY	13993	19715	19715	1619487900000	orphaned
28310	3NKVTMkaZXB3vb4TSQZDYCNci3hMqahZxrFPgEK5uPc1tdJStEAt	28309	3NLLpSR6Gx9EyqzcSwE6LAm2fN1BHETnM7yn6PoKqru6Nvi7wXia	1579	1389	554	12463	18974	jwNmwEfpMEsu9SaQJTjUw9kinN5RQ9mhVWfa2YEEPum5yNuZCsJ	13996	19723	19723	1619489340000	canonical
28312	3NLHAZyhiwYRgtxNtkGWYotfpFe8M11mF6sJKpJ5jsbzxJWRihLc	28310	3NKVTMkaZXB3vb4TSQZDYCNci3hMqahZxrFPgEK5uPc1tdJStEAt	1585	1366	554	12463	18974	jxt9JUzBFnCiL2CBkeEyT4DkkuB8TXjFGNPKayibtGPdp3LXgCH	13997	19724	19724	1619489520000	canonical
28315	3NKomps2UjbqqPfuLLNAcKLPDQm1Tg5Wes78nLEpwueRWaiRdyP7	28312	3NLHAZyhiwYRgtxNtkGWYotfpFe8M11mF6sJKpJ5jsbzxJWRihLc	1578	1296	554	12463	18974	jwX4dCPUJeQkBxWRxqux9fcaf5oD5UqRHA8ce4h6bRoyUhMsEy7	13998	19725	19725	1619489700000	orphaned
28316	3NKmJcvihPBLcEgQ9uexDJ2ptUaYsrcmo4oJ3TRqH7Ja5DMwnbQN	28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	152	1084	554	12463	18974	jwXanY4JG5BWgiTcmt7bmneKuhTeCY6yq9JDzFbDqg4mSAYAg7e	13999	19727	19727	1619490060000	canonical
28317	3NKBDNqGUjyBUwV1U6avFVAJnVi4yrtDmzJJfnLiZGzCWKymt6fF	28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	1631	794	554	12463	18974	jxcid9DhwXqovWfi3gQqF4MRYf33j6LRAHGNEiiPzsKsPyHouWj	13999	19727	19727	1619490060000	orphaned
28325	3NLb8TtnXQAavsSdSrw5n3PLdVGk4aKmV8dncEJZqPBpx1icH831	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1451	926	555	12463	18974	jxTqSUdSqvhNmFjCzDPnusMjbFkkznyrNycdDLoPS2Ftph59ahC	14004	19734	19734	1619491320000	orphaned
28244	3NKPRKPwkmqGajTDxYxoBCg1KCCnGqTvoN1Z3W7Zemrwj1fNbvEv	28242	3NK7h9aBEFAbVreR5RoWXmb3L5HeRZEuqYoRovRFcz3FE4nhNWRy	1489	1380	553	12463	18974	jxEChkaKEUadybXNK4FjBpic1ktWPEgQtLS9WFSgV5yE3qrrabY	13964	19681	19681	1619481780000	canonical
28246	3NKwEKCC6fNqfcVQYYWDrRDKjsjefyS3xtJVwLnqb8ycvh7zbDuw	28245	3NKjVsUYG5eumYGrT9RrYrVEuExo6SdqumMVumrqXfTAvk2na6YH	42	1361	553	12463	18974	jxaZTr1WHcfsQWzVrmecXQuBwynoCGjdyHDNXHcr5gLJcnRp6yd	13966	19683	19683	1619482140000	canonical
28251	3NLiTSViDULdp2vntyNLtsLcgnS45wPNJAmwUHyUXUy5NzAcNfqv	28247	3NLJ4Q27r6EAbBV74A7Mfkn9hGC3bpzdouJ5qUEpHoyR2r2LgXkd	1483	41	553	12463	18974	jxj1PgbjuwLTznpDVZkpVbLKiMPdFx7op2Y1fMcN8pSzPxYxU86	13968	19686	19686	1619482680000	orphaned
28253	3NKCSsojsUGDDcFGhiH4ASzwYw9X8vGy9KvXWow7axNfBcpJWKfD	28252	3NKPnFQtXgfMiQzq3sXPWjZ1k33gAybMMPy1UyrVJzqZEqakCPud	1460	1324	553	12463	18974	jx9kg7voF2AQogUQbxk2KRd9b4oXGRw7GZ8ScHrBmdvnMcJK5Uc	13969	19687	19687	1619482860000	canonical
28255	3NL3eb7sUsu7sp3eUmkzgNY79VdvmEFVYAmrhjjfRTcRfFwqqyjb	28253	3NKCSsojsUGDDcFGhiH4ASzwYw9X8vGy9KvXWow7axNfBcpJWKfD	1406	1393	553	12463	18974	jxCVCnp1WKrDBexVwLugSSVPsxKHtC3qRmFNE3G3Rp96DiFAfW1	13970	19688	19688	1619483040000	orphaned
28257	3NL4f8Yuy1KNyfMj6EwbTYHMo49dqgzTRLGHkeTHYmFwt9qGfLAy	28254	3NKHoSozn5GfSP6A5qC1XsBctp9dLF2VendJBSVjFv5JXV154Z7h	1402	850	553	12463	18974	jx7H3HeyFRdQb4UzmkftNwuFkJnmh8aDxYRgjvS8WV2gpUDxrqW	13971	19689	19689	1619483220000	canonical
28264	3NKy1jgpnBBUebNWN5GverytCZCPgNRmruLhTj9KFE4hja6XE7Uo	28263	3NKGUFHMF4fTx5mPWEoym1qB4PEQSV9ft418hmKShmtnUipmqUcC	1406	1393	553	12463	18974	jx8WrXccBSYHex19c359n6QrgGmFR4KmAstS8s5H8T2tPXvdzvi	13974	19692	19692	1619483760000	canonical
28269	3NKgYnDiLWJg6VW9efWoBzdia4FjSNGXeZb7QQAs9zxWRkaYJ2gU	28267	3NLdbeTQSaviTiyzpMKkXPCxuJF6Xd4JuMdK3bfG5c18pm51cUDW	1509	1194	553	12463	18974	jxtQ4dj1C29FvUrf4ZfP9o9uj6ANjDD412deAzw2FA4qoTvwheN	13976	19694	19694	1619484120000	canonical
28273	3NLPX1xxeLWoNrJQuzCrLh6pv6mrknjHmxga6mmnQXhvbJShuofv	28272	3NKW8HNR1M7fwZhNHozgS4JH4QUXb6XfvqhKBfV4yGfXdHej71wT	1542	938	553	12463	18974	jwFTo9fPgcTUbLxMC2DjcAyH9JDEAnhZrMLfiCUF72CJsU6W1Jz	13979	19697	19697	1619484660000	orphaned
28282	3NLKTdpwcmcBVxyv7xuRjaoCt7rdbYEdZc3CcpaLvqvCfFH1wtcC	28281	3NK9ABnARZhBADLmb5vqbfqDqcdkwMMaafGRmZDXJ76PXEAYrwo5	1407	1395	554	12463	18974	jwd8G53coxD7dj8aWcnPT8dB9VVJXX4DEeEkSUG8e4U5eds2cEX	13982	19700	19700	1619485200000	orphaned
28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	28283	3NLmrGqP4XfAtx7iZH1rrCUDMMxUSDSj7N3uW4EYWoW87S23gw6q	42	1115	554	12463	18974	jx3Ppt3HgBKauRbrTrZpCb4sXKsq4G2i79CdhoHDFVhrX8cqxnS	13983	19701	19701	1619485380000	canonical
28287	3NLyNDUvyGM8evUEoAbJ7rKrvUsTe9ZEDC13m6B3aTc6PGPbvEBD	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	43	944	554	12463	18974	jwaPqnhLotrBEMMpfQpcLSoL632rz91EeDPraJcHzPqdEzk2xLx	13984	19702	19702	1619485560000	orphaned
28314	3NLH1pxZpUQ36pgkwoaMpbz7CYorRDqpaYH3dZCGcfwkX4SSCYTp	28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	1578	1296	554	12463	18974	jxHJwbhWHczsbufUDMMsTSb3WEW5P5ZQg7edYJCczZHTHxVc2rP	13985	19725	19725	1619489700000	orphaned
28295	3NKAewWRxkPKGriamD7m2D77Ljfi9nm6q1ffpfbSKyxPnxUw3rQr	28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	448	1179	554	12463	18974	jxXZzc3MJjdtGbETxY6EQfoUPxZPUiciixcYcHZMWg8sfUHjCCR	13986	19704	19704	1619485920000	canonical
28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	28297	3NLXS7nds37PegEXzNCQwak38iYQUUukb4pc26ApJbQ2csMvYJbi	58	1281	554	12463	18974	jw6d2yd3dszpAkdm4F73LDNHQpbzfXtv9xrBydJjYhJNHA6P8Ra	13988	19708	19708	1619486640000	canonical
28300	3NLWadHvfEEzckf1y3j9fgPxvSGzvK6isB85QF7ZLjjZRcuoPf9w	28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	1474	963	554	12463	18974	jwjnDnX3EBe8Q38R39SAhinM1gPDvN6GdA6bVPuN842JtctBjYg	13989	19709	19709	1619486820000	orphaned
28303	3NLR1j7irUUtswt7iMBmXKi9U1hNwUDkxsCAuY3jCM2b3wRpA4HK	28302	3NKQ6ZSKaT7ER8kotqP2uVkEXMXW33Z8ektT2EuPwaTwLD9CaPSp	1419	814	554	12463	18974	jxboRxK4x2c4MNedVcehpnNskud3DgGvGsW4WSePtTZKstWTE78	13991	19712	19712	1619487360000	canonical
28308	3NKrk7pnGgo493Ma15FNPR3JgozUSwxmCmtBWHmTvT4YLc1ERkGg	28305	3NKjXNbqv9H3BU9ZeHWYR8xwrrQ2GjEmnxxyHcHgRBvHTXMUjDMb	311	1061	554	12463	18974	jwgPpoUTCsLa5prMMUJrPYkKT6ZaV7fCjPs8CNsENAQAa3pATuV	13994	19716	19716	1619488080000	canonical
28309	3NLLpSR6Gx9EyqzcSwE6LAm2fN1BHETnM7yn6PoKqru6Nvi7wXia	28308	3NKrk7pnGgo493Ma15FNPR3JgozUSwxmCmtBWHmTvT4YLc1ERkGg	1406	1393	554	12463	18974	jxnJdM8yne5i6qReJQfXLvmEmAEsYVw5BhArtsLkxgMu5FpUYwr	13995	19721	19721	1619488980000	canonical
28319	3NLAWCty2dpkvZLWk7P4Bk6mQvTXZ2mBJigKpjYqcm4dD9Kb5vJP	28318	3NKRFbk8kmdcK9bdMEh3jST4RmAU6EPVwtQ46665BqRJQeFWkoiD	1402	810	554	12463	18974	jwYoAsaKm2WEDQzZjWcocnB9gvJq82bPwt7nkf1W622XD4wwPYu	14001	19729	19729	1619490420000	canonical
28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	641	1090	555	12463	18974	jwXzsWFnkjVu4sQ1yfQ6xNP9vEjS11StrvGdx24vRipJtzxcQ9v	14006	19738	19738	1619492040000	canonical
28330	3NKNSTf9URzWL5CWp175eEaFq98oVWTzXPzF5PPvya2MdFcNt9fN	28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	1536	1313	555	12463	18974	jxytzhv2QjWgi9f9CAUkgBb5dT3wNdHy2Ht6XUHuVoi9qEbeFpv	14006	19738	19738	1619492040000	orphaned
28335	3NLk4bcDQKvDyN45AvUiREASujftiHamxipayH5sUrjBr9HeTS3s	28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	1523	955	555	12463	18974	jwNr1XGhyaANrHjetPsAxXnqHiNgrd6J896ZQGs2Q5QaEfui1cN	14007	19739	19739	1619492220000	canonical
28337	3NKamW5vQdNaRkm3VceKnZsmCxm57PG3TuFgGgV7PDz6CRMLCVKU	28335	3NLk4bcDQKvDyN45AvUiREASujftiHamxipayH5sUrjBr9HeTS3s	1617	1042	555	12463	18974	jwtqRFydUEDw4deRBxvqCXio66h5BJ8y2DL44M4RZb2uwdmWpfa	14008	19743	19743	1619492940000	canonical
28351	3NLnrxhwPRokvJbsENNs63v2BAmddcy1Ci99qgwySoPPy87ezbe3	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1590	198	555	12463	18974	jxNgZUcd3F2Uki96PX2dUzq4Wqk8eW1TCv5T1j6yvJJ6NwPN6eQ	14015	19756	19756	1619495280000	orphaned
28355	3NLbbE6yg5MKQ1f59nhaJFKiqD1Asz1vvALAprkFfXCJYy1uNa1u	28354	3NLNDmUhr5zk4QvTF1CHe8ZBcq7q2egeWswAQniWW8Spp6NjsyzW	1403	824	555	12463	18974	jwqgcTW4tLrGAHWqDE3LFqbve8mtgmhSydi73v57Z1b1GmHQJbQ	14017	19759	19759	1619495820000	canonical
28360	3NLN2UjVsTGSu2U3QkEJdJhubBzuUjZ4UsR4pyxPD3jodVkPKUTk	28358	3NLgpaJJ4WnrsuLfVAE9bKkkQg5DgTuJiCn2tPkETdWxyuudAUMq	152	1330	555	12463	18974	jx6gDnWBBwp532jBNn9MD8U7PWKc9Gk8hktaQ4xYq9DZ85CzVAZ	14020	19762	19762	1619496360000	canonical
28362	3NK7ZtzRG2rq9HqJJyJXmJhcFEoRem3mTpCrWkXJnWLLEEbLfovW	28360	3NLN2UjVsTGSu2U3QkEJdJhubBzuUjZ4UsR4pyxPD3jodVkPKUTk	1458	1077	555	12463	18974	jxJ5QHhBRibTDcmYq2kzyNJViAFqocTibYMUb9G3f9MD8zWQy6u	14021	19763	19763	1619496540000	canonical
28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	28363	3NLQSJUcVTCfyThFcxXE2187zrEmyF81xUJeD5p7vy7B67Tx8Yow	1610	1068	555	12463	18974	jxoEfdY6knjYLWqxCDG6WR9LfAg8ZswDaEt9zpkhPcJS9xqHVFt	14023	19766	19766	1619497080000	canonical
28288	3NLqdNp7tPNsSkQePGMTUGChS8iu57zreMErEu89bm5AF8aE3H6S	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1476	1371	554	12463	18974	jwqTC1riXScibgDR3dw7nRhDTHGKw8uG9p58eiitU7HHaBy8i7t	13984	19702	19702	1619485560000	canonical
28286	3NL356rxfnmKb8S4wXNurGoNSUjhJ8i38tBzq5qpmBbiTF2xLgyv	28284	3NLGFr4bmt6gQyPAjHvANfMKusFfRQJhBWPCFZezvqCVtq7YymTg	1609	1333	554	12463	18974	jwLqEUxHHcEJ8SZTZBYJsqbr7scWswKxC97XLerCxzsVnj1JnVB	13984	19702	19702	1619485560000	orphaned
28292	3NLLjeeB1GZXs6s2QPXPYLsVGtw3TYnsvf9wdET2pkoQp8V4VoFQ	28291	3NKFkvHsxjTKUWv9AeSCRJCe3Uc2DoxRCCPH7eUuhzJmq8orY87j	1668	1004	554	12463	18974	jwguPR9bUA6SRx28EPjsVy6zSE769GdADkoSGhtw28XLVCLji6u	13986	19704	19704	1619485920000	orphaned
28297	3NLXS7nds37PegEXzNCQwak38iYQUUukb4pc26ApJbQ2csMvYJbi	28295	3NKAewWRxkPKGriamD7m2D77Ljfi9nm6q1ffpfbSKyxPnxUw3rQr	1483	877	554	12463	18974	jx1gtP8zWyHrdtT1ueYTU8D1LNW2VpihXMSYqxKURF3JAPCSBQy	13987	19706	19706	1619486280000	canonical
28299	3NKZUkPEmUcbN4qhipmcwscKRTP9GjK4N6o1zrYNDomQZuT7DBHQ	28298	3NLsX299y49pPXJNGBu18CW5P7jUmF6TZXytJ6JuJvuEt5F4KZPF	1402	868	554	12463	18974	jwMzv2wWsMtiAcfzdFH7QKFkD3kEduPUs58W4vDbi7gk857jhvc	13989	19709	19709	1619486820000	canonical
28304	3NKHmcoUZ6NfLDsQWK4DJhZsif8kpDpeoWbQjm6kmZyJ4DRNAPQw	28303	3NLR1j7irUUtswt7iMBmXKi9U1hNwUDkxsCAuY3jCM2b3wRpA4HK	1451	1292	554	12463	18974	jwSsrKyywYLH2hDXFYBBsSmLGXeJRWscRfGSfXq2bD4aNz4BtvD	13992	19713	19713	1619487540000	canonical
28305	3NKjXNbqv9H3BU9ZeHWYR8xwrrQ2GjEmnxxyHcHgRBvHTXMUjDMb	28304	3NKHmcoUZ6NfLDsQWK4DJhZsif8kpDpeoWbQjm6kmZyJ4DRNAPQw	1651	1175	554	12463	18974	jwZ2WF1GVN3txb7f2g9q5XB9ojpTECsCbHHbuiFKNnLqPQmDnoW	13993	19715	19715	1619487900000	canonical
28307	3NKzaq9PBUM5CyekYgWLB5yXRrrbYSTsj3CtMRmtEV5jyxAAYsmP	28305	3NKjXNbqv9H3BU9ZeHWYR8xwrrQ2GjEmnxxyHcHgRBvHTXMUjDMb	311	1061	554	12463	18974	jxHifTTLsAhVqVpbeBLakDB8TAQoXqvKj9KeWopN5cH7hQ3r85N	13994	19716	19716	1619488080000	orphaned
28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	28312	3NLHAZyhiwYRgtxNtkGWYotfpFe8M11mF6sJKpJ5jsbzxJWRihLc	1406	1393	554	12463	18974	jxZkUovQM1tfGX4dqJerTxEyBaRn3z32AdbRj6Vb2Zz2TD1FWrw	13998	19725	19725	1619489700000	canonical
28318	3NKRFbk8kmdcK9bdMEh3jST4RmAU6EPVwtQ46665BqRJQeFWkoiD	28316	3NKmJcvihPBLcEgQ9uexDJ2ptUaYsrcmo4oJ3TRqH7Ja5DMwnbQN	1407	1395	554	12463	18974	jwRXjxZKn6h9JJey1LUvxFmUVjakwpfVr8nPfDDTjd5QvPHE11v	14000	19728	19728	1619490240000	canonical
28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	28321	3NKnr9qvWLpcWsAmheRAb1qvY3WFpw7J5rXViqFNq3v3X8AEf7Eq	1581	777	554	12463	18974	jwb7AYvXtjrTCjhpvgKtgbdEXDBtyxBDsXppk95bAs4eGB3qVkd	14003	19733	19733	1619491140000	canonical
28327	3NLdXfX3L77UXTYXi6EsL9Cg3Hp7czPaZoydGjKksGjJzHrNDXmB	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1445	924	555	12463	18974	jxSk4ftH7NNf12MiJzEgXJXZafcJKnPGPnyT3zJ1ovgXPe1yQDv	14004	19734	19734	1619491320000	canonical
28326	3NLfjrNxxTVEvUNMLfQ66oC3fqiokap6v44TrEHvZpQ3GQfcbSLm	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1501	1114	555	12463	18974	jwAqwB97WthMtzRu633YtL7KRYbs441nKj9MGjiqJt392mCxqqm	14004	19734	19734	1619491320000	orphaned
28329	3NKUbGDUgu7U82pNWVuLHynUdsJwuJbfY17Q5AW1JnQxv1aY3xq7	28327	3NLdXfX3L77UXTYXi6EsL9Cg3Hp7czPaZoydGjKksGjJzHrNDXmB	1549	1362	555	12463	18974	jweXvQGA6ibH4NufZbV15oDZzysZCZehGyyAHssP1TsSRVrkrwM	14005	19735	19735	1619491500000	orphaned
28331	3NL6kZ1f99Njsw4DcRhZ1nFKje3umW7ckWPBfoaLmqAHupYuBzV2	28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	1608	1043	555	12463	18974	jx4GSQA8nj8Y7jwzfNzBNzGWCQfn6aMatvrXFUQYMZgchdRPmM2	14006	19738	19738	1619492040000	orphaned
28334	3NLUQvojqbux2fPmQuRqxiMxhU88JxUBkF9ZMRSTvfu1yXcmaKfQ	28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	1523	955	555	12463	18974	jwjSjFqYNViTB3kUjnkGtEPdBML8vjER2qpEW9jr3uYBJf5JYMM	14007	19739	19739	1619492220000	orphaned
28338	3NKQ6kixnHmPRYL3mUCv18sANJKZfEshXyFW3jhCF9B5Jb7kzdF2	28337	3NKamW5vQdNaRkm3VceKnZsmCxm57PG3TuFgGgV7PDz6CRMLCVKU	1522	1322	555	12463	18974	jxqRRqNhtbWyEEKTRfT1shdzVXd81AXvtYQ8LQCudFp4R1Htc7p	14009	19744	19744	1619493120000	canonical
28339	3NKhQeLYxiq5NKYa2Ci1QnM7VwdEjpHrvU1zBMzo37FAPQHgZMxv	28337	3NKamW5vQdNaRkm3VceKnZsmCxm57PG3TuFgGgV7PDz6CRMLCVKU	55	278	555	12463	18974	jxtKzWvT383aPzkxM5i7cZneMgCH71k78eH3VYv9BZt3M1UgfMS	14009	19744	19744	1619493120000	orphaned
28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	28338	3NKQ6kixnHmPRYL3mUCv18sANJKZfEshXyFW3jhCF9B5Jb7kzdF2	1670	916	555	12463	18974	jwoW9qheMXveNb2F8AF3qxfm8GzQhhqroms4KG1hUcR5oEfbxim	14010	19745	19745	1619493300000	canonical
28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	1403	782	555	12463	18974	jxtMkCLiShC2JDdoPr7gJvQscBnMEBS3Jniz87ktgZ2qLWejDoT	14011	19749	19749	1619494020000	canonical
28341	3NL1MqeJULovMtcUFGmDj4jNY5uuiQS8MD3fDcy2ze6DRyESSHAF	28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	1406	1393	555	12463	18974	jwvqHk939MWZUM1JKymcsvWh7DXsym5byzWPR7bGgL8QinHM4r9	14011	19749	19749	1619494020000	orphaned
28345	3NLDMzPk9kRHHT1CtoLRHota3y2hVBgcex3As3TSigDBhCQWuJDn	28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	1617	1288	555	12463	18974	jwURZ6ggNFcUCJkume7RXvbWY83CYtfDDEgCQbzx6cH6WDD6kKK	14012	19750	19750	1619494200000	orphaned
28346	3NLrR9TbisjkC1fVD6ZaVYJWisLdQcmtqvvvvnSCo7afdEJUTfAE	28344	3NKgUtatXxqh54d1RnuULvYLxfZEjEHutAT3SxPSzXj8vhYDLcKz	1542	1058	555	12463	18974	jx6icTxpTEB2vdYiyTjCb4f3DFrhHN8UzHXKNysGUUDQuj1Xep6	14013	19753	19753	1619494740000	canonical
28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	28346	3NLrR9TbisjkC1fVD6ZaVYJWisLdQcmtqvvvvnSCo7afdEJUTfAE	1585	1000	555	12463	18974	jxgZLwfeBpGiWXTWNqM2Cwj2BdN3TnTMEf1YxEy13KHt8sTDgkm	14014	19755	19755	1619495100000	canonical
28350	3NK9EYWdbWkxehGNnmxoxYHH5U2yjCc7GsuAFK8bryfKKx6EU1DZ	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	43	1064	555	12463	18974	jxPoPMbqBi4LtCxZ3eQZ6MTDbvoPjTA6aciC8QgqRSuWZKX98Wh	14015	19756	19756	1619495280000	orphaned
28354	3NLNDmUhr5zk4QvTF1CHe8ZBcq7q2egeWswAQniWW8Spp6NjsyzW	28352	3NLMhNTaUpoFgyurQ564FUHDSXnd7dRH6pHzU6E7h9EDcuz9Fvcj	1559	1353	555	12463	18974	jwHtvjXfdXcGSTgT8Uv1xVhXZRdMnKChvzAVnqVhbihWeMjcXZ5	14016	19757	19757	1619495460000	canonical
28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	28355	3NLbbE6yg5MKQ1f59nhaJFKiqD1Asz1vvALAprkFfXCJYy1uNa1u	1668	1124	555	12463	18974	jwdS1t72B2ZGfAK42Nwa9ah5Uz2TdmHPv4jGw1mHnBfJ4QiZtGg	14018	19760	19760	1619496000000	canonical
28357	3NL69qAzPPUUQUD98fFyNH6fwzUPiCLo32xxSGPbxTCMxCKYmWQ4	28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	1675	1342	555	12463	18974	jx7yuaXxkazMjcrLJpwub9idCYyEowv2D3UUTWSAiEXDA1smRJo	14019	19761	19761	1619496180000	orphaned
28364	3NK8FAstAcT3GGcQKmztaf5BBggP9fjvuNJnmMeBqDRYe2Xo2XR8	28360	3NLN2UjVsTGSu2U3QkEJdJhubBzuUjZ4UsR4pyxPD3jodVkPKUTk	1509	1509	555	12463	18974	jxB9stTM7EnSMcM2qow71pyXy7HhHEFKcFWZKYDMDDymzL5YRbA	14021	19765	19765	1619496900000	orphaned
28321	3NKnr9qvWLpcWsAmheRAb1qvY3WFpw7J5rXViqFNq3v3X8AEf7Eq	28319	3NLAWCty2dpkvZLWk7P4Bk6mQvTXZ2mBJigKpjYqcm4dD9Kb5vJP	1547	1132	554	12463	18974	jwRshw1oBESrTC1nmrmtAr73h1HspBsr82PHGQ3K2SJKUjZSYQM	14002	19730	19730	1619490600000	canonical
28324	3NKSwFWCybWN2vb4URnCZYyPywo6FrEdiP8AjxoJkcnpGDjBuftC	28323	3NKwoxDkPPPJfJe4RKXoScmniRqiFA112smTWcccqrTNB8Dj5TPC	1451	926	555	12463	18974	jxTqSUdSqvhNmFjCzDPnusMjbFkkznyrNycdDLoPS2Ftph59ahC	14004	19734	19734	1619491320000	orphaned
28328	3NLaNmyPf12esr92W7ayCsU6dQv7ZWQYDjBErZrWD4SYxBgKJGoE	28327	3NLdXfX3L77UXTYXi6EsL9Cg3Hp7czPaZoydGjKksGjJzHrNDXmB	1467	1376	555	12463	18974	jx6w1kg5eVMRenSZqYujt33Tj2yvUEUjtv25VSDd8E2Uvg8p7FA	14005	19735	19735	1619491500000	canonical
28333	3NKoDLzgwf1DNZHY9dePPnoQiPSpEUPnaqqxmrwh9aBs5WPBToZo	28332	3NLbsJKCxGzmMbgVYq13tXzBffKCZvm3iZoYTiJLzHqsHyeFAmeX	1523	955	555	12463	18974	jwZSWPobaGFL9uckqJ4FRzX58NbWFYqf3hFcea6aGfbCBiAoThn	14007	19739	19739	1619492220000	orphaned
28336	3NLwBDkMXabgwbfXiYsaEtpWRNTutZoq2siNQvmZSC93nJqzV8UC	28335	3NLk4bcDQKvDyN45AvUiREASujftiHamxipayH5sUrjBr9HeTS3s	1509	1074	555	12463	18974	jwP92urMcPyt9VLZamooh3f33gEoRaMaCTwgooRRANaPPBmtap4	14008	19743	19743	1619492940000	orphaned
28342	3NLGRYrNATfjUAT4t4NnML1rx9NrceDeH4TNn3pVNPTuPWzKdFzC	28340	3NLrZWi9p3nq38JVTzBJz2ePEokWmD7e8PfRUQHgr679HPTTn6Fe	1609	1333	555	12463	18974	jxM4aLGpChyPhJ1Ds65e1NL4uESG2BGD3FWAakDhk9TFVpgDZ9H	14011	19749	19749	1619494020000	orphaned
28344	3NKgUtatXxqh54d1RnuULvYLxfZEjEHutAT3SxPSzXj8vhYDLcKz	28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	1627	1139	555	12463	18974	jxYnhhPfEVdCbsqUZosfVdMUHBiktmpx81mp9MpbSo81zwGNJtr	14012	19750	19750	1619494200000	canonical
28347	3NLAvattKqMcvXzbzNYG7hKSVrT99hzr53dHRzYDMWCVMnWZZ9ys	28344	3NKgUtatXxqh54d1RnuULvYLxfZEjEHutAT3SxPSzXj8vhYDLcKz	532	1303	555	12463	18974	jwqMQQ9VNfWUb6CPhJtshWj5S89c48Rp6wg2hdYqPuariieYeSB	14013	19753	19753	1619494740000	orphaned
28358	3NLgpaJJ4WnrsuLfVAE9bKkkQg5DgTuJiCn2tPkETdWxyuudAUMq	28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	632	1136	555	12463	18974	jwzxY2fPQsB1HijNQeymppjB8ADyuvmzwKFAohCKfnRKNfbCZux	14019	19761	19761	1619496180000	canonical
28359	3NKxKzcunuX2fux6GXpLMqWV1WgrPFzKj3gJ1BXjj6CuyPQBcizv	28356	3NKv92pxyNcrTto7fyXjfx3XYbkT4poW2sYYwktna3L2XHA5RkLq	1559	1107	555	12463	18974	jwUDuMgiDXLcxWwEfADMxFkewE2jB2qrRaChZMsLimYNW5sb7Bm	14019	19761	19761	1619496180000	orphaned
28361	3NKGFTQdh1cCdDJDWijbvcwgxomgsaZdN2PwDR9888z6dbMZwLxY	28358	3NLgpaJJ4WnrsuLfVAE9bKkkQg5DgTuJiCn2tPkETdWxyuudAUMq	1619	1149	555	12463	18974	jwBgarKrroNeqno41fd6JtCSjLyP8FNendZzkSE21uk745b7PrX	14020	19762	19762	1619496360000	orphaned
28363	3NLQSJUcVTCfyThFcxXE2187zrEmyF81xUJeD5p7vy7B67Tx8Yow	28362	3NK7ZtzRG2rq9HqJJyJXmJhcFEoRem3mTpCrWkXJnWLLEEbLfovW	1509	1509	555	12463	18974	jwwjjAERQNqhMMj4RGk6VdcebNZXfreYat5mziV9zJ6gm2wrEPZ	14022	19765	19765	1619496900000	canonical
28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	1589	1040	555	12463	18974	jwdQwRaVQiqP4a7WmAabGojZW5Ck8NUKtyqVd1nkbn6ijwvRCQK	14024	19767	19767	1619497260000	canonical
28368	3NKpkjmMXPNMFxQSqMnZBjJuVJptxWMpaNytXDr9cQK7tTPwY7Zo	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1571	1209	555	12463	18974	jxDGvpV16qYujHLgDs1JUa2jkmx1jqGQ7bxLVVAQjRPFR2xQfrn	14025	19768	19768	1619497440000	canonical
28369	3NLVsEzvh8j1zWjQxD55DvW9HDVZq1xwTDEf5L9U3VomBgyU2r8X	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1501	1360	555	12463	18974	jwBU8gweEtqXBKGtuQgsombp1D9SQTaq8HrLLF4YnzCfYXMkf6v	14025	19768	19768	1619497440000	orphaned
28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	28368	3NKpkjmMXPNMFxQSqMnZBjJuVJptxWMpaNytXDr9cQK7tTPwY7Zo	1406	1393	555	12463	18974	jwiQYjdQqziXGcpsrWpHAHhSS92mV7Fx38Uthpv7x8e4CagTBEC	14026	19769	19769	1619497620000	canonical
28373	3NKmKyQYo8oJ2LEdv6vDerdxNKzKmrbR636LTCjbmbUikumwQajC	28368	3NKpkjmMXPNMFxQSqMnZBjJuVJptxWMpaNytXDr9cQK7tTPwY7Zo	1633	1390	555	12463	18974	jx9G2Dn7y7vG44aQ6sP8MEr7BMoAtm6USgLZnL1AzD4ok9gNxN5	14026	19769	19769	1619497620000	orphaned
28375	3NKUt2zsx2nrE97Mo9jX7i9ReoH7yd4k8rYR6z5MDQ3HwqdfMgU3	28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	1403	31	555	12463	18974	jwLpAHdZHEexqQcqXPZjs8ZL7WkXhPK6hTub2iUeSUdxtSqrsx2	14027	19770	19770	1619497800000	canonical
28376	3NKVvqwmEtfrFi8svc1ehfggriWdTegGYG46Aeht579D6xCYrShL	28372	3NL7Ewjbq4rzkwSFv8oNJ54DLpUTNQikjWBxihpmFt5j2tpmbmGj	484	1319	555	12463	18974	jxk7K3SVuWDjPekPH4JyQ5EY5BRUUPBQbKznoRT4nnsiSfaqiDF	14027	19770	19770	1619497800000	orphaned
28379	3NL2F5vDkfX5nDr3ZNgjnxTkSjhbLv1Vc9KFk1YZHc9ki7XJjk8X	28375	3NKUt2zsx2nrE97Mo9jX7i9ReoH7yd4k8rYR6z5MDQ3HwqdfMgU3	1419	814	556	12463	18974	jxTGWwR7HhMmdCSeVjPNi2SXXF31TjgLdX6hnFKmDxMw9y3AFbD	14028	19771	19771	1619497980000	canonical
28381	3NKv8Lvc9GkfcbU4ELj4dwczAJaxkHphdKKTN2qQxiuK5W6k1RTe	28379	3NL2F5vDkfX5nDr3ZNgjnxTkSjhbLv1Vc9KFk1YZHc9ki7XJjk8X	1506	598	556	12463	18974	jwvT1kfi1opTfCBzZPQ7qWCXa7kjRSrhDEJtWJmJXhaUyZiqG6H	14029	19772	19772	1619498160000	canonical
28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	28382	3NLW8C1Bc54TxLw6wDBTPXhs23tugYu6uoxEzjnRebaHKXBnkrG6	1587	1111	556	12463	18974	jwAPASgtzL4NHdKf39nJLQZ4sNh1mSiuHeQNwwR6NekkvosRbmy	14031	19774	19774	1619498520000	canonical
28386	3NLRc7MQ2ToM6eGFXFPi6Veiw2XwCq5dHKXhz5DoLkFKf57XkuSn	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	1406	1393	556	12463	18974	jxQEhQb8QMEws8FjyZdho8wQNzy3iMaJTSdg4gBxjoYKVmPJMsd	14032	19775	19775	1619498700000	orphaned
28388	3NLssJZifJ7NzYaGUdfET5jSZVhTokU6dywdvyCcaLsg79JAyYyS	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1503	1277	556	12463	18974	jwxpNqvtq8CLi5xXKBtq82n9qBd2s6HvZEbGE1LysFAqPnxWr26	14033	19776	19776	1619498880000	canonical
28390	3NK9tQMB126Cj3yNKQSJjFtBsztnnUjiXJfEQbLs7f2F61QJ8sMv	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1593	980	556	12463	18974	jx7AturpJxmTXZYR3Br5cjDpEjxxzN24ds8TuJRYUqEihLfiTvw	14033	19776	19776	1619498880000	orphaned
28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	28388	3NLssJZifJ7NzYaGUdfET5jSZVhTokU6dywdvyCcaLsg79JAyYyS	1407	1395	556	12463	18974	jwLhSMU9q5kb7b7vHVBm8qvNg9qAshRMF5FHc5pwgzCRBMyJkeA	14034	19777	19777	1619499060000	canonical
28399	3NKdRjLE3HAoGzdt8gE2Nk1c9pK4BdVFdoZZkgyDosrcKShLwC1B	28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	1407	1395	556	12463	18974	jx7cVm2x1ZvVmw4bjF46woShQ85LriWqFrGebBEJGcDWjzLApKu	14037	19780	19780	1619499600000	orphaned
28404	3NKUgVVaScH9cAK9uUrvCc25CKSBUV5FTi7Sk35w3G84FjBFH5wp	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1407	1395	556	12463	18974	jwmtpMQrTHnCYVJqKEYx7rkSVzZcZAfS9F4zXDMV9KG36eSaMBs	14039	19783	19783	1619500140000	orphaned
28406	3NLRAApmycER9rMKGpvkbo9e6vj1ch2kycDafCoa5RQNtncDeP6H	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1541	1298	556	12463	18974	jxowiJQCZqDffL3CytpSCcAS8qa8uJr1hvuoA855r3Ug8VArtc1	14039	19783	19783	1619500140000	orphaned
28367	3NKideQLmg53wDtYomDWzNa9VPwGSKojiV5wYYLuxY43jSeFrEMb	28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	1593	1100	555	12463	18974	jx14T9wzYk1U7qDcWrM6kdKmo3YfryPUEUmYasxorzpgkBeHA4V	14024	19767	19767	1619497260000	orphaned
28370	3NLCzgaRVvbEbarP47bWqTziM1KueA63Qu2FUsXjF7mao9wZTGns	28366	3NKqBuNeSEMGttJwBo3VACZoVQXnVBsJ8gxKMZxaj6upB5sJGyfq	1671	1119	555	12463	18974	jwFcSEb5Kx3gZ1WDvpCMMwar8zBu3vwgRS4v1BUk9gnzQveCxCg	14025	19768	19768	1619497440000	orphaned
28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	1440	1011	556	12463	18974	jx7vQRvxjRAUaznjk9XAuv3n7np1aQ54EiNZ7eTgYk9FpJTLwhJ	14032	19775	19775	1619498700000	canonical
28387	3NLpFeSKD7ctv5RtDKo1aQMgRuTRRotSq2CfJCUu1qik1zobxuL8	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	1440	1011	556	12463	18974	jw9f1joSRN8vKV3pfJHW8t7QTncquyxFNhjToxqt88zvJbPcSvW	14032	19775	19775	1619498700000	orphaned
28391	3NKN3Y9qYNk6nYviq5ka1ujxuPrDKoL9bvQ8TA45MmJmvJJjcTGe	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1506	1373	556	12463	18974	jxBuXJe1EAc5wGtttr9qvEHivrrcs9s4aGNT8qWtaxEjTH8KVoV	14033	19776	19776	1619498880000	orphaned
28395	3NL3jekfbwVusZ85n7xQGxScMwAkkwx7eEsf4JcpTL4UBosJFUon	28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	532	1177	556	12463	18974	jx4xgX1uuaQbao4e23pKyYcz3ehQHH31uwPsstoEyn2sXGCWEPm	14035	19778	19778	1619499240000	canonical
28400	3NKgTJfqJmyU4PctDHpWoEUPr2XSxitneamrwLNYstShgwQAkwPJ	28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	1542	1178	556	12463	18974	jxSqEAogNGaM9edECkiUdhYPdyea2J7LS2imkUpnLXSUanSuRHs	14037	19780	19780	1619499600000	canonical
28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	28400	3NKgTJfqJmyU4PctDHpWoEUPr2XSxitneamrwLNYstShgwQAkwPJ	1403	782	556	12463	18974	jwgNmvfupQJK7dGjrt3jBBZWWN7KdV7bAT7Yay2KtB5RYCAGmb2	14038	19782	19782	1619499960000	canonical
28405	3NLoLKrKU16LJhfw3Fpb2neYcTmdahrX47Q6isqMszqXVM1FjLms	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1542	1696	556	12463	18974	jxtaVPzTtWSHY8rKpqbQ1XEJzfC8rCP9iM7GGcfnZ7aH7doZwf8	14039	19783	19783	1619500140000	orphaned
28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	298	357	556	12463	18974	jwizybFMqCQxvYcX1zauFS49SLQgsM91iCSRpfDFfSsbBVXwzhg	14040	19784	19784	1619500320000	canonical
28409	3NL8bN9JVNYf1Y6taktnZ5yZxTRgrejJqvvtqdMv17gNJcewYVo2	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	1406	1393	556	12463	18974	jwjsucfEL4prxJLmmGBKSRwYsyUWVvU5EZz9jhowMMc4pjC53CB	14040	19784	19784	1619500320000	orphaned
28412	3NLqUaZUvbkyKofNBLu5TchHkT6eAA21BfhNhkDXPwqjpobSsr8J	28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	1509	1194	556	12463	18974	jxL6byXjzayb6D4bt4yXhEY5ihQGPvK7ck1jesFJGSMFJTgG7uo	14041	19785	19785	1619500500000	orphaned
28415	3NKXp722Mw3sy8Lfw9A3FtaZ3u2qtKoCUxaMPggpPuLw7Q8EmPTU	28413	3NKozPVSP1Ebki5YvNndxs618aTfDP54PhsyM2RKKw5xtP7Mpov8	42	1361	556	12463	18974	jxHofEhhgfEtrhKtPCSobURCSYcKRV4jDkoXDQ2TuK79bQ8ruop	14042	19787	19787	1619500860000	canonical
28417	3NKjfcwPPJVtf7ZjQBo72zfZXJKhSo7UpvtsHweJM9BsrQLL71Af	28416	3NKVvMzj6x1yBK36oCXGoAUPjNsP2NPqAG5x2LhJFtChJNa2PMgK	519	536	556	12463	18974	jwgpfAA2Lskfx715DsCvTLBeibTYTa2yMWSkJ4PcmcRP4xr2XXr	14044	19789	19789	1619501220000	canonical
28418	3NLVDU16SUbsk2z9vtDP1oMqx3XXrgH6gKsw8Sw7PPcxuP6q6W4F	28417	3NKjfcwPPJVtf7ZjQBo72zfZXJKhSo7UpvtsHweJM9BsrQLL71Af	1559	1353	556	12463	18974	jxBy1DcR9gpCD3qxgtgRhi4Ru8URCHWP7oEcWxKXRxhntb89juH	14045	19791	19791	1619501580000	canonical
28420	3NKMMH2e3oNc41qXJSrP4YsD1vfYLyUzLoWjvm8z8byAKVSB6BTs	28418	3NLVDU16SUbsk2z9vtDP1oMqx3XXrgH6gKsw8Sw7PPcxuP6q6W4F	1559	1353	556	12463	18974	jxEG7bZCzfTpvorJxHhJ2tP7WTiP6UUmW9sc986rXwUzWkwSMWT	14046	19793	19793	1619501940000	orphaned
28421	3NLtZ94HhCHjxP6eUZUj7KpkL8WoF2z1nsBC8ontnoaBvdQBDKiM	28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	1654	1340	556	12463	18974	jwTep8jx3sEtxodgncCG8bG6c6on6BisjRYguSgvyLN73XRBG1u	14047	19794	19794	1619502120000	orphaned
28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	28422	3NLrVyRWArZmwBhhbF86x5LKxQULK4nQpC3jFvCd2EWm6Tbn2YkD	1654	1340	556	12463	18974	jwss1DrRrRfA78NphC7k7bR7NrYYxvhVfbxmZjefLbqofGhtJ7a	14048	19801	19801	1619503380000	canonical
28425	3NL5yofKp4nP91aGuJSoLtjhaM13k2vyK4HMTBfuZBvUBqnLDWWQ	28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	1483	894	556	12463	18974	jw8LAhrcFjMhCeVUWAanKxYw7QJgDVTCYczvoMccSwkSv2xHTES	14049	19802	19802	1619503560000	canonical
28429	3NLYwtLWn4Y2MnNi7jito3Y4CCSe3UAdVxkmQ9YQ3tFVfnuF9RL3	28425	3NL5yofKp4nP91aGuJSoLtjhaM13k2vyK4HMTBfuZBvUBqnLDWWQ	1637	816	556	12463	18974	jwJkdLm1HPaVxWX8bbZ1rXpnMoVih9niyANjCfZVVc9uE23QJF8	14050	19804	19804	1619503920000	canonical
28432	3NLaQyVc2citK5fFpyDPpExHRrv4s3sN3Jp42tkpLxLnJn7Lcus4	28431	3NL1fZk4CVJ5VZZgsNZmQaGyBQjJp3oM57aPshLvp51Xy395Zv74	1647	1302	556	12463	18974	jwMQEqrqhtqKusUoNVpahnorYDDuGvfSRHdi5CkNCSrnci15cvw	14052	19806	19806	1619504280000	canonical
28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	28432	3NLaQyVc2citK5fFpyDPpExHRrv4s3sN3Jp42tkpLxLnJn7Lcus4	1407	1395	557	12463	18974	jxxZipEti46p3fKXTydUrxyzCBz7LmSwsvvonM95Qoof98SyY7Y	14053	19809	19809	1619504820000	canonical
28435	3NK3ZtwCGHrio9f6a9eAPwU1FbCde3hYc1KPcy4Qt2XjvYkdWLCg	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1447	1099	557	12463	18974	jwemz52G6Mmn77uj2pS43U9VuWPB7fseRbqmXBHewEercgCk1Xw	14054	19810	19810	1619505000000	canonical
28437	3NK4iJNvVbfKkJ9SUfcyytHWGmzMHf5FQUxapikmV8t6GPFUPY2r	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1601	1388	557	12463	18974	jxbAiYjdQNdj21wSNjXf9qATgnk451aKYwqecNMhmRzoe1xsrBg	14054	19810	19810	1619505000000	orphaned
28441	3NKQvTW3WfV3gZCbGy5qzho3erzekMUEvDbJwU3zf5bEfPpRvgCV	28440	3NLs49vM6f5pDCXQx9xnz2UiVhtzwwbw4qrwQHpq2UVm1uwHPDqt	1599	1287	557	12463	18974	jy37J5rPusXHtAxpnDWZNnRCpNirQbg18CZoNw8WAHGrrS6ZyrL	14056	19812	19812	1619505360000	canonical
28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	28443	3NLvf1fGJSRAy1Pvdb7RVrf2EEwZF6a7SNY6XhSseT99or5ddmup	1656	1343	557	12463	18974	jxAGxshPQpCgaPJvwLNn4BYGZ2tBBRERcwKqfFgp1N45fGBR1j3	14058	19815	19815	1619505900000	canonical
28446	3NL1jNYwTvzfgpdT4SBUpY5TFx2aiqdxKWB4puVsNFURsKkGLbaW	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1541	1298	557	12463	18974	jxh6Y3WPvgT5yV42QrhWM8uYU5nWSPeAu1R87rKLZcYBZUyriFV	14059	19817	19817	1619506260000	orphaned
28447	3NL1b4pviyPmQoD4DHetiRqvmYqqg2HSogGTvpkWtXiufAYxrm7P	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1406	1393	557	12463	18974	jy3CA5d72zniZJFFxx8R4NDMu1pb9EudxzqvUYYzFtHBKLH1N5E	14059	19817	19817	1619506260000	orphaned
28451	3NKxMR2roYBARWFisY8zXscoNHTBbBf63msHrUuPabArMdgdxR2p	28449	3NKPZTs6kDUVQqYJT166SW7r4fC5ux3PSCpB3r9MpKuahw72TjPe	1406	1393	557	12463	18974	jxhHaUuHJ5rfh7SNiisthYpbgBiJg5v8uDkKeXt2DKdXPahWib5	14060	19818	19818	1619506440000	canonical
28378	3NLF71uZyeNZKtK3XFbZJEFb3kfdsJFPz5Lt5sCooLwV2u4EXpcN	28375	3NKUt2zsx2nrE97Mo9jX7i9ReoH7yd4k8rYR6z5MDQ3HwqdfMgU3	1508	1387	556	12463	18974	jx2r6mNo64FF7txtUTfD3KMH1v5xxxwbgFQN8DwypiSxmo62vSL	14028	19771	19771	1619497980000	orphaned
28380	3NLXyuFYbQfZMNhKPM1dijXAknqv6yGLtQMboz3ChAkNbe5mEusQ	28379	3NL2F5vDkfX5nDr3ZNgjnxTkSjhbLv1Vc9KFk1YZHc9ki7XJjk8X	1506	598	556	12463	18974	jxY1uTwMmfNm2E6BdiveXzG4gujX6THJZmStDo7SuDoN2L3zpdu	14029	19772	19772	1619498160000	orphaned
28382	3NLW8C1Bc54TxLw6wDBTPXhs23tugYu6uoxEzjnRebaHKXBnkrG6	28381	3NKv8Lvc9GkfcbU4ELj4dwczAJaxkHphdKKTN2qQxiuK5W6k1RTe	576	1109	556	12463	18974	jx97eQn69fTKz4sQXt5rNPXs4E1kHGwPZrb7CF8NCvJMJmRF5EP	14030	19773	19773	1619498340000	canonical
28385	3NKvpGCuFfrgvY1y4ofNMhoHMcPWwyDrueuhLJqpsdN8oFDywLdE	28383	3NLHmmsrtnSotko53eYSosFxadr6NPkB3ng3WJY6g4p5Eo5dY7Qt	623	623	556	12463	18974	jxxL9nYr2F8AqGPVbyfAPkW1aZ1JwJiRjqKJwoybnn8c8xBi962	14032	19775	19775	1619498700000	orphaned
28393	3NKiHzS1LSzLvxgC4hmJmKwMgyFZRQoaRf5FaJzvBYDa7eMKrR75	28384	3NLMG5291QhZFEis28izFqNZk2booLjbEMiurc7U8b3uAkDoENzh	1506	1373	556	12463	18974	jwbn3fWhd1R4n5F9HREaoS9tnJ3dvpm5sbGYD1EfSHWrAUW8wky	14033	19776	19776	1619498880000	orphaned
28396	3NKpRFaiXUnbeePG2CvmFDC5Nb9QZDopC1K1RHvYXeZVJX2QCkGH	28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	1617	1162	556	12463	18974	jxzj3LVwH2iTYVxVAnLTxGJuuczjE1PHcpzWGXZmbpTtBLYVpbg	14035	19778	19778	1619499240000	orphaned
28407	3NKXuqUSvrhY88A8oFthtB4FWcghqzcq9GkK1T3rgZWUehqh7UaG	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1541	1298	556	12463	18974	jxFDXBDumDYsRfkxBEJbN3rRPhciHGyYnBEhx9BfNMPKf4iPzeq	14039	19783	19783	1619500140000	orphaned
28410	3NLL3ug76w9MUBqRGvm4EhVf6ckHSbtZwn2cedevXurVK1eGq9ei	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	1403	812	556	12463	18974	jxTfGgAWvbZmxUHjwVVw8fUgmkdqdr129EA2RaXs2vWEs7b3Jg5	14040	19784	19784	1619500320000	orphaned
28416	3NKVvMzj6x1yBK36oCXGoAUPjNsP2NPqAG5x2LhJFtChJNa2PMgK	28415	3NKXp722Mw3sy8Lfw9A3FtaZ3u2qtKoCUxaMPggpPuLw7Q8EmPTU	1609	1087	556	12463	18974	jxrppigg4n4QJ8ayeSYALwFfqZKzodVVmAmccDND1GJB5QF6s6M	14043	19788	19788	1619501040000	canonical
28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	28418	3NLVDU16SUbsk2z9vtDP1oMqx3XXrgH6gKsw8Sw7PPcxuP6q6W4F	1672	1285	556	12463	18974	jwx1gimi9LNVnwfvsGJWKGbZsBY1gm2FXF7PHPPntPcYJTUx9PC	14046	19793	19793	1619501940000	canonical
28426	3NKViXmKsHR9LMft16bhigBSFjJGJGvnZnUBEA7fMi5JBmxW1tXv	28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	44	1199	556	12463	18974	jwmqb8mnjQj2fq16doNRt4BRy75nmTGgix4Pj9tskH3rQnRc56J	14049	19802	19802	1619503560000	orphaned
28430	3NLWFNvxsNuwyXNvjZV9jXUjztdbnCYAVEedM4qgHYLzY9TcErUG	28429	3NLYwtLWn4Y2MnNi7jito3Y4CCSe3UAdVxkmQ9YQ3tFVfnuF9RL3	1406	1393	556	12463	18974	jwxaqN5KkPaqNSBwhxprmN22Y3jPrgTqjTJSF8tnVbv3zcGNfBB	14051	19805	19805	1619504100000	orphaned
28442	3NKjNuZsB62U8RE4mJC7yUzVtZUS7uv8A6mLawThi1Snf7jVYN2t	28441	3NKQvTW3WfV3gZCbGy5qzho3erzekMUEvDbJwU3zf5bEfPpRvgCV	1460	595	557	12463	18974	jwpLPzw6mg6tvxhdGtHe3HKGvbuShFw92TVP94fQghE1wJhuXup	14057	19813	19813	1619505540000	orphaned
28449	3NKPZTs6kDUVQqYJT166SW7r4fC5ux3PSCpB3r9MpKuahw72TjPe	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1541	1298	557	12463	18974	jwmQpALEbpEkR2w9CnR3ihjksHzN8EuyGvp2t2Dsj1tAUPy9AEG	14059	19817	19817	1619506260000	canonical
28454	3NLCt6mfHbPmdT7JAJcAWTuNrHsYNCPPSMR4Ezz9tiQaXa4QDLLm	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1668	1370	557	12463	18974	jwEw8jXePfkdrc8gNUMAQZJ7N4ycc9xmHdGsMSnnDzB7AkACJye	14062	19822	19822	1619507160000	canonical
28455	3NKyG3vb4LrHcpzx7NGXf656UQXgogSFAsajUqfNY8R8XTHfMTWF	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1407	1395	557	12463	18974	jwT2QbFbUVEBKpw3KYyzGHdQauNSaHhFMnD7toEXvzCFrJh2Df1	14062	19822	19822	1619507160000	orphaned
28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	28454	3NLCt6mfHbPmdT7JAJcAWTuNrHsYNCPPSMR4Ezz9tiQaXa4QDLLm	1448	1185	557	12463	18974	jweQvmYDcnwbeiirZ5oN6SxXZDexaehdp5WnugXCqrn8EN3qotX	14063	19823	19823	1619507340000	canonical
28459	3NKapqAbQhfrJX57V2qDobsmirt5rdJciuHhTqBLFZncN5dgzUfZ	28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	1642	1241	557	12463	18974	jw9bRvwWZj5ppjEnQHSheQ5EPCPuDzWRzk8mcibyAkoLm1uMNw3	14064	19824	19824	1619507520000	orphaned
28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	28461	3NLfj1h9woAvwwtvb6t1J7fwogeddHAPtfKApZaz8UEbfXqq5RLg	1529	950	557	12463	18974	jxyzk4x9XkF5hagS3D5bWnj2uoGkKyJWhHv9z5HjqK3dSn48bXn	14065	19825	19825	1619507700000	canonical
28463	3NL7QixsqBvu8pwu873NRZJ9rU5JALb5LbzjkHaaEKVPpQkEirHx	28461	3NLfj1h9woAvwwtvb6t1J7fwogeddHAPtfKApZaz8UEbfXqq5RLg	1529	950	557	12463	18974	jwf74vyiUv7V8eV9QAqv54N7Uh1zpkJfjrhwgktjaRtCV9g7GFD	14065	19825	19825	1619507700000	orphaned
28466	3NKx2nazzqF44r4a31Srz2zew9bBXXuma7H6zi2bDVuRi7FoGmLu	28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	1407	1395	557	12463	18974	jwSocaYEMs6dPPYrDytet73GNVDbXv4cZBiBfH26PAGuXoGjKgw	14066	19826	19826	1619507880000	orphaned
28467	3NL5VHk5mFMJMriMqdWDQL5TSa8rjNSfzuqabnYRMDP7uaYfPmiP	28465	3NLZCD22vZ1QXTcDUq7ej4WwDt4hb9Nzg6sNw9HDqpNaHv6nYbQf	1403	786	557	12463	18974	jxVtW1zau94CS9EAa4WoUZsBenE4qPAg1Bn4MRSHywWNantHRHk	14067	19827	19827	1619508060000	canonical
28469	3NLYYWwn2EoXqGjc9rvoPyX2vCoVYKXhXX6vC3zKaznWqgjCd2mR	28467	3NL5VHk5mFMJMriMqdWDQL5TSa8rjNSfzuqabnYRMDP7uaYfPmiP	1402	852	557	12463	18974	jxd5a29Txun8o3ajnimSecc3fPJdr2UdJEcViZsqrWpys28AEsJ	14068	19829	19829	1619508420000	orphaned
28471	3NKAS1taJG8crrm2itVJbEW586UpnkjKc7itTzwJ6HrYCxEaHErQ	28470	3NLDnRhJL4DSeVMVff3cZ4in2qDWCU9LheS1EWWtAkrazX6vfA5h	1406	1393	557	12463	18974	jxeHVJQGDRPCqTwzEfoX3VzK9qvDWJA4G693fUdqEYn7wVan1tF	14069	19831	19831	1619508780000	canonical
28472	3NLrSpS1GK6XAjfQBFM6dRaBhzH43YkP45UG48KKYoBRTbCNSqV6	28471	3NKAS1taJG8crrm2itVJbEW586UpnkjKc7itTzwJ6HrYCxEaHErQ	1516	1294	557	12463	18974	jw7gEv2yGrsT2PNkiMn7kLMyWrmge3LuKcaJUBTcXfQraQ6E1TG	14070	19832	19832	1619508960000	canonical
28474	3NKjKtvJrBMx9AWQrMq3Z4yqPwerA9zh2MxGNaoPu6bnwbAcn8UV	28473	3NL8y6SYobShNCkKP5GNKDcyfPJ72fpXHkiYKgy56WhGZeBQugKB	1590	1300	557	12463	18974	jwectwUsP4HV4Zbn8nqKTuxvKjQY2ZjVwXT3g4Prg1qR2SMJvuk	14072	19834	19834	1619509320000	canonical
28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	28475	3NKf55UQteR9rRnH2PUGrJ2MZ8cbWMxxSVmwptbXr5s9QMSS8x1e	1673	1368	557	12463	18974	jx9B4bPkrk7dBiN7LxAWJA2yGKt5g77Zcp5mbCzPF85rCbB8Ywn	14074	19836	19836	1619509680000	canonical
28482	3NLHM9qiE5wLSryL6TTbhEFV44a9SCattpYPmyiTSKYQ6JS11E3z	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	369	1312	557	12463	18974	jxaWRWz29w6gDbPv5a5d8edH6UfmsdsH77HPwcrisyenRHGTAcW	14076	19838	19838	1619510040000	orphaned
28484	3NLi8cxsUEBL7gp99ZKwavMwhTdo1WdJ7KCFsoGqEq5kukfGx6Ei	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	1403	824	557	12463	18974	jx5RH755xuew87T1Rep1LPLUioeSXs9mgNeD6urZw5Gju24FjBb	14076	19838	19838	1619510040000	orphaned
28423	3NLLGeUBZiVgfvQinziJ6ikqRJ2yrhvU51hpJGX5PPoUvtCEHbC4	28348	3NLEmeiGQJ22DUFJGU6bZQ8d9dwYZmioZSiXSPixLbkW41np3sL3	1553	776	549	12463	18974	jwMaaggaQ1mHcSpZDzXRH9Dp4326A9kccVLtrWc81uUxKWbpqFK	13880	19798	19798	1619502840000	orphaned
28414	3NLeVMnTKyq984yj6bJ6mowQHWJTGNEQGJnCmR7C2DMw8uyLLzij	28364	3NK8FAstAcT3GGcQKmztaf5BBggP9fjvuNJnmMeBqDRYe2Xo2XR8	1509	1194	555	12463	18974	jwyXjUdzBok8he2ekeDbT3GajUgc72yXj7w2YB86gKJUzpN2a9x	14022	19785	19785	1619500500000	orphaned
28397	3NKV3BxmvW7ntQKzjtTxm4hNef3pFiFu5s1BjUzU7SZdM4fJMnSr	28394	3NKVkrmyL9Tfb2EGw8tGWkoiie6ct9J5EeFAynVB3Ees4b4ukDyi	1631	794	556	12463	18974	jwz6ijEnUygd7ynVqkFFAKizhhZiQCWYcDnrqG6oRqGMSc85mHs	14035	19778	19778	1619499240000	orphaned
28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	28395	3NL3jekfbwVusZ85n7xQGxScMwAkkwx7eEsf4JcpTL4UBosJFUon	1406	1393	556	12463	18974	jw8Kg8oohoRPcYm8Q9orwN123mzDatgVtTvpCUHck7mtiLqYSUV	14036	19779	19779	1619499420000	canonical
28401	3NLd5Kb12g7gT8WGuM8iif3ap4C4N33X2oUiUJrRFsZ4CRgtixr7	28400	3NKgTJfqJmyU4PctDHpWoEUPr2XSxitneamrwLNYstShgwQAkwPJ	1406	1393	556	12463	18974	jwpFydkfvVc9XVt7QgDNh1kNY1BGL8vwnDZCRLC3X5NjBW9quJ9	14038	19782	19782	1619499960000	orphaned
28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	28402	3NL6GU7bvAVHXou5EpVHnZ5bi1LVVPwXjyDBF6t3emSNp38KeTzf	1406	1393	556	12463	18974	jx4b3HaoYwKSzuV2d8UTunRWMqPunf4ffMGYZjxqUtNHJndWUQw	14039	19783	19783	1619500140000	canonical
28411	3NKkmk7ZQ7eMpEYPHD2Cea9jPXSh1gyyHypGEQSGcDHbGouQUQ7N	28403	3NKkR8VELSNDi1eDKbCosBKwmRe2CNGyGvDRxsyVUSPPYHdeHhQc	1608	1289	556	12463	18974	jxBhiUwFMtBqwjmxTydTUZ8vN73Sx3KNofKPFg6BetKk8NoS4FE	14040	19784	19784	1619500320000	orphaned
28428	3NLeqfJTSyz4Xa1mxrcFaqfd8p9wTTfuRsfwe82VvPYTiNZvZcMx	28408	3NLME3K3TTfNm5Kjgw4vrRiWHAuAH6x7R3XhxGV9fuDoa7B3YzJg	1483	894	556	12463	18974	jwSjs5JtvvYC29BiDSFeo2bBWVgyNx943G9LM1ZcQbNKjXQ7tci	14041	19802	19802	1619503560000	orphaned
28427	3NKQ1mK6xXzmtpRD7DLHoAitCXUsXjSnbAR3YCxzkVQC8FHdJP35	28424	3NKQU5jzzYYDHgYMn4qbRvpX2uT3MwssqcyRsphvqgSAjoBrmo5P	1637	816	556	12463	18974	jx7ZhVXgtgHUhRw2jaK9M24y52dyNEaMJvDoS4DR6cwbSCyRL4Q	14049	19802	19802	1619503560000	orphaned
28431	3NL1fZk4CVJ5VZZgsNZmQaGyBQjJp3oM57aPshLvp51Xy395Zv74	28429	3NLYwtLWn4Y2MnNi7jito3Y4CCSe3UAdVxkmQ9YQ3tFVfnuF9RL3	1631	794	556	12463	18974	jwpNfHtcnbHf7d2xvfi7u1zWVPzMi5wJmRT8J9yLgbHLVUbRugw	14051	19805	19805	1619504100000	canonical
28433	3NKow8imXjFJtkECZMrU23GyHLWUXWMPmJmCjhvWCYWqdRaoMLwN	28431	3NL1fZk4CVJ5VZZgsNZmQaGyBQjJp3oM57aPshLvp51Xy395Zv74	1647	1302	556	12463	18974	jwMQEqrqhtqKusUoNVpahnorYDDuGvfSRHdi5CkNCSrnci15cvw	14052	19806	19806	1619504280000	orphaned
28438	3NLL1FDCgUKJZVdD332esrarXywuLg3fS9uzSbnTcvSN1ssArZTH	28434	3NKA7RB4gHkLn64mkzJi7daJy6z7dDeTDZc5jGCy7HeYaPCNk1pA	1651	462	557	12463	18974	jxWLdweWDtXDzYVQ5AJS1Mn5AN49RpvwqxHRgnXDFbSRxHJSqs2	14054	19810	19810	1619505000000	orphaned
28440	3NLs49vM6f5pDCXQx9xnz2UiVhtzwwbw4qrwQHpq2UVm1uwHPDqt	28435	3NK3ZtwCGHrio9f6a9eAPwU1FbCde3hYc1KPcy4Qt2XjvYkdWLCg	42	995	557	12463	18974	jxzaqsnTZFDZ693d39Wz2oi3zi7Ksuv5sc1a248YMeEvjL1nMVt	14055	19811	19811	1619505180000	canonical
28443	3NLvf1fGJSRAy1Pvdb7RVrf2EEwZF6a7SNY6XhSseT99or5ddmup	28441	3NKQvTW3WfV3gZCbGy5qzho3erzekMUEvDbJwU3zf5bEfPpRvgCV	1406	1393	557	12463	18974	jxGyEzCsUwFtekg8vyfMV7hdmxMHBfYBZbMuTfVg5X15h3RFF63	14057	19813	19813	1619505540000	canonical
28445	3NKQnjaPjVGHDVxRdrnnduR5Pzx57ok1mFfPwsYNKHLovTfpTRzF	28443	3NLvf1fGJSRAy1Pvdb7RVrf2EEwZF6a7SNY6XhSseT99or5ddmup	1559	1227	557	12463	18974	jwgVFBWdBLS2FvX1NNpQAf72Vs7xoHy5dKzuXr24GSSJJbGp8cf	14058	19815	19815	1619505900000	orphaned
28448	3NKRsiJGR1b8sibJnyw65W969QkJ9NCTJVdh2pBGUZLqHQrVwUes	28444	3NLk9wknAAjhkAtKSxgr6q4DEUeRvSi256EFybcBQ9hofCqFxC4b	1541	1298	557	12463	18974	jwkDVHGZ3QysRaMGgM8JJMsvppuHszeFFpyBLFasahD9f8pfL6o	14059	19817	19817	1619506260000	orphaned
28450	3NL9TNFqDioQLpQx4PvLc7Z6byoxdZhAY5ZnjxerV17qYJFqpCqJ	28449	3NKPZTs6kDUVQqYJT166SW7r4fC5ux3PSCpB3r9MpKuahw72TjPe	1507	1034	557	12463	18974	jxMj4uPKQXSQnipwtYFoTc6YH6B6PHcWfMBSxVp23bs6bRj8Cie	14060	19818	19818	1619506440000	orphaned
28456	3NKge5YXvBoKsykhxwmEifKNMoGf9xzWXoJ5gciwZNVhM75obG6J	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1555	1347	557	12463	18974	jxijTsHjA2UCHmrHJaDDf2L5SRsUBghSn26QiSTJ2zJphxLkJM8	14062	19822	19822	1619507160000	orphaned
28464	3NLH5muZSirhUg7AA7KdfACVyo8is658CLZs9B2Mjkih1ZGKgdnp	28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	1460	333	557	12463	18974	jxLdhbqYGRR7mgXzMXmcfj9Mj5cwxmQVePB3a1uELphtGjGnJm7	14066	19826	19826	1619507880000	orphaned
28475	3NKf55UQteR9rRnH2PUGrJ2MZ8cbWMxxSVmwptbXr5s9QMSS8x1e	28474	3NKjKtvJrBMx9AWQrMq3Z4yqPwerA9zh2MxGNaoPu6bnwbAcn8UV	1508	1141	557	12463	18974	jxo6VqoGyd1YimRax34uGu1jSJhY1jFiK1VKqs1SNfGaqJeQhBr	14073	19835	19835	1619509500000	canonical
28488	3NLZckrxzTVXsSY2JtykhJrbiQPKv7mKrwrXZT11GNZmayCieP82	28485	3NKaJodQC5qSzkJaSazZrgS4CVmb264TRo4C2ZUGa45NGRVwkw6A	1633	1144	557	12463	18974	jxyPqW8HhCqiFrJnt4hQEXf92BQWubK3AbzRDoCWYMimkFaVkM6	14078	19840	19840	1619510400000	canonical
28491	3NLefxxwA7h3ZdDcdQrMxKwp6otH2GfkC1sYpSQF2Qjk4Y37uAFb	28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	1506	1247	558	12463	18974	jxRC5mGGpVY1iHiigUoap6oJQcpgUYSuZb6Rp8UPvGWvtyUsS7h	14080	19844	19844	1619511120000	orphaned
28493	3NKvYhLEE1McKDTNdzFpcaUKX2RW8L6e352xNN3mVWks2rTAv3QV	28490	3NKtpNrzfWJ883226t2B4YimPU4pgVwDbyMfgQvaXFznr6EyEsBy	1483	240	558	12463	18974	jwC75oKWFea81jZjxv6URivtBUHo13wshrYy116iEjm5EgUMPri	14081	19845	19845	1619511300000	orphaned
28498	3NKzxEaKz47bjjxpSPsmYNX38VAbXrmH5cbJPJ4UHpeVz1s4bzVv	28496	3NL3oYYybXcYFveitV6Q8CmMw9cWBjqdn8jfhavQ6283JsLbMMXW	1646	1108	558	12463	18974	jxCSWtqwNGFb9oACKhbwFexVhFkHoCN4qR973X8FLfFCVQD8jba	14083	19849	19849	1619512020000	canonical
28503	3NLBTxsmA3gZX16AdFX9mvCjs8kcrSMmmSWZrQCrC3EWwh9e1uY3	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1654	1214	558	12463	18974	jwjqKBKUYSCianvRaANcjym5DwJmg9okAvumWmovCBo27SojVrF	14086	19852	19852	1619512560000	canonical
28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	28503	3NLBTxsmA3gZX16AdFX9mvCjs8kcrSMmmSWZrQCrC3EWwh9e1uY3	1426	1364	558	12463	18974	jxRBVqTKj2q8wBe7122gQnasMVxp61SZV8yXX77zNnJdzdY4bjb	14087	19853	19853	1619512740000	canonical
28509	3NLuaYSQpV62SDDbo1eBBLKMh4aumZJejAc4221TdWZmjHAsK9rw	28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	1668	1370	558	12463	18974	jwjPPbsGaKW9dxbDaWEvSrNVJR5bHrEaDrVc2ddRcBeeuFXm63R	14088	19854	19854	1619512920000	orphaned
28513	3NKiiTCe8XmSXX21azV7kMiyxtCBjsVxEfqkfWHwsbyKr8rjEdFq	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	1462	471	558	12463	18974	jwFeKn4Qa8jVD9bALAoe2N4zwbvXD4AzE5PZx9FiZhg31W19sk2	14089	19855	19855	1619513100000	orphaned
28516	3NKMRcdLjxuWQ8GD4DcKzrTyCEE2eqGX4MVEuaT7yuePdA5DeXH5	28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	1602	1369	558	12463	18974	jwnzP9FLptpwxubZ9CaBHznf8dLoM2es3EUW3o23yG851MJ7szr	14090	19856	19856	1619513280000	orphaned
28508	3NLNTgeoUEJsfJaQC1VSiYV3Cxc6tXftZDapnQ6yGL4oSGosNoQJ	28225	3NKr4NQRaMA8bsBhQuo1feUHaoikTEeqz7kTsdFnM8UPvKhiXnJJ	1426	1364	552	12463	18974	jwr2t373v7HtMU272qGVRUTjBFtCtZMTK2pSYoBiks8coKYXpij	13933	19853	19853	1619512740000	orphaned
28517	3NLZftUsGcAUvZ8NcuZHGidZCZ6J35ssce3EWGJDzY1vchWGsGig	28419	3NKZbmfJu6MjPAT7QGX45pkLzkP9hmYo4yrsqrbZd1xgFFRaj62r	1602	1369	556	12463	18974	jxdccayBy38oRzgDEwotjQ4wTMn7DVPMkYFNRxWweBtdNbVWc3q	14047	19856	19856	1619513280000	orphaned
28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	28451	3NKxMR2roYBARWFisY8zXscoNHTBbBf63msHrUuPabArMdgdxR2p	1407	1395	557	12463	18974	jwtJk9yPZ6MGu8R4YhmYemS9fic1823ZEPN8JWfvSdGWvZBrRr9	14061	19821	19821	1619506980000	canonical
28453	3NLhRpNpCzUQBK8rWYMzWJ4RLUpaS2qZfE5mAH8yHoukU8iguV6e	28452	3NKNaQ9ddev1YaxE1YPUEGWv61zrm3i4V7Ga1ZHoNCnuxAUGneWv	1405	853	557	12463	18974	jx1RcuSQHjvDMi6Mz9C8Fo7kAjKRVftAicJ8n4oAFQSMd87XWWn	14062	19822	19822	1619507160000	orphaned
28457	3NKVX8peM9pDLxGpKvMnGw6RXUTDGmtcMg8sF6xrMPtE4m1dwYfo	28454	3NLCt6mfHbPmdT7JAJcAWTuNrHsYNCPPSMR4Ezz9tiQaXa4QDLLm	1448	1185	557	12463	18974	jxD2zdon2KTqYVhX5YyZazmsfRd6qxKeCAsD6ENQVryq9g2xYzL	14063	19823	19823	1619507340000	orphaned
28461	3NLfj1h9woAvwwtvb6t1J7fwogeddHAPtfKApZaz8UEbfXqq5RLg	28458	3NKLU3gbxCyMEiop6JKQQJ5h3M1j3VCxM82WJR2ETbSSmBB6ZvHp	1652	949	557	12463	18974	jwW5UbaZKFCJ5bufg3HFLfCc4LHGqXhjBEUUspvf7tB94HGiWg1	14064	19824	19824	1619507520000	canonical
28465	3NLZCD22vZ1QXTcDUq7ej4WwDt4hb9Nzg6sNw9HDqpNaHv6nYbQf	28462	3NKyr2JEsfh9o8bpNJJy2LhKBgpDEYmXcXp2sLtya9md3xSQvxn1	1406	1393	557	12463	18974	jwsoGRcK2Y2Yreon7RQXu5fzfLgD6yk3ZCmeeM4o9Xx2gs8A14G	14066	19826	19826	1619507880000	canonical
28470	3NLDnRhJL4DSeVMVff3cZ4in2qDWCU9LheS1EWWtAkrazX6vfA5h	28467	3NL5VHk5mFMJMriMqdWDQL5TSa8rjNSfzuqabnYRMDP7uaYfPmiP	1637	816	557	12463	18974	jwAmcFZ42mU6CWM114WsFN6NBminGUZUrbWgqhrsBbnzMS9bAAo	14068	19829	19829	1619508420000	canonical
28476	3NL2PuAaquK7nK56hB4tyr7fnKYLVTTiQzar8v3fc4meHjCLXYvs	28475	3NKf55UQteR9rRnH2PUGrJ2MZ8cbWMxxSVmwptbXr5s9QMSS8x1e	1587	991	557	12463	18974	jxf9NBi8x84kBQVESXrHf58ZFRkSwbeJ9iAN5VgUknrVxonxSHf	14074	19836	19836	1619509680000	orphaned
28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	1407	1395	557	12463	18974	jxAF97AiqA29eEfwqXRou4WiKsa51RR4b4WNYHntGpAWkCrUSdE	14075	19837	19837	1619509860000	canonical
28480	3NLAoVmoAox4hoEv51W28RQm58kQQhDudTjKCLcTrvMCzd3BGCPz	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	1631	794	557	12463	18974	jx6P3uqW8igxzxWqXeJmwWYNetgspzay1EQedmSyZPnprPpaXDH	14075	19837	19837	1619509860000	orphaned
28486	3NLZGTL73VYqiVFy6TDf3wBiTWrLcHo1ydZJgJWR3K4nUJw55zKh	28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	1601	1388	557	12463	18974	jxQRTcSaozvSh5gVh8ruuB645KLRJhgs6UPXc6peZWh64u3kbji	14077	19839	19839	1619510220000	orphaned
28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	28488	3NLZckrxzTVXsSY2JtykhJrbiQPKv7mKrwrXZT11GNZmayCieP82	1405	849	558	12463	18974	jwd9EdZz99gZUqKvtvreHcw2co9ouUMqptoGWEoy3zcb36FnkWz	14079	19841	19841	1619510580000	canonical
28490	3NKtpNrzfWJ883226t2B4YimPU4pgVwDbyMfgQvaXFznr6EyEsBy	28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	1402	850	558	12463	18974	jwnFgnrrnckMruYzHHaUJdWQfyYrYcLUuk2KMnwZQa8r7ikr2BY	14080	19844	19844	1619511120000	canonical
28492	3NLAf3AbiaP4C9UTVKbD7wjmucd2qqKWnwnvuUVhj7712bsYeR9G	28489	3NLWc2AYcCZuo5wqbZ9mEuJtY2q9jWoJ46szigLXCv7HYTcx5cPK	1506	1247	558	12463	18974	jwqHYQeDhsTVgWEBJdiZW4Gfure8RPdKd13n2McZZfSfNFDqB3o	14080	19844	19844	1619511120000	orphaned
28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	28490	3NKtpNrzfWJ883226t2B4YimPU4pgVwDbyMfgQvaXFznr6EyEsBy	1461	1271	558	12463	18974	jxWmCuSE8ewPsQ9pNqhSVcHoyVPXKW6cL6udinhUpG2CbdkLXnM	14081	19845	19845	1619511300000	canonical
28496	3NL3oYYybXcYFveitV6Q8CmMw9cWBjqdn8jfhavQ6283JsLbMMXW	28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	1407	1395	558	12463	18974	jwVKuwjkg5SHPomzuoyTvEyL6i75HUYG5ds67E7neYuTsyUh2Hy	14082	19846	19846	1619511480000	canonical
28497	3NL7BqpkVe4rePkzya5ty8WTi3SGvuGHewF19oha7rTGWokzBc8t	28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	1599	1287	558	12463	18974	jxKqEY3vJ53Dkrbz4eyTebMFeozQiZhLgrehnmWzT4VsQhSr8VP	14082	19846	19846	1619511480000	orphaned
28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	28498	3NKzxEaKz47bjjxpSPsmYNX38VAbXrmH5cbJPJ4UHpeVz1s4bzVv	1559	1353	558	12463	18974	jwipba6E7orNqKdpcLP6Kb78jyJJs7o8Pc3PkZq3eGfFHY9e1Zm	14084	19850	19850	1619512200000	canonical
28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	1541	1298	558	12463	18974	jwND1BAJWNXkptm5oV5gyk6HkePiSgWZd2b1j5RJwcvGwCBvZur	14085	19851	19851	1619512380000	canonical
28502	3NLmMYT3m6bjDxUKC65V4iCHYWLsgMPWnjiDUXb6StXaj314c7oR	28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	1541	1298	558	12463	18974	jxSHrNs4gTTvjkkvtMh8i4pYKVGCxVusNpoPH6evwiSr9u1wY8W	14085	19851	19851	1619512380000	orphaned
28504	3NKsGoQ6RmnodBLFiTfqDhsxrk6PGNwk3vY4xsKZDe4HUZb5MEax	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1471	1260	558	12463	18974	jx3wrW45YZzGeD432AE9hTEVyDmNmVoxCZsfAoDtRc4ZLys5xqh	14086	19852	19852	1619512560000	orphaned
28506	3NLeFZjCYg3BoN7Us5D7Cz6yfnj31pL5aDx2XnRHcVp46m3E3GXP	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1406	1393	558	12463	18974	jwaQ7tnV2PsUn4wNthyjRYF3muErjsgc56V2RmCDfTNgHKW4yCw	14086	19852	19852	1619512560000	orphaned
28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	1648	1284	558	12463	18974	jwEc11RTDKT3hnR8ANyrqo5ADxCQHk8aKGkJa4nWU9acqH4wZUW	14088	19854	19854	1619512920000	canonical
28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	1405	867	558	12463	18974	jxNEj6JEP6gjRAa5xpBLXVeXABNYEPcbi68bjdA68ZCf8kwFfAa	14089	19855	19855	1619513100000	canonical
28514	3NLpuamjE9Lu864JBxCNdSUjPDqNvASnz8Ko5GVEPcsSSWgLZqdf	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	1581	778	558	12463	18974	jxs82VvRcetPAQ9t8zQMih8Vmv8ioFipVBZjev2ot86rSFTVBmw	14089	19855	19855	1619513100000	orphaned
28518	3NLTJ3Q7yYPDAnHeQ8EMGSQuvsjhbZ7vx5BGsB3ZUF5GXmc75AjW	28512	3NLqFFKCReeNL6cf5AcxkLRQLUyuF66pbvW95mhsAwsum1f5vTSQ	1406	1393	558	12463	18974	jxLAj8BeGwnv9GTWMmn6zeymw1F7NDWqaB9WmkuumrmrKTDKsp6	14090	19856	19856	1619513280000	canonical
28525	3NKPtJseT6YDD8NvCEN6zuM7WTDdEkmxuKaJmpwAwNaPRt2S3fMo	28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	1651	1055	558	12463	18974	jwvYtdbQA2iEDmcfTyjWNLEEFumwhQECGuNmhYDTAysYVMmzbH1	14093	19859	19859	1619513820000	orphaned
28527	3NLdgh3QBfDD3NPLpxaiAaNPhKCBfUjX9iHqJybvNc5qtAAX8oWx	28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	1407	1395	558	12463	18974	jxaFor7emQ3ruSG12GQ4xcfQCfAVzjQU6m8BGsM5Gz2vrZh6Y3S	14095	19861	19861	1619514180000	orphaned
28479	3NKxfNF3wVQoXhtgLrk6C5HMDZVYiRmmrr8vGwNeGJEgJbeLy6Vn	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	1406	1393	557	12463	18974	jwd2NPT6FFJv144aURg1xiPf5V7micjZUmbTSbQmrKkX4xcyrou	14075	19837	19837	1619509860000	orphaned
28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	1522	1322	557	12463	18974	jwniiF6pbveAvjmwtBEkN4euKpjuM7WnNtfBXC11ABT1CjaVAbe	14076	19838	19838	1619510040000	canonical
28483	3NL1EkbD95dseX5ji4twvds2fiebTivioZ73s2kABbPYFP742GM5	28478	3NLCKMeZajGPzAAZGFn5MZrSAqPisfXXCngLVBoAgeoWeUBREaqx	367	367	557	12463	18974	jwcpNFDih1H1wfHDd54RAvcc62bB8XCtGtpnMfkLTktHZvyyNLZ	14076	19838	19838	1619510040000	orphaned
28485	3NKaJodQC5qSzkJaSazZrgS4CVmb264TRo4C2ZUGa45NGRVwkw6A	28481	3NKSiMqwAFq6czoFV6iNomQSwr8Mwq6whARo97reSDzGw5Z8MnGn	1467	1130	557	12463	18974	jxgNBuEGY6M5TKrvJXBwDMu14dB4wtmsB92JQRGM2ftiyGTMPuU	14077	19839	19839	1619510220000	canonical
28495	3NLZohQxhFTVLS1AsjGZp2J7ocrU67wrBLvvof7BkoSgWbDQbn4M	28494	3NLyKEPu2J1DSex3LLBbC4UgeuKmeSP4druhBFJFz1nHTaJvFwtr	1672	1285	558	12463	18974	jwEFRvpTFhVfuJpy7ywEPaR1uN6Xvp8UXiNg9NNAMFAf5tEAJ77	14082	19846	19846	1619511480000	orphaned
28500	3NLetrhQiTo78vbLrq68v6pN5Y9vWgsfLspD9xD8izG52brS9eow	28499	3NKXqm8BfRq8iiyRxZSbW9SVi51vPqFYLQBifbtAiPSANYaFyScG	1541	1298	558	12463	18974	jxmwqVZRFbmMUv1yjwSf8ptYVovQnrCittbhuhT44V3GhDX4L7r	14085	19851	19851	1619512380000	orphaned
28505	3NL6pKj2Ah3jY7vuJVxV9pQteMUL7zEFc487M7z4hhUnuUAvy27U	28501	3NKMhY9qRGDDD2RYHE9qfL68qxduLfwqzWkTkhyWcDp86CXrTCrh	1534	220	558	12463	18974	jxMe2cpx6WexPofM6GotJLMjoXvhyKCUxqqeN8rur5boFU1GciW	14086	19852	19852	1619512560000	orphaned
28511	3NLJ8FQ42i4XA4UwxLDuJ8XypsefWkP3r96GkG3LRamq1sDKrT6S	28507	3NKagF1zp6pPCNybLBja1jF2LZxoXdKnGiTpXkZ1zHdC3YGZZnFz	1573	1318	558	12463	18974	jwr8pYjYryrDM6ZzAuScGu3dLZnfzgdmRh1wg5F3MbnBM4tCMEp	14088	19854	19854	1619512920000	orphaned
28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	28518	3NLTJ3Q7yYPDAnHeQ8EMGSQuvsjhbZ7vx5BGsB3ZUF5GXmc75AjW	1631	793	558	12463	18974	jx3bPtSJwETiiFuoLZGvurE7KSKGm71yByfA38AacTqvXkJxmnu	14091	19857	19857	1619513460000	canonical
28521	3NKjTQP6PSdyDSknhgfShvDZELRwzzk2B87JCfsLv9eVi8Khd4TC	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	1406	1393	558	12463	18974	jxjwPR7mEZgZkd61qcGnKrGEJctb73fozVEkzJM9DhUUy2WgeUi	14092	19858	19858	1619513640000	orphaned
28523	3NL2HXGewXXicU9y5wzWMBpJfiGDbjiR2ieKwbzsnBc6DTwVpsyS	28522	3NKK2dcBzxdYjzt4HAtKiPVesEHuuqFuZupyX5ZYxzP3GmiU66qL	1656	977	558	12463	18974	jx6RkBkN7AhkiRwMVqdYYuzotRTnvD7UQsnbC7BusDWxSx4jvYW	14093	19859	19859	1619513820000	canonical
28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	28523	3NL2HXGewXXicU9y5wzWMBpJfiGDbjiR2ieKwbzsnBc6DTwVpsyS	1403	782	558	12463	18974	jwHsNeJC9aVpAEgASNmrMqhPHstKLto6oUhX6M27vV2JmG1BcTN	14094	19860	19860	1619514000000	canonical
28528	3NLaukAzBmeDzsASMmFhEHBuPKF7tZvHEtnupzMwW21vhnoG5cR9	28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	1596	1363	558	12463	18974	jwvndjNVBmDJ4ZJn6LThZ8WSA9HkLf7s91XqSrkBuHkLp6itkJq	14095	19861	19861	1619514180000	canonical
28530	3NKhPTmrvgm3Q3TnkYL5J2vy1AxQQvmeq1Vxnet8DmqGHKZNEKcc	28528	3NLaukAzBmeDzsASMmFhEHBuPKF7tZvHEtnupzMwW21vhnoG5cR9	1407	1395	558	12463	18974	jwBN45FVrJp7oNKQCtq1J4whXZq2HpbV5mG1k5yC3gaBhcE3hyS	14096	19862	19862	1619514360000	canonical
28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	28530	3NKhPTmrvgm3Q3TnkYL5J2vy1AxQQvmeq1Vxnet8DmqGHKZNEKcc	1407	1395	558	12463	18974	jxGi62BNSpNoWrsixDP6jBE2DwzkcQ98aw65S7GXVUof6aTSHDV	14097	19864	19864	1619514720000	canonical
28533	3NKyk5niXjWuGUYWMBpVaPwEkTU6xfFWZtGsQc4H7Qm6XHXTokX1	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1406	1393	558	12463	18974	jwVratWMQyGDgetYoGbkuHTXTMSnsvqabEjX5zDmkzMu1v4ibUG	14098	19865	19865	1619514900000	canonical
28537	3NKsb2zBdYuWaTWi1Edr26adygfcArduxGjDqzkNCAQAJbcJNM2b	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1523	1195	558	12463	18974	jwpBQNCQr21QX29QvLrnN5ZxRuCUyNw4UvXkS4Kkx4LBEDYTLm9	14100	19867	19867	1619515260000	orphaned
28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	632	1256	559	12463	18974	jwutcWi3kreub6wkfyk2SaQV5AzhLqFmzTSwm3WaD7JDMwYqd9A	14103	19871	19871	1619515980000	canonical
28545	3NKbq9nMqTVGgYeW3Ndnk2vxZ8pCrpjVa8UF3rccTWmXQB5DKsAm	28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	641	1336	559	12463	18974	jwmJLX6TKpod1SLEz2NmK38oZfG7UgSQtfTatDBF63VjZd3tU6v	14103	19871	19871	1619515980000	orphaned
28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1458	1323	559	12463	18974	jxfpaNsnpTFNT2hpGzUxAKUh4meHuNBiC2ZA8G2Hs59CUWSnaFf	14104	19872	19872	1619516160000	canonical
28550	3NKDnuL83rqjbwxBowqwY5icznFZofyZ35z58YYpMUxrEXvcpPrJ	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	369	1066	559	12463	18974	jwhyp9sBP8bpJWWQK1rp4r65rH9Hd3TgcaeT3EnELaNdZEo1BmA	14104	19872	19872	1619516160000	orphaned
28551	3NKL4qQiMHxuqVcVFjAYPfXddLLi8xJCTXj2VtR6tD8vsKLk5rfx	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1527	1047	559	12463	18974	jw8rWYZm2QJ9sXES99rmt5zzeSkVnCmzzcMTrQUf4u2m7x1oEpR	14104	19872	19872	1619516160000	orphaned
28553	3NKpuL7FqhpMF1uJ4boF4QJesv7FEBcJsBycQnt3GKNwoB4eM3hn	28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	1483	191	559	12463	18974	jweQxHJ1GdhYg6P4UPf2qTLmNVo685hJhQX6r4ZFQWGQiJJGw2e	14105	19873	19873	1619516340000	canonical
28555	3NLAqWAyUKXFL2BrwuTvWwfCcpTZJHDB2t3NAaiPKiFHV6dBfyba	28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	1577	961	559	12463	18974	jxbqmMakEQ7nkden6v8c4bqs2fFPTEFNUj3DY8JD28g1VVejpRM	14105	19873	19873	1619516340000	orphaned
28558	3NLqTJkJhkowhJVdiZS8kkgfTB7LAZaqxfNL77BcP14uEbmb5tjG	28557	3NKhw5WtZVA2M9F7z33rL72zJ48GGw8UrinLbknJG5nTCVfQiHsu	1631	794	559	12463	18974	jxD76smutyfyPrNVdAWsiXQ4qfmz2iBeqZDKYVyTNzyeZVmu8rv	14107	19876	19876	1619516880000	canonical
28561	3NKhEodXYgwMMrLhXesdRRiLCdJNkYU4LRraKyXRLjuzNgCq5upG	28560	3NLiCqiobRnV677z4LBKCvRmpU478Prn2BiRCuS3WFdenyydB3VT	448	1179	559	12463	18974	jwparWFUWsJJn1guGXTPq254NxgVsAXo6GVvCAoah639BoAgazB	14109	19880	19880	1619517600000	canonical
28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	28561	3NKhEodXYgwMMrLhXesdRRiLCdJNkYU4LRraKyXRLjuzNgCq5upG	1654	1094	559	12463	18974	jwCNxMqcdrBKt96ahDoXCN7ab8heo4gVNB8jz5f8paCypaAaSbg	14110	19881	19881	1619517780000	canonical
28571	3NLdyMPVB4i6ZPXxtdf2RU1LYZUxUkdhGR1ADbdsF5sGsmxcCGLY	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1406	1393	559	12463	18974	jxC3Za2sJgueB5amLRXAzWgg6DiCycSzXNpe5WrQQxfu1qeF4oi	14113	19888	19888	1619519040000	orphaned
28573	3NKKnnXp3qcxvtH5YuZcKU4ov37yAuZJonuGkSzWWM6EUMNG961P	28520	3NKsSzdyyx7FSdZEz238KCn6mhG29rcKPv7BVdfE1v7YZ3Akjxdn	1610	1068	558	12463	18974	jwW64m1mFT1Dzv7YCDhoTzcoqCbwEodh2PfoZuorUzuiZuSxQb6	14093	19888	19888	1619519040000	orphaned
28529	3NKBEZuiXjEzqwo7PoP8gzst7sUHFEhZMRNmF55puE4PmAgw1CeF	28526	3NLHDbTEbYebjCDmPFbe1ZxKbTVF4eR53M87H7XzLMb1iCUtGR3S	1616	116	558	12463	18974	jxikqnpfysFqbnJBLsrZtXtxMRHKWQsv95AqyfoLq3EkifA7J9Y	14095	19861	19861	1619514180000	orphaned
28534	3NLddC2jZVTd151r9yV7HVWJACujwd9ATQ54yfhUe1TE16u9k28U	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1633	1390	558	12463	18974	jxqwjmdZaJ6LqURDWi7snHs9TPuWyrvyKNZdGSGtEg3LSSmjRnz	14098	19865	19865	1619514900000	orphaned
28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	28533	3NKyk5niXjWuGUYWMBpVaPwEkTU6xfFWZtGsQc4H7Qm6XHXTokX1	1407	1395	558	12463	18974	jwzFjEpPWZuEgNDF9QJjHpKf99s8n6ABsa3eT4ish4Zn3T9wEgU	14099	19866	19866	1619515080000	canonical
28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	28541	3NKGEG5QGcaTYy4tbFvxVYzB2tGsKJmxDNtMnQiU8yiJhSnM64tf	1616	2	559	12463	18974	jxMjrC467wPGPnNidJFBF6Kmxe8FrjhjUKvxg5w4Xzx76g9n5tQ	14102	19870	19870	1619515800000	canonical
28548	3NLVexaZNBRU8B5CvUvUFn4sGh6nk84tWiC4BeW2vKov6MRdCuYW	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1460	1324	559	12463	18974	jwhYk1RD7FpdsKbbPYZuGPrx2VStoXp8WCxbz3pGXgdUqid6UEa	14104	19872	19872	1619516160000	orphaned
28552	3NKMiyr4g3v3nhsUHJar7sJF6JeWbcu6M6sMyTKZDv3sWRM35AQn	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1527	1047	559	12463	18974	jx9FY2LeLwcu4563eMUBBhUtta8FvctQFb1u63kuwFzQjxE5rUc	14104	19872	19872	1619516160000	orphaned
28554	3NKEkUeu2hqoUknE9rdqz9yF6JipJiKMaT3ZRbcW9NZbvc9WVNvK	28547	3NKrxBQZbS1yJNgAVQjFzi9tYjhDUR6Xy3Wa9AGkU8qrYqKqNBqn	1613	983	559	12463	18974	jwbpVNACgma2QxNTrpkupUxihv7LQe9yYtvyj4VpP3zwMQVc6mD	14105	19873	19873	1619516340000	orphaned
28562	3NKxSsyx4GhC6FGrfyGCheE5h9uBLy99zyJpXRLA3FeAQBL4uKAM	28560	3NLiCqiobRnV677z4LBKCvRmpU478Prn2BiRCuS3WFdenyydB3VT	1642	1121	559	12463	18974	jwVNBuQhAiYv7t7nGXpSpwJ3APgTzHBfvt9JSpM28zbNQnk9c7u	14109	19880	19880	1619517600000	orphaned
28564	3NK47SCQPkeVSYXXRKQ6pneEUmSFJpmNkaV2tjFTfoRgeZ9b9TEN	28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	1534	951	559	12463	18974	jwrsUzB6wTBUXbsUSjk822Z9tBVuB7uF8BN6gffaGg36c9hXD9R	14111	19883	19883	1619518140000	orphaned
28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1610	1068	559	12463	18974	jxXTx7qeXCoNrPNmztC5zGKxQXCxVqDAzkPcEHtvsFd72RGtLag	14113	19888	19888	1619519040000	canonical
28575	3NLecSiXr6EgyDYWA9Jv5q92jgpFbHm74JaCwmknjfLQxpEdNXeL	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1651	1055	559	12463	18974	jwAcwBDJoFw1JRU1jKfTYG6R5Fr17cFYiKyyH6cx7n2sSeSVP14	14113	19888	19888	1619519040000	orphaned
28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	1397	828	559	12463	18974	jxkXgtYJSUajUya9Kub7TRNSPmwhYC8N1giMKtLTkWTL41cpXxB	14114	19890	19890	1619519400000	canonical
28576	3NKTgh2qxqCHWzvK7Uw6HQ91hBgWrfz5MXZsr8UBMDxKsndL4Bqr	28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	1546	1213	559	12463	18974	jxtvDQm32jzJLPBzSvJYkdqFj9KyZhMEqgDCoU25iyRvbCaus4p	14114	19890	19890	1619519400000	orphaned
28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	1536	1067	559	12463	18974	jwajAR1o1QKSidjjBsNAuKXfK1Rk4WsjdLHG6e3rFXgxnmbCKhj	14115	19892	19892	1619519760000	canonical
28581	3NLxdBgxUqbmJS3aQBgxsqtVBMuyfXwhyYshxQnLjNLTVQUrsn2t	28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	1454	130	559	12463	18974	jxV23uGTzN2KPfQtxQU8Wdc4dqhdtKKr2WTUZR6R7Lk4EHfhw3E	14115	19892	19892	1619519760000	orphaned
28584	3NLehyWmga7HT6sWm9dLCSMomJdwMscHGzqp5iFe43KeZTfPb4jW	28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	1536	947	559	12463	18974	jwJ62EJGDL9Unk1f7cyrdNTMtM5Kfe2dYSe2CCtF83XcGo8p7sK	14116	19893	19893	1619519940000	orphaned
28588	3NKWgPGwh1pG9qSJAn1kkph7BamBggxgEtZvTDhQUTkgzriGEpam	28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	1672	919	559	12463	18974	jxMsjxoVGmaWuYJiXpjXUtXTmbsw63uxtpHUzXj185echezAVoM	14116	19898	19898	1619520840000	orphaned
28585	3NLsvR3KPod56jce5hce4s2d1HqFoGDenJvbcBtGG9JTkxvzuKx7	28583	3NKSnnDffnnweFeHPqFs1T6QsSKopPRsBKHFwL9cDNuP5CPTmwfG	1406	1393	559	12463	18974	jxYmyQSqd4DsrMQdWXsAUBWsFChvwgQuPTvnLTxNUXyA5U6bg33	14117	19896	19896	1619520480000	canonical
28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	28585	3NLsvR3KPod56jce5hce4s2d1HqFoGDenJvbcBtGG9JTkxvzuKx7	1406	1393	559	12463	18974	jxM2EXDLoJGNfKbbWYUMzoJPrth6Kt75UzVGKZ2Ba9RJZR6LRKA	14118	19897	19897	1619520660000	canonical
28612	3NLUJ9EksJ3dysMfnY8prQae1X9JcYg4LzpLbZSbZiA7z8XDaK5d	28607	3NKdTd9WEbX26vERkUe3AJDW3r35LTjnRqxB5Cq8xoJ7USMRHRLs	1672	1039	559	12463	18974	jxFXEno9FcPcLvDRmrpxK3bdgZQcNLqHes8CbScWCaAP3SHh371	14118	19908	19908	1619522640000	orphaned
28590	3NLVSweiUoPZXL9hbZ2hs7aXwTBb86Ays92Envb7Tb23PvUxzvTa	28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	1406	1393	559	12463	18974	jwBn917WKRe7L5EpHmVFexMjtYwQfXRRGwbgZ2uMMY8RuUBgNse	14119	19898	19898	1619520840000	orphaned
28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	28591	3NLDtryZNnZnFX3qvjRVHPTeZTF4fheiDnEbMnmQ7buh9PUp37V8	1654	1340	560	12463	18974	jwMVKikpYveoe5mE9D6d8LuHFhHUid3xbTtVLFYLJXzgMth3r5o	14120	19899	19899	1619521020000	canonical
28596	3NKi9uZFjHdnnjk6TLrubgeBQRjotcPeoirSAxGv38JH62r7h72e	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1541	1172	560	12463	18974	jwjy1MP8DEAR5K6L1Fqysq7F399EhjbaxchQon1KMRT7CzWc4Cy	14121	19901	19901	1619521380000	orphaned
28598	3NKLViyPPH5vsYF1BTKH2nPFLPKdAxDHDh7mjGnu95n6eEoANKa7	28593	3NKeBmjvc7LodRxXCYwr2aYZ83hcE1uiGccutRzvXpwHGrHFBdbF	1650	1375	560	12463	18974	jxoWiqSTt1xEDHMHLq4pGK2ELs9TooZyoYvAYd56EptjUfBQ7wm	14122	19902	19902	1619521560000	orphaned
28601	3NKGTxoPqsnoxziMpthCkKFU2qGK7p37BVMNeML9Dj65eBNWsbQU	28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	80	80	560	12463	18974	jwXaWAtb8d3PxDJ2U9LjmL9fr1VLQJVJTz2ExNNYnHmUSU55XU6	14124	19904	19904	1619521920000	orphaned
28603	3NL21QoHQewLis9AP4wAt1KBvWo64dT6KGN3tQZi3ZhbYoT1sgnv	28602	3NKC7nKyXave889yeZBqRexBjVRLbVRFXTQVXg6nCAxXU9yQBBYQ	1406	1393	560	12463	18974	jxi4pUTxTCNNAWKvx79rcrNAMXqHEJjpMQCZBx4tHHQVdssonGJ	14125	19905	19905	1619522100000	canonical
28608	3NLYmoofkzuSpfYbW3GKkXV4K9JWmRDAzSfWCSMPkvecJadyK9Qr	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1672	919	560	12463	18974	jwjzJZbsiXfDNvJiJXFyBYnDWXWPxqj1r82LQCaukmiS9QWNqNu	14127	19907	19907	1619522460000	orphaned
28610	3NLcgms2FLGqan662WYQXEMCg9ieaLE2ZsznMENLjoauhzHMn5bf	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1651	1175	560	12463	18974	jwe5rNUtsXs4JuLez12GL4ianVqkzAsc8bbdag4X2bDartuTKp5	14127	19907	19907	1619522460000	orphaned
28639	3NKBHZhN1JS4hcU2bdjBwGdsw15d3776g82QqkgBpnGdpDcmCyUV	28508	3NLNTgeoUEJsfJaQC1VSiYV3Cxc6tXftZDapnQ6yGL4oSGosNoQJ	1426	1364	552	12463	18974	jwWbL3pgiuJTDGsBuYu8mHgAqCZBb8k7ayTha7zger4UUW2AF71	13934	19926	19926	1619525880000	orphaned
28556	3NKVw7bz1RsYmkPVGJmnYZN5YY4rJ2knF9zo7xY8j6vFD3VML76h	28349	3NKC6h6PeE8nBbZTUeD8Au2F6fDtxpKmnhNbMMs5HbvvwDtQGBb9	1577	961	555	12463	18974	jwVe8z625URWcKJRuuZWVZfTy63c24Vu6a1bVJA2yc9CtLvAjRm	14015	19873	19873	1619516350499	orphaned
28643	3NKUEZpXi5su5BywzXqARqLDjTLY7moZ1bdVYjHTJjueQfC7L2NJ	28623	3NL7CFambEjLDbDRbB7b7evvEurffbBkmu79KPe75fdUW3iEwhiw	563	1359	558	12463	18974	jx1zLxR4fZBUYAaBBLBeVspv4HnVdHa8gNtaB6QP7wc9C1pPJVg	14090	19928	19928	1619526240000	orphaned
28532	3NLdaPMrt4wb5bCwyb9Nv6PD75SDrJJByRWuA5rQm7du3v55yxZ6	28531	3NL5dTcLaAwhaFjCakEohJYXXSvioGAUDkBTcopyn63cix3sUa2B	1455	966	558	12463	18974	jwpEqX2cKBSd32E8gLLADxKPLYueaJR9ifdJYEXacitwKDPjsTa	14098	19865	19865	1619514900000	orphaned
28539	3NL71XRaGuLWhCVP7abdxexN8QqxLzV23tPxbo5X7VvLkJ2Ka6cj	28536	3NKSBq464rJrH46Y6THYXXqFFVW6yLqJziYAa4uW5UNoN7eTXrJF	1523	1195	558	12463	18974	jxE8S2L7KUFfw1EsZXGn2iEzAmRQTfVKM6PG9wvFPGyBeTCb24N	14100	19867	19867	1619515260000	canonical
28541	3NKGEG5QGcaTYy4tbFvxVYzB2tGsKJmxDNtMnQiU8yiJhSnM64tf	28539	3NL71XRaGuLWhCVP7abdxexN8QqxLzV23tPxbo5X7VvLkJ2Ka6cj	1637	816	558	12463	18974	jwZ3jpQM3xKS6UrVybhyw2V8dNQAN5NXD8MffMm1YMb84V9zhsv	14101	19868	19868	1619515440000	canonical
28546	3NK45Rk52eA4cxVCCugbt8Eci8LzvMQDXaEU7ENvafgiB6RD7CDK	28543	3NKnUoNWFiAg63Pk8wUK3upBfMRGRc49iXmS7ddVTaEsmU7f8eRd	641	1336	559	12463	18974	jwrFFoAy9uMZ7TTmXPWoAtPz8wAipuG1YDaKnzupffi4NZfz7Xf	14103	19871	19871	1619515980000	orphaned
28549	3NKfAnEmMmnVZRgG7DTyBgMJNRiYfyYfbdbutDADiLwCw9r43AFC	28544	3NL8URDPFNj9W2YymCHDQNNmRM1uRf3i4QDEznRhkh8Jy6XgTE6j	1527	1047	559	12463	18974	jxUQTYn2f48rDQoADxr3YcAyyVFnuYmbzJe37y4qKf6UkbeVWux	14104	19872	19872	1619516160000	orphaned
28559	3NL198NoU5V7856AQvkAdgE4ZN9frMbibkTvoDxmzpFiyp9scwPN	28553	3NKpuL7FqhpMF1uJ4boF4QJesv7FEBcJsBycQnt3GKNwoB4eM3hn	1670	1156	559	12463	18974	jxwhb6tsfx4E1Lu5yHZ2ExTTgnrW44VLqrutt2gAzXo8d2s5BQX	14106	19877	19877	1619517060000	orphaned
28567	3NKpSvTVtkyoqNAAL1CsVnx1WNiPt8bfcRYy7sXfZqAzcztWg33V	28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	1529	1070	559	12463	18974	jwRzdXnYdCX3cfyodQDGG26Gs1mYQ3SoEExzx5ghPPE4N6q47W5	14112	19886	19886	1619518680000	orphaned
28574	3NKCSyD5v3zJuRuAVUsMgtazSULTCEPAMboTe1vfJiybEJemSTCw	28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	1651	1055	559	12463	18974	jwhzMmQJy1L2tCANFgcVTdD694fivF6zYEcoYpWCaFmDTfouYjo	14113	19888	19888	1619519040000	orphaned
28582	3NLrRhfqTkWvuZ9tR9i6HKg8xuCc4RGKUJxDeJywSgcjW6N8EyPp	28578	3NLtm3s7EHXH7KjMXpbYQrEaTasrvheDQEn7nqPqA2xArNXe9sT1	1406	1393	559	12463	18974	jwgdm368kmQrXYP2kn4gJQSQzgnhz7LcgkrFEGdN3hb9xzXv2au	14115	19892	19892	1619519760000	orphaned
28583	3NKSnnDffnnweFeHPqFs1T6QsSKopPRsBKHFwL9cDNuP5CPTmwfG	28580	3NLjWY6WB3euEqKjgZ8rpA14YRfvxNaU9oPPxX727odk85YxNpXS	80	1273	559	12463	18974	jw9PpZR1Jm362qVP5UEHJckHj1Ez1v8mB6QjkSxCJ7paZ9kyym6	14116	19893	19893	1619519940000	canonical
28586	3NLhcX2juPF5TbLbChSi24fezP32r3j5WVMae9vcTp8AyzFCNBd6	28585	3NLsvR3KPod56jce5hce4s2d1HqFoGDenJvbcBtGG9JTkxvzuKx7	1483	878	559	12463	18974	jxmCmRDQDSHR9gkHRsCpnrcnQzgN3KHh2Zj4JNuL4trcGmN1sRn	14118	19897	19897	1619520660000	orphaned
28589	3NLJAxbAUxMu1YMZN3EQECJ84LhLW3HTNNpUuVQUjbW7TBNRkR49	28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	1672	919	559	12463	18974	jwcZTzS8cM3ozE3h47FS3DWhGKny65E3HNMqHn49hQcJ2tG38Xj	14119	19898	19898	1619520840000	orphaned
28593	3NKeBmjvc7LodRxXCYwr2aYZ83hcE1uiGccutRzvXpwHGrHFBdbF	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1402	874	560	12463	18974	jxjFEbVE9Sqi1peSYe1oPCGmTjYTtmez1YDr5rdbXZ7fUjxqQDU	14121	19901	19901	1619521380000	canonical
28595	3NKmg3DVBS3ZVXtVQ84TieXn8CBifWB3G52qtepz3JSc863iAHYq	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	1541	1172	560	12463	18974	jwprE6VbhBnYp2rwjcSqPpLyQimNa5GksrHwdQ8zPZHGhn2mCBv	14121	19901	19901	1619521380000	orphaned
28597	3NLUS5cV7SS9cmgenTM55MrVu8dg76xCiBKvCfv6LFKxs22CFaZ1	28593	3NKeBmjvc7LodRxXCYwr2aYZ83hcE1uiGccutRzvXpwHGrHFBdbF	1406	1393	560	12463	18974	jwYWudNfbgLBGdX7x5pLAVLZxHhJZLaThGUkj6eaT8jnEQpaydB	14122	19902	19902	1619521560000	canonical
28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	28597	3NLUS5cV7SS9cmgenTM55MrVu8dg76xCiBKvCfv6LFKxs22CFaZ1	1542	1058	560	12463	18974	jwTVvJjYckyfhHPqwMPiG1UgHDTZ2cWrxTNLqfNvwrVtnjq7Yy4	14123	19903	19903	1619521740000	canonical
28602	3NKC7nKyXave889yeZBqRexBjVRLbVRFXTQVXg6nCAxXU9yQBBYQ	28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	1649	1257	560	12463	18974	jwVWDD5ej1ssKbSKJ9Cn2XVvYtGv1FgTK5TKtj1oNWdGTFLxkKw	14124	19904	19904	1619521920000	canonical
28604	3NKfo8SdNqzyYdFoFpwciPdk4ixaKSf59aVHLMajs4GpE9UDDg2o	28602	3NKC7nKyXave889yeZBqRexBjVRLbVRFXTQVXg6nCAxXU9yQBBYQ	641	1090	560	12463	18974	jwoZy7dunmR5Loq97Wh6x8ChaoTYL8cPjPcVGZKQ56eE7qubDTv	14125	19905	19905	1619522100000	orphaned
28606	3NL7xKpg9sSvdz4rbEu2h2yYucT6ZJvB5p71Q12u68JyJKYArnyg	28603	3NL21QoHQewLis9AP4wAt1KBvWo64dT6KGN3tQZi3ZhbYoT1sgnv	1403	824	560	12463	18974	jxXLYtxgQXRe4q4HkeVvMxSQeWxswEafmvvGyP8TbMYj14LptPC	14126	19906	19906	1619522280000	orphaned
28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	28616	3NKqV9ygpXoZv3EZBjnh2vZF3pAZq9MD5ZwRQhGWHEfVF2B8ZYa1	1607	1102	560	12463	18974	jwrFPzsH9yDF2qkTSDJPPGAQucNgnvC1HSPGzNWUcKKpSftw1H3	14131	19912	19912	1619523360000	canonical
28621	3NKTK6YBo14BtWjQp9Lf2Y8ZNk7NQhvoXh2cECDpDPoB8iQ4VgfJ	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	1403	812	560	12463	18974	jxRhiv44KoTDkf9n7eeh7nYR99LG48bGKGchK2ZThJqCfs9sYcW	14132	19913	19913	1619523540000	canonical
28619	3NLo1M8XkTtvmL9hhB6MyCAikuzNmby2wLePCT994CE9BT78cRZu	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	633	1138	560	12463	18974	jwMNve7iNbZ4rBdcb1LV5QKiZGRjhjiA16empJA1XB3UxKUvGe5	14132	19913	19913	1619523540000	orphaned
28628	3NLPHE8wzVZMZZHqnpZyX9wYJomcj3uhGBZiWgERWh5CMhvkQ1nm	28627	3NK5GRAWH8JxDoZw4DXgKHpTqJAActfsNyocuiuHMM8P5iGVWdMB	1581	778	560	12463	18974	jxKG1fBQKubY1k8YGDrVyTbwmkJAY8SSj7vHBpjoE9sLg1dSvX6	14136	19917	19917	1619524260000	canonical
28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	28628	3NLPHE8wzVZMZZHqnpZyX9wYJomcj3uhGBZiWgERWh5CMhvkQ1nm	1619	1275	560	12463	18974	jxhdXegRFKchiMTN4128ZUK1w5neZV2FcZ5w1dLwnH522dyqjj6	14137	19921	19921	1619524980000	canonical
28634	3NL4ztmV8Y8XJyShQ5CNYMQJiMEp6RQZ1Cp3xXTyzU2M48GRn1Xo	28633	3NKkavxDK8fCgr7VdARoijQvpnCCjtCLqq1BJD4U5aRsKdQpWcPn	1476	1371	560	12463	18974	jxTt2Z7UMtcom9utUnMkxZsfmEapxfRYqRASUJBsKCixsvXokB9	14139	19924	19924	1619525520000	canonical
28636	3NKVDb8coS21d75ePbS22usAzPm3Sqq8XsPy9AAnn9RBbQXj1HUJ	28634	3NL4ztmV8Y8XJyShQ5CNYMQJiMEp6RQZ1Cp3xXTyzU2M48GRn1Xo	555	555	560	12463	18974	jxrpKzW2aaCLxMXyYvJgpBCFzpEnZq1TxjZWi7me1UqCMX3ydKa	14140	19925	19925	1619525700000	orphaned
28630	3NKV8Y8Yks3suBZAeU2pPvRgiooSZTnMLaDqKZAxtVqraHgCa11J	28626	3NLhusdXsL3iJR7S7qWMcj6tVGzfHNtuMZs9ZwDaExqshEMVJn1u	1553	776	549	12463	18974	jx5Db31Hoz4tqogqrrCvNo5iN7CQfAsH5RhWmn3Z5nYBS132GAk	13885	19922	19922	1619525160000	orphaned
28557	3NKhw5WtZVA2M9F7z33rL72zJ48GGw8UrinLbknJG5nTCVfQiHsu	28553	3NKpuL7FqhpMF1uJ4boF4QJesv7FEBcJsBycQnt3GKNwoB4eM3hn	1631	794	559	12463	18974	jwBrK7BfwbKR6ZUX3x4LusSeNACNvybfKwKWMGYD2m4o3hr9YdG	14106	19874	19874	1619516520000	canonical
28560	3NLiCqiobRnV677z4LBKCvRmpU478Prn2BiRCuS3WFdenyydB3VT	28558	3NLqTJkJhkowhJVdiZS8kkgfTB7LAZaqxfNL77BcP14uEbmb5tjG	1670	1156	559	12463	18974	jxeyjY3vpiqo27qCpLsmWhnwAWdcVG9uVQKVs4mGjvqzZTKxzXG	14108	19877	19877	1619517060000	canonical
28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	28563	3NLJeo5D4jHVodE6HtmNxmjaG7teEgmd4QZkaj2diEaYhfDxL8tf	1581	778	559	12463	18974	jxLjFeKHEobFYFMVSeLFLMNGZn8wsRmG3ecSgnYZy15eAMrsU6X	14111	19883	19883	1619518140000	canonical
28570	3NL6g8si7DugcpZSNfcXpX6qXdx5tYdQdTcCdwobXSL73io2q5pf	28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	1419	814	559	12463	18974	jwWaRjmyebseThUshTUqSwm2HCH5KPYvXihqtqQ2cQxEGMFgLVn	14112	19886	19886	1619518680000	canonical
28568	3NLsuWc4DeSzc8NB1ThMAio7Jo52CifxnjdXnVnPegrfmM7DQY2k	28565	3NKEanJk4R6v3wxKpyrH8gWLs42VjD3nmp7CmdNfbmruRXb8ypm6	1529	1070	559	12463	18974	jxafYgJkr84hVwxuLZ5WN6cFQPmYaiHTEQdJRiTxr1GCswBZY8q	14112	19886	19886	1619518680000	orphaned
28577	3NL4V9jwAY1KyE4sQnEXWWLvFdb19QCe2ywrtLUQSdJQGfo5Atki	28572	3NKRV7CMeK7j6k1uT2w4Ef9xnHxUone6zSwgqLpSvco2wy8xeVUe	1406	1393	559	12463	18974	jwDC7dagAgUGC6zQfowTsVEUMJpNpJTWU3KRkbo48pitKNan5aL	14114	19890	19890	1619519400000	orphaned
28591	3NLDtryZNnZnFX3qvjRVHPTeZTF4fheiDnEbMnmQ7buh9PUp37V8	28587	3NLkUTYVsxvscJvyqXg2XkSS1fKX5ZwmVrXsXEQRatqdBgRRHViV	1596	1117	559	12463	18974	jw7S2veZoMnsyxUteYt3LAtfdkt1qPVV4dd78BinxCD6qYmx8R3	14119	19898	19898	1619520840000	canonical
28600	3NKF7WRwqBt3fSuMrjjCvxkjMkuisDD2BBGCUoRWzV8PrwirVRnG	28599	3NL9L7rcFQRqFP36pJpWfLN8Ji6CVLw5u44af9qxnWEovdUViN5z	1516	1294	560	12463	18974	jxS6ek7a9T6xFEqNeFf2BrsXwoCrYBN4UpVGtNx9ckuYzvsQWH9	14124	19904	19904	1619521920000	orphaned
28611	3NKpye78asT8eNa5nyfMRi7nM7DrmYudaqbAyQGgF2aYxGZzjqCf	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1651	1175	560	12463	18974	jwDcBTmK6i7TbMbqKmBEDqvqELaAcuqhDDSuYHaF9dryWHnG6PX	14127	19907	19907	1619522460000	canonical
28609	3NKcx3BjFSyGGfkdFMT9iGr7bgNG9bWrvj2ZhZRgs78Czv5737N3	28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	1406	1393	560	12463	18974	jxiKp86AKrkrvk9xmnpzQjk6ygySRnJpXWsRhfhPbK6uHuXZvVb	14127	19907	19907	1619522460000	orphaned
28613	3NLHKWeiyGuqcQoZDzYTf8TbsnvntLuwqfb3m3Q1XQBK5d3XeUvb	28611	3NKpye78asT8eNa5nyfMRi7nM7DrmYudaqbAyQGgF2aYxGZzjqCf	1672	1039	560	12463	18974	jwxfEqQ7nguoRh2oQp77Wy6VodgFn3ZVznZrjwz2vCHDBDRHDu4	14128	19908	19908	1619522640000	canonical
28616	3NKqV9ygpXoZv3EZBjnh2vZF3pAZq9MD5ZwRQhGWHEfVF2B8ZYa1	28614	3NKGEryn1wDM8YYSKhKKGUCMt5wqCuSknqrPBArTwwCzQvKXQggM	641	1336	560	12463	18974	jwdJXvy3yz61pUo6BQhUE5mbAu29GVZaKmfCoFr9BM2DEGP9sNb	14130	19911	19911	1619523180000	canonical
28615	3NKGTosyta2uVqY4q3j8HGhbEFoJuSwaiKaDicWLaZ9Zknewsrzw	28614	3NKGEryn1wDM8YYSKhKKGUCMt5wqCuSknqrPBArTwwCzQvKXQggM	1627	1385	560	12463	18974	jwUX8vbFF4XQpjJois3dP8qQKxdF37RKzE1SNWtmSkpd2CP5Wib	14130	19911	19911	1619523180000	orphaned
28618	3NKjFEAEzJHJ5mF8N2MupTj1juxmJFsDYC33KaQtbJrmtawHzkvs	28617	3NKPEM37jcEKxBjLFGtVmXXZqH7uCsN8mUmWiXw8b7s7Gub3Yjor	1444	1135	560	12463	18974	jwMEVRWr2SUgovxqaYHn3YDJzS8vZR5iGKgZY28u7AZTA8Ecnas	14132	19913	19913	1619523540000	orphaned
28622	3NKL62qYoXKzpaqUomk6TWqQxJUMDA5VyKAuzsS5TD7GdbXjrzpn	28621	3NKTK6YBo14BtWjQp9Lf2Y8ZNk7NQhvoXh2cECDpDPoB8iQ4VgfJ	1403	824	560	12463	18974	jx7CY97StEJgRumLRtTMUBcQhz3A7sbPP8dA8AcoNz6mRiZSexE	14133	19914	19914	1619523720000	canonical
28624	3NK5yhM5BsFW8g5X3FbkRN4Y5tt7hcW4mgS7crfJYE1V9HSrAhnS	28622	3NKL62qYoXKzpaqUomk6TWqQxJUMDA5VyKAuzsS5TD7GdbXjrzpn	563	1233	560	12463	18974	jww9vVHWPSYxB8X8jGXmurvaAcVxUCEn8ptwHe3EgYwVtUMRb3x	14134	19915	19915	1619523900000	canonical
28627	3NK5GRAWH8JxDoZw4DXgKHpTqJAActfsNyocuiuHMM8P5iGVWdMB	28624	3NK5yhM5BsFW8g5X3FbkRN4Y5tt7hcW4mgS7crfJYE1V9HSrAhnS	311	941	560	12463	18974	jwmVyoDdCKr1bjygyL1B1GVsZ3KDS6BEqoFyoqYTTTWyccyrjKo	14135	19916	19916	1619524080000	canonical
28625	3NLrUjkkzUMReM2xEGF5ZoMeJgxd9bngfzbLQSkQUAPHxT6mm6Ug	28624	3NK5yhM5BsFW8g5X3FbkRN4Y5tt7hcW4mgS7crfJYE1V9HSrAhnS	1607	1102	560	12463	18974	jxRGc7cdRSm1Q6bTLPpKVsW4mPWqMo5Y5N1BMrPMcKcFD8Zjs5b	14135	19916	19916	1619524080000	orphaned
28633	3NKkavxDK8fCgr7VdARoijQvpnCCjtCLqq1BJD4U5aRsKdQpWcPn	28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	1627	1259	560	12463	18974	jwVqnUWmjT55aFVPHr2qndDTd8h6SbthhUYmbCNnVBs2u4VLe7V	14138	19922	19922	1619525160000	canonical
28632	3NKK9P2FPo7aCkPvux77RYPC8rWTSL8o243Pxmy6R9FZdCjgNLxe	28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	1654	1094	560	12463	18974	jwwJpekD1xQQ7zDLt6SfLV7CoWg4bbV8GVZrvWwQyerZH7FuJy2	14138	19922	19922	1619525160000	orphaned
28635	3NLKd22JQ5HuTMwmEf6yLyRT6opkgCBPBHxrEAkqK99U7NU7eTw1	28633	3NKkavxDK8fCgr7VdARoijQvpnCCjtCLqq1BJD4U5aRsKdQpWcPn	1648	1038	560	12463	18974	jwav5w419uudXvh2ndEsmUL6TzmQbgQ4F8b6iD612Dsri4TsJoQ	14139	19924	19924	1619525520000	orphaned
28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	28634	3NL4ztmV8Y8XJyShQ5CNYMQJiMEp6RQZ1Cp3xXTyzU2M48GRn1Xo	555	555	560	12463	18974	jxrpKzW2aaCLxMXyYvJgpBCFzpEnZq1TxjZWi7me1UqCMX3ydKa	14140	19925	19925	1619525700000	canonical
28641	3NK4HSzau3ZZpnDM4z8K4NxXC17rEAybdNzFBKey9515uvvRSdvC	28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	1403	792	561	12463	18974	jxTxqukmBWqvHumjdZ9YDYFEHLLUhiE3jYsf4bnu5AZeXewqAr7	14141	19926	19926	1619525880000	canonical
28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	28641	3NK4HSzau3ZZpnDM4z8K4NxXC17rEAybdNzFBKey9515uvvRSdvC	1405	873	561	12463	18974	jxkoFcQNT6tqHDQD8H3QszLvKeK4XyAVzkiMVD5BTrwXz1ir9v7	14142	19928	19928	1619526240000	canonical
28646	3NKBZwrJ2wxkXPmisLzGbppsRUgG3wmJfkhgQ4yzw9v9HwzozzQE	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	1670	1036	561	12463	18974	jwVxS33dngbJ8cswbDwMqc4LQfya5mPhuz8NJcYHyQGByouSL2m	14143	19929	19929	1619526420000	orphaned
28648	3NLDDxf86FfAAtgd2kEKN2R5nJcGwcovxJuSdKApmRYjmVascdCT	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	1406	1393	561	12463	18974	jwUDCCnfquhNXB9LxHJ9CkGf4774qsKB7bgwFcGPpdf6vpJ5z2B	14143	19929	19929	1619526420000	orphaned
28650	3NL2pFSCNMMxUdMk2HzJofYsiejMZE8zFV1dxRkatUy67bU2JFKV	28647	3NLGcNer47NykAV5MSJUmX9Rh5NPW3sVcSw4mEcPzhP3NudzpBHM	684	1106	561	12463	18974	jxa1BiVWAcLXf9ezfacGqTtmj4ABaZftqbW2NBDCf3kszoVZ4SN	14144	19930	19930	1619526600000	canonical
28655	3NLkWnxJWYJxEvFg9itaTv12hdrxXkRikMDMbK7P4rNt9kR2XvuE	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	1593	1346	561	12463	18974	jwL82pZQXjnNDw9LpmgVWB6kDGtLhdfoXka7B4793iBJKxKYmku	14148	19940	19940	1619528400000	canonical
28682	3NL6QRniz6jAFWbZA45JoLTtNnu5zJoWuzjt6ZQq57CnmgsJPGy3	28677	3NKnny9sMGLGRwm1TL6fH7uds3xSMEcih77yRj9ng8wjR2L5Bb2U	1553	775	549	12463	18974	jwHRpLHUat18boRNoS4TWSqhJv6tv5i4CvgeGAuZUabhgHGetcv	13887	19955	19955	1619531100000	orphaned
28623	3NL7CFambEjLDbDRbB7b7evvEurffbBkmu79KPe75fdUW3iEwhiw	28510	3NKPBdMJcw1sJeb4wqEjDy9upnSem3jWcJakbqjTCcef3ojDrJA4	563	1233	558	12463	18974	jxCfxMB8gQ2UR7qT71rcs4MvdXsPdcXqAFDyGeDxgsPjBeKKYp4	14089	19915	19915	1619523900000	orphaned
28660	3NKX4eKc38W8kFWFSeooQhzb9Jjsy8K1VwpekUPMCMYcHiXLMxJ3	28658	3NKaNEQN6ZeghcgTAnz2PRuF5pYaV8g8ETLnN4CtteFFVzgXoebb	563	993	558	12463	18974	jwo93XfjY4kA2m3mFtx8dSEnhrjkFS3NA3XWsPGRcDxRZHVjqMt	14092	19942	19942	1619528760000	orphaned
28607	3NKdTd9WEbX26vERkUe3AJDW3r35LTjnRqxB5Cq8xoJ7USMRHRLs	28588	3NKWgPGwh1pG9qSJAn1kkph7BamBggxgEtZvTDhQUTkgzriGEpam	1672	919	559	12463	18974	jx2aEkLJtzHwnRhHsoEhedWhYJzuKRCZ6kMJ1rqAggmLAiZbytD	14117	19907	19907	1619522460000	orphaned
28605	3NL1pNPcX5GxRZhDoJ4da9n5wavP1P6mmpGSSB3GcTFG1Dez41mo	28603	3NL21QoHQewLis9AP4wAt1KBvWo64dT6KGN3tQZi3ZhbYoT1sgnv	1483	1150	560	12463	18974	jxw8TPUtb1jBXLixDSS2nDZMERnTtUhuk4XYwmmUiYQ9JFoVFwV	14126	19906	19906	1619522280000	canonical
28614	3NKGEryn1wDM8YYSKhKKGUCMt5wqCuSknqrPBArTwwCzQvKXQggM	28613	3NLHKWeiyGuqcQoZDzYTf8TbsnvntLuwqfb3m3Q1XQBK5d3XeUvb	1657	1344	560	12463	18974	jwpMcL1FpsiwtWogGXRYc2tAp8HZthSG8G732uWiT2pCnt1R8Q1	14129	19910	19910	1619523000000	canonical
28631	3NKgVU71EVL5fzvAbXhPnww7e6eAUZ5uvEArA9SG5j6ArgcKYWPw	28629	3NLUgCMkcFZUw3QB8awJFXEw9YfGffhK1p7Dmvyny9iuVsJTohtN	1405	873	560	12463	18974	jwyJ8ZpLdbCgv2aFUKqXPsjMc52ideTVsykd7hwCw4P6b1sR7To	14138	19922	19922	1619525160000	orphaned
28638	3NLWEhXPkmDsmHRSAZbsxBV4N1ppEacC35U1Eghc2StxsunSoeX1	28637	3NLm2j1zc7qPfZxT5HJxTgJ2kXhekqq3AkcWVPVbCzSSYTBoiUjw	1426	1364	561	12463	18974	jwxKG2pXyEtpmh4FE7c3gUaD1dSB2fMXTkdtX72hZReUfSHDB4R	14141	19926	19926	1619525880000	orphaned
28649	3NL1Wb86RLXAb1eqHkyxYkKFzzhfbwFBYpbzzceVrEU3jSGjh6SA	28647	3NLGcNer47NykAV5MSJUmX9Rh5NPW3sVcSw4mEcPzhP3NudzpBHM	1467	1010	561	12463	18974	jxha253jKv4MWKJcixiAtG3pYqUgrgk3CBzNB38Tt6UH2e5K44a	14144	19930	19930	1619526600000	orphaned
28652	3NLVmWYQYXXvUqF1okqLsE6ofSWrTNVh9xvFG4kGn3ES84rvPV89	28651	3NKL4V8qT3U9GM9J7ji4Smu6iwJToeye6HpDn5Qypf6sEAAgTAYX	1581	778	561	12463	18974	jwgg3w8ycmeLyRFbkjMD38Lb35mB4QSoNYQ8SjJRNtmLTdysCcw	14146	19934	19934	1619527320000	canonical
28657	3NKiJZEKxzFYAAMEcm8khrwYkZF2ojS3Yzdw1oXXvCEAMWypdyVG	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	1596	1363	561	12463	18974	jwcmFwTuAjuF22PM45ZSU7xXZByXuFHtKkYmZ8Lbp5iHws4sJAC	14148	19940	19940	1619528400000	orphaned
28661	3NKKecESB776jdrgNhu34eQQiKh3szjEFp9J7MRQA63e7dSEX2fz	28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	1406	1393	561	12463	18974	jxkjM5KjAjoxDtRpcvwzSAvc7ay5kwVXRBJyX7R9UCLhrBvartk	14150	19942	19942	1619528760000	canonical
28663	3NLEcH82bjcBPLRx5RM1GuydEWZrB25ws2Kze8V4BMi3kTW2V7Xa	28661	3NKKecESB776jdrgNhu34eQQiKh3szjEFp9J7MRQA63e7dSEX2fz	1588	1392	561	12463	18974	jxas5AswzcWT9M7eDnFnpjjj8RKahcHeYTiHSvpxLCrhUD7RdWR	14151	19943	19943	1619528940000	canonical
28667	3NKHND8MYDpW6ptk4mGqu3D93SzU25sP9mNzHeSSoUGWkVogZaG4	28664	3NL2b8mT3a9q3jjhbveeAvYXmiGhFWP3ZrigdFF79sbEM9qFbLg8	1631	794	561	12463	18974	jxwpJzd1rJ8EB2RGqUz7enDyLtoyfhWmsvXyCoXNMiXQBcxojFS	14153	19945	19945	1619529300000	canonical
28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	28667	3NKHND8MYDpW6ptk4mGqu3D93SzU25sP9mNzHeSSoUGWkVogZaG4	1402	874	561	12463	18974	jy1rsyLVm6AitdcYbstmykHGLkJNRhwqNLxgTyrA3DmtehxixwZ	14154	19947	19947	1619529660000	canonical
28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	1610	1314	561	12463	18974	jwE27uyFAvNst5zTa2TzYJzjACTWfosurgj7pnF1kzCgEsgq8W4	14155	19948	19948	1619529840000	canonical
28673	3NKxup1roBVzHNRq5gfmxzFL9BdwAhXs8bpWhLhwx5qywABVHmgq	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	1578	1296	561	12463	18974	jxXK5Vfmz2P1ndR4TnBHJjEHSZgygLbpTX1aRykQaYZyoLuro5C	14156	19950	19950	1619530200000	orphaned
28678	3NKBBMQUw7AQX257CG9fwZarHDFRjQKoeAQ6ruhdqgDG2cvLUCJx	28675	3NKGSQtra5UsVnVGMVybTpZQ4DXDaNTYsvagNCiFUcfeiVERVEWT	1406	1393	561	12463	18974	jxtePFJmomZxpr7WeD9LexDcuF4isqoAfaMLCRCwVRkRfqXbecS	14157	19952	19952	1619530560000	canonical
28680	3NLw4WzdD2TKnHESXnRUZQV3YbDhaJWX6oYVKGMwzcBn1BwPYtD1	28678	3NKBBMQUw7AQX257CG9fwZarHDFRjQKoeAQ6ruhdqgDG2cvLUCJx	1406	1393	561	12463	18974	jx59nBgjMDHHGuv5yQWCnsxvjTumFDwjpD59d7VgPCAyz791Q3Y	14158	19953	19953	1619530740000	orphaned
28681	3NKtigbryVc3RecyR5jY7jLyhoTnbHEk3fU5dpRuP1aBtfo5KpeR	28679	3NLCNiVfaDg6wAuDDSWqCqh2XPGFfyFRHoJNCKmR6N7qJNZ7BiqQ	1508	1387	561	12463	18974	jwE4aqUQgpmUk3PRtmqCqvKNwgzaWyudyRuAGZ4Lj6thcfhJQDQ	14159	19954	19954	1619530920000	canonical
28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	28681	3NKtigbryVc3RecyR5jY7jLyhoTnbHEk3fU5dpRuP1aBtfo5KpeR	1444	1255	561	12463	18974	jwSLNaud47iK4XuS7dfqMCquBTaHUUxev8sJg5yQsAxkNkcJs5c	14160	19955	19955	1619531100000	canonical
28686	3NKyijieL166eDBUYATaJtvSzNoeuzHdTFpLVu6gMv2PF8SC8qGL	28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	1581	778	561	12463	18974	jwtBeUxb5dswMyY22yoP9nfmh2ossJcyPm6p7NCHto73jegKzsm	14161	19956	19956	1619531280000	orphaned
28687	3NKXxh8cbYA9fdBdNWU2rrhHMD6e3dpkmS3TJs8ZxkJECtAQjbCF	28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	1403	824	561	12463	18974	jx4pLJYBJEXJJNPvVGfxFjVKMyPPhkdv1Dxmp9wHHG4uUVqWYMZ	14161	19956	19956	1619531280000	orphaned
28689	3NLpBsW6FPtcZr4n3maQYWpTKX6jrKb2KJi53Kk9kZhDZX6YaFbx	28688	3NKNHqtzmTJ3fa8xQaxRUK84fG9Dkdyy5K86Jhdj4cgwepcWKLKF	1455	1206	561	12463	18974	jwbGuAqyqukKcDieX6riuEQTxb5qrgmS8EZdPmHgn7HirczDXz6	14163	19958	19958	1619531640000	canonical
28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	28689	3NLpBsW6FPtcZr4n3maQYWpTKX6jrKb2KJi53Kk9kZhDZX6YaFbx	1652	949	561	12463	18974	jwotgPEG8agCS6pe2wbZj3TtDGkC3AU1Nuy75oDuW3V1L4uyYYd	14164	19959	19959	1619531820000	canonical
28692	3NKgwGcRMQASnPVbQUFNB3JurHCZAunCR51Psjf18ic47nKy36Zi	28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	1588	1392	562	12463	18974	jwg9EnoDfhhJF165KXjfu5pxChWQYL1PNHkK55prbuTf9rJxi3q	14165	19960	19960	1619532000000	orphaned
28697	3NLXQ2PX9hNKqhbUixo5ghB9fnogmQqWsoBdoRJ6v6wPjXKYsWE9	28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	1489	1380	562	12463	18974	jx26DoZ5rPd3FQrWfxxjUep96ooy7GqTp2FLYTPY2JjN241QGU8	14167	19962	19962	1619532360000	orphaned
28696	3NKVw9Em8cPmH5QsbMAgEuUdYvMPUoCC9h5RNFUGurRd3sZYqkjG	28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	1489	1380	561	12463	18974	jwUEAMb3jGY6Kzk4idcxs19uhiXo9rn6AkgZnFRF3wuLAecG65C	14167	19962	19962	1619532360000	orphaned
28699	3NKKE5gVN4iUjXCcnfGijfWxyQaQKJoWaiEnsyQhdok81sABSLiY	28698	3NLVDNRo3fQwEBsKDMdcG2PUatcVreNCkpfv6LMgksvsRDR3nRQk	1405	861	562	12463	18974	jxZUsHpm7GssDwcaYBcRs2uayzTpJD5kRJL4xzLQEDZmZjQmFJL	14168	19963	19963	1619532540000	canonical
28665	3NLEykqhQoFum3zo8GxeFCUe7SwKibqhqk5NVP8ZAhgdqxbcYfd5	28322	3NLihba6daaGLK4mT1aeWq3zNRVGdyUvjwc8HQBXvBn2GTgtoPfc	1623	839	552	12463	18974	jxH7VM2q4h2MewYA4TZNSV7q1FyASb9ug2PNQTe6Nb4jrBFMRX1	13945	19944	19944	1619529120000	orphaned
28710	3NKWsSCE8n8gZDqCB9zTj1QADMPMF2nxgrM7vQtHwR8VNdjeipNW	28477	3NKmEaBSX9Nfgze3xXzvNrnf4oBWQBbmLa5RM8UiP4wxRZkSZt27	152	1330	557	12463	18974	jxB65SSYTMQWydwBPxMNnb8VJQNhJpAtQgFhA4qZXvooMLeAqq8	14075	19968	19968	1619533440000	orphaned
28672	3NLFYgYHbywPjGe92Yj2Kj9HyBuVwZnqc9ZWqdEYVnZfxcT7vnVb	28573	3NKKnnXp3qcxvtH5YuZcKU4ov37yAuZJonuGkSzWWM6EUMNG961P	1610	1314	559	12463	18974	jwpUG9T3SPZJbx2obKFZKTyzQcZanbe5VzdkTYMyeensb8xG8pP	14094	19948	19948	1619529840000	orphaned
28644	3NKqkbU5oxKAU2sWBz7F9VUMqcJgzMBNWjwkdGhVNUje78Aoqjmn	28641	3NK4HSzau3ZZpnDM4z8K4NxXC17rEAybdNzFBKey9515uvvRSdvC	563	1359	561	12463	18974	jxp3S2YsKG8MNPU7F5Wi8oTqGevbgA27YQ9qNBc29xz2wqqyXj9	14142	19928	19928	1619526240000	orphaned
28651	3NKL4V8qT3U9GM9J7ji4Smu6iwJToeye6HpDn5Qypf6sEAAgTAYX	28650	3NL2pFSCNMMxUdMk2HzJofYsiejMZE8zFV1dxRkatUy67bU2JFKV	1631	794	561	12463	18974	jwThra8c2snf25NiU35hd3NQWdWHKp8rLuLjX6vL1tWwEeEz9w5	14145	19932	19932	1619526960000	canonical
28656	3NKKouaJcGozNmfpxXdqJ6pqpkGhDca6XizKNLwBC1CSq1XtJQyk	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	684	986	561	12463	18974	jxT75FpeaShyBYGKYA1R957D4W7Kn3YM8Mn8td893RojrhB4RgU	14148	19940	19940	1619528400000	orphaned
28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	28655	3NLkWnxJWYJxEvFg9itaTv12hdrxXkRikMDMbK7P4rNt9kR2XvuE	563	1233	561	12463	18974	jxTv17u6ohgZTanwZ2Ex8HdW5F2sv7xTcse3yWDf84PDrW78mLy	14149	19941	19941	1619528580000	canonical
28662	3NLWN8mKftdRswSL74CxS46dRBdjGig1nPLkQLVBHsD2bSLb5aLY	28659	3NLg1B3z8wq3jdCozxjGDK6PJKxuhWd987FKerzU4b4hVz5g6pLK	563	993	561	12463	18974	jxinSk4srs7Fc1DiRWBEnCpFHoMJx57h4NXfVy2rEhWNeyygmNA	14150	19942	19942	1619528760000	orphaned
28664	3NL2b8mT3a9q3jjhbveeAvYXmiGhFWP3ZrigdFF79sbEM9qFbLg8	28663	3NLEcH82bjcBPLRx5RM1GuydEWZrB25ws2Kze8V4BMi3kTW2V7Xa	1402	862	561	12463	18974	jxPS9xKaNw8CRUWKCtQU3TDwnosupUxUQvcDZ61mXmaxcx3dp1Y	14152	19944	19944	1619529120000	canonical
28670	3NLNE6uqM8UEXMg3pRQMBoTziDrCbfX5JzNHMrqQY74BoH6MvsAQ	28668	3NKo43Lbz1T2JmEvDBCr5ARZc3xY9pnYSW8dsR2em8fqtgoVfp8F	1607	982	561	12463	18974	jxuXuawZJJAzqMKwjigGcY9zpwMzGg3CBW71wchLSEb3oKs5eM6	14155	19948	19948	1619529840000	orphaned
28675	3NKGSQtra5UsVnVGMVybTpZQ4DXDaNTYsvagNCiFUcfeiVERVEWT	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	1460	1078	561	12463	18974	jxbxbGL4JSJBR41QPtEDaCGYDRU8dzvy465LwC9eobJkQjePqUL	14156	19950	19950	1619530200000	canonical
28679	3NLCNiVfaDg6wAuDDSWqCqh2XPGFfyFRHoJNCKmR6N7qJNZ7BiqQ	28678	3NKBBMQUw7AQX257CG9fwZarHDFRjQKoeAQ6ruhdqgDG2cvLUCJx	1407	1395	561	12463	18974	jwuJAznGbsh7rKJrJrDcee9YHVqgQNyBKHPLVHxjWUX361Teamg	14158	19953	19953	1619530740000	canonical
28688	3NKNHqtzmTJ3fa8xQaxRUK84fG9Dkdyy5K86Jhdj4cgwepcWKLKF	28685	3NKxGBnceQc9pXhom1yyLteCfHyHWPRtdnv7HLg16S4VQWZf2W3A	1471	1140	561	12463	18974	jx3ypkE4D1mqZZKoDZMkUvVJhmLyJXB3T7CCKLtp6yxJCSTgDoU	14162	19957	19957	1619531460000	canonical
28727	3NLbxi3wp1argtCEd3NN5Znx7THHcsgbpcdDp2v2SmPnwGdv8qgh	28688	3NKNHqtzmTJ3fa8xQaxRUK84fG9Dkdyy5K86Jhdj4cgwepcWKLKF	1403	824	561	12463	18974	jwiZdo1i95F8BRXafdMV2zkYSTHGAjPs2sLt5q1HaJHNS7W3KUU	14163	19972	19972	1619534197375	orphaned
28691	3NLLwvcoDQUZyxgGrfRCZhZmbGoHVezpdwg2JSMcXxq3GBZHANyx	28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	1647	1176	561	12463	18974	jxmfZWaffWPpshLK58HDVUzRHr4mnoFosNrNgppbADeWUC6yKNP	14165	19960	19960	1619532000000	canonical
28693	3NLAjRyANbMhjXpXTH9DZDZQPAU9cckU1aMpknL2CdTH7bcjx4Sw	28690	3NLWKgXsxZbep7LFGCVTM11M6myTGxoEJwynAgUhRFJHy2BohFgG	1631	794	562	12463	18974	jxbkyYVTUw9T71Q46FNxX1Jkq25VTWsQ6HnKSyb4BkyfxkgESYd	14165	19960	19960	1619532000000	orphaned
28695	3NKRraViHhyDhpcJV4FaQcgduNcQmSQVA66yxo1z81NAUigcQVHH	28691	3NLLwvcoDQUZyxgGrfRCZhZmbGoHVezpdwg2JSMcXxq3GBZHANyx	1602	1369	562	12463	18974	jwuusEP9d8TinyKLKadL9deKq1gqWhMd5TamGEEkhDNACVTucdE	14166	19961	19961	1619532180000	orphaned
28698	3NLVDNRo3fQwEBsKDMdcG2PUatcVreNCkpfv6LMgksvsRDR3nRQk	28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	1489	1380	562	12463	18974	jx26DoZ5rPd3FQrWfxxjUep96ooy7GqTp2FLYTPY2JjN241QGU8	14167	19962	19962	1619532360000	canonical
28700	3NLZUGtaXqJX32gytKvKHA7YSRzXMAbzBaWgkqgxL2a5Jka4emrg	28699	3NKKE5gVN4iUjXCcnfGijfWxyQaQKJoWaiEnsyQhdok81sABSLiY	484	953	562	12463	18974	jxmeKMnABHX9Kv8Bd1DfTkeWDysHRBaxA478cVz4jScXTej1X7d	14169	19964	19964	1619532720000	canonical
28702	3NKbbRT1g8QL3WW4bSEbbcjXWMG555H6bN9D4z2guM6Y8KPR6hnu	28700	3NLZUGtaXqJX32gytKvKHA7YSRzXMAbzBaWgkqgxL2a5Jka4emrg	1649	1649	562	12463	18974	jxgH9w6hH6RiSDhLBQsQaLprQpidwn2ZuMTBXLoFpxU1ZuK4rP3	14170	19965	19965	1619532900000	canonical
28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	28702	3NKbbRT1g8QL3WW4bSEbbcjXWMG555H6bN9D4z2guM6Y8KPR6hnu	1406	1393	562	12463	18974	jxX1pwivVJYDF3N91BZdr77DAGrCj1wCbdxwnxLB1vtZqnBELr3	14171	19966	19966	1619533080000	canonical
28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	1529	1070	562	12463	18974	jwJ7SpPGybLUCqTRZJxMSeXofzH3sAnR9cAuon3NF6rk5EPvjet	14172	19967	19967	1619533260000	canonical
28714	3NKGmFCygSo3ww1C5xukpDi5qiMSzPwPSSEkH8SveZYctiCH1Yow	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	1406	1393	562	12463	18974	jxtQBfFG5Byqx3CiUABVh5THLX8vKoPEdQzEciLr4zfkx5EMibP	14173	19968	19968	1619533440000	orphaned
28720	3NLP5u3bvLwnbXb62dtH43C1NzsPF3B2ArckZyWzpQsEUK5hmuyf	28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	1451	1292	562	12463	18974	jxBwfXqprdm6KfxNUDgXrDj7W1ygQX1NikVyvTqZyUWZTDGkDmd	14174	19969	19969	1619533620000	orphaned
28722	3NKFTQ18Wbgw5mEgKXYUEBJL2rEDRNHNS46nVM2VCEgugeE6rVeU	28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	1654	1094	562	12463	18974	jwYbzNrxuW8C5UFn441sMYB1saTCJBy1bgkQqAhWzQb6S7dt34U	14175	19971	19971	1619533980000	orphaned
28733	3NLgoL5qisXvob9heviTtvthuRr4ExcTFuzdrHQ6pYQF9AxHv96H	28731	3NLr6rPAWR6F5Pq4Co7ZsX8Mi82ZkQgX6Dkhx8ErfYvUWJ1Xvy12	44	1199	562	12463	18974	jwQTKuwzMQ1vHuuzaekU5DJVqZ5eMhLuC37dTYKLmV28J47VhHj	14178	19974	19974	1619534520000	orphaned
28735	3NLATTKVfyeXYMuWPDXknu12k7fPESPP2RcyrrQ3ZnSvhm3jBseF	28732	3NLjFXFy3BnhB7d62jXJ2UbCL2xs4BXmEYpMq4sYhUePeh4Doovs	1609	1087	562	12463	18974	jy1yo8jpCK5n2hCqMA5Wgvgm3C4SfnZrDUAx5rENzL9eKXh5DrU	14179	19975	19975	1619534700000	canonical
28740	3NK6KZisfAmXws15Q75UW4yBTGo7cxymCggBtb8GQHLuxdfqQJAN	28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	1407	1395	562	12463	18974	jxjVPpUXRLfKtUZq7xZpNYBw7UfMjizyBTvfSiWVAhxfSs94VDB	14181	19977	19977	1619535060000	orphaned
28747	3NKmtdUTyoZv3FkQuRG6E5tAq1KhrzMW2cAZptsQJTPSVrctxyv4	28132	3NLvnqF2drXrmAFAhwFdGvgWkhd9QjXWS1SaS9ugCYSnQcr1gLTf	1553	775	551	12463	18974	jx4RUwNpzMMZpdVGpqSyRemu9ykk71J9LB5aHr2iaZH5Z6bvoNx	13906	19979	19979	1619535522330	orphaned
28658	3NKaNEQN6ZeghcgTAnz2PRuF5pYaV8g8ETLnN4CtteFFVzgXoebb	28643	3NKUEZpXi5su5BywzXqARqLDjTLY7moZ1bdVYjHTJjueQfC7L2NJ	563	1233	558	12463	18974	jwyDrbkW3AxCY6nhqXU8dm4Br53vu9NA8HP7DZ69U4AhXM41mBT	14091	19941	19941	1619528580000	orphaned
28718	3NLx6mBTVPcQAEQLac9cSHy7jvHE4GG89yMusenWY9gtmFQjmdBW	28592	3NKFZF94EJvA2zdLL2jo5dq8QFkto1889njinmNHEPfTRdoNU7gq	152	1330	560	12463	18974	jx8agZkYFc9m7yK2puVtn3WM31G4va4fWeiwB8SK75CFhBaFLh1	14121	19968	19968	1619533564243	orphaned
28647	3NLGcNer47NykAV5MSJUmX9Rh5NPW3sVcSw4mEcPzhP3NudzpBHM	28642	3NK4QotnnbLt5vFNc9WMKQH94VsixVmQB1WuMjJy7FpAk25PogcH	448	1059	561	12463	18974	jwsDfNzhDcTc9eV43g8WiYx7hzoHoqQ7uJ8FUtN7KL44iJjquu2	14143	19929	19929	1619526420000	canonical
28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	28652	3NLVmWYQYXXvUqF1okqLsE6ofSWrTNVh9xvFG4kGn3ES84rvPV89	149	1037	561	12463	18974	jwedTkQtsXGRet8mj8uWJJ11C9S88RzNF6NPG9GSaHBi7DiViuQ	14147	19937	19937	1619527860000	canonical
28654	3NKnXwKa5B1vchgKfi3ycicrFPX9eXLdDZPMK7YHaoSxFePfEwmj	28653	3NKtCgBz7ma5BcvCMdMdXLAGnWESSCXfK9yFQ6TzbfwPgTpCNE1B	1407	1395	561	12463	18974	jwWy9FCUKBZNBrWtiE5nybGgsbXUdKx5THxqbYi6wvSDvVYFn6s	14148	19940	19940	1619528400000	orphaned
28728	3NKNg7bgCjjjeC5UBC1UChcCkZqQ83CYivHTVvTZk1gaUGsMVDwT	28655	3NLkWnxJWYJxEvFg9itaTv12hdrxXkRikMDMbK7P4rNt9kR2XvuE	1403	824	561	12463	18974	jwrBwcTTqgDSM9uLaNN7Qkz5Po7VhRmdDjWmmBeddKQg9i5S4A1	14149	19972	19972	1619534160000	orphaned
28666	3NLcNSbRwSua69xhnqJUJYqGenqp33VuPhAAtXxZz1DK9rrkA9A5	28664	3NL2b8mT3a9q3jjhbveeAvYXmiGhFWP3ZrigdFF79sbEM9qFbLg8	311	1307	561	12463	18974	jwPwRZUgk1cJ71DPfQbC7hZd9Ct3MPwTkmMwggWMS6vnkRvCCGg	14153	19945	19945	1619529300000	orphaned
28674	3NLbSMCeUSHSa4u1YKAoWNmUSDU5ZUE5KyX4eDSr3MYzt4zmCo6J	28671	3NLSatyWiELdFf1A5jWA1ChncdP1t5jsbYSRrE6qqzyjDX2SJanm	1672	1285	561	12463	18974	jxD4S9hfF3bfMy2EctaLScKGuDTJhooUeeJiNvRvkALmLadpFYH	14156	19950	19950	1619530200000	orphaned
28685	3NKxGBnceQc9pXhom1yyLteCfHyHWPRtdnv7HLg16S4VQWZf2W3A	28683	3NKkdVHGSQGoxjh1Dj958bjaVvNWQ6DvwPRrkhWQCxKsRQoycza6	484	1073	561	12463	18974	jwn6wmv49JLzxv2mRYwkNSuGsEWdEyE7nqqBqqNSViz66HEH8fZ	14161	19956	19956	1619531280000	canonical
28694	3NLQxmoGz9MrL48BYKN3A9YDmbW5QaoVy1tHX1r98oTjGA58jSZ1	28691	3NLLwvcoDQUZyxgGrfRCZhZmbGoHVezpdwg2JSMcXxq3GBZHANyx	1602	1369	561	12463	18974	jwPbtcUkygQ59uQ9jiGUqUVzuuX2PHh2o3SAk1SMtMQU8RoCrMs	14166	19961	19961	1619532180000	canonical
28701	3NKmcvDDUy4dhMbpRUJnY5MLKLrbafMKc9R85W8k3mLCpT7ftNLR	28692	3NKgwGcRMQASnPVbQUFNB3JurHCZAunCR51Psjf18ic47nKy36Zi	1649	1649	562	12463	18974	jxp97WcZbUDjNzCtv6eNXUZ8LGUbJousWHV6Wq6vQ92zQRLNwhK	14166	19965	19965	1619532900000	orphaned
28706	3NLjfWjgdSCvudGpmTPsoxmH3rymDMYCDuavmZgGNeViAmSuMg8Q	28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	1529	1070	562	12463	18974	jxgVUHwCLra622XyPWsUr3XVKTHwWG8sTaY2wAoEZnZhcnzSWcc	14172	19967	19967	1619533260000	orphaned
28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	152	1330	562	12463	18974	jx5YrakEUHhskyiZu2thMKBDGgEwJM5zLV6tzLbXJY7tTZPwvDd	14173	19968	19968	1619533440000	canonical
28708	3NKbL9YhDv9d5G6r7TkhiC73svMx1KD1RfG7616ziprQBaJqsUAR	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	298	1308	562	12463	18974	jxpwuzxQCKiPVQWoxud95fmktRF7eDT1r5NkVGQabe2Xp5YDhQG	14173	19968	19968	1619533440000	orphaned
28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	1451	1292	562	12463	18974	jwWDdN4r8DqgY3t7vukRfvVgqRnvJVssDVrtvBmpyqtJumtjmry	14174	19969	19969	1619533620000	canonical
28729	3NK4kXGYbHcYaLgCeK3eYUKMiPHgdz9FG97year9qCe45DHGVACC	28711	3NLibEJPpK8pQTPaeajSM2T943kGQ3z3N3T4hHnPffJ4wuGEWJGG	1403	824	562	12463	18974	jwGQ3fkgkdL843qhGhig5iLrzGSbPs1NDpVjdYyHsL8K9BrQE1u	14174	19972	19972	1619534232627	orphaned
28724	3NLwa9DBo581cmKjNFZuxSeXAPuRFMgicV2tDGyzfwKX2q2vepdC	28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	576	989	562	12463	18974	jwHy6p7QM7TY1XpjaDJf7b7MmMM76TZRdeHjorCTbGEXdtLYbYM	14175	19971	19971	1619533980000	canonical
28725	3NKDNh48eSnUT5njjoXnPxna2he4XLJYRUuGQcXcnv3qzX2LZYnA	28724	3NLwa9DBo581cmKjNFZuxSeXAPuRFMgicV2tDGyzfwKX2q2vepdC	1675	1216	562	12463	18974	jxRdTqxMfz7DbYi4bVEKAY6mo2YTXi9g9onsx1QPWf7ht991cED	14176	19972	19972	1619534160000	canonical
28731	3NLr6rPAWR6F5Pq4Co7ZsX8Mi82ZkQgX6Dkhx8ErfYvUWJ1Xvy12	28725	3NKDNh48eSnUT5njjoXnPxna2he4XLJYRUuGQcXcnv3qzX2LZYnA	1407	1395	562	12463	18974	jxqQQX14ipZZqmN5Kx3eKLHwUEqHEi7Z2iUj2je79XvAZLS5T13	14177	19973	19973	1619534340000	canonical
28730	3NLJTrsk13is531CaAvs2HBg5r4hMXcz4bNwH55hcJgv2yJNEGdn	28725	3NKDNh48eSnUT5njjoXnPxna2he4XLJYRUuGQcXcnv3qzX2LZYnA	1609	1333	562	12463	18974	jwU189kGZAt6cMeCGc7e7syj1if9M9AxzGMSnxsZSK26M1dsPWu	14177	19973	19973	1619534340000	orphaned
28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	28735	3NLATTKVfyeXYMuWPDXknu12k7fPESPP2RcyrrQ3ZnSvhm3jBseF	1406	1393	562	12463	18974	jxZSMsBj9UsgUnYkhxyvqrda6xWMTRUjP2raGxy45aMDNZHoaMx	14180	19976	19976	1619534880000	canonical
28736	3NLLacAXYUwoqPMbwzvNBtLomZ3Gc2tXLn814tLXSbZ73EGxYFh8	28735	3NLATTKVfyeXYMuWPDXknu12k7fPESPP2RcyrrQ3ZnSvhm3jBseF	1483	893	562	12463	18974	jwvEfxoQ3fWCP5JybpEjQNiHv1jNRydWgafBpTUxF2gNQ89BhAg	14180	19976	19976	1619534880000	orphaned
28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	1536	1067	562	12463	18974	jxgr4cC6bZLso8MMscZnpJYKdouiVdUsTaKVnVBxz6h4oLpeA1D	14181	19977	19977	1619535060000	canonical
28738	3NLCSwfJ6QkMnqizq9PqtJQ78sHJPEDhQrdjTMwyNtUyibveSEHV	28737	3NKtfW6Nn3vDBLUxSiJ4whMd63m5bqojZ6TQAM7pmHc4svwYV5kZ	532	1303	562	12463	18974	jxtNgTWHtneM1UnbzsiZcsMsGgSULaoW63DCFBwAt7brXAsCzSk	14181	19977	19977	1619535060000	orphaned
28744	3NL88WxmQYKrLr72sEfcBRAr82v3Q9aQSV9aMWGQ2kkHSs6q5KVH	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	1407	1395	562	12463	18974	jxFAAYqdgGdpUA8eXCsFuYsq2iCzQwF1rT4bKmCttFbnqgtsN27	14182	19978	19978	1619535240000	orphaned
28748	3NKyjkbZWN98ae3iEmJnwAzRwb6BCQq8FcWGdEQ4gieyqW9co3Nj	28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	1451	1046	562	12463	18974	jwtFnmQzYB3XBixhN7tFsGwa4twgSiMmupoeuWfd5PwbedAhvyh	14183	19980	19980	1619535600000	canonical
28750	3NLwDV8jCAxhaPimV1CcE1r8DQrCNve2kB4Pwhgcsq8virhbtsMm	28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	1407	1395	562	12463	18974	jxL2J9WS6iDUriF1Tx2fbh42bZVpPKujq2Tofd14paMnmpNpngz	14183	19980	19980	1619535600000	orphaned
28759	3NKr2Dt6ieoim6iwByCz4gcxGK1jyiVq3rgS2NBNQwB8xoGuTRAE	28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	1422	1337	562	12463	18974	jw7znbbodFwbzxZ27WZ1RdGdmbU9URuWyzSb5jfXh75KVTXKtpi	14187	19984	19984	1619536320000	canonical
28754	3NKSC9SM5dZ6XbpzV5rvQbR5x1EzuyxN2NEKBUiHWWKEiYDaKFGS	28308	3NKrk7pnGgo493Ma15FNPR3JgozUSwxmCmtBWHmTvT4YLc1ERkGg	1553	776	554	12463	18974	jwnCLGENyp1BLZkmxKTBvRJFKg3MyVK4QQDmvRwkt7RLT9BCMVh	13995	19981	19981	1619535890792	orphaned
28741	3NLbkWwcTaaktE33vaa2Hdjf5FsB7bz6q7qyE5HKr4dWSeZkUXHd	28416	3NKVvMzj6x1yBK36oCXGoAUPjNsP2NPqAG5x2LhJFtChJNa2PMgK	532	1303	556	12463	18974	jwLpL5xnrdSUhuppHVmoACbbDszWPPuR8SP2GqJaPx11Znhf3aX	14044	19977	19977	1619535060000	orphaned
28715	3NKkYKUJko5gqaBM29AbPkVdN7rVfkVrNBtZjtvRAhEUAmXSVLuH	28519	3NKwWDXN4ip3PA9oCW37hFDv91EEdsqXW7Ah4m3ZLyjDJ5HftvEw	152	1330	558	12463	18974	jwPu33DgmkCYYkuruJrVGnqbPMYQ8PMjKkFoxb8kKwxQ7xeVJ8Q	14092	19968	19968	1619533482257	orphaned
28717	3NLJ8GeJBBVjBWzq2sKbtD75BEcx3B76wtc768ozFt4scccycFsi	28557	3NKhw5WtZVA2M9F7z33rL72zJ48GGw8UrinLbknJG5nTCVfQiHsu	152	1330	559	12463	18974	jwUoZVg42wrBodWqGu4uo7CYbxec6SD3VtpaUyNm9kDKZyvRBKw	14107	19968	19968	1619533523114	orphaned
28704	3NKCpP5KevpAUdEUb6aN2SGBh76oz777QQVuv4KR8Y7S5NNHdRte	28703	3NKmHSxnVgUgoL5YxEFjoj2YAcTUNVWHX8tqE5WkeYJStvgMFN9C	1529	1070	562	12463	18974	jxnpB4jsJpTSAnpRRXEskaGKZwLdieLm1hsFmvDoEkLeDpbDFyM	14172	19967	19967	1619533260000	orphaned
28709	3NLEWs6JHFfSPriwSneRj2JsMWxpFUsiZ7HfgGxkEUh2PCoXE2Tg	28705	3NKx1xysSadrr17UsKNv8fTNsri5A1aVsg6qf1S4ETSEQYayjnci	298	1308	562	12463	18974	jxFht3nTv5xCwAsNrmobrfjWGmLDRuScr4nAqAvP1fJw1FYjxrq	14173	19968	19968	1619533440000	orphaned
28721	3NLJKwBTo15Q1VzZSQMLw7fUhJLsULvunWTXLRstoHcqPZ2S7xrH	28716	3NK4qcR75CabUscrhi6sKUiqVCgAVGZJUyzj9T9AP5k9t1AJUmcr	1631	793	562	12463	18974	jxRwNPHy1UK8xtJqoQDAmDv6TRQmkcJd4HYsVR5moS3AHPkoAEK	14174	19969	19969	1619533620000	orphaned
28723	3NKhpqNb1NFzk1LuZkQjvyLYB7W18VZRZaEbhxQWzVhG8Cyaz8bt	28719	3NK4rDP4TjBMFdfSeEQ42kiu87btmNQBwekigF5Kb1TgSgip174F	1577	1327	562	12463	18974	jxFgpHPQwrs2hdKmUdfBCxFB6csMXgKbsVZjvpwdGymfcaoah6F	14175	19971	19971	1619533980000	orphaned
28726	3NLZ7Lg98XMWBPfNFGjggBu877wiJ8A5BJThbmzMuuLqHtZYhb6f	28724	3NLwa9DBo581cmKjNFZuxSeXAPuRFMgicV2tDGyzfwKX2q2vepdC	1637	815	562	12463	18974	jwcDdyGxZvR85UTTqBALcV7rRTatVzRkuSxZ2rk1rNpCnpihXmH	14176	19972	19972	1619534160000	orphaned
28734	3NLBJtonqEbNNkJ15Mzuzt2v6oMqBmppWNSmoKP6EuxeQwnRmNyz	28726	3NLZ7Lg98XMWBPfNFGjggBu877wiJ8A5BJThbmzMuuLqHtZYhb6f	1403	782	562	12463	18974	jwEKh9YoorGR8HeTmZJAJasUVwT7LiyfFKdGWNeFi3e7kGVuDVw	14177	19975	19975	1619534700000	orphaned
28732	3NLjFXFy3BnhB7d62jXJ2UbCL2xs4BXmEYpMq4sYhUePeh4Doovs	28731	3NLr6rPAWR6F5Pq4Co7ZsX8Mi82ZkQgX6Dkhx8ErfYvUWJ1Xvy12	1549	1236	562	12463	18974	jxD2dHdk2KxXpgqXppRA8WrqQDzr4qCNDfcMA9tYXKWZAEo9bvz	14178	19974	19974	1619534520000	canonical
28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	448	1305	562	12463	18974	jweAg8pMSckF6GpRQaKqTncYi2AVtyVd2RdvQP9Ha2nv6ZgbVVn	14182	19978	19978	1619535240000	canonical
28749	3NKBsPdshoKdAvDu8kdGvsNnnFXSw39wDwvzksz2HfMTNaW8yuLP	28743	3NKziekGSTtx7Y6WD7eVGAmazwnKyEVfau74VcZbHweDsAp9864N	1406	1393	562	12463	18974	jwEAow8cnAyKTH1pzXHhNYKxsey6DZecvXPevcL2tdxsdzteb9p	14183	19980	19980	1619535600000	orphaned
28751	3NL4zQ4qYXjp6x46JqHeYbc4Cp5DUoH2rjbk8Fvuhb1P467zxiB9	28748	3NKyjkbZWN98ae3iEmJnwAzRwb6BCQq8FcWGdEQ4gieyqW9co3Nj	1509	1194	562	12463	18974	jwqkDy9AY13fwqWmFJZV8nSKAcTk8aoHmttcM6mwCprVeJYpRMm	14184	19981	19981	1619535780000	canonical
28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	28751	3NL4zQ4qYXjp6x46JqHeYbc4Cp5DUoH2rjbk8Fvuhb1P467zxiB9	1577	1327	562	12463	18974	jwAndVkS1qM3BN6Uuz37MzDQM5HTEvGGYPVXWfr6m3jRUQrTLmG	14185	19982	19982	1619535960000	canonical
28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	1467	1376	562	12463	18974	jxNmRKUY6nMg4ZBvLLs4B6mYJ5DKuMqYakL8YU9q4TEoc6ShuKM	14186	19983	19983	1619536140000	canonical
28765	3NLiLkPxH48tLCmdGMr4sFFspMW6G8tBKMf5fqht6YMohxXDMsE2	28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	1403	824	562	12463	18974	jwrsZjTzQ9nSaZGVXPsT2Avvn9bk9ST5PmsDv999WiAdywxRTGt	14186	19987	19987	1619536995832	orphaned
28761	3NLYJLR8RQjgg2bA1QLLUQ3kxALhdPWVd2z5dAMSUSKFFYu5oTJx	28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	1440	1251	562	12463	18974	jwD2wahyzgvxeAkcT2c45A5qc25xWGkNosrroPhrsCJbk6gkLFw	14187	19984	19984	1619536320000	orphaned
28763	3NKc7iUGEdRTDSKknK8HYkzBzg9hvKjrGdUCsPGkQriCQx8637L2	28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	1553	776	562	12463	18974	jwUiH1B1yu24jBBhpjz3gV4NNhb6QUHAEY726STzzodwRPR2S35	14189	19986	19986	1619536680000	orphaned
28768	3NKiGSj5CnrDfprVJDqWqW1eLsibQXfC1jAFdC6acR5iKUSiHDqe	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	1523	1075	562	12463	18974	jxTYUTC1hYmXCrhMvDQsHHs6jdpSMyYNwLp5kiiZW5iKwgqrtzv	14190	19989	19989	1619537220000	orphaned
28770	3NKLqxVSLHCFG9vUY7TFc9ZbwjtaLAdLBv3BHcyf44fhQtFYckR8	28769	3NKkdfoqpPwV9EBxtJrAFaehSrcwfyP5XzByfPSZWRBTjpR1kbR8	1647	1056	563	12463	18974	jxT191yrfsrG9dXWkhNn6RYoR5iwqeBFXw1QHCQ52XVcPVKjBF1	14192	19992	19992	1619537760000	canonical
28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	28770	3NKLqxVSLHCFG9vUY7TFc9ZbwjtaLAdLBv3BHcyf44fhQtFYckR8	1422	1337	563	12463	18974	jxsVCvmLZBGt7cFeKpAV1xpSLa3eqXux5JmemTYNaynjV7Ztyi4	14193	19993	19993	1619537940000	canonical
28773	3NLeHpifJVMxurSZUeqbtHr8wX8cjzpdFoZyFp2wf5at36QyPcQm	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1403	824	563	12463	18974	jxce3f5ReLfW4eL4JrsdogNtiG35YJqPhHGtN7DgajikFwvLy6n	14194	19994	19994	1619538120000	orphaned
28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	28776	3NKvqtDKJ7g7i2GspErgm5vGmY6YhyenEbjz3EcxDb2kbL6PiXWA	1474	1083	563	12463	18974	jxFm27PwG2qGt6N2jxLeUqJBLCzoc7TpGJQC7MsWEsFdNyY8Jcs	14195	19996	19996	1619538480000	canonical
28780	3NLT9K3dprzxz1QzVT2NruUCAP9bPcK7LzjhYRRS8MtuCJF3RmjT	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	448	1305	563	12463	18974	jwALfAb4ei5Y6K98j3iVWEE8szNpdzY5Tv4WTRJxq95ADmaXRNb	14196	19998	19998	1619538840000	orphaned
28781	3NLF3LXhMej8GSu9zR5h2CSYQP9wrKimuUouwFsuHq1XbafBZwRf	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	1439	1033	563	12463	18974	jxKd3rkS6SJeUB9wZPoJBjtWEuKzoAfa5671QmgJHwyRUKqxpVk	14196	19998	19998	1619538840000	orphaned
28784	3NLy2wWAiYihd4mTovg9HtZ6Fzs1SfUmFeLKS4aE1pBMdW5zSBCn	28783	3NLsThMMyRquo6WMo1rSrXFnAAd1hsPzJVhfPzMT1EkYwdkN6EY1	1671	1365	563	12463	18974	jxqNYDtjaq5WY3GYoiDCEQpuupPz75EZ9fdo1r9o5wCQ3ysfwGn	14198	20001	20001	1619539380000	canonical
28785	3NLuKt13F7WwQVtvgVU4gTJKoxVU4YGomdu9p3RmRpXBXk9a9XQf	28784	3NLy2wWAiYihd4mTovg9HtZ6Fzs1SfUmFeLKS4aE1pBMdW5zSBCn	1506	1127	563	12463	18974	jwTSUf2Zbcn8fwfvKY16tXG6ozfC3qgdUdP7HGozRwDq88SAT3F	14199	20002	20002	1619539560000	canonical
28796	3NLxYZvRJPZSmfP2nwK8o9hXyJ12yFb2xwP9sKumJ8yHfNpJfYUf	28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	1607	372	563	12463	18974	jwASmQcWcMEu8YvuZGjbq97oDqdJhgy14ds7M9Jp29jn59Pp6w3	14206	20012	20012	1619541360000	orphaned
28800	3NLwvJqFUL37khtg9uTyV5feBxKRrZLR9tVbs8WEGSYhqFjgBmWo	28313	3NLB1TmhrRxxWdfVswdw4TukVFfFFiDMQZ1otUJvEZiXBsMvhbDF	1406	1393	554	12463	18974	jxzCxXZN7EiBStQnrEEra3PFVWBDMDLoF4uYzhuukMjWbmAScCW	13999	20014	20014	1619541720000	orphaned
28801	3NL8U67cJeYdszYRpRRwPE6trjGjgJLjLFYU4Dy8AQVAgjBfn9pt	28343	3NLmmaDSucbyHEaTDxDkzv6eTjEbmpNsNvppSbvdnorHx999VaCS	1406	1393	555	12463	18974	jxZfstks5q7fwJzQ9KPZ9wGRFKUjVWi5aWeGnW6XFrvuHCDLVCN	14012	20014	20014	1619541755872	orphaned
28803	3NLGzsa9mG3kN3RT2oVBMd42ZsnyY6FB2Sv1SxnurJrAGsbM7gRb	28365	3NL8keG4mSHiYBGeDnrvYuLZ4rsS3rguso5SsNqTovNXCRbgw8pk	1406	1393	555	12463	18974	jwm4r2jpYNk2mD4th9nj3gnyNT2dxZGJjMCRwaND59Hce4ip23a	14024	20014	20014	1619541792267	orphaned
28804	3NLduaAY5FiAMSKhBsSz9KCqZVVSSUWxZojZNGJjxjyhJDwNN52Y	28398	3NLwWJxwJCWZ4c3uZENRqyNHjZdyWKgngEcqAjaACvq8db6X4bJg	1406	1393	556	12463	18974	jxdgw5ixV4T8uCUxsSKn8fPnHS2xismnoh8nWnw869fv6G4MQr8	14037	20014	20014	1619541829297	orphaned
28823	3NLGNa3y2QHBrGAh1Bo2zhRAMtWimrbjca1jiYdKZsEkqoMGTe7m	28685	3NKxGBnceQc9pXhom1yyLteCfHyHWPRtdnv7HLg16S4VQWZf2W3A	1500	1051	561	12463	18974	jxmcLuTt2NHtfskTzDEakVeVQD4YmR1BRf1tSgcQocumVhkVAe3	14162	20026	20026	1619543880000	orphaned
28742	3NK3MAU6cNcED91wknDugNA1AzDSpiDuNsBnYYaSH9UvhVR6oFWj	28739	3NKD3Yob3BC5euSR1uN2RcMcBxD21R3AZkTphGRy63x69Dopqme2	1506	1247	562	12463	18974	jwM5nJY1iimWuTbNdfhcY2UHzXWuyhtiA3Wkps5AQdpi6tHZPCU	14182	19978	19978	1619535240000	orphaned
28755	3NKULnb6jb5aCCBd3iQG5fys622ZnJx1NtRNW2KSum2cGHrwXnSQ	28751	3NL4zQ4qYXjp6x46JqHeYbc4Cp5DUoH2rjbk8Fvuhb1P467zxiB9	1406	1393	562	12463	18974	jwPUYgdFaN5565F6go69vwQJQnLfHbtthTNDJt9vbD6DkDxJEbF	14185	19982	19982	1619535960000	orphaned
28757	3NLCcmGfrt4jAtBVudJvhd1PzfqbGrKUoHKaL7fztcpL1GUXgRBY	28756	3NKwL1wuSbqYi7xfTGTzTYKjJH8CMaRimB3odHrAJXt3oPR3rfbL	1403	824	562	12463	18974	jw9KBUMJjZQ9gZp5xg5GZeqeQhfSYnihqSryMnwPhC4VUA3kAT2	14186	19983	19983	1619536140000	orphaned
28760	3NLRkGqRJyJwychZ9gahaHzrmuQSjE2jtT2UdU2mzYrLRMR9R9zK	28758	3NKShiNNXjZSmRQXoNcsWSZNh3GMJgMKxNfBrVKa9hP1FEPVEmag	1440	1251	562	12463	18974	jy1boPSCjvmSvVaJCrnhMMicRUtTQ3EbST44BVXwGb5TSy1DVS4	14187	19984	19984	1619536320000	orphaned
28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	28759	3NKr2Dt6ieoim6iwByCz4gcxGK1jyiVq3rgS2NBNQwB8xoGuTRAE	1631	794	562	12463	18974	jxnQuGtAYfVkaxUmNeQ3B1xnQ9TqkRiVKxtrvwFwnA6uvJgBG5f	14188	19985	19985	1619536500000	canonical
28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	28762	3NKZt1B8dvd4eS2HaDvxhgpHhVr3oUbyqmGdcEZavbpVcF18z5JY	1599	1287	562	12463	18974	jxiKrujqR9CyTja44cBCeejqBbsgfpfmMif2i5Sdf1MMCraaSSm	14189	19986	19986	1619536680000	canonical
28767	3NL3cdWNCwK3t8aRQqyL9WCgmvt3SCRvwsUW1nwfhdVqG9gQqYhA	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	1523	1075	562	12463	18974	jxn9Q9Sv9r7PcsRHwbpUDX868tMpp2NcD8dahAazMvkzLhJrtnu	14190	19989	19989	1619537220000	orphaned
28769	3NKkdfoqpPwV9EBxtJrAFaehSrcwfyP5XzByfPSZWRBTjpR1kbR8	28766	3NKe4Gap1qJae5B4x16cgHJbBVS7x7nvZVNwbpfcRiS7dY2ytXGH	1407	1395	563	12463	18974	jxRUxkSinM2GMSxgavNFP6xcNfmkSZMqGtsGwU9mhgZJTP8ozzN	14191	19991	19991	1619537580000	canonical
28776	3NKvqtDKJ7g7i2GspErgm5vGmY6YhyenEbjz3EcxDb2kbL6PiXWA	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1579	1389	563	12463	18974	jwr5YwTet7Kh9DfjnCQZiDprrwCZgzfCHqrXm9fnmSKdNWM1q8g	14194	19994	19994	1619538120000	canonical
28774	3NLK2rD58mgsgadqTT5tFynAmrJr1nX8i6suckdiavZYvBJ1tieV	28772	3NKLfZFdtmVpkWxiw1iyJ7arAGFb34ktVuejNnwDRLDayBWCA96w	1579	1389	563	12463	18974	jxz69geY5Jp5yVkr336Wr2xo1SBBnTze1W1BegEgFgSQz5GWvzE	14194	19994	19994	1619538120000	orphaned
28779	3NLby4FWGjLzUu1FmCMn5DYXmd4AGMZ9LU4FL6ZRcagfCTFxwrhA	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	1406	1393	563	12463	18974	jwmwhxKhDKP6BAWu1bq6FfPf549YZ1pCYHyFGKxZ2fcgafaRpJ7	14196	19998	19998	1619538840000	canonical
28782	3NK3DLGrx1Zyhh93gPtdcgTWU5bTw3JHFjdtfP4kAc1tVyiyvEpi	28777	3NLbGRhEn4ofSDBj2TDYAZF3qWNHofRKHqc2CzCjd9D1CPyPg3oE	1627	1139	563	12463	18974	jwo1Pkm9rURMVH4ZYzUYRUv9YrmrCmQozaskioMKLD18ca9ha82	14196	19998	19998	1619538840000	orphaned
28783	3NLsThMMyRquo6WMo1rSrXFnAAd1hsPzJVhfPzMT1EkYwdkN6EY1	28779	3NLby4FWGjLzUu1FmCMn5DYXmd4AGMZ9LU4FL6ZRcagfCTFxwrhA	1405	873	563	12463	18974	jxU94HYPgfiaxiCXJgkSAZNGymW2uqkDvYk8MdJ8nRSLL9YbztL	14197	19999	19999	1619539020000	canonical
28786	3NKxgpUieX33zQhM8UV7MVcoPwAKRC7o6CeG8it7SzRGgUrTCnnv	28784	3NLy2wWAiYihd4mTovg9HtZ6Fzs1SfUmFeLKS4aE1pBMdW5zSBCn	1506	1127	563	12463	18974	jwoKm8ehgbGx9d3wvPzxLohR3eN1aoux9PJiG1VrCkt8xns3MSZ	14199	20002	20002	1619539560000	orphaned
28789	3NLVDtEsXSfNx8kcx2G9H2WXWRG8n5TuVm2fKfaCzXz8ZwwPvPJn	28788	3NLjmZmoUNT6tySjuUhmCsC1ZdGGbEZSxBw19VhqY1o4ciKRMqCE	298	1062	563	12463	18974	jxHrAhxJF8o4Xf7y6Z9spyT1bUPGE16ih6zKVPDh7QJmFeFffm2	14202	20007	20007	1619540460000	canonical
28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	1559	1227	563	12463	18974	jwPmpyF8rnRJXWFBaYN9w4rf7MXwRozRZfLCB3JNBoKHWRhLM5R	14205	20011	20011	1619541180000	canonical
28792	3NKTihdGhv2DLuRTm7yWgNb6sWtHQoEqHYCG5P6j3F6jDmQ9jAyW	28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	1654	1340	563	12463	18974	jwy12qgHvtAgzNgJeSaMQqtTpr9dpoaEiCE4BowJeuMTLWDVXBa	14205	20011	20011	1619541180000	orphaned
28799	3NLmzRTgvxB3ah25t9k49hXseZSA6nPe2LxnjxrnLzNwyKEemfMF	28797	3NKHySdt6fhm7C7tQ8HCZhKHZLFBomCWoP7CQ6oxdZfbLyFM8rrN	1553	776	563	12463	18974	jwTx5XSGnqyA1KFQbHDmJbLwPYE8FyLytzPRL3BcgMPiWNxPTpo	14207	20013	20013	1619541540000	canonical
28802	3NKzTyggTw5DNsCUYD8XGrYK7XJtkFaJBjAhxMbuFth5zHNWejn2	28799	3NLmzRTgvxB3ah25t9k49hXseZSA6nPe2LxnjxrnLzNwyKEemfMF	1573	1318	563	12463	18974	jx2NAdZHn1uaPQ1YS13R6sFRBzSSqCa1NxZ4xbhGYqe93pPiC1i	14208	20014	20014	1619541720000	canonical
28809	3NKBCbt57B1YeX5nBfjsAwfb1GdQETvwKugpSpt1wJxbKq2eceWr	28806	3NLM6Lq13SxSutTsTpJsYXauyeo4Jd3hxp2VPTW8ZEPoQFUevWSb	1434	642	564	12463	18974	jxUK5twUS6mFZqhiLMSa2EpJYopeo3h8dnxRzQAPrHkL4tEy8Eg	14210	20017	20017	1619542260000	canonical
28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	28809	3NKBCbt57B1YeX5nBfjsAwfb1GdQETvwKugpSpt1wJxbKq2eceWr	1571	1335	564	12463	18974	jwPGkrNBESgcd3THghh6Xtnvy4pPgm8JYT7CFZ6g4TJREPV2MT2	14211	20018	20018	1619542440000	canonical
28813	3NLLbzQdp45QGaejpNHD2NkKuLNtEHGwkDsp1DrQun3H2p1xooTd	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1672	1285	564	12463	18974	jxZJhLLCS4ALJ4DousqSzqUMZLF98eDrURRmxtUWkMRyea3TbfS	14212	20019	20019	1619542620000	orphaned
28820	3NLkEatKd1m1Sy5iMHN8fMNwBXf1nWN5gymniYpTPeKrTXPA3EpX	28819	3NLtdoKJwTgrCmLtofVQaX9HpXJ28A1EoNNQ4cgQp5SLAFmtMxD5	1407	1395	564	12463	18974	jwVjope9K5wMpKb8s9inUJuUMafEiwAhyxbC91yDusmt4nQrDQB	14215	20022	20022	1619543160000	canonical
28825	3NLacbvUuku7AnJeJ53WicpB3WnerskNDHxgt6v3TPpsZP1xSN2i	28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	171	1128	564	12463	18974	jx1YLwB6pF7ZoJSLoZMoGcyxJaAEevY2wTuuDTzav6zHMybW8yP	14218	20026	20026	1619543880000	orphaned
28766	3NKe4Gap1qJae5B4x16cgHJbBVS7x7nvZVNwbpfcRiS7dY2ytXGH	28764	3NLP1XmAHxovoQ9w9MJgd8wxAj8qqHJD72rJcoRuiDJyqeYncmSB	1523	1075	562	12463	18974	jxkukSAN6AtY2nzgAwuijHDgAxyEEQqVL84fBdyy6vPBUdiLbf9	14190	19989	19989	1619537220000	canonical
28771	3NLChNwQ7AbC6x2RUG1z9EZ94qyMJ7kYXp6CWv1z6PZ3HvBgdmRM	28769	3NKkdfoqpPwV9EBxtJrAFaehSrcwfyP5XzByfPSZWRBTjpR1kbR8	1596	1363	563	12463	18974	jx8i3LEhZUBgQZ5tjncofLkueoeivwVPtyAMd4w981FQGxNRKGb	14192	19992	19992	1619537760000	orphaned
28778	3NLDTZXNgmRq9oJa2SmDfmmxubChov9fERZ1w6VhnPyi441VYBbk	28776	3NKvqtDKJ7g7i2GspErgm5vGmY6YhyenEbjz3EcxDb2kbL6PiXWA	1650	1129	563	12463	18974	jw7S7z2Em51YCL45v4yXYmfoC3JQ8GZqmmo2kRi393Q3CuVZNqi	14195	19996	19996	1619538480000	orphaned
28788	3NLjmZmoUNT6tySjuUhmCsC1ZdGGbEZSxBw19VhqY1o4ciKRMqCE	28787	3NKopbFdC9Q7ZZD1beWGrXeRnboUdKMXCeKGbcfBTfb2WuUe3Aku	1581	777	563	12463	18974	jxC9fmYwPfRTSFsFPcW73vxA8j9oNhbogrYgJYWnoL9dYnzdTk4	14201	20004	20004	1619539920000	canonical
28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	28790	3NLC4EDPL3QUGtNvsiTMPsjuKV6D94iYfxDiHc935FMYESpsSKXA	1407	1395	563	12463	18974	jwZqZCa8yn2Ct1Q5tHqELecHXdKyyDU13U6BzhJA9Sif58qxtsb	14204	20009	20009	1619540820000	canonical
28798	3NLX8eng3zSPmqWTn1hCS6HdjB3vSNZmGg2oKj7M86uMFbqXiiab	28797	3NKHySdt6fhm7C7tQ8HCZhKHZLFBomCWoP7CQ6oxdZfbLyFM8rrN	1489	1254	563	12463	18974	jxJA8Yin1yzgfXrpVY2BUCYbzC9mwfFwZeiTwLrTqUGmsm24GjV	14207	20013	20013	1619541540000	orphaned
28806	3NLM6Lq13SxSutTsTpJsYXauyeo4Jd3hxp2VPTW8ZEPoQFUevWSb	28802	3NKzTyggTw5DNsCUYD8XGrYK7XJtkFaJBjAhxMbuFth5zHNWejn2	1631	794	563	12463	18974	jxo7QWNnJ7Ux2mJrRxYKrjioFGHm4g58nXoM9L4greujwhh5EFw	14209	20016	20016	1619542080000	canonical
28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	28802	3NKzTyggTw5DNsCUYD8XGrYK7XJtkFaJBjAhxMbuFth5zHNWejn2	1474	1329	563	12463	18974	jxszYyDfcViwVdkAxt3VcdACfEABmQ5mXKy76WfpQKqmdyvBB2V	14209	20016	20016	1619542080000	orphaned
28812	3NLeWc2SpV1dzBb6QPTzP7n4u8w83e9ZXnsiABd4dyHNv31rmXSn	28809	3NKBCbt57B1YeX5nBfjsAwfb1GdQETvwKugpSpt1wJxbKq2eceWr	1553	776	564	12463	18974	jxtb41ntjhcGdd5ZEMpLjax7GtLCH6LSNKJWsYWnW4hnDnj1UkP	14211	20018	20018	1619542440000	orphaned
28816	3NLqsm98bWQ5uxjZ9KBzFdsLMfUhisD75vp7GLVx6rMEkWQh8wGH	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1402	852	564	12463	18974	jxG8cJ8BYBgrNax1HvM72btTHNFpftxgzN52uXbzAKMNbPWLypp	14212	20019	20019	1619542620000	canonical
28814	3NLDC4yZp4W8r22puP6GVBKdQgEpahhbDnMMiDruiFBDjjcDbUji	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1671	1365	564	12463	18974	jwcwP9PhEduGYHx1opxQRVebeVHzWkpam1Wu4k1xeHKWVZ1XmuD	14212	20019	20019	1619542620000	orphaned
28818	3NKYNby6QHHRwoir8RMUc8RbEHiYoS5FTUsWypqP9V6UizE7BBxS	28817	3NKah9NZ962Uwo9X4CqPXsjMkVSyuLhLtP8QJnqDaJ3KidvjQtaL	1546	1339	564	12463	18974	jy2gExpHCPXA4qFuBWw7YftMkdUKDeG7M1oCMGaKVEgTSihGQRc	14214	20021	20021	1619542980000	orphaned
28821	3NL9E4kV4pHpxuh6LMiFgrckmdHLxyzcKj9XCAz8o9RR7TkKX4rX	28820	3NLkEatKd1m1Sy5iMHN8fMNwBXf1nWN5gymniYpTPeKrTXPA3EpX	1406	1393	564	12463	18974	jxZLxPMjJVJzwov7iXeVF54fb5DHbAW6PPy3VfsGhGMDSUkz4Jd	14216	20023	20023	1619543340000	canonical
28826	3NL3PvVDdUeXEz4NWwWjYVBz6t1oZLHyMTdeEZqXgSqzu52Vubho	28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	1500	1051	564	12463	18974	jxHc7EvGpVbSFJZJzs7U7JutY6RHw9Ls1pKjJyBn5N9Y5u1nUyw	14218	20026	20026	1619543880000	canonical
28824	3NLNptJsE42UbNcp4ZG7CpVYxfGpZmEjcLYecbHyZZCug2ELigeK	28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	632	1016	564	12463	18974	jwdXr7bv2DZjhfqrnMRn5dqTqz8D39nwbM5ZShFEX1ka53ufjXT	14218	20026	20026	1619543880000	orphaned
28831	3NLPGyqjPVr1drJkYYJYmZ8kbAnb2NUNE7DdMNAvjbbfYtBVGpSx	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1613	983	564	12463	18974	jwnsfSMJkrXKaST4PGWfgRkND543LHpGqDeKML9AH8jJf6b6Vm3	14220	20029	20029	1619544420000	canonical
28828	3NKusgWL55Mw2VdZ7iWdEYHjWB87aK3hJ8jnozC4oKfbSidSFWya	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1403	782	564	12463	18974	jwRE6sF1FvZaw87iukaqNukJKQABgvoFmmcbmkSqzrHVWr2HV2h	14220	20029	20029	1619544420000	orphaned
28830	3NKnaK9vtn1jh3cz7VfbGsp36tvUsyanWV8jXrgM5mntWGcNALYt	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	369	1186	564	12463	18974	jxNHRmRQEN1BDWFtzSB9fdKM1XNv3XYwHoa422eJa9NcXpnWAcK	14220	20029	20029	1619544420000	orphaned
28833	3NL2XM3vzxZ4ThMhYMsLexP2QVrEMAiZJkfPACTimSiHVbJRvfpN	28831	3NLPGyqjPVr1drJkYYJYmZ8kbAnb2NUNE7DdMNAvjbbfYtBVGpSx	1627	1385	564	12463	18974	jxiWQz1tR3FrSHotoZPD2CWmQgmdp1SHWk7Rd4adVSPquadqvH3	14221	20030	20030	1619544600000	canonical
28840	3NKJo8AAWdR4xDmHYKtRQiTZeuoznqzrmXkRcUjUbCEScetgzznV	28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	1513	1379	564	12463	18974	jxVQdLShSLbAtodtLpuxQSpH2YWmuYCVN4XKWeg3KbVjRJThLmT	14225	20037	20037	1619545860000	canonical
28841	3NLAowm5n2rDy4LfFjALt6E1LKa8gwd3TS7CkXzbMs3gVUaTB6bi	28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	1651	1175	564	12463	18974	jx6XweNYf73QmsH729Up7HQHSwybPrAG3aoU2mUsPZJgyAC5keu	14225	20037	20037	1619545860000	orphaned
28847	3NLgCL4oAqAVJr6g2HazqyVkZzeZ5rgqPmifK3UM1dBGShMzdfaz	28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	1599	1287	564	12463	18974	jx17cGFgYoKdkSLgwwfktQYv1fYPiqL7RbZFgmVKE2h7QQ8rsXy	14227	20039	20039	1619546220000	orphaned
28852	3NLheYyHrgJCfw4GitZeY7KRWFD98zTvR9EdgKnNguJB74cYJo17	28851	3NKa7gis8MSDYYZewXPARPuAUSiwYdLLmZLHByx43iNJQMDQLQ7e	1406	1393	564	12463	18974	jxGctT2NCowrHqUdxcyitcZoYrqv9r1uwGYP6drr2TY42TA6LG3	14230	20044	20044	1619547120000	canonical
28854	3NKj3F8fpEvaJmrusjrJbRXYnshNgeayaLxzYWYKccB3PoyBcfWU	28852	3NLheYyHrgJCfw4GitZeY7KRWFD98zTvR9EdgKnNguJB74cYJo17	1540	110	565	12463	18974	jxcyWfzHnWqbNHRFi7d4GHeJsQsmddJL6qGfCcVRJvmNZMBZFG1	14231	20046	20046	1619547480000	orphaned
28858	3NKsMrZxcjG8io3yYkps6nG224FPaLSxfnSzkVeHj1mddbQsSBW4	28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	1631	794	565	12463	18974	jxbbwfzW5y4frdJifaEB8nZZhxZP9Uecxz9G6mPcbCgtgtMwrkF	14233	20054	20054	1619548920000	orphaned
28862	3NLZwk62rTskA1ZNonadvQNAHcgYXFshx6MZTKakkT1apTDCoELr	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1513	1379	565	12463	18974	jx9ygna3QvDsRiZKuymDdFuCZj6Fuaxxhw9snACkVkFPaGKddbf	14234	20055	20055	1619549100000	orphaned
28864	3NKA8hc1oNriZW4FQVVno8iewi868yrSPq9e3XZEnhXQcZ7Mrd9Z	28863	3NKFxUpU3cRk9CKNaKWxGLoTBLpMP268rZwszroBuKt2bkFrqTwf	1622	990	565	12463	18974	jxRbCAddz7pizAJvRtEoQPfhF7C986prABMqVxHbSnyvyc6XDvg	14236	20057	20057	1619549460000	canonical
28869	3NKwbTJA945KCZ6YZB9MdzsTTm2AUm7WxfhX2pHwPJmJRRjpxqN2	28868	3NKtTKaiGq918jZYZJmxYfFv1x91NWD71QahsrEpDWGbPiGtV7PT	1553	776	565	12463	18974	jwmNzAFDTAVGWKoUeoYDGxb7WQoPWDrCcKmVyHpYAkQsHpkuFNR	14240	20061	20061	1619550180000	canonical
28877	3NKM3HNe7f73pgdNAqp1AWhvZ6VdM6PMYBnTkYFG34wZBm8D6tAY	28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	1607	1348	565	12463	18974	jwYMjuEvEqM3DmwN6WavKNVVuj6cPxwgFeWLQQwcvDgBLp8JksK	14244	20065	20065	1619550900000	canonical
28787	3NKopbFdC9Q7ZZD1beWGrXeRnboUdKMXCeKGbcfBTfb2WuUe3Aku	28785	3NLuKt13F7WwQVtvgVU4gTJKoxVU4YGomdu9p3RmRpXBXk9a9XQf	1631	794	563	12463	18974	jxcaZcLobcEHLjjVp7Hyce8ZsMU7LBUZQ1UTqRro5qo89xYMWzb	14200	20003	20003	1619539740000	canonical
28790	3NLC4EDPL3QUGtNvsiTMPsjuKV6D94iYfxDiHc935FMYESpsSKXA	28789	3NLVDtEsXSfNx8kcx2G9H2WXWRG8n5TuVm2fKfaCzXz8ZwwPvPJn	1637	816	563	12463	18974	jwHee5o6N6KykCVqJbEe1SYsejsZ96JoYpFdC1CsHimd7eeskcU	14203	20008	20008	1619540640000	canonical
28793	3NKFMGQzypMkfpEYDcviN8UK2huaRhRrvf26zrXwRjQL6naN4NeW	28791	3NKsYkQu5HSDybcXaXjQbcT5dyT3NBRY6eQDuE5r7bbpa3NF3hYX	149	1283	563	12463	18974	jxF2NXoiMGKeE3Ahx7PbzjdqbRe8VxCPZiC6js7zDvTBgRg5DtB	14205	20011	20011	1619541180000	orphaned
28797	3NKHySdt6fhm7C7tQ8HCZhKHZLFBomCWoP7CQ6oxdZfbLyFM8rrN	28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	1483	1030	563	12463	18974	jxh5XzE4LDKA74G4F5CJ3hLkexbGZAfJnMCZ52fh33irNznF1ed	14206	20012	20012	1619541360000	canonical
28795	3NKtWTZzYT7kQY7SwZYMVW6jQsEeDLBZrkT95cpWtRf52DRQ3QbU	28794	3NLpKwcUJfHnx9QRTm2PRpY73HgWh9NtBW5F1SNwfcaLeA5WxMTh	1403	823	563	12463	18974	jwZpQ5rXPoPWjFMydhESZPzMmNttU1935ajGnnodikqThkgAQe5	14206	20012	20012	1619541360000	orphaned
28808	3NKs5EqAjkKC5dFJEit4ZFaMyJrAGpUmiT7vP5AiLhMDxF6Z8SZF	28805	3NLRiJCuEQ9x4zTVQifoqUn4FtkJzRK4s6tD9Z36WpSXW3mo4u71	1405	849	564	12463	18974	jxBQPouPWrCiqQaKZvFDsLQKLX774UfbGohf1b8ZK2y9AKUfdmf	14210	20017	20017	1619542260000	orphaned
28815	3NKv6uLSmrK4va7oKv4FstRFs4mQq2dZsRscbYYSWNTbGZo5mkhW	28811	3NL7BNi9xv2LB3sEMRVjxzk4PxByeJpSJyENwVK8Cmpy3xLdF2gf	1671	1365	564	12463	18974	jwRcaU4bysLZzr5x5vLinF2VPYY9w8Fpx2k8t7vSKVGbekUudjy	14212	20019	20019	1619542620000	orphaned
28817	3NKah9NZ962Uwo9X4CqPXsjMkVSyuLhLtP8QJnqDaJ3KidvjQtaL	28816	3NLqsm98bWQ5uxjZ9KBzFdsLMfUhisD75vp7GLVx6rMEkWQh8wGH	44	1325	564	12463	18974	jxYHUv1siLs9wbgwLnDVJphvFBmpEdJ1p72FHZrRkXCvWWjG4EN	14213	20020	20020	1619542800000	canonical
28822	3NLeEYQhPHkyjY62SGjSF3jEceJZeYM56ZzEmsgLHDyARJLwZngs	28821	3NL9E4kV4pHpxuh6LMiFgrckmdHLxyzcKj9XCAz8o9RR7TkKX4rX	1406	1393	564	12463	18974	jx7B7wP27qWpEeGqN56mJZvxqt3VsEjnVgzfTeR6F3GnpAaPyVR	14217	20024	20024	1619543520000	canonical
28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	28826	3NL3PvVDdUeXEz4NWwWjYVBz6t1oZLHyMTdeEZqXgSqzu52Vubho	1637	816	564	12463	18974	jxV4bYMQVmTgTWF1VrmtF8bDzSXHVYzTFHcXRwk8zYpQ5gBWHzP	14219	20027	20027	1619544060000	canonical
28829	3NLLEQRsfjW93siFWQCCqKC3N4AsZYYKQgQ32CKXc6rgjybXK6Gm	28827	3NLxyvgr64t8gCPrcPhrRAVL3FUqevyhzvunLchxqM4zukh3pNJa	1600	1372	564	12463	18974	jwNmHW2Ma7X6TCMvDYVqZKXQBGHirbEsDJF3ryNh8QaqvdoSURJ	14220	20029	20029	1619544420000	orphaned
28834	3NL83ambGEVK7cVb2ABHprNtV347zkPvD6nmoZimbrodZ4niFGKA	28833	3NL2XM3vzxZ4ThMhYMsLexP2QVrEMAiZJkfPACTimSiHVbJRvfpN	1407	1395	564	12463	18974	jxkM1L1EX33SapDU3w88AL3hvYB9g2n5deay2qqfHzxmzeqaeTh	14222	20032	20032	1619544960000	canonical
28839	3NL2obcJB8k3iWLYKA3VbZBZwftGph4vAgGXypZ74SH7tvWWZdA5	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	1637	815	564	12463	18974	jxrTd3bKg5FjF7ZacYWYFMbVHRRqwWDkDkrNbDErzmtXwAY9Y5k	14224	20035	20035	1619545500000	orphaned
28842	3NL4wc5TqZGaeh3ASf6dDqYHWhdnrQrymfun8kD2SbZGZ2XCM8td	28838	3NLGXqEQ3786Z1DteEL2xJvQ1yWXxdjpTMzBzS3z57zJSmk3akLt	1651	1175	564	12463	18974	jxrQoJvH8iG3JLAYZ3Mi6NSfiZN6BBBHeoXH5uyeYhCCRxVcHZG	14225	20037	20037	1619545860000	orphaned
28850	3NKbXyhyjCethzFvvfEAnpmdGXbEbg4D8BxFKaLKmiMg4dxDCrZD	28846	3NKdPgoHT3mwUDncz3n9kVUfupNNr9xEDtjgBJEhozC1yJMRje9h	1654	1340	564	12463	18974	jxYhCjbE3VpZ1p6xM9kVPL4Rr83XHipi8h6pc6m9c3bQSLQKrJY	14228	20041	20041	1619546580000	canonical
28853	3NKPwUvu1KeF6jbeHR8Tbx8WQ2Kj52K7rFREAiXtujD8WEf4YqcR	28852	3NLheYyHrgJCfw4GitZeY7KRWFD98zTvR9EdgKnNguJB74cYJo17	1578	1050	565	12463	18974	jxbqLVJ1kYPXremMECYR8anJnCzGHaihvbJRaezCren1ERGfREu	14231	20046	20046	1619547480000	canonical
28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	1532	253	565	12463	18974	jwpTSFPkftmHaGxY1JEM8CjkfoENfyEKheqWzx9iwur3JcDoSgq	14233	20054	20054	1619548920000	canonical
28860	3NLxwv945WugTioGWeqyeaTipe5NTmmuPKGEpmY4ZJAcQToF6xWp	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1457	1145	565	12463	18974	jxSsm4ZvZGMeYTNvtz5Hgf5CPZGoUGqC8a829oHA7iPFHt48m4P	14234	20055	20055	1619549100000	canonical
28865	3NKwidqQ8afktJmaXrFjivW7bxHTbXn18ch6CJffZBKjB6NLaSHK	28863	3NKFxUpU3cRk9CKNaKWxGLoTBLpMP268rZwszroBuKt2bkFrqTwf	1406	1393	565	12463	18974	jxXuk6aG2NF1VrzKRQUBFAkJyysyQvMuiEsoMKmPPZKYEn9SLv6	14236	20057	20057	1619549460000	orphaned
28882	3NK3QtF9T2qV3vHSreWMgnwdnBGdCRVw2kGcYg195xxSQ2SyTMH1	28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	1631	794	565	12463	18974	jx3EMxxuCZTW7gDwVbjev5tfiVWZjgbfk4Sb32D1McjFQg3tDUz	14246	20067	20067	1619551260000	orphaned
28884	3NK6wPGQ5LxgE1fMpN5CcTFvHr7epWKg8MRNcQi3Ca6QAGVSKfKk	28883	3NKWErFrp7iENdFKZsrhuvLFfkmJuLinkUCEaNqcs5QgzUQfZdeZ	1406	1393	565	12463	18974	jxxdhkSo3LEo6RmhWqxMZ4FgngcnW57jmahRf6QrKk5t8jF3YaS	14248	20069	20069	1619551620000	canonical
28885	3NKnPmkQgTggfjVJmRdgPBXnfZVa8C8Dtc1keepeQJu4NfPNfnmR	28884	3NK6wPGQ5LxgE1fMpN5CcTFvHr7epWKg8MRNcQi3Ca6QAGVSKfKk	1651	1055	565	12463	18974	jxcETFbjR9V6U6TQEoMfHz2BqKA2rruBbKJxqxAGKoT7ERTj6wA	14249	20071	20071	1619551980000	orphaned
28887	3NK32HC2BmFE2Zx3VfJjwjNraUFaCxD3JHsRxUnKCydvWeFKvhuu	28886	3NKYedTCKBvPepkzvkbYX98iGPaT98XN4fkoAQPiF1VUJPTHT4sc	1406	1393	565	12463	18974	jxJSeYMzkgxrzHzYB5sraMN9gza3ybnL2cQP74gmr9LKxT4CpkM	14250	20072	20072	1619552160000	canonical
28889	3NLJDGZiZ3Ejjsbg5pjBANGscXJrzaaj9AKxhvQhkjw2pMwZmV1T	28885	3NKnPmkQgTggfjVJmRdgPBXnfZVa8C8Dtc1keepeQJu4NfPNfnmR	576	1355	565	12463	18974	jx3uHewZftvdzZPw1uq25sLbDtKyv6dPXGBVvLANa2YDdpN7WDB	14250	20075	20075	1619552700000	orphaned
28891	3NKMGkEqWY5e4G2kwYED12oEvtDe1hGgB6x2bppcHKCDqRpHNbCb	28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	1654	1094	566	12463	18974	jxCeHbpt4jcvmYjecLokea9KTom2NPWavS5c3x15dwRrDG9dDcy	14252	20075	20075	1619552700000	orphaned
28896	3NL2it4ssXACp3DNiZiAYTjWCUQgFDkcQ9B2oEHRTo3E6jFnJSJf	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	632	1136	566	12463	18974	jwQutvVgmuYEFVd4k9mnQBFQankM4KM895rokXEGv7eXviGSbWs	14253	20076	20076	1619552880000	orphaned
28898	3NKLMdZRXe5coXtxxN8Ai5T5zk3X3zQs1Tf2RLWnnr7bRLJUV7MA	28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	1483	301	566	12463	18974	jwinYCJBUTseHLBwLRugR4h8HPVJgz5DfCZ5UPjP7ztYyrADuuj	14254	20077	20077	1619553060000	orphaned
28900	3NKy4AN8F4M6rfbHvSS1srVSN1rDRistpot2BWE64cXHQPy3hfL5	28897	3NLnN6xgJ6p2U55s34i8q8KyncF5YN8Fj38hz2zCWbMoLxMmpFKR	1623	830	566	12463	18974	jxTdXxbZvpJEPoPpV49AEK6Yqwbr4FTYAAVjEA87d1Et2wKZmba	14255	20078	20078	1619553240000	orphaned
28902	3NLuRqyw3Wi8yHtaD5ZwLWWKvE3N3wqewn2a357LQexpEDaUqjNo	28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	1403	824	566	12463	18974	jy3Fkr91CvXarY4Yvt2b1PzW4XJPQKoCvnx9s9bNoZiQbC8mqeA	14256	20081	20081	1619553780000	orphaned
28836	3NLWmMmfrMspR9fF8tzpHtVMt8FJLHrjUd8778BdtD2V7Z4hVkb5	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	1656	977	564	12463	18974	jxQPeToqgeTdg42o6KdVkWxhecLbYC5XE5XjsPwypdR77e2rEmD	14224	20035	20035	1619545500000	orphaned
28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	28840	3NKJo8AAWdR4xDmHYKtRQiTZeuoznqzrmXkRcUjUbCEScetgzznV	1637	816	564	12463	18974	jxrPKj2myv1QKmZ8JamRQxe5SDwSGrrt6mkYq2CHuhFfDX4Tbbj	14226	20038	20038	1619546040000	canonical
28845	3NKrULGHRE7s1Yga6qTdXjYD7Jt9e4MkaSi4fAf4wHJBZF3h6MWG	28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	1602	1123	564	12463	18974	jxVoMZDzXJMTuj44NhkoW4TxW31ofKifmsor9ciZeeMyJ9iKKUt	14227	20039	20039	1619546220000	orphaned
28857	3NLbBrcN2U7sA5m1ekNwDNBSqQztzGGzcrydpWQfb75eXvAbARkv	28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	1407	1395	565	12463	18974	jwfjtJmhH1KRiqCJRzJRTTXmuzLkdSg2H8XyRTFySNRqJWLLECb	14233	20054	20054	1619548920000	orphaned
28861	3NLy3BRndwNuqg6fAneJGfXpU7ZR1q2zyP28hxnMHBvtKusuX1RU	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1439	1153	565	12463	18974	jxtBXugLdBVKDPRFBTwbY9qyqZMJ7T9GSgNWpLu58GDiq6akCbh	14234	20055	20055	1619549100000	orphaned
28863	3NKFxUpU3cRk9CKNaKWxGLoTBLpMP268rZwszroBuKt2bkFrqTwf	28860	3NLxwv945WugTioGWeqyeaTipe5NTmmuPKGEpmY4ZJAcQToF6xWp	1607	1102	565	12463	18974	jx4gMh6LumFQnZcjZPTgZyDZ4BzrH8s61d2HoGmPiPky3EA6WhK	14235	20056	20056	1619549280000	canonical
28867	3NKrMdTmzF12owHVF5jegjsKUCWJXk2RqvsM8Rikc9zyY83auME4	28866	3NKhuPDCPkB7qfq3yxHnC4WdD6prkaQXQAZLgW4PDGAmh7UQrH1y	152	1084	565	12463	18974	jxUFdFHahzgNuMq7yx9geZf4RgCF8XUrSm9u1xWW5M5HUbBEBdp	14238	20059	20059	1619549820000	canonical
28868	3NKtTKaiGq918jZYZJmxYfFv1x91NWD71QahsrEpDWGbPiGtV7PT	28867	3NKrMdTmzF12owHVF5jegjsKUCWJXk2RqvsM8Rikc9zyY83auME4	1407	1395	565	12463	18974	jxRydzrSQ8wBTJqfW89Cv3SJEVQJEq6NbDojZd6EUW89K6VqhPj	14239	20060	20060	1619550000000	canonical
28873	3NLKyJLjpjmwcsXPEDzzh9jSvw9kXUKyJGvDnUQRwuELiEQyhDAw	28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	1481	790	565	12463	18974	jxViZY7G7vzt5umt8os9xEfrm6iKNJuYeqbZyujtRiccnDg6VmV	14242	20063	20063	1619550540000	canonical
28872	3NKZ6zdb2norYJuBtpj9grykcSQJ4vkMDY9mGkMq3Zn7s828s4kN	28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	1503	1277	565	12463	18974	jx2pkGK8CN9xSmB6BEy2uS9Gu75gdfYev191Ut4HuCotM1rNVcx	14242	20063	20063	1619550540000	orphaned
28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	28873	3NLKyJLjpjmwcsXPEDzzh9jSvw9kXUKyJGvDnUQRwuELiEQyhDAw	1581	778	565	12463	18974	jxXTXTzAAT6o8DT2Gx9s9uD3AmN7c6Yk1tFMNz9aBjRp7jSzRPr	14243	20064	20064	1619550720000	canonical
28875	3NKEXTp4c4P1o38fkNTK1ACKNM3v2M4vmC1ZSi56o7E1rht7Q9iA	28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	1406	1393	565	12463	18974	jxpej1wqYwjRgAgRAeV9gxznH98MafN7ZV8SP8QJ5y9Noy6f5hH	14244	20065	20065	1619550900000	orphaned
28879	3NL49PwK75KkySwGALXTW6m3QFaGBn3Lg1dCbyQ7hSMmawk5STPg	28877	3NKM3HNe7f73pgdNAqp1AWhvZ6VdM6PMYBnTkYFG34wZBm8D6tAY	1624	1334	565	12463	18974	jwitxY3EH9xa9AvURZfKMyhYqcCFiqznk9E8SMWrLN1UdFE15im	14245	20066	20066	1619551080000	orphaned
28901	3NLcQic49yZuF3tEFqPrBvpQhprUvR8CSnYsLFZsLMdefuAo4pXR	28875	3NKEXTp4c4P1o38fkNTK1ACKNM3v2M4vmC1ZSi56o7E1rht7Q9iA	1455	966	565	12463	18974	jwzLH3omXohPq85hegAWgcidYyXnLz337tZX2NwbG6Spdb1jqWz	14245	20080	20080	1619553600000	orphaned
28881	3NL7Trs1yqP22y2F21rZ1rdasYsA7R8863thST4zbpWbQAhyuC2i	28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	1403	824	565	12463	18974	jxdKYgCuK1Krx9YEoU7zPKnPtuTPC6yXTuuqgKrUttjLYynvZLJ	14246	20067	20067	1619551260000	orphaned
28883	3NKWErFrp7iENdFKZsrhuvLFfkmJuLinkUCEaNqcs5QgzUQfZdeZ	28880	3NLBD9bHqAeV8LkMtNiCh8vPt6Z1KirtNDP6tmaUd9mRhSR3zKqc	1403	824	565	12463	18974	jwvSrC4N7ndFb5aENaChnvxHcjGAAyxi7Bd63T4t8YqNWbg1TT8	14247	20068	20068	1619551440000	canonical
28886	3NKYedTCKBvPepkzvkbYX98iGPaT98XN4fkoAQPiF1VUJPTHT4sc	28884	3NK6wPGQ5LxgE1fMpN5CcTFvHr7epWKg8MRNcQi3Ca6QAGVSKfKk	1651	1055	565	12463	18974	jxS1gNk8YLqkXnuecxg666NuT3oEGRwJay8nKGfzxWD8kq1GjNn	14249	20071	20071	1619551980000	canonical
28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	1579	1143	566	12463	18974	jw961Z9tujj2VnjYe69dssguUgSkFQeUcys7fsCz78u3ijEeP2J	14253	20076	20076	1619552880000	canonical
28894	3NKjnsc79k8F452d5X8R7WC8NePKsHAsPNTzWHSRfxHLsyAyssHw	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	1579	1143	566	12463	18974	jxrEfz2tvYGvroEUMjB1bLz5cWE5Db4qs523HQnJ6cntVDGMkXb	14253	20076	20076	1619552880000	orphaned
28893	3NK6ieYePXqG7X4iLiW7TA1iocbccCV7KqBniYuQWigHWQEQ5A8S	28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	1536	1313	566	12463	18974	jwsb5zp4w348pCWgJnidaRFKCPxc3FeV2RGvFQQbyF2KDbxcfLe	14253	20076	20076	1619552880000	orphaned
28897	3NLnN6xgJ6p2U55s34i8q8KyncF5YN8Fj38hz2zCWbMoLxMmpFKR	28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	1483	301	566	12463	18974	jxT7fna2PdfE97Cnsq23drPEPmrSruwAD4bAUWAgsA6QZfoCp5d	14254	20077	20077	1619553060000	canonical
28903	3NLQztquW7SEYhx4a82ugr2Tbb3sJe98hRbEgoTGYd9ySNXA8UPV	28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	1458	957	566	12463	18974	jwu3vKEgoUVGLD1yTHTmSG7vh9VBUW5kcBKqJhrgdd6K61jQ1HH	14256	20081	20081	1619553780000	orphaned
28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	28906	3NLJZ6MSC1PA2i9YY85QZ5DJccohZjVkmbzzB61ud3FcfziGQQra	1637	816	566	12463	18974	jy2R8GPrq1a2xKmNwamJhbV6TsoHTsv767VbXU1c8HEjxceonAS	14258	20083	20083	1619554140000	canonical
28910	3NKUwR2cMk2Ka8aFV56TatZ8SkWojCkHDUVS42kG5z51u59dzK7Y	28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	1654	1094	566	12463	18974	jxQfGkTYF174sh6529uK6FS9XRYfz99dqGFzWjChrWneubdk3Fx	14259	20084	20084	1619554320000	canonical
28908	3NLUwCG7vesC6hbRV41cTRvQvJAH3fn12Hahi2FufFJaXz97VsYF	28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	1671	1365	566	12463	18974	jx4kqi49XJhuqLebv2moJVZmnAUVz7QNuovyd5RcRtNUaevr9sZ	14259	20084	20084	1619554320000	orphaned
28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	28911	3NLwHwPt5eEBPAEfoyQqwJpGjXEeUiA52KTgxEEPQXbTfEo9rZ7A	1467	1250	566	12463	18974	jwwayAhp1LtFD7EjmbrGNjGotDmRvuy5xKJVgmviJxYcmMuKVgD	14261	20087	20087	1619554860000	canonical
28922	3NLihHcw7ZyAiW2ZBHTdoVGtFmPr12aDSA3pMGNwc1fDzzoYpVFU	28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	1506	1127	566	12463	18974	jxqJ95NpVbB56K6scsUwu5kBhyFeSTq3Yz7q7HoCGDT71ARwD2L	14264	20091	20091	1619555580000	orphaned
28924	3NKEnxNWxBZFuGT6LxXpWYpYyHuMjunrPznqWFZy456pcmSHTKkc	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	484	1319	566	12463	18974	jwVWJAsxEUMDhSab12TKXha3iJCwL2X1TuB6a6pkiRgQyNEgDRw	14265	20093	20093	1619555940000	orphaned
28926	3NL6FCHBEaRRiqW34MwF2enrmuGtDR2YT2nUGEDVKqKtkfCkoJ6u	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	1627	1385	566	12463	18974	jx85p6hMoXkLTuWoAWfLTv84UYC1p5W38jmHHW1Y2SEFnaPokZo	14265	20093	20093	1619555940000	orphaned
28837	3NKm8kqTxLuoJ63DY6LPgw91MA9en8kBfmfmbPaSBPUmzJn2N5Gb	28835	3NKtR2Hcb1AR9wRQg7DeyL1isAb351Cu3oPi3QamcWt6Dh9Vj1fd	576	1109	564	12463	18974	jxsq9enw6eVk8jy4wMTAuiKmRg6hDedbEnfBAyUgVAiMMj1EVT2	14224	20035	20035	1619545500000	orphaned
28846	3NKdPgoHT3mwUDncz3n9kVUfupNNr9xEDtjgBJEhozC1yJMRje9h	28843	3NLuz5J8nm34QPMVENe2TQhphDF13TU1xCuEFD5nZ4FpcDgFGfPh	1460	625	564	12463	18974	jxcMDiJDRM5AAaj5nfPZCr8Lvm8u9GnDmm8Ttprq1rUMLxYKJpo	14227	20039	20039	1619546220000	canonical
28851	3NKa7gis8MSDYYZewXPARPuAUSiwYdLLmZLHByx43iNJQMDQLQ7e	28850	3NKbXyhyjCethzFvvfEAnpmdGXbEbg4D8BxFKaLKmiMg4dxDCrZD	1482	226	564	12463	18974	jwYAbt1fs19FSix8MsaqLzYquKCk5PB3BkcFzyUyDBRtVY1jRXS	14229	20043	20043	1619546940000	canonical
28855	3NL85E269VKeoxM8j9pW4Ckbg5QqcLE8VAoXkMkNLgDfDtGTzQu4	28853	3NKPwUvu1KeF6jbeHR8Tbx8WQ2Kj52K7rFREAiXtujD8WEf4YqcR	1637	816	565	12463	18974	jwg9UmPcqnkCFg4koj7Yg54Ni7BPp8kQg4ashFKPeKbsPz6CfYj	14232	20049	20049	1619548020000	canonical
28859	3NK3FH64YmpQQ6Hth11Y7tymGBS1JrAFRgLfpoWjksCi16HLJuGU	28856	3NL1ujk6nf6wU17ZgQr8PzF6V58XNTpr7dDqA9oFUhpyhbP2XAzR	1602	1123	565	12463	18974	jwGd5VgqeoHx6Tp4QeSMQTm9dfFhoui4iPnHxuBPn6fCNkJ6wdx	14234	20055	20055	1619549100000	orphaned
28866	3NKhuPDCPkB7qfq3yxHnC4WdD6prkaQXQAZLgW4PDGAmh7UQrH1y	28864	3NKA8hc1oNriZW4FQVVno8iewi868yrSPq9e3XZEnhXQcZ7Mrd9Z	470	1063	565	12463	18974	jxAxwULh2Au4mh5xJpz9BX7cTxqX7z6Y1LBr1mHNdqLnmfnmDUd	14237	20058	20058	1619549640000	canonical
28871	3NLbkV3QYxo2eeV2Hfbykc1ofibdnBA7YH5iXzzXgh5xjURAMnY8	28869	3NKwbTJA945KCZ6YZB9MdzsTTm2AUm7WxfhX2pHwPJmJRRjpxqN2	1671	999	565	12463	18974	jxy2JAZBe1A2vV7nLChrPTCG6dEacGD8yvdzCVWedRisK4EtB4s	14241	20062	20062	1619550360000	canonical
28876	3NLLUXRBgvF52kbmcNZ4RqiaGXmt3GzYr9tfrfuVrJ1XG3gSTUzL	28874	3NKpozVTLyNmcD6GWz5MCFPQg73copmfLbcaEWEbQN5BmEjW9EeG	1403	824	565	12463	18974	jwPxfLavUhn6YwPpBW53XWXpjiQfK9bn1z3Nx1ZZsNkaRLrpEmo	14244	20065	20065	1619550900000	orphaned
28880	3NLBD9bHqAeV8LkMtNiCh8vPt6Z1KirtNDP6tmaUd9mRhSR3zKqc	28878	3NKrrpNSot6PBoXWQpwunuMP4HNpjubdUaQN7mPSxJJ4RLEsLFWo	1406	1393	565	12463	18974	jx8SzrmNFKcMDsM3sSdtUjJKbdozxyxCj2YnaqCncdN2zoS9Hkg	14246	20067	20067	1619551260000	canonical
28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	28887	3NK32HC2BmFE2Zx3VfJjwjNraUFaCxD3JHsRxUnKCydvWeFKvhuu	1617	922	566	12463	18974	jxFCRBu9iP2EwkVwBDDwanmDFa5FKoJexD6adUZLys4frrzDa8T	14251	20073	20073	1619552340000	canonical
28892	3NL7Y4xDWKfbqFoNAQKbsEiwJfXR3YvQQSBiGRdMz7tau4wLb4LT	28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	576	1355	566	12463	18974	jxedd9NmDknraY5GSRGV4SV2yU4hYFQg8GofvnjfbKk7Ds4oLCN	14252	20075	20075	1619552700000	canonical
28890	3NLq9NUjqjYjYTxVn1hkP6tPWgNmcsxQ7oWoAoHHxx8bvJy7oVbP	28888	3NLoFpypsS4w1xXqpnsB54poTSsjw22DZUcKaXmw2y1XtPAduZM7	1406	1393	566	12463	18974	jwgxCKXE5QDW3MSwMaUMvLdhqyBxMVLaKdtW4uQ3CDaa7iegYpk	14252	20075	20075	1619552700000	orphaned
28919	3NKw1ERzcL6GHp96n35AEZ2c6idPvbqVnKbDGKcbEqrU8KFhLC1V	28895	3NLuT3mEkdAZ5JeScgCUbc4fppNR3HUnHir6EAsVEW3wKaK1Bp4w	44	1325	566	12463	18974	jwe2JtaAHZCxL2YLn66fKaLQAuAY2xFid6RUjsghacdMNJjz2iZ	14254	20088	20088	1619555068122	orphaned
28899	3NKJAcj6AjU2HqHjU493Tp6hFmL7EWVbwyL1XAkJCaqpchhV9NGN	28897	3NLnN6xgJ6p2U55s34i8q8KyncF5YN8Fj38hz2zCWbMoLxMmpFKR	1406	1393	566	12463	18974	jxZt6K18A4WC2vXQSB58nmmMDwoWNUCVKg6gjm4PsYB48QfLRQG	14255	20078	20078	1619553240000	canonical
28913	3NKsZVNwBDoiPWBN2c4QBWHoziT3i4M9i4FHUxXCfPiJZqyZhKgR	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	44	1325	566	12463	18974	jy3Jw1ZVaPe8TGwiSupKmRMyi1mNm3pnmZBjCF46eH8vVJfmTUw	14262	20088	20088	1619555040000	orphaned
28928	3NLECA3g5AYJwWbahV9c3WGzpxiwpx7DAcYCYwpXWFG285zoDEMf	28925	3NLuLjYaiH5XwVtqLMuMQD4BEe1fHLJnSTRuYQQjznkNF1m7K1xd	1403	812	566	12463	18974	jwcBSs5AM59NSxKescvxeByB8fAMT6bF6tc9XwMHf5WMs48pa9L	14266	20094	20094	1619556120000	canonical
28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	28929	3NKaza6XWtZjCyKpqSK43N8fcyDRfjpP4kYrHEtj7d8fyXDuKsKA	1407	1395	566	12463	18974	jxpbEQtUgVmU17N7iFGayTFBUhcon6XCr3xX69RuxD4u9uJLxJJ	14268	20097	20097	1619556660000	canonical
28931	3NKn8NBdsTPhBosrGfBmbEKR7zNonhXYZt2KfpfPRbW3pH9xmRkF	28929	3NKaza6XWtZjCyKpqSK43N8fcyDRfjpP4kYrHEtj7d8fyXDuKsKA	1646	988	566	12463	18974	jwCwroFh2CXhQhQwKehKQsjsfBMpeYLz5XY8EaNCkNqgUHbYANu	14268	20097	20097	1619556660000	orphaned
28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	28935	3NLo6cVM7w9KzehLzTdArcPPsmYy3BrXp5eL4i5wfVNyPokhpNkK	1646	1354	567	12463	18974	jxBbmMcTd3e5MgSppYLzN1LKDUx4f2w4sfkybQEnuc8KffS8xXT	14271	20100	20100	1619557200000	canonical
28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	1476	1371	567	12463	18974	jxHRXhWwMeG6vjMgXKv1GbDo8TqDBfqiPjRHMWqas2pLFUvTv89	14272	20101	20101	1619557380000	canonical
28940	3NKVw3fAFysEb836LSK9mF3CB57Bk4YyJ1m8LMxrTY7S6iUGYqUk	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	44	959	567	12463	18974	jxeMMY79TiRpzEisXcnn1YQ5ADAyvhfFw66ARaB3kGiv3EU5xdf	14273	20102	20102	1619557560000	canonical
28945	3NL9RKH5xZw14CqfNit1MmZNEFXCmxcKRmyPr1PzqwUo12uxpJfm	28940	3NKVw3fAFysEb836LSK9mF3CB57Bk4YyJ1m8LMxrTY7S6iUGYqUk	1607	1102	567	12463	18974	jwcbr8Jft3LXxeBsWXwqWM25V5T7kko5QRh7W4R5p2GXGwYwRWX	14274	20103	20103	1619557740000	orphaned
28946	3NK4PgJzCGK5Lbz6xQkvV4aZKZ7X3aNLdwAZPhkqqvKBGu6VK9Js	28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	1406	1393	567	12463	18974	jxanVZ3MVS7Co6gzMQdb9VTheWdZNtZ4xD9crfWvATa7JTTUib9	14275	20106	20106	1619558280000	canonical
28950	3NLE169YD7crqbE7TGRbgybuTY2pFdZbHuYtfHDNqAuenUG7xZuv	28946	3NK4PgJzCGK5Lbz6xQkvV4aZKZ7X3aNLdwAZPhkqqvKBGu6VK9Js	1651	1175	567	12463	18974	jxXR3pf6gnesChP3Epo18sQSQvkxCm3oYPoVisu8xzrqaSkatHX	14276	20107	20107	1619558460000	canonical
28955	3NK3dozS6Xdy4o5XahL7HxUv6bs4ZyKf7mZzFa6MJwBVTKVhwNwz	28954	3NLGK2G7R8cJ6UxAgndowg4XZpYm8wg17eoZTWrWL4aVGCMWsdQK	1403	824	567	12463	18974	jxeKh4wVYgsDF2zZBx4tMtQZdeJjqwH6eZUsJpe6iRhCjnz9KcV	14281	20112	20112	1619559360000	orphaned
28958	3NKy7az3MjZjcUaupZeXFdwWWt5r5fXdYYkCDYwwaGrcb6M41zGR	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	1609	1333	567	12463	18974	jx2PacHGj4C7r5aMSMgePKAaffAHU63GxSoF9ZT1vdm82UAJFHY	14282	20114	20114	1619559720000	orphaned
28962	3NK47fbA1YwLAqU2tvb7ejhydZ7Yo2y6DUiaSfqaWDNtZvdSSknF	28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	1448	1065	567	12463	18974	jwaBHqAxsCiWL89TGfWfA7pAt4fJbqi2fmv5nzPJvMpS5pbinHj	14283	20115	20115	1619559900000	orphaned
28966	3NKU3ic5o6rtMLCRWR6bp1Ji8o6YFDoYCVrjwYYMY4XKbTBnxvdE	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1610	1188	567	12463	18974	jy13UbnmNQ2aaXdCGusNng2BtGTdzGK8jQRy5xtUS7XPxTdLwMK	14285	20118	20118	1619560440000	orphaned
28906	3NLJZ6MSC1PA2i9YY85QZ5DJccohZjVkmbzzB61ud3FcfziGQQra	28904	3NLikYpMe43DTeWqs6HCMoRAFkGZR7kVb1rQKoTMuKfohMSHSBr2	448	939	566	12463	18974	jwLhtberSdPenuSqTvxZM5CRVZbFuEQCN9qhvJfEapf3FEbthge	14257	20082	20082	1619553960000	canonical
28909	3NK7iov93TJKDeK6peQAassnD7gThbmWHJVxkqebE1HT7zUpvK5V	28907	3NLqn3V7jgUQn6z9mQtaAfroi1ShnZ7aoyrSNGCQDjnAfoUE93qE	1610	1068	566	12463	18974	jwfTMYgpJTTihicjfDtTng2kbwcL57Pp4zxVXUay1HJpF7h6yXc	14259	20084	20084	1619554320000	orphaned
28911	3NLwHwPt5eEBPAEfoyQqwJpGjXEeUiA52KTgxEEPQXbTfEo9rZ7A	28910	3NKUwR2cMk2Ka8aFV56TatZ8SkWojCkHDUVS42kG5z51u59dzK7Y	1623	830	566	12463	18974	jxqyTDTamcvtsAYaCrGY68kYSZFrQ7RJe9zFVScngwxFjmsa3TB	14260	20086	20086	1619554680000	canonical
28916	3NKkpAP4x5Gs6mPZMkirhbtTDCX42dVUnT9MWrxuhqtGJhfW9djB	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	58	1035	566	12463	18974	jxh1jK9yBBSgZ3Yk3MfGekNnSnBHwxWbHHJfHQ4RMs7e2okbxDk	14262	20088	20088	1619555040000	canonical
28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	28916	3NKkpAP4x5Gs6mPZMkirhbtTDCX42dVUnT9MWrxuhqtGJhfW9djB	43	1310	566	12463	18974	jwnckPrdCHDc3oHxFDhUa7tujwXY7p2t11UZ77KT4KxuenVYQSd	14263	20089	20089	1619555220000	canonical
28925	3NLuLjYaiH5XwVtqLMuMQD4BEe1fHLJnSTRuYQQjznkNF1m7K1xd	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	1483	402	566	12463	18974	jwhaC21kQchACVCGvTfeyti42tMBDjHaCkjEo2YPqHocvs4zgL3	14265	20093	20093	1619555940000	canonical
28927	3NKik2WmDo3acwiMLByUMwP4RGcZddYfzs4imVJNk8obiKYLxBW5	28925	3NLuLjYaiH5XwVtqLMuMQD4BEe1fHLJnSTRuYQQjznkNF1m7K1xd	1406	1393	566	12463	18974	jw9teELj8B1nhEoMueZrebVqBrnnzRNwaAEzTURPJ5AEkiEStcb	14266	20094	20094	1619556120000	orphaned
28929	3NKaza6XWtZjCyKpqSK43N8fcyDRfjpP4kYrHEtj7d8fyXDuKsKA	28928	3NLECA3g5AYJwWbahV9c3WGzpxiwpx7DAcYCYwpXWFG285zoDEMf	298	1308	566	12463	18974	jxsy8M7QEurnv1HqzPGJm9rE6wNEZnzTrzn4tCBKrBCD14moWmn	14267	20095	20095	1619556300000	canonical
28935	3NLo6cVM7w9KzehLzTdArcPPsmYy3BrXp5eL4i5wfVNyPokhpNkK	28934	3NL1hcHusDs8douLhhgXyD4LP9nRMDyxZrS9REUybCZYMPR3u3su	1406	1393	566	12463	18974	jxcAPRzGMZWW9GjLfaPVAiNV6XX9cyPWQ2vz3XrHV9rQCQbZyPL	14270	20099	20099	1619557020000	canonical
28937	3NLZj7sswNEdTBYrsdpFqj6Kb7irnK49WT4jVbWKg6YbKLtuyNP6	28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	1547	1378	567	12463	18974	jxhLBK67FdA1boMz39Wrs8Tnexjx3AsHk63bk9thuqLoFajiw6J	14272	20101	20101	1619557380000	orphaned
28942	3NLrX4KSaEmwCRv9rxZvFPNCBaw2ppGyt3RAYCez3f1PAJwmycVy	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	641	1336	567	12463	18974	jwHJHrciSX5jmEfQ6vrMgbEkFJnyrhh2DvTKw4jSzMiRmzqSFZG	14273	20102	20102	1619557560000	orphaned
28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	28940	3NKVw3fAFysEb836LSK9mF3CB57Bk4YyJ1m8LMxrTY7S6iUGYqUk	1406	1393	567	12463	18974	jwWaNkNCvD7GF6a9vnMJrXP3dgv5vzgp3evZM8Aa1jApeu5A9nC	14274	20103	20103	1619557740000	canonical
28947	3NLiFvsp16DUBUTaEizDm4Nt8R9xBuHPwzrGuksqP2daazQDHsDK	28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	1642	1001	567	12463	18974	jwV5TJnifuetf3i9Y2x5ZSjoMXmZnac2MfSpVYsr2Wi4pqghpDe	14275	20106	20106	1619558280000	orphaned
28949	3NL5HBRmxNdxcV8SJB35FygXRspfvAJyBLMpsGRrXunqVD3GTWEy	28946	3NK4PgJzCGK5Lbz6xQkvV4aZKZ7X3aNLdwAZPhkqqvKBGu6VK9Js	1651	1175	567	12463	18974	jwXjDXfWnaG6pmFb1Z6a487t5AKu55kq5kAHiZbsHF3GBAsp4jc	14276	20107	20107	1619558460000	orphaned
28951	3NLqPFwN5uarD2EcyZfgf4LZCLH589vFrYuFnQwa7XSoStNpgPHL	28950	3NLE169YD7crqbE7TGRbgybuTY2pFdZbHuYtfHDNqAuenUG7xZuv	1627	1385	567	12463	18974	jxLLgUMFHP7SBmNqL5tZKvtxMi8LYURaU2H4yURwu6mM2h8naLZ	14277	20108	20108	1619558640000	canonical
28953	3NLiURFFrowFCMWcFHeVSA2QFz2r9msFWAbxcB7dHaQAFZsMo2LJ	28952	3NLiehxMGd1ktjugC6Y8K9A1GdfuXgdM772Z4nFykuLBAG3anCbH	1593	1220	567	12463	18974	jwzY6zwq5Mwf67oTGPButQPsiXpDgadDf6X94oti1wJw5uz4n78	14279	20110	20110	1619559000000	canonical
28954	3NLGK2G7R8cJ6UxAgndowg4XZpYm8wg17eoZTWrWL4aVGCMWsdQK	28953	3NLiURFFrowFCMWcFHeVSA2QFz2r9msFWAbxcB7dHaQAFZsMo2LJ	1673	1002	567	12463	18974	jwZKFreMQ49eV1TJhtBykqkX65qzvyW9ZwB4HPyW69asWuEvQKP	14280	20111	20111	1619559180000	canonical
28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	28954	3NLGK2G7R8cJ6UxAgndowg4XZpYm8wg17eoZTWrWL4aVGCMWsdQK	1508	1261	567	12463	18974	jxwVMLZeAtForgTK2dHSvGE9r1A6L3yAkovXNMa9Mgs98CPuMWi	14281	20112	20112	1619559360000	canonical
28959	3NLXhKMUG3eUkgLCqa32VX3B2hTSAQbDxUHfFmvEJ8ULRVMywRXj	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	1407	1395	567	12463	18974	jxRNh38vUVJD3DUoq9nx7BMPGAYckNCWUhiq1FHra5RCj1t3hXH	14282	20114	20114	1619559720000	orphaned
28960	3NKxFrbViN2798iuMH17sHPDz2LCGpgsGmi548JiuzodCVxAYu6i	28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	1619	1275	567	12463	18974	jw8LgN3XiLLuN9buh6S2A9asXe1kFHpQfoapvYVuGtcbSNxSFE5	14283	20115	20115	1619559900000	canonical
28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	28960	3NKxFrbViN2798iuMH17sHPDz2LCGpgsGmi548JiuzodCVxAYu6i	1637	816	567	12463	18974	jxLFC7cxn9Qq9UwHjYEUGkRnm8YZAQUzfxkPPPGUwor2EW9aHwg	14284	20116	20116	1619560080000	canonical
28967	3NLJ4iyWcAErecqNAsWA73D7yApoJ2bpDr7woq1xFcM1s95ckTkR	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1474	1329	567	12463	18974	jxexTW6VtKM5nFfSdkJEEmYu1bFLECnBGhq9zk5B5N45shYjCMw	14285	20118	20118	1619560440000	canonical
28965	3NL8CAhNHN8Nv9Bn8UEP51CzymWgB6hyGPQ8L5cQAGgpLTpxTzb9	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1407	1395	567	12463	18974	jwkAHyQ1SRtsKC18KMLF7jioKAn41xaJyeBN1LfmuPem9znGn5J	14285	20118	20118	1619560440000	orphaned
28971	3NLTQmpDgA1dVKTmVxmsC5X5CbSHRPoYKZe4ZegQTXYtNQkoboDG	28969	3NKo35t8ySGFE7GK8AJYS5KEY6iJ4VVcv37ef89ToWUsr8P7AJ2U	1602	1369	567	12463	18974	jwpN3hPbxfT85rU6UE2Wt6voTAQhdgmyw8Lamsub68QAQ6Ri8tp	14287	20120	20120	1619560800000	orphaned
28976	3NLTibAuTR1KBzCsi9eCrhTSmUadnzhwtijDKgoXhiS6gJmztiVf	28974	3NKvk6meTpXeJPfQgjbkXVU1MNUWtCRMzgqhr4NJPtQBaKihvekH	448	1305	567	12463	18974	jw9KRoHm18ctWsZzDTw4AGpXkaNqW6VZRvHjPKD4ciZ4ebZm5fH	14289	20123	20123	1619561340000	orphaned
28979	3NLdTP9jSKccR2Frxjgr2JWznrPdaha6CfSYJurwHmgRnLCNqWNN	28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	1547	683	567	12463	18974	jwWLNpwYeVn8JDk3y7ZdqqeGFDafyLUsvm3oPREXdb7U2AZLDkS	14290	20124	20124	1619561520000	canonical
28978	3NLaNcznzpkpaxZxWtfCGHr9zVgB5bLTYtpQN5SaWk7rPaKUcmwg	28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	1516	1294	567	12463	18974	jwaTWH2XsPrq9oqice8DqQtwdeFCXQqnxsz7835ixNb7LYBXJZd	14290	20124	20124	1619561520000	orphaned
28980	3NLcNySYzp2oFsFuuRxeSMisVbjeKbFTAugaRepDue6pEy79JZty	28979	3NLdTP9jSKccR2Frxjgr2JWznrPdaha6CfSYJurwHmgRnLCNqWNN	152	1330	567	12463	18974	jxhxucFXwxpFN2qgcbSTRKCe3CJrUxg55zxg4r9irZ1FmkJPYge	14291	20125	20125	1619561700000	canonical
28981	3NLtjBDytSwqxXKNeVmWz4Az79K9LGYVjkVnqFepvZX2y3onaZzi	28979	3NLdTP9jSKccR2Frxjgr2JWznrPdaha6CfSYJurwHmgRnLCNqWNN	1406	1393	567	12463	18974	jwZB2iwQshqWcDqdNoxf8iH5LEms3W7iTBATktFJJcYx9KGEqGr	14291	20125	20125	1619561700000	orphaned
28914	3NKXiEi77tVauf79i2ASujQTKZ6poivcVko24KULdgm3czEPfyki	28912	3NKMxRCkBNWH4k8RNTAAfgWpTMve6d8f6Eb1A5EN1e3Da6W2jB3h	1642	1367	566	12463	18974	jxXk2YmJWdeyopcBcbT2Kwb4UzByWKW1oDGxXU9VGanN1hMUzEQ	14262	20088	20088	1619555040000	orphaned
28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	1506	1127	566	12463	18974	jwGe4FDM2WXsFV4ajwogviVXxbXdk3VmuaF7Kn7v9nuvdUFoNkM	14264	20091	20091	1619555580000	canonical
28923	3NL4jdxLN7hf4nnJgPYWBQNeTbYCL2JDzv5ERu8L6n7zLcHH2h8x	28920	3NLCrCzgaZAi4Wi4K7khGfPAdE7Ea6JSb5UEiaKMmfHVH7Be8Wv5	1474	1329	566	12463	18974	jxEGDQrBYa5bBk6BWbRzjKSQRg6r5QNMbj3w44WNCTWgzLPkkJi	14264	20091	20091	1619555580000	orphaned
28988	3NKbe5ZP5uSzxT6UJkanggcmAU4eu6yGiJzDzbsKnGdCbg6DV2Bn	28921	3NKmCMuEFn65ee8Ez2DyMexeHSHVWwfrc92qn2qjxXcdHUoJkiy5	1637	816	566	12463	18974	jxaywrysNVU4P1ru1FCzTrN88bScgt4wqGnMxvfphwbjsn5YsNG	14265	20128	20128	1619562288421	orphaned
28934	3NL1hcHusDs8douLhhgXyD4LP9nRMDyxZrS9REUybCZYMPR3u3su	28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	1555	1347	566	12463	18974	jxoM8K5UA9k2ANRMdSH2tBX1SRtuqC4U37AyeiJJCBkD6rkV3RK	14269	20098	20098	1619556840000	canonical
28932	3NLhUxUSVV1yN1PfJxnC7YXKySNvXkoW8VqwC7PMUf9VFr29Ncs2	28930	3NKC7MjBXc33h1uM9AaBkJaq3ZriW5DPgncne5Hn4rS2vGadoSr9	1406	1393	566	12463	18974	jxSfvoE8JH8nnRgDTpmk3sQgR3CKDeY7dzx27ipd6NfLsuC3vUj	14269	20098	20098	1619556840000	orphaned
28939	3NLXJJh44vA42zu4LtBjpDauxBvHGWXGPviYpx7RLZZeSKP5LMho	28936	3NK6KzgauZc9z6f861ZHhpXzm9anR3Sz9QH7VfYGhjKgS1bhgb3u	1631	794	567	12463	18974	jxx6fXWk5cC3Z99d7UkAKsR5V1QZPugNJuZT3bFwU6U7PFVjTaR	14272	20101	20101	1619557380000	orphaned
28941	3NKPZUA2dGmHejB5RPphCa7tpQDkYpV44M8ysfBnuyRgU5gWNe4q	28938	3NLt8LdqLcv7bCL7DCi9n9HoggaxQuvYysJVnUBYYDMomKnAZNwx	44	959	567	12463	18974	jwJDwMAYbZReSKDGU6vZFRW3ggZtyXi9Tv1Bm9y9kTd4FpZ2YV9	14273	20102	20102	1619557560000	orphaned
28948	3NKhQX17dGuAGZaBY7KXMwERWjPhXLXE9ffYoKJHyPzac73LnPbw	28944	3NLGene1j3PBbzJTZiCt6MBLwQuEVDeZfhehuGzqH2oB1WRRGpRq	1642	1001	567	12463	18974	jxCc2cohRBN8iogAt3TSQNjjLpbiWcLmjyLQhFXenjDWHbZxthz	14275	20106	20106	1619558280000	orphaned
28952	3NLiehxMGd1ktjugC6Y8K9A1GdfuXgdM772Z4nFykuLBAG3anCbH	28951	3NLqPFwN5uarD2EcyZfgf4LZCLH589vFrYuFnQwa7XSoStNpgPHL	1617	1288	567	12463	18974	jwyYkNTFHUWF8DVc5ZytGZ2jSefYJfqZArW8eDoK9RYqXUsEv9F	14278	20109	20109	1619558820000	canonical
28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	298	298	567	12463	18974	jxGozZGfoMTVJgz2TwSaQfJTQKGB48rRfeSEfztjYYsS2aNfyv3	14282	20114	20114	1619559720000	canonical
28990	3NLhABsk66PjrFtKGDx3BGHtvBiR2PPgdenm6VsS54Be8mrJzdsj	28956	3NKPmtNHFubaU5xsUFCyxpJxotw9BHp2V3dGtToFo6seRXcV5GoC	1637	816	567	12463	18974	jwrbcCThLZPPMtqGN2vighVeZNfQfm8Bd6TAMJyrZJwbpxGHYrr	14282	20128	20128	1619562339164	orphaned
28961	3NKJj8q9NB2c72qeNXYdm8aEiA3UQCi1YS2Np2cXaEnCR7VNxKFY	28957	3NLJDqq72VyNUku9JHUKeQoLCuhFQpaweNHsnbbmVRze71WuPeND	1448	1065	567	12463	18974	jwTz6Ymgd8gdpfxEptG12zwjXmDAE9usr3SSftDzGDnSvitbv2t	14283	20115	20115	1619559900000	orphaned
28964	3NLiGx2JawgtUsAXs6e1qZNCyhJ4DDKUjPtAFWpoMzSkKddSpwVZ	28963	3NLw85mEzuR4dNE7W1Fw1rAeQ78MQgagGMuwgzRGjNerBMzoyb6p	1610	1188	567	12463	18974	jwGKiZFQzcnYGHMsEKb9AvJJbLyg1W4x9qMpNVt6BNfVsTGdNAu	14285	20118	20118	1619560440000	orphaned
28969	3NKo35t8ySGFE7GK8AJYS5KEY6iJ4VVcv37ef89ToWUsr8P7AJ2U	28967	3NLJ4iyWcAErecqNAsWA73D7yApoJ2bpDr7woq1xFcM1s95ckTkR	1599	1287	567	12463	18974	jwjj8iNbo9pJjj7NZCdL6vJvQuwjXnw7gaqGpAsyGNPwZ3o5fnw	14286	20119	20119	1619560620000	orphaned
28973	3NL9jqTRH6PzGmFgrXV87nXhW3j2HKj5oryNVT25b3nzWcBDPJsd	28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	1611	1341	567	12463	18974	jwjDENxGecYoLvYJ8B6jZQXbdhvBrRn2xGQH9h4fKdS3fX6xQn6	14287	20120	20120	1619560800000	orphaned
28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	28974	3NKvk6meTpXeJPfQgjbkXVU1MNUWtCRMzgqhr4NJPtQBaKihvekH	1457	1391	567	12463	18974	jx5HK3zcjcAybn29NzbZNZzhWPdhkUQSuuL7JTy25WmDcyAFY4V	14289	20123	20123	1619561340000	canonical
28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	28980	3NLcNySYzp2oFsFuuRxeSMisVbjeKbFTAugaRepDue6pEy79JZty	1402	850	567	12463	18974	jxPB1EAkba9Q4FvTUyj5QX2LvynYRm19W1kXxhoWwvfS1dHEjpz	14292	20127	20127	1619562060000	canonical
28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	1405	851	568	12463	18974	jxyrx5kDVdPMGRTAgAegFXKa6NMuavCRQ5o5mWMborEv7sFjmor	14293	20128	20128	1619562240000	canonical
28992	3NLYke3gCBAefEMV5KvBzhYiecEQmdCwihed23mGnS8Z4tJaH4mp	28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	1483	894	568	12463	18974	jwVZFZJsKDZ8HL2NVQUqmsgi9Jo4FunFzV7o7xXKz27ifpzDzkf	14294	20129	20129	1619562420000	canonical
28994	3NKrEQ4tDJ1m4DcvMGF48KjcEb9JHfeuLbUXpgkY2bSYvtJmi1c9	28992	3NLYke3gCBAefEMV5KvBzhYiecEQmdCwihed23mGnS8Z4tJaH4mp	1651	1301	568	12463	18974	jwMkSyLA6AtqvLFZAhs9mVRriUjb5f47h8B3bnf2dwiuSnCVkQr	14295	20130	20130	1619562600000	canonical
28996	3NLgKjsLR7xab18fCyYHxaD9A7PWNGmTTcqewYVGkNtbvVmQ3e6x	28994	3NKrEQ4tDJ1m4DcvMGF48KjcEb9JHfeuLbUXpgkY2bSYvtJmi1c9	1406	1393	568	12463	18974	jx8gi2RQzwncZ46HptAnsWKbFvRTuXCmfZSUZaEyHh5kE48Kzaf	14296	20131	20131	1619562780000	canonical
28999	3NKWD7jtswCHyvvG4iMPVKXRxLz4kwqpymXoUiUwmdS4pUQR5rT5	28998	3NLwCfAoT2m87jvfAjcA82UKZeWHRLomT516fW8Jv8Rh8XwoTXt3	1673	1368	568	12463	18974	jxaTSKin6ia44VZYCcHmdC5Z7qXEcYCSuunbgP4W1ngu82UBdsi	14298	20133	20133	1619563140000	canonical
29001	3NKG6kEAUqpFJZdFAyBjDH1cZymMTNtJsVfkYUhB7oAKtA9QKmAL	28999	3NKWD7jtswCHyvvG4iMPVKXRxLz4kwqpymXoUiUwmdS4pUQR5rT5	298	1182	568	12463	18974	jxQD8VchV5KfwYVQZB9HJ9yjWTXtHHTNyiJFZUTyBzHWEqwuiM7	14299	20135	20135	1619563500000	canonical
29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	29002	3NKz8vT1BvbVtzBz9CkFUnfS9xyupJYu4srms2woqHL5UzNpCxGY	1406	1393	568	12463	18974	jxE7QeVNoECYLRi2G2bUjzGYrr9Zu2J8rqcE9FbLRqLq37KCJaT	14301	20137	20137	1619563860000	canonical
29010	3NLsTaRbDoLutWDBosGyDGqUxzxAb2rnQky5yWnKKtMzgLx9Fwnb	29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	1659	548	568	12463	18974	jy2KSBqoJs52kGtDGmQei8YzXNufvQLoqwiXWfFJRLy3QSXhrk2	14305	20143	20143	1619564940000	canonical
29012	3NKJF6mCDoLPNzHA4eyxxXjS6RdKXWTbNDB4SerhTViMbjwssizt	29010	3NLsTaRbDoLutWDBosGyDGqUxzxAb2rnQky5yWnKKtMzgLx9Fwnb	1406	1393	568	12463	18974	jxco3Upbx81Bfuq7bQGo5xckbT2KDtmnYbeXE6v72CkthcjePex	14306	20144	20144	1619565120000	canonical
29017	3NKj5RBaVTY8XFcnLML5bLyVnPGVJZqfe9KWQ41KzYLiq3PDPjL2	29016	3NLx1kvstJkJrhAkHGZTU27RcuRxnpMoPjwYwKhes8CvV7ejiWM6	1547	1132	568	12463	18974	jxxxxc151SLR2jMNnGdWY7yscdb2v3TK2xkFYm2W2SST3fiXdJf	14309	20149	20149	1619566020000	canonical
29019	3NKpKNYityKVAbiLhtCKnreJV4V3E51Ue7phLHG2aCGR2J1tosHL	29018	3NKbvjin3kfZYrtivPyxMNCaXuLuDLbtM7Z2yeF4CcT5jACP3uWz	1406	1393	568	12463	18974	jxmDdrnDQjMGdZfZxaf8uQCDjgu1zfcH2dhWAqt5DWMuiax8dVp	14311	20151	20151	1619566380000	canonical
28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	28967	3NLJ4iyWcAErecqNAsWA73D7yApoJ2bpDr7woq1xFcM1s95ckTkR	1599	1287	567	12463	18974	jw89bd6BixxP8iC4zXcpGLABdHVx14ETD94o9C1KHn7x1sGP7co	14286	20119	20119	1619560620000	canonical
28972	3NKT2wQg1jEjcFvQnetgH1vtjMtJ1RcJ88wUsadJVYZTnU6nWkNb	28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	1599	1041	567	12463	18974	jxHtq5NZyqaYV55JgGs3EtMLcxyxu5eATGadYLmWJhHfeoGDsrB	14287	20120	20120	1619560800000	canonical
28970	3NLfnwAd1sH6LumkvokSEPrVb1ZqpkwJtVnhpkPXs1pKYRnwrWPf	28968	3NK7ezC6JNDh28rFqQ6s8Jm5idtMdLaUNMDH2eBYeLPejPfynq1D	1602	1369	567	12463	18974	jwvTWHSjYZ3mTfx5YRXViDADTLYkodnkjaRTG4hpiNJQ7wZyBqa	14287	20120	20120	1619560800000	orphaned
28974	3NKvk6meTpXeJPfQgjbkXVU1MNUWtCRMzgqhr4NJPtQBaKihvekH	28972	3NKT2wQg1jEjcFvQnetgH1vtjMtJ1RcJ88wUsadJVYZTnU6nWkNb	1549	1116	567	12463	18974	jwMutgTHSwUSdJNptS93boxnghXX5Z792iyLqYebLmwBLR5gL5U	14288	20121	20121	1619560980000	canonical
28977	3NLWu81KDBRHNsjLcLH5meFzTj1LFKjE3MTMf3Jn4u5jJ81u7jAj	28975	3NKxvT8V5MyPRDvyLNY5fK89vTqHwhrvDAV1vZnUPRRuS6ASHCF7	1467	1376	567	12463	18974	jwvhKUbmwnqDzQp778wCCPvzVaqLALdjW4epC1YST6FDpcxLzZL	14290	20124	20124	1619561520000	orphaned
28987	3NLQpf1kjmPFRjtgxVxVTfzkpFWnVy3ZiYYGSqRkNgTK22GvahyH	28982	3NKMQHsHj9rVD57FEV4TYCQyJFRnZLJMqjeNumwgTMUCTBHfkeuk	1471	1140	568	12463	18974	jx3HRRY72ZsCk3P8nN6JyoVYRZpAq6iVRg3QM27phEJhk2Q3Sjj	14293	20128	20128	1619562240000	orphaned
28993	3NK3CyVJs8J8WFDnnGFFKZscCrzXMTu2sfc4DjgMeWDf9YRix14M	28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	369	946	568	12463	18974	jwNxc9C54QujSQkYQwqY6YL4h29TSE9STPeqkizUtwQ5suD58W2	14294	20129	20129	1619562420000	orphaned
28995	3NKHmNLRoES8aGB6s7RWRhdtG9ob5P3bkTdjZhSbj3Ev9QRe6awC	28992	3NLYke3gCBAefEMV5KvBzhYiecEQmdCwihed23mGnS8Z4tJaH4mp	1651	1301	568	12463	18974	jwxkvVJgQHKEvPAch3YZvdsZveB76EtwnFqbpMTzWpichAHLkcv	14295	20130	20130	1619562600000	orphaned
29002	3NKz8vT1BvbVtzBz9CkFUnfS9xyupJYu4srms2woqHL5UzNpCxGY	29001	3NKG6kEAUqpFJZdFAyBjDH1cZymMTNtJsVfkYUhB7oAKtA9QKmAL	1403	824	568	12463	18974	jwYY4yNUWnTLXmrRFRCnhQ7bGmvKD8pRD14khXwLJUZ66vdv6FS	14300	20136	20136	1619563680000	canonical
29004	3NKS7ZyhAEJ1Vszv2PSX6SQMTKyAijBuj2iNzMjwyeYGwfbcrgzC	29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	1642	1241	568	12463	18974	jxqVaGoqsNFa9regAWxjwBs2fdrynUFo3Q61ifXbkbUeBAWUTYd	14302	20139	20139	1619564220000	canonical
29005	3NKaxrrccySTKPQnc2mK8jUZDCSs7q5bmYrPzZDTcpwyAyhxvnSX	29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	1607	1348	568	12463	18974	jx1a8tdbGNvFkaEndbRpUc5y6qAqceJyabpiKc6Ni2S6cnXK7S1	14302	20139	20139	1619564220000	orphaned
29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	29006	3NKH1813odyzVijzoK6uPN19aZhm58kwHW5BPEs3Mu1TRkZCVMnx	1406	1393	568	12463	18974	jwkeZc83WQMnDMQTkBZMZZzf8W4Ahp5m6JFaNnfYURnWut3yVxU	14304	20142	20142	1619564760000	canonical
29009	3NKitMk3NiiJUxYQQzvyr4aL6HvNHvyt5NS3EHdGntiD3c9upYDC	29007	3NKQMrcGQkGXP8BxDodmeiKEdMqfjzAYRCUtxskq63GrtFp7RgxJ	1571	1089	568	12463	18974	jwg6rbw5sgWD8LBBJjZdAddtB5uqRj1LKajSkKQxpUznvUododH	14305	20143	20143	1619564940000	orphaned
29015	3NLr94MbCc6pzDSiRpCybsGRRdTfXsQXXZpM15S9kjYaaTCx1ZFi	29012	3NKJF6mCDoLPNzHA4eyxxXjS6RdKXWTbNDB4SerhTViMbjwssizt	1623	830	568	12463	18974	jxBS6UqbdRaNCi16tmyj84fVH5Jhb6gM3X1PqNSqrN3MCuQHBED	14307	20146	20146	1619565480000	canonical
29014	3NL8TW6rvp42JMrLdv4eMspxn14dX9LtEfag8bmFHvsdoY5A4MT4	29012	3NKJF6mCDoLPNzHA4eyxxXjS6RdKXWTbNDB4SerhTViMbjwssizt	152	1084	568	12463	18974	jwQyeLXqMyPefwxt5Cf4eGExkjJUbrfQkXh13PPEfV2Qyd72ojS	14307	20146	20146	1619565480000	orphaned
29016	3NLx1kvstJkJrhAkHGZTU27RcuRxnpMoPjwYwKhes8CvV7ejiWM6	29015	3NLr94MbCc6pzDSiRpCybsGRRdTfXsQXXZpM15S9kjYaaTCx1ZFi	684	986	568	12463	18974	jws7UsmMCh9bjzwTTZk5CZP3aGJo8m84GABHeWKYnzoRjAYbFAA	14308	20147	20147	1619565660000	canonical
29018	3NKbvjin3kfZYrtivPyxMNCaXuLuDLbtM7Z2yeF4CcT5jACP3uWz	29017	3NKj5RBaVTY8XFcnLML5bLyVnPGVJZqfe9KWQ41KzYLiq3PDPjL2	1573	1318	568	12463	18974	jwNJGsQpc3RcyGn3x445eoek8sxpn8bRBx1npYY438GsMWupnmd	14310	20150	20150	1619566200000	canonical
29020	3NKLP8HVXNBGP92yL9ZVyZJDw7LXfykc6pRhWXrrqBdHv1Fbu4vV	29019	3NKpKNYityKVAbiLhtCKnreJV4V3E51Ue7phLHG2aCGR2J1tosHL	1623	839	568	12463	18974	jxzEMw32T9ZBxnbNE1eRBHfP3X86RQcyMpx7a4p1hxjkLE1b59N	14312	20152	20152	1619566560000	canonical
29021	3NLRd1UzT8RVxGqAahA762TS13kCg9SMGuDjckh8P1JyW4KBMxgP	29019	3NKpKNYityKVAbiLhtCKnreJV4V3E51Ue7phLHG2aCGR2J1tosHL	1407	1395	568	12463	18974	jwWQZ3tsPN8ha7Skq7W2U1AUQs61iDkd1ceFbY8P5VDq7UwqVPL	14312	20152	20152	1619566560000	orphaned
29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	29020	3NKLP8HVXNBGP92yL9ZVyZJDw7LXfykc6pRhWXrrqBdHv1Fbu4vV	1501	1114	568	12463	18974	jwMuKZw9RC31jJiHRYZpkeusGo9TGkX1piEDk3HubU9S6tz32cC	14313	20153	20153	1619566740000	canonical
29022	3NKwcD1ndTW8RGdfpa7EAGpAoLzHAs3PS6BkRqqkPKDmS4fc6vjK	29020	3NKLP8HVXNBGP92yL9ZVyZJDw7LXfykc6pRhWXrrqBdHv1Fbu4vV	1553	776	568	12463	18974	jxZ1ZkiEMfDprSdzhofQKyepyocLmjKqBz5KHcZrhMaqDnYwDgS	14313	20153	20153	1619566740000	orphaned
29027	3NKuxvyLXsrMTX22J5eNPqANwsjspJwG78mdYjNEoWMsmv9yssnZ	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	1656	1343	569	12463	18974	jxeLC5Z2mBiercVhZFgSrQ5iRhHohKuqASr1jEpQBadk1VjoQLE	14314	20155	20155	1619567100000	canonical
29025	3NKAcXD9jC5PQqR2Gdxt8jNaCDp9CeTcnJTuk7rthiiyrN51PhWm	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	1656	1343	569	12463	18974	jxeLC5Z2mBiercVhZFgSrQ5iRhHohKuqASr1jEpQBadk1VjoQLE	14314	20155	20155	1619567100000	orphaned
29028	3NL6dBqmRZY8tQTyPxqptHP9NfGmvoJwyHPceC8TtRMxPbSG3DCw	29027	3NKuxvyLXsrMTX22J5eNPqANwsjspJwG78mdYjNEoWMsmv9yssnZ	1522	1196	569	12463	18974	jwWhMfRrayN43Pg7WA9heyRukTvizZXycbte8orUBgFLfjZPYSP	14315	20157	20157	1619567460000	canonical
29029	3NKgdUh5nUGYrcXyzZm7HpkRvptf5pPvZaKAoP8Z99FR1eBKTAqi	29028	3NL6dBqmRZY8tQTyPxqptHP9NfGmvoJwyHPceC8TtRMxPbSG3DCw	1483	399	569	12463	18974	jxk2TQywRURDn23ybzFTbp6TvQyXHQX2WLsrS89bx7VeemBBNTe	14316	20159	20159	1619567820000	orphaned
29031	3NKiPF79GYV5hcZ8cJMsJVPLqsgWPSQjvGCwN97WB9wFTvh9Wf1z	29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	1501	1360	569	12463	18974	jxX8JpsRrM48EkgxJ7qDHZ7WiXH6PtF4rN6Nd5kSjAcSSEbAsPP	14317	20160	20160	1619568000000	canonical
29032	3NKzpvDLVcxZ9xdguRXDP6q29oHfDEnNx4ykdddZjm9kyeefAM8v	29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	1477	1104	569	12463	18974	jxoZTrk2yyR8eg4jdAuEe4aHvWLU3UCEJDab4eQoSDJ9rXEFyHY	14317	20160	20160	1619568000000	orphaned
29034	3NLVePsVf2jXjoodCVBA8RsjnU6xtgKAwtnWyMHnLLTZLaMsk4sg	29031	3NKiPF79GYV5hcZ8cJMsJVPLqsgWPSQjvGCwN97WB9wFTvh9Wf1z	1406	1393	569	12463	18974	jwhfLqVmUDU5JryAdMwF7Zb3cBPK1AYPxZwfazLNt2J5Axx5FBy	14318	20161	20161	1619568180000	orphaned
29037	3NKqGus58AkiFaxZ24ipw4nRDtfwbpeitDh5Qxk6er1avNjdFBvd	29035	3NKShtZHXP7zV7jhLgDk5HZLAXis4PCvuxa98GS9Ljx3aABo3AMG	1407	1395	569	12463	18974	jwUCLrWyiTu3vhJLB6iesZHddnNrZzyN1sch47QYKiEcEdaQtWM	14319	20162	20162	1619568360000	canonical
28991	3NK3drc2wbZ2a5aJWfH1xzdcDgLBuG9vzit93nNGC35crCbLAqg3	28986	3NLshL4t43psPUozBw6s71pZ5Vtv2mo35mZeMLyBXJ4kTT98shuA	1406	1393	568	12463	18974	jxs8f57poAng7oWKwNZmfuQwrzcmuYifw2aTPCBJxpXUi2CYJ54	14294	20129	20129	1619562420000	orphaned
28998	3NLwCfAoT2m87jvfAjcA82UKZeWHRLomT516fW8Jv8Rh8XwoTXt3	28996	3NLgKjsLR7xab18fCyYHxaD9A7PWNGmTTcqewYVGkNtbvVmQ3e6x	1536	1313	568	12463	18974	jwWAqQyBEquQ6p17u4JJbfVBTW2bwxoFjDz8zHQFmJw8rkcP7YJ	14297	20132	20132	1619562960000	canonical
29000	3NK3i4cjgG7N34wfJvn6PMnoBNZAzEtvAYETMWcLx2B26tmKpD54	28998	3NLwCfAoT2m87jvfAjcA82UKZeWHRLomT516fW8Jv8Rh8XwoTXt3	1631	793	568	12463	18974	jwJoSf4yX4KVYnRbyeX4RwUTaESrrEy72aCqWG9rmgX3q6pqSF2	14298	20133	20133	1619563140000	orphaned
29006	3NKH1813odyzVijzoK6uPN19aZhm58kwHW5BPEs3Mu1TRkZCVMnx	29004	3NKS7ZyhAEJ1Vszv2PSX6SQMTKyAijBuj2iNzMjwyeYGwfbcrgzC	1600	50	568	12463	18974	jwgxG1VjvksvwRx4pefyWLt3xcsREpQGvuqCcFKB5NUhNb1asEm	14303	20140	20140	1619564400000	canonical
29008	3NKKWbniFq7pFEjarYKHL2FT7A2nh5Kj4W6aWkvFaYwvoaEcQ9mq	29006	3NKH1813odyzVijzoK6uPN19aZhm58kwHW5BPEs3Mu1TRkZCVMnx	1559	1353	568	12463	18974	jxwFVBNkcH4aQehuxfQY1hxbVuT13wtnpj1W26Qv4ZLW81bwvsz	14304	20142	20142	1619564760000	orphaned
29013	3NLj6iRKhsMiv7ygBnwSChxjt5iosWok5VqPBEF6Y75AUCMe9qUX	29010	3NLsTaRbDoLutWDBosGyDGqUxzxAb2rnQky5yWnKKtMzgLx9Fwnb	80	1273	568	12463	18974	jwA2zrWscC38VAKV2J8gQD7JdYi517QfNrm1WUbyLSBxgzyfXwE	14306	20144	20144	1619565120000	orphaned
29024	3NLoFWQuffzqSmyypHuJLZ81wbeDyBqc9e7BUKrfknL4uH7yrccH	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	298	1062	569	12463	18974	jxAo9aVWPcBWQN1CAQBBkqbVSWhM5edXEZmcZb6QYb89sV6Yazk	14314	20155	20155	1619567100000	orphaned
29036	3NKrYZbgA5NUhzALs65X6JoCH7QcpbwKrYrJZqyYSEg3kuHvqZM7	29027	3NKuxvyLXsrMTX22J5eNPqANwsjspJwG78mdYjNEoWMsmv9yssnZ	55	59	569	12463	18974	jws17rrvQWbkZekkxhVCbzBkkYWWUNcF6YFpxGoosik6ezPGzRe	14315	20162	20162	1619568360000	orphaned
29041	3NLJaonzjxbB7vGmiHkAQt8UBB4MrbfUYD63b95bv96PdumHKCz3	29040	3NKK2U19D3HdZgSPqZBvKchNGeykjUQhG1cvC12A4pSoJzp6Zu3D	470	1063	569	12463	18974	jw6ybykNrF9gzMV7gKKb4ATN7k6y33XdQkgxHmFcquCqBA1ez9P	14322	20165	20165	1619568900000	canonical
29043	3NLgL3Som6XmURoUJwTQDGkmGW8SbsPddTvKuurqj4KevLE2GGWy	29041	3NLJaonzjxbB7vGmiHkAQt8UBB4MrbfUYD63b95bv96PdumHKCz3	1672	1285	569	12463	18974	jwtrNFBkKSJDwuKXMRbSxhNqwYakadpLGPQ51xetboGNTJfZW24	14323	20167	20167	1619569260000	canonical
29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	29043	3NLgL3Som6XmURoUJwTQDGkmGW8SbsPddTvKuurqj4KevLE2GGWy	1406	1393	569	12463	18974	jwEYqJvF64YyWyQjmm6vszVC3mnSuj1HjZoEjynJu71QyywsCVo	14324	20168	20168	1619569440000	canonical
29045	3NLLBgUzS6GorRJAEmESuGSRY1bCYEM4K9oaypKfye2aoAGRyjCd	29043	3NLgL3Som6XmURoUJwTQDGkmGW8SbsPddTvKuurqj4KevLE2GGWy	1670	1036	569	12463	18974	jwkA5TBQXfZ1U7fjh3vAAyKEzGx6ReH4kfAqGrWKPkau3sw4esa	14324	20168	20168	1619569440000	orphaned
29048	3NKUgP2ChYLhiAxkTkW8uph4UHKqMp2rXmYbXnZjgQTcaXMc4fPR	29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	1513	1379	569	12463	18974	jxFe1BJnoyu8k6SSXaRm3eMXwFRv2XVQp1YaLAYPhnLPSgAFrxM	14325	20170	20170	1619569800000	orphaned
29049	3NKQQFYtBCAHRHDBsEQCReVRVyStWemUs4kJzMHtHAjUtqTXcQoW	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1406	1393	569	12463	18974	jwYioBBMsnBrVUHdFtJLtgcpcaWeZCT7VeG6jbAjfAEgAwsjaHf	14326	20171	20171	1619569980000	canonical
29052	3NLjFeSRcq5a3dxyRtVAoqdFFLEDdbQSmdHkt1Yrq7XTwSXpMNRs	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1527	1293	569	12463	18974	jwtxXVH6o87wwhU6Bq6DgAW6RMJdX2dDVQDjzsUHUG2hTJudv5r	14326	20171	20171	1619569980000	orphaned
29053	3NKEfzSY91zyyBUGLD7Nrog4FRCmZJvRGkgucQEGHFerYJUCUNLG	29049	3NKQQFYtBCAHRHDBsEQCReVRVyStWemUs4kJzMHtHAjUtqTXcQoW	1403	824	569	12463	18974	jwW2Tg33ZHDFBecJx9ddHsmrEgcTHx58vESP8Fv6SjUA6BeCRs3	14327	20172	20172	1619570160000	orphaned
29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	29055	3NL5KtGzjhss4Q41SyEAC9prgeGUvFbczHr11R4fGJkHRX69Tcu4	1631	794	569	12463	18974	jx89nzHpSeTTM8forq8kBc2fFCRuEC1584DFJfEVvPiiQg8gsso	14329	20175	20175	1619570700000	canonical
29061	3NLnTNPFiuvMBzEUy7ibyDDrXGCqg6mnqhhBLBy55i1ZVsbyfDfr	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1529	1070	569	12463	18974	jw8C7NEBgnZ3DPBR9drZaqZpBYe4oBDbGLwevQMxQV9Awn9d929	14330	20178	20178	1619571240000	orphaned
29062	3NLufN9hoKn1socytWJbT2UwSLDjCTy1hn8pGcnyrmzVb9ZnB71Q	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1483	1276	569	12463	18974	jxzb6NNELKZXP5wBgD9DFDsA59FJioMJU17JqjTjk65MCaqC4tC	14330	20178	20178	1619571240000	orphaned
29068	3NKqLgwRbTC1ccMk51kKf5KM16YpK32c89MbrGRSvwRCTE48qchC	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1523	1321	569	12463	18974	jwpkTKKuPNK4uRpwsyp87srgN9wBGUtwvHKJ4rX4VxhCUYqJnDw	14331	20179	20179	1619571420000	orphaned
29067	3NKkd5oT6FicYFWwtxjfmP5jnFTSoYTGUajpKsPnU94bgsh1gcmc	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1523	1321	569	12463	18974	jwdx18z4QgQFDQKcpmCt7DciaK3suHz1dxLzku2ysydtSZr5D5H	14331	20179	20179	1619571420000	orphaned
29069	3NK6rWiP9FzAa9tE5mpskCDrdp6txoqdasN57ZZmkb2f6BENpdAL	29066	3NKw7FMTGZhdT5nWg49AjZd5giPfPDAkpeRkGHBLAPvDCcwxm2hg	1668	1370	569	12463	18974	jwNkRzFB2AhZMPHcwp4S8Tjb7MGYYwmEAFqeHYyZVzWv7RAkhHW	14332	20180	20180	1619571600000	canonical
29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	29069	3NK6rWiP9FzAa9tE5mpskCDrdp6txoqdasN57ZZmkb2f6BENpdAL	1601	1388	569	12463	18974	jx3H5nPQGkzwa1fBJzG6LMLkJh1rzQmYZFdSbAU7KQJaz3g2NH8	14333	20181	20181	1619571780000	canonical
29072	3NLLC5BRXDBLxNW9hsd8PqXhGW75Cx87tVsKD24kGQEMUanRYJv7	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1609	1333	569	12463	18974	jx1yksXFKokwnRJbqo6b73snNNnxr2YsDsRcJux9TALTjMKmHJ9	14334	20182	20182	1619571960000	orphaned
29075	3NKK3gNTQuQ1NvwErfHPZtv9DuY7gAZHSNwtkx2SJR16hw4D1Vcu	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1633	1144	569	12463	18974	jxrGQ98xMtMFJseACB3zzKLKQ6hA1x3jrq3tXboMWWzSvjfrRvx	14334	20182	20182	1619571960000	orphaned
29076	3NLYZv3PT7MoMHUwfGCxiC7fkvwWXtCtqce9vWGhHqPZipsJ5FDB	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1642	1121	570	12463	18974	jwdyCwQSW57nB659rgZcdh6g9gBgXUzMU1V9hCgewJSox8BQ949	14335	20183	20183	1619572140000	canonical
29077	3NKLJ8zsKEiC1pazXXR1D3QNhgYs34QQnQdAjDWP1QLcd3NSNGhm	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1642	1121	570	12463	18974	jwdyCwQSW57nB659rgZcdh6g9gBgXUzMU1V9hCgewJSox8BQ949	14335	20183	20183	1619572140000	orphaned
29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	29076	3NLYZv3PT7MoMHUwfGCxiC7fkvwWXtCtqce9vWGhHqPZipsJ5FDB	1599	1161	570	12463	18974	jxKAMenXcYGHP1TiNprjdNn8ZWs6Fh74FjQ2uHtaH8fDS4o4bni	14336	20184	20184	1619572320000	canonical
29083	3NLKDi7SVWz2fapu7eT5rQRZgu2S8JWNK4GRQnGDJEysyLjDowV6	29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	1442	288	570	12463	18974	jwbutXB1PFowZUiP5cUoJXjbureRMtNFNcUnubGDkggR9pPZZu5	14337	20185	20185	1619572500000	orphaned
29026	3NKN9GT7qsuQaSQz2Tpe2EYp6MWDtRBQoTM95ugc1GwkTdRAipMY	29023	3NL52gyCYrzZR3iBifFwZSai8j1GVum5CSezAbPJUqziU3Jkoonb	298	1062	569	12463	18974	jxAo9aVWPcBWQN1CAQBBkqbVSWhM5edXEZmcZb6QYb89sV6Yazk	14314	20155	20155	1619567100000	orphaned
29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	29028	3NL6dBqmRZY8tQTyPxqptHP9NfGmvoJwyHPceC8TtRMxPbSG3DCw	1458	1197	569	12463	18974	jxoZ7nTYC1hkpFAt58SbkAi7MyTmCozwSrDpu7y6qAUPUMFKqD8	14316	20159	20159	1619567820000	canonical
29039	3NLLxPExmHYjEhqsPMf9ruk4wWAYyRCtzJTLCpaha6ao2xKpoxss	29037	3NKqGus58AkiFaxZ24ipw4nRDtfwbpeitDh5Qxk6er1avNjdFBvd	1542	938	569	12463	18974	jxHzGayfg3mx5n4zX1LJtgPSm7tcrVpD1rZ2zT97UdRae83hdbC	14320	20163	20163	1619568540000	orphaned
29042	3NK3YN9RsDhHMFtHipjjXwxycEVyNTJ5DCxqiFyZx2Lx1cG6pyrX	29041	3NLJaonzjxbB7vGmiHkAQt8UBB4MrbfUYD63b95bv96PdumHKCz3	1403	824	569	12463	18974	jxSXTUvh6azXWnjodh7AjLyEfte8uidRYZPjkCXKw1HSXpkDaZw	14323	20167	20167	1619569260000	orphaned
29050	3NKuJdxLeHM97C8XW6HNtunv2pjCwpwqSAozu14wZdKPNQbKan3J	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1527	1293	569	12463	18974	jxwKzYEWff1mdpgkQh6xhL9ijritmAG9dsHcdNsr9yzAxcbZ8u1	14326	20171	20171	1619569980000	orphaned
29054	3NKvXNvbESHgn86hvBD22LhVrMfrmduWx31PvQ7wapm7213xCKYP	29049	3NKQQFYtBCAHRHDBsEQCReVRVyStWemUs4kJzMHtHAjUtqTXcQoW	1633	1264	569	12463	18974	jwtc3yf2Y14TopudaGKqdAEmRxxxzC57tjH9uUMAQXJsY6NrqF6	14327	20172	20172	1619570160000	canonical
29056	3NL5ZaTDTp2WpjR5RqBFLNFKos7VBipZFXP5A86P1EFTqNf2mduK	29054	3NKvXNvbESHgn86hvBD22LhVrMfrmduWx31PvQ7wapm7213xCKYP	1607	1222	569	12463	18974	jwYypzYnqUZjfy1inbHrbh6QABviXRriJXzjwXuXDb479TxpWqM	14328	20174	20174	1619570520000	orphaned
29059	3NLpJiq958SBTQHMX6QbuWa783KHb7jmFehPcWVu771PJ4TJ2srg	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1529	1070	569	12463	18974	jwNs9tcpUG537tw1eLqAEZ3ifatCNrz4UMekkGkgw9ywPqHGZyF	14330	20178	20178	1619571240000	orphaned
29065	3NKt6cr9UijLrCAszW2EJZgoYjZ5xysByrAzPGcmSBfqxXmSsKeD	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1523	1321	569	12463	18974	jxqwLbjZzoz8mvyjWRi4g4L9ovTJzMCbPsQbumYpSLnuq6docRq	14331	20179	20179	1619571420000	orphaned
29074	3NK9frKLLbKVPBxVxr99g52CaH43ph5szoJJgea8ALAKvAnFVMD1	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1590	1300	569	12463	18974	jwmH8HBqAeEjtx85VHCMkHEwSRtwd24DSaVFa8Zk4auRzVXi1FC	14334	20182	20182	1619571960000	orphaned
29078	3NKkJ8p3Jx6wzb8DnioPG7TjraYMcJjfBHGcpstUJFQ5sR4MGrW5	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1444	1255	570	12463	18974	jxzzNHhdtKfU1tZ5S7GSJpSXZWREoeRTxbWAPp2NcYYAeYWBfpY	14335	20183	20183	1619572140000	orphaned
29082	3NL5TZMf8YvfgsAJPiGwDQ5MzCvVRcP2N1G1B5yvKWWWfpKjvvvZ	29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	1426	1238	570	12463	18974	jxFBsTZHuMaxN9tCmtYX65XEx45xAsy5MDyAhfTEvkcgsL9im8e	14337	20185	20185	1619572500000	canonical
29086	3NLX9vDQc97bEYgcv8ncdvkYfF5gUz7JYrCsynsWRAr767auCtWR	29082	3NL5TZMf8YvfgsAJPiGwDQ5MzCvVRcP2N1G1B5yvKWWWfpKjvvvZ	484	1319	570	12463	18974	jwKLVNpxuTQ46JZjunS6YD76yGjaZfxr7Eya5tXobAdKpXAm7wb	14338	20186	20186	1619572680000	canonical
29085	3NLdzakyjr167AVoAVRNLk7Z2fHFyYfGaUmoH3gJFbDyBs4NwYUF	29082	3NL5TZMf8YvfgsAJPiGwDQ5MzCvVRcP2N1G1B5yvKWWWfpKjvvvZ	1406	1393	570	12463	18974	jwdBJwrGWb8kfE9ZgCqWdogvc5YheQgUFB4To13ebtr4dGfz6K9	14338	20186	20186	1619572680000	orphaned
29087	3NL7V3uQ8EY8n9y6U2wKYKVtaz1w2ceYGtiNArkoPVKm6v6CfoKH	29086	3NLX9vDQc97bEYgcv8ncdvkYfF5gUz7JYrCsynsWRAr767auCtWR	1476	1371	570	12463	18974	jwfaGf59djUzJ9jFeCC4SkZxhftnfU8XhfWa6V4CwVE3jQT5CTc	14339	20187	20187	1619572860000	canonical
29089	3NKPNb1cXYBJJkskjoeANwq6inDBSJe618nG3vY62BVWhBdkNN11	29088	3NKzZqV5CSBWquNqnLbt7rUCS66xwFFhxR5QfAzMwPT3CZUGao8C	58	1035	570	12463	18974	jx425TLk2ewYtaVEm4zXSgW9Hb8nmbz2bfLdaxFV4cLxnRndZSx	14341	20189	20189	1619573220000	canonical
29093	3NLtPuzHjN38a8JvYAhRSPLDLDRawgEZBHESrqaiBej7xAg3yijJ	29091	3NLHEusW7GdHRs7zHVzSetD4tLKxdKhQ2H2BjSeQLsvjZrAnC9Mg	532	1177	570	12463	18974	jwZiteJ7g3fqiMayWXgfU2A9YtTbw3TSjaZe6NkwndoHwv1bNu5	14343	20192	20192	1619573760000	orphaned
29097	3NLXDrDaEu7UJd28PJKn8oEHTzT21oawqvpVk5Ag6toErbJRvo6R	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	1444	1381	570	12463	18974	jwpv6K8FMSQsZyNAXxkSrDpp8X9k2cfXt33ytD2t4JKqsMaHjha	14344	20193	20193	1619573940000	orphaned
29096	3NKXSQMV2pNifWoUyfTvTJPMBR6JrHRPvxNBYtuDhSxZKcMa5Eps	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	1547	1132	570	12463	18974	jwRe9UJCYCkiJmbQtQ5RpbcnBnaEMKwJFPefyGkR4YEUeTq6AZf	14344	20193	20193	1619573940000	orphaned
29099	3NK8TZ6rMLdkUK5Q4w5tQRyn9zdx6cv4sAjBFjNpWhizG2MneMLf	29094	3NK3eQg7A6YM51fHJokbDLTPNJPYsnQNRWZ9KBKm1ZnRww75oEEB	1406	1393	570	12463	18974	jxmfcE9rm43RmNgZF8eJ9iiGpPduVppoNeU2F52uQr7CsqtrqBn	14345	20194	20194	1619574120000	canonical
29102	3NLwbyDz4eVPum2EU7KuthN1C2CH4KbEphG6rW2RuG71vAVj2Auh	29099	3NK8TZ6rMLdkUK5Q4w5tQRyn9zdx6cv4sAjBFjNpWhizG2MneMLf	1407	1395	570	12463	18974	jwVzrDHFE9vTonTPG3Mr5mhnnBZS9LgU1UXLFPcCvVxBF62BuYy	14346	20197	20197	1619574660000	canonical
29104	3NKtjsdrvYmk2e9ASqFRZ4C7wLAtVX4JM3yYskrKdPwRZzVVm8vk	29102	3NLwbyDz4eVPum2EU7KuthN1C2CH4KbEphG6rW2RuG71vAVj2Auh	1407	1395	570	12463	18974	jw8VmLwEpyvpN3GmRR1EbdKCeSWgnXsF1LUvZ64YZwHwfmsrbfp	14347	20198	20198	1619574840000	canonical
29106	3NLPr113AQ9ng1AutPMyPLyYpRzDwmuKgEijYhCuNy4aNfoeaQH3	29104	3NKtjsdrvYmk2e9ASqFRZ4C7wLAtVX4JM3yYskrKdPwRZzVVm8vk	576	989	570	12463	18974	jxgtggketH2ChBy1PvUBk7MdCQA8x5jznJm9ddn1uRNES3JcqCs	14348	20199	20199	1619575020000	canonical
29107	3NKTD3fMQWhXGQeMPZanQg8dgY64Pi8fbNgs9gFw7XAUvMbH752a	29106	3NLPr113AQ9ng1AutPMyPLyYpRzDwmuKgEijYhCuNy4aNfoeaQH3	1489	1134	570	12463	18974	jxR1ogQdTYegNNpXWAk26yzVAGAVQgDra5su4vmbAEA55vyWVnW	14349	20200	20200	1619575200000	canonical
29110	3NLbj7BSVFW3fDRfWqninJ8CfZUYPzfusrfmebENyFR89xapiWPG	29109	3NKEJufqzcWiVsGTgLANQfYJs8DB4DnSD7VS871BRJMVCnCbYtnW	1448	1311	570	12463	18974	jwjJ4aVFV89R1jBNb3aUsQdqwfmKsSynMWAgJoaHdovJztGdrTK	14351	20203	20203	1619575740000	canonical
29112	3NKr7g78pXHjEmzidQqoKh7AynCPV1JqVX9seyGguKbfgf1J21Xt	29110	3NLbj7BSVFW3fDRfWqninJ8CfZUYPzfusrfmebENyFR89xapiWPG	1637	816	570	12463	18974	jxRPgpZeSsuymZNVHWQizuz7K3NVkBUXKa6LxRuz2gZMKUB6qTA	14352	20204	20204	1619575920000	canonical
29114	3NKxvTTkq6JWyZNMWYh72YXjT5hnMiof3Zq14SWfAcTpjQaszeBg	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1460	576	570	12463	18974	jwcaKFCh7eWggdpt7qL1dA3vAqfyFuGJFj9U7qwABeJBvHX3uq9	14354	20209	20209	1619576820000	orphaned
29116	3NLG7stL1DP7RGZB7Q7wp3cVKvFr3zmx7LjWWAbdtGxNZnJbWP5S	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1483	1276	570	12463	18974	jxyZ6Y7aQ85L8hsW32jgWyfg9rMCR5wTpadv4NujsGs5xoo63zt	14354	20209	20209	1619576820000	orphaned
29121	3NLNgQA1bd62TuNP9Vuco91Xn3VSQVnZvWWoVXbKExbWFZ53Gp9g	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	684	1352	571	12463	18974	jx6ieBabac43WMuZSrSAKPqqtF7zYiuJk94mrENDW9WmEM9VN4u	14357	20213	20213	1619577540000	orphaned
29118	3NLNsfxWFaYTSMvS8bCr7S7CTPpcLkoDV82Nzsu1bPEdf27Q384m	28985	3NLxi1yEDGE2kUVmE19Hbo7SS3HeA3A34z5w7LZkF2LMxXyXYKwJ	1460	576	568	12463	18974	jy2fXiLLBDr3Bc2bueUK5p3GPJcAFvSzw8WAHtJ2fLAvhrncyAG	14294	20209	20209	1619576820000	orphaned
29033	3NKgCtvn2mHxnU7nom5GBnU7d5ifQF89cZERde6yMaHyLs8BMtFw	29030	3NLaKvXDmPeNDNWT8r5r1VeXWA77kP1wxXML9RRfwTEQ9YhAn7wk	641	1336	569	12463	18974	jx4EaVHQwN7aioD6yC6Zt1kjBVA1fwMv6oaa2ibuVpBtihh5fH2	14317	20160	20160	1619568000000	orphaned
29035	3NKShtZHXP7zV7jhLgDk5HZLAXis4PCvuxa98GS9Ljx3aABo3AMG	29031	3NKiPF79GYV5hcZ8cJMsJVPLqsgWPSQjvGCwN97WB9wFTvh9Wf1z	1405	873	569	12463	18974	jxZrSPcahShdkA9LjUmaFoKCwvW2DLy7JQXggEggSNND9hPcVAT	14318	20161	20161	1619568180000	canonical
29040	3NKK2U19D3HdZgSPqZBvKchNGeykjUQhG1cvC12A4pSoJzp6Zu3D	29038	3NLJ2n8JLvXmPpQAxaxbDZHEsQtmdPphzUpXdd8H6sV1JNjHR6U5	1489	1380	569	12463	18974	jxzukjGrHLWsRkiiYDcMgXqeFAhw9JQ3G79SDWjr9cvwsD62YYu	14321	20164	20164	1619568720000	canonical
29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	29044	3NKUxMAqc8ZSejZ7tm9vUv3vkYJKE5iMocfjgVT1MFZAfMbbkFg5	1448	449	569	12463	18974	jxvNyUoqV3qJc6egTzdpH3dHFKDjZMBsazA3PkUn31r1YgC2hgg	14325	20170	20170	1619569800000	canonical
29051	3NK7wkLM3i1HgwEeyFRydHz3kEShbsT8T2kR8VBYfcxe3iMJWAhy	29046	3NLLnuXfXt1QdcQBLzrJzMDDxjuQDksH8o7WJKM9Yw7iHT5MUUdz	1527	1293	569	12463	18974	jxWymgygsUbVAAKUywAZZRG2iDQYpiBpgDhbbDzUuVVNnknAYDs	14326	20171	20171	1619569980000	orphaned
29055	3NL5KtGzjhss4Q41SyEAC9prgeGUvFbczHr11R4fGJkHRX69Tcu4	29054	3NKvXNvbESHgn86hvBD22LhVrMfrmduWx31PvQ7wapm7213xCKYP	1402	852	569	12463	18974	jxYEkLV4M6ttmZnRWYh1p3c15xnTsDE9cNayERGy8Wx7zM4Y4xy	14328	20174	20174	1619570520000	canonical
29057	3NLqZWckiuP8wtuYepr9kyYjux9RhMDZ3d3kfrWVQznd3cLGB1Lp	29055	3NL5KtGzjhss4Q41SyEAC9prgeGUvFbczHr11R4fGJkHRX69Tcu4	1406	1393	569	12463	18974	jwC5osA9dXHCTHm5nXNFdLT93We3Y7JCQz3ydUiBiQrzF7ERR44	14329	20175	20175	1619570700000	orphaned
29060	3NKjHdPzwrPyZ21kDNG53nfTKQSdR61hUjZq638Ft6dztSZ5phUo	29058	3NKRfrAAkZdksb7zQEri88br8rUskXzYGSwjrPqqxTVMx4j8m5Jk	1406	1393	569	12463	18974	jxpCsJtTj2dvPgY8B2VNSmmcF9pGtkW9JczstwZkDjiLmsAZQ13	14330	20178	20178	1619571240000	orphaned
29066	3NKw7FMTGZhdT5nWg49AjZd5giPfPDAkpeRkGHBLAPvDCcwxm2hg	29064	3NKQEDxLnHcoX1esjG4JVxAFFyto14Ur1i3kTyvWNeMGnCwBia7z	1402	868	569	12463	18974	jwj8rGqF44mn3FnRK5BGhuJ7qCUo1JUxrtCkzcAKa2qFQGK5yTQ	14331	20179	20179	1619571420000	canonical
29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1593	1220	569	12463	18974	jxyGLQ37Amz1vtEyLbWSPdHCdEpJkMixy5JVPwF9SEFSQQ2gkEf	14334	20182	20182	1619571960000	canonical
29071	3NLMhjrCT5fzXraf6cAGn79aWErBmAhmHmKtEY3bqWXQwTntuQK3	29070	3NKjBfmsTwgWCAdd56mRmMY37pSVbgbHbia6dRJ1uxPr7fBQNB4u	1609	1333	569	12463	18974	jxKSrLfHt3Je4so2pkKzALtj4U7J6qB4C9AJmFXAFr4EyN4tPVj	14334	20182	20182	1619571960000	orphaned
29079	3NKynnUEgmTFrCP7nicmecyYXktDBtydAgbkxXKTnvjKqm4rJu68	29073	3NLdJPR6SVUQDmhGwXRfGoofG5GYj6r5HD62yjNgzEh1RQETGv3p	1444	1255	570	12463	18974	jxoiwk3jbxQAWXqMKCrwij5AVNYjqyfKzsT6mLZmiUc4M4guw3t	14335	20183	20183	1619572140000	orphaned
29091	3NLHEusW7GdHRs7zHVzSetD4tLKxdKhQ2H2BjSeQLsvjZrAnC9Mg	29089	3NKPNb1cXYBJJkskjoeANwq6inDBSJe618nG3vY62BVWhBdkNN11	1631	794	570	12463	18974	jwSmDuck6Cok8bwJQ38syLhTnNhqk9fHZa9bVj97GbNKK1U8GeZ	14342	20191	20191	1619573580000	canonical
29095	3NKAvaXbhERszECkpxn5HgtmF6rTLbSGpbkq85XRpvzcKfvp66PQ	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	1654	1094	570	12463	18974	jx1nGgrhwExBzsyVHbryJT4WVx3s5b2uwcK8GiFfgarzTEnVcF3	14344	20193	20193	1619573940000	orphaned
29100	3NLg44ExKDPVVtq7RzBCbczCD2yPq5dsWqiFAWbiVPHyca9zQRMG	29094	3NK3eQg7A6YM51fHJokbDLTPNJPYsnQNRWZ9KBKm1ZnRww75oEEB	1405	873	570	12463	18974	jx2BSFXXcCa8vDb6tnSEfPp1h1t1mHbHZBKjhKFjuXaKKJ27k8N	14345	20194	20194	1619574120000	orphaned
29109	3NKEJufqzcWiVsGTgLANQfYJs8DB4DnSD7VS871BRJMVCnCbYtnW	29107	3NKTD3fMQWhXGQeMPZanQg8dgY64Pi8fbNgs9gFw7XAUvMbH752a	1599	1287	570	12463	18974	jxrsrfG7h9or9ccW8Ke2US3boBS3cNp3cqD1SXu2JuYYkvj87Cp	14350	20202	20202	1619575560000	canonical
29123	3NLCMnDprxyXjkWKfMeF5NavZtK66eD8pgW9FecamSWfnPPM9Q1Q	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	1407	1395	571	12463	18974	jxiqb8uJkRvAdy4dYt4Q1BGfAQHq4XdAZ9drGNHbn1Fe8SYLLHm	14357	20213	20213	1619577540000	canonical
29122	3NKNuktMUAD7JnmbVTkcbVHsEeF8r7xxpHth4fTAL28x1CocuvAK	29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	1419	814	571	12463	18974	jxc4sMqZE1EgZ8TbzGWeT6SW9P9oopComAP8hsTtZ2X2LZ4hYL7	14357	20213	20213	1619577540000	orphaned
29125	3NKJK1B2Zmc7zthDWRdLUUSEehEB4EkPWGSCZmta6QjPnTjrerCE	29124	3NKDTeeSQ5Zbfh5VYcyofALafZQt6MznvnAgfAfGoXsEBB3EkKmY	1610	1314	571	12463	18974	jwQn5DYk4j4hugzjkhpjgNkY6Z3MXTa3vj3NmAKtEUgJNBkuJAK	14359	20216	20216	1619578080000	canonical
29130	3NKhAWXeZSDfSHkV2DCff2eFXKdan7HP2kpzWKo9N95jbvNbzzzP	29129	3NKp1WQriUGrdVjmpYQfTDhnmkUahB78AqMP91ESYSoZED9ZPg8M	42	1361	571	12463	18974	jwapqcnTNwMPhMp9PiSb8t6GRxzd8tYcmNKYyucmnBMAWo5qNHx	14362	20224	20224	1619579520000	canonical
29131	3NLya2P8dfiTNKBCP7kvNdonVRnu57g4GRydBDSis2yUV9nSrbsU	29129	3NKp1WQriUGrdVjmpYQfTDhnmkUahB78AqMP91ESYSoZED9ZPg8M	1403	824	571	12463	18974	jy2sJFpp2FhFTzxVzDtPZcHvQxT7veHxmWvBbmv8r5kDscFsE8J	14362	20224	20224	1619579520000	orphaned
29134	3NLig89FfDmqnJr4XMMPPY3LKonrFxA7kvVAKayaErrCxArLty8J	29132	3NLQL8hJ5724KwFkNmyjxhgsJu2QMoywrSHgqBd5bvYYvQzyDKhP	1419	814	571	12463	18974	jxcBKiqrDFB9DqRahFv5YidGb6718wV9gYvVyrFrQuRK9UdzTtk	14364	20228	20228	1619580240000	canonical
29136	3NKr4K32nviZfnfp5rwkRSbo2MFPXtDB9UvdCbzwD6E4mdvXQgue	29135	3NKRkjGTWXXEcxB5zg7YjWo3L4qtXju98AmPiKAycEPeUzXFqej5	1483	1030	571	12463	18974	jwcdSxU3bbBVBXeiDyBVbVQdzGgZfBmA97jrhaTnTC9QgaPR8BH	14366	20231	20231	1619580780000	canonical
29147	3NKofUqMvCr1vorUDtgKp3WyEapkpWiEz2995mx9qL2PaaW9dSsS	29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	44	1325	571	12463	18974	jx3x68LvnbmbVoZwkSRBJ98FaC58M7Zn9uFYBs3mkoLzU1zMJb7	14372	20240	20240	1619582400000	orphaned
29150	3NLVvCNzGBKxoBdQwKYJBb5x5zqPRxGoKVNZSt8v9MP6wGbM3xXV	29149	3NKZ3T7itmGb35YuPnzRXg4h8AVrTh4J4PXUTYKH1SUnhZjtroes	1403	782	572	12463	18974	jxCDLDMUoVeWiNTeMZAJKhmFnFP2zyeF3PytbPzAf32Po1PLSA1	14374	20244	20244	1619583120000	canonical
29153	3NKUTKuFpTgui1Bg2pk38CRGDBUpCb9ZzzDD7KtGETc7zFRyXKC8	29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	1607	982	572	12463	18974	jx6PxAFvZvMXP5U39QzZZtG67ufvPsz7djwwemBEpkjgwg16AVo	14376	20246	20246	1619583480000	canonical
29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	29153	3NKUTKuFpTgui1Bg2pk38CRGDBUpCb9ZzzDD7KtGETc7zFRyXKC8	1668	1370	572	12463	18974	jx6jLC4eo6om5qa8s3JyBeTSnffTYQVeSWBcgyHN9BttPDHaLgP	14377	20249	20249	1619584020000	canonical
29158	3NKNMcqrkGAnKshnQvPVjAbs84yPFAyUkGpNyEWV5gzAMAqbamZW	29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	58	1155	572	12463	18974	jxPDXmh8GkmVmVEeinymtDhMxDg2yjitbd3rWgZgrhfQy5wCohn	14378	20250	20250	1619584200000	orphaned
29128	3NKGCETcA3YRyHnzpxJJz5AC9Yw6qYnaSfhyGTKMaLBi6LtnSJjc	28901	3NLcQic49yZuF3tEFqPrBvpQhprUvR8CSnYsLFZsLMdefuAo4pXR	1455	1332	566	12463	18974	jxkCRptjo3hX4rdNaHZuEvtBUBLn6KFFPERrgLtTHNnsmGLoGS1	14246	20221	20221	1619578980000	orphaned
29105	3NKGWhkydLivpysWwmmJcj4VM8vApPbWf6GVXQramokEKpLGxjHK	29003	3NKVLb21nVAay3puN11ivZCkggSDGnem9qHKDbjbVBw9qboBpp9T	1611	1215	568	12463	18974	jxyxtryN85UGoUzrZcqoR7TEZXNa8r9QwTTvHxEGZs4HNv1wPqF	14302	20198	20198	1619574840000	orphaned
29084	3NL5MiEdE9ZgoJFLD34CBpSRzW1QXxxZQrPFUJsqUevqKFrDVeqE	29081	3NLbL1HeSTqropFy7naYKJQqFSKWFzpnBrGz8wSKFZTNPXvjPEcL	1483	1030	570	12463	18974	jx5QNxu87SHYXswzN45WevWfcu2tTuXCLDfqFSypHpdMZVQUSbK	14337	20185	20185	1619572500000	orphaned
29088	3NKzZqV5CSBWquNqnLbt7rUCS66xwFFhxR5QfAzMwPT3CZUGao8C	29087	3NL7V3uQ8EY8n9y6U2wKYKVtaz1w2ceYGtiNArkoPVKm6v6CfoKH	1407	1395	570	12463	18974	jwr6owQN2AVo4PJ4e5XQof2UpCuQhT4U9soX2CAinQvMFjoEFbB	14340	20188	20188	1619573040000	canonical
29090	3NLegL2fkbyHvSEVqBzQ1BHkDZACHCeujd5UnPUjdpcyR8Caobg9	29089	3NKPNb1cXYBJJkskjoeANwq6inDBSJe618nG3vY62BVWhBdkNN11	532	1057	570	12463	18974	jwMejDXGej8t1G317eyngKMb3U7oN3bitwLhakqkCyPkDG6tYAg	14342	20191	20191	1619573580000	orphaned
29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	29091	3NLHEusW7GdHRs7zHVzSetD4tLKxdKhQ2H2BjSeQLsvjZrAnC9Mg	1522	1322	570	12463	18974	jxwA9GHTJaBXZZnYaxrTQ2xeLDvaiRSQVCfFoAXxZwpBtn3Uy9G	14343	20192	20192	1619573760000	canonical
29094	3NK3eQg7A6YM51fHJokbDLTPNJPYsnQNRWZ9KBKm1ZnRww75oEEB	29092	3NL9kEdm42tcc4XkWJgdb3Bs25R9vX8TkBpqecNtxqXxgvqqBx71	606	1049	570	12463	18974	jwQ7bY19Rs8qdGuiijWoMZNqZfTE1kKtREYbi42qe4L71m1XHhX	14344	20193	20193	1619573940000	canonical
29101	3NKrYj49ix19eA9GwLd3eKY5MqBDXu8LT2fRkfDm2h4eWrPx8RLy	29099	3NK8TZ6rMLdkUK5Q4w5tQRyn9zdx6cv4sAjBFjNpWhizG2MneMLf	448	939	570	12463	18974	jxkdkmYqDPpZQFjQj3jhpdSozNK39DemPYYSArXhuRGwsakeqt5	14346	20197	20197	1619574660000	orphaned
29108	3NKKi5RaGgKSPYHx6x2HKG6XjsTBkNdRpXCteCKLKhnaRqWBxrST	29106	3NLPr113AQ9ng1AutPMyPLyYpRzDwmuKgEijYhCuNy4aNfoeaQH3	1419	814	570	12463	18974	jwHVUqZ1bjPHrJikXQ8tf8Ta9B4vQVp5HPvmRdB5uYvorVdGuLQ	14349	20200	20200	1619575200000	orphaned
29111	3NLsyrRmLtqw5fdmsdQKBQLyR9k8U95uos2hB9rkQTu6CzpwdKPs	29109	3NKEJufqzcWiVsGTgLANQfYJs8DB4DnSD7VS871BRJMVCnCbYtnW	1448	1311	570	12463	18974	jwyusRTv42Rhe7kAxShdevr81BHN3uhWni8bxhyimmesv3rE99V	14351	20203	20203	1619575740000	orphaned
29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	29112	3NKr7g78pXHjEmzidQqoKh7AynCPV1JqVX9seyGguKbfgf1J21Xt	1637	816	570	12463	18974	jxBnRbYKJMY8nrAjREkrVEjbaXAx8SYo7S3B81C8ToHC8aDCjbK	14353	20206	20206	1619576280000	canonical
29117	3NLEWtDwmPTE5JoXFUnT8Jwuja8N6hSKMEj2HQJaXA8gJjzUiiZb	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1647	936	570	12463	18974	jwNwmTpGmWemmGzQS3EjsVWMhqfZLeetCmTy8yJ9vj8PME2u1A6	14354	20209	20209	1619576820000	orphaned
29124	3NKDTeeSQ5Zbfh5VYcyofALafZQt6MznvnAgfAfGoXsEBB3EkKmY	29123	3NLCMnDprxyXjkWKfMeF5NavZtK66eD8pgW9FecamSWfnPPM9Q1Q	1406	1393	571	12463	18974	jwA7NvzGS8Wvkn18ZsSAqRs8voL4Z5u96Piyvv13X2DafRi8yTr	14358	20214	20214	1619577720000	canonical
29129	3NKp1WQriUGrdVjmpYQfTDhnmkUahB78AqMP91ESYSoZED9ZPg8M	29127	3NKGPLEmNG2tDFWnfBai9m4y6m5xYKeK6c9T5jyyizAJo3kjsFmG	1406	1393	571	12463	18974	jxvyvQEXGtPpsWksEiQC4mGb5pgKqDYSP6f3x3syaokSghpwCkP	14361	20222	20222	1619579160000	canonical
29133	3NLMmDtwQqaYAeF7WKSr2YjsPDGbG6fUUk7y5uVipKrcGtdnDuaC	29132	3NLQL8hJ5724KwFkNmyjxhgsJu2QMoywrSHgqBd5bvYYvQzyDKhP	43	1310	571	12463	18974	jwLDPfWPBdVKvNBNUjEwjEeGY7yV2uXvr7kGc1kMfhRvpcVLWc3	14364	20228	20228	1619580240000	orphaned
29137	3NKrUhhvmibrACmCNUWenxCrD9DcH8oZMhoc4foD9cXCbgfYw6vS	29136	3NKr4K32nviZfnfp5rwkRSbo2MFPXtDB9UvdCbzwD6E4mdvXQgue	1610	1068	571	12463	18974	jxiekWMHPJGJgrnranbvTDacrkKBcFUgVKqPCKz5NviG4jyk9wN	14367	20233	20233	1619581140000	orphaned
29140	3NLmjfkY5VKn5hFYzpQJ9JTnomUkCsuCMVokzfDxCuD1nwEqatn1	29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	1402	868	571	12463	18974	jwRrQ91cJyBZvZ1eTZFHcMLbfbz4axujjc5e5XKdMn2VyuJ4YAx	14368	20234	20234	1619581320000	canonical
29139	3NLooJYDtdDSaAN42BwHnHUyWwihRsSFD8hw889rfMgXve83MBxz	29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	1579	1389	571	12463	18974	jxDipW76paUmwYxbGsU5kzJd5YWsexNHxusgS3gVG1DRdeG2SfD	14368	20234	20234	1619581320000	orphaned
29142	3NL7tKvBJVGiq7sPVD5rWVokE9pTHbkntFQYJbpVZ5dH7uqrq9Cq	29140	3NLmjfkY5VKn5hFYzpQJ9JTnomUkCsuCMVokzfDxCuD1nwEqatn1	1407	1395	571	12463	18974	jx8BQ5WYctuLFLRqJtjjs2NhbBLMtHMAEucXU91mvj4tESuTJEb	14369	20237	20237	1619581860000	canonical
29143	3NKPkghiQjAehKJKc7Jtk8XJx8Pv3V6XmsPCkCvYxty7iQGy9KEc	29140	3NLmjfkY5VKn5hFYzpQJ9JTnomUkCsuCMVokzfDxCuD1nwEqatn1	1601	1142	571	12463	18974	jxgE6H6N6ASwtriAyrBvq4gJK8fsF3C1g57mKtgpaytdez1wLek	14369	20237	20237	1619581860000	orphaned
29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	29144	3NLJAQhCmDnRoBuQU1wPDe7dVBsDSS3Jrz9UxqJZ8TjrV1fBUou8	1578	930	571	12463	18974	jxgoyDP6wtWJm2ruMreC7E56AhUUdGbuNQmDwxAoY47XLhqY4JP	14371	20239	20239	1619582220000	canonical
29146	3NLaV6FvZ79UtcYd9E3vTKebwZLM8ooPmi8Jr117qdBK4oDrN792	29144	3NLJAQhCmDnRoBuQU1wPDe7dVBsDSS3Jrz9UxqJZ8TjrV1fBUou8	532	1177	571	12463	18974	jwUAYmuuhHeVYLu1jfzx3RGHLnVPUSzvz9QZRFDowybYaM4koZQ	14371	20239	20239	1619582220000	orphaned
29148	3NKMmWCzkE3aWN4eagsK3cNNLBCSNNFBBJXVotRi3nYsCGdivbQ5	29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	1670	1156	571	12463	18974	jwzmmbJGie1KuqeXsnRh1wG24MPYeceQe4Q1YPEMXWWoW9dEN8N	14372	20240	20240	1619582400000	canonical
29149	3NKZ3T7itmGb35YuPnzRXg4h8AVrTh4J4PXUTYKH1SUnhZjtroes	29148	3NKMmWCzkE3aWN4eagsK3cNNLBCSNNFBBJXVotRi3nYsCGdivbQ5	1622	1356	572	12463	18974	jxDPR6cVQkJbYf2mqG3r8KX4vCJK5zNc3XHKHY5AP9rhR2TeE5b	14373	20242	20242	1619582760000	canonical
29166	3NLTPUFm6vBzUFygWbEyVodzbqMbm5xtz14fdBJhxPK74Qbtq81H	29149	3NKZ3T7itmGb35YuPnzRXg4h8AVrTh4J4PXUTYKH1SUnhZjtroes	1527	182	572	12463	18974	jwUuTmN6tcACGPugsFMeP6r1XztkYsByiMo4DjD3yJi6ZiYzqbj	14374	20252	20252	1619584581798	orphaned
29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	29150	3NLVvCNzGBKxoBdQwKYJBb5x5zqPRxGoKVNZSt8v9MP6wGbM3xXV	1622	990	572	12463	18974	jx2ybshScsjKtwT8UwS43wnF7dtuFGKxTbPeiTogqYLXmidCgYH	14375	20245	20245	1619583300000	canonical
29152	3NKgkoKad3LWw3q89VrfrFVf5zkvJrWKBeRPaRxUfXBLgAtFKVo6	29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	1546	1093	572	12463	18974	jwFR7N12ZrHhQPsvmk71t9EYkGKXZzvgEvkkmaq81nUMje7BjG3	14376	20246	20246	1619583480000	orphaned
29156	3NLouyWzviwWsNXziv75R3xsec32U22d9gLN9vFqTonKxQqAJBJE	29153	3NKUTKuFpTgui1Bg2pk38CRGDBUpCb9ZzzDD7KtGETc7zFRyXKC8	1581	778	572	12463	18974	jxgVy9JAcTpXeF5pg3mJ3knPz8cAXVN742dEEPgdpBmpSGWQWSe	14377	20249	20249	1619584020000	orphaned
29157	3NK452zRMhxNDTV97yjz3v1pFEMFu9B1Qj9TtXpSz7Z2vqrzT9gz	29155	3NLrk6KhKGWF7VKDDLThSRLuxUcUgTcAtGr6RqiZZtgvxBBk8bGL	1671	1365	572	12463	18974	jwQ4qQKKL9fWUVNWBWUVJibnEq5VELceoPvhC7KmCWFV7ot6PAX	14378	20250	20250	1619584200000	canonical
29162	3NLwXVzZfBoSVMrfVXzFcYpS8u9Q2LHwYLkwDFsNKWPdhgpvhjoh	29128	3NKGCETcA3YRyHnzpxJJz5AC9Yw6qYnaSfhyGTKMaLBi6LtnSJjc	1455	1086	567	12463	18974	jwcdP6UfzaHtCzXnUAxXrEBVpxs8x3L5SehysRHDHFJRm7JavLq	14247	20251	20251	1619584380000	orphaned
29182	3NK5dUXUUUkUajCkTUbSK5H4t1Jw3L7VQGWTCfgozC5xu9cdkxKB	28949	3NL5HBRmxNdxcV8SJB35FygXRspfvAJyBLMpsGRrXunqVD3GTWEy	1576	605	567	12463	18974	jwZLZoojPtBgqd5ioLfKgfB3hopaXG7vCNHsqq8b6EB8B6a1E38	14277	20261	20261	1619586180000	orphaned
29115	3NKve8V64zaB735zAUTKT7YS3rPkV1oyPEdW5un5c1cuguZ5mEbG	29113	3NLRwdT13GVcLeGf83Bd4nt3SNgDenh5t88gNDHJtDTufNVJiWX1	1564	1338	570	12463	18974	jwqKjxwQuhkkikk7XtrhDphGPhUhdwVEiGYw3uMMFanNahBd6YR	14354	20209	20209	1619576820000	canonical
29119	3NLZNKtLz64xYRYNsb7fWMrbLKdRyD5HhyLEQ2xpXBZo6qg8ygpA	29115	3NKve8V64zaB735zAUTKT7YS3rPkV1oyPEdW5un5c1cuguZ5mEbG	1406	1393	570	12463	18974	jxCEB84BokBMawSKrpkrdmVdh2QZhusC6Z6Xb5sJf8LFdwz71x5	14355	20210	20210	1619577000000	canonical
29120	3NLrHxeECVfJUkGxB9kMa1vZBVMu21YYLrFwEsUBZmagtyHThQmc	29119	3NLZNKtLz64xYRYNsb7fWMrbLKdRyD5HhyLEQ2xpXBZo6qg8ygpA	1406	1393	571	12463	18974	jxbveTpSy9E95ouSL72H1oUxi9fBfmajGuaQVCE8AYJiEwQymru	14356	20212	20212	1619577360000	canonical
29127	3NKGPLEmNG2tDFWnfBai9m4y6m5xYKeK6c9T5jyyizAJo3kjsFmG	29125	3NKJK1B2Zmc7zthDWRdLUUSEehEB4EkPWGSCZmta6QjPnTjrerCE	1633	1144	571	12463	18974	jxGBd8TDkrCqFzucadG1NLCpZEcqsXQE9KqVU2xpzzVBu3rLU89	14360	20220	20220	1619578800000	canonical
29132	3NLQL8hJ5724KwFkNmyjxhgsJu2QMoywrSHgqBd5bvYYvQzyDKhP	29130	3NKhAWXeZSDfSHkV2DCff2eFXKdan7HP2kpzWKo9N95jbvNbzzzP	1633	1390	571	12463	18974	jwQGpLBpGvvbhQSBb8gu7MG982SaukabyU4qiVXhiLMTcnMrDzw	14363	20227	20227	1619580060000	canonical
29135	3NKRkjGTWXXEcxB5zg7YjWo3L4qtXju98AmPiKAycEPeUzXFqej5	29134	3NLig89FfDmqnJr4XMMPPY3LKonrFxA7kvVAKayaErrCxArLty8J	632	1136	571	12463	18974	jwuqfTSE2KXXUfmSSZNYv6warFJmAzV2qXt6wbCJrAREXH6EJPY	14365	20230	20230	1619580600000	canonical
29141	3NLfomyeHD1jFn7aoTravEfGLspQmhGw494KTdQiu7QwbHY4DoEh	29138	3NKE9TobQhePDwCR8BMFFtxKKxNH4txrzZmCf4J7pkBMVgLaThFH	1600	1246	571	12463	18974	jwD6EiJHLNrKMgwL8qN6TTHRM4qxxesahFBmoCfRS5s6C7pGvTc	14368	20234	20234	1619581320000	orphaned
29144	3NLJAQhCmDnRoBuQU1wPDe7dVBsDSS3Jrz9UxqJZ8TjrV1fBUou8	29142	3NL7tKvBJVGiq7sPVD5rWVokE9pTHbkntFQYJbpVZ5dH7uqrq9Cq	1578	1050	571	12463	18974	jy2ifMzyPBQjQzLbk8YYyyhe8gWadKsjaatrAgEKPPMSpd5kUF8	14370	20238	20238	1619582040000	canonical
29154	3NK84kZxXVzWo7rTjtCWuM7J672woUxAwYHnjttPF797MPGkU2Cg	29151	3NLuU6V6wDsn965oLE3gdTxnqikfq1ZGhaSgpsK7WEfT1o45SNJh	1607	982	572	12463	18974	jwWgV4Tnm5aWYpQ1aWdBqKCy96jhKbJsFcdrkkaJosXFVA4ys1f	14376	20246	20246	1619583480000	orphaned
29165	3NLe63VZvtx2iamGbxnu2KVtJkBhHJhqytSQGZfssLZBCo6Czajn	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	596	940	572	12463	18974	jwuhy8TrpmQrZhgrnxXFnV2YLXv7jXKd4x5eP3BTJriC6acy6mQ	14380	20252	20252	1619584560000	orphaned
29169	3NLEK69BaztKr7WqbSbB8C9m1BGa1dM4uzACF541NiCFJiv6kEtE	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1546	1339	572	12463	18974	jy1UgCiPBroMBctsd9iSBh5BeRk2nsaV8jwxDdQLaevG7629fWm	14381	20255	20255	1619585100000	canonical
29171	3NKvkEcWGpKRc279m2Kw9JBrs3GQ7uNUvJAaG7mqTAPaoz45TL2E	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1546	1339	572	12463	18974	jwVt198yMVu1AogU5Qut1CBaWVoEr4NivxfZbbduvwtUH9Kd7bT	14381	20255	20255	1619585100000	orphaned
29175	3NKMR2TwA8fweRwbXVP5hM2AZRn3BEHsbDoYcy5NHDvfyAjKFWrE	29173	3NLebam3hDkSxK8E96goFFddwDV6876EVWQpmm8WMgiib5RFFbJ7	1407	1395	572	12463	18974	jxhswPd3db95djr16ygatX9xvLr3BMchNNQtPvDUHo2yiiCELwL	14383	20257	20257	1619585460000	canonical
29177	3NLaSGGy5hXcDuKh2PtprTKdz5Um39FLVE9yhp3HXhpk9TrKXWb8	29176	3NLQH3a2chnePwhuJ5XMPZroUWjcSPuMMmAmkiXPxDnmpxaFZcmK	448	939	572	12463	18974	jxDUup2tjtV39pqcPVigpYupcwaA1wy8pCzfHaejpM1dhfXeMzM	14385	20259	20259	1619585820000	orphaned
29179	3NL21XtsaRD3qS9WV3f26ycgybCJa8Wh6QGyGLJuGKA9CqveDx5N	29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	1668	1244	572	12463	18974	jxZS7myk1t89rco3HBWZQDwBjGUpda8Dx3WjRE1bkbAia9vxL1E	14386	20260	20260	1619586000000	orphaned
29187	3NLPsfUfJqBRwU2GXRCWKW5UVrjX3AtKxjP1vxkuYML9WBmF5Sio	29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	1405	887	572	12463	18974	jw86UMEKdSiZe7NoY3hR9zagLUdFGetKKbV5w8xyJZRagZqD2cm	14388	20263	20263	1619586540000	orphaned
29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	29188	3NLNGG68X77KHd8rDMVLh8QmswJpwoUjZyPaK8PBkEcXnukfvMC9	1593	1346	572	12463	18974	jx63UTHNCTGYjw7cofJKr8bwjx8qd6suQpUg6y1oNtDdhuFEsG8	14390	20265	20265	1619586900000	canonical
29195	3NL96aJSJQBPdbUzLTNY6x2jsgb4XTszCerLZr5DSRTexURK1ELr	29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	448	1305	572	12463	18974	jwN9vodGqv9go4PadYuS9bJAw6P2dLRUfkLMt76VmjFGSuwejNC	14392	20268	20268	1619587440000	canonical
29194	3NLUXbKpvUn1Rh5Eiab2cwPB8XZ1Z3MXkEZLyXXnv1DnxGnxSfdY	29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	1587	1231	572	12463	18974	jwXTaUcFfwgQznv6oEMEtLvCQBQvVVeR6TgUvp6scpEBL5xxSRj	14392	20268	20268	1619587440000	orphaned
29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	606	1049	572	12463	18974	jxaKDJYCUq3S95n19j5CGZJ4uCgs5Ff9syF8nVeveRUTDADmqMS	14394	20272	20272	1619588160000	canonical
29198	3NKQHjm9YagKejBZRNsHPo5hEYyXe4HxjRbWpYQU1poHjqwGv5Cx	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000	orphaned
29201	3NLwvexAwcqrRJVsae7geCwM3Cx69aDnBNw7cTALYTKCx4r8RK2Y	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000	orphaned
29204	3NK3s7rK7vcN2qySga2pkri7UhH5rTQH1rJLzJTye2jEiFPjtvwX	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	606	1049	572	12463	18974	jxTeAF1eSoBk9UZR7wjv5xvHxvDmeMj4h9VRiS3GRQaLttXfk4b	14394	20272	20272	1619588160000	orphaned
29218	3NKpo7Ti8CsABdwtB2J4YeMmkRTFF391vQt2e8KBBXbAi8K7Sn7e	29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	641	1090	573	12463	18974	jxXAGDinrg6nFk6ZR5A5HfY225jS4vR7PGPmpLSV3u7DDUzsJee	14399	20277	20277	1619589060000	orphaned
29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	1471	1020	573	12463	18974	jxSkB1kXA3DDVNx4AUtKecXGzYcvsMUkM4N6wZBKMgnpmQ21ej2	14400	20278	20278	1619589240000	canonical
29222	3NK6xcmiNPdez2vDGiW2oSWswAKa4eU1A9fdSfJV1wJUoYZGxwNj	29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	80	1273	573	12463	18974	jxrD5hxLkFTWhVJg8cmqLF5YeS4edikT9fEGvypp9E6okapadFg	14401	20279	20279	1619589420000	orphaned
29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	29161	3NLN4GyrqK3c6nidNU1Zksn11VJSrazRc2vQsKVQTPMongFEkXtq	1527	182	572	12463	18974	jxxfkzqXztCeggZRmkdFXZaCTpC2UxP1wAVFdQJDVGEjsoULhs4	14380	20252	20252	1619584560000	canonical
29168	3NKXJVHAfeKUwpzwvcefPcTe6D9vzmkMvDfyCssDbe9irZ9iCKX6	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1406	1393	572	12463	18974	jxAPSK34P4j2SUxhCKp8cSkPJo15g2QTRNNXEzGMKCqjTPTG9qr	14381	20255	20255	1619585100000	orphaned
29174	3NKUpAZn1JvMCZAb6dXdnbpVPJwvULwE6qwtPM1sG4L1gHvTVHYc	29169	3NLEK69BaztKr7WqbSbB8C9m1BGa1dM4uzACF541NiCFJiv6kEtE	171	1248	572	12463	18974	jxYoenRaJJRtZ8SUckMmVfhgFxCgW93m7Cc4XgKdY8j23wmAwDe	14382	20256	20256	1619585280000	orphaned
29180	3NLuwvnrtZJ4BM92DuC1oW9BByFR5jzsoHdzECMLaFyHR1wpGCPd	29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	596	1060	572	12463	18974	jxqza1vQfuCrXDFPkd16UKTj6TyWwRhnQfyAFx2R44maaxERcU3	14386	20260	20260	1619586000000	orphaned
29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	29181	3NKehreegkPWiQoUEztUgc1NLC6jPhZ7HxYAmjwpiRVF2TEfzFoD	1576	605	572	12463	18974	jx4Ksa1gCZgkDVBqD8GNubyz3g1ddF2eduMEy2fHFMxzMAJoFYa	14387	20261	20261	1619586180000	canonical
29185	3NKi8y4qry6MvYKHaB7FSCgME1emAdLrKeuUdAV1oUPWdDdVtxbV	29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	1671	1365	572	12463	18974	jwXukMRhLg3u1uffcQnGradpL12ZXPMrScr43LNBJxHMrna81w1	14388	20263	20263	1619586540000	canonical
29192	3NLKYMukZnqpa1TNSnRB7xzgYDAEU5aH5eoxvANYk2oqXwcoWFfm	29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	1407	1395	572	12463	18974	jxyXyzd2iEy47Ejq74NhxwWp2X2qFrNdhezfFinyqPfic5f3REQ	14391	20266	20266	1619587080000	canonical
29190	3NLHzFnxKmu8ijHtvox7ToP6oY9YLMX2y9KXXuqkXngZAg8b1s3S	29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	1642	1121	572	12463	18974	jwVycF3qczXAVVpF3aYFpL7SjRV7jDrBFfgWeFNpgDuELFNmkqS	14391	20266	20266	1619587080000	orphaned
29199	3NKHL6PDevkeWNLaMJvXmp1ZWt7J7WFLpow8EE5bi64P6sHrxFhZ	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	606	1049	572	12463	18974	jxTeAF1eSoBk9UZR7wjv5xvHxvDmeMj4h9VRiS3GRQaLttXfk4b	14394	20272	20272	1619588160000	orphaned
29207	3NLNuDrzMkjG38AS22QWRvooAxKCESzT81xAHrbMBxpvVMpPqbzd	29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	1523	955	573	12463	18974	jwzBX7FTiXXy5V8HUngaLyWboQytW5qCWhWAR7zrPyVwM19hvWG	14395	20273	20273	1619588340000	orphaned
29209	3NKKnWMiBcPynVJ579c8xrDgioVQie7pgAkwoBuuVLUdQ96CD6SR	29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	1611	1215	572	12463	18974	jxB1rXYsRHNotfHeUFHpmavVqhuot8YNvEF17RgCN6YGsVjc8bD	14396	20274	20274	1619588520000	canonical
29213	3NLew4jw2koGL117GDGXhtPh2F61XAAD8TjCapbJsKJVFTj9oHD9	29209	3NKKnWMiBcPynVJ579c8xrDgioVQie7pgAkwoBuuVLUdQ96CD6SR	58	1035	573	12463	18974	jwBqSWamLj7F2KbHzmyebVQ88XZpfaTtwpK1QzzULnAUKaRHCbh	14397	20275	20275	1619588700000	canonical
29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	29213	3NLew4jw2koGL117GDGXhtPh2F61XAAD8TjCapbJsKJVFTj9oHD9	1406	1393	573	12463	18974	jxP25t9rC15vxfDqTeF7r4JFCFJmZ3a9GzJBCvV1nmiS7q4jUSW	14398	20276	20276	1619588880000	canonical
29217	3NKqVaVRcxfh6MaHuoSH4kipEfPruxihVGir5GBJ4KatASXtueLf	29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	641	1090	573	12463	18974	jwxTJAKcCsJXon4tMu9wWTsDTUa9UdKn6EyfwpymaW9LCbKsb6i	14399	20277	20277	1619589060000	orphaned
29224	3NKFpftgMJqigqSXZRVRcJKRBoVV8P7jVkr7kAoTLiRzRBVB2MJM	29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	1407	1395	573	12463	18974	jwdQfJWA6wSFgUcznJUGompfZrkuqj2ydSDVNFbPzDSNzjifaVY	14401	20279	20279	1619589420000	orphaned
29226	3NLRU4dtox6saK6PX5LJpKezzH6jgLjrugCwLHoEjWdbb7HuyKxL	29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	1590	1174	573	12463	18974	jxrUZU1XCHdUCcuVAVbW4nHc2LsK3gzhp1XyHz4gtUYj1HkWgBQ	14402	20280	20280	1619589600000	orphaned
29229	3NLya1F2DzDbg9viXYDkWrBdEosUrgrfWP8Apduv6ohrP29RcPU2	29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	1407	1395	573	12463	18974	jxw2CYXUdGjjW3gz5ebNq4TwpQuipBZEBo4n6caBa8iLRXBaGZA	14403	20282	20282	1619589960000	canonical
29231	3NLdrVkji33Uj8Hxjv6SeuEvtsDJ2qfcC7Pk4XEzqNXB8HQ5z7Ft	29229	3NLya1F2DzDbg9viXYDkWrBdEosUrgrfWP8Apduv6ohrP29RcPU2	1633	1390	573	12463	18974	jxTgJG7szbMwFHte2pMvzf7v7LVGvsB4uLNJ2TRiHxmThLzrjQf	14404	20283	20283	1619590140000	orphaned
29233	3NKCZ27aqSXc29mAR5RaRjfiiXsWi9HcXsLLWg5nrHM6U3Ni6rqa	29232	3NK5LPTZFJthP2hVtNhW5XEMhLsRbTNnUq6G1QzdUeg55vu2JAR5	470	1309	573	12463	18974	jxboT61G5XSni4s2PycFra6dnqAC1p8KbAP5EEEtz5qvdvmiavQ	14406	20286	20286	1619590680000	canonical
29235	3NKZxMfoA9bXFFcS38droHhSipx85vzmVpuYagXecY8nWH2RKoMT	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1523	955	573	12463	18974	jxEZptuxL2jWX4vNxq6R751djm9yMjWZwVp4cP4Xj2kHLT2fLHm	14408	20289	20289	1619591220000	orphaned
29240	3NLpyvaM7eStC8w9BsiAHxf34oS8YsYecNeb7yRri9Z2A8Lmmowh	29238	3NKyFGguywc7XXArbsv1W5AmqNYfRFHyT7rTPkYZYMZ1BNK654u9	58	1035	573	12463	18974	jxpjm9LnbDYvWCN7MxKSVPQwjLPhCLEXcZ7WzcEppYfmqnLoXpm	14409	20290	20290	1619591400000	canonical
29243	3NKtMxkr1aHyKmjX9D6k7kobwgnAP22g4RUrbx42WA83SrkEHXDL	29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	1553	776	573	12463	18974	jwpz6xBLxx5kUyBAL3PYnXkE99trTDKr44owLu76D89XEkFJEjY	14411	20292	20292	1619591760000	canonical
29242	3NLtKwEKESe7favNxPwQP2tcyCA3NH7w2iyVT24hWS3iXyUyDKaW	29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	1403	782	573	12463	18974	jxESE7PZqFonZjJNezsPj7VonU6vhQWfpJyGh3ozqJu7CdBP84i	14411	20292	20292	1619591760000	orphaned
29245	3NLq8W5qwmxomA3cAMt6G21DQ18AVVMSnGaAGNso3Yv5t6KTDVNU	29243	3NKtMxkr1aHyKmjX9D6k7kobwgnAP22g4RUrbx42WA83SrkEHXDL	1407	1395	573	12463	18974	jwMsN3MqHcotVPj2MExe2zreaLJnshWMv5tjUBqM6pw9DT75cum	14412	20293	20293	1619591940000	canonical
29248	3NKit44Rk4PivHjXgNvpatDmKTGS6QKgnFdKLpMomzvyryfnp2Cx	29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	1578	1170	573	12463	18974	jxaTkTz83GgunFx5uq5BshApxMjUuCzeJSHnwjFP25fMYN1zYDV	14414	20296	20296	1619592480000	orphaned
29252	3NK6wo3MnEZ5HnixFKeeNGvyBNscCcdK8Ud7pXRBeKbubVdvXizP	29251	3NLEoTqW5GYXjYKMDyPo7LDz5YefU4Txk2qMymandddao3B4Km2Q	633	1258	573	12463	18974	jxskLeizVRCsXQUHvmRKw79XVCPVRjwVLZPEVgF1MArUHnh6VLg	14416	20298	20298	1619592840000	canonical
29255	3NKE5eVWxhC5BPcU12gyY22YxHRwwJXfSMbfGtFTAiaBk23ivKdd	29253	3NKok71rtcmJcbYSLh6UDzAEgvegYh7XkhHus6Qq4vmdG9jhVNW9	1564	972	574	12463	18974	jwWdSfP54jvQgzL6hEuGPpdNhbLsrRv5EUp2x3ddXvmhgmVJ1aP	14418	20300	20300	1619593200000	canonical
29257	3NLA1YKyeM5axLc3og2yd96m1bxC1fGqrWCNBukpoMBQnQoan49T	29255	3NKE5eVWxhC5BPcU12gyY22YxHRwwJXfSMbfGtFTAiaBk23ivKdd	171	1248	574	12463	18974	jxKL6iqYCeZRciN4wL12KGs3z1rSVSWuiLs2XAURCxLt34ayqiQ	14419	20301	20301	1619593380000	canonical
29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	29260	3NLPXRi3f9R4FtuSoGiLvyiTw8jZHVx25Z3EbE8WLQPSnoYV4VzJ	1585	1366	574	12463	18974	jxPZ7ZiNEiRe4MvWDE8wUSzvEF1BFKaEdPUxWs7vXKF9h3Euzam	14422	20304	20304	1619593920000	canonical
29172	3NKMDh4qk9KBkoPtDfJwd3sGFemWWzp7gRShPgV1xao6uTrwvAwV	29164	3NK3go1RapxduTKL4p8k24oiQypGhCRDkREJrTdFJjkveEDPfhSi	1668	1244	572	12463	18974	jwtTf8RjrxtvUQtxMtRgXo5NXk8ZHnnd5UXksS7FdJ5MMFidvhy	14381	20255	20255	1619585100000	orphaned
29173	3NLebam3hDkSxK8E96goFFddwDV6876EVWQpmm8WMgiib5RFFbJ7	29169	3NLEK69BaztKr7WqbSbB8C9m1BGa1dM4uzACF541NiCFJiv6kEtE	1402	850	572	12463	18974	jwoQCV5b13TucU41Y9tTR2WaZHDkqMmYHUrd7xs4DUWarotrE2Q	14382	20256	20256	1619585280000	canonical
29176	3NLQH3a2chnePwhuJ5XMPZroUWjcSPuMMmAmkiXPxDnmpxaFZcmK	29175	3NKMR2TwA8fweRwbXVP5hM2AZRn3BEHsbDoYcy5NHDvfyAjKFWrE	149	917	572	12463	18974	jxHWuzjbLdzwhrQSg8oK4WJp4B6CX559AVqN7NzFnCWWykMjo6z	14384	20258	20258	1619585640000	canonical
29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	29176	3NLQH3a2chnePwhuJ5XMPZroUWjcSPuMMmAmkiXPxDnmpxaFZcmK	1474	1083	572	12463	18974	jwGhCQjrGHVuPGERhERvJCVT9wHPwvuFLvk2emJLNTfBkjmDaao	14385	20259	20259	1619585820000	canonical
29181	3NKehreegkPWiQoUEztUgc1NLC6jPhZ7HxYAmjwpiRVF2TEfzFoD	29178	3NKeB7BrTVncwtjedqZwv6YfN6pjqTt3ec3xnnXVHJFR3povKPpA	1407	1395	572	12463	18974	jwT3AVDmDPCWcRifcZDWC8LSfLgJizbTSDLFMZeY2CQMcYHGp15	14386	20260	20260	1619586000000	canonical
29186	3NKPUvt2EFSrDnQeWxsBpQW8b6yn7iJoZ4MZJjUo9EhHbGWkyniL	29183	3NL5GKkRvHGNGJFJJqegRy6ebAUvKmNiF7tjcBcXPMATKYjGW8jv	1403	824	572	12463	18974	jxnGHuzoESwVFjFFHtb5FQF6xk3buLvLSd1nbnRMNhPqUegaroB	14388	20263	20263	1619586540000	orphaned
29188	3NLNGG68X77KHd8rDMVLh8QmswJpwoUjZyPaK8PBkEcXnukfvMC9	29185	3NKi8y4qry6MvYKHaB7FSCgME1emAdLrKeuUdAV1oUPWdDdVtxbV	1619	1029	572	12463	18974	jxcJQSZr3XzYf9a7MqVNwvSHLPphHhvHRr9VMgZ8oCHeS7Xvdev	14389	20264	20264	1619586720000	canonical
29191	3NLx4bPMfQyL8Fmm34cHU3YTWEj4E5omuCoC92Q2VhvSoB7ebPGc	29189	3NLu74RrAE8mRobkEGf1fAa4j5jzxgEcjtZgZzGLsAD75dieVavF	484	1193	572	12463	18974	jwkuYTazTGZ6v1tUD7FraiWvL2ZcJyqa22QgzCt7a5noXgDf1q1	14391	20266	20266	1619587080000	orphaned
29200	3NKHpPKkLh3DiqknJE8mPwPNCbEeZf1qcoTpo5v85LFP34QykDDd	29197	3NLkzTa5vci4UXFAoLTcrwvamwKv6UjX76qWgv6q6J2kzKtYYDUQ	1592	592	572	12463	18974	jxbKYpyotwPXZjQ5G9qoyiiAzVHmhqjZXfURVaUeDvmuDA9iX9k	14394	20272	20272	1619588160000	orphaned
29205	3NKjMGw6JTvHktJ3h71tXx1Ei8VDGvcY5VSY1i6jKzbo2tokDJQn	29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	1523	955	573	12463	18974	jwAYxkD9morKtX9tMjBUr4GMfrvjsVXLJcjpkpQqYnErapbeKUa	14395	20273	20273	1619588340000	orphaned
29210	3NKLgSi3nDamaKAoNUBc9tdq1o1SyYbbmdfWrpL8sXRqc5EizHS8	29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	1613	1349	573	12463	18974	jwipB3fmXAh8SdmHxRwfJ3fpbdi4sC9Bgrt74mHaKXKL2tSRbin	14396	20274	20274	1619588520000	orphaned
29212	3NLZWh4JUvdrjSja7pGwZeHxqXXNpR6aAQxtTEEY78GnegJgmfUH	29210	3NKLgSi3nDamaKAoNUBc9tdq1o1SyYbbmdfWrpL8sXRqc5EizHS8	58	1035	573	12463	18974	jwd8e8ovDNT39bAsCHXTdPR9DZ5c2gMskXPkECJ48da4r6ygP1a	14397	20275	20275	1619588700000	orphaned
29214	3NLFmVuLuLCNFaGuW2w9LCqPqw8LX3vpjN57pEbBJNWEvFxjy514	29213	3NLew4jw2koGL117GDGXhtPh2F61XAAD8TjCapbJsKJVFTj9oHD9	1588	1266	573	12463	18974	jwv16jkytZFSuYCjkjf63nW8N4gAkv5uZ3D7bT8fwq8SA9H15md	14398	20276	20276	1619588880000	orphaned
29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	29215	3NLo2w4NoUGeQtwRpZ2a6kAqqf2MtZfmqU7JprxQpUe952thQQcQ	1406	1393	573	12463	18974	jxUi2i3mYupkpHyjyPytwhixCg6yoXiVXVyFZC5iNrhchrpgGMQ	14399	20277	20277	1619589060000	canonical
29219	3NLRCGY36xEVm874henPr2bDDqEY4qQUa9uELbyPMLEKe6zrQHYg	29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	1471	1020	573	12463	18974	jwCiBQnZGRghShpBS89t9BbQonmN9oL2bzfDhTDMcPkRgCYkqGg	14400	20278	20278	1619589240000	orphaned
29221	3NLNoNj1YcBLnUjB4MSRY5LKMB6cH7VqS7fUiCYqsd91KVdqRJXR	29216	3NKVvp4KNuFDUeYYvGhWBPxCQ958bAjukVsHk8q8jsV4NeyqJSxb	641	970	573	12463	18974	jwLiotVM27bwyioAw8Hb4naF8GGR17Qq4R9pcUhbHCRbm932vcn	14400	20278	20278	1619589240000	orphaned
29228	3NKuqMVtSQpZTpTzuak2WnBAcwv2df7be7t4MVwGzViar1q1Jtip	29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	1656	1343	573	12463	18974	jxdSKfgE7bcyPkrTx64JAdPt7Z5grEq4A6ZLEiq7WE7Ey2KMcFo	14403	20282	20282	1619589960000	orphaned
29230	3NKCKgcDEZrNY3JyMQZ7gexNSNQ8yTWpTLPwN3RFFGZ3Rd5wqm1k	29229	3NLya1F2DzDbg9viXYDkWrBdEosUrgrfWP8Apduv6ohrP29RcPU2	1407	1395	573	12463	18974	jxwkwBwnyvCQr5Asaao9Z3KpjMmvkBrWeeeB2xQsbt658JpRTc8	14404	20283	20283	1619590140000	canonical
29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	29233	3NKCZ27aqSXc29mAR5RaRjfiiXsWi9HcXsLLWg5nrHM6U3Ni6rqa	1407	1395	573	12463	18974	jwz2ycEckat3ZTWJm1zLGfEpDs748f9bof5PdWz6HQcAyHSW5FS	14407	20288	20288	1619591040000	canonical
29259	3NLhsKn13VGqaMuwg6dEJnpjvCRe4HZLwwf7ReDVJZ7VDAFRFaVw	29257	3NLA1YKyeM5axLc3og2yd96m1bxC1fGqrWCNBukpoMBQnQoan49T	1633	1390	574	12463	18974	jxkxxVXhz6ULo4TnDNjno8zu2zvYToAqmbZiRAyMsgfzzfLUfgo	14420	20302	20302	1619593560000	orphaned
29263	3NL9sgR516vkuSM1wQv2AmD61NUqkmDBEsuGUCtCS9Qh9sUpuEdi	29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	1405	897	574	12463	18974	jwAGXPZqkjQJyZKeUZAx933St27DmMjFtKQKzAH2Xe1NDzT4q4G	14423	20308	20308	1619594640000	orphaned
29268	3NLK7owzyo6VjUmDQSy2ZGD6hdfVcCr6uxqsngQMxjjxU3JSvqfQ	29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	303	303	574	12463	18974	jxzpQYpgcVUUHqFWfB6L2t2QdUC34mUvDjk4yFP7LEoJw25rpd4	14425	20311	20311	1619595180000	orphaned
29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	29270	3NKXsFkgp4LUrVvSFrhqpr1xh2vBhXh3LzXt1K52N3W2EJm9JZuB	1599	1287	574	12463	18974	jxqfkTKbHqytUkp1Puj88uPv8sAs7wkQwibvGYy64etr8Xa2qcg	14427	20317	20317	1619596260000	canonical
29276	3NLYhHame1h46k6WdauPJpXursjXEmS5f4mNDCNvS38BjpX1VkgB	29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	1637	816	574	12463	18974	jwEgJ2KXh24zfxUKXwwujZuMSq1jtRTgRQU1b25XcWFVDPasyqi	14428	20318	20318	1619596440000	orphaned
29282	3NKc28QU3DpnLfApfZcDpEBPNo3h5VNFf7DXLwJBP7sQEAwvY9b3	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1483	103	574	12463	18974	jwQeBKou24qDJbpxgCeQynS1FnHzbCgEKnRVLRFntcrsuuNzrMK	14431	20323	20323	1619597340000	orphaned
29286	3NLA41FQLCZCJAsSjWmBURQPqhyhrHSABxBhsGZnv8YF97z6mRGM	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1654	1094	574	12463	18974	jxW166FBUzycuNv4o9qXg2a4GtbEjWwV8pZSom5vExbPcneErTM	14432	20324	20324	1619597520000	canonical
29288	3NKiRxCBzCShaMWJLHWcVPLZMmaF27xxx5heEQQe12ZESdJ4qwY7	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1651	1055	574	12463	18974	jxqbP9grh88spLWVt3nQqrNHJbHqNVMPwcpEEVeaC7R7ExfhFbQ	14432	20324	20324	1619597520000	orphaned
29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	29289	3NKXiuDxYCnx89ds77oFQc6uHXLoxxpuoC3mggMXnFVcWfyr2ssL	1406	1393	574	12463	18974	jxy9U6K2be8F64AQayDZrQHP4WuA4XEY37kxVNA8hDDNdy6yrYp	14434	20327	20327	1619598060000	canonical
29292	3NK7M5m3oxGEHBx5x4xaNRhEB3ckwi9tcjYyE362qYU316w9nSx1	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1471	1260	574	12463	18974	jx7VvNvn6X2uggwx3QAuB2GRV7mFTGcJnJdPGM4WKA6HMUPxuho	14435	20328	20328	1619598240000	orphaned
29266	3NLVqk7Y8oMaQgYG8JzsXbR9cbhfahmvPY3qCQ5o5gCCD3FWqX2j	29016	3NLx1kvstJkJrhAkHGZTU27RcuRxnpMoPjwYwKhes8CvV7ejiWM6	1481	790	568	12463	18974	jwWdAwBzWfZBDHr8MKtnu4Gabd5kde25MuYbwcZPW3fiUCqsr3k	14309	20311	20311	1619595180000	orphaned
29208	3NKMxF7Cj2yJSjH1SL6Z49UHYCTMxjtXfcDyEGBm6PuWYGCxUzVD	29127	3NKGPLEmNG2tDFWnfBai9m4y6m5xYKeK6c9T5jyyizAJo3kjsFmG	1513	1379	571	12463	18974	jwcpRev3JaoUEJh4ePdYcTY1XTAteHKc4Zv2kH1jEPQzxnLBArn	14361	20274	20274	1619588520000	orphaned
29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	29203	3NLjQnicRLtxo3wwWY46WYCJBKv4NUiphbokwPmWwqfRi1E2sjKQ	1523	955	572	12463	18974	jy1a8NYYDzfc1XLq7XerRFPen9scNnoSJzdgqM9QEfSBTuqJsLs	14395	20273	20273	1619588340000	canonical
29211	3NLP9xYCqWEAeeUhQxhU26vioFwAuzrzBk4rm3zDF83sPJMFJzzC	29206	3NK74jydN18LZUyyjCY6tSNYaDEoz1Vz8KYEh5FBg5AfXcDTcCKM	1613	1349	573	12463	18974	jxDK88LgETQYM2TT9CnCTtN6Kx3QcpMgNNaJQ4ZW3RatCFkS75e	14396	20274	20274	1619588520000	orphaned
29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	29220	3NKYFHYxLLtt3VfobPJMUWYWCRku4JHhedaXrbqWwc9KYFULGZYY	80	1273	573	12463	18974	jxsVmofKjmNNgQUVH7BsxATjS4ZN5eGPzsEHicTe9tdUQsWLyag	14401	20279	20279	1619589420000	canonical
29227	3NK6NjiNu2nA2YPdwT974MVv8WLwYhpMu2xWfEn3L4Zw4V1CDs3N	29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	1633	1390	573	12463	18974	jxHfGQZ1jARTsBPNmmNaThWUAAyJrZE12xTGYNk2XV79ZCtJnoa	14402	20280	20280	1619589600000	canonical
29225	3NKGdQ32EEf6KfYeb6FG47Lgqvme6S1fJY7ErPSJqXZ5VJDZRA9A	29223	3NLHiJ2idnbz7bHCJr3hshQh36EGc5Fc9y4pEGWQbYhCv6owNJNe	1668	1370	573	12463	18974	jxA6Nx7zYzw2QV42kmvHg86UUSQ8BW6wq3YAyb9JdTLjsvio1gD	14402	20280	20280	1619589600000	orphaned
29232	3NK5LPTZFJthP2hVtNhW5XEMhLsRbTNnUq6G1QzdUeg55vu2JAR5	29230	3NKCKgcDEZrNY3JyMQZ7gexNSNQ8yTWpTLPwN3RFFGZ3Rd5wqm1k	171	1374	573	12463	18974	jxFZnJmbzdmjbP7b8K2NVSjdfWyuLkYuZ5TSYrLUWxYcGwagoZs	14405	20284	20284	1619590320000	canonical
29237	3NLes2DmkhqJWry3sZW7hqmbcArxZNnMHat5A62w2VAGB1YfoTxq	29234	3NLArUsy1dzjohk3W4bqcsddbVNM2vgtJuaZKTXD5nmzUmusf5wY	1523	955	573	12463	18974	jwom5Uejq183Q5BXaaeq3L14D58WAXRrV7E6xyiuis76AibSrYM	14408	20289	20289	1619591220000	orphaned
29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	29240	3NLpyvaM7eStC8w9BsiAHxf34oS8YsYecNeb7yRri9Z2A8Lmmowh	1403	824	573	12463	18974	jwfD586FZkwmZTXTEqk1qNXDypAtf3GvvdSC6vEemj8eCjznQW5	14410	20291	20291	1619591580000	canonical
29244	3NKZ3zJsqhDZrNAk7tAMwH6VWD3b4XTAe1GimgSe9Mu9EM6F75PA	29241	3NLpBWEzbta5h48JCqwffNfsDsFNcfYfgxanvTEthxkivCYGamzf	1407	1395	573	12463	18974	jxVthqNBmwHtLER7FxBkJUGmPY4B6vsAeAvuHbJzkquSqrkH8Kr	14411	20292	20292	1619591760000	orphaned
29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	29245	3NLq8W5qwmxomA3cAMt6G21DQ18AVVMSnGaAGNso3Yv5t6KTDVNU	1406	1393	573	12463	18974	jxTgsdTDSyuUTehAZnu6XqryjwLrK4L3qfti3o3NJR8nwaBqnTr	14413	20295	20295	1619592300000	canonical
29247	3NKjnUNarpNK3kzcVJUXL72by1KbEtykuiFuC4ibU5iACj1bRC5J	29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	576	1355	573	12463	18974	jxQuMoT4PCC3iPRNLuVxwq8tts6chBiMsG6NcritaVtZxz4dX5B	14414	20296	20296	1619592480000	canonical
29249	3NKeJJbDLHT6kuuJUEjzyQ6Enhr8o66pHiWCEywqWGwRhSMN1cKb	29246	3NK93kaibi7Nad6pBJMiasckAMRe1m3hpz9hdAa8wcVHRLBymX9u	1578	1170	573	12463	18974	jy2eByBjvekr36nNy7LVAKY4AiQnAPQC5nqFeG5ZZzyK6M57tT2	14414	20296	20296	1619592480000	orphaned
29251	3NLEoTqW5GYXjYKMDyPo7LDz5YefU4Txk2qMymandddao3B4Km2Q	29247	3NKjnUNarpNK3kzcVJUXL72by1KbEtykuiFuC4ibU5iACj1bRC5J	1581	777	573	12463	18974	jwfy4eQNCrSxL1mXXZmd2FR6sgdHZjbw4Vhm826LfddjtHNjAsF	14415	20297	20297	1619592660000	canonical
29250	3NLCaMUPmSsGeenRj6bFbYBFzcyRiLEMPEVWEng2Af8VywqfykJ3	29247	3NKjnUNarpNK3kzcVJUXL72by1KbEtykuiFuC4ibU5iACj1bRC5J	1444	1381	573	12463	18974	jwKVtUZZQ4twHhbwyfNWNrVsChAhbjzHfdjuXxphuGPsntrSEjz	14415	20297	20297	1619592660000	orphaned
29253	3NKok71rtcmJcbYSLh6UDzAEgvegYh7XkhHus6Qq4vmdG9jhVNW9	29252	3NK6wo3MnEZ5HnixFKeeNGvyBNscCcdK8Ud7pXRBeKbubVdvXizP	1654	1214	574	12463	18974	jwuvGrQRLmNPvQBHsVmaGNfMcChdf9bTUmGxsZGUkK4XQXxt5M4	14417	20299	20299	1619593020000	canonical
29254	3NLSPWuWC8m2Cngy4m8TZZpTa3f4vNBXdHtdzXkTXK1V8iGBU7An	29253	3NKok71rtcmJcbYSLh6UDzAEgvegYh7XkhHus6Qq4vmdG9jhVNW9	1547	1378	574	12463	18974	jxmff4faMKiXvB8rhRYzQq7Q8PuQUvwH9rQTegJyQWTNQmt2mNX	14418	20300	20300	1619593200000	orphaned
29256	3NLsCijupEyeV8ECx7PhfPnPTT7aiuECKHNC4hSs462KrygcpQtq	29255	3NKE5eVWxhC5BPcU12gyY22YxHRwwJXfSMbfGtFTAiaBk23ivKdd	1476	1371	574	12463	18974	jx71MXFBK6zNYDZ1V1bKswuiBBkK8W2MMEaUagq8pkqqxmS2iza	14419	20301	20301	1619593380000	orphaned
29258	3NLyLD6ACR2CT1rMndbuR783ZLMrUGTKkgndujNpRCGiLtvB8FvP	29257	3NLA1YKyeM5axLc3og2yd96m1bxC1fGqrWCNBukpoMBQnQoan49T	1407	1395	574	12463	18974	jx7Wimuxs4dDU6YvFM7SG558d54GPCYStactXuhbKk1sG3ygvFJ	14420	20302	20302	1619593560000	canonical
29260	3NLPXRi3f9R4FtuSoGiLvyiTw8jZHVx25Z3EbE8WLQPSnoYV4VzJ	29258	3NLyLD6ACR2CT1rMndbuR783ZLMrUGTKkgndujNpRCGiLtvB8FvP	1673	1122	574	12463	18974	jwi6AaHKnfATVBfDfnH8K8UVQqAXGc7K7SPxu4tvCXCo1zjjHVq	14421	20303	20303	1619593740000	canonical
29262	3NLLXUE6fmPb1HEEGcjCd71FjBxAwXgQEj7zCHCm9Qs9rgsStSc4	29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	1406	1393	574	12463	18974	jxEyhqu9gU9C4HX8tLbsw1QZTh8bxCwmCWPqpMR1ynShTawvdKX	14423	20308	20308	1619594640000	canonical
29264	3NLwTAtdbuYF2PYsfz6YzwwQ7aPq8hRMkgi4rWNFA41vbduHETa4	29261	3NLKe4CHULuoqick6TSUce2oyLMLmnMLySwyHtxozeRsFhc6Juz2	1623	830	574	12463	18974	jwPWD8UJ5mXd7qqbxt65vkwikCPy4GAQnYX4SQbkNdE4xQ4mtdn	14423	20308	20308	1619594640000	orphaned
29269	3NL6mfZN264jVuz1zQNGUUEmTASsDsXnaRgAJGDSjmheZBjNmXWq	29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	1407	1395	574	12463	18974	jxQhrzf2sohZegVA5J1Qnc6FBen9snGhgoL4BP1usKj6Bax8PwW	14425	20311	20311	1619595180000	canonical
29275	3NKXLDsf9oSUaxnXBZpQnDu4cRHi7Y34h49JNQZ89nifGzjMHJZk	29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	1406	1393	574	12463	18974	jx4BQH3DiHPQmqT7EEuGAqpdsexvbdFZ3TjWzF3t9pGg25G7CkY	14428	20318	20318	1619596440000	orphaned
29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	29279	3NK7DWRoaR9RDrXXWpPkA3qg78JsFRpubA4kx1bxJczyTGRbmTme	1405	873	574	12463	18974	jwTrBVPwoK16bo2sG7JCwaccN9XvLoQL2HddApQw8oaHJFMWMxH	14430	20322	20322	1619597160000	canonical
29283	3NKDx2ygjE3RiyQ8B2aky2A5SiRQGAiaJT2DWQEkLcjyRuyGupEw	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1672	1159	574	12463	18974	jx9iDCAq8DYR4H9EHUracwECHJZLrYeSUPijaEKiqYCWaX1LRRo	14431	20323	20323	1619597340000	orphaned
29285	3NLQzhHg5AwxZSMDVPmVXVp6L2sB7MPW4YmGK5keuLWjtvTZXjSy	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1407	1395	574	12463	18974	jwQ3e9JJZyN6b7mvBBC1KfNV4VuerR2vxqpPk2DuSregonZYWZS	14431	20323	20323	1619597340000	orphaned
29289	3NKXiuDxYCnx89ds77oFQc6uHXLoxxpuoC3mggMXnFVcWfyr2ssL	29286	3NLA41FQLCZCJAsSjWmBURQPqhyhrHSABxBhsGZnv8YF97z6mRGM	448	1059	574	12463	18974	jxemDyEAyeP3JEMs6HVn9bWNzA7SJZWxxiY9yCnaq9JNXSS8SKc	14433	20326	20326	1619597880000	canonical
29278	3NKWTqQv1dHuvdxGjENHyB2smjS3wUpxsMfmQoTMUxEmnRkrn2CP	29230	3NKCKgcDEZrNY3JyMQZ7gexNSNQ8yTWpTLPwN3RFFGZ3Rd5wqm1k	1516	1294	573	12463	18974	jx4jNHDzyWWzm5qtR7U1bbvwqNHGY8AxaQrPAPYjH3t6dah4Peh	14405	20319	20319	1619596620000	orphaned
29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	29262	3NLLXUE6fmPb1HEEGcjCd71FjBxAwXgQEj7zCHCm9Qs9rgsStSc4	1406	1393	574	12463	18974	jx6kbfyRT4PAdUHKdxx7sZZwdprByNJzqr7vvcYNWHypeZeLTfp	14424	20309	20309	1619594820000	canonical
29267	3NKRb2RuccDxQxSyTJnfDzdQ9kFjYsV5k9mheCJoxfNPJAqwjxWc	29265	3NK7N8rCxAR4AcjjtXDovaKCZ2iPdev6csChHCXATDTSpvHEbcQD	303	303	574	12463	18974	jxtWpEUJixxAXENu1qzw5T9yrrhMEENmXAe7ikJtfjJ2ohA4yEG	14425	20311	20311	1619595180000	orphaned
29270	3NKXsFkgp4LUrVvSFrhqpr1xh2vBhXh3LzXt1K52N3W2EJm9JZuB	29269	3NL6mfZN264jVuz1zQNGUUEmTASsDsXnaRgAJGDSjmheZBjNmXWq	1589	1040	574	12463	18974	jxMajzpgwd13mAjB2habPcupszfB6aUPy76riWUUfYWZrf3DxFe	14426	20315	20315	1619595900000	canonical
29272	3NLPYGjr9h2rdEmdkHCoXCFSVXDrEbfAtBpYQ2ksCFnynoKURGpz	29269	3NL6mfZN264jVuz1zQNGUUEmTASsDsXnaRgAJGDSjmheZBjNmXWq	1474	1329	574	12463	18974	jwfjLHJ1Mij6LwrkZst3zkRKaDprJFizvP3jdA9E8pQKnwMd2Fo	14426	20315	20315	1619595900000	orphaned
29277	3NL4i1s6S5vd7LrCfzNiUxsUst6t9o1Ryj77QNy3ZvwupcUDXDpP	29273	3NKTRy6SQes3LVVTZxKKT2RxC6EyJuVcGxJuZLCkg7cNoqdzj3ou	149	917	574	12463	18974	jwJpygsirdVj3wU6UP9M9yFaJUJzjUpCYDyXxTAAZ6yzemRF4Fr	14428	20318	20318	1619596440000	canonical
29284	3NLFBmt6W9swf7px4j4FL4RwRHFx3Ri1CsC5RpiEM4j9kT5RDea3	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1656	1217	574	12463	18974	jxeBjjoTySKCabX1cxFEbSdVN2JjMfdAnJLTf4uQ4nrV4ue333v	14431	20323	20323	1619597340000	orphaned
29314	3NLFhr1wuRupFA3rpw7iFuihoU2UVbKPuDzXYKJKZpHZKRV3zBXY	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1569	485	574	12463	18974	jxs63XynpKHGV6WRswvGmVgfR6NoZtjh7gYbLwhUBjyW7ARoxfL	14432	20342	20342	1619600760000	orphaned
29301	3NKU4JbhXM4T7Ycpd9yt8hCAMiFDefab3SHWYfWnZuqbAG8DHXnE	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1440	1377	575	12463	18974	jx1zvU7DW3CW8UagLoDwpHyS1ksVY32p8WT4HQf27FzZMeRKGoj	14438	20332	20332	1619598960000	canonical
29298	3NLu22qKfGBqhQ9fAX5BZtV6xr4SkCL6TEgx6tbfAZkQpQNyc8Ub	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1477	1104	575	12463	18974	jxBq1VAD6gCfWziigsuCKb5srAkHetaAsiL9b3ZqLKy3qBrcu1D	14438	20332	20332	1619598960000	orphaned
29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	29303	3NKocKTkXYmoJRGvUwZTQCLnaUkcvk1DCZj8ur9rTcmdnjCrxmfY	1627	1139	575	12463	18974	jxDDjKKFCf3bo8fd1kLrnk6DY9pomGFYWnZ88fXvQsk1onkugyW	14440	20335	20335	1619599500000	canonical
29306	3NLaViuDHKVsajk7JvKWpC7MRCutc2RSH8ty1MJoeEYwQtx5EwTF	29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	1407	1395	575	12463	18974	jwWHLWHzzS9o6HM96K2PHDtaFsU6kZj2xtJmevyr9rZdXAqTHyp	14441	20336	20336	1619599680000	canonical
29308	3NKedZJwwup7Mevj1zT7dVd1Gy8G6FNuL5PYynSbX18unh3xH7Nm	29306	3NLaViuDHKVsajk7JvKWpC7MRCutc2RSH8ty1MJoeEYwQtx5EwTF	1633	1264	575	12463	18974	jxQ5YGAJt3yPm2FbnPJR1uPwHfZ4aLC4zC2DYaejpC5qC649duV	14442	20337	20337	1619599860000	canonical
29311	3NLqSxqLCid5XDQ4dDwPtSMSwsQiLCGNKozvXR3CfscMWZhEMCbT	29309	3NLwS859mHzQuNi2MVShuj12AmyFcPHZK6WPWzWKufLY4YK2JSdc	1406	1393	575	12463	18974	jwpM4AjhdRGvHR6BqF6E1uASBgts7RiQ7xTERWprVp2EHdHEk4o	14444	20340	20340	1619600400000	canonical
29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	29311	3NLqSxqLCid5XDQ4dDwPtSMSwsQiLCGNKozvXR3CfscMWZhEMCbT	1406	1393	575	12463	18974	jxH4AsAj7toJhR4mAbXYHZfFkcu4WX3PrePSLc8Z2BMQ5HpAGJM	14445	20341	20341	1619600580000	canonical
29316	3NLRiaKrEZRH6CxsgunXwb4duX3V5y8axF8RGB2ZKMA2Zu9qxQdN	29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	1555	1347	575	12463	18974	jxwFhELpQQMt88YwjgZMggnAcWNkJp6z6ijN7xGJnFKMq6pgyAb	14446	20342	20342	1619600760000	canonical
29318	3NKTkjeUbZKPuNvCt2fH8qLgRDGXBjBApc32rP85boBcS9zFPvuS	29317	3NKiz6yStExaMiAUyxetBy95pjuYfCHAsoAkNUatbHTZCmLVZK9m	1406	1393	575	12463	18974	jwS1ZfL1NMojyeATGL3z4ZGjr3tE8YF8V9ryxA7jtZEJs6PapGK	14448	20344	20344	1619601120000	canonical
29319	3NL5tMxPpdqJtReF6Tuqm1UrNR6Hfgb77A7HN1Jsiw8o2TSzXaKb	29317	3NKiz6yStExaMiAUyxetBy95pjuYfCHAsoAkNUatbHTZCmLVZK9m	1460	1324	575	12463	18974	jwxK6RiKQue9cLFyDke14tAauPmEsMDRKczekPHzxDAi1g5pGGN	14448	20344	20344	1619601120000	orphaned
29320	3NLxQZHZjEs567wBzY83NNg9tDBhV3coVjmxZvvPrX5UVmBqrRtk	29318	3NKTkjeUbZKPuNvCt2fH8qLgRDGXBjBApc32rP85boBcS9zFPvuS	1483	251	575	12463	18974	jwKjDjipiCpyrcbQd78V5ZK4EAvRPnpXcRiqeXcH39Mks9pUvXU	14449	20345	20345	1619601300000	orphaned
29323	3NLdeUrikt4kzHqHRb3SDTJt27Ka3R5xSpvQ723qLNxxY2Q47326	29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	1622	1110	575	12463	18974	jxRMapZVTPsNiNHta8czFEoegZEqGJBgJgca1Ntd9T44KrowQcP	14451	20347	20347	1619601660000	orphaned
29328	3NLG6aixKRmw25rnzigaHwuKoxbdJ6fUoderF3g6QqgF7gxgyVzD	29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	1527	1167	575	12463	18974	jxEPeAEebRrgoBVbUNue4VuBAhqyXw3bX1exwNT7FnHWXPKqXmg	14452	20348	20348	1619601840000	orphaned
29332	3NLduF3oPANeWEsftWHonANToVmrhCpfofwN5fQNJkRGFRXBYvhd	29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	44	1199	575	12463	18974	jwa34Fmo8uQwUtUzGVoG3VCR9yTeXy1KuHMYfTiEkJXYer19RXN	14455	20352	20352	1619602560000	canonical
29336	3NLMPvzvjEM62VojnaGLBZzkk8NhqHL5FcxWXqC2CSRnm6iBfdzd	29332	3NLduF3oPANeWEsftWHonANToVmrhCpfofwN5fQNJkRGFRXBYvhd	1426	1364	575	12463	18974	jwQDHBXSjvdRfYUPYXVYkSpEBjrFnconudvtXTpZd49T7b8pTtx	14456	20353	20353	1619602740000	orphaned
29339	3NLKK6WRsuKuE97wF5Ck3rs8MTnpcqR4KKsWuXfha23JcWDrYoDR	29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	1646	1354	576	12463	18974	jx5ZbsXdLaeXC7DPLmr3tQh7QzAytDTXG5gibWEEZpp391WTPPT	14458	20356	20356	1619603280000	orphaned
29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	29340	3NLS7qtw3zo2JGduKUqXS3mNNPoBkyt54EM8krrXaspkigwhnZAu	1406	1393	576	12463	18974	jwnQ6GZqV3McQzWjP1A2XDbUARU9Yzobfab7aqH3eehKsqrnrFT	14460	20358	20358	1619603640000	canonical
29342	3NLZCvtrsZJEzHUNFMRtfxGxerqkaw2xxDKTvnjJ8EiSRLQJCVyk	29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	1402	870	576	12463	18974	jxLoxXjtmtxr5CQWwdrbAmmGjHsLRYowpVTfuPqzVCshYbfe4sf	14461	20360	20360	1619604000000	orphaned
29349	3NLLvKubbfwZNFvpnxp7k2RqotTc1H68NUij7AJv89f9bT8Z7UoJ	29348	3NL8b7egjkQ4vanvkarCuAyXitSf3h8R7fY4KNUSsCGLKoQGPeMJ	1509	1320	576	12463	18974	jx9QbUgkkzDe7EMBySnZL8113krR6iAJgcgnaAkwv2QnW5KX7d4	14465	20365	20365	1619604900000	canonical
29354	3NLsmHS5gK2g9uEanCC4FrEXgvhM2Zr2e85fJ21susmK92p1k768	29352	3NLQRPH3wxFDj4haS8tKFnbrLwGtgkHfLKd9Zm16euTfdBHkRoib	1573	1072	576	12463	18974	jxe3JsxM9mVWr5i7R3nARecaT5gw31Y7GXfxSpKLnLUiPJSK6wJ	14467	20368	20368	1619605440000	orphaned
29362	3NLQGPVfkuBMLmq3r2jUuthSN2AvejraaNmRCUZwdfFQPMv3z5KU	29359	3NLvZzNMK4V7gWAVvfNzaTTiSjqs36KFfpyMfM6H4L6LxchaNQPx	1483	910	576	12463	18974	jwNHxuDh67FuXPQzifNcekD1BtJcTcuU2Aot1k7PS3yVeqaHGhp	14470	20371	20371	1619605980000	canonical
29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	29280	3NLx28hMAqfCuLGvwAn6UeY4cZokP6txkh5zpznVjLNRcWrNJQyr	1668	1244	574	12463	18974	jwaaeh4B2Cd1z26f2AjU9VufrxkomRQ8JaGeTtDMJARiQuv41yH	14431	20323	20323	1619597340000	canonical
29287	3NKHKDd1mYgsbHJvEqtb7umyDZsPmVrS77V8c5KgJUd7JFV4Ha7Q	29281	3NLATUsVs9EHadPsg5Bw6DRmgEH3U7FJ9W2e7AGJM5Zk5E6aFPhk	1651	1055	574	12463	18974	jwZjvhhBijpvq4tWeEbxHHVUnZHtTnUwSese3XgfFLNi241Y9fC	14432	20324	20324	1619597520000	orphaned
29313	3NLeHuFuJT6wz7o1vbHo1KZ6hzutSBpP3cuqB4ZRQu29LzKJqNrz	29286	3NLA41FQLCZCJAsSjWmBURQPqhyhrHSABxBhsGZnv8YF97z6mRGM	1569	485	574	12463	18974	jwGpX9u4MKxmUcPVQ4mVWsfWiqPLipBLZgs1agWWRa9VaiqGH2h	14433	20342	20342	1619600760000	orphaned
29293	3NLicnZMBi73eHSHe6BQHwUWexE54CbY6dPVo4WLQCtpxxWDkdug	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1471	1260	574	12463	18974	jx8VMMdWDXiafX6xvcE7ZZ5M8KzpsoRByhNDeSYfdPMRgT2smVr	14435	20328	20328	1619598240000	orphaned
29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	29296	3NLVMNHjmvxgEv2ZyEp2MCyRKaxWY5Si81vA3ZXoefoKvdM2mFvZ	448	1305	575	12463	18974	jx47VVLfn8Ratm9eqbvS6vsC8hXbAuD64sSbHyXLTep2Mm3kowJ	14437	20330	20330	1619598600000	canonical
29300	3NKiszJMbHWdHucmmRTHW6Zsm2jBi94VcUEozrCkQGvEXC6WxHHA	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1440	1377	575	12463	18974	jwHcTLeAyVaPxqZ5tbjk2pYv1T2ZnTBebREkJWHd87JWSiCz4TP	14438	20332	20332	1619598960000	orphaned
29303	3NKocKTkXYmoJRGvUwZTQCLnaUkcvk1DCZj8ur9rTcmdnjCrxmfY	29301	3NKU4JbhXM4T7Ycpd9yt8hCAMiFDefab3SHWYfWnZuqbAG8DHXnE	484	1073	575	12463	18974	jwotTDACRVBmSNsvEmStNRaLzo8mAwq1KoUpbNCVfoHYzY8TNzj	14439	20333	20333	1619599140000	canonical
29310	3NLM3AHkvpQQGFb7ZpTKZiQcoBaCJrWSR6hLHBDcTd7ce3d3Mf63	29308	3NKedZJwwup7Mevj1zT7dVd1Gy8G6FNuL5PYynSbX18unh3xH7Nm	1657	1344	575	12463	18974	jxGjFXvxFghq2veGNbwbQCArhnnGnpUpaiAuFGycsocQEZnbiee	14443	20338	20338	1619600040000	orphaned
29317	3NKiz6yStExaMiAUyxetBy95pjuYfCHAsoAkNUatbHTZCmLVZK9m	29316	3NLRiaKrEZRH6CxsgunXwb4duX3V5y8axF8RGB2ZKMA2Zu9qxQdN	470	943	575	12463	18974	jwWMuNVoSs5uUG3UgEQ8AGqw6pmYb7TG9TPYSYW5uCuso9Atyep	14447	20343	20343	1619600940000	canonical
29321	3NLaSAWV3zLcb4qwLVfjQ1TAWpXwHGrK6qcXzSY6ayTUauppHSyg	29318	3NKTkjeUbZKPuNvCt2fH8qLgRDGXBjBApc32rP85boBcS9zFPvuS	1407	1395	575	12463	18974	jwefwL7xtnobHabLzgdAaVzgXcw7N4PQ1gufmmkc8GP5ghKbmWv	14449	20345	20345	1619601300000	canonical
29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	1403	786	575	12463	18974	jxeZjGRMtDPCCCDvetpuDrfeqnGhaF9WqLvDZbzMRfzvqkvRnU9	14451	20347	20347	1619601660000	canonical
29326	3NL5cdcEtxUmNRqM9S1xpw1tSiyC94ikJzX5kVM568WtdGPmJU8X	29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	1527	1167	575	12463	18974	jwjCQ9xF7Jbt1Z9TA6PQSSm5Emy8sHRyTZipW14k8DQtxMDbWD7	14452	20348	20348	1619601840000	canonical
29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	29329	3NLpfQ6u31MPdZf6mHm77Lw7mV18tCrB3piGJ9wfj7W4xq5KKKyc	80	1147	575	12463	18974	jwjC2gUJRXEahC1pmBQSW7EvmWaecxc2ue1QcxUx3A7nz1Rcdv1	14454	20351	20351	1619602380000	canonical
29333	3NKtnutqBD2F6eA5DBW75iM7og2NZ8ot1CTZkRFJQjigF2AvZHoF	29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	1405	849	575	12463	18974	jxYz8jZi5Zfkzzkmh3wsX9j6i8DPWZPFfLuotTVadit7MYM8Cv7	14455	20352	20352	1619602560000	orphaned
29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	29335	3NKcpQVbzPN7ESXrrxgqTehbBATuvXrpZJN4ai4xzm9pq5oMJKue	1607	1102	575	12463	18974	jx7pTFADZqUPoCa5K4xu2UvYfYP8PZEmkq9uNAP6rc8e1tmnpSK	14457	20355	20355	1619603100000	canonical
29346	3NKYGSo2R41WT8MDXaARmuyUpSzTKczTgPCNVFMo8Rg6Lio9xxhQ	29345	3NKqUSkdeaW2NpnCtXdfAitEURXqpJuU2hv4ceHW9sK9EbN9s36y	1406	1393	576	12463	18974	jxBt9VeTbndqSHPNte6gFGvT1ok81bVgw7tjY2vmAkVGBBCaTLV	14463	20362	20362	1619604360000	canonical
29348	3NL8b7egjkQ4vanvkarCuAyXitSf3h8R7fY4KNUSsCGLKoQGPeMJ	29346	3NKYGSo2R41WT8MDXaARmuyUpSzTKczTgPCNVFMo8Rg6Lio9xxhQ	1483	138	576	12463	18974	jxVUdoq4UCtEK1qbshxwA8AkN6VEgwswf7jeGVMSBeMNG4gEv6B	14464	20363	20363	1619604540000	canonical
29350	3NKYqvPP7qbvLbxDLm6YsA2S6QC4PTf5tFpTJ825GbXcZRQDNrsj	29348	3NL8b7egjkQ4vanvkarCuAyXitSf3h8R7fY4KNUSsCGLKoQGPeMJ	1419	814	576	12463	18974	jxrLBYzjU6iwjG3FTAmnanSMXjrxK1XJm7eGPHUC3B1RHZq5TjQ	14465	20365	20365	1619604900000	orphaned
29352	3NLQRPH3wxFDj4haS8tKFnbrLwGtgkHfLKd9Zm16euTfdBHkRoib	29349	3NLLvKubbfwZNFvpnxp7k2RqotTc1H68NUij7AJv89f9bT8Z7UoJ	1407	1395	576	12463	18974	jwL7wgwyEQWBs2KKDQH9BW3PEjhcg6iXw2LMzF136voF6euN9ax	14466	20367	20367	1619605260000	canonical
29359	3NLvZzNMK4V7gWAVvfNzaTTiSjqs36KFfpyMfM6H4L6LxchaNQPx	29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	1594	1326	576	12463	18974	jwzRdMR5FdHGpLY2gZ7aor5VFFBKrCmycc3GKcr9fgsezK9pki9	14469	20370	20370	1619605800000	canonical
29365	3NKd9H42xT9yaeBKYv2fg8qn97KbiXgSCDW3TN52A3EVKGNpgrtH	29364	3NLZUr7qbRAComp4NgLbH5fpuDXTUpnUDiJY49yP1Y99DZLpd8Ym	1460	476	576	12463	18974	jxzv6PkGWfwNYHrqN99qYoHSDq8pEawnzGgfLHM5LcknykhP27s	14473	20374	20374	1619606520000	canonical
29370	3NKYbyheErsf5BwRZV1tgbWvGu2SuXfV9CerupVseZWT9yDXzt6f	29369	3NKazC6zWuAVqQzH8MNLNjsivkMKUNEgue3KNLCPHfHEBvttxt3Z	1589	1286	576	12463	18974	jwi8mff4sjEfEpq41qrRX6o9YeT5HEUHvzwDTNEYJpGHYxTjbyT	14476	20377	20377	1619607060000	canonical
29374	3NKWU84f41MWAod2Un4pFEuVhw9mDHRzMupsErqPrNd9C5vRY6TS	29373	3NKfqvvNucTMQnZrFiFC7VSfQLLQBukMGiZZyYU73X7hTTvK3rsJ	1610	1314	576	12463	18974	jxRztWyh47fkszLC3Hv4PEYtDS7DYRsXQgHZEFfm2paTGivnpGg	14479	20381	20381	1619607780000	canonical
29381	3NLY1kE7KcA8Ns3aCspTS75irBHvqRafCSgJptzK5HoZ2AA4T23b	29380	3NKY2YxkTysyAi5z9xrYsmDDgRLbJL7bEWn4Z756fLxEiZ7TWFWA	1439	1279	577	12463	18974	jxnt1s6iU3m114QzSpk4qgk7NzWUDYQWv3phcBDWYUU1ZkfSf1f	14484	20387	20387	1619608860000	canonical
29386	3NLp2HCyupsJSfLNUiGLi2tD5ZB4unLNPukqSioB9SRF5E3he85W	29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	1501	1360	577	12463	18974	jxgyQdNqWLkg4V5XSS1fopBDFNmWQBLy6cqHjBhzaBbGjPV9dFb	14488	20395	20395	1619610300000	canonical
29388	3NKMnXjdaFw5bt2VSAUFZm9jqJ9DRfcureEWtKArrufuYwcRsuzy	29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	1460	1198	577	12463	18974	jw9Ha7koZowCDZxRSdDkiV8hwsYtMEPtjoKzmotCirFJ5yiDrX1	14488	20395	20395	1619610300000	orphaned
29390	3NLf4pRikTXVhhWDmxdqVVmeEGAudPZmRn2fXCydR9kgnEwfNMt4	29389	3NLsDmf3cX4NFQqCoXgHR5kQkcKsMD9Psa5Cx1XGUhbTArPQjWmf	1406	1393	577	12463	18974	jxR38DBtFfaw1bJ5fEh4ho1jucwEEFAvqCzegNy7f3SLvAPRiPW	14490	20397	20397	1619610660000	canonical
29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	29395	3NLrjey8DUcynD5dj1DxB7tD3DCKa8bCxawuWJExXpAw94Cxkq87	1406	1393	577	12463	18974	jxBoPVGR2Q8RTz1QQEFuLTrzqENsTr18uqRYKiRAMjZ4UyRHghT	14493	20400	20400	1619611200000	canonical
29398	3NKfqjtoFpDXRDNKHZXG6D5x8j3M5UvwZDeBot2xM9GyZLrVDtPt	29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	1440	1131	577	12463	18974	jwhUBifGPWg7uAnHrwxo6pastCnsdBaTxWzuCJ1dUBcz72Y5NmG	14494	20401	20401	1619611380000	orphaned
29294	3NKTc7ptxt9viFz6SXxA8KXrgbxVMyfaetv8Hp4FvzbTtSNDoAYC	29290	3NKSwu6JVkbcE7VkxniJAta3GD8ezJxDNvu5sgajnXhudeCo3ED9	1633	1144	574	12463	18974	jxVMXdyUmeXeD1F7iFG54ryNnvigYQC3WPXNz7Yg7gPcF9vJPZD	14435	20328	20328	1619598240000	canonical
29296	3NLVMNHjmvxgEv2ZyEp2MCyRKaxWY5Si81vA3ZXoefoKvdM2mFvZ	29294	3NKTc7ptxt9viFz6SXxA8KXrgbxVMyfaetv8Hp4FvzbTtSNDoAYC	1403	824	575	12463	18974	jxDNzhJaBLWkADZjsYiJCyR2PH4jPhc4yShKQo3U2CuJE5pK1e7	14436	20329	20329	1619598420000	canonical
29299	3NKrtvzeJzi8AeB68gzkrT4vV5nRnbBAbaZEq6EbQx8K7Bq7QNdh	29297	3NKc1LA1y2cnP9QyjjSoyMmYjdkaghuNAAhR5GGqwPeZyTfTuPLB	1637	815	575	12463	18974	jxnBWQXVpERz7xh51gAjr2jcvZrj5CqZBzrPVASz4daFJZvPc7K	14438	20332	20332	1619598960000	orphaned
29305	3NLRZqpjdkAFFzhFUxrKs6oKnBJFVDtEEA7vo6rtzK1n2FcankNV	29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	1637	816	575	12463	18974	jxY1YpiAGHkvnsFrQakvBCnt8mh7E7acKEiAU3PHdxf8Fyet5mP	14441	20336	20336	1619599680000	orphaned
29307	3NL5MivbNyu6hkxF7fhVQpXJn8frckpGPzPtVoM66hVeE5Dtjj7y	29306	3NLaViuDHKVsajk7JvKWpC7MRCutc2RSH8ty1MJoeEYwQtx5EwTF	1637	816	575	12463	18974	jw8xCkSwAt9y5J3LU2zVAqRxbWat9NcZypakaCjcf9KtpdbJQyw	14442	20337	20337	1619599860000	orphaned
29309	3NLwS859mHzQuNi2MVShuj12AmyFcPHZK6WPWzWKufLY4YK2JSdc	29308	3NKedZJwwup7Mevj1zT7dVd1Gy8G6FNuL5PYynSbX18unh3xH7Nm	606	1295	575	12463	18974	jwcG1E4Ajp4d6LGFrPV1A9gYGShK2Ky1XPKCCfH9w55Hy43W5HF	14443	20338	20338	1619600040000	canonical
29315	3NKn3vXFSt4hAYnLbEpVrxMYS5zkiVHv3pVkQZLc9ZLz8i3Kara7	29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	1569	485	575	12463	18974	jxtB9SeetZnkHt6FXdon4BrzcAdbi4RgaEWX5u5KTQYZwBMk1C2	14446	20342	20342	1619600760000	orphaned
29322	3NK3wP1EJoELKeRTYYL5t7X2QSqWqXdGVu5jB35ZFsP4G8Ys2yar	29321	3NLaSAWV3zLcb4qwLVfjQ1TAWpXwHGrK6qcXzSY6ayTUauppHSyg	519	519	575	12463	18974	jwcQJrLJkmcRZojGLL1os95VccQQDoZFHMRcFbxHZZyLvMLfTvs	14450	20346	20346	1619601480000	canonical
29327	3NLfo25Wk8KRUwv1J1dSi9f7CGyZhDt9xwEmnzHsq1Lgmh4xzThv	29324	3NKFEvC77yNd3mDtEn2oJ6fmEhQodg7PLMutCFrArsXi8UGq7C4n	1527	1167	575	12463	18974	jwzGsmd95ctq9igTnNkZWG815yTCaRF9hykPX3Dq68f87XuabNM	14452	20348	20348	1619601840000	orphaned
29329	3NLpfQ6u31MPdZf6mHm77Lw7mV18tCrB3piGJ9wfj7W4xq5KKKyc	29326	3NL5cdcEtxUmNRqM9S1xpw1tSiyC94ikJzX5kVM568WtdGPmJU8X	1403	812	575	12463	18974	jxQUzGsjdphK1SDSGL8hmaFLPCirRL6yvanBrFQ38Xq4eGjMmYt	14453	20350	20350	1619602200000	canonical
29334	3NL6pwgse78uCA37aBeEzUnDgjJFGyTwvwyWRYPkv53vV5SE4mkB	29330	3NLVPT7h54mMQYCASfp4QUm6e7LcPdxEQh1Z6TMvhaNkGQk3aAG6	1407	1395	575	12463	18974	jxHiHi3yqV2AQFQQmTkmmRPKZczyNYAQZvefbBbd23QRw2WSAhW	14455	20352	20352	1619602560000	orphaned
29335	3NKcpQVbzPN7ESXrrxgqTehbBATuvXrpZJN4ai4xzm9pq5oMJKue	29332	3NLduF3oPANeWEsftWHonANToVmrhCpfofwN5fQNJkRGFRXBYvhd	1406	1393	575	12463	18974	jxubEJCkzAh2bAkrJFG7gacmrSp6fkFLaMfzjWT9gKnMEYzT99U	14456	20353	20353	1619602740000	canonical
29338	3NLiygR4Mt8jNrDwsGw27smcJHBzWceG1BgWXB5qbySLcYrKh9Hg	29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	1405	897	576	12463	18974	jwRmpNwWmCbcb35KbHUQzPQAbHSUTzhuhpU9FQjKP4B9DouYmnJ	14458	20356	20356	1619603280000	canonical
29340	3NLS7qtw3zo2JGduKUqXS3mNNPoBkyt54EM8krrXaspkigwhnZAu	29338	3NLiygR4Mt8jNrDwsGw27smcJHBzWceG1BgWXB5qbySLcYrKh9Hg	1403	824	576	12463	18974	jwFxV8dftvXcmtEEZavjdS5MGTKA93WubGzQS6Xd8KD7w1xwx7u	14459	20357	20357	1619603460000	canonical
29343	3NLRyEwJFU3A72CtrSjeY3izNSG2Nt1iWHmgYy4BKxD8Ux4rnqLy	29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	1406	1393	576	12463	18974	jwjfHCpZVVBRq4th57TGMohvSnuFfG6pJKkDcEYdgaFRdEcCPZq	14461	20360	20360	1619604000000	canonical
29351	3NKMWkMGpzfAkHZ2mWJU7DnEvSfbCAurFmCBur5L3HjE8BveNXum	29349	3NLLvKubbfwZNFvpnxp7k2RqotTc1H68NUij7AJv89f9bT8Z7UoJ	1425	184	576	12463	18974	jwmMJVSFPwLTTN2ppaekiGAdD3gEwwYhDxcMC7ToaSMMdvGDaCJ	14466	20367	20367	1619605260000	orphaned
29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	1448	1311	576	12463	18974	jw9zGoQ1CKkaJooTvBTiDAGvhQeEsE1DGgbyVSgNYLoVfhj23St	14468	20369	20369	1619605620000	canonical
29357	3NKAAsMKYnji4QBzsp42B9Q68KWiZdmZ4hRpw3JHDigPyKCzayBL	29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	1590	1300	576	12463	18974	jwy7PNzwxvn5wGDP5YVow4P6JMCp7kttKmC1s31RRm8boiedFWT	14468	20369	20369	1619605620000	orphaned
29361	3NLyMHYeTB5zwEvgmb1vF7VqhoArVBVeajGR7E2uL2PXfjhnwjcm	29359	3NLvZzNMK4V7gWAVvfNzaTTiSjqs36KFfpyMfM6H4L6LxchaNQPx	1585	1366	576	12463	18974	jwrSS53Qen9vQmuRGpZy7YkPjUoJxjSiY4uMNdAqdL44stVPkJr	14470	20371	20371	1619605980000	orphaned
29363	3NKepb6uSLgStZ1pLzfhQGWL34mgprc5RsKAo4KvyQjt7nz2pJ9T	29362	3NLQGPVfkuBMLmq3r2jUuthSN2AvejraaNmRCUZwdfFQPMv3z5KU	1483	1276	576	12463	18974	jxCPzRddcyU4p7SJN4EpLAQ9BgZKwXiNkJPrgQ5sLnb5knFdGN4	14471	20372	20372	1619606160000	canonical
29366	3NLMdi3jR96DSXbbUJeZnGhZuaemr6zoisrskhW8K8YvsAvYEVJ1	29364	3NLZUr7qbRAComp4NgLbH5fpuDXTUpnUDiJY49yP1Y99DZLpd8Ym	1451	1046	576	12463	18974	jxkz2cphG89Pi4BFQoiwcQy6mo4uxHQZY9ZzLKTJVKfSDRohKud	14473	20374	20374	1619606520000	orphaned
29380	3NKY2YxkTysyAi5z9xrYsmDDgRLbJL7bEWn4Z756fLxEiZ7TWFWA	29379	3NLTUg7DeAn3Lk69XD5NtidGtcTCdGBVG899pwdncUyr1vS6EkYU	1668	1370	577	12463	18974	jxAdJdzTKoZ293o6vQeKRSF8JawfDM7pTFWT1iHFtSvMkdhUKRy	14483	20386	20386	1619608680000	canonical
29383	3NK6iTXTy26e86fQiFua8uKseey7LQrTeigkK6ZGNSc6SbF6SaNi	29381	3NLY1kE7KcA8Ns3aCspTS75irBHvqRafCSgJptzK5HoZ2AA4T23b	1577	1081	577	12463	18974	jxNhyYWET5aCg2PSXiroTtJjZomWSRfXdosgyf8XvVn9dJnRcP4	14485	20388	20388	1619609040000	orphaned
29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	29384	3NKLG7NCYJkxKZYqf6YnjJiCbcpFk7GBj7FvxhPVikUHSY4oCPPS	484	1319	577	12463	18974	jwsbLJg5o67JE9asCiGPxKmQdGtb8p7GHeirGtfTp17UuetUGxY	14487	20391	20391	1619609580000	canonical
29387	3NLfHYA5kc6tAZ1qCcNufvvAL2p5ALxWYTJzBP9vtYoCRtdFAo2Z	29385	3NKNChk5WDsLZxsF4T57AeHB5jcEgKo5tki4TSdQHEdpWSTg7kJe	1460	1198	577	12463	18974	jwvv9pxChRmZWkumbBEffeXUEKrefhDuYNvVK2x1tQf5cS9Se9D	14488	20395	20395	1619610300000	orphaned
29405	3NLXd7yk9cw72Rbb8KwYAUi1ZHDk3Avc9bvFsY79GTH8sVAZ2ETJ	29389	3NLsDmf3cX4NFQqCoXgHR5kQkcKsMD9Psa5Cx1XGUhbTArPQjWmf	684	1106	577	12463	18974	jwC4HvmJZZqNv3YQdcndvQwPfRjksLdtF5P3MLSM6WsEvksMaei	14490	20406	20406	1619612280000	orphaned
29392	3NLSsCQy6vskEUy1jDempVdmGDVfANT8M3HpDZiphnfs22C34yWp	29390	3NLf4pRikTXVhhWDmxdqVVmeEGAudPZmRn2fXCydR9kgnEwfNMt4	1483	237	577	12463	18974	jxPNaDmtNTT52wA3iaCWxBHEaq3zyoBw3xhET7SWjqyrEtRoMtp	14491	20398	20398	1619610840000	canonical
29394	3NK8Q5B3Bs6gpkGy1vJyr1jupCQhrC2yrYjLuUhsaQ9iKnpZQ8zL	29392	3NLSsCQy6vskEUy1jDempVdmGDVfANT8M3HpDZiphnfs22C34yWp	1397	828	577	12463	18974	jwuYCcUKbc6PuFdZsK5EgCjNRF9CtvTgc3ZQ1ujGwhNqzGkA9go	14492	20399	20399	1619611020000	orphaned
29403	3NKsQPXm1JAvqqi5uqfksWqadkQnPUU8LvzwhmnoBGueD5uGbP9B	29401	3NKVTK79SxzWqgx6V67LJg3PRQepWpwgjZSBkEdWGwNmgnMx5qfY	1419	814	577	12463	18974	jxjx1KRNW9a6KZ1vvGbBdeF1P3odNyhq8aNLhjEGHoU74mHav5S	14497	20405	20405	1619612100000	canonical
29391	3NKD9jYsB6oJNXczkbH6HXd4WyNBGoMx6JA46sofMSnWkFVqRJ4J	29278	3NKWTqQv1dHuvdxGjENHyB2smjS3wUpxsMfmQoTMUxEmnRkrn2CP	1516	1294	574	12463	18974	jxvgDD7cGAiMq6zW6KzqjAEXpkGjP1ovosMJ7u1Z7JQvr14RAwB	14406	20397	20397	1619610660000	orphaned
29344	3NLnSvog8rndVXHEPQX5xzbaUMHUg458W1UDuSQpuF5oBW58WRg2	29341	3NKbb1bCW1dmMJDsYQ7oexyc7BWVmDfEFDgEbTJVYeTAMKJLwBac	1403	824	576	12463	18974	jxXz51RPQHhadfFHGsinFjsqiCLg5o1vRvmctF5HsvZsbiVvSKd	14461	20360	20360	1619604000000	orphaned
29345	3NKqUSkdeaW2NpnCtXdfAitEURXqpJuU2hv4ceHW9sK9EbN9s36y	29343	3NLRyEwJFU3A72CtrSjeY3izNSG2Nt1iWHmgYy4BKxD8Ux4rnqLy	1637	816	576	12463	18974	jx2SYJfcQ6o19zDqtFGmkWxhVS8XTS6md9gkLwcgjuFCxmD22jS	14462	20361	20361	1619604180000	canonical
29347	3NK7u6hENafikNrcSLprnQEpLi2JSW1y5jEuTJtMBPfxMTnG4ZtX	29345	3NKqUSkdeaW2NpnCtXdfAitEURXqpJuU2hv4ceHW9sK9EbN9s36y	1617	1288	576	12463	18974	jxkiYcgnWjNyRsB3KtCz5UcDsHkENXWEGS2qzTmQSfaaLnxv5kr	14463	20362	20362	1619604360000	orphaned
29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	29352	3NLQRPH3wxFDj4haS8tKFnbrLwGtgkHfLKd9Zm16euTfdBHkRoib	1619	1149	576	12463	18974	jwRPd9QMk6xUTTmocP4vKtsxSNwXC5T7spz4EKwAUyAeRHDgts6	14467	20368	20368	1619605440000	canonical
29355	3NKcFnEw3FTK9ighYsEkyhwwa8qFGeU66pmB4zUZN4AqySc2UifJ	29353	3NK9dLVtnATPY5R7XrEa5keQNBAMVC5uPjLr53iEYaAXLtFPAJSF	1448	1311	576	12463	18974	jy3DzHKhCT9NivrkZV75H7PcQVwaUrVevgpubDnF6WFQyygzmBy	14468	20369	20369	1619605620000	orphaned
29358	3NK5dosCdZUJEbKW1KyEbBg29gTfTqPUAvVVbHYQK252EkzTxJQ4	29356	3NKjARCKuJDWx8zR6nKop9pviWuyum44TTxfz8oTrosDUGcGE7jq	1646	1354	576	12463	18974	jx7it7Ve9YfzHqyuck78CoTCfVwKnUDrsCPay6rCrWfHy5uU9Fi	14469	20370	20370	1619605800000	orphaned
29364	3NLZUr7qbRAComp4NgLbH5fpuDXTUpnUDiJY49yP1Y99DZLpd8Ym	29363	3NKepb6uSLgStZ1pLzfhQGWL34mgprc5RsKAo4KvyQjt7nz2pJ9T	1670	1036	576	12463	18974	jwpwj83FGzGhQzqYLwNhFxYzwK4EjkMMM3HeE3UnpkbExajWPEn	14472	20373	20373	1619606340000	canonical
29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	29365	3NKd9H42xT9yaeBKYv2fg8qn97KbiXgSCDW3TN52A3EVKGNpgrtH	1619	1275	576	12463	18974	jxMaKeuzhgkNFdq7mp7dhmra5YgfboRQ1bT8S9SsgUF2a4h3ypM	14474	20375	20375	1619606700000	canonical
29369	3NKazC6zWuAVqQzH8MNLNjsivkMKUNEgue3KNLCPHfHEBvttxt3Z	29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	1593	1100	576	12463	18974	jxLrd458pQBxfjm62FtBQgpPeSRpH5NVZLtvpQVCAMB91QDow3e	14475	20376	20376	1619606880000	canonical
29368	3NL2RncViKf85SWJbX4x12JnbrHHRxoAJ1voccgzFPEftgwdWP31	29367	3NKjTAMfcGj4wopwCESVMtefeqJaNmXSnrY3FBhv7WAKqkaRqe6t	1402	882	576	12463	18974	jxZ9q2vYY8nRipTFjFencxxnwPfNepGGRhnAHKakSRf6hFBi5Vx	14475	20376	20376	1619606880000	orphaned
29371	3NKo7yZoJ7yYRSRWosJw5FvecQJHLYSdDbBPpN2cXwYmSgnmHYHK	29369	3NKazC6zWuAVqQzH8MNLNjsivkMKUNEgue3KNLCPHfHEBvttxt3Z	1483	1276	576	12463	18974	jwhMtCxTpBGwzzYmNWwSGv3GgTsaxCZFt1QvPpzJddGRnRUA9rd	14476	20377	20377	1619607060000	orphaned
29372	3NKBxtiaqJTc5S2tMttW5CpCA81ZZL3ViJ3FBpfRgm2Z25EBNf7g	29370	3NKYbyheErsf5BwRZV1tgbWvGu2SuXfV9CerupVseZWT9yDXzt6f	1407	1395	576	12463	18974	jxp6uqp699n8WAzmYBS6QReQiGHaGMJ3Rfw8D7bHA7ZwHYkNSM6	14477	20378	20378	1619607240000	canonical
29373	3NKfqvvNucTMQnZrFiFC7VSfQLLQBukMGiZZyYU73X7hTTvK3rsJ	29372	3NKBxtiaqJTc5S2tMttW5CpCA81ZZL3ViJ3FBpfRgm2Z25EBNf7g	1522	1196	576	12463	18974	jxnJVmc4B4hAiPWKi84TxPjL679M2t7HkCJAyxPzVjoRJ5CecYE	14478	20379	20379	1619607420000	canonical
29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	29374	3NKWU84f41MWAod2Un4pFEuVhw9mDHRzMupsErqPrNd9C5vRY6TS	1403	824	576	12463	18974	jwPxFQBUni5ZxUUoiMf6HLuAwBzmukKmL2tbHGCzYARqEUcX2ee	14480	20383	20383	1619608140000	canonical
29377	3NLW1P3Cab6pYo74RC6myKDfvLVcexrg7iNVe1BHmUapTxjhZezK	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1419	814	577	12463	18974	jxH3n8ygVVEJRgjYESySRNAwnRYb4a1oyB3wEnNsRd5nA1pcaEo	14481	20384	20384	1619608320000	canonical
29376	3NKnFfFXX8bUVjXNVSBqjFWCpTXo2jQThF6EYMFwezon5FJ5YSd4	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1406	1393	577	12463	18974	jxcmJr5c31e1GrkEYjiqgsXaBXU2c2wKNyz1Jd9JBvVHpr19x5Z	14481	20384	20384	1619608320000	orphaned
29379	3NLTUg7DeAn3Lk69XD5NtidGtcTCdGBVG899pwdncUyr1vS6EkYU	29377	3NLW1P3Cab6pYo74RC6myKDfvLVcexrg7iNVe1BHmUapTxjhZezK	1637	816	577	12463	18974	jx5AFzWtPB8wYvqSHNxEmhjjDngZ9GwbibtgF6A83g2N8aMhurY	14482	20385	20385	1619608500000	canonical
29382	3NKJ1inVzMvkVrD8pTQ21F4KrtfAwzQhdxkGKPcxC3JcZ5g1vU2N	29381	3NLY1kE7KcA8Ns3aCspTS75irBHvqRafCSgJptzK5HoZ2AA4T23b	1577	1081	577	12463	18974	jwaTiNF26a4c96K1DGQZUnUUHPQHd9buSfFJRqaJ5tUJ5As8uki	14485	20388	20388	1619609040000	canonical
29384	3NKLG7NCYJkxKZYqf6YnjJiCbcpFk7GBj7FvxhPVikUHSY4oCPPS	29382	3NKJ1inVzMvkVrD8pTQ21F4KrtfAwzQhdxkGKPcxC3JcZ5g1vU2N	1403	824	577	12463	18974	jxn1yJJF4hhXGvJs3aSQkQL82vsbUwBCs6SqtTdwb3oiQqEh7Yj	14486	20390	20390	1619609400000	canonical
29389	3NLsDmf3cX4NFQqCoXgHR5kQkcKsMD9Psa5Cx1XGUhbTArPQjWmf	29386	3NLp2HCyupsJSfLNUiGLi2tD5ZB4unLNPukqSioB9SRF5E3he85W	1637	816	577	12463	18974	jxbBoqSuWBcLeQpSPCLChnAH9zgQpsPQbdLX1otY2gSewP7topV	14489	20396	20396	1619610480000	canonical
29393	3NKDuQycEyEophXcuDoAY2fvquKhq2xbghjQwvwdjvKpo2FmdqTg	29390	3NLf4pRikTXVhhWDmxdqVVmeEGAudPZmRn2fXCydR9kgnEwfNMt4	1405	901	577	12463	18974	jxyjhNXnmKWbfWQeJiR3yGKfhwtUX7L5WEDpoxUz6iQcNgQJt5t	14491	20398	20398	1619610840000	orphaned
29395	3NLrjey8DUcynD5dj1DxB7tD3DCKa8bCxawuWJExXpAw94Cxkq87	29392	3NLSsCQy6vskEUy1jDempVdmGDVfANT8M3HpDZiphnfs22C34yWp	1402	882	577	12463	18974	jwj9Gx9c6AYeaAvNf9Fje3x1SbS59rYSWy1cSNsTvHJSK9ZmaKn	14492	20399	20399	1619611020000	canonical
29397	3NKNC6G7VdRp3EzrWGW4QbjNZWf5CQdfw6QkJAJvohvdYgWPoHY2	29396	3NKwD7r4b5oRKfQZ349MZmpqAVJV8UUEhLCMSMzPTN4PwLqanS5V	1440	1131	577	12463	18974	jxBn7K4tDSzYtQoPNUhnr6yB18Hrj4ZvnXHCm24xDHXfMbyq9et	14494	20401	20401	1619611380000	orphaned
29400	3NKXKEDVtXUaQGEDeKrk66Jt2bhPrt3SSxfHgwbA3uu3oN2vHMap	29399	3NK9krJkZgpBWbg9dit8NC8XM9B6cryotjUEimCtrM1dz3wVXfNj	1439	1279	577	12463	18974	jx4D5hgzRoXqjAPdJi2RpbWREswiwcptnNBYUfrioMSoe5R7HmG	14495	20403	20403	1619611740000	canonical
29402	3NK4N8qqBDb4E7CQD8EkBrAmrPnyDX13XijT8Ai61JioZjKLdVYN	29401	3NKVTK79SxzWqgx6V67LJg3PRQepWpwgjZSBkEdWGwNmgnMx5qfY	1419	814	577	12463	18974	jwAFmXCa1QY9DzvooQ498zQg4C3AxArckeovyKt8iE3HRH95uVX	14497	20405	20405	1619612100000	orphaned
29406	3NKUFDThmpoEdtUPtWBH1fNjqeZ9piQF3yfx3eznjqVpUtg669oV	29403	3NKsQPXm1JAvqqi5uqfksWqadkQnPUU8LvzwhmnoBGueD5uGbP9B	1631	794	577	12463	18974	jy2txVn1nPTBRc92JHmep3Ct8gv1V2dddvM7JmnbcmHWWiabdk5	14498	20406	20406	1619612280000	canonical
29404	3NKfkcnyBvTjKmgrAhCbkFNnFU1h8bzrAW4qUteHtb2qZJCHc9PT	29403	3NKsQPXm1JAvqqi5uqfksWqadkQnPUU8LvzwhmnoBGueD5uGbP9B	684	1106	577	12463	18974	jxui5Fn2QwyWmXNy4Uq2YxnaRUrPQbiLLzHdcBB8v1VVLtnJH4R	14498	20406	20406	1619612280000	orphaned
29415	3NLhJfk64spWfxUQZsPzaghnQKeQBNPFcJnTTqF5zxAKQyKsazPD	29411	3NLanbg8x6CWLJKwVkuSb58uboziPnKSwUMinQp3sEUnozch2wcX	44	1325	577	12463	18974	jwKh1jgeS7tiZxU1wirkB2nmSyDeunUA8xQvUtTckX8uCrVXswD	14502	20414	20414	1619613720000	canonical
29409	3NLjVZqckbsL6GPHji5KZdauzXsrz4gTMw8f42AsE32KFqSqi2Ly	29407	3NLyaMyrkMC8EPPHgC8tz3Rb9G7dUjEPrNwNmFYW43evhuZcgJvU	1622	1356	577	12463	18974	jxSWK2YuvpPZzcQC5S8hvUeAdxcFc839yHpXdjEnNkAmUZYczyh	14500	20408	20408	1619612640000	canonical
29420	3NKs9nwSy7Sz9bMmpWker5C3gkeTmLmwJ9qsryKJevYXEW9M5AWn	29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	1523	955	578	12463	18974	jxC4PhrL9K7ARVwK1Ag6qBzLwUoRisXX6UJpRAkr34ca1KZgbjw	14504	20416	20416	1619614080000	orphaned
29424	3NLmcbhr7DWN7ciLqxRfD5wXbFH4v7CzPwVERYd4RAgdcTvu8jJZ	29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	1407	1395	578	12463	18974	jxt4Fz8ZRFGbphAqNhf7pBcvT4XkeUbXoygNmrYEWkv9v3Myjci	14506	20418	20418	1619614440000	canonical
29422	3NLDHTMbopjZzMdjFQCn9J3tgeeu8BYfz82Gpxw7ss8mGbhosnc9	29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	1457	1265	578	12463	18974	jx3jWhtZQ768dbcpFDoUtDwgGzLnNJbJk4kwBazhcLtCAxDeL4Q	14506	20418	20418	1619614440000	orphaned
29428	3NKmX1CyBahfjz3B1BmJXQdE54LWougctczGEYa5qWCBxgzZJYSL	29426	3NK6mLcURAD2yoZ6MhcAfJai7LJuwwR8hRrxpy9cRDsVKdEa1e8A	1631	794	578	12463	18974	jwXTV7UBYmZVVvpCiZyn5ZA87mSCKVXRkUyjMzaNEGUYzqKXZja	14509	20421	20421	1619614980000	orphaned
29430	3NLQAaH1zy1UtwmAWfxE2VQBRb9t8xBDeLjrs3J753dZuMgFmvMb	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1406	1393	578	12463	18974	jwekUD2xpoy6286ZMmcXGx6ugj95voZi3tQga9cBQXAbn9TQ3EH	14510	20422	20422	1619615160000	orphaned
29432	3NLwZevDHHtCQ7cYEzN1D3eF2147b97QYfht9TkZVLFXXm5oW6i4	29428	3NKmX1CyBahfjz3B1BmJXQdE54LWougctczGEYa5qWCBxgzZJYSL	1668	1370	578	12463	18974	jwRtWopcouJHovoUG8QJrxig1DjU4uwGk5svSzzAyXSuFJMXAii	14510	20422	20422	1619615160000	orphaned
29436	3NKQbQZ2ZaZ9ae9XAUS3RTEwPi5uWyh1hehvotQH7TzKiWAA6vGW	29435	3NKbbDmcEPfcFQnaYhEbNssNz6YX2RDaCDeFSYshebv9iH4bnCTo	1507	1154	578	12463	18974	jwpBA6YpmZX5vWM8WWkCkqDUyU97VrtwJ6WpVuaB19HyecFWDM3	14512	20424	20424	1619615520000	canonical
29440	3NLMouWJp8gjArUgnzjrtcMgQGmpsMzHMQWYLeJNQuHxY31qNjE1	29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	1447	1345	578	12463	18974	jxJXiModPyYEeftqZDXq9PVSZ7G71a9u6q2JgmjLAUBBEf2J366	14516	20431	20431	1619616780000	orphaned
29442	3NKtuJupCnm19t1x5TrLc6UeJT5H6M71sZXVkMWcdH6rUnyJjGQ9	29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	1407	1395	578	12463	18974	jxE9N3zAdeSzjrjE1u9qpzhikgszviBaDaLSt3TFWvbR14Suhen	14516	20431	20431	1619616780000	orphaned
29444	3NLmxf7YGBKrs9iTRAuLZVzc1asBKw937sG1Z832mbnVS91dneUZ	29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	1624	968	578	12463	18974	jw7FPNesRVPVnamfrBMgHfwHZURN8EKuSdCtBdtJgSVkoqLNm8h	14517	20432	20432	1619616960000	canonical
29443	3NLH18z4c1kfGTwxyYSPLXkGKy4h737PBSTSUzKK9HmpzFSz7kC2	29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	42	1115	578	12463	18974	jwUjct4gLmwwmkhjTGatGb35Axykq55HQXJ7MgrszHLLPub45Fy	14517	20432	20432	1619616960000	orphaned
29445	3NKLtALrXwQCCPqqzGYotxeLBrs3cgCsAqwTqANciv7pMVp2hDuk	29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	171	1374	578	12463	18974	jxF7c2oGMfBCwz87CJ6VkFsckHLSVK3nSma7aiuyY73umrUbwcP	14517	20432	20432	1619616960000	orphaned
29446	3NLivxHoWtZ9xtWVBsW11szVSAsQ33znvUMuqUaYqQPR18cLJULZ	29444	3NLmxf7YGBKrs9iTRAuLZVzc1asBKw937sG1Z832mbnVS91dneUZ	1578	1050	578	12463	18974	jwSJEDRyvSBgyhgeS3X3o2tTATpcBAqiT2WsZNSkta6WUiVD3DZ	14518	20433	20433	1619617140000	canonical
29448	3NL5d8wMQgghC4EkvwrXySBQmc38PJToov7YjsYDAN9bAXprx714	29447	3NKENnchUQKH1CxArnrWZ1TDQBCVxi6MVsKsvBDSssuywfLA97iM	1637	816	579	12463	18974	jxpYGseQ9qq1yEaA6jWPhLV1R1J8XxnLjYssJJKGq8iCXJRceoT	14520	20437	20437	1619617860000	canonical
29449	3NLUBntMiqoMEkvevRjrT67QKmYTbUnHtV6bb4xTGP9Cq6nGfhXH	29448	3NL5d8wMQgghC4EkvwrXySBQmc38PJToov7YjsYDAN9bAXprx714	1542	938	579	12463	18974	jxZaHAmGEH3mmmeKgsb3rRPQkfis26UkQ8L4Rn9Hz13DWWwGVEx	14521	20438	20438	1619618040000	canonical
29450	3NKekZJWq6yKaYj9s4rRdcz9LmNAxj9Um7agV7soo4rjEkKGBVvp	29448	3NL5d8wMQgghC4EkvwrXySBQmc38PJToov7YjsYDAN9bAXprx714	1542	938	579	12463	18974	jxS7AGZyMW3CzNb3AynSCQPWkFUgpkpr4Cru5wFU4VQ1KHptwSM	14521	20438	20438	1619618040000	orphaned
29452	3NLqDoyMyDBWrqpYYqfudRCzQCGXh3NY6MZEMThFMuQtrgdQKPRZ	29451	3NKgkHyPk8WpfHp7zZH3oArb5qowwfxaLGZoYmsS7AZYLfEMC7sq	1564	1092	579	12463	18974	jwFg6DHwz53JixrDVsD8kH8coXn3LMDADiUJgf2W3P1BijKvMZD	14523	20441	20441	1619618580000	canonical
29454	3NLG2E8788dhqyZLXWNS3saovr1Rd1wfkaeW6mbbmPh8AViFEPah	29452	3NLqDoyMyDBWrqpYYqfudRCzQCGXh3NY6MZEMThFMuQtrgdQKPRZ	80	1273	579	12463	18974	jwVu75B7KyhBaV4Z8HmpHk2rcwoR3dSgR99zpFzfNcSD4pvHFP6	14524	20442	20442	1619618760000	canonical
29463	3NKYD842VoExaxsS51KYTqoLp9xDXqCaib8jMD38fVfBZc1v9TE4	29461	3NLdpEVNyMusvSwiFXYvzjvHDV6zUVbGWwZuqPjYGodUdLUvNGXa	1503	1031	579	12463	18974	jxMuhvJQrTsVDmdTzL9g6pJSgefrWfAK2Qa1AHXanLdrSnbCihB	14529	20448	20448	1619619840000	canonical
29466	3NKwr9FxtHhAbT658cntvN4xVHHuREuZ9sJdusrosTES3mnap1b4	29463	3NKYD842VoExaxsS51KYTqoLp9xDXqCaib8jMD38fVfBZc1v9TE4	1501	1114	579	12463	18974	jw8SziZr45khWFPve4Awrj9FqgXB7pUqq89ekw98YjkKoeGMcrR	14530	20450	20450	1619620200000	orphaned
29468	3NKRa7L3JdvZ3Y2Ak5zJyijcP7HwkCBz84SEPaJGCM3fkMsudbrB	29467	3NKZXt2seHSNu354mZZrqp9TtkawAhPPZ7ipR9nf3VC3D4cvNfdn	1637	815	579	12463	18974	jw9bAoXgruLVu2drggGBNxFmrMLnBjx3dKKeyAvWjkrGHgBLQw8	14532	20453	20453	1619620740000	canonical
29473	3NL9EAXdzSgt9u22zfhx4K8qCNmCVpYDRD6QWxswDfMNZmpdoLmE	29471	3NLh458BtnBw2y5QeBYVTWpjWxevq9cwxNuP4GVn2NZrqtaSBT3b	1402	850	579	12463	18974	jxRp68J6CqxLmT7aKcj56A7S8pPfgippuasCKBCRXyhdJ5nUYKa	14535	20456	20456	1619621280000	canonical
29477	3NK9eVnqrcpHXV9pFGaQhUogo1sSgD7qg1hTFRgtiyscr4oGQvnv	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	606	1295	579	12463	18974	jx1otUYLp13ktJcoSzHaX55Yz5py7a1SAxqbGprC3WTa6cLFMD6	14537	20461	20461	1619622180000	canonical
29479	3NKpbQdN3Uvgi1sxrxQiPJtHWrihQzYDKmwZBSrgav15QyCH66LN	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	606	1295	579	12463	18974	jx1otUYLp13ktJcoSzHaX55Yz5py7a1SAxqbGprC3WTa6cLFMD6	14537	20461	20461	1619622180000	orphaned
29481	3NKad9gmoBaJztoo9R4r23V9edqVf2PQhfCp2RP7hNXwa7FQpKRn	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	606	1295	579	12463	18974	jx1otUYLp13ktJcoSzHaX55Yz5py7a1SAxqbGprC3WTa6cLFMD6	14537	20461	20461	1619622180000	orphaned
29485	3NKnqWU6aS8tAa9Kfo1SgjHrmxyaZi8C3yQgTjwEfQXzyyNuDmN4	29477	3NK9eVnqrcpHXV9pFGaQhUogo1sSgD7qg1hTFRgtiyscr4oGQvnv	1483	383	580	12463	18974	jwXwzxHuX3Tco2xo1zqohcZoKiBUHJUqhjCs9vwB3vn9Zxf6y6o	14538	20462	20462	1619622360000	canonical
29483	3NKRM5oZtsWNBsq3Z1taNGVgBNVWnezCZnW9cjWegZtvDmp3xSVF	29480	3NLioQBSu4p3xFetLP5BPMjbaknkxHpQ8AjGtjBCkMScZnmn91TZ	1406	1393	580	12463	18974	jx3huzmcwNbgYNPM94xeAkAqs96EaARMbEBrN7rjaHyyX7amJkC	14538	20462	20462	1619622360000	orphaned
29486	3NLdDUS8KjyYEfmyBFCwynYb4n23gmruPxpSr5FrrADtofEorSJA	29485	3NKnqWU6aS8tAa9Kfo1SgjHrmxyaZi8C3yQgTjwEfQXzyyNuDmN4	1647	1302	580	12463	18974	jxL1FEji5dn3tR8SFGtDCRWJpkh5DnwFzm1uzpDfZBKr1JCebcQ	14539	20465	20465	1619622900000	canonical
29408	3NLEAT34MzkQn1prtP7HXQBW9gGP4TvZDtJQczoKGENq4KyMvC5E	29407	3NLyaMyrkMC8EPPHgC8tz3Rb9G7dUjEPrNwNmFYW43evhuZcgJvU	1587	1357	577	12463	18974	jxuwqXgdw4z8b9Kv3bfdhVwseNndAbUpVopcc9uxCBV7L5gHTGk	14500	20408	20408	1619612640000	orphaned
29411	3NLanbg8x6CWLJKwVkuSb58uboziPnKSwUMinQp3sEUnozch2wcX	29409	3NLjVZqckbsL6GPHji5KZdauzXsrz4gTMw8f42AsE32KFqSqi2Ly	606	1049	577	12463	18974	jwtSBawJfE7dHXwyPtfyARbmtkFC88J2cUCV2iqiuNFMsB1SZBP	14501	20411	20411	1619613180000	canonical
29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	29415	3NLhJfk64spWfxUQZsPzaghnQKeQBNPFcJnTTqF5zxAKQyKsazPD	1460	1324	578	12463	18974	jxEYwAz6Gn9RUqk1f3Aow9bUwxuq4mwtHdHmM8uSRx1keVLpF5L	14503	20415	20415	1619613900000	canonical
29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	29419	3NL3aV7JeEjATFSXwfAyyfvXaGV7MuNyS4a5Ren2BN4D3Bf4xHR8	532	1303	578	12463	18974	jxQmkkSWt7bTrtTZEss7kuoF9eM2zBT5uw2Sm3rL5zKc2FAt1hN	14505	20417	20417	1619614260000	canonical
29423	3NLwS5UkXJkh2LMMatdvL3yDNbLVSVBxwr4bQXaVEYA3HK6mXg9W	29421	3NKd9sjDSoHaKd29zCPWmiu2Y1Z1Dfg9rRCY2Hsn6zTu8XHmBovp	1593	1100	578	12463	18974	jwYACcgydCjvMdQfTVRKa99HvLgx74LzXjem58iERWrtFdnPHDD	14506	20418	20418	1619614440000	orphaned
29425	3NLWjL7haXGHT3fdzZpQwbSdfCv5UeV5ha2JieqX1no7j6ZNDSmH	29424	3NLmcbhr7DWN7ciLqxRfD5wXbFH4v7CzPwVERYd4RAgdcTvu8jJZ	1406	1393	578	12463	18974	jwrEr4CSvHv9d9YVutBHJtnRN2eyaqq95MrFRtCdDHTJcy9jjFQ	14507	20419	20419	1619614620000	canonical
29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	29426	3NK6mLcURAD2yoZ6MhcAfJai7LJuwwR8hRrxpy9cRDsVKdEa1e8A	1587	1111	578	12463	18974	jwehGNDbJCVMV6mpauBhVwYSvmgmKUK4WcVAnnjqjLpKpReNVra	14509	20421	20421	1619614980000	canonical
29429	3NLB42QJ5jZp4w1vpfE8mfayL3jHdAgAvFrYg6ewnqeQfmo3sWww	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1668	1370	578	12463	18974	jy2E6iBb1xnVQBAkGx7LcMom6MaztU9Dhixi6s7RvTmsX9UKCou	14510	20422	20422	1619615160000	orphaned
29437	3NLt9w7j5Z8B6434UyUbZaXHJsj3LC4HRA4BQ5kYzoDuxqzk1fQJ	29436	3NKQbQZ2ZaZ9ae9XAUS3RTEwPi5uWyh1hehvotQH7TzKiWAA6vGW	1422	1337	578	12463	18974	jwnnQSmLukBHZwJ9VnaN72ogUTgKsEM4S4rMxSYafzoaMfRbM6g	14513	20425	20425	1619615700000	canonical
29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	29438	3NLDc1gK12Siuct31K3jnGrTRFmVVmf8xnAFHmynqebXYRE1ceaD	1445	1044	578	12463	18974	jx8i2kgaK36JQBNoAfhH4eNjE6f36CUeHqEvcbc6222v4i59nZ1	14515	20427	20427	1619616060000	canonical
29441	3NKdgzigxBkhSssDHmtdkPnjVdqzfbp2q8R12JCkYcHUVJUZqfMn	29439	3NKS2vSpsDKKVNQ16YyVNS6K1ABQWvCx8swCU9WSxyJ8HV1VcMsG	298	1062	578	12463	18974	jxyfiNqAR3gLjsYPKCDbD1GkWkMLcDqkuWGfJfyUjQNKtS5LiyA	14516	20431	20431	1619616780000	canonical
29451	3NKgkHyPk8WpfHp7zZH3oArb5qowwfxaLGZoYmsS7AZYLfEMC7sq	29449	3NLUBntMiqoMEkvevRjrT67QKmYTbUnHtV6bb4xTGP9Cq6nGfhXH	1609	1087	579	12463	18974	jwsi4ygm3TZL6s1R4hyFV9CZimKpuse4qnLp6jHxxh3KCbsmTzw	14522	20440	20440	1619618400000	canonical
29453	3NLDNKUS6a1cvYZyeN1FiLS8okM6qc13xT29p8ni13apbLwcR4kA	29451	3NKgkHyPk8WpfHp7zZH3oArb5qowwfxaLGZoYmsS7AZYLfEMC7sq	1534	1317	579	12463	18974	jxKZX1FRaw6aEMmiQuUfg5TQVT9AsF3LyyqivCdCCENB3Ry9Nur	14523	20441	20441	1619618580000	orphaned
29455	3NKW7nNoLnXy6GBbKNVENq4KJSYS86Gtf5HErY6mu3nY4VK4qUhe	29454	3NLG2E8788dhqyZLXWNS3saovr1Rd1wfkaeW6mbbmPh8AViFEPah	1675	1096	579	12463	18974	jwHhnq7vbxEvW6B5qXkah532ngYHq3REkhiSa2RuobMHArccJ3a	14525	20443	20443	1619618940000	canonical
29462	3NKwK7zRS3DZKeTSqwNYtmyF72kYsxeaRqBr3f8fGiqVLdagHkSX	29457	3NKGuBUsy9bkcJC7E8eQq2MPtzhfX132NjRQWKibJfeiTnhwKTEv	1529	1190	579	12463	18974	jwH2qQLiKvzrgwrsQYotK6JBtre2xGHaunuH8nGGyqJP8cLyXBK	14528	20447	20447	1619619660000	orphaned
29464	3NLq5mFtq8j88aUhGYC12h9UXKoG1un16FmRcnG8sRWE3UYUHcpm	29461	3NLdpEVNyMusvSwiFXYvzjvHDV6zUVbGWwZuqPjYGodUdLUvNGXa	1623	830	579	12463	18974	jwtRoGZmNF5GeVa1u4Perc1mjYi5KG8EXeaVvCrAuFfLmvNHjoc	14529	20448	20448	1619619840000	orphaned
29476	3NKukmMoaof24pBH5rZeSNvQxCcU3RNh9wNrUq6AgXrpS9ZF11nf	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	1622	1356	579	12463	18974	jwVuf2z2pNmt28wtGn7MEVvZma4iziyDR5anBgGkrtWycqYrsNM	14537	20461	20461	1619622180000	orphaned
29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	29486	3NLdDUS8KjyYEfmyBFCwynYb4n23gmruPxpSr5FrrADtofEorSJA	152	1330	580	12463	18974	jxuuewvtwGg7R2qoAXpAaByMgcowQAvQwAJHTLansVz28LpXaPz	14540	20467	20467	1619623260000	canonical
29489	3NL6UpaXzZYmPSfhtTPTPfMDdFtMa7NMT5DWT2dHgNk8NMC1fLES	29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	1407	1395	580	12463	18974	jxcyqKcCzCwJfvD3iHghtkirUXw5KibpEXMhaCK3PRQN1xn1WNg	14541	20469	20469	1619623620000	orphaned
29492	3NKSzdjidDTa9qTV7Vq3scG1punSi7UZHq96JjYNDwiznLbVYHYE	29491	3NLJaGaW6cNXnVHigLK3ekCgBXt7u6M2TZejxnrrTjYoARsfGUTS	1406	1393	580	12463	18974	jwwpUs7WEBX5gyxhPKsFFpgcUH3TzroqkrMA5YFwywegCCWoJ62	14543	20474	20474	1619624520000	orphaned
29496	3NL1RmNW1w8PgRiBc7Sj885Wo28zijE1huv4ujFKcc6k7urPHtZe	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	1541	1298	580	12463	18974	jxFsEh8A5ACAXsAbAZaMmBn9A6JVpccnKsb7xi2QwYRAoAzqcWy	14544	20475	20475	1619624700000	canonical
29494	3NL1ewtRAfYhCPxzjW869aDkUcnD62yvWLZmKS8hgDSCHbYFK9XW	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	1422	1091	580	12463	18974	jx7VMAwWDiWTCHu5ZFXdALxuXXEJnzU7onnCWUn7M1266gBGcwq	14544	20475	20475	1619624700000	orphaned
29500	3NLWApfZVHFrekR7s12oAwgBK7VYe4ajeV3tUKkJLRU7NKDA9JmR	29499	3NKRiLXT5qBukuAd3sdJg9NHxJCDgennZiPgmHeCvnUxw7ow24vr	1406	1393	580	12463	18974	jwd2E3CvHWcyjXZTwEZm4pDwy1qUxHgN1jw8RbfutVCrATXbEpw	14547	20478	20478	1619625240000	orphaned
29505	3NLVzdgzq7eLmHqo2Cjft6ZjtC1GwwChYAUDw16fAsXTR4k3R4Vc	29504	3NKkGbB9LU1EpXQLmgXM5ELAJzbN9ueoKaHKEZt9TQGrZawccvZn	1406	1393	580	12463	18974	jxZeeZz48jjJANQJxQKjAEj23v1SmnY4jpeUg6fKznC23qb3XaF	14551	20482	20482	1619625960000	canonical
29510	3NLP855Fd5oDz1zELf5jCVnTzoNo3mt9QFeJxnuxBoaBCTvBSU62	29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	1522	1322	580	12463	18974	jxagTXLbnhSmpFpCFqCdZGbAiVub9Jr5XzrC7BQMWrtvbpnbyg9	14555	20487	20487	1619626860000	canonical
29512	3NKTmod7L5hn345QMQxWJX4NBVh6n5yjzqLXQAtmFii9REHWmrAG	29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	1419	813	580	12463	18974	jxp7c6wowkjhfDgbKX7FsJK1Wnp9PmXw6gU22UjeFuXPrNFS9Fa	14555	20487	20487	1619626860000	orphaned
29514	3NKjyaMnkgvnnSdB7iCUcdY8MuMEnuiC9HfyCrigrjET9TvMhzYt	29510	3NLP855Fd5oDz1zELf5jCVnTzoNo3mt9QFeJxnuxBoaBCTvBSU62	1407	1395	580	12463	18974	jwsGxmNftd3EYxNrwxUivkf3CZU1YwiLx8wtaZLLn4jnNWfiDZP	14556	20488	20488	1619627040000	orphaned
29517	3NKoJCSbx7J5tnU7UG9ZBLLKMcSYvbjmEQ1XuKw2UV14LbzNyVrF	29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	1672	1039	580	12463	18974	jwZ5vSHaDWkF1b8XFLStVFWqgoSVpoZqjwwtaVF8HaoD8RKJDxD	14557	20490	20490	1619627400000	orphaned
29521	3NLhadGY7ZUG6DFaS7WT6rEnoxm3wMf2GWakyHtGHMdmmWW23zL4	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	152	1084	581	12463	18974	jwrnRpZF4tXdyr4mLacJqYWAqhH4cRyNMtH1nshBFrZ6yBYApT8	14559	20494	20494	1619628120000	orphaned
29414	3NLVz4rKfsMwpJ6Bn16TZxwtYk7NroxQ998FVwfYG8g1mudtgui2	29411	3NLanbg8x6CWLJKwVkuSb58uboziPnKSwUMinQp3sEUnozch2wcX	44	1325	578	12463	18974	jwSSZxGrR9tzN2HVe7x6eVdMQssGTWdcRJWtGS3dCwhkZY2nBxP	14502	20414	20414	1619613720000	orphaned
29416	3NLZmDEQaQqMfvdWm8WfBiDsU3v8zHMmriyR3hXrF4noWE9X1yjG	29415	3NLhJfk64spWfxUQZsPzaghnQKeQBNPFcJnTTqF5zxAKQyKsazPD	1460	1324	578	12463	18974	jwzperPppNjBV5pBV2j6vf7n5L9XxnwPNS66DiDT8u2Nb5Cra4C	14503	20415	20415	1619613900000	orphaned
29419	3NL3aV7JeEjATFSXwfAyyfvXaGV7MuNyS4a5Ren2BN4D3Bf4xHR8	29417	3NKyiRqpjMVRcd6Ftr7ajz2tMpRJ3YYpNy5br8EZevxRY2KuxEkQ	1523	955	578	12463	18974	jwbiGdj6kvkg6ZsmriJyJffQ7BpTyqRUwLSWiKfgwwtXuPL3Hch	14504	20416	20416	1619614080000	canonical
29426	3NK6mLcURAD2yoZ6MhcAfJai7LJuwwR8hRrxpy9cRDsVKdEa1e8A	29425	3NLWjL7haXGHT3fdzZpQwbSdfCv5UeV5ha2JieqX1no7j6ZNDSmH	1550	434	578	12463	18974	jwTBFw9FkqHRWxwdAvwKyAVhogV2ijKSRRxwYq7PrWLysYv3iSX	14508	20420	20420	1619614800000	canonical
29431	3NLCE2yZd1XMWMyYeBiFvQVXFa2ujMuybYVKVX6aNPSF93LwfXGg	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1627	1259	578	12463	18974	jxHGCsPrk9BZfm5ne3P2NsqSSBj9YWDoqjwjFsvZjLViyzeGfny	14510	20422	20422	1619615160000	canonical
29433	3NL6vYYHhNuGu9K1D3xxodt5tH1oUk8Zd2TGN9k88S1uYYVoqCvY	29427	3NLFxutofymvamgsJ1VN6yzAHG2DUAiXZU9RKkQcx6EpVfkeBoHS	1522	1322	578	12463	18974	jxZa37GAzvVHGkGHK22x9n6U94aF6NZgRxGBKisq7jGvJChE1JJ	14510	20422	20422	1619615160000	orphaned
29438	3NLDc1gK12Siuct31K3jnGrTRFmVVmf8xnAFHmynqebXYRE1ceaD	29437	3NLt9w7j5Z8B6434UyUbZaXHJsj3LC4HRA4BQ5kYzoDuxqzk1fQJ	1673	1122	578	12463	18974	jwvwbYubMFespjg5jVC8iL2YJAFCDWaWc3DfdX497RjFpiYZiDa	14514	20426	20426	1619615880000	canonical
29447	3NKENnchUQKH1CxArnrWZ1TDQBCVxi6MVsKsvBDSssuywfLA97iM	29446	3NLivxHoWtZ9xtWVBsW11szVSAsQ33znvUMuqUaYqQPR18cLJULZ	1673	1122	578	12463	18974	jxrLiTfG2CLF2VzdKhwsbbhY9oAAmK7jj1t6JoyczxvL7Nfkahe	14519	20434	20434	1619617320000	canonical
29458	3NKTEHPfKmKP3EVPiiSpRKoM6kf4bYi8J3ajMBfmrZK5CMyjUNtq	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	1596	1363	579	12463	18974	jwvuDBMD7Cu9xLPGhpXSdJMRwsyLpzVLpnyVswmPGG6h5fnByeR	14527	20446	20446	1619619480000	orphaned
29465	3NL6G4pN5nsM43Xc1tga4fKHjjPNjfjeCAgmcexveUSZWmvQ2J8Z	29463	3NKYD842VoExaxsS51KYTqoLp9xDXqCaib8jMD38fVfBZc1v9TE4	80	1027	579	12463	18974	jwyfahncMHsVrX8tJWdAX1hxrx352aWCZd1kUQb2nweQwi6kVEA	14530	20450	20450	1619620200000	canonical
29467	3NKZXt2seHSNu354mZZrqp9TtkawAhPPZ7ipR9nf3VC3D4cvNfdn	29465	3NL6G4pN5nsM43Xc1tga4fKHjjPNjfjeCAgmcexveUSZWmvQ2J8Z	1483	205	579	12463	18974	jxNaxoXe9YmwArQ2wdCxrds4LtWSwHMuvbmj6Jb2j1kpKe8iSkB	14531	20451	20451	1619620380000	canonical
29469	3NKxQ9gTygfznVJHZozNjvQwvkKzjVUeGWDZWBLssjM9o5BrnRoJ	29467	3NKZXt2seHSNu354mZZrqp9TtkawAhPPZ7ipR9nf3VC3D4cvNfdn	1407	1395	579	12463	18974	jxQafmTYQwuQcqcURhwBv4uxjyGqfiMhZ7aDzQy8o5Q2zBA9V6b	14532	20453	20453	1619620740000	orphaned
29471	3NLh458BtnBw2y5QeBYVTWpjWxevq9cwxNuP4GVn2NZrqtaSBT3b	29470	3NKcvW83HupdP1bdGwHX6bHPvmuoikaDPtbG1HVsRzoeJai1V9sp	1406	1393	579	12463	18974	jwjWUvjKY3Es8zkUS5mf6a8Asf8RjU1anaTmvnS8BG89C7GRyMi	14534	20455	20455	1619621100000	canonical
29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	29473	3NL9EAXdzSgt9u22zfhx4K8qCNmCVpYDRD6QWxswDfMNZmpdoLmE	1403	786	579	12463	18974	jxoXtNnPgKFW1bifZF4g5VWRDiPTaPWopCFs3DyRMU62Wc8vQFT	14536	20458	20458	1619621640000	canonical
29478	3NK5x6Cpws7uzbRiszZqZLGmY64r27UxXQB82NjKBCJaXNMASHTq	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	1622	1356	579	12463	18974	jwVuf2z2pNmt28wtGn7MEVvZma4iziyDR5anBgGkrtWycqYrsNM	14537	20461	20461	1619622180000	orphaned
29480	3NLioQBSu4p3xFetLP5BPMjbaknkxHpQ8AjGtjBCkMScZnmn91TZ	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	1405	861	579	12463	18974	jwf8ACZvhUUyGEFtQvz5K6PdkpnsWHQNid9d1xidfj3q1SJA3ss	14537	20461	20461	1619622180000	orphaned
29484	3NKiCUEjJhEzxW7tNtBhWX51NK768vkLcDCcM965Qapx9t8Rr75v	29480	3NLioQBSu4p3xFetLP5BPMjbaknkxHpQ8AjGtjBCkMScZnmn91TZ	1483	383	580	12463	18974	jw9frcmVgAAs85wXuMLgMCjv4sfi2QKvGPe19z1BaKxdwdvg2mt	14538	20462	20462	1619622360000	orphaned
29488	3NKspaSYWrA1rhoM1wrNchNnmXmhvBcC91jH6wPcrUyxyPJkUo8r	29487	3NKyd2UmB1JwWd7fRXbdkD29kjphbm27NFKb4hUeqTNfhYaqn5CL	1403	782	580	12463	18974	jxiEnLYaR626RUwsaYWDGfrkak2xZYSSwQ7wVPcUcEVVkxuf46B	14541	20469	20469	1619623620000	orphaned
29497	3NK7WzNyN3LGQGj3M6a5TMWF5QKiC6614bni2TmAnNTcKR3L6j6J	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	1541	1298	580	12463	18974	jwkuVn8X2d2LoxZNwpyDEgpANVTxTvY5zp6qqEbMNk9Fs4J71S3	14544	20475	20475	1619624700000	orphaned
29502	3NL3i56r8eccgmbVKiX5xfjoeHzwkcikdHahxku8wkDiz9qk92iP	29501	3NKmHBz4RQwE8Zvddzv16Hromb9aWtweMC9aorMtr1pbNKsBUAVj	1656	1343	580	12463	18974	jwC5K7eXsLeU1MmAv954xmHCE66aBZrHC4xe4e5Zhf147vGmBFq	14548	20479	20479	1619625420000	canonical
29504	3NKkGbB9LU1EpXQLmgXM5ELAJzbN9ueoKaHKEZt9TQGrZawccvZn	29503	3NL5ugstC1SVMNuhh12MCDiTXeKbr74eRMCc8772T3rsKusoGpQZ	1407	1395	580	12463	18974	jxeaWL9hQ3kqCqKCrgL7bY2QciyRxJuDYPpwwF2dEEeQq2tCdLZ	14550	20481	20481	1619625780000	canonical
29506	3NKWtj2UjXgktdM1heYouUic8eFAsAizvhuyzpPDRBvXdEx3CLyf	29505	3NLVzdgzq7eLmHqo2Cjft6ZjtC1GwwChYAUDw16fAsXTR4k3R4Vc	1406	1393	580	12463	18974	jwJsAVUfTWAPSnBAjCFAXAoVwiCAZtiWXRv9nJrnzozgRyhfQwr	14552	20483	20483	1619626140000	canonical
29508	3NKPK2479cCbWz6ZkKa5pt21LnTvyBugokPc6UY8zTZJZBA1Y6Ac	29506	3NKWtj2UjXgktdM1heYouUic8eFAsAizvhuyzpPDRBvXdEx3CLyf	1440	1131	580	12463	18974	jwbTDp1pYLCRYURwZvL9wCRRQ2W6rZYJ6Cj7VDsvXUV6jqSfRvn	14553	20484	20484	1619626320000	orphaned
29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	29510	3NLP855Fd5oDz1zELf5jCVnTzoNo3mt9QFeJxnuxBoaBCTvBSU62	1402	34	580	12463	18974	jwMCLgnxMrXhzHLe94faGJa9HDGRD5xz13WKrrbRD7TvxyrxVHF	14556	20488	20488	1619627040000	canonical
29516	3NLWZHeciQJZ8ZCYesZa8KJC37KE4f4DyGADxtVtkwGTx64Ujyg8	29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	1637	816	580	12463	18974	jxn9GhEURpxjLEv5NCp5DrKFrQaR8R1qA3LbNqsgEFktFrmFCm1	14557	20490	20490	1619627400000	orphaned
29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	29515	3NKFds7A8npnpxBXe4vGgUYF4EpSDF28aCCqxSxt3BbW5ohPjhFr	152	964	581	12463	18974	jwEpToZnDtVqFkLxddHJZVeE9YpLe137bRGy4R4xxrVVSoPEJBX	14558	20493	20493	1619627940000	canonical
29523	3NKzq4FsNVX9ZiQJ3hxL3dgjQVh5TxuZbQrgukdki456EZaUGvy3	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	43	1310	581	12463	18974	jw9nk5LCmari3AQY276HSMiv21bqVmzvvwidCoDkfokBQkvYdpK	14559	20494	20494	1619628120000	orphaned
29525	3NKUrpZp5wo8ubHTFRpjAbsmQ3nZ69maUG5LoynKxj54rKMVePpd	29519	3NLR5mUxrNdX7SZsbpJiK7oJwaair6N4GASqfSfuKugoP63TfoNY	298	1308	581	12463	18974	jxgm93oeGD1Uw9G9ui1ebBQMmvaNZr2bms2hTBgNMsxXR5XbDzz	14560	20496	20496	1619628480000	canonical
29537	3NLR8A1E8MfH8CmJkacS1SqhgiikTc4FgWymEb72rtXj2X2NWX5x	29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	1637	816	581	12463	18974	jxRb2NpU4UGgDzAZ1dkaGx1szQMvYL8MMQxAM5nMWsVsJqB2xP3	14564	20500	20500	1619629200000	canonical
29555	3NKwtGS3bGftja9MXaYQBRNq24vJPLe5okVdV9ADkAMvH2Ynj3Ua	29208	3NKMxF7Cj2yJSjH1SL6Z49UHYCTMxjtXfcDyEGBm6PuWYGCxUzVD	1513	1379	572	12463	18974	jwChZqCfwjw5ZUnxgBXaRKxDY1scETzehaiWLHfCeoh4ywuTaMS	14362	20510	20510	1619631000000	orphaned
29457	3NKGuBUsy9bkcJC7E8eQq2MPtzhfX132NjRQWKibJfeiTnhwKTEv	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	42	1235	579	12463	18974	jy25X4BS898qKn6hNVknETWNZXtx9q6wSMaEyuwv7LnjBihCTS3	14527	20446	20446	1619619480000	canonical
29459	3NK9vf9cNGiF13hs56Utwcohx28Vfuhvg9HDM62jCe8vAu8Hg2gK	29456	3NLAv6jxpthZyWe2NeEXYRTNvrvoU4svQz1skpAyrWFwXzXcm1MK	1541	1298	579	12463	18974	jwfoXBFncEu7D32e4W44S8xZnE2idx386buqMycV2ADnXtmwMU4	14527	20446	20446	1619619480000	orphaned
29461	3NLdpEVNyMusvSwiFXYvzjvHDV6zUVbGWwZuqPjYGodUdLUvNGXa	29457	3NKGuBUsy9bkcJC7E8eQq2MPtzhfX132NjRQWKibJfeiTnhwKTEv	1529	1190	579	12463	18974	jwK8isndttAjTXhzpZNQF5sEkSCJQzVN9tnCCqqNqYVbZJ5AhBE	14528	20447	20447	1619619660000	canonical
29470	3NKcvW83HupdP1bdGwHX6bHPvmuoikaDPtbG1HVsRzoeJai1V9sp	29468	3NKRa7L3JdvZ3Y2Ak5zJyijcP7HwkCBz84SEPaJGCM3fkMsudbrB	1631	794	579	12463	18974	jwzJ54dgLe6N9tb4JsbgCfGigoRKLLftaFmr2wQ8YfcQpSGVmaY	14533	20454	20454	1619620920000	canonical
29472	3NLPEAZYGFLug6RhWGsXcwiC8zP1hUHnUzpuAy3BreH8JRtSrCcU	29470	3NKcvW83HupdP1bdGwHX6bHPvmuoikaDPtbG1HVsRzoeJai1V9sp	576	1355	579	12463	18974	jxKsJcp1RgoCRMTKjZUoZCFmzJCotkBBq4G8rSyb1dkPoUqyHi7	14534	20455	20455	1619621100000	orphaned
29475	3NLc5AA4CYR8163sCywtaTWCsjr8Jntr6R8EfrEVV2vNfvPUvcVS	29473	3NL9EAXdzSgt9u22zfhx4K8qCNmCVpYDRD6QWxswDfMNZmpdoLmE	1596	1117	579	12463	18974	jwShA7r3tpsFKCdg1fqGU9kn7XfumZw4FfLSeoZatPDF6SXtHvw	14536	20458	20458	1619621640000	orphaned
29482	3NKNi9UPjBfuVHQxRBU8om55hWLywCUxn8BvEeFpXaKu9gkQnMhF	29474	3NLJwM8QgiFW2viv9Cz9C881ujV2L8DYCCxgMXqSgb5CJWgMR6Hr	641	1090	579	12463	18974	jx7L3QFz2ekyD2AFS6tGbmHGYgr24AMFv2osLi3Gbwxb9VUj2WP	14537	20461	20461	1619622180000	orphaned
29491	3NLJaGaW6cNXnVHigLK3ekCgBXt7u6M2TZejxnrrTjYoARsfGUTS	29490	3NKQQB77z8s9gtk1drs4ds51XKMQKXzwuX8pnphDUCSg5tfX7Zy1	1672	1159	580	12463	18974	jxkVUKuuTnwpAQfTAG5qY8jy7h79e8jBvHZ2bjB2PivmfGz7RF5	14542	20473	20473	1619624340000	canonical
29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	29491	3NLJaGaW6cNXnVHigLK3ekCgBXt7u6M2TZejxnrrTjYoARsfGUTS	1600	1006	580	12463	18974	jwNManLeD8oyARCpp75yKqcMz24u74jXZMFnzBch4k5hsUzBX8i	14543	20474	20474	1619624520000	canonical
29495	3NKq2d6QhMrrztQLmmpVwPfnwPPorHe2dcxszifaSB7GS4YMBhhf	29493	3NKb5cUCpE7EW6p63ASZJSicfaChZrnMbLBvgmDQjjShtaDCEoDz	58	1035	580	12463	18974	jwCivP9qZsNu1ex7wZ3n8eKg6eHx82SgE7KGeo6Rk6dSwy6WxzS	14544	20475	20475	1619624700000	orphaned
29498	3NLcYJ4qRZU9vgwjCesiX42n3zcoWysZXia1q83BEWD4a6uAo8bY	29496	3NL1RmNW1w8PgRiBc7Sj885Wo28zijE1huv4ujFKcc6k7urPHtZe	1581	778	580	12463	18974	jxWEP8GRThBCFdD5U6eNMUkkqWfB3MH5NSUB2Z1AFGChkMQSjnG	14545	20476	20476	1619624880000	canonical
29499	3NKRiLXT5qBukuAd3sdJg9NHxJCDgennZiPgmHeCvnUxw7ow24vr	29498	3NLcYJ4qRZU9vgwjCesiX42n3zcoWysZXia1q83BEWD4a6uAo8bY	1607	1348	580	12463	18974	jx1BtF8QhRDhexB5PtdPJDjHbohrtSdV6iAKkwagzzmrmiDSN9z	14546	20477	20477	1619625060000	canonical
29501	3NKmHBz4RQwE8Zvddzv16Hromb9aWtweMC9aorMtr1pbNKsBUAVj	29499	3NKRiLXT5qBukuAd3sdJg9NHxJCDgennZiPgmHeCvnUxw7ow24vr	1407	1395	580	12463	18974	jwyyyCo47GMVk7BXGHioTcaqVzz39n1L595TBtf9V8iUb3sPauc	14547	20478	20478	1619625240000	canonical
29503	3NL5ugstC1SVMNuhh12MCDiTXeKbr74eRMCc8772T3rsKusoGpQZ	29502	3NL3i56r8eccgmbVKiX5xfjoeHzwkcikdHahxku8wkDiz9qk92iP	1610	1314	580	12463	18974	jxUpYJzcstDR8V988ZdwGmsZWTZngoFDkoQGCVuRmn1Cc6YP3QJ	14549	20480	20480	1619625600000	canonical
29507	3NKi3jSTHtJvYgbeLKwmxkVYdAVNxgxxzcw68wmiUNb8fMvVF7j1	29506	3NKWtj2UjXgktdM1heYouUic8eFAsAizvhuyzpPDRBvXdEx3CLyf	1440	1131	580	12463	18974	jxtyFpNBqgxrWXNQ1ne9PRQQwTKLtRtNfmfTv7t6ctu1aLtdmAa	14553	20484	20484	1619626320000	canonical
29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	29507	3NKi3jSTHtJvYgbeLKwmxkVYdAVNxgxxzcw68wmiUNb8fMvVF7j1	1670	1036	580	12463	18974	jwPMKWGFffHw7oAVxzbYnzVTVX11SPjaFLS9fLoghAs68UBCvat	14554	20485	20485	1619626500000	canonical
29511	3NKJwEx21dh3iw8sLvsXmdSgLYqVohuf6ExWrZFtLCtxgQiKqf4V	29509	3NLGgd3DiB9uUwfbAWH25dn5w6cxBxoSQcbbJzXTttaT2brwm1fm	1542	1304	580	12463	18974	jx3ttsVymofpTjc5eqXLhCBQgnPQNW2t6W8fN5WD96QFuearBDP	14555	20487	20487	1619626860000	orphaned
29515	3NKFds7A8npnpxBXe4vGgUYF4EpSDF28aCCqxSxt3BbW5ohPjhFr	29513	3NKBBmCDSzGn4ECy5TF8wobWUuaQwVFi7zB51weVBhwGqXfgGumU	1439	1033	580	12463	18974	jwnHUSjNYvVKYpFtK7gqDA5BDqDJGQ1XNyF1aNdmcTUwGW5ureV	14557	20490	20490	1619627400000	canonical
29519	3NLR5mUxrNdX7SZsbpJiK7oJwaair6N4GASqfSfuKugoP63TfoNY	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	596	1180	581	12463	18974	jwitee3KND4pbzHdC9b2nJg2tYTTzSEdLsNkNGRskJamoc8yS39	14559	20494	20494	1619628120000	canonical
29520	3NKNP2xuPSMYSCNsmwmFYbKeLCvVTMvLqvV75XqT5nqAYi162cRH	29518	3NKsFJ8dYUuuxAWS8RboNcqS76Z2PRhTtkNxo8dtqSC3pJztMhKL	1406	1393	581	12463	18974	jw8Q9SJajBFijPKnqsGnSDfAJmHpU9Wgv5eBiqfBYiTTAzBPjMh	14559	20494	20494	1619628120000	orphaned
29524	3NLmH4UtByk1W5XuJ1bVbdUMCf4CiFTCct9XDnxv4epKRM3TiJfo	29519	3NLR5mUxrNdX7SZsbpJiK7oJwaair6N4GASqfSfuKugoP63TfoNY	1547	1378	581	12463	18974	jwB5f2mrbDfDzxKgxHfyNxMwth9tU8gDcyn7Uqi12yoSZiNu3kt	14560	20496	20496	1619628480000	orphaned
29527	3NKr3tYGPHQaBpiLs6yoAAp2fnokE3QxbqBq7WeGeBGRogYmDnBy	29525	3NKUrpZp5wo8ubHTFRpjAbsmQ3nZ69maUG5LoynKxj54rKMVePpd	1623	829	581	12463	18974	jw7hfHZvBjUkUVVx1Vcm6yzkLejBVUydKF79NEHJ5deWG17ckHD	14561	20497	20497	1619628660000	canonical
29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1549	1236	581	12463	18974	jwvmziXUNBm6DwzWcn7meiAvQsmoTroAPQ3AK2pV4A6QZT2pnaF	14563	20499	20499	1619629020000	canonical
29531	3NLFPcZDquZCkDhTjHJTRXUsZFDyZkPwG6jfWKxcQyhbPRVzsToq	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1527	1167	581	12463	18974	jxFMtVqiprkBNLhVxgrQ72D67L8URKyesRXGv8RbBjqsAe8jxkQ	14563	20499	20499	1619629020000	orphaned
29546	3NKFcd8r1kwczw5Tb4N4GPmpZMdJCsF1wE4FDpFV8oqkZhAHJgcA	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1564	972	581	12463	18974	jxEnUoW4P1eFv87FjcsiHeKHHpZCZTijCGdDN7gVKGouF8vwPnu	14568	20507	20507	1619630460000	orphaned
29551	3NKAfLWxJUuQSwLx6b6BkwomBJyu9vWtJaDD7Pk5updm96K4QYeQ	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	1585	1366	581	12463	18974	jwLZ3F9ZUG9e7wWCMyVJzVBtjRjMV21k4eCfLWHjP3bE6MBysoD	14570	20510	20510	1619631000000	canonical
29557	3NKS6Jqw1k1Zbr8cSyg9oHXS3Ja7x6W1iG5B544AEjHMnxh9SDyV	29551	3NKAfLWxJUuQSwLx6b6BkwomBJyu9vWtJaDD7Pk5updm96K4QYeQ	211	211	581	12463	18974	jwRMZRTmNWjSwYMhxnFt4qNpRma2xYw7UVmaci68U6nxR6RK81N	14571	20511	20511	1619631180000	orphaned
29568	3NLdZo8c7d7mcrLxTen4HKvaC7exwWw29aCHvraCKXDdKLyCi95v	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1405	867	582	12463	18974	jwBjPfp4mNGzPq4tMT8GCktBCymZNfJc9gKmBjSA76WghuZnNvZ	14578	20521	20521	1619632980000	canonical
29560	3NL1mbRzXN1sDNRgc1rjaTkVZX6DDPuDxe1YCZW9LNtwfBz74yYG	29503	3NL5ugstC1SVMNuhh12MCDiTXeKbr74eRMCc8772T3rsKusoGpQZ	1507	1034	580	12463	18974	jwi5mXxgGsreXUQ8jvbmQbDWdcnzNSxcrhktjLWNTL2GzbdGm7m	14550	20513	20513	1619631540000	orphaned
29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	29527	3NKr3tYGPHQaBpiLs6yoAAp2fnokE3QxbqBq7WeGeBGRogYmDnBy	1608	1043	581	12463	18974	jwTZqs6LaBChnGoDocjjeky6jSmTLnHiLBvNTy7QgPYTRk2ksxq	14562	20498	20498	1619628840000	canonical
29530	3NKXSySmVB9XNAsCYESWuubdtqWMaprN85Xa4iMntjzKfvY68AFb	29528	3NLcAZpThiMS1nryfTrkCFuh3w9HcPHcT92v253yvrNwLXckDpP6	1527	1167	581	12463	18974	jxEfX1iLPNm46Y8n68yk8pXcD8XdPzCaQUVDgcxC6VUk5GdyoqG	14563	20499	20499	1619629020000	orphaned
29536	3NLMUgcoCTe1sqm7yfc7L1Y2iu7iaJebGaKvJShrji1rbqSLv4Ca	29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	1610	1068	581	12463	18974	jwecURHeRMt8KKDzzga4PhNDGBrxpr5ZpQMaWw6LdvwnqkVEwU5	14564	20500	20500	1619629200000	orphaned
29538	3NKqqcUrKw7A8swb43ijTWrtw8JCBzsQfkeBCQdAzY5cdDwN655n	29533	3NKXKeFNg14eEZD9Xdbwwy7XSeiDJGRB7NsZXSgvUyrymt46hDvi	1581	778	581	12463	18974	jwaMUH3pLU5gkWQ4LhUdKyDCZqyyrvPbHHzfurLtWUGrzjDqfqS	14564	20500	20500	1619629200000	orphaned
29548	3NKP4UvDQJaqVn7qpjwTHeWfh8WnzFQS3yXRb9VUGYqYehAy8at5	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1406	1393	581	12463	18974	jxDgP5iHidSGBxQYMLR5AETgxh5xZnwqmcLqDaEHXGRnC9doN78	14568	20507	20507	1619630460000	orphaned
29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	29547	3NL1dmAYEVzd43whyF4bZu53z8cF3GVHHjkjosS9MimtQMzeBvK5	1403	824	581	12463	18974	jxE6ZKShwTJmnGjuE2kcXZxAUeQUbzo31hwSzsPsabSwTJQR1vY	14569	20508	20508	1619630640000	canonical
29552	3NKAdtDQaeFLmmY12xEEY6QjSsCqJc1YpEtyMXL12LxPoSo6bW2y	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	532	1057	581	12463	18974	jxPRhAabT8y3fY1h9rZCYT1DU5FYbomkNKYdj8F5zv6nSmvZ7Vw	14570	20510	20510	1619631000000	orphaned
29554	3NLhcdmdJH9YnwxyA96hupazTurFNGjBwnGmsbfuYmVWGpFt6hH2	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	1407	1395	581	12463	18974	jxqKUpP7xQrGEvL3Qc96m4oxQQrhZKvkNax3VJWsP9s5wqSyucP	14570	20510	20510	1619631000000	orphaned
29558	3NL83Ua5nguZaXc71yEzm4PEoznEaFXbJLLA5dXrEQCCkbt98J6Y	29556	3NKcrYRUHGM5uVu3BUNh8zU81z4sYcHHZDRcS8LBHv5CW8QfDBVF	1406	1393	581	12463	18974	jxo7B9sztKWGKpdrMqSRyWUpLjhordA5Mcoc2LBaEepF9eUzWqB	14572	20512	20512	1619631360000	canonical
29563	3NL9RDPzx7VEFPbYCXaUUQ66BJRg1hrqf3EtcffAh6qwG4hgNqmH	29562	3NLUEQ9kEotBHiABn5u9kMGdkWwMgks3jCbpp4SGQLxsx3oXbv78	1588	1266	581	12463	18974	jxRQD7acmddScwyziVakEGTdANWGAmF25Jx2C15fdiFMgtvRyHW	14576	20518	20518	1619632440000	orphaned
29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	29564	3NKwnF3VSz2PtqeyHUqkPENhRmjaokjHEgPGsi8y9oeq2GAsobTo	1444	1381	582	12463	18974	jy1TTpibQC1oNTFCrwQ7qj9pgjWxvTw4jJebaqpkSZM7E2nAhz1	14577	20519	20519	1619632620000	canonical
29567	3NKy1oszaPPJC3oZ4cXJQpHjggG3zSwsa1t1xzYj7qQq7nojNGD6	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1642	1367	582	12463	18974	jxS1QajCf33jm89hFPXbRcSNec5xHNvoYTigZAJNFPDHmewqZZu	14578	20521	20521	1619632980000	orphaned
29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	29568	3NLdZo8c7d7mcrLxTen4HKvaC7exwWw29aCHvraCKXDdKLyCi95v	1649	1383	582	12463	18974	jxaCWBuy8EkA1B6H6f5SExwHQa1hsnhR4qQ787XjQxchb5iYRd7	14579	20523	20523	1619633340000	canonical
29572	3NLvCc65qH2jRqCJdcZMQ3PnhVyuhzcEvgjHWQKVLXPTd1fKiuNJ	29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	1483	275	582	12463	18974	jxypFSSuHbosnLErgkCJESBM8VNF6MVDxUJRNWjRt5MG8Wb2gGb	14580	20524	20524	1619633520000	orphaned
29574	3NLffNrZToPxv3ZoQAC52r6hgwqbCA31Bg9zW9S6HnwejRPeZXon	29573	3NKKY1fxkzSvr7xR2suyaKYdzkzYjonCYNr77WYwAGYzEkUeMN4c	1553	776	582	12463	18974	jxxy8ioyN7YNGxFwLdBY5wjBTDfoUu3NqdgEkEf7apPKWmu21Hx	14581	20525	20525	1619633700000	canonical
29575	3NKw6QxBHdtKrMEaDJTXU6gx37Q9wKUgy3snCjf4eotMrTzDgbuV	29574	3NLffNrZToPxv3ZoQAC52r6hgwqbCA31Bg9zW9S6HnwejRPeZXon	1624	1334	582	12463	18974	jwgsU7AeBkJQVjAmRj6uqNPyx3MYH2A3AnopcuKWwddt61gZuiR	14582	20526	20526	1619633880000	canonical
29576	3NKSqP8HPJA387cVpKbyAEeeuZQQCNGA5Usz1ogueYGbb89Fo6My	29575	3NKw6QxBHdtKrMEaDJTXU6gx37Q9wKUgy3snCjf4eotMrTzDgbuV	58	1035	582	12463	18974	jwn9WFdqjiAjhAjHQ1JVaE2kW8UNZcsrWWpqgLKqw1hhvkXgA4y	14583	20527	20527	1619634060000	canonical
29578	3NLm2f7ywXZKG3jcjTNNimdBk1y4HcJ4L47gVeVzjX1W9pJ7EHmX	29576	3NKSqP8HPJA387cVpKbyAEeeuZQQCNGA5Usz1ogueYGbb89Fo6My	1448	1311	582	12463	18974	jw9XiwXvnnfy35jRYNAebb5b4p76zEbSGjyTJjiPtFhAdXSzRzz	14584	20528	20528	1619634240000	canonical
29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	29581	3NKfYucc7FGU2Eswkz4bA9dVW5aUQqvmDdAMQWJebyw4jWTW3zgw	1599	1287	582	12463	18974	jx477qa9tfjabfVeEKAVcrpZCR9zeLiXkoYBj99b9azYhC33EQj	14587	20533	20533	1619635140000	canonical
29585	3NKPg8m2KKDHqMBDF3ycQbvBX8trDU8gXFQrjqobngiKvYP6SDUc	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1523	1075	582	12463	18974	jxE37mZoKXFv88PJ9z5kJgp7669yhXbdwvDCNYXDdBDdnAYMtzL	14588	20534	20534	1619635320000	orphaned
29584	3NLPT5KwFUQ5WLca3Cj2ndiX4fFyf4d7MRgZfkC1MeNAed2ac3Kc	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1523	1075	582	12463	18974	jwqyknucHfj3tCGiojmoSM6dxaP9mgNAbQmqBD4p2MKNHuTCw3L	14588	20534	20534	1619635320000	orphaned
29588	3NLiTyGWp3chNLHewrgnfMTtzd8xQenST8B8xPDZpPXJRqHh4hiv	29583	3NKigt3TnS4cNYyJ2oUT1xWqKGCoER5ksLABuGnawAE2wvSQg7ki	1573	1192	582	12463	18974	jxs3kH3bWf6WytbG86uD1udDJXbfWVm9iAH5cxMGumkRmMmCrh3	14589	20536	20536	1619635680000	canonical
29590	3NKFLwtWccqrrWqyqGs8EVRJxjMmxk58DnED7uT5cCtDxsTfzxh7	29588	3NLiTyGWp3chNLHewrgnfMTtzd8xQenST8B8xPDZpPXJRqHh4hiv	1536	1187	582	12463	18974	jwdxtSUYA56khxXTKLErdMzpbYoTTJfwr7NFnUVD8xkC9jUE3S5	14590	20538	20538	1619636040000	canonical
29591	3NLeLCzTTyC2MPYWzNbiLnHdphrxiAsXAFgyUCeDrHvZkDcwfgRM	29588	3NLiTyGWp3chNLHewrgnfMTtzd8xQenST8B8xPDZpPXJRqHh4hiv	1553	776	582	12463	18974	jxRMbVCy2kowtpLTynnVM9mrWqxEXaHB65BdT2qbHpiciARg5Um	14590	20538	20538	1619636040000	orphaned
29595	3NLCBj7USiZmA9KrshLuDHpdSdXi55voRzSuczThM6DzWMwLtThq	29594	3NKrpSb96DaBxVg1DasK88XpwEX4mmA71S9cYwdBXYWsnPX1tbVR	1483	266	582	12463	18974	jxnTicCW6hWa9FmxxxwRiNBLesrQGzfteQJ2LzFrNLxMuQ9nMVy	14593	20545	20545	1619637300000	orphaned
29598	3NL866N66TApEddvejQcvXUnGvQVgZHuhif25ys5mrnMcAk5SGRt	29597	3NLDxNfCSXkpSWUioyRSCMHjn58iEzhtTriJ1r9qMxcmUqTN6ckx	1581	778	583	12463	18974	jwsFJug4kpZsa6qRWLWZJfHDMBHekGitfQBqzVUqjXUKj3c7CVV	14595	20548	20548	1619637840000	canonical
29602	3NLqH86dWmmBNEDGMThHk4JJ5Z48JHGR3rbZ1eagxccpoV7RPrSE	29601	3NLnyh5cDZz2hXYCYA4rn8YU5u4JMWPx9D2cXsHFrHvHZC5AKPjN	1631	794	583	12463	18974	jxygbc6LgqbFGeiTqEzkxHn5y1z7SgA3xzbGVhf8Q3ZByr4t76y	14598	20551	20551	1619638380000	canonical
29604	3NKBBaEaFBtSDjs64BgwddpeRjr5D48aRQbJKpayzGAvCzDofH3J	29602	3NLqH86dWmmBNEDGMThHk4JJ5Z48JHGR3rbZ1eagxccpoV7RPrSE	1672	1285	583	12463	18974	jwQ6Dt8LYz3mhnZy9UHW3X7wtAkqf3FgtXBEAEV9pe7bwvDDkqe	14599	20552	20552	1619638560000	canonical
29628	3NL8HuMjnDvidLDaiE4jM5ezWm8MZgXc77NRurJkN91EcgcmDSBh	29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	1407	1395	583	12463	18974	jxgZNfRGqrrtJyNtq7yHXQqA7XKoj5fgmsP45zPuktWTeesgwzk	14611	20574	20574	1619642520000	pending
29630	3NLKFQHDxHPUHy6UGUj7ESj2oBVXwbRpSAWqsHAi7sf91S3X53xj	29629	3NKhTZ2dVHekWbqFGaj2XvRUxdp5rRGMeSkG84PuWhwNHLiandKZ	1406	1393	583	12463	18974	jxmYdpaC5GoAyKTarheY5op4Qrxik6rJACj74isUvd67CErTweJ	14612	20575	20575	1619642700000	pending
29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	29632	3NKmNGi8QhwJFrMmZZhUHYhqk2zMdrBqF26RzX6DVSEghopTefVh	1624	1334	584	12463	18974	jwcpYSVwRriuiH9eSWxeeq5Dxesd61oB3zU5jiai2GnkBwyq2jD	14614	20578	20578	1619643240000	pending
29639	3NKnuH9HHp3HZvHgZUaXszuNbUVoAwr9yxdDyfCYMyTgyNrkdf3Y	29635	3NK6oWoprogNtNWeFEWhsQGDgwi8dfQ9ABeSF12HPKWCxoGv2yC4	1406	1393	584	12463	18974	jwbKSVJMj9jBP32dk1hSNPfevxVV8yrRnjHoBcgpEo7h7L9xTXb	14616	20580	20580	1619643600000	pending
29535	3NLcpN1x4HnhgXJ9GYDuAjAWyigj6mrQ9cQd8Phh7hSTGmRMgpDp	29304	3NLamhpNLXyZcmp8Jn8XbUe4AXcThbicK5uMt64ejk3d7uuBTKZV	1610	1068	575	12463	18974	jwPbG1APqhYPWHfdNnedkJzC6bcy9LNER5GeoAinjwDjdiiDovv	14441	20500	20500	1619629200000	orphaned
29539	3NLg4ob9VkFqAbGR8SpCYciAJEgAMTDXTCbEDr3c4i6N1dPAvifP	29337	3NKrcUi1qssNWkLEdmaWoJzhe9HVzq22TGNsxVKJ6kBiou3t8u58	1610	1068	575	12463	18974	jxrHw76A2FgF2fpEigQa1US7o8NcvGscwEECpBcoayLNtnu5sKL	14458	20500	20500	1619629241815	orphaned
29603	3NKNQsUmu1pHb6YbFoXXTKC9haN7e2Eb3XK7P1QVvmAFjjvEqr31	29560	3NL1mbRzXN1sDNRgc1rjaTkVZX6DDPuDxe1YCZW9LNtwfBz74yYG	1507	1154	581	12463	18974	jxB2FaThpjqzN46pqTZ1UzCoWN6ZrAZoQxRtePhueQYGojVVvpp	14551	20552	20552	1619638560000	orphaned
29542	3NLhSRrEZm3PenpCm91fbB8PiqUK3wZbYH9t4j2Yje2fHUfKCzFT	29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	1602	1369	581	12463	18974	jxjn3VvhRjfkM5eETxDSiPni48XRuMQn32mfKVn2hUHHgTLA1MF	14566	20504	20504	1619629920000	orphaned
29547	3NL1dmAYEVzd43whyF4bZu53z8cF3GVHHjkjosS9MimtQMzeBvK5	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1670	916	581	12463	18974	jxGWRTDTGJZm6o4q1niCWTq5TTRaMEV1uGj4kJpW7kFoqGSNHB9	14568	20507	20507	1619630460000	canonical
29553	3NKcoQwiYmeczrv7hHNU3194u6wuLjNVdwuUXM2gLdKVzAqhD8vz	29550	3NKAWQCPneS8W4T7eKd8RM4M5gr2SDPMRor5EhYKwXb7fHmWYigL	532	1057	581	12463	18974	jwpBRrKuiyJGNCwHMxyjgkXFxqyietgaBc3Rkbp3DykLqcB9sW5	14570	20510	20510	1619631000000	orphaned
29556	3NKcrYRUHGM5uVu3BUNh8zU81z4sYcHHZDRcS8LBHv5CW8QfDBVF	29551	3NKAfLWxJUuQSwLx6b6BkwomBJyu9vWtJaDD7Pk5updm96K4QYeQ	1536	1187	581	12463	18974	jxXcsFnMTeuxJcsZ3yytfpnA7Ba8UtDWctKpzf27fG5pVrKZLyZ	14571	20511	20511	1619631180000	canonical
29561	3NKyejZb4sZQNZZ7Ctm3Z5W1oNYbtnsgwqvUSssFf43hkpa83Z8Y	29559	3NLiJMFc1nyTKuKDCH7TZ4Gjt4dGHmJrH38GvytRuJp9X5DMcKd4	1546	1339	581	12463	18974	jwxf5SvQ5vu9gcqMYatAgB9rz8A1FeUmXsG9mCX1bRWrh2J2QvR	14574	20514	20514	1619631720000	canonical
29566	3NLkyrkyb89Lr5i1CTN6Exr9fJbSGVMRRBZMPGYdcrmvngfAtgkb	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1467	1130	582	12463	18974	jw9E4QYjT2z2RsyB6eV8z7dfLfzqNCsmbjcBQh86AbxqnpfhgTM	14578	20521	20521	1619632980000	orphaned
29577	3NLBNJKfuEUiZqEZpPK2pkpHE5ZXNkdCUEoX1C5ZmmkcRLdM8DdK	29576	3NKSqP8HPJA387cVpKbyAEeeuZQQCNGA5Usz1ogueYGbb89Fo6My	1448	1311	582	12463	18974	jw7J9MDTAxLfA8fnev47KavVrCRkiqsiwVzRQYz5MyMvpHo6dB6	14584	20528	20528	1619634240000	orphaned
29579	3NLardzAFRVbn7ZvuiivmqZKgseADy5rgZ3PQkwb2GM22NydVFaJ	29578	3NLm2f7ywXZKG3jcjTNNimdBk1y4HcJ4L47gVeVzjX1W9pJ7EHmX	1648	1158	582	12463	18974	jx2kmQAXB8NHLbEYwnPRHgjvckFLcek15ymMKauG1wHgy6547z6	14585	20529	20529	1619634420000	canonical
29581	3NKfYucc7FGU2Eswkz4bA9dVW5aUQqvmDdAMQWJebyw4jWTW3zgw	29579	3NLardzAFRVbn7ZvuiivmqZKgseADy5rgZ3PQkwb2GM22NydVFaJ	1407	1395	582	12463	18974	jxvoebskGVWfrdjBZNCpQnsVZxaPnqYDaicu89MSuFbg5AXyZKK	14586	20530	20530	1619634600000	canonical
29587	3NKvQweJLtHvjTpsFeLbt3cbr28YMb5fq9PL416Rb6UC5ggWKVaX	29583	3NKigt3TnS4cNYyJ2oUT1xWqKGCoER5ksLABuGnawAE2wvSQg7ki	1407	1395	582	12463	18974	jwnBKxJr6MmcW1ioiemCMoYPBjtAcxhWCvq16W9SMjXfqFGowkf	14589	20536	20536	1619635680000	orphaned
29593	3NLSQTFPimdvQLwM58WViEmFfxjGmuLVfepqGxNgin8SgJasVHRV	29590	3NKFLwtWccqrrWqyqGs8EVRJxjMmxk58DnED7uT5cCtDxsTfzxh7	1601	1142	582	12463	18974	jwA2ZrzYAk86oTBidt2jDbcfvpmvTFa7wXzEupRJcGGacA5p8TP	14591	20540	20540	1619636400000	orphaned
29597	3NLDxNfCSXkpSWUioyRSCMHjn58iEzhtTriJ1r9qMxcmUqTN6ckx	29596	3NLvbN8oY5LPk9E24PcWyuEiXcMNRGUnWhqSSTMECRnJPsiVMBid	1406	1393	582	12463	18974	jxEFyfiUEZ6ocNTo3dk33r4jBakgDBLmctWYgEdpmbKQh2JA6Le	14594	20547	20547	1619637660000	canonical
29599	3NKAMwGB7LeAqJ8j4kHXdCbRwto8WGbi8EHTU4niXgyC2L7YjvwF	29598	3NL866N66TApEddvejQcvXUnGvQVgZHuhif25ys5mrnMcAk5SGRt	1619	1275	583	12463	18974	jy2mvj4M6Esz6EuqmsVKXDZ4CzN8vbcu8fDUiUqy7xLy6hDx8fT	14596	20549	20549	1619638020000	orphaned
29601	3NLnyh5cDZz2hXYCYA4rn8YU5u4JMWPx9D2cXsHFrHvHZC5AKPjN	29600	3NKBYTiTAoahiofRgnPi59QYzUuAfcRqftzRSy5RqFKQit676Rdc	1613	1103	583	12463	18974	jwkKLUYAGkK2zCipU7UQfKTzKYhTgKNUvsYoqNQAFcc12tmArZ1	14597	20550	20550	1619638200000	canonical
29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	29604	3NKBBaEaFBtSDjs64BgwddpeRjr5D48aRQbJKpayzGAvCzDofH3J	1445	1290	583	12463	18974	jwYtVLCARnvH1ivVPiWz7tuycgqvjPhP9zhqV1XRXFcfT4PfviH	14600	20553	20553	1619638740000	canonical
29606	3NL2P3ibPGV9gPCEdBjU16UuugxvQrcWU8dTrci6zmkxsy4Y33bK	29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	298	1182	583	12463	18974	jwH6KucgfxQCJUCwMeevXA6aE6goptdvdLPTyBFQ6M8cTpegYmT	14601	20554	20554	1619638920000	orphaned
29609	3NKoQXicp3xNjdMHeEL69R3QeGJmdP1JyM2er3cjaamsV4w2oGP3	29608	3NKRxiZ7xxawgvgYXoHi9EuUcEvsJyxNcjZs2VVFAdnNL8KcPk2t	1588	1392	583	12463	18974	jxx3cNvupSwqVz7LioeaybYECPnb9dLvP57y9JEed9gBC9S3DPA	14602	20555	20555	1619639100000	canonical
29614	3NKojSiBsm9dXUxYvx2DQ9MWKRCGERhKEZ2MZ8y1NefwhWiQLXKG	29612	3NLQ1XdRxxvZ7qLUnxQzGKW36V5tUUhnWg5cuMNK8e7HNgJRWpW6	1581	778	583	12463	18974	jwq6kQhh3AF77dGbxZw1bBStPj7QCXGwQ7CRoYWioFZkNA7QU1G	14605	20562	20562	1619640360000	canonical
29619	3NLeiAaSpH9582U7oQqDeHH4DzWJMp6GEbQuknpCiV9kgxPHS4WG	29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	1506	598	583	12463	18974	jwpqGzQdBfMnTy7feWguu99xvDmgb3wmk1LsCsYB2eWiNQRbDZd	14607	20565	20565	1619640900000	orphaned
29621	3NKaokZByvUCetuEJVKU8UzpU2XeR4hvMxpK5R2oV7Cw8JcN3MFj	29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	1406	1393	583	12463	18974	jwfpdSPGPv97x4VgASkpjaLrzWGkwwssNSZi7QhwTftuFyq53Ug	14608	20567	20567	1619641260000	orphaned
29623	3NK7bUk3KzHm7WhyT8WptNSX1RbutBBuAZrdGjr2BrsFKeok3Ve4	29620	3NKQ68xWT5WkAUagopx17xxMp7rrcfp4DMv5h1AVbD31kptDSoJC	1649	1257	583	12463	18974	jxWNxwaUhzPHV2s2Yf8JPKGBM39PC38sxVrQs2FQNhd1Uhm3v3x	14609	20569	20569	1619641620000	canonical
29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	29623	3NK7bUk3KzHm7WhyT8WptNSX1RbutBBuAZrdGjr2BrsFKeok3Ve4	1474	1329	583	12463	18974	jxV93xDVSLKd8b4JSrUv8HaS3UGA4gT7cFotGjQzkMee7EpAGNH	14610	20573	20573	1619642340000	canonical
29646	3NKZVyyigcZoePbZBsNBFo18DXJDXL5ryqDvSXqpV36kqMHSZWDV	29645	3NLVDq2XcyfJDz78WEM4vNpMpsh6BiAtUHXmTSZ7qYDJohTM4UAd	1406	1393	584	12463	18974	jxae81zivzKD492NhB2mXXtZ2L94kKqaRMgkLCRj6PFAQ2zo6q6	14620	20584	20584	1619644320000	pending
29648	3NLmPsuHCfKpJwuhWozVNKLaJPDRUof812P3ocsGKw6rB1F4EtQL	29646	3NKZVyyigcZoePbZBsNBFo18DXJDXL5ryqDvSXqpV36kqMHSZWDV	1529	1316	584	12463	18974	jx1eQxbL7e5aNVBAmLr1aTaQqqJcdggBDgXcttcFtccmbZfpnyr	14621	20585	20585	1619644500000	pending
29651	3NK4W8QE83SG4CSqC3bXzbFfwpTv4TLJwPPLZP1dJLyDse7BXo6U	29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	606	929	584	12463	18974	jxCwnD3aiBvcoPwqL5Uq3Ki5RSGhaANtvmP7iqu2paUcKuG2inC	14623	20588	20588	1619645040000	pending
29653	3NLwF6J1yNPy8CtWwesH78MuRiLhHSZywEgQpUnjx6B7ckA2ZTTs	29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	563	1359	584	12463	18974	jxQgyur1MYdCi3mLFEUHzkCyb7NEc3uxPGrdGhDge6cABPL1KzU	14623	20588	20588	1619645040000	pending
29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	29659	3NLbmPNzxmaHZNUSg3rrhfQW3pQpYfVaLhyWZ7K5zjAb2HN3Hj9L	1405	867	585	12463	18974	jxrFAKHqBo4YRSQikodpEoFszzX6j4haojeK5p3PLXUMQY2cNC8	14629	20598	20598	1619646840000	pending
29665	3NL9xGqiBn9zMvrLtGhu4P3JJP967czgwNecseJHnC4UfwWUgeVR	29664	3NLJHTM1F4nWqXGyAUCDMsCfKBRgroUf9cRs7CZgahhMKfpNUbSS	1403	791	585	12463	18974	jwafkJAbtXQfEh9xCgfJ9A8DkgqY5abT9CQzmeguYCtbkJz5NDh	14632	20603	20603	1619647740000	pending
29543	3NK4J1MsVKsacmN2QyL1B249QGm2Hew2EQ83qvkBLwuNSTvrktD1	29541	3NL4nFcu6FRzNB3DJmFLkyaYKXMN9LLjawL8Zwm5sDXEmwXzTUbx	369	1186	581	12463	18974	jxoTsr3PG2WEL8fdFKyghTpfz7NfsmqazASogzwaehvjpYpWEp9	14566	20504	20504	1619629920000	canonical
29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	29543	3NK4J1MsVKsacmN2QyL1B249QGm2Hew2EQ83qvkBLwuNSTvrktD1	1406	1393	581	12463	18974	jxetNHSv8ZuGzxaPWwJPnsFR4MYTPZhefQAoQW4w759kDmdaqq2	14567	20505	20505	1619630100000	canonical
29549	3NLtMda9PLA89UkJ9xyvt4ExKvLuhpLJKXm9zanC2HbZzrK1hxh2	29545	3NKUEdYPFXgriBXV4P3hZpKT2LDtfG573CqSCBXDYbWySMeHWWh3	1581	778	581	12463	18974	jxQGh67yqGRjM3wKmRSbaRwnMWD9K85zmYMXWwZDFZNv99vE6in	14568	20507	20507	1619630460000	orphaned
29559	3NLiJMFc1nyTKuKDCH7TZ4Gjt4dGHmJrH38GvytRuJp9X5DMcKd4	29558	3NL83Ua5nguZaXc71yEzm4PEoznEaFXbJLLA5dXrEQCCkbt98J6Y	1444	1381	581	12463	18974	jwFr3xrwfbXRKNT4H7WgJowKcLrUqcnnSpzmd3Q7sQ95NEPpJ91	14573	20513	20513	1619631540000	canonical
29562	3NLUEQ9kEotBHiABn5u9kMGdkWwMgks3jCbpp4SGQLxsx3oXbv78	29561	3NKyejZb4sZQNZZ7Ctm3Z5W1oNYbtnsgwqvUSssFf43hkpa83Z8Y	1617	1042	581	12463	18974	jwhtNVz6HZ7Y9TPo5MHWvQ7FUhouURw5S1SC52uY7FuGXYJEUrf	14575	20517	20517	1619632260000	canonical
29564	3NKwnF3VSz2PtqeyHUqkPENhRmjaokjHEgPGsi8y9oeq2GAsobTo	29562	3NLUEQ9kEotBHiABn5u9kMGdkWwMgks3jCbpp4SGQLxsx3oXbv78	1588	1266	582	12463	18974	jwDiZwUGmDdELyiRtydkfKXc2EdDs5WhwVMMEC1xNXgWH4Kx5E2	14576	20518	20518	1619632440000	canonical
29569	3NL8vWTCYp8KBUSeyDh5Vyp9RpgweRkmPQ9tQh44vvtLFHBMw7q4	29565	3NKFCjG3hUb7kaQM9ijtD8ZAFc897NV1s6hxWfRvr4dFRpseW4b3	1407	1395	582	12463	18974	jxft3xWxcMJaVFEgYisHZN5MK9YYoUxBSMz8H9mRP3AxzCEk3dM	14578	20521	20521	1619632980000	orphaned
29573	3NKKY1fxkzSvr7xR2suyaKYdzkzYjonCYNr77WYwAGYzEkUeMN4c	29570	3NKgoD5G8HbwMkG5Ty1XHm3Jzx8d7Q7xiyMaJ9Egwt7rSsCVpuvp	1483	275	582	12463	18974	jwuXGoBtJPaytLjPgWRnjwsjFGufunUV2LPupFAjkD7SKFQqEMh	14580	20524	20524	1619633520000	canonical
29580	3NLvoe4pwZQhzhk6dC5mznjLusB52rcwKrZsoVFZ81MaMq9US1Jc	29579	3NLardzAFRVbn7ZvuiivmqZKgseADy5rgZ3PQkwb2GM22NydVFaJ	1609	1087	582	12463	18974	jwyG3L8sFvWZsy794th8BiRLuS1hNkkd8B1DbtyYGy86y9Mt6Xj	14586	20530	20530	1619634600000	orphaned
29583	3NKigt3TnS4cNYyJ2oUT1xWqKGCoER5ksLABuGnawAE2wvSQg7ki	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1406	1393	582	12463	18974	jxzszV7oPnC4DSvLqespi3W9UzsM1iVikaoY5VTHYFFPt82BeYP	14588	20534	20534	1619635320000	canonical
29586	3NKPKjjWfTwTebq9ogPaL4p5Lr1BSodMzHVYSjbASztBKmd7jEXe	29582	3NKjUF6Kop7QcfN17yTWACeyHbvPxTpR28f6zYS94pkxchsMJywx	1523	1075	582	12463	18974	jxk6T1sJVHrNTe1FfDsv3Bx4nVjJHSYxLJRXDmeshuQBQ7QrKC6	14588	20534	20534	1619635320000	orphaned
29592	3NKs3sFyfzicC2MSGhAAb3NpvFNeMXJSyztVtbZqX8iujefAbWq2	29590	3NKFLwtWccqrrWqyqGs8EVRJxjMmxk58DnED7uT5cCtDxsTfzxh7	1457	1391	582	12463	18974	jwSujedNJsDRc19FQwjApofcJdfzGf959wuWnFPRo9XW5VT4zBh	14591	20540	20540	1619636400000	canonical
29594	3NKrpSb96DaBxVg1DasK88XpwEX4mmA71S9cYwdBXYWsnPX1tbVR	29592	3NKs3sFyfzicC2MSGhAAb3NpvFNeMXJSyztVtbZqX8iujefAbWq2	1668	1370	582	12463	18974	jxsPjsktt9KGm2wvyaA9E2sxEjYU5c8oS3pareCFSjcFsZwMJG9	14592	20541	20541	1619636580000	canonical
29596	3NLvbN8oY5LPk9E24PcWyuEiXcMNRGUnWhqSSTMECRnJPsiVMBid	29594	3NKrpSb96DaBxVg1DasK88XpwEX4mmA71S9cYwdBXYWsnPX1tbVR	1407	1395	582	12463	18974	jwmJ3B2q1DgdR7Bn4nqJUbo3o4NLq79UeRpNjrtpkFcQG78Mpub	14593	20545	20545	1619637300000	canonical
29600	3NKBYTiTAoahiofRgnPi59QYzUuAfcRqftzRSy5RqFKQit676Rdc	29598	3NL866N66TApEddvejQcvXUnGvQVgZHuhif25ys5mrnMcAk5SGRt	1619	1275	583	12463	18974	jwNyuhocnvZmxTDs7o88HueTPfe16ooAeTRQDzQBpKW4uAD9Abj	14596	20549	20549	1619638020000	canonical
29608	3NKRxiZ7xxawgvgYXoHi9EuUcEvsJyxNcjZs2VVFAdnNL8KcPk2t	29605	3NKPxX3pg6ejb66qWFyThbA9oHSVXGhYTr8kvgVRRssBbR8xw4S6	1436	87	583	12463	18974	jxGc1duUNn2vUAbvmZG9ghfApf4mWReAu1AkRe6Lwmkvn7GJjrb	14601	20554	20554	1619638920000	canonical
29610	3NLQDP3wa8fYtuu4quXwicAFqE8Ui3NPVQDWNosGYkrjjTVxCYPF	29608	3NKRxiZ7xxawgvgYXoHi9EuUcEvsJyxNcjZs2VVFAdnNL8KcPk2t	1668	1370	583	12463	18974	jwSsTfZQ1cwPM5b7uZbBaHj1LYUa1MzsSvcT57EWGkNXyknXNYE	14602	20555	20555	1619639100000	orphaned
29611	3NKFNjnD8n5FGwwVXACNFnU4P2adRQVATTbCfY9aQR8iDPJ1Bw66	29609	3NKoQXicp3xNjdMHeEL69R3QeGJmdP1JyM2er3cjaamsV4w2oGP3	1616	116	583	12463	18974	jxQCJaJq9zGbMm7nsyHcGbH1oWCeGf6suaKXtM9bkRS7Frd1KSZ	14603	20559	20559	1619639820000	canonical
29612	3NLQ1XdRxxvZ7qLUnxQzGKW36V5tUUhnWg5cuMNK8e7HNgJRWpW6	29611	3NKFNjnD8n5FGwwVXACNFnU4P2adRQVATTbCfY9aQR8iDPJ1Bw66	298	1308	583	12463	18974	jxhKCxrpVCvXKhGkXmW3RT4FvwymTuqohGaeGethzHLod7g784j	14604	20561	20561	1619640180000	canonical
29613	3NK9jkWUksSzkSRWCpkmQv4KsuWhJh93E6jXDUqNFnk9NArfowR5	29611	3NKFNjnD8n5FGwwVXACNFnU4P2adRQVATTbCfY9aQR8iDPJ1Bw66	1405	849	583	12463	18974	jwXh4kEjsMLkZLdoZGnkPYriLwrris5KYSUvpdLxsfj6Wz1BG2Y	14604	20561	20561	1619640180000	orphaned
29615	3NKLUoiULKhdMi8yC4XXAKgc6r9sVQxHYUmboUN3uYU2568JytLT	29614	3NKojSiBsm9dXUxYvx2DQ9MWKRCGERhKEZ2MZ8y1NefwhWiQLXKG	1500	1051	583	12463	18974	jxdCgecxE9Fbx1XoDwFL4wKrLEDZqVsscsaPL8GyG3u32WHohcS	14606	20563	20563	1619640540000	orphaned
29617	3NLyYgmXD1CbS7EoDit5ZYSxefDvTh15cXKcwLrSzT31akKcRhfm	29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	1506	598	583	12463	18974	jwymg53hSw6z3G4dof322WiWgmaq8aQwCYbEcL2unwmcdEeH3Dx	14607	20565	20565	1619640900000	orphaned
29620	3NKQ68xWT5WkAUagopx17xxMp7rrcfp4DMv5h1AVbD31kptDSoJC	29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	1579	1263	583	12463	18974	jwYbJhZ3LT7MEaGWa23Qec2E3ekadsdZER5Dj6e9e8goboHyf5N	14608	20567	20567	1619641260000	canonical
29622	3NLJoTA7HQt2QoRc2ZXtdFovN92FsfPfaPT76z4RW6FPJD5LPcP9	29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	1601	1262	583	12463	18974	jxQ9iAeoZSRgPnYx1fjmFqn8CBftXsCUehPpbZQTaSy2M91fXSA	14608	20567	20567	1619641260000	orphaned
29627	3NKhZ4uu7nxfQ2MrXPc27oCC5iviU2qe7uemE4LAxeScbD8iNbnV	29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	1460	333	583	12463	18974	jwwFNyxGoeQiTEEYHfSESCgkvYE6fvdYXezQ4GyLiKMt1YyNyRz	14611	20574	20574	1619642520000	pending
29632	3NKmNGi8QhwJFrMmZZhUHYhqk2zMdrBqF26RzX6DVSEghopTefVh	29630	3NLKFQHDxHPUHy6UGUj7ESj2oBVXwbRpSAWqsHAi7sf91S3X53xj	1402	874	584	12463	18974	jxsmmED1ff6M5pzbwLbN3WzTWuv9LSKjdwdH8oVwrDuWWeG86ef	14613	20577	20577	1619643060000	pending
29636	3NKaxAntT4HRe6a1U7bGeMjrMG68nautx4Brv9TxyKHtPwJyBGoA	29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	484	1319	584	12463	18974	jwZ1trUnuN3vuDWKDwSoTP22LE9wADbQJgy3pZtqsgJSSuZPLg7	14615	20579	20579	1619643420000	pending
29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	29639	3NKnuH9HHp3HZvHgZUaXszuNbUVoAwr9yxdDyfCYMyTgyNrkdf3Y	1602	1369	584	12463	18974	jxFriiGKirFAYSBCspQvLjisV4DGPegQgUhz76gcLkTQWSJQiaf	14617	20581	20581	1619643780000	pending
29643	3NLiEzhHyFbf6V6GT1DMzhbHECoKvxsPRZevca3eBjGD7vbRVXfJ	29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	1588	1266	584	12463	18974	jxRvE6XL2KWU9MVFAruS9Te4igmTbVErHsp2sEqijq47anLy38k	14618	20582	20582	1619643960000	pending
29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	29649	3NL2mbJ8CmQtTRPBLdUz4SHfwYZXG1ujpU5284FTEFihp3H6u7F9	470	1309	584	12463	18974	jwuYyoac6jchUjhK9TR4U5UVfLjRKbEZ7b1kBAv7vRJM7DtvnxR	14622	20587	20587	1619644860000	pending
29655	3NLyR9R2FUthjTu79JKfYw97M4RRiDZDhcBFRi7PRFNX49oRTXLC	29654	3NLfGCZScEiF8HHdeDPLRdgdicoNhHs5AX4DEtWdF3LyFLfySigM	1573	1318	584	12463	18974	jxJpsKU3XcxvwYx4vQrRMj6KBgoSBcJRyXSZWiUHYzKRHUUsi9G	14625	20593	20593	1619645940000	pending
29657	3NL4aJYzao626ZcSDwpRAUYBAkconVS17MdS51WGxXMrzCg3bDJZ	29655	3NLyR9R2FUthjTu79JKfYw97M4RRiDZDhcBFRi7PRFNX49oRTXLC	1637	816	585	12463	18974	jy1aVYMCniXHa3WTsSEMuaomMNEGDrPBMmsmmEj4rooigTDQo2R	14626	20595	20595	1619646300000	pending
29629	3NKhTZ2dVHekWbqFGaj2XvRUxdp5rRGMeSkG84PuWhwNHLiandKZ	29626	3NLAsPiamNuYzeFs13n6a1qgDQLi9EdUHPxcLAY53saChZtuBDzT	1611	1341	583	12463	18974	jwSboHPRpuU2ej4wmUrWMB16QpmC8iSAmqxcHzJHbMKXMPZFTyQ	14611	20574	20574	1619642520000	pending
29633	3NKNhr1H5Mtzeg6jcTm22cVRqAdTok5vAq7a8saZ84srAZch1qh8	29630	3NLKFQHDxHPUHy6UGUj7ESj2oBVXwbRpSAWqsHAi7sf91S3X53xj	1553	776	584	12463	18974	jx4jUsw1Wbtx9VCDmFJxzhsL4FqUfyxwDbehWsGKfqz4MfYtc3p	14613	20577	20577	1619643060000	pending
29635	3NK6oWoprogNtNWeFEWhsQGDgwi8dfQ9ABeSF12HPKWCxoGv2yC4	29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	1406	1393	584	12463	18974	jxD9aeb9r4nY3fJPuFTz12fyU6m9u68QoqABf2WiCC2NJyyLYkZ	14615	20579	20579	1619643420000	pending
29637	3NKy5GkzDsZ9m9xnTc8p65Kj8K1LM38xNQkWAEvefR7LCuJcYR7T	29634	3NL4sDpCrpopQjcSZZKFpLToFJcA41bZbDY26HAmMWbAMrX4E1Tm	484	1319	584	12463	18974	jwhuwTP3cEkyaDAYN6WQFFZt16hPk3kfFqefwBBsoKqMeNLK1q1	14615	20579	20579	1619643420000	pending
29642	3NKpL4cJ1bbx47Y98LsM2ZoR89hnvBoXp2SVtS33kJ1LXjD9a6vT	29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	1588	1266	584	12463	18974	jwpn2te2kRg5FxoMhfMRU5YSCZs3SpBGiMbPNkfYGWt41ZgcbDd	14618	20582	20582	1619643960000	pending
29644	3NKiWGTT36XFXHBnpfgsGucELMsQpbZQKsNrBu1Uke5thr8etFVB	29640	3NKeTF5KdjjXXQaqGtGTnCQ4HD2GxTKXu8cfU1vZGwHVxXwxS227	1474	1329	584	12463	18974	jwHoReyYJcwAFtCmXmcjEJN3jdY1b86RDh4hZ9ZtQrxAHm76MaX	14618	20582	20582	1619643960000	pending
29647	3NKWBR1EDr59xeR6qkjLQTGv7Z6EGyAxXgo12CyEsEuTyGborn6v	29645	3NLVDq2XcyfJDz78WEM4vNpMpsh6BiAtUHXmTSZ7qYDJohTM4UAd	1622	1230	584	12463	18974	jy1oBjAt5ECVLDh3giAJM4Hkdn2wb5hPNcTBrfD1mY7dnJa96Mj	14620	20584	20584	1619644320000	pending
29658	3NKS9usVo28RyXacN34VccHygrYw5ee8fTo54DHHUY9MgizcBUFE	29656	3NKBqAR9PRt8nADGKd6i6DNWhhCH8dWdZrH4vTbJrg3eRtH6ELRV	1637	816	585	12463	18974	jx6JEUjbuo4YtDo5qKMADDxyAcD2mV4YcdUipgoow6xGQJ25Q7q	14627	20595	20595	1619646347215	pending
29677	3NKb7Pzo4axc4DBfu8FeWwPTngXXDtLML9mosUxjHhzRuroPMtgx	29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	1403	792	586	12463	18974	jxCeZp8vrkKYjL9jKWNnTFyoSzLCerettGCtLAGMiaKyMZdkhVw	14639	20614	20614	1619649720000	pending
29679	3NLHPQdaMUwLtxjRspFabnepW7KQixp1HkwGFFjYX73BD45RmJJq	29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	1633	1144	586	12463	18974	jwezsQaznRNySWYextKjQFFNEP3fWZpWvihojR4mbPQyNubn2fR	14639	20614	20614	1619649720000	pending
29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1622	990	586	12463	18974	jx2hbozGFJmmkaSN5R96vjhJyAckypcaakWMGoAZ6hvCWJcs17e	14641	20617	20617	1619650260000	pending
29690	3NLs7hGP5WKa88Wv9JMLHc2V3b9zRTJTfDmfaziQVam2mJexywTW	29689	3NL7jU17MyqGa4kKN3V9hj2HjRirKq7T2PMbgpnENqkQ7oQB8W7t	1407	1395	587	12463	18974	jx1eFBnSxhEgjeroGZCkvRBLkfDBRGJdvY3j11GamNCsPuLMQ26	14645	20621	20621	1619650980000	pending
29692	3NLq41PTWyR3xtkWNHUxZd31z2btYd6wvpVB4Y2g4qWAe2Yp5reX	29690	3NLs7hGP5WKa88Wv9JMLHc2V3b9zRTJTfDmfaziQVam2mJexywTW	1490	1028	587	12463	18974	jwfCvcXNrrf7ws5Vc8w6QcVdHAyFvDd5B9hXL7kgcvaN29JT4yf	14646	20622	20622	1619651160000	pending
29698	3NKW7ZktHyrTPTf34vvSmh6cYdf2VUKMRdpqDHE6F8DjiPsEj1xw	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1647	936	587	12463	18974	jwaPK7USBcbFNSDgu4ZuvEviCriJGVdfGt1RJXhXWxypXvepJ4D	14647	20623	20623	1619651340000	pending
29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1509	1320	587	12463	18974	jxdhN8BD3nZgEGGLEjc1zd3NJqwCg5wmpemDvYVk8hiMDS4tuHt	14648	20624	20624	1619651520000	pending
29707	3NL147sZNrTdTJ7ybxPF5cBS8uqrzLdq7Fvbwzn3XiFKKxZZ8X6Z	29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	1637	816	587	12463	18974	jxPjCxsT8RrprSsRwVXcmwvGSN7KfZ4rQLUMgFh42MTCqFeBrTG	14649	20625	20625	1619651700000	pending
29695	3NK7LzH35g8QVXU4YXzEgsGqrpJdN4RNpBobLSqoSsu98BwZDDYx	29631	3NKvgVQ98gTALMnRgPx47yvQNXsV4p4sWgaWyKn9FK3kt455Psid	1513	1379	573	12463	18974	jxShAtHXRvas5wbTL8HyZ19Y4NP7JTR9GK3vpiNWpP1purXZPVD	14365	20623	20623	1619651340000	orphaned
29701	3NKERjBaED6XC8LRZQMN2LMRjRoJjop2LGKCQpGQCL1veZFRKV1R	29145	3NLxSiXm3cPTRrkK6BiMLryvtc3LrjM7Yx7NmrfwPCbdfsMhhRxv	149	1283	571	12463	18974	jxaseTRJR2yKYccombnWEGERwKM6eJDfmnGUBMpb9FUmkJpehss	14372	20623	20623	1619651437793	orphaned
29638	3NKjyQnzhxZq5xi9WbSbYXd3rcphwRmZwdJeTDhaY15wMdDGKLoQ	29375	3NLqWXwWQzz9xb79tKBMykGeYScFLSa4RSULgZrE6ntYEmLSCwVn	1581	778	576	12463	18974	jwPxFQBUni5ZxUUoiMf6HLuAwBzmukKmL2tbHGCzYARqEUcX2ee	14481	20579	20579	1619643420000	orphaned
29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	29614	3NKojSiBsm9dXUxYvx2DQ9MWKRCGERhKEZ2MZ8y1NefwhWiQLXKG	1500	1051	583	12463	18974	jxoGdMjyZisFepcMUYkTLfBL8WJyo2BaieAoWJit3WU8xY2uKE1	14606	20563	20563	1619640540000	canonical
29618	3NKucFD9wPD3BmYohxgwK9bGXLSmiqPBPjXq9SFjAkVWxCLsjY16	29616	3NLXRQM5A6e1xY8zZeKXhtK9ydkBoVJQkTStmnZBavUbYWX1knNi	1654	1340	583	12463	18974	jxKdpKt53gB3XWPTFhQXXkpqQRUNU2z5CyjDyP8chqChejKK8AJ	14607	20565	20565	1619640900000	canonical
29624	3NKPNVKozbUHiYQpA1M13Qi1x8VDb7WcC9iGuWKVxE1JTND86xfg	29620	3NKQ68xWT5WkAUagopx17xxMp7rrcfp4DMv5h1AVbD31kptDSoJC	1631	794	583	12463	18974	jxgWNsCsWpKU9NuzbZQn7f2ZMaQJEyXvhjJScfdCMFsJvVRiqBc	14609	20569	20569	1619641620000	orphaned
29625	3NL3CQstwkHvCGmRhUKRRfW6972agK6D6dR5kNitfQ8YUKAniMmA	29624	3NKPNVKozbUHiYQpA1M13Qi1x8VDb7WcC9iGuWKVxE1JTND86xfg	1406	1393	583	12463	18974	jxvAP4DLvHSfcKDuCpa79VhwJ34yYCLNvo6zDyvTgt8m3Xht9h4	14610	20573	20573	1619642340000	orphaned
29715	3NKDVpwcu5fQnBmax59X2CYeBJUTQ3tmvHdqXYR31Scj1macDhsY	29709	3NKgCmPZVU9sosVmkQ4ErGJudwY8eR4P5fSic1HoFWH6Ppm7sVxJ	1439	1279	587	12463	18974	jwRxxrtVLS4GHXge2qThgcCjWhAUZ2kPNtSxAos4h8mEAxFGsgU	14651	20629	20629	1619652420000	pending
29717	3NKbBFMPFr8TvTEezALnwAq4TTmVVY5QxofedTeLWRjJqD9jSFsE	29715	3NKDVpwcu5fQnBmax59X2CYeBJUTQ3tmvHdqXYR31Scj1macDhsY	1406	1393	588	12463	18974	jwBhS9x3rnEDhQ5fcFA9Fb9UcHPhLKHJDmQAXDgSfGazzhmi2wS	14652	20630	20630	1619652600000	pending
29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	29717	3NKbBFMPFr8TvTEezALnwAq4TTmVVY5QxofedTeLWRjJqD9jSFsE	700	840	588	12463	18974	jwQN6YaRPB3UTwMgfCM6BXYzfXnK9tizoDVoCPWf5AfjpSHPQFx	14653	20631	20631	1619652780000	pending
29724	3NKyZ6nGKuBNTrLi5UGmBCq9wsEdAJzFTDzJPjX9NSD7WR3SAByh	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1444	1381	588	12463	18974	jwuDEbK2wzEuQYESNXNzsQtfPgexvmC5RwVKX1iu6XRra9pXZne	14654	20632	20632	1619652960000	pending
29738	3NLhKEVtq9TaDWVu3kmnPaVdZtTKeM74UwwJ8i8XSa83SQGqpxB5	29732	3NLxSviH9AXHRwcWNZQuqqvrTvk1YTx4eUGnan9ZkaSeu29fqxNk	1652	1069	588	12463	18974	jxeLvyo27qBKqGkfUKooG7AipoeaGv2Lzb3r3wMLfwtXYqHd2oo	14658	20637	20637	1619653860000	pending
29740	3NKpfotXpF5txfA3HYR41VW5wtnadB6TJHSkBnpZ6mpM612ZDKHM	29739	3NKS2LmBPZtWAboDr1FFDHHkuAjSA5EEmpoZxXZgHr9yzibhEzXw	1406	1393	589	12463	18974	jxrhnVt8pvChf4MBx3TxB7ZxwUR544Wyyg4A3pi81oz8CooP7jo	14660	20641	20641	1619654580000	pending
29747	3NKonRcXwdphLaCHet2NdBRTQP32Nrt8og3n3nG41HfFgigMXU5S	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1490	1028	589	12463	18974	jxWJu4PXvavGqLrc6GEDUtmX31crMPZDawCYRVDebUC5Er4YGNi	14663	20648	20648	1619655840000	pending
29749	3NLtVm61bo8PdCmAr2gyKAmtS7KpBYdouncfgrmT1SMPbuGqXmpZ	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1581	778	589	12463	18974	jxiLqAb47ApSkgbozHoCZCW1bT1yWvyKBLwZbtFYjhgwNsFgKMB	14663	20648	20648	1619655840000	pending
29751	3NL97bkrb2y7FPhbxkVDmagzhfo38MYTVEbaGSMw7mRc9gxixjsL	29748	3NK37cR9TaK7hMakzfJeo6hec1zVrSWschAnR2j2F9zCJAxHw6q1	1549	1362	589	12463	18974	jxjzHmsZziMRtF8UsuoYGKjGn2xQBKqpQCizGEHRUTLvjcKQ2Xp	14664	20649	20649	1619656020000	pending
29753	3NKwYQixHqegakFQQsVL55eFxMp36RUoxiJAfPp8bbL67a4LxjNc	29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	1407	1395	589	12463	18974	jx4yYV3wyy8sqyo2FvcRcqZgVonw8UrsvM5JMVG2qUpAwjRFwMw	14665	20650	20650	1619656200000	pending
29641	3NKUHXTRbSPDpieTtYBZtvp8sGad6FhEdY7eMbxsGPGmvvdZeAL6	29639	3NKnuH9HHp3HZvHgZUaXszuNbUVoAwr9yxdDyfCYMyTgyNrkdf3Y	1419	814	584	12463	18974	jx9SKq9QuUipt5e9rSR5VniN4JfTYmH8Tb37zqAo8kX9kuZWwom	14617	20581	20581	1619643780000	pending
29645	3NLVDq2XcyfJDz78WEM4vNpMpsh6BiAtUHXmTSZ7qYDJohTM4UAd	29642	3NKpL4cJ1bbx47Y98LsM2ZoR89hnvBoXp2SVtS33kJ1LXjD9a6vT	1585	1366	584	12463	18974	jwk67ATk2K9tz77oNKPPNz5a8P34tMMgNdd9Z4e6pTuxgV4Mwy3	14619	20583	20583	1619644140000	pending
29649	3NL2mbJ8CmQtTRPBLdUz4SHfwYZXG1ujpU5284FTEFihp3H6u7F9	29646	3NKZVyyigcZoePbZBsNBFo18DXJDXL5ryqDvSXqpV36kqMHSZWDV	1529	1316	584	12463	18974	jwqMsr1FH9qQrrWSdasiejCHrBBKxbPphMyNVqsX3gBLp19pFjR	14621	20585	20585	1619644500000	pending
29652	3NKJyd99Un4c51hekzX5ZEskfj1TTDp4zvomKFHvAjEKG24T1Kwb	29650	3NL9oNVKYRxPMbL9NxpGyoEuT7qZPtxxTmKaJdmzZuzqBWvzdMF9	1617	1042	584	12463	18974	jxHfiqUHZ18Cakajr2aCDomHbZ23RRFVKoVaj3PQeGMXMZha9BE	14623	20588	20588	1619645040000	pending
29654	3NLfGCZScEiF8HHdeDPLRdgdicoNhHs5AX4DEtWdF3LyFLfySigM	29651	3NK4W8QE83SG4CSqC3bXzbFfwpTv4TLJwPPLZP1dJLyDse7BXo6U	1405	867	584	12463	18974	jxvwugvD6tLkNcTtNAnonNwxjye3Ef5TrSTgMz7modCeV4gS161	14624	20590	20590	1619645400000	pending
29656	3NKBqAR9PRt8nADGKd6i6DNWhhCH8dWdZrH4vTbJrg3eRtH6ELRV	29655	3NLyR9R2FUthjTu79JKfYw97M4RRiDZDhcBFRi7PRFNX49oRTXLC	171	1008	585	12463	18974	jwfNMz6Tz4tZWUMbiZeK6o12VLUSvvHgDCSNDVp5Xs3NNrA8H5X	14626	20594	20594	1619646120000	pending
29662	3NKi4bbyZTgz7HtPNnZ8dbALMm1h2dALPZvoZwkCtE8w9fMadjCv	29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	1503	1277	585	12463	18974	jxY1CPjHoKaJ8gwDR2qzoETSpiCxBhfVKRWXVKpo5mQsvC3VYvw	14630	20599	20599	1619647020000	pending
29664	3NLJHTM1F4nWqXGyAUCDMsCfKBRgroUf9cRs7CZgahhMKfpNUbSS	29663	3NK3Nv2uGogYLkdYoQPc6hegr4tGEdayRmM2BnswrqBfEUHZv2ry	1407	1395	585	12463	18974	jwcnBU8z7VgZycW9C1Sz6t824gBXUgWvTDEtLy45LqpuzTzf6H7	14631	20600	20600	1619647200000	pending
29669	3NKJ55tJtD8HDMj7ZgyuBZ8DZKEATQ75zro9zTU8NEA9GitJgAP5	29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	1656	1217	586	12463	18974	jxzgyz5KvNSDCaHaAoRu3fe13sLWE6ZZJhck5AeRpiWmSjUTTGj	14634	20606	20606	1619648280000	pending
29674	3NLyNVadEx9qaEsnEJ8GujiuKnGbAaRYYAk8trXtJAPReD7UXP9C	29672	3NKMCqb3WyZYhf6J6SghqA9UC79StCJfKjUngiqxWEUKoTYkvm68	1553	776	586	12463	18974	jx6zv97uS4PT4KHWZTCsekqhP1Ejr7UVtSZEE76BS359eKCHc6z	14636	20610	20610	1619649000000	pending
29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	29675	3NKjth8padGjQTnyhmg53CBdSJuXTe4y9g2XHCoFs1R2o6KR2rhJ	1610	1068	586	12463	18974	jwPi9qJmLW7co4rJWxr5VTa1dcWT3VYxpH9QMvJMFDkexmGkpV3	14638	20613	20613	1619649540000	pending
29678	3NLMAadQqou4f7TfS9777XgEG85P1at1MrKPP2UfwX564ugR4tNY	29676	3NKg7EYZv3w2K2Kwf3DhoBpd9kgkvoHc4YG8deSRdAHDCbEtBc4K	1633	1144	586	12463	18974	jxWUcyvFMPcYKooKyL6pePsPHt8MRbQp5FvWgNGg2uGdGnYy1wV	14639	20614	20614	1619649720000	pending
29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	29678	3NLMAadQqou4f7TfS9777XgEG85P1at1MrKPP2UfwX564ugR4tNY	1589	1286	586	12463	18974	jxNBV1ZTpSj2aBKX4KvRts3MfAxP9qC9GM3pZui4Qijth27ZdY5	14640	20615	20615	1619649900000	pending
29684	3NKc6hha9ZRtVaZh11tWrm6FxBJWn6JqHkNYm3CzX7PshBwZVmhH	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1407	1395	586	12463	18974	jwdEqoHQoL787tBrHWPMoP5sPwf4EPCC9KR7vn6WafnHDxGK1Rk	14641	20617	20617	1619650260000	pending
29686	3NKR9DT6R4UMZxMkN7aV4fSBHZX2aDcQqnj2YdPAw5duVoQhfJac	29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	369	1066	587	12463	18974	jxUV5djR2Th1YiojvhYxqqsgsRfRyV6tKLzZqj5hgEQK55h1KVB	14642	20618	20618	1619650440000	pending
29694	3NKUZRvtLrpj8iEjSeKQo8N5RtC5VhgyoxTPhvqmQ7Dj1SBAh9ci	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1406	1393	587	12463	18974	jxT9CEcRJgmX61WtJoRCu6w1o2JHxwrcnAiHeVfQhwUj25ftAJy	14647	20623	20623	1619651340000	pending
29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1553	776	587	12463	18974	jx1yaGUbv7iEAVvmW58x6h3NYkgL7pet7pNoWoZFqiq8ASvgx3Z	14647	20623	20623	1619651340000	pending
29705	3NLC7v9PBC3wNzJTeY1SsJSNqmypRcrTjMnTqK1LxvKPsBCQZNXq	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1590	1054	587	12463	18974	jwcuyD6dEvYA779xBA1D86N1A1UuskNgPbccPe3wjh4mGLJsnTv	14648	20624	20624	1619651520000	pending
29710	3NKZfGoSnjkWCWBgX7eUq2oAoeH7JV2pzQSyYzFgW41a9kgzcBZ5	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1542	1178	587	12463	18974	jxFBv6mMUCgdVvMtrrAnYYbk8KEhWWkeNFDfKsiDBB9pJXuai89	14650	20628	20628	1619652240000	pending
29713	3NLrr38PozejXNWssf9VMhnp4BqS6dZk2wuEfFb5Kk6tPmAnPd2F	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1593	1100	587	12463	18974	jwmmdqF4ijF7nEE8ZPZpRfTVJj8kxdjTDkv4DukNRi4t1ALyMSS	14650	20628	20628	1619652240000	pending
29723	3NLJ6ad5RF6D6uwunjwA6ExwBSnBSuTMNRrXstc7JkL2dWNjWmke	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1444	1381	588	12463	18974	jwmCWE6dcuX4DfYfTXutJptifXUaRyWGLhHCDvbZp5FMmX32985	14654	20632	20632	1619652960000	pending
29725	3NKt83ottSqxUHkL47jEtchnv3tJomWoMrqXKaV2QYsLZLQ5iJrP	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1559	1107	588	12463	18974	jwUYLZbkoJeKkmKTrALPL5DBRP5hS4M16UmiZ5CKigmRNTXDPHP	14654	20632	20632	1619652960000	pending
29727	3NKqLJTtXwephyoppLtoPWg8XrHmiRDJTWJyrf7PnGW8doamhgc3	29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	1406	1393	588	12463	18974	jy1sQ8wNjrpGr3tGP685dudVmdSniwWTXAG6QogyjDjiC87DHQh	14656	20635	20635	1619653500000	pending
29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	1654	1094	588	12463	18974	jxkFQjet5v2ZFppP8vH89TePYEBdxFQZKEFHSQxQSkTz6M4PipA	14656	20635	20635	1619653500000	pending
29731	3NKo8cni6hT7jHfQg4ePpxPimb3GXn5SWUpzCD4DnS28a3bbbDcy	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1483	562	588	12463	18974	jwFsHne2sENrCqTHuPJLUG33NdStPtmF48jAk9Zc5LmoYfsAF7H	14657	20636	20636	1619653680000	pending
29735	3NKtRWVt3CMNC3Q5PeRPyNCHNVBRrhnvvb975eo21L62M4QyX7Kx	29728	3NLGXcfyUxUmMv3iyD21t4sFWCQi89nkgDE69WW8Yri5XRCngnLd	1624	1334	588	12463	18974	jwMVicPiS6LS8d5xcScM6kQaYBqnNM2aXC8t3TZSftzDC1AzEZH	14657	20636	20636	1619653680000	pending
29737	3NKXw6hQ5U3XUKGbyZtrSu5VmJR21oC7bb8HKY3Qs2SmsERVaJJq	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1624	1334	588	12463	18974	jxiw3pTW13cw6ZQfFPvugLUhRR7AyJkrUughwLrsrKWSkxYepjp	14657	20636	20636	1619653680000	pending
29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	29740	3NKpfotXpF5txfA3HYR41VW5wtnadB6TJHSkBnpZ6mpM612ZDKHM	1406	1393	589	12463	18974	jwkKzGPTDWziMey4yAraWHR2feyEoEakNuCQD6Z7JCc2hsAhEBz	14661	20643	20643	1619654940000	pending
29744	3NKbcFmgV36z6C7BQjE2tXiEEe2g7tkKb2dsKoRJKJwFaWBi2eJC	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1607	1348	589	12463	18974	jwxVF7MttSJmWUpTP2mYDZapdUg5Sh5W86yeb86NRn8HNccB1rS	14662	20645	20645	1619655300000	pending
29748	3NK37cR9TaK7hMakzfJeo6hec1zVrSWschAnR2j2F9zCJAxHw6q1	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1490	1028	589	12463	18974	jx1jod5hzfAXR73yvDGSudHt4uuFxDTGYAwwwBbBGGVg4Hci3Xz	14663	20648	20648	1619655840000	pending
29750	3NLcuTLa23iRgyQLWTMWVoZJbeP6fi6aGfsgxhnRwiyb937r8P68	29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	1490	1028	589	12463	18974	jxhkWpbqnQdoa8mPGe762r5raf8CJtP9b2aFFBispH341HdQcfE	14663	20648	20648	1619655840000	pending
29659	3NLbmPNzxmaHZNUSg3rrhfQW3pQpYfVaLhyWZ7K5zjAb2HN3Hj9L	29658	3NKS9usVo28RyXacN34VccHygrYw5ee8fTo54DHHUY9MgizcBUFE	1594	1080	585	12463	18974	jx75zvnGHu1ALt4j48qxLgp7RHn9xsmSj1za3ZsH188McP5aeDS	14628	20597	20597	1619646660000	pending
29661	3NKt2bLqAENUQfhSz98Tbk81qpmr3pCPMa8zxrQAjCVXasQ7XsVu	29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	1503	1277	585	12463	18974	jxxDKvrFA1VHPqgDpEKjykkMjox93cWK6K9YvHLLwHTfY1QQEGv	14630	20599	20599	1619647020000	pending
29663	3NK3Nv2uGogYLkdYoQPc6hegr4tGEdayRmM2BnswrqBfEUHZv2ry	29660	3NLntDLD2fDf2mPLCCT3qHHomTxypmTPuiUyV8c4qGMiMFRc4ySH	1602	1369	585	12463	18974	jwxnuaUS6Ez7oWW7uKGVSTEodNs3t7PRsZ8Z4RoME832CVcaVGv	14630	20599	20599	1619647020000	pending
29666	3NL3SbsKR1jv7g6j4QfbZfD9ko9KqYm9TF8rT1WRULopcvoHVmLf	29665	3NL9xGqiBn9zMvrLtGhu4P3JJP967czgwNecseJHnC4UfwWUgeVR	1444	1381	585	12463	18974	jwDz7pBTsnrBRnipp6MyNhjqjKDSVHSdrujZJWhTJmPG2hUgX1m	14633	20605	20605	1619648100000	pending
29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	29665	3NL9xGqiBn9zMvrLtGhu4P3JJP967czgwNecseJHnC4UfwWUgeVR	1444	1381	585	12463	18974	jwDz7pBTsnrBRnipp6MyNhjqjKDSVHSdrujZJWhTJmPG2hUgX1m	14633	20605	20605	1619648100000	pending
29671	3NKRC88mvdx16s9J33msbUsL2hNYaHLygtvMMqC2SGkvid8NVg16	29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	1671	1119	586	12463	18974	jx8Ud8afK1xR6j2jnDnVVgvB9XcCjJZFsteZGkBW4WDiWy3y75K	14635	20608	20608	1619648640000	pending
29673	3NLYgy2ZjgeFg4ctGWQ4uGEMtTNeXKM5sh8dKm9d1ZFtWdBg2wBL	29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	1440	1131	586	12463	18974	jxYntKbo3SSwePh4FptwAShK14kK2FP3uzTz5B7twvhycSDhze5	14635	20608	20608	1619648640000	pending
29682	3NLmgA2kF1GS4NnD2EXeHPNMAmUsnvgMFZmCbQHgZMb65T5GSbvm	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1622	990	586	12463	18974	jx2hbozGFJmmkaSN5R96vjhJyAckypcaakWMGoAZ6hvCWJcs17e	14641	20617	20617	1619650260000	pending
29688	3NLhuEtiwYDkCwWYiQY7MFGddo44zTvH6ksDSx5UrPvzWkx6j3Wp	29686	3NKR9DT6R4UMZxMkN7aV4fSBHZX2aDcQqnj2YdPAw5duVoQhfJac	1623	830	587	12463	18974	jy2LFXVBzxYwi5qZAYVgPmosvzw8cou5R8kuJYE4TN5UjhNmvKy	14643	20619	20619	1619650620000	pending
29699	3NKmrGbiyiULkPYRxgrNgbGV73VsB9V6n8uvkqwAojAChQYsem8k	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	149	1283	587	12463	18974	jx16E4zGbDr22LLppMBDMNbEk4upJnMEuUkP4Sx4KAUQaQffJ3w	14647	20623	20623	1619651340000	pending
29702	3NKhQhM2wfhnFxWJzi3KgcFJu7G57yDfrPpr6Cj3nmv5qaRHdDaG	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1637	816	587	12463	18974	jwhonjMjmbZdbm26XRHTf24HKAGoRb7TwTYzNezqJrAVMV425of	14648	20624	20624	1619651520000	pending
29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	1402	852	587	12463	18974	jwjip6GL9fvMTurRLCexzoG9wmrktN9R4ouAzGfbuFJmFPRkfxh	14649	20625	20625	1619651700000	pending
29708	3NK4A8FZoPFo7zoGhP89rhPv5QYZNMWEkizbXJNqdCqz2NnFFQLu	29703	3NLnATVXLqTpJkGkB1WGA7u8EDkTiLg2NX2HBFVvcYizhhGXukPT	1407	1395	587	12463	18974	jwjkfCCD1qZtdUd3vJzKosjxm2b8nicGDBE16fk4jmAoTmZvB1y	14649	20625	20625	1619651700000	pending
29711	3NKysQ9rACeiRJzW5dCAyvdQNLxhRXmL7GtfvMNcbY45KCGgVBcW	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	369	946	587	12463	18974	jxV4R2PHrFmcivVvPoQy84ThAaSHhCi8Tg4dT5VEw66iXqjQUx1	14650	20628	20628	1619652240000	pending
29716	3NLUb6q83RtaMuXoyW3kbYw57sPSSQAUBn2Tky3XUAPS5neP2i7a	29709	3NKgCmPZVU9sosVmkQ4ErGJudwY8eR4P5fSic1HoFWH6Ppm7sVxJ	1439	1279	587	12463	18974	jxXbbLFPg8YmzLz1VHDsR6qksX2pyZ53kJFcHGn8nRNo8RfvMYp	14651	20629	20629	1619652420000	pending
29718	3NLFU4qZmsH8yktEyhMXW571RUXTCheeX9XTF9dSWeiFBeGkN6Ha	29716	3NLUb6q83RtaMuXoyW3kbYw57sPSSQAUBn2Tky3XUAPS5neP2i7a	1627	1139	588	12463	18974	jxUTHDTN564jQde16ruJ8nWNAkzeQyLjb9MuWxQCuXe5fXX5hoG	14652	20630	20630	1619652600000	pending
29721	3NLi1jRyzRhVosJq7TAcBENY2ZVmNszcCZJKCxYgZ8mQxViKhzfR	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	1471	1386	588	12463	18974	jwJrzwyyHUeKh2D93qH6VAznJvPtMCsn79rzhRCSGmpJWp32mRF	14654	20632	20632	1619652960000	pending
29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	29723	3NLJ6ad5RF6D6uwunjwA6ExwBSnBSuTMNRrXstc7JkL2dWNjWmke	1613	1349	588	12463	18974	jwt2YYDBrW2QvYKXCsUnDQWpV27wAas1JhDww5YPCxEcUFBbqJK	14655	20634	20634	1619653320000	pending
29733	3NKrPpLiC8FpVdu95D5rbcQPypF7PWAhbZt1vAtm4xHumPxi4FC6	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1403	782	588	12463	18974	jwAjGpEjnponCyiKQJcP3WAoRtMZWdzBiwafTm2yCFdeVsL7FJF	14657	20636	20636	1619653680000	pending
29741	3NLyAPxruZB1eiRHsfDjG3jG5fwn2ehDQz4GMP47jeQqxMQ3hKm2	29739	3NKS2LmBPZtWAboDr1FFDHHkuAjSA5EEmpoZxXZgHr9yzibhEzXw	1403	824	589	12463	18974	jwfTqTha5CQJdbCbJKrATkyKx1PzDtdz16egPgu2tvWH1tysh1W	14660	20641	20641	1619654580000	pending
29743	3NKfRRde1ugeKC6ynXQyjHWYYAXT2jTD7icDghcEvrnei2GLv1pW	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1607	1348	589	12463	18974	jy2aauMv18jiPQmyDZ4Lvu3NBEA9B552YbpCCVxtgcnmbwfsT1q	14662	20645	20645	1619655300000	pending
29746	3NKsZtnf4xmru9mUcqKDb6tLaBZpYZzTPmgGBvhPAXtMdCJuhKhU	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1623	830	589	12463	18974	jw7EgzthSprRgWNs1VyLZfPENB5qfAXQd2HxGMRs6o7mzf6hWsX	14662	20645	20645	1619655300000	pending
29756	3NLfhpDALJxiv5QNYfLVMhygTNbPpnGqj7BdvbkrsU7zFv5nmxJx	29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	1652	1069	589	12463	18974	jxUKqHGvqp1hi8andXfBha5ffahvMXpYw5ksD5wfRuYQjJv3MQS	14666	20652	20652	1619656560000	pending
29758	3NLjQ53dB9mrXTpUdFbrM3bTw7xEdkFkpn7zXJe2BVq9kUXKQMk1	29754	3NL3c43PTdiaq4jrYYYRAbGSW8oqCY8FhKA8rUVeBmGZ9sJXbLSb	1652	1069	589	12463	18974	jwmbGG7rUGk7qh582NeSraB9Ju3WWcqygXBbwEeFYajUXNmeU46	14666	20652	20652	1619656560000	pending
29767	3NKicCGRjdXXqUE6XkUR4KXXnQkJh29Usp2nNobdTtbUt1JWw6T6	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	369	1186	590	12463	18974	jws7AwmVfckEsfrRwamBZsXacUh8iXqnWUeyUEQVRqyuDayyX46	14672	20659	20659	1619657820000	pending
29769	3NL93wTRHoGvoD6Mh8RUpGan8SB3FBsQ8oiMcKDxgEsw9Xx9uqv8	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	369	1186	590	12463	18974	jxVL1KFVf21uVoNMNpjbZReLiEHhY9mgzcStMDigCnTJT1B3rnY	14672	20659	20659	1619657820000	pending
29771	3NLM7kGQQTeTWZeixN4j5GoVcVpUmRSxStReJSVMJmDLgGL2AbSh	29769	3NL93wTRHoGvoD6Mh8RUpGan8SB3FBsQ8oiMcKDxgEsw9Xx9uqv8	576	1109	590	12463	18974	jxNEiapHkfySmimQvjnojK32ubz7qJbdxbvMZLNaSAdwu2q5Fkc	14673	20661	20661	1619658180000	pending
29777	3NKmro3PnFaa2Lc8UCQEC1LhDcgqGt7YjjBxBAmAz8rdPDutjj7j	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1542	1304	591	12463	18974	jxFNBtQQuSvALLnzTnN4YfCxSEat6YBSs1tNnmLGmKAoyqMpfEk	14676	20666	20666	1619659080000	pending
29781	3NLPwtBppK4SMFnjq2EfmutT9GqGzMT8vMiWF5rnsWUv53Ax7W4W	29779	3NKCoTce8A57A5wki23nLyxZ4sYQsKA3uChbRyK63CFbvNSw9i3G	1579	1263	591	12463	18974	jwnc8aPhD6baAtYMDJAK8SteWpErVsVE3BGPEebLfMVCkm3gAxc	14677	20668	20668	1619659440000	pending
29783	3NLEccXPuF2gjPj5kh5gdbr3Q1VLzrKi6pBDJQbctKCSk4zbdqcL	29754	3NL3c43PTdiaq4jrYYYRAbGSW8oqCY8FhKA8rUVeBmGZ9sJXbLSb	1419	814	589	12463	18974	jwvSEx33NhdR4o7mAwf4srhL13d7GmvPJ65nZBH1Q85isv9Lhth	14666	20669	20669	1619659620000	pending
29785	3NLXEM8EJUdfvtVuDjeyzbEPYnWE2AnonY2QfTS4gFVK4ntL52Q6	29784	3NKR3b8eNr5WnfpybSJKDaH2rvF73NQvfyKFHFv2G9nR4MnxHJPs	1546	1339	592	12463	18974	jwBcoqG7vj5LtwtWvzTzq3nGFmRdP84XMiTVRrgoccdRsKfqTi8	14679	20671	20671	1619659980000	pending
29788	3NLMGGidcFPRyvyasLRNDqz2jwE1w1737M7eYpi5VREgRWRZL1oM	29783	3NLEccXPuF2gjPj5kh5gdbr3Q1VLzrKi6pBDJQbctKCSk4zbdqcL	1419	814	590	12463	18974	jwRnP9V1wtbMrRhtX41H6Xt6a1BDSxMEUXDgoFpa89VeeoqAFct	14667	20671	20671	1619659980000	pending
29668	3NLw1ZdLsEGFbuB6JHQEytUpsgEEGeAsPzLjS9gmBrPU5L1c6TV7	29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	1656	1217	586	12463	18974	jxzgyz5KvNSDCaHaAoRu3fe13sLWE6ZZJhck5AeRpiWmSjUTTGj	14634	20606	20606	1619648280000	pending
29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	29667	3NL3igMygJQdho9fQkPjEQHHz9aCgS3fC8i7B6nuoE6g1jm26yd6	1652	1315	586	12463	18974	jxcYmKU9rcYmXZKvrXHAqqXqeHZ65BFsQfFBXbge6HbDr8L149i	14634	20606	20606	1619648280000	pending
29672	3NKMCqb3WyZYhf6J6SghqA9UC79StCJfKjUngiqxWEUKoTYkvm68	29670	3NKa9NdZ3iFn1Dh6dhLLz4LrPy8vv3cSWpPmKZKK5PAiTLz1ALDs	1440	1131	586	12463	18974	jxXLytCs7sZJEEoCs4u8MaXryzGhfo6wChGaDmQ43SNqvG95dya	14635	20608	20608	1619648640000	pending
29675	3NKjth8padGjQTnyhmg53CBdSJuXTe4y9g2XHCoFs1R2o6KR2rhJ	29674	3NLyNVadEx9qaEsnEJ8GujiuKnGbAaRYYAk8trXtJAPReD7UXP9C	1406	1393	586	12463	18974	jw7BMQs7u7aRTxksntKNaYfEeookXzmmF33YEEejtzkarLYXpNF	14637	20612	20612	1619649360000	pending
29681	3NKUZN4SBWk6e5BZ8LGWydTNKghZhU8RP8itY5GpJbXLMcPMgo3j	29680	3NK5NWCcLNdxSP88HDNn2ejqZS2UHimu8bMAVHFYUSTEiovcRMFu	1549	1362	586	12463	18974	jxubG3rZcyEXwMUebqUpNqLQnZYSxq8uYuHvn39qTtjoNGkva3x	14641	20617	20617	1619650260000	pending
29685	3NKko4Xq4QGfGwZnRPQqY7q7Bpy6aThMJoXdNkVDkSHFQFMek5Qg	29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	1405	887	587	12463	18974	jwuAHQ9seEfK72AyADuQLFFBBmTzfZS9Nkc2maNu34JmKzP6nrq	14642	20618	20618	1619650440000	pending
29687	3NLEoDdL6uGYiA4mrKHEjUaguipG8xCCSLH7bcN8JGtm1mhABpSU	29683	3NKT2ygc3dwXqYsYzozCPGEwx4Vb7qqEU6sQ9bjJCZWFuGtwd3QC	369	1066	587	12463	18974	jxHmyniyZRzMKGGVYqhH1nABMyXdtvkSyZS3XG1KtpEsPhnG7dK	14642	20618	20618	1619650440000	pending
29689	3NL7jU17MyqGa4kKN3V9hj2HjRirKq7T2PMbgpnENqkQ7oQB8W7t	29688	3NLhuEtiwYDkCwWYiQY7MFGddo44zTvH6ksDSx5UrPvzWkx6j3Wp	152	1084	587	12463	18974	jxcmuMGyZZkgPemchGh2Dq2hTDnNJYR2xZMNPgMBwS63PnyDV5x	14644	20620	20620	1619650800000	pending
29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	29690	3NLs7hGP5WKa88Wv9JMLHc2V3b9zRTJTfDmfaziQVam2mJexywTW	1490	1028	587	12463	18974	jxjpGWVpjzR3ytYHzmYS2aduLZ71L2gCHgwiayJrG2VKj1pBwwC	14646	20622	20622	1619651160000	pending
29696	3NLtMXCPDUGVMq6qu9XnKrrNae66KSoJ1Grw4SJBqN3prHpebJwu	29691	3NKDWVG639tQ6NGrHGGQUYE4NfgW6rLkTvY9n7MxddBNpWSjtjEQ	1407	1395	587	12463	18974	jwoY81DWLbcHvFmvVhEe3k8q8eexrDKnumoxa2dhK5gAs96MPmu	14647	20623	20623	1619651340000	pending
29704	3NLSQqvM64toktWrbkKQgbuxL6qqt3yrVLRqq7qWZMtrUzPAs6ve	29697	3NLcCzC1abv7GgBtuPN8o6BN541sD1XFReh4R3PRV5yMs43UjuiT	1509	1320	587	12463	18974	jwJJ5vqXbV9mseKe3zcVeQagU769x2AhLwmAJfbiTdjGa1DcJ1P	14648	20624	20624	1619651520000	pending
29709	3NKgCmPZVU9sosVmkQ4ErGJudwY8eR4P5fSic1HoFWH6Ppm7sVxJ	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1406	1393	587	12463	18974	jy2LYXtTBj53UKftw1CDBtp4QGU3L6VcxuXPbwroPRWM8hQXXxw	14650	20628	20628	1619652240000	pending
29712	3NKyfmSfXCK6N2qYdneqzHRS7o5FvFcMyDBCHX8YNdizEikjfx5f	29706	3NLBfU38cc3FHjHW1pzqk9rDDy8W5UeatNkngSMKVMCPzJzmWi6Z	1542	1178	587	12463	18974	jwUXU4DnXMn5bBM6zcg8eLoepyS1Lpyee1Q4hk7Czz9F5uQppdu	14650	20628	20628	1619652240000	pending
29722	3NLMoyxJyF2ywi2hqkrrEwLbkxDHGmxjuTUZYkrWN2WTzm9hVfHB	29719	3NKq7NmBrRJbeMYkbRQoau1VpKmXddifcARHRPyiATLHPVH5qCu8	369	1312	588	12463	18974	jwDjvJZDRFNcLgpxWc15MMnVo4t8thbMSCjut1PsWfex6odJUHu	14654	20632	20632	1619652960000	pending
29728	3NLGXcfyUxUmMv3iyD21t4sFWCQi89nkgDE69WW8Yri5XRCngnLd	29726	3NLRxwciBFreoYZBkgrk5hFRNauNhVLNtK1xNJa4ehfNrwMNq4Ff	1654	1094	588	12463	18974	jwvj6g6vhopBtxUdyPSS8PtR9Rr7MY9gLhAvVC7sSCwzxdQHUSX	14656	20635	20635	1619653500000	pending
29730	3NLP2qtrpg5fUYUzymkaQnF4V6aue8BJt45s4ikSQuJbnZQFzDQw	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1422	971	588	12463	18974	jxnvUvRL8rAPicXpEwN7CDEPjdQoWpnb17KNi3xGpTdE4cbyBsX	14657	20636	20636	1619653680000	pending
29732	3NLxSviH9AXHRwcWNZQuqqvrTvk1YTx4eUGnan9ZkaSeu29fqxNk	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1547	1252	588	12463	18974	jxZL6caPavh1NAxBrK2xzcpF3fFfcKmRVHHDojSdhd5NkpF64ZQ	14657	20636	20636	1619653680000	pending
29734	3NLhdxFrtRw5b8Sqfgzpfq6NNHjbuSQAVogDsZ2W2C4bUAjJ4zvs	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1624	1334	588	12463	18974	jx8QnkSQa2p7RAvAYCJmn2r8yv4A77kaVkyc5vyYKo3fHXbhNrH	14657	20636	20636	1619653680000	pending
29736	3NLFGnMm1LckbVGHBLDhZXJUrMnTFJ8aw9g9x94qEM7THKpUUCWL	29729	3NKxJtEUDVATjCxruUm8jue4kPdX8zXhJTuJ74M4jiP16C9Zh9st	1483	562	588	12463	18974	jxbYUwZd7ErwuJBCaoHnAyp3eALqkNeZbygn6VFTpHjfvs4Xvfy	14657	20636	20636	1619653680000	pending
29720	3NKoVNU5p6L4yUDTUCdnTpCd7UDpzKLqupaGoatFRggWU9DaZmRZ	29312	3NKPTdFLv2WuNwL8zshxTuS2yo2GaPMV8SnpVoQPGHoV3BhdD2uV	700	840	575	12463	18974	jxVDX7Hhx155apBzRVhhjATZuVqmrzA9AwM9CmaRdRQZEgSXrjW	14446	20631	20631	1619652780000	orphaned
29714	3NLgsrz6ebiXUh6TFmqqbbE9sykppwWZzq8MFu4geowY7bme3w87	29556	3NKcrYRUHGM5uVu3BUNh8zU81z4sYcHHZDRcS8LBHv5CW8QfDBVF	1593	1100	581	12463	18974	jw9JMqxXVjjSqnAdDbHkQJeYCTnpwbTKYsY9g8xWuYhhg4CwXHE	14572	20628	20628	1619652240000	orphaned
29739	3NKS2LmBPZtWAboDr1FFDHHkuAjSA5EEmpoZxXZgHr9yzibhEzXw	29738	3NLhKEVtq9TaDWVu3kmnPaVdZtTKeM74UwwJ8i8XSa83SQGqpxB5	1406	1393	588	12463	18974	jx6teiJWfj7YhDXdEgY87q1tNiE2Yn2ghvtY9YBsBjc3TXqhuKd	14659	20640	20640	1619654400000	pending
29745	3NLgVnE9ovpBtoyW3kmpPkRi54mfC8NLpAQxviN6AFp5Tkyef4v5	29742	3NLnUrSSTqRJknQtTy41gjUDo8388vMR2SSmZqHgLazQfJqSfGqj	1637	816	589	12463	18974	jxPsMmY6i94GDjEXFhr85uaaHD12W563EXi9DWkELVQyKD8Qfpp	14662	20645	20645	1619655300000	pending
29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	29748	3NK37cR9TaK7hMakzfJeo6hec1zVrSWschAnR2j2F9zCJAxHw6q1	1549	1362	589	12463	18974	jxgob3izkjuRWASJvf7ST4vBWe2yWoZrhvLL3nxsGvcXAak9zih	14664	20649	20649	1619656020000	pending
29754	3NL3c43PTdiaq4jrYYYRAbGSW8oqCY8FhKA8rUVeBmGZ9sJXbLSb	29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	1588	1146	589	12463	18974	jx1yTP3iAyCFwaJTY8Kq2RT5AixuUGKTc4F3Sy3U8TDX2Z41hF3	14665	20650	20650	1619656200000	pending
29757	3NKQwUYUtTxNT4AnhfqFRK4NmVRCwyZGij5GcP71KS7RZrAyFDVt	29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	1652	1069	589	12463	18974	jx5hYq2ooEsqET6ibuM1rergrXDtSz2LGwrdTLkndZbCNyi28Rt	14666	20652	20652	1619656560000	pending
29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	29757	3NKQwUYUtTxNT4AnhfqFRK4NmVRCwyZGij5GcP71KS7RZrAyFDVt	1617	1042	590	12463	18974	jw91Cx9jnfTeeLDxTiKbGobLvcijqgXdoxc68tgU7cUn3T93yEj	14667	20653	20653	1619656740000	pending
29761	3NL9qEMz957bHVVT3hqXFN4jhrjrhyPEoZW5fJQanG9eqDmWPTWj	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	1517	197	590	12463	18974	jxonkLWidT6mfNBLY6kPYSQHNXtZsVgR9zMMZJZyWvxqW5x8wfc	14668	20654	20654	1619656920000	pending
29763	3NKEqmECwWW4tqyT4KSGJ3GApBxDQNmoSvzQgon84j54Vjgj6MrJ	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	1517	197	590	12463	18974	jwBLePx9RoF6nxxQdTAdwK65C6TiWPGKM71Di7RDFczfoU6kwzx	14668	20654	20654	1619656920000	pending
29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	29769	3NL93wTRHoGvoD6Mh8RUpGan8SB3FBsQ8oiMcKDxgEsw9Xx9uqv8	576	1109	590	12463	18974	jwHLmArBGe7ps5p85Af6KdqWWdmcHH2kunaJKT2f1fEd68C6ieq	14673	20661	20661	1619658180000	pending
29772	3NLjyCkZpc3Kk1eyEQrW32fSs53UGd9JHKFKjZZBLZEgMdrCmTzN	29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	1467	1250	591	12463	18974	jxfCexCc5drzY5qGmN9D2Yi1Mg11HY9tP9wQ1Y3DDLYdA62TwMR	14674	20663	20663	1619658540000	pending
29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	29752	3NLozCFDaQmmgq8uNPqh5PiKvkMBiEFFbT6EC9baCzjqqzuYikLp	1651	1301	589	12463	18974	jxPug9T7N51fVb2Pc9w6XdMdEyFDv83mx3ecrxhvYZiQ1w8sWtg	14665	20650	20650	1619656200000	pending
29760	3NKzKdB9AMiZhXfw9d6hzrtrhd3cuMokHzLfMzmJXMvL9DBfbTJ7	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	1517	197	590	12463	18974	jwk7pqaJ5c2A2pHxfZv3YJc8ZbrmXADt3fCJWEbfjA38N1QC59d	14668	20654	20654	1619656920000	pending
29762	3NLADPCCj678JBCmhfuuGgPcPKif5SN9DoHR5SpUFVEapBteh4jy	29759	3NLM58oJ2ifi2SgyQMeeaBvc5XKHXbaWkgXcyA31AxVzrEpQFZdA	563	1233	590	12463	18974	jwrtC3rizBjNug5vMGfkkqbidmbX28K4CeHqSSBp9Hfn4JtApkc	14668	20654	20654	1619656920000	pending
29764	3NLD1by6T9JNgvWT3dAjKQWbyqve4ZYA18TDa2KhPNg11rd9h79i	29762	3NLADPCCj678JBCmhfuuGgPcPKif5SN9DoHR5SpUFVEapBteh4jy	1460	496	590	12463	18974	jx66s9QRndFdhtiGazzq124wRSQ8toPheEc4dH7WAMg3NSKuRQ4	14669	20655	20655	1619657100000	pending
29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	29765	3NLwDVdBkqWt8FbhkUjnd37C5HotMjsPUF3A7mhEyzza6URQxMtA	1406	1393	590	12463	18974	jxtgRww2Jy59VRb5Rfcn5cat4B9CtHx71WV8odCvukMshN7cMbK	14671	20657	20657	1619657460000	pending
29774	3NKJhiZhDs6ZGdMEDvL9ExdsviByiJCtddHrYuGfxhxpkr6CoBJx	29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	1623	839	591	12463	18974	jwAQziWcczVPsb8WtCCdmzrmzf4zgczysUvrDQSXUuQeq79n9vz	14674	20663	20663	1619658540000	pending
29776	3NK4HTG3HvL6FeHYEfcXAea98vXToSf5napzkbZxnEaRFviDH2oQ	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1406	1393	591	12463	18974	jxvVh2cagVkt2F4TKGEiRU1Rxmpx4xYa1YL1AS1xh8LKHXY3sts	14676	20666	20666	1619659080000	pending
29782	3NKn8KJUSFMEMwH1eWSSQUkn9c6LUA7Vu7LAZSBr4wUM51kbnrwZ	29781	3NLPwtBppK4SMFnjq2EfmutT9GqGzMT8vMiWF5rnsWUv53Ax7W4W	1419	814	591	12463	18974	jxteG1CbxnQPyhKYvWw2dYq95FX5X7fGKYwYAEgcySjGeUQQ2Y6	14678	20669	20669	1619659620000	pending
29784	3NKR3b8eNr5WnfpybSJKDaH2rvF73NQvfyKFHFv2G9nR4MnxHJPs	29781	3NLPwtBppK4SMFnjq2EfmutT9GqGzMT8vMiWF5rnsWUv53Ax7W4W	1650	1129	591	12463	18974	jwJHJHJP7fTbmHgHxLkKGEf8A6i42ZRW58Xa1ZhLPuT4QTp9D4M	14678	20669	20669	1619659620000	pending
29793	3NKpvFZJAvLPMBGtYDfHJ4SKxiUZJy3e6zNhBgFvoNJ3RMY8L1Bp	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1656	1097	592	12463	18974	jxR9XcQgKHWeqUEvy7qFn54kkAwXsfKpJTNY2zm2J3UtHxZSDpF	14681	20673	20673	1619660340000	pending
29795	3NLg7pjMiZiG4HjXfBRmED8ejgTixwvAwD2NdMiqfe48vG5zQVse	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1590	1174	592	12463	18974	jwav3BpM4pa8E6HHy9k7qQ8ffsUbXN1BcqWhomfC5SFQFzvvfie	14681	20673	20673	1619660340000	pending
29797	3NLyd3k59hs3GoWkPN5ypMjCaApS5wYkQ2prByw5vp3sZpgYBv3v	29795	3NLg7pjMiZiG4HjXfBRmED8ejgTixwvAwD2NdMiqfe48vG5zQVse	1590	1300	592	12463	18974	jwkWVzDv3ATWopXk5GpPZje3oTqrzm56CdaspXM8VcNUTA7Q7Nn	14682	20677	20677	1619661060000	pending
29801	3NKLu1Lc7gMPADR8Yhomsr5rvUEef2BoGnXkFX4Lcw5RjjiaKqGQ	29799	3NL1Y7LtjmNSbCbZpysAxz62AZYibiSfr5Hiqqspt7AJnSwnmKP4	298	1062	593	12463	18974	jwWCyEQ38okQvgSaqJ4jrLKD4KeELU4qT4id3sVPwMHVQGsnm7o	14684	20679	20679	1619661420000	pending
29803	3NL586YuEASwuTni8LhUGDFQHqiAYUWdptEqa7EQgTvZP64Ao5ar	29802	3NKuszyx4YdhJLaeK1S3sxm5YmEf3xHGbybi4A6nU6huJbMYgFZS	1549	1362	593	12463	18974	jxaSqr9R7zfLxdCFuKZwMb4zgrHcPy7rjHB4Yk8ccft3dnPE74z	14685	20681	20681	1619661780000	pending
29805	3NKTTtPYLobciDThKREDhubQxQcL1V2tMX89Go4JyUM4ZdkqFpZm	29803	3NL586YuEASwuTni8LhUGDFQHqiAYUWdptEqa7EQgTvZP64Ao5ar	1622	1230	593	12463	18974	jxp6ehTZQci7Wxm5AkDYdUymtEjA1BFeqWyri1nTdYQ74Ug2e6G	14686	20682	20682	1619661960000	pending
29807	3NLNtfaA3QTsU1FgX32FJmqmXbFFndSBEFmLodSUHi8keyNkMDs4	29805	3NKTTtPYLobciDThKREDhubQxQcL1V2tMX89Go4JyUM4ZdkqFpZm	298	1182	593	12463	18974	jwX557DsvkW2fgx8zi6hseyboR5Duy7onX6QVbFDMJg3WukMpSU	14687	20683	20683	1619662140000	pending
29810	3NLji2B5bSDKD4YJmYkMmcPqvwK97QqGQD1nuG2h6avDJU3ekKpR	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1637	816	593	12463	18974	jxHVKjMqfoKFUeYBa6qUw8NgKPevyaNBZtJCQUZ1iToZEaHHx8Y	14688	20684	20684	1619662320000	pending
29820	3NKP2tYiWEwMcqWYCrcnzPBVisFeu8n4FEqMSvyKeNtxto7Z9yXp	29818	3NLMSbxpNrDCcrS5NezkSxA9hS51U1gWZmG38B7t6pmvetegxgUE	1578	1296	594	12463	18974	jx1p3Jbrpv3RfUMk8PPHHQeiQqxiPpgVCkRVv9jhMEvD2jAuCod	14693	20691	20691	1619663580000	pending
29837	3NKn7wuCBbRJYwEGfwNx4texfXHCwgDeJWjZ9q5mRASe9p92vzsM	29836	3NKs3aUodGyJ1Bn1C7Eh4noNNyn8ceB7kQJMfvMYu3tJSC8TMbeF	1403	823	595	12463	18974	jxj1d7PpF3ei8ZpFLWJ1RCEtrFuLKeVktMY2mHVywp1BSFSybfj	14703	20701	20701	1619665380000	pending
29840	3NKM4PWvQfcgGHZzndWNZyZ6mNJzZa87Ct7ysth8h5TVD8HpNuB4	29838	3NK8ANhJTsamWXkxo5hB2THGc4pHyCuaFvu3WTMjgKxz9DunnW5K	1406	1393	595	12463	18974	jxEJcN8aPsTSD3wjxwjDugnRGAWsz3wi5dS3XtPts2jNUNJjuEC	14705	20706	20706	1619666280000	pending
29845	3NLHGPvSdq9XqEXr4t5zMpz5dNhGhXa8yK5g3SQcR4dwH5hd75DM	29843	3NKmuuPsuv34zmGWXQmkXHosYwwTshwRN9qGUsz4J1JFfpnYGarN	55	59	595	12463	18974	jwzohvDRhVBjM9n187D2tViE2caTwEFtzhPQYz3C375DGKF2NVB	14709	20713	20713	1619667540000	pending
29850	3NLZibFsvkwTTCx85F4LB8Dw2ENfT4w8Kxt1H2FzbW1iGMcLUWdm	29847	3NLByy59Z27E86saYPUDzafe1BvkCUKJSrpXxJTAVyDhMzjE1K4J	1406	1393	596	12463	18974	jx6qztNnncKMib8cEswsujAbv65K7WfGGP8FojeEYwiSXTA6rK1	14711	20716	20716	1619668080000	pending
29852	3NKwLcVuWWAovBdvJU3ivBGScE6rkZi4dV6GhRsM4SFxu1t5HPLo	29849	3NLoLKME3CGnZHR7TPhqrxx4sgAqUfLS1u8CgoihsD1nuWTNXVaS	1590	1174	596	12463	18974	jwqVTDd6BAv8xYhQDbKCLDJ6XUXQteHQUwrpt7ghDXBfdKjQUNa	14712	20717	20717	1619668260000	pending
29857	3NLadxQFSH1SzTEcystMP5wqP8V9frzXU6Rro64jwchcRQAPVtZ9	29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	1474	1083	596	12463	18974	jwHtxRntU9vJPcFqiU7Jmpb3nSJ5vFyPHnQqFb5NHiQmTLHAQUu	14715	20721	20721	1619668980000	pending
29859	3NLZqkLXoUd2Mm9hu11kp5JDvpZrrDn7Tb3weYvBbNgqK4EEuV55	29858	3NLVZkkzPF7Gr82nXnnLcBoRLYbFapCUHCNeVHPSKPRPtRenRBGB	1426	998	596	12463	18974	jxZAmbXZ8sghnhEHSUuUs4ug8zuVWMVnQZBUReYvXouHJ6nJUVm	14717	20723	20723	1619669340000	pending
29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	532	1303	597	12463	18974	jx3dF56h1KahspqtnstJ81N3TxKdR21TWe7TavVhT1Togez1Qvp	14720	20727	20727	1619670060000	pending
29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1406	1393	597	12463	18974	jw7NuCPaBVTBh5ghMkNnszpWghaizQxPTYfJJNKjiG3gFMvDQPT	14721	20728	20728	1619670240000	pending
29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	1406	1393	597	12463	18974	jx27QG7LK4ie3bvA2CAfDg4GXexzegM9r28NUpSWe3yC6XCavS8	14722	20730	20730	1619670600000	pending
29874	3NKCiLH6prszaTpnVmAvnjVe8JgCPaJnGHZ9SuEyJQoMwpg3aeSd	29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	42	1235	597	12463	18974	jxgCUkvwvqKk28sdsZRFEXiaySup8M9tCQw7QaHvh2XKhioZszW	14723	20731	20731	1619670780000	pending
29880	3NKu9x5RybQ3CAW8LQn6XeQ88PM9ioBsUYrG19USEhPhZLZAo3yt	29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	1559	1353	597	12463	18974	jxTvbnLu4DvN2WpxoxbtmrHYTwQGs1VmTsM1xwAdKjjhBgRxuLf	14725	20734	20734	1619671320000	pending
29884	3NKEoE2Fm8SV1V3BsPgB5YzsELz5zVGaUZxnW1cPFeRbgBZZafsB	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1651	1301	598	12463	18974	jx3FtxwbAFbDGfrFaBQ3dsFvPXVtZPM1xM6hnK6CoxDN9sHzVUL	14727	20738	20738	1619672040000	pending
29886	3NKqsK4RCpBFCKBcV5tfWyesV1RfrpziCBBLbeKNr9x9JHaaoLJ2	29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	1406	1393	598	12463	18974	jwTxVmTqkHW6cdgxHniN8mjREtAT2EbKrcB6z1eTxKq9k99PERb	14728	20739	20739	1619672220000	pending
29765	3NLwDVdBkqWt8FbhkUjnd37C5HotMjsPUF3A7mhEyzza6URQxMtA	29764	3NLD1by6T9JNgvWT3dAjKQWbyqve4ZYA18TDa2KhPNg11rd9h79i	95	95	590	12463	18974	jwnQfkVbBpGHrEcxQw8PAgKjp5KNvW5Ju33MSkfvXbsFMaQ22zm	14670	20656	20656	1619657280000	pending
29768	3NKyzfiU9QfPW69w6NvRsuwoxi1vBk5zF6ksLJbHH2MyZceBpEDD	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	1647	1302	590	12463	18974	jxadf5MMs6NR88XwKW5Jxd3EGCsMS4gb3R6jciVgT1ymBSwruv1	14672	20659	20659	1619657820000	pending
29773	3NK54r4NwTsygDX4LrBjeKRU4a11eBWneEGgJVAH11HUcFLETYDg	29770	3NKUAkkrsoGrVExhv3qbJXJjHBVfhfoGSjkGQxSdW9b1FrxAfNL7	1645	460	591	12463	18974	jwpo4Zmhg1U9Mu933d5rJvTT1uAmZnhWg4eVWuLUCbzDfZeSaew	14674	20663	20663	1619658540000	pending
29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	29772	3NLjyCkZpc3Kk1eyEQrW32fSs53UGd9JHKFKjZZBLZEgMdrCmTzN	1532	253	591	12463	18974	jxDnBtu1J8o8SYoSLCTu7y85YpXDowv2pHgXVdUHP8MVaRUZLZh	14675	20665	20665	1619658900000	pending
29778	3NKjQnXLnxgcsdrB4Q43GpXycYeik2AiWftuGMmrxTq44vwEFE2x	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1501	1114	591	12463	18974	jxfWuLtv35XKe5uRhax9ryq2AJKTSpZ3yoREaj3j8NHTomXnypj	14676	20666	20666	1619659080000	pending
29779	3NKCoTce8A57A5wki23nLyxZ4sYQsKA3uChbRyK63CFbvNSw9i3G	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1542	1304	591	12463	18974	jxvGm2cBMvM4mYKXcvg9AW2tLh6N5ELNtYVHSpfDvy1i4VurvTo	14676	20666	20666	1619659080000	pending
29787	3NLjynDPVHSFXwWp7W72ZPBgWmsKYhTw7jnToguLjoNt3pE4LQU7	29782	3NKn8KJUSFMEMwH1eWSSQUkn9c6LUA7Vu7LAZSBr4wUM51kbnrwZ	1419	814	592	12463	18974	jxMR93B4XstG4KR9L7pyr7Ub83AhpkoNgQTCwNHpXSHHNdwJzmP	14679	20671	20671	1619659980000	pending
29791	3NKijusexbDhwmV6J36MjW4jiEQvPJcpfRuSw1y5uWGaWhc16Ef1	29789	3NKLc1wXCYwKgAhURoEe3na5pSAFFmaDJEBhXmkZzTWF3emw7mNX	1618	527	592	12463	18974	jxM6YhNRfSnXkE9yF67mha4CVznd8Y7QgnyTYwgX5ucsVfGYjg2	14680	20672	20672	1619660160000	pending
29796	3NLssuHhJqdouNFnA3L9dBkUAxbfGzEciSiGPBetiGTvBVRS2cd2	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1624	1334	592	12463	18974	jxEJAfd4gYMEfPsU32vmPKd4BfEnep8Ez3cuVKH1xxJuCyLbqJf	14681	20673	20673	1619660340000	pending
29798	3NLmrBuo7Bxv4myywNqRWA9PLezvDKw2fLzZ1i6YbtQZFB9JAXFS	29797	3NLyd3k59hs3GoWkPN5ypMjCaApS5wYkQ2prByw5vp3sZpgYBv3v	1490	1148	593	12463	18974	jxyF8ojrv6G3gFVh4T9xK2t447dXKLaRVVg23JQfsC4Y5U1quGq	14683	20678	20678	1619661240000	pending
29808	3NLZKRsoUUa6KaCvYM7X1TcreiNefMvbC5VEdSnNdMUFXG1uXMQ1	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1406	1393	593	12463	18974	jwCEugEp7pwnrNzD5KAPFqpBFNtYwT5b2FiN3VmxA4WR9iyxRGS	14688	20684	20684	1619662320000	pending
29814	3NLUfr7UgQSjuMfLRxJgd2rf4JzqUCCSmC2XRxr4wC8vXiVcdpQf	29808	3NLZKRsoUUa6KaCvYM7X1TcreiNefMvbC5VEdSnNdMUFXG1uXMQ1	1601	1262	593	12463	18974	jxKW1znJEXPGcF2hYgNmnn2TYvFxM4FVF8CBaVW2mX55Uay1Hmn	14689	20686	20686	1619662680000	pending
29816	3NLYS8GjLApbPg35SJfWHPJZfb1Td9et2JdZddt7NR9xJqmGntCT	29808	3NLZKRsoUUa6KaCvYM7X1TcreiNefMvbC5VEdSnNdMUFXG1uXMQ1	1503	1031	593	12463	18974	jxyqwfZqY1cWEmXEV8hzcrmKT2BnV5ZFurvsuv7HcmHDCQpujUh	14689	20687	20687	1619662860000	pending
29821	3NKUCpHri5wtMVnW8QXvdAajSXcZh3Mkn6ayA11uumfHwRi8MCdv	29820	3NKP2tYiWEwMcqWYCrcnzPBVisFeu8n4FEqMSvyKeNtxto7Z9yXp	1617	1288	594	12463	18974	jwUvSc3thewfwZgjhUB9atmzcqgQVLJA637xHkQTKypFYBkM7Tk	14694	20692	20692	1619663760000	pending
29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	29821	3NKUCpHri5wtMVnW8QXvdAajSXcZh3Mkn6ayA11uumfHwRi8MCdv	1460	609	594	12463	18974	jx9aAvsgBWKb1bAx4PreKs7H3UhcZ1MBNMrGyH9Mj5wCR3NGRjC	14695	20693	20693	1619663940000	pending
29825	3NLR23zpWkmvGhuqqgvYDJ5QS4vWsvY1qYCEtsFmsSuH5Mnjh96Q	29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	1527	1047	594	12463	18974	jx4ER2o4aLp4NaEY9iPuKwp1AkQXqzd1Rf23nh5BgyiUef9Urig	14696	20694	20694	1619664120000	pending
29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	29824	3NKPjfAxceDtZtKQbXth9KRfnCZoa7edwCiBE2QrEbheNcreKZvG	1426	1364	594	12463	18974	jy2JEPzGfkTvEMuTUZBmaeAJTc9Z2f5CxoQK82tXtKC8h68w44A	14697	20695	20695	1619664300000	pending
29832	3NLLahDjrEEufYGo8zrPzec7ZyDo3qKh44w9usrMRfPt3GA9wRBm	29830	3NKzoRwUDNLUSck9ZvYF9VG7ErRiXHKMcNGVVYGJgZUi1WrjWMGR	1646	1228	594	12463	18974	jwmeiffow1DGY9v6Z62Yq1vMYzzJpS3ggXtAQvXkGs9CFnjqYyh	14699	20697	20697	1619664660000	pending
29834	3NKN7guVjZXn195JSqfPmJWKutfDVuLdKvDGMYx5nuEJunw4K7eM	29833	3NKjrSPAYUSpd9yUYSGaXJZdvg5r4Yn5ygc1CNpCTV2p76QDF14E	1501	1360	594	12463	18974	jx8asMM7FYkEKnkuF2Zpii3spP1wKqfuQyPPwph2Cyr4WuuH4HF	14701	20699	20699	1619665020000	pending
29836	3NKs3aUodGyJ1Bn1C7Eh4noNNyn8ceB7kQJMfvMYu3tJSC8TMbeF	29835	3NLvTuN92b1vGfbZkyRMZ252zimM7tmRT3ub75hujD592jPnTrKz	1503	1031	594	12463	18974	jxpxMEn74RyAgLxcDVKi9ZjkZcuD5uvEEoNPGKq2FjNarxkU6aZ	14702	20700	20700	1619665200000	pending
29838	3NK8ANhJTsamWXkxo5hB2THGc4pHyCuaFvu3WTMjgKxz9DunnW5K	29837	3NKn7wuCBbRJYwEGfwNx4texfXHCwgDeJWjZ9q5mRASe9p92vzsM	1405	873	595	12463	18974	jx1uJPVQcrdDj7zSfseAh8v4zCGRod2RLQRARTaPbuFKD8js32K	14704	20703	20703	1619665740000	pending
29842	3NKi9dbCuBsP3Ea9QVW5ivamqQKsWDRV2Huf5q9hfFpEFZQZkcAS	29841	3NKJH3PSN5zooQSb9hjeSCMkxkeZSFonuCgivM8cTBSVBFgHyqLN	1407	1395	595	12463	18974	jxAWQLShpjG1DsxkR2GdhH11PBwRcrFmpguYrhJVxh7NzkPPMSf	14707	20711	20711	1619667180000	pending
29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	29843	3NKmuuPsuv34zmGWXQmkXHosYwwTshwRN9qGUsz4J1JFfpnYGarN	1578	1050	595	12463	18974	jwZJY6o9xLJSMBMWmtsfK1WtAcnAM1NKuzmgZHAe3KFxPxya8ED	14709	20713	20713	1619667540000	pending
29846	3NKYri2aGPrrY4cJ4JRmF87YfNBcq6ubtMi8pV7N9WEs7vgAegg3	29842	3NKi9dbCuBsP3Ea9QVW5ivamqQKsWDRV2Huf5q9hfFpEFZQZkcAS	1578	1050	595	12463	18974	jxnm3KTVs3MaUxjP7Ks2GDG1L4yubEbnwavsnLUi9vtr2GiJori	14708	20713	20713	1619667540000	pending
29848	3NLCuczniMWJEcaAMEMCK8DwQzskCStVUu2QQDibDoAoPMMDMQpB	29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	1405	867	595	12463	18974	jx69JVnEZVLFULLNZw5bU5QHurEwBGn7TgpGEtM2evGmZrxgDXx	14710	20715	20715	1619667900000	pending
29860	3NKRQdeXikKqcKTEJUuuwjmp5fP1ZivSUhVcJg2nK82Xn6Q7nhkD	29859	3NLZqkLXoUd2Mm9hu11kp5JDvpZrrDn7Tb3weYvBbNgqK4EEuV55	1402	906	597	12463	18974	jwFWovP5XLEXPP6HgfYK4QzxcS9Sv51ErHBme4TEn15YdJhiUkK	14718	20724	20724	1619669520000	pending
29865	3NLHhUkk2gqs7grDSGGJwcAzWXnmExmaqLacRup3e6sW8s9gxG4Z	29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	1553	776	597	12463	18974	jxbpUW9qpD8WgURhFmeq7iJp1vA4n5q6D348UyHE3J9npXS1rKg	14720	20727	20727	1619670060000	pending
29869	3NLFrnZ6Lg1MvFtiFP1U13mYawbbqDLrqadPLWifZHQXLuzaQC3V	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1527	1047	597	12463	18974	jxPKppcihbv1rxJ2uezs62JXxxNrF5CbX77QcqBzX5PrZ939FBm	14721	20728	20728	1619670240000	pending
29872	3NLKwux9BjLnxsDYWGWKZayAKf2YwaMCCUwvooKxGHCy3mk6yuoz	29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	1405	887	597	12463	18974	jxm8LTg7pR91mF9VmMtySNRoNdbgDeJQg3e43oumbZmNpUZ5sfP	14722	20730	20730	1619670600000	pending
29883	3NKnKpUTjYUQ82gcWpj7Eqdn9vatZxudVgsuAmN9ZcVqKyZiHTFS	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1651	1301	598	12463	18974	jxFAQvHwvYb1QnTb8HP9WHn9svYzmE9Zo6Qb7pwZRAuUrXZH33w	14727	20738	20738	1619672040000	pending
29780	3NKxG7SfKBXa1hh8qQbg1ccqCXJ6PcM6UBss43uHpXhmRBrpZW5e	29775	3NLikXYXbgyywUUxWYFBjrpvwxWGkJx7bxhGCXE62b5KiYHZLLzP	1637	816	591	12463	18974	jwFNNc8eq9pbtNUr9VoM8cyUgahcLLNGtw8fHDXFircQwsgxX4A	14676	20666	20666	1619659080000	pending
29786	3NLVqvAddmtyyJCZQXvXQ6GakEGnjRs8jRjvPRYttmEPaU87XW5L	29782	3NKn8KJUSFMEMwH1eWSSQUkn9c6LUA7Vu7LAZSBr4wUM51kbnrwZ	1546	1339	592	12463	18974	jwvauxbQsTWBGRdBGokANmhncTmc7NS9ViKtHPadYxpYjgr8DYt	14679	20671	20671	1619659980000	pending
29789	3NKLc1wXCYwKgAhURoEe3na5pSAFFmaDJEBhXmkZzTWF3emw7mNX	29784	3NKR3b8eNr5WnfpybSJKDaH2rvF73NQvfyKFHFv2G9nR4MnxHJPs	1419	814	592	12463	18974	jxeUTZw1p3CKcdWQbjaUJFx93Rcoqj1c7N4qJevQqREsxWmMsf5	14679	20671	20671	1619659980000	pending
29790	3NLSvRbXRRbUe9RCD3qaF4izfxszCEJvDdpiDFtHPX4iY5XAwvC1	29766	3NKbC7zH8ctb7PFsemWm1M2NXZPbxAYqBAZTeMhfu7riKAwxGdrR	1618	527	590	12463	18974	jx4KV9CbfiWsRLZYFcgh6SNzp84jPSnTL3ykC5nSeVgYGDhZaHi	14672	20672	20672	1619660160000	pending
29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	29787	3NLjynDPVHSFXwWp7W72ZPBgWmsKYhTw7jnToguLjoNt3pE4LQU7	1599	1287	592	12463	18974	jwGWhsUNewYLxPEYWspaDPjGTqHaSFJCgGGySE22vZQAL6seJzy	14680	20672	20672	1619660160000	pending
29799	3NL1Y7LtjmNSbCbZpysAxz62AZYibiSfr5Hiqqspt7AJnSwnmKP4	29797	3NLyd3k59hs3GoWkPN5ypMjCaApS5wYkQ2prByw5vp3sZpgYBv3v	1490	1148	593	12463	18974	jxW9SNY76rt9URjHF6983idnwhmvbbZtqodK8xi2wcN6UfZj3fi	14683	20678	20678	1619661240000	pending
29804	3NKe1SmLuzfaztPQgrJoehNpfRNWCqFE21gva83uimwEUhBYB4X7	29803	3NL586YuEASwuTni8LhUGDFQHqiAYUWdptEqa7EQgTvZP64Ao5ar	1622	1230	593	12463	18974	jwq1BhVN37TKZRQa76evHhycd3zkSXekHvDchGtxrVgthT79SNK	14686	20682	20682	1619661960000	pending
29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	29805	3NKTTtPYLobciDThKREDhubQxQcL1V2tMX89Go4JyUM4ZdkqFpZm	298	1182	593	12463	18974	jwkSjCFEkzFMB8FqhoecuXayge3PwvrhZCgQwrqsZKMyYnL6pFT	14687	20683	20683	1619662140000	pending
29809	3NKCCcoEN9PdxXnx97JiLcY7ETitzPwHKFdjo8h2Hqrv1TBqreAd	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1405	1	593	12463	18974	jxRESSTJQsW6hPgWg1EeRpQYZHeZdsA6fvGiHwwiu5SDAi4Gevc	14688	20684	20684	1619662320000	pending
29813	3NKYgnSzRp7eQj42RP96dbXWS1CVSjZPgqpvLRPA7x55bqbmNC7w	29755	3NLRCVtVxXMNxuaLFALRyA6g84TJofFYWMcAXAhnVsrsAoguH24i	1601	1262	589	12463	18974	jxNhxRbsnuQrMz19rmPgQv5nmhhgj6H1QCcBmTZxzsMXKgMKSsE	14666	20686	20686	1619662680000	pending
29815	3NLj76yuDCzmzfCWUTC8vemroNuCVpzSBW7SzLwqd1676PL6dX89	29814	3NLUfr7UgQSjuMfLRxJgd2rf4JzqUCCSmC2XRxr4wC8vXiVcdpQf	1503	1031	593	12463	18974	jxXu3QZiyXEGPdKfebrR8kPfnXs9uTYhU7yFjcJ7ijwWxbULMLX	14690	20687	20687	1619662860000	pending
29818	3NLMSbxpNrDCcrS5NezkSxA9hS51U1gWZmG38B7t6pmvetegxgUE	29817	3NKqJ4KzoVV5EyJUdxq1UQuTdE8nBXh6FNFyadvVvGM534g4P3WH	1476	1371	594	12463	18974	jwmUEKHwm528nnWxxmhfTZ5aLNyjZye5ZLAv2nNXKJsqGYZWsuK	14692	20689	20689	1619663220000	pending
29822	3NKmEUadiGtB8rzcR9LmPGbprpm1hxFHMJWfSgRbtftQfakiGBA5	29821	3NKUCpHri5wtMVnW8QXvdAajSXcZh3Mkn6ayA11uumfHwRi8MCdv	1407	1395	594	12463	18974	jxQ4y8r9PVc4heS1hJXx1kAckzHy9JTzia7YuzXfqxD7AWtsMnM	14695	20693	20693	1619663940000	pending
29829	3NKQWxELCwbJSMZynGwMQ2z8yzLMU7Q6raEc3tfysgRq7mJuQ2uo	29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	1610	948	594	12463	18974	jxw1u9WM9DqDsnXDPN6pPG3nBRXEFfe1U9mrK59WLLbbwRFgfLK	14698	20696	20696	1619664480000	pending
29831	3NLPv52nykzixR3vdjfs9DCyDMS6AuTy3QfQ4Mg3jf4fAAB2shMu	29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	1624	968	594	12463	18974	jwERZwpfkUKY3RhQmX6HQrbEf7i6ZNQvMDU4cr7qrTH9ZUvyqET	14698	20696	20696	1619664480000	pending
29833	3NKjrSPAYUSpd9yUYSGaXJZdvg5r4Yn5ygc1CNpCTV2p76QDF14E	29832	3NLLahDjrEEufYGo8zrPzec7ZyDo3qKh44w9usrMRfPt3GA9wRBm	1613	1349	594	12463	18974	jxV44qavrDwH1hccvpyz7stLY9gr2Yo8KxaF2jouB2E2NytJ6Uv	14700	20698	20698	1619664840000	pending
29839	3NLjfdoFBuRL4Rn65btWsJf4NMFuTBhU3WKK37su4yuEmGw8JSou	29837	3NKn7wuCBbRJYwEGfwNx4texfXHCwgDeJWjZ9q5mRASe9p92vzsM	1637	816	595	12463	18974	jwNEr9wqeLsCwoRbAWzacBQHaRdhfUhfuB5PS8wt8Zw2b6H4Cx3	14704	20703	20703	1619665740000	pending
29841	3NKJH3PSN5zooQSb9hjeSCMkxkeZSFonuCgivM8cTBSVBFgHyqLN	29840	3NKM4PWvQfcgGHZzndWNZyZ6mNJzZa87Ct7ysth8h5TVD8HpNuB4	1622	1356	595	12463	18974	jwi8dzX6cF2LkWJyQpdfADf3P3LvXJEfPGCm9yyRd7XR9qG2gTm	14706	20707	20707	1619666460000	pending
29847	3NLByy59Z27E86saYPUDzafe1BvkCUKJSrpXxJTAVyDhMzjE1K4J	29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	1403	824	595	12463	18974	jwZ6WamdMysr3y1ivr7xZwNykMWYRvBgkioHGUw34XiZHsxeutd	14710	20715	20715	1619667900000	pending
29849	3NLoLKME3CGnZHR7TPhqrxx4sgAqUfLS1u8CgoihsD1nuWTNXVaS	29847	3NLByy59Z27E86saYPUDzafe1BvkCUKJSrpXxJTAVyDhMzjE1K4J	1407	1395	596	12463	18974	jxWDnyGKwqjWX7YG4zKHA1WL1SuWKyp762JfK57u5BauoSBuwZ2	14711	20716	20716	1619668080000	pending
29851	3NKm9M8Z3zYeAbeNL71tHPqmLVaVpiYUaCmHs52b8Q63it5mkobo	29849	3NLoLKME3CGnZHR7TPhqrxx4sgAqUfLS1u8CgoihsD1nuWTNXVaS	484	1319	596	12463	18974	jxC5tnsLJFJ9j8T5bn6WJ4ukYUrLngaJHpxgUPM1HjVsZDy7q1G	14712	20717	20717	1619668260000	pending
29853	3NL2EVQBB6zeLR4tWqkdh3KqefSM5yqx2RJ4iDZrVEovShtYjFsb	29851	3NKm9M8Z3zYeAbeNL71tHPqmLVaVpiYUaCmHs52b8Q63it5mkobo	1451	1046	596	12463	18974	jwgYDx7rovPbzaziXvJkYTVpcrvbKFotwJvF66ffaRUELcPR32e	14713	20719	20719	1619668620000	pending
29855	3NL8cVdsnRQiLYpw1pkQ9dqwgcgAgDPWLStsRDwGg4QbBj4BPWe3	29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	1407	1395	596	12463	18974	jwceaMh9Cx2wWHoVuA1UJJqhZxjSvZXdTrPYhajZ7i6PYZ5rKT6	14715	20721	20721	1619668980000	pending
29858	3NLVZkkzPF7Gr82nXnnLcBoRLYbFapCUHCNeVHPSKPRPtRenRBGB	29856	3NK97Xj1j6ufSdqQj8u5LPUbYUvQABFCjoLxhxP5KJDtxj1BqvTQ	1622	1356	596	12463	18974	jwbBgS29GPD3ZPPtWQizz2voT8NbXabnZNoYSXeStt8xM3MGM3d	14716	20722	20722	1619669160000	pending
29861	3NKYTX12NzCgV7jwydiGJHwrR4pKZFih1Q3KqNekSkr4C17ZdP5r	29859	3NLZqkLXoUd2Mm9hu11kp5JDvpZrrDn7Tb3weYvBbNgqK4EEuV55	1673	1368	597	12463	18974	jxWRi3gLN4UyPqah2mLYTSquD1RHm7NLcs42j4FpA4qLAPkBsDR	14718	20724	20724	1619669520000	pending
29864	3NKsf8SbuhXyEPu9pvNvQa97qN3gBfdSYhMhASV22gujRfkbD4Dd	29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	1600	1006	597	12463	18974	jw9Ntf8g3czsEQPRLBk1uWWTdFVAbdSQbCihJU3LkfoBv2BgZe9	14720	20727	20727	1619670060000	pending
29866	3NKdKnPeGb2oMDmghYztk61mX5NyguJ2h76kkShseEkP1xAW98ZV	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1527	1047	597	12463	18974	jxkeK8z3XyZbzU5PxUdVndJzMieL5Qx4kavou6tN6CBdGTP4xKv	14721	20728	20728	1619670240000	pending
29871	3NLxxedUxyLGjqTNPm2EtECUKTSeogFCtKNwpYqunmdxP2YQUqJx	29868	3NLd1FEfQn1MPkZDpc6XDCDsJ5XjjygKHLQaSS87Siu5LAGhRXj6	1422	1337	597	12463	18974	jwboKR7pTZkDX7JXvXErMPWJu3t3KHCDNhkTWr3U2x3GNT8cwre	14722	20730	20730	1619670600000	pending
29875	3NKCUXHdDMsUQW9QEfArjqFbkzG73Uv3hP7D9ep2eBcCRMSBZEqu	29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	1439	1033	597	12463	18974	jxX1zCmzAFiXeDCJxciRPdgoKYq3SGF2VJPYUNLMTN8T8pLYqV7	14723	20731	20731	1619670780000	pending
29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	29874	3NKCiLH6prszaTpnVmAvnjVe8JgCPaJnGHZ9SuEyJQoMwpg3aeSd	1588	1266	597	12463	18974	jwqfwnxhW7g7HofXGn8Yqey3S2sG2rmxR8ZCodddbuEKNEFHPWw	14724	20733	20733	1619671140000	pending
29879	3NLmsNwngxhH2NbS3YMG34dqd42gApdv8TeLU5a7CUeLWjBPLKkN	29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	1406	1393	597	12463	18974	jxyAxYbyteWXvze8YzsGXPFLAFkCgTf9MN2PjRGqYFB51kJAtKV	14725	20734	20734	1619671320000	pending
29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1547	1012	598	12463	18974	jxPEVpxt92SU6gBky2PGJevptBPFXKStFyC5MX3t4QkBmB7YbT4	14727	20738	20738	1619672040000	pending
29794	3NKtVYvXjwgp6QhEXUANjxio3rjJKg6zn89jWBMwc6EZVPXFYd31	29792	3NLMX3cFdJW4pBL3ToU35axP7P6zeaoW5cq5XyHHr2dCH1VUJPZG	1624	1334	592	12463	18974	jwu8qtQjQSSTbNyT2VmQgLHnKJsNc3fHKnr3pUys5gyUFEXPokP	14681	20673	20673	1619660340000	pending
29800	3NKtzMSaPyxcoQrJjJVatsCZBurukzC57f4QAkxRnFtD9cisrgH4	29757	3NKQwUYUtTxNT4AnhfqFRK4NmVRCwyZGij5GcP71KS7RZrAyFDVt	1490	1148	589	12463	18974	jwSbUixaDkgKEXUAzSHs2uDT69bhL24vbX8T2aGDUidQcEotqPB	14667	20678	20678	1619661240000	pending
29802	3NKuszyx4YdhJLaeK1S3sxm5YmEf3xHGbybi4A6nU6huJbMYgFZS	29799	3NL1Y7LtjmNSbCbZpysAxz62AZYibiSfr5Hiqqspt7AJnSwnmKP4	1402	874	593	12463	18974	jwCujxXAcdQSeu8Ze3MDnK1dp3ASCUi9gCmGdNkAksVwV4dMdVW	14684	20679	20679	1619661420000	pending
29811	3NKa1Qw7f4EVyzy5AmsHKUUKNAhK5KELdfbM1qCRdU5cYYWCdcJU	29806	3NLmTueBgJYB1dheLBPJS9eSvmACVhUd1CGFybE2HgkB2sGca9q2	1619	1275	593	12463	18974	jwALdAJSUaAGRzk3hnN1ubcViSmV6zrbysbXncHtjav9PgjP4Wb	14688	20684	20684	1619662320000	pending
29817	3NKqJ4KzoVV5EyJUdxq1UQuTdE8nBXh6FNFyadvVvGM534g4P3WH	29815	3NLj76yuDCzmzfCWUTC8vemroNuCVpzSBW7SzLwqd1676PL6dX89	1407	1395	593	12463	18974	jxFugyNpUeZtG6MqtdVAJrnM2duAeXczZHdwmhpxu79pvc3Z5Bh	14691	20688	20688	1619663040000	pending
29819	3NKyYtdGj7rccnBptyjK8pYYVRAeK1dmDpuMbPXKwoCCHjWifFJ5	29818	3NLMSbxpNrDCcrS5NezkSxA9hS51U1gWZmG38B7t6pmvetegxgUE	1406	1393	594	12463	18974	jxdeG53jE49DAXwvRAZVK9HBrG6cLhkvLcvNqrKixfBXRSfdqbP	14693	20691	20691	1619663580000	pending
29824	3NKPjfAxceDtZtKQbXth9KRfnCZoa7edwCiBE2QrEbheNcreKZvG	29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	1527	1047	594	12463	18974	jwcEwiDNQc5XkdwdJ8ZZuSmDqzJDYKhWubR7TfAkH9e3bMi57Do	14696	20694	20694	1619664120000	pending
29826	3NKte59rsGoF7vK23LziTy9QyKqENbvBsntChef4a7Kzah5YcbCe	29823	3NL2UcArMp1FeiFx3itUE4qE8yHT7cZ2thjTsGxrjjCmycyWwuRz	1527	1047	594	12463	18974	jwe71REYXGpwxQRCqZMRN3K5kXpCJ73G7ZUw3Mynu8VLBHa4RUx	14696	20694	20694	1619664120000	pending
29828	3NLL7edpRUigzSU68W9Kj6rqgP8rdQvmKsnxcv4R3Xsv1QaWozmK	29824	3NKPjfAxceDtZtKQbXth9KRfnCZoa7edwCiBE2QrEbheNcreKZvG	1596	1363	594	12463	18974	jwULhy1KLH2X65FePw7KqQzjtZYewLQBGwJPsuxSfXATk5eb5Cq	14697	20695	20695	1619664300000	pending
29830	3NKzoRwUDNLUSck9ZvYF9VG7ErRiXHKMcNGVVYGJgZUi1WrjWMGR	29827	3NLvavD6kve3jaqMsPwPufTSK6Mr2LM1H5qqk8RjfwCoP9XPBhBd	1624	968	594	12463	18974	jx5CqvFZPd66iegLrn4ezrKSdMLr3swujj56H4WyJSc9TkQBhg3	14698	20696	20696	1619664480000	pending
29835	3NLvTuN92b1vGfbZkyRMZ252zimM7tmRT3ub75hujD592jPnTrKz	29833	3NKjrSPAYUSpd9yUYSGaXJZdvg5r4Yn5ygc1CNpCTV2p76QDF14E	1590	1174	594	12463	18974	jx1RVZqxMUzWqjuA1KWu6EsEmWHcChdep3FfSaBKmWexdLkT8GM	14701	20699	20699	1619665020000	pending
29843	3NKmuuPsuv34zmGWXQmkXHosYwwTshwRN9qGUsz4J1JFfpnYGarN	29842	3NKi9dbCuBsP3Ea9QVW5ivamqQKsWDRV2Huf5q9hfFpEFZQZkcAS	1553	775	595	12463	18974	jxy314BoWmqUyhVJwW8hN6nSenJWcmBG4gXvyAHkk3YKDcUPwaN	14708	20712	20712	1619667360000	pending
29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	29853	3NL2EVQBB6zeLR4tWqkdh3KqefSM5yqx2RJ4iDZrVEovShtYjFsb	1471	1140	596	12463	18974	jwh53wK738yZf7D6F5xPYLPkMYhu7k4okdJT6VUqSTcoGNwKEdm	14714	20720	20720	1619668800000	pending
29856	3NK97Xj1j6ufSdqQj8u5LPUbYUvQABFCjoLxhxP5KJDtxj1BqvTQ	29854	3NKtj8XK8HmKVfAJxkioPkPU2hWHLQaQDBfiDTYDE1JKaNLQPAQT	596	1180	596	12463	18974	jwrdv8D9FvnMj79qGN1KRtM6WNARJRAiXpHDm5ecPinV5EirADi	14715	20721	20721	1619668980000	pending
29862	3NKqL6u5XKyxypfPMJW5aJTuqSA1ZfANuZyK1FDhL4VgxVkjSCmw	29860	3NKRQdeXikKqcKTEJUuuwjmp5fP1ZivSUhVcJg2nK82Xn6Q7nhkD	1403	802	597	12463	18974	jwcLogyL2jxyFsAwS7bgHvHcDCQJcUajVaKi5ay2XCHjUFaw4gy	14719	20726	20726	1619669880000	pending
29867	3NLSxffnCjqGo36o7ZASHQeF2FvTwRPRnr8VUvzvDFykiaiJFJq7	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1527	1047	597	12463	18974	jx2fCRGXgWz9KmU5jeALMCGxKPsHDdzREKEDLtvHadV98zdBApz	14721	20728	20728	1619670240000	pending
29873	3NKTenmTEkaBncNbBxrdSjvezRjGVa4a4yseAbaN1TP1f9tKLdFg	29870	3NKKyPeo9bjEocCF5Lch4C4C9KjhYiaeTpz58E6ECCEzFuKJSAsv	1439	1033	597	12463	18974	jxeqhZ5HEGKZns3ALvDrBath8sRypNFXnTX9va8AFz5UERbovtv	14723	20731	20731	1619670780000	pending
29876	3NKgLpdzKThUtdgJoiqENopinikgNDH6jtbzbct64Sc8NFy732mH	29816	3NLYS8GjLApbPg35SJfWHPJZfb1Td9et2JdZddt7NR9xJqmGntCT	1439	1033	593	12463	18974	jwTs8ZbNTC2WH3N89pxWTVep8QoXoPT5qaj61fndRGXCmKDYCUh	14690	20731	20731	1619670780000	pending
29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	29880	3NKu9x5RybQ3CAW8LQn6XeQ88PM9ioBsUYrG19USEhPhZLZAo3yt	369	1312	598	12463	18974	jx88mzLk3d21xKz4rvZDixZAYciF7jbzBpAdh4B55zVhyEe1Vrv	14726	20736	20736	1619671680000	pending
29885	3NLB3GHAvj5SUVH9mqXrTUynzNwt9HVr9GxCmQL57JQhYDac4a9v	29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	1407	1395	598	12463	18974	jxW56DK82iE4mB4N8mPWcNkv6Zv166x1u9xJQYN66K5XYFx6gsX	14728	20739	20739	1619672220000	pending
29892	3NK59Vh6XVtKptKuta3GjaUCawFqJ7PbV8bN4GG7HZyDCBA3ND9u	29889	3NKkwUGRaEtkr2ZvBG86ANYCLnZN5WMCuxRGFAyUSKk8EeuBWz4X	311	1307	598	12463	18974	jwXHFs55Kjf2ci51ffNvzgNmwwaxXUQhojrhMND8WpmNWygZz8A	14730	20741	20741	1619672580000	pending
29894	3NLwXiUcApqwwQzFdmRwYssBKoMMdpEg33ajpVwnzw9s8fmNZP1k	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1527	1047	598	12463	18974	jxNuFEufZjTpscQGLwv8yYSTYejA1jR1bcZVtiTr1mqodEV4FJi	14731	20742	20742	1619672760000	pending
29898	3NL6QMZSH4WqZD5zPQeijLG65ASfRtkbcNzwxtNM4UEnrycZcZ15	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1407	1395	598	12463	18974	jwBNpNE2zopS58eH1Xr7K71gXRspatNwzUjE1AMrE3RHYcGywsC	14732	20743	20743	1619672940000	pending
29901	3NLw6qqeJtz37QrZz44s6r1yWtjHGTLHiYyi8d1RKsW12GSEXLVZ	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1624	1334	598	12463	18974	jwtcZ6hLHTqGQYL3Ln8digEya5f6vTKiAsKqxDh38wUuCdrtdgn	14732	20743	20743	1619672940000	pending
29905	3NLtwm1URHAtv78CzvLNoSKnGFNagFMAhLKK7FEwpJb7g1mX19B3	29903	3NK6f4VFsjjdU4yWkdJs7iD4D5NuKq4F6mHQtNgLExeZ5ZD7rLEQ	1675	1342	599	12463	18974	jxrpp8kgYcHR44NyYSEyz991aGbFAeh55MwPt4c5JrRiaUWmjSe	14734	20745	20745	1619673300000	pending
29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	29904	3NLHNqrwdyfwLKGa65w7Jv79tWzffYEoQ7Y1YnJQLCHstCnFN9e8	1481	790	599	12463	18974	jwXA5rNLen5yuJ7k2XiGBB3B31qM1qSWf3RoFreJusbz3LyTE2Q	14735	20746	20746	1619673480000	pending
29909	3NKYpCDZedpb53cE54S4ohibT7tkhGUZJfTZK455tjS7PMy1W3rG	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1451	1046	599	12463	18974	jwW4rVxFSkSRdrbPWwSd9smSPL8Viip2MbK3kPDjsY5neq9BA45	14736	20747	20747	1619673660000	pending
29912	3NL9nQzwhRmwLzEtTZVP3EjyquB7X3UkZqaHiJYByAeWgx6MV9VF	29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	1419	814	599	12463	18974	jxfyajs7xkMWeHCThPqRVDmQeMA2as1LKWZZq6WZuFt54TS7Rvu	14737	20748	20748	1619673840000	pending
29914	3NLZfY7UJuFXR6tege71HVk9pKgJZ5S6bZqbviFgEq5hQZvJEUWj	29788	3NLMGGidcFPRyvyasLRNDqz2jwE1w1737M7eYpi5VREgRWRZL1oM	1419	814	590	12463	18974	jxKiNax4c3nTyF3uwN6gBgZyn7zy5eA1CKwd15YwXSyQ3SAzMSD	14668	20748	20748	1619673840000	pending
29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	684	1226	599	12463	18974	jwE5nKZFqos3rPqLYVSdqEjscXLJW9pMungcVW6hNgP8xMtZRpz	14741	20752	20752	1619674560000	pending
29927	3NKYuKh1twhyn8eH6xWdVNzVxhAmeVyFumsi7D16oExSE79qcHqM	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1460	539	599	12463	18974	jx4B6VvaoB5XiRJBGQyemwfSbCTUC9EXAS6cCsepT7y6GKbohxC	14742	20754	20754	1619674920000	pending
29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	29925	3NKwmKQzjg8XxpDbtVtjsx8uPLaGPRN1X7QSkeD9bzhLuFkSLgde	1500	1051	599	12463	18974	jwvaLSixfEy26vf8MuddotxegXx6dZV9irMhrcVYcDYryMkhEJw	14743	20755	20755	1619675100000	pending
29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	29882	3NL1p2LmSvYuYNsodcrqK3zCEjCHrMr5KxwVCA7K8ixcs4oHKB9Y	1553	776	598	12463	18974	jxnGBeShFk6o4hANR3m9KWpXXwtLJsGN2jC3oaaBdi73kms1huJ	14728	20739	20739	1619672220000	pending
29889	3NKkwUGRaEtkr2ZvBG86ANYCLnZN5WMCuxRGFAyUSKk8EeuBWz4X	29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	1647	1056	598	12463	18974	jxUPqLZU6aEHwsTmuKWqUJs6fYw5jo3AZtLMxjQZaRQPXzhucP2	14729	20740	20740	1619672400000	pending
29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	29889	3NKkwUGRaEtkr2ZvBG86ANYCLnZN5WMCuxRGFAyUSKk8EeuBWz4X	311	1307	598	12463	18974	jxB2iEQz3u7DrEppe4kxeaLe6fjywtq8LeUML2sf6aRqWtAMMnX	14730	20741	20741	1619672580000	pending
29896	3NLwpNLh38ZBvu1f9CaJkkT2e6eVkqG9Zf5kiXr2j17pS85sV6xQ	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1602	1369	598	12463	18974	jwR2XzMrDKDNh8CUfgSsPaRbEjfeh4KvPPzTKw24pHhhtHxK1ok	14731	20742	20742	1619672760000	pending
29900	3NKUqUKB3xvGEvEUUmskapcA7KxuvdzM1eTg8Rnv175ndTZoePRC	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	596	1306	598	12463	18974	jwmkyfq2s81rCVKsoBfJmDJYLFQ1eAS31bXb4esAZSgUWjTAW8s	14732	20743	20743	1619672940000	pending
29902	3NLAbka4tTcTLKbZjUj1GSUbfah4XsxoqppeAgFjG1ygjdGNzHUh	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1624	1334	598	12463	18974	jxuWegh42yGK5P8GcvdwDhB9WaDHtTyuzUPsN1Qv1NdyWwDcAEN	14732	20743	20743	1619672940000	pending
29904	3NLHNqrwdyfwLKGa65w7Jv79tWzffYEoQ7Y1YnJQLCHstCnFN9e8	29903	3NK6f4VFsjjdU4yWkdJs7iD4D5NuKq4F6mHQtNgLExeZ5ZD7rLEQ	1670	916	599	12463	18974	jxNjkMby9787YQqkKG9bf1CBK9fZFRoDpeh3pgXbiwrC457D7w1	14734	20745	20745	1619673300000	pending
29906	3NLdz9BYbKJJZetTab5pjdStVLGeZNMSzBFYi5jrFfvU5CHAqsfD	29904	3NLHNqrwdyfwLKGa65w7Jv79tWzffYEoQ7Y1YnJQLCHstCnFN9e8	1406	1393	599	12463	18974	jw9AnVkvs9pTUK6NFT7CnnDAVqvhGkgZhPPRQFjzaa5RM5Ro9VM	14735	20746	20746	1619673480000	pending
29908	3NKbhDhSeHYthsLUmc1Be3vvREFjixWbBnJoqTRnLerUGHAhTVkv	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1451	1046	599	12463	18974	jxvJpYhvWQfSU93gyGyZRTRNd5YZvTH7K1AuDg6CmoSsEVLTcPC	14736	20747	20747	1619673660000	pending
29915	3NKGVQMHoj46docNsry4V1ngRhWUR1cbEzgrgxf82mQiEHyqx34N	29911	3NLDJh5Wzk4URYNUVbhDqRBwQwNwL3Xcbr5RUxMZvksP4ifMf1Uu	1613	1223	599	12463	18974	jwuojqaxanCRX72TGyedPeUbEFzLg1Hy8AvVKaYvqKNqhovKBxK	14738	20749	20749	1619674020000	pending
29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	29916	3NLyQZdvAedFpbV6zGireD33o68LP7xWgU9nB5eYovck7BtJmh6y	58	1281	599	12463	18974	jxMEihwRfjaVGwV1kDjYGzuBgN2fgZZZtJjyQNVBus789pMbEG8	14739	20750	20750	1619674200000	pending
29919	3NLqBJ3MwQeDkmPEHseWqhTyMhvN35MJ6xtzuJTfQrFe559f3dSh	29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	1406	1393	599	12463	18974	jwiHZTTEf8nkenQXnDjetzAHZnokTbG5opFfBWmELxeRrQG8MWf	14740	20751	20751	1619674380000	pending
29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	1581	778	599	12463	18974	jxhgFpe2KKXQrURcqiMmEBC1K9rpAQked7XY6qee688abRNYLb1	14740	20751	20751	1619674380000	pending
29923	3NKpfxq23j3riPn54MUA4ZJoZvyXULSova43kvaQ8e6Foj6yvGQV	29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	1406	1393	599	12463	18974	jxqUXjsWqyKKZCj83Sc5whu6RAiAZxXxvMXt2DJEz4GAZsJZt1f	14741	20752	20752	1619674560000	pending
29938	3NLdkqoTgdAEZBEonnDnDwpwdQs67QsmS9qVnLva6tC2ribJw4y3	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1527	1047	599	12463	18974	jx8K8pcHeskBkZ6W2ceM9mJZHgunhxQoaq8MSGLGsPdinU46j8k	14742	20759	20759	1619675820000	pending
29940	3NLXWJUqL8TmQodYM9Mi1o8WxhDwJmMHxbtjBVMei4XmBufCy51g	29939	3NLkYAucMi4oyVrmroq9fLaNjR9TcTCXBtwFNyMFC8YWWc9h19MN	1672	1039	600	12463	18974	jxLJpjdHPpivK9C2cxFxHaZbXoB99N3C5h5jSzKshMxQMKHT3w5	14747	20761	20761	1619676180000	pending
29942	3NKabg6ApBecPUphUzY6LaPxpP11HN3G7Z2TRv1APFVw7WRVzDyp	29877	3NLWRWCsHErnKFKkuADKVGUHW6oJvT1Lna4g2BJxLwomjWguSPFc	1672	1039	597	12463	18974	jwYn4sfvVnqqTxpPjiRd1nH9y7UWujZSd528nn1pVhfzVQpeopE	14725	20761	20761	1619676223872	pending
29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	29940	3NLXWJUqL8TmQodYM9Mi1o8WxhDwJmMHxbtjBVMei4XmBufCy51g	1507	914	600	12463	18974	jwTisWVpk9QkupVN37v93ocDUnG2SaxfEMzFKw3SPbDcTZXiwHH	14748	20762	20762	1619676360000	pending
29946	3NKJjxnsaByvnTKKx1rihnA3eSnH1DHVXWLLZPLgiDHzLZ8JTGsH	29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	1670	1036	600	12463	18974	jxpLUfrBS6Qmuck3BtF6EQyVZjT29Y4qJJJNDSNSNCykT7xodwH	14749	20763	20763	1619676540000	pending
29948	3NLeMXSJK2yiM5zxSGCG4mv13tqKWTSc5pcBA2uhfXJgRD1nWAYQ	29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	414	414	600	12463	18974	jxBFxNuojDywtbfFh4qdLHmRRSDS3qrPAmV5w4s19sM48WYcH43	14749	20763	20763	1619676540000	pending
29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	29954	3NKPsjP1to1Jg1ut8JSr6hCbwDam3UJQjPcvtbh6uV6GmYBv6od7	1559	1107	600	12463	18974	jwcWjLEsD36Bk3xDzToTHtzKs6RxxZF6Y5qUCzjc8YeWSeCZwVG	14754	20769	20769	1619677620000	pending
29958	3NLQQfuQUZMGivPW3DPFgg77X494onojDHaXPQ8jK9thLGfRSqEN	29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	1406	1393	601	12463	18974	jwCzT1NwafHzU2SL7vTPGX8FduR3jJW5eb1q93HAFwbt2Tjm5Qw	14755	20770	20770	1619677800000	pending
29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	29959	3NLU79ozLzD3L5Xq2aRiEgd9RJomox8qEScyePT2kzQEUx6YMSEn	1483	1030	601	12463	18974	jxafBbNPRt3JeiLFPa7toiM6YLMx646T3qDGMGsiviqcSnEkB9v	14756	20771	20771	1619677980000	pending
29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1405	873	601	12463	18974	jxES3pDD3eV1fHGkE3Lde2VJajxAUnHUcpjcThHZshH6Wiut9qj	14760	20775	20775	1619678700000	pending
29973	3NL6RYKyt7X3Zk6mjMpmswNbbNW9DKmGmALvv6yYCTsERAnbSiKt	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1579	1023	601	12463	18974	jwq8MszvbgQpcEiF4HKAZPgn4i877Ymx21CtvaH1a3bJv78zyDs	14760	20775	20775	1619678700000	pending
29975	3NLHt2CTgtFWBvrzqY5Mugdvi9MnJrw6VBD73nEnx8Dp5Q4qrTNa	29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	1560	1045	601	12463	18974	jwanxdMnptzMpunmiok37iTick2FzTTMmK98Lwdy3TLGoKuAynE	14761	20777	20777	1619679060000	pending
29978	3NLKH8ecDXo4qg3SFR362997hsNF8saiBK6MPe9RSntJbnLFjJMe	29975	3NLHt2CTgtFWBvrzqY5Mugdvi9MnJrw6VBD73nEnx8Dp5Q4qrTNa	1406	1393	601	12463	18974	jxCVJpHYkykKq69KpXj674qoP6jeE5UtcwC2DJyBtPcb297ZE5U	14762	20779	20779	1619679420000	pending
29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	29978	3NLKH8ecDXo4qg3SFR362997hsNF8saiBK6MPe9RSntJbnLFjJMe	700	832	601	12463	18974	jxsyQJkotiPCeLvohj3FcsamFkERNx8MvAXjNve9v1LcFSVTdkv	14763	20781	20781	1619679780000	pending
29981	3NKCrMkSLq1EGJ7dmqUzzzqaGbY3NxpKamutGs8U2zj3JLV3R8QU	29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	1476	1371	602	12463	18974	jwTaZDrCRjKi3qobNjB8QjPBtgKMLiqQ7zweL82789S2GGFhAjb	14764	20782	20782	1619679960000	pending
29997	3NLWMGsGrrJLEBSct8sFPQ8R5qR1jFUUwq8fXYk2tJKZiZMRW9BF	29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	1671	1365	602	12463	18974	jxh8HTVuKfWGrt2jN34Hg2yHeWuFe3K8kGbD4KvtvLMcE8GoFUb	14770	20790	20790	1619681400000	pending
30005	3NLTjhoynE5NfpFk526qGB8fBuyowXzqpaUgQ95BP8uQ75ULrvLX	30003	3NLr6uN6z4QpNMVzwW5EDMhhBPbk8cwUNhtK2CSBsu2MYJWrUoXr	1602	1602	603	12463	18974	jxe93NYYmNmbrre5EJe5nNCsMg5kSwPdLoy8LxTp3xTnZ4aVyWH	14775	20797	20797	1619682660000	pending
30011	3NKtHSnQmkDKfqtio2VkUoiic7x16uDhhyFisNTibApTTz64GM3W	30008	3NKGA4waPvVkECxVGJ4U9bNS5AmxiJeEcSDqZ9SF8cfTFuDX3kD8	1637	816	603	12463	18974	jx4rBU9b9yZiDfPC22e3Ngk83PrxEoswpUBWtdFnXjGWJ41CjpG	14778	20802	20802	1619683560000	pending
29888	3NKTLS8otFYHzgDusPFSe5RmjEyHy9utNyeNNea2cQ2uNThFvspK	29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	1406	1393	598	12463	18974	jxRzCZpgaZYPEE5zzX9b32TTrKVqNAenx1i55gbxHD3BAFjD3F8	14729	20740	20740	1619672400000	pending
29890	3NLUc9DeBx47vv6GiDG1WW3LCsLPtcE197TDEa8wNzciZKvm7P8w	29887	3NLXzfhiGNVpVxgv7Xh1auo9byh6rziVCLkNQHgKCGfhZsUbyqXy	1647	1056	598	12463	18974	jxNXGXcCFeZbyMS6ZdmSSR4Ro3f5cxhg7LXzyYbpBd9acEikQf4	14729	20740	20740	1619672400000	pending
29893	3NKCzPUZd4F22nPy5A2vHuMpt9m8FjtVu8QbpPN49XmYrBafwyNg	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1527	1047	598	12463	18974	jy2DVP4JvRNDabU9zVP5jRznyN52TZU977NCe1Ynwwif2tyTyvy	14731	20742	20742	1619672760000	pending
29899	3NL3pD9vdybCkW9bQ5JvZPWosMFNXxbSkegyWcMzsNPuHneZia4g	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1422	1211	598	12463	18974	jx4YjqqA32PVdRn98TDcpt4MjP7S3b6YnSttx1H2irtx1DXc2Hf	14732	20743	20743	1619672940000	pending
29903	3NK6f4VFsjjdU4yWkdJs7iD4D5NuKq4F6mHQtNgLExeZ5ZD7rLEQ	29900	3NKUqUKB3xvGEvEUUmskapcA7KxuvdzM1eTg8Rnv175ndTZoePRC	1447	1099	598	12463	18974	jwsSHnnqCdjYf8rz4KiTrPvk9iMTvyQaFGdCAtxFiaoteMtkhfG	14733	20744	20744	1619673120000	pending
29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1451	1046	599	12463	18974	jxSgHKNVmEmrD78AkRydVPNe5SvCwY3TdXn7oZmBK7xW1RS2Pcp	14736	20747	20747	1619673660000	pending
29913	3NKbo38gN6wSyLXNYG5F4Pj7zyucikib8BiTq7XuzLWDvtPJiFu1	29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	1581	778	599	12463	18974	jw92FJeLaedfavDt8nTi7bkvSo95MTvhHmKH84kWwn2BpT6JPgu	14737	20748	20748	1619673840000	pending
29916	3NLyQZdvAedFpbV6zGireD33o68LP7xWgU9nB5eYovck7BtJmh6y	29912	3NL9nQzwhRmwLzEtTZVP3EjyquB7X3UkZqaHiJYByAeWgx6MV9VF	1613	1223	599	12463	18974	jxZ61aMRXUpdxF646DmcMYdkuxZ3QZ6Ay6kAdUvNF8wt58shPiu	14738	20749	20749	1619674020000	pending
29918	3NLNiA3vMwuaTRdEPd7SssWV4QCoewAoyVhNMgZyofTeETdzkGZc	29917	3NLD4euvCuFrqwKXAcZrboEertfJ9wA15WVtTRuW4r6jgAAG4XL2	1593	1346	599	12463	18974	jwUSNKePcK3qjdh2bt5Z8xMV8rZ9zN9wxD8WppU6a48DYaURFSR	14740	20751	20751	1619674380000	pending
29925	3NKwmKQzjg8XxpDbtVtjsx8uPLaGPRN1X7QSkeD9bzhLuFkSLgde	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1460	539	599	12463	18974	jwwtuQnAwiYpCXsyJH8pVJCWaF1bm8MBiWgz2EKHTCu92SCcDmx	14742	20754	20754	1619674920000	pending
29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1460	673	600	12463	18974	jxLHEhnosgB1Zw1ZgkBSDWehG27sTD4jAsZ8hp2p8pcRW8zQfK5	14744	20757	20757	1619675460000	pending
29934	3NLbWbm268S9duB8eyNZCagWrmL4TL7c3J495x6KxZgo441pHvZP	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1527	1047	600	12463	18974	jxvhp3JKiW6YqMvKQB89tMf2LtbxzXKY728saZFaX7FDVN3LJv2	14745	20759	20759	1619675820000	pending
29936	3NKczHwtNYwRUebJPZquduLaLQrsnLAAQj4XYhTkNK6gkM5aYzrc	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1527	1047	600	12463	18974	jxb7FvevAmBdspwosx4D1HaXFzqu365wRto8MKW1dY8YmAiKjsk	14745	20759	20759	1619675820000	pending
29941	3NLHqST7Bz1aqFJPvMaJF8h6cY7KwPs9Zxte6X9GtEcxkGnsxBLo	29853	3NL2EVQBB6zeLR4tWqkdh3KqefSM5yqx2RJ4iDZrVEovShtYjFsb	1672	1039	596	12463	18974	jwh5pvgxoTw9TsSN1gXYv4j5k3GzQvLsxEZuut7fJf12ZbVW4CB	14714	20761	20761	1619676180000	pending
29943	3NLRW19fWYBmky6ruD1hA7FDNBhU7ahEAW4gNUKtRXBPbC7azyg2	29907	3NKeVFS5fT97Aw9a9DzMZ6zZF3qeEvzBcADQePcAszdqVEHR9UXc	1672	1039	599	12463	18974	jwpCpbSecBYmr7NwtL6cvhhkm44gceypFumsPWSc27ucehJHU6B	14736	20761	20761	1619676270320	pending
29950	3NKr7nzcJmLb3Yd4n2sqdmn5ELLNuM3L7oXuhEykLc3oSUi931H4	29949	3NLVrZQMyKDo76UtRvQ6LFx3E4boa6p2fZHXGco2xx7zfyGn6zdW	1622	1230	600	12463	18974	jxxpgD555ysgxj1UVzip8HqtbZVMRXskQRhsui3ViBWWrxAz3L9	14751	20766	20766	1619677080000	pending
29963	3NKfrFNp8qQy2bQcQhzaaKR1UYCmHoBpkyzk742EtB3UJ2PrurD2	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	43	944	601	12463	18974	jwCwVnBDzr1T4ytANEeTsMeXEctWGX9doeakmu5YM2pfi3PAxsJ	14757	20772	20772	1619678160000	pending
29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	29965	3NKfTrmQzN6iQNPzkszy2fBPwr5eTjYH4WteNipicLwqomS2heQy	1587	1111	601	12463	18974	jwsVw3WagsSCRpp9A1nL7YkC7rLGDA6SyZgZbRfEMSidHt26HCJ	14759	20774	20774	1619678520000	pending
29969	3NLufAEhgDHoMn5keUGFWw8GWfkX7LGNpxv5dyeyB4RhVnp6g5ej	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1588	1026	601	12463	18974	jxx6W3XYbxuHVLGQ3HCMSsmtpYRwXTzLAePQDvWRJf3bV5GWWjn	14760	20775	20775	1619678700000	pending
29976	3NKw5qj9aezk8chRdTrnsNxZsWrZBESVacZsEpNDzgtZwPKPSPkE	29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	1560	1045	601	12463	18974	jxw3JGShHbtkWEbhjrSVen2NXG9D4S2BQWYkkHZH6fxCkGvsQBg	14761	20777	20777	1619679060000	pending
29980	3NKdb6nazespoTyX3uavWMiZTYyjp1ktMcFpLaVDiqGiseRkxnPY	29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	1406	1393	602	12463	18974	jxSsH7s5Xwr9RunGbMR7P6h8xMjPdBri2HuXePs1UiRxgzRn5tv	14764	20782	20782	1619679960000	pending
29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	29979	3NLUEQ1t5hvXKwFr74kKT2kWaRBPdF5k5GSHCPYkc8Nsp8Gbo1Xp	1476	1371	602	12463	18974	jxDUTsEUavkoZisXxbXz78bkbFdJJLWqcivi7HxhdcwkBXediqu	14764	20782	20782	1619679960000	pending
29984	3NLH38Sb98td2pDMfA9Kir4Fty45XGjLrVJLvZHHdRUQiZ8vd4y9	29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	684	1106	602	12463	18974	jxfjur3KrriYwto91qRfGqT6jNFbGfSUTdrdsRm13Lygow4myok	14765	20784	20784	1619680320000	pending
29986	3NLPVHqg1KTKDNtsEWSrCNjZuGwAocQnHSwUmZBuVtj3gPNCZC7H	29949	3NLVrZQMyKDo76UtRvQ6LFx3E4boa6p2fZHXGco2xx7zfyGn6zdW	58	149	600	12463	18974	jxiF9dBo4Z13AKfzE6wyJwf5tixvJ8oiFa6bzwzqLfja9JxJ3Xq	14751	20784	20784	1619680320000	pending
29990	3NKdTfadMzuT2sP95bPUbsEe9UijUJBzHybx7KcKtdSYryJrgaDE	29988	3NLGDVqjyBbCawYpx77yuJ3phtGfQJXy8Tfwib8NdVX7NhsZJRjq	298	316	602	12463	18974	jx49WpQbRitDLsdGKQ3eFr1hc2Rs18A2mJFP88SghD6q4oUu1n1	14767	20787	20787	1619680860000	pending
29995	3NK57sgviqBVKVunMWAvhf5e3bYCvZjJsyx7RasxxgdCvfkbVtq9	29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	1397	828	602	12463	18974	jxSG67X1QpTN6cqz9reiQPWyMqDpcPxyMckpSCNJD6vQgyTS4tT	14770	20790	20790	1619681400000	pending
29999	3NLtEMwL4daHzGAmsxnu3v6VjdZmo2G4ujwJ8MCJaeG8ut8uL3L7	29995	3NK57sgviqBVKVunMWAvhf5e3bYCvZjJsyx7RasxxgdCvfkbVtq9	1553	776	602	12463	18974	jwgfp2k32syJaC1NiCDj8t9eTbQT3xkTLmQ6J9bEmsTYGQ9HnRN	14771	20792	20792	1619681760000	pending
30009	3NLqpEeaJ7hVducwgG9Q7JEVi6ixJPdZi4GvKDdM5a2RxZQHCkd3	30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	1460	1078	603	12463	18974	jxQpgz43ixV3RvZBKoRLEs2EPf2ACo5dmtVrGodeHpnwpFtQKX8	14777	20799	20799	1619683020000	pending
30015	3NKb4wFmu6zwQZWLPTDiGFMFMXP5DmXdd5WQB3FtGZUsT1vuX9cq	29844	3NKtUzv2gT95NpoTxddooV7RVNQnLJybtTVAHSEMoSUFC2hjME5p	1523	1195	595	12463	18974	jxakaHEey1BkLoMofKHmUsr5kupc67HhtCARKhvZUSFzHMaMzH9	14710	20808	20808	1619684640000	pending
30017	3NKpAc9BgXLtoXbqmYvJw2G1nYoJVmUgo7QVfaBu4uia5cCxEFT5	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1523	1195	604	12463	18974	jwm2pWHPsimSpbjCoHwidVb13wd6gVVcYwMQMcBy5zX3Hbr2KjA	14782	20808	20808	1619684640000	pending
30019	3NL7KcWSEnbvWwhZEqLsNKr6MmT9Ui4A2AmAs2ogjyke5k3sdh5w	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1523	1195	604	12463	18974	jxjZxKmSJSQP5RoNwUVQdB5ujbiqHieapHhYPPus2qxYjpuWx29	14782	20808	20808	1619684640000	pending
30021	3NKu9nF799KC824NaSCwapH4kHz3tWzbJj5oPLZDMjd7Fi2uRPYp	29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	1523	1195	598	12463	18974	jxj7pLKcp9FfMJbsqKiL4gsd6CKrDp1P8kCocPv2RVsLo196x6j	14732	20808	20808	1619684702030	pending
29895	3NLXFNbxNt7derdiizqpbT7o7H84otJaDoLPa6Lznd1JpnLFKAcX	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1406	1393	598	12463	18974	jxSaedxcRNMvTjqgKt8qLagw1oXG29ZPyvXsBGPmPAsfYvfaSej	14731	20742	20742	1619672760000	pending
29897	3NKG3TAUUNzgcPNHPXELeje95sYhgouMA72D2YzRGicv6JupuhBV	29891	3NLYNzUGCSZjNWCwVVvfEuqPiySxyLzmSiEC4Yrrb4XuEWCAqjNT	1527	1047	598	12463	18974	jxLRhoKjLGeSDUiC3qdJcUpV27ABvEGYkHrne5TaUsEMpLCc3kT	14731	20742	20742	1619672760000	pending
29911	3NLDJh5Wzk4URYNUVbhDqRBwQwNwL3Xcbr5RUxMZvksP4ifMf1Uu	29910	3NLftqrj6zWEjhaSzcmnfb4NGvkF1YZbdac1PiZ6bHKZyvDj3twB	1419	814	599	12463	18974	jxEtFw49TDjBLnZG9TWfgKiYbH39uZA2yQiYYeTpjA9ZZwEMeWc	14737	20748	20748	1619673840000	pending
29920	3NLt54wM7bkfDEi97Sr95oEM4T7PVPY9CQPYEr9z6r4rmrFM4GP3	29898	3NL6QMZSH4WqZD5zPQeijLG65ASfRtkbcNzwxtNM4UEnrycZcZ15	1593	1346	598	12463	18974	jxdqJg33XzxcRVVf5Vy1iH8WyAv2taN3T9Cc6tGdh9FBvF2xnAb	14733	20751	20751	1619674380000	pending
29922	3NK2xi4LcJAXGdCyzd6QaUxNNYFNpJnVKvT3ErQQ8nrDWS4Cyg4X	29921	3NKPfTvhAMFgAxRgz1SDiZj1bvxapuRCDE9awpFoGEWFRqwC6zNN	1407	1395	599	12463	18974	jxma4CaEmwUCx3GQjvnuK3cgewy9HqvwGyqz6atHJ6wovpTSkaQ	14741	20752	20752	1619674560000	pending
29926	3NKUMqLKUEHXPKJCp1fvY5mY15VfFMMsXpqDHNraCPvyR54QiCtN	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	484	1319	599	12463	18974	jwJQ56SQ3g7TjNQv3J4PQi5RMnt5118ZXoDtjRhSbSCAg6Vod1x	14742	20754	20754	1619674920000	pending
29928	3NLoJSNRTyApiWHTLpVwUiy2Z2iCyFS1XfVvrJJCS8Xafn7KkrZN	29924	3NL1tjkgm58xxNQLxCo5BkmWJgiB5FvdbwJdMygs6uS6Jo2y1m2V	1646	1354	599	12463	18974	jxoKsySdBYXhxyQMaNNkLB6GaQbS8FgQDVT6obpEyjKLimGB8us	14742	20754	20754	1619674920000	pending
29930	3NLpeS6Gc19pNo89bQucReySx6muQWaYdGB16fNPHF2Wtb33KNiB	29881	3NKg46dWQ9VAMWgU6Sn47wGH9v4T7d3gZMHQJitJWHCQowPDKHBE	1500	1051	598	12463	18974	jwQmYXSSLBuJ4BarsyoJJNBtC5siFHQqqVuYx7LrZEnp1DTrQrF	14727	20755	20755	1619675100000	pending
29933	3NKa7hqq3D2jBzSjWfaPgFe1MAtWpZBSn8TNeNrRzEYKHYQkeUcR	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1581	778	600	12463	18974	jwLZAbj8xPRcTH9Snn8aCYjFywieLSn7cZXuCr5pw8Ltdv4E5Qy	14744	20757	20757	1619675460000	pending
29945	3NKi8v5JDFVULsKrFve5ro7YGVNq4fvQqBQxj81vR1AmxLuoFZ2y	29940	3NLXWJUqL8TmQodYM9Mi1o8WxhDwJmMHxbtjBVMei4XmBufCy51g	1585	1240	600	12463	18974	jw75F5vA8Xj8PsJwF9CMLQtY6Tqx1A3Bo5NAmR4ju9mb9pQKov6	14748	20762	20762	1619676360000	pending
29947	3NKsFdhyEPt7gNHeGNyvA5kyvMLeY8S4PbPGjJW6htcrnPqeFQvo	29944	3NLnibHjzPzMjzTF1Ex5pAUU8UhDipyLQLD61RSrC5aMCTxvPsvq	1670	1036	600	12463	18974	jx2cRj3KuqDNAQd6Cvrp1LmJKvFQrq2gaXgFk6wDM5AtbyyPfz1	14749	20763	20763	1619676540000	pending
29949	3NLVrZQMyKDo76UtRvQ6LFx3E4boa6p2fZHXGco2xx7zfyGn6zdW	29948	3NLeMXSJK2yiM5zxSGCG4mv13tqKWTSc5pcBA2uhfXJgRD1nWAYQ	1581	778	600	12463	18974	jw8R5LvzxgQbNCGfd4QXyHu46BpyNwNq63pcfk7mknQ9zQ7vpWv	14750	20764	20764	1619676720000	pending
29951	3NKUkLJLh1jYe4J2WwLuWfCD5TV6y5MqwJMYHgeat91dNwwNNoaJ	29950	3NKr7nzcJmLb3Yd4n2sqdmn5ELLNuM3L7oXuhEykLc3oSUi931H4	1649	1137	600	12463	18974	jx1nWYvMHEAG95CbxCcjDqYLk7o4kEfmrobhcKf9NgEc7EjgwyN	14752	20767	20767	1619677260000	pending
29953	3NKjJdQY2EnLxsaUKGa6SP6SkazZGQbqXKo8B2ipynjjkYWa26se	29952	3NKMXTzwMYu3qGNhgRq7QUdp9ao8EFoa4i912zbFFDMiuymyNzX8	1672	1285	600	12463	18974	jxZomSfCGqCoaJCnza8NPmxMWNDQ45BZJbxDVx3FHCQyrTcHUcn	14746	20768	20768	1619677440000	pending
29955	3NLxgVL16ciQty1uADgTUDJ8ijxVVJsZNXGxdLCd9mgwLRpJuSwU	29951	3NKUkLJLh1jYe4J2WwLuWfCD5TV6y5MqwJMYHgeat91dNwwNNoaJ	1553	776	600	12463	18974	jxqd7WSEDXsE5HfQYv6fs5wszMc2vNvVwHDMjeMDQL5TANMSDYC	14753	20768	20768	1619677440000	pending
29957	3NLAgjey9YeSMRBHSoNJyEptZLKHoiTjFXsenvcveEK7pZUtZbVp	29954	3NKPsjP1to1Jg1ut8JSr6hCbwDam3UJQjPcvtbh6uV6GmYBv6od7	1581	778	600	12463	18974	jx3bVEuoeYRhd6tV2NvGuobmaXGgn6WggayQk68wpmGcpZhjFVM	14754	20769	20769	1619677620000	pending
29959	3NLU79ozLzD3L5Xq2aRiEgd9RJomox8qEScyePT2kzQEUx6YMSEn	29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	470	1063	601	12463	18974	jx35T2Fm1tY3n3asvUBLP8sqwFMxtG7bm3JtudfFCBYSwfM3UjE	14755	20770	20770	1619677800000	pending
29962	3NKMQyank4tJF6tBRFkdhrXvJGxLameYczvD9h7D1AVU96eYE8CL	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	1403	824	601	12463	18974	jwcp9gPC6fGimEZzzxmG7TLvvyM7D6KS4xaYPQCGtDjrrPAzgEr	14757	20772	20772	1619678160000	pending
29966	3NKN6TSne8Wg5PJmYxXphppNRL5DFN4x13WvmKHQSo1jvqdXxvt2	29962	3NKMQyank4tJF6tBRFkdhrXvJGxLameYczvD9h7D1AVU96eYE8CL	1403	824	601	12463	18974	jwUiomcCh6dqtrqydYsoZjifvbgcfb7Gt7BovNyvzKpsV4DHFzj	14758	20773	20773	1619678340000	pending
29968	3NLbwme5etGSAiNkeVLbm5bncQXW8KyYAWqjoxwhmBdL6rKvm2Ni	29965	3NKfTrmQzN6iQNPzkszy2fBPwr5eTjYH4WteNipicLwqomS2heQy	700	832	601	12463	18974	jwpRbmCbXvdtmpRLQsCEa3eVAZW3UbaavuRdtHUs6RXmubYAsp4	14759	20774	20774	1619678520000	pending
29970	3NLDaC3xt7gQvk3mLbwCRqSNJ2wt4iHrXtQzpjEgZYf1bQ2oKb3f	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1579	1023	601	12463	18974	jxKXHu4X8S88ZgCHez1HUE3f2t5X65A34K7SKgNjfvA6ADDeTvf	14760	20775	20775	1619678700000	pending
29987	3NKQzDN11himtMMCQrxBemCt6gcVGWcEwLLeGhNBtJiJVUE8yx48	29984	3NLH38Sb98td2pDMfA9Kir4Fty45XGjLrVJLvZHHdRUQiZ8vd4y9	1439	1033	602	12463	18974	jxavAfiVRo6iWjRHeCM47nt1FdUkZjPV9vTWCZ7c13XYaCSC2Dq	14766	20786	20786	1619680680000	pending
29989	3NLgpA2UP3RjVp8JP4fDqFhKbAyUt9Av9KPDAq1NHdJdTeaMYphL	29985	3NKnpsDAtYbqsggFHqopZWqAFEdcntku9v4mSVQ4dNA39u9RRUN1	1439	1033	602	12463	18974	jw9g3YFzbmEz7UCZ5dGBqwaZfxmaPzJLxuXpohjYU19q6xjH15X	14766	20786	20786	1619680680000	pending
29991	3NKhRLfYE6xQ31CqJ2aUbV2XqEN7i4WBq412CJChkY6QQ7J8Zf7W	29988	3NLGDVqjyBbCawYpx77yuJ3phtGfQJXy8Tfwib8NdVX7NhsZJRjq	1623	839	602	12463	18974	jxQAYv8j8d3hrGNjkPJJvST2psW6fSJK9bjPNrwqCKNBomLePu6	14767	20787	20787	1619680860000	pending
29993	3NL3iEi1U6etfe3tRnUvzK63CHPjVJuiz8HDLvu7RXvdSZu4d6xF	29992	3NLRxSdsqFPd5Rz6nmAzWUXtvNDpbke28i9op9iVRScKMuaEfHY3	1656	1343	602	12463	18974	jw7eMUyeKP52joEx8V6jDBDReYarFhWc4epCUXn4KQxZXA2nA7n	14769	20789	20789	1619681220000	pending
29996	3NKKMZJ6pzaZbUi7LLAZmSyw1ri87rsSdHpjnfMYDXm7VxdXR1qT	29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	1671	1365	602	12463	18974	jxzjReZQUdG95gTb8AGitcTETWaQcVeS2Suh6eYT1bUpcdDR63n	14770	20790	20790	1619681400000	pending
29998	3NKKxPF2tCVRQMf7d9j9CX7J7bJPR1zGafPq7KnS2w1BLhu2wUVE	29995	3NK57sgviqBVKVunMWAvhf5e3bYCvZjJsyx7RasxxgdCvfkbVtq9	1490	1274	602	12463	18974	jxpEi1Qzh2q2XZpTxgLYheMVDUSrv9Unb1CfNY2saezcvqC3fCz	14771	20792	20792	1619681760000	pending
30000	3NLPcmf75r9gnCAyaRoCUidQwGDG3QEHXBRZab4U1MjtvFhF4qPF	29998	3NKKxPF2tCVRQMf7d9j9CX7J7bJPR1zGafPq7KnS2w1BLhu2wUVE	1593	1220	603	12463	18974	jy1VaozRVGMHJE6pur2heoVLeeCf7MMYoFYQ8FhopCqstoNWU3A	14772	20793	20793	1619681940000	pending
30002	3NKqBqj4Rq5K2Pm9RoJZ6akHG8ABn8vqM26L4UF9WL84aKfYyvAt	30000	3NLPcmf75r9gnCAyaRoCUidQwGDG3QEHXBRZab4U1MjtvFhF4qPF	1581	778	603	12463	18974	jwpVGyZA8ANcsgxh3y8VTVUaXZtmVEeB4DhXgMuwvQ73rAX2Nyu	14773	20794	20794	1619682120000	pending
30004	3NLGjikxSFTVPkwFsrLRvUwWa3uNBmTovu31i2VbQoYSWBQNJMer	30002	3NKqBqj4Rq5K2Pm9RoJZ6akHG8ABn8vqM26L4UF9WL84aKfYyvAt	1585	1120	603	12463	18974	jxyRyw5wRi38NrMxgbqhxYPCQ3WBoNK7w6Wf93TqBsBXRPbGb4c	14774	20795	20795	1619682300000	pending
30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	30005	3NLTjhoynE5NfpFk526qGB8fBuyowXzqpaUgQ95BP8uQ75ULrvLX	1405	867	603	12463	18974	jxvfqmMUPumUuYiozHFALcQ1UzuuTLcKEMwZyGhCUcRNU8S8gj9	14776	20798	20798	1619682840000	pending
30013	3NKnvESZMdfA1Lyj64kppba4KiFn5kPhTqorzFjGVKycsvDgKheZ	30012	3NL9uNn1uSSsrEkGGtFPq61JLyaouVdQNK3JY2PNRDGvKiPtAQAW	1610	1188	604	12463	18974	jxU5e6571AeMwttopqL5M9tia9dmyW2DYtjYWq77XtzMqWEiMnV	14780	20804	20804	1619683920000	pending
29931	3NKqAA2Ni6NMqSYkwr1m8K5BMGij7j8u4svLkKGbnn8FV8p3GKDA	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1460	673	599	12463	18974	jwvaLSixfEy26vf8MuddotxegXx6dZV9irMhrcVYcDYryMkhEJw	14744	20757	20757	1619675460000	pending
29935	3NLSSFwsrxwDLfF9poFp6NagkMZfbprT13PS3gVYGXD86aSV7o5f	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1407	1395	600	12463	18974	jwKbA7KnrN7H73HeiTd2sum1zfN6UAg6a1829fsrvvPrg1MHLV1	14745	20759	20759	1619675820000	pending
29937	3NKkULRFc1xZMDQzbW34qqT6srrvB3hHaMwcULnTbPfKdxoC8hbj	29932	3NLy3FdW1utxS8qB16P8qzF7gBzmVgkyXN16KKmmwqucj2aBPfjp	1547	1132	600	12463	18974	jxRwxBeosWedxUoHvhsNFBPe6V9Ci3UWe1CGDNYf3jANz5hRpGx	14745	20759	20759	1619675820000	pending
29939	3NLkYAucMi4oyVrmroq9fLaNjR9TcTCXBtwFNyMFC8YWWc9h19MN	29935	3NLSSFwsrxwDLfF9poFp6NagkMZfbprT13PS3gVYGXD86aSV7o5f	1547	1252	600	12463	18974	jxpsqjFobjA3K7MBHqkuPXitMzby4nLBMkxN24NtX4wnUskj5GE	14746	20760	20760	1619676000000	pending
29952	3NKMXTzwMYu3qGNhgRq7QUdp9ao8EFoa4i912zbFFDMiuymyNzX8	29933	3NKa7hqq3D2jBzSjWfaPgFe1MAtWpZBSn8TNeNrRzEYKHYQkeUcR	1672	1039	600	12463	18974	jxXi6CzjmRd1wQLvjRG1PSuj9V3ffYoQoF8yeYTHjQwDPf2VTiN	14745	20761	20761	1619676314712	pending
29954	3NKPsjP1to1Jg1ut8JSr6hCbwDam3UJQjPcvtbh6uV6GmYBv6od7	29951	3NKUkLJLh1jYe4J2WwLuWfCD5TV6y5MqwJMYHgeat91dNwwNNoaJ	1672	1285	600	12463	18974	jwVrDye8agJrEAVbefwSRF87unvf3Kdaa6MayWTJ724oWHPZzA6	14753	20768	20768	1619677440000	pending
29961	3NK6CY7SHcJVqarhTNjVEhdN3aEZxWfM53n2zb8w8dD1ch2WbQHd	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	1522	1076	601	12463	18974	jwP6cNvAsFDgVAJFkCb59HmA6MT8R7atTY1S8kj9HXHP4sSJwgw	14757	20772	20772	1619678160000	pending
29964	3NKprrqScWyA6Uk6nUZ7PS1pQH6zqENpGRm86RyBV3uAU48DdkG8	29960	3NL1vzdRGk4ahr2aLDu53YVeRgAbPuxojLvHJMGxLXuVH1g6s9vH	1637	816	601	12463	18974	jwswnpVWyJK2q6GiJKwcP9ESQeqTe5hU26CpDRdKk2sMtnuosdv	14757	20772	20772	1619678160000	pending
29965	3NKfTrmQzN6iQNPzkszy2fBPwr5eTjYH4WteNipicLwqomS2heQy	29962	3NKMQyank4tJF6tBRFkdhrXvJGxLameYczvD9h7D1AVU96eYE8CL	1571	1089	601	12463	18974	jwyZkuqLwjHVykrabvSDh4L35MeUFfSwDtoJ3bM6UY6kQsmjYY9	14758	20773	20773	1619678340000	pending
29972	3NKctd96f694jfNRbNRaJYFSno1oMrqBeGPV34uavKmaAF9H564a	29967	3NL2JP92xqByxEqM3R3NZwkzhYx1b3TSdahaiAsqgKsQumLdRGeM	1673	1368	601	12463	18974	jxnxBXAhCM6VwzUDMjGy7m1PmJa5Vxow8WEFKYUdpVnHDua9Bs3	14760	20775	20775	1619678700000	pending
29974	3NKRzYAfrbYNSsKAUSUpHjjTx6FR7WAiRhs5xezPZHPgU1pTQxJX	29971	3NKZWsuZS6DQfvyyDasHDcbS6dKGtqr6E6tm2uHG5ZS7HPZMCecs	1407	1395	601	12463	18974	jwwvpbfQ2uTRKox1iwjKvvgSrJQg66yvwCRC5H69YnS4enfEzc6	14761	20777	20777	1619679060000	pending
29977	3NKRoD9p3HDZbEmrtsrip5H4EBu3juYyocLTFo5Q4djHqW1eguFY	29975	3NLHt2CTgtFWBvrzqY5Mugdvi9MnJrw6VBD73nEnx8Dp5Q4qrTNa	596	940	601	12463	18974	jxn3U6i38xdyQfZNh5UF3zAhHJ3r9FeGwhggPb1NNk8eJ3F8bdx	14762	20779	20779	1619679420000	pending
29983	3NKdCT83PR83UCmnno4X9ct4HdTfHMQqvjkCs4BV52tVCNbymzSg	29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	1407	1395	602	12463	18974	jwwyuUeSU5tJUFFa3ZhFh5jrfE7UUkdu3VAks9kz6jVqTVuaQaS	14765	20784	20784	1619680320000	pending
29985	3NKnpsDAtYbqsggFHqopZWqAFEdcntku9v4mSVQ4dNA39u9RRUN1	29982	3NLYawydnTv6Uz972xyccDj2qJ6f8vc3rdaq96JLaGMaEHT5tq3g	58	149	602	12463	18974	jwhz9aHeCmSk8TYaNKoWRoybSHzpo7HaCQ9C1DpRAS4RZU4bUEv	14765	20784	20784	1619680320000	pending
29988	3NLGDVqjyBbCawYpx77yuJ3phtGfQJXy8Tfwib8NdVX7NhsZJRjq	29984	3NLH38Sb98td2pDMfA9Kir4Fty45XGjLrVJLvZHHdRUQiZ8vd4y9	1439	1033	602	12463	18974	jxTc6X8ybXJmU7KkQnHBB1JdxgUdNPkvd4gzXWn4YUoeRgmbRxf	14766	20786	20786	1619680680000	pending
29992	3NLRxSdsqFPd5Rz6nmAzWUXtvNDpbke28i9op9iVRScKMuaEfHY3	29990	3NKdTfadMzuT2sP95bPUbsEe9UijUJBzHybx7KcKtdSYryJrgaDE	1501	1114	602	12463	18974	jwe1wjiwasaX3FnFoFWDi7JCJ1s5JH7P72FJxpKVwUxkacmuTHS	14768	20788	20788	1619681040000	pending
29994	3NKXEFzihGvBhSCZageCK4bnW7Gb4ZVWZ7hM8eogCj67id6iazLy	29992	3NLRxSdsqFPd5Rz6nmAzWUXtvNDpbke28i9op9iVRScKMuaEfHY3	1656	1343	602	12463	18974	jwcvQy4PcstTLiDH7E2T43peSyCF4Nm746K2Qtg9vAQnsDfgwyN	14769	20789	20789	1619681220000	pending
30001	3NLv6UwsRR68LXhbiYGn8ms3vY8hZG4Q1zJk3w1oYqY9XaWTV7Zz	29920	3NLt54wM7bkfDEi97Sr95oEM4T7PVPY9CQPYEr9z6r4rmrFM4GP3	1593	1220	599	12463	18974	jwvnofJTUa3K8YRaEYhvjKTVFmBXC226dhUAKepR3cyhcHDnugd	14734	20793	20793	1619681940000	pending
30003	3NLr6uN6z4QpNMVzwW5EDMhhBPbk8cwUNhtK2CSBsu2MYJWrUoXr	30002	3NKqBqj4Rq5K2Pm9RoJZ6akHG8ABn8vqM26L4UF9WL84aKfYyvAt	1585	1120	603	12463	18974	jxd5esqQdRKMbN5V2MVyQNZhGScVYrdUkn7QEM88BCaNKTxWtj3	14774	20795	20795	1619682300000	pending
30006	3NKKmadqFekUgZZLYDCMNLEm3KyFyBJFwMQBBmkerZzGvudpQaRN	30003	3NLr6uN6z4QpNMVzwW5EDMhhBPbk8cwUNhtK2CSBsu2MYJWrUoXr	1403	824	603	12463	18974	jwmBAcyKL9PGVDrU8sPvvP6F74PhN49FX9VLhZXY4N5EJi2C7N5	14775	20797	20797	1619682660000	pending
30008	3NKGA4waPvVkECxVGJ4U9bNS5AmxiJeEcSDqZ9SF8cfTFuDX3kD8	30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	1500	1051	603	12463	18974	jxjwS8DX1vihv3hxyxm8uBuMsY2MXrxNZ16hkQgBaKAsbLSjgir	14777	20799	20799	1619683020000	pending
30010	3NLLj1dAN31qkd3sgBs2uPk3YsMz2f1wceYj3v4x6wDa3gL3cxsJ	30007	3NKX7KTSjsH1H4PJ4JG2g1NLuFp9jCEJDuVdE1XtJLNT3y1RvBLX	1596	1117	603	12463	18974	jxStQZKAAx61ygrFSg4JYMesdmBJNjW9S6N9B6uPB7tG455dNjk	14777	20799	20799	1619683020000	pending
30012	3NL9uNn1uSSsrEkGGtFPq61JLyaouVdQNK3JY2PNRDGvKiPtAQAW	30011	3NKtHSnQmkDKfqtio2VkUoiic7x16uDhhyFisNTibApTTz64GM3W	1406	1393	604	12463	18974	jwwvi58NxnzBcfpL8y1UnHMzSFZ26hQiJiScRFkTcEHvZnT6cQW	14779	20803	20803	1619683740000	pending
30025	3NK7zRNk2mas79CQDXDiChbmaXFu7Ujo8Exq2YyT8a6UMTv967FK	30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	606	1295	604	12463	18974	jwVA99ptWpyPR3cwUhqocTwHKYc7gzq1hkiorKRraRivqhwrKm7	14783	20809	20809	1619684820000	pending
30027	3NKpYCKCqcnbyB5FF1aLLwqBxRDe6VBrEeRsHcnJJd1B1qm2NqN1	30016	3NLd8mqQvMmuFbLGsQX25AZfDNWSNTgHyvyd3eQBP9EUHyCEuwRD	1474	1203	604	12463	18974	jwqUS59KErbtrXhbToTC5Qg49DcyQB3BnkszD3KH9NHiy2JJWh9	14783	20809	20809	1619684820000	pending
30029	3NLrDHybUbCKwDHnSmGdf5L7RRtFGY4Lwpzsu4Q3Vomyn1ivgkhV	30025	3NK7zRNk2mas79CQDXDiChbmaXFu7Ujo8Exq2YyT8a6UMTv967FK	1608	923	604	12463	18974	jwunEwYnQyhYGXmmLjG8Aq4H4rQSMPp6BAgAZLDUnVr6FEnqr4m	14784	20810	20810	1619685000000	pending
30032	3NKxEAuiTuY2A88Z3peLYXeeNjk3padob7F2TSL4UGqeaKSa6K1a	30030	3NLGm5X9382eJ3LESJJndJrDbkhTRzAoiwiytNo9pgCe6aNLT8i1	1507	914	604	12463	18974	jxMi3bJdLvvRgfXneRes5oMWs4W4ijxv6rasMVDybCXUp6kz9Di	14786	20813	20813	1619685540000	pending
30037	3NLrgfZWBeE2z3FPPqFsFiVMBARVqRYELiMAkNUXroSMgqDQRe82	30034	3NKN8NvMDGcFNKSyP2yKdFxfbLSPpSaN11ARXxafqGaehwRaSjL8	1403	824	605	12463	18974	jxEKrNR93XyWAcaY1iD1XZBmPzCNxjmcMyoiW7tjP3tLWQxarL9	14789	20817	20817	1619686260000	pending
30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	684	1352	605	12463	18974	jxH5R1aSnWEmYUSiBjz8aZsZbhZiEYi8bUpYcAqP6ev485Pxek2	14790	20819	20819	1619686620000	pending
30046	3NLwrGYpL2qfeYSpvZq8DLBrGbN8ctj8og3gwsC747wUaYT2prSp	30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	1403	786	605	12463	18974	jwaJRHpx8Z1UFtU5VRoXugyHHLiCXmZDeuQWiVu1ETRMUr4kmf3	14792	20823	20823	1619687340000	pending
30049	3NLSsU5f1PBsfFB8AhZ7rJkpRvhNtB9U32ucidsXQFeZj5WrADLm	30045	3NKuxCihAmcy46wRCwNHxqJeH1JXhC4MCHTGeyZ7hH5wN3teDWpp	497	497	605	12463	18974	jwBSuiCASfhDrtnNt3SsH98ZGNSEM5Y3z4n5hcFuzVySQjKGSWE	14793	20824	20824	1619687520000	pending
30052	3NL7Wc5QcQgm7Ks5tihDzKsBGfSGqYcxtDTKWEBeMMn56MVyAURL	30050	3NKnoCza3eMKGeZ96psa9ZBzpzWhgxHB9kGCgA6sdLmcXfKzv2JB	1549	1236	606	12463	18974	jxixkKTxAHUPEqpnj3xDX5iHUqvcWt6P5S7kDXaDBNvrPsF8NJH	14795	20826	20826	1619687880000	pending
30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	30013	3NKnvESZMdfA1Lyj64kppba4KiFn5kPhTqorzFjGVKycsvDgKheZ	1406	1393	604	12463	18974	jxrojdeF65qordRnQb4RWGQZto4wjS1ZMojQfQeu36NWsE9jcry	14781	20805	20805	1619684100000	pending
30016	3NLd8mqQvMmuFbLGsQX25AZfDNWSNTgHyvyd3eQBP9EUHyCEuwRD	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1672	1039	604	12463	18974	jwWLsbA51n6QsFwK2igqmfayN9x85znH6krQDdofa4zd88jXMZF	14782	20808	20808	1619684640000	pending
30018	3NKbnMutjLxPYPX4MU9oKxxkWnhtD9irfT16aLPeLEcbDnMYn12N	29863	3NKQvUya9wP264RxqVEvjxkGFJzDXaZAxKogEaL1KGVb6JesDoTN	1523	1195	597	12463	18974	jx3jhccVJCD4oNTgR9Z6XUXfubCYPwezwjnvA1QiDXZ1ge3nvMg	14721	20808	20808	1619684671373	pending
30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	30014	3NKjSQXPHZbxh18ivY6XgTu6gCL2TEVfA2XAWYoz8r6jjaaW4HDc	1547	1012	604	12463	18974	jxjahED8WahvaYkNuAGEVc4HXuchTNqBZYnLYuQT8Xx4CKJ9H3m	14782	20808	20808	1619684640000	pending
30022	3NKrDaFfys7vsN6bvNYwhnNJmMkR68hxLMYwg8yq6NNJWYgvcJFd	29929	3NLwGpK4ZsbKeEUA2CrpWM6vW9NSoS8vsUf6W2Ryv55LkFS731xY	1523	1195	599	12463	18974	jwvaLSixfEy26vf8MuddotxegXx6dZV9irMhrcVYcDYryMkhEJw	14744	20808	20808	1619684733531	pending
30024	3NK8tWLRJaAD4oeaU7Dvht9KakPagy69FL7rF7TYY9XdTRfYBWdq	30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	606	1295	604	12463	18974	jxtVt1NRnBVf9GATGo2vxmhWTcy3Rf2rb9PJtJorCwcBz43Jk9y	14783	20809	20809	1619684820000	pending
30026	3NLGMkfVLvNL4d2j8ZGhNKHow4rKp9vbpKmxS53tWPFbenykS5RK	30020	3NL9Mpe2AvxJuu5FBxoQMuLvqVWGy4svk8ZFtscwugo6sRGywyU9	606	1295	604	12463	18974	jwK2fKFxQFrsD8iTp5U23CjFyXNLPR25zJuxLasCAEFp91FRijt	14783	20809	20809	1619684820000	pending
30028	3NL8Ly3vx3tgrdJfjTk3sD7XJNGoM8dge8g9pxd57HJdFdZRe3hg	30025	3NK7zRNk2mas79CQDXDiChbmaXFu7Ujo8Exq2YyT8a6UMTv967FK	1608	923	604	12463	18974	jy3HwiFRpGeEsF93FRFYMcDCrEBvVT8a1AHuEUFcLQXtHCCk5Tz	14784	20810	20810	1619685000000	pending
30030	3NLGm5X9382eJ3LESJJndJrDbkhTRzAoiwiytNo9pgCe6aNLT8i1	30028	3NL8Ly3vx3tgrdJfjTk3sD7XJNGoM8dge8g9pxd57HJdFdZRe3hg	1407	1395	604	12463	18974	jxMyUG8jVhHm1Zg2LyoKD6LxxxPD3RpDbugX7Jp9wpJuxYt2Quf	14785	20811	20811	1619685180000	pending
30033	3NKzC5aMfXzRUUigEbgY4cVZLWWwKQvYdxnHEi4xMBhZ8Mm8qNX1	30031	3NLm8GjNG6HtLbxxcawsziKsXZnexbZRWrq7Yn6fR9T1DMck1bv9	1403	802	604	12463	18974	jy1rMWYRpMsjHSs3Z2p3m7bbCn5jpxEvNRSSE9ZVDD8U4LjA4kq	14787	20815	20815	1619685900000	pending
30035	3NKH6iy26GVi4TRHJ9SQo1e7qmGSJbxEM4MBjs1Ko4vzn5AZRH2S	30033	3NKzC5aMfXzRUUigEbgY4cVZLWWwKQvYdxnHEi4xMBhZ8Mm8qNX1	1419	814	605	12463	18974	jwVwjfAgmDYrFQ4WwRRxAbVv4GW7hZ3wnWyjKQqMYqc8K31G15d	14788	20816	20816	1619686080000	pending
30041	3NK6VLP8B2qjHaimP9CPjWK3ScfCw1D863NSNwnTtpNUbHk1sAwm	30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	1637	816	605	12463	18974	jwDPJnEGJBLmtCfLU1HBpyRKhh5NMPwPdNGd1eCKUGc1o8mPbae	14790	20819	20819	1619686620000	pending
30047	3NLTAJSKHCeQUHvo7oYVcmPjaBvSpARCpAqEBnzap88n7pjcDD98	30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	1585	1366	605	12463	18974	jwJJhgJfPduV2GfKAy8re8BbsqJcbPP2mjs3YgvnyPLcUoDmGiJ	14792	20823	20823	1619687340000	pending
30051	3NL8rW8NEQ3Ht4QPCyYfsNZm1dRUNvNS9UrwTnQbJX83BKWhRpjP	30050	3NKnoCza3eMKGeZ96psa9ZBzpzWhgxHB9kGCgA6sdLmcXfKzv2JB	1406	1393	606	12463	18974	jwBUr11PETR9WsZkGECDG9ixb6RLqhZ8XHn9CoQzypPLzvZZnvR	14795	20826	20826	1619687880000	pending
30056	3NKheNqnHgEoMxENPnt3dtCn2c95jVRy8JPLwa1bN2CWT2KDs1Zv	30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	1549	1116	606	12463	18974	jxgLmea53FWAbG2hBRPkXm1PZC2MiNJtNcMKdgcMQTkh4SQZJ8C	14797	20829	20829	1619688420000	pending
30060	3NKRg6VpbzAcnjWEbbajaYCXsyiz7nvqrC1FoimdM61q1Aib7Yny	30058	3NLXdsAy1uEEDFjbwoHrvSiMdEZr31wMJ6zf2EDFdJrL5YkoZEX5	1406	1393	606	12463	18974	jwB1Kd2dKgHEFxzeJL6xZwRcVn1oijBXAqgfPCgxidsihbgMMzC	14799	20832	20832	1619688960000	pending
30068	3NLFXrgwk6fFfnpzUVSNc1B6Ah9V7q5ps9f9SZYHurffB5eMoneg	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1471	1386	607	12463	18974	jwGb2WUg54ppksC2D7fFh8LTZrKxySRsXazkfgtPcC7v3FJzEL7	14805	20840	20840	1619690400000	pending
30070	3NKw7Furi9UE8Efae9CsHhg2Qou1fepRb69bgskCWf1Hze6AVqzD	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1599	1161	607	12463	18974	jx68nntWMF3UdQMncQ3po6bdpXNhvnXintdBXhoTEbGHZmaaR5V	14805	20840	20840	1619690400000	pending
30076	3NLZ4makkKxGEnyuc1j3fSW3B7CSs31zS2jr2kkdQKc3oV6oqWXP	30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	1448	1311	607	12463	18974	jwudbHjryro5BKUpw6xEb4xUopqKbNCS6eYm7dtwrnSwpjYCWsi	14808	20844	20844	1619691120000	pending
30078	3NLiJwYSrqTqCzNfk5Y7QZY41vobn7MZ1dAycHtZh68t5hRERUrh	30077	3NKCYwRSA2v3BSvqLmH1XiMnjwtEMtttjk3hPqRKgyJqDmDzhXZD	1549	1236	607	12463	18974	jx5XFktXrBVUbrM65dyXnoEW3jccMYycLnu9bEeMm9bFhGnCbLi	14810	20846	20846	1619691480000	pending
30080	3NLXsdJ8Sp9w72yZRvuzyJ9Pk2pNB7CacjxpN9cjgHhSttwFYcAz	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1407	1395	607	12463	18974	jwN9XUpK21kJ36qf1DV5RbxsEuw7bUiq4gsCSB17JNZCiHFSfmK	14811	20847	20847	1619691660000	pending
30081	3NKB1g2QsqL6wKdMjR9v8rsfTJB6tkQPvSztsGBH5AFKPkLBXrNA	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1460	511	607	12463	18974	jwabLtjENxJ8TNJNEQquWDMnFnq5xaLsaZqQnNEXDuUCASo4zX6	14811	20847	20847	1619691660000	pending
30089	3NKyCQt7cfKMNW6huLRV6d1NpAtQYtVmMPQ2WUer6Y2fMDzwmq6h	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1657	1344	608	12463	18974	jxnLyS27DdyDAyTGJBJnUQJpKJwsdr1Tqo3BLrp9yR5iGuASb9S	14814	20852	20852	1619692560000	pending
30093	3NLoTM3b2tQBjwd7CpgJd4MvBdPuMDomxcD5qrWhPNeLruNcDmfK	30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	1668	1124	608	12463	18974	jwnB1Ld5ZUWgPJyUq3jXfHVe33cbTXghdUDvxGjRy5NTaWHCmu3	14815	20853	20853	1619692740000	pending
30100	3NKNYPQE7iNBHU8HuwLD18gV7jpDhrm1CzPGc6hsN96Foiuenvj6	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1560	1045	608	12463	18974	jxP5h26gYs5xZKT5TUuucpodDTxCZremFN12GvSHCwaDm7G9Jmc	14818	20857	20857	1619693460000	pending
30103	3NKJ8R3c6uD3ucP793Mjcdrz99G3oooNvrkf84usQZEG4PsikSgn	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1602	1369	608	12463	18974	jwEG68jGaJmZbYfUfey2gQQhzPPHJZKVEsf2TCYdSv3wZGDf8xQ	14818	20857	20857	1619693460000	pending
30109	3NLXd1sviDgXEvCBwo6cL94q6ix7m9h9tq3VKjGeaBdUAfwvW8YQ	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1407	1395	608	12463	18974	jxwiFTiTo1GLkKips9KGzJJRuUheA4wFu2XKoCXqSzwpy5Pebih	14820	20862	20862	1619694360000	pending
30113	3NL3ZYrs2QULsRGMYteVgKUPaUStszAYDpq72k22S1J3YyYcS2vi	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1522	1322	608	12463	18974	jwFCvt1wijyduecEE2sun3znviwRXgCAWP9m1GJf6TgQtrsjVXX	14820	20862	20862	1619694360000	pending
30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	1547	1012	609	12463	18974	jwTYwWu4LgnYpp15UYq16DwJx8VU57sGzJUjQFDw4cPiAFx2TaB	14821	20863	20863	1619694540000	pending
30121	3NK7QvtkPLYvNyYErCJ9xWX7DrbPGgn1GH9dnmfWGEVekJ5w4Xqk	30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	1440	1251	609	12463	18974	jxPLywBRoqETWngbHa3VpJ1BXUdSZrw3BCkioTJWrEysURDoWye	14822	20865	20865	1619694900000	pending
30123	3NLScUbGdLoKnkw4S38eKPz2DUFPKhTB2jXbU2skHMRRdR8WQH4k	30120	3NLu7jAEm3RbUbt3aQZKxB1WrRtUYouLX8X7QG6EgC8JKbvm5bYb	1668	1004	609	12463	18974	jwygNMS1L5jjZXesF6qeE5f1xUsrCJoZxPdpbJYj17ndaZxDUBR	14823	20868	20868	1619695440000	pending
30131	3NLhazy4hH4yXRs5JgzS8gRwb6tbjjX5uL3MjF6JYj7p9um9tx2V	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	1581	778	610	12463	18974	jxoaxCepHydhRk8AEJvFFPCFDbggzWXTDQDZqoQ973iqSBuKkEf	14827	20874	20874	1619696520000	pending
30023	3NL5CqbZHb6QXp8eQBN2QPhFbJyh4RdQgKxBCG84ANSoy2kQbVza	29956	3NK7m9yMAgyeateVXxP96JabYf612VoDf2eBDdRBfkbJzKiFHYdF	1523	1195	600	12463	18974	jwpUQYbDJbKAZdx1FS5njYvmc7fjoMbg8Eoke8LPeMVsJAwBsBJ	14755	20808	20808	1619684764103	pending
30039	3NK6zLdDNYLybX3Tv9jB49QL1VkhqsgSpixMuc7Gd4ynQUNVr5f6	30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	369	1066	605	12463	18974	jwwGRf57NVbigdAhvVcLjHFwz5skqk9WpMiqSQ4bKQUnAeyD6cc	14790	20819	20819	1619686620000	pending
30043	3NKCpkvYVBmPUFdcxjdi6xvxhbYE8WPDATUvGVVuQGjpc1viCFPG	30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	1627	1385	605	12463	18974	jxErHTgvK1gNoyj3TqaQYanAZkrB14kERiHXP1Py9cWJiPEQA7d	14791	20821	20821	1619686980000	pending
30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	1534	61	605	12463	18974	jxWsSFarNGbKVBKG2zWdh3NHE1goFkxw7pmNLrq6QJGAFuRVkRL	14791	20821	20821	1619686980000	pending
30048	3NKhBrGD6vT9gR6PRHHcRmeEFJqHr6CZ8m3yZdriJ8dPU7LjtWAZ	30045	3NKuxCihAmcy46wRCwNHxqJeH1JXhC4MCHTGeyZ7hH5wN3teDWpp	298	298	605	12463	18974	jwdy3rPXFSBHbXUz354BHA1GFeqMxEweHwor9pKRoRbroUsbT1S	14793	20824	20824	1619687520000	pending
30050	3NKnoCza3eMKGeZ96psa9ZBzpzWhgxHB9kGCgA6sdLmcXfKzv2JB	30049	3NLSsU5f1PBsfFB8AhZ7rJkpRvhNtB9U32ucidsXQFeZj5WrADLm	1578	1050	605	12463	18974	jwmQtpH4qSqE5iJ4eHin4bQpQGbgxEwRfMExDeD7eDqjbnJyKSw	14794	20825	20825	1619687700000	pending
30054	3NKhQmSQdMA5UAp31m9Y767bHYBEQ1tSUYvbXdDEKAv1CdcJSGLE	30052	3NL7Wc5QcQgm7Ks5tihDzKsBGfSGqYcxtDTKWEBeMMn56MVyAURL	1581	778	606	12463	18974	jwP7ANJew8o4a9eMsYybTydccyJhZgMA4WqzP1sWrGMWsxjLo5k	14796	20827	20827	1619688060000	pending
30057	3NKfNcfwM2DBsbb1nnYtKM4uoMu4rsToG6L5R74qhLcYBA9ZNA2c	30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	1483	453	606	12463	18974	jwJhZjT5F5cTYxQF1u7J8MgP46XvseF5bAWoM3oxhsCTGk5oM6Q	14797	20829	20829	1619688420000	pending
30063	3NLA6Kdkmc5r91afz3Z4VWdzE8v2XZ8JJ8fQT5oHj1PrYDpqJkpR	30062	3NLMwaC3hkSt13VyxQbbuwU6aEZSnGVtLDPXQgVdfnKmoqPtr9mm	1607	1348	606	12463	18974	jxBpNthkcqFvuo1tUEdyDNeYc2nYq22vsCwCwmMxXCeATEKqcXV	14801	20836	20836	1619689680000	pending
30065	3NKVpbvQrMrGkqu3Ay7aN3ZxkB4HmjATeth1CvVwJHC1yGpAHEbx	30063	3NLA6Kdkmc5r91afz3Z4VWdzE8v2XZ8JJ8fQT5oHj1PrYDpqJkpR	1585	1120	607	12463	18974	jxGE36gkDnBvXKxvKn7YPmiqQ6sfsnHRX6QREXxRYbWVisrxpgr	14802	20837	20837	1619689860000	pending
30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	30066	3NKqSHHpepjY9j1jCyH1QmgzqGoTgrpXrCt1S9E7B8RWXZpWgiH6	1407	1395	607	12463	18974	jxAHyijYxW93py3qFCgoyoEQe3XUoty96y8PW93nsyeagHYQWVJ	14804	20839	20839	1619690220000	pending
30069	3NLWG96q5Kv2EDoDi3ETQ4wUc9fXPSgQCDSnTSmn2B4XgvK5FX4P	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1407	1395	607	12463	18974	jwSBiCTriXBmoHkPM4sfikUe7GgxSLuWBgUdFjSeU9g1it3XPhv	14805	20840	20840	1619690400000	pending
30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	30072	3NKuET4oceW9oLHxJMw8yHUbF6GhXtPgnsa68RiSZR6v9chXGoVc	1672	1285	607	12463	18974	jx9F2CsiwiTRVWTGnPPXgchVPGc9J3oWSeYjLss8GQzkfDtMCCg	14807	20842	20842	1619690760000	pending
30077	3NKCYwRSA2v3BSvqLmH1XiMnjwtEMtttjk3hPqRKgyJqDmDzhXZD	30075	3NKZMtNUt4cw5wBKKt295eNJf5e1vEiQFtLJwZtLTi6m5yGTvdKg	1547	1012	607	12463	18974	jxLt5id5ndXx7F73dGaPs5BxmUNh6UQ9tkYAMdhtyDyCx5wx1XP	14809	20845	20845	1619691300000	pending
30082	3NLpq6CEKcc6TzUu9WBcjLSrBeyHVvRuT2hNUJ46v519WajmanD6	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1460	511	607	12463	18974	jwabLtjENxJ8TNJNEQquWDMnFnq5xaLsaZqQnNEXDuUCASo4zX6	14811	20847	20847	1619691660000	pending
30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	30085	3NLMYJVQfSX2o1hPnkpfSmCog6KWLWHfuoVXkLW2xeyEN9jyQgti	1407	1395	608	12463	18974	jwUYj7822WAAEewEHGaW1kpWgd2EmZiogXCqsobCXeUH1b2YFJP	14813	20851	20851	1619692380000	pending
30088	3NLvmSSU4Unbn5mmfAyJc1qk2wb5CxNXFnuizcV4npT7Fd2NBSgK	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1657	1344	608	12463	18974	jxT8d2tJVmwYAH8XUCSwnHYSgsJrxTxgVEjhX5NzDVuH2DngFpa	14814	20852	20852	1619692560000	pending
30090	3NLSWvLzLVhhgJZhvLuEbaYeDRbiyHpNJXaCAuKhKyHzC51K9WDp	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1534	951	608	12463	18974	jwVXv6pwCw6nRLk4Th6D4bHUrMDUSfum79hpyfCrkqnCRHuJrQE	14814	20852	20852	1619692560000	pending
30092	3NKcJ8mdC2dvcxxEaUCdTHxp7kLnkuqoC1rSx2WJnBXwJ74bPsQP	30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	1668	1124	608	12463	18974	jwSBjrEreyCQSSzvKddKQtTr7ymHRPbSbXrCFYs7eX9qkNPUZwg	14815	20853	20853	1619692740000	pending
30095	3NLVaxYtS1ZFsBDVNoTLNDijbzo17YbetGLkWCd34mkUrCFUbtZw	30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	1407	1395	608	12463	18974	jwyidNY2Y9ExVwctH313gsj7r3EaUFF7Sy364XmYYcdTARjhaU9	14816	20854	20854	1619692920000	pending
30097	3NK9pCNeF7BjTksdDuT4Em26Df6wu9oWfCSRp68d3RV8DDYjEjrV	30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	1542	1178	608	12463	18974	jxcZu9rbmCsgL3LXUaqDKR2Ruq2u2rDs7dc8BWM8hNHcBrLN2f5	14816	20854	20854	1619692920000	pending
30099	3NKCjMX55eJgYyvcytptXBRd8AbAN5TUFmKjERM9UbMmRjYPgPPV	30000	3NLPcmf75r9gnCAyaRoCUidQwGDG3QEHXBRZab4U1MjtvFhF4qPF	1589	1160	603	12463	18974	jws9kTTrHGkzhFqhWsmV2gCXJG7UvwvyzZADbNZTdbM7nCYFnBA	14773	20856	20856	1619693280000	pending
30102	3NLiG5qQrqUng9A9FNXX6N7iFddh98tMK8XwLXV1rXCiQFGHnyUE	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1602	1369	608	12463	18974	jwuNaSQgfqDjkDjfGur9PCWNUTH2m1YxUUMCMb1xeiCkthGwBMs	14818	20857	20857	1619693460000	pending
30104	3NKhPxMyD6vWcEU57TDgRQUbkXHn9kSSXQTZzsgRSgd1ai9dmZzv	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1651	1055	608	12463	18974	jy1AvWFYCQSAKbHQM5kYxEJdRF7rYdkF5BRxHpy7vYYZ32Wgwm9	14818	20857	20857	1619693460000	pending
30105	3NKQkzBX7kzutAAycoik276oyWhCiPKXir4nfAaBGRNm4Cft45NM	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1560	1045	608	12463	18974	jwyHVied1qp1vx1ZFwYf4SxftD3kvy3HhX9PJHm3bbsLRFsPQhq	14818	20857	20857	1619693460000	pending
30107	3NL1dVj19r3MEd8hvNN79KJNkbjfXpe71JNcZhKQk6o2QKrm6RTE	30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	1464	591	608	12463	18974	jwnz2rHxx4mirvmq7NsjiEA3qB6NmE5Vfi8caDQpNL9Wy1EkUSj	14819	20860	20860	1619694000000	pending
30110	3NKGasNXQEndomddsKRiTCyuWnU4bDkCz2G77AmjBxf3tEgsWyes	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1405	873	608	12463	18974	jxSwSsGTaDgiY4VCmhqnUcsSjR4D3bbWhVWy8yPBoUvQVP527RA	14820	20862	20862	1619694360000	pending
30114	3NLxrmM5V7RwPPkPE69Ni3yM5gf1iCSX3j9ypiwgnCm1mCLkM9ha	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	341	341	608	12463	18974	jwmAXhdDBrzvHnhvUY9UZCaB3g7S6AnrP1bEvXamdPLP9Suirhm	14820	20862	20862	1619694360000	pending
30119	3NKZ8zEjcCTPkoKHkVenAntABDG8Xn3ebJZRqhrAUAL476Juhw1q	30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	1403	786	609	12463	18974	jwGpn4tuA9DBiYJmXXxuLpJtLUAcj4mqMfpFpxZp77iGVTzXqB8	14821	20863	20863	1619694540000	pending
30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	30125	3NLUX5bbc3HD4APX1Qy5F2Xm4STMr93hpPnLJE97trn5Qky6tebc	1406	1393	610	12463	18974	jwVTbo9ibceyZkP7BXwzzZkPJX1r5QVdrzBoeHCKJtXFDmFXZTi	14826	20873	20873	1619696340000	pending
30129	3NLoPah2c6PpEgT7Y6rj5qoFAkp9LC7SjDap27mNWJF1dkXvKrb1	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	80	1273	610	12463	18974	jxJX1YCqgPJpU5m72Gm12MmdFz88QKCgYzqh7fnJHHfb7sz9Bqa	14827	20874	20874	1619696520000	pending
30133	3NLKhtC43xJFuqM78s3wsXnf1dAjH7xzjJErWrHmhybpCWMSp2w3	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	563	563	610	12463	18974	jxXdG5rUe1EJDZHE2M5JyECU2qsg7Wt2tPCNJwn4fLMqQoUxCYJ	14827	20874	20874	1619696520000	pending
30031	3NLm8GjNG6HtLbxxcawsziKsXZnexbZRWrq7Yn6fR9T1DMck1bv9	30030	3NLGm5X9382eJ3LESJJndJrDbkhTRzAoiwiytNo9pgCe6aNLT8i1	1407	1395	604	12463	18974	jwLxh1Ghm2W1x6pZLtmqrxYDkmeZHKRjKWYxy4HeC8wFCLDCTM1	14786	20813	20813	1619685540000	pending
30034	3NKN8NvMDGcFNKSyP2yKdFxfbLSPpSaN11ARXxafqGaehwRaSjL8	30033	3NKzC5aMfXzRUUigEbgY4cVZLWWwKQvYdxnHEi4xMBhZ8Mm8qNX1	1622	1110	605	12463	18974	jwVNagN1idjtgJSCBFZfKMBCR2SR9fZRUDV2yZvm6G2rgU8AuG7	14788	20816	20816	1619686080000	pending
30036	3NKfW1ipxaSrEE3drFDjBwVsm12QnUPJRqEZtGehDjbwB4dgy2Nj	29914	3NLZfY7UJuFXR6tege71HVk9pKgJZ5S6bZqbviFgEq5hQZvJEUWj	1419	814	590	12463	18974	jwLKQK5dqGWaCuF4T3ZcRQ6TtX1b4eKUMqHEpjd7HiT9oju9c5n	14669	20816	20816	1619686080000	pending
30038	3NLkpimok5vyxoSriLpZHDVMwsSeweV6hFThAgt7LPVtM1pUwBXQ	30034	3NKN8NvMDGcFNKSyP2yKdFxfbLSPpSaN11ARXxafqGaehwRaSjL8	684	1106	605	12463	18974	jwXDS2iBTEZwHjtuUdKp9rDJenFSW6AZdRV3MPhPgAFCeRFCwcn	14789	20817	20817	1619686260000	pending
30042	3NLK9TsL865CYUmz5dqr9cApWTZmEso3CTTRJPhD3dxPUH12VQxi	30040	3NKs83Y2DqjJGL9hdUdy8pf6DoM7fWK87SR1cVLLDdQqAVmmY9Dc	1460	1078	605	12463	18974	jx8diMkFUv9TwJU5xz4n8mJSExb6TtD8sJCGmAhE3W3UEmmPiiT	14791	20821	20821	1619686980000	pending
30045	3NKuxCihAmcy46wRCwNHxqJeH1JXhC4MCHTGeyZ7hH5wN3teDWpp	30044	3NLopf5fKQYJUuzGW8h8j3PnJ8Fqya3ChoCVSs2GvRqYLxQTQQD4	1460	1078	605	12463	18974	jxTuvbBRnCUXzXP3S5qYTgLSkjmZ6MMzbSmbKfPdjdRh656nhEx	14792	20823	20823	1619687340000	pending
30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	30052	3NL7Wc5QcQgm7Ks5tihDzKsBGfSGqYcxtDTKWEBeMMn56MVyAURL	42	1235	606	12463	18974	jxgdqkWDbuW6uakfheL6VdCNGwUw4nwWM6nCySdRUehheweY3oh	14796	20827	20827	1619688060000	pending
30055	3NKn7TLNexfENY3F3RkG9n34YKyAWS61m54LCshoCHYjKQKRbr1D	30053	3NLVJMhAr9FYe4ARkFhtQh57CyvZRQKRSicttcarKNQ7fdS6CCB2	80	80	606	12463	18974	jxa5SVSqQA9zx6SZUQCBGjNax83u4A47JurSBwMo7n7C7oJTrWS	14797	20829	20829	1619688420000	pending
30058	3NLXdsAy1uEEDFjbwoHrvSiMdEZr31wMJ6zf2EDFdJrL5YkoZEX5	30056	3NKheNqnHgEoMxENPnt3dtCn2c95jVRy8JPLwa1bN2CWT2KDs1Zv	1407	1395	606	12463	18974	jxMcAKLrkJ1e5sHihQLYGVmCyevRV8tx6i6PzzEUDSuYWqkbp6E	14798	20831	20831	1619688780000	pending
30061	3NLU3mk1bLUNkbuX86VsiZjzQ3gLXSuMf3PgrmegwMTdQnK4jtgm	30060	3NKRg6VpbzAcnjWEbbajaYCXsyiz7nvqrC1FoimdM61q1Aib7Yny	1657	79	606	12463	18974	jxJVAutT1fTq8h9bRjnuJmZVQ2BnQHuTzJ7HDJm41YaSefqt2na	14800	20835	20835	1619689500000	pending
30064	3NLi979kBc7CF6wiVJwwrMaW9AvKSKMLUbQHS8wbruiyquztpMYt	30062	3NLMwaC3hkSt13VyxQbbuwU6aEZSnGVtLDPXQgVdfnKmoqPtr9mm	1607	1348	606	12463	18974	jxBpNthkcqFvuo1tUEdyDNeYc2nYq22vsCwCwmMxXCeATEKqcXV	14801	20836	20836	1619689680000	pending
30066	3NKqSHHpepjY9j1jCyH1QmgzqGoTgrpXrCt1S9E7B8RWXZpWgiH6	30065	3NKVpbvQrMrGkqu3Ay7aN3ZxkB4HmjATeth1CvVwJHC1yGpAHEbx	1407	1395	607	12463	18974	jwwZDrFgT1uBVnfT7oLWdp4HwQr3kKzkVTW3rog6yG3h33okXEv	14803	20838	20838	1619690040000	pending
30071	3NLUxtRiakhbpbJ1UrbG4ZZhe7rkf9Btn52dBRGSBDuxCGNPKGEc	30067	3NKahGo8GMqzkRg3oXdKHwVs3eDB4jS6c7dR2J6ZjtAHeyWzs6xF	1471	1386	607	12463	18974	jwuzbLNYEVPXYg74XyHMoJjWXaA8cnpuBaYEUnukS37Tm977uqA	14805	20840	20840	1619690400000	pending
30074	3NKKpffe9MkakcQBU2ssong4G8wRsjmZ6FEqWxGSAnmPaqVEpAmf	30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	1406	1393	607	12463	18974	jxMr83PVXvJ793Fz62WeuA1yJbvDTtG7UB4zZjq5e93JyTdv3Rq	14808	20844	20844	1619691120000	pending
30083	3NKmFSPd9aBorJjxUHe8GRH6CPAe6sZZwKRoRMBTXAGq3Xi2WhjZ	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1403	786	607	12463	18974	jwdLXEbvyStVXThCXGvJFTL4qAak5TenfYwYNN9Poysfhg1dQ3u	14811	20847	20847	1619691660000	pending
30087	3NKW1ozjUTwiieSZ7vZQgJyNiiSHYUbbs3uWv7W6rvhx6S1L7Qik	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1500	1297	608	12463	18974	jx4qjfN9tHpzsxJpn8MsjkJbj1Sjt4BdKyDKTfntwpjK3Cj3ytq	14814	20852	20852	1619692560000	pending
30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	30086	3NKqQpgTKV8ixYtUq9kLPCM7XHryPhxcXL8y5EzBSTLAiAffBpjB	1477	1350	608	12463	18974	jxmVfNzXPgFqk4v33CTDoPnqCvWceWUZaLLyVXRFkqzKhLDUeRE	14814	20852	20852	1619692560000	pending
30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	30091	3NKJPTgn5jGK7PnaRyrhzq1UKqZx9nMyj1N8fuU8LQhA9BXNfq7o	1403	31	608	12463	18974	jxFnN9vFm2NXYyH7YNubHEpPFkws1MU1BtDMonB1DHbh28onByj	14815	20853	20853	1619692740000	pending
30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	30097	3NK9pCNeF7BjTksdDuT4Em26Df6wu9oWfCSRp68d3RV8DDYjEjrV	1407	1395	608	12463	18974	jxXDcTp9t9uzZoRoDezaLXL4FQvqJUDg8t7pEHa3xZEvuMYYKby	14817	20856	20856	1619693280000	pending
30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	30098	3NKbkr5nM4aDtQhgp9uD2UovQxiPXHPgaWoQkDnSBoXz4V5QGS9f	1651	1055	608	12463	18974	jwKtEtd6WZoZ1ow8CMuUgZKbDoQ1Ekywjr8BskejfsUUzn8oKgi	14818	20857	20857	1619693460000	pending
30115	3NKQLgucxzXZWUd8kY5mAnLEi1wJNyrDwnhfwRxxDUieVzajGoHo	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1476	1125	608	12463	18974	jxv87PQ7sRTeeXrXiSguqqwtHqEambMQT7FedRjr5tRGEYp43D9	14820	20862	20862	1619694360000	pending
30117	3NLbDPTD9B4nAUKuau61hB1wr5g2Q19uCgLkuNG3BHGzE4MeLZEu	30110	3NKGasNXQEndomddsKRiTCyuWnU4bDkCz2G77AmjBxf3tEgsWyes	1547	1012	609	12463	18974	jwrBd7U5TNqvwrzbBkjuJkrb7dUXPNDNEro2omZMpp9xZ1LfC5B	14821	20863	20863	1619694540000	pending
30122	3NKQG2DqXqEHFJepbitFZihap2nSQNTcud1Z8wEjRN1zDrZR64Tm	30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	1440	1251	609	12463	18974	jxGsTzPxRz7wEHzK8vEfPAGQ5YziqhJ3KbxKMMShCRWe2NPVDvr	14822	20865	20865	1619694900000	pending
30124	3NKAkj8gSnSd7mLM8gu1BMuXKD6qcKTkinnJkoV9dPRr1dBkPniq	30123	3NLScUbGdLoKnkw4S38eKPz2DUFPKhTB2jXbU2skHMRRdR8WQH4k	1633	1390	609	12463	18974	jxwsrvvAWPx5CgRxoPSw3DfgyuDDkWkmP3rDsZoZs8P77EGQZMB	14824	20870	20870	1619695800000	pending
30126	3NLRz9H5QyK3QrAocLpt6k3jDFTFvJSUuYmpjPJcEhKtLEfjW2tB	30124	3NKAkj8gSnSd7mLM8gu1BMuXKD6qcKTkinnJkoV9dPRr1dBkPniq	1602	1243	610	12463	18974	jxdnzpokvq5gAZ8Fxq89d79ADxCy3gKHmZnMU9ZETD8peZ4XfpJ	14825	20872	20872	1619696160000	pending
30128	3NK9qu9TNdXvMx9Bs2WHo255Adns4TuUkHnAD36FTrtNXytWA2qw	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	80	1273	610	12463	18974	jx3ZHamxGkzsZgwZ3xXJRdqnbMrgnZ1igT7AHTj328zqrZaYQMC	14827	20874	20874	1619696520000	pending
30135	3NL8rpRYW89NeQZRFGF5fs9WkqMpmsCiqZpktZJTQLnGdHc8HGMr	30134	3NL4ZNhqrWBiFmWG7rAu6uhHBS7jxDMqnBPG7od5L2npB8CxB4cL	1619	1029	610	12463	18974	jy2rZUqu7CDUjHYQiiGjmmvytw8Ln3BgnutMN7PPMCbYEHrA1By	14829	20876	20876	1619696880000	pending
30137	3NLFhD6WZFZ3i1K4KvEsw2FZdYgLjqnLTX2Lbd6aRRTq28Q4Mz8V	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	606	1295	610	12463	18974	jwuAyuTbhzKULV9JAbZeJKGzJmuVvXjpKj1vN9g6gDCfxnLDwif	14830	20877	20877	1619697060000	pending
30166	3NKUCYKv2393HqmE4qxxKNXuz1CYtAYPzM5zQ8XqZHWZtwG8TtxT	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1599	1287	611	12463	18974	jwnpbNFo9EGxYUdBJzFiUASQoCWmiCrw6rUKDgh5FyExEVr8NPi	14842	20894	20894	1619700120000	pending
30168	3NLdgEjdvxAuiDgqtUhq7w9vCvqSEM4bU8Fs8M1dZ3ohgNrLxhAd	30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	1617	922	612	12463	18974	jx2PqFrnAH12r7xqXEfoZsqXGtmuZAcYT1mHLcF3X9CzrBi5m7N	14843	20895	20895	1619700300000	pending
30170	3NKyTUUhjQhCEu778LoQE3LkyBSaTQErfci7FMVLwiZVQ5oddNkK	30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	1523	1195	612	12463	18974	jwEPWPiSNh8Y47NH2tPkWanitmR5iSRAZHrZ2RViHw8ARex8qWx	14844	20896	20896	1619700480000	pending
30172	3NKnLg7MZxctR7H3jLmeYJHS2MGHqNAu6xJD6aqgc2VCxLgmP9gJ	30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	1523	1195	612	12463	18974	jxopAPTVSjxKDBf3YS1nAJWg7PgmWEvJoY73T168AEQf18XJcP3	14844	20896	20896	1619700480000	pending
30059	3NKRDEzYwhkQ2iLKHCcV6Bx6XCvawuF6wbemNAbVXLFX4owqABAk	30056	3NKheNqnHgEoMxENPnt3dtCn2c95jVRy8JPLwa1bN2CWT2KDs1Zv	1602	552	606	12463	18974	jwG77L4KBCY566QYVsgTMQjRbJqWEvJTUSKk1gJSj4mcw4mDJ8h	14798	20831	20831	1619688780000	pending
30062	3NLMwaC3hkSt13VyxQbbuwU6aEZSnGVtLDPXQgVdfnKmoqPtr9mm	30060	3NKRg6VpbzAcnjWEbbajaYCXsyiz7nvqrC1FoimdM61q1Aib7Yny	1657	79	606	12463	18974	jxrWPF87nmjUFtqyQvyNWgUoDhvt67GMVDTsYrQY3JuaNTTDA6W	14800	20835	20835	1619689500000	pending
30072	3NKuET4oceW9oLHxJMw8yHUbF6GhXtPgnsa68RiSZR6v9chXGoVc	30070	3NKw7Furi9UE8Efae9CsHhg2Qou1fepRb69bgskCWf1Hze6AVqzD	1637	816	607	12463	18974	jwfuKcsNJfj6STPBEmVcqoNmEfgu4LD3miHGAZi2ibMd2LWbzMg	14806	20841	20841	1619690580000	pending
30075	3NKZMtNUt4cw5wBKKt295eNJf5e1vEiQFtLJwZtLTi6m5yGTvdKg	30073	3NLqQTS2dEsVgppUB1YjsDZwSi3y6tkRLJhi345tKwBx8oyRM5ds	1448	1311	607	12463	18974	jwbDQVrca9yJnhnaCkpvNk8P5mP2wkuoaKzjE6G3cLyEdQbudjY	14808	20844	20844	1619691120000	pending
30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	30077	3NKCYwRSA2v3BSvqLmH1XiMnjwtEMtttjk3hPqRKgyJqDmDzhXZD	1549	1236	607	12463	18974	jx8U5W4XA6v4XDAS2AgdEfgXpM4VSH5uvyuYYNRgHYYFv4rAdbu	14810	20846	20846	1619691480000	pending
30084	3NL5pHc7fthCEAti2wUGa6W6WJSAraYosmCi792mAmbeDMkcZ1gj	30079	3NLGfZfNuGJLZ1Hm2wDeManAhVw8RvC6qxJbGks7No5TYzQWCF6D	1460	511	607	12463	18974	jxRt57L1Xo3ZgSjz9bVum9nm19wRWgrhKTfB2BohLrmFv6ijCCY	14811	20847	20847	1619691660000	pending
30085	3NLMYJVQfSX2o1hPnkpfSmCog6KWLWHfuoVXkLW2xeyEN9jyQgti	30080	3NLXsdJ8Sp9w72yZRvuzyJ9Pk2pNB7CacjxpN9cjgHhSttwFYcAz	1611	1095	608	12463	18974	jxk2AwiBf3Ye2LNVK8k1kweAiXzVtsdXjc4YyssMs8E5ZDgb1sJ	14812	20848	20848	1619691840000	pending
30096	3NLvH8EDReLSHzrxa37xCa96bgGhCm4SsNoggpLsm7dCX3vykWGM	30094	3NLHJzjgnFogHH254sWfD3j8mrztw6D3Xmn4vzURs77ZTGVBB6dU	1542	1178	608	12463	18974	jxFRs3SLKpRvKAtaDPKR4q8eERAn1LPXa6oCaDk3Xs5CtPPiNYg	14816	20854	20854	1619692920000	pending
30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	1464	591	608	12463	18974	jxucKhqSVacUvbgREinzaLt28p8SHio2LnBjXUM6PiyA5YVSWbn	14819	20860	20860	1619694000000	pending
30108	3NKVrWKyiNwjokw11mEwg9PHmCyCUZkTyL297ap5HqMxrvQ6htDU	30101	3NKJZS1zP4pUcT3KbGLjv6yoJYZpQGxDyAGj83Sna5yTT9Ykxitp	1464	591	608	12463	18974	jxsE3EsnmPGZzghjFNEBJyw4FGrLEMD3LKwn9cpjMcLHZMw5htV	14819	20860	20860	1619694000000	pending
30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1522	1322	608	12463	18974	jwFCvt1wijyduecEE2sun3znviwRXgCAWP9m1GJf6TgQtrsjVXX	14820	20862	20862	1619694360000	pending
30112	3NK9rNk5934oXbhns91dKKPb4YFA6cGBnnT1sFKV3duoszQE9jmX	30106	3NKHjE63gdMMoGxvoyjCbkPA2nPz7vSgeDPV2gAhqrmJCxYdjcKc	1476	1125	608	12463	18974	jwgVBBa64BQTbMYe2yMhPJ7fhAK3dgPGazSBUFvzRVsWHsgUHC3	14820	20862	20862	1619694360000	pending
30118	3NLWwRh5FAGnHeDhonFpJbUVnhy4bg4HKCb4HFR1E22ubktwq7Pi	30111	3NLNqKU8taodDaDmJUyYnNZxZFUiHmpdMNNkSc99aMcvQ93MhimJ	1547	1012	609	12463	18974	jxt4bJxt6xUhzznBz25Ks5uSLACyLSaYM6u4zDdTbSDmd4FePWk	14821	20863	20863	1619694540000	pending
30120	3NLu7jAEm3RbUbt3aQZKxB1WrRtUYouLX8X7QG6EgC8JKbvm5bYb	30116	3NKReJkZ3nD2GFRMhwYvqM4YeUpJaULCahQeVpWRPEu9wL2riXUi	1549	1362	609	12463	18974	jxa15nw8FbnXsMhXX93qTnMeCygfaV2t4nJ887BYZj3Y1VCMmgM	14822	20865	20865	1619694900000	pending
30125	3NLUX5bbc3HD4APX1Qy5F2Xm4STMr93hpPnLJE97trn5Qky6tebc	30124	3NKAkj8gSnSd7mLM8gu1BMuXKD6qcKTkinnJkoV9dPRr1dBkPniq	1407	1395	610	12463	18974	jwGAgDj5cK5dw4VHsuRpLG7NZJnSXTD1TAvemngoV4fqSn2DAxA	14825	20872	20872	1619696160000	pending
30130	3NLprv3QY4e7zjj7LAc4dJEogFBUsWKveawTqYrCq4BEa5dvjUSm	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	80	1273	610	12463	18974	jwnH9DE8BAoceRBqxDCiNNVuHMeHDBUMf4gDjCZZP34tBX3bB58	14827	20874	20874	1619696520000	pending
30132	3NLBSsZp2wkw3vyVEg5s3c2LifRcF95FVQPtoVy7ZzvZyybf3fbx	30127	3NKmJasonv4eFzzFZkXU22W7p1eWuKwr3gsUdQhGtGENxzpchCax	563	563	610	12463	18974	jy2otkzVDatvm1zLXDSxcDpLoMkRwVJ2xL5zaxogGbUst28wzfw	14827	20874	20874	1619696520000	pending
30134	3NL4ZNhqrWBiFmWG7rAu6uhHBS7jxDMqnBPG7od5L2npB8CxB4cL	30131	3NLhazy4hH4yXRs5JgzS8gRwb6tbjjX5uL3MjF6JYj7p9um9tx2V	1406	1393	610	12463	18974	jxRtm6Wx1bmNQtsh6h1pJ8AiWUEZoKQezx7Qafu7Jpj3TwPViKD	14828	20875	20875	1619696700000	pending
30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	1594	1200	610	12463	18974	jwZPcEgQtmen7RvtdbABVQ43zioS3A4uEfZrjkcgkouPp3scNpb	14832	20879	20879	1619697420000	pending
30147	3NLqJAcEj8yz13wfngRwUGgpfj39HW7V677gevV22k49HSkW6weJ	30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	1457	1145	610	12463	18974	jwgXrjZXnEmBUpszQi5hLuJcrZs9hcGQxbf9S4Pv9izepw7hCnd	14833	20880	20880	1619697600000	pending
30149	3NLCvxKRc5bKrGn7S4WcMUoQN6wyPDsSWML3bdA4fDFF9z42y7o2	30148	3NLZpuEqerGSc5YoPXZQoU2pwjrD7mxQN3JwPLbA6yQpQqLWpQda	1407	1395	610	12463	18974	jwyNsd3eFk1MEGARAU8dQDpQQkKFvubwivcrFeVkx4mfxJCab6P	14834	20881	20881	1619697780000	pending
30151	3NKXJaac9qfeV2UdVS23qVRZn9RaVXpyLv9JZ5EbBeBM5Un9bn8E	30149	3NLCvxKRc5bKrGn7S4WcMUoQN6wyPDsSWML3bdA4fDFF9z42y7o2	1553	775	610	12463	18974	jy1JqTNnbsv5ujqX7rbpVwCLF5n3KA8WYJHbcaQkoNw5gFxNUHv	14835	20883	20883	1619698140000	pending
30156	3NKXhNa3vuEnjdYMwqHmedpiqoU76V6Tjdxf84WbPqHVmngwzMCN	30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	1670	1036	611	12463	18974	jxuDcydCBxTtVnTzRnonX4VXSBq6tZbs2GbTFSKxw46BefQyjxt	14838	20887	20887	1619698860000	pending
30158	3NKs2qoEAEiK6UBuLtc8ht7SRtJhYhHNJbB6g9NDodLwLhdQYQnH	30155	3NK3aq7zovkpw1ZUoKa9Z74crBDk5q2K5Vr7gMUwMcDttmHge2YT	216	216	611	12463	18974	jwZvBmLEm8twtpPbMPjPSNQ4uuASkMKJ9Y4kZqzMyS4DHxpgf7B	14839	20888	20888	1619699040000	pending
30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	30161	3NKZANShucbvi6Shru8KQYYYhW9r93NwF7ktmdkNZyTBXEHHfH1Q	1407	1395	611	12463	18974	jxJ7Ci2kHc1BYwtgrPofL9frySSPLeNxnyaQt16mgnYLw523NeD	14841	20890	20890	1619699400000	pending
30164	3NKNZQ69NHMpTR6bjesQ7RC3h5P8udQVo5NwyE4zjxZ3ALEAU61p	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1509	1320	611	12463	18974	jwmzCxaeQcg4zwKHpDfJ8Rhkg9jjLKNh9XqUESvPZMEdcdWT8bt	14842	20894	20894	1619700120000	pending
30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	1587	991	612	12463	18974	jxojAXSfJszXCdH2cLLBHx7qhCU6CExPWiv3ysQFsopecKP3UGR	14843	20895	20895	1619700300000	pending
30173	3NLYkbayCQDUMym2pUrDqsiSuJZQEouQY9YW2mYMktPVxn3WtEvA	30172	3NKnLg7MZxctR7H3jLmeYJHS2MGHqNAu6xJD6aqgc2VCxLgmP9gJ	42	1235	612	12463	18974	jxjCN9qtWSnrg5iArXzj57PfRD21XypXCAqVs8z2W54tTsrDj4t	14845	20897	20897	1619700660000	pending
30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	30174	3NKohjC2RNzRtzu5dTaHkAMFj3WCXmMK5kPzS6YPcK27KMeYymzu	1581	778	612	12463	18974	jwgFjaYXmeD7SN2VtcdcBYVvJxqd7GJaGyw8myNS82z8jK93u5y	14846	20898	20898	1619700840000	pending
30177	3NKLDdHMwUbLL48D3hJStLt41QTaBN42UuzXgQvYwsxGxBfyehfF	30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	1483	397	612	12463	18974	jxQ68mWAu2oDxEb2fGKLRu61MjrzYaSJfyoy972YfxKuqiExgPh	14847	20900	20900	1619701200000	pending
30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	1637	816	612	12463	18974	jxDENFoVZxkYSDcni5Sv8XBw36GA868c8Wdqox81aTTuzqQm76b	14847	20900	20900	1619701200000	pending
30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	30134	3NL4ZNhqrWBiFmWG7rAu6uhHBS7jxDMqnBPG7od5L2npB8CxB4cL	1619	1029	610	12463	18974	jx7aQncwdFoWuVPPPfXTz1oQqZJjWeLP8RgKBuGCkzTyTAD8RHF	14829	20876	20876	1619696880000	pending
30138	3NL4LH1VkohzhysAkbB4kziTUodoYCPeZAdTsUza8mXTywNqs7mT	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	684	1106	610	12463	18974	jwiiQDcDEEQZ5cxZ2NVWVijBjCe1z9NHVYrZSWrWFCCnjD4YzPU	14830	20877	20877	1619697060000	pending
30140	3NK5iXf63Xu67CqmT7nfkA9kT6YY2v8qfYaQ2Lk8e3GAzrKNGZVx	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	606	1295	610	12463	18974	jx4s8q6Neu8awbhrypduiXuUf9XHVukPKQeV3B4GPWDW1WRxYSk	14830	20877	20877	1619697060000	pending
30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	30137	3NLFhD6WZFZ3i1K4KvEsw2FZdYgLjqnLTX2Lbd6aRRTq28Q4Mz8V	1608	1289	610	12463	18974	jxjJERGwZxcLRmDXh7p2Zq6pKKMH2uazttqSJhLQMwqJ4mbDyA7	14831	20878	20878	1619697240000	pending
30144	3NK67hAfmpTqXTcvL9L3NnLRptT6W73QaXds63dgSWX46zgY95ze	30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	1406	1393	610	12463	18974	jw8DDcowuenb8R9h5SD7Xx83nL2KXGSzutANozxQSoC97iSrJPa	14832	20879	20879	1619697420000	pending
30146	3NLKySEVr3xhkXYrdNaPun8uVY1kn3oZZe9NbNCchBZGMfv2ECwK	30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	1509	954	610	12463	18974	jxmvS8W7GExSi4orY5HUe23m7tFzD9aoR9DQncNLp6MQxvdpEQb	14833	20880	20880	1619697600000	pending
30148	3NLZpuEqerGSc5YoPXZQoU2pwjrD7mxQN3JwPLbA6yQpQqLWpQda	30145	3NK9TF2wVr3gW4A15nHfMzF3aZQfVDkNG9HpELr9LTQoXyzFPjn3	326	326	610	12463	18974	jwrmXiNgscouYmGSYyvvZ7gPVehSdPsHbyvamXHWzChmv2BQ8mN	14833	20880	20880	1619697600000	pending
30150	3NKSYmJrthTgcM3RoWcZmYHEt4RjQabWHvhZKjavTX71cNquhc3b	30148	3NLZpuEqerGSc5YoPXZQoU2pwjrD7mxQN3JwPLbA6yQpQqLWpQda	632	632	610	12463	18974	jwkutyJLpg2PzPQTjQrj6xGcVrJwU1ZrC95MSuoryMusbtYNgKD	14834	20881	20881	1619697780000	pending
30153	3NLFMajibWF7SJsZZHviuoy2hRGJgFERq8W3MXD4Tptmrju1TqtP	30152	3NLLavD6fnr3UtkJizFbu6XDTAhghPyzasB7updwKqzJVCUPRbqb	1657	1344	611	12463	18974	jw8vwmYHtaA4dAhrCK3fdYvKKviBwyj5QnjiktPXrcThGR1GTTS	14837	20886	20886	1619698680000	pending
30155	3NK3aq7zovkpw1ZUoKa9Z74crBDk5q2K5Vr7gMUwMcDttmHge2YT	30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	1405	883	611	12463	18974	jw7N6CFv2CgJtwEEjJf6q6Upo8s3LN8GtGtXbovzSGUFW8Hw8Fu	14838	20887	20887	1619698860000	pending
30159	3NL1mJZ1xJ58pG2fF7pRZJ68ajpcyvsnkGYgeSqTr1kyfane2ieL	30155	3NK3aq7zovkpw1ZUoKa9Z74crBDk5q2K5Vr7gMUwMcDttmHge2YT	1631	794	611	12463	18974	jxrEX16DLRTVXLG2hPhLJxjr1EPNPuNU8WeFJjWJX4bPk1FKTjN	14839	20888	20888	1619699040000	pending
30163	3NKE4L6XsAAApmbFNzmMgrXFY7k1MihvuaKMZwCGCTDpbx8xKUHx	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1509	1320	611	12463	18974	jwkGeSGA1UcwjoFjVnbfkyngg5abWwdS92tHkP51aMg4njkGTpo	14842	20894	20894	1619700120000	pending
30167	3NLHMSKXGJaxobMZWoDfm4DoLGLxE8ZoERrVxD7j2J2YB9jKrviP	30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	1397	828	612	12463	18974	jwr8bxuB7HrfCK9N4A2wRo66sGmWKvrkCPH2FgwGEP3Nrok8eAf	14843	20895	20895	1619700300000	pending
30171	3NKBzhYiRmEkJ9YA8LW5xhQi5scrLV6T4mudNvgScgDP1LUuA5oU	30169	3NKxgBqpXvRH9X4g6FdKwFMamYQVjeXnV87Qe45HGMaJd5i11yLk	1523	1195	612	12463	18974	jxNHAEzfATDoAxuQW4ahZ2FPDqpqCr8aEojFFgF3MGykNuEjxm1	14844	20896	20896	1619700480000	pending
30178	3NK8ort4gvc2FehmpKbmqhrHohiek3Y6hRBmP2xWskUR7yubQau3	30175	3NKX7ZS2ejrURi8VsXtKFGULVYGbcKGU3MW6chqTu9XdNFQfycB7	1483	397	612	12463	18974	jwC4h6VN5RSw9Zmx9rKZsMGZxGHSWLq3MRHCQt8nX7ZhmvoKJqz	14847	20900	20900	1619701200000	pending
30183	3NLbaRwdRHB67A8eEMqcB4cUFMUqgJsRJYipqp4bzkyTEXmm3ACe	30181	3NL3auq6wMAK2emWk6ydPNazRt6AXhhipRoJ2cgyiQwMSwBXgkwZ	1610	1068	612	12463	18974	jxk5MMtJ1aSUDJcADy15wxxUgfLEp114p52eQNtsDfAyiqtMGXA	14849	20902	20902	1619701560000	pending
30189	3NK78UGnn73T5MRAxJb8zw2JVyVbNuNkVe9euVZ74j2iXX6dxGAe	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1553	776	612	12463	18974	jwe8wBLYAgjE9U4bcpZL3dPPMZcCdj6HHVGfNNQav8WreaZZhUb	14851	20905	20905	1619702100000	pending
30190	3NK5XiuGdmHFYBoNmp2QAuKhSBvcs2fz3sDwoFgjmjRhkn2ykGtL	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1490	123	612	12463	18974	jx1rP77TCQBUqSYHF9BbzvS45ZUcoudpoU3DeHQeDHfCfBVVu9x	14851	20905	20905	1619702100000	pending
30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	30190	3NK5XiuGdmHFYBoNmp2QAuKhSBvcs2fz3sDwoFgjmjRhkn2ykGtL	1637	816	613	12463	18974	jxM4hrYjnw1ywJvccChuEMjcTY7mZepFD2Bpr565yKsrkafuL1o	14852	20906	20906	1619702280000	pending
30197	3NLCJJkEVLqAAk9qcLmVJixk7HSMxP2UnPz6121nVK53HDYD2bTe	30195	3NKzi3oy59tbGW62RYFrsfuPAVPDAjcvr2pYbg9bqBwHWcLyx55V	1590	1174	613	12463	18974	jxcsvJnptbABStUcG7DkY4ci2mBRRTxrqxPmCmELpXUAv6ftiNv	14854	20909	20909	1619702820000	pending
30160	3NLaxjJm5wRr4r7JjqXaA3Pu1QAjJrSxorG64dUAs1d6zBtzjF3s	29878	3NLH3eNkmb2X7mtHL9L1FW1ZwX5Sxfya4nqhQ2A5HdQ7D8JqT63s	1516	1294	582	12463	18974	jwo9NdAx3jaPnFpGFjAJh41piZxM7sq9fzTiUojbX9vow9jCvw2	14593	20889	20889	1619699220000	orphaned
30176	3NLJyR6AoGxKezwMVLdCXybAeGjx9WA8iqQbPqws2foAv7afZZ7X	30160	3NLaxjJm5wRr4r7JjqXaA3Pu1QAjJrSxorG64dUAs1d6zBtzjF3s	1516	1294	582	12463	18974	jxpapMcfKYzz8i8kdHqyfteGyNYWUwAfFtRpL7rhwmV3616y9pn	14594	20900	20900	1619701200000	orphaned
30211	3NKcsTyxEtKpeSr5Gmhs8xeiaDedbER9qkcrs8Mzj2nNZuq88Ymd	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	684	1352	613	12463	18974	jxK7Vx4Qn5oTj2qRCoNVRo5VatttTnxbyDRBoLUARn8RNnnoP4B	14858	20916	20916	1619704080000	pending
30222	3NK6xFiCE9tj1iao5p6MXUtMDfGowwxS4CuPUcahMM7j48dDo2zu	30221	3NKLedebGjPizamFx5C3tcBGSXmR6DPZ3hPVPQ8EoFxGskR3nkm4	1593	1100	614	12463	18974	jwYgdX7AbgQXqygv3xsjWZyGUpyWW8pQ1aHMksD1c8geTXRNHZi	14861	20919	20919	1619704620000	pending
30227	3NLjjwHNNmUZoV7oLgKqx8m7B5ZSVgUF25PbbACVUZfr18tjUqRi	30221	3NKLedebGjPizamFx5C3tcBGSXmR6DPZ3hPVPQ8EoFxGskR3nkm4	1529	1316	614	12463	18974	jwNweowYX2p7n5kgG6LXgdaKXx48b7fwC3Vxp8iHrYNey5PTBhJ	14861	20921	20921	1619704980000	pending
30228	3NLmKcVGJdUiwsNnLFCMKkaeAJPHFqQyJpfNfo6M8VyEC3FwNFeH	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1406	1393	614	12463	18974	jxPokrfDANjTYukVSzA6N9DWTi9vvHJLftALUb5No4M7S2dUirg	14863	20921	20921	1619704980000	pending
30229	3NKmXEnNxbmAznGS62CxmSp5fXa23eq1UKWbe1F5cyZ9zCBBUTA6	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1529	1316	614	12463	18974	jxFVYwC4xoJm7nVhN7pAMD9iaXMk4cpYjawsADnSrrjWspp7JNm	14863	20921	20921	1619704980000	pending
30231	3NK5nq7EUVhLX86mTX17m3WkziQbLqK4sLv5nBVTDvWGmaHvUAig	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1483	421	614	12463	18974	jxX3jASDXSrMJP8vkb5z7dbu9R5suxLXnKrzuZaNkU6HGWGEXRk	14865	20925	20925	1619705700000	pending
30234	3NKyw3uHCoT8mQn6KPQv5Z3JEsjTJGG8T5oCv8eppFGjh7wwZFQs	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1637	816	614	12463	18974	jwuoQp2LTSwdY7zSjaR6UNGiXa5Tjc3uA2KkjRckPYA2ga7vD9q	14865	20925	20925	1619705700000	pending
30236	3NLx18qFWoFbXo2QwBSar4gLDLH7W7w1LmbmfdqGyFA2YLBomPyz	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1541	1298	614	12463	18974	jxArn27oh4QiNnDiPeRLzgsRAPSRi1d7yV1bDy2KPp1EHbDcG6j	14865	20925	20925	1619705700000	pending
30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	30237	3NLKUyKmJzYqzLNV7u87iVW3svpCWsqnVngBYbPWBFvztUsC8LBK	1402	888	614	12463	18974	jwiqJJAcYTtV4wL2QaKqRUH2VeNHbJyT2BbVkgWGd24jZC1AuWy	14866	20927	20927	1619706060000	pending
30139	3NKZuMZdDCkDZuPFHfkzehrPbUaAUV1XNGCo68rs6Ga1XNPTpTw6	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	684	1106	610	12463	18974	jxdK3nuEgEj4jDxCRgzMouGgUbERuVnJCJekFVt1AToCocQac6T	14830	20877	20877	1619697060000	pending
30141	3NLfon1Tz3dHy9CnKNCZDZdsumm12ijXmLd7QarQVckMcWTrDcGq	30136	3NKhqoHmA6hwpgwhfRANrTbJaqs24eZXSwdDMBtjPPU4nD4aq3FL	606	1295	610	12463	18974	jwV319rBwnhiz7kxQg9ybcqz2NVDMUqkYJ8ksRSk1R9oWkBNXft	14830	20877	20877	1619697060000	pending
30143	3NKdjBDTcXezn3KjFfMWHLfjUQzaKKr7KSeXbPViWyYZ4UcbPfjF	30137	3NLFhD6WZFZ3i1K4KvEsw2FZdYgLjqnLTX2Lbd6aRRTq28Q4Mz8V	1608	1289	610	12463	18974	jwEm2UCEBqrWNEt129kEuMALiMpYBQGzRmfe1guRYUS1qeZYnhd	14831	20878	20878	1619697240000	pending
30152	3NLLavD6fnr3UtkJizFbu6XDTAhghPyzasB7updwKqzJVCUPRbqb	30151	3NKXJaac9qfeV2UdVS23qVRZn9RaVXpyLv9JZ5EbBeBM5Un9bn8E	1542	1178	610	12463	18974	jwPwVsSPZ2tmmGbp8UrWGmDgFDrrzTPpYcjpWosckmcVZV2kcW7	14836	20884	20884	1619698320000	pending
30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	30152	3NLLavD6fnr3UtkJizFbu6XDTAhghPyzasB7updwKqzJVCUPRbqb	1508	1387	611	12463	18974	jxdA9X8qx9VqrVwXZL38hV8seUSwM3S8vAs98y3rtrswZkLUpTo	14837	20886	20886	1619698680000	pending
30157	3NLHQqSjoWPLATzxcwqhQabLoK7G97U6YM23AngaQa7cbjfjuy2o	30154	3NLCqTKRUSFtLaR5fRvEhSbqd3WGUwFjYdVsSBvcuX3gXYVHNRk6	1670	1036	611	12463	18974	jxiFxudZTzb9NqimtLXvQ2z75hU6RVTC5R2SgEh9YHhPip2MNTn	14838	20887	20887	1619698860000	pending
30161	3NKZANShucbvi6Shru8KQYYYhW9r93NwF7ktmdkNZyTBXEHHfH1Q	30158	3NKs2qoEAEiK6UBuLtc8ht7SRtJhYhHNJbB6g9NDodLwLhdQYQnH	1457	1145	611	12463	18974	jwienHXzqU1HLmzTwCnjcPoFY9ux2PGtaZXNuQm6bWuUPAMRo4h	14840	20889	20889	1619699220000	pending
30165	3NLhiisSkA8HXPZnU4XwoW8Wbs4sRGHTAJSb3ywGdgrDuMnYLQc2	30162	3NKnLgo5GieA8R5ufG9kJJtoSX8tGaRmmJfPf12QdpBG3bTZBDgS	1599	1287	611	12463	18974	jwnpbNFo9EGxYUdBJzFiUASQoCWmiCrw6rUKDgh5FyExEVr8NPi	14842	20894	20894	1619700120000	pending
30180	3NL5cYeajLbLHXEyUagQktd2mgB3gB8farE1fSNDG1QcxkEpgSuM	30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	1444	1381	612	12463	18974	jwJKWsW6BijTAJ1sdjZ58TmCy79zgZeSfkiMt9KpmN8x4tZb9dB	14848	20901	20901	1619701380000	pending
30182	3NK3nD2aF19o7sc599RSBJRifDShM4fyUr612yhaAA6LBpdvxifc	30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	1444	1381	612	12463	18974	jwSp9d8MXGZNMB5ZPJe1t7HZMizxTNRayKW3UxU2pDdnFnWnBFB	14848	20901	20901	1619701380000	pending
30187	3NK9X3sjg4hcJHH4goH8pVNevEP7738hZr2Ko4j1Dpvp3kMoMKJJ	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1490	123	612	12463	18974	jxE1XScX3a2VRKDqzjQkxifs8FZAwZqiaw3e4AE5jFTEMVRH8J9	14851	20905	20905	1619702100000	pending
30200	3NKsEgfdhA3pKbxKix2Wd9mr3p8hDRRHJheGumnEDaDjuuQwWcLF	30196	3NL7vtCnSNT6ALqivSgybip2n3NMa3bbt1P51GUnKMuaJX9QD4t4	1590	1174	613	12463	18974	jxzLEgb34H3Ucr9HJGVVCgaTtAzuWQaLsB1sSHiFG8LxhfYyLPt	14855	20911	20911	1619703180000	pending
30202	3NKRjfcakgAYC1ztupaNPsGxynmwCPtyBgoQN5jYbdxnpjczn8iH	30199	3NKbYTFY68QUdZeQZzDYN1vrEK6E3G63wx8nUDq5NdEkai59mw4P	80	907	613	12463	18974	jwaeg27szxDeCKk3WaiztoobyzZBVepvapY5ScCsns29caYLtob	14856	20913	20913	1619703540000	pending
30204	3NKFm4gSJEApYEuceuFFvBsw599WpQ25ze4VyUDjfhM5rHfCAL6S	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1609	1087	613	12463	18974	jxNRPRQkpVNZkCrhdM4EB9oiQmiM6yPRoLJqodkULmsY66Yapan	14857	20914	20914	1619703720000	pending
30206	3NL8ZGX3isofXJgoVeRLXvcxthfjLaw8soGKLenXwLDD9p7r6Rh8	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1637	816	613	12463	18974	jwJ4N5aAqHuh3mM31p9Zvg6nrdXzjL9d2VmekPJkPLNoMijaF8d	14857	20914	20914	1619703720000	pending
30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1609	1087	613	12463	18974	jwcUJYTuTNvk1YZe1r5JqaYmr8u6ZhHjySHxn4PcfyVmskmVPZd	14857	20914	20914	1619703720000	pending
30210	3NKSyARDY9e8pK537NxGnkXc4wm7wgUfmSg6wdVE7vThZyEjYdSo	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	1406	1393	613	12463	18974	jxZZb2MZ1VKMqGNZnyZ4Pocat1V2QHTpJ1dieiaUTtfHwUMaEpE	14858	20916	20916	1619704080000	pending
30212	3NL3SuLsPPqW37myzTzjvDRwEhjdrn8w1KYJ2YUTj8wDLf3SzrBJ	29664	3NLJHTM1F4nWqXGyAUCDMsCfKBRgroUf9cRs7CZgahhMKfpNUbSS	1403	824	585	12463	18974	jxhycYKNGuLmtyvGL1k87UQtUrbC4NuAE398ZiDjvt8Cs761nNp	14632	20917	20917	1619704260000	pending
30217	3NLPZ9SrUTvKbAYWuz7yza7f6TT7q67ox7obguHipCmMVnhkZan7	30211	3NKcsTyxEtKpeSr5Gmhs8xeiaDedbER9qkcrs8Mzj2nNZuq88Ymd	1523	1321	614	12463	18974	jxSPpjuBQvSz7PWJJqja3fbWxmR7Qk3yXKeoRBE6XiCJTbaN7sP	14859	20917	20917	1619704260000	pending
30220	3NKs9GTu2R7XigYTWtrKd2D624PnErtnR83gkRGY9xmqYqY5wHLA	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	1439	913	614	12463	18974	jwVDZBvZF29Ewiif6B5zcSauQtJT5trEiv1FGcay8VphrXabd4x	14859	20917	20917	1619704260000	pending
30223	3NL5D3HJJCgsWXCqLA31GYuVMJTy3ACWYeqC2Z63Nsyq5jFfUcEf	30001	3NLv6UwsRR68LXhbiYGn8ms3vY8hZG4Q1zJk3w1oYqY9XaWTV7Zz	1593	1100	600	12463	18974	jxyLgc6xhxp9USWpV3oqcbytdCTDRfNYKQ8rQXXrakVQkviHzGR	14735	20919	20919	1619704620000	pending
30225	3NL2chMDae3zdxU92cyu9SVr3xKgeVDuAWW6Zo1WSoAQmr3RyLLe	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1588	1146	614	12463	18974	jwTb8MaKAAMLXvRPWAg1xt4d4BzdgRfdFRW8U6KTWbPkm8h6xp6	14863	20921	20921	1619704980000	pending
30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	30228	3NLmKcVGJdUiwsNnLFCMKkaeAJPHFqQyJpfNfo6M8VyEC3FwNFeH	1402	874	614	12463	18974	jy1mtbsdjch168hgubJ2wefM5iH9PsCNgU5XWe1i15JCwmznnbb	14864	20924	20924	1619705520000	pending
30232	3NKd4GUSHQQfKsvCcvR4mwFJwZGtSuq1BBfBg9gC6BJMarxZCT6a	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1619	1275	614	12463	18974	jwXYfr7cYTtQPLMWneEx35jyZ3bMeS4emf6hZdk2ZRWpMxgmiEu	14865	20925	20925	1619705700000	pending
30235	3NK4gAMtfFdvG437BSTRrECT9YuPfVSf8dTGRevVBSPrPi2uFKUB	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1619	1275	614	12463	18974	jxBAFZnAyDndWrfpm1McVdgwuqiXhi83TnrrQJvKYmJZjgSw7MU	14865	20925	20925	1619705700000	pending
30241	3NLjEpiagyYsjJv7mPXK1faV7JuhmLnVqHRtZFJjBUUk4TqMS838	30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	1670	1282	615	12463	18974	jxxCM6kFfz14A789r6rYfXszbY7aV4kSJUXwFmxKc4g9enR41vs	14867	20928	20928	1619706240000	pending
30248	3NL4yHToErMwEnrY1sa8RswzM3VQJxHHiiteBuV3FSGathJnidxz	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1541	1298	615	12463	18974	jwhkPTsJ7XVfx8YHXa7CcCWUNfy67Zuo1Gn155A6ywzfE6xkRBh	14873	20935	20935	1619707500000	pending
30252	3NL7LasWkSvBf6813uY9nkA1kVofBbPYZ3FnfsWzu1ozSunWDZmE	30250	3NK4u1KBHubxBUTRcd6uDFHz5DsiWzirSjqqZoBhwFguzRLxfwgN	1406	1393	615	12463	18974	jwYDBpDVoHq7uSd6ZbNiHBre4DPWiYXPyPoxFLMDD4Jv5wUqHbd	14874	20936	20936	1619707680000	pending
30255	3NLsxGSWJzm6Yn2NjQRhJ9L98FVsYxL3PgaQoyDJTdngEMysQUx5	30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	1673	1368	616	12463	18974	jwmUULT6XR3L99EB58PZZMC7omuDmuqVHkmV5FCNQgBxUu738B3	14876	20939	20939	1619708220000	pending
30174	3NKohjC2RNzRtzu5dTaHkAMFj3WCXmMK5kPzS6YPcK27KMeYymzu	30172	3NKnLg7MZxctR7H3jLmeYJHS2MGHqNAu6xJD6aqgc2VCxLgmP9gJ	1559	1107	612	12463	18974	jxxqpNoC2UZMzoiR2dKTxjihaFxJAMswnFbJvsiw4GgqvEN98mN	14845	20897	20897	1619700660000	pending
30184	3NLJzMycdbTSQ3znBB4hgVTwGbWSkGthEBsW6Mi7pR6NhAtqwisH	30181	3NL3auq6wMAK2emWk6ydPNazRt6AXhhipRoJ2cgyiQwMSwBXgkwZ	1610	1068	612	12463	18974	jxu5PtTgEAoaZUfeaNaEgLjvtNSGK7Eha1utSTV2kzVxVYfrN6Q	14849	20902	20902	1619701560000	pending
30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	30183	3NLbaRwdRHB67A8eEMqcB4cUFMUqgJsRJYipqp4bzkyTEXmm3ACe	1407	1395	612	12463	18974	jxvtev35HpMAHctzCvyVxViMc9cTSGxb6Bn9BCZrq28RXC5BqFB	14850	20903	20903	1619701740000	pending
30193	3NLfh4cg3HcMcF1WkZjSMTzS6AYaAcuDVhgJtbuXJ7TUuc63ZWw7	30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	1490	1274	613	12463	18974	jxr6xwRa4bvkxbKz2b56C5pfADzMWfXNbnDi8bfwLQVFAzRTnYb	14853	20908	20908	1619702640000	pending
30195	3NKzi3oy59tbGW62RYFrsfuPAVPDAjcvr2pYbg9bqBwHWcLyx55V	30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	1631	794	613	12463	18974	jxRSRHXymBL6sTr3EGozcoC3MvvsKsUzME7Gk8WaL2kVEzvLZys	14853	20908	20908	1619702640000	pending
30199	3NKbYTFY68QUdZeQZzDYN1vrEK6E3G63wx8nUDq5NdEkai59mw4P	30196	3NL7vtCnSNT6ALqivSgybip2n3NMa3bbt1P51GUnKMuaJX9QD4t4	1460	1324	613	12463	18974	jxyBgt3Lr3xMMgmrhv9sWkahTw3P99sUpTnbvLaM4ingF8W8XDG	14855	20911	20911	1619703180000	pending
30201	3NKhQkQ46nF9eDXYvLyq9sshW8jUN2GxCSuw5VXd3HrGVrim2mSE	30198	3NKQrdVoSTHk4DDxDBi24xwL2X9S35qDspdBNvmBhG4LBJC3P68n	1590	1174	611	12463	18974	jwnU4E1R6DysxZLn3j46Gi4PNEZkiYT2ACV2k9zYycz6nUw3ECX	14839	20911	20911	1619703180000	pending
30213	3NKj6dj6vnjZBoZ9DyRZcaWxYbCUNqz78qyRrRgKZNc4fvPsZpka	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	684	1352	613	12463	18974	jxvCVQSdhjspRhSbkDvxMBCtmS8VZswrTHdKZPWra3JuN1Ac2UN	14858	20916	20916	1619704080000	pending
30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	30208	3NK64RdmgAMhqpHESBq6eCSbEgKTk1xCbaGNgomj1avafP3pbFQc	684	1352	613	12463	18974	jxvCVQSdhjspRhSbkDvxMBCtmS8VZswrTHdKZPWra3JuN1Ac2UN	14858	20916	20916	1619704080000	pending
30216	3NKdi6mraFQFasnaawjYDkDUo4wjvdgYjACcpWvwSFPbRntUKsCr	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	1523	1321	614	12463	18974	jxwkt6ubLhNWzSzvaKY44TPhkz6tBrP17Madbaw4mkR2DEfsnGo	14859	20917	20917	1619704260000	pending
30219	3NK32bRk7cxgKEoAAsS8wo42kHAdvA7GcGVJWyFBwY2fWLjqJQnn	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	632	1382	614	12463	18974	jwAG9e7GUiCRSDNW4xTLooqwyRM4CzaSFiFw95SpzvDuQbQab7t	14859	20917	20917	1619704260000	pending
30240	3NKyD4xLBkEAUrV12qgaENNgyc2Mmzhm8TyYRpReV6NAmRS28CGv	30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	1670	1282	615	12463	18974	jwMw3FJfPwt83GQ7ohioqrR33UhDQmbHcqet1iK77zNECNHCAeG	14867	20928	20928	1619706240000	pending
30242	3NKfvGhga6Rv8f2ngLhbLWyVqs6rurqJbEjc9NLaez3vdyX6LbBq	30239	3NKsWEHLSD99MdNhJ1HfcvreG2ZpHSP26tZnViL97RtpVcnysYHM	1637	816	615	12463	18974	jx1S5HQTg1HYW1DjuaY1PCUf5NqKsKWkquh5dYCH25ZMWzwK1hA	14868	20929	20929	1619706420000	pending
30244	3NLWW8D9r6Ac8j933nQ7GvgU962BrtSUMqGrwEsaoK9mXTSpimZ3	30243	3NKc8xaFd8CY7UrfcfbCemcMWE7DbhgVDywKB3WyzGypHgp8EZ92	1403	786	615	12463	18974	jxV3MPnbtK2qu47qp99xfccjPRYRMCZDWRRrndqxad9259GPcB5	14870	20931	20931	1619706780000	pending
30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	30245	3NLBUusiobC4B8tdxE5xhBxR1q6vf4iQvYrCsC1zvemk5xynTPxq	1637	816	615	12463	18974	jwHxm7siPvEM6pVZJvwhQFj3FJxDukttSRs1JHfUCq8x9ryoQRb	14872	20934	20934	1619707320000	pending
30250	3NK4u1KBHubxBUTRcd6uDFHz5DsiWzirSjqqZoBhwFguzRLxfwgN	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1600	1126	615	12463	18974	jxTSyWLTsioVNeVHBjoXkpzVAaMssPZ2BGQxCR3vZs6poWDmq8N	14873	20935	20935	1619707500000	pending
30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	30253	3NLbtVZRrZroDFZuK16ZGJufqxHrDzSNwewRHR3CAFLCqgs54Wiv	1457	1145	615	12463	18974	jwgaQwZsfPnc9GqS7radx5QRoRRdYHEE4cohf4vSR1ciUD5gksS	14875	20937	20937	1619707860000	pending
30256	3NKHtkSg7TAcrWor8xFVBSHQAj9p9rQoahArPLsBtUB32hXwrKSv	30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	1564	1338	616	12463	18974	jwtWu5Xg5pYi5KMECJwfSy2aXpKE9g2kpWt8dM8w6J9CcPLJARS	14876	20939	20939	1619708220000	pending
30261	3NKThpoH1H8fVSGq9atZswifyEUccG3AdDYRgPbSLgGsMhEqgTzq	30260	3NKP1qSq2v6d7RteACaygpBjSULKowLKu6KBt3QcbFR1ciJfFSc3	1402	868	616	12463	18974	jww8Z4trz2eCK7mRKxoxUffj9wbqbkJpV4S7v8KaDtGKaD9gDP3	14878	20944	20944	1619709120000	pending
30263	3NKQjBaFrKCL17JNBuqzba2itUWLuttun1dLWwQZNXjEBW5Q1cNp	30261	3NKThpoH1H8fVSGq9atZswifyEUccG3AdDYRgPbSLgGsMhEqgTzq	1609	967	616	12463	18974	jx1CjkTQbSpLkCti9nsGpabMa75fucugNdMYXRNXkVjzgyT5MyF	14879	20946	20946	1619709480000	pending
30181	3NL3auq6wMAK2emWk6ydPNazRt6AXhhipRoJ2cgyiQwMSwBXgkwZ	30179	3NLqU4fnk4NCx8RsXNyumVGdJDPEnJgAQKZez2TsQmZX2WTF1Qjs	1577	1201	612	12463	18974	jwF4XceTx5Cjv8gA8PKhkkY6QEYWr5ydjA414h3p2mB1HfS8By9	14848	20901	20901	1619701380000	pending
30188	3NLSuskWHw9bqeHzuXZJ57LmFs2up8F64Ma2AJQMs8i1LvHekhx1	30186	3NLPBvyceQctkN2NXJzMK6JgfnTdBKA53dYp1yZEx9nxd4hh2SzF	1490	123	612	12463	18974	jx1rP77TCQBUqSYHF9BbzvS45ZUcoudpoU3DeHQeDHfCfBVVu9x	14851	20905	20905	1619702100000	pending
30191	3NLdBtQwEHoxkzu7FpD6Kxycda9knzu6191d1esJt9yMHQkmMKZ5	30190	3NK5XiuGdmHFYBoNmp2QAuKhSBvcs2fz3sDwoFgjmjRhkn2ykGtL	1407	1395	613	12463	18974	jxQdb27Q1rX46ufE1Y2J9EFQk1YQxNNvcC3fMwbfu9CtsZMzVfw	14852	20906	20906	1619702280000	pending
30194	3NLKa5qdaN69wDK441duVe3Cbm1e293mp1RELoykWAaAW3Gqrsiv	30192	3NLA2xYbqZnRUuzU9ciMKTyiCRZC2zTLXSZsamg62sf77cdUzQfZ	1490	1274	613	12463	18974	jxhvyppRsoMqoDE7Jr7hyp9nQ9nAm6JxfLqycrXELkHnaEHZoZ6	14853	20908	20908	1619702640000	pending
30196	3NL7vtCnSNT6ALqivSgybip2n3NMa3bbt1P51GUnKMuaJX9QD4t4	30195	3NKzi3oy59tbGW62RYFrsfuPAVPDAjcvr2pYbg9bqBwHWcLyx55V	1403	824	613	12463	18974	jxv7qez6P16pL6HFzRx1xfSTD9c6KEv4S4kAeZEVicsk7GUyZhA	14854	20909	20909	1619702820000	pending
30198	3NKQrdVoSTHk4DDxDBi24xwL2X9S35qDspdBNvmBhG4LBJC3P68n	30153	3NLFMajibWF7SJsZZHviuoy2hRGJgFERq8W3MXD4Tptmrju1TqtP	1590	1174	611	12463	18974	jxbLks4oJ5ruK9ycuzoMjXHsD8yP6Wfd6xaphZ6NGrsnkX8PQth	14838	20909	20909	1619702820000	pending
30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	30199	3NKbYTFY68QUdZeQZzDYN1vrEK6E3G63wx8nUDq5NdEkai59mw4P	1407	1395	613	12463	18974	jwCHdd5TEvcPC1xUhLGgopgP9gcDGBi1joC9BWJjuigKdAE1UHF	14856	20913	20913	1619703540000	pending
30205	3NKU9rEWf7nSkaFUoEG4jeEZcaXoEgeMZA2uc2ZETFWnfJeoqvih	30203	3NL7REChnPz713csQapeWsJRWGM9nKscEVfb2fQDfPrvz8GhsULM	1596	997	613	12463	18974	jwEaZHN6YfLqynMzC6taRELaDDtNZP2gSVyxEQFaEtZEX3VaE3U	14857	20914	20914	1619703720000	pending
30207	3NKLQyaa7P5SFytSyZDvRssQ9y3cYkjsXw8fzr9PgWkiFz2BXvmR	30142	3NLsmb7X5BN92WjiYtLA7ESKgSwbGkBDiPkbgn5DZCa4o6oHtvvf	369	1312	610	12463	18974	jwBcQQxhjU9urCC68u7kirm83k6zT4DJUVnGoLokBXcjcU3iMK9	14832	20914	20914	1619703720000	pending
30215	3NL2jdoRuDRFCDmBYXyRToV6zTseo3n25ZF9i6upS7jxwYg6914k	30214	3NKW6PHgjd1WE8M1LuwkqtPF4wvGsRGZjRY1XYAcMZTGTetec8GL	1523	1321	614	12463	18974	jxb8hvEtpQpgDjJR1U7Tmq6k3DLgLwMLkiQtGtnVpR2iqPoVZXy	14859	20917	20917	1619704260000	pending
30218	3NLXZ6qjX2Cq4jkw7CiT78DESVVbsEeuYE4jwYygiUHYKBoUVj2c	30211	3NKcsTyxEtKpeSr5Gmhs8xeiaDedbER9qkcrs8Mzj2nNZuq88Ymd	632	1382	614	12463	18974	jxRmnb7w5cEVNzrZSgTiX6SqpSXs3aNgQcFRFmYiLgbQG4NuvSh	14859	20917	20917	1619704260000	pending
30221	3NKLedebGjPizamFx5C3tcBGSXmR6DPZ3hPVPQ8EoFxGskR3nkm4	30220	3NKs9GTu2R7XigYTWtrKd2D624PnErtnR83gkRGY9xmqYqY5wHLA	1407	1395	614	12463	18974	jwSH8npEHiyykxjhzXgpcnUDHAMf4heha1UQRPVooLtY6wTC7Zi	14860	20918	20918	1619704440000	pending
30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	30222	3NK6xFiCE9tj1iao5p6MXUtMDfGowwxS4CuPUcahMM7j48dDo2zu	484	1319	614	12463	18974	jwXt9h2WQsZaDUc4z2QB56PcAZAqnzWZKRfn96e19mY8K9XbAQU	14862	20920	20920	1619704800000	pending
30226	3NK35LhKxhwXupcbQNqEhis9rcMCCqEeMasLmpqf4j7g5vQ31Rue	30224	3NLa41LjvMLtb4bUK3EpkTghEczDTFoWUHioAe7rq751ULda97Ca	1529	1316	614	12463	18974	jx1eGeZ9yU9sMHKHcAv4M27asuMc15aDMQNKSMTU4nLZyJEreL2	14863	20921	20921	1619704980000	pending
30233	3NKPJxmQHQZNTu52CeUtoYFEWLEcGqcBkpzd18VoWgvpvuuvKVr4	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1541	1298	614	12463	18974	jwgcsmsXphnGjBtoeGE7E3Xzydwy5N2EBecEAi2Gm5gKTZ7C3b4	14865	20925	20925	1619705700000	pending
30237	3NLKUyKmJzYqzLNV7u87iVW3svpCWsqnVngBYbPWBFvztUsC8LBK	30230	3NLTcNGQekMovZAgZ8F9cG4V8A8DvzaCLwRKDFFWLB8HoPYbj4aJ	1483	421	614	12463	18974	jxk2De3bWUdzjopkdoMVG91N3puin6FV179FXkGpGHbiUGdynPy	14865	20925	20925	1619705700000	pending
30239	3NKsWEHLSD99MdNhJ1HfcvreG2ZpHSP26tZnViL97RtpVcnysYHM	30238	3NKjkkUEA6q4k8S7wh5gSdTiNj3mn7vsw2u2GmDCK872ydEgLNjQ	1670	1282	615	12463	18974	jxAqsFsPX8MJxWQPoVBagAejtohvLgujzbUJ29M5hpSejcX715z	14867	20928	20928	1619706240000	pending
30243	3NKc8xaFd8CY7UrfcfbCemcMWE7DbhgVDywKB3WyzGypHgp8EZ92	30242	3NKfvGhga6Rv8f2ngLhbLWyVqs6rurqJbEjc9NLaez3vdyX6LbBq	1607	1222	615	12463	18974	jwLbze7xqdfzBU1jJHQaXibqmt65hw2N7X3fVt1eG2LrdDXonsn	14869	20930	20930	1619706600000	pending
30246	3NK57NJjsdWJxV91bSX5JRn8qQqcQNyKX35v5W1MHp5tD89hbw8H	30245	3NLBUusiobC4B8tdxE5xhBxR1q6vf4iQvYrCsC1zvemk5xynTPxq	1600	1006	615	12463	18974	jxnVFR3ANxxyPnHXbezvGBg7az4uSfgCyoTb4Wm9zK8wWepHfKN	14872	20934	20934	1619707320000	pending
30251	3NKSw61MeeuohKbJPBkXbNQEQLzeCBDXJqKTDMkjU38nzWPHRidn	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1581	778	615	12463	18974	jwMy9mmXnsHz56yJgN4YUXsn4zofpJo85MXjkpANfd8kRgUffKQ	14873	20935	20935	1619707500000	pending
30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	30254	3NL4Gbmh6YDEqdtiCKjqTfVXArXdnywuj7H7WTobdDeECJAW4j5p	1406	1393	616	12463	18974	jwkrHRc3gRKQ4w8UipCThxMLVMXWv9Yf2GohxT7Yc1sjLbJzfdo	14876	20939	20939	1619708220000	pending
30260	3NKP1qSq2v6d7RteACaygpBjSULKowLKu6KBt3QcbFR1ciJfFSc3	30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	1609	1333	616	12463	18974	jwoQQrRserNYhRqFJUw6bEsH9FNjhD8ehvug7SPouBnuFCaSsGm	14877	20943	20943	1619708940000	pending
30262	3NLk7XPFBUBgMK7SvwQw4Yc2hsyGmHaNHtZi8cxLSZh6Nsau9ERW	30261	3NKThpoH1H8fVSGq9atZswifyEUccG3AdDYRgPbSLgGsMhEqgTzq	1609	967	616	12463	18974	jwfpDLm6BTMAD6eUJBHMkxjVy9ZvXtY2WhHgpeA6PnVsiX83V6U	14879	20946	20946	1619709480000	pending
30245	3NLBUusiobC4B8tdxE5xhBxR1q6vf4iQvYrCsC1zvemk5xynTPxq	30244	3NLWW8D9r6Ac8j933nQ7GvgU962BrtSUMqGrwEsaoK9mXTSpimZ3	1405	873	615	12463	18974	jwEYG8F8S1UDvusxdKzj2LQ3MYKss4RPsG7KoHNZhnVkG8QAmBG	14871	20932	20932	1619706960000	pending
30249	3NLPXjzxb17q2RGE2THVWTr9CfK8JhsYo4MypSwF2j7zPCzi1dV4	30247	3NLYww2jRrAa7SBnSTchHySaUa2MypSXqnyZiRzuo2TBh5jYgYbA	1541	1298	615	12463	18974	jwkML7D1dpevUHXFR46kcsNkwqsr6nL2qivYdaAuzHYa3YEY9hv	14873	20935	20935	1619707500000	pending
30253	3NLbtVZRrZroDFZuK16ZGJufqxHrDzSNwewRHR3CAFLCqgs54Wiv	30250	3NK4u1KBHubxBUTRcd6uDFHz5DsiWzirSjqqZoBhwFguzRLxfwgN	1573	1192	615	12463	18974	jwLTwy8wmtRvsxJrTgwR5drzEyGJjbrBNhwPAcySY31uGb2rnXW	14874	20936	20936	1619707680000	pending
30258	3NK99pAtBs8Z1XhQJybzNQ5zFomLYgPzDtjqQP4NkDnX1RTDDMSb	30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	1609	1333	616	12463	18974	jwdkDewynvnXV1K1KCBqJARGXaj1XcqYCKspgC53LntDjdEQ8Te	14877	20943	20943	1619708940000	pending
30259	3NLozTx9fgdxNLPAaEUd5WmzpUGNFDQ8gWorZNqZ3SnxbpuD8Zcz	30257	3NLM5rZeYJ1jv1ZF3zrGvGkaabuK8yrBkSAufiwbVM9qnqSeonNp	632	1382	616	12463	18974	jxri7TiY9njGJPzY65Jdx1kh7XJq4A6VKmvCpX2cccga2Db6363	14877	20943	20943	1619708940000	pending
30264	3NKV4yeXvPRECBYbBrDds8kzoTGvnNxMyDdib35EPCPZqV8i3uSr	30262	3NLk7XPFBUBgMK7SvwQw4Yc2hsyGmHaNHtZi8cxLSZh6Nsau9ERW	1577	1327	616	12463	18974	jxmaH2T5weP6DdqJ8ssx5BakCq99ztei1fSkEryym3S9Wo9pQm1	14880	20947	20947	1619709660000	pending
30265	3NKpEusGuGbfwxivMYqFq39Pb7uPkVAXiTJ1yBStBpoe1v8F6p6z	30262	3NLk7XPFBUBgMK7SvwQw4Yc2hsyGmHaNHtZi8cxLSZh6Nsau9ERW	1577	1327	616	12463	18974	jwieeNxKLZea7qWH4T4ddqRFzoiVwDkAXcfSR4p7fpQtPFQdtFA	14880	20947	20947	1619709660000	pending
30266	3NKGHSDiTFiyixMvKSLgRb9Hcfj1GwMR1Ngq4XwM8m4nt46y6s3K	30264	3NKV4yeXvPRECBYbBrDds8kzoTGvnNxMyDdib35EPCPZqV8i3uSr	1467	1250	616	12463	18974	jxqLLTHGDtr7FEE2PKskeSALmFiiGFGhwU6h2dExeyA196P9LHN	14881	20950	20950	1619710200000	pending
30267	3NLq4DhZyncrcvf8VqfmuooKHgDr6LuE2Vg5NFMJikEWABBbQdQp	30080	3NLXsdJ8Sp9w72yZRvuzyJ9Pk2pNB7CacjxpN9cjgHhSttwFYcAz	43	944	608	12463	18974	jxSc4QbpdS2ueNtu4eLAisQkzKiEhmmbqLy8FP2eAqTYLGQSTQC	14812	20950	20950	1619710200000	pending
30268	3NK5wpmBgNAFbCCgB9JFDXJyMJ21TForMsWXEUyeJYT2Pb4VCfEg	30266	3NKGHSDiTFiyixMvKSLgRb9Hcfj1GwMR1Ngq4XwM8m4nt46y6s3K	1672	1039	617	12463	18974	jwMcUUHMYGek6mMHvMy7prAStTD5we5Tf4uvzvd1jqfXi3s1nLW	14882	20952	20952	1619710560000	pending
30269	3NKt8Zu3uUCEAQNXSPDQyc7hC3jzM3LfqAM81UvweqAwaWKPmi7P	30266	3NKGHSDiTFiyixMvKSLgRb9Hcfj1GwMR1Ngq4XwM8m4nt46y6s3K	1672	1039	617	12463	18974	jx69NPLkpSieqbMfKcP8RKhb6TEjRGgfB9FpDSGj3Rvuy1FpuDo	14882	20952	20952	1619710560000	pending
30270	3NKVL6v19FiRX9DirC84R1XNkQtkEZVZwwDJBWjPB1z6C28ZVNHf	30269	3NKt8Zu3uUCEAQNXSPDQyc7hC3jzM3LfqAM81UvweqAwaWKPmi7P	1407	1395	617	12463	18974	jwF4f1QaTecL3tHCpYURFhFKk8o8NSjufLDHLzyXHdQGMymcVTZ	14883	20953	20953	1619710740000	pending
30271	3NLtZN9RD7HznPZF9kUxaXnq1S6QncJdmpmpjnaxHWBMPoncPi6u	30270	3NKVL6v19FiRX9DirC84R1XNkQtkEZVZwwDJBWjPB1z6C28ZVNHf	1642	1367	617	12463	18974	jw84zdtheJWaPRNLvQxR6Md1rTaz3S6wXe8Z3b2hoTYxjv76qnN	14884	20954	20954	1619710920000	pending
30272	3NL6e1hKcDYA9AwPcRxTPPN3yHFTd2CK8bvdqCXs7CQzEkh55wQ3	30270	3NKVL6v19FiRX9DirC84R1XNkQtkEZVZwwDJBWjPB1z6C28ZVNHf	1623	830	617	12463	18974	jxhATZAQMEkxjP9TQVbPYXuLBA733TfGnBYfmcHP7PGwC2MNwkr	14884	20954	20954	1619710920000	pending
30273	3NLHBJJ9GXJNF1J7vtZ3roBJHa3umP4Q6ULXxfYxcCrduVJvLsGP	30271	3NLtZN9RD7HznPZF9kUxaXnq1S6QncJdmpmpjnaxHWBMPoncPi6u	1602	1003	617	12463	18974	jxsrk6iite77ESmNonfNVa1umY6j9R5hmHnb71BPhpQDFZ5FGzM	14885	20958	20958	1619711640000	pending
30274	3NKgYu6zxonkqLnMQw54n9c4AUzija8ncZ83xZuxDMpBPoNcCeJG	30271	3NLtZN9RD7HznPZF9kUxaXnq1S6QncJdmpmpjnaxHWBMPoncPi6u	1602	1003	617	12463	18974	jwaiLzo2akguqzG1pqwsMzRHMr2fyX7tUCiVVbJanxmQjb3tfC7	14885	20958	20958	1619711640000	pending
30275	3NKnbhgrbJAzhH3wKhDX4VM6fjjTBKqxZGpLFUFYmZN3z2Y1acRf	30273	3NLHBJJ9GXJNF1J7vtZ3roBJHa3umP4Q6ULXxfYxcCrduVJvLsGP	1474	1203	617	12463	18974	jx5kfWVtZcwbZwFEf8wc2aojzbc7TbYFvxhQju3FCoKbLTfvho1	14886	20959	20959	1619711820000	pending
30276	3NL5vHpXV7At6w46BgC26q9s14tnuKzD3CQvU1kMuT1G8gMm2NCv	30275	3NKnbhgrbJAzhH3wKhDX4VM6fjjTBKqxZGpLFUFYmZN3z2Y1acRf	1501	1234	617	12463	18974	jxhq4ujAFrdco4pTmvxb4HVwWwpo2PRTGSb4tXoRMpZLVUdNYBe	14887	20960	20960	1619712000000	pending
30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	30276	3NL5vHpXV7At6w46BgC26q9s14tnuKzD3CQvU1kMuT1G8gMm2NCv	1405	869	618	12463	18974	jx9mmLPFHK417NcDDsrH7VYkZDECXsNeh3uXijDunUPVDB4FBAk	14888	20961	20961	1619712180000	pending
30278	3NKz3ZLSZ6Vb7tjfojhQfHzABoCpHRRvRnyFoz5euteqWidXB6FN	30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	1579	1389	618	12463	18974	jwHqnJyxNkixpiTTo8xPS1QtzURpsC6Ned2JPDgc1GGoFN9cvrh	14889	20962	20962	1619712360000	pending
30279	3NKugYhxkPb8YYEMQxDBVhyQoVZGuJDBWq3gzZjYw4QP1WFSNx2W	30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	1529	1316	618	12463	18974	jxLt57Lrb75aKVLHq41HMoRL4wSubiscCBBdFEHgm2qprVNPkNR	14889	20962	20962	1619712360000	pending
30280	3NLvZe6SbFPvEJyfwQrX2wq5Han4aSiN5QNq4pAKRkrAgUua9KuY	30237	3NLKUyKmJzYqzLNV7u87iVW3svpCWsqnVngBYbPWBFvztUsC8LBK	1529	1316	614	12463	18974	jy1xKCwfiiodQDqFv16tMfnrii1XQV5vrc61THpk7ozQvau9LQW	14866	20962	20962	1619712360000	pending
30281	3NLtKLhqUx5ma1cCwRAx73nAwEQTtogrQgkR69yNBMvPfYYhFHnW	30277	3NKPmsYo1bRRkwNNhdSyWVsKxLSuH2WrFsAQnhbwXaAQb92ntKnV	1529	1316	618	12463	18974	jxU2Kf8cyuiJqkqaCBpGQARdDppaF8PSLECcaf9RejNo2YKE8xQ	14889	20962	20962	1619712360000	pending
30282	3NL3WMoAU3P3Yco36gTuCm7xkF11GD6LRQMzyZr7WRqrxy5YeYga	30278	3NKz3ZLSZ6Vb7tjfojhQfHzABoCpHRRvRnyFoz5euteqWidXB6FN	1406	1393	618	12463	18974	jwxz4tr6njU9em9hfTZXraqUXX2ZwuyUkXVhK1GTmyNENTWzcqe	14890	20963	20963	1619712540000	pending
30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	30278	3NKz3ZLSZ6Vb7tjfojhQfHzABoCpHRRvRnyFoz5euteqWidXB6FN	1600	1372	618	12463	18974	jwJ6bzfDDxsikohxe9VSSJtstWH5adSbVh36LJ74JxbN6jVR3eu	14890	20963	20963	1619712540000	pending
30284	3NLunwQk8mev4nKPFGR62sMSep5dMGMww3FLcciMnzsLj5JUzWHV	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1403	824	618	12463	18974	jxhNkDtkgqZ9Q4ccwfaDungSCqbaJYgkWvAD3BesMHhdKhtyyT4	14891	20964	20964	1619712720000	pending
30285	3NKrXfawRPT8AJCJUF6wwLzSyuWQcrqC9B2LCRA2V2kzWKw6Znf8	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1407	1395	618	12463	18974	jwib5RfNmhvdNLYoL8Yxor8we9NUSYzT4GRRhwjdsMciBrUqvBr	14891	20964	20964	1619712720000	pending
30286	3NLbNxsY58tjRADqbiAzzeYHSJ3yCSSb8HT3JAEapDcgaRXizc1G	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1541	1298	618	12463	18974	jxDnzJPpmDKDiiyVRvYixCFd55TJAVRN8E2yFj4jFfwrZKicfZG	14891	20964	20964	1619712720000	pending
30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	30283	3NLd354Kn2HncTUy72erdKqTV5MVkXPZu8u1NjViXLG4V73qezo4	1541	1298	618	12463	18974	jxZHF1xckzEHNriANUPRrmWmCivBDkQMiDVtA9roq6PycjhNL3V	14891	20964	20964	1619712720000	pending
30288	3NLgmz883ArmrNPBQjuGH3tpcx4zJphJcyjx2UgR9jfFWJuM1B8r	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1610	1314	618	12463	18974	jxNrXBDg714DHgZsffuf2wcx5SH37yYc18fD8i9RK5nuXYfkKio	14892	20966	20966	1619713080000	pending
30289	3NLPGjbYccG7sna9eWcKPauneutGfKCEHyVa62biX4puxBR7rx7V	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1407	1395	618	12463	18974	jx3WRWibLVtVSie5gbjb76sFkqKr9L4LSRmm11WMLHkmA2E8tbY	14892	20966	20966	1619713080000	pending
30290	3NLoJKD2Jw1AwgbKDKDFCC62w3coTshQECqE5WUjLzHrXbdjBnSG	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1610	1314	618	12463	18974	jxPHnjMiCpPVgixQUJo9jCy3mSVzzwoATwSp4NGw7kQDEBuUw7j	14892	20966	20966	1619713080000	pending
30291	3NLGGGTyeEe8c5yURV86AyiwAb916FhKnWAi1NgB4RbRppP1c2G4	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1471	1386	618	12463	18974	jxsLP58ey226zDDfxcMyTdFSxyAz3Wj6wEcHWRcYSkKbi2CyLuU	14892	20966	20966	1619713080000	pending
30296	3NKruY4o6U3oq4rUp8SpYYmy7yzRiPsL1YWT4brUfDBJp95EAgxn	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1455	1332	618	12463	18974	jxvRSGc9jTUt8A64PqmMvaTruRHDn5iYR9aqKGjgKM9GRzCkiRU	14893	20967	20967	1619713260000	pending
30302	3NLU7A5kWUU2ASX4CB6RwZ1SZ4No3yUgEteTPvMmBRpuyeYPyH1j	30301	3NL9QVKoAEP1DPBv7MWpadUR7GyxjiRCvsegs2PCgzrPo9pvYd4R	1439	1279	618	12463	18974	jx2TGFmZ1Xh2t2FYY97jUpEsnaxDjrnToirTPXkdWgUxSsX7uPt	14895	20969	20969	1619713620000	pending
30311	3NLVrGS28dWs2ucixMRe5gGzpJ93JWpNG7BLMu8147sjWu6MQsHE	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1490	1274	618	12463	18974	jx2G1vmd5PZzpMn8HGvKEYfgYq8BHScMRLjSXRYKZTLW5kknNo8	14897	20972	20972	1619714160000	pending
30313	3NLyYFgirM6ZDymk4vmZhSELQmc7kTQiaqttbiJAkfiNpKNpbrb9	30310	3NKynE6zteTC7Eoajh3Zqn5FN693DNzPahrQy2cWeG8Nz2UcsHaq	1509	954	618	12463	18974	jwPM4WcgFPtqg7k5Zav3mby8kMy4apxkDoeZ2sbSbJSV4iPTLGf	14898	20973	20973	1619714340000	pending
30316	3NKoW6KFs9Tu85vJUsQeyUNosxmb89saf77Jx6bAJeysjTy1Y9HT	30313	3NLyYFgirM6ZDymk4vmZhSELQmc7kTQiaqttbiJAkfiNpKNpbrb9	1631	794	618	12463	18974	jxYEXU9Y8qYBBQjmpJyWjX1rF8wk8miFrh34VDDj7riHSMyybuz	14899	20974	20974	1619714520000	pending
30318	3NKmi5p6dANCUHASVnou6faUB4aPS4FrqhB9UtdYowcXf32yYqvk	30316	3NKoW6KFs9Tu85vJUsQeyUNosxmb89saf77Jx6bAJeysjTy1Y9HT	1587	1111	618	12463	18974	jwmLe35uCwvWLeJhhz1QMcsCAkCwZYh6eb6KZNk15WaMmhbTvMj	14900	20975	20975	1619714700000	pending
30292	3NK77SA8ZBbyUE52KmoGDKsNRKZ4ZsziEGCGVpGHrs6AWjeYBeHF	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1673	1122	618	12463	18974	jxuKFFAiiQra884oL8NVfADWasCByyby5gzDyxJ1Rzud9xMHFmS	14892	20966	20966	1619713080000	pending
30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	30287	3NLYPMwShFo1pqNuevaA9yPdSwvwjasLRVDfrSh4TE5Cg8WCMLAU	1637	816	618	12463	18974	jxnUMXsf1oi5sJTbfa3xcfiXnUWKbHwdkzCsquQFjFnZRqoHizF	14892	20966	20966	1619713080000	pending
30299	3NKkDAciuF2KjEA3y87L7pWWo3jxniFR2yZkkmzDhJgDEWyptQEr	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1523	1075	618	12463	18974	jwZHQpyo7wE3yBPwS43vbrm4u2xGU9ULsLhks86JXXV4BTRZBHQ	14894	20968	20968	1619713440000	pending
30303	3NKbpM5sJaP6dsMaKp2HxJQ3rXXqdwVW48oRifJckHepM6of29ji	30301	3NL9QVKoAEP1DPBv7MWpadUR7GyxjiRCvsegs2PCgzrPo9pvYd4R	1439	1279	618	12463	18974	jxnwg8SLPfSywT8GTdS7JyVMKr21mkrLE8SXiMFm2FqNUecYZzq	14895	20969	20969	1619713620000	pending
30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	30302	3NLU7A5kWUU2ASX4CB6RwZ1SZ4No3yUgEteTPvMmBRpuyeYPyH1j	1534	951	618	12463	18974	jxvyWaroEQ1ZWejGwXpRYFkybDHNHroxRX4NYvhfvKhm95vUg4a	14896	20971	20971	1619713980000	pending
30307	3NKrSoomyfH9JcTe95Svq1ZGK8zgYz7Hp82CPsJJdPjy8X4tzv3q	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1451	1292	618	12463	18974	jx1DusVj9aqqRvY6c2VrX66GCc6pxcEQZPZHdJDiEFnZbMNG8Ng	14897	20972	20972	1619714160000	pending
30312	3NLJVTSBw6KG8S58ctg1irxvz6eJ26q12efkxkUfey85cS7ySbzN	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1483	1276	618	12463	18974	jxqeAozJCbWQrUkTr3b2ac4Gb1Qf3kkFVgCFYkYZLgW7ntH26tV	14897	20972	20972	1619714160000	pending
30314	3NL3PjgizqqeWMANdZSjqQxHhZu3kBG1T6pFqoFirPdp7BRb8qdv	30310	3NKynE6zteTC7Eoajh3Zqn5FN693DNzPahrQy2cWeG8Nz2UcsHaq	1581	778	618	12463	18974	jxBpErZBThNa3u5XZ6o2ma8dEAuFV3MDCKLpcVAfnH4TorHpSuR	14898	20973	20973	1619714340000	pending
30294	3NKA8bdFFmjHnACybeCFDqcttmtSK5UEzyJceV8FxWjqZy5VmJpS	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1405	867	618	12463	18974	jwhD1YYQBbnAk1rvnfdtcvHqJiaTPc4odWHmeFaxyUQ3S8yHMsC	14893	20967	20967	1619713260000	pending
30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1406	1393	618	12463	18974	jy2YVJU5btMKwJ9dsvTqHCZq4tYi7At6o7TYKWqJJayrLQEdAaa	14893	20967	20967	1619713260000	pending
30298	3NLAHREf3AjbLinqxuqYYimszcEYi7B3FUHV46tsk5CBggUCXUg6	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1523	1075	618	12463	18974	jwKXZnhuV4EpiAh5oqXR5ZCUd3i1CfRoLv7iHaeG8y9M8MNjBCv	14894	20968	20968	1619713440000	pending
30300	3NLuSay24d8a9DZKj9JG3fH2m7FWqGTwZNvKXYx2Ga8xx5Xs6PAL	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1523	1075	618	12463	18974	jx9cM2nQrPvgy97JBCbQeje5UcVDSELvDuZmJFAtJVLLzKgCjU1	14894	20968	20968	1619713440000	pending
30308	3NKdEDUKAbdFJ6X37jg9WBVBpS7v51b1AcoDNtFG3YS1cVGGv8t5	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1483	1276	618	12463	18974	jxSJeicT2Ch9Sa5Y3AahhmGHZqyTFSLDPSkreJQrEJiMrkGnGbu	14897	20972	20972	1619714160000	pending
30317	3NLA5KYve8vX5RwfFru3mP2ikZooRdstmWyirR5wULfKw6WxvZhU	30316	3NKoW6KFs9Tu85vJUsQeyUNosxmb89saf77Jx6bAJeysjTy1Y9HT	1553	776	618	12463	18974	jwgbt9QHP6HbpRfKQrk7fUyprTgzdhb5PwQk2psFWyTUc4bfkYz	14900	20975	20975	1619714700000	pending
30295	3NLp8YRcdAqFB7GHBJWwR9WVfw8WWbbbudqhsAfYbamcKHrAhqFu	30293	3NLKJbYEPRf61NPicgvPAaEni5pg78CN4GvLhWPRBpb7rq9Nm789	1608	1289	618	12463	18974	jwf3U6bQkrLCBcxHodMEdy1NFG7HYVh2WPiWtn1Ja1HzsoaxkXE	14893	20967	20967	1619713260000	pending
30301	3NL9QVKoAEP1DPBv7MWpadUR7GyxjiRCvsegs2PCgzrPo9pvYd4R	30297	3NLeLoHxtqhJMCwV6FzQfqB1D6N4HVR9LPjqBi3EABjVwE92eyJY	1407	1395	618	12463	18974	jwB8ScUrmJH7QKNi8WddzNnXemhqG19D8XPdG4NRF1GtyjjkkkT	14894	20968	20968	1619713440000	pending
30304	3NLiP1aBccAqtscSVu2dcFTuntCPxLy3KhTQJir6ZQMxaCJuyYMg	30302	3NLU7A5kWUU2ASX4CB6RwZ1SZ4No3yUgEteTPvMmBRpuyeYPyH1j	1608	1289	618	12463	18974	jwFFWeumB4huU3TVAzpZVZNjUNFzEeLLz62BYpHv5CHBXrEELj9	14896	20971	20971	1619713980000	pending
30306	3NKLgzVzKD31JEjvRzjt6ybt1GhjJsRo9FbjJED5zw6TpZmxbm1h	30299	3NKkDAciuF2KjEA3y87L7pWWo3jxniFR2yZkkmzDhJgDEWyptQEr	1608	1289	618	12463	18974	jxj6z1N12cFnSRRtiRpn1eu4ZSyWRGK5QvNkiJzCfgQ3GwtAsvL	14895	20971	20971	1619713980000	pending
30309	3NKNs6XD7p6xNT5UEujkmzsVKMUnHfXUN911PLoLDeq525gLmFxm	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1490	1274	618	12463	18974	jwj1cqP2neqMbDgLYdR2tqt4nb3hXcJi2b5DzgZqtpw8sbcMtcF	14897	20972	20972	1619714160000	pending
30310	3NKynE6zteTC7Eoajh3Zqn5FN693DNzPahrQy2cWeG8Nz2UcsHaq	30305	3NKVs9qf3hhvrL81GgZRkb7nePtr2Q6yDn3HzmjPgNsyx5yGdEXA	1402	874	618	12463	18974	jwaiWQEjBGnEBq7KMH2WZekkRggFgR1uEb2BvrpeCePem7iNSs4	14897	20972	20972	1619714160000	pending
30315	3NLByAURuUPkaK4A8xPicpwez53oogAZoAYfHanvCm8GT12jVmxZ	30307	3NKrSoomyfH9JcTe95Svq1ZGK8zgYz7Hp82CPsJJdPjy8X4tzv3q	1509	954	618	12463	18974	jxkQG2YkvV4P6hxXw5Qyr2gqZz1sG2jFk5TWEWfo4q1FAUPrr6p	14898	20973	20973	1619714340000	pending
1	3NKeMoncuHab5ScarV5ViyF16cJPT4taWNSaTLS64Dp67wuXigPZ	\N	3NLoKn22eMnyQ7rxh5pxB6vBA3XhSAhhrf7akdqS6HbAKD14Dh1d	1676	1676	1	1	2	jx7buQVWFLsXTtzRgSxbYcT8EYLS8KCZbLrfDcJxMtyy4thw2Ee	1	0	0	1615939200000	canonical
8	3NKvdydTvLVDJ9PKAXrisjsXoZQvUy1V2sbComWyB2uyhARCJZ5M	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	43	1310	1	1	9	jx4eFvGfdvYQ8bwkuK4FmLjDnxwFHvcysBTRiosC946nnns44U2	6	5	5	1615940100000	orphaned
9	3NLM3k3Vk1qs36hZWdbWvi4sqwer3skbgPyHMWrZMBoscNLyjnY2	5	3NKQUoBfi9vkbuqtDJmSEYBQrcSo4GjwG8bPCiii4yqM8AxEQvtY	1460	1198	1	1	10	jwMQWidFmfF7T4tdRP5RVJjJupWPJFUmBqiBibyJgFf6FZ9WCo1	6	5	5	1615940100000	orphaned
34	3NLPpt5SyVnD1U5uJAqR3DL1Cqj5dG26SuWutRQ6AQpbQtQUWSYA	32	3NLEu5K5pmEH1CSKZJd94eJatDTM3djoeJTVE3RkcNztJ4z63bM6	1474	1203	1	1	35	jxcMQgBgvPT9CABuws7TKa1JAmJ23GiciewYYwcYdh9Y7u2GJvD	20	23	23	1615943340000	canonical
42	3NLtkfBsNLZGq26MdXo7LGTos15GrURu5CkwDh78JSf6tEKwfL6x	39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	1406	1393	1	1	43	jxW8myYxLQAx5ptqR7qNGXFiexNHpsokAtU3LoNEyGBkDQcEWZP	26	33	33	1615945140000	orphaned
43	3NKscz4fVou6AUG2qZ7WkJk2ijubgcYFukbpd8Q2KGi5yTi6nWyq	39	3NLBPtiaGtnU63R2WnWa17VsgPxUYg22evbcX8zSUWPS6wZaM8cP	1637	816	1	1	44	jxU1kKkSy6t25WTbPhYXG2ugczxMRtEWXuzU4r3zDuQVzbEPwB7	26	33	33	1615945140000	orphaned
45	3NKidUELim7Dvc2jrewJjoojDtTqqynoPmGwgU7n8VVe1j4CaDzj	41	3NKZbZ6xEcgVqy2EwzrN6Wmj77xZxaodtkNv38Ssx5BepUeMz416	1654	974	1	1	46	jwLV9aeJzA53BEP4TGoCY3n7DFkZCXrxSEhVtVieMj84WuFFKCE	27	34	34	1615945320000	orphaned
65	3NLAM3XtX6gcV3HPAeM4KPYnGSX7CF4C2mfHZnn29wijozEp7QtJ	62	3NKWfWdWxzARGUkN957q2VXLD64EB3LCknLDmhkT3xgzwbvN4ha3	1619	909	1	1	66	jwFmfS2w7DzmqS46WfZskxF9796bvi7wNH7QJLvo3RPkcvaarP9	36	44	44	1615947120000	orphaned
74	3NLAgYAh6UdzRsDKwzYKegdEoB71u6s5z9Kh5gejGQGquchy1qoN	73	3NLuesuqs8NoehpUnNouzr6ArcmQcnjQhJaGsPfHMpT7BQZD6erj	1534	574	1	1	75	jx7s4w4BmdkzABhLcj6bpytgb4quhdcdNLKqNpK8RAfEgM4ux5a	43	52	52	1615948560000	canonical
80	3NKM57jFp1XXwVyrg9SgxkEJ2zvcY3VuiCjCxXdsaBvdnPDZRmsD	79	3NKdPZWJtwYTY6mpeTEgf2RbfLaJTV5HoAYy3GZcvJJ2cE8qTRVp	1504	113	1	1	81	jxnMokDMva4JFZxtzSzdtbmXdDdDRQM8FCFb4DEZvUsJ42q1ZJy	48	59	59	1615949820000	canonical
98	3NKYioZFVfvLw6BRmfnbpQRKaLcLQzyo6YTZ5Gr2TPtY4RiY8A2H	94	3NLUgbM5PpzExzsvcbxFy5G4PrSNCMNdL7Q8whJiJMdxQ7ZVuUZu	1474	1203	1	1	99	jwx67py3DFtqFNGXZFkuM7JypvuBY6KNuJuuv23nsbyN7aciijR	60	78	78	1615953240000	orphaned
105	3NKcqgxhZhuPohp7Lan1A1fQMf5cS7tTruEVvoiGb5koyPRJrxsJ	104	3NL3W58MGw9VD2Tjmg685KJUAPmjq7zDU37TqCcAsJ35rcJKFKJa	1587	1231	1	1	106	jw9yQdXScmn5v7sHHAbsEQF5K419grkoMBm5gvV9jwxZV6vi8dZ	64	85	85	1615954500000	canonical
114	3NLvxoHq8vrVJnh5vHYDZNpD4ygTfsaVZJy3uicDXNBXL5YdJo3B	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	1651	1301	1	1	115	jwo8HkLTtHQ5AwqFg5KzJsG44h4YagCLBQAgfx1Nekb98KirZih	68	91	91	1615955580000	orphaned
115	3NL321XkaQuY7bkR1FNo5quu9kNVEzYCNBXiuu4y7wznv4V6xP3y	111	3NLuR1ekDJndXWgJK19ApUtTKFaqdLKbLXTtBbGVM3YjAtC3AkjG	1651	1301	1	1	115	jwkDQQircvHZpZmLWogFNJgqAmNf65ncextEC5aRQgFvLxnwkys	68	91	91	1615955580000	orphaned
129	3NLppkyBnB8bVJJbkkbF6biLMNcTXov4qhfY1ZxtFDXgwbnVuq3q	128	3NK4unW4nVKn8qETiSQpcez6wsLkXpU5jBgzjRcQzrmvB8GP4z1a	1534	428	1	1	129	jwtUGt173hug8ts13y79yWDhhrhUnQLRukLCjTsJENMnVaJMCSa	76	107	107	1615958460000	canonical
136	3NLud5r6RmCymkHLZFTKypvyv298pkX97B1kYxSi4mnaTTctw3Xy	135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	1503	1277	1	1	136	jwqg4FyeTQfXBwprhk7NCVNUVfEYXpAGGfzLeeASQ2CQeiQ5J16	81	114	114	1615959720000	canonical
137	3NKpCp1mxV6CqXt6ozYyZoWp2UJ135sdMduh6Kaz5sLs7fr9KtZf	135	3NLjTqfynmjrxAVQctG4uPz5ERdKvfwwW3GfdPAZdQH8FqVcnoMn	1405	851	1	1	137	jwPeXcWtkeisKSskhtjD76ssy9VV8c7pvZD7eH8pNxxaXmBxFWt	81	114	114	1615959720000	orphaned
160	3NLk3W18mspMqvCRgyoPyEpyBHrKZcqGjroabZJEMxZ18pvE5joy	159	3NKGnZMYQiKAZDZfAnyHgVPhSrMWRHaR3aHMnAc28oatHJiifVFz	369	1312	1	1	160	jxeacUHBAbfyhoKTDoPs4Gu7MsDph5k4ZbMjM9RZRnm39kxMkVH	96	138	138	1615964040000	orphaned
168	3NL9oTg9i373jA6yxA51epRFQhGg7e41v2nnsUey4fH7P3x6iFFx	166	3NKLtRnMaWAAfRvdizaeaucDPBePPKGbKw64RVcuRFtMMkE8aAD4	1396	436	1	1	168	jxKwNCZ542hAK6kWtHcXzG6UuKc5QB6CkWokJYhuM9sFSgmpM4s	101	148	148	1615965840000	orphaned
175	3NLi19wzyT23KWzippDRoEjvLmzjUorVv4MavM2DbWJrLGreXLKj	172	3NLgCN1a7BzAEjEGptDZpi9bh8qArpyh3KNMDetQnBAiVYd6exoT	1406	1393	1	1	175	jxjwLDEPPnbGmJbBMPPB5EGD95MoCFtCgGzAnFaTBGPfsa9jejL	104	152	152	1615966560000	orphaned
193	3NKxBqpTfp2PPn7rGZ51aRNyz9Npt1si8y7MXWdZrA77GAEgc1eb	192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	1549	1362	1	1	192	jwW3i69fiJXbz1qSY1sp9huJKVpcJmJEv3WiJvEcSuQZ6iRntdV	115	167	167	1615969260000	canonical
195	3NKdijar8CNAaN7enSPULyrKbRntTet9DGNyY8M5x4vev2rYVt2Q	192	3NLu8nvFoqjTEi3SuNt396kaJiZhWLtXKB2n3pJ7EBaG4R7yer1z	1631	793	1	1	194	jxwD7e3XZ9wn3rYzgSQ6C2iFxznPArC7GBVJdirGEzgHatwYz2y	115	167	167	1615969260000	orphaned
198	3NLgbVt67xbbKxJYrvhAmQbQeKcdf8fhwkJZjoAWsB6mS67V5gmB	196	3NLkmfZNq1hYJoMzQj2aWiJQwMHg2XTr9iSZNdN8f21mJMNZ7Jap	298	942	1	1	197	jwyJF36JJWz1QjgLsmHSKQJ5A4gojAPJX4gArrpcAa9B7PdVXLp	117	169	169	1615969620000	orphaned
207	3NKr6HMunb7fjF4obYeedU4HtcKasfKhz1QnPNuPD199qhjwpbuT	204	3NLNyQC4XgQX2Q9H7fC2UxFZKY4xwwUZop8jVR24SWYNNE93FsnS	1601	1142	1	1	206	jxXa6LncjN2V71pwV6mpKHF58r6ZFByRk6ASLYMfDwm1Yp4WRm9	121	174	174	1615970520000	orphaned
223	3NKgNo9Z3minLdnobnXLMrEPCfLoHnSkJ7E3YKGeQESzXQVm5ci1	221	3NLDzhZq7vwEsebgenzciaa65yWm6RsEtfphXz5WUifJNbtmBvsi	1447	1099	1	1	222	jw8MWBRqEzqP61hAfijSFVcDkEp1JBn3XKEKoiCNBFmWPdANAbm	132	188	188	1615973040000	canonical
253	3NK7JZWEKWNGGLv3oY8ud5Bb12mx64R5ANeiHKQ7qGqW7f6k7mcp	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1474	1329	1	1	252	jxHMcRwgYWkpgi3kW5YcPhq1oMNgy1oLpnNSygVUjaCrJGw5iGa	148	212	212	1615977360000	orphaned
254	3NKa83pLN7gqyzxT9Q4L3FQWfhywiZdq9mYLHjgZUAUafQvVMpef	250	3NKqiwsxvNiQDGoxdRCpNLWRYrVdFMT6bLurE6rCc1f7nxt88iJQ	1590	1054	1	1	253	jwBgDeVL5mPAauA5CZcG7yDATt7mSfF9JgQGH14i1uE6euhYKk9	148	212	212	1615977360000	orphaned
257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	256	3NKWovz2sP2AnyVHXoKYgo7ZwZmP9Ud2vVp2uPRCd46XyRC4zew3	1647	1176	1	1	256	jwwKnBGvgvBLPyJZFZ3vChET2nwinhTpYmBenSNyxEWhV7ajfhk	151	217	217	1615978260000	canonical
259	3NLCWFzDVKfi488HyKmdoj6doZJspFN8SAwNBZ9TGnLeSNqFcqgj	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	1651	1055	1	1	257	jxNj5UrVLqBmeCYBY6T95cXavWWb5pqk7tep1RHpDuNPNW6fh8n	152	218	218	1615978440000	canonical
258	3NLH4VkbsKeLy4aYf4vfCwzAexHyLy999UiPAcMnAtUfGBFwKmdv	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	1651	1055	1	1	257	jxvMpEGFKfcYUpzXZ2u7eS2xSTwb8sNKwgX2SVCdueQ9kP644DH	152	218	218	1615978440000	orphaned
261	3NK6edhb7iUHMHvACytTQn4qTuWEPkFLfa5omn1D19dCRUr9kYuv	257	3NKERoMjC3Rxh1kgoZwwR36rgyNZfEWdWJgcmz5WbbYJPRXj3DuF	344	344	1	1	259	jxYt8nejgt8So1zYdReFw6sEg3P4NT7vrbEpT2dSptTSZMHn3oW	152	218	218	1615978440000	orphaned
282	3NKTNtYgYJjsUvPWDkAWGQSiJy3EiQDM17yNkLbfcYWff4Mxk2CE	281	3NKcHWtoPjY2fZ7JGuos2hWK6rJChr6WMGFgy7TCSZcKLhBzh7Rd	1406	1393	1	1	279	jw8ijxDuWjaVvvSSLt7UmD9FmH93adxdRWWym7F2tSyoqnmXUeq	163	231	231	1615980780000	canonical
302	3NLiLZXqKXSDGRvrvUPLp1DubUrCFHv9EmtQAsbKLu7teKPJMqaH	299	3NL5gZQiuurE6gD4X1Bk5FqRPfSGUDsmN54SCvU1RPGQH2WhsMYf	311	1061	1	1	299	jwTHym2wQ7Zb9GpZnXSkBRAagoQitBTCogbSYLdN8sk9rnCMFYe	173	245	245	1615983300000	orphaned
321	3NKhAchWTAoFGfcX8gwMJDGXAyBHXYxTAYxpehd7DdEdrm4mCKAU	318	3NKufRLNcazp23YUsV5zo9xiL3yW5zrtJVNX6ZKWnqufFs8vrVg8	684	1226	1	1	318	jwdYdkAob9rkxBXbsTmjRQ4GL444s2mTfa45Gvgg3fQVtj4b9FE	184	261	261	1615986180000	orphaned
326	3NKKcQ91BH3uZAi4D9vrooeQWKCY58EakUieKANWBdhhB81rt5XR	323	3NKdEro486UfPKynMF6AGwfkxwGA5o7jUfVs1JLgcjEGYVHiSXn9	1483	1150	1	1	323	jxVthbjToFZyoU5VuemCo3Y7h4LnMKLGywdZfejVq9KTHtKt61a	187	266	266	1615987080000	orphaned
331	3NKYWBSZyxQ7su3hH9qhUsGD4dLAaTdiYQFFHSxZySA9v9q2SGj5	330	3NLgXos1fdLVDxbZRTuseejicXGh7oBeiWe3DpUBrDyj5iDYWW9P	1599	921	1	1	328	jxAjqNqQyqGoLbEje1HNQt1xfGmFuhTWhrC7tGDwY3TYADovSJJ	191	271	271	1615987980000	canonical
337	3NLDvNN69tvBfFjBoUefXKdGxNHcz4LQMTewZdEqWbXJqD7dU7DQ	335	3NKbLU7BdrSmA9HuLJhMshfbLw18gnZuKqe752CicDKePf9bPVZh	55	463	1	1	334	jwjjfupnB8SFKNqoPueGdEgQiUf7ugz2MzxYnERLXqekPJKL1Bj	193	274	274	1615988520000	orphaned
353	3NK6Ts4p4setuSinGyJTEjF51gk89ecs3b7R95d4vKCuBX23L9nf	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1463	464	1	1	349	jwwZoiVddez3Zmu5uZNwZQbgJJn6r1bLsaSbBKEW3ZsGmheHUZj	201	284	284	1615990320000	orphaned
352	3NKrBVvhQPfvxG9D3ZLDY8AVJVbJBPsFsNQUS8QBRnCtoowf7Rmq	349	3NK6XuvVwfKc7oS8h9H8n9n3eVRVTtSbsLvB2XbPLKD91Ykmy2Zn	1463	464	1	1	349	jwSwJ6jRyhpmTxmcFrmARi6t6FF9GbhbYF7qa9daRrAMbxZs9xB	201	284	284	1615990320000	orphaned
357	3NLVGieupLJWUYBrCDtB9TV9KGYoQtk955qnEeizswvSYdKJnCXo	355	3NLYdJbJ479DDBoBjVtV2X3W6SGwLb9AkxUW2J3GRFbWuWCCyuHH	1560	1291	1	1	353	jxXw1we7oFkvdWxYwaKXJi6ta4GR5WAKp4ywTJy8cugLL3cPoTx	203	288	288	1615991040000	canonical
375	3NLxxJFLxmDHxXdWA6f3Hp2bi99SiucD1dLijaVZC6CjwSPA7bbR	372	3NKUdp4D3AsmXvZXoWTv5MVe3v2NFmtnCgjJ5QRXSb7SUWRyzsjM	43	1310	1	1	371	jxh9xjYF8G5mBzEbpsPN3Rp9ebBXv7GAPVDCVuhvSLgvi91hChv	213	303	303	1615993740000	orphaned
385	3NK8iwLoZYmUUdQsseZ3sbLeRW5Dy46mtFuKmPz1DjvWZTLPJmfY	382	3NLUMVTutHHFoeyYR54QjzMJQrr6wi9vxXW5zFhgeVsESSiKg5t9	1529	1070	1	1	381	jx9G6dxzbgmY9RdjgTaKY4cHhKzF5B5B7BMv1JwPkPsqWcM8Pty	219	311	311	1615995180000	canonical
400	3NLTFwwxwpbLM1wj2DNvirj4WPergf7sjm1kkUnHGs8SXd8QTns3	396	3NLKszmXe8n8UPGijviCd2NG94WfDhLXQ2xCLEhaiuSBdtQpCmNK	1619	1149	1	1	396	jxUXBhfS618RCepuWvif6XQAbshz7dppKix9V8cNmUSb5vobeyw	227	322	322	1615997160000	orphaned
410	3NLZ2zcTEwW8XUfk2GShmNo56hBkM6dL7fXP1QmBwTKZSoQYQLKb	408	3NLNPCBZiQYdsoS1e7qfXw2LUMRerJxnQe6vZWRWqihcU6mH6kEw	1506	1373	1	1	406	jx8yWgiJYE2bKfuqB6Uo1ak8TjYCdxR2KRXoPUQTugwt9A8y9Q8	233	330	330	1615998600000	canonical
425	3NKg1HJ3T2fPczQ5XYi6qt42w9EQiSXyncqgH6XVn6r33jajnsqX	423	3NL2FUZrvGesRw1WwWBzx8GcwWFy8g44E9N1q7cKo2V3qAH35mFY	369	1312	1	1	421	jxz9cx7vGDZy4BsjQpgfLEgu1HFhsWbJXWWcSuu4NUm6EWcwDLQ	242	342	342	1616000760000	orphaned
432	3NKh1SSkJwPNSZn8mmCxSt36WZSTVmvR9s3cfQPFDna2MXnGrsHP	429	3NLnbWz4mmxCN5QZMEw5TsfdgxkgsTBEZzMS3Q1rofHhQ35nvuiP	1581	778	1	1	428	jxGACHYPExZq6Ryi2wacCZBZANveeU1dpyjuwhMtL5iLzB3xY2K	245	345	345	1616001300000	orphaned
435	3NK3qWUiNvyyMMdkdXRzuGuuGjWVpTmdH4XrRxLrw1sYtUtpSyJ2	433	3NLgHQDDtb2t3EkwceDiEvgNNsVQX1jNPw6GSayz7bxJaxCh3UTp	1613	1103	1	1	431	jxsoihUjyzpiZH5NHYb5soJEyJ1fhjUQiHX7631wesBTEaf6awn	247	347	347	1616001660000	orphaned
445	3NKZytxEjzmNLcKtawuQ8gCZBya7D9GtcJVgtKdFCJzN5hTiS4K1	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	700	840	1	1	441	jxqtmsRT5GXviagWN2jijUg33rpCiE39hkNZcfyXUHvCFrg2yZ6	249	350	350	1616002200000	orphaned
444	3NKNLPp7FSCEM8pWJ9G3is2YQ1wVBaQHQdWQ3WYp63kxwDSkMVNG	438	3NKMc4NXJ13cEJak8eU7PH3boMWFp7hM4kjFEoeMPkxsQR5fG2JV	1579	1263	1	1	440	jwhQeugkCDBgyTunBjQ43Qm2twX5wjfLfHdfFfJ8PwGdSCRAeUy	249	350	350	1616002200000	orphaned
458	3NL6pot4eGLtvBQEweZtbmMnpoJH4oth2RR5UZSmNrqqRN5skGES	454	3NKs6MHjS5jTrzzMYKtxCLBFe1nJ7zp7QGksiGhPPFJgUA6ppEJR	1651	1055	1	1	454	jxt4iG63t7SCsmZwp6e2F9ZCTTuGqufcm97hiXjmHdSSnYGZJTM	257	360	360	1616004000000	orphaned
467	3NKAY8PLSuKQdfH1XtBHRL4Y66nkCmgVAgncbAKagcPA5U4vY1d7	465	3NLkFf7DgMx2GUp3gFhaDG3JsGyhRZ8uXAonwHGJBTei3kiqAxq5	1405	905	1	1	462	jxc1F1N3BHnfkxiLDEDCigSb3ZL4Pxyj9td9R44RF8GXoAnQcJX	262	365	365	1616004900000	canonical
476	3NKYEgqzncuvDGTp3wcKVq9Wpcq5CPYcHzr2okzeDFibd2WZM6eW	472	3NLJQrUVYWxkaY8ZRL5CVRkraVeBPZjz2JXthcpNpKqXCWTJRGLq	1637	816	1	1	471	jwAed73gkbo8mMD62ywoeXLYgUNa8YXARAmDFkUiV9SHxVzWpqT	265	373	373	1616006340000	orphaned
487	3NLyYL78WHUpTPKPK64RsRbgmu63ven1eGPNeQe85Uf8SQrg4FD3	482	3NL5c7afJYcBUybGkkgLyfRhDNcjKkTFZK84BvNUzrCXuesy3VLQ	1651	1055	1	1	481	jwrqm1SYxoMi6V9RThCsWcYQgUUNQQjT3TeXwrQGEUzj9Qqs154	271	379	379	1616007420000	orphaned
506	3NKykhATq9Vy3YSeSbop8BJncDG1ehzijCxcHdHVpmuUjn425x2x	504	3NKNDac9RCLQnNLbJgVhKuiNr9AEmgy9KG9FGeTY6UFPjpGr6aGX	1623	839	1	1	500	jxE9oAZ6MZvyNfqZGB5oT6AWhmyVpaLobPVgREGfnsShoVYWgx9	284	400	400	1616011200000	orphaned
512	3NLAHBUTDYQHpohyCiRf44N7gMhMp5jkbzvRXtE9RMDt5mWs8cqX	509	3NLGCG2uHEkdfGhbUAdkZmyiBjPQB46i23qnSK3shW4cpLSLP3X5	1517	197	1	1	505	jxDbGQ1niFgXZyebSYUBYwdJyD4AUA6epL4X8F4Q3QCU7qzkc3L	286	402	402	1616011560000	canonical
513	3NLaTehr2ZSL4LqE4zQkCaKznrRpwVKrovrgeJHe6raiVnhbUq4P	512	3NLAHBUTDYQHpohyCiRf44N7gMhMp5jkbzvRXtE9RMDt5mWs8cqX	1637	816	1	1	506	jw7PwiSfQamSqbmPQNuCBfhCscfGdoeyNH9bVkadyb7UULjsLoJ	287	406	406	1616012280000	canonical
528	3NLqyguzus94qW6iC2TUZzzB2hqoZw7sqQhWLKvHHNwmHfhcBuuQ	527	3NKJqaYgfYiTVb2RXiKLkzPQzbruWNShRHw9szgES1uPySpMC1ZY	1642	280	1	1	521	jxRt8ZcGTXBR2vaXzLt85xy5qutNmdHUTrWrGAEn4UX2U4YV6Di	298	424	424	1616015520000	canonical
539	3NKG61kXj3iVjVWinKj6jVHMmkTTWiUqjvKkT3qvFVVc2xszwLVL	536	3NKcNe2BbJBjmsznHVxYJsqBqkpF2qrs7Zc9SVrVyxMFaogrJe7Q	1573	1192	1	1	532	jwTUeoz4WmXkC7eLbdDGeKwzCSiH8EQ4bxxei7hdKKrP889MxWY	305	431	431	1616016780000	orphaned
555	3NKDwso22CGUxHxpFF75mKjvWkrgLHj1vFS3hNQGTzdgG6rMawH8	551	3NLNJavrD2QNSJB9reX3oDVzETVkbuLLYv1mF5y8jtoH8aSATdXb	1631	794	1	1	548	jxUF3pxmsWYBsNzXhxSpUEKYrWo7FBiAbtYXAWm61HtLqwSeZfB	313	441	441	1616018580000	orphaned
575	3NLwDQ7voAd6NsHVe6jYoYvHDNoR64kkc6J9V9XuSrXuGSAMn8mC	571	3NKfxzuUt9uKpV6ETsLLvmQyJ4X3wEn7y5H6gLis5jXytC49c8nK	1637	815	1	1	568	jwBSy11u1LRL5bdmXcrPjaYFjZw9hKTFND1663VVgdH77fPD2rw	324	453	453	1616020740000	orphaned
585	3NLSCszv8xddJSaVLtaAQf6r8Enekt3DYC7WMagTgML9m6XZgNKm	582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	1643	1053	1	1	578	jxYTRUYqsqmstQ8XiMFfmo5yAHEHCjR5eR3pqju9gWNAvmmnrk8	330	462	462	1616022360000	orphaned
584	3NKgm92jWsZKCkqWCn4ReWQD17Q7zDfHDKTBXoZ9sjmnBGmpRpqz	582	3NLWf5Rj859PcL69VPnVYQzzxhrsz8D8EdTEsmSawapMc9QNseGT	1637	816	1	1	577	jxyH1M4EVov7s7cFbUqVgs1mbpZGSLR4YPDoKsySGyVVXHXB21b	330	462	462	1616022360000	orphaned
712	3NKi5CyUTUQvcEJkZper3dQwUQ5PEsUFGgjBbK6yDArzz8m4q3dt	587	3NLZEH3KrGSUk2w56hCTn6FyCFHTnTBjHvijkGgmrbiNiXzoF8WH	1569	485	1	1	704	jxXMY9DUcGSgyMAKonDiajh8UCfXg2zws7Dj6rLL4G5zqKWCBDg	332	560	560	1616040000000	orphaned
593	3NLuNEom9JdW6bzTyrGNC6ngpsahvCjp36VyTV7zTcXBf9nz5DDx	591	3NLh79LNPujEjjycAKL93MHkhKX78tWu9rmRzAAQ6qoKhi1zW9tu	1407	1395	1	1	586	jxKnXxqZEyD1zPqoXQECDMqyX1Q4Hur8M5vH9MHP45V9qt6qCRf	336	468	468	1616023440000	orphaned
598	3NKNNi1BYKAB7h5bmchNg5TNUyJrR16DTeeKfHveZrbmQVYHAXnw	596	3NKETdZnRgXNbsVtwsHXEf6YGYBrbJ7hy5i6qk8HhD2VoADnVMrw	1529	1190	1	1	591	jwxcyycQtfJdB8ktfRpb7TiDVrbZWPP2Q38DKxAzLBRDJHtdvk4	339	472	472	1616024160000	orphaned
605	3NKLHFk391XWufbes2qz52gM9Ke95WfofzbtbLjLL2TjvdTHYKjN	601	3NLrArF2zuTjoh7EXEuHy5h9LTfAscYRaYUWDtBt7oGLACW8tmd6	1601	1388	1	1	598	jxQ8LKXdiKWyLNnaQWKbCwg1SFNspBmHkH1khsjFeWHwiMj2Qg1	342	475	475	1616024700000	orphaned
627	3NKwXRrjShCLkpJmtDt2pw8hGtTxur6UrEUA5J1gTNfwDELqqhvD	624	3NLZu7zL8Q1tumxWvrXRcqexmNi264qo1b5Zu1qhxDuCxTkWYtYP	1458	1197	1	1	619	jwS5L5NbB4f9RGxQRKn2fsKuex58vG4C1PqAB9eMoq33LuGz7Mq	352	488	488	1616027040000	canonical
634	3NL6MhzM8ubVJNdWJquYohajr3toZbkY2wv9AgBL8Rgpab5Ec2iH	633	3NK5awGURipQdAnundUT86zxmCogBH4FZefmqYsmWqfVpbEWGky2	1407	1395	1	1	626	jwRHWCQHS8qrqzNKmvqXA2yJaKEtZi2w8iXgFUriPLB1qhB1aHT	356	492	492	1616027760000	canonical
641	3NKGRjyeTRY9hztL4VJ6aYPjDNCzSk3EidW4x8mYJyxVTn4PCBSB	640	3NLJGLAi7HE9oFReZGz6iMHUPVHNfEyR7RgMUmGFTMLFwU3xgNzi	1405	869	1	1	633	jwkfdsYFmZgHiBMJDznntXpsmPCw462v1gSScRMvZtbsehTE9SN	360	496	496	1616028480000	orphaned
647	3NLR6vhsWszP2BBxVqyb62Md3SRtBYkgJZFmVzmjuUCXBuMQ7fj1	646	3NLT3WqSbEQ8chxJNMsfDytuPDuf8HQprLUJ6vtgCbfed8uDZuQw	1406	1393	1	1	639	jwYLJpnqYFfRb9FX2RY1qicg9SCP2EpbMdwuvEwtqvJnhgyEzbV	363	501	501	1616029380000	canonical
762	3NLbUH8t7WdiR3aATe4SgYw4KaZoZx22QYAjr85tKkP1cPKHeigW	662	3NLrDbAnajtqD33ATDm8T6Rwo34VgDnbXJMvpZGN57hL6tcuNEQJ	341	341	1	1	754	jwnsyfxKV1msrNVe1D8Z9ReNHjm1C3Tc7V9zezTFRah3jXMV92q	369	596	596	1616046480000	orphaned
668	3NKsMdhhCrXxv4k6VfzfhNMSkMEukSYZPB5E5BVhduEwFSVG7u1G	665	3NKHENTgEi9dUeNP6ckFV2KbPfQyLjnwFXzdkT9wE7rJnRSMyqft	1407	1395	1	1	660	jx4x2f8Qjz8ySgaEp7b5HDhtTJfX88zbuy7vus3FqR4dD9MLUC5	371	515	515	1616031900000	orphaned
691	3NL3tCmZJMooTGvTTtrMe5pPygqRPKFVkjVot2ZSLSxsapfAWdPa	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	1522	1322	1	1	683	jxfWPsQFYgnydLyXrxVRa8nqGXrCHCjjyAZcSQy4ArgTW4cTg5U	385	540	540	1616036400000	orphaned
692	3NLugNa6vYWaHv7PMQ5QPS2HSdBVpv8H8oeu3mXioGEe8j7xLo4n	688	3NLPk9qA6Z84PyLAqRBn9E8cb4cQj86AgsU8Liib1wrTjKhoCGho	1481	790	1	1	684	jxiu8acB54BCGXj3ey3JfMdBtqWmxcZ8cwhUxYckGgadB4Dp1Lc	385	540	540	1616036400000	orphaned
696	3NLViifuzjunXnKtDE9Z4VkdPNxSn9VKH6UTVQiKDGcviQHydkAq	693	3NKbVRxrVKTcz1XZucYaEqZQZKFqudwi5bZDZ9WvKFJNobvQEkDL	1633	1390	1	1	688	jxs8fh5wwHA13sS9pC7RThHRVxVqvhyQmHkg5KKwk9L4Y6zomKJ	387	542	542	1616036760000	orphaned
711	3NLQEkT8beVL1VpBfxtaxuDY84cWgCpkiEPXbcW8kq6s9AF8PuiB	709	3NK4VCptj5kjSyxBvTJhDb5wjsnMPwoXo2NWsm9b9sGZPn5znnPK	1405	851	1	1	703	jwCzQvLETdyu7Zeh9dfP97U3bXzgpNWHMAjZaqKQrCQxBQkkqe5	398	560	560	1616040000000	orphaned
725	3NKQyWCFocB6Bg6my9z5jcMpVTySTpi2mLgd12h3mQACFyAzSamA	722	3NKUkcRbqprZqsJpnxwcgZy2HthhYig3efTewmeh8m9FC2meiLKs	152	1204	1	1	717	jxm2YSPzQPkhay7uairos9ku1HwFXXM6LQxafbisX3mfkBSDqiH	405	572	572	1616042160000	orphaned
746	3NLrqmX22uAMb6WhoEjRdCPYjRfgiLLNCnBEwBZhe3w4hEzg4cX1	743	3NKkRgkVNQRk8n9f4csp4ZjiaBaWqZqFFW5oeMxKfqw1fqcsHbcG	606	929	1	1	738	jwQtuPstms7ZemKxdniHp4WPDgyktCR5z9gNTaYUdyfP4nzAL3D	418	589	589	1616045220000	orphaned
750	3NKx29vmdZpv7uT8C6gaMwSowrv7NDBNBMGkKEEP48SWDJNMdJ73	747	3NKteKhZNoroNdAaJb34Q4H9MuY55K2wxQZnuxEWM16LjWoGtQDB	1536	947	1	1	742	jwkWqTawzbSbUiYRS44sZkp8N9pXDUdzjzTMRmHPEaKDme9LEHW	420	591	591	1616045580000	orphaned
761	3NK5PEhW8ifChej11WSfRX3GirdDsLBCXzpo3CNEsz27i8PKHkQG	756	3NLtYLzPjE9LSS3N5VcAwXoeX6gGnqRiz9rtbdjkyoCVvVE2ABAP	1555	461	1	1	753	jxPiJAL8zk3xX1MdxkTGciBpBSsk7nurb2HFkdTZa3ZJD8mHqxh	424	596	596	1616046480000	orphaned
775	3NLqGGvMxigCiVdPoyCMM4wDMeufbpVCNScrehKZ76vvycCk93qE	773	3NKFw9GXv3ADEc8L81q9hjBhkQhWSaesauMaJjhBmmcx6drvPTKF	1405	869	1	1	767	jwAVmNgjoWEmVoafUy3hPuJCjnC5rQMCymGPWfzPnxu4LuP3ECf	431	605	605	1616048100000	orphaned
777	3NLBtTsKUmA4Yk115mTwSuyhBPNhdpgjNewTr8zLsPytVCmFzV9a	774	3NLL3WtQ816fnzJuhL6uCYn2T1LrFfgpFeHimUVqrLisM5pEj8JE	1508	1387	1	1	769	jxy3wVh6vLvuUm6afEuopfqFZ9AmWkv8D14Ap332BVSLG4eKrya	432	606	606	1616048280000	orphaned
786	3NKpRx2RL32dAk86yB6jXtGxPDt6S3xGcwGcir5CuQYW9KefRhyu	783	3NKmWxAkiR9DNeffXV9BVktTHp5xbbn1c2tQyc2FahiuwgwBAiG1	1553	776	1	1	778	jxv8pSxnQXbMGowUu5ZiYvA2U17q4mhPujx1mRNc2B7Vx1RRzqs	435	611	611	1616049180000	canonical
1322	3NKsGLHhxtMQedijqzL7Y1mweGAepNDcsoCqMY8ZvtNX8wCviX7C	790	3NLa47H4XkVhpJXNVj3XVMTsEZuVmzNFAbtUuXvAg59XrRx7L6Jp	1599	1287	1	1	1307	jwB1R1LznpcKuJuPCeLjahpKjP73npk1ABsRyzGBAaw2YynKE2M	438	1011	1011	1616121262441	orphaned
808	3NKrJvpG2jyyj7N4dYMR49cvkxVnixJ1XK4r38TDTVnzBu4DNwZM	806	3NKHVPVEpdT2zo1T6jHsnava51QehUMxBf4Bc3grmA2MHjJVv2HB	1407	1395	1	1	800	jxZt9KC6SVCn8HEy2DWKETS5sFvJd6KvLfBsMc6F7cEyJQ16qrk	447	627	627	1616052060000	canonical
1323	3NKHEv23kbVMd84GcWf3AzZ5ZdJA6D6HM1iF4Cbj4X1a98Xw4fLe	806	3NKHVPVEpdT2zo1T6jHsnava51QehUMxBf4Bc3grmA2MHjJVv2HB	1599	1287	1	1	1308	jxvSrbka4uoUwceVeBYBSWHC7ShgXmQBWudwjfN9grbTKbjMprB	447	1011	1011	1616121306621	orphaned
822	3NLQCHMeEYTd2TCQpdcmiYpHhYVnG4GZDyNZCr2WSGGRGzsSHdhS	819	3NLkKtYg88J7Hu847VT9vd75TeNvv5zPdHbTWS6ebiT6Cv9uVm6t	1547	1378	1	1	814	jy1z44oNscHappPFFXADNikrrj2NwH17np6F1vjXWphM7VTjEUX	454	635	635	1616053500000	orphaned
826	3NLqntsuAKJQoUy1Rf7uczxh9YcaDXTR1DYqxNeJr7MBrRKxxAMR	820	3NKnwt36yeDTBeGRJ5wjAwcyUES1tfGBvNGGCnUiEuCp5ECD17Wg	470	1183	1	1	818	jwtCjriAugNsyhFb1z5RbQLZWZRpVRpMxjDwATrSUraVFAaXxHS	455	637	637	1616053860000	orphaned
833	3NLrLSb62TLh39wWitnF6AC2wNAMVzcuk6AH5YB8pk9PtMjmyR5t	832	3NLMyN8qSUJTAkWEHoXqLH7Z4QfYa1F7PnNbRUM5YG5773b1hcx6	1573	952	1	1	825	jwH6v36AboFkMWiCDKdtWSNMNATf6hgEPEhVz7uWxW7BAxjz67B	459	641	641	1616054580000	canonical
841	3NKS1B6tzRRhTYEZh5AaA2jRx4M9kvFfcKU6W1vsUP37Aq6LkfwN	839	3NL96fDfbzAbCD9UHj6pjQQSGWtBm4GPDiMAHvssn2VJ1CwCQPAP	1406	1393	1	1	833	jxxVosqh3cc1kVfgyEJknHcD57fcue9TDL7E8cdZzpmCtktXh1v	464	649	649	1616056020000	orphaned
849	3NKu5H5prn9ftZsAQAoSdoWKr6iPU83eLULqddqYgXkaFESbMdDn	848	3NKhfcwMXWxSSKLkFbWsYv6rssEw6xNhQZPMDW32zZBFghBUJJ8g	1656	1343	1	1	841	jxyaZXeWRdYvqYaaKkHq4ipdMepkUSXNRtY3BAw82RFUqAbVisQ	470	656	656	1616057280000	canonical
850	3NKmKacb8QGKU5h1L1r535ZV7rJ7eTn8dCMAf6pySFVv2ngWPYnL	849	3NKu5H5prn9ftZsAQAoSdoWKr6iPU83eLULqddqYgXkaFESbMdDn	1516	1294	1	1	842	jy2GE6vYNuzYXwuvGpSMnCHJSo6TRyGJHq5Fg4pohUeHXxriDa4	471	657	657	1616057460000	canonical
874	3NKXbwgjHPjpyj762DJcFXfuNDfHbhMWKHefYDXXnCAf7A1jxUFJ	873	3NKfgnZaAUh7wbk6FNvDKSeF6VbRTLmVXXQmX3g9Q2xgRUFaQWW3	1581	778	1	1	865	jxcnHt7HSgJV4Pd92gGwk3kVyYC8i7tLdqrwCBK5AkrrdJBnw1B	484	677	677	1616061060000	canonical
885	3NKj3XovsHpw5rDvdoQgoprCQ9BcNtGDhRvUdEqNbSrPSwSz2ZWd	884	3NKDQQxab6vnXmJ5xPRKksYHpK6zWqjsbtD2S9wRZEZfpb5HykWK	1534	1317	1	1	876	jxMj6GVy6wx69uuApYVWip7tw3zndtPiMLYh17up1ciMbbd65YP	493	691	691	1616063580000	canonical
891	3NKUgAF1Mw2rGgtk9txf5H9hZz4Eo5e8vi8QXjtB6gicvykrmfZf	889	3NLyRd86rSqXhx6uTLDVkk5iCEjku6TmX929o2UesZqFnrohok3w	1536	947	1	1	882	jx6qTZmxJFd1XCHLGULwPbXQtBLCwHmACZzY7s7h7YUq9EouTzQ	495	694	694	1616064120000	orphaned
904	3NKeVDxfgM8yzWvnz1bWv25czBwTXZnu1gah3UYkig2QN6gKf9YC	900	3NLCWVQSo8XLeunFaAekBiGPGYFaX3XLWKPeGEfjmgVzozUmcCnk	1406	1393	1	1	895	jx4uCdwtZwbf5hCnBHPMU5ZHapXEofEFdc6XNWJp8y7fkRf8iEM	502	704	704	1616065920000	orphaned
913	3NKXV3hcouKBdktSM67UZkqXYppqp4wD57jtftdHrqZQ9cgoU98R	910	3NKJYgoQDftfbXAUSNQibWAjbbDLqixSngjuyjGhvik9o3W7mUyb	484	1319	1	1	904	jwAWp1A3d2PyNB9mRayAdcXKs8GvA5ks3QmKmwfbCC5dok7um3t	507	712	712	1616067360000	orphaned
916	3NKSHBw6pCWQNeQ6s6ZMLV6n7vGmXd7HGvbhRSGqHwpbZLaLY8Vd	914	3NLmQPpQfxzgatWGAGZ6L3musejmRkCAhyDDYbp8zrxDaxXLVLgw	1560	1291	1	1	907	jwgP2nMDp3dVF1zK5j7BSFuk8wpbTFXDE7v5F4wqXK2dfDZy2HW	509	714	714	1616067720000	orphaned
937	3NLoqBuXvxfXg1uDC5Cw7YXnvnnjCGfUDRtefh1uNg3T4Zego1H8	936	3NKZjiju1xQSqFodEwgPvANaTcY76FnAeLWkyMBAXBHjZo9xhyLu	1610	1068	1	1	928	jwjbUbeMdzduzBfAFLarXXzHfLVGsoQtrbquytDZaMNo4Ff7s8w	521	731	731	1616070780000	canonical
941	3NLCi4aEr1uDw15ymUcR64iHhaXhu4qDT86HMFbYHibX2i64XwVV	938	3NLQMeX9EnBfVJMnF7cAkLDGu5M8uNFC2yDAJawX7Smagka9RAdk	1619	1275	1	1	932	jx4kiqqc6w8PUqJdtNTAZB3ZRewLb1g9ecdV2p6DXLFrZGk6unu	523	733	733	1616071140000	orphaned
961	3NL5La3n6voFLsZyEefubBrKbdVoUnGAiCdWxo1Ug8dwDyAGBeK8	959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	1670	1282	1	1	952	jxzvMycBbk1kUS5eSZDCfWQG8ZwwErTWxLZC8HPxqtYrNXPUJ8d	536	760	760	1616076000000	canonical
963	3NLWbrhbyNL85zDTxg9RZAT7gg6uaxcCjQP169ifezuJkuPVmxG6	959	3NKFkBmmi7gRufz9zPmk1iejHqW8QTc2hBrbWFKXax2ryBRWfGEE	1619	1149	1	1	954	jxwBqn2GynwqLiucfi1LMz6dicPQJRqxped9ESsCwBhQo99bNRo	536	760	760	1616076000000	orphaned
974	3NLJmeaxHxYk9ni5KgmBiSan1xvLgqTVf85yEEFjd4vwTFXCTHf7	970	3NLdDYjXTdRzyxUyGkQW5dMJcgcoXs4WV47rW7VGNie77LsZ7VdC	1631	793	1	1	965	jwtdixqNyveHZRtfAsafAF4KKdY62b7GoFvRuhhWDr8bwFQ7qyQ	541	766	766	1616077080000	orphaned
980	3NKN7eQFJutridCxoyZ6XXiqeZtVvQR7VgaHSdkZnyir5iM7sb7K	978	3NLVVhkjFpMgNpdpzqpN6f4XsCYpKLtx751opyQsfMcKpH6pdo44	1668	1370	1	1	971	jxsUy2Gax9nyXE2L7SCh7ftzpHQEBnLWydxYCZZgzR4yLvtA66x	544	769	769	1616077620000	orphaned
983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	979	3NLZkSru6jt19z52q6HeBSjLa6kZbmfMnuyUcGXfpHf1d1zx4U9S	1407	1395	1	1	974	jxZ2Kk3LZVZArce5KjjRmkiwpvKG9fWMYRr6q6gVPQaZ67NRauQ	545	770	770	1616077800000	canonical
988	3NLa2bER8PqR9DDQMm93aDo9pFA6EPgPKAWsjYWdWcEXJqhxzctW	983	3NLL1PafHXsu3ABMCpJqLm5ib1BughXyufH8xFkGxMSSVypcoqqh	1637	816	1	1	979	jxqZQRuKjY5Lur32H2cBxg8WRJpdiagv1afHvFRd3qvn3yQbWK3	546	771	771	1616077980000	orphaned
1012	3NKr4ioU5Rt4iLMUPCew5BEBprZR6TsYT9saiDyWmUEoPKFpmDGx	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	470	943	1	1	1001	jwVF343XsLYvFPwQvbY7ibEyS55qwZKjyyUqZ8KsjHpdePAvhkm	559	788	788	1616081040000	orphaned
1010	3NKyYjj9hHBQfcbM52uBigkao3B4jaGv8hMe8utyFMJRB14xJSuV	1008	3NKVsYc1rh5L4523a5GL9iG6y4fQTnERR1jG87H7Sx5QpjQzAhg1	470	943	1	1	1001	jwKY9GDRKA4FLiU3sWWZWuJKLR58n6rjXFJGUv233yZNpxvM2vN	559	788	788	1616081040000	orphaned
1025	3NKTTkJuvskanfRRqWzqCkBcwMxEFQ6e67nvwBrePvvzWkfrgoHL	1024	3NKe4ZyhVHFypRegDzJw2jJ6fYZYmcFNpfhtoBpH3CYd5aYJgeYt	1602	1369	1	1	1015	jxUQRG2JpEMU9S7CZ7fLpA1sWorFcwZPZRAVret6HWBgHJuBBzh	568	798	798	1616082840000	canonical
1054	3NKUccuKEfQvRPkQ8Bhs7UR3ZoP7KiLf3ZgoJBoBfv5Nbp8TTony	1051	3NKXeRLVCrJSHqSfrg6ytaq9yqsBYdP1rdLRoP9VaqkNTPquxu2Q	1622	990	1	1	1044	jwJV2txdZpjLZKUWwFKz5ywpKKAmr6HQQkQKKBXxEGfaZ9WiH1t	585	819	819	1616086620000	orphaned
1063	3NLGSAYLdxQUWCPtV34qkLeYpJnRZWMjeiL2zm7LieagNRuU8zWk	1060	3NLqhKig1WnhiyA5RS4icmcohZJRaCftcG4W93Hs4gzfrsNDb3Cn	171	1374	1	1	1053	jxCYpK9WEr2f1Uz7tCFUwoLqXewakJpnRTYwWcpRKhesMfAXDbT	588	822	822	1616087160000	orphaned
1125	3NLoPbdNggPdfJUgtg7xpRg8oWmTXzj5ivHxP5XpyPNGvgrYSB9e	1065	3NKFX5VhV4XVwMxRUbedK2EvSZ3bGQsdEbbfR8s4T7VeiwwVEpDp	80	1273	1	1	1113	jweZqHmPBFY54kzjPPCx7gKC4W9ach5BBwVwPzxnQerh2NG6eAz	591	861	861	1616094180000	orphaned
1072	3NKX4Ai56iX1rYRkjiQu1jUngzjxoNfDSUikeDqjiAm4QHSb2ioa	1068	3NLKtGWpSJba5ep6zvsjdYmLvGohwuHaQqhfvFoyYhgJHbuMcvCm	1637	816	1	1	1062	jwxhexomsKtXzmacETTUhsyp6P8JJWV1zNdoQdc3p9PrcuskrBw	593	828	828	1616088240000	orphaned
1079	3NLxhuv3ncQRdbRxb1oCXYhyMdiwyCUQXsXduvpwg7vDyWXifHTH	1077	3NLA7xCwgzYbyJv4vt5wC1MZqJdM3zc1e22ipvCxbzx2uJTdKTmN	1610	948	1	1	1069	jwWtZG1oKHfYALp4aE7oaSRe1FU9z9qEAm2Cu8ioWve1kc2Cu4a	598	836	836	1616089680000	canonical
1096	3NLWogafJbTK3zeqrEehVs7yfe8ZhYjP6JLc4mYXDfPg5Vji16KJ	1093	3NLsqoiPtEkxQ5QJmRtaUF2U8jkV24Fz6zr5P6LyTUA6aG7pe1wS	1642	1367	1	1	1084	jy1S8MoF9phaRg67keDi48aKsExxb2tHrwWwJgefYo9rxpcDFpK	606	845	845	1616091300000	orphaned
1099	3NLgaCbqa1Hy3Pm291ixUUPri3zMa4cc6yub12egigdsn9tUErdp	1095	3NLcwRCPDvfyEKHBMCXFV7L85Xi8RiWSpvTzEeEGHFQVMwaRgM3h	1490	1274	1	1	1087	jwG9fFhG4PRS7EtusRR6A5hN6hJ2GfbMb5PGHgLphTRWvviQFLR	607	846	846	1616091480000	orphaned
1111	3NLfkR76TYArhQf3ikcc3RJBh6oNKPSNHreNTZg8RQujHeESSUkp	1106	3NKTbDJGofFspeAiiu9L6sqVw2vsLFP6iYZ17sxwQfwjUgemmdHk	1541	932	1	1	1099	jwkX6jFB6fwm7oj2Us78wBSXDW2TKDDKvetAJpc2P2b2Y6QpChN	613	852	852	1616092560000	orphaned
1121	3NL4a8k48MpKUtMj6vQn9StXc72KA72pJa2T9yN6HKpJ1gSacdod	1117	3NL4zQCBLR9TrU7QwRUhRxyjpjawfv8CyzP9Cap5NBRLv9nE1aYt	1623	830	1	1	1109	jxmrYL4jTucQ9mBajEmvJFSJfhgHoMLgSFSGS37Fckj7vCArLXW	617	858	858	1616093640000	canonical
1132	3NKyXT4WNvNQjMVwVLdg98362kwPACaygj1AQcdQqpkoi8gGQ2C8	1131	3NL1mTXCGeXNwKXTycQmcjZ1PqU5jc2UUwUMV36tYBL8ypJZCxDf	1637	816	1	1	1120	jxC7UDWKJ2MXw1wXxQSvCvekDXPS3BG5itUPk2YRVYB46YmBtCA	625	868	868	1616095440000	canonical
1138	3NL6XHD2yycDdKHb5GUHZDsfRS2NDQm2sNEhgfsFZ5uaZ8BNbfEh	1136	3NKsbaoqramcQ1CTKvZb4TJGFU3T1vLmka7Aa4ZBeTLSfeQPtKgc	369	946	1	1	1126	jx2C5RZks1MJpnG223BnJDi5Qet9YQf8LGaZz1kCGb2o3qv9EYk	629	873	873	1616096340000	orphaned
1149	3NKZPz93ghKvXGSBGeFsAJu7mTmU1JZzSX9sPyNvRJwZ6WJ3Zu3A	1143	3NLH45Eji2bxsHGe9FSsQSkDZCWhNZykMVu5eJ3RUhG5wtoyaU4A	1513	1379	1	1	1137	jxnAL7rxCXXpaaSTwjpe3aRPFys7RuTT8kv8cPxqQLkEi4F53ef	632	876	876	1616096880000	orphaned
1154	3NKdBziQvLEcpFPfy2iaK3W5CjZDt6M8ZqKqvC9AtWwQU3RUx59N	1151	3NKab7TwfhweJLN6YNGzeYRZ3ZkZycGSmqUSt5HEU57T5b8tsbtP	363	363	1	1	1142	jwpgwgUADpAZ7cmAhLf69FkqgvFgogGWsLmA2qkEzUHQjqJsV22	635	882	882	1616097960000	canonical
1194	3NLQhkfRdkuw2yFeL5c8ozW1yXAwNQybDGFBM81TXiw1TUwqATmD	1190	3NLhSH2dYXW6PxaVvQAhAqdMjLFWzbqvZY9HPbKoghjpaU6ZQdqo	1581	778	1	1	1182	jwdWnTHySWjW7n7wYdbSZbs2EePKDHJvYyoNczmmR261g7x28Ha	658	914	914	1616103720000	orphaned
1540	3NLQteRLvqAu8n4Q7gnKzMetUsFgZNZRxHDxgadEU9FPt4eEosKw	1200	3NKJ6gPu7cXU5epG6sExjxgThyC12ugmevmYzTtSqoRyjbdnbnb5	1560	1045	1	1	1519	jxPCVk2qNgWdUDt9sK9e3FqczDxDU8dqQE1qGKVRgmVJPb5NG9Y	662	1185	1185	1616152500000	orphaned
1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	1204	3NL1mtdjnRm9ZVXHyYraLSK1Qq6pxdYm2FsYekKNRfuUszjF6u7N	1608	1289	1	1	1195	jwe9UX3dQqNde7nfMfMdKoUdbHLCBk4JBuotwnCC4fzRyg3merX	665	922	922	1616105160000	canonical
1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1207	3NKNHsRsVXbfxF6EuMKGZkUif43RzkoXgtP1maoTePjmvi4QrQUF	563	1359	1	1	1198	jxAokq86Pfk4pEAzJEAicDpjh2t8bZ3rArMqwfosk9HRjkTwBcT	666	923	923	1616105340000	canonical
1213	3NLc1eiFndSnxU4XSCZ3x8C9JMKLcnc7yt4Xe5DkqZKs64azhcZm	1210	3NKsQektBeEoKNmNCdF8HQzNxbfFFhqu35FrbJAShTqkihFU6jdV	1631	794	1	1	1201	jwNUpjmXFsFeAUxhVfn4YHLwWgLFX1qryEAks2PuYpN3Cyzu2iC	667	924	924	1616105520000	orphaned
1254	3NKUnYt2bgikE6RHWjiqvZYgT7AHrQ5B3LRCsJAgu8ZmGnybpbbL	1227	3NKC99Z7ymewnLbrW7k8e5NNuwqkwbLenQAMZZsZC8pqomD1HPgP	1643	1053	1	1	1241	jxgrFiu45Wi2x7Rr5TEWKCADuGgB3YrY7PZ6WEMTd3YqKmcNMPY	677	959	959	1616111820000	orphaned
1543	3NLfzsQDgbUrHXYfXBjC9gG226SjKn6wWGdhnHDEJFaDv2KuLicH	1231	3NL14RwMouSQenxPqZ9WxTpCC6jsmftVLzFoTfXtAjsHkSwKrMPU	1560	1045	1	1	1522	jw97TSx9oysLenZvAmb2i3SyvankYhRb2V4mXmaRg7MXjejHEdo	680	1185	1185	1616152549087	orphaned
1235	3NKhNnVf7x8UXFKYampbEJvDRtbHRh2D24XFd6zkd41EskMferVo	1234	3NKgwunF69gUBVEGD7yYea2RsxSbQGoTwtK8THFGNABk1w8UqReL	1406	1393	1	1	1223	jxsViUaR4ZUgs8sNJCQuCZjpYqMr2kkBEhdLF1uunFoJR6JvkCJ	683	947	947	1616109660000	canonical
1238	3NLEWx91csxjRx7BaA8xza5VmdnGJSwk5jXCdhASPT83BEHZRYt3	1236	3NLbruginYM9YoFJYWyuScRLoaembT6LjpfwqAxcxxn1RYHvZ3fZ	1403	824	1	1	1225	jwoGWcQUWRWfLsBaSP3fkyQeEY9dC73qRtMgZGk3N56TSzTSsUc	685	949	949	1616110020000	orphaned
1308	3NKC28T7ZNa91KYJndmCFgtihxwA3CUmSyoJE8zXqT8sQy2Z5iP7	1241	3NLfEJ7uYN3hTYswDgsSqW8jyb1KXGuexKfpN1voKJMPWGA2L7G6	1406	1393	1	1	1293	jy1RoScp8wAE5yX49BU6VdaQW2mhnNgx4izFDHRXxFHXNxUP783	687	1000	1000	1616119200000	orphaned
1444	3NKA1tAoHtHUvX2ZwjzQF5e8RaCS7QGJx3c8z4XCmf8iFLW12Pz5	1380	3NKbvJjvzXUFCeB2qjGNn9VsGhnN8nfjVuGXM81g8QtcVYfnXHVS	1553	776	1	1	1424	jxCWTSTaWCPsQyuBZkewofABS89EPNc8h5mHUVWCyWGKBNKb3cJ	693	1102	1102	1616137560000	orphaned
1469	3NKwBDNW3PhGS7pnbEkDKb99AGrRLdf45o9XXa6bcxNMh985njg2	1444	3NKA1tAoHtHUvX2ZwjzQF5e8RaCS7QGJx3c8z4XCmf8iFLW12Pz5	1553	776	1	1	1449	jxviD4C2UCprjFSqBffZkWv2VFN4cTFBeYvvSTcdSUnP5c3ytVi	694	1124	1124	1616141520000	orphaned
1257	3NKbU3cMDzCGRidnXarMJiTBUWzQeNjQuBh1DNw1cyFHEzxBNN7x	1256	3NK5Z6nRaqYg4211iCKSPXndWtZPv5Tbd9EbvJ9FCmKTbbKGkjWE	1407	1395	1	1	1244	jxwRMehSKQCD4YVZSbXREqqnTLjeycWGxGC2SVEvyBdyBNufe7W	695	960	960	1616112000000	canonical
1495	3NLXaBey8Tx5m6EiUHRTruMCy3NaJY5afKdaUYh9QX8d4JV3JtRs	1469	3NKwBDNW3PhGS7pnbEkDKb99AGrRLdf45o9XXa6bcxNMh985njg2	1553	776	1	1	1475	jwcAifVEBN1yd7kLUXSypSYJDyPEDiQih8TvSvsAcpMi9s1kRmc	695	1149	1149	1616146020000	orphaned
1547	3NLjPdZF22m8wcjJjxUvNCYdNEM4XZBiDH33qsjwQMDHfhXoKUVJ	1495	3NLXaBey8Tx5m6EiUHRTruMCy3NaJY5afKdaUYh9QX8d4JV3JtRs	1553	776	1	1	1526	jxcV2UkUH8HHyPFXxiUzbZ9VXLxsFWmn5r89EoF3cv3wzfik7zk	696	1187	1187	1616152860000	orphaned
1261	3NLH21SapdoycPdx36ugAS7wCZGqpbxqu46zFCJaWqS8c7AZFnwA	1258	3NLS61AzwVqwfxr252sGSXDqpp1kajJxv2y4T1sx2QXoPb5kyUG1	1631	794	1	1	1248	jwtXhAbuukNA5vw59EV9zT3aRhx9TkBxC8cGUZ8kV4tXT9WwovU	697	965	965	1616112900000	orphaned
1624	3NK6x6vtQy2Hmkzpkd8XFo14cYSsMRX8fSMhKkcUxBsDmRzXJzLL	1547	3NLjPdZF22m8wcjJjxUvNCYdNEM4XZBiDH33qsjwQMDHfhXoKUVJ	1553	776	1	1	1601	jxqcacPzU8XazpcPD8pcYN9x731GM5wgwVaKwTJN25sALBHH3UR	697	1231	1231	1616160780000	orphaned
1647	3NL3m2kMfnKNNKMXTENwBxtUCjo7Rifq4RxyuoVJb4NMtGLczzJP	1624	3NK6x6vtQy2Hmkzpkd8XFo14cYSsMRX8fSMhKkcUxBsDmRzXJzLL	1553	776	1	1	1622	jxxz7Z42HHqyUFVBDvj8FvWrFrSYMFPPT5R3W7hjL92EEci8fs8	698	1244	1244	1616163120000	orphaned
1654	3NLc3hXr1rHUggdRc3xqhFvLVMmf64yHaiKnb9JTXEdgopAtuiLm	1647	3NL3m2kMfnKNNKMXTENwBxtUCjo7Rifq4RxyuoVJb4NMtGLczzJP	1553	776	1	1	1629	jxosrM5s8csrhqcAtf2ZUhhnV7SPPXKekBUSnqvWxMn5NuVTJrJ	699	1249	1249	1616164020000	orphaned
1699	3NKsAEv2WFp7GqCbCFBgm3G3XPxyMjP5qwEP4AJzcbgvKA8j1CC8	1691	3NKEwsNnjAxUKQKEHBdWdE5a6uF3DYqHDLF54Q7HBULyEpUFqyhG	1553	776	1	1	1674	jxwp9qzJxS6Q7tAiN7HQ3QiQndFCYxtxw2ZMigN7BD1Cf48Thke	701	1287	1287	1616170860000	orphaned
1293	3NKnEMpydQaRHUy8upuRmVtuZ7es1zKsVoTpv2vLcVL5hzcFgDLQ	1291	3NLFQ2iqNgr8FBnpphaTZKeYgwrfwih9a196i8XfB2B41b674UiU	152	1330	1	1	1278	jwbdHp4xYNzHDAYCpoymxS6y6und25QHJbyQgfypfu9TtBk93v9	714	988	988	1616117040000	canonical
1294	3NL2st5mHwxmadTgRvdsYewWEbq7Vj8eAvmMGyLxWiZbU3pLCBHb	1291	3NLFQ2iqNgr8FBnpphaTZKeYgwrfwih9a196i8XfB2B41b674UiU	641	1336	1	1	1279	jxiYDHUyYyJQtDKUrFFHnPXEE2d6bnZf5tnQw5y37fB25Jrfvjq	714	988	988	1616117040000	orphaned
1298	3NLwe6796QPzqdppV69xikxk2dJHyLFZfoF5KsEd38ubTCW7uGCh	1295	3NKfz1x2zXRQHwiBGoGLzf7hXicnEbB4VZ4YUaurKRoXFiAN6tzQ	44	1199	1	1	1283	jwJYn6hZFZB9XhSHjxmkBozrQm271hk2rxWCmjsdjsaKSNghGno	716	993	993	1616117940000	orphaned
1326	3NKjyv4h5wQkgVu1RW1KewzFVLuEbttFc5KyUxHpdECTA5owDuBE	1324	3NL81hXC62JZDwod4rE4VikZ1mrcHJKBXzj767kgxzuBGmDZQHsZ	1529	1316	1	1	1311	jwgfHP24voPSm8qx5QCrS6wewM9ku8g9XxBHsfpHF43jne9YGh2	729	1015	1015	1616121900000	canonical
1350	3NLcg3vdynmtsNzvSNZ8M3jRiPcVCpTwSbphktnmra6Ws2ab2D8u	1345	3NLWkcqn6U2rV86zzWn46vsjFVsrGjVyFDNfJkPt7YAF9eDusCMG	532	1057	1	1	1332	jxQ3nzKpAnMMNErews15KfLM8eNfj8zN2chcuVKehTSMtUZGsMx	740	1027	1027	1616124060000	orphaned
1364	3NK938DP2oRbL9Bbn2mCGoVYN2YtQbZWmGANQTZXvqP5CG7tz5JK	1361	3NKEQadiXU4VTsmmjcNzz8qpAzTVbSF3e4yTr7udV4vtnQ8QFCmk	1483	1276	1	1	1347	jxoo25pFcyuMkzAUs9SCJDhqkn5Zk7QHwrmjtZnPtS7ZVGoAkYP	747	1037	1037	1616125860000	orphaned
1371	3NLJ6LMUidtxxu7YaoF1mW7dU1aAdw4PFAAiEuSW1VMQHLRnFMNo	1369	3NLFkhrNBLRxh8cfCAHEFJSe29MEuT3HGNEcheXBKvexfRuEo9eC	1646	988	1	1	1354	jx3XoktYHxHmUr5WrrAySdgAqHqLYKWmuJaAyj9K2ShtYNtkjkP	751	1041	1041	1616126580000	orphaned
1384	3NKtUqPYC3QSsv9nhZWiM5ArsqXDafZeDsrruDDELpfLRDjxt8v8	1383	3NKpEyzBpnFuMTG6GyMSe6dX8xuSYHaHXdi8BUUfy43xC9ACYNUU	1406	1393	1	1	1367	jwAVwksTPbCDA2J83xfsuNSPtzPWYYi47sq8739vEFf7kzz4yyE	759	1057	1057	1616129460000	canonical
1387	3NLCpzh1ZsqFZoQhPXghzGe5W8v3Qy2iKjDH5VHLfFSrGqr9gEgr	1385	3NLUsiuingqXx2EUM1H28QrbzTnn5JqFq5ATamqJaWKqaNcuscVG	1642	1121	1	1	1370	jxTYhWhMUQK98KTNt8R2rEwAeGtDZc1jX5XzAdPzwfZMFDEaRqw	761	1063	1063	1616130540000	orphaned
1392	3NKW52oPmAHntW52M4U9epxHBY6pVgLMSL7WXaQwZ35bxy2rpFFH	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1405	851	1	1	1375	jxG38aszGRbfec2PX5LZCyrAcQQ5iAWjk2F4984gkMYgBmbMgCS	762	1064	1064	1616130720000	orphaned
1393	3NKGGTuxRwpjDUHC2AW57qagtqBxByqdHFAHY16btiTRWLMnWK7j	1388	3NKmQkD9uNg9ej7doBW63tvpBjE81G2po6ogSLQ1tKW6FZwHQ6n2	1534	1317	1	1	1376	jwE9FGYxgeyMoiWhTnByRghwXHjW83Ljjzwk6sY95wVjsssKRqx	762	1064	1064	1616130720000	orphaned
1411	3NLkGjMnMuzG9BmeZUNSXBCb6xSMgGmnAPWtkjLKkZf5QDrSY1T9	1405	3NLqNNsTetyxjknL8Rh6gEezs5BNHjACytAFv51ue3eVnMMohVti	1523	1195	1	1	1392	jxMHRnexjVxnDp36wmds5HdqCsgDfgcZT9f7khZNBFos2VskJYa	769	1076	1076	1616132880000	orphaned
1443	3NL2c1228be2Q57DKWnU3we1GEo55esNmNJvRpT41y92HGKd4nyH	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1483	383	1	1	1423	jwqFMFUCEGSJxoGHYM9QLeyofSujViiVKJMwjPZoJN4c3N3ou4K	785	1102	1102	1616137560000	orphaned
1445	3NKz6W5xAPWwJTZxfkMXZgZq1opnCxMdKoQequh3RorR9mFoPfH6	1439	3NLEwwWL5mRkQTMRC338ePRD8fXwi67bCwcGXfiuyxVJsBR9bhEf	1486	335	1	1	1425	jxYGkDb5qQ5yKpr7QXSZgfEzfrrFQrcFPDf4ijxtfHnfEmVmEZS	785	1102	1102	1616137560000	orphaned
1468	3NL2DXvH5bafnFQSS8FsPQHwEP43M82hbtjP8Lz3YHHTjyhJrYTZ	1467	3NKtBKsSTK58gjQFvVycv7HPBSi5DWSsDpU4HZAxAsds8csgUQVR	1673	1002	1	1	1448	jwRUDWhdPVsM5Af9VDnbmVvwLbu7mgiadYiWAGsE28cE5crzHxk	801	1124	1124	1616141520000	canonical
1477	3NLi9T5F43YAwF8okujmXMr3pUckdu2qQ7BfTAkeQRqs3GmXKEbq	1475	3NKcWSAGKXLmBP5cv3vdFZcsAetKUgmpvcZBNe5hJJXmfcd5PrkQ	1589	1286	1	1	1457	jwhWYgUrkAJctUrtdyt9SmQzgmmvm8WDPqEjNoLvHrPht7GZLv9	806	1134	1134	1616143320000	orphaned
2088	3NLcxDo4BRu1cQuJZD7giXyZhT9VbBSoALoFd3Nqii25SqkycjMw	1494	3NLSuUbVr1tfogHmYRFkQhcDtFhiDttox7zZekbVu1PJeeXJXJsk	1448	1311	1	1	2051	jwKqSNbbj7ngrZKog5Yxyu7gh9pUsagqY4nNZgqwpgbXKDno6Gu	818	1550	1550	1616218200000	orphaned
1509	3NKGX8FPzHMh5tBhCEbBmnfoN1uqQwCShfxta8bnHhX3yuNE4QCd	1505	3NLuc2Avmrey7CVf2Wo29G7vHAciC67Z2quo58h5WkL4PVXMPWgN	1477	1350	1	1	1489	jwXb7FtLUBu2bTnZocVPbuxLk9McCpsgK4XVN3EGLfam39ua2pa	826	1159	1159	1616147820000	orphaned
1538	3NL8afoEJTxTGYXAL3HH1PHH2TceyuNQyqbhxnJYddXvRFQ1JzLL	1537	3NLpiQEC5rgySgfG2LUVxbktEYrCD9gzMe3zUrqmJ14zJauAmxZ9	311	1307	1	1	1517	jxTZ8icgo6BS236c5XKf4ddrhKHnYShWh63jkzVmSaZa38c7eyT	841	1184	1184	1616152320000	canonical
1548	3NKY9aXSu6nkdX7oJuLP6EbVQwxuLiEBk4LBLjc7Q5iUhrr5qsqQ	1546	3NLKwfJVeefVYjAqAU4QSm3SgxgVtB3dFCduF6ByBcVuFvHrFkvP	298	1062	1	1	1527	jxxTH6Xj9bqFPSeFAqMbTRi7W9jHNRJ1c9z9wpqFcp79w1LC6d9	844	1187	1187	1616152860000	canonical
1556	3NLqj3zd2R632kS9nq5QyRuReMEpG9rxS8VarSSMAXhQVxoXygrU	1550	3NKgbzSaghtXytc6MMKftiqMoi93MUh5YtXEF1rJWvqxA2vXbj5f	369	1312	1	1	1531	jwXpD4esoiVsPKZNrxzQYbsQh42hXS5PqiqhbCKJw6Mfm2vJZdm	846	1190	1190	1616153400000	orphaned
2151	3NLRozf8kNKMuv9ycxgaHqDrsTiLawxbfsX6ipaL1CRBrhHqqtNJ	1568	3NK6jzRueBdJSsPqCDs6ShYKbB5gV8j1FsRfgZZdGSaRP4BXz1Qs	532	937	2	1	2112	jxhAbhMoCUxGfjTsPKSv8mEAEpmj7FfXBeaJhtp4ruWaNnbxA7V	855	1593	1593	1616225940000	orphaned
1579	3NLTniKRbWZ1JfkRfT1w6Tuip8Ew8YiMH8fEj8t2gAcQB7HW3prp	1575	3NKs1Gj2ikTU6UMzcnshDCzpn7eDgJM4sC9WwF4pHBZHmsyp7uGT	1631	794	2	1	1556	jwPg6xiMNgr2i8Hj8DHeGbKKLBTNnqEpsMxFjAGQBCcJKDNqRzq	859	1205	1205	1616156100000	orphaned
1585	3NL75sbGeXk9BeMoyzC5z1Q6JA3wzqsyMDngeRFAgwtvuaTBAxwx	1581	3NKBoaJoipYWgYMvhUcQf1skZpcivPGRLnWNsArwewucVopVVJnt	1483	395	2	1	1562	jx2nKaXYpwLmKRfThCykHF5266YcHWasx273KZP5io7LDjhN7kW	861	1209	1209	1616156820000	orphaned
1595	3NK6MvT5s1BindgEnUnCAEegNkcmgf9CGwC7CjsRc1LfQFg3pG3F	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1522	1322	2	1	1572	jwbjcV9nYNn4i67z5VT2ZcW9oV82gFCEKM44r2FjkQD6azqYu6J	866	1215	1215	1616157900000	orphaned
1597	3NKScmJfsYhcKNK1mLUmSK37XK1EmsmzKV8pey5aWrgmM1K3ymGC	1591	3NKYv6KSaYqryZJNpfMm1R1eRJQh4wzeArZfr6fDxnZ3SyhdTc4W	1668	1370	2	1	1574	jwrPompXycRFujpMHHuKsUNGE2qCjDQ5rA5Nm1wLkrftkDMfEyn	866	1215	1215	1616157900000	orphaned
1641	3NL1jDEJLgTcxTUoizQycjzdt5coLHBg2ZCsEdpGHAi5sbm3eYwQ	1639	3NLwF1kS6unCyoLGcixaaiHa9jf76H5A4sQxFwC548VqcewnZKgz	1523	955	3	1	1617	jwkETv3nR5WjUFsFzaRR2NmvYpZEXW9h4rSQ8t6suVUV3UaqWhf	885	1242	1242	1616162760000	orphaned
1649	3NLubeDznQi8CeMgHLTM1eJpMZB1sqA37AaohsQV9tj3CxbKeyhr	1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	1588	1146	3	1	1624	jwRVSLSvVMzA5WLHMZNjwdwijxymBMr8VG2iG4XoiQ7ByJPEwc7	888	1245	1245	1616163300000	canonical
1664	3NKB8HVWcp2mqc41t88gbTzzswij7PWAGxWCoFji5Zvmcv3G36QD	1648	3NKo8vUGHEMh2ZxAUDHdrbpoM64d9AxADugHTAK4cPJS3852kFsW	532	1177	3	1	1639	jw78VsUCppcVZfnB4JYZVHHGktfi43wCWfNA426gpu3BRHd85JR	888	1258	1258	1616165640000	orphaned
1701	3NLRwSPBGPKCqmh4RXaowozy4wbWoKNeY4CuGRARoBoe5rwnYjrc	1664	3NKB8HVWcp2mqc41t88gbTzzswij7PWAGxWCoFji5Zvmcv3G36QD	532	1057	3	1	1676	jx9Gux3JStYRqzKgJ4fR4P8eNK7RdUg3ZAn5uYL3wu5oPYTzQ8R	889	1287	1287	1616170860000	orphaned
1728	3NKe7DL5ZS1rTFUjGsfcwrmMQuxQz93YAHXsqB627WBDtEJJg8we	1718	3NKFwYkEWsGnh6DPYDVXPkacgMr4TKt5xsJhpYGxqUCys2e7pywn	532	1057	3	1	1702	jxnxAwyucyff1qMuepSKBR44cLxZKuNX6D3YtUc6aUB8PwzdbRY	891	1305	1305	1616174100000	orphaned
1975	3NLC3kfxjFZdwJSH9tBh5d5ToxvdtB2TcvCLPDHL2RosBtsdCax9	1728	3NKe7DL5ZS1rTFUjGsfcwrmMQuxQz93YAHXsqB627WBDtEJJg8we	532	937	3	1	1941	jxBub5xi2fF3qhA7KZTqDxy5thbdyyovaTCivQHyJM4MLCabTU8	892	1464	1464	1616202720000	orphaned
2002	3NLkSb1gtyD2rm1eaAJmeqCRgCTAyCSa6gmEWbG2mq8SeTdoYgKg	1975	3NLC3kfxjFZdwJSH9tBh5d5ToxvdtB2TcvCLPDHL2RosBtsdCax9	532	1177	4	1	1968	jxc8GgefQoYDiZNKXYVGb3peXg4ywrha8bvFYFidUZg5QSMUfxo	893	1482	1482	1616205960000	orphaned
1667	3NLLoiFSjb977EsxYBFTPu1kpiU1pFNry8RRyKnd4HcwhLCxr8MY	1660	3NKHooyhpKoYKVTSrhMb4YWwEG63tAzwBZnwEB68SA5SGRNUPJB8	1547	1132	3	1	1642	jwu2kkAs6s77JB2BVJS8nVDqrUbgdHefn9azXYzFZmCCNodZXr8	895	1258	1258	1616165640000	orphaned
1793	3NKGZpVdfHM2LXBzzPT5hf9hfq9QDWFuci4R8Kwf16mMvFPQArat	1700	3NKxQoqWt4RdAhsHo5szASXkgXv3oUytqsG9b5yNH2xKiPfHNeFh	1577	1201	3	1	1766	jwrzNxXmnqUarbFBdYEp1jqo8FxCkf8KYzZfJUA3MJnn6FvhDcJ	914	1351	1351	1616182380000	orphaned
1705	3NKJVrnoJ6g8HfMQYpPkKnMd4bieaG4kfFhN5oGFMu8hEjiM7s2K	1698	3NL4evbVtwpZnLQ6QnKp8Uc6t4PMR7rYb561c3C7mCUqD6dWjHmg	532	1057	3	1	1678	jwEkxPzH2baxjk11XvJDwdUWEmFh6fAvLZFBTus13r4ZAZa7tFG	916	1287	1287	1616170931378	canonical
1717	3NLWsrQ6vDVR8ccfvWiek6XHZYw7Nadp6p1Ja4FPeAygWFU9mbMc	1716	3NKMkZnTW3dyYJf28WwmUZvXWnscxGJYimNYuRP8AHZWsLdhcARr	1406	1393	4	1	1691	jxWrrQLe1DW5Eaq5iWBLMYxKnKXpU4Zo5RNNJB2RB32FcuShvDB	923	1296	1296	1616172480000	orphaned
1734	3NLmprvwNHBVYagBYSaL72o3rBAr4gYDLgrpa3DexvLd2WRG59eM	1731	3NLnt5uQLhGzMsUfirhXrAk565dxMfMbfsWto7Dyt2Dy1tVW1ECV	1483	399	4	1	1708	jxnc2o5MgNr2oLfqww1cXMQxgWWSAzztnGXXX6VjvAv4UQui8BK	931	1309	1309	1616174820000	orphaned
1868	3NKKGVvksGswb68TsYad7c2oJXkij4HrXq2UEX8NQRu7f2WMpQq2	1740	3NLmvJVWUUuYggfQVLxyvaFbUj68zUJhsKveMJYPpUiXE2PNzyPc	1622	1356	4	1	1837	jxTApUXxtwTz5v8SUHPjKdYLCy6FPbDG9aY7WDm5CoLqfW3AF46	935	1396	1396	1616190480000	orphaned
2318	3NKA1uVoH3ZjmdtbShcSZsZnhSh5wPCJjrmC3Pwuv1CpdncucMtX	1868	3NKKGVvksGswb68TsYad7c2oJXkij4HrXq2UEX8NQRu7f2WMpQq2	1622	1230	4	1	2269	jxu4jReDr14Vh7eUxYrzen3GW8AV9dFgDDq3JvvU3XnpzQxRaeT	936	1705	1705	1616246100000	orphaned
1749	3NKqXpefwV2uH5YoAf5keRYyAUq68N1v8Bb9WMduQK5Af5ewMaeg	1744	3NLy3V9uSSxcs87ioyHqRAX3Aohn8uPWhE5JRAJTNYcJbfHSiuiN	1581	778	4	1	1722	jwxmjqcXUWtec9ySsVK2fJs7RUH6oHn9cR69mSgKVDXmUtezUqJ	937	1316	1316	1616176080000	orphaned
1775	3NKXx4q5qovKCm7Dh8ed22t1ZcNgGqLivQiujMmHpZ11BSh92AsF	1772	3NKbowXrLUQ9VeH1RKjCrqf5gMsSD4bPYDhULoQWBadCgUzqxNx1	1457	1391	4	1	1748	jxdj6HKqNoEYXLByuHFnLQ9cx8KZJVFTcwAXENNyagUeSEMth3J	952	1338	1338	1616180040000	orphaned
1779	3NLpGLLtasuWohtrnjwp5qRNnpHcrL7pmowmcC8CiJnbo8yBQgHn	1776	3NKvTgMJQqVG4BYKMtRrvo4xepbYVwknxzWSiHBzboUFRbq41tQe	42	995	4	1	1752	jxk2uiymPAhCtdmAnPQimEgmQxFHjT5z9K72GwMdbQhq3Q3nT5S	953	1339	1339	1616180220000	orphaned
1789	3NLVMdfFgJpkYFRtgZQQ91oM899wpHusknZZnWV5vtQdN4WFtnTn	1787	3NKBjjcPtY8AMT216cfFDQ9gzRFsCfn9MwdBbdGUHqJM6632QY4g	1648	1284	4	1	1762	jxiP1bgfhrtSLA5XUmzpc2vpqMZkVrX7rNmGLvrjHLduDKshTYe	957	1348	1348	1616181840000	orphaned
1795	3NKBZ3pcwok49VAsarxtzAq7eY5tGUHtdDTaUkYzsE6HuDxq7ufh	1791	3NKxUy4mRpuH7MJxFQEobEJbUhPyvDyMEBQywmTRLbWsaHto3nur	1577	1201	5	1	1767	jwdNn8gY2qqo6P4hmC39NCHzBuouZ6c7caDoTEdhum5TtTH5V9X	959	1351	1351	1616182380000	orphaned
1816	3NKZSvbsKBMpFWR8LZZKLhpui2mBhdngxhXdc1Qxi57MQHkGhgq9	1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1613	1349	5	1	1787	jwa9pEPiKDu3C48SGYf1nBAu46VJRChAf3zCfzDGWFY5JPTiQ3E	971	1368	1368	1616185440000	canonical
2011	3NKN28rxg1nGfmyPM5Ew3iuN8TD6NdjcxuZmfQTThW3PC1qYdQFb	1814	3NLanNRSDJzHkgwJZpGwBNifGxxiK1qAAqcEU5zjeiCnorDBCMKS	1643	1173	5	1	1977	jxDxgCwtB81mntFaKej94ERyXtRtR2LsZdLx7eZrLr9jbFR63Qt	971	1490	1490	1616207400000	orphaned
2186	3NLhiUdtnfPRN2qAqZJVfojrdG42Y4fj5oy7sTxpBVvaR9qUuhoj	2011	3NKN28rxg1nGfmyPM5Ew3iuN8TD6NdjcxuZmfQTThW3PC1qYdQFb	1643	1299	5	1	2141	jxoK2sXWkgFDTJ2ZT314xGKpkCJHjMS279R7ywUgnB6fqmQTsc6	972	1616	1616	1616230080000	orphaned
2252	3NLZgD6WMBLFYVSGZMYzhwhGkecoWcLQwkHn7dBNzrv4r1KWGeen	2186	3NLhiUdtnfPRN2qAqZJVfojrdG42Y4fj5oy7sTxpBVvaR9qUuhoj	1643	933	5	1	2206	jxpjH1kdvr9mivFwvDkNprzpm1MmgEhjF8MPUq5PT2YvcmWwksp	973	1662	1662	1616238360000	orphaned
2261	3NLsXes7FScPCyZG7rCjBfn48yeLAR37yNXsBM7cNctrWrcBPjHd	2252	3NLZgD6WMBLFYVSGZMYzhwhGkecoWcLQwkHn7dBNzrv4r1KWGeen	1643	1173	5	1	2214	jwQ3MMAFUtmPFmhrXT8iQ25wUpWyRZar1teYXVxS1mHHKcTY9AW	974	1670	1670	1616239800000	orphaned
1824	3NKPVYS9AzeRL9camryEQF36tNbyRpXCeKkP1VvQa9XNbSoA9J5a	1819	3NLmsT7TPkbrv9JV9LbqYsMWKsELfPB7rQZH5g77ez677Uyac24x	1581	778	5	1	1795	jwveo922FNwMwjjTDvKZMZbcGHHFRLYXFJuJZamwRHiFqCH9Nz9	975	1374	1374	1616186520000	orphaned
2354	3NKn5pDUC96GJykFJifGaWNnAucVw114iadHJGKWvPPM9bGZ353g	2261	3NLsXes7FScPCyZG7rCjBfn48yeLAR37yNXsBM7cNctrWrcBPjHd	1643	1173	5	1	2301	jwQ3MMAFUtmPFmhrXT8iQ25wUpWyRZar1teYXVxS1mHHKcTY9AW	975	1731	1731	1616250780000	orphaned
1845	3NKdFFW2owX2tRJuJ4r22k3t1fbroCdNShWCua37kCa4sv26WRNv	1839	3NLAFhJb8EDRt9YPRuHEQLHzDHtEyqnSRqKzQdKzsNDQ3vdWYFyd	43	1184	5	1	1814	jxVYuGGdwVAhRdvuxr6cz8D1T1w2pjt5DBvhdwqRhEz5B3rNtGs	984	1384	1384	1616188320000	orphaned
1849	3NLSBvDadtc8MgnRacFfcQrfxDCjFbKWPkDGjSb47nLof6SqN5Rt	1844	3NKEFrwwN8Udui7EuvCoPyfLLYQXyn91had8e3tPuyDGPtF52gko	1631	794	5	1	1818	jwdagHYrGKMgszyGiWokMU1WwuZrvuU1ZM3Xao1xJMLGhS7bRGU	986	1385	1385	1616188500000	orphaned
1860	3NL2DtkdVrJv5Hb1b6tffCGet7Zt6j4Sr7JXaipJujDPBtotRmLo	1857	3NK9aySQJBEgAUKcWGrpbZhA4M8wL2N3cjipq3mEb4HPTuUkowEF	1623	830	5	1	1829	jxjnb1whX5qYxKegDnKDoEPjibbxiFpBm4mCdvYzumdprF9icNj	991	1391	1391	1616189580000	orphaned
1864	3NKhciGbc4k1o7BEyyDKcGHc7U42PhF2C3gLR4CVaBbdcPfbCR3Y	1862	3NLRf4f7dVWJJZtgivyxmg7hL1m2AvC216C7548H5xQAwTxVv2Br	1647	936	5	1	1833	jxb2fVQ7Sr6ubKqfA7okbHYhZQQCD2cVcuzQNpEzoBCGBmSifrX	993	1393	1393	1616189940000	canonical
1863	3NKMg96PV3RVhgxWgdqoN9qMznzqrKzSQ4GNLuqHsL3XbYxhxVov	1862	3NLRf4f7dVWJJZtgivyxmg7hL1m2AvC216C7548H5xQAwTxVv2Br	1406	1393	5	1	1832	jwnQjR8H9vQPrekyztttUNwtE6KLiz66fCLb5uApF3STes5ix9F	993	1393	1393	1616189940000	orphaned
1870	3NL3WN1FeyVW9rLtAb1VYip64AWgQC6nkjhsd7sjov5NK3SYkowS	1867	3NLhtmk5DVQW2zet55jC4cYsXz7k1fFYWP8p2FX39o1PY7dsBRTo	1579	1023	5	1	1839	jwwj52fN9ZrvwSFT4MH4SDBNsJ2uWwTQ5MEJ1883jNP9LuBsKbg	996	1396	1396	1616190480000	orphaned
1891	3NKEgoUYPvpjWemBLFJAR6Pae83QBJUftcsF8DhpEs5RGtF4j42f	1890	3NKwSZbvmtGeXcsLrXuSDoPeEmXXX9mb1jaiy2unF6t1wdBRbyG8	1507	1154	6	1	1859	jwW62vTgdgR4b5d5jd5N5Yiun1v5ZDNPwYE43bobHB1sWUM1MMo	1006	1409	1409	1616192820000	canonical
1902	3NLeFenrpvrB7NFm4AvHRsP8ZD9V1epUe7veD9CK6f3NQsCR49Rt	1899	3NLd8StJqJUepHDNZ21Tc3UTTHnPCRbTvhbwV6135z3kz21iMWva	1581	778	6	1	1870	jxWfHTy54fAin9eJBACS52UAGkBuymNps7PTD7aT8y23uk3fUMt	1013	1420	1420	1616194800000	orphaned
1907	3NLj4oy8mYAWEQJkTpuKW8YpWqohwmgJQhxutiLTXVqK6tVbKxRJ	1904	3NKqxygrBWp2XdYS2QTU9j7qAXzcEJNaEf3w4F17gvRBaxnedLLe	1590	1054	6	1	1874	jxcAonanydvsGjC35bPH5tVHPmmf5ncU4ppuEum4RDw2Zy6DZAz	1015	1422	1422	1616195160000	orphaned
2281	3NKr2wgQqCgiL9MwtSKFkhyF4bL35h2gxfBWb65h37367ci8sn1b	1905	3NLrpWSD2qmJE5g61SfjdFtCio5n8aFyYkfVkSdkqGzrPXWZkeSx	1555	981	6	1	2233	jwwdq9vJpvBDitBV2FVi1cD3vQnethty1SzUY7V4GkEWjZ7Zg64	1016	1679	1679	1616241420000	orphaned
1924	3NLAkojo4cHEKkBaM2Maiyjb6A2YaQ9CPBwQvESgN1jKfQQmVP5i	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1637	816	6	1	1891	jxyWoSRgvP6Ukm2W13Q12YNf2jvWt2tqqWTo4NSsegfUAuKWscH	1024	1432	1432	1616196960000	orphaned
1925	3NKoGi3V2VY9gXfb8zNPouyTw56c8rPhQkJhYeNHSDqZeC9cW5vf	1920	3NKoLdL9sUzzWhNzMDvJFhW7YcHewKnfA9KQ7ZPkL18c5kq6HHRW	1631	794	6	1	1892	jxgkzv1JM1KczRBNJZTfvpJGUDu8Npk77cc2paocFJiYS7cNFWC	1024	1432	1432	1616196960000	orphaned
2155	3NKQD87puDtDghhf3Tn5LNDewajXg93VCACydcwMGnhLw1w3kV48	2045	3NKxx4gJBq4MBDbpp1YDN95UDmXX3frJoiKoQiDDqCQLkj6f1wwW	1623	839	6	1	2116	jy24a53gdnXkUMio6XdbgHcVw4Abwmmezxp68B4bBGADdxwKpE4	1032	1597	1597	1616226660000	orphaned
1951	3NLofStZZperDw2Bqm7rGDQHGUvdrzLERLsEH21icYLFYZJQ91FQ	1948	3NKPLGjzmAqBzzLwTgcGzuDQa6hsL2Lj1CNYF9NrvzYPzFpLfwtK	606	1295	6	1	1918	jxhqhVjvV6DUPk7dkHwRQKoS37yahEbcDk5CCXszWwJDhMU3Paw	1034	1447	1447	1616199660000	orphaned
1978	3NLjy5Sz6ZknRek9GdmY7cuTZjaEfJ5D7UScDmGQsumeyFPJaE9V	1976	3NKe9rkmNo322eoFGdouq584XBFBWzvvd3kCor2bAK7p1vK9jdsw	1489	1380	7	1	1944	jwKt46uNwdAL2S1EQW3L1oKpAnHGcmYEGgQMp9FeUAxaWo4ccCG	1045	1466	1466	1616203080000	canonical
1989	3NL9ohaKhocB2VbJj69EkkJJatZVeGLs7sTNjmdMMYYdr73d9Qrq	1986	3NL1RsbaQ2nT3z4kNUJ8JdTqd7v4FK4tJidhDJbELm7eZLzDwn3s	1573	1318	7	1	1955	jwHzFqT84n26fi35ZxqZiipeenvWQYMjpsVqj8mqhmvWa4KR47Q	1051	1475	1475	1616204700000	orphaned
2362	3NLHcezPGTwh8RCja6w9LUe9rSSXQUNQWdiqSA4YJLJUcXpyd4SJ	2009	3NKKgcbHxAs8vzfpo2ETMYYGt6gs6svVs8TSRotk5bz4GScaH3nx	441	441	7	1	2309	jx2jxefnc89o73nUvJzjyvvW6ptvxSbEXcL82VYvkFPW8VaiGWi	1062	1734	1734	1616251320000	orphaned
2019	3NKt4ZW7huJBKQnbyUvaHDXHYTMvxyXapFaSar7Q1gS2w3FtWkN3	2017	3NLG4TraWqtafFTo2dXJpUYCZ8kZa7uCx7iFeekHJfJdZ85sNnMy	152	1330	7	1	1985	jxNfZYUnLiuqYmHFBX8JuerSxfLUXKxHMthN8a7YPXg1rrKTaEn	1065	1495	1495	1616208300000	orphaned
2032	3NLqmZJpXzva9QFKBknKVJbnPpp774nGUBCdFRLpvogRRXUEbeRh	2030	3NL3tePe3q6PkzwjueNiVS8HzPanotgiwk8taqNNkGM7yLvbS4sn	311	941	8	1	1998	jxhtouYVeXxy1B4Q9iVYykyuJBZUf6VeuuGH8yh4uKc3jLSSjeg	1072	1506	1506	1616210280000	orphaned
2040	3NLZzwq7E6WAHYctgCgyNf18w1WKpPDkjXQTL6AbCXAM2xtiCAUT	2039	3NLncCzwYwDtw6VtsetULmRLS98QqttXMVH3E7qcjUYEDbxUkQfz	1407	1395	8	1	2003	jx3WoNtEQDFcDXBuxyS3TC9pvhPP6pmLfNKX347ges6ikug9ajc	1077	1514	1514	1616211720000	canonical
2050	3NKMZKsWhChR8rCJyFCTpkrApCaqipPjZrQSkdxt37Ht6xnY17eL	2048	3NLp1CA7Tr5HdPnquVuK3BbnQbgWM4vyNfWrs7VqjbkUoQ78NUrb	1578	1296	8	1	2013	jxcJGsF6dM9Yz5hvgMn9qAFhZCwUeynLwoWQiDMgZQZELmEEu6w	1083	1525	1525	1616213700000	canonical
2058	3NLuTvZSLK1wLZj3NFkHrYSrsgU6LAGbvAmDCN48MYoZcC1neDnD	2055	3NLM4tWXjPBWDE8pDDL9FwCUtunrvu7xaQvrpW6tBRr94v3jA1Vu	1406	1393	8	1	2021	jxuPWwxnS4ny2ThgeaSErRkKPxrYizHx6h6Z9BoksQo8Z8maoz2	1087	1530	1530	1616214600000	orphaned
2057	3NKXfPiPTFazNzwpEBU6UCSrdPeskquX4ckzRm3dhxtGpoFyUpbF	2056	3NKHFHQHSHz4w756KxYAst8qxYTxLuaJDR5ixgpUmGZVMZcW5iju	633	1384	8	1	2020	jwpsYwAu5zoCZHPUBxqP351aBhgoF6jPgifVdHYt9GokWgwA567	1087	1530	1530	1616214600000	orphaned
2082	3NLGrrEkxL1fpP7DP8iekxv1ksAUePnzqN8DLocRiCsVrpRU2fGq	2080	3NLjxUDj4VyWXsx3uszekJ9XPFsu6CjLraoUZvZ2HrYrc8z7R1EJ	1406	1393	8	1	2045	jxxRu1ZrsKXG6ane1j3MiCmSVheenN9mfSdewGH4BMMviqz6tLQ	1099	1543	1543	1616216940000	orphaned
2092	3NKk6AHd2TwuPWpjGGp5sfQb6842m6svENarCHLtvtmdorMCGPtH	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1553	776	8	1	2055	jx6qQ8BcdS1msLoAhBrSBF9HU5xmUKmQvmb2XDA4QrTtwTB3zF4	1105	1553	1553	1616218740000	orphaned
2094	3NLg3U6kLxHPV1uFG8oCKmbMGHb4Pc8eQ47VH9reUNYr4u4Xw9KE	2090	3NKWLR154TSB6JYWjWfNnxywAWmsbbcshkJZXCFVRzszfhaGhEUz	1501	1360	8	1	2057	jwr35GWyfApkw1UwnSKRowyXoHTGi69orPQkK9cxufuMiPtgYay	1105	1553	1553	1616218740000	orphaned
2124	3NKpe9AZwYbqqBgFrZpUErvAiUixbcgv26U4XZCXRS1tRcuNkady	2123	3NKtDwCnWFGPz3xUT1EC8ms7zheFFB3EvFGaDo13WyjrGJVkFywr	1610	1314	9	1	2085	jwpfYBmdu5f3XLnsW79EC733pepWNgjTMHEPsnSrGffhXt4Bwaz	1120	1573	1573	1616222340000	orphaned
2130	3NKkLBxBxEGu6LAburpyohshwqNHKZDvQfUGfXbo9i4AiDVHX7rh	2129	3NKoZCPRyWza9m7UUKqzA8ayxZWYTcVw9LyRLLwkxfft3KVQ77Nn	1513	1013	9	1	2091	jxSq4aoo8kSuhgeiX4jPCXxJWw9paDzfXDdyrPoYZLvsJQYpW7i	1125	1578	1578	1616223240000	canonical
2137	3NLVoZe2gQTHYU8bVH7MDCrnsX7GgoMFrCXUkRn7ama2N1FKJuW2	2131	3NLm9JmsPpXc8cEg4i3RcFeydgLmH6UFMTfPmfSK5RYABuMhvRnV	1458	1077	9	1	2098	jxFhPJTuJUsUemHNBybXs9wQtETTJBDa16QfWhdNCdVLSSgraBc	1127	1580	1580	1616223671491	orphaned
2159	3NKRC7pyLng5wwNfPMtigRzF7pGcP2WiArzb5ax7jvwfhFCqge58	2154	3NKmZaUPN6LKuoF1bTdbCHJnc7KES75QMsjTLNzBL3ruEtHc6cft	1627	1385	9	1	2118	jwwPwMrswaub5Q2bb8bNKcXqvsG4ZVVwvS6QsdtJEvLpVaEASRr	1140	1598	1598	1616226840000	orphaned
2569	3NKsog9yAhtzAV5sNSEnNkSuP8r4SRCLMqJKhRvkStye59JqEetR	2166	3NL7sYQuG3QE7ahbGyyJYSdBqkJJMshVifFs6Z6WiCHA6gpsVCy6	1518	788	9	1	2510	jwCK4Hq5ScLfhaBRX7dpAdTBjShauudHAXADGQ3ZKhxpJT545a2	1144	1904	1904	1616281920000	orphaned
2586	3NKK3fcmmQwWt527RYaAJSP9jVrri84jMryg6MNMGd45NtkCQFJ9	2569	3NKsog9yAhtzAV5sNSEnNkSuP8r4SRCLMqJKhRvkStye59JqEetR	1518	788	9	1	2527	jx7gX6nj7kiT3GJjUVnjmzvkEJcCTDR95f8j1oW76wpd19D4f9j	1145	1920	1920	1616284800000	orphaned
2198	3NKdNBuWfthcaWXVTtoiPHorsC6WmzUAfA6qJBgGEb7muepm9TiN	2194	3NK7ZDqTpM4hAQAms4Ak6aLe2mojCHufR9KrUSow94trLUwzfV7z	1407	1395	10	1	2153	jxQjw1WgbA3cYT96LbhXjVcFZvopy7ZEvsAQZoh9fHLm86NKipA	1157	1623	1623	1616231340000	orphaned
2215	3NK9UPs6LD1Cu3P3zdNbheaXccrrrvKc8VDLpu3688hbo7cTxkDg	2213	3NLggpkhQRJojptjJxQiSNAJKuoWRqvgSEmJYL7mpSguPotXCE4t	1426	1364	10	1	2170	jw6yLPXLobAHdtqrzyri63jCSASsRi4rp6wMSSWQBZDasik327v	1166	1637	1637	1616233860000	orphaned
2226	3NL5fRzUBMnyywqA6UfBZwR3c2YSV6Eceg25hcSmX5tKoHn1ME8i	2225	3NKijJdjMPSPygkjkkxTDwNFdgj9xhmpoCdXKNtmeqdSA9dGcsoq	1448	1311	10	1	2181	jxh94MEvjJbSVtTKD479duYAFyBJWowoVp1qe6xtB7xE7pUvRMD	1173	1648	1648	1616235840000	canonical
2229	3NKRNc3PsNTC81fuE2xSVrwdddNgUSFi9sgQibRVKCbhwLupRooX	2228	3NKVU3SC1X1wBZM71WQQ7XHB3ZbQXNtHDYK37ikbtYh93sTBuYCv	1419	814	10	1	2184	jxNDLRBGm7NrtxhqUTNMqRXsjLwwXjuawHwAPJVUQR9dU58q6Rs	1175	1650	1650	1616236200000	canonical
2247	3NKxx3gvhb4CXUhChhAkZCf7f3deravkvGUB4mKfQGo66nCHzUey	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	1509	1074	10	1	2202	jxheJgUFbrCweFCADp35yLVs9ioEViULQSjai2w4gBtsdHmh63B	1183	1660	1660	1616238000000	orphaned
2249	3NLvUhXr6Lk7yK4AAU9krdMLQfED4Z3JxGHM2xNHubyw69WX2ox6	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	42	1115	10	1	2204	jxSSv445UxjUkascAWDKg778GbKbnKhqXbxv9XYzUhUJabXCLg1	1183	1660	1660	1616238000000	orphaned
2250	3NLyYZeFw9dndYcnXU1KCQoFApj7YqMn9Ee1DL9huHzwj26RnUY7	2243	3NLLuFtGomnGxpPpzZNwA2Q6cyRGqJ8rSk1XDdj9FQahUFidwCCE	386	386	10	1	2201	jwi3evpMnoHjrWe8mUxnHoyV6ecHeKn9VGMzs6JR34vtwgqoYip	1183	1660	1660	1616238000000	orphaned
2260	3NLvXky79agh2M1Qm63wfZd43uNYi5KVrzcBP248npJnSM2VAW2S	2259	3NKoG934G9AHdpqP4gMpdLnDx2BDh4qoSbUKn84kGRUB1Zo85QW2	1419	139	11	1	2213	jwtWo9eVoLZqxoCfQfFwyqEpgiwiQKK2gAVpK5Y2xtavcE97WW1	1187	1667	1667	1616239260000	canonical
2275	3NK971rc9eGs99nKmAajtvL17wFewMMKJ3REUSVycG7SqB2zWDMy	2271	3NLArLcRX9ziJJtXYwrYnvFkno278HTYZiwHNNctWvVuYUwDGM86	1470	542	11	1	2228	jxP22oqoT3LG7Kb1jY4aprSyDTmV6MUMdTDGNLmX5NV3s4m4NeZ	1193	1676	1676	1616240880000	orphaned
2295	3NLbtWJqardpeBAT5JEgFUWtBKs9kWs9ZPMo5GLvRd5zCtqopd4Z	2294	3NKSTn3uHhqBAVtMiYG8isyYEtx5ahNfKc4NLUdkoat54gPf8fTW	576	1229	11	1	2246	jx2vGApe6JR9YhXFNeEz5kMYuK4xptPGE1FaCpcjDpJCCApWL1z	1204	1691	1691	1616243580000	orphaned
2311	3NLSi594KBrysRXnMwnhA49wbfJnGi3HeXxR81ditmSrUjYas86F	2306	3NKG4YkGQVssA1F1Mceum7oSMxQ39wEt4qdz93x3ZUiZGfjdeu7Z	596	1306	11	1	2262	jxe7oPKNLdnJjXRR1qaGNYA1zYs9B9x8rMzYsfS1nQBAbTht6QX	1210	1699	1699	1616245020000	orphaned
2329	3NLm5zRHhDw9D7RPg56LF4B9BRb42yd1sCCWESeTx9xZpdaFr2he	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1553	776	11	1	2280	jx47YZfKvnysswHE4N3aVnvAbb8UJAbqhiMFsiuA4UgVxfGJGa6	1219	1711	1711	1616247180000	orphaned
2328	3NLKMcuhbs71GSHXMcdjijrKPeEGtEvaD7mJNNwGVpmA5m5oLAY1	2325	3NK4Dw3Y5ZptK4GaTFpJTj5AnK34e1ky1QuDMQjPbbJfB8o5z1UM	1619	909	11	1	2279	jwPUmkRWjBsyBkbgmH36F9LKeRB6tWgoJYLGRKdmFyiV9GiwZDk	1219	1711	1711	1616247180000	orphaned
2334	3NKtKDZzb6XVp4nsvHNrsD3FCqi8r1RwRLQHfj4wcAQtGDKZ9Bfp	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1419	814	11	1	2283	jwbxQitZ912krF6vXnva1Jgwmu6Dr7GqCoQKFL4eY3jgG9jpxRa	1220	1714	1714	1616247720000	orphaned
2335	3NLLM73chi5ppyzpatzanrgbA7whMkDLu93jcuZ4MTenC99yLzvH	2326	3NLu7jZqNpvdYdjdkGMnhe7vUWw47FAHvAuvB7Skek2cGdLkwii1	1633	1390	11	1	2284	jxkt1LJPvtgBTnfuHWPnkYxGRn7GgvGin3QpP9GKRdKd7Aq3juo	1220	1714	1714	1616247720000	orphaned
2339	3NLbpwhYpcnXnprZLiyE5dNfuN53DL5PjkRchf31E2B5WCB85aKJ	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	633	1384	12	1	2287	jwwMnforTjQUx8WGSGvfy7iuhduExMvi9s4JGaUTnbYNGbDMpuk	1222	1716	1716	1616248080000	orphaned
2823	3NK7HWx9zANRNzquzR5AR2dFyAuQMLEX6asTQj9dkkaAKDsPBcXP	2336	3NK5SxZ62tEYn3S3VdKPdv3mffNdxor8mDJU7G3JVv921v5KB74u	1529	950	11	1	2756	jwUZGFkGuGqzhNRhdvNH3nxKvDvwuLsBNo11rgf3htJ7PkWCXF4	1222	2082	2082	1616313960000	orphaned
2351	3NKTMAh1ePdfDQW42VJvMarHMH82Yvsu3d7X4hAydoc4B2S4nR7Y	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	44	1325	12	1	2298	jxYshNAqg9LKJVYpr4xZR82DYPgnt9RuRJS9yLpavWXeP7AtoYx	1229	1728	1728	1616250240000	orphaned
2352	3NLU6jZai3xytD6PkpdKNFTYjfYSsEWoksr9AmufqYbxJN2Mpuke	2348	3NLGaCf4zNXouyKDkmrFuYBVt8BHnCuLC9PMvkytfFgiuuqv5xsH	1440	1377	12	1	2299	jx22Hbd1yhYmaz3UhtRZEB9MDxbP7uJG9Y2oMUJkbcvXojtUqSs	1229	1728	1728	1616250240000	orphaned
2485	3NKNqeqRjSY8Qy1x4qwzfCVSCGUq2czp4Jo9E7pUY6ZnHTBg4JiW	2352	3NLU6jZai3xytD6PkpdKNFTYjfYSsEWoksr9AmufqYbxJN2Mpuke	1529	950	12	1	2430	jxzCUhafkVQFEBYaDMNZyc6fCNjPPBxrGiNCmvs6p6GANiBH8cH	1230	1827	1827	1616268060000	orphaned
2760	3NKMBzGM1pySPanKkLdxjnUS9mZ88oCeanq3Nhm2QZ6eNB5ZkeGn	2485	3NKNqeqRjSY8Qy1x4qwzfCVSCGUq2czp4Jo9E7pUY6ZnHTBg4JiW	1529	950	13	1	2694	jwFubYD5Zo3e2wgYnDPZ75TCnUr8URZUyosjLHNYBeWqwRrVhTK	1231	2034	2034	1616305320000	orphaned
2357	3NK86abekKmd1YqdWxKVLUgCpozLecksYDWpmHEXfqXoQxz8Xkig	2356	3NLc4kGkfWUSrtaJVUMiaePDnDqLfBJXrLStvoCCG1SPnKz1Zaw2	1587	1357	12	1	2304	jxcY4xzN3Wrr4pXToViz3pmk6z5UXRTJ9QDA5uypNeqaK5XDUUN	1232	1732	1732	1616250960000	canonical
2383	3NKDBTw4qsGCsvDXHRj8bHu63kC5eZwGvgJZcByUfbpjM2U497Va	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1623	839	12	1	2330	jxNHoH9cuYE1osMdfGUvs9dHeVRVYcw1uosWw3TK8apEcSCvJUp	1246	1748	1748	1616253840000	orphaned
2384	3NKvYRrSEsBYTAsR1CvDMV4uaowE9NXqzVDLBGrZQfdVXi9YNE2M	2379	3NKsuKrzWpfLPhSamPGGC6FvETQ2LD4QvaJ84PcE9Y7u56NpLSTq	1403	824	12	1	2331	jxaV7KNNW3uXTMfuLZwmaLyRFyPEDxj6b4wjkLoxvrBK5xyXXtv	1246	1748	1748	1616253840000	orphaned
2405	3NLorEADbNp7MGQnBp66ga7pZh1sa5YGHMibLcxzL3fsV1ofsyJh	2404	3NLy3FquFRPv8RWVX1TPBbLS6edcr8xA1osnxcKdh3tGcZpysBqd	42	1115	12	1	2351	jwWjnaBpxUb8PKGHX2KjNmnRrnovkjZTiFDgXqQs1tubuEj2yxT	1258	1764	1764	1616256720000	canonical
2501	3NKLtWLEWqQphQWaaNUTFCtzSotGtJD2pwyhTFXkrgb93WHjgNAK	2416	3NKy7zDtEMDTdEsmA9SFYT9T5HQE7THGovEgB8GkmFAvDwiLhvmc	641	1090	13	1	2446	jwhiSz5EoVWduhoPxCebVtEiVYC5kTDEhr7k5UJNfuFXDPFitvg	1266	1841	1841	1616270580000	orphaned
2655	3NL8xwQf1tTmefZU9NGKMq1aaakboatBhzSjxfngFRa2hLjUKm2y	2501	3NKLtWLEWqQphQWaaNUTFCtzSotGtJD2pwyhTFXkrgb93WHjgNAK	641	1336	13	1	2595	jx39AbM6QVZEVDm8FmfLtoMYz1KZdSRCAkVTQ5eCT8d7adF5XbW	1267	1970	1970	1616293800000	orphaned
2754	3NLJJfAtHRTA1fF822h9y1a8ZQ1BMd9bJ13DuBw62vjjXrWNPDB1	2655	3NL8xwQf1tTmefZU9NGKMq1aaakboatBhzSjxfngFRa2hLjUKm2y	641	1336	13	1	2689	jx39AbM6QVZEVDm8FmfLtoMYz1KZdSRCAkVTQ5eCT8d7adF5XbW	1268	2033	2033	1616305140000	orphaned
2917	3NLGPVxGUx6XBTx2aZ1F96fRnSUVCdXV91VDYynQfGTfyGAghtTp	2682	3NKt9CzWSmrdfRdpH8dcaPh2akczcBktP8ExLJguXTnmxNaAVpWh	1643	1299	13	1	2842	jwBxF1EngeeDc9BN539FC43v1MsUNLfmJbVGy4yNLC6oBqP6Tgd	1270	2153	2153	1616326740000	orphaned
2436	3NLJhhnbwfXapiUf3TsW8ZSmRqvSioi9zPsZ8Td8TPsG6BAJKnNL	2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	1657	978	13	1	2382	jwuQfzT7pvaEBhymQ9HjB9n9Gqy3z5jnYsok4kMDkXUcdebXM9P	1275	1789	1789	1616261220000	orphaned
2437	3NLEf1k7wxYGPfwU6CMCiXT4eCBwZBcnw8P5YJGeqVmiFo5grNdx	2435	3NKy3WeGaBkUDhLy3YdTcdSiZD7ATeAwnmE1N8kziPcZGDgafaL5	1422	1337	13	1	2383	jxYh7Vrz2ELMtKH3CxdQ1SnKkkRj3EFHWbRzxsqKcWmc58neSe5	1275	1789	1789	1616261220000	orphaned
2441	3NLdWBRDFkZP6Wo8rvxuHP9ew4QQEjEo3MBRdB7epBS3ZtHSrAv1	2440	3NLBvZP6pdHW9BLrogyvfDvAKWKYKNrKaugLrHM3QXjb6v1Umk1q	1405	873	13	1	2387	jx5dvJc8NkeMYjqMHHA3ScCVN65CdzvKExJCamkRGdajaaSwZKy	1277	1791	1791	1616261580000	orphaned
2454	3NK5XGPARdXzbEn5hQmLZiQxNH2Q8VX4j1MSu2bw3xLEvDCcQhLn	2452	3NKr8KQDDg8wHd8KfwpVDPmR6KQiZ7iPaAT5etAeH4BZ8K6swwFA	55	463	13	1	2399	jws28dczrEiCfeEQ9SpxhJpGzDSonthomEsywZT4JbbPi51R8Nn	1284	1799	1799	1616263020000	orphaned
2870	3NKE6f9G5w9GCLMzdq9aGKWogvqGDLJiQNU1S6U5kLKxqGDS9mPH	2835	3NKu8j3nt4ReUzAQ6vKmbD2stwokKzqRZW1J7YZyw37grXBtxBcu	1403	792	13	1	2802	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1285	2123	2123	1616321340000	orphaned
2977	3NKPef1GyR2TdkRTJ3xqgLpdgVsArWbfUKkLwbSeu3QE7uLRQfQZ	2870	3NKE6f9G5w9GCLMzdq9aGKWogvqGDLJiQNU1S6U5kLKxqGDS9mPH	1403	792	13	1	2901	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1286	2194	2194	1616334120000	orphaned
2989	3NLM7233PUk5ui4pZmsGPD7Xuaktg9kwRCjm5sVuJzYtSXuRkcKX	2977	3NKPef1GyR2TdkRTJ3xqgLpdgVsArWbfUKkLwbSeu3QE7uLRQfQZ	1403	824	13	1	2913	jxCfW5X1MBNc4CRE9Bpto6ZNouvkvTYVHVB6YRPhqG98zCixfkB	1287	2202	2202	1616335560000	orphaned
2471	3NLcfhSK6HRc238a7hQGCWuYG2SWvUy4h4UoivRWD4sjasDq3pL8	2468	3NKgf7qgJaK2MSsvhdzBnzsEVD198XvBEDDQmeHdXU6zB2FwHgKf	171	1008	13	1	2416	jxTbYaJJLaBkAJ1BCizgHLYUt9PiBtgiVf4LGxnope6y33pSZMV	1294	1814	1814	1616265720000	orphaned
2477	3NKSfH38q1yMxmWs1xJheTeUnMPgFP6GDPSGK4uFExpT7nrsCpex	2476	3NLMTTbKm5ZpMvhXXmGa6uZnfbkMqZB35RsBsgJ5hhcdBJwWtGfe	1407	1395	14	1	2422	jx8dAPsuhdqYunhiE4sm29Atb8bQW2pSbeoSxBe64je9xWT8bRf	1298	1822	1822	1616267160000	orphaned
2532	3NKxfcpRExBbbY7zhF8j7Xn1Ap6GEbfnBCA515M7gMyb6DnjaSQH	2487	3NKYDq4L55kYy9XmVEwtZao4aCiTgZV3KJvccwTgwRUuLFA2jpwZ	576	1229	14	1	2477	jwj6Rx5VWGHnUtP4RwA5SViBugVZnJAk6s5u2Z983ACMJ391k3f	1304	1876	1876	1616276880000	orphaned
2491	3NKLzn5boboG2zh6fZKvLfC6xDEAF9B1V6XNsgUUCz2kSQ336E3J	2490	3NLaRPUQ24ft5N6MTijugwRPRKe3xspMMcUt9EVVfp42WhXScFrc	1560	1165	14	1	2436	jwwhxEx4D828Y3FkNMqHLYwe9nvVLwo3Nj5DAfjMGHp1giroch1	1305	1830	1830	1616268600000	orphaned
2519	3NKUtEmiuEtUGuChZhkW57Vd6g3DfZNAJBNQw8LC5WTyseZWWwn5	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	1559	987	14	1	2464	jxoSXrD695JXb4zuugCKXXDyQcJK31GorfKici8szRY59QVqYKo	1322	1861	1861	1616274180000	orphaned
2816	3NLiWUP6qWFKs5WExMb5XNYneA76a4Kzz1LzEFo16j851wQ8hSqo	2515	3NL6ZeBwFvT4HedHSPd7AkHnzFH8BcmiNCkooCKvjR6iUfSj3tvT	1406	1393	14	1	2749	jxKravBhCLkSd228LDmzg9hertPht9wAAvJPzBSPkpGixRbkeiB	1322	2080	2080	1616313600000	orphaned
2535	3NKP3VfQ3WMUkPRQejLR8zb5pGD4jXppDtkBvRpn7DFhrQJndgGs	2533	3NLHGLALFyzXii7Un8ZUhs7LjcGUqAXPda6mQNF7d1G2JAWGGo2F	1458	957	15	1	2479	jwuXTcsfPywEhxwvbqZCoJ9qshrZS4QrUjm8KBr7BghtULWGaWe	1333	1877	1877	1616277060000	orphaned
3092	3NLZ6PwaWnW21ktX5MD6JBTfE9vKcYfYXkfDb2AwATHjQhCEgY28	2788	3NLqK6Ek82h2USzp5XGb7BmukQGERdarRoQ8JTyXEYSUwUe79hST	1673	1122	16	1	3014	jxhHMcuC2r6TunEEFXvtHFnogzJg8peZLvR3iZXuBGkSpjmqdaq	1334	2270	2270	1616347800000	orphaned
2541	3NLQBrUPdr24mK9czDbR6cbA7w6JNTfsVSvQ7KtdYKcaNmPvkxZU	2538	3NKjFewTBFGVPaH138NKu6bjYxXoh9yRRfofnreqCuQFeUtJvdGC	1406	1393	15	1	2484	jx5eUYuC6HGafRV3fU6jCrgMRKZ6FK5jmfYhJmQNHMDkTarYp9i	1336	1880	1880	1616277600000	orphaned
2560	3NL73C1v9kT4MFhM7YPbpTt1UMi5uGyud3N9pw1NfERg54JGgaNk	2559	3NKdxMtiVhWMfF7i2iXj1CEAwDZCx8X7x8BxdD4xATRZ82BZgnX7	1560	1165	15	1	2502	jxJxytADYEhu6upYzoFCaBnJF5VfuHVkcq51SdWaBHbhbqsvRBe	1350	1901	1901	1616281380000	orphaned
3105	3NLgFG9741ZdUfFesEhpSdyKzK7Kr5TqQAAwss4zDZfHFYbs7ni1	3004	3NKh73y9jsHgBjqxUrcE7dd8eDjB9PJsBxGuhmHJJ4U8cRMGTYg8	633	1384	15	1	3027	jxdHhm1nzUukHUHQm2LXcQn8tFKJW7cSHWyxGm1EtFAYacmDSCx	1360	2280	2280	1616349600000	orphaned
2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	2591	3NLgbPn3diRbzHrpEZ1n6DMBAcNsYtJngDRzSrp4ZWWduFJoiNmG	1552	513	15	1	2534	jwpQmUX42cgqh6t7SjDNmorbQNStscKRL76qKcaS3qKLdGsbWvz	1366	1924	1924	1616285520000	canonical
2597	3NLZgvzzAsKqyncK6jxZNrpSDARq8gVhYWxMs4B5fdSUQCdy3BTH	2593	3NLcaGegrQjETukeizMu43QtRBc917y3WsStkMYLbo8Nsxtd7FSo	1406	1393	15	1	2538	jxfUMSAGCmRa3aFwL1AxgCmC8Hjypp5ZKiPKXHUezPYMcg1NCM4	1367	1926	1926	1616285880000	orphaned
2611	3NL8nCmrYyhsDtUz36aampyc3w5bBEHwZKBrMBD88VeWtcKThJkN	2608	3NLNJRgnSxAPG6w5t8aXgF3AhuRGWsSnnWCoaccGKZZDmVeAjfq1	1578	1296	16	1	2552	jx9EUngBkJL8EmJdTxv88WkMS9QxzWfT7PNeLd2uhLPM8ca8tdE	1373	1934	1934	1616287320000	orphaned
2620	3NKSCVgRgSDkw49VE9ryokXhCeoVpMuZhhMrci3PkLfarjNruUAq	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	1652	1315	16	1	2559	jwLuMbgrddfyjdETmLJ1ezrgjxp4nDF6rbDQYP5CpnVeWjKeYeu	1378	1943	1943	1616288940000	orphaned
2622	3NKEaWuwEvfwFYfHBrH6H4WtLZEogSavTVzD7pBT3FNacUtDyJib	2616	3NKcCTjmnLy5CjDHCDo8tJQykdL8d6sAmaRu2fN6c3oAfV2Yihs9	606	1049	16	1	2562	jwvJijJQ5P7X1fXTTeDoVZZUzgXQduAzzRaqocT2RXvgrKAzYMV	1378	1943	1943	1616288940000	orphaned
2625	3NKGygFghCvHn4YyrAYhS6YhHxAuc37uhnEYjMzSP231nvfyCNi6	2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	1407	1395	16	1	2565	jxkhjwhnHtbBkwGekd7kXMmVNxGY5L7ZBxa7Pou2DdbEkY4hKnr	1381	1948	1948	1616289840000	canonical
2627	3NKMWRYWpKvg2Eoywe1Aejgr1ySk2XVbUcC86pGXjEqfxYYMvLBD	2624	3NLyRCfhr2iWqcgRgipHu8YRS97zVgxZZDDB6eFShLx8pDs89CWf	1509	1320	16	1	2567	jy1ewM34mLXE68kGLoZR4WDjstCANAEFKgHecd48izc9rY1hCi2	1381	1948	1948	1616289840000	orphaned
2632	3NLoz5FLpjtQNTNMmxAkSZkFcgkNgMNkNXFoSRGcd7wZvJYZMACi	2630	3NLYU9QrT6yjaAQoM8QbpWnCW4f2MZDc7xRMCtJ1oV5dCELZqgRe	1474	1083	16	1	2572	jwR8ybry2yJv6njzkLzuYv7d6zmzPWMXaQ1CfSBEE2H33pHh2mf	1385	1953	1953	1616290740000	canonical
2641	3NL9jUiu2b51Vey6N6z7JuMW2rdXNUnsSTA78roPPvBUsk7JdDqq	2636	3NKQsWpiKx2jA72A3Vu8RdTAd2T7U4sRbK3gj9MUGeXXaoWNQ6Hs	1611	1095	16	1	2581	jxWa1NxgtKhKR3z6jPg6F83rC4PEymSfkVUgEMduq1RZZ93uBvK	1388	1956	1956	1616291280000	orphaned
2652	3NKfB7Ygco3SzTKdL27jfK8QEDnJXcAab4S3px2ZCRWWQ2o8vi1v	2649	3NKTcS28ccZ1wdyMmey57PJMGYSQNZ3tLTXAdYp8Y37CmbYeT64x	1506	1373	16	1	2592	jxR25i9CepwzkEHwTC2bStU1rV1HvpeBc4BbZjSbj8YdoVxxy6d	1395	1965	1965	1616292900000	orphaned
3066	3NKJaMwsFgyJFb3WYEigCbLaiX6ZsVN5QoDaGUXgeE7cW3zTUX7B	2957	3NLPEwo3hkfkKNUMVapZ2MkYuuC1zFrXJ26rG3uvUzoGGQmRA5et	1513	1013	16	1	2988	jwFomTwsXqG1cJamGGd8u43SgT1e1qzYx7UN1GkiiyMF52fWdqq	1407	2250	2250	1616344200000	orphaned
2690	3NKB2Hfz9DxySNYqYZr2wiEPv4bwfeeDrm66bUdynZSnQC89Yiu2	2685	3NK93prH4H6fQxcKdTBaLr84cBpYMqFx8KuaMGiuWwutwDuMF5yY	1633	1390	17	1	2629	jxvWGQgjUhCRcy3LmH2Lre8DPpUiBQxwRTE6zHBfMZKtein9XLC	1412	1992	1992	1616297760000	orphaned
2713	3NLjPBsfkzxJeCSuhx7sESYCWfVxiDRi5JUkZdAtFWcTun4efEg5	2709	3NLtDNkq6arkQfADM35fKm7NxGjq2eSDRrdiEAYuBeJxY1DSB8Lb	1474	1329	17	1	2648	jwkNUo8zoMZjHenimtuRvyUbm8BhzQH1chLr31xH35FWwP3QE8K	1424	2007	2007	1616300460000	orphaned
2717	3NLH3LjD1crsKqkGuCRsrVhNmyLkw9HMYRLGTa6ZvqBTh2AF4EiM	2716	3NL1omcoo8b2WYWDZLLXf1mJWk6BBYDZJHsCZX5JvcizXw8P6JVE	1509	1320	17	1	2654	jxLXCwLY7TsBiDcRjiG9o2RRJG4hCE2sJwRczH4HGdgggVxQyPy	1428	2014	2014	1616301720000	canonical
2725	3NKeHNeVp2XaAaJ1MomqnYjWond5oAs8J3aBxqKqsuTkurAxkCaN	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	369	1312	17	1	2662	jwMTWd3evrwsqD23sfhnegkLva9ea6cHvcoi5JaqeJq21pNxvux	1431	2020	2020	1616302800000	orphaned
2723	3NLNspHoKzMv48Zz73ERrW4X5UDkmpsLkkpxVPkkUQqZWTy1XnU5	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1657	978	17	1	2660	jxgLoNR5FwNbHZy7z3me4nRnKWhiFKwKYbHwXNxqac3VEn2iX6s	1431	2020	2020	1616302800000	orphaned
2726	3NKvFf6cmccVgVfwdSen8fJi1FgdwNu3HXhofnfLt9rUEwSZyg5J	2722	3NLAo7LPAF4pk8wy27JREjyQfZz3KrPJg75vD53cAt6h55Q6WAYw	1602	1003	17	1	2663	jwXuGqAXYpaxiwtx8EZG44WY4t2ReJz24Kq99JdqDigY4PSon1N	1431	2020	2020	1616302800000	orphaned
2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	2740	3NKu1rqi3oeAoUw4YLX7GyqbFh8fNBGfKx1mrabbr1AEvyWgtyjU	632	1256	17	1	2678	jxmvJ4DjXjZF9sxMeZRvAaJKGBafjPzwVafMHfXWaSSb6STNj4B	1439	2031	2031	1616304780000	canonical
2752	3NLd1FoWBY3ZVDCUZdyEa71EYKCLPAoYKECwYBnvZKfjKjBhk1D2	2742	3NKEPjhRgs3X2mkkgch8BDk5MzEbT7UFiGuMmpRn97DwdCPuWyEm	448	1179	17	1	2687	jxMAqgEmeuz7uGnrFK1BxpRqm6cigbnQqbN1zd5usy4vMJDC5bS	1440	2033	2033	1616305186337	orphaned
3289	3NKqUsSoLzWf3wsiZKBJW1qJDAnj3ughZRp193QHdLDn5hUyfF5L	2772	3NKsSdWY9WH6CEiv28CNg3BVNTPKykqirwZ6a3AYZ4tabwQXJk9B	1467	1376	18	1	3206	jwRZ1UyfbDTsA7T3dEYL5P8Gh81ywBxeR7xmmSrZVM97e6yQrSX	1451	2438	2438	1616378040000	orphaned
2777	3NKVsZKVyBZp18qCBhsEXntRgdoi5rxx4eYUndKQz3Dppsc9pmAL	2774	3NKaR5ZiT76tGFf2SRKdRGX7ib4wWuUW7WP5ujMBfsxYRwkecc1B	1555	1347	18	1	2710	jx4Asv59zQfFQkSMd929TuS4jWYdWb69r6c9iyJWtT1fjzEXGvo	1453	2052	2052	1616308560000	orphaned
2809	3NLFmtPGYmsFjxdgchiQ7qgJE6pNd483bk6tKF7njRuEquc6Y8CK	2808	3NLbTw6CsTsWmc9HJBzFyKU291ZoyYkexB6tnpUhM72pfoseumLa	171	1374	18	1	2742	jxvMiMZFNRiPtpuAguJZ5WUMRMrsz9YGqqhuDYbxj9s8h7NVuJ9	1468	2074	2074	1616312520000	canonical
2828	3NLto3AEKdkUNy4mqQeMg3ccGF8MxmPe19cZSPA9CCHo52jHiGpN	2827	3NLDnqgTk3wgKA686HJkTG93MVBDY1uffpqtQN1igKVy4nVs3GZB	1649	1137	18	1	2761	jxet9sr3vDBkx4S9YBZk34QM19xULEUxK2pgDyXeeoSyVPwQeQS	1478	2089	2089	1616315220000	orphaned
2831	3NL25GoxSwjfo1rpGETYgXFZ1ADTWrPnCaDgSrRGQs3cgCDzoRM8	2829	3NKHUqwc1YhRQVPUfrojewmYdoQzpLSBgra2XwvNVgJeHu9JoPmk	152	1084	18	1	2764	jxXuzRSDeYsXACDgkM9GszmYChTocLcFFoRQdamwFokbquxN4GB	1479	2090	2090	1616315400000	canonical
2859	3NLdFp5jq1HRb1a38JWXeCyjQ2hVrDarYvELzJYPQmDzE4YE64XC	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	532	937	19	1	2790	jwrtP3DB68gmFByKP9Yd6syimWA2MVfSEamL6s9oNucbeJrNfGH	1496	2114	2114	1616319720000	orphaned
2860	3NKaMySnEKzNziq4vScokqLWuFB9scQPuhVEdGf3TWT2uxnM2EBb	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	1631	794	19	1	2792	jx7bkeMrQ8W1f8u8ojHwc7r9dXiEUbvVk4LjN5mYDTVWCEmPXbz	1496	2114	2114	1616319720000	orphaned
2857	3NKb7dJZsq2e7x4ghLBfA5h2NAJGepXB4PkBYxP5B4nVN3bwYbzi	2854	3NLR46C2vpimAdaQ1Hqk5JrArmNRSAL2A21aWpe1YdYu2YTSfeRU	532	937	19	1	2790	jxRJicRDQMWpxcrvzf7VX4VMBW8DSQFboxYgmSR8EDWxDFsBuEP	1496	2114	2114	1616319720000	orphaned
2874	3NLQt8wDsiHNi8nF1tEK7cjojto5N8m5eUBiFBP5R3w9tPii2fjE	2873	3NKpnywYMci5Jitm2DvKWEhRaySZxoCHyJtfFtiUDWJy1PLuSuzr	1406	1393	19	1	2806	jxGBbLsthMmaywryCtrGxqCgyaDFbGn7JreZ2iChcyirVcd944j	1504	2125	2125	1616321700000	orphaned
2886	3NKyLghS7fN8X1Pux7LeksB1bidhdPzYFLN5zHcB34HPqpKwGTrA	2881	3NL1seqD7PgwB2ikAWYMBrPqEn9qk2nmvDjYtLF14tGzqfnvWFjH	1523	1195	19	1	2815	jxtzB8Koqf2YXTPLnsLTNCxUDUsfQLcvAzALVWPQssy9A9BsiuM	1507	2128	2128	1616322240000	orphaned
2908	3NLHfmAGmVfnuysM48V7PZK5yNTGHaCP4ULRFz9Gvp9K7aeN9eJo	2904	3NKuUBaw3LvKp6B3P3dJURNydpXbAv5TutsMrMHqhdsoPsc8kJoQ	1613	1349	19	1	2836	jwSN8PKyrMDEJHRVbcAwK8jokoCKfE81bT3QTEmhCguui1W9Q3d	1517	2144	2144	1616325120000	orphaned
2928	3NLyU97Wrn5HEKQaea455maeWdu9Sp2NnXUWxDknYaU1HdfBTDfY	2923	3NLAJY5L6x1ejscT984JtGxrTop15qvgPX1h3spZZnkSZsgnEaq6	532	1303	20	1	2853	jw8pUpbDhRbvifTWGm9KKvjWjnZ1KrvyCkE8a73F1p3v5ZyRrnZ	1523	2157	2157	1616327460000	orphaned
3176	3NK5JHAvkqPdj91tJsReTbKAHiSFZNqwByy3ojtP1C14fF36VCVD	2951	3NKki19KLbqwvyCKWwiu7d5HSbWVmSYZkDpzq5kk8RRkn1mktHB4	1611	1095	20	1	3098	jw8yE6sX6mksg9TgdEEsUHqrGVBCaptsVyqi9aGk19HLeowk2NM	1531	2346	2346	1616361480000	orphaned
2947	3NKBv8iGwee5PaA1b4Y29Ujxk3J6HuX9JW3dnaiuRqf8wiFZDNXA	2946	3NKzVj7cmpAwSBkAzkL7iRLdRWRijNRd6UXCRzMQaXsj4Ne9J1DU	1609	1207	20	1	2871	jwmMcQQMZYaRLQoXayoWLNbNyqHLjiiGFm4dKJhnQoDULhmbsu5	1532	2167	2167	1616329260000	canonical
3350	3NL9sMa9s9WQX9FU3unfZj9HsAfL4moGq2MttiiQ17eh1vPBeMB6	3176	3NK5JHAvkqPdj91tJsReTbKAHiSFZNqwByy3ojtP1C14fF36VCVD	1611	1341	20	1	3267	jw7V28F3MotnADUUCvjTF45cuRXXKWSky9NBMiSWWYTuPnCgMPt	1532	2481	2481	1616385780000	orphaned
3443	3NLFdQu8JyQyXWHkPHqKJG7X8agxB3ETyo3uwzsWMvGqDSTveNbj	3350	3NL9sMa9s9WQX9FU3unfZj9HsAfL4moGq2MttiiQ17eh1vPBeMB6	1611	1341	20	1	3354	jxzg99kGK3yp39oDWrw2yinhZxq5DK8M5KFzMthMJp5r9vekHf7	1533	2543	2543	1616396940000	orphaned
2955	3NKtq1emtWjbnuCiTgpdodGXXWW7u4EQbkMHXBJdKM7urhKgYc2C	2953	3NLmCfiqyDtGDPGd5GyFN8TaJ5uwkVzKoRPWu6pxPFvzpJBG8FwP	1507	1034	20	1	2879	jwrwAYGT6eJBBjGTa5kbDjw1eWknq96qHHEqLxdZuZixKHMGZ1V	1537	2178	2178	1616331240000	orphaned
2961	3NKC1SRaayvfZtoAKGJLjVJRjnvS1YBtXsqbnKoJxbVQNmuK1YBt	2956	3NKdo2PK6xVe9XD2fZphgDcZvu7ce5x6VAb2yjpuwPnYXk8XVvWu	1588	1392	20	1	2885	jx1Niez71dfT5xkqdEiQpWJHJjQHNdXtrZc3YquFHLCbn58Rs7V	1538	2179	2179	1616331420000	orphaned
2980	3NLJeUk2tBmBu8zWcxSnxZbeTWnowH4k8iUzFZazUhPCPyxNoR34	2976	3NLxwz22ZWEnrwenTFxaXu5MjwrJRf71aU4BUwSc1ezVd732en8d	1668	1124	20	1	2904	jwSmcy5bJzh4dnv4x8WEM1vWuzgBJ3sYDuTzZuGrMRg5D4jKomd	1549	2195	2195	1616334300000	canonical
3233	3NKJRwoH7ihxSCFy5Ri5YHZppzSs762gvGxA9qHUTCrcJBY6DE2q	2981	3NLZMneZfXNBtC4jPfn1norm8zsPykbjpYnkPugK1bLe46nXCsUL	1461	1271	20	1	3151	jxCBgyr3W7EbH3goKshGj5Epi1JdxprEXjaHvpTpknby2wJgi8q	1551	2391	2391	1616369580000	orphaned
2986	3NLAmLut4GE6uffRGGSNd1UphmMaHDppmq1SEXqRk2TpXDvcwaix	2982	3NKhJLS3rhvuRRFGbdNtJvCiJ3sisbgtnzsgbr68S1tddnvKSguc	1496	427	20	1	2910	jxZgnr8x2L5k39WK3QEwz9w8z8mSqvr8xUNG55EbxJ2hk5ZeGcn	1552	2198	2198	1616334840000	orphaned
3209	3NLcuWZk8VVgHdhRMxU4pWYjmZTphszX17Z8ovvQ8S7n5Nk8mehp	3084	3NLhkUtqQKGdvxKyS129RyByxZwQ8rQdVyqAhbgFAuNZ9qtVsPRZ	1651	1175	21	1	3130	jwX5a1KxWpGLCtCqsqcUeGBKGjWz1BT2ZcUG3T78usCZtwpqi4R	1554	2373	2373	1616366340000	orphaned
3027	3NKoELMESoqWzuVU6CBEAMUatVBV8eJubyMMZ6GNgQUh8djW1NUa	3024	3NKC81N2e316eixtXNRjpmdwCtuHxdUE9hRZyeyUvL84RH924Vth	1657	1098	21	1	2950	jxaXVL5B7zVJrB7Df4j3egPbC9WYcqnGSTn1nQbCLJncboxDSAJ	1572	2222	2222	1616339160000	orphaned
3045	3NK8oTAnof7rsAmRhEcC741DYxgcpKzm8Umhhq3afDxnbUYrbp23	3044	3NKKSbGHbZUsPsQEC6cGrVcMeEjcLaRuf9FZuH1RPSrWsWLi17TN	576	1355	21	1	2967	jxALPC4aQv6g4JHQ7NRiywuQrYaYLXP1H1C6erVcZXaFc1JDSiD	1582	2235	2235	1616341500000	canonical
3049	3NLvBghs4ty9sZyoT8b4bfLZFpakyd7ffvQmYzRvXsjxs98iJPus	3047	3NLQAoho3MarwDq32M6ZFMrXBUafKGBsg8Gtv3oSwHP6rJ4nFsk7	152	1330	21	1	2971	jxBYLhR4mzfd8QYVUc3ou2zXfNnh5aRSmfeYVvi7kyCz9ZpNpf9	1584	2238	2238	1616342040000	canonical
3065	3NL3WSTDRK8hP9X8REY3e3zJDa7ENbuavSvSqNnfPRBCWhf6iekE	3064	3NLCk4LPenVMHH67EgMiAaDFQLU5SKmgcm7WU98ViJgGeM5HEDUZ	1406	1393	21	1	2987	jxWhaDow2EMf7ZJi31qnvEKCoRsuT7wG5WVaZtpHSwcnw3Yyrsx	1592	2250	2250	1616344200000	canonical
3074	3NK5HbzBQxb4YuxRzGMFqCbhb1THY71AKEtnWLqbqt4grsR39k5R	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	1654	1094	22	1	2996	jxfCLJpsaYkTvtnrtYDNB4J5KYdzbB8sBA5Q3oFbfpTJmwi6hpA	1598	2257	2257	1616345460000	orphaned
3075	3NKkrbsMi6zGu2Je9o5MFbidn1UjWMt4WKW2PkjGPcLKPim6mp9v	3071	3NL3keRE9pipUr7Tr165g2Rdi2pFvS7YFAaVw3cazRSicsrfPViH	1553	776	22	1	2997	jwWd4FuxH7ZPE7GYhtLox6UgUJ5Txw7BdzwFMY3tLwdfCNg2X9N	1598	2257	2257	1616345460000	orphaned
3083	3NKFryKF5ZKhNViQxzEPYYtCMSJTRGo5fCjx1AupK7VkGusXhMfP	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1419	814	22	1	3005	jxkphKfJjs82M6JSHrh6gM6CZiVAt39uobgAkTy1DJAtdpQsKhP	1600	2259	2259	1616345820000	orphaned
3085	3NKpDBGE3CXtLJSApXC3twsKDcvjdg6LscAroj8gzvLBnE9GTT98	3077	3NKjcHPZuMVRXsY23hyWY1F3ZcLtob9QmAv2wrBrvAxkjSAAnXmy	1631	794	22	1	3007	jxunGLvkp5uusLeUboWBpJqZg2pgB327TkGcMUCVoPoNyzbWpxS	1600	2259	2259	1616345820000	orphaned
3376	3NK8oWwyEYQjeYZ4vNMT3UdFL5tJWoPKzNJzQiBE7ZBrHZrcne4q	3102	3NL21Vg6Qad5FLZyM99u3BxE4x8MJLVeypFGnZNQ1bdVmGWbBjW5	1506	1373	22	1	3293	jx1ajxzmBC5BZg6CxqNCtzPzyX5SfemmDBevaazkfWsk1bsHk1H	1611	2507	2507	1616390460000	orphaned
3395	3NKqdNAb7XTfXTd2BKdXK2d1nAsHEAy4vi4yLV3hGHHbR5ma1RHa	3376	3NK8oWwyEYQjeYZ4vNMT3UdFL5tJWoPKzNJzQiBE7ZBrHZrcne4q	1506	1127	23	1	3310	jxC9p1oome9P13yz8Za9NvWtmq4KeKHhPkQZrinBFTJUd6cdnV6	1612	2517	2517	1616392260000	orphaned
3493	3NL88Hje2DScLA9ZA2XV9GSePiYZPiyiBHWd7HxZDQvdg9Ryw9Gy	3395	3NKqdNAb7XTfXTd2BKdXK2d1nAsHEAy4vi4yLV3hGHHbR5ma1RHa	1506	1247	24	1	3404	jwQjZKbnPHTD3xqNh58MuXcocm5RC9s9MkJv7Y4GtuGXRiv6Tzj	1613	2580	2580	1616403600000	orphaned
3137	3NKgUaYc57yjaribcJx7s1rXyR4zr29YcNgqPQkSvbwoMKTRSV4c	3134	3NL3SqqP6ywtNyMxZix4UDz8oN5SdXHiWY743E64oY1KNQmjbTfZ	1601	1388	23	1	3059	jwgMTqL5vwRXfqSJgtSmDVt7k9B1PFwDiviNjqFp9h72kNULcH2	1631	2314	2314	1616355720000	orphaned
3151	3NLKeiGV8jFc77gFcWKzTp1JbP2zKGNQmejMDCJRHnKBDwcdKFjy	3147	3NL4RXnHT7JxZPkScuZMwYJ6hBU914BZCnva7xCqCgDff5JHemG3	1637	816	23	1	3073	jwVQCP2YSjFq8wQKNNvZrS1H3G8WLmkQHngFbXrf3jsMtiihkwV	1637	2330	2330	1616358600000	orphaned
3158	3NLZTPHcciK6Jg6UNTey4Rgq5zkJCxSeSH8mrTb5wwaqfUmVNcjV	3154	3NL6vsec1nDtC8deHG4bM6iq4znoSV3FsnD2CrHfYcUNaWNi51De	1474	1329	23	1	3080	jxFGN1MgZZYCmFgSA9dvCmJzkR8T2o6QWEm9rqGhcvkGYTYLoqt	1641	2333	2333	1616359140000	orphaned
3162	3NL5mhrEQkJAroe4QiJkpkmR82bbb9yAKqV8nkTjYXRG2jbsvj7s	3156	3NKwpW818DKRijymKL9NksDNkCxhY59uxN4koKaFxjKLkALkgWGu	1547	1132	23	1	3084	jwKkvNY3hcEPTGaVXU6M7VdY33tsyrrDy3ofHsXzLuJ8wtrjpcb	1642	2334	2334	1616359320000	orphaned
3166	3NLMcPccg5GtPrxuCuZstkvVGD8MVPt8FhsLQ6hDT5qg8AVofmzU	3165	3NKfMtpZ2sSRgYiinFFDuxdHgeu5vCKbMnKTGGzZjpGsnK78Vywk	1406	1393	23	1	3088	jwTj39Dy37bo8U6u9DGXRXQni6jECowMLzkGqLbpbQxvTUgHf3E	1646	2342	2342	1616360760000	canonical
3173	3NLa7e9bh62U5TsXog21sa9mgSkuwdW1PRHjSnrJrAwaAwMAJzEt	3168	3NKsnV4tVEqZz4pEhgdZXGW2eUGxw3hD64t72qgvv53EEktAeuQr	1553	776	23	1	3095	jxtEDX1Qf3sAVJ6CFbe9DM1XyWRpZ1gmPTtRigiFkAX7JKHFavY	1648	2344	2344	1616361120000	orphaned
3197	3NL5RguTubeDoNMUeHmj2TgHcb7W7ZQGdAQnLPtABSnWKvSzCu4n	3196	3NKanapudvCQ7gdu753SyquZUiWALX9GMxyY7KRNWLtUN7C5G2gy	1406	1393	23	1	3118	jwmZjPh2UsU7oSFVXD3cgma8WnV23zWoZhqjYKdLsMJXhXGT5WH	1660	2362	2362	1616364360000	orphaned
3494	3NKpMzrpxcSxMJaDPUT1KqLkYUba9yH3RVEnabDdSbDDWyazERoZ	3200	3NKMwNsUfZuU981A8AiSN8waK23jM1vg4UP9LGL85sM4Rj3rhab9	613	613	23	1	3405	jwfr4UsZNPiQyEKcJj41zmsXtmXarmirEjSdjzhBDuNJhc6cRjp	1662	2582	2582	1616403960000	orphaned
3223	3NL8SDTJE2A9gNefpLbHYHtkmXWvZdhahTpc11ppZmthYiWUBSz9	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1523	1195	24	1	3142	jwrazfaBkfRFTzCK3bSHhBRRraMLLrsFDgFUqq3aY7hGnfbEJsc	1674	2384	2384	1616368320000	orphaned
3222	3NLReJVTG7ibjmbQmsxKp31EYFQSw7mSDP2h5rShL4a83zbZpAGR	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	470	943	24	1	3143	jxducHzDFf6wVugyxB4VrSSdTC96XMRey3pH91orLJZWWrVFoMB	1674	2384	2384	1616368320000	orphaned
3225	3NLqQJ1YmJQiUPTP1poUFsFB3d94Crtvvbk4QqBCeMy3N31CHMiE	3218	3NKjca7eCxaWBk1Kj2dAg6fbVeRVY53DqvWoBP83MDdzi9JjY8PX	1523	1195	24	1	3142	jxQ1j4zL2vXFB2JMQ4tRSGM6DucBJELsr1P7dSACVippU53pRri	1674	2384	2384	1616368320000	orphaned
3456	3NKSjHU35J1oBzQh6KEaRogxf3ZSMM1v1isCcVNuQirmn2whkvCG	3247	3NLe27sY13b3f2TQAEUDihUH29HxQfKu2fN1dMGfCqhiBgbjPf91	1500	931	24	1	3367	jxD4DrQz4zgUiohPLpg1sf7dsP21JHNjUCgm3DeREdTrgPhb7wY	1676	2551	2551	1616398380000	orphaned
3264	3NKgPiJz3y2tZi1HazaiQM5JaXcuFMcMbJjCbHHbMA7nGss75ngJ	3262	3NK6b9N231dKqbaPU6Yb9gokEr4oPi6GNmZ6PeEb8idSfB3jVBHX	1448	1065	25	1	3181	jwH4pzYLfTJF8qy86YDEyPJn32UJ1HzPUj8Loo61ucmRgSpDhhS	1696	2418	2418	1616374440000	orphaned
3278	3NLQjxDq32QfejAz9ttWQhEXMQnYdqrJSN6RYFUUdjRb7SUxWJ78	3275	3NLHSVnEhR5p8bD3dY4yFAZF8bEvsatZJjBNmiBFkLcPr62nFeEu	1536	1313	25	1	3195	jwdKc6SsbynxM3SsjrNjQwRUzvZGKNivAT7fKXWrboXk4QDywGt	1702	2426	2426	1616375880000	orphaned
3627	3NKTkaaKHmaGS3WLEn3AvoJ3VjMVskCMnzfyQRZP1c1vRyKbtt2D	3293	3NLVFvJzbAZhiFqD5vJsrE5GvFhRwhYervRUsyGb6Ko2stDpWFQk	1614	315	25	1	3536	jxs858w5XbXaxRDooBKKhmGLcBA4yDGKXuL88KSKPS5gF6QiLnB	1710	2680	2680	1616421600000	orphaned
3570	3NLKECu63mRYywvccRPXUrHQSzW7vUaS9Qmhg7uJt8wnKYLCvKR5	3543	3NKWSAUeoqthPeZenfMTgsN7aYYFJ7eCjxRPyEd7WaCLSRZrKgVb	1513	1379	25	1	3481	jxUAbBFo5EhC9fCH6oXrLLk5Ue84eCNsCUhMhXup4WK6ebkw6o1	1711	2641	2641	1616414580000	orphaned
3759	3NK8ZWWfVSMAM6od3vDHPF2awjEg1nEN4b62FJbGUAfCKy9oCGCy	3640	3NLT7uFiGFQUkT453FVQfLarpPvaoTbAo5sPGF7NAXjHiUfN4o9Q	1513	1133	25	1	3659	jwAU1VeoBrCCSp6EANFe1EDwLHCSf93AszG3pzyKAvekJUn87CZ	1713	2774	2774	1616438520000	orphaned
3308	3NKUhNgUtLdDsEXFpjCjgwXrr2DHdSc6YgUQvo5Dw76GZmuo8CjP	3305	3NKD6VNF3rSDwEpMcqc69dewNSYgreK2KTMHxUy8rsKTknoD9Any	1647	1302	26	1	3225	jy1ELeHspPr1UKiWeqFJMRyyBokkASdt9gZezpMuBgtzSCtS3TQ	1717	2448	2448	1616379840000	orphaned
3311	3NKMse4uYGXDG2dWUs2YEKghRv85i3QSuL23XcZmi2ouLzmQoDUF	3306	3NLeikLtrfrTzesuSotjGCazreqUKx9dJRtTC9uK7sEe3kF3mx3V	1593	1220	26	1	3228	jwT4Nqnt8PizNtX3uYtPxDVLu7zJRtuotEg4XeaWqx23jn1KnWS	1718	2449	2449	1616380020000	orphaned
3325	3NLXMKAtzi99rZa4A6FPY5Qz9VgNphzyFkcqoT1VXyibMZve8rr1	3323	3NLM6KFh1LHt9JNfRRYRTHEYBnnEUzzNiPhTdwsL37xpzFbNhyjn	470	1183	26	1	3242	jxQRZ7r79z1xtQfiTiFpsud7SHZesyinoWE6X128mTMhMaCJaaw	1724	2457	2457	1616381460000	canonical
3402	3NLFMJ15mFUY5cUMms5UbqHDfhCcDLG87ksjh5QPRoY9ukMxrGVs	3348	3NLqso4UXxbhNC3sPEThDho45ZeMncTBgHm7i2j3W2HCvCUUbUR2	1426	1118	27	1	3317	jwki6bKxvQfePmZDxBWymwBHaUwazXuUDhebWJPMoSmNZDLDC1U	1741	2519	2519	1616392620000	orphaned
3381	3NLipXV2zsrQBEeRzXJTSdwuJXD7qmcZneiU8igeusM5RrZEcZPL	3379	3NKH7dsobFaYHXj4ZceYv5ivvPppzcS9fdToThhE8bwjnUvgLKxp	1451	1046	27	1	3298	jx45k3Q5CP2b4oub9ntTL88JWBaytdFf5z9uq3s3obb7gWWV2KV	1759	2510	2510	1616391000000	orphaned
3385	3NL2QTvbsj2ks1qWuJaG8ASdBD173Zn6PjMrq7D76RzeiWPcvPUJ	3380	3NLRZsgBeCBbFJ8DfCnvDdo3KmHxvdq33MF9dmEX6UkHYkpYgwyH	1483	504	27	1	3300	jw9XCQTzqD55vSGNozDG5ac5ryYwEkD3rS15X9NgYi3kRhaVQDG	1760	2511	2511	1616391180000	orphaned
3393	3NKFqJx3wooWkGc4aPZNafyFWjpF9aGpW4Ps94PQC4pofLR34uEB	3392	3NKwnnJDdf1Mhym9MrBxUPFLy28eViE6aER3931gTQZsvDrgmuRg	1407	1395	27	1	3308	jxJMTnhNp2iD9QF7ptDUD5DHt5M2dH633bttJg7PdyNsJgBbYHG	1766	2517	2517	1616392260000	orphaned
3401	3NKcBrwC5xGCD1sJp1FwtGK8LfWnUcfJWJEL5mLw2DWUgkBHAkLX	3396	3NLGfrKbTmbddVs2PyfqG1GzYVmeZ2Z9v1VX9NtaT3cbrkSU9Qjf	1426	1118	27	1	3316	jwtt4h7QNBFskQEjr6qmKq5KgvjaytiR2LGcZ5BkxQcqdqt2rdg	1768	2519	2519	1616392620000	orphaned
3412	3NKbEWvcFrL16aT5YFMKUJA541LMc8d3Fkn9iRiY5kuaFa9Ch5Ge	3406	3NKRcpGExbf3FgHoQoJBvBMzoqMCqiPfVnnArxBGdNhBXJ5623tQ	80	1273	27	1	3325	jw9z7pMAPXJixmg8K7tW3rSeL25rxeU7pHzNqSoS2JA5XPzhvh3	1773	2524	2524	1616393520000	canonical
3427	3NKFJFa7EGHXC3e5byi3kkbqxDBM3Lneq82wk1Yz7nEd2JsydgPg	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1401	231	28	1	3339	jxEMXJ6BXtRxm5yss7WBQzsse8R13ymiU9DEngnm6YaVQxVkMW1	1780	2533	2533	1616395140000	canonical
3428	3NLqZj39DU29V6u1oxk9Di8TAk3b8LjfudfbKD2aLpEs7mNHF4aW	3423	3NK4A1YGK8pYLoyq2Vki5k51XgvhJ4PKB7PqsHk4q5JHwJu6g7et	1624	1088	28	1	3338	jxXEd7W8hNUkbGExz3Kj4W4exnSdPzTAPPjs2g6gxmYhY9j8JEf	1780	2533	2533	1616395140000	orphaned
3448	3NKXVYCW3xJTe8TYwv9FruyRFkAfUfXYAsfhkFxZL9FEGgEtWW4g	3444	3NKZ8vosziTDCb7Db3xTmWEFRNvSBc7cNcpDuyPPp3sgWZkJNWr1	311	1061	28	1	3359	jxX5VtBFp7vJ6qkYVFPKJ48d1BrXTiafgygXAbpBTVC1uDvEKRL	1789	2545	2545	1616397300000	orphaned
3826	3NLBYstHVBsCg7arm5NvuKvPHLx8mYtEyYeauUsL45Cmp9tARyCw	3452	3NKuoYucf3hVJSNQkmRmyjS8iskNtwdMy1hZabAwFNsQbExP7cFV	662	662	28	1	3722	jwmFHBVSWAkUJS2ufvFXpLK3JcStwMcsHPMSEmSNW1vZ7EAWHTs	1793	2822	2822	1616447160000	orphaned
3628	3NLiymmwinNHwPCnEDu2o3P55V6SL22TjCP7Tx87qAG5YJJ8hRR9	3526	3NL2dvvrsoBGikrsLNM5XbAkGCZRDjDk6aEUCkwZzjKNbPbM7tDx	1634	965	28	1	3537	jxXt3g9zP39uUA282hjyN6MxajSob5AW3fbpmfrwmT9eR6VtqYM	1794	2680	2680	1616421600000	orphaned
3475	3NKdAHVDVDBJVUbuuwBxqDeQovKcdKMHGNqg7oRVMHs8Djtvqmzm	3473	3NKfURyWbpq27wQ2Z32RLjTYSExjG45QUsWdGNKP1DHg5PAp7oNh	1652	1315	28	1	3386	jxBFDeVzBwj3DfkKSJU9JNAnt5vqXgHoF2adjAq5q6bkxoVKDXh	1804	2566	2566	1616401080000	canonical
3490	3NKHc8HNe4C9tc5vXTNfFupx4V1gy9536xxMdw37dpedPuTLY6Pg	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1407	1395	28	1	3401	jwtUevYU3FcgrrFYYrgiKjWch6CsLRFhCdjfnvZLj85PsNXkzwj	1813	2580	2580	1616403600000	canonical
3774	3NLgtJ4w8YX2oh96GCuK16H8W8gVcgr8T7m2i58yaZ8646KyZJpj	3488	3NL8Bzb9JACD4M3Ek47tjvZMbT3z2y2VSSpJcLYqsHYfFQLy7d1z	1602	1369	28	1	3674	jxiCKZHLiTobXvtmxvytPSQZNhgDGv2QDYyq8PMYzgS8kbqaPkD	1813	2785	2785	1616440539740	orphaned
3502	3NKwYZ2kS8L5m69yvdb8w4E2y4ua3DTGejgy53azNr1EF4TQ2HJQ	3500	3NL3LEUB2Wph4x2n9n4SefU1PgmkChknESgeHfBEWzHek6X4hnU1	448	1305	28	1	3413	jwURY3Zm55pTa6kCXGpNGzqm4rUWMFYSh1pWo1euZcPgxFXpRxp	1818	2589	2589	1616405220000	orphaned
3515	3NKrRXcTy3xjBhV5LzL2yCDVuAsHcKDSe2e7Ru4vkzwzpiPXUMLG	3512	3NKqY7cqyb119Dy61FpL4v9kzq5AqpejDU2d4k8QiGw2wGXEqw4c	1647	846	28	1	3426	jxctjkzMw95DF8ZLHFBhUSxx9tdEjafz9hQeZet7HcLtreNN46E	1824	2595	2595	1616406300000	orphaned
3525	3NKZpLjA8f1vXUhTzepKqLADafYeC6sJKtwznyyCwRMxWWnoqX29	3521	3NKV2an7FQUZqZmW9M9okeTjgqJ1Bx3WohjnoN7VqhQWE7LGCTpj	596	1306	28	1	3436	jwyf5sAAGmHNBzsviiC78LGEnpkw9X9SubkXm4Ehe9ak5cYXFv7	1830	2606	2606	1616408280000	orphaned
3528	3NLinLbHz9R7wbRTJckvZdXhpX2j5TiuKr6gdMP2BuwihSx1csXY	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1405	865	28	1	3439	jxH13N1JuiTuLCZft36xkQH9XSNqLgHpyuVtRzK2W1oh1A2ZuvQ	1832	2609	2609	1616408820000	orphaned
3530	3NLfrAGd1wU7SoXqY9qTSDnP6URvUbS8jxB4jQMfW5nXgY72qUzu	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1490	908	28	1	3441	jwNYrhrbhRFjWmLe2sthhf32vsJPzSwNi26AxvYm2sNzg7qiVbS	1832	2609	2609	1616408820000	orphaned
3531	3NL5HinAjZ4SsvixnsvxQUTxxVySetxYTH8vzirhqPWZdeCPyZim	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1439	1033	28	1	3442	jxa8kAs4bp4cgj67jYnV3D2P1pZqQAJimNwiA76D42kRpauDULC	1832	2609	2609	1616408820000	orphaned
3776	3NKmS5c1ukGJpPxvHvFQktMy2EWgUpCegR8qrS2ZsJAuqHcVW5Ax	3527	3NLHrKGyuX8sKPdvMfVvZNGJmcC84ozUp1k5HP1zmLPCqDTdyoNE	1602	1369	28	1	3676	jwWktZsHeWxDv55Snk9CutWYor2joDjp6kPHkSykUpNBQY7DWN4	1832	2785	2785	1616440580632	orphaned
3542	3NL52oB1n5JTTGgjziNHyvfHBm24ceazWNE667kMj8YbtSLjicQu	3539	3NLc1XJ1jQzQ52o7AcrGZyEXEnfWK4TuhTb93TDwZwaUJNtfhvjL	1403	824	28	1	3453	jxzHBJkW27SC3DM5f5HiCsTmkypQR4Au65dFgZcLjVZ76f8QVho	1838	2618	2618	1616410440000	orphaned
3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	3541	3NLXZqLecJU4Jvz8LjhNzGWQj2XcXexHThMGFqe36THniW4Cf9fx	1607	1102	28	1	3455	jxAsz9X6PN5Q8FnneqEDXgDazxtrrddMAF2LiMftEAC3aBBsbGU	1839	2620	2620	1616410800000	canonical
3547	3NLpv3MwgYUwALEqVcDz7g5eZmRwbaTKz5GMH3tgyA61v1yA6uzK	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1623	839	28	1	3458	jxWfScFdMWUXDpwqfGAxmdVUY1XBu5wvkBDQuJUwQCH6vWUJK9y	1840	2621	2621	1616410980000	canonical
3888	3NKs7MrgZmRxR573Lm6qoaqJYcrwEZQWM6JmzpRR8L3JpT3nVPq6	3544	3NLUMVtsnzXpcE5HnpCVKn6qtPy2Q9vX8KSqf3tQrKBJ8GGiXVTR	1610	1188	28	1	3782	jxjnfKhaPQS2QUJjGmT5wVeQcFPmuVDdBN48JGTfDSHM4U4sptz	1840	2873	2873	1616456340000	orphaned
3890	3NKKNgGmAXQk1frzEiSqdxvTF1Hmf7X93DyjmuDbiZnzbLWQL6La	3571	3NKCFeGSs1veson87HPhApftTzcSuhw6ca1nN72gie2vHe1yJSmU	1610	1188	28	1	3784	jxeasJMQEnutVSV3RNLDTdQGfDkMQ27kceCK6V9AvirZ525zzp1	1854	2873	2873	1616456379972	orphaned
3910	3NLYEffQP2jzujmQaNnbdkN6z8jtpCw3iUALSTUKUU4yqZfdCBzs	3586	3NKfy9BpbxPBcSZ8zkk3GJGVjpnaL3Lz7DpZFy4wKWqSAFZcfKwN	1536	1313	29	1	3804	jxDzt94CzizfJ1FPqKHAxryptjXyYqDTxpJdHoCPeLZPbGziMZt	1864	2888	2888	1616459040000	orphaned
3589	3NL6UmnPkW8iJHMYKZwLWqQ6pS7zLcZNndFuFjvAWrVjTGBtux1V	3588	3NLvGT9uVDE8ioXvJYU5UQdiBLC95xPsCZBo9Ry3BnKojACMSxvJ	1403	792	29	1	3500	jwVJm57JgDKuNo8JJuaYwSzCgJvHrUKdEcjoPWYnj5YSiTJMG2S	1865	2660	2660	1616418000000	orphaned
3600	3NK8avasVMqvNQ5mnUqTxhtkBXbJyZxQLvLU1NyQzredHpxxx4Bj	3596	3NKpXMjWjAQdoB93SZTbsc9gyTM9gfXubnqBFWSeEUy3WWEBii9q	1406	1393	29	1	3511	jxs9cvN7uhRYw359Xuzvc1LeTyh5CX3BLiXLbFcp9zfGif5TbxM	1869	2665	2665	1616418900000	orphaned
3603	3NKaAcEj5d5NEnKFqrjMnKrCHgEH8NU1tdfhokdjp3NXN8M7eojk	3599	3NL7ZryAvqBi883a6QjH7YRCcnAYnGcZu7Y1rYzgDPq8pW6NF6sg	1624	1334	29	1	3514	jxWjuK9J2zL992APcDqdc7ovTUbA6ewxG1JNE8iSWTXp8prgm7G	1870	2668	2668	1616419440000	orphaned
3620	3NKczWtNQBj7J4GBzeGq8cK2ghVVwwa6Kh1WqAEipHxfZWpCDxeh	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1523	1321	29	1	3529	jxpedyVHy78ypHMaQmi1s6taASyCAEo3Q428Zxi6oRWohBLxdQ2	1878	2677	2677	1616421060000	orphaned
3621	3NKuLpZCLKRZTY9LqGJL7QiqyX2zQdEER1GPTPuqXM1K3TN7MqwK	3617	3NK69DLDmEXtLCJWgtQgASZNABnT79A4uvRynkcZomQamMomBtbd	1523	1321	29	1	3529	jwcP8wH2ueLTqRXdTFCD6Lin86RNWyTHsbNPMVwkfkqx5AgbJy9	1878	2677	2677	1616421060000	orphaned
3660	3NLQRaDSqB5MsFmFXmffXoPyQvaYj4PuMQTeFU1LvYZTy4QXFs3C	3634	3NK7codetekh5upAzzXdYzgwpEE45FnJkpeFFnkgH3n5LPuWHEPs	1500	1171	29	1	3568	jwTwSq1BzUriz3g9GuDnoY1kcuQjppYzAc2pn4VSnAjkvRDsJMm	1885	2713	2713	1616427540000	orphaned
3651	3NL91osmEeN2DHPYZrFANjcC8YPuFfTbZC2MQ2k4GFKaHX6wZgZE	3647	3NLqqHeoTe2UgUcB5CbrFod4ugnsQqYtqUdu8gmkJVXrmPhQWipU	606	1049	29	1	3560	jwqCqs8ePoXuYPY21miMNq4ugnKsiVKT3LAMae25nsihTT7mMHh	1894	2703	2703	1616425740000	orphaned
3663	3NLi1j8fwZsn51VUvZiyQ5TZjrLxVvDSDCeW5vrxHN4iqgY451iB	3659	3NL9MbvVZafGQCzKdYgksJQMhkicfeuUYXhJcKKbx9QJQp5PApRm	1590	1300	29	1	3570	jwnSgx6oUmgNNQj8eju6uH2HQku9my9TcmtCFusQQDHUNGRLbET	1901	2713	2713	1616427540000	orphaned
3666	3NKj187Zo38pM4q8Vu2RCDYHPke74aLsg87q9ksLVgNHUfQN4h3C	3664	3NL8XF6sjEj8khQXUVzXwv7qxzkRCDoeukvGTssWR4QUijUJh4Lk	1406	1393	29	1	3573	jxKp3eBnUTiNy6d7myNps8mRUi3UZkRQrWxCrwrysC3zHuraLMw	1903	2715	2715	1616427900000	canonical
3692	3NLmCmCFguBW11x1KNtQdbB6aHjWTAMyivzYdKuwkjaHfErPMv48	3687	3NL7KFMRuRhKSKgqdqHezMmyEMxxAQ675tVZLtR5oD6JjLHGNWHj	1577	1327	29	1	3597	jx3nZtMHNeD5GTR2RczNt2m5d1ctuwNrT3ijjpdEfL3UXLSKBPC	1916	2731	2731	1616430780000	orphaned
3701	3NKMGvw2uaoHpDVT9N9ixSHQgf8NJ3FNNp9Gkb3JfVgoVsMy23YK	3700	3NKveWi13jYVnoFhRKsqFVZK5goKgGDqHtGokx4YwqjMunAj4bJn	1407	1395	29	1	3605	jxvW9xjiJsQesQJWr9355GLT8vv4FmtPbvu8VgYBxqrfXrffZLy	1922	2738	2738	1616432040000	orphaned
3719	3NKvRAyMSb9nfDXWZ1kpu6Pp2MFfBBjUQ4EPwHAj57yjAh37qYnW	3715	3NL9Wnekj6sn9WyEykguhFv67rnN43Z9y6qnN6zTY1w58S4sW2Nc	1581	778	30	1	3620	jwA7vaNPRxGEkSg2NLY8zD1uSxc1f9ceiL29V6aXvxcRpMm9NUP	1930	2750	2750	1616434200000	orphaned
3724	3NLVeeC1KCXaxdaGASoGqAurp5pAf8Cv3P1FaDwb6zLCvtpBa2qk	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	152	1330	30	1	3625	jwKxfsZiKgrcUkhPco8sBcBS988vma1i1UNfA2WoqaCdEHcCeBg	1933	2753	2753	1616434740000	canonical
3726	3NK35ydNasAevZXLemiE5FYwst7goJbavzwMKyrFC9cSLW32hiPU	3723	3NKzbLc6sns27xCSccXJ4zsf1qAFFgVb9DWELTmBmLKtDCue2qsQ	1508	1387	30	1	3627	jxW38JnEpWpPPkpWmasxao34b26j7NtUCfRxr9JM6pkDoZjRRni	1933	2753	2753	1616434740000	orphaned
4298	3NLR8iqahxsaJ3LqszB6R97xXXiq6PQPhVxQzMyQjQfb1UrjcRd4	3739	3NLE43YsTAL7r9HEDASL6gx2t35Xtjj1p1A6hdw5JhzoyDdkWCc6	1634	1331	30	1	4181	jxxT6aYiakdJ6n2H8hQAzukjya38BazBkHogrNgGvQtBc2foyHA	1940	3166	3166	1616509080000	orphaned
3749	3NK76pK3AkYRvuQMuoJgcv48sLLTJDYLkaotJ8v6GuW21jhj7xj3	3748	3NL2T1Bk1YbBwanCXatoGFCnAuZUPLVmNoAiGfpMKyKFAg2nn2M4	1403	824	30	1	3649	jwV4rbnzNcfSA87Tk3eXSCXkQEqQvxXHec69UyVpPJU3RYdUKcz	1944	2767	2767	1616437260000	canonical
4300	3NL3Kg2DyQUwQ8TKmVqhf7wUJy81FPPTHC9bUAAZADQ7EpesjJWs	3755	3NLunyXGBGRJR7854BCjBqxhQHj5V1RU9oMQ1V2JZbNfrtss6tSC	1634	1331	30	1	4183	jwfZckeNTeqwdTD49LV1nixM6nKy3ufU9p8mbejwFngXEXm1Xjr	1948	3166	3166	1616509114222	orphaned
3767	3NLDVGH28pFe9xwjHrx1coFeXdRFk6SWd7vqwDJ6HW43FoyTiHBv	3764	3NKqueq9eCAmQt2Bbvw77g8kg9c93faM9G7x7tBWEm56Aa7vj4Hj	1483	877	30	1	3667	jwv4D7PoCr29D34zLuK1HXMozdsmJTAERQDG6RH1sEnnUaBMEMb	1954	2781	2781	1616439780000	orphaned
3782	3NLQxuZBBMZ1P6RWGF8LQ3twbHMCw3Ue1WL4uXRQjFCgMN42Crtt	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1460	629	30	1	3681	jxm8BDwRvegHaPhMESJRiKnD2HQke9J5AtRSRYpN8wTsv3YbPir	1960	2789	2789	1616441220000	orphaned
3785	3NLZkrRZya12bxvJ5ATDHVj6xLmwKQmWDDqfA7DrJYSYRPns7Q9E	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1460	629	30	1	3681	jxm8BDwRvegHaPhMESJRiKnD2HQke9J5AtRSRYpN8wTsv3YbPir	1960	2789	2789	1616441220000	orphaned
3786	3NK3G9WHwUV9Lk8xeNhPh5fAK1CB2EaxebTiEHTQrPPrQJx7sGwm	3780	3NKJhsCtSP9sTa31ZtrcVpGhE3QorPuqifZVTGRVHuKDb3HPW6mH	1623	839	30	1	3683	jxM76gW5LNkkN7sV6o2hSsfHHtP1B9QS4mFSEAAjwUL8qJTvGtV	1960	2789	2789	1616441220000	orphaned
4301	3NKwC2PFEWN4zNyyFNMVbEbrjDYKxzJsLoebBq32WQuoYSTd2kpW	3794	3NK3oQRG4Yx8CaXsEzQVT3CLfKD8CsMfAEWAUuTkzuBjzoutARBg	1634	1331	31	1	4184	jwPeed73Udrt5m9EjaMs4ioLMxfUGMkLg4c9UiFu5GwwRmfzErg	1966	3166	3166	1616509148520	orphaned
3802	3NLw4BUQLKmtMcNVMVjb7bTWDRvPPoJfwKkXEzi97QR5hQ8Jowum	3799	3NLGqwdi55q6TX3ni5c3gTiq7oZHbkdabvK949YnXBDTtijXALm5	1631	794	31	1	3699	jwsf5BNygS1RV8EbfxJVMCYGyxmjFaNG3cwfELBMQAzSHosCndJ	1970	2804	2804	1616443920000	orphaned
3818	3NLDuTR7oHfP4W8WEqrvVAQM3fn9XVuKPdySfHn5xbVkFgQMAnjf	3814	3NKJYY9WcctpKmbhxMWvEZnovxoZTCedDbGdCGBfgEDrYnxgVdkV	1549	1362	31	1	3714	jxFDvZn9GC1Vxxensra4hLTqVqsmFKcoVquonUtX7GGDZmjYHUe	1978	2815	2815	1616445900000	orphaned
4302	3NKLtK9nqVHwMeAUQ8YxYhwPn5DSxDsEKk5nwTeFRX7x2MnCiQf5	3824	3NLjKRM8n23K2rcmpsKMyhix4cN2zWzuxatbHEaawQ7QjVWBQvyP	1634	1331	31	1	4185	jx9UkuoKyZ5tx1hDw9nPtsNb6rqk7o2pqoxPo3h4y4PySQVHskk	1984	3166	3166	1616509182326	orphaned
3966	3NKPuV2A7WssutjR5MM5UC2tEm3TzSQ2RkrpVADhrkv3Pyet4T9R	3829	3NLSPt4wVnDKGKB4TYzh8wGYFzYAMfA5aCxBauw1E7saRQqmCB1W	641	1090	31	1	3859	jwMJ9f61isFnY1ZPsaYdjD2NyKDvzSU78ntCJTsaLDu6wZ1diLY	1988	2926	2926	1616465880000	orphaned
3845	3NKMkBnH7yu8nNZXTBkfW9BP1gKdVTY3LB9STjRqCQqyaSLfEWwU	3841	3NLnfgMq3VpqF46J2tD5LoyCCjhUDb7HkVqJSemtSvSiXNamozmc	152	1330	32	1	3740	jw9czh2jWGs6w8TUpSXBQANEQYyQmGBkhQpVi5ifAaz94rmmj5o	1997	2841	2841	1616450580000	orphaned
4347	3NK8q2Z42ccxzmS6BphuwxaMUbrS88t6XEW53fqKzTXCmFBZoYCa	4306	3NKAwu5nYQAFBwMBSbZkHW23Mj1xAUSnqGv9RHU575DbBHe1qe2F	171	1374	32	1	4228	jxTue3CB1qnadA7S1BJtVdDFp5ab3u5d7sfsuifb52h336ifAvM	1997	3196	3196	1616514480000	orphaned
3848	3NLao2bekMvkFbXW7jBzCiiK2eD9PjdcbkWpBpFFQUpzcsyzjUrs	3846	3NLDsfTFahAfqkpZYkToh1E7BSesb2vZBjKTKb5FVSkTq7nYNk1D	1508	1387	32	1	3742	jy37VorNY4Mx6nib45RTuVCYErTfETXr8Kx6HqqjkohqmcEgju7	1998	2842	2842	1616450760000	orphaned
3879	3NLGzhtGxHrm8HBq427NLoAeZZsBHp39KdkfNvqCRPyxXxNgFHt7	3875	3NLD2ioy1dgbGU6qfHkU9NPVnoprfuH5zhiwzka5EtG7yf7TYeHW	1402	874	32	1	3773	jxANAnKdwPjBbyTDYoBFFmeRqGkzcvZwApFgLJjwbBvMa4AXMt1	2014	2865	2865	1616454900000	orphaned
3884	3NLMbg4ABm1tGgFdxiXMrJHDpVTHQwuVHbEt59CbF5PMfREHf8Co	3882	3NLHR9qqpx6RcYgdBMPa82Vgck64DP5pmNZ58h28GcBgBADbZNQp	1406	1393	32	1	3778	jwPbpgGAUN28R5Xmi2j3JPA8NTcHFGPwsRcoTCQaHPYkTt8jeQH	2018	2870	2870	1616455800000	orphaned
3923	3NLCCe8XijMYDA5uWofLFcZH3zSsRZ93q9k2ebA7GZ6t7p4Ymj8c	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1657	1098	33	1	3817	jwLSMBtK2NbwaNiiycEzyEkKiHFpdsM1QtfF7NqDKKk2VbmCB6e	2036	2894	2894	1616460120000	orphaned
3926	3NLXgAnWJ42mcoJua8CMqavwhvj4TwS6xswz9auHatGjXUuqddvv	3922	3NKdHRE8FTWYNL3XHqFmDcK4uSmyNXwHhTiwSFXCbCEKKoJuYGAo	1547	1252	33	1	3820	jwbHutcQ9gwiU3PYwpufb96e3UsMzKSRtq8i3sV64fn3bYSLuoc	2036	2894	2894	1616460120000	orphaned
3930	3NLy5xXzE25CzU8K7LNUHwfkTPUAB51bditADK6vAArmR5bXkLFs	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	1447	1099	33	1	3824	jxpRNnsuJiJDRVF6CXmJbtL3SzkPy14VCwWoGygZdb1NkYfZVrc	2039	2899	2899	1616461020000	orphaned
4117	3NL7oayULFbQ4HDSwYcmQxfAtGaqF4BDtUodrscLQYkERnWXpSo8	3929	3NLMeHEjVERBqS9UGfKpoaszesF3ceqcP3cKX7Y1dDQkQzQf3dyG	1507	1280	33	1	4007	jwqPRYjvHg7NLR64RFtEfm8su7vdJjmLrg6GKEuBoSxnd2RYKNV	2039	3032	3032	1616484960000	orphaned
4180	3NKducHU4goKH3X6nNhBC1R9ucrt68QqvdC78wrnukFi8ksSuU8W	4117	3NL7oayULFbQ4HDSwYcmQxfAtGaqF4BDtUodrscLQYkERnWXpSo8	1507	1280	34	1	4068	jwxgzcwFMoxfSVdcFcDZpTqrb53nomnmmUnVsteWPrBLQrR8vFg	2040	3081	3081	1616493780000	orphaned
3944	3NLKfCoYMzXWpmKgUCrx6SKXxM5qgKqdPDA49gHanAhDGUfaEuVo	3942	3NKUjhibf8oQt24ctFFyBufeES7E2xYJSfdN5RCgaornMnFBfeow	1590	1300	33	1	3838	jxVGqWudDrcPE8E4bcEtNdLkLiBVLmNuy8KaJjK6gN1TpPiYqcd	2047	2910	2910	1616463000000	orphaned
3952	3NKz8WHC6vFjeYq7FYnxHFHSyQfFu1EwzCDhie7G1geMGuvpt6wH	3950	3NL1NhJWKR1KRgkV3ibXo16L9qv3tjyJicHuJdSdp1YLXcdWyFuF	1651	1055	33	1	3845	jy2JLhpp9PCGMHm8xapoxKRGXvzsHuPL3Jf1AQJ7UzQfgBdNQsL	2054	2920	2920	1616464800000	canonical
4226	3NKwuJR8F9pnyaZoE7tpUABbJ4Mv7ZeEtixtpKHnA2jMZkqBJifP	4184	3NKMGwPQ11xr8FMXJt13EGF5h9wrkg6Umqdsy6GxdoAHrwd5MrQS	1581	777	33	1	4112	jy3HEMTDKXqnJhGm8g8KaNhYGMvhABJvKFu1xkzu9ZukdS4sqt5	2059	3113	3113	1616499540000	orphaned
3964	3NKARf5Ee7HY545CW57LGeW23wxqTkUHeJi1tciiKKG9P9nwqZnC	3959	3NK6rmm1X1J6VbRttDs8aVhtZwkWQmSC9mGoqDSRj1q7S13MjhFY	641	1090	33	1	3857	jxAmqBzbJBxu4wVtGo8DB1umGerGygRyNG5cJX5L49U9ttFRN6B	2060	2926	2926	1616465880000	orphaned
4238	3NL8Eckegg94T1FgHuhHYjzipVdMp6vsoxwaBNw1kMaNw5w9DjgH	4226	3NKwuJR8F9pnyaZoE7tpUABbJ4Mv7ZeEtixtpKHnA2jMZkqBJifP	1581	778	33	1	4124	jwmrhYGrg8nyvHsuAZdR2dcdgfnUQge3QheXxRiAdgk7iVVXMqM	2060	3127	3127	1616502060000	orphaned
3973	3NL2774ed3Xs8AU865JEngR6ppXmmiytNvxB4i1GzauN6uUpMNyq	3971	3NLkeN255oLaoT35ezr61v2giqMKuf44mf6bGcjz4utpq1b8Hhoo	1407	1395	33	1	3866	jxFdSUxdEqHj5RBs1hEXT2nKRW7535XbDQhWUZp3PtBRF3865nc	2064	2932	2932	1616466960000	orphaned
3981	3NLjnk64G7h6Vqx539fdWF69nZ3qr192Vsg2RLeyD6edbdkWxFqt	3979	3NKT841RQobVLiJcouPTLZCMSEUFb6DNTMET2qxrgskULtGyRSe3	1403	824	33	1	3874	jxpFT1YWumtKvWwCATVPGJAHHoPiczyMoJZkPnGsAJMFrSzsDLX	2068	2937	2937	1616467860000	orphaned
3992	3NLnifEKxjcsDYyXEZNHq2zps6no7rhSjgQj8fmpE7ZA2cq4v9c6	3988	3NLV88Y8oZ2KeXwHVB3i12R34MsEme1NSKEaGDaoEVng4z74qJT6	1402	880	34	1	3884	jwe25m1y5SevCRkKhFw8uyjxCmGPjXF1tdX4FhZ6p26nXHf55YP	2072	2942	2942	1616468760000	orphaned
4000	3NLaAHT5sZZPUBLEAcfsNw3tmroNrz1P9Ty2eVmeSgzJNDVKg7hg	3998	3NKd6tgJB2hPBrXcSUmicMuD1tnLsqMEcQVZ5hGyUuJEzVK26gty	1596	1117	34	1	3891	jy14r6rvtCXhKwFpi5yA2hwVwLWKWHfsCDbBZ5yF2MvTbDjkrdQ	2076	2947	2947	1616469660000	orphaned
4014	3NKEXHq4anmZr5DKJXmYiXE3PYMFG91rxdUXEdd3jYmDqHTxucDj	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1647	936	34	1	3905	jwyQJh2Axsfjk1JqtiNqmHHmE3dUqLatkxdiii3vqoyUjNKUM7d	2082	2955	2955	1616471100000	orphaned
4011	3NK9zcgMqg7RapEf1NbPgBCVhC1aJfEG1Y8jvzwgddX5ZfdnpLSo	4009	3NKnS5dFHsQQA7MsuwE3dUD9AbVC6hYywVWhhAADGfKM3yiBQwXx	1458	1323	34	1	3902	jxdhTi8XWBJFBbBm1gf2jbvKXvaKHEU7FApshf8gnUE7cUpqUP1	2082	2955	2955	1616471100000	orphaned
4030	3NLe2rZPLumNqQuJMLhTsmUZaComQTm7WWqypLMfBomYTybvt7fR	4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	1406	1393	34	1	3920	jx2KKvA8KeTtSvwSycREVkgActtFnmuiDa5yrucc6cThd3s8sR8	2093	2968	2968	1616473440000	orphaned
4032	3NLMNcVT69ua4WBe9UQ4nP6VPQEmhLZj4eAoMrosvD37PyV95VWK	4029	3NLW4AbeJLzUQSPDpxcrAPQVsXi73iFGUJmZzRQPxtpTfusxy9FT	1598	543	34	1	3922	jwW4vcSC9xZUCTt5qeJxnjTzFJEzm669dTbqVPtgzSoKnqQ3VRL	2093	2968	2968	1616473440000	orphaned
4065	3NL23PF7rHEK5u5G6QTT69ZBWURWwenrbBEBjJJT4kRuDPkj8oKn	4063	3NLKCeCYoFa9f96RyJQG3h8gALTVPtdWMNhWP55VfRBgUqPmVL81	1419	814	35	1	3955	jxbPX5dH2xeypReP9pUtTRfourNNR2PmaVAg9qL84s3i8K2HzCL	2112	2997	2997	1616478660000	orphaned
4551	3NKPKMNZbKFEugMTuCZUhutimAVeLT9uHmYcRHmXfEJb7emGsyNm	4067	3NK7nnQtLzKfCxMpxHnE2vmtQ3275pA6biimFQLxSf3vxirYB6GY	149	1283	35	1	4423	jy3DvAk5UukV4p6h5tY85wvY3SDn5jQKAEkf1Rpfi7aayumFtHG	2115	3330	3330	1616538600000	orphaned
4073	3NLH3FTKaqcRG6rkk7LazpWkZnQcLpjyHQXrgzgYi5uqw4kNhqqh	4071	3NLtukrJ2N32svkw46AmT9zWJqqEQdM5VBv8TTEdhnaZKzA1XMEU	633	1384	35	1	3963	jwJDZnVBHpfF6Ui4WuJTHbWeYpjuQwBvswdoRrT1aNp7HLvHaUi	2117	3003	3003	1616479740000	orphaned
4079	3NK6an6uDY44UFCWVFTzYEUwmafcsDVLFzbtDGumE2597NrmAiRv	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	1451	926	35	1	3969	jw7vsVP1c1xyjKXkZQVMwjL8kXNUC6QiCr9HK9jvoPmtiM8tY3d	2120	3007	3007	1616480460000	orphaned
4080	3NLmkXzHxsJvaFtqyqJdWBp3XMrEQY13hc3bxVVX8v2hsmmcTr6L	4077	3NKvywtmciEkiShAV1fBaQg567iAfjLDGyTwhhHLfVkqoSPEwYdk	1648	1284	35	1	3970	jxDoPeAkUquT6PD5iFjWQtzrZy2Lwd1Mf2CFcHKuCtQNKtrg7sP	2120	3007	3007	1616480460000	orphaned
4552	3NLEqMMaMrhJFUoKzEUVa6VNcsgnfcfqutieauEqzM8FRFSDtBLA	4098	3NKH8CAGga3JnNubmo3gjs487qGZMK7HLDB73ScnsKtiDUpPThzi	149	1283	35	1	4424	jx6yzCXJ2DS3VJiNNPdmmitBMGPs5Z7RjLjuUanYSevW3uNwG9g	2132	3330	3330	1616538651326	orphaned
4106	3NK7NB9JTfNsNnh3x5sGTzJnwJzNuRdUtfo4Pq4RPocX3C6obKnr	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1555	1101	35	1	3996	jxTqoqBcY5JuMtybjLg1WVmkpBuEnoAHm7S9aGn8tpKf4zTu8CB	2133	3025	3025	1616483700000	orphaned
4102	3NKjBmTkumK5cxfEZfJBifripJysYJ6Sg3VZRrhG1UPgg22ycPUJ	4100	3NLS9YXokCWGZ5nQio2Fo4kccdbr4AWYHhxRBHjFr1ighs1rnURB	1406	1393	35	1	3992	jwQdtsnKdsDcZjJaASDKt5QodhejVRprmVFMgEJ34vNdXaEGwap	2133	3025	3025	1616483700000	orphaned
4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	4121	3NL5Smi24YgyUjb4Gwc8FDeyoZMc796tK2aoo97NeDvbuEzcspXn	1406	1393	35	1	4012	jwsUb3UpSCPKUCZgD513CN3f9KorQXVvM9NusuN9WMcrSKucbMM	2143	3038	3038	1616486040000	canonical
4124	3NKEkTUEJjAbdrYGf3HFRduUDudmfiGDcSCeRXSZ2FBAJpZ5yZmr	4122	3NKzi56XpiQmLZSJwmqaMj23SwPPGPxY2S18J11Y1xwnRNXwg4dM	532	1177	35	1	4014	jx7RMxzjNUXZVfHuLoQEgk5reejqBLfo8zkN7Nyd9i2Jji887fu	2144	3039	3039	1616486220000	orphaned
4152	3NKNU5kTU7N5Wf8VcFGQhGgXxmYxAFuUbaDn2rNAJe53tyidkrrF	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	367	367	36	1	4042	jxPZWSjizrfPRBDrRmSKrr4AZuN6eQMFKZGML6Cgwfnwux3aSCL	2160	3061	3061	1616490180000	orphaned
4154	3NKczwaho5D79WDngFE6BHB2eFFwgFae9365PpCTDQdNmeCQ1L7X	4148	3NK8Ex7wpRVDZZyYnmDM1ABYCJP5uTPe6eJ31rW6FEYd9xrwMQYF	367	367	36	1	4042	jxWwwr7TqoovQ3MHEAjHEUh3Hq44wFMPDe5DwrJFaJdtxu1VKCb	2160	3061	3061	1616490180000	orphaned
4158	3NKNxSLQrCayMHnXLdAcaTxjdpxMScA2fK4Z1pCoybCXRn7cMyX7	4156	3NLr7iAQ9BxXhehHHdNq4iKPnmmTk8qRSPTQdd7fb9mJnnyAt67D	1407	1395	36	1	4046	jxLWL2aVqKdVydoDY1nmvW1nUdS1nCWCmqtu9p6MPo12t4hSe5Y	2163	3064	3064	1616490720000	canonical
4215	3NKc6i45r6YgpJd7PiKPRmV5wi2ELpUEJGC8wxUj2tXsEvhvL9vK	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1652	1069	37	1	4102	jwYPoASU4aWvebm9pcNSXToNcTf72dnBDwzMKZdCg5Nin9UvHHv	2192	3108	3108	1616498640000	orphaned
4218	3NL2JUgagbHoX2vGMNH4FSvhQxeCjixBwLcvJWizYfsJvG1S8DVk	4212	3NKV9W8QNCqUSmDVhTeTXSdXXcx5YAHhGzr1ngTYwUL7kn4qTgWP	1652	1069	37	1	4102	jxDwJjf3ggb8HfLBvnupo9YWWMLMSahkKrHNotUbcgnxYBfBuAA	2192	3108	3108	1616498640000	orphaned
4591	3NKt47dn1NQHknTmtXZPSo8gGMPEJrrJWbL3LnPZWo7oJS9QswJP	4461	3NLHVvdAEjTzDkrm7GJhTPXHoE3ZiCBvNQzq73EXkmcQU7aoavmF	1627	1385	38	1	4460	jxysfR7R7ssjagEJMt459ZHraLi79CjmbFsv5ipCUuL8zz59ES5	2194	3358	3358	1616543640000	orphaned
4693	3NLxDQV2Ps9SxUNNnr8UZkTvXauJrRkw1rdC5HNJXJrrpFM9iiFT	4591	3NKt47dn1NQHknTmtXZPSo8gGMPEJrrJWbL3LnPZWo7oJS9QswJP	1627	1385	38	1	4558	jwJuNKo49qyFmSSmSQ2yxY6smist79Sf8yyysyhWeLaHAs3VyEr	2195	3423	3423	1616555340000	orphaned
4235	3NKcaQVsemsbk7dZS6MVuQ8qshGro4MpZNfHgZnhSnNhJu9Jhxnk	4232	3NKiiZa5kCz6mLKjAcw5FGyhNmKH6xdiJTyBhLwCGEd9Mcbm9bMb	684	986	37	1	4121	jwuLJifUqFwsTWszbogdUuBrc74TVRgTtiTZd7PRf4FysZ9kQ3s	2200	3126	3126	1616501880000	orphaned
4241	3NLeRapiqJrixbFs2M9NqVX3JDEAqgKyb3o2ktxggdhHKdHMTS15	4236	3NKjwFBMYmaoR45cZKhgL8RN9rpyzdF5zzCe4sFpo77c6H1zU6BK	1419	814	37	1	4127	jxW6ZhCNSdrKvmmxUcgU6aqYSQeUMihoPpXPHUFkEYTfaGDKRYm	2201	3127	3127	1616502060000	orphaned
4249	3NLdGnm74tMdoeV6qVBkC9pNaZHwHQ1vCg6Yedurm9gB9nWewgzz	4244	3NLwWhN2i3gB5dbEDWio4qBK3vTw8bZ9tBK6LShTuHAkzdFhxH8J	1647	1302	37	1	4135	jwMYkp4SuWs85QdrwxjMJXrNQaNKxEFnyoDMknmh9HGYnBhEwnr	2204	3132	3132	1616502960000	orphaned
4262	3NKi6VNp6TxpSZ3KA41hjT7LdJXbhUpnt4DADRPdLVRSBvTgdSpp	4258	3NL5BjhwWuAPFpK3BMDbdFfNAx35sdmQStX5uB664gYd8TMLSBMY	1559	1353	37	1	4148	jwxHAtMtfuSBuiNNPKG45GX5GJ41dza5RDyJ73NRn7QVDQTGUJy	2210	3143	3143	1616504940000	orphaned
4407	3NLDf8AnYPZWfYySTuy7Tvk7QJpFJkWLPGgcnh3XQ9R7Fhhn55Qw	4264	3NKPiLcifYTLn1FyshTbEgVNRjEA5b6XnvmXaXSbj1EARpWCkBjH	369	1066	38	1	4285	jy3Ex71iptKW7ZdJkZx1MbeFGnEhyGoXsNyRefpuYTqdfM7EGAb	2212	3234	3234	1616521320000	orphaned
4449	3NLr2qMKesf8CDGYJirbZ9R9vPkGhf5paZ7Xiugobh8z15gREkad	4407	3NLDf8AnYPZWfYySTuy7Tvk7QJpFJkWLPGgcnh3XQ9R7Fhhn55Qw	369	1066	38	1	4325	jw7puAsAB6SUkxFPukA6Lrwn2z6BKLZmS2EPc1kxRnUH6mAetXV	2213	3263	3263	1616526540000	orphaned
4275	3NK3jPVMFjfNdcEaMPtSVrpDBbhjB4dsFnq25MQpjSAmmrzD9nue	4272	3NLYXytaJnGBECWjv3moZpkvC5dSwLvg3cF8D2rgdTA2NAcQabs4	470	1309	38	1	4160	jy1teVFqp7B1fZzA5PNFwKS3nwUTH4cZCBw2owSJTVbLqLCuw2C	2217	3150	3150	1616506200000	orphaned
4288	3NK3zEoC7N3x4cXcHuG41kxLdzKuhhRS9krgW73c5JyymbBR6zge	4283	3NLQx3oQNq6xtF4wXCNey7pDbCopRBv5TdmnMUSCtcbQdp5VA1bV	1652	1315	38	1	4171	jwmKRs15ktAKGE22eUKCHgPGjnbq6AMf5dEJi6uXHyiWXXBRJYp	2222	3158	3158	1616507640000	orphaned
4388	3NLW9YR7i4tUqXNdtC1x1utxGs4y77UFjWAo95in2RPsG4mM3gqh	4287	3NKr6UCWjSe7LD6GNf6ZwzjUvXosDQq5QbjkYq9bi9apdUaPueea	1476	1371	38	1	4269	jxDbob5pyG7BX5v2N7ooiY12ouDZ6ruxvDZXMJQ5DpUqAMxSfMd	2223	3226	3226	1616519880000	orphaned
4321	3NKXnT4FKFTgNRBu2d3SmQMwywynL1dkqjZ7Zv5psJzmMtUQAvSH	4310	3NLicDbdc2KdYuWGC2yFBqX6s7DhiYeoYS8K53pZ5CwL7FgE7QNz	1434	642	38	1	4202	jwZqrdFqp9EMXPXfH4YzvXR6hELBS1vPXQXoqUYbKRbsu3Ukoaz	2236	3178	3178	1616511240000	orphaned
4493	3NKpAXkFX3aYCCz1VqfQ7TXkx9K3Di4S9t3odoJV4td4K6wv2XDj	4424	3NKZSsxaSB6JMpet5KpaEEBMsQagjxQKVpwqntKf1mKL24UGT9E8	1652	1069	38	1	4366	jwxn3a9yhMDAqojLgsmzkVcEbHwxQ6ovjpTxTWCRhPCWVkUTVKu	2242	3293	3293	1616531940000	orphaned
4899	3NLZat9yyxmvAyRA9MHVkXX4KDtt8zEDjcymrRcpn5yKtXd2b2s6	4334	3NKNMcnWAAToJEUuXRm3TjUigRDT59JJHp4bkLgaACEVFFsBMxmk	563	993	38	1	4758	jxt5BpRs8whkPvsBxBDM79k9Xm5o4j26oi5LuryYM7vGkMeEwMa	2247	3562	3562	1616580360000	orphaned
4353	3NKa2hvyjDPgVxSCf1QX9MZuDNbacx3kEKfbYbrmZ6wcW7civUZS	4351	3NL5Z5N8s9CMk8HQjYur2prM6RqowZbpLCVZiizba9Yrq4Bh3AhM	1406	1393	39	1	4234	jxeRmkHR2KEoaVdZXUW6d1JgxmuroGRfj2pjgvHy3sQYth78aY7	2255	3203	3203	1616515740000	orphaned
4359	3NKoiRCLFRtoUFFQdaJrSt4hH3u28UcDN3ixSPY7NEUZ9puUynzW	4356	3NLMwrdJg5z2UvQ1o8pk1vRxFjGh4RpKEjfP7wMtLpGNd6RGbnfp	1654	974	39	1	4240	jwaxL2gtVWdifHPTTe1Q2jaKqhEZQPbSosUqF8eEYHPmUq52yzc	2259	3207	3207	1616516460000	orphaned
4843	3NLJt7qodiFFwRVazaib19EmhF3LyAAj6nRkKUBiAmB8HRiZc889	4571	3NKp3jv7GsV6EsBxoxiYVSr2rJjqmxfQuQGkXdMNCjcDX6CPbjuq	641	1210	40	1	4705	jxFQzrDNaVU3q2GgWnb69hbmBwdYmxoD2pyj1yABcrg3UhnpE7T	2261	3528	3528	1616574240000	orphaned
4367	3NLtEtC6jLog6RaPTqRzyz1Qrv7Qg666VZPxABtzkzW3vbw7FBJo	4364	3NKbavuzM56C2snAJzgwbEXPvt1An5tjyxPEcfVs2A4AeRxwwPKc	1631	794	39	1	4248	jxvFQA3hRZ9bcGXGxB5VUhAVGyknEN8uiMSxQC6x11neJoMkzab	2264	3213	3213	1616517540000	orphaned
4383	3NKQaXNtrzBRtYebpCumU3XuJQ1LECPuVUSJVw2trDg3oK3bPhBy	4380	3NKjMavEFYtmBrTqhvxsjbj2HGYhG12Zmcz7rvTwtGnWQX9EMo7N	1577	1327	39	1	4264	jwJwTGvYmZhQVHBvzNA9p6kY1fYukaMJuCcVxG2yoR8TvKbD18Y	2273	3224	3224	1616519520000	orphaned
4394	3NLrRZid7niwWzHEpkTJrqYMA3d9X8f6fqzKxdcfZRCP4b1Z6r6Q	4393	3NKU66cHbqL713WMNHC1KA1m1hi9JRRXw7maHfbzAMmqWknrHW9y	1407	1395	39	1	4275	jxv6KP25YBjTRwbWLhuh1tGenLUhGcjX3NcifJZ81PZYqqNtMD8	2279	3230	3230	1616520600000	canonical
4398	3NLEVYD8oZ8Eo1E2KxqdUGkpED3X7B9xmZ5kwfj8g7fGdPecTEb5	4394	3NLrRZid7niwWzHEpkTJrqYMA3d9X8f6fqzKxdcfZRCP4b1Z6r6Q	632	1256	40	1	4277	jxYJmr8piQxv3ZoP9Sw6gGysT91G5UKoMAD38WqiBJPxxhwN4wR	2280	3231	3231	1616520780000	canonical
4402	3NL7m5MgpeSfdzoXDrxUV7xxJCoZiEDEbSUAYyASae9hYrSznHRM	4397	3NKoszHyUoSEZzRVAD3NyZuyhda5X5xRJaLtW9exWb76VdHvsuRD	1471	1386	40	1	4279	jwk13rTmcx3VjWKPKrEzYmybqkHoNfcSkMXYNb6CHizsW97Jpka	2281	3232	3232	1616520960000	orphaned
4745	3NLdeFZimMRp7ozYyP3aJoumtKwqvBBfNfXbMNeqr5Ekr6Tb8KSM	4617	3NLnb2ArYfDdEs1dxzoThh2ATDMWWGQ7pcYZ1FwKZuxQgKb5VQxm	576	1355	40	1	4608	jx3iWa9GeKwsnn2YBnFPcRozkZuHbBv6aTm1Y5UGV7kgoUgWB4Z	2285	3457	3457	1616561460000	orphaned
4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	4441	3NLLDK84ZW1QAY6dq4581SVB3SGnZWnUrSoKpVNETGWZh6kBnyox	1573	1072	41	1	4320	jx4zai8XRyz3ZhpoRRaKJXKx35AQJimwiY8jAfJ86HxcWkUEJBW	2303	3262	3262	1616526360000	canonical
4450	3NK7N5W1K1rxZ41xtCRhBB7qL4MN95Ce6RtnWNHWgtLVVkTA2iCs	4444	3NLEkQrzvpC3j4CYj76CJ7kr9xPLzEbyaRsHziBfmi8EbMpm51Je	1601	1262	41	1	4326	jwhXgEmk8XPvXSuscgJden2saimiQwW8HRVfEJA11tt4r9xaM8A	2304	3263	3263	1616526540000	orphaned
4482	3NLCpJ21wLYWppmCek8r4cJtcHtTuPrtZ7j79xKnCwr2PT2ayQzD	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1490	1148	41	1	4354	jwASBWuMLbFszAeFZ16ZftQLFdBqbYzZLVLFobSXCQgNwH3Z1DE	2321	3287	3287	1616530860000	orphaned
4481	3NLWGPqujwjDiyhNnNZJ58ybegaqrc9nM1vByh5zHNDtBnEKYifw	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1474	963	41	1	4355	jxSGqfzEiEvRTdddZG21JuHnoBpHHkvupjpirB4GvotMGA7CmT7	2321	3287	3287	1616530860000	orphaned
4479	3NKn4r8FwXnymawyoTz3A2v5KCFmdjZkK1LYHRXKMCv4r2Fumv1v	4478	3NL2uFUoYaA8ZgRx1eeYVSbawDNRYqPd1XoSxYd87Qm1k6t4CLBb	1490	1148	41	1	4354	jwASBWuMLbFszAeFZ16ZftQLFdBqbYzZLVLFobSXCQgNwH3Z1DE	2321	3287	3287	1616530860000	orphaned
4589	3NLg8Xhe7H8YCsyPhXrBegT8HDmjVRhzE5cTama96qbf6v7tvm3p	4484	3NLtEGhwN51o4hvif3Svm2ocDY8ynXR9qL5SuRqfsgt8ugcnyQFo	44	1079	42	1	4458	jxj2Z5zp3sLYKs16DwhJoR7PrHpBbUzniyJNobKdCLTcn2au3fY	2323	3354	3354	1616542920000	orphaned
4643	3NKzxhNJjzYKmxv4L9iDxDjAyqvKtFEMvMfjjkTAjnUR93byFBkR	4497	3NL6G18TUdA8vdshxQU4JQoLM7b2uyh7VG9tkatT3r3ZrJQaEctN	43	1064	42	1	4510	jwW1vL7Sm9c6B5bRpnyr5uheWw6PA1GgmEaPPYkkHUMKV1haMRN	2329	3394	3394	1616550120000	orphaned
4510	3NLbTtcn6EJbRHum6MVCBqkHd1cYtkVoDgVR6ujXb2oU59tMePtD	4505	3NK7Vht9LHZi2Xr8DXLPXAhmsisUear45AvJvQabkepCAUse5ZLr	1613	1223	42	1	4383	jxcv43LK8kfvxn69s4HjukBuAc6nAte8gJqAuRU53cH2k9UoUkU	2333	3303	3303	1616533740000	orphaned
4516	3NKPF9jzmMZB49c9RzSViQ4aU7wN9sfvpb4NgXF3prUiVxwewYKk	4514	3NLHWnkAeDFQ6JdMR8ZUbR9a26D3ZnsANo3e5fhgFHZJEWu81fqi	1474	1329	42	1	4389	jxDR1xe4Ax3KC1ErnYeZ4ecnPiXGKrXF4bUMeg1ZF9ALPK8hPvT	2336	3307	3307	1616534460000	orphaned
4529	3NKaV6f5Aywo4dhwXY3VVRNd221hff8UwhjWxTyfLPJtfTvyW6oJ	4527	3NLejboxnqwtdYWEvf8c5fATthtUxhLnik2cbQtnpBP2A32hyoHt	1455	1332	42	1	4401	jxaWQeUESZRtiygoJFR9SS8ev5hRhPohvZzEDBvcVzpYPTq5w3e	2343	3315	3315	1616535900000	orphaned
4556	3NK84WG6UgUvvVpcENYhYYQdcAUeB7tVSJWDPsdZEiw4mZ2usGfQ	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1503	1151	42	1	4426	jwUjRxeVWEERgusjw5JQs78Hyi4YpqAF2XRTLERiwdhz6K94Poh	2357	3333	3333	1616539140000	orphaned
4558	3NKrZp7mY8P3KB8R4yH3qUDqyxenoj9cKDkqkZw49BGHMrwLtwEm	4553	3NLBtAZnfZtrGyHsLpxzi9scUoPHgXCRNndEDvUMar42jrN5A3Vb	1587	1357	43	1	4429	jwzRn3khM6gen4NS84B99W9EjJveU7M2aRoBHW4sR7xizUFsLYb	2357	3333	3333	1616539175099	orphaned
4572	3NKeqK7twLGBmFug7xzQpjRpNqEFir7SeTnsh73QugqCUfA7dgFX	4570	3NKfJDNNmDBm2TfeMTnWeQgcyQyZuYmCyVvWALBv8MjmkxtDth5F	1406	1393	43	1	4441	jxsuABEykzmbEC26vWD45PN34NSwCM7h9tZpousSptrpNXAsuQB	2365	3343	3343	1616540940000	canonical
4582	3NKSJ3rmTNcuMPSL8CPbLgCpJZgnCbJANbtNUdgDfMrEX1fp7y8Z	4579	3NLeG3wpdswRVzAJhNyjUeBHuUDSnyQPd3ZyUN76ZaG9Z3q5FsPd	1534	1317	43	1	4451	jxqkr8c1xrbBfyEnbBw5igAH6Tsg7rhLHHiimBmnTGjhRVFTLFD	2370	3349	3349	1616542020000	orphaned
4587	3NKZKJBYu3u6AyGvWF6h9wB75aQMdyEWLAFBHHP6kyMCLpXxDTuX	4584	3NLxVbVUmW16GX85mSRAkfjefvsudnfaD2ehdscREeYQzUH1MC4o	44	1079	43	1	4456	jx2vWhGjWn2JY5RiHWBrVWeC7o35U3GNq4UD5WhNTsrbHMcM3Tr	2372	3354	3354	1616542920000	orphaned
4935	3NKWGoo34S53QHcSs5MpBTBepqugNWJ5JwzU6UPQ9gcv4Zg1ZwS7	4811	3NKsEZHapJGZfaHf82eAvyWAPfUJiunNCQxu5kpx2NJPFiQuHMtf	298	1308	44	1	4793	jxLxxAoBnexmCr9E9NokswG5YemaiXP8V8sBojceD5Qv4PBEM84	2396	3588	3588	1616585040000	orphaned
4825	3NKjTJPSnNVz1VaUnSDZ61uy4Xc5ygYK3sWtTqf8wmEEwfL9Sxi4	4631	3NLidPZJFRQtRcRvBRkHnQTCqk7s9eoVQcwzpckSpvVoJc3kG5ia	684	1106	44	1	4688	jxJUMnHC2dHa2MTqzc2PScxY8MsxBw95Njb3BdJVeYoJ5C4XwRg	2397	3514	3514	1616571720000	orphaned
5097	3NKj6nzeDRFUPuWZagYHVbo4qEmor1qBbczu2UyEreWr8B3vvEC1	4935	3NKWGoo34S53QHcSs5MpBTBepqugNWJ5JwzU6UPQ9gcv4Zg1ZwS7	298	298	44	1	4949	jxLxxAoBnexmCr9E9NokswG5YemaiXP8V8sBojceD5Qv4PBEM84	2397	3713	3713	1616607540000	orphaned
4649	3NL5geWvMYJbZPGYU3WMRHCMvYxt5rac2sX9sxhey3dg77EjL5jy	4644	3NKx3EY3ixkqVqHYWrg21SetN9C4Y8Wipmfd1u6g3WGGEasCmigD	1631	794	44	1	4516	jxRGkrBMJoppmdpSbQzZsHqHMyyYnTfssfC8q75C2wyTDjrAYYf	2401	3395	3395	1616550300000	orphaned
4705	3NKaPvrF47z9FVyKaAJv2nux64XNgDvmEV4ciCv3g53tHU7G3jei	4662	3NLSutyoCW1QsuvYmrV2Bbi7T5B8HWYWBHzC19dLcxKXdQ2AwwsJ	311	1061	44	1	4570	jwoYeHz59AxXtBkE4s8kWpARgdtTJtx6DLSzdmeVofP6FjWjwFG	2411	3428	3428	1616556240000	orphaned
4673	3NLaZPQKZJLckDPoMzpRGj9QogqkphSgdoJMmqj8MvtUVxmx7nKF	4670	3NKPWGZxnEwpEHTLGxUpB8qKrjmr2dnLocjBNH5L1fL49D7trUfR	1607	265	44	1	4539	jxxK7T1C35KFiEj6eiKoGc5enoNhiNoEEs5BhrCFRcMrZgmQzXG	2416	3412	3412	1616553360000	canonical
4675	3NLNwXtf7Ei2LCQ92Bsar2iNTto3rDcJ3XGZPbR878qvpsSLXwzY	4673	3NLaZPQKZJLckDPoMzpRGj9QogqkphSgdoJMmqj8MvtUVxmx7nKF	1447	1099	44	1	4541	jxDPL2HTAs5a6a61Rwe4GDVhdTKs1kk6td6PHY5dJgKtyyKdtMh	2417	3413	3413	1616553540000	canonical
4676	3NLYjBw1X4zVjBHuEdFVPZv555Zdv85hL4dJqzoG4FVsHnoHso4H	4673	3NLaZPQKZJLckDPoMzpRGj9QogqkphSgdoJMmqj8MvtUVxmx7nKF	1654	1340	44	1	4542	jxSZRd56vvDmmTYnGgM71367a3CPdjjPJcGWd2HL4PHHdoZYVMh	2417	3413	3413	1616553540000	orphaned
4679	3NKPKLNyh7aJw7957LQNazmTLbKujwxhFnCeiX28oYXGknCwazDt	4677	3NKQSNZcZZt5SQGA7ygX7e6qKoacmBFyzo8sSy8Pjw2uy7hGADsr	1670	1156	44	1	4545	jxerjPHERw6msVsqYAmH7HZqref8WpA8rDf4j2g14XrPXXwaSDo	2419	3416	3416	1616554080000	orphaned
4696	3NKfrxikUW76xDqvJkGaXngiY2ktbicdtJscqdfFNFbJCnWntxV5	4695	3NKQVrWEEqVxAQXF9Rd6Qt2nv9cKpyDt1ntvPGhajfPFbSgnSCRB	1513	1253	45	1	4561	jxVteZHmrnnpo6iHMn4QFQm4WyuuZAfuNaZxZZDeicHHno2c9Y3	2428	3425	3425	1616555700000	canonical
4699	3NKNMEe7UJjkTJc1bdeZ6SLb1KsmKGFGwNzLAyLnzHBPcxQQmgBW	4697	3NLKeY7gMc6gJUF2huLWj9UHPHifEyHufXxaSyDrKBR1MLgz5zHb	1405	873	45	1	4564	jxha76FoP6oUqKBD7vS9MgPDPQSFWwLCumrGaQC828rFW76YUKH	2430	3427	3427	1616556060000	orphaned
4742	3NLKXpVuFj4fdzJ6N2sKovhy9WUP5EpQWZTKiDw5dSUBfyb5kjXt	4713	3NKfxQhuuikDxMAwLY8Z91sqiqvJeG4CPFJsnQV9VWx5gWsnpeS9	1489	1134	45	1	4605	jwrwTwT2fFikBD5KPBjmgyAeuCEzPuEZP8WoUMQZruUTAU57H4s	2438	3455	3455	1616561100000	orphaned
4730	3NKAgjdYQSCFKLAtpia3dMW9E6YWAPoDS3U3LYoDbMgorXuRxTE4	4725	3NKoQu6v8GvfgtdQAHFTqxhf9x9N6vMSakqhxMy36YMas89fASjj	1400	77	45	1	4593	jwXiEvvkctNj2GmpQNNSR3gYRJV2th5tkfNwDy5i2SLbfa8RHbU	2445	3445	3445	1616559300000	orphaned
4751	3NKLYRSAwAsvR6bdRVUSe5eEa3pKGrhByfw39eWc1RhoFeMyHP7Z	4747	3NLgD7ZzjmPBDpTcQwTZYXZD7H5wy9FFY5eCGufnJGgDnWZ2o8HD	1402	842	45	1	4614	jw6dxj7dWgF2fEnXhqCsr7bGPMDgJENQ3XnXrHJoKqwvvUsib1o	2455	3461	3461	1616562180000	orphaned
4784	3NLkQaEPEUsgd7BUzEXu7seDpherVizBp5VYph8W5yDtC2JK1USr	4783	3NLNMu8a4JeCXuEQ5LyPcB4rYcwZnohsmhSPG5EKS6ztLkcFKBys	1637	816	46	1	4647	jwHmAYWBUxjqhhWMb2XeLUTgV6eZwgcnawPX3Av2oEo5bYwtYck	2473	3485	3485	1616566500000	canonical
4786	3NLA5N1i1R4AyuEHKgD4Uo5c5kAnc8ULjN9LnuuHaXiNj461zB2w	4784	3NLkQaEPEUsgd7BUzEXu7seDpherVizBp5VYph8W5yDtC2JK1USr	1581	778	46	1	4649	jw8MNTXBxXHwxVBFf7oJYANcc6VE8bwhZw2i8inTT9avGSMhy6f	2474	3486	3486	1616566680000	canonical
4817	3NL5DV3Gu9fXnrGs56Rw3odYYf5gAU59MG4CbLCutppwm7UtuV5M	4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	1534	1317	46	1	4680	jwhkzXc2ysLbMTQcd6Ee4gfqwh4ssGncBLw2o5XbpTyYKuzAQDq	2495	3509	3509	1616570820000	orphaned
4818	3NKpchFp8Em2Tphuo6K4KpBUHe3pg198782Vyn1Tkz13UBbMWdKD	4815	3NLTwGGh1PUbYTSTswcRJHaFDXpBJ9o4fCXxEEBHXRkBfcLtPzh1	1631	794	46	1	4681	jwCBu18g2dz3z3sQa1Q43CRWaN9QjtzF2J86TL9ViwPiQLaw1gz	2495	3509	3509	1616570820000	orphaned
4823	3NLuTc3TTYHMWtNXqZjxYmPXoj4mwHybPw7yDje112ZCU7UrQQh8	4822	3NKwmUxnoZMzfCfzAEkZeQhPsJdG5a7PnTNjHhFxErAHjR5NEpwm	684	1106	46	1	4686	jxQ2SEFRekRpBXzSzV6Fug6ZqJZ3aFgFHwYcbWYDtnBLgws81B4	2499	3514	3514	1616571720000	orphaned
4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	4831	3NLPrFG4AN9fyCHwsbs54XhtwA9a91N9Ac73DPj4kS96kro54mfb	684	986	47	1	4694	jxg8uVgsNyi7WsJMJkB13m95R5bnbNoBfsnB7qieAcmm9SMLXp6	2504	3520	3520	1616572800000	canonical
4835	3NKGm6rNDNdj5ExyjFA9N4FtxuCN8NtHnisgYHbKv1x1cxkGQrjM	4832	3NLGkZGBA1PGiY7zTzqdx9DFs8pqg2iWzXdasmquCVdCyvDBWnft	44	1325	47	1	4697	jwdRSfTKw7ewGXfVT3z1cDQvVtWhZ774FxDYwT86JyNqQoJncgn	2505	3523	3523	1616573340000	orphaned
4839	3NL2BWb5hkCYVtnmEHHj2ZsuwPBFzri1hxqhpTrzxcoZqbhinZL9	4836	3NKxKGcFH9ni5ii8kDS4xZ44pTJ9Yj1MN6pGWMWSEE9m3SyRUkn8	1652	1315	47	1	4701	jx25A5qsvcWJemRnfgkbtngVJvQsjGSmoRysuzbmZDj6XfQfKsC	2506	3524	3524	1616573520000	canonical
5232	3NLJcM5RxdVMhYvw2HycYxoP2ZVEbo6sphrd46yvTP6bcbBrnpNE	4859	3NLjHZwynpxHBNhCpk6pckN1iVfe6U8hk9qWpabj3oosdRyNRHi9	1406	1393	47	1	5076	jxP4EnWyv5AF2QTMXxjdaZ9AyJsiVJs7dnXpz8s6SToMAjWAYfN	2517	3814	3814	1616625720000	orphaned
4865	3NKJ6ma9wBihN2yxGsvpdvXLLCVPKNbQKic7eHJifg1tSFXXPwJY	4864	3NLAB1yV6ymXfpcuz2rW82VC3NXJfpwr9kaL8UdToBY8e3F8ioJK	1671	1239	47	1	4726	jwq6sjKjZ6QtkvzncV3cdiajoZCFNsgs5Kdy4yEdxLXiUEApEGe	2519	3541	3541	1616576580000	canonical
5233	3NLe9n9m4XQ2M8s74vKMhu13toAseURkDY8Novq5P6PD8iHcK3TV	4884	3NKv79T9bAuu2LenoroREYkXCRVt58mb1tB5GoY9BCUnaGVBvKd3	1406	1393	47	1	5077	jwj3rsSvkB3v7C38ZKFfMJcB4uQRTaMWJWF4whc8MmXgXt6Ei7p	2530	3814	3814	1616625753878	orphaned
4911	3NKVKiAfxje6Csa2cd7h29ujz5uKfx4ZWgPzKiEEQmd3dUSdMWiu	4907	3NLVuwXrPjPodfPQFqJivwSbBj81V2khWUopuwgMwY2uphVayZ9T	1578	1296	47	1	4769	jxaCE879F1n1Lh9AYeQhfLTK3wRB68u47aupG7qnPXSrVvFL6Tx	2541	3566	3566	1616581080000	orphaned
4927	3NLFcdgb28bxreti51F9zXfpnkmmt91DYccoTk7Mnyprun2KeCBE	4926	3NKGmTKZd4w6jJUwfypfqPiKTUCAVW8x1jZ2LLVRxqSfoxNXcYpi	1483	1030	48	1	4785	jwDW55GS5LE3khgBkpTvoxgt28mWs42brE95jxrz7ghjVkeyE49	2550	3578	3578	1616583240000	orphaned
4933	3NLjb7acHe7Cupqir896y4ddvBcyVZF236ehB2gNEKMYVob5UNWy	4932	3NLwjkLroAUXDZddpF9UQ8yyZPRWGQQc9pfK7axqfNG7AKv7aHn8	1549	1236	48	1	4791	jx7fXjQC26XJhR2xZhL5rhFjeGhFgFq4eox3M6UoLdTrURdnJdx	2554	3587	3587	1616584860000	canonical
4936	3NLjVjmFXyYW1Tr9C7qkKZXrpwCcAZg7gWg4A6mNkjww8owJiZoP	4934	3NKLkF1X2X1DYdkmJJvSVtsascEN9Ld6tuhnweFFiaBcK3U89f3m	1406	1393	48	1	4794	jwe5fTMPrRz8UCe4D7NtNiyCSF8GteanWLLqAfsDYMRwhCHFbyv	2556	3589	3589	1616585220000	canonical
4951	3NKdTWWZhZaXHtgqkFPP3hxmRnQNdJARy7AzfzV5Hzx3uBqHUsaC	4950	3NKDeJM2MWHUoP7gfvBBiRmFHVTSsx8TaJXzCLpRpr4mCePHg5QU	1460	190	48	1	4809	jxKwwqoU9ba8wzLqZf2qwcZra9gbAG5u1Wr3KeErTdaPPr5zmxU	2564	3601	3601	1616587380000	canonical
4958	3NLgfgWxxEAv48HvfTJh5Z1qg1hebdsMBApZ43XVmyQeyBPiXNAC	4957	3NL5itqDZfuT8DZA2ceitRhJDiAtb5bGrYPf7Z9cQU5mZXY68Mnc	1500	1051	48	1	4816	jxUcXDXv4Y6VGDYu3emQC51G5UFPuiZVjjTBrtjWBqqUHhhQtBN	2570	3607	3607	1616588460000	orphaned
4961	3NKbgwZsvoNpecX2rnHUbd8RbcpmsCWZjur5kcrsw44izR4zBQj5	4960	3NKW5PqvY6CD8Pnjkb1B4dKWWLA74oGcqdJmCeoXwcrKq1aA4tdq	632	1256	48	1	4819	jx2qiZ74aQ5X2JnHpCokkaD8ec3UUYDAuqqFaP4aSbUFSNzVDVX	2572	3611	3611	1616589180000	orphaned
4987	3NL6uwhEiUn2uTxSGBWYKfqgwvaEwsMFcJ1fRF3cPNNc89iGi4sb	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1637	816	49	1	4845	jxDsgmQmS2huMXm11kiqTp8hiJiYje5HkCLyFE5N9AY1UrG8e3n	2584	3631	3631	1616592780000	orphaned
4985	3NLx6FTZVke8mbizoX9EXcDMEo6uSgTchJHS1WwWFUC8VysEkCrC	4982	3NL2sdkB8ZQZs4DnbLUXZTDVjWvfBoPXAUQMtVGWzXdmmJpai85z	1457	1391	49	1	4843	jxLFUT11zJAhyxiQ3fghKAuZkxp2R578pF9tK5jN5puQpmXPc7k	2584	3631	3631	1616592780000	orphaned
5006	3NLjVnEswF7FthSza1eEmBFnwZGu8NoM7mXBGyf5Pp93NN5vexKJ	5000	3NKZ5AaW1dkpFFnfRUchH3sHgYaFJPY6a6dar86owdx4ZEZDskh2	1643	933	49	1	4864	jwBXowEG2bAW3JPHBadC8Sur7dLebt87D52WrnxeUqdM9DX77Aa	2594	3645	3645	1616595300000	orphaned
5206	3NLNck4mGGvnD9mvsLZhWe8fvXWSxqdo7wYdhSg2EAHxaBUzF9jf	5003	3NKRbrHGDYJRACK1qKKA7a2nkANv6TjxR7xguxqHSA2Uw1rbn5Gs	311	1061	49	1	5050	jwijkEbnmpHwgbGH3AZxA97ap6iB3rL3UH8ScCDn5wkG8VcU61R	2595	3797	3797	1616622660000	orphaned
5026	3NL4RN5j5Bx2d3DnenuCgKGAeCmESbFguVM7VejdSW9cU8W8Nim4	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1534	428	49	1	4884	jwZfmKtncmmn2kDogdYR42UWvtn1LWann1kwYkGRGb4bDcrygdb	2609	3663	3663	1616598540000	orphaned
5027	3NLJVa3Wjt3JLhseoSjHEMTmQkos4zYhpLHMizA6uYDA7R6tTvK1	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1403	824	49	1	4885	jwM7BYY14TYFSfMW8iFvikiDRYLkoRLCdE33H5Twi52dA5QAcni	2609	3663	3663	1616598540000	orphaned
5028	3NKrLD4AnB1jPuxAL234orb8hMaGMEy5ZEadp28JakJQU7b9bC7R	5023	3NLLToyn4N1xKdD2JR81zRzQbAJK6efCwdttKW6uYYCji2wdoJ5c	1534	428	49	1	4884	jwoWnYqNJhTU7PuGJoFf94arXuJJWHHCL6jCDenZ9RAQYktbFH7	2609	3663	3663	1616598540000	orphaned
5044	3NLmmZK8NCWHnoV6Z2R2UADpzRdLzFiTzgejhypBYEkPWU1cANNr	5038	3NKALuETaniDue1ju7SNVvnBE8WqgSyGUvxsDjDWjgwiYs2GLGBi	1508	1021	49	1	4896	jxjmt3cRJ8ncvsCJ6EWbqXD5rhxPJawPEmTSMN8wQgm3V42qSvQ	2614	3671	3671	1616599980000	orphaned
5041	3NKgcWhmW1rzajFKygxFCJd6c9gYHzWHzhxMQHjFXcwMQDzL2MwE	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1671	1365	49	1	4894	jwwDomkgddGpuUTCwyuif5DDBKBi1rJHVbc8EoJ3KjNSUeE8iyc	2615	3671	3671	1616599980000	orphaned
5043	3NL1jSWAjogk9NPgxVGi1Jqc2YsyKmCxPhF9iAXwwJnvywWmh8vj	5040	3NKw3YTy94X44WwkPRBjWUZfveP54TBDT2vzPUgc6w2yyZ88uDc3	1671	1365	50	1	4894	jxYjw9uXusHvba4w7Q3rVkN9DoWU5NwcrwJDuHnVkqd2x7iWuno	2615	3671	3671	1616599980000	orphaned
5071	3NLeVJkKJZtZwfxrgU4Dh1EpN4KqYHEJjtrXwqyKEZN65LY8scAr	5068	3NK6sNd4JsPy65rtw6LAyW97Qt5Fjvo7khk3dsfg5SmebAoYiqtR	1405	865	50	1	4923	jxCXwWkYeUbpQ4uipGwuLXY3JbHJ36ok2RZcWqthaPZg9ihHPgz	2630	3691	3691	1616603580000	canonical
5077	3NKZLYBFzCh4QnLJq5geJ4qELDo5bjxh7hyCjr7W2wektZndLHj4	5076	3NKoQeeLBYB3przccTe7wpKkGMPDLiuxqvCQ2RLgRQ97aep3wyua	1460	664	50	1	4929	jxmGvrHArNw2osDaFv1WMK3CtRpFGSKoLG8Nf1wTfbvhvfpWbJB	2635	3699	3699	1616605020000	canonical
5083	3NKEfHxW3zrkx54Jhe5uPMK4arWSPJJdFij1PsXneN8Z4ANHgd9X	5081	3NKQmRkUy3ZU9M832YarrV6wKK6Y9bFKrfRciqd1z8fKLEzs1ncT	1445	1290	50	1	4935	jwc5Svfv8zUGJY3JQr4mGcCdtpnmbn57x5YyX1VC5g3AHgWevS3	2637	3701	3701	1616605380000	canonical
5115	3NLDyMjX8Ygv61GHbaVDWe78w6gwnj1gaf9vtFkiWfYVKihr4gfR	5111	3NKwjx2WDX5p2scjadGQxTYFzCDrJMfewp3WftQ8Z7AGuvEeHPVZ	1654	1094	51	1	4967	jx9p32XAXYhbfs6hFMCs9ArXbeba1iAc1Lr3PPGi5hcmRcWwyny	2654	3725	3725	1616609700000	orphaned
5116	3NKQHpH4zkNhU4MWuSGz5hwWZW6zv8eZFFyZLRaav3M7aHFz8PTX	5113	3NKHfBntbyjdxd28pZ2u9pLSeVnonRr4HND1Pcy3FuaikzWCJyJM	1654	1094	51	1	4968	jwHqbPvK3u43SRSejYtuQVesVQu5ZdF8g3sYaL6jW8TYpuVnBrH	2655	3725	3725	1616609700000	orphaned
5325	3NKC3HWaJC6WCrTtKNGrtBwSBZ4pnBGaRCp6QUsVAwnyPoTr4NGC	5116	3NKQHpH4zkNhU4MWuSGz5hwWZW6zv8eZFFyZLRaav3M7aHFz8PTX	1518	788	51	1	5162	jx1AiciCTWTQvphJwx8RELbmu75nEPDctNaF6Y6PScbaAtRnfFG	2656	3871	3871	1616635980000	orphaned
5210	3NKvhutyRgz8jgjxqhgo3XcSSu8Dzqc5kJg6jZ1pfuqbb6GWTXBV	5131	3NKUxTRndzXr926RsmvSxX6us3DuPMGcngxSVXPQ8Uv52aszydEg	1656	1097	51	1	5054	jxDBHe588VEtQ9UQa7Qtm4JqShnGwzqp1mFXRMUmo3DGwyAaX78	2661	3802	3802	1616623560000	orphaned
5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	5157	3NKuRgNQqnXt76ghrUcUBpujLnrRMmPW6yzW61Hkrj7GFkykNULw	1637	816	51	1	5005	jxzaS1MHWmWvJZrFA2d3RKJ5ujxjx8utJYxcfbBbgev5VZGtun1	2677	3759	3759	1616615820000	canonical
5161	3NKMs4fwfcvJbaQsz2ZFw7X8nVn55qWCGqAPo446Bjq4RG6WtR3s	5158	3NL1aBtjhuDmpdAqzbJVsACZ8hkHyW7cCNdnVxdtqjNAPe7uu9UG	1546	973	51	1	5008	jxmT4pkWC8GzQsEWSX6KVjiT6Y2zmzqggEURoA6CiaVu5jUQjg3	2678	3760	3760	1616616000000	orphaned
5168	3NKSwUY5z26UcasD3iFCkRHMMrrvWMfY46kUeZW7XH2kGT6VTqG6	5167	3NLL3b47cMCXyGng7UxwxaBGghh7iJu2b3ewH1CcDuhjCFTFjehd	1642	1241	51	1	5015	jxZf7UV4CtaFKBDHkU4wHhnxV4YQn4jcTo3Gq23hqWiicVsXB7A	2683	3766	3766	1616617080000	canonical
5184	3NLXJtRoSGC9re2whWv4UCHa4kLgnLWzN9JVihoedDSwF495D1UV	5183	3NKGehcLpk5V9dASRs9stiT26vBtW3Bo8eHqzV1wrvdWwKysZwAQ	1577	1327	52	1	5028	jw6zGT3DKGfCni8MmYP8vcfQTxpLRUdA151diyHrhwpfSLY2g2C	2693	3780	3780	1616619600000	canonical
5193	3NLXShrUfGzxKALg7TMPY7XPgCTDEnjfqyHcoADX4sXBKcawxyhm	5192	3NLEyFSRxrEJdSfaViNJXEQxzr8mzcux9jR39uoVRtmUxkvu3qZh	1623	839	52	1	5037	jw8Aattc743c6gqNS5JymzVjjJ984PdtAM95h86gFxXwHbAZUBo	2700	3789	3789	1616621220000	canonical
5194	3NLhwX7Puw1TfsHjGDBLz2XX3ryeTMGFmQ1jRRYusgAXygp2upLQ	5193	3NLXShrUfGzxKALg7TMPY7XPgCTDEnjfqyHcoADX4sXBKcawxyhm	369	946	52	1	5038	jxDYHzEVgtuDs8JruxAd3GNM4ukSpSoUByiGmaDkHHAN46WE6pM	2701	3790	3790	1616621400000	canonical
5514	3NLs47DKuENU3YBYC5APNd2wPPEmY22juTEtAcbs7PLi6eWf5MLH	5205	3NKGujEgVz1yqbJApmKzj5EguErtBeGp3BpoXJAkkrxvG56HSzj7	1426	998	52	1	5350	jxa3VJiejgeb73aPfioL1Fyifaw23AT6FvBMFzXfE7LSx1fsXYX	2708	4021	4021	1616662980000	orphaned
5453	3NLu6mB9h3gNDRpCAzNXTUNRcBRgiSsFyGqDCg1aumyBuEyvrDpf	5216	3NLRw6P3LXHvhohLtMa8yA3ccyEC3V8scaVDDXwQrEFFJK3nqJQF	1407	1395	52	1	5289	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2713	3979	3979	1616655420000	orphaned
5553	3NLa14YXqHhqvUH5gm3rguPWNGXEDYFx5EzCZXYRAN2Dx1FFm9HP	5498	3NKpXyZ3zo4GnTgCP84ZUZ9LETrjipeLKdY8PL8eCPWHiyJ4jdWk	1407	1395	52	1	5388	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2717	4052	4052	1616668560000	orphaned
5606	3NKXhproXaci144iz8W6aeRyGUhg9vmeF1vwJdjY4ZukeqMTrKGb	5553	3NLa14YXqHhqvUH5gm3rguPWNGXEDYFx5EzCZXYRAN2Dx1FFm9HP	1407	1395	52	1	5436	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2718	4083	4083	1616674140000	orphaned
5616	3NLpsuDpp1P5LnK8zJRC7VsjNfaaNp6BzozbfwKzw7DQK4bfokef	5606	3NKXhproXaci144iz8W6aeRyGUhg9vmeF1vwJdjY4ZukeqMTrKGb	1407	1395	52	1	5446	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2719	4092	4092	1616675760000	orphaned
5621	3NKR8JKbmqqKX8hKXa13uiv65qf15dvnRQjpwCqZ6iv3apUxaEaQ	5616	3NLpsuDpp1P5LnK8zJRC7VsjNfaaNp6BzozbfwKzw7DQK4bfokef	1407	1395	52	1	5451	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2720	4094	4094	1616676120000	orphaned
5623	3NL5gXsYQDmCyKzeEjTSXYfrgKHUFFJnRdZpKReRqyaa7oAGaPqw	5621	3NKR8JKbmqqKX8hKXa13uiv65qf15dvnRQjpwCqZ6iv3apUxaEaQ	1407	1395	52	1	5453	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2721	4097	4097	1616676660000	orphaned
5249	3NKQ6MPuUZ7x6xmfMvdzKwwkHTnEv9aTW2c6fCovBKrHhguzEgzU	5248	3NKw5sHxi7iq8R6bWoNHhgAjcQKkTCWWSBB6djBnCfqhHikcXCHo	1523	1075	52	1	5091	jxKuQdqo2hpVT5RGDuzK2o52dGCeiC3jgfr1cf2SHJ2xJR5SdEe	2725	3821	3821	1616626980000	orphaned
5733	3NLw61fg4tzn4i3UqcMuhBYVijediS3dnnBkmJHCA83QrKHyTo8n	5721	3NLafBqsf63d1SvjuTftGBcutY8BZq9V9YG6oCa7fH4NwPxKpMk8	1407	1395	52	1	5557	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2729	4171	4171	1616689980000	orphaned
5737	3NKayafyVEocn4z1xZQPfFuN77qxeeDab1vpEK1mk572MSvU2849	5733	3NLw61fg4tzn4i3UqcMuhBYVijediS3dnnBkmJHCA83QrKHyTo8n	1407	1395	52	1	5561	jw9kCJi44BCDYiB95QbBAs4aoxD3728xW7GgLLDeas8QXcWro88	2730	4175	4175	1616690700000	orphaned
5283	3NKP7xTQrMnuUf8fXScAGDY92zmv1hrdZUVpDTqZbC4V4kEVPSb9	5277	3NLf6msSuSrjoPZ7iS7jKGdWiABMTEVUzMckMXuV8ZxXtK8n6T8d	1631	794	53	1	5122	jwvmD4e6DyGNba4GF8jtpVJwYK4g53E9PkLeFnHFgkZLJ5DrvN9	2743	3845	3845	1616631300000	orphaned
5284	3NKuMVz8TP6wUKWNVU3aUEwkJw6YAkgYXAi5wTPPcRfzAKadNJnL	5281	3NKZpt9ZwtGTVH8DYbga5RaUWSayGNGBLERAnVHukrDrENwZ7WZT	1405	851	53	1	5123	jxUhsTuUA7g7sJcsRCrzFKPRHpKmwsZ6MrC2GgKHPciHxsxhedu	2744	3846	3846	1616631480000	canonical
5286	3NKWRFu2CBVQZQN5TVLt5Zzcea335NAJwgRbtUE8CRgwNQ6UYFBP	5285	3NKuZE6AxjKYp7hmesaHcmGs3cKGHHwJDz5MhHrLQCceNhwHmULz	1534	1317	53	1	5125	jwr9yfRmW4Y8MJZ66cr27sJZWw6c97AirWPU7SJNr3K5LavyjSe	2746	3848	3848	1616631840000	canonical
5289	3NLZSKjh5zkZFWEYZozeAkauwYAXq1YNUVFSpqqafEFHBnkPWqbE	5288	3NLhgA5nJXv7Jjyjfji71dZ49FvEekr61iEQ1eZTpMGMaWtovyco	1422	1211	53	1	5128	jxEPbqQopdVmCGHHGCq7pLvWtHxzb9HrFJbbeFcbfSMXLTgTrVN	2748	3851	3851	1616632380000	orphaned
5297	3NKcvsBgREz4CLzRmEkvD5JQPAo6p99CsSP4PbT41vdXh9ZT56Kc	5295	3NLqD7m5ACwCp4MgSEZoyKqRP9J62qyzA1WYgvf3DTZBoGp7Ch3y	1457	1265	53	1	5136	jxnC6d6CKqx9eEDD41xbM3L9Sb985uYbSb5VJWUUPAZxwzf7Eso	2752	3855	3855	1616633100000	canonical
5308	3NLisrdFZ2ZztSLbjVhrgemoP8DWGPbdddRFbTKNLDso7HtWoKMg	5306	3NKPMVGzT9XCXHr2U4sSJmBXq5p2vz9ZSBZxZhFn5yLu9zfZXFk1	1654	1340	53	1	5147	jxwx9gmxk7TbyfG3x7VqvvvbgkftE53JH7PCaevWkm4gfTgFBNY	2759	3864	3864	1616634720000	canonical
5321	3NL1JNCCZ1ku3yT728fe9ounZqSqFcJX2NcFnaofHMAH4s4hAL97	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	563	1359	53	1	5158	jxfJv5mqbCtSSnG8VYEUrUdseHGqXZJmESDK5J5WdPjtjketj9L	2764	3870	3870	1616635800000	orphaned
5320	3NL4nPTtcPmK8wFUiFxuy1QHeeYgkCW3wmjY1zwJNF52Q1eUC9Jq	5316	3NLjZqqczXRtMxNVMyh7kV6bJKCJsb1G24e2ZPWddE4EkuisEKaC	563	1359	53	1	5158	jxfJv5mqbCtSSnG8VYEUrUdseHGqXZJmESDK5J5WdPjtjketj9L	2764	3870	3870	1616635800000	orphaned
5361	3NLmhuA2cw1aYa6ETizdBacFKeU4r9awn7BTxKMwaU6hLnNdmK1c	5324	3NKvRda4VS8ZNBcGaSNdteuAJAzYvnJmadY8Qug1H7pwmUjmDxED	1534	1317	54	1	5198	jwuv3gvrTSCDoDqcWkL2sQbN4TbTajdP6rjvtYYvhNC7ffV365B	2766	3893	3893	1616639940000	orphaned
5414	3NKb1nA7iuHzGBG2hu7pT9P1JKwNU3wsoCSVrQ7K9kC56RBJrXTe	5361	3NLmhuA2cw1aYa6ETizdBacFKeU4r9awn7BTxKMwaU6hLnNdmK1c	1534	628	54	1	5251	jwhQctG5v1KwNiWnvFTd6F96hJ3PVV7BW3CuskkmzWdQi6wacGy	2767	3937	3937	1616647860000	orphaned
5337	3NLP237GwYY1F3Z5Lb3P3LzfVzz2wwpU4y9hnCJX6RfCeDSGqKwc	5333	3NKuJcijTWnGiUyxJT4QNKj9ZNPZfT3tcpxk6c2RaZ7d7JAsQgH5	1581	778	54	1	5174	jxKYNfxax9yRXpKydXEeQ2ZbL1t7HhBJBG8sZ1hRB2NjZUDTmRf	2769	3875	3875	1616636700000	orphaned
5352	3NLQvPaJ8F2UEVtKfXtnF5MXpYkr1x4eeJY6q4xm2TAfNFBbSuTC	5351	3NKLS2csviHuuq3uQENNctmjvbUHQv6DsnTxXL9mmzz3teBW6biV	1637	816	54	1	5189	jwoqSTnd4i97dCZfeo9gWuYDHxKQ7MxpojuJaQFL1c61LaQaLoA	2778	3886	3886	1616638680000	canonical
5386	3NLsMveYea5svBasY9mxzHREM6HCshe3sXR5kpsa99eLFwbRyMuu	5383	3NLjbKNsKSnSFNTJbus5hA1SQ1G6ma9JQ5LyLXWmdoMDUK1q1a4L	1448	945	54	1	5223	jxR6zCVPhjYczLmH1XNeU7zMfNXv16hNJ2xYxPU4APLqAuVCues	2803	3919	3919	1616644620000	orphaned
5389	3NL82VzwCZLdzYUHzpeUYiWyvazuNgsiTv7DmjCu2EhsQMgX2Exu	5385	3NLam8pKmWqL1qaDBGiNxTjbUWwJgYejF5Ko8Ww5n9rD7maarc4p	1553	776	54	1	5226	jwWV7wKBhGeqJRo9ycta4YXcXzVaRuUnZV5ztX4yLvwPvPWXgMJ	2804	3920	3920	1616644800000	orphaned
5407	3NKG5MvW8qxxZc3NSYooz8b4nu6LNFqMuhymTrfuKd3ABnF2pzYE	5404	3NKsNK85gxEvnwTjiBbUkyRKf7MsqxCfWv8N5qjUCXmqJeKZ5Rf2	1593	980	54	1	5244	jwq9MMULxTekkkzrvW3f2do93Wqy433rdQ8V671DYFgmHzGCqXp	2814	3931	3931	1616646780000	orphaned
5804	3NK6Km3JfBXp49YDGt7oGETASY3iQuPaWwXbjbZu86KZ8CzQhykg	5792	3NLo3PZUFtAj2vBN2LhUAsEaiyXQorxT5Tea61kC8uh8ZoMf7ef7	1419	813	54	1	5627	jwML8tnEB9QppyS3YXxcT7qP2bqS52mqGb8tGNQnpnK3HCW2Fu1	2820	4237	4237	1616701860000	orphaned
5434	3NKRN5vGtNoEHV1nzcy7Pg13YCp8NfgtJW2ow9fyPjxgKwmbsS8a	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1627	1139	55	1	5270	jxkPBdkxjFysBq8WjG3jSHuzLAbG1fHTrzH39zeF8WzKMVqwf7m	2828	3961	3961	1616652180000	orphaned
5858	3NLmG8G7FgQ69S7CM1SyHvrPUYMUtVdVbYGykSdsrcCebNWkZa3X	5433	3NLMuSfJrs5yFNpBNFLzkJ3oxudmFVvUFZ2Wcuzt7rY7y54EhncU	1407	1395	55	1	5677	jw85SNWeLR2gvgTRkEX33EBLcJkcHTbeYbQFEjyMErK7d7yXJmf	2828	4275	4275	1616708734163	orphaned
5439	3NKGoYw4fzAxJs6ddhQV6TYJQ1uGk2yBi7gJFKZkDLBU3wC6Cjhw	5438	3NK9eKXwRw4dthQHojaUF3nU5Tkp22bLc2ckSryRLCv2rn23VaGC	633	1018	55	1	5275	jwcQoE1fej1iJF1cwzgFjVqksCk3P8eN3bAhGWPGGQwqwCC6Lku	2831	3966	3966	1616653080000	orphaned
5449	3NLYDuuTPU3Tvsaz67Ruhk1kf4dXSFETf1LAJG8WH5naeCoUjm8t	5448	3NKduCCSQDVzgwMyrGS5eG22WZufxYJbvXMYxgaAdoYtGtTTjHJr	1637	816	55	1	5285	jwW5Eck3vCtcuVZE34Fi96jYCGQ9wF8PkdX42YVnRaJMVKj2kkm	2836	3975	3975	1616654700000	canonical
5596	3NKJTKonrq4UAT5Nh4VDPbfxvGPgJwCmv7e7b4jMRVfwvNisws4D	5449	3NLYDuuTPU3Tvsaz67Ruhk1kf4dXSFETf1LAJG8WH5naeCoUjm8t	1490	1274	55	1	5427	jx2dj7toa7YMbcMaRDFT1Xt6XQ82DcgrPMQYvdyBtUAdrhyQjG1	2837	4078	4078	1616673240000	orphaned
5463	3NLY3W8euKPEveHRTDUdFXSM1yxv2nh9LkevqrHAf2WdQmwxWjuR	5462	3NLDs5u67eVE11CKvaLo5GeJQpVZd8TjgnJuSzFyRoCemrfSh83i	1643	1053	55	1	5299	jxrnjCdDZSQScpDb5CvQHQtHqZvpriKuyBVtk3cF2HHSo34D1ix	2843	3986	3986	1616656680000	canonical
5468	3NK65KBfgsH8AvgfLncgkf2MLwoWtogSkJyWVhm96H3Cv1B3eXp1	5467	3NK3khRnLvdXh9GK2z1Bf7fdYCDstqg1Gy7HSBKfne1Vgngqahkh	1489	501	55	1	5304	jwv2yD3EJ1NHBHcyHLhd1aNyBgsRrqS6KbwjgotiL99N47fxJgz	2848	3994	3994	1616658120000	canonical
5860	3NLB2T1qSNX3neFWhZP6mtxmYvTb66ZgYteuuijkP2jeRiYSZysS	5507	3NLtkhHpFHyxsSbwQAWfmCASUDEt7wgfphn32KaTGqbUuJFpfP71	1407	1395	55	1	5679	jwnjXcUNbPuWu1b1ks1V2Bd6ynrEaeDshJu3dYHDiNgcMdwe4bL	2867	4275	4275	1616708798173	orphaned
5560	3NLTUh4nKguzKb2MmE26MXmJA1jTfTcYLr8CjPP5ufKr7ZpfpAST	5512	3NLjregJ5FzAtStLPoYHzAqkCbG7jzQucce73fQ5FaNZ9mkHLkZe	311	1061	55	1	5395	jwHeX1yhfqmBAcPBMrrksfgPHbmxFYTSzpgCndYkan7yBpPakjJ	2869	4055	4055	1616669100000	orphaned
5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	5519	3NLrktb9bBjQKHjJvzC4x7zwdWo5H4L37P51J5bCWRZGRc2gcayg	1560	925	55	1	5355	jwTdbMayyLvA6nxxHbWzxbdEyFc6t9atEwkH76AEmEH6YmDdiYu	2872	4029	4029	1616664420000	canonical
5524	3NKBirhuq6vwpHraVc78aWhU2cfmYXjZpr4YEDPK8cAuzzGpkkph	5520	3NKwcAtZkcMD3bQVzNNW5Y8FzrGfLrqxrJRMuJgMz1hgERiZcRXQ	1650	1129	55	1	5359	jwky4vVXbjmeAQ8vhYPKZrmp9YaQpcy78yjzxxzm2N7hf1CDYam	2873	4030	4030	1616664600000	orphaned
5551	3NK54cFxp3Hyrj967Ci4rftdwwbHgWKtMBotcLk2aurS7dBBt1eG	5550	3NKyEr9JbycR8cgcFnMG1scfkPVEC8Hkcc2fceF7tAvuVDr1KUZU	1642	1367	55	1	5386	jwKYkfpcQjcjmJmBrH2kxWrFtYiHTiY8Q98z8SeUsY7DqwXRTWz	2887	4051	4051	1616668380000	orphaned
5559	3NLh5u1pNEuFrVmkssceejaK1hS4SQAnMJkdNn6Xu1KhncjfwKVx	5557	3NLYf3ZHdKKKaxjWoosei6u4UQsoYw1yXPyvciMKqZxCHaq5s6V7	311	1061	55	1	5394	jxcGPLqQuer5gYeHWugWEwisw1FSFjCp7UtMDNjyPDEfLZgj7PK	2891	4055	4055	1616669100000	orphaned
5567	3NKENd395sbsrNUkPDmEBYLhaLD8w7Rt39QrmAgYcQTFPxLTLzEZ	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1523	1321	55	1	5399	jwG8ZywXo7N8YvnfKhSzHTNYtK1ARoDcndU7zNJzLme7DGWnRJp	2894	4059	4059	1616669820000	orphaned
5568	3NLnnGqcW5XkzhxEF2tFVMsU2Jr3Ft7sMvsyS7FtpN388oLrENvB	5563	3NLdyqiHd3o8gKRBqMzC9d1bqt2DMpjvGBtYjDX6QsnhfQquedJA	1523	1321	55	1	5399	jxtm9NDFuRMdWKgMXTNK9PrRUco8zXryVbuyxN58NgSnJsETHWb	2894	4059	4059	1616669820000	orphaned
5587	3NLRfFsQJQpu2pJN5v2f1wcobLZq9XMjLPrqGG37bKTqnuzwj3G2	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1523	1321	55	1	5417	jwtFiJj9ycxpY8NajGs8kz7YsUZ8Ju2pXXuGrTmqXEjJHf9FsDT	2905	4075	4075	1616672700000	orphaned
5588	3NKrY9myfD64mjJ9rtJudfEWJDTRvpJp6ZY4472HEnPSuwDQYzQ7	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1406	1393	55	1	5420	jx9ghWPdyt1hdGw5Fy9xBk7EPf1JRrhp17YN6gjarDXggsSfrxT	2905	4075	4075	1616672700000	orphaned
5589	3NLpBYNuoRoM8krR2iE2kiwBoC5UdzwiUTZ7bUig6VMWtpTKYxqL	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	576	1109	55	1	5421	jxAyv5WeFP4RiZCxCR5U8F7rdLjHsvq2CWKkpji2Vdp6A3KX6Mb	2905	4075	4075	1616672700000	orphaned
5590	3NLDbjULhjAPqU1tfydkbPLHc78VTTVvwL58Sy2cqPyyKJyKMZ7M	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1590	1300	55	1	5422	jxW1ygQoNUUrvW6qjPAozNXLyai2w8owngCtiNPFsXuTQKpaJEg	2905	4075	4075	1616672700000	orphaned
5591	3NL5qkGTF2hfzk1ws2fZCb5quBNQuxqQYcRqt8LY42uMzsCtm2Jc	5583	3NKHpebUNy6hB8gKyaRyNWojySGP5Vk8WVM6679iePcEGvNQHQcX	1523	1321	55	1	5417	jx4H8ivhBMGQ95BqrcANStatjf7VaqqoywSSnEYQQ12wHpx8d5N	2905	4075	4075	1616672700000	orphaned
5612	3NLwfwYGJG3mD8msBAFzEu8ga7QanHQHHDuT3KJLVpCAWR1yVkSV	5608	3NKcFm3na745oGcqy2u6BHCbH59SgDAhZptB7Ko4nqvBEUuQtGUP	1581	777	55	1	5442	jxdg5XSjqj8QiS6G69qnQ6viAQ9JaSt9gmo5uT5QWLgXq1VqRBz	2915	4087	4087	1616674860000	orphaned
5617	3NLMqQuVgZhVyjb7PLTSj1eCbmerRME8gU27hdgLJ7akg3mYgWHQ	5615	3NL9GktPNJmmn8NnKiuzQSZyNkG8aNbT2PmyoyURyZmkxws6TCEh	1623	839	55	1	5447	jxxaFJgky6ZMKG1XuNnQeFuFWr9hRxJKWwCheQ7UD2wMAGmcdmc	2918	4092	4092	1616675760000	orphaned
6143	3NLxKMC3czHUrwseSFGkK2fRGZp4uHHSiDfPq2Y9hxt9EvkzWtaC	5628	3NKFHng472qWdCHwihKj5JKLqof6chsSmAst5RG9Whxi5gahA5k1	1649	1383	55	1	5954	jxUgwjevzY76mim3eZybnrdXW7rGmfVJfDWmtPA8ZYjfWAjzvAn	2924	4488	4488	1616747040000	orphaned
5635	3NL7grRDyy5D8REzHktayndAsodAqx5sSczB9nVN1QWxy9wTnSLv	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000	canonical
5640	3NKmcyb6XtXtonANg1Svn15qLuSspoHVzuWgYr3vWsQtoefr7yZ7	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1594	960	55	1	5466	jxieTMqFFyUJxskeYdQFdWFahsyYphLcPkVNTqJFWZgyrPhewaV	2928	4106	4106	1616678280000	orphaned
5639	3NLKeA2Qv2UJVEyaropwLn2j8D3WajjZ5Sc8vZoCW4MNTtxHDxxV	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1594	960	55	1	5466	jxieTMqFFyUJxskeYdQFdWFahsyYphLcPkVNTqJFWZgyrPhewaV	2928	4106	4106	1616678280000	orphaned
5637	3NLqpE4qeRNAYLXMxRZHsngF62YsqqtbKWfUiRnjW43NtBW36eBb	5634	3NKFW4rHAAU2mdMKYSR9Ne6cpRnrqSYwQ6iqFG8Bmru6auR4So1k	1542	1304	55	1	5465	jxcNykGVs3cCuRfez1XbvtWTGuekmed17STr2buArTSym6yQxsX	2928	4106	4106	1616678280000	orphaned
5783	3NKuPkfChCFMPwfBVGAANaeNYvX2TyLEVbrqvJ6orwa62fMmPNCa	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	532	1303	56	1	5607	jxv7ThP17Sf6NUTXeJqjrgc2V1dwWAbYFHiiAEf2ecvrmL5BZ2z	2945	4225	4225	1616699700000	orphaned
6146	3NLFxQFFMo59BombHrSWjVu8jf7gWyX14B82DVA4XyktcDXtbZj8	5679	3NKoaGnc5jEXnmFqEaWC7ronmjbTBn2tGwMJK1bSMC7asHAZ8ky9	1649	1383	56	1	5957	jxyMmy56JLRxfNKndYHwqVM2nbSFSWgDZoD2nfiPRB3dZKTP5Wf	2945	4488	4488	1616747074125	orphaned
5866	3NLV4n4u9NUJr8HCxnFSbMvtywZSaAzTJyNm7CeBimZeX65Di4ub	5783	3NKuPkfChCFMPwfBVGAANaeNYvX2TyLEVbrqvJ6orwa62fMmPNCa	532	1303	56	1	5685	jxy1Mmeic2bpBr24QAV4qVM2svDqNeteZD5C4KDNujmoDwUZ4QE	2946	4277	4277	1616709060000	orphaned
5728	3NKFUY9SuMGbykqLrdYQX4uMV1hFnAiQXNbHv4pbX9F8xb3QbQrM	5727	3NLJFwtGtuQ6st1P321xKcNcn8hqhXHZacXx3qT1NSdG8c88A4gY	1607	1348	56	1	5552	jxwTPmw1Gi7bERV8hEFYrDNkX1bUGXr8w1eukGG8TvhRWgT9pWe	2968	4167	4167	1616689260000	canonical
5735	3NK7RHLR2a4bKqaeNVL8XQV8atULddcixtNuWY6GodV4FaJnnMFZ	5731	3NKDQN6iZvXA3uf4R2THNEk2XnU2AUdmcaUN1sSbg531dJ9Sj2XL	1649	1137	56	1	5559	jxerZgGkj7GffbGKZre8RgiQN1oR5PeEj3wpirU2qKdrPEqKMQh	2971	4173	4173	1616690340000	orphaned
5741	3NLseHynzg4givDNtwKoBsw92T7upPgJGqrY5qNwf5ars55ffrJP	5740	3NL4oYPDn6UkdZGpMe6ADyaB9iTCepDEzbLPc1s7A8obkN8ReQMz	1670	1156	56	1	5565	jwCsszgMB89WfknYYXkoJXE3ZUXKYqyCffDUzGcdGRbDhZLya9F	2975	4179	4179	1616691420000	canonical
5745	3NKEn9K5PYTxKGdFB9DQ8sQciA6FxK6wxVBg7HPFpPRBhM4FDxLH	5744	3NKGvuQTkxGDLJqNVCrapq1VZh9T7Ersvgm2zVzYz8qFUUy4L7cG	1671	1239	56	1	5569	jwFUtGGpG4wXXYyGnAK8k3NmNyHV8mN3dVUzaC9rrGoLPi2yz8U	2977	4182	4182	1616691960000	canonical
5752	3NL8C51A5Y8fwHmMchB2SFPWa1n7yxFmaeg3GAPk85AXdZr1PD1h	5751	3NLuz8jZh9btjqyG9sXi5Akz1qfkD5an74ZmpAeDgdQQZRrD9CLy	1624	1088	56	1	5576	jxV1Y4Ca3z1eFgQKJ7qMFw8oL6Q28RzXmM3qT5qWMjrvr2cUBoK	2982	4187	4187	1616692860000	canonical
6149	3NKFH4mHrC1TH5RGhLVy3SvLzuXLo4aWRfYVtiC6P52z73SV9qPb	5780	3NLvbgxVtrcH1VoWcxQpMyBERHmrnJzJ4sb26StczLzDeLtFVX6X	1649	1383	57	1	5960	jxCG923VtVMTYQkikTfyEN7GqrjFN5bZE8dVwFcN46mb7PabQaV	3000	4488	4488	1616747169815	orphaned
5789	3NKAMvE7RZvT96HgiAmqjUwoFx6bRaztDyTo2sNbc2xDnaEiecHv	5784	3NLAgdmNj9EN7hZZZCW3jQJazgY25rxo5oNhWwuV1w6TGvfrNHq9	1553	775	57	1	5613	jwhkUE36P4Es6XwS6uuS9ZWcZviP4LfCa9jgJVok7Y9h2La8qzb	3003	4226	4226	1616699880000	orphaned
6010	3NLSn6wQTfuouV5aUBwrEG4pLSbNLsE5N5pNMLAGDEd6JJSz11UF	5800	3NKRJhknJAZFFCnQz9uy2VEAvF8zv57ruiiKoHve2EpEEBPXr5sT	1508	1021	57	1	5826	jxz82Mz9QnsZ2iW2LRM4AcJ92Pf3WSEAyGCkN1d6mBpfkhRPszY	3010	4395	4395	1616730300000	orphaned
6105	3NKooPubRhAQbAJbNrXLSoFr5hB1AJrMMMaLbsRbpPSdfM5E6Gpz	6010	3NLSn6wQTfuouV5aUBwrEG4pLSbNLsE5N5pNMLAGDEd6JJSz11UF	1508	1021	57	1	5920	jwFfsEMXH23e8XDXxMmCJ3McGmPu5stLa6jP7dqf87t8G7v6gVK	3011	4466	4466	1616743080000	orphaned
6232	3NKUMxiy6WnQ7nAsv6NUxELnQn4DHwZC43ZvsUc6KU65kD9SGkus	6105	3NKooPubRhAQbAJbNrXLSoFr5hB1AJrMMMaLbsRbpPSdfM5E6Gpz	1508	1141	57	1	6040	jwpB81CVUXPrZhBKGgoFN1GmYR8tdbpWWpg5ai3wh7LWTnCRMeC	3012	4549	4549	1616758020000	orphaned
6334	3NLXJvBfepFZZD6RXDGxMNA11df276nqMRRwQAFKMX884cRtVAWn	6303	3NL7o18c4EEHYNgJRF6weVqZqjmLvdokPu4sZ3t2mQX2hPTStQyj	1508	1021	57	1	6137	jxbmfBvSqJho6yJwex6fQwkuq1HUNCt2iomyReaiuTPo7EjaDDf	3014	4629	4629	1616772420000	orphaned
5832	3NLY2iZSAfK8dJHMT83oVWXMGqR1HKfZkUY62ugNpHtHj76CUaug	5830	3NLX2YUQJLyL9s61kMkQwRe2vZUhdLxBM7XK7yRm7gZGVzRvtsmH	1457	1025	57	1	5653	jwWupMnsEFobY6MMWT5wAgrjabr2vXaZxVmCNRa43MYx2Fyohuh	3026	4257	4257	1616705460000	orphaned
5840	3NKbLHmY5jtgtoWQo41umAg741KhRBssTUZsCNS4t17JgFPPnBEn	5835	3NKMT6VEf8pkECfijVVwJnHEbBnFJuUwFTGtAnhZGkoH8XZrV61Y	1474	1083	57	1	5658	jwPCtLMx3tnpGc3kKQanHPwScBxmraE29zwE7CZKHn5mPZN8nkA	3029	4261	4261	1616706180000	orphaned
5852	3NLf7YJoxYJsLuq67X9P9gUbeTCsPTXHeCJZAM1v3zteHVve49zD	5850	3NLVp7PdDf9ubyBoBMMhgWz1TqzsRDijhD2HKYKiJvw5Ntziozwj	1402	850	58	1	5671	jwJ8Zs27juE9f9DrtfDSZHQ3bQNdGpmZpX9fHkbUJukQ9qn4ofP	3036	4270	4270	1616707800000	canonical
5853	3NKCHn1vX2jc1kmNHTuGP5eZ2LHcDs8Godx73QYDrNqW6KjCwzFw	5852	3NLf7YJoxYJsLuq67X9P9gUbeTCsPTXHeCJZAM1v3zteHVve49zD	1637	816	58	1	5672	jx6AKUn1o9xQEmyxRfQWVG2diuksQZG3VAaVQFaXb93jxmbfrps	3037	4272	4272	1616708160000	canonical
5867	3NLM7fjaKZqbHiFcbfvTbgNi5EqHsLT8ghaQigd4FLmtSGuLdZ8T	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	532	1303	58	1	5686	jxSqNHP8jFaE4Awgmo51DYnqs3fjj9PL3WtVKsez9yD92jXuvSJ	3040	4277	4277	1616709060000	orphaned
5862	3NL2C71gvaFwFRQa6nNdZcZqE9LXs3ZKmMQ7zXPhWppB7K8Qx9bc	5857	3NK9WwsSmpwhBn9bGAzhh9dZ5gLDS1i5h8LptzBASL6GmRjsgnjo	1407	1395	58	1	5681	jwFz1L7eTVxabvVtrr91Y8tGPQY8BuXTqj2xBaQ4UYzePK4Ss4p	3040	4277	4277	1616709060000	orphaned
5871	3NLtErv9ttGYTqJXByEy9Wid3k8nfgZQtGfhDTkrxvKS1E6bFLyM	5870	3NKDsRVh7gdFGBNLgG2H4LN4AnbNmYtx6QyBM1E7iHX44eMvLZF5	311	941	58	1	5690	jwfbisg1CpQbJrLUdqYrY3mG92uhrKmLTzo7DaEq4vAUdHEA7AT	3043	4283	4283	1616710140000	canonical
6339	3NLr2JZAPqhFMV9NG6oJafBPTa5ZJmp4k2kiRWA5ZpoSyJQRB6yQ	5876	3NLRwcHjQK75mTPMJ1FL4hNymVpVSYxVwqPYnfQZ4TzBS6Ktzyqh	1571	1335	58	1	6142	jxauTf5eAhu8cb2VazFgv7wDbHWh2oEkzjNZJdTAjecSNeWXnad	3048	4632	4632	1616772960000	orphaned
6422	3NKEfbdGktE7Zja2ebAhSyrLGZu1vBhjfdnQWVbNppfPELbJq9vr	6346	3NLf65X5WP51esqP2BythGUQgJm7WQiq4n6vo5SoiXYNNjgqpgvP	1571	1335	60	1	6222	jxhaMpY6W8HoQQYpt7mXHJKK58KEsc33ifoM4xD5VwvXS9iWZB5	3050	4702	4702	1616785560000	orphaned
5893	3NLYkRzqaTpPt24aQwfATXZQN83nEfh6KEfJaG5o7rAGdYVxbjbL	5888	3NKC2DzvVorndfwuhsXVEi8v5ix7cuvMzKxNh2NNRXqQpzcQnMkL	1611	1341	58	1	5711	jx7opdK6cWHnUAtE7pMGqzZxMCXmpYKzDGf8dp5HBJKvpPwFAee	3054	4303	4303	1616713740000	orphaned
5901	3NLuLUTE5WX4TSShkGhFK9Vs5mjAVwJkcisoYy2e6qWf3UeRs3Lb	5900	3NL2JU2yhwqRBibvqmEeyZcD6X57GRW53MJDe4yMYcFNzVkvMhgd	1637	816	58	1	5719	jwYKcTxn3WgQYj27tFwxb4iobhr2uUr3ZKTCcoQgnEApnSuKz9c	3059	4312	4312	1616715360000	canonical
5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	5901	3NLuLUTE5WX4TSShkGhFK9Vs5mjAVwJkcisoYy2e6qWf3UeRs3Lb	80	1273	58	1	5720	jxmBtn6iioCQG1Gebb8Mo32mJeQdsbL8h1wgbQSGYufUAU8xdNy	3060	4313	4313	1616715540000	canonical
5907	3NKhge5CYUf6CD5TTFE4becD3JKe13cVkbZce1wi8bYyxNmxNXoL	5902	3NKrR7PuHuW91eApyJYxspiTxVSDx4BryuvP2Zsa7AADaRtzYLBA	1493	614	58	1	5725	jwo2LxJAomCqbx2kk4B5jqKe7fFmjgAxkcqys1vhUJPi7VdY52c	3061	4314	4314	1616715720000	orphaned
5919	3NL4akQkVaJS8NKjRmHDgY9YrY9SfYiSNa4fAsTv3iiHf8r3yVoG	5914	3NKm389wvZN3vpSHj7UYz1rZYEgRNmqCpXrsf9RCd6X3BFrFC1Pn	393	393	59	1	5737	jxSHeucsKPp8mYY4AjzMXkYL3u4wAqRN7gLJZ6AZi9TZHzKrCHW	3067	4323	4323	1616717340000	orphaned
5960	3NKv3Q1aCmYDeExC5Q2tNqTEx4JavqHPaoH1CRS1v82wNHAg7E3n	5959	3NKXzZowXt9wEPFkYCGk1QTS2WS5CuW2cTVwepm68N9q4wv5ZQPN	1581	778	59	1	5778	jwnH4hwk5RjRCiyzpnUdpY7EzeESwjeZNcTSJXeoHMMfdDmXg8J	3091	4356	4356	1616723280000	canonical
6516	3NKLHPefwSiCzW38wyHcsF8mxGAW1A3JwqkCbVsyxEyF8mBJeNb1	5960	3NKv3Q1aCmYDeExC5Q2tNqTEx4JavqHPaoH1CRS1v82wNHAg7E3n	1647	1056	59	1	5778	jxxAEeyKCdGBEuGvUYkqhBLGF41EcjsTqJrtBCP3WZfCjszf5Au	3092	4769	4769	1616797620000	orphaned
5965	3NLMuLgUz9jxXGhUF9NQXeemN3zSYBNfvoZ1BMra11uVYpjAugQf	5961	3NLSwYEtjzJ6wSAv4HvVHF3Hq7rRm56SAiT6EgGJb6knB2EG6jbU	1560	1165	59	1	5783	jxfqBRtBBJf26V6EALu7HSmzfjwFs3YoFsJrEniLdGWqdridf3t	3093	4359	4359	1616723820000	orphaned
6051	3NKW9X8pM9R2hUPnM1hR4ZmvH7nAS81q4AJrfdwWC3jaoHA5ryNT	5974	3NLHpEgCa1tMBZWRv3T3eCewMHj7P2WhBWsyCKH3B9SbRiuvfe6Z	1647	1302	59	1	5866	jwXEjmgFdbgnfdwEjrM9gEtDsmNEG7eniBEAsEDWjziPXmRydSe	3100	4429	4429	1616736420000	orphaned
5992	3NLkEMYAWuMgeunYBwDb56GrwcMbTabSwmJjaLP39GsYq2P1hfUn	5991	3NK2zkbQa3PnSw2Ea7ZJwX5C23jo2VMpqDjQZMDq21pH7ApB8BY6	1407	1395	60	1	5808	jxJK2cZrSV9rvXsraHVHySeRt9Fw9ahxZciCxG6twRnjPwJPxou	3109	4379	4379	1616727420000	canonical
6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	6025	3NLbmqaqToMWKs5kEDtUs1hpikNfEn7Hegtsg4MFbpJx8Vy9Fi6s	1403	786	60	1	5842	jx5nrGYxk29peTwRJjtBqrfE3yVy3vgA4zbqAepUC8XsG4NkB5o	3127	4409	4409	1616732820000	canonical
6028	3NKoZ9KPTqBx79hs9EfZTKvvj5Y8fPwKNxuz9v6PaRFyZuKV92sQ	6026	3NKni4fLPyU4oCE8hcUgVqANj8zPHPmGPKyVB4qd5C3e3fkuz7Ay	1407	1395	60	1	5844	jxMty5Pf59SaApNE4XKVUgmRiTUvbfAZXVAngc5CXcm1GoekG9a	3128	4412	4412	1616733360000	orphaned
6039	3NLMNtJCyQGS89BEKhuesTCiRGKx8co7EfbeWjYyuojUPZTsGetk	6038	3NLio5Eh7tKEBCQnkwjpZdEjG6hxnPS9cviQX8So42KrWh4sXWXz	58	1281	60	1	5855	jxDZEtkAaiDr959oqhMUfDida8zknfLjVjL3kc9iv2i4SP1athr	3136	4420	4420	1616734800000	canonical
6627	3NLeC5vnWdW59QzpSkNdEJ46iZ9pgKhwSvNgdqgqwfAQEXsG85EN	6039	3NLMNtJCyQGS89BEKhuesTCiRGKx8co7EfbeWjYyuojUPZTsGetk	1402	874	60	1	5855	jwxZ5yGnHCuCKGCjvBGp8UpMQuGo8awGjr4DqKUGZmR4BbmqLhX	3137	4834	4834	1616809389329	orphaned
6628	3NLGTbLxAyRQLECTKXHUGGvA7GCrsh9NMNUTrNDd4aRvB97zzrUf	6047	3NLZmhwtUpBAUCSWQVewH1JeQnq1UFQc9CgJq8D35WGEufAzM2WE	1402	874	61	1	5862	jxLRZoM1LoNTBW7M5nb3ovieikwiCJL2DnCaL7PiZMpiRWrf42X	3143	4834	4834	1616809425608	orphaned
6629	3NLrCEmpyGVAsw5FeqgRz4snY1L8pT1a3FCsUyHtDmVx77hLG6e4	6055	3NKnkZ3MUuUfZa83ji1oy7tpLnh6cyqi1yYis5Qwy6qbB2rAoUue	1402	874	61	1	5870	jwBfd6rkysdzXjbYLDpQHXaA5RnyxVmsLhV25iNycMnBYxHer9o	3147	4834	4834	1616809461122	orphaned
6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	6072	3NLDGZ946xgmF9D17qYrAB4aHg3feRLhdXTEk8VMq41Hfgk1vZ5Z	1549	996	61	1	5889	jx6LSgRmtnP5uQhi8XHf7J8GC6QvqEcgsT2Ns8KWBSj3YHVrHtC	3155	4446	4446	1616739480000	canonical
6078	3NKQzrG922eo9qmHDLNCtvmDdZa65xKFjj9FHABMbmmG4znwqsYb	6074	3NL24KtGH3RJyB7fPTNj9WVgETwxxokvpnFRhV2rBQjGtvV2gGxr	1509	1320	61	1	5893	jwFad1fJnCBjoJEuWmVXsNaQzSAqwkA6Qvbt7wU8inN3ht8skpd	3156	4448	4448	1616739840000	orphaned
6102	3NK3wBvXFpGfuWW4HaKDNLwoTn9vJZUrte8tWVjGHb5PMRqH4grL	6101	3NKgt2BLJr4Aj12jRqMchh1QN9oGw547C3mCceR8nrkh18mwuUBy	1529	1316	61	1	5917	jw7XkhbrFRtNTGC8tdgMuaRLfjiuMXk3HaRPC3qXSqRtDzM7Uar	3167	4466	4466	1616743080000	orphaned
6109	3NKsjxH43BFueWrqiezrtF1YMEahftxRufKBtpSfmwZkgjy6b7aY	6104	3NKV4jwZRQqapdLtxYpu6QJgxRrKRodbA65RVgCKDmqkjxzcneGU	1445	480	61	1	5924	jxXmHVA94rHR7tkefHkFA4Vb4BrVEjE2ET99bCJZYw4aGpTuJ4U	3168	4468	4468	1616743440000	orphaned
6120	3NLdrzRDgKFNN6FuoQR2Ap8DqDoNtfz9Ax4V4Vgh9mRg5BQ7bWJt	6118	3NLwWmUvYH6YrYVvuXJNpWfrGRuKPrCvrHqmCoF8prZp3xdXjr7N	369	1066	62	1	5933	jwYiNp3evFEy8TSrZcYDb12XDe72RVCPTAHY2EKVfkDFoLT72u3	3173	4475	4475	1616744700000	orphaned
6128	3NKspde1cRtTdAHkEQE2AzRt9y8THd6iBqohrGP9pBz8K8sik5C8	6125	3NLXPFURft25gSjHnnGvWsAnZ4wxaBCRUCM6iydjnLvdZeCCt3C1	43	944	62	1	5940	jx24Ee41w69CcMn7zGdWSXnKviPTaPzjsHtm4idTsQYaNi11XkZ	3178	4481	4481	1616745780000	orphaned
6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	6138	3NLsyNydR7u45FqUk5E4zSwgJyrsSwenfgoY7PGnsF47JWgTkSH9	1546	973	62	1	5950	jxRXiQLicJwPqGh1jXt6pXb7Ejz9Wfkazedau8dAvDuRytK8y3D	3183	4486	4486	1616746680000	canonical
6141	3NKydE1GMF38JSdest46AFg1vKzkF9eZGPDMyH5fGE6yV2TtgVnZ	6139	3NKbreu3aANBfzawWAhFHVfJdmfe7A42fuWN5rdjSrA1GwqMxDDR	1522	1322	62	1	5952	jwQdKUabyHZd28xz1VEcJFrm58TvnUNhdK2jh17anjgQqYP7qxa	3184	4487	4487	1616746860000	orphaned
6360	3NKUPPTYRsf5fwTbXmTHH2aNhPMDE1ZCG3W5fLrHQrZtWd8w78Wp	6140	3NLpyht84M6WrggdPJtkt4R3pVaJd7zDXWRUU7BHecsjBv5aVpuZ	676	676	62	1	6163	jxv3fHxPmAcNi7foTP4WwFHJi9eKnsXT3mTYfcz93KSFnG8mMLz	3185	4650	4650	1616776200000	orphaned
6186	3NKZoVsTttDjnWbwe4yeVaW1rPHhcsxQ1eUVUfdp3D49pv3hTqmJ	6185	3NKsTiXcuyQcwxYRHkwUtcSzUpnmTyhXyk6XPuyUFuWyvY4ZtgpH	1397	828	62	1	5997	jxMFTyUDiPUQpXNBanJmP5QyDyoNzqsWMDoUq33LQXmLcfEuxT1	3203	4518	4518	1616752440000	canonical
6191	3NKJWdij12jDY6vWQCccMRpEvgx6NpU3g15WVQo8wa776rFJJgb6	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	1587	1111	62	1	6001	jxH2WBAui99XrdS5Knfaou1nUCP9aVLFE3hSexg2jxxjirT9aUS	3205	4520	4520	1616752800000	orphaned
6192	3NL9Km16w9br5pUnE2V7F6VtnEXTGtB8AmQp7vzkRVNvRwroa7r7	6187	3NKej9EhTUsEZSF4t5uDHqoapW7psgTQeidLjQ1zUyPR79sNgkJe	1519	863	62	1	6002	jwxQ8mzqp6ugvJ3FFVXk7WSfcvvp32VSf9HmfodFSSt1DjGqdGE	3205	4520	4520	1616752800000	orphaned
6199	3NLqa4P9HB1jZdvTT4vVgsHbEcpduYn4Lzy3jR8tRTCb2oy3b656	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1673	1242	62	1	6008	jwMeFdXmgWSqFP9M7frJKyfu9iBwUSvEi1qDgeFkQFjiwFftY7A	3208	4524	4524	1616753520000	orphaned
6200	3NLJrrtZ3zeE8v4Q295SHrEXsRK3RDQCwTYwSGzpRcfJh7sagnSC	6194	3NKzqCzB7XdoqEQBfrzhg4RzsbGzP84XvDbF2XJp9b6nXwDSAJ2s	1523	1321	62	1	6006	jwZ1MubbhvMHA7MJkjjWyMP9BXvUv17qfaKaoAbJhGW3QQJZyck	3208	4524	4524	1616753520000	orphaned
6228	3NLXsYLKC5kB38wdemjhQPkJWPz4EtDfwXnFgFb6uzKW5jk7roQC	6206	3NLLPYXtqgWV4EsPZkPZs1Fs2kbUaJ8BEehKCosU66Y7V9GHepbZ	1476	1125	63	1	6036	jwYgRVC5WJ73YpP2jx7rMCppF351drVWdWtGzYbc3NaQmRQ2orf	3213	4545	4545	1616757300000	orphaned
6211	3NKA6riDf9vkkHGvjmueRvqZM3zehYuSaqa1DxDH7HwGRgSFRbCD	6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	1593	1346	63	1	6019	jxDzN8nBziesrUh4HxBry2zFmZzi8nUHLgbNx2RjoqeppguWF2L	3214	4531	4531	1616754780000	canonical
6210	3NKrVTYxBZniaZz4Xr9xdPpucpnEypb4iAMKatM5KhuxNke3iJRo	6208	3NKGQi1c51RVUp29mQh5PtxZNhy6UsWZA12ufigCGWkdGBo39wkq	1461	1271	63	1	6018	jwKfe4u1sUpd5woHvm3nAJPrtbnnduw3YWEAcz52sgKdcamuPHA	3214	4531	4531	1616754780000	orphaned
6237	3NKqejwQFBhatEkTrVhKiNsC7e2iKZAkRwxkKxGnncJNH16X7pKE	6233	3NLs5fYzagXTHc6u5XFCWeZnwGAbmtrrrW5sXNDrgVTQYVRSydkR	42	1361	63	1	6045	jwE7sqFSXXR9m6bfmxfFknJyZpsfTY14kNdrcmung6anLPH9dXg	3226	4552	4552	1616758560000	orphaned
6245	3NLQa4xQgwNTryuSrZ6CfLBbn7Ysv3UgEtHK5ZynqRgL4wSHiNiP	6242	3NKjh9Nb4oWijuhGhPSzQ3SBVkMYxamFcgzYfKNvurPTr3nmWVAD	1675	1342	63	1	6053	jxbLY9NgzftwpzW5TAXZoHGvrXTX12dfqt7K5tTtJqTJbj45oyf	3230	4558	4558	1616759640000	orphaned
6262	3NLH6i2zgRBdFfnHRSHgJYiwgcoLCuNgcsPJR4Z8GvpyEqPatb59	6260	3NLNPVMELFG3DSZT3wBvp9KD3SydKicHYW3EyhURgPnVbFvyDrTV	43	1310	64	1	6070	jwhSE4BGqyrMcopSzD76eAvNUgGtQqGTgqWW2rc11ZXb7bEGn21	3243	4577	4577	1616763060000	orphaned
6488	3NLRPfcSo6QCA4LmLAZmABVHyFQKX84MGNbTjsJFSC8k14m59H48	6285	3NKPXUrmgfjxAiYGV6VoCrawPAFV768EfnaoGm2682mz3GGrps1E	689	689	64	1	6288	jwyrVwtfnUm9gAXvQPNFnHkLJJ8XN12io7CTkABC23K8ERzX8DV	3256	4751	4751	1616794380000	orphaned
6294	3NKPaGMMdyTSt6ECSc6q7aTuGMJG2ojrST1YCtWCwpedAzhQ8koS	6290	3NLUPAEeBXTstRnZb7aTXCS6k1Es3zGLNpCvP6EKdq1WjWt9A1Lu	1622	1110	64	1	6100	jxXWEmZJ4QkmW1x5Kcy3LLpgJSwZ4qoBCE3wkDTUCsJiBg6W5gW	3260	4602	4602	1616767560000	orphaned
6299	3NLD2tfEi59PwSn4zgmmcxY8Q6cFbyaGHPFW8znzUsRnnx2RfCVF	6292	3NKXHPrMFrMHmyWvEm7MpMsX3pAm3xGVv9BLQsqCtXZuL1vfr2C9	1651	462	64	1	6105	jwZHuEkjq57BW7xWzJ9aUG99vnax4oJYnnig9PYHMy3YY2Y8C6b	3261	4603	4603	1616767740000	orphaned
6330	3NKnWSGsK4aDsZjNyNyc2CYDV8FQRY84GDLmFKEvqRLL5PxpoKWS	6329	3NKUn8XQ8tikT5wMr2Vy9yWhUnDwfXjmNMpzxgnbDrkqS5YjLffV	1593	1220	64	1	6135	jxHhKaBAj8NcqnUhoqYPXS6g5bnLpQHGTLYtr77SUaJ6978UcEX	3277	4627	4627	1616772060000	canonical
6337	3NKxiMi3pLxtVBUYiqB5j8d2AmBCLv9pVUGacxiXemTUC5fucqgm	6336	3NLKiV6LiXhtZnn8tiYM2sB4rGUwnrRChWCCABYjAXWbqXhbaTSe	1405	867	65	1	6140	jwajgjK9U7mvsdmK4MEGR4kMQHWTBXE5utmAkTVtSGboc95J1fC	3280	4630	4630	1616772600000	canonical
6405	3NLQyLeFAzx4RGFCJi5de8wvUnqNbPdRtdyEvvuJsYZBXmnRGnnv	6337	3NKxiMi3pLxtVBUYiqB5j8d2AmBCLv9pVUGacxiXemTUC5fucqgm	1623	839	65	1	6207	jxWXqwhbhbVXA4kRBgrJfFu2siWNgyEADH33YtRtFVseWUta53P	3281	4688	4688	1616783040000	orphaned
6342	3NKoNHLpEnN8umcPCyNjhUEvMTRTF5f1CQSVGnBwNV6zf67V42o2	6338	3NLRX5qY4fxsCQNHaPCriM39p56XUSb45NxFKsL9xJ8QMPaGRNf7	1631	794	65	1	6145	jwirejEpLNTS5fYv4HJfDNhCVYoPyUCkh6LCXVvz17c8mV7a3pd	3282	4633	4633	1616773140000	orphaned
6426	3NLk2a63Z3WnfxKaL92EZqt6xxyr5KDjrVHuLAhcSSGfRsQrsdxj	6405	3NLQyLeFAzx4RGFCJi5de8wvUnqNbPdRtdyEvvuJsYZBXmnRGnnv	1623	830	65	1	6226	jxJ2mFAP2Z6fBC9rSRFmNh8TZcXgaTDHS5BHCaF2mL78hpHaFtj	3282	4704	4704	1616785920000	orphaned
6728	3NKZThnpm9kzPJtCddbyxpXBXg83X9pnc9LmsqpZfUuHunYGM2JP	6689	3NKrJoEnaVvkoiyk4SMjjH8MRputkwEThybfUZYHTYsVxQsvteUb	1623	830	65	1	6226	jxUUKZAQD5nWHp2Dd4np1dA2YVUCiJZSHxTdkYcKftn8T6kMWMm	3284	4918	4918	1616824440000	orphaned
6785	3NKeBUzSuuvhQrUUK8gNSFYwWXGDh4X8RMVF3i2KyfJFRDb4fe1C	6728	3NKZThnpm9kzPJtCddbyxpXBXg83X9pnc9LmsqpZfUuHunYGM2JP	1623	830	65	1	6226	jwSLeFvkSUYKEzikkChpPHZtcmUp2mARGkaKFSwQjvuaSS3aAZV	3285	4957	4957	1616831460000	orphaned
6364	3NLA7dUfcjJDnYPYvBJVRbnhkeHiqz1MKX9gNnBPyNhxnfXJyQr1	6362	3NLNNJwshfRG4NToQvge6mtfCKZXPEeJXRJTfMA1saSet5PBW42q	412	412	65	1	6167	jxLTD3xEVBw3fDcxtXt7C6swPVDkKj7VyNA5EMocxndbePUgkpR	3295	4652	4652	1616776560000	canonical
6371	3NLfneSiSF3FumR6jNsfQKt2DTh74hARtMtmSxqDPiXTJTZGaxLL	6370	3NKUaJkcN94jF1EPNovfriCYHfof6sRV9WDp8ZDY4zkQ74e7eFdN	1549	1362	65	1	6174	jwuwKCDZfKndMKFGfVdY5ZuzUYP3dc4uRZcUeAKTiqNYvGtLCDR	3300	4659	4659	1616777820000	canonical
6380	3NLJxQ84rVUaN6a7XNpVo6xv8MGihWnMCu9BUb2bFK5f4tdx1UNw	6379	3NLfNtEVDx7iuJ9YaWdaKNp1vwhXisC2Cj4rTo2meXpTkAgL3D1F	1501	1360	65	1	6183	jx5TziasHAKKVqC73uaKCrBveFSUVBCDnFecgfZYpm2WnJCvjo1	3305	4667	4667	1616779260000	canonical
6435	3NKKCVkoiAHAuZHCNXHFH5JJJ4JdWhV8bJMXcd89XzjtQW8CzNhU	6431	3NLp4DersEq4VkPqLGG329neSjjunEogniWALKVGd6cer6jX6BNc	1581	778	66	1	6235	jxbxMYPK5Hsg7yYG7ga7JUWGsuY4Y4YXMR9CNMACtXD7apy12hZ	3330	4708	4708	1616786640000	orphaned
6446	3NK9Fjao522VceumzpUM4hKgKSdgzeKGaVvFnh7ccxDFeX83iQWG	6444	3NLxCMTBhDsww6PD8AjFo5LxFp1uZJqycM691YYzy3SniSf1qguk	1671	1365	66	1	6246	jwjhjjUZ2yKwmLz1gwxR5oqvPd4JDri9w5wwEEbUoszpYDLL7Tt	3336	4718	4718	1616788440000	canonical
6462	3NLLaGHBiMBicaNRLbdBayBHtZzGoXPEAcmvJnKHtEkFr1QByq1C	6458	3NLp3EuXrXa9eqDtAcsjE7ddGaxesfVkzJnCt141VUwPKkYikCob	1647	481	67	1	6262	jwrKdW1dgiYj47qtYw1gEDG73PRNA16PUKF5bHCzKZC4xtEPB6t	3347	4732	4732	1616790960000	orphaned
6471	3NKtK4ksUVuxWMonq68sy8XtZLk3C7yReDA34XJdjbjhNEuBZ4fP	6470	3NKQAeMRDvMcNDC58mB7onQYB6y8hboTCzkcgGm6QgJuPzfPmGwL	1403	782	67	1	6271	jwpVFkRgo1fSr5YndKXo4U3s3pnjrSDcL39pYciTwiPrxBDFLq6	3354	4741	4741	1616792580000	canonical
6480	3NK43XiwJ8uUVsjD8gWeaYmHLYgF37gdt24tV37Ekp1zGpHxiv9N	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	1448	1311	67	1	6280	jwLSDoJ28VWCW446kpvDGDRiDEpjHBGBv64ssaAFmA7gzfvmWok	3359	4747	4747	1616793660000	orphaned
6479	3NLNnavKdkp5gJ9kZxZHBoRRgD5TLmdDS5J4s9mGfEyULccAD3r5	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	1467	1130	67	1	6279	jxuo6YhwjLdUwbRrtbG8p8fDfJ2T3EWfCD8i8b3LQispqLxX3vT	3359	4747	4747	1616793660000	orphaned
6481	3NKEMM58Bpq5xnSjtc2HuKCmHU3AChKh25eS34PbNgkb85U26sTu	6478	3NLEFsJwoBD1cQmW5PA7zbrJCvG9a1uYk1kS3iuAfUshb9ygC95H	171	1374	67	1	6281	jxEPLkscTZsMJq9bkoGjn1FkW9wxq2qrrrziGkWyJGAkf8QcXvt	3359	4747	4747	1616793660000	orphaned
6889	3NKqAcW6P4kv6a5khfma6PQg1qugt564hH1WQ5XqNMFJhs8nN4QU	6706	3NKBDXqYpdvanNdBj3zqEGKqJyCLGrNeJAbmaaACGLqHjfCer7w4	1581	778	67	1	6290	jxWpqTRKa3Lg3zJ2Fa48Bz47eSgQWBn6HJXaUY7nvEKfzBKAhw7	3370	5024	5024	1616843520000	orphaned
6503	3NKEd44xY18FQCPKCTPZFHvkg1GAfSDJrDT4fSYYqoHKbZ8m1evq	6502	3NLNDA6XwJKM4dA4QC1qSNunrxgxE5F5Ah5eq1ihSLtqw2LCbJc5	1403	786	67	1	6301	jwPmPqWtfiUB28vozq2N4yPgDWRqs1T1EMHatbztmZuTdnZGTa1	3371	4761	4761	1616796180000	orphaned
6894	3NLswoPtQQAheysxfnTzHAuXh1BVcqFJmLtf4VKHVCVCgUjtYX31	6889	3NKqAcW6P4kv6a5khfma6PQg1qugt564hH1WQ5XqNMFJhs8nN4QU	1581	778	67	1	6290	jxrtePUtSM5nh44iUcNL9HJcdJuXw6ULLuVLLCiNxfmNARnQBk2	3371	5029	5029	1616844420000	orphaned
6944	3NKUmqbHoAcbe6bw32RfUk2WLfNd7wsHqcjbMDTbngzE2d4RoyYB	6897	3NLhPoNsa8aPC2UVzM6juqhrFkNwr1oCgdUgaJxuwVpj6S75iT35	1581	778	67	1	6290	jwbugkmv5RiR86cmK9qrT412NSSGY1EyFkFmh6RdeF7YPagThEa	3373	5056	5056	1616849280000	orphaned
6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	6506	3NKcSQ78EpBc4PtaWp7qfQ3Cyq5Z1HAoFvshWVbFNhSey6awUbMt	1406	1393	68	1	6301	jwmZChXPV3fiNvJvpvCwCHQoosNcoHovXMh75grapXKufYEBAFm	3374	4765	4765	1616796900000	canonical
6511	3NKSqEyyCqJdmHKigUXK8j5m4CaXt6nbN5AxsAZ8DCA2dCgftPAN	6507	3NLoDRSxh6QJo9cn9fwymDqNhJoVpAm9q1mYRETQU5z4UdZzV1sX	1651	935	68	1	6301	jxNuH6yXQ4gCrie1Nx6oskisZfXYV2jugU8EF8f7eSDw3yWnwPu	3375	4766	4766	1616797080000	orphaned
7063	3NKS73bzb2oYTpEZayVFdZSTHBuND3q3b6oE3g8mA3cYe61bNATT	6948	3NLk7B3qroqqPJ1r9gdrqBEZ5g7DRwaeotNisWju65cp2F1XstNE	1581	778	67	1	6290	jx7ZZ7pWEFLLb2GjCbcbkXziGEif76hLjfqjn6UsJddSShw9TJp	3375	5145	5145	1616865300000	orphaned
6545	3NLk2rAyR1NLANWPvnpcL7JdQMdpAeypmFDDyycdppTGotRRbw2a	6538	3NLNp3VCcy2dCtU9pkH8rLuGXyEmXh5wR2VxVSafJSrXpsHKdFCM	1481	790	68	1	6301	jxCf2QdzFnryq8CJYu6NRepCv7TVfTiJV8e5gFcz8ZmjCdcKuSN	3388	4784	4784	1616800320000	orphaned
6720	3NK5pERoyog1nZZaKGyFCVok64W4iMsE2jej1NmcHQJqMmX5DAVS	6564	3NLUCbRvW9VgdEBqUHjviMHRp7DFydLQS6qbok66r5MTuLoSiWAF	1481	790	68	1	6301	jxctEjFLGuVyBd1RE7pgXxwTtwaoH2XXjTqkr68VrqRR86qgS4V	3390	4914	4914	1616823720000	orphaned
6563	3NLS7tPK8WEVn9iksLLFFk28f5EsU8Snaw4H6a8b3tbaDw2yM6U8	6559	3NKxVEgzDHfoCyDKJu27oCHJcmjC99Dfw9zqc2RGEDA6Q3rL1Vag	1522	1322	68	1	6301	jxw16wdsKUhJzT4dwHGLuRdcJjrR2XmQcRBBeBYg5fCL3ENpJ7Y	3399	4793	4793	1616801940000	orphaned
6579	3NKkf3q768NKarGjWxB4YxiB1at5o2qhHAB3PT5taCjTxSbACv7j	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	311	1307	69	1	6301	jwEtDUAzUFsYSmo9Zik2vx8WaNWWip7xyuk8rKT6UkDUJspGNhb	3405	4800	4800	1616803200000	orphaned
6581	3NKMKPyDwGtQtdip4TEXsKJ1FPsGZqVaU7TG5RpsUq9uyhaHjJXi	6576	3NLnM8FTZyypymvjnkMdRDLbYnWKxr8M5pFDu5KTQBc8boWYXH2s	448	1059	69	1	6301	jw742QNnjfHfyPTKqq9bT8Gco4Z2r6xJe8HnuuSsscPggEKwPh2	3405	4800	4800	1616803200000	orphaned
6600	3NKxXJ2f5S85dKhWEShjZpa4xGzNmoBKxmNjvmcgWWoYRKj61Xtu	6595	3NLe2amhyNxjw4QM7N2Bpm8Ap6FpvHjG4TkKo2nFNNyMKhe6hBaU	43	1184	69	1	6301	jwhPrkCe55hApX7SyeCa3QujDtnfrwKFnuifPd1DGiGQnGtBqhu	3413	4813	4813	1616805540000	orphaned
6612	3NLYULUMrrXWMnNpFLTMNNLocMJAJdrjDJVgwkHhqUGW6EnyF4N5	6608	3NKzfv9UZsVAvLjGY1DCZVW9qHisVKYCmmUrksGWmr5y3n3Mt3ab	1613	983	69	1	6301	jxSM3kdBrK53mtSkXdNvQ3AUsQv7RXJkAP3nxvcDpDjk9TUVgMz	3419	4823	4823	1616807340000	orphaned
6878	3NLHbZMxpouo56LHC13kzyRknUr6o5mqa91mWD2HJF8EgomPCy8T	6690	3NKPJG9erNFMqWiVPHCpV92zJcfwoUDPPqNRg5rYwnt3iLqDjbzu	1650	1375	70	1	6301	jwBG8T9B6cNWQskXy89gwLgjXCYCRAytdoN2ALpy4ZRrFQp6D9G	3420	5020	5020	1616842800000	orphaned
6632	3NKCp85J2feSWeYQMKgL2Ys3kTbgNjMKH8gZtVK1gY3RkstKwLzs	6626	3NKj9c9q1P6375uRRwcshPiHoozM61arRnZoMvojc8gbAMZyQVbj	58	1281	69	1	6301	jwT5xGgDo8eYbyR71rjz1GwfgH1PJ2K1Nabs7j1PuQok2gJxKBR	3427	4835	4835	1616809500000	orphaned
6636	3NLGceYz8UqDKkVm5mWQ44go39JFZHZbxLZqtFzaTCKKtZwdpaKe	6635	3NLe7qqUbuKsUxYqzab1HmQYSuVxkdAgEvZE3XBHmPtKvN8tkdVU	1406	1393	70	1	6301	jxuE5c6Lk31hZPUGrfXAAqp7FxeN5wBamswfLnE3JhtwK3F5amV	3429	4837	4837	1616809860000	canonical
6641	3NK8Be3vwTrjnTpHYA9zqtdWJW3etwzjDwnTJoEJCzhkANkTtdof	6640	3NKKAGumZBtbd8jXdR6XFEYXEAJ6k3SqG1D9jsuTapHGxCLzUpT5	1407	1395	70	1	6301	jy1kpE32K9bazpbQs5jxiA681SYDpqQx5pjktEpsUyY95nTcDSP	3433	4845	4845	1616811300000	canonical
6998	3NKmczyChA5qiHiGb9PQ4N9oS8QGBARt22gudtoEbhKobrBJb2KS	6680	3NLcH53ATvMZafoFuK5zx1ocx4FkjATFj4S39occVW51Y4Phu42X	311	1307	70	1	6301	jwrXzNDjKo9a7FSKAs7f1eow1K79tEEAjfuxK3h4is4oxXHGD7o	3454	5096	5096	1616856480000	orphaned
6717	3NLpzFn9W11fxkjrAtEMqJHNVqhnaQKarzJQCdyTDmFXH45DYD1e	6716	3NLvyur6iriFfLeEP6vMMh7SRSJEkSGjpMX9NN5pWHrccBJG62SD	1407	1395	71	1	6301	jwtybSvWWnotHzXDYubBBMNHvLpSiYJtjUuCTiVMj7VnvMJnzKM	3475	4909	4909	1616822820000	canonical
6722	3NLWjckAbzM5XE5M6RkZvhdjpG9EAwTqM2wtBf6MLxEbCF7aAJUT	6719	3NLUKjucYt19uLksaBRBG3528iijD4oyyZZRnGZ5n8m4Qm7pHEer	1419	814	72	1	6301	jxTPpgAmUr89YWMaGhZQ44grcbCZ2XNd3HAC1wEJBz4WE7hCFNn	3478	4915	4915	1616823900000	orphaned
6730	3NK9w9ZxUzCuMiiySxoR23hXSAaZJvpzhdGz6NQTtoBJou2rdx29	6729	3NLU3xbRqB1JtP1o4ZQ2Vs3X4o9JrGMqv5ZjvMvSJRhA5P9JH1z6	1458	1323	72	1	6301	jxbqN6dnxNGgpPawpty2Qe9f3Ga4dbzqh8mPPAzK3ty27ndEi1p	3483	4920	4920	1616824800000	orphaned
6732	3NLUQ4jtKJoFPVEX3NAshtTgdCepYfxwd6YdeJfQdqB4mWHYaBgU	6731	3NLaXfHD7TMRF9N9Q77HrDaTjzu4Hhtsyg4jjy1R8GckRjCXaUuc	1585	1120	72	1	6301	jwW6opQXP9FJ6znxiDKPN7feSeBd3YrprwELse59QyLoVRC21w5	3484	4922	4922	1616825160000	orphaned
6771	3NLg2Mzxh8yXfjLyMq3YtF5fzcrerZK9MDxBa5w891BD4JdJkwmY	6732	3NLUQ4jtKJoFPVEX3NAshtTgdCepYfxwd6YdeJfQdqB4mWHYaBgU	1489	1254	72	1	6301	jwBrDBofwMKrfPphsSFKF4qsdFvqj1FB8htuo7zwErF5bsFUL3o	3485	4947	4947	1616829660000	orphaned
6747	3NKBvHRRrLfrit16rEFtS3otXTNuoi8sUvab5mCchef8gx5uCMMg	6746	3NLRo2dirWiNCEz7bA24sGsrKyw9p9iiXcH4jAYRQ9C12L2VKEW8	1507	1280	72	1	6301	jwDNPiX1kMw6aho2mcvzr4xfhT22tSkiD1uqKmLsWwCjDecWYPe	3492	4930	4930	1616826600000	canonical
6765	3NKNA9uFwyxoyTwKkVT4x3EhyvRbC4nd4hdEaRjnpurF6Gx2thdd	6763	3NLZA9cYW8PAgoC54JR9Pf6TTJ68N6oYGDq8MAuVFstNXuPQ2VgU	1624	1208	72	1	6301	jxQnr3ccEQg1cNP8xKKqnV2vq73yazN8uPtBjfWumAK69CDz6GX	3501	4943	4943	1616828940000	canonical
7004	3NKWFs3wWgMX4yiLx9RpyrViiizGSP9egPXg75zSPP2V2MKUPCnJ	6784	3NLaowv5vkK28VM347z98Jjf2JLzKaXXF69TYq9qdFi5dnWVVk2w	311	1307	73	1	6301	jwS68K9KFvWdjyWo2XwCZf422MqaGwcP452AFpDSqyLHjsqn6tb	3514	5096	5096	1616856615534	orphaned
6788	3NKgTXsWadewBgtCqESCtyFAQca1FrDNWwoua9GjhCNBdDmSDR81	6786	3NLyBBiUVGzHrJiWygGrcMKEwnY2gYh1L3dr1d4Z7Jb2FKWabeth	1447	1345	73	1	6301	jwNgYP9cTfPB3zEVHrguhRtwTLyuBdhMXnj4JWNXkhTyKy2cyp1	3515	4958	4958	1616831640000	canonical
6826	3NL8P9CStP7x7hBFaEi1mvqRFy1oynfjvoVEeW8aaMiYEQc3kzcD	6824	3NKAdpfW3sXZTNff7fnrmMWNkEb3Tehbn2ifQzSLVQZommff7zMN	1647	845	74	1	6301	jwcy2crUfFcJrYfnvrBanNooBDjG2sURKWJWVj238tdsegbkLxe	3534	4984	4984	1616836320000	canonical
6833	3NLH1fUHVsGJswaNKkhiybXaky2v1VUAz4aR2DUGMVqLKXJgjT9f	6827	3NKCkXAbj4prLWyd4yqS7WLsX5dmVJw3d9238mZuuedj4rbGP5Vu	1541	1298	74	1	6301	jxE2LpEzATWv6XP3bjq7a5CydC7ErphFPHS6Z5PL1YJWVxLuqL6	3536	4989	4989	1616837220000	orphaned
6848	3NKNQmYDTFaL1y8jR5pTNUPuNvEcrDq38BLWwJxDvMiN9cvrcS5i	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	43	1310	74	1	6301	jwWaHmoLNszg5R9XNhH1hRgyQJWjRiYeoVvsPgUsXPgvhmTTELK	3542	4998	4998	1616838840000	orphaned
6850	3NLiq1k9jF9QHDKHkLRuiyNEW1FECjt821TUUYPnzjhRSaKppN9X	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	470	1309	74	1	6301	jx9TcWaBnsKKJTb78vCxQCmnjXMMdPE77RwdRcBDUDEgaAA99y9	3542	4998	4998	1616838840000	orphaned
6849	3NLXbnBwekrAzHxg22AkuKQUixfH4hjnHyQ8qqTdREkH9mLgAWqa	6844	3NKLzGZE9iPBDpTyzTMbQCFoaBdipM9wcgEzN9X1pRTTzhquT3eQ	470	1309	74	1	6301	jxwJUsPL32wgiqJAzrSZcxZZwuQFvuA332HS9c7ndxUdAF9SjWz	3542	4998	4998	1616838840000	orphaned
6853	3NLW7qDtCum1caMxc2SC9uFnEpi7cPmrG7MGmSuDedfLxZzSKo2b	6851	3NLC5GRckhpEWBoZtCjpRdX9gjUoEji3MGNr6wK95cBvBXuRMMam	1652	1315	74	1	6301	jxK2ZPqBLu2CQvs26pHht6nmZXvLgmwJ1qyb51UeX9nu4fJtyx4	3544	5000	5000	1616839200000	canonical
6866	3NLuHx41TAWRmwBFgwQiPB1xMLWNGn4tQRP6ig6NaRq739gydQ9N	6854	3NLfBhX9mmoNqf3xU4bSotzdm6hJRndUuuXd3RiwM9F4umNA9pkR	1675	1096	74	1	6301	jxSi2Bxgo8HeKN6WLicmEgmhqQiUVhChwqbFffUS2MWdNKYqVRM	3546	5013	5013	1616841639225	orphaned
6871	3NKr1ASYcLoDnPunJTENiyKT2UHXn3Ui4JSUQZoUHD6iBPjBjX7i	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	1523	955	74	1	6301	jwotF2rpXn4r6h8JiDNLaf2UVP8Qrq5ayotm3hfKG6X6d6Z4Xxd	3554	5018	5018	1616842440000	orphaned
6873	3NKbhKSFN89nsXGAGKBPhRvf2eekbHY9gyAuSvdftZj7ErKFQd5z	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	563	1113	74	1	6301	jxX9bB9bG9w8L7aLVGm16Ab1vyUwcmhMQU8vXrfuHiQHiSksABQ	3554	5018	5018	1616842440000	orphaned
6874	3NLVqKTy6us7FmcKFQBRmwgLVUejr9mZ2FHcnxAENFFYsyWy8uys	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	563	1113	74	1	6301	jxw999zd82pEkrmo51a3DFAenTe3eRDhTJwbwjcQyqQcFfkP4At	3554	5018	5018	1616842440000	orphaned
6875	3NKsSMCgggff9Q5KHWfUXeC7PqtdAHhDUBz9PbjHJAdJSDLUjErm	6868	3NKpotTraKn4qhmp6Pu41vxn5eQnAp5jUiCKrmV5X7KcXkkyhRny	563	1113	74	1	6301	jxw999zd82pEkrmo51a3DFAenTe3eRDhTJwbwjcQyqQcFfkP4At	3554	5018	5018	1616842440000	orphaned
6885	3NLNTWtkcnWC92SKHUK6sLh5EoKAmzsj6gRpAX893h1UNNBdMqPp	6877	3NLcRUWLYuc7y8BxALUT4QGPk9dUzkKbZnAr6CCAysg2ojHsQsj5	1577	1081	75	1	6301	jxM1ArfVyWr84oZon11f77CuSGdymwSU2u65MDRESXm7kHr5Dt6	3557	5022	5022	1616843160000	orphaned
7424	3NKuj4zDUxG5ufnrAitzCz5VG6MLBcV98UkjujpoVFJxT2CpmMEH	6954	3NLHxnbxZzW5MbpisHSE1MSTDeS8WUgVqeJ4KfwqNy8CwzHtti2a	484	1319	75	1	6301	jw76DKtdFrA4QwAg7S2qwFvtpgBS2jimj22urrtCthE2mCyRcua	3561	5426	5426	1616915880000	orphaned
6901	3NLAboqyq64uDwKXsdGYZJ72FaEnywvH7ELTpDoovckLfmLv1Dza	6898	3NKXpvQorVRTUEPvKr2gFauaxuDiRUhhcvfWNmCgF4wYtYGPQush	1631	794	75	1	6301	jwjXqs8DRKbsMQRBfxhSxbPHqJ4RXsG2UbkZNHks3coS4K4zAMU	3565	5032	5032	1616844960000	canonical
6913	3NLAm18exRM3MpQVnwQxsPnPUEXRTMPUGzFH48YngLXotA2pmM9U	6907	3NKSi3KrLDn8yYHvhPqBz6rYeSq2j13Z77cPujd3mpDetkdM6FtQ	311	941	75	1	6301	jwp9CdK3UX7pPQGHBTtXVnDJ7uwBkazDDQPPa5LABsUtvpT7sfo	3570	5038	5038	1616846040000	orphaned
6915	3NLEp4dTK8GVsUnkYCmYpoTYsjgMfTd5aMjd3ZV3sWYB2jgEbYMT	6912	3NLizAF6EykRkyqXbvscvFsVsEjwxG2VsMx85DYbyYm5d8V2kxx5	1631	794	75	1	6301	jxkuov8UZ59uoRadqEKDScpQFHUnBN1G4f6Z9c1tySCtjrxP3Lx	3571	5039	5039	1616846220000	orphaned
6953	3NKeUhePJ5fT6DA3CMPogviyf7Y3k8tsp7m1Sori6WbgmVAttz3u	6949	3NLXMWQ6T7CeZvFqXNsakNnm4kjqfYjKZNy1PwPaBsQ6q2hDSy3Q	1541	1172	76	1	6301	jwZA4tYMFejzJzFSLMAXLzP4cQwAb5xYAMyZTpZkPFYdMNryL3K	3587	5061	5061	1616850180000	orphaned
6996	3NLbpbXv2gRyuEWewpE3ws41FYEtj4cTsjV6HrPNNpv7Und9MCus	6994	3NLAAxReS4jXuz2CxiXsUsf58ZGeyjNyhBxZff57eD4uMwno6wBa	42	995	77	1	6301	jxWmmgNgZaB62pMoxfucRPSLC4WYfrMifUMrAAo916M34PyzvCN	3611	5094	5094	1616856120000	canonical
7078	3NLQjZtoTUEfDoyzzDjwkqYBrVTjXA8xdwMsCufPBphYqh5bX7Zb	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	1474	1329	77	1	6301	jxMWwwq2Ui7CtAztYYsZ9GDtyAgSPYEbnVENTu1eSLBFYRHXHtQ	3614	5155	5155	1616867100000	orphaned
7296	3NKCa42bCaCGeoxSs86MUhWqHCDgK5shnHBjgnE2hiEg82JzTLoy	6999	3NKKmYNTjTCDow5joBKU9kqhByyJDPcmtUviENhJJNKNtKMukefK	55	278	77	1	6301	jwjBg9H4piX6DeB2apHk9viDgKVmvcxBui438id5ADCxTWY6kRg	3614	5327	5327	1616898060000	orphaned
7011	3NLciVoaV9EmgwWfMpfYvgRrfKfRctFo4bpBgVzC3Dg17GEN4WEY	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1631	793	77	1	6301	jxESouLT9kZ8Ysa6Yo7i5nhxC8T5CTamPCkRWLHSTwRYfR9M316	3615	5099	5099	1616857020000	orphaned
7010	3NLMRG5mByA2ZqYebECAPnRaXDopEFFUdNRuM7bAefP9ZHiNDpH3	7007	3NLxLGr3byECXZqa3VN557ytGDCzgNt7TtMLJ6Luq19ef7PsiyP3	1419	814	77	1	6301	jxFMdrNWMJsFEuoGE5StA82XmAKfr6HC17QWJZy2GEVViq8Keqo	3615	5099	5099	1616857020000	orphaned
7230	3NLKnzv2PXSQUe8oDriiL3v65TMUKzQvCqBEQdxGduF6mJSde83B	7009	3NLDT8eWud8p9ZmHvWedjCifRXjnUJLtpyeaxugPScCQ14WtjJQ2	1474	1203	77	1	6301	jxcDNK5PiR9Viz3L6GBXiv7q459DACNuy9dBiUEZqCyecwLfkFX	3616	5279	5279	1616889420000	orphaned
7015	3NLXfMwjVyDX6rzFVdXNGhbwrPRv1icWh4gfG1Gswy3Uu81o3wCM	7013	3NLW6PBE8JRn6ARPrL7rGSkiZSdsRTCcBf5Jf2QDSQ5EqNwbW27w	1406	1393	77	1	6301	jwCumLRS8ETex5s2QuiZsxPEuX8oot9uJYgx26xAAUEchryqY6s	3617	5101	5101	1616857380000	canonical
7034	3NKcgQvP2xXvmP5Pi4fwdtX9TcneY9Sg4g8ZF6LVctoZQtRbPSan	7033	3NLvTHzuTdi7K45ry49EPvEBoevUKAiZJbrpwhcNkCRkwhxy3KYa	1406	1393	77	1	6301	jy1t949taBhfX7ebmYgqSEoJZox2JmVBnGu1QewY3jHnfSgueGV	3628	5120	5120	1616860800000	canonical
7038	3NKsyQyihxAVHpSu76Nza2LsrUZsvMqJJwQ4DTEgCgtNSjdUKwu1	7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	1455	1332	77	1	6301	jwMjTBWVZVNNembVQ3pnXCBAmSidVgFZKq6vUaExWY19HNoqa7i	3632	5125	5125	1616861700000	canonical
7297	3NKKWjMpi514N7cXd2WGCmsrjqRbCnL2117LwRpyXqKr9mfUodgB	7037	3NKei2xpJzpvzQSL7tDVimHPRVeGHognbbEAHeLEhQ4DmdR8mW6m	55	278	77	1	6301	jxi8YFfCWj8zTUQF1RvxoBtnWijnKL2ag5EfJP9WsM5mGGsagfy	3632	5327	5327	1616898115781	orphaned
7044	3NKo5Mcjzdpp2o3phj1AjD3cMNMw9L748fT91PwVwwqVGnBQ4ZTN	7042	3NLd8XuhJ93sFWpmsGifvF3rTCiytSMZVQ9sfnZYsTV6qV9Boe7X	42	1115	78	1	6301	jxGDRc8zSdXaK34py5xhAXr1FoMz21QtxtJ5CAGzQ7kxXXFektz	3635	5130	5130	1616862600000	canonical
7059	3NKqeugPzCdgCuNpc559bfFp6meKqt2F7u5KPnWNWCi5ZX6Jvxch	7057	3NKwMF1seewzhXZsSkFiN8SbM3RGr61vPXEnQHShakb6nBxZQ5i1	563	1233	78	1	6301	jwN3Ta7Hsg4wy1ac6BfycUNNt29DoDVms8WXsMN4vU3xFFHtHcS	3644	5141	5141	1616864580000	canonical
7068	3NLTECMrKicxzMgjf1nRWSaNk4mRNqqRaRqxvQCXitF8ZQ2recjr	7065	3NL6ZeuZ5odSRHwPmVKEGZo99E1nW4PB55qMLbBdzBHBA3QSUcvR	641	1336	78	1	6301	jxjqwJiM7vNgANpGTKKE4gy1Jeiu7ZXMc4m7wMFFLVVVr9mSjD9	3648	5147	5147	1616865660000	orphaned
7084	3NLcbjjVyn2QCzvXSaa2MgJXgop3mGsQDZsnA5FauaGxK85LCVbZ	7081	3NKJr8VgpPe6gpJiv47W9GWNv9WHHd4Bm6mg6BFp5sbj9XBX4LML	1631	794	78	1	6301	jxb7JSSc9gqM6Rj8KSDE8Kq64p9CcW7pCby1xeW6cY8qx2ry4XJ	3655	5161	5161	1616868180000	orphaned
7526	3NLFQmf6v2ig6eXvhTaQgZ4tARp22opUZGzJ7A1cPAwSK62zdPUM	7112	3NKA6xz12Hg9UhxN9QKjsymbddf7GTipTBGWuwkbHYaxkKTJhE91	641	1336	79	1	6301	jxDLDZ3FiDgaYbFCcjq8YJerfgQzjyWcpjedLXFHCYGRLWkMEQx	3673	5508	5508	1616930640000	orphaned
7119	3NL6x8uZgCR8z9zXcTfkjSfpFupiVsHLJdKnAQAoexA5S2LSQ92j	7118	3NLQDKRVqvvw1qmmY8ooDc8uo1xaEoYrT6aYAGXjyR2tBeabJbrw	1627	1259	79	1	6301	jxC2hpxtz2hzW29hvLVvN8Hp9sDQ8YaoYkCfS6tnyk63EL2y1RH	3678	5196	5196	1616874480000	orphaned
7528	3NLe2rT2dx7rMd1nYbZsnkZ8qYRviTRkHzu2jK8cNCV1dpvad1YD	7260	3NLqDHQNnw4C7hAE7F5Luan2VKbQgD8fauEumDsADQu4hAR51qo2	1633	1390	80	1	6301	jwJBc2waSfnt3bCN5cW1HPnCMgYB6xiQhPqGfV2JAsJgquzzkXr	3678	5508	5508	1616930640000	orphaned
7131	3NKDBF1U72EKc8KMpawRhzWrDmBKa2XzVXuPmd5eU8CC6Rg7cVdU	7128	3NKXMGaj7mTnpviJJEnyDaBy2DhkVC2jnbSD8ER5cPF2vax22VQH	1675	1216	80	1	6301	jxaoqG5NXENLMd41SjGNo15t8N9rHRodZbNWEfsXHTE7ieu6pcX	3685	5206	5206	1616876280000	orphaned
7134	3NLrcNXXdohLidLx9dL3QLoHwDWphShY7xo4Yx9FS4EiGYLfHUU4	7132	3NKfXCLTHfZo5qgYy6vZ2mdqwEobkpagAfySXhwSz4gvW69C6W3Z	1602	1369	80	1	6301	jwRM3tTfWmSqGkecTC9uMC5WzxHLzEvfaQc5idbdFisgjnXeA8R	3687	5209	5209	1616876820000	canonical
7140	3NLhbKFV9xH3tYqiZXaW76ZFhuuuXmEsUB35QarFTMRQb2t9k1CN	7139	3NLLck9Gq8ehdXY5ReiP2Nhd1aUUGHJcEt2BjAeUGEC4V4DT5xjD	1403	824	80	1	6301	jx7Jdfqt8xfhXrGZ1MDns3p329f9V727swZLzeVeGy4tYvxZszQ	3690	5213	5213	1616877540000	orphaned
7153	3NLaQe2279rn6iZTiuQCBBUXfYnWMLf8qewpcyr7p1WHm7Dwn5YC	7151	3NLnXe2o6PtYfwjJWj9EcsFv7HH5JLL2Rf2bJnnvQjWpbgHB9L7D	1490	1028	80	1	6301	jwD4acQ8wjzLxYutdH8fd4bqux7DmMDGET8qRgpXEAvNDCJGSam	3696	5222	5222	1616879160000	orphaned
7529	3NKVC4jPNwetTR9avr9LMxcazY89WTZz1vGftuNa4En24mKp7DAQ	7341	3NKB7XBfRvaCSVru7xcXHLkgmFxjBeEYFsm7WTrUZGbVAjHHo7ot	641	1336	81	1	6301	jxcWH1GcC9hruDGeTYatwXy3sanVxrgoQnXMdiqFQR4fSGhwyHq	3696	5508	5508	1616930640000	orphaned
7155	3NLVCHa3DWH61gG2qbc4JSAgKA5Q5UDjzRHVhUue9z1yVheYMFA7	7152	3NK8ShHfpkH6wKTfHyJMHTuK4mfuaNHGJP8kBeuW4pWV2UVQqibh	1407	1395	80	1	6301	jxgM7z4u5nDK1ajZnHTdyv9BidUMKGCcvRhWAsKewSDyTeXvDrP	3697	5223	5223	1616879340000	orphaned
7161	3NK8EHnEPggRREqEk7DurQqtHHFFgAgovpTBj1q5TFfsGxgZhWrQ	7154	3NLrHaUwGx64EbgCCQwuujrHwMHiZZca7fTCNTEugTQbnE3p6Nqn	470	1309	80	1	6301	jxLXZJ9RGty5zYyJBcLroVP4GE3HiTayWMSByTwmB3mEtWHWzqc	3698	5225	5225	1616879700000	orphaned
7340	3NKL9kQfnQwif4cHRguHzoXVyTZqrLSoUWggrs6vcRMXu1uJrudS	7162	3NLhNUKF7QeUC9dRh3R6bZajadva6Yasn1oFC1uUB8t7yKRL1CZH	641	1336	80	1	6301	jwLWCGmcyrswwDimoXhK7ghGwKCvuCNUsVAnSWQYUwrnDonzdvj	3700	5363	5363	1616904540000	orphaned
7173	3NK3zUNd2Tyuqm44N4QPs58MDxctAusa4g5FCcDsSeYEw9ednFn7	7172	3NLozf5se65JGt17LJ6u8oEeqkQ23WhhNWQ6D9TqrZE1Z4sN4sYG	1564	1212	80	1	6301	jwdhikG9ZL51qo6ehj1piEw9UVsqyjkrVRdYaF6XjsogukcFDt1	3705	5236	5236	1616881680000	canonical
7189	3NLvNnVbWBMtsfVtdNFneNzEN1g2AkNmNRhxT48U3iWgczNA9Nqo	7187	3NLbAyLKcFdk67D7S5CXBZqJKPdFnVxMTPZpHUozG1vmetkLd91Y	1440	1011	80	1	6301	jxBYQFNuLh3RGRQKNsaAZTdHRPPv6mhAzi2452GR17VRpbkaftY	3716	5249	5249	1616884020000	canonical
9960	3NLh8rC7s6VZu46yAnqe3Df6sh18yGtVqLB7k8ruwVzQaL5YbB3t	9608	3NKLjSajTbSp4wgEcuM1eesBu8eZ8FGgR9YtUetK4UtiTmvLr7nG	1407	1395	122	6301	6460	jxiy3U7upZL3mJQyVjkCA8gYkRVL8Bp6MDr8GvG4UGKpuu7sbUP	4986	7271	7271	1617248084367	orphaned
9948	3NKwVT9vh7tKvZPCV8hCTYe2hbDoqouKp2AoTCYxpY9gXCNuj5mN	9946	3NLYQ7NorWtB5tgocjoAwXztsXZpjyzbyts1vkkeSxSgaDurdxJx	1637	816	130	6301	6450	jwZjhkoXjm9kfotJBnjmQMwCRNz7soKeZMdoqqCSs5fsAVMJC3Y	5164	7264	7264	1617246720000	canonical
10088	3NL7TMc2w6fSk1dpVjhn2kKK3fVQYz4D3NDEyYUWUEKaDTtaTVbF	10085	3NKWW2oMycrgprtSHR9tYJ7Wtk7MiVi1wNF28YAcPQSugbbyfbos	1581	778	134	6301	6582	jw6e5VLjJ5auWvdYof6w1JmFX5Gtcw2nvZE3o2jBFACfk7wgiLn	5233	7366	7366	1617265080000	canonical
10104	3NKqNyCE3vV9DuXnwRQy18Rs4gfEazAT2Pp7ivqgTaQHajn9ALmB	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1483	570	135	6301	6594	jwYuKnEuUvqCGEHGogifzNCCGdfwAA2VBsDnaCTjWdFs3DALbPH	5243	7381	7381	1617267780000	orphaned
10447	3NLcq2s8p5cUbxme6LFv6bnaYu8Mam2B8HJ566wqftuo9ruiSGeD	10103	3NLaSGxhQE1DbBostb8KN6preCEmQGuV7B37wacSmvGgsbV2e2do	1489	1134	135	6301	6908	jwczzZefc9piPYrLjzr46qXoMfCKtC3NQ1f9cS8r6xLdKLUjDUP	5243	7624	7624	1617311520000	orphaned
10170	3NKhxrvx4j1PHbqTMdcmjXXosXGvMEcuyeZVAZYHcqkc2N9ahpxE	10165	3NKvvydqv24LBnaZDVBJYSVTYs3cL99xQXF4cy7b52LKGGzasp6p	1631	794	136	6301	6654	jx4ZvkSgsbrcPE4hPTtLEfqagm183fAuXaxwB6yGr6s2h9J6EoQ	5269	7416	7416	1617274080000	orphaned
10190	3NLQ9bCd7JKkN2bR2gteVm8HYj6WrmQF6aQvaNRLnaZdUs7pSD3J	10186	3NKrQCDfXbmi9bUSzv7Smzfijb7asYSgLqzqEav6vcuCGDBwt5rE	149	1283	137	6301	6668	jwQvuJRkTHDx9CwdPtJkeriTCWJPDLh2jQL1bevVf7qqNpXfSUC	5277	7425	7425	1617275700000	canonical
10220	3NKmHqt8qQu5k6fyh366FZhvbLdMsEfuVghoWnbMkSmSEVS2HK5f	10218	3NL22LQZUY8ET2hFi5ftNJ8sbT1xT2Rhwop91s2bw6V3E21mvxA3	1581	778	137	6301	6697	jxBRCEYTvEbVXqCebceMNWpUiaFHrwFNWY6DLZSWE8DMU6eUvz7	5291	7445	7445	1617279300000	orphaned
10387	3NLJcxdxprpaQSnZ5isVzKwPMZASAryFBgtTWiVr6oUGAeEVnZm2	10238	3NLUWrxbjoWVRZrRKU3dfLeGVwjZoKwywoDzxFU8ajeCCi9bu6Ga	1467	1130	137	6301	6850	jxV15at7KE2BZMPsHDqgDbX7BwcMx8TKrRCRYYB5tfu8GEBDuEh	5295	7574	7574	1617302520000	orphaned
10558	3NKWNJBJMRknsmcQuYcystZke3rYgUYmqWT3amfrmK4E7jAavF9w	10387	3NLJcxdxprpaQSnZ5isVzKwPMZASAryFBgtTWiVr6oUGAeEVnZm2	1467	1250	138	6301	7007	jw8CNxs8bHP4QjSpMB422nxBkbtCXTHRpwVpyHHj2EdaVS2KX3a	5296	7706	7706	1617326280000	orphaned
10618	3NLX7Ex1PVPAMFX3i6LP3X6rwx9zdbfCMFou3gfLgzJEHPMvicJj	10558	3NKWNJBJMRknsmcQuYcystZke3rYgUYmqWT3amfrmK4E7jAavF9w	1467	1130	139	6301	7065	jxqqqqAaFtepvyAxfuqNngmMVYjKUgzMfZBhzWm22w28ArUtqAD	5297	7746	7746	1617333480000	orphaned
10358	3NKwg61TwbEn1CKNdJaxESukWCh1SvmWimZuwLfuBpq4mtLj687W	10242	3NLNeikqodLz7Ve9Y2WPKYJRz6jj65erFNSnJgHePNqhPBk3vsxb	1588	1026	138	6301	6824	jxtPRK1KVe46vjgSXah5UDcx3556EnJ1M3H7PMiri64sQPiuEp8	5300	7556	7556	1617299312303	orphaned
10260	3NLdehbiHyAupEPfzj3RhN2sFoLyryeWgZCZNprjBMw3tVG5JY1X	10256	3NK6v9KZVhVm1cT7M989mSUayywAtsrD8BTmRv2rdDZKYohrYxpC	1406	1393	138	6301	6737	jwfwXjcGfUeKvkyUUdVoimxLeGgSeohbeXkNVjn22yJ1m2QxaJb	5307	7477	7477	1617285060000	orphaned
10464	3NL9acKsFvzsE9xqRJTnoLmzHTNnts88tPr6b7B1J6d8pT4GNrEZ	10263	3NKUmYhpRTzzsrZMNfcxXquYicqAbD6MEyTzqsgjYWWgcJi6FnDF	1675	1216	138	6301	6918	jx1kvyXGuavK7nby4Y6pBqd4SWhQrfKF1zRbhW5z7sZ5XW5osU8	5309	7630	7630	1617312613904	orphaned
10273	3NL62QUJm879srXtdnVVHzq5YKeUBXmXUcJU935Z2DHBFh3rPtdD	10272	3NKu8jsnzzudqmKme1NoEhGM4kXvnmmoEkZxAqYqju7Ec2prRswd	1461	1271	138	6301	6750	jwajb4reWYKpdRyQP57TugMz2JNXA7gmUtfjQ64aTRNfY6S4zny	5316	7488	7488	1617287040000	canonical
10278	3NKdiQoNL58iog1hxMyS61GQUK28TVQLYQ226azSHcYVH1mjjb9q	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1501	1360	138	6301	6753	jwuWqMBLcuevpVpRHKacyg4f9Wgh6NaPp8nE59kqJE2UmX9KHFs	5319	7495	7495	1617288300000	orphaned
10279	3NK9XE49ByFZTe2BZ7Tnif5gLJKXU9DopZScjY63g5L517XKP3UH	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1651	1301	138	6301	6755	jwHZ6SAzmG3xa5oknoBY3EBut6Q8AF7y1uBvR9Ht5WkDQQEBfEu	5319	7495	7495	1617288300000	orphaned
10280	3NLotSJmHyevhkky9mcTGE4t2ms9FNnBASqwdZSy1vfXuuGKzxRZ	10275	3NKhFnW3p4HDHibhYeFoxfGQbtwF1F76NfKqhbWWRnqPZXc3sRsm	1651	1301	138	6301	6755	jxpGebePFG7dWcGzYMqJmMgGwkX4pyW9jqQ5sfAbWBDCj8ZvSTk	5319	7495	7495	1617288300000	orphaned
10301	3NKkmMxy5Pm4y9rYR8dBV2W2rRgtV7LtykHshQvBo3rvYesVfBKb	10299	3NKe3EaD8PdXB7yoMtCkDVyMMcmHzFEoSAHyoxRp71Kb6UGBN8wD	149	1283	139	6301	6775	jwyPPenuv2jqT2TQx9dFmShaNcjNxsT8hXeWmTEvgzsqfmexVqJ	5329	7509	7509	1617290820000	orphaned
10325	3NKtLq26RtARCmjsU9nwo7JPk5PbBHBJerDXDNsBen5rnHRaGbxp	10324	3NK9ggPL4kBztvt6dYgBzmqzZbt6ij8nAwwSp5yjnjFzs2AwrtiJ	1646	1108	140	6301	6794	jwkJ2CBjTnYw1NvgDaeGsSHRkzdQi1yaKt6NGQsDyxxaoBiFisH	5342	7530	7530	1617294600000	canonical
10339	3NKuLkjJurmevtUMqaAsLHrGtxkdwD6qxV4CiD1yi8xUoF5s2Aiq	10338	3NKGZdm8baUUMqm7GDDUqoeCHvhfFYb9vN5KxxbSR9nuQx2zcqkZ	470	1063	140	6301	6808	jxb8tXpRg63dJo26o5Awh8Nz3UD3DvVdyNnGhzFZVtA2Z2kYpWz	5352	7546	7546	1617297480000	canonical
10340	3NLkbHMf4iH8byjrQr62n6nahFE2oJRxsakjA5i2Uhv6qtFULG4E	10338	3NKGZdm8baUUMqm7GDDUqoeCHvhfFYb9vN5KxxbSR9nuQx2zcqkZ	470	1063	140	6301	6808	jx731Ky4hFtPNhM9uSEMD9vVQpY6AzvAgxCtqeG88kWLRimwjvF	5352	7546	7546	1617297480000	orphaned
10351	3NLcbpob9A3FUjFvsMfdD8WQUAJ5jqwcEauimF2iWa6q5GAmHkyQ	10349	3NLXhhEsSyrdgcrY7kXUHTMUmA1JVtwj6n3gm8Kn8bhZk6CAonBN	1549	1362	140	6301	6819	jwbfPTGB7pMFBHGAX8hy7wSvHS1kab9zJhWnY881DqHyHHXGZii	5357	7554	7554	1617298920000	canonical
10375	3NLnGU5pbfXx5yvkqiEMTy4kfVTnEshcy9TaNcTe67RwgwMwhmXE	10368	3NLNbevaALmrnRoLMgaVetANYA3aQXnVECzWvg3XUwrjh2XNUSzB	1581	777	141	6301	6838	jwkPhyN8t45nqFgevjYXHaD5H2F2PZbKbKQq76hAGY8fEGPeZxd	5363	7562	7562	1617300360000	orphaned
11000	3NKv71feUhgv2G2iMcmG7EixBXzT15V4iBc7s1fSL5bw8tQ1fsFZ	10404	3NL16Zv7nQJs7HLoCTUxt1WmrSSkesFU2EKTYXqq4xUGgarxDDwu	1483	1276	141	6301	7402	jxW1tJpXbZ4xMGPy2D3PktRuPUQFp9rkPAN9Lwc3iCz12FHvaAD	5381	8004	8004	1617379920000	orphaned
10417	3NLkGhGHVfhssNuKmtuNEYepv3jbP4uoPPd4yYZpw51WiLEqaPBk	10416	3NLWct4EZqVXu5iDvKeVpKvaQVE9xXXus71zVTwBbeGwwxT9yucN	43	1184	142	6301	6879	jwPpp5j3uZoGT3wPEdfy7yZKND5RqqYq26gaWcxu4E4uHU84hXN	5389	7601	7601	1617307380000	orphaned
10422	3NKys5uxvV6c6jiget5qu6GSyYbE7rZM9w2tgPyXmwcpmA8CvuLt	10419	3NLr9YpTKTK5i2asNyUeHSU1sjKcVdinPXJJriijCBynRfBuNvTf	1403	824	142	6301	6884	jwbCiAo4y9pZeF6pBe56mK7n8eawZhPm1UVDVTQpE6jKsofxSzQ	5390	7605	7605	1617308100000	orphaned
10423	3NL7ph5y6ze6rAftiskXaREmvPop7mXNzeKDeqxgHB7oHihdvam8	10420	3NKrZU2ghwXEzNsGEYmoNwQZQqdXVweSQHmorWrJ4ZCpttQ2y6wL	1407	1395	142	6301	6885	jx5Got9EMaTfgMt5ssHfTvYjNnATirRys93D3BxPvXx52XpibRn	5391	7606	7606	1617308280000	orphaned
10433	3NKmF6AJCrY5NYucuriSeEcbqRtcnbUrPV2KqmR5wbwmC4afk41q	10429	3NKQsNRQoxBiaojTZnttikyXYikgC5p9a6sjUSBuhy2JDZRKy3NE	470	1309	142	6301	6895	jx1DNMxCjuquaxeSunwEKSvmdkMQJDcKV8gf1DEyeUkwXth41xr	5396	7613	7613	1617309540000	orphaned
10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	10443	3NLswohwPSpE1WLPyYbeePxmt3nSTitrChbU5hbdkJYuALkyFkuy	1602	1369	142	6301	6906	jw8JQi1UrFbBmXS9Jt3P2w8QaReHZgkbmfkY7q22diEqWz1fcCW	5404	7624	7624	1617311520000	canonical
10454	3NKHrx6KuFYwLAwE3FchfhGuC9WHVms6RA3X6DVGK7r4mAkfVcVE	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jx141PrA6LEyNk8Ufbj5vmfktem31PUhEFxwnMk6w9Z5MTB2EJM	5405	7626	7626	1617311880000	orphaned
10452	3NKBVeiAtxW6mpSFdEVsfnvuKpmbJEBZNLd8pddkXSxYZQQKjyTQ	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jxe7VEqp7qV73Ku82QqeGYd89jmk2iK7cY6AhcpiHFsNrLV5gPK	5405	7626	7626	1617311880000	orphaned
10448	3NKtZrG7u8WHp2951tofy6fwuGyp67K7JgzDrhFBak7XBhoQhA1q	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1542	1304	142	6301	6909	jx141PrA6LEyNk8Ufbj5vmfktem31PUhEFxwnMk6w9Z5MTB2EJM	5405	7626	7626	1617311880000	orphaned
10450	3NKmLegsADB6PjkrSARR9vNaBRNCVPzx3zj5REtGzJMiPfVHjSaM	10445	3NLvno9G82dk7asspMJsVW5rV1xTt95oZoJmwbR92gTVchdtTuzp	1646	1354	142	6301	6910	jwdVRqUZE9aNdN7tumEunSzdPCKQjfuZU86He44DNjG4A2Lg2Vc	5405	7626	7626	1617311880000	orphaned
10462	3NK8uh1EbVDaGJS7ey89z2BHAHfWR72GMGq2KEg4hpqefaKTCKME	10454	3NKHrx6KuFYwLAwE3FchfhGuC9WHVms6RA3X6DVGK7r4mAkfVcVE	1406	1393	143	6301	6916	jwqnAo7RWaDLEXrSWBZB8uLzkKLjpmPDL2yP9jTHyV6WpWQSyZA	5406	7627	7627	1617312060000	orphaned
10725	3NLGvS2qyFZGw9C4gt6RUbGzp8xLHiRs2v6qGpsN912V9foCE3F6	10479	3NLidJWxCXQT9hoXiG5mjiRbymEiuUB2h8xe1JMw4Pb8xr1Ak2Q6	1593	1100	143	6301	7160	jxPmXEyjysYVYaPeD2s5GrATniFMQan7mPfmW6sv5Zq1J9eETCN	5418	7818	7818	1617346440000	orphaned
10809	3NKLYNKvR2fe4JdD5fF1oizqarPLPref4jvettVxHaG387fNjhmr	10725	3NLGvS2qyFZGw9C4gt6RUbGzp8xLHiRs2v6qGpsN912V9foCE3F6	1593	980	144	6301	7235	jw7aWpssRjjTCAV2NFLsm3BgkavshhmLaguLBEpYc3p4tFB6M9j	5419	7881	7881	1617357780000	orphaned
10489	3NLk76977HPAYRumfb5sqwdqvrd3417xdNnVGAag18rSRLhWqn3G	10483	3NKTbr4x36tQCLuGBXPBH9gHSbTTm3mdVJzAGGCjYBv9QrKmySbN	1406	1393	143	6301	6943	jx41qitg9Enbefgjg2pM4HqyJ31mUpqzuNAgmPNWUjDb7qZaqud	5420	7653	7653	1617316740000	orphaned
10499	3NLbrZtbhukM2SphkqiHpvEVESKqBxQPksxp8rLP5qP53QuPCv1M	10495	3NK47LcCtc8U9qLLHgU839tSjb32h6kbsKnaLSCmiYoKKpnwQugs	1594	1080	144	6301	6951	jwkzGdZ7hmVsjgA22VTv18X97hV2Q2XX8CbbCHivye3jLhkqJTK	5424	7660	7660	1617318000000	orphaned
10527	3NLhMaXdYcyzeUjgbvcRBQEbomh5Ff7EwWMWBpEcwqBr4N6CUnDS	10504	3NKGEe9oRru8zP96vPCtsJz3n67rHeZYV6zyYGgRxdpF65jnw89i	1587	1111	144	6301	6976	jx3hp9TcEvrpDEk9Cew1iUgdHsVeS1QGQ5CjN2j7AQZwZGLSBpE	5428	7684	7684	1617322320000	orphaned
10551	3NLRzoNQyTGNMWJygzkNA4bfVPaJZg4y7BVKytdSR4VUR2HVpFRH	10527	3NLhMaXdYcyzeUjgbvcRBQEbomh5Ff7EwWMWBpEcwqBr4N6CUnDS	1587	1357	144	6301	7000	jxJDyC392Aor1odwbN1DpHhhEUcirZpuiZ7B8KSc4YYFCMxwB2s	5429	7703	7703	1617325740000	orphaned
10784	3NLKa6gU4RBJB6QPXGgDmzELGEZ6ypGcU75tNC717HUpuLqp476A	10537	3NLTb4NCYjwxuLgauEJPmxjToeNWTsFGKGediB8aVheEdYaR7hNQ	1633	1390	145	6301	7215	jx6a4bQytth6bKxB24uyDgVpZKdBskJQFFKqTdhgm5mGm5zKyNg	5443	7860	7860	1617354000000	orphaned
10854	3NKnM19fobYXKGu1oBDvWqTTyLppDDzR4EVdiZSAtmrf66cAh54k	10802	3NLr1SgutMpkemDNu33uxgQRYDEVsR7FgLCRpKPDvibBVGNBYhkT	1633	1264	147	6301	7278	jwc4czw9K7UHwWq9q4Mpz2s57NVCKY4fcLBsj1Lx3UTp84Muq6B	5445	7917	7917	1617364260000	orphaned
10560	3NK6xb4jkfXA8m8bahopycZWKHj6FyVPJes2NkkvS1RsnATDVCYv	10559	3NLwL3pRmoU5DeKhRdf36XzJCRFB71aeAKuwGS8zNL7LNqtDpra8	1449	385	145	6301	7009	jxxhqLxzHKqDPQsp56YCDxV19gb1DWDUtcuYFadkm58aBbJhx1p	5453	7708	7708	1617326640000	canonical
10568	3NKjZf3YyuB5Y6b33ieThhzhsbeFfs5fUFuQKpFy2eXm4kX8xXB7	10564	3NLDkk8ZwidZwvhthzo4wKrQ6WfSYBeq3qAHk187p74QTJgWYT2E	1631	794	145	6301	7017	jwfThFx5w8XfwAJfsvw4WJbCxz6tETwiR2e5bWf2qTDLWYbrvsf	5457	7712	7712	1617327360000	orphaned
10579	3NKf6NEsGGWBi3JuL691caPbprquB4cr7XFLnCVirUPHceLR68hx	10578	3NLRMCKyPf2kE2tw6zhCxRUrffafREn4JjKGErxETgjMapTBfYy1	1670	1036	145	6301	7027	jxwrgD721XzLbQDRj5Zv5aBy2w1G2NRwa2KyaHmsmNf7JKA68mu	5464	7723	7723	1617329340000	canonical
10592	3NL8bHuAuVRsmwCXFFJkGmxXyg9JSHnCX7nFi7zdYcNbv4Fa4ob2	10588	3NLPWCWCrTPzuDQ21fg69s8RSgeDc1mzAumHUUbdZRdV7ruZJ1kz	189	189	146	6301	7039	jwHF2z64nMCB19NMQYcCH9VaiaER1TpTKSE1qj1Y3bASfdSkfG3	5470	7730	7730	1617330600000	orphaned
10601	3NLEP9Da8zUyNWjiWRa2EYA8qW5Z2QFaqYM4oUsuWpKAE8NQJs6g	10599	3NKWqMmAZ2t3kyKJaJoHo6eHVhhBCJqSrHtcqFMgcjFQKCG5RWpZ	1407	1395	146	6301	7048	jxxyAQbMnvnWFWc66F6oguwFzNmVb5WSMraSNNsW7x9aMMigper	5476	7737	7737	1617331860000	orphaned
10608	3NKhEKBMrXLb6AAPsf9FcBcBCpEzP1duuRP34m2A3cvqDu87pPD1	10606	3NLJwH5Wrfj5FA61Jz4omQL1i2kwpid2bnTaDCpyrKTPBgP2LHt5	1447	1219	146	6301	7055	jx7hRo3xLvzzuwEY2TECAdpCh89GX9VkTQGmQbtxhHwpscAbq8f	5479	7740	7740	1617332400000	orphaned
10634	3NKe2iveVabJ49ohynM9XHstsNceRd1auSWrUY2gg6AwgM18wfPs	10632	3NLECv1Pi54XdHcsf22rBNGkzPdvaNhs1P2j9izDos81KhtGde6K	1477	1350	146	6301	7080	jxyDfojqb8im5RHXPmVspCjGV5tcSXaYdQzzbwEKuQQ5tuvwApH	5492	7757	7757	1617335460000	canonical
10659	3NKq8ofAkPupjf3SmHLSmXSam3oGfUTizoySC2P54Ntgc9uiM9uW	10655	3NLG5bCWPAJNcPzNQgGLJdbJu9n9iiC8ML8Mmc2Dheh6uswykCjy	1403	824	147	6301	7103	jwJizc2Lc5zKc4JrE5rZDfGkiWn6qSHtVUMFMvmtGidH5f8UKdx	5504	7774	7774	1617338520000	orphaned
10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	10660	3NLDyhS9tRnA7kzahPnboq26Aa4oMiPfuyfvyZu6fJKmL9uZir4P	1599	921	147	6301	7105	jxwqmB8f4nyYTzR82YuT5C3mojy9mVB4UrF9VvUUZgYx4uMB371	5506	7776	7776	1617338880000	canonical
10664	3NKwGzDtMRY8Kx8LdNvsr96FvxjHMuHRx35WRN8pC4Tigs5ewSqu	10661	3NK8AKgfWgeSuzgBLcuoN3JxG42KsJCjBzfZY47Qq9NDKo7VxJNq	1654	1094	147	6301	7108	jxUxhkDP9vppZSu4VNKZ38aGAxtxjS3qTGy5icWYGYqKzvyzu15	5507	7777	7777	1617339060000	orphaned
10686	3NLR6ALdCEygpNut5MQa7cqNWduf7nxVv4YXhahh1XCyr3YebFw3	10684	3NLDSLjcHACSPu8BKT4FGpcs9KH2hHr1Ygq6xxeLuHZtcLPVU92p	1622	1356	147	6301	7129	jxa1zNN36GEo6ABdzLdx9oxxdCmnGwoJUg1NQLBhHVbYjWipCx2	5517	7792	7792	1617341760000	orphaned
10691	3NKF5iLbtQJWbWWVmoLWsNbpq9x5otjRaM9TQ9goP7QrJzuqtzEH	10689	3NLST6e1i9W8JxHCbVo6gd5gHC94ZJ1WK7z73ExsnrrPsU121eUT	1457	1265	147	6301	7133	jw6vJ2Q9NQrfhK8wC4i4QSAt2eUfJpEG8kEZWQ4CV7jNsc2fjgH	5520	7795	7795	1617342300000	orphaned
10694	3NKH1ejF2aUzfW5ZQwrh3Wu9jZzi1M8oZoTLwAQJNYULfWRPdwro	10692	3NLXjKY6cx5gDWnJZ449gDgHkL8ugyjvoRhpkm2o6zBT7C8zDn4W	700	840	147	6301	7135	jxuHoa5PtECt7mV4GC7Dr6pXPxJ6SmvpFnfoiuj5LqUuQfMLHDW	5521	7796	7796	1617342480000	canonical
10700	3NLmoVbZh2QvUcjgiucnsBbEjHWdWjca24HQenmA5aHL1e8kh1yj	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1508	1261	148	6301	7139	jwQVzVLhAodWqxCMkb3Z6W2UdpmEnuHiv4FpY5MGRGpMEqSzrZG	5524	7802	7802	1617343560000	orphaned
10701	3NKRapNhPbDSCVuPn4F5GjhPffYNvkYbfxk9rQwbEXwjqUCqwEdK	10696	3NKfDfFBEuRErSv5SsphMWhr6smSYcWe7EppoLGyMunssy6EWBTB	1508	1261	147	6301	7139	jxUVuumjFDybaWqq7XtE1Lc25E8mrkhgJaJvqmzLpzXm6MCeQ83	5524	7802	7802	1617343560000	orphaned
10709	3NKUkCry4nyV1TEv7se11nux8ZnzJnokGxHzZ5bHoFBfMc9bS7Uk	10708	3NKRmGuWX1w12PiUubeP2g31c5oYG4DQcGNpJ76CPBwSTdJndz3z	1536	1313	148	6301	7147	jxobAUEtjEVsrVFmvSFP2xcVHoAuyDHaQ1Wg82XBNHhCUJ3VNSd	5529	7811	7811	1617345180000	canonical
10716	3NL9YsXKiBmuDmNgcW5virfpNwNtuQUMtdqfGnaGcHVeL7oH6NXy	10711	3NKhKuSyB95FzpTzwHv7XQVXJx2q7NgXdddJ8DJ7MgYh49KGD8Fi	1403	824	148	6301	7153	jxML8HXPDzyQxcDpToDBeYQ7tzvUL8H45ueF2ZSpYD46FrJjUFy	5531	7813	7813	1617345540000	orphaned
11157	3NKKVcrGvqGGzDmLDJHyXX7tD3ENkeBoeBHFLsdqerCUXHY3fEwz	10728	3NKULcKdCW9UFf7TXyALcC1jDigCCNHGQhUtjn8KANovTcWamseJ	1403	782	148	6301	7548	jwCNyG7zBTgpfStguRo3YAmt32YmSEJMv85vJ4gnMcaGBCvC5kD	5538	8096	8096	1617396480000	orphaned
10733	3NLYWfWMnZwLNbA7NFqGZqanY7DYvEPAKndsRF4rGXSohme19cQv	10730	3NLVPQFfdan37PLrtz4xFoXGwkTD4Z8H6LfAjPEYyQ1DXnmD8UfE	1637	816	148	6301	7167	jw7o7FkASttfKich5hSGY2fmzm2NaGNVaXy5HyAiWjLsEFrN2gT	5539	7822	7822	1617347160000	canonical
11159	3NK9VePzdrMQJJAs438Gt5jTmkzio8DXNsNa17yDH8weYt4eD9p4	10753	3NLYhF2Kixa5m1Vw3scLxW3S8QMiQcNyBJziEQVeDwuKHHrTbQs9	1403	782	149	6301	7550	jxRhWbuT4hBtJoqrVYrbxCbXWEiirV2AwUyvmns3Szxw4a7RaX1	5551	8096	8096	1617396513600	orphaned
10798	3NLsv72RhfLWHJGX7s2mNdsTZ7AnKj5XQ5RcRtGm5zryok7qhNNo	10793	3NKwyTXCnk43Rwb27B84SkZjdoz192PTAfSEteajgKuuw4vrwe3z	1534	1071	150	6301	7227	jxDUzjnf1kFzhCzrvevWjmaaf9XzqXcRkDiyBK5q7vee5m3A8yU	5573	7873	7873	1617356340000	orphaned
10801	3NLy5cAwfD7TFEwYw12mgSSvZ2amFtvs1ktPHNC9KVGc8QyTXGRx	10800	3NKbvS1EsmrJXXQpJKqREEFjJvnhbaw1R1K4kLm1WELuDSW3vwAD	606	1169	150	6301	7229	jwCta33zGgr1R3gxVZQ1F3Dcoz8LbZFzt7bX6khYuSNHGSs9bf1	5575	7877	7877	1617357060000	canonical
10807	3NLgXBdRGbUWNQNER91ZVuUJQ2iPCsBJTDjyhQtPZruv4WoWSxUw	10805	3NLJ8kpakhD5JVMH2J53TKS4TXJwxWk8wZEYY6vyeiGTjcKns9mX	1649	1383	150	6301	7233	jwxb4yqzDGeFKXsgFSXMpuuMqsPTzvUoT8PXM7X9eyKPW53MdXF	5578	7881	7881	1617357780000	orphaned
10812	3NKuPGwSBPEu6a8LjLCYqWLDzY9KPd19oh9r6WeY3M7JSJBKEAT3	10806	3NKcqD84kWDV2LjTuikNujAyyYgNugFGfWqX13aUon1vbMjggpv4	1490	1148	150	6301	7238	jwLWdVyd9sfuVuFUwFVsK7xdq8aUDLVcx1KBy5WdFkd9SApvsUr	5579	7882	7882	1617357960000	orphaned
10815	3NKbJpHvaF4KhUfbnvv8qTJvL7KHpUMRDTuv8myCik3TXWSoGz8g	10811	3NKURoNnjXxQoLZXeXM94bHjUwTb5PZHoF5y9y5HdJXD1H1Hw5Qt	1581	778	150	6301	7241	jwtUJZZicvk22YLtEf79dfGKefhWSsE8U8a9Ap79do5RCQbbkRx	5580	7883	7883	1617358140000	orphaned
10838	3NKt2JHsVGypWznDTte91CAHy7ViGfMmNBE7h45AFboQDk1z54to	10835	3NK8UjhWiLc7BrnytXCWNUDodQrLRyqnrP2JZhzWqARtBceB6evq	1631	794	151	6301	7262	jxDhodQTan5gD8gzB1h8iZEuzLb9ZuymkpvUhckmHCPUvG2WA5K	5593	7901	7901	1617361380000	orphaned
10850	3NKru5geVTUJE9aossWY9eFtgSGgLn8xzqmC6VgF7spNQ1GXtRv7	10849	3NKuWxbnvoqkG2cr7K84SJDFhdUBxehqQayk6ZdA9d9hKAcTWt7d	1673	1002	151	6301	7274	jx6UYiuxRyp5h9ezW4suhbFUm7VDtEskEpadsrudDi3fcmdRaJP	5601	7912	7912	1617363360000	canonical
10913	3NLEbB5yU7b3g5qVsQGiBCksV8FJrY2Yvdr6LaeQRUexviCRSuGM	10895	3NKnMtVx8AUb7nv6Q12F7WeW7UNUVQjLrXAaU17csiWqWWuchayR	1581	778	151	6301	7328	jxy6eL2rwmX1eASPbLFTbm9NtxShmy8HFM6DihpYuFUqLYFLHbW	5605	7955	7955	1617371100000	orphaned
10857	3NKtXXLAEDc3h2ZaoWmhrc74Zh165zKSFWR2Td83gGXyDJesZRAc	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	1507	1034	151	6301	7281	jxRhPfNu2992iECir6m9dMkk4YZp1UaBQDcBHLu1mUmajMoQLTi	5605	7919	7919	1617364620000	orphaned
10879	3NLT6EuLF5MHWQSnXd5xnP2o5Yh3aYvogaQ4cJoNrtSGaN8w8Zng	10855	3NKcTpUdXHca5baFPYUKweoF91b9ybpUA8SxR6Mjhn3XYyp5YJv2	439	439	151	6301	7303	jxDB7TQLQfggKxopg7iw3qt8Kd3Qr83cekom2tk9gs7PaT2dQUD	5605	7930	7930	1617366605050	orphaned
10958	3NK9qSYqL5s4F96M7mc6ZLJuwWLEuFRP8vqRFVRj7VnEA2oZBWRY	10913	3NLEbB5yU7b3g5qVsQGiBCksV8FJrY2Yvdr6LaeQRUexviCRSuGM	1581	778	152	6301	7369	jwqfoZ7tu8Y4rpuUbmoQYzsAHVD9hpyUZAbMogEJKBFWTSSsn8j	5606	7978	7978	1617375240000	orphaned
11033	3NKBVSudxo9EbxXnTNbqB5tuqTdkXwJLSTGr6fcKic4iZtJ2QAzx	10958	3NK9qSYqL5s4F96M7mc6ZLJuwWLEuFRP8vqRFVRj7VnEA2oZBWRY	1581	778	152	6301	7434	jw9gcFjABFLcJ9y7LAx18sAQKsXXkVJEeGSUFncYYb3DR7tT9nA	5607	8023	8023	1617383340000	orphaned
11104	3NL9mi69W2e7XnReJshrNC1guhLiHR3nCBYHV13LAsteoaXhCfaF	11033	3NKBVSudxo9EbxXnTNbqB5tuqTdkXwJLSTGr6fcKic4iZtJ2QAzx	1581	778	153	6301	7498	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5608	8061	8061	1617390180000	orphaned
11117	3NKbbKoRTpmxN6ujXiwZ6ju6NXB3iYeeofqCQ9i3npfxdqa1rnQS	11104	3NL9mi69W2e7XnReJshrNC1guhLiHR3nCBYHV13LAsteoaXhCfaF	1581	778	153	6301	7510	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5609	8068	8068	1617391440000	orphaned
11242	3NLDpSMN55WikZc6zcCjJhrLs93vAho9CfkMscMrW2YEbbbDt9Kh	11117	3NKbbKoRTpmxN6ujXiwZ6ju6NXB3iYeeofqCQ9i3npfxdqa1rnQS	1581	778	153	6301	7625	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5610	8158	8158	1617407640000	orphaned
11264	3NLAvbc9Z76WZLu1FpnqKarDTCXjVEnVLEGfxJMVQk3NemrmAZf9	11242	3NLDpSMN55WikZc6zcCjJhrLs93vAho9CfkMscMrW2YEbbbDt9Kh	1581	778	153	6301	7645	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5611	8177	8177	1617411060000	orphaned
10884	3NKy5hBKLGr8weJxAv7WCjthTW4pgKzP3jdp7kCY7wTg6xwxKR7T	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366606167	orphaned
10885	3NL3JZZahsAaAEyjWbeVfpafVZrg9o48g9u1dd839JrJH4heRYDh	10878	3NKq32ASGGBqueKyktV9W61fDegkzamTr49nf9mCFHqxMJNqVjBe	439	439	151	6301	7304	jxqEgS2truf53Z9PddaEYdh5kvsiHCTKwL6pV1o9daLDGMyQbM6	5613	7930	7930	1617366600000	orphaned
11317	3NLPL8p9hH5ix3dm1RGUTdA2r9LqzLfXVw7gQmdKYaKTMgDdo4GP	11268	3NKXxu5Dn42wuR4rUj64Z8hCaPifmqYMu2prgk9W5JAr2rTiuYMw	1581	777	153	6301	7695	jwndjYcAcBzosajjiivdJb8u8JNAHZSxGvUJ6GYouw8eFf16AyM	5613	8205	8205	1617416100000	orphaned
10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	44	28	152	6301	7336	jwX8z2X8LNQxdd7H467uP6Fk64KnzsqB8wPyNhXt4kC8miaWost	5633	7961	7961	1617372183603	canonical
10922	3NKGmJ2HCjb4wVATj3h2iNmr6PZ5ENgeoUQA4xtYJqxfjerHt1Jp	10919	3NLMhrtBcZsemFSksyGZCAstaq4c2Hx3Kn5ZRCcijFgGMJw4RjFL	1476	1371	152	6301	7335	jwC4fBmThDaN5pTjwW5DuS9iboWK1s9o4RUpoZo2yucDw1WviyL	5633	7961	7961	1617372187768	orphaned
10924	3NKoMr1yRbM5HF41BsSRMxH8iqQVvg5gHCA9KNEZWmmvhaX8d4u3	10921	3NLjS8HcjwJyoatjUdz3vhSau3XtXwsLdntG1xBQkxZPRrTGF6yD	1553	776	152	6301	7338	jxP6zCgmAVsKqjKYBXizNKmCHg9Lsb2bSA8N6LqN3YET8nTvqLr	5634	7962	7962	1617372360000	orphaned
10936	3NLGn36fKm1jwwTgU4itf7YVzyi1PVUzXHyd4tbUCZeWAZTdqcCb	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1555	1101	153	6301	7348	jweTktaHuvR1uewMjDSg8CHw2H5UxxzzLdyQGdnmzzVKHMV4spv	5636	7965	7965	1617372900000	orphaned
10932	3NKJ4HVbGCwBnFVa5F1FmFdt1PuSgnWbEqxFvfbc4AVtizYXmYr3	10927	3NKFkhXpSGfud9BP4U4iS5B7HXGw6bFBT4HijrbB4D26uEvQQvzU	1651	1055	153	6301	7343	jxPFBPYKjmZMvMfNeTDZHa9rtG43vzTdZjr7rjrgAvt6emSepmg	5636	7964	7964	1617372720000	orphaned
11525	3NLMDsUXoA39XKh9yYvbvKcvGo2idTpRs7uQLwH74w8i42dbbWUT	10950	3NLe2vTnYgxg4FMPSiwvrhng5BzXDA9yNepEpdJc4codicN1e2gf	1571	1335	153	6301	7895	jwFKn5JiHRiXDZJ9HLJeE71ey4UfXcAYBxjtE8ZJwfWBz3GkFkv	5637	8359	8359	1617443820000	orphaned
10955	3NLkTJcLgpBL6kPy3qj4TG5HH4nGUhgH16zdQcUE6v41g5zaVmo7	10953	3NKxj8EyWX7c2nudKtPwAiGswEr7WyQBa1HjXCFQcr1w3G3iYcJX	632	1382	153	6301	7366	jxvLv7dtxdfL7t2BqKcX4megyYuw3Ey69hfJQbxZJXVugNrZcEJ	5645	7976	7976	1617374880000	orphaned
10978	3NK8XjXCeUqe1bpTvT1tDjzWRBaGqzwvTB6ufCMxotbpfW6ffhiF	10977	3NKtEnKKcrWWYbrJeCsGeRPVZy8B1D7YxhfGoNVP7pFyDKEuFyLg	1673	1368	153	6301	7385	jxoLudptYzs5NR9MMW83B4YMF2r71cJLL8vTMNvutckRdsF2DUJ	5657	7990	7990	1617377400000	orphaned
10989	3NKDS5NhRQMZWtQDug6dYqYih8ekVo4H8dP1oMScjnZRjM3KtP29	10987	3NKZUtHRVgu5Prp1hV1ezYRz4SPPSWDFgrcL9muQGmskhUxWc3Ux	596	1306	154	6301	7394	jx1YMTLhPMSQKbqdtjdeeGcsTYfeCnL6iNYbtceEhiAr1EZZTyZ	5662	7997	7997	1617378660000	orphaned
10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	1637	816	154	6301	7400	jx6W2LniwCWCNniQeVCdM8DQMjRw794hEMUXcyd6M8QMDbPysRN	5666	8003	8003	1617379740000	canonical
10997	3NLniYeezsrxecjzSaGgeTZNmgwYrzmXLF5R4wxh1kzDDMs86aPt	10995	3NKaoJQfbatbNnHMy12kZjnUxArcV2haoPCw6sfz6M5ZFbFTrnUZ	1549	1236	154	6301	7399	jwAufJy1Dz1LVfWR5PYNtYxsv8FKuUsFrSKExKpWqRTD849XTrg	5666	8003	8003	1617379740000	orphaned
11002	3NKgBXWGc5GYLardpCe8m2S3SBMWNd1946mf3GicC55oNxMHZSMj	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1637	816	154	6301	7404	jwF3GE5PVyR4LwYWyeQAcApUoME4t6y9qaRT5CxqHKP8sygWpVt	5667	8004	8004	1617379920000	canonical
11004	3NL2ehh83eiqDfH48k4LzqEifQpEDxFdr7vrRGT7nFo8jkYGh3Sw	10998	3NLwbcH33HvonhYK9RXkBDYZFaspZHwPiXM6yV1kbdZLgC9QKuKm	1553	776	154	6301	7406	jxULuuf1UsWMEMyQLX4cQkeCHtG3mpKZDKssAZLP11RnHLFBnkP	5667	8004	8004	1617379920000	orphaned
11016	3NLJpUMEy58ywF8LA5ngHagPMoH2waumEPrBFfvY94srZsXGu3gH	11007	3NLmnuuG2k6rTpc12qsFmW3dfqjWwwzXeV9y3srmJZz3piZFWFRa	1406	1393	154	6301	7417	jxLTQojQBCtLn3N5LyigB1enpKJ6USNZbAwWXsBng28ZDqTTn22	5669	8010	8010	1617381000000	orphaned
11055	3NKjE3PsFnpsRrRKxeX6t923q4SExE5TANQLmCDrCigamwPWkk4Z	11018	3NLd1bV531czGZLHL3MZAGevhgQADLZnW4NJAjzUPxdV3WaYx7T5	1447	701	154	6301	7451	jxtA5RTfuHACSCoCBxMxMysoSgQeARp6SVvvQ4GkAPWBzygNKxF	5673	8032	8032	1617384960000	orphaned
11056	3NLQdgwdM2Y2XvCu6JDvJPrtAj2u9uBByHYd7AAgAbVoUQ9DbBp5	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	576	1355	155	6301	7452	jxZ5z9oWekrdkeRPuotxjo1NSQbgorNo8uStQhsdzChAEUUHY6w	5687	8032	8032	1617384960000	orphaned
11057	3NKT1VfFyCRCgst8vT6eGHVmGrowiEp66Gq6gB9j7ViQ4BhtCBTU	11052	3NLqKpxHs69CMvFu5PTLSjZkgfV4nWUTdgiEjXZhVVURQUDX8BDR	576	1355	154	6301	7452	jxwDFKpsT1EgBnZYGU8P93bbieVLDReEt5GsfEJYwvCtp4Mi4CL	5687	8032	8032	1617384960000	orphaned
11076	3NK46JCUtj3aubrJ9GhkavrKFRz5yxttfRjDdVsBeDr9v7EpvjP6	11073	3NL4gfjgyjP3zYaoq6TLcDkeajaaWqqR5gY1mEdVyBMnWxcMPP3L	1508	1387	155	6301	7471	jwvwksyY6X4fZyQGzifHXPrXH5eFiPkbKuTrkWLgrttt8gSV8Gw	5698	8046	8046	1617387480000	canonical
11096	3NKTycJQ7eXo5Dc489VW5Ar8YEkJzZToZBD1BnzQVyKYszmFNf5Y	11091	3NLZWwmgH8kDoEjGUZJkXKWcEsRZ1BsyYtBtk6ioWhfz6trFbzLm	1405	867	155	6301	7491	jwb4YeyEaYtTnzWM6uBxUtwzfHNPFaKfLBrKmv6NyEJ12wz1jpC	5709	8058	8058	1617389640000	orphaned
11108	3NLomTsHhe7VoBoxAHucWe57Yrp3szrGbFmVWiK7W235NqyJiEtY	11106	3NLboZbnLPJgcGk7TdyMvnSEBzMdwSzYiGhNjtQ7xUCg5ALWuS7K	1402	868	155	6301	7502	jxVVALHGoPSKyUvvmYi9Bnma9vPZrVDeSJWNhXg2S8PMyYm1R4p	5713	8064	8064	1617390720000	orphaned
11136	3NKts7FHp8ZdYbo65YZdsvj59UetDpbC7n5wb2bkgBQCQCcVeF8C	11132	3NLSGf5SkMHyZPmsDiEekg9ZbkoZYF9d1YdGnnxFwtuDL3uqr48Z	1523	1075	156	6301	7526	jwx5hBrTBaCtya8SQjGohodDgNm5KgXuUe9Gbt3eCPDrdatXnNz	5723	8078	8078	1617393240000	orphaned
11142	3NKcneNb1kW8eoLtEFcJW4uwnicGLAuCyUCKGUVhzn9ikreUcQS4	11139	3NLQjoHPwKXSrXtUskQvx2sAf7GdzHYVJGGUFCHabfCp6kt8cLhC	1646	1228	156	6301	7533	jxhxn4utkxQ97JBfbQxbvjvuGfHznqH2f2m4fbvgQ6o8HnTQLGM	5726	8083	8083	1617394140000	orphaned
11147	3NLirSwuFDrqhQPy4i4pWR73D1AYnmp3bfuhYu4drsuCHxZQWPPp	11143	3NK4gXzHYRkYeGkyZZC8HPKGnyTRkRsNHAtetPVzZPE6roVBPbFf	1402	850	156	6301	7538	jx6K3183sjHFBQZbPUZFbrawS1GqN1unwD1agBo7tBBoydq1MD4	5728	8087	8087	1617394860000	orphaned
11174	3NLZsjZ38P2jE62Zp1qLFwAXnuFf6K2EnWaZjfp1B7bFqkBagur4	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	563	1359	157	6301	7563	jxGauD6Gs8ZVErVqeQnPZs5FinzttP3W7fb5379fTQykKtyAa8s	5741	8103	8103	1617397740000	orphaned
11175	3NLeGmU72QdWxgAYfY7K92EY8WSjVehKUZMDLVNzi59DGGY1DX3W	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	1451	1292	156	6301	7561	jwDhYddNVcV5pCsfYK6CGK3GXf4AVRiWx84K2jY4RbMHg5wtGJY	5741	8103	8103	1617397740000	orphaned
11173	3NKuSX8Wto3CETLzHXat9fHFXWi81m3tMdRNVH5s5uUfBGqgpxRr	11167	3NLrHDgWmDD5DHaVRZqWJRLpGdqx1kDL79NiqPPf8SGLZveFGWbw	563	1359	157	6301	7563	jxGauD6Gs8ZVErVqeQnPZs5FinzttP3W7fb5379fTQykKtyAa8s	5741	8103	8103	1617397740000	orphaned
11184	3NLsBYdNMXF1BWPZCjc55TxzvgFJGD59SR9DQ7A8X3KDCXfa3Vsy	11180	3NLMqQ8QjPnqT3FAqjSvF2oapnGNKkS7Nzo7gjDa1StBziMayWaH	171	1128	157	6301	7572	jxncPgY4xUazribW9wgAUcpujDv9FbNHSWCtAcUXc9ybyxJ9ZnT	5743	8107	8107	1617398463325	orphaned
11208	3NLuRdUUbf2YYuSt47MqjiQN3bDerctfZLh7JGHwCEK5x3XXM5b1	11204	3NKZKSSHcv179gsHfpLCFDNWmBbrrxBXHfMmu2ZmJSsfq5vCYAYq	632	1256	157	6301	7593	jxAuVhjBTyT8bAUkYaR26QqAktRm3bUwwTe9sHEwVZVeTDUyahY	5755	8123	8123	1617401340000	canonical
11234	3NLCfTbWhp6hy1Lb9gu6NKy6cxWdWwxvL3zmXdonFStfJobxJpwp	11229	3NLrbHNMRC1WFVXdSnwMDrVVrgdWFRVQS2ugC8ZdV4LmoFjbVKpD	1513	1379	158	6301	7618	jxsd6sRPPeTpLpJnNARo8aphzHSqnzNchvQGpkfzYbS5UA6tdWS	5772	8152	8152	1617406560000	orphaned
11237	3NK71yNV4ZqhTpgtE3tEDJxTh6H8eMgYmF2K5wRdjNviSSZ8bNX1	11235	3NLv4dVdjKuGh6KpyMjbWJqDqhJKoHwgjnaDdTmHkTcgux4ux8LP	448	1179	158	6301	7621	jw7wnV6yCaQ2NZcdyEoNyjkGPxVamXxzD5NfGwvz3ksHhYCGSbw	5773	8153	8153	1617406740000	orphaned
11456	3NKo78gFSjPSgmjQXtqkhZpQJsqLUrBYVtprxatTmFrTckovfU1E	11243	3NLbeg6DEpUwqKvpuiiKfL8zV445aSSvyhqh4SBYETcpFzAk9CEM	298	942	158	6301	7828	jxxYn15kX29yRiTia7teBpMGTXv4fkC9A5LVaAeQ3qtN8wE2HVc	5777	8311	8311	1617435180000	orphaned
11246	3NKakZ7iKXwTd9KvQBYn4hSnMNR5SMAWPd4Z993JBnb3LnFD2EpD	11244	3NKzQVUGMQdYRhaxwuYVSetdHpCpNRLCoufFz1rkqVXtwo2HEW8T	1455	1206	158	6301	7629	jxprZCY7vw2zwL1W1rgPE3hy6PZUJxkbeZcXC4GkmDK433DvjpX	5778	8163	8163	1617408540000	orphaned
11262	3NKqNZAEkNg8e5LWtWBfq1eRnWBqDJLxiK4zE7FbE4peVZtghFPx	11259	3NLfNTaJ4XSSmgn6RNSRoyZgXjASzLhAYb4dixfC1YBxySFb9qSL	1650	1375	159	6301	7643	jw8DyFpZbz6qJrDkEdq3eb9sDukFvZbUgNtLUBbpx8hcdDeRPxF	5786	8173	8173	1617410340000	orphaned
11273	3NKG4GuLkUe6wqCijpgHpRpLvwSLrbAtEa5o3rf5wYB2kQ72Bniz	11270	3NLTu7z4NWGTxcsvxPerXuZ82y2oKQhPL8UHUKCuhbJMUTY3GHAt	1513	1379	159	6301	7653	jwXGBzjXzhAmEDvmmxmdnwsKbyKhAvfsFnaqa9bw36za48FCbjW	5791	8182	8182	1617411960000	canonical
11426	3NKYwRrR4a1eQdVbz3orankYWMQpfuei8CEeYydB5LkH9mePZECo	11272	3NL8TxfBvrEz6QGXUt5y7RGie94MVZXvYbzYwnYr6WmkfZUhmic7	1527	1293	159	6301	7798	jy2z31DNi3Y13H3LVEDm53cQWmQfS5F6chZDW3zckJcwqQ61hc4	5792	8285	8285	1617430500000	orphaned
11504	3NKpFttN7k4ZZyUA8NxTWchovckzXauGrEmrZPdFo3nS4FWXH4qG	11426	3NKYwRrR4a1eQdVbz3orankYWMQpfuei8CEeYydB5LkH9mePZECo	1527	1047	160	6301	7875	jx9jgBsQnhrR8M2fKr6nMZbt5cT5Q2RZE2H1iKeXDzJgMF4UuNn	5793	8342	8342	1617440760000	orphaned
11286	3NKBzkHJaeyLN99MDrDMWT3Go9CELZe618Vas4MgoydvuLtHgrbG	11283	3NLgGidzLgyBCYXsjmUzCcj3HoxBczcPA96zaHvvzVnEGGzzFVXp	1403	824	160	6301	7664	jw8vKdvLut9oLwghH2wbrcSVRFS2icvLgvHwYTS4x59P3duttmT	5797	8189	8189	1617413220000	canonical
11325	3NKG8bUfrciX74W91D54ZUen8mDZ7othWKjN2bdWnmwdXjp6tESN	11322	3NKRQF4RyBF1AYo7JLbpN2WBpmue3CeJan6Hm1ZzSTv6RC5C9G32	1407	1395	160	6301	7702	jxpLXyZNjykjVpTDJbxPVRhHsJM3RN4LnHkSd6JN6PTiGnafwGs	5815	8209	8209	1617416820000	canonical
11604	3NK85Y125yTDYhW77QuCUG6etPVmDZwHFkp5znXbgL15A49hZ49o	11328	3NKBQz1AoWT9P5S5v5bRSkaY24PEHVEyfquzUiPEMz4UY2y945JR	1573	952	160	6301	7970	jwiQaNw2wjPi3FYgTb6RiTZXtuxskV35SgsfGbU2vZnrvZ3r8fY	5818	8421	8421	1617454980000	orphaned
11796	3NKqmFKkwm7S1ZyNz6HDSkQcWYLWrCJiW1UC2MDmZd4iCeQNwy4T	11604	3NK85Y125yTDYhW77QuCUG6etPVmDZwHFkp5znXbgL15A49hZ49o	1559	1353	161	6301	8151	jxi5jW99aMRV4k4CAcy7Amb7K8HHUAjAq1Uea8bGRHsEDMjub2N	5819	8561	8561	1617480180000	orphaned
11347	3NLnDs2PPh1BmmgmPzp67PhDcTqETD9gr9fHLUCr5Jk4abDviPYC	11346	3NLyNZsrVFALbf69xvziWUtej4FejsnjCaLDVP2Rcpei6ZTLgw1M	1447	1099	161	6301	7723	jxgvpUuJEwD92VomNXZfs4zCQdPziBHxZaPtCpxhMVXQJJZnKWD	5828	8229	8229	1617420420000	orphaned
11349	3NLjFfqZMdCRqBHufyYRYG18s36Ey5EjLWX2VFEgNatVPLE7dGef	11348	3NK9rNUTMYo2MPKi6h817L23LrYvwzmBASfWwC1uv6x5fCW1Gy7u	1445	1044	161	6301	7725	jxP4wiyRuKQ423LoV8gKcgbDnGXbDCKoZAtZexsgNYYgB3VcZE1	5829	8230	8230	1617420600000	orphaned
11353	3NL1mZ2BDWmJALZ4eQu1HjgNaJrmGzTdcUexiqgYAG8SSp66SCPa	11351	3NLJ8TZsbHqsqiqENi5K1XyrFCnfWUzAZ8xs7An3kitMhbSv67Uu	1507	1154	161	6301	7729	jxoHRkAxmsyMsL4unMY6USnkLyVDGyrcQhuahLWUNhV6QBpfvj5	5830	8231	8231	1617420780000	orphaned
11361	3NLqtzST6PG6MKKeRtqFGFyeJ7671Xa7KpMmSS8dU4erYutS3BAq	11358	3NLq2PHXTnrFX5aJbsDf2b22K7CjAMuPr5VsPcLbuRc9onJF6Y6K	1402	874	161	6301	7737	jwo1KnVvkq9iSFYeinQwU83WewuSLCkEkHq6ShyvtH83j4rpaMf	5834	8239	8239	1617422220000	canonical
11370	3NLmScxzCvbTpZsfH2PNcZ7BWLqu2uyGhhBsK4ihV9J23Ephjj2X	11369	3NLQfUnA5PqUtYLKcSQqNftwCH6jxZRPqHWwGR7veK5xrqf97dpC	1637	816	161	6301	7746	jxQsMQ2Vj2xoEAvJMDFURXsZxp4UGpRo1UUVqH6eo3gu8aierJi	5840	8248	8248	1617423840000	canonical
11379	3NKKv33bSxxND9YWC1ae7WdAtihGUW2sgihTKWh19mGS47tPoFBn	11376	3NKZppsm9G8w4ryYN5ZHQvG4bkndAgCv8BSiviKSH58M2H6Z3hiK	1503	1151	161	6301	7753	jwwHDZdLbfr2PsnUgyktngpz6D3dKK82s5BaTbFt5HCkFUsSKyB	5845	8255	8255	1617425103519	orphaned
11391	3NLeznMevvkXYu34Xip4ExpJ6eMjns93N52om3YAC2aYJVQ55sJN	11388	3NKfENFaz6u7MxQaEbNrmBDAB4ER8p9KpggkRXa2b5Zu8CVtfVtV	1649	1137	161	6301	7764	jwKSeCeQz62F1bw9q29zx5frQ9Cp7Nc86jS5hzufTxLfNCAmZcX	5850	8261	8261	1617426180000	orphaned
11408	3NKHSs4CeqANqBnwoEE9hkezfmizgqL3aG2J4hgUfCjuwCrRNuMV	11407	3NLdawetrV19UJeEy17qBDHD14SJQcQsNXEi57XVtuteXZvkBNBc	1403	824	162	6301	7780	jwxLacTkNYSoqfTZVQLpDnoFwwLemgdZXMAX4KfWHuiSD3gLPTj	5860	8275	8275	1617428700000	canonical
11427	3NKrVfiQDgHbPMkNmXgS1cgsMxgPqowcyq7iSLnNmnBKY5fLPWvy	11410	3NLnsvGhFXKCnDiiwz12XsJUDAoQrRDvRfvnJNWvkFJvSwEjUouo	1401	4	162	6301	7799	jxdUHh71c6tqk9uYuyJGmUzT73ZktMHY9W6PN6aBvkjWjdosWUQ	5862	8287	8287	1617430860000	orphaned
11434	3NKeKS4ZPYkKWng5SeUVtzk3ncyxNokWfpM2ZBn1NTkeJxsWU9VR	11431	3NL5S9ihgdr6k258fARknkMHuuLWa1hHDnPNK9R1j2xSDqfSSXEg	1671	1365	162	6301	7806	jw7qyvyrhHwBM8BWFHWh7Zm8NUPc1m8HvRumTZWafDdHoBfUfKV	5873	8292	8292	1617431760000	orphaned
11462	3NL5rmQm7Fq3nD72ri6fiHESiHBb714Qx1DvPzSUvTrbBXxJXDjB	11461	3NKg2tnigsij6AwWmWHFuZAjP2T9QkLg541twmsgFJU2gpALun9c	1405	867	163	6301	7834	jwEFreqkrzXzBdJdd8uGDBG48zhVTCrB58K4vJnWkYKsDX9uwaw	5890	8315	8315	1617435900000	canonical
11482	3NLWhXRDuH9HefLUyC45umNev1xGanfpVn4haav8VjBhcoSjVft4	11479	3NKf54HNmAegr39yu4UoHNyVw6vFEpRjpaDbKR8Zp3j1VhmXgW6y	1406	1393	163	6301	7854	jwrwom4tLppLPfyrUwBEuZNrNsMqVT8eQbbCEXFhvpmDWQyWE4c	5901	8330	8330	1617438600000	orphaned
11490	3NKXKMnGhmtE8WXrYdEeJkBTBs9hqGvxCH67nYNqN5KZEk1USa5Y	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1439	1279	163	6301	7862	jwiQuDwdHxaYyKjWMYhWimXcrZ9F7zXS2KJccF3AmVsDqmAXqra	5903	8332	8332	1617438960000	orphaned
11491	3NKQP26tyqKBhSagGAWqrnE6fZfCsfF6h6LiXnzrwoaiFP3ZFDWN	11483	3NLD4eWfN4vLFc2NKVCrpzZ4PDAbwD9WZcjdn7XcRxzwmPB8CtuD	1675	1342	163	6301	7858	jxPYtuPfD2B8zhsHrnYbi5crHijRqWNfd4SqXL7z925WAz9isuG	5903	8332	8332	1617438960000	orphaned
11493	3NLqCHPeVEtRdqWTa6XWZszw7s5Ntbp8ShWxhv1nPb2iW3yLyWu3	11488	3NLQy5oF9P6yL1jdBRkG1W7hs1sLnJnE6vBgrGPc6f5xESVhwLw4	1585	1366	163	6301	7864	jwmfSZaQ5JS1smeYwKNhfYEhm1kvSwh74cGkPrDERBcrnXEZ2pz	5904	8335	8335	1617439500000	orphaned
11634	3NKjX2arrZwCiyoG2N4E3r9Z4GhnnzFBJr4HDp8WBBYf4yrUHVBB	11520	3NLqDXU8YtvPu7GKmnEFvwNK6pUkB5D6B6dcUfvxN5mA69inwYtZ	1458	1077	164	6301	7999	jwkCaXyWxRSeXdzyQ5oiA4uP1x3rXzpLPtgpA7joT63CmjYfVqG	5907	8456	8456	1617461280000	orphaned
11661	3NKCgYrZyPWYwmzq4eSKPrLqcGHVt1frKR4izfzuoCyYhBE4zn9A	11634	3NKjX2arrZwCiyoG2N4E3r9Z4GhnnzFBJr4HDp8WBBYf4yrUHVBB	1458	957	164	6301	8024	jxfmLtKyo6zLCqZcqtyKKeaUKn6jhpgN6DeXyQeC2iU3WnmLPAt	5908	8471	8471	1617463980000	orphaned
11894	3NL7x7XQXvusWTDdZKvJBQnYJS2euW9gLRzw7of45ANyNmRVKLDV	11661	3NKCgYrZyPWYwmzq4eSKPrLqcGHVt1frKR4izfzuoCyYhBE4zn9A	1458	1197	165	6301	8243	jwi9CwprJ3xQeDruseoUhEJCoLkQDh3aSeezET13LcTZbCyzFTq	5909	8639	8639	1617494220000	orphaned
11951	3NLaxhW4r8PYtDu1g2nZ1ndQxwpYHxmWD1yt7FXGF2XfPdhnHziw	11894	3NL7x7XQXvusWTDdZKvJBQnYJS2euW9gLRzw7of45ANyNmRVKLDV	1458	1077	165	6301	8298	jwSyqP1bXT6H45qcJoCZr55hDBGzkYvGWafRVRBe2egXv3HjwyQ	5910	8691	8691	1617503580000	orphaned
11510	3NKhmSmfCtaysDv7XEjVpCEEoggNynDS5PbPHXo7cMma51DumxAP	11506	3NLNssDyNhPGDqM6SJPGD86MEWfsaw8Q6F7mqQJoUeq65k814Gsw	448	1305	164	6301	7880	jxtfa41SeBuR7ke84tVySJuKJCBqy3G1CnZgjnQn7vW6rzgMaLA	5912	8346	8346	1617441480000	orphaned
11864	3NKg81rmiHcEr57ehKwmh8Wb3YScbRK7QsDjrWy2G1eioJnKzdaS	11524	3NKrJa1seRRyPQ1diKTbs73zbnuTATrMDakZUxjfiYFuZh3MF9JT	1654	1340	164	6301	8214	jwyPEtt9FeQmgnnVTGNUoXam1d5wrMCG2nRJFMJJBVCNpkDXgAU	5918	8616	8616	1617490080000	orphaned
11717	3NKkGRiDXJLPFAYjZiN9JYsLCTFk7U8QBVz5pjbHCGCJDFEVBfVN	11529	3NKzHsFNRwVAwgLsFASV5kUgAPj84aM7Q5gC3ED7WCBbHHea6ux7	1483	1150	164	6301	8077	jxADMDHT12nR1FAeZzREK2CyRxjYc2viRY3ogHRqzNgvKJTz3Ei	5923	8512	8512	1617471403026	orphaned
11534	3NLU7QPwMuQ6MaB8KbQoRrceSpLxFi7scvegbSJYK8bRLxqRYi98	11533	3NKMcCzxe7AFD2avrzHLBukruh9M3X5inbNGrti75tFjxy3DKS2U	1407	1395	164	6301	7904	jwDCre3vZWE1KJS3HZuVELQhPtDjPuqVYQBXcoCHqXruCeqQciC	5927	8368	8368	1617445440000	orphaned
11539	3NLwmefiLM5aUiU7KZg5pjh82mjzxeFzhytmkJ1r728fcbZR3Wt1	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1518	788	165	6301	7908	jwrF9zVd5LDzje7mBgAc2s9A5khMLP4toQFZMGv3DNxerkCAzHh	5928	8371	8371	1617445980000	orphaned
11537	3NK9gGNzD6krwEt21eCUZENup2jnh1t1ceh6oC5DBbSHUYb1xGXk	11535	3NKW3LY52hRdE3WFqacQ3uBPy1tMY1WxeoLEXnsQopmznPifpG2N	1642	1241	165	6301	7906	jxVfDkQMbMM47HZP7AYLjpta5HLNfMSLYXLZgwVSufKLaLrdyo3	5928	8371	8371	1617445980000	orphaned
11541	3NLXWPr1XZpS9CX2mnCBoFqHmUM1RSv9RoTUxnRERA2YXY17Weda	11534	3NLU7QPwMuQ6MaB8KbQoRrceSpLxFi7scvegbSJYK8bRLxqRYi98	1518	788	165	6301	7910	jwop9VX6BRP9y1V7UHitFrJXxm6kxgdJjm9cPCCnE2AKCZ5xNKV	5928	8371	8371	1617445980000	orphaned
11773	3NLxWCmYzrGcyqTge1ETGdCeoBnRpP3fHojRvFzi3LdNxiG9DaBx	11613	3NLei58q5i8p9AGVMJdPJTfKPEQvLw85vcZuEdarfQTiQDZ2wR9a	1585	1000	165	6301	8131	jxk51coLX7KBrJJH5YZTzqe2HyiNxic5rk2SZiBndQfdXde7buB	5929	8549	8549	1617478020000	orphaned
11545	3NKoUKftpYBHz3sA21VKoXPFVpoBRurRLMWxBa8QwM5dHn1RmqwL	11543	3NKrTJHVgBAcWzgJ7GDhYCFrDccr1kfxsyvQ9NjevxCt7ZcRjs5c	1402	852	165	6301	7914	jxqTXRRwxVk3wJ7JRyG68raQcGcryVV3qwXzvQuEfZD3e2vPgZV	5930	8373	8373	1617446340000	orphaned
11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	11562	3NKMVLMPqKSnp6b4CbwPFT9tKetEqxtzDV7rXkWbAP9xqVoSqzRj	1525	310	165	6301	7932	jwU7wL8CEPHBfDoo2fe1pPbvtdhgFzTyainwAuv4ZT4DV7ah3Uz	5944	8392	8392	1617449760000	canonical
11566	3NLE3CgUDHdFE1Gz9Q1cVrneh7Cuu6drM5w485LBCbDGCCcfZdPu	11563	3NLi5rX7C6SiXSPsNRsH5c48bwCcNfYHXHfMPgSi3TWAMPYJo5u5	1631	794	165	6301	7935	jwoC5GepnJJDWS2dsN7MjRmBg5PSJHyhtQxDJj5idQd2jeJbX51	5945	8393	8393	1617449940000	orphaned
11708	3NLSb4kBdFC3bxSjDmi95H8s8y14GjCH13Bdw9sfrDUghG5Ko2CQ	11591	3NLPCwaxvixmXadoAuyeRZ8YSbYRerFLh7hcBHfjntYS3tZkhNRT	369	1066	165	6301	8069	jwhC6qMAF3Sdr8KPkxCY9kABYuPG9Tgm5dGdxydtg9V67YheePs	5963	8508	8508	1617470640000	orphaned
11595	3NLVk3L8UzXjSqtN9VDcM6HjkQ8nWA565LbGM5fYSifEHbqVY8Yg	11594	3NKRga8FujubTW9eMJLN4d5CbN4wajsLqwaEVvMirqBS6DaUWDNf	1406	1393	165	6301	7964	jxuAKU2mKyDzQksj1hhtKyqEzhGpqEEcKrkPtZfKnrR1MencPXG	5965	8416	8416	1617454080000	orphaned
11629	3NLefDVnhMcy8pHPgytFga9uv88PoxajCNGYNdjvq1h7ts8cztTh	11626	3NKbcT1LZvzFaPHfRdrGmDzmqNHYXVB4h9AwnWPJN6oR7jqNHyEv	606	929	166	6301	7994	jxNhsZHz8Uyd4rJ58z3vtH8nis6Gh97aNja9WDV4mykMhCZLPsr	5985	8454	8454	1617460920000	orphaned
11647	3NLoc55eZQKWyeRMJhMJUQZaPLzoR1RwxT83ymzphgP3MwhdVwgD	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1523	1321	166	6301	8012	jwusx4NdUC6M8Ft2rDVwpSsWTXvJwQH1LD7yAzQNx1iXZx68Sfg	5993	8467	8467	1617463260000	orphaned
11652	3NKGiq2vutHuXh54nTSQSBHuDwUwWjBtsBL2BDuiBFiMjQm6Q1zf	11646	3NK3vPPyJsbR7hX5kQgj4T2kTcgKqz5if2UZuGo8Z9Hsy7QZqD2W	1407	1395	166	6301	8015	jxGte7reuMbo9sbcYYnsmkcbc8Mq4QH6eFKWV1ZKFzsqnwiy1fy	5993	8467	8467	1617463260000	orphaned
11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	11662	3NKG7bg2iZJqQ5eMEagT4wZfmNqeJBDpfUWVhF56fDoZpCY1o9id	1508	1021	166	6301	8026	jxppAeC7fMqii28iUUZ9VcUSf53SMAEKgzgqL9hRaMf57wSkk8A	5998	8476	8476	1617464880000	canonical
11671	3NKukFN4KCwAiadPdnYDaQwi795s5NFG8xDoqrjPceU6tXzn1Nvp	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1633	1144	166	6301	8032	jxJGftyLtzvoSgr4eG2vs74a4ifBaaKDBo2q9ojQ5veQdMJDbjo	5999	8477	8477	1617465060000	orphaned
11665	3NLYS6pDqui7wHRN1MTM9Mgs6qtRwLCPWc8uiisUZK9jMRNsJAxY	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1523	1321	166	6301	8027	jx6nX1JpMArjSxADAfSLbDct5FZQfC8Y3wr3XU8wcoXJKZyGHUa	5999	8477	8477	1617465060000	orphaned
11668	3NKC1Z3QRamePNCJ1LBw8yvo2yFfHaXdSK15J4fXE5HEZqhnSL7e	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1483	601	166	6301	8029	jwVdv4kgR7cCNMnuALt11Xq6MLFgoHmfukHYQPqep2ttxSmAhuq	5999	8477	8477	1617465060000	orphaned
11669	3NKi1riwwLmEYBVmzx34HuUAPPZkeE1kbhKkNeEQGecvEsfwPiJH	11663	3NKHk9ft5nPCdTaTNHc6Lq23hmFQTeUAV1CBScL4RvFhfxgZhUks	1647	481	166	6301	8030	jwCWXqmQVevuxG1tg7VeqAM8LYh3EXTojsgk3tCXhexEVaBgdMA	5999	8477	8477	1617465060000	orphaned
11685	3NLew8yZeY9XzctTA6Yg2eSKZMTdrvWfuVRkUt6oHKFugCPzvKFC	11681	3NL1shMFuFNUhBHpjhfpKaS9PTcibcgoc5miWx2qTD1frYp37e1Q	1407	1395	167	6301	8046	jxA12pKur86GbaAixVaB2Nr1eAZgBJy1EuAz3CKwkrJyAxz8TFq	6007	8492	8492	1617467760000	orphaned
11722	3NLjTpyj8fMqFkru465NjpFpUNXDga5otxzomfHMhjy54tBV28kR	11689	3NLeW7ikcWrWrNQDh1G5VBJDNGP166ab4RX5PdnFEjBvcAFMz3fX	1483	1030	167	6301	8082	jwfY6cM9KeGBnw2PTPH4bwvcmXHfHZ4LW1fxrPnaGbZvWzh2FGF	6011	8514	8514	1617471765595	orphaned
11723	3NKUmpi9Mhhapr5Qoop5DkzZzJD8a6684YTB725GicTXgHWHJNxk	11707	3NKc313pBMYi8bKQHXTSegjWjDynjYTgsGPXdm8JXBNso92YoBti	1483	1030	167	6301	8083	jxmp4cqGmKwhanz7ti61idCjBmHkwrzj4dugVbGd5GQmKfufNmh	6021	8514	8514	1617471811555	orphaned
12091	3NKDEbntnCXHe1tXYgbBrTYFxigkH1eGR1m6xMZ5V97LPsSBvnJn	11727	3NKbwRT6kUSc8KM4PLqXExoBz4FKkwZiQU195pj1UZCrmMADDRnS	1556	578	167	6301	8436	jxscg8eMRfHRzWZoybx55cFTopA3JFP7T7Wb8YpHutt9mZgqNDS	6029	8792	8792	1617521760000	orphaned
12263	3NLM6TuezPBwMKerW4Svy5eZYNJmoit7HrQjzGEAF1qf5xXGLJiB	11878	3NLGY75wkHzeXm8vmpE7qcz3WSdnjzAtcbUSr297AXya3QS3QSeT	1542	1304	167	6301	8594	jxF2pGoyELQc8DHPiAX5JtJaLZ15njMXs8DJPpHFFcuWjjtQjGU	6036	8922	8922	1617545160000	orphaned
11774	3NKiXpikVvaNxziaFSdXBabQAPVmz8H55Tm6fb5xHAh4Lr5wsnY2	11770	3NK3v8jijhvakuD7H3DhyRDvCpi5krmmBK3binz6BLUbAbqXwyZY	470	1309	168	6301	8130	jxL4EPUipRovTwmB5YpPkLQ3H72drKvExYhGgkF7S44XfnYD6AE	6052	8549	8549	1617478020000	orphaned
11780	3NLun2zVfSoTFYqYf1fejrt88LipwUsVq7XgjgYtaZ5GhDgUTAdE	11777	3NLtMADqnBBT5YoZJV6Raup88TjGKXH31ZzQoGyqW2Ud26epGsw8	1609	967	168	6301	8137	jxhL2Hy35QwtPeG9nNwQMAMvHZuiv5cLVATQSUt4snH9mEcCk5H	6056	8554	8554	1617478920000	canonical
11786	3NKPXpMmRrY4FeCGyMs49v3aoiyE2EAwjAXz12ugprQwE2iNYY53	11784	3NLf754QZa5nBTRtELnpmWJBFqGk7XnARc5hZSSwPTMXruFcjNTR	532	1177	168	6301	8143	jwj4PK9Q5e1iVFhvvGf35qJmt2N5EBJmp6ZGaKR4SSqLqWr9yhw	6058	8557	8557	1617479460000	orphaned
11795	3NLK9VsX8HKD1SwXKvnKXWZ5qpP2ev3HFpiwQGngHCEdtyVX1cdV	11791	3NKNo3kva7Xm3WdudF9tRzy4DEFMQmqUyjBJvz1Lgnhk9KegGr5K	1631	794	168	6301	8150	jxitiCGLqnt7qxMd8y4tkdVgttSuSm5f8ZQNohCMPnKAzqdVSNc	6061	8561	8561	1617480180000	orphaned
11801	3NK8tgNa8BQ4eKV5KYbWKqhzV8UoAQxp7uiEgW6VjAcAVuauEij4	11799	3NLbsaHFpaNnPRFNxQXhss8QPHUzNCEhHucC9EcqdYCMXRu9HrkM	171	1374	168	6301	8156	jwPHnxKw4Txf9dcmZqmPYqzPmsZkkxMmQS7RX3qwtkf1gnZmqRs	6065	8566	8566	1617481080000	canonical
11806	3NL2YGKfMwDTzg4oBEufKagCq6JpC9E3YzFhpwcDk5s7vAujFDao	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1637	816	168	6301	8159	jy1Y27tzzN7e9RQcRCjDPAwVZNZ8pU2eBiroobGoB86fZr5BM5D	6067	8568	8568	1617481440000	orphaned
11803	3NKJ9JEqbzR6SiaVBUY2fB7BMT7idWTSDeBs1gk1ys1mEFNzFa7h	11802	3NL9UwFyjpzadgit9kiY8jz7e2gZXMpjnZZLMn6PyN9LY3Tr4rcS	1523	955	168	6301	8158	jxKNxAFryrq7xG6ShXGFdaMZyPkrcvygzwFDXhZyyQhWQxPxxZy	6067	8568	8568	1617481440000	orphaned
12013	3NKhrqGDGf71NkoBdXrwmQUZihEr39NXR3hAhQSEBkMUegaXxBaG	11875	3NKbAjiNzT79UTPbhMrtUW4ojQhThGpzKg8irFcFED6AxXMbPFp7	1439	1033	169	6301	8358	jwcr2VMjWWxHzYGbg7LD7GzSSvutAq9rnKVXtyUBmwSz4Xrj3qL	6072	8736	8736	1617511680000	orphaned
11839	3NKee1ANVGYro8D3LPzZ1fpQcwaUbk4YcjARdHb6ptpfc2vAFym2	11837	3NK8U7Yg15duSGeE9e2fz834ACuUJgdbbmcL4BuNCjbuA3E8RBKb	1406	1393	169	6301	8190	jwjurzwt3cT5eXhjNn2BnpUbc57sDRyqvc8xCXYk8vJer6z9yP1	6086	8601	8601	1617487380000	canonical
12061	3NKkv76T8senu1pZXCMMbq6uv63cSYKgrH9W7VsBPBvpsdJMZCdw	11886	3NLCQR4jQS8RbBjhK28L1stAeQsqP84ifQ4Dc3jNxbeW5zjYs8EZ	1440	1011	170	6301	8406	jwUFHjGAcpXkwsZ9w5HMChqumEcdeNZiYGbwN3Gc9y2vbY8xZva	6109	8765	8765	1617516900000	orphaned
11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	11897	3NKeD75G5ScPJR3faWpGeQ1WH6GGgMfA9KKt7DTbcv6jW3uz95uZ	1573	1318	170	6301	8247	jwzraetQi2JNkdSpmsBFT2CSEKyMGsw616tsiPh79Uu2kQBJQQu	6117	8645	8645	1617495300000	canonical
11934	3NLofsZnCCXEV62aByXNsrQSTPRymBhz9gnuSKZapY8MpWyo5qUR	11898	3NLUKRVamwXxzT2uaeic6t8gH2viS8USCgk9DbEeQkLiyjFUD6ht	1593	1100	170	6301	8283	jx3eHkT1Z1pDfmXeuLHtCrVsDSSBhuQTbmXi5ZxT5GFdnYXWz9H	6118	8677	8677	1617501060000	orphaned
12067	3NKVkUmBqX5XDejwUB4GYMqsu7ZSurY5LxejwM6MXpUGBNamYWFJ	11952	3NLxwtsp2zFAAs6FptYd5byrNXxWPC68qgCM2iHzacKhftQPDnFK	1593	1220	170	6301	8412	jwULyuCBfms91zfRUipr8fRDXXHw9ahQN4yo4LgPL3shqxXabKE	6120	8771	8771	1617517980000	orphaned
12185	3NKZmCddKuALssgCLrkkmbnkqas947xqCgpvnDU6nSLzzpLo17sq	12067	3NKVkUmBqX5XDejwUB4GYMqsu7ZSurY5LxejwM6MXpUGBNamYWFJ	1593	1220	171	6301	8521	jxT9ZgUN3eSExAPLbULj2ftQVDfPDqqsJ3qVHSnqiQTC7cfJ66B	6121	8866	8866	1617535080000	orphaned
11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	11909	3NLrBWPcmTR1nQP4969AHwgvHFyzDb21XyYLnyAPPp78PHf4uuPp	1578	1170	170	6301	8259	jwE7YNi8h5ftyDByzxMZdqQDs3Hrt9G9CzjjY6L5JSQyUzXe94H	6127	8657	8657	1617497460000	canonical
11913	3NKzHpw5vxkZrpaktaSdoZmW5EdzAiKTz2LVd1E4sTsjix7Miqz9	11910	3NKcQwimx1ocSXgiFNnSahG4KZKHtjjXepkvMJbiDdmFUkkUPbow	1611	1341	170	6301	8262	jxjFC3mujf4X48v2bnQ4KZxsz3ucA9EjYfbM8vnTrfVCFaVwMso	6128	8658	8658	1617497640000	canonical
11920	3NLC6WGHC5SZaggiXFS1vk8CUoutvkQKLfcmm4SYzBEP6SCGqbbk	11918	3NL2DmonS6tRQDegE2VpEsxKQqsA7ari9U4A3XJsSVeJmwV8ip8W	1489	1254	170	6301	8269	jx8bSTksga45zHJfgU9D35XxRzHQ8CbkkBbxFmMgmpwchdqYkQr	6132	8662	8662	1617498360000	orphaned
12372	3NKw34rKwHDh3JoQCwg8c64HsoTeY1yAWixhir2TaBqR6sERXLTR	12015	3NKnr8ffDttC5Z1zZXhhcwkhT436X5fmqyQxi4Wx7FHTX4MbrJ1s	1439	1279	171	6301	8699	jxeThJakGgVT6KE1EbCPBhxYjFAxXCPZtegeya5GdvsQR3nkuHc	6135	9015	9015	1617561900000	orphaned
11926	3NKAqiE1Tkp3nG1eeACXzGvWaYmyVn1MaZ6cpBgEYNMGHr3KxsPL	11925	3NLFAYNTe5iWzFvkWyaNiThdnBHgvBFVRs21VZ83nwysYjCxfvqQ	633	1384	170	6301	8275	jwtubXTntTwF9ESAkd5RUvAYQ9bjraRHJWZwUzBCbGTXo5VmDaf	6138	8670	8670	1617499800000	canonical
12459	3NLGsHJjgk4uLifTtrpZkeKfAxgkiBZUMLphNyaFfzmAC1ot9vsA	12290	3NL7AjZXdYxrQaj5tHvxrTBShvKzDehikyfZzSA8i6st13xpVZtq	1458	1077	170	6301	8783	jxygW7V3iBvTsWz8M2nmR6TT9DfZG73aXYZJDgLCARKRLLYkbgX	6140	9073	9073	1617572340000	orphaned
12271	3NKN5tsSumJW91aHZ9Xpzo8xGeTptDerzjF7hFZR6ZhtVi29s14X	11931	3NKppSR5gDkHeYYgBQzBBCZLP5nbxmS3rmAnB9hrnoUu5fMe5PnN	1460	617	170	6301	8602	jxwpFjP89nvFYm1TruhcC1fdTojHpaWs4kF2HGrMGHU16WTk2zS	6142	8928	8928	1617546240000	orphaned
11936	3NKMBCh7QAWDDs5u2HtVJJQ11VbDNi7uDeVsz29xCRYEHX4qz9rm	11933	3NKqz8qbhvjs9S3EV9Cz3KwSKPLqzfRKYhRefvREbie93oL8yLNd	171	1374	170	6301	8285	jwKhBMAaCD6HsVAimUUpQam71W8nNG5wDr1nQypVB7pEknyn9uv	6143	8677	8677	1617501060000	orphaned
11966	3NKugE5DbRDmUc3QjXrTLz2diiHYmpSag64LoG1JXp5E4H8W1AbJ	11960	3NLuYFVpGadiMQcdFn6oUajApqxKjRtZG3cbPrJmw3xGhb21LSef	1600	1126	171	6301	8313	jxR9hrxVF9tujFMEXytEEpGVz6Tk4X8VVKXbKpmG6VrNKDsfsWU	6158	8701	8701	1617505380000	orphaned
11981	3NKuUe69bw2D4cAPVaZCNKsPEynwVuwjurcJruFqESDK9RuHG27Z	11979	3NLeL4soGwLkK37bQ4Uy2J6axwQxUsAQ5XrFc7kcPi4sJ93VdwjM	1560	1045	171	6301	8326	jxuD6rdD8gTDiJ3M926syXTajkVLrBKjrJK9pRSvDKGXRvwNx5d	6166	8712	8712	1617507360000	canonical
12276	3NLgrRB9RffjFnXD8wRBvRipYhX24xcRxLtFqBMYCdpnTSbTk6Wa	11998	3NLtfNf1jKCUXuW5y5xnNTW3UxAWnTLqy6Vx2LefXZEgVyo6PxNy	1460	617	171	6301	8607	jwLEeviDwm6WjkkdLSNqwssDphoNKBUWqemA2Zng3qY3UwwaSXW	6175	8928	8928	1617546312985	orphaned
12006	3NKQDM48uvixa915pkddVA8eX72qSuwJgyMSqKR5r6riHgZqGZJA	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	1403	824	171	6301	8351	jy1madhbt7cBYrkBkZPnWyHiCbfDC55Wms5HvryzT4voH8LhsAA	6180	8730	8730	1617510600000	orphaned
12009	3NL15pEm9r43Xo2Aexf1EEfyaaj51zfaj5hGVc8F8dQuNRutYiPn	12005	3NLHN22vuHbk6WGvvgEM2mM1jcfRCXC1rKJrBxCp5EQ3ZJmoCJZu	171	1374	171	6301	8354	jx57NaEp6zdZ9auCpvV7zRgoHf2pbE76vcVGzx3Ku9VwE1YABds	6180	8730	8730	1617510600000	orphaned
12025	3NKZEb51jEBcGjs5HFHJaA3SRonQ3p4fsQ67u92k2cBaTRPHvQtS	12024	3NLrsy9ruRm49MKBPNTCP7ZcfHwteL16yz1JtL2JRfpKPxB3eVSQ	684	1352	172	6301	8370	jwExn6rJpXLSv6YKXmZJRfzLL2nFtXYnoCV3CzHcunz2NLiYT4j	6189	8744	8744	1617513120000	canonical
12029	3NKiFTUF2yyCK2FopvxZFu6CDXXbqdkuwu2JNF3cJa7QJjfNdQLt	12026	3NLdE4LQ3fd1e1UwzBxTYc4EWBHx9m9uddNjWiCC975jhdjSjhMs	1422	1211	172	6301	8374	jwG3g7q7u7UeCQrqE95Stq9nkZxzh5gyMZ1LeA2YqPWqKHN9sU9	6191	8747	8747	1617513660000	orphaned
12034	3NK6kZp8ZmUAkL84nLWmbDYDe6ysxZWvD336aqvjDhNX7D5ZTHrA	12033	3NKt497xpvqqnCT4iJK5SaxoDq7PSgDXLKxX8WoqF6JqoiFPBfXn	1403	824	172	6301	8379	jwxCWj8vgzuzWWtHnVnTX11xNR4uGGjUV4w91BuZctKhqm2rJvT	6194	8750	8750	1617514200000	canonical
12039	3NLEiuVCk1nuLM56BJuPhthxdrDj3aN25J3ypgMUvAaFv1oUDjhp	12036	3NLurevTz48CW6Udk12aYqciKy7Rp116e5KAFLhBuMUD6n2HwWqi	1590	934	172	6301	8384	jwENQp9kEAPn5ZUnHeEfVRzL64uDdHZq95D3FCo3M4ZCdYWpBXh	6197	8754	8754	1617514920000	orphaned
12051	3NLEBcv2CuJgJxhEa1G7TKifTLRcfyCPMNpvFnv6aBoefn5cJFoF	12047	3NL6Qx4sgnEDvLhaAwZxdH2UsohBdABnAgLtxqisUAPsypUgrGwU	1553	776	172	6301	8396	jwsNYMKTFgUkky8fAK2Ku1bHx8LEnSYvcoowTDo1dV1vYUhfXgg	6202	8759	8759	1617515820000	orphaned
12055	3NLP7k8Farfy7fDLdYjvJ7wqJ46Sb9Mxeu6F5dcbGTXxVZtBPEMg	12053	3NKjWWthcZwYSyXxGmPwDpEhqg7rd2wHdYwsTaMvTovXAJBEZzNQ	1647	846	172	6301	8400	jwGJ4a1ddXMGv1fAqBUfvouJ2J5VfPDYpN5DGUZHSEJKjHTEayD	6205	8763	8763	1617516540000	orphaned
12065	3NLwUrahMUbgyjfrnM39NkNZVg24xJyi3mW9ZZT5WoPLtFyfW4Ju	12063	3NLZPX8sfv9LAkdXGAReoEHWcRUwvujprp5Ch9x7WiHLcpNUY6FZ	1403	824	172	6301	8410	jwGR9d5tqftkqKrFZpPLYkxvVqBF1rk2Yx521sx9A4sJQXWC1hm	6210	8769	8769	1617517620000	canonical
12085	3NKABGR3DgJ64JTzPzD8333zgsnJSbU3bMAUvxEsLAyhB9TsgdAt	12081	3NKSbbmg5iQkvsXzsgubCm5wCzSoU2kXKEAdjo8vw7fTnfTbGBPq	1555	981	173	6301	8430	jxtcphkZk7atVcQnWAnVjtTJEHcKo1xXEDuaWJAVELfR2F55nM6	6222	8788	8788	1617521040000	orphaned
12640	3NLhSBBXGx6AJuM1o6okM4iMSHULBFYrertkJoQPrvqt4LGusvCE	12261	3NLPG7x4jCHPUnpk3NHefcuN3obBzWFWyT87Vs6bpfxV2ydGZGwh	369	1186	174	6301	8955	jwf88gCJZcGukvRminA88BDLqyeHoiueX5cs8KcV4yWFh6QKNKY	6242	9218	9218	1617598440000	orphaned
12133	3NKVZRsGEcSLCAWVDyq5ogiLBzbcGLifvKPnPk9GxDRHt1xzb5oA	12128	3NLqKvDYaVc6WBCpchC4kEgLnJ8mReTrsL2pVnR6Yn5Nr2HwgwCb	1578	1050	173	6301	8474	jxSfPorHuEFgHDzbB5VnMZPxEuihmvqCuXvG6pBSCbpbwKguzse	6248	8825	8825	1617527700000	orphaned
12144	3NKccDhQ1jt4nchHZSAcQDgTiQBbvvNddq6XXVd8bwPHXQMZcfRu	12140	3NKoquiRBUu8CvUoZ4MJXXDTyrX44uPij9CDR1B1gsAw3GXgS5wZ	532	1177	174	6301	8484	jwtG3ekJiCyU19RXq4zXM7nrnwLT4Nunic8AfiGxfXN2gbanuWe	6254	8831	8831	1617528780000	orphaned
12150	3NLChXN8FX37BViEouQCgmJifPyrq1PK3hhAUxGhq2g7kB3dwwWA	12147	3NLaC3z2rbbzMkWWz6b6RjYnhuVq4WBfAdPZbohy3E6CZHrDw37D	1419	814	174	6301	8489	jwLTmBat73GPF3v6qmhUWvHj2gk9CSstC541bF7HJwxb6Qceoi4	6258	8835	8835	1617529500000	orphaned
12163	3NLQZwCgWkNQ86qwsbsESgLrBAQwnBBxYNDZAdvot9Px6YHssPXD	12156	3NKVy7bTzWqUC2HwGjKd86Z5yNt2Q41cgeUcqAw53pfXg9hFKeYU	1407	1395	174	6301	8500	jxvtjWrtnyvVK4XaaHMpNvSXDZDZmEpPxYfFDbCg8zLRrQv9bUT	6262	8843	8843	1617530940000	orphaned
12445	3NKqpL93JYVfKFwNLWsgbm6F1HA7uZN6j183fshHcd8y9o7NGFBS	12192	3NKBDrw6rLn7tXdSJMYwsJFBzS7AUY4Lu5eX8BK57EnjEGJwjV19	1518	788	174	6301	8769	jxHkKbCtsDEph3qFhBmWERQ7LB8Wg6v9zLig6YswxUKHxsksZL9	6265	9062	9062	1617570360000	orphaned
12184	3NKaLKHikVorDTc7gaAEzXny7akZxMRfNiEpWcuToVw1hHVNo4pQ	12182	3NKP2ppFMLQytb1FN7ytUsVunMia3Ce4HxMYeoSNkPnUNLBJMHMQ	1623	830	174	6301	8520	jxiiL54G3JWBYZFUDwG5KRGFCh9immVmZZ6BrLQRZHNj3cGPgQi	6273	8865	8865	1617534900000	canonical
12183	3NKh7oguDvzcAvcNVi4Y69qcEEva8XFWdkk1BzBtTBZ6kCAw31Pu	12182	3NKP2ppFMLQytb1FN7ytUsVunMia3Ce4HxMYeoSNkPnUNLBJMHMQ	1668	1124	174	6301	8519	jxkJbHBgznAkKEdRN7zgZGa3W4YKj5VjXNkB8ptJcLietxffgrt	6273	8865	8865	1617534900000	orphaned
12214	3NLJnT6p1v4X8yWQ4j9CQ9K24gA2ugMgLGx32eEG6Mh5JExdg577	12213	3NKUwp9J1xy8LQBq6s12qN2ebcL7M9NAqc5QnZnmVo24GwFb88s5	1407	1395	175	6301	8548	jxnb18rokFR31j1J25Nah6ixMEXtBCVZY7auNMa4dYXmoZmBW43	6292	8891	8891	1617539580000	canonical
12231	3NKzEALpiPDEnUAb7BYo7sFpodXr81vt6Aq8i2NTgLvYf9hBQqRW	12227	3NLJ7bfWq3vcVJLLyF4FaqcXfH1vj5cyQess4cUawzgbfsjDBiwf	1419	814	175	6301	8564	jxQKV1bNFkwBD2j4qrKA1FFuhSCohDHhkYQPfcwZjaYowBqpE9F	6299	8902	8902	1617541560000	orphaned
12250	3NK7Fc9CXhzEzG2DWDi4ZcbfELKUXFn6hkJsc6Em6iekWa8rrfdt	12232	3NKfQUBLVPap3sYthV8MT1Qp4dYx3YP2RK1NPRDrhmgoBZK5i6Hb	1579	1389	175	6301	8581	jxmsVNXrpBaTanTV3hfPrgtWHX3hJC2sUVEmuBRwxDUWmhXmfkw	6301	8914	8914	1617543720000	orphaned
12578	3NLsJWXzomvMQhQPgC3CyRuRmNMKtR5i1zX3saTGfroUymQmjo2K	12321	3NKGkLxdJLgFsxZNgQ3uK6PfVBFd7EB7Ta31d9cx5dwH52JTbGw3	1579	1389	175	6301	8896	jxVvkGMYhGTXBcAGCyujySeo83sG1gC9YHAEWYsRJ8cKKdZYVUR	6303	9161	9161	1617588180000	orphaned
12269	3NKn6fCb3PCh2Dz8wb9aRibL3uyLshbQjuk4rTPxLR94Mkt2JrR5	12268	3NKjr3qzU5LQpr1r36hc9phDL1M3pnuEurgEWCQTR165WiUDGo5n	1406	1393	175	6301	8600	jxji4JNtcQNrxrkLGL6mwuJ62jDpmeiBrXKTETbv6qnBnNbUdVA	6317	8925	8925	1617545700000	canonical
12289	3NLYgmuXpbEVqND9xeCNmgyJkGFeqPKmLo1Kfgyd1A9GefpMsbUc	12287	3NKNYRLvmnJKAsCLTrrUdwJCfk6k9yFUdfWEDCez85E1MX2K7qAC	1467	1376	176	6301	8619	jwE8xodBVHBExygyz3ak3errHMY7jMj4udiEpu6ohzt7e5KcsCJ	6328	8938	8938	1617548040000	canonical
12291	3NKX2TfipbMFsKwCBPeAifAH5Eri1NYh9ntsE4AUwpny3B5k4Y7X	12289	3NLYgmuXpbEVqND9xeCNmgyJkGFeqPKmLo1Kfgyd1A9GefpMsbUc	1648	1284	176	6301	8621	jxQb17sC9MWDBptwnQoU5MUiW7zNEz4zt59MzxTH57VRmV6bzfE	6329	8939	8939	1617548220000	canonical
12298	3NLv8FwgEy9wqiSBrmmEjNTLF1opvezwkLfVAUG1LxFYJDS5AM7m	12297	3NLxBe7ozF9ofpL7APtwHM4j29s6nVgBTv7npop6Nd4EUt2esJPR	1553	776	176	6301	8628	jxy855g66Qeb5DDSgKajj6xpAmk6aiLaUBZwCvBK5BsHnpK5RCc	6334	8946	8946	1617549480000	canonical
12300	3NKwkmvgCWhy6AW8wy3WHPSp5mQi56DSb5wJpcWu9AHc99t4JWaX	12298	3NLv8FwgEy9wqiSBrmmEjNTLF1opvezwkLfVAUG1LxFYJDS5AM7m	1642	1121	176	6301	8630	jxZi479dFx6JL1BEH3fnMrqZ46wNtuHQAAuaP58zXvZGEd2UHCU	6335	8947	8947	1617549660000	canonical
12323	3NKjDpLDWdTU8nsw1NX3dqZWQvrRA6VHSBExPC6ADzPLL7joQ6ev	12322	3NLV8ru2SF9E9hX4w5cSsgWfst1FWeeyhoLpQ7WgntFn7BgGjrzC	1601	1022	176	6301	8653	jwzHP4CwviRm6w8Red9DetJnDg4EUxP9v9wnN4UjSrfFwyf3HmM	6351	8969	8969	1617553620000	canonical
12552	3NKKybAVAQbWhzqZRCkUDoS7FJNTsKqy2ovPxrgz4wQA4WQATo3c	12323	3NKjDpLDWdTU8nsw1NX3dqZWQvrRA6VHSBExPC6ADzPLL7joQ6ev	1613	1103	176	6301	8870	jxQu1xckKufi9eBxPbc82ENwbZZ5NNaL8kjBQD9emRy5gyZMttT	6352	9139	9139	1617584220000	orphaned
12325	3NKNxRSRrfZDhyE6pd65yAej3bTw6UmPV8JMqfApurufsiMLv4gf	12324	3NLJQutssm5a2gmYXQek4UgN6JbHnoqqZe731DtC1mm1wtLM73dT	1405	865	177	6301	8655	jwaBgNRn3KfVVyopMWpQajtYbFifQ1FMKw47DZqqW3tawphGMzf	6353	8975	8975	1617554700000	canonical
12331	3NLGfucdYQZm6xncAbzz3z2WhTZeYpe2Y3fk3qo788qnBYT5iPC7	12330	3NL84msvQLh512TXqnvDtjRkmTA7ChMKidGYW3MCo2ZtraBnUott	1509	1320	177	6301	8660	jwuu5qVeuceZQnK3BACruLkLUoQZUjm41aAB5zsrAo7mjHoC9rs	6355	8977	8977	1617555060000	canonical
12765	3NLUp9pFLysxP4EQAQDzmh7x4mUWKt3KjZQySoVc3io9VFb2aZo4	12353	3NLhJStQvR98oMfUngP7UCDiEkQQ8DYDdZGsAovCeAb6cgoGatvi	1643	1299	177	6301	9073	jxPn8NeEhVSSSFXFGQdXB1cFicRiej7trB97NqwQPTkAQqfWAAe	6370	9312	9312	1617615360000	orphaned
12370	3NLEKMmAjrF5RqLWa6N7nDEnx7uE9xbfSMtskH86tVP8s92bzUTV	12367	3NKt5pAfBz6ZXiyXBUcSxFNb2SDGCQmTG8ncHCpHwpgqg2afp4PY	1646	1354	177	6301	8697	jxE2iidXJi8hfxAWxe4UDRxHmYefKzqhh4o3n4dc2dseiKr15Yq	6379	9013	9013	1617561540000	orphaned
12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	12371	3NKPpuMegA43hAaUzuB7LCqCdANVuGbAr1L5pgPpwUFQfg2H3Skr	1671	1119	177	6301	8700	jwxemvpSnax3Urcx1c1KKHj3asU7Ajk8Uij1KnmzWn9JMhbnga6	6381	9016	9016	1617562080000	canonical
12376	3NL5Y9bBwTL8Eb51iM6z1x78hMjPkZErJ5Z1xgxyZbQoDxQU9cgu	12373	3NLtvkFVELEcLkF6ZV7wE8Z6zD84Vovw1pKESvHs2TMKw4LepoY5	1553	776	177	6301	8703	jwdLNWCqRhRs8iR7jV4AXZv4XnotrCrLwy8C1WQQNMdv3bJVmdk	6382	9017	9017	1617562260000	orphaned
12766	3NLY8VNtzTU7nZTMLD94sbwXtbThdwZfD4fK2qouvFi5SFeYAxFy	12381	3NLhzKXDL2Rr8xe8bPyfyEJmEE38G9kxgUjisQKR1phau6CMG9kn	1643	1299	177	6301	9074	jx5HH8WMkejQn3pP1D51QC8fjkSFDonqhSH326qLe7dd48CQVF8	6386	9312	9312	1617615421170	orphaned
12423	3NLFwUZyMgN7c8ySNcaYxWaSKQkWm26LsSYDBP6NxdC6rgK3kZzN	12422	3NK7vuV46n3skVoXgdasaZKSz4PnJFzWSYWUaxw27NJTh2zbTurw	1407	1395	178	6301	8747	jwXmktr1zaTbdMKk9PknYqNXt5CwP8BkR1YhyNSn4sugKDpuELQ	6401	9050	9050	1617568200000	orphaned
12417	3NKMwUiuWwodS3DFdoFKgKVArWaGGF4j8Ch47vuS6HJvWRoDMBkj	12414	3NKiyrStVxdiyLpGDAL5tfS5AjqAdgwnBuXyH7dXi9sUN4uSDVsB	1500	1051	178	6301	8742	jxbfSSr1JgFdSxD9oWVgk7aFBjVGXxWqFBXeVBW69RETXRygfwF	6403	9042	9042	1617566760000	orphaned
12420	3NLCEpT82TvCWUownBay9tzfyKVApxWrFh9vtSSxqrkUtW9JAbEm	12415	3NLnmFivfKpG9NVE3brKMJAn1fMNwGPDL1vS3trkqdVDyW5z8jZX	1403	824	178	6301	8744	jxQoLVmrZ4rQqCALNbJFqnmGkC2DDNzWbeG4gYiRMMyqLM9CfbX	6404	9044	9044	1617567120000	canonical
12424	3NL1M3Qm9Dg19e83Xnfd9jwEiEgyjP3PgqQtQ9HFB3f8FbcA8fJw	12420	3NLCEpT82TvCWUownBay9tzfyKVApxWrFh9vtSSxqrkUtW9JAbEm	1402	882	178	6301	8748	jx7fQ5SEu1kupTrd8wD9P1s7uo18kcHR3TjnnRfsa2ekZ8Bnhje	6405	9050	9050	1617568200000	canonical
12426	3NL4hFowmB3JD2tMYJTkNNLNLPMgV2kdcmLh13c6Qydhi6PvrVL2	12425	3NKfnAf7stFjTK1LTwuGFMpySEQq88vuyYkgHABsQvNCbGDP3DxR	1654	1340	178	6301	8750	jwzn3X4GmF7gLtzAKAVMBEdey3vKaTGP8LLciQnVTzKA9o7kGe7	6407	9053	9053	1617568740000	orphaned
12444	3NLsYM91Sy7AsuV9T1BGjoe9qacwgYNSiRrFozZmuHeHJtUhZbVn	12440	3NLkUqAwqoqCF1HCm1cUBxZatvdDCAwygx3fnn65rxermVQKDb4o	1407	1395	178	6301	8768	jxzTE5Aivt8r8w4uba6YDgSo6tr2svKU1Kxf84QVbV2DmUb8LoZ	6414	9062	9062	1617570360000	orphaned
12449	3NL4MUMN1U6DVNGca4Pn78st4wD6mty5Qr6AboGCzf9N7YbRBZdj	12447	3NLtRFKKiugRbvopHDQwMXuNmq9KMEkvYqWSe1dNeBy158WenB9S	1501	1360	178	6301	8773	jwbBJZNfyXyUqi99evVnjrA1iTTcj7SvZ1tkZFCon1qLt4phRra	6416	9064	9064	1617570720000	orphaned
12479	3NKiU5QMHXmpVQqQr3Tg2p3kugHxM5X5cWhZSeK9ykddXKbRuoXg	12476	3NLvLPzcQD84Gya8yAiSMvUdFCQKcSELyA4G5BoryxMeXcxx7i5c	1553	776	178	6301	8803	jxGzQfnipnZD22DvehaHwNCnEuneS7gC69GiLfiPstpF4LySL68	6430	9086	9086	1617574680000	canonical
12725	3NKQKSUVxRKLVTwQ5n69uik77FHHiqyvyJBWpWZyugym79wMfMWw	12479	3NKiU5QMHXmpVQqQr3Tg2p3kugHxM5X5cWhZSeK9ykddXKbRuoXg	1542	1178	178	6301	9037	jx4S3o7QRnBAJVsuqGHgfTcBFpGZfumoApQUSmkDqUbUTfnw6dG	6431	9278	9278	1617609240000	orphaned
12486	3NKDaZmUJERaoMubdWj645XjrzG2DFfmhMmRU4mnjjgY3im3CrDJ	12484	3NLmxd3Ve5tRhpLpojRkacq4BokJ6PZo5PUJmMFcnC3m4viAXNQD	1553	776	178	6301	8810	jxTK6NokmViwVL3ZaQkrjGaSLAu5x6t7D8e9ESPdkHKFfjyViRC	6436	9095	9095	1617576300000	orphaned
12489	3NLHwpi5Kj8rtqrVmNCM9cQKKmecNogcCPKeX2ttqj4X9Vz76TXS	12487	3NLS4gBUggkYNdRCC8fdzHaKja79bvmdmSdYNLv38SBQuzdRuWdn	563	1359	178	6301	8813	jwFGiD689X4AxbqD2Yrvf7F66HXuPtSeKCgUNYKmyVNxSdS5Kw2	6437	9096	9096	1617576480000	orphaned
12496	3NLcC6W5YpkBRnAbQ2LNENhCLZphEWCKooAN1Rr1a8YXq7yd6MLN	12490	3NLLQzZ2FzvsMz2KuKyaihUQzUViLtm1Us3q4ZgYec7MA932t55T	1651	1301	178	6301	8819	jwmJM78NKTBPtE9vVWbTprs2mnj2KKqFQRBxi5aZ3fqpG9qBQNi	6438	9097	9097	1617576660000	orphaned
12505	3NLW5EyotQjzgcUEj5BaEuyRRyqbRG3ySorvFVTRx8LwrnUA3f3g	12488	3NLFQeori8ZGkkeP4hPizVfQ6nAkxNAomw1cXpXpUZqu4o3Z7suA	448	1305	178	6301	8827	jwwAhURKuN9AztaMybu5ZV7tSoqYfBVJc6rXUDqnPYpE1ma4M39	6438	9101	9101	1617577380000	orphaned
12547	3NLd2YBy6VD3x6Gc3CBiMQzQuZTP233wGUmV8AyqTE2wswPZYEPi	12543	3NLNhUZ8n3JoSEwbimBCxBMpdzuXffn1HsNUWrFCKWzvSDwtKYBQ	1523	1321	179	6301	8866	jwN5FEJB2XrCvRWWjnKu5N1Kr7CHK8gp8skRg45B3J89A5K9tfp	6465	9136	9136	1617583680000	orphaned
12884	3NKY391eoM6aQuNk6FeuYGLqUefabuBafnvbv85GmxnXxRWYfnKC	12669	3NK3iczmFnnusyneCnjBCydmtmpEWN2MT3k7HfceYz8NamCV5XxC	1671	1239	179	6301	9183	jxaEabbpkpn8JbH5LoWbxeFAsckoVDWeFkK3cFSZPUNKSYCErgx	6467	9396	9396	1617630480000	orphaned
12561	3NKdqjtqyC3RhzYbxdWUZnqRL7qWRYgxQeZih9eZt5x7cFkz6oyg	12558	3NLLMFbcmwwsVNYKUKCVVDUzm3B8r48aoRwzKnWMF8dRpoQjbg9S	1406	1393	180	6301	8879	jxVhY2ChcgG9ThmzS6Nx8P2TPze9DigHg8SRDANcP5zLVckLkMs	6472	9146	9146	1617585480000	canonical
12729	3NKxodu4r5RtssNAF16SxiuVUV9y7aZ11oky2c6Vnf9XxZKSp286	12716	3NLoyVPppk2AiC1JULhrRw9Kh23AtJh9TXUNVx4ovHnn8UaiTtND	1675	1096	181	6301	9041	jwK8NXW3DBbsvcnJ5o7GEKma71hLtPBr4jyiqWC8H5bBougLZgT	6481	9282	9282	1617609960000	orphaned
12577	3NKV475GZbXo2nGmscxUePAT4w8A1pfhV3ytcawGeZFrfbGsG1a3	12576	3NKhKGnWr7HZq2bWqnY8qgcJGSKZujkFu1VFL9mNQbSdnakSyYDn	1579	1389	180	6301	8895	jxwGxC7N2UHHidgSYr2prwBYoVn4Bwy7JgBJdbsNn8thgcrqe7K	6483	9161	9161	1617588180000	canonical
12985	3NL3hhHnov6gx4gjVPY68CLFv2KDvy2szRnmLrh17BYi67XSHoBK	12817	3NK9suBainM83RWgpe4va3PNvXwc4hxcAka5E1UqmfrrVsbpHcmJ	1675	976	181	6301	9274	jwBTuc5J9TUnUT4cULDs1kN7CsbDneNpNxYpUqNNhiPnyA6yD9A	6483	9465	9465	1617642900000	orphaned
12584	3NL56v1JoNKWxqWHGnQk3WvhE38HjeWBP1ovhBBFk4oXT3P6aTnz	12583	3NLcTxpKcab4ccxWcTgYtL6Dh4y1AZ2eQkd8JeDTkwc79R2QWLBc	1619	1029	180	6301	8902	jxqwgGaTFGEkUSJ9JUpsaGMtWSKLg1ic5KxnGiPgKCw5nHihWLd	6486	9164	9164	1617588720000	canonical
12591	3NKTHf2jULPf7CCSySXmatzkvwkHGTroQx6RHrZPdDsCHsuNmR44	12590	3NLDiwowvQzjNLTeGbkGdErkPjRworFRWZ3q8aEYqcZJ35ZpaxtF	1406	1393	180	6301	8909	jxF8NiEyUe4rnysWfqFkjY56jPiuvMNS2ewo8KPd4yqg62xRKTr	6491	9173	9173	1617590340000	canonical
12625	3NKm69TR4UUzLbFqHz7fdGQ1UNNjAHya4vwgFqV29cRthjJDeh6T	12623	3NKdfKTHGt1jqttJpQ5vQK6AaVkRHrTTwhWg8eNQzEeueqWTcPp8	1622	1356	181	6301	8942	jwLQeHUgbrcrKkoxXwvD7NPQe4vixTfojSjL3qSLitFzaQERL1n	6516	9210	9210	1617597000000	canonical
12634	3NLZQ1vNRVJ6PEUs8hZZxSPYtSgYsufzSTXQWXPMu6Duw4A8F7TX	12632	3NKiLsvCc28WjzzVv3y4SYWwLRNiM1fmFKTwnxkCwJo8oBgVRkj2	80	1273	182	6301	8950	jx95Bu7JGYdynJUgAm1WqSkbedshjFAoNGvqYhL9Md5nGQuBJ54	6518	9212	9212	1617597360000	orphaned
12673	3NKxBvcUn6ThgSzQnw1jwjXBUSzAgKu3xcfPcEKgZDXJaYNmHgsM	12670	3NLtQ6HYGaZToJpM1trxdzn7DaYY9iK7ZEiLeKkipKCp41AxEBXz	1651	1301	182	6301	8985	jxaVFRqGbZ3sT5TQTej5EQuCbXpFiX27efF8ifeHbxTfz9GGbDq	6536	9240	9240	1617602400000	orphaned
12681	3NLgsc9n1b7scXwwjuoECrj6ZDYdvTQ8LEa1pjTWr8fvbzKGFtWa	12678	3NLb7ytJwUdeNYWBn2J4Wb7vAty7yUJzkVHg324FfdgiDWFMsyZ7	1407	1395	182	6301	8993	jw9NdDmPXpLzEntknH2Wqs1xGZp7qdzJB1XFAPXGtgFDhj9aN8t	6540	9246	9246	1617603480000	canonical
12684	3NLJKiLhPgiQgUTUuMXPMmBh6abveP9rGCcp3s82rMKpJipJm2rH	12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	1672	1285	183	6301	8996	jwdgDU2FqPUnLbnAwUYtkUXZ6CbV3A66WVGSxeBFkYZrf6AFgow	6542	9248	9248	1617603840000	canonical
12686	3NLW6e3HsnoE5pqjkVKiuNRJsrFTT1dWFgT2676TJW5taNXqWLyS	12682	3NKKnQ5n4wvtvtcVTmR5zJrnTwo8sXSFceMy132C4AW9kXMuqQA5	1673	1122	183	6301	8998	jxUF7Cke32XzanPLMCVnQfBoxP4Ngn8PwwTTYay9rKrz11KgcKC	6542	9248	9248	1617603840000	orphaned
12692	3NKpK3BWfPKeiGFBMS6L2MpUCZ8pkXFG8NMX2gpyJAT443LDKvzA	12690	3NLNLe41ni4svx9ADiABhzxcYvBWn1k3ZN3ewoqfu9sD563E82KP	1474	1083	183	6301	9004	jwXmNZ5nAtL4xpY14Ux312nhDkgHshCfyc6gzTXdxy17xCdcWEz	6545	9251	9251	1617604380000	orphaned
12708	3NL8eZwT926r9zAU7uhdhqBUpQihVb8W2PxGUnDgtyASyBF8N2vB	12704	3NLWJKhg7rZH4iRJZuub5SQuoDWFwith1GgECHCHJ1pWzJc8o9Uh	1623	830	183	6301	9020	jxMffGcKmeMpSLrJwM7UW7YuuFN8M1W85x2pcvm3Th8RFXzpCsk	6553	9261	9261	1617606180000	orphaned
12721	3NKPNEDrudfxPDgms7sN7LxAkwF8zvcRDbHmT8PZc1ywGABKBpMw	12720	3NKemCJ6Zg48AJAwPwXjRRQXJy7C1zXjvQ3yBFeZbPm3Fio664D6	1588	1026	183	6301	9033	jwRL9VR7mcXuHwj57hLpSDyGpewmXbN8oUjeA365n3iwxh33JLK	6560	9275	9275	1617608700000	canonical
12730	3NLTpC7W2PaBxhods8mAinHrHvRdmyBYvuommg5LTotCr7F8nP13	12727	3NKHBqD9can6Mmqa5YV9dwKfL4vpK1S6gVWjCy9yjmpAQeRKMyCo	1631	794	183	6301	9042	jxmyukcUtTyrbqMeRkUW9w585AtbPCZwbZ2Xoz8KwKPWmVDrPu4	6564	9282	9282	1617609960000	canonical
12734	3NLGkiQfhgewrjHMtPMjixU7G4zZyy9Vb44humPsw3XWo53eeWeH	12728	3NK5SugZBBG3QfkstZSuooQy1oHw4v8fAA2GSY9kKxN7nMCrKgai	1407	1395	183	6301	9045	jwBCiu49UepXsVTjvFo3so49h1RNci3p92iHSBzb6ALXMd9WF3q	6565	9283	9283	1617610140000	orphaned
12848	3NKPF33CfH3URkMP9PeuYmrN3cLR14MsBgGphJCLjjUL3s9WCGan	12768	3NLjZGLP7VAJzu5JZZMp8SaQJZL34TFcrhb61prt6RvT3qdka7mJ	58	1155	184	6301	9147	jx1NC7NDwL3DRPUgt64bjbnsf67C2KCgpL6nMsqiGEntZ2DHhcZ	6585	9365	9365	1617624900000	orphaned
12772	3NK8Ypi61CiaRmWHZ6uDxjFV2d9CTEbgDKwWUKUQHacCcLbZ45sA	12770	3NKrMXLbeozu9XEUSvQ9Ny52Hm3EKfq1hQ2eVCttVkstCRtxrTET	1403	824	184	6301	9079	jwW7c87CHfQDiw7EesVyYB8kxtZ6mXT3Xvwe7JaANSfhDmRJeCr	6586	9316	9316	1617616080000	orphaned
12795	3NKz97txVcYDpDBCyjsm44b1bfpbPConcaTYT32TbdWujmsdmCNa	12794	3NKAE6UQgVJ3HRGCddJjLFWyK8G5i15cqhy7nPMVrb6HEx2AFJsn	1600	1372	185	6301	9097	jxmyGZBpqrVAoUqfTd52p7VPewko6fJEDihMdvaszxv1EhEHKa1	6597	9333	9333	1617619140000	canonical
12806	3NKtqw5VYiawKYWrTYuW1UyaUd2mYTecrGHjFYbaP3Xs1dzuweDD	12803	3NLkJ9KLqYwnDPVB9tnAUn12uLdJXTvdSUVpzefiC4RGhy5dC6U2	1402	868	185	6301	9107	jwxFZnsrg1DrjvTD21LcPqfbSFARS2wqaU1nfQVyaTEvpjiGcs8	6604	9340	9340	1617620400000	orphaned
12834	3NKsoeVVeLXyBgRcmdEL1bMNw1BCpjfx5rYZP3h9B7fesbTSiGXy	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	470	1183	185	6301	9135	jwPg1sfS5jFRG1SvtbGcbq65ZjQJYdijmdVwLEjU1f3aESwT1JS	6619	9359	9359	1617623820000	orphaned
12833	3NLZ2x8TsXV6QxUyavW4g7UcHVpQGBzJcNjphv3ZZ7kkZ44v6bE9	12828	3NKByABP2ort9ePb2SEc9o3hc9gE48uvcJSjBp74N5VZnXki2yoo	1407	1395	185	6301	9134	jxL4wJK4HuM1HJEYXduzKz17g79G6gf8sGkY8vVqoyZCZ9iZLXC	6619	9359	9359	1617623820000	orphaned
12835	3NKJB3xuLgqiAYSzvyN2LsCW9cawUpRTA2RoKd4CGvVQAyNXYc6D	12830	3NKdqdpNdX44AjAQn2P98mxLspN1w6vq2iVRpiBZF5GguVXm2TkA	470	1183	185	6301	9136	jwKMtHEG5zgU1KBqCUwBJ7KSKHdE8kCgiieCw9xrh9D7ZXmPYzW	6619	9359	9359	1617623820000	orphaned
12837	3NLAhmQdt71XXxFWVoDLuGx3bDeSe3yTSayuTP1M3KayGujNnX7i	12832	3NLXd8ZM5Znqhz759EuTCCQJc5FXsUhDxhxPMfnZ1PkGkCWVYTfn	1471	1140	185	6301	9137	jxNXnyS6rPirbEyjeEsLrQN9Yo56EqWwfmrRoBGLSMXjAUKMS7K	6620	9360	9360	1617624000000	canonical
12853	3NLHUfuQzD8r8s3EJnLCMfA5KF9U9psNkP7AdXNd6jcVXGNYpWPE	12851	3NLgDJSgGDiJh6Fh7VANCs86nSnR5GUnWsdTgvZrUrBwjdAawCnP	1406	1393	186	6301	9152	jxyTsMH3FriEBvtiNWCrUeo5cYVqgY1dY5ahxJKonxuRaT2KYRw	6628	9368	9368	1617625440000	canonical
12873	3NKNKZynpBAsiK7xeXwbxCZdRyXSZGNzuxhw4fXwX45cNfcQBXGs	12870	3NKQcL5PMyjo6zR8hUW7KAJzizbX9AqLa8qgiWUceu95ALWKUYmn	1637	816	186	6301	9172	jwTnRAu2cCLUPGj5jefzec2STGnHe53yA6dSBCJ3bwQceziSXxA	6638	9391	9391	1617629580000	orphaned
13034	3NLGiMkXNLb2nMQfrZ2A8Wo89QLZED8uamoehooJMj61LX9GvSjv	12882	3NL1w2ouT2pKQMm2K2dyR3duB8qU2mGY3SKn6ee4nihdKb6m8a4m	1455	1206	186	6301	9320	jwnxsJecAbyBEpw9ZNMK39L6PovtzDEbBc1SqFDdJ3vGEHipvqj	6643	9503	9503	1617649740000	orphaned
12889	3NK6HCEAXaeePHpbVjh9b1DVCsmxnRyF8R3QyHstmyqenSmEb4g7	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	563	1359	187	6301	9187	jxbhdhDgJeoXXJfQbTUkxmANcrrjLHT4TDxXLAsoBZzDeHybPDK	6644	9398	9398	1617630840000	orphaned
12892	3NKfsT4VzRP1aegCM4MFEn5davd6kXQJvipNFQ1ddwhcyYQA6ERq	12886	3NKZvs5r2zUF8ciXzvJoLnijQjcj36oemJppkEpTpGuFaijPM1Ux	1627	1385	186	6301	9188	jxXd3SLavN1o4jDjiVKGj7SH4AoBgHgtxE8Q6yGnmyC4UdvdVqF	6644	9398	9398	1617630840000	orphaned
13047	3NLGE4dSKt3B9RqqGepiaFoQYEL81nnYPgRszWrVkk1JL2Ax3NMq	13034	3NLGiMkXNLb2nMQfrZ2A8Wo89QLZED8uamoehooJMj61LX9GvSjv	1455	966	186	6301	9332	jwnxsJecAbyBEpw9ZNMK39L6PovtzDEbBc1SqFDdJ3vGEHipvqj	6644	9514	9514	1617651720000	orphaned
13106	3NK8BvshvDnNsH57hsaYXbh823xSbwNmdSdX4SeRxSLyhPQJzZrC	13047	3NLGE4dSKt3B9RqqGepiaFoQYEL81nnYPgRszWrVkk1JL2Ax3NMq	1455	966	186	6301	9387	jw8mkkwEx1sLb5K1vBT1Xr42V8xW488pLK41WoE35dvdgxi6BfF	6645	9546	9546	1617657480000	orphaned
12895	3NKyhuCtGordXujvEaBPcpWkn6gVHwusFbcbLykMyFk64EU9f9va	12893	3NKoKZwTnFrk9krcYhAWh8chmSLTkSVqBjYFnrj3K278Hih6CgC9	700	840	187	6301	9191	jw6tMKRxx79nPW2dmXN6U7HJQcjKYPHgZrpxdq3Zgxk9ExuAmhX	6646	9400	9400	1617631200000	orphaned
12902	3NKfPzdcgbFSh47ekXu1dCK6hxcj7z3UR2TcSBVMQbLQEADLg6ZA	12901	3NKHCC4MmDNWtbjA82g5KoMqJYpRKFZyUG53geT37takgMLi7btj	1503	1277	187	6301	9198	jwm5rKKcbnGf6j3BJpmkeG9dPAnTU2cQMHgEmqqoqvvQEqvEeXT	6650	9405	9405	1617632100000	orphaned
12919	3NLBXwM7drXF4GpViQJspSbzqnoPuoMqD3sKE3hicEx7HoAffe2m	12917	3NKf4BF31zm773shyMta7Em5KxBrmytVkuQKNCwbmWxtvukevJSw	1637	816	187	6301	9215	jxQh5pZF5nwtzdrutuZDFSEMSVWMk4F5n87x6ecAmE6KTtM5EqN	6658	9418	9418	1617634440000	canonical
12933	3NLY1j7DtAczCbEAKL4bWf2UAXykMZkhKZ2wCWrNC7oFZ6hnsthb	12928	3NLharLk4pjDGCLCjmVt8sr2EBuMvaXNvZ1bFPFcFWyLkKNLmWy2	1610	1188	187	6301	9229	jxP3CL2kBTCdLsbgwkctKqDEm8spBG9nYxWXkizSB7ExxSytHGd	6665	9426	9426	1617635880000	canonical
12942	3NLpQR4ZTMnQsDzvtBes7jqoEQZEspiXqkJLWNhxSXPQU2oSGprd	12940	3NLqyV9XmsRv82bLkMCr8TqBLQqaWSDxPrH9sdPUWyw35qQ9eizF	1602	1243	187	6301	9236	jxxAHipHg6c7huCaxDu7aZdTfkEznj4GMK59t4g1DJGq5UtNNJ1	6670	9434	9434	1617637320000	canonical
12947	3NKNhxxh8y7zk4AzHQkwczhSWDV4tKGe5fqqcrTaesFFaSWmdU81	12946	3NLRixZMj6G7HUM2Xp5VGGvgSvzJDRAhpLAJHEZaW67wc8t8eEH6	1503	1277	188	6301	9240	jxreBzL11h2kHxoWR86RvJgE5mtqTBmK1qgG3aMzkPcRa6PX3mi	6673	9437	9437	1617637860000	canonical
12965	3NL7bVGNFBZGQePDS6bJmr7422AZRm1FQvMibBhvHhiwZuN9d5P6	12964	3NKCrk5c97jEu1SvoRWjr6gt8jHXcehxV5vsxswrcA1UxpM5hTDr	1407	1395	188	6301	9257	jwh8qc23yqV2DH8NTvPn7TnWDCiQ7GnxLhR4CPagTq9E4WfpAUc	6686	9455	9455	1617641100000	canonical
12972	3NLDbAxzeXFBBRTA3qdhEEaBzBMVyeXKM7y3hUQVpDVmgJHGTrSP	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1406	1393	188	6301	9264	jwZwadAYZCW3gGg32XRk79Rc63MHcq4kirBoWfqPyuAUXNA8RR3	6689	9458	9458	1617641640000	orphaned
12976	3NKfLMzWNoLUEoYt9HAtK2TgsBnasLcbgj5JCbsU9R9aS6U9EDY2	12969	3NKVKgz5qnuwcQ8thNV7UyrF8XBT6CZiuVUq2qUt5kx9hR1BUZnQ	1631	794	188	6301	9266	jwPsg8jnekcAeiMauE79dTUfEBG7MECUhzrMWw5xsUxWevEEd3a	6689	9459	9459	1617641820000	orphaned
12978	3NLn5z4xGv4Lrsp4RhVcy57HzFT8RNQegdZFiVof3SfJJX3qtYsd	12975	3NKzE4nrzQAtYyYYc5szG4fBkCoAMHNPFyaizbNn53Wns8yrhpuT	1637	816	188	6301	9268	jwoBuwWb77i99UC5E1KJxVVcpoq3GxUGVqY7HHa55DC4gPFQwjT	6691	9461	9461	1617642180000	orphaned
13021	3NLmnHvkdzFS8KVizfy87ZbHiwpQJEBo4U2By3fLx1teWK8g7fRF	13018	3NLNta4xodstrokrm53awwccSQbSnxPBuK3WCoZuefWczfCJ7sUE	686	686	189	6301	9307	jx5mGpQxDE9NRVv9mg95jbR9BjnBWTWjftHz5bxWYu4bSVycctT	6712	9489	9489	1617647220000	orphaned
13038	3NKGM7pqzuay5ZPWzh336GsaSzWbwnNYUMJb9Ht9WoMSWecZK3yJ	13036	3NL4kyL8usP2Az4Y9KbA8Kwce2jPUmFSHEDBy6ZidNoFvWLHVbxj	1403	824	190	6301	9324	jx3i8V7bPSa42Lz4VzBmVYF1sGhrSScggbMR7ZxK8aVfZZd2rWa	6722	9506	9506	1617650280000	canonical
13052	3NLRSkqRxSyxm7bNgU2D835C7QWniQtDrujPNvnyjw7Swma61qAX	13046	3NLhbhaERuBtyqijqeyZhpghixtnd4R8euX2i6nv4pEZ51mdj4Xg	1637	816	190	6301	9337	jwNWCRA3LuNNz9BMzfRjaYL9mcEbEwSKnsJ6Ee9eHLKgArc6qq3	6728	9514	9514	1617651720000	orphaned
13657	3NKZbDyaUcfx192AbGiZfdahwgL5YiyWEtkkJDtdPuTJbu3TDADn	13054	3NK9nkfMdV5vBbTRRkr4B4iZSe4NQaBAKpgyNQXVVV8BGwN9MTXh	1646	1354	190	6301	9869	jwmHkLDDhuKyNjjVBHdmyiW4Copr45ZJaBAyCuqrYNAQNtQRkNm	6731	9927	9927	1617726060000	orphaned
13062	3NLe5jMvYBW5fxVygcmBqTN1y4PmMdbQfH8nmt9YeW2K7q5BDq5V	13061	3NLmhkN2Pg2df3tgpBqcb4vAEz25svkjtAtuUtfmoAdY8uZmZeKy	1397	699	190	6301	9345	jwoYHJkRvbWM4zcZoGUzdmZBXqvPnebXPKPHsgF4HdbDEE63waP	6734	9522	9522	1617653160000	canonical
13069	3NKDbwzjaMP8txhh68jL1MaHibu5WJoM1zop6nbaqQFRRyCpA6DF	13066	3NKGqAhRk4pTf7szvphB3uewxGYfGStjG3HHgDE6342QGsBXHifQ	1406	1393	190	6301	9352	jwkeoU5WmBmHGW8zQZy3sjCASw2NgKTCTLFRMPco88jA3JHjFiw	6736	9525	9525	1617653700000	canonical
13077	3NKExwQiJ7AdBNBEhGMHpJghtKKmnUaYMWCitHkNMyPjf1vsLm1u	13075	3NKtkEFsmPJTuXMQ1AMgL7sWmX8YxumwUDHvzK97WZS14dKziznw	596	1180	191	6301	9359	jwxA59WyhX3JRrZEBs7nGJBP2H6bwENXSAYrEY5vc5GLVQQjrY4	6739	9528	9528	1617654240000	orphaned
13081	3NLhLfqZ3BraDWXetQkBdG8BqHR6AMFqPhc3nKezeTD6G7Tz2uPo	13076	3NKYNmdPkqgTWmYgMaFGY25yqRnBpgK8nXaqkkVsEMASE1ADjD9a	1579	1143	191	6301	9363	jxyDkHgPVQG1Ajt58APj9noFChvg7k8XkJQSVgPU5mGoAnRy769	6740	9529	9529	1617654420000	orphaned
13362	3NLZNSAbpFyMQrKkqMqwd4gH3C4j24Jf8jhyEkVqT7jdhemv3qyV	13087	3NL1CkX8Tkm4Abwg4HNaxecBLCFBEPekxdy6xtgCgaX796k3qjQQ	1627	1385	191	6301	9613	jx52Et3Xu8ji8wFVVYiVftbHJv6G7sjHMzFhKUhRTo56AhuBrA9	6743	9726	9726	1617689880000	orphaned
13101	3NLMzCxkcEAQPN25M9kSjursjVNB4x45zgXU8Gf28Rnxc9XxJBKV	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1406	1393	191	6301	9382	jxL9JU6CoCjQYo7LP6uFjxNJAdFQgHwt3bvDpi23cscYskq83d2	6752	9543	9543	1617656940000	orphaned
13170	3NLZXSbDCUfQHitjDb7Zh414WPBaqKhyC3AMybQ8qcMsnzKiewWa	13099	3NLWc6QXzLscCVQkuzdd2ZeqgcxbkdT1G4ajwLpEVvw9VuhSRSPq	1509	1194	191	6301	9446	jwJMC9jnkuH6f3J2fotmAmZZQwL5Q4hVWymCdC64V5qR9PTqStH	6752	9597	9597	1617666660000	orphaned
13466	3NKFZXZaJPHKaPJqQeWeegT4o7xSCETYYNzH9S8Z8bAkuWbN1n5m	13170	3NLZXSbDCUfQHitjDb7Zh414WPBaqKhyC3AMybQ8qcMsnzKiewWa	1509	1320	192	6301	9705	jxpt19ZhLsJS37CPKi9u6Tj36spXJqZfCxXJWZiQEVK7bxbykm8	6753	9802	9802	1617703560000	orphaned
13183	3NLG3JE5NCXoHci3CJ65XPnikMGhQP6w4YNJ47yrisZgWXujZq97	13112	3NLYGybyoJXLN1io72J9hVq8KbWWeZMm6Syyu76zadN8FaVxcKxX	1542	1304	192	6301	9459	jwbUEmdMjovXQ7f2FgLnjzcfYfsTKHJxgRAsytULtkRmjdoiGJs	6758	9610	9610	1617669000000	orphaned
13217	3NLLvYR94XtKs9kbnrC47dNEZjw3rBxRDJfQ2WqdiT9WW3MwbaTk	13183	3NLG3JE5NCXoHci3CJ65XPnikMGhQP6w4YNJ47yrisZgWXujZq97	1542	1304	193	6301	9490	jwZioJqRGhiSWEMjLKwd37ri9CrkPvoZJVXBruj7m7ry7SqLuVF	6759	9639	9639	1617674220000	orphaned
13537	3NKWC8xqmzDzQjnn6prm2FmQxG5y3z2FW8KBmhco1VHjBMozto9h	13234	3NLwF1hJSSVsaEHg7P5VPsSLxBaZ8coDvoZSrdUX6uo9B4GneSET	1542	1178	193	6301	9766	jx6qwVS1EJ678SQaJA8W8u7ZSaWg14FGZHNauvXjwi4DXNjAzsy	6761	9852	9852	1617712560000	orphaned
13135	3NLB8osbwSdGkRMVFBhmuYmw2Qgrn1rnyPpbQVj2osGn8TQW4dYX	13134	3NLi46hkVg7piNSMt2MAmioMkSbST1QoJ4ELkRCCRkzZMQoUudDE	1460	523	192	6301	9414	jx5doCPpHAa7jbhaH9Lep2LjPobZ8WztDzhVLpq4vmSBPPDYWAB	6771	9574	9574	1617662520000	orphaned
13158	3NKYxmgH7zF6qjqAxViFgNRT9uEVydEyTyLNZJyJV3GXoTXeBqYr	13154	3NLfbDwCmWXvVRJEkq3VFsAkrYH2pvm5udX4cwKRzqJ6WhRh9akt	1483	1276	193	6301	9433	jxzBJjgYCARMDs5XRshqmepMdV6ZTJiMUh6T3r7avytShHeoeLz	6779	9589	9589	1617665220000	canonical
13160	3NKTY3YK6uiZ4iHK7a9x6e1dvD1u9J7wXWgv8oHbJtwJyu3e52kN	13158	3NKYxmgH7zF6qjqAxViFgNRT9uEVydEyTyLNZJyJV3GXoTXeBqYr	298	1308	193	6301	9436	jwoKdqUU1sUMzKtGbEcQHfYiHCAxbHeAtFbv9TJSfjXsfwfMkim	6780	9590	9590	1617665400000	orphaned
13163	3NLHj2orze6iWykPLTynQ6e8FMwUCrh6DVxvH9KTVmkJ6qSHqCMe	13162	3NKG8FrVveA8UYAjjGPZfP5nb9eGin395jm8usuiWRzwzZUDZ45u	1407	1395	193	6301	9439	jxqJw386GmKH6mVnmkSAbghBSXf4URKTihnBMgs7MpW1vqYawDU	6782	9594	9594	1617666120000	canonical
13242	3NL7mbWHMWDfJpp6Hidq3C6xF3ecxCAEt1RSaLddN9Sy4fQJ7nad	13171	3NKzz2AFU7DK58KUpWd9WCT17r8UNN4DwTyedkw23Zuy76uV7Q3F	1471	1386	193	6301	9512	jxiX3oVD6hdN4dx35imTP2LV96GtmckdDVD8Y47T9NhoF2rQ1vk	6787	9649	9649	1617676020000	orphaned
13327	3NKm5UUmyc6reg5v8TfNh5GgDwWHRqYChBY7wmybpYH6VMAiJJUY	13178	3NKN5P1K1nwThLE55G45MAjLfbn94dLye2jEqgZLhbLEHaiYcrhH	1553	776	194	6301	9587	jwC2sK8G6aaZRDiwUc9u6fo48sTqDFYFiibqsXgdkfBrAfCKhpx	6790	9708	9708	1617686640000	orphaned
13370	3NL5uvtjVU3spG6eVGK7Pz8wrkcJXHp2H8ptZaWEUVQaXroYRip4	13327	3NKm5UUmyc6reg5v8TfNh5GgDwWHRqYChBY7wmybpYH6VMAiJJUY	1553	776	194	6301	9621	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6791	9734	9734	1617691320000	orphaned
13389	3NLKCAEUYdiSEmpkp5NbGqHRtJMgNYJuwXi1vF7L9y73HwccsUJ6	13370	3NL5uvtjVU3spG6eVGK7Pz8wrkcJXHp2H8ptZaWEUVQaXroYRip4	1553	776	194	6301	9639	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6792	9749	9749	1617694020000	orphaned
13417	3NKR4bs7JEM6DYEHyJYHaQSEhWPm5bodCv6GEoXA9A4MN1uw5PPg	13410	3NLsYLNGvH5duNUQFyMu41diehVozZbTPfjqv4kALJUDuR9MxaoY	1553	776	194	6301	9664	jwuEkmPE6MWEf1XvMtv7DqSegtxovHCoomYvHoqhoWMnWvxk9qz	6794	9770	9770	1617697800000	orphaned
13197	3NKwsrZAyKuCXRGTkNfhG6RBZoaJLk7agKa71MMnQURa4Z21NtwJ	13194	3NLFRpkTukQPoqhVghVxrGWixP5YwrY74qnACBv9iCTjZr68rLK4	1481	790	194	6301	9471	jwB4MER7aTYkKHpmyS58nET7RxdhnoTcVDCpYvJqxtecHFjkCcS	6799	9622	9622	1617671160000	canonical
13199	3NLDyFfTt6r1forhKEcQoGhovYA2oLvTHatCz9DtXeXHH1M8aeWx	13198	3NKkJnfnWBgYZMPyqKPNyH2ahiKm1UE3xPADJbiJbK2opAUuxAZf	1670	1282	194	6301	9473	jxAYuGubaJkjHbNKj3iETAJFpfkrw1Tfe3YCrSwSUUX1Y9fNT2U	6801	9625	9625	1617671700000	canonical
13215	3NKF1sLbGrS5KMpJ4HwsjHHjNiHU7f6fFnmz2iLxMnhFuoqwbDFy	13214	3NK9P8KFt3nZzBgaGa78SH696zWydUWiKQ7mypR7KtyPqaG5jmGc	1608	1043	195	6301	9488	jwqhQnnjGaDq5rQLpD2WVi5upvsfX59ppYdDNGrGnRnHPPTrZvb	6811	9638	9638	1617674040000	canonical
13225	3NLqwvtpsvX2jjEzPbuedCVj7cX1LfswWzZDGzTyUQX1kdvq4Lpa	13221	3NKF76KDf7xpVA97EBcYkca5u9sCsBJoFhU55xDuctjzVWAEoF9J	311	1307	195	6301	9496	jwNWRVcqTZYKRMS3TFeYaLNBjBqrKjcAHyVi1zSbVRdNELhRjHW	6815	9643	9643	1617674940000	orphaned
13238	3NLGZE9utWLEQYxe2Bywt8RtHU2YeuvHaar4pvwcfWxVqcsJrFsw	13231	3NK7rxvZ92Eos7xaD7vtXAaR5d3r57fysfaDGosYwvxtZJ6gHfTt	1624	1208	195	6301	9509	jxfLRfiC56R8e5ffhx8TiHAC1zomU836pYZCBDqjGjg7n9owE3v	6819	9647	9647	1617675660000	orphaned
13268	3NKC9HdcxCU4pU7bGNAw5gYDzbBX8oazEETZ2C7p4HKyyo2rfGMo	13267	3NK9DaK8tP7NntDvcWJd2s5vUamUxYuYWh4iw1PSdJAjzCS9UoCr	1651	1301	196	6301	9534	jwEBvTeQ5MUWkA4mqihuw1swB2uhJfygvEteFGr6xteJwDgBuSV	6835	9666	9666	1617679080000	orphaned
13274	3NLp7dqzGERRYfgFa8FDHoM2xxk96QZYFFDviZWDxvP1yo56EVzg	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1581	778	196	6301	9539	jxKY3qttftsq85fy81m87ZfUKeaJu7ri8ep3ervqKn4DeyyFTxA	6836	9667	9667	1617679260000	orphaned
13275	3NKRxbEBdXydg2mM4vCAfQNRAQMELLhYT16w3GgRdKtm9V222uvP	13270	3NLTq4YyJxrEscDhFFYvoM2eXHqfDXdfc8EYAep6TAbzFqQrpgha	1555	1101	196	6301	9540	jwKxGJyvnBXQcwxTMdFRzuEwnxnjDopFFjBx6dkCesWY8iskJGz	6836	9667	9667	1617679260000	orphaned
13315	3NLSCnRGaUSYUbLxJXcka78g72vrfN4kBNtFsnx3NA6dF89B9Cwv	13309	3NLdYa3ixBZpHHNU5b6HN5ypf9zwcXXXvXmC6xsauBJ1TQkpb97L	58	1155	197	6301	9576	jwsXauHh6vFSZqogoN7ZBCxcV6Y1KrN3RhLiHXiV2358mAs3ffi	6859	9696	9696	1617684480000	orphaned
13317	3NLejpeZ5TrXDuJsomJmtReyfXR3hfcAgAtUwgvbEUSpoHEXLw4d	13316	3NKto9JrwES2gAcQaaWwhEwbxQi1m2aUaZfwKTU4FaACb6AF1LLG	1609	1333	197	6301	9577	jwaEbqPVxPb2Uwn8PHAYU7oWPrehtKj8LbMHpLZsTSmUZDpa2sm	6860	9697	9697	1617684660000	canonical
13346	3NLd2KgFZzuWFe684JAANjazdgsXMAGPe9RNPZyubtakkhc3hUxh	13345	3NLtYT2i5QhcVwt1sJ35r2b4YCbBCLPfK8yxX3bqDs5VphGRsLn7	1406	1393	198	6301	9603	jwvhNVfa3meiDLte4on1V9JdS4JV2NRaUJdLYXuCcZZvxBhu4D5	6879	9721	9721	1617688980000	canonical
13358	3NLTFnRLPDEUEb3JwAN6dEcuFwD9qpSsMJDGm8k9JTSZyMR4dNwf	13352	3NKedGB6iqjEBdkWr7tkSCEBKVyinxy87VjeyChvFfsMUPrWBfic	1594	1326	198	6301	9610	jwjd99bHcHTqr5rJmazLBoxv1r4twyviowwgMQGz7yNNwTpvCcc	6883	9725	9725	1617689700000	orphaned
13459	3NL7LkarJKwezi4vaDht6JdqT861Rmz6wnC18ouiBYw4vSmVTewk	13378	3NLsfyX6DRtWfYmJUVAX24qEScHr83uMTyR2TC38DHf5qzim4nzU	1588	1266	199	6301	9698	jwi8gSJWA52mLbcnJXW1iasL2NfUdeJpief9QNyRd9LwYyk5CzZ	6895	9799	9799	1617703090544	orphaned
13408	3NK5budLHpEau5pHtKbTprFB4Hqhv6a7jqAh3S3RqKJNQeM5y7Xs	13401	3NKyf1m8Dqb3UjMZdMtqyq8TNNUCdhkNEfdUk3GHj2hCQ7WweUDG	1647	1176	199	6301	9654	jxfnGqXJZrWsqMxWEemaJLfQJkFsJpJA53v1SkCtRHmmVa3Bnki	6906	9759	9759	1617695820000	orphaned
13704	3NLr7r4q47utdzrZ8KjRLKFXC6fxTF1WzWsGpTccsHLuJy8LrVas	13515	3NK8Sqk3SyxzpK68pLCppT6EYYsLwRxjhVvBSVPUC5XjUHHAXFrr	1471	1140	199	6301	9910	jwgiBQz6wgxMnDyK67eoDSHor1zThqUyAbgFtohjbprfZGmAPHV	6907	9958	9958	1617731640000	orphaned
13416	3NKdbYpJZv4hJsVZ24CpjftJ4xfufKvpACTsMF6CV1vYAAAA3kj7	13415	3NKdAHJNCaQ3pcDXtypnrjfoAVLUKQxC4r4ARRjgZKexRzBkjhGK	43	1310	200	6301	9663	jwenzLH7g1qvCRX47SX1tJVEBeuceHZxGvrX9EKb1Lx1x55qWVG	6912	9770	9770	1617697800000	canonical
13554	3NLWxhdLcAco5k8Ex9AWr4UYraZ1fA7Aisj8xAUFJFqXuteS4HRK	13415	3NKdAHJNCaQ3pcDXtypnrjfoAVLUKQxC4r4ARRjgZKexRzBkjhGK	1588	1392	200	6301	9778	jw7nPLwXe7c9SwQL8LG9idPjLF7Mg8iXieZ1sb6CYdNAdAeTdqE	6912	9856	9856	1617713367329	orphaned
13555	3NKjpCpxFDqLxYdoJ4dGxYMedsvzwbeFpaBUPptUFAapEosQysoL	13418	3NKyzD6sw6MEfr7RrBopp23pdimh7VB8vPDSp4wXdRWqXQDvNJFZ	1588	1392	200	6301	9779	jxu1A75PQMVTjV7CEB8ZTxfxaVUUcCCfAAr86nA1ZDhjB7K43xB	6914	9856	9856	1617713405201	orphaned
13423	3NKSz3M3WbNz8hFMsMWb3LmB2RXSKtNJ3ekBEyE1ySGCgwjcL3pJ	13420	3NK3zz4nhWc1ALDQ2Sbu8D9KobojVe7J8T9KkG3fU3sZUsCmWHuL	1500	1297	200	6301	9668	jwKyZqrS7f1cJ7D2reuXFdZkCuFERfUQFvHqFro1GFxHDXzSnp3	6916	9776	9776	1617698880000	orphaned
13428	3NKx5Sgk34t6xqjMvn7wiR9rhfjCwgyyMGFLrgH5o7k7QvzDisb9	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	1407	1395	200	6301	9674	jwNPpf4BrhtnZMMh1wj3cYKnXfRfJ9f6WvMTNjg4M9WVrDGFG1X	6918	9778	9778	1617699240000	orphaned
13877	3NKEjUWZ7XicHrs5kaXgCfG8MKECULZVkyUdcmMi6HmHDq6epmVo	13424	3NKvuYMSi9iqYbDFG5Q32afHtz1e5BEKKNjH8XY8Tp2YF2YSUQpx	632	1136	200	6301	10060	jxoZJt1ULRcU93RBnxXeNSLK68fB9tnGuvJoxnN9yJBVwvRSdMk	6918	10083	10083	1617754140000	orphaned
13433	3NLYPPhoMukjq4aPJrqqVijhBgxEDnRRCUAMv5zVF1gsEMmvyT84	13432	3NLcDz215yAMVD1ENw67QDNNBXbazb91DXXd9R9KmTgZwMx9Q1Ls	1403	824	200	6301	9679	jwbNVY6KpBAigbAfUD658MfMPCRwERymGFAf99PLity9txN6RYQ	6922	9784	9784	1617700320000	canonical
15487	3NLcztnvwUP86WSLiSk5DodgQ9qG5DMFUNSijYNijRfEmzmpD3VM	15483	3NKywAMzQEzWdiHdv2CKL7vjWaVen2djkqZ3WWqgDJMAKb1vxQrJ	1622	1230	248	6301	11519	jwpo33Qhg9CKzHU8CiNFJGkcPYbYFWTGSr2kuUgLzpTdanrgD8t	7884	11149	11149	1617946020000	orphaned
15706	3NKT5GFuBfTmnzpdpu8XHyzoZrWV55k7NuSYFhjEK24RhKJZxtpF	15700	3NLfmu5KksCZSWXyndf2uTV79UwUmzHDaqW7riLE3rDRwmcdCHAj	1542	1058	253	6301	11715	jwctv3yazDh6tkXerJLp9zXsoHo3ESw1frAG1vTa36PhLCxUMsb	7986	11304	11304	1617973920000	orphaned
15878	3NLUMjdvaoD8DAVWCgVacrc62VS7QSb7GYN7JXi55nwVFrUVMsWC	15733	3NLHN1xwJdgVqXuxfGPuzd2nSoRigv8X77cY8JYJ3256Ann8Qh6K	470	1309	253	6301	11872	jxTJC2Lafnpu6dQBPfc3CixNANcZroMsd4gqNef3ZuE6zGiLdfL	8002	11439	11439	1617998220000	orphaned
15755	3NKmqHdKW719DWPm1FuzBr7789CajngRKazFj2AS9fRiTDpUH5B3	15751	3NKKpehM383T9PxUBtkjbSKyM8R35tkuGFAxxsox1vTpn5KXpu84	470	1309	254	6301	11761	jxdXGPstuk3zzvesLsXaUDYUT7eMyvvdb9vTwtrjuAFJgn3DMYF	8011	11344	11344	1617981120000	orphaned
15768	3NLk6VpFaLn4VVxfeh8DrRQLvDe7g2FyEprD3mshR9PrufFT87kr	15765	3NKYW9B8obi7vaPQ8ZniCgrCDbe6VnDdwDDCEe6GXkUvspDBZ6hK	1406	1393	254	6301	11775	jwG1RB3sEdTKBCc7jWuRPQWGtUMJdi29aCZnfKyWM7bHK8nbCzk	8019	11356	11356	1617983280000	orphaned
15769	3NL8TNQvFgg4fYERwPSCHxEtixGVr34cndaGRT4GTs1yCfRKW4Wf	15767	3NKbrZkhyCLz1oBYnifeswBeLWK9W868eG2GyosCyVRxAY7Ug6Um	1573	1318	255	6301	11776	jwDe8yBqjwXTm3q74gJTAawPvvVQ1rfsvSUEquG3ue1wEohbdHt	8020	11357	11357	1617983460000	canonical
15783	3NKEmHmrfLhL8yBZt2JFMJTNbe9cC6c4XqLRZmR96HZZQNCRfBxs	15781	3NKXtWtkfUK79jQL6NqbnD2BpVCqievP2Bcgrt3XZXr1KWpptTBQ	1555	981	255	6301	11789	jx2zL5jqUaDkHrrNmsXYCyvRkp6Q2XTmKCVJojgaKZD8ddDvpw7	8028	11368	11368	1617985440000	orphaned
15805	3NKwG8HPB9em3ERL7L5vujAgU5AsH3172avahf7bbnihC9wAZNPm	15803	3NK6nqaTaVipEWGHUmy1HEYULtjmYFDBYSPAhbPy6Mux1FEWXfZt	1406	1393	256	6301	11810	jwpvG8mdMTSTMwogYWBoJURpnD1wT3kXSsB6RbiCAjjtbtTGbgX	8045	11393	11393	1617989940000	canonical
15806	3NLnsABpdMjt44GGAw1U9pxaVxJ2eoSAyCgxPeEPNpu1xRVjDL72	15805	3NKwG8HPB9em3ERL7L5vujAgU5AsH3172avahf7bbnihC9wAZNPm	1647	1302	256	6301	11811	jwpYWQPv73DfTbpD5dhMriPrdTMJgFeQipPKA5cVzYf1qY9JLjc	8046	11394	11394	1617990120000	canonical
15976	3NKMth3LhQmgsDcZLAni2D2CXCiqRoq6uG8EwejqnHnBB1hGgGzL	15806	3NLnsABpdMjt44GGAw1U9pxaVxJ2eoSAyCgxPeEPNpu1xRVjDL72	1596	1363	256	6301	11963	jwpM99SJwE5YBUbYGfr1epeZWJYRst8EMPqsFkYCjJe6UptfzM6	8047	11501	11501	1618009380000	orphaned
15816	3NLfQx57TnSf16CLeUPcbzuPUuPKHdR2W14ma5D9vDb7sAQwUuWG	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	684	1106	256	6301	11814	jwyzDQd12va1ni3gMEyhgpPvqvJeDqbKML6i3a1p7uHLxAS8rck	8048	11398	11398	1617990840000	orphaned
15815	3NKfw76h9gQVjo3fXec7244iZ9rXfDCdAJojXhBCH7FH7yC5DAr3	15809	3NLDCLwPtrRxZJG2gkKbbHuTdst6NBXucC2v8kEtU3ftUPMQg65X	1523	1075	256	6301	11815	jweyCybf2RMhXiVbTdvGUVQ8VoQAUZ9xNsbzPDYkU64DZ6b91ui	8048	11398	11398	1617990840000	orphaned
15824	3NL9Bv9SKc8Xbe1NExEBZzhWKtxeTQPDJ6PtDrbwwbfW4BDjW2Sr	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1506	1007	256	6301	11822	jwTpERpsf6MMUiCWGr4Hfem6cS3u2BuDSFDX4Twvhc9RFwH5JTY	8052	11408	11408	1617992640000	orphaned
15827	3NKQkndWi8AQrapLQXsf7hk15nBxBzyqEavkRXNKxs8qB5q7jEc3	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1581	778	256	6301	11825	jwXoi2ev6uT9DtmAYfpKYNDDZdCxNQ9TwRTY76Ca2opZCGwqCoB	8052	11408	11408	1617992640000	orphaned
15828	3NK79gE25xBPKML5Snv3FaFzNqwZgC7v2Ko4uxg7ZN1SxKry4Dvs	15820	3NKweFMDFwWd1fY4zb5fDSZJPrcCSzbWVoz9EsGULtVPnCQstA5X	1490	908	256	6301	11821	jwfBMG8S5EhdTPqgsi6tJmLoJPSFgK1TvYSnmtk2K5tsMTYgPov	8052	11408	11408	1617992640000	orphaned
15840	3NLioeZJk9yoQpP1jQwyMLf6u7yUghcRR3GMW3ENFR1s94JLFBSb	15836	3NKdiTFK8VqNtW6uKB9c9jQcdQ9B7soofir35JYhTdY91RVXjYb1	1489	1380	257	6301	11835	jw92hA5Gb3ebwcBvS1JhupW1KdEv4pCPWyP5AV4JJtw7M7J6c1L	8058	11417	11417	1617994260000	orphaned
15890	3NKQudvzqLnTTgNKUx8G1NfF3pnqgtLt8Y2ZZQjG39rMiVLpAwWQ	15889	3NKcn767Drb7EY1v93kUMqHnJWNaUVvYFoNFqBJaTeabXHvvMQ9V	1507	1280	258	6301	11884	jxfm5NViHZwJy3GEnZgYxHTW724xVeXEP3pJVKAmEiCLtPQZnhi	8079	11445	11445	1617999300000	orphaned
15902	3NKCymMYK1hXqRR6vtavMgKNMpjSEbzFSWCs9wJHsjYBxhSsvXMW	15900	3NK6e2bM4L65TJ4YGm4ewB12cHDU9RxCErYgWJdhs9GVGGgRcK5K	1402	906	258	6301	11896	jwKn4p5DbXCQG6DeEh8zm9754LAnXbYrjUFVStbTk9nsbxJs7Qx	8086	11455	11455	1618001100000	orphaned
15907	3NKHDedFH7D4e22gdyXtGAhPTcpq3dCmpo3BTV5UYo7AgiNAdNAc	15903	3NL39ZhFVK9g87RAdWsdh637b8j9rhEona99Vf74bRyvv6pHYYco	448	1059	258	6301	11898	jwio91N9rHQvQm129DmvXLoXY5g97PUSVuChXDVmcEjjjsWxzBM	8087	11457	11457	1618001460000	orphaned
16054	3NLKVjAX2ditw7R7bw7k316MfirCXHY2XZxuvq3zoDo5xpVhNTy4	15908	3NKWPrd8BwxVULhxFfWJefjvMBhV2rY84Mg2cd9VB1Azy2Eby6Df	1599	1041	259	6301	12036	jwK9JXzvo2mepz87oU9fVsPmS983yVpqLmP76Qkn32Ybd2i8p6m	8089	11566	11566	1618021080000	orphaned
15916	3NLmeM9W7wcZzhCHrqVoLQtwQ8zBFhKPkEz5hZVJdkdAyGEKHJoK	15915	3NKuvAjYbKvYYu8vBxmKzbKRigXwB9SfbEcfRZiFsgEXQocUiqz9	1505	276	259	6301	11908	jx1ZCojYy7jHRQegEd3usNhrbxF8HEJsvJRppeMFU1Ry1eCU6Ry	8093	11465	11465	1618002900000	orphaned
15934	3NKjL1A5dh7f2Ucw8Q45HjzEZfxguUDiSVZbMiUDaCQ46jeXwZd5	15930	3NLQQ4t7ZAeg54ZsW7yD3afYjyjpzxcF7B4zLHtHN6kRKUtqRB9N	1649	1257	259	6301	11925	jwZVCjUL9JsbhpsxDMTTdf6y2uqtXHtkYjCtidKDdnCwofQgMnX	8100	11475	11475	1618004700000	canonical
15941	3NLRmoP8gkNVjKpY5EgpXG2HYz4ggGGrx39fAzBaUuqedVsC6mib	15938	3NKS2ZGB3XN3rYjdEJJr4zhRx1WoR7tQpXhwaqF5z3QtZtufCgS3	1403	824	259	6301	11932	jwEN6i9DVTWDLB9L6bJf8m2ENWh98kAeroTUnKsWqzS7tzDCvbz	8103	11478	11478	1618005240000	canonical
15960	3NLmU1LcsDjNemzNRLT4GkdTncBqHQxQASZ1P31P3Gr5zPfN12Wm	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1504	113	260	6301	11949	jxsniUKCU5q7WUL7Hfhsp3qMiRdqahub6FjEkmqV5GtPkNH4Ge1	8113	11491	11491	1618007580000	orphaned
15959	3NK7LkMRE8T7PftamyRjXJSDiZTF8At5p3MgTAqKykWmfQ9po59v	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1405	851	260	6301	11948	jwS8cX9oCwU6bdq5psty888W52zNVsoBjnToCTrm4uyaqvwqJiG	8113	11491	11491	1618007580000	orphaned
15961	3NKVxtb1mtxF4d4K29PkPZYWaABkLkuTwZ5WL7bKzVRr4U6W4VrX	15956	3NL91RasZP5vXFej8iVpt6eLCpJgKxy7XrB32zvx6dyGbNk1wK7Y	1637	816	260	6301	11950	jwXT9XKuDjrQzBFBd1r7fiMz85VfXwPsrPPzYjn7dHLVF8GDpqd	8113	11491	11491	1618007580000	orphaned
16129	3NLXxCy5oVyTpoQ6dGoGKtJdVkHhCVn3MKnK6ozXwsWRNVKYDKZk	15954	3NKwTch9NZSdhkmPybcJpjVAJgduQ7LkxgoGY2bAUHyeXQuJMR2H	1500	931	260	6301	12105	jxF5oo1JZjkHg8nB5oBzVY4G7gpLWz1ABxg5BnktwrByL5GYviG	8113	11620	11620	1618030800000	orphaned
16539	3NL4bNTngbpPEz5rYAFMCgRHGjmMPNUxYaadYAqFxtWQaYyxLbm4	15973	3NLvWdZeURUM7MrC8TnpNEfcyMxxec6uA1GQStBUtjCMdUzRsYrq	1590	934	260	6301	11960	jwEmxuKRCTuxXuq77ezmZweF7uLGqKxgKj7Tkj2yZC1SV6CrPaA	8120	11908	11908	1618082640000	orphaned
16001	3NK339cMGouMJQz9wBJJdniksks75gs1yvgwKkdjH6aKT1PDRMWb	16000	3NKzbHGzm3pTSwXX96VGTAnSBQWApBgeQeQqYWxrNTdxpGeHMiTo	152	1084	261	6301	11985	jxPBAqFJPps6AUijxUCMy4Ukeb23zejVX2wmiZcGAFc8VYZ6Ywg	8137	11526	11526	1618013880000	canonical
16006	3NK7hKmqGgh2Cd2GV1RaC3Faomofcz39eVp6peAa1wiHGqTJNDFA	16004	3NKE7pT9eGrk3BW3UuHSUFXM3sYLvDtrVWGiwjgxw7bZHSpEE66Y	1585	1000	261	6301	11990	jwpcbwxcjZ5J4vohuz1FhodHGSdZk7LaY3bdKPXgo9UhUQrgT4Y	8140	11531	11531	1618014780000	canonical
16175	3NKrVAhybhRW6omfEDnmwwPmAvhYZzMALmWKyjPAyDeWAX6vLXcd	16100	3NK4UEdfpvQiX6X8bJ1Zycjiy2edbv2PFNWHLEq5qt6bP8i9KDTQ	152	1330	262	6301	12149	jxyVTe4K42Eq3e7sFCeF1MTjBSSsyBmy5ZXoUtdTNm1rLDQdwy6	8141	11644	11644	1618035120000	orphaned
16013	3NLhJWwPX8px9wfnJcVVCbbeRafQhtyyHfMdgunAfzyPHeeqhehv	16007	3NLL2ZRCg1u6Z1fgoyfXuRdZomZPjeWGBLbVav6LYr8zaZjK5foY	606	1295	261	6301	11997	jw9GXtMtjFe21kFN7aw2iX7Ru5bP3TgQyYwXTjcekvsFeixpfaC	8142	11537	11537	1618015860000	orphaned
16035	3NKi3NkRbMpECDzYZhfk1xkdGLCtGZ4MWeVerwduYHVfaioPe2nG	16033	3NK3pbXB1YH4weo4jzdjYR51ZV7rg7HeWSjBDLxL3nudGYWmaZgC	1406	1393	262	6301	12018	jx8Z2oXP12SjPRBq3FsfmvkzHNz5j5wuqsLSiBFwsAZprfmcVhb	8154	11553	11553	1618018740000	canonical
16042	3NK8ANCQMf4Gt52vB7pHBePnW6Z6X8ijbyoBNGZbNbCZoghmjniC	16038	3NLgbLcEM3nDre39ZuqNdHsWkggieddGq82K2f1mJosMEf6gkb23	43	1310	262	6301	12024	jxbM2jGVm5BApfJzMWdyJC8CyHjxwmxCUwd18VNd46j8ZAQoU3j	8157	11557	11557	1618019460000	orphaned
16258	3NKknitVeqWXbEA43h9CQwkTPn2z7eE1HWsMqKft8eVGEEHmppt5	16043	3NLQQdKRVnQ4umr6AZrwHkJkNEnmMtpKEP8segNM56c3GwkuyuzX	563	1359	262	6301	12223	jxzbQuQ1fkzKxbmBjcgtdtpU7bmPQvDZ7KRa23TizdZzEdmdVpy	8159	11695	11695	1618044300000	orphaned
16293	3NLZ12QKAjUX3aJqL2r5Uf6W1BMXyuNw9Rkg7eUozqybtxx5XLpP	16258	3NKknitVeqWXbEA43h9CQwkTPn2z7eE1HWsMqKft8eVGEEHmppt5	563	563	263	6301	12252	jwUxC4u4E7Wbu9nfXvChofZYxY9yLqzeg5ggPHkBbMVeVJKGdHE	8160	11717	11717	1618048260000	orphaned
16058	3NKyDTkzjE4Qb5994fBhikK1th8PVt9GSNgWrxzRwQmJP2JqHZkP	16056	3NKZhor6uEArx1mneTAtgf6hEiJ5Z1VjUNuJxagXcLtSLHeBNnWS	80	1273	262	6301	12040	jxiH6QB5TmmAZoVVdXTnA6JVn1esPczXypZtpVEfy55yUcm6hmt	8167	11569	11569	1618021620000	orphaned
16063	3NKG5MhfGf5XR1D84zvFD8wXM3mhrN48fvNA9dkMJH6PAFE2eh5F	16057	3NLJ95CWET13MNLtseZbeE1Y2RoahPe3S1d6T7sBGTEk7uYz3F2r	1581	778	263	6301	12044	jwj9oykK3iW5zA4c22uDXhbcrktBSVYGZ1a5VoSikWStvvGXTdf	8168	11570	11570	1618021800000	orphaned
16071	3NLLZWUQF8P1Hvn2H61aY2W6chP8HS8WrHUzxYTABg2PpjixcGVZ	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1474	1203	263	6301	12051	jwhdZvRQ4iYqRSKa23Fa9ft7wuhz5q6yyz49SvbVEmRYShD64em	8172	11577	11577	1618023060000	orphaned
16074	3NL6VKhFyQBtSgteuC3yPmmcfpmpwosF7T3ZDFaxhXnMuX2y5pXN	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1637	816	263	6301	12053	jxxR4pygnErgB6UhkAeLsNLau6FmaPTyU3ZaGT2K6TsbuHtHnqK	8172	11577	11577	1618023060000	orphaned
16075	3NKsd2gVfHuBoaQxaFAZgvLUGSDs3J6abKm45UrYaYCSNZ5Nhn2T	16069	3NKeYejbV9tpYGBEhGHiCKfEFyK8eKPZoaXxuwoTH2FeqPHp6pxa	1474	1203	263	6301	12051	jxm5hquZUj5VjDmsD7GgSxrZCrmCzG6Ak1bpaHDtu3K1o2zi1Q1	8172	11577	11577	1618023060000	orphaned
16103	3NL3TmkX5PSSDyBid9pCqE5nwUewJeE9XDQ1Zfioy9AT7CNX3Vw5	16101	3NLTM1p2SEF1WrxQ5odTnG5bmnMvsLiYJWiSugHcP5D1t13wwgDv	1542	1058	263	6301	12080	jwuLqeLnCS79JuN6Y8DpTDPjxD81JSRYLdsEQr5Um4y7wRLw7dV	8185	11598	11598	1618026840000	orphaned
16116	3NKEfgxowxN9a6DPf9Dfxc7QDhVQ8tacCLuP5dDjfKPJyF45f49y	16115	3NKKJFFCrP5PxVT6QZvRY8SUva61PL5nHw4NQzqFDXLDaTfJXLcx	1451	1292	264	6301	12092	jxqRo9aTNM2VZB5qrMDLAZZ2D1N7DrhECRvWZQZq9RZ7AFkQoX6	8193	11610	11610	1618029000000	canonical
16122	3NLH9iapwhfxmXx3p2Uf7TPVMaghALHeWoyeq249Agt5uTVikX8Z	16120	3NLC3dLGgvYYkiwEPZhhLP7LRXrPJYimiBuQDNPdNBJYedTTBg72	1547	1378	264	6301	12098	jwr5WKZHVG4oKY5pHDqTud6kRdSXi2n4AEXTWrzLrTt7Y3GZy7s	8196	11614	11614	1618029720000	orphaned
16138	3NLvasWRbQu9DaBjZdVaPjHf1EdRZZoriTzDzrTj1bXsG3HoTMa3	16136	3NKCzeMAVwx6WdYw9qzprXwhM3ZQAr53NWG7rV8j978fe8ZsNXe9	1407	1395	264	6301	12114	jxFFRS9ecmHR8C3jHiwVbuyTtP9FPa9MiZvMWgpm124cFPHPFyr	8204	11625	11625	1618031700000	orphaned
16576	3NLhPA57toFu5ZLDNRTfyd1yCCddF37VRyWjEs1QdSS21N3CHdFA	16235	3NKTEBWZktuZPt1uK99KE4UzZF7cq8EDVLr7L3UCNw5KUekH7EH9	1455	1332	265	6301	12201	jxXsKhaFVE2tNCoYwbJ9kxxardwaGX1SDCCasS1ug9P8cVh3563	8211	11932	11932	1618086960000	orphaned
16160	3NL7EDvGT7CFrbBkAYT1BXF3NDpzfhGGaaNRLF7pxqZDfTnSTnbD	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	58	1155	265	6301	12136	jy1migP9MNRA3a3uvqrJ5FTSYLg8PdRpEfgivLn7snfBz2Y8d5S	8213	11636	11636	1618033680000	orphaned
16158	3NLDZq8FjWMCn8cDjBune96iHmZ4BGm4b6iyB1SNAjASsMZoVjiq	16155	3NLHCnJpWUmZWTRhgEqLR9HP7f7XwRaNrNdCMgQS2w1zyNxCnAZi	1407	1395	265	6301	12134	jx9qHXMyw4EiHmFirtny2kUgmm2FSXbbaSKMnRicf8cbjnE3EZc	8213	11636	11636	1618033680000	orphaned
16743	3NKSa81b5HjDP5xcNiUJsHitiACyU6ydYPN7rKzkXMPYzFtzCpwN	16162	3NLUJiokLWB6Y6un6QAywqMDMmUG3JmT63iGZJov5x88Q4DtNSPm	1430	296	265	6301	12138	jwRuji9YwmSzGBEU1TjbyKJkJW3Uo78XM3UTwZvmNMjwandG9Tr	8215	12040	12040	1618106400000	orphaned
16180	3NK9pf5qeLkpfvYtkaAhDyCiL5dAjsLgvDCoCj6YVy4woLci1MZp	16177	3NLpJY3NVMbHjZo1FWo4ssQGBZvyqHjmnMFs9YFj1cWBv43cdM88	1419	814	265	6301	12154	jxyGKohw2E72WCHd27xdBASbpopjLMP9kUtEdDDZZZTm1HxFfTx	8224	11647	11647	1618035660000	canonical
16210	3NLHzj9o6LNqyVVoHhNXcm2ezPtEnXnnpmTHvk52MENedEbnyffx	16190	3NLBpMc4YGSMgbh2zeb1saGgn7FmVeehZSxKmKskFoB7NmTcF2um	1509	1320	265	6301	12179	jwjLpK6mY2Fj9vCf3QGD2a9iC1nFpssaUvyFk63mWKGbjs629oT	8225	11667	11667	1618039260000	orphaned
16206	3NLcAmVYyUq2mC3udeBiHpayHDj49cdbkMXrGPQvymGHDXtjGsF8	16202	3NKvZf67QtBJjyg8q8pPMoK3nyK8QkzP1KYMXzE9ZkvFLRo8RVhz	1489	1254	266	6301	12176	jwwchjNkZYMBviQk1a6hni3pL6WY485r521ceceqBQMCYeqAjW8	8235	11663	11663	1618038540000	orphaned
16786	3NLC18CiXSMRiPNCejBDqJXBWTnqazk9pgfSs8YmumH77Qqg4xDJ	16523	3NLu4ykxmyBoN7A25Mef1nPZuQJmS2ra4KW9KWqLrNCCDj8BLds1	1513	1133	266	6301	12461	jxUsLJafQoFA69yzM4xGXWXtd8syZFzd42cPDdKiT9RrnqZTQRV	8235	12067	12067	1618111260000	orphaned
16214	3NLXrhfpyWW3SoKV3iaConM9Yk6XpLq8qq3bs2eXm81CyCBgkpeo	16211	3NLnjSm9BrefLUy4nay9PwsmZpDMpfqL7n7PcgArwhaZjQQ2Hg4J	470	1309	266	6301	12182	jwA4qn4ZpafCKurKjMExAA1SnfT942E2cMD6GDZzQAkA4Yy4Bcx	8239	11669	11669	1618039620000	orphaned
16246	3NKizkKUTtrfK62rgUz2KeDqztK8j63CYf5rbd75fktA8jgvB6iy	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1406	1393	267	6301	12212	jw7uYE9itY4782P7j1yJeMD8MVwakDBoUsWQb5Lka5r3H84UXKf	8258	11691	11691	1618043580000	orphaned
16251	3NLdwYGRNHpC8yiZe7XuZAxLFPV7tJDGKCsj3QtzQmVGUFC4DbT5	16245	3NKHENuXEHzAkfe2stwHknPc8DHnQwTtr5KgNyYAmRgLoUpKuEVC	1541	1298	267	6301	12215	jwXQZ9XPdweTfDZvrMvdjs7N8Egue7aEVywiP3LChERriK99qMc	8258	11691	11691	1618043580000	orphaned
16833	3NLHMD2zxkp3xLFJK7VgidziWQw7wxofxhoBq3Q59PbwoyeUeXXX	16247	3NLoMefigDVhmPYTdnv75UYEfcGxK6AuiXH9yGijGg4jVuuootFC	1646	1228	267	6301	12213	jxhQQLkRoFU8EKjw6v7YojKbiEN2N67oTieDmM5NoSYDPCHWr8g	8259	12092	12092	1618115760000	orphaned
16253	3NLCuyGd83Exxgjpd8uSML76yzdyZo7tidGV2KL9UowPFYGmxd4r	16252	3NKdNfVkQEibT9j8o2ndXgcAfZwyMqLNcSFEJ1oTpa48DG5WExGR	1483	560	267	6301	12218	jwWxehBDgpWDpPvx9VDZxj8jD2sx5hb3c1gt7cCnCwuLwLP5Vbm	8260	11693	11693	1618043940000	canonical
16274	3NKxJeRkB1hoL3rdBucP9CXduTBVci9PXA9hy1dxy1NWpr4fA8s7	16272	3NKzwHkEyByQYRVQsxd3qk8M4zpGcuZMGyNN2vc1FT61biigB9mS	1402	874	268	6301	12238	jwD9cHWkzsNeDqxffhPX82nHSKfWZU43RXd5muMvEynDcLWouoF	8272	11711	11711	1618047180000	canonical
16279	3NKsAsFJVuYA1ELxLVstx9DQZBfKGgHajQQze1hsW2iA8NpZu7vS	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1403	823	268	6301	12242	jxwWqvz1jgehrVm82zyoWPcdqr8y8cawL8wLQ3okk9ok617bn2p	8274	11713	11713	1618047540000	orphaned
16278	3NKe1kDtdrbEbSsrmaZCxdMWLifbc5tAphM8J4po27MSsaCk4Jzr	16275	3NLnh8JLadiNoDepYMiMKvf73nT7Zh5NEd9p93wmd9eMwhEqj5qm	1523	1321	268	6301	12241	jxT1HuTkzqoWoqZGAzA3Ng945gjpGV4qWDkA9QxobGpJ2euoiVE	8274	11713	11713	1618047540000	orphaned
16290	3NKTeQ32sQfgXfFRKx1JWfAsJjbtVVDCSawQ4NR2px7opLxdCEz9	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1534	1317	268	6301	12248	jxX8Ton7mx6c2Dkg8bBxQ78RZhmXTYKMXt7QympajVmx75vrUVb	8276	11715	11715	1618047900000	canonical
16289	3NLnozxkUcToZUctgqhnCe5bo5E5vmdNDUi75pW6HafnjgswCavC	16285	3NKKjqNMmrVQSqTdLdmSGoZBnxBTrksWakZbm3UhUyHtoLP9h2L5	1534	1317	268	6301	12248	jwH4gWbzd4yKPiuf5wr218LQUmKSGQxoLak7PfvQSKRZrMcnfWc	8276	11715	11715	1618047900000	orphaned
16311	3NLJPdsYDPhcyEgMtoeXNDweuo6JofnB8HEwEHR6D8qd1Xps6ZuU	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	1648	918	268	6301	12270	jwnk6c5pea66u3ns2UvaQCAKShBC5zHkdEodDKp1y6Ur3yYwX6L	8287	11728	11728	1618050240000	orphaned
16309	3NKup3cR9ZtTg6d4G6ZFKo7VR2AeTzizyKgTHbPX1kFxYmB7JZV9	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	1553	776	268	6301	12268	jw9rKYyM5RoSFaQydiYkwZ8A8aSL5y8DHVetjwfPTjR9THgoJKe	8287	11728	11728	1618050240000	orphaned
16310	3NKcvB2ffrNSHMk2WRB72SnYk5fy6sqRkE9jiKfkxj9d3fw8CmgG	16307	3NKCanFmqRCDB7KUxPACJntVr1HQVn4mP8YqZbbgnTgydq2hN1wW	576	1109	268	6301	12269	jwRNR7UsqUpKaprwAXvptmMUL7yo4QSZi4FfmGbWYmbH6ZPfDdY	8287	11728	11728	1618050240000	orphaned
16343	3NLR6efMMzEm1DHHviG2hqqfe3NP1Fc1CGMqBTAxJ5i5HyxxYKQN	16341	3NLPMGE1KtssQZhxnteL32ifKmKGcfVBLiCuGp4EVCqLrgvN996Z	1426	1364	270	6301	12301	jwMQG1FF6NbSksfEnjFikC2rzK55AqNZZsRbxihcSxanGLP1veJ	8310	11759	11759	1618055820000	orphaned
16357	3NKuyTU4P1bXottYGtPuMxxsLjarUjeMWbF5pc36EMc4NFqrBLur	16355	3NLxryTEhdUfiT5sQCUskiMoqerqGz1mF1oNx3YjYKWN5va36uSk	298	1182	270	6301	12315	jxvfigMgwfpof3S9VeoyeTqxyzpX6XnAx4TfDVacLTDHxPt8dxj	8319	11774	11774	1618058520000	orphaned
16375	3NKSbJjYDpqowHR4dfXmnyP4rgNtLHCy5VGxg1GZJfkXT3ANP1NH	16373	3NKLEJj5erVTbe1DWm4iD7jqJfy6CaqhSAFVwet35DtB7urYE9Ty	1402	852	271	6301	12329	jxXu2kWR9XrGU4XTqazn6rZZKtT7zAh17XeQx6pHagRrY7y7aMh	8329	11788	11788	1618061040000	canonical
16472	3NLgTUqUhd4Zypv4SuTS95vCD9W5D25T1Q1LmeJ2BNMEZcz9ruFT	16378	3NLENGH2CcH8uW6nAbadGSG6RKNc2hF8dHzca9N2oBUWEw2JCffM	1580	423	271	6301	12418	jxLZuFpRqChHCpRNJAbuYXntmZpDYmEJWBoc8hgp5kurvWoSiXV	8331	11856	11856	1618073280000	orphaned
16662	3NKch96WaqyYa7eapYa7hsZs92aWUfZqCGBq9bue8A7hecRZ6B9u	16393	3NK4MoPRUHCJk3kX3ugmhGzynTABhDJU9HV9mFMCZNwND5v8GKmE	576	1109	271	6301	12347	jxY1o7y4fQKVxTwHho3FpDPEbg3sww2bFnAZMaM9ve5aFLqJVmW	8335	11984	11984	1618096320000	orphaned
16810	3NLqPKHtNMnRX3xSQAhtp5iW7zVDN5Ku21pJPjVJUGbWPHPC9tkg	16729	3NKdAACyLUNj7mefSnSPgk5wj2AkqjBB63VMyf6dS14sx2Wommjb	576	1229	271	6301	12347	jwKSMDSQBHF1WoYTZZPicxLHpQYgfL6JW1H5N2CuSTYWCas9mMU	8337	12080	12080	1618113600000	orphaned
16392	3NKLGZ7niZf4ufiiyZQmpuXbYyGkHHnN26BrKft23UwJyLkMLdic	16389	3NLwDmGTsC5Khxc8NqRitx94gwRA4o9gsDiBrrHcuTbyJKeC6Fwj	1627	1385	271	6301	12346	jxF2L53ZQkCaTnBwyRMvidmfqWr4CGy7mCxrLGyNx5Mz4zpfeVn	8338	11802	11802	1618063560000	orphaned
16454	3NKMBb7fGTHH8N9gmSyuzyceruzoir3cQpoamkJ5Zv45hXTY5TPY	16392	3NKLGZ7niZf4ufiiyZQmpuXbYyGkHHnN26BrKft23UwJyLkMLdic	1627	1259	271	6301	12402	jwSWLXoQemkpnur6hsaHk63oN16gtWp3mSzMXCVdeLtefRGVXx8	8339	11844	11844	1618071120000	orphaned
16410	3NKncKtqjFH9mP44eKSf2LVTYGYwgW6RPuFoVxLkagxZEAagfhVK	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1523	1195	272	6301	12360	jwHUsxq7PHv3cGtijWgJK5fdcc2T75X293U9x1xvg7i3RgirTiA	8347	11814	11814	1618065720000	orphaned
16408	3NLRurUdghPbtLtVXHpubzci92u1Pc9wgNAXXW3h2JSRDxxskPdF	16406	3NLad2ZdKELNbPJVApdmQxk43eX4ERUggNNTu9V18faN4vy2G3bV	1547	1378	272	6301	12361	jy19zSc1pPaxQEp8xoWNtTDGNgJ8KCLwHQWkb2uGSXNHpqh3qJu	8347	11814	11814	1618065720000	orphaned
16617	3NKs7GJwtfjEygz2eFejpCH85jf7n5y9vk7rs8wEf3bR4LSDWkVr	16421	3NKUp24rMb5k65B6yNv54foW5BSySYkvkdYbtmCi3mXSg1V8rrv4	1560	1045	272	6301	12371	jwXRG4TNrC75Srn8phGcvFJKjNuBrgRcfR95j66D5bBW82zZ1ZA	8353	11952	11952	1618090607348	orphaned
16433	3NLnkZrgNbdvXCRPnX4fTozx6WnakYhnJbHJrEeKdhGACDjRAbni	16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	1643	1299	272	6301	12383	jwtSZM1czgpG4NgdeoEwztwtTnw41PkZA4YG2greUxzrChmnSvh	8356	11826	11826	1618067880000	canonical
16431	3NK9Zbow87rtqKKTQtPcGpgNQLhncMcxrJjkekSCxubXkNDvyoxb	16429	3NKex5carY4TDYtThJUQcb2VeeG7fwe55nCi5s5gTvVMtoYsX9FH	152	1330	272	6301	12381	jxmZRn2sAAYweTUAfgdahhxPtrHaSPPHBAmX4AgDEF5up71YGmB	8356	11826	11826	1618067880000	orphaned
16441	3NKb3WRrApDUvmQ3QJ5mh53cezrmJSkYJWcx2uR91VboNF1cXxbk	16437	3NL8iwjyL6h7jm61uqsfBRAWyWDiv7ENCAnWx4yBPcA2gievqvjw	1490	1028	272	6301	12388	jwSfKR6Quv7Khmuyby3kai7gV9ra3DnoPPoB8ULrVjaZCjhAND9	8360	11832	11832	1618068960000	orphaned
16445	3NKsg6kh7hfBefeLcSDSRfA75qiPr42m26PkYr13sMG8yZEnK5en	16444	3NLnNXggMLQFkWmH13QJTmPfgoxcJ3RaAAxP6vXC3zUH1XVhVFZG	1549	1362	273	6301	12393	jxjb6hmz3b5viaPWgrhQ3wwYzsq58QX31vggfTJPZ6EtTtqHXop	8364	11838	11838	1618070040000	canonical
16466	3NK8zJAjGNGR1qSKzEaisVmjcDGhX8awjAL64i7HcvEzFAc8b9Ry	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1467	1376	273	6301	12413	jwu7i76F14zkDUGhYFtPfLtSwoyLR73pwdPaFDnptJt2WXHkvy2	8376	11854	11854	1618072920000	orphaned
16467	3NKfAunMUwxUSmCboYxdZdTVGxJsLgPf3AqxihEiDK8G9zKMEAoy	16465	3NLgZcFE5m2Si9eP3MohuVAz2vkU5LcXAjSC1aSW4J4yqujkQdws	1474	1083	273	6301	12414	jxbX25K7ebym9cVBNxWnJqoF9PjVR6dP3FZpFpYDNYcwvweJQU6	8376	11854	11854	1618072920000	orphaned
16475	3NK92TxYUQZ9Uf1Yg6pVqqJcVYwhG7nKAiTvHK8KZQ2ds3eMysRs	16470	3NKGrEtvKnp84C5yEBrDhUnovRFFGQ7Ubj3pETEEMNfYrxiNpwwp	1580	423	273	6301	12421	jxAQ1cLGV9UjTqkNqdbSwytS4ViCywhPsKVhaMF1sGWKyRkWkRv	8378	11856	11856	1618073280000	orphaned
16950	3NKhka82CHcTB4Cry8HWQBrj65LJNLoeWkJwQLuDUAYipTtf3VDG	16476	3NKNabtySedfUCPGL7FLaHHSFFjJ4ocyBuaBYYjTTMJhbxWWoVAx	1560	1045	273	6301	12422	jxjG4Xq9Z5NBipFKY5dBscv46BW8NSLA4CuYmrXMJNsSPLspMas	8380	12159	12159	1618127820000	orphaned
16687	3NLc2SWcwke8uFTYABaZ311tv4hqckPWuyiukfYZL1zWW8EKD9oX	16482	3NKpTUGzPd9kS8sbUpcPdb2fRYombJP16rzvs5S8ckUGZEE3UzFs	1564	1212	273	6301	12426	jwumo2sKkztXXrx82m16gi38bvwT2czYsnbAQaED1AvKhF2k9yN	8383	12004	12004	1618099920000	orphaned
16487	3NLi1rtf9brvpuQ9Cxx58RJF5FjQhx748Euwf51nbH5ECUTYfsE1	16483	3NLsXVQCAwUzqd5pmzKAuwdsuYiEoKytqct4ky2ce5mMqRqoCZBQ	1503	1031	274	6301	12428	jx44BwaquWvKX9NLK7a43S9ozsizVbBGGCBVW9A3jWNayonDjpK	8384	11865	11865	1618074900000	orphaned
16992	3NLLUDjGtBHMVccARBoRndiLTcEsBgMRwjBoGgxpSYBbC6QWDvXZ	16767	3NKjJskkTp3uvhtrFaYfCFwhxT9QR29WFZDpn6GGEjDvnqaxLzNQ	1564	1338	275	6301	12426	jw9ZwZ6w9SoLVBzQKARsUk9yS83uszKYfgtoULWmUCykduqyXVC	8386	12180	12180	1618131600000	orphaned
16623	3NKwghUapCHoxRaghsWjNHZ8eRFku1TZi6Mgebfsqg1NicY2nmzr	16493	3NLPLH3SKRwugaMtAq9Ld8DoLYgqYSKGntidUi3cc9QiuGQAmuFG	667	667	274	6301	12435	jx68Sbf5ZcaRnBerBiCdwA45HoepdDxezsppkTJSiqK7ZU4M4Sw	8389	11954	11954	1618090920000	orphaned
16514	3NKxFiPU9SX4uBynwL48MLpSfWZnrUdXT1mHCHXNQ8VLEFH8DhH4	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	329	329	275	6301	12454	jxqfphB5crCaWGsBP8XJEwtb2DACrJLgEufQX2KKdxPS1xWAy3X	8400	11894	11894	1618080120000	orphaned
16512	3NLFoSkxhPuyKLgS4u8LNRUmfzjYoU8eWpy6P8Y86dVmL8nnsen1	16510	3NLMZSfZXNq2n326U2cgWodwkvU1vwYHW6aiAr639fvdvDJUf6jz	329	329	275	6301	12454	jwc6r3B2Ci4k7ConK3qXC4txGHYjySeAxhJSNnByrfioXZr91TF	8400	11894	11894	1618080120000	orphaned
16564	3NKkUGh4nWczD56aoRvrJPS7MrzRY3r5oskbDa16PQspZ7n5qvyG	16529	3NLCciucR5NYWkbjDD4V87H2DXeC9BCojWmsSBwSNutViXpZPsrN	1508	1387	275	6301	12463	jxriosAaJyd4BGobn55UzhCNtjBBH7igGspiLptcojpsnshLRjm	8408	11924	11924	1618085520000	orphaned
16531	3NK9a8ecRQfacNUdjQMjzTL8arMmwZQJZGxm6tx1w6GNsmZVgnJU	16528	3NKSagms6Gs3vs3LfirVZsSmvRcoiAjpquEgXYWEsANcjPt8Evr7	1571	1089	275	6301	12463	jwvKXDNSMNdASoeBVDZoB5VuFuCkodutYN6Fw2ttKZdcJbEhLEd	8408	11905	11905	1618082100000	orphaned
16537	3NKMah83dxD232idYLSvFgyQW2uuSRJFMK6TCDwUyCWHSRDWV82c	16532	3NLckyqzwDrP2PP5iG1Wvp2UYLo5h76ww4PNLUE3t1CkMDih1eh4	1440	1131	275	6301	12463	jwhPkv4Z98J9ixbkpYwv1jYkCNKBPFis4kypq9hRFGyRFepZmc1	8409	11906	11906	1618082280000	orphaned
16629	3NKMbEZgiaZPsdaUJoTcuobmKPaZFVZjQmEJYxMxjTATAFFu2AeL	16564	3NKkUGh4nWczD56aoRvrJPS7MrzRY3r5oskbDa16PQspZ7n5qvyG	1508	1141	276	6301	12463	jx6bdSXp6ewie8VxRGvC1EhKAagJkLGupxyAKSDH7RJut1Mjgyw	8409	11960	11960	1618092000000	orphaned
16545	3NLBPM6SpyHedsDmr1hAzbnx2Ldpn6BRzrfGkXNjUjZjKdSnX9Ev	16536	3NLMvJyErfJDy9e2CXeR8HnT9hYgxSa9HiP483yiMuwrBVyDzaom	1451	1166	275	6301	12463	jwUBmKpr9xJrjgqY7PN4yraFS9uxRZUwf9MffVNMtDEgysH4XJY	8410	11910	11910	1618083000000	orphaned
17063	3NLaMFabzyvHDEKKxdvbSinwBfFcCnkpSTagbr2q94scuHR788GN	16772	3NKqwZjPAHEdqEqkGeNMokrGcyrjfWuCPLjJd2c6dTQ2rESn5Q6V	1508	1261	277	6301	12463	jxipqSFNX7fnBQcxRWs5e2NcnXuqWUd7LTL6KwxCuFGmWmyYMDa	8411	12223	12223	1618139340000	orphaned
16868	3NL4dFLh1mizK4CAB2jCx3BEiDqMCzLa7Surnsb3Txcaicmumq4J	16709	3NKqte8h5ynaoh1BAoWf6vKG5Fm7RbxL2spFXRka5juCBxrPBNCF	1471	1386	277	6301	12463	jwT8QM4VqLhNsp4Ht5JaxmTbYsdGqj4HK5dXZKt5MgjrXuiGXEn	8427	12109	12109	1618118820000	orphaned
16596	3NKSSvW5XMqd78oukQ5SSqCxLgkw63FLSsSG466BJc4CbFZ5Pa2j	16592	3NKYv9ThMDVM3bKzquqrtA5jpMQdXzxTiTK9F2zUL2qHxpTtQRKR	1460	1324	276	6301	12463	jwdMpp3hvXKJ17Dor5Uv5eK6hCQQUnvYjFr3WE57K4w1mM1Bh9e	8433	11944	11944	1618089120000	canonical
16606	3NKnHEG67HudcZYMK3djZ7Qx3DQQxgUDeGMRnGqkG8os9TfcfnNw	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1609	1333	277	6301	12463	jwgEGNyULyTa1B6FzGZ6MQ5zodU3LZ5JC32V38A1ngBvhsEhDWd	8436	11947	11947	1618089660000	orphaned
16609	3NLNGYT9DaSPFYkqafSvhRTtqZi8XagBeEqEEdPzfAaRGhQURA7k	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1573	1072	277	6301	12463	jxouyj7x46FBnUyAQXf9LVV8m8EMvRuXo7mmJcDdwGHMGVB7AMm	8436	11947	11947	1618089660000	orphaned
16607	3NKZc32murLvrxzGJ48EYMy3nvtM7ahCNrnn3X8oE2VL1guFGyrY	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1522	1322	277	6301	12463	jwwcBX8MW5NppNkrJgtxRx6LPej2cC7ifSbRDcUKndpZ9Tyq3bt	8436	11947	11947	1618089660000	orphaned
16605	3NLfFB2LBge32F7ocCrtkRrgTHuicHWtWexYKYf1HSERosmP8nUH	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1407	1395	277	6301	12463	jxy7kacyQ1V5iD24TiKtNAVSBqzmtiZfSeFyTPkBCANPRq92xND	8436	11947	11947	1618089660000	orphaned
16608	3NLBNnetgNJjNvDaY26J8fUeSxhVZ23RPUiQ1WaqMWUxwXQMjFSY	16601	3NLVgvJp8SSm9JrPst2mWkfrF4zyskKDjqUq4PM2gUc9uXCYBhhy	1553	776	277	6301	12463	jxaGHLPEeuu8Fhku6Aw2ZYSQH2r4pRMEMrLNgQYHNswYQrdJ7Qt	8436	11947	11947	1618089660000	orphaned
16651	3NLJQBWRaP6VWXLgzPHWB8rokFmePgkTJseRXpuMgwz1S5Z8Pd3M	16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	1553	776	278	6301	12463	jxq4sfckFLCBoQu8SVaX7zRthzpFw6CNzocwrBJwPiKdn5dXTgp	8460	11976	11976	1618094880000	orphaned
16889	3NLmbfHQBBF7abanzLhifTT6mvs9nxSUYg1agrGFxnZtsFyPZvaG	16648	3NKuXuXZff3tPwcxRVXzaocEs7WSj16UWgc9BkQbhvbuxSf4NY6v	1642	1367	278	6301	12463	jxCwdvk91ZtajQ1PCkttLEUj6epWRsWdhSvt5pfRxqP1KEyptCC	8460	12124	12124	1618121520000	orphaned
16654	3NKTEPYPhHZjXBTtBou5zQvXSFLktZKYmxFnwUfRiLB1dEzztJpK	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1527	1047	278	6301	12463	jxT5C3xfLonAKpLZCwACmfrwM5fckqZEnYjZ6WthS9BiHXnXzc7	8461	11978	11978	1618095240000	orphaned
16655	3NK4J2ocfsGTsLbpLJDm51VXnj47S3D46xiT8iL1r2rwr8hXpTx1	16650	3NKWA2WcfHsuhgS92RoAxj7GJYWkovUtGjj7nD286tQuDbn9jhih	1527	1047	278	6301	12463	jxL8Ed72iAWoefuMtuFYUSNeYTf7ioHcJGjTi5i8n6PbzuaxVZg	8461	11978	11978	1618095240000	orphaned
16684	3NKv9greAF4qS2Z27ij9CMREtdmzA4YGDdkpzqLWA95YkKs89Ut6	16683	3NK3fPtCRpnm4NqbC8wCgp3YSLzLoDTEk6nCJaMmnsAJQ1wZDKiK	1541	1298	279	6301	12463	jxafjFPfhQb3NvHV8J2Y9xsqJov4YSXTW1ff5ANSJiJ6ufxk8bC	8475	11999	11999	1618099020000	orphaned
16885	3NKU7iVib4Nur9D9aGSQHRfJDN3V9pP5s4L7fWoHy4xuNSuAm2KY	16722	3NL4EUnS8TAeCUHePueaDyCsdVZCNmK1yg7cqmttCj7g5cyvkTN9	1589	1286	280	6301	12463	jwc2RBTPjrwpQhCLrYEBsbMv1cac8SvgGQ6rHbKcrMiNxtu6VVg	8487	12122	12122	1618121160000	orphaned
16715	3NL6ta4tTmGD2FuyETpkRR7GBhMVcdB6Urm7yPm8kc71fKnumpSh	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1560	1045	279	6301	12463	jx517uQPoEHZUaZdbRajgQfhLypwAUy3or6wT3LBF3xxgzK6zo9	8492	12027	12027	1618104060000	orphaned
16716	3NKycQGxcStoVqi9rfFu8PPv2H35jrdUkSprGhQL5Z5th46HaL5Y	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1500	931	279	6301	12463	jwC57bThdXqQHfKyAVgm9CENpfXGFnifadfuJEd7qgxWY9KJaNy	8492	12027	12027	1618104060000	orphaned
16712	3NL62wDdG3rik3DDuphjrHXpebSjTWcWuMBvUDALPrzvzN7DwGJF	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1500	931	279	6301	12463	jwC57bThdXqQHfKyAVgm9CENpfXGFnifadfuJEd7qgxWY9KJaNy	8492	12027	12027	1618104060000	orphaned
16717	3NKYmkAayR6H6W3cKK2rw6V7xRcb9nEL7J6sPJYuKwc9j9xjkyaq	16711	3NLTdHYgJ3o2txf4itSaXM932oHyBfxphvrs333E8PDXRB6om9DL	1500	931	279	6301	12463	jwC57bThdXqQHfKyAVgm9CENpfXGFnifadfuJEd7qgxWY9KJaNy	8492	12027	12027	1618104060000	orphaned
16771	3NLvSHQBD26JHzxGyjgSeuwr8mHb7vKxegzVdFJkWn36Nwvi7t59	16769	3NKTSKx2ztq55CM6NZYvKgkF529PX1QDWvEZt98iJDZFfvZvcB16	1508	1387	281	6301	12463	jwYsK9r8MrvqGAYV9EuD5b7SLonVgKWqLFiPCnimzf1qmpM6VXr	8513	12055	12055	1618109100000	orphaned
16775	3NLKo3cw9pbQHLwzYSZvBHQ7da5BXxmLjdBspBURkyJWMiTpmNok	16774	3NKVCczE9GxbrguxuSPM3T9ooPYyxBpVeVHccHJDxTA4wQw6SvYG	1593	1100	281	6301	12463	jxAB9mzWqyTaLAksxKpVhB2BGEp6tm7LV1eM5RgvFUNtp5bzXeh	8515	12060	12060	1618110000000	canonical
17092	3NLH4QgVtSTY9vcQ53kDMXDwtV3fhJZrR5Wbq7jcWBZni4MynwQo	16790	3NKKyDhFbsRSF4HrbKKNXS1q4mvSiBNdgqmNjiCi1w9R59PZmtXg	641	1336	281	6301	12463	jxhbJ9mZJ6Pk1XRgpWyJtZPctjjxGG2amPSUjhPsafPYAkXXAiR	8522	12247	12247	1618143660000	orphaned
16795	3NLopsBu4REasPDVpPumiZadUDLHqCHTrmu9uZMsPk4PLKAu98c3	16794	3NL19daf2upubJcCucXRX3znSiqXvT8M5xN3mQztao8Mb1er2Tj6	1483	1150	281	6301	12463	jwPWbEhuCGKhhGjFREoFrUa9Embaf875dGRCpMJDZJSeMvnJ2JB	8524	12071	12071	1618111980000	canonical
17205	3NKWnxBGdoBf7u3ZA4AZnS73yNx9V9BxMWeXburCvMziYdZgH9um	16964	3NLT4r9Xrvow13UgTCUFHiKrVEcFkkLAmUTasx9ni2ZgsKevctM2	1474	1329	281	6301	12463	jwiXC97sn9YY7aFCNNwxz5M4db9no8xwZZ7NVWK8nVAAgRm4WKE	8524	12322	12322	1618157160000	orphaned
17261	3NKCKJxpGLc73t8WxK7ZMVyCczZWU9v35E6Bm9RsiNv8kFmAARXa	17205	3NKWnxBGdoBf7u3ZA4AZnS73yNx9V9BxMWeXburCvMziYdZgH9um	1474	1329	281	6301	12463	jxn559hDonGZruZ2csyzoM32KYzksFbHyeoRANwDmTtmW8KPvtm	8525	12356	12356	1618163280000	orphaned
16817	3NLkKgayRj5nJDvf9AEFjogAxejXdE9vkF53bNAH5WNDNz322kwr	16816	3NKXuUbEekLgwi4m8rJGw5DhqYP6ff19e7ALmnTM1TSYLQHMZdC8	1461	1271	282	6301	12463	jweQfiTDvGKDotU5Z1E6tx2ttUYKd41Jw2v3krYyebvBqkw9xJX	8535	12084	12084	1618114320000	canonical
17301	3NL6oFG3eTzeNVtqMFZH1Cnp3JJStjSaj3YNw47HqDQ6QmK31kxX	17053	3NLjvxtwxiuZvtqheDgLhL7UG94McuKvBn2Cgrrpr1JWd8b8fpXV	1542	1304	282	6301	12463	jwnbCBMJN4VTCBA9erXA12AUDnq9fve74VWw2WbWuitdepjuX4X	8540	12387	12387	1618168860000	orphaned
17067	3NLtdPydZV8oLQon2pXf4XkTGNAeLfNRCc4ybvrufn9zywZargoN	16826	3NLAfsVckBR6iuwjQpSeVnnzHT6tLSycjFKbNc5hDt1ABa4SqhuQ	329	329	282	6301	12463	jy34iAGKvMQdpH74KpNcHnhiEd2F3a64qyZPtnpxDS8iQ2HPCg5	8541	12228	12228	1618140240000	orphaned
16832	3NKdzSrGEkChjEVuZMgvCaYtmvhYThHckPg8NBfEdPuzYR4PDnh7	16828	3NKFkUfp6cokYaR13zYcUuVcvRiFKbbrWzTeMfZEVSvAxsn1jQ8U	1448	945	282	6301	12463	jy1wP25su7vRnrXScsTiVYGmZ6c1RVjhXWzDryPKgnMGR9ezdwx	8542	12091	12091	1618115580000	orphaned
16839	3NKhEpqCWi7i1oUezrDLuwg2koFhpmL2p2nEppnPpVrEC4kHRZRZ	16834	3NLERQ6ULNPqFxyoszx4jeWjGaysaMiHJsXsp8XqTvXfSFffDsPL	1601	1022	282	6301	12463	jwGLtCLcDCeGoPTp3cD7fnKe9xraTXYoLsEhHximjjTRAY5eZpS	8544	12093	12093	1618115940000	orphaned
16841	3NLtGfxwWpCEGEJ3rAbMWpHNzmcEuL9jk3GtoJCAcysRzjw3YhLg	16837	3NLei75DsxfAfy34GVn1XWt1R1VJwNAwm15UYnx4uGPPnNg7QmLo	152	964	282	6301	12463	jwNQEzv4Tga5VPzmSK5pdhipk6kQdag4Fj6BDKFH8RajT1Wu4Cw	8545	12094	12094	1618116120000	orphaned
16871	3NLSg1LR2TfmCKEuEHHwhExddaEeYit26m8W6XuVzmDEsQ8y5TbR	16867	3NKgRPQpi4UexUfkYbFayfkKhRG2u2qLK6DjeEXhRkwR7v8Nys1t	1471	1386	283	6301	12463	jxkunzaoHhZLdLHmaYgqL4GSDX8eZuG9hg44LEYi15wPu1t2M51	8556	12109	12109	1618118820000	orphaned
16874	3NK3qGWkacZ6kQNSoFj7inHXQEYPg6z1ZtteLzmPtzwi8iBQEf2F	16872	3NLbUPPk4bF9Mts1PFaQ2bvhvHZWSRUufdBS4jXwFTuFkMGhuRCV	1578	1296	283	6301	12463	jwPygmumLVh87kUsjKGbAxxwojWbDtHvN1gwCwsFrgT3RjY2pGp	8558	12111	12111	1618119180000	orphaned
16901	3NKiGHbPG6NbUxmoTbDGievedxqtBw3n12FX9UxbpAuzzTf7Z161	16887	3NKicx2tznWyYGrqKXmVxE1VXtw49XE8z8PstdVG1nbmskGpGzrZ	596	1306	283	6301	12463	jxCQXGiaNpdkwhz4yNLZhMGraUZviQixMW6HP1NkesTc7iT6mR9	8566	12128	12128	1618122313595	orphaned
17451	3NLe1CW3PXQMtVgU7omUznvq7L7HTeAzwUJEzWb9cTHn9y2CBRoU	17052	3NLpitDQKKuUFatogn9FwkPWaAXVMt62Pp7QgpoG1q5KakJgQUiE	700	832	284	6301	12463	jxSa9BSBCS5tEL8WzJotwQiMxL7KFZFm4WgRkHG4RG2HsipJQpE	8568	12488	12488	1618187040000	orphaned
16900	3NLaZZ4YHMrHtqfUEVKJu2rWEbsyzswt9gtTpBeE7jCtDTKknYE7	16893	3NKTJKP8T8MD8xbNtdG6XF8nTzq2GrkNLLk1aEXqmrg6NMN3RE49	596	1306	283	6301	12463	jwTq84D2kURy3PP5GeQjSr2JruN8a7PkZR99KfULTmKSavvLNVM	8569	12128	12128	1618122240000	orphaned
16915	3NKhfNjWw58uht8tpf7mUDRz8izZZGkM1EfdsXbCfXFCb8VSkhLs	16909	3NLvgzpCsJCMkHfj4Sqn9pMvbkaMxh4KgHMp7SKRxXnaKahgCfcS	1406	1393	284	6301	12463	jwAD8XvXYrz6iKSFewmN5RFkAdBihWn6qM6cnc6nvwm4C8ZGfcG	8575	12137	12137	1618123860000	orphaned
16938	3NKBMDxy2m5CXhYyB39iMsUZhaxbYsPJ1p8xrmoTy6giF7cF8XgY	16935	3NKypdYSim3HxLaSqUKHJCXJFyyjw5pxzqhh85L8239MYDcj2YQP	1573	1072	284	6301	12463	jwZ79VPE448mKsTfdtE6BjyTGQCZ7FKHzJtzzypahuKZmZaz3GM	8585	12151	12151	1618126380000	orphaned
17269	3NKcp9PYK11VH6oe34rVyRRCtgY9iBhyBA23X5EmBb5kfZ74T9GB	16948	3NKgNMWMpHyjUi3oM3XTZVw6uuyNkKfNFQH5r8ZxsNMD3Ezr1g4F	1601	1142	284	6301	12463	jwbjwssQS9qcskrkp7cqkyo2SePAfwd9NcDHEYG5RQSdKwbjGQj	8591	12361	12361	1618164180000	orphaned
17086	3NK7Zu3osh3uGZJRdPe2kyYTo1g4QsWQKD7tWbaBkatouYLnS9wA	17027	3NKvNQoucp75MCs9zLDvtXEmWik9wJVRFkaHkkvzyZrmmVJmFHC3	1489	1014	285	6301	12463	jxudtR23fAfLS1vk1r9WZXSy5yea1cj1F4pcguQ27foHEuYyK5o	8593	12243	12243	1618142940000	orphaned
16959	3NLS4Dp3B4abDYbx5ygEkBhSeJC4HHryfzBiDwy7cubmCmNidzYN	16958	3NKSqPJP5mCFshdHa1utkc5prxfB3NScYbcjdNnLzqHdvwSUh7KA	1516	1168	284	6301	12463	jw9ZwaNuAqpVdw3N3TUbGV87pB9vfb8wdLfurdLp1dkXmPGv2F3	8595	12164	12164	1618128720000	canonical
16976	3NKQBP22ifpiNoJRDskMZmn3VNdVmq6bD9qHMyJMGVhNXn7K9VyL	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1406	1393	285	6301	12463	jxGcuDraCLmEdjYobh2iUEYeRcopXtxhhrKTVaKygs1DM3cGBsZ	8600	12171	12171	1618129980000	orphaned
16977	3NLXLpgovW2vtvZZLgkp48uESFZLzc69Sryeo1LYftZVDrG5UpNw	16970	3NL8fZRFvbsCuoGVpaQQfY4coj2LGK8fifJFhxARB1Dh3RPdqLVN	1555	1101	285	6301	12463	jwC1KD7Lg8y4H7QZZAFdQsRmtShAHDcpc6G9ybBv5eUEjS8ahQ6	8600	12171	12171	1618129980000	orphaned
17151	3NKeqyK6cWqJNm7HZPXyQXWP29JihWpnqwNw2kBiVgwrtVE1Qy36	16972	3NKhu4jByJWLe56rXqKP8AtTUXwLiVe93JttBmZzoG79dWgVncCF	1471	151	285	6301	12463	jxPyKt62RvCJ24pKW6GA6Lq6HPJW2ki7exErYLRGzezwLqcwwYL	8601	12287	12287	1618150860000	orphaned
17599	3NLQWviuvZ8KyV51p8NDwXXmWxhVvHP6ZFdX3zUq2TZkBw16Zw8B	17101	3NKgbYxLKhUJz2AgfbkGgim2tYT3yQZAV2YQ8Jq63pL2kJ8JHKB8	152	1330	285	6301	12463	jxfhYJ1P12eaZ4Tnr4XQHsLSDU2C9DxXPx2twFn9Vj2UxEjdQ4G	8619	12575	12575	1618202700000	orphaned
17017	3NLB3iAAxSahcunXYrYd9ojX1uXG6JcY3r32CoYwGjPU7Asv6Y5M	17016	3NLcSw9a3LiUchs6fKLHy5EgVqh8iobzN4YSNELUw8d83TYG3sLN	1637	816	286	6301	12463	jwZ2gQXbxcEQEKE8wTC7q5xbNE7H7SBWYqNytJe7QfwD3uypWz4	8621	12199	12199	1618135020000	orphaned
17025	3NLunpMJknEJk1EwVTL3Hf1YQ3TFxdM6rbgdTex5LbBsMSNYw7HF	17023	3NL5a2ZmbF365vQ1ay5AcsXUuih7M2iQFh7YNDyV2rHXYdZJFPpr	563	1113	286	6301	12463	jy2ndvUKfyFa8JHh6vXtLr17GHoAJV5RPD6cANtdjHcamH93fxB	8623	12202	12202	1618135560000	orphaned
17032	3NL7BYFUh54C8LP24eY5ZLjfo6uvxvsfW228oJutM1QEhGYmxNjg	17024	3NKQ5Dm2ozCmhY6RJba55UhczaQrLtoJkVzuKzekAzzWoWpoCUQt	1649	1383	286	6301	12463	jwezvFxwoKwLbvmu9nqTwnZWbS4HsE3UM8hWRHt2b5uKqqp3Nkm	8624	12203	12203	1618135740000	orphaned
17055	3NKoAQj1JNXBnXQXPVBZfeqoknb4dEdJt5kvfDk4mUbB5YD6APCd	17051	3NKbyCXxMHLCBZUAXKwu7nqwsr62SsfF1a8NgsjBMQxrrWviHQA5	1542	1058	286	6301	12463	jw83jTBC4sEnwBqXj1HxPrw2zUDQaCVVJ2hDGcdzxM4wRWTMMcp	8637	12217	12217	1618138260000	orphaned
17391	3NLfQp8M6kjKCFNEL82YskKKFmUANLsbSK85eg9TuxuYi3qLHtBT	17264	3NLtZsybM9r5YfAqBd5bikWeqhQu38wFmss7GLySE2rG1RgEUpUH	1588	1392	286	6301	12463	jx3nZ1BSN4tLoKzDPd3vCEaGpMD4Kvh3FseMYz2TPwhAAhyoHxx	8644	12446	12446	1618179480000	orphaned
17095	3NLu9d5pMU32uNPwzUmtRdfJJ7nNBKxBe63Fm98PVFmZmoVSthQv	17094	3NKH68xjm6FZWBVZrzU1ArgXUsmmYywNZU6ym4cKkddx73LdVnBq	1596	1363	287	6301	12463	jxDsCRTv8urs68kn2jZdipC1V81aJM7aC1KmR78pwU2WZcCv9nL	8663	12251	12251	1618144380000	orphaned
17099	3NKybMqmuBUf2AxZZKFpQx868UkmX2yiqnAsTYbkVdb8GXXnWHXT	17097	3NKke7HDDssDn9F2UXCWbjoL29rnDbtuG2YEjwugEECrJCF8bq2W	42	1361	287	6301	12463	jwFyTho1nxyK1vK9f6gEXTLp55HVg6FxRustoXMux1gSjbohQbH	8664	12252	12252	1618144560000	canonical
17130	3NLD3fuunMkWD7qgL1RpS3JyiHtKT2XDR68oKEdZSwT22YFL2GUN	17129	3NLNoRuv7udNPM7BERC3WPTjb45zYHD9kzEXEd4LWAERqwS6T95i	1500	1171	288	6301	12463	jwGTVzSe2HosuH1QopuNhyH672sc9PxYn2Bv2Ax9bBm6KsSFWpT	8681	12270	12270	1618147800000	orphaned
17136	3NKR9HqMf3RHYPkCLKRWox8QUeYXTArUjU7WYpmGdW1tcv728UeA	17134	3NKSZdmz8qievmVgVYUA6Z21njAXtC3whraqCesGM7Q1hym49xTg	1403	824	288	6301	12463	jxrEcDjRBA93vHSw63bZWc31SjwQ1xg6vVTBroGQqUbwiGjPBGb	8683	12273	12273	1618148340000	orphaned
17158	3NLL1247JdajhEuzeaajtPU4FYMzfoQL5LzARvmnWuZju5K7YvZg	17154	3NLMztAC2qPS7E9Co27aJDnQXtoeLGbcQpPWGVegZ5R1Dko39WKG	1593	1100	289	6301	12463	jxcLxydF6XzT1y8wV5ZhtvCqSvPpcK53vamb5pkR1HpzqzjvTTz	8697	12293	12293	1618151940000	canonical
17632	3NLsWUu3dtzLnxPYpY368EF8BgkpQPqjTW27qhvhHZtR3zzqdBk8	17165	3NKvhGN9aqT9QedSCEieiPMYfivAWUkatC9p4pupqy4fqpvTvjRB	369	1312	289	6301	12463	jy22J3E6r9N5tAPsd8keFbfskyzsWaARpC1RpDD7DCdt2QzLgDE	8702	12589	12589	1618205220000	orphaned
17175	3NLyQPDy1W6R7GQjU52ZfUSEmukHfvmL6QTPYeBomFdr9pzezT57	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1627	1385	289	6301	12463	jwK4s4mrCXCdvWJ2BzcwBsPtvSzcFDSeoLbmYN3hVQF4KPoRts4	8706	12307	12307	1618154460000	canonical
17176	3NKQdc5gzKi4MyQEYvcvreuPDMV4fQ63M4zFSSTjEyuHRA5bPHQT	17173	3NLPsb8qHcxErjoPphCnt5AjvXaeYgJbMu126VmErT5nBsgbZEz7	1407	1395	289	6301	12463	jxsEronNJRbXy4qPtNyNAYMgYs8YHHSbHwPyTyGBZfxHei6R3jJ	8706	12307	12307	1618154460000	orphaned
17181	3NLroH1Hxw3trtXtLBes33YVNkouH1XDx5fsAatnyUitA4DPbtEu	17179	3NKAcwynZkpfBLLo1U3o7jq2zAZGcCb1d2DP5FC3Ya1AeSpLREm1	1649	1257	289	6301	12463	jwELYfU29z66bujr6mNKtBfmRyfs3KuWSiC59PFLPNWLwGmQLXn	8708	12310	12310	1618155000000	orphaned
17200	3NLGYKmKarPyYK75z9ZsZnAw7WyFKZyFHTpTVkc2RXvR1VCkmGwF	17199	3NLNi5RJesuTN4ninyGJYap27VhN27AGj9anyvx7C71sdEb95RVY	1637	815	290	6301	12463	jwHbcJYWZtPKq3Fb6j9uuT9J88r92SZrDoQwDqt2wxXfLdueUvQ	8717	12321	12321	1618156980000	canonical
17216	3NLcyK7Aq1krMaGmoCZM1LfxPLECXsAK4gnWRKwTCMYTVConk1Jc	17212	3NLpg4KLyTp4vg58Q4Z1ZwAQvy1VaoVbaaaWDGuHLTjvZemv6sm9	80	1273	290	6301	12463	jwUSs9tbnGckAdT9ZfaomnXag8ymjEA7eHxSsi8ZkfTjZF5N2KR	8722	12326	12326	1618157880000	orphaned
17225	3NKCSG7wYaAD2hGLWZGo5NW64KtvJuQMkd3ARQcHGNVRNEcBLP8C	17222	3NLcvwPXi4EfpTj3trN91aH6rdDybFYVXvjyGqaiaL6GaGWXEJpn	1458	1323	290	6301	12463	jxWv2hExtLtQoZUz6afEi5ENCeoYpE87f77CoRrt7pbP1UNivqw	8726	12332	12332	1618158960000	canonical
17233	3NK7FHnoCWg9HweLhdBLW7yMGMsgfnXdBncqC4A68wHf85gNakoL	17229	3NLoKJFGudKM65jpxygcQxkvEfzm4yffHHPbecUhpMXR9G86aQR8	1451	1166	290	6301	12463	jxzxpSFKuXNmVEuycvJ41TgeFq9huJwPYRpP6n68forApvjgMHs	8730	12338	12338	1618160040000	orphaned
17466	3NKRqij9Jo3LmARqhRXHj1UR6SxfXPUN1NsgZHLricwjSqVSp8MG	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	1652	949	291	6301	12463	jwgqdWrK3xdK5QbNMMB73jCwDK9mu4Qd6uGjFwwFD7tr4wAFk4a	8745	12498	12498	1618188840000	orphaned
17601	3NKrCAA86Yq8TpjNUsaDo9etgXSZnNNroC6rvELt7dG7AeCtZJfQ	17263	3NLHnySUrCt5Zsv77y51UUZmbqkDCPt6z9RNWSwaQ9R8MgkTBinr	152	1330	291	6301	12463	jwo7VMKxPQ8N2yw5E6yGF47mabru9br6hRSBgQYPPL3mFdHWTKJ	8745	12575	12575	1618202700000	orphaned
17280	3NLKNAS891Ar68dkhgnjj23hhbjJ3Pnt18TbtKKEp3JCgDzcrJaS	17277	3NKEZjk3b1QgKho5828TYeXd4oUfV3fH9eozFWC72zqXytfG3uZH	1406	1393	291	6301	12463	jxNgNxU4ysrqSsaFC2MZ6jNcms7qqoiagjcuwx9eba4tow3yz32	8752	12365	12365	1618164900000	orphaned
17284	3NL4QFLcePJUNtABTzyGyHwMCVgvSfcFU2ijTZzHwQeGDjorwMnQ	17283	3NLDdC1yEDBeDfJvhY3NRKkwxZxQtHchtdQDiJABn7cGqBaGNNb4	1649	1383	292	6301	12463	jwMEDMdv59EZogzpUZK5tarBQ4oGJ54YexyphBBBfJWNAgKapoa	8754	12368	12368	1618165440000	canonical
17287	3NK4dY6dXTaV9ftbVNBQweaDefwB8PRv3HZCS7ppPgUDfnPu7YMH	17284	3NL4QFLcePJUNtABTzyGyHwMCVgvSfcFU2ijTZzHwQeGDjorwMnQ	44	1325	292	6301	12463	jwgSfbY3Sz5B2RDWwaUBa5NP7cc8cgtFkTFjmDVFSmYYa1r2xP6	8755	12371	12371	1618165980000	canonical
17288	3NKs2c4B8HqDh75XcDh8ACDhk3MVGXRNnxsPDLBLmSjxMkDeEWnZ	17287	3NK4dY6dXTaV9ftbVNBQweaDefwB8PRv3HZCS7ppPgUDfnPu7YMH	44	348	292	6301	12463	jxEZkvhZ9WNDkqGigncBb5eQ26uXyVqV8REPG1rGdYmEQARxnU4	8756	12373	12373	1618166340000	canonical
17303	3NKFwiHuRVugRAVWKzRSQfdnuWmTbvzdmmNzqfXJgEzzkz3tK6eo	17299	3NKLnFmzEvUnPYYhNbqZnJQhgiysv4Kv25PZ6J8dYkMJjNoXHYPf	1542	1304	292	6301	12463	jwPakYejKBYZRTWoDXUuuSUFU3jwNYH3Xo7UFGzGwJCeRe5r8Dh	8764	12387	12387	1618168860000	orphaned
17592	3NKPnq2FXcrviTkpPCkxF1BtH8PLarUJLGgFQrA2yov72wZtUrQe	17302	3NLoMopcjuwzqgFxsb98A4QGpNg7HFfMugdgnmSWHAyqL3vHQTHt	1513	1013	292	6301	12463	jwvbE4kpSavbXowHb2TXGwzxnh5htZPT3CHqRY2jVHPngVu5iE4	8765	12572	12572	1618202160000	orphaned
17919	3NLQXfygomK4sUoZgcsJmj2fuFS58k29kfrQSUXfECujj5NN5h1g	17592	3NKPnq2FXcrviTkpPCkxF1BtH8PLarUJLGgFQrA2yov72wZtUrQe	1513	1133	292	6301	12463	jw8WQMvfxtLjD4kTpVT8gBeENoXM38sWHkcGksCvU86SfruEoSY	8766	12774	12774	1618238520000	orphaned
17308	3NLkm4Q82sCZonxpUS1rwCAA42KfQrFWTCf2KBSzTFQeaZ91Regc	17306	3NK8QvSzmFpadFwJ2uk97Vn3wkxWKc8ESHjrSxYHAseJZvw2pPyX	596	940	292	6301	12463	jwRyEhrWC83Ev5ULsq5KfRawLPWa2sAhKPpmBTgrFErVACCweHC	8768	12392	12392	1618169760000	canonical
17321	3NKpfgqfk6p1eNHQ6GQPM346FeknB38EGzwDMTFZ3CMuaFxK3Wi7	17319	3NKMKUkfZeVPkMpvdJkPwyjAShuj5ACkUqUMCLkX8bjeWDtweX1D	1406	1393	293	6301	12463	jxnFj8X7LKQ4GJi84sG4w1NUckaQHa5mppQyFLgCsKK3zuWtFUh	8776	12400	12400	1618171200000	orphaned
17335	3NKA8jooGge4bZ2QvqiVtp9Z8egnjVoAzAWSBvPucEwrdEcjjVjq	17322	3NLjTKwdTTVy1yUMXi5gzSi2MgCwMMcvRkSSZiMo35ren6Au8ou4	1672	919	293	6301	12463	jxCcxnwyRcJvnJe6qY8VLMjibNerpxG8MEFniQR35CBLmWdaKwG	8777	12409	12409	1618172820000	orphaned
17351	3NLSdviqqcrVkzeQDEsgseH89WZsCGmVCZrwBoSj5kMDNPDjF91s	17347	3NKFqz2knmTDtnF49p1szgoUthPgj7g3r8TpQJ1qAvxn7NCZK4Mz	1440	1377	293	6301	12463	jwRW9HvQeCZRNJ3bpMouKL8mDMmYVT2SSkXzEjA48thyjq3PYbi	8790	12417	12417	1618174260000	canonical
17355	3NKTEqdhxy3EiX1AnnG9Xbg6rdhkHrFrqcBy1AHnj6c5aEAa1Tf9	17353	3NKQ2piToxSzWLAJxnXrNxpaRQCAUfjnL7r1g7fCLVFGkA7N6XHu	1624	1334	293	6301	12463	jxWPvUobLzmvwD4NF9vpQBx4jvYAoBmT2ZTEYZLnpMFuBr4ZUMP	8793	12422	12422	1618175160000	orphaned
17375	3NKHFnfbQKfNHaYM3ZPz7kksdGhXQZGkM1MTByQrD93SdnvL3k4c	17370	3NLCks3DhcniUf4ZV9k8TCUKW79NYpGEf27FyHVNJL23qaXoJ3Dw	1602	1003	294	6301	12463	jwZRZWdjuugutvqwsdnqLR5A1DbMw4Lc2B56UtgVvQTccaYg85z	8799	12430	12430	1618176600000	orphaned
17404	3NLGrp2v4a1z7N4qhMnkGLWaFmgghp2qpbh6mCsKTVgDob3JgrhJ	17403	3NK8UwYd9Xy5StVtMiiK4uX3PjAZWrzUPct7bxUn4gk8bBQcbprp	1581	778	295	6301	12463	jx5j84w629dpzVibDqBaXDDrKDLANPYHg7UJioYbmNqS1HDYs9i	8816	12460	12460	1618182000000	canonical
17417	3NKTKtekbJfG6PZHa6phwXYtw2uJ1mms6Pr5DqfEVLtisXSEiHSd	17416	3NKUdHb7S3524faUrqRgvYaGvwHKvhLuminPvxbD1LJMD1ewKKxA	1490	133	295	6301	12463	jw6iKFy1WbEDSsrykqizvywKifPW1Qcg5fKms3moBAoJ3e3jGdp	8822	12468	12468	1618183440000	canonical
17470	3NLqjmbZ6q5qUUCaoJ8RRH2WQpyQQitPVnh3mizXcNXegKDbsC62	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1594	960	295	6301	12463	jxhKDR3mP83N4yyf63P36J843K6MxSSgVjstRbvnJCSoAENm2Hm	8831	12501	12501	1618189380000	orphaned
17435	3NKtCfGTB3GReMM1rhGk62vgdDeoEiRruvApYwHjAFm9KzjGYFnw	17430	3NKm8tePmjuXbAu9hR1aVGgpVnfbmxVrJvGrMNAD7PqfsgBgnQKH	1403	824	295	6301	12463	jwcEZvH93sQLKAHwW7rPmmqNna3TesDwteLZjr7tAbwtfJwRNWS	8831	12479	12479	1618185420000	orphaned
17439	3NKs8Q6tBwyKr14MtgcmTcEHJAaZ6RGygJyiXKZ33pEdzTYXqE3x	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1483	910	295	6301	12463	jwvxGdDV1WS4hc4JWXGWiotgmx3s6Jbr95KdjYTTxcjWEJJVNWJ	8833	12482	12482	1618185960000	orphaned
17442	3NLXJxdrSmRpc7ktCFrJt5bNbu8LRHR5nhd68wy88AgrZYk578YB	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1483	910	295	6301	12463	jwvxGdDV1WS4hc4JWXGWiotgmx3s6Jbr95KdjYTTxcjWEJJVNWJ	8833	12482	12482	1618185960000	orphaned
17440	3NLqa3FZgSeYjRcFUeCdLcipodTsNV6W3wiV5fuEbrAgAcYEE82A	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1407	1395	295	6301	12463	jy2S6Lcy1tFLzapRhYPUMQPcQ8JLJjHwBxuh3hqoiAjsgZj1WKu	8833	12482	12482	1618185960000	orphaned
17443	3NLeUPY21LWY2dPY2dUg3ysE5QWbEi8STS5GXDDoyYKemXhVkDAF	17436	3NLPPYfnoYQDtXt6XE2izD13zTH1XUgp6JU2QKr1gnJxtgnmpTiV	1483	910	295	6301	12463	jwvxGdDV1WS4hc4JWXGWiotgmx3s6Jbr95KdjYTTxcjWEJJVNWJ	8833	12482	12482	1618185960000	orphaned
17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	17460	3NL4uwApUhEg8v7uxLz19ViUGWTonXn5WJN53m8ja9fX9jcjYMpv	1652	949	296	6301	12463	jwRyDpkhBXeVE9itiCtLph8ebXh2jS86dmZWcBJWthg6dSPpC9e	8844	12498	12498	1618188840000	canonical
17784	3NK5SLgDvtiRR9ZaNmnKu56ywy9gBxW8sthqBUq85ijrR65hRR1z	17465	3NKiqsxvxJCmtZRDNuANsYkMMYQhca1QNoWKCQxXeSmBpf9oiZC4	1549	1362	296	6301	12463	jx6Ai3Q2bk2T8KGa2HQfTFEvSjJ2RedDZVkL8mcsqKDmuobm9bU	8845	12702	12702	1618225560000	orphaned
17481	3NKiXYmHRG8rZjstAUhPB1EdhMo8hAQHM4hzLQzJMfZhY1Wzrdmp	17480	3NKm8TRu1WZhGMAZPy5z5pXCQSHbgEpBxgLCLDFLzZUWGGKyr1r1	1523	1075	297	6301	12463	jw9SQwnHRzVu2Gii9FndbFnuVqX9PoyGSABWjqe5c9Hm9S5kC8Y	8851	12507	12507	1618190460000	orphaned
17487	3NK3UPHnS1iZGLhhTSV9iHD7jwkphTMnpp6YajDASMCJf7YvKen8	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1406	1393	297	6301	12463	jx9t4nmTdjD2czHgLk2Nhwj7LRD12PWSGpijUCrEkNfrwiM22qj	8852	12508	12508	1618190640000	orphaned
17538	3NKEZBg4D4pta6sbV9giuYYLuttqKuFzwhvrjL1sp4YgDppFirTM	17482	3NLo4oSAGz2mtTy8vquTnLbdHCxTfKReU1Av89CXh1yu1GDhk6jS	1571	969	297	6301	12463	jwAdhdaDmbSpe6aszrqjLjwZctgd2Hby45LLirbBLH3n6CcXaG1	8852	12548	12548	1618197840000	orphaned
17688	3NLKwR2WNymmRwwDmAM51LjEsjSQZ9FgSWjk9SrDeQmux9NR9RtF	17582	3NK5X4w4Apm5iySfFNqybA4vvtGgM2AXJiW4sY66SS3SfAeo1Qij	1571	1335	297	6301	12463	jxFMB2a9Tq65RJpySZRkxZtEyXgsu3RABjViHcCZtB8bSuFSrHi	8854	12625	12625	1618211700000	orphaned
17866	3NKKjJGUrj2KQpNZXM7Y6NtWH5ygh1GcHVs11EDY9cRBS6FvB45K	17688	3NLKwR2WNymmRwwDmAM51LjEsjSQZ9FgSWjk9SrDeQmux9NR9RtF	1571	1089	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8855	12739	12739	1618232220000	orphaned
17886	3NLJpoj47Wm3aF8FFtDzxot9Y9dNjS3Hkm6yVx457YCGF1wRjXQD	17866	3NKKjJGUrj2KQpNZXM7Y6NtWH5ygh1GcHVs11EDY9cRBS6FvB45K	1571	1209	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8856	12754	12754	1618234920000	orphaned
17787	3NKWSSYqwhZtK62pgLCgbohbgGm9EAMwBUim6ePN5N2f54aQFBn8	17495	3NL8uzRT7ApjNioT9Nj1dN8s2GHmPLGLMD3QxmnZv8vS6F64V1Re	1549	1362	297	6301	12463	jy2ZWqsWKspp7xFLcCvVXbVknuFrh5LWVFxFXBqc9LmJTyEmrRm	8857	12702	12702	1618225596628	orphaned
18083	3NK6qFZvbwS7kuUt9guCwDdQ4WZRLNdQFsP4FsyZeJ74k8SbaQdb	17886	3NLJpoj47Wm3aF8FFtDzxot9Y9dNjS3Hkm6yVx457YCGF1wRjXQD	1571	969	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8857	12878	12878	1618257240000	orphaned
18116	3NKPCmQDQUQUC1H1axb7zoW6xUMh12kgFrd7JeN7jAuWyWhP2yNU	18083	3NK6qFZvbwS7kuUt9guCwDdQ4WZRLNdQFsP4FsyZeJ74k8SbaQdb	1571	1335	297	6301	12463	jy2vqEJSb5cvkqUZuNLwrnvk2c3dTkNnRnLUSgQTXh7ALFyGkRv	8858	12899	12899	1618261020000	orphaned
17790	3NKbNobdczPMEAsoEPntZW1RJRMGd57RhJtwCF49U9U656fUhfmt	17516	3NLZr4BBMEzZEYrWn7hjH49inHFhRch5nXTvasotNg54zmtVL8TS	1549	1362	298	6301	12463	jxYLNqgXF2X5vJqQirwJBDzzaJPJ2WruJA7oeYYxvRzLSe8XND7	8870	12702	12702	1618225630387	orphaned
17521	3NKbpyi89nEwS6vfEjNz4XgaHxoGMaaVcz6GXVoNB1ZABeHYWdjz	17518	3NLcPmc79JomJHmS1NyjFLrdbHdVdhxdeT685GB5gYAvYKgDAAZe	1637	815	298	6301	12463	jxZ5z8UA86DgbrH9QuJb5gi43HDv55doX365PqbsPASxn3f4cNE	8871	12530	12530	1618194600000	orphaned
17541	3NLPJJpzKLouSoyyXL4j3CPmruFYcHaHtXYXp2GZSBhs8x9tSn9B	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1541	932	298	6301	12463	jxTkGcx1KQCkM7qa7mKYXYVFQvfHDsjTNSLAfhVVdvmFktjEgbT	8883	12550	12550	1618198200000	orphaned
17544	3NKG17imkvDeepSQoy78Y6qCfcT4J6VbjE5zuujtwdFpifTjEpLz	17539	3NLvQupMkZ1LW9PuUhMUJ2okRpeV2A6XXgJZA9rCz9KwPdvYS8PY	1407	1395	299	6301	12463	jwhGfxcrfYVkRy2jz14gwjtghaW61Z3LZR6XY83EiRPtw6yLXD5	8883	12550	12550	1618198200000	orphaned
17558	3NKLEaj8VKx94rARVFBk6xrUTR3YbJtaie8AMb7wKG2BRKJTNsZv	17551	3NKNisX2xGCNTxDmzAr3ZbosJo7nki6eu5RoaPvq3Q55VgecNrbq	1573	1192	299	6301	12463	jy3Dh6NJaPcvKUcn9Brnjv9DKN3ZJB69scrohwYmvTgsi8SEzED	8888	12555	12555	1618199100000	canonical
17792	3NKKJfpmyW3PrR2jNQtg2yC8SWa4f16aLU82ywTRsi6NKMsPQMJZ	17575	3NLvW4E5dbkNiuCr5C5oPaP6ywWETpFx3XcoopP2pZNkN9d4FuFS	1549	1362	299	6301	12463	jwHxum5WVzbr2RfzpewBwvLFqPe5Wqeu5sbYBWoAb7ZzY5Tx8jZ	8895	12702	12702	1618225697454	orphaned
17586	3NLxbRL8fdXdab52mmBaXoaqSMgUW78d7Vaa96ZttRMSv8D6xu9B	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1651	1055	299	6301	12463	jx4VVU7W8KUGhKqNLPATdaLi8pTL2mKDRcZp93sNrBAmXpeCEZy	8897	12568	12568	1618201440000	canonical
17600	3NLTuoFcbkUixe6NBTkoED6YQBmeFA6qPvnCTGeGtFUbebHbXB7R	17581	3NKKTDHh2jvtH3m1STF4Fby6up5fHN6VMAjYsudUUSh6neFZuNFU	1673	1368	299	6301	12463	jwW6wHaJVHitbzJZDtCRUGxC8WuehHmqEtboqkHdC4TCcc2Z5ho	8897	12575	12575	1618202700000	orphaned
17591	3NKvwb1YYwTmFKaZrc1cRz82kb2NN8co8mjM7rVSsNJPLdZBnFsZ	17587	3NKXkyLo5JPFrBhz4sUojQFBfT1gX6uEwQ5HW3HuhghFYFfJu5ah	1650	1249	299	6301	12463	jxquqWedjGQSfgRBuf1EB3Wgk86oyreZjuaD5zJJyzodCy1Ftg1	8899	12571	12571	1618201980000	orphaned
17624	3NKNEJWJv8AvePHjtHYJaogkFsU6WUwpS7ZGCaB6tPBEfWx9Y9W3	17622	3NK7RX1s8cbekwynPvHysBWAq3VJr8Km8BD6YPc1AarGKHYs9csK	1541	1298	300	6301	12463	jy1DfzijEJvr19uRyskZajNskmCyk98M8nzZpStRmB7DZ151Wc5	8912	12586	12586	1618204680000	orphaned
17959	3NKVdqP4DnCkydZma7vLSoTkKANYG7fCAodStEufyP5TsKXkeC58	17712	3NKWtHL64a7cYuqJz7r44Bquo9YiDvtBqE77d9TouVo7w7r7rpdn	1516	1294	300	6301	12463	jx1SCxX2fvkQkjXRE3C7sL4FarM4HaM8WyToKEduGRv5utnmDGn	8913	12798	12798	1618242840000	orphaned
18057	3NKokdCh22kNz6NScou2wrj2oUjFyRr4D6eDM1zbQn9zge3uLrPK	17959	3NKVdqP4DnCkydZma7vLSoTkKANYG7fCAodStEufyP5TsKXkeC58	1516	928	300	6301	12463	jxmFHfHaXnMiaXhJwpufqgTiTkWN6WMTJuZZp4YHcdt3BP3xLTy	8914	12861	12861	1618254180000	orphaned
18177	3NLT8Mt7e8LpKsr3dsjUA4EaS1T3ePe92VYgqDbRgBdMPPGpZycb	18057	3NKokdCh22kNz6NScou2wrj2oUjFyRr4D6eDM1zbQn9zge3uLrPK	1516	1168	300	6301	12463	jxe6bEKL3LSjUgjzqUNwRVtwz3jTbmHQvQLiRYWtiENEPHCihCK	8915	12956	12956	1618271280000	orphaned
18135	3NKqFQr6bHLEHaXaYYsnAeR4NG6tBmKZ8uwJeTZWebm2sruA4XV1	17703	3NKGUvfByN6FGnmTVKAEE5VpXV3V19iaYMx7mqBccyxeLqbXhy7a	1500	931	300	6301	12463	jxU4mam4ywqWpjfjeQDBTQgztQDHzQHwT6WRREc1PZ3wQrit6co	8917	12914	12914	1618263720000	orphaned
17677	3NLt4LKFD3zSuULXAozE1X4bYEaRdoEjDLRi9pnzD5WfaCbnctJE	17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	1585	1240	301	6301	12463	jxUN4yJi2zSx62PMHD2Q5E7k6p7JqsNuKiubLeBL6gJTXG3omAU	8935	12618	12618	1618210440000	canonical
17675	3NLRoVLf6KXpj7Rt36HJBL6P2wrkYKUEtH48k5EZgcNDDhTdAmBV	17674	3NKYQQR9hxmEtL4HZzpBWQFykKhTW9TXFxigYwRwJMxfr21NYA3G	1406	1393	301	6301	12463	jxqSyavnjQAjiWVDfEw1Ep8mpbxRxm5PGHkLpQBckccoScHtaLe	8935	12618	12618	1618210440000	orphaned
17691	3NKNZAQZzSvT7vnq8P1C6rxDN2CkVSqAcK4sE5t5nPeg3xQstK55	17689	3NKh4ED3tmwzE76FbgcFduMNyCBoYWatyQV4rK1KPopwozo42vNj	1610	1314	301	6301	12463	jwas2Sbk1DAXgYn3g55D1afm5Ee2UK3V5gzphNNQWz7TJ7y7LRG	8942	12632	12632	1618212960000	orphaned
17695	3NKhDVb6Fvc9NLVjpDe3spEfEqghZusim69VGikjnNbsqSy7tYBP	17694	3NKQPTuXNXo3BWT7evgQMNYmRFoDFcT25iL5xa78A9ykxe16AzRv	1601	1022	301	6301	12463	jwU39A56V2FfKX2jhK6PuqbHcf5UaDYiUxaTPZTzR4952chMEd1	8944	12635	12635	1618213500000	canonical
17701	3NKvpPPGjqe7MeyurSr4dGKnMnwKgt9e1hWunizNZD2KSCrKk9KU	17697	3NKFWDZDwC4iSfjRnHH7giSuy7hAMs4SnTmQwGNXTzWJMNCJFy6m	1633	1390	302	6301	12463	jxT8iL2527UdDf8pHSVy9YqvKWZWUXzANihuTMsMbvWRsDg15YD	8947	12640	12640	1618214400000	orphaned
17704	3NKBBtn19C2wUCZYv1DWpVixwjr5Wnnhu83JNuSC7L9xvZEBrxCS	17699	3NLHFg3LqMnQ6wy9jX9hcnMQTaABnhK2fi8jRMnjLg82Yy6EPimT	1619	1275	302	6301	12463	jxtSWCLjQ1EhsijuJCJnePn9ZyGuQ3L7iCpUcPYn7mpw8hztHXy	8948	12641	12641	1618214580000	orphaned
17741	3NKuXM8ae5tm6NUELgxjX3kp2v7X5g8bUzM8jTua4quMx42EXvxj	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1483	520	302	6301	12463	jxXy7jR8Gj1M8AkhacBBDpfD5D9MzchdQWfp1n57jYCAG7tS1mt	8966	12670	12670	1618219800000	orphaned
17743	3NKkmXTRd49KmNsGttaGf4ZawvgwPZsWPPJDcYBVUrYfMYdbvTwB	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1483	520	302	6301	12463	jxXy7jR8Gj1M8AkhacBBDpfD5D9MzchdQWfp1n57jYCAG7tS1mt	8966	12670	12670	1618219800000	orphaned
17742	3NKmz4NKtGSFpkSwRP5gqR3qikSqGb4SyjyaZ5skGMz3xZTJHd2s	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1483	520	302	6301	12463	jxXy7jR8Gj1M8AkhacBBDpfD5D9MzchdQWfp1n57jYCAG7tS1mt	8966	12670	12670	1618219800000	orphaned
17744	3NLY67YtSe5DsotJUkoPG3EwyvpgAMU66rofum2rbrTCNPhkeh2K	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	532	1303	302	6301	12463	jw79epwzM5C5tHT5Mw7X9f32PwNvvvmUYwgWjC4an6ge1V5ewYm	8966	12670	12670	1618219800000	orphaned
17745	3NKaYVJW7iwpktXb9E8oeiVf1gu3MbGejToXXMZ6yKxZ9kiPWQNz	17736	3NKc7LU7DeXd9Sy6TzNxGDDhX2sBJbWBxpAPzb2Hwzvrs2fUy5N6	1624	1088	302	6301	12463	jx4TTyhKcq5Ke93RutC3rQWwPQpZyK41m3Eq64g92rPMr3iixyi	8966	12670	12670	1618219800000	orphaned
17783	3NKVpANZxKYjLie9q9ujVyCLCJiX2ALFSFjPXKD4s8UfDf3X54x9	17781	3NL3iCMS6Gv9kAn5LV7QwLUyrG2jWQhYNpELA4zYqnWgKGSrrGcn	1407	1395	304	6301	12463	jx6R19YT2sfNPsKKDz4K8wiQd71vUHWKnRxDh8j99ELwavr38ac	8986	12701	12701	1618225380000	orphaned
17803	3NLpcFcAXPuPg752wRkTQqmS3etNNYhfQvCERKoAtS4AQP5CenfZ	17798	3NKfrtBwTZLrCsF2V5yjoEPcrHRihXM74sCZm6aC9cgDDxJZWpe7	1594	1326	304	6301	12463	jxP2S4c7nPvpq3hkrvDt3DN9RGU5g3obJLhS95Wmg6oH4iNHeow	8992	12708	12708	1618226640000	orphaned
17810	3NK3boAK9cGAo7TkjTd7TFExjjnRNdP9gFrUAnMkF5bD4zyzT91u	17809	3NKx6a2bXxduQuYJEQsaES36A1QrLiZoKiaD7c9hnK2hYQfyQfge	1623	830	304	6301	12463	jxLwMyaYUKEcQVpGmZLsZe2mNDqPHz2FMb46pYVNfjk6v7zf8j8	8995	12714	12714	1618227720000	canonical
18222	3NKmGxjfmntdkF8VFhZTx4uZFnvmszwPZwBr7psQGCMScsM9nbkH	18042	3NLZ1F3F11iYbm18D8CiFa3pXrxYBud32s3t9M97xrQrXw58uGLj	1481	790	304	6301	12463	jx5FHcjFYdLmcFyVyeiE3VFjYS9Bq6r63jU5JKmsJAJTvjQPshC	9000	12972	12972	1618274160000	orphaned
18384	3NL815yzdH8CUBw3aswhRoLZLLRSqaUur4W9V1EsXMK16TgboVm4	18222	3NKmGxjfmntdkF8VFhZTx4uZFnvmszwPZwBr7psQGCMScsM9nbkH	1481	790	304	6301	12463	jx9fseydvrsaMEs5QAbSkzTsgFM8Ee8G3JZqSjwTRYTjdkbJ5aP	9001	13088	13088	1618295040000	orphaned
17826	3NLJpYPuE3kJMvc9dGGikm4YwF36BUz3jMYff5ocGYcuZjMNdsLd	17824	3NKapUM8qYkaQVMiZxmbErifs8TSh2MtH2W9BBmS9hDbs2YXSyZ6	1627	1259	304	6301	12463	jwkSVweZLwvZjpeudnmqyoBG7E8qrhDmuNeNvd9qGz2enpjybub	9003	12723	12723	1618229340000	canonical
17841	3NLdtqNtB4TDhfUaQwGzuzxebFC5xDJtVn3iW4ibCwa1yAJkiUJn	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	470	1309	305	6301	12463	jxbANz4AKgzXt29DqqLRQMGcZYSwcLX5HASj4yizgPgnRx7nQvi	9007	12728	12728	1618230240000	orphaned
17846	3NKv1bZYhdPvqpY8qC6ytBNVCJ8YGrDSgimVBpv1QVwJqWX61F2K	17834	3NKtE7ifUyjShHjyAuboVTEMvmymRLCrDi5nAhgT8kyRroNk54Ac	1403	824	305	6301	12463	jwLd19xtCCSr54dB6T1aypGZM5GycABMDLVE43ctmqXWXfPHuCp	9007	12729	12729	1618230420000	orphaned
17839	3NLQnaJ3SaeDqPg3s1mW28cKwhQF9XUABFSWYHywqxNASaXKwnNK	17835	3NKGZZCA8h2XrFzWsfQ2b8QhArKBBNrV8x3tMgmsq3DWHBAB9txm	1534	1071	305	6301	12463	jw87QzQJos7c9sQXi9TTi9NkXdV9jKspZ67guoL4bLZyt5bUjKr	9007	12728	12728	1618230240000	orphaned
17845	3NLd8q2Ex9NMt9344enN1wF9v5jeGYYQCPHPknQF6ZiEUDhxrWuc	17842	3NKVCVdEvpQL1GV9urmNtNCyj1EiiKDKsgZ6Eku5R3E2Pi4kESnc	1546	973	305	6301	12463	jwtGYmoSz6WojpsbQTSDk6qXKr5uCMepymsQ8sY6wLbNewJKy9v	9008	12729	12729	1618230420000	orphaned
17881	3NKzm9T1pmRDETjSwXLsh8U1dmGV8kHYEXwycUnx3rsHDZy2bNTu	17879	3NKWPg78D1MgmZeYYbqJEBd9hrquMbEgkFMrVAuCJEA8agMohdrb	1406	1393	305	6301	12463	jxXgzZX9SjJQ72KQ7C2fciiGfTc1YKWuSJFUZVua9zUtHCibFsz	9025	12751	12751	1618234380000	orphaned
17889	3NL7bpwMB5BBmx7c3qHrbdXCfF5QRtuHoqiHQw1YNvqBuAABVu51	17888	3NKM2kXmJYcUSTEpdJHPaBNp32wNuzNRpiuF6E2FhamE1nMpQ8HA	1634	1085	306	6301	12463	jwq3cBsDhPMxnWJJ8D3tvVivU7qvUUDsMiP2rZEd8Sstr7dpFUh	9028	12756	12756	1618235280000	orphaned
17902	3NL8nte3isdUbkCHRTmXpsLnRR844HDGUZWcwmFTXCKBvc9zFBV2	17899	3NLjGkNdGTJTk9xDU897gNomSyRouHbFuccj5zdtJ5JEyjdn4FeG	1581	778	306	6301	12463	jwnmdG8XjWJVnw7kBRkhttFDm1EFfqhiDst7UPdQAxqbSxtWZwT	9032	12766	12766	1618237080000	orphaned
17908	3NLNK8ifUXAZD3YS931NdTBhgZCNkLgooKzvwPqqPCvjHtvdnUQE	17901	3NLW9ng8LZNHe2dTQsseYAwyJ5KWZg6MoKumSdgwbK4dLurbKeLU	1643	1053	306	6301	12463	jwEi9a3pyDaR7Po2R37T3mcJDwqykTSE3hucYiRUMp2NsPBoTB8	9033	12767	12767	1618237260000	orphaned
18507	3NLbtdksRA6bX8jqXS1E5kFBW68vtcHTyi9DBcchqUYdu9U3giEA	17915	3NLEkZguQvuZM1Yp6krFk9gLDZ2VL5mmY4kdUeiqVubEHxd8vGYi	1592	592	306	6301	12463	jx8MAfXPHr5hsRVvuEtpXqtoCEkerthCKzojHp9fgsHEASWpKJX	9037	13161	13161	1618308180000	orphaned
18508	3NKmLpRsSvSYt1iZBWDqMNWsHUNcfUFG95ygdCUvMeRKgATJsbL2	17922	3NLkZeyCXza9HKHCJ1bnhzk663cMAazwUA8nkoK7ZS9v4tsEat3j	1592	592	306	6301	12463	jxgRWJs8Y3hqDFtMgFFCHqSK3ttowHDC16LwBMtzQHSMBFoAMCJ	9042	13161	13161	1618308235389	orphaned
17938	3NLyFeBq5Rtoxcc8aYx8Yd7SnbeLjYnHzZQTnNznYLaYUGo6oYDL	17937	3NLRrvmoqfGBBXVrwrKyqr1Dn2zCoxAEicNDfXswjMSFXRp8F1by	632	1382	307	6301	12463	jxc6LtKAYQwpTzBp1vQPPza5PpqotGFFGyLDeeNPBaS2kXpjwDX	9048	12785	12785	1618240500000	orphaned
17941	3NKMnpvn99irDWSeC2EAVoEidtfMUtdJpvJ1hsq5FqUVYGfe7Uj5	17939	3NLEFozNWKYEywMviMyfUBXxmvdEr6dSYcdCbszexEnjYLcyGrgT	43	1310	307	6301	12463	jwgfYmhdmdL7jsWP66krkkPjAgcbAnWGnoV1VCrqaf9bBS8Q2QL	9049	12786	12786	1618240680000	canonical
17946	3NKEWRpSdtrVGopoKcV37oU8c9h447fU56vtrxPXwZWqHdrZnbkk	17944	3NLZr8ArGrPxsCZj2fahDtUHzZkA9qNi8NuSqrmSfrJe4kopKBWx	1547	1378	307	6301	12463	jwarJyHJSWbfLSNpvJJ6j3sq5NJLy3tPh2f3Yq1xxDtkpPN5tHc	9052	12790	12790	1618241400000	orphaned
17967	3NLSuxeUaDafV2EhAgisbv5YDXRGomjgna8ifveEG9rRVKT3qUjP	17966	3NLREmTdM8T5w1MRFwNWAJnqtz8oAdLcyadn6hBDVt78ws9K4jut	1503	1031	307	6301	12463	jwMnqhrGVFnTsQiBWZudZs8SJ3n5NTt8Be27EQ6ytzPVqJDR5kQ	9063	12805	12805	1618244100000	orphaned
18004	3NLa8HKbArDGg4nggZJcRweagsELHRMCNFXDSb7uTHK21Tzr8Unq	18000	3NLoDCqLxN83iGis5fAv4nqkW8DVeVJikme6upTCTuexDwPFAePv	1560	1291	309	6301	12463	jxk8DYDkBQ7NX8SDALzop1d41qQw8xjaDrme2N8b4JcBLddrumT	9082	12831	12831	1618248780000	orphaned
18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	18015	3NKfvfsHcizyLVLFb3NtNF5ZSaCHHRqLk22NxvDDYzf3h2y1vK9v	1607	1102	309	6301	12463	jxkBhZZYYACBRueSjbQqzLg7m1P4pygzncXuPBia1Q4zQCtwNds	9088	12837	12837	1618249860000	canonical
18017	3NKKwDWjdNtMZT14AJMH9G5vwFtxSGbb4LU2KhAwPZyBngDhuPeo	18016	3NKjyr3YzF4Me4efmGT6nVnH94YQbzc6z2Kz1JHzpPKLSMFFfnCa	1451	1292	309	6301	12463	jxHkrMHzL3F3foxboy4oC36RGQtQ9ifQ7y3Rn94jnUdkWhSBAcB	9089	12838	12838	1618250040000	orphaned
18021	3NKzRHwVPai1ou466JdyEVnPHLBzmn2dbfDB3ebrSdDbcpCxwCxb	18018	3NKZWd4wG76Dfjvwhtw1FJ5QbfNQhKo5517LNjCVbZqodRaPSGfe	1637	816	309	6301	12463	jwo9QoZUDVpUSk6Kc1yUgrvg8xcoeg9gnbe7NxsVyRTd37eW1VR	9090	12839	12839	1618250220000	canonical
18056	3NLGMUYDBNRCy2tPKegyQXoHbaj3xPNAdW7Y1zhcJ25h7efMj9Ks	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	44	1079	310	6301	12463	jwpnW6y31fsiSvLZDiafqHXyQ4i8raTtS11rkxSxmCVS1dGpPwf	9107	12859	12859	1618253820000	orphaned
18053	3NK49DLmkoqj9i5Dhj8NrQt4bzaJPcjP94t6kPgFjVp7t9gZwkN1	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	1462	471	309	6301	12463	jwUQpF72hacYgQ9p7uMy29oq3uq3YKGBmLx5FLyXTNSTH1mHSuT	9107	12859	12859	1618253820000	orphaned
18055	3NKPUT3LpS3WTaEjo8UNDtWR3bNUScn3oHL2yUw3w7TMtKizyBoi	18052	3NLGBFkq54hRMQ6Y81zXRxo8kfdGxtcJ8VjLdzYRpnj9FcRBzs67	1462	471	310	6301	12463	jxpwPCufWMMmjQidRRPxcvUfuAD1mHi5UpTqaQMhn8eggwFhH8e	9107	12859	12859	1618253820000	orphaned
18367	3NKaNrzQ5rp1wde4kthnkwDDqk15eMYPtxosuZqEENRmUeV5UBNS	18126	3NKLbGi6j8gkagt9Bb2PFKrr4b1ZuT4sNmtjSEkYmhnUCuRKG2z6	1555	1101	310	6301	12463	jw9HpdUTpB9WGyVwuUYoqXCiPmYtHAtRR8bc2esvPfNtLzVKQcV	9112	13076	13076	1618292880000	orphaned
18071	3NLRpk5FZHHboTpH9fqUkBqhdmTGUGemRsntwZadWGbVt5kZ4Kwi	18067	3NKB9e29narfkfE984k3yNwE7rUvT7vtuzb4AKMQCAkiWnTsGuGH	1513	1133	310	6301	12463	jw7p34VYD8pdVc3ixKAUNaNDGnusLtseN8DiGtdCvACGDzndMwN	9113	12867	12867	1618255260000	orphaned
18092	3NL3X8PzrvbaveuygU3pqf4WdFFVG4Rke16xNR34X1nPSCwtPjzH	18090	3NKcoj43yjxhwYk5biwvV7Xx1auuraazjo4R67C9QMdiVYa4MZAA	1578	1296	310	6301	12463	jwS45g4wtAUKRMz5YvcXrUnx8R8HH3zJTw2WmAH3rVTtUfHhTTE	9123	12883	12883	1618258140000	orphaned
18223	3NLXdE19xMbnyE3DcZEpYNSpB59xEVgyYnrkPUf7da7xsSrxcPhe	18109	3NKmw5auRQ74hPFrYEjrGg3T4jSJicSiK4iUipfg9tfFBymm27HR	1560	1165	310	6301	12463	jwT4syKDsUveN55VJBgJ5kp1x5K6nYugKVooidiM6gMzXYFByUw	9129	12972	12972	1618274160000	orphaned
18112	3NLcT9zKQUsFB7AiUj9p9aseHKBtcppb6qPGPsNguLrrJkoEWrm7	18110	3NLwYoWvWQfB1fuUwrnWBY737bjBtVkrVgjFSP8v57Yk6d8aWxGe	1406	1393	311	6301	12463	jxCdVjenBGYEPRtersRb9Y3maJST7ij57dcwNUnYn5xg2iiSCdw	9136	12897	12897	1618260660000	orphaned
18117	3NKsZkKSFbz17cjd3xQ2VYm3YkLem7oDvaAjMNtWe7PzsNenegdD	18111	3NLX3w6BLoRV7eEtt5LaLyec5JLjdFmdxMLD9ucbnAQEnVeoD4ZL	1553	776	311	6301	12463	jxUvk3Lzba6Fq6kTMQ5DShURS3yKtFbA2oH1cbA5Z4kZWygcLzg	9137	12902	12902	1618261560000	canonical
18132	3NKEydBvTipJAkAHtwMf99uHKhSnHeANX3u9hYkcJuAY3aEnHibB	18129	3NLPNgd455m9Er9T14q8KTtRHg9aPeYv3fEYpz6N52AarnpP1qPm	1489	1380	311	6301	12463	jwWsb2p1SH3YBoGRjxjFML9f4YURWVZbwrnn57VyBEZGU7rhaxS	9143	12913	12913	1618263540000	orphaned
18138	3NKQoNJypjgo2E1jeMBbu1wZ5ckwxiXnRPiv2fFFhs8y8hMfBqi7	18134	3NLceH5HY8EkcL6qVYz59mXb9JJbJXJNicZL3CGihuGnGxCL2hRV	1483	520	311	6301	12463	jwib7uMghPJB1WNXetEiWnyjMmoMxC1yi7yieWKfQJP92Sd3HeQ	9145	12917	12917	1618264260000	orphaned
18190	3NKkbkcyenZ6hjwfgTvmgUvEx9hfhVVxeEFJ3T7gmKYmn2mG3L7s	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	364	364	313	6301	12463	jwocJUtTxqUCzhH34ZDX46bR5YoVWoRqYnKSbYoKqHeSEwwSwqh	9170	12960	12960	1618272000000	orphaned
18194	3NKq1bjfFZmJtRsezeEVRvw9LQZUkEAeQ6Nf8tMYYQSEE59N19dw	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	641	1336	313	6301	12463	jxpp4aSZ8VPLrNXWGKCwR5qhyg9ZLqpvKiZpb281eoajftwvapJ	9170	12960	12960	1618272000000	orphaned
18191	3NKmss5T7oDfhdXWEwWANELGrd6DZvcmqA8CuDica6ooQjUvJtM8	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	641	1336	312	6301	12463	jxsyDgy39qty8vaFcMaDHqCSDHzEcAT6hnbjtb3uHVdWiFuKZft	9170	12960	12960	1618272000000	orphaned
18195	3NKBUw1Pdrn2WHBEygPVED6t8u1NfFK35PskejzwMvbEBmH7Joe6	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	364	364	313	6301	12463	jwocJUtTxqUCzhH34ZDX46bR5YoVWoRqYnKSbYoKqHeSEwwSwqh	9170	12960	12960	1618272000000	orphaned
18186	3NKwLDoWTUDn8hyKoFELNieXReeP1g6jdTeTaGt7sfwc1KTgZFcm	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1609	1333	313	6301	12463	jwR1MQaCayEN8uYqy1UL3nVvUHnsZeiqMWXbEf1M8LBJ5nF3ZjU	9170	12960	12960	1618272000000	orphaned
18196	3NKsHJ5Ke7uwxvzToG1odkisxQweFzFXHqs43iXYFRoNhb3Kv6HT	18184	3NKy9tGLU1P6wRotZZj8crJTQZLQ96pVX5w7WCd7TM1pPMnXgaW7	1483	1276	313	6301	12463	jxogxeu5bJ3mQo9EDdpFJ7kKqTNUssqmhFkzLrhnX6CaHgHGZxd	9170	12960	12960	1618272000000	orphaned
18199	3NKHDcWoCuP6CXqSKv5PZVRxQpKjszGtGqBpsEY62Chxje7KzEJc	18193	3NL4UGxZ2zKgcojxVVVnAw786Hthx3FkowUpQfnU3CsoYZsPiZJC	1553	776	313	6301	12463	jx7YnzptF6Hw4k5u9hamS7nM37HVahbW39r3xtanzn7xuhvvATu	9171	12962	12962	1618272360000	orphaned
18202	3NLFoZdk8wuNafPEzhRR53GTqz1mg4yBJ1AX5roNVffYBpPHxr4V	18187	3NLMuvpQLwCho5DjX4Bjdf6FoZnaZy6EqsZbqQS5yD9raMRFLfP1	1403	824	312	6301	12463	jwjM2R5ACGBHsWgziSsKN6iS7ALrb72RMDUHRgumbrP78rhsaX7	9171	12963	12963	1618272540000	orphaned
18370	3NKX9cTRKHECTzDKXCTrWczBZELeW4zUrfuDfe3eyfDeNErfHTkn	18250	3NLV8UgYZbHmQNn5QjWCs61dXDqXMmbqPsJ63ziYVRRDxRLCcqkU	1599	1041	313	6301	12463	jwkn381q5vLPUoATVdSnHFP1JXgwyA6i5oNK8W97YM24NSMNhWC	9186	13077	13077	1618293060000	orphaned
18241	3NL1NRmDkNYvhCHFmfGeXXJTuyPdGkXifui8CRAjqVJANGwYQLSX	18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	1668	1124	313	6301	12463	jwYLArydgTfyoKAFpTaJ46cZcBy9ntPKB6e2JNxsCW5D2bNW223	9188	12984	12984	1618276320000	orphaned
18243	3NLNtgAkDsJV8uFhP5PmNqaEaMo1KiNZH6avcyaKyeT2aL9pULqg	18239	3NKQTTLMaRzpANSUTtCjcxwp2493VSLp3i8Jst2ALCnuZ4ExyHUv	1483	84	313	6301	12463	jwnpHRRyULFD2jXaWDg5j6XVXTACMvKTqbKN5HrqboqYZUKcZZt	9188	12984	12984	1618276320000	orphaned
18570	3NKGLzrbUBVrJtuy4S7RejxBXdQMobUDRUJQHsaZBYg9U87LRa33	18263	3NKMeu9Aug4nQufE3bypig16cGhse7LCnN9uAsxyh3j3kpWNjwmh	1670	1036	314	6301	12463	jxHenFGRrWpjZCz3H67dypTrYcRZimmEp42qQf7PxdeoPDLepRF	9200	13208	13208	1618316640000	orphaned
18287	3NLSArtsVmSF3BX1XmLxMQNriQw5U8e1SXKbUoe4ZuErv8s52BJt	18283	3NLGd97xoXXDFWZt47KikDF2UeuM1UiSPwZJTXrsDGs3GFmeNezN	470	1063	314	6301	12463	jxJUknrXFw9b7Xvr9J2LJiLyqFDThWiJgQ5NyedZdoF4fFDhWMi	9214	13017	13017	1618282260000	orphaned
18299	3NKu9mcqi2ymtPqSXmMZrEP9rcbsKqUJEGaAfMv6SD9VYj5B2ZSx	18295	3NLDn58ED5xEWMVAno7UqqoQGR4whZKGfnMYYpTTK4WPorjCMKvj	1546	973	315	6301	12463	jw7vmFdTB4qbpff3vkEXXStGDseSxU8QhDXGkA2821XfKttTrE2	9219	13023	13023	1618283340000	orphaned
18323	3NLkSZVkcTGUcNXoVENPRxw1rArfZwjkEwUAB8nUBNjFvvsGVUer	18322	3NLSm9sBkJZSx3qiE54bkQFDVHYKXTZfX7iBsEVT7uFZCkgoUa3D	1577	1327	315	6301	12463	jxUJk15DhxFaKbXXT1J3bjnKabf5NNhMaXoDUoHsuStj3sUoRiH	9229	13038	13038	1618286040000	canonical
18327	3NKDMkvS9oBdoYv3wCK9NTpL1Nb4tVYDiPm4hb4YQfvzGFXJzqff	18324	3NKsyzrZd1F4KYzaM9r1XBdVvzLQE6mmQGc6J71qby7Fro3gpTq9	1578	1296	315	6301	12463	jxvZZJQ4iLgMV6jwcCkjEfYeB7av3a2xHyjHUgYapKaW95xvdfM	9231	13040	13040	1618286400000	orphaned
18331	3NLQPj2bopMTr7dRWBoqDpXQtmbj1pWUoiL4CPnhuB2YgX6e15wa	18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	1534	1317	315	6301	12463	jxQj7ghG1ceoRXXBgpg61P99rEKWSN7rQHPvbfC2Kmzy5YSiHLZ	9233	13044	13044	1618287120000	canonical
18574	3NKBe7mxANRjsV6s4yEJBJV7BdK6iXEQiJKDf2L2ZSqGw9kcNGcE	18329	3NKwqbKsgAjgA18NQx37dR9fzp1cNVRJPwvCdoJHN1iPnpCt7gW9	1670	1036	315	6301	12463	jwJTnh1yUPUY1LkxTLwV9GtTy7LrsqpWXvKwTJfDEk4jLP79KdS	9233	13208	13208	1618316715041	orphaned
18349	3NLMCaJV12eJ77krUrnBxbSAxjBerKjNTVyHVfr9bx82qXyz5rgk	18345	3NKmDKgWu63GsC72JT1zFCN7pDcpTAuXZwsAdmYRiDZXrfLJK6p4	1523	1195	316	6301	12463	jwAEyR6JYxBsrXzzh24taKcT99N4pwHorKRSMDC4nJokCYtGWoE	9244	13060	13060	1618290000000	orphaned
18360	3NLaCnX6JJP3rXy7BFYf5YoLor494kz4SqYaEg4FiKahCvxDZEkc	18358	3NKcy7r1LwsDzjRSqvbKQMFayJVfhrbMboWvMHGf7zW5cYVH7V7D	1587	1357	316	6301	12463	jwD78t4DM5HzBh5P16utrC4j7vPPWtoSGtGjpCWDXZFSAbdgM7y	9253	13071	13071	1618291980000	orphaned
18453	3NKBMUWfUopZuGVdi1odTBXQhuSMwXZyEU4wgvemNsftFJcoz9zK	18382	3NKmC4dRzo2y6vr1ukqbfHCx2YZzpdwm6oMxbcsFPCrRid9xU5jf	684	1106	316	6301	12463	jwyBhhxEcZ8iU6JRYeNjo8qLnmH665Xc6ZLXJeJpLhVRy7bx1QX	9265	13129	13129	1618302420000	orphaned
18392	3NLXNS4gy5FB9rwkpkjqXQzoqVDn3Vv8251Jx1XqRdo7ACWxgpdh	18388	3NLyWzE87UPWohsNjFwhfh8vd6uooy3mjxwSXK9nkF5zmi2TSWBC	1573	1072	317	6301	12463	jwzs5aB88Kfmu7MbfdgKVQ9YZFuJivbXRt67rbsDmDhMZQDg6xB	9269	13092	13092	1618295760000	orphaned
18673	3NL78VBhT7TUVYY9agFQ46CQBKNjnJAVa1vtjoZ4TRhpV7A8AZvn	18400	3NLkNBJKG2GW4NrsG2aVW63GqKKNMRjTzhTiK9KTBWB8wepmZngo	1506	1373	317	6301	12463	jxqVBhL2Fpj2JVa4D9RNcpTN8JMByzMJpg3shxnWy4naFKJdEJK	9276	13279	13279	1618329420000	orphaned
18422	3NKZMsXD6yPyiXd544Zmjtw5xP6QdrGQQz2RH2hMagkj119e48iW	18404	3NLD2bNF4xSuKouA56ARakUnPPrYT8XUmZogBXRgWYKftLr24LsG	1529	1316	317	6301	12463	jxJAeMcVVBZv87qdJQLN72dQCmhNGfuziA9ioa7dYcKteMDur4g	9278	13114	13114	1618299720000	orphaned
18416	3NLvqjsCQQpCk51DPM6omDzVBbje41riyztaZ6zxjV27gLy2EJMF	18413	3NKMYcquW2MENrzeynykPWCaT72yQY4VB6KQ9jU3HMebHuB5TDny	606	1049	317	6301	12463	jwPTr8fiWYT8kZgPiskaY5S9zb4sNvmpYK9uT7KnxhYkztqeFHM	9284	13111	13111	1618299180000	orphaned
18420	3NLUsHDuxyopLoEutN4VuXrqByuoMHPWfpMWXwgD4A16YWjxTpxh	18417	3NL1mXfsiCey3Vh78rxQGA8aR2LY6Yx61czKtRC2eH4hayDCoXr2	1675	976	317	6301	12463	jwsHnzUaXey5ZKdsqVA3fftXrZmWm2KniVkQqbKqnkfEiFrgovu	9286	13113	13113	1618299540000	canonical
18902	3NLbwQN4WC5wfHTQB3oZnwCCu5p9YRyeWLVECHZgSv6yjTJPsScQ	18420	3NLUsHDuxyopLoEutN4VuXrqByuoMHPWfpMWXwgD4A16YWjxTpxh	1603	444	317	6301	12463	jxGYiEdm9Kztw7TA7KMJmNxcejt168RVUxA8HZZWknqyDQqfyAq	9287	13457	13457	1618361460000	orphaned
18440	3NLmYjR4q9jC8sGrSft12R2zFoSSZuTnLBpg2HxvzjkQew6PdUiY	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1476	1125	318	6301	12463	jxLvvFAAL8P35rE86r4n6N3ezkHGu93U4rdkmzcfYPznZnzYmPk	9294	13122	13122	1618301160000	orphaned
18437	3NK7ALvK5Ue9bNkwBJRFM2ZM2gvRLXxZCsCA6C51ZVuQEPvDzf3q	18434	3NKwJHAGo6N8cZjuB4hSfxzwF1ibtHSi4dN37cR81HJvGytFKzfH	1407	1395	318	6301	12463	jxYqPo9rHRAzUbdAtTkPqPEYW1ZGjfW2JZhQTr4bijyjsnY2YBj	9294	13122	13122	1618301160000	orphaned
18460	3NKDksLa3uEp19uokvmrPBSya9pbUtePYvwRbHwRLLyEwZ6JHNVd	18454	3NK5kJiHwqWTsnA5f2SfDGhPHvBY87oGwZiQpptfs7Zrtz1EA583	1541	1172	318	6301	12463	jxU6GMPcUX6GNMV1j54WZn4H3NiFAYvwbeAHfnmoURXG8sQJF1N	9302	13131	13131	1618302780000	orphaned
18463	3NLaeDeRGpb8ZwSLgjnmky5LLuy9u3pjTAE2Xf3GgjCxEhk7S9oH	18462	3NKtN4ReZAXR6Yo86f4EKiy1iWSgm1xzcJHe6mpFACrC7soXHyfR	1458	1323	318	6301	12463	jxCperN1xaHmXLHXYfN6nCX556KHc8XSmNRVebtiAoLFUwgi8jR	9304	13133	13133	1618303140000	orphaned
18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	18469	3NKghdPX2FKj2pfumxD1XdDnmKR6HkA9zrmkpnhTB23aMvYkooaF	1508	1261	318	6301	12463	jxRVQHK8HxQLTQB1FCLABXeBMj6SpJsupAwM7oqmxnogxBZJVkR	9307	13139	13139	1618304220000	canonical
18475	3NLSR3phdbQAB5y9rkcuy3uimvDPxi1ZpTuKktWytXmV8pqYJz33	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	1527	1293	318	6301	12463	jxvQGE3zpgntz5M2dwR8L3qYcbBoGUsrf9WKA5STfoFRYkpHGKK	9308	13141	13141	1618304580000	orphaned
18478	3NKh9f2KKbgAgk5rDpkZ7L3rrWroikFLdotfSFN2BfM9ZGBBBUPb	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	1649	1383	318	6301	12463	jxKck7X9s49yMiecGLcq9ULeNFe8ZU2Hw5FFncvAepxFJkxMxCp	9308	13141	13141	1618304580000	orphaned
18482	3NLHMNFLXnmBD8N1ZmCbrdNkY6Dta3GYgpet87zubgdoctxKYkr6	18472	3NKQc1kw3Y11rt6ZPhXjNthB8WQShc7QLe7qGAkv9xL4AqmbsFQD	532	937	318	6301	12463	jwJgQTyeekhd7maFdDhnYnTgonc5PyejJwrXV2B63pB2dWBi3BV	9308	13141	13141	1618304580000	orphaned
18481	3NKVCBmVXVs2mSvMQJKaMBfKuWCKSLqxHddz1QpodEfSi2p229uN	18473	3NKp5KgWfGuGf1NvTgwuTU6CyUFLkT2ToPdUtWck8NUbwgvrRDhF	532	937	318	6301	12463	jwd89BBuhAnuhDikrhdmkrVadEcWaSUeeetwBuJKjj5m9kyRsdD	9308	13141	13141	1618304580000	orphaned
18522	3NLu3Rf2sN6nM2gVz3VxiMTBhyHT9oV6ZRvJ9eaYbgx3HFRgmoQe	18521	3NKrFrpdcbXiXpSztLgB7rXD1fN7k38YQkW9X5FkuepWNuEQqX8j	1507	914	320	6301	12463	jwtcWdqSjBhMh35X51B3EHA22n14jme9NedVAv183WgnqV5i5v1	9329	13169	13169	1618309620000	canonical
18544	3NKBXZirHDgpK78YGkL43tnL9edMzQfF1sm5CkZEovAYJwb6e9UD	18543	3NLiTD4H3DMNW8FBoZw2Fa1LKhQDqS7ibHbpsVpP4h5hjKZGrALm	1406	1393	320	6301	12463	jx3vmty1sfSTPHfKoyEphqGcKJLSwhdKFQtc61Gx3NbPD54KZFb	9344	13187	13187	1618312860000	orphaned
18561	3NKwB6vyUCBff7jb4FQHDNas49DbWyCq8NVE2jg8VnpPTaVzqDoo	18560	3NLPbXoWpya7wZTEbzGup6Z6erBRcW9Aqa51q6ZXF3HgA2Dg76PS	1406	1393	321	6301	12463	jwLc49rHWtCvq936G2NBnU96xr7yNCxd1cfECabHs348Wx8bMhi	9354	13202	13202	1618315560000	canonical
18566	3NLGR3pNU9vZXLRXpsG4a5yuvGfsLVrVUW6WEHDR3Rbe6Ti5We9B	18562	3NKoGyCnvXa72jexyhvi39SCubCJX2V2EvE3xZTz573MKHc9t6KV	1405	887	321	6301	12463	jwraEknktAKNx8KsvfkefHQr9mRMGJCDTVw237ajPTvkpDbfNQW	9356	13205	13205	1618316100000	orphaned
18594	3NK3BYTGmyhz5s36jBcXzEFbxhu6DbnNnrsVJZTnhyoj5sR9cGee	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1471	1140	321	6301	12463	jxu8zi9iTr9x7a1d4LH1hnkCaunV29JG5N4N4V2Bxggk8K8Jz29	9370	13225	13225	1618319700000	orphaned
18596	3NLbGfWijB4yXuuXcxUZ6tyXzDHnRudEr7xK37qWEp1rqmoAs7C2	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	448	1059	321	6301	12463	jxfT6ZzmSi23WGGTJGow4VFKGqXjJsmGvfikGvkuuoab5Wrdnq2	9370	13225	13225	1618319700000	orphaned
18592	3NLwT7ZeNJeMtgCDMGxUZNnJreLaMcB1owpvz5aJ6GgX86VGHSVm	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	1622	1356	321	6301	12463	jwxHeZFfPGzcL6tNmvEKQPvNzs2s4w8UR6KfMT7oiKkpWoW69Fq	9370	13225	13225	1618319700000	orphaned
18597	3NKkzozh9CPdmgP9HdSjPVUdFKnEAvaZ85tise5ksBRopz9kSQqG	18591	3NKS5A1hNXWU6Wz84SBxDLHbFxMZmjwqHb6tfgBCb99j6x9ZBUu3	448	1059	321	6301	12463	jxfT6ZzmSi23WGGTJGow4VFKGqXjJsmGvfikGvkuuoab5Wrdnq2	9370	13225	13225	1618319700000	orphaned
18602	3NKKU9ygEAL458egN3K8wed3Sm61L7Utz4biLYzQvzMwcpSu8WrW	18601	3NKws9cfr4rdHnnEBAoToRr1FGMd24WXjL7ZerLBRXMDyWmPbfUz	311	1181	322	6301	12463	jw9CYfurwWFjj9rZRcPHo5xS6CGpA57E4aabnoGbCLScqMfKCBT	9372	13227	13227	1618320060000	canonical
18608	3NLXJf6xpPTZ7Z2R9ayPDw5ZVdPKVHtzyZzaFW4i9hk4rMZDYRMU	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1507	1280	322	6301	12463	jw7mU29CNey8iowwQBXNN7EFVrnuEySGtuCfXCfnGPL6ZJjWGtS	9376	13231	13231	1618320780000	orphaned
18609	3NLLiLbfRwrXSrzixLnkqVhVN4ShRrZycVeXgz3dQZgoX4yaGDHD	18606	3NKFC9zAvfFa6AzenkbRaza1hLUFjrH5hbfFbfmDCkiFxbkkmh5p	1553	776	322	6301	12463	jxk5BSy2MWVHNHzJpNaAfmWBBckeC57wCee6Zn2qSpDovARsdvU	9376	13231	13231	1618320780000	orphaned
18663	3NLVkj7WB2SmmfDuLyTu7eZuVBjxdCnXtixVstD4YGcvMVt8BiuX	18613	3NKTDV3nLQyDRdsP6PDfbBWxLLHhCnbuasoNK12VfFfDYiAunT7X	1631	794	322	6301	12463	jxC9AhRomiVF9Gvjj9r2t5keLzHZNLAfLvdJE5SJM364PWeDdZ2	9379	13276	13276	1618328880000	orphaned
18624	3NKThLA9FeFeVQCTSx6NLG1BFUGBE9NGneQ5huz32sXm1qxWdoWk	18622	3NKh1Yzp71CF64phcQ7HkQZhRRbb3iXXkHDCwWjux5TeekTQjbW1	1476	1371	322	6301	12463	jwuh4qaqefDZwsdQ5r1EMBc6xv2CiaWBygM3Gn9kPfPJgLXCR6G	9384	13245	13245	1618323300000	canonical
18645	3NLLAdjTQiBTrYrkufw8xEkrWhibw3Y35hFgtPuaaC91XyxpkB5L	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1474	1329	323	6301	12463	jxUBGDmvkWMjWtetXK2EVPD4ZpXCh3m965yUAqkzh4DkTAisTuZ	9395	13264	13264	1618326720000	canonical
18644	3NKqLyAXPrmK65DzQdCrpaNHfFZ9ycDScV43Dnt1pg4Rm6f78ZAj	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1501	1360	323	6301	12463	jxvaQbmuBu1eZHN8S69MoMWGwiWKMwf23UCQqLzkkQE42uGBPsQ	9395	13264	13264	1618326720000	orphaned
18646	3NL2qUvRJtghqjt37WnNBy7zrVBUcJ4PFsjGyiRSqsoANahNX7AK	18640	3NLRJmWibx7qLYiYYEJjp1gNLVdLjj6CMPHPec2UWhbw7rwePYjA	1474	1329	323	6301	12463	jxRUupvDQtfKQJPYTkAgd7QtEofbKiopXMYR3ohAwq1KrPY5FQs	9395	13264	13264	1618326720000	orphaned
18651	3NLC1TE3iKM4xocgNxpUgkLB8bSkzk23CZsFpNPqre7nko6EUyTS	18650	3NLfzSxvjFGcKcrZ6SprdqEEvmvSSgNd35wh6qzVDooX5g7wpgmt	1406	1393	323	6301	12463	jxWNCE89qAG8vMc6BkGaZhk9pRjYhjTrjfpNLErJ4rA7AkYoU3m	9398	13268	13268	1618327440000	canonical
18658	3NKwstKCGeh2uQQApZSDmvKDvybZUBy4ePtCRsnCKaVWYn8zZig4	18653	3NLTZCDo5bR41AdK3Ui1UWSXH6N3u31qvrFqEjEcoaxmSo1Q21YL	1573	1192	323	6301	12463	jwST8BFFEjeHWxMLmbCi3ivS3UrHCg7nKVbtcR9DjRJvN91wztK	9401	13273	13273	1618328340000	orphaned
18669	3NKkePwAYSAdAe3gsTmRz1xoQAaNcZ163q1w8WtLzDg2q5Dc9u95	18660	3NLb9qTmQRehSkjx7YrvCGXD48sMUXETnh688WRhRJ9saBXJVNcQ	1547	1012	323	6301	12463	jxGV5miHSHDoN4bQCCB6sF6aHjVMbvby3u2Y76snfjBThT4MC9S	9403	13278	13278	1618329264374	orphaned
18819	3NKyvtpUkHcDYDqkUSrUhUvTui1nJAfUnMcgjeoQV8uc44N2pJEh	18748	3NL222n1K5s68n46TCiC9GHcgEgff8WwsMoskKkHZtH71sFBZFHg	1649	1137	324	6301	12463	jxYVx27FYL31Ghm3MKQNxryJj6wcZbHqqQEfW5XbK2Nbtnk4DuK	9438	13392	13392	1618349760000	orphaned
19019	3NKg8KmFqoL5JhTiZ82r5ybqNbkPGeUi9Pwi2qdiKuJpys8b6A9v	18819	3NKyvtpUkHcDYDqkUSrUhUvTui1nJAfUnMcgjeoQV8uc44N2pJEh	1649	1383	324	6301	12463	jwz6m94tyoEW9Rv6qfRpLRJ9tBzJ5o9bEPvrhFDEnwELSeQiaUC	9439	13524	13524	1618373520000	orphaned
18749	3NKWNjWdt7W4SEQ2uMygocSZddkYDFsfRnw2Yx1oC2dKJm4d3HGS	18747	3NLLwA3Yt9oKq5MHpSkZHypFWht76PsQbYmrUTKvVxq1QRMXmLJb	1407	1395	325	6301	12463	jwdnYDERXipsMUv2L7LyKoShJ1LKkte5oRfgzV7zTkxi6RHodAk	9449	13342	13342	1618340760000	canonical
18758	3NKthpQMa8DXjv6bEqGcXnKFcLc1EDkPpA4BYgp874jfxJTyiSfv	18756	3NKAJ8MYXfSGNSzyWJ6b8hPUEwWgzmPLLjBJQfPL23gTDQouTzsE	1407	1395	325	6301	12463	jwxKxtJ6zrnfw8tn7LMakZnQMVbKwFHdYiCiTc4KBbgdzb1eoUb	9455	13349	13349	1618342020000	canonical
18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	18758	3NKthpQMa8DXjv6bEqGcXnKFcLc1EDkPpA4BYgp874jfxJTyiSfv	1541	932	325	6301	12463	jwcWwcx2Vqz7VHEtS6TgG3CEhagxegfu7watP3tyQduVu45Q5hC	9456	13350	13350	1618342200000	canonical
18762	3NKREpB6hMSSKvGN3KXC3nTLKKEDW8BHFou6mW8NtvCvA3Eodjqg	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1406	1393	325	6301	12463	jwBEJT5ScN7koCHD8CrMt4zSsjGEXthmbYchniFLM2K6kN938Cz	9457	13351	13351	1618342380000	orphaned
18764	3NLoLmCoeBXJ6WdB5bkLFCGARWCagceDNwATibe22PZUh3q2tW6u	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1407	1395	325	6301	12463	jxsgYs8DacXdHdvr1YrwNVG9wBETkKUVyvNvCp7MZZxJmP5zvwu	9457	13351	13351	1618342380000	orphaned
18763	3NK97a4PR9ZpjNGdHnYTnv9Agm2iPGXGisP4RFtbsbBsbdjDGtUt	18759	3NKX8U8s2gGt5uE3U5pYatsibvDtS9VK74FnNpYNy1UwyMix1oF4	1461	1271	325	6301	12463	jwqSjE4AruVMzoRbB1tgUQtYgEUxHHD7CFwD2YuNq9tYuuNdFrA	9457	13351	13351	1618342380000	orphaned
18766	3NLBkhmWmpDHMvXhPBYqTQFkjLd5UKNcbgyHKoKYAtmpWjhM1ULX	18765	3NLkAvHLBVQZ2LhUK2sX2dgu279VP8ExPGgEJCvPkbSAB3fq1uT6	1403	824	325	6301	12463	jx5ae8ovfPkPajh3KaNcGkurixoQom9zB34K4htSMTJpXyMRKbo	9458	13352	13352	1618342560000	canonical
18775	3NLNsTgjvEW8t676DKrotmZc5diYBcHjbDi2aWzMGGekcypdUBaL	18772	3NKNYeXpVLg6VM2WtsaCNQQFgKnyYcHY2jfosT44bpLH6aqkTS8K	1402	810	325	6301	12463	jwmmznJ7C88VGNLLr8QopbRJfvKmH85ApeMkNkN86QpxdExVMnF	9461	13355	13355	1618343100000	orphaned
18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	18774	3NLARSkfTYQheJob8n68zxfgFW3yX4z92MhwMBPvMMxaXjoAicLE	1647	846	325	6301	12463	jxxYEKrNK9xTBesNUECJ8uEu8JHTkVFY33vjKFvxZTZZsG7G3a4	9462	13359	13359	1618343820000	canonical
18779	3NKt4jF6TUdsvvxpvzdjvSDCo9FsVt9cTF2hMP72WChY3aGm3WRw	18776	3NKyLXMCcdCxxWqf9NZ2ttYi39QxHpU6FRfYWwQtBQdM88hJhNRr	1403	824	326	6301	12463	jxmx7daGJy3djx3enUaPuc1Js3ybx8fQaECNTAYRvfZDief35oV	9463	13360	13360	1618344000000	orphaned
19200	3NKP7ErPWjB1j2CeJdypoZackT9B2X4HJR1eT5T5fsyUYN2tJP9E	18796	3NLBk5EFtjCx1K8YxATE2d5V7jDcwP5cSRz35ERGTzxYCbZjPzk4	369	1066	326	6301	12463	jxwwbHhy59TTCokcP1V3QG4DBkUssUj1Fw4fHSUxuvNCimd1673	9473	13666	13666	1618399080000	orphaned
18811	3NKPwT4SBtAuShBuK17oxtxuGkPHRiyUvFRVmUc76wjzqxmUqBdZ	18807	3NKrtgKVgqpykQD5LnsMvh1FW5cMhV5cjzwQVn5ysDnrGUvhfm4X	1651	1175	326	6301	12463	jwEBoVJXhz7219f8TGFeKJHZpTRRjmLEo9Atm1eNXFCbmPEmgWS	9479	13385	13385	1618348500000	orphaned
18818	3NLhRAZqPBznTiHE96dMCC1sbwpozArjALd65phzHqbmvz6X5i2f	18817	3NKWonhXDJYg8Htr7KgMtSgMhdy4ef83dh69UVERTpzJT3iLGgYb	1601	1022	326	6301	12463	jxQinPsEVz8jozUqSwiynpdsjkZEr7dHVGTo5oGeUJJ5WbGv44B	9483	13391	13391	1618349580000	canonical
18850	3NKMSecF3Be7VefLyqBGoaxHFzVA8RbBCQBWntJbhFcr877hc8em	18849	3NLDF4j1aRvdsPeNFZvrGwikxYpEQKYDvNxL9E4QNyDUPppT7DFL	1509	1074	327	6301	12463	jxtrDCpTcXGVtAmsN7VG9xZEn5Fb3gvDN1MDYeXK4is4eq5vHyL	9505	13418	13418	1618354440000	orphaned
18908	3NKRukMvCgmMCt7EX21K4Z8n8wSxoXYLjWW1TCTy3bmuG7Cd2t4j	18857	3NLcgoEsqEQfWPmcwMrFU86jXL3WrU5zYeTbQFvhx65EGX7v9C5Q	1581	778	327	6301	12463	jwPzAAcrc4C3AX2RMB4z5C5CyppBhfXc2BxUE6MYjMtjJHMrLA7	9509	13462	13462	1618362360000	orphaned
18875	3NLh6qRnhW1VJJq8QayVXjDAA971HR9Uqjp95P7VER5faicU3d8H	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1445	1290	327	6301	12463	jx2s4B4vEu4i1kqsjGU1HKCFRfSigupHxCBtoWBvThg22RsRkG3	9518	13436	13436	1618357680000	orphaned
18874	3NKcA3NHCcWK4hsgVN7KFVH3pkCRwsTbUbbevA3SvQHUNCCTsRK8	18872	3NKLL9pq3hBPWnitEf2Qgb2KEvBWQ7bNQnwJ7hVfUYCaikiHnPtK	1560	1045	327	6301	12463	jx34XQVdUSsNC1Cu4KukgCnSqdLeW5Jiyu6xxDoJsk56JQRNbvR	9518	13436	13436	1618357680000	orphaned
18893	3NKumUJ7yXtP4xuJXoXuPxBN2Fvhpi4mSGw5JQWq9oB9F1qvxA6u	18890	3NL6LtYSfN2Kdnx8y56235s3DptLWqaEyQLLEc6bwQbxfCmfkCYS	470	1063	328	6301	12463	jxhWtcr2hiubFiGVb5Urra1Ev4WnKc2piygi2wmYEzWJUT5k1qD	9530	13451	13451	1618360380000	orphaned
18911	3NKadQbzUZhitND9Z7pjvWawoxZRZypE5PZN2Nx2S85baDNwsEZm	18910	3NLSuaZPU4hVeaGwycmqX9jcpgb8Bdrw495Aj8oe8kmst7Tiax7J	1547	1012	328	6301	12463	jwG6yPMFiYmnStfxajobBuLqN4KSTpintiWGmw71QTWtUWY7YSU	9539	13464	13464	1618362720000	canonical
18916	3NL1dcwGG9oDs3d4AxpHu7k8t9H6XwhazAs7ogtyA4oK4qT1JgoB	18912	3NKckog8ZgVRgyuJJhS43aXZuQQWPJtMsgEXFnVCiB9tV4TgswCK	1407	1395	328	6301	12463	jxPb5FDzfKTZgNNADKYRRsfGmKULopMRrrGsfZgy4r6vDYBphH7	9541	13467	13467	1618363260000	orphaned
18917	3NKwcPF9YG3r1bcEXxvTa1U6Q7c17BDsz7xf4Hkts1Ad97QQ6fS3	18915	3NKCBT87G4cMDot4vxttSgRKDwbFYHVAxC2sr9fpiQYtQoCRxz5J	1407	1395	328	6301	12463	jws6DRCRk3SJ2UsespZ2QzEiJaDnoAgQkLUrxWSWcBfzZMricGC	9542	13468	13468	1618363440000	canonical
19121	3NLAebd1kg4K6RTbb8nZaCvmNhpVR7AVoqKkcT3tmAUWdGogLTfS	18929	3NLrLjY9P4pXnHvQhLxB84uoTkLUpBAwtcgS5dqzaUrwuXBTUx4v	311	1307	328	6301	12463	jxsjHBoQoKSPZpcTxd8fhTwKQSNAf599BMDag4oHuBCe516dFmG	9549	13609	13609	1618388820000	orphaned
18933	3NL3ViziXE51RoGwrPE3p6phH29kPHsDWAs7M8oohAM8fAesW8vj	18930	3NKvURVctYTAKFRM4oTe61EXUVxYT37d2GNnwthKsbKAMbzWVQKz	1474	1083	328	6301	12463	jxDKmY9SUeiwmzgqg4SxZ7474RncnHGARsqZwgrMCfyT4FunVjw	9550	13477	13477	1618365060000	orphaned
19419	3NLYFoUuEEsjTqrUFgfhjbSRPyzwtzhY87vVc4JpbFfddN1Vwnvo	19121	3NLAebd1kg4K6RTbb8nZaCvmNhpVR7AVoqKkcT3tmAUWdGogLTfS	311	1061	328	6301	12463	jxpGTxuSoGLh1UKVdwXktshZ96jHM3xE9tK3fW8vgeLu8mBEnRA	9550	13815	13815	1618425900000	orphaned
18951	3NLJizXxfw4vA8MxeGmVG7GWC8QHnFeNbKMCBE2sDZ471xgNYUG3	18948	3NKAv4tmJgRDNDep3iYNmQGZgUHSZkeDi9mEgt335C715E81oFWW	1602	1243	329	6301	12463	jwk8dFpoCNY3vG6U7kHqmVQqKDnEz6nc2JSGiE5B4841yJRUHwd	9559	13489	13489	1618367220000	orphaned
19005	3NLURHkmSMc7sLFJL7pE23ix16cNzuHPqZgZcyY2vD7xZwjwYvDx	18964	3NKRfRrgkbdFYwHFmT8nTWSviDHEAw2ccnzstkNz3499y2Vzrvzd	1587	1357	329	6301	12463	jwPSCt8Visv6xcWdxcMs81LbwM831iQXHtmAqswj4jxC7iTdrTd	9566	13517	13517	1618372260000	orphaned
18969	3NL8EXD9zgUdGFPtvjudxCSWJGn6rX64jowqqPU2xi1ikpjfN7HH	18965	3NLD8buriHnjrVCrqQJgYnP3tXVzq5zGRqKctVtL7PNrN392oiNj	1633	1024	329	6301	12463	jwSPcHqaEbvCj8kom9oz6ZrFKVAdMLwD8foBmnSE5CfvDLpFKpL	9567	13497	13497	1618368660000	orphaned
18976	3NKCotUvL91NKCf1yR3A2HyYy6fX4mVwsYANk9bS65Duy3armMDM	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1481	790	329	6301	12463	jwANMvNX22rYFLDYn8qXPChCAjARnB8XpvmhAvAJzcwsYRAckwi	9570	13501	13501	1618369380000	orphaned
18974	3NLXARGoCxTJWBKYUbfZSnRH1KrHLgEJjArgXvzVHi8RWa7FFqgV	18971	3NKgxPr9nyzRHbuKZftxxx8RXNy7e7xen8hicF7DZcinbXwuTVpA	1523	1195	329	6301	12463	jxqFqDD3F1hTPf5vjBi1vcr8EKm4hEc13dC4Y74tP3nLfK8W7iA	9570	13501	13501	1618369380000	orphaned
19002	3NL6yBHa1gHapK4iSc7T1BTXD19Gicg8imNERfa88fvK2Lb69wsU	19001	3NK5tHwsZ9gBUYkFMS2obEKYXGdMsRgQXv1TRSn1kJpKFmCxFZe9	1527	1293	329	6301	12463	jwp19pf9rRe1WkGnUromJBd23WCgWNqCkZR4GBc1ahW4xBxa3c3	9582	13516	13516	1618372080000	orphaned
19020	3NLcgHnhq4rquKbYSHeWBywws6DDAYBf8hda6hyVxbEPL4n2w5AA	19018	3NL3CrMRHqxhi5T1ffoxw4vQuLAoWBG6o9fYWLerTjZdJnerGVkE	1649	1383	329	6301	12463	jxsdo3zY4bzamt9EjXnzCPKSsHSdwQyCY27EXJB91aStWybFqL3	9589	13524	13524	1618373520000	orphaned
19438	3NLJH5vwPNhZUwdEJFmx7xMgAvhq3M8kDrtaPqCR1K4f6KuuzMNL	19256	3NLm3oNU4VMu6xrmi5958tb3dmeBimKTT2saKMjDGTQ1nMGKTLvS	1461	1271	330	6301	12463	jwzn6CYrBg9r5ACdFFLGqAgJkow7dCJ6VxFuVHDzR4nBsbsJ1tB	9605	13831	13831	1618428780000	orphaned
19047	3NLvQGKSpw7tao4d9AVoJtnatnUsxERWzkVbCetfd1PdUrtHkMjg	19044	3NLHjLZb4wQ2Wz1PW6jBznXM2nvEciwgpYjHUWhishw4kWPg2yaN	1523	1321	330	6301	12463	jwnfahhzNupKL9F2bYSN7JT248z4GYS88Thuq5neZ1ebuZadwVg	9606	13550	13550	1618378200000	canonical
19048	3NLk4Qj1drLMgErbYgJnzxowyy795NoiUBHNw56eUjd1s1mUpoCV	19047	3NLvQGKSpw7tao4d9AVoJtnatnUsxERWzkVbCetfd1PdUrtHkMjg	1407	1395	330	6301	12463	jwoa9WxibFDYt8vC2kNg9c9EXMibSPCTJG51JfXFoSQynUFUYfw	9607	13551	13551	1618378380000	canonical
19052	3NKZyNNDzCBtNgpTSAfGq5vUkVpCUMJKGEefR41ofCYypYJ7fu4y	19051	3NKKYcVb6gtcuM8U8vUPyKUAsN21CEFkfHyGxExvY6DZ321UAZX6	1406	1393	330	6301	12463	jxD5sk1FsKUiE7FDQu78YxszpykxTBgTRpw8Kfpv2134rBWcHD2	9610	13558	13558	1618379640000	orphaned
19057	3NKBjaZ4CeS9UESeuHYWYPNHVS193oQJB9xnuhWs886hzaPnic6T	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1523	1321	330	6301	12463	jwirNSLQvewt8a6DgtpayyhwBdSCajmdeQh2xRusKvDkL9g7A3b	9612	13564	13564	1618380720000	orphaned
19060	3NLweScyeipRcjT9om6T8yVk7EEx4pHaARF1LLu7kkVWQQ9m4ojQ	19054	3NLNq6drCh1e5FkYseDZZ7N4gL8t1AEuiz7UZ34hvr8VNQGqJqdp	1623	839	330	6301	12463	jwRBSPhcj1nh99qRrysvhQKM7WGcaV3gbHDRuzUkFG7uZSLxHkJ	9612	13564	13564	1618380720000	orphaned
19074	3NKmpxCEvykKjgAqFEXz7Jv93AVTCXA3rxrHxLkJhsSESnKovgdW	19070	3NKNLw9J9JPHoRaga7S1U1A9Gfun3zaPfHfrMA47JsWpDUWjtuNT	1527	1293	331	6301	12463	jx9GvTHpFixc2jii6wea9UFDSY7yXComX5WDXvZx4hse49r7VWM	9619	13571	13571	1618381980000	orphaned
19408	3NL5p88e1bUwgkjHebpyw24AeKVtETkopdstCLYyVWYp8CLpEgDu	19083	3NLrU2kmVtEr5HH7j8BL7RTZPVn68xZV4r49eJNWjZEkwzBr1ch8	1534	1191	331	6301	12463	jxwcDux3HJNuxLpFECRdCcm2a41KWpF6qMfYMGp82umH8cyyQLE	9627	13806	13806	1618424280000	orphaned
19088	3NKoZ1DszYqbsp7WKiWEJvAzALJ8w5Q71oK1XoiNwCsXBzebCD1T	19085	3NLfwkCS5zTsGbqE85f9HQhprmqsKjJeRCd7vsKorR8HEZyFtcMU	1402	858	331	6301	12463	jxp9nAVZrkCZcSM8QE8yNv3kFG9kDBAZJQdrd63KZfFjTEZjs8A	9628	13583	13583	1618384140000	canonical
19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	19091	3NLDMENKGT82Q9nB5Ue1hiZm8N7d5SVYBTCS4HvK7pc8GoF6iBrA	1619	909	331	6301	12463	jwLmkxbEC12mHX93ufRR6tGDTKQ8JckSh6YVNy2poN1TZHA1oTL	9631	13589	13589	1618385220000	canonical
19097	3NLk1jnhx1f6bUYxgRcS3seRLAFHonL6r21ihijv3MHXEw9ZLk26	19093	3NLVpZQZRShN1ac4zPv4S8ypGh7Fy9GjcqwhpdkUDSCp1baoAPbX	1578	1050	331	6301	12463	jxpHxPhCg6Ziuaru9kTeVVow64gyMb8zRfMuQ3pwvNKdfdd6nni	9632	13590	13590	1618385400000	orphaned
19102	3NKDn7ym7CHCD96EERqUk14w9oQNDmvDp6ymZ7nEgaEPjQiqBbun	19099	3NKwnDjEURcF3k5EL2daYNiRiTo4e7JgTSypreVihjzVvrtBa7nP	1406	1393	331	6301	12463	jwfK2crzA89jd3SNafz8iucZdJbsnpp4LFX3jaNGdnvCLsAdHBz	9634	13593	13593	1618385940000	canonical
19127	3NKCDrvgnPKCKRnXVMLg5zpfSKghtJixqtUeckpzx5rvgzDBE5Gn	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1474	1329	332	6301	12463	jwxtBY8jjVXFpzaiyaxosYv4et74osmM1KQzx5UsGR8C29mV59P	9648	13611	13611	1618389180000	orphaned
19128	3NLWmzrShXY1SJnjrhfmJXJtkxRQeEC1dwfPhxS22ak6Gv2BqgpZ	19124	3NKXUbTmpAfDY6B6KfM1HhgFrk8zNQvXfFSAnxF39gnVfdhHVP4G	1590	1054	332	6301	12463	jwrpgBLKVuwFsXzXJ47jDdoBwJ4Lvb3gXip8KYS9HjJFo2mRu96	9648	13611	13611	1618389180000	orphaned
19321	3NK8d6ujQjLZ4yvoQL6cAWqDDGB4jHyWLcY1zFMpo9zcND8wgWhz	19137	3NKtcLx2NJ5p64WNgJwZnZiq77GLwwLTebxAvDWer4zAvcfXtCCp	641	1336	332	6301	12463	jxMFqf2qxxpBaJU1GfZdpzXLvWeaMCiDc2szYC4dL3K7wVDUL35	9655	13751	13751	1618414380000	orphaned
19143	3NKMqXgNkKQP5s5PZBpjBgG3qUe8KZ9gYocqywg3Pfonz3ZVfgst	19140	3NKMD8hcR3qDs1AG8v54EkX9TMAsBUkFEp5bdvxzdXv7rzqRkbeq	298	1182	332	6301	12463	jwS7cE1Na1NVE35YLbjNKpNAMjPAxJBVJLA5Uo7BUfdznouQCjs	9656	13624	13624	1618391520000	orphaned
19349	3NKc4Z54nPipK9AXKvYM9mrGSV2Q7rd45drMu7rkrrswLvvo2RP9	19321	3NK8d6ujQjLZ4yvoQL6cAWqDDGB4jHyWLcY1zFMpo9zcND8wgWhz	641	970	332	6301	12463	jx8oagFKqja3r7zQCtBZjFa244cXxkkiwn3fdiG9o1Gq4n53b4H	9656	13771	13771	1618417980000	orphaned
19176	3NLEKYqokV9G5mkFRzHgA75F1jGrCGLfrvyojFkhLsRB8YzJXpLL	19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	1673	1368	333	6301	12463	jx532ioMPs2xXSB2cE3mPXRvE8uJiD825zx8ZTYgmYBCSEbeH59	9675	13652	13652	1618396560000	canonical
19224	3NLHcwFWcJanq4es2nf6NG2Qcp3eYWUMqGgrYAYNxYicwk3HBVob	19174	3NKXvWusjpQ69X1tkoMuBeA1yk6qqxhj5QVeKet2Kn4xSJzhawry	44	1325	333	6301	12463	jxSGFmp2rEeEH1jXZ7Q7ujJSSsfox8YhqtE1PfAjRWYK2S6JVgr	9675	13691	13691	1618403580000	orphaned
19551	3NLaz5h2vUx9ZWU4WToDMTuhWck1oKNm5ctuURHMP4hF2LXajo3d	19186	3NKMjzQfhnUuhpeiauLG42NJwcQyLuEamTqzUN4xRBJeSPPsNrC8	1483	438	333	6301	12463	jxMMUndLr5wdcPNoKCnUz8Ytd9hhhXtzXiHxDtsPhPHtny5CWYw	9681	13897	13897	1618440660000	orphaned
19195	3NK69qA47SDJWLYSTZB2kyZ9kyuqZWP4WTYGUvh8pMYzZimYpY79	19191	3NLGVZG7kZAZNHVcQueV4tUg6b4Sh27tKHVSSN5g7e2NSkhNMNdQ	1406	1393	334	6301	12463	jxfKsusJ6VkUMsUzw3esUtGaUL6B66BrWqeq9WKT1HCnza4527L	9684	13663	13663	1618398540000	canonical
19212	3NKgYxwCbyDyCbq8nfzNZQn7xJZnCeWis2tau1h3BSbMqW5jeoYa	19209	3NKrc9AF57b2LHtvPx8m3n5xSXnbfF4zh28AxbuMd84jBVdW2jTr	448	1305	334	6301	12463	jwtCSBqHrYEZ45QEsytximj3HQuvLGMFboSHquuTg1t8Nb7mGGw	9692	13678	13678	1618401240000	orphaned
19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	19213	3NKLjPaCMzeTjsy5F2H2HKhtDQqq7s1vJynhuCaB9ybuAhKaB2tx	1403	812	334	6301	12463	jxWkYMkUVCmNfTkc2AsD7K39uRLmJacgcSuAafhSz8maRVjyGHC	9694	13685	13685	1618402500000	canonical
19218	3NL5MPB45BEBm64QfEAcmS4Bc6gMquXKutKNiLPW9bzbNho25zkP	19216	3NLdm5QTjtchYHcZ6RH1tTbMqY44dPesStCnAPfPg8bwjWmmc5Lh	1536	1067	334	6301	12463	jxvZ4DExmgfNFeMgZJHDLGrBGV5neqHt5jgkiBjTLn3SPSU9WJs	9695	13688	13688	1618403040000	orphaned
19230	3NKVjcWz9bfDyXa2wL7eRPAo1AZz2QFtkpTeGm9554H54RHQrHLF	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	1523	1321	335	6301	12463	jwJk4YDLMoGvDUJNSMo2kUHoxp8mxawHdNn6Vmom1BVbPHPuqva	9697	13691	13691	1618403580000	orphaned
19229	3NLg6RL9MmYWyxbpJH3mWrXYfvLqaz27fLXDt9L5jk79yhPLZbER	19223	3NL4Su1vuzMusZvJfU6Lo6GKb2bBcwfDNJcViw21mDf7sNiH17tv	44	1325	335	6301	12463	jwVymigzAN6LN2kfQNhawXRXSeN1T4ZbQMwVxqQT2zVTNeFrbK8	9697	13691	13691	1618403580000	orphaned
19238	3NLYGCMvuSNRHuQageJG8yRA2znp6iHgUqwjvKhjBsErRE9CTVu9	19233	3NKHGq3jozyytPU3oGbNbcskCgx7L19hrrUM6fbu3btcZwn67iMu	1541	1172	335	6301	12463	jxnAN9QoYiej9go5uzJUGXyw9u5Th8WfmT6F6yHGzUDuhcPsghd	9699	13693	13693	1618403940000	orphaned
19260	3NK4Ta6VzwS7qJ72bs2qp5cAASr4GvKi6LDetzT6wSaAbJWxRmwQ	19254	3NKmimcxLBK3SEHNgnrnTgBkX3mFirPdSgy59DJtAeo8Y1JcUNZ8	1581	778	335	6301	12463	jx9D6s5k8a3Ho6ykeFzhJVaL6kUndWWkjvL25PLB3o4QqYQJyqn	9709	13708	13708	1618406640000	orphaned
19275	3NKh3PBwX8mtWLQzTLhjKfJeMr2eLhXXN6k7AwHBW1yk1A1Nb2Bo	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1406	1393	336	6301	12463	jwFmfhb8gQQmGWc1n8uZ65ye6VuUdHjVXumd2Gh3NPyuV3LrH4K	9717	13716	13716	1618408080000	orphaned
19276	3NKJACHGkZk2jTVdttL6gGkSRFJhBxe8FLSUQQP38yy1Na7RXZa4	19272	3NKY3k4hzsKfFo54bmVE5UTjpGnzEo8XNbp6vPL6bwRHK5nmY1zg	1523	1195	336	6301	12463	jwYoDB7W5XtGNrBrpEdrsdwn2bQuBFJV573sq276DAecuiDxH2p	9717	13716	13716	1618408080000	orphaned
19303	3NLx4VxFjDMvK3f33mXoVHWoL6ygjXcD2QaRx5hCkW88cbFcQYb2	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1634	1205	337	6301	12463	jxHHPBsbTEm15gU1661vD7LCgmateYjMuNahnpcriEKRwsmg5f4	9734	13740	13740	1618412400000	orphaned
19306	3NKZMcNqMkWb7S35QS71o8FBmJbcFJovbk4ViDzSCVXmEzMVtpoy	19302	3NK6vy8RDaBRK4zgxTz23fZN2X9MGRqhVKoyF67LgSYSaVxnrt2j	1553	776	337	6301	12463	jwdaUPEzvT4cbwXNmuNKidFTAU5rVMuiobfFn5nt6jHTeFcRP9P	9734	13740	13740	1618412400000	orphaned
19309	3NKFfWRgEnZiFqFSKu4RMG7BAvCnezF1rLkcgp6WgBBuJ8mxUdsV	19307	3NLqz6tMRookmHkwqzee6ANpUWh3Qk3UoZE9nmSwcmVCLU8fpbCT	1406	1393	337	6301	12463	jxiNoM2B11Qq9AKbqSMfKvWtRhGRF6cuS2BKfrduvQsVTCeHECh	9736	13743	13743	1618412940000	canonical
19329	3NLZmXRw1dvqYQND7PMVfaqAr2DpjYwEcCR37Exd8nNnY87wBxNH	19324	3NKMnKCv7TktPdsTDJ4UjHdsswmfo9WUw7QsidUvYpm4JuDAs3qp	1631	794	337	6301	12463	jxbwPdJeQaqfq28MKEKLzdXhqFg5KU7qTxrHMPJCsfSDGmEy4to	9746	13758	13758	1618415640000	orphaned
19333	3NLYszUnDQKgJiT7AhRqio28wGWjqBTdq63jawStakDzkyw9Ginf	19330	3NKEGJdjiQvCEjA3sLoP9v5Tz1cMo8oV2XT7pxZ2sFfpP87NFgU6	42	1115	338	6301	12463	jxbeWx4QrZUQ3hYqyjDDPjhGTXLHkWtQ23bzRReu9ogkZ93p6TA	9748	13761	13761	1618416180000	orphaned
19352	3NKq3Tz4TwGmTzmLUPtgJU6SyMj9tB68dp2vYLLVBnC2k4u9qUfq	19350	3NLnTqJRn4nZ5f5JcBNrZXdjwNkpQuWH2DxBuNCde5NDVFeSkpF6	1577	1081	338	6301	12463	jx4MP2YUmoweqLkCrUGzdaUTdmxBpPntW5zcnyL18iCuJnsJRfb	9757	13773	13773	1618418340000	orphaned
19380	3NLhfM6WGZr6ZCPifMVSghdddeGVmcAUoLAFU884f8p3hXKCkxsr	19372	3NLXHR7rdRwMmCWe3v5AhdanbVRFkRfsZ43jvJ3mNKFQsfuYsLDD	641	970	339	6301	12463	jwyvbqsJDDqojd91osgoQdAeh3Wa8hgVpTAUE7pS2zx1hdaQTHF	9768	13790	13790	1618421400000	orphaned
19385	3NLi3z4HdXwpnykL9u88vx9mHg1PG8SBYBdCnr3JnNaTwSPYX29u	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1476	1245	339	6301	12463	jxL68zw5SygZGwT2yi3qprhGxHEN1xUTSNJm4WP7UXq8FGhFHJf	9770	13792	13792	1618421760000	orphaned
19609	3NLUk1g7uFWMJRYfRt4649AUYiZqU9se4JxLzWeG19dHudPEXhne	19381	3NLM3G6gsSntaMjg2iRkodQQz5uF75v5fi2wBvyn1sy8x8oTFaEZ	1556	578	339	6301	12463	jxC675BzoaAfybid3LyTYt4jZf7x1qcoHKj3iSHnuprA8Xn5qvc	9770	13930	13930	1618446600000	orphaned
19417	3NLGVAj7Ksez1uhXm47AEDB8bZY9fejiJxi288aTJXbZaPJZsUhY	19414	3NLohbJLeYvqfqCFuK8iBGemM9nWjyrpwaF2erYzqpR2ibHBk4GE	1460	617	340	6301	12463	jy19a7wPnrQwNpz8Ty37UXFHCbx47bnhvUuNF7MrzUGm3y4TgdS	9786	13812	13812	1618425360000	orphaned
19439	3NKYDhoXqrut7pUDRhDx4pGcXnnBHRyhwQJbfyooXkwCPLtQ9oAJ	19436	3NLSmjYi4aNhW6KMrobzkJvfyTMN2mn692E3gzAjjyPmUr7B2s6m	1476	1005	340	6301	12463	jxwa5EVWvKxmHwaXJRA9Sd3dSK5DDwQGrJ9gmyssJK6CQk9cqez	9797	13831	13831	1618428780000	orphaned
19449	3NLb8jSkpDsBfEGQzPRABbBKTyW7y1eHckyUHZ8akX8ZqbLP7cHh	19444	3NKrgYRoyQy7Xx4Tad6grHDbWuue7DGiDxrrHyBzvoXun8QGYJp9	1406	1393	341	6301	12463	jxm49eVL33yPfQTCB8zxMn87qGfoRPSBzUa56vjamsg2vHngsNC	9802	13836	13836	1618429680000	orphaned
19452	3NLVdVg6hTszQvK3vJf2524K1ZQsqSoU979pY9ZwvyNvKNN7oXNn	19446	3NLrLvUfuiceDPBc9n1Qf3f26kEkmBHg8nFkZjPAiq7opX99gBwM	1406	1393	341	6301	12463	jwocuStFdwDgedo92j1psQXq8QGqXs9abmjYwtAyZ8VNbY3GYEA	9803	13837	13837	1618429860000	orphaned
19518	3NKyfpVgV2yD3CKpWi54k8yHbjUmZbQ6cfTPMLUHgd6kgevvAdjW	19454	3NLACLQEyeHcj5m65GKFkmTNbLJXKT8xagi41hXoE1uVofWaKzZ4	1445	1164	341	6301	12463	jx1eW56C33DoWmSHGDa1ovP43dXdmMAkbWYGV42RwE8o4vcLdEY	9806	13879	13879	1618437420000	orphaned
19471	3NKZu22pVT48X3iBVhESeoqtcmqRG2ZcMgcFUgfwmJedsJGAUpPC	19468	3NLdZ7s5LwP4SRvqYTmTfEMUdmcDMQoosp9yfviboF7z86FNePxo	1402	906	341	6301	12463	jxWnh8RnW2PQU9uyp6zu323ebbJJrs1BK6YffquhaHKXgtHjjZW	9815	13854	13854	1618432920000	canonical
19715	3NKca4veHPud36h8ghHt284mSXzc9WHBgwPZmZeZcnd9D3ATqNex	19487	3NLxLP1p7W9DGGqQvsfPervNx6jUiLqANJ9Nmd5D8EMxXvHQiezF	684	1106	342	6301	12463	jxJ3NSrGDRwq6ZZ4qcoKMRERVPcw1xFaqtodWbDF1eb2W28m8JH	9824	14004	14004	1618459920000	orphaned
19493	3NLCzJ52QhFaZmrZq7DBGJEuBVZhDr6MKGdoBdUNXX4hRSUejiEC	19488	3NKiefj76vf6s6jxFcQXC21GN66CrV5eV2c7FsKr7xv4k9CQkGZt	1457	1391	342	6301	12463	jwue7Bn2aCWf3TYyPNHknykXw3o8HzjpnfLhDbJyokQjo5XGTuR	9825	13865	13865	1618434900000	orphaned
19503	3NKJSf9qjSizcp4Ai1N2zHMX4C9poeqHEPGWUC8JVn2Dm4fQuni1	19498	3NKUqmmxFaQPotPVzZk8HTBkMfcYha2Bb1XV1hck4Ch4gQ9purgT	1600	50	342	6301	12463	jxYa9oi5Tkou2r21VsPpfb19t6aUfzm8JUhEPjKN5sx27mToQhM	9830	13872	13872	1618436160000	orphaned
19506	3NKDnAY2pxAmYoihNLg34pPXg9wYe94iLeXTGphEED3RqsBvcNwz	19502	3NLB4TkU11BSNotUdnD5gzMwrbDHbyJveNkX3VTcVEgTHWCRiXaL	1549	1236	342	6301	12463	jwFvqeUUReBa771UH4rFw38h1vMtGmpZb7PTYXdCFqzWJx9RLLB	9831	13874	13874	1618436520000	orphaned
19513	3NKHS1xLxwqrgvtgTM9MxN7GokiiARXEn5r6xwZ3kJdbGLwyqkoR	19507	3NL1gXfm3hWcRdRAvUrv6wPTNvRWi61T8rVbPdHWLaHjtpyDyHyD	1631	794	342	6301	12463	jwoM7LZN2fquQvthx7FBdQfqmmHuMr6TCCyk8REF3k1u1TyRTxE	9832	13875	13875	1618436700000	orphaned
19516	3NLEF4g2P66wm4fnKLLfusFttohCSNyBghPUJDSV11d7KDb32WgH	19515	3NLZS4941z8SkoWSGTKju489AmcuPcD1SzNiEQt5ZzwaJycAsz6c	1406	1393	342	6301	12463	jxBCdwZiUGKDN17d11nCm5rraPJePVsMjMF5s538xwwjzjd3njg	9834	13878	13878	1618437240000	orphaned
19847	3NKkPLyVnfSFwPmKpmZSRi7MoGvSk4dNnrESLjShRLrQSrLKKYfn	19589	3NL2hLumxPjaayaopL9s5sm9mV85RTRFvZh8e1QNv2EM4sjbCaZE	532	1303	342	6301	12463	jy1pHYRiLs11xG1uwQcNzgEjz2k1J2fVNptcVfg2kHgE6Yq4rWb	9838	14104	14104	1618477920000	orphaned
19855	3NLdHqqPvPmRbF8jUE4J85viacFA6yRa8jPGXmHZVYJb1Wsh7iRj	19847	3NKkPLyVnfSFwPmKpmZSRi7MoGvSk4dNnrESLjShRLrQSrLKKYfn	532	1057	342	6301	12463	jwPmJKyCxg2262HFhC9fczETeX8Sd6zzMdR7urcV2ei7s3TEwbw	9839	14107	14107	1618478460000	orphaned
20115	3NKi4qBhqW5ZPMa9LxzBDbBDdPrzDd7sgBqKCbjriX1F8JfPLPLb	19855	3NLdHqqPvPmRbF8jUE4J85viacFA6yRa8jPGXmHZVYJb1Wsh7iRj	532	532	342	6301	12463	jxpn59dP9fXweqMwq7Y5ayyDmhqvyxcdsKg5wgx3ckqRzXCDrNo	9840	14276	14276	1618508880000	orphaned
19544	3NKu98Y6NNiBGH1LAp9Ke3FSLDr27jhA8TE4J1Rgf3rern8i9ztb	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	1672	1285	343	6301	12463	jwpJmMKpQE8t8FgLm3z8boRA5FQSLVqNWK5XCiLQdvYNTzaRZnT	9845	13892	13892	1618439760000	orphaned
19593	3NLt6JFFQ51yz8RE1LHxk6VcUupWouTveMZRuhGcd9iG4My1D5cs	19542	3NKhWMptEHBXYmVNtQz2VTi5usfyeStsbkUenV4nsKtB8Wx5CnkS	641	1090	343	6301	12463	jxCFsSaaiQtXatKun847F6amsc6mdjvLAM8CDLPAAdfR1CPE9jR	9845	13917	13917	1618444260000	orphaned
19723	3NKXb76fUHDaoCm55G9XaR5QYm3isKfD5BUHSgN5qWuthX8famre	19593	3NLt6JFFQ51yz8RE1LHxk6VcUupWouTveMZRuhGcd9iG4My1D5cs	641	1336	343	6301	12463	jxqnd8PVp5Xz4hatKaBGZb8qdbyZjgXuWUSBwQXp7898a2Dv8Aw	9846	14012	14012	1618461360000	orphaned
19766	3NLbWa3efG7zb2XJdtMuzJaJWvjVMYhUW4axfLCkh3zEVrPkjwym	19723	3NKXb76fUHDaoCm55G9XaR5QYm3isKfD5BUHSgN5qWuthX8famre	641	1090	343	6301	12463	jwZqiA1DDEYGhDxa8DqQfiWLPzsxX2aDWCQRU65sxpEfXzMmD67	9847	14041	14041	1618466580000	orphaned
19554	3NKAmLfEZH9cAZCZ8LQL5byHwniE1b2as3DvhPXz7v61V6k9pe8x	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1546	1093	343	6301	12463	jwaweTscRwFMK1eMuZs7nMnJrkpJvD1anoaX1MQ1bAq5FnQEduw	9849	13898	13898	1618440840000	orphaned
19556	3NKTtQYzQBpyDeqgSNh8vpgN4Nr4waqnM3tWqr9vZ34wM7vjy9fC	19552	3NK5kNaazvorM3EmtBpVHdTZhm6hAVM4PXWdvARb2HBWs5RREH6B	1506	1127	343	6301	12463	jwFPh6Vevq1YUw1SxEJydZS4AsibiStFXQHQTzAipZozzkKEixc	9849	13898	13898	1618440840000	orphaned
19598	3NKkBnojJAmRLSqXvA28gqNP7GmFthuqLusCW71YAUwB27NptUNB	19597	3NKGtdkHYDHqmh1CBza3DDa67GsYRLFqk5iEJ1MavAS7YJhgQ3Ui	1467	1376	344	6301	12463	jy33FHUeFhvs6mQsEF213sE4BKLkePdzx5ANc1J9gpxNMdU6TFv	9871	13923	13923	1618445340000	canonical
19604	3NK5bKwu6TRuoJsW7dByrkjjPXXYk2k6PVa7PNVgpAvufiEQP1VZ	19603	3NLDpD7kV3fdqHY6bNk5uXcge6pBnz7ji5FUU55eCypHNju7qrcu	1619	454	344	6301	12463	jxBircFR2GBGCfhizYzcFfRxopVm4WqSp8VncrpVC3aLJ8bu9Fc	9875	13928	13928	1618446240000	orphaned
19616	3NLBWfkmRPuJ5pBSfEf7LZ6ZFKwUpMmfagkee6MWVK1pzcnFPoNB	19613	3NK4tGXbqyWj75q19KNiSvogTNdksuELWp1wZ4KMeardJybGXe1y	1647	1302	344	6301	12463	jwGqBZgod4VBFLVLpW3fZ3SwcaDSEm47DhubszqHRzTEv1X65LV	9880	13938	13938	1618448040000	orphaned
19738	3NKBiSkKA5mRyYFBfPUVkUsTWq2spZRQLFNc7PeRGxQQnwCJzGAr	19694	3NLsErhJXyegJySzhns996Y7vXZK6xradT9cBBPrfZtUkp5hMzyx	1534	1071	346	6301	12463	jxY3ZnStymdGFeKeajna1qnADKq7nMUeERY2k3eXEbB62h7HunF	9880	14019	14019	1618462620000	orphaned
19627	3NL4LyKdTf8cYvT6k1DGeAeAsebUq7DquY55DQBFqqyVwAeCubbB	19624	3NKynUX6Fdi6VfDtLZ57L6rzvNhr7wsUDfKnwXgiHGGR5JDHgS7r	1406	1393	345	6301	12463	jxpPmFy1cVCKGpGqnTH3bKBpU3SSX46r6hefXXQuyJGewEcGUNj	9885	13950	13950	1618450200000	orphaned
19642	3NLUirVZZ5SUuBmQgzWVERCricHAiaXYqBDyDJ2SCSUWJhdaEa2Q	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1474	1329	345	6301	12463	jwBs5oRYdizGhHse8GvdDPdKgFWucxQpWA5UquEpeJemcRqf29v	9892	13960	13960	1618452000000	orphaned
19640	3NKfHkHRf6Q5hxCwcp8gt6pQvNdGSPuo4LbToDM36xQpiXwqdn5q	19635	3NKiGKVgfC3xtcqdjPDWTv1FgXkMxdW9NAk4u2STbBdUKVzauwCQ	1458	1323	345	6301	12463	jwVM44CTQPVpsVTXNLcSCn5aZVnWH2xkNM7rAaN1jwVRXLFhznw	9892	13960	13960	1618452000000	orphaned
20181	3NLfedSiPtaaeUG6Aamj5HRsqbVQRsy4xxqmdLDVEBt6dE2oKLus	19652	3NLn2LK5ZQebpgAEX8uJ8JH9mE3uYYwj3xfxs6RfJJWU42qvJp1T	448	1305	346	12463	12522	jxh1xwM2iPVnKnWUkReB2gx32GQ4zL3ECkaekJYmUsKpVrAwpby	9899	14330	14330	1618518600000	orphaned
19690	3NK7NChdMqVveA7mVqJ7yc7Az6N9c6FRppng2DsjMMtYp2nDQeFu	19683	3NLWV9CDCXZ2xQcD82nuJ4ZKbB97cMwvV4iJu3bGzDsqCtL5frvG	80	1273	347	6301	12463	jxBXQcswQgv7L1jGDskytbon1n1DThoQZF8veqrPZi5hvi6pNL4	9914	13989	13989	1618457220000	orphaned
19688	3NL3fnqkhmU6aRVDCc1f9C32sQaWM26LdgWungTn4X5ERme1tr2a	19684	3NKaSJDxfDNefVEb3B4euaUSg9vMdaJMTssYZcd7seGcDDCw1TaW	80	1273	347	6301	12463	jwrLC144xk3h1dLWNyuXAVVfTLp3umbwjvRRf8BbEZkTk9dLzA4	9914	13989	13989	1618457220000	orphaned
19757	3NKbvGDx9aVFEa9PZ1BV3tqygPtrb53hpimcQt9MK6BxUv8Kumbo	19689	3NLTdZBH3CsXR5msmSMSd51iQSkx4DU6UyXH2EixSjc2FJ5vQuUh	1588	1266	347	6301	12463	jx3txhYMkiVbkntfWunSZzvUi14yN9wZ5R8dfQocgkfsKenDsdR	9915	14035	14035	1618465500000	orphaned
19707	3NKSqhqcxVs8BxiFzUkhTSvR9988LsrAt7Sj3yomdoszUsbhRFcb	19705	3NL6sxikY1JMFe8TpGyfbYESUhrtTK6T3Mbn6HXeg9DvcK71cGJk	1439	913	347	6301	12463	jxhXrkZ1cuKfSY6DNnZkQ8HMxWk5tfSo9MPKgvgohufZqnRx9Jc	9923	14002	14002	1618459560000	orphaned
19944	3NLiS9jKjfrJtBXuSFEuufzfdb8TonfrqrT4v7P1cpeidM5xrUBG	19749	3NL3BYScVgwu6mig7HAVXvF3XSPNkAHAgUmS7gQrwPSwz6yxPizV	632	1016	348	6301	12463	jxz4QsquQscxEXTs342SSVKsVWeWr4LNq2PZZcqxK8tZEJvjFm4	9926	14159	14159	1618487820000	orphaned
20185	3NLR1uBqzEeiyZq9isfCBphAMeA5zAugWCdvsrHD7Jt7SjREkLmd	19944	3NLiS9jKjfrJtBXuSFEuufzfdb8TonfrqrT4v7P1cpeidM5xrUBG	632	1136	349	12463	12526	jx3gXGjNqJ6FDgBfVDwar2z7EXndT45i6mXYxnddbrgbt7S8KJb	9927	14335	14335	1618519500000	orphaned
19726	3NL2gcQa9ySqtDFmJRpU4hVt23EQ3z38mqwRiikukJy7s4QFSmd6	19722	3NKhUzVXkzns5h7wozAJz2baQQHLNsXHMDPgX6SpcFd7N4yhXNFT	1483	6	348	6301	12463	jwWGCfNVLLg4aX1Vza4zWKmoDGN2jJ3wuJgDAhD1rbgUSDBmGCb	9931	14014	14014	1618461720000	orphaned
19737	3NLdDwSnsK8sVV6iDW1kathNyrG1uYDoPLCfqXRk4aNNdpyQBQvZ	19733	3NKYn8p5qsf7bKohWQri6e8sXRGqQ5D6rvyXdunhUv6pfwnQuKeH	1534	1071	348	6301	12463	jwKS1CZxFEs4qxcfCpvVSAt3eSLbnzvNFAuM8bN6h4c9GkktrGh	9935	14019	14019	1618462620000	orphaned
19964	3NLShbNfNXB8ehdaYJJbhikKYWN7oVeCE9usSzd2t787rLYNJKF2	19880	3NLAWUiBBPbJJpHCnrYxoW6rthtbAxYhoJZYL5TP6BTw7fBk31Lg	1560	1291	348	6301	12463	jwbKHWwYdqcYBrRyVHo3tU6ocUF1hdkr7SrhhYuMxeHi4cjH9JE	9936	14181	14181	1618491780000	orphaned
20278	3NLSHv2xNnaKgrRmd6yuT9TE3M81qVN1w2NGs8wytHjdBNTSF4MK	19765	3NKHBXudXT8fXihJBZvuiN1rn5j2U5uH3tdh4xCZwSc9dpn3hfUc	42	1361	349	12463	12616	jwJhEToo9bQV3hxUP1Eg8q7zWjrtk4VCD9xFMfpzgfvx3mhRLgt	9953	14408	14408	1618532640000	orphaned
19775	3NKBkWhpEgzacU2M8JGECbrMq6ZoEAowWFthvdbTGkDdSCdn1m2W	19774	3NLi2N1uAuQT6X9Y1oDZKB2Xqanjz2MawUNGzeDKk2jPvMzHs5GA	1483	377	349	6301	12463	jxPLJPog5b53wecaujKJcD3YyzK1pxBYoFCv1Zc1y61S3vVQogn	9958	14049	14049	1618468020000	canonical
19781	3NKka51tixPPBUd4MeJ7RZnJjbqceBHek3W5xfB8XB4RPDpSA7TA	19780	3NKJzh4Ue7HU8yC2zeNVWLaBtrbX4N3VkYirDbrs7BGSfHg4rGE4	1476	1371	349	6301	12463	jxsGLWvhJzgJQU3dWZXRhdqgKjQHrr9RyTgzzuEzEot3GmwDiJt	9961	14055	14055	1618469100000	canonical
19801	3NLgzuo66S6jVwMjRN43p9i5tcc8BSGhwQKkukiwE5RrFsnyz7ug	19797	3NKTtYuBQnby2wSjGTAnF1f6fSkr9tUEVmMFVE77wQQ8WMW2nAmG	1527	702	350	6301	12463	jwZvcetG39nr3PRiQyDpEpDjJgcQtdPqc9EvJuS6TPtGiDRtSaK	9971	14067	14067	1618471260000	orphaned
19827	3NKLktBQKZTEf9VR8fxZGz4UaccXJgSs3jgZ8zgUn3PmPG1A71p4	19825	3NKjCFzxyaT6MQcY6ymWTyYFViViVQtJFHm4ow4g88eDuhQnRbZA	1542	1304	351	6301	12463	jwXdpDBjhPbpkNhsHAquAWmYTLUtEyJdBgDQAUenXGK1VH3F9qs	9989	14094	14094	1618476120000	orphaned
19875	3NLWbWj5US2atTS38JkecFofgRN3BUGhwsWGtMMvD2qbAeKJtb6m	19834	3NK9ELhG8R1oqSmtpvCiLgEvmQekyJ9sv7bfzCTZdyd7kUoMUP3c	641	1210	351	6301	12463	jxZvpjfDCRLwMosss2ZeAFh74MdvH43ECgQmvuB7QfW9F9Fn29L	9992	14121	14121	1618480980000	orphaned
19843	3NLNWxa9GWpcAn1NF6ULPVifBm77PTWkmBsPvaQA9EZQNftJYrd6	19841	3NKeCAcqyEUEjenRvFVuea58wmSKuLLCvbtTFaRMjPqkM9Axs2dw	1619	1149	351	6301	12463	jwYsGGiC5GQcspaJuMejDbFnQUkeSh7ncMhobzYzqizpP4erzMr	9997	14102	14102	1618477560000	orphaned
20025	3NKFhMmNeGZR8daKD8zWASLzUUzhVtyMp3DfjFteUxyKKAvukYwk	19842	3NLmHHjWp7vGwrMFrsYYYW3MJLBaRneSZLohGHhsAvGgEH1J4RbE	1619	1275	351	6301	12463	jxEN6B2jYVuiVtSr7MsK6QjJYybKpuHMCZ7SoaWnqQLQxACXsRC	9998	14219	14219	1618498620000	orphaned
19848	3NLjanAoyqjqmPsQHafJcvQiGW2xbvyXANHxEyNwPwan2eUoZBV9	19846	3NKrd5saMRPLRLXBZoN7wfxbwNhJVB5t2ksK4dVXatCKhYC1CK7o	1406	1393	351	6301	12463	jwKyrYy6qFkC9E3NNBEahaSCwGVQoBvFLmM5jKkycqYibUepbEU	9999	14105	14105	1618478100000	canonical
19851	3NLpxsyVVG1BovcXZgoeBPDe8ZGd6oZfNTgX9sv6nxsViC6WHVqC	19849	3NLhfsN1QPHsKzqu6RaVyLKmMCYTXnkrueMoWpmRQErfBkh6v6as	1406	1393	351	6301	12463	jxcZXUjEYzY1uw6GVY7qiY3u523jCL33ps6s9wd4JVfbcGdXHDn	10001	14107	14107	1618478460000	orphaned
19886	3NLDE7781p6kZqxtCWpxuPsijnKnmPMmreNNnFTBHK217YffGptG	19884	3NLgXFtye54cXZwGsNyDmCc8wLG6zD9fSDkAg78SMwW8tVQSZQee	1622	1110	352	6301	12463	jxLPZPnYwKQa8TrzjSsfCuC4eainUWBHbmEyot2LAzieJ2VCrPV	10017	14129	14129	1618482420000	orphaned
19901	3NKnh941uKc88pfZFAoyR5ijftJoy1giJeVsCYtvjvSNF5dWo9Hx	19900	3NK4T4RZ1vND3pdtBw2sBaxCT3hiSoiHtqwBTfqM6jtiU6MvXeWG	1637	816	353	6301	12463	jxxiAeRMqbX4WCGDv9j25AicPz7k7Fow7aJc4kY6zTZjoUVtanz	10023	14138	14138	1618484040000	canonical
20029	3NL5Vc5Uq3fJnJ5JmanmUgm362PY6kTFmaj36a8E4uhQ16Y41d6d	19912	3NKetnSyg4fbSmmJdraBVKi8fG2mDMRiFu9rCYkxcEXAFiVYXRZE	1619	1275	353	6301	12463	jxWku9R5w1E9e8CHMXgw1VfYFy6VY6f4ZiWyyErYVCWem8iXpMr	10028	14219	14219	1618498697181	orphaned
19942	3NLtWGdZRcUgsj7nTnfy7L5iABEWi6XGdGcy8q74oTEUf6BEPvqQ	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	632	1016	353	6301	12463	jw8kK2htLnh2N3Cjts8RsK4NurE2vWRrpiX85V1AEfwWXRzeSPV	10041	14159	14159	1618487820000	orphaned
19943	3NLDL3nYSMzyCA6RPdMCMCmeXuEg95CvCuK4suFBThb2J6J9jsFd	19935	3NK6ejZvBJTt8sfrQzgG1C1niBXWahfR14gGLbL6Tx5uTDQvqfLp	1581	778	353	6301	12463	jwQ9aZFFVDQ8gR3mdGTj6Lj9VF3jsRGHHhPdyChzDc4HdZBFf9e	10041	14159	14159	1618487820000	orphaned
20030	3NLLR6ibUU8ydRk9RZD41Rz1byxF8nramyhvAgx9VDNWvSC8g8pE	19940	3NLJnq6hNLkh4jmDaRRDxThTr7Enadv8LZ6CabegbtQ3smX3RYWn	1619	1275	353	6301	12463	jx86Yc8zqp3orfEHZ9tX6oZGJVCZoNVozf8UnSFmA7MpqpnTaBc	10042	14219	14219	1618498734624	orphaned
19959	3NK4K7vWSuvQfSwSgf1wkwoVDEXdh5em6wfbFPyLJo49ZkUAD5N3	19957	3NKtYoLkkQo3D3WyfhWiNwNFvKZkPmTu84HHenP14qXKPFwt8NJk	1439	1153	354	6301	12463	jw8zTazedYLRPGN4U8KVfecabEmPm4ZE7AGUARBVQSSidWgk72C	10051	14178	14178	1618491240000	canonical
19971	3NKu7HryJHJ66U7LhwxcMdY3zCTMGUVySDEfvtHnyD32eCP6qoXY	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1523	1075	354	6301	12463	jwsKpNTCrnRHdN5V8Sj18ieRYxpzWCxmZ8FidF9LsL2fKUMftNk	10058	14188	14188	1618493040000	orphaned
19976	3NK66LvMy13LfiUmZ9Gu2t9JpdzB4LRw1EczdXFc7DMYqvJw5TP5	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1553	776	354	6301	12463	jwSX3sPknzEc3ykkuhRXu5CnJSSZLcavZSE9h9RuJ3unYpw1MzM	10058	14188	14188	1618493040000	orphaned
19975	3NKJrjeJrC6AGn4rQXfWyNyNAoHRFNFJM3RtXHphqfeiN2qLvrMU	19970	3NKHKNEbnuAxU6RwgADnSGENqCMzTFsUBaurPuZakUkBNgST6N8D	1407	1395	354	6301	12463	jx26PsEQk5Fukg4r4fnh1kZaiRTup449iuXD7fCYjyCJEjXPa6X	10058	14188	14188	1618493040000	orphaned
19989	3NK8ub8n8xxG6zsij9kZWAegJsNsnFn8x2vvNT8u2MB7kW5JudJd	19986	3NLNbcstHuzRdRpia6fuQGdzDDVh9Vr4qWQHLbS1uLEWx6iCn8nc	1631	794	355	6301	12463	jwKYsgXE1r41u5qYxHrZeGe67upnoUtm9TS3QPqyKBhsybFj1Mq	10065	14197	14197	1618494660000	orphaned
19996	3NKX6z6Y2WXBkH4V4Ek37w8yfBQ1oinV3bNndVTH1nnLvFD2rwTz	19991	3NKnxfjb9Vrg4uF1xQpQxPrZu3wZsrx4QbRBNVvHkDwk8myTLD34	1477	1224	355	6301	12463	jwskpGTdWcV9CryzAsWbKSNreRpzDy7V42cT93A4L4W22fTJJGU	10068	14202	14202	1618495560000	canonical
20031	3NKer5juTTJbduGpyJyNqQDrZKshgdgz3LVVBsEroJWnXT44KnnN	20026	3NLuiseRfwpKPXCNu2aPXZtHRP9UzC544AXekJj85iMoiWkqGmVw	684	1106	356	6301	12463	jxK98BPsbF7a7YZp41jnkTiFtZdN2CbRYdQRdFuJiQcv5txvv2Z	10083	14220	14220	1618498800000	canonical
20066	3NLtgvowSw7PPpmZnSUuy8rKC6mtDru11rC8j9EmKJdYChxRicnD	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1652	1069	357	6301	12463	jx8jY13XFfM3B46iWQehEEUM6PtnoZmyfDQvEA7BFoyje7eJ7ap	10101	14244	14244	1618503120000	orphaned
20068	3NKc1KxmDg2i4S4Cw1PQ9MA2HC1UFiRMfYhLcMv4WH2ZTUAasaig	20061	3NKbni9V9KsBJuzcVGvL9scTHb1iB5Xkuey5KoVMDACJSNAZ1cNL	1652	1069	357	6301	12463	jx3pQBJAcSVNT2SNdtXepupezta6uwnu4hbc4ZpzNpzkBvnnFE8	10101	14244	14244	1618503120000	orphaned
22513	3NLhL7hFVeyB4kN65nfBi3qDWeUctnDJqNcoGZSo5iE3FWS5exvA	22503	3NKuavwNyHvSC7yNXHfVRzAZmhZpY1wX4zdWoscNiReQEPfPbrpW	1553	776	405	12463	14611	jwcUq4kgqiy1a5yF3DMVe48cVbRKkVkVJ3tp1LM9tAN4m4xfMTk	11038	15850	15850	1618792200000	orphaned
22542	3NLxyntFVdh2pZXvAzJmMc75cBM48bzP9kcgbkYEYx87DkfJCkLN	22540	3NLBsiXw4YC2NxWaFmuK6Da47Ehb5ZCwt2BH8m4NCNAyhfVSGwK3	1602	1003	419	12463	14637	jxXDRuC7jbktdb3yJAeAzsgzKgXXJS4iMLhdNJtkBkuaTiaTQFp	11278	15874	15874	1618796520000	orphaned
22619	3NL7PRWGVDAQoBAxvpUKe3HL6brYzcunVbqWuYXDcomatjjsE9kb	22613	3NLKcE8hGGCDidrchekKCcqBKEJoaTpY6SiouR2GgQmkUeG4GTP2	1581	778	421	12463	14707	jwB6G2Ef6bCsopCWae1tL9s5WfiMCsQKkCFCRBGhS2SHfijnjKC	11313	15928	15928	1618806240000	orphaned
22633	3NLVkrpgFyYJGnVSTJiWdE4hLJJQQ8PLCvqgo39BnYpnYx4YVp8C	22629	3NLoGyhMZb2LeVisXzPgeZbw2xxCXrbWVXqRuNSJCWhyasmFwkMB	1541	1172	421	12463	14719	jwZaY4hZkVs2hcw1FzCaZC6gtGuCQPtjLbcf3FzuYBzTnX5vU9Q	11319	15935	15935	1618807500000	orphaned
22670	3NLSyyM8zasprQGggcPrgVU3LhnRxusop8j3TsgvLbbaL3cJScXc	22668	3NKLy6Hx7RP77JYwgZSxka6K9wup4MwMVSjJ9KEwBD1Jz7edLvB8	1506	1127	422	12463	14754	jwhQb8V2kbc1ErH8TrxNBdZgW7BdbWfSs1hgxXeKFLNcm6j4oyf	11333	15956	15956	1618811280000	orphaned
22680	3NKawWXDyrMRKb9vfMc4HrxXNf4noCBzJatMJEVdnJR3UgGXJfwi	22679	3NLbg7wnTMYwGgfSmDiFgevKy2sz9Cn73mfbeKUzqSASERrVxDNe	1483	201	422	12463	14764	jwCzmfQiDjUd6uNg7cSdGXVcchxyuoH4PCUSVv5NaQgrg44KkUy	11340	15964	15964	1618812720000	canonical
22701	3NKHVPH61yVXhQkZxDGh3DAEsQgNpTqdxukQhSD51Mn8ago2JJ4h	22696	3NKMyBsmFpoPcrZy9s5dBbTkkYEYnzegQuuN1nGSoqUqQ5A8pHpG	1581	777	423	12463	14784	jw8XxjZeJKWNgDpicHo4iDpgDd92FCdb3eTpXz6mUcE56Qoa9k5	11349	15978	15978	1618815240000	orphaned
22741	3NKB1D5aw5jKVo3oMcAVMRySqF815MEH9ga8LuVRLSEBCk6JWKKh	22740	3NLsuNo7XvCipabU4vnpoMbv9aLoFZaeFG5dnFuJaNbVAMNxfQhU	1476	1125	424	12463	14820	jy3FwsF82SMFgUXVenb6ZL3PEP75zu7sZXF4Vr6oBtdWXhH6eUC	11371	16012	16012	1618821360000	canonical
22743	3NKdoHSN9PkUpurM3RxeeeNdzwhd65GzYu1uij4JVrc99nR7tHCE	22742	3NLvXvkkgz2Gma5BTfeE2Ux57UnKSCsrcRcFSVVtzk6kdDC8s2VV	1581	778	424	12463	14822	jxNDUne4DHgrAod6FijVoo25CdAJUKT4ioDotW5ZabKBF8hLyM4	11373	16016	16016	1618822080000	canonical
22753	3NLo6oPGLPGtDKADZt1dRdoH4jYgKkGH4SPcF1aUaDRJMZk7V9Y1	22746	3NL5zc3ahoq4nDoD6TgvPkNGSpLhbRbzG6MWLbcztJEmngZwueTF	1579	1143	424	12463	14828	jxwXpTPHsV88V6VWPfNtF48z3finZfoUHtGf8FFnxc2kXFsZR5f	11376	16019	16019	1618822620000	orphaned
22843	3NKtHMCP7hS2AJk8xnq6GAA9BLxK596byJ79ZXnzTDX1tgH4j4Fh	22761	3NKC3oDXdoJoszKpfn2cGYooiRWibRrC7CCPhaxcgfBjCMh74Hcw	1509	1320	424	12463	14910	jxoSQEc9cw3Uh5yzMRZchbURzpxeGD1sDWWYjsua3MrP9PkVboq	11382	16084	16084	1618834320000	orphaned
22766	3NKZ3uLdG3dnPViJWLKVWdBAtPp7AkjnZcQxxaY6rayuscd8gFaj	22763	3NKjUnfuKagg1vNqEGhsr7rb542iRyuQu5SrXf8aXcgg4GEuD7oy	1406	1393	425	12463	14842	jwpXu1KbsbAMDPpHm4csdTM4gSNCWXpWGCAUTHiGS2pUi9LSdhZ	11383	16029	16029	1618824420000	canonical
22768	3NKYVgp6qKPJqVx9eGM5h6gu5hsViJDJro9BkvHC2BuEkfjJ6StR	22767	3NKzw7wrcHftWgCF6BavkGnbuZ94DBzUuKXdUHvrwNXPDjmGPLX1	1651	1175	425	12463	14844	jwcjhzoerSSsLqbbV6AGhiRrKzrr7NgcfdAMxw1H1zM5tKb9mH9	11385	16031	16031	1618824780000	orphaned
22791	3NKHegWnLYijTJNHd7oYXnfQ8oDK21FJ881e3xatoUHmKaG59dwp	22790	3NKfkrYjmrrNH7ouBxnQSS5q5p8sVse364NyiJcxSxBVoLnhC7rm	1406	1393	425	12463	14864	jw7svmjmqjMfLN8qimMF8jqEE7zyhbELZoCTJZQ5UALnq5Vtq7v	11399	16055	16055	1618829100000	canonical
22798	3NKdHyBPbm34ibBh1SwuprfWaVMzSZwoJc6Cq79SbgJNVXtPXT89	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1506	1373	426	12463	14870	jxz2Ci1fcotzsZwL4HXsiSbeq2LKxL21Wh52gThnhnQV3K28xSu	11401	16058	16058	1618829640000	orphaned
22793	3NL9C5Degoa96xAxG6eBhqTqyH6519eNEuMmyfKuTNAFeYNVA8ZF	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1403	824	426	12463	14866	jx3HestFRqjc3rhST93pNVxSdYvE2CVTRYxeDQ3rAM4CCaNv6AY	11401	16058	16058	1618829640000	orphaned
22795	3NKqW8ThSLV5KMrSAQMePpYuzGWf54deH5bKnPUw7T524c7dGX3W	22792	3NKPVPPNbKHgz2xa6Xzqds755JMidDZ9edJN4DkgGzZpwDh3VKAN	1483	878	426	12463	14868	jxK64mEHCtbZ6ZuCSYgSbAMwwPaoxc8pkpfB4hbCm2ehtomwHVh	11401	16058	16058	1618829640000	orphaned
22980	3NKWzbrU5y4vmNe6Frnn1bZ6aKPAQxjrpT5wJ38Z6cpwi2VVa82N	22794	3NL5tgAmTs8WrvagkDBGb9FAvj9JSybqmubj95FbcVAPPyyyQFQ6	1646	1228	426	12463	15028	jwAVp9PKj1Eb4GqayNA9n1VkKzuP1Nwp2QZZqUH8tzZZ7fomBqM	11402	16155	16155	1618847100000	orphaned
22842	3NLUFv8EdEcFWBYLh5kJXRyYWvRzGEp1XVZCY9heeLFsSoXBabcz	22802	3NLchqY4eBthTyUMFbhAFb8npjoGsbgbgPGsqV5VP5akGjmnRPX5	1509	1320	426	12463	14909	jwFeY3RXH2u73tywaKSavfMGFAbTWStkQ4Q2t9cgXUqnGPiVkzR	11404	16084	16084	1618834408300	orphaned
23302	3NLM7p8tbzLQ82HQDCnD94GJu93M2DJctTXYuaEXQSMZxaDDRSxR	23184	3NLEZiDKFenwna9o3kEaAQnBEQxcBtTQQJgaoXXnepTimydTMQ46	80	1027	427	12463	15316	jwiQkQXGTsEFETAR4TfS31Eyvc7Ru64TpPFmfNTY8cbtuptHFqW	11406	16365	16365	1618884900000	orphaned
23353	3NL8puLK4LituyHzdXjMmmKRKH1TcqAKY9oyu3JEWX6UMZg85Zc9	23302	3NLM7p8tbzLQ82HQDCnD94GJu93M2DJctTXYuaEXQSMZxaDDRSxR	80	907	428	12463	15365	jxHLfovYKApmVuhkcGxk8tAPpHLqP82nEpyWgPbbC4G17MrETdX	11407	16397	16397	1618890660000	orphaned
22853	3NLKkok3XMK1QUNNnNdFhVakQZxZYCeUKAHKrrJjpqX1Fg2nAoFP	22852	3NLxrAyxwZvmpmMvGJ2WCjCuxk56fzxaxwF9Lgw11543fcFesSSD	1509	1320	427	12463	14920	jwJgbVipb6RbzMZxwKgvQzqrx7R9xZn2hsGKgWihEdsioKxw7ny	11422	16088	16088	1618835040000	orphaned
23047	3NLTDzfKHQSdZQLSBukxtdM9wD3NCfhzmk9bppgh3fXuAa3tgk42	22844	3NKgUicGixFe77caK3NxkWQydr6ckEWDoRRoutaWj8vVyRwxuKCa	1522	1322	427	12463	15086	jxshaHTmU7qwGv6FwRHSt9nCaRJct5QhiXqE35mPAVoESSh7F55	11424	16205	16205	1618856100000	orphaned
22847	3NKgPRHLsKgdvYusMoo1CinpB164EtWiaUsj7WVXicv6bL2LqTKv	22846	3NL5ywLUH3ehTpaHnpWNjBcXpP2ozs7iAx77deMS6Q1DC9JQ7SE6	1578	1050	427	12463	14914	jwp9euE1BRbJGNAbFANVJFgK2SjJS5DMnJ1zrVKWCPfPPUZR19R	11425	16087	16087	1618834860000	canonical
23057	3NLSkaoCEGxUN3N3KWPCi6aSR3QWRhnyP6EiG9do3GGSnBybdzuL	23047	3NLTDzfKHQSdZQLSBukxtdM9wD3NCfhzmk9bppgh3fXuAa3tgk42	1522	1322	427	12463	15096	jwcp7236AYtqogvoQhCJUwnmznNzxr9WnxMu9ofwPzNKMQfdBiN	11425	16212	16212	1618857360000	orphaned
22856	3NKcBZgRJRZNjNKWK4PkQx1FpTWNztv2UVqFBYyGRsMLzJSF2CQA	22850	3NLpQryNTUghLLcJPBUwoggnNinAkDGWc9CbiQwCgMKYxb3Wsvur	298	1308	427	12463	14922	jwxHxM7Kp8RmoEXLC7DnzGnYmSbyGgQZv23jrKHpNqrKYNBit7Q	11427	16089	16089	1618835220000	canonical
23174	3NLyU7i1P5eceuNB6eWr6roN8YhgSD8thCLpREuZk9m9bLummb75	22857	3NKtbA8jUohGq1Ft2BfgJJG7gLqEnKjgKKFFQwqVFYqBMxTrT6cD	1588	1392	427	12463	15200	jxAuTm4fw5KpGUAbYPKKT9KKRH3u8QF2M2a8zRj7WXUjJyBDwXF	11429	16290	16290	1618871400000	orphaned
22870	3NLiLTxR6FDZEKKBaNSnHoWgBUF4da1QxsN3hYvCfoexJZEV2DdQ	22865	3NKZN2Zx9mCr16Dirk9qUTZXUW7YxXrWZJcWR2B9sDfcZtBfWWTG	470	1309	427	12463	14932	jx2737oqjy4ihBpp3u5hjGVKTAS3yhBd14NCep8Y6cBX2pdThuB	11431	16093	16093	1618835940000	orphaned
22880	3NKs3854fLzGB6ts2CxQNBX93hmS7sYRrgy6pW1YuBR1tpNoG3JK	22874	3NKU49Ad5odP7yMFKDjo7npJ3zMA7SFvnujPCUZoqs8t7mSm8XCc	1631	794	427	12463	14942	jwQUiWQzGRnbd18Ggym3ktJtQdfK7LJKz2hSg1UpSKR2eURbeLN	11436	16099	16099	1618837020000	orphaned
22941	3NLcp7sRGGmcVBhKd2gwjVpUEizV8wfzurU19WwoXJHcabcUXxn4	22884	3NKCBSoDtuDwDALPecA4HTtLZ7wrwK1eDcaCDdkMtQf9BFNtQ3Jf	1675	1342	428	12463	14995	jwVwZhsa3PW3zh8wAskZ32PHJaGdgggNrzF3ph3kcCdorJ1G452	11441	16131	16131	1618842780000	orphaned
22893	3NKUfFjNHRU17khbEuxswjH4x92M8xbKiJH8YFcvu4dFAz5EDb7F	22889	3NLttxH9DoRueu8kw832J6Qfa29cxir6wbnwcTUrK66NR6EWi9kX	1541	1298	428	12463	14954	jxq3wBb3UbRZrfvgRtyzwzxYkYX6v6y1Sa9w4pU4E6Uei7QQb7r	11443	16107	16107	1618838460000	orphaned
22898	3NLAhFTZmcLNECsGjEp8BMHPi9PQ33bLmWqR4VBthSyAAzoAvWyn	22897	3NKmmExXmy4bvUfXy6WdERv91AoR51jwLGLzJHmwgT9Rgac3F3kd	1403	824	428	12463	14959	jwzEZuNKpZdP1wXvEuD9M3ugHspNGc3DGQhFSYmxGPX4TazpywS	11446	16110	16110	1618839000000	orphaned
23438	3NKaRYpdCRBYmEVZVK6Zyb1s2xPGbHuFSrunckPbiXgBwaXbtaF3	22904	3NKB5Xa2J21UsKMdV7jFuaxz4dGEvaqhXErT4rAEXCDsrcjYu6g7	1602	1123	428	12463	15440	jwfjKWom9K47FQL8XMQTrb91CMzoDSJprdSB9MyHGwc8qj6Sq4E	11449	16454	16454	1618900920000	orphaned
22917	3NLyMocCmnq9yPkTxPQg9bJgPUyNt8PijRqNGgxZY6s2ndhitNse	22914	3NKX4HtuSrTNLm8e9vQweqsQk9jJnM7Um7fFREeFY48A4A2eBH1U	1461	1271	428	12463	14974	jxcT7Jxa4mR5WnbKdbzS5mhf84oRzgHTpid3pHM6z5hkyGqqCX7	11455	16123	16123	1618841340000	canonical
22926	3NKzdFpYp5o2iMk2z9Qz1hc437J3STK6T1EbBbask87wdsPQxHDz	22921	3NLibQhaffChMYApy2pFwpZTeDZxP7Q1G7TQ6ZkCVaEy6NtgXpyF	1571	969	428	12463	14983	jxChumZqnfSDVFEkpQqjpKBF3sf8S722jPnCwWERuA7yiz6Erz4	11458	16126	16126	1618841880000	canonical
22934	3NKT2gWcqVhF6VH1sSYPvbtc5HW1KPUMkp9PwEB4Y4FtrYp38vCG	22930	3NKEcWp8hf6Zr3hVG43qUyfjR8FK7xRpa9t1f9oCQKHfEQm8RJae	1503	1277	429	12463	14988	jwuHD6fDUPedTgRKtbauHfqTyxXCiwL6t32M6Xis1AxWzMuqkh5	11461	16129	16129	1618842420000	canonical
23443	3NK5GhMyFnNKh5MQtGk6gecdqxURE2wREboPugprgyC46GK7z8fh	22940	3NLUQScZGZrfzhYLDGJoguoFMp7f6hkN53meLASyUrG1B5McQxp8	1602	1123	429	12463	15444	jwtNYVjwe9uE42H9Pe8BwNMB8yZbfy8QiM7dR8zg5fkdXnDMRC1	11464	16454	16454	1618900962235	orphaned
22949	3NKABgHskPVSs2xfVghkpEqtD8qhNniZMYit4G7as6rPfUhX5WSc	22945	3NLGyXv6nCEYg75W4cJV585iHTvtXgEmXeuZrjpdLJpwXSyaH6H8	1513	1379	429	12463	15002	jxsxo1HpD2hqEhG854V3p3ohuf32HYUYYamEqNP9xbEj4GcqYTM	11466	16137	16137	1618843860000	orphaned
22965	3NLBfsT59zB298CCda8GJ6tnvzrxT7Z5jwmGvqjj6L6wZrHmKQtw	22960	3NKQ6qDE2SFi48TUujpTTeE5VAjSbgTRrF1qE8DbWpvkcxJ5ui9z	1607	1348	429	12463	15016	jxUL7zHPGTAhiF7XPE4Sf7BxBd63weFMmJuyKzoBZxcg2Yv5MaX	11472	16148	16148	1618845840000	orphaned
23445	3NKQFXHohKkkkYzoewCCmzc7RSytefUe6jQ9tuvUkNDfrD4BoQj8	22975	3NKbGjCy368XpjWVKuhUg3hreK9HCXy88sR3w2ZuiA5dBE3gLYpf	1602	1123	430	12463	15446	jxvz8BXtddxW3NkFGF4izUmiftjp9FMRnckjv16QVgRwCMXbviq	11478	16454	16454	1618901003744	orphaned
23290	3NK8fNUMQ2cwX9dtwFUybSap9ZpHDG4Qfn3CLo6Ty1zq37M1zvWC	23151	3NK6tx433x3aRfbZQBHyZP7RaQ6Y4nvKZVimpzFcrQUCFiUgkYJL	633	1384	431	12463	15304	jwuq4neuDQshVPqrCdDTbf9hm2LqkZMwdb61zPtE4u88G1ovf3z	11485	16354	16354	1618882920000	orphaned
23008	3NKRuLjfzPWd5rbAmMzJAPVJyur94J86NQwXQQJFzSVTn6sWEfFP	23004	3NLkLLPgsNArsSZYwMPA4AXteiGdiRHbsFxy5NMqQ3x7VruYrDdt	1444	1381	430	12463	15052	jxrksmw8gRALQgRwgjA9urnZqhMxDGuo7tYZcM7iQmPeQU13rzB	11493	16180	16180	1618851600000	orphaned
23013	3NKw3KEKgUhdgiDcUGZSghX1ZkfTQKzHjESEEfQ9VnK2a7JxicBC	23012	3NK3fA1ZagCTTsVB5Cu48iuygNBZt4me1xxxS1skyWMvp1SdwaQd	1403	824	430	12463	15056	jxXTfKef4swLcwkZ9exxcfxncRvZH9Ekra1sitteTDHroYdwViX	11495	16183	16183	1618852140000	canonical
23028	3NLQjcs8u4DXyExTBD3WKJV4m1jYfjA6zBygGuxXzph8NZ2jAedY	23016	3NKe6ZPKqK3y9HgEBtqi7nzfLCE5GDp84ohN1PbiPkaRq1qXePfd	1407	1395	430	12463	15067	jwCLvQ9fiYYKXzZdgvTAziciTrUwSmuuDs48Ja21k4y2ux1r8VD	11497	16188	16188	1618853109385	orphaned
23027	3NKh7dvi4B5VjTavMWBoXgPWcYt9MoqWyTK2SJC1bLfTzdiaNa6v	23019	3NLcZo2k4uAiH1XqSsB7gFyuQ1jBcw9hpzYEUkXPjiNcELoAFYAt	1651	1055	431	12463	15065	jx4UFdsVzFosVDTqki3qduWei1twXqh83TUTveYeviLEdHo8LM5	11498	16188	16188	1618853040000	orphaned
23061	3NLWt7QievmsLdeR4qVDVreHfJzCnSSP49SPP61spzXfmv1U99Vh	23058	3NKSnK5Tnkk2DXVB57nLxx6fUJuqxfZ23EDzbwJeKKSMvsESL7Yw	1406	1393	432	12463	15100	jwbvd4SSy7JPBYXDfSKqD8ZFREQbZ8wzHiNRvVjUxfhCDiiKNRf	11515	16214	16214	1618857720000	orphaned
23683	3NK9kFh4EeqXw91GuqdSav9NYWSGxwioaB9MPsY6WcVeDwANcj5h	23500	3NKoedTeGXzDFeobhEKxvKd9rAditqRAKn24MTJxjZimLLedpL2L	1458	1323	432	12463	15660	jwN8driy1HEQyMGs3rXJHwrxuuzCbg3SEbf1qPaamacXpwQ1fm9	11524	16591	16591	1618925580000	orphaned
23088	3NKFDdpA3PecGpwJvSiiP6bBpLq4NKf8rMx9YdZbAkKzCSRQ5HPv	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	1651	1055	432	12463	15123	jxQxwhE51ck7Y1CNp2uihVRVkTvqvQMzWSfG33TxyhXed1yAh9p	11528	16230	16230	1618860600000	orphaned
23085	3NL1eHSGeWfPL3hQXYX6cEn5YWu8QhQKrHRMyYWxSToi7Xc3gkw5	23084	3NKSmPVGwSoSsXdtouDKbe4XDFRbaPhN4CWVQkPB2Zpu87QWhjuo	563	1113	432	12463	15122	jxMRJXeKT1g8uBD6RAY3bZh71aMJ2wL5jNaDaGBhmKqGaNAE7KW	11528	16230	16230	1618860600000	orphaned
23090	3NKeaBtVTZnanj7YA4iET2LqX1oz98Huj7CNTbvL61doPdPD28eC	23087	3NK5brhqsWUfR7wKTMkgPfJxea5mCHvQjnDgktjUJP9inv1n16NH	1637	816	432	12463	15125	jweNb4hhzPKe2GzaMDwwgBszYYhPxk1HHqbmFYDwQ5gHrZYdLaF	11529	16235	16235	1618861500000	canonical
23136	3NLLW4rnhqupr8VEXp4XRTph5aUkjYSiM4cA8u56J6QDiGR13GZs	23099	3NK7LJVi1zydRiHZu3mfYdhuGy6VXoAoYpMzf8yVsDdsGzxF2yuP	1444	1381	433	12463	15166	jwaBWzoi8A8nFGESQJ3fe1JbALPyhJbbMkhUJ7uo97yAeah1JsX	11536	16266	16266	1618867080000	orphaned
23119	3NLDnUzCXwAddvqqGXnSm8jcGP2iPQzscfrrRPr82p4SFPPZwZqc	23116	3NL7kNoSJcNgcuseqNXRcEf4xBbhxW6hT6aFvpF2ZoMSbNrhDF4D	1633	1024	433	12463	15152	jwhsq9q98XPgt3UVJzyxTt1hRd8WfHLBCjn4be7zmj9Kfd2Zm5z	11547	16258	16258	1618865640000	orphaned
23131	3NLFf2AZieSkHJE2HbHzo5NfaaDsYH2NfQsHPinJJoDo1bN4VnfY	23126	3NKsCHaPt9hzwaCCzRBkMwo8wzjpxGXsqywW1BbFbbvtHHN9oSGQ	1652	1189	433	12463	15163	jxBk7cmhSyQJQsHWCNPcgivyqBtxi7WKh3Km8aG2QX7EhGYMGpV	11552	16264	16264	1618866720000	orphaned
23535	3NKnkT6Rqa5KynzGGxPgZ2oQH9T7JBrHT3VjbzFz76r1zLtsQk7i	23479	3NKYGYGeyxnW3X9zBfEiPRVbvT529FQbuLhBW6iGbF4N6WEVfWN7	1581	778	433	12463	15528	jwY2JqTTC8wwC7RspFdLDgCWijzwmzJ2sWrXxGcxzTYQuJssZ39	11553	16505	16505	1618910100000	orphaned
23607	3NKzF5vDdmRLDSAqTpp6kwwjUn85ooefJt841kVfKtRJc1ZboNSA	23535	3NKnkT6Rqa5KynzGGxPgZ2oQH9T7JBrHT3VjbzFz76r1zLtsQk7i	1581	777	433	12463	15596	jx3QxfehBVCtYovfBcd55CK3X7SqQqx99yPnjPWGs5NWgXwYf9Q	11554	16545	16545	1618917300000	orphaned
23140	3NLxERtJ74zM4TtakXKAYRwRgCSLJn9sJJxhmDorqZVE5XjG1X6u	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	1406	1393	434	12463	15170	jxUN3MmVxQnLzZU32rNF3KghQFEDPhsVaoKiPqrWxcYQoKwxVvH	11555	16270	16270	1618867800000	orphaned
23141	3NLYCFMYMpqX45PizhC4iiXfELn9NTVWPUMzPwo7esQFgG4GvJhh	23138	3NLmnzegamvrGy4HzEPqrsKwbWVF28L3kzbG3G6zAiVyxrEayiL8	1651	1055	434	12463	15171	jwDGq2EqPTDK6iy9sZt1qaThzxTZyLtZPWaNxQv8MJkx6vQFS5J	11555	16270	16270	1618867800000	orphaned
23745	3NLbHFrVDxzZtT5SDuEUgYjNgNuerygbcQXve3GwMsEmSmwSCDh5	23721	3NK9j7RgRBo6GYLCmxtqDBuEoQYg4fxr2o9xg6f8mDZMxZSAr6cM	1581	778	433	12463	15714	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11559	16648	16648	1618935840000	orphaned
23768	3NL3xHsWghLGPfkr4L8xrBhn4mvnJSAUsdQ7DG274xgA63ZMqmjT	23745	3NLbHFrVDxzZtT5SDuEUgYjNgNuerygbcQXve3GwMsEmSmwSCDh5	1581	778	433	12463	15736	jxi5bjsoMXRmo8REXfSHP6PdpoTTkMZjVhmDBxgPGCxk8NGgrMF	11560	16660	16660	1618938000000	orphaned
23157	3NKkHVJu8oqqBdaoWjfYFN7wMftL5e7kMAFsH8YuJTi1yDyJA8xL	23153	3NLJUh81dw1Hc4oN2poXqmeBWxyt9rfG8zDCqRbGYLpQdY6V4A8f	1633	1144	434	12463	15184	jxNCou88fyMcYkzNtGMZgjAqADXfTpJskmorUVhGuqTTvjf5wfW	11563	16280	16280	1618869600000	orphaned
23168	3NKeqdT67gTpArop9bNCVNpV8TAn3bvZVqbdGx9vPKcfa3NqnyTs	23165	3NLi5xiA9x7UBhxnR2BQNZGeY5QMXxEzcfBsYgWJywwjFUtJwnvd	42	1115	434	12463	15194	jxH6xmFajAZ38FCbYce3z8nBWErwmxFTcBtMRkQYLeN1babJkQ2	11568	16288	16288	1618871040000	orphaned
23222	3NLAoS6LLZUUahhAWTu1ZWT37ZbdXphyXhJXacNqBUyU3BEiKoUD	23164	3NKjMZ7A9EDqepQMk6ZNzjbvbJcG94oHKNzDUAno5FYbrxC31giB	576	1355	434	12463	15243	jwPWsKq6r9C1rR6HRdBZhBrfHgagfBuKZdXizcykK5GpnjmmyYB	11568	16317	16317	1618876260000	orphaned
23312	3NLtGAzZza3mcw8ggcvzs55xQczCjd8CysW6VG6qmNfA8Gkj3Cpe	23222	3NLAoS6LLZUUahhAWTu1ZWT37ZbdXphyXhJXacNqBUyU3BEiKoUD	576	1355	435	12463	15324	jwJc2WhyudQwD2bqtKpuiu3rSFnHbMNTXHz7AJi6LgPXQ8qvXHP	11569	16371	16371	1618885980000	orphaned
23197	3NLP2G4mGMnALzgrbupSC1QDXRGEbqfC1qXZBz3BfNA28AZhCZ4v	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1483	49	435	12463	15219	jxmxaWJPmBBRzcE8Ddr71f3pqJxpNreQZSus1tQ75AyzdE3aWuK	11579	16305	16305	1618874100000	orphaned
23196	3NLHvPjC5g9mmD9h3bo3KKkoq25nbrUWZxDJGfGypJQmQaskgovC	23190	3NLXH3KmNBoUxJuwWg8PSRbkZRYwu6jCNTFAUSkLPxCwWS88ENK5	1483	49	435	12463	15219	jxisYh4xh6FEMYGh5uqziutFPxv1fGtrJwNmEApM6SLxvcDfyvF	11579	16305	16305	1618874100000	orphaned
23210	3NLK1Vy9T8ApTDgGh1zdFRFwaitUcC1bnYtWKf16dS4EfKfckVCq	23203	3NLThUALqnHUxT1RVm1t75NusTAhWh13yChSh4eLAERRECP3cfyc	1673	1368	435	12463	15232	jwGcgfwbGynb1XS3qCYbFmNQTYnUPTkB5auiVZHHmh9gXz8htKP	11585	16312	16312	1618875360000	orphaned
23227	3NLNzF9co3NfP9Eu2G8VT2xCGo2k3AZc1Sp4w1Dx1cw1ZKHSPXtt	23221	3NLDBfPEd7Qb5N69xj4NcMukZMBYvKZAUj3rF8RTXZFcdosqu9ei	58	1281	435	12463	15248	jwwHmgPDaUk2Q7bAFdjACTs2U2hYUnF97X3Q3Q3A3Vacj3wtWK1	11591	16319	16319	1618876620000	orphaned
23252	3NKqQTjC2KSoHkyk1zNZrmHEUZhjwmy3VUWiPPo6ab7SpxP8eQV2	23246	3NLqLsbKAoShRKPUpLoi179RNmZ6vNCExVLszj12MwBTFbskRQwP	1455	1206	436	12463	15271	jxp82Y6N4H5fbskPrRiSLjNGpKLRNZbRuoD1JJTwCBmxEUUTkCc	11601	16330	16330	1618878600000	orphaned
23268	3NKp553FRhWY3gepGyxbLhnuGaVEy2nrSGaoqA7HsTQgRi4NYNCZ	23263	3NKAhbHoSJXQNpRVNjccnMr5r8BhzST8Rg3vrSgw2iWotYQ64EG8	1406	1393	436	12463	15285	jxhvmGdUjqfSRpxh5eLHadAp5LbTFMfRJBAqQ6pRvqes7AyogtN	11609	16338	16338	1618880040000	orphaned
23285	3NLf8QYgWzCdPqFMriCbXKxfCr8bL1Q1VyHxi4AGSNHMXXhFaMoe	23283	3NLPvCEGGd2ggHP6PHtUYhunzBMgkPKXongmJaH5U8CQ49hi4ha5	1529	1316	436	12463	15300	jwwppZgxWeVAd9Lkd9bWfXmnkoBYzRzUf8SoHhaEAtGvs6dxCsY	11618	16352	16352	1618882560000	canonical
23303	3NKMaSEsxAJGW9sH6ReUR2JdfatvfXFDdYDrQWtmvAXyv6zXBuXV	23301	3NLcv4QyNJrZgHAoNbS49Qcq218KYyf3EEHXw2gyo183qoxRAgyW	1460	483	437	12463	15317	jw79LsoUMNi9YQpqx4Jm9PwqM2AX8qjD6ze8pnSvogEWdwaUSCF	11629	16366	16366	1618885080000	orphaned
23853	3NLswdMWmC8ovv32aeNYKHoEoyAo85NDT8PNzFBMtf42k4MSgqyh	23311	3NKttqw356xNngj9n4yPr2yS89Q6Vwoqf4qYhErSxv1joyKz1dbb	1513	1253	437	12463	15809	jwP7JZHzL5qT7iadcrN17F5NbXAYJ6zChnD2CeFbgqybh6Lshws	11634	16710	16710	1618947000000	orphaned
23319	3NLh8LebVgzycGpjb6hntmdpnRfeHQP4Hfcabsq3JcvZSQQw99Xm	23318	3NKGUayTsvAEQWR5P1GGx4w5Nsy8LNYnKDkRLRHPg3XiKLaX6J4R	1403	824	437	12463	15331	jxXRU7mgPJmthKjySMGcLmPFcnofaa7j7wYnf5rp4jaLpQbJTZo	11637	16378	16378	1618887240000	canonical
23342	3NKNSDiQUPNb62Gih9opa7UcKfxGGdfLe6DeJHtHLphibV6AYSPK	23339	3NKVHQPw1iNxYK9oyqJ9JZcKztWJfajDsVkJ2TXyCj7gA5gcncsD	1637	816	437	12463	15354	jwkcV35TViVycqJLuLvtkPGMiGdkUq3oJMLEmoevSnNQaQPN7KD	11647	16390	16390	1618889400000	orphaned
23360	3NKzPDMao83A8uzrLSCpmagnWEGJdqhXESy4zgbSAZiLudoKcWWZ	23357	3NLkqQJYpvhVyjzeVEMzTspxa7qmtcR9o8im3Wa9rd3W82g6buo6	1617	1042	437	12463	15372	jxrpYn8KgmFQpYHh2eA18eWh5cAe57BkR5s5ArqZQLGcrmLadju	11656	16402	16402	1618891560000	orphaned
23382	3NKjxfMEpqP9Rw3c4aPViLVPU8KTw8ybwcrjXskW5nRcrsGqUyPJ	23380	3NKLknE9qRaR5mQ3ePniwf1dqGZN9DK8NT7nYoCPwRhLAywfHUYt	1406	1393	438	12463	15390	jwRQ2Ecv4Ub64GeKhCFmx5asLMwNrCoGZy9uKvgz2bsBfejyoCV	11667	16417	16417	1618894260000	orphaned
23386	3NKBANQK4C4nMxsx477wdK1kZYtgYj4BT6FFX12cgMbfPBJBBdUe	23384	3NLjNLSLBCpRo8G8dnjsxMZCezrQ6UrqKwzJz8idt2EQyTSUYZPk	311	1307	438	12463	15394	jwiHKtYa8h7DWCVvNoh9PtYCToGkuo9zyYRHcGSt8TxmHK6BUsf	11669	16420	16420	1618894800000	orphaned
23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	23385	3NLsWf2q1uD1ULTxPuRr3xeBmNp9hqcK2cATYg7mCZR8H5oK7GDK	1407	1395	438	12463	15398	jxNWzb6XeLpvu8gNhwxf3iM5s6UhJmox7Etzf4GjoKvsyVraBkF	11670	16425	16425	1618895700000	canonical
23396	3NLG4qWaAgeMXyqSqnhpRKC6isb2yQe7gjbigSr4r5zbTbwNRU1e	23390	3NKqkXd9YMac84sz1Mj3N6Wm72GeMze9tN4bwwcAQ8CZ9HCdR1c2	1483	893	438	12463	15403	jxZmtHMrYwyDK8CjEy2znUUR4KnDU2toEZ7XKi5z2C1mJF73aDE	11671	16427	16427	1618896060000	orphaned
23416	3NKUagUSNesemRChmmiwL7vr51sVG3w4tVGz77Nm3DH4ppGnF98V	23393	3NKXsNydThGNcAmJGoPsaheTZ6jWRnVxytjkK2KRuEV9HGD9kvJj	1457	1265	438	12463	15422	jxkks1ijbyvPoM1W7LDfezrkrshnyzWUTo8f6gPmdPhjrkM6ATJ	11672	16443	16443	1618898940000	orphaned
23847	3NLwZbkTYZsZN2tGhFzN2dgXM8wZL2XJirvDP8HupLYvKZ1qn3yo	23416	3NKUagUSNesemRChmmiwL7vr51sVG3w4tVGz77Nm3DH4ppGnF98V	1457	1145	438	12463	15803	jxiVrARCC8J9o3pyP87pysnZ2E4QBmpSXJZwC7hhj7ke32Bejho	11673	16704	16704	1618945920000	orphaned
24015	3NLYDjGM6CHSgHmH8kHWk96ja63YjZHpivgvbe1sJ2i7oAgG5Xcr	23409	3NL3CEHP4z85gbXdrzy4mYgqC5ngjrEGBtCyW2MrVzQHisAVvpKu	1534	67	438	12463	15953	jwApZJGH4aL16esxeUS9B6amRseUsAWuzALNZJAJkx3JN2y61PK	11680	16814	16814	1618965720000	orphaned
23425	3NLEDaH1sVcpL9GohPVSSxoMCWfckFhQo3UZDQzikK15k8DJ2rnN	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1445	1290	439	12463	15428	jxm3LgBh5n88ZNF3oXfMmoxT3YrTjpy5Y6Q6e4AEZVReXdUNacy	11687	16450	16450	1618900200000	orphaned
24016	3NKm2xaZ6XEgqmBKTg6tXnEJg2eXW7cvVeTqKkp187jHujoBnpcE	23422	3NLwZHGdQF4fsCZdMsZEGFWVVyLdrt5KQLds11C3wfkCaWaKB2jH	1534	67	439	12463	15954	jwhfqkFok1vyvuE7tpgAT8Yp7gBxmzog91G3HowJ9mxXaKAgfBa	11687	16814	16814	1618965794366	orphaned
23427	3NKgdL8NHUgSZJrYXxgPMnc7WBywDx69k32dydXfPeyCVpmEhR6t	23426	3NKPTrmyHknVvXejNZhrYLjotq9LbLD6ctpUkuJ1uHbZUm6k7NrN	1624	1334	439	12463	15430	jwuNRa6HdiQDFJ6ktLrEngop9kPc8NKyHabo3kG2qihnv1pD5wc	11688	16451	16451	1618900380000	canonical
23434	3NL7DQezmX5YbppZYDfeXTvaUW4FqTh2MbSxZpGLpH13xPsh6n4u	23429	3NLfjSD27PcGMGvLS3XgKx8ppArAtFU3xB77rG2zCaoFCxWnVwwL	1406	1393	439	12463	15436	jwk3WeZjGAefkZg2r8rwTLFnrkpYiTumaTLiSosgFZmyKTxiffW	11690	16453	16453	1618900740000	orphaned
23436	3NLUXVcRJWi8XGpqi6uHC3XHBXVyJASwLtNcRYr1yXWnPnZ8KNYb	23428	3NKXHLHZb3cpFkfNEyjXsdfHcKetfAS5D82GwKDuaS4Pm2Rwa38T	1541	1298	439	12463	15438	jwym5BtJtcdukiESf5uowZUM2J4F5PMVL5jP12VAJbyNCwXWmnX	11690	16453	16453	1618900740000	orphaned
23461	3NLJN9n3rYtmruvyU6D5cHAYhdpREX7BxQoSPcZvgQ6Ms5G5wa1k	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1444	1015	439	12463	15461	jwehYpHZ35G5pDjSbGwQrocd7cKZd41KyLQsWLHaFZABvkwTdd7	11697	16460	16460	1618902000000	orphaned
23459	3NLQJagNo1ouVjCoAVJ6pHpqsTpNTNeN9XRxBpMVGCd8toXwZmwz	23455	3NKmRKFK95sycHfW88tnK7Ea7nnj9183HtysWu6PgyhdPBzzAxHx	1440	1011	439	12463	15459	jxUF5Z7nNfWA5MiigybqM9WCdrAzWvxTaTGWtBa9PWJYLZt7hHK	11697	16460	16460	1618902000000	orphaned
23626	3NKiCqdJAh2AKWdzrkkZutSXUj8tk6ncJLUu1EzXH3avt3KADd8q	23468	3NLboa3WzjLSf9QknCne7nbDu3fCsCvVXtXzvn69dsM5JAT5spjE	1673	1242	439	12463	15612	jx9iZej7N3orJf5VkqKv5NSCxqsXsGLvA1igQpjj1hCACuabf3R	11702	16558	16558	1618919640000	orphaned
23506	3NKzstpqBdza89HaGRvTPjxXeGbENXghWzib9QmcEZkZnRS6waAp	23503	3NKjy9VVr1pen31i9tsVTsmAhnDqNyJVG6QMvdhAmS1GxUDNqmBP	1623	830	440	12463	15504	jwGL5j5nuPQSKphpK9apbZp86FBrGdryWpPoRHPapx1ggZ6mS8B	11717	16487	16487	1618906860000	orphaned
23517	3NLdGpvmGH89tBsEZhZ55yE5ym6Jq685LXoQVQVBhCJSLnZJELba	23516	3NLqPDMZujETmkTgTb1XkAmBWw1D24AJrH3yDSarVnvEBqWFJq2H	1447	1345	440	12463	15512	jwY1g24KGFvF8og5yhH4wznQBu8wzgSnC2LBmkjEkMgD2j6sVWi	11722	16492	16492	1618907760000	orphaned
23520	3NL8MDkmWLTVf7SXizYdF97bxghLpQcSeKp2JczqdyxpTz5pQjto	23518	3NKC2SHtH2cbGoBV53e7EeUzcBr1PmdmUU7hvrM9sZcHDE9LP2rM	1406	1393	440	12463	15514	jwmetMVtYQGZYkvD4nWvkTNcALEqwPqkD7d68ZsTzUn1Tzq7Avx	11723	16493	16493	1618907940000	canonical
23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	23536	3NLH1LrqC5KQW9vheBaf1DCA4vfpmMge4upaWQERtK31csSENnpP	1403	782	441	12463	15531	jy2AHkqgUJyM6Z45Ny5QGZL6YBtvV6JGgYnXcG5j8h5XDDCrhx8	11733	16509	16509	1618910820000	canonical
23542	3NKpKY7tyc2Yaz4NcNZhEy8ZcBxJYpkdES7WKUq2MH15bjZH1quz	23538	3NLxo89pVzKhsVfyiPYsuLLia3aktRsh5sFnnKJMPM4nzFcit2yB	632	1016	441	12463	15535	jxAFasWCxTyturDdoioLPYZDvAJGnoq9TVhcJbpHbzrkAzREG28	11734	16510	16510	1618911000000	orphaned
23547	3NKqwEPovKAKYKAiEGutpmBD4bb5AdU1YvjPbyCzAydTUDdxgmQv	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	43	1310	441	12463	15540	jxEVwsfvB5qjsZP69DUbKcQPxuTeLSPUvgBwURW8aqH1CXVUT8j	11738	16514	16514	1618911720000	canonical
23546	3NKwjcP6Xda3hhPStVG7Q7PJo2jgR3H7g3iBhZ7idfKMreEszXS1	23545	3NKePpyGpJHofBfAoqnJtQN1ifaX5BfBZuLa7JSsuHw8aUujgWCQ	1439	1279	441	12463	15539	jxX41qpGfJidbLLExxghsNPra5WM8C27ZqKuC1pHfXRXpFQqMtk	11738	16514	16514	1618911720000	orphaned
23570	3NLt9YgHoRvWzsz6dddTD2M7nZEkhAb3WUyQgMSztKvKgiMsxHWs	23567	3NKRktaSiWeNzYbt4qa9NUFDpM1pTq4g6e9g7cJLwnuyjSGFHM4z	563	1359	442	12463	15562	jxYayFXuaGf7fDTkF1FRnQSTqfdZJQEsUEYL39ghM1d8SQDzt86	11746	16527	16527	1618914060000	orphaned
24040	3NKuaoBZJrPGPoRZaXHyXjSE244cVPFPbY1MuKizNHsiCk2opgAb	23916	3NKy8yYtkyVKP5oTVzCiMKjmpLzduVZ1SASnQtrbDPhbYGyh86mM	1455	1086	444	12463	15975	jxXjBxwCa1mSvCfEtyhqa39VMxzS56PuzcR36tfHe4S11Be55Wh	11756	16828	16828	1618968240000	orphaned
24116	3NKmMVV5PiYejRbkeVNbGS6832rYWdsybYHZWv9HVSQvyC43UVE2	24040	3NKuaoBZJrPGPoRZaXHyXjSE244cVPFPbY1MuKizNHsiCk2opgAb	1455	1086	444	12463	16041	jxXjBxwCa1mSvCfEtyhqa39VMxzS56PuzcR36tfHe4S11Be55Wh	11757	16887	16887	1618978860000	orphaned
23601	3NKZfsGZFbhFZCKfpVwTmPjHRbZ3B2KvQtRMZqD4NRawctGkzme3	23599	3NKPDLxw7CJ1QCNH1LY6djDqncsQQzJ3n1gMMTTLtyZcznt5XWTW	149	1037	442	12463	15590	jxPYMbqEdwToGWUubb7egQjcyVMjDpzzYKE3f3CeTbDudcG235H	11759	16543	16543	1618916940000	orphaned
23608	3NKLBFEb9ywWV2NdrnRgTChARmnNih4YQtXE3i4sCzZ8G3MR27af	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1637	816	442	12463	15597	jwiaKv8NsWM3QdYt6pWoLHZ1T3nDGyc6S8YQPfFrLHjgBTZLxBi	11761	16545	16545	1618917300000	orphaned
23609	3NKfyDsiXvh6uT5CiMg55ce1e4ZCiLP5KUnyHnFet5yQwopDtSRf	23602	3NLEqdig8i4CV9Ps3A1jzScjibeMjCFaPUaEuvWisyijxQCNy24o	1406	1393	442	12463	15598	jxz1CzQWB7MtvNDFh2siao8Dtyz6gVXSojYCQbo5vFpzF2sAuSM	11761	16545	16545	1618917300000	orphaned
23637	3NL5N63yCqvVDswFbukz9aaEXfg8Pz27cp8VV9ezERoa3RTCRsM8	23634	3NKkEUo8Jr7Nm4rm6NPFexLqHJKxq3JxsoWyjfPL9Efua3xzie2H	1552	513	443	12463	15622	jwpjZjiPgMavyFyBEoE2Bc9DAta92v19cKnH68BqRBFirVubdDL	11775	16567	16567	1618921262872	orphaned
23640	3NKvLJMvtXYnMTo2TqZUmT3G2UHmeHsXgbVJaNB1eHMz6iuHemMW	23636	3NKFT7aVf3YdYVFJgFYTx3K5UULonkzu5FSJps5CSsZBE4D9VBRR	1633	1144	443	12463	15625	jxsrWffuP4aTDL4RP4vdmKJSKKMRHfCpTovgzg8zEMcMiCg286W	11776	16570	16570	1618921800000	canonical
23660	3NLUoUsvjqm7yEDiryyGCHMnSK9Gs68pc7SmNyS5ePmJiQ9E1esw	23658	3NLaSahRJLXn9Hk2abMX7JNFDhorjKhCV2ZzxCS9Hc4SuWQoVY7M	1670	1282	444	12463	15642	jxiWaLVPJHxrpTdEz7yYgoKTJ8gS3pyvqEMQiLW7LjCatHHtJck	11785	16582	16582	1618923960000	orphaned
23665	3NLnWuMRMyrijy4bFkAT6oNfyu3antm3yTDsQkfrWi2hPgws2UHW	23661	3NLULYxRzQwDaNtb47EEZRCvgpcGjSf9JLypdSZu2v3a5y9iFzb5	1481	790	444	12463	15646	jw7k5mWa96SeZuChQX6xPa1ZroV1pLdgzsuUQ6xBcw9eJN23BvK	11786	16583	16583	1618924140000	canonical
23964	3NLNnVSpgJKM3SYx8gx4mNf2HZGwrraNUpSETaY946kJa1KtVckT	23762	3NLbVtxr3VhXq7WVXXmekERndMRq4nJQvtydzMneJ8ugkbtMPsUS	1593	1346	445	12463	15906	jwYWJC1zN58Ejq5tzgzByBdSaHeBgeRyHmb7RhqiEHhbzRTcoRL	11786	16785	16785	1618960500000	orphaned
24144	3NLGWYPqK94zsvtKjRTZj6taKdZ6HyL2BbMr4coUfe18CTkAW6Qc	23964	3NLNnVSpgJKM3SYx8gx4mNf2HZGwrraNUpSETaY946kJa1KtVckT	1593	980	446	12463	16064	jwHoEybQ4u3on5pDsqGUYCfiFZmohjML118umPBVyKQax5XU4uf	11787	16913	16913	1618983540000	orphaned
24210	3NLEoHFo3FgQWnmEY2HwG8w9VMqzkZodhNYBbP3oKjmuaZjU1Sdc	24144	3NLGWYPqK94zsvtKjRTZj6taKdZ6HyL2BbMr4coUfe18CTkAW6Qc	1593	1220	446	12463	16126	jwHoEybQ4u3on5pDsqGUYCfiFZmohjML118umPBVyKQax5XU4uf	11788	16957	16957	1618991460000	orphaned
23674	3NKgjVC5dqTXpfXWtdP8SEYWcniTAKc5XatYmPBUGQYQ2fmTazdz	23669	3NLoLv6CUCQViWoNFPK8jgTATa8L7W71K16DRq6TqzNbpuUGr9Dh	1651	1175	444	12463	15653	jxLQDtn7anQp7fpdqJtQGmTm9RBQu5aF8G7iwrMWGtMWimtiHWy	11789	16587	16587	1618924860000	orphaned
24281	3NKANUaJsnbR4UZCtscTrEQ6SuDVR4vpxEhoQrD8D4qmvGCYgLvU	23678	3NKvKnnGrQGnEmzTfuzcWGQn7CPboG35APbHjydXBDmUcT47DTmY	1405	849	444	12463	16193	jwxGcknURL1RNay7epMTY2RJxEvUSF6nXMvzBSe6p2jjfm3VPyd	11792	16995	16995	1618998300000	orphaned
24283	3NLYScMQMW6ZGFjwh2jMjnFRxeNq4kVdSzi2qobFxGmXkGgvYk58	23682	3NLUB8h6X4XdmmZkyDgxmbec4G3PZ4zCMUB2ixc1D175FbEM5fgE	1405	849	444	12463	16195	jxs5C3uyrWztw6voeGG2qv9rsxCqVNmEptYW9rHzx81pXWQL1UK	11793	16995	16995	1618998333356	orphaned
23697	3NLvt1GYjLyokBhv9b1qSpHY9HdeCefvr5etMxJpdpqA1fjwfUJu	23691	3NLSjCX31kXfgFAQD9qfxshDHkrvnLxGAHjwjDDP5wXNEzRAyrSV	1471	1140	444	12463	15672	jwkTiJHq2NRj4H1BswdGugqiDgHqNcZVQsSNBQZrjugxeTGCUKF	11801	16603	16603	1618927740000	orphaned
23702	3NKrSHRUmzivSUeobRokELk9sr1HqcRvPYUduauRoM1B76RVytML	23701	3NK6cWL7Y8du635TvGBxXQBwchgu3EfSaQNQEuFoZnSvCxyqFxhn	1407	1395	445	12463	15676	jx2AGN9dafuDNtc5DoXZpPQZxs1CbexQEFqwCkRb7cPCjqyFWAR	11804	16609	16609	1618928820000	canonical
23722	3NKd9zQXQAbHtDSF8qVhLTttL9uJkqDXpNbLcAWD5T7LPqYYowbp	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	43	1310	445	12463	15692	jxrgeAa2CvsEDu1cbpXWnkcVQ5k9nT9cutFhZ76qL7ALGhos6xE	11814	16622	16622	1618931160000	orphaned
23877	3NLDKJxTruxY9CeA56urH9av5xdDPXN7odw2JLxzWMyMyacmvJw3	23719	3NLTENRGm72kFLcwrDxHKiB6zDPz9wyPmdMTNU3qzJYaFKoC9BxA	632	1256	445	12463	15830	jxxxe9JrmT7tQJBJpP2yA2d6rH1u6YtuUHc98MZnswetiDEJLg5	11814	16726	16726	1618949880000	orphaned
23739	3NKbe9kKcX2P8EfqH9B1UAYZiDRFp6vTXtDbDRcFK7UpDijJ2Rf3	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	369	1312	446	12463	15709	jxbAKwRK7wv6bHzJMLr9oehFtZPFSj5qR9TrV7PgKMWnwDKiJuH	11824	16639	16639	1618934220000	orphaned
23742	3NLjTYjvQs4ZLdLNJDHTagUzneW6uB1JiriMho2VWVjtfFuo5wbw	23735	3NL6bAKtQ5KPFJaVxGiiEMGHAuki2xibnwMj4ZdHrvYNrAWzTfsM	1448	1311	446	12463	15710	jwNhQBA4MyiAhy4eFh3MTfUpQp9K2Ng7CfwzuXQbVY1g54HSRV7	11824	16639	16639	1618934220000	orphaned
23760	3NK6n6XMGMoKAQetyzbwUvaPUp43tm3XYyAoCxuU8LJFyrb1pX6S	23758	3NKnBCoZcwPm2NFeVMjY7xuRAZSKDysUoTqSqi1vzscFjysU14B4	1593	1346	446	12463	15729	jxTa8j6JErMx5CWn3z5BzZQ3KerDFAJP2RvgHZbif9oMgYG1TUA	11832	16655	16655	1618937100000	orphaned
23786	3NKqUCHcLLiWDGYosHV73b8gfaXWGoRUSueVKtqbTL1o8d6sSJ9c	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1483	78	447	12463	15752	jwzTfpKgttn5jePfPas8T33AxRtXJgKDRWuFWoPcvHkfdcyKY4a	11843	16669	16669	1618939620000	orphaned
23787	3NKdo7UU6cpspMXGtn3X9d23BRSPMj3e2NY8boXncnu4JdrRoavL	23783	3NLtnXDT4gsatPoP7ng5xL7KPQSUcbPh6Es6uxYeG1EBJhGmiH8k	1675	1342	447	12463	15750	jwMhQRK7htZP8RExah6QwPhBB7XoSGcnkCab3UEUMP7aSByCJsy	11843	16669	16669	1618939620000	orphaned
23795	3NLtyw5KHiMGQJitwFAPQ6soJZozM9jiFc7VkwRZ4j9BZuEUKKJw	23789	3NLnPdBnhNmCMBVEmPBnX5bqNd7F3AzLc1YJrT5531SZ7skjKi67	1654	1214	447	12463	15757	jw76rxswoi3p89wssmW6b3wGXmEFb2qhdXqNLCKCw3PsW5pfzLg	11845	16671	16671	1618939980000	orphaned
23797	3NLLRKp6FtMh6n8C6MdFxmspLdFU1ZRWXWd1GsTNnKSTHfxqi4qD	23792	3NLuQW6nbaWWbyi9ZuukhfmtDxfNZG2vu6xH8KDRrNWti6WGECnt	1426	1364	447	12463	15759	jx49CMGPnyaZPgLuJEBT2hE5VBmLLdABfkHVvpgot3ZWdphEj1H	11846	16672	16672	1618940160000	orphaned
23832	3NKgMcaGL4imuQhv4mcX7aoP6yBbggAJqqt8NHW57zUaLRNdkWgW	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1560	1291	448	12463	15790	jx4ZPGtQZaKnggx4SqSd5nQWWtp1pcNAGA7eCmtFgS21ip3HrLJ	11862	16694	16694	1618944120000	canonical
23829	3NKfVV4PZNJkmj5iaZhuLtCfUhnCc5uK56LEeGMxJgYXtJDY7S26	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1471	1140	448	12463	15787	jxUjEcdKzwWNUcMc7pBo8hRRcBpLxfXjjY9iQ89STLs1PXeH9Wz	11862	16694	16694	1618944120000	orphaned
23833	3NLhWHii4BSjaGdnECtootZRQGtLWxjTqb4RmUEXW56jdTkjEGR3	23827	3NK9xZyJULYDaBrKjvpTS65TZhG4GAGbHxnze4vDotpvpUcDB3Vh	1637	816	448	12463	15791	jwrpof1qZFTdgjhnY2P79JAGvF4fPF6B6DHp1xgvgc7vm5WdzYi	11862	16694	16694	1618944120000	orphaned
23859	3NLUc2PS4TEPzqNLUSynEY2rDYhRVdKifXJKjA9RJnGEHYuFqhGN	23856	3NLprhtgYZq6jMMAT69n3KgkBfZgMVAtYTcJpx2J1GRHJPsBMEcx	1403	812	448	12463	15815	jxW7pVZeAT1eKmov8J7HyjcovPGkrGgpvnRyRCwH5gnzvysw5Bi	11876	16713	16713	1618947540000	orphaned
23889	3NKFP4jftzZUSU8SrJS1Ti1zHksXwEZ7S8zzFLXLr1kGroqGWw3E	23887	3NK5mYDS92cz6ZhRXAwzt6TumkGSgutnepS1HQvHDuDWbRExYnyb	633	1138	449	12463	15841	jxP88xEY9EWD8PxUK4fSvTT1K7HvGv9RQkvsdSQY4dz5a2ztKYK	11892	16741	16741	1618952580000	orphaned
23892	3NKPDXdBgb9z4q2nZ4VhLijREA7oekgoBHUexsBRU7CLCZeTUpfx	23890	3NKdEa6rAyp7DzogpVfjrduoidTrNPFwDWSec3bR1KcSeozeX5YK	1536	1313	450	12463	15843	jww71mBD1RtRarrUNg2xsbLsbgMnHHrHipi1hTgH5PRtQkjFsWw	11893	16742	16742	1618952760000	orphaned
23894	3NKrwwHV1mA4nNTXdbEDgYQnF3iQhifMKP4TTpobyD6BJyKn3mu6	23889	3NKFP4jftzZUSU8SrJS1Ti1zHksXwEZ7S8zzFLXLr1kGroqGWw3E	1559	1227	450	12463	15845	jxn8w3A9i9RoxTANpwBYmMZ1yLWm5Rico6aZWJ7xVuCRyMuffSx	11893	16742	16742	1618952760000	orphaned
24063	3NKqsfSUr2fo5S9kMXwZkPYTw5AdHKMwFrZRbcghUZ2AVc96Znqb	23993	3NLWMNJXL23rqUa1bx2MxtBP5vrsZ8NCjYxEtBj97uJXEzr3giCp	1657	1218	451	12463	15995	jw8rrqXKJPN3yhVWJ4wXCe5ze4ZJAjsPnFCmijcJwPi32Jv3yWG	11895	16844	16844	1618971120000	orphaned
23903	3NKwDbBLpNNfiBXNusVqgN9eYX5aADZ9hZYGGnVWtwqgw67J3VbJ	23898	3NKyZyZruxPBmahc4A3PjNy5Utay1sa1XJSiao8CgvCaCYDP9EDZ	1419	814	450	12463	15853	jxZuTfmnt95AvqL6g7Xsi2zNrsi8Z4ja42EubXDjUeLRCvRuzv8	11896	16745	16745	1618953300000	orphaned
24148	3NKz7LtpWk5bsrRpXyFswgNDuNum1GfLyZKEdybxTvX6A37GK8Lm	24063	3NKqsfSUr2fo5S9kMXwZkPYTw5AdHKMwFrZRbcghUZ2AVc96Znqb	1657	1344	451	12463	16068	jxucsDa3MT2Jdxrdi8qEFpD9eyJPEFWSU1q3e6VCRpAR8FPLoGW	11896	16914	16914	1618983720000	orphaned
23911	3NLvXbsxsXmiuNvEhRXDEHtC9dtmG4rmgjTwu6DzQcseJbY17g15	23907	3NLdgZcNLAQxKLf2BoMGzVwVkbAcoFu7ogFASjPmxAjcYRRFKmBU	58	1281	450	12463	15858	jwSU3jhD5ccoLfJs2FNyHJxPntP4FvaAEUn52N9Wq623FTfsAjy	11898	16747	16747	1618953660000	orphaned
23939	3NKE4J4i6oUgLutcJpqMibncM3RSjcCrgtCZEA5LfbfFJkXU3Uqd	23935	3NLR5c1LhsJjtmrnVPM5dFajsYpHuj3MdDGWynxAmWyiVwvWarnj	1471	1386	451	12463	15882	jxPEVvjxmFHcgYiM7yAUTNzety2KqyRAVxUmfSs8f9qhJgWacy2	11913	16770	16770	1618957800000	orphaned
23947	3NKXJtG3JbW7VbVZfuT2iBd9rnwNM3b1aCHHm4xDvEm6in1P8QFb	23942	3NL1Kb9Eg8VaDegJcVtYxAdLphBJnLQvQavw7HVG4EYbFUsWcDUi	1647	936	451	12463	15891	jwmYkd94iATNfEGfvxa5KPixBJ73ATMbxRVjj1H9AuyZ6hwdmbU	11915	16773	16773	1618958340000	orphaned
23949	3NKnyVNAFczjwq18keyY2swBkkLzZUu9ALe6GiMKhUHJrTbiainV	23946	3NKDK73jxJteFomSUJcyn85iimm32qktZ1gy8Ygui9fYaH2KEojS	1607	1348	451	12463	15893	jxRVESF8bwNwUZYdqsNVK7tNPwg6V7HNR1XEFvpCAggJsSCBzEk	11916	16775	16775	1618958700000	orphaned
24517	3NKKuLxyXnHR5uLheYRxNdoiXEEBdyDPkQvraHirdQjeXLLbcp8n	24245	3NKo9S1vPZYwYrJ51nuZoYNQ8pJ2M44xrcWrVqddcAqVyS9S3VCc	1500	931	451	12463	16415	jx883Zbe7ngr7B6QtB8nE7pYxtXiASnMQSCbX9W5usqGyhshKPQ	11919	17159	17159	1619027820000	orphaned
23969	3NK87DqmKJNUu8mU67pvAbApWSX3vH3imj2YJvYMyhNWz245Jqkj	23967	3NL9Pdq6VjnFAwD6yfn5CDaU1zdwEw5EZ9P4PkU99KkHt7dp26cB	1623	830	451	12463	15910	jxpTVqhDFAJhtQJ27E93C9dvGBYPSQd6UJXpoMZMXR7TrQNbLrL	11927	16788	16788	1618961040000	orphaned
23995	3NLTbim5XFPFfJ3cZMrPpsWCq7sE968cPpcwZ1u58h7B12ZWFDzD	23989	3NL4BqfCHAbTCkekfvnLnw4BshkdXhEreknNFAGNzLJHQ5USuwxB	1402	882	452	12463	15934	jwRbHG2JodLiJ5LfwxTHgFVq1wJ3VpprHE62Vh99cqLtdeDu4aq	11940	16803	16803	1618963740000	orphaned
24000	3NLiVA8aFjwQFcRmNScB6QVFpRsL2DJnmTj5JdLc892PVWZ1ks7E	23999	3NKUu3nAQae46kos7btwLSsfGRsgA1Zeh9xHQDoCmYGQphxUcVib	1406	1393	452	12463	15939	jwndSNK9WpTit7HvRH3D9EPkB3Hh5RGm13Vd51QnVQM46EVZ9uA	11944	16807	16807	1618964460000	orphaned
24036	3NKguHHErERc21iLfjvJMmL11sRKPsTSPKAY2poYtAHtdFh57J8Q	24034	3NLMWpJSYtX1r4ufuXzXZR1skPo7b8jhfSMiTdhZfQWaEWs2Qukh	1560	1045	453	12463	15971	jxii7zhcHr9wsCHeeAPgQauTHPfwZsucVYhsxiTeBP6siPuR1fd	11961	16827	16827	1618968060000	orphaned
24053	3NLVEvbAPraWfDZv8EDvgQwuMjTYPEJPhdEx3FibtvC74BXmdhtv	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1448	1065	453	12463	15985	jxgvcKB4VWXV6yimfikc1pwgYzWjXTUaSnKk7ziYN55pdSD3y2B	11969	16838	16838	1618970040000	orphaned
24054	3NKWi8yzauyAPx7H3PV8mSbFfA3Xy9a2CP54DzQwkMj53gGLfMju	24049	3NK4f596XpHcZxCpdEP75pmkndbVXCwH7p98vPknRs5uzHLm5yNz	1483	1276	453	12463	15986	jxmNsdFT4mMWPostFWRmT5UWWYc5Tvtio42QYpdr6fmhp4sw9Z3	11969	16838	16838	1618970040000	orphaned
24480	3NLTVwVcNg3ESh9TVi9kUfRNS8LTW4zvpfLkupYBtZTp76K4mS8S	24052	3NKNRJAhcEr1woRMNyW6kJPpQH7knEnvcfMoJZDFU1Fs231nnJ6r	1445	1164	453	12463	16379	jwpqrAtY6tRRDsypsovYNscyJApSossNDVE1qq3u7YJCa8jgniE	11970	17131	17131	1619022780000	orphaned
24674	3NKfG5NwZDy6xsZVnqHjLY7G995Er4ppfFM8iFA1NU3xWWTnmUCU	24057	3NLg9z8AtUMLisAi9GqvnqYBYhmabrYBABTjDZ8F4Bt1sRQJcej9	1668	1124	453	12463	16553	jwgbjnijC5vURt3svdp2bP2SRCYvFih77nfw74ncoVdWkDxR9Ke	11973	17251	17251	1619044468545	orphaned
24078	3NLfaEYqU3951WaFkHoZFEqmG88sJsroADbpKKpVPFferqTXHmM2	24077	3NKXPiyrzvW72bJpjpQEs9SDG54iFD1S2dXZFF3qxSzPLixa4wDm	1564	1092	454	12463	16009	jwBwLBGYsjuVwrQH3NXt7ygzuqTgLmhvhmVjXgJgfZMbra2DhLY	11986	16863	16863	1618974540000	canonical
24087	3NKibsLXBJTsQmjcqZgbpS1DfNYDHpEZ2Cc9Ekyzh4sU8SaE4qoY	24084	3NLyVvsYVhaYwMxYP7HZW31ZkmrefpQQxiMLLnwcXP7HR4Pg3esD	1523	1321	454	12463	16017	jwdMHmipJGKApdGe4WydfMugBc3HgGQTRnTnJELCSqqJcWbv68G	11990	16871	16871	1618975980000	orphaned
24483	3NKRBpJFNwzWPYBPUuQBaz5oyQxuMRVp6SC2PP34jTCmVbwoRprA	24093	3NLdEThok2Fn4GSpTnaqyfMQxEqEj7xBJpLAyHvbZMKm55kLpMr2	1445	1164	454	12463	16382	jxZfjyyVq9yWMuPCfHqBBJhcFAYGa3gCgeep3Smqh2nn53AD49r	11995	17131	17131	1619022893980	orphaned
24112	3NL8wqtKrjUDFqBj3n76gTCJZdPbQGphTnJ9qQJAmSzMh8MSopaK	24108	3NLJGsbZ5ycFZ8ks3JsEbH7r5zDFPLYXUnPhEUMLEgba1sN68mXi	1649	1383	454	12463	16038	jxwxC6TVhtp3hSa6r8dZkYdyVKFoWwqad9D2mftFf1TNkqbazBb	12002	16885	16885	1618978500000	orphaned
24135	3NKzYmPoQxuFjDfhcVi5UZ9pGt8U43fem4eE3p1rVjho7QiVrtVd	24133	3NLgCiK6XBZRffJk2NBm9psgpfGyEb7NXfefRnGJuLdehMiTx5Jv	42	1115	455	12463	16057	jwAE2rxuAYnWwAXn6vnM2uijbdo6Rs1mkb7z97spDx65K7AvNhw	12014	16905	16905	1618982100000	orphaned
24142	3NK3xKJFGxqQTzLMoqGcJF6H2j3hM9WVSHTJMgGsKYWZNDK29jaW	24140	3NKSzHNeUeWUEKxH57EapbNP9tLn3rQxAXgunEmdbe3bFwuQz2Wp	1593	980	455	12463	16063	jwCmCe1Hd4BNUjDMzaWXXW3tQ5xcQy8ixGR7aXZZnVZm8DZAh68	12018	16913	16913	1618983540000	canonical
24160	3NKFxQYZq1Z7eo564dcAXApEViALmrCax56Z6jkVknRpNrbERuRi	24156	3NK651rp5nP2pbuSDfXdkyt1ot3hDrvQpHxPW1Kv3vDDFco9TUxT	1637	816	455	12463	16080	jy27WCLwi4SFFGeE5LwaiaAUZL2NPu4APwDEPFkPDJ9z4LhXwaw	12025	16922	16922	1618985160000	orphaned
24557	3NLL5XTjiYWkciCuGZm5zhyYsjJccco9N39DHKcPnHExxjaBqgxG	24502	3NKmTPgiCXBxVVcS1LivruUqTZjoRmjJYNNdsqYyH36Lv2b1mfTt	1654	1214	457	12463	16454	jxRBbcA5P26ZLkXwjUpTPqCj7rg8CKX8xYVhuSCupbQmxgVa8tY	12029	17179	17179	1619031420000	orphaned
24174	3NLTaGkqYGGdTYLUHWweuMeHG6McGBvMcKWrGrt7tJ1FjX55DRVL	24173	3NKanATJqu822LsNpauJyht9ZqtNqxbFXF2DMCSrffc31nWvLCyn	1516	1294	456	12463	16093	jxk6RB5mw6ujR42coDnGi1aJeYVLyoMVXb1SaixNNwBNjtqg5i1	12033	16935	16935	1618987500000	orphaned
24189	3NKuSJrrfMimLafPrjrt6cPrL5q6RVg8Cz8pykbQZqRtoXB4cHpo	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	684	684	456	12463	16107	jwevTSDvXCE3T9K9FV6G8oNQgFWCrRc91CCk2Ui5wiJgXSn4gWy	12041	16945	16945	1618989300000	orphaned
24193	3NKZPWhkCm7UkxNrehgAFSpaHATfw4L7waFhEe9w9SawY2YwFsmZ	24186	3NKWxvMudZYTWpP6irkfSLSVmD5gaKPX5s2fZBNtBET5oZyiiFQw	1403	782	456	12463	16110	jxVDNiyQA1ieoKWWjGkSM2LcpeZ1Gz8akzSwT618m1dNRPNHtb2	12041	16945	16945	1618989300000	orphaned
24198	3NLJh2MchyWQoHC277hcF1dtQwLoYdziMSZvRuksgLXGgmTkeRHz	24197	3NLdxWV4mFRmU61n6nVDrUYviWJ1wWBUZRag247tKeM5ggppuDhw	1564	1212	456	12463	16115	jxu4HxNgpqwBetXeabiqs2NS7SQAPKjiy1UsVj1wayNQJ9E4whq	12045	16950	16950	1618990200000	canonical
24202	3NKi6Beb4ooqb8ejExRym9wp3TykF9grV4fHbJ2o1wXNmZn2oQd7	24200	3NLc3njByoRLHNFypzKXY3JmJD7WJPLcW3BTUvALKcdCiV3mfurX	1500	1297	456	12463	16119	jxnYuqtBTgBNJ65euCjwoQphWcSAkxWPdjiyotft4TTMaAVkwSx	12047	16952	16952	1618990560000	orphaned
24229	3NLwZhKAXZzQ4Dx69Ypi17DfNTNYUjVHTB2w6wXciXKaKrLgkvcg	24224	3NLvUNqeSigtijossbphEms3gqVHy23xYZymugUWHUARYya2pejc	633	1384	457	12463	16144	jwmugbGGknnUt6Aamqz4czCvAQnLZjTZyo3a7N1UjSL5CDHHRpC	12057	16964	16964	1618992720000	orphaned
24237	3NKqeNvVy1mKczabz9m7CmX4bL9yQryrh7rtMNm8N5rwej39w6Bb	24236	3NLEHw6RtekKqG6Yhi871FhWQRfdz3iQSqEte5QCSzZJWdupmQMH	1607	1102	457	12463	16152	jwBEp2asxN2hQ97SRVF71G8aNxNjFufAXJuFcZGJLw94bvxfkYT	12061	16968	16968	1618993440000	canonical
24243	3NKTASL93SVTjfYFJJK9eS8gbLX7Eeq1Ss4hPEVwzLBrwBHNwt61	24238	3NL9KKp8m9ZZiVnGDESt6BAsDY1Fjowxoy1CpthXg7g1tER5Sr19	1419	814	457	12463	16157	jwFhqPduUBKeUeUYRiB6oJK7YwX3hNQ697UtTN8vpTwucRbTh52	12063	16970	16970	1618993800000	orphaned
24421	3NK8WqYpjEcnYPbX1ZVbGn9RPbdeKPjKv5y7U35MZyvWCuy7kcWw	24267	3NLwtZdtNMhnswVvGRUpYLdqF621jA9bHPzpDfKyZaszeyxoPq5Y	1559	1107	458	12463	16322	jwejf8igjWfQYpZyKqUxe8z6eymQbgibMUkKs85RUkRuDQM897x	12075	17091	17091	1619015580000	orphaned
24279	3NLUERTEWzfL3trroQPeXjuCqtuRcn3M3LmUGuRmtqALZmpRFdym	24275	3NKBYRoL8GAxgZg8S5GRZdX7E3RhWXHhRSLek2ZQFFctuY25Sxki	1403	824	458	12463	16191	jxWNgbLaFbcG3EJt4ZuZdufHJRvybpcj77UdjiVHZAoGRAc2euY	12078	16994	16994	1618998120000	orphaned
24282	3NLXTnAxVrWyFH25kjFrQ3cqSqbcwoqMU4ZAUTJxxzypcTeeZPcc	24280	3NKUNJFdFF8CZ4vSC5W39PhES8RiYi2V7SFsdkxxZvE31dYgmR3p	1670	1282	458	12463	16194	jwJiSyAPgE2hDAmogSjisLG8enNdyoPYwpudZLLmCWKb4EQPPct	12079	16995	16995	1618998300000	canonical
24296	3NKj7caFj5tvoRPNv9kwCbMcnMqhJLeqTY2wQ3NNDHuaEchAK8gH	24293	3NKXjF9uVs1iAfD9w2VDXyG258zciH6xKooRnPb7JyyPsMPFsGtN	1648	918	458	12463	16207	jwKNyPAwx6MdhGPcWTawwXNP2wvAhWgGZcDP7qmoP7kg3ungSKU	12083	17001	17001	1618999380000	orphaned
24308	3NLcf5QtG5kHhrYTTz5WUPohwJjuupSPyMJ2MvuDfUTgbi8KKcba	24301	3NKdPRHYUUxSEicCMihYv8daVcDrYNCMq1CebpLv2bssZMpiEbSj	1668	1244	458	12463	16216	jxTuLMmQaHgtMiPYU4qmWT88r2FwE5sgAbpv38gwfxP6dKzFDXA	12087	17007	17007	1619000460000	orphaned
24313	3NKpdH2k74zqKSNAjeG1P2goqFALnvqWYWmTSzYtKnHS3xaaNH1U	24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	1573	1318	459	12463	16222	jxcc4DXaSReiEQzQVrCLLyJvPRDj9HwCBBEieNLJFGV19QqBbK3	12090	17012	17012	1619001360000	canonical
24546	3NLx16gR7vtnsnpKisqn4se2q3NcC5fJSfk32J1sm1v5h3uQpDwE	24310	3NKvSqGqRBEqsUHBz7zyZNL7i942S7aCFv4SfnELEBWnePovFv8e	1571	1089	459	12463	16443	jxnsbc5anYR6D5R5xA4E3aCr43QCqEoQMCuabPzPHsx4d2ZqUhQ	12090	17174	17174	1619030627108	orphaned
24371	3NLHLMkkHJuHmKCJZLrbBRnMh1QfE1c6hmNjY147fbEEQ7i7SMVW	24321	3NLcN6yp1pB4ML9F8yM7ZWx9Jci7228gYvL3aevHoHwCsFmgmzn4	1602	1369	459	12463	16273	jxicdEaPEYUVVm3XuP6LwfS5aHt6HqVdAq4JzU82b6KQvtapU1S	12097	17060	17060	1619010000000	orphaned
24622	3NLrq596jawTQRk6rphqc3dqMHTWLN9iok5FFFrUccaNqeyb1BZY	24446	3NKJhM3Q8TeivAiZTKechF6zpvacnHuJUoAv15NcXNDXsVBMuyfq	563	1113	460	12463	16511	jwxH6YbeGhTdGUfDDTjReZYX2aZgFtYTWAs2wwuqz8AhjBhCk3S	12110	17227	17227	1619040060000	orphaned
24354	3NKzAxsYzzPfyKKhidLhb6qYCpdLbzh4FvbzhPyZAmnbVjcGq3ZF	24350	3NLH4GJUaiTdw2ZR5iJFRJEh2xE65PB2UqNuAtPvfhpnWgLcafMJ	1634	1331	460	12463	16257	jwH32Fzt4yE8BRTyjWeJcPiqTEmhECZJjV3WNKDHNdPz3o9gCx9	12111	17046	17046	1619007480000	orphaned
24359	3NKp8KEyauSRRS2qWvWSM4pitFz6TS9xVVreBAoEACzePDwEkye2	24356	3NKujxNF9Agq6FJ2GHRZQNhf6V3ybGG2beysVYXYncNh9VJPAhGZ	1651	1175	460	12463	16262	jxJV7nuTKS4EigTA4YKiBKJGpF2ptxJB9X2W8tVTNiNCRRW7bNd	12114	17049	17049	1619008020000	orphaned
24643	3NKkxPENcGcpPksZ3cy2ZyeaET2UMhZmGK71B8BWSQRpZV4Tjooz	24360	3NLajrrp3UNXavz9YabP6XWPkkbrwD8Sv1i48NvzQX5utBm1Jjpc	1489	1380	460	12463	16525	jwkeVndJVP1W4KAKkK9a8eprUkfaAwFkEY761tQwWQFxqfqiTyd	12115	17236	17236	1619041680000	orphaned
24364	3NKQZBmkCqdtvrQvoWqWwQipvViErMYfBhijRoZLvRPDZyeJBcUd	24362	3NKm5ZoEgBrmbCf7KjzCnPkDQQ5zzbDX5fXuXP6HwDCeqtfAjmsY	1407	1395	460	12463	16266	jxwFxs1nUjNaUxiMASbTGVR1fAv6GjTkf9DVjSx8gBBjYBh1q4Z	12116	17051	17051	1619008380000	orphaned
24939	3NLYmtwU3Jr7nHW217YxwNVe16U7qsAQkbdo4Vep5VJkTQJ5whvw	24363	3NLLWwfT8p1Avjuah1HaPrSsFYg2QADXC2pDkVSkECYwh5fcdtbs	1672	1285	460	12463	16799	jwzhzi2rc7KsxLetFgBnNmZvSWECHNVSLdEBxfXLbdGe5MWCj9i	12117	17427	17427	1619076060000	orphaned
24385	3NKwHzmwsueREgLv6bszPNNJVv1vi35CneCGcDDRfZLP9GKsLN6n	24382	3NKNfFVpH3nMMipo5fzoNN6qvn6aK65H9bwjqZ2nNt1yiVR3o3Re	1508	1021	461	12463	16287	jxE1XB72aYrVKxZYRPCc3seuoxaGbzagW4rjfho2cfuNC1eTzRK	12127	17069	17069	1619011620000	orphaned
24387	3NLxP1UmTkKmM7o48g32hqWhdgJA1LegASqPzgC8ieyrP8T5oN1X	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1549	996	461	12463	16288	jwyYNXJSUBxvTZ7c8jxCDocJPYRq2tDLLVUdi5o4j64jFyEQFQZ	12128	17070	17070	1619011800000	orphaned
24392	3NLdhhcDYCRzExVBDSn5dWeZC3LunK7EZrDeqZ7h64vcd8MrwdVk	24384	3NKkAavtJSxWKEqBJcovwQFxSeSqps6ZPkDHWkG4tL2qg6eMohC9	1403	824	461	12463	16293	jxT6UNnfukiaZ5NBhhMfV6pvaSXshowNaJ6w984N5ds7Lzu7fn9	12128	17071	17071	1619011980000	orphaned
24427	3NKBqQemFhL4efkbiogFtBJPi2QgfQTNX9PQEWGJuWdZnaZXH3Jt	24424	3NKn2SsxvHUgmDJGEbohkDXg5BES8dvLdFCGjxDZjJrhMuwHqWAL	1403	824	461	12463	16328	jxqS4sHLyHCGkcirCxjoCLBaww3zPWLkinEKFKSFFw5UU8Q2oNL	12148	17097	17097	1619016660000	orphaned
24432	3NKtmDP9589vThU64KHkT8FiQ4hFNRoh2CniRZ8c8paw3sQchyX3	24426	3NKfHKvDFjpVvFbnBZ7NAdAaMSUaXyULZmFSRUNn1W4qSJwka6jW	641	1336	461	12463	16333	jw7AutPYThpGGwXnfg6mgT6HxxkmZ2WWprcbduTMJsg9Me89XCC	12149	17098	17098	1619016840000	orphaned
24439	3NLnMVFLkfzNP9jLnh1X1tJFs17uMMeaGTUPSZnBgZnG8bXxfZfC	24438	3NK3ggzzku7cqf2xDmEbskEiZA2mUMbyXTaN5xFUjHq683rEgxcx	1407	1395	462	12463	16340	jxxg3Ud3qK19HNGLRkXgVY5V1Cwuo6EFoMDw8s4yzDYnmrcmwmy	12154	17104	17104	1619017920000	canonical
24788	3NLr16yAf4pyo6d9DAxwqwthy5pJ4d2j1h1DfFHTxpcHJpQU7BQM	24591	3NLwey7uhKSQBBrfH4kLihktrSUrMaakbeeV6qxkXc5d9raXPC8h	1426	1238	461	12463	16660	jwzbmvtvSzh6PvfGj65DqH61qaQB1Rip93xjFimBB4fVhGXF1jc	12154	17331	17331	1619058780000	orphaned
24783	3NK7Q2KVE1YWdMqe5kbnSAL7uaNTZX3f3JfhqmPQw58XjnU4WxJY	24781	3NKQKo4JmpriBM2CQxbsjC4YzKcsyp94BYFTRxepJJx1tD5ywpbs	1458	1323	462	12463	16655	jxQqh3EFG5VTdCH2MGyPcXH8dHpGKDwBbfsWcPD4rbfJuVsu3od	12158	17322	17322	1619057160000	orphaned
24451	3NLS4q7q6HBSATVcQhdJsh7PAKFPCb3LQEMT77GfZPXn3vQqkfbe	24447	3NLRm8oeSeiHL5BAZzvXSbzHjp9UFZhJsfgGuV93fgbNf5DBHAE4	1581	778	462	12463	16351	jxavuvRxw4L7ccCCEFiGYfptw7V8gHXLS8Grs21KN9mJWyb858W	12159	17110	17110	1619019000000	orphaned
24457	3NKtiMVzGWPpyVoH8eNHAckcB3Wgyf4Lu3v16rqPgffVL9Ze5Rgy	24455	3NKGjLzrZTpNPgCC9jAWkShYBa83eUZ6h6BbBmayigrhCwpSuE2w	1451	1292	462	12463	16357	jwgjy9ciTvFMZRza4gW3ca5mnWV5APBvvwz37xZFme3MxpoGoew	12163	17116	17116	1619020080000	canonical
24469	3NKA4WzaR5BkzPou7bvYP5JozCX3JGiHtX5QjhyG1QSo5NzDRsbY	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1476	1005	462	12463	16368	jxMW8nurqd8pa1XbXWbqw1osbUzTDzYmHnUDqF7B67TfDGZ3F1q	12168	17124	17124	1619021520000	orphaned
24730	3NLGBVZJC6k52uA68cxcL4kivjJ4mWQYtkAXTA7B9UCNoVH2uTLZ	24465	3NKfHkkksiw4qAuBWnEMg6kqvgKfJRFMkPw1rwKFCx1CQR67Q9Zp	1461	1271	462	12463	16605	jwY3S2dZ5qDkEXqmmG4oh81PasPryeAi9kegEsSi6eX42couGEP	12168	17291	17291	1619051580000	orphaned
24486	3NLf1psCSmKYeoaSi8EokEsA8QDcUdwXBiBy42WRAVSz9ngkaiW5	24485	3NKWzZthr8nSsPseTqKc46j93o7558gaprNTDrxpxtX3E2ggf7i8	152	1084	463	12463	16385	jwXnR9Au1eVYTCiY8cJPtHyaACS8zoBXcyhwhNGtwPjiovg2Aw4	12176	17135	17135	1619023500000	canonical
24731	3NKcceWGWQGEAafSCmEsoXGSp5uohtBQsEArvAE153oqkuRqumwr	24498	3NLgyCiR4YgcEwwa1Vd4HbBZqz6qqEAY3RtqXf959zoQXG7gjq2F	1461	1271	463	12463	16606	jxmJa8Vpop6Ep8Qj9HFg6Sy7fmyAAZg7MFQtAtxLHpcF4Q5GVeE	12184	17291	17291	1619051632435	orphaned
24509	3NLCDtCk7eoZC6qsHe7Z5iDFdii8fWZBfybc8x33ce7KhRuXeGiA	24507	3NKE8hy8EKESJd7M9DxEvy8EW1yURb99fUFkmWEYdKcxzvcQijk2	1668	1668	463	12463	16407	jxepE5TiJvQJL8MwECgLN8pzWTfrWxsymt31zmFbLnzzrGpUntP	12190	17153	17153	1619026740000	orphaned
24528	3NLrrRbNGXaVZbkeoscw7KAjJjzWyPB3MXp856VrTbw7w7TQyN2w	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1407	1395	463	12463	16426	jxsj4iEbgeiSr5MgVW4eDsNZ4Wna2VvuK7Weku3AhmNirVMX1M4	12193	17159	17159	1619027820000	orphaned
24535	3NKL6u14fadM4gH1yCwZ4ycvJK27JmwRFmXHuxUoktxDrSV7QuKb	24515	3NLeJ4Kn7HaovH6oq1BXShgPGghd6wAec8WVk74GVFTUw8qUa5wu	1477	1224	463	12463	16433	jw6wXhhbkCGWWBGqFsoBvNwjYgR1T4rymXNJ7hx8sX1EYhDiSAx	12193	17167	17167	1619029260000	orphaned
24519	3NK3MZx7PAZVKbVfThaGvgB4jq3dQitD7nTdCDBju6WWPSdm1k87	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1657	1098	463	12463	16417	jxSuUzicJRuMX1YK3UjrmwqQwUoL6pnBiqJxM797AX8xHYyaRQu	12193	17159	17159	1619027820000	orphaned
24522	3NKsCTmdBtCEyKdJVjwFDJ2dCic1ZqjScdGqERoZV4AVrRCVGXfH	24516	3NLeZtFTyzKvNWSNjH8RRxA4mkGEqcJpsa7CSWGo72bNvAAqpRLp	1615	459	463	12463	16420	jwhsaz9s1MubYdYxDdp6zzVxg9CWM1kgUZGQozJsHCHk6YtTJe3	12193	17159	17159	1619027820000	orphaned
24526	3NLJxhPG5WDfZnfbY4uJvharMEcud6NibqivYrLqm7NqpN6RgXgc	24515	3NLeJ4Kn7HaovH6oq1BXShgPGghd6wAec8WVk74GVFTUw8qUa5wu	1675	1342	463	12463	16424	jwfrBKArfJc8dVtfAQQaDbzXzhEP66mfRK3DFG9fH4mQYACp4kj	12193	17159	17159	1619027820000	orphaned
24552	3NLJcXm19s2JQuYA84GrP38vSe6yho16YCrXR8NSQKUWDMHGPC8k	24536	3NKcseSBrj5CZUeGcxgxGsKpUzhAyNd7pGP2PJpdUyrK85ETCx8e	1633	1390	463	12463	16449	jwEL1eAhgnqDRNvaraq14LjnCLr3Hcci81CG6wtGf6qtQPCTCm2	12200	17176	17176	1619030880000	orphaned
24570	3NLrDkCrFF2vEKWN3WLBhUyxUttdqFBui8R2rRgQ9swfABotqZUx	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1407	1395	464	12463	16466	jy2YAnmj5cuNSsGjP4AxWz3QDR9Co6S6q6nLiZAgapPrVaVibke	12213	17187	17187	1619032860000	orphaned
24568	3NL9pth51i4aJzyuYX7wXZ7PU85QJgsFaaNePRHr3VzURus7jRFE	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1406	1393	464	12463	16464	jxr4t9bC3ZMFdGWVNKsH1DtSEQ5Ewyo2y48GoqZmVwbDL24yQ3s	12213	17187	17187	1619032860000	orphaned
25205	3NKxUa4PeRG5Df57bQGMP9YcFvuf1QP31yHCQmBvYvJ8NMrYd4Ea	24565	3NLYeGzc4tgc1oJwxugbTJWvBhDZ7iuQzcwPF6pRCvPTUAgNhmGD	1406	1393	464	12463	17030	jw83R18oB6fWDAuDPSPAH8Cntfpg54RUMZdg8BzGxepwB1apoBU	12213	17585	17585	1619104608030	orphaned
24585	3NK8Z4ouosXfRWCgMLxFhHz8uHLNpMP2TD3VWAjEySw3H5x59g3T	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1440	1377	464	12463	16478	jwLVJ4o6Ug2uhtYVk5ntK9JkMQougxfQxCWeRX39BqVVEbuNU7u	12222	17204	17204	1619035920000	orphaned
24587	3NLLoxdmovzTzAhioku7ZMTcPnpLrJM4AQKRtdYKr1z7iaygCjFR	24581	3NLmE2gEiUZ6qBahnyZC33c5buGZbJ3ANeDaJ5dLCyE9T87Gsx7S	1613	1349	464	12463	16479	jwTq7T5vsDH147yG6hpdoe5gUFbUxZPeYz3ejnTWegyDJwANk9s	12222	17204	17204	1619035920000	orphaned
24588	3NKmUgiVaKLDCSAoJeJq7YG6Hd3oL9pasYwwEmNRxjky1bavAmD7	24582	3NKAejuZFyrjhQtkUtWWwbTt3MGyxhB2AfwF4gXzbSDdwzz5KyzG	1668	1124	465	12463	16480	jxcRSissf9CHaqSBVmnWj13Yc2qo7TzsEwxghu7DYTexZTJaoA4	12223	17205	17205	1619036100000	canonical
24612	3NKCe77bjaiZMcHjUJCLtNELE7nbUc94U5YRgJUWnq2mb5wNt8y9	24606	3NKi9uyp8qy7fHbGiFDs3nuoB94f8JfocWphQ4Y6EdpaaJeSqtio	1501	1360	465	12463	16502	jweqRiuwFWQ2d8QBpcWG2kzPUhCxVtsa2mWD4bUWfUsyF6TsHW1	12232	17219	17219	1619038620000	orphaned
24624	3NLA2mgYMX2kFkV2yzXXEQJKvpUkyfFtczB8nvwG6XH4W2b5gLZS	24619	3NKNdzrRJfBLQifroNZ4pedR1Bjonzay7gJC45tkt786Ujn3tADJ	1527	1167	465	12463	16510	jxTnarbc4ik4VikTjn1uZJs5wKySaA9mNgcsj1rDVzhsKXmGfD9	12236	17227	17227	1619040060000	orphaned
24637	3NKGWFbQKKGZMao9e7Vg5m4Kk4bz6VnyCcLkmpVyvQj71R7ymeHv	24633	3NL9ftqj7VXUV9MCY5CC359FnnVAY42WAx57bLCzLtx8k5tFxsqU	1483	1276	465	12463	16521	jwwLHVj3yu6p9Y2S5kGcSUFj7DXgqhBAssvbzM924EvJkNMLh8a	12241	17235	17235	1619041500000	orphaned
24664	3NLPmcZTEDjhoBb2SrqdkwAv9vPzSPoF1KRDP6T56APuHndfcvD3	24660	3NLCmVvHegACRnWauugtSKKHQ65ch3GcnzFNHyW1kTbUcuyi8NSS	1474	1203	466	12463	16542	jx7W14jm2Q8JSdavS7NAoaqdAQnBYfQFw2qD35TG51SVRZCBxLP	12250	17245	17245	1619043300000	orphaned
24994	3NLLCSTvLT8oUEM3GeZNrJNqXJWdzj1aLMNonFuYjJ9S96U6UZi3	24810	3NLGHoZU7DGb2XiJ1NWZkvwhvgXX2pFJfkfs4vyrdYsERJ8rfrPy	1649	1017	466	12463	16847	jwGn9CEypCZ5WxzpfMLGiCUSsbDSpCRcqq1CNNxb3F2FpWP18Ft	12262	17458	17458	1619081640000	orphaned
24690	3NKugigAKWj4CPeWxrPqDQrC6h6dZyytNkaRzL3M11sS9awByKwT	24686	3NLAJqgBAxS7iYjkwqTRnPBeT2MbJYxVpVRhqQP47TqiGm15RYsh	1652	1315	467	12463	16569	jy1mgiVskzEcSFH3sYRtoyPNDgkmeTnY7oQp1wUwdEkVw3wN5yS	12263	17264	17264	1619046720000	orphaned
24695	3NKffdmie4dYkGcQHPHb8iNmxi1MhQ7JYWnFmaxMSRP15fPFbnth	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1648	1158	467	12463	16574	jxXNtrHg7bEbUCJprUWQGym3tBELg8ki5HSU1ou5wXneRXK8o3C	12266	17268	17268	1619047440000	orphaned
24699	3NKbzhurwGFi88ke8oh57vyscyNUSzdB5AmS9v4xCruL6xZdZEZi	24693	3NLHBuXYdAhaePenNn5ntpz95ZjijmXhv26u9GudDbGyTLHvD4Cm	1529	1316	467	12463	16577	jx4fiZuKpoMuQCWUR4bTJn5sMS2xKwkZ5KWbf9juSRuaFqUqkXJ	12266	17268	17268	1619047440000	orphaned
24705	3NKq3mYu4GKYy1HebmGEXZ7k72GFo6GRK5QWG9jC8pZRh15e1r8W	24701	3NK46rqn3RfjQjhU8CgcLP5mNYfsVtBvyVrVWfUvkcVZULDYZQ8C	1529	1316	467	12463	16582	jxThxUEPo7rcdoxe5UP3RpJLoczstU2Pb9yGeKBJNZ9B2fMKFAZ	12269	17273	17273	1619048340000	orphaned
24735	3NKKBzbBrMTKS51UU8rR7SaKaNvXFJyZLgkLJgg1dUuymmgAWLcd	24732	3NLAdbKLSmkKARNKdZtu4jvCgfFaGBiHe6f8pvjaSdDbZRXuK9Ef	1407	1395	468	12463	16610	jx7La4EESdVhvREGbxqVg4yBjxke6kPnvyucgzas6zWadEdUjes	12283	17292	17292	1619051760000	orphaned
24815	3NKYBCpNEz5xysjNMnNQ2mznd29DeJLZkDqQtTkKUMGkixgbi6kU	24742	3NKVaV8Qihi8wWxsQBcChdFV55u7A4ii3VMCbhdrEvHym9PDXcvu	641	1336	469	12463	16687	jxDKifgy3J15sUjQYvxgbLxKCZwJaJFhx1PoVsaTvqTP5PrzRem	12287	17346	17346	1619061480000	orphaned
25120	3NKb7TbuW4Mort5mqvegVmDJD581YYdC5DSJUVj2XWj7kiATfEaH	24815	3NKYBCpNEz5xysjNMnNQ2mznd29DeJLZkDqQtTkKUMGkixgbi6kU	641	1090	470	12463	16956	jxQxXBDBjeGEZLY3P5HsqatfwYwhcw3L8BpqmQGUBd2AkUMsiVE	12288	17541	17541	1619096580000	orphaned
24750	3NL39Bfe4upDPcBHhSWu1YRFYR2FkkBa5TRetzeWz6jMM4rN6Uec	24748	3NKRgk9WpxGsBWYZ7FHq5JzvzPKLBmwxoB7fTQ3s7jukck5BoFts	1647	1176	469	12463	16624	jx2zJdqvWX34ttvBxK6UpeKNsBqvxLPv3BZujBBHf9o5a4btkja	12290	17301	17301	1619053380000	canonical
24755	3NKCHPoGj1Cpr9t6J1E9VRWqezb2zZbbkqEHABc5BHz89AiCNyxB	24752	3NLCZpqWW3GkxKtMseCjtB3yeojR2hT2zYDyfFfywVBerch9z7Gc	606	1295	469	12463	16629	jwhfKL2J4CJuuLsHNu5zuvdr2gRndmb5FCwhYfLUNEbVDa7S9iH	12293	17306	17306	1619054280000	orphaned
24807	3NKLapUjZC8hsdKmawM3avFCmmG6j9NGnwp9pUjSqW1cQoZwFv5F	24803	3NKm8pXTzs8ERKnV1nwa218w7sYCdJf1c7TZ7KPRe1RPLSKiLZyq	1407	1395	471	12463	16679	jxNKsUHkqfyAS4t9YtbMDbkHk8HhoerAJfitejVqcSs1T1vj8sa	12319	17344	17344	1619061120000	orphaned
24811	3NL5gkUpPtkukhvLhWP39rFbYtRPeLA2M7gyvgkFK8GBxLwApFH2	24806	3NKNanPs7w5TMUNn9ZpJrtK988seSWH2Wx4iu1LPEr9MHysTFWvY	1573	1072	471	12463	16683	jwdiNuHZWxxJ2DvrbR3PJXsJibH9Q21Q199xR4HhFuhqCkeg5VX	12320	17345	17345	1619061300000	orphaned
24822	3NLPoSv63MUQw613DmcZxwGBKvSxJwiNNsb733NgqFKRpopiGdG8	24820	3NLKjjwPbkz5Cq986STtAQ7jcVsmbgsXTaziaaKcm5zTVXnDCjyY	1451	926	471	12463	16694	jxiQRtpHtpMwuDdYCo2EkEwyj1oz2r4ChFgUsogdVTouhHpNgij	12326	17353	17353	1619062740000	orphaned
24826	3NKExGtEDokfoPXxpTd6ffQHt3UCP1KdiD6cmmNwzKkMTMF2R16p	24823	3NLhckkn95cKXVSUr9Zop72VGiZjfUWZhDgtVaUktwkX3V7A9joa	1553	776	471	12463	16698	jxbzzTCtWm8wG8T29bFwmh7AjsZvQpGocqZa9CKXijBdrn3Gp9C	12327	17355	17355	1619063100000	orphaned
24835	3NLDUUFM2vHDPjv2HevqtmKpqTmyTcuQwvdJzaanmafFhzhHH6Hm	24834	3NLLfPHv3PW8jbnfhSPbPW2DiuRdP5eKRjguJB1g5eWCeAV1Bq2s	1407	1395	471	12463	16705	jwu3L6FmvFzohe21VWsfcPs9rRsE2ZRMNpTYAXtLEhpQ9fjUW5d	12331	17360	17360	1619064000000	canonical
24844	3NLmYt1QYDnaWg7ddWCRCfnpvsvueSxvzUv3zHZvamfnQdrcr7Pe	24839	3NKfDkUVXhoU48ZDbEZJxPTsTXCWPhdkaijqW4nAQYVZsFU54Mmg	1609	1333	472	12463	16711	jx6bRinrAD6cjv6teqmcTjVoUrTjMWZ3wczJyGgYzhgPptojQ21	12334	17366	17366	1619065080000	orphaned
24849	3NL3W1P9hKAf8iVta1PoR11eeoqRi4GEYQkqTAWXAGSHhXPnqfDG	24847	3NK6tBt5xj1i5sv6bo35BHpTtjj4K2uX6vdSCqSNUTbVNypxqEHF	1403	824	472	12463	16717	jx22txjhjHRJYJyDB5ESeqdaspSDLTT2gix5PYzEBjaJnWu1tRm	12337	17371	17371	1619065980000	canonical
24866	3NKABdZki28WBNTg7C17CSVogEVNjJtD2zsYEKxX6K2zYcMro32b	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1619	1029	472	12463	16734	jxBdrgdg91JjeEzqY7HUfXWN3RAZ2pp3fjYkcj8zPjpvsWAB1Bf	12347	17386	17386	1619068680000	orphaned
24869	3NLKcxNSMZZGnpA5oSMYDbW41fHradd23W3FTFaEtZxy2fktfrY4	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1553	776	472	12463	16736	jxV7yeDqcRGNjLUPL29GV9sANC7ZGByfXMdKHKvLvdz4Hsnkf9p	12347	17386	17386	1619068680000	orphaned
24870	3NKxTkV2HMHTqEV8wKEQ69mvYZnYRM1apz4AdMQwmXDme73qcK2Q	24863	3NKa2f3j3yKeXxksEyLm4SRyqzKxPM6EDDk9HhE9u1FbsS3bG58u	1619	1029	472	12463	16734	jw8kA6MsdVV5uZe4mSaBZ82PbMGYUtBdQwAaMaPgxXs3xZz2Daf	12347	17386	17386	1619068680000	orphaned
24877	3NLKueUKHLcHpkRhvZdcxmVV3HNszZkvdtz4z5D6ZYdj1Ab2nkRf	24873	3NLs6R2rCfUTeMArcNXoEtLMQLQrEjtpcwu1wrDjdRBYFTh8sUgC	1627	1385	473	12463	16743	jwGEiszwMZ5PGFRpnCaV369coKehc9oqorj2naaqmG4Rykm5kQF	12351	17393	17393	1619069940000	orphaned
24988	3NKxprJ9Re27oBCuARhE4anh1LvY2sX9kPfRSXHQTfUcEKZcW5Un	24892	3NKcEEi4WZCymeKXgFATUZHCcXZETzYTE3rsstrJwCRcMDWmnWCM	563	993	473	12463	16843	jwfSBJsGuLsmwNqwBNwK3njQ6B94AEjrkz1wvetuRVueG2yQvAm	12360	17452	17452	1619080560000	orphaned
24915	3NLkSqUEHc5tntSFk1r9jPcME3dB8BMDG54BVRFnSoXNFZdkCiwb	24910	3NLg37YjYREp4UUPXZ3HYHvxyCj2YmBuCV769pxgM5pRch9ZoqvY	1440	1377	473	12463	16775	jxpicJYvdFUHxRkMrg4P4FhuArFrCvqJKRnHzDtLtgxYz8hc4px	12369	17414	17414	1619073720000	orphaned
24936	3NLhNN4iPbEjgT8vKcqyoJ4oC7p18mZ71HLnzjF36wtfhbhvJvZy	24911	3NLghxzktdWkVk3Z5yKmJj5LkBSN95deu6NFvU35MavP6Rmz9udm	1549	1116	473	12463	16796	jwymg6e22DJYYNSYBEgnQX9eaM65JojyGrRsJc69pwCBYkS35Wk	12369	17423	17423	1619075340000	orphaned
24927	3NKQvMKRxq679tqxrU3Dg5BHqsgK9Y7uM2VJyWNzFmHrKi461pMK	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1540	229	474	12463	16787	jxHRhYA41SrPLDP321VdyHeKN32Prp9bQqW8wo6PCD27nk4VMid	12375	17421	17421	1619074980000	orphaned
24928	3NLajhWv3YnoX6ZVzmCnSBtxt99Lt2XyXHn8AMjF9PfqCZjhGAe3	24924	3NKut95E2JY461vqRMecX1zAJSBuqTHBBKYEEyVJK39pC6JkRfx2	1508	1387	474	12463	16788	jxKturjeZRXJVCDoJ6YaNHN6gb8zthL1ypQYqnqLWc5WB9f61ua	12375	17421	17421	1619074980000	orphaned
24931	3NLG4tgA9CqnWf5RWFRJXnJsKxzwQnucExpETSWNpaJexrfM1knz	24922	3NKoANfynqHYX4sL4gHRa7QDdSCceo7em7v6Fn48CcuYm3pr6h8x	1540	229	474	12463	16791	jxz9PqjwC4xAVTqsk2uxfdbt8Y4FFCGZoKxaLpc7NnQJgL89vbS	12375	17421	17421	1619074980000	orphaned
24961	3NLGD9AuKtNm8CjaZ4EM1XQpC7zRaCdHpkDvfTKEbACRT7M92f2a	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1647	845	474	12463	16820	jx5xPAmoLJ2W1SJKMtrZ14Rf3nzTTFq5XxkbuXGWzszqCyZzuPV	12386	17433	17433	1619077140000	canonical
24958	3NLotkP6tmL7rTc8wmPTpVBdMa75MucUchAjBzjBA5noCzm9bJbr	24956	3NLLQjuapH9gU8yd6o4ZeopXmLJ651ZkocewMiUD6iRmhcM7VpX8	1467	1376	474	12463	16818	jwFMqYMTGUiqoXzDkxWwDJeHs18KaLWEaAqVmjDDWvC4JVJ7eNR	12386	17433	17433	1619077140000	orphaned
25180	3NLhze8LigBymZYSJeFXidGAFLzmUu2bejJd71q3kvLfyDFP7MgH	24969	3NLijmNBTtx8zmPsNG4VgV2QwAwNRdgiKq6vgFrautWD7Yo5Ci95	1553	776	475	12463	17008	jwstq7Uzd6b9bFmsB9yWitee1pT75mvLKR6PVtKwJGWS3DBK2E7	12393	17573	17573	1619102340000	orphaned
24983	3NKP4i2ajpQf9tfN4wvzEpZV6VeywNqCtwXnrTctgkpYgpyKejYt	24981	3NLDan8LYEeTf9zMq3USMjxn7qgH3GruEwT8BzMwsDTfmuehYWbE	1527	1167	475	12463	16840	jwCyHbERUeUT9SAkHKx2g1ttzhUieUTAvtdYrTg7AhfBdnBX72N	12398	17449	17449	1619080020000	orphaned
24990	3NK6ByhaG64KNAposwkKaae188N64nvwwpgVtk8eKPPqhRBx3hh5	24986	3NKWWidBeSzi67Qb5X3QNU2cGJZ864huWYzetvKpWJXumsZi2Zcv	1440	1251	475	12463	16844	jwByc93V5bPTNN1vZsTe27ew8jbQKRoveg92zbSUfy2vtesP4YZ	12400	17455	17455	1619081100000	canonical
25001	3NLhdwXWKZuirrqYyjZiUDTsAV8WqYYzwrkmmkZkxB1Rv8qZeWrM	24997	3NLWW6nfYLrmZE2LGVLGJzrWuuL4MfrrTZEUytrRnX6xfSKM83uq	1651	1301	475	12463	16852	jxbb4MLW5Jn1Tji1zgM32hg6QtXokhhH7Kn4j5Y8uSVQWeqdfDZ	12403	17461	17461	1619082180000	orphaned
25181	3NLiT6EAwDm4YGmnTf3vz7bsnxkVtsmjnZHHbQUGh3vBcftvYUrL	25010	3NLJLByb1wnYExaGHqMZ9tWbjyKBmasyQtrdN8x6YdeoKq1FTUpa	1553	776	475	12463	17009	jwuW6qGwJZXLa8oXymQddUJRoEJVHqc8at1Z6Taz6JzfT9UU23M	12409	17573	17573	1619102394887	orphaned
25015	3NKExRW2n2E8y6HR8UbSB5s3SWMvYGmxErPKav46SaQfyUuKzdKs	25014	3NKhXdHqK4JRFYiAgDrR9X2MY4zaa6Yz6weL2yjnBY3muUVhmp26	1609	1333	476	12463	16866	jwoMq36sehDvRrSaBaMyjtW3YU5xfUsBDQ37sxzQbWgGppdKEpT	12412	17471	17471	1619083980000	orphaned
25040	3NLR9Jfqy5nF53NMeyQRzTnfQUCG5eA1BWMnBH884ozqkYYygUpM	25035	3NLLAFKDraawxFAS5Z7JYvaFpAm1jUGhgaizXDTzfHnNW4Hg2nzQ	1578	1050	476	12463	16889	jwScaabX3beXMCUSMkKDhe1ux1wRQmUVwEkqHUBQ3Zx4tJtg8zC	12422	17484	17484	1619086320000	orphaned
25088	3NL9VgC8nwVL6ZvHXeYbPy1hPzFbEipbV16jVkh696o8GBp1KTXZ	25086	3NKucatYqBYsP4JPRe2j8q1zdS7quCwBE3aXKbTcX3uH8UNdahNg	1596	1117	477	12463	16931	jxzhK5fyoGBJATbgiEHAn4sPkP2weErNStggATQi1sYytZtdkh1	12454	17528	17528	1619094240000	orphaned
25090	3NKUhVrjL4nhFyw7fJBarqoP9YYnoMmLmxwVGK9DafwC4LBMhgWg	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	1670	916	477	12463	16932	jwjApf2JSP21mEuPtj3WzaT2DymAU9dCcsaAw1b1q55tJShhuBh	12455	17529	17529	1619094420000	orphaned
25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	25087	3NKJ6jVB6YoqDJTN4SVZSKrMwW7wUbTmwjcLUpBtFi8H9kMs24cX	1534	1071	478	12463	16933	jwN5LdjdrV8L1QDtcH7MhyyZsPErp6jCnZmaugMZmDRRTZLspgM	12455	17529	17529	1619094420000	orphaned
25092	3NLkYrW7mdHUtgumEwa4o8e8R46KMqfQurbfAeMUeG2KG2radNrw	25089	3NL1bCacSyGtdtGUZUCtQuHnkG1T9uujks2KT7ZTuMAuCaPFEbdN	1670	916	478	12463	16932	jwNANoqkGaB4xb7zVZcaqYN1ufDj6nBf8cVErHtF4W9i193EYqd	12455	17529	17529	1619094420000	orphaned
25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	25093	3NKP4oLCWgU28UCNRLVMjRjKxhKk12NWh3eqdVELEwedkwnhaK6i	1541	1298	478	12463	16935	jwU2Pns8vsCZW5Ss1dykXvJ5WNVnrHPBWYWd6wwHKif49NzjJ1p	12456	17530	17530	1619094600000	orphaned
25098	3NK3awgFotWnnYhbABwDkQoPawkknWYwJwTCMo6uwbaMZX3rupLF	25097	3NKViBQie4kN6QhdZH5TyDEqVLhCUHAeZro2AFP1b3WETgyMgRes	1547	1378	478	12463	16936	jxQNdd3jAy7iNGbZKTjexCGapU6rGvgZYRwcpCVtHzcfHkeLjBr	12457	17531	17531	1619094780000	orphaned
25102	3NLD5trPLvSYLUXgTR6pru8oo3mqWskEL4CwTzhmnMEmJJrg4pAW	25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	1607	1102	478	12463	16937	jwApvFQgEudAuSYmBMMJJE45sPCzCPWSmsG24H7uD6M8TsuPbpw	12457	17531	17531	1619094780000	orphaned
25105	3NKtrgWDcweng96F3TjYjYerxvrhq95jozhr8jMDXnFnCaNZiruq	25096	3NKiTJFmPVRtp12DUd5RDDsKwYRESWci6eBEYhcLCEefDiugDPfk	1419	813	478	12463	16940	jwtbrBNnUnkwRALHsjGZPqwGe3rKXjEcgpf2rkX3XmpT3A15sNp	12457	17531	17531	1619094780000	orphaned
25150	3NKU2zLeZoq1NDBQgL9hrpkegnGGPVzsPuFSHLpq7SEpvGuBbf4s	25126	3NLDpbAreVke1VYahDFfpF17arwkk2LbBcPyt8MAhNyyifsTABmZ	1637	816	478	12463	16982	jwnPTY11FBetBTxqeyM6eLtsjMDE2NnbTxEwUouQSrwezuvz6M3	12468	17556	17556	1619099280000	orphaned
25134	3NLh23pp8VgeY7FqPqHWGnz3er8avLiz67ZCaeqxq3Mr7NPtXU5h	25129	3NKTUeivpZJUi9QcCyawDN6qzwxWat97utQiTedF3xaP5iS8HKGP	1523	955	478	12463	16969	jwiJR2jssDoE1dhzndQiJZj29Sa4TB1TK43BXJHGX2GcwGFXwsq	12471	17549	17549	1619098020000	orphaned
25243	3NKb233itACUmcLMTUWBGh2kQnrivaT8CAycUCub4rDcXsUFqgkD	25166	3NLh6v7xgiqHM5xbvqopHPYaNAok6rHeQ3vwB43sggrFqKFzj88h	1637	816	479	12463	17064	jxpVCfudSGDPFcPoe8pcYD1cNBozdRSeYF4iRQTfujUBYvnu65s	12471	17605	17605	1619108100000	orphaned
25291	3NKe7DoLAFxgBcq72SAXbGCrTK2MUCQtsQNn8uq8denpnjzacGua	25243	3NKb233itACUmcLMTUWBGh2kQnrivaT8CAycUCub4rDcXsUFqgkD	1637	816	480	12463	17107	jx8ojSJsjtFcgiEei8yM7N92cobqTqCuTXba1DradoBURSXEHEz	12472	17642	17642	1619114760000	orphaned
25375	3NKNdXBeeAWpBz2B5GubkQcHwJYFjiQz2N4pjJkPhQpkKf9F7JFx	25291	3NKe7DoLAFxgBcq72SAXbGCrTK2MUCQtsQNn8uq8denpnjzacGua	1637	816	480	12463	17182	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12473	17687	17687	1619122860000	orphaned
25491	3NKet6gukUEDmYVMp6MGa9BUBJuNbgAtK7mMyHHsrKSck8JR2WSt	25397	3NKUuACBS6BsVSm7vdSyAe3rpoTjNkcKESoYSqzj8X76kiW1tGhQ	1637	816	480	12463	17282	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12475	17738	17738	1619132040000	orphaned
25482	3NK8r6vb12Af2yjb34FYnmDN8dryAoqyZ924ySNZ7MQhXgNFoSs1	25397	3NKUuACBS6BsVSm7vdSyAe3rpoTjNkcKESoYSqzj8X76kiW1tGhQ	1509	1074	480	12463	17274	jxiuKN3ujDip7LwT6tX5poxqCBZAteuCEhxuyBNfb4uJwFLz3bD	12475	17733	17733	1619131140000	orphaned
25547	3NKAs1VvjVxQd8yHZ29LwMJzmXivrJ1G33iKKDybkfdARre4CSx5	25528	3NKJWyxritHZx6BnwB4RRoPM7SZ8RHXY7x3Rg9Pi8zwthgv2KQKE	1637	815	480	12463	17331	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12477	17768	17768	1619137440000	orphaned
25553	3NKnY1JiWciaiUscXvc7SNg3fP3F4HT9JxZFe5pYJKs8f1t6DurC	25547	3NKAs1VvjVxQd8yHZ29LwMJzmXivrJ1G33iKKDybkfdARre4CSx5	1637	816	480	12463	17337	jwv2zu3u1aBNzbRYkBN83PM63mBFnz5PC8BN2s5vFVD7joJ3zTJ	12478	17773	17773	1619138340000	orphaned
25696	3NLKq4F6AzX2N3XHnrUwPmDCYsL1qFSS2nxYosrFGP7EbxyEigjc	25559	3NLN841T4YThWpvcDM2EN5bZEDkG2WJsCTpg4SEuem8Lv51zrtGU	1509	1320	480	12463	17458	jxiuKN3ujDip7LwT6tX5poxqCBZAteuCEhxuyBNfb4uJwFLz3bD	12480	17877	17877	1619157060000	orphaned
25158	3NLmQ29Gv7yVZGCui2gb8HRxicSGppspMZezfqizTm33ZGMBGsso	25154	3NLnTDvrCtsMUDGjt9QytePCB33mD8QJM19D7kx5GqUPMSm3zX1N	1461	1271	479	12463	16989	jwFaviod1CSHJYGUHuP4tLbokyvpiad7tyHUamuDVAZ2jeMwvuN	12481	17559	17559	1619099820000	orphaned
25183	3NKaBqXs2RbpdasFFULvSHSo12UNcXiz1hXsi4eSHLNf63nn9Woj	25173	3NKnheJLpdszYo5dgD55xvi8GDFDgCkoUMgy6tEdzSxSJg3z69zd	1529	1070	479	12463	17011	jx4f5yjGqpoLkTgm1gA4f2h78Ey7jzBEXCb6b93LdhAmi2Timt6	12489	17575	17575	1619102700000	orphaned
25188	3NKgZNxGr6MwqNgGfqFevMC4hRLrAYsrvvUqcTqrKhCUSFVuD7ch	25179	3NLdvjB4TNE4jrFFv28ysbPjZj8YAJ1LQAWVM5mjZ49wqhKqgt2A	1590	1300	479	12463	17013	jw7MnGA6GmEiAKHydkg3zfoik4XEJu8UZsNkTfPXCgBhe6cfpZz	12495	17575	17575	1619102700000	orphaned
25210	3NLdxFtsAf7uoBY9D3n7gkuq5dc88zWPmRACa1ZwYL8D6PCLcvAW	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	632	1136	480	12463	17035	jws5CJCqkZBsnT5nYWuTSuAEyr5967bjE79w9fvTow5imbDKhYo	12505	17589	17589	1619105220000	orphaned
25212	3NKn1zxWR7zmPDi9XQYAWksYTg9PUa5wPixeVZPU6BEkT9vfUUEX	25207	3NLCbPCUdN2s8LcE3Ro5SKpSCaCRTbHmCc5WGWgKhkzid1C483TB	1541	1052	480	12463	17034	jxUpUNhWewK9f83aAYB8tP2W471V8Mq2eBW2DuBB6EtxRj6gMCh	12505	17589	17589	1619105220000	orphaned
25227	3NLX3m6ZarbU1rmgDgYn14aMV53zHDDRgnG3zV4AFXigeWQprqHA	25225	3NLByneXrW1GfwyCegp2X1srWr7kHQ3ixLaEX7PAExPPMh55ZXmn	596	1306	480	12463	17050	jxQgatasTtyXohphft5RP8rjbCiHZBd4T8b9Ym2q6aeXETBLRd2	12514	17598	17598	1619106840000	orphaned
25231	3NKAp2nwWZ5o34Fy3qr71ftz17RQcVUcciH3vVXo11n3SGYXcgjA	25224	3NL4N1C9A1P6TtAi3Tj3ycK2R2DPuz5JjTXsXjbeJ2b6xkC4kELH	596	1306	480	12463	17053	jwKBxNmCh5o2ZYKDzQrKZZ9dWaLrR8ZRzXEsAcNQUDgRTRb1LAE	12514	17598	17598	1619106840000	orphaned
25271	3NKThz1JbiWnNasq85ugzWzeVEUSrZPvQzPKexBwYxjZv6bsrXQW	25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	1523	1195	480	12463	17091	jxDW15jZ2ByF8rkaKtUGhv9aQ4oVRUbuFTs86X5suEorefxUVhw	12515	17630	17630	1619112600000	orphaned
25903	3NLgmpH8VCLUs6j2BuiLmSyE2gkaZChqcEvpg3tEG3TQUXTi6gYg	25229	3NLRoXch3yjZkhT4wPfttop24vtpx6dqBiu7hsWr1Cjg9bYdcxP8	1637	816	480	12463	17639	jx8QPktrisrduArMEpCiwjAgeBTC1H3mye8vvBCvkDKuNo4GV4J	12515	18002	18002	1619179610532	orphaned
25247	3NKZsRenQPkcb86kF4tKGuGcrHoDkbfr2NzJDKjVjNsNoUpWBYre	25242	3NKJVNE3Z3payVoyPwDro71x8aKyHny4iZJigh2p2QGxX4WEBKVy	448	1059	481	12463	17068	jwTYa6RxQ9FKsWTTKP7iunVgPznH3njGZnp1hdk5dVWXqn1Af65	12521	17606	17606	1619108280000	orphaned
25437	3NKgeBZh6JsK4sGP15LAuPx1KtLKWh5UfmDhBjjjPAQJ7zsMGWMB	25256	3NK5Mg6ZCneGvwws7hbgAKxbBGNcGDne3PcSxhM6F64Q4NnDzHtv	80	1273	481	12463	17236	jxL9xzMRqNGFbWsHxRtcWX6kooTDjVUGieF6ayYTDNLYmfyamNc	12529	17715	17715	1619127900000	orphaned
25260	3NLnB9VRCuZ9Bu1wGWoc9e8m4Vtq3o6b29ZfYCez2mng7CFq47t2	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	1407	1395	481	12463	17081	jwQqVXndisXGDQBDdjsEdJSUMZgEptup5xPbrnKaSiK9NhHJN4o	12531	17620	17620	1619110800000	orphaned
25262	3NKaU2o5h7znXpvd2MPoyTNoQPB4X3YQxtqXKd1GQ7UsKFfqS4Cv	25258	3NKHovWgunBAo37ZTZogcV4oSr9G4bg4R1xtFNqHF395mBznuWwn	171	1374	481	12463	17083	jxpGYvdeApFgiVf4vhuQqoaKB692HrWyJDVr7UNAcgfxPpxuwH3	12531	17620	17620	1619110800000	orphaned
25279	3NKJgJoKzRnMrip8V3E6RvMNSuYaHYjQqmdwuBVaJfjEYhHQdH3L	25274	3NKYGNjkLNKNKCtSs2S4kpqwUJW2G6xKTqkyLMjGh7d1y5bvdcYR	1581	778	482	12463	17097	jxTM4AWJY17LvGvUc2u4Gg3YDMA6XmfipsEMNxWbzFscTSbD8jG	12539	17635	17635	1619113500000	orphaned
25405	3NKCLj1YCdcJ1a61RTfoVv6466FLviVemTpi2re44bnHqn4os9Rc	25311	3NKxTLbGKzeUooT7iyUzLa8SXhXgXZEaPtqp4KWsZ6L6wxoVK24g	532	1177	482	12463	17207	jxbWiiMix6ThF7BCrUFTLmdqed29WD1FuCWxWo6ki4g8QEyMW4e	12547	17697	17697	1619124660000	orphaned
25297	3NL1yUUeDiSnQSVDTbAQCyRukmUCf3rF2cmVFzMPpLu5jiHV3z2R	25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	1439	1279	482	12463	17113	jwKPDNivqpRYcq9qfsLQTK41KLFRUHvhSjjaU5R6YEJ586Vsj2N	12550	17647	17647	1619115660000	orphaned
25299	3NKxYaxPxyz5MUyaPwqpr6pqu3Xjz7HrBZReGMR9v25eusdx5cgq	25295	3NL9wsvNb6mHscRr25Gzc8JtXy3gsksG3kEtwMmBC5SroQ7tgjjS	1439	1279	482	12463	17113	jxzGhNhLarfnHZNEbmMGvqhRduKkLZgrujYKpmREkSx24ziyaDf	12550	17647	17647	1619115660000	orphaned
25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	25329	3NLRNyKngUascfkh7nLUYBr1MRASaVEE4UdzR63QQpwLSLaeApEx	1553	776	483	12463	17144	jxKCbu45sqBfqpE2FmLPn6BDuu6WgVM33W3r6gVy1STbjfFrZtQ	12564	17665	17665	1619118900000	canonical
25333	3NLnEsbXLYDMjZprnnVrSKYggoQ1YdgWdQjoNpson5M3BxCnz24m	25331	3NLDP7g64z417hZH4tVY27jDQy5EvdreAJQ31iVM3kvx6RxgCgUr	1407	1395	483	12463	17146	jwJ9p4nieJcQZTVhqZVNwA1AHN8JsdDnAaQsNyLVCg3SvJYrzUY	12565	17667	17667	1619119260000	orphaned
25342	3NLSk5SwVNWq5XJY6oXQ7g8LQiYDLKWB7HyST1CFTkrmHPdQokYX	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1402	850	483	12463	17153	jxpDaSSWQpPBoYU3G5iduEviFQWZiPDM652btf5kTXuB72A3ygS	12566	17668	17668	1619119440000	orphaned
25343	3NLbbT8wsFef6yzvxWURewLYHcYNQ5Eje396KPpryfR8QJoM9s6q	25334	3NLpqLCgRTJGVA2FwPSBjZKyMWSvA4JHyufYxPQ1GjC1d37EnA4Z	1460	426	483	12463	17150	jxc9DHviVUDzwkjZ1KtJiDoCiGEAceP4MrJ2beUm2KcTkGftvVp	12566	17668	17668	1619119440000	orphaned
25338	3NL4DT6py2sFGr6cWokerScdyAKP8vgrXwxeV8pxwjL7wez58TRk	25336	3NLFeLnWPJugS1JxLK3CdZhLcq26LqsNaoAcoBQP9GSGFEKvbMFc	1460	426	483	12463	17150	jxSrMh1NoQACWhCqHE22uNhEGaHB89WfSjihNf1meA8kgH7ThfV	12566	17668	17668	1619119440000	orphaned
25366	3NLXc3mBmc9B7xvVzqtXpZFiuZyC3ZtBKa1UmPBbErQqQsWR3Lp1	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1483	163	484	12463	17173	jwyVVrJjjTpAREPYssJfyh1DbpDBt1sJSevd1h86vif2LCCzgkk	12577	17683	17683	1619122140000	orphaned
25367	3NLwtLMGk5jp1tcsT9mCCjsYJPVr9JKpr6JC29FWEqVyeedu8hYi	25363	3NLM2xkfUMMzxH3qyBadEETap8eFFo96hpLT3qyeQjdRLotE9Mrj	1406	1393	484	12463	17174	jwqRTaBw3JaobKp2K1DAqrbdJX1aQmNbBSEiM31YGsnTVyqUAhG	12577	17683	17683	1619122140000	orphaned
25597	3NKregwkXLowMFnzeevLnt73APNC53ti4Hu5zSkrKq9UZ3mXpb6H	25542	3NLEfCE4tQygwayF1nkGSFrQQswWbhJsbsSvp7b79x9nprhxswYG	1419	814	484	12463	17376	jxxBejyHVvvSD2hv82Bk3WzvA1JN5CwppRHgDEjC3MzUVHcZQ1D	12583	17802	17802	1619143560000	orphaned
25742	3NK4enPyee2J1ya5keksv94ssSHCzjDRw7jBdzBHJsxxgNrKUDfp	25597	3NKregwkXLowMFnzeevLnt73APNC53ti4Hu5zSkrKq9UZ3mXpb6H	1419	814	484	12463	17497	jwEQZpmykdCahf9HAiztVBWVE7Ruu5t6wG8cnGdSZCfDFS5rCnu	12584	17906	17906	1619162280000	orphaned
25388	3NKqVMtJkKyW6LVmD7ZBHFLDZmNv2bsD5esfmEcEQKy7VRAWxG7o	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1403	824	484	12463	17193	jwMCstybHeJ7a1T3DNk3hnACz6VrwPxcKtEGC3CcCxDi9oFSiNt	12585	17691	17691	1619123580000	orphaned
25392	3NLu32onDa7aXLRzfxjGuLxFJVqjUmNfTsvRAVW6td4YQmpfJhRW	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1517	197	484	12463	17195	jxbegJ1Nd75dY5ky3BH7KxrNqLZKRtY7WZu2LDKqjj5nkT4yB9X	12585	17691	17691	1619123580000	orphaned
25389	3NLbY7vCMAMviuMNajFKeAY6WCcxsAkyDMfJwCENB3PQjrspt1hv	25384	3NKYPSr3arnLAUcAoFXMDZen4n6W5xkSogpHKN3d1gfgKYHptv6B	1529	1190	484	12463	17191	jxHBoGM345HJQqgN8ogtNWf3QEKYyst1MNsWWKSJJ4csqvLtjm8	12585	17691	17691	1619123580000	orphaned
25765	3NL8PLJysbcUupyQA6qVZBkqZieV8qjYGGM67aYfziCL9kZQzfSS	25742	3NK4enPyee2J1ya5keksv94ssSHCzjDRw7jBdzBHJsxxgNrKUDfp	1419	814	484	12463	17516	jxqavydpawpj7XnqadHmM8iUpLR8tUcv7p8D7wN2kYdcPoAmkKA	12585	17915	17915	1619163900000	orphaned
25436	3NLR28ApuUpKqUxwyx4RqXuSFACYKUXgG9NSbncEjLgZfvpcaAtv	25433	3NK5hf3b6g6Hg9yDjJ9VKGiVVvNQZ43r8arCKjCbZWAegbG14HSr	1406	1393	485	12463	17235	jx9AbiwNj8aiNw6hFwRt5RmSEQqVdPNU4NfMZhbHoNSFZ7ooyFC	12603	17714	17714	1619127720000	orphaned
25459	3NL35kbc4E7ftZ7m5KjYfS2PRGh29VxNFWGHyae7imUzfNrES8ds	25439	3NK9FPeTdyZPzTN4sWhGFkRhvJMbLkanzZWb4aVRyPd5fd8nQGpc	1419	814	485	12463	17253	jxs6HEUAcSBrLcSWLnCWP1jXo9bSdWC6MPek7xu8K9xPCHbHKuM	12605	17722	17722	1619129160000	orphaned
25455	3NLHXC3HgPw2sAbG2iz1xqT4JtZ357LoRXsqWN5zsEiZrRe9Ezv3	25451	3NLSQneZBDSJed9VQCTnppwtAbZHdx6kEMuzAAV8UzSormwkP3xr	576	1109	485	12463	17250	jx1gj8xVoUS92XwgisN2TfDgVPMqE6rkto7K3K6K8gqsq7TYrGZ	12609	17721	17721	1619128980000	orphaned
25746	3NL7t6A3Jgj3YF2pvqF4dTZiX7EUUoNrmtd4JUmByfpLLWSRbs1U	25598	3NKNCd4GCpx5HYsbBWTTagK3BpK4bEMuT4oFAiTFHFrKV1Yd14Zi	1419	814	485	12463	17500	jwXggSmYXXVevDDUsBNLKK6t3i1UW7MfJ6knXFy5LbzpPD4v2Mk	12610	17906	17906	1619162280000	orphaned
25768	3NLk24cZ3tp82TtgoQHZMKjQ5uiKe4jrqQpTLpzs443qpFnbfWTe	25746	3NL7t6A3Jgj3YF2pvqF4dTZiX7EUUoNrmtd4JUmByfpLLWSRbs1U	1419	814	485	12463	17519	jxCEJEKRUkXF3gTNUPjPgKQ4WRcwHSFBQuz7pkaUBMihk6iTUoD	12611	17915	17915	1619163900000	orphaned
25469	3NLR5FWAEuSsomCS1VaKwuYQsfqXHjmm9YeBoBDstyLv76r4KZgP	25466	3NLh9wB1CKFLjet9mgCvY5Y3QqYRM1xZ9zGWW4Z2W3xhXDeJtKSR	1447	979	485	12463	17263	jxdw3D9QyFHUkJe1R4TfA4fKeDm9isiAB8enhds5suR1jQeN24b	12615	17728	17728	1619130240000	orphaned
25477	3NKfsUm6RtKqEwiZ3B6UC2uaf9iL9RUJt5pt3XdKRRoMesJsJhs9	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1555	1101	485	12463	17269	jwkPZNwKr7roTPkTThBLX5attWyKV9V93BtHw8qRaUuAaVUtWw9	12617	17730	17730	1619130600000	orphaned
25475	3NLu8xXWULtnR13aUqqsUTKxWeGoLASDKrJPsTdQ3pVFkoVgyAky	25472	3NKHJUpRwqUSNYpKhFGMStgXthUvDAzquNpQ2sbsduvUi5ag3Dub	1608	1163	485	12463	17267	jwSf24u5ChUpWSeJNrqimjtZiodxgRykEmwQBs5DMwdUUXBtoLn	12617	17730	17730	1619130600000	orphaned
25489	3NL2M35jSGdkz8w9AdNJKpNMmGHLsMDdC5o6MZMRdJAT8xTp2n3j	25486	3NKy3tTQFiMQdYxBRbMdDrnB2YTUFjp4aNjCzfy7J6vmQVmuC1F9	1560	925	486	12463	17280	jxa3x6ajEdaxDb1PjPJFQEu6WivSQXMFiJ57ji4i7p5K4kzDYv7	12623	17736	17736	1619131680000	orphaned
25494	3NKf6XxqqFLGpFHN5bvdjW6FZrBoHc5zCpuBgxeJRP8GdE2sMy7Q	25490	3NLtiAk2b1ZivgY5VSdxefVb6q186vPGM9WStbAHYByiVHDLfuW9	1448	1311	486	12463	17284	jwBQf6CDEyfU5eMLiJbDWRBqMk7QGN2Y6zmH137AcMhpUQrdTxf	12625	17739	17739	1619132220000	orphaned
25949	3NKyMm7RRLeFABoEvbizjJtHMr2TtDyrSCcuLBXpkqxQK9QqGACW	25493	3NL6e1dcPeMJUbLeqarCapTw8d3Egaq7W7P8QRgfNds1AcfPrrPo	633	1258	486	12463	17680	jxBYjXkRgXQpdYQMrefy1yuTKBkX6Fi5bQBMXGziEu25LHfZ2jG	12626	18037	18037	1619185939015	orphaned
26107	3NKiFwYheXyEajVbhZvmiXVVTjU91tsJdiwnVsGT5n887iNkSKmi	25777	3NL3KNpBpxEXtyjV2J3GgBnvUZfskjRUsP15z9yZG5yFw2VqSav1	1506	1247	486	12463	17827	jxuYgpk84x2Y3MNshypsNNRuX6gYAKfh7P8aCt2qC26jM4xEeqQ	12626	18149	18149	1619206020000	orphaned
25510	3NKbioA8GS5oadF5ufbj8Bg3YUP1391vK7HvrGPLamTHKN62giaq	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1527	1167	486	12463	17297	jwXhyyo2DnrEZFka6aiQya8jnXQx13WEz1xtkfFdeaFj4okVGfE	12633	17747	17747	1619133660000	orphaned
25513	3NLFSJhnsTG98NBiCia2zMDpEHFK3TK99nY8sKuFqcvZZxGVvf9D	25509	3NK8YCoz4LXf9oRS61m53f35BSXWzaAft7Bw8efbjAyyEZCxjmT8	1527	1167	486	12463	17297	jxSt6wza4hBz2iQaovxsYku5Jbvnh8EVTVBXeYbvXsivQmA9XE9	12633	17747	17747	1619133660000	orphaned
25643	3NKY63djrMfGibNcBSss7QRmSisZtUXLFDp5LmnabDy2EFtLgZzg	25551	3NKoDtJCZNsknvgjq4QLbuHeDvhGpk7znpY9ELLgxpy1pnUUtu3z	1555	1347	487	12463	17418	jxi6EBS28RhKEiYZBG2hQaqdXMq79hj3R2TYJeU8kb4TfJtdPWJ	12633	17838	17838	1619150040000	orphaned
25561	3NKCV6vKHSb4LV95wweQsobS1TdRFXjpxNua4oH2AyFjSyUHJ34N	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1403	824	487	12463	17345	jy1yu952UT6ADCttUyavXrx75fYcr6yewdS7gqZG6gnY6DreFHG	12656	17779	17779	1619139420000	orphaned
25563	3NKWNWfjf2HcoCccz7ywLWa5RKNqLRT6CBxdRqZzf7SrNMRS4H9q	25558	3NKxUMjoWKS1GPZy9z2HGja9927ys1922U3FtKW3JCm6KxMMbbrF	1651	1301	487	12463	17347	jwcNAbd1QBFqW2UkBwUUUrVDtVXn3JNnjyBNfFXCoRnZ5QWAcYF	12656	17779	17779	1619139420000	orphaned
25575	3NKwpAPe9BJJsV4cfCEwJAm4bnRbR5asSPYCtx6hGDLnNMEB7BBj	25569	3NL9f6rRCjvJAgTa5i1BP35KYh7Pn94YXJy6HT99bQwbCSozGDWZ	1460	681	487	12463	17354	jwM8FKaYAoYcMCYqMC2E9YnkvqNqAMgaHZ1Na2JwMKRwhJCLxBD	12660	17788	17788	1619141040000	orphaned
25595	3NKwJubrMnnniT4h7uRkDbxYfjhtvB77kH1bKvGaw7NDuj9qWbSs	25592	3NLJP2xfF3tV7DWudrR9n618k8dwG6rRG76Em8YPu2GRQS4p1iGg	1590	1054	488	12463	17374	jwS9hsnrHAcz7B34Vsg6aZawy3WGRNvCEsBWRQMTr5Fn8fuzJ92	12668	17801	17801	1619143380000	orphaned
25618	3NLgHPMgao561bUjDu6UCqVvWpb8BAc3NiHJTwmbKkuy9NgXbSaA	25613	3NL59MPNCmEg5MaqTTEUajxVycmKcWVqGvUSDtzyZpyz2cT9M7JV	1403	824	488	12463	17394	jwYLgNvjUB4GmjUuzfDNnVD7CuZLLHLFqmjdMcen3yNXMafz2f8	12677	17814	17814	1619145720000	orphaned
25621	3NLW7osD87YBdRkVykkeFQfyRgRFrNKEtM89LnG7CbB9X2E1RhCq	25619	3NLZhSNyfyF8T1NUw6jSdgQwVRE52weEbCiEF6FcJHAZQqp5v9WH	1483	217	489	12463	17397	jxq5AgZfsXsb5pvocWb467ip5Vv8xxpZQfrj2mUzWub2xy5yyTw	12679	17818	17818	1619146440000	canonical
25626	3NLXPhtbXhEsp8ZRvqUEGkQNiKJ2Fbsw92kQLPRDVueA9gYmph78	25622	3NLeAgkHmKmL2sYRvLEHcfTvzsfgfuLnT5JGrtXEEnmAH8bdtPzG	1646	1354	489	12463	17401	jxKBgUP5f51zqtpSfpCMdhEpYyShmFyRh8VoPFTC3WMRiNHgXdR	12681	17822	17822	1619147160000	orphaned
25645	3NLB9kKXPxsrrn7L7xwDjUFYYQpx4ki8ZZ5buUuXMx1niWnWXmW1	25641	3NLbpfm4zjiHScgt4wsxDM7unPd36ejtds56uXp1W9pzPZrqTq1k	1474	963	489	12463	17420	jwww4PDuq61s7yyJy9sMgi1tm83WNfHezFRVFKLUnoG9B41wN2Y	12691	17840	17840	1619150400000	canonical
26027	3NKvkp6hK6wqkq7a71t3znAbcec4RQnrkXLkw9qWj9ps5fuX5Wcp	25686	3NKSS2fxqsP1D9LjoJnxi6y4kYVQQT351bkLcE9Y4KBid5sR4cty	1671	1119	490	12463	17754	jxY8EZ6u2cuZhon7g19hSj9erXquH1mVum1KFvxdMDn5eRPsZYc	12710	18088	18088	1619195040000	orphaned
25697	3NKPPrKKSEwSisk51xWgencM4hkkWyn3Dh5J3FttuJReN5n4mtQi	25695	3NLZ1pw4gwmzY6E9oB6trn9mTspBVMPfsmE9UL9hBgcY3yQyHZrq	1509	1320	490	12463	17459	jxNH8oisGHJWQuJzuKq7Rf1tm7tbZXxPmTFsViTn52vCMqezMun	12715	17877	17877	1619157060000	orphaned
25708	3NLg3WDiGcFyVvYXdMddpPNgZ8NDRR4jUxybtSDXiykGhPhzYpjb	25704	3NKGLeeUpgwc72bvjPrysL5wWzg8rSkoPnvJ1hQYPYqFYhLFtecv	1541	1298	491	12463	17464	jwndRy6dcmDufjBWoBfJ75x6NvVeWqTkL1c3XjnDNtpk1AaUadH	12718	17880	17880	1619157600000	orphaned
25719	3NKjxmkxrRoCKxHs92r5NgqgjqzFVc8x8cHkQetDwzX5UV8e8cUF	25716	3NLPPMKWycFQw3LHS6FW4VDo5SGTwEQ66Jzk8AZT27dPtMHnPYE9	1634	313	491	12463	17475	jwk911p5T7Gaj1KZ3UJic9aXs5GJSaqtyJDk2nt3U1R9vjYRjjn	12722	17888	17888	1619159040000	orphaned
25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	25728	3NK7ZkRR5g9VBQ3PbJ8KQ9okX2JZ2KkcD9oHQnfUeBrKSyGzUQvy	1437	155	491	12463	17485	jxRqN1pNrPV1P6zzc8UK14aNfpd6xezCBnsv3H98KZdRfUBZUnh	12730	17900	17900	1619161200000	canonical
26002	3NLyS5MywmwTbjGkCQe8TDs37aApKNjszpEnknpQjyVGvFTRXmWL	25729	3NKozfkdPzCSpTK7hfQs9SnFHZKDAU19WDNoEY7Z37uXkHd396sJ	1578	1296	491	12463	17732	jxHa1WLNJ5MqGDxBSburZhfp2w4GoM1b1zHQzArJHsefUjCXahH	12731	18010	18010	1619181000000	orphaned
26003	3NLxRMUkY5MbbegUHSntj661RDj1pXR7evMEq9HBuz6gxaZzRH4w	26002	3NLyS5MywmwTbjGkCQe8TDs37aApKNjszpEnknpQjyVGvFTRXmWL	1578	1050	491	12463	17733	jxJC7LPJ8rouTm1gg39BE2okAxhq6u1R5AzE8ayaANKfrWfWCs9	12732	18072	18072	1619192160000	orphaned
25741	3NKbvRPfbQVg99dMxZYjzYGFAb7D9qZoQgFk63DWkrKGFUeBzPyA	25734	3NL6RmYzojXnponr8qRqFyCxurD4GmbDhQx556GecGQrDAPa3pBj	1631	794	491	12463	17496	jy2ndzh53pF6y1d3D5o3Q1LFRGYN7Sz55J5diVkJdgf1wuLjAFo	12734	17905	17905	1619162100000	orphaned
25753	3NKwRzWwF7L3BenLLqJvVx8NL9UXPiJf7HfJf7kTCNVqWNQJSCUm	25751	3NKFM9PoRmHMxB6ULZwmnxYUKGfxdH2ayTLG5NDhWTEMMJ1kuxFV	1422	1091	492	12463	17507	jwnEJgYCzrvG3crdxKwxRkLo8FARgYt9pDSdbvagSVm3qJ2GYb6	12739	17910	17910	1619163000000	orphaned
25758	3NLbU1GuLSbD2B7oxrgiTFTiPpMAHkKM5pFpPcEXxxtxYHshTwvb	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	1560	1291	492	12463	17512	jwg4vXahFowPEeuz8aJ2w9MdZ4Dw22iEobFM1mqTtd8UQuzBfjy	12741	17912	17912	1619163360000	orphaned
25760	3NLtwLzndcRmPDeLmih49BfrVdMy6YQnKTyfy2NGbvan2uXDu4CH	25755	3NL9VhspKm5TbLEHZgqQ1LHoSXXeXNkpwDi1YMAiSqjM8G53w6rz	641	1336	492	12463	17513	jw937CuzJQpEPz9fx3YaCjkkTfkkhuyWTo87o1FPch347S5EJVX	12741	17912	17912	1619163360000	orphaned
25783	3NKTVfBEG3JG7pLuUu4ZtaELp7PxrMAqQLsStXpUti38sCfk3HyH	25781	3NKbmNs6TVFxcnCRfhn1cAuD4s3QC6ggfHWJ8fxxxm1snh9wRuMh	1541	932	492	12463	17533	jw8BRcVYfDR42spZc39e2KVoYY84sWXLRUNymPUNUUmjnQ1NeJU	12752	17926	17926	1619165880000	orphaned
25790	3NKtD6uqnqZPHn9V1kA6cT85iuuo2tADcfhg9FQqWKBBg16ycnb3	25787	3NKJgyM6WQCddpxEmkiCzxX7c9FNzcSCX1vTsJxXw5uNiDcL7Zcd	1460	273	492	12463	17537	jxXcJ2VcQg7uTPoEBWgiknCkNKRqxK5GNAT11FLYp4Ypjn7KRzg	12754	17928	17928	1619166240000	orphaned
25806	3NK8uLwTgn8vwPGGPc2kyJ2c6Tg7B3GWDWQYTxgytiDjmQB986re	25804	3NKMhpnZw1V7KfA17brTJtsB2e1JYQx9jxFytVX8uec1rkyuAKD3	298	1062	493	12463	17550	jx4rFUuLQaezcuMe2DBqUrWHJujCvs7NRKVQPT2NVKDWnoxGqZi	12760	17939	17939	1619168220000	canonical
25823	3NLFn5z6nFcHRgx7y6PB5wU4aCjk94fPmtyCQ8n7eRH32kMdEQzo	25821	3NKL6vwpQW5mG9eFi9NHA6z4QGMo33RLWxKCN8USZqPiorGM77eN	1406	1393	493	12463	17567	jwXvwo28TYEhurR2Khg51XHq27jsUyQpASPUAi23JDqKr1kxGKx	12769	17953	17953	1619170740000	orphaned
25841	3NLHvGmj5uaTqt5NuZpXy2VaApZiDUZa2QvgJn8i8HMFWwBH2bKx	25836	3NKq5DrDm22HYJwMrTn2Mw2Fb75cXKgoL43ekFStMFw2gyvfX5Fj	1651	1175	493	12463	17585	jxRoV8aUC2bbArTVANPa2unJmgS4af34KAgM6LbibbvS57Wjcoi	12776	17961	17961	1619172180000	orphaned
25848	3NLEieVtb7GuaZxNb2eRiN143NLsiXE1DifsWpdRVV2D5vg2WPar	25844	3NKrF8FL5cS8xVFk23KMhrDWa2Rk7Gocccsd35kJSKZC1ouW8aVw	632	1382	494	12463	17590	jxGWTAzDsga7mxfoG2abdSkuk3NTFtDkdhHqz7YJzzQgUmvNMsk	12778	17963	17963	1619172540000	orphaned
25856	3NKANPjqR8yhbsiwX68uGfypPisMjLkTh1XjM2Me9xMSst46x6qQ	25852	3NKYJhLAUjm6RqzD7LyKRWft8BsqoHqxToMwE5o7Kn9EvmVGFK7m	1523	1321	494	12463	17596	jxdSr3DYVTPPjGVjVFNN3DQDSK2wB17o8ahiKPe323ZhgLB8HGe	12783	17972	17972	1619174160000	canonical
25862	3NLqMHAjNVnVUmUKYDwk234ZM312KkZANvcjGw8oR28YZwQBPEfD	25859	3NL4N6tkn4LJB8s8WfM4bn8ukqGHg2mio5xWF7mb2UiU9AGsFEZB	1403	824	494	12463	17601	jwsSTYHoXnUrW33j78SCXqAH8X5bkGqCZSFJUtf7gqwEqQEQSKy	12785	17975	17975	1619174700000	orphaned
25872	3NLJvuaYA6G6j7WGNbTvhK1RgusVEJ7eJVKVTBJDpt8g6PK5SWyT	25866	3NLB3VXFusPoahXNfDStvJqmQjPeRoCbG1bUiTSGvQRbYUCGDLyc	1534	81	494	12463	17610	jwhztVt2eSw2tgtBLErWthkoY3B9Nxsh2JxWhMbX8zMvyL7quwr	12788	17979	17979	1619175420000	orphaned
25893	3NKpqJDeKes3nSdQTA62AS8JetnzYGrpN7QEeMHf8uqxdB51Z5qF	25891	3NL8j1A7kCbP9tyQLQy8n44UcqqHy7qBehscxtWmTXbAngSeEMCM	1596	1237	494	12463	17629	jxnD8G8i4hsZzuuFKmZYjWgfQFQqpEiQrJ4Qyq24wegFUTXFXUF	12797	17992	17992	1619177760000	orphaned
25902	3NLVyozckDUMLUsxvr5WtTfQwREXu5gNNDoMc2rjM53sLHWrCD9n	25898	3NKXNEdAP6ig7QT9ame7qsfNdRidePFUCD3WFfmgxewdajXzNAzg	1501	1360	495	12463	17638	jwT33y2RN6Q4AXXaZUYCT4wYwLYVSRudCk986tYfyJh6qxVPty6	12802	18002	18002	1619179560000	canonical
25916	3NL3iLjDjHS11wiRwwEDv3hzhEikeGKFp6wX878MectFwfVpDdLj	25913	3NLVCw7WYujiaTS7k1DkVr15RE8dwr715x8bTqYu6BCWxAXyR5sK	1500	1297	495	12463	17651	jxApbmSqUDZC8KUxHrAjaHHeFfHQ84rte9ueAGTqcBTwGN3bsV3	12807	18010	18010	1619181000000	canonical
25922	3NLWDtrLmNZvXHhB38wsXHWz4J8BCHqVXSyed1m7BMgQdRJKBfLd	25918	3NLRvnAiC24QXHyB12zWfhynjda9LmbczwcReyhB3vW6jA2WdrQ8	1527	1293	495	12463	17655	jxbAYqt2yGvTJe8BiRJiKquqwEL4Uhx1hdvm8YdHZ4M7nZF689s	12809	18012	18012	1619181360000	orphaned
25939	3NKnZ9CUbRY2vDC7oKaX4SkurHX1mjYzF2CzQxjxS9BayCfhT2GP	25937	3NLrzrLZmQpv3XRbYoCRYrwsZY9tBK1XGn2NYCadLYuTKj23LdAh	1537	227	495	12463	17672	jxmE6j21c3rLCdZD7n45FDAuLia1jDiwRPwAtw77FMm51URgkWn	12821	18034	18034	1619185320000	orphaned
25959	3NLB3shnToiovLeV1RsjEinK9onaBCdnCcfZNSwwboDZGZnBE42J	25956	3NKNTgDa8vLEgWZg8y2LjarmU8R9n4kVdhfvQgd66dDdJxA71aWY	1611	1341	496	12463	17690	jwGviLjHrLqNCuyaCae1r2NVKtMsTdQbbY4yJMhU72jukECB7R7	12827	18043	18043	1619186940000	orphaned
25965	3NL2YrtSb6imTYGz97SHc8r7MxQuNRSjGaVTFjp3DuD5uG8rjzbP	25960	3NK5qmMeN61aHZVGqSnuLhi3J7WcNS2tbfWkFWhnGXs6LDH5cMF5	1581	778	496	12463	17696	jwzSiDDwcaNoesT7yQJAn5jmePoqVqCJK8z6o8cNZk4A5u1qFTW	12829	18046	18046	1619187480000	orphaned
26280	3NKKcX8rkc1kmqJhK1DMMa3degJ73i98iqSWkBCYsmxwV6TUt1TV	25967	3NKk9XxZy8afJm96nMW78wMXH58gEQ4T7hWhM51DJYMpSLeuh5va	1481	790	496	12463	17991	jxTxJqYNbg7iCNTszq83o7EkpiEek3HWPyWcA9seRdrTt3yyR7k	12831	18282	18282	1619229960000	orphaned
26235	3NKyRwWNZbcdWxPnkNz4eBZKBS16oRQc5rYfKWkJW5U7wymsu2P7	25973	3NLePP191qMoR6XCQyDSE8Azd7qq6ReJeXRdDsQnQVJFJo9rEp6A	633	1384	496	12463	17947	jx8qkrqNaQZZeuiWW2U4VLVjjfcJYavnQEaNEL4ZxvuWaaE5Azy	12834	18245	18245	1619223300000	orphaned
25994	3NLV9on3htGfcsYU82VVbrVUDrjXVT3L466HTLs8KLQeyh3eC5hS	25993	3NLQQLkWStcU2HJXX6WRjdxx74DFEJyjTEGTCZontVkvYGNZKHvQ	1587	1111	496	12463	17725	jxBFV6BMU35nesP1ZjDaAocQXVB3U2Vb1mV5Q6EGYT7hCFTuysy	12847	18069	18069	1619191620000	canonical
26190	3NKeHWCFwiVuURuZAmWzfCJwzxx1j33P3fLCgpknmK2n6qDKKSVU	26001	3NKWC7i2Y9CeV4nxr3fMKyEaPCcxYtXnTLp52SLwfabgMSybdHMS	1617	1288	497	12463	17904	jx8bCmHS8UTQzXSBm2XXeRR5jEcrS7mZt6oZWV22cbR3q4EBTCt	12851	18204	18204	1619215920000	orphaned
26409	3NKdoCDz3a5KH1V3kQ97Ei571jTd8eN34bCBsPjhGe7PBV3yg32j	26225	3NKGdU2FtivFq9nC3MPU6QwEonsH4WrsL5sngvKK7TEA6tbLmewu	1617	1288	499	12463	18105	jxA57u3qrtXdjv7fdocwBQXsBsFRusgHn2YX3heXK6rjVePn14F	12853	18379	18379	1619247420000	orphaned
26019	3NKhN2T85x17JpEjrYhzQSDisJCUVM2RC83Be5oLFT1dYSP7Fx3v	26015	3NLUHhWFLiz59XxYQy4pjY7RNbuCsUT97J5zVDxtmVdfmjcr8zVb	1476	1125	497	12463	17746	jwPgUqgESByba78Kvpq878C5H9txHm4F61am1TFkysKVHoCCCRw	12859	18083	18083	1619194140000	orphaned
26025	3NLMp7KrkFSNb9rQHb5zjdwiDEjJYsy4aLGTkgReTomixEKJGLwk	26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	1610	948	497	12463	17752	jweGVfyCqFk438DninbneTsTUMEBJ32wDPAhgZs15iEVL78kAtK	12862	18086	18086	1619194680000	orphaned
26060	3NLWo9kiZe6s1zwtsi4KLPFhDFwPCUcPr2zubfNRZwEKuxkzRkJq	26022	3NKnb59zvBwCNDv3Ht4XaEkX4fhUxMSsXdV9y8FkQb1YVVh2Njc1	58	1281	497	12463	17785	jxLJjtvoLHZz6FUECSiAojad8d3cDxAbZukgs2cDfAQ22X1MhdW	12862	18107	18107	1619198460000	orphaned
26240	3NKgCgiMB9roA89Tas2akGHTzygz8xEuEB9hq4X27WG83ebxwBnt	26023	3NLj8bzDicfPcp1VdLRPPfvY7zDNFyUZbsAJWtDiYkiyPqRpRcQT	633	1384	497	12463	17952	jxLz4GX2se6ub6tk8rAg6TcVrSsHf51XaumkvQe6Xmd79UZS6hC	12862	18245	18245	1619223379502	orphaned
26193	3NKZUdBqfgYRumpJJCbkRb3cTbVkitb3HnAFfxpAQz6SVEsnXTd7	26060	3NLWo9kiZe6s1zwtsi4KLPFhDFwPCUcPr2zubfNRZwEKuxkzRkJq	58	1281	498	12463	17907	jwG5doaVEHAF92kSWKrD3J9TdeyjPJ3PmviYWuJLDrc5mvRwJ5V	12863	18207	18207	1619216460000	orphaned
26057	3NL42ce8CykPjvGF4zNhpNB7xzfRnEAbhcHuDCuFJpjq5xxe8Qfc	26053	3NKWv2caXvrEmuWSu9REFa7wWadvKKtbik67WKBDbHzLsQVWJQNj	1560	1045	498	12463	17781	jwsjSE6aCRdke5kh4cf76PFXwNNXZ7ewsXZnh5q2NRnDTeKsTdA	12876	18105	18105	1619198100000	orphaned
26069	3NLnwKkwzgJnwyke45zcBBdkpzoXgo4orB92wfE4oxPyyKPV7FMC	26068	3NLnjbPittE4nf42pdMU2gcomXrNTAhaVdYqVtmrrqSzKvECsbrq	369	1186	498	12463	17794	jwyEaRDr8zTCwfd69fg96d5AaQM6UCLnrfKchVKQLorFpy4e4dv	12884	18123	18123	1619201340000	canonical
26086	3NKk1UrrsuAkKEKCZTDdGApMbjqpZFBKRjbrCGcqZesE7vELN2ou	26085	3NK4p7CrNjdPFWy2doujdd1tspoz4RpjY8z9vnwusFhAC6FYUhPM	689	689	499	12463	17806	jwoHQhX55qm6sqkvC5SuFBWZpca8TEqm1SVNu51ebRJrEGb7tqj	12892	18135	18135	1619203500000	canonical
26392	3NLk9KqnyEruF13Y7VpwvQHhPfHDAZGRkhq4qRSYbLTwxiNMw28o	26099	3NK3cgrVKfvEYk8iMNUxggmYLuLw3prtwrNDRgCjqyKXsr6okzr6	1602	1369	499	12463	18089	jwtcuJn7jgFKgUbFuWMu7hGgrkTQYCbcKdY8Wue1zMjxD5HWU1L	12900	18365	18365	1619244900000	orphaned
26101	3NLok8NeGQr2HuCYVE4FfECFq9WuwZ88V3NnWzyXG8gpNf2mSWTw	26100	3NLXDRrWjBb9oW87NhT3ZAW4WxekMzUQujTQHPhzL8huxD135xz2	1514	39	499	12463	17821	jxNZfQCqx6Bij6pqaySEyy2RNfRLTNWocwrNjUsgcAWtMzEPd5R	12901	18145	18145	1619205300000	orphaned
26130	3NLcuG2FDkN48DChdRCqBhRpmxdC81HZggLwaULxYJp7gQ9PiN8n	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1423	199	500	12463	17846	jxAfjCizfpTLuYjeqAwfFKsaoRJveRV2i3GV1ozHseFVBbEcLNA	12917	18166	18166	1619209080000	canonical
26131	3NLGS1u8K3AFdpYYvZHdF8FwYUfW4gV3xfTLA4opthXuFT7Ju4kK	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1403	782	500	12463	17848	jwdanMdF4X5CDedA9PyuwogsF3Y4DsHvwmjVfEEqSFdGu6xV4kY	12917	18166	18166	1619209080000	orphaned
26149	3NL1Ak7NaDS473QEieQW5enXmyFfwVkTtBBUcv7qwebyjcVwkLRt	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	596	940	500	12463	17866	jwXsfMKit236iDFVUHpoQJA3GCnHcY4uaV1KPCerSnaqDE4ou9C	12917	18178	18178	1619211240000	orphaned
26129	3NK5hK7Go2pRbXY6hKAcdUK1L58NVcjL6PaUqEXZNXLtK4ybW3qs	26126	3NKpB1ns8mtCuPzfYGLgGYKGRJ7oHuNopumNHw8vMR58E43yWVzi	1489	1380	500	12463	17847	jxq9FPxhn2b5t2yg7WMncGXXia9w67KR3iwng7ZTbWp2vL6a5S5	12917	18166	18166	1619209080000	orphaned
26152	3NLJKzXvvFMAJv8SPRovCDkb7o3nPX7RY9k8ZZj9xg9gHzKCA5MD	26148	3NLGeE2kLRKbAqim9R2JW1cPPKt3cdzSvWQAfytT7FNt4qyLaFS8	448	1059	500	12463	17869	jwhQKeWqAGxervomujwpSjqTg3F4FU9NhmKBHXeHp3Vq2dTk5E8	12928	18180	18180	1619211600000	orphaned
26309	3NLs13ZMzYFLkTYFYbHZrfpEBFqTivrs1YXxC4suCtqL7zdc9heZ	26153	3NLZNtnaRbf3GQo9ZruS1RQ4Qe5vCmBbKC7JfjyFp2Y5ZdgRmTrW	1555	1347	500	12463	18019	jxGPb22z7X8G7PHehSwJTmhpCczpjrAegW4Fsd7jZK7AmzPVq19	12929	18308	18308	1619234640000	orphaned
26184	3NLibb1cfnc2BQD3iXnssMr5Sgx8zdSt2iJvBf3BGMTVfiihWbni	26180	3NKQ1TiXmqqysNu2XrAC2LgbBSgcpfkC2HtzXCYGYJRcrVWnTcae	1527	1293	501	12463	17897	jwNsBsDtE4h7TWaeNdENbGjKjcQDF7pLwqTpQav1te19Ac7TQ7d	12944	18201	18201	1619215380000	orphaned
26197	3NKpwbYTB6SADxF92Vpjkiwhd6AVKgvDCR6vdrVpQcJ32XTFZeQd	26195	3NLbZDf72rsq69Sd1TmGtJmXDCLmmh3fMiYczB4PUndo7y5yifsk	1489	1380	501	12463	17911	jxigGZkqRugLEGxZVKtrovfugzN5DhVYZaujUz2pdHnYhvM8XUF	12950	18210	18210	1619217000000	canonical
26209	3NKYhevTR7EUMZCetstNyyLzGXS4xrXCrz25Voue9uL83ceZWbds	26206	3NKzy9hDw1cbC7mvoJjrsa32ePECXjBpTpVmoLTRkhjr3nj8MGwy	152	1084	502	12463	17921	jxwCcYbaP2RBd5xD9BwKQHXTziiQVuFrW3oDamay4KZH2DLEf8i	12957	18220	18220	1619218800000	orphaned
26228	3NLv5EA4AqQMLgiNm63zHoX1twqzQNE2CGgaYkpK9pqS77ML1Cuv	26226	3NLvknuZkc24DX5dGm8kzgMgqkYdUFgEJzMkU4XDHRFV1jq3TgHv	43	1064	502	12463	17940	jxTCM29fyugbTiEHwTUhqfSErRGyUpAnvjJfRjJNgCKMB9WBaas	12967	18238	18238	1619222040000	canonical
26238	3NLG3ngSiQ4otXs1h3wGs943TKxeEmE9qpnVPdFTwoL12ETVXTyH	26233	3NLPA4YTiySxgasq121zThYjXHNLPchuCXcom1zWizSWRUeGUQhm	302	302	502	12463	17950	jwfL4fwiYEunevFBdcvzsuFm4vVCAT3eMqrCtW7WQWB3wxJwAuq	12972	18245	18245	1619223300000	orphaned
26255	3NLnML9KR7CTKQXz4tMn25UteXtVVeTCqAscHGpEVnq1zBayjUkK	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1406	1393	503	12463	17966	jxUcQ6EPJpZreGyGY7JM4NBKa83qthE3rxuiiBHGt9LpQ8kCRk5	12983	18262	18262	1619226360000	orphaned
26258	3NLQyfPKT16A2KatC4ryhKwRF8q1pm94ZAZeJkk4hTWSTBHLoEam	26254	3NKXVsBjVHxVq2HCyMR9BJhRNfPjEueKMWrfv2fztqtc3fFRskX4	1652	1315	503	12463	17969	jwirBGoTrvG72GHM3p4pHN2XfauXPQJtasmQwRwvRqS2gdJUjq1	12983	18262	18262	1619226360000	orphaned
26284	3NLBdDRKqDrG5A6GS5UYBWhzcGYBjpNfKgvdFps3c4ekXGwD5N2C	26279	3NLU7skZp7kmnjZ2rAGrQT1faRZ2DoGwnHQ47pDk4DjX4C5Cm3Gg	1403	823	504	12463	17995	jx4J33oQjarYx6hZksH3Pwgp4tMx7WuFShyaJTq4JFdQ7iMp7Nm	12999	18284	18284	1619230320000	orphaned
26294	3NLXy97stCgN65tDtqNkQ47T5VAuRhMWBm6h72kyNrD74uGV9oRC	26293	3NKidoHfqW9nrWNQ5f3tT4VjZjvWGcK2TFMPKKZWK2jJViDbV31n	1406	1393	504	12463	18005	jxWNBasyvyCsXmvY2XJb88C6HG6fqZACUFoN3JeuHfRbmCGJhMh	13007	18297	18297	1619232660000	orphaned
26311	3NKrsMgeMVhpr3mX5FuGhMqzuGi4TfjaisWrU6bL6SSHhaNNQx3c	26310	3NKFGD98mgiRbQEXTSzi2jsyFG5F7uCdxnpNpzdLVcDghuY3aNPF	1529	950	504	12463	18021	jx6ZpJ5gcLBjq65d6B8kXyTPr2RsWGSA8sd11TW2Eq8SwnpaxPD	13015	18309	18309	1619234820000	orphaned
26319	3NLsD3uv3rrAhCHy3xJ9d2y8phrrjC1foCBszb6Tym8VWLrxGNw6	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1406	1393	505	12463	18026	jwzfxbXRz8nS8JZ1hDQz5ZnvFiSwsCH8skFeSU3ozqbDGmJk5jv	13017	18312	18312	1619235360000	orphaned
26321	3NKBzC3fCho4ZphGQFDB9pezog2LhwvKQDRUjjqLf9TDUSBdKGWg	26316	3NKopP7SDvZu948n2HZ9PxVRtkfrJ6HvxyDQTAKgnWfAZTUBPkCt	1509	1074	505	12463	18028	jxov9o6CTqdBbf1rFMC844SeMkDbvfHpjQoL7p7eh7R4stjWEYj	13017	18312	18312	1619235360000	orphaned
26347	3NLg5xn4keT1HaRMqWwe9XXbJpRdNBdrXY2BSZ5Y6bKwTnSjRvqF	26342	3NKhXMLmWcSA7f3eHGvA1HAcmrm9kyTqXmhuso28ChFPVyTRgsAG	1624	1208	505	12463	18048	jx9vACSap4nvx9uXE2xNFJ2nkjjFQyUTBoo7Y68q9F8TtbhTFeG	13028	18327	18327	1619238060000	orphaned
26468	3NKVY3Lu5HWTQcTojYSXyQm5AJu4vpeM9VS1XocAMaRxTQThGFbV	26343	3NK7udsrdgH5ggBspVzW1DhowSE3XGFoqW1eCo9YpcA4smvsfAtP	641	1210	505	12463	18160	jx11d4g4tN4A7oZyddRHSSX1KbfCDGQfqm6LTDAtFf7Yr9gpNmv	13028	18415	18415	1619253900000	orphaned
26776	3NLDgFN8Ctbiokjh5adkNVgFv3Wwzhg5979AVwbYGWNy7LH8rimn	26468	3NKVY3Lu5HWTQcTojYSXyQm5AJu4vpeM9VS1XocAMaRxTQThGFbV	641	1336	506	12463	18439	jwctY4UvTg95GrfkFvZ4YNfW1YtJwKhs7NyPyfqDDhZHKC19TYd	13029	18636	18636	1619293680000	orphaned
26364	3NK3fHzmmqsGbhbMfR2JCsXZfRPizuDjJvxVkHgcVwirqNhGv1yK	26363	3NLCrM2m9mhNtGFUSxePj5kYDTZbjDQFx8pDCmiHZz9rEEZjyg1t	1508	1387	505	12463	18064	jwdzZgGrhbKt98HF8zVdtKkE9jhfQiL9Y2Wkac8cNKdqfcXzbG8	13038	18341	18341	1619240580000	canonical
26383	3NL8DCVo38zutccbnrCpQ5cuxAucRUuGdvubqixWYRS6AbQvf2S2	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1527	1167	506	12463	18082	jx8DZywWWxnEovEjcGHvbFz79pPeLXwTRaHzzUeeap5mfzDUgTA	13049	18357	18357	1619243460000	orphaned
26384	3NKvXn2LsWPty8Yv3SXUhaXNEwEgaGqXza1cy6mE3pwH9FqrYfLb	26379	3NLq61yJhLb1WTGTKc7M8UWwsjiEUbDEpW5JPnp1R1W82cptDDuw	1527	1167	506	12463	18082	jxv375xXYjKqZ6b7skjNK6ShENkL79eiPXQqX6jXHqVPoC3nTnG	13049	18357	18357	1619243460000	orphaned
26706	3NKtPgerSmwqETaLWMEfjgko55HhSQhf4QXB4c3prGsinh8L5N76	26388	3NLhG86LTxr1xyPxMLvETcJiSNsB53ufXCXMAhEujVdnuwaCB7Pw	1522	1322	506	12463	18377	jwqyTpVYuyPFs1XbLggxixdF8HDJgmnKaNm3AfWmEaL3Mncc9mz	13053	18586	18586	1619284680000	orphaned
26494	3NLbk6vnEQEaBgk5kSoFngC99uavwBgXbW7Ux8Eptw7PxjKmnms7	26406	3NKPHJZAAAZYUxH9jtRDVgWhkcrU36Y9uhzHNgE8fDuJxoWfcYoH	1648	1158	507	12463	18184	jwRgMJK6qf9zqsXaDMX8YJscAgeFuyjnP9mJXW9UVWdvX6csDXk	13060	18434	18434	1619257320000	orphaned
26467	3NKVy6RXjNtRM1npdvJ4uFhZuq7ec3TKGYHBcmZJXXZNPRJCBEwV	26408	3NK87maaogcUy6sjFWfHXXaH6NARfcYArRJF4yvLGsZAK9CkHuNp	641	1210	507	12463	18159	jwKajJSGCK4WeXbGfH7YycRZcrRi4xpnnaX9qT88o9Cjkm4rLbo	13066	18415	18415	1619253900000	orphaned
26775	3NKAFRtnpV8TW4pmfAkztAWYr4MxTZrsHgeRstQ6bGCZ2Hdex5HP	26467	3NKVy6RXjNtRM1npdvJ4uFhZuq7ec3TKGYHBcmZJXXZNPRJCBEwV	641	1336	508	12463	18438	jxFqc34uv4v3MVTDm5gu2oZPHiwQ9CcXEBdNd8RdB3k7DKCbQA3	13067	18636	18636	1619293680000	orphaned
26564	3NKszAvbTCxYXmrekj1Uz9MC7WnFU8oE8LKyHGuwh6KJD2FiT1Ew	26455	3NLsm8LVSebP3ya3ouvczK2DG7FZ6JSKep69yZ7SKUvswKzSH6cw	1402	874	508	12463	18251	jwNrG2ADouwbcGHU12RYjYHYefw3rjbxhJZktWVKe7gHf9voeD7	13069	18486	18486	1619266680000	orphaned
26651	3NLqRvvVqns4MZUSM3fV4A31492HuqZPTk3NAzfzBCzhcLg2gP3j	26564	3NKszAvbTCxYXmrekj1Uz9MC7WnFU8oE8LKyHGuwh6KJD2FiT1Ew	1402	852	509	12463	18325	jxG3tCY2qWpqg98x14Xd9LJZ4nL92BcVsZyzky6EQjQJ2YFjY8g	13070	18548	18548	1619277840000	orphaned
26419	3NLZPz1ZbhL6aFiRfVPVMjHrHgiPcFe3tngkaCoHa1CfMqi1x91H	26418	3NLDAd5SdWipdjv6kwSFhWTHsfURpaKgDH2JtfndwB8PGUDgS1NF	1406	1393	507	12463	18115	jwX1CmxL9pMCDH3KL6NnBCRbnC8CHhqdffvpBP3wpVeDbhtnJJf	13071	18390	18390	1619249400000	canonical
26693	3NKhDrTDVW18s9KToKvgsKkocM9DeydXRKUQ8SqkRixCaHAmhrp2	26689	3NKyBoQMktbcqyrbVHQkYar7Tde9YPwVTTQaiTgcoESPoFeJVGvb	1402	866	509	12463	18364	jwz2vqV5kFTjCCMqh8Ah84pTDNhiDdSwysRQjoPnznR4RDTryU4	13074	18574	18574	1619282520000	orphaned
26435	3NKjVfHBBE8kQ5bP4BozyrwtTRci6jekkpnvaex1pDifCfHiF1Ab	26431	3NK5ZEwWj74gNDaiaKy5a64aH57NQwDANghpRbTpNLgSF1aHaNxF	1419	813	507	12463	18129	jxiGFLBx3JEqZ3bBa7mUDAgph49eXPFKw7yPGeVHonefzLMm2hN	13077	18397	18397	1619250660000	orphaned
26436	3NKY1y9FeCsRm9ajiohDTMeiExgP2gKATpZCBBYG1SvTpjAYPPnj	26432	3NLUKjSUKDCENQgsXis5CPMYxEk9C2yaY7s9jN7zzEG392Jwcqyr	1444	1381	508	12463	18130	jwdkyCViHMzackpG8P6FmENhnb48SG8XqeZNqsKTYLpQFPgsgdH	13078	18399	18399	1619251020000	orphaned
26441	3NLXFjTwtCmqeDtS7LyBXnt9EqFH6oUvuXciBhKRGK3bxRU8dKAj	26439	3NKY1tVsuwXvUKTVvTiyrHEJ9cHP1NumS3jQ7qrpwvn1sT5mh5H6	1613	1349	508	12463	18134	jwUB2JZ4rTQzv2YqzZ8Zr4PKq38rCZFgbzCD9HpPThbxTQSYb9j	13080	18401	18401	1619251380000	canonical
26473	3NK9iuLKDKcESdfCRwH9tKLPJMaEGfoJUzAiFm62itAdD5rVf3Fa	26471	3NK7q97DfZCon2d4oPjqmdScM3kNiQkVAZhFcEMWkJer9yKh8ysk	1460	1078	508	12463	18164	jwr1zFQYvY9r7PLGomDD41QGfGvuZjti4GVB4tmxz22Gr5sKtoK	13094	18420	18420	1619254800000	canonical
26483	3NK95QcdGTqoFFSrnTH9i5wxbQcWbnMa6uJNDTwEiotN84zZvYe1	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1506	1373	509	12463	18174	jwJPe54MJxR2wXbk1W5PwDngwDNKP3cif8x3ym6JEHQZWbYXQrp	13099	18425	18425	1619255700000	orphaned
26484	3NKGjLmtge1vsgeqFJArHtBPGQBj9HmeAM3eJonWWHe9MnieUJnL	26480	3NLYmsoFZ5gR3JcK3k9B8zgctxqGxJznaxJ7J1deRsAdY5NGQmFM	1506	1373	509	12463	18174	jwwKhirmsMjsLqejqYQ578hwbYoKpb5FNMQbyLw9FoqQ5ZNWMVL	13099	18425	18425	1619255700000	orphaned
26504	3NK6bc2dH3oAGpxh1hzNnvCLFxEERfRfmagJpMwUytGyhU6jTTQV	26503	3NLGdtRakDofiodSSNnhUy8NXHfNZxyoqaSbKJyqPJRFhYte5cxD	1407	1395	509	12463	18194	jwRWnjGtLnxXKV7ZWJrG5g3o4ADPrG1kxvY2QZadfBVx8DYW6LN	13112	18443	18443	1619258940000	orphaned
26512	3NLPciH9fFTPHi5YwnF6cBWYgx6XL4ZPCYxWJ7AvjyNnQi8UZjS1	26511	3NLxfNT7PVaGBWxZRsq1SoAi4o2vaGU1R6NoxEhvanbsfiYZM8cX	1631	794	510	12463	18202	jwy49DHFdnqWC66wFPPHk9EX3U9bAVEm86Xk7fJEkcWZJpz1X8Z	13117	18450	18450	1619260200000	orphaned
26525	3NLcZ6tyYqvqqPiQuEoSU7AK7M769Y7u6ByDJcYLQacSobGvUYg4	26519	3NKheRgs1xMd1Njm3AacbPEJZCZd7mDkA2gJSbLmMKjG9wcGQTXh	1643	1173	510	12463	18214	jxfvEMcCoWQR7VTqCrkgYuYXyZsYtk7Xb3vVULdEbm5mBtCwgyN	13121	18455	18455	1619261100000	orphaned
26823	3NKq53pXkzawTeyQ1Azf3Azkbgs6PCCmencDcK1s2riYPwGXQcwD	26747	3NLFM4waNowaokNBNLARxPrpjdFZoxrzrFWGLsYwLqf1pSKv1SEY	1654	1340	510	12463	18482	jy2kBYED2j3RkqsLyErabxruNZwJ3PQFjoXCjCaCCEGom4fKFCn	13126	18671	18671	1619299980000	orphaned
26546	3NL3svQunzJUNzHuLJL51W6n1ksD9gjh19UJm5fMQEE9WreND74J	26544	3NLj1c3Bx9LNfnh2RqxQyGLP9dNAmXdnV21qSiePcwQV4wphNVcJ	1406	1393	510	12463	18234	jx7wKJyFGvb715E2F9jZTTBi3nkbuL8o2zqjKkMqAZmAaZE6Gbp	13133	18474	18474	1619264520000	canonical
26562	3NKEWamVwbHfXUAMVnwy4wFXwx8EXmfZGbphLJtc2Yw8CZBPVrUR	26561	3NKRvHnG43eSV1Epy8wzULTtbKuxUT757RdWiubeJLmss4egHrtT	1407	1395	511	12463	18249	jxLCzjmRbRDCabXCULvswdxcHZ7XGooMecTkG6ddkmfsCac5xtP	13143	18486	18486	1619266680000	canonical
26754	3NLoCoq4QMw9RUErChNfRzBWk3ELQVs1N9oUwiHDgMofjBJ23TLd	26571	3NLo4VhgagRwS6ZqCVEVjwRNcbqRNz2ELqMeGHdXZc3LCnUH4LV7	1405	889	511	12463	18418	jwBM9nyRbo6a6bjiYUK3QbRKRGBKCwfgx9Db2wYQ9NQj3E1cWra	13148	18617	18617	1619290299169	orphaned
26582	3NKqP8PULko4AsqpqUBtc1CnrABH5bBHatH8FMhxrb4EkQQWedN3	26579	3NLxGD2yfBrFkw4EatnhFYU3kVotksCK71pFFUxsFC1gXqbs31ah	1426	1364	511	12463	18269	jwuGtHU6kDrNz42TnD1kwuTH7Fqu1Z46sR4JqAHAq9in9onXCCq	13153	18501	18501	1619269380000	orphaned
26589	3NKJ34XqJWW59yGeAnkT5BeUhwPGF86FYgeDUSoMeSfjR7uLVneN	26582	3NKqP8PULko4AsqpqUBtc1CnrABH5bBHatH8FMhxrb4EkQQWedN3	1403	824	512	12463	18272	jww1c4MifZ2uZqMEH7NZ664vz59CBfJzSnUrVhP7QiGJCKp77pt	13154	18503	18503	1619269740000	orphaned
26597	3NLjtRfpN53bCEnnJCXCpcfbnWVZHWDZNv7x9swtLdtqB9oL4PkX	26592	3NKVSW4VUjSwFx8jENduQ7jfWZpAm7j3oXMdhCfLqANZvFEz351J	1403	812	512	12463	18278	jxNp6wXFtJNbBfxQazX1j7cwQZWxjSFrxZS99EzQUCRCGeCNsPk	13158	18509	18509	1619270820000	orphaned
26610	3NLW6WvQJaMjBoDgVC4iEtebgefZhqFtABk7it5g74TrkMeLYfDV	26607	3NL8tfxGRrWvQdJEyBF6xZmjYdw29dtgeAN4cPbNcPBA4XT4FXQF	1407	1395	512	12463	18290	jwNMi8ow8mSVX2yeRKbGjdEjXJHNRrhPkTGQiqNsr7ikKCtTwu9	13165	18519	18519	1619272620000	orphaned
26619	3NL3t58mdnU9347fJNZPtjjm5G92GvruW2kzuKe2BnJzL76yydtf	26613	3NKSevQFX65Vd9mndLNMtVtRYqrEtraxY5pp725ghZLnnZy2Xiqm	1594	1326	512	12463	18298	jweDhoJTfJimGJ2a4c1WA5z3r7M88wH26MQQvumYeyo4Upk9bfs	13168	18525	18525	1619273700000	orphaned
26638	3NLGrVGigniZQwgdKPfn9UKuHMoXxL1GjAdG63xnHMXiS8ynrkEE	26634	3NLXGrcLtoU617rh7D9TAKDVwcES5d2Qht6DdLWBFWQti5iFzErK	58	1281	513	12463	18315	jwVKDrpY6vcSKermC2ssENd9nbwcuZpZPyCr8Ep6K4xN67MGVT9	13178	18540	18540	1619276400000	orphaned
26642	3NLvcw3D9sNmvt2vAyr8WoTvMqvJkF6RFZah7eozhffnQrdojuVW	26637	3NKczvqVTHivvhEz71wa4K5ef4Aht1wn1krR3FbgJ1LanrL2Qji8	1523	1075	513	12463	18316	jxusKQxvqmMz7J5xUpRoph2VTRcvyvagFAdfbwrvWkoXzWgMPL1	13179	18543	18543	1619276940000	orphaned
27150	3NLMwycpugNqKGqrd3utyKevYD2KDn2UWSfqamnTozxxhcUtULJT	26640	3NLb73Mn7pR17uZdpDfRdfVqGP7kKuuJrX4y7CEqapENFzim32PP	171	1248	513	12463	18775	jwxsM1D87SJMhBLWSQqJVmEtPi6tJM3SEQkSazdqsNC5xMvj4Fx	13180	18894	18894	1619340120000	orphaned
27180	3NKo4XzJyXTKUZqY729fHVqoGN4oTTBsyocm5GRdYXq1iCCG3bVx	27150	3NLMwycpugNqKGqrd3utyKevYD2KDn2UWSfqamnTozxxhcUtULJT	171	1374	514	12463	18805	jwFJhxPByBFaL2BDVHrc9KgEcWzRVb4kA3wuG9L5RLHPGU6euf8	13181	18918	18918	1619344440000	orphaned
26655	3NKEQP4ze2CmfaNCjWEaerdyn9F5YfWzqkbtv5aQxRLi48VNR4LQ	26654	3NKu4cnPJygajZyyAoYmdhsqpnkfbB4JssqA8yDt4rNjPfrq5Byr	1507	914	513	12463	18329	jxgv1tvk6Jy1gXVWfrnTkPiGRVzby7MQ2BexQCCoGnZjoXuy9x2	13185	18550	18550	1619278200000	canonical
26668	3NLcsBRmghDvPQ8zcgQFqqjYwKHQWDw7vV6W29xSqRtuQ3MU1n6Z	26664	3NKSUCjhPnJKXKjetRS4x4zsR3xssteKyrJtkyKdyk3TSE1f5R45	1527	1293	513	12463	18340	jxRJ4ianPPUyPWs6Tknykn9fx8UUnncJaeobBfjVfgmGFMpVD1s	13190	18557	18557	1619279460000	orphaned
26715	3NL5n8qMG5Qaxmee2uSxdoJCVoQDRYVFWGHJRAi8vnmEYJSV9kht	26714	3NKiACMBvv2WxpUk7WZh8tFwkyFrFAFxt5hU1e9eBWj7FdnRazZr	1593	1346	515	12463	18385	jxAiK8tCgvNX3bJXFfpoqVGo5KuqZ67LADAVwE25jJhGBY96Xqv	13214	18594	18594	1619286120000	orphaned
26727	3NKAF1PUBZF9ftLgtpUWdLMGnYbe8LsREhraPiG8vTX7R3jY7KVb	26726	3NK3YY8MmY4pJ5b9kQsTdT4mVUVZynx5Pu1wVNgdS9Pj4FwPB9gS	1607	1102	515	12463	18396	jwcDTDtCrazLweQhnfuKnBpvXBJ8A6tVgUWpCnmYiJZ5gBxbmtS	13221	18604	18604	1619287920000	orphaned
26736	3NLpPQig6E7ZL7am1Y3UvcMxjQLc2yDwExnA8Vpjmn6SveEdojxW	26735	3NLwjYj4T9GxyxHMZ3QEedUfcnXCmRz3KuBAMU9T49HCXyGy3Xzu	1407	1395	515	12463	18405	jwgABBdFhzD2JD75RKaLetCbA2J3ZJsX685GffyHGrKXVKJKfka	13225	18609	18609	1619288820000	canonical
26740	3NLVsULm24shm9SdPLgFHRmMGYTuWepYPJSg6xJC7qCfbLwGKh6g	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1560	264	516	12463	18407	jxT5cgRoBXXrHgz5NNi4qiuGVQBvkiPQby4TpuM6yCmwprrsopE	13227	18611	18611	1619289180000	orphaned
26742	3NLVFrj65JDfEHnun8bYGkbjxYzQ63KoCPdU3MC8F17DXK83297Z	26737	3NLd32iJr1jVr3yfYfUvn5C8okNiJM8yLStSgod5RZi1KyeEBP5L	1560	264	516	12463	18407	jwt9SU4ekby1e6yHPGcJPELRQyJ37AZoUXKLxtEFKPsG3kZWG8a	13227	18611	18611	1619289180000	orphaned
27044	3NKCCiQ792J77zznv9XDHYUmYRXyS1uL3jLGSujYRwMzUgErYaFf	26761	3NKcRxTbKmsS1krd7MrVnjvuMvPjjpXVzL3pVexKryQQnRkT2BSU	576	1109	516	12463	18678	jxGFu1aGDcbagbQyu4MJMsHxqZ7KVHnKr2ngG9DDpnv1Zwtgr3Q	13233	18818	18818	1619326440000	orphaned
27097	3NKy31q2ShWpYVutexkfWJqpnp4cmA8tMgXvoug87a4UGPNBoBYq	26768	3NLXSEuPFW7obE6UYgdYNArR7oQ994WcoRyaUYKVyrAe4d9mHCFZ	1507	1280	516	12463	18726	jwZAsJbFNrH9r6XLLEdv2TaBRVGpN4u7gc3MqxQiKzStTd7f3wD	13238	18856	18856	1619333280000	orphaned
26882	3NLvzRBngiPnsENB84c9N56idEVv3CQ7bDE95v2n9ZTviW9RgkZo	26856	3NLTCQpTLfi1oVXjTYoP7m3pEurQz4ssyrGU3MuW4qcVXXvT3tdZ	1553	775	518	12463	18536	jxuCCiZqtG4BwqmZ82VBqGAv9zvGdwsDrsvJnTMCe2VxbFj3dEC	13246	18710	18710	1619307000000	orphaned
26894	3NKAKDVSSshnVjWiC7YZAW83S2wBiHjHX4mXdpRm4MR6kqLb62Rs	26882	3NLvzRBngiPnsENB84c9N56idEVv3CQ7bDE95v2n9ZTviW9RgkZo	1553	776	518	12463	18548	jxKUT1v1cK6httkxQycYyfGDhbYbP6q2Bmr6HXT6isogSaKbu4o	13247	18718	18718	1619308440000	orphaned
26970	3NL31TiFD7gKiBVEj7GCAizKWtE5TTWUPxeHwye1rjsdpMTHUMWq	26787	3NLg7hHzWJiBwAXXtbFM4tPDghg64ExX1ogBdaGazY33MygPgfpf	1506	1007	517	12463	18619	jxWAYA6KRmjWxom9zqysQaSfbGYRFwCheQ1tTnaGaSwZoEgXeB2	13247	18776	18776	1619318880000	orphaned
27069	3NL8juk56Z6v1ozAqtvuXZs25Q2tBDUwDefmqLSQws6w1AS3KvPC	26970	3NL31TiFD7gKiBVEj7GCAizKWtE5TTWUPxeHwye1rjsdpMTHUMWq	1506	1373	518	12463	18702	jwcnKKbQsWcgEAjtyn6V6r7mzXgm8giMV9bgcBPSzMdTNxGvVqf	13248	18835	18835	1619329500000	orphaned
26793	3NKwzNBvBEhTnbHdZoVEJLpbaEhFuPc2czP3kzoDB1a2fTJs4hJC	26792	3NKMMmCY4Vp3nSLwJripH8ECVF6xm1TMqSBmok98T5G7XyTiC6cD	1523	955	517	12463	18455	jwcEFtzuSfMxJSbV9oDnB1DMfyBKhG9fWsc649Xa1zbohJzZrRo	13249	18649	18649	1619296020000	orphaned
27064	3NK9hJr73oYKfNcFUeGMYRMp4kXeEHkFnNbAfe2PR8e5xfPAXDH2	27041	3NK85ucFQGDUr7D7vmf46wjwTqYbip1jjRKhk5WoYC7z2dcWaVpi	1553	776	519	12463	18698	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13250	18834	18834	1619329320000	orphaned
27105	3NLaPgivsqu4QCgBoGyjD7fFCbvbHzL1KjyTciR4F6o86m8rUMgG	27064	3NK9hJr73oYKfNcFUeGMYRMp4kXeEHkFnNbAfe2PR8e5xfPAXDH2	1553	776	519	12463	18734	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13251	18863	18863	1619334540000	orphaned
27156	3NKFkpijvLNxXs1iVJ38oM7NFKK7XrQLjMhPjpSgfgCAG3D4pNxk	27105	3NLaPgivsqu4QCgBoGyjD7fFCbvbHzL1KjyTciR4F6o86m8rUMgG	1553	776	519	12463	18781	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13252	18896	18896	1619340480000	orphaned
27272	3NLsLMhrHPEmgNpAVGs1nHty2P1kv1nqh4i1tG1o66eisWLjDFqZ	27156	3NKFkpijvLNxXs1iVJ38oM7NFKK7XrQLjMhPjpSgfgCAG3D4pNxk	1553	776	519	12463	18889	jxB35qZE15WQV6TRKzw9Y7vD1B3GNN6bYygvuqBgbyTU1gCKNJ7	13253	18971	18971	1619353980000	orphaned
26806	3NKpnMN5KMksu3FE7av6K7mfBbhms5kHBeSmDqf7DuemZ27WCznk	26805	3NLW3h8FE7fZiyhzgLJdPuud2F2j34Rz7HHPFqZb183oFGcWPoET	1546	1339	517	12463	18466	jxWAXwsBvJcQins42JdXqtG65XkMVZxLLY7BkqSQxYQGXhZVtWP	13256	18658	18658	1619297640000	canonical
26809	3NKcMwzwrVDwWc7JiWGrek27rsWgH2BTFEPEUrTqAdmc1USwpgZA	26807	3NKyx7zXnkoK7PDSXBxMxijf1LEkWF2Xo3TDLLDkFPepemGjJXpC	44	1199	517	12463	18469	jxruJUWvdtT4GoLQmideAxayFjAkzPdxXd69bF4xoTyiTXs18NB	13258	18660	18660	1619298000000	orphaned
26824	3NL8r6X1ALgJdKavt9fLMw98DViHvq9DMQBH6XBHgPf8jSQQqtUK	26822	3NKikUv7qjHaAmLyggvDAaoToWhaNQfPPY6WPHWBgBzKdCbbpUtP	1403	786	518	12463	18483	jxzEKRNnRWqP9KJ7beN5pWWE5B5WYpmKaSKAQRK5Xzqm31Uw9xP	13265	18671	18671	1619299980000	orphaned
26835	3NLEkYJ8LUE2sWpjWTSFPWEYidifTRczoqNmqHqVg7ik6zKK16CW	26833	3NLmJNWD8EHTuxzg9tsBocCyxd2NGX2qSQbZ8SBLDMHWfs4qL8DF	1619	1029	518	12463	18493	jwCzE5gKa5UFye2UbMgTA1wMRtcerSuvFw2NyecuPoKJ1FjbkZn	13270	18678	18678	1619301240000	canonical
\.


--
-- Data for Name: blocks_internal_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.blocks_internal_commands (block_id, internal_command_id, sequence_no, secondary_sequence_no, receiver_balance, receiver_account_creation_fee_paid) FROM stdin;
17490	40	8	0	42233	\N
65	51	1	0	43440	1000000000
40	52	2	0	43443	\N
65	52	2	0	43444	\N
47	56	1	0	43665	1000000000
47	57	2	0	43667	\N
58	71	1	0	44706	1000000000
58	72	2	0	44707	\N
62	75	1	0	44975	1000000000
62	76	2	0	44976	\N
68	79	2	0	46060	1000000000
69	81	2	0	46062	\N
68	80	3	0	46063	\N
74	88	1	0	47009	1000000000
74	89	2	0	47010	\N
81	100	2	0	47450	1000000000
81	101	3	0	47451	\N
82	103	2	0	47764	\N
8	13	2	0	208	\N
37	46	3	0	635	\N
37	47	4	0	644	\N
72	84	1	0	1747	\N
72	85	2	0	1748	\N
89	110	2	0	2376	\N
26	35	2	0	4116	\N
26	36	3	0	4121	\N
88	109	2	0	11635	\N
63	77	1	0	12981	\N
63	78	2	0	12982	\N
48	58	1	0	13402	\N
48	59	2	0	13403	\N
57	58	1	0	13405	\N
57	59	2	0	13407	\N
77	92	2	0	14878	\N
77	93	3	0	14879	\N
34	44	1	0	15937	\N
34	45	2	0	15938	\N
35	44	1	0	15939	\N
29	38	2	0	16236	\N
29	39	3	0	16247	\N
80	98	1	0	16975	\N
80	99	2	0	16976	\N
23	30	2	0	17965	\N
23	31	3	0	17968	\N
49	60	1	0	19347	\N
51	60	1	0	19348	\N
49	61	2	0	19349	\N
51	61	2	0	19350	\N
50	62	1	0	19676	\N
75	62	1	0	19677	\N
75	63	2	0	19679	\N
53	64	1	0	20632	\N
53	65	2	0	20634	\N
55	67	2	0	22093	\N
55	68	3	0	22094	\N
17	22	0	0	22323	\N
61	73	1	0	22349	\N
61	74	2	0	22359	\N
71	82	1	0	23683	\N
71	83	2	0	23685	\N
56	69	1	0	24577	\N
56	70	2	0	24580	\N
39	50	2	0	24966	\N
76	90	2	0	25970	\N
76	91	3	0	25971	\N
73	86	1	0	26403	\N
73	87	2	0	26404	\N
78	94	2	0	26669	\N
78	95	3	0	26672	\N
83	104	1	0	27153	\N
83	105	2	0	27154	\N
31	42	1	0	27450	\N
31	43	2	0	27451	\N
11	16	1	0	27756	\N
27	16	1	0	27758	\N
27	17	2	0	27759	\N
43	16	1	0	27760	\N
43	17	2	0	27763	\N
79	96	1	0	29417	\N
79	97	2	0	29418	\N
15	21	0	0	29945	\N
45	54	1	0	29952	\N
66	54	1	0	29953	\N
45	55	2	0	29954	\N
66	55	2	0	29955	\N
14	20	0	0	30325	\N
24	32	4	0	30327	\N
25	33	2	0	31644	\N
25	34	3	0	31645	\N
38	1	3	0	32980	\N
38	48	4	0	32981	\N
44	1	1	0	32982	\N
44	53	2	0	32983	\N
70	53	1	0	32984	\N
64	1	1	0	32985	\N
64	53	2	0	32986	\N
70	1	2	0	32987	\N
84	1	3	0	32988	\N
3	3	5	0	34882	\N
20	2	1	0	34883	\N
20	26	2	0	34885	\N
4	4	2	0	35829	1000000000
4	5	3	0	35830	\N
19	4	1	0	35831	\N
19	25	2	0	35832	\N
41	4	1	0	35837	\N
41	25	2	0	35838	\N
5	6	3	0	36193	1000000000
5	7	4	0	36194	\N
6	9	2	0	36439	\N
28	37	3	0	36441	\N
7	10	1	0	36489	1000000000
7	11	2	0	36490	\N
10	10	1	0	36491	\N
16	10	0	0	36492	\N
10	11	2	0	36493	\N
22	10	2	0	36494	\N
22	29	3	0	36495	\N
32	10	1	0	36496	\N
32	11	2	0	36497	\N
33	10	1	0	36498	\N
42	10	1	0	36499	\N
46	10	1	0	36500	\N
52	10	1	0	36501	\N
42	11	2	0	36503	\N
46	11	2	0	36504	\N
52	11	2	0	36505	\N
59	10	1	0	36506	\N
59	11	2	0	36507	\N
60	10	1	0	36508	\N
67	10	2	0	36509	\N
60	11	2	0	36510	\N
67	29	3	0	36511	\N
36	14	1	0	38959	1000000000
9	15	2	0	38960	\N
36	15	2	0	38961	\N
12	19	2	0	39584	\N
18	23	2	0	40632	1000000000
18	24	3	0	40633	\N
21	27	1	0	40944	1000000000
21	28	2	0	40947	\N
30	41	2	0	41325	\N
54	66	3	0	41329	\N
23815	40	3	0	42290	\N
147	56	1	0	43666	1000000000
147	57	2	0	43668	\N
151	56	2	0	43669	\N
151	169	3	0	43673	\N
135	75	2	0	44979	\N
135	159	3	0	44980	\N
158	75	4	0	44989	\N
158	172	5	0	44990	\N
113	79	1	0	46090	\N
113	81	2	0	46092	\N
129	88	2	0	47011	\N
129	154	3	0	47012	\N
138	100	1	0	47452	\N
138	160	2	0	47454	\N
95	102	1	0	47765	\N
134	102	2	0	47766	\N
95	103	2	0	47768	\N
134	158	3	0	47770	\N
92	114	3	0	48156	\N
96	120	2	0	48491	\N
103	119	3	0	48498	\N
103	129	4	0	48502	\N
97	121	1	0	48785	1000000000
97	122	2	0	48787	\N
100	126	4	0	49120	\N
114	136	2	0	49392	\N
115	138	2	0	49658	\N
125	147	3	0	49938	1000000000
125	148	4	0	49946	\N
133	156	1	0	50142	1000000000
133	157	2	0	50143	\N
157	170	4	0	50468	1000000000
157	171	5	0	50471	\N
85	106	4	0	1750	\N
94	117	3	0	1912	\N
94	118	4	0	1913	\N
116	117	4	0	1914	\N
116	139	5	0	1915	\N
160	117	2	0	1916	\N
160	175	3	0	1920	\N
89	111	3	0	2379	\N
112	110	1	0	2384	\N
112	134	2	0	2385	\N
109	132	2	0	11062	\N
99	123	1	0	12679	\N
99	124	2	0	12680	\N
159	173	3	0	14575	\N
159	174	4	0	14576	\N
165	92	3	0	14880	\N
165	180	4	0	14881	\N
98	44	1	0	15941	\N
122	44	1	0	15942	\N
98	45	2	0	15943	\N
122	45	2	0	15944	\N
139	44	2	0	15947	\N
139	161	3	0	15951	\N
93	116	2	0	16607	\N
150	167	2	0	17593	\N
150	168	3	0	17594	\N
162	177	2	0	18282	\N
162	178	3	0	18285	\N
120	142	1	0	18428	\N
120	143	2	0	18431	\N
144	60	1	0	19351	\N
144	61	2	0	19352	\N
149	60	2	0	19353	\N
149	166	3	0	19355	\N
104	64	3	0	20633	\N
140	64	2	0	20636	\N
140	162	3	0	20637	\N
145	164	1	0	20925	\N
145	165	2	0	20926	\N
128	153	1	0	21762	\N
124	145	3	0	21769	\N
128	145	2	0	21770	\N
124	146	4	0	21771	\N
105	73	1	0	22350	\N
105	74	2	0	22360	\N
126	149	3	0	23024	\N
126	150	4	0	23025	\N
117	141	2	0	23939	\N
87	94	1	0	26670	\N
87	107	2	0	26671	\N
154	104	1	0	27157	\N
154	105	2	0	27158	\N
130	16	2	0	27761	\N
141	16	1	0	27762	\N
141	17	2	0	27764	\N
130	155	3	0	27765	\N
156	16	2	0	27766	\N
156	155	3	0	27767	\N
161	21	2	0	29946	\N
121	20	1	0	30328	\N
121	144	2	0	30331	\N
127	151	3	0	30629	\N
127	152	4	0	30630	\N
86	33	2	0	31646	\N
86	34	3	0	31647	\N
142	33	1	0	31648	\N
142	163	2	0	31653	\N
91	1	2	0	32989	\N
107	1	2	0	32990	\N
111	1	1	0	32991	\N
111	53	2	0	32992	\N
107	112	3	0	32994	\N
166	1	1	0	32996	\N
166	53	2	0	32997	\N
106	2	2	0	34884	\N
106	131	3	0	34886	\N
132	2	1	0	34887	\N
132	26	2	0	34888	\N
137	2	1	0	34889	\N
152	2	1	0	34890	\N
137	26	2	0	34891	\N
152	26	2	0	34892	\N
153	2	1	0	34893	\N
163	6	2	0	36195	\N
163	179	3	0	36196	\N
136	8	1	0	36438	1000000000
136	9	2	0	36440	\N
90	10	2	0	36512	\N
90	29	3	0	36513	\N
108	10	2	0	36514	\N
119	10	1	0	36515	\N
119	11	2	0	36516	\N
108	29	3	0	36517	\N
131	10	2	0	36518	\N
131	29	3	0	36519	\N
148	11	2	0	36521	\N
155	10	1	0	36522	\N
155	11	2	0	36523	\N
164	10	1	0	36524	\N
164	11	2	0	36525	\N
101	18	3	0	39585	\N
118	18	1	0	39586	\N
123	18	1	0	39587	\N
143	18	1	0	39588	\N
118	19	2	0	39589	\N
123	19	2	0	39590	\N
143	19	2	0	39591	\N
102	40	3	0	41321	1000000000
110	40	1	0	41322	1000000000
110	41	2	0	41326	\N
102	128	4	0	41330	\N
243	52	2	0	43446	\N
169	56	4	0	43670	\N
169	185	5	0	43675	\N
192	75	0	0	44995	\N
195	75	1	0	45004	\N
209	75	1	0	45005	\N
195	76	2	0	45007	\N
209	76	2	0	45008	\N
235	79	2	0	46091	\N
235	80	3	0	46093	\N
184	100	2	0	47453	\N
184	101	3	0	47455	\N
222	100	1	0	47460	\N
227	100	1	0	47461	\N
222	160	2	0	47462	\N
227	160	2	0	47463	\N
224	119	1	0	48499	\N
224	120	2	0	48501	\N
186	195	1	0	49121	\N
173	125	2	0	49122	\N
186	125	4	0	49123	\N
173	188	3	0	49124	\N
186	188	5	0	49125	\N
211	125	2	0	49135	\N
211	188	3	0	49136	\N
187	196	3	0	49398	\N
188	197	3	0	49659	\N
167	182	5	0	50831	\N
170	187	2	0	51140	\N
194	200	1	0	51436	1000000000
216	200	3	0	51437	1000000000
194	201	2	0	51438	\N
216	219	4	0	51439	\N
203	210	1	0	51701	1000000000
203	211	2	0	51703	\N
240	13	2	0	209	\N
217	220	1	0	515	\N
217	221	2	0	516	\N
198	204	1	0	1697	\N
232	228	1	0	2731	\N
232	229	2	0	2732	\N
233	228	1	0	2733	\N
233	229	2	0	2734	\N
246	237	4	0	3554	\N
246	238	5	0	3559	\N
176	189	1	0	4737	\N
176	190	2	0	4738	\N
219	222	1	0	5239	\N
239	222	2	0	5240	\N
219	223	2	0	5243	\N
239	232	3	0	5245	\N
168	184	5	0	10067	\N
190	123	1	0	12682	\N
190	124	2	0	12683	\N
210	77	2	0	12983	\N
210	216	3	0	12984	\N
223	58	1	0	13406	\N
223	59	2	0	13408	\N
241	233	1	0	13703	\N
241	234	2	0	13704	\N
247	239	4	0	14568	\N
179	92	1	0	14882	\N
179	191	2	0	14883	\N
181	193	2	0	15258	\N
245	235	1	0	15586	\N
245	236	2	0	15587	\N
191	115	1	0	16608	\N
191	116	2	0	16613	\N
204	212	1	0	16987	\N
204	213	2	0	16988	\N
201	208	1	0	19179	\N
201	209	2	0	19180	\N
234	208	1	0	19203	\N
234	209	2	0	19206	\N
193	198	1	0	19983	\N
208	64	1	0	20638	\N
208	65	2	0	20639	\N
228	164	2	0	20927	\N
228	226	3	0	20929	\N
230	67	2	0	22097	\N
230	68	3	0	22098	\N
207	214	1	0	24280	\N
229	214	2	0	24281	\N
207	215	2	0	24282	\N
229	227	3	0	24283	\N
225	224	1	0	25389	\N
225	225	2	0	25391	\N
199	207	2	0	25728	\N
213	94	1	0	26673	\N
213	107	2	0	26674	\N
202	16	2	0	27768	\N
202	155	3	0	27769	\N
206	96	1	0	29419	\N
206	97	2	0	29421	\N
242	54	1	0	29956	\N
242	55	2	0	29958	\N
197	202	1	0	30947	\N
197	203	2	0	30948	\N
221	202	1	0	30949	\N
177	33	1	0	31649	\N
177	163	2	0	31654	\N
238	230	2	0	31968	\N
238	231	3	0	31971	\N
172	1	2	0	32998	\N
172	112	3	0	32999	\N
189	1	1	0	33000	\N
205	1	1	0	33001	\N
189	53	2	0	33002	\N
205	53	2	0	33003	\N
218	1	1	0	33004	\N
218	53	2	0	33005	\N
226	53	2	0	33008	\N
178	2	1	0	34901	\N
178	26	2	0	34902	\N
180	4	1	0	35845	\N
180	25	2	0	35846	\N
196	4	1	0	35851	\N
196	25	2	0	35852	\N
183	6	1	0	36203	\N
183	194	2	0	36204	\N
220	6	1	0	36207	\N
220	194	2	0	36208	\N
185	11	1	0	36526	\N
200	10	1	0	36528	\N
236	10	2	0	36529	\N
175	11	2	0	36530	\N
185	10	4	0	36531	\N
200	11	2	0	36532	\N
236	29	3	0	36533	\N
185	29	5	0	36534	\N
237	10	2	0	36535	\N
237	29	3	0	36536	\N
244	10	1	0	36537	\N
244	11	2	0	36539	\N
215	18	2	0	39593	\N
214	23	1	0	40634	\N
214	217	2	0	40635	\N
171	27	1	0	40945	1000000000
171	28	2	0	40948	\N
174	41	2	0	41327	\N
182	41	2	0	41328	\N
212	40	1	0	41332	\N
231	40	1	0	41333	\N
212	41	2	0	41335	\N
231	41	2	0	41336	\N
11730	40	1	0	42303	\N
322	56	2	0	43672	\N
322	169	3	0	43674	\N
277	75	1	0	45006	\N
277	76	2	0	45009	\N
319	75	2	0	45014	\N
319	284	3	0	45016	\N
276	79	1	0	46145	\N
303	79	3	0	46146	\N
276	81	2	0	46147	\N
303	272	4	0	46148	\N
326	79	2	0	46233	\N
326	80	3	0	46235	\N
255	88	5	0	47013	\N
255	243	6	0	47014	\N
266	88	3	0	47015	\N
266	249	4	0	47016	\N
267	100	3	0	47491	\N
267	250	4	0	47492	\N
299	102	1	0	47767	\N
299	103	2	0	47769	\N
265	119	3	0	48500	\N
265	129	4	0	48503	\N
258	135	1	0	49387	1000000000
258	136	2	0	49393	\N
259	137	1	0	49677	\N
259	138	2	0	49678	\N
306	200	2	0	51444	\N
306	276	3	0	51445	\N
272	242	1	0	52029	1000000000
272	253	2	0	52031	\N
286	260	1	0	52332	1000000000
286	261	2	0	52333	\N
298	260	3	0	52334	\N
298	271	4	0	52337	\N
301	268	1	0	52608	1000000000
293	269	2	0	52609	\N
301	269	2	0	52610	\N
304	273	5	0	52895	1000000000
304	274	6	0	52896	\N
314	279	2	0	53166	1000000000
314	280	3	0	53169	\N
321	285	1	0	53349	1000000000
321	286	2	0	53355	\N
291	266	1	0	1127	\N
291	267	2	0	1128	\N
268	251	1	0	1388	\N
268	252	2	0	1390	\N
300	204	1	0	1698	\N
300	205	2	0	1701	\N
302	84	1	0	1751	\N
302	85	2	0	1753	\N
261	246	1	0	1862	\N
261	247	2	0	1864	\N
263	117	1	0	1917	\N
264	117	0	0	1918	\N
289	262	1	0	3659	\N
309	262	1	0	3660	\N
289	263	2	0	3661	\N
309	263	2	0	3662	\N
278	256	1	0	13316	\N
278	257	2	0	13318	\N
280	258	0	0	14342	\N
247	240	5	0	14569	\N
296	173	3	0	14577	\N
296	174	4	0	14578	\N
253	44	0	0	15948	\N
329	292	1	0	18248	\N
328	290	1	0	18844	\N
328	291	2	0	18849	\N
287	198	1	0	19985	\N
287	199	2	0	19987	\N
252	241	0	0	20349	\N
315	241	2	0	20350	\N
315	281	3	0	20353	\N
307	64	2	0	20640	\N
307	277	3	0	20643	\N
271	145	1	0	21773	\N
271	153	2	0	21774	\N
275	254	1	0	22315	\N
281	22	1	0	22324	\N
281	259	2	0	22325	\N
290	264	2	0	23374	\N
290	265	3	0	23375	\N
294	264	1	0	23382	\N
294	270	2	0	23383	\N
269	214	1	0	24284	\N
269	215	2	0	24285	\N
260	244	1	0	27184	\N
279	244	1	0	27185	\N
260	245	2	0	27186	\N
279	245	2	0	27187	\N
295	16	2	0	27771	\N
283	17	2	0	27772	\N
295	155	3	0	27773	\N
311	54	1	0	29957	\N
311	55	2	0	29959	\N
323	230	1	0	31969	\N
323	287	2	0	31970	\N
250	1	3	0	33007	\N
250	48	4	0	33009	\N
270	1	1	0	33010	\N
270	53	2	0	33011	\N
274	1	1	0	33012	\N
297	1	3	0	33014	\N
310	1	1	0	33015	\N
316	1	1	0	33016	\N
310	53	2	0	33017	\N
316	53	2	0	33018	\N
297	48	4	0	33019	\N
318	1	2	0	33020	\N
318	283	3	0	33021	\N
327	1	2	0	33022	\N
327	112	3	0	33023	\N
248	2	2	0	34907	\N
248	131	3	0	34910	\N
284	25	2	0	35870	\N
312	8	2	0	36442	\N
312	278	3	0	36443	\N
249	10	2	0	36538	\N
249	29	3	0	36540	\N
256	10	1	0	36541	\N
256	11	2	0	36542	\N
262	10	1	0	36543	\N
273	10	1	0	36544	\N
282	10	1	0	36545	\N
262	11	2	0	36546	\N
273	11	2	0	36547	\N
285	10	1	0	36549	\N
288	10	1	0	36550	\N
285	11	2	0	36551	\N
288	11	2	0	36552	\N
305	10	2	0	36553	\N
305	275	3	0	36554	\N
313	10	2	0	36555	\N
313	29	3	0	36556	\N
320	10	1	0	36557	\N
320	11	2	0	36558	\N
324	10	2	0	36559	\N
324	29	3	0	36563	\N
308	19	2	0	39596	\N
257	28	2	0	40949	\N
292	40	1	0	41334	\N
292	41	2	0	41337	\N
317	40	2	0	41338	\N
317	282	3	0	41340	\N
17847	40	4	0	42358	\N
358	308	5	0	43456	\N
338	75	2	0	45015	\N
338	159	3	0	45017	\N
340	75	1	0	45022	\N
340	76	2	0	45024	\N
370	79	2	0	46234	\N
370	80	3	0	46236	\N
343	119	1	0	48506	\N
343	120	2	0	48507	\N
419	125	3	0	49134	\N
419	126	4	0	49137	\N
424	260	1	0	52335	\N
385	269	1	0	52611	\N
334	268	1	0	52619	\N
334	269	2	0	52620	\N
385	268	6	0	52621	\N
385	318	7	0	52622	\N
380	317	2	0	53844	\N
392	325	2	0	54118	\N
375	13	2	0	210	\N
371	312	3	0	518	\N
337	46	2	0	648	\N
337	296	3	0	659	\N
384	266	1	0	1129	\N
384	267	2	0	1131	\N
423	84	1	0	1752	\N
423	85	2	0	1754	\N
335	294	1	0	3233	\N
335	295	2	0	3234	\N
387	237	2	0	3555	\N
387	319	3	0	3558	\N
332	262	1	0	3663	\N
368	189	2	0	4744	\N
368	311	3	0	4748	\N
367	183	2	0	10063	\N
367	310	3	0	10064	\N
349	300	3	0	12003	\N
349	301	4	0	12004	\N
330	123	1	0	12687	\N
330	124	2	0	12688	\N
416	256	2	0	13317	\N
416	335	3	0	13319	\N
346	233	3	0	13705	\N
355	233	3	0	13706	\N
355	305	4	0	13708	\N
363	258	1	0	14343	\N
363	309	2	0	14345	\N
352	303	0	0	15233	\N
353	303	1	0	15234	\N
353	304	2	0	15239	\N
398	38	2	0	16255	\N
398	39	3	0	16262	\N
369	167	2	0	17595	\N
369	168	3	0	17597	\N
373	313	1	0	18731	\N
373	314	2	0	18734	\N
378	291	2	0	18858	\N
413	60	2	0	19354	\N
413	166	3	0	19356	\N
407	241	1	0	20351	\N
407	333	2	0	20352	\N
357	164	3	0	20928	\N
357	307	4	0	20930	\N
360	164	2	0	20935	\N
360	226	3	0	20940	\N
403	145	2	0	21780	\N
403	331	3	0	21781	\N
420	336	3	0	22685	\N
426	264	1	0	23394	\N
426	270	2	0	23398	\N
331	140	1	0	23940	\N
331	141	2	0	23941	\N
361	224	1	0	25393	\N
361	225	2	0	25395	\N
342	16	2	0	27774	\N
342	155	3	0	27775	\N
381	16	1	0	27776	\N
381	17	2	0	27777	\N
402	16	2	0	27778	\N
402	155	3	0	27779	\N
414	334	2	0	29208	\N
351	151	1	0	30631	\N
351	302	2	0	30632	\N
390	322	1	0	32316	\N
390	323	2	0	32317	\N
347	1	1	0	33024	\N
347	53	2	0	33025	\N
354	1	3	0	33026	\N
364	1	1	0	33027	\N
376	1	1	0	33028	\N
364	53	2	0	33029	\N
376	53	2	0	33030	\N
386	1	1	0	33034	\N
386	53	2	0	33035	\N
391	1	1	0	33036	\N
404	1	2	0	33037	\N
408	1	1	0	33038	\N
391	53	2	0	33039	\N
408	53	2	0	33040	\N
404	112	3	0	33041	\N
341	2	2	0	34908	\N
345	2	3	0	34909	\N
341	131	3	0	34911	\N
345	298	4	0	34912	\N
374	2	1	0	34923	\N
350	26	2	0	34925	\N
374	26	2	0	34926	\N
365	6	1	0	36212	\N
365	194	2	0	36213	\N
336	10	2	0	36560	\N
339	10	1	0	36561	\N
339	11	2	0	36562	\N
336	29	3	0	36564	\N
344	10	3	0	36565	\N
348	10	1	0	36566	\N
348	11	2	0	36567	\N
359	10	2	0	36569	\N
359	29	3	0	36570	\N
362	10	2	0	36571	\N
362	29	3	0	36572	\N
366	10	2	0	36573	\N
372	10	1	0	36574	\N
372	11	2	0	36575	\N
366	29	3	0	36576	\N
388	10	2	0	36577	\N
388	29	3	0	36578	\N
411	10	1	0	36580	\N
411	11	2	0	36581	\N
415	29	3	0	36587	\N
356	14	3	0	38964	\N
383	14	1	0	38965	\N
399	14	3	0	38966	\N
383	15	2	0	38969	\N
356	306	4	0	38971	\N
399	306	4	0	38972	\N
333	18	1	0	39597	\N
377	18	1	0	39598	\N
333	19	2	0	39600	\N
377	19	2	0	39601	\N
395	18	1	0	39603	\N
396	40	2	0	41339	\N
396	66	3	0	41341	\N
409	40	1	0	41342	\N
409	41	2	0	41345	\N
400	51	3	0	43463	\N
400	329	4	0	43468	\N
446	56	2	0	43676	\N
446	169	3	0	43677	\N
436	75	1	0	45023	\N
436	76	2	0	45025	\N
477	75	2	0	45035	\N
477	284	3	0	45036	\N
475	79	3	0	46289	\N
475	272	4	0	46290	\N
483	79	1	0	46336	\N
483	81	2	0	46339	\N
468	88	1	0	47024	\N
468	89	2	0	47026	\N
458	136	2	0	49394	\N
486	136	2	0	49395	\N
459	137	1	0	49697	\N
487	137	1	0	49698	\N
459	138	2	0	49702	\N
487	138	2	0	49703	\N
488	253	2	0	52032	\N
424	261	2	0	52336	\N
437	286	2	0	53356	\N
421	338	3	0	53756	\N
421	339	4	0	53762	\N
406	316	2	0	53845	\N
406	332	3	0	53846	\N
464	353	1	0	54497	1000000000
464	354	2	0	54498	\N
479	363	3	0	54734	\N
469	357	5	0	211	\N
438	266	1	0	1130	\N
438	267	2	0	1132	\N
425	117	1	0	1921	\N
425	248	2	0	1924	\N
422	35	1	0	4117	\N
422	340	2	0	4119	\N
491	365	1	0	4416	\N
445	222	3	0	5241	\N
445	351	4	0	5246	\N
465	300	1	0	12005	\N
465	355	2	0	12006	\N
443	349	4	0	12315	\N
452	123	1	0	12698	\N
463	123	1	0	12699	\N
452	124	2	0	12701	\N
463	124	2	0	12702	\N
455	256	2	0	13320	\N
455	335	3	0	13323	\N
429	58	1	0	13409	\N
429	59	2	0	13410	\N
431	58	1	0	13411	\N
431	59	2	0	13414	\N
460	239	1	0	14570	\N
442	173	3	0	14579	\N
442	174	4	0	14584	\N
447	92	1	0	14884	\N
447	191	2	0	14885	\N
480	44	1	0	15949	\N
480	45	2	0	15950	\N
430	341	1	0	16970	\N
430	342	2	0	16971	\N
410	212	1	0	16989	\N
410	213	2	0	16990	\N
485	212	1	0	16995	\N
485	213	2	0	17000	\N
394	327	2	0	17285	\N
453	326	1	0	17286	\N
453	327	2	0	17287	\N
448	292	1	0	18249	\N
448	293	2	0	18252	\N
454	60	2	0	19357	\N
454	166	3	0	19358	\N
440	336	3	0	22687	\N
466	336	1	0	22688	\N
466	356	2	0	22690	\N
440	337	4	0	22692	\N
433	82	2	0	23684	\N
457	140	1	0	23942	\N
457	141	2	0	23943	\N
401	214	3	0	24286	\N
401	330	4	0	24287	\N
397	49	2	0	24967	\N
397	328	3	0	24970	\N
435	90	1	0	25972	\N
470	90	4	0	25973	\N
435	344	2	0	25979	\N
470	358	5	0	25984	\N
439	345	1	0	26284	\N
439	346	2	0	26286	\N
461	107	2	0	26678	\N
481	42	1	0	27452	\N
481	43	2	0	27453	\N
476	16	3	0	27780	\N
476	359	4	0	27782	\N
389	320	2	0	29206	\N
389	321	3	0	29209	\N
471	20	1	0	30329	\N
471	144	2	0	30332	\N
478	360	2	0	31267	\N
478	361	3	0	31268	\N
428	33	1	0	31650	\N
382	1	1	0	33032	\N
382	53	2	0	33033	\N
417	1	2	0	33042	\N
417	112	3	0	33043	\N
456	1	1	0	33044	\N
462	1	1	0	33045	\N
456	53	2	0	33046	\N
462	53	2	0	33047	\N
472	1	1	0	33048	\N
472	53	2	0	33049	\N
473	1	3	0	33050	\N
473	48	4	0	33053	\N
379	315	5	0	34927	\N
412	2	1	0	34932	\N
427	2	1	0	34933	\N
412	26	2	0	34934	\N
427	26	2	0	34935	\N
467	2	1	0	34940	\N
467	26	2	0	34941	\N
482	8	1	0	36444	\N
482	9	2	0	36445	\N
405	10	2	0	36579	\N
405	29	3	0	36582	\N
450	11	1	0	36583	\N
450	10	3	0	36586	\N
450	11	4	0	36588	\N
441	347	4	0	36589	\N
451	10	1	0	36590	\N
474	10	3	0	36591	\N
484	10	1	0	36592	\N
451	11	2	0	36595	\N
484	11	2	0	36596	\N
474	347	4	0	36599	\N
393	18	1	0	39599	\N
393	19	2	0	39602	\N
432	18	1	0	39604	\N
432	19	2	0	39608	\N
434	218	3	0	39609	\N
444	23	3	0	40644	\N
444	350	4	0	40645	\N
418	40	3	0	41343	\N
449	40	1	0	41344	\N
449	41	2	0	41346	\N
418	128	4	0	41347	\N
24236	40	4	0	42415	\N
554	52	2	0	43466	\N
546	71	3	0	44708	\N
561	71	2	0	44709	\N
561	401	3	0	44712	\N
546	397	4	0	44713	\N
531	75	1	0	45045	\N
531	76	2	0	45046	\N
555	75	1	0	45059	\N
555	76	2	0	45063	\N
515	79	1	0	46337	\N
515	81	2	0	46340	\N
553	100	1	0	47477	\N
553	160	2	0	47483	\N
500	119	1	0	48521	\N
500	120	2	0	48523	\N
495	125	3	0	49146	\N
495	126	4	0	49147	\N
550	170	1	0	50469	1000000000
550	398	2	0	50470	\N
529	186	1	0	51151	\N
529	187	2	0	51152	\N
528	210	1	0	51702	1000000000
528	211	2	0	51704	\N
488	242	1	0	52030	1000000000
540	395	2	0	54733	\N
512	379	2	0	54906	\N
530	389	1	0	54920	1000000000
530	390	2	0	54921	\N
557	400	2	0	9	\N
562	110	2	0	2398	\N
562	111	3	0	2401	\N
565	228	1	0	2735	\N
565	229	2	0	2736	\N
509	294	1	0	3235	\N
492	367	1	0	3247	\N
521	367	5	0	3248	\N
492	368	2	0	3251	\N
521	386	6	0	3254	\N
491	366	2	0	4417	\N
551	365	1	0	4418	\N
551	366	2	0	4419	\N
517	381	3	0	5200	\N
517	382	4	0	5201	\N
499	222	1	0	5242	\N
499	223	2	0	5244	\N
504	373	1	0	5306	\N
532	391	1	0	10073	\N
532	392	2	0	10074	\N
522	132	2	0	11064	\N
522	133	3	0	11065	\N
519	123	2	0	12700	\N
519	384	3	0	12703	\N
497	77	2	0	12993	\N
497	216	3	0	12994	\N
543	173	1	0	14580	\N
543	396	2	0	14582	\N
508	92	1	0	14886	\N
534	92	1	0	14887	\N
534	191	2	0	14890	\N
556	38	1	0	16256	\N
556	399	2	0	16260	\N
502	370	2	0	16594	\N
502	371	3	0	16595	\N
538	326	2	0	17288	\N
538	393	3	0	17295	\N
511	376	1	0	18280	\N
511	377	2	0	18281	\N
490	290	3	0	18866	\N
490	364	4	0	18870	\N
567	241	1	0	20354	\N
493	145	1	0	21787	\N
493	153	2	0	21788	\N
539	67	2	0	22108	\N
539	394	3	0	22111	\N
552	336	1	0	22689	\N
552	356	2	0	22691	\N
563	49	1	0	24968	\N
563	50	2	0	24969	\N
523	224	3	0	25400	\N
523	387	4	0	25402	\N
506	94	3	0	26676	\N
545	94	1	0	26677	\N
506	375	4	0	26680	\N
513	16	4	0	27781	\N
513	380	5	0	27783	\N
527	16	2	0	27784	\N
527	388	3	0	27785	\N
536	16	1	0	27786	\N
536	17	2	0	27787	\N
498	20	2	0	30330	\N
498	369	3	0	30333	\N
535	151	1	0	30633	\N
535	302	2	0	30638	\N
501	230	1	0	31972	\N
525	1	1	0	33051	\N
525	53	2	0	33052	\N
533	1	1	0	33054	\N
533	53	2	0	33055	\N
510	2	1	0	34950	\N
542	2	1	0	34951	\N
510	26	2	0	34955	\N
542	26	2	0	34956	\N
544	4	1	0	35868	\N
544	25	2	0	35871	\N
494	10	1	0	36593	\N
524	10	1	0	36594	\N
524	11	2	0	36598	\N
537	10	2	0	36600	\N
537	275	3	0	36601	\N
541	10	1	0	36602	\N
541	11	2	0	36603	\N
547	10	3	0	36604	\N
547	347	4	0	36605	\N
548	10	1	0	36606	\N
548	11	2	0	36607	\N
549	10	1	0	36608	\N
558	10	1	0	36609	\N
549	11	2	0	36610	\N
566	10	1	0	36612	\N
566	11	2	0	36613	\N
505	14	3	0	38967	\N
514	14	1	0	38968	\N
514	15	2	0	38970	\N
505	306	4	0	38973	\N
516	14	0	0	38978	\N
518	14	2	0	38983	\N
518	383	3	0	38986	\N
507	18	3	0	39606	\N
507	127	4	0	39610	\N
496	27	1	0	40950	\N
489	40	3	0	41348	\N
503	40	3	0	41349	\N
503	372	4	0	41350	\N
489	128	4	0	41351	\N
520	40	5	0	41352	\N
520	385	6	0	41353	\N
526	40	2	0	41354	\N
559	40	1	0	41355	\N
559	41	2	0	41356	\N
526	282	3	0	41357	\N
560	40	2	0	41364	\N
560	66	3	0	41365	\N
568	40	1	0	41370	\N
564	41	2	0	41373	\N
19231	40	5	0	42449	\N
573	52	2	0	43467	\N
608	56	1	0	43678	\N
608	57	2	0	43680	\N
650	75	1	0	45060	\N
650	76	2	0	45064	\N
613	79	1	0	46338	\N
613	81	2	0	46341	\N
651	154	2	0	47017	\N
651	88	5	0	47028	\N
651	154	6	0	47029	\N
574	125	1	0	49153	\N
574	195	2	0	49156	\N
580	156	3	0	50147	\N
580	407	4	0	50148	\N
592	186	1	0	51159	\N
592	187	2	0	51160	\N
645	260	2	0	52338	\N
645	419	3	0	52343	\N
598	268	1	0	52628	\N
598	269	2	0	52630	\N
612	273	1	0	52897	\N
612	410	2	0	52903	\N
586	286	2	0	53357	\N
604	338	1	0	53757	\N
619	338	1	0	53758	\N
621	338	0	0	53759	\N
604	409	2	0	53760	\N
619	409	2	0	53761	\N
620	338	0	0	53763	\N
622	338	2	0	53764	\N
622	415	3	0	53765	\N
637	417	2	0	54948	\N
617	13	2	0	216	\N
577	405	4	0	1134	\N
582	110	1	0	2399	\N
582	134	2	0	2400	\N
648	228	1	0	2740	\N
648	229	2	0	2742	\N
587	294	1	0	3237	\N
587	295	2	0	3238	\N
628	367	1	0	3249	\N
628	368	2	0	3252	\N
569	262	1	0	3664	\N
569	263	2	0	3666	\N
607	35	1	0	4118	\N
602	189	1	0	4745	\N
602	190	2	0	4747	\N
578	406	2	0	10075	\N
578	391	3	0	10076	\N
624	391	2	0	10077	\N
624	406	3	0	10078	\N
631	391	1	0	10079	\N
631	392	2	0	10080	\N
640	391	1	0	10081	\N
640	392	2	0	10082	\N
571	402	1	0	14017	\N
571	403	2	0	14018	\N
583	396	2	0	14583	\N
599	173	1	0	14585	\N
599	396	2	0	14586	\N
635	173	1	0	14587	\N
635	396	2	0	14589	\N
627	92	2	0	14888	\N
627	93	3	0	14891	\N
597	38	1	0	16269	\N
597	399	2	0	16276	\N
643	38	1	0	16285	\N
643	399	2	0	16287	\N
603	292	1	0	18254	\N
616	413	1	0	18352	\N
616	414	2	0	18354	\N
576	140	3	0	23944	\N
576	404	4	0	23949	\N
605	214	1	0	24288	\N
605	215	2	0	24290	\N
610	49	1	0	24971	\N
610	50	2	0	24972	\N
614	411	1	0	25125	\N
614	412	2	0	25129	\N
630	206	1	0	25727	\N
630	207	2	0	25729	\N
584	16	1	0	27789	\N
591	16	3	0	27790	\N
575	17	2	0	27791	\N
584	17	2	0	27792	\N
591	408	4	0	27793	\N
601	16	1	0	27794	\N
601	17	2	0	27795	\N
626	16	2	0	27796	\N
626	155	3	0	27798	\N
585	320	1	0	29219	\N
585	334	2	0	29223	\N
581	96	1	0	29420	\N
594	96	1	0	29423	\N
594	97	2	0	29425	\N
618	20	1	0	30334	\N
618	144	2	0	30335	\N
639	33	1	0	31651	\N
639	163	2	0	31656	\N
579	1	3	0	33056	\N
579	48	4	0	33057	\N
593	1	1	0	33058	\N
596	1	2	0	33059	\N
593	53	2	0	33060	\N
596	112	3	0	33061	\N
609	1	1	0	33063	\N
611	1	1	0	33064	\N
615	1	1	0	33065	\N
600	53	2	0	33066	\N
609	53	2	0	33067	\N
611	53	2	0	33068	\N
615	53	2	0	33069	\N
625	1	2	0	33070	\N
632	1	1	0	33071	\N
634	1	1	0	33072	\N
632	53	2	0	33073	\N
634	53	2	0	33074	\N
652	112	2	0	33080	\N
652	1	5	0	33086	\N
652	112	6	0	33087	\N
629	2	1	0	34952	\N
629	26	2	0	34957	\N
572	10	1	0	36614	\N
588	10	1	0	36615	\N
572	11	2	0	36616	\N
588	11	2	0	36617	\N
590	10	1	0	36618	\N
590	11	2	0	36619	\N
595	10	1	0	36620	\N
606	10	1	0	36622	\N
623	10	1	0	36623	\N
606	11	2	0	36624	\N
623	11	2	0	36625	\N
633	10	1	0	36626	\N
633	11	2	0	36627	\N
636	10	1	0	36629	\N
642	10	1	0	36630	\N
647	10	2	0	36631	\N
636	11	2	0	36632	\N
642	11	2	0	36633	\N
647	29	3	0	36634	\N
589	15	2	0	38985	\N
570	18	1	0	39611	\N
570	19	2	0	39612	\N
568	41	2	0	41374	\N
682	56	1	0	43679	\N
682	57	2	0	43681	\N
657	75	2	0	45061	\N
680	75	2	0	45062	\N
657	159	3	0	45065	\N
680	429	3	0	45066	\N
693	75	1	0	45071	\N
693	76	2	0	45072	\N
723	75	1	0	45083	\N
723	76	2	0	45085	\N
730	79	1	0	46392	\N
653	101	2	0	47459	\N
725	100	4	0	47478	\N
653	100	5	0	47486	\N
653	101	6	0	47489	\N
725	448	5	0	47490	\N
694	437	2	0	48155	\N
662	119	4	0	48522	\N
662	423	5	0	48524	\N
706	338	1	0	53766	\N
706	409	2	0	53767	\N
738	316	1	0	53847	\N
738	317	2	0	53849	\N
656	362	2	0	54735	\N
656	420	3	0	54740	\N
692	436	2	0	54959	\N
728	452	3	0	55152	\N
687	433	3	0	218	\N
722	221	2	0	520	\N
664	424	1	0	672	\N
664	425	2	0	673	\N
649	204	1	0	1699	\N
649	205	2	0	1702	\N
690	204	1	0	1703	\N
690	205	2	0	1704	\N
688	84	2	0	1755	\N
688	434	3	0	1756	\N
731	110	1	0	2409	\N
731	134	2	0	2410	\N
665	367	1	0	3250	\N
676	35	5	0	4122	\N
676	427	6	0	4123	\N
697	391	2	0	10083	\N
700	391	1	0	10084	\N
700	392	2	0	10085	\N
697	406	3	0	10086	\N
734	132	1	0	11066	\N
734	455	2	0	11067	\N
679	233	2	0	13711	\N
702	233	3	0	13712	\N
702	305	4	0	13715	\N
679	428	3	0	13716	\N
658	309	2	0	14346	\N
695	235	1	0	15588	\N
695	236	2	0	15590	\N
644	30	1	0	17966	\N
644	418	2	0	17967	\N
660	292	4	0	18260	\N
660	421	5	0	18262	\N
691	142	1	0	18429	\N
691	143	2	0	18432	\N
683	60	1	0	19359	\N
683	61	2	0	19362	\N
713	440	3	0	21736	\N
714	443	2	0	21738	\N
713	442	4	0	21739	\N
675	73	1	0	22366	\N
675	74	2	0	22367	\N
686	73	1	0	22376	\N
686	74	2	0	22379	\N
674	411	1	0	25126	\N
674	412	2	0	25130	\N
710	90	1	0	25974	\N
710	344	2	0	25980	\N
666	94	1	0	26681	\N
666	107	2	0	26683	\N
699	244	2	0	27189	\N
696	245	2	0	27190	\N
699	438	3	0	27191	\N
707	42	3	0	27454	\N
707	439	4	0	27455	\N
655	16	2	0	27797	\N
655	155	3	0	27799	\N
705	16	1	0	27800	\N
705	17	2	0	27801	\N
720	16	2	0	27802	\N
727	16	1	0	27803	\N
727	17	2	0	27806	\N
701	20	1	0	30336	\N
701	144	2	0	30338	\N
667	202	1	0	30951	\N
667	203	2	0	30952	\N
724	33	4	0	31652	\N
724	447	5	0	31657	\N
681	322	2	0	32318	\N
681	430	3	0	32319	\N
638	1	1	0	33076	\N
638	53	2	0	33077	\N
646	1	2	0	33078	\N
646	112	3	0	33079	\N
668	1	1	0	33082	\N
673	1	1	0	33083	\N
668	53	2	0	33084	\N
673	53	2	0	33085	\N
661	422	5	0	33088	\N
678	1	1	0	33089	\N
698	1	2	0	33090	\N
678	53	2	0	33091	\N
698	112	3	0	33092	\N
716	1	0	0	33093	\N
719	1	2	0	33094	\N
719	444	3	0	33095	\N
685	432	2	0	34755	\N
641	2	1	0	34953	\N
672	2	1	0	34954	\N
641	26	2	0	34958	\N
672	26	2	0	34959	\N
711	2	1	0	34973	\N
711	26	2	0	34975	\N
654	179	2	0	36214	\N
654	6	5	0	36222	\N
654	179	6	0	36223	\N
659	6	1	0	36230	\N
659	194	2	0	36232	\N
669	10	2	0	36647	\N
663	11	2	0	36648	\N
669	29	3	0	36649	\N
670	10	6	0	36658	\N
670	426	7	0	36659	\N
677	10	1	0	36662	\N
677	11	2	0	36663	\N
684	10	1	0	36666	\N
684	11	2	0	36667	\N
689	10	1	0	36672	\N
704	10	2	0	36673	\N
689	11	2	0	36674	\N
717	10	3	0	36678	\N
717	347	4	0	36679	\N
703	18	3	0	39613	\N
703	127	4	0	39614	\N
742	18	1	0	39615	\N
742	19	2	0	39616	\N
740	23	1	0	40642	\N
740	217	2	0	40643	\N
671	40	1	0	41371	\N
671	41	2	0	41375	\N
782	56	3	0	43683	\N
782	475	4	0	43684	\N
771	185	5	0	43685	\N
786	56	3	0	43686	\N
786	475	4	0	43687	\N
807	56	3	0	43688	\N
807	475	4	0	43695	\N
783	75	0	0	45084	\N
730	81	2	0	46393	\N
760	79	1	0	46437	\N
760	81	2	0	46438	\N
776	79	2	0	46493	\N
776	472	3	0	46498	\N
752	88	1	0	47025	\N
752	89	2	0	47027	\N
757	100	2	0	47479	\N
757	101	3	0	47487	\N
759	125	1	0	49154	\N
759	195	2	0	49157	\N
788	170	1	0	50474	\N
788	398	2	0	50475	\N
756	210	2	0	51705	\N
756	458	3	0	51706	\N
764	210	1	0	51710	\N
764	211	2	0	51711	\N
754	260	1	0	52339	\N
792	260	1	0	52340	\N
754	261	2	0	52341	\N
792	261	2	0	52342	\N
778	473	2	0	53168	\N
806	338	3	0	53768	\N
806	339	4	0	53769	\N
743	316	2	0	53848	\N
743	332	3	0	53850	\N
768	316	1	0	53853	\N
768	317	2	0	53855	\N
804	481	3	0	54960	\N
787	477	4	0	527	\N
772	468	4	0	675	\N
779	251	1	0	1389	\N
779	252	2	0	1391	\N
762	461	6	0	1851	\N
763	461	1	0	1852	\N
763	463	2	0	1853	\N
762	462	7	0	1854	\N
780	367	3	0	3255	\N
780	474	4	0	3260	\N
746	262	1	0	3681	\N
746	263	2	0	3683	\N
790	391	1	0	10087	\N
791	391	1	0	10089	\N
791	392	2	0	10092	\N
736	132	2	0	11070	\N
736	133	3	0	11071	\N
758	459	1	0	11930	\N
758	460	2	0	11931	\N
735	300	1	0	12007	\N
735	355	2	0	12008	\N
798	300	1	0	12009	\N
798	355	2	0	12013	\N
774	469	2	0	12346	\N
774	470	3	0	12347	\N
802	124	2	0	12711	\N
748	456	1	0	13395	\N
748	457	2	0	13398	\N
773	233	1	0	13713	\N
773	234	2	0	13714	\N
794	173	2	0	14588	\N
794	480	3	0	14590	\N
732	326	1	0	17289	\N
777	326	1	0	17290	\N
732	327	2	0	17292	\N
777	327	2	0	17293	\N
721	292	3	0	18261	\N
737	290	1	0	18880	\N
750	290	1	0	18881	\N
737	291	2	0	18887	\N
750	291	2	0	18888	\N
753	62	1	0	19681	\N
753	63	2	0	19687	\N
708	198	1	0	19986	\N
708	199	2	0	19988	\N
761	241	1	0	20355	\N
761	333	2	0	20363	\N
755	64	1	0	20641	\N
755	65	2	0	20642	\N
712	441	6	0	21740	\N
789	67	1	0	22109	\N
789	478	2	0	22110	\N
765	73	3	0	22377	\N
765	464	4	0	22387	\N
751	264	1	0	23395	\N
751	270	2	0	23399	\N
709	82	1	0	23690	\N
709	83	2	0	23693	\N
805	49	1	0	24973	\N
805	50	2	0	24974	\N
739	411	1	0	25127	\N
803	90	2	0	25975	\N
803	91	3	0	25982	\N
781	16	3	0	27804	\N
799	16	1	0	27805	\N
799	17	2	0	27807	\N
781	359	4	0	27808	\N
801	16	1	0	27810	\N
801	17	2	0	27813	\N
726	449	1	0	29752	\N
726	450	2	0	29753	\N
784	54	3	0	29960	\N
784	476	4	0	29963	\N
800	302	2	0	30639	\N
744	202	1	0	30957	\N
744	203	2	0	30958	\N
795	202	1	0	30963	\N
795	203	2	0	30966	\N
770	360	4	0	31276	\N
770	467	5	0	31277	\N
793	360	1	0	31299	\N
793	479	2	0	31300	\N
733	453	1	0	32602	\N
733	454	2	0	32605	\N
749	1	1	0	33096	\N
769	1	1	0	33098	\N
769	53	2	0	33099	\N
785	1	3	0	33100	\N
785	48	4	0	33103	\N
741	2	2	0	34974	\N
741	131	3	0	34976	\N
775	2	2	0	34997	\N
775	471	3	0	35002	\N
718	10	3	0	36684	\N
718	347	4	0	36685	\N
729	10	1	0	36688	\N
729	11	2	0	36689	\N
766	10	3	0	36695	\N
745	11	2	0	36696	\N
766	465	4	0	36697	\N
796	10	1	0	36700	\N
796	11	2	0	36701	\N
767	18	3	0	39617	\N
767	466	4	0	39620	\N
747	23	1	0	40655	\N
747	217	2	0	40656	\N
715	40	0	0	41372	\N
797	40	1	0	41381	\N
797	41	2	0	41384	\N
29837	40	8	0	42579	\N
831	56	1	0	43690	\N
816	57	2	0	43692	\N
831	57	2	0	43693	\N
810	75	2	0	45090	\N
819	75	1	0	45091	\N
819	76	2	0	45092	\N
810	159	3	0	45093	\N
840	79	2	0	46494	\N
842	79	1	0	46495	\N
842	81	2	0	46496	\N
840	80	3	0	46497	\N
885	88	2	0	47052	\N
885	154	3	0	47053	\N
862	100	1	0	47480	\N
862	160	2	0	47484	\N
881	113	1	0	48161	\N
881	437	2	0	48162	\N
815	125	1	0	49155	\N
815	195	2	0	49158	\N
857	136	2	0	49396	\N
858	137	1	0	49699	\N
858	138	2	0	49704	\N
882	170	1	0	50472	\N
882	398	2	0	50473	\N
814	242	1	0	52033	\N
814	253	2	0	52034	\N
884	260	1	0	52344	\N
884	261	2	0	52345	\N
839	338	2	0	53770	\N
839	415	3	0	53771	\N
845	316	1	0	53854	\N
845	317	2	0	53856	\N
860	316	4	0	53861	\N
860	494	5	0	53864	\N
838	324	2	0	54119	\N
838	486	3	0	54120	\N
818	362	1	0	54736	\N
818	395	2	0	54738	\N
844	435	1	0	54961	\N
844	436	2	0	54962	\N
866	451	2	0	55154	\N
866	497	3	0	55156	\N
834	484	2	0	55516	\N
826	111	3	0	2426	\N
855	492	4	0	2743	\N
861	189	4	0	4746	\N
861	495	5	0	4749	\N
880	108	2	0	11638	\N
880	501	3	0	11650	\N
872	58	1	0	13412	\N
872	59	2	0	13415	\N
865	402	2	0	14019	\N
865	496	3	0	14020	\N
843	173	1	0	14591	\N
843	396	2	0	14593	\N
820	92	1	0	14892	\N
856	38	3	0	16292	\N
856	493	4	0	16302	\N
850	292	1	0	18264	\N
850	293	2	0	18265	\N
887	292	2	0	18266	\N
887	502	3	0	18269	\N
868	177	1	0	18283	\N
868	498	2	0	18284	\N
873	290	1	0	18882	\N
873	291	2	0	18889	\N
854	208	4	0	19204	\N
864	208	1	0	19205	\N
854	491	5	0	19209	\N
822	62	1	0	19682	\N
822	63	2	0	19688	\N
853	64	4	0	20645	\N
853	490	5	0	20646	\N
851	488	1	0	21388	\N
851	489	2	0	21389	\N
833	67	1	0	22118	\N
833	478	2	0	22119	\N
859	67	1	0	22125	\N
859	478	2	0	22126	\N
830	336	1	0	22693	\N
869	149	1	0	23026	\N
869	499	2	0	23027	\N
847	140	2	0	23945	\N
847	487	3	0	23948	\N
852	69	0	0	24583	\N
876	69	2	0	24592	\N
876	500	3	0	24593	\N
813	49	1	0	24977	\N
817	49	2	0	24978	\N
813	50	2	0	24979	\N
817	328	3	0	24980	\N
821	206	1	0	25730	\N
812	345	1	0	26285	\N
812	346	2	0	26287	\N
811	16	1	0	27811	\N
832	16	1	0	27812	\N
811	17	2	0	27814	\N
832	17	2	0	27815	\N
870	16	1	0	27816	\N
883	16	1	0	27817	\N
870	17	2	0	27818	\N
883	17	2	0	27819	\N
886	16	2	0	27820	\N
886	155	3	0	27833	\N
835	334	2	0	29224	\N
825	96	2	0	29424	\N
825	482	3	0	29426	\N
837	54	2	0	29961	\N
837	485	3	0	29962	\N
877	54	3	0	29964	\N
877	476	4	0	29965	\N
849	20	1	0	30337	\N
849	144	2	0	30339	\N
808	1	1	0	33101	\N
808	53	2	0	33102	\N
824	1	2	0	33104	\N
846	1	1	0	33106	\N
828	53	2	0	33107	\N
846	53	2	0	33108	\N
824	112	3	0	33109	\N
875	1	2	0	33110	\N
875	112	3	0	33111	\N
878	1	1	0	33114	\N
878	53	2	0	33115	\N
863	2	1	0	34998	\N
863	26	2	0	35001	\N
809	6	2	0	36231	\N
809	179	3	0	36233	\N
827	10	1	0	36705	\N
827	11	2	0	36706	\N
823	29	3	0	36707	\N
829	10	1	0	36711	\N
829	11	2	0	36712	\N
841	10	1	0	36717	\N
848	10	1	0	36718	\N
841	11	2	0	36719	\N
848	11	2	0	36720	\N
871	10	1	0	36723	\N
879	10	2	0	36724	\N
871	11	2	0	36725	\N
867	14	1	0	38991	\N
867	15	2	0	38992	\N
836	18	1	0	39618	\N
836	19	2	0	39619	\N
874	18	2	0	39621	\N
874	218	3	0	39622	\N
19530	40	4	0	42614	\N
953	51	1	0	43476	\N
941	52	2	0	43477	\N
953	52	2	0	43478	\N
963	51	2	0	43483	\N
963	524	3	0	43491	\N
920	56	1	0	43691	\N
920	57	2	0	43694	\N
919	88	1	0	47062	\N
919	89	2	0	47064	\N
932	516	3	0	49944	\N
895	170	3	0	50476	\N
895	506	4	0	50477	\N
923	186	1	0	51171	\N
923	187	2	0	51172	\N
892	260	3	0	52346	\N
892	505	4	0	52347	\N
954	286	2	0	53358	\N
924	338	1	0	53772	\N
924	409	2	0	53773	\N
889	316	1	0	53862	\N
889	317	2	0	53863	\N
905	433	3	0	219	\N
951	520	3	0	679	\N
927	514	1	0	1041	\N
927	515	2	0	1043	\N
921	84	1	0	1757	\N
921	85	2	0	1758	\N
893	228	1	0	2754	\N
893	229	2	0	2755	\N
913	228	2	0	2766	\N
913	511	3	0	2771	\N
950	365	2	0	4422	\N
957	365	1	0	4423	\N
957	366	2	0	4424	\N
890	391	3	0	10090	\N
910	391	2	0	10091	\N
910	406	3	0	10093	\N
890	503	4	0	10094	\N
930	391	2	0	10095	\N
930	406	3	0	10096	\N
952	77	2	0	13001	\N
952	216	3	0	13002	\N
928	58	1	0	13413	\N
928	59	2	0	13416	\N
902	233	3	0	13721	\N
902	507	4	0	13722	\N
925	396	2	0	14594	\N
896	167	2	0	17596	\N
896	168	3	0	17598	\N
956	167	3	0	17600	\N
956	521	4	0	17601	\N
888	30	2	0	17969	\N
888	31	3	0	17972	\N
891	290	3	0	18898	\N
891	504	4	0	18904	\N
922	198	2	0	19989	\N
922	513	3	0	19990	\N
916	164	2	0	20936	\N
965	488	1	0	21392	\N
965	489	2	0	21393	\N
936	517	1	0	21623	\N
936	518	2	0	21624	\N
966	149	1	0	23028	\N
966	499	2	0	23030	\N
958	140	1	0	23950	\N
958	141	2	0	23953	\N
938	411	1	0	25128	\N
938	412	2	0	25132	\N
906	224	2	0	25408	\N
906	508	3	0	25410	\N
937	225	2	0	25423	\N
911	86	2	0	26405	\N
911	509	3	0	26411	\N
944	94	1	0	26682	\N
944	107	2	0	26684	\N
899	16	1	0	27821	\N
901	16	1	0	27822	\N
909	16	1	0	27823	\N
899	17	2	0	27827	\N
901	17	2	0	27828	\N
909	17	2	0	27829	\N
949	20	1	0	30340	\N
926	151	1	0	30635	\N
926	302	2	0	30640	\N
912	360	2	0	31309	\N
912	510	3	0	31310	\N
961	360	2	0	31319	\N
961	510	3	0	31320	\N
947	33	1	0	31663	\N
947	163	2	0	31664	\N
894	1	1	0	33118	\N
914	1	1	0	33119	\N
894	53	2	0	33120	\N
914	53	2	0	33121	\N
917	422	5	0	33125	\N
929	1	1	0	33129	\N
931	1	2	0	33130	\N
933	1	2	0	33131	\N
929	53	2	0	33132	\N
931	112	3	0	33133	\N
933	112	3	0	33134	\N
935	1	1	0	33140	\N
943	1	1	0	33141	\N
948	1	1	0	33142	\N
960	1	6	0	33143	\N
962	1	2	0	33144	\N
935	53	2	0	33146	\N
943	53	2	0	33147	\N
948	53	2	0	33148	\N
962	112	3	0	33149	\N
964	112	3	0	33150	\N
960	523	7	0	33151	\N
903	2	3	0	34999	\N
915	2	2	0	35000	\N
915	471	3	0	35003	\N
903	3	4	0	35004	\N
908	4	1	0	35869	\N
908	25	2	0	35872	\N
897	11	2	0	36730	\N
898	10	1	0	36733	\N
898	11	2	0	36734	\N
900	10	1	0	36741	\N
900	11	2	0	36742	\N
904	10	3	0	36745	\N
907	10	1	0	36746	\N
907	11	2	0	36747	\N
904	465	4	0	36748	\N
934	10	1	0	36755	\N
940	10	1	0	36756	\N
945	10	1	0	36757	\N
940	11	2	0	36759	\N
945	11	2	0	36760	\N
946	10	2	0	36763	\N
946	29	3	0	36764	\N
942	18	3	0	39623	\N
942	127	4	0	39624	\N
955	18	1	0	39625	\N
955	19	2	0	39628	\N
918	40	1	0	41382	\N
939	40	1	0	41383	\N
918	41	2	0	41385	\N
939	41	2	0	41386	\N
959	522	7	0	41390	\N
967	40	1	0	41393	\N
974	76	2	0	45103	\N
976	88	1	0	47063	\N
976	89	2	0	47065	\N
999	88	1	0	47078	\N
999	89	2	0	47079	\N
1027	100	1	0	47481	\N
1027	160	2	0	47485	\N
987	119	1	0	48588	\N
987	120	2	0	48590	\N
1056	547	18	0	49947	\N
1059	147	43	0	49948	\N
1059	551	44	0	49949	\N
1001	170	1	0	50478	\N
1001	398	2	0	50479	\N
1015	170	1	0	50480	\N
1015	398	2	0	50487	\N
996	181	1	0	50832	\N
996	530	2	0	50837	\N
972	186	1	0	51189	\N
1058	186	17	0	51190	\N
972	187	2	0	51191	\N
1058	549	18	0	51192	\N
975	260	1	0	52348	\N
975	261	2	0	52351	\N
1002	268	1	0	52629	\N
1002	269	2	0	52631	\N
991	286	2	0	53359	\N
1033	316	1	0	53867	\N
1033	317	2	0	53868	\N
1011	324	1	0	54121	\N
1011	325	2	0	54122	\N
1013	362	1	0	54737	\N
1013	395	2	0	54739	\N
1031	362	1	0	54741	\N
1031	395	2	0	54743	\N
992	389	1	0	54922	\N
992	390	2	0	54923	\N
994	13	2	0	217	\N
1028	535	2	0	1067	\N
1045	536	1	0	1670	\N
1045	537	2	0	1671	\N
985	204	1	0	1705	\N
985	205	2	0	1706	\N
1010	110	1	0	2421	\N
1012	110	2	0	2422	\N
1010	134	2	0	2424	\N
1012	111	3	0	2427	\N
1018	367	1	0	3256	\N
1018	368	2	0	3258	\N
979	237	1	0	3556	\N
982	189	1	0	4754	\N
982	190	2	0	4757	\N
1042	391	1	0	10097	\N
1042	392	2	0	10098	\N
1047	391	1	0	10099	\N
1047	392	2	0	10100	\N
989	528	1	0	12374	\N
989	529	2	0	12377	\N
1016	77	1	0	13012	\N
1016	78	2	0	13013	\N
1014	233	1	0	13741	\N
1014	234	2	0	13742	\N
1006	173	1	0	14597	\N
1006	396	2	0	14601	\N
1053	192	36	0	15257	\N
1053	544	37	0	15259	\N
1022	167	1	0	17604	\N
1034	167	1	0	17605	\N
1022	533	2	0	17606	\N
1034	533	2	0	17607	\N
1032	292	1	0	18267	\N
1032	293	2	0	18268	\N
968	241	1	0	20356	\N
968	333	2	0	20364	\N
1021	499	2	0	23031	\N
1036	140	1	0	23951	\N
1036	141	2	0	23954	\N
1009	69	1	0	24604	\N
1025	69	2	0	24605	\N
1009	70	2	0	24606	\N
1025	500	3	0	24607	\N
977	16	1	0	27824	\N
988	16	1	0	27825	\N
1024	16	1	0	27826	\N
977	17	2	0	27830	\N
988	17	2	0	27831	\N
1072	16	1	0	27836	\N
1072	17	2	0	27839	\N
970	525	1	0	29195	\N
970	526	2	0	29196	\N
998	20	1	0	30348	\N
998	144	2	0	30349	\N
980	202	1	0	30964	\N
980	203	2	0	30967	\N
1008	33	5	0	31680	\N
1008	532	6	0	31681	\N
984	453	1	0	32603	\N
1004	453	1	0	32604	\N
1004	454	2	0	32607	\N
981	1	1	0	33160	\N
983	1	1	0	33161	\N
981	53	2	0	33162	\N
983	53	2	0	33163	\N
1003	1	1	0	33166	\N
1019	1	1	0	33167	\N
1003	53	2	0	33168	\N
1019	53	2	0	33169	\N
1061	1	3	0	33174	\N
1061	48	4	0	33176	\N
1069	1	1	0	33182	\N
1007	431	2	0	34756	\N
1007	531	3	0	34757	\N
1000	2	1	0	35015	\N
1039	2	1	0	35016	\N
1000	26	2	0	35018	\N
1039	26	2	0	35019	\N
1037	6	1	0	36238	\N
1037	194	2	0	36239	\N
971	10	1	0	36767	\N
973	10	1	0	36768	\N
971	11	2	0	36769	\N
973	11	2	0	36770	\N
990	10	1	0	36776	\N
1005	10	0	0	36777	\N
986	11	2	0	36778	\N
990	11	2	0	36779	\N
1050	29	2	0	36784	\N
1050	541	3	0	36789	\N
1041	10	1	0	36790	\N
1041	11	2	0	36791	\N
1066	10	1	0	36800	\N
1066	11	2	0	36802	\N
969	18	1	0	39626	\N
1038	18	1	0	39627	\N
1038	19	2	0	39630	\N
967	41	2	0	41394	\N
978	41	1	0	41395	\N
978	40	2	0	41400	\N
993	40	1	0	41403	\N
995	40	1	0	41404	\N
993	41	2	0	41405	\N
995	41	2	0	41406	\N
997	40	1	0	41413	\N
997	41	2	0	41414	\N
1017	40	1	0	41423	\N
1017	41	2	0	41424	\N
25388	40	3	0	42709	\N
1060	552	17	0	43697	\N
1074	75	2	0	45099	\N
1103	75	1	0	45100	\N
1103	76	2	0	45104	\N
1074	159	3	0	45107	\N
1115	88	1	0	47088	\N
1115	89	2	0	47090	\N
1098	119	1	0	48589	\N
1098	120	2	0	48591	\N
1065	122	2	0	48788	\N
1093	121	10	0	48789	\N
1093	563	11	0	48790	\N
1112	516	3	0	49945	\N
1118	181	1	0	50833	\N
1118	530	2	0	50838	\N
1107	186	1	0	51202	\N
1107	187	2	0	51205	\N
1096	210	4	0	51716	\N
1096	565	5	0	51719	\N
1048	260	4	0	52349	\N
1048	538	5	0	52353	\N
1076	268	1	0	52656	\N
1076	269	2	0	52657	\N
1078	316	3	0	53874	\N
1078	555	4	0	53877	\N
1071	353	1	0	54500	\N
1099	353	1	0	54501	\N
1071	354	2	0	54503	\N
1099	354	2	0	54504	\N
1119	433	3	0	226	\N
1084	425	2	0	683	\N
1088	424	1	0	686	\N
1088	425	2	0	687	\N
1020	251	1	0	1394	\N
1020	252	2	0	1395	\N
1063	251	3	0	1402	\N
1063	554	4	0	1404	\N
1049	391	4	0	10101	\N
1049	539	5	0	10102	\N
1086	108	1	0	11639	\N
1087	108	0	0	11640	\N
1086	109	2	0	11645	\N
1080	459	2	0	11932	\N
1062	528	3	0	12375	\N
1062	553	4	0	12379	\N
1104	256	1	0	13321	\N
1104	257	2	0	13322	\N
1116	58	1	0	13419	\N
1116	59	2	0	13420	\N
1046	173	1	0	14598	\N
1046	396	2	0	14602	\N
1077	92	1	0	14894	\N
1077	191	2	0	14895	\N
1081	44	1	0	15967	\N
1090	115	9	0	16609	\N
1091	115	8	0	16610	\N
1091	560	9	0	16616	\N
1090	559	10	0	16617	\N
1085	556	1	0	16939	\N
1085	557	2	0	16940	\N
1113	212	2	0	16996	\N
1113	566	3	0	17003	\N
1075	30	1	0	17970	\N
1075	418	2	0	17971	\N
1040	413	1	0	18353	\N
1040	414	2	0	18355	\N
1092	562	10	0	18807	\N
1082	290	1	0	18899	\N
1082	291	2	0	18901	\N
1111	208	1	0	19226	\N
1111	209	2	0	19232	\N
1023	60	1	0	19360	\N
1023	61	2	0	19363	\N
1105	64	1	0	20649	\N
1105	65	2	0	20652	\N
1029	145	1	0	21800	\N
1029	153	2	0	21801	\N
1083	69	1	0	24619	\N
1110	411	1	0	25133	\N
1110	412	2	0	25136	\N
1070	224	1	0	25432	\N
1079	224	3	0	25433	\N
1070	225	2	0	25436	\N
1079	387	4	0	25439	\N
1054	86	36	0	26406	\N
1054	545	37	0	26412	\N
1026	94	2	0	26685	\N
1121	94	2	0	26686	\N
1026	95	3	0	26687	\N
1121	95	3	0	26688	\N
1067	17	2	0	27835	\N
1120	16	2	0	27837	\N
1120	155	3	0	27840	\N
1100	449	1	0	29754	\N
1100	450	2	0	29755	\N
1102	202	1	0	30965	\N
1102	203	2	0	30968	\N
1108	360	1	0	31327	\N
1108	479	2	0	31331	\N
1044	1	1	0	33172	\N
1057	1	17	0	33173	\N
1044	53	2	0	33175	\N
1095	1	4	0	33188	\N
1095	422	5	0	33189	\N
1097	1	1	0	33194	\N
1101	1	1	0	33195	\N
1097	53	2	0	33196	\N
1101	53	2	0	33197	\N
1051	2	9	0	35017	\N
1051	542	10	0	35020	\N
1068	2	1	0	35027	\N
1068	26	2	0	35028	\N
1089	2	16	0	35037	\N
1089	558	17	0	35038	\N
1123	4	1	0	35882	\N
1123	25	2	0	35885	\N
1125	4	71	0	35888	\N
1125	568	72	0	35889	\N
1114	6	2	0	36245	\N
1114	179	3	0	36246	\N
1035	10	1	0	36782	\N
1035	11	2	0	36783	\N
1064	10	2	0	36796	\N
1064	29	3	0	36797	\N
1073	10	2	0	36801	\N
1073	29	3	0	36803	\N
1106	11	2	0	36807	\N
1109	10	1	0	36810	\N
1109	11	2	0	36811	\N
1122	10	2	0	36814	\N
1122	29	3	0	36815	\N
1052	18	9	0	39632	\N
1052	543	10	0	39635	\N
1030	23	1	0	40670	\N
1030	217	2	0	40671	\N
1055	23	36	0	40677	\N
1055	546	37	0	40681	\N
1043	27	1	0	40956	\N
1094	40	4	0	41435	\N
1117	40	1	0	41436	\N
1117	41	2	0	41437	\N
1094	564	5	0	41438	\N
1124	40	1	0	41445	\N
1124	41	2	0	41446	\N
1126	40	2	0	41451	\N
13029	40	5	0	42760	\N
1179	169	3	0	43699	\N
1145	75	1	0	45101	\N
1156	75	1	0	45102	\N
1145	76	2	0	45105	\N
1156	76	2	0	45106	\N
1127	79	1	0	46086	\N
1127	81	2	0	46087	\N
1140	79	1	0	46136	\N
1140	81	2	0	46137	\N
1192	79	2	0	46203	\N
1192	80	3	0	46205	\N
1185	88	3	0	47089	\N
1185	580	4	0	47091	\N
1139	113	1	0	48157	\N
1139	437	2	0	48159	\N
1148	121	1	0	48793	\N
1158	121	1	0	48794	\N
1148	122	2	0	48795	\N
1158	122	2	0	48796	\N
1137	138	1	0	49679	\N
1137	137	2	0	49705	\N
1129	156	1	0	50145	\N
1129	157	2	0	50146	\N
1151	156	2	0	50149	\N
1151	571	3	0	50150	\N
1142	242	1	0	52035	\N
1142	253	2	0	52036	\N
1198	435	1	0	54963	\N
1198	436	2	0	54965	\N
1160	204	1	0	1708	\N
1134	570	3	0	1712	\N
1183	84	1	0	1759	\N
1183	85	2	0	1760	\N
1154	573	3	0	1891	\N
1154	574	4	0	1892	\N
1138	117	1	0	1922	\N
1138	248	2	0	1925	\N
1157	367	1	0	3257	\N
1157	368	2	0	3259	\N
1190	367	1	0	3261	\N
1190	368	2	0	3262	\N
1163	365	1	0	4430	\N
1201	222	1	0	5249	\N
1201	223	2	0	5250	\N
1143	391	1	0	10103	\N
1143	392	2	0	10104	\N
1171	391	1	0	10105	\N
1171	392	2	0	10106	\N
1186	391	3	0	10107	\N
1197	391	1	0	10108	\N
1197	392	2	0	10109	\N
1186	581	4	0	10110	\N
1136	78	1	0	13014	\N
1136	77	2	0	13031	\N
1162	335	3	0	13328	\N
1131	58	1	0	13421	\N
1131	59	2	0	13422	\N
1150	192	1	0	15260	\N
1150	193	2	0	15261	\N
1135	38	2	0	16293	\N
1135	39	3	0	16301	\N
1164	326	1	0	17291	\N
1164	327	2	0	17294	\N
1149	30	1	0	17973	\N
1196	30	1	0	17974	\N
1149	418	2	0	17976	\N
1176	177	1	0	18286	\N
1176	498	2	0	18287	\N
1166	290	2	0	18900	\N
1166	575	3	0	18903	\N
1155	208	1	0	19227	\N
1155	209	2	0	19233	\N
1172	60	1	0	19361	\N
1172	61	2	0	19364	\N
1177	577	1	0	20336	\N
1177	578	2	0	20337	\N
1170	64	1	0	20650	\N
1170	65	2	0	20653	\N
1188	164	0	0	20938	\N
1189	164	0	0	20939	\N
1187	307	4	0	20941	\N
1206	67	1	0	22136	\N
1206	478	2	0	22139	\N
1128	336	1	0	22694	\N
1128	356	2	0	22698	\N
1184	82	2	0	23697	\N
1184	343	3	0	23699	\N
1191	411	2	0	25134	\N
1191	582	3	0	25137	\N
1199	86	1	0	26407	\N
1132	16	2	0	27838	\N
1132	155	3	0	27841	\N
1193	449	2	0	29756	\N
1193	583	3	0	29757	\N
1174	151	2	0	30636	\N
1174	576	3	0	30642	\N
1165	360	2	0	31328	\N
1165	510	3	0	31333	\N
1167	33	1	0	31697	\N
1167	163	2	0	31699	\N
1144	230	1	0	31978	\N
1144	287	2	0	31980	\N
1147	53	2	0	33203	\N
1159	1	1	0	33206	\N
1159	53	2	0	33207	\N
1169	1	1	0	33210	\N
1169	53	2	0	33211	\N
1173	1	1	0	33216	\N
1173	53	2	0	33217	\N
1204	1	1	0	33219	\N
1204	53	2	0	33220	\N
1153	2	3	0	35049	\N
1181	2	1	0	35050	\N
1181	26	2	0	35051	\N
1178	4	2	0	35883	\N
1200	4	1	0	35884	\N
1200	25	2	0	35886	\N
1178	579	3	0	35887	\N
1130	10	1	0	36820	\N
1130	11	2	0	36821	\N
1152	10	3	0	36826	\N
1161	10	2	0	36827	\N
1161	29	3	0	36828	\N
1152	347	4	0	36829	\N
1182	10	1	0	36840	\N
1195	10	1	0	36841	\N
1195	11	2	0	36843	\N
1202	10	1	0	36850	\N
1202	11	2	0	36851	\N
1203	10	1	0	36856	\N
1203	11	2	0	36858	\N
1141	14	1	0	39003	\N
1141	15	2	0	39005	\N
1133	18	1	0	39633	\N
1133	19	2	0	39634	\N
1175	18	2	0	39636	\N
1175	218	3	0	39637	\N
1194	18	2	0	39638	\N
1126	569	3	0	41452	\N
1146	40	1	0	41457	\N
1168	40	1	0	41458	\N
1180	40	1	0	41459	\N
1146	41	2	0	41460	\N
1168	41	2	0	41461	\N
1180	41	2	0	41462	\N
1265	56	19	0	43700	\N
1265	593	20	0	43711	\N
1233	71	1	0	44710	\N
1233	72	2	0	44711	\N
1213	75	1	0	45116	\N
1261	75	1	0	45117	\N
1213	76	2	0	45122	\N
1261	76	2	0	45123	\N
1262	79	4	0	46204	\N
1262	589	5	0	46206	\N
1248	88	1	0	47100	\N
1297	88	4	0	47101	\N
1304	88	1	0	47102	\N
1248	89	2	0	47103	\N
1304	89	2	0	47104	\N
1297	601	5	0	47105	\N
1253	125	2	0	49175	\N
1279	125	1	0	49176	\N
1279	195	2	0	49177	\N
1253	188	3	0	49178	\N
1236	136	2	0	49397	\N
1237	137	1	0	49700	\N
1237	138	2	0	49706	\N
1271	599	2	0	49943	\N
1315	170	1	0	50481	\N
1315	398	2	0	50488	\N
1209	269	1	0	52658	\N
1209	268	2	0	52678	\N
1223	273	3	0	52898	\N
1255	273	1	0	52899	\N
1255	410	2	0	52904	\N
1223	586	4	0	52907	\N
1245	338	1	0	53781	\N
1245	409	2	0	53782	\N
1249	316	1	0	53875	\N
1249	317	2	0	53876	\N
1219	435	1	0	54964	\N
1219	436	2	0	54966	\N
1210	584	1	0	55153	\N
1210	451	2	0	55155	\N
1220	451	1	0	55157	\N
1220	584	2	0	55158	\N
1205	221	2	0	525	\N
1230	434	3	0	1766	\N
1313	110	1	0	2423	\N
1313	134	2	0	2425	\N
1259	237	1	0	3560	\N
1259	527	2	0	3561	\N
1294	189	2	0	4755	\N
1294	311	3	0	4759	\N
1264	591	4	0	5162	\N
1264	592	5	0	5163	\N
1225	391	1	0	10111	\N
1225	392	2	0	10112	\N
1246	391	1	0	10113	\N
1301	391	1	0	10115	\N
1301	392	2	0	10116	\N
1310	391	1	0	10117	\N
1310	392	2	0	10119	\N
1211	528	1	0	12376	\N
1211	529	2	0	12378	\N
1286	528	1	0	12381	\N
1286	529	2	0	12382	\N
1212	58	1	0	13423	\N
1212	59	2	0	13428	\N
1285	402	1	0	14025	\N
1285	403	2	0	14027	\N
1221	585	3	0	14357	\N
1224	235	3	0	15589	\N
1224	587	4	0	15591	\N
1321	115	5	0	16611	\N
1321	607	6	0	16615	\N
1250	290	1	0	18908	\N
1250	291	2	0	18910	\N
1229	198	1	0	19991	\N
1229	199	2	0	19992	\N
1218	241	1	0	20357	\N
1218	333	2	0	20365	\N
1227	73	1	0	22378	\N
1322	140	0	0	23946	\N
1234	69	2	0	24620	\N
1234	500	3	0	24622	\N
1267	69	3	0	24633	\N
1267	594	4	0	24634	\N
1207	411	2	0	25135	\N
1207	582	3	0	25138	\N
1242	411	1	0	25139	\N
1242	412	2	0	25140	\N
1228	206	1	0	25731	\N
1228	207	2	0	25733	\N
1247	206	1	0	25734	\N
1208	43	1	0	27456	\N
1240	42	1	0	27457	\N
1208	42	2	0	27458	\N
1240	43	2	0	27459	\N
1266	16	3	0	27842	\N
1266	359	4	0	27845	\N
1231	320	2	0	29221	\N
1254	320	0	0	29222	\N
1231	321	3	0	29225	\N
1256	320	1	0	29246	\N
1256	334	2	0	29247	\N
1291	151	1	0	30637	\N
1214	1	1	0	33223	\N
1214	53	2	0	33224	\N
1222	1	3	0	33227	\N
1244	1	1	0	33228	\N
1244	53	2	0	33229	\N
1222	48	4	0	33230	\N
1251	1	1	0	33233	\N
1252	1	2	0	33234	\N
1251	53	2	0	33235	\N
1252	112	3	0	33236	\N
1257	1	1	0	33243	\N
1257	53	2	0	33244	\N
1282	1	1	0	33248	\N
1260	53	2	0	33250	\N
1282	53	2	0	33251	\N
1295	2	1	0	35063	\N
1295	26	2	0	35064	\N
1241	4	1	0	35903	\N
1241	25	2	0	35904	\N
1216	8	1	0	36446	\N
1216	9	2	0	36449	\N
1215	10	3	0	36857	\N
1215	347	4	0	36859	\N
1226	10	1	0	36871	\N
1226	11	2	0	36873	\N
1235	11	2	0	36874	\N
1239	10	1	0	36881	\N
1243	10	1	0	36882	\N
1239	11	2	0	36884	\N
1243	11	2	0	36885	\N
1276	10	1	0	36889	\N
1307	10	0	0	36890	\N
1276	11	2	0	36891	\N
1316	10	1	0	36897	\N
1316	11	2	0	36900	\N
1217	14	1	0	39004	\N
1258	14	4	0	39019	\N
1258	588	5	0	39020	\N
1263	18	4	0	39639	\N
1263	590	5	0	39641	\N
1232	40	1	0	41478	\N
1232	41	2	0	41479	\N
1238	40	1	0	41489	\N
1238	41	2	0	41492	\N
1334	611	35	0	43712	\N
1334	56	55	0	43721	\N
1334	612	56	0	43722	\N
1339	56	3	0	43725	\N
1339	475	4	0	43726	\N
1344	56	3	0	43729	\N
1344	475	4	0	43730	\N
1364	79	2	0	46193	\N
1364	616	3	0	46198	\N
1340	88	1	0	47114	\N
1340	89	2	0	47115	\N
1293	100	2	0	47482	\N
1293	101	3	0	47488	\N
1337	100	1	0	47501	\N
1337	160	2	0	47503	\N
1324	102	3	0	47771	\N
1324	608	4	0	47772	\N
1268	113	1	0	48158	\N
1268	437	2	0	48160	\N
1330	119	1	0	48621	\N
1330	120	2	0	48622	\N
1318	181	1	0	50834	\N
1318	530	2	0	50839	\N
1326	268	3	0	52677	\N
1326	610	4	0	52679	\N
1347	325	1	0	54123	\N
1349	325	1	0	54124	\N
1350	325	1	0	54125	\N
1300	324	4	0	54131	\N
1347	324	2	0	54133	\N
1349	324	2	0	54134	\N
1350	324	2	0	54135	\N
1300	603	5	0	54136	\N
1312	362	1	0	54742	\N
1312	395	2	0	54744	\N
1341	451	1	0	55189	\N
1341	584	2	0	55190	\N
1269	596	2	0	55535	\N
1270	598	2	0	55830	\N
1290	400	2	0	10	\N
1298	602	5	0	528	\N
1359	424	1	0	692	\N
1359	425	2	0	695	\N
1305	204	1	0	1709	\N
1305	205	2	0	1711	\N
1273	84	1	0	1762	\N
1361	84	1	0	1763	\N
1273	85	2	0	1764	\N
1361	85	2	0	1765	\N
1351	367	1	0	3265	\N
1351	368	2	0	3266	\N
1303	237	3	0	3562	\N
1274	35	1	0	4124	\N
1274	340	2	0	4126	\N
1363	365	2	0	4431	\N
1367	365	1	0	4432	\N
1363	615	3	0	4441	\N
1356	391	4	0	10118	\N
1356	614	5	0	10120	\N
1346	109	1	0	11636	\N
1346	108	2	0	11646	\N
1354	528	2	0	12383	\N
1354	613	3	0	12385	\N
1288	256	2	0	13327	\N
1348	234	1	0	13743	\N
1348	233	2	0	13754	\N
1320	292	5	0	18270	\N
1320	606	6	0	18271	\N
1287	142	1	0	18430	\N
1287	143	2	0	18433	\N
1314	60	1	0	19370	\N
1314	61	2	0	19373	\N
1278	198	1	0	19993	\N
1278	199	2	0	19994	\N
1280	198	1	0	19995	\N
1280	199	2	0	19996	\N
1352	199	2	0	19998	\N
1327	64	1	0	20651	\N
1327	65	2	0	20654	\N
1353	67	1	0	22137	\N
1353	478	2	0	22140	\N
1277	336	1	0	22695	\N
1277	356	2	0	22699	\N
1328	82	1	0	23704	\N
1328	83	2	0	23706	\N
1323	140	0	0	23947	\N
1275	140	1	0	23952	\N
1275	141	2	0	23955	\N
1342	141	2	0	23957	\N
1302	224	1	0	25451	\N
1331	224	1	0	25452	\N
1302	225	2	0	25458	\N
1331	225	2	0	25459	\N
1311	42	1	0	27460	\N
1311	43	2	0	27461	\N
1281	16	1	0	27843	\N
1281	17	2	0	27844	\N
1319	16	1	0	27846	\N
1319	17	2	0	27847	\N
1332	16	1	0	27848	\N
1306	96	3	0	29427	\N
1306	605	4	0	29428	\N
1292	449	1	0	29762	\N
1292	450	2	0	29764	\N
1272	54	1	0	29966	\N
1272	55	2	0	29967	\N
1289	1	1	0	33249	\N
1289	53	2	0	33252	\N
1299	1	4	0	33271	\N
1299	422	5	0	33272	\N
1355	1	2	0	33280	\N
1355	112	3	0	33281	\N
1358	53	2	0	33284	\N
1360	1	1	0	33287	\N
1365	1	1	0	33288	\N
1360	53	2	0	33289	\N
1365	53	2	0	33290	\N
1335	4	2	0	35910	\N
1335	579	3	0	35911	\N
1343	8	1	0	36447	\N
1343	9	2	0	36450	\N
1308	10	0	0	36883	\N
1284	10	1	0	36894	\N
1296	10	4	0	36895	\N
1336	10	1	0	36898	\N
1284	11	2	0	36899	\N
1336	11	2	0	36901	\N
1296	600	5	0	36902	\N
1338	10	1	0	36905	\N
1357	10	1	0	36906	\N
1362	10	2	0	36907	\N
1338	11	2	0	36908	\N
1357	11	2	0	36909	\N
1362	275	3	0	36910	\N
1366	10	1	0	36915	\N
1366	11	2	0	36916	\N
1329	18	1	0	39643	\N
1329	19	2	0	39644	\N
1325	609	4	0	39645	\N
1333	18	1	0	39646	\N
1345	18	1	0	39647	\N
1333	19	2	0	39648	\N
1345	19	2	0	39649	\N
1283	40	1	0	41490	\N
1317	40	1	0	41491	\N
1283	41	2	0	41493	\N
1317	41	2	0	41494	\N
5770	41	1	0	42907	\N
1380	618	27	0	43734	\N
1444	56	55	0	43737	\N
1444	628	56	0	43738	\N
1506	79	1	0	46258	\N
1506	81	2	0	46259	\N
1388	88	6	0	47122	\N
1388	623	7	0	47123	\N
1393	88	1	0	47130	\N
1393	89	2	0	47132	\N
1491	88	1	0	47149	\N
1491	89	2	0	47150	\N
1503	88	1	0	47162	\N
1503	89	2	0	47163	\N
1464	113	1	0	48168	\N
1464	437	2	0	48169	\N
1515	113	1	0	48172	\N
1515	437	2	0	48173	\N
1396	119	1	0	48660	\N
1399	119	5	0	48661	\N
1396	120	2	0	48662	\N
1399	624	6	0	48663	\N
1406	121	2	0	48801	\N
1406	625	3	0	48804	\N
1373	125	1	0	49189	\N
1373	195	2	0	49191	\N
1411	147	1	0	49958	\N
1411	599	2	0	49969	\N
1371	170	1	0	50482	\N
1371	398	2	0	50489	\N
1386	186	6	0	51203	\N
1386	621	7	0	51207	\N
1370	210	1	0	51717	\N
1370	211	2	0	51718	\N
1387	210	6	0	51737	\N
1387	622	7	0	51744	\N
1382	242	2	0	52037	\N
1382	620	3	0	52038	\N
1478	242	1	0	52039	\N
1478	253	2	0	52040	\N
1476	268	5	0	52690	\N
1476	642	6	0	52693	\N
1379	324	3	0	54132	\N
1379	617	4	0	54137	\N
1377	362	1	0	54749	\N
1377	395	2	0	54750	\N
1409	596	2	0	55536	\N
1410	598	2	0	55831	\N
1467	638	2	0	56359	\N
1421	221	2	0	526	\N
1400	110	1	0	2442	\N
1400	134	2	0	2443	\N
1418	110	1	0	2448	\N
1418	134	2	0	2450	\N
1378	367	1	0	3269	\N
1378	368	2	0	3270	\N
1374	237	2	0	3564	\N
1374	319	3	0	3565	\N
1369	35	1	0	4125	\N
1369	340	2	0	4127	\N
1367	366	2	0	4437	\N
1427	391	1	0	10122	\N
1461	391	1	0	10127	\N
1461	392	2	0	10128	\N
1420	132	1	0	11076	\N
1420	455	2	0	11078	\N
1404	108	1	0	11641	\N
1404	109	2	0	11647	\N
1389	300	1	0	12010	\N
1389	355	2	0	12014	\N
1512	256	2	0	13332	\N
1512	335	3	0	13333	\N
1401	258	1	0	14365	\N
1401	309	2	0	14366	\N
1391	236	2	0	15595	\N
1390	44	1	0	15983	\N
1390	45	2	0	15984	\N
1441	44	2	0	15989	\N
1441	161	3	0	15992	\N
1472	212	1	0	16998	\N
1472	213	2	0	17002	\N
1480	60	3	0	19371	\N
1480	643	4	0	19375	\N
1511	164	2	0	20946	\N
1511	226	3	0	20955	\N
1484	145	1	0	21805	\N
1432	224	3	0	25453	\N
1432	387	4	0	25463	\N
1408	94	2	0	26689	\N
1450	94	3	0	26690	\N
1408	95	3	0	26691	\N
1450	631	4	0	26692	\N
1456	16	2	0	27850	\N
1456	388	3	0	27852	\N
1508	16	1	0	27856	\N
1508	17	2	0	27858	\N
1490	449	2	0	29771	\N
1490	646	3	0	29775	\N
1375	55	2	0	29970	\N
1402	20	1	0	30358	\N
1402	144	2	0	30361	\N
1397	151	2	0	30645	\N
1397	576	3	0	30646	\N
1514	33	2	0	31698	\N
1514	34	3	0	31700	\N
1385	453	1	0	32610	\N
1385	454	2	0	32611	\N
1395	453	1	0	32617	\N
1395	454	2	0	32619	\N
1376	1	1	0	33295	\N
1376	53	2	0	33298	\N
1407	112	3	0	33299	\N
1470	1	1	0	33303	\N
1470	53	2	0	33304	\N
1481	112	2	0	33305	\N
1485	1	2	0	33309	\N
1485	283	3	0	33311	\N
1481	1	3	0	33312	\N
1392	2	1	0	35078	\N
1392	26	2	0	35081	\N
1440	4	1	0	35924	\N
1440	25	2	0	35926	\N
1372	10	1	0	36920	\N
1368	11	2	0	36921	\N
1372	11	2	0	36922	\N
1383	10	6	0	36929	\N
1383	426	7	0	36930	\N
1384	10	1	0	36937	\N
1384	11	2	0	36938	\N
1394	10	1	0	36943	\N
1394	11	2	0	36944	\N
1405	10	2	0	36951	\N
1405	29	3	0	36952	\N
1494	10	1	0	36972	\N
1500	10	2	0	36981	\N
1500	29	3	0	36982	\N
1424	18	2	0	39650	\N
1424	218	3	0	39653	\N
1458	18	1	0	39654	\N
1458	19	2	0	39655	\N
1381	27	2	0	40957	\N
1381	619	3	0	40961	\N
1398	40	2	0	41501	\N
1403	40	1	0	41502	\N
1403	41	2	0	41504	\N
1398	66	3	0	41505	\N
1447	41	2	0	41516	\N
1496	51	4	0	43484	\N
1496	648	5	0	43492	\N
1469	639	11	0	43739	\N
1469	56	25	0	43743	\N
1469	640	26	0	43744	\N
1495	56	25	0	43749	\N
1495	647	26	0	43750	\N
1517	71	1	0	44716	\N
1517	72	2	0	44717	\N
1438	79	2	0	46194	\N
1443	79	2	0	46195	\N
1455	79	2	0	46196	\N
1475	79	5	0	46197	\N
1455	616	3	0	46199	\N
1438	80	3	0	46200	\N
1443	80	3	0	46201	\N
1475	641	6	0	46202	\N
1453	88	3	0	47131	\N
1453	632	4	0	47133	\N
1474	88	5	0	47148	\N
1474	243	6	0	47151	\N
1454	100	2	0	47502	\N
1454	633	3	0	47504	\N
1416	119	1	0	48684	\N
1452	119	1	0	48685	\N
1416	120	2	0	48686	\N
1452	120	2	0	48687	\N
1439	121	1	0	48802	\N
1439	122	2	0	48803	\N
1519	156	2	0	50161	\N
1519	571	3	0	50163	\N
1501	186	1	0	51204	\N
1501	187	2	0	51206	\N
1433	260	3	0	52350	\N
1433	271	4	0	52352	\N
1477	273	1	0	52900	\N
1477	410	2	0	52905	\N
1435	338	1	0	53774	\N
1435	409	2	0	53775	\N
1518	338	1	0	53776	\N
1518	409	2	0	53778	\N
1486	338	2	0	53783	\N
1486	644	3	0	53784	\N
1492	324	1	0	54140	\N
1492	325	2	0	54141	\N
1493	324	1	0	54153	\N
1493	325	2	0	54154	\N
1523	324	2	0	54157	\N
1523	486	3	0	54165	\N
1488	362	2	0	54753	\N
1488	420	3	0	54760	\N
1483	451	1	0	55197	\N
1483	584	2	0	55198	\N
1473	289	3	0	11	\N
1426	424	3	0	694	\N
1423	520	3	0	696	\N
1426	468	4	0	697	\N
1413	554	4	0	1405	\N
1419	110	2	0	2449	\N
1419	626	3	0	2451	\N
1507	228	1	0	2767	\N
1507	229	2	0	2769	\N
1434	367	1	0	3273	\N
1520	367	2	0	3274	\N
1434	368	2	0	3275	\N
1520	651	3	0	3276	\N
1479	604	4	0	3567	\N
1448	365	1	0	4433	\N
1448	366	2	0	4438	\N
1415	391	1	0	10121	\N
1415	392	2	0	10123	\N
1446	391	1	0	10125	\N
1446	392	2	0	10126	\N
1513	391	2	0	10129	\N
1513	406	3	0	10132	\N
1502	256	1	0	13330	\N
1502	257	2	0	13331	\N
1459	258	4	0	14376	\N
1425	192	3	0	15262	\N
1425	627	4	0	15269	\N
1428	235	1	0	15593	\N
1428	236	2	0	15596	\N
1524	44	1	0	15990	\N
1524	45	2	0	15991	\N
1437	38	2	0	16311	\N
1437	39	3	0	16314	\N
1445	629	2	0	16603	\N
1445	630	3	0	16604	\N
1466	115	2	0	16612	\N
1466	636	3	0	16614	\N
1417	213	2	0	17001	\N
1457	241	2	0	20358	\N
1457	634	3	0	20366	\N
1526	64	4	0	20665	\N
1442	82	2	0	23705	\N
1442	343	3	0	23707	\N
1498	214	4	0	24289	\N
1498	649	5	0	24291	\N
1414	86	1	0	26408	\N
1414	87	2	0	26410	\N
1463	244	0	0	27194	\N
1460	16	4	0	27851	\N
1482	155	2	0	27854	\N
1482	16	3	0	27855	\N
1449	449	1	0	29763	\N
1449	450	2	0	29765	\N
1462	449	1	0	29770	\N
1505	449	1	0	29772	\N
1462	450	2	0	29773	\N
1505	450	2	0	29774	\N
1471	54	1	0	29969	\N
1471	55	2	0	29971	\N
1412	151	3	0	30649	\N
1412	152	4	0	30652	\N
1522	34	3	0	31711	\N
1468	322	1	0	32320	\N
1468	323	2	0	32321	\N
1436	1	2	0	33297	\N
1436	112	3	0	33300	\N
1487	1	2	0	33310	\N
1487	112	3	0	33313	\N
1504	1	1	0	33318	\N
1504	53	2	0	33319	\N
1525	1	4	0	33322	\N
1525	422	5	0	33323	\N
1431	431	1	0	34758	\N
1497	2	4	0	35079	\N
1497	315	5	0	35083	\N
1509	6	1	0	36254	\N
1509	194	2	0	36256	\N
1422	10	0	0	36955	\N
1429	10	1	0	36958	\N
1429	11	2	0	36959	\N
1465	10	1	0	36968	\N
1465	11	2	0	36969	\N
1499	10	1	0	36978	\N
1499	11	2	0	36979	\N
1521	10	2	0	36988	\N
1451	18	1	0	39651	\N
1451	19	2	0	39652	\N
1516	23	5	0	40678	\N
1516	650	6	0	40679	\N
1489	27	2	0	40958	\N
1489	645	3	0	40960	\N
1430	40	3	0	41503	\N
1430	128	4	0	41506	\N
1510	40	2	0	41523	\N
1510	66	3	0	41526	\N
13863	40	1	0	42994	\N
1529	52	2	0	43488	\N
1547	56	40	0	43755	\N
1547	652	41	0	43756	\N
1624	671	43	0	43757	\N
1624	56	46	0	43760	\N
1624	169	47	0	43761	\N
1647	56	12	0	43766	\N
1647	676	13	0	43767	\N
1579	75	1	0	45118	\N
1634	75	2	0	45121	\N
1579	76	2	0	45124	\N
1634	159	3	0	45127	\N
1637	75	1	0	45150	\N
1637	76	2	0	45153	\N
1530	113	1	0	48176	\N
1530	437	2	0	48178	\N
1536	135	1	0	49402	\N
1536	136	2	0	49404	\N
1537	137	1	0	49701	\N
1537	138	2	0	49707	\N
1642	147	1	0	49959	\N
1642	599	2	0	49970	\N
1555	156	3	0	50162	\N
1555	407	4	0	50164	\N
1561	156	1	0	50167	\N
1561	157	2	0	50168	\N
1623	156	1	0	50173	\N
1623	157	2	0	50175	\N
1554	210	3	0	51738	\N
1554	655	4	0	51743	\N
1557	242	1	0	52041	\N
1557	253	2	0	52042	\N
1665	324	2	0	54159	\N
1665	486	3	0	54166	\N
1615	353	1	0	54502	\N
1615	354	2	0	54505	\N
1567	433	3	0	227	\N
1558	252	2	0	1413	\N
1570	251	1	0	1418	\N
1570	252	2	0	1423	\N
1548	204	1	0	1713	\N
1548	205	2	0	1714	\N
1533	84	1	0	1767	\N
1538	84	1	0	1768	\N
1533	85	2	0	1769	\N
1538	85	2	0	1770	\N
1528	117	1	0	1923	\N
1528	248	2	0	1926	\N
1552	654	0	0	1927	\N
1556	117	3	0	1929	\N
1553	118	4	0	1932	\N
1556	118	4	0	1933	\N
1588	110	1	0	2458	\N
1588	134	2	0	2460	\N
1578	657	1	0	3050	\N
1578	658	2	0	3052	\N
1587	367	1	0	3286	\N
1587	368	2	0	3290	\N
1627	189	1	0	4756	\N
1627	190	2	0	4758	\N
1670	391	2	0	10131	\N
1593	108	1	0	11642	\N
1612	108	4	0	11643	\N
1593	109	2	0	11648	\N
1612	669	5	0	11651	\N
1600	663	7	0	12712	\N
1602	58	2	0	13424	\N
1602	665	3	0	13432	\N
1630	92	1	0	14898	\N
1630	191	2	0	14900	\N
1598	38	1	0	16317	\N
1598	399	2	0	16319	\N
1560	142	2	0	18434	\N
1595	143	2	0	18437	\N
1560	656	3	0	18439	\N
1667	62	2	0	19683	\N
1667	683	3	0	19692	\N
1549	64	1	0	20666	\N
1549	65	2	0	20668	\N
1526	490	5	0	20670	\N
1600	662	6	0	20942	\N
1540	164	0	0	20947	\N
1541	164	1	0	20948	\N
1543	164	0	0	20949	\N
1544	164	0	0	20950	\N
1600	664	7	0	20957	\N
1551	73	0	0	22391	\N
1649	336	1	0	22696	\N
1649	356	2	0	22700	\N
1652	264	1	0	23396	\N
1652	270	2	0	23400	\N
1655	214	1	0	24295	\N
1655	215	2	0	24296	\N
1566	49	1	0	24983	\N
1566	50	2	0	24984	\N
1633	224	2	0	25454	\N
1633	508	3	0	25461	\N
1638	16	2	0	27865	\N
1644	16	1	0	27866	\N
1644	17	2	0	27867	\N
1550	54	0	0	29972	\N
1582	54	1	0	29973	\N
1582	55	2	0	29975	\N
1658	678	1	0	30912	\N
1658	679	2	0	30914	\N
1552	653	0	0	30942	\N
1597	202	1	0	30979	\N
1597	203	2	0	30981	\N
1532	360	1	0	31329	\N
1542	1	1	0	33326	\N
1542	53	2	0	33327	\N
1546	1	1	0	33332	\N
1546	53	2	0	33333	\N
1559	1	2	0	33336	\N
1559	112	3	0	33337	\N
1581	1	3	0	33348	\N
1581	48	4	0	33349	\N
1591	1	2	0	33359	\N
1591	112	3	0	33360	\N
1621	1	1	0	33374	\N
1662	1	4	0	33375	\N
1662	422	5	0	33387	\N
1608	667	95	0	34760	\N
1608	431	126	0	34763	\N
1608	668	127	0	34764	\N
1673	4	4	0	35939	\N
1673	684	5	0	35940	\N
1613	6	4	0	36255	\N
1613	670	5	0	36257	\N
1527	10	1	0	36989	\N
1527	11	2	0	36990	\N
1531	10	1	0	36995	\N
1531	11	2	0	36996	\N
1539	10	1	0	37000	\N
1545	10	1	0	37001	\N
1573	10	1	0	37002	\N
1535	11	2	0	37003	\N
1539	11	2	0	37004	\N
1545	11	2	0	37005	\N
1573	11	2	0	37006	\N
1672	10	1	0	37041	\N
1672	11	2	0	37043	\N
1534	18	1	0	39656	\N
1534	19	2	0	39657	\N
1584	27	1	0	40968	\N
1654	56	5	0	43770	\N
1654	677	6	0	43771	\N
1691	56	8	0	43782	\N
1691	689	9	0	43783	\N
1599	75	1	0	45119	\N
1619	75	1	0	45120	\N
1599	76	2	0	45125	\N
1619	76	2	0	45126	\N
1666	75	2	0	45151	\N
1666	159	3	0	45155	\N
1585	79	1	0	46306	\N
1585	81	2	0	46309	\N
1606	121	2	0	48808	\N
1606	625	3	0	48809	\N
1614	121	1	0	48832	\N
1614	122	2	0	48837	\N
1583	210	1	0	51739	\N
1671	210	1	0	51740	\N
1583	211	2	0	51741	\N
1671	211	2	0	51742	\N
1628	242	1	0	52047	\N
1628	253	2	0	52050	\N
1664	324	13	0	54158	\N
1664	682	14	0	54167	\N
1645	451	1	0	55207	\N
1645	584	2	0	55209	\N
1641	595	1	0	55537	\N
1641	596	2	0	55543	\N
1640	598	2	0	55832	\N
1618	400	2	0	18	\N
1574	252	2	0	1424	\N
1616	204	1	0	1715	\N
1616	205	2	0	1717	\N
1590	117	1	0	1930	\N
1590	248	2	0	1931	\N
1629	117	1	0	1934	\N
1629	248	2	0	1938	\N
1635	674	2	0	2281	\N
1635	675	3	0	2282	\N
1685	228	1	0	2768	\N
1685	229	2	0	2770	\N
1575	35	1	0	4128	\N
1668	391	2	0	10130	\N
1668	406	3	0	10133	\N
1692	391	2	0	10135	\N
1692	406	3	0	10140	\N
1686	687	1	0	11594	\N
1686	688	2	0	11599	\N
1594	660	88	0	11637	\N
1594	661	89	0	11652	\N
1611	108	0	0	11669	\N
1646	663	0	0	12713	\N
1680	663	0	0	12714	\N
1660	256	4	0	13334	\N
1622	115	1	0	16618	\N
1622	116	2	0	16622	\N
1565	167	1	0	17611	\N
1631	167	1	0	17612	\N
1565	533	2	0	17613	\N
1631	533	2	0	17614	\N
1636	292	1	0	18272	\N
1636	293	2	0	18273	\N
1639	292	1	0	18274	\N
1639	293	2	0	18275	\N
1676	142	1	0	18436	\N
1676	143	2	0	18438	\N
1657	291	2	0	18917	\N
1580	208	3	0	19228	\N
1596	208	1	0	19229	\N
1596	209	2	0	19234	\N
1580	659	4	0	19237	\N
1601	164	2	0	20951	\N
1648	164	1	0	20952	\N
1648	165	2	0	20954	\N
1601	226	3	0	20956	\N
1646	664	0	0	20964	\N
1680	664	0	0	20979	\N
1562	82	1	0	23712	\N
1625	672	1	0	23908	\N
1625	673	2	0	23909	\N
1632	672	1	0	23911	\N
1632	673	2	0	23912	\N
1572	206	1	0	25735	\N
1679	206	1	0	25736	\N
1572	207	2	0	25738	\N
1679	207	2	0	25739	\N
1651	86	1	0	26413	\N
1651	87	2	0	26414	\N
1659	244	1	0	27195	\N
1659	245	2	0	27196	\N
1663	681	3	0	27463	\N
1569	16	1	0	27857	\N
1569	17	2	0	27859	\N
1571	16	1	0	27860	\N
1571	17	2	0	27861	\N
1576	16	1	0	27863	\N
1576	17	2	0	27864	\N
1609	96	2	0	29429	\N
1609	482	3	0	29430	\N
1626	96	1	0	29431	\N
1626	97	2	0	29432	\N
1682	449	1	0	29786	\N
1674	20	4	0	30359	\N
1674	685	5	0	30363	\N
1594	653	89	0	30943	\N
1669	360	2	0	31330	\N
1669	510	3	0	31334	\N
1564	322	1	0	32322	\N
1564	323	2	0	32325	\N
1568	453	1	0	32618	\N
1568	454	2	0	32620	\N
1563	1	1	0	33344	\N
1563	53	2	0	33345	\N
1589	1	1	0	33354	\N
1610	1	1	0	33368	\N
1610	53	2	0	33369	\N
1688	2	1	0	35080	\N
1688	26	2	0	35082	\N
1643	4	1	0	35925	\N
1643	25	2	0	35927	\N
1617	8	1	0	36448	\N
1617	9	2	0	36451	\N
1577	10	1	0	37011	\N
1577	11	2	0	37012	\N
1586	10	1	0	37016	\N
1586	11	2	0	37017	\N
1605	10	2	0	37023	\N
1607	10	1	0	37024	\N
1592	11	2	0	37025	\N
1607	11	2	0	37026	\N
1605	29	3	0	37027	\N
1656	10	2	0	37036	\N
1656	29	3	0	37037	\N
1661	10	4	0	37040	\N
1689	10	1	0	37042	\N
1689	11	2	0	37044	\N
1661	600	5	0	37045	\N
1603	14	11	0	39033	\N
1604	383	3	0	39035	\N
1603	666	12	0	39036	\N
1653	18	1	0	39658	\N
1653	19	2	0	39659	\N
1620	40	1	0	41524	\N
1620	41	2	0	41525	\N
1650	40	1	0	41531	\N
1650	41	2	0	41533	\N
1786	677	6	0	43710	\N
1684	75	1	0	45152	\N
1684	76	2	0	45154	\N
1714	75	0	0	45160	\N
1776	75	1	0	45161	\N
1776	76	2	0	45162	\N
1677	79	1	0	46307	\N
1687	79	1	0	46308	\N
1677	81	2	0	46310	\N
1687	81	2	0	46311	\N
1706	88	2	0	47166	\N
1706	154	3	0	47167	\N
1721	113	4	0	48177	\N
1721	699	5	0	48179	\N
1813	119	1	0	48726	\N
1813	120	2	0	48728	\N
1723	156	2	0	50174	\N
1723	571	3	0	50176	\N
1710	186	2	0	51214	\N
1792	186	1	0	51216	\N
1792	187	2	0	51220	\N
1710	696	3	0	51223	\N
1820	200	1	0	51441	\N
1820	201	2	0	51443	\N
1773	210	1	0	51751	\N
1773	211	2	0	51753	\N
1801	273	1	0	52901	\N
1801	410	2	0	52906	\N
1695	338	1	0	53777	\N
1695	409	2	0	53779	\N
1795	338	1	0	53787	\N
1795	409	2	0	53789	\N
1700	324	0	0	54160	\N
1703	324	1	0	54161	\N
1705	324	0	0	54162	\N
1703	325	2	0	54164	\N
1719	324	1	0	54171	\N
1727	324	1	0	54172	\N
1719	325	2	0	54173	\N
1727	325	2	0	54174	\N
1701	324	31	0	54175	\N
1701	690	32	0	54176	\N
1718	324	11	0	54206	\N
1718	698	12	0	54207	\N
1728	324	9	0	54239	\N
1728	700	10	0	54240	\N
1803	353	1	0	54510	\N
1803	354	2	0	54516	\N
1731	389	2	0	54924	\N
1731	701	3	0	54925	\N
1761	252	2	0	1425	\N
1716	205	2	0	1718	\N
1764	84	1	0	1771	\N
1764	85	2	0	1772	\N
1704	691	1	0	1794	\N
1704	692	2	0	1796	\N
1683	262	1	0	3682	\N
1683	263	2	0	3684	\N
1807	391	1	0	10136	\N
1807	392	2	0	10138	\N
1678	300	1	0	12011	\N
1678	355	2	0	12015	\N
1694	402	1	0	14026	\N
1775	173	1	0	14599	\N
1775	396	2	0	14603	\N
1826	92	1	0	14899	\N
1826	191	2	0	14901	\N
1754	38	1	0	16325	\N
1754	399	2	0	16328	\N
1713	212	0	0	16999	\N
1709	290	4	0	18915	\N
1709	695	5	0	18919	\N
1733	290	1	0	18926	\N
1733	291	2	0	18929	\N
1720	577	1	0	20338	\N
1675	241	4	0	20359	\N
1675	686	5	0	20367	\N
1681	164	1	0	20962	\N
1681	165	2	0	20963	\N
1726	164	1	0	20978	\N
1726	165	2	0	20980	\N
1746	73	2	0	22392	\N
1746	703	3	0	22393	\N
1838	73	1	0	22400	\N
1838	74	2	0	22401	\N
1715	149	2	0	23032	\N
1715	697	3	0	23033	\N
1767	49	1	0	24988	\N
1767	50	2	0	24989	\N
1730	328	3	0	24990	\N
1785	49	1	0	24993	\N
1785	50	2	0	24994	\N
1707	206	2	0	25742	\N
1707	693	3	0	25744	\N
1702	90	1	0	25976	\N
1816	90	0	0	25978	\N
1702	344	2	0	25981	\N
1834	90	0	0	25988	\N
1696	16	1	0	27868	\N
1724	16	2	0	27870	\N
1770	16	3	0	27871	\N
1724	155	3	0	27872	\N
1770	359	4	0	27873	\N
1740	20	2	0	30360	\N
1740	702	3	0	30362	\N
1841	360	1	0	31347	\N
1841	479	2	0	31348	\N
1722	1	4	0	33376	\N
1748	1	2	0	33378	\N
1798	1	3	0	33381	\N
1748	112	3	0	33385	\N
1798	711	4	0	33389	\N
1708	431	73	0	34767	\N
1708	694	74	0	34768	\N
1739	4	1	0	35954	\N
1739	25	2	0	35955	\N
1690	8	2	0	36452	\N
1690	37	3	0	36453	\N
1717	10	1	0	37048	\N
1725	10	1	0	37049	\N
1717	11	2	0	37050	\N
1725	11	2	0	37051	\N
1729	10	1	0	37054	\N
1743	10	1	0	37059	\N
1743	11	2	0	37061	\N
1745	10	1	0	37064	\N
1755	10	1	0	37065	\N
1745	11	2	0	37066	\N
1755	11	2	0	37067	\N
1778	10	1	0	37070	\N
1778	11	2	0	37072	\N
1804	10	3	0	37076	\N
1804	297	4	0	37079	\N
1835	10	2	0	37082	\N
1835	29	3	0	37083	\N
1693	218	3	0	39661	\N
1697	18	4	0	39662	\N
1697	590	5	0	39663	\N
1737	18	1	0	39666	\N
1737	19	2	0	39667	\N
1698	40	1	0	41532	\N
1698	41	2	0	41534	\N
1711	40	2	0	41541	\N
1711	66	3	0	41542	\N
1712	40	0	0	41547	\N
1782	40	2	0	41549	\N
1782	66	3	0	41553	\N
6928	40	2	0	43085	\N
1850	57	2	0	43706	\N
1805	75	3	0	45170	\N
1805	713	4	0	45171	\N
1734	79	1	0	46365	\N
1797	79	1	0	46366	\N
1734	81	2	0	46367	\N
1797	81	2	0	46368	\N
1762	88	3	0	47170	\N
1762	580	4	0	47171	\N
1765	88	1	0	47174	\N
1765	89	2	0	47175	\N
1814	88	1	0	47178	\N
1814	89	2	0	47179	\N
1872	160	1	0	47505	\N
1874	160	1	0	47506	\N
1872	100	3	0	47518	\N
1874	100	3	0	47519	\N
1872	160	4	0	47520	\N
1874	160	4	0	47521	\N
1744	119	1	0	48708	\N
1744	120	2	0	48709	\N
1859	170	2	0	50483	\N
1859	718	3	0	50493	\N
1756	181	1	0	50835	\N
1756	530	2	0	50840	\N
1750	186	1	0	51215	\N
1750	187	2	0	51219	\N
1809	200	1	0	51440	\N
1809	201	2	0	51442	\N
1857	200	1	0	51446	\N
1857	201	2	0	51447	\N
1891	200	1	0	51450	\N
1891	201	2	0	51451	\N
1856	268	1	0	52701	\N
1856	269	2	0	52703	\N
1780	338	1	0	53785	\N
1794	338	0	0	53786	\N
1780	409	2	0	53788	\N
1822	338	0	0	53791	\N
1887	362	1	0	54754	\N
1887	395	2	0	54757	\N
1777	705	2	0	56367	\N
1845	12	2	0	241	\N
1752	220	1	0	529	\N
1752	221	2	0	530	\N
1799	424	3	0	711	\N
1876	424	1	0	712	\N
1876	425	2	0	715	\N
1799	712	4	0	718	\N
1878	251	1	0	1421	\N
1878	252	2	0	1426	\N
1753	657	1	0	3051	\N
1753	658	2	0	3053	\N
1848	189	1	0	4767	\N
1848	190	2	0	4768	\N
1862	720	2	0	5169	\N
1827	391	1	0	10137	\N
1827	392	2	0	10139	\N
1871	132	1	0	11084	\N
1871	455	2	0	11085	\N
1759	108	1	0	11644	\N
1759	109	2	0	11649	\N
1829	300	1	0	12017	\N
1829	355	2	0	12018	\N
1757	528	2	0	12384	\N
1757	613	3	0	12386	\N
1772	528	2	0	12391	\N
1881	58	1	0	13425	\N
1881	59	2	0	13429	\N
1868	722	81	0	13995	\N
1742	192	1	0	15263	\N
1742	193	2	0	15266	\N
1847	115	1	0	16619	\N
1853	115	1	0	16620	\N
1854	115	1	0	16621	\N
1847	116	2	0	16623	\N
1853	116	2	0	16624	\N
1854	116	2	0	16625	\N
1769	292	1	0	18276	\N
1788	209	1	0	19208	\N
1788	208	2	0	19235	\N
1800	60	1	0	19372	\N
1800	61	2	0	19374	\N
1771	64	2	0	20667	\N
1771	162	3	0	20669	\N
1875	145	1	0	21824	\N
1875	153	2	0	21825	\N
1890	67	1	0	22138	\N
1890	478	2	0	22141	\N
1774	149	1	0	23034	\N
1774	499	2	0	23037	\N
1763	270	2	0	23401	\N
1766	82	0	0	23713	\N
1868	721	80	0	26415	\N
1868	723	81	0	26424	\N
1860	94	2	0	26694	\N
1860	95	3	0	26701	\N
1865	42	1	0	27465	\N
1865	43	2	0	27466	\N
1839	449	1	0	29787	\N
1839	450	2	0	29791	\N
1836	54	1	0	29974	\N
1836	55	2	0	29976	\N
1812	231	3	0	31981	\N
1741	1	2	0	33377	\N
1758	1	2	0	33379	\N
1760	1	1	0	33380	\N
1760	53	2	0	33383	\N
1741	112	3	0	33384	\N
1758	112	3	0	33386	\N
1832	1	1	0	33392	\N
1832	53	2	0	33394	\N
1866	1	1	0	33398	\N
1866	53	2	0	33400	\N
1736	2	1	0	35099	\N
1736	26	2	0	35101	\N
1817	315	5	0	35102	\N
1738	4	0	0	35953	\N
1732	10	1	0	37058	\N
1732	11	2	0	37060	\N
1791	10	2	0	37071	\N
1791	29	3	0	37073	\N
1808	10	1	0	37077	\N
1808	11	2	0	37078	\N
1863	10	1	0	37086	\N
1882	10	1	0	37087	\N
1863	11	2	0	37088	\N
1884	10	1	0	37092	\N
1884	11	2	0	37096	\N
1818	14	1	0	39049	\N
1818	15	2	0	39050	\N
1735	18	1	0	39664	\N
1735	19	2	0	39665	\N
1749	18	2	0	39668	\N
1783	18	2	0	39669	\N
1824	18	1	0	39670	\N
1824	19	2	0	39673	\N
1749	218	3	0	39676	\N
1783	218	3	0	39677	\N
1751	28	2	0	40986	\N
1747	40	2	0	41548	\N
1844	40	1	0	41550	\N
1844	41	2	0	41551	\N
1747	66	3	0	41552	\N
1879	40	2	0	41562	\N
1879	66	3	0	41563	\N
14866	40	2	0	43117	\N
1895	51	1	0	43487	\N
1889	52	2	0	43489	\N
1895	52	2	0	43490	\N
1926	56	3	0	43703	\N
1926	475	4	0	43709	\N
1789	72	1	0	44718	\N
1789	71	2	0	44727	\N
1806	75	1	0	45179	\N
1806	76	2	0	45180	\N
1849	75	1	0	45200	\N
1849	76	2	0	45203	\N
1900	119	1	0	48727	\N
1900	120	2	0	48729	\N
1897	121	1	0	48833	\N
1897	122	2	0	48838	\N
1921	170	1	0	50484	\N
1921	398	2	0	50490	\N
1899	181	3	0	50836	\N
1899	724	4	0	50841	\N
1907	242	1	0	52048	\N
1907	253	2	0	52051	\N
1940	260	1	0	52354	\N
1940	261	2	0	52357	\N
1802	268	1	0	52691	\N
1802	269	2	0	52692	\N
1810	268	1	0	52700	\N
1810	269	2	0	52702	\N
1793	708	26	0	53780	\N
1793	710	27	0	53790	\N
1825	338	1	0	53792	\N
1825	409	2	0	53794	\N
1823	710	0	0	53796	\N
1911	316	3	0	53888	\N
1911	555	4	0	53889	\N
1843	12	1	0	240	\N
1928	424	3	0	713	\N
1928	468	4	0	717	\N
1784	117	1	0	1935	\N
1784	248	2	0	1939	\N
1885	110	1	0	2459	\N
1885	134	2	0	2461	\N
1934	228	1	0	2793	\N
1934	229	2	0	2794	\N
1903	725	1	0	3046	\N
1903	726	2	0	3047	\N
1821	714	1	0	4079	\N
1821	715	2	0	4083	\N
1837	717	2	0	5293	\N
1811	132	1	0	11077	\N
1811	455	2	0	11079	\N
1781	300	2	0	12012	\N
1781	706	3	0	12016	\N
1904	727	1	0	12322	\N
1904	728	2	0	12325	\N
1888	123	1	0	12721	\N
1888	124	2	0	12722	\N
1892	256	1	0	13336	\N
1892	257	2	0	13337	\N
1830	38	1	0	16326	\N
1932	115	1	0	16626	\N
1932	116	2	0	16629	\N
1793	709	27	0	16983	\N
1823	709	0	0	16984	\N
1873	533	1	0	17608	\N
1873	167	3	0	17615	\N
1873	533	4	0	17616	\N
1819	292	2	0	18250	\N
1819	502	3	0	18253	\N
1831	292	1	0	18256	\N
1831	293	2	0	18258	\N
1909	208	1	0	19230	\N
1938	62	1	0	19684	\N
1938	63	2	0	19689	\N
1840	64	1	0	20674	\N
1840	65	2	0	20675	\N
1886	64	2	0	20680	\N
1886	162	3	0	20681	\N
1828	164	1	0	20989	\N
1919	164	1	0	20990	\N
1828	165	2	0	20992	\N
1919	165	2	0	20993	\N
1914	488	2	0	21398	\N
1914	729	3	0	21404	\N
1943	703	3	0	22411	\N
1855	149	1	0	23035	\N
1855	499	2	0	23038	\N
1898	264	1	0	23416	\N
1898	270	2	0	23417	\N
1861	140	1	0	23958	\N
1861	141	2	0	23960	\N
1893	411	1	0	25141	\N
1893	412	2	0	25143	\N
1815	90	2	0	25977	\N
1815	91	3	0	25983	\N
1833	90	1	0	25987	\N
1869	86	1	0	26416	\N
1869	87	2	0	26422	\N
1852	244	1	0	27199	\N
1894	244	1	0	27200	\N
1852	245	2	0	27201	\N
1894	245	2	0	27202	\N
1787	16	5	0	27874	\N
1787	707	6	0	27875	\N
1790	17	1	0	27876	\N
1790	16	2	0	27877	\N
1877	16	1	0	27878	\N
1877	17	2	0	27882	\N
1905	54	1	0	29980	\N
1846	55	2	0	29981	\N
1905	55	2	0	29982	\N
1842	33	1	0	31725	\N
1842	163	2	0	31727	\N
1851	1	1	0	33393	\N
1851	53	2	0	33395	\N
1867	1	1	0	33399	\N
1867	53	2	0	33401	\N
1896	1	3	0	33405	\N
1896	48	4	0	33406	\N
1917	1	1	0	33413	\N
1937	1	1	0	33424	\N
1937	53	2	0	33428	\N
1858	2	2	0	35119	\N
1858	131	3	0	35120	\N
1883	8	1	0	36454	\N
1908	8	1	0	36455	\N
1883	9	2	0	36457	\N
1908	9	2	0	36458	\N
1901	10	1	0	37093	\N
1906	10	1	0	37094	\N
1923	10	1	0	37095	\N
1901	11	2	0	37097	\N
1923	11	2	0	37099	\N
1929	10	1	0	37105	\N
1929	11	2	0	37109	\N
1796	14	3	0	39043	\N
1796	306	4	0	39044	\N
1902	18	1	0	39671	\N
1910	18	1	0	39672	\N
1902	19	2	0	39674	\N
1910	19	2	0	39675	\N
1870	23	1	0	40694	\N
1870	217	2	0	40702	\N
1864	27	1	0	40985	\N
1880	40	1	0	41572	\N
1880	41	2	0	41573	\N
40	51	1	0	43439	1000000000
1942	169	3	0	43708	\N
1930	75	1	0	45202	\N
1930	76	2	0	45205	\N
2075	79	1	0	46459	\N
2075	81	2	0	46464	\N
1996	100	2	0	47517	\N
1996	101	3	0	47522	\N
2065	125	1	0	49190	\N
2065	195	2	0	49192	\N
1936	156	1	0	50180	\N
1936	157	2	0	50181	\N
2094	156	1	0	50192	\N
2094	157	2	0	50196	\N
2083	170	1	0	50486	\N
2083	398	2	0	50492	\N
1915	242	2	0	52049	\N
1915	620	3	0	52052	\N
1947	242	1	0	52063	\N
1947	253	2	0	52064	\N
2062	260	1	0	52355	\N
2062	261	2	0	52358	\N
2090	268	1	0	52710	\N
2090	269	2	0	52712	\N
1991	285	1	0	53367	\N
1991	286	2	0	53368	\N
2047	338	1	0	53801	\N
2047	409	2	0	53802	\N
1975	738	127	1	54142	\N
1975	737	42	0	54241	\N
1975	324	126	0	54249	\N
1962	353	1	0	54511	\N
2052	353	2	0	54512	\N
1962	354	2	0	54517	\N
2052	755	3	0	54521	\N
2056	757	2	0	56585	\N
1948	734	2	0	1074	\N
2032	748	3	0	1746	\N
1999	84	1	0	1773	\N
1999	85	2	0	1774	\N
2032	84	2	0	1777	\N
1966	110	6	0	2472	\N
1966	736	7	0	2473	\N
1951	262	1	0	3709	\N
1951	263	2	0	3711	\N
1953	365	1	0	4434	\N
1954	365	1	0	4435	\N
1953	366	2	0	4439	\N
1954	366	2	0	4440	\N
2059	366	2	0	4451	\N
1912	391	1	0	10141	\N
1912	392	2	0	10142	\N
1968	391	2	0	10143	\N
1980	391	1	0	10145	\N
1980	392	2	0	10148	\N
1968	406	3	0	10150	\N
1975	124	127	0	12831	\N
2036	256	2	0	13340	\N
2036	335	3	0	13342	\N
2088	233	0	0	13763	\N
2097	239	2	0	14572	\N
1971	173	1	0	14600	\N
1971	396	2	0	14604	\N
1995	235	1	0	15594	\N
1995	236	2	0	15597	\N
1956	38	2	0	16327	\N
1956	39	3	0	16331	\N
1978	115	1	0	16628	\N
1978	116	2	0	16630	\N
2091	115	1	0	16632	\N
2091	116	2	0	16634	\N
1944	142	1	0	18442	\N
1946	142	47	0	18443	\N
1946	733	48	0	18449	\N
1977	60	1	0	19378	\N
2005	60	2	0	19379	\N
1977	61	2	0	19380	\N
2005	166	3	0	19381	\N
1982	164	1	0	20991	\N
1982	165	2	0	20994	\N
1939	336	1	0	22701	\N
1939	356	2	0	22702	\N
2004	336	2	0	22703	\N
2004	740	3	0	22708	\N
2010	82	1	0	23714	\N
2045	752	13	0	26693	\N
2045	94	49	0	26702	\N
2045	753	50	0	26703	\N
1984	16	2	0	27880	\N
2030	16	1	0	27881	\N
2030	17	2	0	27884	\N
1984	155	3	0	27885	\N
2035	16	1	0	27886	\N
2035	17	2	0	27887	\N
2014	320	1	0	29271	\N
2014	334	2	0	29273	\N
1994	151	1	0	30655	\N
1986	202	1	0	30980	\N
1986	203	2	0	30982	\N
1918	360	1	0	31357	\N
1918	479	2	0	31359	\N
1920	1	1	0	33417	\N
1920	53	2	0	33418	\N
1981	1	1	0	33425	\N
1993	1	1	0	33426	\N
1981	53	2	0	33429	\N
1993	53	2	0	33430	\N
2008	1	3	0	33439	\N
2016	1	3	0	33443	\N
2069	1	1	0	33467	\N
2069	53	2	0	33469	\N
2101	1	1	0	33473	\N
2101	53	2	0	33474	\N
1973	2	1	0	35135	\N
2007	2	2	0	35136	\N
2022	2	2	0	35137	\N
1973	26	2	0	35139	\N
2007	131	3	0	35142	\N
2022	131	3	0	35143	\N
1958	6	1	0	36273	\N
1958	194	2	0	36279	\N
1957	10	1	0	37108	\N
1950	11	2	0	37111	\N
1957	11	2	0	37112	\N
1960	10	2	0	37114	\N
1972	10	1	0	37115	\N
1972	11	2	0	37116	\N
1960	29	3	0	37117	\N
1983	10	1	0	37120	\N
1983	11	2	0	37121	\N
1988	10	1	0	37124	\N
1988	11	2	0	37125	\N
1998	10	1	0	37129	\N
2099	10	1	0	37176	\N
2099	11	2	0	37177	\N
1959	18	1	0	39678	\N
1965	18	1	0	39679	\N
2001	18	1	0	39680	\N
1959	19	2	0	39682	\N
1965	19	2	0	39683	\N
2001	19	2	0	39684	\N
2078	18	1	0	39686	\N
2078	19	2	0	39687	\N
1990	23	1	0	40695	\N
1990	217	2	0	40703	\N
2072	66	3	0	41610	\N
1941	56	1	0	43704	\N
1941	57	2	0	43707	\N
1925	75	1	0	45201	\N
1925	76	2	0	45204	\N
1952	75	1	0	45217	\N
2031	75	1	0	45218	\N
2044	75	1	0	45219	\N
1952	76	2	0	45221	\N
2031	76	2	0	45222	\N
2044	76	2	0	45223	\N
2024	79	2	0	46419	\N
2024	80	3	0	46420	\N
1955	88	2	0	47186	\N
1955	154	3	0	47191	\N
2019	100	1	0	47532	\N
2019	160	2	0	47535	\N
1967	102	2	0	47773	\N
1967	158	3	0	47774	\N
2050	113	1	0	48182	\N
2050	437	2	0	48183	\N
2077	113	1	0	48196	\N
2077	437	2	0	48199	\N
2100	121	1	0	48834	\N
2103	121	1	0	48835	\N
2100	122	2	0	48839	\N
2103	122	2	0	48840	\N
1987	156	1	0	50191	\N
1987	157	2	0	50195	\N
2049	170	1	0	50485	\N
2049	398	2	0	50491	\N
2015	273	3	0	52902	\N
2015	586	4	0	52908	\N
1927	730	4	0	53360	\N
1961	338	2	0	53793	\N
1961	415	3	0	53795	\N
1964	338	1	0	53797	\N
1964	409	2	0	53798	\N
2020	338	1	0	53799	\N
2020	409	2	0	53800	\N
2066	338	1	0	53803	\N
2066	409	2	0	53805	\N
1974	324	1	0	54197	\N
2000	324	1	0	54198	\N
1974	325	2	0	54202	\N
2000	325	2	0	54203	\N
2002	737	42	0	54250	\N
2002	324	54	0	54263	\N
2002	698	55	0	54264	\N
2085	353	1	0	54513	\N
2085	354	2	0	54518	\N
1922	362	1	0	54755	\N
1922	395	2	0	54758	\N
2011	744	82	0	54938	\N
2009	742	2	0	1363	\N
2034	751	2	0	1775	\N
2034	434	3	0	1776	\N
2080	758	1	0	1821	\N
2080	759	2	0	1822	\N
1976	237	1	0	3568	\N
1976	527	2	0	3569	\N
1931	262	2	0	3694	\N
1931	731	3	0	3695	\N
1985	189	2	0	4773	\N
1985	311	3	0	4774	\N
1970	391	1	0	10144	\N
1970	392	2	0	10147	\N
2074	392	2	0	10152	\N
2061	77	1	0	13042	\N
2061	78	2	0	13043	\N
1997	38	2	0	16335	\N
1997	39	3	0	16338	\N
1935	115	3	0	16627	\N
1935	732	4	0	16631	\N
2046	212	6	0	17011	\N
2046	754	7	0	17012	\N
2026	326	2	0	17296	\N
2026	747	3	0	17298	\N
2013	177	1	0	18289	\N
2012	290	1	0	18927	\N
2012	291	2	0	18930	\N
2023	198	2	0	19999	\N
2023	746	3	0	20000	\N
1989	67	1	0	22152	\N
1989	478	2	0	22155	\N
2018	336	1	0	22704	\N
2018	356	2	0	22706	\N
2089	149	3	0	23036	\N
2089	150	4	0	23039	\N
2098	42	2	0	27469	\N
2098	681	3	0	27470	\N
1924	17	2	0	27883	\N
2041	16	2	0	27888	\N
2041	155	3	0	27893	\N
2011	743	81	0	29248	\N
2011	745	82	0	29275	\N
1963	449	1	0	29788	\N
1963	450	2	0	29792	\N
2021	54	2	0	29991	\N
2079	54	1	0	29992	\N
2079	55	2	0	29999	\N
2021	485	3	0	30003	\N
1916	151	1	0	30650	\N
1933	1	1	0	33423	\N
1933	53	2	0	33427	\N
2003	1	1	0	33433	\N
2003	53	2	0	33434	\N
2008	48	4	0	33440	\N
2038	1	2	0	33444	\N
2038	112	3	0	33445	\N
2060	1	1	0	33463	\N
2060	53	2	0	33464	\N
2093	1	1	0	33468	\N
2093	53	2	0	33470	\N
1969	2	2	0	35134	\N
1913	6	1	0	36265	\N
1913	194	2	0	36266	\N
2054	6	1	0	36274	\N
2054	194	2	0	36280	\N
1979	8	3	0	36456	\N
1979	739	4	0	36459	\N
1945	10	1	0	37106	\N
1945	11	2	0	37110	\N
1992	10	1	0	37128	\N
1992	11	2	0	37130	\N
2006	10	2	0	37134	\N
2006	29	3	0	37136	\N
2048	11	2	0	37147	\N
2055	10	1	0	37152	\N
2055	11	2	0	37153	\N
2058	10	1	0	37156	\N
2064	10	1	0	37157	\N
2067	10	1	0	37158	\N
2058	11	2	0	37159	\N
2064	11	2	0	37160	\N
2067	11	2	0	37161	\N
2082	10	1	0	37169	\N
2096	10	2	0	37170	\N
2082	11	2	0	37172	\N
1949	14	1	0	39062	\N
1949	15	2	0	39063	\N
2017	14	1	0	39074	\N
2017	15	2	0	39075	\N
2068	40	1	0	41591	\N
2068	41	2	0	41592	\N
2071	40	1	0	41599	\N
2071	41	2	0	41600	\N
2087	40	3	0	41637	\N
2087	128	4	0	41638	\N
146	52	2	0	43445	\N
2135	52	2	0	43501	\N
2092	56	1	0	43713	\N
2113	56	1	0	43714	\N
2143	56	1	0	43716	\N
2092	57	2	0	43717	\N
2113	57	2	0	43718	\N
2143	57	2	0	43720	\N
2204	71	2	0	44725	\N
2204	401	3	0	44729	\N
2132	75	1	0	45220	\N
2132	76	2	0	45224	\N
2181	75	2	0	45236	\N
2181	159	3	0	45237	\N
2231	242	0	0	52074	\N
2076	268	1	0	52709	\N
2076	269	2	0	52711	\N
2114	268	1	0	52722	\N
2114	269	2	0	52723	\N
2220	268	1	0	52732	\N
2220	269	2	0	52736	\N
2133	273	1	0	52909	\N
2133	410	2	0	52910	\N
2115	338	2	0	53804	\N
2115	415	3	0	53806	\N
2128	362	1	0	54756	\N
2128	395	2	0	54759	\N
2107	761	101	0	55199	\N
2109	451	1	0	55208	\N
2109	584	2	0	55210	\N
2107	451	126	0	55211	\N
2107	762	127	0	55212	\N
2158	595	2	0	55538	\N
2158	768	3	0	55546	\N
2168	597	2	0	55836	\N
2168	771	3	0	55837	\N
2195	783	63	0	251	\N
2174	220	1	0	532	\N
2175	220	1	0	533	\N
2175	221	2	0	534	\N
2166	266	1	0	1137	\N
2166	267	2	0	1138	\N
2145	251	1	0	1422	\N
2145	252	2	0	1427	\N
2120	204	1	0	1719	\N
2120	205	2	0	1720	\N
2033	84	2	0	1778	\N
2033	434	3	0	1779	\N
2210	117	2	0	1936	\N
2110	237	1	0	3570	\N
2110	527	2	0	3571	\N
2131	35	1	0	4136	\N
2131	340	2	0	4139	\N
2057	365	1	0	4448	\N
2057	366	2	0	4450	\N
2053	391	1	0	10146	\N
2053	392	2	0	10149	\N
2172	459	3	0	11944	\N
2172	773	4	0	11945	\N
2081	123	1	0	12731	\N
2081	124	2	0	12733	\N
2037	335	3	0	13343	\N
2226	233	1	0	13764	\N
2226	234	2	0	13765	\N
2039	402	1	0	14031	\N
2039	403	2	0	14032	\N
2183	402	1	0	14037	\N
2183	403	2	0	14041	\N
2117	92	2	0	14904	\N
2117	93	3	0	14905	\N
2137	92	1	0	14918	\N
2137	191	2	0	14921	\N
2112	763	1	0	15247	\N
2147	115	2	0	16633	\N
2147	636	3	0	16635	\N
2142	212	1	0	17026	\N
2142	213	2	0	17028	\N
2174	777	2	1	18235	\N
2043	290	1	0	18928	\N
2043	291	2	0	18931	\N
2119	62	1	0	19685	\N
2119	63	2	0	19690	\N
2207	64	2	0	20689	\N
2207	162	3	0	20691	\N
2102	67	1	0	22153	\N
2228	140	1	0	23959	\N
2228	141	2	0	23961	\N
2063	411	1	0	25142	\N
2063	412	2	0	25144	\N
2124	224	2	0	25455	\N
2124	508	3	0	25462	\N
2073	16	2	0	27889	\N
2108	16	1	0	27890	\N
2108	17	2	0	27892	\N
2073	155	3	0	27894	\N
2191	16	1	0	27898	\N
2191	17	2	0	27901	\N
2106	96	1	0	29434	\N
2104	97	2	0	29435	\N
2106	97	2	0	29436	\N
2042	20	1	0	30377	\N
2042	144	2	0	30378	\N
2040	1	2	0	33453	\N
2040	112	3	0	33454	\N
2051	1	2	0	33459	\N
2051	112	3	0	33460	\N
2116	1	2	0	33480	\N
2116	112	3	0	33483	\N
2214	2	1	0	35138	\N
2111	6	1	0	36275	\N
2140	6	1	0	36276	\N
2111	194	2	0	36281	\N
2140	194	2	0	36282	\N
2025	10	2	0	37135	\N
2025	29	3	0	37137	\N
2028	10	1	0	37140	\N
2028	11	2	0	37141	\N
2029	10	1	0	37144	\N
2029	11	2	0	37146	\N
2070	10	1	0	37168	\N
2070	11	2	0	37171	\N
2122	10	1	0	37181	\N
2105	11	2	0	37183	\N
2122	11	2	0	37184	\N
2160	10	1	0	37189	\N
2160	11	2	0	37191	\N
2165	10	1	0	37198	\N
2165	11	2	0	37200	\N
2188	10	1	0	37204	\N
2188	11	2	0	37205	\N
2202	10	1	0	37208	\N
2202	11	2	0	37209	\N
2027	18	1	0	39681	\N
2223	18	1	0	39689	\N
2223	19	2	0	39691	\N
2095	23	2	0	40696	\N
2095	24	3	0	40706	\N
2163	27	1	0	41012	\N
2163	28	2	0	41013	\N
2084	40	1	0	41615	\N
2084	41	2	0	41616	\N
2086	40	1	0	41625	\N
2086	41	2	0	41626	\N
2118	40	1	0	41643	\N
2118	41	2	0	41644	\N
2197	41	2	0	41662	\N
358	51	4	0	43455	\N
2121	57	2	0	43719	\N
2290	56	0	0	43732	\N
2240	71	2	0	44734	\N
2240	401	3	0	44735	\N
2282	75	2	0	45257	\N
2282	159	3	0	45258	\N
2185	79	2	0	46460	\N
2189	79	1	0	46461	\N
2189	81	2	0	46465	\N
2185	80	3	0	46468	\N
2179	113	3	0	48198	\N
2179	778	4	0	48201	\N
2297	113	1	0	48209	\N
2297	437	2	0	48210	\N
2340	113	3	0	48214	\N
2340	778	4	0	48216	\N
2126	119	1	0	48739	\N
2126	120	2	0	48740	\N
2167	147	2	0	49961	\N
2167	770	3	0	49977	\N
2234	338	2	0	53807	\N
2250	338	0	0	53808	\N
2276	338	1	0	53810	\N
2276	409	2	0	53819	\N
2234	788	3	0	53828	\N
2127	316	1	0	53901	\N
2127	317	2	0	53902	\N
2186	744	13	0	54939	\N
2261	744	2	0	54942	\N
2186	779	14	0	54944	\N
2261	799	3	0	54945	\N
2148	451	1	0	55224	\N
2148	584	2	0	55225	\N
2157	767	3	0	55833	\N
2249	288	0	0	15	\N
2194	12	3	0	243	\N
2194	782	4	0	247	\N
2173	775	0	0	531	\N
2339	749	2	1	630	\N
2291	424	1	0	714	\N
2291	425	2	0	716	\N
2227	117	1	0	1942	\N
2227	248	2	0	1944	\N
2313	237	13	0	3573	\N
2313	238	14	0	3577	\N
2164	35	1	0	4137	\N
2164	340	2	0	4140	\N
2339	365	1	0	4457	\N
2278	391	1	0	10156	\N
2278	392	2	0	10159	\N
2325	132	1	0	11118	\N
2325	455	2	0	11119	\N
2253	300	3	0	12020	\N
2253	301	4	0	12029	\N
2267	528	1	0	12397	\N
2267	529	2	0	12399	\N
2153	123	1	0	12732	\N
2153	124	2	0	12734	\N
2239	77	2	0	13050	\N
2170	58	1	0	13426	\N
2170	59	2	0	13430	\N
2255	796	4	1	14015	\N
2136	92	3	0	14917	\N
2136	180	4	0	14923	\N
2201	192	1	0	15264	\N
2201	193	2	0	15267	\N
2217	235	1	0	15598	\N
2217	236	2	0	15601	\N
2233	38	2	0	16336	\N
2233	39	3	0	16339	\N
2199	212	3	0	17027	\N
2247	167	0	0	17621	\N
2130	30	1	0	17975	\N
2130	418	2	0	17978	\N
2230	30	1	0	17979	\N
2230	418	2	0	17985	\N
2209	292	2	0	18257	\N
2209	502	3	0	18259	\N
2279	142	1	0	18444	\N
2279	143	2	0	18447	\N
2264	290	2	0	18936	\N
2264	575	3	0	18940	\N
2173	774	0	0	19155	\N
2299	60	1	0	19385	\N
2299	61	2	0	19388	\N
2255	729	4	0	21386	\N
2255	488	3	0	21399	\N
2337	816	0	0	22326	\N
2235	49	2	0	25003	\N
2235	789	3	0	25004	\N
2236	411	1	0	25145	\N
2236	412	2	0	25147	\N
2212	785	1	0	26310	\N
2212	786	2	0	26311	\N
2319	86	1	0	26417	\N
2318	811	0	0	26432	\N
2270	94	1	0	26695	\N
2270	107	2	0	26698	\N
2203	16	1	0	27899	\N
2203	17	2	0	27902	\N
2186	780	14	1	29204	\N
2261	800	3	1	29205	\N
2263	320	4	0	29296	\N
2263	803	5	0	29300	\N
2186	745	13	0	29301	\N
2261	745	2	0	29341	\N
2186	781	15	0	29776	\N
2306	202	1	0	30994	\N
2309	202	0	0	30996	\N
2306	203	2	0	30998	\N
2327	202	2	0	31005	\N
2327	812	3	0	31008	\N
2182	33	1	0	31726	\N
2182	163	2	0	31728	\N
2245	230	0	0	31996	\N
2141	1	1	0	33481	\N
2141	53	2	0	33482	\N
2198	1	1	0	33486	\N
2238	1	1	0	33487	\N
2238	53	2	0	33490	\N
2296	1	2	0	33495	\N
2296	112	3	0	33496	\N
2332	1	3	0	33504	\N
2332	48	4	0	33509	\N
2337	817	0	0	35170	\N
2139	10	1	0	37188	\N
2139	11	2	0	37190	\N
2178	10	1	0	37199	\N
2178	11	2	0	37201	\N
2242	10	2	0	37214	\N
2285	10	1	0	37216	\N
2242	792	3	0	37220	\N
2293	10	3	0	37229	\N
2293	347	4	0	37232	\N
2224	18	5	0	39692	\N
2224	787	6	0	39693	\N
2258	27	1	0	41042	\N
2258	28	2	0	41044	\N
2125	40	2	0	41653	\N
2125	66	3	0	41654	\N
2162	40	1	0	41659	\N
2162	41	2	0	41661	\N
2222	40	1	0	41706	\N
2274	40	2	0	41735	\N
2274	66	3	0	41736	\N
554	51	1	0	43464	\N
2144	52	2	0	43502	\N
2328	51	2	0	43506	\N
2328	524	3	0	43510	\N
2146	56	2	0	43723	\N
2146	169	3	0	43724	\N
2190	56	1	0	43727	\N
2190	57	2	0	43728	\N
2248	56	0	0	43731	\N
2294	56	3	0	43735	\N
2294	475	4	0	43736	\N
2320	56	1	0	43741	\N
2320	57	2	0	43742	\N
2221	71	1	0	44726	\N
2221	72	2	0	44728	\N
2213	75	1	0	45248	\N
2213	76	2	0	45249	\N
2244	102	0	0	47775	\N
2161	113	1	0	48197	\N
2161	437	2	0	48200	\N
2156	147	2	0	49960	\N
2331	147	3	0	49962	\N
2156	516	3	0	49974	\N
2331	148	4	0	49976	\N
2273	156	2	0	50193	\N
2273	571	3	0	50198	\N
2138	170	1	0	50501	\N
2138	398	2	0	50502	\N
2159	181	2	0	50842	\N
2180	181	2	0	50843	\N
2257	181	1	0	50844	\N
2257	530	2	0	50845	\N
2159	769	3	0	50846	\N
2180	769	3	0	50847	\N
2251	200	3	0	51462	\N
2251	219	4	0	51463	\N
2225	260	2	0	52356	\N
2225	419	3	0	52359	\N
2269	260	2	0	52360	\N
2269	419	3	0	52361	\N
2272	338	2	0	53809	\N
2272	415	3	0	53825	\N
2151	324	0	0	54163	\N
2150	324	2	0	54199	\N
2150	486	3	0	54205	\N
2169	595	2	0	55539	\N
2169	772	3	0	55548	\N
2321	400	2	0	21	\N
2193	357	5	0	248	\N
2216	12	3	0	252	\N
2218	12	1	0	253	\N
2218	13	2	0	254	\N
2216	782	4	0	255	\N
2317	424	2	0	734	\N
2317	520	3	0	735	\N
2206	266	1	0	1147	\N
2206	267	2	0	1148	\N
2200	84	1	0	1780	\N
2283	84	1	0	1781	\N
2284	84	0	0	1782	\N
2283	85	2	0	1784	\N
2211	117	1	0	1937	\N
2211	248	2	0	1940	\N
2241	790	3	0	3217	\N
2241	791	4	0	3218	\N
2311	237	3	0	3572	\N
2311	809	4	0	3576	\N
2268	262	0	0	3710	\N
2338	365	1	0	4456	\N
2338	366	2	0	4459	\N
2192	189	1	0	4785	\N
2192	190	2	0	4786	\N
2177	392	2	0	10158	\N
2154	132	2	0	11090	\N
2154	133	3	0	11091	\N
2229	132	1	0	11096	\N
2229	455	2	0	11097	\N
2260	132	2	0	11111	\N
2260	133	3	0	11112	\N
2334	132	3	0	11127	\N
2334	814	4	0	11130	\N
2215	300	1	0	12019	\N
2254	300	3	0	12021	\N
2215	355	2	0	12026	\N
2254	795	4	0	14013	\N
2134	92	1	0	14916	\N
2219	92	1	0	14919	\N
2134	191	2	0	14920	\N
2219	191	2	0	14922	\N
2275	804	1	0	15581	\N
2275	805	2	0	15583	\N
2129	44	1	0	15997	\N
2129	45	2	0	15998	\N
2280	212	1	0	17043	\N
2280	213	2	0	17044	\N
2266	326	2	0	17297	\N
2149	765	1	0	18405	\N
2149	766	2	0	18407	\N
2262	765	4	0	18409	\N
2262	802	5	0	18412	\N
2301	807	85	0	19384	\N
2301	60	126	0	19394	\N
2301	808	127	0	19395	\N
2281	241	10	0	20360	\N
2281	806	11	0	20368	\N
2287	411	1	0	25146	\N
2287	412	2	0	25148	\N
2277	224	1	0	25456	\N
2184	244	1	0	27206	\N
2335	244	3	0	27207	\N
2184	245	2	0	27210	\N
2335	815	4	0	27213	\N
2152	16	2	0	27891	\N
2152	155	3	0	27895	\N
2171	16	1	0	27896	\N
2171	17	2	0	27897	\N
2187	320	2	0	29272	\N
2187	321	3	0	29274	\N
2256	320	3	0	29295	\N
2256	797	4	0	29299	\N
2305	202	0	0	30993	\N
2307	202	0	0	30995	\N
2259	453	4	0	32626	\N
2259	798	5	0	32627	\N
2243	1	2	0	33488	\N
2243	444	3	0	33491	\N
2314	8	1	0	36462	\N
2314	9	2	0	36465	\N
2123	10	1	0	37182	\N
2123	11	2	0	37185	\N
2232	10	2	0	37213	\N
2265	10	2	0	37215	\N
2265	29	3	0	37219	\N
2286	10	2	0	37223	\N
2286	29	3	0	37224	\N
2324	10	1	0	37235	\N
2324	11	2	0	37236	\N
2176	18	1	0	39688	\N
2176	19	2	0	39690	\N
2208	27	2	0	41041	\N
2302	27	1	0	41043	\N
2302	28	2	0	41045	\N
2208	619	3	0	41047	\N
2205	40	2	0	41687	\N
2237	40	1	0	41707	\N
2237	41	2	0	41709	\N
2271	40	0	0	41719	\N
573	51	1	0	43465	\N
2425	52	2	0	43509	\N
2329	56	2	0	43745	\N
2329	169	3	0	43748	\N
2481	75	0	0	45273	\N
2298	79	1	0	46462	\N
2376	79	1	0	46463	\N
2298	81	2	0	46466	\N
2376	81	2	0	46467	\N
2401	79	1	0	46533	\N
2401	81	2	0	46534	\N
2430	102	1	0	47776	\N
2430	103	2	0	47780	\N
2341	113	3	0	48215	\N
2341	778	4	0	48217	\N
2345	121	1	0	48836	\N
2345	122	2	0	48841	\N
2350	121	2	0	48858	\N
2350	625	3	0	48860	\N
2386	137	1	0	49723	\N
2386	138	2	0	49726	\N
2475	840	5	0	52362	\N
2475	260	6	0	52363	\N
2485	843	98	0	52724	\N
2485	845	103	0	52740	\N
2485	847	104	1	52892	\N
2489	338	1	0	53811	\N
2489	409	2	0	53820	\N
2365	353	1	0	54514	\N
2365	354	2	0	54519	\N
2487	435	1	0	54967	\N
2487	436	2	0	54968	\N
2333	595	3	0	55540	\N
2333	813	4	0	55547	\N
2330	597	0	0	55856	\N
2351	821	3	0	544	\N
2485	844	103	0	617	\N
2454	46	1	0	649	\N
2454	839	2	0	655	\N
2395	266	4	0	1151	\N
2395	832	5	0	1152	\N
2434	251	2	0	1442	\N
2471	251	1	0	1443	\N
2471	252	2	0	1445	\N
2434	828	3	0	1447	\N
2342	819	2	0	1823	\N
2342	820	3	0	1824	\N
2380	117	1	0	1943	\N
2362	824	31	0	2360	\N
2362	822	126	0	2363	\N
2362	825	127	0	2364	\N
2374	228	1	0	2814	\N
2374	229	2	0	2815	\N
2490	228	1	0	2837	\N
2490	229	2	0	2838	\N
2295	367	2	0	3287	\N
2295	651	3	0	3291	\N
2353	365	1	0	4458	\N
2353	366	2	0	4460	\N
2364	189	3	0	4797	\N
2315	391	1	0	10157	\N
2315	392	2	0	10160	\N
2410	391	1	0	10164	\N
2410	392	2	0	10169	\N
2480	132	2	0	11128	\N
2480	133	3	0	11129	\N
2288	258	1	0	14377	\N
2288	309	2	0	14380	\N
2323	173	1	0	14607	\N
2323	396	2	0	14608	\N
2409	173	1	0	14611	\N
2409	396	2	0	14613	\N
2348	116	2	0	16637	\N
2343	30	2	0	17980	\N
2343	31	3	0	17988	\N
2377	142	1	0	18445	\N
2377	143	2	0	18448	\N
2456	208	4	0	19231	\N
2456	491	5	0	19238	\N
2346	164	1	0	21003	\N
2419	164	3	0	21004	\N
2346	165	2	0	21005	\N
2419	307	4	0	21006	\N
2482	145	2	0	21842	\N
2312	82	3	0	23724	\N
2312	810	4	0	23730	\N
2465	69	1	0	24648	\N
2465	70	2	0	24650	\N
2413	90	1	0	25995	\N
2413	344	2	0	25997	\N
2459	90	1	0	26003	\N
2459	344	2	0	26005	\N
2383	94	1	0	26696	\N
2440	94	1	0	26697	\N
2383	107	2	0	26699	\N
2440	107	2	0	26700	\N
2443	107	2	0	26705	\N
2493	16	1	0	27908	\N
2356	320	2	0	29297	\N
2356	321	3	0	29298	\N
2404	20	1	0	30383	\N
2404	144	2	0	30384	\N
2310	202	0	0	30997	\N
2300	360	1	0	31358	\N
2300	479	2	0	31360	\N
2347	360	1	0	31367	\N
2347	479	2	0	31368	\N
2359	360	1	0	31381	\N
2416	360	2	0	31389	\N
2416	510	3	0	31390	\N
2303	230	1	0	31997	\N
2303	287	2	0	31998	\N
2289	1	0	0	33494	\N
2326	1	2	0	33501	\N
2326	112	3	0	33502	\N
2398	1	1	0	33512	\N
2398	53	2	0	33513	\N
2477	1	1	0	33520	\N
2477	53	2	0	33523	\N
2349	2	2	0	35189	\N
2468	4	1	0	35965	\N
2468	25	2	0	35966	\N
2304	8	1	0	36460	\N
2304	9	2	0	36461	\N
2322	10	1	0	37230	\N
2322	11	2	0	37231	\N
2389	10	1	0	37240	\N
2389	11	2	0	37242	\N
2407	10	2	0	37245	\N
2407	29	3	0	37246	\N
2431	10	1	0	37260	\N
2438	10	3	0	37261	\N
2438	347	4	0	37263	\N
2447	10	1	0	37274	\N
2447	11	2	0	37275	\N
2292	14	3	0	39089	\N
2292	306	4	0	39092	\N
2403	18	1	0	39694	\N
2403	19	2	0	39695	\N
2308	40	1	0	41770	\N
2316	40	2	0	41771	\N
2308	41	2	0	41772	\N
2316	66	3	0	41773	\N
2336	564	4	0	41774	\N
2344	40	3	0	41819	\N
2344	128	4	0	41820	\N
941	51	1	0	43475	\N
2366	57	2	0	43747	\N
2370	56	2	0	43751	\N
2370	169	3	0	43754	\N
2406	75	1	0	45272	\N
2406	76	2	0	45274	\N
2573	75	2	0	45309	\N
2573	159	3	0	45310	\N
2421	88	1	0	47187	\N
2421	89	2	0	47189	\N
2399	100	1	0	47533	\N
2399	160	2	0	47536	\N
2563	113	2	0	48229	\N
2563	114	3	0	48230	\N
2496	121	4	0	48870	\N
2496	848	5	0	48871	\N
2538	137	2	0	49725	\N
2538	866	3	0	49728	\N
2387	170	1	0	50513	\N
2387	398	2	0	50514	\N
2402	186	1	0	51217	\N
2427	186	1	0	51218	\N
2402	187	2	0	51221	\N
2427	187	2	0	51222	\N
2525	242	2	0	52081	\N
2525	620	3	0	52082	\N
2446	273	1	0	52911	\N
2446	410	2	0	52913	\N
2502	285	4	0	53373	\N
2502	851	5	0	53374	\N
2415	353	1	0	54524	\N
2415	354	2	0	54525	\N
2417	353	2	0	54530	\N
2417	755	3	0	54533	\N
2518	782	4	0	265	\N
2424	836	2	0	1032	\N
2361	822	1	0	2361	\N
2361	823	2	0	2362	\N
2358	228	1	0	2806	\N
2358	229	2	0	2807	\N
2458	228	1	0	2824	\N
2458	229	2	0	2825	\N
2450	237	1	0	3574	\N
2450	527	2	0	3575	\N
2462	237	2	0	3578	\N
2462	319	3	0	3579	\N
2393	262	1	0	3722	\N
2393	263	2	0	3724	\N
2394	731	3	0	3725	\N
2478	365	1	0	4469	\N
2478	366	2	0	4474	\N
2501	189	69	0	4799	\N
2501	850	70	0	4803	\N
2508	391	3	0	10166	\N
2508	581	4	0	10171	\N
2554	391	2	0	10177	\N
2554	406	3	0	10178	\N
2352	123	2	0	12748	\N
2352	384	3	0	12751	\N
2355	335	3	0	13348	\N
2439	402	1	0	14038	\N
2439	403	2	0	14042	\N
2397	92	2	0	14929	\N
2397	93	3	0	14930	\N
2567	192	1	0	15270	\N
2567	193	2	0	15271	\N
2463	30	2	0	17981	\N
2463	31	3	0	17989	\N
2385	290	1	0	18937	\N
2385	291	2	0	18939	\N
2470	208	1	0	19241	\N
2470	209	2	0	19243	\N
2507	854	3	0	19244	\N
2381	60	1	0	19386	\N
2515	60	1	0	19387	\N
2381	61	2	0	19389	\N
2515	61	2	0	19390	\N
2522	60	1	0	19401	\N
2522	61	2	0	19402	\N
2391	241	0	0	20361	\N
2557	241	2	0	20370	\N
2557	281	3	0	20371	\N
2512	64	2	0	20690	\N
2519	64	3	0	20702	\N
2528	64	1	0	20703	\N
2528	65	2	0	20705	\N
2519	130	4	0	20707	\N
2560	164	2	0	21012	\N
2560	226	3	0	21016	\N
2460	145	1	0	21841	\N
2460	153	2	0	21845	\N
2379	73	1	0	22422	\N
2379	74	2	0	22423	\N
2546	73	1	0	22432	\N
2546	74	2	0	22435	\N
2530	356	2	0	22707	\N
2467	411	2	0	25153	\N
2467	582	3	0	25154	\N
2432	90	1	0	25996	\N
2432	344	2	0	25998	\N
2457	94	1	0	26706	\N
2457	107	2	0	26707	\N
2411	42	1	0	27473	\N
2411	43	2	0	27474	\N
2426	16	1	0	27900	\N
2426	17	2	0	27903	\N
2493	17	2	0	27910	\N
2420	834	4	0	29443	\N
2436	151	3	0	30662	\N
2436	152	4	0	30671	\N
2510	202	1	0	31024	\N
2510	203	2	0	31025	\N
2579	230	3	0	32009	\N
2579	876	4	0	32012	\N
2412	322	2	0	32324	\N
2412	833	3	0	32327	\N
2464	1	1	0	33516	\N
2464	53	2	0	33517	\N
2473	1	1	0	33519	\N
2550	1	1	0	33539	\N
2550	53	2	0	33540	\N
2576	1	1	0	33549	\N
2576	53	2	0	33550	\N
2367	2	1	0	35203	\N
2441	2	1	0	35204	\N
2445	2	1	0	35205	\N
2367	26	2	0	35206	\N
2441	26	2	0	35207	\N
2445	26	2	0	35208	\N
2360	10	1	0	37239	\N
2360	11	2	0	37241	\N
2414	11	2	0	37252	\N
2444	10	1	0	37270	\N
2444	11	2	0	37271	\N
2514	10	1	0	37284	\N
2514	11	2	0	37285	\N
2544	10	1	0	37298	\N
2544	11	2	0	37299	\N
2455	18	1	0	39696	\N
2455	19	2	0	39697	\N
2369	23	1	0	40697	\N
2369	217	2	0	40704	\N
2373	40	1	0	41856	\N
2553	868	68	0	41858	\N
2553	40	81	0	41887	\N
2553	869	82	0	41888	\N
1529	51	1	0	43485	\N
2499	57	2	0	43753	\N
2492	75	1	0	45284	\N
2492	76	2	0	45285	\N
2524	75	3	0	45300	\N
2524	857	4	0	45301	\N
2526	79	1	0	46529	\N
2526	81	2	0	46531	\N
2469	88	1	0	47188	\N
2469	89	2	0	47190	\N
2390	121	2	0	48859	\N
2390	831	3	0	48861	\N
2388	135	1	0	49403	\N
2388	136	2	0	49405	\N
2449	135	1	0	49416	\N
2449	136	2	0	49417	\N
2537	135	2	0	49427	\N
2537	865	3	0	49438	\N
2448	137	1	0	49724	\N
2448	138	2	0	49727	\N
2521	181	4	0	50848	\N
2521	856	5	0	50853	\N
2474	210	1	0	51752	\N
2474	211	2	0	51754	\N
2531	260	1	0	52364	\N
2531	261	2	0	52365	\N
2520	273	4	0	52912	\N
2520	855	5	0	52914	\N
2516	338	1	0	53812	\N
2516	409	2	0	53821	\N
2408	353	1	0	54515	\N
2408	354	2	0	54520	\N
2363	451	3	0	55240	\N
2363	826	4	0	55241	\N
2534	863	5	0	56594	\N
2479	842	2	0	56905	\N
2503	853	5	0	57179	\N
2405	400	2	0	22	\N
2371	828	3	0	1433	\N
2527	110	1	0	2480	\N
2527	134	2	0	2481	\N
2532	367	51	0	3288	\N
2533	367	0	0	3289	\N
2532	858	52	0	3292	\N
2488	262	1	0	3739	\N
2488	263	2	0	3742	\N
2442	365	1	0	4468	\N
2442	366	2	0	4473	\N
2500	189	4	0	4798	\N
2500	849	5	0	4802	\N
2483	391	2	0	10165	\N
2549	391	4	0	10167	\N
2400	392	2	0	10168	\N
2483	406	3	0	10170	\N
2549	539	5	0	10172	\N
2437	108	3	0	11653	\N
2497	108	1	0	11654	\N
2497	109	2	0	11663	\N
2437	837	4	0	11668	\N
2472	300	1	0	12022	\N
2472	355	2	0	12027	\N
2536	528	1	0	12398	\N
2505	58	1	0	13427	\N
2505	59	2	0	13431	\N
2559	58	1	0	13435	\N
2511	92	2	0	14940	\N
2534	92	2	0	14941	\N
2535	92	2	0	14942	\N
2534	860	3	1	14943	\N
2511	93	3	0	14944	\N
2535	93	3	0	14945	\N
2452	192	2	0	15265	\N
2452	838	3	0	15268	\N
2451	38	1	0	16346	\N
2534	864	5	1	16930	\N
2523	212	1	0	17056	\N
2523	213	2	0	17057	\N
2461	326	1	0	17300	\N
2461	327	2	0	17301	\N
2534	862	4	1	18238	\N
2484	241	0	0	20369	\N
2491	164	1	0	21011	\N
2491	165	2	0	21014	\N
2495	145	2	0	21843	\N
2495	331	3	0	21847	\N
2357	73	1	0	22409	\N
2428	140	1	0	23962	\N
2540	140	1	0	23963	\N
2428	141	2	0	23964	\N
2540	141	2	0	23965	\N
2509	214	3	0	24310	\N
2509	330	4	0	24311	\N
2378	829	1	0	24962	\N
2378	830	2	0	24963	\N
2435	206	2	0	25743	\N
2435	693	3	0	25745	\N
2506	90	1	0	26004	\N
2506	344	2	0	26006	\N
2466	16	1	0	27905	\N
2433	17	2	0	27906	\N
2466	17	2	0	27907	\N
2529	16	1	0	27909	\N
2529	17	2	0	27911	\N
2486	96	3	0	29442	\N
2486	834	4	0	29444	\N
2418	54	2	0	29993	\N
2453	54	1	0	29994	\N
2453	55	2	0	30000	\N
2418	485	3	0	30004	\N
2368	151	1	0	30656	\N
2429	202	1	0	31006	\N
2429	203	2	0	31007	\N
2423	360	2	0	31399	\N
2423	510	3	0	31400	\N
2476	360	1	0	31418	\N
2476	479	2	0	31419	\N
2504	33	1	0	31739	\N
2504	163	2	0	31740	\N
2382	322	1	0	32323	\N
2382	323	2	0	32326	\N
2375	1	1	0	33505	\N
2396	1	1	0	33506	\N
2396	53	2	0	33508	\N
2494	1	2	0	33521	\N
2494	112	3	0	33524	\N
2513	1	1	0	33527	\N
2513	53	2	0	33528	\N
2517	1	3	0	33535	\N
2517	48	4	0	33536	\N
2539	2	1	0	35231	\N
2539	26	2	0	35233	\N
2556	4	1	0	35978	\N
2556	25	2	0	35979	\N
2422	10	1	0	37255	\N
2498	10	1	0	37280	\N
2498	11	2	0	37281	\N
2541	10	1	0	37291	\N
2543	10	1	0	37292	\N
2543	11	2	0	37295	\N
2552	14	1	0	39090	\N
2552	15	2	0	39091	\N
2372	40	1	0	41836	\N
2372	41	2	0	41837	\N
2384	40	1	0	41877	\N
2392	40	1	0	41878	\N
2384	41	2	0	41884	\N
1889	51	1	0	43486	\N
2575	57	2	0	43759	\N
2588	56	1	0	43762	\N
2588	57	2	0	43764	\N
2577	71	1	0	44740	\N
2577	72	2	0	44742	\N
2585	75	1	0	45317	\N
2585	76	2	0	45318	\N
2629	75	1	0	45336	\N
2629	76	2	0	45337	\N
2598	79	1	0	46530	\N
2598	81	2	0	46532	\N
2561	870	41	0	48218	\N
2561	113	47	0	48231	\N
2561	871	48	0	48232	\N
2611	113	2	0	48237	\N
2611	114	3	0	48242	\N
2609	113	31	0	48243	\N
2609	888	32	0	48244	\N
2587	119	1	0	48757	\N
2587	120	2	0	48758	\N
2607	119	1	0	48765	\N
2624	119	2	0	48766	\N
2607	120	2	0	48767	\N
2624	891	3	0	48768	\N
2639	119	1	0	48775	\N
2639	120	2	0	48778	\N
2562	135	2	0	49428	\N
2562	196	3	0	49437	\N
2564	137	2	0	49760	\N
2564	197	3	0	49765	\N
2555	170	2	0	50509	\N
2555	718	3	0	50512	\N
2605	200	2	0	51470	\N
2605	887	3	0	51471	\N
2545	210	1	0	51761	\N
2545	211	2	0	51762	\N
2618	338	1	0	53813	\N
2620	338	0	0	53814	\N
2635	338	1	0	53815	\N
2618	409	2	0	53822	\N
2635	409	2	0	53823	\N
2566	316	1	0	53907	\N
2566	317	2	0	53908	\N
2594	881	2	0	57509	\N
2610	433	3	0	264	\N
2614	890	6	0	546	\N
2569	874	14	0	611	\N
2569	844	13	0	618	\N
2622	262	1	0	3740	\N
2622	263	2	0	3743	\N
2581	391	1	0	10192	\N
2591	391	1	0	10193	\N
2581	392	2	0	10194	\N
2591	392	2	0	10195	\N
2570	256	1	0	13345	\N
2570	257	2	0	13347	\N
2559	59	2	0	13436	\N
2626	403	2	0	14043	\N
2582	173	1	0	14612	\N
2582	396	2	0	14614	\N
2572	192	2	0	15278	\N
2572	838	3	0	15279	\N
2631	44	2	0	16001	\N
2632	44	1	0	16002	\N
2632	45	2	0	16003	\N
2631	161	3	0	16004	\N
2592	167	1	0	17622	\N
2627	167	1	0	17623	\N
2592	533	2	0	17625	\N
2569	872	11	0	18288	\N
2569	873	13	0	18297	\N
2586	879	0	0	18300	\N
2569	875	14	1	18351	\N
2595	290	2	0	18938	\N
2595	575	3	0	18941	\N
2593	577	1	0	20340	\N
2593	578	2	0	20341	\N
2574	241	2	0	20372	\N
2574	281	3	0	20373	\N
2542	64	1	0	20704	\N
2542	65	2	0	20706	\N
2630	331	3	0	21848	\N
2547	73	0	0	22433	\N
2616	73	1	0	22434	\N
2616	74	2	0	22436	\N
2601	82	0	0	23736	\N
2613	140	5	0	23966	\N
2613	889	6	0	23967	\N
2589	69	2	0	24649	\N
2589	500	3	0	24651	\N
2636	411	1	0	25159	\N
2636	412	2	0	25160	\N
2623	224	2	0	25473	\N
2580	90	3	0	26009	\N
2580	877	4	0	26010	\N
2615	90	1	0	26013	\N
2615	344	2	0	26014	\N
2596	94	2	0	26708	\N
2596	95	3	0	26712	\N
2634	42	1	0	27484	\N
2634	43	2	0	27485	\N
2590	16	2	0	27912	\N
2606	16	2	0	27913	\N
2608	16	1	0	27914	\N
2608	17	2	0	27915	\N
2606	155	3	0	27917	\N
2637	16	1	0	27918	\N
2637	17	2	0	27921	\N
2600	54	0	0	29995	\N
2568	1	1	0	33543	\N
2571	1	2	0	33544	\N
2568	53	2	0	33545	\N
2571	112	3	0	33546	\N
2583	1	1	0	33553	\N
2603	1	2	0	33554	\N
2625	1	1	0	33555	\N
2583	53	2	0	33556	\N
2603	112	3	0	33558	\N
2638	1	1	0	33561	\N
2638	53	2	0	33564	\N
2558	2	1	0	35232	\N
2558	26	2	0	35234	\N
2565	2	1	0	35245	\N
2565	26	2	0	35246	\N
2584	2	1	0	35261	\N
2584	26	2	0	35263	\N
2604	6	2	0	36277	\N
2604	886	5	0	36278	\N
2640	6	1	0	36287	\N
2599	8	0	0	36463	\N
2628	8	1	0	36464	\N
2628	9	2	0	36466	\N
2541	11	2	0	37294	\N
2597	10	2	0	37302	\N
2612	10	1	0	37303	\N
2612	11	2	0	37307	\N
2597	29	3	0	37308	\N
2619	10	1	0	37313	\N
2633	10	1	0	37314	\N
2619	11	2	0	37316	\N
2633	11	2	0	37317	\N
2621	19	2	0	39699	\N
2548	23	4	0	40698	\N
2548	867	5	0	40709	\N
2551	27	2	0	41040	\N
2551	619	3	0	41046	\N
2135	51	1	0	43499	\N
2734	79	2	0	46583	\N
2656	81	2	0	46585	\N
2734	80	3	0	46587	\N
2643	88	2	0	47204	\N
2643	154	3	0	47205	\N
2680	88	1	0	47219	\N
2680	89	2	0	47220	\N
2660	102	1	0	47777	\N
2661	102	1	0	47778	\N
2660	103	2	0	47781	\N
2661	103	2	0	47782	\N
2669	119	2	0	48776	\N
2669	891	3	0	48779	\N
2749	121	1	0	48887	\N
2752	121	0	0	48888	\N
2756	121	1	0	48889	\N
2749	122	2	0	48893	\N
2756	122	2	0	48894	\N
2698	135	1	0	49429	\N
2764	135	1	0	49430	\N
2698	136	2	0	49433	\N
2764	136	2	0	49434	\N
2767	200	4	0	51481	\N
2767	899	5	0	51483	\N
2686	242	1	0	52088	\N
2686	253	2	0	52092	\N
2760	919	119	0	52605	\N
2760	845	126	0	52745	\N
2760	924	127	1	52893	\N
2664	285	1	0	53383	\N
2664	286	2	0	53385	\N
2655	896	88	0	53742	\N
2663	338	2	0	53816	\N
2670	338	2	0	53817	\N
2663	415	3	0	53826	\N
2670	415	3	0	53827	\N
2740	338	1	0	53829	\N
2740	409	2	0	53830	\N
2707	316	1	0	53921	\N
2707	317	2	0	53923	\N
2760	920	119	1	54489	\N
2760	859	117	0	54946	\N
2677	841	4	0	56907	\N
2677	900	5	0	56909	\N
2644	13	2	0	275	\N
2760	923	127	0	614	\N
2760	844	126	0	619	\N
2604	883	3	1	621	\N
2737	424	1	0	742	\N
2737	425	2	0	744	\N
2760	922	121	0	1785	\N
2701	117	1	0	1947	\N
2725	117	2	0	1948	\N
2701	248	2	0	1951	\N
2725	175	3	0	1953	\N
2728	906	28	0	1956	\N
2728	117	93	0	1965	\N
2760	916	117	1	2271	\N
2646	892	1	0	3059	\N
2646	893	2	0	3060	\N
2647	35	1	0	4138	\N
2647	340	2	0	4141	\N
2655	895	36	0	4804	\N
2654	189	5	0	4820	\N
2654	894	6	0	4821	\N
2655	189	87	0	4822	\N
2655	898	89	0	4823	\N
2775	222	2	0	5253	\N
2775	232	3	0	5256	\N
2731	233	2	0	13778	\N
2731	910	3	0	13779	\N
2665	258	1	0	14378	\N
2665	309	2	0	14381	\N
2672	92	1	0	14959	\N
2672	191	2	0	14963	\N
2650	235	1	0	15599	\N
2650	236	2	0	15602	\N
2710	44	1	0	16025	\N
2713	44	0	0	16026	\N
2710	45	2	0	16027	\N
2668	115	2	0	16638	\N
2604	885	4	1	16931	\N
2760	885	120	0	16932	\N
2652	212	2	0	17067	\N
2667	212	1	0	17068	\N
2667	213	2	0	17069	\N
2652	566	3	0	17070	\N
2649	167	1	0	17624	\N
2649	533	2	0	17627	\N
2704	167	2	0	17630	\N
2704	168	3	0	17631	\N
2760	921	120	1	18805	\N
2777	241	2	0	20380	\N
2671	67	1	0	22154	\N
2671	478	2	0	22157	\N
2760	918	118	1	22341	\N
2674	73	1	0	22441	\N
2674	74	2	0	22442	\N
2683	82	1	0	23743	\N
2683	83	2	0	23745	\N
2784	214	1	0	24330	\N
2784	215	2	0	24331	\N
2648	69	1	0	24662	\N
2648	70	2	0	24674	\N
2645	411	1	0	25169	\N
2641	206	1	0	25751	\N
2641	207	2	0	25757	\N
2746	94	1	0	26709	\N
2746	107	2	0	26711	\N
2653	16	2	0	27919	\N
2658	16	1	0	27920	\N
2658	17	2	0	27922	\N
2653	155	3	0	27923	\N
2666	16	1	0	27924	\N
2666	17	2	0	27925	\N
2722	16	1	0	27926	\N
2722	17	2	0	27927	\N
2659	287	2	0	32011	\N
2657	453	1	0	32638	\N
2695	453	2	0	32640	\N
2657	454	2	0	32641	\N
2695	902	3	0	32643	\N
2692	1	2	0	33562	\N
2692	112	3	0	33566	\N
2719	1	2	0	33585	\N
2724	1	2	0	33586	\N
2719	112	3	0	33589	\N
2724	112	3	0	33590	\N
2772	1	1	0	33598	\N
2781	4	1	0	35989	\N
2781	25	2	0	35990	\N
2651	6	2	0	36295	\N
2651	179	3	0	36296	\N
2662	6	2	0	36302	\N
2662	179	3	0	36303	\N
2642	10	1	0	37315	\N
2642	11	2	0	37318	\N
2689	10	1	0	37324	\N
2716	10	1	0	37325	\N
2689	11	2	0	37326	\N
2716	11	2	0	37327	\N
2761	14	5	0	39100	\N
2761	383	6	0	39101	\N
2743	914	48	0	40680	\N
2743	23	71	0	40710	\N
2743	915	72	0	40711	\N
2144	51	1	0	43500	\N
2796	52	2	0	43518	\N
2694	56	1	0	43768	\N
2694	57	2	0	43769	\N
2759	56	2	0	43772	\N
2759	169	3	0	43778	\N
2808	71	2	0	44741	\N
2808	401	3	0	44743	\N
2691	75	1	0	45346	\N
2691	76	2	0	45347	\N
2822	75	2	0	45381	\N
2822	159	3	0	45382	\N
2855	75	2	0	45394	\N
2860	75	3	0	45395	\N
2855	159	3	0	45400	\N
2860	713	4	0	45402	\N
2877	88	1	0	47238	\N
2877	89	2	0	47240	\N
2831	100	0	0	47534	\N
2736	102	1	0	47779	\N
2736	103	2	0	47783	\N
2817	119	2	0	48777	\N
2817	891	3	0	48780	\N
2861	119	1	0	48781	\N
2861	120	2	0	48782	\N
2748	121	0	0	48886	\N
2688	125	1	0	49199	\N
2688	195	2	0	49200	\N
2801	125	3	0	49206	\N
2801	126	4	0	49211	\N
2843	170	1	0	50519	\N
2843	398	2	0	50520	\N
2849	181	1	0	50854	\N
2849	530	2	0	50855	\N
2709	260	1	0	52372	\N
2709	261	2	0	52373	\N
2789	260	1	0	52376	\N
2789	261	2	0	52377	\N
2798	260	4	0	52382	\N
2798	538	5	0	52391	\N
2685	316	1	0	53913	\N
2685	317	2	0	53914	\N
2751	324	0	0	54201	\N
2676	841	4	0	56906	\N
2676	900	5	0	56908	\N
2739	913	2	0	57177	\N
2703	904	127	1	1910	\N
2833	117	3	0	1949	\N
2833	118	4	0	1954	\N
2703	117	126	0	1955	\N
2733	262	1	0	3741	\N
2733	263	2	0	3744	\N
2742	35	2	0	4149	\N
2742	36	3	0	4150	\N
2871	35	2	0	4160	\N
2871	36	3	0	4161	\N
2814	189	0	0	4800	\N
2852	189	1	0	4851	\N
2852	190	2	0	4853	\N
2706	223	2	0	5255	\N
2771	373	1	0	5308	\N
2771	374	2	0	5309	\N
2792	108	1	0	11656	\N
2792	109	2	0	11665	\N
2679	528	1	0	12407	\N
2679	529	2	0	12408	\N
2891	173	1	0	14619	\N
2891	396	2	0	14622	\N
2810	235	1	0	15600	\N
2810	236	2	0	15603	\N
2769	370	1	0	16596	\N
2718	212	1	0	17080	\N
2718	213	2	0	17082	\N
2840	326	1	0	17304	\N
2840	327	2	0	17305	\N
2804	929	121	0	19245	\N
2804	208	126	0	19256	\N
2804	491	127	0	19257	\N
2865	62	1	0	19686	\N
2865	63	2	0	19691	\N
2811	145	1	0	21859	\N
2811	153	2	0	21860	\N
2807	73	2	0	22455	\N
2783	82	1	0	23744	\N
2783	83	2	0	23746	\N
2893	82	1	0	23757	\N
2893	83	2	0	23759	\N
2813	930	1	0	23917	\N
2813	931	2	0	23922	\N
2830	49	0	0	25007	\N
2712	206	1	0	25752	\N
2712	207	2	0	25758	\N
2787	94	2	0	26710	\N
2787	95	3	0	26713	\N
2842	94	2	0	26714	\N
2721	42	2	0	27494	\N
2721	681	3	0	27500	\N
2774	16	1	0	27929	\N
2774	17	2	0	27931	\N
2780	16	2	0	27932	\N
2846	16	1	0	27933	\N
2846	17	2	0	27934	\N
2780	155	3	0	27935	\N
2889	16	1	0	27936	\N
2889	17	2	0	27938	\N
2682	320	94	0	29319	\N
2682	901	95	0	29323	\N
2828	933	9	0	29456	\N
2766	322	0	0	32328	\N
2788	322	126	0	32333	\N
2788	926	127	0	32338	\N
2793	453	1	0	32665	\N
2793	454	2	0	32666	\N
2697	1	1	0	33563	\N
2697	53	2	0	33565	\N
2700	1	1	0	33569	\N
2700	53	2	0	33570	\N
2715	1	3	0	33581	\N
2715	48	4	0	33582	\N
2730	53	2	0	33588	\N
2745	1	1	0	33596	\N
2745	53	2	0	33599	\N
2795	1	1	0	33608	\N
2799	1	4	0	33609	\N
2795	53	2	0	33610	\N
2799	422	5	0	33611	\N
2825	1	2	0	33615	\N
2825	283	3	0	33616	\N
2827	1	0	0	33627	\N
2837	1	0	0	33629	\N
2868	1	0	0	33636	\N
2836	935	5	0	35280	\N
2845	2	1	0	35291	\N
2816	10	0	0	37293	\N
2819	10	0	0	37304	\N
2820	10	0	0	37305	\N
2673	10	1	0	37320	\N
2673	11	2	0	37321	\N
2727	10	2	0	37332	\N
2727	29	3	0	37333	\N
2763	10	1	0	37338	\N
2763	11	2	0	37340	\N
2786	10	1	0	37348	\N
2874	10	0	0	37350	\N
2786	11	2	0	37353	\N
2790	27	1	0	41076	\N
2790	28	2	0	41078	\N
2758	51	2	0	43508	\N
2758	524	3	0	43511	\N
2876	51	1	0	43517	\N
2876	52	2	0	43519	\N
2693	56	2	0	43763	\N
2693	169	3	0	43765	\N
2778	56	2	0	43773	\N
2872	56	2	0	43774	\N
2778	169	3	0	43779	\N
2872	169	3	0	43780	\N
2747	75	1	0	45358	\N
2747	76	2	0	45359	\N
2805	75	3	0	45380	\N
2805	857	4	0	45383	\N
2812	79	1	0	46584	\N
2812	81	2	0	46586	\N
2757	121	2	0	48890	\N
2757	625	3	0	48896	\N
2699	137	1	0	49761	\N
2765	137	1	0	49762	\N
2699	138	2	0	49763	\N
2765	138	2	0	49764	\N
2711	170	1	0	50510	\N
2711	398	2	0	50511	\N
2702	181	1	0	50849	\N
2773	181	1	0	50850	\N
2702	530	2	0	50851	\N
2773	530	2	0	50852	\N
2869	181	1	0	50856	\N
2869	530	2	0	50861	\N
2675	200	4	0	51480	\N
2675	899	5	0	51482	\N
2794	242	1	0	52089	\N
2794	253	2	0	52093	\N
2823	932	0	0	52731	\N
2708	338	1	0	53818	\N
2708	409	2	0	53824	\N
2785	338	1	0	53831	\N
2785	409	2	0	53832	\N
2750	324	1	0	54200	\N
2750	325	2	0	54204	\N
2857	324	3	0	54229	\N
2859	324	1	0	54230	\N
2864	324	1	0	54231	\N
2859	939	2	0	54234	\N
2864	325	2	0	54235	\N
2857	937	4	0	54238	\N
2888	451	1	0	55250	\N
2888	584	2	0	55251	\N
2885	597	1	0	55876	\N
2885	598	2	0	55877	\N
2729	909	2	0	57513	\N
2806	908	1	0	57514	\N
2806	909	2	0	57515	\N
2809	252	2	0	1446	\N
2832	828	3	0	1463	\N
2834	117	1	0	1950	\N
2834	248	2	0	1952	\N
2720	110	3	0	2497	\N
2720	905	4	0	2498	\N
2802	237	3	0	3580	\N
2802	809	4	0	3581	\N
2863	237	2	0	3582	\N
2863	319	3	0	3583	\N
2851	189	0	0	4819	\N
2753	189	1	0	4834	\N
2815	189	1	0	4835	\N
2815	190	2	0	4837	\N
2847	222	2	0	5254	\N
2847	232	3	0	5257	\N
2858	373	3	0	5311	\N
2858	938	4	0	5314	\N
2866	391	3	0	10198	\N
2866	581	4	0	10199	\N
2687	108	1	0	11655	\N
2875	108	1	0	11657	\N
2687	109	2	0	11664	\N
2732	528	2	0	12420	\N
2732	613	3	0	12423	\N
2854	216	3	0	13059	\N
2776	256	2	0	13346	\N
2776	335	3	0	13349	\N
2856	258	3	0	14379	\N
2856	936	4	0	14382	\N
2879	92	1	0	14960	\N
2879	191	2	0	14964	\N
2838	192	3	0	15286	\N
2838	627	4	0	15289	\N
2770	326	1	0	17302	\N
2770	327	2	0	17303	\N
2717	167	1	0	17637	\N
2850	167	1	0	17641	\N
2850	533	2	0	17642	\N
2862	30	1	0	17982	\N
2862	418	2	0	17986	\N
2797	290	1	0	18950	\N
2797	291	2	0	18951	\N
2791	927	1	0	19164	\N
2791	928	2	0	19172	\N
2803	208	3	0	19252	\N
2803	659	4	0	19255	\N
2714	241	1	0	20376	\N
2714	333	2	0	20377	\N
2882	697	3	0	23045	\N
2726	69	2	0	24663	\N
2726	500	3	0	24677	\N
2867	90	3	0	26018	\N
2867	877	4	0	26020	\N
2690	244	1	0	27208	\N
2690	245	2	0	27211	\N
2738	16	1	0	27928	\N
2738	17	2	0	27930	\N
2735	911	2	0	29185	\N
2735	912	3	0	29191	\N
2684	320	1	0	29320	\N
2744	96	1	0	29451	\N
2873	96	1	0	29453	\N
2744	97	2	0	29454	\N
2873	97	2	0	29455	\N
2829	20	8	0	30396	\N
2829	934	9	0	30397	\N
2723	151	2	0	30663	\N
2723	576	3	0	30669	\N
2678	33	2	0	31749	\N
2678	34	3	0	31750	\N
2762	230	1	0	32023	\N
2762	287	2	0	32024	\N
2681	454	2	0	32642	\N
2705	1	1	0	33575	\N
2705	53	2	0	33576	\N
2755	1	2	0	33597	\N
2755	112	3	0	33601	\N
2826	1	0	0	33620	\N
2848	1	0	0	33632	\N
2853	1	0	0	33633	\N
2696	2	1	0	35262	\N
2696	26	2	0	35264	\N
2845	26	2	0	35293	\N
2844	6	1	0	36311	\N
2821	10	0	0	37306	\N
2779	10	2	0	37339	\N
2779	29	3	0	37341	\N
2800	18	4	0	39700	\N
2800	590	5	0	39703	\N
2741	23	2	0	40699	\N
2741	24	3	0	40707	\N
2841	27	2	0	41077	\N
2841	619	3	0	41079	\N
2953	57	2	0	43785	\N
2894	75	1	0	45396	\N
2931	75	2	0	45397	\N
2950	75	4	0	45398	\N
2894	76	2	0	45399	\N
2931	159	3	0	45401	\N
2950	172	5	0	45403	\N
2981	79	1	0	46661	\N
2981	81	2	0	46662	\N
2880	88	0	0	47239	\N
2906	601	4	0	47241	\N
2907	88	0	0	47252	\N
2906	88	5	0	47253	\N
2902	121	1	0	48891	\N
2902	122	2	0	48895	\N
2892	125	1	0	49207	\N
2892	195	2	0	49209	\N
2886	147	1	0	49963	\N
2886	599	2	0	49971	\N
2984	156	1	0	50194	\N
2984	157	2	0	50197	\N
2999	170	1	0	50525	\N
2999	970	2	0	50526	\N
2945	181	1	0	50857	\N
2998	181	1	0	50858	\N
2945	530	2	0	50862	\N
2998	969	2	0	50864	\N
2955	200	1	0	51490	\N
2955	201	2	0	51492	\N
2964	210	1	0	51775	\N
2964	211	2	0	51777	\N
2996	242	2	0	52090	\N
2996	620	3	0	52096	\N
2904	273	1	0	52921	\N
2904	410	2	0	52922	\N
2942	338	1	0	53833	\N
3007	338	0	0	53834	\N
2942	409	2	0	53837	\N
2976	316	1	0	53922	\N
2976	317	2	0	53924	\N
2928	324	1	0	54232	\N
2928	325	2	0	54236	\N
2890	451	1	0	55259	\N
2890	584	2	0	55260	\N
2884	595	1	0	55541	\N
2884	596	2	0	55544	\N
2956	841	1	0	56910	\N
2956	842	2	0	56911	\N
2899	908	1	0	57517	\N
2899	909	2	0	57518	\N
2913	953	6	0	1803	\N
2914	953	6	0	1807	\N
2960	110	1	0	2527	\N
2973	110	1	0	2528	\N
2960	134	2	0	2529	\N
2973	134	2	0	2530	\N
2967	237	1	0	3584	\N
2967	527	2	0	3585	\N
3004	972	70	0	4410	\N
3004	971	34	0	4461	\N
3004	365	69	0	4477	\N
2913	951	5	0	5286	\N
2896	391	2	0	10204	\N
2936	108	1	0	11658	\N
2937	108	0	0	11659	\N
2940	108	0	0	11662	\N
2875	109	2	0	11666	\N
2936	109	2	0	11667	\N
2925	528	2	0	12421	\N
2925	613	3	0	12424	\N
2916	77	1	0	13069	\N
2916	78	2	0	13070	\N
2923	58	2	0	13441	\N
2923	665	3	0	13442	\N
2948	960	1	0	15223	\N
2895	44	3	0	16023	\N
2895	940	4	0	16024	\N
2995	44	2	0	16049	\N
2995	161	3	0	16050	\N
2986	964	1	0	16941	\N
2986	965	2	0	16942	\N
2992	966	1	0	16953	\N
2965	212	1	0	17081	\N
2965	213	2	0	17083	\N
3008	167	0	0	17648	\N
3004	973	70	1	18402	\N
3010	290	2	0	18956	\N
2887	198	1	0	20001	\N
2887	199	2	0	20002	\N
2974	241	1	0	20381	\N
2974	333	2	0	20386	\N
3001	64	0	0	20725	\N
2958	164	1	0	21013	\N
2958	165	2	0	21015	\N
2954	149	1	0	23041	\N
2954	499	2	0	23043	\N
2930	140	2	0	23975	\N
2930	487	3	0	23976	\N
2962	49	1	0	25008	\N
2978	49	1	0	25012	\N
2978	50	2	0	25014	\N
2878	411	1	0	25170	\N
2883	411	2	0	25171	\N
2878	412	2	0	25175	\N
2883	582	3	0	25178	\N
2951	206	0	0	25753	\N
2993	42	1	0	27495	\N
2993	43	2	0	27499	\N
2898	16	1	0	27937	\N
2898	17	2	0	27939	\N
2934	16	1	0	27940	\N
2934	17	2	0	27942	\N
2946	17	2	0	27943	\N
2918	320	3	0	29339	\N
2918	797	4	0	29340	\N
2990	144	1	0	30398	\N
2990	20	4	0	30410	\N
2990	702	5	0	30411	\N
2943	202	1	0	31038	\N
2943	203	2	0	31039	\N
2980	202	1	0	31044	\N
2980	203	2	0	31045	\N
2927	360	1	0	31424	\N
2901	1	0	0	33639	\N
2968	1	1	0	33644	\N
2968	53	2	0	33645	\N
2970	1	1	0	33648	\N
2970	53	2	0	33649	\N
2971	1	3	0	33652	\N
2971	48	4	0	33653	\N
2992	967	1	0	33656	\N
2992	53	2	0	33657	\N
2983	1	1	0	33658	\N
2983	53	2	0	33659	\N
3002	1	0	0	33663	\N
2881	2	2	0	35292	\N
2881	131	3	0	35294	\N
2922	4	2	0	36007	\N
2922	579	3	0	36013	\N
2926	10	0	0	37352	\N
2933	10	0	0	37356	\N
2944	10	0	0	37359	\N
2987	10	1	0	37360	\N
2987	11	2	0	37361	\N
3005	10	0	0	37366	\N
2909	942	4	0	41080	\N
2909	27	5	0	41101	\N
2897	56	1	0	43775	\N
2932	56	2	0	43776	\N
2897	57	2	0	43777	\N
2932	169	3	0	43781	\N
3015	71	1	0	44748	\N
3015	72	2	0	44749	\N
2982	75	1	0	45416	\N
2982	76	2	0	45417	\N
2975	79	2	0	46625	\N
2975	80	3	0	46626	\N
3030	125	1	0	49208	\N
3030	195	2	0	49210	\N
2921	958	37	0	50182	\N
2921	156	126	0	50199	\N
2921	959	127	0	50200	\N
2919	210	1	0	51769	\N
2919	211	2	0	51770	\N
2991	253	1	0	52083	\N
3086	242	1	0	52091	\N
2991	242	4	0	52094	\N
3086	253	2	0	52095	\N
2991	620	5	0	52097	\N
2959	260	1	0	52383	\N
3013	260	1	0	52384	\N
2959	261	2	0	52387	\N
3013	261	2	0	52388	\N
3089	285	1	0	53384	\N
3089	286	2	0	53386	\N
3033	338	1	0	53835	\N
3033	409	2	0	53838	\N
2947	362	1	0	54765	\N
2947	395	2	0	54766	\N
3023	362	1	0	54769	\N
3023	395	2	0	54770	\N
2911	945	5	0	55522	\N
2915	945	1	0	55523	\N
2910	943	0	0	55524	\N
2915	956	2	0	55530	\N
2911	948	6	1	55532	\N
2941	913	2	0	57178	\N
3006	852	0	0	57184	\N
2911	947	6	0	1800	\N
2910	944	0	0	1804	\N
2911	946	5	0	1805	\N
2912	950	52	0	1808	\N
2963	962	1	0	2317	\N
2963	963	2	0	2320	\N
2935	110	2	0	2519	\N
2935	111	3	0	2520	\N
2979	228	1	0	2857	\N
2979	229	2	0	2859	\N
3044	237	2	0	3586	\N
3044	319	3	0	3587	\N
3003	365	0	0	4470	\N
3068	232	3	0	5259	\N
3011	391	1	0	10208	\N
3050	391	3	0	10209	\N
3011	392	2	0	10210	\N
3050	581	4	0	10211	\N
3017	132	1	0	11143	\N
3053	132	1	0	11144	\N
3083	132	1	0	11145	\N
3017	455	2	0	11147	\N
3053	455	2	0	11148	\N
3083	455	2	0	11149	\N
2938	108	0	0	11660	\N
3025	58	1	0	13447	\N
3025	59	2	0	13450	\N
2966	233	1	0	13786	\N
2972	233	3	0	13787	\N
2966	234	2	0	13789	\N
2972	305	4	0	13791	\N
3016	258	1	0	14395	\N
3016	309	2	0	14396	\N
2905	941	4	0	15290	\N
2905	192	5	0	15305	\N
3019	326	1	0	17306	\N
3019	327	2	0	17308	\N
2915	955	1	0	17647	\N
2924	142	2	0	18452	\N
2924	656	3	0	18456	\N
3028	290	1	0	18963	\N
3028	291	2	0	18964	\N
3036	290	2	0	18971	\N
3036	575	3	0	18972	\N
2985	64	1	0	20724	\N
2985	65	2	0	20726	\N
2961	336	1	0	22709	\N
2961	356	2	0	22711	\N
3082	264	1	0	23438	\N
2988	140	1	0	23987	\N
2988	141	2	0	23989	\N
2900	411	1	0	25172	\N
2900	412	2	0	25176	\N
2908	358	4	0	26015	\N
2969	90	3	0	26019	\N
2969	877	4	0	26021	\N
2908	90	5	0	26022	\N
3000	86	0	0	26418	\N
3014	94	1	0	26716	\N
3014	107	2	0	26718	\N
2903	244	1	0	27209	\N
2949	16	1	0	27944	\N
2949	17	2	0	27945	\N
3062	320	1	0	29350	\N
3062	977	2	0	29353	\N
3079	96	1	0	29460	\N
3079	97	2	0	29461	\N
3076	980	24	0	29983	\N
3076	54	126	0	30006	\N
3076	981	127	0	30007	\N
3022	20	1	0	30415	\N
3022	144	2	0	30416	\N
3027	151	1	0	30664	\N
2994	202	1	0	31052	\N
2994	203	2	0	31053	\N
3021	360	1	0	31425	\N
3021	479	2	0	31427	\N
3092	322	126	0	32341	\N
3039	453	1	0	32674	\N
3039	454	2	0	32678	\N
2952	1	4	0	33640	\N
2952	422	5	0	33641	\N
2997	1	1	0	33662	\N
2997	968	2	0	33664	\N
3020	1	1	0	33670	\N
3020	53	2	0	33672	\N
3047	112	3	0	33673	\N
3077	1	1	0	33685	\N
3077	53	2	0	33686	\N
3024	8	1	0	36467	\N
3024	9	2	0	36468	\N
2920	10	0	0	37351	\N
3026	10	1	0	37369	\N
3029	10	1	0	37370	\N
3026	11	2	0	37371	\N
3065	10	1	0	37379	\N
3065	11	2	0	37380	\N
3071	11	2	0	37383	\N
3012	18	1	0	39701	\N
3012	19	2	0	39702	\N
2929	23	2	0	40700	\N
3018	23	1	0	40701	\N
3018	217	2	0	40705	\N
2929	24	3	0	40708	\N
3056	40	0	0	41879	\N
3059	40	0	0	41881	\N
3048	71	2	0	44753	\N
3048	401	3	0	44761	\N
3085	75	1	0	45428	\N
3195	75	1	0	45429	\N
3085	76	2	0	45431	\N
3195	76	2	0	45432	\N
3073	88	1	0	47264	\N
3073	89	2	0	47265	\N
3202	88	7	0	47273	\N
3202	1002	8	0	47277	\N
3049	100	1	0	47543	\N
3049	160	2	0	47544	\N
3142	102	1	0	47784	\N
3142	103	2	0	47787	\N
3121	121	12	0	48892	\N
3121	992	13	0	48897	\N
3208	135	1	0	49432	\N
3208	136	2	0	49436	\N
3046	974	7	0	49766	\N
3046	137	35	0	49779	\N
3046	975	36	0	49780	\N
3117	186	2	0	51234	\N
3117	696	3	0	51235	\N
3130	268	1	0	52733	\N
3130	269	2	0	52737	\N
3120	273	12	0	52927	\N
3120	991	13	0	52930	\N
3054	353	1	0	54531	\N
3054	354	2	0	54532	\N
3145	353	1	0	54544	\N
3145	354	2	0	54545	\N
3210	353	2	0	54548	\N
3210	755	3	0	54549	\N
3103	362	2	0	54775	\N
3103	420	3	0	54776	\N
3031	852	1	0	57185	\N
3031	913	2	0	57188	\N
3111	908	2	0	57522	\N
3111	988	3	0	57524	\N
3154	997	2	0	1870	\N
3045	368	2	0	3301	\N
3041	189	0	0	4833	\N
3042	189	2	0	4852	\N
3042	311	3	0	4854	\N
3148	391	2	0	10214	\N
3148	406	3	0	10220	\N
3043	58	2	0	13448	\N
3043	665	3	0	13452	\N
3094	192	8	0	15301	\N
3094	985	9	0	15306	\N
3102	235	1	0	15605	\N
3102	236	2	0	15607	\N
3214	236	2	0	15611	\N
3034	44	1	0	16059	\N
3034	45	2	0	16063	\N
3055	38	1	0	16347	\N
3055	399	2	0	16351	\N
3067	62	1	0	19693	\N
3067	63	2	0	19694	\N
3038	198	1	0	20003	\N
3038	199	2	0	20004	\N
3069	978	0	0	20327	\N
3215	241	1	0	20382	\N
3215	333	2	0	20387	\N
3112	990	3	0	21723	\N
3172	67	1	0	22166	\N
3172	478	2	0	22169	\N
3118	336	1	0	22710	\N
3118	356	2	0	22712	\N
3058	264	3	0	23428	\N
3058	976	4	0	23429	\N
3032	140	1	0	23988	\N
3032	141	2	0	23990	\N
3127	140	0	0	24016	\N
3178	140	2	0	24017	\N
3178	487	3	0	24018	\N
3188	141	2	0	24031	\N
3191	214	1	0	24351	\N
3191	215	2	0	24353	\N
3114	224	1	0	25479	\N
3114	225	2	0	25481	\N
3099	94	1	0	26717	\N
3099	107	2	0	26719	\N
3035	16	1	0	27946	\N
3035	17	2	0	27947	\N
3091	16	1	0	27948	\N
3091	17	2	0	27949	\N
3123	16	3	0	27950	\N
3151	16	3	0	27952	\N
3175	16	1	0	27954	\N
3175	17	2	0	27956	\N
3151	359	4	0	27957	\N
3205	16	1	0	27959	\N
3205	17	2	0	27961	\N
3063	320	1	0	29351	\N
3063	334	2	0	29352	\N
3133	320	1	0	29361	\N
3133	334	2	0	29363	\N
3070	449	2	0	29789	\N
3070	583	3	0	29793	\N
3097	987	4	0	31065	\N
3199	360	1	0	31437	\N
3199	479	2	0	31440	\N
3064	230	1	0	32035	\N
3064	287	2	0	32036	\N
3216	322	2	0	32330	\N
3216	833	3	0	32332	\N
3092	983	127	0	32342	\N
3052	1	2	0	33679	\N
3052	112	3	0	33680	\N
3096	1	3	0	33689	\N
3096	48	4	0	33690	\N
3100	53	2	0	33704	\N
3115	1	3	0	33707	\N
3124	1	4	0	33708	\N
3115	48	4	0	33709	\N
3124	422	5	0	33710	\N
3156	1	1	0	33714	\N
3156	53	2	0	33716	\N
3108	2	3	0	35305	\N
3108	572	4	0	35306	\N
3126	2	0	0	35332	\N
3169	2	1	0	35351	\N
3169	26	2	0	35353	\N
3051	10	1	0	37375	\N
3051	11	2	0	37376	\N
3163	10	1	0	37404	\N
3163	11	2	0	37405	\N
3166	10	1	0	37418	\N
3166	11	2	0	37419	\N
3180	10	2	0	37426	\N
3180	29	3	0	37427	\N
3197	10	2	0	37431	\N
3197	29	3	0	37435	\N
3037	14	1	0	39116	\N
3037	15	2	0	39119	\N
3040	19	2	0	39705	\N
3093	23	8	0	40636	\N
3093	984	9	0	40641	\N
3088	27	2	0	41091	\N
3088	619	3	0	41099	\N
3069	979	0	0	41876	\N
3057	40	0	0	41880	\N
3060	40	0	0	41882	\N
3061	40	0	0	41883	\N
3218	40	1	0	41956	\N
3218	41	2	0	41957	\N
2425	51	1	0	43507	\N
3106	52	2	0	43527	\N
3075	56	1	0	43786	\N
3090	56	1	0	43787	\N
3075	57	2	0	43788	\N
3090	57	2	0	43789	\N
3149	56	2	0	43790	\N
3149	169	3	0	43791	\N
3161	56	1	0	43792	\N
3173	56	1	0	43793	\N
3161	57	2	0	43795	\N
3173	57	2	0	43796	\N
3144	88	1	0	47272	\N
3144	89	2	0	47275	\N
3159	102	1	0	47785	\N
3159	103	2	0	47788	\N
3167	113	1	0	48238	\N
3167	437	2	0	48240	\N
3081	135	1	0	49431	\N
3081	136	2	0	49435	\N
3084	137	24	0	49795	\N
3084	982	25	0	49796	\N
3129	210	1	0	51776	\N
3129	211	2	0	51778	\N
3143	268	1	0	52734	\N
3170	268	1	0	52735	\N
3143	269	2	0	52738	\N
3170	269	2	0	52739	\N
3141	273	5	0	52928	\N
3141	274	6	0	52929	\N
3189	338	1	0	53836	\N
3189	409	2	0	53839	\N
3187	852	1	0	57186	\N
3187	913	2	0	57189	\N
3140	908	2	0	57523	\N
3140	988	3	0	57525	\N
3136	221	2	0	543	\N
3157	117	1	0	1961	\N
3157	248	2	0	1963	\N
3185	1000	1	0	2287	\N
3185	1001	2	0	2289	\N
3110	367	2	0	3309	\N
3110	651	3	0	3310	\N
3104	365	1	0	4471	\N
3104	366	2	0	4475	\N
3194	391	1	0	10215	\N
3194	392	2	0	10218	\N
3184	233	1	0	13788	\N
3184	234	2	0	13790	\N
3153	403	2	0	14044	\N
3132	258	1	0	14414	\N
3132	309	2	0	14415	\N
3078	235	1	0	15604	\N
3078	236	2	0	15606	\N
3158	44	1	0	16060	\N
3158	45	2	0	16064	\N
3107	326	1	0	17307	\N
3107	327	2	0	17309	\N
3162	62	1	0	19695	\N
3162	63	2	0	19697	\N
3095	64	8	0	20737	\N
3164	65	2	0	20739	\N
3095	986	9	0	20740	\N
3087	164	2	0	21023	\N
3087	226	3	0	21024	\N
3179	488	2	0	21400	\N
3179	729	3	0	21405	\N
3125	73	3	0	22456	\N
3125	993	4	0	22458	\N
3186	73	1	0	22465	\N
3186	74	2	0	22466	\N
3207	73	1	0	22473	\N
3207	74	2	0	22484	\N
3196	499	2	0	23044	\N
3203	149	7	0	23048	\N
3203	1003	8	0	23049	\N
3113	140	1	0	24001	\N
3113	141	2	0	24002	\N
3137	214	1	0	24350	\N
3137	215	2	0	24352	\N
3135	411	1	0	25173	\N
3135	412	2	0	25177	\N
3128	224	4	0	25496	\N
3128	994	5	0	25499	\N
3176	206	2	0	25773	\N
3152	16	1	0	27953	\N
3152	17	2	0	27955	\N
3192	16	1	0	27958	\N
3192	17	2	0	27960	\N
3131	320	13	0	29365	\N
3131	995	14	0	29366	\N
3074	54	1	0	29996	\N
3074	55	2	0	30001	\N
3183	360	1	0	31436	\N
3183	479	2	0	31439	\N
3155	322	1	0	32329	\N
3155	323	2	0	32331	\N
3098	53	2	0	33703	\N
3146	1	1	0	33713	\N
3146	53	2	0	33715	\N
3177	1	2	0	33719	\N
3182	1	1	0	33720	\N
3182	53	2	0	33721	\N
3177	112	3	0	33722	\N
3193	1	1	0	33729	\N
3193	53	2	0	33730	\N
3198	1	2	0	33737	\N
3198	112	3	0	33738	\N
3119	2	1	0	35317	\N
3122	2	3	0	35331	\N
3122	572	4	0	35333	\N
3072	4	1	0	36008	\N
3072	25	2	0	36011	\N
3080	10	1	0	37386	\N
3109	10	3	0	37387	\N
3116	10	3	0	37388	\N
3080	11	2	0	37389	\N
3109	347	4	0	37390	\N
3116	347	4	0	37391	\N
3134	10	1	0	37394	\N
3134	11	2	0	37395	\N
3139	600	5	0	37401	\N
3165	10	5	0	37412	\N
3165	998	6	0	37413	\N
3168	10	1	0	37422	\N
3168	11	2	0	37423	\N
3181	10	1	0	37430	\N
3204	10	1	0	37432	\N
3181	11	2	0	37433	\N
3204	11	2	0	37434	\N
3174	14	1	0	39117	\N
3190	14	4	0	39118	\N
3174	15	2	0	39120	\N
3147	18	1	0	39706	\N
3147	19	2	0	39707	\N
3200	18	1	0	39708	\N
3200	19	2	0	39709	\N
3171	23	1	0	40637	\N
3171	217	2	0	40639	\N
3101	27	1	0	41092	\N
3101	28	2	0	41096	\N
3138	40	4	0	41905	\N
3150	40	1	0	41906	\N
3150	41	2	0	41907	\N
3138	564	5	0	41908	\N
3160	41	2	0	41933	\N
2796	51	1	0	43516	\N
3241	329	4	0	43535	\N
3318	79	2	0	46377	\N
3318	80	3	0	46378	\N
3256	88	2	0	47274	\N
3256	154	3	0	47276	\N
3238	113	1	0	48239	\N
3238	437	2	0	48241	\N
3224	125	1	0	49218	\N
3224	195	2	0	49220	\N
3209	1004	72	0	49797	\N
3209	137	126	0	49814	\N
3209	1005	127	0	49823	\N
3225	147	1	0	49964	\N
3225	599	2	0	49972	\N
3228	170	13	0	50537	\N
3228	1008	14	0	50541	\N
3271	181	2	0	50859	\N
3271	769	3	0	50863	\N
3245	186	2	0	51252	\N
3247	186	66	0	51253	\N
3245	696	3	0	51257	\N
3247	1020	67	0	51258	\N
3286	210	8	0	51782	\N
3286	1026	9	0	51785	\N
3211	268	1	0	52743	\N
3211	269	2	0	52744	\N
3275	273	1	0	52937	\N
3275	410	2	0	52938	\N
3333	324	4	0	54246	\N
3333	603	5	0	54248	\N
3248	362	1	0	54779	\N
3248	395	2	0	54780	\N
3226	435	13	0	54969	\N
3226	1006	14	0	54970	\N
3221	595	1	0	55542	\N
3221	596	2	0	55545	\N
3223	597	1	0	55884	\N
3223	598	2	0	55889	\N
3257	1021	1	0	56485	\N
3257	1022	2	0	56486	\N
3268	908	1	0	57530	\N
3268	909	2	0	57532	\N
3302	908	4	0	57540	\N
3302	1032	5	0	57544	\N
3246	520	3	0	745	\N
3222	134	2	0	2545	\N
3237	237	1	0	3588	\N
3237	527	2	0	3590	\N
3235	262	4	0	3775	\N
3235	1015	5	0	3776	\N
3250	262	1	0	3800	\N
3250	263	2	0	3801	\N
3261	365	1	0	4472	\N
3261	366	2	0	4476	\N
3233	1012	10	0	5310	\N
3233	1013	11	0	5315	\N
3206	391	1	0	10216	\N
3206	392	2	0	10219	\N
3234	1014	9	0	10221	\N
3251	528	2	0	12422	\N
3251	613	3	0	12425	\N
3253	123	1	0	12749	\N
3253	124	2	0	12750	\N
3329	123	12	0	12767	\N
3329	1041	13	0	12770	\N
3336	77	3	0	13085	\N
3336	1043	4	0	13088	\N
3294	192	0	0	15303	\N
3242	115	3	0	16642	\N
3313	115	2	0	16644	\N
3255	636	3	0	16647	\N
3242	732	4	0	16650	\N
3313	1034	3	0	16651	\N
3231	167	4	0	17649	\N
3231	1011	5	0	17650	\N
3278	290	4	0	18977	\N
3278	695	5	0	18988	\N
3233	978	11	0	20328	\N
3243	1018	2	0	21861	\N
3213	149	2	0	23050	\N
3213	697	3	0	23051	\N
3320	140	2	0	24029	\N
3258	141	2	0	24032	\N
3320	487	3	0	24034	\N
3219	90	1	0	26025	\N
3219	344	2	0	26027	\N
3227	42	13	0	27496	\N
3229	42	4	0	27497	\N
3229	1009	5	0	27502	\N
3227	1007	14	0	27503	\N
3230	16	6	0	27962	\N
3230	1010	7	0	27963	\N
3240	16	18	0	27964	\N
3280	155	3	0	27966	\N
3240	1017	19	0	27967	\N
3323	16	19	0	27968	\N
3323	1038	20	0	27969	\N
3270	320	50	0	29376	\N
3270	1023	51	0	29377	\N
3243	97	1	0	29462	\N
3244	97	1	0	29463	\N
3243	1019	2	0	29476	\N
3244	96	2	0	29477	\N
3283	449	3	0	29802	\N
3283	1025	4	0	29806	\N
3212	479	2	0	31441	\N
3217	1	2	0	33743	\N
3220	1	1	0	33744	\N
3239	1	18	0	33745	\N
3220	53	2	0	33746	\N
3217	112	3	0	33747	\N
3239	1016	19	0	33748	\N
3263	1	1	0	33753	\N
3266	1	1	0	33754	\N
3263	53	2	0	33755	\N
3266	53	2	0	33756	\N
3279	1	2	0	33759	\N
3232	10	6	0	37438	\N
3232	426	7	0	37439	\N
3249	10	1	0	37442	\N
3252	10	2	0	37443	\N
3249	11	2	0	37444	\N
3252	29	3	0	37445	\N
3254	10	2	0	37447	\N
3259	10	1	0	37448	\N
3259	11	2	0	37449	\N
3254	29	3	0	37450	\N
3273	10	2	0	37460	\N
3273	29	3	0	37461	\N
3305	1033	6	0	37469	\N
3326	10	1	0	37473	\N
3326	11	2	0	37474	\N
3339	10	3	0	37494	\N
3307	14	1	0	39148	\N
3307	15	2	0	39150	\N
3285	27	2	0	41093	\N
3308	27	1	0	41094	\N
3308	28	2	0	41097	\N
3285	619	3	0	41100	\N
3236	40	1	0	41976	\N
3260	40	1	0	41977	\N
3236	41	2	0	41980	\N
3260	41	2	0	41981	\N
3299	66	3	0	41982	\N
3316	40	2	0	41998	\N
3316	66	3	0	42001	\N
3341	56	1	0	43794	\N
3341	57	2	0	43797	\N
3383	79	1	0	46096	\N
3383	81	2	0	46099	\N
3322	113	19	0	48249	\N
3322	1037	20	0	48251	\N
3502	121	0	0	48907	\N
3408	147	8	0	50005	\N
3408	1067	9	0	50006	\N
3499	1083	63	1	51138	\N
3499	1081	14	0	51285	\N
3499	186	62	0	51292	\N
3332	210	4	0	51783	\N
3332	565	5	0	51784	\N
3269	324	1	0	54233	\N
3269	325	2	0	54237	\N
3462	362	0	0	54783	\N
3304	389	0	0	54926	\N
3427	389	3	0	54927	\N
3427	1069	4	0	54928	\N
3348	451	5	0	55286	\N
3348	1050	6	0	55291	\N
3411	597	2	0	55886	\N
3411	767	3	0	55892	\N
3346	1047	4	0	56487	\N
3346	1021	7	0	56495	\N
3346	1048	8	0	56496	\N
3487	1021	0	0	56509	\N
3319	289	3	0	24	\N
3437	220	0	0	539	\N
3366	266	1	0	1157	\N
3366	267	2	0	1158	\N
3414	251	1	0	1475	\N
3414	252	2	0	1476	\N
3399	117	1	0	1962	\N
3399	248	2	0	1964	\N
3325	110	5	0	2544	\N
3325	1039	6	0	2546	\N
3452	110	0	0	2555	\N
3378	228	0	0	2858	\N
3357	391	1	0	10230	\N
3360	132	2	0	11146	\N
3360	133	3	0	11150	\N
3402	300	41	0	12024	\N
3402	1066	42	0	12030	\N
3520	528	1	0	12446	\N
3520	529	2	0	12447	\N
3514	77	0	0	13099	\N
3264	233	1	0	13798	\N
3264	234	2	0	13802	\N
3345	1046	4	0	14616	\N
3345	173	7	0	14626	\N
3345	480	8	0	14627	\N
3478	92	0	0	14962	\N
3477	1056	0	0	14980	\N
3508	92	1	0	14987	\N
3508	191	2	0	14989	\N
3289	192	0	0	15287	\N
3292	192	0	0	15302	\N
3293	192	5	0	15317	\N
3293	1030	6	0	15318	\N
3353	98	3	0	16977	\N
3353	1054	4	0	16978	\N
3344	167	1	0	17654	\N
3344	533	2	0	17656	\N
3384	533	2	0	17662	\N
3331	30	5	0	17983	\N
3331	1042	6	0	17990	\N
3499	1082	63	0	18246	\N
3342	142	3	0	18453	\N
3342	1044	4	0	18457	\N
3449	142	0	0	18464	\N
3284	208	2	0	19253	\N
3284	854	3	0	19254	\N
3297	241	2	0	20397	\N
3297	281	3	0	20398	\N
3471	64	0	0	20758	\N
3356	1018	49	0	21863	\N
3443	1018	0	0	21864	\N
3477	1018	0	0	21865	\N
3424	67	1	0	22167	\N
3424	478	2	0	22170	\N
3420	149	2	0	23053	\N
3420	697	3	0	23056	\N
3363	264	1	0	23439	\N
3363	270	2	0	23441	\N
3375	264	2	0	23450	\N
3375	265	3	0	23452	\N
3347	49	10	0	25024	\N
3434	49	0	0	25028	\N
3350	1052	79	0	25779	\N
3350	1053	80	0	25794	\N
3443	1053	0	0	25804	\N
3511	94	0	0	26721	\N
3298	42	2	0	27498	\N
3298	681	3	0	27501	\N
3526	42	6	0	27511	\N
3526	1090	7	0	27512	\N
3505	16	1	0	27980	\N
3505	1087	2	0	27982	\N
3499	1084	64	0	29403	\N
3496	1079	2	0	29805	\N
3486	202	0	0	31061	\N
3387	360	1	0	31453	\N
3387	479	2	0	31454	\N
3474	33	0	0	31755	\N
3484	33	0	0	31756	\N
3310	1	1	0	33763	\N
3310	53	2	0	33764	\N
3317	1	2	0	33767	\N
3317	112	3	0	33768	\N
3338	1	2	0	33776	\N
3338	283	3	0	33777	\N
3393	53	2	0	33781	\N
3490	1	0	0	33805	\N
3301	431	4	0	34761	\N
3301	1031	5	0	34762	\N
3328	2	7	0	35352	\N
3328	1040	8	0	35354	\N
3430	2	1	0	35413	\N
3430	26	2	0	35414	\N
3528	2	1	0	35444	\N
3528	1091	2	0	35447	\N
3396	4	1	0	36009	\N
3396	25	2	0	36012	\N
3262	10	5	0	37453	\N
3262	998	6	0	37454	\N
3276	10	4	0	37464	\N
3276	600	5	0	37465	\N
3335	10	1	0	37490	\N
3335	11	2	0	37491	\N
3339	347	4	0	37495	\N
3354	10	2	0	37498	\N
3354	29	3	0	37499	\N
3405	10	0	0	37518	\N
3459	10	0	0	37530	\N
3517	10	0	0	37539	\N
3372	18	1	0	39711	\N
3372	19	2	0	39712	\N
3431	18	1	0	39715	\N
3431	19	2	0	39717	\N
3446	23	1	0	40638	\N
3446	217	2	0	40640	\N
3417	40	1	0	42018	\N
3417	41	2	0	42020	\N
3513	40	0	0	42034	\N
3106	51	1	0	43526	\N
3519	56	1	0	43799	\N
3519	1088	2	0	43800	\N
3470	71	0	0	44754	\N
3265	75	1	0	45430	\N
3265	76	2	0	45433	\N
3309	75	1	0	45439	\N
3359	75	1	0	45441	\N
3309	76	2	0	45442	\N
3359	76	2	0	45444	\N
3422	79	1	0	46155	\N
3422	81	2	0	46157	\N
3454	79	0	0	46241	\N
3473	113	0	0	48250	\N
3377	119	1	0	48518	\N
3377	120	2	0	48520	\N
3349	125	5	0	49219	\N
3389	147	30	0	49965	\N
3389	1064	31	0	49978	\N
3489	1073	68	0	50527	\N
3489	1074	86	0	50528	\N
3489	170	85	0	50542	\N
3498	186	1	0	51255	\N
3498	1080	2	0	51256	\N
3456	1070	14	0	51265	\N
3456	186	126	0	51282	\N
3456	1071	127	0	51284	\N
3274	260	2	0	52385	\N
3300	260	2	0	52386	\N
3274	419	3	0	52389	\N
3300	419	3	0	52390	\N
3306	285	1	0	53402	\N
3306	286	2	0	53403	\N
3428	338	3	0	53840	\N
3428	339	4	0	53841	\N
3277	316	4	0	53929	\N
3277	1024	5	0	53932	\N
3296	353	1	0	54552	\N
3296	354	2	0	54553	\N
3438	353	0	0	54556	\N
3409	595	2	0	55569	\N
3409	768	3	0	55576	\N
3448	841	1	0	56916	\N
3448	842	2	0	56918	\N
3287	908	8	0	57531	\N
3287	1027	9	0	57533	\N
3407	908	0	0	57541	\N
3418	13	2	0	287	\N
3288	1028	9	0	547	\N
3458	251	0	0	1489	\N
3476	237	0	0	3589	\N
3464	35	0	0	4166	\N
3334	391	3	0	10226	\N
3334	581	4	0	10227	\N
3400	391	1	0	10240	\N
3400	392	2	0	10242	\N
3479	391	0	0	10245	\N
3492	132	0	0	11168	\N
3401	300	1	0	12023	\N
3401	355	2	0	12028	\N
3392	78	2	0	13087	\N
3358	92	1	0	14961	\N
3358	191	2	0	14965	\N
3356	1056	49	0	14966	\N
3495	92	1	0	14978	\N
3495	1078	2	0	14979	\N
3290	192	0	0	15288	\N
3295	192	0	0	15304	\N
3374	235	2	0	15618	\N
3374	1061	3	0	15619	\N
3395	1065	70	0	17127	\N
3395	212	126	0	17169	\N
3493	1065	70	0	17171	\N
3493	212	96	0	17181	\N
3493	1076	97	0	17182	\N
3267	167	1	0	17653	\N
3267	533	2	0	17655	\N
3425	290	3	0	18978	\N
3425	364	4	0	18987	\N
3507	62	0	0	19696	\N
3291	241	13	0	20383	\N
3291	1029	14	0	20391	\N
3282	164	3	0	21038	\N
3282	307	4	0	21039	\N
3489	1075	86	1	21908	\N
3340	145	1	0	21909	\N
3340	153	2	0	21911	\N
3314	73	2	0	22474	\N
3447	73	1	0	22475	\N
3447	74	2	0	22485	\N
3314	1035	3	0	22493	\N
3311	149	1	0	23052	\N
3311	499	2	0	23055	\N
3419	140	1	0	24030	\N
3419	141	2	0	24033	\N
3281	49	2	0	25013	\N
3504	49	1	0	25036	\N
3504	1086	2	0	25037	\N
3343	16	3	0	27970	\N
3343	1045	4	0	27971	\N
3451	16	0	0	27976	\N
3461	16	0	0	27978	\N
3483	16	0	0	27979	\N
3272	320	2	0	29362	\N
3272	321	3	0	29364	\N
3330	20	2	0	30423	\N
3330	702	3	0	30424	\N
3365	20	2	0	30429	\N
3416	453	1	0	32675	\N
3416	454	2	0	32679	\N
3321	1	9	0	33771	\N
3321	1036	10	0	33772	\N
3413	1	3	0	33780	\N
3413	48	4	0	33782	\N
3501	1	0	0	33809	\N
3380	2	1	0	35397	\N
3380	26	2	0	35398	\N
3398	4	4	0	36010	\N
3398	684	5	0	36014	\N
3410	4	2	0	36024	\N
3315	10	2	0	37472	\N
3315	29	3	0	37475	\N
3362	10	1	0	37504	\N
3362	11	2	0	37505	\N
3371	10	1	0	37512	\N
3386	10	1	0	37513	\N
3371	11	2	0	37514	\N
3386	11	2	0	37515	\N
3432	10	0	0	37527	\N
3467	10	0	0	37537	\N
3303	14	2	0	39136	\N
3303	383	3	0	39137	\N
3337	306	4	0	39151	\N
3368	18	2	0	39710	\N
3368	218	3	0	39713	\N
3510	18	1	0	39718	\N
3510	19	2	0	39722	\N
3404	27	1	0	41095	\N
3404	28	2	0	41098	\N
3453	27	0	0	41116	\N
3312	40	2	0	41979	\N
3312	569	3	0	41983	\N
3324	40	5	0	41999	\N
3327	40	2	0	42000	\N
3324	385	6	0	42003	\N
3445	40	1	0	42033	\N
3445	41	2	0	42036	\N
3351	76	2	0	45443	\N
3539	75	0	0	45449	\N
3622	75	0	0	45459	\N
3385	79	0	0	46097	\N
3406	79	0	0	46098	\N
3423	79	0	0	46156	\N
3482	79	0	0	46293	\N
3585	79	0	0	46346	\N
3610	79	0	0	46398	\N
3607	113	0	0	48263	\N
3633	113	1	0	48264	\N
3633	1102	2	0	48265	\N
3646	113	0	0	48271	\N
3349	1051	6	0	49221	\N
3488	170	1	0	50538	\N
3488	1072	2	0	50539	\N
3455	186	0	0	51254	\N
3568	242	0	0	52110	\N
3466	260	0	0	52394	\N
3577	285	0	0	53412	\N
3442	316	0	0	53930	\N
3457	324	0	0	54247	\N
3530	353	1	0	54557	\N
3530	1092	2	0	54560	\N
3472	362	0	0	54784	\N
3390	595	1	0	55553	\N
3390	596	2	0	55554	\N
3391	597	1	0	55885	\N
3391	598	2	0	55890	\N
3469	793	0	0	56639	\N
3475	793	0	0	56640	\N
3426	852	3	0	57187	\N
3426	1068	4	0	57190	\N
3559	852	0	0	57213	\N
3603	852	0	0	57222	\N
3533	908	2	0	57542	\N
3533	1095	3	0	57545	\N
3525	237	0	0	3591	\N
3460	189	0	0	4867	\N
3595	373	0	0	5312	\N
3642	373	0	0	5313	\N
3388	391	1	0	10236	\N
3388	392	2	0	10237	\N
3465	391	0	0	10241	\N
3403	132	1	0	11161	\N
3403	455	2	0	11162	\N
3429	108	1	0	11670	\N
3433	108	0	0	11671	\N
3545	108	0	0	11672	\N
3616	108	0	0	11673	\N
3531	528	1	0	12459	\N
3531	1093	2	0	12463	\N
3381	402	1	0	14056	\N
3381	403	2	0	14058	\N
3583	92	0	0	14988	\N
3500	235	0	0	15622	\N
3369	1059	59	0	16340	\N
3370	38	2	0	16348	\N
3370	39	3	0	16352	\N
3369	38	61	0	16353	\N
3369	399	62	0	16354	\N
3540	38	0	0	16361	\N
3376	1062	70	0	17103	\N
3376	212	126	0	17125	\N
3376	1063	127	0	17126	\N
3543	30	9	0	17993	\N
3543	1097	10	0	17994	\N
3394	142	1	0	18454	\N
3394	143	2	0	18455	\N
3592	290	0	0	18979	\N
3509	60	1	0	19416	\N
3509	61	2	0	19417	\N
3562	60	0	0	19428	\N
3613	62	0	0	19704	\N
3421	162	3	0	20754	\N
3527	67	0	0	22168	\N
3382	336	1	0	22713	\N
3382	356	2	0	22715	\N
3580	149	0	0	23054	\N
3379	264	2	0	23451	\N
3379	265	3	0	23453	\N
3535	82	0	0	23758	\N
3604	82	0	0	23764	\N
3497	49	0	0	25029	\N
3544	49	0	0	25041	\N
3630	206	0	0	25754	\N
3361	91	3	0	26028	\N
3436	86	0	0	26419	\N
3463	94	0	0	26720	\N
3547	94	0	0	26722	\N
3485	244	0	0	27222	\N
3523	42	0	0	27510	\N
3625	42	0	0	27520	\N
3628	42	1	0	27531	\N
3628	1100	2	0	27532	\N
3352	16	3	0	27972	\N
3352	359	4	0	27973	\N
3364	16	1	0	27974	\N
3364	17	2	0	27977	\N
3550	449	0	0	29804	\N
3367	1057	1	0	29948	\N
3367	1058	2	0	29949	\N
3506	202	0	0	31062	\N
3355	360	2	0	31452	\N
3355	510	3	0	31455	\N
3601	360	0	0	31464	\N
3637	322	3	0	32334	\N
3637	1105	4	0	32337	\N
3440	1	0	0	33785	\N
3441	1	0	0	33796	\N
3444	112	3	0	33800	\N
3503	1	1	0	33812	\N
3512	1	0	0	33813	\N
3503	1085	2	0	33814	\N
3529	1	1	0	33817	\N
3529	1085	2	0	33818	\N
3541	1	0	0	33820	\N
3571	1	0	0	33823	\N
3599	1	0	0	33826	\N
3639	1	0	0	33830	\N
3373	2	5	0	35374	\N
3373	1060	6	0	35375	\N
3412	4	0	0	36025	\N
3532	8	2	0	36469	\N
3532	1094	3	0	36470	\N
3415	10	1	0	37523	\N
3415	11	2	0	37524	\N
3491	10	0	0	37538	\N
3524	10	0	0	37542	\N
3534	10	0	0	37543	\N
3549	10	0	0	37544	\N
3551	10	0	0	37545	\N
3553	10	0	0	37546	\N
3565	10	0	0	37555	\N
3609	10	0	0	37579	\N
3397	18	1	0	39714	\N
3397	19	2	0	39716	\N
3574	18	0	0	39720	\N
3521	23	1	0	40651	\N
3521	1089	2	0	40652	\N
3515	27	0	0	41141	\N
3536	27	0	0	41142	\N
3439	40	0	0	42019	\N
3518	40	0	0	42035	\N
3542	40	0	0	42055	\N
3589	40	0	0	42056	\N
3241	51	3	0	43534	\N
3698	56	1	0	43802	\N
3698	57	2	0	43805	\N
3575	75	0	0	45458	\N
3670	75	1	0	45460	\N
3670	76	2	0	45461	\N
3594	79	0	0	46396	\N
3598	79	0	0	46397	\N
3623	79	0	0	46441	\N
3659	79	0	0	46505	\N
3680	79	1	0	46554	\N
3680	81	2	0	46557	\N
3614	119	0	0	48519	\N
3696	135	3	0	49460	\N
3696	1113	4	0	49461	\N
3695	137	3	0	49773	\N
3695	1112	4	0	49778	\N
3618	147	0	0	49966	\N
3596	181	0	0	50860	\N
3641	181	0	0	50866	\N
3661	186	0	0	51269	\N
3662	186	0	0	51270	\N
3660	186	0	0	51271	\N
3588	210	0	0	51792	\N
3690	210	1	0	51797	\N
3690	211	2	0	51800	\N
3643	242	0	0	52111	\N
3663	242	0	0	52123	\N
3582	268	0	0	52750	\N
3569	273	0	0	52945	\N
3656	338	0	0	53745	\N
3691	338	1	0	53748	\N
3691	409	2	0	53750	\N
3554	316	0	0	53931	\N
3685	316	3	0	53937	\N
3685	555	4	0	53938	\N
3557	353	0	0	54558	\N
3578	435	0	0	54971	\N
3638	435	0	0	54972	\N
3683	435	1	0	54973	\N
3683	436	2	0	54974	\N
3684	451	3	0	55287	\N
3684	826	4	0	55290	\N
3620	595	0	0	55570	\N
3621	597	0	0	55887	\N
3657	1109	0	0	56182	\N
3692	1109	1	0	56183	\N
3692	1111	2	0	56185	\N
3555	841	0	0	56917	\N
3617	908	0	0	57543	\N
3626	251	0	0	1495	\N
3634	117	0	0	1971	\N
3689	117	1	0	1978	\N
3689	248	2	0	1979	\N
3651	262	0	0	3812	\N
3560	35	0	0	4167	\N
3590	391	0	0	10246	\N
3687	391	2	0	10251	\N
3687	406	3	0	10252	\N
3564	132	0	0	11169	\N
3682	108	1	0	11675	\N
3682	109	2	0	11676	\N
3602	300	0	0	12025	\N
3587	256	0	0	13350	\N
3671	256	1	0	13351	\N
3671	257	2	0	13352	\N
3675	258	1	0	14433	\N
3675	309	2	0	14435	\N
3584	38	0	0	16368	\N
3597	38	0	0	16369	\N
3611	115	0	0	16645	\N
3654	115	0	0	16646	\N
3694	167	1	0	17678	\N
3694	533	2	0	17679	\N
3570	30	0	0	17997	\N
3640	1106	6	0	18001	\N
3558	142	0	0	18472	\N
3649	1107	0	0	19339	\N
3567	60	0	0	19443	\N
3648	60	0	0	19448	\N
3576	198	0	0	20005	\N
3572	1098	0	0	20329	\N
3635	488	3	0	21402	\N
3635	1103	4	0	21403	\N
3664	488	0	0	21410	\N
3653	145	1	0	21910	\N
3653	1108	2	0	21912	\N
3673	73	1	0	22477	\N
3673	74	2	0	22486	\N
3619	336	0	0	22714	\N
3645	82	0	0	23771	\N
3652	82	0	0	23776	\N
3669	214	3	0	24370	\N
3669	1110	4	0	24371	\N
3677	206	1	0	25755	\N
3677	207	2	0	25759	\N
3627	1099	0	0	26269	\N
3655	94	0	0	26723	\N
3566	244	0	0	27228	\N
3538	16	0	0	27981	\N
3606	16	0	0	27983	\N
3679	16	1	0	27984	\N
3679	17	2	0	27985	\N
3688	16	2	0	27986	\N
3688	155	3	0	27991	\N
3561	449	0	0	29812	\N
3644	202	1	0	31063	\N
3644	203	2	0	31064	\N
3674	360	1	0	31465	\N
3674	479	2	0	31470	\N
3650	230	0	0	32041	\N
3629	1	0	0	33829	\N
3665	1	1	0	33833	\N
3668	1	0	0	33834	\N
3665	53	2	0	33835	\N
3676	1	1	0	33838	\N
3676	53	2	0	33839	\N
3681	1	1	0	33844	\N
3681	53	2	0	33845	\N
3699	1	1	0	33851	\N
3699	53	2	0	33854	\N
3573	2	0	0	35446	\N
3593	2	0	0	35468	\N
3632	1101	3	0	36329	\N
3636	8	3	0	36471	\N
3636	1104	4	0	36474	\N
3563	10	0	0	37547	\N
3581	10	0	0	37563	\N
3591	10	0	0	37575	\N
3600	10	0	0	37578	\N
3612	10	0	0	37580	\N
3666	10	1	0	37581	\N
3666	11	2	0	37582	\N
3667	10	0	0	37590	\N
3686	10	2	0	37591	\N
3697	11	2	0	37593	\N
3686	29	3	0	37594	\N
3700	10	1	0	37596	\N
3700	11	2	0	37597	\N
3647	14	0	0	39181	\N
3678	14	1	0	39188	\N
3678	15	2	0	39189	\N
3556	18	0	0	39719	\N
3579	18	0	0	39721	\N
3631	18	0	0	39723	\N
3693	18	1	0	39724	\N
3693	19	2	0	39725	\N
3821	40	1	0	42193	\N
3821	41	2	0	42194	\N
3718	56	1	0	43803	\N
3832	56	4	0	43804	\N
3718	57	2	0	43806	\N
3832	1145	5	0	43807	\N
3722	88	1	0	47286	\N
3722	89	2	0	47287	\N
3846	100	2	0	47562	\N
3846	101	3	0	47564	\N
3855	100	4	0	47571	\N
3855	448	5	0	47579	\N
3898	119	1	0	48581	\N
3898	120	2	0	48582	\N
3799	125	1	0	49233	\N
3799	195	2	0	49234	\N
3736	135	2	0	49476	\N
3736	196	3	0	49477	\N
3780	137	1	0	49775	\N
3780	138	2	0	49776	\N
3794	156	1	0	50212	\N
3794	157	2	0	50213	\N
3720	1121	3	0	50540	\N
3716	170	1	0	50550	\N
3716	398	2	0	50551	\N
3720	170	12	0	50552	\N
3720	1122	13	0	50553	\N
3768	200	2	0	51491	\N
3768	887	3	0	51493	\N
3713	338	1	0	53749	\N
3713	409	2	0	53751	\N
3872	316	1	0	53946	\N
3872	317	2	0	53950	\N
3711	324	2	0	54261	\N
3711	486	3	0	54262	\N
3835	435	1	0	54975	\N
3835	436	2	0	54976	\N
3704	943	1	0	55525	\N
3704	1119	3	0	55526	\N
3714	1109	1	0	56184	\N
3714	1111	2	0	56186	\N
3903	908	2	0	57548	\N
3903	988	3	0	57555	\N
3775	1131	2	0	57824	\N
3760	400	2	0	32	\N
3831	1144	3	0	36	\N
3829	12	1	0	286	\N
3829	13	2	0	288	\N
3906	117	2	0	1983	\N
3906	175	3	0	1985	\N
3797	228	1	0	2864	\N
3797	229	2	0	2867	\N
3826	1143	113	1	5152	\N
3826	1140	81	0	5153	\N
3826	1141	112	0	5156	\N
3717	373	1	0	5316	\N
3717	374	2	0	5318	\N
3879	392	2	0	10275	\N
3707	132	1	0	11170	\N
3707	455	2	0	11171	\N
3738	348	1	0	12316	\N
3738	1123	2	0	12318	\N
3705	123	1	0	12768	\N
3705	124	2	0	12769	\N
3790	123	4	0	12794	\N
3790	1133	5	0	12796	\N
3930	58	2	0	13456	\N
3896	1157	1	0	14004	\N
3896	1158	2	0	14005	\N
3704	1116	1	0	14998	\N
3706	92	1	0	14999	\N
3706	191	2	0	15003	\N
3704	1118	2	1	15221	\N
3870	192	1	0	15326	\N
3870	193	2	0	15327	\N
3702	1115	3	0	16640	\N
3703	1115	3	0	16641	\N
3702	115	4	0	16648	\N
3703	115	4	0	16649	\N
3805	142	3	0	18473	\N
3805	1134	4	0	18476	\N
3807	60	1	0	19457	\N
3807	61	2	0	19458	\N
3710	145	2	0	21944	\N
3710	331	3	0	21947	\N
3747	140	2	0	24047	\N
3747	487	3	0	24048	\N
3854	214	1	0	24410	\N
3854	215	2	0	24411	\N
3725	69	1	0	24664	\N
3777	69	0	0	24669	\N
3725	70	2	0	24675	\N
3887	1153	2	0	24947	\N
3920	411	1	0	25185	\N
3920	412	2	0	25186	\N
3847	224	1	0	25507	\N
3891	224	0	0	25509	\N
3847	225	2	0	25511	\N
3889	224	2	0	25516	\N
3889	508	3	0	25517	\N
3925	206	2	0	25756	\N
3925	693	3	0	25760	\N
3826	1142	113	0	26268	\N
3786	95	2	0	26724	\N
3786	94	3	0	26727	\N
3792	526	2	0	29199	\N
3927	320	62	0	29383	\N
3927	1160	63	0	29384	\N
3877	20	1	0	30435	\N
3877	144	2	0	30436	\N
3733	202	1	0	31070	\N
3733	203	2	0	31072	\N
3893	202	1	0	31078	\N
3893	203	2	0	31079	\N
3709	230	4	0	32049	\N
3709	1120	5	0	32050	\N
3701	1114	3	0	33846	\N
3812	1	2	0	33896	\N
3812	112	3	0	33899	\N
3838	1	1	0	33904	\N
3838	53	2	0	33905	\N
3862	1	1	0	33915	\N
3862	53	2	0	33917	\N
3922	1	1	0	33959	\N
3922	53	2	0	33960	\N
3708	2	1	0	35490	\N
3708	26	2	0	35491	\N
3712	10	2	0	37600	\N
3729	10	1	0	37601	\N
3712	29	3	0	37603	\N
3741	10	1	0	37611	\N
3741	11	2	0	37612	\N
3817	10	1	0	37631	\N
3817	11	2	0	37632	\N
3824	10	2	0	37636	\N
3824	29	3	0	37638	\N
3884	10	2	0	37651	\N
3884	29	3	0	37655	\N
3782	383	2	0	39190	\N
3785	383	2	0	39192	\N
3782	14	3	0	39209	\N
3852	23	1	0	40659	\N
3852	217	2	0	40664	\N
3715	40	1	0	42079	\N
3715	41	2	0	42080	\N
3731	40	1	0	42097	\N
3731	41	2	0	42099	\N
3869	40	1	0	42213	\N
3869	41	2	0	42214	\N
3981	40	1	0	42251	\N
3981	41	2	0	42255	\N
3937	56	1	0	43808	\N
3937	57	2	0	43809	\N
3745	71	2	0	44755	\N
3745	1125	3	0	44760	\N
3932	75	2	0	45478	\N
3932	159	3	0	45481	\N
3947	75	1	0	45490	\N
3947	76	2	0	45491	\N
3998	75	2	0	45501	\N
3998	159	3	0	45503	\N
3753	79	1	0	46552	\N
3753	81	2	0	46553	\N
3845	100	2	0	47561	\N
3845	101	3	0	47563	\N
3770	113	1	0	48282	\N
3770	437	2	0	48283	\N
3781	135	1	0	49484	\N
3781	136	2	0	49487	\N
3814	137	2	0	49793	\N
3814	197	3	0	49794	\N
3951	137	1	0	49808	\N
3951	138	2	0	49811	\N
3905	200	1	0	51500	\N
3905	201	2	0	51501	\N
3816	210	1	0	51798	\N
3816	211	2	0	51801	\N
3806	242	3	0	52124	\N
3806	1135	4	0	52125	\N
3944	242	2	0	52155	\N
3944	620	3	0	52158	\N
3828	268	1	0	52753	\N
3828	269	2	0	52754	\N
3991	268	1	0	52764	\N
3991	269	2	0	52767	\N
3956	273	1	0	52973	\N
3956	410	2	0	52974	\N
3900	285	1	0	53413	\N
3900	286	2	0	53414	\N
3967	324	2	0	54282	\N
3967	486	3	0	54283	\N
3840	1119	127	1	55531	\N
3974	1021	1	0	56537	\N
3974	1022	2	0	56539	\N
3940	852	0	0	57223	\N
3942	852	1	0	57224	\N
3942	913	2	0	57225	\N
3823	821	3	0	545	\N
3849	175	3	0	1984	\N
3958	237	1	0	3592	\N
3958	527	2	0	3593	\N
3962	35	1	0	4173	\N
3962	340	2	0	4176	\N
3964	189	1	0	4876	\N
3966	189	6	0	4877	\N
3964	190	2	0	4880	\N
3966	1165	7	0	4882	\N
3748	108	1	0	11677	\N
3748	109	2	0	11678	\N
3972	300	1	0	12031	\N
3789	77	4	0	13121	\N
3789	1132	5	0	13123	\N
3948	256	1	0	13353	\N
3948	257	2	0	13354	\N
3857	58	1	0	13449	\N
3857	59	2	0	13451	\N
3930	665	3	0	13460	\N
3859	233	1	0	13799	\N
3859	234	2	0	13803	\N
3734	258	1	0	14434	\N
3734	309	2	0	14436	\N
3766	92	2	0	15000	\N
3934	167	1	0	17694	\N
3934	533	2	0	17695	\N
3910	290	0	0	18981	\N
3914	290	0	0	18983	\N
3788	60	2	0	19449	\N
3788	166	3	0	19450	\N
3727	198	1	0	20006	\N
3818	198	1	0	20007	\N
3727	199	2	0	20009	\N
3818	199	2	0	20010	\N
3743	164	2	0	21048	\N
3743	1124	3	0	21052	\N
3969	270	2	0	23461	\N
4000	82	1	0	23784	\N
4000	83	2	0	23788	\N
3929	214	2	0	24424	\N
3929	227	3	0	24425	\N
3986	214	1	0	24450	\N
3986	215	2	0	24451	\N
3773	69	0	0	24666	\N
3804	69	3	0	24670	\N
3843	69	2	0	24672	\N
3843	500	3	0	24679	\N
3804	594	4	0	24680	\N
3983	207	2	0	25777	\N
3779	244	1	0	27240	\N
3779	245	2	0	27242	\N
3840	1147	127	0	29203	\N
3840	1146	81	0	29367	\N
3924	320	2	0	29373	\N
3924	321	3	0	29375	\N
3840	320	126	0	29378	\N
3758	449	2	0	29813	\N
3758	583	3	0	29816	\N
3917	230	1	0	32059	\N
3917	287	2	0	32060	\N
3763	53	2	0	33869	\N
3796	1	1	0	33875	\N
3796	53	2	0	33876	\N
3809	1	1	0	33888	\N
3809	53	2	0	33889	\N
3874	1	1	0	33929	\N
3874	53	2	0	33931	\N
3908	1	2	0	33949	\N
3908	112	3	0	33955	\N
3945	1	3	0	33965	\N
3945	1114	4	0	33966	\N
3953	1	1	0	33973	\N
3971	1	1	0	33977	\N
3971	53	2	0	33978	\N
3984	4	2	0	36039	\N
3984	579	3	0	36040	\N
3867	10	2	0	37642	\N
3867	29	3	0	37644	\N
3881	10	1	0	37647	\N
3881	11	2	0	37648	\N
3895	10	2	0	37653	\N
3895	29	3	0	37656	\N
3936	10	1	0	37667	\N
3936	11	2	0	37668	\N
3979	10	1	0	37672	\N
3976	11	2	0	37673	\N
3979	11	2	0	37674	\N
3995	10	1	0	37678	\N
3995	11	2	0	37682	\N
3719	18	1	0	39726	\N
3902	18	1	0	39728	\N
3719	19	2	0	39729	\N
3902	19	2	0	39731	\N
3997	27	1	0	41172	\N
3997	28	2	0	41173	\N
3755	40	1	0	42140	\N
4012	51	2	0	43538	\N
4012	524	3	0	43544	\N
3949	56	3	0	43812	\N
3949	475	4	0	43813	\N
3865	71	3	0	44756	\N
3865	397	4	0	44763	\N
3802	75	2	0	45477	\N
3802	159	3	0	45480	\N
3965	75	1	0	45500	\N
3965	76	2	0	45502	\N
3959	79	1	0	46606	\N
3959	81	2	0	46607	\N
3746	88	2	0	47292	\N
3746	154	3	0	47299	\N
3907	100	2	0	47572	\N
3907	101	3	0	47578	\N
3761	113	1	0	48272	\N
3761	437	2	0	48273	\N
3954	113	1	0	48292	\N
3954	437	2	0	48294	\N
3815	135	2	0	49485	\N
3815	196	3	0	49489	\N
4028	135	1	0	49497	\N
4028	136	2	0	49500	\N
3735	137	2	0	49774	\N
3735	197	3	0	49777	\N
3970	156	1	0	50218	\N
4033	156	1	0	50219	\N
3970	157	2	0	50220	\N
4033	157	2	0	50221	\N
4004	170	1	0	50569	\N
4004	398	2	0	50570	\N
3938	242	2	0	52147	\N
3938	620	3	0	52148	\N
3810	273	1	0	52952	\N
3875	273	1	0	52953	\N
3810	410	2	0	52954	\N
3875	410	2	0	52955	\N
3911	273	2	0	52972	\N
3911	1159	3	0	52975	\N
3764	362	2	0	54785	\N
3764	420	3	0	54786	\N
3756	451	2	0	55288	\N
3756	452	3	0	55289	\N
3827	1021	2	0	56523	\N
3827	1048	3	0	56524	\N
3833	793	2	0	56646	\N
3833	1136	3	0	56648	\N
3897	692	2	0	1797	\N
4021	175	3	0	1993	\N
3918	228	1	0	2865	\N
3918	229	2	0	2868	\N
3878	35	1	0	4172	\N
3878	340	2	0	4175	\N
3993	365	1	0	4485	\N
3993	366	2	0	4487	\N
3868	1151	2	0	5183	\N
3868	1152	3	0	5187	\N
3723	391	1	0	10255	\N
3723	392	2	0	10256	\N
3943	391	2	0	10274	\N
3977	391	1	0	10280	\N
3977	392	2	0	10281	\N
4016	233	1	0	13800	\N
4016	234	2	0	13804	\N
3850	402	2	0	14057	\N
3850	1148	3	0	14059	\N
3968	173	1	0	14621	\N
3968	396	2	0	14624	\N
4038	92	1	0	15013	\N
4038	191	2	0	15014	\N
4026	192	1	0	15337	\N
4026	193	2	0	15338	\N
3941	327	2	0	17317	\N
3963	30	1	0	17984	\N
3963	418	2	0	17987	\N
3913	290	0	0	18982	\N
3926	62	2	0	19707	\N
3926	683	3	0	19712	\N
3836	198	2	0	20016	\N
3836	746	3	0	20017	\N
4009	198	1	0	20031	\N
4009	199	2	0	20032	\N
3739	67	1	0	22177	\N
3739	478	2	0	22178	\N
4018	356	2	0	22717	\N
3769	149	2	0	23057	\N
3769	697	3	0	23058	\N
3776	69	0	0	24668	\N
3888	224	0	0	25508	\N
3961	206	1	0	25774	\N
3961	207	2	0	25776	\N
3819	1137	1	0	27175	\N
3819	1138	2	0	27176	\N
3839	320	1	0	29372	\N
3839	334	2	0	29374	\N
3737	54	1	0	29997	\N
3923	151	2	0	30665	\N
3923	576	3	0	30670	\N
3721	1	1	0	33852	\N
3744	1	2	0	33853	\N
3721	53	2	0	33855	\N
3744	283	3	0	33856	\N
3841	1	1	0	33910	\N
3841	53	2	0	33911	\N
3858	1	1	0	33914	\N
3858	53	2	0	33916	\N
3863	1	3	0	33920	\N
3863	48	4	0	33921	\N
3899	1	1	0	33947	\N
3901	1	1	0	33948	\N
3899	53	2	0	33951	\N
3901	53	2	0	33952	\N
3894	112	3	0	33954	\N
3946	1	5	0	33969	\N
3946	1162	6	0	33970	\N
3973	1	1	0	33981	\N
3973	53	2	0	33985	\N
3800	2	2	0	35509	\N
3800	131	3	0	35512	\N
3935	6	1	0	36338	\N
3935	194	2	0	36340	\N
3988	194	2	0	36341	\N
3732	10	1	0	37606	\N
3732	11	2	0	37607	\N
3771	10	1	0	37621	\N
3771	11	2	0	37623	\N
3844	10	2	0	37641	\N
3844	29	3	0	37643	\N
3885	10	1	0	37652	\N
3885	11	2	0	37654	\N
3783	383	2	0	39191	\N
3882	14	1	0	39207	\N
3783	14	3	0	39210	\N
3921	14	1	0	39221	\N
3921	15	2	0	39223	\N
3730	23	1	0	40658	\N
3730	217	2	0	40663	\N
3860	27	1	0	41157	\N
3860	28	2	0	41158	\N
4014	27	2	0	41196	\N
4014	619	3	0	41202	\N
3749	40	2	0	42098	\N
3749	66	3	0	42100	\N
3751	40	1	0	42118	\N
3795	40	1	0	42175	\N
3795	41	2	0	42176	\N
3909	40	1	0	42228	\N
3909	41	2	0	42229	\N
251	56	0	0	43671	\N
3939	56	2	0	43810	\N
3939	169	3	0	43811	\N
3754	75	1	0	45476	\N
3754	76	2	0	45479	\N
3752	79	1	0	46555	\N
3752	1126	2	0	46556	\N
3767	79	2	0	46605	\N
3767	80	3	0	46608	\N
3994	79	1	0	46649	\N
3994	81	2	0	46650	\N
3724	100	1	0	47549	\N
3724	160	2	0	47550	\N
3834	102	2	0	47786	\N
3834	158	3	0	47789	\N
3955	119	1	0	48612	\N
3955	120	2	0	48614	\N
3952	135	1	0	49486	\N
3952	136	2	0	49488	\N
4027	137	1	0	49809	\N
4027	138	2	0	49812	\N
3757	186	2	0	51286	\N
3757	696	3	0	51287	\N
3880	186	1	0	51293	\N
3880	187	2	0	51294	\N
3904	242	2	0	52130	\N
3904	620	3	0	52131	\N
3990	268	1	0	52763	\N
3990	269	2	0	52766	\N
3742	316	1	0	53945	\N
3742	317	2	0	53949	\N
3801	324	2	0	54274	\N
3801	486	3	0	54275	\N
4005	353	1	0	54559	\N
4005	354	2	0	54561	\N
4034	362	1	0	54789	\N
4034	395	2	0	54793	\N
3813	793	2	0	56645	\N
3813	1136	3	0	56647	\N
3866	793	1	0	56655	\N
3866	1150	2	0	56656	\N
3931	841	2	0	56927	\N
3931	1161	3	0	56931	\N
3989	366	2	0	4486	\N
3853	392	2	0	10266	\N
3992	391	1	0	10287	\N
3992	392	2	0	10291	\N
3765	77	2	0	13120	\N
3765	216	3	0	13122	\N
3883	77	2	0	13134	\N
3883	216	3	0	13135	\N
3861	58	1	0	13455	\N
3957	58	1	0	13457	\N
3861	59	2	0	13458	\N
3957	59	2	0	13459	\N
3740	173	1	0	14620	\N
3978	38	2	0	16370	\N
3978	39	3	0	16371	\N
3759	1128	3	0	17084	\N
3726	326	1	0	17310	\N
3848	326	1	0	17311	\N
3726	327	2	0	17315	\N
3848	327	2	0	17316	\N
3759	1127	2	0	18002	\N
3759	1129	3	0	18010	\N
3873	290	1	0	18980	\N
3916	290	0	0	18985	\N
3873	291	2	0	18986	\N
3912	575	3	0	19000	\N
3825	198	2	0	20008	\N
3825	1139	3	0	20011	\N
3933	64	1	0	20763	\N
3933	65	2	0	20764	\N
3975	64	1	0	20771	\N
3975	65	2	0	20772	\N
3980	64	1	0	20779	\N
3980	65	2	0	20783	\N
3803	67	1	0	22183	\N
3803	478	2	0	22184	\N
3851	73	2	0	22478	\N
3864	82	3	0	23782	\N
3876	82	1	0	23783	\N
3876	83	2	0	23787	\N
3864	810	4	0	23791	\N
3837	140	1	0	24053	\N
3837	141	2	0	24054	\N
3728	214	1	0	24386	\N
3728	215	2	0	24387	\N
3772	69	1	0	24665	\N
3774	69	0	0	24667	\N
3842	69	2	0	24671	\N
4022	69	2	0	24673	\N
3842	500	3	0	24678	\N
4022	1166	3	0	24681	\N
3890	1155	0	0	24919	\N
3890	1156	0	0	25506	\N
3892	224	0	0	25510	\N
3996	785	1	0	26312	\N
3996	786	2	0	26314	\N
3791	525	0	0	29197	\N
3960	1163	1	0	30934	\N
3960	1164	2	0	30936	\N
3856	202	4	0	31071	\N
3856	1149	5	0	31073	\N
4008	203	2	0	31086	\N
3750	1	2	0	33866	\N
3787	1	1	0	33868	\N
3787	53	2	0	33870	\N
3750	112	3	0	33871	\N
3798	1	1	0	33882	\N
3798	53	2	0	33883	\N
3811	1	1	0	33892	\N
3811	53	2	0	33893	\N
3822	1	1	0	33897	\N
3822	53	2	0	33898	\N
3871	1	1	0	33928	\N
3886	1	1	0	33942	\N
3886	53	2	0	33943	\N
3919	1	1	0	33950	\N
3919	53	2	0	33953	\N
3830	8	2	0	36472	\N
3830	278	3	0	36476	\N
3762	10	1	0	37617	\N
3762	11	2	0	37618	\N
3778	10	1	0	37622	\N
3778	11	2	0	37624	\N
3808	10	1	0	37627	\N
3808	11	2	0	37628	\N
3820	11	2	0	37637	\N
3928	10	1	0	37663	\N
3928	11	2	0	37664	\N
3987	10	1	0	37677	\N
3987	11	2	0	37681	\N
4025	10	1	0	37695	\N
4025	11	2	0	37696	\N
3950	14	1	0	39222	\N
3950	15	2	0	39224	\N
3982	14	1	0	39237	\N
4001	14	1	0	39238	\N
3982	15	2	0	39239	\N
3793	18	1	0	39727	\N
3793	19	2	0	39730	\N
3985	23	2	0	40660	\N
3985	24	3	0	40665	\N
3784	66	2	0	42142	\N
4068	40	1	0	42252	\N
4095	40	1	0	42253	\N
4068	41	2	0	42256	\N
4095	41	2	0	42257	\N
4013	56	2	0	43814	\N
4013	169	3	0	43815	\N
4039	56	1	0	43816	\N
4039	57	2	0	43817	\N
4096	56	1	0	43818	\N
4096	57	2	0	43820	\N
4080	71	2	0	44757	\N
4080	401	3	0	44762	\N
4041	75	3	0	45510	\N
4041	857	4	0	45512	\N
4056	79	3	0	46683	\N
4056	1168	4	0	46684	\N
4045	88	1	0	47293	\N
4045	89	2	0	47296	\N
4081	125	2	0	49243	\N
4081	188	3	0	49244	\N
4020	210	2	0	51799	\N
4020	458	3	0	51802	\N
4061	260	1	0	52401	\N
4061	261	2	0	52402	\N
4050	316	1	0	53947	\N
4050	317	2	0	53951	\N
4058	389	1	0	54929	\N
4058	390	2	0	54934	\N
4063	793	3	0	56661	\N
4063	1169	4	0	56662	\N
4035	841	1	0	56928	\N
4035	842	2	0	56930	\N
4076	852	1	0	57228	\N
4076	913	2	0	57229	\N
4083	908	1	0	57549	\N
4083	909	2	0	57552	\N
4074	400	2	0	42	\N
4089	312	3	0	561	\N
4047	424	3	0	752	\N
4047	468	4	0	753	\N
4073	365	1	0	4496	\N
4073	366	2	0	4498	\N
4054	1151	2	0	5184	\N
4054	1152	3	0	5188	\N
4017	132	1	0	11178	\N
4065	132	1	0	11179	\N
4017	455	2	0	11183	\N
4065	455	2	0	11184	\N
4079	402	2	0	14073	\N
4060	396	1	0	14615	\N
4060	173	2	0	14625	\N
4082	173	1	0	14632	\N
4082	396	2	0	14633	\N
4011	92	2	0	15001	\N
4015	92	1	0	15002	\N
4015	191	2	0	15004	\N
4011	93	3	0	15006	\N
4072	235	1	0	15627	\N
4072	236	2	0	15631	\N
4077	38	1	0	16377	\N
4077	399	2	0	16378	\N
4002	213	2	0	17108	\N
4046	413	1	0	18356	\N
4046	414	2	0	18357	\N
4094	142	1	0	18474	\N
4094	143	2	0	18475	\N
4093	208	1	0	19266	\N
4093	209	2	0	19267	\N
4097	208	2	0	19271	\N
4049	164	1	0	21049	\N
4052	164	2	0	21050	\N
4049	165	2	0	21051	\N
4052	226	3	0	21053	\N
4071	489	2	0	21414	\N
4036	149	1	0	23065	\N
4036	499	2	0	23066	\N
4019	82	1	0	23785	\N
4024	82	1	0	23786	\N
4019	83	2	0	23789	\N
4024	83	2	0	23790	\N
4032	930	1	0	23918	\N
4032	931	2	0	23923	\N
4003	214	1	0	24477	\N
4003	215	2	0	24478	\N
4084	214	1	0	24500	\N
4088	214	1	0	24519	\N
4088	215	2	0	24520	\N
4057	69	1	0	24690	\N
4057	70	2	0	24691	\N
4086	49	1	0	25042	\N
4086	50	2	0	25043	\N
4053	224	2	0	25523	\N
4087	224	1	0	25524	\N
4087	225	2	0	25527	\N
4053	508	3	0	25529	\N
4092	1171	5	0	26274	\N
4092	1172	6	0	26277	\N
4055	1167	3	0	26289	\N
4031	151	1	0	30666	\N
4031	302	2	0	30668	\N
4029	322	1	0	32335	\N
4029	323	2	0	32336	\N
4091	322	5	0	32339	\N
4091	1170	6	0	32340	\N
4010	1	0	0	33982	\N
4037	1	0	0	33983	\N
4042	1	2	0	33984	\N
4042	112	3	0	33986	\N
4043	1	1	0	33991	\N
4048	1	1	0	34003	\N
4048	53	2	0	34004	\N
4051	1	1	0	34007	\N
4051	53	2	0	34008	\N
4059	53	1	0	34009	\N
4064	1	1	0	34014	\N
4059	1	2	0	34015	\N
4064	53	2	0	34016	\N
4067	1	1	0	34019	\N
4067	53	2	0	34020	\N
4070	1	1	0	34023	\N
4075	1	1	0	34024	\N
4070	53	2	0	34027	\N
4075	53	2	0	34028	\N
4085	53	2	0	34029	\N
4023	2	1	0	35510	\N
4023	26	2	0	35511	\N
4069	2	2	0	35519	\N
4069	131	3	0	35520	\N
4090	2	2	0	35526	\N
4090	471	3	0	35527	\N
4078	4	2	0	36053	\N
4078	579	3	0	36056	\N
4040	8	3	0	36473	\N
3999	10	1	0	37679	\N
4006	10	2	0	37680	\N
3999	11	2	0	37683	\N
4006	29	3	0	37684	\N
4007	10	1	0	37691	\N
4007	11	2	0	37692	\N
4030	10	1	0	37701	\N
4044	10	1	0	37702	\N
4062	10	3	0	37703	\N
4066	10	1	0	37704	\N
4030	11	2	0	37705	\N
4044	11	2	0	37706	\N
4062	347	4	0	37708	\N
4100	40	1	0	42254	\N
4100	41	2	0	42258	\N
4107	40	2	0	42295	\N
4107	569	3	0	42296	\N
4108	40	1	0	42312	\N
4108	41	2	0	42313	\N
4165	40	2	0	42424	\N
4165	569	3	0	42425	\N
4186	56	3	0	43824	\N
4216	56	1	0	43825	\N
4216	57	2	0	43828	\N
4186	1188	4	0	43830	\N
4322	75	1	0	45527	\N
4322	76	2	0	45528	\N
4104	79	2	0	46720	\N
4137	79	1	0	46721	\N
4137	81	2	0	46722	\N
4104	472	3	0	46723	\N
4222	79	1	0	46750	\N
4222	81	2	0	46751	\N
4202	88	1	0	47294	\N
4202	89	2	0	47297	\N
4141	119	2	0	48650	\N
4141	891	3	0	48651	\N
4291	121	1	0	48910	\N
4291	122	2	0	48911	\N
4303	135	1	0	49498	\N
4303	136	2	0	49501	\N
4117	1177	113	0	51502	\N
4117	200	126	0	51515	\N
4117	1178	127	0	51516	\N
4103	210	2	0	51809	\N
4103	1173	3	0	51810	\N
4110	268	1	0	52765	\N
4110	269	2	0	52768	\N
4138	362	9	0	54790	\N
4138	1179	10	0	54796	\N
4310	1109	1	0	56220	\N
4310	1111	2	0	56223	\N
4153	793	1	0	56677	\N
4218	793	1	0	56678	\N
4288	793	3	0	56679	\N
4153	1150	2	0	56682	\N
4218	1150	2	0	56683	\N
4288	1169	4	0	56684	\N
4332	13	2	0	294	\N
4220	220	1	0	550	\N
4160	221	2	0	556	\N
4220	221	2	0	557	\N
4112	46	1	0	650	\N
4112	839	2	0	656	\N
4125	266	1	0	1163	\N
4125	267	2	0	1167	\N
4146	228	1	0	2866	\N
4146	229	2	0	2869	\N
4151	228	1	0	2886	\N
4151	229	2	0	2887	\N
4116	35	2	0	4174	\N
4170	35	1	0	4182	\N
4170	340	2	0	4183	\N
4327	365	1	0	4497	\N
4327	366	2	0	4499	\N
4099	391	2	0	10288	\N
4099	406	3	0	10293	\N
4286	132	3	0	11181	\N
4286	814	4	0	11186	\N
4191	108	2	0	11681	\N
4191	501	3	0	11691	\N
4149	459	1	0	11955	\N
4149	460	2	0	11957	\N
4228	355	2	0	12037	\N
4243	77	1	0	13142	\N
4243	78	2	0	13144	\N
4279	58	2	0	13465	\N
4279	665	3	0	13468	\N
4172	173	1	0	14636	\N
4172	396	2	0	14637	\N
4111	44	1	0	16061	\N
4111	45	2	0	16065	\N
4272	290	1	0	19012	\N
4272	291	2	0	19013	\N
4097	854	3	0	19272	\N
4106	1175	3	0	20390	\N
4155	164	1	0	21062	\N
4155	165	2	0	21063	\N
4256	164	1	0	21084	\N
4256	165	2	0	21086	\N
4234	73	1	0	22479	\N
4234	74	2	0	22487	\N
4194	264	6	0	23466	\N
4197	264	2	0	23467	\N
4197	265	3	0	23468	\N
4194	1193	7	0	23469	\N
4245	1204	65	0	24055	\N
4245	1205	82	0	24066	\N
4330	69	1	0	24714	\N
4330	70	2	0	24716	\N
4098	49	2	0	25044	\N
4098	328	3	0	25045	\N
4179	49	2	0	25048	\N
4179	1183	3	0	25049	\N
4123	411	1	0	25192	\N
4123	412	2	0	25193	\N
4209	224	1	0	25525	\N
4209	225	2	0	25528	\N
4258	244	1	0	27241	\N
4334	244	2	0	27252	\N
4334	438	3	0	27253	\N
4298	42	0	0	27521	\N
4114	151	1	0	30685	\N
4114	302	2	0	30687	\N
4115	202	1	0	31085	\N
4115	203	2	0	31087	\N
4284	202	3	0	31106	\N
4284	987	4	0	31107	\N
4181	360	0	0	31468	\N
4231	1	4	0	34043	\N
4231	422	5	0	34047	\N
4281	53	2	0	34055	\N
4296	1	1	0	34057	\N
4296	53	2	0	34059	\N
4315	1	3	0	34064	\N
4315	48	4	0	34066	\N
4162	6	1	0	36350	\N
4236	6	1	0	36351	\N
4162	194	2	0	36352	\N
4236	194	2	0	36353	\N
4174	8	1	0	36479	\N
4174	9	2	0	36482	\N
4101	10	1	0	37712	\N
4109	10	2	0	37714	\N
4101	11	2	0	37715	\N
4109	275	3	0	37716	\N
4102	792	3	0	37717	\N
4250	10	2	0	37765	\N
4250	29	3	0	37766	\N
4305	10	2	0	37795	\N
4305	792	3	0	37796	\N
4113	14	1	0	39253	\N
4207	14	1	0	39254	\N
4113	15	2	0	39255	\N
4207	15	2	0	39256	\N
4232	1201	6	0	39262	\N
4105	18	3	0	39732	\N
4105	1174	4	0	39735	\N
4130	23	2	0	40661	\N
4130	24	3	0	40666	\N
4120	40	2	0	42326	\N
4120	66	3	0	42327	\N
4161	40	1	0	42402	\N
4161	41	2	0	42404	\N
4187	1189	4	0	42440	\N
4187	40	5	0	42453	\N
4203	40	1	0	42495	\N
4203	41	2	0	42496	\N
4223	51	2	0	43540	\N
4223	524	3	0	43545	\N
4129	56	2	0	43821	\N
4129	169	3	0	43822	\N
4144	56	1	0	43823	\N
4144	57	2	0	43827	\N
4127	75	0	0	45511	\N
4318	75	1	0	45517	\N
4318	76	2	0	45518	\N
4261	79	1	0	46786	\N
4261	81	2	0	46787	\N
4313	79	2	0	46812	\N
4313	80	3	0	46814	\N
4265	100	1	0	47573	\N
4267	100	1	0	47574	\N
4265	160	2	0	47576	\N
4267	160	2	0	47577	\N
4376	100	1	0	47591	\N
4376	160	2	0	47593	\N
4294	102	1	0	47797	\N
4294	103	2	0	47798	\N
4205	121	5	0	48908	\N
4205	1197	6	0	48913	\N
4180	200	74	0	51530	\N
4180	1184	75	0	51531	\N
4159	260	1	0	52407	\N
4159	261	2	0	52409	\N
4248	268	4	0	52775	\N
4248	1208	5	0	52784	\N
4282	273	1	0	52980	\N
4282	410	2	0	52983	\N
4154	1109	1	0	56219	\N
4311	1109	0	0	56221	\N
4154	1111	2	0	56222	\N
4383	1109	1	0	56228	\N
4383	1111	2	0	56232	\N
4152	852	1	0	57234	\N
4287	852	3	0	57236	\N
4152	913	2	0	57240	\N
4287	1068	4	0	57245	\N
4259	908	1	0	57550	\N
4259	909	2	0	57553	\N
4257	424	1	0	764	\N
4306	1220	127	0	1387	\N
4306	1219	2	0	1496	\N
4306	251	126	0	1514	\N
4135	117	1	0	2000	\N
4135	248	2	0	2002	\N
4277	110	3	0	2557	\N
4277	1217	4	0	2567	\N
4354	367	2	0	3320	\N
4354	1227	3	0	3322	\N
4392	367	8	0	3330	\N
4392	1232	9	0	3332	\N
4212	262	1	0	3813	\N
4349	262	1	0	3827	\N
4349	263	2	0	3828	\N
4374	262	1	0	3846	\N
4374	263	2	0	3849	\N
4397	1236	10	0	4197	\N
4397	1237	11	0	4198	\N
4346	189	1	0	4879	\N
4346	190	2	0	4881	\N
4289	391	1	0	10305	\N
4289	392	2	0	10306	\N
4390	391	3	0	10311	\N
4390	581	4	0	10312	\N
4241	455	2	0	11185	\N
4210	1198	1	0	12335	\N
4210	1199	2	0	12336	\N
4397	1235	10	0	12972	\N
4246	77	4	0	13143	\N
4246	1206	5	0	13145	\N
4225	233	2	0	13801	\N
4225	910	3	0	13805	\N
4177	173	3	0	14640	\N
4177	174	4	0	14645	\N
4388	38	77	0	16384	\N
4388	1230	78	0	16396	\N
4337	64	0	0	20781	\N
4263	64	3	0	20785	\N
4263	65	4	0	20786	\N
4364	164	2	0	21094	\N
4364	226	3	0	21095	\N
4357	488	1	0	21421	\N
4357	489	2	0	21423	\N
4229	145	1	0	21945	\N
4229	153	2	0	21946	\N
4239	67	1	0	22191	\N
4251	67	1	0	22192	\N
4239	478	2	0	22193	\N
4237	69	1	0	24701	\N
4237	70	2	0	24703	\N
4118	49	2	0	25046	\N
4118	328	3	0	25047	\N
4195	94	1	0	26728	\N
4195	107	2	0	26729	\N
4301	42	0	0	27523	\N
4359	54	1	0	30021	\N
4359	55	2	0	30024	\N
4189	20	2	0	30447	\N
4189	369	3	0	30450	\N
4352	202	1	0	31128	\N
4285	230	3	0	32068	\N
4285	876	4	0	32071	\N
4142	1	1	0	34026	\N
4142	53	2	0	34030	\N
4150	1	1	0	34033	\N
4150	53	2	0	34035	\N
4171	1	1	0	34039	\N
4198	1	4	0	34040	\N
4200	1	1	0	34041	\N
4171	53	2	0	34044	\N
4200	53	2	0	34045	\N
4198	1194	5	0	34048	\N
4299	444	3	0	34060	\N
4308	1	2	0	34061	\N
4308	112	3	0	34062	\N
4372	1	1	0	34073	\N
4372	53	2	0	34075	\N
4399	1	10	0	34082	\N
4399	968	11	0	34083	\N
4408	1	10	0	34085	\N
4214	4	1	0	36054	\N
4214	25	2	0	36055	\N
4122	10	2	0	37725	\N
4122	29	3	0	37726	\N
4132	11	2	0	37730	\N
4140	10	2	0	37733	\N
4140	29	3	0	37737	\N
4316	10	1	0	37799	\N
4316	11	2	0	37804	\N
4381	10	1	0	37827	\N
4381	11	2	0	37830	\N
4270	14	2	0	39269	\N
4270	383	3	0	39270	\N
4184	18	10	0	39738	\N
4184	1186	11	0	39739	\N
4395	23	5	0	40688	\N
4134	40	1	0	42379	\N
4134	41	2	0	42380	\N
4143	40	1	0	42401	\N
4143	41	2	0	42403	\N
4193	40	6	0	42451	\N
4193	1192	7	0	42452	\N
4199	40	4	0	42478	\N
4199	1195	5	0	42479	\N
4336	40	0	0	42540	\N
4409	40	10	0	42556	\N
4409	1244	11	0	42558	\N
4201	51	1	0	43539	\N
4201	52	2	0	43542	\N
4373	56	0	0	43819	\N
4393	56	12	0	43831	\N
4393	676	13	0	43832	\N
4367	75	1	0	45535	\N
4412	75	10	0	45536	\N
4367	76	2	0	45537	\N
4323	79	2	0	46813	\N
4323	80	3	0	46815	\N
4360	100	2	0	47575	\N
4360	1228	3	0	47580	\N
4377	100	1	0	47592	\N
4377	160	2	0	47594	\N
4370	102	1	0	47804	\N
4370	103	2	0	47805	\N
4126	119	1	0	48613	\N
4126	120	2	0	48615	\N
4304	137	1	0	49810	\N
4304	138	2	0	49813	\N
4247	170	4	0	50563	\N
4379	170	1	0	50564	\N
4379	398	2	0	50565	\N
4247	1207	5	0	50568	\N
4340	186	1	0	51301	\N
4340	187	2	0	51303	\N
4325	260	2	0	52408	\N
4325	419	3	0	52410	\N
4235	285	1	0	53428	\N
4235	286	2	0	53430	\N
4124	324	1	0	54291	\N
4124	325	2	0	54294	\N
4355	908	1	0	57551	\N
4355	909	2	0	57554	\N
4404	1241	11	0	769	\N
4347	251	126	0	1540	\N
4347	1224	127	0	1541	\N
4406	117	9	0	2008	\N
4406	1242	10	0	2010	\N
4275	110	2	0	2556	\N
4275	1214	3	0	2565	\N
4185	228	3	0	2890	\N
4185	1187	4	0	2891	\N
4391	367	4	0	3329	\N
4391	1231	5	0	3331	\N
4145	237	2	0	3594	\N
4145	319	3	0	3595	\N
4398	1237	11	0	4207	\N
4380	132	1	0	11196	\N
4380	455	2	0	11197	\N
4219	300	1	0	12032	\N
4219	355	2	0	12036	\N
4368	300	5	0	12043	\N
4368	1229	6	0	12044	\N
4365	77	1	0	13161	\N
4365	78	2	0	13163	\N
4233	256	5	0	13355	\N
4233	1202	6	0	13360	\N
4297	58	1	0	13466	\N
4192	92	2	0	15024	\N
4192	93	3	0	15025	\N
4326	92	1	0	15036	\N
4326	191	2	0	15039	\N
4400	235	10	0	15628	\N
4402	235	10	0	15629	\N
4400	1238	11	0	15633	\N
4402	1238	11	0	15634	\N
4157	115	2	0	16652	\N
4382	115	1	0	16653	\N
4382	116	2	0	16655	\N
4157	1034	3	0	16657	\N
4136	327	2	0	17318	\N
4244	142	1	0	18504	\N
4244	143	2	0	18505	\N
4344	142	1	0	18516	\N
4344	143	2	0	18518	\N
4119	290	2	0	19011	\N
4119	575	3	0	19014	\N
4363	290	2	0	19022	\N
4363	575	3	0	19025	\N
4384	241	1	0	20385	\N
4384	333	2	0	20388	\N
4386	64	2	0	20782	\N
4335	164	1	0	21085	\N
4335	165	2	0	21087	\N
4280	67	1	0	22201	\N
4280	478	2	0	22202	\N
4121	94	1	0	26725	\N
4121	107	2	0	26726	\N
4302	42	0	0	27524	\N
4254	320	2	0	29210	\N
4254	321	3	0	29211	\N
4338	54	3	0	30020	\N
4338	476	4	0	30027	\N
4164	360	2	0	31467	\N
4182	479	2	0	31471	\N
4164	361	3	0	31473	\N
4268	33	1	0	31767	\N
4268	163	2	0	31768	\N
4148	1	1	0	34031	\N
4148	53	2	0	34032	\N
4208	1	1	0	34042	\N
4208	53	2	0	34046	\N
4252	1	2	0	34049	\N
4252	112	3	0	34052	\N
4273	1	2	0	34053	\N
4273	444	3	0	34056	\N
4309	53	2	0	34065	\N
4328	1	1	0	34067	\N
4328	53	2	0	34068	\N
4341	1	1	0	34069	\N
4341	53	2	0	34070	\N
4375	1	1	0	34074	\N
4375	53	2	0	34076	\N
4389	1	3	0	34078	\N
4389	48	4	0	34079	\N
4169	10	1	0	37735	\N
4169	11	2	0	37736	\N
4221	10	1	0	37755	\N
4227	10	9	0	37759	\N
4227	1200	10	0	37760	\N
4292	10	1	0	37785	\N
4292	11	2	0	37786	\N
4320	10	1	0	37800	\N
4353	10	1	0	37802	\N
4358	10	1	0	37803	\N
4320	11	2	0	37805	\N
4353	11	2	0	37807	\N
4358	11	2	0	37808	\N
4362	10	1	0	37815	\N
4362	11	2	0	37816	\N
4226	18	3	0	39744	\N
4226	609	4	0	39745	\N
4350	18	0	0	39756	\N
4217	27	1	0	41197	\N
4217	28	2	0	41200	\N
4131	40	1	0	42346	\N
4131	41	2	0	42347	\N
4173	40	1	0	42438	\N
4173	41	2	0	42439	\N
4204	40	5	0	42506	\N
4204	1196	6	0	42507	\N
4290	40	1	0	42522	\N
4290	41	2	0	42523	\N
4343	40	1	0	42555	\N
4343	41	2	0	42557	\N
4283	56	1	0	43826	\N
4283	57	2	0	43829	\N
4412	1245	11	0	45538	\N
4378	88	1	0	47295	\N
4378	89	2	0	47298	\N
4242	102	1	0	47791	\N
4242	103	2	0	47792	\N
4269	119	1	0	48672	\N
4269	120	2	0	48674	\N
4206	121	2	0	48909	\N
4206	625	3	0	48912	\N
4183	125	1	0	49251	\N
4183	1185	2	0	49252	\N
4371	125	1	0	49259	\N
4422	125	2	0	49260	\N
4371	195	2	0	49265	\N
4422	188	3	0	49269	\N
4276	1215	37	0	51532	\N
4276	200	80	0	51539	\N
4276	1216	81	0	51540	\N
4163	242	1	0	52156	\N
4163	253	2	0	52157	\N
4260	253	1	0	52159	\N
4260	242	2	0	52166	\N
4432	362	4	0	54791	\N
4432	1252	5	0	54795	\N
4314	435	2	0	54977	\N
4314	481	3	0	54980	\N
4425	793	2	0	56681	\N
4425	1250	3	0	56685	\N
4262	1211	4	1	56897	\N
4351	841	4	0	56929	\N
4351	900	5	0	56932	\N
4215	852	1	0	57235	\N
4215	913	2	0	57241	\N
4348	1226	4	0	57968	\N
4224	821	3	0	559	\N
4178	175	3	0	2003	\N
4253	117	2	0	2007	\N
4253	175	3	0	2009	\N
4446	117	2	0	2019	\N
4446	1257	3	0	2022	\N
4449	117	24	0	2023	\N
4449	1258	25	0	2024	\N
4295	367	1	0	3319	\N
4295	368	2	0	3321	\N
4190	35	2	0	4191	\N
4190	1191	3	0	4192	\N
4345	189	39	0	4878	\N
4133	391	1	0	10289	\N
4147	391	2	0	10290	\N
4133	392	2	0	10292	\N
4147	406	3	0	10294	\N
4339	132	3	0	11182	\N
4339	814	4	0	11187	\N
4342	108	1	0	11682	\N
4342	109	2	0	11687	\N
4274	300	2	0	12034	\N
4274	1213	3	0	12038	\N
4319	469	1	0	12348	\N
4321	469	0	0	12349	\N
4333	77	1	0	13152	\N
4333	78	2	0	13153	\N
4230	402	1	0	14074	\N
4230	403	2	0	14081	\N
4262	1212	5	0	15217	\N
4331	44	1	0	16062	\N
4331	45	2	0	16066	\N
4168	167	4	0	17717	\N
4168	1182	5	0	17718	\N
4369	167	1	0	17729	\N
4369	533	2	0	17730	\N
4156	142	2	0	18485	\N
4439	142	1	0	18517	\N
4439	143	2	0	18519	\N
4196	60	2	0	19474	\N
4196	166	3	0	19479	\N
4211	198	1	0	20050	\N
4211	199	2	0	20052	\N
4262	1210	4	0	20630	\N
4262	65	1	0	20773	\N
4264	64	2	0	20780	\N
4262	64	3	0	20784	\N
4264	162	3	0	20787	\N
4361	145	1	0	21956	\N
4444	67	4	0	22211	\N
4444	1256	5	0	22212	\N
4213	69	1	0	24700	\N
4213	70	2	0	24702	\N
4317	49	1	0	25051	\N
4317	50	2	0	25053	\N
4240	94	1	0	26730	\N
4240	107	2	0	26732	\N
4300	42	0	0	27522	\N
4255	54	3	0	29998	\N
4255	476	4	0	30005	\N
4307	54	1	0	30014	\N
4175	202	1	0	31095	\N
4175	203	2	0	31096	\N
4128	360	2	0	31466	\N
4128	510	3	0	31472	\N
4139	33	9	0	31761	\N
4139	1180	10	0	31762	\N
4312	230	2	0	32069	\N
4312	231	3	0	32070	\N
4158	1	1	0	34034	\N
4158	53	2	0	34036	\N
4167	1	1	0	34037	\N
4167	53	2	0	34038	\N
4271	53	2	0	34051	\N
4356	1	1	0	34071	\N
4356	53	2	0	34072	\N
4437	1	2	0	34092	\N
4437	112	3	0	34093	\N
4385	4	2	0	36061	\N
4166	10	2	0	37734	\N
4166	792	3	0	37738	\N
4176	10	3	0	37745	\N
4176	347	4	0	37746	\N
4188	1190	4	0	37747	\N
4188	10	5	0	37750	\N
4266	11	2	0	37772	\N
4278	10	2	0	37781	\N
4278	29	3	0	37782	\N
4329	10	1	0	37801	\N
4329	11	2	0	37806	\N
4366	10	1	0	37821	\N
4366	11	2	0	37822	\N
4427	10	1	0	37836	\N
4427	11	2	0	37841	\N
4238	18	5	0	39748	\N
4238	1203	6	0	39749	\N
4324	18	2	0	39752	\N
4293	23	2	0	40674	\N
4293	1218	3	0	40675	\N
4249	27	4	0	41198	\N
4249	1209	5	0	41203	\N
4447	40	2	0	42573	\N
4447	282	3	0	42574	\N
4477	569	2	0	42575	\N
4477	40	3	0	42603	\N
4451	51	2	0	43541	\N
4451	1260	3	0	43543	\N
4420	56	3	0	43833	\N
4420	676	4	0	43834	\N
4436	75	2	0	45545	\N
4464	75	1	0	45546	\N
4476	75	1	0	45547	\N
4464	76	2	0	45548	\N
4476	76	2	0	45549	\N
4436	159	3	0	45550	\N
4423	79	1	0	46088	\N
4423	81	2	0	46089	\N
4471	79	3	0	46139	\N
4471	1265	4	0	46140	\N
4426	119	1	0	48673	\N
4426	120	2	0	48675	\N
4415	970	10	0	50566	\N
4416	970	10	0	50567	\N
4415	170	13	0	50586	\N
4416	170	13	0	50587	\N
4415	718	14	0	50588	\N
4416	718	14	0	50589	\N
4461	1263	75	0	50867	\N
4461	181	126	0	50878	\N
4461	1264	127	0	50879	\N
4478	242	0	0	52178	\N
4475	260	1	0	52415	\N
4475	261	2	0	52417	\N
4467	268	1	0	52776	\N
4467	269	2	0	52780	\N
4457	316	1	0	53948	\N
4457	317	2	0	53952	\N
4463	324	1	0	54292	\N
4463	325	2	0	54295	\N
4479	1268	1	0	54562	\N
4482	1268	1	0	54563	\N
4479	353	4	0	54574	\N
4482	353	4	0	54575	\N
4479	755	5	0	54576	\N
4482	755	5	0	54577	\N
4465	435	1	0	54978	\N
4465	436	2	0	54979	\N
4413	1021	13	0	56538	\N
4413	1246	14	0	56540	\N
4424	793	22	0	56680	\N
4424	1249	23	0	56691	\N
4407	117	126	0	2011	\N
4430	367	1	0	3344	\N
4431	367	29	0	3345	\N
4430	368	2	0	3349	\N
4431	1251	30	0	3352	\N
4486	35	1	0	4214	\N
4486	340	2	0	4216	\N
4433	365	4	0	4505	\N
4433	1253	5	0	4506	\N
4441	365	1	0	4521	\N
4441	366	2	0	4522	\N
4448	365	2	0	4529	\N
4448	615	3	0	4532	\N
4460	1262	5	0	12815	\N
4435	258	2	0	14445	\N
4435	585	3	0	14446	\N
4480	1269	1	0	16051	\N
4481	1269	1	0	16052	\N
4480	44	4	0	16067	\N
4481	44	3	0	16068	\N
4481	45	4	0	16069	\N
4480	161	5	0	16070	\N
4387	38	1	0	16383	\N
4387	399	2	0	16385	\N
4429	212	1	0	17107	\N
4428	30	1	0	17991	\N
4428	418	2	0	17992	\N
4462	142	1	0	18535	\N
4462	143	2	0	18537	\N
4455	208	1	0	19303	\N
4455	209	2	0	19305	\N
4419	164	9	0	21110	\N
4419	1248	10	0	21113	\N
4484	336	1	0	22718	\N
4484	356	2	0	22719	\N
4454	149	1	0	23070	\N
4454	499	2	0	23071	\N
4472	1266	4	0	24064	\N
4450	214	2	0	24338	\N
4450	1259	3	0	24342	\N
4466	411	1	0	25200	\N
4468	411	0	0	25201	\N
4466	412	2	0	25202	\N
4434	42	2	0	27525	\N
4434	681	3	0	27528	\N
4474	16	1	0	27987	\N
4474	17	2	0	27989	\N
4443	96	4	0	29485	\N
4458	96	3	0	29486	\N
4443	1255	5	0	29488	\N
4459	20	1	0	30448	\N
4459	144	2	0	30449	\N
4403	230	10	0	32084	\N
4403	1240	11	0	32085	\N
4485	322	1	0	32343	\N
4485	323	2	0	32344	\N
4394	523	6	0	34077	\N
4394	1	12	0	34080	\N
4394	1233	13	0	34081	\N
4405	1	9	0	34084	\N
4405	1036	10	0	34086	\N
4417	1	9	0	34088	\N
4417	1247	10	0	34089	\N
4421	1	2	0	34090	\N
4421	112	3	0	34091	\N
4442	1	4	0	34094	\N
4445	1	2	0	34095	\N
4452	1	1	0	34096	\N
4452	53	2	0	34097	\N
4445	283	3	0	34098	\N
4442	1254	5	0	34099	\N
4469	1	3	0	34100	\N
4469	48	4	0	34101	\N
4453	131	3	0	35544	\N
4483	2	1	0	35554	\N
4483	26	2	0	35558	\N
4385	579	3	0	36064	\N
4401	10	10	0	37828	\N
4410	10	10	0	37829	\N
4401	1239	11	0	37831	\N
4410	1239	11	0	37832	\N
4438	10	2	0	37837	\N
4440	10	1	0	37838	\N
4456	10	1	0	37839	\N
4470	10	1	0	37840	\N
4456	11	2	0	37843	\N
4470	11	2	0	37844	\N
4438	29	3	0	37845	\N
4411	1239	11	0	37846	\N
4473	14	6	0	39279	\N
4473	1267	7	0	39280	\N
4414	18	9	0	39733	\N
4414	543	10	0	39734	\N
4396	1234	6	0	40676	\N
4396	23	12	0	40692	\N
4396	650	13	0	40693	\N
4487	27	1	0	41199	\N
4491	40	3	0	42599	\N
4539	40	1	0	42600	\N
4539	41	2	0	42601	\N
4491	128	4	0	42602	\N
4503	56	2	0	43835	\N
4503	169	3	0	43838	\N
4568	56	1	0	43839	\N
4568	57	2	0	43840	\N
4651	56	3	0	43841	\N
4651	475	4	0	43842	\N
4490	75	1	0	45557	\N
4506	75	1	0	45558	\N
4518	75	1	0	45559	\N
4490	76	2	0	45560	\N
4506	76	2	0	45561	\N
4518	76	2	0	45562	\N
4528	88	1	0	47312	\N
4528	89	2	0	47315	\N
4544	113	2	0	48293	\N
4544	1277	3	0	48295	\N
4637	113	2	0	48322	\N
4637	114	3	0	48323	\N
4661	137	1	0	49825	\N
4661	138	2	0	49827	\N
4640	147	1	0	49967	\N
4640	599	2	0	49973	\N
4656	156	7	0	50228	\N
4656	1313	8	0	50229	\N
4530	200	1	0	51513	\N
4530	201	2	0	51514	\N
4517	268	1	0	52777	\N
4690	268	5	0	52778	\N
4517	269	2	0	52781	\N
4690	642	6	0	52783	\N
4623	273	1	0	52981	\N
4623	410	2	0	52984	\N
4519	435	2	0	54981	\N
4519	481	3	0	54982	\N
4495	793	3	0	56694	\N
4547	793	1	0	56695	\N
4547	1150	2	0	56696	\N
4495	1169	4	0	56697	\N
4512	520	3	0	768	\N
4625	228	1	0	2896	\N
4625	229	2	0	2899	\N
4489	237	1	0	3596	\N
4489	527	2	0	3597	\N
4635	237	1	0	3599	\N
4635	527	2	0	3602	\N
4513	262	2	0	3847	\N
4513	731	3	0	3850	\N
4654	35	2	0	4226	\N
4648	132	1	0	11202	\N
4648	455	2	0	11205	\N
4537	233	1	0	13817	\N
4537	234	2	0	13821	\N
4508	92	1	0	15037	\N
4508	191	2	0	15040	\N
4521	235	1	0	15630	\N
4521	236	2	0	15632	\N
4516	44	1	0	16076	\N
4516	45	2	0	16078	\N
4497	38	5	0	16399	\N
4497	1271	6	0	16408	\N
4520	30	1	0	17995	\N
4520	418	2	0	17996	\N
4696	30	3	0	17998	\N
4666	62	1	0	19708	\N
4666	63	2	0	19710	\N
4684	1316	1	0	22327	\N
4684	1317	2	0	22328	\N
4555	1283	5	0	22472	\N
4559	73	1	0	22481	\N
4659	73	1	0	22483	\N
4559	74	2	0	22489	\N
4659	74	2	0	22490	\N
4555	73	15	0	22504	\N
4555	1284	16	0	22505	\N
4681	264	1	0	23495	\N
4578	140	1	0	24061	\N
4578	141	2	0	24063	\N
4621	214	1	0	24339	\N
4621	215	2	0	24341	\N
4566	224	2	0	25538	\N
4566	1294	3	0	25547	\N
4510	90	1	0	26031	\N
4511	90	54	0	26032	\N
4532	90	1	0	26033	\N
4510	344	2	0	26034	\N
4532	344	2	0	26035	\N
4511	1273	55	0	26036	\N
4501	17	2	0	27990	\N
4671	16	2	0	27993	\N
4677	16	2	0	27994	\N
4677	155	3	0	27996	\N
4671	445	3	0	27997	\N
4610	449	1	0	29814	\N
4610	450	2	0	29815	\N
4505	151	1	0	30686	\N
4505	302	2	0	30688	\N
4514	360	1	0	31490	\N
4514	479	2	0	31491	\N
4679	360	1	0	31502	\N
4633	33	1	0	31777	\N
4633	163	2	0	31778	\N
4498	453	5	0	32676	\N
4499	453	2	0	32677	\N
4499	902	3	0	32680	\N
4498	1272	6	0	32681	\N
4488	1	1	0	34102	\N
4488	53	2	0	34103	\N
4507	1	1	0	34104	\N
4507	53	2	0	34106	\N
4573	1	2	0	34109	\N
4573	444	3	0	34111	\N
4614	1	0	0	34114	\N
4576	112	3	0	34115	\N
4628	1	3	0	34117	\N
4628	48	4	0	34118	\N
4668	1	1	0	34127	\N
4668	53	2	0	34128	\N
4509	4	1	0	36062	\N
4509	25	2	0	36063	\N
4492	10	3	0	37849	\N
4500	10	4	0	37850	\N
4492	347	4	0	37851	\N
4500	600	5	0	37852	\N
4502	29	3	0	37858	\N
4515	10	1	0	37861	\N
4515	11	2	0	37863	\N
4581	10	1	0	37878	\N
4586	10	5	0	37879	\N
4602	10	1	0	37880	\N
4581	11	2	0	37881	\N
4602	11	2	0	37882	\N
4586	1298	6	0	37883	\N
4631	10	1	0	37900	\N
4631	11	2	0	37905	\N
4496	14	5	0	39299	\N
4504	15	2	0	39303	\N
4496	1201	6	0	39306	\N
4563	18	1	0	39736	\N
4563	19	2	0	39737	\N
4494	27	3	0	41221	\N
4494	1270	4	0	41222	\N
4545	27	2	0	41243	\N
4545	619	3	0	41245	\N
4601	40	2	0	42616	\N
4601	66	3	0	42617	\N
4800	40	1	0	42688	\N
4800	41	2	0	42689	\N
4531	51	1	0	43548	\N
4531	52	2	0	43551	\N
4649	75	1	0	45591	\N
4767	75	1	0	45594	\N
4649	76	2	0	45595	\N
4767	76	2	0	45597	\N
4727	79	2	0	46312	\N
4727	80	3	0	46319	\N
4736	88	1	0	47314	\N
4736	89	2	0	47317	\N
4744	121	2	0	48923	\N
4744	625	3	0	48926	\N
4791	125	2	0	49262	\N
4791	188	3	0	49270	\N
4683	135	1	0	49510	\N
4683	136	2	0	49512	\N
4522	137	1	0	49824	\N
4522	138	2	0	49826	\N
4722	186	1	0	51302	\N
4722	187	2	0	51304	\N
4592	210	1	0	51816	\N
4592	211	2	0	51818	\N
4543	285	2	0	53429	\N
4543	1276	3	0	53431	\N
4579	324	1	0	54293	\N
4579	325	2	0	54296	\N
4734	324	1	0	54305	\N
4734	325	2	0	54308	\N
4739	435	1	0	54983	\N
4739	436	2	0	54984	\N
4672	451	2	0	55299	\N
4733	451	1	0	55300	\N
4733	584	2	0	55302	\N
4672	497	3	0	55303	\N
4639	595	1	0	55571	\N
4724	595	2	0	55572	\N
4639	596	2	0	55574	\N
4724	768	3	0	55577	\N
4723	597	2	0	55900	\N
4723	767	3	0	55905	\N
4647	793	1	0	56710	\N
4647	1150	2	0	56712	\N
4703	841	1	0	56948	\N
4703	842	2	0	56953	\N
4704	852	1	0	57238	\N
4704	913	2	0	57243	\N
4715	400	2	0	52	\N
4589	1301	89	0	563	\N
4551	266	0	0	1164	\N
4758	262	1	0	3864	\N
4758	263	2	0	3868	\N
4738	391	2	0	10319	\N
4738	406	3	0	10320	\N
4751	391	1	0	10327	\N
4751	392	2	0	10329	\N
4556	1285	0	0	11591	\N
4780	108	1	0	11684	\N
4780	109	2	0	11689	\N
4782	528	1	0	12462	\N
4670	77	2	0	13162	\N
4670	1314	3	0	13164	\N
4788	233	2	0	13818	\N
4788	910	3	0	13824	\N
4776	402	3	0	14076	\N
4776	1328	4	0	14086	\N
4731	92	3	0	15038	\N
4731	1321	4	0	15041	\N
4753	92	1	0	15046	\N
4753	191	2	0	15047	\N
4540	235	1	0	15639	\N
4540	236	2	0	15640	\N
4665	45	2	0	16079	\N
4742	115	23	0	16661	\N
4742	1323	24	0	16665	\N
4562	1291	1	0	16933	\N
4562	1292	2	0	16934	\N
4608	326	1	0	17314	\N
4608	327	2	0	17319	\N
4706	167	1	0	17736	\N
4706	533	2	0	17737	\N
4752	30	1	0	18003	\N
4752	418	2	0	18007	\N
4798	177	7	0	18290	\N
4700	290	1	0	19023	\N
4700	291	2	0	19024	\N
4807	164	1	0	21128	\N
4807	165	2	0	21129	\N
4748	488	3	0	21442	\N
4748	1324	4	0	21453	\N
4558	73	1	0	22480	\N
4627	73	3	0	22482	\N
4558	74	2	0	22488	\N
4627	993	4	0	22492	\N
4620	264	1	0	23482	\N
4620	270	2	0	23483	\N
4674	49	126	0	25055	\N
4674	789	127	0	25056	\N
4577	206	2	0	25792	\N
4577	693	3	0	25793	\N
4694	86	0	0	26420	\N
4613	94	1	0	26737	\N
4613	107	2	0	26738	\N
4622	244	1	0	27260	\N
4622	245	2	0	27263	\N
4689	16	1	0	27998	\N
4713	16	1	0	27999	\N
4689	17	2	0	28001	\N
4698	96	1	0	29498	\N
4698	97	2	0	29501	\N
4711	20	1	0	30459	\N
4711	144	2	0	30460	\N
4595	1	3	0	34113	\N
4595	48	4	0	34116	\N
4645	1	1	0	34123	\N
4645	53	2	0	34124	\N
4718	1	2	0	34129	\N
4718	112	3	0	34130	\N
4793	1	1	0	34137	\N
4793	53	2	0	34138	\N
4810	53	2	0	34140	\N
4697	431	1	0	34765	\N
4697	432	2	0	34766	\N
4699	2	1	0	35556	\N
4699	26	2	0	35559	\N
4556	1286	0	0	36478	\N
4611	8	1	0	36486	\N
4611	9	2	0	36488	\N
4567	10	2	0	37869	\N
4567	792	3	0	37870	\N
4572	10	2	0	37874	\N
4572	29	3	0	37875	\N
4629	11	2	0	37895	\N
4743	10	2	0	37916	\N
4743	29	3	0	37919	\N
4761	10	1	0	37920	\N
4765	10	1	0	37921	\N
4785	10	1	0	37922	\N
4761	11	2	0	37924	\N
4765	11	2	0	37925	\N
4785	11	2	0	37926	\N
4805	10	1	0	37930	\N
4805	11	2	0	37932	\N
4658	18	1	0	39741	\N
4652	40	2	0	42628	\N
4652	66	3	0	42629	\N
4779	40	1	0	42664	\N
4779	41	2	0	42665	\N
4844	40	1	0	42701	\N
4844	41	2	0	42702	\N
4527	56	1	0	43836	\N
4527	57	2	0	43837	\N
4863	56	4	0	43843	\N
4863	1145	5	0	43846	\N
4525	75	1	0	45579	\N
4599	75	3	0	45580	\N
4525	76	2	0	45581	\N
4599	857	4	0	45582	\N
4701	75	1	0	45592	\N
4701	76	2	0	45596	\N
4797	75	1	0	45629	\N
4797	76	2	0	45633	\N
4582	88	1	0	47313	\N
4582	89	2	0	47316	\N
4523	135	1	0	49499	\N
4523	136	2	0	49502	\N
4662	135	1	0	49509	\N
4662	136	2	0	49511	\N
4682	137	1	0	49836	\N
4682	138	2	0	49838	\N
4588	200	5	0	51526	\N
4588	1300	6	0	51529	\N
4816	200	2	0	51537	\N
4816	1333	3	0	51538	\N
4549	210	1	0	51815	\N
4549	211	2	0	51817	\N
4823	285	2	0	53443	\N
4832	285	2	0	53444	\N
4823	1276	3	0	53445	\N
4832	1276	3	0	53446	\N
4795	353	1	0	54572	\N
4795	354	2	0	54573	\N
4849	435	1	0	54985	\N
4849	436	2	0	54986	\N
4874	1211	113	1	56896	\N
4705	841	24	0	56949	\N
4705	1320	25	0	56955	\N
4809	908	1	0	57562	\N
4811	908	107	0	57563	\N
4809	909	2	0	57565	\N
4811	1332	108	0	57567	\N
4874	1281	114	0	57858	\N
4643	1312	19	0	306	\N
4835	477	4	0	560	\N
4827	424	0	0	792	\N
4692	266	1	0	1166	\N
4692	267	2	0	1168	\N
4598	117	1	0	2020	\N
4598	248	2	0	2021	\N
4616	367	3	0	3346	\N
4616	1307	4	0	3351	\N
4664	237	1	0	3600	\N
4664	527	2	0	3603	\N
4596	262	3	0	3848	\N
4596	1305	4	0	3851	\N
4584	340	2	0	4217	\N
4678	365	2	0	4530	\N
4678	519	3	0	4533	\N
4570	189	1	0	4889	\N
4570	190	2	0	4890	\N
4842	189	2	0	4900	\N
4842	311	3	0	4901	\N
4772	391	1	0	10328	\N
4772	392	2	0	10330	\N
4606	528	1	0	12461	\N
4606	529	2	0	12464	\N
4874	59	113	0	13401	\N
4675	59	2	0	13477	\N
4874	796	114	1	14014	\N
4775	402	2	0	14075	\N
4775	1148	3	0	14085	\N
4856	173	1	0	14641	\N
4856	396	2	0	14643	\N
4777	92	1	0	15056	\N
4777	191	2	0	15058	\N
4590	115	4	0	16654	\N
4590	1302	5	0	16656	\N
4687	212	1	0	17134	\N
4687	213	2	0	17135	\N
4792	167	1	0	17753	\N
4760	533	2	0	17754	\N
4792	533	2	0	17755	\N
4604	60	1	0	19475	\N
4604	61	2	0	19477	\N
4541	488	1	0	21422	\N
4541	489	2	0	21424	\N
4874	1280	112	1	21637	\N
4650	149	1	0	23076	\N
4650	499	2	0	23077	\N
4593	930	2	0	23919	\N
4593	1304	3	0	23924	\N
4673	49	1	0	25052	\N
4673	50	2	0	25054	\N
4873	49	1	0	25057	\N
4873	50	2	0	25061	\N
4874	49	126	0	25065	\N
4565	224	3	0	25537	\N
4565	1293	4	0	25548	\N
4695	86	0	0	26421	\N
4575	16	1	0	27992	\N
4575	17	2	0	27995	\N
4802	449	2	0	29834	\N
4802	1331	3	0	29835	\N
4834	583	3	0	29849	\N
4618	1310	1	0	30932	\N
4618	1311	2	0	30933	\N
4865	33	1	0	31797	\N
4865	163	2	0	31798	\N
4707	230	1	0	32090	\N
4707	287	2	0	32092	\N
4534	1	1	0	34105	\N
4534	53	2	0	34107	\N
4536	1	1	0	34108	\N
4536	53	2	0	34110	\N
4630	1	1	0	34119	\N
4630	53	2	0	34121	\N
4634	53	2	0	34122	\N
4657	1	1	0	34125	\N
4657	53	2	0	34126	\N
4770	1	4	0	34132	\N
4770	422	5	0	34136	\N
4787	2	1	0	35570	\N
4787	26	2	0	35571	\N
4554	8	0	0	36480	\N
4585	8	5	0	36481	\N
4585	1297	6	0	36483	\N
4609	10	2	0	37886	\N
4612	10	1	0	37892	\N
4612	11	2	0	37894	\N
4646	10	1	0	37902	\N
4685	10	1	0	37903	\N
4646	11	2	0	37907	\N
4685	11	2	0	37908	\N
4708	10	1	0	37912	\N
4790	10	2	0	37923	\N
4790	29	3	0	37927	\N
4851	10	2	0	37935	\N
4851	792	3	0	37936	\N
4580	14	1	0	39301	\N
4813	18	2	0	39750	\N
4813	1222	3	0	39751	\N
4730	75	2	0	45593	\N
4730	159	3	0	45598	\N
4771	75	4	0	45621	\N
4771	172	5	0	45622	\N
4560	1287	5	0	46138	\N
4557	79	0	0	46207	\N
4560	79	15	0	46208	\N
4560	1288	16	0	46209	\N
4574	79	1	0	46260	\N
4574	81	2	0	46261	\N
4749	88	3	0	47332	\N
4749	580	4	0	47335	\N
4594	113	2	0	48310	\N
4594	114	3	0	48311	\N
4569	125	1	0	49261	\N
4569	195	2	0	49266	\N
4732	170	3	0	50606	\N
4732	1322	4	0	50609	\N
4591	181	26	0	50894	\N
4591	1303	27	0	50895	\N
4789	200	2	0	51527	\N
4789	887	3	0	51528	\N
4626	242	1	0	52190	\N
4626	253	2	0	52191	\N
4799	316	7	0	53957	\N
4799	1330	8	0	53958	\N
4726	324	2	0	54304	\N
4726	486	3	0	54310	\N
4663	389	1	0	54930	\N
4663	390	2	0	54935	\N
4638	597	1	0	55888	\N
4638	598	2	0	55891	\N
4603	1021	1	0	56543	\N
4603	1022	2	0	56550	\N
4542	841	1	0	56947	\N
4542	842	2	0	56952	\N
4619	852	1	0	57237	\N
4756	852	2	0	57239	\N
4619	913	2	0	57242	\N
4756	1325	3	0	57244	\N
4822	852	1	0	57256	\N
4822	913	2	0	57257	\N
4644	13	2	0	303	\N
4587	1299	6	0	562	\N
4680	424	1	0	780	\N
4680	425	2	0	782	\N
4819	266	1	0	1177	\N
4819	267	2	0	1179	\N
4524	110	1	0	2558	\N
4524	134	2	0	2559	\N
4632	110	1	0	2571	\N
4660	110	1	0	2572	\N
4632	134	2	0	2575	\N
4660	134	2	0	2576	\N
4617	1308	53	0	3353	\N
4617	1309	100	0	3361	\N
4526	237	1	0	3598	\N
4526	527	2	0	3601	\N
4762	35	1	0	4238	\N
4571	1295	86	0	4886	\N
4571	189	126	0	4893	\N
4571	1296	127	0	4894	\N
4564	222	2	0	5260	\N
4564	232	3	0	5261	\N
4669	132	1	0	11203	\N
4669	455	2	0	11206	\N
4624	108	1	0	11683	\N
4624	109	2	0	11688	\N
4778	300	1	0	12049	\N
4778	355	2	0	12050	\N
4655	58	1	0	13472	\N
4655	59	2	0	13473	\N
4803	233	1	0	13819	\N
4803	234	2	0	13822	\N
4529	258	1	0	14452	\N
4529	309	2	0	14454	\N
4740	115	2	0	16660	\N
4740	636	3	0	16664	\N
4801	30	1	0	18004	\N
4550	142	1	0	18536	\N
4550	143	2	0	18538	\N
4583	142	1	0	18544	\N
4583	143	2	0	18545	\N
4615	208	3	0	19304	\N
4615	1306	4	0	19306	\N
4783	164	2	0	21120	\N
4783	226	3	0	21121	\N
4686	488	1	0	21433	\N
4754	488	1	0	21443	\N
4754	489	2	0	21448	\N
4712	67	1	0	22217	\N
4812	73	1	0	22506	\N
4812	74	2	0	22507	\N
4607	336	1	0	22722	\N
4607	356	2	0	22723	\N
4720	149	1	0	23083	\N
4720	499	2	0	23084	\N
4605	264	1	0	23476	\N
4605	270	2	0	23477	\N
4806	82	1	0	23808	\N
4806	83	2	0	23809	\N
4642	224	1	0	25562	\N
4642	225	2	0	25564	\N
4533	90	14	0	26045	\N
4533	1275	15	0	26046	\N
4773	345	0	0	26290	\N
4548	94	2	0	26731	\N
4548	1278	3	0	26733	\N
4553	1279	5	0	26734	\N
4553	94	15	0	26735	\N
4826	1339	1	0	27179	\N
4826	1340	2	0	27180	\N
4667	449	1	0	29824	\N
4667	450	2	0	29825	\N
4676	54	1	0	30022	\N
4676	55	2	0	30025	\N
4714	55	2	0	30026	\N
4763	322	1	0	32345	\N
4763	323	2	0	32346	\N
4716	453	1	0	32694	\N
4716	454	2	0	32695	\N
4768	1	1	0	34131	\N
4768	53	2	0	34134	\N
4653	2	2	0	35555	\N
4747	2	3	0	35557	\N
4653	131	3	0	35560	\N
4747	572	4	0	35561	\N
4808	26	2	0	35579	\N
4561	1289	5	0	36477	\N
4561	8	15	0	36484	\N
4561	1290	16	0	36485	\N
4538	10	1	0	37862	\N
4538	11	2	0	37864	\N
4636	10	1	0	37901	\N
4636	11	2	0	37906	\N
4708	11	2	0	37913	\N
4717	10	1	0	37914	\N
4728	10	2	0	37915	\N
4717	11	2	0	37917	\N
4796	10	1	0	37928	\N
4796	11	2	0	37929	\N
4600	14	1	0	39302	\N
4600	15	2	0	39305	\N
4641	18	1	0	39740	\N
4641	19	2	0	39742	\N
4535	27	1	0	41242	\N
4535	28	2	0	41244	\N
4719	40	2	0	42642	\N
4719	66	3	0	42643	\N
4838	40	0	0	42700	\N
4855	40	1	0	42718	\N
4861	40	4	0	42719	\N
4870	40	1	0	42720	\N
4855	41	2	0	42721	\N
4870	41	2	0	42722	\N
4861	564	5	0	42723	\N
4818	75	2	0	45630	\N
4894	75	1	0	45631	\N
4894	76	2	0	45634	\N
4818	1335	3	0	45636	\N
4868	79	1	0	46314	\N
4868	81	2	0	46317	\N
4817	88	2	0	47333	\N
4836	88	3	0	47334	\N
4836	580	4	0	47336	\N
4817	1334	3	0	47337	\N
4764	1326	20	0	47595	\N
4766	100	1	0	47604	\N
4766	160	2	0	47605	\N
4764	100	30	0	47607	\N
4764	1327	31	0	47608	\N
4910	1354	4	0	48151	\N
4910	113	3	0	48338	\N
4755	121	1	0	48924	\N
4755	122	2	0	48925	\N
4725	147	2	0	49968	\N
4725	516	3	0	49975	\N
4710	170	1	0	50584	\N
4710	398	2	0	50585	\N
4693	181	5	0	50903	\N
4693	1318	6	0	50904	\N
4829	210	2	0	51843	\N
4830	210	2	0	51844	\N
4829	458	3	0	51845	\N
4830	458	3	0	51846	\N
4854	210	2	0	51855	\N
4854	1173	3	0	51856	\N
4709	260	2	0	52416	\N
4709	419	3	0	52418	\N
4691	268	1	0	52779	\N
4691	269	2	0	52782	\N
4888	273	1	0	52982	\N
4888	410	2	0	52985	\N
4825	1337	102	0	53440	\N
4825	285	126	0	53451	\N
4825	1338	127	0	53452	\N
4833	285	21	0	53461	\N
4833	1341	22	0	53462	\N
4848	451	1	0	55315	\N
4876	451	1	0	55316	\N
4848	584	2	0	55317	\N
4876	584	2	0	55318	\N
4900	451	1	0	55331	\N
4900	584	2	0	55332	\N
4897	597	0	0	55901	\N
4857	1109	0	0	56229	\N
4839	793	0	0	56711	\N
4867	793	1	0	56722	\N
4867	1150	2	0	56724	\N
4759	520	3	0	783	\N
4882	492	4	0	2900	\N
4746	367	2	0	3347	\N
4907	367	0	0	3348	\N
4746	651	3	0	3350	\N
4757	262	1	0	3863	\N
4757	263	2	0	3867	\N
4688	35	1	0	4227	\N
4843	1342	86	0	4895	\N
4843	189	126	0	4905	\N
4843	1296	127	0	4906	\N
4893	189	1	0	4914	\N
4893	190	2	0	4916	\N
4804	391	1	0	10341	\N
4804	392	2	0	10342	\N
4906	391	1	0	10348	\N
4906	392	2	0	10350	\N
4837	108	3	0	11685	\N
4837	837	4	0	11692	\N
4741	123	2	0	12829	\N
4741	384	3	0	12830	\N
4815	233	1	0	13820	\N
4815	234	2	0	13823	\N
4750	258	1	0	14453	\N
4750	309	2	0	14455	\N
4820	327	2	0	17321	\N
4890	142	1	0	18556	\N
4890	143	2	0	18557	\N
4735	290	1	0	19032	\N
4735	291	2	0	19034	\N
4781	62	1	0	19709	\N
4781	63	2	0	19711	\N
4881	198	3	0	20051	\N
4881	1347	4	0	20053	\N
4769	241	1	0	20395	\N
4769	333	2	0	20396	\N
4840	241	1	0	20415	\N
4729	164	2	0	21111	\N
4729	226	3	0	21112	\N
4686	489	2	0	21434	\N
4845	488	1	0	21444	\N
4845	489	2	0	21449	\N
4553	1280	16	0	21627	\N
4910	1355	4	1	21730	\N
4814	145	1	0	21966	\N
4814	153	2	0	21967	\N
4853	73	2	0	22514	\N
4853	1035	3	0	22517	\N
4794	82	1	0	23797	\N
4737	214	2	0	24340	\N
4737	227	3	0	24343	\N
4859	411	1	0	25212	\N
4859	412	2	0	25213	\N
4864	224	1	0	25563	\N
4864	225	2	0	25565	\N
4553	1282	17	1	26736	\N
4784	16	1	0	28000	\N
4784	17	2	0	28003	\N
4850	16	1	0	28004	\N
4850	17	2	0	28005	\N
4886	151	2	0	30701	\N
4831	202	1	0	31136	\N
4831	203	2	0	31137	\N
4908	360	3	0	31503	\N
4908	1353	4	0	31505	\N
4721	33	1	0	31787	\N
4721	163	2	0	31788	\N
4872	322	1	0	32347	\N
4872	323	2	0	32348	\N
4774	1	2	0	34133	\N
4774	112	3	0	34135	\N
4821	1	3	0	34141	\N
4821	1336	4	0	34142	\N
4824	112	3	0	34144	\N
4702	10	1	0	37904	\N
4702	11	2	0	37909	\N
4828	10	0	0	37931	\N
4841	10	1	0	37933	\N
4841	11	2	0	37934	\N
4877	10	1	0	37942	\N
4877	11	2	0	37943	\N
4879	10	3	0	37944	\N
4891	10	1	0	37945	\N
4891	11	2	0	37947	\N
4879	347	4	0	37948	\N
4786	19	2	0	39747	\N
4917	40	2	0	42737	\N
4923	40	1	0	42738	\N
4924	40	1	0	42739	\N
4923	41	2	0	42740	\N
4924	41	2	0	42741	\N
4917	66	3	0	42742	\N
4946	40	1	0	42754	\N
4946	41	2	0	42757	\N
4953	56	1	0	43844	\N
4953	57	2	0	43845	\N
4852	79	2	0	46313	\N
4927	79	1	0	46315	\N
4927	81	2	0	46318	\N
4852	472	3	0	46321	\N
4931	88	2	0	47344	\N
4931	154	3	0	47345	\N
4885	113	1	0	48330	\N
4885	437	2	0	48331	\N
4911	113	3	0	48339	\N
4911	778	4	0	48342	\N
4880	121	3	0	48935	\N
4880	1346	4	0	48938	\N
4898	147	1	0	49987	\N
4898	599	2	0	49997	\N
4928	170	1	0	50607	\N
4928	398	2	0	50608	\N
4921	181	1	0	50876	\N
4921	530	2	0	50877	\N
4958	186	1	0	51311	\N
4958	187	2	0	51314	\N
4869	200	1	0	51547	\N
4869	201	2	0	51549	\N
4932	260	3	0	52423	\N
4932	271	4	0	52424	\N
4905	316	1	0	53964	\N
4905	317	2	0	53966	\N
4902	1352	0	0	55298	\N
4899	451	0	0	55301	\N
4913	451	1	0	55343	\N
4913	584	2	0	55346	\N
4896	595	1	0	55573	\N
4896	596	2	0	55575	\N
4858	793	1	0	56721	\N
4858	1150	2	0	56723	\N
4934	908	2	0	57564	\N
4934	1356	3	0	57566	\N
4846	400	2	0	53	\N
4862	357	5	0	310	\N
4884	220	1	0	555	\N
4884	221	2	0	558	\N
4960	220	3	0	564	\N
4960	1359	4	0	565	\N
4952	117	1	0	2027	\N
4952	248	2	0	2028	\N
4889	228	3	0	2898	\N
4889	492	4	0	2901	\N
4961	35	2	0	4257	\N
4915	365	4	0	4531	\N
4915	1253	5	0	4534	\N
4895	189	104	0	4932	\N
4895	1350	105	0	4933	\N
4914	373	1	0	5317	\N
4914	374	2	0	5319	\N
4903	391	1	0	10347	\N
4903	392	2	0	10349	\N
4926	459	1	0	11956	\N
4926	460	2	0	11958	\N
4909	528	3	0	12476	\N
4909	553	4	0	12478	\N
4944	256	1	0	13356	\N
4944	257	2	0	13358	\N
4950	1358	6	0	13486	\N
4925	402	1	0	14077	\N
4925	403	2	0	14082	\N
4878	173	1	0	14642	\N
4878	396	2	0	14644	\N
4887	173	2	0	14648	\N
4887	480	3	0	14649	\N
4871	235	1	0	15647	\N
4871	236	2	0	15649	\N
4943	115	1	0	16662	\N
4943	116	2	0	16663	\N
4918	167	1	0	17765	\N
4957	413	1	0	18358	\N
4957	414	2	0	18359	\N
4933	198	2	0	20060	\N
4933	1139	3	0	20061	\N
4919	241	1	0	20426	\N
4919	333	2	0	20428	\N
4920	488	1	0	21445	\N
4920	489	2	0	21450	\N
4902	1351	0	0	22346	\N
4949	73	1	0	22515	\N
4949	74	2	0	22516	\N
4947	69	1	0	24715	\N
4874	789	127	0	25066	\N
4860	1343	116	0	25203	\N
4860	411	122	0	25214	\N
4860	1344	123	0	25215	\N
4929	90	3	0	26042	\N
4929	877	4	0	26043	\N
4939	86	17	0	26427	\N
4940	86	1	0	26428	\N
4940	87	2	0	26429	\N
4939	1357	18	0	26433	\N
4892	16	1	0	28006	\N
4938	16	1	0	28007	\N
4938	17	2	0	28009	\N
4948	96	1	0	29499	\N
4948	97	2	0	29502	\N
4883	33	3	0	31814	\N
4883	1348	4	0	31819	\N
4916	1	2	0	34145	\N
4916	112	3	0	34146	\N
4922	1	1	0	34147	\N
4922	53	2	0	34148	\N
4937	1	1	0	34149	\N
4941	1	1	0	34150	\N
4954	1	1	0	34151	\N
4937	53	2	0	34153	\N
4941	53	2	0	34154	\N
4954	53	2	0	34155	\N
4959	53	2	0	34156	\N
4955	2	1	0	35590	\N
4955	26	2	0	35591	\N
4956	2	1	0	35597	\N
4956	26	2	0	35598	\N
4866	10	1	0	37937	\N
4866	11	2	0	37939	\N
4875	10	1	0	37940	\N
4875	11	2	0	37941	\N
4936	10	1	0	37950	\N
4912	11	2	0	37953	\N
4936	11	2	0	37954	\N
4942	14	1	0	39321	\N
4942	15	2	0	39322	\N
4945	14	1	0	39333	\N
4951	14	1	0	39334	\N
4945	15	2	0	39335	\N
4951	15	2	0	39336	\N
4847	18	1	0	39754	\N
4847	19	2	0	39755	\N
4901	18	1	0	39757	\N
4904	23	1	0	40689	\N
4904	217	2	0	40690	\N
4930	23	2	0	40714	\N
4930	24	3	0	40716	\N
4978	40	3	0	42755	\N
4997	40	3	0	42756	\N
4978	128	4	0	42758	\N
4997	869	4	0	42759	\N
5082	40	1	0	42785	\N
5082	1383	2	0	42789	\N
5203	40	1	0	42825	\N
5203	41	2	0	42826	\N
5017	75	2	0	45641	\N
5017	159	3	0	45642	\N
5103	75	1	0	45649	\N
5103	76	2	0	45651	\N
5090	88	2	0	47350	\N
5090	154	3	0	47353	\N
5191	88	1	0	47359	\N
5191	89	2	0	47361	\N
4968	160	1	0	47606	\N
4968	100	2	0	47621	\N
5162	113	1	0	48340	\N
5162	437	2	0	48341	\N
5084	170	2	0	50618	\N
5084	718	3	0	50620	\N
5175	170	2	0	50637	\N
5175	718	3	0	50643	\N
5123	181	2	0	50901	\N
5123	769	3	0	50902	\N
4979	186	4	0	51312	\N
5066	186	2	0	51313	\N
5066	696	3	0	51315	\N
4979	1363	5	0	51316	\N
5037	210	2	0	51863	\N
5038	210	2	0	51864	\N
5037	458	3	0	51865	\N
5038	458	3	0	51866	\N
5040	1371	2	0	51878	\N
5040	458	3	0	51879	\N
5039	210	2	0	51880	\N
5039	458	3	0	51881	\N
5087	260	2	0	52429	\N
5087	419	3	0	52430	\N
5098	324	3	0	54307	\N
5098	1384	4	0	54311	\N
4962	362	2	0	54792	\N
4962	420	3	0	54794	\N
5126	597	2	0	55902	\N
5126	767	3	0	55906	\N
5117	1109	1	0	56230	\N
5117	1111	2	0	56233	\N
5183	793	2	0	56737	\N
5183	1136	3	0	56738	\N
5206	841	0	0	56951	\N
5095	908	2	0	57578	\N
5095	988	3	0	57584	\N
5131	267	2	0	1180	\N
5135	111	3	0	2578	\N
5208	110	1	0	2603	\N
5004	228	1	0	2906	\N
5004	229	2	0	2908	\N
4961	36	3	0	4259	\N
5165	373	1	0	5322	\N
5165	374	2	0	5323	\N
5052	132	1	0	11204	\N
5052	455	2	0	11207	\N
4967	123	1	0	12835	\N
4967	124	2	0	12836	\N
4981	173	4	0	14657	\N
4985	174	4	0	14665	\N
4981	1046	5	0	14666	\N
4963	303	2	0	15235	\N
4963	1360	3	0	15241	\N
4982	235	1	0	15648	\N
4982	236	2	0	15650	\N
5151	38	1	0	16400	\N
5151	399	2	0	16401	\N
5029	115	1	0	16675	\N
5029	116	2	0	16676	\N
5045	326	0	0	17329	\N
4966	30	2	0	18005	\N
5146	60	1	0	19476	\N
5146	61	2	0	19478	\N
5062	62	1	0	19715	\N
5062	63	2	0	19718	\N
5148	67	1	0	22228	\N
5148	478	2	0	22229	\N
5061	336	1	0	22739	\N
5061	356	2	0	22740	\N
5069	214	1	0	24356	\N
5081	214	1	0	24358	\N
5081	1382	2	0	24359	\N
5069	215	2	0	24360	\N
5112	50	2	0	25062	\N
5040	1370	2	0	26044	\N
5196	90	1	0	26053	\N
5196	344	2	0	26054	\N
5010	94	1	0	26739	\N
5010	107	2	0	26740	\N
4975	1361	1	0	27169	\N
4975	1362	2	0	27170	\N
5008	16	2	0	28011	\N
5008	445	3	0	28015	\N
5158	16	1	0	28020	\N
5158	17	2	0	28021	\N
5188	155	3	0	28027	\N
5059	320	1	0	29229	\N
5059	334	2	0	29232	\N
4973	54	1	0	30036	\N
4973	55	2	0	30037	\N
5020	360	1	0	31513	\N
5020	479	2	0	31514	\N
4970	453	2	0	32704	\N
4970	902	3	0	32705	\N
4965	1	2	0	34157	\N
4965	112	3	0	34158	\N
4976	1	3	0	34159	\N
5025	2	1	0	35615	\N
5025	26	2	0	35618	\N
5198	2	1	0	35631	\N
5198	26	2	0	35632	\N
4964	10	1	0	37955	\N
4964	11	2	0	37956	\N
4969	10	2	0	37957	\N
4971	10	1	0	37958	\N
4974	10	2	0	37959	\N
4971	11	2	0	37960	\N
4969	29	3	0	37961	\N
4974	792	3	0	37962	\N
5019	29	3	0	37974	\N
5021	10	2	0	37975	\N
5021	29	3	0	37976	\N
5076	10	2	0	37983	\N
5076	29	3	0	37984	\N
5109	10	1	0	37993	\N
5121	10	2	0	37994	\N
5109	11	2	0	37995	\N
5121	29	3	0	37996	\N
5139	10	2	0	37999	\N
5157	10	2	0	38000	\N
5157	29	3	0	38005	\N
4972	14	1	0	39347	\N
4980	14	4	0	39348	\N
4972	15	2	0	39349	\N
4980	588	5	0	39350	\N
4995	14	4	0	39359	\N
4995	1365	5	0	39362	\N
5169	18	1	0	39763	\N
5169	19	2	0	39766	\N
4977	27	3	0	41262	\N
4977	1270	4	0	41263	\N
4998	40	1	0	42772	\N
4998	41	2	0	42774	\N
5144	40	1	0	42788	\N
5144	41	2	0	42791	\N
5132	40	3	0	42800	\N
5132	128	4	0	42802	\N
5207	40	1	0	42833	\N
5207	41	2	0	42834	\N
5046	56	2	0	43847	\N
5046	169	3	0	43848	\N
5130	75	2	0	45650	\N
5130	159	3	0	45652	\N
5185	79	1	0	46421	\N
5185	81	2	0	46422	\N
5026	88	1	0	47348	\N
5100	88	2	0	47351	\N
5026	89	2	0	47352	\N
5100	154	3	0	47354	\N
5286	88	1	0	47360	\N
5286	89	2	0	47362	\N
5155	121	1	0	48936	\N
5155	122	2	0	48937	\N
5296	121	1	0	48947	\N
5296	122	2	0	48949	\N
5091	156	2	0	50235	\N
5091	571	3	0	50237	\N
5067	186	1	0	51338	\N
5067	187	2	0	51341	\N
5168	210	1	0	51888	\N
5168	211	2	0	51889	\N
5120	268	2	0	52787	\N
5269	268	2	0	52788	\N
5120	1387	3	0	52789	\N
5269	1387	3	0	52790	\N
5005	353	1	0	54590	\N
5195	353	1	0	54591	\N
5005	354	2	0	54594	\N
5195	354	2	0	54595	\N
5250	597	0	0	55904	\N
5051	852	3	0	57262	\N
5051	1068	4	0	57263	\N
5033	1368	2	0	57849	\N
5264	289	3	0	54	\N
5000	220	1	0	566	\N
5000	221	2	0	567	\N
5041	1372	1	0	1349	\N
5041	1374	2	0	1350	\N
5208	134	2	0	2604	\N
5225	367	1	0	3390	\N
5225	368	2	0	3391	\N
5149	714	2	0	4080	\N
5149	1394	3	0	4084	\N
5060	189	1	0	4936	\N
5060	190	2	0	4937	\N
5289	108	1	0	11701	\N
5177	1399	0	0	12309	\N
5074	123	1	0	12840	\N
5074	124	2	0	12841	\N
5096	77	2	0	13184	\N
5096	216	3	0	13185	\N
5229	402	2	0	14096	\N
5229	1148	3	0	14098	\N
5138	173	2	0	14659	\N
5138	1391	3	0	14667	\N
5278	326	2	0	17336	\N
5278	747	3	0	17338	\N
5011	167	1	0	17773	\N
5011	533	2	0	17776	\N
5218	168	3	0	17777	\N
5053	1376	1	0	17954	\N
5053	1377	2	0	17959	\N
5177	1398	0	0	18745	\N
5147	208	1	0	19307	\N
5147	209	2	0	19310	\N
5215	164	3	0	21186	\N
5215	1405	4	0	21187	\N
5104	145	1	0	21980	\N
5104	153	2	0	21982	\N
5301	67	1	0	22234	\N
5173	73	0	0	22524	\N
5047	336	1	0	22730	\N
5047	356	2	0	22731	\N
5078	149	2	0	23096	\N
5078	1379	3	0	23103	\N
5222	264	1	0	23502	\N
5222	270	2	0	23503	\N
5070	214	3	0	24357	\N
5070	330	4	0	24361	\N
5266	214	1	0	24376	\N
5266	215	2	0	24377	\N
5217	206	1	0	25802	\N
5033	87	1	0	26430	\N
5033	1369	2	0	26438	\N
5193	94	1	0	26744	\N
5193	107	2	0	26745	\N
5261	244	1	0	27261	\N
5261	245	2	0	27264	\N
5013	16	1	0	28012	\N
5013	17	2	0	28013	\N
5063	16	1	0	28016	\N
5154	16	1	0	28017	\N
5063	17	2	0	28018	\N
5154	17	2	0	28019	\N
5187	17	2	0	28026	\N
5303	16	1	0	28030	\N
5271	320	1	0	29230	\N
5271	334	2	0	29233	\N
5115	54	2	0	30052	\N
5115	485	3	0	30060	\N
5210	20	0	0	30476	\N
5212	20	0	0	30478	\N
5213	20	0	0	30483	\N
5022	151	2	0	30702	\N
5022	1366	3	0	30707	\N
4986	202	3	0	31142	\N
5041	1373	1	0	31813	\N
5180	453	5	0	32727	\N
4990	1	1	0	34160	\N
4990	53	2	0	34171	\N
5071	2	1	0	35617	\N
5071	26	2	0	35620	\N
5093	2	1	0	35623	\N
5093	26	2	0	35624	\N
5145	2	2	0	35627	\N
5145	131	3	0	35628	\N
5201	2	2	0	35633	\N
5201	131	3	0	35636	\N
4983	11	2	0	37965	\N
5012	10	1	0	37969	\N
5012	11	2	0	37970	\N
5092	10	1	0	37990	\N
5092	11	2	0	37991	\N
5127	10	2	0	37998	\N
5236	10	0	0	38001	\N
5127	29	3	0	38004	\N
5242	10	0	0	38008	\N
5224	10	1	0	38017	\N
5247	10	1	0	38018	\N
5224	11	2	0	38019	\N
5182	14	1	0	39367	\N
5182	15	2	0	39368	\N
5291	14	1	0	39377	\N
5291	15	2	0	39381	\N
5108	18	1	0	39761	\N
5108	19	2	0	39762	\N
5009	27	1	0	41276	\N
5009	28	2	0	41277	\N
5016	40	1	0	42773	\N
5016	41	2	0	42775	\N
5102	40	1	0	42786	\N
5129	40	2	0	42787	\N
5129	66	3	0	42792	\N
4989	75	2	0	45632	\N
4989	159	3	0	45635	\N
5192	75	1	0	45661	\N
5192	76	2	0	45662	\N
5283	75	1	0	45672	\N
5283	76	2	0	45675	\N
5163	79	1	0	46369	\N
5163	81	2	0	46370	\N
5244	79	1	0	46469	\N
5244	81	2	0	46470	\N
5028	88	0	0	47349	\N
5128	147	2	0	49988	\N
5128	516	3	0	50000	\N
4992	156	1	0	50234	\N
4992	157	2	0	50236	\N
5176	1396	3	1	50466	\N
5176	170	2	0	50638	\N
5073	324	1	0	54306	\N
5073	325	2	0	54309	\N
5170	324	3	0	54332	\N
5170	1384	4	0	54333	\N
5197	324	1	0	54338	\N
5197	325	2	0	54342	\N
5282	451	1	0	55356	\N
5282	584	2	0	55357	\N
5249	595	0	0	55590	\N
5238	597	3	0	55903	\N
5238	1406	4	0	55907	\N
5305	1109	2	0	56246	\N
5305	1412	3	0	56247	\N
5160	1021	1	0	56544	\N
5160	1022	2	0	56551	\N
5231	852	2	0	57275	\N
5231	1325	3	0	57276	\N
5180	1395	8	0	57831	\N
5176	1395	3	0	57835	\N
5180	1404	8	1	58113	\N
5180	1402	6	0	58119	\N
5256	433	3	0	321	\N
5156	515	2	0	1044	\N
5194	117	1	0	2037	\N
5194	248	2	0	2038	\N
5136	110	1	0	2574	\N
5136	134	2	0	2577	\N
5199	367	2	0	3378	\N
5199	651	3	0	3379	\N
4996	189	1	0	4915	\N
4996	190	2	0	4917	\N
5189	189	1	0	4951	\N
5189	190	2	0	4952	\N
5023	391	2	0	10357	\N
5080	391	2	0	10363	\N
5080	1381	3	0	10370	\N
4993	108	1	0	11686	\N
4993	109	2	0	11690	\N
5055	300	1	0	12058	\N
5055	355	2	0	12060	\N
4988	58	1	0	13492	\N
4988	59	2	0	13493	\N
5058	402	1	0	14079	\N
5075	402	4	0	14080	\N
5058	403	2	0	14083	\N
5075	1378	5	0	14087	\N
5024	309	2	0	14469	\N
5152	173	1	0	14660	\N
5152	396	2	0	14663	\N
5036	45	1	0	16081	\N
5036	44	2	0	16097	\N
5263	38	2	0	16411	\N
5263	39	3	0	16412	\N
5293	30	1	0	18012	\N
5293	418	2	0	18013	\N
5068	142	1	0	18563	\N
5068	143	2	0	18564	\N
5161	60	1	0	19492	\N
5065	198	1	0	20074	\N
5065	199	2	0	20078	\N
5150	164	2	0	21160	\N
5150	226	3	0	21161	\N
5277	164	2	0	21198	\N
5277	226	3	0	21199	\N
5110	488	1	0	21446	\N
5274	488	1	0	21447	\N
5110	489	2	0	21451	\N
5274	489	2	0	21452	\N
5015	67	1	0	22218	\N
5015	478	2	0	22220	\N
5050	356	2	0	22735	\N
4994	411	4	0	25229	\N
4994	1364	5	0	25230	\N
5031	411	1	0	25241	\N
5031	412	2	0	25242	\N
5035	87	1	0	26431	\N
5035	86	2	0	26439	\N
5086	42	2	0	27526	\N
5094	42	2	0	27527	\N
5086	681	3	0	27529	\N
5094	681	3	0	27530	\N
4987	16	3	0	28010	\N
5176	1397	4	0	29404	\N
5102	1386	2	1	29414	\N
5116	54	1	0	30053	\N
5295	54	1	0	30056	\N
5116	55	2	0	30057	\N
5295	55	2	0	30059	\N
5308	54	1	0	30068	\N
5308	55	2	0	30069	\N
5140	202	2	0	31143	\N
5140	1392	3	0	31147	\N
5298	360	1	0	31525	\N
5298	479	2	0	31529	\N
5167	33	1	0	31816	\N
5043	163	2	0	31817	\N
5167	163	2	0	31818	\N
5178	322	3	0	32349	\N
5178	1400	4	0	32354	\N
5180	1403	7	1	32728	\N
5003	2	1	0	35611	\N
5003	26	2	0	35612	\N
5260	2	1	0	35634	\N
5260	26	2	0	35635	\N
5186	6	1	0	36358	\N
5186	194	2	0	36359	\N
4984	10	3	0	37964	\N
4984	347	4	0	37966	\N
5007	10	2	0	37967	\N
5007	792	3	0	37968	\N
5088	10	1	0	37986	\N
5088	11	2	0	37987	\N
5089	10	2	0	37989	\N
5089	29	3	0	37992	\N
5122	10	2	0	37997	\N
5240	10	0	0	38002	\N
5122	29	3	0	38003	\N
5171	10	1	0	38007	\N
5204	10	1	0	38013	\N
5204	11	2	0	38015	\N
5077	14	1	0	39360	\N
5077	15	2	0	39361	\N
5049	18	1	0	39758	\N
5049	19	2	0	39760	\N
5102	1385	2	0	41317	\N
5027	40	1	0	42784	\N
5027	41	2	0	42790	\N
5153	40	1	0	42799	\N
5153	41	2	0	42801	\N
5228	40	1	0	42849	\N
5228	41	2	0	42850	\N
5048	79	4	0	46316	\N
5048	589	5	0	46320	\N
5099	102	1	0	47810	\N
5099	103	2	0	47811	\N
5124	102	3	0	47817	\N
5124	1388	4	0	47818	\N
5137	102	2	0	47826	\N
5137	1390	3	0	47827	\N
5105	125	1	0	49263	\N
5105	195	2	0	49267	\N
5241	147	3	0	49989	\N
5241	148	4	0	50001	\N
5079	170	2	0	50617	\N
5079	1380	3	0	50619	\N
5230	170	2	0	50639	\N
5230	718	3	0	50644	\N
5018	181	1	0	50892	\N
5018	530	2	0	50893	\N
5111	324	1	0	54318	\N
5111	325	2	0	54319	\N
5202	435	2	0	54987	\N
5202	481	3	0	54989	\N
5220	451	2	0	55344	\N
5275	451	1	0	55345	\N
5275	584	2	0	55347	\N
5220	452	3	0	55348	\N
5125	595	2	0	55588	\N
5237	595	3	0	55589	\N
5125	768	3	0	55602	\N
5237	813	4	0	55606	\N
5118	1109	0	0	56231	\N
5134	1109	4	0	56238	\N
5134	1389	5	0	56239	\N
5184	1109	1	0	56242	\N
5184	1111	2	0	56243	\N
5246	1021	1	0	56545	\N
5246	1022	2	0	56552	\N
5205	841	1	0	56950	\N
5205	842	2	0	56954	\N
5101	228	1	0	2907	\N
5166	367	2	0	3358	\N
5166	651	3	0	3359	\N
5064	189	1	0	4944	\N
5064	190	2	0	4945	\N
5141	189	2	0	4950	\N
5141	1393	3	0	4953	\N
5106	373	1	0	5320	\N
5106	374	2	0	5321	\N
5133	391	4	0	10364	\N
5133	539	5	0	10372	\N
5054	300	1	0	12057	\N
5054	355	2	0	12059	\N
5072	77	1	0	13175	\N
5002	78	2	0	13176	\N
5072	78	2	0	13177	\N
5227	77	1	0	13192	\N
5227	78	2	0	13193	\N
5083	256	1	0	13357	\N
5083	257	2	0	13359	\N
5270	256	2	0	13361	\N
5270	335	3	0	13363	\N
5057	402	0	0	14078	\N
5034	45	1	0	16080	\N
5219	44	2	0	16093	\N
5219	161	3	0	16098	\N
5044	326	3	0	17328	\N
5044	1375	4	0	17330	\N
5272	765	2	0	18413	\N
5272	1411	3	0	18414	\N
5113	290	1	0	19033	\N
5113	291	2	0	19035	\N
5159	208	1	0	19308	\N
5159	209	2	0	19311	\N
5245	64	1	0	20795	\N
5245	65	2	0	20796	\N
5107	164	1	0	21142	\N
4991	145	1	0	21976	\N
4991	153	2	0	21977	\N
4999	336	1	0	22726	\N
4999	356	2	0	22727	\N
5142	69	2	0	24734	\N
5142	500	3	0	24735	\N
5114	49	1	0	25059	\N
5114	50	2	0	25063	\N
5001	224	1	0	25570	\N
5239	224	3	0	25571	\N
5001	225	2	0	25573	\N
5239	387	4	0	25574	\N
5209	509	3	0	26443	\N
5287	86	2	0	26446	\N
5287	509	3	0	26453	\N
5143	94	2	0	26742	\N
5143	95	3	0	26743	\N
5267	244	2	0	27262	\N
5267	438	3	0	27265	\N
5252	42	2	0	27538	\N
5252	681	3	0	27541	\N
5164	16	1	0	28022	\N
5164	17	2	0	28025	\N
5223	16	1	0	28028	\N
5223	17	2	0	28031	\N
5226	17	2	0	28032	\N
5006	320	1	0	29228	\N
5006	334	2	0	29231	\N
5181	96	1	0	29500	\N
5181	97	2	0	29503	\N
5119	54	2	0	30054	\N
5119	485	3	0	30061	\N
5172	20	0	0	30475	\N
5211	20	0	0	30477	\N
5214	20	0	0	30484	\N
5216	230	1	0	32091	\N
5179	453	5	0	32726	\N
5179	1401	6	0	32729	\N
5032	2	1	0	35616	\N
5032	26	2	0	35619	\N
5284	2	1	0	35637	\N
5284	26	2	0	35638	\N
5190	6	2	0	36364	\N
5190	179	3	0	36365	\N
5232	10	0	0	37938	\N
5233	10	0	0	37946	\N
5234	10	0	0	37951	\N
5235	10	0	0	37952	\N
5014	11	2	0	37972	\N
5030	10	1	0	37977	\N
5042	10	1	0	37978	\N
5056	10	1	0	37979	\N
5030	11	2	0	37980	\N
5042	11	2	0	37981	\N
5056	11	2	0	37982	\N
5085	10	2	0	37985	\N
5085	29	3	0	37988	\N
5200	10	2	0	38010	\N
5243	10	0	0	38011	\N
5200	29	3	0	38012	\N
5221	29	3	0	38016	\N
5248	10	1	0	38021	\N
5248	11	2	0	38022	\N
5280	10	1	0	38024	\N
5280	11	2	0	38026	\N
5299	40	2	0	42859	\N
5299	66	3	0	42865	\N
5292	51	1	0	43549	\N
5452	51	0	0	43550	\N
5292	52	2	0	43552	\N
5322	71	1	0	44758	\N
5322	72	2	0	44759	\N
5376	75	0	0	45673	\N
5423	75	0	0	45674	\N
5442	75	1	0	45688	\N
5442	1427	2	0	45689	\N
5344	79	3	0	46535	\N
5344	272	4	0	46536	\N
5384	79	0	0	46588	\N
5361	88	22	0	47378	\N
5361	1415	23	0	47380	\N
5335	119	1	0	48585	\N
5335	120	2	0	48587	\N
5362	121	2	0	48948	\N
5362	625	3	0	48950	\N
5251	147	0	0	49990	\N
5262	156	2	0	50244	\N
5262	571	3	0	50245	\N
5434	181	0	0	50914	\N
5294	242	1	0	52196	\N
5294	253	2	0	52197	\N
5318	253	1	0	52198	\N
5318	242	2	0	52204	\N
5458	260	7	0	52437	\N
5458	1431	8	0	52438	\N
5422	268	1	0	52793	\N
5422	1422	2	0	52794	\N
5306	273	2	0	52992	\N
5306	1413	3	0	52993	\N
5281	285	1	0	53457	\N
5281	286	2	0	53458	\N
5359	362	1	0	54799	\N
5359	395	2	0	54800	\N
5381	362	0	0	54805	\N
5321	584	1	0	55351	\N
5321	451	2	0	55360	\N
5279	1021	2	0	56546	\N
5279	1048	3	0	56553	\N
5347	793	1	0	56743	\N
5347	1150	2	0	56744	\N
5253	1408	4	0	57850	\N
5413	12	0	0	328	\N
5378	424	0	0	793	\N
5255	1409	0	0	2272	\N
5290	228	1	0	2912	\N
5290	229	2	0	2913	\N
5364	237	2	0	3604	\N
5364	319	3	0	3605	\N
5440	237	1	0	3606	\N
5440	1425	2	0	3608	\N
5420	262	0	0	3865	\N
5439	365	1	0	4542	\N
5439	1424	2	0	4544	\N
5300	189	2	0	4962	\N
5313	189	1	0	4980	\N
5313	190	2	0	4981	\N
5312	391	1	0	10365	\N
5331	391	1	0	10366	\N
5367	391	2	0	10367	\N
5312	392	2	0	10368	\N
5331	392	2	0	10369	\N
5367	406	3	0	10371	\N
5415	391	1	0	10381	\N
5415	1420	2	0	10383	\N
5432	132	3	0	11216	\N
5432	1423	4	0	11218	\N
5390	58	0	0	13507	\N
5311	59	2	0	13508	\N
5410	233	1	0	13849	\N
5410	1418	2	0	13850	\N
5297	173	1	0	14661	\N
5297	396	2	0	14664	\N
5429	92	0	0	15057	\N
5273	235	2	0	15657	\N
5273	1061	3	0	15658	\N
5444	44	0	0	16094	\N
5302	38	1	0	16425	\N
5302	399	2	0	16429	\N
5356	116	2	0	16693	\N
5258	30	0	0	18006	\N
5268	30	2	0	18011	\N
5268	31	3	0	18014	\N
5323	177	1	0	18291	\N
5323	498	2	0	18295	\N
5383	208	0	0	19309	\N
5409	198	0	0	20075	\N
5450	64	1	0	20817	\N
5450	1428	2	0	20819	\N
5349	67	0	0	22248	\N
5446	336	0	0	22745	\N
5314	149	1	0	23097	\N
5314	499	2	0	23101	\N
5388	140	0	0	24062	\N
5328	214	1	0	24392	\N
5328	215	2	0	24395	\N
5339	49	1	0	25060	\N
5339	50	2	0	25064	\N
5457	49	7	0	25067	\N
5393	411	0	0	25248	\N
5316	94	1	0	26746	\N
5316	107	2	0	26747	\N
5397	94	0	0	26748	\N
5253	1407	3	0	27540	\N
5399	42	0	0	27559	\N
5303	17	2	0	28033	\N
5304	16	1	0	28034	\N
5304	17	2	0	28035	\N
5309	16	1	0	28036	\N
5309	17	2	0	28037	\N
5346	16	1	0	28039	\N
5346	17	2	0	28042	\N
5373	16	0	0	28044	\N
5395	320	0	0	29286	\N
5406	96	0	0	29510	\N
5265	55	2	0	30058	\N
5354	33	1	0	31824	\N
5354	163	2	0	31826	\N
5307	230	1	0	32104	\N
5307	287	2	0	32106	\N
5453	1	39	0	34161	\N
5453	1429	40	0	34175	\N
5405	4	0	0	36073	\N
5276	10	2	0	38023	\N
5285	10	1	0	38025	\N
5285	11	2	0	38027	\N
5276	29	3	0	38028	\N
5288	29	3	0	38030	\N
5326	10	1	0	38032	\N
5326	11	2	0	38034	\N
5365	10	1	0	38042	\N
5365	11	2	0	38045	\N
5379	10	1	0	38047	\N
5379	1416	2	0	38048	\N
5424	10	0	0	38053	\N
5428	10	0	0	38054	\N
5435	10	0	0	38055	\N
5417	14	0	0	39378	\N
5418	14	2	0	39379	\N
5337	18	1	0	39764	\N
5370	18	0	0	39765	\N
5337	19	2	0	39767	\N
5402	18	0	0	39768	\N
5343	40	4	0	42860	\N
5394	40	0	0	42861	\N
5403	40	0	0	42862	\N
5430	40	0	0	42863	\N
5474	40	0	0	42864	\N
5343	564	5	0	42866	\N
5483	40	0	0	42877	\N
5490	51	0	0	43555	\N
5369	56	2	0	43849	\N
5369	169	3	0	43850	\N
5389	56	0	0	43851	\N
5464	56	0	0	43852	\N
5493	56	0	0	43853	\N
5480	71	0	0	44768	\N
5448	75	0	0	45702	\N
5471	75	0	0	45716	\N
5360	88	2	0	47377	\N
5360	154	3	0	47379	\N
5412	88	0	0	47386	\N
5414	88	13	0	47387	\N
5414	1419	14	0	47388	\N
5327	102	1	0	47841	\N
5327	103	2	0	47846	\N
5363	125	1	0	49264	\N
5363	195	2	0	49268	\N
5497	125	0	0	49275	\N
5336	156	1	0	50254	\N
5336	157	2	0	50255	\N
5408	156	0	0	50262	\N
5387	181	0	0	50913	\N
5488	186	0	0	51339	\N
5396	242	0	0	52203	\N
5400	242	0	0	52213	\N
5461	242	0	0	52219	\N
5404	273	1	0	53000	\N
5404	1417	2	0	53001	\N
5333	316	1	0	53965	\N
5333	317	2	0	53967	\N
5319	584	1	0	55349	\N
5320	584	1	0	55350	\N
5319	451	2	0	55358	\N
5320	451	2	0	55359	\N
5375	451	0	0	55365	\N
5456	1021	0	0	56547	\N
5348	841	1	0	56970	\N
5348	842	2	0	56971	\N
5353	220	1	0	568	\N
5482	1433	0	0	1057	\N
5445	117	0	0	2047	\N
5477	117	0	0	2054	\N
5350	110	1	0	2620	\N
5350	134	2	0	2622	\N
5392	228	0	0	2920	\N
5459	228	1	0	2921	\N
5459	1432	2	0	2922	\N
5351	222	1	0	5262	\N
5351	223	2	0	5263	\N
5467	391	0	0	10382	\N
5492	391	0	0	10390	\N
5382	256	0	0	13362	\N
5427	256	0	0	13364	\N
5386	233	0	0	13848	\N
5460	233	0	0	13870	\N
5469	402	0	0	14097	\N
5332	258	1	0	14474	\N
5332	309	2	0	14475	\N
5433	258	0	0	14495	\N
5330	192	1	0	15343	\N
5330	193	2	0	15345	\N
5468	115	0	0	16701	\N
5484	212	0	0	17172	\N
5325	177	105	0	18292	\N
5325	1414	106	0	18299	\N
5377	290	0	0	19039	\N
5485	290	0	0	19047	\N
5355	62	1	0	19716	\N
5355	63	2	0	19719	\N
5421	198	0	0	20076	\N
5481	198	0	0	20077	\N
5324	488	1	0	21463	\N
5324	489	2	0	21465	\N
5476	145	0	0	21981	\N
5340	67	1	0	22240	\N
5357	73	2	0	22525	\N
5357	703	3	0	22526	\N
5407	149	0	0	23098	\N
5475	1153	0	0	24948	\N
5457	1430	8	0	25069	\N
5462	206	0	0	25815	\N
5465	206	0	0	25820	\N
5486	206	0	0	25827	\N
5419	90	0	0	26066	\N
5447	90	0	0	26067	\N
5315	86	1	0	26447	\N
5315	87	2	0	26451	\N
5374	244	0	0	27291	\N
5310	42	2	0	27546	\N
5310	681	3	0	27547	\N
5338	16	1	0	28038	\N
5352	16	1	0	28040	\N
5338	17	2	0	28041	\N
5352	17	2	0	28043	\N
5380	16	1	0	28045	\N
5398	16	0	0	28046	\N
5449	16	1	0	28047	\N
5380	1087	2	0	28048	\N
5449	1087	2	0	28049	\N
5495	16	0	0	28051	\N
5366	320	1	0	29253	\N
5366	334	2	0	29254	\N
5463	320	0	0	29306	\N
5472	320	0	0	29324	\N
5334	96	1	0	29509	\N
5334	97	2	0	29518	\N
5341	449	1	0	29847	\N
5341	450	2	0	29848	\N
5443	33	0	0	31825	\N
5372	230	0	0	32105	\N
5489	453	0	0	32738	\N
5416	1091	2	0	35640	\N
5466	2	0	0	35641	\N
5317	11	1	0	38031	\N
5317	10	2	0	38033	\N
5329	10	1	0	38035	\N
5342	10	1	0	38036	\N
5329	11	2	0	38037	\N
5342	11	2	0	38038	\N
5345	10	1	0	38039	\N
5345	11	2	0	38040	\N
5358	10	1	0	38041	\N
5368	10	1	0	38043	\N
5368	11	2	0	38046	\N
5385	10	0	0	38049	\N
5391	10	0	0	38050	\N
5401	10	0	0	38051	\N
5411	10	0	0	38052	\N
5437	10	0	0	38056	\N
5438	10	0	0	38057	\N
5451	10	0	0	38058	\N
5454	10	0	0	38059	\N
5478	10	0	0	38060	\N
5487	10	0	0	38061	\N
5494	10	0	0	38062	\N
5431	18	0	0	39769	\N
5441	18	1	0	39770	\N
5499	18	0	0	39771	\N
5441	1426	2	0	39772	\N
5500	40	0	0	42878	\N
5527	40	0	0	42879	\N
5731	40	0	0	42891	\N
5734	40	0	0	42906	\N
5552	56	0	0	43854	\N
5556	56	0	0	43855	\N
5618	56	0	0	43857	\N
5687	56	0	0	43859	\N
5523	75	0	0	45717	\N
5538	75	0	0	45718	\N
5504	79	1	0	46589	\N
5504	1434	2	0	46590	\N
5529	79	0	0	46627	\N
5665	79	0	0	46663	\N
5807	79	1	0	46734	\N
5807	81	2	0	46735	\N
5541	88	0	0	47393	\N
5548	88	0	0	47394	\N
5672	100	0	0	47631	\N
5635	102	0	0	47842	\N
5627	119	0	0	48586	\N
5744	121	2	0	48956	\N
5744	625	3	0	48957	\N
5795	135	2	0	49537	\N
5517	135	0	0	49539	\N
5653	135	0	0	49541	\N
5795	196	3	0	49543	\N
5516	137	0	0	49837	\N
5599	137	0	0	49850	\N
5591	147	0	0	49992	\N
5551	210	0	0	51902	\N
5513	242	1	0	52220	\N
5513	253	2	0	52221	\N
5532	242	0	0	52226	\N
5543	242	0	0	52235	\N
5510	260	0	0	52441	\N
5713	260	0	0	52444	\N
5534	268	0	0	52797	\N
5679	268	1	0	52798	\N
5679	269	2	0	52799	\N
5700	316	1	0	53982	\N
5700	317	2	0	53987	\N
5783	324	54	0	54340	\N
5783	1465	55	0	54344	\N
5771	436	1	0	54991	\N
5771	1458	2	0	54992	\N
5531	451	0	0	55377	\N
5536	1109	0	0	56257	\N
5762	1021	2	0	56549	\N
5762	1048	3	0	56554	\N
5674	793	0	0	56753	\N
5560	841	1	0	56985	\N
5560	1437	2	0	56988	\N
5768	852	1	0	57296	\N
5768	913	2	0	57297	\N
5546	288	0	0	62	\N
5555	266	0	0	1187	\N
5725	750	0	0	1689	\N
5771	1457	2	0	2326	\N
5646	228	0	0	2927	\N
5651	228	0	0	2928	\N
5779	237	1	0	3607	\N
5779	527	2	0	3609	\N
5834	237	1	0	3610	\N
5518	391	0	0	10391	\N
5530	391	0	0	10396	\N
5533	391	0	0	10397	\N
5549	391	0	0	10406	\N
5725	1450	0	0	11253	\N
5547	108	0	0	11703	\N
5512	300	1	0	12065	\N
5514	300	57	0	12066	\N
5512	355	2	0	12069	\N
5514	1435	58	0	12071	\N
5695	123	0	0	12847	\N
5805	256	2	0	13365	\N
5805	335	3	0	13366	\N
5648	258	0	0	14517	\N
5832	173	1	0	14685	\N
5832	396	2	0	14687	\N
5574	235	0	0	15670	\N
5722	235	0	0	15697	\N
5577	115	0	0	16710	\N
5800	212	2	0	17184	\N
5800	566	3	0	17185	\N
5542	413	0	0	18360	\N
5825	142	1	0	18587	\N
5825	143	2	0	18588	\N
5554	208	0	0	19312	\N
5605	208	0	0	19313	\N
5505	60	0	0	19493	\N
5726	60	1	0	19507	\N
5820	61	2	0	19510	\N
5726	1451	2	0	19512	\N
5677	198	0	0	20084	\N
5692	64	0	0	20818	\N
5520	164	0	0	21230	\N
5766	164	2	0	21246	\N
5766	226	3	0	21247	\N
5615	488	0	0	21464	\N
5508	145	0	0	21986	\N
5537	73	0	0	22537	\N
5583	336	0	0	22747	\N
5797	336	1	0	22759	\N
5708	49	0	0	25068	\N
5668	345	0	0	26291	\N
5790	86	1	0	26449	\N
5790	87	2	0	26452	\N
5519	94	0	0	26749	\N
5683	94	1	0	26751	\N
5683	107	2	0	26754	\N
5528	16	0	0	28052	\N
5540	16	1	0	28053	\N
5608	16	0	0	28055	\N
5540	1436	2	0	28056	\N
5739	16	1	0	28062	\N
5503	320	0	0	29325	\N
5525	320	0	0	29342	\N
5524	449	0	0	29862	\N
5521	151	0	0	30703	\N
5658	360	0	0	31526	\N
5742	360	1	0	31528	\N
5742	479	2	0	31531	\N
5759	33	2	0	31838	\N
5759	34	3	0	31839	\N
5509	230	0	0	32111	\N
5545	322	0	0	32350	\N
5697	322	0	0	32351	\N
5785	2	3	0	35644	\N
5815	2	2	0	35645	\N
5815	131	3	0	35646	\N
5785	1466	4	0	35647	\N
5515	6	0	0	36379	\N
5603	8	0	0	36487	\N
5502	10	0	0	38064	\N
5507	10	0	0	38065	\N
5511	10	0	0	38066	\N
5522	10	0	0	38067	\N
5526	10	0	0	38068	\N
5539	10	1	0	38069	\N
5544	10	0	0	38071	\N
5569	10	0	0	38072	\N
5611	10	0	0	38077	\N
5633	10	0	0	38079	\N
5702	10	0	0	38083	\N
5829	10	2	0	38095	\N
5829	29	3	0	38097	\N
5550	18	0	0	39773	\N
5610	40	0	0	42881	\N
5778	40	2	0	42912	\N
5778	66	3	0	42914	\N
5787	40	3	0	42918	\N
5801	40	1	0	42919	\N
5845	40	1	0	42920	\N
5938	40	1	0	42923	\N
5801	41	2	0	42924	\N
5845	41	2	0	42925	\N
5938	41	2	0	42927	\N
5787	1467	4	0	42929	\N
5789	56	3	0	43862	\N
5863	56	2	0	43863	\N
5863	169	3	0	43865	\N
5789	1469	4	0	43867	\N
5698	75	0	0	45720	\N
5935	79	1	0	46794	\N
5935	81	2	0	46796	\N
5637	102	0	0	47844	\N
5956	113	1	0	48349	\N
5956	437	2	0	48350	\N
5951	121	1	0	48962	\N
5951	122	2	0	48964	\N
5655	137	0	0	49851	\N
5568	147	0	0	49991	\N
5723	156	0	0	50263	\N
5817	156	2	0	50264	\N
5817	571	3	0	50265	\N
5891	181	5	0	50922	\N
5891	1484	6	0	50923	\N
5791	200	1	0	51561	\N
5791	201	2	0	51562	\N
5923	242	1	0	52243	\N
5923	253	2	0	52247	\N
5908	273	2	0	53013	\N
5908	1159	3	0	53014	\N
5557	285	0	0	53469	\N
5565	285	0	0	53488	\N
5598	285	0	0	53489	\N
5784	324	2	0	54341	\N
5784	486	3	0	54343	\N
5837	1478	6	0	54490	\N
5595	353	0	0	54592	\N
5711	353	0	0	54601	\N
5764	435	3	0	54988	\N
5764	1456	4	0	54990	\N
5823	597	1	0	55932	\N
5823	598	2	0	55938	\N
5919	1491	4	0	56586	\N
5809	908	1	0	57582	\N
5809	909	2	0	57583	\N
5837	1480	7	1	57861	\N
5813	1470	1	0	58208	\N
5813	1471	2	0	58209	\N
5843	266	3	0	1188	\N
5911	237	1	0	3611	\N
5834	527	2	0	3612	\N
5911	527	2	0	3613	\N
5604	365	0	0	4543	\N
5585	391	0	0	10407	\N
5851	391	1	0	10427	\N
5851	392	2	0	10429	\N
5676	108	0	0	11713	\N
5822	459	1	0	11967	\N
5822	460	2	0	11968	\N
5706	300	0	0	12067	\N
5758	528	1	0	12493	\N
5619	123	0	0	12846	\N
5915	256	3	0	13367	\N
5915	1488	4	0	13373	\N
5685	58	0	0	13525	\N
5691	402	0	0	14105	\N
5652	258	0	0	14522	\N
5562	192	0	0	15344	\N
5837	1479	7	0	15935	\N
5837	1269	1	0	16082	\N
5839	1269	1	0	16083	\N
5840	1269	1	0	16084	\N
5837	44	5	0	16100	\N
5840	44	5	0	16102	\N
5839	1481	6	0	16103	\N
5840	1481	6	0	16104	\N
5718	1448	2	0	18801	\N
5718	1449	3	0	18804	\N
5846	290	1	0	19058	\N
5846	291	2	0	19061	\N
5940	60	3	0	19509	\N
5940	1493	4	0	19511	\N
5624	62	0	0	19724	\N
5693	62	0	0	19725	\N
5900	64	1	0	20826	\N
5966	164	1	0	21283	\N
5966	165	2	0	21285	\N
5647	488	0	0	21473	\N
5681	488	1	0	21474	\N
5681	489	2	0	21478	\N
5837	1355	6	1	21724	\N
5873	145	2	0	22006	\N
5873	331	3	0	22008	\N
5748	73	1	0	22547	\N
5748	74	2	0	22548	\N
5673	411	0	0	25249	\N
5781	224	1	0	25585	\N
5885	86	0	0	26450	\N
5875	94	1	0	26753	\N
5875	107	2	0	26756	\N
5602	16	0	0	28054	\N
5657	16	0	0	28058	\N
5774	16	2	0	28063	\N
5853	16	2	0	28066	\N
5853	155	3	0	28067	\N
5895	16	1	0	28070	\N
5895	17	2	0	28071	\N
5901	16	1	0	28073	\N
5901	17	2	0	28075	\N
5953	17	2	0	28079	\N
5828	20	1	0	30485	\N
5828	144	2	0	30486	\N
5745	33	1	0	31831	\N
5745	163	2	0	31832	\N
5645	230	0	0	32120	\N
5715	322	0	0	32352	\N
5727	453	1	0	32739	\N
5727	1452	2	0	32740	\N
5856	1	0	0	34162	\N
5860	1	0	0	34165	\N
5883	1	0	0	34169	\N
5959	1233	6	0	34179	\N
5750	4	1	0	36081	\N
5830	4	1	0	36082	\N
5750	25	2	0	36083	\N
5830	25	2	0	36084	\N
5613	6	0	0	36380	\N
5579	10	0	0	38073	\N
5582	10	0	0	38074	\N
5588	10	0	0	38075	\N
5593	10	0	0	38076	\N
5634	10	0	0	38080	\N
5753	10	3	0	38086	\N
5799	10	2	0	38091	\N
5799	29	3	0	38092	\N
5811	10	2	0	38094	\N
5811	29	3	0	38096	\N
5943	14	1	0	39404	\N
5943	15	2	0	39405	\N
5571	18	0	0	39774	\N
5946	27	2	0	41288	\N
5946	619	3	0	41291	\N
5570	40	1	0	42880	\N
5680	40	1	0	42882	\N
5680	41	2	0	42883	\N
5570	1244	2	0	42884	\N
5855	40	1	0	42921	\N
5855	41	2	0	42926	\N
5572	56	0	0	43856	\N
5558	75	0	0	45719	\N
5740	75	1	0	45727	\N
5740	76	2	0	45728	\N
5581	79	0	0	46628	\N
5636	102	0	0	47843	\N
5684	121	0	0	48955	\N
5796	137	2	0	49852	\N
5796	197	3	0	49854	\N
5905	170	1	0	50640	\N
5905	398	2	0	50642	\N
5563	181	0	0	50915	\N
5808	210	1	0	51903	\N
5827	210	1	0	51904	\N
5808	211	2	0	51907	\N
5827	211	2	0	51908	\N
5936	268	1	0	52804	\N
5936	269	2	0	52805	\N
5690	273	0	0	53006	\N
5642	285	0	0	53490	\N
5643	285	0	0	53491	\N
5769	316	1	0	53983	\N
5769	317	2	0	53988	\N
5867	324	2	0	54348	\N
5867	486	3	0	54351	\N
5714	353	4	0	54602	\N
5714	1445	5	0	54603	\N
5678	389	13	0	54931	\N
5678	1443	14	0	54937	\N
5587	595	0	0	55592	\N
5584	597	0	0	55931	\N
5649	1021	0	0	56548	\N
5871	841	1	0	56986	\N
5871	842	2	0	56987	\N
5752	852	1	0	57289	\N
5752	913	2	0	57290	\N
5760	908	2	0	57580	\N
5798	908	2	0	57581	\N
5760	988	3	0	57585	\N
5798	988	3	0	57586	\N
5803	12	1	0	339	\N
5589	367	0	0	3415	\N
5835	262	1	0	3866	\N
5835	263	2	0	3869	\N
5777	1463	4	0	4105	\N
5777	1464	5	0	4106	\N
5934	365	1	0	4580	\N
5934	366	2	0	4583	\N
5601	391	0	0	10408	\N
5656	1442	14	1	11061	\N
5656	1441	11	0	11220	\N
5656	132	13	0	11233	\N
5841	108	1	0	11714	\N
5868	108	3	0	11725	\N
5868	837	4	0	11730	\N
5592	348	0	0	12317	\N
5932	402	1	0	14112	\N
5932	403	2	0	14114	\N
5659	173	0	0	14674	\N
5774	1460	3	1	15580	\N
5887	38	0	0	16426	\N
5631	326	1	0	17349	\N
5631	327	2	0	17350	\N
5710	167	1	0	17775	\N
5710	1444	2	0	17778	\N
5894	533	2	0	17799	\N
5903	30	1	0	18016	\N
5903	418	2	0	18019	\N
5566	290	0	0	19048	\N
5597	62	0	0	19717	\N
5844	62	1	0	19726	\N
5844	63	2	0	19727	\N
5847	241	1	0	20427	\N
5890	164	0	0	21280	\N
5929	488	2	0	21476	\N
5929	729	3	0	21481	\N
5609	1440	0	0	21632	\N
5732	145	0	0	21991	\N
5849	145	1	0	21992	\N
5849	153	2	0	21993	\N
5917	67	3	0	22241	\N
5917	1489	4	0	22245	\N
5666	73	0	0	22546	\N
5639	264	0	0	23510	\N
5780	264	2	0	23512	\N
5780	265	3	0	23513	\N
5893	206	5	0	25843	\N
5893	1486	6	0	25847	\N
5720	90	0	0	26080	\N
5688	244	0	0	27317	\N
5848	244	1	0	27331	\N
5848	245	2	0	27333	\N
5818	42	1	0	27579	\N
5818	43	2	0	27580	\N
5675	16	0	0	28059	\N
5717	16	2	0	28060	\N
5717	1447	3	0	28061	\N
5774	1462	4	1	28065	\N
5879	16	2	0	28068	\N
5879	155	3	0	28069	\N
5898	16	1	0	28072	\N
5926	16	1	0	28076	\N
5926	17	2	0	28078	\N
5735	96	0	0	29511	\N
5842	96	3	0	29512	\N
5842	834	4	0	29519	\N
5793	449	1	0	29863	\N
5793	450	2	0	29864	\N
5921	151	1	0	30714	\N
5921	302	2	0	30718	\N
5939	202	1	0	31144	\N
5877	453	1	0	32751	\N
5877	454	2	0	32754	\N
5861	1	0	0	34166	\N
5884	1	3	0	34170	\N
5884	1483	4	0	34174	\N
5705	2	0	0	35643	\N
5669	6	0	0	36387	\N
5628	10	0	0	38078	\N
5663	10	0	0	38081	\N
5747	10	1	0	38084	\N
5747	11	2	0	38085	\N
5757	10	1	0	38087	\N
5757	11	2	0	38088	\N
5763	10	3	0	38090	\N
5838	1239	1	0	38100	\N
5838	10	5	0	38101	\N
5838	465	6	0	38102	\N
5857	10	2	0	38103	\N
5857	29	3	0	38104	\N
5864	10	2	0	38105	\N
5889	10	0	0	38106	\N
5925	10	1	0	38107	\N
5925	11	2	0	38108	\N
5864	29	3	0	38109	\N
5816	14	2	0	39392	\N
5821	14	1	0	39393	\N
5821	15	2	0	39395	\N
5881	15	2	0	39396	\N
5816	383	3	0	39397	\N
5612	18	0	0	39775	\N
5770	40	2	0	42913	\N
5836	1244	1	0	42915	\N
5886	40	0	0	42922	\N
5836	40	5	0	42928	\N
5775	51	2	0	43556	\N
5775	524	3	0	43557	\N
5620	56	0	0	43858	\N
5761	56	1	0	43860	\N
5761	57	2	0	43861	\N
5712	71	0	0	44769	\N
5909	71	1	0	44770	\N
5909	72	2	0	44771	\N
5754	75	3	0	45733	\N
5754	857	4	0	45734	\N
5782	79	2	0	46695	\N
5782	80	3	0	46696	\N
5967	79	2	0	46828	\N
5967	80	3	0	46829	\N
5622	88	0	0	47395	\N
5696	88	0	0	47396	\N
5638	102	0	0	47845	\N
5736	125	0	0	49279	\N
5600	135	0	0	49540	\N
5826	147	1	0	49993	\N
5826	599	2	0	49998	\N
5756	200	1	0	51548	\N
5756	201	2	0	51550	\N
5590	242	0	0	52242	\N
5699	260	1	0	52442	\N
5699	261	2	0	52443	\N
5660	324	0	0	54339	\N
5866	1482	52	0	54345	\N
5866	324	56	0	54352	\N
5866	1384	57	0	54353	\N
5836	1472	6	0	54495	\N
5596	353	11	0	54593	\N
5596	1439	12	0	54596	\N
5567	595	0	0	55591	\N
5824	595	1	0	55593	\N
5824	596	2	0	55600	\N
5564	597	0	0	55930	\N
5836	1474	7	0	56593	\N
5559	841	0	0	56984	\N
5972	841	1	0	56993	\N
5972	842	2	0	56994	\N
5578	852	0	0	57285	\N
5650	908	0	0	57579	\N
5854	908	1	0	57599	\N
5854	909	2	0	57600	\N
5836	1475	7	1	58117	\N
5614	251	0	0	1513	\N
5716	117	2	0	2055	\N
5716	1446	3	0	2062	\N
5812	110	2	0	2621	\N
5812	111	3	0	2623	\N
5874	228	2	0	2929	\N
5874	511	3	0	2930	\N
5746	1454	1	0	10068	\N
5746	1455	2	0	10069	\N
5788	391	3	0	10418	\N
5788	1468	4	0	10419	\N
5920	300	1	0	12068	\N
5920	355	2	0	12070	\N
5982	528	2	0	12495	\N
5897	58	1	0	13532	\N
5897	59	2	0	13533	\N
5607	233	0	0	13871	\N
5707	233	0	0	13884	\N
5912	233	0	0	13885	\N
5831	402	1	0	14106	\N
5831	403	2	0	14107	\N
5576	258	0	0	14505	\N
5738	1453	0	0	15242	\N
5870	192	2	0	15356	\N
5870	838	3	0	15357	\N
5954	1061	3	0	15705	\N
5907	1291	1	0	16935	\N
5907	1292	2	0	16936	\N
5878	212	1	0	17195	\N
5878	213	2	0	17196	\N
5730	167	0	0	17783	\N
5928	142	2	0	18596	\N
5928	656	3	0	18600	\N
5682	198	1	0	20102	\N
5682	199	2	0	20104	\N
5847	333	2	0	20429	\N
5892	164	5	0	21281	\N
5586	1438	0	0	21381	\N
5977	489	1	0	21466	\N
5694	488	0	0	21475	\N
5977	488	2	0	21479	\N
5625	145	0	0	21987	\N
5630	149	1	0	23099	\N
5662	149	0	0	23100	\N
5630	499	2	0	23102	\N
5765	149	3	0	23112	\N
5765	150	4	0	23113	\N
5810	149	1	0	23125	\N
5810	499	2	0	23128	\N
5664	214	0	0	24393	\N
5704	214	0	0	24394	\N
5916	214	3	0	24416	\N
5916	330	4	0	24417	\N
5594	69	0	0	24746	\N
5671	69	0	0	24747	\N
5728	49	0	0	25070	\N
5561	206	0	0	25833	\N
5575	206	0	0	25840	\N
5580	86	0	0	26448	\N
5617	94	0	0	26750	\N
5749	94	1	0	26752	\N
5629	16	0	0	28057	\N
5802	151	1	0	30704	\N
5802	302	2	0	30705	\N
5741	360	1	0	31527	\N
5741	479	2	0	31530	\N
5751	360	1	0	31538	\N
5751	479	2	0	31539	\N
5888	230	0	0	32121	\N
5913	323	1	0	32353	\N
5913	322	2	0	32355	\N
5970	322	2	0	32356	\N
5970	833	3	0	32359	\N
5876	53	2	0	34172	\N
5904	1	1	0	34176	\N
5904	53	2	0	34178	\N
5962	1	1	0	34180	\N
5962	53	2	0	34181	\N
5902	4	1	0	36091	\N
5902	25	2	0	36092	\N
5814	6	1	0	36388	\N
5814	194	2	0	36389	\N
5914	6	1	0	36403	\N
5914	194	2	0	36404	\N
5686	10	0	0	38082	\N
5833	11	2	0	38099	\N
5931	10	2	0	38110	\N
5931	29	3	0	38111	\N
5667	18	0	0	39776	\N
5689	18	0	0	39777	\N
5794	18	2	0	39778	\N
5794	218	3	0	39779	\N
5927	18	1	0	39780	\N
5949	18	1	0	39781	\N
5927	19	2	0	39782	\N
5949	19	2	0	39783	\N
5836	1473	6	1	41331	\N
5989	40	1	0	42936	\N
5989	41	2	0	42938	\N
6000	56	4	0	43864	\N
6000	185	5	0	43866	\N
6057	56	1	0	43870	\N
6057	57	2	0	43876	\N
5850	79	1	0	46762	\N
5850	81	2	0	46763	\N
5945	79	2	0	46795	\N
5945	80	3	0	46797	\N
6129	100	1	0	47658	\N
6129	160	2	0	47660	\N
5865	156	2	0	50274	\N
5865	571	3	0	50275	\N
5906	170	0	0	50641	\N
6096	170	2	0	50653	\N
6096	718	3	0	50654	\N
6086	210	1	0	51905	\N
6086	211	2	0	51909	\N
5952	242	1	0	52244	\N
5952	253	2	0	52248	\N
6117	268	0	0	52809	\N
5948	273	1	0	53020	\N
6032	273	1	0	53021	\N
5948	410	2	0	53022	\N
6032	410	2	0	53023	\N
5944	285	1	0	53498	\N
5944	286	2	0	53499	\N
5963	316	1	0	53984	\N
5963	317	2	0	53989	\N
5991	324	1	0	54349	\N
5991	325	2	0	54350	\N
5872	362	2	0	54808	\N
5872	420	3	0	54809	\N
5964	362	1	0	54814	\N
5976	362	1	0	54815	\N
5964	395	2	0	54816	\N
5976	395	2	0	54817	\N
6059	793	2	0	56755	\N
6059	1136	3	0	56756	\N
5942	852	3	0	57306	\N
5957	852	1	0	57307	\N
5957	913	2	0	57313	\N
5942	1068	4	0	57316	\N
5836	1476	8	0	57862	\N
6040	424	2	0	805	\N
5947	1494	3	0	1673	\N
6120	117	1	0	2057	\N
6120	248	2	0	2060	\N
5836	1477	8	1	2325	\N
6090	110	2	0	2632	\N
6131	110	2	0	2633	\N
6090	111	3	0	2638	\N
6027	228	1	0	2933	\N
6027	229	2	0	2936	\N
5922	367	1	0	3416	\N
5922	368	2	0	3418	\N
5880	714	2	0	4081	\N
6021	35	3	0	4258	\N
5882	365	0	0	4565	\N
5852	391	1	0	10428	\N
5852	392	2	0	10430	\N
5968	391	2	0	10434	\N
5968	406	3	0	10442	\N
6016	77	1	0	13201	\N
6016	78	2	0	13203	\N
5930	233	2	0	13886	\N
5930	910	3	0	13887	\N
5971	233	2	0	13896	\N
5971	910	3	0	13897	\N
5933	402	28	0	14113	\N
5933	1492	29	0	14115	\N
6070	258	1	0	14527	\N
6070	309	2	0	14530	\N
5980	396	1	0	14675	\N
5980	173	2	0	14688	\N
6019	92	1	0	15081	\N
6019	191	2	0	15083	\N
6064	235	1	0	15712	\N
6064	236	2	0	15713	\N
5941	167	3	0	17796	\N
5941	521	4	0	17803	\N
5899	418	2	0	18018	\N
5997	208	5	0	19314	\N
5997	1497	6	0	19328	\N
6074	198	1	0	20103	\N
6074	199	2	0	20105	\N
5869	164	3	0	21269	\N
5869	307	4	0	21270	\N
5965	164	1	0	21282	\N
5965	165	2	0	21284	\N
5995	1495	2	0	21382	\N
5995	1496	3	0	21383	\N
6037	488	2	0	21489	\N
5958	67	2	0	22242	\N
5958	68	3	0	22244	\N
6079	69	2	0	24767	\N
6079	500	3	0	24770	\N
5950	49	1	0	25071	\N
5950	50	2	0	25072	\N
5918	206	3	0	25844	\N
5918	1490	4	0	25846	\N
6024	90	2	0	26085	\N
6024	91	3	0	26088	\N
5955	94	1	0	26757	\N
5955	107	2	0	26758	\N
5910	43	2	0	27595	\N
6052	16	1	0	28080	\N
6052	17	2	0	28081	\N
5924	54	1	0	30074	\N
5924	55	2	0	30075	\N
5939	203	2	0	31145	\N
5961	360	1	0	31546	\N
5961	479	2	0	31547	\N
6091	33	3	0	31873	\N
6091	1348	4	0	31874	\N
5858	1	0	0	34163	\N
5862	1	0	0	34167	\N
6007	112	3	0	34187	\N
6072	1	1	0	34193	\N
6072	53	2	0	34194	\N
6108	1	4	0	34198	\N
6108	1194	5	0	34203	\N
5896	431	5	0	34769	\N
5896	1487	6	0	34770	\N
6062	6	2	0	36409	\N
6101	6	1	0	36410	\N
6101	194	2	0	36411	\N
6062	179	3	0	36412	\N
6127	6	1	0	36413	\N
5937	10	1	0	38112	\N
5937	11	2	0	38113	\N
5973	10	1	0	38114	\N
5975	10	1	0	38115	\N
5973	11	2	0	38116	\N
5975	11	2	0	38117	\N
6002	10	1	0	38122	\N
6002	11	2	0	38124	\N
6045	10	1	0	38128	\N
6045	11	2	0	38131	\N
6110	10	1	0	38138	\N
6110	11	2	0	38142	\N
5960	19	2	0	39785	\N
6093	18	3	0	39790	\N
6093	127	4	0	39793	\N
6050	27	2	0	41289	\N
6050	619	3	0	41292	\N
5969	40	2	0	42932	\N
5969	66	3	0	42933	\N
5996	40	5	0	42937	\N
5996	385	6	0	42939	\N
6026	40	1	0	42942	\N
6026	41	2	0	42943	\N
6020	71	1	0	44792	\N
6020	72	2	0	44793	\N
6073	71	1	0	44804	\N
6073	72	2	0	44807	\N
6081	75	2	0	44977	\N
6081	159	3	0	44978	\N
6083	79	0	0	46850	\N
6065	100	1	0	47645	\N
6065	160	2	0	47646	\N
5983	113	1	0	48357	\N
5983	437	2	0	48358	\N
5986	125	2	0	49285	\N
6058	125	1	0	49286	\N
6058	195	2	0	49289	\N
5986	188	3	0	49291	\N
6017	135	1	0	49538	\N
6017	136	2	0	49542	\N
6085	200	1	0	51567	\N
6085	201	2	0	51568	\N
6056	260	1	0	52445	\N
6099	260	2	0	52446	\N
6056	261	2	0	52448	\N
6099	419	3	0	52449	\N
6124	268	0	0	52819	\N
5978	409	1	0	53743	\N
5979	409	1	0	53744	\N
5978	338	2	0	53746	\N
5979	338	2	0	53747	\N
5988	316	1	0	53985	\N
5988	317	2	0	53990	\N
6042	435	2	0	54993	\N
6042	481	3	0	54994	\N
6029	793	3	0	56754	\N
6029	1169	4	0	56757	\N
6160	841	1	0	57003	\N
6160	842	2	0	57005	\N
6112	13	2	0	350	\N
6039	424	2	0	804	\N
6144	734	1	0	1076	\N
6144	1508	2	0	1077	\N
6119	117	1	0	2056	\N
6121	117	1	0	2058	\N
6119	248	2	0	2059	\N
6121	248	2	0	2061	\N
6131	111	3	0	2639	\N
6003	228	1	0	2931	\N
6003	229	2	0	2932	\N
6076	365	2	0	4581	\N
6076	519	3	0	4585	\N
6087	392	2	0	10440	\N
6001	108	1	0	11726	\N
6133	108	1	0	11727	\N
6001	109	2	0	11728	\N
6133	109	2	0	11729	\N
5981	528	2	0	12494	\N
5981	613	3	0	12497	\N
6036	77	1	0	13202	\N
6036	78	2	0	13204	\N
6103	256	1	0	13368	\N
6103	257	2	0	13371	\N
6069	402	1	0	14120	\N
6004	92	1	0	15073	\N
6004	191	2	0	15074	\N
6047	92	1	0	15082	\N
6047	191	2	0	15084	\N
5984	192	2	0	15364	\N
5984	838	3	0	15367	\N
6107	235	4	0	15720	\N
6107	1506	5	0	15721	\N
6023	44	2	0	16095	\N
6023	161	3	0	16099	\N
6009	326	1	0	17355	\N
6009	327	2	0	17358	\N
6105	1505	6	0	17369	\N
6078	167	2	0	17797	\N
6135	167	1	0	17798	\N
6135	533	2	0	17800	\N
6078	168	3	0	17802	\N
6134	208	1	0	19315	\N
6134	209	2	0	19322	\N
6014	60	1	0	19521	\N
6014	61	2	0	19523	\N
6034	488	1	0	21477	\N
6034	489	2	0	21480	\N
6158	73	1	0	22555	\N
5974	214	1	0	24428	\N
5974	215	2	0	24429	\N
5994	69	2	0	24753	\N
6018	69	1	0	24754	\N
6018	70	2	0	24755	\N
5994	500	3	0	24756	\N
6080	94	1	0	26759	\N
6080	107	2	0	26761	\N
6006	244	1	0	27332	\N
6006	245	2	0	27334	\N
6156	244	1	0	27341	\N
6156	245	2	0	27343	\N
6054	17	2	0	28084	\N
6146	96	0	0	29514	\N
6149	96	0	0	29517	\N
6049	678	2	0	30913	\N
6049	1501	3	0	30915	\N
5999	360	4	0	31552	\N
5999	467	5	0	31555	\N
6067	453	3	0	32752	\N
6067	1503	4	0	32756	\N
5993	1	2	0	34184	\N
5993	112	3	0	34186	\N
6013	1	1	0	34188	\N
6088	1	1	0	34196	\N
6088	53	2	0	34197	\N
6140	1	1	0	34204	\N
6140	53	2	0	34205	\N
6153	1	1	0	34206	\N
6153	53	2	0	34211	\N
6136	2	1	0	35650	\N
6136	26	2	0	35652	\N
6061	4	2	0	36098	\N
6061	579	3	0	36101	\N
5990	10	1	0	38120	\N
5990	11	2	0	38121	\N
6011	11	2	0	38125	\N
6044	10	1	0	38126	\N
6044	11	2	0	38127	\N
6063	10	1	0	38129	\N
6066	10	3	0	38130	\N
6063	11	2	0	38132	\N
6066	347	4	0	38133	\N
6089	10	1	0	38134	\N
6089	11	2	0	38135	\N
6114	10	1	0	38139	\N
6114	11	2	0	38143	\N
6151	10	1	0	38154	\N
6031	18	3	0	39786	\N
6031	127	4	0	39787	\N
6046	18	1	0	39788	\N
6046	19	2	0	39789	\N
6041	23	2	0	40715	\N
6041	24	3	0	40717	\N
6051	1502	7	0	41278	\N
6051	27	8	0	41293	\N
6097	40	2	0	42950	\N
6097	66	3	0	42951	\N
6170	40	1	0	42954	\N
6170	41	2	0	42957	\N
6005	56	1	0	43868	\N
6053	56	1	0	43869	\N
6005	57	2	0	43874	\N
6053	57	2	0	43875	\N
6015	71	1	0	44782	\N
6015	72	2	0	44783	\N
6071	71	1	0	44803	\N
6071	72	2	0	44806	\N
6106	75	1	0	44981	\N
6106	76	2	0	44984	\N
6012	75	1	0	45745	\N
6012	76	2	0	45746	\N
6082	102	2	0	47849	\N
6084	102	0	0	47850	\N
6082	158	3	0	47851	\N
6022	113	2	0	48371	\N
6022	114	3	0	48373	\N
6102	268	1	0	52808	\N
6118	268	3	0	52810	\N
6102	269	2	0	52811	\N
6118	610	4	0	52812	\N
6165	268	1	0	52822	\N
6165	269	2	0	52824	\N
6048	338	1	0	53752	\N
6048	409	2	0	53754	\N
6172	324	1	0	54356	\N
6172	325	2	0	54357	\N
6161	908	1	0	57609	\N
6161	909	2	0	57612	\N
6128	13	2	0	360	\N
6060	821	3	0	572	\N
6132	110	1	0	2634	\N
6157	110	1	0	2635	\N
6132	134	2	0	2636	\N
6157	134	2	0	2637	\N
6111	228	1	0	2934	\N
6111	229	2	0	2937	\N
6033	237	1	0	3614	\N
6033	527	2	0	3616	\N
6130	365	1	0	4582	\N
6130	366	2	0	4584	\N
6163	365	3	0	4595	\N
6068	373	2	0	5324	\N
6068	1504	3	0	5325	\N
6154	391	1	0	10436	\N
6154	392	2	0	10441	\N
6174	391	4	0	10452	\N
6174	539	5	0	10456	\N
6030	132	3	0	11217	\N
6030	814	4	0	11219	\N
6075	300	2	0	12076	\N
6075	706	3	0	12086	\N
5982	613	3	0	12498	\N
6035	123	3	0	12850	\N
6109	256	4	0	13369	\N
6159	256	1	0	13370	\N
6159	257	2	0	13372	\N
6109	1507	5	0	13374	\N
6038	58	2	0	13552	\N
6038	665	3	0	13553	\N
6167	233	1	0	13918	\N
6167	234	2	0	13923	\N
6152	173	1	0	14686	\N
6152	396	2	0	14689	\N
6166	173	1	0	14704	\N
6166	396	2	0	14705	\N
6094	180	4	0	15097	\N
6010	326	10	0	17356	\N
6104	326	1	0	17357	\N
6104	327	2	0	17359	\N
6010	1498	11	0	17360	\N
6141	142	1	0	18597	\N
6141	143	2	0	18599	\N
6139	60	1	0	19522	\N
6139	61	2	0	19524	\N
5998	67	1	0	22249	\N
5998	478	2	0	22250	\N
6169	149	1	0	23126	\N
6043	82	1	0	23816	\N
6043	83	2	0	23817	\N
6155	214	1	0	24454	\N
6155	215	2	0	24456	\N
6077	224	2	0	25592	\N
6077	508	3	0	25594	\N
6125	94	3	0	26760	\N
6125	375	4	0	26762	\N
5987	42	1	0	27594	\N
5987	43	2	0	27596	\N
6164	42	1	0	27611	\N
6164	43	2	0	27613	\N
6162	17	2	0	28086	\N
6143	96	0	0	29513	\N
6147	96	0	0	29515	\N
6148	96	0	0	29516	\N
6145	96	1	0	29533	\N
6145	97	2	0	29536	\N
6095	54	3	0	30082	\N
6142	54	1	0	30083	\N
6142	55	2	0	30086	\N
6095	476	4	0	30088	\N
6168	20	1	0	30493	\N
6168	144	2	0	30494	\N
6175	151	4	0	30716	\N
6092	152	4	0	30720	\N
6175	1510	5	0	30721	\N
6055	33	1	0	31852	\N
6055	163	2	0	31853	\N
6008	322	1	0	32357	\N
6008	323	2	0	32358	\N
5992	1	1	0	34182	\N
5992	53	2	0	34183	\N
6025	1	5	0	34189	\N
6025	1233	6	0	34191	\N
6028	1	3	0	34192	\N
6116	1	1	0	34199	\N
6126	1	1	0	34200	\N
6116	53	2	0	34201	\N
6126	53	2	0	34202	\N
6113	2	1	0	35648	\N
6113	26	2	0	35649	\N
5985	10	2	0	38118	\N
5985	29	3	0	38119	\N
6098	10	2	0	38136	\N
6100	10	1	0	38137	\N
6115	10	1	0	38140	\N
6100	11	2	0	38141	\N
6098	29	3	0	38145	\N
6122	10	1	0	38146	\N
6122	11	2	0	38147	\N
6123	10	2	0	38148	\N
6123	792	3	0	38149	\N
6137	10	1	0	38150	\N
6150	10	2	0	38151	\N
6137	11	2	0	38152	\N
6150	29	3	0	38153	\N
6173	10	4	0	38155	\N
6173	600	5	0	38157	\N
6176	10	1	0	38158	\N
6138	14	1	0	39412	\N
6138	15	2	0	39413	\N
6171	18	1	0	39791	\N
6171	19	2	0	39792	\N
6182	40	2	0	42955	\N
6189	40	1	0	42956	\N
6189	41	2	0	42958	\N
6182	66	3	0	42959	\N
6271	40	4	0	42970	\N
6271	564	5	0	42977	\N
6343	56	1	0	43873	\N
6343	57	2	0	43879	\N
6394	56	2	0	43880	\N
6394	169	3	0	43881	\N
6184	75	2	0	44982	\N
6184	159	3	0	44986	\N
6401	75	3	0	45010	\N
6401	857	4	0	45011	\N
6341	100	1	0	47682	\N
6341	160	2	0	47684	\N
6289	119	2	0	48619	\N
6289	891	3	0	48620	\N
6188	135	3	0	49578	\N
6188	1515	4	0	49587	\N
6187	137	3	0	49853	\N
6187	1514	4	0	49855	\N
6299	137	1	0	49884	\N
6299	138	2	0	49887	\N
6414	147	6	0	49996	\N
6414	1557	7	0	50003	\N
6305	156	1	0	50288	\N
6305	157	2	0	50289	\N
6411	186	2	0	51340	\N
6411	696	3	0	51342	\N
6266	260	2	0	52447	\N
6266	419	3	0	52450	\N
6270	260	3	0	52457	\N
6270	271	4	0	52458	\N
6368	316	1	0	53986	\N
6368	317	2	0	53991	\N
6226	324	1	0	54360	\N
6226	325	2	0	54361	\N
6295	435	1	0	54995	\N
6387	435	1	0	54996	\N
6295	436	2	0	54998	\N
6387	436	2	0	54999	\N
6196	595	1	0	55594	\N
6196	596	2	0	55601	\N
6399	1553	5	0	58112	\N
6399	1551	4	0	58131	\N
6364	1546	2	0	58426	\N
6190	288	1	0	79	\N
6213	220	4	0	573	\N
6213	1521	5	0	574	\N
6372	220	3	0	575	\N
6372	477	4	0	577	\N
6197	734	1	0	1078	\N
6310	734	1	0	1079	\N
6197	1508	2	0	1080	\N
6310	1508	2	0	1081	\N
6399	1552	4	1	3658	\N
6269	262	1	0	3876	\N
6269	263	2	0	3877	\N
6322	262	1	0	3886	\N
6399	262	3	0	3902	\N
6210	373	1	0	5326	\N
6210	374	2	0	5329	\N
6177	391	5	0	10453	\N
6194	391	1	0	10454	\N
6194	392	2	0	10455	\N
6177	1511	6	0	10457	\N
6215	391	1	0	10467	\N
6215	392	2	0	10468	\N
6247	391	1	0	10478	\N
6247	392	2	0	10479	\N
6318	391	1	0	10488	\N
6223	402	1	0	14132	\N
6223	403	2	0	14136	\N
6399	1554	5	1	15220	\N
6329	235	1	0	15727	\N
6329	236	2	0	15729	\N
6181	30	1	0	18017	\N
6181	418	2	0	18020	\N
6392	30	1	0	18023	\N
6392	418	2	0	18025	\N
6192	413	1	0	18361	\N
6192	414	2	0	18363	\N
6240	62	2	0	19737	\N
6240	683	3	0	19739	\N
6379	1547	3	0	19740	\N
6339	1540	58	0	22001	\N
6339	145	126	0	22010	\N
6339	1541	127	0	22011	\N
6346	1542	58	0	22012	\N
6346	145	126	0	22015	\N
6346	1541	127	0	22016	\N
6193	67	3	0	22256	\N
6193	1516	4	0	22257	\N
6191	73	1	0	22556	\N
6191	74	2	0	22559	\N
6253	356	2	0	22766	\N
6330	149	3	0	23141	\N
6330	150	4	0	23142	\N
6335	264	1	0	23524	\N
6335	270	2	0	23527	\N
6325	140	1	0	24071	\N
6325	141	2	0	24074	\N
6278	90	1	0	26086	\N
6278	344	2	0	26087	\N
6195	42	1	0	27612	\N
6195	43	2	0	27614	\N
6180	16	1	0	28087	\N
6255	16	2	0	28094	\N
6255	155	3	0	28099	\N
6178	20	5	0	30503	\N
6178	1512	6	0	30506	\N
6296	230	1	0	32126	\N
6296	287	2	0	32128	\N
6245	453	1	0	32761	\N
6245	454	2	0	32763	\N
6236	1	2	0	34208	\N
6243	1	2	0	34209	\N
6236	112	3	0	34212	\N
6243	112	3	0	34213	\N
6375	53	2	0	34232	\N
6186	431	1	0	34771	\N
6186	432	2	0	34772	\N
6408	2	4	0	35656	\N
6408	315	5	0	35657	\N
6183	10	2	0	38160	\N
6183	29	3	0	38161	\N
6185	10	4	0	38162	\N
6185	1190	5	0	38163	\N
6206	10	2	0	38165	\N
6206	29	3	0	38166	\N
6327	10	1	0	38178	\N
6350	10	1	0	38184	\N
6350	11	2	0	38185	\N
6382	10	1	0	38194	\N
6384	10	1	0	38195	\N
6382	11	2	0	38196	\N
6384	11	2	0	38197	\N
6179	18	5	0	39794	\N
6179	1513	6	0	39795	\N
6284	18	1	0	39796	\N
6284	19	2	0	39797	\N
6220	27	1	0	40952	\N
6220	28	2	0	40953	\N
6256	942	5	0	40963	\N
6320	27	1	0	40970	\N
6320	28	2	0	40971	\N
6208	40	1	0	42961	\N
6208	41	2	0	42962	\N
6427	40	4	0	42996	\N
6427	564	5	0	42998	\N
6505	66	2	0	43000	\N
6503	40	2	0	43003	\N
6503	66	3	0	43004	\N
6385	51	1	0	43567	\N
6385	52	2	0	43568	\N
6248	56	1	0	43872	\N
6248	57	2	0	43878	\N
6260	75	2	0	44991	\N
6260	159	3	0	44992	\N
6323	75	1	0	44996	\N
6323	76	2	0	44999	\N
6451	75	1	0	45018	\N
6451	76	2	0	45019	\N
6351	79	2	0	46865	\N
6351	80	3	0	46866	\N
6369	79	1	0	46885	\N
6369	81	2	0	46886	\N
6347	119	1	0	48658	\N
6347	120	2	0	48659	\N
6498	119	0	0	48679	\N
6300	135	1	0	49579	\N
6300	136	2	0	49583	\N
6380	156	3	0	50298	\N
6380	1548	4	0	50300	\N
6423	156	2	0	50307	\N
6423	571	3	0	50308	\N
6419	170	2	0	50660	\N
6428	170	4	0	50661	\N
6419	718	3	0	50664	\N
6428	171	5	0	50666	\N
6456	260	4	0	52461	\N
6456	538	5	0	52462	\N
6409	324	1	0	54374	\N
6409	325	2	0	54375	\N
6218	353	1	0	54623	\N
6218	354	2	0	54627	\N
6469	435	1	0	54997	\N
6469	436	2	0	55000	\N
6272	595	4	0	55595	\N
6272	1530	5	0	55607	\N
6198	597	1	0	55933	\N
6198	598	2	0	55939	\N
6415	1021	6	0	56557	\N
6415	1558	7	0	56560	\N
6432	1470	2	0	58216	\N
6262	13	2	0	361	\N
6316	424	1	0	818	\N
6280	425	2	0	821	\N
6316	425	2	0	822	\N
6282	251	1	0	1538	\N
6282	252	2	0	1539	\N
6436	237	2	0	3615	\N
6436	319	3	0	3617	\N
6400	262	3	0	3903	\N
6400	1305	4	0	3907	\N
6395	391	0	0	10489	\N
6412	132	2	0	11249	\N
6412	133	3	0	11251	\N
6390	529	2	0	12522	\N
6421	123	2	0	12854	\N
6421	384	3	0	12855	\N
6377	77	1	0	13211	\N
6377	78	2	0	13215	\N
6333	402	1	0	14135	\N
6333	403	2	0	14139	\N
6259	396	1	0	14706	\N
6259	173	2	0	14720	\N
6313	173	1	0	14728	\N
6313	396	2	0	14730	\N
6224	235	1	0	15726	\N
6228	38	20	0	16428	\N
6228	1526	21	0	16436	\N
6356	38	2	0	16447	\N
6356	39	3	0	16452	\N
6376	38	1	0	16461	\N
6376	399	2	0	16462	\N
6231	326	3	0	17366	\N
6231	1375	4	0	17367	\N
6203	142	10	0	18598	\N
6203	1520	11	0	18601	\N
6287	290	1	0	19059	\N
6287	291	2	0	19062	\N
6311	281	3	0	20439	\N
6430	241	4	0	20449	\N
6430	686	5	0	20450	\N
6491	73	2	0	22557	\N
6491	703	3	0	22560	\N
6486	264	2	0	23525	\N
6486	265	3	0	23528	\N
6264	82	1	0	23834	\N
6264	83	2	0	23835	\N
6344	140	1	0	24072	\N
6344	141	2	0	24075	\N
6308	214	5	0	24455	\N
6405	94	2	0	26764	\N
6405	1555	3	0	26768	\N
6201	16	0	0	28088	\N
6353	16	2	0	28100	\N
6442	16	2	0	28101	\N
6353	155	3	0	28103	\N
6442	155	3	0	28104	\N
6482	16	2	0	28113	\N
6482	155	3	0	28114	\N
6496	16	4	0	28115	\N
6496	380	5	0	28118	\N
6306	96	5	0	29534	\N
6348	97	2	0	29537	\N
6306	1535	6	0	29538	\N
6233	151	1	0	30717	\N
6233	302	2	0	30719	\N
6250	151	2	0	30732	\N
6250	576	3	0	30733	\N
6292	151	1	0	30744	\N
6292	302	2	0	30745	\N
6472	151	2	0	30750	\N
6472	576	3	0	30753	\N
6207	33	2	0	31880	\N
6290	33	1	0	31881	\N
6207	34	3	0	31883	\N
6446	33	2	0	31897	\N
6446	34	3	0	31898	\N
6267	1	1	0	34218	\N
6267	53	2	0	34219	\N
6319	1	1	0	34222	\N
6319	53	2	0	34224	\N
6362	1	1	0	34226	\N
6362	53	2	0	34227	\N
6418	1	2	0	34238	\N
6418	112	3	0	34240	\N
6337	2	1	0	35654	\N
6467	2	2	0	35662	\N
6467	131	3	0	35664	\N
6314	4	3	0	36099	\N
6314	1538	4	0	36102	\N
6359	10	1	0	38190	\N
6359	11	2	0	38191	\N
6425	10	2	0	38201	\N
6425	29	3	0	38204	\N
6444	10	2	0	38210	\N
6444	29	3	0	38211	\N
6449	10	2	0	38212	\N
6449	29	3	0	38215	\N
6462	942	5	0	40995	\N
6244	40	1	0	42966	\N
6244	41	2	0	42967	\N
6363	40	1	0	42972	\N
6381	40	1	0	42973	\N
6363	41	2	0	42975	\N
6381	41	2	0	42976	\N
6386	40	1	0	42986	\N
6386	41	2	0	42987	\N
6434	51	2	0	43574	\N
6434	524	3	0	43576	\N
6361	75	2	0	44998	\N
6361	159	3	0	45001	\N
6304	79	2	0	46851	\N
6304	80	3	0	46852	\N
6445	79	2	0	46907	\N
6445	80	3	0	46909	\N
6249	88	2	0	47397	\N
6345	88	1	0	47398	\N
6345	89	2	0	47400	\N
6249	154	3	0	47401	\N
6235	100	2	0	47670	\N
6235	101	3	0	47671	\N
6358	102	2	0	47854	\N
6358	158	3	0	47855	\N
6431	121	2	0	48963	\N
6431	625	3	0	48965	\N
6374	170	1	0	50659	\N
6374	398	2	0	50663	\N
6420	181	2	0	50934	\N
6420	769	3	0	50940	\N
6298	324	1	0	54364	\N
6298	325	2	0	54366	\N
6230	353	3	0	54624	\N
6460	353	4	0	54625	\N
6230	1527	4	0	54629	\N
6460	1570	5	0	54630	\N
6288	451	1	0	55378	\N
6288	584	2	0	55379	\N
6274	597	4	0	55934	\N
6416	597	6	0	55935	\N
6274	1531	5	0	55942	\N
6416	1559	7	0	55944	\N
6398	793	0	0	56769	\N
6493	841	2	0	57018	\N
6432	1565	3	0	58218	\N
6476	1470	2	0	58230	\N
6476	1565	3	0	58232	\N
6470	252	2	0	1548	\N
6481	828	3	0	1574	\N
6465	117	1	0	2069	\N
6465	248	2	0	2070	\N
6202	1517	11	0	2369	\N
6440	367	6	0	3417	\N
6440	1567	7	0	3419	\N
6422	1561	91	0	4031	\N
6488	1572	54	0	5202	\N
6488	1573	55	0	5207	\N
6202	1518	11	1	5214	\N
6238	373	2	0	5327	\N
6238	1504	3	0	5330	\N
6391	455	2	0	11232	\N
6483	77	2	0	13212	\N
6483	216	3	0	13216	\N
6389	233	2	0	13919	\N
6389	910	3	0	13924	\N
6332	402	1	0	14134	\N
6332	403	2	0	14138	\N
6378	173	1	0	14729	\N
6378	396	2	0	14731	\N
6352	92	2	0	15104	\N
6352	93	3	0	15106	\N
6479	192	2	0	15374	\N
6227	38	2	0	16427	\N
6227	39	3	0	16433	\N
6286	115	1	0	16711	\N
6286	116	2	0	16712	\N
6457	212	4	0	17207	\N
6457	1568	5	0	17208	\N
6302	326	1	0	17377	\N
6302	327	2	0	17379	\N
6334	326	2	0	17418	\N
6334	1539	3	0	17419	\N
6279	30	1	0	18021	\N
6279	418	2	0	18022	\N
6239	656	3	0	18615	\N
6371	198	1	0	20113	\N
6371	199	2	0	20115	\N
6315	64	3	0	20837	\N
6315	130	4	0	20838	\N
6422	1560	58	0	22017	\N
6422	145	90	0	22023	\N
6422	1562	91	1	22092	\N
6222	67	2	0	22264	\N
6222	68	3	0	22265	\N
6277	82	1	0	23840	\N
6277	83	2	0	23842	\N
6307	1536	6	0	25620	\N
6294	86	1	0	26456	\N
6294	87	2	0	26458	\N
6252	16	4	0	28091	\N
6252	1529	5	0	28093	\N
6312	16	1	0	28096	\N
6312	17	2	0	28098	\N
6447	16	2	0	28102	\N
6447	155	3	0	28105	\N
6452	16	3	0	28106	\N
6452	359	4	0	28107	\N
6454	16	2	0	28108	\N
6205	33	3	0	31879	\N
6205	1348	4	0	31884	\N
6199	322	1	0	32370	\N
6199	323	2	0	32374	\N
6212	1	4	0	34207	\N
6212	1194	5	0	34215	\N
6258	1	1	0	34216	\N
6258	53	2	0	34217	\N
6324	1	1	0	34223	\N
6324	53	2	0	34225	\N
6366	1	1	0	34228	\N
6366	53	2	0	34229	\N
6404	422	5	0	34235	\N
6407	1	3	0	34236	\N
6407	48	4	0	34237	\N
6474	1	2	0	34239	\N
6474	112	3	0	34241	\N
6437	2	2	0	35658	\N
6439	2	6	0	35659	\N
6437	131	3	0	35660	\N
6439	1566	7	0	35661	\N
6490	2	4	0	35663	\N
6490	315	5	0	35665	\N
6202	10	10	0	38164	\N
6217	10	3	0	38169	\N
6217	1524	4	0	38171	\N
6229	10	1	0	38172	\N
6229	11	2	0	38173	\N
6242	10	2	0	38174	\N
6242	29	3	0	38175	\N
6291	10	1	0	38177	\N
6291	11	2	0	38180	\N
6355	10	3	0	38186	\N
6355	347	4	0	38189	\N
6433	10	2	0	38206	\N
6433	29	3	0	38208	\N
6261	15	2	0	39419	\N
6326	18	1	0	39800	\N
6326	19	2	0	39801	\N
6349	40	1	0	42971	\N
6349	41	2	0	42974	\N
6406	40	3	0	42990	\N
6410	40	3	0	42991	\N
6406	128	4	0	42992	\N
6410	128	4	0	42993	\N
6417	51	2	0	43573	\N
6417	524	3	0	43575	\N
6225	56	1	0	43871	\N
6225	57	2	0	43877	\N
6530	56	2	0	43883	\N
6204	75	1	0	44983	\N
6204	76	2	0	44985	\N
6342	75	1	0	44997	\N
6342	76	2	0	45000	\N
6373	88	3	0	47399	\N
6373	580	4	0	47402	\N
6221	100	4	0	47659	\N
6221	1525	5	0	47661	\N
6309	100	1	0	47681	\N
6309	160	2	0	47683	\N
6511	137	2	0	49885	\N
6511	197	3	0	49888	\N
6200	147	1	0	49994	\N
6275	147	4	0	49995	\N
6200	599	2	0	49999	\N
6275	551	5	0	50002	\N
6367	156	1	0	50297	\N
6367	157	2	0	50299	\N
6301	285	1	0	53508	\N
6301	286	2	0	53509	\N
6328	324	1	0	54365	\N
6328	325	2	0	54367	\N
6464	451	3	0	55392	\N
6464	1571	4	0	55393	\N
6413	595	6	0	55596	\N
6413	1556	7	0	55609	\N
6354	1021	3	0	56555	\N
6354	1543	4	0	56556	\N
6527	1021	2	0	56558	\N
6527	1048	3	0	56559	\N
6297	841	1	0	57004	\N
6297	842	2	0	57006	\N
6263	852	1	0	57308	\N
6263	913	2	0	57314	\N
6475	908	2	0	57610	\N
6475	988	3	0	57613	\N
6237	289	3	0	77	\N
6383	1550	2	0	1061	\N
6459	237	4	0	3618	\N
6459	1569	5	0	3636	\N
6360	719	11	0	5170	\N
6360	1544	12	0	5173	\N
6281	1532	1	0	11057	\N
6281	1533	2	0	11059	\N
6522	108	2	0	11748	\N
6522	501	3	0	11749	\N
6234	300	2	0	12077	\N
6365	300	1	0	12078	\N
6365	355	2	0	12083	\N
6246	528	1	0	12507	\N
6246	529	2	0	12508	\N
6388	58	2	0	13565	\N
6388	665	3	0	13566	\N
6480	233	2	0	13920	\N
6480	910	3	0	13925	\N
6331	402	1	0	14133	\N
6331	403	2	0	14137	\N
6321	258	1	0	14528	\N
6513	258	2	0	14529	\N
6321	309	2	0	14531	\N
6513	585	3	0	14532	\N
6251	193	2	0	15366	\N
6504	235	2	0	15738	\N
6504	1061	3	0	15739	\N
6209	341	1	0	16972	\N
6209	342	2	0	16974	\N
6336	326	1	0	17378	\N
6336	327	2	0	17380	\N
6232	326	11	0	17381	\N
6232	1528	12	0	17382	\N
6303	326	1	0	17404	\N
6303	1534	2	0	17405	\N
6293	198	1	0	20112	\N
6477	198	2	0	20121	\N
6477	746	3	0	20123	\N
6216	336	3	0	22764	\N
6216	1523	4	0	22768	\N
6211	149	1	0	23127	\N
6211	499	2	0	23130	\N
6257	224	1	0	25601	\N
6257	225	2	0	25602	\N
6283	94	1	0	26763	\N
6283	107	2	0	26766	\N
6426	94	8	0	26773	\N
6426	1563	9	0	26774	\N
6219	17	2	0	28092	\N
6276	16	1	0	28095	\N
6276	17	2	0	28097	\N
6501	16	2	0	28116	\N
6501	155	3	0	28117	\N
6268	449	2	0	29875	\N
6268	583	3	0	29876	\N
6340	54	1	0	30084	\N
6340	55	2	0	30087	\N
6484	20	2	0	30504	\N
6484	702	3	0	30505	\N
6448	33	2	0	31905	\N
6396	322	0	0	32371	\N
6241	453	1	0	32753	\N
6241	454	2	0	32755	\N
6254	1	2	0	34210	\N
6254	112	3	0	34214	\N
6317	1	1	0	34220	\N
6317	53	2	0	34221	\N
6402	1	1	0	34231	\N
6402	53	2	0	34233	\N
6273	2	4	0	35651	\N
6273	315	5	0	35653	\N
6214	10	4	0	38168	\N
6265	10	2	0	38176	\N
6338	10	2	0	38179	\N
6265	29	3	0	38182	\N
6338	29	3	0	38183	\N
6357	10	1	0	38187	\N
6357	11	2	0	38188	\N
6370	10	3	0	38192	\N
6370	347	4	0	38193	\N
6393	10	2	0	38198	\N
6403	10	4	0	38199	\N
6424	10	2	0	38200	\N
6393	29	3	0	38202	\N
6403	600	5	0	38205	\N
6441	10	2	0	38207	\N
6441	29	3	0	38209	\N
6489	10	4	0	38213	\N
6489	600	5	0	38217	\N
6494	10	2	0	38218	\N
6506	10	4	0	38219	\N
6494	29	3	0	38220	\N
6506	600	5	0	38221	\N
6285	18	1	0	39798	\N
6285	19	2	0	39799	\N
6435	18	2	0	39802	\N
6461	23	4	0	40722	\N
6461	867	5	0	40723	\N
6516	27	0	0	41290	\N
6471	40	3	0	42997	\N
6471	869	4	0	42999	\N
6576	40	2	0	43009	\N
6576	66	3	0	43011	\N
6515	56	4	0	43882	\N
6515	1145	5	0	43893	\N
6533	75	2	0	45027	\N
6533	159	3	0	45030	\N
6458	79	4	0	46908	\N
6458	589	5	0	46910	\N
6478	79	4	0	46929	\N
6478	589	5	0	46930	\N
6619	79	2	0	46947	\N
6619	80	3	0	46948	\N
6633	102	2	0	47863	\N
6633	158	3	0	47865	\N
6500	119	2	0	48680	\N
6556	119	0	0	48682	\N
6500	891	3	0	48683	\N
6642	119	4	0	48724	\N
6642	423	5	0	48725	\N
6468	121	2	0	48973	\N
6468	625	3	0	48974	\N
6581	121	2	0	48982	\N
6581	625	3	0	48989	\N
6621	125	2	0	49287	\N
6621	188	3	0	49292	\N
6657	147	2	0	50041	\N
6657	516	3	0	50043	\N
6514	200	4	0	51575	\N
6514	899	5	0	51576	\N
6694	242	6	0	52246	\N
6694	1630	7	0	52250	\N
6701	324	2	0	54391	\N
6701	486	3	0	54393	\N
6712	353	2	0	54637	\N
6712	755	3	0	54639	\N
6564	435	1	0	55004	\N
6564	1580	2	0	55005	\N
6579	841	2	0	57019	\N
6493	1161	3	0	57021	\N
6579	1161	3	0	57022	\N
6453	852	3	0	57309	\N
6499	852	2	0	57310	\N
6499	1325	3	0	57315	\N
6453	1068	4	0	57317	\N
6463	1470	2	0	58217	\N
6463	1565	3	0	58219	\N
6693	1470	2	0	58231	\N
6693	1565	3	0	58233	\N
6688	1620	5	0	825	\N
6502	511	3	0	2938	\N
6495	367	2	0	3429	\N
6495	651	3	0	3430	\N
6554	262	3	0	3904	\N
6554	1579	4	0	3906	\N
6521	189	2	0	4992	\N
6521	311	3	0	4993	\N
6429	222	4	0	5264	\N
6438	222	2	0	5265	\N
6438	232	3	0	5269	\N
6429	1564	5	0	5272	\N
6629	391	0	0	10439	\N
6539	501	3	0	11760	\N
6508	123	2	0	12860	\N
6508	384	3	0	12863	\N
6569	1148	2	0	14140	\N
6510	402	2	0	14153	\N
6510	1148	3	0	14154	\N
6569	402	3	0	14155	\N
6519	38	2	0	16466	\N
6519	39	3	0	16469	\N
6610	115	2	0	16723	\N
6610	636	3	0	16725	\N
6583	212	3	0	17215	\N
6588	212	9	0	17225	\N
6588	1590	10	0	17228	\N
6537	326	2	0	17402	\N
6537	747	3	0	17403	\N
6699	326	2	0	17416	\N
6699	747	3	0	17417	\N
6544	30	2	0	18024	\N
6544	31	3	0	18026	\N
6715	60	2	0	19532	\N
6715	166	3	0	19535	\N
6466	198	1	0	20120	\N
6466	199	2	0	20122	\N
6595	226	3	0	21297	\N
6638	488	6	0	21498	\N
6638	1601	7	0	21499	\N
6528	73	2	0	22565	\N
6528	703	3	0	22566	\N
6631	356	1	0	22767	\N
6631	336	5	0	22771	\N
6631	337	6	0	22772	\N
6671	90	4	0	26110	\N
6671	358	5	0	26114	\N
6518	244	2	0	27342	\N
6455	16	0	0	28110	\N
6473	155	3	0	28112	\N
6645	16	2	0	28122	\N
6645	155	3	0	28126	\N
6497	449	4	0	29888	\N
6497	1574	5	0	29889	\N
6649	54	4	0	30085	\N
6649	1604	5	0	30089	\N
6561	20	2	0	30523	\N
6561	702	3	0	30525	\N
6710	151	2	0	30752	\N
6710	576	3	0	30755	\N
6547	202	2	0	31155	\N
6487	230	2	0	32127	\N
6487	231	3	0	32129	\N
6683	322	4	0	32372	\N
6683	1616	5	0	32375	\N
6485	1	2	0	34242	\N
6485	112	3	0	34243	\N
6509	1	2	0	34244	\N
6509	112	3	0	34245	\N
6593	1	2	0	34253	\N
6593	112	3	0	34255	\N
6718	1	4	0	34268	\N
6718	422	5	0	34269	\N
6721	422	5	0	34271	\N
6659	431	2	0	34774	\N
6659	531	3	0	34776	\N
6450	6	2	0	36414	\N
6450	179	3	0	36416	\N
6492	10	2	0	38214	\N
6492	29	3	0	38216	\N
6507	10	2	0	38222	\N
6507	29	3	0	38223	\N
6535	10	2	0	38224	\N
6535	29	3	0	38226	\N
6590	10	2	0	38233	\N
6616	10	2	0	38242	\N
6616	29	3	0	38243	\N
6666	10	2	0	38250	\N
6666	29	3	0	38252	\N
6696	10	4	0	38256	\N
6696	600	5	0	38257	\N
6587	18	1	0	39808	\N
6587	1426	2	0	39809	\N
6675	18	1	0	39812	\N
6675	19	2	0	39813	\N
6614	23	0	0	40732	\N
6663	27	3	0	40991	\N
6505	40	3	0	43005	\N
6542	40	2	0	43008	\N
6542	66	3	0	43010	\N
6647	40	2	0	43024	\N
6647	66	3	0	43025	\N
6652	40	2	0	43028	\N
6652	66	3	0	43029	\N
6708	40	2	0	43035	\N
6708	66	3	0	43037	\N
6726	40	2	0	43047	\N
6726	66	3	0	43048	\N
6767	1649	0	0	43060	\N
6526	51	2	0	43581	\N
6526	524	3	0	43582	\N
6650	56	2	0	43886	\N
6650	169	3	0	43891	\N
6574	1584	4	0	45026	\N
6733	75	4	0	45029	\N
6733	172	5	0	45032	\N
6574	1585	5	0	45238	\N
6512	135	2	0	49580	\N
6512	196	3	0	49584	\N
6740	137	2	0	49886	\N
6740	197	3	0	49889	\N
6747	200	2	0	51581	\N
6747	887	3	0	51582	\N
6766	200	1	0	51597	\N
6766	201	2	0	51598	\N
6678	268	2	0	52823	\N
6678	1387	3	0	52825	\N
6611	273	2	0	53038	\N
6611	1159	3	0	53042	\N
6702	1632	127	1	54116	\N
6702	486	2	0	54376	\N
6702	324	126	0	54394	\N
6655	595	2	0	55597	\N
6723	595	2	0	55598	\N
6655	768	3	0	55603	\N
6723	768	3	0	55604	\N
6602	841	6	0	57020	\N
6602	1594	7	0	57023	\N
6541	908	2	0	57611	\N
6541	988	3	0	57614	\N
6743	908	2	0	57623	\N
6743	988	3	0	57624	\N
6689	1623	126	1	58116	\N
6689	1622	126	0	58120	\N
6757	1470	2	0	58246	\N
6757	1565	3	0	58247	\N
6713	289	3	0	78	\N
6546	1577	7	0	362	\N
6600	12	4	0	367	\N
6600	357	5	0	375	\N
6767	1648	0	0	1648	\N
6531	1575	2	0	1786	\N
6531	1576	3	0	1787	\N
6567	573	2	0	1893	\N
6567	1581	3	0	1894	\N
6627	391	0	0	10437	\N
6750	391	2	0	10497	\N
6750	406	3	0	10498	\N
6719	108	4	0	11771	\N
6731	528	2	0	12531	\N
6731	613	3	0	12532	\N
6549	77	0	0	13213	\N
6550	77	2	0	13214	\N
6550	216	3	0	13217	\N
6625	77	7	0	13232	\N
6625	1597	8	0	13236	\N
6730	92	2	0	15114	\N
6730	93	3	0	15117	\N
6552	44	2	0	16115	\N
6598	115	4	0	16721	\N
6598	1302	5	0	16726	\N
6738	212	2	0	17226	\N
6738	566	3	0	17227	\N
6574	1586	5	1	17632	\N
6574	1583	4	0	17801	\N
6605	30	2	0	18028	\N
6605	31	3	0	18030	\N
6594	208	2	0	19316	\N
6594	854	3	0	19324	\N
6691	164	4	0	21308	\N
6691	1582	5	0	21312	\N
6702	1355	127	0	21731	\N
6524	214	2	0	24481	\N
6534	90	2	0	26103	\N
6534	91	3	0	26104	\N
6596	86	0	0	26462	\N
6689	1621	104	0	26775	\N
6689	94	125	0	26778	\N
6689	1624	127	0	26779	\N
6728	94	0	0	26782	\N
6518	438	3	0	27344	\N
6617	16	2	0	28119	\N
6617	155	3	0	28120	\N
6681	1615	7	0	29416	\N
6591	96	2	0	29550	\N
6668	20	2	0	30524	\N
6668	702	3	0	30526	\N
6523	202	2	0	31154	\N
6523	812	3	0	31156	\N
6760	230	8	0	32136	\N
6760	1643	9	0	32141	\N
6520	1	2	0	34246	\N
6529	1	2	0	34247	\N
6532	1	2	0	34248	\N
6520	112	3	0	34249	\N
6529	112	3	0	34250	\N
6532	112	3	0	34251	\N
6586	1233	6	0	34257	\N
6667	1	2	0	34259	\N
6667	112	3	0	34261	\N
6697	1	4	0	34262	\N
6697	422	5	0	34263	\N
6525	2	2	0	35666	\N
6525	131	3	0	35667	\N
6608	2	2	0	35668	\N
6608	131	3	0	35669	\N
6673	2	2	0	35670	\N
6673	131	3	0	35671	\N
6752	2	2	0	35672	\N
6639	6	4	0	36417	\N
6639	670	5	0	36418	\N
6572	10	4	0	38229	\N
6572	600	5	0	38231	\N
6636	10	2	0	38246	\N
6636	29	3	0	38247	\N
6705	10	2	0	38258	\N
6705	29	3	0	38259	\N
6742	10	2	0	38263	\N
6742	29	3	0	38271	\N
6762	10	5	0	38275	\N
6764	10	3	0	38276	\N
6769	600	5	0	38279	\N
6764	465	4	0	38280	\N
6762	1645	6	0	38281	\N
6686	18	7	0	39816	\N
6686	1618	8	0	39817	\N
6606	23	8	0	40730	\N
6606	984	9	0	40739	\N
6681	28	7	1	40941	\N
6517	27	4	0	40989	\N
6664	27	4	0	40992	\N
6517	942	5	0	40996	\N
6664	942	5	0	40997	\N
6681	27	6	0	41016	\N
6644	40	2	0	43017	\N
6644	66	3	0	43018	\N
6665	40	2	0	43033	\N
6665	66	3	0	43036	\N
6530	169	3	0	43888	\N
6565	75	2	0	45028	\N
6565	159	3	0	45031	\N
6623	79	4	0	46959	\N
6623	589	5	0	46960	\N
6754	100	2	0	47697	\N
6754	101	3	0	47699	\N
6536	119	0	0	48681	\N
6538	119	2	0	48704	\N
6557	119	2	0	48705	\N
6538	891	3	0	48706	\N
6557	891	3	0	48707	\N
6739	135	2	0	49581	\N
6739	196	3	0	49585	\N
6725	147	2	0	50042	\N
6725	516	3	0	50044	\N
6540	242	2	0	52245	\N
6540	620	3	0	52249	\N
6732	316	4	0	53996	\N
6732	1024	5	0	53998	\N
6651	353	2	0	54626	\N
6651	755	3	0	54628	\N
6545	435	0	0	55001	\N
6720	435	12	0	55012	\N
6720	1634	13	0	55013	\N
6656	597	2	0	55936	\N
6656	767	3	0	55940	\N
6768	1650	4	0	56890	\N
6768	1652	5	0	56898	\N
6761	852	8	0	57311	\N
6761	1644	9	0	57318	\N
6690	1627	127	1	58403	\N
6575	1588	3	0	58434	\N
6763	1646	6	0	578	\N
6749	1639	5	0	1865	\N
6543	117	2	0	2077	\N
6543	175	3	0	2078	\N
6759	228	8	0	2940	\N
6759	1642	9	0	2942	\N
6744	1636	2	0	3063	\N
6744	1637	3	0	3067	\N
6607	189	8	0	5007	\N
6607	1596	9	0	5008	\N
6658	132	2	0	11250	\N
6658	133	3	0	11252	\N
6624	77	4	0	13231	\N
6555	233	2	0	13921	\N
6585	233	5	0	13922	\N
6555	910	3	0	13926	\N
6585	1589	6	0	13927	\N
6570	1148	2	0	14141	\N
6571	1148	2	0	14142	\N
6570	402	3	0	14156	\N
6571	402	3	0	14157	\N
6768	1653	5	1	14341	\N
6703	258	4	0	14541	\N
6703	635	5	0	14542	\N
6768	1651	4	0	14543	\N
6654	1605	7	0	14742	\N
6553	92	3	0	15105	\N
6553	1578	4	0	15107	\N
6577	192	2	0	15375	\N
6577	838	3	0	15377	\N
6672	804	2	0	15582	\N
6672	1607	3	0	15584	\N
6552	161	3	0	16119	\N
6601	115	2	0	16722	\N
6601	1593	3	0	16724	\N
6558	30	2	0	18027	\N
6558	31	3	0	18029	\N
6680	30	6	0	18032	\N
6680	1319	7	0	18033	\N
6563	142	2	0	18630	\N
6563	656	3	0	18631	\N
6580	60	2	0	19531	\N
6670	62	4	0	19763	\N
6670	1606	5	0	19764	\N
6573	164	4	0	21295	\N
6573	1582	5	0	21298	\N
6714	336	2	0	22787	\N
6714	740	3	0	22788	\N
6566	149	2	0	23148	\N
6604	49	4	0	25073	\N
6604	1595	5	0	25076	\N
6626	206	7	0	25845	\N
6626	1598	8	0	25848	\N
6682	90	3	0	26111	\N
6682	877	4	0	26113	\N
6559	86	1	0	26457	\N
6559	87	2	0	26459	\N
6635	244	2	0	27358	\N
6635	438	3	0	27359	\N
6698	16	4	0	28123	\N
6698	380	5	0	28127	\N
6751	1641	3	0	29395	\N
6690	1626	127	0	29751	\N
6690	1625	40	0	29890	\N
6690	449	126	0	29897	\N
6562	151	2	0	30751	\N
6562	576	3	0	30754	\N
6568	202	2	0	31164	\N
6568	812	3	0	31165	\N
6685	360	4	0	31553	\N
6685	1617	5	0	31554	\N
6727	33	2	0	31910	\N
6727	34	3	0	31911	\N
6704	1633	7	0	32376	\N
6641	1	4	0	34254	\N
6641	422	5	0	34256	\N
6661	1	2	0	34258	\N
6661	112	3	0	34260	\N
6707	1	6	0	34264	\N
6707	523	7	0	34265	\N
6717	112	2	0	34266	\N
6717	1	3	0	34267	\N
6741	1	2	0	34272	\N
6741	112	3	0	34273	\N
6758	2	2	0	35673	\N
6548	10	2	0	38225	\N
6548	29	3	0	38227	\N
6560	10	2	0	38228	\N
6560	29	3	0	38230	\N
6578	10	2	0	38232	\N
6578	29	3	0	38234	\N
6592	10	2	0	38236	\N
6592	29	3	0	38237	\N
6597	10	4	0	38238	\N
6597	600	5	0	38240	\N
6618	10	2	0	38244	\N
6618	29	3	0	38245	\N
6677	29	3	0	38253	\N
6735	10	2	0	38261	\N
6737	10	2	0	38262	\N
6746	10	2	0	38264	\N
6735	29	3	0	38269	\N
6737	29	3	0	38270	\N
6746	29	3	0	38272	\N
6756	10	2	0	38273	\N
6756	29	3	0	38274	\N
6582	18	1	0	39803	\N
6582	1426	2	0	39805	\N
6551	27	2	0	40990	\N
6584	40	5	0	43016	\N
6584	385	6	0	43019	\N
6669	40	4	0	43034	\N
6669	564	5	0	43038	\N
6753	40	2	0	43052	\N
6753	66	3	0	43053	\N
6755	40	2	0	43061	\N
6755	66	3	0	43062	\N
6782	40	2	0	43073	\N
6839	40	4	0	43075	\N
6782	66	3	0	43077	\N
6839	564	5	0	43080	\N
6620	56	2	0	43884	\N
6637	56	2	0	43885	\N
6729	56	2	0	43887	\N
6620	169	3	0	43889	\N
6637	169	3	0	43890	\N
6729	169	3	0	43892	\N
6795	56	2	0	43894	\N
6795	169	3	0	43895	\N
6812	56	2	0	43898	\N
6812	169	3	0	43900	\N
6855	56	4	0	43902	\N
6855	1145	5	0	43905	\N
6790	75	2	0	45037	\N
6790	159	3	0	45039	\N
6781	79	2	0	46969	\N
6781	80	3	0	46970	\N
6793	79	2	0	46973	\N
6793	80	3	0	46974	\N
6841	79	2	0	46979	\N
6841	80	3	0	46982	\N
6778	113	2	0	48372	\N
6778	114	3	0	48374	\N
6734	170	2	0	50662	\N
6734	718	3	0	50665	\N
6817	242	3	0	52270	\N
6817	1668	4	0	52272	\N
6653	260	2	0	52465	\N
6653	419	3	0	52467	\N
6801	324	2	0	54415	\N
6801	486	3	0	54419	\N
6772	362	2	0	54822	\N
6772	420	3	0	54825	\N
6780	435	0	0	55020	\N
6724	597	2	0	55937	\N
6724	767	3	0	55941	\N
6648	1109	2	0	56258	\N
6648	1412	3	0	56262	\N
6589	793	9	0	56770	\N
6589	1591	10	0	56771	\N
6765	852	3	0	57312	\N
6765	1647	4	0	57319	\N
6679	1611	6	0	58422	\N
6679	1613	7	0	58423	\N
6646	1603	3	0	58440	\N
6846	1577	7	0	376	\N
6630	424	0	0	819	\N
6632	424	5	0	823	\N
6632	468	6	0	824	\N
6783	424	2	0	833	\N
6783	520	3	0	834	\N
6774	1654	2	0	1114	\N
6774	1655	3	0	1117	\N
6676	251	4	0	1573	\N
6676	1610	5	0	1575	\N
6695	228	4	0	2939	\N
6695	1631	5	0	2941	\N
6634	1599	2	0	5234	\N
6628	391	0	0	10438	\N
6722	132	4	0	11257	\N
6828	132	8	0	11258	\N
6722	1635	5	0	11260	\N
6828	1670	9	0	11262	\N
6700	300	2	0	12079	\N
6700	706	3	0	12088	\N
6786	58	4	0	13573	\N
6786	1660	5	0	13574	\N
6788	58	2	0	13582	\N
6788	665	3	0	13583	\N
6684	402	4	0	14162	\N
6660	258	1	0	14539	\N
6660	309	2	0	14540	\N
6784	258	2	0	14544	\N
6784	585	3	0	14545	\N
6662	192	3	0	15386	\N
6662	627	4	0	15393	\N
6770	115	2	0	16736	\N
6771	115	0	0	16737	\N
6770	636	3	0	16738	\N
6776	1656	2	0	16944	\N
6776	1657	3	0	16945	\N
6748	326	4	0	17427	\N
6807	326	2	0	17440	\N
6807	747	3	0	17441	\N
6745	290	2	0	19060	\N
6745	575	3	0	19063	\N
6832	208	2	0	19318	\N
6832	854	3	0	19326	\N
6580	166	3	0	19534	\N
6736	198	2	0	20136	\N
6779	198	2	0	20137	\N
6736	746	3	0	20138	\N
6779	746	3	0	20139	\N
6692	1628	4	0	21619	\N
6775	67	2	0	22268	\N
6775	68	3	0	22270	\N
6709	140	2	0	24073	\N
6709	487	3	0	24076	\N
6787	140	4	0	24081	\N
6787	1661	5	0	24085	\N
6612	90	2	0	26109	\N
6612	91	3	0	26112	\N
6599	86	4	0	26463	\N
6599	1592	5	0	26464	\N
6785	1659	0	0	26783	\N
6819	244	2	0	27369	\N
6622	16	2	0	28121	\N
6716	16	4	0	28124	\N
6622	155	3	0	28125	\N
6716	380	5	0	28128	\N
6805	16	1	0	28131	\N
6805	17	2	0	28135	\N
6674	1608	16	0	30944	\N
6674	1609	17	0	30945	\N
6640	453	2	0	32762	\N
6640	902	3	0	32764	\N
6773	1	2	0	34274	\N
6773	112	3	0	34275	\N
6603	600	5	0	38241	\N
6643	10	2	0	38248	\N
6643	29	3	0	38249	\N
6687	10	11	0	38254	\N
6687	1619	12	0	38255	\N
6711	10	2	0	38260	\N
6711	29	3	0	38268	\N
6777	10	2	0	38282	\N
6777	29	3	0	38283	\N
6798	10	6	0	38284	\N
6798	1663	7	0	38285	\N
6862	10	4	0	38291	\N
6706	18	0	0	39819	\N
6609	23	2	0	40731	\N
6615	23	0	0	40733	\N
6609	24	3	0	40736	\N
6679	1614	7	1	40943	\N
6679	619	2	0	40998	\N
6679	1612	6	0	41015	\N
6815	40	4	0	43074	\N
6815	564	5	0	43079	\N
6806	56	2	0	43896	\N
6806	169	3	0	43899	\N
6915	75	2	0	45047	\N
7033	75	2	0	45050	\N
6915	159	3	0	45051	\N
7033	159	3	0	45052	\N
7056	79	2	0	46991	\N
7056	80	3	0	46993	\N
7025	100	4	0	47698	\N
7025	448	5	0	47700	\N
7091	113	1	0	48380	\N
7091	437	2	0	48381	\N
6919	147	2	0	50049	\N
6919	516	3	0	50073	\N
6984	200	4	0	51611	\N
6984	899	5	0	51612	\N
6976	268	3	0	52833	\N
6976	610	4	0	52835	\N
6966	285	2	0	53517	\N
6966	1276	3	0	53518	\N
7020	316	4	0	54007	\N
7020	1024	5	0	54011	\N
6802	324	1	0	54416	\N
6802	325	2	0	54418	\N
6873	452	2	0	55394	\N
6873	1676	3	0	55408	\N
6883	595	5	0	55599	\N
6883	1682	6	0	55608	\N
6884	1109	3	0	56259	\N
6884	1683	4	0	56263	\N
6853	793	2	0	56783	\N
6853	1136	3	0	56784	\N
7098	908	2	0	57636	\N
7098	988	3	0	57637	\N
6873	1675	3	0	58101	\N
6929	1470	2	0	58256	\N
6929	1565	3	0	58261	\N
7044	1710	5	0	98	\N
6943	13	2	0	372	\N
6791	424	4	0	843	\N
6791	1620	5	0	844	\N
6858	424	2	0	865	\N
6973	424	2	0	883	\N
6973	520	3	0	885	\N
6796	251	2	0	1586	\N
6796	828	3	0	1589	\N
6851	110	2	0	2652	\N
6851	111	3	0	2654	\N
6931	367	4	0	3445	\N
6931	1231	5	0	3446	\N
6960	731	3	0	3905	\N
6964	189	2	0	5018	\N
6964	311	3	0	5019	\N
7070	1714	53	0	5020	\N
7068	189	3	0	5039	\N
7068	1713	4	0	5043	\N
7070	189	73	0	5044	\N
7070	1715	74	0	5045	\N
6825	222	2	0	5266	\N
6825	232	3	0	5270	\N
6835	391	2	0	10503	\N
6835	406	3	0	10505	\N
6899	406	3	0	10517	\N
7066	391	3	0	10556	\N
7066	1691	4	0	10565	\N
7010	132	5	0	11279	\N
7010	1704	6	0	11282	\N
7012	58	2	0	13595	\N
7076	58	13	0	13596	\N
7012	665	3	0	13598	\N
7076	1717	14	0	13599	\N
6945	233	4	0	13936	\N
6945	1689	5	0	13937	\N
6799	235	2	0	15746	\N
7078	1719	104	0	16106	\N
7078	44	123	0	16122	\N
7078	1720	124	0	16124	\N
7061	115	0	0	16754	\N
6789	208	2	0	19317	\N
6833	208	1	0	19319	\N
6833	209	2	0	19323	\N
6789	854	3	0	19325	\N
6904	60	4	0	19533	\N
6904	1687	5	0	19536	\N
6823	198	2	0	20144	\N
6823	746	3	0	20150	\N
7041	68	3	0	22271	\N
6981	73	4	0	22573	\N
6981	1696	5	0	22574	\N
6808	149	4	0	23157	\N
6808	1664	5	0	23158	\N
6957	930	2	0	23926	\N
7075	930	0	0	23927	\N
6957	1304	3	0	23928	\N
7088	86	2	0	26481	\N
7088	509	3	0	26482	\N
7081	94	4	0	26776	\N
7081	1706	5	0	26777	\N
6938	155	3	0	28140	\N
6999	16	2	0	28147	\N
6999	155	3	0	28148	\N
7053	16	2	0	28149	\N
7053	155	3	0	28150	\N
6993	1640	9	0	29399	\N
6993	1701	10	0	29401	\N
7008	96	5	0	29565	\N
7008	1702	6	0	29570	\N
6997	360	2	0	31580	\N
6997	510	3	0	31581	\N
7036	322	2	0	32399	\N
6989	1	2	0	34289	\N
6989	112	3	0	34291	\N
7030	1	4	0	34292	\N
7030	422	5	0	34294	\N
7039	1	2	0	34296	\N
7047	1	4	0	34297	\N
7086	1	2	0	34298	\N
7101	1	2	0	34299	\N
7039	112	3	0	34300	\N
7086	112	3	0	34301	\N
7047	422	5	0	34303	\N
6870	531	2	0	34773	\N
6842	2	2	0	35678	\N
6842	131	3	0	35681	\N
6892	2	4	0	35684	\N
6892	315	5	0	35685	\N
6933	10	0	0	38266	\N
6936	10	0	0	38278	\N
6820	11	1	0	38286	\N
6820	10	3	0	38287	\N
6820	11	4	0	38288	\N
6844	10	3	0	38289	\N
6844	347	4	0	38290	\N
6865	10	5	0	38293	\N
6924	10	2	0	38305	\N
6924	29	3	0	38306	\N
7051	10	2	0	38323	\N
7051	29	3	0	38327	\N
6876	14	2	0	39422	\N
6876	383	3	0	39423	\N
6889	18	2	0	39822	\N
6889	1685	3	0	39823	\N
6897	18	0	0	39829	\N
7093	23	3	0	40735	\N
7093	350	4	0	40738	\N
6863	40	2	0	43076	\N
6863	66	3	0	43078	\N
6886	40	2	0	43083	\N
6910	40	2	0	43084	\N
6886	66	3	0	43086	\N
6910	66	3	0	43087	\N
6930	40	4	0	43092	\N
6930	564	5	0	43095	\N
7029	40	4	0	43101	\N
7029	564	5	0	43103	\N
6810	56	4	0	43897	\N
6810	1145	5	0	43901	\N
6988	56	2	0	43906	\N
7065	56	4	0	43907	\N
6988	169	3	0	43908	\N
7065	1145	5	0	43909	\N
7071	56	6	0	43910	\N
7071	1716	7	0	43911	\N
6982	75	4	0	45048	\N
6982	172	5	0	45053	\N
7060	75	4	0	45067	\N
7060	172	5	0	45068	\N
7090	75	2	0	45074	\N
7090	159	3	0	45075	\N
6843	79	1	0	46980	\N
6843	81	2	0	46981	\N
6923	79	2	0	46990	\N
6923	80	3	0	46992	\N
7087	79	2	0	46997	\N
7087	80	3	0	46998	\N
7057	88	2	0	47407	\N
7057	154	3	0	47408	\N
6827	102	8	0	47864	\N
6827	1669	9	0	47866	\N
6925	102	2	0	47879	\N
6925	158	3	0	47880	\N
6830	113	2	0	48379	\N
6830	114	3	0	48382	\N
6975	125	2	0	49302	\N
6975	188	3	0	49306	\N
6882	147	5	0	50048	\N
6882	1681	6	0	50082	\N
6822	156	2	0	50313	\N
6822	571	3	0	50315	\N
6860	186	2	0	51358	\N
6860	696	3	0	51359	\N
6965	210	2	0	51906	\N
6965	458	3	0	51910	\N
6792	242	4	0	52269	\N
6792	1662	5	0	52271	\N
6963	242	2	0	52283	\N
7069	242	0	0	52284	\N
6963	620	3	0	52285	\N
6811	268	2	0	52828	\N
6811	1387	3	0	52829	\N
6803	324	0	0	54392	\N
6875	452	2	0	55396	\N
6875	451	3	0	55410	\N
6916	595	2	0	55612	\N
6916	768	3	0	55620	\N
7055	1109	4	0	56261	\N
7055	1389	5	0	56264	\N
6927	793	2	0	56789	\N
6927	1136	3	0	56793	\N
6913	841	1	0	57040	\N
6998	841	0	0	57041	\N
7001	841	0	0	57043	\N
6913	842	2	0	57048	\N
6958	289	3	0	87	\N
6996	289	3	0	91	\N
6848	12	3	0	369	\N
6848	782	4	0	374	\N
6898	220	2	0	579	\N
6898	821	3	0	580	\N
6858	520	3	0	866	\N
6956	424	2	0	875	\N
6956	520	3	0	876	\N
7045	424	2	0	884	\N
7045	520	3	0	886	\N
7050	266	2	0	1189	\N
7050	1711	3	0	1190	\N
6850	1672	8	0	2657	\N
6985	110	2	0	2673	\N
6985	111	3	0	2674	\N
6905	391	2	0	10516	\N
6905	406	3	0	10518	\N
6947	391	3	0	10532	\N
6947	1691	4	0	10533	\N
7042	1691	3	0	10534	\N
7042	391	6	0	10542	\N
7042	406	7	0	10543	\N
6934	132	2	0	11271	\N
6934	133	3	0	11272	\N
7037	585	3	0	14547	\N
7077	44	13	0	16116	\N
7077	1718	14	0	16120	\N
7013	115	2	0	16746	\N
7013	636	3	0	16747	\N
6814	30	4	0	18034	\N
6814	1667	5	0	18037	\N
6942	208	2	0	19320	\N
6942	854	3	0	19327	\N
7031	264	2	0	23526	\N
7031	265	3	0	23529	\N
7021	411	4	0	25251	\N
6834	206	2	0	25851	\N
6834	693	3	0	25852	\N
7048	90	4	0	26119	\N
7048	358	5	0	26122	\N
6837	86	2	0	26467	\N
6837	509	3	0	26468	\N
6939	86	2	0	26477	\N
6939	509	3	0	26478	\N
6949	94	1	0	26765	\N
6949	107	2	0	26767	\N
6800	42	2	0	27619	\N
6800	681	3	0	27622	\N
6880	1679	6	0	30103	\N
6824	202	2	0	31174	\N
6824	812	3	0	31175	\N
6859	202	2	0	31180	\N
7092	360	3	0	31586	\N
7092	1353	4	0	31598	\N
7009	230	5	0	32138	\N
7009	1703	6	0	32140	\N
6991	453	4	0	32794	\N
6991	798	5	0	32799	\N
6952	1	7	0	34284	\N
6952	1336	8	0	34287	\N
6816	315	5	0	35677	\N
6857	2	9	0	35679	\N
6857	1674	10	0	35683	\N
6932	10	0	0	38265	\N
6877	10	2	0	38297	\N
6877	29	3	0	38298	\N
6890	10	3	0	38299	\N
6890	347	4	0	38300	\N
6914	10	2	0	38303	\N
6914	29	3	0	38304	\N
6971	10	1	0	38311	\N
6971	11	2	0	38312	\N
7016	600	5	0	38318	\N
7024	10	4	0	38319	\N
7034	10	2	0	38320	\N
7034	29	3	0	38321	\N
7024	600	5	0	38322	\N
6944	18	0	0	39834	\N
6826	27	2	0	41014	\N
6826	619	3	0	41017	\N
6928	66	3	0	43088	\N
6986	40	2	0	43093	\N
6986	66	3	0	43094	\N
6968	56	2	0	43903	\N
6968	169	3	0	43904	\N
7072	56	1	0	43912	\N
7072	57	2	0	43913	\N
7080	56	4	0	43914	\N
7080	1145	5	0	43915	\N
6901	75	2	0	45038	\N
6901	159	3	0	45040	\N
6921	79	4	0	46989	\N
6921	589	5	0	46994	\N
7058	79	2	0	46999	\N
7058	80	3	0	47000	\N
6959	121	2	0	48983	\N
6959	625	3	0	48990	\N
6872	516	2	0	50004	\N
6872	147	3	0	50045	\N
6896	170	2	0	50673	\N
6896	718	3	0	50674	\N
6972	268	2	0	52832	\N
6972	1387	3	0	52834	\N
7097	268	2	0	52838	\N
7097	1387	3	0	52841	\N
7043	285	4	0	53525	\N
7043	1709	5	0	53528	\N
6813	316	4	0	53997	\N
6813	1666	5	0	53999	\N
6980	353	2	0	54638	\N
6980	755	3	0	54640	\N
6794	362	2	0	54823	\N
6937	362	4	0	54824	\N
6794	420	3	0	54826	\N
6937	1688	5	0	54827	\N
6992	1700	11	1	55529	\N
6869	768	2	0	55578	\N
6869	595	3	0	55605	\N
6917	597	2	0	55963	\N
6917	767	3	0	55967	\N
7106	1109	2	0	56276	\N
7106	1412	3	0	56277	\N
6992	1699	11	0	56595	\N
6926	793	1	0	56788	\N
6926	1150	2	0	56791	\N
6911	841	2	0	57039	\N
7002	841	0	0	57044	\N
7003	841	0	0	57045	\N
6911	1161	3	0	57050	\N
6992	1697	10	0	57843	\N
6854	1620	5	0	852	\N
6852	110	3	0	2653	\N
6852	905	4	0	2655	\N
6849	736	7	0	2656	\N
6954	228	76	0	2943	\N
6954	1693	77	0	2946	\N
7100	237	2	0	3620	\N
7100	319	3	0	3635	\N
7114	222	3	0	5268	\N
6887	391	2	0	10504	\N
6887	406	3	0	10506	\N
7046	391	4	0	10548	\N
7046	539	5	0	10549	\N
6840	1635	5	0	11261	\N
7085	77	2	0	13233	\N
7085	216	3	0	13234	\N
7005	58	2	0	13594	\N
7005	665	3	0	13597	\N
7095	233	2	0	13957	\N
7095	910	3	0	13959	\N
7038	258	2	0	14548	\N
7038	585	3	0	14549	\N
7027	173	2	0	14760	\N
7027	480	3	0	14766	\N
7007	177	2	0	18293	\N
6953	208	7	0	19321	\N
6953	1692	8	0	19329	\N
6838	198	2	0	20145	\N
6838	746	3	0	20151	\N
7022	164	6	0	21309	\N
7022	662	7	0	21313	\N
6836	69	2	0	24768	\N
7083	69	4	0	24769	\N
6836	500	3	0	24771	\N
7083	1721	5	0	24772	\N
6983	49	2	0	25074	\N
6983	328	3	0	25075	\N
6809	1665	5	0	25252	\N
7014	224	2	0	25609	\N
7014	508	3	0	25617	\N
7019	94	4	0	26769	\N
7019	1706	5	0	26772	\N
6804	42	1	0	27620	\N
6804	43	2	0	27621	\N
6797	16	2	0	28129	\N
6797	155	3	0	28130	\N
6908	16	2	0	28133	\N
6908	155	3	0	28137	\N
6978	16	2	0	28143	\N
6992	1698	10	1	29393	\N
6992	1640	9	0	29398	\N
6829	96	2	0	29557	\N
6856	96	9	0	29558	\N
6829	482	3	0	29559	\N
6856	1673	10	0	29560	\N
6878	1625	40	0	29898	\N
6878	449	126	0	29911	\N
6878	1677	127	0	29912	\N
7040	54	2	0	30096	\N
7040	485	3	0	30099	\N
6859	812	3	0	31186	\N
6961	479	2	0	31562	\N
6845	33	6	0	31919	\N
7017	33	4	0	31920	\N
7017	447	5	0	31923	\N
6845	1671	7	0	31924	\N
6906	230	2	0	32137	\N
6906	231	3	0	32139	\N
6821	322	6	0	32383	\N
6821	1633	7	0	32384	\N
6818	453	2	0	32773	\N
6818	902	3	0	32774	\N
6864	453	5	0	32781	\N
6864	1272	6	0	32783	\N
6831	1	2	0	34276	\N
6831	112	3	0	34277	\N
6847	1	6	0	34278	\N
6847	523	7	0	34279	\N
6940	112	2	0	34280	\N
6940	1	3	0	34283	\N
7032	1	4	0	34293	\N
7032	422	5	0	34295	\N
6903	2	2	0	35686	\N
6903	131	3	0	35687	\N
7035	2	4	0	35688	\N
6935	10	0	0	38267	\N
6891	10	2	0	38301	\N
6891	29	3	0	38302	\N
6950	10	3	0	38307	\N
6950	347	4	0	38310	\N
6894	18	0	0	39826	\N
6948	18	0	0	39839	\N
7063	18	0	0	39842	\N
7074	27	2	0	41048	\N
7111	27	4	0	41049	\N
7074	619	3	0	41057	\N
7111	942	5	0	41059	\N
6995	40	2	0	43100	\N
6995	66	3	0	43102	\N
7067	40	3	0	43108	\N
7067	869	4	0	43114	\N
7110	51	4	0	43585	\N
7110	648	5	0	43586	\N
7011	75	5	0	45049	\N
7011	1705	6	0	45054	\N
7084	75	4	0	45073	\N
7084	172	5	0	45076	\N
7141	79	1	0	47003	\N
7141	81	2	0	47004	\N
7018	88	4	0	47403	\N
7018	601	5	0	47404	\N
7028	88	2	0	47405	\N
7028	154	3	0	47406	\N
7151	260	2	0	52466	\N
7151	419	3	0	52468	\N
6951	338	3	0	53753	\N
6951	339	4	0	53755	\N
6888	316	2	0	54006	\N
6888	332	3	0	54010	\N
7126	324	2	0	54417	\N
7126	486	3	0	54420	\N
6874	452	2	0	55395	\N
7059	451	2	0	55407	\N
6874	451	3	0	55409	\N
7059	452	3	0	55411	\N
6871	767	2	0	55943	\N
6881	597	5	0	55962	\N
6871	597	3	0	55966	\N
6881	1680	6	0	55968	\N
6885	1109	5	0	56260	\N
6885	1684	6	0	56265	\N
7104	704	3	0	56368	\N
7104	1724	4	0	56369	\N
7079	1021	4	0	56561	\N
7079	1047	5	0	56564	\N
7000	841	2	0	57042	\N
7004	841	0	0	57046	\N
7000	1161	3	0	57051	\N
6920	852	2	0	57326	\N
6920	1325	3	0	57327	\N
7116	852	4	0	57339	\N
7116	1727	5	0	57340	\N
7054	908	4	0	57635	\N
7054	1032	5	0	57638	\N
7118	908	11	0	57649	\N
7118	1728	12	0	57650	\N
6941	433	3	0	373	\N
6912	117	2	0	2089	\N
6909	248	2	0	2090	\N
6912	175	3	0	2091	\N
7089	1722	2	0	2273	\N
7089	1723	3	0	2274	\N
7026	110	4	0	2693	\N
7026	1708	5	0	2703	\N
7006	237	2	0	3619	\N
7102	237	1	0	3621	\N
7102	527	2	0	3628	\N
7006	319	3	0	3634	\N
6902	222	2	0	5267	\N
6907	373	2	0	5328	\N
6907	1504	3	0	5331	\N
7073	391	2	0	10557	\N
7099	391	2	0	10558	\N
7073	406	3	0	10562	\N
7099	406	3	0	10563	\N
7064	300	4	0	12080	\N
7176	300	1	0	12081	\N
7176	355	2	0	12084	\N
7064	1712	5	0	12089	\N
7052	528	2	0	12543	\N
7052	613	3	0	12546	\N
7094	234	2	0	13958	\N
6895	173	4	0	14752	\N
6895	1046	5	0	14753	\N
7136	192	2	0	15387	\N
7136	838	3	0	15391	\N
7062	115	2	0	16755	\N
7062	636	3	0	16756	\N
6979	212	2	0	17231	\N
6979	566	3	0	17234	\N
7146	198	1	0	20146	\N
7146	199	2	0	20148	\N
6893	488	4	0	21506	\N
7173	729	3	0	21508	\N
6893	1686	5	0	21509	\N
7160	149	3	0	23164	\N
7160	1739	4	0	23165	\N
7134	69	3	0	24785	\N
7134	594	4	0	24786	\N
7154	49	1	0	25079	\N
7154	50	2	0	25080	\N
7023	224	6	0	25610	\N
7023	1707	7	0	25618	\N
7049	94	2	0	26770	\N
7049	95	3	0	26771	\N
6922	16	4	0	28134	\N
6900	155	3	0	28136	\N
6922	380	5	0	28138	\N
6946	16	3	0	28141	\N
6967	16	2	0	28142	\N
6967	155	3	0	28144	\N
6946	1690	4	0	28146	\N
6977	911	3	0	29186	\N
6977	1695	4	0	29192	\N
6994	1640	9	0	29400	\N
6994	1701	10	0	29402	\N
6879	54	3	0	30094	\N
6962	360	2	0	31561	\N
6962	510	3	0	31563	\N
6990	322	4	0	32391	\N
6990	1616	5	0	32392	\N
7131	453	2	0	32795	\N
7131	902	3	0	32797	\N
6861	1	2	0	34281	\N
6861	112	3	0	34282	\N
6955	1	6	0	34285	\N
6955	523	7	0	34286	\N
6974	1	2	0	34288	\N
6974	112	3	0	34290	\N
7103	112	3	0	34305	\N
7105	1	2	0	34306	\N
7113	1	6	0	34307	\N
7105	112	3	0	34308	\N
7113	523	7	0	34309	\N
6868	2	6	0	35680	\N
6868	1566	7	0	35682	\N
6970	4	9	0	36100	\N
6970	1694	10	0	36103	\N
6867	10	2	0	38294	\N
6867	29	3	0	38295	\N
6969	10	1	0	38308	\N
6987	10	2	0	38313	\N
6987	29	3	0	38314	\N
7015	10	2	0	38315	\N
7015	29	3	0	38316	\N
7082	10	4	0	38324	\N
7096	10	2	0	38325	\N
7096	29	3	0	38328	\N
7082	600	5	0	38329	\N
7163	10	1	0	38333	\N
7163	11	2	0	38334	\N
7165	10	1	0	38335	\N
7165	11	2	0	38336	\N
6918	24	3	0	40737	\N
7186	40	1	0	43121	\N
7186	41	2	0	43122	\N
7425	40	3	0	43140	\N
7425	128	4	0	43144	\N
7211	51	1	0	43589	\N
7211	52	2	0	43590	\N
7432	79	1	0	46229	\N
7248	88	2	0	47409	\N
7248	154	3	0	47412	\N
7417	1783	1	0	47415	\N
7417	88	2	0	47418	\N
7255	102	1	0	47887	\N
7255	103	2	0	47888	\N
7312	102	1	0	47905	\N
7312	103	2	0	47911	\N
7389	113	3	0	48412	\N
7389	778	4	0	48414	\N
7119	181	2	0	50935	\N
7119	769	3	0	50941	\N
7279	186	0	0	51386	\N
7349	186	8	0	51398	\N
7349	1759	9	0	51401	\N
7266	260	1	0	52478	\N
7266	261	2	0	52481	\N
7153	353	2	0	54647	\N
7153	755	3	0	54651	\N
7428	1109	2	0	56288	\N
7428	1412	3	0	56292	\N
7298	1021	3	0	56562	\N
7298	1543	4	0	56563	\N
7191	424	2	0	900	\N
7235	424	2	0	920	\N
7235	520	3	0	921	\N
7356	424	9	0	939	\N
7372	424	30	0	940	\N
7356	1766	10	0	942	\N
7372	1779	31	0	944	\N
7375	424	1	0	958	\N
7375	425	2	0	959	\N
7156	1736	1	0	1881	\N
7156	1737	2	0	1882	\N
7430	110	1	0	2707	\N
7430	134	2	0	2709	\N
7245	1394	3	0	4086	\N
7107	365	2	0	4615	\N
7107	519	3	0	4616	\N
7109	365	4	0	4623	\N
7109	1725	5	0	4624	\N
7149	189	2	0	5040	\N
7149	1393	3	0	5042	\N
7341	1754	85	0	5046	\N
7341	189	126	0	5061	\N
7341	1755	127	0	5062	\N
7310	222	4	0	5275	\N
7310	1564	5	0	5277	\N
7142	581	4	0	10564	\N
7420	391	0	0	10601	\N
7354	1763	44	0	12090	\N
7354	300	59	0	12099	\N
7354	1764	60	0	12100	\N
7117	77	11	0	13251	\N
7315	77	2	0	13252	\N
7315	216	3	0	13257	\N
7117	1314	12	0	13259	\N
7344	58	1	0	13606	\N
7344	59	2	0	13608	\N
7197	402	2	0	14163	\N
7197	1148	3	0	14170	\N
7306	1148	3	0	14171	\N
7108	173	4	0	14761	\N
7108	1046	5	0	14769	\N
7347	173	7	0	14772	\N
7347	1757	8	0	14783	\N
7399	38	1	0	16483	\N
7399	399	2	0	16484	\N
7323	326	1	0	17452	\N
7323	327	2	0	17461	\N
7238	177	1	0	18301	\N
7238	498	2	0	18304	\N
7339	165	2	0	21324	\N
7199	336	1	0	22793	\N
7199	356	2	0	22795	\N
7209	264	1	0	23534	\N
7209	270	2	0	23538	\N
7144	82	1	0	23841	\N
7144	83	2	0	23843	\N
7223	49	2	0	25083	\N
7223	789	3	0	25086	\N
7139	224	1	0	25623	\N
7139	225	2	0	25624	\N
7147	206	1	0	25853	\N
7127	16	2	0	28151	\N
7127	155	3	0	28152	\N
7183	16	1	0	28159	\N
7183	17	2	0	28160	\N
7381	16	1	0	28165	\N
7381	17	2	0	28166	\N
7411	16	1	0	28171	\N
7411	17	2	0	28173	\N
7409	54	2	0	30098	\N
7409	485	3	0	30101	\N
7291	202	1	0	31181	\N
7291	203	2	0	31184	\N
7132	833	3	0	32412	\N
7101	112	3	0	34302	\N
7158	1	3	0	34311	\N
7194	53	1	0	34315	\N
7194	1	3	0	34317	\N
7194	53	4	0	34318	\N
7204	1	2	0	34320	\N
7204	112	3	0	34324	\N
7225	1	2	0	34326	\N
7225	444	3	0	34328	\N
7272	1	1	0	34337	\N
7272	53	2	0	34339	\N
7337	1233	6	0	34352	\N
7394	1	2	0	34354	\N
7394	112	3	0	34355	\N
7309	431	3	0	34775	\N
7309	1751	4	0	34778	\N
7125	2	2	0	35690	\N
7125	131	3	0	35691	\N
7228	2	1	0	35693	\N
7228	26	2	0	35696	\N
7251	4	1	0	36126	\N
7251	25	2	0	36127	\N
7112	6	4	0	36419	\N
7115	10	4	0	38326	\N
7115	600	5	0	38330	\N
7219	10	1	0	38342	\N
7219	11	2	0	38344	\N
7253	10	1	0	38348	\N
7253	11	2	0	38352	\N
7294	10	2	0	38355	\N
7294	29	3	0	38356	\N
7304	10	1	0	38357	\N
7304	11	2	0	38359	\N
7264	14	1	0	39433	\N
7264	15	2	0	39439	\N
7318	27	3	0	41050	\N
7330	27	1	0	41051	\N
7331	27	0	0	41052	\N
7364	27	8	0	41053	\N
7330	28	2	0	41055	\N
7318	1270	4	0	41058	\N
7364	1773	9	0	41060	\N
7124	40	2	0	43109	\N
7140	40	0	0	43110	\N
7162	40	1	0	43111	\N
7162	41	2	0	43112	\N
7124	66	3	0	43113	\N
7169	56	1	0	43916	\N
7178	56	1	0	43917	\N
7333	56	1	0	43918	\N
7169	57	2	0	43920	\N
7178	57	2	0	43921	\N
7333	57	2	0	43922	\N
7305	75	0	0	45108	\N
7343	79	1	0	47007	\N
7343	81	2	0	47008	\N
7414	89	1	0	47416	\N
7414	88	3	0	47419	\N
7414	1783	4	0	47421	\N
7406	113	1	0	48419	\N
7406	437	2	0	48420	\N
7167	121	1	0	48984	\N
7167	122	2	0	48987	\N
7159	125	3	0	49303	\N
7159	1738	4	0	49308	\N
7392	170	1	0	50689	\N
7392	398	2	0	50690	\N
7257	181	1	0	50936	\N
7257	530	2	0	50938	\N
7357	181	18	0	50951	\N
7357	1767	19	0	50952	\N
7401	186	1	0	51399	\N
7401	187	2	0	51400	\N
7171	285	1	0	53526	\N
7171	286	2	0	53527	\N
7397	285	1	0	53552	\N
7397	286	2	0	53556	\N
7382	595	1	0	55613	\N
7382	596	2	0	55617	\N
7179	1109	1	0	56280	\N
7179	1111	2	0	56282	\N
7145	841	1	0	57047	\N
7145	842	2	0	57049	\N
7282	841	1	0	57056	\N
7282	842	2	0	57059	\N
7133	1470	3	0	58257	\N
7133	1733	4	0	58263	\N
7210	221	2	0	582	\N
7188	424	1	0	899	\N
7188	425	2	0	901	\N
7373	424	29	0	941	\N
7373	1780	30	0	943	\N
7259	266	1	0	1196	\N
7259	267	2	0	1197	\N
7410	573	2	0	1895	\N
7410	1581	3	0	1896	\N
7161	110	3	0	2694	\N
7164	110	1	0	2695	\N
7241	110	1	0	2696	\N
7412	110	1	0	2697	\N
7241	134	2	0	2700	\N
7412	134	2	0	2701	\N
7161	1217	4	0	2704	\N
7138	367	2	0	3457	\N
7138	651	3	0	3458	\N
7370	1777	7	0	3888	\N
7370	262	8	0	3909	\N
7114	1726	4	0	5273	\N
7280	222	2	0	5274	\N
7280	232	3	0	5276	\N
7321	391	1	0	10581	\N
7321	392	2	0	10582	\N
7182	109	2	0	11782	\N
7216	108	3	0	11789	\N
7216	837	4	0	11790	\N
7352	300	8	0	12097	\N
7352	1762	9	0	12098	\N
7268	192	1	0	15388	\N
7268	193	2	0	15390	\N
7229	44	1	0	16117	\N
7229	45	2	0	16118	\N
7319	44	1	0	16129	\N
7319	45	2	0	16130	\N
7121	30	5	0	18035	\N
7185	142	1	0	18628	\N
7185	143	2	0	18629	\N
7376	290	1	0	19095	\N
7376	291	2	0	19097	\N
7201	198	1	0	20147	\N
7201	199	2	0	20149	\N
7368	67	7	0	22272	\N
7368	1775	8	0	22273	\N
7395	73	2	0	22580	\N
7395	703	3	0	22583	\N
7300	264	3	0	23536	\N
7300	1748	4	0	23540	\N
7122	1730	7	0	24086	\N
7175	49	3	0	25081	\N
7175	1740	4	0	25082	\N
7390	49	5	0	25084	\N
7390	1781	6	0	25085	\N
7303	94	5	0	26780	\N
7303	1750	6	0	26781	\N
7290	42	1	0	27627	\N
7290	43	2	0	27628	\N
7143	16	3	0	28154	\N
7143	359	4	0	28156	\N
7288	16	2	0	28161	\N
7404	16	1	0	28167	\N
7404	17	2	0	28168	\N
7328	151	1	0	30762	\N
7377	151	1	0	30763	\N
7328	302	2	0	30764	\N
7377	302	2	0	30765	\N
7129	1731	2	0	30924	\N
7129	1732	3	0	30926	\N
7335	33	5	0	31929	\N
7335	532	6	0	31932	\N
7158	711	4	0	34316	\N
7218	1	1	0	34325	\N
7265	1	1	0	34333	\N
7265	53	2	0	34335	\N
7285	1	1	0	34341	\N
7326	1	1	0	34344	\N
7285	53	2	0	34347	\N
7326	53	2	0	34350	\N
7221	2	1	0	35692	\N
7221	26	2	0	35695	\N
7180	10	1	0	38337	\N
7180	11	2	0	38338	\N
7187	10	1	0	38339	\N
7187	11	2	0	38340	\N
7203	29	3	0	38346	\N
7276	10	1	0	38349	\N
7276	11	2	0	38353	\N
7387	10	1	0	38369	\N
7387	11	2	0	38371	\N
7190	14	1	0	39426	\N
7190	15	2	0	39427	\N
7262	14	1	0	39432	\N
7267	14	1	0	39434	\N
7359	14	9	0	39435	\N
7418	14	2	0	39436	\N
7262	15	2	0	39438	\N
7359	1769	10	0	39443	\N
7172	18	5	0	39804	\N
7172	1513	6	0	39807	\N
7232	18	2	0	39814	\N
7232	218	3	0	39815	\N
7196	40	2	0	43129	\N
7196	66	3	0	43130	\N
7386	51	2	0	43595	\N
7386	524	3	0	43596	\N
7247	75	1	0	45094	\N
7247	76	2	0	45095	\N
7213	79	1	0	47005	\N
7213	81	2	0	47006	\N
7308	88	1	0	47410	\N
7308	89	2	0	47411	\N
7348	88	10	0	47413	\N
7348	1758	11	0	47414	\N
7416	89	1	0	47417	\N
7416	88	3	0	47420	\N
7416	1783	4	0	47422	\N
7277	113	1	0	48397	\N
7277	437	2	0	48399	\N
7384	147	1	0	50050	\N
7384	599	2	0	50066	\N
7123	186	6	0	51365	\N
7123	621	7	0	51366	\N
7281	186	2	0	51387	\N
7281	696	3	0	51388	\N
7208	200	1	0	51620	\N
7208	201	2	0	51621	\N
7353	210	8	0	51917	\N
7361	210	9	0	51918	\N
7353	1026	9	0	51930	\N
7361	1771	10	0	51931	\N
7184	285	1	0	53540	\N
7184	286	2	0	53541	\N
7237	416	1	0	54949	\N
7237	417	2	0	54951	\N
7174	451	2	0	55422	\N
7174	452	3	0	55423	\N
7244	1109	3	0	56281	\N
7244	1745	4	0	56283	\N
7351	1109	8	0	56287	\N
7351	1761	9	0	56294	\N
7286	400	2	0	114	\N
7166	527	2	0	3629	\N
7379	262	1	0	3917	\N
7379	263	2	0	3920	\N
7168	365	1	0	4631	\N
7168	366	2	0	4632	\N
7227	365	1	0	4639	\N
7227	366	2	0	4640	\N
7150	1735	106	0	5047	\N
7150	189	126	0	5063	\N
7150	1715	127	0	5065	\N
7314	222	1	0	5278	\N
7314	223	2	0	5279	\N
7355	1765	10	0	10592	\N
7189	123	1	0	12861	\N
7189	124	2	0	12862	\N
7198	402	4	0	14164	\N
7198	1378	5	0	14174	\N
7230	1743	93	0	16105	\N
7230	44	116	0	16121	\N
7230	1744	117	0	16123	\N
7234	38	1	0	16467	\N
7234	399	2	0	16468	\N
7239	30	1	0	18038	\N
7239	418	2	0	18039	\N
7374	291	2	0	19096	\N
7429	290	1	0	19104	\N
7429	291	2	0	19110	\N
7170	60	1	0	19542	\N
7170	61	2	0	19544	\N
7250	64	1	0	20847	\N
7322	64	1	0	20848	\N
7250	65	2	0	20849	\N
7322	65	2	0	20850	\N
7222	164	1	0	21310	\N
7222	165	2	0	21311	\N
7403	164	3	0	21331	\N
7157	73	3	0	22579	\N
7157	464	4	0	22584	\N
7263	336	1	0	22794	\N
7263	356	2	0	22796	\N
7400	336	8	0	22809	\N
7400	1782	9	0	22810	\N
7440	149	1	0	23178	\N
7440	499	2	0	23182	\N
7427	264	2	0	23537	\N
7427	265	3	0	23539	\N
7130	49	2	0	25077	\N
7130	328	3	0	25078	\N
7327	207	2	0	25856	\N
7260	1746	43	0	27360	\N
7260	244	126	0	27373	\N
7260	1747	127	0	27374	\N
7135	16	3	0	28153	\N
7135	359	4	0	28155	\N
7181	16	1	0	28157	\N
7181	17	2	0	28158	\N
7137	54	2	0	30097	\N
7137	485	3	0	30100	\N
7148	20	2	0	30535	\N
7269	20	1	0	30536	\N
7148	1734	3	0	30540	\N
7128	1731	2	0	30923	\N
7128	1732	3	0	30925	\N
7192	479	1	0	31582	\N
7193	479	1	0	31583	\N
7193	360	3	0	31592	\N
7193	479	4	0	31596	\N
7271	33	2	0	31921	\N
7271	34	3	0	31922	\N
7346	230	7	0	32148	\N
7346	1756	8	0	32149	\N
7120	322	2	0	32405	\N
7293	453	2	0	32807	\N
7329	453	1	0	32808	\N
7329	454	2	0	32809	\N
7293	902	3	0	32810	\N
7155	1	1	0	34310	\N
7177	1	1	0	34312	\N
7155	53	2	0	34313	\N
7177	53	2	0	34314	\N
7252	1	1	0	34330	\N
7252	53	2	0	34331	\N
7274	1	2	0	34338	\N
7274	112	3	0	34340	\N
7320	53	2	0	34348	\N
7408	1	3	0	34358	\N
7408	48	4	0	34360	\N
7283	2	1	0	35694	\N
7283	26	2	0	35697	\N
7317	2	3	0	35698	\N
7317	572	4	0	35699	\N
7336	2	5	0	35700	\N
7336	1060	6	0	35701	\N
7367	2	7	0	35702	\N
7367	1040	8	0	35705	\N
7152	10	2	0	38331	\N
7338	11	1	0	38361	\N
7338	10	4	0	38362	\N
7338	29	5	0	38363	\N
7369	1776	7	0	38366	\N
7363	10	8	0	38367	\N
7369	10	8	0	38372	\N
7363	1772	9	0	38373	\N
7422	10	1	0	38377	\N
7422	11	2	0	38378	\N
7441	10	2	0	38380	\N
7441	29	3	0	38381	\N
7256	40	1	0	43133	\N
7256	41	2	0	43134	\N
7289	40	1	0	43139	\N
7289	41	2	0	43142	\N
7195	75	2	0	45086	\N
7195	159	3	0	45087	\N
7345	75	1	0	45128	\N
7345	76	2	0	45129	\N
7275	100	1	0	47709	\N
7275	160	2	0	47715	\N
7302	102	5	0	47904	\N
7302	1749	6	0	47914	\N
7278	113	0	0	48398	\N
7388	113	1	0	48411	\N
7388	437	2	0	48413	\N
7443	121	1	0	48985	\N
7443	122	2	0	48988	\N
7311	137	4	0	49898	\N
7311	1752	5	0	49904	\N
7258	181	1	0	50937	\N
7258	530	2	0	50939	\N
7212	210	1	0	51916	\N
7212	211	2	0	51924	\N
7254	268	1	0	52839	\N
7254	269	2	0	52840	\N
7415	410	1	0	53024	\N
7415	273	3	0	53040	\N
7415	1784	4	0	53041	\N
7350	435	8	0	55002	\N
7350	1760	9	0	55003	\N
7358	435	18	0	55006	\N
7358	1768	19	0	55011	\N
7383	597	1	0	55964	\N
7383	598	2	0	55965	\N
7362	908	8	0	57655	\N
7362	1027	9	0	57658	\N
7202	1470	2	0	58258	\N
7334	1470	1	0	58259	\N
7334	1471	2	0	58260	\N
7202	1565	3	0	58262	\N
7214	425	2	0	908	\N
7413	111	3	0	2702	\N
7431	110	2	0	2708	\N
7431	111	3	0	2710	\N
7424	1787	24	0	2947	\N
7424	228	126	0	2950	\N
7424	1788	127	0	2951	\N
7371	262	6	0	3901	\N
7371	1778	7	0	3908	\N
7340	189	6	0	5057	\N
7340	1753	7	0	5060	\N
7246	391	1	0	10560	\N
7246	392	2	0	10561	\N
7261	581	4	0	10574	\N
7231	108	2	0	11799	\N
7292	108	1	0	11800	\N
7292	109	2	0	11801	\N
7231	501	3	0	11802	\N
7240	300	1	0	12082	\N
7240	355	2	0	12085	\N
7205	123	2	0	12874	\N
7205	384	3	0	12875	\N
7366	402	7	0	14166	\N
7366	1774	8	0	14175	\N
7301	173	1	0	14762	\N
7316	192	2	0	15389	\N
7316	838	3	0	15392	\N
7249	38	2	0	16476	\N
7249	39	3	0	16477	\N
7313	212	1	0	17232	\N
7313	213	2	0	17233	\N
7421	212	2	0	17241	\N
7421	566	3	0	17242	\N
7236	326	2	0	17451	\N
7236	747	3	0	17466	\N
7295	30	2	0	18040	\N
7295	31	3	0	18049	\N
7360	1770	10	0	19081	\N
7273	241	1	0	20457	\N
7273	333	2	0	20458	\N
7393	241	1	0	20468	\N
7393	333	2	0	20471	\N
7365	64	8	0	20855	\N
7365	986	9	0	20856	\N
7220	1440	1	0	21633	\N
7220	1741	2	0	21635	\N
7224	149	2	0	23177	\N
7224	1742	3	0	23186	\N
7299	264	0	0	23535	\N
7398	107	2	0	26785	\N
7332	16	1	0	28162	\N
7332	17	2	0	28163	\N
7407	16	1	0	28169	\N
7407	17	2	0	28170	\N
7436	16	1	0	28172	\N
7436	17	2	0	28174	\N
7215	96	3	0	29566	\N
7215	834	4	0	29569	\N
7287	20	2	0	30537	\N
7287	702	3	0	30539	\N
7192	360	3	0	31591	\N
7207	453	3	0	32796	\N
7207	1503	4	0	32798	\N
7200	1	1	0	34319	\N
7206	1	1	0	34321	\N
7200	53	2	0	34322	\N
7206	53	2	0	34323	\N
7243	1	3	0	34329	\N
7243	48	4	0	34332	\N
7270	1	1	0	34334	\N
7270	53	2	0	34336	\N
7324	1	1	0	34343	\N
7385	1	2	0	34346	\N
7385	112	3	0	34351	\N
7391	1	5	0	34353	\N
7391	1233	6	0	34356	\N
7405	1	1	0	34357	\N
7405	53	2	0	34359	\N
7423	1	1	0	34361	\N
7423	53	2	0	34362	\N
7439	4	1	0	36138	\N
7439	25	2	0	36139	\N
7226	10	1	0	38343	\N
7226	11	2	0	38345	\N
7233	10	1	0	38347	\N
7233	11	2	0	38351	\N
7284	29	3	0	38354	\N
7307	10	2	0	38358	\N
7307	29	3	0	38360	\N
7342	10	3	0	38364	\N
7342	347	4	0	38365	\N
7378	10	1	0	38368	\N
7378	11	2	0	38370	\N
7396	10	2	0	38374	\N
7396	29	3	0	38375	\N
7402	10	3	0	38376	\N
7402	347	4	0	38379	\N
7418	1785	3	0	39441	\N
7419	1786	4	0	39442	\N
7217	18	1	0	39810	\N
7217	19	2	0	39811	\N
7325	18	1	0	39820	\N
7325	19	2	0	39821	\N
7380	18	1	0	39824	\N
7380	19	2	0	39825	\N
7426	18	3	0	39827	\N
7426	127	4	0	39828	\N
771	56	4	0	43682	\N
7493	57	2	0	43923	\N
7446	71	1	0	44805	\N
7446	72	2	0	44808	\N
7437	75	1	0	45156	\N
7437	76	2	0	45157	\N
7442	75	1	0	45163	\N
7442	76	2	0	45164	\N
7478	75	2	0	45172	\N
7478	159	3	0	45173	\N
7464	79	1	0	46230	\N
7432	81	2	0	46231	\N
7464	81	2	0	46232	\N
7515	79	1	0	46287	\N
7461	113	3	0	48431	\N
7461	778	4	0	48436	\N
7447	119	1	0	48737	\N
7447	120	2	0	48738	\N
7470	121	2	0	48986	\N
7470	625	3	0	48991	\N
7453	125	3	0	49304	\N
7453	126	4	0	49307	\N
7465	170	1	0	50705	\N
7465	398	2	0	50706	\N
7484	181	1	0	50961	\N
7484	530	2	0	50962	\N
7450	186	2	0	51408	\N
7450	696	3	0	51409	\N
7476	200	2	0	51633	\N
7476	887	3	0	51636	\N
7433	268	1	0	52844	\N
7433	269	2	0	52845	\N
7438	268	1	0	52848	\N
7438	269	2	0	52853	\N
7482	324	3	0	54433	\N
7483	324	3	0	54434	\N
7482	937	4	0	54441	\N
7483	937	4	0	54442	\N
7485	353	1	0	54648	\N
7485	354	2	0	54650	\N
7468	451	1	0	55418	\N
7468	584	2	0	55420	\N
7435	1021	2	0	56565	\N
7435	1048	3	0	56566	\N
7455	908	1	0	57656	\N
7455	909	2	0	57657	\N
7457	13	2	0	392	\N
7496	821	3	0	584	\N
7499	1793	1	0	2370	\N
7499	1794	2	0	2373	\N
7448	110	1	0	2713	\N
7448	134	2	0	2714	\N
7500	237	1	0	3623	\N
7500	527	2	0	3630	\N
7467	1789	1	0	5176	\N
7467	1790	2	0	5179	\N
7501	1151	1	0	5185	\N
7501	1795	2	0	5186	\N
7495	391	2	0	10602	\N
7506	459	2	0	11975	\N
7506	1796	3	0	11976	\N
7502	528	1	0	12544	\N
7502	529	2	0	12545	\N
7486	123	1	0	12883	\N
7486	124	2	0	12884	\N
7445	256	1	0	13375	\N
7445	257	2	0	13376	\N
7472	456	1	0	13396	\N
7472	457	2	0	13399	\N
7454	258	1	0	14550	\N
7454	309	2	0	14552	\N
7466	764	2	0	15250	\N
7480	1792	0	0	16584	\N
7449	167	2	0	17812	\N
7449	168	3	0	17813	\N
7444	290	1	0	19105	\N
7444	291	2	0	19111	\N
7488	488	2	0	21517	\N
7488	729	3	0	21519	\N
7505	67	2	0	22274	\N
7505	68	3	0	22275	\N
7513	67	4	0	22276	\N
7513	1802	5	0	22281	\N
7492	499	2	0	23183	\N
7511	1799	57	0	25087	\N
7509	49	4	0	25088	\N
7509	1797	5	0	25091	\N
7511	49	117	0	25092	\N
7511	1800	118	0	25093	\N
7434	411	1	0	25258	\N
7434	412	2	0	25259	\N
7507	206	1	0	25857	\N
7507	207	2	0	25858	\N
7494	94	2	0	26786	\N
7494	95	3	0	26787	\N
7452	155	3	0	28176	\N
7458	16	1	0	28177	\N
7463	16	1	0	28178	\N
7458	17	2	0	28179	\N
7463	17	2	0	28180	\N
7503	16	2	0	28181	\N
7503	155	3	0	28182	\N
7508	16	1	0	28183	\N
7508	17	2	0	28184	\N
7479	20	1	0	30545	\N
7479	144	2	0	30546	\N
7471	230	1	0	32156	\N
7473	1791	20	0	32413	\N
7473	322	22	0	32421	\N
7473	323	23	0	32422	\N
7451	1	2	0	34363	\N
7459	1	1	0	34364	\N
7459	53	2	0	34365	\N
7451	112	3	0	34366	\N
7462	1	3	0	34367	\N
7462	48	4	0	34368	\N
7469	1	1	0	34369	\N
7477	1	2	0	34370	\N
7489	1	2	0	34371	\N
7469	53	2	0	34373	\N
7497	53	2	0	34374	\N
7477	112	3	0	34375	\N
7489	112	3	0	34376	\N
7504	1	2	0	34377	\N
7512	1	4	0	34378	\N
7504	112	3	0	34379	\N
7512	1801	5	0	34380	\N
7514	1	1	0	34381	\N
7514	53	2	0	34382	\N
7456	10	1	0	38382	\N
7460	10	3	0	38383	\N
7456	11	2	0	38385	\N
7474	29	3	0	38386	\N
7460	347	4	0	38387	\N
7475	10	2	0	38388	\N
7481	10	3	0	38389	\N
7475	29	3	0	38390	\N
7481	297	4	0	38391	\N
7487	10	2	0	38392	\N
7487	29	3	0	38393	\N
7498	10	3	0	38394	\N
7498	347	4	0	38395	\N
7510	10	4	0	38396	\N
7490	18	2	0	39830	\N
7490	218	3	0	39833	\N
7491	27	1	0	41054	\N
7491	28	2	0	41056	\N
7549	40	1	0	43153	\N
7549	41	2	0	43154	\N
7570	40	1	0	43157	\N
7570	41	2	0	43159	\N
7661	40	2	0	43172	\N
7661	66	3	0	43177	\N
7752	51	1	0	43607	\N
7752	52	2	0	43609	\N
7573	56	1	0	43928	\N
7573	57	2	0	43930	\N
7742	56	1	0	43932	\N
7756	56	1	0	43933	\N
7742	57	2	0	43934	\N
7756	57	2	0	43935	\N
7630	71	1	0	44817	\N
7630	72	2	0	44818	\N
7670	71	1	0	44823	\N
7670	72	2	0	44826	\N
7712	75	1	0	45225	\N
7712	76	2	0	45227	\N
7802	75	1	0	45259	\N
7802	76	2	0	45261	\N
7515	81	2	0	46288	\N
7831	100	1	0	47710	\N
7831	160	2	0	47716	\N
7805	113	1	0	48441	\N
7805	437	2	0	48443	\N
7656	125	1	0	49320	\N
7656	195	2	0	49321	\N
7720	125	1	0	49335	\N
7720	195	2	0	49340	\N
7754	135	1	0	49612	\N
7754	136	2	0	49613	\N
7683	156	3	0	50333	\N
7683	407	4	0	50334	\N
7602	170	1	0	50711	\N
7602	398	2	0	50712	\N
7537	268	1	0	52849	\N
7594	268	7	0	52850	\N
7537	269	2	0	52854	\N
7594	1812	8	0	52857	\N
7698	273	1	0	53065	\N
7698	410	2	0	53067	\N
7858	279	1	0	53172	\N
7858	473	2	0	53174	\N
7714	316	1	0	54018	\N
7714	317	2	0	54019	\N
7819	1840	6	1	55521	\N
7703	597	1	0	55976	\N
7703	598	2	0	55977	\N
7521	1109	3	0	56289	\N
7521	1745	4	0	56293	\N
7819	1839	6	0	58105	\N
7691	1470	0	0	58286	\N
7819	1838	5	1	58441	\N
7554	13	2	0	404	\N
7800	221	2	0	594	\N
7759	424	1	0	960	\N
7759	425	2	0	964	\N
7807	734	1	0	1082	\N
7807	1508	2	0	1085	\N
7675	117	5	0	2106	\N
7675	1831	6	0	2112	\N
7835	35	1	0	4269	\N
7516	132	1	0	11280	\N
7516	455	2	0	11281	\N
7547	132	2	0	11300	\N
7547	133	3	0	11301	\N
7605	132	1	0	11310	\N
7605	455	2	0	11311	\N
7819	1837	5	0	12979	\N
7819	77	4	0	13254	\N
7530	256	2	0	13377	\N
7530	1806	3	0	13380	\N
7764	402	1	0	14168	\N
7764	403	2	0	14169	\N
7672	258	1	0	14551	\N
7672	309	2	0	14553	\N
7523	92	1	0	15115	\N
7523	191	2	0	15116	\N
7663	838	3	0	15401	\N
7791	326	1	0	17453	\N
7791	327	2	0	17462	\N
7621	177	3	0	18302	\N
7621	1821	4	0	18305	\N
7793	198	1	0	20170	\N
7793	199	2	0	20171	\N
7735	241	1	0	20470	\N
7735	333	2	0	20473	\N
7648	64	2	0	20866	\N
7648	162	3	0	20873	\N
7532	164	1	0	21337	\N
7628	164	0	0	21344	\N
7825	488	1	0	21528	\N
7825	489	2	0	21529	\N
7518	67	1	0	22277	\N
7561	67	1	0	22278	\N
7518	478	2	0	22279	\N
7561	478	2	0	22280	\N
7559	149	1	0	23180	\N
7559	499	2	0	23184	\N
7855	149	1	0	23192	\N
7855	499	2	0	23193	\N
7641	82	1	0	23846	\N
7566	214	1	0	24482	\N
7566	215	2	0	24487	\N
7598	49	57	0	25098	\N
7598	1813	58	0	25099	\N
7596	86	1	0	26491	\N
7596	87	2	0	26493	\N
7528	1803	43	0	27375	\N
7528	244	126	0	27384	\N
7528	1804	127	0	27385	\N
7653	42	2	0	27643	\N
7653	681	3	0	27644	\N
7633	16	1	0	28190	\N
7639	16	1	0	28193	\N
7639	17	2	0	28197	\N
7749	16	1	0	28203	\N
7749	17	2	0	28204	\N
7579	54	54	0	30112	\N
7658	54	0	0	30114	\N
7579	1810	55	0	30118	\N
7726	151	1	0	30784	\N
7726	302	2	0	30785	\N
7707	202	3	0	31183	\N
7707	987	4	0	31187	\N
7797	360	1	0	31587	\N
7761	1	0	0	34393	\N
7517	431	1	0	34779	\N
7517	432	2	0	34780	\N
7650	4	0	0	36142	\N
7779	4	1	0	36149	\N
7779	25	2	0	36152	\N
7542	10	1	0	38402	\N
7542	11	2	0	38403	\N
7545	10	2	0	38404	\N
7545	29	3	0	38407	\N
7552	10	2	0	38408	\N
7552	29	3	0	38409	\N
7678	11	2	0	38435	\N
7696	10	1	0	38437	\N
7696	11	2	0	38443	\N
7744	10	0	0	38449	\N
7636	18	1	0	39835	\N
7636	19	2	0	39837	\N
7612	23	3	0	40747	\N
7612	350	4	0	40752	\N
7629	40	6	0	43158	\N
7629	522	7	0	43160	\N
7768	40	3	0	43185	\N
7768	128	4	0	43187	\N
7762	56	3	0	43936	\N
7762	475	4	0	43937	\N
7649	75	2	0	45182	\N
7649	159	3	0	45184	\N
7519	79	3	0	46332	\N
7637	79	1	0	46333	\N
7637	81	2	0	46334	\N
7519	272	4	0	46335	\N
7862	102	1	0	47906	\N
7862	103	2	0	47912	\N
7787	113	1	0	48433	\N
7787	437	2	0	48435	\N
7613	135	3	0	49582	\N
7613	1817	4	0	49586	\N
7705	147	1	0	50052	\N
7705	599	2	0	50067	\N
7733	186	3	0	51416	\N
7733	1834	4	0	51418	\N
7796	200	1	0	51650	\N
7796	201	2	0	51651	\N
7557	242	1	0	52297	\N
7557	253	2	0	52298	\N
7620	273	0	0	53057	\N
7860	285	1	0	53554	\N
7860	286	2	0	53558	\N
7538	362	1	0	54830	\N
7538	395	2	0	54831	\N
7667	595	2	0	55614	\N
7667	768	3	0	55621	\N
7718	597	1	0	55986	\N
7718	598	2	0	55990	\N
7833	704	1	0	56370	\N
7833	705	2	0	56371	\N
7568	1021	1	0	56569	\N
7568	1022	2	0	56570	\N
7690	841	1	0	57058	\N
7690	842	2	0	57060	\N
7680	852	1	0	57355	\N
7680	913	2	0	57356	\N
7611	477	4	0	591	\N
7695	252	2	0	1588	\N
7829	117	1	0	2107	\N
7829	248	2	0	2110	\N
7748	367	1	0	3463	\N
7748	368	2	0	3465	\N
7571	237	1	0	3624	\N
7571	527	2	0	3631	\N
7826	1841	1	0	3654	\N
7826	1842	2	0	3655	\N
7526	189	0	0	5041	\N
7535	391	2	0	10610	\N
7535	1381	3	0	10611	\N
7771	392	2	0	10645	\N
7765	300	1	0	12116	\N
7765	355	2	0	12117	\N
7777	77	1	0	13253	\N
7820	77	4	0	13255	\N
7777	78	2	0	13256	\N
7820	1132	5	0	13258	\N
7789	233	3	0	13972	\N
7789	1836	4	0	13973	\N
7746	402	3	0	14167	\N
7746	1328	4	0	14172	\N
7555	92	1	0	15126	\N
7713	192	1	0	15412	\N
7713	193	2	0	15413	\N
7643	38	9	0	16504	\N
7643	1825	10	0	16523	\N
7618	115	1	0	16781	\N
7618	116	2	0	16782	\N
7810	60	2	0	19569	\N
7810	166	3	0	19575	\N
7533	164	3	0	21338	\N
7533	1807	4	0	21341	\N
7632	67	2	0	22282	\N
7632	68	3	0	22283	\N
7697	478	2	0	22285	\N
7600	149	2	0	23181	\N
7600	697	3	0	23185	\N
7582	264	1	0	23549	\N
7582	270	2	0	23550	\N
7865	214	1	0	24484	\N
7865	215	2	0	24488	\N
7597	49	1	0	25089	\N
7597	50	2	0	25090	\N
7652	49	3	0	25095	\N
7652	1740	4	0	25096	\N
7803	49	1	0	25101	\N
7646	411	2	0	25268	\N
7646	582	3	0	25270	\N
7626	224	2	0	25632	\N
7626	508	3	0	25633	\N
7709	16	2	0	28196	\N
7709	155	3	0	28199	\N
7813	16	1	0	28205	\N
7813	17	2	0	28206	\N
7659	54	1	0	30115	\N
7659	55	2	0	30117	\N
7687	151	1	0	30776	\N
7687	302	2	0	30777	\N
7706	203	2	0	31185	\N
7591	230	2	0	32162	\N
7591	231	3	0	32169	\N
7837	453	1	0	32821	\N
7616	1	2	0	34387	\N
7616	112	3	0	34388	\N
7743	1	0	0	34392	\N
7817	1	1	0	34395	\N
7817	53	2	0	34397	\N
7606	2	1	0	35706	\N
7711	2	1	0	35707	\N
7606	26	2	0	35708	\N
7722	2	1	0	35710	\N
7722	26	2	0	35711	\N
7815	2	1	0	35716	\N
7824	2	1	0	35717	\N
7815	26	2	0	35718	\N
7824	26	2	0	35719	\N
7730	4	1	0	36145	\N
7730	25	2	0	36146	\N
7728	6	0	0	36421	\N
7550	10	1	0	38405	\N
7550	11	2	0	38406	\N
7580	10	1	0	38412	\N
7580	11	2	0	38416	\N
7583	11	2	0	38417	\N
7601	10	5	0	38420	\N
7601	1814	6	0	38423	\N
7623	10	4	0	38424	\N
7623	600	5	0	38425	\N
7664	10	4	0	38429	\N
7664	600	5	0	38431	\N
7671	10	1	0	38432	\N
7671	11	2	0	38433	\N
7682	10	1	0	38436	\N
7700	10	1	0	38438	\N
7700	11	2	0	38444	\N
7775	10	1	0	38453	\N
7775	11	2	0	38455	\N
7784	10	2	0	38457	\N
7784	29	3	0	38466	\N
7738	27	2	0	41081	\N
7738	619	3	0	41082	\N
7524	40	1	0	43141	\N
7524	41	2	0	43143	\N
7634	40	1	0	43163	\N
7634	41	2	0	43164	\N
7710	40	1	0	43173	\N
7710	41	2	0	43175	\N
7577	56	1	0	43929	\N
7577	57	2	0	43931	\N
7794	56	1	0	43938	\N
7794	57	2	0	43941	\N
7539	75	1	0	45181	\N
7539	76	2	0	45183	\N
7724	75	2	0	45226	\N
7724	159	3	0	45228	\N
7767	75	3	0	45239	\N
7767	857	4	0	45240	\N
7786	79	3	0	46390	\N
7786	272	4	0	46391	\N
7587	113	1	0	48432	\N
7587	437	2	0	48434	\N
7686	125	1	0	49328	\N
7686	195	2	0	49329	\N
7841	135	6	0	49620	\N
7841	1845	7	0	49629	\N
7755	137	1	0	49900	\N
7755	138	2	0	49902	\N
7721	147	1	0	50053	\N
7721	599	2	0	50068	\N
7520	156	3	0	50314	\N
7520	407	4	0	50316	\N
7592	200	1	0	51634	\N
7592	201	2	0	51635	\N
7843	260	1	0	52480	\N
7543	273	2	0	53039	\N
7543	1159	3	0	53043	\N
7740	279	1	0	53170	\N
7740	473	2	0	53171	\N
7694	285	1	0	53553	\N
7694	286	2	0	53557	\N
7699	316	1	0	54008	\N
7699	317	2	0	54009	\N
7840	1844	0	0	54421	\N
7717	595	1	0	55616	\N
7717	596	2	0	55619	\N
7666	597	2	0	55975	\N
7666	767	3	0	55978	\N
7654	841	2	0	57057	\N
7654	1161	3	0	57061	\N
7692	1470	1	0	58287	\N
7692	1471	2	0	58288	\N
7750	289	3	0	120	\N
7610	220	1	0	587	\N
7562	221	2	0	589	\N
7610	221	2	0	590	\N
7589	110	1	0	2715	\N
7589	134	2	0	2717	\N
7840	1843	0	0	3167	\N
7529	1805	85	0	5064	\N
7529	189	126	0	5078	\N
7529	1755	127	0	5079	\N
7747	391	1	0	10629	\N
7747	392	2	0	10630	\N
7708	132	2	0	11322	\N
7608	300	1	0	12106	\N
7608	355	2	0	12107	\N
7736	528	19	0	12557	\N
7736	1835	20	0	12567	\N
7551	123	1	0	12889	\N
7551	124	2	0	12893	\N
7540	256	1	0	13378	\N
7540	257	2	0	13379	\N
7575	256	1	0	13381	\N
7575	257	2	0	13383	\N
7673	58	1	0	13607	\N
7673	59	2	0	13609	\N
7783	236	2	0	15758	\N
7617	115	0	0	16780	\N
7567	30	1	0	18041	\N
7774	30	1	0	18042	\N
7567	418	2	0	18045	\N
7774	418	2	0	18046	\N
7622	177	3	0	18303	\N
7622	1821	4	0	18306	\N
7603	1815	1	0	19331	\N
7603	1816	2	0	19334	\N
7701	60	1	0	19543	\N
7701	61	2	0	19545	\N
7727	166	3	0	19558	\N
7662	198	0	0	20157	\N
7569	241	1	0	20469	\N
7569	333	2	0	20472	\N
7745	488	3	0	21518	\N
7745	1324	4	0	21520	\N
7676	82	0	0	23852	\N
7642	49	9	0	25094	\N
7642	1824	10	0	25097	\N
7651	49	8	0	25109	\N
7651	1828	9	0	25110	\N
7669	90	2	0	26120	\N
7753	90	1	0	26140	\N
7753	344	2	0	26142	\N
7584	16	1	0	28187	\N
7584	17	2	0	28188	\N
7615	16	2	0	28189	\N
7615	155	3	0	28192	\N
7679	16	1	0	28194	\N
7684	16	3	0	28195	\N
7679	17	2	0	28198	\N
7684	359	4	0	28200	\N
7737	16	1	0	28201	\N
7737	17	2	0	28202	\N
7548	97	2	0	29568	\N
7704	230	1	0	32163	\N
7704	287	2	0	32167	\N
7837	454	2	0	32826	\N
7599	1	1	0	34385	\N
7599	53	2	0	34386	\N
7681	1	0	0	34389	\N
7689	431	3	0	34781	\N
7689	1751	4	0	34782	\N
7585	2	4	0	35703	\N
7585	315	5	0	35704	\N
7781	2	1	0	35712	\N
7780	4	0	0	36150	\N
7531	10	2	0	38397	\N
7531	275	3	0	38398	\N
7553	10	1	0	38410	\N
7553	11	2	0	38414	\N
7645	10	1	0	38426	\N
7645	11	2	0	38427	\N
7657	10	1	0	38428	\N
7657	11	2	0	38430	\N
7715	10	1	0	38439	\N
7732	10	1	0	38441	\N
7715	11	2	0	38445	\N
7766	10	0	0	38450	\N
7770	10	1	0	38451	\N
7770	11	2	0	38452	\N
7560	14	1	0	39446	\N
7560	15	2	0	39449	\N
7564	18	1	0	39831	\N
7564	19	2	0	39832	\N
7757	18	1	0	39836	\N
7757	19	2	0	39838	\N
7625	23	2	0	40748	\N
7631	23	1	0	40749	\N
7631	217	2	0	40750	\N
7725	40	1	0	43174	\N
7725	41	2	0	43176	\N
7758	40	1	0	43180	\N
7758	41	2	0	43181	\N
7763	40	1	0	43184	\N
7763	41	2	0	43186	\N
7773	40	1	0	43192	\N
7773	41	2	0	43193	\N
7798	40	1	0	43198	\N
7798	41	2	0	43199	\N
7716	51	1	0	43599	\N
7716	52	2	0	43600	\N
7522	56	1	0	43924	\N
7522	57	2	0	43925	\N
7546	56	1	0	43926	\N
7546	57	2	0	43927	\N
7782	71	1	0	44824	\N
7782	72	2	0	44827	\N
7693	75	3	0	45206	\N
7693	1832	4	0	45207	\N
7769	75	1	0	45250	\N
7769	76	2	0	45251	\N
7811	75	2	0	45260	\N
7811	159	3	0	45262	\N
7816	75	1	0	45275	\N
7816	76	2	0	45277	\N
7790	119	1	0	48516	\N
7790	120	2	0	48517	\N
7614	137	3	0	49899	\N
7614	1818	4	0	49903	\N
7668	147	2	0	50051	\N
7668	516	3	0	50074	\N
7674	156	5	0	50321	\N
7674	1830	6	0	50322	\N
7804	170	1	0	50719	\N
7804	398	2	0	50720	\N
7525	186	1	0	51415	\N
7525	187	2	0	51417	\N
7792	260	1	0	52479	\N
7792	261	2	0	52482	\N
7595	273	1	0	53049	\N
7595	410	2	0	53050	\N
7688	435	1	0	55007	\N
7688	436	2	0	55009	\N
7702	595	1	0	55615	\N
7702	596	2	0	55618	\N
7565	1021	1	0	56567	\N
7565	1022	2	0	56568	\N
7578	908	1	0	57666	\N
7578	909	2	0	57668	\N
7640	1470	9	0	58272	\N
7640	1823	10	0	58273	\N
7655	1470	2	0	58280	\N
7655	1565	3	0	58281	\N
7760	424	2	0	961	\N
7647	266	1	0	1206	\N
7647	267	2	0	1207	\N
7590	110	2	0	2716	\N
7590	111	3	0	2718	\N
7572	237	3	0	3625	\N
7572	1809	4	0	3633	\N
7527	189	2	0	5058	\N
7527	311	3	0	5059	\N
7723	189	1	0	5074	\N
7799	189	2	0	5075	\N
7723	190	2	0	5076	\N
7799	311	3	0	5077	\N
7619	1820	2	0	5301	\N
7719	373	1	0	5332	\N
7719	374	2	0	5334	\N
7544	391	2	0	10619	\N
7660	391	1	0	10620	\N
7660	392	2	0	10621	\N
7544	406	3	0	10622	\N
7795	132	1	0	11323	\N
7795	455	2	0	11325	\N
7607	300	0	0	12105	\N
7734	528	1	0	12556	\N
7734	529	2	0	12563	\N
7576	124	2	0	12894	\N
7685	58	2	0	13616	\N
7685	665	3	0	13617	\N
7801	58	1	0	13624	\N
7801	59	2	0	13625	\N
7818	58	0	0	13634	\N
7823	233	1	0	13982	\N
7541	173	1	0	14773	\N
7541	396	2	0	14776	\N
7677	193	1	0	15394	\N
7677	192	5	0	15400	\N
7677	627	6	0	15402	\N
7635	399	2	0	16492	\N
7593	115	7	0	16770	\N
7593	1811	8	0	16771	\N
7751	62	1	0	19771	\N
7751	63	2	0	19775	\N
7534	164	4	0	21339	\N
7534	1808	5	0	21342	\N
7627	164	2	0	21343	\N
7627	226	3	0	21346	\N
7665	82	3	0	23847	\N
7665	1829	4	0	23849	\N
7776	140	1	0	24083	\N
7604	69	1	0	24796	\N
7604	70	2	0	24797	\N
7644	1826	7	0	25100	\N
7644	49	44	0	25103	\N
7644	1827	45	0	25104	\N
7638	411	1	0	25267	\N
7638	412	2	0	25269	\N
7624	224	6	0	25631	\N
7624	1822	7	0	25634	\N
7729	90	3	0	26128	\N
7729	1833	4	0	26129	\N
7558	16	1	0	28185	\N
7581	54	1	0	30113	\N
7581	55	2	0	30116	\N
7788	151	1	0	30792	\N
7788	302	2	0	30794	\N
7563	453	1	0	32819	\N
7772	453	1	0	32820	\N
7563	454	2	0	32824	\N
7772	454	2	0	32825	\N
7574	1	1	0	34383	\N
7574	53	2	0	34384	\N
7741	1	1	0	34390	\N
7741	53	2	0	34391	\N
7806	53	2	0	34396	\N
7809	2	1	0	35714	\N
7809	26	2	0	35715	\N
7536	10	1	0	38400	\N
7536	11	2	0	38401	\N
7556	10	1	0	38411	\N
7556	11	2	0	38415	\N
7586	10	4	0	38418	\N
7588	10	1	0	38419	\N
7588	11	2	0	38421	\N
7586	600	5	0	38422	\N
7731	10	1	0	38440	\N
7739	10	0	0	38448	\N
7778	10	1	0	38454	\N
7778	11	2	0	38456	\N
7808	10	1	0	38458	\N
7821	10	2	0	38459	\N
7808	11	2	0	38463	\N
7821	29	3	0	38467	\N
7785	18	2	0	39840	\N
7785	218	3	0	39841	\N
7812	40	1	0	43210	\N
7812	41	2	0	43212	\N
7913	40	2	0	43219	\N
7913	66	3	0	43221	\N
8057	40	1	0	43225	\N
8057	41	2	0	43226	\N
8122	40	2	0	43232	\N
8130	40	1	0	43233	\N
8130	41	2	0	43235	\N
8122	66	3	0	43237	\N
7901	75	2	0	45276	\N
7901	159	3	0	45279	\N
8098	75	2	0	45319	\N
8098	284	3	0	45321	\N
8134	75	2	0	45339	\N
8134	159	3	0	45341	\N
8043	88	1	0	47424	\N
8078	88	1	0	47425	\N
8043	89	2	0	47427	\N
8078	89	2	0	47428	\N
7842	137	6	0	49901	\N
7842	1846	7	0	49905	\N
7946	147	1	0	50054	\N
8001	147	1	0	50055	\N
8032	147	3	0	50056	\N
7946	599	2	0	50069	\N
8001	599	2	0	50070	\N
8032	148	4	0	50078	\N
7881	210	1	0	51919	\N
8101	210	1	0	51923	\N
7881	211	2	0	51925	\N
8101	211	2	0	51927	\N
8114	260	7	0	52490	\N
8114	1884	8	0	52491	\N
7847	268	1	0	52851	\N
7847	269	2	0	52855	\N
8105	279	1	0	53173	\N
8105	473	2	0	53175	\N
7951	285	1	0	53570	\N
7951	286	2	0	53571	\N
7838	324	1	0	54435	\N
7838	325	2	0	54438	\N
8014	378	2	0	54909	\N
8014	1867	3	0	54914	\N
7887	1109	1	0	56290	\N
7887	1111	2	0	56291	\N
7949	1021	1	0	56571	\N
7949	1022	2	0	56573	\N
7968	793	0	0	56797	\N
7910	841	1	0	57066	\N
7910	842	2	0	57067	\N
7827	852	1	0	57369	\N
7827	913	2	0	57370	\N
7822	821	3	0	595	\N
8006	1494	3	0	1675	\N
7967	1861	0	0	1907	\N
7929	367	1	0	3474	\N
7929	368	2	0	3475	\N
7899	365	2	0	4650	\N
7899	519	3	0	4653	\N
7975	189	3	0	5095	\N
7975	827	4	0	5096	\N
7857	391	1	0	10644	\N
7857	392	2	0	10646	\N
7919	391	3	0	10657	\N
7919	581	4	0	10660	\N
8092	392	2	0	10682	\N
8139	391	2	0	10702	\N
8139	406	3	0	10705	\N
7890	355	1	0	12108	\N
7890	300	2	0	12118	\N
7932	1855	37	0	12568	\N
7932	528	126	0	12582	\N
7932	1856	127	0	12583	\N
7986	123	3	0	12892	\N
7986	1041	4	0	12896	\N
7903	233	2	0	13983	\N
7823	234	2	0	13984	\N
7936	173	1	0	14788	\N
8036	173	1	0	14789	\N
7936	396	2	0	14790	\N
8036	396	2	0	14791	\N
7828	92	1	0	15137	\N
7828	191	2	0	15138	\N
7859	192	1	0	15422	\N
7859	193	2	0	15423	\N
7924	235	1	0	15773	\N
7924	236	2	0	15774	\N
8069	235	1	0	15787	\N
8069	236	2	0	15788	\N
8087	236	2	0	15794	\N
7868	44	1	0	16137	\N
7868	45	2	0	16138	\N
7832	326	1	0	17454	\N
7832	327	2	0	17463	\N
8024	167	2	0	17832	\N
8024	168	3	0	17836	\N
7908	290	1	0	19106	\N
7908	291	2	0	19112	\N
7814	198	1	0	20176	\N
7814	199	2	0	20177	\N
7897	64	1	0	20867	\N
7897	65	2	0	20871	\N
7970	65	2	0	20872	\N
7875	164	2	0	21345	\N
7875	226	3	0	21347	\N
7864	214	0	0	24483	\N
8008	411	0	0	25282	\N
8124	224	5	0	25671	\N
8124	1885	6	0	25674	\N
7885	94	1	0	26788	\N
7885	107	2	0	26794	\N
7941	16	1	0	28215	\N
7941	17	2	0	28218	\N
8136	144	2	0	30560	\N
8021	453	2	0	32823	\N
8021	902	3	0	32828	\N
7830	1	1	0	34398	\N
7830	53	2	0	34399	\N
7834	1	1	0	34400	\N
7844	1	2	0	34401	\N
7894	1	1	0	34402	\N
7834	53	2	0	34403	\N
7894	53	2	0	34404	\N
7844	112	3	0	34405	\N
7980	1	3	0	34420	\N
7989	112	3	0	34422	\N
7980	48	4	0	34423	\N
7998	1	1	0	34424	\N
7998	53	2	0	34427	\N
8080	1	2	0	34431	\N
8080	283	3	0	34433	\N
8018	4	1	0	36164	\N
8018	25	2	0	36165	\N
7836	10	1	0	38460	\N
7849	10	2	0	38462	\N
7849	29	3	0	38468	\N
7852	10	3	0	38469	\N
7962	10	3	0	38489	\N
7962	347	4	0	38490	\N
8062	10	2	0	38513	\N
8062	792	3	0	38514	\N
8103	10	4	0	38524	\N
8103	1881	5	0	38527	\N
8119	10	1	0	38528	\N
8119	11	2	0	38530	\N
7927	18	2	0	39844	\N
7927	218	3	0	39851	\N
7886	40	1	0	43211	\N
7886	41	2	0	43213	\N
7920	40	2	0	43222	\N
7920	66	3	0	43223	\N
8051	40	3	0	43224	\N
8051	128	4	0	43227	\N
8148	40	1	0	43234	\N
8148	41	2	0	43236	\N
7937	51	1	0	43608	\N
7937	52	2	0	43610	\N
7960	56	1	0	43944	\N
7960	57	2	0	43945	\N
7950	75	1	0	45286	\N
7950	76	2	0	45287	\N
8007	75	2	0	45311	\N
8007	159	3	0	45312	\N
8104	75	4	0	45320	\N
8104	1882	5	0	45322	\N
8146	75	2	0	45348	\N
8146	159	3	0	45353	\N
7982	79	3	0	46435	\N
7982	272	4	0	46436	\N
7977	88	1	0	47423	\N
7977	89	2	0	47426	\N
7866	102	16	0	47907	\N
7866	1847	17	0	47915	\N
8066	210	2	0	51921	\N
8099	210	2	0	51922	\N
8066	1874	3	0	51928	\N
8099	1874	3	0	51929	\N
7879	285	1	0	53555	\N
7879	286	2	0	53559	\N
7923	353	3	0	54649	\N
7923	1854	4	0	54652	\N
8061	435	1	0	55008	\N
8061	436	2	0	55010	\N
7996	595	1	0	55643	\N
8030	595	3	0	55644	\N
7996	596	2	0	55648	\N
8030	813	4	0	55650	\N
7944	597	1	0	55987	\N
7999	597	0	0	55988	\N
8003	597	0	0	55989	\N
7944	598	2	0	55991	\N
8084	597	1	0	56017	\N
8084	598	2	0	56018	\N
8112	425	2	0	965	\N
7905	1851	3	0	1598	\N
8037	117	1	0	2108	\N
8037	248	2	0	2111	\N
8154	117	1	0	2132	\N
8154	248	2	0	2133	\N
7845	367	2	0	3464	\N
7845	651	3	0	3466	\N
8054	262	1	0	3918	\N
8054	263	2	0	3921	\N
8020	35	2	0	4273	\N
8020	36	3	0	4275	\N
8074	1875	5	0	4276	\N
8150	373	4	0	5333	\N
8150	1887	5	0	5335	\N
8071	391	2	0	10674	\N
8071	406	3	0	10676	\N
7917	1852	1	0	12329	\N
7917	1853	2	0	12331	\N
7958	528	1	0	12559	\N
7958	529	2	0	12565	\N
8015	123	2	0	12899	\N
8015	1868	3	0	12900	\N
8081	77	3	0	13268	\N
8081	1877	4	0	13269	\N
7870	480	3	0	14778	\N
8059	92	2	0	15145	\N
8059	93	3	0	15146	\N
7853	192	1	0	15418	\N
7853	193	2	0	15419	\N
8093	235	1	0	15804	\N
8093	236	2	0	15806	\N
7931	38	1	0	16505	\N
7931	399	2	0	16510	\N
7863	167	1	0	17820	\N
7863	533	2	0	17821	\N
8135	198	1	0	20191	\N
8017	164	1	0	21350	\N
8017	165	2	0	21351	\N
8086	149	2	0	23201	\N
8086	1379	3	0	23203	\N
7966	140	0	0	24100	\N
8028	214	1	0	24485	\N
8132	214	2	0	24486	\N
8028	215	2	0	24489	\N
8132	227	3	0	24491	\N
8056	224	1	0	25642	\N
8056	225	2	0	25643	\N
8116	206	1	0	25859	\N
8079	94	1	0	26789	\N
8079	107	2	0	26795	\N
8144	42	2	0	27654	\N
8144	681	3	0	27659	\N
7839	16	1	0	28207	\N
7839	17	2	0	28208	\N
7850	16	1	0	28209	\N
7850	17	2	0	28210	\N
8026	16	2	0	28221	\N
8026	155	3	0	28222	\N
8109	16	1	0	28223	\N
8109	17	2	0	28224	\N
8143	17	2	0	28228	\N
7928	1057	1	0	29950	\N
7928	1058	2	0	29951	\N
8128	20	0	0	30556	\N
8152	151	1	0	30801	\N
8152	302	2	0	30803	\N
7973	202	1	0	31196	\N
7973	203	2	0	31197	\N
8089	360	1	0	31588	\N
8138	360	0	0	31589	\N
8089	479	2	0	31594	\N
8012	322	2	0	32429	\N
7939	1	1	0	34414	\N
7939	53	2	0	34415	\N
7892	26	1	0	35722	\N
7877	2	2	0	35724	\N
7892	2	2	0	35726	\N
7877	131	3	0	35728	\N
8107	6	1	0	36424	\N
8107	194	2	0	36425	\N
7836	11	2	0	38464	\N
7902	10	2	0	38481	\N
7948	10	1	0	38483	\N
7953	10	1	0	38484	\N
7953	11	2	0	38486	\N
7902	275	3	0	38487	\N
7993	10	2	0	38497	\N
7993	29	3	0	38498	\N
8046	10	1	0	38507	\N
8049	10	1	0	38508	\N
8046	11	2	0	38511	\N
8049	11	2	0	38512	\N
8068	10	0	0	38519	\N
8095	10	2	0	38521	\N
8095	275	3	0	38523	\N
8125	10	1	0	38529	\N
7955	14	1	0	39448	\N
7955	15	2	0	39451	\N
7984	14	3	0	39454	\N
7984	1863	4	0	39455	\N
7889	40	1	0	43216	\N
7889	41	2	0	43217	\N
8072	40	2	0	43228	\N
8072	66	3	0	43231	\N
7874	56	1	0	43940	\N
7874	57	2	0	43942	\N
7971	56	5	0	43946	\N
7971	677	6	0	43947	\N
8060	56	2	0	43948	\N
8060	169	3	0	43953	\N
8117	75	1	0	45338	\N
8117	76	2	0	45340	\N
8023	79	1	0	46490	\N
8023	81	2	0	46491	\N
8067	79	2	0	46545	\N
8164	79	0	0	46546	\N
8067	616	3	0	46549	\N
7926	113	2	0	48442	\N
7926	114	3	0	48444	\N
8121	113	0	0	48452	\N
8123	113	2	0	48453	\N
8123	114	3	0	48454	\N
8096	119	2	0	48575	\N
8096	1879	3	0	48578	\N
8141	121	1	0	49005	\N
8141	122	2	0	49007	\N
8085	147	1	0	50057	\N
8085	599	2	0	50071	\N
7938	210	1	0	51920	\N
7938	211	2	0	51926	\N
7956	242	2	0	52301	\N
7956	620	3	0	52302	\N
7843	261	2	0	52483	\N
7856	273	1	0	53066	\N
7856	410	2	0	53068	\N
7940	324	1	0	54436	\N
7940	325	2	0	54439	\N
8094	353	1	0	54655	\N
8094	354	2	0	54657	\N
7848	378	1	0	54907	\N
7848	379	2	0	54908	\N
8031	1870	0	0	55985	\N
7988	1109	3	0	56305	\N
7988	1745	4	0	56306	\N
7985	1021	3	0	56572	\N
7985	1864	4	0	56574	\N
8005	1130	2	0	57825	\N
8005	1865	3	0	57830	\N
8113	1883	2	0	58439	\N
8151	1888	5	0	1373	\N
8082	1878	5	0	2113	\N
8090	367	1	0	3485	\N
8090	368	2	0	3489	\N
8031	1869	0	0	4111	\N
8126	35	1	0	4281	\N
8126	340	2	0	4283	\N
7964	391	1	0	10658	\N
7964	392	2	0	10659	\N
8050	391	1	0	10673	\N
8050	392	2	0	10675	\N
8171	391	1	0	10703	\N
7882	132	2	0	11324	\N
7959	528	31	0	12609	\N
7959	1860	32	0	12612	\N
8118	256	1	0	13382	\N
8118	257	2	0	13384	\N
7945	258	1	0	14554	\N
7945	309	2	0	14555	\N
7994	258	2	0	14556	\N
8042	258	1	0	14557	\N
8042	309	2	0	14558	\N
7994	585	3	0	14559	\N
8156	258	1	0	14560	\N
8156	309	2	0	14561	\N
8110	161	3	0	16162	\N
8045	30	1	0	18043	\N
8045	418	2	0	18047	\N
7896	60	1	0	19570	\N
7896	61	2	0	19573	\N
8102	62	2	0	19773	\N
8102	1880	3	0	19774	\N
7969	64	5	0	20868	\N
8052	64	3	0	20870	\N
8052	130	4	0	20874	\N
7969	1862	6	0	20875	\N
7884	164	1	0	21348	\N
7912	67	1	0	22286	\N
7912	478	2	0	22287	\N
7979	149	1	0	23200	\N
7979	499	2	0	23202	\N
8010	90	1	0	26141	\N
8010	344	2	0	26143	\N
7915	16	1	0	28213	\N
7915	17	2	0	28214	\N
8000	16	1	0	28217	\N
8000	17	2	0	28220	\N
8129	20	1	0	30557	\N
8129	144	2	0	30559	\N
8075	1876	5	0	30804	\N
8161	151	1	0	30814	\N
8161	302	2	0	30815	\N
7880	453	1	0	32822	\N
7880	454	2	0	32827	\N
7907	1	1	0	34406	\N
7907	53	2	0	34407	\N
7918	1	3	0	34410	\N
7918	48	4	0	34411	\N
7935	1	1	0	34412	\N
7935	53	2	0	34413	\N
8033	1	12	0	34425	\N
8077	1	1	0	34430	\N
8077	53	2	0	34432	\N
7867	2	1	0	35720	\N
7867	26	2	0	35721	\N
7871	2	2	0	35723	\N
7961	2	3	0	35725	\N
7871	131	3	0	35727	\N
7961	572	4	0	35729	\N
8038	2	1	0	35730	\N
8038	26	2	0	35731	\N
8040	4	1	0	36166	\N
8040	25	2	0	36167	\N
7846	11	2	0	38465	\N
7854	10	1	0	38471	\N
7861	10	1	0	38472	\N
7854	11	2	0	38474	\N
7861	11	2	0	38475	\N
7921	10	2	0	38482	\N
7921	29	3	0	38488	\N
7974	10	2	0	38492	\N
7974	29	3	0	38494	\N
7991	10	1	0	38495	\N
7991	11	2	0	38496	\N
7997	10	1	0	38501	\N
8064	10	1	0	38515	\N
8064	11	2	0	38516	\N
8091	10	1	0	38520	\N
8091	11	2	0	38522	\N
8133	10	2	0	38532	\N
8133	29	3	0	38536	\N
7851	14	1	0	39447	\N
7851	15	2	0	39450	\N
8013	14	2	0	39460	\N
8013	1785	3	0	39463	\N
8047	18	1	0	39853	\N
8047	19	2	0	39854	\N
8100	1685	3	0	39858	\N
7900	40	2	0	43218	\N
7900	66	3	0	43220	\N
8111	40	1	0	43229	\N
8111	41	2	0	43230	\N
7965	51	0	0	43617	\N
7872	56	2	0	43939	\N
7872	169	3	0	43943	\N
7893	76	1	0	45263	\N
7893	75	2	0	45278	\N
7983	75	1	0	45302	\N
7983	76	2	0	45303	\N
8004	79	2	0	46489	\N
8004	80	3	0	46492	\N
8063	100	2	0	47711	\N
8063	1228	3	0	47719	\N
8097	119	2	0	48576	\N
8097	1879	3	0	48579	\N
7904	186	2	0	51419	\N
7904	1850	3	0	51423	\N
8131	260	1	0	52496	\N
8131	261	2	0	52497	\N
7922	268	2	0	52852	\N
7922	1387	3	0	52856	\N
8009	316	1	0	54028	\N
8009	317	2	0	54030	\N
8016	451	3	0	55419	\N
8016	826	4	0	55421	\N
7943	595	1	0	55642	\N
8083	595	1	0	55645	\N
7943	596	2	0	55647	\N
8083	596	2	0	55649	\N
7898	793	1	0	56790	\N
7898	1150	2	0	56792	\N
8025	793	2	0	56804	\N
8025	1136	3	0	56808	\N
7878	852	3	0	57380	\N
7878	1848	4	0	57381	\N
8127	248	2	0	2125	\N
7954	1859	2	0	3022	\N
8044	367	1	0	3484	\N
8044	368	2	0	3488	\N
8034	391	12	0	10667	\N
8034	1872	13	0	10668	\N
8137	391	2	0	10693	\N
8137	406	3	0	10694	\N
7930	528	1	0	12558	\N
7930	529	2	0	12564	\N
7925	123	1	0	12891	\N
7925	124	2	0	12895	\N
8022	123	2	0	12905	\N
8073	123	2	0	12911	\N
8073	1868	3	0	12912	\N
7934	173	1	0	14775	\N
7934	396	2	0	14777	\N
8048	192	1	0	15426	\N
8106	192	1	0	15427	\N
8048	193	2	0	15429	\N
8106	193	2	0	15430	\N
7933	38	4	0	16506	\N
7933	1857	5	0	16513	\N
8115	115	1	0	16794	\N
8115	116	2	0	16795	\N
8142	116	2	0	16805	\N
7891	213	1	0	17243	\N
7876	212	2	0	17249	\N
7891	212	2	0	17253	\N
7876	566	3	0	17256	\N
8035	326	12	0	17455	\N
8035	1873	13	0	17469	\N
8145	167	2	0	17833	\N
8027	60	1	0	19571	\N
8027	61	2	0	19574	\N
7895	62	1	0	19772	\N
7895	63	2	0	19776	\N
7906	199	2	0	20183	\N
7952	198	1	0	20189	\N
8058	198	2	0	20190	\N
7952	199	2	0	20192	\N
8058	746	3	0	20194	\N
8070	488	2	0	21541	\N
8070	729	3	0	21542	\N
7981	224	3	0	25640	\N
7987	224	3	0	25641	\N
7981	387	4	0	25644	\N
7987	387	4	0	25645	\N
8076	224	2	0	25657	\N
7992	86	1	0	26492	\N
7992	87	2	0	26494	\N
7873	42	1	0	27653	\N
7873	43	2	0	27657	\N
7909	16	1	0	28211	\N
7909	17	2	0	28212	\N
7957	16	1	0	28216	\N
7957	17	2	0	28219	\N
8055	151	1	0	30793	\N
8055	302	2	0	30795	\N
8153	151	44	0	30802	\N
8153	1889	45	0	30805	\N
8140	510	3	0	31597	\N
8011	33	1	0	31930	\N
8011	163	2	0	31931	\N
7947	322	1	0	32419	\N
7947	323	2	0	32420	\N
7916	1	1	0	34408	\N
7916	53	2	0	34409	\N
7976	1	1	0	34416	\N
7976	53	2	0	34417	\N
7978	1	1	0	34418	\N
7978	53	2	0	34419	\N
8053	1	1	0	34426	\N
8159	1	1	0	34434	\N
7911	4	1	0	36151	\N
7911	25	2	0	36153	\N
8120	4	1	0	36168	\N
8120	25	2	0	36169	\N
8157	4	1	0	36170	\N
8157	25	2	0	36173	\N
7972	6	1	0	36422	\N
7972	194	2	0	36423	\N
7869	10	2	0	38473	\N
7869	29	3	0	38476	\N
7883	10	1	0	38477	\N
7883	11	2	0	38479	\N
7888	11	2	0	38480	\N
7963	10	1	0	38491	\N
7963	11	2	0	38493	\N
7995	10	2	0	38499	\N
7995	29	3	0	38500	\N
8019	10	1	0	38502	\N
8019	11	2	0	38504	\N
8039	10	1	0	38505	\N
8041	10	1	0	38506	\N
8039	11	2	0	38509	\N
8041	11	2	0	38510	\N
8065	275	3	0	38518	\N
8108	10	1	0	38525	\N
8108	11	2	0	38526	\N
8088	14	1	0	39461	\N
8088	15	2	0	39462	\N
7914	18	2	0	39843	\N
7942	18	1	0	39845	\N
7990	18	2	0	39846	\N
8029	18	1	0	39847	\N
7942	19	2	0	39848	\N
8029	19	2	0	39849	\N
7914	218	3	0	39850	\N
8191	40	1	0	43238	\N
8196	40	3	0	43239	\N
8191	41	2	0	43242	\N
8196	128	4	0	43244	\N
8160	51	1	0	43618	\N
8219	51	2	0	43619	\N
8160	52	2	0	43622	\N
8219	1897	3	0	43623	\N
8173	56	1	0	43949	\N
8206	56	1	0	43950	\N
8173	57	2	0	43951	\N
8206	57	2	0	43952	\N
8212	56	2	0	43954	\N
8212	169	3	0	43955	\N
8225	56	1	0	43956	\N
8225	57	2	0	43957	\N
8165	79	1	0	46547	\N
8165	81	2	0	46548	\N
8223	79	1	0	46599	\N
8223	81	2	0	46601	\N
8194	113	3	0	48464	\N
8194	778	4	0	48465	\N
8182	119	4	0	48577	\N
8182	423	5	0	48580	\N
8203	119	3	0	48610	\N
8203	1893	4	0	48611	\N
8234	147	3	0	50058	\N
8234	148	4	0	50079	\N
8167	170	2	0	50731	\N
8167	718	3	0	50736	\N
8166	242	1	0	52305	\N
8166	253	2	0	52307	\N
8168	362	2	0	54838	\N
8169	362	2	0	54839	\N
8168	420	3	0	54840	\N
8169	420	3	0	54841	\N
8172	435	1	0	55014	\N
8172	436	2	0	55017	\N
8230	595	3	0	55646	\N
8230	813	4	0	55651	\N
8232	597	3	0	56028	\N
8232	1406	4	0	56037	\N
8195	793	3	0	56805	\N
8221	793	1	0	56806	\N
8221	1150	2	0	56807	\N
8195	1169	4	0	56809	\N
8188	852	1	0	57393	\N
8188	913	2	0	57394	\N
8204	852	3	0	57404	\N
8204	1894	4	0	57413	\N
8217	1470	2	0	58297	\N
8217	1896	3	0	58298	\N
8176	821	3	0	599	\N
8149	1886	3	0	1372	\N
8220	237	2	0	3626	\N
8220	1898	3	0	3637	\N
8181	35	2	0	4282	\N
8171	392	2	0	10704	\N
8178	391	2	0	10710	\N
8178	406	3	0	10711	\N
8192	108	2	0	11809	\N
8193	108	0	0	11810	\N
8192	501	3	0	11811	\N
8177	1890	2	0	12338	\N
8177	1891	3	0	12340	\N
8185	92	1	0	15155	\N
8185	191	2	0	15156	\N
8201	235	1	0	15805	\N
8201	236	2	0	15807	\N
8226	235	1	0	15816	\N
8226	236	2	0	15819	\N
8145	168	3	0	17837	\N
8214	765	1	0	18419	\N
8214	766	2	0	18420	\N
8224	142	1	0	18646	\N
8224	143	2	0	18649	\N
8170	198	1	0	20201	\N
8200	67	1	0	22288	\N
8200	478	2	0	22289	\N
8205	336	1	0	22820	\N
8205	356	2	0	22821	\N
8211	336	1	0	22832	\N
8211	356	2	0	22833	\N
8147	206	2	0	25860	\N
8147	693	3	0	25862	\N
8216	94	1	0	26790	\N
8228	94	1	0	26791	\N
8216	107	2	0	26796	\N
8228	107	2	0	26797	\N
8180	245	2	0	27371	\N
8231	42	3	0	27655	\N
8231	439	4	0	27660	\N
8183	16	4	0	28226	\N
8227	16	1	0	28227	\N
8227	17	2	0	28229	\N
8183	380	5	0	28230	\N
8202	54	3	0	30126	\N
8202	1892	4	0	30143	\N
8179	20	1	0	30569	\N
8179	144	2	0	30570	\N
8162	151	4	0	30816	\N
8199	33	1	0	31939	\N
8199	163	2	0	31941	\N
8189	322	1	0	32430	\N
8189	323	2	0	32431	\N
8233	453	3	0	32833	\N
8233	1503	4	0	32836	\N
8175	1	2	0	34435	\N
8186	1	1	0	34436	\N
8190	1	1	0	34437	\N
8159	53	2	0	34438	\N
8186	53	2	0	34439	\N
8190	53	2	0	34440	\N
8197	1	1	0	34442	\N
8197	53	2	0	34443	\N
8213	1	1	0	34444	\N
8218	1	2	0	34445	\N
8235	1	2	0	34446	\N
8213	53	2	0	34447	\N
8235	112	3	0	34448	\N
8218	444	3	0	34449	\N
8209	2	1	0	35732	\N
8209	26	2	0	35733	\N
8155	10	1	0	38533	\N
8163	10	2	0	38534	\N
8163	29	3	0	38537	\N
8174	10	1	0	38538	\N
8174	11	2	0	38539	\N
8184	10	1	0	38540	\N
8184	11	2	0	38541	\N
8187	10	1	0	38542	\N
8187	11	2	0	38543	\N
8198	10	1	0	38544	\N
8207	10	1	0	38545	\N
8215	10	1	0	38546	\N
8198	11	2	0	38547	\N
8207	11	2	0	38548	\N
8222	10	1	0	38550	\N
8222	11	2	0	38551	\N
8229	10	1	0	38552	\N
8229	11	2	0	38553	\N
8210	1895	56	0	39464	\N
8208	14	1	0	39471	\N
8208	15	2	0	39473	\N
8210	14	59	0	39475	\N
8210	383	60	0	39476	\N
8158	23	1	0	40761	\N
8158	217	2	0	40762	\N
8274	40	3	0	43240	\N
8274	128	4	0	43245	\N
8435	40	0	0	43254	\N
8246	169	2	0	43958	\N
8242	56	1	0	43959	\N
8242	57	2	0	43961	\N
8246	56	4	0	43962	\N
8256	75	2	0	45349	\N
8271	75	1	0	45350	\N
8271	76	2	0	45351	\N
8256	284	3	0	45352	\N
8337	75	1	0	45362	\N
8415	75	0	0	45364	\N
8337	76	2	0	45368	\N
8401	102	1	0	47908	\N
8401	103	2	0	47913	\N
8254	113	2	0	48466	\N
8254	1899	3	0	48468	\N
8264	119	2	0	48648	\N
8264	1879	3	0	48649	\N
8368	121	1	0	49006	\N
8368	122	2	0	49008	\N
8304	170	1	0	50732	\N
8334	170	1	0	50733	\N
8304	398	2	0	50734	\N
8334	398	2	0	50735	\N
8236	279	0	0	53178	\N
8237	279	1	0	53179	\N
8237	473	2	0	53180	\N
8240	285	1	0	53582	\N
8240	286	2	0	53585	\N
8255	316	2	0	54029	\N
8255	1900	3	0	54031	\N
8309	353	3	0	54656	\N
8309	1919	4	0	54658	\N
8365	353	1	0	54671	\N
8365	354	2	0	54672	\N
8245	1048	2	0	56575	\N
8245	1021	4	0	56578	\N
8245	1022	5	0	56579	\N
8385	793	1	0	56824	\N
8385	1150	2	0	56825	\N
8359	1470	2	0	58307	\N
8359	1565	3	0	58308	\N
8314	1923	2	0	2	\N
8392	46	1	0	654	\N
8392	839	2	0	657	\N
8448	266	1	0	1234	\N
8448	1954	2	0	1235	\N
8410	1949	1	0	1738	\N
8410	1950	2	0	1739	\N
8246	340	5	0	4285	\N
8445	35	0	0	4294	\N
8252	391	1	0	10722	\N
8258	391	1	0	10723	\N
8252	392	2	0	10724	\N
8258	392	2	0	10725	\N
8281	455	2	0	11336	\N
8322	528	1	0	12560	\N
8322	1093	2	0	12562	\N
8356	123	2	0	12921	\N
8356	384	3	0	12922	\N
8260	233	2	0	13986	\N
8260	910	3	0	13987	\N
8321	173	1	0	14796	\N
8321	1927	2	0	14797	\N
8265	92	2	0	15172	\N
8265	93	3	0	15173	\N
8261	38	2	0	16507	\N
8302	326	2	0	17456	\N
8302	393	3	0	17465	\N
8253	167	1	0	17834	\N
8253	533	2	0	17835	\N
8331	30	1	0	18044	\N
8331	418	2	0	18048	\N
8351	30	3	0	18050	\N
8351	1932	4	0	18055	\N
8370	60	2	0	19572	\N
8370	166	3	0	19576	\N
8439	62	0	0	19789	\N
8317	64	5	0	20880	\N
8238	164	1	0	21352	\N
8241	164	0	0	21353	\N
8238	165	2	0	21354	\N
8307	73	1	0	22581	\N
8307	74	2	0	22582	\N
8451	140	1	0	24101	\N
8451	141	2	0	24105	\N
8293	224	2	0	25684	\N
8293	508	3	0	25687	\N
8248	94	1	0	26792	\N
8248	107	2	0	26798	\N
8283	244	1	0	27382	\N
8263	16	6	0	28231	\N
8263	1902	7	0	28234	\N
8340	16	1	0	28241	\N
8340	17	2	0	28243	\N
8430	16	0	0	28245	\N
8375	320	2	0	29214	\N
8375	1937	3	0	29215	\N
8379	96	4	0	29579	\N
8379	1941	5	0	29584	\N
8399	54	1	0	30128	\N
8399	55	2	0	30135	\N
8251	151	1	0	30828	\N
8259	230	2	0	32164	\N
8259	231	3	0	32170	\N
8249	1	1	0	34450	\N
8249	53	2	0	34451	\N
8319	1	1	0	34453	\N
8319	53	2	0	34455	\N
8396	1	2	0	34462	\N
8396	1948	3	0	34464	\N
8423	1	0	0	34469	\N
8288	2	2	0	35734	\N
8288	1911	3	0	35736	\N
8390	2	2	0	35738	\N
8346	4	1	0	36172	\N
8346	25	2	0	36174	\N
8243	29	2	0	38554	\N
8243	10	4	0	38555	\N
8243	11	5	0	38556	\N
8247	10	1	0	38557	\N
8247	11	2	0	38558	\N
8250	10	1	0	38559	\N
8257	10	0	0	38560	\N
8250	11	2	0	38561	\N
8266	10	3	0	38562	\N
8266	297	4	0	38563	\N
8324	10	2	0	38567	\N
8362	10	1	0	38571	\N
8311	11	2	0	38572	\N
8362	11	2	0	38574	\N
8324	29	3	0	38575	\N
8394	10	2	0	38580	\N
8425	10	0	0	38582	\N
8394	1946	3	0	38583	\N
8432	10	0	0	38586	\N
8453	10	1	0	38588	\N
8453	11	2	0	38589	\N
8262	14	6	0	39472	\N
8420	14	0	0	39494	\N
8244	218	2	0	39855	\N
8244	18	3	0	39859	\N
8441	18	0	0	39868	\N
8239	23	1	0	40767	\N
8239	217	2	0	40771	\N
8303	40	2	0	43241	\N
8303	282	3	0	43243	\N
8327	40	1	0	43248	\N
8327	41	2	0	43249	\N
8349	40	3	0	43250	\N
8349	128	4	0	43251	\N
8369	40	1	0	43252	\N
8499	40	1	0	43256	\N
8369	41	2	0	43257	\N
8499	41	2	0	43260	\N
8555	40	1	0	43266	\N
8555	41	2	0	43267	\N
8269	51	1	0	43620	\N
8269	1905	2	0	43621	\N
8315	56	0	0	43960	\N
8467	71	1	0	44854	\N
8467	72	2	0	44857	\N
8284	75	1	0	45360	\N
8407	75	1	0	45363	\N
8284	76	2	0	45366	\N
8407	76	2	0	45369	\N
8344	88	6	0	47431	\N
8344	1930	7	0	47432	\N
8487	88	1	0	47438	\N
8487	89	2	0	47439	\N
8305	100	1	0	47712	\N
8417	100	0	0	47713	\N
8305	160	2	0	47717	\N
8373	113	2	0	48467	\N
8373	114	3	0	48469	\N
8575	121	1	0	49034	\N
8575	122	2	0	49036	\N
8397	125	1	0	49336	\N
8397	195	2	0	49341	\N
8464	260	1	0	52501	\N
8464	261	2	0	52503	\N
8329	279	1	0	53302	\N
8329	473	2	0	53303	\N
8404	285	1	0	53584	\N
8404	286	2	0	53586	\N
8446	316	0	0	54040	\N
8528	353	1	0	54678	\N
8528	354	2	0	54682	\N
8513	1021	1	0	56576	\N
8513	1022	2	0	56577	\N
8414	841	0	0	57072	\N
8298	1916	3	0	58476	\N
8458	13	2	0	405	\N
8289	266	2	0	1218	\N
8289	1912	3	0	1219	\N
8447	266	1	0	1224	\N
8447	1953	2	0	1225	\N
8443	1793	0	0	2371	\N
8393	110	1	0	2719	\N
8545	110	1	0	2720	\N
8393	134	2	0	2721	\N
8545	134	2	0	2722	\N
8501	228	1	0	2952	\N
8501	229	2	0	2954	\N
8431	262	0	0	3919	\N
8312	365	1	0	4651	\N
8312	366	2	0	4652	\N
8395	391	2	0	10732	\N
8395	1947	3	0	10735	\N
8497	391	1	0	10744	\N
8497	392	2	0	10746	\N
8267	300	3	0	12129	\N
8267	1903	4	0	12132	\N
8563	300	2	0	12140	\N
8563	706	3	0	12147	\N
8277	1907	2	0	12310	\N
8277	1908	3	0	12313	\N
8519	192	2	0	15436	\N
8519	838	3	0	15442	\N
8295	38	2	0	16508	\N
8295	39	3	0	16512	\N
8548	212	1	0	17252	\N
8548	213	2	0	17255	\N
8438	326	0	0	17457	\N
8357	1376	2	0	17955	\N
8357	1934	3	0	17960	\N
8543	30	2	0	18056	\N
8543	31	3	0	18057	\N
8530	142	2	0	18647	\N
8383	198	5	0	20209	\N
8383	1943	6	0	20210	\N
8492	198	1	0	20221	\N
8492	199	2	0	20223	\N
8360	73	2	0	22591	\N
8360	703	3	0	22592	\N
8291	214	3	0	24504	\N
8291	1110	4	0	24505	\N
8294	69	2	0	24808	\N
8294	500	3	0	24818	\N
8573	49	2	0	25106	\N
8573	328	3	0	25107	\N
8285	207	2	0	25867	\N
8388	90	126	0	26159	\N
8490	90	3	0	26160	\N
8490	877	4	0	26164	\N
8388	1944	127	0	26165	\N
8476	94	1	0	26793	\N
8476	107	2	0	26799	\N
8286	16	2	0	28235	\N
8286	155	3	0	28236	\N
8352	16	3	0	28242	\N
8352	1045	4	0	28244	\N
8508	16	1	0	28249	\N
8508	17	2	0	28253	\N
8535	17	2	0	28254	\N
8436	20	0	0	30586	\N
8495	202	1	0	31226	\N
8495	203	2	0	31228	\N
8550	322	1	0	32449	\N
8550	323	2	0	32450	\N
8354	1	4	0	34456	\N
8354	1933	5	0	34457	\N
8363	1	2	0	34458	\N
8363	112	3	0	34459	\N
8380	1	4	0	34461	\N
8429	1	0	0	34470	\N
8450	1	3	0	34472	\N
8565	1	1	0	34489	\N
8570	1	2	0	34490	\N
8565	53	2	0	34493	\N
8570	112	3	0	34496	\N
8402	2	1	0	35739	\N
8402	26	2	0	35740	\N
8347	10	3	0	38569	\N
8347	347	4	0	38577	\N
8376	10	4	0	38578	\N
8376	1938	5	0	38579	\N
8411	465	4	0	38584	\N
8426	10	0	0	38585	\N
8538	10	1	0	38600	\N
8538	11	2	0	38604	\N
8560	10	1	0	38607	\N
8560	11	2	0	38609	\N
8332	14	1	0	39482	\N
8332	15	2	0	39484	\N
8335	18	2	0	39857	\N
8335	218	3	0	39860	\N
8341	18	1	0	39861	\N
8413	18	3	0	39863	\N
8413	466	4	0	39867	\N
8580	23	1	0	40769	\N
8580	217	2	0	40772	\N
8313	40	3	0	43246	\N
8313	1921	4	0	43247	\N
8457	40	1	0	43255	\N
8457	41	2	0	43259	\N
8509	40	1	0	43261	\N
8509	41	2	0	43263	\N
8478	51	2	0	43640	\N
8478	524	3	0	43642	\N
8409	56	1	0	43963	\N
8409	57	2	0	43964	\N
8498	56	1	0	43966	\N
8498	57	2	0	43967	\N
8316	71	5	0	44837	\N
8316	1924	6	0	44838	\N
8485	71	2	0	44855	\N
8485	401	3	0	44859	\N
8505	79	1	0	46600	\N
8505	81	2	0	46602	\N
8525	79	1	0	46645	\N
8525	81	2	0	46646	\N
8336	88	1	0	47429	\N
8336	89	2	0	47430	\N
8437	113	0	0	48470	\N
8455	113	1	0	48471	\N
8455	437	2	0	48472	\N
8270	119	1	0	48666	\N
8378	119	4	0	48667	\N
8270	120	2	0	48669	\N
8378	1940	5	0	48671	\N
8391	121	1	0	49022	\N
8391	122	2	0	49023	\N
8465	170	1	0	50743	\N
8465	398	2	0	50745	\N
8582	186	1	0	51420	\N
8582	187	2	0	51422	\N
8268	260	1	0	52500	\N
8268	1904	2	0	52502	\N
8486	279	2	0	53316	\N
8486	280	3	0	53317	\N
8480	285	1	0	53594	\N
8480	286	2	0	53595	\N
8489	1109	1	0	56311	\N
8489	1111	2	0	56312	\N
8297	1915	2	0	58475	\N
8503	221	2	0	598	\N
8343	1929	4	0	660	\N
8419	1951	0	0	1070	\N
8273	228	3	0	2944	\N
8273	492	4	0	2945	\N
8468	367	5	0	3486	\N
8469	367	5	0	3487	\N
8468	386	6	0	3490	\N
8469	386	6	0	3491	\N
8382	35	2	0	4289	\N
8556	35	1	0	4301	\N
8556	340	2	0	4302	\N
8466	391	1	0	10733	\N
8466	392	2	0	10734	\N
8339	687	1	0	11596	\N
8339	688	2	0	11600	\N
8512	300	1	0	12130	\N
8512	355	2	0	12131	\N
8306	1907	1	0	12311	\N
8306	1917	2	0	12312	\N
8454	233	1	0	13988	\N
8454	234	2	0	13991	\N
8372	258	1	0	14562	\N
8372	309	2	0	14564	\N
8473	192	1	0	15428	\N
8279	44	2	0	16169	\N
8279	1910	3	0	16172	\N
8475	115	1	0	16814	\N
8475	116	2	0	16815	\N
8496	212	1	0	17250	\N
8517	212	2	0	17251	\N
8496	213	2	0	17254	\N
8517	566	3	0	17257	\N
8521	30	1	0	18052	\N
8521	418	2	0	18053	\N
8422	290	0	0	19108	\N
8374	198	1	0	20202	\N
8299	336	1	0	22848	\N
8299	356	2	0	22850	\N
8290	49	3	0	25105	\N
8290	1913	4	0	25108	\N
8500	206	1	0	25865	\N
8500	207	2	0	25869	\N
8387	90	1	0	26158	\N
8387	344	2	0	26162	\N
8389	42	2	0	27656	\N
8389	1945	3	0	27658	\N
8477	42	2	0	27672	\N
8477	681	3	0	27673	\N
8280	388	3	0	28233	\N
8471	16	1	0	28248	\N
8537	16	4	0	28251	\N
8471	17	2	0	28252	\N
8537	380	5	0	28255	\N
8479	96	1	0	29580	\N
8479	97	2	0	29582	\N
8494	20	1	0	30594	\N
8494	144	2	0	30596	\N
8434	202	0	0	31202	\N
8333	360	1	0	31603	\N
8333	479	2	0	31604	\N
8514	33	1	0	31946	\N
8514	163	2	0	31947	\N
8542	33	2	0	31950	\N
8542	34	3	0	31954	\N
8345	322	1	0	32437	\N
8345	323	2	0	32438	\N
8398	453	1	0	32834	\N
8398	454	2	0	32835	\N
8367	1	1	0	34460	\N
8367	53	2	0	34463	\N
8463	1	1	0	34474	\N
8463	53	2	0	34476	\N
8484	1	2	0	34478	\N
8520	1	2	0	34479	\N
8484	112	3	0	34480	\N
8520	112	3	0	34481	\N
8527	1	1	0	34482	\N
8552	1	0	0	34483	\N
8561	1	1	0	34485	\N
8527	53	2	0	34486	\N
8561	53	2	0	34488	\N
8323	2	2	0	35735	\N
8323	131	3	0	35737	\N
8308	4	3	0	36171	\N
8506	6	1	0	36426	\N
8506	194	2	0	36428	\N
8276	10	1	0	38564	\N
8276	11	2	0	38565	\N
8326	10	1	0	38568	\N
8326	11	2	0	38573	\N
8444	10	0	0	38587	\N
8461	10	1	0	38590	\N
8461	11	2	0	38592	\N
8507	10	1	0	38594	\N
8507	11	2	0	38595	\N
8547	10	2	0	38601	\N
8576	10	2	0	38613	\N
8576	29	3	0	38615	\N
8579	10	1	0	38616	\N
8579	11	2	0	38617	\N
8482	23	2	0	40768	\N
8482	1957	3	0	40774	\N
8405	40	1	0	43253	\N
8405	41	2	0	43258	\N
8483	56	2	0	43965	\N
8483	1469	3	0	43968	\N
8301	71	1	0	44825	\N
8301	72	2	0	44828	\N
8328	75	1	0	45361	\N
8328	76	2	0	45367	\N
8567	75	1	0	45384	\N
8567	76	2	0	45386	\N
8361	88	2	0	47433	\N
8361	154	3	0	47434	\N
8406	88	1	0	47435	\N
8406	89	2	0	47436	\N
8428	88	0	0	47437	\N
8416	102	0	0	47909	\N
8442	102	0	0	47910	\N
8598	119	1	0	48668	\N
8598	120	2	0	48670	\N
8412	156	3	0	50343	\N
8412	1548	4	0	50344	\N
8584	1959	43	0	50963	\N
8584	181	102	0	50974	\N
8584	1960	103	0	50975	\N
8377	210	4	0	51944	\N
8377	1939	5	0	51948	\N
8400	242	1	0	52306	\N
8400	253	2	0	52308	\N
8275	273	3	0	53075	\N
8275	1906	4	0	53076	\N
8296	285	2	0	53583	\N
8296	1276	3	0	53587	\N
8577	285	1	0	53610	\N
8577	286	2	0	53611	\N
8569	324	1	0	54437	\N
8569	325	2	0	54440	\N
8529	353	0	0	54679	\N
8459	435	1	0	55015	\N
8459	436	2	0	55018	\N
8523	1109	2	0	56319	\N
8523	1412	3	0	56320	\N
8594	1109	1	0	56325	\N
8594	1111	2	0	56328	\N
8403	852	1	0	57405	\N
8403	913	2	0	57407	\N
8384	1470	1	0	58316	\N
8481	1470	2	0	58317	\N
8384	1471	2	0	58318	\N
8481	1956	3	0	58319	\N
8554	1470	1	0	58331	\N
8554	1471	2	0	58332	\N
8618	1965	1	0	58442	\N
8618	1966	2	0	58443	\N
8562	821	3	0	601	\N
8610	424	23	0	968	\N
8418	251	0	0	1597	\N
8488	251	1	0	1601	\N
8488	252	2	0	1604	\N
8625	996	2	0	1873	\N
8625	1967	3	0	1875	\N
8342	228	3	0	2948	\N
8342	1928	4	0	2949	\N
8470	1841	1	0	3656	\N
8470	1842	2	0	3657	\N
8540	35	1	0	4296	\N
8540	340	2	0	4298	\N
8386	366	2	0	4664	\N
8620	189	1	0	5110	\N
8620	190	2	0	5113	\N
8616	391	1	0	10758	\N
8616	392	2	0	10759	\N
8287	132	1	0	11347	\N
8287	455	2	0	11348	\N
8338	687	0	0	11595	\N
8358	30	2	0	18051	\N
8358	1127	3	0	18054	\N
8613	30	2	0	18058	\N
8613	31	3	0	18059	\N
8278	1909	3	0	19113	\N
8318	64	5	0	20881	\N
8318	1925	6	0	20885	\N
8272	488	1	0	21559	\N
8272	489	2	0	21560	\N
8522	73	3	0	22597	\N
8522	1958	4	0	22598	\N
8371	336	1	0	22849	\N
8371	356	2	0	22851	\N
8366	1935	1	0	23008	\N
8366	1936	2	0	23012	\N
8627	149	2	0	23216	\N
8449	1955	4	0	23860	\N
8292	69	0	0	24807	\N
8574	49	1	0	25111	\N
8574	50	2	0	25112	\N
8474	206	1	0	25864	\N
8474	207	2	0	25868	\N
8534	90	1	0	26161	\N
8534	344	2	0	26163	\N
8325	16	2	0	28237	\N
8325	155	3	0	28238	\N
8330	16	1	0	28239	\N
8330	17	2	0	28240	\N
8462	17	2	0	28247	\N
8348	54	3	0	30127	\N
8348	476	4	0	30142	\N
8350	20	3	0	30585	\N
8350	1931	4	0	30587	\N
8472	202	1	0	31225	\N
8472	203	2	0	31227	\N
8518	230	2	0	32165	\N
8518	231	3	0	32171	\N
8282	1	1	0	34452	\N
8282	53	2	0	34454	\N
8408	1	1	0	34466	\N
8421	1	0	0	34468	\N
8440	1	0	0	34471	\N
8456	1	1	0	34473	\N
8456	53	2	0	34475	\N
8559	1	1	0	34484	\N
8559	53	2	0	34487	\N
8608	1	1	0	34491	\N
8608	53	2	0	34494	\N
8364	431	1	0	34783	\N
8452	431	1	0	34784	\N
8364	432	2	0	34785	\N
8452	432	2	0	34786	\N
8310	4	105	0	36181	\N
8310	1920	106	0	36182	\N
8355	10	2	0	38570	\N
8355	29	3	0	38576	\N
8510	10	1	0	38596	\N
8510	11	2	0	38597	\N
8515	10	1	0	38598	\N
8532	10	1	0	38599	\N
8515	11	2	0	38602	\N
8532	11	2	0	38603	\N
8572	10	2	0	38612	\N
8572	29	3	0	38614	\N
8596	11	2	0	38622	\N
8320	14	1	0	39481	\N
8320	1926	2	0	39483	\N
8381	14	2	0	39493	\N
8381	383	3	0	39495	\N
8353	18	3	0	39862	\N
8433	18	0	0	39864	\N
8353	609	4	0	39866	\N
8557	18	1	0	39871	\N
8557	19	2	0	39873	\N
8536	40	1	0	43262	\N
8536	41	2	0	43264	\N
8544	40	2	0	43265	\N
8544	66	3	0	43268	\N
8614	40	2	0	43270	\N
8614	66	3	0	43274	\N
8773	51	6	0	43641	\N
8773	1994	7	0	43643	\N
8551	56	0	0	43969	\N
8725	1979	0	0	43979	\N
8558	75	1	0	45365	\N
8558	76	2	0	45370	\N
8750	75	2	0	45404	\N
8750	159	3	0	45406	\N
8775	75	2	0	45419	\N
8775	159	3	0	45422	\N
8709	79	1	0	46746	\N
8709	81	2	0	46747	\N
8637	88	1	0	47440	\N
8637	89	2	0	47444	\N
8662	147	1	0	50059	\N
8662	599	2	0	50072	\N
8761	186	2	0	51421	\N
8761	696	3	0	51424	\N
8645	210	0	0	51945	\N
8648	260	2	0	52506	\N
8648	419	3	0	52507	\N
8605	1961	7	0	55426	\N
8605	451	19	0	55433	\N
8605	452	20	0	55435	\N
8533	1021	1	0	56580	\N
8533	1022	2	0	56581	\N
8722	793	4	0	56831	\N
8722	1986	5	0	56834	\N
8626	1971	126	1	56902	\N
8699	852	1	0	57406	\N
8699	913	2	0	57408	\N
8682	1976	42	0	57659	\N
8682	908	88	0	57670	\N
8682	1977	89	0	57671	\N
8626	1972	127	0	58421	\N
8626	1969	125	0	58517	\N
8659	13	2	0	415	\N
8727	433	3	0	436	\N
8780	357	4	0	437	\N
8626	1973	127	1	1868	\N
8626	1968	9	0	1871	\N
8626	996	124	0	1877	\N
8667	117	4	0	2148	\N
8667	139	5	0	2149	\N
8553	367	1	0	3502	\N
8553	368	2	0	3503	\N
8566	237	1	0	3627	\N
8566	527	2	0	3632	\N
8568	237	1	0	3638	\N
8660	262	1	0	3939	\N
8660	263	2	0	3942	\N
8539	35	1	0	4295	\N
8626	1970	126	0	5127	\N
8541	391	1	0	10745	\N
8541	392	2	0	10747	\N
8675	391	0	0	10770	\N
8516	132	1	0	11353	\N
8516	455	2	0	11354	\N
8780	1995	5	0	11597	\N
8702	108	5	0	11831	\N
8702	1980	6	0	11832	\N
8642	300	1	0	12142	\N
8642	355	2	0	12146	\N
8626	124	125	1	12678	\N
8578	123	1	0	12929	\N
8578	124	2	0	12930	\N
8743	402	2	0	14201	\N
8743	1148	3	0	14203	\N
8491	173	3	0	14800	\N
8491	174	4	0	14801	\N
8588	192	1	0	15437	\N
8588	193	2	0	15438	\N
8511	235	1	0	15817	\N
8511	236	2	0	15820	\N
8571	1061	3	0	15821	\N
8597	167	1	0	17844	\N
8581	142	1	0	18648	\N
8581	143	2	0	18650	\N
8583	142	1	0	18664	\N
8583	143	2	0	18665	\N
8730	61	1	0	19578	\N
8730	60	3	0	19598	\N
8730	61	4	0	19599	\N
8526	198	1	0	20222	\N
8526	199	2	0	20224	\N
8706	686	5	0	20489	\N
8705	164	1	0	21355	\N
8705	165	2	0	21356	\N
8585	488	1	0	21566	\N
8585	489	2	0	21567	\N
8586	488	1	0	21576	\N
8586	489	2	0	21577	\N
8725	1018	0	0	21997	\N
8531	264	2	0	23557	\N
8531	265	3	0	23558	\N
8524	69	1	0	24809	\N
8524	70	2	0	24816	\N
8590	224	2	0	25686	\N
8546	508	3	0	25688	\N
8590	508	3	0	25689	\N
8593	94	1	0	26800	\N
8602	94	1	0	26801	\N
8593	107	2	0	26806	\N
8602	107	2	0	26807	\N
8628	42	2	0	27686	\N
8628	681	3	0	27687	\N
8759	16	2	0	28259	\N
8759	155	3	0	28262	\N
8595	320	2	0	29242	\N
8778	449	2	0	29907	\N
8778	583	3	0	29909	\N
8757	360	2	0	31607	\N
8757	510	3	0	31610	\N
8619	230	1	0	32166	\N
8619	287	2	0	32168	\N
8504	453	1	0	32850	\N
8504	454	2	0	32851	\N
8710	1	8	0	34504	\N
8710	1982	9	0	34509	\N
8764	1	2	0	34511	\N
8764	112	3	0	34513	\N
8493	11	2	0	38593	\N
8549	10	1	0	38606	\N
8549	11	2	0	38608	\N
8564	10	2	0	38610	\N
8564	29	3	0	38611	\N
8591	10	1	0	38618	\N
8591	11	2	0	38619	\N
8607	10	4	0	38621	\N
8607	600	5	0	38623	\N
8612	10	2	0	38624	\N
8612	29	3	0	38626	\N
8653	10	2	0	38629	\N
8737	10	2	0	38640	\N
8737	29	3	0	38641	\N
8753	10	2	0	38648	\N
8753	29	3	0	38652	\N
8692	14	2	0	39509	\N
8692	383	3	0	39511	\N
8502	18	1	0	39869	\N
8502	19	2	0	39870	\N
8592	40	1	0	43269	\N
8592	41	2	0	43272	\N
8729	41	1	0	43277	\N
8729	40	2	0	43279	\N
8756	40	2	0	43281	\N
8756	66	3	0	43282	\N
8874	51	2	0	43646	\N
8874	524	3	0	43648	\N
8599	71	1	0	44856	\N
8599	72	2	0	44858	\N
8621	75	1	0	45385	\N
8621	76	2	0	45387	\N
8803	75	2	0	45420	\N
8803	159	3	0	45423	\N
8895	75	4	0	45445	\N
8895	2038	5	1	45446	\N
8630	79	2	0	46676	\N
8630	80	3	0	46677	\N
8672	79	0	0	46709	\N
8687	102	2	0	47925	\N
8687	158	3	0	47933	\N
8680	113	1	0	48473	\N
8680	437	2	0	48475	\N
8704	121	2	0	49035	\N
8704	625	3	0	49037	\N
8898	121	4	0	49044	\N
8898	848	5	0	49048	\N
8872	135	2	0	49622	\N
8872	196	3	0	49626	\N
8873	137	2	0	49915	\N
8873	197	3	0	49917	\N
8694	156	1	0	50355	\N
8694	157	2	0	50356	\N
8712	156	2	0	50361	\N
8712	571	3	0	50362	\N
8601	170	1	0	50744	\N
8601	398	2	0	50746	\N
8606	181	33	0	50984	\N
8606	1963	34	0	50985	\N
8794	186	4	0	51426	\N
8794	1363	5	0	51428	\N
8784	1999	2	0	53324	\N
8787	279	2	0	53325	\N
8787	280	3	0	53327	\N
8719	316	4	0	54041	\N
8719	1024	5	0	54042	\N
8810	353	3	0	54680	\N
8810	1527	4	0	54684	\N
8589	435	1	0	55016	\N
8589	436	2	0	55019	\N
8740	435	2	0	55022	\N
8740	481	3	0	55024	\N
8603	1962	20	0	55149	\N
8603	1961	7	0	55424	\N
8603	451	19	0	55431	\N
8661	595	1	0	55679	\N
8851	595	2	0	55680	\N
8661	596	2	0	55683	\N
8851	768	3	0	55684	\N
8664	597	1	0	56029	\N
8855	597	2	0	56030	\N
8903	597	3	0	56031	\N
8664	598	2	0	56034	\N
8855	767	3	0	56035	\N
8903	1406	4	0	56038	\N
8891	1021	2	0	56380	\N
8891	1048	3	0	56382	\N
8603	1211	20	1	56900	\N
8641	841	1	0	57079	\N
8641	842	2	0	57082	\N
8784	2001	3	1	58451	\N
8846	1914	1	0	58482	\N
8846	2031	2	0	58484	\N
8837	2023	4	0	58515	\N
8837	2025	5	0	58518	\N
8684	424	1	0	975	\N
8860	962	2	0	2318	\N
8860	2033	3	0	2322	\N
8677	110	0	0	2723	\N
8777	367	2	0	3512	\N
8777	651	3	0	3513	\N
8708	237	1	0	3640	\N
8708	527	2	0	3643	\N
8782	1015	4	0	3922	\N
8782	262	5	0	3945	\N
8837	2026	5	1	4733	\N
8837	2024	4	0	5116	\N
8838	189	4	0	5117	\N
8895	2037	5	0	5139	\N
8655	391	1	0	10769	\N
8655	392	2	0	10773	\N
8788	391	2	0	10786	\N
8788	406	3	0	10788	\N
8635	132	0	0	11363	\N
8670	108	0	0	11817	\N
8587	300	1	0	12141	\N
8587	355	2	0	12145	\N
8906	258	2	0	14563	\N
8906	585	3	0	14565	\N
8647	173	2	0	14804	\N
8623	235	0	0	15827	\N
8867	44	2	0	16166	\N
8867	161	3	0	16167	\N
8731	1992	3	1	18237	\N
8724	164	7	0	21357	\N
8724	1987	8	0	21358	\N
8779	164	2	0	21361	\N
8779	226	3	0	21362	\N
8731	1018	2	0	21995	\N
8784	1018	2	0	21996	\N
8784	2003	4	1	21999	\N
8772	140	6	0	24102	\N
8844	69	2	0	24811	\N
8844	500	3	0	24820	\N
8666	224	1	0	25694	\N
8666	225	2	0	25695	\N
8821	345	2	0	26292	\N
8821	1167	3	0	26293	\N
8639	94	1	0	26802	\N
8876	94	9	0	26804	\N
8639	107	2	0	26808	\N
8876	2034	10	0	26810	\N
8701	449	1	0	29895	\N
8701	450	2	0	29896	\N
8636	1	2	0	34498	\N
8636	112	3	0	34500	\N
8731	1990	2	0	34503	\N
8752	1	2	0	34510	\N
8752	112	3	0	34512	\N
8791	1	4	0	34514	\N
8791	422	5	0	34515	\N
8651	10	1	0	38628	\N
8651	11	2	0	38630	\N
8689	10	1	0	38632	\N
8689	11	2	0	38633	\N
8734	10	2	0	38638	\N
8747	10	2	0	38645	\N
8747	29	3	0	38647	\N
8769	10	2	0	38651	\N
8769	29	3	0	38655	\N
8800	10	1	0	38660	\N
8800	11	2	0	38661	\N
8812	10	2	0	38662	\N
8812	29	3	0	38664	\N
8863	10	2	0	38672	\N
8863	29	3	0	38673	\N
8691	18	1	0	39872	\N
8691	19	2	0	39874	\N
8820	127	4	0	39880	\N
8649	40	4	0	43275	\N
8649	564	5	0	43276	\N
8748	40	2	0	43278	\N
8748	66	3	0	43280	\N
8862	40	2	0	43283	\N
8862	66	3	0	43285	\N
8816	2009	0	0	43990	\N
8840	2027	5	0	44971	\N
8770	75	2	0	45418	\N
8770	159	3	0	45421	\N
8840	75	4	0	45434	\N
8893	75	2	0	45435	\N
8893	159	3	0	45436	\N
8617	102	1	0	47924	\N
8617	103	2	0	47931	\N
8668	119	2	0	48722	\N
8668	891	3	0	48723	\N
8897	121	8	0	49043	\N
8897	2039	9	0	49051	\N
8697	125	1	0	49348	\N
8697	195	2	0	49351	\N
8767	135	2	0	49621	\N
8767	196	3	0	49625	\N
8633	170	0	0	50755	\N
8795	242	4	0	52317	\N
8795	1662	5	0	52318	\N
8744	268	2	0	52864	\N
8744	1387	3	0	52865	\N
8814	268	4	0	52868	\N
8814	318	5	0	52871	\N
8878	268	5	0	52876	\N
8878	642	6	0	52881	\N
8631	362	2	0	54847	\N
8631	420	3	0	54850	\N
8604	1961	7	0	55425	\N
8604	451	19	0	55432	\N
8604	452	20	0	55434	\N
8890	451	0	0	55450	\N
8700	1109	1	0	56326	\N
8700	1111	2	0	56329	\N
8713	1983	36	0	56372	\N
8713	704	119	0	56377	\N
8713	1984	120	0	56378	\N
8840	2028	5	1	58513	\N
8785	2004	3	0	58516	\N
8717	433	3	0	427	\N
8781	1998	5	0	441	\N
8711	220	8	0	602	\N
8711	1028	9	0	603	\N
8609	424	1	0	963	\N
8609	425	2	0	966	\N
8802	251	2	0	1602	\N
8899	251	4	0	1603	\N
8802	828	3	0	1605	\N
8881	536	4	0	1676	\N
8881	2036	5	0	1679	\N
8781	1997	5	0	1685	\N
8624	996	1	0	1872	\N
8884	228	2	0	2953	\N
8884	511	3	0	2955	\N
8805	367	4	0	3526	\N
8805	1231	5	0	3527	\N
8695	237	1	0	3639	\N
8695	527	2	0	3642	\N
8850	262	2	0	3940	\N
8850	731	3	0	3943	\N
8831	35	3	0	4311	\N
8831	2019	4	0	4312	\N
8629	189	2	0	5111	\N
8629	311	3	0	5114	\N
8690	391	1	0	10771	\N
8643	392	2	0	10772	\N
8690	392	2	0	10774	\N
8741	391	2	0	10779	\N
8741	406	3	0	10780	\N
8807	459	2	0	11982	\N
8807	1796	3	0	11984	\N
8723	402	4	0	14184	\N
8723	1378	5	0	14185	\N
8622	235	1	0	15826	\N
8622	236	2	0	15828	\N
8785	2005	3	1	15934	\N
8827	2016	7	0	16168	\N
8785	44	2	0	16170	\N
8715	38	2	0	16531	\N
8715	39	3	0	16533	\N
8816	966	0	0	16964	\N
8652	326	1	0	17458	\N
8652	327	2	0	17464	\N
8597	533	2	0	17845	\N
8728	1988	2	0	18370	\N
8728	61	1	0	19577	\N
8728	1989	2	0	19597	\N
8703	62	5	0	19790	\N
8678	67	2	0	22290	\N
8678	68	3	0	22291	\N
8732	264	2	0	23579	\N
8732	265	3	0	23580	\N
8735	930	6	0	23931	\N
8735	1993	7	0	23933	\N
8824	69	2	0	24810	\N
8824	500	3	0	24819	\N
8848	49	3	0	25113	\N
8848	1740	4	0	25114	\N
8676	206	0	0	25866	\N
8832	206	6	0	25876	\N
8798	244	2	0	27395	\N
8798	438	3	0	27397	\N
8843	244	6	0	27407	\N
8843	2030	7	0	27409	\N
8888	16	2	0	28260	\N
8888	155	3	0	28263	\N
8600	320	1	0	29263	\N
8600	334	2	0	29266	\N
8720	96	2	0	29581	\N
8720	482	3	0	29583	\N
8683	151	1	0	30829	\N
8683	302	2	0	30831	\N
8762	34	3	0	31955	\N
8894	322	0	0	32454	\N
8611	1	1	0	34492	\N
8611	53	2	0	34495	\N
8615	1	1	0	34497	\N
8615	53	2	0	34499	\N
8854	1	2	0	34518	\N
8869	1	4	0	34519	\N
8854	112	3	0	34520	\N
8869	422	5	0	34521	\N
8656	2	1	0	35743	\N
8656	26	2	0	35745	\N
8644	29	3	0	38627	\N
8726	10	2	0	38635	\N
8726	29	3	0	38636	\N
8738	10	4	0	38642	\N
8738	600	5	0	38643	\N
8758	10	2	0	38649	\N
8765	10	2	0	38650	\N
8758	29	3	0	38653	\N
8765	29	3	0	38654	\N
8819	10	3	0	38663	\N
8819	347	4	0	38665	\N
8673	14	0	0	39499	\N
8857	218	3	0	39879	\N
8707	23	2	0	40770	\N
8707	24	3	0	40773	\N
8755	23	2	0	40779	\N
8755	24	3	0	40780	\N
8638	40	1	0	43271	\N
8638	41	2	0	43273	\N
8817	51	3	0	43644	\N
8817	329	4	0	43645	\N
8875	51	0	0	43647	\N
8688	1978	13	0	43974	\N
8688	1979	14	0	43977	\N
8789	2009	0	0	43981	\N
8790	2009	0	0	43984	\N
8828	71	6	0	44869	\N
8828	2017	7	0	44872	\N
8760	75	2	0	45405	\N
8760	159	3	0	45407	\N
8865	79	2	0	46778	\N
8865	80	3	0	46779	\N
8877	100	5	0	47714	\N
8877	2035	6	0	47718	\N
8801	113	3	0	48474	\N
8801	778	4	0	48476	\N
8650	119	1	0	48700	\N
8650	120	2	0	48701	\N
8768	137	2	0	49914	\N
8768	197	3	0	49916	\N
8852	147	2	0	50060	\N
8852	516	3	0	50075	\N
8849	156	2	0	50367	\N
8849	571	3	0	50368	\N
8646	210	6	0	51946	\N
8646	622	7	0	51947	\N
8815	268	3	0	52869	\N
8815	610	4	0	52870	\N
8879	268	2	0	52878	\N
8879	1387	3	0	52879	\N
8793	279	4	0	53328	\N
8793	2010	5	0	53330	\N
8811	353	1	0	54681	\N
8811	354	2	0	54683	\N
8632	1974	67	0	54842	\N
8632	362	95	0	54853	\N
8632	1975	96	0	54854	\N
8654	435	2	0	55021	\N
8654	481	3	0	55023	\N
8714	704	2	0	56375	\N
8714	1985	3	0	56376	\N
8681	908	1	0	57667	\N
8681	909	2	0	57669	\N
8786	2001	3	1	58452	\N
8847	1914	2	0	58483	\N
8847	2032	3	0	58485	\N
8663	400	2	0	124	\N
8808	2011	3	0	1649	\N
8809	2011	1	0	1650	\N
8809	2013	2	0	1651	\N
8808	2012	4	0	1652	\N
8686	117	2	0	2166	\N
8686	175	3	0	2167	\N
8804	367	0	0	3525	\N
8783	1015	4	0	3923	\N
8861	262	2	0	3941	\N
8861	731	3	0	3944	\N
8783	262	5	0	3946	\N
8796	35	2	0	4307	\N
8763	391	2	0	10785	\N
8763	406	3	0	10787	\N
8792	391	4	0	10793	\N
8864	391	2	0	10794	\N
8864	406	3	0	10796	\N
8792	539	5	0	10798	\N
8841	132	6	0	11364	\N
8841	2029	7	0	11367	\N
8669	108	1	0	11816	\N
8669	109	2	0	11818	\N
8806	108	2	0	11847	\N
8806	501	3	0	11848	\N
8786	44	2	0	16171	\N
8833	115	2	0	16824	\N
8833	636	3	0	16825	\N
8789	966	0	0	16961	\N
8790	966	0	0	16963	\N
8671	212	1	0	17268	\N
8671	213	2	0	17269	\N
8858	212	2	0	17270	\N
8858	566	3	0	17271	\N
8634	142	0	0	18682	\N
8679	142	1	0	18687	\N
8679	143	2	0	18688	\N
8776	164	2	0	21359	\N
8776	226	3	0	21360	\N
8688	1018	14	0	21994	\N
8785	2006	4	0	21998	\N
8786	2008	4	0	22000	\N
8746	67	2	0	22292	\N
8746	68	3	0	22293	\N
8627	697	3	0	23218	\N
8845	69	1	0	24812	\N
8845	70	2	0	24817	\N
8736	206	2	0	25872	\N
8736	693	3	0	25873	\N
8657	245	2	0	27396	\N
8698	16	1	0	28256	\N
8698	17	2	0	28257	\N
8745	16	2	0	28258	\N
8745	155	3	0	28261	\N
8870	54	2	0	30129	\N
8870	485	3	0	30141	\N
8739	151	4	0	30840	\N
8739	1510	5	0	30841	\N
8799	33	2	0	31952	\N
8799	34	3	0	31956	\N
8696	1	1	0	34501	\N
8733	1	2	0	34505	\N
8749	1	2	0	34506	\N
8733	112	3	0	34507	\N
8749	112	3	0	34508	\N
8835	1	3	0	34516	\N
8835	2021	4	0	34517	\N
8640	431	1	0	34787	\N
8640	432	2	0	34788	\N
8693	2	2	0	35744	\N
8693	131	3	0	35746	\N
8766	2	2	0	35747	\N
8813	2	2	0	35748	\N
8813	131	3	0	35750	\N
8868	2	2	0	35753	\N
8868	131	3	0	35759	\N
8751	4	1	0	36177	\N
8754	4	2	0	36178	\N
8751	25	2	0	36179	\N
8754	579	3	0	36180	\N
8665	6	2	0	36427	\N
8665	179	3	0	36429	\N
8721	10	4	0	38634	\N
8721	600	5	0	38637	\N
8742	10	2	0	38644	\N
8771	10	2	0	38656	\N
8771	29	3	0	38657	\N
8774	10	2	0	38658	\N
8774	29	3	0	38659	\N
8822	10	4	0	38666	\N
8822	600	5	0	38667	\N
8885	10	2	0	38674	\N
8885	29	3	0	38675	\N
8882	14	4	0	39508	\N
8718	14	4	0	39510	\N
8882	588	5	0	39512	\N
8718	588	5	0	39513	\N
8797	218	3	0	39878	\N
8901	40	3	0	43284	\N
8901	128	4	0	43286	\N
8911	40	2	0	43287	\N
8911	66	3	0	43288	\N
8960	71	5	0	44881	\N
8960	2053	6	0	44882	\N
8981	75	2	0	45451	\N
8981	159	3	0	45453	\N
8871	88	2	0	47441	\N
8871	154	3	0	47445	\N
8976	119	2	0	48735	\N
8976	891	3	0	48736	\N
8896	121	2	0	49042	\N
8896	625	3	0	49047	\N
8902	147	3	0	50061	\N
8902	148	4	0	50080	\N
8866	181	2	0	50970	\N
8866	769	3	0	50972	\N
8958	2051	127	1	51150	\N
8958	2049	67	0	51425	\N
8958	186	126	0	51430	\N
8918	210	2	0	51967	\N
8918	458	3	0	51968	\N
9010	210	4	0	51977	\N
9010	565	5	0	51978	\N
8934	279	4	0	53329	\N
8934	2010	5	0	53331	\N
8920	285	2	0	53626	\N
8920	1276	3	0	53627	\N
8944	324	3	0	54461	\N
8944	617	4	0	54462	\N
8892	451	2	0	55451	\N
8892	452	3	0	55453	\N
8900	595	3	0	55681	\N
8900	813	4	0	55686	\N
8983	908	1	0	57677	\N
8983	909	2	0	57678	\N
8988	1623	9	1	58118	\N
8958	2050	127	0	58444	\N
8988	2069	8	0	58538	\N
8978	835	2	0	1033	\N
8939	267	1	0	1236	\N
8939	266	5	0	1244	\N
8939	405	6	0	1246	\N
8899	1610	5	0	1606	\N
8825	189	3	0	5112	\N
8825	827	4	0	5115	\N
8839	189	4	0	5118	\N
8839	849	5	0	5120	\N
8988	2070	9	0	5130	\N
8836	459	3	0	11983	\N
8836	2022	4	0	11985	\N
8826	58	6	0	13644	\N
9001	258	2	0	14566	\N
8916	167	5	0	17860	\N
8916	2040	6	0	17861	\N
8943	167	2	0	17873	\N
8943	168	3	0	17875	\N
8988	2064	8	1	18241	\N
8913	290	2	0	19109	\N
8913	575	3	0	19114	\N
8925	198	2	0	20235	\N
8925	746	3	0	20236	\N
8938	198	0	0	20239	\N
8842	164	6	0	21363	\N
8856	264	2	0	23589	\N
8856	265	3	0	23590	\N
8889	140	2	0	24103	\N
8950	140	2	0	24104	\N
8889	487	3	0	24106	\N
8950	487	3	0	24107	\N
8996	140	5	0	24121	\N
8996	2078	6	0	24123	\N
8880	214	4	0	24523	\N
8880	649	5	0	24524	\N
8933	69	4	0	24813	\N
8933	1721	5	0	24823	\N
8953	411	4	0	25290	\N
8818	2014	4	0	25293	\N
8953	1665	5	0	25294	\N
8883	224	4	0	25701	\N
8883	994	5	0	25702	\N
8830	94	6	0	26803	\N
8830	2018	7	0	26809	\N
8923	94	2	0	26812	\N
8923	2043	3	0	26813	\N
8928	320	2	0	29264	\N
8928	321	3	0	29267	\N
8967	96	4	0	29593	\N
8823	20	2	0	30595	\N
8823	702	3	0	30597	\N
8930	202	3	0	31233	\N
8930	2044	4	0	31234	\N
8936	230	2	0	32176	\N
8936	231	3	0	32177	\N
8834	322	2	0	32453	\N
8834	833	3	0	32455	\N
8974	322	2	0	32458	\N
8974	833	3	0	32461	\N
8886	1	8	0	34522	\N
8886	1982	9	0	34523	\N
8935	1	2	0	34525	\N
8908	112	3	0	34527	\N
8935	112	3	0	34528	\N
8959	1	5	0	34531	\N
8959	2052	6	0	34537	\N
8993	1	2	0	34541	\N
8993	112	3	0	34543	\N
9005	1	2	0	34546	\N
9005	112	3	0	34548	\N
8829	2	6	0	35751	\N
8829	1566	7	0	35752	\N
8904	2	2	0	35754	\N
8985	2	1	0	35756	\N
8915	26	2	0	35757	\N
8985	26	2	0	35758	\N
8904	131	3	0	35760	\N
8853	10	2	0	38668	\N
8853	29	3	0	38669	\N
8859	10	2	0	38670	\N
8859	29	3	0	38671	\N
8887	10	2	0	38676	\N
8905	10	2	0	38677	\N
8887	29	3	0	38678	\N
8905	29	3	0	38679	\N
8907	600	5	0	38681	\N
8910	10	6	0	38682	\N
8910	426	7	0	38683	\N
8921	10	5	0	38684	\N
8921	2042	6	0	38685	\N
8926	10	2	0	38686	\N
8931	10	4	0	38687	\N
8926	29	3	0	38688	\N
8931	600	5	0	38689	\N
8964	10	4	0	38696	\N
8964	600	5	0	38697	\N
8984	10	2	0	38699	\N
8984	29	3	0	38703	\N
8998	426	7	0	38707	\N
8995	14	5	0	39522	\N
8995	2077	6	0	39523	\N
8988	28	1	0	41083	\N
8990	28	1	0	41084	\N
8988	27	7	0	41102	\N
8990	27	7	0	41103	\N
8988	2071	10	0	41104	\N
8990	2073	8	0	41105	\N
8972	40	6	0	43289	\N
8972	522	7	0	43291	\N
9009	40	4	0	43292	\N
9025	40	2	0	43293	\N
9025	66	3	0	43298	\N
9009	564	5	0	43300	\N
8917	51	5	0	43652	\N
8917	2041	6	0	43658	\N
8937	71	2	0	44870	\N
8937	401	3	0	44871	\N
8948	75	5	0	45450	\N
8948	2046	6	0	45455	\N
8999	79	4	0	46808	\N
8999	589	5	0	46809	\N
9011	79	4	0	46838	\N
9011	589	5	0	46840	\N
8979	135	2	0	49623	\N
8979	196	3	0	49627	\N
8980	137	2	0	49928	\N
8980	197	3	0	49929	\N
8957	186	4	0	51427	\N
8957	1363	5	0	51429	\N
8914	210	2	0	51961	\N
8914	458	3	0	51962	\N
9000	273	2	0	53084	\N
9029	273	2	0	53085	\N
9000	1159	3	0	53086	\N
9029	1159	3	0	53087	\N
8909	324	2	0	54450	\N
8909	486	3	0	54451	\N
9028	362	2	0	54848	\N
9028	420	3	0	54851	\N
8922	1021	2	0	56381	\N
8922	1048	3	0	56383	\N
9031	841	3	0	57080	\N
8982	908	2	0	57676	\N
8982	988	3	0	57679	\N
8986	2062	7	0	58115	\N
8986	2066	9	0	58132	\N
8986	1471	1	0	58333	\N
8987	1471	1	0	58334	\N
8991	1471	1	0	58335	\N
8986	2063	7	0	58344	\N
8987	1470	7	0	58345	\N
8991	1470	7	0	58346	\N
8987	2068	8	0	58349	\N
8991	2068	8	0	58350	\N
8912	289	3	0	132	\N
9014	2080	3	0	2302	\N
8932	237	2	0	3644	\N
8932	319	3	0	3645	\N
8986	2065	8	1	5128	\N
8992	2074	2	0	5140	\N
8962	391	2	0	10795	\N
8962	406	3	0	10797	\N
8929	132	2	0	11365	\N
8929	133	3	0	11366	\N
8971	528	2	0	12561	\N
8971	613	3	0	12566	\N
9001	585	3	0	14567	\N
9002	39	3	0	16534	\N
9016	30	2	0	18060	\N
9016	31	3	0	18061	\N
8986	2064	8	0	18247	\N
8970	413	5	0	18362	\N
8970	2058	6	0	18364	\N
9018	2081	5	0	18808	\N
9018	2082	6	0	18809	\N
8986	2067	9	1	19338	\N
9013	60	4	0	19614	\N
9013	1687	5	0	19615	\N
9017	60	4	0	19638	\N
8941	64	10	0	20882	\N
8941	2045	11	0	20883	\N
9004	149	2	0	23217	\N
9004	697	3	0	23219	\N
8968	82	4	0	23865	\N
8968	2056	5	0	23870	\N
9012	411	2	0	25291	\N
9012	582	3	0	25292	\N
8946	206	2	0	25880	\N
8946	693	3	0	25883	\N
8919	345	2	0	26294	\N
8919	1167	3	0	26296	\N
8945	753	3	0	26827	\N
8955	94	2	0	26830	\N
8955	2048	3	0	26831	\N
8966	94	1	0	26834	\N
8966	2054	2	0	26835	\N
8927	42	2	0	27697	\N
8927	681	3	0	27698	\N
8992	2075	2	0	28264	\N
8924	20	2	0	30600	\N
8924	702	3	0	30601	\N
9020	151	2	0	30845	\N
9021	151	1	0	30846	\N
9020	576	3	0	30848	\N
9024	360	4	0	31608	\N
9024	1617	5	0	31611	\N
8994	322	2	0	32459	\N
8994	833	3	0	32462	\N
8975	2059	20	0	32852	\N
8973	453	2	0	32865	\N
8973	902	3	0	32866	\N
8975	453	63	0	32867	\N
8975	2060	64	0	32868	\N
9006	453	2	0	32875	\N
9006	902	3	0	32876	\N
8954	422	5	0	34529	\N
8956	1	4	0	34530	\N
8961	1	2	0	34532	\N
8963	1	2	0	34533	\N
8961	112	3	0	34534	\N
8963	112	3	0	34535	\N
8956	422	5	0	34536	\N
8965	1	2	0	34538	\N
8965	112	3	0	34539	\N
8977	1	2	0	34540	\N
8977	112	3	0	34542	\N
8997	1	6	0	34544	\N
9022	1	2	0	34547	\N
9022	112	3	0	34549	\N
9026	1	2	0	34550	\N
9026	112	3	0	34551	\N
9003	2	1	0	35762	\N
9003	26	2	0	35763	\N
8942	4	2	0	36183	\N
8942	579	3	0	36184	\N
8947	10	5	0	38690	\N
8947	1298	6	0	38691	\N
8951	10	3	0	38692	\N
8951	2047	4	0	38693	\N
8952	29	3	0	38695	\N
8969	10	5	0	38698	\N
9015	10	2	0	38701	\N
9015	29	3	0	38704	\N
8969	2057	6	0	38706	\N
9023	14	4	0	39528	\N
9023	588	5	0	39529	\N
9030	14	2	0	39532	\N
9030	383	3	0	39534	\N
8989	19	1	0	39881	\N
8989	18	7	0	39883	\N
8989	2072	8	0	39885	\N
9027	23	2	0	40787	\N
9019	24	3	0	40788	\N
9027	24	3	0	40789	\N
9058	40	2	0	43294	\N
9058	66	3	0	43299	\N
9146	51	4	0	43653	\N
9146	648	5	0	43657	\N
9045	677	4	1	43664	\N
9043	2087	0	0	43993	\N
9045	2089	3	0	44000	\N
9188	71	4	0	44894	\N
9188	2127	5	0	44895	\N
9191	79	4	0	46839	\N
9191	589	5	0	46841	\N
9042	102	5	0	47926	\N
9042	2086	6	0	47937	\N
9051	156	2	0	50371	\N
9166	156	2	0	50372	\N
9051	571	3	0	50373	\N
9166	571	3	0	50374	\N
9102	181	2	0	50971	\N
9102	769	3	0	50973	\N
9143	285	5	0	53645	\N
9143	2118	6	0	53648	\N
9065	362	2	0	54849	\N
9065	420	3	0	54852	\N
9155	793	2	0	56832	\N
9155	1136	3	0	56833	\N
9031	2083	4	0	57083	\N
9043	1368	0	0	57852	\N
9037	2085	4	1	58450	\N
9071	296	3	0	667	\N
9033	554	4	0	1612	\N
9045	2088	3	0	1846	\N
9137	2116	5	0	2340	\N
9109	228	2	0	2956	\N
9109	511	3	0	2959	\N
9060	262	2	0	3953	\N
9060	731	3	0	3954	\N
9130	2111	1	0	4089	\N
9130	2112	2	0	4091	\N
9054	391	2	0	10807	\N
9054	406	3	0	10808	\N
9114	300	4	0	12144	\N
9047	528	4	0	12579	\N
9047	2091	5	0	12580	\N
9123	123	2	0	12942	\N
9123	384	3	0	12944	\N
9212	402	4	0	14221	\N
9212	1378	5	0	14222	\N
9059	92	2	0	15181	\N
9059	93	3	0	15184	\N
9037	193	1	0	15432	\N
9038	193	1	0	15433	\N
9037	192	3	0	15439	\N
9038	192	3	0	15440	\N
9048	192	13	0	15446	\N
9048	2092	14	0	15447	\N
9055	44	5	0	16179	\N
9055	2095	6	0	16180	\N
9230	44	3	0	16199	\N
9230	940	4	0	16200	\N
9035	115	2	0	16833	\N
9035	636	3	0	16834	\N
9053	115	2	0	16841	\N
9053	636	3	0	16843	\N
9180	1302	4	0	16851	\N
9180	115	7	0	16864	\N
9045	2090	4	0	16967	\N
9057	326	5	0	17459	\N
9237	326	4	0	17460	\N
9237	1638	5	0	17467	\N
9057	2097	6	0	17468	\N
9232	177	2	0	18307	\N
9232	178	3	0	18308	\N
9089	290	11	0	19119	\N
9089	2106	12	0	19122	\N
9032	198	3	0	20248	\N
9032	1347	4	0	20249	\N
9133	198	2	0	20252	\N
9050	241	13	0	20497	\N
9050	2094	14	0	20502	\N
9056	64	5	0	20892	\N
9056	2096	6	0	20897	\N
9135	264	2	0	23599	\N
9135	265	3	0	23600	\N
9214	264	4	0	23608	\N
9214	2137	5	0	23613	\N
9217	214	6	0	24554	\N
9217	2138	7	0	24557	\N
9040	69	2	0	24814	\N
9040	500	3	0	24821	\N
9163	994	5	0	25710	\N
9086	206	35	0	25881	\N
9086	2104	36	0	25886	\N
9128	94	18	0	26844	\N
9128	2110	19	0	26845	\N
8992	2076	3	1	28265	\N
9092	16	11	0	28266	\N
9111	16	2	0	28267	\N
9111	155	3	0	28268	\N
9092	2109	12	0	28269	\N
9206	449	8	0	29908	\N
9206	2136	9	0	29910	\N
9095	55	2	0	30140	\N
9034	360	4	0	31609	\N
9034	1617	5	0	31612	\N
9052	230	2	0	32183	\N
9052	231	3	0	32184	\N
9039	322	2	0	32460	\N
9039	833	3	0	32463	\N
9223	453	2	0	32883	\N
9223	902	3	0	32884	\N
9036	1	2	0	34552	\N
9049	1	13	0	34553	\N
9107	1	2	0	34554	\N
9107	112	3	0	34558	\N
9049	2093	14	0	34561	\N
9186	1	4	0	34572	\N
9186	422	5	0	34577	\N
9137	26	1	0	35761	\N
9137	2	3	0	35764	\N
9200	2	2	0	35767	\N
9200	131	3	0	35770	\N
9245	6	3	0	36430	\N
9245	2140	4	0	36431	\N
9044	10	5	0	38702	\N
9044	2042	6	0	38705	\N
9046	600	5	0	38710	\N
9074	10	2	0	38712	\N
9074	29	3	0	38713	\N
9117	10	4	0	38720	\N
9117	600	5	0	38722	\N
9160	10	2	0	38728	\N
9160	29	3	0	38730	\N
9193	10	3	0	38736	\N
9193	347	4	0	38737	\N
9240	10	2	0	38744	\N
9240	29	3	0	38748	\N
9243	10	3	0	38750	\N
9168	14	0	0	39544	\N
9176	14	2	0	39546	\N
9176	383	3	0	39549	\N
9041	18	2	0	39882	\N
9041	218	3	0	39884	\N
9098	18	2	0	39886	\N
9098	218	3	0	39888	\N
9170	18	2	0	39890	\N
9170	218	3	0	39891	\N
9359	40	0	0	43295	\N
9063	40	3	0	43301	\N
9063	128	4	0	43305	\N
9201	40	2	0	43306	\N
9201	66	3	0	43307	\N
9335	40	7	0	43324	\N
9335	2173	8	0	43327	\N
9282	524	2	0	43650	\N
9282	51	3	0	43655	\N
9115	56	0	0	43970	\N
9120	56	0	0	43971	\N
9238	56	2	0	43982	\N
9238	169	3	0	43983	\N
9274	56	2	0	43986	\N
9274	169	3	0	43987	\N
9327	169	2	0	43989	\N
9327	56	6	0	43991	\N
9327	475	7	0	43992	\N
9136	75	2	0	45462	\N
9136	159	3	0	45464	\N
9313	75	3	0	45482	\N
9313	713	4	0	45487	\N
9302	79	2	0	46064	\N
9302	80	3	0	46069	\N
9273	88	3	0	47442	\N
9273	580	4	0	47446	\N
9226	102	3	0	47927	\N
9317	102	2	0	47929	\N
9317	158	3	0	47934	\N
9226	1388	4	0	47936	\N
9262	113	8	0	48477	\N
9262	2154	9	0	48478	\N
9151	119	2	0	48754	\N
9151	891	3	0	48755	\N
9254	121	7	0	49045	\N
9254	2150	8	0	49049	\N
9258	121	8	0	49056	\N
9258	2039	9	0	49061	\N
9196	186	5	0	51432	\N
9196	2130	6	0	51433	\N
9187	279	4	0	53332	\N
9187	2010	5	0	53335	\N
9253	2148	6	0	53628	\N
9252	2146	43	0	53629	\N
9253	285	25	0	53649	\N
9253	2149	26	0	53650	\N
9252	285	126	0	53651	\N
9252	2147	127	0	53652	\N
9161	316	8	0	54047	\N
9161	2121	9	0	54048	\N
9260	316	8	0	54066	\N
9260	2121	9	0	54067	\N
9308	353	4	0	54688	\N
9308	1570	5	0	54693	\N
9249	362	16	0	54857	\N
9249	2142	17	0	54858	\N
9366	362	2	0	54864	\N
9366	420	3	0	54865	\N
9219	1710	5	0	142	\N
9203	828	3	0	1611	\N
9153	2011	2	0	1653	\N
9153	2120	3	0	1654	\N
9189	117	4	0	2174	\N
9189	139	5	0	2176	\N
9103	35	2	0	4319	\N
9103	36	3	0	4323	\N
9158	189	2	0	5121	\N
9158	311	3	0	5122	\N
9075	391	2	0	10815	\N
9075	406	3	0	10816	\N
9181	539	4	0	10823	\N
9311	503	4	0	10833	\N
9181	391	7	0	10834	\N
9181	406	8	0	10836	\N
9222	300	2	0	12159	\N
9222	706	3	0	12161	\N
9198	469	2	0	12350	\N
9198	2135	3	0	12352	\N
9121	123	2	0	12941	\N
9121	384	3	0	12943	\N
9126	58	2	0	13645	\N
9126	665	3	0	13649	\N
9100	402	2	0	14202	\N
9340	402	2	0	14227	\N
9340	1148	3	0	14233	\N
9084	173	2	0	14810	\N
9084	2102	3	0	14814	\N
9080	167	4	0	17874	\N
9080	1011	5	0	17876	\N
9140	290	2	0	19120	\N
9140	575	3	0	19121	\N
9173	241	4	0	20499	\N
9173	2122	5	0	20501	\N
9279	488	2	0	21586	\N
9279	729	3	0	21589	\N
9349	2174	7	0	26811	\N
9192	94	3	0	26848	\N
9192	2128	4	0	26849	\N
9138	16	2	0	28271	\N
9138	155	3	0	28273	\N
9320	96	2	0	29603	\N
9320	482	3	0	29608	\N
9061	33	4	0	31953	\N
9061	447	5	0	31957	\N
9342	230	2	0	32210	\N
9342	231	3	0	32212	\N
9118	1	4	0	34556	\N
9171	1	3	0	34566	\N
9171	1114	4	0	34567	\N
9184	1	5	0	34570	\N
9184	1233	6	0	34571	\N
9235	1	2	0	34574	\N
9235	112	3	0	34575	\N
9266	1	0	0	34581	\N
9256	2	8	0	35773	\N
9270	2	3	0	35774	\N
9270	572	4	0	35780	\N
9256	2151	9	0	35781	\N
9072	10	5	0	38709	\N
9112	10	4	0	38718	\N
9112	600	5	0	38719	\N
9164	10	2	0	38729	\N
9164	29	3	0	38731	\N
9177	10	2	0	38732	\N
9183	10	2	0	38733	\N
9177	29	3	0	38734	\N
9183	29	3	0	38735	\N
9248	10	8	0	38751	\N
9248	1772	9	0	38753	\N
9251	426	6	0	38754	\N
9251	10	25	0	38755	\N
9286	10	3	0	38758	\N
9286	347	4	0	38759	\N
9322	10	6	0	38761	\N
9322	426	7	0	38762	\N
9337	10	2	0	38765	\N
9337	29	3	0	38766	\N
9068	14	2	0	39533	\N
9068	383	3	0	39535	\N
9169	14	2	0	39545	\N
9209	14	2	0	39547	\N
9169	383	3	0	39548	\N
9209	383	3	0	39550	\N
9354	218	3	0	39899	\N
9324	23	2	0	40822	\N
9324	24	3	0	40823	\N
9147	27	4	0	41117	\N
9147	942	5	0	41122	\N
9360	40	0	0	43296	\N
9159	40	2	0	43302	\N
9362	40	0	0	43303	\N
9159	66	3	0	43304	\N
9211	40	4	0	43308	\N
9211	564	5	0	43310	\N
9239	40	2	0	43312	\N
9239	66	3	0	43313	\N
9271	40	3	0	43316	\N
9271	128	4	0	43317	\N
9315	40	4	0	43320	\N
9315	2167	5	0	43323	\N
9339	40	2	0	43325	\N
9339	66	3	0	43326	\N
9190	56	4	0	43975	\N
9190	1145	5	0	43976	\N
9244	56	3	0	43985	\N
9244	475	4	0	43988	\N
9329	79	2	0	46067	\N
9329	80	3	0	46071	\N
9083	125	2	0	49349	\N
9083	188	3	0	49353	\N
9185	156	2	0	50385	\N
9185	571	3	0	50386	\N
9202	181	2	0	50982	\N
9202	769	3	0	50983	\N
9334	181	4	0	51007	\N
9334	2172	5	0	51008	\N
9197	2131	67	0	51431	\N
9197	186	125	0	51434	\N
9197	2134	127	0	51435	\N
9234	210	2	0	51983	\N
9234	458	3	0	51984	\N
9261	210	8	0	52003	\N
9261	1026	9	0	52008	\N
9297	242	2	0	52320	\N
9297	620	3	0	52321	\N
9182	451	2	0	55452	\N
9182	452	3	0	55454	\N
9064	1491	4	0	56587	\N
9077	1068	3	0	57396	\N
9077	852	8	0	57410	\N
9077	1727	9	0	57412	\N
9294	908	2	0	57684	\N
9294	988	3	0	57687	\N
9097	288	2	0	131	\N
9062	1710	5	0	134	\N
9165	12	2	0	465	\N
9165	433	3	0	466	\N
9085	266	2	0	1243	\N
9085	2103	3	0	1245	\N
9197	2132	126	0	1694	\N
9369	228	2	0	2958	\N
9369	511	3	0	2961	\N
9106	391	2	0	10821	\N
9106	406	3	0	10822	\N
9221	300	2	0	12158	\N
9221	706	3	0	12160	\N
9275	335	3	0	13386	\N
9197	2133	126	1	13700	\N
9323	1157	4	0	14008	\N
9323	2169	5	0	14009	\N
9195	402	5	0	14215	\N
9195	2129	6	0	14216	\N
9067	173	5	0	14805	\N
9067	2098	6	0	14807	\N
9331	92	2	0	15183	\N
9331	93	3	0	15185	\N
9082	192	3	0	15471	\N
9082	627	4	0	15476	\N
9208	1061	3	0	15834	\N
9303	38	2	0	16544	\N
9303	39	3	0	16545	\N
9277	62	2	0	19804	\N
9277	683	3	0	19805	\N
9284	198	2	0	20253	\N
9284	746	3	0	20255	\N
9381	1347	3	0	20256	\N
9381	198	5	0	20263	\N
9381	199	6	0	20264	\N
9280	241	2	0	20511	\N
9280	281	3	0	20512	\N
9175	226	3	0	21366	\N
9229	488	3	0	21585	\N
9229	1324	4	0	21591	\N
9225	73	2	0	22607	\N
9225	703	3	0	22612	\N
9287	82	2	0	23867	\N
9287	343	3	0	23869	\N
9125	49	4	0	25115	\N
9306	49	4	0	25116	\N
9306	2164	5	0	25117	\N
9125	1595	5	0	25118	\N
9365	94	2	0	26817	\N
9365	95	3	0	26822	\N
9374	375	4	0	26825	\N
9218	42	4	0	27706	\N
9218	2139	5	0	27707	\N
9344	16	2	0	28276	\N
9344	155	3	0	28277	\N
9142	320	5	0	29265	\N
9142	2117	6	0	29268	\N
9292	449	4	0	29929	\N
9292	1574	5	0	29930	\N
9079	54	1	0	30130	\N
9094	54	1	0	30133	\N
9094	55	2	0	30139	\N
9091	54	11	0	30156	\N
9091	2108	12	0	30159	\N
9346	33	2	0	31964	\N
9346	34	3	0	31965	\N
9108	1	2	0	34555	\N
9108	112	3	0	34559	\N
9139	1	2	0	34562	\N
9139	112	3	0	34563	\N
9145	1	4	0	34564	\N
9150	1	4	0	34565	\N
9145	422	5	0	34568	\N
9228	1	3	0	34573	\N
9228	48	4	0	34576	\N
9247	1	20	0	34578	\N
9265	1	0	0	34579	\N
9247	2141	21	0	34580	\N
9267	1	1	0	34582	\N
9326	1	5	0	34583	\N
9267	53	2	0	34584	\N
9326	1233	6	0	34585	\N
9351	1	2	0	34586	\N
9351	112	3	0	34588	\N
9157	2	2	0	35766	\N
9242	2	3	0	35772	\N
9289	2	2	0	35775	\N
9358	2	1	0	35776	\N
9358	26	2	0	35777	\N
9289	131	3	0	35778	\N
9242	572	4	0	35779	\N
9132	10	2	0	38724	\N
9132	29	3	0	38725	\N
9148	10	4	0	38726	\N
9148	600	5	0	38727	\N
9216	10	6	0	38740	\N
9216	426	7	0	38749	\N
9263	1663	16	0	38760	\N
9099	18	3	0	39887	\N
9099	466	4	0	39889	\N
9178	18	2	0	39892	\N
9178	218	3	0	39895	\N
9215	40	6	0	43309	\N
9215	522	7	0	43311	\N
9281	524	2	0	43649	\N
9283	524	2	0	43651	\N
9281	2157	3	0	43654	\N
9283	51	3	0	43656	\N
9174	56	6	0	43972	\N
9174	2123	7	0	43973	\N
9207	56	4	0	43978	\N
9207	2123	5	0	43980	\N
9066	2009	0	0	44003	\N
9134	75	2	0	45452	\N
9134	159	3	0	45454	\N
9199	75	2	0	45463	\N
9199	159	3	0	45465	\N
9348	75	2	0	45483	\N
9348	159	3	0	45485	\N
9328	79	2	0	46066	\N
9373	79	4	0	46068	\N
9328	80	3	0	46070	\N
9373	2175	5	0	46073	\N
9309	88	4	0	47443	\N
9309	601	5	0	47447	\N
9227	102	1	0	47928	\N
9227	103	2	0	47932	\N
9116	119	4	0	48753	\N
9116	423	5	0	48756	\N
9341	125	2	0	49350	\N
9341	188	3	0	49354	\N
9356	135	2	0	49624	\N
9356	196	3	0	49628	\N
9355	137	2	0	49930	\N
9355	197	3	0	49932	\N
9304	156	8	0	50389	\N
9304	2162	9	0	50399	\N
9213	260	4	0	52508	\N
9213	538	5	0	52511	\N
9179	1024	4	0	54049	\N
9179	2124	7	0	54058	\N
9104	324	2	0	54468	\N
9104	486	3	0	54470	\N
9307	451	4	0	55464	\N
9307	2165	5	0	55469	\N
9281	1650	3	0	56891	\N
9087	841	5	0	57081	\N
9087	2105	6	0	57084	\N
9076	1068	3	0	57395	\N
9076	852	8	0	57409	\N
9105	289	3	0	138	\N
9096	424	2	0	981	\N
9096	520	3	0	983	\N
9231	251	1	0	1617	\N
9231	252	2	0	1618	\N
9291	2159	16	0	1657	\N
9290	1096	2	0	1659	\N
9290	2158	3	0	1662	\N
9291	1096	126	0	1666	\N
9291	2160	127	0	1667	\N
9152	228	2	0	2957	\N
9152	511	3	0	2960	\N
9162	237	4	0	3646	\N
9110	262	2	0	3966	\N
9110	731	3	0	3967	\N
9122	262	2	0	3981	\N
9122	731	3	0	3983	\N
9131	2111	2	0	4090	\N
9131	2113	3	0	4092	\N
9156	373	2	0	5336	\N
9156	1504	3	0	5337	\N
9069	300	2	0	12143	\N
9069	706	3	0	12148	\N
9314	123	1	0	12946	\N
9314	124	2	0	12947	\N
9293	2161	4	0	13277	\N
9101	233	2	0	13989	\N
9101	910	3	0	13992	\N
9172	92	3	0	15182	\N
9172	1578	4	0	15186	\N
9070	192	11	0	15452	\N
9070	2099	12	0	15453	\N
9081	192	4	0	15470	\N
9205	192	8	0	15472	\N
9081	941	5	0	15478	\N
9205	985	9	0	15479	\N
9073	44	2	0	16189	\N
9124	115	4	0	16842	\N
9124	1302	5	0	16844	\N
9127	115	2	0	16849	\N
9127	636	3	0	16850	\N
9066	966	0	0	16965	\N
9149	62	4	0	19791	\N
9149	1606	5	0	19792	\N
9167	241	2	0	20498	\N
9167	281	3	0	20500	\N
9325	241	1	0	20523	\N
9325	333	2	0	20525	\N
9371	164	2	0	21367	\N
9154	82	2	0	23866	\N
9154	343	3	0	23868	\N
9301	140	6	0	24122	\N
9301	1730	7	0	24124	\N
9119	214	4	0	24536	\N
9141	214	2	0	24537	\N
9141	227	3	0	24538	\N
9119	649	5	0	24539	\N
9345	69	2	0	24815	\N
9345	500	3	0	24822	\N
9113	16	4	0	28270	\N
9210	16	3	0	28272	\N
9113	380	5	0	28275	\N
9321	96	1	0	29604	\N
9321	97	2	0	29607	\N
9088	54	1	0	30131	\N
9093	54	1	0	30132	\N
9088	55	2	0	30137	\N
9093	55	2	0	30138	\N
9333	202	2	0	31247	\N
9333	812	3	0	31248	\N
9204	360	2	0	31625	\N
9204	510	3	0	31626	\N
9298	360	2	0	31637	\N
9364	2	2	0	35782	\N
9364	131	3	0	35786	\N
9078	10	2	0	38714	\N
9090	10	11	0	38715	\N
9078	29	3	0	38716	\N
9090	2107	12	0	38717	\N
9129	10	4	0	38721	\N
9129	600	5	0	38723	\N
9194	10	6	0	38738	\N
9194	426	7	0	38739	\N
9220	10	2	0	38741	\N
9224	10	2	0	38742	\N
9224	29	3	0	38746	\N
9336	10	5	0	38763	\N
9336	998	6	0	38764	\N
9353	10	2	0	38772	\N
9353	29	3	0	38775	\N
9144	14	7	0	39540	\N
9144	2119	8	0	39541	\N
9300	14	2	0	39560	\N
9300	383	3	0	39561	\N
9318	14	2	0	39570	\N
9318	383	3	0	39572	\N
9269	18	11	0	39894	\N
9288	23	2	0	40816	\N
9288	24	3	0	40817	\N
9357	40	0	0	43290	\N
9361	40	0	0	43297	\N
9264	40	15	0	43314	\N
9264	1192	16	0	43315	\N
9278	40	2	0	43318	\N
9278	66	3	0	43319	\N
9319	40	2	0	43321	\N
9319	66	3	0	43322	\N
9382	40	1	0	43329	\N
9400	40	4	0	43330	\N
9382	41	2	0	43332	\N
9400	564	5	0	43334	\N
9488	40	2	0	43339	\N
9488	66	3	0	43340	\N
9476	51	2	0	43659	\N
9476	524	3	0	43661	\N
9310	79	3	0	46065	\N
9310	1168	4	0	46072	\N
9398	100	2	0	47730	\N
9398	101	3	0	47732	\N
9255	121	7	0	49046	\N
9255	2150	8	0	49050	\N
9483	170	2	0	50764	\N
9483	718	3	0	50770	\N
9392	210	4	0	52004	\N
9392	565	5	0	52007	\N
9406	260	2	0	52509	\N
9406	419	3	0	52510	\N
9435	260	2	0	52512	\N
9435	419	3	0	52514	\N
9472	260	3	0	52516	\N
9472	2197	4	0	52519	\N
9179	2126	8	1	54059	\N
9343	324	2	0	54469	\N
9343	486	3	0	54471	\N
9394	435	4	0	55025	\N
9394	2180	5	0	55026	\N
9506	597	3	0	56033	\N
9506	2209	4	0	56039	\N
9370	1109	2	0	56327	\N
9370	1412	3	0	56330	\N
9276	793	2	0	56841	\N
9330	793	2	0	56842	\N
9330	2170	3	0	56843	\N
9276	1136	3	0	56844	\N
9076	2101	9	1	57411	\N
9522	908	6	0	57685	\N
9522	2212	7	0	57689	\N
9330	2171	3	1	57981	\N
9316	2168	5	0	470	\N
9332	220	2	0	604	\N
9332	821	3	0	605	\N
9338	266	2	0	1251	\N
9338	1711	3	0	1253	\N
9454	35	2	0	4320	\N
9454	36	3	0	4324	\N
9241	189	2	0	5123	\N
9241	311	3	0	5124	\N
9296	132	2	0	11378	\N
9296	133	3	0	11379	\N
9299	132	2	0	11388	\N
9299	133	3	0	11390	\N
9352	501	3	0	11858	\N
9312	123	3	0	12945	\N
9312	2166	4	0	12948	\N
9509	77	2	0	13291	\N
9509	216	3	0	13292	\N
9386	256	2	0	13387	\N
9386	335	3	0	13388	\N
9496	58	2	0	13648	\N
9496	665	3	0	13651	\N
9531	402	5	0	14229	\N
9531	2215	6	0	14238	\N
9465	192	3	0	15488	\N
9453	167	5	0	17884	\N
9453	2040	6	0	17886	\N
9421	290	0	0	19129	\N
9423	290	0	0	19131	\N
9408	62	2	0	19822	\N
9408	683	3	0	19823	\N
9447	241	2	0	20524	\N
9447	281	3	0	20526	\N
9272	264	3	0	23609	\N
9272	1748	4	0	23611	\N
9295	214	2	0	24555	\N
9295	227	3	0	24556	\N
9250	411	25	0	25303	\N
9250	2144	26	0	25304	\N
9494	206	5	0	25882	\N
9494	2204	6	0	25884	\N
9412	90	2	0	26190	\N
9412	91	3	0	26192	\N
9363	94	2	0	26814	\N
9363	95	3	0	26815	\N
9427	2183	1	0	27159	\N
9429	2183	1	0	27160	\N
9427	2184	2	0	27162	\N
9429	2184	2	0	27163	\N
9523	16	6	0	28287	\N
9512	359	4	0	28288	\N
9523	1902	7	0	28289	\N
9538	16	2	0	28290	\N
9538	445	3	0	28297	\N
9305	320	8	0	29291	\N
9305	2163	9	0	29292	\N
9257	54	8	0	30157	\N
9257	2152	9	0	30158	\N
9246	230	10	0	32198	\N
9246	1240	11	0	32199	\N
9432	230	2	0	32211	\N
9526	230	5	0	32224	\N
9526	2214	6	0	32225	\N
9377	1	2	0	34587	\N
9377	112	3	0	34589	\N
9478	112	2	0	34604	\N
9478	1	5	0	34607	\N
9478	112	6	0	34608	\N
9507	1	2	0	34614	\N
9507	112	3	0	34616	\N
9233	2	2	0	35768	\N
9233	131	3	0	35771	\N
9501	2	2	0	35784	\N
9503	4	3	0	36185	\N
9503	2206	4	0	36192	\N
9285	6	1	0	36433	\N
9285	194	2	0	36434	\N
9236	10	2	0	38743	\N
9236	29	3	0	38747	\N
9347	10	2	0	38767	\N
9347	29	3	0	38768	\N
9350	10	2	0	38769	\N
9350	29	3	0	38770	\N
9380	347	3	0	38771	\N
9368	10	2	0	38773	\N
9368	29	3	0	38776	\N
9380	10	5	0	38777	\N
9380	11	6	0	38778	\N
9389	600	5	0	38779	\N
9409	10	8	0	38782	\N
9409	1772	9	0	38783	\N
9442	10	2	0	38786	\N
9442	29	3	0	38787	\N
9461	10	2	0	38788	\N
9461	29	3	0	38789	\N
9259	18	8	0	39893	\N
9259	2153	9	0	39896	\N
9268	2155	10	0	40805	\N
9372	40	2	0	43328	\N
9452	40	5	0	43331	\N
9372	282	3	0	43333	\N
9452	2192	6	0	43335	\N
9495	40	2	0	43342	\N
9500	40	2	0	43343	\N
9495	66	3	0	43344	\N
9500	66	3	0	43345	\N
9572	40	2	0	43352	\N
9572	66	3	0	43354	\N
9649	40	3	0	43362	\N
9649	128	4	0	43363	\N
9411	56	2	0	43994	\N
9411	169	3	0	43997	\N
9560	75	2	0	45493	\N
9560	159	3	0	45495	\N
9661	75	2	0	45513	\N
9661	159	3	0	45514	\N
9583	119	4	0	48759	\N
9583	423	5	0	48763	\N
9481	147	2	0	50062	\N
9541	147	4	0	50064	\N
9481	516	3	0	50076	\N
9541	551	5	0	50081	\N
9460	156	2	0	50390	\N
9460	571	3	0	50397	\N
9375	170	3	0	50756	\N
9375	1121	4	0	50757	\N
9391	268	4	0	52877	\N
9391	318	5	0	52880	\N
9545	268	2	0	52884	\N
9545	1387	3	0	52885	\N
9384	2178	127	0	53344	\N
9384	2177	43	0	53653	\N
9384	285	126	0	53668	\N
9449	316	2	0	54092	\N
9449	332	3	0	54094	\N
9514	353	2	0	54689	\N
9514	755	3	0	54691	\N
9402	435	4	0	55027	\N
9402	2180	5	0	55032	\N
9502	595	3	0	55702	\N
9540	595	4	0	55703	\N
9540	1530	5	0	55704	\N
9502	2205	4	0	55705	\N
9592	597	2	0	56080	\N
9592	767	3	0	56082	\N
9463	1109	2	0	56338	\N
9463	1412	3	0	56340	\N
9651	793	2	0	56849	\N
9651	1136	3	0	56851	\N
9471	852	2	0	57423	\N
9471	2196	3	0	57424	\N
9567	908	2	0	57686	\N
9567	988	3	0	57688	\N
9431	1470	2	0	58342	\N
9431	1565	3	0	58347	\N
9384	2179	127	1	58424	\N
9610	2224	6	0	148	\N
9617	821	3	0	607	\N
9543	424	2	0	982	\N
9543	520	3	0	984	\N
9379	118	3	0	2168	\N
9379	117	5	0	2175	\N
9379	248	6	0	2177	\N
9628	262	2	0	3996	\N
9628	731	3	0	3997	\N
9562	391	4	0	10832	\N
9562	539	5	0	10835	\N
9399	300	2	0	12169	\N
9399	706	3	0	12170	\N
9548	706	3	0	12180	\N
9468	123	27	0	12950	\N
9468	2194	28	0	12953	\N
9434	58	2	0	13646	\N
9493	58	5	0	13647	\N
9434	665	3	0	13650	\N
9493	2203	6	0	13653	\N
9437	192	3	0	15474	\N
9437	627	4	0	15477	\N
9644	235	0	0	15843	\N
9521	44	6	0	16201	\N
9521	2211	7	0	16202	\N
9620	2226	10	0	16204	\N
9422	290	0	0	19130	\N
9578	64	1	0	20894	\N
9578	65	2	0	20895	\N
9546	164	2	0	21369	\N
9546	226	3	0	21371	\N
9550	164	2	0	21373	\N
9550	226	3	0	21378	\N
9559	264	4	0	23653	\N
9559	2137	5	0	23654	\N
9597	82	4	0	23877	\N
9597	2056	5	0	23878	\N
9605	2222	7	0	23884	\N
9635	49	4	0	25119	\N
9635	1595	5	0	25124	\N
9528	411	0	0	25302	\N
9570	206	9	0	25889	\N
9612	206	2	0	25890	\N
9612	693	3	0	25892	\N
9570	2220	10	0	25896	\N
9367	90	2	0	26171	\N
9367	91	3	0	26172	\N
9632	86	1	0	26501	\N
9632	87	2	0	26502	\N
9405	95	3	0	26823	\N
9623	94	7	0	26828	\N
9623	2228	8	0	26829	\N
9552	54	0	0	30174	\N
9556	54	0	0	30177	\N
9557	54	0	0	30178	\N
9475	20	4	0	30606	\N
9475	685	5	0	30607	\N
9565	20	3	0	30610	\N
9565	1931	4	0	30611	\N
9439	322	2	0	32466	\N
9439	833	3	0	32467	\N
9397	112	3	0	34596	\N
9458	1	2	0	34605	\N
9458	112	3	0	34606	\N
9533	1	2	0	34621	\N
9533	112	3	0	34624	\N
9622	523	6	0	34632	\N
9614	1	2	0	34633	\N
9614	112	3	0	34635	\N
9622	1	7	0	34636	\N
9585	4	2	0	36186	\N
9585	579	3	0	36189	\N
9407	10	2	0	38780	\N
9482	10	2	0	38794	\N
9482	29	3	0	38795	\N
9485	10	7	0	38796	\N
9485	2202	8	0	38797	\N
9516	10	2	0	38802	\N
9516	29	3	0	38804	\N
9646	10	2	0	38816	\N
9646	29	3	0	38817	\N
9659	10	2	0	38822	\N
9659	29	3	0	38824	\N
9444	14	4	0	39574	\N
9444	588	5	0	39580	\N
9498	18	2	0	39904	\N
9498	218	3	0	39908	\N
9418	590	5	0	39911	\N
9607	18	4	0	39916	\N
9607	590	5	0	39917	\N
9469	40	7	0	43336	\N
9469	2173	8	0	43337	\N
9484	40	7	0	43338	\N
9484	2201	8	0	43341	\N
9529	40	5	0	43348	\N
9529	1196	6	0	43350	\N
9604	40	6	0	43353	\N
9604	2221	7	0	43355	\N
9687	40	2	0	43364	\N
9687	66	3	0	43365	\N
9587	56	2	0	43995	\N
9587	169	3	0	43998	\N
9647	56	2	0	44001	\N
9647	169	3	0	44002	\N
9414	75	2	0	45484	\N
9414	159	3	0	45486	\N
9631	75	3	0	45505	\N
9631	857	4	0	45507	\N
9517	121	2	0	49057	\N
9517	625	3	0	49059	\N
9619	156	9	0	50391	\N
9619	2225	10	0	50400	\N
9524	181	5	0	51019	\N
9524	2213	6	0	51023	\N
9445	260	4	0	52513	\N
9445	538	5	0	52515	\N
9595	285	4	0	53646	\N
9595	1709	5	0	53647	\N
9639	285	2	0	53664	\N
9639	1276	3	0	53666	\N
9387	316	2	0	54076	\N
9387	332	3	0	54077	\N
9609	353	5	0	54690	\N
9609	2223	6	0	54692	\N
9489	362	2	0	54872	\N
9489	420	3	0	54877	\N
9443	451	2	0	55463	\N
9443	452	3	0	55468	\N
9479	595	2	0	55682	\N
9479	768	3	0	55685	\N
9593	595	2	0	55736	\N
9593	768	3	0	55739	\N
9542	597	4	0	56079	\N
9542	1531	5	0	56083	\N
9652	12	2	0	483	\N
9536	2217	4	0	495	\N
9575	262	2	0	3982	\N
9575	731	3	0	3984	\N
9376	714	3	0	4087	\N
9376	2176	4	0	4088	\N
9625	222	2	0	5281	\N
9625	232	3	0	5282	\N
9669	391	2	0	10857	\N
9669	406	3	0	10864	\N
9491	132	2	0	11389	\N
9491	133	3	0	11391	\N
9486	108	2	0	11871	\N
9510	77	3	0	13306	\N
9510	1043	4	0	13310	\N
9662	402	3	0	14231	\N
9662	1328	4	0	14235	\N
9436	192	2	0	15473	\N
9436	838	3	0	15475	\N
9691	167	10	0	17885	\N
9691	1444	11	0	17887	\N
9419	290	0	0	19127	\N
9679	60	4	0	19647	\N
9679	1687	5	0	19648	\N
9450	62	2	0	19832	\N
9586	62	2	0	19850	\N
9586	683	3	0	19851	\N
9582	198	2	0	20261	\N
9582	746	3	0	20262	\N
9577	64	2	0	20893	\N
9577	162	3	0	20896	\N
9551	164	1	0	21374	\N
9551	165	2	0	21377	\N
9378	73	2	0	22608	\N
9616	73	2	0	22609	\N
9378	703	3	0	22613	\N
9616	703	3	0	22614	\N
9534	265	3	0	23623	\N
9642	82	2	0	23882	\N
9642	343	3	0	23883	\N
9599	140	3	0	24133	\N
9599	404	4	0	24135	\N
9549	411	2	0	25309	\N
9549	582	3	0	25310	\N
9440	224	2	0	25717	\N
9440	508	3	0	25719	\N
9413	244	2	0	27418	\N
9413	438	3	0	27419	\N
9459	16	2	0	28280	\N
9601	16	3	0	28292	\N
9601	359	4	0	28295	\N
9618	16	1	0	28298	\N
9618	17	2	0	28299	\N
9676	16	3	0	28300	\N
9676	359	4	0	28306	\N
9555	54	1	0	30176	\N
9555	55	2	0	30182	\N
9553	151	1	0	30853	\N
9553	302	2	0	30854	\N
9519	322	2	0	32470	\N
9519	833	3	0	32471	\N
9395	422	5	0	34593	\N
9424	112	2	0	34600	\N
9424	1	3	0	34602	\N
9504	1	3	0	34613	\N
9504	2207	4	0	34618	\N
9584	1	4	0	34626	\N
9584	422	5	0	34628	\N
9393	2	4	0	35783	\N
9393	315	5	0	35789	\N
9425	10	4	0	38784	\N
9425	600	5	0	38785	\N
9466	10	4	0	38790	\N
9477	10	2	0	38792	\N
9477	29	3	0	38793	\N
9497	10	2	0	38798	\N
9497	29	3	0	38800	\N
9563	10	4	0	38806	\N
9571	10	3	0	38807	\N
9563	600	5	0	38808	\N
9571	465	4	0	38809	\N
9573	10	2	0	38810	\N
9573	29	3	0	38811	\N
9590	10	2	0	38814	\N
9590	29	3	0	38815	\N
9654	347	4	0	38819	\N
9657	10	6	0	38820	\N
9657	426	7	0	38821	\N
9693	10	1	0	38828	\N
9693	11	2	0	38830	\N
9457	18	2	0	39903	\N
9568	18	2	0	39905	\N
9576	18	2	0	39906	\N
9457	218	3	0	39907	\N
9568	218	3	0	39909	\N
9576	218	3	0	39910	\N
9580	18	3	0	39912	\N
9588	218	3	0	39914	\N
9580	127	4	0	39915	\N
9660	18	2	0	39918	\N
9660	218	3	0	39919	\N
9596	23	2	0	40842	\N
9596	24	3	0	40843	\N
9527	40	2	0	43346	\N
9527	66	3	0	43347	\N
9539	40	5	0	43349	\N
9539	2218	6	0	43351	\N
9626	40	31	0	43357	\N
9626	2229	32	0	43359	\N
9629	56	7	0	43996	\N
9629	2230	8	0	43999	\N
9535	75	2	0	45492	\N
9535	159	3	0	45494	\N
9674	75	5	0	45519	\N
9674	1705	6	0	45520	\N
9513	79	2	0	46094	\N
9513	80	3	0	46095	\N
9544	102	2	0	47930	\N
9677	119	4	0	48760	\N
9677	423	5	0	48764	\N
9615	137	2	0	49931	\N
9615	197	3	0	49933	\N
9505	147	3	0	50063	\N
9505	2208	4	0	50083	\N
9490	260	2	0	52517	\N
9490	419	3	0	52518	\N
9474	279	3	0	53333	\N
9474	2200	4	0	53334	\N
9426	316	4	0	54084	\N
9426	1024	5	0	54085	\N
9480	597	2	0	56032	\N
9480	767	3	0	56036	\N
9462	1109	1	0	56337	\N
9462	1111	2	0	56339	\N
9621	1109	9	0	56345	\N
9681	1109	4	0	56347	\N
9681	1389	5	0	56348	\N
9621	2227	10	0	56350	\N
9634	1021	10	0	56384	\N
9634	2232	11	0	56385	\N
9410	841	2	0	57093	\N
9410	1161	3	0	57094	\N
9470	852	3	0	57422	\N
9470	2195	4	0	57425	\N
9515	1470	2	0	58343	\N
9515	1565	3	0	58348	\N
9455	433	3	0	477	\N
9438	2189	26	0	3165	\N
9438	2190	27	0	3166	\N
9520	222	6	0	5280	\N
9520	2210	7	0	5283	\N
9663	391	3	0	10848	\N
9663	581	4	0	10849	\N
9672	391	5	0	10858	\N
9672	2235	6	0	10868	\N
9448	108	2	0	11863	\N
9448	501	3	0	11864	\N
9446	528	2	0	12606	\N
9446	613	3	0	12607	\N
9467	384	3	0	12951	\N
9532	58	5	0	13664	\N
9532	2216	6	0	13665	\N
9451	402	5	0	14228	\N
9451	2129	6	0	14237	\N
9385	173	2	0	14811	\N
9388	173	2	0	14812	\N
9385	480	3	0	14815	\N
9388	480	3	0	14816	\N
9464	192	2	0	15486	\N
9464	2193	3	0	15487	\N
9637	235	4	0	15841	\N
9640	1061	3	0	15845	\N
9637	2233	5	0	15847	\N
9473	2198	67	0	18062	\N
9473	30	126	0	18065	\N
9473	2199	127	0	18066	\N
9420	290	2	0	19128	\N
9420	575	3	0	19132	\N
9643	164	2	0	21375	\N
9643	226	3	0	21379	\N
9670	488	2	0	21587	\N
9670	729	3	0	21590	\N
9645	336	2	0	22880	\N
9602	149	2	0	23226	\N
9602	697	3	0	23228	\N
9390	264	3	0	23610	\N
9390	1748	4	0	23612	\N
9665	264	4	0	23665	\N
9665	2137	5	0	23666	\N
9688	140	5	0	24134	\N
9688	889	6	0	24136	\N
9428	2185	2	0	24920	\N
9428	2186	3	0	24922	\N
9683	224	2	0	25718	\N
9683	508	3	0	25720	\N
9600	877	4	0	26193	\N
9433	94	2	0	26820	\N
9608	94	4	0	26821	\N
9433	95	3	0	26824	\N
9608	1706	5	0	26826	\N
9430	2183	4	0	27161	\N
9430	2187	5	0	27164	\N
9396	244	7	0	27408	\N
9396	2181	8	0	27410	\N
9441	16	4	0	28278	\N
9441	380	5	0	28279	\N
9487	16	2	0	28282	\N
9508	16	2	0	28284	\N
9508	155	3	0	28285	\N
9696	320	23	0	29312	\N
9648	96	3	0	29605	\N
9648	834	4	0	29609	\N
9653	230	2	0	32234	\N
9653	231	3	0	32235	\N
9530	322	5	0	32474	\N
9530	1170	6	0	32475	\N
9655	833	2	0	32476	\N
9655	322	4	0	32479	\N
9655	323	5	0	32480	\N
9383	112	3	0	34591	\N
9401	1	4	0	34595	\N
9401	422	5	0	34597	\N
9415	1	4	0	34598	\N
9415	422	5	0	34599	\N
9416	1	4	0	34601	\N
9416	422	5	0	34603	\N
9492	1	3	0	34609	\N
9492	711	4	0	34610	\N
9499	1	4	0	34611	\N
9499	422	5	0	34612	\N
9518	1	2	0	34615	\N
9525	1	5	0	34619	\N
9525	2052	6	0	34620	\N
9658	1	2	0	34637	\N
9658	112	3	0	34640	\N
9650	2	2	0	35792	\N
9650	131	3	0	35793	\N
9511	10	3	0	38799	\N
9511	347	4	0	38801	\N
9537	10	3	0	38803	\N
9537	465	4	0	38805	\N
9667	10	2	0	38823	\N
9667	29	3	0	38825	\N
9685	29	3	0	38831	\N
9417	14	4	0	39571	\N
9417	588	5	0	39573	\N
9404	18	10	0	39900	\N
9404	2182	11	0	39901	\N
9403	23	2	0	40836	\N
9403	24	3	0	40837	\N
9606	40	4	0	43356	\N
9606	564	5	0	43358	\N
9694	40	3	0	43366	\N
9703	40	6	0	43367	\N
9694	128	4	0	43373	\N
9703	522	7	0	43376	\N
9783	40	4	0	43378	\N
9783	564	5	0	43379	\N
9826	40	26	0	43383	\N
9826	2306	27	0	43385	\N
9589	75	2	0	45504	\N
9589	159	3	0	45506	\N
9564	79	3	0	46149	\N
9641	79	2	0	46150	\N
9641	80	3	0	46152	\N
9564	1168	4	0	46153	\N
9827	79	8	0	46342	\N
9827	2307	9	0	46345	\N
9544	158	3	0	47935	\N
9752	102	3	0	47952	\N
9752	608	4	0	47953	\N
9771	102	2	0	47968	\N
9771	158	3	0	47969	\N
9594	147	2	0	50065	\N
9594	516	3	0	50077	\N
9712	156	1	0	50393	\N
9712	157	2	0	50396	\N
9730	170	2	0	50765	\N
9730	718	3	0	50771	\N
9678	181	6	0	51020	\N
9678	2237	7	0	51025	\N
9836	260	2	0	52520	\N
9836	419	3	0	52521	\N
9829	2308	75	0	54463	\N
9829	324	76	0	54472	\N
9566	362	2	0	54873	\N
9566	420	3	0	54878	\N
9767	595	11	0	55737	\N
9767	2279	12	0	55741	\N
9680	1109	6	0	56346	\N
9680	2238	7	0	56349	\N
9636	1021	4	0	56386	\N
9636	1047	5	0	56387	\N
9675	793	5	0	56850	\N
9675	2236	6	0	56852	\N
9627	841	2	0	57101	\N
9627	1161	3	0	57103	\N
9723	2255	43	0	58539	\N
9723	2259	45	0	58540	\N
9740	2273	8	0	494	\N
9671	520	3	0	992	\N
9668	266	2	0	1252	\N
9668	1711	3	0	1254	\N
9778	251	4	0	1628	\N
9778	1610	5	0	1630	\N
9832	110	2	0	2377	\N
9832	111	3	0	2380	\N
9761	228	3	0	2962	\N
9761	492	4	0	2963	\N
9624	391	3	0	10841	\N
9624	503	4	0	10842	\N
9666	391	2	0	10856	\N
9813	391	6	0	10861	\N
9666	406	3	0	10863	\N
9797	581	4	0	10866	\N
9813	2297	7	0	10869	\N
9738	132	7	0	11405	\N
9738	2271	8	0	11406	\N
9820	132	12	0	11425	\N
9820	814	13	0	11426	\N
9569	108	9	0	11883	\N
9569	2219	10	0	11884	\N
9821	2299	9	0	12581	\N
9824	2303	107	0	12584	\N
9824	528	116	0	12610	\N
9824	2304	117	0	12611	\N
9810	123	9	0	12956	\N
9810	2294	10	0	12957	\N
9656	58	3	0	13674	\N
9656	2234	4	0	13675	\N
9611	402	2	0	14230	\N
9611	1148	3	0	14234	\N
9794	173	4	0	14813	\N
9794	1046	5	0	14817	\N
9723	2258	44	1	15254	\N
9723	2254	40	0	15490	\N
9841	235	2	0	15864	\N
9841	1061	3	0	15866	\N
9664	44	3	0	16205	\N
9664	940	4	0	16206	\N
9684	115	2	0	16862	\N
9684	636	3	0	16863	\N
9633	326	1	0	17478	\N
9633	327	2	0	17482	\N
9723	2260	45	1	17592	\N
9781	198	3	0	20270	\N
9781	1347	4	0	20271	\N
9547	164	4	0	21370	\N
9723	2257	44	0	21638	\N
9747	67	3	0	22294	\N
9747	1489	4	0	22295	\N
9581	336	2	0	22862	\N
9581	740	3	0	22863	\N
9591	149	2	0	23225	\N
9591	697	3	0	23227	\N
9729	264	13	0	23669	\N
9729	2267	14	0	23670	\N
9598	16	4	0	28291	\N
9613	16	2	0	28293	\N
9613	155	3	0	28294	\N
9759	16	2	0	28303	\N
9759	155	3	0	28305	\N
9769	16	11	0	28308	\N
9799	16	11	0	28309	\N
9769	2281	12	0	28310	\N
9799	2289	12	0	28311	\N
9630	449	7	0	29933	\N
9630	2231	8	0	29936	\N
9554	54	0	0	30175	\N
9638	54	2	0	30179	\N
9638	485	3	0	30183	\N
9733	20	13	0	30612	\N
9801	202	2	0	31257	\N
9801	812	3	0	31260	\N
9558	1	4	0	34622	\N
9558	422	5	0	34625	\N
9603	1	2	0	34629	\N
9603	112	3	0	34631	\N
9815	1	6	0	34658	\N
9815	2252	7	0	34660	\N
9561	2	2	0	35785	\N
9561	131	3	0	35788	\N
9574	2	2	0	35790	\N
9574	131	3	0	35791	\N
9579	10	3	0	38812	\N
9579	347	4	0	38813	\N
9673	10	5	0	38826	\N
9673	2042	6	0	38833	\N
9700	10	3	0	38834	\N
9700	465	4	0	38835	\N
9754	10	2	0	38842	\N
9754	29	3	0	38843	\N
9786	10	4	0	38846	\N
9786	600	5	0	38849	\N
9791	10	3	0	38852	\N
9791	347	4	0	38853	\N
9817	350	13	0	40867	\N
9724	40	9	0	43368	\N
9746	40	3	0	43370	\N
9746	128	4	0	43374	\N
9724	2262	10	0	43377	\N
9706	56	4	0	44004	\N
9706	1145	5	0	44005	\N
9848	56	1	0	44006	\N
9848	57	2	0	44007	\N
9811	75	9	0	45529	\N
9811	2295	10	0	45532	\N
9736	79	3	0	46151	\N
9736	272	4	0	46154	\N
9804	79	2	0	46237	\N
9804	80	3	0	46239	\N
9828	79	1	0	46343	\N
9828	1434	2	0	46344	\N
9869	135	4	0	49636	\N
9869	2315	5	0	49637	\N
9710	156	1	0	50392	\N
9710	157	2	0	50395	\N
9690	181	10	0	51021	\N
9690	969	11	0	51026	\N
9884	210	0	0	51708	\N
9883	210	0	0	52002	\N
9877	210	0	0	52005	\N
9857	242	2	0	52322	\N
9857	620	3	0	52323	\N
9717	285	6	0	53665	\N
9717	2251	7	0	53667	\N
9708	316	3	0	54093	\N
9708	555	4	0	54095	\N
9711	316	1	0	54098	\N
9711	317	2	0	54099	\N
9830	324	9	0	54466	\N
9830	2309	10	0	54467	\N
9849	435	1	0	55028	\N
9849	436	2	0	55030	\N
9839	1021	2	0	56389	\N
9839	1048	3	0	56394	\N
9886	793	2	0	56861	\N
9886	1136	3	0	56863	\N
9715	2249	126	0	58668	\N
9715	2250	127	0	58669	\N
9755	289	3	0	147	\N
9762	2276	8	0	150	\N
9739	12	4	0	484	\N
9739	2272	5	0	491	\N
9789	266	8	0	1259	\N
9789	2288	9	0	1260	\N
9863	266	2	0	1267	\N
9863	1711	3	0	1269	\N
9856	117	7	0	2186	\N
9856	2313	8	0	2187	\N
9833	110	3	0	2378	\N
9833	905	4	0	2381	\N
9846	110	5	0	2386	\N
9699	110	8	0	2725	\N
9699	2242	9	0	2727	\N
9702	262	4	0	4001	\N
9702	1015	5	0	4002	\N
9721	391	4	0	10859	\N
9721	614	5	0	10867	\N
9743	300	2	0	12185	\N
9743	706	3	0	12186	\N
9867	77	4	0	12987	\N
9874	77	2	0	12988	\N
9874	216	3	0	12990	\N
9867	1132	5	0	12991	\N
9707	77	2	0	13308	\N
9707	216	3	0	13309	\N
9704	1132	5	0	13311	\N
9713	402	4	0	14232	\N
9713	1378	5	0	14236	\N
9726	192	9	0	15495	\N
9726	2264	10	0	15496	\N
9776	192	2	0	15502	\N
9776	838	3	0	15503	\N
9774	2283	0	0	15504	\N
9792	235	2	0	15844	\N
9792	1061	3	0	15846	\N
9871	142	2	0	18440	\N
9871	656	3	0	18441	\N
9772	142	2	0	18695	\N
9772	656	3	0	18696	\N
9701	2244	9	0	19158	\N
9719	64	5	0	20902	\N
9719	2096	6	0	20904	\N
9750	64	4	0	20914	\N
9750	490	5	0	20915	\N
9734	488	13	0	21588	\N
9734	2269	14	0	21592	\N
9765	411	11	0	25317	\N
9854	86	1	0	26505	\N
9854	87	2	0	26506	\N
9872	86	2	0	26511	\N
9872	509	3	0	26513	\N
9692	94	1	0	26832	\N
9692	107	2	0	26833	\N
9701	2243	8	0	27699	\N
9701	2245	9	0	27708	\N
9686	16	2	0	28301	\N
9686	155	3	0	28304	\N
9689	96	5	0	29606	\N
9689	2239	6	0	29610	\N
9809	2293	5	0	31262	\N
9888	33	2	0	31658	\N
9888	34	3	0	31660	\N
9806	230	3	0	31976	\N
9806	2290	4	0	31977	\N
9682	1	3	0	34638	\N
9682	48	4	0	34641	\N
9727	1	13	0	34645	\N
9731	1	2	0	34646	\N
9731	112	3	0	34647	\N
9727	2265	14	0	34650	\N
9757	1	2	0	34653	\N
9802	1	1	0	34657	\N
9802	53	2	0	34659	\N
9843	1	2	0	34661	\N
9843	112	3	0	34662	\N
9879	1	2	0	34664	\N
9879	112	3	0	34666	\N
9851	2	4	0	35799	\N
9851	315	5	0	35800	\N
9890	2	2	0	35804	\N
9890	131	3	0	35805	\N
9834	4	13	0	36188	\N
9834	2311	14	0	36191	\N
9695	347	4	0	38832	\N
9735	10	13	0	38836	\N
9741	10	7	0	38837	\N
9741	2274	8	0	38838	\N
9735	1881	14	0	38839	\N
9745	10	5	0	38840	\N
9745	2042	6	0	38841	\N
9822	2300	9	0	38854	\N
9818	10	12	0	38855	\N
9822	10	11	0	38858	\N
9822	1416	12	0	38859	\N
9818	347	13	0	38860	\N
9860	29	3	0	38862	\N
9882	10	2	0	38869	\N
9882	29	3	0	38870	\N
9697	14	3	0	39575	\N
9697	1863	4	0	39581	\N
9837	18	2	0	39922	\N
9837	218	3	0	39924	\N
9744	40	5	0	43369	\N
9770	40	2	0	43371	\N
9770	66	3	0	43372	\N
9744	2192	6	0	43375	\N
9796	40	3	0	43380	\N
9796	128	4	0	43381	\N
9812	40	6	0	43382	\N
9812	2296	7	0	43384	\N
9858	40	7	0	43386	\N
9858	2314	8	0	43387	\N
9705	51	4	0	43660	\N
9705	648	5	0	43662	\N
9825	75	1	0	45530	\N
9825	2305	2	0	45531	\N
9831	75	7	0	45539	\N
9831	2310	8	0	45540	\N
9805	79	2	0	46238	\N
9805	80	3	0	46240	\N
9816	79	2	0	46291	\N
9816	80	3	0	46292	\N
9889	100	2	0	47731	\N
9889	101	3	0	47733	\N
9780	119	3	0	48761	\N
9780	129	4	0	48762	\N
9868	137	4	0	49935	\N
9868	1752	5	0	49936	\N
9768	147	11	0	50088	\N
9768	2280	12	0	50089	\N
9840	156	2	0	50394	\N
9840	571	3	0	50398	\N
9732	170	2	0	50766	\N
9732	718	3	0	50772	\N
9819	210	12	0	51707	\N
9819	655	13	0	51709	\N
9880	210	0	0	52006	\N
9793	268	2	0	52886	\N
9852	268	3	0	52887	\N
9793	1387	3	0	52888	\N
9852	610	4	0	52889	\N
9728	273	13	0	53093	\N
9728	2266	14	0	53094	\N
9737	362	7	0	54874	\N
9737	2270	8	0	54881	\N
9766	597	11	0	56081	\N
9766	2278	12	0	56084	\N
9842	793	2	0	56855	\N
9859	793	4	0	56856	\N
9842	1136	3	0	56857	\N
9859	1986	5	0	56858	\N
9825	1395	2	1	57832	\N
9787	2286	3	0	58486	\N
9788	2286	3	0	58487	\N
9787	1914	8	0	58495	\N
9788	1914	8	0	58496	\N
9787	2287	9	0	58497	\N
9788	2287	9	0	58498	\N
9838	1952	2	0	58526	\N
9838	2312	3	0	58527	\N
9795	289	3	0	152	\N
9742	2272	5	0	492	\N
9749	251	1	0	1627	\N
9749	252	2	0	1629	\N
9847	110	6	0	2387	\N
9847	736	7	0	2395	\N
9698	110	5	0	2724	\N
9698	2241	6	0	2726	\N
9764	228	3	0	2964	\N
9764	492	4	0	2967	\N
9709	2246	3	0	3168	\N
9709	2247	4	0	3171	\N
9844	262	2	0	4008	\N
9870	391	2	0	10862	\N
9870	406	3	0	10865	\N
9748	384	2	0	12952	\N
9748	123	4	0	12954	\N
9748	2275	5	0	12955	\N
9850	92	2	0	15189	\N
9850	93	3	0	15190	\N
9853	290	3	0	18845	\N
9853	364	4	0	18852	\N
9720	64	6	0	20903	\N
9720	2253	7	0	20905	\N
9779	73	4	0	22610	\N
9782	336	4	0	22886	\N
9782	2285	5	0	22898	\N
9800	140	2	0	24145	\N
9873	140	2	0	24146	\N
9800	487	3	0	24147	\N
9873	487	3	0	24148	\N
9861	49	2	0	25120	\N
9861	328	3	0	25122	\N
9714	42	4	0	27713	\N
9714	2139	5	0	27716	\N
9716	16	4	0	28302	\N
9716	380	5	0	28307	\N
9845	155	3	0	28313	\N
9696	2240	24	0	29317	\N
9862	54	2	0	30180	\N
9862	485	3	0	30184	\N
9808	20	4	0	30615	\N
9808	2292	5	0	30617	\N
9803	202	1	0	31258	\N
9803	203	2	0	31259	\N
9785	230	3	0	32249	\N
9785	876	4	0	32250	\N
9753	322	2	0	32483	\N
9753	833	3	0	32486	\N
9784	902	3	0	32901	\N
9718	1	6	0	34643	\N
9725	1	9	0	34644	\N
9718	2252	7	0	34648	\N
9725	2263	10	0	34649	\N
9756	1	4	0	34651	\N
9756	2093	5	0	34652	\N
9777	1	6	0	34654	\N
9777	523	7	0	34656	\N
9855	1	0	0	34663	\N
9722	2	4	0	35794	\N
9722	935	5	0	35795	\N
9763	572	4	0	35797	\N
9814	2	6	0	35798	\N
9814	2298	7	0	35801	\N
9864	2	2	0	35802	\N
9864	131	3	0	35803	\N
9775	4	2	0	36187	\N
9775	579	3	0	36190	\N
9758	10	2	0	38844	\N
9773	10	2	0	38845	\N
9758	29	3	0	38847	\N
9773	29	3	0	38848	\N
9790	10	8	0	38850	\N
9835	10	2	0	38856	\N
9835	29	3	0	38857	\N
9866	10	1	0	38863	\N
9866	11	2	0	38864	\N
9875	10	2	0	38865	\N
9751	14	3	0	39576	\N
9807	14	4	0	39577	\N
9751	1786	4	0	39578	\N
9807	2291	5	0	39579	\N
9823	2301	9	0	39920	\N
9798	18	3	0	39921	\N
9823	18	23	0	39926	\N
9823	2302	24	0	39928	\N
9760	23	2	0	40856	\N
9760	24	3	0	40857	\N
9865	27	1	0	41118	\N
9865	28	2	0	41120	\N
9892	40	1	0	43388	\N
9892	41	2	0	43389	\N
9896	40	2	0	43390	\N
9896	66	3	0	43391	\N
9898	40	2	0	43392	\N
9898	66	3	0	43393	\N
10056	40	3	0	43398	\N
10056	128	4	0	43400	\N
9952	51	1	0	43449	\N
9952	52	2	0	43452	\N
10021	75	4	0	45551	\N
10021	2357	5	0	45552	\N
9895	79	4	0	46394	\N
9895	589	5	0	46395	\N
9987	79	6	0	46499	\N
9987	2340	7	0	46504	\N
10092	2392	7	0	47970	\N
10092	102	22	0	47978	\N
10092	2393	23	0	47982	\N
9917	121	3	0	49058	\N
9917	2317	4	0	49060	\N
9921	170	2	0	50767	\N
9922	170	1	0	50768	\N
9922	398	2	0	50769	\N
9921	718	3	0	50773	\N
9881	210	2	0	51712	\N
9881	458	3	0	51714	\N
9943	242	3	0	52324	\N
9943	1135	4	0	52325	\N
9979	279	2	0	53336	\N
9979	280	3	0	53337	\N
10105	793	2	0	56608	\N
10105	1136	3	0	56609	\N
9887	793	2	0	56862	\N
9887	1136	3	0	56864	\N
9919	841	7	0	57102	\N
9919	2319	8	0	57104	\N
9891	1914	4	0	58503	\N
9891	2287	5	0	58504	\N
9878	391	2	0	10873	\N
9878	406	3	0	10876	\N
10003	406	3	0	10877	\N
10053	123	1	0	12960	\N
10053	124	2	0	12962	\N
9910	256	2	0	13389	\N
9910	335	3	0	13390	\N
9991	235	2	0	15865	\N
9991	1061	3	0	15867	\N
9920	212	2	0	17272	\N
9920	566	3	0	17273	\N
9970	326	4	0	17480	\N
9970	1638	5	0	17483	\N
9937	60	7	0	19653	\N
9937	2323	8	0	19654	\N
9908	62	0	0	19859	\N
9915	62	4	0	19860	\N
9915	1606	5	0	19861	\N
9929	62	0	0	19872	\N
10008	62	2	0	19891	\N
10008	683	3	0	19892	\N
9994	198	2	0	20277	\N
9994	746	3	0	20280	\N
10077	241	5	0	20535	\N
10077	2379	6	0	20536	\N
9918	2318	4	0	21391	\N
9906	145	2	0	22007	\N
9906	331	3	0	22009	\N
9911	145	4	0	22013	\N
9911	2316	5	0	22014	\N
9914	145	2	0	22019	\N
9914	331	3	0	22020	\N
9900	67	2	0	22296	\N
9900	68	3	0	22297	\N
9966	149	7	0	23235	\N
9966	2334	8	0	23237	\N
10097	264	4	0	23404	\N
9984	214	5	0	24292	\N
9984	2338	6	0	24293	\N
10030	49	2	0	25121	\N
10030	328	3	0	25123	\N
10006	2020	6	0	25885	\N
10006	206	17	0	25894	\N
10006	207	18	0	25895	\N
9950	244	2	0	27197	\N
9950	438	3	0	27198	\N
9894	16	5	0	28314	\N
9916	16	2	0	28315	\N
9916	155	3	0	28316	\N
10070	16	10	0	28342	\N
10070	1436	11	0	28343	\N
9998	2345	22	0	29318	\N
9998	320	126	0	29336	\N
9998	2346	127	0	29337	\N
9903	449	2	0	29934	\N
9903	583	3	0	29935	\N
9904	151	2	0	30859	\N
9905	151	4	0	30860	\N
9904	576	3	0	30861	\N
9905	1510	5	0	30862	\N
10058	202	2	0	30953	\N
9897	230	2	0	31992	\N
9897	231	3	0	31995	\N
9939	322	2	0	32484	\N
10079	322	6	0	32485	\N
9939	833	3	0	32487	\N
10079	2380	7	0	32488	\N
9957	1	0	0	34623	\N
9959	1	0	0	34630	\N
9885	1	2	0	34665	\N
9885	112	3	0	34667	\N
9901	1	2	0	34668	\N
9901	112	3	0	34669	\N
9902	112	3	0	34671	\N
9909	1	8	0	34672	\N
9909	1982	9	0	34673	\N
9975	1	3	0	34678	\N
9975	48	4	0	34685	\N
10024	1	3	0	34689	\N
10024	48	4	0	34690	\N
10040	1	4	0	34698	\N
10040	422	5	0	34699	\N
10047	1	2	0	34700	\N
10047	112	3	0	34701	\N
10074	2378	0	0	34706	\N
9893	26	2	0	35808	\N
10085	2	26	0	35812	\N
10085	2384	27	0	35813	\N
9875	29	3	0	38866	\N
9876	10	5	0	38867	\N
9876	998	6	0	38868	\N
9899	10	2	0	38871	\N
9912	10	4	0	38872	\N
9913	10	1	0	38873	\N
9913	11	2	0	38874	\N
9899	29	3	0	38875	\N
9912	600	5	0	38876	\N
10011	347	4	0	38891	\N
10043	10	2	0	38895	\N
10049	10	2	0	38896	\N
10043	29	3	0	38898	\N
10049	29	3	0	38899	\N
10102	10	1	0	38910	\N
10102	11	2	0	38911	\N
9961	18	1	0	39929	\N
9961	19	2	0	39930	\N
9932	27	2	0	41119	\N
9932	619	3	0	41121	\N
9933	40	4	0	43394	\N
9933	564	5	0	43395	\N
10015	40	5	0	43396	\N
10015	385	6	0	43397	\N
10048	56	2	0	44010	\N
10048	169	3	0	44012	\N
10149	56	2	0	44020	\N
10149	169	3	0	44023	\N
9935	79	2	0	46439	\N
9935	80	3	0	46440	\N
10212	119	6	0	48769	\N
10212	2444	7	0	48774	\N
10020	181	4	0	51033	\N
10020	2356	5	0	51035	\N
10216	186	2	0	51141	\N
10216	696	3	0	51146	\N
10231	242	6	0	52327	\N
10231	1630	7	0	52328	\N
10035	2365	5	0	52522	\N
10035	260	6	0	52524	\N
9978	273	2	0	53099	\N
9978	1159	3	0	53102	\N
9995	353	2	0	54506	\N
9995	755	3	0	54508	\N
10210	362	3	0	54746	\N
10210	2367	4	0	54747	\N
10235	793	3	0	56610	\N
10235	2453	4	0	56614	\N
10041	841	2	0	57109	\N
10041	1161	3	0	57110	\N
10012	908	4	0	57696	\N
10012	1032	5	0	57697	\N
10167	289	3	0	155	\N
10000	2348	3	0	641	\N
10136	424	4	0	676	\N
10136	2421	5	0	677	\N
9954	2330	1	0	1120	\N
9954	2331	2	0	1121	\N
10205	251	2	0	1392	\N
10205	828	3	0	1393	\N
10228	251	1	0	1396	\N
10228	252	2	0	1399	\N
10230	2449	15	0	2300	\N
10229	2079	4	0	2307	\N
10229	2448	5	0	2308	\N
10230	2450	77	0	2310	\N
10159	725	2	0	3048	\N
10159	2428	3	0	3049	\N
10062	189	1	0	5125	\N
10062	190	2	0	5126	\N
10073	1454	13	0	10070	\N
10073	2376	14	0	10071	\N
10200	391	2	0	10889	\N
10200	406	3	0	10890	\N
10010	108	3	0	11889	\N
10010	837	4	0	11890	\N
10129	300	2	0	12193	\N
10129	706	3	0	12198	\N
10131	2418	4	0	12199	\N
10178	2432	4	0	12361	\N
10178	2433	5	0	12365	\N
9930	123	2	0	12958	\N
9930	384	3	0	12959	\N
9992	256	2	0	13391	\N
9992	335	3	0	13392	\N
10261	173	4	0	14820	\N
10154	92	2	0	15201	\N
10154	93	3	0	15203	\N
10018	212	2	0	17274	\N
9969	326	61	0	17479	\N
9969	2337	62	0	17485	\N
9928	62	1	0	19871	\N
9928	63	2	0	19873	\N
9946	2324	6	0	20265	\N
9946	198	7	0	20272	\N
10241	73	0	0	22351	\N
10246	73	0	0	22355	\N
10188	149	5	0	23272	\N
10188	2441	6	0	23274	\N
10060	140	14	0	24170	\N
10060	2370	15	0	24173	\N
10172	70	2	0	24581	\N
10183	411	4	0	25319	\N
10183	1665	5	0	25321	\N
9956	94	5	0	26836	\N
10187	94	2	0	26837	\N
10187	95	3	0	26840	\N
9956	2332	6	0	26843	\N
10025	96	5	0	29618	\N
10025	1702	6	0	29620	\N
10007	2353	6	0	30614	\N
10005	20	5	0	30616	\N
10005	1512	6	0	30618	\N
10007	144	18	0	30620	\N
10117	2407	3	0	30908	\N
10117	2408	4	0	30909	\N
10059	202	1	0	30954	\N
10059	203	2	0	30955	\N
9973	230	1	0	31993	\N
9973	287	2	0	31994	\N
10240	322	2	0	32492	\N
10240	833	3	0	32493	\N
10034	2364	5	0	32609	\N
10034	453	6	0	32615	\N
9958	1	0	0	34627	\N
9962	1	0	0	34639	\N
9923	1	3	0	34674	\N
9923	48	4	0	34675	\N
9976	1	7	0	34679	\N
9981	1	6	0	34680	\N
9981	523	7	0	34686	\N
9976	1336	8	0	34687	\N
10028	1	4	0	34694	\N
10028	422	5	0	34695	\N
10036	1	2	0	34696	\N
10036	112	3	0	34697	\N
10052	1	2	0	34704	\N
10107	1	3	0	34712	\N
10144	1	2	0	34713	\N
10199	1	2	0	34715	\N
10144	112	3	0	34716	\N
10199	112	3	0	34718	\N
10107	48	4	0	34719	\N
10254	1	2	0	34729	\N
10254	112	3	0	34731	\N
9951	431	2	0	34789	\N
9951	531	3	0	34790	\N
10139	431	4	0	34791	\N
10139	2424	5	0	34794	\N
10002	29	3	0	38885	\N
10057	10	3	0	38897	\N
10057	347	4	0	38900	\N
10072	10	7	0	38903	\N
10072	2274	8	0	38904	\N
10075	10	3	0	38905	\N
10119	10	3	0	38916	\N
10119	347	4	0	38918	\N
10162	10	2	0	38925	\N
10260	10	5	0	38926	\N
10162	29	3	0	38928	\N
10260	998	6	0	38929	\N
10155	588	5	0	39002	\N
9945	18	2	0	39923	\N
9945	218	3	0	39925	\N
10194	18	4	0	39940	\N
10194	590	5	0	39944	\N
10026	51	4	0	43450	\N
10026	2360	5	0	43454	\N
9949	56	8	0	44008	\N
9949	689	9	0	44009	\N
10151	56	2	0	44021	\N
10151	169	3	0	44024	\N
10214	75	6	0	45566	\N
10214	2445	7	0	45575	\N
10104	79	2	0	46500	\N
10104	80	3	0	46502	\N
9986	88	6	0	47018	\N
10175	88	2	0	47020	\N
10175	154	3	0	47022	\N
9986	623	7	0	47023	\N
10208	100	2	0	47464	\N
10208	101	3	0	47467	\N
10141	113	0	0	48488	\N
9990	121	2	0	48791	\N
9990	625	3	0	48792	\N
9988	125	6	0	49126	\N
9988	2341	7	0	49130	\N
10111	170	7	0	50779	\N
10111	2401	8	0	50783	\N
10226	200	1	0	51448	\N
10226	201	2	0	51449	\N
9947	260	6	0	52523	\N
9947	2325	7	0	52525	\N
9931	268	2	0	52890	\N
9931	1387	3	0	52891	\N
9996	353	33	0	54507	\N
9996	2344	34	0	54509	\N
10191	362	7	0	54745	\N
10191	2142	8	0	54748	\N
10039	362	3	0	54876	\N
10039	2367	4	0	54879	\N
9982	595	6	0	55738	\N
9982	1556	7	0	55740	\N
10121	852	13	0	57180	\N
10121	2409	14	0	57183	\N
10157	2427	3	0	59212	\N
10169	433	3	0	490	\N
10190	2442	6	0	1136	\N
10029	266	4	0	1268	\N
10029	832	5	0	1270	\N
10130	954	2	0	1809	\N
10130	2417	3	0	1810	\N
10001	2349	2	0	3239	\N
10001	2350	3	0	3240	\N
10063	189	4	0	4739	\N
10063	849	5	0	4740	\N
9972	222	4	0	5247	\N
9972	1564	5	0	5248	\N
10061	391	14	0	10875	\N
10152	132	2	0	11068	\N
10152	133	3	0	11069	\N
10081	108	2	0	11898	\N
10081	501	3	0	11899	\N
10185	108	2	0	11903	\N
10185	501	3	0	11905	\N
10084	300	26	0	12191	\N
10128	300	1	0	12192	\N
10128	355	2	0	12197	\N
10084	2383	27	0	12202	\N
10042	528	2	0	12629	\N
10042	613	3	0	12630	\N
10023	2359	13	0	13685	\N
10086	233	22	0	13990	\N
10086	2385	23	0	13993	\N
10124	192	2	0	15507	\N
10124	838	3	0	15509	\N
10238	192	14	0	15512	\N
10065	235	10	0	15886	\N
10065	1238	11	0	15889	\N
10164	212	12	0	17275	\N
10164	2430	13	0	17277	\N
10032	326	5	0	17481	\N
10032	2097	6	0	17484	\N
10046	226	3	0	21380	\N
9938	488	2	0	21394	\N
9938	729	3	0	21396	\N
9967	149	8	0	23236	\N
9967	2335	9	0	23238	\N
10067	149	17	0	23243	\N
10113	149	11	0	23245	\N
10113	2404	12	0	23247	\N
10067	2373	18	0	23248	\N
9926	82	5	0	23891	\N
9926	2320	6	0	23892	\N
10101	214	1	0	24297	\N
10181	411	4	0	25318	\N
10181	1665	5	0	25320	\N
9942	244	2	0	27192	\N
9942	438	3	0	27193	\N
10137	2422	22	0	29338	\N
10137	320	126	0	29347	\N
10137	2346	127	0	29348	\N
9993	54	6	0	30181	\N
9993	2343	7	0	30185	\N
10037	54	2	0	30200	\N
10037	485	3	0	30202	\N
9936	360	7	0	31269	\N
10197	510	3	0	31271	\N
9936	2322	8	0	31272	\N
9963	1	0	0	34642	\N
9941	1	2	0	34676	\N
9974	1	3	0	34677	\N
9941	112	3	0	34682	\N
9974	48	4	0	34684	\N
10050	1	2	0	34702	\N
10050	112	3	0	34703	\N
10083	1	2	0	34709	\N
10083	112	3	0	34710	\N
10087	1	22	0	34711	\N
10147	112	3	0	34717	\N
10203	1	2	0	34721	\N
10203	112	3	0	34722	\N
10233	1	3	0	34724	\N
10233	711	4	0	34726	\N
10055	2	4	0	35807	\N
10055	315	5	0	35809	\N
10165	2	2	0	35814	\N
10165	131	3	0	35815	\N
10202	2	2	0	35817	\N
10202	131	3	0	35818	\N
9924	10	2	0	38877	\N
9965	10	7	0	38880	\N
9924	29	3	0	38883	\N
9934	600	5	0	38886	\N
9965	2274	8	0	38888	\N
10013	10	4	0	38890	\N
10013	600	5	0	38892	\N
10016	10	5	0	38893	\N
10016	2042	6	0	38894	\N
10069	10	3	0	38901	\N
10069	297	4	0	38902	\N
10076	10	7	0	38906	\N
10075	297	4	0	38907	\N
10078	10	7	0	38909	\N
10078	1776	8	0	38912	\N
10146	10	2	0	38921	\N
10146	29	3	0	38923	\N
10118	14	3	0	38997	\N
10118	306	4	0	39000	\N
10044	18	2	0	39933	\N
10044	218	3	0	39936	\N
10220	18	2	0	39941	\N
10220	218	3	0	39943	\N
10116	40	10	0	43399	\N
10116	2406	11	0	43401	\N
10174	40	2	0	43404	\N
10174	66	3	0	43405	\N
10098	56	3	0	44011	\N
10098	676	4	0	44013	\N
10142	56	3	0	44018	\N
10142	1188	4	0	44019	\N
10173	56	17	0	44022	\N
10173	2431	18	0	44025	\N
10051	75	2	0	45563	\N
10064	75	4	0	45564	\N
10051	159	3	0	45570	\N
10064	172	5	0	45573	\N
10110	100	7	0	47456	\N
10094	2395	23	1	47761	\N
10093	2392	7	0	47971	\N
10094	2392	7	0	47972	\N
10095	2392	7	0	47973	\N
10093	102	22	0	47979	\N
10094	102	22	0	47980	\N
10095	102	22	0	47981	\N
10093	2393	23	0	47983	\N
10095	2393	23	0	47984	\N
10090	2389	85	0	48479	\N
10090	113	114	0	48484	\N
10090	2390	115	0	48485	\N
9997	125	2	0	49127	\N
9997	188	3	0	49129	\N
9983	147	6	0	50116	\N
9983	1557	7	0	50126	\N
10148	156	2	0	50405	\N
10148	571	3	0	50406	\N
10125	2413	4	0	50467	\N
10112	2402	114	0	50774	\N
10125	170	2	0	50780	\N
10112	170	126	0	50786	\N
10112	2403	127	0	50787	\N
9977	181	5	0	51022	\N
9977	2213	6	0	51024	\N
9925	200	2	0	51622	\N
9925	887	3	0	51623	\N
9968	242	7	0	52326	\N
9968	2336	8	0	52329	\N
10045	2368	61	0	54494	\N
10038	362	6	0	54875	\N
10038	2366	7	0	54880	\N
10014	435	5	0	55029	\N
10014	2354	6	0	55031	\N
9980	597	6	0	56067	\N
9980	1559	7	0	56077	\N
9955	1109	5	0	56335	\N
9955	1684	6	0	56336	\N
10179	2437	6	1	56894	\N
10125	2412	3	1	56895	\N
10125	1697	3	0	57839	\N
10179	2434	5	0	57840	\N
10184	1697	4	0	57845	\N
10179	2435	5	1	57955	\N
10125	2416	5	1	57978	\N
10125	2415	5	0	58514	\N
10004	2352	3	0	58904	\N
10125	2414	4	1	59122	\N
10180	1518	5	0	5213	\N
10054	374	2	0	5339	\N
10158	391	2	0	10880	\N
10158	406	3	0	10881	\N
10163	391	12	0	10888	\N
10163	1691	13	0	10891	\N
10096	2396	4	0	11992	\N
10133	300	3	0	12196	\N
10133	2418	4	0	12200	\N
10045	2369	61	1	12380	\N
10045	528	60	0	12631	\N
10089	77	12	0	12989	\N
10089	2388	13	0	12992	\N
10103	2400	7	0	13000	\N
10143	58	6	0	13691	\N
10143	2015	7	0	13692	\N
10153	58	2	0	13698	\N
10153	665	3	0	13699	\N
10106	38	2	0	16237	\N
10106	39	3	0	16248	\N
10184	2440	4	1	17283	\N
10031	2361	23	0	17486	\N
10179	326	4	0	17492	\N
10180	326	4	0	17493	\N
10184	326	3	0	17494	\N
10031	2363	24	0	17498	\N
10180	2439	5	1	17588	\N
10031	2362	24	0	17888	\N
10091	177	12	0	18309	\N
10091	2391	13	0	18310	\N
10094	2394	23	0	19330	\N
10179	2436	6	0	21628	\N
9953	2328	1	0	22347	\N
9953	2329	2	0	22348	\N
10068	149	3	0	23244	\N
10068	2374	4	0	23246	\N
9927	264	5	0	23380	\N
9944	264	2	0	23390	\N
9944	265	3	0	23391	\N
10096	2397	4	0	23392	\N
10096	2398	5	0	23393	\N
10017	140	2	0	24159	\N
10017	487	3	0	24160	\N
10099	86	10	0	26512	\N
10099	2399	11	0	26514	\N
9948	2327	0	0	28318	\N
9964	16	13	0	28319	\N
9964	2333	14	0	28322	\N
9985	16	28	0	28329	\N
10019	16	53	0	28336	\N
10019	2355	54	0	28337	\N
9999	96	2	0	29617	\N
9999	2347	3	0	29619	\N
10071	151	14	0	30867	\N
10071	2375	15	0	30868	\N
10033	2364	5	0	32608	\N
10033	453	6	0	32614	\N
10009	1	2	0	34681	\N
10009	112	3	0	34683	\N
10022	1	12	0	34688	\N
10022	2358	13	0	34691	\N
10027	1114	4	0	34693	\N
10082	1	5	0	34707	\N
10082	2382	6	0	34708	\N
10087	2386	23	0	34720	\N
10168	431	2	0	34792	\N
10168	531	3	0	34793	\N
10066	2	10	0	35810	\N
10066	2372	11	0	35811	\N
9940	10	2	0	38879	\N
9971	10	4	0	38881	\N
9940	29	3	0	38884	\N
9971	600	5	0	38887	\N
10109	347	4	0	38914	\N
10114	10	11	0	38915	\N
10122	10	13	0	38917	\N
10114	2405	12	0	38919	\N
10122	2410	14	0	38920	\N
9989	18	6	0	39931	\N
9989	2342	7	0	39932	\N
10080	18	6	0	39934	\N
10088	18	22	0	39935	\N
10080	2381	7	0	39937	\N
10088	2387	23	0	39938	\N
10138	18	6	0	39939	\N
10127	40	4	0	43402	\N
10127	564	5	0	43403	\N
10189	40	5	0	43406	\N
10192	40	7	0	43407	\N
10189	385	6	0	43408	\N
10192	2201	8	0	43409	\N
10193	40	4	0	43410	\N
10193	564	5	0	43411	\N
10297	40	2	0	43421	\N
10297	66	3	0	43422	\N
10309	40	5	0	43424	\N
10309	385	6	0	43426	\N
10335	40	3	0	43430	\N
10335	128	4	0	43436	\N
10115	56	5	0	44016	\N
10115	677	6	0	44017	\N
10304	56	4	0	44027	\N
10304	1145	5	0	44029	\N
10170	75	2	0	45565	\N
10170	159	3	0	45571	\N
10218	79	4	0	46501	\N
10218	589	5	0	46503	\N
10166	88	2	0	47019	\N
10166	154	3	0	47021	\N
10204	88	2	0	47030	\N
10204	154	3	0	47035	\N
10110	2035	8	0	47457	\N
10268	100	2	0	47465	\N
10268	101	3	0	47468	\N
10196	102	2	0	47999	\N
10196	158	3	0	48005	\N
10140	2425	21	0	48480	\N
10250	113	28	0	48481	\N
10140	113	22	0	48486	\N
10250	2455	29	0	48487	\N
10318	2477	9	0	48800	\N
10318	121	11	0	48806	\N
10318	122	12	0	48807	\N
10280	1818	2	0	49660	\N
10280	137	8	0	49688	\N
10280	2468	9	0	49690	\N
10276	407	2	0	50276	\N
10276	156	8	0	50290	\N
10276	1830	9	0	50292	\N
10325	170	4	0	50781	\N
10325	171	5	0	50782	\N
10123	2411	114	0	50788	\N
10123	170	126	0	50801	\N
10123	970	127	0	50802	\N
10217	186	0	0	51142	\N
10239	200	2	0	51458	\N
10252	200	7	0	51459	\N
10239	887	3	0	51460	\N
10252	2456	8	0	51461	\N
10120	316	3	0	54108	\N
10120	555	4	0	54109	\N
10134	353	6	0	54522	\N
10134	2420	7	0	54523	\N
10145	2351	2	0	58907	\N
10145	2352	3	0	58908	\N
10213	1577	7	0	493	\N
10234	2452	4	0	1146	\N
10201	365	2	0	4685	\N
10201	519	3	0	4687	\N
10305	365	5	0	4702	\N
10305	2471	6	0	4704	\N
10223	1518	62	1	5212	\N
10176	132	2	0	11072	\N
10247	132	2	0	11073	\N
10176	133	3	0	11074	\N
10247	133	3	0	11075	\N
10186	108	2	0	11904	\N
10186	501	3	0	11906	\N
10336	501	3	0	11922	\N
10132	300	4	0	12195	\N
10132	2419	5	0	12201	\N
10160	727	2	0	12323	\N
10160	2429	3	0	12326	\N
10182	2432	4	0	12362	\N
10182	2433	5	0	12366	\N
10320	77	4	0	13007	\N
10320	1132	5	0	13011	\N
10126	192	2	0	15508	\N
10126	838	3	0	15510	\N
10237	192	2	0	15511	\N
10342	167	2	0	17916	\N
10259	62	5	0	19899	\N
10259	2459	6	0	19900	\N
10198	198	2	0	20278	\N
10198	746	3	0	20281	\N
10256	64	2	0	20918	\N
10256	162	3	0	20919	\N
10195	67	4	0	22299	\N
10291	67	3	0	22300	\N
10195	2443	5	0	22306	\N
10291	2443	4	0	22307	\N
10244	73	0	0	22353	\N
10245	1696	5	0	22362	\N
10161	149	2	0	23255	\N
10161	697	3	0	23256	\N
10207	82	2	0	23687	\N
10207	343	3	0	23688	\N
10248	140	6	0	24171	\N
10248	1730	7	0	24172	\N
10286	140	4	0	24186	\N
10286	1661	5	0	24189	\N
10171	69	2	0	24578	\N
10171	500	3	0	24582	\N
10209	69	3	0	24584	\N
10253	49	18	0	24975	\N
10253	2457	19	0	24976	\N
10249	411	2	0	25327	\N
10249	582	3	0	25328	\N
10156	224	4	0	25390	\N
10156	994	5	0	25392	\N
10219	206	2	0	25891	\N
10219	693	3	0	25893	\N
10221	94	2	0	26838	\N
10319	94	2	0	26839	\N
10221	95	3	0	26841	\N
10319	95	3	0	26842	\N
10223	320	61	0	29360	\N
10223	2447	62	0	29392	\N
10255	54	2	0	30201	\N
10255	485	3	0	30203	\N
10215	20	2	0	30621	\N
10215	702	3	0	30622	\N
10232	20	3	0	30623	\N
10232	2451	4	0	30628	\N
10224	322	6	0	32491	\N
10224	1633	7	0	32494	\N
10264	322	2	0	32497	\N
10264	833	3	0	32498	\N
10227	53	2	0	34725	\N
10242	1	4	0	34727	\N
10242	422	5	0	34728	\N
10262	1	4	0	34730	\N
10262	422	5	0	34732	\N
10177	2	0	0	35816	\N
10225	2	8	0	35819	\N
10225	2151	9	0	35820	\N
10206	6	2	0	36197	\N
10206	179	3	0	36200	\N
10150	10	2	0	38922	\N
10150	29	3	0	38924	\N
10282	465	12	0	38930	\N
10310	10	3	0	38932	\N
10310	347	4	0	38934	\N
10269	40	2	0	43413	\N
10269	66	3	0	43414	\N
10346	56	2	0	44030	\N
10346	169	3	0	44031	\N
10382	56	3	0	44034	\N
10382	676	4	0	44035	\N
10474	56	2	0	44038	\N
10474	169	3	0	44039	\N
10396	75	3	0	45568	\N
10477	75	5	0	45569	\N
10396	857	4	0	45572	\N
10477	2046	6	0	45576	\N
10360	88	2	0	47031	\N
10360	154	3	0	47036	\N
10454	103	1	0	47988	\N
10454	102	14	0	48004	\N
10454	2516	15	0	48008	\N
10392	113	2	0	48482	\N
10392	114	3	0	48483	\N
10388	121	3	0	48846	\N
10388	2317	4	0	48853	\N
10278	2464	9	1	50144	\N
10278	407	2	0	50277	\N
10278	156	8	0	50291	\N
10449	398	1	0	50784	\N
10421	170	12	0	50793	\N
10449	170	14	0	50795	\N
10421	2508	13	0	50798	\N
10449	2508	15	0	50799	\N
10284	242	3	0	52330	\N
10284	1135	4	0	52331	\N
10413	2505	4	1	53165	\N
10413	473	1	0	53338	\N
10294	279	5	0	53339	\N
10413	279	3	0	53341	\N
10294	2469	6	0	53342	\N
10460	285	5	0	53361	\N
10460	2526	6	0	53364	\N
10278	2368	9	0	54493	\N
10427	353	15	0	54526	\N
10427	2420	16	0	54529	\N
10354	597	2	0	56068	\N
10354	767	3	0	56073	\N
10313	1109	3	0	56136	\N
10313	1683	4	0	56138	\N
10401	852	3	0	57181	\N
10401	1068	4	0	57182	\N
10301	266	3	0	1140	\N
10373	2489	1	0	1726	\N
10373	2491	2	0	1730	\N
10493	117	22	0	2200	\N
10339	110	2	0	2402	\N
10339	111	3	0	2405	\N
10367	1214	2	0	2408	\N
10367	110	6	0	2418	\N
10367	905	7	0	2419	\N
10379	262	6	0	3677	\N
10379	2495	7	0	3680	\N
10371	365	2	0	4709	\N
10371	519	3	0	4711	\N
10380	539	5	0	10896	\N
10420	300	12	0	12207	\N
10420	2418	13	0	12208	\N
10405	123	6	0	12964	\N
10405	2500	7	0	12965	\N
10322	2480	5	0	12977	\N
10322	77	4	0	13008	\N
10483	58	9	0	13433	\N
10483	2533	10	0	13434	\N
10238	2454	15	0	15514	\N
10397	235	2	0	15887	\N
10397	1061	3	0	15888	\N
10402	399	2	0	16245	\N
10472	167	2	0	17917	\N
10342	168	3	0	17921	\N
10472	168	3	0	17922	\N
10385	290	2	0	18846	\N
10391	290	4	0	18847	\N
10385	575	3	0	18851	\N
10391	695	5	0	18853	\N
10322	2067	5	1	19337	\N
10351	198	4	0	20279	\N
10351	2484	5	0	20282	\N
10328	64	5	0	20922	\N
10376	488	5	0	21395	\N
10376	2492	6	0	21397	\N
10278	2465	10	0	22021	\N
10243	73	0	0	22352	\N
10356	336	0	0	22887	\N
10358	336	0	0	22889	\N
10363	336	0	0	22892	\N
10263	214	4	0	24312	\N
10263	649	5	0	24319	\N
10307	69	6	0	24585	\N
10307	2473	7	0	24590	\N
10486	69	2	0	24594	\N
10413	2504	4	0	24943	\N
10390	49	3	0	24981	\N
10390	1913	4	0	24982	\N
10404	1171	2	0	26275	\N
10404	2499	3	0	26276	\N
10415	86	5	0	26533	\N
10415	2507	6	0	26542	\N
10406	42	2	0	27714	\N
10406	681	3	0	27715	\N
10348	16	2	0	28323	\N
10348	155	3	0	28326	\N
10479	54	2	0	30234	\N
10270	33	2	0	31659	\N
10270	34	3	0	31661	\N
10333	33	7	0	31665	\N
10333	2483	8	0	31666	\N
10258	230	5	0	32007	\N
10258	2458	6	0	32008	\N
10464	453	0	0	32612	\N
10469	1	4	0	33116	\N
10469	422	5	0	33117	\N
10288	1	4	0	34735	\N
10288	422	5	0	34738	\N
10412	53	1	0	34743	\N
10412	1	3	0	34746	\N
10366	422	5	0	34748	\N
10423	1	2	0	34750	\N
10429	1	2	0	34751	\N
10423	112	3	0	34752	\N
10429	112	3	0	34753	\N
10426	6	2	0	36199	\N
10426	179	3	0	36201	\N
10462	10	5	0	36636	\N
10462	1298	6	0	36644	\N
10489	10	2	0	36651	\N
10489	29	3	0	36653	\N
10352	600	5	0	38947	\N
10403	10	2	0	38949	\N
10403	29	3	0	38950	\N
10419	10	2	0	38953	\N
10419	29	3	0	38954	\N
10295	18	5	0	39942	\N
10295	2342	6	0	39945	\N
10414	18	7	0	39949	\N
10414	2506	8	0	39952	\N
10467	23	9	0	40864	\N
10467	2155	10	0	40868	\N
10369	2486	2	0	41107	\N
10369	1270	7	0	41126	\N
10480	40	6	0	41674	\N
10480	522	7	0	41681	\N
10266	40	8	0	43412	\N
10266	2461	9	0	43415	\N
10290	40	3	0	43418	\N
10290	564	4	0	43419	\N
10315	40	6	0	43425	\N
10315	522	7	0	43427	\N
10330	40	5	0	43428	\N
10330	2192	6	0	43429	\N
10394	40	2	0	43432	\N
10394	66	3	0	43434	\N
10289	56	3	0	44026	\N
10289	475	4	0	44028	\N
10418	56	3	0	44036	\N
10432	56	3	0	44037	\N
10418	475	4	0	44040	\N
10432	475	4	0	44041	\N
10505	71	9	0	44904	\N
10505	2538	10	0	44908	\N
10332	79	6	0	46603	\N
10332	2340	7	0	46604	\N
10448	103	1	0	47985	\N
10448	102	14	0	48001	\N
10448	2516	15	0	48007	\N
10316	119	5	0	48583	\N
10316	2476	6	0	48584	\N
10285	119	3	0	48771	\N
10285	129	4	0	48773	\N
10317	2477	9	0	48799	\N
10317	121	10	0	48805	\N
10334	121	3	0	48830	\N
10334	1346	4	0	48831	\N
10532	121	4	0	48848	\N
10532	2550	5	0	48854	\N
10466	125	9	0	49128	\N
10466	2528	10	0	49131	\N
10279	1817	2	0	49383	\N
10279	2467	10	1	49384	\N
10279	135	8	0	49401	\N
10353	147	2	0	50117	\N
10353	516	3	0	50122	\N
10450	398	1	0	50785	\N
10471	170	2	0	50794	\N
10450	170	14	0	50796	\N
10471	718	3	0	50797	\N
10450	2508	15	0	50800	\N
10521	181	4	0	51048	\N
10521	856	5	0	51050	\N
10279	2368	9	0	54491	\N
10529	435	4	0	55033	\N
10529	2180	5	0	55038	\N
10459	584	1	0	55449	\N
10459	451	14	0	55467	\N
10459	2521	15	0	55472	\N
10514	1109	6	0	56137	\N
10514	2238	7	0	56139	\N
10387	1395	127	1	57836	\N
10279	2435	9	1	57958	\N
10400	266	2	0	1141	\N
10400	1711	3	0	1143	\N
10410	2442	6	0	1145	\N
10372	2489	2	0	1725	\N
10372	2490	3	0	1731	\N
10303	819	2	0	1825	\N
10303	820	3	0	1826	\N
10274	117	3	0	2192	\N
10274	118	4	0	2193	\N
10492	117	22	0	2199	\N
10492	2535	23	0	2204	\N
10340	110	3	0	2403	\N
10340	905	4	0	2407	\N
10433	1708	5	0	2417	\N
10534	228	2	0	2965	\N
10534	511	3	0	2966	\N
10516	262	2	0	3678	\N
10516	731	3	0	3679	\N
10441	35	2	0	4321	\N
10441	36	3	0	4325	\N
10485	365	2	0	4717	\N
10485	519	3	0	4719	\N
10273	373	2	0	5340	\N
10273	1504	3	0	5341	\N
10267	108	2	0	11909	\N
10279	2466	10	0	11933	\N
10261	1046	5	0	14822	\N
10387	2497	127	0	15255	\N
10387	2496	10	0	15515	\N
10386	192	2	0	15516	\N
10386	838	3	0	15517	\N
10387	192	126	0	15518	\N
10446	115	10	0	16869	\N
10446	2513	11	0	16872	\N
10501	326	2	0	17495	\N
10501	747	3	0	17497	\N
10438	142	4	0	18450	\N
10275	64	8	0	20920	\N
10275	2462	9	0	20921	\N
10323	164	4	0	20932	\N
10323	1582	5	0	20934	\N
10279	2465	11	0	22022	\N
10381	145	4	0	22024	\N
10381	2316	5	0	22025	\N
10357	336	2	0	22888	\N
10361	336	0	0	22890	\N
10362	336	0	0	22891	\N
10510	336	2	0	22894	\N
10357	740	3	0	22896	\N
10499	264	11	0	23407	\N
10499	2537	12	0	23415	\N
10308	69	5	0	24586	\N
10308	2474	6	0	24589	\N
10539	224	3	0	25397	\N
10539	2551	4	0	25399	\N
10545	86	4	0	26535	\N
10545	1592	5	0	26541	\N
10526	244	8	0	27214	\N
10526	2546	9	0	27218	\N
10331	16	2	0	28320	\N
10331	155	3	0	28321	\N
10542	155	3	0	28328	\N
10347	449	2	0	29941	\N
10347	583	3	0	29942	\N
10341	202	2	0	30961	\N
10341	812	3	0	30962	\N
10465	453	7	0	32613	\N
10465	2527	8	0	32616	\N
10504	453	2	0	32621	\N
10504	902	3	0	32622	\N
10461	1	5	0	33112	\N
10461	1233	6	0	33113	\N
10296	1	2	0	34739	\N
10443	4	3	0	35833	\N
10443	1538	4	0	35834	\N
10476	10	5	0	36650	\N
10476	2042	6	0	36655	\N
10314	10	3	0	38935	\N
10324	10	2	0	38936	\N
10324	29	3	0	38937	\N
10314	297	4	0	38938	\N
10329	10	5	0	38939	\N
10329	1645	6	0	38942	\N
10395	10	2	0	38945	\N
10395	29	3	0	38946	\N
10411	29	3	0	38952	\N
10497	14	11	0	39009	\N
10497	666	12	0	39018	\N
10368	2486	2	0	41106	\N
10368	27	6	0	41123	\N
10368	1270	7	0	41125	\N
10422	40	12	0	43360	\N
10422	869	13	0	43361	\N
10271	40	2	0	43416	\N
10271	66	3	0	43417	\N
10293	40	5	0	43420	\N
10293	522	6	0	43423	\N
10344	40	6	0	43431	\N
10399	40	2	0	43433	\N
10399	66	3	0	43435	\N
10344	522	7	0	43437	\N
10377	56	9	0	44032	\N
10377	2493	10	0	44033	\N
10507	56	9	0	44042	\N
10507	2540	10	0	44043	\N
10350	75	4	0	45567	\N
10350	172	5	0	45574	\N
10312	79	3	0	46550	\N
10312	1168	4	0	46551	\N
10393	79	2	0	46647	\N
10393	80	3	0	46648	\N
10512	79	2	0	46710	\N
10512	80	3	0	46715	\N
10453	2518	15	1	47762	\N
10453	103	1	0	47987	\N
10453	102	14	0	48003	\N
10531	102	4	0	48017	\N
10531	2549	5	0	48018	\N
10283	119	2	0	48770	\N
10283	891	3	0	48772	\N
10272	121	2	0	48797	\N
10272	625	3	0	48798	\N
10389	121	2	0	48847	\N
10389	2498	3	0	48852	\N
10488	156	2	0	50151	\N
10488	571	3	0	50156	\N
10338	181	4	0	51034	\N
10338	856	5	0	51036	\N
10431	200	3	0	51468	\N
10431	219	4	0	51469	\N
10458	2525	5	0	53347	\N
10458	2526	6	0	53348	\N
10453	2100	16	0	54729	\N
10456	584	1	0	55448	\N
10456	451	14	0	55466	\N
10456	2521	15	0	55471	\N
10355	595	2	0	55754	\N
10355	768	3	0	55755	\N
10384	841	2	0	56919	\N
10384	1161	3	0	56920	\N
10453	2435	15	0	57963	\N
10365	1470	4	0	58135	\N
10365	2485	5	0	58136	\N
10496	1470	11	0	58137	\N
10496	1896	12	0	58138	\N
10453	2519	16	1	58542	\N
10374	2489	2	0	1727	\N
10265	365	8	0	4686	\N
10265	2460	9	0	4688	\N
10306	365	6	0	4703	\N
10306	2472	7	0	4705	\N
10370	2488	2	0	4708	\N
10370	519	3	0	4710	\N
10425	189	4	0	4750	\N
10425	849	5	0	4751	\N
10416	391	5	0	10895	\N
10416	1511	6	0	10897	\N
10520	391	2	0	10900	\N
10520	406	3	0	10901	\N
10428	132	15	0	11081	\N
10407	133	3	0	11082	\N
10428	2509	16	0	11083	\N
10364	459	2	0	11941	\N
10364	1796	3	0	11942	\N
10337	123	2	0	12961	\N
10337	384	3	0	12963	\N
10287	173	4	0	14821	\N
10287	1046	5	0	14823	\N
10277	180	2	0	15191	\N
10311	92	4	0	15202	\N
10277	92	8	0	15204	\N
10277	2463	9	0	15206	\N
10447	2514	74	0	16866	\N
10447	115	126	0	16873	\N
10447	2515	127	0	16874	\N
10321	164	4	0	20931	\N
10528	73	4	0	22357	\N
10528	1696	5	0	22363	\N
10299	149	7	0	23273	\N
10299	2470	8	0	23275	\N
10518	214	2	0	24314	\N
10518	227	3	0	24317	\N
10445	69	10	0	24587	\N
10370	2487	2	0	24930	\N
10494	206	22	0	25899	\N
10494	2536	23	0	25900	\N
10482	94	6	0	26846	\N
10482	2018	7	0	26847	\N
10408	244	4	0	27203	\N
10408	2501	5	0	27204	\N
10435	16	2	0	28324	\N
10435	155	3	0	28327	\N
10359	54	2	0	30209	\N
10359	485	3	0	30210	\N
10478	54	2	0	30233	\N
10503	20	2	0	30624	\N
10503	702	3	0	30626	\N
10378	151	6	0	30873	\N
10378	2494	7	0	30874	\N
10440	151	5	0	30875	\N
10440	2511	6	0	30876	\N
10509	360	2	0	31278	\N
10509	510	3	0	31281	\N
10541	1	2	0	33135	\N
10541	112	3	0	33137	\N
10281	1	2	0	34733	\N
10281	112	3	0	34734	\N
10292	48	4	0	34737	\N
10349	1	2	0	34740	\N
10349	112	3	0	34742	\N
10409	1	5	0	34745	\N
10409	1233	6	0	34749	\N
10524	431	4	0	34795	\N
10524	1031	5	0	34796	\N
10548	431	5	0	34797	\N
10327	2	4	0	35821	\N
10327	2481	5	0	35822	\N
10343	2	2	0	35823	\N
10437	2	4	0	35824	\N
10437	315	5	0	35826	\N
10326	6	4	0	36198	\N
10326	670	5	0	36202	\N
10473	10	3	0	36638	\N
10473	465	4	0	36642	\N
10536	10	2	0	36660	\N
10536	29	3	0	36661	\N
10298	10	2	0	38931	\N
10298	29	3	0	38933	\N
10345	10	6	0	38940	\N
10345	426	7	0	38941	\N
10383	10	2	0	38944	\N
10300	14	3	0	38999	\N
10300	306	4	0	39001	\N
10375	18	1	0	39947	\N
10398	18	2	0	39948	\N
10375	19	2	0	39950	\N
10398	218	3	0	39951	\N
10513	40	4	0	41676	\N
10513	564	5	0	41679	\N
816	56	1	0	43689	\N
10430	397	4	0	44907	\N
10540	75	2	0	45583	\N
10540	159	3	0	45584	\N
10470	79	19	0	46678	\N
10470	2530	20	0	46682	\N
10543	79	2	0	46711	\N
10543	80	3	0	46716	\N
10452	2517	15	0	47760	\N
10452	103	1	0	47986	\N
10487	102	2	0	48000	\N
10452	102	14	0	48002	\N
10487	158	3	0	48006	\N
10522	156	4	0	50152	\N
10522	2543	5	0	50159	\N
10627	200	3	0	51478	\N
10627	2565	4	0	51479	\N
10623	242	6	0	52053	\N
10623	1630	7	0	52057	\N
10506	273	9	0	53100	\N
10506	2539	10	0	53104	\N
10610	353	4	0	54534	\N
10610	1570	5	0	54543	\N
10452	2100	15	1	54730	\N
10535	435	2	0	55034	\N
10535	481	3	0	55036	\N
10455	584	1	0	55447	\N
10455	451	14	0	55465	\N
10625	1109	2	0	56148	\N
10625	1412	3	0	56152	\N
10481	1021	6	0	56390	\N
10481	1558	7	0	56398	\N
10321	2479	5	1	59119	\N
10562	289	3	0	156	\N
10455	2520	15	1	1125	\N
10484	251	9	0	1397	\N
10484	2534	10	0	1401	\N
10592	2561	4	0	1636	\N
10592	2562	5	0	1637	\N
10434	117	2	0	2198	\N
10434	175	3	0	2202	\N
10493	2535	23	0	2205	\N
10519	2541	2	0	3015	\N
10519	2542	3	0	3016	\N
10442	35	3	0	4322	\N
10442	1499	4	0	4326	\N
10665	373	2	0	5344	\N
10586	391	2	0	10909	\N
10586	406	3	0	10910	\N
10650	391	2	0	10920	\N
10650	406	3	0	10922	\N
10495	123	1	0	12966	\N
10495	124	2	0	12967	\N
10608	58	2	0	13437	\N
10608	665	3	0	13439	\N
10560	1157	2	0	14006	\N
10560	2560	3	0	14007	\N
10530	402	4	0	14241	\N
10582	1148	2	0	14243	\N
10582	402	3	0	14249	\N
10663	258	2	0	14351	\N
10663	585	3	0	14354	\N
10457	2523	6	0	14824	\N
10457	2524	7	0	14825	\N
10558	2558	10	0	15519	\N
10558	192	126	0	15522	\N
10558	2559	127	0	15523	\N
10617	192	2	0	15525	\N
10617	838	3	0	15528	\N
10619	38	2	0	16251	\N
10538	115	2	0	16870	\N
10538	636	3	0	16871	\N
10552	198	7	0	20289	\N
10552	2555	8	0	20293	\N
10523	2544	4	0	20617	\N
10523	2545	5	0	20621	\N
10636	164	3	0	20944	\N
10636	307	4	0	20945	\N
10527	73	39	0	22356	\N
10527	2547	40	0	22364	\N
10508	336	1	0	22893	\N
10508	356	2	0	22895	\N
10589	264	0	0	23408	\N
10498	2537	12	0	23414	\N
10642	82	2	0	23691	\N
10642	343	3	0	23694	\N
10517	214	2	0	24313	\N
10517	227	3	0	24316	\N
10490	69	11	0	24595	\N
10490	1166	12	0	24601	\N
10502	411	4	0	25335	\N
10502	1665	5	0	25336	\N
10546	90	2	0	26208	\N
10546	91	3	0	26212	\N
10544	509	3	0	26538	\N
10554	42	2	0	27731	\N
10554	681	3	0	27732	\N
10637	359	3	0	28335	\N
10637	16	8	0	28339	\N
10637	1529	9	0	28341	\N
10475	449	3	0	29758	\N
10475	2531	4	0	29759	\N
10439	54	3	0	30222	\N
10439	476	4	0	30223	\N
10644	54	4	0	30245	\N
10644	2570	5	0	30246	\N
10651	1510	5	0	30881	\N
10511	360	2	0	31279	\N
10511	510	3	0	31282	\N
10525	1	8	0	33122	\N
10525	1982	9	0	33123	\N
10537	1	2	0	33126	\N
10537	112	3	0	33127	\N
10547	1	5	0	33136	\N
10547	2052	6	0	33139	\N
10601	1	2	0	33153	\N
10615	1	2	0	33155	\N
10601	112	3	0	33157	\N
10656	1	4	0	33178	\N
10656	422	5	0	33180	\N
10634	6	2	0	36205	\N
10634	179	3	0	36206	\N
10451	11	1	0	36628	\N
10444	10	3	0	36635	\N
10468	10	9	0	36637	\N
10451	10	14	0	36639	\N
10444	347	4	0	36640	\N
10468	2529	10	0	36641	\N
10451	465	15	0	36643	\N
10533	600	4	0	36645	\N
10533	10	6	0	36654	\N
10533	1416	7	0	36656	\N
10463	998	6	0	36657	\N
10596	10	4	0	36690	\N
10596	600	5	0	36692	\N
10436	10	2	0	38955	\N
10436	29	3	0	38956	\N
10500	40	11	0	41675	\N
10515	40	6	0	41677	\N
10549	40	5	0	41678	\N
10549	2192	6	0	41680	\N
10515	522	7	0	41682	\N
10630	40	2	0	41759	\N
10659	40	4	0	41760	\N
10630	66	3	0	41762	\N
10659	564	5	0	41764	\N
1060	56	16	0	43696	\N
10669	677	6	0	44047	\N
10714	56	2	0	44048	\N
10722	56	6	0	44049	\N
10714	169	3	0	44050	\N
10722	2588	7	0	44051	\N
10744	56	2	0	44052	\N
10744	169	3	0	44053	\N
10568	75	2	0	45599	\N
10604	75	2	0	45601	\N
10703	75	2	0	45602	\N
10568	159	3	0	45609	\N
10604	159	3	0	45611	\N
10703	159	3	0	45612	\N
10633	102	3	0	48023	\N
10633	1388	4	0	48031	\N
10675	125	2	0	49138	\N
10675	188	3	0	49139	\N
10717	147	2	0	50118	\N
10717	516	3	0	50123	\N
10648	170	2	0	50494	\N
10648	718	3	0	50496	\N
10621	181	4	0	51049	\N
10621	856	5	0	51051	\N
10715	273	2	0	53101	\N
10715	1159	3	0	53103	\N
10728	362	2	0	54751	\N
10728	420	3	0	54752	\N
10719	597	2	0	56069	\N
10719	767	3	0	56074	\N
10725	1971	127	1	56901	\N
10600	852	2	0	57193	\N
10600	1325	3	0	57196	\N
10730	2595	2	0	59219	\N
10742	288	4	0	158	\N
10701	2583	10	0	2339	\N
10572	110	2	0	2412	\N
10572	111	3	0	2415	\N
10566	367	2	0	3546	\N
10566	651	3	0	3547	\N
10689	262	5	0	3692	\N
10689	2577	6	0	3693	\N
10701	2582	9	1	4077	\N
10694	222	0	0	5251	\N
10665	1504	3	0	5351	\N
10595	391	4	0	10916	\N
10595	539	5	0	10917	\N
10745	133	3	0	11089	\N
10570	77	2	0	13009	\N
10570	216	3	0	13010	\N
10697	233	8	0	13717	\N
10697	2580	9	0	13719	\N
10618	796	37	1	14016	\N
10755	258	0	0	14352	\N
10638	2567	2	0	14828	\N
10638	480	3	0	14829	\N
10691	173	2	0	14830	\N
10691	480	3	0	14832	\N
10734	92	2	0	15211	\N
10618	2564	37	0	15253	\N
10618	2563	10	0	15524	\N
10618	192	36	0	15531	\N
10658	212	4	0	17278	\N
10658	1568	5	0	17279	\N
10699	326	8	0	17510	\N
10700	326	8	0	17511	\N
10701	326	8	0	17512	\N
10705	326	9	0	17513	\N
10699	2581	9	0	17514	\N
10700	2581	9	0	17515	\N
10705	2585	10	0	17516	\N
10701	2260	9	0	17948	\N
10721	177	6	0	18311	\N
10721	2587	7	0	18318	\N
10760	1815	4	0	19332	\N
10760	2597	5	0	19335	\N
10712	62	2	0	19698	\N
10712	683	3	0	19701	\N
10653	164	4	0	20958	\N
10653	1582	5	0	20959	\N
10764	145	2	0	22027	\N
10764	331	3	0	22028	\N
10551	2553	32	0	22365	\N
10551	2554	44	0	22375	\N
10725	2590	127	0	23022	\N
10725	2589	23	0	23276	\N
10723	149	2	0	23284	\N
10723	697	3	0	23286	\N
10725	149	126	0	23288	\N
10687	264	0	0	23410	\N
10707	90	2	0	26209	\N
10707	91	3	0	26213	\N
10686	86	3	0	26536	\N
10686	2576	4	0	26539	\N
10666	94	2	0	26853	\N
10674	42	4	0	27737	\N
10674	2139	5	0	27738	\N
10550	449	2	0	29766	\N
10550	583	3	0	29767	\N
10643	54	30	0	30247	\N
10643	2569	31	0	30248	\N
10662	54	0	0	30261	\N
10638	2566	2	0	30319	\N
10749	151	3	0	30878	\N
10749	152	4	0	30880	\N
10704	322	4	0	32499	\N
10704	1616	5	0	32500	\N
10671	523	7	0	33181	\N
10681	1	2	0	33190	\N
10726	1	7	0	33191	\N
10681	112	3	0	33192	\N
10726	1247	8	0	33193	\N
10548	2552	6	0	34800	\N
10611	2	4	0	35123	\N
10611	315	5	0	35124	\N
10769	4	4	0	35839	\N
10769	684	5	0	35840	\N
10561	10	2	0	36664	\N
10561	29	3	0	36665	\N
10575	347	4	0	36671	\N
10578	10	6	0	36676	\N
10578	426	7	0	36677	\N
10581	10	2	0	36680	\N
10581	29	3	0	36682	\N
10677	10	2	0	36713	\N
10677	29	3	0	36715	\N
10695	10	5	0	36721	\N
10695	2579	6	0	36722	\N
10696	10	3	0	36727	\N
10696	347	4	0	36728	\N
10708	10	2	0	36731	\N
10727	10	9	0	36735	\N
10727	2591	10	0	36740	\N
10737	10	4	0	36743	\N
10737	600	5	0	36744	\N
10724	23	2	0	40865	\N
10724	24	3	0	40866	\N
10597	40	2	0	41714	\N
10597	66	3	0	41715	\N
10626	40	2	0	41728	\N
10628	40	2	0	41729	\N
10626	66	3	0	41731	\N
10628	66	3	0	41732	\N
10683	66	3	0	41763	\N
10716	40	2	0	41785	\N
10716	66	3	0	41792	\N
1179	56	2	0	43698	\N
10752	2230	8	0	44055	\N
10761	56	4	0	44056	\N
10761	1145	5	0	44059	\N
10824	75	3	0	45605	\N
10824	857	4	0	45616	\N
10803	79	4	0	46713	\N
10803	589	5	0	46718	\N
10635	102	2	0	48024	\N
10690	102	2	0	48025	\N
10635	158	3	0	48029	\N
10690	158	3	0	48030	\N
10777	119	1	0	48616	\N
10710	156	2	0	50153	\N
10710	571	3	0	50157	\N
10753	279	6	0	53340	\N
10753	2469	7	0	53343	\N
10580	353	2	0	54527	\N
10580	755	3	0	54528	\N
10574	435	3	0	55035	\N
10574	1456	4	0	55037	\N
10668	435	5	0	55039	\N
10668	2573	6	0	55044	\N
10758	451	2	0	55159	\N
10758	452	3	0	55160	\N
10606	451	2	0	55489	\N
10606	452	3	0	55490	\N
10757	1021	2	0	56391	\N
10757	1048	3	0	56395	\N
10577	852	2	0	57191	\N
10577	1325	3	0	57192	\N
10834	1470	4	0	58151	\N
10834	2485	5	0	58152	\N
10645	2351	4	0	58911	\N
10645	2571	5	0	58912	\N
10740	433	3	0	223	\N
10702	828	3	0	1400	\N
10672	110	6	0	2432	\N
10672	736	7	0	2440	\N
10652	228	4	0	2968	\N
10652	1631	5	0	2970	\N
10731	367	2	0	3366	\N
10800	367	5	0	3367	\N
10731	651	3	0	3368	\N
10800	386	6	0	3369	\N
10751	262	3	0	3705	\N
10751	1305	4	0	3707	\N
10747	35	2	0	4329	\N
10563	391	4	0	10908	\N
10563	539	5	0	10911	\N
10817	391	3	0	10940	\N
10817	581	4	0	10945	\N
10770	108	4	0	11827	\N
10771	108	4	0	11828	\N
10770	669	5	0	11829	\N
10771	669	5	0	11830	\N
10698	233	8	0	13718	\N
10698	2580	9	0	13720	\N
10557	192	4	0	15520	\N
10557	941	5	0	15521	\N
10647	575	3	0	18863	\N
10565	60	2	0	19657	\N
10565	166	3	0	19658	\N
10713	62	2	0	19699	\N
10713	683	3	0	19702	\N
10599	241	2	0	20554	\N
10599	281	3	0	20555	\N
10706	241	9	0	20564	\N
10706	2586	10	0	20566	\N
10790	64	5	0	20916	\N
10790	2096	6	0	20917	\N
10553	73	7	0	22370	\N
10590	264	4	0	23409	\N
10688	264	2	0	23411	\N
10688	265	3	0	23412	\N
10590	2137	5	0	23413	\N
10661	140	2	0	24187	\N
10661	487	3	0	24188	\N
10602	214	2	0	24315	\N
10602	227	3	0	24318	\N
10775	69	5	0	24596	\N
10775	2474	6	0	24600	\N
10609	49	2	0	24991	\N
10609	328	3	0	24992	\N
10783	994	5	0	25407	\N
10567	206	2	0	25904	\N
10567	693	3	0	25909	\N
10750	86	3	0	26537	\N
10750	2596	4	0	26540	\N
10616	94	2	0	26852	\N
10616	95	3	0	26854	\N
10849	94	6	0	26856	\N
10849	2614	7	0	26857	\N
10620	16	4	0	28338	\N
10620	380	5	0	28340	\N
10657	16	4	0	28344	\N
10685	16	3	0	28348	\N
10685	2575	4	0	28349	\N
10743	155	2	0	28354	\N
10743	16	4	0	28356	\N
10743	17	5	0	28358	\N
10664	54	2	0	30259	\N
10664	485	3	0	30260	\N
10772	202	4	0	30975	\N
10772	1149	5	0	30977	\N
10819	202	2	0	30987	\N
10819	812	3	0	30992	\N
10793	230	5	0	31999	\N
10837	453	9	0	32629	\N
10837	2609	10	0	32630	\N
10583	112	2	0	33128	\N
10583	1	3	0	33138	\N
10676	1	2	0	33184	\N
10678	1	2	0	33185	\N
10676	112	3	0	33186	\N
10678	112	3	0	33187	\N
10738	1	2	0	33198	\N
10738	112	3	0	33200	\N
10774	1	4	0	33208	\N
10774	422	5	0	33209	\N
10846	112	3	0	33222	\N
10765	431	4	0	34798	\N
10765	1031	5	0	34799	\N
10569	10	2	0	36668	\N
10569	29	3	0	36670	\N
10594	10	2	0	36686	\N
10594	29	3	0	36687	\N
10632	10	3	0	36698	\N
10632	297	4	0	36699	\N
10640	10	3	0	36702	\N
10640	2568	4	0	36703	\N
10654	10	0	0	36709	\N
10680	29	3	0	36716	\N
10735	10	2	0	36736	\N
10735	29	3	0	36738	\N
10766	10	4	0	36749	\N
10787	10	3	0	36751	\N
10787	347	4	0	36753	\N
10766	600	5	0	36754	\N
10585	218	2	0	39953	\N
10585	18	3	0	39955	\N
10555	40	9	0	41697	\N
10587	40	2	0	41699	\N
10587	66	3	0	41701	\N
10613	40	2	0	41727	\N
10613	66	3	0	41730	\N
1786	56	5	0	43701	\N
10571	169	3	0	44046	\N
10660	71	1	0	44905	\N
10660	72	2	0	44906	\N
10603	75	2	0	45600	\N
10732	75	2	0	45603	\N
10767	75	4	0	45604	\N
10603	159	3	0	45610	\N
10732	159	3	0	45613	\N
10767	172	5	0	45617	\N
10748	79	3	0	46712	\N
10748	272	4	0	46717	\N
10798	88	2	0	47032	\N
10798	154	3	0	47037	\N
10777	120	2	0	48617	\N
10754	125	2	0	49148	\N
10754	188	3	0	49149	\N
10844	125	6	0	49159	\N
10844	2341	7	0	49166	\N
10746	156	2	0	50154	\N
10746	571	3	0	50158	\N
10655	260	4	0	52526	\N
10655	538	5	0	52527	\N
10629	451	1	0	55499	\N
10631	451	2	0	55500	\N
10629	584	2	0	55501	\N
10631	452	3	0	55502	\N
10718	595	2	0	55789	\N
10718	768	3	0	55790	\N
10564	1470	2	0	58139	\N
10564	1565	3	0	58140	\N
10833	1470	6	0	58147	\N
10833	2608	7	0	58148	\N
10693	2578	0	0	58578	\N
10739	433	3	0	222	\N
10573	905	4	0	2416	\N
10673	110	8	0	2433	\N
10673	2574	9	0	2441	\N
10741	228	4	0	2969	\N
10741	1631	5	0	2971	\N
10711	189	2	0	4762	\N
10711	311	3	0	4763	\N
10605	373	2	0	5342	\N
10605	1504	3	0	5343	\N
10682	391	2	0	10921	\N
10682	406	3	0	10923	\N
10778	391	3	0	10934	\N
10841	391	7	0	10943	\N
10841	2611	8	0	10947	\N
10692	528	2	0	12387	\N
10692	613	3	0	12388	\N
10816	528	10	0	12393	\N
10816	2606	11	0	12394	\N
10588	233	2	0	13709	\N
10588	910	3	0	13710	\N
10759	233	4	0	13723	\N
10759	1689	5	0	13738	\N
10776	173	5	0	14831	\N
10776	2098	6	0	14833	\N
10828	2607	5	0	15214	\N
10851	92	2	0	15215	\N
10851	93	3	0	15216	\N
10667	235	5	0	15902	\N
10667	2572	6	0	15907	\N
10729	2592	2	0	15927	\N
10729	2593	3	0	15930	\N
10814	115	2	0	16885	\N
10814	636	3	0	16886	\N
10679	212	2	0	17280	\N
10679	566	3	0	17281	\N
10831	167	2	0	17918	\N
10649	290	2	0	18862	\N
10649	575	3	0	18864	\N
10709	290	1	0	18872	\N
10709	291	2	0	18873	\N
10639	198	2	0	20290	\N
10639	746	3	0	20291	\N
10789	281	2	0	20556	\N
10789	241	3	0	20565	\N
10808	149	3	0	23285	\N
10808	150	4	0	23287	\N
10809	2604	23	0	23289	\N
10809	149	126	0	23297	\N
10756	264	2	0	23426	\N
10756	265	3	0	23427	\N
10823	82	3	0	23700	\N
10823	810	4	0	23702	\N
10670	140	6	0	24199	\N
10670	1730	7	0	24211	\N
10786	69	3	0	24608	\N
10786	594	4	0	24615	\N
10559	49	2	0	24985	\N
10559	328	3	0	24986	\N
10598	94	2	0	26850	\N
10598	95	3	0	26851	\N
10784	244	126	0	27219	\N
10784	2599	127	0	27220	\N
10802	2603	112	0	27221	\N
10802	244	126	0	27225	\N
10802	2599	127	0	27226	\N
10576	16	2	0	28331	\N
10612	16	2	0	28332	\N
10576	155	3	0	28333	\N
10612	155	3	0	28334	\N
10684	16	2	0	28345	\N
10684	155	3	0	28346	\N
10720	16	2	0	28350	\N
10733	16	3	0	28352	\N
10733	359	4	0	28353	\N
10614	20	3	0	30625	\N
10614	1931	4	0	30627	\N
10773	202	4	0	30976	\N
10773	1149	5	0	30978	\N
10579	360	2	0	31280	\N
10579	510	3	0	31283	\N
10836	453	10	0	32628	\N
10836	1452	11	0	32631	\N
10593	1	2	0	33152	\N
10607	1	2	0	33154	\N
10607	112	3	0	33158	\N
10624	1	2	0	33164	\N
10624	112	3	0	33165	\N
10641	1	2	0	33170	\N
10641	112	3	0	33171	\N
10763	1	2	0	33199	\N
10763	112	3	0	33201	\N
10768	1	2	0	33204	\N
10768	283	3	0	33205	\N
10782	1	4	0	33212	\N
10782	422	5	0	33215	\N
10591	10	4	0	36681	\N
10622	10	6	0	36691	\N
10622	426	7	0	36693	\N
10646	10	2	0	36708	\N
10646	29	3	0	36710	\N
10736	10	4	0	36737	\N
10736	600	5	0	36739	\N
10805	10	2	0	36765	\N
10805	29	3	0	36766	\N
10762	18	4	0	39954	\N
10762	590	5	0	39956	\N
10826	27	3	0	41143	\N
10826	1270	4	0	41145	\N
10556	40	3	0	41698	\N
10584	40	3	0	41700	\N
10556	128	4	0	41702	\N
10785	56	4	0	44057	\N
10785	2600	5	0	44058	\N
10838	75	9	0	45606	\N
10838	2610	10	0	45618	\N
10804	79	4	0	46714	\N
10804	589	5	0	46719	\N
10856	79	2	0	46748	\N
10856	80	3	0	46749	\N
10886	121	4	0	48849	\N
10887	121	4	0	48850	\N
10888	121	4	0	48851	\N
10886	848	5	0	48855	\N
10887	848	5	0	48856	\N
10888	848	5	0	48857	\N
10788	156	4	0	50155	\N
10788	2543	5	0	50160	\N
10859	181	2	0	51061	\N
10859	769	3	0	51063	\N
10857	200	2	0	51486	\N
10857	887	3	0	51488	\N
10845	210	7	0	51713	\N
10845	2612	8	0	51715	\N
10874	242	2	0	52054	\N
10874	620	3	0	52056	\N
10871	324	0	0	54126	\N
10873	324	2	0	54127	\N
10873	486	3	0	54129	\N
10810	353	3	0	54535	\N
10812	353	2	0	54536	\N
10812	755	3	0	54539	\N
10810	1854	4	0	54541	\N
10863	1021	4	0	56392	\N
10863	1047	5	0	56397	\N
10796	1470	2	0	58141	\N
10797	1470	2	0	58142	\N
10799	1470	2	0	58143	\N
10796	1565	3	0	58144	\N
10797	1565	3	0	58145	\N
10799	1565	3	0	58146	\N
10861	139	5	0	2203	\N
10882	2622	5	0	2347	\N
10883	2622	5	0	2348	\N
10884	2622	5	0	2349	\N
10885	2622	5	0	2350	\N
10879	2620	6	0	2351	\N
10881	2620	4	0	2352	\N
10881	2623	5	0	2353	\N
10880	2620	6	0	2354	\N
10882	2620	6	0	2355	\N
10883	2620	6	0	2356	\N
10884	2620	6	0	2357	\N
10885	2620	6	0	2358	\N
10813	228	2	0	2972	\N
10875	228	5	0	2973	\N
10813	511	3	0	2974	\N
10875	2619	6	0	2975	\N
10878	228	2	0	2976	\N
10878	511	3	0	2977	\N
10865	367	2	0	3382	\N
10865	651	3	0	3385	\N
10801	262	4	0	3706	\N
10801	1015	5	0	3708	\N
10825	391	3	0	10941	\N
10839	391	2	0	10942	\N
10825	581	4	0	10946	\N
10847	391	5	0	10955	\N
10869	391	5	0	10956	\N
10847	1511	6	0	10958	\N
10869	1511	6	0	10959	\N
10866	256	3	0	13338	\N
10866	1488	4	0	13339	\N
10830	58	2	0	13438	\N
10830	665	3	0	13440	\N
10842	173	4	0	14840	\N
10842	1046	5	0	14841	\N
10858	167	2	0	17919	\N
10811	60	3	0	19669	\N
10811	643	4	0	19670	\N
10821	241	2	0	20578	\N
10821	281	3	0	20584	\N
10795	488	5	0	21406	\N
10795	2602	6	0	21409	\N
10862	2615	4	0	22313	\N
10862	2616	5	0	22314	\N
10872	264	2	0	23436	\N
10872	265	3	0	23437	\N
10822	82	3	0	23692	\N
10822	810	4	0	23696	\N
10829	83	2	0	23711	\N
10781	69	4	0	24597	\N
10781	1721	5	0	24599	\N
10848	2185	5	0	24921	\N
10848	2613	6	0	24923	\N
10876	90	5	0	26210	\N
10876	1274	6	0	26215	\N
10779	86	3	0	26555	\N
10820	86	2	0	26556	\N
10820	509	3	0	26557	\N
10779	2596	4	0	26558	\N
10854	2603	112	0	27227	\N
10854	815	117	0	27233	\N
10806	96	3	0	29623	\N
10807	96	3	0	29624	\N
10860	96	4	0	29625	\N
10889	96	2	0	29626	\N
10889	482	3	0	29630	\N
10806	834	4	0	29633	\N
10807	834	4	0	29634	\N
10860	2055	5	0	29635	\N
10868	360	5	0	31301	\N
10870	360	41	0	31302	\N
10868	2617	6	0	31303	\N
10794	230	5	0	32000	\N
10794	2601	6	0	32002	\N
10850	322	2	0	32506	\N
10850	833	3	0	32507	\N
10818	1	3	0	33213	\N
10818	48	4	0	33214	\N
10835	1	0	0	33218	\N
10852	1	4	0	33225	\N
10852	422	5	0	33226	\N
10864	1	2	0	33231	\N
10864	112	3	0	33232	\N
10791	2	6	0	35146	\N
10867	6	3	0	36209	\N
10867	2140	4	0	36210	\N
10780	10	3	0	36750	\N
10780	347	4	0	36752	\N
10792	10	6	0	36761	\N
10792	426	7	0	36762	\N
10832	10	4	0	36771	\N
10840	10	2	0	36772	\N
10840	29	3	0	36773	\N
10832	600	5	0	36774	\N
10855	10	2	0	36780	\N
10855	29	3	0	36781	\N
10890	10	3	0	36786	\N
10890	347	4	0	36787	\N
10877	998	6	0	36788	\N
10843	14	6	0	39010	\N
10843	1267	7	0	39017	\N
10815	18	1	0	39957	\N
10853	18	6	0	39958	\N
10815	19	2	0	39959	\N
10853	2342	7	0	39960	\N
10827	27	3	0	41144	\N
10827	1270	4	0	41146	\N
10969	51	2	0	43458	\N
10969	524	3	0	43462	\N
10904	56	7	0	44060	\N
10904	2630	8	0	44061	\N
10924	169	2	0	44062	\N
10924	56	5	0	44067	\N
10924	169	6	0	44068	\N
11082	56	4	0	44073	\N
11082	1145	5	0	44074	\N
11084	75	2	0	45608	\N
11084	159	3	0	45615	\N
11003	79	0	0	46680	\N
11005	79	0	0	46681	\N
11073	100	2	0	47466	\N
11073	101	3	0	47469	\N
10987	102	0	0	48027	\N
10902	121	2	0	48868	\N
10902	625	3	0	48869	\N
10930	135	2	0	49406	\N
10930	2643	3	1	49654	\N
11047	147	2	0	50119	\N
11047	516	3	0	50124	\N
11116	451	4	0	55170	\N
11116	2692	5	0	55186	\N
10923	2519	6	1	58571	\N
10896	2578	7	0	58579	\N
10896	2626	8	0	58580	\N
10911	2351	2	0	58915	\N
10989	2351	4	0	58917	\N
10911	2352	3	0	58920	\N
10989	2571	5	0	58921	\N
11040	2351	2	0	58925	\N
11040	2352	3	0	58928	\N
11119	1710	5	0	161	\N
10907	2631	6	0	1150	\N
11045	1096	2	0	1660	\N
11045	2158	3	0	1663	\N
10940	110	2	0	2434	\N
10972	110	3	0	2435	\N
10940	111	3	0	2437	\N
10972	905	4	0	2438	\N
11057	2678	5	1	3246	\N
11056	367	4	0	3383	\N
11057	367	4	0	3384	\N
11056	1231	5	0	3386	\N
10933	262	2	0	3715	\N
11108	392	1	0	10961	\N
11108	391	3	0	10968	\N
11108	392	4	0	10969	\N
11057	2677	5	0	14011	\N
10891	402	5	0	14247	\N
10892	402	5	0	14248	\N
10891	2624	6	0	14250	\N
10892	2624	6	0	14251	\N
11012	92	6	0	14896	\N
11012	2667	7	0	14897	\N
11099	192	2	0	15527	\N
11099	838	3	0	15530	\N
10977	161	3	0	15946	\N
11027	212	10	0	17004	\N
11027	2671	11	0	17007	\N
10994	326	4	0	17522	\N
10994	1638	5	0	17523	\N
10930	2503	3	0	17599	\N
11031	30	2	0	18067	\N
11031	31	3	0	18068	\N
11014	290	6	0	18891	\N
11014	2668	7	0	18894	\N
10908	60	1	0	19671	\N
10909	60	3	0	19672	\N
10909	2632	4	0	19674	\N
10942	198	2	0	20296	\N
10997	198	2	0	20297	\N
10942	746	3	0	20301	\N
10997	746	3	0	20302	\N
10936	241	4	0	20579	\N
10936	686	5	0	20585	\N
10923	2638	6	0	20631	\N
10923	162	2	0	20647	\N
10923	64	5	0	20663	\N
10893	488	2	0	21407	\N
10893	729	3	0	21408	\N
10905	2443	5	0	22308	\N
10982	264	2	0	23446	\N
10982	265	3	0	23448	\N
11066	69	2	0	24611	\N
11066	500	3	0	24614	\N
10894	90	2	0	26211	\N
10894	91	3	0	26214	\N
10900	16	2	0	28355	\N
10900	155	3	0	28357	\N
10897	2627	7	0	29175	\N
10897	2628	8	0	29182	\N
10944	96	2	0	29627	\N
10984	449	2	0	29778	\N
10984	583	3	0	29779	\N
10903	151	11	0	30879	\N
10903	2629	12	0	30882	\N
10916	322	1	0	32515	\N
10916	323	2	0	32516	\N
10937	322	2	0	32519	\N
10937	833	3	0	32520	\N
11058	322	0	0	32524	\N
11007	1	4	0	33254	\N
11024	1	1	0	33255	\N
11054	1	4	0	33256	\N
11080	1	2	0	33259	\N
11122	1	2	0	33260	\N
11024	53	2	0	33263	\N
11071	112	3	0	33264	\N
11080	112	3	0	33265	\N
11122	112	3	0	33266	\N
11007	422	5	0	33268	\N
11054	422	5	0	33269	\N
11036	431	2	0	34801	\N
11036	531	3	0	34802	\N
10898	10	7	0	36792	\N
10899	10	1	0	36793	\N
10898	1776	8	0	36795	\N
10901	10	5	0	36798	\N
10901	998	6	0	36799	\N
10906	10	4	0	36804	\N
10906	600	5	0	36805	\N
10910	10	4	0	36808	\N
10910	600	5	0	36809	\N
10956	10	1	0	36823	\N
10956	11	2	0	36824	\N
11016	10	13	0	36832	\N
11038	10	2	0	36833	\N
11038	29	3	0	36836	\N
11075	10	2	0	36844	\N
11075	29	3	0	36846	\N
11019	14	2	0	39011	\N
11019	383	3	0	39014	\N
10895	18	46	0	39961	\N
10895	2625	47	0	39966	\N
10958	18	51	0	39976	\N
10958	2651	52	0	39977	\N
11104	2687	49	0	39986	\N
11104	18	79	0	39994	\N
11104	2688	80	0	39995	\N
10963	40	2	0	41804	\N
11087	40	4	0	41863	\N
11087	564	5	0	41864	\N
11095	40	2	0	41897	\N
11095	66	3	0	41899	\N
11004	56	1	0	44063	\N
11004	57	2	0	44065	\N
11078	56	3	0	44071	\N
11078	475	4	0	44072	\N
11090	56	2	0	44075	\N
11090	169	3	0	44076	\N
11169	56	0	0	44078	\N
11106	75	5	0	45624	\N
11106	2690	6	0	45625	\N
11176	75	4	0	45637	\N
10999	79	1	0	46781	\N
11156	79	3	0	46782	\N
10999	81	2	0	46783	\N
11156	272	4	0	46784	\N
10975	113	2	0	48164	\N
10975	114	3	0	48166	\N
10912	135	2	0	49399	\N
10912	196	3	0	49400	\N
11136	147	2	0	50120	\N
11136	516	3	0	50125	\N
11029	156	2	0	50170	\N
11029	571	3	0	50171	\N
11008	170	4	0	50495	\N
11008	171	5	0	50497	\N
10934	186	2	0	51143	\N
10934	696	3	0	51147	\N
10985	242	6	0	52065	\N
10985	1630	7	0	52066	\N
11131	2655	65	0	52067	\N
11131	242	126	0	52077	\N
11131	2694	127	0	52078	\N
10983	316	2	0	53857	\N
10983	332	3	0	53859	\N
11067	362	2	0	54761	\N
11067	420	3	0	54763	\N
11133	597	2	0	56071	\N
11133	767	3	0	56076	\N
11177	2701	108	0	56388	\N
11177	1021	126	0	56399	\N
11177	2702	127	0	56400	\N
10928	2639	9	0	56606	\N
10928	793	8	0	56611	\N
10931	793	2	0	56612	\N
11179	793	4	0	56615	\N
11179	1986	5	0	56617	\N
10992	841	4	0	56933	\N
11129	841	4	0	56957	\N
11186	841	2	0	56958	\N
11186	1161	3	0	56960	\N
11129	900	5	0	56963	\N
11153	2578	2	0	58581	\N
11153	2696	3	0	58582	\N
10928	2640	9	1	59215	\N
10954	2648	6	0	59430	\N
11127	289	3	0	165	\N
11037	433	3	0	238	\N
10970	424	2	0	684	\N
10970	520	3	0	685	\N
10964	365	2	0	4420	\N
10964	519	3	0	4421	\N
11126	391	2	0	10967	\N
11126	406	3	0	10970	\N
11147	391	4	0	10976	\N
11158	391	2	0	10977	\N
11158	406	3	0	10978	\N
11147	539	5	0	10979	\N
11155	132	2	0	11093	\N
10938	123	2	0	12694	\N
10938	384	3	0	12696	\N
11032	123	2	0	12708	\N
11032	384	3	0	12709	\N
11064	77	2	0	13025	\N
11064	216	3	0	13030	\N
11049	402	2	0	14272	\N
11049	1148	3	0	14275	\N
11170	402	4	0	14302	\N
11175	402	4	0	14304	\N
11170	1378	5	0	14307	\N
11175	1378	5	0	14309	\N
11163	2697	7	0	14364	\N
10922	38	2	0	16271	\N
11134	38	2	0	16272	\N
10922	39	3	0	16280	\N
11134	39	3	0	16281	\N
11172	2699	4	0	16582	\N
11172	2700	5	0	16583	\N
11120	212	2	0	17005	\N
11120	566	3	0	17006	\N
10928	2641	10	0	17891	\N
10992	2661	6	0	17927	\N
10919	30	8	0	18063	\N
11015	290	6	0	18892	\N
11015	2668	7	0	18895	\N
11150	60	0	0	19365	\N
11109	199	1	0	20292	\N
11109	198	3	0	20300	\N
11109	199	4	0	20303	\N
11182	164	4	0	20970	\N
11182	1582	5	0	20977	\N
10950	145	19	0	22036	\N
10950	2646	20	0	22041	\N
10966	69	2	0	24609	\N
10966	500	3	0	24612	\N
11165	508	3	0	25406	\N
11166	206	2	0	25905	\N
11166	693	3	0	25910	\N
11113	94	4	0	26859	\N
11113	1706	5	0	26861	\N
11141	94	2	0	26862	\N
11141	95	3	0	26863	\N
10945	96	2	0	29628	\N
10945	482	3	0	29632	\N
11102	151	9	0	30885	\N
11102	2686	10	0	30888	\N
11041	230	2	0	32013	\N
11041	231	3	0	32016	\N
11124	231	3	0	32018	\N
10914	1	8	0	33237	\N
10914	1982	9	0	33242	\N
10980	1	3	0	33245	\N
10980	1114	4	0	33246	\N
11146	1	4	0	33273	\N
11148	1	2	0	33274	\N
11148	112	3	0	33276	\N
11146	422	5	0	33278	\N
11096	2	2	0	35148	\N
11096	131	3	0	35153	\N
11062	600	5	0	36838	\N
11085	10	3	0	36845	\N
11085	347	4	0	36847	\N
11017	10	2	0	36848	\N
11017	29	3	0	36849	\N
11144	10	4	0	36861	\N
11168	10	0	0	36862	\N
11197	10	2	0	36865	\N
11197	29	3	0	36867	\N
11144	600	5	0	36868	\N
10959	27	3	0	41159	\N
10959	2652	4	0	41160	\N
11162	40	0	0	41791	\N
10925	40	3	0	41794	\N
11010	40	6	0	41844	\N
11034	40	2	0	41845	\N
11034	66	3	0	41847	\N
11010	1192	7	0	41849	\N
11143	40	3	0	41898	\N
11143	128	4	0	41900	\N
11167	40	0	0	41923	\N
10968	51	2	0	43457	\N
10968	524	3	0	43461	\N
11218	56	2	0	44079	\N
11218	169	3	0	44080	\N
11176	172	5	0	45638	\N
10986	102	0	0	48026	\N
10974	113	2	0	48163	\N
10974	114	3	0	48165	\N
11107	437	1	0	48167	\N
11107	113	3	0	48170	\N
11107	437	4	0	48171	\N
11194	119	2	0	48652	\N
11194	891	3	0	48655	\N
10932	137	1	0	49680	\N
10932	138	2	0	49686	\N
10979	156	3	0	50169	\N
10979	2658	4	0	50172	\N
11026	210	10	0	51729	\N
11094	210	2	0	51730	\N
11094	458	3	0	51734	\N
11026	2670	11	0	51736	\N
11112	268	5	0	52688	\N
11112	642	6	0	52689	\N
11065	273	2	0	53114	\N
11065	1159	3	0	53115	\N
11201	324	2	0	54128	\N
11201	486	3	0	54130	\N
11140	353	2	0	54537	\N
11244	353	4	0	54538	\N
11140	755	3	0	54540	\N
11115	451	4	0	55169	\N
11115	2692	5	0	55185	\N
11135	595	2	0	55801	\N
11135	768	3	0	55803	\N
11046	597	2	0	56070	\N
11204	597	6	0	56072	\N
11046	767	3	0	56075	\N
11204	2705	7	0	56078	\N
10991	2663	4	0	56921	\N
10991	900	5	0	56922	\N
10921	2636	2	0	58674	\N
10921	2637	3	0	58675	\N
10929	2642	9	0	3721	\N
11070	365	2	0	4427	\N
11023	366	2	0	4428	\N
11070	519	3	0	4429	\N
11061	391	6	0	10957	\N
11061	2680	7	0	10960	\N
11196	391	2	0	10988	\N
11196	406	3	0	10989	\N
11138	300	6	0	12215	\N
11138	2695	7	0	12216	\N
11231	727	5	0	12324	\N
11231	2716	6	0	12327	\N
11053	58	4	0	13443	\N
11009	233	4	0	13724	\N
11009	1689	5	0	13739	\N
10992	2665	5	1	14000	\N
10941	402	2	0	14260	\N
10941	1148	3	0	14261	\N
11051	402	2	0	14274	\N
11051	1148	3	0	14277	\N
11089	402	1	0	14287	\N
11089	403	2	0	14288	\N
11077	258	3	0	14361	\N
11077	2683	4	0	14363	\N
11152	92	2	0	14902	\N
11098	192	2	0	15526	\N
11098	838	3	0	15529	\N
10996	235	2	0	15903	\N
10996	1061	3	0	15906	\N
11121	44	2	0	15963	\N
11121	161	3	0	15966	\N
11033	2674	100	0	16602	\N
10931	2645	3	1	17890	\N
10981	167	2	0	17920	\N
10981	168	3	0	17925	\N
11234	30	6	0	18069	\N
11234	2719	7	0	18072	\N
11044	656	3	0	18471	\N
11236	290	2	0	18920	\N
11236	1909	3	0	18922	\N
11189	62	3	0	19700	\N
11189	2703	4	0	19703	\N
10926	64	1	0	20655	\N
10926	65	2	0	20661	\N
11183	164	0	0	20971	\N
10991	2662	4	0	21631	\N
11223	336	4	0	22912	\N
11223	2285	5	0	22914	\N
11215	264	3	0	23456	\N
11149	82	2	0	23719	\N
11149	343	3	0	23722	\N
11101	69	9	0	24623	\N
11101	2685	10	0	24624	\N
11164	1361	2	0	27171	\N
11164	2698	3	0	27172	\N
10946	16	2	0	28359	\N
10946	155	3	0	28360	\N
11002	16	1	0	28363	\N
11002	17	2	0	28364	\N
11092	16	3	0	28367	\N
11130	16	4	0	28368	\N
11130	380	5	0	28370	\N
11018	96	4	0	29629	\N
11018	2055	5	0	29636	\N
11043	230	2	0	32014	\N
11043	231	3	0	32017	\N
10949	1	6	0	33238	\N
10953	1	1	0	33239	\N
10953	53	2	0	33240	\N
10949	523	7	0	33241	\N
11001	1	1	0	33253	\N
11001	53	2	0	33262	\N
11241	1	6	0	33292	\N
10961	2	7	0	35147	\N
11192	2	2	0	35149	\N
11192	131	3	0	35155	\N
10961	2654	8	0	35157	\N
10918	10	2	0	36816	\N
10927	10	5	0	36817	\N
10918	29	3	0	36818	\N
10927	2042	6	0	36819	\N
10965	10	2	0	36830	\N
10965	29	3	0	36835	\N
11021	10	4	0	36854	\N
11021	600	5	0	36855	\N
11211	465	4	0	36880	\N
11105	14	5	0	39012	\N
11105	2689	6	0	39016	\N
11033	2675	100	1	39582	\N
10913	2633	2	0	39967	\N
10913	18	53	0	39972	\N
10913	2634	54	0	39973	\N
11033	2673	22	0	39978	\N
11033	18	99	0	39985	\N
11072	27	2	0	41175	\N
11072	619	3	0	41176	\N
11157	40	0	0	41787	\N
10976	40	3	0	41805	\N
10976	2656	4	0	41807	\N
11079	40	2	0	41846	\N
11079	66	3	0	41848	\N
11199	40	2	0	41942	\N
11199	66	3	0	41943	\N
11229	40	5	0	41988	\N
11229	2714	6	0	41989	\N
1850	56	1	0	43702	\N
11025	57	2	0	44066	\N
11069	56	3	0	44069	\N
11069	475	4	0	44070	\N
11114	56	4	0	44077	\N
11114	1145	5	0	44081	\N
11081	75	2	0	45607	\N
11081	159	3	0	45614	\N
11103	75	9	0	45623	\N
11103	2610	10	0	45626	\N
11000	79	0	0	46679	\N
10960	79	7	0	46780	\N
10960	2653	8	0	46785	\N
11181	79	4	0	46810	\N
11181	589	5	0	46811	\N
11188	88	2	0	47034	\N
11188	154	3	0	47039	\N
11202	88	3	0	47054	\N
11202	580	4	0	47055	\N
11074	2681	47	0	47458	\N
11074	100	126	0	47470	\N
11074	2682	127	0	47471	\N
11237	121	2	0	48878	\N
11237	2498	3	0	48883	\N
11239	135	2	0	49407	\N
11239	2722	3	0	49408	\N
11205	147	6	0	50121	\N
11205	2706	7	0	50127	\N
10957	156	4	0	50165	\N
10957	2650	5	0	50166	\N
10962	242	7	0	52055	\N
10962	2655	8	0	52058	\N
11213	285	10	0	53365	\N
11213	2711	11	0	53366	\N
10947	316	1	0	53851	\N
10947	317	2	0	53852	\N
11028	316	10	0	53858	\N
11028	2672	11	0	53860	\N
11174	451	4	0	55172	\N
11174	2692	5	0	55188	\N
11048	595	2	0	55793	\N
11048	768	3	0	55794	\N
10993	841	4	0	56934	\N
10993	900	5	0	56936	\N
11086	841	3	0	56956	\N
11086	2083	4	0	56962	\N
10988	2351	4	0	58916	\N
10990	2351	4	0	58918	\N
10990	2571	5	0	58922	\N
11230	2715	6	0	59213	\N
11035	13	2	0	236	\N
11011	2666	7	0	691	\N
11013	266	1	0	1155	\N
11013	267	2	0	1156	\N
10973	110	4	0	2436	\N
10973	1708	5	0	2439	\N
11039	110	2	0	2445	\N
11039	111	3	0	2447	\N
11224	228	4	0	2978	\N
11224	1631	5	0	2979	\N
10955	35	5	0	4341	\N
10955	2649	6	0	4344	\N
10971	132	1	0	11087	\N
11030	123	2	0	12695	\N
11030	384	3	0	12697	\N
11055	58	42	0	13444	\N
11055	2676	43	0	13446	\N
11050	402	2	0	14273	\N
11050	1148	3	0	14276	\N
11171	402	4	0	14303	\N
11171	1378	5	0	14308	\N
11059	258	2	0	14353	\N
11059	585	3	0	14355	\N
10920	38	1	0	16270	\N
10920	399	2	0	16277	\N
10951	212	6	0	16992	\N
10948	754	7	0	16993	\N
10951	754	7	0	16994	\N
11076	326	2	0	17531	\N
11076	747	3	0	17532	\N
11052	167	4	0	17602	\N
11052	1011	5	0	17603	\N
10988	2661	6	0	17926	\N
10939	142	2	0	18462	\N
10939	656	3	0	18463	\N
11123	142	2	0	18483	\N
11123	656	3	0	18484	\N
10952	291	2	0	18893	\N
11088	290	2	0	18906	\N
11088	575	3	0	18907	\N
11111	336	5	0	22911	\N
11111	2691	6	0	22915	\N
11083	140	2	0	24200	\N
11118	140	4	0	24201	\N
11083	487	3	0	24208	\N
11118	1661	5	0	24210	\N
10967	69	2	0	24610	\N
10967	500	3	0	24613	\N
11093	86	2	0	26565	\N
10943	94	2	0	26858	\N
10943	95	3	0	26860	\N
10998	16	2	0	28361	\N
10998	155	3	0	28362	\N
11020	16	2	0	28365	\N
11020	155	3	0	28366	\N
11190	320	3	0	29313	\N
11190	797	4	0	29316	\N
11022	96	3	0	29642	\N
11022	834	4	0	29643	\N
11097	449	2	0	29794	\N
11097	583	3	0	29798	\N
11042	702	3	0	30344	\N
11100	151	10	0	30884	\N
11100	2684	11	0	30889	\N
10978	322	3	0	32523	\N
10978	2657	4	0	32525	\N
11068	453	2	0	32644	\N
11068	902	3	0	32659	\N
11063	1	4	0	33257	\N
11063	422	5	0	33270	\N
11221	112	2	0	33279	\N
11221	1	3	0	33282	\N
11110	26	1	0	35125	\N
11110	26	4	0	35154	\N
10915	10	8	0	36812	\N
10915	1772	9	0	36813	\N
10935	10	4	0	36822	\N
10935	600	5	0	36825	\N
11006	10	3	0	36831	\N
11006	347	4	0	36837	\N
11091	10	3	0	36852	\N
11091	347	4	0	36853	\N
11185	10	2	0	36864	\N
11185	29	3	0	36866	\N
11200	10	2	0	36875	\N
11200	29	3	0	36878	\N
11226	29	3	0	36879	\N
11235	14	6	0	39013	\N
11235	2720	7	0	39015	\N
11245	14	4	0	39027	\N
11060	27	6	0	41174	\N
11060	2679	7	0	41177	\N
10917	40	2	0	41786	\N
10917	66	3	0	41793	\N
10995	40	2	0	41825	\N
10995	66	3	0	41826	\N
11209	40	2	0	41962	\N
11380	71	2	0	44723	\N
11380	1125	3	0	44724	\N
11269	79	8	0	46104	\N
11269	2739	9	0	46107	\N
11187	88	2	0	47033	\N
11187	154	3	0	47038	\N
11360	88	10	0	47066	\N
11360	2787	11	0	47073	\N
11217	113	4	0	48174	\N
11217	699	5	0	48175	\N
11207	125	6	0	49160	\N
11207	2708	7	0	49167	\N
11238	137	2	0	49681	\N
11238	2721	3	0	49687	\N
11142	170	2	0	50503	\N
11142	718	3	0	50506	\N
11339	181	4	0	51071	\N
11339	2356	5	0	51072	\N
11222	200	2	0	51487	\N
11222	887	3	0	51489	\N
11383	268	2	0	52698	\N
11383	2800	3	0	52699	\N
11302	316	1	0	53865	\N
11302	317	2	0	53866	\N
11365	316	4	0	53871	\N
11365	2790	5	0	53872	\N
11173	451	4	0	55171	\N
11173	2692	5	0	55187	\N
11404	1109	2	0	56149	\N
11404	2809	3	0	56151	\N
11180	793	4	0	56616	\N
11180	1986	5	0	56618	\N
11193	841	2	0	56959	\N
11193	1161	3	0	56961	\N
11379	1470	4	0	58156	\N
11379	2798	5	0	58159	\N
11154	2351	2	0	58926	\N
11198	2351	4	0	58927	\N
11154	2352	3	0	58929	\N
11198	2571	5	0	58930	\N
11385	2594	2	0	59220	\N
11385	2801	3	0	59223	\N
11409	2812	4	0	239	\N
11125	2693	79	0	646	\N
11289	424	2	0	689	\N
11289	2755	3	0	690	\N
11184	251	4	0	1408	\N
11184	1610	5	0	1411	\N
11220	1858	2	0	3018	\N
11220	2712	3	0	3027	\N
11278	262	2	0	3716	\N
11278	2743	3	0	3718	\N
11208	35	4	0	4342	\N
11208	2709	5	0	4343	\N
11243	35	2	0	4345	\N
11328	365	3	0	4445	\N
11328	2769	4	0	4447	\N
11128	132	2	0	11092	\N
11128	133	3	0	11094	\N
11248	58	5	0	13453	\N
11248	2726	6	0	13454	\N
11304	402	2	0	14305	\N
11304	2760	3	0	14306	\N
11291	235	2	0	15904	\N
11291	2757	3	0	15905	\N
11376	115	2	0	16889	\N
11376	2797	3	0	16890	\N
11273	1127	3	0	18071	\N
11151	290	4	0	18912	\N
11151	695	5	0	18913	\N
11294	290	4	0	18921	\N
11294	2759	5	0	18923	\N
11362	62	2	0	19705	\N
11362	2191	3	0	19706	\N
11280	165	1	0	20960	\N
11280	164	5	0	20973	\N
11280	1807	6	0	20976	\N
11260	488	24	0	21415	\N
11260	2733	25	0	21420	\N
11195	68	3	0	22305	\N
11251	73	15	0	22386	\N
11251	2728	16	0	22389	\N
11319	149	2	0	23302	\N
11319	1379	3	0	23303	\N
11132	264	2	0	23447	\N
11132	265	3	0	23449	\N
11346	264	2	0	23457	\N
11346	2780	3	0	23458	\N
11368	140	6	0	24202	\N
11368	2792	7	0	24209	\N
11336	206	2	0	25907	\N
11359	206	1	0	25914	\N
11359	207	2	0	25917	\N
11323	42	1	0	27744	\N
11323	43	2	0	27746	\N
11191	16	2	0	28371	\N
11191	155	3	0	28372	\N
11240	16	3	0	28375	\N
11240	1045	4	0	28376	\N
11306	16	1	0	28377	\N
11308	16	1	0	28378	\N
11306	1087	2	0	28379	\N
11308	1087	2	0	28380	\N
11370	16	2	0	28383	\N
11316	1087	2	0	28384	\N
11370	388	3	0	28386	\N
11390	97	1	0	29644	\N
11390	96	5	0	29657	\N
11390	2803	6	0	29660	\N
11139	1	2	0	33261	\N
11139	112	3	0	33267	\N
11225	1	2	0	33285	\N
11225	112	3	0	33286	\N
11228	1	5	0	33291	\N
11228	2052	6	0	33294	\N
11276	1	8	0	33307	\N
11276	2742	9	0	33308	\N
11331	1	2	0	33320	\N
11331	283	3	0	33321	\N
11397	1	2	0	33328	\N
11398	1	1	0	33329	\N
11398	53	2	0	33330	\N
11397	283	3	0	33331	\N
11421	1	4	0	33334	\N
11145	4	4	0	35847	\N
11145	684	5	0	35848	\N
11282	194	1	0	36211	\N
11282	2750	6	0	36216	\N
11416	6	2	0	36234	\N
11416	2805	3	0	36235	\N
11137	10	6	0	36860	\N
11178	10	4	0	36863	\N
11178	600	5	0	36869	\N
11137	426	7	0	36870	\N
11233	10	6	0	36886	\N
11233	2718	7	0	36888	\N
11387	10	1	0	36932	\N
11387	1416	2	0	36934	\N
11418	10	2	0	36939	\N
11159	40	0	0	41788	\N
11161	40	0	0	41790	\N
11253	40	8	0	42012	\N
11253	2730	9	0	42013	\N
11373	40	4	0	42067	\N
11373	2796	5	0	42068	\N
11414	40	1	0	42128	\N
11414	1383	2	0	42131	\N
1942	56	2	0	43705	\N
11412	284	3	0	45656	\N
11275	79	1	0	46105	\N
11275	1126	2	0	46106	\N
11293	79	4	0	46141	\N
11293	2758	5	0	46142	\N
11338	79	4	0	46211	\N
11355	79	2	0	46212	\N
11423	79	2	0	46213	\N
11355	616	3	0	46214	\N
11423	616	3	0	46215	\N
11338	2758	5	0	46216	\N
11461	79	2	0	46262	\N
11461	616	3	0	46263	\N
11426	2817	18	0	48618	\N
11424	119	2	0	48653	\N
11424	1879	3	0	48654	\N
11426	119	126	0	48656	\N
11426	2818	127	1	48783	\N
11258	137	0	0	49682	\N
11353	200	1	0	51496	\N
11407	200	4	0	51497	\N
11353	2785	2	0	51498	\N
11407	2811	5	0	51499	\N
11327	242	1	0	52075	\N
11327	2768	2	0	52076	\N
11212	362	3	0	54762	\N
11212	2710	4	0	54764	\N
11206	595	6	0	55802	\N
11206	2707	7	0	55804	\N
11455	908	2	0	57519	\N
11455	2832	3	0	57520	\N
11203	1545	3	0	58427	\N
11203	2704	4	0	58430	\N
11216	2351	2	0	58931	\N
11216	2352	3	0	58932	\N
11284	2752	2	0	59120	\N
11477	2842	3	0	164	\N
11438	117	2	0	2207	\N
11438	1257	3	0	2208	\N
11428	2819	6	0	2209	\N
11444	262	6	0	3717	\N
11444	2828	7	0	3720	\N
11426	1970	127	0	5134	\N
11361	391	10	0	10994	\N
11361	2788	11	0	10995	\N
11433	391	2	0	10998	\N
11433	1381	3	0	11000	\N
11232	132	5	0	11101	\N
11232	2717	6	0	11110	\N
11454	2831	4	0	12364	\N
11246	258	4	0	14372	\N
11246	2725	5	0	14375	\N
11305	192	2	0	15533	\N
11305	2761	3	0	15535	\N
11381	192	2	0	15536	\N
11381	2761	3	0	15547	\N
11303	235	2	0	15910	\N
11303	2757	3	0	15912	\N
11266	167	36	0	17609	\N
11266	2737	37	0	17610	\N
11313	290	2	0	18932	\N
11333	60	4	0	19376	\N
11333	2771	5	0	19377	\N
11227	488	5	0	21411	\N
11227	2713	6	0	21412	\N
11250	73	15	0	22385	\N
11250	2728	16	0	22388	\N
11340	74	1	0	22390	\N
11340	73	3	0	22397	\N
11340	2775	4	0	22399	\N
11271	206	3	0	25906	\N
11271	2741	4	0	25911	\N
11371	94	2	0	26864	\N
11431	42	4	0	27749	\N
11431	2821	5	0	27750	\N
11436	42	1	0	27751	\N
11436	2823	2	0	27752	\N
11210	16	3	0	28373	\N
11210	1690	4	0	28374	\N
11357	16	1	0	28382	\N
11357	17	2	0	28385	\N
11392	16	2	0	28387	\N
11392	388	3	0	28388	\N
11475	16	2	0	28389	\N
11475	388	3	0	28391	\N
11391	96	5	0	29658	\N
11391	2803	6	0	29661	\N
11262	449	7	0	29795	\N
11262	2734	8	0	29799	\N
11441	2825	93	0	30883	\N
11441	151	126	0	30890	\N
11441	2826	127	0	30891	\N
11498	151	89	0	30896	\N
11498	2855	90	0	30897	\N
11318	202	2	0	30988	\N
11318	2764	3	0	30991	\N
11434	33	2	0	31682	\N
11369	322	6	0	32528	\N
11369	2793	7	0	32529	\N
11419	322	2	0	32532	\N
11419	1866	3	0	32533	\N
11469	453	3	0	32645	\N
11469	2838	4	0	32658	\N
11214	1	3	0	33275	\N
11214	48	4	0	33277	\N
11297	1	2	0	33314	\N
11297	283	3	0	33316	\N
11351	1	2	0	33324	\N
11351	283	3	0	33325	\N
11448	1	1	0	33339	\N
11467	1	2	0	33340	\N
11448	53	2	0	33341	\N
11467	283	3	0	33343	\N
11363	2	2	0	35150	\N
11363	2789	3	0	35152	\N
11452	2	4	0	35195	\N
11452	2830	5	0	35196	\N
11462	2	2	0	35209	\N
11462	2789	3	0	35210	\N
11284	2753	2	0	35853	\N
11284	2751	3	0	35856	\N
11399	2805	3	0	36225	\N
11255	10	0	0	36887	\N
11315	10	2	0	36911	\N
11315	275	3	0	36913	\N
11439	10	2	0	36946	\N
11439	275	3	0	36950	\N
11457	10	2	0	36956	\N
11457	275	3	0	36957	\N
11460	10	2	0	36960	\N
11460	275	3	0	36965	\N
11330	14	2	0	39028	\N
11330	1785	3	0	39030	\N
11447	15	2	0	39042	\N
11219	27	2	0	41204	\N
11219	619	3	0	41205	\N
11321	27	2	0	41223	\N
11321	645	3	0	41226	\N
11286	40	2	0	42025	\N
11286	282	3	0	42026	\N
11343	40	6	0	42066	\N
11343	2777	7	0	42070	\N
11451	40	4	0	42130	\N
11464	40	2	0	42149	\N
11464	282	3	0	42150	\N
11530	40	2	0	42183	\N
11530	282	3	0	42184	\N
11420	51	2	0	43459	\N
11420	1260	3	0	43460	\N
11372	56	2	0	44083	\N
11372	2795	3	0	44084	\N
11492	2846	2	0	49165	\N
11492	125	8	0	49181	\N
11492	2847	9	0	49182	\N
11344	135	6	0	49419	\N
11344	2778	7	0	49420	\N
11515	200	2	0	51505	\N
11515	276	3	0	51512	\N
11536	2877	7	0	51728	\N
11536	2878	8	1	52027	\N
11470	242	3	0	52084	\N
11470	2839	4	0	52085	\N
11274	273	2	0	53122	\N
11274	1413	3	0	53125	\N
11403	324	2	0	54138	\N
11403	2808	3	0	54139	\N
11244	2724	5	0	54542	\N
11358	362	1	0	54767	\N
11358	395	2	0	54768	\N
11401	362	4	0	54771	\N
11401	2807	5	0	54774	\N
11406	435	4	0	55040	\N
11406	2810	5	0	55043	\N
11547	1109	2	0	56170	\N
11547	2809	3	0	56173	\N
11471	2578	10	0	58583	\N
11471	2840	11	0	58584	\N
11459	2636	2	0	58676	\N
11459	2836	3	0	58677	\N
11468	2636	3	0	58678	\N
11468	2837	4	0	58683	\N
11287	2351	2	0	58933	\N
11287	2754	3	0	58937	\N
11281	2749	7	1	59121	\N
11349	2782	2	0	59230	\N
11349	2784	3	0	59233	\N
11536	2876	7	0	59438	\N
11536	2879	9	0	59439	\N
11396	2804	3	0	237	\N
11440	2824	5	0	1162	\N
11463	251	2	0	1409	\N
11463	1851	3	0	1410	\N
11263	110	10	0	2453	\N
11263	2735	11	0	2456	\N
11311	365	2	0	4444	\N
11311	615	3	0	4446	\N
11536	1970	8	0	5132	\N
11437	391	2	0	10999	\N
11437	1381	3	0	11001	\N
11545	391	2	0	11003	\N
11545	1381	3	0	11005	\N
11490	528	1	0	12409	\N
11508	528	2	0	12410	\N
11490	529	2	0	12411	\N
11508	2765	3	0	12412	\N
11347	58	4	0	13461	\N
11347	2781	5	0	13464	\N
11300	192	1	0	15532	\N
11300	193	2	0	15534	\N
11517	235	2	0	15911	\N
11517	2757	3	0	15913	\N
11298	44	2	0	15964	\N
11298	1910	3	0	15965	\N
11450	2829	2	0	20299	\N
11292	241	2	0	20580	\N
11292	634	3	0	20583	\N
11281	2748	7	0	20924	\N
11281	165	1	0	20961	\N
11309	164	3	0	20972	\N
11281	164	5	0	20974	\N
11309	1807	4	0	20975	\N
11367	488	2	0	21416	\N
11476	488	2	0	21417	\N
11367	2791	3	0	21418	\N
11476	2791	3	0	21419	\N
11540	2883	8	0	21432	\N
11525	2869	98	0	22042	\N
11525	145	126	0	22045	\N
11525	2870	127	0	22046	\N
11324	73	2	0	22396	\N
11324	2766	3	0	22398	\N
11356	73	2	0	22406	\N
11356	2766	3	0	22407	\N
11443	73	4	0	22416	\N
11443	2827	5	0	22421	\N
11307	149	2	0	23295	\N
11307	1379	3	0	23296	\N
11485	141	2	0	24207	\N
11394	214	2	0	24333	\N
11394	1259	3	0	24336	\N
11281	2747	6	1	24942	\N
11479	411	4	0	25157	\N
11479	2806	5	0	25158	\N
11533	411	5	0	25163	\N
11533	2874	6	0	25164	\N
11413	224	1	0	25412	\N
11413	2813	2	0	25414	\N
11449	94	1	0	26865	\N
11505	94	3	0	26866	\N
11505	2864	4	0	26869	\N
11481	16	2	0	28390	\N
11481	388	3	0	28392	\N
11378	54	4	0	29977	\N
11378	2570	5	0	29978	\N
11483	20	3	0	30350	\N
11483	2844	4	0	30351	\N
11497	151	2	0	30892	\N
11497	2854	3	0	30894	\N
11326	360	2	0	31311	\N
11384	360	2	0	31312	\N
11326	2767	3	0	31314	\N
11500	322	6	0	32536	\N
11500	2857	7	0	32539	\N
11491	453	1	0	32647	\N
11491	454	2	0	32657	\N
11254	1	8	0	33301	\N
11254	2731	9	0	33302	\N
11521	1	4	0	33351	\N
11521	2814	5	0	33353	\N
11528	1	5	0	33361	\N
11528	2382	6	0	33365	\N
11334	431	2	0	34803	\N
11334	2772	3	0	34806	\N
11411	298	4	0	35180	\N
11285	4	2	0	35855	\N
11285	2751	3	0	35858	\N
11261	10	7	0	36903	\N
11261	2274	8	0	36904	\N
11375	10	2	0	36931	\N
11375	275	3	0	36935	\N
11430	10	2	0	36940	\N
11430	275	3	0	36942	\N
11446	10	1	0	36947	\N
11446	11	2	0	36948	\N
11542	10	2	0	36962	\N
11295	40	2	0	42041	\N
11295	282	3	0	42043	\N
11389	41	1	0	42069	\N
11389	40	5	0	42089	\N
11389	372	6	0	42090	\N
11466	40	2	0	42161	\N
11466	282	3	0	42166	\N
2121	56	1	0	43715	\N
1380	56	26	0	43733	\N
11249	2727	6	0	44085	\N
11342	71	4	0	44714	\N
11342	2776	5	0	44715	\N
11288	75	2	0	45643	\N
11288	284	3	0	45644	\N
11335	75	2	0	45653	\N
11335	284	3	0	45655	\N
11435	75	2	0	45663	\N
11435	284	3	0	45664	\N
11502	75	6	0	45676	\N
11502	2859	7	0	45679	\N
11382	88	2	0	47067	\N
11417	88	2	0	47068	\N
11382	2799	3	0	47071	\N
11417	2799	3	0	47072	\N
11279	2744	47	1	47449	\N
11277	100	2	0	47493	\N
11277	633	3	0	47494	\N
11279	100	84	0	47495	\N
11279	2745	85	0	47496	\N
11296	100	2	0	47507	\N
11296	633	3	0	47512	\N
11352	113	1	0	48180	\N
11352	1102	2	0	48181	\N
11504	2861	18	0	48657	\N
11504	119	39	0	48678	\N
11504	2863	40	1	48784	\N
11509	121	2	0	48879	\N
11509	2498	3	0	48884	\N
11301	125	1	0	49161	\N
11388	125	1	0	49162	\N
11388	1185	2	0	49163	\N
11301	195	2	0	49164	\N
11257	135	0	0	49418	\N
11345	137	6	0	49683	\N
11345	2779	7	0	49689	\N
11247	181	4	0	51062	\N
11247	2356	5	0	51064	\N
11427	389	0	0	54932	\N
11410	1109	3	0	56150	\N
11410	1683	4	0	56153	\N
11337	841	4	0	56972	\N
11337	2774	5	0	56977	\N
11529	852	2	0	57194	\N
11529	2872	3	0	57195	\N
11456	2833	65	0	57516	\N
11456	2835	66	0	57521	\N
11377	1470	4	0	58155	\N
11377	2798	5	0	58158	\N
11456	2834	66	0	59115	\N
11348	2782	4	0	59224	\N
11348	2783	5	0	59225	\N
11422	2816	5	0	59444	\N
11511	2348	3	0	642	\N
11265	2736	12	0	2457	\N
11504	2862	40	0	2728	\N
11252	391	7	0	10990	\N
11252	2729	8	0	10991	\N
11270	391	8	0	10992	\N
11270	2740	9	0	10993	\N
11366	391	2	0	10996	\N
11366	1381	3	0	10997	\N
11290	132	2	0	11102	\N
11518	132	2	0	11103	\N
11290	2756	3	0	11108	\N
11518	2756	3	0	11109	\N
11354	2786	3	0	12226	\N
11513	300	2	0	12238	\N
11513	2786	3	0	12239	\N
11320	528	2	0	12401	\N
11320	2765	3	0	12402	\N
11499	123	3	0	12719	\N
11499	2856	4	0	12720	\N
11553	173	1	0	14595	\N
11553	1927	2	0	14596	\N
11312	92	2	0	14906	\N
11520	92	28	0	14908	\N
11312	2763	3	0	14909	\N
11386	2592	2	0	15928	\N
11386	2802	3	0	15929	\N
11310	44	3	0	15977	\N
11310	2762	4	0	15982	\N
11279	2674	47	0	16601	\N
11458	290	2	0	18942	\N
11458	1909	3	0	18947	\N
11402	164	2	0	20987	\N
11402	1124	3	0	20988	\N
11267	82	7	0	23731	\N
11267	2738	8	0	23732	\N
11393	214	2	0	24332	\N
11393	1259	3	0	24335	\N
11526	2871	7	0	24337	\N
11400	411	4	0	25151	\N
11400	2806	5	0	25152	\N
11322	42	1	0	27743	\N
11322	43	2	0	27745	\N
11272	96	2	0	29654	\N
11272	2347	3	0	29659	\N
11524	54	14	0	29987	\N
11524	2868	15	0	29989	\N
11429	20	5	0	30343	\N
11429	2820	6	0	30345	\N
11442	1876	5	0	30887	\N
11465	360	2	0	31313	\N
11465	2767	3	0	31316	\N
11325	1	2	0	33315	\N
11325	283	3	0	33317	\N
11425	1	2	0	33338	\N
11425	283	3	0	33342	\N
11473	1	3	0	33346	\N
11473	1114	4	0	33347	\N
11534	1933	4	0	33358	\N
11538	1	7	0	33362	\N
11543	1	2	0	33363	\N
11534	1	5	0	33366	\N
11538	2881	8	0	33367	\N
11415	2	1	0	35178	\N
11415	1091	2	0	35179	\N
11283	4	2	0	35854	\N
11283	2751	3	0	35857	\N
11259	10	24	0	36892	\N
11259	2732	25	0	36893	\N
11329	10	2	0	36912	\N
11329	275	3	0	36914	\N
11332	10	5	0	36917	\N
11332	2770	6	0	36918	\N
11364	10	4	0	36924	\N
11374	10	2	0	36925	\N
11350	275	3	0	36926	\N
11374	275	3	0	36927	\N
11364	2568	5	0	36928	\N
11405	10	4	0	36933	\N
11405	2568	5	0	36936	\N
11432	10	2	0	36945	\N
11432	275	3	0	36949	\N
11453	10	2	0	36953	\N
11453	275	3	0	36954	\N
11395	14	2	0	39029	\N
11245	2291	5	0	39032	\N
11548	27	1	0	41224	\N
11548	2885	2	0	41225	\N
11314	40	2	0	42042	\N
11314	282	3	0	42044	\N
11408	40	4	0	42108	\N
11408	2796	5	0	42109	\N
11445	40	1	0	42129	\N
11550	40	1	0	42203	\N
11550	1383	2	0	42204	\N
11556	40	1	0	42221	\N
11556	1383	2	0	42222	\N
11583	40	0	0	42238	\N
11631	40	1	0	42285	\N
11631	1383	2	0	42287	\N
11532	56	2	0	44086	\N
11532	2795	3	0	44087	\N
11656	79	1	0	46323	\N
11716	79	0	0	46324	\N
11656	1126	2	0	46327	\N
11714	79	1	0	46423	\N
11720	79	1	0	46424	\N
11714	1126	2	0	46428	\N
11720	1126	2	0	46429	\N
11567	100	1	0	47508	\N
11567	2895	2	0	47510	\N
11697	100	1	0	47537	\N
11697	2895	2	0	47538	\N
11503	119	3	0	48676	\N
11503	2860	4	0	48677	\N
11510	121	0	0	48880	\N
11577	125	2	0	49195	\N
11577	2902	3	0	49196	\N
11587	125	1	0	49202	\N
11587	1185	2	0	49203	\N
11648	147	2	0	49950	\N
11648	2948	3	0	49957	\N
11478	156	4	0	50177	\N
11478	2843	5	0	50179	\N
11572	181	1	0	51081	\N
11572	2898	2	0	51082	\N
11537	210	7	0	51731	\N
11537	2880	8	0	51735	\N
11493	2849	9	0	53842	\N
11493	2848	2	0	53873	\N
11493	316	8	0	53885	\N
11544	353	2	0	54546	\N
11544	2884	3	0	54547	\N
11531	362	2	0	54772	\N
11531	2873	3	0	54773	\N
11664	597	1	0	55839	\N
11664	2956	2	0	55843	\N
11535	2875	4	0	56154	\N
11535	1109	5	0	56165	\N
11699	1109	1	0	56178	\N
11699	2971	2	0	56180	\N
11704	793	1	0	56619	\N
11704	2972	2	0	56620	\N
11484	2351	3	0	58934	\N
11484	2845	4	0	58938	\N
11480	2782	2	0	59231	\N
11506	2782	5	0	59232	\N
11480	2784	3	0	59234	\N
11506	2865	6	0	59235	\N
11667	2782	1	0	59238	\N
11667	2959	2	0	59244	\N
11493	2850	9	1	59440	\N
11580	2903	2	0	234	\N
11629	2935	2	0	3732	\N
11622	35	0	0	4348	\N
11718	1789	1	0	5177	\N
11718	2976	2	0	5178	\N
11472	391	10	0	11002	\N
11546	391	2	0	11004	\N
11546	1381	3	0	11006	\N
11472	2841	11	0	11007	\N
11598	2909	2	0	12242	\N
11598	300	3	0	12253	\N
11496	58	2	0	13462	\N
11496	2853	3	0	13463	\N
11514	233	2	0	13726	\N
11489	234	2	0	13734	\N
11514	1849	3	0	13736	\N
11519	92	0	0	14907	\N
11661	2954	0	0	14931	\N
11643	192	1	0	15537	\N
11729	192	1	0	15539	\N
11643	2944	2	0	15542	\N
11729	2944	2	0	15544	\N
11661	2953	0	0	16600	\N
11494	167	5	0	17617	\N
11494	2851	6	0	17620	\N
11541	177	7	0	18313	\N
11565	177	1	0	18314	\N
11565	2894	2	0	18315	\N
11539	2882	8	0	18316	\N
11541	2882	8	0	18317	\N
11512	198	2	0	20306	\N
11512	513	3	0	20307	\N
11612	241	2	0	20581	\N
11612	2923	3	0	20582	\N
11694	336	1	0	22923	\N
11694	2970	2	0	22924	\N
11683	149	9	0	23308	\N
11599	140	2	0	24204	\N
11599	2910	3	0	24206	\N
11671	244	1	0	27215	\N
11671	2960	2	0	27217	\N
11602	16	0	0	28395	\N
11711	16	2	0	28400	\N
11711	2974	3	0	28401	\N
11523	54	8	0	29986	\N
11523	2867	9	0	29988	\N
11488	360	1	0	31321	\N
11488	479	2	0	31322	\N
11551	360	1	0	31335	\N
11641	360	2	0	31349	\N
11641	2943	3	0	31351	\N
11690	322	1	0	32542	\N
11690	2968	2	0	32545	\N
11486	453	0	0	32646	\N
11487	1	1	0	33350	\N
11487	53	2	0	33352	\N
11522	1	2	0	33356	\N
11522	283	3	0	33357	\N
11614	1	1	0	33390	\N
11614	1085	2	0	33391	\N
11638	1	0	0	33403	\N
11626	2932	3	0	34805	\N
11501	2	6	0	35235	\N
11501	2858	7	0	35236	\N
11692	2	1	0	35247	\N
11692	1091	2	0	35249	\N
11734	2	4	0	35265	\N
11495	6	5	0	36240	\N
11495	2852	6	0	36241	\N
11482	10	2	0	36961	\N
11554	10	2	0	36963	\N
11554	2887	3	0	36964	\N
11482	275	3	0	36966	\N
11560	2887	3	0	36971	\N
11651	10	2	0	37008	\N
11651	2887	3	0	37009	\N
11592	14	1	0	39040	\N
11592	1926	2	0	39041	\N
11658	14	1	0	39047	\N
11658	1926	2	0	39048	\N
11676	14	1	0	39060	\N
11676	1926	2	0	39061	\N
11474	40	2	0	42162	\N
11507	40	2	0	42163	\N
11516	40	2	0	42164	\N
11474	282	3	0	42167	\N
11507	282	3	0	42168	\N
11516	282	3	0	42169	\N
11527	2714	6	0	42170	\N
11703	40	1	0	42286	\N
11703	1383	2	0	42288	\N
11753	40	0	0	42304	\N
11797	40	1	0	42305	\N
11797	1383	2	0	42307	\N
11693	56	1	0	44090	\N
11693	1088	2	0	44091	\N
11566	75	1	0	45690	\N
11655	75	1	0	45692	\N
11566	1427	2	0	45695	\N
11655	1427	2	0	45697	\N
11759	75	2	0	45721	\N
11759	2989	3	0	45723	\N
11776	75	2	0	45729	\N
11776	2989	3	0	45730	\N
11795	75	1	0	45735	\N
11795	1427	2	0	45739	\N
11722	79	0	0	46425	\N
11723	79	0	0	46426	\N
11778	88	1	0	47080	\N
11778	2896	2	0	47083	\N
11686	100	2	0	47523	\N
11686	2918	3	0	47524	\N
11701	113	1	0	48192	\N
11701	1102	2	0	48194	\N
11696	125	2	0	49212	\N
11696	2902	3	0	49214	\N
11706	200	1	0	51506	\N
11706	2785	2	0	51509	\N
11617	210	1	0	51732	\N
11617	2926	2	0	51733	\N
11613	316	73	0	53882	\N
11613	2924	74	0	53886	\N
11773	2993	51	0	53887	\N
11773	316	125	0	53898	\N
11773	2994	126	0	53900	\N
11743	353	1	0	54550	\N
11743	1092	2	0	54551	\N
11666	595	1	0	55623	\N
11666	2958	2	0	55628	\N
11680	1109	3	0	56171	\N
11680	2961	4	0	56172	\N
11645	852	1	0	57197	\N
11645	2945	2	0	57199	\N
11588	2905	2	0	57508	\N
11789	3001	63	0	167	\N
11600	2088	2	0	1847	\N
11787	2982	2	0	3175	\N
11787	2999	3	0	3186	\N
11775	35	2	0	4352	\N
11775	2996	3	0	4353	\N
11747	365	1	0	4466	\N
11747	1424	2	0	4467	\N
11738	189	0	0	4741	\N
11555	373	2	0	5345	\N
11555	2888	3	0	5348	\N
11790	123	1	0	12728	\N
11790	2275	2	0	12729	\N
11745	2987	3	0	13733	\N
11557	402	1	0	14315	\N
11557	2889	2	0	14316	\N
11642	402	0	0	14324	\N
11726	192	1	0	15538	\N
11726	2944	2	0	15543	\N
11585	235	1	0	15920	\N
11585	2904	2	0	15921	\N
11766	44	2	0	15978	\N
11777	44	1	0	15979	\N
11777	2997	2	0	15980	\N
11766	1910	3	0	15981	\N
11672	38	1	0	16296	\N
11672	2906	2	0	16298	\N
11650	2901	3	0	16299	\N
11757	38	1	0	16303	\N
11757	2906	2	0	16306	\N
11789	3002	127	0	16969	\N
11581	167	1	0	17618	\N
11581	2503	2	0	17619	\N
11728	30	2	0	18075	\N
11728	2980	3	0	18077	\N
11563	2892	2	0	18737	\N
11563	2893	3	0	18738	\N
11762	2923	3	0	20593	\N
11796	3008	126	1	20644	\N
11796	3007	32	0	20648	\N
11793	64	1	0	20656	\N
11793	1428	2	0	20659	\N
11796	64	125	0	20664	\N
11639	264	1	0	23464	\N
11639	2941	2	0	23465	\N
11600	2911	2	0	24198	\N
11549	69	0	0	24635	\N
11608	69	2	0	24652	\N
11608	2920	3	0	24653	\N
11758	2988	3	0	25184	\N
11575	206	1	0	25915	\N
11575	2900	2	0	25916	\N
11570	90	1	0	25985	\N
11570	2897	2	0	25986	\N
11752	86	1	0	26584	\N
11752	2967	2	0	26585	\N
11782	86	1	0	26592	\N
11782	2967	2	0	26594	\N
11662	94	1	0	26870	\N
11662	2054	2	0	26871	\N
11609	16	3	0	28396	\N
11590	96	1	0	29666	\N
11590	2899	2	0	29668	\N
11627	202	1	0	30989	\N
11627	2933	2	0	30990	\N
11765	360	2	0	31350	\N
11765	2767	3	0	31352	\N
11792	230	2	0	32025	\N
11792	3006	3	0	32031	\N
11552	1	1	0	33370	\N
11552	1085	2	0	33372	\N
11620	1	1	0	33396	\N
11620	1085	2	0	33397	\N
11623	2930	4	0	33404	\N
11685	1	9	0	33419	\N
11698	1	1	0	33420	\N
11698	1085	2	0	33421	\N
11685	2965	10	0	33422	\N
11736	1	7	0	33435	\N
11736	2881	8	0	33438	\N
11734	315	5	0	35266	\N
11785	2	2	0	35282	\N
11785	2990	3	0	35284	\N
11748	6	1	0	36247	\N
11748	2261	2	0	36249	\N
11578	2887	3	0	36977	\N
11595	2887	2	0	36987	\N
11605	10	3	0	36992	\N
11595	10	3	0	36993	\N
11605	2917	4	0	36994	\N
11637	10	0	0	37007	\N
11678	10	1	0	37018	\N
11678	1416	2	0	37020	\N
11710	10	0	0	37029	\N
11732	10	1	0	37030	\N
11742	10	1	0	37031	\N
11754	10	0	0	37032	\N
11742	1416	2	0	37035	\N
11771	10	2	0	37052	\N
11771	275	3	0	37053	\N
11669	27	1	0	41246	\N
11669	2885	2	0	41249	\N
11730	1383	2	0	42306	\N
11844	40	1	0	42365	\N
11844	1383	2	0	42366	\N
11601	56	2	0	44088	\N
11601	2914	3	0	44089	\N
11571	75	1	0	45691	\N
11679	75	1	0	45693	\N
11571	1427	2	0	45696	\N
11679	1427	2	0	45698	\N
11561	79	1	0	46322	\N
11717	79	0	0	46325	\N
11561	1126	2	0	46326	\N
11668	79	1	0	46371	\N
11688	79	1	0	46372	\N
11721	79	5	0	46373	\N
11668	1126	2	0	46374	\N
11688	1126	2	0	46375	\N
11721	2978	6	0	46376	\N
11800	88	2	0	47081	\N
11800	3010	3	0	47085	\N
11606	100	2	0	47509	\N
11606	2918	3	0	47511	\N
11665	147	1	0	49951	\N
11665	2957	2	0	49954	\N
11603	156	0	0	50178	\N
11684	156	9	0	50183	\N
11684	2964	10	0	50186	\N
11744	170	2	0	50504	\N
11744	2986	3	0	50505	\N
11615	273	1	0	53123	\N
11615	1417	2	0	53124	\N
11636	279	4	0	53189	\N
11636	2940	5	0	53190	\N
11851	285	2	0	53371	\N
11851	3036	3	0	53372	\N
11735	324	7	0	54143	\N
11786	324	0	0	54144	\N
11735	2981	8	0	54152	\N
11842	353	1	0	54554	\N
11842	1092	2	0	54555	\N
11646	362	1	0	54777	\N
11646	2946	2	0	54778	\N
11649	595	2	0	55622	\N
11649	2949	3	0	55631	\N
11593	841	1	0	56973	\N
11593	2907	2	0	56975	\N
11700	2351	1	0	58945	\N
11700	2925	2	0	58946	\N
11854	2351	9	0	58950	\N
11849	2782	0	0	59239	\N
11799	2903	2	0	235	\N
11809	3013	2	0	1116	\N
11709	117	0	0	2211	\N
11772	110	2	0	2466	\N
11774	110	3	0	2467	\N
11772	626	3	0	2470	\N
11774	2995	4	0	2471	\N
11815	2982	1	0	3176	\N
11815	3014	2	0	3182	\N
11830	262	2	0	3729	\N
11830	3027	3	0	3733	\N
11621	35	1	0	4347	\N
11621	2929	2	0	4349	\N
11677	2929	2	0	4351	\N
11739	189	5	0	4742	\N
11739	2984	6	0	4743	\N
11749	373	2	0	5346	\N
11749	2888	3	0	5349	\N
11822	391	1	0	11009	\N
11822	1420	2	0	11010	\N
11618	132	2	0	11104	\N
11618	2927	3	0	11107	\N
11824	108	1	0	11679	\N
11824	3022	2	0	11680	\N
11596	2909	2	0	12240	\N
11764	300	4	0	12263	\N
11764	2992	5	0	12264	\N
11644	402	1	0	14325	\N
11644	2889	2	0	14327	\N
11633	92	1	0	14924	\N
11633	1078	2	0	14925	\N
11576	38	2	0	16288	\N
11576	2901	3	0	16289	\N
11589	38	1	0	16294	\N
11589	2906	2	0	16297	\N
11847	115	1	0	16911	\N
11847	2908	2	0	16915	\N
11719	2977	2	0	17016	\N
11657	290	1	0	18943	\N
11674	290	1	0	18944	\N
11657	2952	2	0	18945	\N
11674	2952	2	0	18946	\N
11746	198	1	0	20310	\N
11746	2829	2	0	20311	\N
11761	488	2	0	21440	\N
11761	2991	3	0	21441	\N
11741	149	1	0	23309	\N
11741	2985	2	0	23310	\N
11659	264	1	0	23472	\N
11654	82	1	0	23741	\N
11654	2951	2	0	23742	\N
11727	214	2	0	24354	\N
11727	2979	3	0	24355	\N
11691	411	1	0	25181	\N
11691	2969	2	0	25183	\N
11632	206	1	0	25918	\N
11632	2900	2	0	25920	\N
11558	86	2	0	26571	\N
11558	2890	3	0	26572	\N
11568	16	1	0	28393	\N
11568	1087	2	0	28394	\N
11702	1087	2	0	28399	\N
11827	16	1	0	28403	\N
11827	1087	2	0	28405	\N
11834	16	5	0	28406	\N
11834	3031	6	0	28411	\N
11573	96	1	0	29655	\N
11573	2899	2	0	29656	\N
11712	202	1	0	31003	\N
11712	2933	2	0	31004	\N
11781	202	1	0	31020	\N
11781	2933	2	0	31022	\N
11579	1	1	0	33371	\N
11652	1	2	0	33407	\N
11652	2950	3	0	33412	\N
11751	1	1	0	33441	\N
11751	1085	2	0	33442	\N
11767	1	2	0	33447	\N
11769	1	3	0	33448	\N
11767	283	3	0	33451	\N
11769	1114	4	0	33452	\N
11725	2	0	0	35248	\N
11807	6	1	0	36248	\N
11807	2261	2	0	36250	\N
11564	10	1	0	36974	\N
11586	10	1	0	36984	\N
11586	1416	2	0	36986	\N
11695	10	2	0	37019	\N
11695	2887	3	0	37021	\N
11705	10	1	0	37028	\N
11705	1416	2	0	37033	\N
11756	10	1	0	37038	\N
11756	1416	2	0	37039	\N
11839	10	1	0	37080	\N
11839	1416	2	0	37081	\N
11779	14	1	0	39069	\N
11779	1926	2	0	39072	\N
11591	40	1	0	42239	\N
11591	1383	2	0	42240	\N
11798	40	1	0	42320	\N
11798	1383	2	0	42321	\N
11841	40	2	0	42336	\N
11841	3034	3	0	42337	\N
11750	56	2	0	44092	\N
11750	2914	3	0	44093	\N
11562	75	1	0	45677	\N
11562	1427	2	0	45678	\N
11733	75	1	0	45694	\N
11733	1427	2	0	45699	\N
11755	75	1	0	45703	\N
11755	1427	2	0	45704	\N
11763	75	2	0	45722	\N
11763	2989	3	0	45724	\N
11724	79	0	0	46427	\N
11569	88	1	0	47069	\N
11569	2896	2	0	47070	\N
11805	147	1	0	49952	\N
11805	2957	2	0	49955	\N
11802	156	1	0	50184	\N
11802	3012	2	0	50185	\N
11610	268	1	0	52707	\N
11610	1422	2	0	52708	\N
11836	268	1	0	52720	\N
11836	1422	2	0	52721	\N
11788	324	2	0	54145	\N
11788	3000	3	0	54150	\N
11780	362	1	0	54781	\N
11780	2946	2	0	54782	\N
11803	595	1	0	55624	\N
11803	2958	2	0	55629	\N
11647	597	2	0	55838	\N
11647	2947	3	0	55846	\N
11731	793	1	0	56621	\N
11731	2972	2	0	56622	\N
11828	908	2	0	57526	\N
11828	3025	3	0	57529	\N
11604	2171	127	0	57982	\N
11616	2351	1	0	58935	\N
11616	2925	2	0	58936	\N
11853	2351	1	0	58949	\N
11853	2925	2	0	58951	\N
11858	2782	0	0	59242	\N
11791	3005	3	0	59464	\N
11784	2998	2	0	1417	\N
11820	3019	2	0	1906	\N
11708	117	7	0	2210	\N
11708	2973	8	0	2212	\N
11825	117	1	0	2214	\N
11825	3023	2	0	2219	\N
11737	2982	7	0	3174	\N
11737	2983	8	0	3189	\N
11619	365	3	0	4454	\N
11619	2928	4	0	4455	\N
11604	1970	126	0	5138	\N
11687	391	2	0	11008	\N
11687	2966	3	0	11011	\N
11597	300	3	0	12252	\N
11628	77	1	0	13026	\N
11628	2934	2	0	13028	\N
11630	58	1	0	13469	\N
11630	2936	2	0	13470	\N
11634	2937	83	0	14911	\N
11634	92	113	0	14926	\N
11660	92	1	0	14932	\N
11660	1078	2	0	14934	\N
11634	2938	114	0	15075	\N
11833	192	5	0	15540	\N
11833	3030	6	0	15546	\N
11846	2906	2	0	16307	\N
11594	115	1	0	16905	\N
11594	2908	2	0	16906	\N
11783	212	1	0	17014	\N
11783	2977	2	0	17017	\N
11635	326	4	0	17537	\N
11663	326	5	0	17538	\N
11635	2939	5	0	17539	\N
11663	2955	6	0	17540	\N
11837	326	2	0	17547	\N
11837	393	3	0	17548	\N
11611	167	3	0	17628	\N
11625	30	5	0	18073	\N
11625	2931	6	0	18074	\N
11768	30	2	0	18076	\N
11768	1127	3	0	18078	\N
11634	1075	114	1	21913	\N
11604	2915	32	0	22298	\N
11604	67	125	0	22309	\N
11604	2916	126	1	22310	\N
11682	336	9	0	22913	\N
11682	2962	10	0	22916	\N
11829	264	2	0	23473	\N
11829	3026	3	0	23475	\N
11860	49	1	0	24996	\N
11860	1086	2	0	24999	\N
11607	2919	3	0	25001	\N
11826	224	11	0	25413	\N
11826	3024	12	0	25415	\N
11689	86	1	0	26578	\N
11689	2967	2	0	26579	\N
11806	16	1	0	28402	\N
11806	1087	2	0	28404	\N
11640	96	2	0	29667	\N
11640	2942	3	0	29669	\N
11713	20	0	0	30364	\N
11715	2975	2	0	30366	\N
11819	3015	3	0	30368	\N
11819	20	4	0	30380	\N
11812	202	1	0	31021	\N
11812	2933	2	0	31023	\N
11559	322	2	0	32537	\N
11559	2891	3	0	32538	\N
11810	322	1	0	32543	\N
11810	2968	2	0	32546	\N
11670	1	1	0	33408	\N
11675	1	1	0	33409	\N
11670	1085	2	0	33410	\N
11681	1	2	0	33415	\N
11681	2950	3	0	33416	\N
11707	1	1	0	33431	\N
11707	1085	2	0	33432	\N
11740	1	1	0	33436	\N
11740	1085	2	0	33437	\N
11794	1	1	0	33449	\N
11794	1085	2	0	33450	\N
11814	1	1	0	33455	\N
11814	1085	2	0	33457	\N
11760	2	2	0	35281	\N
11760	2990	3	0	35283	\N
11584	10	1	0	36983	\N
11584	1416	2	0	36985	\N
11624	10	3	0	36997	\N
11624	2917	4	0	36998	\N
11673	1416	1	0	37010	\N
11653	10	1	0	37013	\N
11653	1416	2	0	37014	\N
11673	10	2	0	37015	\N
11770	10	3	0	37046	\N
11770	297	4	0	37047	\N
11816	10	1	0	37056	\N
11816	1416	2	0	37057	\N
11821	2887	3	0	37069	\N
11865	10	1	0	37084	\N
11574	23	1	0	40876	\N
11574	1089	2	0	40877	\N
11868	40	1	0	42391	\N
11886	40	1	0	42392	\N
11868	1383	2	0	42393	\N
11886	1383	2	0	42394	\N
11902	40	2	0	42409	\N
11882	3055	4	0	43469	\N
11883	51	4	0	43470	\N
11892	51	1	0	43471	\N
11892	1905	2	0	43472	\N
11882	3056	5	0	43473	\N
11883	3056	5	0	43474	\N
11861	56	1	0	44094	\N
11861	1088	2	0	44095	\N
11848	71	1	0	44732	\N
11848	3035	2	0	44733	\N
11855	75	1	0	45736	\N
11900	75	2	0	45737	\N
11855	1427	2	0	45740	\N
11900	2989	3	0	45742	\N
11915	79	25	0	46471	\N
11917	79	1	0	46472	\N
11917	1126	2	0	46473	\N
11915	3067	26	0	46474	\N
11879	3053	2	0	48028	\N
11878	3050	6	0	48032	\N
11879	3054	3	0	48039	\N
11878	3052	7	0	48040	\N
11921	186	2	0	51153	\N
11921	3068	3	0	51154	\N
11887	200	1	0	51507	\N
11887	2785	2	0	51510	\N
11811	273	1	0	52915	\N
11811	1417	2	0	52917	\N
11813	324	1	0	54146	\N
11813	939	2	0	54149	\N
11888	435	1	0	55041	\N
11888	1580	2	0	55042	\N
11866	3044	2	0	55515	\N
11804	597	1	0	55840	\N
11804	2956	2	0	55844	\N
11896	704	1	0	56373	\N
11896	3064	2	0	56374	\N
11843	793	1	0	56623	\N
11843	2972	2	0	56625	\N
11875	3048	69	0	57834	\N
11894	2171	94	1	58096	\N
11823	3020	0	0	58471	\N
11818	3016	4	0	58670	\N
11854	3037	10	0	58952	\N
11850	2782	2	0	59240	\N
11852	2782	0	0	59241	\N
11859	2782	1	0	59243	\N
11859	2959	2	0	59245	\N
11850	2784	3	0	59246	\N
11878	3051	7	0	59446	\N
11831	3028	3	0	250	\N
11904	2903	2	0	257	\N
11838	424	1	0	698	\N
11856	424	2	0	699	\N
11838	3033	2	0	700	\N
11856	3038	3	0	701	\N
11801	251	2	0	1430	\N
11801	3011	3	0	1431	\N
11879	2088	3	0	1848	\N
11882	2088	4	0	1849	\N
11823	3021	0	0	2224	\N
11897	367	2	0	3263	\N
11897	3065	3	0	3264	\N
11903	3027	3	0	3734	\N
11875	3049	69	1	12372	\N
11875	3047	10	0	12413	\N
11874	528	1	0	12426	\N
11874	1093	2	0	12429	\N
11875	528	68	0	12432	\N
11796	124	126	0	12727	\N
11808	77	1	0	13027	\N
11808	2934	2	0	13029	\N
11884	258	4	0	14373	\N
11884	3057	5	0	14374	\N
11840	173	1	0	14605	\N
11894	3061	94	0	14877	\N
11893	92	2	0	14933	\N
11893	3060	3	0	14935	\N
11894	92	126	0	14947	\N
11894	3062	127	0	14948	\N
11920	115	1	0	16912	\N
11920	2908	2	0	16916	\N
11890	212	1	0	17015	\N
11890	2977	2	0	17018	\N
11895	60	2	0	19382	\N
11895	3063	3	0	19383	\N
11908	198	1	0	20313	\N
11889	488	1	0	21456	\N
11889	3059	2	0	21460	\N
11894	1075	95	0	22030	\N
11796	3009	127	0	22031	\N
11862	73	3	0	22417	\N
11862	3040	4	0	22419	\N
11880	1379	2	0	23311	\N
11880	149	3	0	23317	\N
11914	411	1	0	25190	\N
11914	2969	2	0	25191	\N
11871	224	3	0	25430	\N
11871	3045	4	0	25431	\N
11913	2900	2	0	25921	\N
11857	90	2	0	25990	\N
11857	3039	3	0	25992	\N
11869	94	1	0	26872	\N
11869	2054	2	0	26873	\N
11912	16	1	0	28407	\N
11912	1087	2	0	28409	\N
11885	320	1	0	29314	\N
11885	3058	2	0	29315	\N
11867	96	1	0	29674	\N
11899	96	2	0	29675	\N
11867	2899	2	0	29676	\N
11864	3042	46	0	29990	\N
11863	54	3	0	30010	\N
11863	3041	4	0	30011	\N
11864	54	126	0	30012	\N
11864	3043	127	0	30013	\N
11818	3015	3	0	30367	\N
11818	3017	4	0	30379	\N
11845	20	1	0	30385	\N
11845	2975	2	0	30387	\N
11873	151	3	0	30893	\N
11873	3046	4	0	30895	\N
11876	1	1	0	33456	\N
11832	2	5	0	35295	\N
11832	3029	6	0	35296	\N
11817	10	2	0	37062	\N
11817	2887	3	0	37063	\N
11835	10	4	0	37074	\N
11835	3032	5	0	37075	\N
11865	1416	2	0	37085	\N
11870	10	2	0	37090	\N
11870	275	3	0	37091	\N
11872	10	3	0	37100	\N
11877	10	1	0	37101	\N
11877	1416	2	0	37102	\N
11881	275	2	0	37104	\N
11881	10	3	0	37113	\N
11891	10	1	0	37118	\N
11891	1416	2	0	37119	\N
11901	10	1	0	37122	\N
11901	1416	2	0	37123	\N
11924	10	1	0	37126	\N
11924	1416	2	0	37127	\N
11902	3034	3	0	42410	\N
11919	40	1	0	42428	\N
11919	1383	2	0	42429	\N
11941	40	8	0	42443	\N
11957	40	1	0	42444	\N
11957	1383	2	0	42445	\N
11941	3075	9	0	42446	\N
11969	40	2	0	42456	\N
11974	40	1	0	42457	\N
11974	1383	2	0	42458	\N
11969	3034	3	0	42459	\N
11911	51	1	0	43479	\N
11940	51	2	0	43480	\N
11911	1905	2	0	43481	\N
11940	3074	3	0	43482	\N
11943	51	1	0	43493	\N
11943	1905	2	0	43497	\N
11905	75	1	0	45738	\N
11905	1427	2	0	45741	\N
11909	75	1	0	45747	\N
11909	1427	2	0	45748	\N
11929	75	1	0	45760	\N
11929	1427	2	0	45763	\N
11910	113	1	0	48193	\N
11910	1102	2	0	48195	\N
11970	135	2	0	49439	\N
11977	135	2	0	49440	\N
11970	3088	3	0	49446	\N
11977	3088	3	0	49447	\N
11971	137	2	0	49684	\N
11971	3089	3	0	49685	\N
11978	137	2	0	49708	\N
11978	3089	3	0	49710	\N
11990	156	2	0	50201	\N
11990	3093	3	0	50203	\N
11918	200	1	0	51508	\N
11918	2785	2	0	51511	\N
11966	260	1	0	52528	\N
11966	1904	2	0	52530	\N
11948	324	2	0	54147	\N
11950	324	0	0	54148	\N
11948	3000	3	0	54151	\N
11907	362	1	0	54787	\N
11907	2946	2	0	54788	\N
11945	362	1	0	54797	\N
11945	2946	2	0	54798	\N
11968	435	1	0	55045	\N
11968	1580	2	0	55046	\N
11942	852	8	0	57198	\N
11942	3076	9	0	57200	\N
11975	852	1	0	57201	\N
11975	2945	2	0	57202	\N
11936	2998	2	0	1439	\N
11949	2999	3	0	3187	\N
11991	367	2	0	3267	\N
11976	262	2	0	3731	\N
11976	3027	3	0	3735	\N
11979	3090	1	0	4027	\N
11979	3091	2	0	4028	\N
11926	365	1	0	4482	\N
11926	1424	2	0	4483	\N
11962	108	5	0	11693	\N
11964	108	1	0	11694	\N
11964	3022	2	0	11697	\N
11962	3086	6	0	11700	\N
11972	77	1	0	13039	\N
11916	2934	2	0	13040	\N
11972	2934	2	0	13041	\N
11986	233	1	0	13728	\N
11986	1418	2	0	13732	\N
11951	3078	17	0	14876	\N
11947	92	5	0	14949	\N
11947	3077	6	0	14952	\N
11951	92	16	0	14967	\N
11956	38	2	0	16305	\N
11956	2901	3	0	16308	\N
11930	212	3	0	17030	\N
11985	290	1	0	18952	\N
11985	2952	2	0	18953	\N
11960	198	2	0	20315	\N
11960	3084	3	0	20316	\N
11961	164	2	0	20999	\N
11981	164	1	0	21000	\N
11981	3092	2	0	21001	\N
11961	3085	3	0	21002	\N
11951	1075	18	0	22032	\N
11898	67	1	0	22303	\N
11898	3066	2	0	22304	\N
11906	336	1	0	22936	\N
11982	336	1	0	22940	\N
11982	2970	2	0	22941	\N
11934	149	32	0	23316	\N
11934	3072	33	0	23318	\N
11952	149	20	0	23323	\N
11952	3080	21	0	23324	\N
11927	140	1	0	24216	\N
11927	3069	2	0	24217	\N
11959	69	2	0	24682	\N
11959	2920	3	0	24683	\N
11932	49	1	0	24997	\N
11932	1086	2	0	25000	\N
11955	3083	3	0	25445	\N
11928	94	1	0	26874	\N
11928	2054	2	0	26875	\N
11989	94	1	0	26876	\N
11989	2054	2	0	26877	\N
11923	16	1	0	28408	\N
11923	1087	2	0	28410	\N
11973	16	1	0	28412	\N
11980	16	1	0	28413	\N
11973	1087	2	0	28415	\N
11980	1087	2	0	28416	\N
11953	96	4	0	29680	\N
11951	3079	17	1	30322	\N
11935	151	1	0	30898	\N
11935	3073	2	0	30899	\N
11963	360	1	0	31361	\N
11963	2886	2	0	31363	\N
11965	230	1	0	32026	\N
11983	230	1	0	32027	\N
11965	3087	2	0	32029	\N
11983	3087	2	0	32030	\N
11931	322	3	0	32544	\N
11931	3071	4	0	32547	\N
11922	1	1	0	33461	\N
11925	1	2	0	33465	\N
11925	2950	3	0	33466	\N
11946	1	2	0	33471	\N
11946	2950	3	0	33472	\N
11937	2	0	0	35307	\N
11939	2	0	0	35319	\N
11933	10	1	0	37132	\N
11933	1416	2	0	37133	\N
11938	10	3	0	37138	\N
11938	2917	4	0	37139	\N
11944	10	1	0	37142	\N
11944	1416	2	0	37143	\N
11967	10	1	0	37149	\N
11958	1416	2	0	37150	\N
11967	1416	2	0	37151	\N
11984	10	1	0	37154	\N
11984	1416	2	0	37155	\N
11988	10	1	0	37162	\N
11988	1416	2	0	37165	\N
11954	14	4	0	39070	\N
11954	3082	5	0	39073	\N
11987	14	1	0	39078	\N
11987	1926	2	0	39085	\N
11997	40	1	0	42483	\N
12006	40	1	0	42484	\N
12030	40	1	0	42485	\N
11997	1383	2	0	42487	\N
12006	1383	2	0	42488	\N
12030	1383	2	0	42489	\N
12197	40	1	0	42528	\N
12197	1383	2	0	42529	\N
12251	40	1	0	42543	\N
12251	1383	2	0	42545	\N
12051	56	1	0	44100	\N
12051	1088	2	0	44102	\N
12003	75	1	0	45761	\N
12003	1427	2	0	45764	\N
12221	75	2	0	45769	\N
12221	2989	3	0	45774	\N
12137	88	1	0	47082	\N
12137	2896	2	0	47084	\N
12246	88	2	0	47092	\N
12246	2799	3	0	47095	\N
12131	113	0	0	48204	\N
12072	119	1	0	48702	\N
12072	3128	2	0	48703	\N
12099	135	2	0	49441	\N
12099	3088	3	0	49448	\N
12016	200	2	0	51524	\N
12016	3109	3	0	51525	\N
12241	210	1	0	51749	\N
12241	2926	2	0	51750	\N
12142	324	2	0	54155	\N
12142	3000	3	0	54156	\N
12206	324	1	0	54168	\N
12206	939	2	0	54170	\N
12236	324	0	0	54178	\N
12313	2578	2	0	58585	\N
12313	3224	3	0	58586	\N
12278	2636	1	0	58679	\N
12278	3207	2	0	58681	\N
12232	2351	5	0	58960	\N
12232	3185	6	0	58961	\N
12054	2782	1	0	59253	\N
12054	2959	2	0	59255	\N
12001	3038	3	0	720	\N
12200	3033	2	0	739	\N
12009	251	1	0	1437	\N
12009	2998	2	0	1440	\N
12213	2489	1	0	1728	\N
12213	3174	2	0	1729	\N
12144	2982	2	0	3178	\N
12144	2999	3	0	3188	\N
11991	3065	3	0	3268	\N
12044	35	1	0	4354	\N
12044	2929	2	0	4355	\N
11998	1151	1	0	5189	\N
11998	3097	2	0	5190	\N
12106	3141	2	0	5205	\N
12063	391	4	0	11016	\N
12063	3123	5	0	11017	\N
12041	132	1	0	11105	\N
12041	3116	2	0	11106	\N
12096	132	1	0	11125	\N
12096	3116	2	0	11126	\N
12181	300	4	0	12277	\N
12181	3161	5	0	12280	\N
12014	528	1	0	12427	\N
12014	1093	2	0	12430	\N
12324	58	2	0	13481	\N
12218	3179	3	0	14610	\N
12290	3210	13	0	14953	\N
12290	92	22	0	14974	\N
12290	3211	23	0	14975	\N
12171	115	1	0	16913	\N
12187	115	1	0	16914	\N
12171	2908	2	0	16917	\N
12187	2908	2	0	16918	\N
12154	212	1	0	17032	\N
12154	2977	2	0	17035	\N
12203	31	1	0	18079	\N
12203	30	3	0	18080	\N
12192	177	28	0	18320	\N
12192	3167	29	0	18323	\N
12305	142	4	0	18496	\N
12305	3219	5	0	18503	\N
12216	290	2	0	18965	\N
12216	3176	3	0	18967	\N
12116	198	1	0	20317	\N
12116	2829	2	0	20318	\N
12225	198	3	0	20320	\N
12225	3181	4	0	20322	\N
11992	241	1	0	20374	\N
11992	3094	2	0	20375	\N
12125	3059	2	0	21461	\N
12078	67	1	0	22101	\N
12078	3066	2	0	22105	\N
12058	82	1	0	23753	\N
12058	2951	2	0	23755	\N
12166	82	4	0	23760	\N
12166	3155	5	0	23761	\N
12118	930	0	0	23935	\N
12066	214	1	0	24372	\N
12066	1382	2	0	24374	\N
12239	49	1	0	25005	\N
12239	1086	2	0	25006	\N
12114	2813	2	0	25444	\N
12052	86	1	0	26600	\N
12052	2967	2	0	26601	\N
12177	42	1	0	27475	\N
12177	2823	2	0	27478	\N
11993	16	1	0	28414	\N
11993	1087	2	0	28417	\N
12108	320	1	0	29334	\N
12108	3058	2	0	29335	\N
12182	96	2	0	29692	\N
12182	2347	3	0	29695	\N
12149	33	1	0	31685	\N
11995	453	1	0	32648	\N
12083	453	2	0	32650	\N
11995	3095	2	0	32653	\N
12083	3133	3	0	32656	\N
12020	1	1	0	33475	\N
12020	1085	2	0	33477	\N
12140	1	0	0	33518	\N
12243	1	1	0	33551	\N
12243	1085	2	0	33552	\N
12264	1	1	0	33571	\N
12264	1085	2	0	33573	\N
11996	431	1	0	34807	\N
11994	10	1	0	37163	\N
11994	1416	2	0	37166	\N
12075	10	3	0	37186	\N
12075	2917	4	0	37187	\N
12151	10	1	0	37210	\N
12151	1416	2	0	37212	\N
12222	10	1	0	37248	\N
12222	1416	2	0	37249	\N
12269	10	0	0	37258	\N
12275	10	1	0	37264	\N
12280	10	1	0	37265	\N
12275	1416	2	0	37267	\N
12303	10	2	0	37276	\N
12303	3169	3	0	37278	\N
12310	10	2	0	37282	\N
12310	3169	3	0	37283	\N
12048	14	1	0	39079	\N
12048	1926	2	0	39086	\N
12249	23	4	0	40646	\N
12249	3189	5	0	40650	\N
12035	56	1	0	44098	\N
12035	1088	2	0	44099	\N
12068	56	4	0	44101	\N
12068	3127	5	0	44103	\N
12256	56	1	0	44104	\N
12094	75	3	0	45762	\N
12094	3139	4	0	45765	\N
12224	75	1	0	45770	\N
12245	75	4	0	45771	\N
12224	1427	2	0	45773	\N
12245	3187	5	0	45775	\N
12005	79	1	0	46537	\N
12005	1126	2	0	46538	\N
12202	113	4	0	48206	\N
12202	3170	5	0	48208	\N
11999	121	1	0	48881	\N
11999	3098	2	0	48882	\N
12353	147	1	0	49953	\N
12353	2957	2	0	49956	\N
12032	170	1	0	50515	\N
12032	1072	2	0	50516	\N
12339	210	1	0	51767	\N
12339	2926	2	0	51768	\N
12141	3146	3	1	52615	\N
12141	268	2	0	52726	\N
12189	268	3	0	52728	\N
12189	3165	4	0	52730	\N
12247	285	2	0	53409	\N
12247	3036	3	0	53411	\N
12038	316	1	0	53883	\N
12038	3115	2	0	53884	\N
12082	316	2	0	53892	\N
12082	3132	3	0	53896	\N
12172	435	2	0	55047	\N
12172	3156	3	0	55048	\N
12110	852	1	0	57204	\N
12110	2945	2	0	57206	\N
12328	908	4	0	57535	\N
12355	908	2	0	57536	\N
12355	3025	3	0	57537	\N
12328	3230	5	0	57539	\N
12091	3051	32	0	59447	\N
12129	3013	2	0	1119	\N
12105	1954	2	0	1176	\N
12008	3101	1	0	1885	\N
12008	3102	2	0	1886	\N
12141	2583	4	0	2341	\N
12208	2982	1	0	3179	\N
12208	3014	2	0	3183	\N
12047	391	1	0	11012	\N
12047	1420	2	0	11013	\N
12141	3145	3	0	11626	\N
12015	3107	81	0	12373	\N
12015	3106	33	0	12414	\N
12015	528	80	0	12433	\N
12013	528	120	0	12452	\N
12013	3105	121	0	12653	\N
12254	77	1	0	13047	\N
12254	2934	2	0	13049	\N
12024	58	1	0	13474	\N
12024	2936	2	0	13475	\N
12040	58	1	0	13480	\N
12040	2936	2	0	13483	\N
12324	3228	3	0	13484	\N
12097	402	1	0	14326	\N
12097	2889	2	0	14328	\N
12136	402	1	0	14331	\N
12018	235	1	0	15924	\N
12018	2904	2	0	15925	\N
12124	142	1	0	18495	\N
12124	3117	2	0	18499	\N
12015	3108	81	1	18787	\N
12164	290	0	0	18958	\N
12176	60	3	0	19391	\N
12176	3158	4	0	19392	\N
12212	198	1	0	20319	\N
12212	2829	2	0	20321	\N
12026	241	2	0	20378	\N
12026	2923	3	0	20379	\N
12085	2923	3	0	20394	\N
12091	3135	31	0	20616	\N
12091	3136	32	0	20623	\N
12013	1075	121	1	21849	\N
12071	67	1	0	22095	\N
12071	3066	2	0	22096	\N
12112	73	3	0	22418	\N
12112	3040	4	0	22420	\N
12067	3125	28	0	23325	\N
12067	149	88	0	23336	\N
12067	3126	89	0	23337	\N
12050	82	1	0	23752	\N
12229	140	2	0	24235	\N
12229	3183	3	0	24237	\N
12179	49	4	0	24998	\N
12179	3159	5	0	25002	\N
12157	224	1	0	25443	\N
12157	225	2	0	25446	\N
12056	94	1	0	26878	\N
12056	2054	2	0	26879	\N
12178	94	1	0	26884	\N
12178	2054	2	0	26885	\N
12160	1361	5	0	27173	\N
12160	3151	6	0	27174	\N
12100	2974	3	0	28425	\N
12196	16	2	0	28426	\N
12196	2974	3	0	28427	\N
12117	54	1	0	30018	\N
12117	3142	2	0	30019	\N
12023	20	2	0	30399	\N
12023	3111	3	0	30400	\N
12148	33	0	0	31684	\N
12007	453	1	0	32649	\N
12007	3095	2	0	32654	\N
12089	1	2	0	33497	\N
12089	2950	3	0	33499	\N
12134	2930	4	0	33515	\N
12152	1	1	0	33525	\N
12152	1085	2	0	33526	\N
12199	1	3	0	33531	\N
12199	2814	4	0	33534	\N
12214	1	1	0	33537	\N
12214	1085	2	0	33538	\N
12334	1	1	0	33578	\N
12334	1085	2	0	33579	\N
12074	2	3	0	35334	\N
12173	2	3	0	35336	\N
12074	3129	4	0	35338	\N
12325	2	4	0	35376	\N
12325	3229	5	0	35377	\N
12028	4	1	0	35874	\N
12028	3114	2	0	35876	\N
12042	10	1	0	37178	\N
12042	1416	2	0	37179	\N
12079	10	1	0	37192	\N
12079	1416	2	0	37195	\N
12145	10	5	0	37202	\N
12145	3148	6	0	37203	\N
12168	10	1	0	37221	\N
12168	1416	2	0	37222	\N
12193	1416	2	0	37227	\N
12220	10	2	0	37247	\N
12220	2887	3	0	37250	\N
12234	10	1	0	37253	\N
12234	1416	2	0	37254	\N
12329	10	0	0	37287	\N
12186	27	2	0	41248	\N
12186	3164	3	0	41251	\N
12033	56	1	0	44096	\N
12033	1088	2	0	44097	\N
12256	1088	2	0	44106	\N
12138	71	1	0	44738	\N
12138	3035	2	0	44739	\N
12123	75	1	0	45768	\N
12123	1427	2	0	45772	\N
12219	79	2	0	46629	\N
12219	3180	3	0	46634	\N
12188	186	1	0	51161	\N
12188	1080	2	0	51163	\N
12204	200	1	0	51535	\N
12204	2785	2	0	51536	\N
12143	268	2	0	52727	\N
12143	3147	3	0	52894	\N
12076	285	1	0	53399	\N
12076	3112	2	0	53400	\N
12207	324	0	0	54169	\N
12233	324	1	0	54177	\N
12233	939	2	0	54186	\N
12088	353	2	0	54564	\N
12088	3134	3	0	54568	\N
12284	435	2	0	55049	\N
12284	3156	3	0	55050	\N
12242	852	1	0	57207	\N
12242	2945	2	0	57210	\N
12209	46	6	0	639	\N
12019	424	1	0	736	\N
12019	3033	2	0	738	\N
12155	266	1	0	1185	\N
12155	1954	2	0	1186	\N
12261	3193	38	0	2213	\N
12259	117	3	0	2215	\N
12259	3191	4	0	2220	\N
12261	117	125	0	2225	\N
12143	2583	3	1	2337	\N
12002	110	2	0	2468	\N
12002	3100	3	0	2469	\N
12244	228	3	0	2980	\N
12237	2982	1	0	3180	\N
12237	3014	2	0	3184	\N
12011	189	6	0	4752	\N
12011	3103	7	0	4753	\N
12121	189	2	0	4765	\N
12121	3143	3	0	4766	\N
12090	132	2	0	11116	\N
12090	2927	3	0	11117	\N
12150	132	1	0	11136	\N
12231	132	1	0	11137	\N
12252	132	0	0	11138	\N
12150	3116	2	0	11140	\N
12261	3195	126	1	11593	\N
12029	108	1	0	11695	\N
12287	108	1	0	11696	\N
12029	3022	2	0	11698	\N
12287	3022	2	0	11699	\N
12027	108	3	0	11711	\N
12027	3113	4	0	11712	\N
12217	3177	113	0	11943	\N
12217	459	126	0	11953	\N
12217	3178	127	0	11954	\N
12195	300	1	0	12278	\N
12195	3168	2	0	12279	\N
12061	3122	114	0	12741	\N
12059	123	63	0	12746	\N
12059	3121	64	0	12747	\N
12061	123	126	0	12757	\N
12061	1868	127	0	12758	\N
12102	258	2	0	14391	\N
12102	3140	3	0	14394	\N
12260	173	3	0	14617	\N
12260	3192	4	0	14618	\N
12109	212	1	0	17031	\N
12109	2977	2	0	17034	\N
12084	167	2	0	17633	\N
12226	30	3	0	18082	\N
12226	3182	4	0	18084	\N
12000	142	2	0	18493	\N
12000	3099	3	0	18500	\N
12093	2544	43	0	20619	\N
12093	3138	44	0	20622	\N
12043	336	1	0	22944	\N
12211	336	1	0	22945	\N
12043	2970	2	0	22947	\N
12211	2970	2	0	22948	\N
12185	3162	66	0	23338	\N
12185	149	103	0	23346	\N
12128	140	1	0	24228	\N
12128	3069	2	0	24229	\N
12228	140	1	0	24234	\N
12228	141	2	0	24236	\N
12156	224	2	0	25442	\N
12156	3150	3	0	25447	\N
12175	86	3	0	26604	\N
12175	3157	4	0	26606	\N
12064	94	4	0	26880	\N
12162	94	5	0	26881	\N
12064	3124	5	0	26882	\N
12162	3153	6	0	26883	\N
12036	2974	3	0	28419	\N
12268	16	1	0	28430	\N
12268	1087	2	0	28431	\N
12081	96	3	0	29681	\N
12081	3131	4	0	29682	\N
12132	96	3	0	29690	\N
12132	3131	4	0	29694	\N
12183	202	1	0	31034	\N
12183	2933	2	0	31036	\N
12135	360	1	0	31362	\N
12135	2886	2	0	31364	\N
12240	453	1	0	32651	\N
12070	1	2	0	33476	\N
12070	2950	3	0	33478	\N
12073	1085	1	0	33479	\N
12073	1	3	0	33484	\N
12073	1085	4	0	33485	\N
12107	1	0	0	33503	\N
12126	1	1	0	33510	\N
12126	1085	2	0	33511	\N
12223	1	1	0	33541	\N
12223	1085	2	0	33542	\N
12258	1	1	0	33567	\N
12258	1085	2	0	33568	\N
12119	2990	3	0	35337	\N
12010	10	1	0	37164	\N
12010	1416	2	0	37167	\N
12031	10	1	0	37174	\N
12031	1416	2	0	37175	\N
12104	10	1	0	37193	\N
12111	10	1	0	37194	\N
12104	1416	2	0	37196	\N
12111	1416	2	0	37197	\N
12147	10	1	0	37206	\N
12147	1416	2	0	37207	\N
12191	10	3	0	37225	\N
12198	10	2	0	37233	\N
12198	3169	3	0	37234	\N
12201	10	1	0	37237	\N
12201	1416	2	0	37238	\N
12266	10	1	0	37257	\N
12266	1416	2	0	37259	\N
12273	14	1	0	39080	\N
12277	14	0	0	39083	\N
12273	1926	2	0	39087	\N
12055	27	1	0	41247	\N
12055	2885	2	0	41250	\N
12034	40	2	0	42486	\N
12034	282	3	0	42490	\N
12046	40	1	0	42499	\N
12065	40	1	0	42500	\N
12046	1383	2	0	42501	\N
12065	1383	2	0	42502	\N
12113	40	1	0	42510	\N
12113	1383	2	0	42511	\N
12307	75	1	0	45786	\N
12307	1427	2	0	45787	\N
12017	79	1	0	46591	\N
12017	1126	2	0	46592	\N
12263	3200	15	1	47828	\N
12262	102	1	0	48037	\N
12262	3197	2	0	48038	\N
12263	102	13	0	48056	\N
12133	113	3	0	48205	\N
12133	3144	4	0	48207	\N
12098	137	2	0	49709	\N
12098	3089	3	0	49711	\N
12161	156	5	0	50202	\N
12161	3152	6	0	50204	\N
12080	170	1	0	50521	\N
12080	1072	2	0	50522	\N
12300	210	1	0	51759	\N
12300	2926	2	0	51760	\N
12039	242	1	0	52098	\N
12194	242	1	0	52099	\N
12039	2768	2	0	52101	\N
12194	2768	2	0	52102	\N
12230	260	2	0	52529	\N
12230	3184	3	0	52531	\N
12115	268	1	0	52725	\N
12115	1422	2	0	52729	\N
12022	279	1	0	53197	\N
12022	3110	2	0	53198	\N
12025	285	1	0	53381	\N
12025	3112	2	0	53382	\N
12235	285	1	0	53408	\N
12235	3112	2	0	53410	\N
12180	362	4	0	54801	\N
12180	3160	5	0	54804	\N
12021	852	1	0	57203	\N
12021	2945	2	0	57205	\N
12146	908	1	0	57527	\N
12146	3149	2	0	57528	\N
12261	3194	126	0	57966	\N
12263	3198	14	0	58672	\N
12263	3201	16	0	59116	\N
12263	3202	16	1	59459	\N
12101	3028	3	0	267	\N
12169	2903	2	0	280	\N
12248	424	4	0	746	\N
12248	3188	5	0	747	\N
12263	3204	17	1	1843	\N
12261	3196	127	0	1911	\N
12261	2583	127	1	2345	\N
12158	262	2	0	3751	\N
12159	262	1	0	3752	\N
12159	263	2	0	3757	\N
12158	2743	3	0	3758	\N
12130	365	3	0	4490	\N
12130	2928	4	0	4494	\N
12263	1970	14	1	5129	\N
12060	391	1	0	11014	\N
12060	1420	2	0	11015	\N
12103	391	2	0	11018	\N
12103	2966	3	0	11019	\N
12127	391	2	0	11020	\N
12127	2966	3	0	11021	\N
12302	132	2	0	11139	\N
12302	3218	3	0	11142	\N
12215	459	2	0	11950	\N
12215	3175	3	0	11951	\N
12238	77	1	0	13046	\N
12037	58	1	0	13479	\N
12037	2936	2	0	13482	\N
12263	3199	15	0	13635	\N
12263	3203	17	0	15222	\N
12049	44	1	0	15987	\N
12049	2997	2	0	15988	\N
12087	326	1	0	17557	\N
12087	1534	2	0	17558	\N
12139	326	0	0	17561	\N
12190	177	3	0	18319	\N
12190	3166	4	0	18322	\N
12288	3208	1	0	18385	\N
12045	142	1	0	18494	\N
12045	3117	2	0	18498	\N
12170	290	1	0	18959	\N
12170	2952	2	0	18960	\N
12077	62	1	0	19713	\N
12077	3130	2	0	19714	\N
12092	2544	2	0	20618	\N
12092	3137	3	0	20620	\N
12312	164	2	0	21009	\N
12062	90	2	0	25991	\N
12062	3039	3	0	25993	\N
12012	86	1	0	26593	\N
12184	94	1	0	26886	\N
12184	2054	2	0	26887	\N
12292	94	3	0	26888	\N
12292	3212	4	0	26889	\N
12053	16	4	0	28420	\N
12053	3118	5	0	28421	\N
12122	16	1	0	28423	\N
12122	1087	2	0	28424	\N
12265	16	1	0	28428	\N
12265	1087	2	0	28429	\N
12255	320	0	0	29345	\N
12153	96	1	0	29691	\N
12004	20	3	0	30386	\N
12004	3015	4	0	30388	\N
12057	33	1	0	31683	\N
12057	3119	2	0	31686	\N
12295	230	10	0	32028	\N
12295	3214	11	0	32034	\N
12285	453	4	0	32652	\N
12285	798	5	0	32660	\N
12086	1	2	0	33492	\N
12086	2950	3	0	33493	\N
12095	1	3	0	33498	\N
12095	2930	4	0	33500	\N
12174	1	3	0	33530	\N
12174	2930	4	0	33532	\N
12163	3154	6	0	33533	\N
12227	1	1	0	33547	\N
12227	1085	2	0	33548	\N
12253	1	1	0	33559	\N
12253	1085	2	0	33560	\N
12205	2	1	0	35355	\N
12205	1091	2	0	35356	\N
12069	4	1	0	35875	\N
12069	3114	2	0	35877	\N
12165	10	0	0	37211	\N
12210	3173	4	0	37244	\N
12282	10	2	0	37266	\N
12282	275	3	0	37269	\N
12304	10	2	0	37277	\N
12304	3169	3	0	37279	\N
12271	14	0	0	39071	\N
12274	14	0	0	39081	\N
12297	14	1	0	39084	\N
12297	1926	2	0	39088	\N
12250	23	17	0	40647	\N
12250	3190	18	0	40653	\N
12257	27	1	0	41264	\N
12503	3266	2	0	42585	\N
12298	56	2	0	44105	\N
12298	3216	3	0	44107	\N
12376	56	1	0	44110	\N
12390	56	0	0	44112	\N
12376	1088	2	0	44114	\N
12479	56	3	0	44116	\N
12479	1188	4	0	44117	\N
12450	71	0	0	44752	\N
12270	75	7	0	45782	\N
12270	3206	8	0	45783	\N
12347	75	4	0	45790	\N
12347	3234	5	0	45791	\N
12465	75	7	0	45811	\N
12465	3252	8	0	45812	\N
12407	79	1	0	46631	\N
12407	1126	2	0	46633	\N
12505	3271	9	0	48885	\N
12314	121	1	0	48902	\N
12314	3098	2	0	48904	\N
12505	121	10	0	48906	\N
12496	135	1	0	49442	\N
12496	3262	2	0	49445	\N
12370	170	1	0	50529	\N
12370	1072	2	0	50531	\N
12361	200	1	0	51543	\N
12361	2785	2	0	51545	\N
12405	210	1	0	51773	\N
12405	2926	2	0	51774	\N
12455	316	0	0	53894	\N
12354	597	1	0	55841	\N
12354	2956	2	0	55845	\N
12356	793	2	0	56624	\N
12356	3236	3	0	56626	\N
12397	793	1	0	56628	\N
12397	2972	2	0	56630	\N
12326	908	4	0	57534	\N
12326	3230	5	0	57538	\N
12460	908	1	0	57546	\N
12460	3149	2	0	57547	\N
12279	2636	1	0	58680	\N
12279	3207	2	0	58682	\N
12343	2636	4	0	58684	\N
12343	3232	5	0	58685	\N
12281	1954	2	0	1195	\N
12318	367	1	0	3271	\N
12318	3225	2	0	3272	\N
12431	262	0	0	3753	\N
12348	365	1	0	4492	\N
12348	1424	2	0	4493	\N
12340	108	2	0	11705	\N
12477	108	3	0	11706	\N
12482	108	1	0	11707	\N
12482	3022	2	0	11708	\N
12340	3231	3	0	11709	\N
12477	3255	4	0	11710	\N
12332	300	1	0	12061	\N
12345	300	1	0	12072	\N
12345	3168	2	0	12073	\N
12372	3239	79	0	12435	\N
12372	528	126	0	12453	\N
12372	3240	127	0	12454	\N
12380	258	1	0	14392	\N
12380	3241	2	0	14393	\N
12513	258	2	0	14404	\N
12513	3275	3	0	14408	\N
12286	235	1	0	15623	\N
12286	2904	2	0	15624	\N
12366	44	1	0	15995	\N
12473	38	0	0	16315	\N
12434	1792	0	0	16585	\N
12331	167	1	0	17634	\N
12331	2503	2	0	17635	\N
12503	3265	2	0	18747	\N
12503	3268	3	1	18794	\N
12392	62	1	0	19720	\N
12392	3130	2	0	19722	\N
12412	62	1	0	19728	\N
12412	3130	2	0	19732	\N
12499	513	2	0	20323	\N
12499	198	3	0	20325	\N
12416	1428	2	0	20660	\N
12312	3223	3	0	21010	\N
12337	164	1	0	21019	\N
12338	164	1	0	21020	\N
12337	3092	2	0	21021	\N
12338	3092	2	0	21022	\N
12429	67	0	0	22102	\N
12395	73	2	0	22428	\N
12493	73	1	0	22429	\N
12493	2775	2	0	22430	\N
12395	3243	3	0	22431	\N
12272	336	1	0	22946	\N
12308	82	2	0	23765	\N
12308	3220	3	0	23770	\N
12323	214	2	0	24373	\N
12323	2979	3	0	24375	\N
12267	2185	1	0	24924	\N
12267	3205	2	0	24926	\N
12311	86	0	0	26605	\N
12525	94	6	0	26890	\N
12525	3277	7	0	26894	\N
12470	244	0	0	27216	\N
12330	16	0	0	28433	\N
12468	16	0	0	28443	\N
12490	1087	2	0	28445	\N
12336	320	0	0	29346	\N
12463	54	0	0	30041	\N
12402	360	2	0	31369	\N
12402	2943	3	0	31374	\N
12373	33	1	0	31701	\N
12373	3119	2	0	31702	\N
12441	33	0	0	31712	\N
12475	453	1	0	32667	\N
12475	3095	2	0	32668	\N
12283	1	1	0	33572	\N
12283	1085	2	0	33574	\N
12296	3215	5	0	33580	\N
12342	1	2	0	33583	\N
12342	2950	3	0	33584	\N
12388	1	1	0	33603	\N
12388	1085	2	0	33605	\N
12421	1	1	0	33612	\N
12421	1085	2	0	33614	\N
12507	1	1	0	33630	\N
12507	1085	2	0	33631	\N
12515	1	2	0	33637	\N
12515	283	3	0	33638	\N
12293	10	2	0	37272	\N
12316	10	1	0	37286	\N
12378	10	1	0	37288	\N
12316	1416	2	0	37289	\N
12378	1416	2	0	37290	\N
12400	10	2	0	37296	\N
12400	2887	3	0	37297	\N
12427	10	0	0	37309	\N
12452	10	0	0	37310	\N
12494	10	1	0	37328	\N
12510	10	2	0	37329	\N
12494	1416	2	0	37330	\N
12510	275	3	0	37331	\N
12320	23	1	0	40648	\N
12320	1089	2	0	40649	\N
12321	3226	52	0	40654	\N
12321	23	58	0	40667	\N
12321	3227	59	0	40668	\N
12503	3267	3	0	41318	\N
12523	40	6	0	42587	\N
12523	2777	7	0	42590	\N
12501	51	2	0	43494	\N
12548	51	0	0	43503	\N
12306	56	4	0	44108	\N
12306	1978	5	0	44109	\N
12486	56	4	0	44118	\N
12486	3259	5	0	44120	\N
12291	71	1	0	44746	\N
12291	3035	2	0	44747	\N
12432	75	0	0	45804	\N
12633	75	2	0	45821	\N
12633	284	3	0	45826	\N
12341	79	2	0	46630	\N
12586	79	4	0	46632	\N
12341	3180	3	0	46635	\N
12586	2758	5	0	46636	\N
12504	3270	2	0	48900	\N
12504	2498	3	0	48901	\N
12319	156	2	0	50189	\N
12319	3093	3	0	50190	\N
12396	186	2	0	51173	\N
12396	3068	3	0	51174	\N
12417	186	1	0	51193	\N
12417	1080	2	0	51197	\N
12317	285	1	0	53419	\N
12317	3112	2	0	53424	\N
12344	316	4	0	53893	\N
12344	3233	5	0	53899	\N
12537	362	2	0	54810	\N
12537	2873	3	0	54812	\N
12413	435	1	0	55051	\N
12413	1580	2	0	55055	\N
12546	597	2	0	55842	\N
12546	3286	3	0	55847	\N
12480	793	3	0	56631	\N
12480	3257	4	0	56632	\N
12346	841	1	0	56974	\N
12346	2907	2	0	56976	\N
12638	1470	6	0	58157	\N
12638	3324	7	0	58160	\N
12504	3269	2	0	58453	\N
12322	2578	2	0	58587	\N
12322	3224	3	0	58588	\N
12542	2782	4	0	59254	\N
12542	2783	5	0	59256	\N
12488	3033	2	0	757	\N
12333	1954	2	0	1203	\N
12466	1000	0	0	2288	\N
12383	110	1	0	2478	\N
12383	3242	2	0	2479	\N
12389	2982	1	0	3181	\N
12389	3014	2	0	3185	\N
12414	367	1	0	3284	\N
12414	3225	2	0	3285	\N
12309	3221	1	0	4112	\N
12309	3222	2	0	4113	\N
12478	35	3	0	4356	\N
12478	3256	4	0	4358	\N
12294	3213	11	0	4495	\N
12551	1819	4	0	5300	\N
12551	3289	5	0	5302	\N
12315	391	1	0	11022	\N
12315	1420	2	0	11023	\N
12349	391	2	0	11024	\N
12349	2966	3	0	11025	\N
12424	391	2	0	11027	\N
12424	2966	3	0	11028	\N
12435	391	0	0	11030	\N
12437	391	0	0	11031	\N
12446	391	0	0	11032	\N
12570	1381	3	0	11038	\N
12557	132	2	0	11155	\N
12559	132	4	0	11156	\N
12557	2756	3	0	11158	\N
12559	3293	5	0	11160	\N
12617	132	2	0	11165	\N
12617	2756	3	0	11166	\N
12351	58	0	0	13487	\N
12301	233	2	0	13729	\N
12301	3217	3	0	13740	\N
12398	402	2	0	14021	\N
12398	3244	3	0	14023	\N
12289	2944	2	0	15545	\N
12299	192	1	0	15548	\N
12359	192	1	0	15549	\N
12299	2944	2	0	15550	\N
12359	2944	2	0	15551	\N
12448	192	0	0	15555	\N
12544	192	5	0	15556	\N
12544	3284	6	0	15560	\N
12596	212	8	0	17033	\N
12596	3312	9	0	17037	\N
12550	1988	0	0	18371	\N
12471	60	0	0	19403	\N
12509	3273	5	0	20326	\N
12367	264	3	0	23480	\N
12367	3237	4	0	23481	\N
12379	264	1	0	23488	\N
12379	2941	2	0	23492	\N
12620	214	2	0	24389	\N
12620	1259	3	0	24391	\N
12408	224	1	0	25464	\N
12408	2813	2	0	25466	\N
12549	206	0	0	25925	\N
12540	1171	4	0	26278	\N
12540	3282	5	0	26282	\N
12627	86	0	0	26611	\N
12528	94	2	0	26891	\N
12528	2794	3	0	26892	\N
12530	244	3	0	27223	\N
12530	3278	4	0	27224	\N
12327	16	4	0	28432	\N
12327	3118	5	0	28434	\N
12335	16	0	0	28435	\N
12362	16	1	0	28436	\N
12374	16	1	0	28437	\N
12362	1087	2	0	28438	\N
12374	1087	2	0	28439	\N
12609	388	3	0	28451	\N
12442	151	0	0	30900	\N
12601	322	2	0	32550	\N
12601	1866	3	0	32551	\N
12430	1	0	0	33613	\N
12444	1	0	0	33617	\N
12422	1	0	0	33619	\N
12461	1	1	0	33621	\N
12461	1085	2	0	33624	\N
12514	1	2	0	33634	\N
12514	283	3	0	33635	\N
12566	1	2	0	33650	\N
12611	1	2	0	33668	\N
12611	283	3	0	33669	\N
12458	10	0	0	37312	\N
12518	10	2	0	37334	\N
12518	275	3	0	37336	\N
12527	10	2	0	37342	\N
12533	10	1	0	37343	\N
12538	10	2	0	37344	\N
12533	1416	2	0	37345	\N
12527	275	3	0	37346	\N
12538	275	3	0	37347	\N
12574	10	2	0	37373	\N
12607	10	2	0	37392	\N
12607	275	3	0	37393	\N
12577	23	6	0	40657	\N
12577	3299	7	0	40662	\N
12399	40	2	0	42562	\N
12399	3034	3	0	42564	\N
12502	51	2	0	43495	\N
12502	1260	3	0	43498	\N
12464	56	0	0	44113	\N
12539	75	2	0	45815	\N
12539	284	3	0	45817	\N
12648	75	2	0	45822	\N
12651	75	7	0	45823	\N
12648	284	3	0	45827	\N
12651	3331	8	0	45830	\N
12654	119	7	0	48556	\N
12506	121	2	0	48903	\N
12506	2498	3	0	48905	\N
12495	137	1	0	49729	\N
12495	3261	2	0	49740	\N
12368	156	1	0	50207	\N
12449	156	0	0	50208	\N
12368	3012	2	0	50210	\N
12406	181	2	0	51087	\N
12406	3245	3	0	51088	\N
12602	181	2	0	51100	\N
12602	3313	3	0	51102	\N
12418	186	0	0	51194	\N
12532	186	5	0	51195	\N
12532	3280	6	0	51199	\N
12409	285	1	0	53420	\N
12593	285	4	0	53421	\N
12409	3112	2	0	53425	\N
12593	3309	5	1	53741	\N
12381	362	1	0	54802	\N
12381	2946	2	0	54803	\N
12522	435	4	0	55052	\N
12522	2810	5	0	55057	\N
12489	451	1	0	55173	\N
12610	451	2	0	55174	\N
12489	3260	2	0	55179	\N
12610	3317	3	0	55180	\N
12352	595	1	0	55625	\N
12545	595	2	0	55626	\N
12352	2958	2	0	55630	\N
12545	3285	3	0	55632	\N
12520	852	2	0	57208	\N
12520	2872	3	0	57211	\N
12419	2636	3	0	58688	\N
12419	3246	4	0	58692	\N
12350	266	2	0	1201	\N
12350	3235	3	0	1204	\N
12558	2103	3	0	1205	\N
12567	3295	2	0	1721	\N
12567	3296	3	0	1723	\N
12640	3326	38	0	2226	\N
12640	117	126	0	2230	\N
12640	3327	127	0	2231	\N
12646	367	2	0	3298	\N
12646	3329	3	0	3299	\N
12433	262	0	0	3754	\N
12403	189	2	0	4760	\N
12403	3143	3	0	4761	\N
12401	391	0	0	11026	\N
12425	391	0	0	11029	\N
12564	132	2	0	11157	\N
12564	2756	3	0	11159	\N
12459	3251	11	1	13478	\N
12581	233	1	0	13730	\N
12581	234	2	0	13735	\N
12541	258	4	0	14406	\N
12541	2725	5	0	14411	\N
12459	3250	11	0	14954	\N
12459	92	10	0	14984	\N
12512	1453	4	0	15243	\N
12384	167	1	0	17639	\N
12384	2503	2	0	17640	\N
12443	177	0	0	18321	\N
12364	142	2	0	18497	\N
12364	3099	3	0	18501	\N
12595	3108	3	1	18789	\N
12615	290	2	0	18966	\N
12615	1909	3	0	18968	\N
12472	3253	7	0	19393	\N
12472	60	27	0	19406	\N
12472	3254	28	0	19407	\N
12393	62	1	0	19721	\N
12440	241	0	0	20393	\N
12438	488	0	0	21458	\N
12543	336	5	0	22952	\N
12543	3283	6	0	22953	\N
12436	264	0	0	23489	\N
12536	224	4	0	25465	\N
12536	3281	5	0	25467	\N
12456	206	0	0	25922	\N
12483	206	1	0	25923	\N
12483	2900	2	0	25924	\N
12552	3290	3	0	25994	\N
12552	90	126	0	26001	\N
12625	86	2	0	26610	\N
12625	3321	3	0	26615	\N
12595	3311	3	0	27449	\N
12595	42	2	0	27477	\N
12386	16	1	0	28440	\N
12386	1087	2	0	28441	\N
12447	16	0	0	28442	\N
12497	16	2	0	28446	\N
12497	388	3	0	28447	\N
12517	16	2	0	28448	\N
12517	388	3	0	28449	\N
12642	16	2	0	28452	\N
12587	320	4	0	29354	\N
12587	3305	5	0	29359	\N
12612	449	2	0	29796	\N
12612	646	3	0	29797	\N
12357	54	1	0	30030	\N
12357	3142	2	0	30031	\N
12469	20	0	0	30412	\N
12572	202	2	0	31035	\N
12572	2764	3	0	31037	\N
12491	33	1	0	31713	\N
12562	33	2	0	31714	\N
12491	3119	2	0	31715	\N
12588	230	16	0	32045	\N
12588	3306	17	0	32048	\N
12560	453	4	0	32682	\N
12560	3294	5	0	32684	\N
12391	1085	1	0	33595	\N
12375	1	1	0	33602	\N
12375	1085	2	0	33604	\N
12391	1	3	0	33606	\N
12391	1085	4	0	33607	\N
12451	1	0	0	33618	\N
12529	1	1	0	33646	\N
12529	1085	2	0	33647	\N
12571	283	3	0	33655	\N
12599	431	2	0	34808	\N
12599	2772	3	0	34810	\N
12621	6	6	0	36259	\N
12621	3320	7	0	36260	\N
12453	10	0	0	37311	\N
12476	10	0	0	37319	\N
12487	10	4	0	37322	\N
12487	3032	5	0	37323	\N
12554	10	2	0	37354	\N
12554	275	3	0	37355	\N
12555	10	6	0	37357	\N
12583	10	1	0	37377	\N
12583	11	2	0	37378	\N
12623	10	2	0	37397	\N
12623	275	3	0	37398	\N
12369	40	1	0	42544	\N
12369	1383	2	0	42546	\N
12420	40	3	0	42563	\N
12420	3247	4	0	42565	\N
12498	282	2	0	42566	\N
12474	40	1	0	42586	\N
12474	1383	2	0	42588	\N
12498	40	3	0	42589	\N
12584	51	2	0	43504	\N
12584	1260	3	0	43505	\N
12695	51	2	0	43512	\N
12695	1260	3	0	43513	\N
12385	56	1	0	44111	\N
12385	1088	2	0	44115	\N
12598	56	2	0	44119	\N
12598	2795	3	0	44121	\N
12394	75	2	0	45794	\N
12394	284	3	0	45795	\N
12580	75	6	0	45816	\N
12580	3303	7	0	45818	\N
12606	79	2	0	46664	\N
12665	79	5	0	46665	\N
12606	616	3	0	46666	\N
12665	3341	6	0	46667	\N
12467	113	0	0	48213	\N
12616	119	2	0	48555	\N
12616	1879	3	0	48566	\N
12672	137	5	0	49730	\N
12672	3346	6	0	49750	\N
12547	147	2	0	49979	\N
12547	3287	3	0	49983	\N
12645	170	2	0	50530	\N
12645	1380	3	0	50532	\N
12382	186	1	0	51162	\N
12382	1080	2	0	51164	\N
12534	186	1	0	51196	\N
12534	1080	2	0	51198	\N
12626	268	2	0	52746	\N
12626	2800	3	0	52748	\N
12508	273	12	0	52916	\N
12508	3272	13	0	52918	\N
12585	316	8	0	53895	\N
12585	3304	9	0	53897	\N
12387	324	1	0	54179	\N
12387	939	2	0	54187	\N
12569	353	2	0	54565	\N
12569	2884	3	0	54570	\N
12415	362	1	0	54806	\N
12415	2946	2	0	54807	\N
12358	793	1	0	56627	\N
12358	2972	2	0	56629	\N
12619	852	4	0	57209	\N
12619	3319	5	0	57212	\N
12674	908	2	0	57560	\N
12674	2832	3	0	57561	\N
12492	2351	1	0	58968	\N
12492	2925	2	0	58970	\N
12632	2755	3	0	759	\N
12644	3328	4	0	2496	\N
12457	262	0	0	3755	\N
12511	35	3	0	4357	\N
12511	3256	4	0	4359	\N
12535	35	2	0	4360	\N
12535	1191	3	0	4361	\N
12637	35	6	0	4362	\N
12637	3323	7	0	4363	\N
12576	365	4	0	4502	\N
12576	3298	5	0	4503	\N
12526	391	2	0	11033	\N
12526	1381	3	0	11034	\N
12663	3022	2	0	11721	\N
12371	528	2	0	12428	\N
12371	3238	3	0	12431	\N
12485	58	4	0	13494	\N
12485	3258	5	0	13498	\N
12462	258	0	0	14403	\N
12516	258	2	0	14405	\N
12700	258	2	0	14407	\N
12516	3275	3	0	14409	\N
12700	3275	3	0	14410	\N
12641	92	2	0	14950	\N
12641	2763	3	0	14951	\N
12360	2944	2	0	15553	\N
12411	192	1	0	15554	\N
12411	2944	2	0	15558	\N
12578	3300	0	0	15931	\N
12524	38	6	0	16320	\N
12524	3276	7	0	16323	\N
12652	326	2	0	17322	\N
12652	393	3	0	17323	\N
12445	177	58	0	18326	\N
12445	3249	59	0	18327	\N
12604	488	6	0	21459	\N
12604	3315	7	0	21462	\N
12653	3332	3	0	22721	\N
12377	214	1	0	24388	\N
12377	1382	2	0	24390	\N
12531	1153	1	0	24949	\N
12531	3279	2	0	24950	\N
12628	86	0	0	26612	\N
12629	86	0	0	26613	\N
12630	86	0	0	26614	\N
12426	54	0	0	30040	\N
12608	151	2	0	30901	\N
12608	2854	3	0	30902	\N
12563	447	4	0	31703	\N
12563	447	10	0	31718	\N
12484	230	1	0	32039	\N
12484	3087	2	0	32040	\N
12363	1	1	0	33591	\N
12365	1	2	0	33592	\N
12363	1085	2	0	33593	\N
12365	2950	3	0	33594	\N
12481	1	1	0	33622	\N
12423	1	0	0	33623	\N
12481	1085	2	0	33625	\N
12500	283	2	0	33626	\N
12500	1	3	0	33628	\N
12519	283	3	0	33643	\N
12650	1	7	0	33675	\N
12650	3330	8	0	33677	\N
12681	112	2	0	33678	\N
12681	1	5	0	33683	\N
12693	1	1	0	33687	\N
12693	53	2	0	33688	\N
12634	4	2	0	35890	\N
12636	4	2	0	35891	\N
12634	2751	3	0	35894	\N
12636	2751	3	0	35895	\N
12454	6	0	0	36258	\N
12410	1416	2	0	37301	\N
12521	10	4	0	37335	\N
12521	2568	5	0	37337	\N
12556	10	2	0	37362	\N
12556	275	3	0	37364	\N
12592	10	4	0	37384	\N
12592	2568	5	0	37385	\N
12614	10	8	0	37396	\N
12614	1798	9	0	37399	\N
12649	10	2	0	37402	\N
12649	275	3	0	37403	\N
12656	10	7	0	37406	\N
12679	275	3	0	37416	\N
12698	10	2	0	37424	\N
12698	275	3	0	37425	\N
12404	14	1	0	39096	\N
12404	1926	2	0	39098	\N
12578	3301	0	0	40669	\N
12762	40	4	0	42621	\N
12762	3381	5	0	42623	\N
12811	40	1	0	42634	\N
12811	41	2	0	42635	\N
12717	75	6	0	45824	\N
12720	75	6	0	45825	\N
12717	3361	7	0	45828	\N
12720	3361	7	0	45829	\N
12730	75	2	0	45833	\N
12730	284	3	0	45834	\N
12573	125	2	0	49213	\N
12573	3297	3	0	49215	\N
12872	170	2	0	50544	\N
12872	1380	3	0	50546	\N
12618	181	4	0	51101	\N
12618	2356	5	0	51103	\N
12613	268	8	0	52741	\N
12613	3318	9	0	52742	\N
12858	285	2	0	53422	\N
12858	3036	3	0	53426	\N
12865	316	7	0	53905	\N
12865	3417	8	0	53906	\N
12741	1109	2	0	56179	\N
12741	2809	3	0	56181	\N
12605	841	2	0	56989	\N
12605	3316	3	0	56990	\N
12829	852	2	0	57214	\N
12829	1325	3	0	57221	\N
12752	1470	10	0	58178	\N
12752	3375	11	0	58184	\N
12770	3384	3	0	58433	\N
12631	2755	3	0	758	\N
12879	2755	3	0	785	\N
12740	251	2	0	1456	\N
12740	1851	3	0	1459	\N
12639	117	6	0	2216	\N
12639	3325	7	0	2223	\N
12643	110	2	0	2487	\N
12834	110	1	0	2489	\N
12834	134	2	0	2492	\N
12643	626	3	0	2494	\N
12683	35	2	0	4364	\N
12875	35	4	0	4365	\N
12683	1191	3	0	4366	\N
12550	3288	0	0	5298	\N
12655	391	7	0	11037	\N
12655	3334	8	0	11039	\N
12705	391	2	0	11042	\N
12705	1381	3	0	11043	\N
12806	391	2	0	11045	\N
12881	391	2	0	11047	\N
12881	1381	3	0	11049	\N
12806	406	3	0	11051	\N
12582	108	1	0	11716	\N
12789	108	0	0	11719	\N
12582	109	2	0	11722	\N
12670	2786	3	0	12092	\N
12575	528	2	0	12448	\N
12702	528	4	0	12449	\N
12575	2765	3	0	12450	\N
12702	3353	5	0	12451	\N
12831	192	1	0	15561	\N
12831	193	2	0	15563	\N
12667	235	3	0	15635	\N
12667	3343	4	0	15636	\N
12692	44	2	0	16007	\N
12692	1910	3	0	16011	\N
12565	115	2	0	16925	\N
12659	326	3	0	17331	\N
12659	3339	4	0	17332	\N
12723	326	4	0	17339	\N
12723	3362	5	0	17344	\N
12603	167	6	0	17643	\N
12635	167	2	0	17644	\N
12635	3322	3	0	17645	\N
12603	3314	7	0	17646	\N
12657	3336	3	0	17952	\N
12657	3337	4	0	17953	\N
12773	164	3	0	21030	\N
12773	3385	4	0	21036	\N
12622	2827	5	0	22440	\N
12721	336	2	0	22724	\N
12721	3332	3	0	22725	\N
12757	336	4	0	22728	\N
12757	3378	5	0	22729	\N
12861	82	8	0	23795	\N
12861	3414	9	0	23796	\N
12710	214	4	0	24412	\N
12799	214	2	0	24413	\N
12799	1259	3	0	24414	\N
12710	3355	5	0	24415	\N
12689	69	2	0	24692	\N
12553	90	6	0	25999	\N
12553	3292	7	0	26000	\N
12696	86	4	0	26624	\N
12696	2576	5	0	26625	\N
12590	244	2	0	27230	\N
12590	3308	3	0	27231	\N
12594	42	2	0	27476	\N
12594	3310	3	0	27479	\N
12704	42	2	0	27486	\N
12704	3310	3	0	27487	\N
12707	16	2	0	28456	\N
12707	388	3	0	28458	\N
12824	17	2	0	28465	\N
12685	360	2	0	31370	\N
12685	2767	3	0	31375	\N
12589	230	2	0	32046	\N
12589	3307	3	0	32047	\N
12782	231	2	0	32058	\N
12782	230	8	0	32066	\N
12782	3389	9	0	32067	\N
12851	230	2	0	32082	\N
12851	3307	3	0	32083	\N
12827	322	1	0	32557	\N
12827	323	2	0	32561	\N
12715	3358	7	0	32685	\N
12597	1	2	0	33660	\N
12597	283	3	0	33661	\N
12600	1	2	0	33665	\N
12600	283	3	0	33666	\N
12647	1	2	0	33674	\N
12647	283	3	0	33676	\N
12713	1	2	0	33691	\N
12754	1	11	0	33694	\N
12713	283	3	0	33696	\N
12754	3377	12	0	33700	\N
12805	1	2	0	33724	\N
12561	10	4	0	37363	\N
12561	2568	5	0	37365	\N
12568	10	9	0	37367	\N
12568	2057	10	0	37368	\N
12591	10	0	0	37381	\N
12719	10	4	0	37436	\N
12719	2568	5	0	37437	\N
12816	10	1	0	37457	\N
12816	11	2	0	37459	\N
12842	10	2	0	37466	\N
12842	275	3	0	37467	\N
12853	10	2	0	37470	\N
12856	10	4	0	37476	\N
12856	2568	5	0	37489	\N
12579	27	6	0	40976	\N
12687	27	2	0	40977	\N
12687	645	3	0	40980	\N
12579	3302	7	0	40981	\N
12706	40	2	0	42606	\N
12706	282	3	0	42608	\N
12772	40	2	0	42633	\N
12772	282	3	0	42636	\N
12826	40	1	0	42651	\N
12826	41	2	0	42652	\N
12846	40	2	0	42675	\N
12846	282	3	0	42677	\N
12796	56	6	0	44124	\N
12808	56	2	0	44125	\N
12796	3398	7	0	44126	\N
12808	169	3	0	44127	\N
12863	56	9	0	44132	\N
12863	3415	10	0	44137	\N
12931	75	2	0	45841	\N
12931	284	3	0	45849	\N
12712	79	2	0	46697	\N
12712	616	3	0	46698	\N
12726	102	2	0	47793	\N
12726	3053	3	0	47794	\N
12654	3333	8	0	48572	\N
12739	121	2	0	48918	\N
12739	2498	3	0	48921	\N
12711	125	4	0	49222	\N
12909	125	1	0	49223	\N
12909	1185	2	0	49227	\N
12711	3356	5	0	49228	\N
12722	200	4	0	51557	\N
12722	2811	5	0	51560	\N
12883	242	2	0	52112	\N
12883	3425	3	0	52115	\N
12718	260	5	0	52532	\N
12718	2365	6	0	52533	\N
12869	285	9	0	53423	\N
12869	3421	10	0	53427	\N
12727	362	6	0	54811	\N
12727	3365	7	0	54813	\N
12850	435	2	0	55054	\N
12850	3413	3	0	55056	\N
12837	3403	1	0	56892	\N
12781	3387	10	0	56899	\N
12792	841	9	0	56997	\N
12792	3395	10	0	57000	\N
12830	852	1	0	57215	\N
12830	913	2	0	57218	\N
12781	1697	9	0	57844	\N
12732	1470	2	0	58167	\N
12732	3368	3	0	58169	\N
12751	1470	4	0	58177	\N
12804	1470	2	0	58180	\N
12804	3368	3	0	58182	\N
12751	3374	5	0	58183	\N
12902	1470	4	0	58188	\N
12902	2798	5	0	58191	\N
12895	2578	0	0	58590	\N
12756	2782	4	0	59259	\N
12756	2783	5	0	59260	\N
12848	424	90	0	772	\N
12814	266	3	0	1214	\N
12814	405	4	0	1217	\N
12887	741	2	0	1366	\N
12887	3426	3	0	1369	\N
12860	110	2	0	2491	\N
12860	626	3	0	2495	\N
12701	391	4	0	11041	\N
12701	3352	5	0	11044	\N
12874	391	4	0	11046	\N
12874	3352	5	0	11052	\N
12664	108	2	0	11718	\N
12664	3340	3	0	11723	\N
12682	2786	3	0	12102	\N
12864	58	7	0	13496	\N
12864	3416	8	0	13502	\N
12703	92	2	0	14968	\N
12910	92	1	0	14970	\N
12910	1078	2	0	14971	\N
12703	2763	3	0	14972	\N
12837	3404	1	0	15641	\N
12929	326	2	0	17340	\N
12929	393	3	0	17342	\N
12911	60	8	0	19418	\N
12911	3431	9	0	19423	\N
12907	2122	5	0	20408	\N
12675	164	2	0	21029	\N
12775	164	2	0	21031	\N
12675	1124	3	0	21034	\N
12775	1124	3	0	21035	\N
12781	3388	10	1	21763	\N
12801	336	3	0	22732	\N
12801	3400	4	0	22733	\N
12677	206	4	0	25926	\N
12677	3348	5	0	25927	\N
12743	206	2	0	25928	\N
12743	2773	3	0	25934	\N
12708	2794	3	0	26897	\N
12736	16	6	0	28457	\N
12736	3369	7	0	28459	\N
12855	16	2	0	28467	\N
12855	388	3	0	28469	\N
12924	16	2	0	28474	\N
12924	388	3	0	28476	\N
12765	320	0	0	29355	\N
12786	449	0	0	29808	\N
12691	54	2	0	30042	\N
12691	3351	3	0	30047	\N
12908	20	2	0	30417	\N
12897	1163	2	0	30935	\N
12897	3427	3	0	30937	\N
12905	202	2	0	31042	\N
12905	2764	3	0	31043	\N
12666	33	3	0	31729	\N
12666	3342	4	0	31732	\N
12781	3386	9	1	31966	\N
12684	230	2	0	32055	\N
12684	3307	3	0	32056	\N
12781	231	2	0	32057	\N
12781	230	8	0	32065	\N
12898	230	2	0	32088	\N
12904	322	4	0	32558	\N
12904	3429	5	0	32563	\N
12716	3359	61	0	32669	\N
12716	453	126	0	32686	\N
12716	3360	127	0	32687	\N
12680	1	2	0	33681	\N
12680	283	3	0	33682	\N
12734	1	2	0	33692	\N
12748	1	5	0	33693	\N
12767	1	2	0	33695	\N
12734	283	3	0	33697	\N
12767	283	3	0	33698	\N
12780	1	1	0	33711	\N
12780	1085	2	0	33712	\N
12821	1	2	0	33725	\N
12821	112	3	0	33728	\N
12784	2	4	0	35399	\N
12839	2	1	0	35400	\N
12839	26	2	0	35401	\N
12784	2830	5	0	35402	\N
12794	4	2	0	35893	\N
12794	2751	3	0	35896	\N
12661	10	6	0	37408	\N
12661	2579	7	0	37411	\N
12828	10	1	0	37462	\N
12828	11	2	0	37463	\N
12885	10	2	0	37478	\N
12885	275	3	0	37484	\N
12901	14	2	0	39097	\N
12901	1785	3	0	39099	\N
12737	40	2	0	42607	\N
12737	282	3	0	42609	\N
12843	40	2	0	42674	\N
12843	282	3	0	42676	\N
12857	40	4	0	42694	\N
12857	2796	5	0	42695	\N
12866	56	6	0	44129	\N
12866	3418	7	0	44131	\N
12779	75	2	0	45840	\N
12779	284	3	0	45848	\N
12849	79	2	0	46737	\N
12849	616	3	0	46739	\N
12877	100	2	0	47545	\N
12877	633	3	0	47546	\N
12725	3363	35	0	47790	\N
12725	3364	36	0	47795	\N
12673	135	5	0	49443	\N
12673	3347	6	0	49450	\N
12859	170	2	0	50543	\N
12859	1380	3	0	50545	\N
12662	186	2	0	51208	\N
12662	1850	3	0	51209	\N
12658	200	3	0	51544	\N
12658	3338	4	0	51546	\N
12819	200	1	0	51558	\N
12819	201	2	0	51559	\N
12795	260	7	0	52534	\N
12795	3397	8	0	52535	\N
12797	260	3	0	52536	\N
12797	3399	4	0	52537	\N
12832	273	1	0	52931	\N
12832	410	2	0	52932	\N
12852	273	2	0	52939	\N
12852	1413	3	0	52941	\N
12906	279	4	0	53203	\N
12906	3430	5	0	53204	\N
12768	324	2	0	54180	\N
12774	324	2	0	54181	\N
12768	2808	3	0	54188	\N
12774	2808	3	0	54189	\N
12785	451	4	0	55175	\N
12888	451	2	0	55176	\N
12890	451	2	0	55178	\N
12888	3317	3	0	55181	\N
12890	3317	3	0	55183	\N
12785	3391	5	0	55184	\N
12714	841	6	0	56995	\N
12714	3357	7	0	56998	\N
12847	2755	3	0	771	\N
12880	424	63	0	786	\N
12880	3424	64	0	787	\N
12930	424	61	0	798	\N
12891	741	2	0	1367	\N
12891	3426	3	0	1370	\N
12709	251	4	0	1438	\N
12709	3354	5	0	1441	\N
12776	2982	2	0	3192	\N
12776	3383	3	0	3195	\N
12676	365	4	0	4511	\N
12676	3298	5	0	4515	\N
12790	108	2	0	11720	\N
12763	528	2	0	12466	\N
12763	2765	3	0	12467	\N
12694	58	2	0	13495	\N
12694	2853	3	0	13499	\N
12760	233	5	0	13731	\N
12760	3380	6	0	13737	\N
12840	402	4	0	14035	\N
12840	3409	5	0	14036	\N
12812	92	3	0	14969	\N
12812	180	4	0	14973	\N
12867	192	8	0	15562	\N
12867	3419	9	0	15564	\N
12809	1932	4	0	18085	\N
12917	290	4	0	18973	\N
12917	2759	5	0	18974	\N
12725	2244	36	0	19159	\N
12668	62	3	0	19729	\N
12668	3344	4	0	19733	\N
12916	3433	15	0	21037	\N
12916	164	44	0	21046	\N
12916	3434	45	0	21047	\N
12787	82	6	0	23773	\N
12787	3392	7	0	23775	\N
12802	82	2	0	23779	\N
12876	82	4	0	23802	\N
12876	3422	5	0	23807	\N
12896	214	2	0	24426	\N
12896	1259	3	0	24427	\N
12671	411	5	0	25198	\N
12671	3345	6	0	25199	\N
12933	224	2	0	25476	\N
12933	3150	3	0	25477	\N
12753	90	10	0	26007	\N
12753	3376	11	0	26008	\N
12822	86	1	0	26629	\N
12886	86	2	0	26630	\N
12886	3321	3	0	26632	\N
12943	43	1	0	27488	\N
12678	16	2	0	28453	\N
12678	388	3	0	28455	\N
12755	16	11	0	28460	\N
12755	2281	12	0	28461	\N
12854	16	2	0	28466	\N
12854	388	3	0	28468	\N
12873	16	2	0	28470	\N
12919	16	2	0	28471	\N
12873	388	3	0	28472	\N
12919	388	3	0	28473	\N
12744	2347	3	0	29466	\N
12697	54	2	0	30043	\N
12697	3351	3	0	30048	\N
12938	20	2	0	30425	\N
12938	369	3	0	30426	\N
12807	151	3	0	30722	\N
12807	3402	4	0	30729	\N
12882	33	2	0	31730	\N
12882	2822	3	0	31731	\N
12686	322	1	0	32556	\N
12686	323	2	0	32560	\N
12728	453	2	0	32696	\N
12817	453	0	0	32710	\N
12800	1	2	0	33723	\N
12800	283	3	0	33726	\N
12870	1	2	0	33733	\N
12870	283	3	0	33736	\N
12899	1	2	0	33739	\N
12899	283	3	0	33741	\N
12936	1	8	0	33750	\N
12936	3432	9	0	33752	\N
12660	10	3	0	37407	\N
12660	3173	4	0	37409	\N
12656	3335	8	0	37410	\N
12688	275	3	0	37417	\N
12690	10	2	0	37420	\N
12690	275	3	0	37421	\N
12699	10	2	0	37428	\N
12699	275	3	0	37429	\N
12746	10	2	0	37451	\N
12746	275	3	0	37452	\N
12777	10	1	0	37455	\N
12777	1416	2	0	37458	\N
12894	10	2	0	37479	\N
12914	10	2	0	37481	\N
12894	275	3	0	37485	\N
12758	27	4	0	40978	\N
12758	3379	5	0	40982	\N
12745	40	2	0	42620	\N
12745	282	3	0	42622	\N
12964	40	6	0	42726	\N
12964	2777	7	0	42727	\N
12750	56	5	0	44122	\N
12750	3373	6	0	44123	\N
12862	56	1	0	44128	\N
12862	57	2	0	44130	\N
12913	56	8	0	44133	\N
12913	2431	9	0	44139	\N
12820	71	1	0	44766	\N
12820	72	2	0	44767	\N
12946	88	2	0	47094	\N
12946	2799	3	0	47097	\N
12738	121	1	0	48917	\N
12738	122	2	0	48920	\N
12940	135	2	0	49444	\N
12940	2722	3	0	49449	\N
12939	137	2	0	49731	\N
12939	2721	3	0	49744	\N
12813	156	3	0	50209	\N
12813	407	4	0	50211	\N
12892	181	0	0	50868	\N
12761	242	2	0	52100	\N
12761	620	3	0	52103	\N
12783	273	4	0	52923	\N
12783	3390	5	0	52924	\N
12966	285	2	0	53441	\N
12966	3036	3	0	53442	\N
12747	362	5	0	54818	\N
12749	362	3	0	54819	\N
12749	3372	4	0	54820	\N
12747	3371	6	0	54821	\N
12759	435	4	0	55053	\N
12759	2810	5	0	55058	\N
12889	451	2	0	55177	\N
12889	3317	3	0	55182	\N
12960	1109	0	0	56198	\N
12791	841	5	0	56996	\N
12791	3394	6	0	56999	\N
12731	1470	1	0	58166	\N
12731	1471	2	0	58168	\N
12803	1470	1	0	58179	\N
12803	1471	2	0	58181	\N
12947	1470	2	0	58189	\N
12947	3368	3	0	58190	\N
12994	3051	4	0	59448	\N
12994	3451	6	0	59449	\N
12928	2755	3	0	797	\N
12841	251	4	0	1457	\N
12841	3410	5	0	1461	\N
12838	3204	2	1	1844	\N
12835	110	1	0	2490	\N
12835	134	2	0	2493	\N
12769	2982	2	0	3190	\N
12769	3383	3	0	3191	\N
12838	3408	3	0	4076	\N
12868	365	8	0	4512	\N
12868	3420	9	0	4518	\N
12926	189	4	0	4769	\N
12926	3436	5	0	4772	\N
12953	3441	3	0	4784	\N
12991	391	2	0	11053	\N
12991	1381	3	0	11054	\N
13012	391	1	0	11055	\N
13012	392	2	0	11056	\N
12983	233	1	0	13745	\N
12983	1418	2	0	13749	\N
12764	402	6	0	14022	\N
12764	3382	7	0	14024	\N
12815	402	2	0	14029	\N
12815	1148	3	0	14030	\N
12771	192	2	0	15557	\N
12836	235	1	0	15642	\N
12838	235	1	0	15643	\N
12836	236	2	0	15644	\N
12838	3407	2	0	15926	\N
13015	326	2	0	17351	\N
13015	393	3	0	17352	\N
12893	167	2	0	17651	\N
12893	3322	3	0	17652	\N
12903	167	4	0	17658	\N
12903	3428	5	0	17659	\N
12990	142	4	0	18511	\N
12990	3446	5	0	18513	\N
12956	290	1	0	18990	\N
12956	2952	2	0	18993	\N
13022	290	2	0	19001	\N
13022	1909	3	0	19003	\N
12825	60	1	0	19404	\N
12825	61	2	0	19405	\N
12823	164	1	0	21032	\N
12823	165	2	0	21033	\N
12915	164	2	0	21044	\N
12915	1124	3	0	21045	\N
13011	488	2	0	21469	\N
13011	2791	3	0	21471	\N
12984	73	2	0	22453	\N
12984	2766	3	0	22454	\N
12878	264	2	0	23490	\N
12878	2780	3	0	23493	\N
12941	69	2	0	24693	\N
12942	69	1	0	24694	\N
12942	70	2	0	24695	\N
12941	3350	3	0	24697	\N
12742	411	2	0	25210	\N
12742	3370	3	0	25211	\N
12932	411	2	0	25225	\N
12932	3370	3	0	25227	\N
12951	2821	5	0	27507	\N
12798	16	2	0	28462	\N
12798	388	3	0	28463	\N
12978	16	3	0	28478	\N
12978	1045	4	0	28481	\N
12766	320	0	0	29356	\N
12733	449	2	0	29807	\N
12733	646	3	0	29809	\N
12845	151	2	0	30723	\N
12845	2854	3	0	30726	\N
12980	202	2	0	31050	\N
12980	2764	3	0	31051	\N
12971	2767	3	0	31376	\N
12818	453	1	0	32697	\N
12818	454	2	0	32698	\N
12729	453	59	0	32700	\N
12729	3367	60	0	32701	\N
12778	1	2	0	33705	\N
12778	283	3	0	33706	\N
12788	1	3	0	33717	\N
12788	3393	4	0	33718	\N
12833	1	1	0	33731	\N
12844	1	2	0	33732	\N
12833	53	2	0	33734	\N
12921	1	2	0	33749	\N
12921	283	3	0	33751	\N
12793	4	7	0	35892	\N
12793	3396	8	0	35897	\N
12724	10	4	0	37440	\N
12724	2568	5	0	37441	\N
12735	10	0	0	37446	\N
12871	10	2	0	37477	\N
12900	10	2	0	37480	\N
12871	275	3	0	37483	\N
12900	275	3	0	37486	\N
12923	10	2	0	37496	\N
12975	10	2	0	37508	\N
12975	275	3	0	37511	\N
12935	40	8	0	42705	\N
12959	40	2	0	42706	\N
12959	282	3	0	42707	\N
12935	3438	9	0	42708	\N
13007	40	6	0	42743	\N
13007	2777	7	0	42744	\N
13087	40	8	0	42803	\N
13087	3503	9	0	42804	\N
13114	3532	3	0	43514	\N
13114	3533	4	0	43515	\N
12937	75	8	0	45842	\N
12976	75	3	0	45843	\N
12998	75	4	0	45844	\N
12976	713	4	0	45851	\N
12998	2357	5	0	45852	\N
12937	3439	9	0	45853	\N
13020	79	3	0	46736	\N
12989	79	4	0	46738	\N
13020	1168	4	0	46740	\N
12989	2758	5	0	46741	\N
12945	88	2	0	47093	\N
12945	2799	3	0	47096	\N
13056	125	5	0	49224	\N
13056	2847	6	0	49229	\N
12973	147	2	0	49980	\N
13059	147	16	0	49981	\N
12973	3287	3	0	49984	\N
13059	3481	17	0	49986	\N
12993	210	0	0	51781	\N
12986	316	2	0	53911	\N
12986	1900	3	0	53912	\N
13109	451	6	0	55195	\N
13109	3520	7	0	55196	\N
12970	595	2	0	55627	\N
12970	3285	3	0	55633	\N
12974	597	2	0	55857	\N
12974	3286	3	0	55862	\N
13095	908	8	0	57575	\N
13095	3509	9	0	57577	\N
13114	1368	3	0	57853	\N
13049	2636	5	0	58691	\N
13049	3476	6	0	58695	\N
13027	2351	4	0	58969	\N
13027	3463	5	0	58971	\N
13017	3459	6	0	290	\N
13023	2103	3	0	1216	\N
13072	263	1	0	3760	\N
13072	262	5	0	3789	\N
13072	3492	6	0	3791	\N
12996	35	4	0	4368	\N
12997	35	4	0	4369	\N
12996	1875	5	0	4374	\N
12997	1875	5	0	4375	\N
12949	189	2	0	4770	\N
12949	3441	3	0	4771	\N
13021	1151	3	0	5191	\N
13021	3462	4	0	5194	\N
13004	3453	3	0	5206	\N
12927	391	2	0	11048	\N
12927	1381	3	0	11050	\N
13044	77	3	0	13056	\N
13044	1877	4	0	13057	\N
13034	3467	3	0	14412	\N
13034	258	4	0	14428	\N
12977	38	3	0	16321	\N
12977	3445	4	0	16322	\N
13013	38	3	0	16332	\N
13013	3457	4	0	16333	\N
13108	326	4	0	17361	\N
12979	64	2	0	20658	\N
12979	277	3	0	20662	\N
12982	67	2	0	22103	\N
13008	67	2	0	22104	\N
12982	394	3	0	22106	\N
13008	394	3	0	22107	\N
12934	336	2	0	22736	\N
12934	3332	3	0	22737	\N
13001	82	2	0	23803	\N
13001	3401	3	0	23805	\N
13000	140	2	0	23971	\N
13000	3183	3	0	23973	\N
13018	3460	7	0	24453	\N
13079	214	3	0	24479	\N
13079	3496	4	0	24480	\N
12925	90	4	0	26011	\N
12925	3435	5	0	26012	\N
12952	90	2	0	26016	\N
12952	3442	3	0	26017	\N
13014	86	2	0	26640	\N
13014	3321	3	0	26642	\N
12944	107	1	0	26893	\N
12944	94	4	0	26896	\N
12944	2043	5	0	26898	\N
13053	2794	3	0	26900	\N
13125	94	3	0	26901	\N
13125	2864	4	0	26904	\N
12943	42	4	0	27505	\N
12943	3440	5	0	27506	\N
13025	16	0	0	28480	\N
13010	2627	2	0	29176	\N
13010	3456	3	0	29180	\N
13063	54	19	0	30044	\N
13092	54	6	0	30046	\N
13092	3507	7	0	30049	\N
13063	3485	20	0	30051	\N
13083	3499	5	0	30728	\N
13100	360	4	0	31372	\N
13100	3513	5	0	31377	\N
12963	33	6	0	31741	\N
12963	3444	7	0	31746	\N
12954	322	2	0	32559	\N
12954	1866	3	0	32562	\N
13002	322	1	0	32568	\N
13002	2968	2	0	32569	\N
12987	453	2	0	32706	\N
12987	3366	3	0	32708	\N
12912	1	8	0	33740	\N
12965	1	2	0	33757	\N
12965	283	3	0	33758	\N
13041	1	8	0	33765	\N
13041	3471	9	0	33766	\N
12918	2	4	0	35417	\N
12968	2	2	0	35418	\N
12968	2789	3	0	35423	\N
12918	2830	5	0	35427	\N
12955	4	2	0	35905	\N
12955	2751	3	0	35906	\N
13030	6	5	0	36267	\N
13030	2852	6	0	36268	\N
13066	3487	5	0	36284	\N
12920	10	2	0	37482	\N
12920	275	3	0	37488	\N
12922	10	2	0	37492	\N
12922	275	3	0	37493	\N
12950	10	4	0	37500	\N
12950	2568	5	0	37502	\N
12988	10	4	0	37516	\N
12988	2568	5	0	37517	\N
13076	10	4	0	37528	\N
13076	3493	5	0	37529	\N
13090	10	3	0	37531	\N
13122	10	3	0	37540	\N
13122	3173	4	0	37541	\N
12962	23	2	0	40672	\N
12962	3443	3	0	40673	\N
13116	23	3	0	40684	\N
13116	3497	4	0	40687	\N
13035	40	18	0	42761	\N
13029	2714	6	0	42762	\N
13035	3468	19	0	42763	\N
13038	40	3	0	42776	\N
13038	372	4	0	42777	\N
13043	40	6	0	42793	\N
13043	3472	7	0	42794	\N
13096	40	4	0	42827	\N
13096	3381	5	0	42828	\N
13026	51	4	0	43520	\N
13115	51	3	0	43521	\N
13115	3533	4	0	43523	\N
13026	2360	5	0	43524	\N
13105	119	1	0	48557	\N
13105	120	2	0	48565	\N
12958	200	2	0	51565	\N
12958	276	3	0	51566	\N
13045	200	8	0	51573	\N
13045	3473	9	0	51574	\N
13127	200	12	0	51579	\N
13127	3540	13	0	51580	\N
13019	210	3	0	51788	\N
13120	210	4	0	51789	\N
13120	3536	5	0	51790	\N
13019	3461	4	0	51791	\N
13080	242	3	0	52113	\N
13099	242	4	0	52114	\N
13080	2839	4	0	52116	\N
13099	3512	5	0	52117	\N
13084	324	4	0	54182	\N
13084	3500	5	0	54190	\N
13088	435	3	0	55059	\N
13088	3504	4	0	55060	\N
13113	3530	4	0	55061	\N
13113	3531	5	0	55062	\N
13057	595	16	0	55652	\N
13057	3479	17	0	55663	\N
13067	908	4	0	57574	\N
13067	3488	5	0	57576	\N
13110	3525	10	1	57837	\N
13113	3529	4	0	57842	\N
13110	3522	9	0	58544	\N
13110	3526	11	0	58548	\N
13037	2636	3	0	58689	\N
13039	2636	3	0	58690	\N
13037	2837	4	0	58693	\N
13039	2837	4	0	58694	\N
13077	2351	4	0	58976	\N
13077	3494	5	0	58979	\N
13036	3051	3	0	59450	\N
13005	12	5	0	279	\N
13003	3452	7	0	282	\N
13046	266	3	0	1222	\N
13046	3474	4	0	1223	\N
13103	251	3	0	1458	\N
13103	3514	4	0	1460	\N
13112	3527	6	0	1737	\N
13112	1949	9	0	1740	\N
13112	3528	10	0	1741	\N
13118	1722	8	0	2275	\N
13118	3534	9	0	2276	\N
13028	3464	2	0	3223	\N
13028	3465	3	0	3224	\N
12948	2743	3	0	3759	\N
13074	263	1	0	3761	\N
13074	262	2	0	3790	\N
13110	3524	10	0	10072	\N
13110	3521	6	0	10279	\N
13110	3523	9	0	10285	\N
13048	391	5	0	10912	\N
13048	3475	6	0	10913	\N
13036	1381	2	0	11035	\N
13036	3469	3	0	11040	\N
13121	687	12	0	11601	\N
13121	3537	13	0	11602	\N
12981	1849	3	0	13750	\N
13106	3517	0	0	14431	\N
13031	192	7	0	15565	\N
13031	3466	8	0	15566	\N
13064	44	4	0	16008	\N
13064	3486	5	0	16013	\N
13061	115	3	0	16927	\N
13061	3483	4	0	16928	\N
13009	326	2	0	17341	\N
13009	393	3	0	17343	\N
13123	177	4	0	18324	\N
13123	3538	5	0	18325	\N
12995	290	4	0	18992	\N
12957	1909	3	0	18994	\N
12995	2759	5	0	18996	\N
13040	60	8	0	19419	\N
13042	60	8	0	19420	\N
13040	3470	9	0	19424	\N
13042	3470	9	0	19425	\N
13051	62	5	0	19730	\N
13051	3478	6	0	19734	\N
13016	336	5	0	22741	\N
13016	3458	6	0	22744	\N
12999	140	2	0	23970	\N
13098	206	4	0	25929	\N
13098	3511	5	0	25935	\N
12992	244	4	0	27244	\N
12992	3447	5	0	27245	\N
13032	244	2	0	27254	\N
13032	3308	3	0	27256	\N
12969	16	2	0	28475	\N
12969	388	3	0	28477	\N
13006	16	5	0	28479	\N
13006	3455	6	0	28482	\N
13052	16	5	0	28483	\N
13060	16	16	0	28484	\N
13060	3482	17	0	28486	\N
13093	151	3	0	30725	\N
13093	3046	4	0	30727	\N
12985	453	1	0	32732	\N
12985	454	2	0	32733	\N
13033	1	2	0	33761	\N
13033	283	3	0	33762	\N
13054	1	2	0	33769	\N
13054	2950	3	0	33770	\N
13055	1	5	0	33773	\N
13073	53	1	0	33775	\N
13073	1	2	0	33778	\N
13091	53	2	0	33784	\N
13111	1	2	0	33786	\N
13111	112	3	0	33793	\N
13097	2	4	0	35419	\N
13097	3510	5	0	35426	\N
12961	10	6	0	37501	\N
12961	2718	7	0	37503	\N
12967	10	2	0	37506	\N
12972	10	2	0	37507	\N
12967	275	3	0	37509	\N
12972	275	3	0	37510	\N
13050	10	5	0	37519	\N
13050	3477	6	0	37521	\N
13069	3490	9	0	37522	\N
13075	10	6	0	37525	\N
13075	1946	7	0	37526	\N
13101	10	4	0	37532	\N
13117	10	3	0	37533	\N
13117	3173	4	0	37535	\N
13101	3493	5	0	37536	\N
13068	14	8	0	39108	\N
13068	3489	9	0	39115	\N
13024	23	2	0	40682	\N
13024	3443	3	0	40685	\N
13102	40	4	0	42835	\N
13102	3381	5	0	42836	\N
13175	40	10	0	42851	\N
13175	3566	11	0	42854	\N
13129	56	10	0	44134	\N
13130	56	7	0	44135	\N
13130	3543	8	0	44136	\N
13129	3542	11	0	44138	\N
13147	56	21	0	44140	\N
13147	3549	22	0	44141	\N
13149	56	5	0	44142	\N
13149	3551	6	0	44143	\N
13161	56	4	0	44144	\N
13161	3556	5	0	44152	\N
13156	79	4	0	46764	\N
13158	79	2	0	46765	\N
13158	80	3	0	46766	\N
13156	2758	5	0	46767	\N
13107	119	4	0	48558	\N
13133	119	4	0	48559	\N
13107	3518	5	0	48568	\N
13133	3518	5	0	48569	\N
13157	200	4	0	51593	\N
13174	200	4	0	51594	\N
13157	2811	5	0	51595	\N
13174	2811	5	0	51596	\N
13124	210	3	0	51795	\N
13124	3539	4	0	51796	\N
13167	260	2	0	52538	\N
13167	3184	3	0	52539	\N
13086	279	4	0	53219	\N
13086	3502	5	0	53220	\N
13208	435	3	0	55065	\N
13208	3504	4	0	55066	\N
13058	597	16	0	55858	\N
13058	3480	17	0	55866	\N
13078	1109	3	0	56199	\N
13144	1109	3	0	56200	\N
13145	1109	3	0	56201	\N
13078	3495	4	0	56202	\N
13144	3495	4	0	56203	\N
13145	3495	4	0	56204	\N
13192	1109	9	0	56212	\N
13192	3580	10	0	56214	\N
13141	1150	1	0	56633	\N
13142	1150	1	0	56634	\N
13141	793	9	0	56635	\N
13142	793	9	0	56636	\N
13141	3547	10	0	56637	\N
13142	3547	10	0	56638	\N
13151	908	7	0	57589	\N
13152	908	2	0	57590	\N
13153	908	2	0	57591	\N
13160	908	6	0	57592	\N
13152	2832	3	0	57594	\N
13153	2832	3	0	57595	\N
13160	3555	7	0	57597	\N
13151	3552	8	0	57598	\N
13089	3505	3	0	58454	\N
13089	3506	4	0	58455	\N
13203	3589	3	0	2986	\N
13085	3501	5	0	3196	\N
13180	367	9	0	3307	\N
13180	3571	10	0	3308	\N
13139	35	4	0	4370	\N
13171	35	3	0	4371	\N
13171	3563	4	0	4372	\N
13139	3545	5	0	4373	\N
13154	391	9	0	10284	\N
13154	3553	10	0	10286	\N
13164	391	5	0	10301	\N
13164	3558	6	0	10304	\N
13071	455	1	0	11167	\N
13071	1423	6	0	11177	\N
13165	92	5	0	14981	\N
13165	3559	6	0	14982	\N
13162	235	10	0	15651	\N
13162	3557	11	0	15652	\N
13159	212	6	0	17045	\N
13159	3554	7	0	17046	\N
13170	3561	37	0	17660	\N
13170	167	126	0	17676	\N
13170	3562	127	0	17794	\N
13132	30	17	0	18086	\N
13132	3544	18	0	18087	\N
13198	3585	4	0	19422	\N
13196	164	6	0	21057	\N
13196	3583	7	0	21061	\N
13170	1075	127	1	21965	\N
13136	73	4	0	22463	\N
13136	2284	5	0	22464	\N
13150	73	2	0	22469	\N
13150	2766	3	0	22470	\N
13177	337	3	0	22738	\N
13177	336	13	0	22742	\N
13177	3568	14	0	22743	\N
13176	264	10	0	23491	\N
13094	82	4	0	23804	\N
13094	3508	5	0	23806	\N
13172	69	4	0	24704	\N
13172	3564	5	0	24708	\N
13119	224	8	0	25482	\N
13119	3535	9	0	25492	\N
13178	2596	3	0	26633	\N
13178	86	13	0	26644	\N
13178	3569	14	0	26645	\N
13140	16	4	0	28487	\N
13140	3546	5	0	28488	\N
13104	96	4	0	29465	\N
13070	54	8	0	30045	\N
13070	3491	9	0	30050	\N
13166	33	5	0	31742	\N
13166	3560	6	0	31744	\N
13055	2382	6	0	33774	\N
13137	1	3	0	33787	\N
13146	1	7	0	33788	\N
13155	1	5	0	33789	\N
13163	1	1	0	33790	\N
13163	53	2	0	33791	\N
13137	3393	4	0	33792	\N
13155	1233	6	0	33794	\N
13211	53	1	0	33808	\N
13062	431	19	0	34811	\N
13062	3484	20	0	34812	\N
13173	431	4	0	34813	\N
13173	3565	5	0	34817	\N
13128	2	12	0	35420	\N
13143	2	3	0	35421	\N
13143	3548	4	0	35424	\N
13128	3541	13	0	35428	\N
13169	4	2	0	35912	\N
13169	2751	3	0	35915	\N
13138	10	4	0	37548	\N
13138	3493	5	0	37552	\N
13189	3578	10	0	37554	\N
13082	14	4	0	39109	\N
13135	14	4	0	39110	\N
13168	14	2	0	39111	\N
13168	1785	3	0	39112	\N
13082	3498	5	0	39113	\N
13135	3498	5	0	39114	\N
13065	18	4	0	39962	\N
13134	18	4	0	39963	\N
13065	2302	5	0	39964	\N
13134	2302	5	0	39965	\N
13148	3550	6	0	39970	\N
13081	23	3	0	40683	\N
13081	3497	4	0	40686	\N
2366	56	1	0	43746	\N
13327	3664	112	0	44153	\N
13313	88	3	0	47106	\N
13313	3655	4	0	47108	\N
13183	3573	123	0	47796	\N
13183	102	126	0	47801	\N
13183	3574	127	0	47802	\N
13216	102	3	0	47806	\N
13216	3597	4	0	47807	\N
13233	102	2	0	47813	\N
13233	3574	3	0	47815	\N
13448	3738	3	0	49712	\N
13448	137	9	0	49741	\N
13448	3739	10	0	49934	\N
13456	181	0	0	50870	\N
13423	186	9	0	51225	\N
13423	3724	10	0	51227	\N
13487	186	6	0	51236	\N
13487	3759	7	0	51239	\N
13303	260	9	0	52542	\N
13429	260	4	0	52543	\N
13429	3728	5	0	52544	\N
13303	3649	10	0	52545	\N
13285	273	3	0	52940	\N
13285	3638	4	0	52942	\N
13290	279	3	0	53223	\N
13290	3641	4	0	53224	\N
13445	3658	3	0	54836	\N
13445	362	10	0	54843	\N
13445	3736	11	0	54845	\N
13364	435	6	0	55067	\N
13364	3688	7	0	55068	\N
13359	793	3	0	56650	\N
13359	2644	4	0	56653	\N
13327	3387	111	1	56903	\N
13497	841	6	0	57052	\N
13497	3769	7	0	57053	\N
13349	908	4	0	57603	\N
13351	908	1	0	57605	\N
13351	909	2	0	57606	\N
13349	3488	5	0	57607	\N
13450	908	1	0	57618	\N
13450	909	2	0	57622	\N
13281	1914	0	0	58478	\N
13247	2636	2	0	58698	\N
13247	2836	3	0	58700	\N
13527	3780	5	0	58702	\N
13527	2636	7	0	58710	\N
13527	3207	8	0	58713	\N
13499	2351	3	0	58977	\N
13499	2845	4	0	58978	\N
13319	2782	3	0	59265	\N
13319	3659	4	0	59266	\N
13448	3740	11	0	59475	\N
13333	3625	10	0	59491	\N
13333	3669	11	0	59505	\N
13265	3629	8	0	59636	\N
13237	3611	4	0	812	\N
13193	228	8	0	2982	\N
13193	3581	9	0	2987	\N
13179	1509	3	0	4504	\N
13322	365	44	0	4513	\N
13179	365	13	0	4516	\N
13179	3570	14	0	4519	\N
13322	3661	45	0	4520	\N
13402	189	6	0	4789	\N
13402	3713	7	0	4796	\N
13204	373	3	0	5347	\N
13204	3590	4	0	5350	\N
13397	132	7	0	11192	\N
13431	132	3	0	11200	\N
13431	3729	4	0	11201	\N
13462	300	3	0	12109	\N
13462	3747	4	0	12110	\N
13504	123	3	0	12742	\N
13504	2856	4	0	12744	\N
13448	3593	10	1	13417	\N
13518	233	4	0	13748	\N
13518	3775	5	0	13752	\N
13257	402	2	0	14051	\N
13257	1148	3	0	14053	\N
13301	3647	7	0	14983	\N
13301	3648	96	0	14995	\N
13254	235	6	0	15661	\N
13254	3622	7	0	15663	\N
13269	44	3	0	16009	\N
13269	3631	4	0	16012	\N
13435	212	4	0	17089	\N
13484	212	9	0	17090	\N
13435	3732	5	0	17098	\N
13484	3757	10	0	17102	\N
13380	30	1	0	18089	\N
13380	418	2	0	18090	\N
13385	177	3	0	18328	\N
13240	241	3	0	20400	\N
13275	241	2	0	20401	\N
13275	634	3	0	20406	\N
13240	3613	4	0	20407	\N
13459	336	0	0	22750	\N
13399	69	7	0	24718	\N
13399	3711	8	0	24731	\N
13474	49	1	0	25017	\N
13474	50	2	0	25020	\N
13224	224	3	0	25483	\N
13224	3603	4	0	25488	\N
13259	94	1	0	26905	\N
13521	244	4	0	27255	\N
13521	3778	5	0	27257	\N
13377	16	4	0	28498	\N
13377	3546	5	0	28499	\N
13532	16	3	0	28507	\N
13437	96	4	0	29520	\N
13437	3515	5	0	29521	\N
13310	449	2	0	29817	\N
13310	646	3	0	29820	\N
13360	54	4	0	30066	\N
13360	3685	5	0	30067	\N
13419	54	3	0	30072	\N
13199	360	5	0	31373	\N
13199	3586	6	0	31378	\N
13181	1	1	0	33797	\N
13181	53	2	0	33798	\N
13186	1	2	0	33802	\N
13186	112	3	0	33804	\N
13211	1	3	0	33810	\N
13219	1	2	0	33815	\N
13262	1	0	0	33822	\N
13278	1	0	0	33825	\N
13475	1	1	0	33848	\N
13475	53	2	0	33850	\N
13478	53	2	0	33863	\N
13295	2	3	0	35452	\N
13295	3548	4	0	35454	\N
13298	2	3	0	35475	\N
13298	3548	4	0	35477	\N
13432	10	12	0	37598	\N
13432	3730	13	0	37599	\N
13464	10	3	0	37608	\N
13464	3173	4	0	37609	\N
13214	18	5	0	39969	\N
13214	3550	6	0	39971	\N
13274	18	2	0	39979	\N
13525	18	4	0	39988	\N
13525	3779	5	0	39993	\N
13406	27	1	0	41032	\N
13490	27	6	0	41034	\N
13406	28	2	0	41035	\N
13490	3302	7	0	41037	\N
13361	40	4	0	42892	\N
13365	40	3	0	42893	\N
13365	372	4	0	42894	\N
13361	3381	5	0	42895	\N
13409	40	8	0	42908	\N
13409	3718	9	0	42909	\N
13411	40	4	0	42916	\N
13411	3381	5	0	42917	\N
13370	3694	9	1	43740	\N
13370	475	3	0	44154	\N
13370	56	8	0	44158	\N
13383	79	8	0	46853	\N
13383	3701	9	0	46854	\N
13182	102	4	0	47799	\N
13182	3572	5	0	47800	\N
13342	113	4	0	48247	\N
13342	3677	5	0	48248	\N
13334	119	10	0	48562	\N
13334	3670	11	0	48574	\N
13316	147	3	0	49982	\N
13316	3657	4	0	49985	\N
13420	210	6	0	51813	\N
13420	3721	7	0	51814	\N
13354	273	3	0	52946	\N
13354	3638	4	0	52948	\N
13395	279	7	0	53231	\N
13395	3707	8	0	53238	\N
13347	324	5	0	54183	\N
13347	3680	6	0	54192	\N
13188	362	6	0	54828	\N
13188	3577	7	0	54829	\N
13317	362	3	0	54833	\N
13317	3658	4	0	54834	\N
13446	3658	3	0	54837	\N
13446	362	10	0	54844	\N
13446	3736	11	0	54846	\N
13330	451	4	0	55205	\N
13330	3666	5	0	55206	\N
13438	595	1	0	55654	\N
13438	596	2	0	55658	\N
13314	597	3	0	55859	\N
13314	3656	4	0	55863	\N
13191	1109	7	0	56211	\N
13191	3579	8	0	56213	\N
13308	793	3	0	56642	\N
13308	2644	4	0	56643	\N
13225	841	3	0	57008	\N
13306	841	3	0	57009	\N
13225	3604	4	0	57011	\N
13306	3604	4	0	57012	\N
13452	841	5	0	57024	\N
13452	3742	6	0	57025	\N
13350	908	4	0	57604	\N
13350	3488	5	0	57608	\N
13451	908	3	0	57619	\N
13451	3741	4	0	57621	\N
13248	2636	4	0	58699	\N
13248	3617	5	0	58701	\N
13291	3625	6	0	59490	\N
13291	3642	7	0	59504	\N
13457	3744	9	0	827	\N
13398	110	8	0	2511	\N
13206	134	2	0	2514	\N
13398	3710	9	0	2518	\N
13348	2982	5	0	3194	\N
13348	3681	6	0	3197	\N
13323	365	9	0	4514	\N
13323	3570	10	0	4517	\N
13407	132	4	0	11193	\N
13407	3716	5	0	11194	\N
13328	58	3	0	13509	\N
13328	3665	4	0	13518	\N
13370	3693	9	0	13702	\N
13258	2548	5	0	14054	\N
13228	173	6	0	14628	\N
13241	173	4	0	14629	\N
13241	3614	5	0	14630	\N
13228	3606	7	0	14631	\N
13243	235	4	0	15660	\N
13243	3615	5	0	15662	\N
13245	212	2	0	17058	\N
13245	3616	3	0	17060	\N
13221	198	7	0	20033	\N
13221	3601	8	0	20034	\N
13195	164	2	0	21056	\N
13368	440	7	0	21759	\N
13368	3691	8	0	21760	\N
13370	1075	10	0	22029	\N
13230	67	7	0	22115	\N
13230	3608	8	0	22117	\N
13340	74	1	0	22471	\N
13340	73	9	0	22502	\N
13340	3675	10	0	22503	\N
13460	336	0	0	22751	\N
13270	264	3	0	23508	\N
13270	3632	4	0	23509	\N
13443	3735	6	0	23913	\N
13390	411	3	0	25235	\N
13390	3596	4	0	25239	\N
13226	224	69	0	25484	\N
13226	3605	70	0	25493	\N
13299	42	3	0	27513	\N
13299	3645	4	0	27514	\N
13260	2575	4	0	28489	\N
13260	16	6	0	28490	\N
13260	1087	7	0	28491	\N
13388	16	3	0	28502	\N
13388	3634	4	0	28503	\N
13288	96	3	0	29478	\N
13373	96	4	0	29489	\N
13373	3515	5	0	29490	\N
13201	151	6	0	30734	\N
13201	3588	7	0	30737	\N
13425	360	4	0	31391	\N
13425	3513	5	0	31393	\N
13296	322	4	0	32397	\N
13296	3429	5	0	32398	\N
13185	1	2	0	33801	\N
13185	112	3	0	33803	\N
13219	112	3	0	33816	\N
13255	1	0	0	33821	\N
13325	1	1	0	33831	\N
13325	53	2	0	33832	\N
13428	1	1	0	33847	\N
13428	53	2	0	33849	\N
13207	2	3	0	35422	\N
13207	3548	4	0	35425	\N
13304	2	9	0	35476	\N
13304	3650	10	0	35478	\N
13430	2	4	0	35501	\N
13430	3510	5	0	35502	\N
13210	11	1	0	37553	\N
13267	10	3	0	37557	\N
13267	297	4	0	37559	\N
13210	3592	8	0	37560	\N
13286	10	3	0	37565	\N
13286	3173	4	0	37570	\N
13400	10	7	0	37585	\N
13400	3705	8	0	37588	\N
13414	2770	5	0	37589	\N
13414	10	6	0	37595	\N
13252	18	3	0	39974	\N
13252	3621	4	0	39975	\N
13282	18	3	0	39980	\N
13282	3621	4	0	39983	\N
13337	1270	13	0	40983	\N
13403	27	3	0	41030	\N
13403	3714	4	0	41038	\N
13212	40	7	0	42852	\N
13324	40	3	0	42885	\N
13324	372	4	0	42886	\N
13442	40	1	0	42934	\N
13442	41	2	0	42935	\N
13236	71	2	0	44774	\N
13236	1125	3	0	44778	\N
13307	79	3	0	46798	\N
13307	3652	4	0	46800	\N
13353	79	3	0	46831	\N
13353	3652	4	0	46832	\N
13200	113	6	0	48227	\N
13200	3587	7	0	48228	\N
13251	113	3	0	48235	\N
13251	3620	4	0	48236	\N
13264	119	8	0	48560	\N
13293	119	6	0	48561	\N
13293	3644	7	0	48571	\N
13264	3627	9	0	48573	\N
13447	3630	3	0	49451	\N
13268	135	3	0	49462	\N
13268	3630	4	0	49465	\N
13447	135	10	0	49466	\N
13447	3737	11	0	49469	\N
13375	137	4	0	49733	\N
13375	3697	5	0	49749	\N
13436	147	1	0	50007	\N
13436	599	2	0	50024	\N
13413	181	2	0	50869	\N
13413	769	3	0	50871	\N
13339	285	4	0	53453	\N
13427	285	4	0	53454	\N
13339	3674	5	0	53455	\N
13427	3674	5	0	53456	\N
13256	316	6	0	53919	\N
13256	3623	7	0	53920	\N
13477	324	7	0	54184	\N
13477	3753	8	0	54193	\N
13213	362	5	0	54832	\N
13213	3371	6	0	54835	\N
13197	435	6	0	55063	\N
13197	3584	7	0	55064	\N
13454	451	4	0	55216	\N
13454	3666	5	0	55221	\N
13312	595	3	0	55653	\N
13312	3654	4	0	55660	\N
13356	793	3	0	56649	\N
13356	2644	4	0	56652	\N
13223	841	1	0	57007	\N
13223	842	2	0	57010	\N
13239	852	1	0	57217	\N
13239	913	2	0	57219	\N
13209	908	3	0	57593	\N
13209	3591	4	0	57596	\N
13449	908	3	0	57617	\N
13449	3741	4	0	57620	\N
13280	1914	1	0	58477	\N
13280	2031	2	0	58480	\N
13382	2636	8	0	58706	\N
13382	3700	9	0	58715	\N
13321	2782	3	0	59275	\N
13321	3659	4	0	59276	\N
13394	3706	8	0	296	\N
13416	3720	11	0	305	\N
13401	424	6	0	810	\N
13401	3712	7	0	814	\N
13205	110	3	0	2509	\N
13205	2995	4	0	2515	\N
13344	367	4	0	3315	\N
13344	3679	5	0	3318	\N
13405	189	2	0	4790	\N
13405	311	3	0	4795	\N
13318	132	2	0	11174	\N
13318	2756	3	0	11176	\N
13184	58	6	0	13497	\N
13422	58	9	0	13510	\N
13422	3723	10	0	13521	\N
13305	92	6	0	15009	\N
13305	3651	7	0	15010	\N
13242	235	4	0	15659	\N
13242	2233	5	0	15664	\N
13287	212	3	0	17072	\N
13287	3639	4	0	17073	\N
13396	177	7	0	18330	\N
13396	3708	8	0	18331	\N
13277	290	3	0	19002	\N
13277	3635	4	0	19004	\N
13392	3385	4	0	21059	\N
13190	488	3	0	21470	\N
13190	1324	4	0	21472	\N
13489	1018	2	0	22034	\N
13367	336	7	0	22748	\N
13367	3690	8	0	22758	\N
13220	149	7	0	23059	\N
13220	3600	8	0	23063	\N
13187	264	7	0	23500	\N
13187	3576	8	0	23501	\N
13358	264	2	0	23517	\N
13387	264	3	0	23518	\N
13387	3632	4	0	23521	\N
13424	214	10	0	24502	\N
13424	3725	11	0	24503	\N
13332	69	3	0	24705	\N
13336	69	10	0	24706	\N
13332	3668	4	0	24707	\N
13336	3672	11	0	24709	\N
13300	49	3	0	25010	\N
13300	3646	4	0	25011	\N
13215	411	3	0	25226	\N
13215	3596	4	0	25228	\N
13434	90	4	0	26023	\N
13461	86	3	0	26641	\N
13461	3746	4	0	26643	\N
13246	94	1	0	26902	\N
13246	107	2	0	26903	\N
13329	94	3	0	26907	\N
13329	2864	4	0	26908	\N
13369	94	8	0	26909	\N
13369	3692	9	0	26910	\N
13483	322	9	0	32403	\N
13483	3756	10	0	32404	\N
13194	1	6	0	33806	\N
13194	3582	7	0	33807	\N
13372	1	3	0	33840	\N
13372	48	4	0	33843	\N
13232	2	2	0	35450	\N
13232	2990	3	0	35453	\N
13202	10	3	0	37550	\N
13202	3173	4	0	37551	\N
13218	10	6	0	37556	\N
13218	3599	7	0	37561	\N
13273	10	2	0	37564	\N
13273	275	3	0	37569	\N
13346	10	4	0	37573	\N
13346	3493	5	0	37574	\N
13376	3493	5	0	37577	\N
13379	10	4	0	37583	\N
13379	3493	5	0	37586	\N
13486	2718	6	0	37610	\N
13473	10	4	0	37613	\N
13473	3493	5	0	37614	\N
13486	10	12	0	37615	\N
13486	2770	13	0	37616	\N
13455	18	3	0	39981	\N
13455	3621	4	0	39984	\N
13470	18	3	0	39987	\N
13470	3621	4	0	39991	\N
13244	3189	5	0	40713	\N
13212	3595	8	0	42853	\N
13297	40	6	0	42867	\N
13297	2777	7	0	42868	\N
13433	40	4	0	42930	\N
13433	3381	5	0	42931	\N
13444	40	1	0	42940	\N
13444	41	2	0	42941	\N
13331	51	5	0	43522	\N
13331	3667	6	0	43525	\N
13500	71	3	0	44775	\N
13500	3770	4	0	44779	\N
13343	79	4	0	46799	\N
13343	3678	5	0	46801	\N
13352	79	7	0	46830	\N
13352	3682	8	0	46833	\N
13217	3598	123	0	47803	\N
13217	102	126	0	47808	\N
13217	3574	127	0	47809	\N
13231	102	1	0	47812	\N
13231	3197	2	0	47814	\N
13234	102	56	0	47816	\N
13234	3609	57	1	48150	\N
13374	135	4	0	49463	\N
13374	3696	5	0	49468	\N
13271	137	3	0	49732	\N
13271	3633	4	0	49747	\N
13362	3686	91	0	50865	\N
13362	181	126	0	50872	\N
13362	3687	127	0	50873	\N
13421	186	3	0	51224	\N
13421	3722	4	0	51226	\N
13488	186	4	0	51237	\N
13309	210	3	0	51807	\N
13309	3539	4	0	51808	\N
13272	260	2	0	52540	\N
13272	3184	3	0	52541	\N
13495	353	1	0	54567	\N
13495	354	2	0	54569	\N
13453	451	5	0	55215	\N
13453	3743	6	0	55222	\N
13439	597	4	0	55860	\N
13439	3733	5	0	55864	\N
13249	793	4	0	56641	\N
13249	3618	5	0	56644	\N
13412	793	6	0	56651	\N
13412	3719	7	0	56654	\N
13238	852	3	0	57216	\N
13238	3612	4	0	57220	\N
13283	1914	3	0	58479	\N
13283	3637	4	0	58481	\N
13263	3626	8	0	59485	\N
13292	3643	7	0	59635	\N
13335	3628	10	0	59639	\N
13335	3671	11	0	59660	\N
13315	424	3	0	809	\N
13315	3611	4	0	813	\N
13466	2132	77	0	1693	\N
13311	117	3	0	2217	\N
13311	3653	4	0	2221	\N
13426	3726	1	0	3042	\N
13426	3727	2	0	3044	\N
13479	2982	4	0	3198	\N
13479	3501	5	0	3202	\N
13355	367	3	0	3316	\N
13355	3683	4	0	3317	\N
13465	367	3	0	3325	\N
13465	3683	4	0	3327	\N
13320	391	3	0	10302	\N
13320	3660	4	0	10303	\N
13326	391	7	0	10309	\N
13326	3662	8	0	10310	\N
13384	528	8	0	12479	\N
13384	3702	9	0	12484	\N
13250	77	4	0	13067	\N
13250	3619	5	0	13068	\N
13391	233	3	0	13746	\N
13476	233	7	0	13747	\N
13391	3704	4	0	13751	\N
13476	3752	8	0	13753	\N
13381	3699	16	0	14635	\N
13253	235	0	0	15678	\N
13284	212	6	0	17059	\N
13284	3554	7	0	17061	\N
13466	3561	37	0	17677	\N
13466	167	76	0	17693	\N
13466	3748	77	1	17949	\N
13289	30	3	0	18088	\N
13289	3640	4	0	18091	\N
13466	3108	78	0	18793	\N
13507	62	10	0	19731	\N
13366	440	13	0	21758	\N
13466	1075	78	1	21766	\N
13488	3009	6	0	22033	\N
13229	67	6	0	22114	\N
13229	3607	7	0	22116	\N
13467	67	3	0	22123	\N
13467	3749	4	0	22124	\N
13458	336	3	0	22749	\N
13458	3745	4	0	22757	\N
13357	264	4	0	23516	\N
13357	3684	5	0	23522	\N
13234	3610	58	0	23974	\N
13472	49	4	0	25016	\N
13481	42	18	0	27533	\N
13481	3754	19	0	27534	\N
13276	16	3	0	28492	\N
13276	3634	4	0	28493	\N
13279	16	9	0	28494	\N
13279	3636	10	0	28495	\N
13294	16	6	0	28496	\N
13294	3369	7	0	28497	\N
13386	16	3	0	28500	\N
13386	3634	4	0	28501	\N
13418	16	3	0	28504	\N
13418	3634	4	0	28505	\N
13463	3634	4	0	28510	\N
13378	96	5	0	29504	\N
13378	3698	6	0	29505	\N
13471	96	7	0	29539	\N
13471	3750	8	0	29540	\N
13469	54	3	0	30080	\N
13469	3041	4	0	30081	\N
13338	202	4	0	31058	\N
13338	3673	5	0	31059	\N
13222	360	3	0	31383	\N
13222	3602	4	0	31384	\N
13302	1	0	0	33827	\N
13363	53	2	0	33837	\N
13415	1	2	0	33841	\N
13415	112	3	0	33842	\N
13498	1	1	0	33861	\N
13498	53	2	0	33864	\N
13261	2	5	0	35451	\N
13261	3624	6	0	35455	\N
13341	11	1	0	37562	\N
13345	10	3	0	37566	\N
13345	2917	4	0	37567	\N
13341	10	9	0	37568	\N
13341	3676	10	0	37571	\N
13393	3705	8	0	37587	\N
13441	10	15	0	37604	\N
13441	3734	16	0	37605	\N
13371	27	11	0	41010	\N
13371	3695	12	0	41011	\N
13404	27	6	0	41031	\N
13408	27	4	0	41033	\N
13408	3717	5	0	41036	\N
13404	3715	7	0	41039	\N
13501	40	1	0	42944	\N
13501	41	2	0	42947	\N
13523	71	4	0	44776	\N
13523	2776	5	0	44781	\N
13485	79	9	0	46867	\N
13485	3758	10	0	46868	\N
13560	79	3	0	46887	\N
13560	3652	4	0	46890	\N
13630	88	16	0	47116	\N
13630	3828	17	0	47117	\N
13519	100	4	0	47551	\N
13644	100	3	0	47553	\N
13644	3836	4	0	47555	\N
13519	3776	5	0	47556	\N
13626	102	12	0	47821	\N
13626	3825	13	0	47825	\N
13750	102	7	0	47829	\N
13750	3884	8	0	47839	\N
13539	135	3	0	49464	\N
13539	3630	4	0	49467	\N
13686	135	2	0	49503	\N
13686	2722	3	0	49504	\N
13625	137	1	0	49735	\N
13625	138	2	0	49742	\N
13656	170	0	0	50554	\N
13594	210	4	0	51821	\N
13594	3536	5	0	51837	\N
13611	268	3	0	52747	\N
13611	3815	4	0	52749	\N
13502	273	3	0	52947	\N
13502	3638	4	0	52949	\N
13570	273	3	0	52957	\N
13570	3638	4	0	52964	\N
13480	324	4	0	54185	\N
13480	3500	5	0	54191	\N
13685	353	2	0	54579	\N
13685	2884	3	0	54584	\N
13740	595	4	0	55656	\N
13740	3878	5	0	55661	\N
13614	1109	4	0	56174	\N
13614	3816	5	0	56175	\N
13670	793	3	0	56657	\N
13670	2644	4	0	56658	\N
13509	908	16	0	57629	\N
13511	908	3	0	57631	\N
13511	3591	4	0	57632	\N
13509	3772	17	0	57633	\N
13648	1470	3	0	58197	\N
13648	3838	4	0	58198	\N
13590	2636	5	0	58707	\N
13590	3780	6	0	58712	\N
13653	3843	6	0	59123	\N
13653	3051	4	0	59451	\N
13653	3842	5	1	59462	\N
13541	3625	3	0	59492	\N
13541	3784	4	0	59500	\N
13583	3628	4	0	59641	\N
13583	3803	5	0	59656	\N
13697	2103	3	0	1233	\N
13749	3883	8	0	1467	\N
13637	2982	14	0	3199	\N
13689	2982	2	0	3200	\N
13689	3383	3	0	3201	\N
13637	3832	15	0	3203	\N
13574	367	3	0	3326	\N
13574	3683	4	0	3328	\N
13491	262	5	0	3779	\N
13491	3763	6	0	3787	\N
13592	35	3	0	4377	\N
13592	3563	4	0	4380	\N
13533	189	3	0	4791	\N
13699	459	2	0	11965	\N
13699	3860	3	0	11966	\N
13723	459	4	0	11972	\N
13723	3869	5	0	11973	\N
13482	58	9	0	13511	\N
13546	58	1	0	13513	\N
13546	59	2	0	13516	\N
13482	3755	10	0	13522	\N
13677	763	3	0	15251	\N
13677	3854	4	0	15252	\N
13596	192	3	0	15568	\N
13715	192	9	0	15569	\N
13715	3864	10	0	15572	\N
13516	235	1	0	15672	\N
13517	235	3	0	15673	\N
13516	236	2	0	15676	\N
13517	3343	4	0	15677	\N
13493	44	9	0	16010	\N
13493	3765	10	0	16014	\N
13711	212	4	0	17091	\N
13735	212	3	0	17093	\N
13735	3639	4	0	17097	\N
13711	3732	5	0	17099	\N
13585	326	5	0	17370	\N
13675	290	3	0	19015	\N
13675	3635	4	0	19018	\N
13507	3771	11	0	19735	\N
13703	3273	4	0	20036	\N
13703	198	5	0	20055	\N
13694	3858	41	0	21488	\N
13694	488	89	0	21496	\N
13694	3859	90	0	21497	\N
13718	145	4	0	22037	\N
13718	3867	5	0	22039	\N
13554	336	0	0	22754	\N
13731	3875	4	0	23002	\N
13621	140	4	0	23983	\N
13728	140	7	0	23984	\N
13621	3821	5	0	23985	\N
13728	3874	8	0	23986	\N
13587	214	4	0	24521	\N
13587	3807	5	0	24522	\N
13599	411	3	0	25236	\N
13599	3596	4	0	25240	\N
13616	3321	2	0	26509	\N
13616	86	5	0	26527	\N
13616	2890	6	0	26529	\N
13658	3846	0	0	29405	\N
13580	96	13	0	29552	\N
13580	3801	14	0	29553	\N
13550	54	5	0	30106	\N
13550	3787	6	0	30110	\N
13664	360	16	0	31402	\N
13664	3852	17	0	31403	\N
13653	3841	5	0	32978	\N
13653	53	1	0	33874	\N
13653	3840	4	0	33879	\N
13721	1	4	0	33900	\N
13721	3820	5	0	33902	\N
13505	10	3	0	37619	\N
13512	10	3	0	37625	\N
13512	3173	4	0	37626	\N
13524	10	4	0	37633	\N
13565	10	8	0	37649	\N
13565	3792	9	0	37650	\N
13641	10	4	0	37675	\N
13641	3493	5	0	37676	\N
13730	10	4	0	37709	\N
13730	3493	5	0	37710	\N
13736	3173	3	0	37711	\N
13736	10	4	0	37721	\N
13757	10	8	0	37727	\N
13530	18	1	0	39989	\N
13530	1426	2	0	39990	\N
13618	1685	2	0	39992	\N
13618	18	5	0	39996	\N
13618	3817	6	0	39997	\N
13506	40	1	0	42945	\N
13506	41	2	0	42948	\N
13647	40	3	0	42952	\N
13647	372	4	0	42953	\N
13695	40	6	0	42963	\N
13695	2777	7	0	42964	\N
13737	372	3	0	42965	\N
13737	40	4	0	42968	\N
13758	40	8	0	42978	\N
13758	3718	9	0	42982	\N
13729	56	7	0	44147	\N
13729	3543	8	0	44151	\N
13561	79	2	0	46888	\N
13561	616	3	0	46889	\N
13791	88	4	0	47135	\N
13791	3809	5	0	47139	\N
13566	100	8	0	47552	\N
13566	3793	9	0	47558	\N
13535	102	5	0	47819	\N
13538	102	3	0	47820	\N
13538	3597	4	0	47823	\N
13535	3783	6	0	47824	\N
13649	135	2	0	49490	\N
13649	2722	3	0	49491	\N
13700	135	2	0	49513	\N
13700	2722	3	0	49514	\N
13540	137	3	0	49734	\N
13540	3633	4	0	49748	\N
13657	3844	68	0	50547	\N
13657	170	126	0	50555	\N
13657	3845	127	0	50556	\N
13744	170	20	0	50572	\N
13787	170	8	0	50573	\N
13787	3904	9	0	50577	\N
13744	3880	21	0	50580	\N
13639	181	16	0	50880	\N
13639	3833	17	0	50887	\N
13503	260	3	0	52546	\N
13597	260	3	0	52547	\N
13503	3399	4	0	52550	\N
13597	3399	4	0	52551	\N
13520	273	4	0	52956	\N
13520	3777	5	0	52965	\N
13638	324	2	0	54215	\N
13638	486	3	0	54224	\N
13494	353	3	0	54566	\N
13494	3766	4	0	54571	\N
13544	362	3	0	54855	\N
13544	3658	4	0	54856	\N
13558	597	7	0	55861	\N
13558	3789	8	0	55865	\N
13510	908	44	0	57630	\N
13510	3773	45	0	57634	\N
13571	908	33	0	57647	\N
13571	3797	34	0	57648	\N
13781	3900	59	0	58589	\N
13781	2578	126	0	58593	\N
13781	3901	127	0	58594	\N
13528	3780	5	0	58703	\N
13673	2636	3	0	58708	\N
13673	2837	4	0	58709	\N
13528	2636	7	0	58711	\N
13528	3207	8	0	58714	\N
13726	2782	4	0	59279	\N
13726	3872	5	0	59282	\N
13581	3625	4	0	59493	\N
13581	3802	5	0	59502	\N
13542	3628	3	0	59640	\N
13542	3785	4	0	59654	\N
13762	3893	5	0	1108	\N
13496	3768	5	0	2296	\N
13612	228	3	0	2984	\N
13716	228	9	0	2985	\N
13612	3186	4	0	2988	\N
13716	3865	10	0	2989	\N
13492	262	9	0	3780	\N
13492	3764	10	0	3788	\N
13563	365	10	0	4527	\N
13563	3791	11	0	4528	\N
13651	365	3	0	4540	\N
13651	3839	4	0	4541	\N
13784	391	6	0	10316	\N
13627	132	12	0	11212	\N
13627	3826	13	0	11215	\N
13678	300	3	0	12120	\N
13678	3747	4	0	12122	\N
13631	173	4	0	14646	\N
13631	3614	5	0	14647	\N
13692	173	4	0	14650	\N
13692	3857	5	0	14653	\N
13515	235	3	0	15671	\N
13515	3774	4	0	15675	\N
13705	235	2	0	15699	\N
13705	2757	3	0	15700	\N
13547	399	2	0	16343	\N
13529	3781	5	0	18502	\N
13526	142	0	0	18512	\N
13529	142	7	0	18514	\N
13529	3117	8	0	18515	\N
13777	142	0	0	18530	\N
13634	241	14	0	20402	\N
13634	3829	15	0	20410	\N
13489	1075	3	1	21822	\N
13756	73	8	0	22520	\N
13756	3888	9	0	22523	\N
13551	336	1	0	22752	\N
13551	356	2	0	22756	\N
13666	336	3	0	22762	\N
13666	3400	4	0	22763	\N
13751	82	7	0	23812	\N
13751	3885	8	0	23813	\N
13661	345	14	0	26295	\N
13617	3321	2	0	26510	\N
13617	86	5	0	26528	\N
13617	2890	6	0	26530	\N
13522	86	3	0	26648	\N
13522	3746	4	0	26649	\N
13508	42	3	0	27542	\N
13595	16	4	0	28508	\N
13595	3546	5	0	28512	\N
13745	3846	5	0	29406	\N
13745	3881	6	0	29409	\N
13713	96	9	0	29561	\N
13713	3862	10	0	29562	\N
13577	202	9	0	31068	\N
13577	3798	10	0	31069	\N
13662	360	17	0	31401	\N
13662	3850	18	0	31404	\N
13724	360	5	0	31420	\N
13724	3870	6	0	31421	\N
13607	3812	9	0	31745	\N
13680	1	2	0	33878	\N
13680	283	3	0	33880	\N
13712	2	4	0	35415	\N
13712	3510	5	0	35416	\N
13764	2	4	0	35448	\N
13764	3510	5	0	35449	\N
13513	10	6	0	37629	\N
13513	3599	7	0	37630	\N
13524	2568	5	0	37634	\N
13683	10	7	0	37687	\N
13683	3856	8	0	37689	\N
13708	3493	5	0	37694	\N
13732	10	4	0	37718	\N
13732	3493	5	0	37722	\N
13752	18	4	0	40003	\N
13752	2302	5	0	40006	\N
13489	3761	2	0	41029	\N
13489	3762	3	0	41316	\N
13578	40	4	0	42946	\N
13578	2714	5	0	42949	\N
13573	51	3	0	43528	\N
13573	3533	4	0	43531	\N
13755	71	4	0	44777	\N
13755	3887	5	0	44780	\N
13609	75	0	0	45845	\N
13679	75	3	0	45846	\N
13679	3855	4	0	45850	\N
13672	88	2	0	47124	\N
13672	2799	3	0	47125	\N
13549	113	5	0	48257	\N
13549	3786	6	0	48262	\N
13543	119	3	0	48563	\N
13582	119	4	0	48564	\N
13543	2860	4	0	48567	\N
13582	3518	5	0	48570	\N
13624	135	4	0	49478	\N
13624	3696	5	0	49479	\N
13556	147	7	0	50008	\N
13556	3788	8	0	50036	\N
13562	156	1	0	50216	\N
13562	157	2	0	50217	\N
13600	210	3	0	51822	\N
13668	210	1	0	51824	\N
13668	2926	2	0	51832	\N
13600	3539	4	0	51835	\N
13620	260	4	0	52548	\N
13620	3728	5	0	52552	\N
13796	285	5	0	53464	\N
13796	3912	6	0	53467	\N
13604	316	27	0	53927	\N
13604	3811	28	0	53928	\N
13660	353	13	0	54578	\N
13813	353	8	0	54580	\N
13660	3848	14	0	54589	\N
13682	451	2	0	55217	\N
13682	3317	3	0	55220	\N
13720	3868	5	0	55518	\N
13557	595	1	0	55655	\N
13557	596	2	0	55659	\N
13739	597	4	0	55878	\N
13739	3733	5	0	55879	\N
13579	852	7	0	57226	\N
13579	3799	8	0	57227	\N
13572	908	3	0	57643	\N
13572	3591	4	0	57645	\N
13710	2636	4	0	58718	\N
13710	3617	5	0	58722	\N
13684	2103	3	0	1232	\N
13810	3920	6	0	1242	\N
13606	367	4	0	3342	\N
13606	3679	5	0	3343	\N
13567	35	8	0	4376	\N
13567	3794	9	0	4381	\N
13534	189	1	0	4792	\N
13534	190	2	0	4793	\N
13636	132	14	0	11213	\N
13636	3831	15	0	11214	\N
13669	77	3	0	13077	\N
13669	1877	4	0	13082	\N
13545	58	3	0	13512	\N
13569	173	3	0	14638	\N
13569	3796	4	0	14639	\N
13559	192	3	0	15567	\N
13559	3790	4	0	15570	\N
13765	192	4	0	15574	\N
13765	3895	5	0	15575	\N
13704	235	15	0	15698	\N
13704	3861	16	0	15701	\N
13548	38	3	0	16342	\N
13548	3457	4	0	16344	\N
13734	212	4	0	17092	\N
13734	3732	5	0	17100	\N
13780	142	0	0	18533	\N
13763	60	4	0	19429	\N
13763	3894	5	0	19434	\N
13702	3273	4	0	20035	\N
13702	198	5	0	20054	\N
13691	64	2	0	20671	\N
13691	277	3	0	20673	\N
13794	64	1	0	20676	\N
13794	65	2	0	20678	\N
13760	164	3	0	21069	\N
13760	1807	4	0	21080	\N
13568	488	40	0	21484	\N
13576	73	3	0	22512	\N
13576	3040	4	0	22513	\N
13553	336	0	0	22753	\N
13665	336	0	0	22761	\N
13586	224	4	0	25485	\N
13586	3806	5	0	25489	\N
13633	94	2	0	26911	\N
13633	95	3	0	26912	\N
13532	3634	4	0	28511	\N
13693	16	4	0	28514	\N
13693	2575	5	0	28515	\N
13747	16	1	0	28516	\N
13623	320	4	0	29357	\N
13623	3824	5	0	29358	\N
13770	96	1	0	29571	\N
13770	97	2	0	29573	\N
13806	96	1	0	29585	\N
13806	97	2	0	29588	\N
13536	54	3	0	30092	\N
13536	3041	4	0	30093	\N
13803	202	4	0	31076	\N
13803	3673	5	0	31077	\N
13588	360	5	0	31392	\N
13588	3586	6	0	31394	\N
13741	3879	21	0	31429	\N
13785	360	5	0	31442	\N
13785	3870	6	0	31443	\N
13552	1	1	0	33862	\N
13552	53	2	0	33865	\N
13643	1	3	0	33877	\N
13643	3393	4	0	33881	\N
13696	1	2	0	33884	\N
13696	283	3	0	33886	\N
13801	1	10	0	33901	\N
13801	3915	11	0	33903	\N
13531	10	3	0	37639	\N
13564	10	3	0	37645	\N
13564	3173	4	0	37646	\N
13575	10	3	0	37657	\N
13598	10	3	0	37658	\N
13613	10	4	0	37659	\N
13575	3173	4	0	37660	\N
13598	3173	4	0	37661	\N
13613	3493	5	0	37662	\N
13615	10	4	0	37665	\N
13615	3493	5	0	37666	\N
13632	10	3	0	37669	\N
13632	3173	4	0	37670	\N
13646	3173	4	0	37688	\N
13768	10	8	0	37731	\N
13768	3889	9	0	37732	\N
13773	10	4	0	37739	\N
13773	3493	5	0	37742	\N
13748	14	7	0	39129	\N
13748	3882	8	0	39132	\N
13655	19	1	0	40001	\N
13655	18	4	0	40004	\N
13655	3817	5	0	40005	\N
13754	18	4	0	40007	\N
13754	2302	5	0	40009	\N
13707	645	3	0	41075	\N
13654	40	0	0	42960	\N
13769	40	8	0	42979	\N
13769	3718	9	0	42983	\N
13681	56	2	0	44146	\N
13733	56	4	0	44148	\N
13681	2795	3	0	44149	\N
13733	3127	5	0	44150	\N
13622	3823	1	0	45839	\N
13622	76	2	0	45847	\N
13822	75	7	0	45856	\N
13822	3928	8	0	45857	\N
13786	79	8	0	46911	\N
13786	3701	9	0	46917	\N
13593	88	4	0	47107	\N
13593	3809	5	0	47109	\N
13790	88	5	0	47134	\N
13790	3907	6	0	47142	\N
13629	102	0	0	47822	\N
13714	125	9	0	49225	\N
13774	125	0	0	49226	\N
13714	3863	10	0	49230	\N
13650	137	1	0	49736	\N
13687	137	2	0	49737	\N
13701	137	2	0	49738	\N
13831	137	6	0	49739	\N
13650	138	2	0	49743	\N
13687	2721	3	0	49745	\N
13701	2721	3	0	49746	\N
13831	3932	7	0	49751	\N
13738	147	4	0	50009	\N
13738	3877	5	0	50030	\N
13742	170	20	0	50571	\N
13742	3880	21	0	50579	\N
13667	210	3	0	51823	\N
13690	210	2	0	51825	\N
13690	1874	3	0	51834	\N
13667	3539	4	0	51836	\N
13767	268	4	0	52751	\N
13767	3897	5	0	52752	\N
13833	273	1	0	52958	\N
13833	410	2	0	52963	\N
13674	279	3	0	53232	\N
13674	3641	4	0	53235	\N
13783	285	6	0	53463	\N
13783	3903	7	0	53468	\N
13717	316	7	0	53935	\N
13717	3866	8	0	53936	\N
13635	324	14	0	54214	\N
13688	324	2	0	54216	\N
13688	2808	3	0	54222	\N
13635	3830	15	0	54228	\N
13814	353	2	0	54581	\N
13814	755	3	0	54585	\N
13663	353	17	0	54598	\N
13663	3851	18	0	54600	\N
13825	451	0	0	55218	\N
13835	451	3	0	55229	\N
13835	3934	4	0	55235	\N
13676	841	3	0	57062	\N
13676	3604	4	0	57063	\N
13753	841	4	0	57068	\N
13753	3886	5	0	57069	\N
13608	1470	8	0	58196	\N
13608	3813	9	0	58199	\N
13782	2578	4	0	58591	\N
13782	3902	5	0	58592	\N
13727	2782	1	0	59280	\N
13727	3873	2	0	59281	\N
13622	3822	1	0	59476	\N
13761	3892	2	0	1107	\N
13584	3804	6	0	2222	\N
13642	117	4	0	2227	\N
13642	3835	5	0	2228	\N
13804	110	5	0	2512	\N
13804	3916	6	0	2516	\N
13605	367	0	0	3341	\N
13591	391	3	0	10315	\N
13591	3660	4	0	10317	\N
13797	391	4	0	10323	\N
13812	391	8	0	10324	\N
13797	3913	5	0	10325	\N
13812	3922	9	0	10326	\N
13820	3927	8	0	10340	\N
13619	3818	4	0	11952	\N
13603	300	27	0	12119	\N
13603	3810	28	0	12124	\N
13792	123	5	0	12743	\N
13792	3908	6	0	12745	\N
13818	123	16	0	12759	\N
13818	3926	17	0	12766	\N
13671	77	2	0	13078	\N
13671	3853	3	0	13081	\N
13725	192	5	0	15573	\N
13725	3871	6	0	15576	\N
13775	142	0	0	18529	\N
13778	142	16	0	18531	\N
13778	3899	17	0	18534	\N
13795	64	4	0	20677	\N
13795	3911	5	0	20679	\N
13759	164	8	0	21068	\N
13759	3890	9	0	21081	\N
13772	73	4	0	22521	\N
13772	2284	5	0	22522	\N
13589	149	5	0	23060	\N
13589	3808	6	0	23064	\N
13601	411	1	0	25237	\N
13788	86	8	0	26523	\N
13788	3905	9	0	26532	\N
13789	244	8	0	27266	\N
13789	3906	9	0	27267	\N
13766	42	4	0	27548	\N
13766	3896	5	0	27552	\N
13602	16	4	0	28509	\N
13602	3546	5	0	28513	\N
13771	96	4	0	29572	\N
13771	3515	5	0	29574	\N
13807	96	7	0	29586	\N
13807	3918	8	0	29589	\N
13610	3814	10	0	30432	\N
13619	3819	4	0	33858	\N
13619	3820	5	0	33859	\N
13640	1	16	0	33872	\N
13640	3834	17	0	33873	\N
13698	1	2	0	33885	\N
13698	283	3	0	33887	\N
13706	1	4	0	33890	\N
13706	2814	5	0	33891	\N
13719	1	4	0	33894	\N
13719	3820	5	0	33895	\N
13800	2	5	0	35469	\N
13645	4	3	0	35913	\N
13645	3837	4	0	35916	\N
13659	10	14	0	37686	\N
13659	3847	15	0	37690	\N
13709	10	4	0	37697	\N
13722	10	4	0	37698	\N
13709	3493	5	0	37699	\N
13722	3493	5	0	37700	\N
13743	10	20	0	37719	\N
13746	10	4	0	37720	\N
13746	3493	5	0	37723	\N
13743	1619	21	0	37724	\N
13799	10	4	0	37741	\N
13799	3493	5	0	37743	\N
13776	3898	17	0	37744	\N
13628	18	12	0	39998	\N
13652	18	3	0	39999	\N
13652	3621	4	0	40000	\N
13628	3827	13	0	40002	\N
13816	41	1	0	42969	\N
13816	40	5	0	42981	\N
13816	128	6	0	42984	\N
13861	40	1	0	42988	\N
13861	41	2	0	42989	\N
13891	40	1	0	43001	\N
13891	41	2	0	43002	\N
13897	40	2	0	43006	\N
13897	66	3	0	43007	\N
13995	40	5	0	43020	\N
13995	3999	6	0	43023	\N
14006	40	4	0	43026	\N
14006	2221	5	0	43027	\N
13827	56	16	0	44155	\N
13827	3930	17	0	44156	\N
14051	71	5	0	44790	\N
14051	4033	6	0	44791	\N
13875	857	3	0	45868	\N
13875	75	14	0	45871	\N
13875	76	15	0	45872	\N
13905	75	4	0	45884	\N
13955	75	7	0	45885	\N
13905	3959	5	0	45887	\N
13955	2859	8	0	45888	\N
14045	88	11	0	47137	\N
14045	580	12	0	47143	\N
13830	135	23	0	49544	\N
13830	3931	24	0	49571	\N
13976	147	4	0	50011	\N
13976	3877	5	0	50032	\N
13925	210	4	0	51826	\N
13925	3536	5	0	51838	\N
13798	285	4	0	53465	\N
13798	3674	5	0	53466	\N
14056	285	4	0	53477	\N
14056	3674	5	0	53484	\N
13826	451	12	0	55219	\N
13826	3929	13	0	55223	\N
13837	451	126	0	55228	\N
13837	3935	127	0	55239	\N
13921	597	4	0	55893	\N
13921	3733	5	0	55895	\N
13910	841	4	0	57073	\N
13910	3886	5	0	57076	\N
13950	2636	4	0	58719	\N
13950	3617	5	0	58723	\N
13973	433	3	0	313	\N
14072	4043	5	0	333	\N
13915	424	3	0	835	\N
13915	3973	4	0	837	\N
14071	424	13	0	867	\N
14071	4042	14	0	871	\N
13932	266	11	0	1249	\N
13932	3977	12	0	1250	\N
14011	266	5	0	1257	\N
14011	4007	6	0	1258	\N
14019	1997	0	0	1686	\N
13805	110	6	0	2513	\N
13805	3917	7	0	2517	\N
13832	905	22	0	2526	\N
13884	367	13	0	3356	\N
13884	3958	14	0	3357	\N
13887	367	4	0	3370	\N
13887	3679	5	0	3374	\N
13927	35	1	0	4384	\N
13927	340	2	0	4386	\N
13983	189	4	0	4812	\N
13983	3992	5	0	4813	\N
13971	132	3	0	11243	\N
13971	814	4	0	11248	\N
13809	528	1	0	12480	\N
13908	77	8	0	13079	\N
13908	3972	9	0	13084	\N
14023	77	3	0	13095	\N
14023	2161	4	0	13096	\N
13894	258	14	0	14422	\N
13894	3962	15	0	14427	\N
13852	92	7	0	14991	\N
13852	3943	8	0	14993	\N
13836	44	3	0	16038	\N
13836	3631	4	0	16040	\N
13993	212	1	0	17095	\N
13993	213	2	0	17096	\N
14043	566	3	0	17123	\N
13938	326	1	0	17372	\N
13938	327	2	0	17373	\N
13981	30	16	0	18094	\N
13981	3990	17	0	18097	\N
13793	3909	4	0	22344	\N
13793	3910	5	0	22345	\N
14065	149	0	0	23067	\N
14068	69	4	0	24720	\N
14068	4041	5	0	24727	\N
13842	1154	2	0	24946	\N
13842	1153	9	0	24954	\N
13966	50	2	0	25021	\N
14038	49	2	0	25030	\N
14038	328	3	0	25035	\N
14048	90	11	0	26038	\N
14048	877	12	0	26041	\N
13811	244	5	0	27273	\N
13811	3921	6	0	27281	\N
14019	4012	0	0	27560	\N
14003	16	1	0	28522	\N
14003	17	2	0	28523	\N
14028	16	1	0	28524	\N
14028	17	2	0	28525	\N
13964	3985	14	0	30111	\N
13878	20	8	0	30437	\N
13878	3955	9	0	30442	\N
13941	230	7	0	32116	\N
13941	3978	8	0	32118	\N
14027	230	5	0	32134	\N
14027	3389	6	0	32135	\N
13808	322	7	0	32409	\N
13808	3919	8	0	32410	\N
13817	322	16	0	32416	\N
13817	3925	17	0	32417	\N
13802	1	4	0	33906	\N
13802	3820	5	0	33908	\N
13856	3946	9	0	33909	\N
13866	1	7	0	33918	\N
13866	3951	8	0	33919	\N
13946	1	4	0	33932	\N
14014	1	5	0	33935	\N
13946	3820	5	0	33937	\N
14014	1162	6	0	33939	\N
13849	2	1	0	35470	\N
13849	26	2	0	35472	\N
13880	6	2	0	36289	\N
13880	179	3	0	36292	\N
13819	11	2	0	37749	\N
13824	10	3	0	37751	\N
13828	10	1	0	37752	\N
13828	11	2	0	37753	\N
13824	347	4	0	37754	\N
13847	10	13	0	37757	\N
13847	2568	14	0	37758	\N
13978	10	12	0	37775	\N
13978	3730	13	0	37780	\N
14040	10	8	0	37789	\N
14040	3889	9	0	37794	\N
13899	14	31	0	39130	\N
13839	18	8	0	40008	\N
13839	3937	9	0	40010	\N
13846	18	16	0	40011	\N
13846	3941	17	0	40020	\N
13863	41	2	0	42995	\N
13957	40	1	0	43013	\N
13957	41	2	0	43015	\N
13999	40	1	0	43021	\N
13999	41	2	0	43022	\N
13855	75	10	0	45862	\N
13855	3945	11	0	45863	\N
13873	75	7	0	45866	\N
13873	2859	8	0	45867	\N
13888	75	4	0	45883	\N
13888	3959	5	0	45886	\N
13851	79	7	0	46912	\N
13851	3682	8	0	46916	\N
13943	88	4	0	47136	\N
14047	88	10	0	47138	\N
13943	3809	5	0	47140	\N
14047	154	11	0	47141	\N
13945	100	4	0	47554	\N
13945	3776	5	0	47557	\N
13901	102	31	0	47830	\N
13901	3968	32	0	47840	\N
13937	113	4	0	48258	\N
13937	3677	5	0	48261	\N
13924	147	4	0	50010	\N
13924	3877	5	0	50031	\N
14008	186	5	0	51259	\N
14008	4005	6	0	51262	\N
13815	253	1	0	52118	\N
13815	242	5	0	52126	\N
13815	3924	6	0	52127	\N
13864	316	10	0	53943	\N
13864	3949	11	0	53944	\N
13813	3923	9	0	54586	\N
13914	362	1	0	54866	\N
13914	395	2	0	54868	\N
13874	1456	3	0	55069	\N
13874	435	5	0	55077	\N
13874	1580	6	0	55078	\N
13975	597	4	0	55894	\N
13975	3733	5	0	55896	\N
13912	841	3	0	57074	\N
13912	3604	4	0	57075	\N
14022	4015	10	0	57864	\N
14022	4021	11	0	57960	\N
14022	4022	11	1	58577	\N
14022	4016	10	0	58596	\N
13963	2636	13	0	58741	\N
13963	3984	14	0	58742	\N
13968	2636	1	0	58749	\N
13968	3980	2	0	58750	\N
13985	424	6	0	836	\N
14000	424	5	0	853	\N
14000	4000	6	0	854	\N
14070	424	4	0	856	\N
14070	3188	5	0	859	\N
13862	117	7	0	2232	\N
13862	3948	8	0	2236	\N
14053	1636	2	0	3064	\N
14053	1637	3	0	3068	\N
13877	35	0	0	4378	\N
13879	35	8	0	4382	\N
13879	3956	9	0	4383	\N
13871	189	2	0	4810	\N
14035	391	1	0	10345	\N
14035	392	2	0	10346	\N
13823	132	7	0	11229	\N
13823	3709	8	0	11230	\N
14002	132	2	0	11244	\N
14002	2756	3	0	11246	\N
13909	77	2	0	13080	\N
13909	216	3	0	13083	\N
14034	77	3	0	13108	\N
14034	1877	4	0	13115	\N
14022	4019	12	0	13998	\N
13850	92	1	0	14990	\N
14013	38	2	0	16356	\N
14013	4009	3	0	16357	\N
13992	212	4	0	17094	\N
13992	3732	5	0	17101	\N
14042	212	8	0	17121	\N
14042	4031	9	0	17124	\N
13865	142	4	0	18542	\N
13865	3950	5	0	18543	\N
14060	142	8	0	18548	\N
14060	4039	9	0	18554	\N
14022	4020	12	1	18782	\N
13821	198	7	0	20062	\N
13843	164	16	0	21070	\N
13845	164	5	0	21071	\N
14029	164	1	0	21072	\N
14029	165	2	0	21077	\N
13845	3940	6	0	21082	\N
13843	3939	17	0	21083	\N
13954	145	7	0	22038	\N
13954	3981	8	0	22040	\N
14055	73	4	0	22533	\N
14055	2284	5	0	22536	\N
13857	336	4	0	22769	\N
13857	3947	5	0	22770	\N
13960	3982	12	0	23523	\N
14067	69	1	0	24719	\N
14067	70	2	0	24725	\N
13841	1154	2	0	24945	\N
13841	1153	9	0	24953	\N
13841	3938	10	0	24956	\N
13842	3938	10	0	24957	\N
13907	411	8	0	25245	\N
14074	411	0	0	25246	\N
13907	3971	9	0	25247	\N
13886	42	4	0	27549	\N
13886	3896	5	0	27553	\N
14044	42	8	0	27562	\N
14044	4032	9	0	27569	\N
14026	4025	11	0	27570	\N
14076	16	0	0	28526	\N
13890	320	7	0	29368	\N
13890	3960	8	0	29371	\N
14018	449	17	0	29826	\N
14018	4011	18	0	29829	\N
13947	360	1	0	31456	\N
13947	479	2	0	31458	\N
13990	3997	4	0	31474	\N
13990	3513	5	0	31475	\N
13869	230	8	0	32101	\N
13869	3952	9	0	32103	\N
13893	230	14	0	32114	\N
13893	3961	15	0	32119	\N
13988	230	4	0	32124	\N
13988	3954	5	0	32125	\N
13858	1	4	0	33912	\N
13858	3820	5	0	33913	\N
13898	1	31	0	33923	\N
13898	3965	32	0	33927	\N
13980	1	16	0	33934	\N
13980	3330	17	0	33941	\N
13834	3933	4	0	34816	\N
13918	10	0	0	37767	\N
13920	10	11	0	37768	\N
13920	3974	12	0	37769	\N
13860	18	4	0	40012	\N
13896	18	14	0	40013	\N
13997	18	9	0	40014	\N
14016	18	5	0	40015	\N
13860	2302	5	0	40016	\N
14016	4010	6	0	40017	\N
13997	2301	10	0	40018	\N
13896	3964	15	0	40019	\N
13844	40	4	0	42980	\N
13844	564	5	0	42985	\N
13952	40	1	0	43012	\N
13952	41	2	0	43014	\N
14031	40	2	0	43039	\N
14033	40	1	0	43040	\N
14033	41	2	0	43043	\N
14031	66	3	0	43044	\N
13923	51	4	0	43529	\N
13923	3975	5	0	43532	\N
13885	75	3	0	45877	\N
13885	3855	4	0	45878	\N
14039	75	8	0	45893	\N
14039	4029	9	0	45894	\N
14052	75	5	0	45899	\N
14064	75	4	0	45900	\N
14064	3959	5	0	45901	\N
14052	4034	6	0	45902	\N
13853	79	1	0	46913	\N
13853	81	2	0	46915	\N
14062	102	1	0	47832	\N
14062	103	2	0	47835	\N
13902	135	31	0	49545	\N
13902	3969	32	0	49572	\N
14118	181	4	0	50881	\N
14118	4058	5	0	50885	\N
13926	210	1	0	51827	\N
14141	210	6	0	51828	\N
13926	211	2	0	51833	\N
14141	3721	7	0	51841	\N
14149	279	3	0	53233	\N
14149	3641	4	0	53236	\N
13895	285	14	0	53476	\N
13895	3963	15	0	53487	\N
13882	362	23	0	54859	\N
13883	362	3	0	54860	\N
13883	3372	4	0	54861	\N
13916	3658	3	0	54862	\N
13882	3957	24	0	54863	\N
13916	362	5	0	54869	\N
13916	2946	6	0	54870	\N
14153	793	8	0	56665	\N
14153	4076	9	0	56668	\N
14087	852	9	0	57231	\N
14087	4046	10	0	57233	\N
14021	4015	10	0	57863	\N
14021	4017	11	0	57961	\N
14021	4018	11	1	58576	\N
14021	4016	10	0	58595	\N
13967	2636	4	0	58748	\N
13967	3617	5	0	58751	\N
14162	2636	1	0	58759	\N
14162	3207	2	0	58760	\N
13972	3987	9	0	314	\N
14025	4024	11	0	1109	\N
14005	117	13	0	2233	\N
14005	4003	14	0	2237	\N
14109	110	5	0	2532	\N
14109	3916	6	0	2540	\N
13881	35	0	0	4379	\N
13929	35	3	0	4385	\N
13929	3563	4	0	4387	\N
14092	365	4	0	4559	\N
14092	4049	5	0	4563	\N
13870	189	8	0	4809	\N
13982	189	11	0	4811	\N
13982	3991	12	0	4816	\N
13859	391	4	0	10336	\N
13942	391	4	0	10337	\N
13859	3913	5	0	10338	\N
13942	3913	5	0	10339	\N
13936	132	1	0	11242	\N
13936	455	2	0	11245	\N
14037	77	1	0	13109	\N
14146	77	3	0	13110	\N
14037	78	2	0	13114	\N
14146	1877	4	0	13116	\N
14021	4019	12	0	13997	\N
13949	92	4	0	15007	\N
13949	3979	5	0	15008	\N
13838	3936	21	0	16041	\N
13979	44	4	0	16053	\N
13979	3989	5	0	16054	\N
14145	326	9	0	17385	\N
14145	4073	10	0	17394	\N
13848	30	16	0	18092	\N
13848	3942	17	0	18096	\N
14021	4020	12	1	18781	\N
14115	64	15	0	20687	\N
14115	4057	16	0	20688	\N
13934	3947	5	0	22784	\N
14010	149	6	0	23061	\N
14010	4006	7	0	23062	\N
14066	149	4	0	23068	\N
14066	4040	5	0	23069	\N
14123	264	4	0	23543	\N
14123	3684	5	0	23548	\N
13840	1154	2	0	24944	\N
13840	1153	9	0	24952	\N
13840	3938	10	0	24955	\N
13965	49	4	0	25018	\N
13965	3751	5	0	25023	\N
13994	3998	9	0	25027	\N
13854	224	10	0	25486	\N
13854	3944	11	0	25491	\N
13944	90	4	0	26029	\N
13944	3731	5	0	26030	\N
14100	86	4	0	26525	\N
14100	4052	5	0	26531	\N
13889	42	1	0	27550	\N
13889	43	2	0	27551	\N
14050	42	11	0	27563	\N
14050	439	12	0	27571	\N
13892	16	1	0	28517	\N
14059	96	8	0	29587	\N
14059	4038	9	0	29590	\N
13931	449	0	0	29818	\N
14103	449	5	0	29839	\N
14103	4055	6	0	29841	\N
13987	20	4	0	30438	\N
13987	3995	5	0	30441	\N
13868	231	3	0	32102	\N
13872	230	4	0	32109	\N
13872	3954	5	0	32110	\N
13940	230	4	0	32115	\N
13940	3954	5	0	32117	\N
13904	1	4	0	33924	\N
13904	3820	5	0	33925	\N
13867	3946	9	0	33926	\N
14097	1	9	0	33944	\N
14097	4050	10	0	33945	\N
14165	1	3	0	33961	\N
14165	3393	4	0	33962	\N
13970	431	12	0	34815	\N
13970	3986	13	0	34818	\N
13913	2	1	0	35471	\N
13913	26	2	0	35473	\N
14078	2	0	0	35492	\N
14082	2	0	0	35496	\N
13876	10	8	0	37761	\N
13906	10	4	0	37762	\N
13906	3493	5	0	37763	\N
13876	3889	9	0	37764	\N
13959	10	11	0	37773	\N
13959	3974	12	0	37778	\N
14104	10	4	0	37811	\N
14104	3493	5	0	37812	\N
13900	14	17	0	39131	\N
14009	40	2	0	43030	\N
14009	282	3	0	43031	\N
14096	75	7	0	45905	\N
14096	3928	8	0	45908	\N
13961	79	0	0	46914	\N
14069	79	4	0	46931	\N
14069	3678	5	0	46932	\N
14131	4063	7	0	46933	\N
14131	79	12	0	46951	\N
14131	4064	13	0	46953	\N
14061	102	4	0	47831	\N
14061	3572	5	0	47837	\N
14112	125	4	0	49235	\N
14112	4056	5	0	49238	\N
14120	135	1	0	49546	\N
14120	136	2	0	49559	\N
13903	137	17	0	49767	\N
14119	137	4	0	49768	\N
13903	3970	18	0	49770	\N
13939	242	0	0	52132	\N
14107	260	4	0	52549	\N
14107	3728	5	0	52553	\N
13911	273	4	0	52959	\N
14090	273	4	0	52960	\N
14122	273	4	0	52961	\N
13911	3777	5	0	52966	\N
14090	3777	5	0	52967	\N
14122	3777	5	0	52968	\N
14057	285	3	0	53478	\N
14057	4036	4	0	53483	\N
14017	316	1	0	53955	\N
14017	317	2	0	53956	\N
13922	595	4	0	55657	\N
13922	3878	5	0	55662	\N
13977	595	4	0	55687	\N
13977	3878	5	0	55691	\N
14004	1109	14	0	56144	\N
14004	4002	15	0	56145	\N
14134	4066	7	0	56146	\N
14134	1109	12	0	56161	\N
14134	4067	13	0	56163	\N
14106	793	4	0	56664	\N
14106	3618	5	0	56667	\N
14084	852	6	0	57230	\N
14084	4044	7	0	57232	\N
14024	2435	11	0	57964	\N
13951	2636	1	0	58720	\N
13951	3980	2	0	58721	\N
13962	2636	29	0	58740	\N
13962	3983	30	0	58743	\N
14030	4026	7	0	323	\N
13917	424	5	0	838	\N
13917	3033	6	0	839	\N
13984	424	3	0	845	\N
14001	424	16	0	846	\N
13984	3993	4	0	847	\N
14001	4001	17	0	848	\N
14024	4023	11	1	1102	\N
14024	3891	10	0	1103	\N
14110	110	6	0	2533	\N
14110	3917	7	0	2541	\N
13958	228	1	0	2991	\N
13958	229	2	0	2993	\N
14108	3679	5	0	3375	\N
14093	365	1	0	4560	\N
14093	366	2	0	4562	\N
14101	4053	0	0	4727	\N
13974	373	8	0	5352	\N
13974	3988	9	0	5355	\N
14127	108	3	0	11732	\N
14127	3113	4	0	11737	\N
14020	77	10	0	13094	\N
14148	77	1	0	13111	\N
14148	2934	2	0	13113	\N
14140	4069	83	0	14055	\N
14140	4070	127	0	14072	\N
14054	44	8	0	16071	\N
14054	4035	9	0	16072	\N
14012	38	5	0	16355	\N
14012	4008	6	0	16358	\N
13935	326	4	0	17371	\N
13935	3519	5	0	17374	\N
14036	167	3	0	17668	\N
14091	167	4	0	17669	\N
14036	4028	4	0	17673	\N
14091	4048	5	0	17674	\N
13928	30	3	0	18093	\N
14007	30	13	0	18098	\N
14007	4004	14	0	18099	\N
14041	30	8	0	18100	\N
14041	4030	9	0	18101	\N
14075	290	0	0	19016	\N
14094	198	2	0	20063	\N
14095	198	7	0	20064	\N
14094	513	3	0	20065	\N
14095	3601	8	0	20067	\N
14114	64	0	0	20672	\N
14032	164	6	0	21073	\N
14032	4027	7	0	21079	\N
14058	4037	4	0	22535	\N
13933	336	0	0	22775	\N
14102	264	6	0	23532	\N
14102	4054	7	0	23533	\N
14046	214	11	0	24299	\N
14049	214	2	0	24300	\N
14049	1110	3	0	24305	\N
14046	330	12	0	24306	\N
14099	86	1	0	26524	\N
14099	87	2	0	26526	\N
13919	94	0	0	26913	\N
13953	16	3	0	28520	\N
14152	16	1	0	28528	\N
14152	17	2	0	28529	\N
13930	320	6	0	29369	\N
13930	3976	7	0	29370	\N
13948	360	4	0	31457	\N
13948	3513	5	0	31459	\N
13991	360	4	0	31476	\N
13991	3513	5	0	31480	\N
13956	1	4	0	33933	\N
14083	1	6	0	33936	\N
13956	3820	5	0	33938	\N
14083	2723	7	0	33940	\N
14117	3820	5	0	33957	\N
14080	2	0	0	35494	\N
13989	3705	7	0	37770	\N
13969	10	12	0	37774	\N
13989	10	9	0	37776	\N
13989	1416	10	0	37777	\N
13969	3730	13	0	37779	\N
13996	10	9	0	37783	\N
13996	2300	10	0	37784	\N
13998	10	4	0	37787	\N
14015	10	5	0	37788	\N
14073	10	4	0	37790	\N
14073	3493	5	0	37792	\N
14015	3592	6	0	37793	\N
14077	10	8	0	37797	\N
14077	3889	9	0	37798	\N
14086	10	9	0	37809	\N
14086	3578	10	0	37814	\N
14137	10	15	0	37825	\N
14137	3734	16	0	37826	\N
13900	3967	18	0	39133	\N
14088	18	9	0	40021	\N
14088	4047	10	0	40026	\N
13986	27	4	0	41089	\N
14188	2796	4	0	43032	\N
14222	40	2	0	43041	\N
14222	3034	3	0	43042	\N
14188	40	7	0	43045	\N
14188	3034	8	0	43046	\N
14225	40	10	0	43049	\N
14225	4104	11	0	43051	\N
14133	4063	7	0	46934	\N
14133	79	12	0	46952	\N
14133	4064	13	0	46954	\N
14295	2896	1	0	47144	\N
14295	88	4	0	47153	\N
14295	3010	5	0	47154	\N
14119	3697	5	0	49769	\N
14319	147	4	0	50013	\N
14319	3877	5	0	50033	\N
14313	170	3	0	50574	\N
14313	4148	4	0	50576	\N
14290	181	7	0	50882	\N
14290	4137	8	0	50886	\N
14273	210	8	0	51829	\N
14273	4124	9	0	51842	\N
14252	353	8	0	54582	\N
14252	3923	9	0	54587	\N
14283	362	14	0	54867	\N
14283	4133	15	0	54871	\N
14343	362	7	0	54882	\N
14343	4154	8	0	54887	\N
14135	4066	7	0	56147	\N
14135	1109	12	0	56162	\N
14135	4067	13	0	56164	\N
14105	793	1	0	56663	\N
14105	1150	2	0	56666	\N
14171	841	4	0	57085	\N
14171	3886	5	0	57086	\N
14357	852	6	0	57246	\N
14360	852	4	0	57247	\N
14360	4162	5	0	57254	\N
14357	4160	7	0	57255	\N
14163	908	7	0	57644	\N
14163	4078	8	0	57646	\N
14352	2578	4	0	58597	\N
14352	3902	5	0	58598	\N
14130	4062	7	0	59283	\N
14130	2782	8	0	59290	\N
14190	4089	5	0	59807	\N
14116	4043	5	0	334	\N
14215	4100	5	0	1265	\N
14347	117	4	0	2234	\N
14347	3835	5	0	2235	\N
14174	367	8	0	3372	\N
14174	4083	9	0	3377	\N
14085	3090	9	0	4029	\N
14085	4045	10	0	4030	\N
14089	391	1	0	10355	\N
14089	392	2	0	10356	\N
14126	391	4	0	10361	\N
14126	3913	5	0	10362	\N
14241	391	9	0	10377	\N
14334	391	4	0	10387	\N
14334	3913	5	0	10389	\N
14125	108	4	0	11731	\N
14370	108	3	0	11734	\N
14125	4060	5	0	11740	\N
14266	300	12	0	12121	\N
14266	4121	13	0	12123	\N
14139	402	6	0	14066	\N
14158	402	0	0	14069	\N
14139	4068	7	0	14070	\N
14154	402	3	0	14094	\N
14154	4077	4	0	14095	\N
14113	235	1	0	15707	\N
14113	236	2	0	15708	\N
14111	3615	5	0	15709	\N
14180	235	6	0	15714	\N
14180	3622	7	0	15717	\N
14263	4119	109	0	16073	\N
14263	44	126	0	16088	\N
14263	4120	127	0	16089	\N
14239	212	7	0	17160	\N
14239	4105	8	0	17168	\N
14142	326	6	0	17383	\N
14144	326	6	0	17384	\N
14326	326	3	0	17388	\N
14326	3339	4	0	17389	\N
14259	3519	5	0	17390	\N
14142	3805	7	0	17392	\N
14144	3805	7	0	17393	\N
14308	167	7	0	17670	\N
14308	4147	8	0	17675	\N
14292	4125	0	0	18821	\N
14345	290	8	0	19017	\N
14345	4155	9	0	19019	\N
14143	4071	6	0	19160	\N
14143	4072	7	0	19163	\N
14121	4059	5	0	19742	\N
14310	64	4	0	20698	\N
14310	3911	5	0	20701	\N
14337	145	4	0	22043	\N
14337	3867	5	0	22044	\N
14329	73	3	0	22542	\N
14329	3040	4	0	22545	\N
14136	49	3	0	25031	\N
14138	49	3	0	25032	\N
14136	3646	4	0	25033	\N
14138	3646	4	0	25034	\N
14324	224	4	0	25500	\N
14147	90	3	0	26039	\N
14147	4074	4	0	26040	\N
14254	90	8	0	26049	\N
14254	4112	9	0	26052	\N
14128	16	3	0	28527	\N
14128	3634	4	0	28530	\N
14281	16	8	0	28541	\N
14281	4130	9	0	28547	\N
14168	202	6	0	31082	\N
14168	4079	7	0	31083	\N
14197	360	1	0	31477	\N
14197	479	2	0	31479	\N
14256	322	11	0	32427	\N
14256	3071	12	0	32428	\N
14132	3330	7	0	33958	\N
14132	1	12	0	33963	\N
14132	4065	13	0	33964	\N
14200	1	8	0	33971	\N
14200	3946	9	0	33972	\N
14296	1	2	0	33997	\N
14296	2950	3	0	33998	\N
14350	1	7	0	34021	\N
14350	4136	8	0	34022	\N
14079	2	0	0	35493	\N
14305	2858	8	0	35500	\N
14098	10	9	0	37810	\N
14098	4051	10	0	37813	\N
14129	10	34	0	37817	\N
14129	4061	35	0	37820	\N
14203	10	2	0	37833	\N
14203	29	3	0	37834	\N
14235	10	4	0	37865	\N
14235	3493	5	0	37868	\N
14286	10	4	0	37871	\N
14286	3493	5	0	37872	\N
14318	10	3	0	37888	\N
14340	10	4	0	37896	\N
14340	3493	5	0	37898	\N
14249	18	4	0	40027	\N
14249	2302	5	0	40028	\N
14245	51	3	0	43536	\N
14245	3533	4	0	43537	\N
14250	75	3	0	45906	\N
14250	3855	4	0	45907	\N
14270	75	4	0	45916	\N
14270	3959	5	0	45919	\N
14272	79	8	0	46961	\N
14272	3701	9	0	46962	\N
14399	79	3	0	46971	\N
14399	3652	4	0	46972	\N
14277	88	12	0	47152	\N
14277	4127	13	0	47157	\N
14167	100	3	0	47565	\N
14167	3836	4	0	47566	\N
14214	121	4	0	48919	\N
14214	4099	5	0	48922	\N
14230	135	4	0	49547	\N
14230	3696	5	0	49565	\N
14368	137	3	0	49782	\N
14368	3633	4	0	49786	\N
14415	181	10	0	50896	\N
14415	4199	11	0	50897	\N
14302	268	12	0	52756	\N
14323	268	4	0	52757	\N
14323	3897	5	0	52760	\N
14302	4141	13	0	52762	\N
14342	285	7	0	53479	\N
14342	4153	8	0	53486	\N
14317	597	3	0	55908	\N
14317	3656	4	0	55909	\N
14161	2636	3	0	58758	\N
14161	2837	4	0	58761	\N
14234	3188	5	0	860	\N
14363	4166	5	0	1859	\N
14262	1636	4	0	3065	\N
14262	4118	5	0	3066	\N
14349	367	3	0	3387	\N
14349	3683	4	0	3388	\N
14204	262	8	0	3781	\N
14204	4093	9	0	3786	\N
14376	4173	116	0	4818	\N
14376	189	126	0	4831	\N
14376	4174	127	0	4832	\N
14176	373	8	0	5353	\N
14176	3988	9	0	5356	\N
14378	4179	5	0	5403	\N
14413	4172	6	0	8153	\N
14413	4197	7	0	8154	\N
14151	391	3	0	10375	\N
14151	3660	4	0	10378	\N
14285	391	4	0	10386	\N
14285	3913	5	0	10388	\N
14339	391	8	0	10394	\N
14339	3922	9	0	10395	\N
14268	108	12	0	11733	\N
14268	4123	13	0	11741	\N
14193	123	4	0	12760	\N
14213	1132	4	0	13098	\N
14212	77	4	0	13112	\N
14212	3619	5	0	13117	\N
14213	77	15	0	13118	\N
14213	4096	16	1	13158	\N
14191	233	4	0	13755	\N
14191	3775	5	0	13760	\N
14155	402	0	0	14067	\N
14177	235	0	0	15674	\N
14238	212	1	0	17159	\N
14408	212	2	0	17161	\N
14408	4193	3	0	17164	\N
14227	30	4	0	18104	\N
14227	4095	5	0	18105	\N
14403	177	4	0	18334	\N
14403	3538	5	0	18335	\N
14172	313	4	0	18732	\N
14172	4081	5	0	18736	\N
14405	290	2	0	19026	\N
14405	3176	3	0	19028	\N
14164	60	3	0	19430	\N
14164	3585	4	0	19433	\N
14173	198	5	0	20079	\N
14173	4082	6	0	20080	\N
14359	4161	5	0	20091	\N
14166	67	3	0	22132	\N
14166	3749	4	0	22134	\N
14240	149	6	0	23073	\N
14240	4106	7	0	23074	\N
14181	140	2	0	23993	\N
14183	140	6	0	23994	\N
14280	140	8	0	23996	\N
14181	487	3	0	23997	\N
14183	4086	7	0	23999	\N
14280	4129	9	0	24000	\N
14179	69	6	0	24722	\N
14207	224	4	0	25487	\N
14207	3806	5	0	25490	\N
14194	86	4	0	26552	\N
14194	4052	5	0	26554	\N
14220	94	0	0	26914	\N
14150	244	3	0	27274	\N
14150	4075	4	0	27279	\N
14169	16	1	0	28531	\N
14169	17	2	0	28532	\N
14184	16	2	0	28534	\N
14184	155	3	0	28537	\N
14396	16	0	0	28542	\N
14199	3041	4	0	30109	\N
14198	360	4	0	31478	\N
14198	3513	5	0	31481	\N
14383	230	3	0	32146	\N
14383	4181	4	0	32147	\N
14159	322	3	0	32425	\N
14159	1105	4	0	32426	\N
14389	322	14	0	32447	\N
14389	4188	15	0	32448	\N
14189	1	4	0	33967	\N
14189	3820	5	0	33968	\N
14208	1	4	0	33975	\N
14289	1	7	0	33996	\N
14289	4136	8	0	34000	\N
14299	1	8	0	34005	\N
14299	3946	9	0	34006	\N
14312	1	3	0	34010	\N
14312	3393	4	0	34012	\N
14202	431	6	0	34819	\N
14202	4092	7	0	34820	\N
14260	4	4	0	35914	\N
14260	4117	5	0	35917	\N
14187	10	1	0	37818	\N
14187	11	2	0	37819	\N
14210	3493	5	0	37848	\N
14217	10	4	0	37853	\N
14217	3493	5	0	37855	\N
14232	10	4	0	37859	\N
14232	3493	5	0	37860	\N
14294	11	1	0	37873	\N
14294	10	5	0	37876	\N
14294	2917	6	0	37877	\N
14331	10	4	0	37889	\N
14331	3493	5	0	37891	\N
14157	18	3	0	40022	\N
14160	18	3	0	40023	\N
14160	3621	4	0	40025	\N
14307	23	7	0	40728	\N
14307	4146	8	0	40729	\N
14253	27	8	0	41112	\N
14253	4111	9	0	41115	\N
14375	40	0	0	43050	\N
14170	51	10	0	43530	\N
14170	4080	11	0	43533	\N
14219	57	1	0	44157	\N
14219	56	5	0	44159	\N
14219	4102	6	0	44160	\N
14246	56	3	0	44161	\N
14246	4109	4	0	44163	\N
14341	56	4	0	44165	\N
14341	3127	5	0	44166	\N
14265	75	4	0	45915	\N
14291	75	7	0	45917	\N
14265	3959	5	0	45918	\N
14291	2859	8	0	45920	\N
14216	79	4	0	46949	\N
14216	3678	5	0	46950	\N
14366	125	3	0	49236	\N
14366	4170	4	0	49237	\N
14369	135	3	0	49548	\N
14369	3630	4	0	49561	\N
14274	210	2	0	51830	\N
14274	458	3	0	51840	\N
14206	316	9	0	53962	\N
14206	4094	10	0	53963	\N
14332	435	4	0	55070	\N
14332	3531	5	0	55076	\N
14315	595	3	0	55688	\N
14320	595	4	0	55689	\N
14315	3654	4	0	55690	\N
14320	3878	5	0	55692	\N
14306	1109	7	0	56168	\N
14306	4145	8	0	56169	\N
14377	4177	68	1	58472	\N
14221	2519	6	0	58574	\N
14213	4097	17	0	59209	\N
14182	4085	7	0	174	\N
14278	4128	11	0	1266	\N
14395	741	3	0	1368	\N
14395	4190	4	0	1371	\N
14361	4163	5	1	1845	\N
14361	461	4	0	1856	\N
14348	4156	74	0	2229	\N
14348	117	126	0	2238	\N
14348	4157	127	0	2239	\N
14364	4167	74	0	2240	\N
14364	117	126	0	2243	\N
14364	4168	127	0	2244	\N
14300	2583	6	1	2344	\N
14288	110	6	0	2535	\N
14287	4134	5	0	2537	\N
14288	4135	7	0	2539	\N
14303	1636	12	0	3073	\N
14303	4142	13	0	3074	\N
14175	367	2	0	3373	\N
14175	651	3	0	3376	\N
14346	35	8	0	4390	\N
14346	3956	9	0	4393	\N
14377	4176	68	0	4731	\N
14377	4175	38	0	4817	\N
14377	189	67	0	4830	\N
14300	1151	5	0	5192	\N
14373	4172	0	0	8148	\N
14397	4172	2	0	8149	\N
14397	4191	3	0	8151	\N
14209	391	4	0	10376	\N
14209	3913	5	0	10379	\N
14411	455	1	0	11247	\N
14411	4195	2	0	11256	\N
14205	528	8	0	12481	\N
14205	3702	9	0	12485	\N
14195	123	1	0	12761	\N
14228	123	4	0	12762	\N
14228	4090	5	0	12765	\N
14213	59	16	0	13471	\N
14361	59	5	0	13701	\N
14407	173	2	0	14651	\N
14407	3179	3	0	14652	\N
14185	235	2	0	15715	\N
14185	1061	3	0	15716	\N
14417	235	3	0	15730	\N
14417	3343	4	0	15733	\N
14186	4087	8	0	16359	\N
14186	38	9	0	16366	\N
14211	30	4	0	18102	\N
14311	30	4	0	18106	\N
14311	4095	5	0	18107	\N
14379	142	11	0	18549	\N
14379	656	12	0	18555	\N
14351	927	7	0	19165	\N
14351	4158	8	0	19177	\N
14261	62	4	0	19765	\N
14261	4059	5	0	19768	\N
14338	164	4	0	21074	\N
14338	4152	5	0	21078	\N
14213	4098	17	1	21764	\N
14335	67	8	0	22133	\N
14330	73	2	0	22543	\N
14330	2766	3	0	22544	\N
14344	73	7	0	22553	\N
14344	3675	8	0	22554	\N
14237	149	7	0	23072	\N
14237	3600	8	0	23075	\N
14390	149	3	0	23078	\N
14390	4189	4	0	23079	\N
14314	140	3	0	24014	\N
14314	4149	4	0	24015	\N
14178	69	2	0	24721	\N
14178	500	3	0	24729	\N
14392	207	2	0	25933	\N
14192	86	1	0	26551	\N
14192	87	2	0	26553	\N
14258	86	4	0	26563	\N
14258	4052	5	0	26564	\N
14221	4103	6	1	27755	\N
14221	17	1	0	28533	\N
14223	16	6	0	28535	\N
14221	16	5	0	28536	\N
14223	3369	7	0	28538	\N
14243	16	2	0	28540	\N
14243	2974	3	0	28544	\N
14410	1079	2	0	29872	\N
14353	360	4	0	31493	\N
14353	3513	5	0	31498	\N
14297	322	9	0	32435	\N
14297	4139	10	0	32436	\N
14196	453	6	0	32707	\N
14196	4091	7	0	32709	\N
14226	1	4	0	33979	\N
14248	1	4	0	33988	\N
14248	3820	5	0	33990	\N
14251	1	8	0	33993	\N
14251	3946	9	0	34001	\N
14322	4136	8	0	34013	\N
14355	2	1	0	35513	\N
14355	26	2	0	35514	\N
14201	10	1	0	37823	\N
14201	11	2	0	37824	\N
14218	10	11	0	37854	\N
14218	4101	12	0	37856	\N
14275	10	3	0	37866	\N
14275	3173	4	0	37867	\N
14327	18	4	0	40031	\N
14327	2302	5	0	40032	\N
14381	18	11	0	40035	\N
14224	23	4	0	40720	\N
14224	3189	5	0	40721	\N
14333	56	8	0	44162	\N
14333	4150	9	0	44164	\N
14406	56	2	0	44167	\N
14406	2914	3	0	44169	\N
14371	75	3	0	45923	\N
14371	3855	4	0	45924	\N
14394	75	3	0	45933	\N
14394	3855	4	0	45934	\N
14423	75	2	0	45937	\N
14423	284	3	0	45938	\N
14427	75	4	0	45941	\N
14432	75	11	0	45942	\N
14427	3959	5	0	45943	\N
14432	4207	12	0	45944	\N
14293	89	1	0	47145	\N
14293	88	5	0	47155	\N
14293	4138	6	0	47156	\N
14229	137	4	0	49781	\N
14229	3697	5	0	49788	\N
14316	147	3	0	50012	\N
14316	3657	4	0	50028	\N
14428	170	8	0	50575	\N
14428	3904	9	0	50578	\N
14386	181	3	0	50883	\N
14386	4184	4	0	50884	\N
14367	200	3	0	51601	\N
14367	3338	4	0	51609	\N
14414	260	13	0	52554	\N
14414	4198	14	0	52557	\N
14301	268	3	0	52755	\N
14301	610	4	0	52761	\N
14321	597	4	0	55945	\N
14321	3733	5	0	55951	\N
14400	793	3	0	56686	\N
14400	2644	4	0	56690	\N
14298	841	4	0	57095	\N
14298	3886	5	0	57096	\N
14257	4113	4	0	59782	\N
14257	4115	5	1	59783	\N
14404	12	6	0	342	\N
14424	4204	4	0	344	\N
14402	4043	5	0	345	\N
14404	4192	7	0	346	\N
14425	12	2	0	353	\N
14425	3028	3	0	354	\N
14257	4114	4	0	855	\N
14257	4116	6	0	858	\N
14391	266	3	0	1273	\N
14391	3474	4	0	1276	\N
14257	1374	5	0	1352	\N
14385	251	6	0	1473	\N
14385	4183	7	0	1474	\N
14365	4169	5	0	2242	\N
14282	4131	95	0	2990	\N
14282	228	114	0	2995	\N
14282	4132	115	0	2996	\N
14269	262	1	0	3782	\N
14269	263	2	0	3784	\N
14244	35	4	0	4388	\N
14244	3545	5	0	4389	\N
14236	365	4	0	4561	\N
14236	4049	5	0	4564	\N
14429	189	0	0	4826	\N
14431	189	1	0	4827	\N
14387	4186	0	0	4842	\N
14430	189	45	0	4863	\N
14430	4206	46	0	4866	\N
14421	4178	5	0	5404	\N
14426	4178	4	0	5405	\N
14426	4205	5	0	5406	\N
14421	4202	6	0	5407	\N
14412	4172	11	0	8150	\N
14412	4196	12	0	8152	\N
14419	4172	1	0	8155	\N
14419	4201	2	0	8156	\N
14374	391	3	0	10400	\N
14418	132	1	0	11265	\N
14418	455	2	0	11268	\N
14370	4171	4	0	11739	\N
14435	300	8	0	12133	\N
14435	4210	9	0	12134	\N
14264	235	4	0	15722	\N
14264	3615	5	0	15723	\N
14304	4143	109	0	16090	\N
14304	44	126	0	16109	\N
14304	4144	127	0	16110	\N
14356	4159	8	0	16367	\N
14356	38	9	0	16376	\N
14409	4193	3	0	17165	\N
14325	326	4	0	17387	\N
14325	3519	5	0	17391	\N
14247	177	8	0	18332	\N
14247	4110	9	0	18333	\N
14257	3268	6	1	18748	\N
14276	4125	6	0	18819	\N
14276	4126	7	0	18820	\N
14416	4125	3	0	18822	\N
14416	4200	4	0	18823	\N
14362	4164	12	0	20081	\N
14362	198	126	0	20093	\N
14380	241	1	0	20403	\N
14380	333	2	0	20405	\N
14401	149	3	0	23085	\N
14401	4189	4	0	23086	\N
14279	140	2	0	23995	\N
14279	487	3	0	23998	\N
14255	90	2	0	26050	\N
14255	91	3	0	26051	\N
14420	16	1	0	28543	\N
14420	17	2	0	28545	\N
14388	449	6	0	29852	\N
14388	4187	7	0	29855	\N
14384	4182	7	0	32154	\N
14242	453	4	0	32730	\N
14242	4108	5	0	32731	\N
14398	453	3	0	32741	\N
14398	2838	4	0	32745	\N
14226	3820	5	0	33980	\N
14231	1	4	0	33987	\N
14231	3820	5	0	33989	\N
14267	1	12	0	33994	\N
14284	1	4	0	33995	\N
14284	3820	5	0	33999	\N
14267	4122	13	0	34002	\N
14336	3820	5	0	34018	\N
14233	2	4	0	35497	\N
14233	3510	5	0	35499	\N
14372	2	0	0	35521	\N
14309	10	3	0	37884	\N
14309	3173	4	0	37885	\N
14354	10	4	0	37897	\N
14354	3493	5	0	37899	\N
14358	10	4	0	37910	\N
14358	3493	5	0	37911	\N
14271	18	4	0	40029	\N
14271	2302	5	0	40030	\N
14328	2302	5	0	40034	\N
14382	18	6	0	40037	\N
14382	4180	7	0	40038	\N
14393	18	3	0	40039	\N
14393	3621	4	0	40040	\N
14422	27	5	0	41113	\N
14422	4203	6	0	41114	\N
14433	27	5	0	41137	\N
14434	27	4	0	41138	\N
14434	4209	5	0	41139	\N
14433	4208	6	0	41140	\N
14449	40	2	0	43054	\N
14467	40	4	0	43055	\N
14480	40	12	0	43056	\N
14449	3034	3	0	43057	\N
14467	3381	5	0	43058	\N
14480	4226	13	0	43059	\N
14486	40	4	0	43063	\N
14541	40	6	0	43065	\N
14577	40	2	0	43067	\N
14577	282	3	0	43069	\N
14486	3381	5	0	43071	\N
14541	4255	7	0	43072	\N
14471	51	3	0	43546	\N
14471	3533	4	0	43547	\N
14454	71	4	0	44800	\N
14454	3887	5	0	44801	\N
14458	75	7	0	45947	\N
14458	2859	8	0	45948	\N
14479	75	8	0	45953	\N
14479	4029	9	0	45956	\N
14500	79	3	0	46975	\N
14500	272	4	0	46977	\N
14509	79	1	0	46983	\N
14509	81	2	0	46986	\N
14466	100	8	0	47581	\N
14466	4220	9	0	47582	\N
14459	102	4	0	47833	\N
14459	3572	5	0	47838	\N
14485	113	1	0	48259	\N
14485	437	2	0	48260	\N
14579	121	1	0	48932	\N
14579	3098	2	0	48933	\N
14474	4222	10	0	49239	\N
14474	125	16	0	49245	\N
14474	4223	17	0	49246	\N
14566	135	2	0	49549	\N
14566	2722	3	0	49560	\N
14442	210	4	0	51831	\N
14442	3536	5	0	51839	\N
14446	210	3	0	51849	\N
14589	210	3	0	51850	\N
14446	4215	4	0	51852	\N
14589	3539	4	0	51854	\N
14463	260	4	0	52555	\N
14463	3728	5	0	52556	\N
14439	273	6	0	52962	\N
14439	4212	7	0	52969	\N
14522	316	3	0	53980	\N
14522	4249	4	0	53981	\N
14482	362	0	0	54883	\N
14483	362	1	0	54884	\N
14483	395	2	0	54886	\N
14464	451	4	0	55230	\N
14465	451	1	0	55231	\N
14465	584	2	0	55234	\N
14464	3666	5	0	55237	\N
14498	852	1	0	57249	\N
14498	913	2	0	57252	\N
14506	908	8	0	57653	\N
14506	3509	9	0	57654	\N
14460	2782	4	0	59288	\N
14460	3872	5	0	59289	\N
14531	2103	3	0	1275	\N
14598	3653	4	0	2246	\N
14438	110	4	0	2536	\N
14438	4134	5	0	2538	\N
14461	365	4	0	4574	\N
14461	4049	5	0	4579	\N
14475	189	1	0	4843	\N
14477	189	5	0	4845	\N
14477	4225	6	0	4849	\N
14475	4224	2	0	4850	\N
14436	4178	3	0	5408	\N
14445	4178	3	0	5409	\N
14436	4211	4	0	5410	\N
14456	4178	8	0	5412	\N
14456	4218	9	0	5413	\N
14468	4178	4	0	5414	\N
14468	4205	5	0	5421	\N
14607	4178	3	0	5432	\N
14607	4211	4	0	5434	\N
14457	4172	4	0	8157	\N
14457	4219	5	0	8158	\N
14494	4172	4	0	8160	\N
14494	4219	5	0	8162	\N
14538	4172	4	0	8169	\N
14538	4252	5	0	8170	\N
14604	4275	4	0	8176	\N
14533	391	2	0	10401	\N
14533	1381	3	0	10403	\N
14555	528	3	0	12499	\N
14555	4262	4	0	12500	\N
14441	58	4	0	13514	\N
14441	4213	5	0	13520	\N
14514	233	6	0	13757	\N
14514	4245	7	0	13762	\N
14444	258	10	0	14423	\N
14444	4214	11	0	14426	\N
14443	115	3	0	16658	\N
14563	115	2	0	16668	\N
14563	2797	3	0	16672	\N
14484	212	4	0	17163	\N
14484	3732	5	0	17167	\N
14582	326	1	0	17406	\N
14582	1534	2	0	17408	\N
14462	142	4	0	18550	\N
14462	3950	5	0	18553	\N
14558	290	3	0	19027	\N
14558	3635	4	0	19029	\N
14552	60	10	0	19432	\N
14552	4260	11	0	19436	\N
14437	3344	4	0	19767	\N
14452	62	3	0	19777	\N
14591	62	3	0	19778	\N
14452	3344	4	0	19779	\N
14591	3344	4	0	19780	\N
14453	64	3	0	20699	\N
14453	4217	4	0	20700	\N
14450	164	2	0	21075	\N
14450	3085	3	0	21076	\N
14451	164	3	0	21092	\N
14451	3385	4	0	21093	\N
14573	264	2	0	23568	\N
14472	69	1	0	24723	\N
14473	69	4	0	24724	\N
14472	70	2	0	24726	\N
14473	4041	5	0	24728	\N
14469	90	4	0	26061	\N
14470	90	16	0	26062	\N
14469	3731	5	0	26063	\N
14470	4221	17	0	26064	\N
14447	86	3	0	26569	\N
14447	3157	4	0	26570	\N
14455	244	4	0	27275	\N
14455	3778	5	0	27280	\N
14448	4216	7	0	31752	\N
14478	33	8	0	31757	\N
14478	3812	9	0	31758	\N
14568	33	6	0	31763	\N
14568	3444	7	0	31764	\N
14547	230	12	0	32153	\N
14547	4258	13	0	32155	\N
14481	2	4	0	35528	\N
14481	3510	5	0	35537	\N
14440	1785	2	0	39135	\N
14440	14	5	0	39146	\N
14440	1421	6	0	39147	\N
14594	4272	4	0	39161	\N
14516	40	2	0	43064	\N
14516	282	3	0	43068	\N
14624	40	3	0	43096	\N
14624	372	4	0	43097	\N
14799	40	2	0	43116	\N
14799	282	3	0	43119	\N
14503	56	1	0	44168	\N
14503	57	2	0	44170	\N
14548	56	12	0	44171	\N
14548	4259	13	0	44174	\N
14529	75	2	0	45954	\N
14529	284	3	0	45955	\N
14539	79	6	0	46985	\N
14539	4253	7	0	46988	\N
14662	79	5	0	47001	\N
14662	3341	6	0	47002	\N
14615	135	3	0	49550	\N
14615	3630	4	0	49562	\N
14564	137	2	0	49783	\N
14564	2721	3	0	49785	\N
14542	181	6	0	50905	\N
14542	4256	7	0	50910	\N
14639	285	2	0	53480	\N
14639	4282	3	0	53482	\N
14617	316	9	0	53994	\N
14617	4279	10	0	53995	\N
14723	353	2	0	54605	\N
14723	2884	3	0	54613	\N
14684	362	9	0	54885	\N
14684	4317	10	0	54888	\N
14653	435	3	0	55071	\N
14691	435	6	0	55072	\N
14653	3504	4	0	55075	\N
14691	4324	7	0	55079	\N
14621	451	3	0	55232	\N
14621	3934	4	0	55236	\N
14781	793	2	0	56688	\N
14781	4363	3	0	56689	\N
14496	852	3	0	57260	\N
14496	4235	4	0	57261	\N
14720	2351	4	0	58984	\N
14720	3463	5	0	58985	\N
14712	4315	37	0	59118	\N
14507	4241	6	0	59124	\N
14769	3628	2	0	59642	\N
14769	4360	3	0	59652	\N
14707	4332	3	0	59805	\N
14515	4246	7	0	59808	\N
14797	1187	4	0	2994	\N
14718	4343	3	0	3220	\N
14521	262	6	0	3783	\N
14521	4248	7	0	3785	\N
14580	35	1	0	4391	\N
14580	2929	2	0	4392	\N
14656	4293	3	0	4844	\N
14656	3782	4	0	4847	\N
14501	4178	8	0	5415	\N
14523	4178	2	0	5418	\N
14523	4247	3	0	5420	\N
14501	4237	9	0	5423	\N
14526	4178	2	0	5426	\N
14666	4178	8	0	5444	\N
14666	4298	9	0	5445	\N
14667	4178	24	0	5446	\N
14667	4299	25	0	5447	\N
14756	4178	2	0	5456	\N
14756	4247	3	0	5457	\N
14761	4178	2	0	5458	\N
14761	4247	3	0	5461	\N
14791	4178	2	0	5464	\N
14791	4247	3	0	5465	\N
14802	4178	5	0	5466	\N
14487	4172	4	0	8159	\N
14544	4172	2	0	8171	\N
14544	4191	3	0	8172	\N
14578	4172	2	0	8173	\N
14578	4191	3	0	8175	\N
14612	4172	3	0	8177	\N
14643	4172	2	0	8178	\N
14643	4285	3	0	8179	\N
14612	4275	4	0	8180	\N
14664	4172	3	0	8183	\N
14664	4275	4	0	8186	\N
14693	4172	2	0	8187	\N
14693	4191	3	0	8189	\N
14703	4252	5	0	8192	\N
14656	4289	3	0	11605	\N
14672	402	3	0	14099	\N
14672	1328	4	0	14103	\N
14712	4337	36	0	14430	\N
14712	4338	37	0	14444	\N
14534	167	2	0	17671	\N
14534	3322	3	0	17672	\N
14788	167	2	0	17691	\N
14788	3322	3	0	17692	\N
14697	30	2	0	18108	\N
14697	1127	3	0	18109	\N
14550	4260	11	0	19435	\N
14490	198	17	0	20086	\N
14559	198	3	0	20088	\N
14559	4263	4	0	20090	\N
14490	4229	18	0	20092	\N
14492	4231	12	0	20095	\N
14492	198	46	0	20108	\N
14492	4232	47	0	20109	\N
14730	164	2	0	21103	\N
14730	1124	3	0	21106	\N
14704	488	2	0	21485	\N
14704	2791	3	0	21486	\N
14783	1108	3	0	22048	\N
14569	336	6	0	22777	\N
14569	4267	7	0	22785	\N
14669	149	7	0	23105	\N
14669	1003	8	0	23106	\N
14634	264	0	0	23545	\N
14610	264	11	0	23569	\N
14610	4278	12	0	23578	\N
14495	49	4	0	25039	\N
14495	3751	5	0	25040	\N
14786	224	2	0	25518	\N
14786	3150	3	0	25519	\N
14561	90	2	0	26076	\N
14561	3442	3	0	26077	\N
14562	90	126	0	26078	\N
14562	4265	127	0	26079	\N
14710	42	6	0	27564	\N
14710	4334	7	0	27572	\N
14507	4240	5	0	28539	\N
14507	4242	6	0	28546	\N
14637	16	6	0	28554	\N
14637	3369	7	0	28555	\N
14746	16	2	0	28557	\N
14746	388	3	0	28558	\N
14575	2347	3	0	29596	\N
14680	453	33	0	32742	\N
14680	4311	34	0	32748	\N
14629	2	3	0	35529	\N
14749	2	2	0	35531	\N
14774	2	0	0	35533	\N
14749	2789	3	0	35535	\N
14629	3548	4	0	35536	\N
14776	2	0	0	35545	\N
14657	14	3	0	39159	\N
14657	4272	4	0	39162	\N
14754	14	2	0	39169	\N
14740	18	2	0	40045	\N
14740	1685	3	0	40047	\N
14588	40	3	0	43081	\N
14588	372	4	0	43082	\N
14757	40	1	0	43104	\N
14759	40	2	0	43105	\N
14757	1383	2	0	43106	\N
14759	282	3	0	43107	\N
14779	40	2	0	43115	\N
14779	282	3	0	43118	\N
14645	56	3	0	44172	\N
14645	4109	4	0	44173	\N
14571	75	6	0	45959	\N
14603	75	3	0	45960	\N
14762	75	2	0	45962	\N
14762	284	3	0	45963	\N
14603	3855	4	0	45964	\N
14571	3361	7	0	45966	\N
14511	79	7	0	46984	\N
14511	3682	8	0	46987	\N
14586	100	3	0	47596	\N
14586	3836	4	0	47600	\N
14528	121	2	0	48931	\N
14528	2498	3	0	48934	\N
14747	121	4	0	48945	\N
14747	4356	5	0	48946	\N
14721	125	1	0	49253	\N
14721	195	2	0	49254	\N
14660	156	5	0	50226	\N
14660	4295	6	0	50227	\N
14572	170	2	0	50590	\N
14572	1380	3	0	50594	\N
14595	260	3	0	52558	\N
14595	3399	4	0	52563	\N
14489	353	7	0	54583	\N
14489	4228	8	0	54588	\N
14738	435	2	0	55073	\N
14738	3413	3	0	55074	\N
14606	852	2	0	57272	\N
14606	4276	3	0	57273	\N
14581	880	1	0	57510	\N
14581	2905	2	0	57511	\N
14597	908	3	0	57662	\N
14640	908	2	0	57663	\N
14640	3025	3	0	57664	\N
14597	3591	4	0	57665	\N
14677	2782	24	0	59293	\N
14677	4306	25	0	59294	\N
14767	3625	2	0	59494	\N
14767	4359	3	0	59498	\N
14493	4234	5	0	59951	\N
14613	3003	4	0	173	\N
14627	424	6	0	869	\N
14530	2755	3	0	870	\N
14627	3712	7	0	872	\N
14593	514	3	0	1045	\N
14593	4271	4	0	1046	\N
14599	1858	0	0	3019	\N
14600	1858	3	0	3020	\N
14600	4273	4	0	3025	\N
14602	3726	3	0	3043	\N
14602	4274	4	0	3045	\N
14670	262	9	0	3804	\N
14670	4300	10	0	3805	\N
14618	3839	4	0	4578	\N
14650	365	3	0	4593	\N
14650	3839	4	0	4594	\N
14752	365	2	0	4613	\N
14752	615	3	0	4614	\N
14525	4178	6	0	5424	\N
14525	4250	7	0	5425	\N
14587	4178	3	0	5428	\N
14587	4211	4	0	5431	\N
14638	4178	6	0	5438	\N
14638	4250	7	0	5442	\N
14772	4178	2	0	5460	\N
14513	4172	6	0	8163	\N
14513	4197	7	0	8164	\N
14658	4172	3	0	8182	\N
14658	4275	4	0	8185	\N
14777	391	6	0	10413	\N
14777	4361	7	0	10416	\N
14705	108	2	0	11735	\N
14705	3340	3	0	11738	\N
14673	300	24	0	12150	\N
14673	4302	25	0	12155	\N
14505	528	19	0	12482	\N
14505	4239	20	0	12486	\N
14632	4280	10	0	12512	\N
14676	402	24	0	14100	\N
14698	402	2	0	14101	\N
14698	2760	3	0	14102	\N
14676	4305	25	0	14104	\N
14734	4349	0	0	14451	\N
14630	173	3	0	14668	\N
14630	3796	4	0	14669	\N
14609	92	11	0	15015	\N
14731	192	8	0	15274	\N
14731	3419	9	0	15276	\N
14554	115	3	0	16667	\N
14567	212	6	0	17179	\N
14567	4266	7	0	17180	\N
14724	212	2	0	17191	\N
14724	3616	3	0	17193	\N
14540	142	3	0	18551	\N
14540	4254	4	0	18552	\N
14741	4125	4	0	18825	\N
14741	4351	5	0	18827	\N
14518	198	2	0	20087	\N
14518	513	3	0	20089	\N
14625	73	3	0	22569	\N
14625	3040	4	0	22571	\N
14520	2780	3	0	23547	\N
14537	264	4	0	23555	\N
14537	4251	5	0	23556	\N
14557	264	3	0	23567	\N
14557	3632	4	0	23576	\N
14734	4348	0	0	23815	\N
14728	82	4	0	23832	\N
14728	3422	5	0	23833	\N
14642	4283	63	0	24294	\N
14642	214	126	0	24307	\N
14642	4284	127	0	24308	\N
14648	4286	63	0	24309	\N
14648	4287	127	0	24329	\N
14784	224	4	0	25512	\N
14784	3281	5	0	25513	\N
14549	206	0	0	25931	\N
14508	4243	0	0	26575	\N
14488	94	8	0	26919	\N
14488	4227	9	0	26922	\N
14584	16	1	0	28548	\N
14584	1087	2	0	28549	\N
14590	16	3	0	28550	\N
14605	16	3	0	28551	\N
14590	3634	4	0	28552	\N
14787	16	2	0	28560	\N
14574	3846	2	0	29407	\N
14574	4269	3	0	29408	\N
14681	54	24	0	30123	\N
14681	4312	25	0	30125	\N
14508	2566	0	0	30320	\N
14546	151	4	0	30735	\N
14546	1876	5	0	30736	\N
14765	163	1	0	31771	\N
14765	33	5	0	31779	\N
14765	3342	6	0	31781	\N
14736	453	8	0	32757	\N
14775	2	0	0	35534	\N
14553	40	3	0	43066	\N
14553	372	4	0	43070	\N
14616	40	3	0	43089	\N
14616	372	4	0	43090	\N
14678	869	12	0	43091	\N
14678	40	17	0	43098	\N
14678	2796	18	0	43099	\N
14649	4288	5	0	44802	\N
14649	71	7	0	44815	\N
14649	3035	8	0	44816	\N
14502	79	8	0	46976	\N
14502	4238	9	0	46978	\N
14611	79	2	0	46995	\N
14611	616	3	0	46996	\N
14743	135	4	0	49551	\N
14743	4353	5	0	49567	\N
14614	137	3	0	49784	\N
14614	3633	4	0	49787	\N
14659	186	3	0	51260	\N
14659	4294	4	0	51261	\N
14717	200	2	0	51602	\N
14717	276	3	0	51607	\N
14628	268	3	0	52758	\N
14628	3815	4	0	52759	\N
14524	273	6	0	52976	\N
14524	4212	7	0	52977	\N
14688	353	7	0	54597	\N
14688	4320	8	0	54599	\N
14633	451	9	0	55233	\N
14633	4281	10	0	55238	\N
14497	852	3	0	57248	\N
14499	852	2	0	57250	\N
14499	4236	3	0	57251	\N
14497	3612	4	0	57253	\N
14608	852	3	0	57258	\N
14608	3612	4	0	57259	\N
14700	4327	68	0	57274	\N
14700	4329	69	0	57284	\N
14700	4328	69	0	57851	\N
14545	1470	4	0	58210	\N
14545	2798	5	0	58213	\N
14692	2578	2	0	58599	\N
14692	4325	3	0	58602	\N
14532	2636	0	0	58764	\N
14565	2636	1	0	58765	\N
14565	3207	2	0	58766	\N
14737	2636	2	0	58771	\N
14737	2836	3	0	58774	\N
14683	4315	31	0	59117	\N
14751	4332	3	0	59806	\N
14570	4268	7	0	175	\N
14695	4326	5	0	878	\N
14722	424	2	0	887	\N
14722	2755	3	0	888	\N
14679	4310	26	1	1380	\N
14652	4291	4	0	1386	\N
14652	4290	3	0	1484	\N
14619	367	0	0	3404	\N
14620	367	3	0	3405	\N
14686	367	3	0	3406	\N
14620	3683	4	0	3409	\N
14686	3683	4	0	3410	\N
14683	4314	30	0	3414	\N
14601	365	3	0	4575	\N
14601	3839	4	0	4577	\N
14655	189	0	0	4828	\N
14778	189	6	0	4846	\N
14504	4178	4	0	5416	\N
14517	4178	2	0	5417	\N
14517	4247	3	0	5419	\N
14504	4205	5	0	5422	\N
14535	4178	2	0	5427	\N
14535	4247	3	0	5430	\N
14623	4178	3	0	5433	\N
14623	4211	4	0	5435	\N
14626	4211	4	0	5437	\N
14646	4178	3	0	5439	\N
14702	4178	4	0	5449	\N
14702	4331	5	0	5451	\N
14744	4178	2	0	5454	\N
14744	4247	3	0	5455	\N
14764	4178	6	0	5459	\N
14764	4358	7	0	5463	\N
14527	4172	2	0	8165	\N
14536	4172	2	0	8166	\N
14527	4191	3	0	8167	\N
14536	4191	3	0	8168	\N
14771	4172	2	0	8194	\N
14771	4191	3	0	8195	\N
14733	4347	9	0	8196	\N
14644	391	12	0	10402	\N
14644	581	13	0	10405	\N
14652	4289	3	0	11604	\N
14652	4292	4	1	11631	\N
14512	233	6	0	13756	\N
14512	4245	7	0	13761	\N
14636	173	6	0	14681	\N
14636	3606	7	0	14684	\N
14609	4277	12	0	15016	\N
14748	2757	3	0	15732	\N
14583	4125	1	0	18824	\N
14583	4270	2	0	18826	\N
14690	4322	6	0	18839	\N
14690	4323	7	0	18840	\N
14715	62	10	0	19794	\N
14715	4340	11	0	19797	\N
14491	241	17	0	20404	\N
14491	4230	18	0	20409	\N
14551	241	10	0	20417	\N
14551	4261	11	0	20421	\N
14596	64	3	0	20718	\N
14727	164	4	0	21102	\N
14727	4345	5	0	21109	\N
14543	73	6	0	22563	\N
14543	4257	7	0	22564	\N
14635	264	0	0	23546	\N
14556	264	3	0	23566	\N
14556	3632	4	0	23575	\N
14641	214	2	0	24301	\N
14647	214	3	0	24302	\N
14641	2979	3	0	24303	\N
14647	3496	4	0	24304	\N
14592	411	3	0	25256	\N
14729	411	2	0	25264	\N
14729	3370	3	0	25265	\N
14510	86	7	0	26576	\N
14663	16	3	0	28556	\N
14663	3634	4	0	28559	\N
14679	54	24	0	30122	\N
14679	4308	25	1	30124	\N
14753	20	2	0	30439	\N
14753	369	3	0	30440	\N
14719	151	2	0	30746	\N
14719	2854	3	0	30747	\N
14766	163	1	0	31772	\N
14766	3342	6	0	31782	\N
14675	2	24	0	35530	\N
14675	4304	25	0	35538	\N
14709	14	6	0	39160	\N
14709	2720	7	0	39163	\N
14585	18	2	0	40041	\N
14585	3817	3	0	40042	\N
14622	18	3	0	40043	\N
14631	18	3	0	40044	\N
14622	3621	4	0	40049	\N
14631	3621	4	0	40050	\N
14576	27	2	0	41153	\N
14871	40	7	0	43123	\N
14871	4394	8	0	43126	\N
14859	4390	3	1	43438	\N
14851	51	2	0	43553	\N
14851	1260	3	0	43554	\N
14859	4388	2	0	43558	\N
14800	56	2	0	44175	\N
14800	2795	3	0	44176	\N
14654	75	3	0	45961	\N
14654	3855	4	0	45965	\N
14790	75	2	0	45973	\N
14790	284	3	0	45974	\N
14883	100	5	0	47598	\N
14883	4400	6	0	47601	\N
14768	119	2	0	48608	\N
14768	1879	3	0	48609	\N
14873	119	2	0	48664	\N
14873	1879	3	0	48665	\N
14742	137	4	0	49798	\N
14742	4352	5	0	49801	\N
14844	200	2	0	51603	\N
14844	276	3	0	51608	\N
14782	210	2	0	51851	\N
14782	1874	3	0	51853	\N
14785	242	4	0	52133	\N
14785	4364	5	0	52141	\N
14696	268	2	0	52769	\N
14726	268	4	0	52770	\N
14739	268	2	0	52771	\N
14696	2800	3	0	52772	\N
14739	2800	3	0	52773	\N
14726	4344	5	0	52774	\N
14689	353	6	0	54604	\N
14689	4321	7	0	54617	\N
14796	362	3	0	54889	\N
14796	3372	4	0	54892	\N
14725	451	2	0	55244	\N
14725	3317	3	0	55247	\N
14763	1021	6	0	56393	\N
14763	4357	7	0	56396	\N
14780	793	0	0	56687	\N
14699	852	2	0	57264	\N
14806	852	2	0	57265	\N
14699	2872	3	0	57269	\N
14806	1325	3	0	57271	\N
14811	4368	2	0	58446	\N
14811	4370	3	0	58449	\N
14758	2636	1	0	58772	\N
14758	3207	2	0	58773	\N
14841	2636	3	0	58777	\N
14841	2837	4	0	58778	\N
14854	4381	10	0	59473	\N
14859	4389	3	0	59474	\N
14830	3628	4	0	59643	\N
14830	4375	5	0	59657	\N
14716	4342	3	0	2314	\N
14892	731	2	0	3736	\N
14895	731	2	0	3738	\N
14892	262	9	0	3767	\N
14895	262	9	0	3769	\N
14892	4403	10	0	3770	\N
14778	4362	7	0	4848	\N
14801	189	4	0	4864	\N
14801	3436	5	0	4865	\N
14665	4178	6	0	5440	\N
14646	4211	4	0	5441	\N
14665	4297	7	0	5443	\N
14685	4178	9	0	5448	\N
14708	4333	6	0	5452	\N
14685	4318	10	0	5453	\N
14849	4178	6	0	5474	\N
14849	4358	7	0	5475	\N
14864	4178	2	0	5477	\N
14864	4247	3	0	5479	\N
14869	4178	2	0	5480	\N
14869	4247	3	0	5482	\N
14651	4172	3	0	8181	\N
14651	4275	4	0	8184	\N
14793	4172	6	0	8197	\N
14793	4365	7	0	8198	\N
14853	4191	3	0	8201	\N
14889	4172	4	0	8209	\N
14889	4219	5	0	8212	\N
14674	132	24	0	11266	\N
14760	132	2	0	11267	\N
14760	2756	3	0	11269	\N
14674	4303	25	0	11270	\N
14832	300	2	0	12151	\N
14832	2786	3	0	12153	\N
14687	77	7	0	13128	\N
14687	4319	8	0	13133	\N
14706	233	2	0	13758	\N
14750	233	2	0	13766	\N
14750	1849	3	0	13773	\N
14886	258	12	0	14424	\N
14886	4401	13	0	14425	\N
14794	4367	0	0	14460	\N
14846	326	76	0	17407	\N
14846	4380	77	0	17409	\N
14859	3265	2	0	18749	\N
14859	3268	4	0	18753	\N
14854	4383	11	0	18754	\N
14811	4371	3	1	18818	\N
14811	4369	2	0	18828	\N
14817	73	2	0	22577	\N
14817	2766	3	0	22578	\N
14668	149	8	0	23104	\N
14668	2335	9	0	23107	\N
14694	411	4	0	25263	\N
14694	2806	5	0	25266	\N
14745	4355	102	0	26741	\N
14745	4354	45	0	26925	\N
14745	94	101	0	26928	\N
14711	4335	23	0	27554	\N
14711	42	126	0	27573	\N
14711	4336	127	0	27574	\N
14840	16	8	0	28567	\N
14835	388	3	0	28569	\N
14840	4379	9	0	28571	\N
14820	320	2	0	29379	\N
14820	1937	3	0	29381	\N
14661	1640	5	0	29396	\N
14661	4296	6	0	29397	\N
14671	96	9	0	29611	\N
14671	4301	10	0	29612	\N
14804	20	2	0	30451	\N
14804	369	3	0	30452	\N
14770	202	4	0	31093	\N
14701	360	4	0	31494	\N
14701	4330	5	0	31499	\N
14732	33	8	0	31769	\N
14732	4346	9	0	31770	\N
14798	230	2	0	32160	\N
14798	3307	3	0	32161	\N
14682	453	24	0	32743	\N
14714	453	10	0	32744	\N
14714	4339	11	0	32746	\N
14682	4313	25	0	32747	\N
14773	2	0	0	35532	\N
14854	4382	10	1	35828	\N
14861	1538	3	0	35932	\N
14854	4	9	0	35941	\N
14861	4	6	0	35943	\N
14861	2751	7	0	35944	\N
14878	4	4	0	35956	\N
14878	4117	5	0	35957	\N
14755	18	2	0	40046	\N
14755	1685	3	0	40048	\N
14880	40	9	0	43124	\N
14880	4397	10	0	43127	\N
15026	40	3	0	43145	\N
15026	372	4	0	43150	\N
14865	56	2	0	44177	\N
14865	2795	3	0	44178	\N
14885	56	3	0	44179	\N
14926	56	2	0	44181	\N
14926	2795	3	0	44182	\N
14885	4109	4	0	44183	\N
15043	76	1	0	45981	\N
15043	75	4	0	45987	\N
15043	2989	5	0	45990	\N
14815	79	2	0	46122	\N
14815	616	3	0	46123	\N
15074	102	2	0	47834	\N
15074	3053	3	0	47836	\N
15003	113	2	0	48269	\N
15003	1899	3	0	48270	\N
15018	119	3	0	48688	\N
15018	2860	4	0	48697	\N
15006	121	5	0	48953	\N
15006	4430	6	0	48954	\N
14959	181	3	0	50906	\N
14959	4184	4	0	50909	\N
14905	260	4	0	52559	\N
15077	260	5	0	52560	\N
14905	3728	5	0	52564	\N
15077	4447	6	0	52565	\N
14805	273	3	0	52986	\N
15067	273	2	0	52987	\N
15067	1413	3	0	52988	\N
14805	1906	4	0	52989	\N
14911	285	4	0	53481	\N
14911	3674	5	0	53485	\N
14803	316	2	0	54002	\N
14803	1900	3	0	54005	\N
15069	353	1	0	54609	\N
15069	354	2	0	54612	\N
14901	362	2	0	54890	\N
14901	2873	3	0	54891	\N
15001	451	4	0	55245	\N
15001	3391	5	0	55248	\N
14839	1021	8	0	56403	\N
14848	1021	6	0	56404	\N
14848	4357	7	0	56407	\N
14839	4378	9	0	56408	\N
14898	4406	5	0	56605	\N
14808	852	1	0	57266	\N
14808	913	2	0	57268	\N
14917	908	3	0	57682	\N
14917	3591	4	0	57683	\N
15013	2578	3	0	58600	\N
15013	4431	4	0	58603	\N
14909	2636	4	0	58781	\N
14956	2636	3	0	58782	\N
14956	2837	4	0	58785	\N
14909	3617	5	0	58786	\N
14990	2351	3	0	58992	\N
14990	2845	4	0	58994	\N
14829	3625	4	0	59495	\N
14829	4374	5	0	59503	\N
15061	3625	4	0	59513	\N
15061	4443	5	0	59515	\N
14876	3628	2	0	59644	\N
14876	4360	3	0	59653	\N
14981	4088	2	0	59814	\N
15035	4088	5	0	59815	\N
14981	4332	3	0	59816	\N
15035	4436	6	0	59817	\N
14845	2842	3	0	172	\N
15046	2804	3	0	364	\N
14821	266	2	0	1279	\N
14821	2103	3	0	1280	\N
14818	117	4	0	2247	\N
14818	4169	5	0	2248	\N
14898	4408	6	0	2327	\N
14810	110	0	0	2551	\N
14942	1636	2	0	3082	\N
14942	4416	3	0	3088	\N
14898	4407	5	1	3245	\N
14898	367	4	0	3407	\N
14935	367	5	0	3408	\N
14894	731	2	0	3737	\N
14894	262	9	0	3768	\N
14894	4403	10	0	3771	\N
14895	4403	10	0	3772	\N
14826	35	6	0	4394	\N
14826	3323	7	0	4395	\N
14944	365	1	0	4621	\N
14944	366	2	0	4622	\N
14877	4178	7	0	5481	\N
14877	4396	8	0	5483	\N
14891	4178	4	0	5488	\N
14891	4205	5	0	5489	\N
14954	4211	4	0	5502	\N
15044	4178	2	0	5512	\N
15049	4178	2	0	5513	\N
15044	4247	3	0	5514	\N
15049	4247	3	0	5515	\N
14929	4172	1	0	8215	\N
14940	4172	2	0	8217	\N
14929	4201	2	0	8219	\N
14940	4191	3	0	8220	\N
15053	391	0	0	10423	\N
14795	132	2	0	11275	\N
14795	2756	3	0	11276	\N
14976	2856	4	0	12793	\N
14902	77	4	0	13129	\N
14902	3619	5	0	13132	\N
14978	233	2	0	13767	\N
14978	1849	3	0	13774	\N
14906	92	3	0	15026	\N
14906	4410	4	0	15027	\N
14870	192	7	0	15275	\N
14870	4393	8	0	15277	\N
14858	235	2	0	15748	\N
14858	2757	3	0	15752	\N
14999	341	0	0	16973	\N
14813	4372	10	0	18832	\N
14789	73	4	0	22570	\N
14789	2827	5	0	22572	\N
15033	149	44	0	23115	\N
15033	4435	45	0	23119	\N
14831	69	58	0	24736	\N
14834	69	0	0	24738	\N
14831	4376	59	0	24740	\N
14963	69	2	0	24748	\N
14963	3350	3	0	24749	\N
14948	224	5	0	25530	\N
14948	4419	6	0	25533	\N
15024	4434	11	0	27297	\N
14787	388	3	0	28562	\N
14897	16	4	0	28568	\N
14897	3546	5	0	28570	\N
14792	202	2	0	31104	\N
14792	2764	3	0	31105	\N
14913	322	4	0	32451	\N
14913	3429	5	0	32452	\N
14915	2	2	0	35547	\N
14915	2789	3	0	35548	\N
14904	14	4	0	39170	\N
14823	18	1	0	40052	\N
14823	1426	2	0	40054	\N
14868	1685	3	0	40055	\N
15051	18	1	0	40064	\N
15051	19	2	0	40066	\N
14850	27	2	0	41154	\N
14850	645	3	0	41156	\N
14866	282	3	0	43120	\N
14887	40	12	0	43125	\N
14887	4402	13	0	43128	\N
14908	40	4	0	43131	\N
14908	3381	5	0	43132	\N
14860	51	2	0	43559	\N
14860	1260	3	0	43563	\N
14968	56	1	0	44186	\N
14996	56	3	0	44188	\N
14968	57	2	0	44192	\N
14996	4109	4	0	44196	\N
14824	71	4	0	44821	\N
14824	2776	5	0	44822	\N
14842	100	2	0	47597	\N
14842	633	3	0	47599	\N
15060	119	4	0	48690	\N
15060	4442	5	0	48699	\N
14998	186	1	0	51272	\N
14998	187	2	0	51274	\N
14934	210	5	0	51859	\N
14934	4413	6	0	51862	\N
14939	285	2	0	53496	\N
14939	3036	3	0	53497	\N
14922	316	1	0	54003	\N
14922	317	2	0	54004	\N
14982	362	3	0	54893	\N
14982	3658	4	0	54894	\N
14965	793	3	0	56698	\N
14965	2644	4	0	56699	\N
15066	908	2	0	57694	\N
15066	2832	3	0	57695	\N
14985	2782	1	0	59309	\N
14985	3873	2	0	59311	\N
14874	3625	2	0	59496	\N
14874	4359	3	0	59499	\N
15038	3628	1	0	59646	\N
15038	4438	2	0	59650	\N
14931	251	1	0	1486	\N
14931	252	2	0	1488	\N
14947	251	2	0	1493	\N
14947	1851	3	0	1494	\N
15010	251	2	0	1506	\N
15010	1851	3	0	1511	\N
15030	117	3	0	2252	\N
15030	3653	4	0	2254	\N
15063	35	4	0	4396	\N
15063	4445	5	0	4398	\N
14802	4333	6	0	5467	\N
14814	4178	2	0	5468	\N
14814	4247	3	0	5469	\N
14827	4247	3	0	5471	\N
14836	4178	2	0	5472	\N
14836	4247	3	0	5473	\N
14852	4178	2	0	5476	\N
14852	4247	3	0	5478	\N
14890	4178	4	0	5486	\N
14890	4205	5	0	5487	\N
14914	4178	14	0	5491	\N
14914	4411	15	0	5493	\N
14916	4178	2	0	5494	\N
14958	4178	3	0	5497	\N
14916	4247	3	0	5499	\N
15005	4178	5	0	5504	\N
15008	4178	2	0	5505	\N
15008	4247	3	0	5506	\N
15005	4429	6	0	5507	\N
15032	4178	2	0	5510	\N
15032	4247	3	0	5511	\N
14907	4172	2	0	8210	\N
14907	4191	3	0	8211	\N
14928	4172	3	0	8213	\N
14928	4275	4	0	8214	\N
14938	4172	5	0	8216	\N
14975	4172	4	0	8218	\N
14938	4415	6	0	8222	\N
14980	4172	2	0	8223	\N
14980	4191	3	0	8224	\N
15028	4172	3	0	8227	\N
15028	4275	4	0	8228	\N
15042	4201	1	0	8231	\N
15042	4172	4	0	8233	\N
15042	4285	5	0	8234	\N
14855	814	3	0	11277	\N
14855	132	9	0	11296	\N
14855	4384	10	0	11299	\N
14881	108	9	0	11736	\N
14994	123	5	0	12817	\N
14994	4427	6	0	12820	\N
14903	258	4	0	14441	\N
14903	4409	5	0	14442	\N
15050	173	1	0	14682	\N
15050	396	2	0	14683	\N
14809	235	3	0	15740	\N
14809	3343	4	0	15741	\N
14953	38	3	0	16381	\N
14953	3457	4	0	16382	\N
15071	115	1	0	16669	\N
15071	116	2	0	16671	\N
14847	393	3	0	17422	\N
14920	142	3	0	18561	\N
14920	4254	4	0	18562	\N
15012	142	2	0	18584	\N
15012	4418	3	0	18586	\N
14812	4125	9	0	18829	\N
14812	4372	10	0	18831	\N
14960	62	5	0	19795	\N
14960	4422	6	0	19796	\N
14900	198	3	0	20106	\N
14900	4263	4	0	20107	\N
14862	145	5	0	22052	\N
14973	264	2	0	23571	\N
14973	2780	3	0	23574	\N
14945	206	13	0	25932	\N
14945	4417	14	0	25936	\N
14970	90	6	0	26083	\N
14970	3292	7	0	26084	\N
14807	16	3	0	28561	\N
14807	1045	4	0	28563	\N
14816	16	2	0	28564	\N
14816	388	3	0	28565	\N
14918	16	3	0	28572	\N
14918	3634	4	0	28576	\N
14927	1937	3	0	29382	\N
14819	33	2	0	31789	\N
14819	2822	3	0	31790	\N
14955	230	1	0	32174	\N
14955	287	2	0	32175	\N
14987	230	3	0	32181	\N
14987	4181	4	0	32182	\N
14989	230	3	0	32194	\N
14989	4181	4	0	32196	\N
14932	431	5	0	34821	\N
14932	4412	6	0	34822	\N
14912	2	4	0	35546	\N
14857	1538	3	0	35931	\N
14857	4	9	0	35942	\N
14857	4387	10	0	35945	\N
15025	6	1	0	36290	\N
15025	194	2	0	36291	\N
14904	3498	5	0	39179	\N
15015	18	5	0	40060	\N
15015	3550	6	0	40061	\N
15023	18	10	0	40062	\N
15023	4433	11	0	40063	\N
15055	27	2	0	41169	\N
15055	645	3	0	41170	\N
14910	40	4	0	43135	\N
15011	40	2	0	43136	\N
15011	282	3	0	43137	\N
14910	3381	5	0	43138	\N
15065	40	2	0	43146	\N
15065	282	3	0	43149	\N
14863	51	5	0	43560	\N
15058	51	2	0	43561	\N
15058	1260	3	0	43564	\N
14863	4392	6	0	43566	\N
14921	56	3	0	44180	\N
14921	4109	4	0	44184	\N
14991	56	3	0	44187	\N
14991	4109	4	0	44195	\N
14969	75	3	0	45979	\N
14969	3855	4	0	45980	\N
14977	75	3	0	45985	\N
14977	3855	4	0	45989	\N
15105	75	2	0	46001	\N
15105	284	3	0	46002	\N
14933	79	5	0	46171	\N
14966	79	1	0	46172	\N
14966	81	2	0	46173	\N
14933	3341	6	0	46174	\N
14828	119	4	0	48646	\N
14828	4373	5	0	48647	\N
15036	119	1	0	48689	\N
15036	120	2	0	48694	\N
14951	279	5	0	53234	\N
14951	4421	6	0	53237	\N
14882	353	9	0	54606	\N
14937	353	5	0	54607	\N
14937	2223	6	0	54616	\N
14882	4399	10	0	54618	\N
14964	416	3	0	54950	\N
14964	4423	4	0	54952	\N
14962	435	2	0	55080	\N
14962	3413	3	0	55083	\N
15002	451	126	0	55246	\N
15002	4428	127	0	55249	\N
15078	1021	5	0	56411	\N
15078	4448	6	0	56422	\N
15107	793	6	0	56713	\N
15107	4454	7	0	56716	\N
14822	852	2	0	57267	\N
14822	2872	3	0	57270	\N
14949	852	5	0	57277	\N
14950	852	0	0	57278	\N
14952	852	0	0	57279	\N
14949	4420	6	0	57283	\N
14843	908	2	0	57674	\N
14843	2832	3	0	57675	\N
14971	2782	2	0	59299	\N
14971	2784	3	0	59300	\N
15039	2782	1	0	59310	\N
15039	3873	2	0	59312	\N
15019	3625	3	0	59497	\N
15019	3784	4	0	59501	\N
15064	3628	4	0	59647	\N
15064	4446	5	0	59659	\N
14983	4424	2	0	59949	\N
15016	13	2	0	352	\N
15004	117	2	0	2251	\N
15004	1257	3	0	2253	\N
14896	4405	0	0	3403	\N
15068	365	2	0	4627	\N
15068	615	3	0	4629	\N
14879	4178	3	0	5484	\N
14879	4211	4	0	5485	\N
14899	4178	4	0	5490	\N
14899	4205	5	0	5492	\N
14919	4178	3	0	5495	\N
14961	4178	2	0	5498	\N
14961	4247	3	0	5500	\N
15014	4178	3	0	5508	\N
15014	4211	4	0	5509	\N
15083	4178	2	0	5517	\N
15083	4247	3	0	5518	\N
15097	4178	0	0	5522	\N
15102	4172	0	0	8191	\N
14825	4172	4	0	8199	\N
14825	4252	5	0	8202	\N
14867	4172	2	0	8203	\N
14875	4172	2	0	8204	\N
14884	4172	3	0	8205	\N
14867	4191	3	0	8206	\N
14884	4275	4	0	8208	\N
15056	4172	3	0	8232	\N
15056	4440	4	0	8235	\N
14888	391	4	0	10414	\N
14888	3913	5	0	10415	\N
15072	391	1	0	10424	\N
15072	1420	2	0	10425	\N
14856	814	3	0	11278	\N
14856	4386	4	0	11287	\N
15115	300	1	0	12171	\N
15115	355	2	0	12172	\N
14837	528	2	0	12510	\N
15040	309	1	0	14443	\N
15040	258	4	0	14449	\N
15040	3140	5	0	14450	\N
15096	303	1	0	15236	\N
15096	4452	2	0	15238	\N
15080	192	3	0	15284	\N
15080	4449	4	0	15285	\N
15088	192	1	0	15293	\N
15088	193	2	0	15297	\N
14923	235	1	0	15749	\N
14923	236	2	0	15751	\N
14943	44	2	0	16085	\N
14946	142	2	0	18583	\N
14946	4418	3	0	18585	\N
15093	4451	0	0	18739	\N
14896	3265	0	0	18750	\N
14972	73	2	0	22587	\N
15031	149	4	0	23114	\N
15031	3808	5	0	23118	\N
14967	264	1	0	23570	\N
14967	270	2	0	23572	\N
14992	270	1	0	23577	\N
14992	264	3	0	23587	\N
14992	2941	4	0	23588	\N
14979	3401	3	0	23838	\N
14833	69	2	0	24737	\N
14833	3350	3	0	24739	\N
15090	224	2	0	25531	\N
15090	3150	3	0	25532	\N
14872	244	7	0	27276	\N
14872	4395	8	0	27282	\N
14941	16	2	0	28573	\N
14997	16	3	0	28574	\N
14941	388	3	0	28575	\N
14997	3634	4	0	28577	\N
14957	96	3	0	29621	\N
15047	453	2	0	32765	\N
15047	3366	3	0	32768	\N
15021	2	2	0	35562	\N
15021	2789	3	0	35564	\N
15110	2	2	0	35572	\N
15110	2789	3	0	35573	\N
14838	4	8	0	35928	\N
14838	4377	9	0	35929	\N
14930	14	1	0	39171	\N
14930	15	2	0	39175	\N
14893	218	2	0	40051	\N
14893	18	9	0	40056	\N
14925	18	3	0	40058	\N
14925	3621	4	0	40059	\N
2499	56	1	0	43752	\N
15000	56	4	0	44189	\N
15127	56	3	0	44190	\N
15041	56	4	0	44193	\N
15041	2914	5	0	44197	\N
15127	4109	4	0	44198	\N
15000	3556	5	0	44199	\N
15073	75	1	0	45986	\N
15073	76	2	0	45988	\N
15081	100	3	0	47609	\N
15081	250	4	0	47615	\N
15176	121	3	0	48960	\N
15176	4471	4	0	48961	\N
15091	186	2	0	51273	\N
15091	1850	3	0	51275	\N
15027	200	3	0	51604	\N
15076	200	1	0	51605	\N
15076	201	2	0	51606	\N
15027	3338	4	0	51610	\N
15070	210	1	0	51860	\N
15070	211	2	0	51861	\N
15126	268	3	0	52785	\N
15126	4456	4	0	52786	\N
15086	316	2	0	54016	\N
15086	1900	3	0	54017	\N
15007	353	2	0	54608	\N
15007	2884	3	0	54614	\N
15125	435	1	0	55081	\N
15125	436	2	0	55082	\N
15022	1021	2	0	56405	\N
15022	4432	3	0	56406	\N
15140	793	2	0	56714	\N
15140	4363	3	0	56715	\N
15112	852	0	0	57280	\N
15136	852	0	0	57286	\N
15202	2636	2	0	58783	\N
15202	2836	3	0	58784	\N
15200	2782	3	0	59326	\N
15200	3659	4	0	59328	\N
15037	3625	1	0	59512	\N
15037	4437	2	0	59514	\N
15020	3628	3	0	59645	\N
15020	3785	4	0	59655	\N
14988	4425	4	0	59950	\N
15153	4466	4	0	60177	\N
15087	288	2	0	178	\N
15087	2842	3	0	181	\N
15017	424	3	0	903	\N
15017	3611	4	0	904	\N
15137	251	1	0	1507	\N
15137	252	2	0	1510	\N
14995	117	3	0	2249	\N
14995	3653	4	0	2250	\N
15193	117	3	0	2255	\N
15193	3653	4	0	2256	\N
15146	262	26	0	3763	\N
15146	4458	27	0	3773	\N
15148	35	6	0	4397	\N
15057	4178	3	0	5516	\N
15057	4441	4	0	5519	\N
15089	4178	1	0	5520	\N
15089	4450	2	0	5521	\N
15100	4178	2	0	5523	\N
15100	4247	3	0	5524	\N
15155	4178	2	0	5527	\N
15155	4247	3	0	5529	\N
15158	4178	3	0	5532	\N
15158	4211	4	0	5533	\N
15165	4178	3	0	5536	\N
15165	4211	4	0	5540	\N
15225	4178	3	0	5543	\N
15216	4247	3	0	5548	\N
15225	4211	4	0	5550	\N
15101	4172	0	0	8188	\N
15009	4172	2	0	8225	\N
15009	4191	3	0	8226	\N
15029	4172	2	0	8229	\N
15029	4191	3	0	8230	\N
15082	4172	3	0	8236	\N
15082	4440	4	0	8237	\N
15117	4172	1	0	8239	\N
15117	4201	2	0	8240	\N
15134	4440	4	0	8242	\N
15168	4172	4	0	8243	\N
15168	4219	5	0	8247	\N
15052	391	0	0	10422	\N
14974	300	3	0	12152	\N
14974	3747	4	0	12154	\N
15075	300	2	0	12162	\N
15075	2786	3	0	12163	\N
15059	77	2	0	13130	\N
15059	3853	3	0	13131	\N
15138	77	2	0	13140	\N
15138	3853	3	0	13141	\N
15034	3380	6	0	13777	\N
15209	235	4	0	15750	\N
15209	4479	5	0	15753	\N
15094	38	1	0	16397	\N
15094	2906	2	0	16398	\N
15129	115	5	0	16670	\N
15129	4457	6	0	16674	\N
15144	142	2	0	18594	\N
15144	4418	3	0	18595	\N
15111	4125	4	0	18833	\N
15111	4351	5	0	18834	\N
15157	4125	2	0	18835	\N
15120	64	2	0	20719	\N
15120	277	3	0	20722	\N
15183	164	3	0	21104	\N
15183	1807	4	0	21108	\N
15178	73	3	0	22588	\N
14972	2766	3	0	22589	\N
15178	3040	4	0	22590	\N
15106	140	8	0	24021	\N
15108	140	6	0	24022	\N
15109	140	6	0	24023	\N
15108	4455	7	0	24024	\N
15109	4455	7	0	24025	\N
15153	214	2	0	24324	\N
15045	206	2	0	25937	\N
15045	2773	3	0	25938	\N
14986	244	1	0	27277	\N
14986	245	2	0	27278	\N
15048	42	2	0	27565	\N
15048	3310	3	0	27568	\N
15121	16	2	0	28578	\N
15121	388	3	0	28579	\N
15084	320	2	0	29385	\N
15084	1937	3	0	29386	\N
15098	20	1	0	30461	\N
15114	151	3	0	30756	\N
15114	3046	4	0	30757	\N
15062	33	4	0	31799	\N
15062	4444	5	0	31802	\N
14993	322	5	0	32456	\N
14993	4426	6	0	32457	\N
15131	322	1	0	32464	\N
15131	323	2	0	32465	\N
15103	2	3	0	35563	\N
15103	298	4	0	35565	\N
15116	2	3	0	35580	\N
15116	3548	4	0	35581	\N
15079	3964	6	0	40067	\N
15147	18	7	0	40068	\N
15147	4459	8	0	40069	\N
15054	27	76	0	41168	\N
15054	4439	77	0	41171	\N
15247	40	7	0	43165	\N
15247	4488	8	0	43171	\N
15315	56	4	0	44200	\N
15315	3556	5	0	44201	\N
15335	56	2	0	44202	\N
15335	2795	3	0	44204	\N
15336	71	7	0	44848	\N
15336	4508	8	0	44853	\N
15128	75	2	0	46003	\N
15128	284	3	0	46004	\N
15164	75	1	0	46005	\N
15370	75	2	0	46008	\N
15164	76	2	0	46009	\N
15370	284	3	0	46010	\N
15264	79	1	0	46356	\N
15264	81	2	0	46358	\N
15141	102	1	0	47847	\N
15141	103	2	0	47848	\N
15123	119	1	0	48691	\N
15219	119	5	0	48692	\N
15123	120	2	0	48695	\N
15219	4482	6	0	48698	\N
15085	156	1	0	50224	\N
15085	157	2	0	50225	\N
15325	181	3	0	50916	\N
15325	4184	4	0	50917	\N
15211	200	2	0	51617	\N
15211	276	3	0	51618	\N
15252	273	4	0	52994	\N
15320	273	5	0	52995	\N
15252	3390	5	0	52996	\N
15320	4503	6	0	52997	\N
15257	3421	9	0	53505	\N
15257	285	11	0	53513	\N
15257	3112	12	0	53516	\N
15350	324	3	0	54217	\N
15350	4514	4	0	54223	\N
15171	362	4	0	54895	\N
15229	362	1	0	54896	\N
15229	395	2	0	54898	\N
15171	4470	5	0	54900	\N
15274	435	8	0	55085	\N
15274	4493	9	0	55089	\N
15113	852	3	0	57281	\N
15113	3612	4	0	57282	\N
15387	1952	2	0	58528	\N
15387	4523	3	0	58529	\N
15291	2782	1	0	59334	\N
15291	3873	2	0	59335	\N
15357	4088	3	0	59825	\N
15357	4506	4	0	59833	\N
15368	4233	5	0	59955	\N
15368	4518	6	0	59961	\N
15254	2272	5	0	386	\N
15338	4510	8	0	3094	\N
15145	262	2	0	3762	\N
15195	262	2	0	3764	\N
15145	2743	3	0	3765	\N
15195	2743	3	0	3766	\N
15173	35	4	0	4400	\N
15173	3545	5	0	4401	\N
15187	189	2	0	4870	\N
15187	3441	3	0	4873	\N
15149	4429	5	0	5525	\N
15143	4178	1	0	5526	\N
15143	4450	2	0	5528	\N
15149	4460	8	0	5531	\N
15160	4178	4	0	5534	\N
15160	4468	5	0	5535	\N
15213	4178	2	0	5538	\N
15213	4247	3	0	5539	\N
15310	4178	3	0	5563	\N
15310	4211	4	0	5564	\N
15398	4178	3	0	5578	\N
15398	4211	4	0	5579	\N
15092	4172	0	0	8238	\N
15269	4172	5	0	8260	\N
15269	4415	6	0	8265	\N
15396	4172	2	0	8273	\N
15343	4191	3	0	8275	\N
15396	4191	3	0	8276	\N
15104	392	1	0	10426	\N
15104	391	2	0	10433	\N
15185	391	2	0	10447	\N
15190	391	11	0	10448	\N
15185	1381	3	0	10450	\N
15190	2841	12	0	10451	\N
15363	391	0	0	10475	\N
15333	123	4	0	12818	\N
15333	4507	5	0	12819	\N
15298	2853	3	0	13517	\N
15099	258	2	0	14461	\N
15167	258	4	0	14462	\N
15099	3275	3	0	14464	\N
15167	4409	5	0	14465	\N
15197	173	2	0	14696	\N
15197	2102	3	0	14700	\N
15135	192	3	0	15294	\N
15135	4449	4	0	15300	\N
15151	4463	5	0	16087	\N
15151	44	7	0	16107	\N
15151	2997	8	0	16108	\N
15385	3483	4	0	16691	\N
15236	326	2	0	17421	\N
15236	393	3	0	17423	\N
15304	167	47	0	17704	\N
15304	4501	48	0	17715	\N
15271	30	4	0	18111	\N
15271	4004	5	0	18113	\N
15377	30	31	0	18117	\N
15377	4519	32	0	18128	\N
15238	290	2	0	19041	\N
15238	1909	3	0	19044	\N
15296	336	10	0	22778	\N
15281	82	2	0	23837	\N
15281	3401	3	0	23839	\N
15162	69	1	0	24758	\N
15162	70	2	0	24759	\N
15401	69	5	0	24773	\N
15401	4526	6	0	24774	\N
15170	224	4	0	25542	\N
15170	3806	5	0	25545	\N
15175	206	1	0	25939	\N
15175	207	2	0	25940	\N
15180	90	6	0	26097	\N
15180	4472	7	0	26102	\N
15341	3746	4	0	26583	\N
15132	96	2	0	29637	\N
15132	2347	3	0	29638	\N
15095	54	1	0	30149	\N
15095	3142	2	0	30152	\N
15359	360	0	0	31495	\N
15206	322	3	0	32468	\N
15206	1105	4	0	32469	\N
15241	322	7	0	32472	\N
15241	4486	8	0	32473	\N
15380	4	2	0	35968	\N
15380	4522	3	0	35970	\N
15118	2805	3	0	36298	\N
15312	6	2	0	36304	\N
15312	2805	3	0	36307	\N
15352	14	2	0	39172	\N
15352	1785	3	0	39177	\N
15227	18	3	0	40070	\N
15227	3621	4	0	40071	\N
15361	18	2	0	40072	\N
15361	1685	3	0	40075	\N
15301	27	0	0	41194	\N
15169	40	4	0	43147	\N
15169	3381	5	0	43152	\N
15228	40	1	0	43155	\N
15228	41	2	0	43156	\N
15314	71	3	0	44835	\N
15314	3770	4	0	44836	\N
15221	75	5	0	46006	\N
15221	4484	6	0	46012	\N
15235	79	2	0	46355	\N
15235	616	3	0	46359	\N
15217	102	5	0	47852	\N
15217	4480	6	0	47853	\N
15174	113	1	0	48278	\N
15174	437	2	0	48280	\N
15239	156	2	0	50232	\N
15239	4485	3	0	50233	\N
15133	181	2	0	50907	\N
15133	3313	3	0	50908	\N
15119	210	2	0	51872	\N
15119	1874	3	0	51875	\N
15230	242	1	0	52134	\N
15230	253	2	0	52139	\N
15311	260	2	0	52561	\N
15311	3184	3	0	52562	\N
15353	260	2	0	52566	\N
15353	3184	3	0	52567	\N
15250	279	3	0	53243	\N
15250	3641	4	0	53244	\N
15186	285	2	0	53502	\N
15186	3036	3	0	53503	\N
15293	285	3	0	53521	\N
15293	4496	4	0	53523	\N
15365	324	5	0	54218	\N
15365	4516	6	0	54225	\N
15334	362	2	0	54897	\N
15334	2873	3	0	54899	\N
15214	435	2	0	55084	\N
15214	3413	3	0	55087	\N
15284	1109	2	0	56166	\N
15284	2809	3	0	56167	\N
15122	3625	1	0	59534	\N
15122	4437	2	0	59542	\N
15124	3628	1	0	59648	\N
15124	4438	2	0	59651	\N
15386	251	0	0	1529	\N
15156	1851	3	0	1533	\N
15159	228	3	0	2997	\N
15159	3186	4	0	3000	\N
15378	892	6	0	3061	\N
15378	4520	7	0	3062	\N
15150	4461	5	0	3075	\N
15150	1636	7	0	3091	\N
15150	4462	8	0	3092	\N
15351	2982	3	0	3204	\N
15351	4515	4	0	3205	\N
15196	4475	44	0	3774	\N
15196	262	77	0	3798	\N
15397	35	2	0	4402	\N
15397	1191	3	0	4404	\N
15207	189	3	0	4871	\N
15207	3782	4	0	4874	\N
15205	716	2	0	5290	\N
15205	4478	3	0	5292	\N
15181	373	6	0	5354	\N
15181	4473	7	0	5357	\N
15237	4178	2	0	5544	\N
15237	4247	3	0	5549	\N
15275	4178	4	0	5552	\N
15275	4331	5	0	5553	\N
15279	4211	4	0	5555	\N
15288	4178	5	0	5558	\N
15288	4429	6	0	5559	\N
15337	4178	7	0	5567	\N
15342	4178	3	0	5568	\N
15369	4178	5	0	5570	\N
15342	4211	4	0	5572	\N
15369	4429	6	0	5574	\N
15337	4509	8	0	5575	\N
15403	4450	1	0	5580	\N
15403	4178	4	0	5581	\N
15403	4527	5	0	5582	\N
15189	4474	12	0	8248	\N
15232	4172	3	0	8252	\N
15242	4172	3	0	8253	\N
15232	4275	4	0	8256	\N
15242	4275	4	0	8257	\N
15285	4172	10	0	8261	\N
15285	4494	11	0	8266	\N
15300	4172	0	0	8267	\N
15309	4172	3	0	8271	\N
15309	4275	4	0	8277	\N
15139	391	2	0	10446	\N
15139	1381	3	0	10449	\N
15326	3660	4	0	10466	\N
15362	391	0	0	10474	\N
15130	132	5	0	11288	\N
15130	3831	6	0	11297	\N
15262	300	3	0	12181	\N
15262	3747	4	0	12182	\N
15226	115	3	0	16688	\N
15226	3483	4	0	16690	\N
15172	167	4	0	17701	\N
15305	167	8	0	17705	\N
15172	4048	5	0	17712	\N
15305	4502	9	0	17714	\N
15244	1127	3	0	18112	\N
15277	142	1	0	18604	\N
15277	3117	2	0	18608	\N
15203	4125	3	0	18837	\N
15203	4200	4	0	18838	\N
15234	290	3	0	19036	\N
15234	3635	4	0	19037	\N
15212	62	2	0	19806	\N
15212	2191	3	0	19813	\N
15191	149	2	0	23116	\N
15191	1379	3	0	23117	\N
15267	149	5	0	23131	\N
15260	264	2	0	23595	\N
15260	2780	3	0	23597	\N
15154	214	1	0	24325	\N
15154	1382	2	0	24326	\N
15161	69	1	0	24757	\N
15161	4469	2	0	24762	\N
15223	90	2	0	26099	\N
15223	3442	3	0	26101	\N
15265	90	1	0	26107	\N
15265	344	2	0	26108	\N
15316	90	3	0	26117	\N
15316	4074	4	0	26118	\N
15188	17	2	0	28581	\N
15324	16	3	0	28584	\N
15329	16	7	0	28585	\N
15324	3634	4	0	28586	\N
15329	4504	8	0	28587	\N
15388	320	2	0	29388	\N
15388	1937	3	0	29390	\N
15142	202	1	0	31116	\N
15408	202	4	0	31117	\N
15142	203	2	0	31122	\N
15360	360	2	0	31496	\N
15360	2767	3	0	31497	\N
15163	454	2	0	32767	\N
15198	2	2	0	35592	\N
15198	2789	3	0	35593	\N
15379	4	7	0	35967	\N
15379	4521	8	0	35969	\N
15152	23	0	0	40742	\N
15210	40	3	0	43148	\N
15210	372	4	0	43151	\N
15240	40	2	0	43161	\N
15240	282	3	0	43162	\N
15318	40	2	0	43166	\N
15318	282	3	0	43170	\N
15381	40	6	0	43178	\N
15381	4255	7	0	43179	\N
15243	56	2	0	44191	\N
15243	2795	3	0	44194	\N
15270	75	4	0	46007	\N
15270	2357	5	0	46011	\N
15182	79	3	0	46250	\N
15182	1168	4	0	46251	\N
15215	79	2	0	46302	\N
15215	616	3	0	46303	\N
15299	88	2	0	47192	\N
15371	88	3	0	47193	\N
15299	2799	3	0	47197	\N
15371	3655	4	0	47199	\N
15348	102	1	0	47856	\N
15348	103	2	0	47859	\N
15231	113	3	0	48279	\N
15231	3620	4	0	48281	\N
15287	186	2	0	51288	\N
15287	1850	3	0	51289	\N
15272	268	2	0	52791	\N
15272	2800	3	0	52792	\N
15286	268	10	0	52795	\N
15286	4495	11	0	52796	\N
15364	273	5	0	53002	\N
15364	4503	6	0	53003	\N
15394	279	2	0	53247	\N
15394	4525	3	0	53251	\N
15258	4491	12	0	53346	\N
15256	3421	9	0	53504	\N
15258	3421	9	0	53506	\N
15256	285	11	0	53512	\N
15258	285	11	0	53514	\N
15256	3112	12	0	53515	\N
15166	1109	3	0	56159	\N
15166	3495	4	0	56160	\N
15280	793	3	0	56725	\N
15417	793	3	0	56726	\N
15280	2644	4	0	56731	\N
15417	2644	4	0	56732	\N
15248	841	7	0	57105	\N
15248	4489	8	0	57106	\N
15251	841	2	0	57111	\N
15251	3316	3	0	57112	\N
15282	1470	1	0	58211	\N
15282	1471	2	0	58212	\N
15177	2782	3	0	59325	\N
15177	3659	4	0	59327	\N
15302	4498	5	0	59479	\N
15218	3625	5	0	59535	\N
15218	4481	6	0	59551	\N
15220	3628	5	0	59649	\N
15220	4483	6	0	59658	\N
15179	4233	3	0	59954	\N
15179	4425	4	0	59958	\N
15233	3186	4	0	3001	\N
15246	615	3	0	4630	\N
15204	716	3	0	5289	\N
15204	4477	4	0	5294	\N
15184	4178	3	0	5537	\N
15184	4441	4	0	5541	\N
15266	4178	1	0	5545	\N
15273	4178	8	0	5546	\N
15266	4450	2	0	5547	\N
15273	4237	9	0	5551	\N
15283	4178	3	0	5556	\N
15283	4211	4	0	5557	\N
15292	4178	3	0	5560	\N
15328	4178	2	0	5566	\N
15366	4178	5	0	5569	\N
15328	4247	3	0	5571	\N
15366	4429	6	0	5573	\N
15383	4178	2	0	5576	\N
15383	4247	3	0	5577	\N
15192	4172	2	0	8245	\N
15192	4191	3	0	8246	\N
15199	4172	3	0	8249	\N
15201	4172	2	0	8250	\N
15208	4172	4	0	8251	\N
15201	4191	3	0	8254	\N
15208	4252	5	0	8258	\N
15261	4172	3	0	8259	\N
15289	4172	2	0	8262	\N
15289	4191	3	0	8263	\N
15261	4275	4	0	8264	\N
15405	4172	1	0	8278	\N
15405	4201	2	0	8279	\N
15313	391	3	0	10463	\N
15313	3660	4	0	10465	\N
15255	132	4	0	11289	\N
15255	3293	5	0	11293	\N
15276	528	4	0	12523	\N
15290	77	3	0	13150	\N
15290	1877	4	0	13151	\N
15355	233	0	0	13771	\N
15245	402	5	0	14110	\N
15245	4487	6	0	14111	\N
15295	402	2	0	14118	\N
15295	2760	3	0	14119	\N
15253	258	4	0	14463	\N
15253	2725	5	0	14466	\N
15339	44	7	0	16125	\N
15339	4511	8	0	16126	\N
15400	38	2	0	16409	\N
15344	212	2	0	17192	\N
15344	3616	3	0	17194	\N
15302	4499	5	1	17590	\N
15194	167	3	0	17702	\N
15302	167	4	0	17703	\N
15194	4028	4	0	17711	\N
15294	30	3	0	18114	\N
15294	3640	4	0	18115	\N
15278	142	3	0	18605	\N
15278	4254	4	0	18610	\N
15258	3108	12	1	18791	\N
15249	208	3	0	19181	\N
15375	62	1	0	19807	\N
15375	63	2	0	19812	\N
15323	64	1	0	20720	\N
15323	65	2	0	20721	\N
15297	336	2	0	22779	\N
15331	82	3	0	23850	\N
15331	4505	4	0	23851	\N
15346	70	1	0	24750	\N
15346	69	4	0	24760	\N
15346	2920	5	0	24761	\N
15321	411	3	0	25280	\N
15321	3596	4	0	25281	\N
15222	3442	3	0	26100	\N
15224	244	2	0	27293	\N
15224	3308	3	0	27295	\N
15308	42	1	0	27566	\N
15308	43	2	0	27567	\N
15373	42	1	0	27581	\N
15373	43	2	0	27582	\N
15259	16	2	0	28582	\N
15259	388	3	0	28583	\N
15263	20	3	0	30479	\N
15263	2844	4	0	30480	\N
15268	33	5	0	31800	\N
15392	4	2	0	35980	\N
15392	2751	3	0	35981	\N
15465	40	0	0	43168	\N
15466	40	0	0	43169	\N
15406	40	6	0	43182	\N
15406	4255	7	0	43183	\N
15435	40	4	0	43189	\N
15435	2796	5	0	43191	\N
15340	56	7	0	44203	\N
15340	4512	8	0	44205	\N
15512	80	1	0	46407	\N
15512	79	6	0	46450	\N
15512	2758	7	0	46453	\N
15349	102	1	0	47857	\N
15317	113	2	0	48288	\N
15317	1899	3	0	48290	\N
15450	121	0	0	48972	\N
15517	121	4	0	48977	\N
15517	4099	5	0	48978	\N
15444	210	2	0	51873	\N
15444	1874	3	0	51876	\N
15510	242	2	0	52135	\N
15510	3425	3	0	52140	\N
15399	273	2	0	53007	\N
15399	1413	3	0	53008	\N
15409	316	4	0	54024	\N
15409	4531	5	0	54026	\N
15418	435	3	0	55086	\N
15418	3504	4	0	55088	\N
15372	1109	3	0	56176	\N
15372	3495	4	0	56177	\N
15374	2636	1	0	58797	\N
15376	2636	0	0	58798	\N
15374	3980	2	0	58801	\N
15413	2351	4	0	58993	\N
15413	4534	5	0	58995	\N
15473	3625	2	0	59536	\N
15332	4088	3	0	59824	\N
15429	4088	2	0	59826	\N
15429	4332	3	0	59831	\N
15332	4506	4	0	59832	\N
15384	251	0	0	1509	\N
15493	1610	5	0	1535	\N
15514	3100	7	0	2375	\N
15514	111	1	0	2553	\N
15514	110	6	0	2569	\N
15367	2982	5	0	3207	\N
15367	4517	6	0	3211	\N
15438	262	5	0	3792	\N
15440	262	28	0	3793	\N
15438	4539	6	0	3796	\N
15440	4541	29	0	3797	\N
15532	189	3	0	4896	\N
15532	3782	4	0	4899	\N
15306	4237	9	0	5565	\N
15415	4178	3	0	5583	\N
15415	4211	4	0	5584	\N
15416	4178	3	0	5585	\N
15431	4178	3	0	5586	\N
15447	4178	7	0	5589	\N
15416	4211	4	0	5590	\N
15431	4211	4	0	5591	\N
15447	4509	8	0	5594	\N
15470	4178	2	0	5598	\N
15470	4247	3	0	5599	\N
15537	4178	6	0	5608	\N
15303	4172	8	0	8268	\N
15303	4500	9	0	8270	\N
15411	4172	2	0	8280	\N
15411	4191	3	0	8281	\N
15432	4172	7	0	8282	\N
15432	4537	8	0	8283	\N
15442	4172	2	0	8284	\N
15442	4191	3	0	8286	\N
15468	4172	1	0	8292	\N
15468	4201	2	0	8294	\N
15448	528	3	0	12533	\N
15457	528	2	0	12534	\N
15448	4262	4	0	12536	\N
15482	77	3	0	13159	\N
15482	1877	4	0	13160	\N
15330	233	3	0	13769	\N
15354	233	0	0	13770	\N
15356	233	3	0	13772	\N
15330	3704	4	0	13775	\N
15356	3704	4	0	13776	\N
15427	233	2	0	13780	\N
15427	1849	3	0	13782	\N
15540	402	3	0	14130	\N
15540	4077	4	0	14131	\N
15407	4529	5	0	16423	\N
15459	167	2	0	17706	\N
15459	3322	3	0	17710	\N
15461	4545	16	0	17716	\N
15461	167	126	0	17727	\N
15461	4546	127	0	17728	\N
15520	4555	0	0	18278	\N
15322	142	1	0	18606	\N
15322	143	2	0	18609	\N
15393	208	2	0	19182	\N
15393	4524	3	0	19192	\N
15391	60	3	0	19444	\N
15471	198	3	0	20116	\N
15471	4263	4	0	20117	\N
15463	67	3	0	22148	\N
15463	3749	4	0	22150	\N
15297	3332	3	0	22782	\N
15460	149	2	0	23132	\N
15460	1379	3	0	23133	\N
15319	82	2	0	23844	\N
15319	3401	3	0	23845	\N
15423	69	3	0	24787	\N
15423	4536	4	0	24790	\N
15327	411	2	0	25287	\N
15345	94	2	0	26915	\N
15477	94	5	0	26916	\N
15345	2794	3	0	26917	\N
15477	4547	6	0	26918	\N
15514	438	7	1	27446	\N
15545	42	3	0	27615	\N
15358	16	2	0	28588	\N
15358	388	3	0	28589	\N
15425	16	2	0	28590	\N
15425	388	3	0	28591	\N
15500	16	3	0	28592	\N
15500	3634	4	0	28593	\N
15404	334	1	0	29387	\N
15404	320	4	0	29389	\N
15404	4528	5	0	29391	\N
15420	54	2	0	30150	\N
15420	3351	3	0	30153	\N
15452	202	7	0	31118	\N
15454	202	7	0	31119	\N
15452	4543	8	0	31125	\N
15454	4543	8	0	31126	\N
15520	4556	0	0	31492	\N
15347	26	1	0	35594	\N
15307	2	1	0	35599	\N
15307	26	2	0	35603	\N
15347	2	4	0	35604	\N
15347	2990	5	0	35606	\N
15497	4550	7	0	35608	\N
15395	4	1	0	35982	\N
15395	3114	2	0	35983	\N
15433	18	7	0	40073	\N
15433	4538	8	0	40077	\N
15402	28	1	0	41195	\N
15402	27	4	0	41217	\N
15402	3164	5	0	41219	\N
15464	40	0	0	43167	\N
15426	40	2	0	43188	\N
15426	282	3	0	43190	\N
15578	40	3	0	43195	\N
15578	1921	4	0	43196	\N
15614	40	2	0	43201	\N
15614	282	3	0	43205	\N
15562	79	0	0	46518	\N
15563	79	1	0	46519	\N
15563	81	2	0	46521	\N
15550	88	2	0	47194	\N
15550	2799	3	0	47198	\N
15579	100	3	0	47610	\N
15595	100	2	0	47611	\N
15595	2918	3	0	47613	\N
15579	250	4	0	47616	\N
15704	102	6	0	47867	\N
15706	102	9	0	47868	\N
15704	4599	7	0	47876	\N
15706	4601	10	0	47877	\N
15610	113	3	0	48289	\N
15610	3620	4	0	48291	\N
15507	119	2	0	48710	\N
15507	1879	3	0	48717	\N
15428	125	2	0	49271	\N
15428	3297	3	0	49272	\N
15421	156	2	0	50242	\N
15421	4485	3	0	50243	\N
15593	170	2	0	50591	\N
15671	170	7	0	50592	\N
15593	2986	3	0	50593	\N
15671	4591	8	0	50595	\N
15698	181	4	0	50924	\N
15698	4058	5	0	50927	\N
15664	285	4	0	53522	\N
15664	3674	5	0	53524	\N
15546	316	9	0	54025	\N
15546	4561	10	0	54027	\N
15700	325	1	0	54194	\N
15700	324	3	0	54219	\N
15678	597	4	0	55946	\N
15678	3733	5	0	55952	\N
15419	1109	4	0	56196	\N
15419	4535	5	0	56197	\N
15494	1109	6	0	56209	\N
15494	4548	7	0	56210	\N
15584	793	2	0	56727	\N
15584	4363	3	0	56730	\N
15565	2782	1	0	59340	\N
15565	3873	2	0	59341	\N
15644	2782	4	0	59346	\N
15684	2782	2	0	59347	\N
15684	2784	3	0	59350	\N
15644	3872	5	0	59353	\N
15573	3625	1	0	59539	\N
15573	4437	2	0	59543	\N
15575	3628	1	0	59669	\N
15575	4438	2	0	59671	\N
15582	13	2	0	383	\N
15646	3248	4	0	1053	\N
15646	4585	5	0	1054	\N
15539	266	4	0	1285	\N
15539	2824	5	0	1286	\N
15513	111	1	0	2552	\N
15570	110	1	0	2564	\N
15570	134	2	0	2566	\N
15513	110	6	0	2568	\N
15513	4552	7	0	2570	\N
15702	4596	1	0	3206	\N
15702	2982	8	0	3209	\N
15702	4597	9	0	3212	\N
15682	3839	4	0	4638	\N
15571	189	2	0	4897	\N
15571	3441	3	0	4898	\N
15637	189	4	0	4908	\N
15637	3992	5	0	4911	\N
15436	4178	4	0	5587	\N
15436	4331	5	0	5592	\N
15511	4178	1	0	5603	\N
15511	4460	2	0	5604	\N
15587	4178	4	0	5612	\N
15587	4331	5	0	5615	\N
15602	4178	2	0	5616	\N
15619	4178	2	0	5623	\N
15619	4247	3	0	5625	\N
15721	4178	3	0	5628	\N
15721	4211	4	0	5629	\N
15453	4172	7	0	8288	\N
15453	4537	8	0	8289	\N
15462	4172	3	0	8290	\N
15462	4275	4	0	8291	\N
15531	4172	3	0	8299	\N
15531	4275	4	0	8300	\N
15724	391	3	0	10485	\N
15586	132	4	0	11292	\N
15430	3747	4	0	12188	\N
15445	528	5	0	12524	\N
15445	4542	6	0	12526	\N
15661	123	4	0	12838	\N
15661	4090	5	0	12839	\N
15635	233	4	0	13792	\N
15639	233	17	0	13793	\N
15635	3775	5	0	13794	\N
15639	4583	18	0	13795	\N
15700	796	4	0	14012	\N
15716	173	4	0	14699	\N
15716	3614	5	0	14701	\N
15592	4574	5	0	17206	\N
15617	212	5	0	17211	\N
15617	4580	6	0	17212	\N
15612	326	3	0	17429	\N
15612	3339	4	0	17432	\N
15693	149	3	0	23144	\N
15693	4189	4	0	23145	\N
15687	264	3	0	23606	\N
15687	3632	4	0	23607	\N
15624	140	4	0	24037	\N
15624	3821	5	0	24042	\N
15567	90	2	0	26137	\N
15545	3645	4	0	27616	\N
15673	3846	7	0	29412	\N
15673	4593	8	0	29413	\N
15455	202	7	0	31120	\N
15408	4530	5	0	31124	\N
15455	4543	8	0	31127	\N
15495	230	6	0	32195	\N
15495	4549	7	0	32197	\N
15518	230	2	0	32208	\N
15518	3307	3	0	32209	\N
15410	453	4	0	32775	\N
15410	4532	5	0	32776	\N
15474	2789	3	0	35605	\N
15528	2	2	0	35613	\N
15528	2789	3	0	35614	\N
15412	4	4	0	35991	\N
15412	4533	5	0	36001	\N
15414	4	2	0	36002	\N
15414	579	3	0	36003	\N
15469	18	3	0	40074	\N
15469	3621	4	0	40076	\N
15483	18	2	0	40078	\N
15483	1685	3	0	40079	\N
15633	18	3	0	40083	\N
15554	23	5	0	40743	\N
15554	4564	6	0	40744	\N
15600	217	1	0	40746	\N
15600	23	3	0	40758	\N
15600	1089	4	0	40760	\N
15609	40	3	0	43200	\N
15609	372	4	0	43206	\N
15502	56	3	0	44206	\N
15611	56	3	0	44208	\N
15502	4109	4	0	44211	\N
15611	4109	4	0	44212	\N
15697	56	4	0	44214	\N
15697	3127	5	0	44215	\N
15422	75	2	0	46013	\N
15422	284	3	0	46014	\N
15699	75	4	0	46020	\N
15773	75	10	0	46021	\N
15699	3959	5	0	46023	\N
15773	4628	11	0	46024	\N
15434	79	5	0	46357	\N
15434	3341	6	0	46360	\N
15656	100	3	0	47622	\N
15656	3836	4	0	47625	\N
15749	102	14	0	47869	\N
15749	4619	15	0	47878	\N
15472	119	2	0	48693	\N
15472	1879	3	0	48696	\N
15695	135	3	0	49552	\N
15695	3630	4	0	49563	\N
15680	147	4	0	50014	\N
15680	3877	5	0	50034	\N
15675	156	3	0	50240	\N
15675	4594	4	0	50241	\N
15616	186	2	0	51305	\N
15616	1850	3	0	51306	\N
15524	210	6	0	51874	\N
15524	4558	7	0	51877	\N
15738	210	3	0	51897	\N
15738	4612	4	0	51901	\N
15548	242	5	0	52136	\N
15597	242	2	0	52137	\N
15597	4576	3	0	52138	\N
15548	4562	6	0	52142	\N
15516	4553	3	0	52568	\N
15443	268	2	0	52800	\N
15443	2800	3	0	52802	\N
15467	273	4	0	53015	\N
15467	3390	5	0	53016	\N
15456	353	2	0	54610	\N
15456	2884	3	0	54615	\N
15606	362	2	0	54901	\N
15606	2873	3	0	54903	\N
15777	451	8	0	55256	\N
15777	4631	9	0	55257	\N
15751	1109	7	0	56234	\N
15751	4145	8	0	56235	\N
15730	1021	3	0	56414	\N
15730	4551	4	0	56419	\N
15631	1470	3	0	58220	\N
15631	3838	4	0	58224	\N
15688	2782	3	0	59348	\N
15688	3659	4	0	59351	\N
15505	3625	0	0	59537	\N
15621	4088	4	0	59827	\N
15621	4089	5	0	59835	\N
15718	4606	11	0	60243	\N
15686	3003	4	0	185	\N
15490	117	0	0	2259	\N
15492	117	0	0	2261	\N
15439	189	5	0	4872	\N
15439	4540	6	0	4875	\N
15481	189	4	0	4887	\N
15481	3436	5	0	4888	\N
15437	4178	5	0	5588	\N
15437	4429	6	0	5593	\N
15449	4178	3	0	5595	\N
15449	4211	4	0	5596	\N
15451	4178	0	0	5597	\N
15476	4178	2	0	5600	\N
15733	4178	3	0	5634	\N
15733	4211	4	0	5635	\N
15743	4178	3	0	5636	\N
15743	4211	4	0	5638	\N
15446	4172	2	0	8285	\N
15446	4191	3	0	8287	\N
15484	4172	3	0	8293	\N
15484	4275	4	0	8295	\N
15519	4172	3	0	8296	\N
15519	4275	4	0	8297	\N
15522	4172	6	0	8298	\N
15522	4537	7	0	8301	\N
15542	4252	5	0	8304	\N
15551	4201	1	0	8306	\N
15551	4172	9	0	8307	\N
15723	4172	3	0	8321	\N
15723	4275	4	0	8323	\N
15764	4172	3	0	8327	\N
15764	4275	4	0	8328	\N
15756	391	6	0	10495	\N
15756	3521	7	0	10496	\N
15544	132	4	0	11291	\N
15544	3293	5	0	11294	\N
15586	3293	5	0	11295	\N
15711	2934	2	0	13171	\N
15441	58	2	0	13526	\N
15441	2853	3	0	13527	\N
15736	4610	8	0	14467	\N
15736	258	12	0	14472	\N
15736	4611	13	0	14473	\N
15479	173	4	0	14697	\N
15479	3857	5	0	14702	\N
15677	192	4	0	15296	\N
15677	3895	5	0	15299	\N
15589	38	6	0	16416	\N
15589	3276	7	0	16424	\N
15551	4383	11	0	18755	\N
15458	60	2	0	19451	\N
15458	4544	3	0	19452	\N
15509	164	2	0	21105	\N
15509	1124	3	0	21107	\N
15735	488	3	0	21493	\N
15735	1103	4	0	21494	\N
15628	440	3	0	21742	\N
15628	4581	4	0	21749	\N
15769	67	3	0	22164	\N
15769	3749	4	0	22165	\N
15708	336	3	0	22780	\N
15526	82	2	0	23853	\N
15526	3401	3	0	23857	\N
15534	224	5	0	25544	\N
15534	4419	6	0	25546	\N
15641	206	3	0	25941	\N
15641	4584	4	0	25942	\N
15424	90	3	0	26126	\N
15424	4074	4	0	26127	\N
15496	42	6	0	27597	\N
15496	4334	7	0	27600	\N
15779	16	3	0	28600	\N
15779	3634	4	0	28601	\N
15651	2803	4	0	29650	\N
15536	360	6	0	31515	\N
15536	4560	7	0	31516	\N
15529	322	7	0	32477	\N
15529	4486	8	0	32478	\N
15591	322	6	0	32481	\N
15591	2793	7	0	32482	\N
15648	453	4	0	32784	\N
15648	4108	5	0	32789	\N
15604	2	2	0	35625	\N
15604	2789	3	0	35626	\N
15626	14	3	0	39174	\N
15553	18	1	0	40080	\N
15553	19	2	0	40084	\N
15541	40	4	0	43194	\N
15541	2796	5	0	43197	\N
15696	40	4	0	43202	\N
15642	51	2	0	43562	\N
15642	1260	3	0	43565	\N
15583	56	1	0	44207	\N
15654	56	4	0	44209	\N
15583	57	2	0	44210	\N
15654	3127	5	0	44213	\N
15527	75	2	0	46015	\N
15576	75	1	0	46016	\N
15576	76	2	0	46017	\N
15527	284	3	0	46018	\N
15669	75	4	0	46019	\N
15669	3959	5	0	46022	\N
15504	79	8	0	46405	\N
15504	4238	9	0	46406	\N
15515	80	1	0	46408	\N
15515	79	5	0	46451	\N
15515	3652	6	0	46452	\N
15574	119	1	0	48711	\N
15574	120	2	0	48716	\N
15549	186	2	0	51295	\N
15549	1850	3	0	51296	\N
15689	186	5	0	51317	\N
15689	3280	6	0	51322	\N
15559	4568	16	0	51619	\N
15559	200	126	0	51630	\N
15559	4569	127	0	51631	\N
15552	210	1	0	51886	\N
15552	211	2	0	51887	\N
15603	210	2	0	51896	\N
15603	1874	3	0	51899	\N
15598	242	2	0	52149	\N
15598	3425	3	0	52150	\N
15649	242	4	0	52160	\N
15649	3512	5	0	52161	\N
15672	242	7	0	52167	\N
15672	4592	8	0	52169	\N
15516	4554	4	0	52569	\N
15657	260	7	0	52570	\N
15657	4589	8	0	52571	\N
15640	316	3	0	54034	\N
15640	4249	4	0	54037	\N
15676	595	4	0	55706	\N
15676	3878	5	0	55709	\N
15499	1021	3	0	56412	\N
15629	1021	3	0	56413	\N
15499	4551	4	0	56417	\N
15629	4551	4	0	56418	\N
15506	3625	0	0	59538	\N
15473	4359	3	0	59546	\N
15475	3628	2	0	59667	\N
15508	3628	2	0	59668	\N
15475	4360	3	0	59672	\N
15508	4360	3	0	59673	\N
15485	3611	4	0	913	\N
15491	117	0	0	2260	\N
15489	248	2	0	2262	\N
15572	117	2	0	2263	\N
15572	4571	3	0	2264	\N
15620	262	2	0	3794	\N
15620	2743	3	0	3795	\N
15538	35	2	0	4403	\N
15538	1191	3	0	4405	\N
15478	4178	5	0	5601	\N
15480	4178	4	0	5602	\N
15480	4331	5	0	5606	\N
15478	4429	6	0	5607	\N
15561	4570	7	0	5611	\N
15588	4178	2	0	5613	\N
15588	4247	3	0	5614	\N
15607	4178	2	0	5618	\N
15608	4178	7	0	5619	\N
15607	4247	3	0	5620	\N
15608	4509	8	0	5621	\N
15547	4172	5	0	8303	\N
15547	4415	6	0	8305	\N
15551	4563	10	0	8308	\N
15594	4172	2	0	8310	\N
15594	4285	3	0	8312	\N
15647	4197	7	0	8317	\N
15652	4172	3	0	8318	\N
15652	4275	4	0	8319	\N
15530	132	7	0	11290	\N
15530	4559	8	0	11298	\N
15580	300	7	0	12203	\N
15580	4572	8	0	12204	\N
15585	123	2	0	12832	\N
15585	1868	3	0	12833	\N
15622	233	4	0	13781	\N
15622	3775	5	0	13783	\N
15590	173	6	0	14698	\N
15564	192	1	0	15295	\N
15564	193	2	0	15298	\N
15535	4555	0	0	18279	\N
15525	198	2	0	20124	\N
15525	513	3	0	20125	\N
15558	241	6	0	20418	\N
15558	4567	7	0	20419	\N
15627	440	0	0	21741	\N
15691	67	7	0	22149	\N
15691	3608	8	0	22151	\N
15577	73	1	0	22595	\N
15577	74	2	0	22596	\N
15569	1748	4	0	23598	\N
15605	69	2	0	24788	\N
15605	3350	3	0	24789	\N
15523	411	6	0	25298	\N
15523	4557	7	0	25301	\N
15533	224	0	0	25543	\N
15560	224	6	0	25554	\N
15560	1707	7	0	25566	\N
15487	86	3	0	26588	\N
15543	86	4	0	26589	\N
15487	3746	4	0	26590	\N
15543	2576	5	0	26591	\N
15568	375	4	0	26923	\N
15503	42	1	0	27598	\N
15503	43	2	0	27599	\N
15566	42	2	0	27623	\N
15566	681	3	0	27624	\N
15665	42	6	0	27629	\N
15674	42	3	0	27630	\N
15674	3645	4	0	27633	\N
15665	1090	7	0	27635	\N
15659	16	3	0	28594	\N
15659	3634	4	0	28595	\N
15662	16	6	0	28596	\N
15596	3846	2	0	29410	\N
15596	4575	3	0	29411	\N
15535	4556	0	0	31506	\N
15521	360	4	0	31507	\N
15521	4330	5	0	31508	\N
15667	453	6	0	32785	\N
15667	4091	7	0	32790	\N
15501	2	3	0	35602	\N
15501	3548	4	0	35607	\N
15581	2	1	0	35621	\N
15581	26	2	0	35622	\N
15556	14	6	0	39173	\N
15555	18	5	0	40081	\N
15557	18	6	0	40082	\N
15555	3550	6	0	40086	\N
15557	4566	7	0	40087	\N
15599	217	1	0	40745	\N
15599	23	3	0	40757	\N
15599	1089	4	0	40759	\N
15734	40	3	0	43203	\N
15734	372	4	0	43207	\N
15696	3381	5	0	43208	\N
15710	56	10	0	44216	\N
15710	4602	11	0	44217	\N
15760	71	4	0	44849	\N
15760	3887	5	0	44852	\N
15636	88	4	0	47195	\N
15636	3809	5	0	47201	\N
15615	100	2	0	47612	\N
15615	633	3	0	47614	\N
15744	113	4	0	48308	\N
15744	3677	5	0	48309	\N
15694	137	3	0	49799	\N
15694	3633	4	0	49800	\N
15815	147	14	0	50015	\N
15815	4641	15	0	50040	\N
15690	186	7	0	51318	\N
15690	4595	8	0	51326	\N
15778	200	1	0	51626	\N
15801	200	3	0	51627	\N
15778	201	2	0	51628	\N
15801	2565	4	0	51629	\N
15717	4603	16	0	51632	\N
15717	200	126	0	51648	\N
15717	4604	127	0	51649	\N
15739	210	2	0	51898	\N
15739	1173	3	0	51900	\N
15765	210	4	0	51913	\N
15765	3536	5	0	51914	\N
15701	325	1	0	54195	\N
15703	325	1	0	54196	\N
15701	324	6	0	54220	\N
15703	324	8	0	54221	\N
15701	3500	7	0	54226	\N
15703	4598	9	0	54227	\N
15821	4647	7	0	54620	\N
15828	4647	7	0	54622	\N
15821	353	20	0	54631	\N
15828	353	20	0	54633	\N
15828	4653	21	0	54635	\N
15821	4648	21	0	54636	\N
15811	597	11	0	55947	\N
15811	4637	12	0	55956	\N
15714	1109	3	0	56224	\N
15714	3495	4	0	56225	\N
15658	793	7	0	56728	\N
15658	4590	8	0	56734	\N
15681	908	3	0	57702	\N
15681	3591	4	0	57706	\N
15653	4587	3	0	57833	\N
15601	4577	2	0	59785	\N
15601	4014	3	1	59794	\N
15634	4088	4	0	59828	\N
15634	4089	5	0	59836	\N
15719	4606	11	0	60244	\N
15668	4085	7	0	182	\N
15776	4630	9	0	1087	\N
15707	228	3	0	2999	\N
15707	3186	4	0	3002	\N
15796	4635	6	0	3389	\N
15796	367	17	0	3412	\N
15796	368	18	0	3413	\N
15727	262	4	0	3806	\N
15618	4178	5	0	5622	\N
15625	4178	4	0	5624	\N
15625	4205	5	0	5626	\N
15618	4429	6	0	5627	\N
15725	4178	3	0	5630	\N
15725	4211	4	0	5632	\N
15726	4205	5	0	5633	\N
15834	4178	7	0	5646	\N
15834	4659	8	0	5647	\N
15601	4579	3	0	8145	\N
15601	4578	2	0	8309	\N
15613	4172	2	0	8311	\N
15613	4191	3	0	8313	\N
15645	4172	4	0	8314	\N
15645	4219	5	0	8316	\N
15666	4172	6	0	8320	\N
15666	4197	7	0	8324	\N
15660	3660	4	0	10477	\N
15679	391	4	0	10484	\N
15679	3913	5	0	10487	\N
15785	391	6	0	10501	\N
15785	3521	7	0	10502	\N
15712	77	3	0	13169	\N
15712	1877	4	0	13172	\N
15683	58	3	0	13534	\N
15683	3665	4	0	13540	\N
15720	402	3	0	14151	\N
15720	4077	4	0	14152	\N
15838	115	2	0	16704	\N
15826	4654	7	0	17424	\N
15763	326	3	0	17430	\N
15763	3339	4	0	17433	\N
15826	326	20	0	17435	\N
15826	4655	21	0	17436	\N
15821	4649	21	1	17680	\N
15643	290	2	0	19042	\N
15643	1909	3	0	19045	\N
15685	62	3	0	19808	\N
15685	3344	4	0	19814	\N
15655	198	3	0	20140	\N
15655	4263	4	0	20141	\N
15638	241	4	0	20430	\N
15638	4582	5	0	20431	\N
15650	241	7	0	20432	\N
15650	3094	8	0	20433	\N
15770	164	5	0	21118	\N
15770	4626	6	0	21119	\N
15623	73	6	0	22605	\N
15623	4257	7	0	22606	\N
15709	336	0	0	22781	\N
15692	149	0	0	23143	\N
15630	224	3	0	25555	\N
15630	3603	4	0	25559	\N
15722	4584	4	0	25948	\N
15731	244	7	0	27294	\N
15731	4608	8	0	27296	\N
15705	16	6	0	28598	\N
15705	4600	7	0	28599	\N
15830	16	5	0	28602	\N
15830	3455	6	0	28603	\N
15653	4588	3	0	29646	\N
15653	2803	4	0	29649	\N
15758	54	3	0	30151	\N
15758	3041	4	0	30154	\N
15793	202	4	0	31134	\N
15791	33	3	0	31820	\N
15791	3342	4	0	31821	\N
15632	230	3	0	32220	\N
15632	4181	4	0	32222	\N
15670	453	6	0	32786	\N
15670	4091	7	0	32791	\N
15715	2	4	0	35629	\N
15715	3510	5	0	35630	\N
15713	14	3	0	39184	\N
15742	14	3	0	39185	\N
15713	4272	4	0	39186	\N
15742	4272	4	0	39187	\N
15663	3621	4	0	40089	\N
15832	18	5	0	40094	\N
15832	3964	6	0	40097	\N
15804	27	3	0	41216	\N
15804	4636	4	0	41220	\N
15806	27	3	0	41238	\N
15806	4636	4	0	41240	\N
15782	40	4	0	43204	\N
15782	3381	5	0	43209	\N
15794	40	6	0	43214	\N
15794	4255	7	0	43215	\N
15737	4150	8	0	44218	\N
15842	56	4	0	44219	\N
15842	3127	5	0	44222	\N
15737	56	12	0	44223	\N
15737	4102	13	0	44224	\N
15797	71	3	0	44850	\N
15797	3770	4	0	44851	\N
15784	75	3	0	46025	\N
15819	75	5	0	46026	\N
15784	3855	4	0	46028	\N
15819	4645	6	0	46029	\N
15759	268	4	0	52801	\N
15759	3897	5	0	52803	\N
15810	285	0	0	53531	\N
15814	285	14	0	53532	\N
15816	285	11	0	53533	\N
15816	4642	12	0	53538	\N
15814	4640	15	0	53539	\N
15813	353	14	0	54611	\N
15813	4639	15	0	54619	\N
15825	4647	7	0	54621	\N
15825	353	20	0	54632	\N
15825	4653	21	0	54634	\N
15812	595	14	0	55707	\N
15812	4638	15	0	55711	\N
15839	841	3	0	57119	\N
15839	3604	4	0	57120	\N
15817	2578	19	0	58601	\N
15817	4643	20	0	58604	\N
15843	424	4	0	912	\N
15748	4618	15	0	917	\N
15772	266	10	0	1289	\N
15789	266	3	0	1290	\N
15789	4633	4	0	1299	\N
15772	4627	11	0	1301	\N
15774	117	3	0	2265	\N
15775	117	8	0	2266	\N
15774	3653	4	0	2267	\N
15775	4629	9	0	2268	\N
15762	1722	3	0	2277	\N
15762	4623	4	0	2278	\N
15753	110	7	0	2581	\N
15753	4621	8	0	2594	\N
15755	3710	9	0	2595	\N
15799	1858	3	0	3021	\N
15799	4273	4	0	3026	\N
15727	4607	5	0	3809	\N
15754	4178	7	0	5637	\N
15754	4396	8	0	5639	\N
15768	4178	7	0	5640	\N
15795	4178	4	0	5641	\N
15795	4205	5	0	5642	\N
15768	4509	8	0	5643	\N
15805	4178	5	0	5644	\N
15741	4172	7	0	8322	\N
15741	4614	8	0	8325	\N
15752	4172	7	0	8326	\N
15752	4614	8	0	8329	\N
15781	4172	3	0	8330	\N
15781	4275	4	0	8331	\N
15786	4172	4	0	8332	\N
15786	4219	5	0	8333	\N
15790	4172	5	0	8334	\N
15790	4634	6	0	8335	\N
15798	4172	3	0	8336	\N
15802	4172	5	0	8337	\N
15802	4634	6	0	8339	\N
15818	4172	5	0	8340	\N
15818	4644	6	0	8341	\N
15820	4172	13	0	8342	\N
15820	4646	14	0	8343	\N
15829	4172	5	0	8344	\N
15829	4644	6	0	8348	\N
15724	3660	4	0	10486	\N
15746	77	7	0	13170	\N
15746	4616	8	0	13173	\N
15745	77	4	0	13180	\N
15745	4615	5	0	13183	\N
15757	4401	4	0	14489	\N
15792	173	4	0	14715	\N
15792	3614	5	0	14717	\N
15729	192	3	0	15315	\N
15729	3790	4	0	15316	\N
15728	115	3	0	16698	\N
15728	3483	4	0	16699	\N
15840	115	3	0	16705	\N
15840	3483	4	0	16708	\N
15822	4650	7	0	17213	\N
15824	4650	7	0	17214	\N
15822	212	20	0	17221	\N
15822	4651	21	0	17223	\N
15824	4651	21	0	17224	\N
15827	4649	21	1	17951	\N
15747	177	7	0	18336	\N
15747	4617	8	0	18339	\N
15740	60	7	0	19459	\N
15740	4613	8	0	19462	\N
15783	241	4	0	20440	\N
15783	4582	5	0	20443	\N
15771	164	3	0	21126	\N
15771	3385	4	0	21127	\N
15844	164	4	0	21138	\N
15761	4622	10	0	22620	\N
15808	149	9	0	23150	\N
15809	149	4	0	23151	\N
15809	4040	5	0	23152	\N
15808	2963	10	0	23153	\N
15835	264	6	0	23620	\N
15835	4660	7	0	23621	\N
15766	140	7	0	24038	\N
15841	140	4	0	24039	\N
15841	3821	5	0	24043	\N
15766	4624	8	0	24045	\N
15800	69	3	0	24798	\N
15831	94	5	0	26921	\N
15831	4657	6	0	26924	\N
15750	244	14	0	27305	\N
15750	4620	15	0	27306	\N
15836	16	17	0	28604	\N
15836	4661	18	0	28605	\N
15732	202	8	0	31121	\N
15732	4609	9	0	31123	\N
15780	360	3	0	31532	\N
15780	3602	4	0	31534	\N
15837	14	3	0	39203	\N
15837	4272	4	0	39205	\N
15788	18	5	0	40090	\N
15788	3550	6	0	40091	\N
15827	2506	7	0	40093	\N
15827	18	20	0	40098	\N
15767	23	7	0	40765	\N
15767	4625	8	0	40766	\N
15787	23	6	0	40777	\N
15787	4632	7	0	40778	\N
15803	27	2	0	41215	\N
15803	645	3	0	41218	\N
15807	27	4	0	41239	\N
15807	3717	5	0	41241	\N
15833	40	7	0	41691	\N
15833	4658	8	0	41694	\N
15823	40	20	0	41695	\N
15823	4652	21	0	41696	\N
15847	51	10	0	43569	\N
15847	4662	11	0	43572	\N
15856	56	3	0	44220	\N
15856	4109	4	0	44221	\N
15925	56	3	0	44225	\N
15925	4109	4	0	44226	\N
15895	75	9	0	46027	\N
15895	4685	10	0	46030	\N
15949	75	6	0	46032	\N
15949	4694	7	0	46034	\N
15869	79	3	0	46520	\N
15869	3652	4	0	46522	\N
15901	79	6	0	46566	\N
15901	4253	7	0	46578	\N
15911	88	3	0	47196	\N
15911	3655	4	0	47200	\N
15930	88	9	0	47206	\N
15930	4692	10	0	47207	\N
15891	100	4	0	47623	\N
15891	3776	5	0	47627	\N
15904	4686	6	0	48979	\N
15905	4686	6	0	48980	\N
15907	4686	6	0	48981	\N
15904	121	7	0	49002	\N
15905	121	7	0	49003	\N
15907	121	7	0	49004	\N
15851	135	4	0	49553	\N
15851	4666	5	0	49573	\N
15853	137	4	0	49815	\N
15853	4668	5	0	49818	\N
15860	156	7	0	50252	\N
15860	4672	8	0	50253	\N
15875	170	4	0	50610	\N
15875	4680	5	0	50611	\N
15890	200	4	0	51644	\N
15890	4683	5	0	51646	\N
15852	242	4	0	52168	\N
15852	4667	5	0	52170	\N
15845	260	3	0	52572	\N
15845	3399	4	0	52573	\N
15920	260	3	0	52574	\N
15920	3399	4	0	52575	\N
15923	1021	6	0	56415	\N
15923	4691	7	0	56421	\N
15864	4675	4	0	57971	\N
15865	1225	4	0	57972	\N
15864	4676	5	0	57973	\N
15865	4676	5	0	57974	\N
15867	4678	3	0	58463	\N
15867	4679	4	0	58464	\N
15954	3625	3	0	59540	\N
15954	3784	4	0	59548	\N
15956	3628	3	0	59670	\N
15956	3785	4	0	59674	\N
15897	4233	3	0	59956	\N
15897	4425	4	0	59959	\N
15916	4605	5	0	60246	\N
15916	4688	6	0	60248	\N
15849	4664	11	0	387	\N
15862	251	43	0	1536	\N
15878	110	1	0	2583	\N
15879	110	1	0	2584	\N
15885	110	4	0	2585	\N
15886	110	1	0	2586	\N
15878	3242	2	0	2589	\N
15879	3242	2	0	2590	\N
15886	3242	2	0	2591	\N
15885	4552	5	0	2592	\N
15858	228	3	0	3003	\N
15858	3186	4	0	3006	\N
15893	790	3	0	3221	\N
15859	4670	3	0	3243	\N
15859	4671	4	0	3244	\N
15855	262	6	0	3807	\N
15855	4248	7	0	3810	\N
15850	4178	10	0	5648	\N
15871	4178	4	0	5649	\N
15880	4178	1	0	5650	\N
15889	4178	9	0	5651	\N
15880	4450	2	0	5652	\N
15871	4205	5	0	5653	\N
15889	4682	10	0	5654	\N
15850	4665	11	0	5655	\N
15937	4211	4	0	5658	\N
15877	4172	0	0	8269	\N
15882	4172	0	0	8274	\N
15846	4172	3	0	8345	\N
15848	4172	10	0	8346	\N
15846	4275	4	0	8347	\N
15848	4663	11	0	8349	\N
15861	4172	7	0	8350	\N
15933	4172	3	0	8352	\N
15933	4275	4	0	8356	\N
15861	4614	8	0	8359	\N
15939	4172	3	0	8360	\N
15939	4275	4	0	8364	\N
15947	4275	4	0	8365	\N
15887	391	6	0	10511	\N
15896	391	3	0	10512	\N
15896	3660	4	0	10513	\N
15887	3521	7	0	10514	\N
15902	391	6	0	10525	\N
15902	3521	7	0	10530	\N
15873	108	4	0	11750	\N
15873	4060	5	0	11753	\N
15854	192	6	0	15324	\N
15854	4669	7	0	15325	\N
15913	60	3	0	19460	\N
15913	3585	4	0	19461	\N
15844	4152	5	0	21140	\N
15876	264	4	0	23628	\N
15876	3684	5	0	23650	\N
15888	214	6	0	24348	\N
15888	4681	7	0	24349	\N
15883	206	3	0	25944	\N
15883	4584	4	0	25949	\N
15866	94	4	0	26926	\N
15866	4677	5	0	26927	\N
15868	16	3	0	28606	\N
15898	16	3	0	28608	\N
15903	16	6	0	28609	\N
15898	3634	4	0	28610	\N
15903	3369	7	0	28611	\N
15908	16	2	0	28612	\N
15919	16	6	0	28613	\N
15908	388	3	0	28614	\N
15919	3369	7	0	28615	\N
15899	96	3	0	29648	\N
15899	2803	4	0	29651	\N
15857	151	3	0	30766	\N
15857	3046	4	0	30768	\N
15892	3673	5	0	31141	\N
15900	230	3	0	32221	\N
15900	4181	4	0	32223	\N
15870	14	4	0	39204	\N
15870	3498	5	0	39206	\N
15894	14	3	0	39219	\N
15894	4272	4	0	39220	\N
15863	1685	2	0	40092	\N
15863	18	4	0	40095	\N
15863	1426	5	0	40096	\N
15881	18	3	0	40099	\N
15881	3621	4	0	40100	\N
15906	18	7	0	40102	\N
15872	40	3	0	41692	\N
15872	372	4	0	41693	\N
15874	40	4	0	41712	\N
15874	3381	5	0	41713	\N
16094	56	3	0	44238	\N
16094	4109	4	0	44241	\N
16067	71	4	0	44867	\N
16067	3887	5	0	44868	\N
16001	100	3	0	47624	\N
16001	3836	4	0	47626	\N
16099	100	3	0	47632	\N
16099	3836	4	0	47635	\N
16048	121	3	0	49000	\N
16048	4471	4	0	49001	\N
16070	125	7	0	49281	\N
16070	4719	8	0	49283	\N
15998	137	10	0	49816	\N
15998	4704	11	0	49817	\N
16073	137	7	0	49828	\N
16073	4722	8	0	49829	\N
16189	268	4	0	52815	\N
16189	3897	5	0	52818	\N
16010	285	4	0	53534	\N
16010	3674	5	0	53536	\N
15931	316	9	0	54035	\N
15931	4279	10	0	54039	\N
15966	435	0	0	55091	\N
15969	595	6	0	55708	\N
16183	595	11	0	55742	\N
16183	4748	12	0	55753	\N
16163	852	3	0	57291	\N
16163	3612	4	0	57292	\N
16014	1470	3	0	58221	\N
16126	1470	3	0	58223	\N
16014	3838	4	0	58225	\N
16126	3838	4	0	58227	\N
15921	2636	3	0	58799	\N
15921	2837	4	0	58802	\N
16177	2782	3	0	59361	\N
16177	3659	4	0	59362	\N
15988	3625	3	0	59541	\N
15988	3784	4	0	59549	\N
15990	3628	3	0	59696	\N
15990	3785	4	0	59697	\N
15917	4605	6	0	60247	\N
15917	4689	7	0	60249	\N
16042	4043	5	0	385	\N
15983	4702	4	0	1063	\N
16154	266	28	0	1292	\N
16154	4739	29	0	1302	\N
15975	228	3	0	3004	\N
15975	3186	4	0	3007	\N
16013	262	4	0	3833	\N
16013	4607	5	0	3841	\N
15950	189	6	0	4909	\N
15950	3713	7	0	4913	\N
16140	4735	6	0	5358	\N
16140	373	7	0	5359	\N
15942	4178	6	0	5657	\N
15957	4178	3	0	5661	\N
15995	4178	3	0	5662	\N
15957	4211	4	0	5664	\N
15995	4211	4	0	5665	\N
16004	4178	10	0	5666	\N
16004	4665	11	0	5667	\N
16085	4178	3	0	5681	\N
16085	4211	4	0	5683	\N
16096	4178	4	0	5687	\N
16096	4205	5	0	5688	\N
16110	4178	3	0	5692	\N
16110	4211	4	0	5693	\N
16131	4205	5	0	5700	\N
15928	4172	2	0	8351	\N
15935	4172	3	0	8353	\N
15938	4172	3	0	8354	\N
15928	4191	3	0	8355	\N
15935	4275	4	0	8357	\N
15938	4275	4	0	8358	\N
15968	4172	6	0	8362	\N
15968	4197	7	0	8367	\N
16039	4172	4	0	8368	\N
16039	4219	5	0	8370	\N
16138	4197	6	0	8374	\N
16150	4172	4	0	8376	\N
16150	4219	5	0	8377	\N
16138	4172	7	0	8378	\N
16124	4614	8	0	8379	\N
16152	4172	3	0	8380	\N
16152	4275	4	0	8381	\N
16166	4172	3	0	8386	\N
16166	4275	4	0	8387	\N
15986	391	3	0	10526	\N
16101	391	4	0	10527	\N
15986	3660	4	0	10528	\N
16101	3913	5	0	10529	\N
15909	2756	3	0	11309	\N
15978	108	3	0	11751	\N
15978	4171	4	0	11752	\N
15965	300	3	0	12209	\N
15965	3747	4	0	12210	\N
16083	300	3	0	12217	\N
16083	3747	4	0	12219	\N
15952	123	3	0	12844	\N
15952	2856	4	0	12845	\N
16008	402	16	0	14180	\N
16116	402	4	0	14181	\N
16116	4731	5	0	14182	\N
15972	92	3	0	15042	\N
15972	4410	4	0	15043	\N
16114	92	3	0	15049	\N
16114	4410	4	0	15052	\N
16031	192	7	0	15334	\N
16031	4713	8	0	15336	\N
16121	192	3	0	15341	\N
16121	3790	4	0	15342	\N
16143	235	3	0	15760	\N
16143	3343	4	0	15763	\N
15960	98	3	0	16979	\N
15960	4695	4	0	16981	\N
16024	488	5	0	21503	\N
16024	2991	6	0	21504	\N
16043	69	3	0	24825	\N
16043	4536	4	0	24827	\N
16016	2185	3	0	24925	\N
16016	4710	4	0	24927	\N
16019	244	3	0	27318	\N
16169	244	3	0	27319	\N
16019	4075	4	0	27322	\N
16169	4075	4	0	27323	\N
15945	16	3	0	28616	\N
15945	3634	4	0	28617	\N
15934	2803	4	0	29663	\N
16046	54	4	0	30167	\N
16046	3685	5	0	30170	\N
16034	20	7	0	30495	\N
16034	4714	8	0	30500	\N
16089	360	3	0	31533	\N
16089	3602	4	0	31535	\N
15926	2	3	0	34978	\N
16021	2	3	0	34980	\N
15926	3548	4	0	34982	\N
16021	3548	4	0	34984	\N
15914	18	6	0	40103	\N
16063	2302	5	0	40108	\N
15914	4180	7	0	40109	\N
16076	23	2	0	40784	\N
16076	3443	3	0	40785	\N
16026	40	9	0	41750	\N
16026	4712	10	0	41758	\N
16106	40	7	0	41780	\N
16106	4718	8	0	41784	\N
15985	51	3	0	43570	\N
15985	3533	4	0	43571	\N
15974	56	3	0	44227	\N
15974	4109	4	0	44228	\N
15987	56	6	0	44229	\N
16009	56	16	0	44234	\N
16009	2588	17	0	44237	\N
16164	56	3	0	44240	\N
16164	4109	4	0	44242	\N
16097	75	6	0	46040	\N
16097	4694	7	0	46042	\N
16136	75	7	0	46045	\N
16136	2859	8	0	46046	\N
15979	79	3	0	46567	\N
16005	79	10	0	46568	\N
15979	3652	4	0	46574	\N
16005	4707	11	0	46579	\N
16175	4745	57	0	47638	\N
16175	100	126	0	47653	\N
16175	4746	127	0	47654	\N
16104	3053	2	0	47862	\N
16104	102	4	0	47872	\N
16104	3197	5	0	47875	\N
15912	113	3	0	48320	\N
15912	3620	4	0	48321	\N
16040	113	4	0	48328	\N
16040	3677	5	0	48329	\N
15989	119	3	0	48713	\N
15989	2860	4	0	48719	\N
15999	135	10	0	49554	\N
15999	4705	11	0	49570	\N
16129	186	35	0	51319	\N
16129	4732	36	0	51327	\N
15982	200	6	0	51645	\N
15982	4701	7	0	51647	\N
15946	268	3	0	52806	\N
15946	3815	4	0	52807	\N
16187	268	4	0	52813	\N
16187	3897	5	0	52816	\N
16086	353	3	0	54641	\N
16204	353	6	0	54643	\N
16086	3766	4	0	54644	\N
16204	4754	7	0	54646	\N
15969	4698	7	0	55710	\N
15967	597	6	0	55948	\N
15967	4697	7	0	55954	\N
16195	1021	4	0	56430	\N
16195	4752	5	0	56432	\N
16117	841	4	0	57121	\N
16117	3886	5	0	57132	\N
16017	1470	3	0	58222	\N
16017	3838	4	0	58226	\N
16171	4743	5	0	60255	\N
16119	251	6	0	1545	\N
16071	1636	7	0	3084	\N
16071	4720	8	0	3093	\N
15929	262	2	0	3825	\N
15929	2743	3	0	3826	\N
16081	35	3	0	4408	\N
16081	3563	4	0	4409	\N
16056	189	4	0	4910	\N
16056	3992	5	0	4912	\N
15944	4178	3	0	5660	\N
15944	4211	4	0	5663	\N
16029	4178	3	0	5670	\N
16035	4178	7	0	5671	\N
16035	4396	8	0	5673	\N
16044	4178	3	0	5674	\N
16044	4211	4	0	5675	\N
16079	4178	3	0	5680	\N
16079	4211	4	0	5682	\N
16148	4178	3	0	5702	\N
16192	4178	7	0	5703	\N
16148	4211	4	0	5704	\N
16192	4396	8	0	5705	\N
15993	4172	3	0	8363	\N
15993	4275	4	0	8366	\N
16092	4172	7	0	8369	\N
16139	3521	6	0	10531	\N
16134	391	7	0	10537	\N
16139	391	7	0	10539	\N
16134	3662	8	0	10540	\N
16037	132	6	0	11318	\N
16037	4690	7	0	11321	\N
16065	132	6	0	11332	\N
16065	4690	7	0	11334	\N
16180	132	4	0	11345	\N
16180	3716	5	0	11346	\N
16155	528	3	0	12547	\N
16155	4262	4	0	12548	\N
16061	3614	5	0	14718	\N
16153	38	3	0	16417	\N
16153	3457	4	0	16420	\N
16207	115	3	0	16716	\N
16011	142	4	0	18607	\N
16011	3950	5	0	18611	\N
15936	67	3	0	22175	\N
15936	3749	4	0	22176	\N
15977	67	16	0	22181	\N
15977	4700	17	0	22182	\N
15932	73	3	0	22623	\N
15932	3040	4	0	22625	\N
16146	4737	7	0	23162	\N
16185	930	11	0	23936	\N
16185	4750	12	0	23937	\N
15963	94	6	0	26929	\N
15963	4696	7	0	26932	\N
15951	16	3	0	28618	\N
15951	3634	4	0	28619	\N
15961	16	3	0	28620	\N
15961	3634	4	0	28622	\N
16074	16	7	0	28624	\N
16074	4723	8	0	28629	\N
16151	16	4	0	28630	\N
16198	151	3	0	30767	\N
16198	3046	4	0	30769	\N
16157	230	3	0	32230	\N
16157	4181	4	0	32232	\N
16127	431	3	0	34823	\N
16127	3933	4	0	34824	\N
15910	2	3	0	34977	\N
15959	2	3	0	34979	\N
15910	3548	4	0	34981	\N
15959	3548	4	0	34983	\N
16027	2	9	0	35005	\N
16027	3650	10	0	35006	\N
16051	3548	4	0	35022	\N
16161	2	3	0	35029	\N
16161	3548	4	0	35030	\N
16002	18	3	0	40104	\N
16112	18	13	0	40106	\N
16002	3621	4	0	40107	\N
16112	4730	14	0	40110	\N
16141	18	6	0	40111	\N
16141	4180	7	0	40112	\N
16178	18	3	0	40115	\N
16178	3621	4	0	40118	\N
15941	40	3	0	41725	\N
15971	40	6	0	41749	\N
16049	40	3	0	41751	\N
16068	40	6	0	41752	\N
16049	372	4	0	41754	\N
16068	4717	7	0	41755	\N
15971	4255	7	0	41756	\N
16095	40	3	0	41779	\N
16111	40	4	0	41781	\N
16095	372	4	0	41782	\N
16111	3381	5	0	41783	\N
16135	51	7	0	43577	\N
16135	4734	8	0	43580	\N
15987	4703	7	0	44230	\N
15992	57	1	0	44231	\N
15992	56	4	0	44232	\N
15992	2914	5	0	44233	\N
16028	56	4	0	44235	\N
16028	3127	5	0	44236	\N
16147	71	6	0	44878	\N
16147	4738	7	0	44880	\N
15927	75	3	0	46031	\N
15927	3855	4	0	46033	\N
16003	75	4	0	46037	\N
16003	3959	5	0	46038	\N
16041	75	4	0	46039	\N
16041	3959	5	0	46041	\N
16203	75	3	0	46047	\N
16203	3855	4	0	46052	\N
16060	79	4	0	46569	\N
16060	3678	5	0	46575	\N
16100	4727	57	0	47628	\N
16174	100	2	0	47633	\N
16174	633	3	0	47634	\N
16100	100	126	0	47636	\N
16100	4728	127	0	47637	\N
16103	3053	2	0	47861	\N
16103	102	4	0	47871	\N
16103	3197	5	0	47874	\N
15955	119	3	0	48712	\N
15955	2860	4	0	48718	\N
15953	125	3	0	49276	\N
15953	4170	4	0	49277	\N
16072	135	7	0	49555	\N
16072	4721	8	0	49569	\N
15970	147	6	0	50016	\N
16184	147	11	0	50017	\N
15970	4699	7	0	50038	\N
16184	4749	12	0	50039	\N
16123	181	3	0	50925	\N
16123	4184	4	0	50926	\N
16130	186	4	0	51320	\N
16130	4733	5	0	51321	\N
16179	273	4	0	53025	\N
16179	3777	5	0	53031	\N
16006	316	3	0	54036	\N
16006	4249	4	0	54038	\N
15948	435	0	0	55090	\N
16182	597	11	0	55949	\N
16182	4747	12	0	55955	\N
16168	1109	3	0	56187	\N
16173	1109	4	0	56188	\N
16168	3495	4	0	56192	\N
16173	3816	5	0	56193	\N
16082	1021	3	0	56416	\N
16082	4551	4	0	56420	\N
15964	793	6	0	56729	\N
15964	3719	7	0	56733	\N
15915	852	6	0	57287	\N
15915	4687	7	0	57288	\N
16091	2578	22	0	58605	\N
16091	4726	23	0	58606	\N
16023	2754	2	0	58996	\N
16025	2754	2	0	58997	\N
16023	2351	5	0	59004	\N
16025	2351	5	0	59005	\N
16023	4711	6	0	59006	\N
16025	4711	6	0	59007	\N
15973	2782	3	0	59349	\N
15973	3659	4	0	59352	\N
15981	2782	3	0	59356	\N
15981	3659	4	0	59357	\N
16170	4741	5	0	60253	\N
16160	424	3	0	925	\N
16053	3712	7	0	930	\N
16050	117	4	0	2269	\N
16050	3835	5	0	2270	\N
15997	228	3	0	3005	\N
15997	3186	4	0	3008	\N
15922	367	3	0	3427	\N
15922	3683	4	0	3428	\N
15924	262	6	0	3808	\N
15924	4248	7	0	3811	\N
16020	35	4	0	4406	\N
16020	3545	5	0	4407	\N
16007	4178	16	0	5668	\N
16045	4178	4	0	5676	\N
16045	4205	5	0	5677	\N
16055	4178	4	0	5678	\N
16055	4205	5	0	5684	\N
16098	4178	3	0	5690	\N
16098	4211	4	0	5691	\N
16113	4178	3	0	5694	\N
16113	4211	4	0	5695	\N
16118	4178	6	0	5696	\N
16118	4250	7	0	5701	\N
16093	4172	3	0	8372	\N
16093	4275	4	0	8373	\N
16036	132	4	0	11317	\N
16036	3293	5	0	11319	\N
15918	4690	7	0	11320	\N
16064	132	4	0	11331	\N
16064	3293	5	0	11333	\N
16038	123	3	0	12848	\N
16038	2856	4	0	12849	\N
15980	58	3	0	13535	\N
15980	3665	4	0	13541	\N
15984	92	3	0	15048	\N
15962	235	6	0	15759	\N
15962	3622	7	0	15766	\N
16075	4144	8	0	16134	\N
16159	38	3	0	16418	\N
16159	3457	4	0	16421	\N
15943	115	6	0	16706	\N
15943	4693	7	0	16709	\N
16206	115	6	0	16715	\N
16206	4755	7	0	16720	\N
16210	167	10	0	17723	\N
16210	4757	11	0	17726	\N
16165	198	4	0	20152	\N
16165	4161	5	0	20153	\N
16199	198	3	0	20158	\N
16142	577	3	0	20342	\N
16142	4736	4	0	20343	\N
16194	164	6	0	21139	\N
16194	3583	7	0	21141	\N
16105	488	7	0	21502	\N
16105	4729	8	0	21505	\N
15958	73	3	0	22624	\N
15958	3040	4	0	22626	\N
16033	336	3	0	22791	\N
16033	3400	4	0	22792	\N
15976	82	2	0	23854	\N
15976	3220	3	0	23858	\N
16181	2979	3	0	24385	\N
16145	42	3	0	27631	\N
16145	3645	4	0	27634	\N
16030	16	3	0	28621	\N
16030	3634	4	0	28623	\N
16108	16	3	0	28625	\N
16133	16	2	0	28626	\N
16133	388	3	0	28627	\N
16108	3634	4	0	28628	\N
15940	54	3	0	30166	\N
15940	3041	4	0	30169	\N
16058	4	7	0	35993	\N
16069	40	7	0	41753	\N
16069	4718	8	0	41757	\N
16196	40	4	0	41802	\N
16196	3381	5	0	41803	\N
16137	56	0	0	44239	\N
16128	71	3	0	44877	\N
16128	3770	4	0	44879	\N
15991	75	3	0	46035	\N
15991	3855	4	0	46036	\N
16125	75	7	0	46043	\N
16125	2859	8	0	46044	\N
16242	75	3	0	46048	\N
16242	3855	4	0	46053	\N
16062	79	4	0	46570	\N
16248	79	2	0	46571	\N
16253	79	4	0	46572	\N
16248	616	3	0	46573	\N
16062	3678	5	0	46576	\N
16253	3678	5	0	46577	\N
16102	3053	2	0	47860	\N
16102	102	4	0	47870	\N
16102	3197	5	0	47873	\N
16066	170	4	0	50621	\N
16066	4680	5	0	50631	\N
16232	260	3	0	52576	\N
16232	3399	4	0	52581	\N
16188	268	4	0	52814	\N
16188	3897	5	0	52817	\N
16251	279	2	0	53248	\N
16088	353	4	0	54642	\N
16088	4724	5	0	54645	\N
16107	362	3	0	54902	\N
16107	3658	4	0	54904	\N
16258	4779	54	0	55258	\N
16258	451	126	0	55283	\N
16197	841	3	0	57122	\N
16200	841	3	0	57123	\N
16197	3604	4	0	57128	\N
16200	3604	4	0	57129	\N
16217	1914	3	0	58488	\N
16217	3637	4	0	58491	\N
16233	4766	3	0	58519	\N
16233	4767	4	0	58520	\N
16229	4233	3	0	59957	\N
16229	4425	4	0	59960	\N
16186	4751	12	0	388	\N
16078	425	2	0	926	\N
16084	266	2	0	1291	\N
16244	266	4	0	1293	\N
16084	3235	3	0	1296	\N
16244	4100	5	0	1297	\N
16018	251	3	0	1532	\N
16018	3514	4	0	1534	\N
16214	110	7	0	2588	\N
16214	4758	8	0	2596	\N
16223	3328	3	0	2598	\N
16223	110	8	0	2610	\N
16223	4761	9	0	2611	\N
16132	3329	3	0	3442	\N
16059	4178	4	0	5679	\N
16059	4205	5	0	5685	\N
16090	4178	22	0	5686	\N
16090	4725	23	0	5689	\N
16144	4178	3	0	5698	\N
16144	4211	4	0	5699	\N
16212	4178	5	0	5706	\N
16218	4178	4	0	5707	\N
16218	4205	5	0	5708	\N
16212	4429	6	0	5709	\N
16243	4178	3	0	5710	\N
16158	4172	3	0	8382	\N
16162	4172	4	0	8383	\N
16158	4275	4	0	8384	\N
16162	4219	5	0	8385	\N
16205	4172	6	0	8388	\N
16205	4365	7	0	8391	\N
16236	300	4	0	12218	\N
16236	4770	5	0	12220	\N
16209	77	3	0	13181	\N
16209	1877	4	0	13182	\N
16227	58	7	0	13536	\N
16227	4764	8	0	13543	\N
16000	4706	10	0	14161	\N
16235	258	14	0	14484	\N
16235	4769	15	0	14494	\N
16120	92	4	0	15050	\N
15984	4410	4	0	15051	\N
16120	3979	5	0	15053	\N
16256	92	3	0	15059	\N
16256	4410	4	0	15061	\N
16032	192	0	0	15335	\N
16167	38	3	0	16419	\N
16167	3457	4	0	16422	\N
16240	4774	7	0	16435	\N
16240	4775	30	0	16453	\N
16190	167	2	0	17707	\N
16191	167	7	0	17708	\N
16190	2260	3	0	17709	\N
16191	4147	8	0	17713	\N
16087	142	3	0	18622	\N
16087	4254	4	0	18625	\N
16249	208	2	0	19183	\N
16249	4524	3	0	19193	\N
16057	60	7	0	19480	\N
16057	4613	8	0	19481	\N
16122	62	3	0	19809	\N
16239	62	61	0	19811	\N
16122	3344	4	0	19815	\N
16238	4772	6	0	19816	\N
16239	4773	62	0	19817	\N
16047	64	3	0	20735	\N
16047	4217	4	0	20736	\N
16172	1440	4	0	21634	\N
16172	4744	5	0	21636	\N
16202	82	2	0	23855	\N
16202	4753	3	0	23856	\N
16052	140	6	0	24040	\N
16054	140	117	0	24041	\N
16054	4715	118	0	24046	\N
16109	214	3	0	24368	\N
16109	3496	4	0	24369	\N
15994	69	3	0	24824	\N
15994	4536	4	0	24826	\N
16115	94	3	0	26930	\N
16115	2864	4	0	26931	\N
16156	16	3	0	28631	\N
16219	16	4	0	28632	\N
16156	3634	4	0	28634	\N
16219	3546	5	0	28637	\N
16220	449	3	0	29819	\N
16224	449	8	0	29827	\N
16224	4762	9	0	29828	\N
16022	20	3	0	30487	\N
16022	2844	4	0	30488	\N
16201	360	3	0	31540	\N
16201	3602	4	0	31542	\N
15996	453	3	0	32787	\N
15996	2838	4	0	32788	\N
16193	2	4	0	35039	\N
16193	3510	5	0	35040	\N
16012	4	4	0	35992	\N
16080	4	3	0	35994	\N
16012	4117	5	0	35998	\N
16149	14	3	0	39235	\N
16149	4272	4	0	39236	\N
16176	18	3	0	40113	\N
16176	3621	4	0	40114	\N
16245	18	4	0	40119	\N
16245	2302	5	0	40120	\N
16015	27	3	0	41256	\N
16015	4636	4	0	41259	\N
16372	51	4	0	43578	\N
16372	3975	5	0	43579	\N
16311	71	7	0	44890	\N
16311	4793	8	0	44893	\N
16378	75	3	0	46049	\N
16378	3855	4	0	46054	\N
16288	79	3	0	46615	\N
16405	79	3	0	46616	\N
16288	3652	4	0	46617	\N
16405	3652	4	0	46618	\N
16417	79	2	0	46656	\N
16417	3180	3	0	46657	\N
16287	88	2	0	47221	\N
16289	88	2	0	47222	\N
16290	88	3	0	47223	\N
16287	2799	3	0	47224	\N
16289	2799	3	0	47225	\N
16290	3655	4	0	47226	\N
16438	102	2	0	47883	\N
16438	3574	3	0	47884	\N
16352	125	14	0	49282	\N
16352	4807	15	0	49284	\N
16280	147	4	0	50018	\N
16280	3877	5	0	50035	\N
16461	260	3	0	52577	\N
16461	3399	4	0	52582	\N
16216	268	3	0	52820	\N
16216	3815	4	0	52821	\N
16208	285	11	0	53535	\N
16208	4756	12	0	53537	\N
16463	324	2	0	54244	\N
16463	2808	3	0	54245	\N
16334	353	4	0	54653	\N
16334	4724	5	0	54654	\N
16258	4780	127	0	55284	\N
16292	451	4	0	55294	\N
16292	3666	5	0	55295	\N
16277	597	4	0	55950	\N
16277	3733	5	0	55953	\N
16479	597	3	0	55979	\N
16479	3656	4	0	55980	\N
16281	841	2	0	57124	\N
16281	3316	3	0	57127	\N
16291	908	2	0	57704	\N
16291	2832	3	0	57705	\N
16485	4842	4	0	58127	\N
16485	4843	4	1	58134	\N
16485	1470	3	0	58235	\N
16315	2578	6	0	58607	\N
16315	4795	7	0	58608	\N
16318	4798	6	0	186	\N
16250	4776	3	0	3012	\N
16393	367	2	0	3439	\N
16393	3065	3	0	3441	\N
16271	262	8	0	3835	\N
16271	4093	9	0	3842	\N
16329	4178	21	0	5720	\N
16329	4802	22	0	5721	\N
16339	4178	4	0	5728	\N
16342	4178	3	0	5730	\N
16342	4211	4	0	5731	\N
16383	4178	3	0	5738	\N
16383	4211	4	0	5739	\N
16426	4178	4	0	5742	\N
16413	4205	5	0	5743	\N
16426	4205	5	0	5745	\N
16451	4178	8	0	5755	\N
16451	4237	9	0	5756	\N
16470	4178	3	0	5761	\N
16470	4211	4	0	5762	\N
16491	4178	4	0	5768	\N
16491	4331	5	0	5769	\N
16231	4172	2	0	8389	\N
16231	4191	3	0	8390	\N
16268	4172	7	0	8393	\N
16380	4172	6	0	8402	\N
16380	4197	7	0	8403	\N
16403	4172	3	0	8405	\N
16403	4275	4	0	8407	\N
16419	4172	4	0	8409	\N
16419	4252	5	0	8411	\N
16274	391	3	0	10546	\N
16274	3660	4	0	10547	\N
16375	391	7	0	10554	\N
16375	3662	8	0	10555	\N
16296	123	4	0	12852	\N
16296	4090	5	0	12853	\N
16398	58	8	0	13539	\N
16398	4820	9	0	13544	\N
16228	4765	11	0	13545	\N
16207	1115	4	0	16719	\N
16211	167	7	0	17724	\N
16211	4147	8	0	17725	\N
16234	1376	3	0	17956	\N
16234	4768	4	0	17961	\N
16263	177	7	0	18337	\N
16263	3708	8	0	18338	\N
16247	290	2	0	19043	\N
16247	1909	3	0	19046	\N
16262	4781	8	0	19827	\N
16408	62	3	0	19835	\N
16408	3344	4	0	19839	\N
16267	64	0	0	20757	\N
16400	488	3	0	21514	\N
16400	1103	4	0	21515	\N
16472	1316	10	0	22329	\N
16472	4836	11	0	22334	\N
16284	82	3	0	23861	\N
16284	4505	4	0	23863	\N
16301	214	3	0	24408	\N
16301	3496	4	0	24409	\N
16421	3807	5	0	24423	\N
16306	4789	23	0	26139	\N
16306	90	96	0	26156	\N
16306	4790	97	0	26157	\N
16297	94	3	0	26933	\N
16440	244	3	0	27321	\N
16440	4075	4	0	27325	\N
16294	42	6	0	27632	\N
16294	1090	7	0	27636	\N
16325	16	3	0	28640	\N
16325	3634	4	0	28641	\N
16433	320	7	0	29269	\N
16391	151	4	0	30778	\N
16391	3499	5	0	30779	\N
16344	33	4	0	31827	\N
16344	4806	5	0	31828	\N
16370	453	3	0	32800	\N
16370	2838	4	0	32803	\N
16428	2	4	0	35065	\N
16428	3510	5	0	35068	\N
16308	14	7	0	39193	\N
16308	3882	8	0	39196	\N
16221	18	2	0	40116	\N
16221	1685	3	0	40117	\N
16265	3621	4	0	40122	\N
16322	18	3	0	40125	\N
16322	3621	4	0	40126	\N
16449	18	7	0	40133	\N
16449	1618	8	0	40138	\N
16446	27	10	0	41257	\N
16446	4830	11	0	41261	\N
16260	40	3	0	41823	\N
16260	372	4	0	41824	\N
16363	40	2	0	41891	\N
16365	40	11	0	41892	\N
16363	282	3	0	41894	\N
16436	51	4	0	43583	\N
16436	3975	5	0	43584	\N
16309	56	7	0	44243	\N
16468	56	4	0	44244	\N
16468	3127	5	0	44245	\N
16309	4791	8	0	44246	\N
16471	75	3	0	45194	\N
16471	3855	4	0	45197	\N
16422	75	4	0	46050	\N
16427	75	4	0	46051	\N
16422	3959	5	0	46055	\N
16427	3959	5	0	46056	\N
16434	88	12	0	47242	\N
16434	4828	13	0	47243	\N
16431	100	7	0	47648	\N
16431	4826	8	0	47651	\N
16340	113	4	0	48336	\N
16340	3677	5	0	48337	\N
16368	121	2	0	49017	\N
16368	4815	3	0	49020	\N
16454	4833	31	0	50946	\N
16454	181	126	0	50957	\N
16454	4834	127	0	50958	\N
16328	268	6	0	52826	\N
16328	4801	7	0	52827	\N
16347	268	3	0	52830	\N
16347	3815	4	0	52831	\N
16241	316	3	0	54045	\N
16241	4249	4	0	54046	\N
16404	316	3	0	54054	\N
16404	4249	4	0	54056	\N
16255	451	3	0	55281	\N
16255	3934	4	0	55282	\N
16293	4785	54	0	55285	\N
16353	451	10	0	55329	\N
16353	4808	11	0	55330	\N
16480	595	3	0	55745	\N
16480	3654	4	0	55750	\N
16323	1021	4	0	56431	\N
16323	4752	5	0	56433	\N
16283	841	3	0	57125	\N
16283	3604	4	0	57130	\N
16361	4766	4	0	58521	\N
16361	4811	5	0	58522	\N
16332	2351	4	0	59014	\N
16332	3494	5	0	59027	\N
16316	4088	5	0	59829	\N
16316	4796	6	0	59837	\N
16299	4788	4	0	60265	\N
16401	424	8	0	928	\N
16213	110	6	0	2587	\N
16213	3917	7	0	2593	\N
16222	2995	3	0	2597	\N
16222	110	4	0	2609	\N
16464	2982	2	0	3208	\N
16464	3383	3	0	3210	\N
16215	365	6	0	4647	\N
16215	4759	7	0	4648	\N
16246	4178	2	0	5712	\N
16270	4178	13	0	5713	\N
16246	4247	3	0	5714	\N
16270	4782	14	0	5715	\N
16313	4211	4	0	5717	\N
16320	4178	3	0	5718	\N
16320	4211	4	0	5719	\N
16345	4178	3	0	5732	\N
16345	4211	4	0	5733	\N
16488	4178	3	0	5766	\N
16488	4211	4	0	5767	\N
16503	4178	8	0	5772	\N
16503	4237	9	0	5773	\N
16259	4172	3	0	8392	\N
16259	4275	4	0	8394	\N
16330	4172	21	0	8398	\N
16396	4172	3	0	8404	\N
16396	4275	4	0	8406	\N
16477	4172	3	0	8416	\N
16477	4275	4	0	8417	\N
16226	391	7	0	10538	\N
16226	3662	8	0	10541	\N
16452	391	8	0	10567	\N
16452	4831	9	0	10571	\N
16373	132	5	0	11351	\N
16373	2717	6	0	11352	\N
16276	108	4	0	11761	\N
16276	4060	5	0	11763	\N
16343	3747	4	0	12230	\N
16319	233	5	0	13806	\N
16319	4799	6	0	13811	\N
16466	192	4	0	15350	\N
16466	3895	5	0	15355	\N
16237	38	5	0	16437	\N
16285	38	3	0	16438	\N
16285	3457	4	0	16439	\N
16237	4771	6	0	16440	\N
16495	115	4	0	16717	\N
16495	4844	5	0	16718	\N
16489	212	3	0	17219	\N
16252	64	3	0	20751	\N
16252	4217	4	0	20752	\N
16415	64	4	0	20769	\N
16415	3911	5	0	20770	\N
16366	140	11	0	24051	\N
16366	4814	12	0	24052	\N
16376	140	3	0	24058	\N
16376	4149	4	0	24059	\N
16304	224	3	0	25556	\N
16304	3603	4	0	25560	\N
16459	90	4	0	26168	\N
16459	3731	5	0	26169	\N
16509	4849	8	0	26186	\N
16225	345	3	0	26298	\N
16225	4763	4	0	26299	\N
16498	785	4	0	26313	\N
16498	4846	5	0	26315	\N
16297	2864	4	0	26934	\N
16269	16	3	0	28633	\N
16269	3634	4	0	28635	\N
16388	16	7	0	28642	\N
16388	4723	8	0	28643	\N
16230	320	4	0	29217	\N
16230	3824	5	0	29218	\N
16406	4821	4	0	29245	\N
16337	96	3	0	29670	\N
16337	2803	4	0	29671	\N
16456	96	3	0	29678	\N
16456	2803	4	0	29679	\N
16349	449	3	0	29836	\N
16349	4760	4	0	29838	\N
16385	202	4	0	31152	\N
16385	3673	5	0	31153	\N
16371	453	2	0	32801	\N
16371	3366	3	0	32802	\N
16424	2	6	0	35053	\N
16356	4	4	0	35995	\N
16356	4117	5	0	35999	\N
16273	6	8	0	36305	\N
16273	4784	9	0	36309	\N
16443	18	4	0	40131	\N
16443	2302	5	0	40132	\N
16486	23	3	0	40800	\N
16486	3497	4	0	40802	\N
16279	40	4	0	41840	\N
16279	3381	5	0	41843	\N
16358	40	4	0	41861	\N
16358	3381	5	0	41862	\N
16492	2796	5	0	41919	\N
16476	71	4	0	44891	\N
16476	3887	5	0	44892	\N
16416	79	3	0	46655	\N
16416	3652	4	0	46658	\N
16511	4851	4	0	46689	\N
16511	3678	5	0	46691	\N
16351	100	3	0	47647	\N
16351	3836	4	0	47650	\N
16346	102	3	0	47881	\N
16346	3597	4	0	47885	\N
16367	121	2	0	49016	\N
16367	4815	3	0	49019	\N
16407	147	2	0	50019	\N
16407	3287	3	0	50025	\N
16392	181	7	0	50942	\N
16392	4137	8	0	50945	\N
16251	4525	3	0	53252	\N
16293	451	126	0	55296	\N
16293	4786	127	0	55297	\N
16312	451	7	0	55313	\N
16312	4794	8	0	55314	\N
16278	595	4	0	55743	\N
16410	595	3	0	55744	\N
16410	3654	4	0	55749	\N
16278	3878	5	0	55751	\N
16266	908	0	0	57703	\N
16357	908	4	0	57709	\N
16357	3488	5	0	57712	\N
16511	4850	4	0	58121	\N
16484	4842	4	0	58126	\N
16514	4842	5	0	58130	\N
16484	4843	4	1	58133	\N
16484	1470	3	0	58234	\N
16487	1470	3	0	58236	\N
16487	3838	4	0	58240	\N
16338	2636	3	0	58800	\N
16338	2837	4	0	58803	\N
16382	2351	3	0	59015	\N
16382	2845	4	0	59025	\N
16254	2647	3	0	59431	\N
16254	4777	4	0	59432	\N
16499	4847	5	0	60266	\N
16402	424	8	0	929	\N
16514	4855	5	1	1798	\N
16514	954	4	0	1812	\N
16326	228	4	0	3010	\N
16326	4800	5	0	3013	\N
16467	1636	4	0	3085	\N
16467	4118	5	0	3090	\N
16310	367	7	0	3438	\N
16310	4792	8	0	3443	\N
16257	262	3	0	3834	\N
16257	4778	4	0	3839	\N
16331	4178	3	0	5722	\N
16331	4211	4	0	5723	\N
16335	4178	6	0	5725	\N
16333	4205	5	0	5726	\N
16335	4804	7	0	5727	\N
16355	4178	3	0	5734	\N
16355	4211	4	0	5735	\N
16448	4178	7	0	5753	\N
16448	4396	8	0	5754	\N
16455	4178	3	0	5757	\N
16455	4211	4	0	5758	\N
16465	4178	3	0	5759	\N
16465	4211	4	0	5760	\N
16307	4172	3	0	8396	\N
16412	4172	4	0	8408	\N
16412	4219	5	0	8410	\N
16430	4172	4	0	8412	\N
16450	4172	3	0	8413	\N
16450	4275	4	0	8414	\N
16430	4219	5	0	8415	\N
16502	391	8	0	10568	\N
16502	4831	9	0	10572	\N
16414	132	4	0	11359	\N
16414	3716	5	0	11362	\N
16423	528	6	0	12569	\N
16423	4824	7	0	12573	\N
16298	3665	4	0	13542	\N
16317	173	5	0	14724	\N
16317	4797	6	0	14727	\N
16336	326	4	0	17431	\N
16336	3519	5	0	17434	\N
16360	1376	4	0	17957	\N
16360	4810	5	0	17963	\N
16523	30	9	0	18143	\N
16523	4859	10	0	18144	\N
16272	413	8	0	18365	\N
16272	4783	9	0	18366	\N
16348	290	3	0	19053	\N
16261	62	5	0	19824	\N
16261	4422	6	0	19826	\N
16264	62	3	0	19834	\N
16264	3344	4	0	19838	\N
16387	198	3	0	20159	\N
16445	198	10	0	20160	\N
16387	4263	4	0	20162	\N
16445	4829	11	0	20163	\N
16474	198	3	0	20172	\N
16474	4263	4	0	20173	\N
16453	241	8	0	20441	\N
16453	4832	9	0	20445	\N
16327	3911	5	0	20762	\N
16282	164	3	0	21156	\N
16341	164	3	0	21157	\N
16282	3385	4	0	21158	\N
16341	3385	4	0	21159	\N
16435	336	4	0	22802	\N
16435	3947	5	0	22806	\N
16395	206	10	0	25945	\N
16395	4819	11	0	25951	\N
16305	90	3	0	26154	\N
16305	4074	4	0	26155	\N
16295	86	4	0	26596	\N
16303	94	3	0	26935	\N
16303	2864	4	0	26941	\N
16379	244	3	0	27320	\N
16379	4075	4	0	27324	\N
16507	244	11	0	27335	\N
16507	4848	12	0	27336	\N
16324	16	3	0	28638	\N
16324	3634	4	0	28639	\N
16442	16	3	0	28645	\N
16442	3634	4	0	28646	\N
16458	16	10	0	28648	\N
16458	4835	11	0	28649	\N
16350	3602	4	0	31543	\N
16275	322	3	0	32489	\N
16275	1105	4	0	32490	\N
16390	4	4	0	36027	\N
16390	4117	5	0	36033	\N
16314	6	4	0	36306	\N
16314	3487	5	0	36308	\N
16418	6	3	0	36313	\N
16418	4823	4	0	36316	\N
16321	14	2	0	39194	\N
16321	1785	3	0	39195	\N
16300	18	3	0	40123	\N
16362	18	3	0	40127	\N
16362	3621	4	0	40128	\N
16397	18	3	0	40129	\N
16397	3621	4	0	40130	\N
16493	23	6	0	40801	\N
16493	4632	7	0	40803	\N
16302	40	3	0	41841	\N
16302	372	4	0	41842	\N
2575	56	1	0	43758	\N
16565	75	4	0	45196	\N
16558	3855	4	0	45198	\N
16565	3959	5	0	45199	\N
16513	79	4	0	46690	\N
16513	3678	5	0	46692	\N
16519	79	4	0	46728	\N
16519	3678	5	0	46730	\N
16534	88	3	0	47254	\N
16534	3655	4	0	47256	\N
16437	102	3	0	47882	\N
16437	3597	4	0	47886	\N
16457	102	3	0	47899	\N
16457	3597	4	0	47902	\N
16369	121	2	0	49018	\N
16369	4815	3	0	49021	\N
16551	135	4	0	49556	\N
16551	3696	5	0	49566	\N
16478	147	3	0	50020	\N
16478	3657	4	0	50029	\N
16559	156	3	0	50260	\N
16559	4594	4	0	50261	\N
16539	242	0	0	52179	\N
16540	242	0	0	52180	\N
16541	242	0	0	52181	\N
16494	273	4	0	53026	\N
16494	3777	5	0	53032	\N
16439	353	3	0	54659	\N
16441	353	2	0	54660	\N
16441	3134	3	0	54665	\N
16439	3766	4	0	54666	\N
16409	597	3	0	55969	\N
16409	3656	4	0	55970	\N
16563	908	3	0	57710	\N
16563	3591	4	0	57711	\N
16512	4850	4	0	58122	\N
16512	4853	5	0	58129	\N
16497	4204	4	0	384	\N
16546	4866	15	0	955	\N
16384	251	3	0	1562	\N
16384	3514	4	0	1569	\N
16512	4854	5	1	1799	\N
16512	4852	4	0	1811	\N
16394	367	10	0	3440	\N
16394	4818	11	0	3444	\N
16481	262	3	0	3836	\N
16481	4778	4	0	3840	\N
16381	4178	3	0	5736	\N
16381	4211	4	0	5737	\N
16420	4178	4	0	5741	\N
16429	4178	4	0	5746	\N
16429	4205	5	0	5747	\N
16444	4450	1	0	5748	\N
16432	4178	7	0	5749	\N
16444	4178	4	0	5750	\N
16444	4527	5	0	5751	\N
16432	4396	8	0	5752	\N
16483	4840	3	0	5763	\N
16483	4178	15	0	5764	\N
16483	4841	16	0	5765	\N
16501	4178	3	0	5770	\N
16501	4211	4	0	5771	\N
16508	4178	7	0	5775	\N
16505	4211	4	0	5776	\N
16508	4396	8	0	5777	\N
16550	4178	4	0	5782	\N
16550	4205	5	0	5784	\N
16578	4178	10	0	5789	\N
16578	4665	11	0	5792	\N
16359	4172	6	0	8399	\N
16359	4197	7	0	8400	\N
16522	4172	4	0	8418	\N
16522	4219	5	0	8420	\N
16490	108	4	0	11762	\N
16580	300	4	0	12228	\N
16580	2992	5	0	12231	\N
16354	123	6	0	12856	\N
16354	4809	7	0	12857	\N
16537	123	3	0	12865	\N
16537	2856	4	0	12871	\N
16543	402	0	0	14192	\N
16545	402	14	0	14193	\N
16548	402	0	0	14194	\N
16545	4865	15	0	14200	\N
16530	235	3	0	15761	\N
16530	3343	4	0	15764	\N
16469	3486	5	0	16133	\N
16564	4869	65	0	17437	\N
16564	326	70	0	17446	\N
16564	2939	71	0	17447	\N
16528	167	3	0	17734	\N
16528	4028	4	0	17735	\N
16374	30	17	0	18118	\N
16374	4816	18	0	18130	\N
16482	4838	4	0	18242	\N
16482	4839	5	0	18243	\N
16389	290	11	0	19054	\N
16389	4817	12	0	19056	\N
16377	3385	4	0	21180	\N
16475	1316	3	0	22330	\N
16475	4837	4	0	22332	\N
16399	336	3	0	22801	\N
16399	3400	4	0	22805	\N
16411	672	6	0	23914	\N
16411	4822	7	0	23916	\N
16520	411	4	0	25299	\N
16520	4858	5	0	25300	\N
16496	224	13	0	25557	\N
16496	4845	14	0	25561	\N
16561	206	3	0	25947	\N
16566	345	6	0	26300	\N
16566	4870	7	0	26301	\N
16526	42	5	0	27645	\N
16526	4860	6	0	27646	\N
16425	16	6	0	28644	\N
16425	3369	7	0	28647	\N
16460	16	4	0	28650	\N
16460	3546	5	0	28652	\N
16553	16	1	0	28654	\N
16553	1087	2	0	28655	\N
16516	202	3	0	31160	\N
16518	202	2	0	31161	\N
16516	4857	4	0	31163	\N
16447	431	2	0	34825	\N
16447	2772	3	0	34826	\N
16364	4	4	0	35996	\N
16364	4812	5	0	36004	\N
16386	4	3	0	36015	\N
16386	3837	4	0	36016	\N
16500	14	3	0	39212	\N
16500	4272	4	0	39214	\N
16473	18	3	0	40134	\N
16506	18	3	0	40135	\N
16473	3621	4	0	40136	\N
16583	18	6	0	40139	\N
16462	40	3	0	41893	\N
16462	372	4	0	41895	\N
16504	40	8	0	41912	\N
16557	40	3	0	41914	\N
16570	40	14	0	41915	\N
16573	40	6	0	41916	\N
16557	372	4	0	41917	\N
16573	4255	7	0	41920	\N
16504	3503	9	0	41921	\N
16570	4871	15	0	41922	\N
16575	40	4	0	41960	\N
16577	51	10	0	43587	\N
16577	4662	11	0	43588	\N
16639	56	7	0	44251	\N
16728	56	3	0	44254	\N
16728	4109	4	0	44255	\N
16639	4791	8	0	44258	\N
16776	56	3	0	44259	\N
16776	4109	4	0	44261	\N
16521	79	4	0	46729	\N
16521	3678	5	0	46731	\N
16774	88	13	0	47255	\N
16774	4948	14	0	47257	\N
16781	88	7	0	47266	\N
16781	4949	8	0	47269	\N
16624	113	2	0	48347	\N
16624	1899	3	0	48348	\N
16654	119	7	0	48714	\N
16654	4891	8	0	48720	\N
16594	121	3	0	49030	\N
16594	4471	4	0	49033	\N
16560	125	3	0	49293	\N
16560	4170	4	0	49298	\N
16787	135	3	0	49558	\N
16787	3630	4	0	49564	\N
16552	137	4	0	49839	\N
16552	3697	5	0	49840	\N
16568	137	4	0	49856	\N
16568	4352	5	0	49865	\N
16741	260	8	0	52578	\N
16741	4933	9	0	52583	\N
16659	279	9	0	53249	\N
16685	279	2	0	53250	\N
16685	4525	3	0	53253	\N
16659	4892	10	0	53254	\N
16591	285	2	0	53547	\N
16591	1709	3	0	53548	\N
16602	285	1	0	53564	\N
16602	3112	2	0	53566	\N
16582	353	6	0	54661	\N
16582	4876	7	0	54668	\N
16610	353	28	0	54675	\N
16610	4883	29	0	54676	\N
16736	597	5	0	55992	\N
16736	4929	6	0	56008	\N
16752	841	3	0	57126	\N
16752	3604	4	0	57131	\N
16713	4920	2	0	58447	\N
16686	1914	0	0	58489	\N
16536	4088	3	0	59830	\N
16536	4506	4	0	59834	\N
16586	1096	126	0	1668	\N
16515	954	4	0	1813	\N
16515	4856	5	0	1817	\N
16770	4944	7	0	5150	\N
16770	4945	8	0	5151	\N
16510	4179	4	0	5778	\N
16510	4178	17	0	5779	\N
16510	4441	18	0	5780	\N
16554	4178	5	0	5783	\N
16554	4429	6	0	5785	\N
16562	4178	6	0	5787	\N
16562	4250	7	0	5788	\N
16589	4178	5	0	5790	\N
16598	4450	1	0	5793	\N
16663	4178	3	0	5807	\N
16663	4211	4	0	5810	\N
16567	4172	4	0	8419	\N
16567	4252	5	0	8421	\N
16572	4172	8	0	8422	\N
16572	4500	9	0	8429	\N
16670	4172	3	0	8432	\N
16670	4275	4	0	8433	\N
16727	4172	5	0	8442	\N
16746	4172	10	0	8443	\N
16759	4172	3	0	8445	\N
16759	4940	4	0	8449	\N
16779	4275	4	0	8451	\N
16727	4415	6	0	8453	\N
16746	4663	11	0	8455	\N
16658	391	3	0	10569	\N
16658	3660	4	0	10570	\N
16525	132	3	0	11360	\N
16525	3729	4	0	11361	\N
16641	132	4	0	11376	\N
16641	3716	5	0	11377	\N
16699	132	3	0	11403	\N
16699	3729	4	0	11404	\N
16744	1853	2	0	12332	\N
16718	124	1	0	12859	\N
16517	123	3	0	12864	\N
16718	123	4	0	12869	\N
16517	2856	4	0	12870	\N
16718	4862	5	0	12873	\N
16792	123	3	0	12877	\N
16792	2856	4	0	12881	\N
16542	77	14	0	13190	\N
16542	4863	15	0	13191	\N
16734	58	4	0	13554	\N
16734	4213	5	0	13556	\N
16533	3704	4	0	13809	\N
16576	258	28	0	14503	\N
16576	4873	29	0	14504	\N
16595	258	4	0	14515	\N
16595	4881	5	0	14516	\N
16683	4902	5	0	14719	\N
16683	173	8	0	14725	\N
16683	3179	9	0	14726	\N
16709	4917	63	0	15754	\N
16708	235	3	0	15762	\N
16708	3343	4	0	15765	\N
16709	235	126	0	15767	\N
16629	4887	121	0	17448	\N
16629	326	122	0	17474	\N
16765	167	2	0	17762	\N
16765	3322	3	0	17763	\N
16702	241	4	0	20451	\N
16794	241	3	0	20452	\N
16794	3613	4	0	20453	\N
16702	4582	5	0	20454	\N
16529	164	3	0	21173	\N
16615	164	0	0	21174	\N
16529	3385	4	0	21181	\N
16713	165	1	0	21183	\N
16713	4921	2	0	21191	\N
16715	164	4	0	21192	\N
16715	3085	5	0	21194	\N
16756	1324	3	0	21527	\N
16756	488	126	0	21538	\N
16756	4937	127	0	21539	\N
16531	145	7	0	22055	\N
16636	145	6	0	22056	\N
16531	4861	8	0	22057	\N
16636	4889	7	0	22058	\N
16555	86	13	0	26597	\N
16555	4868	14	0	26599	\N
16622	2864	4	0	26942	\N
16649	42	3	0	27661	\N
16649	3645	4	0	27663	\N
16661	320	9	0	29293	\N
16661	4894	10	0	29294	\N
16750	14	4	0	39242	\N
16750	2291	5	0	39246	\N
16588	18	6	0	40140	\N
16588	4180	7	0	40142	\N
16626	18	3	0	40143	\N
16626	3621	4	0	40144	\N
16679	40	3	0	42008	\N
2953	56	1	0	43784	\N
16579	4874	11	0	45216	\N
16527	79	7	0	46754	\N
16527	4063	8	0	46755	\N
16694	79	2	0	46790	\N
16694	616	3	0	46792	\N
16569	135	4	0	49557	\N
16569	4353	5	0	49568	\N
16671	242	3	0	52182	\N
16671	2839	4	0	52185	\N
16590	285	5	0	53546	\N
16590	4880	6	0	53549	\N
16603	285	3	0	53565	\N
16603	4496	4	0	53567	\N
16707	4911	124	1	54496	\N
16784	4950	18	0	54499	\N
16584	353	12	0	54662	\N
16584	4653	13	0	54670	\N
16707	4910	19	0	54677	\N
16707	353	123	0	54687	\N
16784	4953	67	0	54694	\N
16784	353	66	0	54700	\N
16737	595	5	0	55746	\N
16737	4930	6	0	55752	\N
16673	793	6	0	56739	\N
16673	3719	7	0	56740	\N
16761	1470	3	0	58237	\N
16761	3838	4	0	58241	\N
16556	2636	3	0	58806	\N
16556	2837	4	0	58807	\N
16642	2351	0	0	59016	\N
16666	2782	4	0	59367	\N
16666	3872	5	0	59368	\N
16707	4498	124	0	59480	\N
16652	3625	7	0	59528	\N
16652	3626	8	0	59552	\N
16655	3628	7	0	59717	\N
16747	3628	10	0	59718	\N
16655	3629	8	0	59725	\N
16747	3671	11	0	59726	\N
16707	4914	126	1	59776	\N
16606	4787	3	0	60271	\N
16606	4788	4	0	60275	\N
16585	4877	9	0	1664	\N
16755	3653	4	0	2072	\N
16571	228	8	0	3011	\N
16571	4872	9	0	3014	\N
16729	367	0	0	3462	\N
16632	262	5	0	3838	\N
16632	2828	6	0	3843	\N
16724	189	7	0	4934	\N
16724	4927	8	0	4935	\N
16623	4885	84	0	5161	\N
16623	591	102	0	5166	\N
16623	4886	103	0	5167	\N
16707	4916	127	1	5284	\N
16544	4178	14	0	5781	\N
16544	4864	15	0	5786	\N
16598	4178	4	0	5795	\N
16598	4527	5	0	5796	\N
16613	4178	3	0	5798	\N
16613	4211	4	0	5799	\N
16645	4178	15	0	5803	\N
16645	4570	16	0	5806	\N
16730	4178	2	0	5814	\N
16730	4247	3	0	5816	\N
16735	4178	4	0	5819	\N
16735	4205	5	0	5820	\N
16751	4331	5	0	5822	\N
16760	4178	3	0	5823	\N
16760	4941	4	0	5824	\N
16797	4178	11	0	5830	\N
16797	4957	12	0	5838	\N
16605	4172	3	0	8423	\N
16634	4172	4	0	8424	\N
16605	4275	4	0	8426	\N
16634	4219	5	0	8428	\N
16782	4172	7	0	8447	\N
16782	4614	8	0	8454	\N
16689	132	7	0	11386	\N
16784	4951	18	1	11628	\N
16707	4912	125	0	11629	\N
16707	2466	126	0	11929	\N
16581	300	6	0	12229	\N
16581	4875	7	0	12232	\N
16538	123	2	0	12866	\N
16538	4862	3	0	12867	\N
16707	4913	125	1	13404	\N
16784	3693	67	1	13547	\N
16771	326	7	0	17442	\N
16771	4946	8	0	17445	\N
16772	4947	126	0	17475	\N
16707	4915	127	0	18232	\N
16784	4952	19	0	18233	\N
16600	143	1	0	18613	\N
16600	142	4	0	18624	\N
16600	3099	5	0	18627	\N
16660	208	9	0	19184	\N
16660	4893	10	0	19202	\N
16620	62	3	0	19836	\N
16620	3344	4	0	19840	\N
16616	164	3	0	21175	\N
16616	3385	4	0	21182	\N
16719	165	1	0	21185	\N
16719	3085	5	0	21195	\N
16687	1601	3	0	21516	\N
16687	488	126	0	21525	\N
16687	4903	127	0	21526	\N
16742	145	8	0	22060	\N
16742	4934	9	0	22062	\N
16609	67	3	0	22187	\N
16680	67	3	0	22188	\N
16609	3749	4	0	22189	\N
16680	3749	4	0	22190	\N
16700	73	2	0	22629	\N
16700	2766	3	0	22630	\N
16766	3350	3	0	24833	\N
16601	411	3	0	25307	\N
16601	3596	4	0	25308	\N
16547	206	6	0	25946	\N
16547	4867	7	0	25952	\N
16532	16	7	0	28651	\N
16532	4723	8	0	28653	\N
16597	96	5	0	29684	\N
16597	4882	6	0	29689	\N
16656	449	7	0	29837	\N
16656	801	8	0	29840	\N
16593	151	3	0	30786	\N
16799	360	3	0	31556	\N
16799	3602	4	0	31557	\N
16697	453	3	0	32811	\N
16697	2838	4	0	32812	\N
16627	14	7	0	39225	\N
16627	3882	8	0	39226	\N
16732	14	3	0	39241	\N
16732	4272	4	0	39244	\N
16710	18	10	0	40147	\N
16710	4919	11	0	40148	\N
16535	23	3	0	40812	\N
16535	3497	4	0	40814	\N
16524	3381	5	0	41918	\N
16574	40	5	0	41940	\N
16574	2714	6	0	41941	\N
16647	40	3	0	42006	\N
16668	40	7	0	42007	\N
16647	372	4	0	42009	\N
16668	4718	8	0	42011	\N
3516	56	0	0	43798	\N
16619	56	4	0	44248	\N
16608	4109	4	0	44249	\N
16619	3373	5	0	44250	\N
16651	56	6	0	44252	\N
16672	56	6	0	44253	\N
16651	4703	7	0	44256	\N
16672	4703	7	0	44257	\N
16677	75	7	0	45212	\N
16677	2859	8	0	45215	\N
16691	113	7	0	48353	\N
16691	4906	8	0	48355	\N
16789	137	3	0	49857	\N
16789	3633	4	0	49864	\N
16739	147	5	0	50021	\N
16739	4932	6	0	50037	\N
16712	187	1	0	51323	\N
16717	187	1	0	51325	\N
16712	186	4	0	51344	\N
16717	186	4	0	51346	\N
16712	3068	5	0	51347	\N
16717	3068	5	0	51349	\N
16604	353	3	0	54663	\N
16604	3766	4	0	54667	\N
16625	451	3	0	55335	\N
16625	3934	4	0	55340	\N
16812	1109	11	0	56189	\N
16688	1914	16	0	58490	\N
16688	4904	17	0	58492	\N
16628	2636	3	0	58810	\N
16628	2837	4	0	58811	\N
16745	3625	10	0	59529	\N
16745	3669	11	0	59553	\N
16723	4926	8	0	1300	\N
16662	367	24	0	3451	\N
16664	367	3	0	3452	\N
16664	3683	4	0	3455	\N
16662	4895	25	0	3456	\N
16810	367	8	0	3472	\N
16810	4959	9	0	3473	\N
16631	262	6	0	3837	\N
16631	4888	7	0	3844	\N
16621	591	3	0	5164	\N
16621	4884	4	0	5165	\N
16611	4178	6	0	5794	\N
16611	4250	7	0	5797	\N
16638	4396	8	0	5801	\N
16643	4178	0	0	5802	\N
16646	4178	3	0	5804	\N
16646	4211	4	0	5805	\N
16669	4178	3	0	5808	\N
16669	4211	4	0	5811	\N
16763	4178	3	0	5825	\N
16764	4178	3	0	5826	\N
16763	4211	4	0	5827	\N
16764	4211	4	0	5828	\N
16773	4178	13	0	5829	\N
16773	4782	14	0	5837	\N
16637	4172	3	0	8425	\N
16637	4275	4	0	8427	\N
16648	4172	3	0	8430	\N
16648	4275	4	0	8431	\N
16682	4415	5	0	8434	\N
16682	4172	8	0	8438	\N
16701	4172	4	0	8440	\N
16701	4219	5	0	8441	\N
16754	4172	3	0	8444	\N
16754	4275	4	0	8450	\N
16791	391	3	0	10579	\N
16791	3660	4	0	10580	\N
16743	1852	126	0	12333	\N
16743	4936	127	0	12334	\N
16769	4943	3	0	12337	\N
16769	1890	4	0	12339	\N
16675	528	7	0	12570	\N
16726	528	5	0	12571	\N
16726	4542	6	0	12572	\N
16675	4899	8	0	12574	\N
16749	528	4	0	12585	\N
16749	3353	5	0	12599	\N
16758	2592	3	0	15932	\N
16758	4939	4	0	15933	\N
16803	3457	4	0	16458	\N
16801	115	4	0	16732	\N
16801	4844	5	0	16733	\N
16657	212	3	0	17229	\N
16657	3639	4	0	17230	\N
16667	167	3	0	17750	\N
16667	4028	4	0	17751	\N
16740	167	8	0	17761	\N
16740	4502	9	0	17764	\N
16599	143	1	0	18612	\N
16599	142	4	0	18623	\N
16599	3099	5	0	18626	\N
16607	4254	4	0	18644	\N
16682	3108	9	1	18800	\N
16633	60	4	0	19495	\N
16633	3894	5	0	19500	\N
16635	198	4	0	20178	\N
16635	4161	5	0	20179	\N
16696	241	9	0	20442	\N
16696	4907	10	0	20444	\N
16617	164	0	0	21176	\N
16618	164	0	0	21177	\N
16767	1324	3	0	21540	\N
16767	488	64	0	21557	\N
16653	336	7	0	22803	\N
16653	3690	8	0	22808	\N
16775	149	3	0	23160	\N
16775	4189	4	0	23161	\N
16780	82	3	0	23862	\N
16780	4505	4	0	23864	\N
16587	69	6	0	24830	\N
16587	4084	7	0	24835	\N
16614	86	4	0	26602	\N
16614	4052	5	0	26603	\N
16665	4896	3	0	27753	\N
16665	4897	4	0	27754	\N
16644	4890	13	0	28657	\N
16721	4923	56	0	30155	\N
16721	54	126	0	30172	\N
16721	4924	127	0	30173	\N
16612	151	3	0	30787	\N
16612	3046	4	0	30789	\N
16674	202	7	0	31170	\N
16640	360	3	0	31548	\N
16640	3602	4	0	31549	\N
16693	431	3	0	34827	\N
16693	3933	4	0	34828	\N
16592	2	3	0	35066	\N
16796	4	11	0	36028	\N
16796	4956	12	0	36034	\N
16596	14	5	0	39213	\N
16596	2720	6	0	39215	\N
16583	4180	7	0	40141	\N
16650	18	6	0	40145	\N
16650	4180	7	0	40146	\N
16793	18	3	0	40149	\N
16793	3621	4	0	40151	\N
16778	23	3	0	40820	\N
16778	3497	4	0	40821	\N
16630	40	3	0	41986	\N
16695	40	2	0	42023	\N
16695	282	3	0	42024	\N
16704	40	3	0	42039	\N
16704	372	4	0	42040	\N
16725	51	5	0	43591	\N
16725	4928	6	0	43594	\N
16798	56	11	0	44260	\N
16798	4958	12	0	44262	\N
16806	71	2	0	44899	\N
16806	1125	3	0	44901	\N
16795	79	4	0	46791	\N
16795	4955	5	0	46793	\N
16676	100	7	0	47649	\N
16676	4826	8	0	47652	\N
16800	100	4	0	47662	\N
16841	100	3	0	47663	\N
16875	100	4	0	47664	\N
16841	3836	4	0	47665	\N
16800	3776	5	0	47666	\N
16875	3776	5	0	47667	\N
16878	102	0	0	47900	\N
16777	113	7	0	48354	\N
16777	4906	8	0	48356	\N
16785	113	3	0	48361	\N
16874	113	4	0	48362	\N
16785	3620	4	0	48367	\N
16874	3677	5	0	48368	\N
16748	119	10	0	48715	\N
16748	3670	11	0	48721	\N
16852	119	3	0	48730	\N
16852	2860	4	0	48733	\N
16836	4969	26	0	50612	\N
16856	170	0	0	50623	\N
16858	170	0	0	50624	\N
16859	170	0	0	50625	\N
16862	170	0	0	50627	\N
16836	170	70	0	50633	\N
16836	4969	71	0	50634	\N
16828	181	3	0	50943	\N
16828	4184	4	0	50944	\N
16716	187	1	0	51324	\N
16716	186	4	0	51345	\N
16716	3068	5	0	51348	\N
16722	4925	43	0	53017	\N
16722	273	44	0	53034	\N
16885	4979	126	0	53035	\N
16885	273	127	0	53046	\N
16705	353	7	0	54664	\N
16705	4909	8	0	54669	\N
16783	353	7	0	54673	\N
16783	4909	8	0	54674	\N
16814	1109	11	0	56191	\N
16814	4966	12	0	56195	\N
16864	841	3	0	57133	\N
16864	3604	4	0	57134	\N
16757	2594	3	0	59221	\N
16757	4938	4	0	59222	\N
16762	4233	3	0	59966	\N
16762	4425	4	0	59967	\N
16768	4100	5	0	1298	\N
16731	3329	3	0	3454	\N
16855	4971	19	0	3845	\N
16855	262	81	0	3860	\N
16855	4972	82	0	3861	\N
16698	4178	4	0	5809	\N
16698	4205	5	0	5812	\N
16706	4178	7	0	5813	\N
16733	4178	3	0	5815	\N
16733	4211	4	0	5817	\N
16706	4396	8	0	5818	\N
16821	4178	3	0	5831	\N
16835	4178	4	0	5832	\N
16821	4211	4	0	5834	\N
16842	4211	4	0	5835	\N
16835	4205	5	0	5836	\N
16866	4178	4	0	5839	\N
16866	4205	5	0	5840	\N
16678	4172	3	0	8435	\N
16692	4172	7	0	8436	\N
16678	4275	4	0	8437	\N
16692	4614	8	0	8439	\N
16802	4172	3	0	8448	\N
16802	4275	4	0	8452	\N
16819	4172	2	0	8458	\N
16851	4172	3	0	8460	\N
16851	4275	4	0	8463	\N
16876	4172	9	0	8464	\N
16876	4977	10	0	8465	\N
16877	4172	4	0	8466	\N
16877	4219	5	0	8467	\N
16894	4172	4	0	8468	\N
16894	4219	5	0	8471	\N
16824	391	2	0	10588	\N
16824	1381	3	0	10590	\N
16690	108	7	0	11773	\N
16690	4905	8	0	11778	\N
16753	3747	4	0	12244	\N
16831	528	3	0	12586	\N
16831	4262	4	0	12594	\N
16714	124	1	0	12858	\N
16714	123	4	0	12868	\N
16714	4862	5	0	12872	\N
16830	233	3	0	13808	\N
16830	3704	4	0	13810	\N
16884	173	4	0	14739	\N
16884	3614	5	0	14740	\N
16896	173	7	0	14746	\N
16896	4982	8	0	14751	\N
16805	4410	4	0	15062	\N
16870	235	13	0	15775	\N
16870	4975	14	0	15779	\N
16786	30	18	0	18147	\N
16786	4954	19	0	18148	\N
16790	142	3	0	18643	\N
16790	4254	4	0	18645	\N
16684	208	2	0	19185	\N
16684	4524	3	0	19194	\N
16681	62	10	0	19837	\N
16681	4900	11	0	19841	\N
16880	198	3	0	20184	\N
16703	145	3	0	22059	\N
16703	4908	4	0	22061	\N
16807	67	2	0	22199	\N
16807	394	3	0	22200	\N
16738	73	5	0	22633	\N
16738	4931	6	0	22634	\N
16823	73	2	0	22637	\N
16823	2766	3	0	22640	\N
16846	82	3	0	23871	\N
16846	4505	4	0	23874	\N
16816	206	2	0	25953	\N
16816	2773	3	0	25954	\N
16844	4074	4	0	26184	\N
16788	244	3	0	27345	\N
16788	4075	4	0	27350	\N
16809	16	0	0	28658	\N
16826	320	4	0	29249	\N
16826	3824	5	0	29250	\N
16720	54	7	0	30168	\N
16720	4922	8	0	30171	\N
16834	202	4	0	31171	\N
16834	3673	5	0	31172	\N
16674	4898	8	0	31173	\N
16843	360	7	0	31564	\N
16804	4	3	0	36029	\N
16837	4	2	0	36030	\N
16837	2751	3	0	36031	\N
16804	3837	4	0	36032	\N
16848	18	4	0	40150	\N
16848	2302	5	0	40152	\N
16711	23	3	0	40813	\N
16711	3497	4	0	40815	\N
16882	56	3	0	44263	\N
16921	56	4	0	44264	\N
16882	4109	4	0	44265	\N
16921	3127	5	0	44266	\N
16891	75	3	0	45246	\N
16891	3855	4	0	45247	\N
16902	75	7	0	45255	\N
16902	3331	8	0	45256	\N
16960	100	1	0	47672	\N
16960	160	2	0	47673	\N
16879	102	11	0	47901	\N
16879	4978	12	0	47903	\N
16969	102	3	0	47920	\N
16969	1388	4	0	47921	\N
17006	137	4	0	49859	\N
17006	4352	5	0	49866	\N
16861	170	0	0	50626	\N
16887	181	3	0	50953	\N
16887	4184	4	0	50955	\N
16907	186	10	0	51343	\N
16907	4985	11	0	51350	\N
16889	4980	103	0	51915	\N
16888	210	3	0	51937	\N
16888	3539	4	0	51940	\N
16889	210	126	0	51941	\N
16889	4981	127	0	51942	\N
17039	273	4	0	53030	\N
17039	3777	5	0	53033	\N
17051	316	3	0	54055	\N
17051	4249	4	0	54057	\N
17025	451	2	0	55337	\N
17058	451	7	0	55338	\N
17025	5006	3	0	55339	\N
17058	4794	8	0	55342	\N
16975	595	2	0	55747	\N
16975	3285	3	0	55748	\N
16813	1109	11	0	56190	\N
17083	1021	4	0	56460	\N
17083	4752	5	0	56462	\N
17114	841	2	0	57135	\N
17114	3316	3	0	57136	\N
16827	1470	3	0	58238	\N
16827	3838	4	0	58242	\N
16840	2636	3	0	58816	\N
16840	2837	4	0	58818	\N
16898	2351	1	0	59018	\N
16899	2351	1	0	59019	\N
16901	2351	1	0	59021	\N
16898	4983	2	0	59022	\N
16899	4983	2	0	59023	\N
16901	4983	2	0	59024	\N
16850	3625	3	0	59530	\N
16850	3784	4	0	59547	\N
17100	4014	3	1	59793	\N
17150	4787	4	0	60272	\N
16991	3003	4	0	188	\N
16956	4995	7	0	1069	\N
17071	266	4	0	1307	\N
17071	4100	5	0	1308	\N
17068	954	3	0	1815	\N
17068	5019	4	0	1816	\N
16811	367	0	0	3461	\N
16854	262	3	0	3858	\N
16854	4778	4	0	3859	\N
16915	4178	3	0	5841	\N
16937	4178	7	0	5843	\N
16915	4211	4	0	5846	\N
16937	4396	8	0	5848	\N
17019	4211	4	0	5859	\N
17088	4178	3	0	5867	\N
17088	4211	4	0	5868	\N
16818	4172	5	0	8456	\N
16818	4634	6	0	8457	\N
17016	4191	2	0	8472	\N
17016	4172	4	0	8475	\N
17016	5004	5	0	8476	\N
17066	123	13	0	12879	\N
17066	5018	14	0	12882	\N
16873	77	4	0	13197	\N
16873	3619	5	0	13200	\N
16857	4764	8	0	13557	\N
16925	92	12	0	15076	\N
16925	4989	13	0	15077	\N
17144	92	3	0	15085	\N
17144	4410	4	0	15088	\N
16934	192	3	0	15351	\N
16934	3790	4	0	15353	\N
17120	38	2	0	16456	\N
17120	4009	3	0	16457	\N
17086	5022	39	0	16745	\N
17086	115	126	0	16752	\N
17086	5023	127	0	16753	\N
17096	5025	6	0	16766	\N
17100	5028	3	0	17964	\N
17100	30	2	0	18120	\N
16927	142	3	0	18657	\N
16927	4254	4	0	18662	\N
17073	60	2	0	19496	\N
17073	4544	3	0	19499	\N
16998	62	5	0	19852	\N
16998	4422	6	0	19853	\N
16911	241	7	0	20459	\N
16911	4987	8	0	20465	\N
17008	64	2	0	20777	\N
16951	164	5	0	21190	\N
16951	4994	6	0	21196	\N
17081	488	4	0	21523	\N
17081	5021	5	0	21524	\N
16966	145	6	0	22063	\N
16966	4998	7	0	22074	\N
16893	336	4	0	22804	\N
16893	3947	5	0	22807	\N
16913	336	3	0	22816	\N
16913	3400	4	0	22818	\N
17031	149	2	0	23167	\N
17031	5008	3	0	23170	\N
16808	4149	4	0	24070	\N
16985	140	5	0	24079	\N
16985	5000	6	0	24080	\N
16839	214	2	0	24444	\N
16929	214	21	0	24445	\N
16839	1259	3	0	24448	\N
16929	4990	22	0	24449	\N
17047	411	4	0	25313	\N
17142	411	9	0	25314	\N
17047	4858	5	0	25315	\N
17142	5039	10	0	25316	\N
17049	206	2	0	25956	\N
16904	94	3	0	26937	\N
17106	16	2	0	28673	\N
17106	388	3	0	28674	\N
16863	54	3	0	30196	\N
16886	54	3	0	30197	\N
16863	3041	4	0	30198	\N
16886	3041	4	0	30199	\N
17123	360	2	0	31584	\N
17123	2767	3	0	31585	\N
16963	230	6	0	32242	\N
16963	4549	7	0	32247	\N
16869	18	13	0	40153	\N
17061	27	4	0	41270	\N
17125	27	2	0	41271	\N
17125	645	3	0	41273	\N
17061	3717	5	0	41275	\N
16953	40	4	0	42064	\N
16953	2796	5	0	42065	\N
17021	40	7	0	42104	\N
17021	4718	8	0	42107	\N
3552	56	0	0	43801	\N
16906	3770	4	0	44902	\N
16822	75	3	0	45213	\N
16822	3855	4	0	45214	\N
16867	75	0	0	45235	\N
16962	75	3	0	45270	\N
16962	3855	4	0	45271	\N
17002	75	2	0	45282	\N
17002	284	3	0	45283	\N
17010	75	5	0	45294	\N
17013	75	2	0	45295	\N
17041	75	3	0	45296	\N
17013	284	3	0	45297	\N
17041	3855	4	0	45298	\N
17010	4484	6	0	45299	\N
16965	79	6	0	46826	\N
16965	4997	7	0	46827	\N
16936	88	7	0	47278	\N
16936	4949	8	0	47279	\N
17053	102	2	0	47942	\N
17053	158	3	0	47943	\N
17000	135	2	0	49588	\N
17005	135	4	0	49589	\N
17000	2722	3	0	49593	\N
17005	4353	5	0	49595	\N
16881	156	3	0	50272	\N
16881	4594	4	0	50273	\N
16833	170	45	0	50622	\N
16833	4968	46	0	50635	\N
16947	4992	103	0	51943	\N
16947	210	126	0	51959	\N
16947	4993	127	0	51960	\N
16995	273	0	0	53027	\N
16997	273	0	0	53029	\N
17060	285	3	0	53573	\N
17060	4496	4	0	53574	\N
17080	353	11	0	54685	\N
17080	5020	12	0	54686	\N
17024	451	3	0	55336	\N
17024	3934	4	0	55341	\N
16974	597	2	0	55993	\N
16989	597	2	0	55994	\N
16974	3286	3	0	56002	\N
16989	3286	3	0	56003	\N
16812	4962	13	0	56113	\N
16959	4432	2	0	56434	\N
16959	1021	3	0	56449	\N
17044	2782	6	0	59371	\N
17057	2782	3	0	59372	\N
17057	3659	4	0	59373	\N
17044	5009	7	0	59374	\N
16853	3628	3	0	59719	\N
16982	3628	2	0	59720	\N
16982	4360	3	0	59722	\N
16853	3785	4	0	59724	\N
17063	4914	26	0	59777	\N
16832	4088	3	0	59845	\N
16832	4506	4	0	59850	\N
16812	4963	13	1	60259	\N
17056	2224	6	0	190	\N
16910	4986	8	0	953	\N
16825	251	2	0	1563	\N
16825	1851	3	0	1568	\N
16812	4960	12	0	1641	\N
16817	373	2	0	5360	\N
16817	4967	3	0	5361	\N
16946	4178	2	0	5849	\N
16946	4247	3	0	5851	\N
17087	4178	3	0	5865	\N
17087	4211	4	0	5866	\N
16872	4172	2	0	8461	\N
16872	4191	3	0	8462	\N
17048	4172	3	0	8479	\N
17048	4275	4	0	8481	\N
17030	4634	6	0	8482	\N
16815	391	2	0	10587	\N
16815	1381	3	0	10589	\N
17020	391	7	0	10597	\N
17020	3662	8	0	10600	\N
16820	123	2	0	12878	\N
16820	1868	3	0	12880	\N
17015	2763	2	0	15078	\N
17015	92	4	0	15086	\N
17015	1078	5	0	15087	\N
16868	4973	63	0	15770	\N
16871	235	13	0	15776	\N
16868	235	126	0	15782	\N
16868	4974	127	0	15783	\N
17018	38	3	0	16455	\N
17018	3457	4	0	16459	\N
17027	1323	23	0	16734	\N
17027	115	110	0	16743	\N
17027	5007	111	0	16744	\N
17098	115	30	0	16767	\N
16838	212	2	0	17235	\N
16838	3616	3	0	17238	\N
17063	326	25	0	17501	\N
16924	30	12	0	18119	\N
16924	4988	13	0	18127	\N
16871	4952	14	1	18234	\N
16977	241	0	0	20460	\N
16950	164	0	0	21178	\N
16952	164	0	0	21179	\N
16971	73	3	0	22638	\N
17007	73	5	0	22639	\N
16971	3040	4	0	22641	\N
17007	4931	6	0	22642	\N
16916	336	3	0	22817	\N
16984	336	5	0	22826	\N
16984	3283	6	0	22830	\N
17095	82	5	0	23872	\N
17095	5024	6	0	23875	\N
16849	224	3	0	25569	\N
16849	3603	4	0	25572	\N
16926	224	4	0	25583	\N
16926	3281	5	0	25584	\N
16829	206	3	0	25955	\N
16829	4584	4	0	25961	\N
16904	2864	4	0	26943	\N
16865	244	3	0	27346	\N
17034	3308	3	0	27349	\N
16865	4075	4	0	27351	\N
16847	42	3	0	27662	\N
16847	3645	4	0	27664	\N
17077	42	4	0	27674	\N
17077	3896	5	0	27677	\N
16933	16	3	0	28659	\N
16933	3634	4	0	28660	\N
17046	16	4	0	28667	\N
17046	3546	5	0	28668	\N
17090	16	3	0	28671	\N
17090	3634	4	0	28675	\N
16943	450	2	0	29853	\N
16845	230	3	0	32231	\N
16845	4181	4	0	32233	\N
16968	230	6	0	32243	\N
16968	4549	7	0	32248	\N
16931	2	3	0	35084	\N
16931	3548	4	0	35088	\N
16979	6	1	0	36314	\N
16979	194	2	0	36315	\N
16918	18	3	0	40156	\N
16941	18	3	0	40157	\N
16918	3621	4	0	40162	\N
16955	40	6	0	42085	\N
16955	2777	7	0	42088	\N
17070	40	4	0	42122	\N
17070	3381	5	0	42126	\N
7493	56	1	0	43919	\N
16928	4109	4	0	44268	\N
16994	56	2	0	44269	\N
16994	2795	3	0	44270	\N
16999	79	2	0	46848	\N
16999	616	3	0	46849	\N
16883	88	3	0	47267	\N
16883	3655	4	0	47268	\N
17101	100	4	0	47685	\N
17101	5029	5	0	47690	\N
16970	102	3	0	47922	\N
16970	3597	4	0	47923	\N
17055	102	5	0	47945	\N
17055	4480	6	0	47950	\N
16983	119	2	0	48731	\N
16983	1879	3	0	48732	\N
17124	121	2	0	49031	\N
17124	2498	3	0	49032	\N
17001	137	2	0	49858	\N
17001	2721	3	0	49862	\N
16972	147	2	0	50022	\N
16987	147	2	0	50023	\N
16972	3287	3	0	50026	\N
16987	3287	3	0	50027	\N
17094	181	2	0	50964	\N
17094	3313	3	0	50965	\N
16939	186	3	0	51360	\N
16939	4294	4	0	51361	\N
16944	210	2	0	51938	\N
16944	1874	3	0	51939	\N
17108	242	2	0	52183	\N
17108	3425	3	0	52184	\N
17040	268	3	0	52836	\N
17040	3815	4	0	52837	\N
16919	285	4	0	53572	\N
16919	3674	5	0	53575	\N
16988	595	2	0	55756	\N
16988	3285	3	0	55774	\N
16917	1109	3	0	56207	\N
16917	3495	4	0	56208	\N
16914	1021	3	0	56448	\N
16914	4551	4	0	56450	\N
17033	1021	4	0	56459	\N
17033	4752	5	0	56461	\N
16903	908	3	0	57717	\N
16903	3591	4	0	57718	\N
17052	5011	46	0	58609	\N
17052	2578	126	0	58612	\N
17052	5012	127	0	58613	\N
16897	2351	3	0	59017	\N
16900	2351	7	0	59020	\N
16897	2845	4	0	59026	\N
16900	4984	8	0	59028	\N
17065	3051	1	0	59452	\N
17065	5017	2	1	59460	\N
16981	3625	2	0	59531	\N
16981	4359	3	0	59544	\N
16954	424	4	0	949	\N
16990	2755	3	0	951	\N
16954	4326	5	0	952	\N
16912	4986	8	0	954	\N
17064	424	0	0	977	\N
17067	954	5	0	1814	\N
17067	953	6	0	1818	\N
16964	1636	8	0	3086	\N
16964	4996	9	0	3099	\N
16932	189	3	0	4941	\N
17092	189	0	0	4942	\N
16932	3782	4	0	4943	\N
16920	4178	4	0	5842	\N
16942	4450	2	0	5845	\N
16920	4205	5	0	5847	\N
16949	4178	2	0	5850	\N
16949	4247	3	0	5852	\N
16958	4178	6	0	5853	\N
16958	4358	7	0	5854	\N
16976	4178	2	0	5855	\N
16986	4178	5	0	5856	\N
16976	4247	3	0	5858	\N
16986	4429	6	0	5860	\N
17036	4178	3	0	5861	\N
17036	4211	4	0	5862	\N
17050	4211	4	0	5864	\N
16940	4172	3	0	8469	\N
16940	4275	4	0	8470	\N
16945	4172	2	0	8473	\N
16945	4191	3	0	8474	\N
17038	4172	3	0	8478	\N
17038	4275	4	0	8480	\N
17079	4172	8	0	8483	\N
17079	4500	9	0	8484	\N
16890	132	3	0	11421	\N
16890	3729	4	0	11423	\N
17065	5016	2	0	12677	\N
16935	402	2	0	14195	\N
16935	2760	3	0	14196	\N
17089	192	3	0	15352	\N
17089	3790	4	0	15354	\N
16967	44	6	0	16139	\N
16967	4999	7	0	16140	\N
17085	115	6	0	16750	\N
17085	4693	7	0	16751	\N
16957	167	6	0	17769	\N
16957	3314	7	0	17772	\N
16905	142	3	0	18656	\N
17122	142	2	0	18658	\N
16905	4254	4	0	18661	\N
17075	60	1	0	19497	\N
17075	61	2	0	19498	\N
16938	67	7	0	22207	\N
17004	67	4	0	22208	\N
17004	5001	5	0	22209	\N
16938	3608	8	0	22210	\N
16930	214	3	0	24446	\N
16930	4991	4	0	24447	\N
16973	224	2	0	25589	\N
16973	3150	3	0	25591	\N
16961	90	3	0	26181	\N
16922	94	4	0	26938	\N
16922	4677	5	0	26944	\N
16923	244	4	0	27347	\N
16923	3778	5	0	27352	\N
17017	16	3	0	28661	\N
17017	3634	4	0	28663	\N
17113	16	2	0	28677	\N
17113	388	3	0	28679	\N
17029	96	2	0	29685	\N
17029	2942	3	0	29688	\N
16892	20	3	0	30496	\N
16892	2844	4	0	30497	\N
17076	3673	5	0	31179	\N
17043	230	6	0	32244	\N
17043	4182	7	0	32246	\N
17117	322	3	0	32495	\N
17117	1105	4	0	32496	\N
16895	18	4	0	40155	\N
16978	18	1	0	40158	\N
17012	18	2	0	40159	\N
16978	19	2	0	40160	\N
17012	1685	3	0	40161	\N
16895	2302	5	0	40164	\N
16908	23	7	0	40832	\N
16908	4146	8	0	40834	\N
16909	4146	8	0	40835	\N
16948	27	3	0	41258	\N
16948	4636	4	0	41260	\N
16980	40	3	0	42086	\N
16980	372	4	0	42087	\N
17140	51	3	0	43592	\N
17140	5038	4	0	43593	\N
17105	56	3	0	44271	\N
17105	4109	4	0	44272	\N
17152	56	3	0	44273	\N
17152	4109	4	0	44274	\N
17219	56	7	0	44275	\N
17219	4791	8	0	44281	\N
17103	100	4	0	47686	\N
17103	5031	5	0	47689	\N
17054	102	4	0	47944	\N
17054	5013	5	0	47949	\N
17003	181	3	0	50954	\N
17003	4184	4	0	50956	\N
17130	186	3	0	51367	\N
17130	4294	4	0	51375	\N
17093	260	2	0	52579	\N
17093	3184	3	0	52580	\N
17138	260	2	0	52584	\N
17138	3184	3	0	52585	\N
17135	268	2	0	52842	\N
17135	2800	3	0	52843	\N
16996	273	0	0	53028	\N
17102	285	4	0	53588	\N
17102	5030	5	0	53589	\N
17119	451	2	0	55354	\N
17119	3317	3	0	55355	\N
17148	1109	5	0	56205	\N
17148	5040	6	0	56206	\N
17226	2351	3	0	59031	\N
17226	2845	4	0	59032	\N
17161	4088	7	0	59846	\N
17161	5049	8	0	59854	\N
17009	5002	6	0	970	\N
17131	5037	4	0	1086	\N
17107	117	2	0	2079	\N
17107	1257	3	0	2081	\N
17011	35	4	0	4130	\N
17011	1875	5	0	4131	\N
17091	189	3	0	4948	\N
17091	3782	4	0	4949	\N
17211	189	4	0	4960	\N
17211	3992	5	0	4961	\N
17111	4178	2	0	5869	\N
17111	4247	3	0	5870	\N
17121	4178	3	0	5871	\N
17128	4178	1	0	5873	\N
17128	4450	2	0	5874	\N
17147	4178	8	0	5878	\N
17147	4237	9	0	5879	\N
17191	4178	3	0	5881	\N
17191	4211	4	0	5882	\N
17084	4172	3	0	8485	\N
17084	4275	4	0	8486	\N
17165	4172	3	0	8487	\N
17165	4275	4	0	8488	\N
17176	4172	4	0	8490	\N
17176	4219	5	0	8493	\N
17109	3716	5	0	11424	\N
17137	132	2	0	11433	\N
17137	2756	3	0	11434	\N
17163	132	10	0	11445	\N
17163	5050	11	0	11446	\N
17168	132	10	0	11463	\N
17168	5050	11	0	11469	\N
17170	300	7	0	12255	\N
17170	5054	8	0	12256	\N
17189	123	9	0	12886	\N
17189	5063	10	0	12888	\N
17069	77	3	0	13198	\N
17074	77	2	0	13207	\N
17074	3853	3	0	13209	\N
17171	258	3	0	14486	\N
17171	4401	4	0	14490	\N
17151	5042	101	0	15768	\N
17151	235	126	0	15780	\N
17151	5043	127	0	15781	\N
17026	115	3	0	16741	\N
17026	3483	4	0	16742	\N
17126	115	3	0	16763	\N
17126	3483	4	0	16764	\N
17098	5027	31	0	16768	\N
17062	3519	5	0	17444	\N
17133	30	4	0	18121	\N
17133	4004	5	0	18125	\N
17082	290	4	0	19066	\N
17082	2759	5	0	19070	\N
17186	198	0	0	20185	\N
17153	488	10	0	21534	\N
17153	5044	11	0	21536	\N
17116	145	0	0	22064	\N
17166	145	126	0	22075	\N
17166	5051	127	0	22079	\N
17028	149	2	0	23166	\N
17028	5008	3	0	23169	\N
17158	5046	8	0	23171	\N
17035	140	3	0	24090	\N
17035	4149	4	0	24098	\N
17072	214	3	0	24469	\N
17072	3496	4	0	24476	\N
17042	69	3	0	24832	\N
17042	4536	4	0	24834	\N
17143	69	3	0	24838	\N
17143	4536	4	0	24847	\N
17014	224	7	0	25590	\N
17014	5003	8	0	25593	\N
17115	224	84	0	25598	\N
17112	3150	3	0	25600	\N
17115	5033	85	0	25605	\N
17023	94	7	0	26939	\N
17023	5005	8	0	26946	\N
17110	244	3	0	27361	\N
17110	5032	4	0	27363	\N
17022	16	7	0	28662	\N
17022	4723	8	0	28664	\N
17037	16	3	0	28665	\N
17037	3634	4	0	28666	\N
17078	16	3	0	28669	\N
17104	16	3	0	28672	\N
17104	3634	4	0	28676	\N
17032	96	1	0	29686	\N
17032	2899	2	0	29687	\N
17207	96	2	0	29697	\N
17207	2347	3	0	29700	\N
17097	151	5	0	30796	\N
17097	5026	6	0	30797	\N
17201	151	3	0	30806	\N
17201	3046	4	0	30810	\N
17045	230	0	0	32245	\N
17214	431	3	0	34832	\N
17118	2	2	0	35085	\N
17173	2	3	0	35086	\N
17118	2789	3	0	35087	\N
17173	3548	4	0	35089	\N
17229	6	6	0	36322	\N
17197	18	4	0	40166	\N
17197	2302	5	0	40170	\N
17162	23	4	0	40840	\N
17162	3189	5	0	40841	\N
17145	27	3	0	41272	\N
17145	4636	4	0	41274	\N
17059	40	3	0	42105	\N
17136	40	2	0	42123	\N
17154	40	10	0	42124	\N
17136	282	3	0	42125	\N
17154	4104	11	0	42127	\N
17319	40	2	0	42181	\N
17319	282	3	0	42182	\N
17338	40	3	0	42200	\N
17338	372	4	0	42202	\N
10571	56	2	0	44044	\N
17310	56	3	0	44276	\N
17310	4109	4	0	44279	\N
17212	75	3	0	45307	\N
17212	3855	4	0	45308	\N
17380	79	8	0	46877	\N
17380	4238	9	0	46880	\N
17303	102	6	0	47946	\N
17303	5086	7	0	47951	\N
17322	121	3	0	49054	\N
17322	4471	4	0	49055	\N
17253	147	6	0	50046	\N
17253	4699	7	0	50047	\N
17292	186	2	0	51368	\N
17292	1850	3	0	51373	\N
17159	210	7	0	51951	\N
17159	5047	8	0	51956	\N
17331	260	9	0	52588	\N
17387	260	5	0	52589	\N
17387	2365	6	0	52590	\N
17331	5097	10	0	52591	\N
17400	353	9	0	54697	\N
17400	5110	10	0	54699	\N
17141	451	4	0	55363	\N
17141	3666	5	0	55364	\N
17208	451	3	0	55370	\N
17208	3934	4	0	55372	\N
17192	793	3	0	56745	\N
17192	2644	4	0	56746	\N
17355	5100	8	0	57294	\N
17355	852	10	0	57299	\N
17355	2945	11	0	57302	\N
17129	1470	3	0	58239	\N
17129	5036	4	0	58243	\N
17222	4233	3	0	59970	\N
17222	4425	4	0	59971	\N
17312	4233	3	0	59979	\N
17312	4425	4	0	59981	\N
17177	5055	5	0	1571	\N
17300	5084	7	0	4154	\N
17248	5073	106	0	4649	\N
17248	365	126	0	4661	\N
17248	5074	127	0	4662	\N
17347	365	0	0	4669	\N
17132	4178	3	0	5875	\N
17146	4178	0	0	5876	\N
17132	4211	4	0	5877	\N
17155	4178	10	0	5880	\N
17155	4665	11	0	5883	\N
17198	4178	3	0	5884	\N
17198	4211	4	0	5885	\N
17259	4331	5	0	5888	\N
17343	4178	3	0	5901	\N
17343	4211	4	0	5903	\N
17386	4178	3	0	5911	\N
17386	4211	4	0	5914	\N
17187	4172	0	0	8491	\N
17217	4172	7	0	8492	\N
17217	4614	8	0	8495	\N
17374	4172	3	0	8502	\N
17374	4275	4	0	8506	\N
17227	391	4	0	10608	\N
17227	3913	5	0	10609	\N
17244	3660	4	0	10617	\N
17169	300	11	0	12254	\N
17169	5053	12	0	12257	\N
17357	528	3	0	12587	\N
17357	5101	4	0	12603	\N
17194	233	4	0	13827	\N
17223	233	3	0	13828	\N
17364	233	5	0	13829	\N
17223	3704	4	0	13834	\N
17194	3775	5	0	13836	\N
17364	3380	6	0	13838	\N
17230	1148	2	0	14197	\N
17230	402	8	0	14209	\N
17232	402	8	0	14210	\N
17232	5068	9	0	14213	\N
17149	235	4	0	15777	\N
17149	3615	5	0	15778	\N
17127	5034	7	0	16769	\N
17127	115	36	0	16778	\N
17127	5035	37	0	16779	\N
17202	212	3	0	17236	\N
17202	3639	4	0	17239	\N
17220	167	6	0	17770	\N
17220	5066	7	0	17771	\N
17234	4147	8	0	17782	\N
17204	60	3	0	19513	\N
17204	3585	4	0	19515	\N
17314	2771	4	0	19518	\N
17314	60	6	0	19526	\N
17314	5088	7	0	19528	\N
17242	62	7	0	19862	\N
17242	4781	8	0	19866	\N
17304	198	4	0	20195	\N
17304	3273	5	0	20196	\N
17368	73	7	0	22651	\N
17368	5104	8	0	22652	\N
17388	5105	124	0	22831	\N
17388	336	126	0	22842	\N
17388	2970	127	0	22843	\N
17324	82	7	0	23879	\N
17324	5090	8	0	23880	\N
17180	140	6	0	24091	\N
17183	140	1	0	24092	\N
17183	3069	2	0	24095	\N
17180	5056	7	0	24099	\N
17269	214	0	0	24470	\N
17276	214	0	0	24474	\N
17274	214	3	0	24498	\N
17139	206	2	0	25957	\N
17139	2773	3	0	25960	\N
17203	86	3	0	26607	\N
17203	3746	4	0	26608	\N
17134	244	4	0	27362	\N
17134	3447	5	0	27364	\N
17215	16	3	0	28681	\N
17215	3634	4	0	28682	\N
17181	96	6	0	29696	\N
17210	96	3	0	29698	\N
17210	2803	4	0	29701	\N
17181	3698	7	0	29702	\N
17174	20	4	0	30507	\N
17279	20	4	0	30510	\N
17279	2975	5	0	30512	\N
17174	3995	5	0	30514	\N
17172	431	3	0	34829	\N
17172	3933	4	0	34830	\N
17333	2	6	0	35104	\N
17333	4825	7	0	35109	\N
17216	4	1	0	36042	\N
17250	4	3	0	36043	\N
17216	3114	2	0	36045	\N
17250	3837	4	0	36047	\N
17296	5082	10	0	39264	\N
17178	18	3	0	40165	\N
17178	3621	4	0	40168	\N
17199	23	6	0	40854	\N
17199	4632	7	0	40855	\N
17286	27	6	0	41286	\N
17286	3715	7	0	41287	\N
17195	40	4	0	42145	\N
17363	75	3	0	45315	\N
17363	3855	4	0	45316	\N
17236	79	3	0	46861	\N
17238	79	2	0	46862	\N
17238	616	3	0	46863	\N
17236	3652	4	0	46864	\N
17275	79	3	0	46875	\N
17275	3652	4	0	46878	\N
17301	102	9	0	47960	\N
17301	5085	10	0	47967	\N
17182	113	6	0	48363	\N
17182	5057	7	0	48369	\N
17239	135	0	0	49590	\N
17237	137	2	0	49860	\N
17237	2721	3	0	49863	\N
17369	156	2	0	50282	\N
17369	4485	3	0	50285	\N
17365	170	5	0	50628	\N
17365	5102	6	0	50632	\N
17175	181	4	0	50976	\N
17175	4058	5	0	50977	\N
17267	200	1	0	51654	\N
17267	2785	2	0	51655	\N
17256	210	3	0	51952	\N
17256	3539	4	0	51955	\N
17265	268	3	0	52846	\N
17265	3815	4	0	52847	\N
17398	353	9	0	54695	\N
17398	5110	10	0	54698	\N
17247	435	1	0	55092	\N
17247	1580	2	0	55095	\N
17254	595	6	0	55757	\N
17254	4698	7	0	55785	\N
17218	841	7	0	57137	\N
17218	5065	8	0	57138	\N
17258	908	5	0	57723	\N
17258	5076	6	0	57726	\N
17196	4088	3	0	59847	\N
17224	4088	3	0	59848	\N
17196	4506	4	0	59851	\N
17224	4506	4	0	59852	\N
17245	4787	3	0	60273	\N
17245	4788	4	0	60276	\N
17150	5041	5	0	60277	\N
17228	4085	7	0	194	\N
17283	3186	4	0	2739	\N
17205	1636	11	0	3109	\N
17205	5064	12	0	3110	\N
17260	35	7	0	4143	\N
17260	5077	8	0	4144	\N
17246	365	2	0	4659	\N
17246	5072	3	0	4660	\N
17272	4178	3	0	5890	\N
17272	4211	4	0	5891	\N
17280	4247	2	0	5892	\N
17280	4178	4	0	5894	\N
17280	4460	5	0	5895	\N
17378	4250	7	0	5908	\N
17231	5069	2	0	8489	\N
17231	4172	8	0	8494	\N
17231	5070	9	0	8496	\N
17281	4191	2	0	8497	\N
17281	4172	4	0	8498	\N
17281	5004	5	0	8499	\N
17382	4172	6	0	8504	\N
17382	4197	7	0	8509	\N
17190	391	4	0	10598	\N
17190	3913	5	0	10599	\N
17394	132	5	0	11465	\N
17384	108	1	0	11774	\N
17384	3022	2	0	11776	\N
17348	300	3	0	12265	\N
17348	3747	4	0	12271	\N
17188	123	9	0	12885	\N
17352	77	3	0	13208	\N
17352	1877	4	0	13210	\N
17157	233	9	0	13825	\N
17160	233	7	0	13826	\N
17157	2580	10	0	13839	\N
17160	5048	8	0	13840	\N
17193	233	1	0	13861	\N
17221	233	0	0	13874	\N
17233	1148	2	0	14199	\N
17233	402	8	0	14211	\N
17230	5068	9	0	14212	\N
17233	5068	9	0	14214	\N
17156	258	10	0	14485	\N
17156	5045	11	0	14493	\N
17225	92	3	0	15098	\N
17225	4410	4	0	15099	\N
17305	235	6	0	15789	\N
17305	3622	7	0	15790	\N
17206	44	3	0	16143	\N
17206	3631	4	0	16145	\N
17262	3631	4	0	16146	\N
17240	38	7	0	16464	\N
17240	5071	8	0	16465	\N
17255	38	3	0	16472	\N
17257	38	1	0	16473	\N
17257	2906	2	0	16474	\N
17255	3457	4	0	16475	\N
17164	1316	3	0	22331	\N
17164	4837	4	0	22333	\N
17263	336	3	0	22827	\N
17263	3400	4	0	22829	\N
17167	5052	11	0	23876	\N
17184	140	1	0	24093	\N
17185	140	1	0	24094	\N
17184	3069	2	0	24096	\N
17185	3069	2	0	24097	\N
17270	214	2	0	24471	\N
17270	1259	3	0	24475	\N
17371	69	3	0	24839	\N
17375	69	2	0	24840	\N
17375	2920	3	0	24846	\N
17371	4536	4	0	24848	\N
17179	206	3	0	25958	\N
17282	3308	2	0	27379	\N
17282	244	4	0	27389	\N
17282	2960	5	0	27390	\N
17235	42	3	0	27675	\N
17235	3645	4	0	27676	\N
17325	42	7	0	27688	\N
17325	5091	8	0	27693	\N
17200	16	3	0	28678	\N
17200	3634	4	0	28680	\N
17360	16	3	0	28684	\N
17360	3634	4	0	28685	\N
17341	449	3	0	29851	\N
17251	33	3	0	31833	\N
17251	3342	4	0	31834	\N
17336	230	9	0	32255	\N
17336	5099	10	0	32256	\N
17389	453	12	0	32837	\N
17389	4339	13	0	32842	\N
17397	5108	4	0	34831	\N
17397	431	10	0	34834	\N
17397	5109	11	0	34835	\N
17213	4	3	0	36041	\N
17213	3837	4	0	36046	\N
17209	14	3	0	39243	\N
17277	14	3	0	39257	\N
17277	4272	4	0	39258	\N
17317	18	3	0	40167	\N
17317	3621	4	0	40169	\N
17289	40	3	0	42159	\N
17289	372	4	0	42160	\N
17320	40	3	0	42199	\N
17320	372	4	0	42201	\N
17345	40	3	0	42217	\N
17376	40	3	0	42218	\N
17345	372	4	0	42219	\N
17376	372	4	0	42220	\N
17307	79	3	0	46876	\N
17307	3652	4	0	46879	\N
17309	88	3	0	47288	\N
17309	3655	4	0	47289	\N
17318	121	3	0	49040	\N
17318	4471	4	0	49041	\N
17293	186	0	0	51369	\N
17297	260	3	0	52586	\N
17297	3399	4	0	52587	\N
17366	285	5	0	53596	\N
17366	5103	6	0	53601	\N
17399	353	9	0	54696	\N
17399	5111	10	0	54701	\N
17330	451	11	0	55371	\N
17330	5096	12	0	55373	\N
17252	597	6	0	55995	\N
17252	4697	7	0	56009	\N
17326	1109	7	0	56215	\N
17326	5092	8	0	56218	\N
17354	5100	8	0	57293	\N
17356	5100	8	0	57295	\N
17354	852	10	0	57298	\N
17356	852	10	0	57300	\N
17354	2945	11	0	57301	\N
17356	2945	11	0	57303	\N
17287	2636	9	0	58817	\N
17287	5079	10	0	58819	\N
17288	2636	6	0	58822	\N
17288	5080	7	0	58823	\N
17316	2636	2	0	58826	\N
17316	2836	3	0	58827	\N
17308	2351	2	0	59037	\N
17308	2754	3	0	59038	\N
17344	2351	3	0	59045	\N
17344	2845	4	0	59047	\N
17188	5061	11	1	59453	\N
17188	5062	12	0	59773	\N
17367	4088	4	0	59849	\N
17367	4089	5	0	59853	\N
17311	4233	1	0	59978	\N
17311	5087	2	0	59980	\N
17249	4787	6	0	60274	\N
17249	5075	7	0	60278	\N
17332	5098	5	0	193	\N
17334	251	1	0	1566	\N
17334	2998	2	0	1567	\N
17266	3514	4	0	1570	\N
17188	5058	10	0	1642	\N
17392	110	7	0	2624	\N
17392	4621	8	0	2626	\N
17299	228	3	0	2752	\N
17299	3186	4	0	2753	\N
17261	1636	0	0	3125	\N
17328	5093	62	0	3862	\N
17327	262	2	0	3872	\N
17327	2743	3	0	3873	\N
17328	5094	69	0	3875	\N
17350	365	3	0	4670	\N
17350	3839	4	0	4671	\N
17241	4178	7	0	5886	\N
17241	4396	8	0	5889	\N
17298	4178	12	0	5893	\N
17298	5083	13	0	5896	\N
17302	4178	6	0	5897	\N
17302	4250	7	0	5898	\N
17321	4178	3	0	5899	\N
17323	4178	7	0	5900	\N
17321	4211	4	0	5902	\N
17373	4178	3	0	5905	\N
17373	4211	4	0	5907	\N
17381	4178	6	0	5909	\N
17381	4250	7	0	5910	\N
17337	4172	3	0	8500	\N
17337	4275	4	0	8501	\N
17379	4172	6	0	8503	\N
17395	4172	5	0	8505	\N
17395	4415	6	0	8507	\N
17379	4197	7	0	8508	\N
17370	391	2	0	10615	\N
17370	1381	3	0	10616	\N
17329	5095	12	0	11470	\N
17188	5060	11	0	11606	\N
17385	108	3	0	11775	\N
17385	4171	4	0	11777	\N
17349	300	2	0	12266	\N
17349	2786	3	0	12270	\N
17188	5059	10	1	12887	\N
17351	123	5	0	12897	\N
17351	3908	6	0	12898	\N
17399	5112	10	1	13546	\N
17295	258	9	0	14487	\N
17295	5081	10	0	14492	\N
17358	3796	4	0	14749	\N
17290	92	1	0	15108	\N
17291	92	2	0	15109	\N
17290	191	2	0	15110	\N
17291	2763	3	0	15111	\N
17188	116	12	1	16765	\N
17243	60	3	0	19514	\N
17243	3585	4	0	19516	\N
17313	2771	4	0	19517	\N
17313	60	6	0	19525	\N
17313	5088	7	0	19527	\N
17372	198	3	0	20205	\N
17359	164	3	0	21215	\N
17361	164	3	0	21216	\N
17362	164	3	0	21217	\N
17359	3385	4	0	21223	\N
17361	3385	4	0	21224	\N
17362	3385	4	0	21225	\N
17390	336	12	0	22839	\N
17390	5106	13	0	22840	\N
17294	149	4	0	23187	\N
17294	4040	5	0	23188	\N
17342	149	3	0	23194	\N
17342	4189	4	0	23196	\N
17273	214	0	0	24473	\N
17306	214	3	0	24517	\N
17306	3496	4	0	24518	\N
17353	411	2	0	25325	\N
17353	3370	3	0	25326	\N
17268	244	4	0	27376	\N
17268	3447	5	0	27377	\N
17285	16	6	0	28683	\N
17285	3369	7	0	28686	\N
17284	96	6	0	29699	\N
17284	5078	7	0	29703	\N
17278	369	2	0	30498	\N
17278	20	4	0	30509	\N
17278	2975	5	0	30511	\N
17377	2844	4	0	30513	\N
17335	230	1	0	32254	\N
17335	1240	2	0	32259	\N
17339	453	3	0	32829	\N
17339	2838	4	0	32830	\N
17315	2	2	0	35103	\N
17315	2789	3	0	35107	\N
17229	5067	7	0	36323	\N
17340	18	3	0	40171	\N
17346	18	3	0	40172	\N
17346	3621	4	0	40174	\N
17435	40	3	0	42232	\N
17435	372	4	0	42235	\N
17579	40	3	0	42301	\N
17579	372	4	0	42302	\N
17424	51	4	0	43597	\N
17424	5119	5	0	43598	\N
17563	56	3	0	44283	\N
17563	4109	4	0	44284	\N
17495	75	2	0	45333	\N
17495	284	3	0	45334	\N
17553	79	3	0	46108	\N
17553	3652	4	0	46113	\N
17439	2758	4	0	46881	\N
17442	2758	4	0	46882	\N
17439	79	7	0	46901	\N
17442	79	7	0	46902	\N
17439	3180	8	0	46904	\N
17442	3180	8	0	46905	\N
17482	147	7	0	50084	\N
17482	5155	8	0	50085	\N
17428	200	2	0	51660	\N
17428	276	3	0	51661	\N
17498	273	2	0	53044	\N
17498	1413	3	0	53045	\N
17422	279	6	0	53263	\N
17422	5117	7	0	53264	\N
17414	324	2	0	54255	\N
17414	3000	3	0	54257	\N
17417	353	2	0	54702	\N
17417	3134	3	0	54703	\N
17434	353	3	0	54704	\N
17434	3766	4	0	54705	\N
17484	595	8	0	55759	\N
17555	595	3	0	55760	\N
17555	3654	4	0	55778	\N
17484	5157	9	0	55787	\N
17464	5142	9	0	56747	\N
17464	793	14	0	56760	\N
17464	3618	15	0	56761	\N
17463	1470	25	0	58250	\N
17463	5141	26	0	58253	\N
17511	1470	14	0	58265	\N
17511	5170	15	0	58267	\N
17569	1545	3	0	58428	\N
17569	5184	4	0	58429	\N
17537	1914	3	0	58499	\N
17537	3637	4	0	58500	\N
17575	4204	4	0	395	\N
17493	2755	3	0	986	\N
17573	5185	37	0	1832	\N
17573	5187	38	0	1834	\N
17393	110	8	0	2625	\N
17393	3710	9	0	2627	\N
17416	5114	2	0	3038	\N
17416	5115	3	0	3039	\N
17402	4178	2	0	5912	\N
17402	4527	3	0	5913	\N
17413	4178	3	0	5915	\N
17413	4211	4	0	5920	\N
17396	4172	2	0	8510	\N
17403	4172	3	0	8512	\N
17403	4275	4	0	8513	\N
17408	4172	6	0	8515	\N
17415	4172	2	0	8516	\N
17415	4285	3	0	8519	\N
17408	4197	7	0	8521	\N
17529	4172	5	0	8531	\N
17544	4172	5	0	8532	\N
17585	4172	9	0	8533	\N
17529	4634	6	0	8538	\N
17544	4415	6	0	8540	\N
17585	4977	10	0	8543	\N
17407	4690	7	0	11468	\N
17518	132	3	0	11475	\N
17518	3729	4	0	11476	\N
17405	300	3	0	12267	\N
17405	3747	4	0	12272	\N
17411	528	3	0	12588	\N
17411	4262	4	0	12595	\N
17410	77	3	0	13225	\N
17410	1877	4	0	13227	\N
17412	173	3	0	14748	\N
17412	3796	4	0	14750	\N
17383	192	3	0	15362	\N
17429	192	3	0	15370	\N
17429	3790	4	0	15371	\N
17409	235	5	0	15795	\N
17409	5113	6	0	15796	\N
17419	38	2	0	16481	\N
17419	2901	3	0	16482	\N
17426	115	8	0	16776	\N
17426	5121	9	0	16777	\N
17425	326	4	0	17470	\N
17425	5120	5	0	17472	\N
17423	208	6	0	19186	\N
17541	208	5	0	19187	\N
17423	5118	7	0	19201	\N
17433	198	3	0	20211	\N
17433	4263	4	0	20218	\N
17420	64	2	0	20791	\N
17533	64	3	0	20792	\N
17420	5116	3	0	20793	\N
17533	4217	4	0	20794	\N
17391	336	9	0	22838	\N
17391	5107	10	0	22841	\N
17452	149	6	0	23195	\N
17452	5130	7	0	23197	\N
17471	264	0	0	23630	\N
17587	4681	7	0	24535	\N
17430	224	4	0	25599	\N
17430	3281	5	0	25603	\N
17418	345	3	0	26302	\N
17418	4763	4	0	26303	\N
17427	86	2	0	26616	\N
17427	3321	3	0	26620	\N
17406	16	3	0	28687	\N
17406	3634	4	0	28688	\N
17444	16	2	0	28689	\N
17444	388	3	0	28690	\N
17445	16	6	0	28691	\N
17508	96	1	0	29705	\N
17508	2899	2	0	29706	\N
17506	449	6	0	29865	\N
17506	5168	7	0	29870	\N
17436	20	3	0	30527	\N
17436	5125	4	0	30528	\N
17421	202	6	0	31192	\N
17421	4079	7	0	31195	\N
17432	5123	29	0	31835	\N
17431	33	4	0	31840	\N
17431	5122	5	0	31842	\N
17432	33	126	0	31844	\N
17534	5176	7	0	32257	\N
17401	230	2	0	32264	\N
17401	3006	3	0	32265	\N
17534	230	13	0	32266	\N
17534	5177	14	0	32268	\N
17458	2	36	0	35105	\N
17458	5137	37	0	35110	\N
17477	2	9	0	35121	\N
17477	5150	10	0	35122	\N
17404	18	3	0	40175	\N
17404	3621	4	0	40176	\N
17578	18	0	0	40184	\N
17525	5172	9	0	40862	\N
17491	27	8	0	41020	\N
17491	5164	9	0	41025	\N
17559	40	3	0	42281	\N
17559	372	4	0	42283	\N
17594	40	5	0	42318	\N
17594	2714	6	0	42319	\N
17704	51	2	0	43601	\N
17704	524	3	0	43605	\N
17526	56	9	0	44278	\N
17526	5173	10	0	44282	\N
17634	56	3	0	44286	\N
17634	4109	4	0	44287	\N
17443	2758	4	0	46883	\N
17443	79	7	0	46903	\N
17443	3180	8	0	46906	\N
17618	102	3	0	47947	\N
17618	3597	4	0	47948	\N
17520	121	2	0	49066	\N
17520	2498	3	0	49067	\N
17485	147	6	0	50090	\N
17610	147	4	0	50092	\N
17610	3877	5	0	50100	\N
17485	5158	7	0	50101	\N
17761	181	3	0	50987	\N
17761	4184	4	0	50992	\N
17693	200	4	0	51682	\N
17693	2811	5	0	51684	\N
17542	210	6	0	51965	\N
17542	3721	7	0	51966	\N
17673	353	10	0	54706	\N
17673	5217	11	0	54713	\N
17539	5181	3	0	55374	\N
17539	3934	4	0	55375	\N
17483	597	8	0	55996	\N
17556	597	3	0	55998	\N
17556	3656	4	0	56004	\N
17483	5156	9	0	56011	\N
17465	793	5	0	56758	\N
17465	5143	6	0	56759	\N
17699	793	1	0	56773	\N
17590	852	2	0	57321	\N
17590	2872	3	0	57322	\N
17739	852	2	0	57328	\N
17739	4236	3	0	57333	\N
17699	4842	3	0	58123	\N
17460	1470	9	0	58248	\N
17460	5139	10	0	58251	\N
17759	1470	3	0	58282	\N
17759	3838	4	0	58283	\N
17710	3628	2	0	59721	\N
17710	4360	3	0	59723	\N
17715	3628	4	0	59747	\N
17715	4375	5	0	59748	\N
17519	4088	3	0	59865	\N
17519	4506	4	0	59868	\N
17775	5251	11	0	1319	\N
17499	4776	3	0	2763	\N
17450	35	18	0	4153	\N
17450	5127	19	0	4155	\N
17513	35	2	0	4162	\N
17513	1191	3	0	4163	\N
17663	35	4	0	4168	\N
17663	1875	5	0	4169	\N
17687	189	2	0	4975	\N
17687	3441	3	0	4977	\N
17496	4178	2	0	5918	\N
17496	4247	3	0	5919	\N
17503	4178	3	0	5924	\N
17570	4178	3	0	5937	\N
17570	4211	4	0	5941	\N
17580	4178	9	0	5946	\N
17580	4682	10	0	5948	\N
17616	4178	3	0	5949	\N
17616	4211	4	0	5950	\N
17675	4178	2	0	5958	\N
17675	4247	3	0	5962	\N
17707	4178	2	0	5965	\N
17707	4247	3	0	5966	\N
17717	4178	4	0	5968	\N
17717	4331	5	0	5970	\N
17722	4247	3	0	5972	\N
17440	4252	4	0	8514	\N
17437	4172	3	0	8517	\N
17446	4172	6	0	8518	\N
17440	4172	7	0	8520	\N
17440	4285	8	0	8522	\N
17446	4197	7	0	8523	\N
17437	5126	4	0	8524	\N
17614	4172	3	0	8535	\N
17614	4275	4	0	8537	\N
17672	4172	2	0	8550	\N
17672	4191	3	0	8551	\N
17489	5162	10	0	10628	\N
17732	132	6	0	11479	\N
17732	4690	7	0	11480	\N
17531	459	3	0	11988	\N
17531	3178	4	0	11989	\N
17598	528	20	0	12589	\N
17598	5195	21	0	12601	\N
17646	173	7	0	14756	\N
17646	5211	8	0	14759	\N
17467	1061	2	0	15797	\N
17467	235	13	0	15808	\N
17467	5146	14	0	15812	\N
17655	5215	5	0	16159	\N
17455	38	8	0	16489	\N
17455	5133	9	0	16490	\N
17472	326	29	0	17471	\N
17472	5148	30	0	17473	\N
17512	167	9	0	17790	\N
17512	5171	10	0	17793	\N
17727	4322	7	0	18841	\N
17727	5231	8	0	18842	\N
17546	60	3	0	19546	\N
17566	60	3	0	19547	\N
17546	3585	4	0	19549	\N
17564	64	6	0	20811	\N
17564	5183	7	0	20815	\N
17480	67	8	0	22215	\N
17480	5153	9	0	22216	\N
17558	67	3	0	22226	\N
17558	3749	4	0	22227	\N
17749	149	4	0	23220	\N
17749	4040	5	0	23221	\N
17474	264	29	0	23632	\N
17666	264	2	0	23634	\N
17666	2780	3	0	23644	\N
17474	5149	30	0	23652	\N
17628	5205	7	0	25966	\N
17684	94	3	0	26940	\N
17684	631	4	0	26945	\N
17530	16	5	0	28694	\N
17530	5175	6	0	28699	\N
17757	96	12	0	29708	\N
17757	5245	13	0	29713	\N
17539	5178	3	0	30911	\N
17630	360	3	0	31599	\N
17630	3602	4	0	31601	\N
17713	33	4	0	31841	\N
17713	5122	5	0	31843	\N
17535	230	13	0	32267	\N
17535	5177	14	0	32269	\N
17600	322	21	0	32501	\N
17600	5198	22	0	32504	\N
17523	14	2	0	39271	\N
17523	1785	3	0	39272	\N
17602	18	2	0	40186	\N
17602	1685	3	0	40187	\N
17637	18	3	0	40189	\N
17637	3621	4	0	40193	\N
17490	5163	9	0	42237	\N
17615	40	3	0	42330	\N
17615	372	4	0	42333	\N
17705	51	3	0	43602	\N
17705	5038	4	0	43606	\N
17509	75	5	0	45356	\N
17509	4484	6	0	45357	\N
17522	75	2	0	45375	\N
17635	75	3	0	45376	\N
17522	284	3	0	45377	\N
17635	3855	4	0	45378	\N
17736	75	11	0	45414	\N
17656	79	2	0	46109	\N
17656	616	3	0	46112	\N
17601	5199	35	0	47674	\N
17601	100	126	0	47692	\N
17601	5200	127	0	47693	\N
17670	5216	35	0	47694	\N
17670	100	126	0	47705	\N
17670	5200	127	0	47706	\N
17716	125	4	0	49294	\N
17716	3356	5	0	49300	\N
17584	135	9	0	49591	\N
17584	5189	10	0	49596	\N
17586	137	9	0	49861	\N
17554	147	3	0	50091	\N
17554	3657	4	0	50099	\N
17676	186	2	0	51370	\N
17676	1850	3	0	51374	\N
17502	200	3	0	51667	\N
17502	3338	4	0	51668	\N
17457	210	36	0	51953	\N
17459	210	17	0	51954	\N
17459	5138	18	0	51957	\N
17457	5136	37	0	51958	\N
17497	324	2	0	54256	\N
17497	2808	3	0	54258	\N
17481	595	8	0	55758	\N
17481	5154	9	0	55788	\N
17611	597	4	0	55999	\N
17611	3733	5	0	56007	\N
17720	793	7	0	56785	\N
17720	5229	8	0	56786	\N
17462	1470	24	0	58249	\N
17462	5140	25	0	58252	\N
17510	1470	9	0	58264	\N
17510	5169	10	0	58266	\N
17536	5179	3	0	58493	\N
17536	3637	4	0	58494	\N
17674	1914	10	0	58501	\N
17674	5218	11	0	58502	\N
17451	5128	46	0	58614	\N
17451	2578	126	0	58617	\N
17451	5129	127	0	58618	\N
17596	5193	82	0	59040	\N
17596	2351	126	0	59049	\N
17596	5194	127	0	59050	\N
17454	2782	7	0	59379	\N
17454	5132	8	0	59382	\N
17623	4233	3	0	59986	\N
17623	4425	4	0	59987	\N
17574	4787	3	0	60291	\N
17574	4788	4	0	60299	\N
17619	3611	4	0	995	\N
17552	251	3	0	1581	\N
17515	3514	4	0	1583	\N
17552	3514	4	0	1584	\N
17631	117	3	0	2080	\N
17631	3653	4	0	2082	\N
17652	117	2	0	2092	\N
17652	1257	3	0	2093	\N
17708	228	2	0	2762	\N
17708	4776	3	0	2764	\N
17694	35	4	0	4178	\N
17694	1875	5	0	4179	\N
17487	4178	8	0	5917	\N
17550	4178	3	0	5929	\N
17561	4178	3	0	5931	\N
17550	4211	4	0	5933	\N
17561	4211	4	0	5935	\N
17572	4178	6	0	5938	\N
17603	4178	2	0	5939	\N
17603	4527	3	0	5940	\N
17572	4250	7	0	5942	\N
17644	4178	7	0	5955	\N
17685	4178	2	0	5959	\N
17685	4247	3	0	5963	\N
17644	5210	8	0	5964	\N
17660	4172	2	0	8544	\N
17649	4172	3	0	8545	\N
17649	5004	4	0	8546	\N
17660	4191	3	0	8547	\N
17680	4172	2	0	8552	\N
17680	4191	3	0	8553	\N
17697	4172	6	0	8556	\N
17697	4365	7	0	8557	\N
17438	3352	4	0	10618	\N
17438	391	7	0	10626	\N
17438	2966	8	0	10627	\N
17725	391	3	0	10636	\N
17528	459	5	0	11980	\N
17528	5174	6	0	11981	\N
17517	233	3	0	13830	\N
17730	233	4	0	13832	\N
17517	3704	4	0	13835	\N
17730	3775	5	0	13837	\N
17696	173	2	0	14757	\N
17696	2102	3	0	14758	\N
17469	1061	2	0	15799	\N
17469	235	5	0	15810	\N
17469	1061	6	0	15811	\N
17612	212	4	0	17237	\N
17592	5192	35	0	18116	\N
17592	30	36	0	18129	\N
17568	60	0	0	19548	\N
17689	488	16	0	21535	\N
17689	5222	17	0	21537	\N
17538	145	3	0	22065	\N
17538	5180	4	0	22067	\N
17582	145	0	0	22076	\N
17473	264	0	0	23631	\N
17479	411	8	0	25331	\N
17479	5152	9	0	25334	\N
17691	224	2	0	25611	\N
17449	16	2	0	28692	\N
17449	388	3	0	28696	\N
17733	16	8	0	28701	\N
17733	5232	9	0	28702	\N
17507	96	3	0	29704	\N
17507	2803	4	0	29707	\N
17536	5178	3	0	30910	\N
17718	230	7	0	32274	\N
17718	5228	8	0	32277	\N
17476	2	3	0	35106	\N
17476	3548	4	0	35108	\N
17667	14	2	0	39281	\N
17441	3779	4	0	40177	\N
17441	18	7	0	40178	\N
17441	3817	8	0	40179	\N
17505	18	6	0	40180	\N
17505	4180	7	0	40181	\N
17545	18	2	0	40182	\N
17577	18	0	0	40183	\N
17545	1685	3	0	40185	\N
17617	18	3	0	40188	\N
17617	3621	4	0	40192	\N
17548	27	3	0	41021	\N
17548	4636	4	0	41023	\N
17547	40	3	0	42234	\N
17547	372	4	0	42236	\N
17565	40	6	0	42282	\N
17565	4255	7	0	42284	\N
17627	40	6	0	42331	\N
17627	4255	7	0	42334	\N
17447	56	6	0	44277	\N
17447	4703	7	0	44280	\N
17501	76	1	0	45335	\N
17501	75	7	0	45344	\N
17448	88	2	0	47300	\N
17448	2799	3	0	47301	\N
17669	100	2	0	47687	\N
17669	633	3	0	47688	\N
17586	5190	10	0	49867	\N
17562	181	3	0	50986	\N
17562	4184	4	0	50991	\N
17678	186	6	0	51371	\N
17678	5219	7	0	51377	\N
17703	186	1	0	51391	\N
17703	187	2	0	51392	\N
17549	200	3	0	51673	\N
17549	3338	4	0	51674	\N
17607	200	10	0	51678	\N
17607	5203	11	0	51679	\N
17629	273	3	0	53051	\N
17629	3638	4	0	53053	\N
17543	279	5	0	53266	\N
17625	279	3	0	53267	\N
17625	3641	4	0	53272	\N
17543	4421	6	0	53277	\N
17605	285	9	0	53598	\N
17613	285	3	0	53599	\N
17613	4496	4	0	53600	\N
17605	5201	10	0	53603	\N
17633	285	3	0	53612	\N
17633	4496	4	0	53613	\N
17662	285	4	0	53630	\N
17662	5030	5	0	53633	\N
17671	316	2	0	54062	\N
17671	1900	3	0	54064	\N
17540	451	3	0	55382	\N
17540	3934	4	0	55383	\N
17609	595	4	0	55761	\N
17609	3878	5	0	55783	\N
17486	597	8	0	55997	\N
17486	5159	9	0	56010	\N
17658	1109	2	0	56216	\N
17658	2809	3	0	56217	\N
17653	1021	6	0	56442	\N
17653	5214	7	0	56447	\N
17466	5144	35	0	56748	\N
17466	793	126	0	56762	\N
17466	5145	127	0	56763	\N
17698	793	2	0	56772	\N
17698	5224	3	0	56887	\N
17588	852	4	0	57320	\N
17588	3319	5	0	57323	\N
17701	4842	3	0	58128	\N
17551	2636	3	0	58835	\N
17551	2837	4	0	58836	\N
17595	2754	2	0	59039	\N
17595	2351	4	0	59046	\N
17595	2925	5	0	59048	\N
17648	2782	7	0	59380	\N
17648	4062	8	0	59381	\N
17709	3625	2	0	59532	\N
17709	4359	3	0	59545	\N
17583	4787	9	0	60292	\N
17583	5188	10	0	60303	\N
17576	3003	4	0	197	\N
17571	5185	6	0	1831	\N
17571	5186	7	0	1833	\N
17701	5227	4	0	1876	\N
17632	5206	50	0	2073	\N
17632	117	126	0	2083	\N
17632	5207	127	0	2084	\N
17651	5213	50	0	2085	\N
17651	117	126	0	2094	\N
17651	5207	127	0	2095	\N
17641	262	3	0	3880	\N
17641	4778	4	0	3883	\N
17461	4178	9	0	5916	\N
17500	4178	2	0	5923	\N
17500	4247	3	0	5925	\N
17504	4178	6	0	5927	\N
17524	4178	2	0	5928	\N
17557	4178	3	0	5930	\N
17524	4247	3	0	5932	\N
17557	4211	4	0	5934	\N
17504	4250	7	0	5936	\N
17622	4178	3	0	5951	\N
17622	4211	4	0	5952	\N
17659	4178	2	0	5956	\N
17659	4247	3	0	5960	\N
17475	4275	4	0	8526	\N
17492	4172	8	0	8527	\N
17492	5165	9	0	8528	\N
17527	4172	3	0	8529	\N
17527	4275	4	0	8530	\N
17589	4172	4	0	8534	\N
17643	4172	5	0	8536	\N
17589	4252	5	0	8539	\N
17643	4415	6	0	8541	\N
17593	391	3	0	10635	\N
17593	3660	4	0	10640	\N
17581	77	3	0	13226	\N
17494	92	2	0	15118	\N
17494	2763	3	0	15122	\N
17468	1061	2	0	15798	\N
17468	235	27	0	15809	\N
17468	5147	28	0	15813	\N
17679	235	2	0	15829	\N
17679	2757	3	0	15830	\N
17665	115	2	0	16792	\N
17665	2797	3	0	16793	\N
17456	5134	19	0	16937	\N
17456	5135	20	0	16938	\N
17597	142	3	0	18659	\N
17453	60	7	0	19537	\N
17453	5131	8	0	19538	\N
17682	164	2	0	21218	\N
17682	1124	3	0	21222	\N
17470	264	0	0	23629	\N
17567	264	3	0	23633	\N
17567	3632	4	0	23645	\N
17560	82	3	0	23885	\N
17560	4505	4	0	23888	\N
17695	214	2	0	24552	\N
17695	1259	3	0	24553	\N
17639	5208	20	0	26170	\N
17639	5209	127	0	26189	\N
17701	5226	3	1	27181	\N
17701	244	2	0	27386	\N
17521	16	2	0	28693	\N
17521	388	3	0	28697	\N
17591	449	4	0	29866	\N
17591	5191	5	0	29869	\N
17514	20	3	0	30541	\N
17514	2844	4	0	30542	\N
17478	431	8	0	34836	\N
17478	5151	9	0	34841	\N
17516	2	2	0	35144	\N
17636	4	3	0	36044	\N
17636	3837	4	0	36048	\N
17532	23	3	0	40874	\N
17532	3497	4	0	40875	\N
17488	27	8	0	41007	\N
17488	5161	9	0	41008	\N
17829	40	3	0	42356	\N
17829	372	4	0	42360	\N
17774	56	10	0	44290	\N
17774	4602	11	0	44291	\N
17706	71	2	0	44916	\N
17706	1125	3	0	44921	\N
17650	76	1	0	45379	\N
17638	75	3	0	45390	\N
17650	75	3	0	45391	\N
17650	1427	4	0	45392	\N
17638	3855	4	0	45393	\N
17771	75	15	0	45437	\N
17771	5250	16	0	45438	\N
17741	3341	5	0	46077	\N
17743	3341	5	0	46079	\N
17741	79	8	0	46116	\N
17743	79	8	0	46118	\N
17741	3180	9	0	46119	\N
17743	3180	9	0	46121	\N
17839	88	6	0	47319	\N
17839	5263	7	0	47326	\N
17599	5196	9	0	47691	\N
17599	100	13	0	47703	\N
17599	5197	14	0	47704	\N
17683	102	3	0	47961	\N
17683	608	4	0	47965	\N
17690	156	16	0	50283	\N
17690	5223	17	0	50287	\N
17814	181	3	0	50988	\N
17814	5260	4	0	50990	\N
17702	186	3	0	51372	\N
17702	3722	4	0	51376	\N
17726	273	3	0	53052	\N
17726	3638	4	0	53054	\N
17781	273	3	0	53058	\N
17781	3638	4	0	53059	\N
17824	273	6	0	53069	\N
17824	4212	7	0	53070	\N
17604	285	5	0	53597	\N
17604	3963	6	0	53602	\N
17677	316	2	0	54063	\N
17677	1900	3	0	54065	\N
17854	595	3	0	55762	\N
17854	3654	4	0	55779	\N
17712	1021	1	0	56457	\N
17712	1022	2	0	56458	\N
17700	793	2	0	56774	\N
17700	4363	3	0	56776	\N
17776	841	4	0	57140	\N
17776	3886	5	0	57142	\N
17738	4420	5	0	57324	\N
17738	5237	6	0	57334	\N
17734	1470	7	0	58274	\N
17734	5233	8	0	58275	\N
17834	1470	7	0	58290	\N
17834	5261	8	0	58293	\N
17724	2351	3	0	59053	\N
17724	2845	4	0	59056	\N
17859	3004	3	0	59465	\N
17714	3625	4	0	59533	\N
17714	4374	5	0	59550	\N
17731	4088	4	0	59866	\N
17731	4089	5	0	59870	\N
17812	4787	2	0	60293	\N
17812	5258	3	0	60298	\N
17735	228	7	0	2779	\N
17654	1636	2	0	3087	\N
17654	4416	3	0	3089	\N
17768	365	7	0	4677	\N
17768	5248	8	0	4683	\N
17686	189	9	0	4974	\N
17686	5220	10	0	4979	\N
17723	716	3	0	5291	\N
17723	4477	4	0	5295	\N
17721	373	7	0	5362	\N
17721	5230	8	0	5365	\N
17606	4178	5	0	5943	\N
17608	4178	2	0	5944	\N
17606	5202	6	0	5947	\N
17640	4178	3	0	5953	\N
17640	4211	4	0	5954	\N
17664	4178	2	0	5957	\N
17664	4247	3	0	5961	\N
17711	4178	4	0	5967	\N
17711	4331	5	0	5969	\N
17746	4178	6	0	5973	\N
17756	4178	12	0	5974	\N
17746	4250	7	0	5975	\N
17756	5083	13	0	5976	\N
17668	4172	2	0	8548	\N
17692	4172	2	0	8554	\N
17692	4191	3	0	8555	\N
17809	4172	10	0	8564	\N
17809	4663	11	0	8565	\N
17645	300	7	0	12268	\N
17645	4572	8	0	12274	\N
17729	233	11	0	13831	\N
17729	1849	12	0	13833	\N
17642	402	3	0	14207	\N
17642	4077	4	0	14208	\N
17753	402	3	0	14217	\N
17753	4077	4	0	14219	\N
17858	4401	4	0	14502	\N
17661	235	4	0	15822	\N
17661	4479	5	0	15823	\N
17819	212	3	0	17244	\N
17819	3639	4	0	17247	\N
17755	167	4	0	17791	\N
17755	4048	5	0	17792	\N
17844	177	4	0	18341	\N
17844	3538	5	0	18346	\N
17624	208	3	0	19188	\N
17624	4490	4	0	19196	\N
17647	198	7	0	20212	\N
17791	198	0	0	20216	\N
17792	198	0	0	20217	\N
17647	5212	8	0	20219	\N
17808	241	1	0	20461	\N
17808	333	2	0	20463	\N
17764	64	3	0	20812	\N
17764	4217	4	0	20814	\N
17688	145	8	0	22080	\N
17688	5221	9	0	22085	\N
17681	149	2	0	23204	\N
17681	1379	3	0	23205	\N
17800	264	3	0	23635	\N
17803	270	2	0	23642	\N
17800	3632	4	0	23646	\N
17738	5236	6	0	27378	\N
17728	16	3	0	28695	\N
17728	3634	4	0	28698	\N
17798	16	3	0	28703	\N
17798	3634	4	0	28704	\N
17621	320	1	0	29276	\N
17621	3058	2	0	29280	\N
17626	54	6	0	30207	\N
17626	5204	7	0	30208	\N
17657	151	2	0	30807	\N
17657	2854	3	0	30809	\N
17853	3499	5	0	30811	\N
17751	5242	9	0	32505	\N
17751	322	70	0	32514	\N
17751	5244	71	1	32601	\N
17620	2	3	0	35171	\N
17620	3548	4	0	35174	\N
17848	14	3	0	39283	\N
17848	4272	4	0	39289	\N
17719	18	7	0	40190	\N
17719	4538	8	0	40195	\N
17795	40	7	0	42332	\N
17795	4718	8	0	42335	\N
17846	40	9	0	42357	\N
17873	40	3	0	42359	\N
17873	372	4	0	42361	\N
17846	4712	10	0	42364	\N
17856	51	3	0	43603	\N
17856	3533	4	0	43604	\N
17820	56	3	0	44294	\N
17820	4109	4	0	44297	\N
17980	56	6	0	44300	\N
17980	4703	7	0	44305	\N
17850	71	2	0	44918	\N
17850	1125	3	0	44922	\N
17736	5235	12	0	45415	\N
17769	75	3	0	45426	\N
17769	3855	4	0	45427	\N
17742	3341	5	0	46078	\N
17760	79	3	0	46110	\N
17760	3652	4	0	46114	\N
17742	79	8	0	46117	\N
17742	3180	9	0	46120	\N
17931	79	4	0	46163	\N
17931	3678	5	0	46169	\N
17969	113	2	0	48364	\N
17974	113	8	0	48365	\N
17969	1899	3	0	48366	\N
17974	5299	9	0	48370	\N
17949	170	3	0	50629	\N
17949	4148	4	0	50630	\N
17797	242	5	0	52192	\N
17797	4562	6	0	52193	\N
17879	260	10	0	52592	\N
17879	5270	11	0	52593	\N
17793	268	7	0	52858	\N
17793	5254	8	0	52862	\N
17740	4516	5	0	54259	\N
17744	4516	5	0	54260	\N
17747	324	6	0	54267	\N
17740	324	8	0	54269	\N
17744	324	8	0	54270	\N
17744	3000	9	0	54273	\N
17740	5239	9	1	54488	\N
17895	451	3	0	55384	\N
17895	3934	4	0	55387	\N
17750	841	4	0	57139	\N
17750	3886	5	0	57141	\N
17964	2636	10	0	58852	\N
17964	5295	11	0	58857	\N
17913	2782	6	0	59385	\N
17913	5279	7	0	59386	\N
17859	5266	4	0	59467	\N
17866	5268	37	0	60398	\N
17955	5290	4	0	60400	\N
17932	4986	8	0	996	\N
17831	251	3	0	1582	\N
17831	3514	4	0	1585	\N
17801	110	3	0	2640	\N
17805	110	5	0	2642	\N
17807	110	7	0	2643	\N
17801	2995	4	0	2644	\N
17805	5256	6	0	2646	\N
17807	5257	8	0	2647	\N
17841	110	7	0	2659	\N
17903	110	7	0	2660	\N
17841	4621	8	0	2667	\N
17903	4621	8	0	2668	\N
17878	3186	4	0	2786	\N
17962	2246	7	0	3169	\N
17962	5294	8	0	3170	\N
17885	367	7	0	3481	\N
17885	4792	8	0	3483	\N
17961	5293	94	0	4093	\N
17961	2111	95	0	4096	\N
17861	35	3	0	4184	\N
17861	3563	4	0	4185	\N
17938	35	3	0	4193	\N
17938	3563	4	0	4195	\N
17872	189	3	0	4976	\N
17762	4178	3	0	5977	\N
17762	4211	4	0	5979	\N
17772	4178	4	0	5981	\N
17772	4205	5	0	5982	\N
17870	4178	4	0	5996	\N
17870	4205	5	0	6000	\N
17921	4178	4	0	6005	\N
17921	4205	5	0	6007	\N
17992	4178	12	0	6014	\N
17992	5304	13	0	6015	\N
17770	4172	15	0	8558	\N
17783	4172	3	0	8559	\N
17770	5249	16	0	8563	\N
17875	4172	4	0	8570	\N
17875	4219	5	0	8571	\N
17933	4172	4	0	8578	\N
17933	4219	5	0	8579	\N
17990	4172	5	0	8580	\N
17990	4415	6	0	8583	\N
17816	132	3	0	11483	\N
17816	1423	4	0	11484	\N
17993	77	3	0	13247	\N
17766	258	7	0	14488	\N
17766	5247	8	0	14491	\N
17882	2761	2	0	15373	\N
17880	192	4	0	15382	\N
17880	2944	5	0	15384	\N
17789	927	3	0	19166	\N
17789	5253	4	0	19173	\N
17785	198	3	0	20225	\N
17785	4263	4	0	20227	\N
17948	64	7	0	20813	\N
17948	5286	8	0	20816	\N
17866	4889	36	0	22086	\N
17866	5269	37	0	22089	\N
17863	67	4	0	22232	\N
17827	214	4	0	24558	\N
17827	3807	5	0	24560	\N
17758	69	12	0	24841	\N
17758	5246	13	0	24851	\N
17780	411	6	0	25332	\N
17780	5252	7	0	25333	\N
17927	3806	4	0	25604	\N
17927	224	5	0	25616	\N
17810	94	2	0	26947	\N
17810	2043	3	0	26948	\N
17818	16	3	0	28705	\N
17818	3634	4	0	28706	\N
17979	320	3	0	29278	\N
17908	4528	3	0	29281	\N
17979	4821	4	0	29282	\N
17937	449	3	0	29867	\N
17937	4760	4	0	29868	\N
17943	449	3	0	29877	\N
17943	4760	4	0	29880	\N
17837	54	6	0	30217	\N
17837	5204	7	0	30220	\N
17832	20	0	0	30547	\N
17754	202	3	0	31193	\N
17754	4857	4	0	31194	\N
17897	5275	18	0	31201	\N
17851	360	3	0	31605	\N
17851	3602	4	0	31606	\N
17890	360	6	0	31613	\N
17890	5271	7	0	31622	\N
17963	230	3	0	32279	\N
17963	4181	4	0	32280	\N
17922	2	3	0	35173	\N
17922	3548	4	0	35175	\N
17847	3381	5	0	42362	\N
17883	282	2	0	42363	\N
17883	40	4	0	42387	\N
17883	1383	5	0	42389	\N
17737	3551	5	0	44285	\N
17737	56	8	0	44288	\N
17737	2914	9	0	44289	\N
17876	56	4	0	44298	\N
17991	56	5	0	44301	\N
17876	3127	5	0	44302	\N
17991	3551	6	0	44304	\N
17806	71	5	0	44917	\N
17806	4033	6	0	44924	\N
17929	79	4	0	46161	\N
17929	3678	5	0	46168	\N
17923	100	3	0	47701	\N
17923	3836	4	0	47702	\N
18013	102	7	0	47963	\N
18013	5310	8	0	47966	\N
18015	242	4	0	52205	\N
18015	3512	5	0	52206	\N
17987	273	4	0	53077	\N
17987	3390	5	0	53078	\N
17748	324	6	0	54268	\N
17748	5241	7	0	54272	\N
17857	597	3	0	56000	\N
17857	3656	4	0	56005	\N
17745	4420	5	0	57325	\N
17745	852	6	0	57336	\N
17833	1470	7	0	58289	\N
17833	5261	8	0	58292	\N
17918	1470	3	0	58299	\N
17918	3838	4	0	58300	\N
17967	1470	2	0	58309	\N
17967	3368	3	0	58311	\N
17997	4088	3	0	59867	\N
17997	4506	4	0	59869	\N
17877	3003	4	0	198	\N
17894	3003	4	0	200	\N
17940	12	3	0	407	\N
17940	4204	4	0	409	\N
17966	251	10	0	1599	\N
17966	5297	11	0	1600	\N
17901	117	7	0	2126	\N
17901	5276	8	0	2127	\N
17838	110	6	0	2658	\N
17905	110	10	0	2661	\N
17838	3917	7	0	2666	\N
17905	5277	11	0	2670	\N
17884	367	7	0	3480	\N
17763	262	3	0	3881	\N
17763	4778	4	0	3884	\N
17960	2111	6	0	4094	\N
17960	5292	7	0	4095	\N
17939	35	4	0	4194	\N
17939	3545	5	0	4196	\N
17900	365	7	0	4678	\N
17900	5248	8	0	4684	\N
17767	4178	7	0	5978	\N
17767	4396	8	0	5980	\N
17799	4178	3	0	5985	\N
17821	4178	4	0	5986	\N
17821	4205	5	0	5988	\N
17852	4178	4	0	5989	\N
17862	4178	4	0	5990	\N
17852	4205	5	0	5992	\N
17862	4205	5	0	5993	\N
17906	4178	2	0	6002	\N
17906	4527	3	0	6003	\N
17917	4178	3	0	6004	\N
17917	4211	4	0	6006	\N
17928	4178	4	0	6008	\N
17928	4205	5	0	6009	\N
18020	4178	4	0	6016	\N
17823	4172	3	0	8567	\N
17823	4275	4	0	8568	\N
17893	4172	3	0	8573	\N
17911	4172	6	0	8574	\N
17893	4275	4	0	8575	\N
17911	5278	7	0	8577	\N
18025	4172	2	0	8584	\N
18025	4191	3	0	8586	\N
17828	391	3	0	10637	\N
17910	391	2	0	10638	\N
17910	2966	3	0	10639	\N
17828	3660	4	0	10642	\N
17907	2927	3	0	11494	\N
17786	528	3	0	12590	\N
17786	4262	4	0	12596	\N
17995	233	3	0	13851	\N
17995	3704	4	0	13858	\N
17765	402	3	0	14218	\N
17765	4077	4	0	14220	\N
17871	92	4	0	15120	\N
17871	3979	5	0	15123	\N
17882	192	4	0	15383	\N
17882	2944	5	0	15385	\N
17813	38	3	0	16499	\N
17843	60	4	0	19559	\N
17843	3894	5	0	19562	\N
17946	62	7	0	19863	\N
17946	4781	8	0	19867	\N
17790	198	0	0	20215	\N
17986	241	4	0	20462	\N
17986	2122	5	0	20464	\N
18002	164	3	0	21219	\N
18004	164	3	0	21220	\N
18002	3385	4	0	21226	\N
18004	3385	4	0	21227	\N
18018	73	3	0	22660	\N
17924	264	3	0	23637	\N
17924	3632	4	0	23647	\N
17778	140	0	0	24118	\N
17889	42	6	0	27689	\N
18028	42	3	0	27690	\N
18028	3645	4	0	27691	\N
17889	1945	7	0	27692	\N
17972	16	7	0	28707	\N
17977	16	4	0	28708	\N
17977	2575	5	0	28709	\N
17972	4723	8	0	28710	\N
17912	96	6	0	29709	\N
17957	54	4	0	30218	\N
17957	3685	5	0	30219	\N
17888	151	4	0	30819	\N
17888	1876	5	0	30820	\N
17752	360	3	0	31600	\N
17752	3602	4	0	31602	\N
17892	360	4	0	31614	\N
17892	3513	5	0	31621	\N
17811	230	2	0	32275	\N
17811	3006	3	0	32276	\N
18041	2	2	0	35045	\N
17935	2	3	0	35191	\N
17802	18	3	0	40191	\N
17802	3621	4	0	40194	\N
17842	18	6	0	40196	\N
17842	4180	7	0	40197	\N
17902	18	7	0	40198	\N
17902	1618	8	0	40202	\N
17773	23	4	0	40881	\N
17934	23	2	0	40883	\N
17934	3443	3	0	40886	\N
17773	3189	5	0	40889	\N
17952	27	3	0	41022	\N
17952	4636	4	0	41024	\N
17970	40	2	0	42385	\N
17971	40	2	0	42386	\N
17970	282	3	0	42388	\N
17971	66	3	0	42390	\N
10669	56	5	0	44045	\N
10752	56	7	0	44054	\N
17815	56	3	0	44293	\N
17815	4102	4	0	44295	\N
17788	4109	4	0	44296	\N
18009	56	4	0	44306	\N
18009	3127	5	0	44308	\N
17904	71	7	0	44919	\N
18051	71	3	0	44920	\N
18051	3770	4	0	44923	\N
17904	4793	8	0	44925	\N
17982	75	8	0	45447	\N
17982	5302	9	0	45448	\N
17915	79	3	0	46111	\N
17915	3652	4	0	46115	\N
17925	79	3	0	46160	\N
17930	79	4	0	46162	\N
17925	3652	4	0	46167	\N
17836	88	4	0	47318	\N
17836	5262	5	0	47324	\N
17989	135	3	0	49592	\N
17989	3630	4	0	49594	\N
17988	137	3	0	49890	\N
17988	3633	4	0	49893	\N
17855	5264	19	0	50086	\N
17855	147	126	0	50102	\N
17855	5265	127	0	50103	\N
17826	181	4	0	50989	\N
17826	4058	5	0	50993	\N
17916	242	7	0	52199	\N
17916	4592	8	0	52200	\N
17985	260	3	0	52594	\N
17985	3399	4	0	52595	\N
18022	260	6	0	52596	\N
18022	5311	7	0	52597	\N
17896	5273	104	0	55376	\N
18034	451	15	0	55385	\N
18035	451	4	0	55386	\N
18035	3391	5	0	55388	\N
18034	5312	16	0	55389	\N
17896	451	126	0	55390	\N
17896	5274	127	0	55391	\N
17959	1021	59	0	56473	\N
17959	5291	60	0	56474	\N
18057	1048	2	0	56475	\N
17849	841	3	0	57143	\N
17849	3604	4	0	57144	\N
17930	2435	5	1	57959	\N
17835	1470	7	0	58291	\N
17835	5261	8	0	58294	\N
18027	1470	2	0	58310	\N
18027	3368	3	0	58312	\N
18054	2636	3	0	58853	\N
18054	5314	4	0	58855	\N
17999	4233	5	0	59992	\N
17999	4518	6	0	59995	\N
17891	251	6	0	1594	\N
17975	5300	9	0	1682	\N
17865	117	3	0	2114	\N
17865	3653	4	0	2115	\N
17976	117	4	0	2134	\N
17976	4169	5	0	2138	\N
17804	110	5	0	2641	\N
17804	5256	6	0	2645	\N
17860	228	3	0	2780	\N
17860	3186	4	0	2785	\N
17779	367	0	0	3471	\N
17909	365	2	0	4679	\N
17944	365	3	0	4680	\N
17944	3839	4	0	4682	\N
17782	4178	3	0	5983	\N
17782	4211	4	0	5984	\N
17867	4178	8	0	5991	\N
17867	4218	9	0	5994	\N
17881	4247	2	0	5995	\N
17899	4178	7	0	5997	\N
17881	4178	4	0	5998	\N
17881	4460	5	0	5999	\N
17899	4396	8	0	6001	\N
17984	4178	8	0	6012	\N
17984	4237	9	0	6013	\N
17796	4285	3	0	8561	\N
17822	4172	4	0	8566	\N
17822	4219	5	0	8569	\N
17926	4219	4	0	8572	\N
17926	4172	5	0	8576	\N
18037	4172	3	0	8585	\N
18037	4275	4	0	8587	\N
18047	4172	2	0	8590	\N
18047	4191	3	0	8591	\N
18036	391	3	0	10651	\N
18036	3660	4	0	10655	\N
18017	402	3	0	14223	\N
17869	92	1	0	15119	\N
17869	1078	2	0	15121	\N
17919	5281	0	0	15218	\N
17920	212	2	0	17245	\N
17920	3616	3	0	17246	\N
17919	5282	0	0	18142	\N
17956	142	3	0	18676	\N
17956	4254	4	0	18680	\N
17845	60	3	0	19560	\N
17845	3585	4	0	19561	\N
17784	198	0	0	20213	\N
17868	73	9	0	22655	\N
17794	149	7	0	23229	\N
17794	5255	8	0	23232	\N
17951	140	4	0	24119	\N
17951	3821	5	0	24120	\N
17975	69	8	0	24843	\N
17975	5301	9	1	24918	\N
17777	206	3	0	25964	\N
17777	4584	4	0	25965	\N
17864	206	4	0	25967	\N
17864	3511	5	0	25968	\N
17874	86	4	0	26617	\N
17874	4052	5	0	26623	\N
17983	94	8	0	26950	\N
17914	5280	7	0	26951	\N
17983	5303	9	0	26952	\N
18010	16	4	0	28711	\N
18010	3546	5	0	28713	\N
18031	16	3	0	28717	\N
18031	3634	4	0	28720	\N
18049	16	2	0	28721	\N
18049	388	3	0	28723	\N
17887	151	6	0	30818	\N
17887	3588	7	0	30821	\N
17950	151	3	0	30832	\N
18006	151	6	0	30843	\N
18006	5308	7	1	30903	\N
17840	678	0	0	30916	\N
17945	33	7	0	31854	\N
17945	5284	8	0	31861	\N
17825	2	6	0	35172	\N
17825	4825	7	0	35176	\N
17965	2	10	0	35192	\N
17965	5296	11	0	35194	\N
17830	14	3	0	39282	\N
17830	4272	4	0	39288	\N
17898	23	17	0	40882	\N
18001	40	5	0	41768	\N
18001	2714	6	0	41769	\N
17981	40	6	0	42147	\N
11025	56	1	0	44064	\N
17958	3127	5	0	44303	\N
18101	56	4	0	44307	\N
18101	3556	5	0	44309	\N
18110	56	3	0	44310	\N
18110	4109	4	0	44311	\N
17930	5283	5	0	46058	\N
18044	88	3	0	47320	\N
18086	88	7	0	47321	\N
18044	3655	4	0	47323	\N
18086	5323	8	0	47327	\N
18012	102	2	0	47962	\N
18012	3053	3	0	47964	\N
18024	113	4	0	48377	\N
18024	3677	5	0	48378	\N
18039	181	2	0	51009	\N
18070	181	2	0	51010	\N
18039	3313	3	0	51011	\N
18070	3313	3	0	51012	\N
18000	285	5	0	53631	\N
18000	5103	6	0	53634	\N
18042	435	19	0	55093	\N
18042	5313	20	0	55097	\N
18072	793	2	0	56794	\N
18072	4363	3	0	56795	\N
17942	2636	3	0	58844	\N
17942	2837	4	0	58845	\N
18056	2636	3	0	58854	\N
18056	5314	4	0	58856	\N
18120	2351	3	0	59054	\N
18131	2351	3	0	59055	\N
18120	2845	4	0	59057	\N
18131	2845	4	0	59058	\N
18145	4088	2	0	59873	\N
18145	4332	3	0	59882	\N
18016	4233	3	0	59993	\N
18016	4425	4	0	59994	\N
17941	4043	5	0	410	\N
18147	12	2	0	417	\N
18147	2804	3	0	418	\N
18128	5332	8	0	421	\N
18026	266	2	0	1317	\N
18026	2103	3	0	1318	\N
18033	117	4	0	2135	\N
18033	4169	5	0	2139	\N
18063	110	1	0	2662	\N
18065	110	3	0	2663	\N
18063	134	2	0	2664	\N
18065	3328	4	0	2665	\N
18050	228	3	0	2782	\N
18155	189	14	0	4988	\N
18155	5340	15	0	4990	\N
18075	1151	7	0	5193	\N
18075	5321	8	0	5195	\N
18059	373	6	0	5363	\N
18059	5316	7	0	5364	\N
17968	4178	2	0	6010	\N
17968	4247	3	0	6011	\N
18023	4178	3	0	6017	\N
18023	4211	4	0	6018	\N
18046	4178	3	0	6020	\N
18046	4441	4	0	6021	\N
17998	4191	3	0	8582	\N
18038	4172	2	0	8588	\N
18038	4191	3	0	8589	\N
18113	4172	2	0	8598	\N
18125	4172	5	0	8599	\N
18113	4191	3	0	8600	\N
18125	4415	6	0	8601	\N
18154	5339	13	0	11485	\N
18030	132	3	0	11492	\N
18048	132	2	0	11493	\N
18048	2756	3	0	11495	\N
18030	3729	4	0	11496	\N
18154	2927	17	0	11498	\N
17994	5305	20	0	13229	\N
17993	1877	4	0	13248	\N
17994	77	98	0	13249	\N
17994	5306	99	0	13250	\N
18096	258	2	0	14509	\N
18096	3275	3	0	14513	\N
18055	960	3	0	15224	\N
18055	5315	4	0	15230	\N
18058	38	6	0	16500	\N
18058	3276	7	0	16509	\N
18084	62	7	0	19864	\N
18108	1807	4	0	21228	\N
18160	145	6	0	22066	\N
18160	5341	7	0	22068	\N
18019	73	2	0	22661	\N
18019	2766	3	0	22662	\N
18040	336	2	0	22856	\N
18040	3332	3	0	22857	\N
17978	140	4	0	24131	\N
17978	3821	5	0	24132	\N
18029	140	3	0	24141	\N
18029	4149	4	0	24143	\N
17973	69	8	0	24842	\N
18078	224	2	0	25612	\N
18078	3150	3	0	25615	\N
17996	94	3	0	26953	\N
18076	94	5	0	26954	\N
17996	2864	4	0	26955	\N
18076	4547	6	0	26956	\N
18068	42	2	0	27700	\N
18068	3310	3	0	27702	\N
18011	16	5	0	28712	\N
18011	5175	6	0	28714	\N
18021	16	4	0	28715	\N
18021	3546	5	0	28716	\N
18032	388	3	0	28719	\N
18098	16	2	0	28722	\N
18098	388	3	0	28724	\N
18005	151	6	0	30842	\N
17954	202	3	0	31211	\N
17954	4857	4	0	31219	\N
18073	360	4	0	31615	\N
18073	4330	5	0	31623	\N
17947	230	7	0	32278	\N
17947	5285	8	0	32281	\N
18007	453	10	0	32838	\N
18008	453	4	0	32839	\N
18007	5309	11	0	32841	\N
18150	5336	13	0	32843	\N
18152	5336	13	0	32845	\N
18091	453	3	0	32853	\N
18091	2838	4	0	32856	\N
18150	453	16	0	32857	\N
18152	453	16	0	32859	\N
18150	3133	17	0	32860	\N
18152	3133	17	0	32862	\N
18066	2	1	0	35060	\N
18066	26	2	0	35061	\N
18061	18	6	0	40199	\N
18093	3621	4	0	40201	\N
18061	5318	7	0	40203	\N
17936	23	3	0	40884	\N
17936	3497	4	0	40888	\N
17953	5287	62	0	41009	\N
17953	27	126	0	41026	\N
17953	5288	127	0	41027	\N
18089	5287	62	0	41028	\N
18089	27	126	0	41072	\N
18089	5324	127	0	41073	\N
18003	40	0	0	41798	\N
18014	40	7	0	41813	\N
18187	5350	6	1	42745	\N
18168	56	10	0	44318	\N
18168	4602	11	0	44319	\N
18199	56	4	0	44322	\N
18199	3556	5	0	44325	\N
18193	5359	6	0	46057	\N
18138	79	7	0	46164	\N
18179	79	2	0	46165	\N
18179	616	3	0	46166	\N
18138	4063	8	0	46170	\N
18189	79	5	0	46246	\N
18193	79	5	0	46247	\N
18196	79	5	0	46248	\N
18189	3341	6	0	46249	\N
18196	5360	6	0	46884	\N
18092	113	3	0	48391	\N
18092	3620	4	0	48394	\N
18215	121	4	0	49080	\N
18217	121	0	0	49081	\N
18215	4099	5	0	49082	\N
18074	135	4	0	49614	\N
18074	4353	5	0	49615	\N
18267	135	2	0	49630	\N
18267	2722	3	0	49632	\N
18134	186	2	0	51389	\N
18134	1850	3	0	51390	\N
18211	285	10	0	53632	\N
18211	5366	11	0	53635	\N
18094	324	2	0	54280	\N
18094	2808	3	0	54281	\N
18213	451	10	0	55400	\N
18213	5367	11	0	55405	\N
18292	595	3	0	55763	\N
18292	3654	4	0	55780	\N
18275	1109	4	0	56226	\N
18275	4535	5	0	56227	\N
18177	5345	0	0	56501	\N
18248	2644	3	0	56787	\N
18248	793	4	0	56796	\N
18119	841	3	0	57145	\N
18119	3604	4	0	57149	\N
18208	852	1	0	57330	\N
18208	2945	2	0	57332	\N
18192	5357	8	1	58564	\N
18193	2519	6	1	58569	\N
18099	2636	2	0	58865	\N
18099	2836	3	0	58866	\N
18161	2351	4	0	59061	\N
18161	3494	5	0	59066	\N
18192	5356	8	0	59781	\N
18196	4014	7	0	59786	\N
18177	5344	0	0	59800	\N
18192	5355	7	1	60178	\N
18102	5325	3	0	60179	\N
18192	5352	6	0	60261	\N
18186	4787	5	0	60295	\N
18186	5349	6	0	60301	\N
18121	251	3	0	1607	\N
18192	5353	6	1	1638	\N
18287	110	4	0	2676	\N
18287	4552	5	0	2687	\N
18257	367	1	0	3498	\N
18257	3225	2	0	3500	\N
18067	5319	3	0	3648	\N
18067	5320	4	0	3649	\N
18305	5319	2	0	3650	\N
18305	5383	3	0	3652	\N
18192	5354	7	0	4734	\N
18182	189	3	0	4996	\N
18192	189	5	0	4998	\N
18052	4178	4	0	6022	\N
18052	4331	5	0	6023	\N
18082	4178	2	0	6024	\N
18082	4247	3	0	6025	\N
18112	4178	2	0	6026	\N
18136	4178	7	0	6027	\N
18112	4247	3	0	6029	\N
18136	4509	8	0	6031	\N
18165	4178	3	0	6034	\N
18165	4211	4	0	6035	\N
18171	4178	6	0	6036	\N
18171	4250	7	0	6037	\N
18297	4178	2	0	6051	\N
18318	4178	2	0	6052	\N
18297	4247	3	0	6054	\N
18273	4429	6	0	6057	\N
18080	4172	3	0	8592	\N
18080	4275	4	0	8593	\N
18129	4172	4	0	8602	\N
18129	4252	5	0	8603	\N
18184	4172	0	0	8611	\N
18229	4172	3	0	8614	\N
18229	4275	4	0	8615	\N
18285	4172	3	0	8621	\N
18196	3593	6	1	13418	\N
18124	142	5	0	18677	\N
18124	3781	6	0	18681	\N
18197	60	2	0	19600	\N
18198	60	2	0	19601	\N
18197	4544	3	0	19607	\N
18198	4544	3	0	19608	\N
18126	241	58	0	20474	\N
18126	5331	59	0	20484	\N
18109	5327	16	0	21197	\N
18109	164	17	0	21229	\N
18178	488	2	0	21550	\N
18187	1075	7	0	22069	\N
18193	1075	7	0	22070	\N
18192	5358	9	0	22073	\N
18238	336	2	0	22867	\N
18238	3332	3	0	22870	\N
18143	149	5	0	23230	\N
18143	3808	6	0	23231	\N
18158	149	7	0	23239	\N
18158	5255	8	0	23240	\N
18163	82	4	0	23886	\N
18163	3508	5	0	23890	\N
18174	140	5	0	24151	\N
18307	86	3	0	26619	\N
18307	3746	4	0	26622	\N
18240	94	2	0	26957	\N
18279	94	2	0	26958	\N
18240	2794	3	0	26959	\N
18279	2794	3	0	26960	\N
18269	244	1	0	27387	\N
18269	245	2	0	27388	\N
18224	42	5	0	27701	\N
18224	4860	6	0	27703	\N
18102	388	2	0	28725	\N
18102	5326	3	0	28726	\N
18251	388	3	0	28734	\N
18180	96	3	0	29710	\N
18180	2803	4	0	29711	\N
18245	230	2	0	32283	\N
18245	3307	3	0	32285	\N
18041	2789	3	0	35047	\N
18169	2	3	0	35072	\N
18169	3548	4	0	35074	\N
18043	4	3	0	36057	\N
18043	3837	4	0	36058	\N
18140	18	2	0	40206	\N
18255	18	2	0	40207	\N
18255	1685	3	0	40209	\N
18045	40	3	0	41814	\N
18045	372	4	0	41817	\N
18187	40	5	0	41830	\N
18210	40	3	0	41831	\N
18210	1921	4	0	41834	\N
11249	56	5	0	44082	\N
18148	56	3	0	44315	\N
18133	2795	3	0	44316	\N
18148	4109	4	0	44317	\N
18253	75	2	0	45466	\N
18253	284	3	0	45471	\N
18243	79	5	0	46298	\N
18243	3341	6	0	46300	\N
18204	113	6	0	48392	\N
18204	5363	7	0	48396	\N
18111	121	2	0	49076	\N
18111	2498	3	0	49077	\N
18319	135	2	0	49631	\N
18319	2722	3	0	49633	\N
18282	156	5	0	50295	\N
18282	4295	6	0	50296	\N
18077	170	2	0	50645	\N
18077	1380	3	0	50646	\N
18176	170	11	0	50655	\N
18176	3880	12	0	50656	\N
18172	210	6	0	51973	\N
18172	3721	7	0	51975	\N
18218	273	5	0	53088	\N
18218	5368	6	0	53091	\N
18222	5369	14	0	55098	\N
18222	435	15	0	55103	\N
18212	451	3	0	55399	\N
18212	5274	4	0	55404	\N
18057	1021	4	0	56490	\N
18057	1022	5	0	56491	\N
18207	852	0	0	57329	\N
18209	852	3	0	57331	\N
18209	1848	4	0	57335	\N
18227	5371	13	0	58313	\N
18225	1470	3	0	58320	\N
18225	3838	4	0	58321	\N
18227	1470	126	0	58322	\N
18227	5372	127	0	58323	\N
18190	1914	5	0	58505	\N
18190	5351	6	0	58509	\N
18185	5347	7	0	58572	\N
18185	4014	6	1	59791	\N
18214	4088	4	0	59874	\N
18214	4089	5	0	59888	\N
18185	5346	6	0	60262	\N
18185	4787	5	0	60294	\N
18188	4787	5	0	60296	\N
18188	5349	6	0	60302	\N
18221	2755	3	0	998	\N
18309	5385	20	0	1325	\N
18249	5377	3	0	1640	\N
18286	110	3	0	2675	\N
18286	2995	4	0	2684	\N
18258	367	3	0	3499	\N
18258	3683	4	0	3501	\N
18205	262	6	0	3882	\N
18205	5364	7	0	3885	\N
18079	365	3	0	4689	\N
18079	3839	4	0	4698	\N
18156	189	14	0	4989	\N
18156	5340	15	0	4991	\N
18194	4540	6	0	5004	\N
18219	4178	5	0	6038	\N
18219	4202	6	0	6039	\N
18262	4178	2	0	6042	\N
18262	4247	3	0	6043	\N
18265	4178	2	0	6046	\N
18270	4178	2	0	6047	\N
18265	4247	3	0	6048	\N
18270	4247	3	0	6049	\N
18175	4172	5	0	8608	\N
18175	4415	6	0	8609	\N
18206	4172	6	0	8613	\N
18303	4172	3	0	8623	\N
18303	4275	4	0	8625	\N
18118	391	11	0	10652	\N
18118	5330	12	0	10656	\N
18298	391	2	0	10663	\N
18298	1381	3	0	10665	\N
18153	5337	63	0	11486	\N
18153	132	126	0	11499	\N
18153	5338	127	0	11500	\N
18326	123	3	0	12902	\N
18146	233	2	0	13852	\N
18216	233	4	0	13853	\N
18216	3775	5	0	13860	\N
18280	173	2	0	14770	\N
18280	2102	3	0	14771	\N
18291	173	3	0	14785	\N
18291	3796	4	0	14787	\N
18115	44	35	0	16154	\N
18115	5328	36	0	16160	\N
18071	30	2	0	18122	\N
18289	30	6	0	18123	\N
18071	1127	3	0	18124	\N
18289	2719	7	0	18126	\N
18230	142	2	0	18678	\N
18299	60	2	0	19602	\N
18299	4544	3	0	19609	\N
18085	62	19	0	19865	\N
18085	4340	20	0	19869	\N
18220	164	2	0	21239	\N
18220	1124	3	0	21241	\N
18185	5348	7	1	21765	\N
18249	1018	2	0	22071	\N
18249	1075	4	0	22072	\N
18106	73	2	0	22666	\N
18106	2766	3	0	22668	\N
18234	73	2	0	22669	\N
18081	264	3	0	23638	\N
18081	3632	4	0	23648	\N
18200	214	4	0	24559	\N
18200	3355	5	0	24561	\N
18123	69	0	0	24845	\N
18311	69	2	0	24869	\N
18311	3350	3	0	24870	\N
18141	90	2	0	26182	\N
18141	3442	3	0	26183	\N
18235	90	1	0	26200	\N
18166	449	4	0	29879	\N
18166	5343	5	0	29881	\N
18060	5317	7	0	30231	\N
18314	54	3	0	30241	\N
18314	3041	4	0	30242	\N
18241	202	5	0	31212	\N
18241	5374	6	0	31221	\N
18104	33	4	0	31856	\N
18104	4806	5	0	31859	\N
18281	33	2	0	31875	\N
18281	2822	3	0	31876	\N
18069	230	2	0	32282	\N
18069	3307	3	0	32284	\N
18151	5336	13	0	32844	\N
18151	3133	17	0	32861	\N
18062	2	6	0	35046	\N
18062	4550	7	0	35048	\N
18249	5376	2	0	35071	\N
18249	5378	3	1	35742	\N
18064	6	1	0	36330	\N
18064	194	2	0	36331	\N
18087	27	2	0	41067	\N
18087	645	3	0	41069	\N
18232	40	2	0	41832	\N
18232	282	3	0	41833	\N
18202	40	6	0	41853	\N
18301	40	3	0	41869	\N
18301	372	4	0	41873	\N
13327	56	110	0	44145	\N
18117	5329	12	0	44313	\N
18173	56	4	0	44320	\N
18173	3556	5	0	44321	\N
18293	56	3	0	44323	\N
18293	4109	4	0	44324	\N
18329	56	5	0	44326	\N
18329	3373	6	0	44327	\N
18144	75	2	0	45456	\N
18144	284	3	0	45457	\N
18260	75	3	0	45467	\N
18260	3855	4	0	45472	\N
18331	88	5	0	47322	\N
18331	3907	6	0	47325	\N
18228	113	4	0	48393	\N
18228	3677	5	0	48395	\N
18226	125	3	0	49295	\N
18226	4170	4	0	49299	\N
18268	137	2	0	49891	\N
18268	2721	3	0	49892	\N
18320	137	2	0	49906	\N
18320	2721	3	0	49908	\N
18247	156	7	0	50284	\N
18247	5375	8	0	50286	\N
18135	5333	40	0	51395	\N
18135	186	112	0	51406	\N
18135	5334	113	0	51407	\N
18288	200	7	0	51683	\N
18288	5382	8	0	51685	\N
18316	279	3	0	53268	\N
18316	3641	4	0	53273	\N
18295	595	3	0	55764	\N
18341	595	0	0	55765	\N
18349	595	7	0	55766	\N
18295	3654	4	0	55781	\N
18349	5396	8	0	55786	\N
18339	597	0	0	56020	\N
18387	1021	3	0	56443	\N
18387	4551	4	0	56445	\N
18277	841	2	0	57146	\N
18357	841	4	0	57147	\N
18277	3316	3	0	57148	\N
18357	2774	5	0	57150	\N
18195	1914	5	0	58506	\N
18195	5351	6	0	58510	\N
18130	3653	4	0	2137	\N
18114	4416	3	0	3103	\N
18312	367	3	0	3506	\N
18312	3683	4	0	3509	\N
18183	189	0	0	4997	\N
18139	4178	2	0	6028	\N
18139	4247	3	0	6030	\N
18162	4178	4	0	6032	\N
18162	4205	5	0	6033	\N
18246	4178	2	0	6040	\N
18246	4247	3	0	6041	\N
18263	4178	5	0	6044	\N
18263	4429	6	0	6045	\N
18324	4247	3	0	6056	\N
18090	4172	1	0	8594	\N
18090	4201	2	0	8595	\N
18097	4172	3	0	8596	\N
18097	4275	4	0	8597	\N
18157	4172	7	0	8604	\N
18167	4172	3	0	8605	\N
18167	4275	4	0	8606	\N
18157	4614	8	0	8607	\N
18181	4172	3	0	8610	\N
18181	4275	4	0	8612	\N
18271	4172	5	0	8617	\N
18276	4172	3	0	8619	\N
18276	4275	4	0	8620	\N
18351	4172	2	0	8627	\N
18351	4191	3	0	8628	\N
18354	4172	2	0	8629	\N
18354	4191	3	0	8630	\N
18376	4172	3	0	8631	\N
18376	4275	4	0	8632	\N
18264	391	2	0	10653	\N
18304	108	2	0	11783	\N
18304	3340	3	0	11786	\N
18239	235	2	0	15835	\N
18132	115	3	0	16800	\N
18132	3483	4	0	16803	\N
18170	326	3	0	17487	\N
18170	3339	4	0	17488	\N
18371	142	2	0	18693	\N
18371	4418	3	0	18694	\N
18100	60	2	0	19579	\N
18100	4544	3	0	19580	\N
18084	5322	8	0	19868	\N
18223	164	60	0	21243	\N
18223	5370	61	0	21245	\N
18142	488	5	0	21549	\N
18203	5362	7	0	21555	\N
18142	5335	6	0	21556	\N
18254	67	2	0	22238	\N
18254	394	3	0	22239	\N
18261	67	2	0	22246	\N
18261	394	3	0	22247	\N
18107	73	0	0	22667	\N
18231	336	2	0	22866	\N
18231	3332	3	0	22869	\N
18242	149	5	0	23249	\N
18242	3808	6	0	23250	\N
18259	264	3	0	23639	\N
18347	82	4	0	23893	\N
18347	5394	5	0	23896	\N
18164	140	6	0	24142	\N
18164	5342	7	0	24144	\N
18250	140	27	0	24152	\N
18252	140	2	0	24153	\N
18252	3183	3	0	24154	\N
18250	5379	28	0	24157	\N
18368	140	5	0	24163	\N
18368	5000	6	0	24165	\N
18122	69	4	0	24844	\N
18122	3564	5	0	24850	\N
18235	2897	2	0	26203	\N
18236	3442	3	0	26204	\N
18201	2183	2	0	27165	\N
18201	5361	3	0	27166	\N
18127	16	7	0	28727	\N
18127	4504	8	0	28728	\N
18233	320	84	0	29279	\N
18233	5373	85	0	29283	\N
18149	449	0	0	29878	\N
18283	54	2	0	30229	\N
18283	3351	3	0	30230	\N
18244	202	2	0	31213	\N
18103	33	4	0	31855	\N
18105	33	4	0	31857	\N
18103	4806	5	0	31858	\N
18105	4806	5	0	31860	\N
18306	453	2	0	32854	\N
18306	3366	3	0	32855	\N
18137	18	7	0	40204	\N
18137	4538	8	0	40205	\N
18095	23	2	0	40885	\N
18095	3443	3	0	40887	\N
18088	40	2	0	41815	\N
18088	282	3	0	41816	\N
18159	4718	8	0	41835	\N
18237	40	2	0	41852	\N
18237	282	3	0	41854	\N
18256	40	4	0	41867	\N
18256	2796	5	0	41874	\N
15041	57	1	0	44185	\N
18377	2795	3	0	44329	\N
18274	79	5	0	46299	\N
18274	3341	6	0	46301	\N
18343	79	2	0	46351	\N
18343	616	3	0	46354	\N
18356	100	3	0	47720	\N
18486	100	8	0	47721	\N
18356	3836	4	0	47724	\N
18486	5431	9	0	47725	\N
18359	102	2	0	47976	\N
18359	3053	3	0	47977	\N
18475	5424	8	0	48734	\N
18475	119	9	0	48750	\N
18400	137	4	0	49907	\N
18400	4352	5	0	49909	\N
18348	181	7	0	51027	\N
18348	5395	8	0	51028	\N
18452	181	3	0	51037	\N
18452	4184	4	0	51038	\N
18468	181	7	0	51052	\N
18468	4137	8	0	51057	\N
18317	210	9	0	51974	\N
18317	5388	10	0	51976	\N
18460	279	4	0	53269	\N
18460	3502	5	0	53275	\N
18453	285	118	0	53655	\N
18453	5421	119	0	53661	\N
18482	5427	8	0	54290	\N
18482	324	9	0	54303	\N
18290	597	3	0	56001	\N
18290	3656	4	0	56006	\N
18294	597	3	0	56019	\N
18294	3656	4	0	56021	\N
18346	597	7	0	56040	\N
18346	5393	8	0	56064	\N
18323	1109	2	0	56236	\N
18323	2809	3	0	56237	\N
18366	1109	2	0	56240	\N
18366	2809	3	0	56241	\N
18363	908	2	0	57724	\N
18363	2832	3	0	57725	\N
18372	908	2	0	57729	\N
18372	2832	3	0	57736	\N
18390	2636	2	0	58871	\N
18390	2836	3	0	58872	\N
18361	4088	2	0	59875	\N
18361	4332	3	0	59883	\N
18397	5411	3	0	2321	\N
18415	5412	11	0	3899	\N
18375	35	3	0	4208	\N
18375	3563	4	0	4211	\N
18318	4247	3	0	6055	\N
18328	4178	5	0	6058	\N
18330	4178	5	0	6059	\N
18345	4178	5	0	6060	\N
18345	4202	6	0	6061	\N
18330	4429	6	0	6062	\N
18328	4333	6	0	6063	\N
18365	4178	5	0	6064	\N
18365	4429	6	0	6065	\N
18373	4247	3	0	6067	\N
18378	4178	2	0	6070	\N
18378	4247	3	0	6071	\N
18380	4450	1	0	6072	\N
18380	4178	6	0	6074	\N
18380	4205	7	0	6076	\N
18388	4178	3	0	6077	\N
18388	4211	4	0	6078	\N
18417	4178	3	0	6082	\N
18417	4211	4	0	6085	\N
18336	4172	5	0	8624	\N
18336	4415	6	0	8626	\N
18410	4275	4	0	8636	\N
18444	4172	3	0	8641	\N
18444	4275	4	0	8643	\N
18264	1381	3	0	10654	\N
18338	391	2	0	10664	\N
18338	1381	3	0	10666	\N
18302	300	3	0	12269	\N
18302	3747	4	0	12273	\N
18333	300	5	0	12281	\N
18333	5389	6	0	12282	\N
18325	123	2	0	12901	\N
18325	4862	3	0	12903	\N
18350	58	7	0	13567	\N
18350	5397	8	0	13568	\N
18463	92	2	0	15128	\N
18463	2763	3	0	15132	\N
18403	235	3	0	15868	\N
18403	3343	4	0	15872	\N
18471	44	3	0	16155	\N
18471	3631	4	0	16158	\N
18439	115	2	0	16811	\N
18439	1593	3	0	16812	\N
18296	142	2	0	18685	\N
18296	4418	3	0	18686	\N
18313	208	3	0	19189	\N
18313	4490	4	0	19197	\N
18300	60	1	0	19603	\N
18300	61	2	0	19606	\N
18367	5401	43	0	20485	\N
18367	241	125	0	20494	\N
18367	5403	126	1	20537	\N
18284	1075	81	1	22051	\N
18407	67	3	0	22252	\N
18407	3749	4	0	22254	\N
18358	149	2	0	23257	\N
18358	1379	3	0	23258	\N
18266	4505	4	0	23889	\N
18385	82	2	0	23894	\N
18385	3401	3	0	23895	\N
18370	5404	10	0	24158	\N
18370	140	126	0	24167	\N
18370	5405	127	0	24168	\N
18381	5406	10	0	24169	\N
18278	86	2	0	26618	\N
18278	3321	3	0	26621	\N
18332	94	2	0	26961	\N
18332	2794	3	0	26962	\N
18310	42	19	0	27709	\N
18478	5423	8	0	29718	\N
18478	96	9	0	29725	\N
18284	5380	31	0	30221	\N
18284	54	80	0	30232	\N
18315	54	56	0	30243	\N
18315	5387	57	0	30244	\N
18284	5381	81	0	30266	\N
18321	33	2	0	31885	\N
18321	2822	3	0	31888	\N
18353	322	2	0	32502	\N
18353	1866	3	0	32503	\N
18420	453	3	0	32870	\N
18405	2	3	0	35073	\N
18405	298	4	0	35075	\N
18429	14	3	0	39284	\N
18442	14	3	0	39285	\N
18429	4272	4	0	39290	\N
18442	4272	4	0	39291	\N
18322	18	2	0	40210	\N
18322	1685	3	0	40211	\N
18490	18	3	0	40213	\N
18272	40	5	0	41868	\N
18308	40	19	0	41870	\N
18272	2714	6	0	41875	\N
18335	40	1	0	41903	\N
18335	41	2	0	41904	\N
18504	71	3	0	44928	\N
18504	3770	4	0	44929	\N
18344	79	2	0	46352	\N
18327	113	3	0	48402	\N
18327	3620	4	0	48408	\N
18448	135	4	0	49638	\N
18448	3696	5	0	49643	\N
18619	170	2	0	50667	\N
18619	1380	3	0	50670	\N
18568	181	2	0	51053	\N
18568	3313	3	0	51056	\N
18342	260	9	0	52598	\N
18446	260	3	0	52600	\N
18446	3399	4	0	52601	\N
18553	260	0	0	52602	\N
18421	268	4	0	52859	\N
18421	3897	5	0	52861	\N
18487	279	8	0	53270	\N
18487	5432	9	0	53276	\N
18369	324	5	0	54286	\N
18369	4516	6	0	54287	\N
18481	5427	8	0	54289	\N
18481	324	9	0	54302	\N
18384	5410	0	0	55104	\N
18428	451	4	0	55402	\N
18428	3666	5	0	55403	\N
18610	1109	2	0	56252	\N
18610	2809	3	0	56253	\N
18485	1021	8	0	56444	\N
18485	5430	9	0	56446	\N
18621	852	3	0	57341	\N
18621	3612	4	0	57345	\N
18497	2782	4	0	59389	\N
18497	3872	5	0	59390	\N
18577	2782	1	0	59398	\N
18577	3873	2	0	59400	\N
18479	5426	8	0	59554	\N
18479	3625	9	0	59573	\N
18412	4088	3	0	59876	\N
18412	4506	4	0	59884	\N
18583	4169	5	0	2129	\N
18593	110	6	0	2685	\N
18593	3100	7	0	2688	\N
18470	1636	2	0	3101	\N
18470	4416	3	0	3104	\N
18419	367	3	0	3507	\N
18419	3683	4	0	3510	\N
18340	262	0	0	3895	\N
18374	4178	2	0	6068	\N
18374	4247	3	0	6069	\N
18402	4178	3	0	6079	\N
18402	4211	4	0	6083	\N
18426	4178	3	0	6087	\N
18455	4178	3	0	6091	\N
18495	4178	4	0	6092	\N
18518	4178	3	0	6094	\N
18455	4211	4	0	6095	\N
18518	4211	4	0	6097	\N
18495	4331	5	0	6098	\N
18530	4178	3	0	6101	\N
18530	4211	4	0	6102	\N
18538	4178	3	0	6104	\N
18538	4211	4	0	6105	\N
18560	4178	3	0	6114	\N
18560	4211	4	0	6115	\N
18572	4468	5	0	6119	\N
18601	4178	2	0	6124	\N
18601	4247	3	0	6125	\N
18437	4172	3	0	8640	\N
18437	4275	4	0	8642	\N
18451	4172	3	0	8645	\N
18513	4172	3	0	8647	\N
18451	4275	4	0	8649	\N
18513	5441	4	0	8652	\N
18587	4172	2	0	8661	\N
18587	4191	3	0	8662	\N
18626	4172	2	0	8672	\N
18579	391	5	0	10679	\N
18579	5462	6	0	10680	\N
18435	5417	63	0	11501	\N
18435	132	126	0	11510	\N
18435	5418	127	0	11511	\N
18355	5399	3	0	11993	\N
18355	5400	4	0	11994	\N
18326	2856	4	0	12904	\N
18409	123	3	0	12908	\N
18409	2856	4	0	12910	\N
18549	123	4	0	12914	\N
18549	5451	5	0	12920	\N
18362	233	2	0	13854	\N
18362	1849	3	0	13857	\N
18492	92	4	0	15129	\N
18520	92	0	0	15130	\N
18511	192	3	0	15397	\N
18511	3790	4	0	15398	\N
18352	38	5	0	16501	\N
18352	5398	6	0	16503	\N
18535	115	3	0	16820	\N
18535	3483	4	0	16822	\N
18472	326	3	0	17517	\N
18472	3339	4	0	17518	\N
18459	4095	5	0	18139	\N
18342	4952	11	0	18216	\N
18547	290	4	0	19067	\N
18547	5450	5	0	19073	\N
18392	67	2	0	22251	\N
18392	394	3	0	22253	\N
18360	73	2	0	22671	\N
18360	2766	3	0	22673	\N
18462	336	3	0	22868	\N
18462	3400	4	0	22871	\N
18614	149	17	0	23277	\N
18614	5470	18	0	23278	\N
18382	140	6	0	24164	\N
18382	3821	7	0	24166	\N
18590	411	2	0	25350	\N
18590	3370	3	0	25355	\N
18629	94	5	0	26965	\N
18379	244	0	0	27398	\N
18364	16	2	0	28730	\N
18364	388	3	0	28735	\N
18570	360	0	0	31617	\N
18574	360	0	0	31619	\N
18603	230	1	0	32286	\N
18603	287	2	0	32287	\N
18515	2364	6	0	32879	\N
18566	2	7	0	35160	\N
18566	5459	8	0	35169	\N
18527	4	3	0	36065	\N
18527	3837	4	0	36066	\N
18424	194	1	0	36325	\N
18424	6	4	0	36333	\N
18424	1101	5	0	36335	\N
18533	14	3	0	39286	\N
18533	4272	4	0	39292	\N
18337	18	5	0	40212	\N
18490	3621	4	0	40214	\N
18612	18	3	0	40219	\N
18612	3621	4	0	40220	\N
18334	40	2	0	41871	\N
18334	282	3	0	41872	\N
18431	40	7	0	41951	\N
18441	40	6	0	41952	\N
18441	4255	7	0	41953	\N
18431	4718	8	0	41954	\N
18467	40	7	0	41974	\N
18467	4718	8	0	41975	\N
16608	56	3	0	44247	\N
18473	3855	4	0	45473	\N
18393	102	2	0	47997	\N
18393	3053	3	0	47998	\N
18597	2317	3	0	49084	\N
18597	121	6	0	49090	\N
18597	4815	7	0	49093	\N
18449	137	4	0	49918	\N
18449	3697	5	0	49927	\N
18476	5425	8	0	51039	\N
18476	181	9	0	51058	\N
18543	186	3	0	51402	\N
18543	4294	4	0	51403	\N
18522	200	7	0	51686	\N
18522	5445	8	0	51687	\N
18545	200	3	0	51688	\N
18608	200	2	0	51689	\N
18608	276	3	0	51691	\N
18545	3338	4	0	51692	\N
18342	5390	10	1	52599	\N
18422	268	34	0	52860	\N
18422	5414	35	0	52863	\N
18563	285	5	0	53657	\N
18563	5103	6	0	53660	\N
18565	285	7	0	53670	\N
18565	5458	8	0	53672	\N
18503	316	4	0	54074	\N
18503	5437	5	0	54075	\N
18480	5427	8	0	54288	\N
18480	324	9	0	54301	\N
18631	353	5	0	54707	\N
18427	451	54	0	55401	\N
18427	5415	55	0	55406	\N
18546	1109	3	0	56244	\N
18546	3495	4	0	56245	\N
18344	5392	3	1	58125	\N
18500	5435	13	0	58324	\N
18499	1470	7	0	58336	\N
18499	5261	8	0	58337	\N
18500	1470	126	0	58338	\N
18500	5436	127	0	58339	\N
18618	2578	2	0	58610	\N
18618	4325	3	0	58611	\N
18483	5428	8	0	59727	\N
18483	3628	9	0	59749	\N
18581	4787	4	0	60297	\N
18581	4847	5	0	60300	\N
18505	3003	4	0	202	\N
18550	117	2	0	2118	\N
18550	1257	3	0	2120	\N
18509	3653	4	0	2121	\N
18464	35	2	0	4209	\N
18464	1191	3	0	4210	\N
18386	4178	4	0	6073	\N
18386	4331	5	0	6075	\N
18406	4178	3	0	6080	\N
18406	4441	4	0	6086	\N
18447	4178	4	0	6089	\N
18447	4205	5	0	6090	\N
18502	4178	3	0	6093	\N
18576	4178	1	0	6120	\N
18576	4450	2	0	6121	\N
18605	4178	2	0	6126	\N
18605	4247	3	0	6129	\N
18391	4172	2	0	8633	\N
18391	4191	3	0	8635	\N
18458	4172	4	0	8646	\N
18537	4172	7	0	8648	\N
18458	4219	5	0	8650	\N
18537	4614	8	0	8651	\N
18541	4172	3	0	8653	\N
18555	4172	13	0	8654	\N
18578	4172	2	0	8656	\N
18578	4191	3	0	8657	\N
18541	4275	4	0	8658	\N
18555	5454	14	0	8659	\N
18558	5456	5	0	8660	\N
18494	391	4	0	10671	\N
18494	3352	5	0	10672	\N
18434	132	7	0	11508	\N
18434	3709	8	0	11509	\N
18616	132	1	0	11518	\N
18616	455	2	0	11520	\N
18389	123	3	0	12907	\N
18395	402	3	0	14224	\N
18395	4077	4	0	14226	\N
18492	3979	5	0	15134	\N
18623	303	3	0	15237	\N
18623	5471	4	0	15240	\N
18398	235	3	0	15848	\N
18398	3343	4	0	15849	\N
18408	115	2	0	16801	\N
18408	2797	3	0	16802	\N
18383	326	5	0	17499	\N
18383	5408	6	0	17500	\N
18456	208	3	0	19190	\N
18432	198	7	0	20226	\N
18432	5416	8	0	20228	\N
18567	73	2	0	22672	\N
18567	2766	3	0	22674	\N
18506	1935	7	0	23009	\N
18507	1935	0	0	23010	\N
18508	1935	0	0	23011	\N
18506	5438	8	0	23013	\N
18381	140	118	0	24184	\N
18381	5407	119	0	24185	\N
18516	785	7	0	26316	\N
18516	5443	8	0	26317	\N
18501	3746	4	0	26627	\N
18592	5465	3	0	26628	\N
18592	86	6	0	26638	\N
18592	2890	7	0	26639	\N
18552	94	4	0	26963	\N
18552	5452	5	0	26964	\N
18536	42	7	0	27717	\N
18536	5449	8	0	27730	\N
18466	16	2	0	28731	\N
18523	16	4	0	28733	\N
18466	388	3	0	28736	\N
18523	5446	5	0	28738	\N
18528	3634	4	0	28740	\N
18542	16	4	0	28741	\N
18542	3546	5	0	28742	\N
18600	16	2	0	28745	\N
18600	388	3	0	28747	\N
18488	449	4	0	29891	\N
18488	5343	5	0	29892	\N
18493	20	4	0	30561	\N
18493	3995	5	0	30562	\N
18540	360	3	0	31627	\N
18540	3602	4	0	31633	\N
18525	322	4	0	32508	\N
18418	453	7	0	32869	\N
18418	5413	8	0	32871	\N
18519	453	3	0	32885	\N
18519	2838	4	0	32889	\N
18445	431	3	0	34837	\N
18445	3933	4	0	34839	\N
18531	2	7	0	35130	\N
18531	5448	8	0	35132	\N
18582	2	7	0	35161	\N
18582	5463	8	0	35162	\N
18529	18	3	0	40216	\N
18529	3621	4	0	40217	\N
18628	3550	6	0	40225	\N
18554	40	13	0	42016	\N
18554	5453	14	0	42017	\N
16928	56	3	0	44267	\N
17788	56	3	0	44292	\N
18609	2795	3	0	44332	\N
18396	79	2	0	46403	\N
18396	616	3	0	46404	\N
18399	79	4	0	46446	\N
18399	2758	5	0	46448	\N
18596	2317	3	0	49083	\N
18596	121	6	0	49089	\N
18596	4815	7	0	49092	\N
18704	186	2	0	51410	\N
18704	1850	3	0	51412	\N
18532	260	7	0	52603	\N
18532	4589	8	0	52604	\N
18450	285	3	0	53654	\N
18562	285	2	0	53656	\N
18450	4496	4	0	53658	\N
18564	285	3	0	53669	\N
18564	5457	4	0	53671	\N
18688	12	3	0	430	\N
18491	5433	3	0	1690	\N
18491	5434	4	0	1691	\N
18510	117	2	0	2117	\N
18510	5439	3	0	2119	\N
18645	1636	2	0	3102	\N
18645	4416	3	0	3105	\N
18416	262	7	0	3897	\N
18416	4888	8	0	3898	\N
18411	4178	3	0	6081	\N
18411	4211	4	0	6084	\N
18521	4178	0	0	6099	\N
18524	4178	4	0	6100	\N
18539	4178	3	0	6106	\N
18539	4211	4	0	6107	\N
18544	4178	3	0	6108	\N
18548	4178	4	0	6109	\N
18544	4211	4	0	6110	\N
18548	4468	5	0	6111	\N
18556	4178	4	0	6112	\N
18556	4205	5	0	6113	\N
18561	4178	7	0	6116	\N
18561	5089	8	0	6117	\N
18588	4178	6	0	6122	\N
18588	4358	7	0	6123	\N
18627	4429	6	0	6131	\N
18652	4178	3	0	6132	\N
18652	4211	4	0	6133	\N
18430	4172	3	0	8637	\N
18430	4275	4	0	8638	\N
18433	4172	7	0	8639	\N
18433	4614	8	0	8644	\N
18598	4440	3	0	8663	\N
18598	4172	6	0	8664	\N
18598	4285	7	0	8665	\N
18604	4172	3	0	8666	\N
18604	4275	4	0	8667	\N
18606	4191	3	0	8669	\N
18617	4172	1	0	8670	\N
18617	4201	2	0	8671	\N
18706	4172	2	0	8682	\N
18706	4191	3	0	8683	\N
18584	391	4	0	10685	\N
18584	3352	5	0	10692	\N
18534	123	3	0	12913	\N
18534	2856	4	0	12917	\N
18465	58	2	0	13575	\N
18465	2853	3	0	13577	\N
18413	233	3	0	13855	\N
18594	5466	3	0	15850	\N
18594	235	6	0	15873	\N
18594	5467	7	0	15875	\N
18438	38	2	0	16525	\N
18440	38	3	0	16526	\N
18624	38	3	0	16527	\N
18438	2901	3	0	16528	\N
18440	3457	4	0	16529	\N
18624	3457	4	0	16530	\N
18647	38	5	0	16540	\N
18647	5398	6	0	16543	\N
18436	115	3	0	16810	\N
18671	212	4	0	17258	\N
18671	4574	5	0	17264	\N
18643	167	2	0	17807	\N
18643	3322	3	0	17809	\N
18401	142	2	0	18699	\N
18401	4418	3	0	18700	\N
18559	62	3	0	19874	\N
18559	3344	4	0	19882	\N
18443	5419	3	0	19980	\N
18443	5420	4	0	19981	\N
18457	164	4	0	21240	\N
18457	4152	5	0	21242	\N
18683	1124	3	0	21264	\N
18498	145	4	0	22077	\N
18498	3867	5	0	22078	\N
18638	145	4	0	22081	\N
18638	5475	5	0	22088	\N
18658	67	6	0	22258	\N
18658	3607	7	0	22260	\N
18404	411	3	0	25339	\N
18404	3596	4	0	25340	\N
18526	411	4	0	25343	\N
18526	4858	5	0	25344	\N
18557	224	4	0	25613	\N
18484	244	10	0	27399	\N
18496	16	4	0	28732	\N
18496	2575	5	0	28737	\N
18469	96	11	0	29714	\N
18469	5422	12	0	29715	\N
18474	5423	8	0	29716	\N
18477	5423	8	0	29717	\N
18474	96	9	0	29723	\N
18477	96	9	0	29724	\N
18655	202	6	0	31214	\N
18655	4079	7	0	31222	\N
18512	360	3	0	31616	\N
18512	5440	4	0	31624	\N
18514	453	56	0	32877	\N
18514	5442	57	0	32880	\N
18517	453	4	0	32891	\N
18517	5444	5	0	32892	\N
18664	431	3	0	34838	\N
18664	3933	4	0	34840	\N
18454	2	3	0	35092	\N
18454	3548	4	0	35093	\N
18489	2	2	0	35113	\N
18489	2789	3	0	35114	\N
18423	194	1	0	36324	\N
18423	1101	5	0	36334	\N
18668	18	2	0	40228	\N
18668	1685	3	0	40230	\N
18580	27	2	0	41068	\N
18580	645	3	0	41070	\N
18394	40	2	0	41926	\N
18414	40	10	0	41927	\N
18425	40	2	0	41928	\N
18394	282	3	0	41929	\N
18425	282	3	0	41930	\N
18414	4104	11	0	41931	\N
18551	40	10	0	41996	\N
18666	40	2	0	42095	\N
18666	282	3	0	42096	\N
18679	40	3	0	42116	\N
18679	372	4	0	42117	\N
18701	40	4	0	42138	\N
18779	40	3	0	42207	\N
18779	372	4	0	42212	\N
18663	75	43	0	45469	\N
18722	75	3	0	45470	\N
18722	3855	4	0	45474	\N
18663	5481	44	0	45475	\N
18625	79	5	0	46447	\N
18625	3341	6	0	46449	\N
18591	125	2	0	49296	\N
18591	3297	3	0	49297	\N
18696	135	3	0	49639	\N
18696	3630	4	0	49642	\N
18644	156	2	0	50303	\N
18644	4485	3	0	50305	\N
18657	200	6	0	51690	\N
18657	4701	7	0	51693	\N
18562	1276	3	0	53659	\N
18801	324	2	0	54299	\N
18801	2808	3	0	54300	\N
18649	451	2	0	55414	\N
18650	451	1	0	55415	\N
18650	3260	2	0	55416	\N
18649	3317	3	0	55417	\N
18620	1021	3	0	56455	\N
18620	4551	4	0	56456	\N
18790	793	3	0	56799	\N
18790	5510	4	0	56801	\N
18602	841	2	0	57151	\N
18602	3316	3	0	57152	\N
18661	2782	3	0	59399	\N
18661	3659	4	0	59401	\N
18653	5098	5	0	95	\N
18781	5509	3	0	1048	\N
18685	266	3	0	1323	\N
18685	4633	4	0	1324	\N
18750	117	5	0	2140	\N
18750	5505	6	0	2141	\N
18760	117	3	0	2150	\N
18760	3653	4	0	2153	\N
18599	110	1	0	2677	\N
18599	3242	2	0	2682	\N
18642	228	2	0	2783	\N
18642	4776	3	0	2784	\N
18797	1636	3	0	3113	\N
18667	367	2	0	3519	\N
18667	3329	3	0	3522	\N
18680	262	11	0	3913	\N
18681	262	92	0	3914	\N
18680	5486	12	0	3915	\N
18589	373	2	0	5367	\N
18589	4967	3	0	5370	\N
18651	4178	2	0	6128	\N
18651	4247	3	0	6130	\N
18662	4178	3	0	6134	\N
18662	4211	4	0	6135	\N
18720	4178	2	0	6136	\N
18725	4178	3	0	6138	\N
18725	4211	4	0	6141	\N
18732	4178	5	0	6142	\N
18732	4429	6	0	6143	\N
18762	4178	3	0	6144	\N
18762	4211	4	0	6148	\N
18806	4178	3	0	6150	\N
18806	4211	4	0	6157	\N
18635	4172	5	0	8674	\N
18635	4415	6	0	8675	\N
18737	4172	7	0	8686	\N
18737	4537	8	0	8689	\N
18783	3796	4	0	14799	\N
18753	235	4	0	15869	\N
18753	4479	5	0	15874	\N
18646	44	2	0	16156	\N
18646	1910	3	0	16157	\N
18673	5482	67	0	17248	\N
18673	212	114	0	17266	\N
18673	5483	115	0	17267	\N
18613	167	17	0	17806	\N
18613	5469	18	0	17811	\N
18634	60	5	0	19604	\N
18634	5473	6	0	19610	\N
18677	62	2	0	19878	\N
18677	2191	3	0	19881	\N
18674	5484	4	0	19883	\N
18637	5474	8	0	20220	\N
18637	198	9	0	20229	\N
18727	336	2	0	22882	\N
18727	3332	3	0	22883	\N
18656	264	6	0	23640	\N
18709	264	1	0	23641	\N
18709	270	2	0	23643	\N
18656	5480	7	0	23651	\N
18755	264	2	0	23659	\N
18595	5468	3	0	23897	\N
18640	82	7	0	23898	\N
18595	82	6	0	23899	\N
18595	4753	7	0	23900	\N
18640	5477	8	0	23901	\N
18742	214	4	0	24564	\N
18742	3807	5	0	24565	\N
18818	214	2	0	24568	\N
18818	1259	3	0	24569	\N
18692	224	7	0	25626	\N
18692	5493	8	0	25628	\N
18629	4547	6	0	26968	\N
18585	5464	5	0	27168	\N
18569	16	3	0	28743	\N
18569	5460	4	0	28744	\N
18675	16	3	0	28746	\N
18675	1045	4	0	28748	\N
18793	16	6	0	28753	\N
18793	5512	7	0	28756	\N
18748	96	3	0	29720	\N
18748	2803	4	0	29721	\N
18820	96	1	0	29727	\N
18820	97	2	0	29733	\N
18641	449	7	0	29899	\N
18769	20	2	0	30588	\N
18769	369	3	0	30591	\N
18575	360	0	0	31620	\N
18571	360	4	0	31628	\N
18571	5461	5	0	31636	\N
18611	322	3	0	32509	\N
18611	1105	4	0	32512	\N
18773	453	2	0	32886	\N
18773	3366	3	0	32888	\N
18788	2	5	0	35185	\N
18788	3624	6	0	35186	\N
18670	14	4	0	39307	\N
18586	18	4	0	40218	\N
18586	3779	5	0	40221	\N
18615	18	2	0	40222	\N
18615	1685	3	0	40223	\N
18632	18	5	0	40226	\N
18659	18	6	0	40227	\N
18632	3550	6	0	40232	\N
18659	4180	7	0	40233	\N
18776	2073	5	0	41071	\N
18776	27	11	0	41087	\N
18776	5508	12	0	41088	\N
18607	40	2	0	42029	\N
18607	282	3	0	42031	\N
18622	282	3	0	42032	\N
18630	40	5	0	42053	\N
18630	2714	6	0	42054	\N
18766	40	3	0	42173	\N
18766	5506	4	0	42174	\N
18772	40	3	0	42191	\N
18772	372	4	0	42192	\N
18851	40	1	0	42208	\N
18851	41	2	0	42210	\N
18885	40	2	0	42226	\N
18885	282	3	0	42227	\N
18782	56	2	0	44331	\N
18782	2795	3	0	44333	\N
18964	56	1	0	44342	\N
18848	75	1	0	45508	\N
18848	76	2	0	45509	\N
18936	75	1	0	45515	\N
18936	76	2	0	45516	\N
18717	88	2	0	47338	\N
18717	2799	3	0	47342	\N
18910	88	1	0	47346	\N
18910	89	2	0	47347	\N
18672	121	4	0	49087	\N
18678	121	5	0	49088	\N
18672	4356	5	0	49091	\N
18678	5485	6	0	49094	\N
18796	156	3	0	50304	\N
18796	4594	4	0	50306	\N
18830	170	1	0	50668	\N
18830	398	2	0	50669	\N
18883	170	1	0	50675	\N
18883	398	2	0	50677	\N
18648	242	5	0	52214	\N
18648	4562	6	0	52215	\N
18714	242	3	0	52222	\N
18714	2839	4	0	52223	\N
18846	242	3	0	52227	\N
18846	5519	4	0	52230	\N
18759	279	3	0	53271	\N
18759	3641	4	0	53274	\N
18705	353	2	0	54708	\N
18705	2884	3	0	54711	\N
18631	2223	6	0	54712	\N
18858	841	1	0	57153	\N
18858	842	2	0	57155	\N
18735	908	3	0	57731	\N
18735	5501	4	0	57741	\N
18868	1470	1	0	58351	\N
18868	1471	2	0	58352	\N
18861	2636	3	0	58879	\N
18861	5314	4	0	58888	\N
18897	2351	1	0	59063	\N
18897	4983	2	0	59064	\N
18687	5489	4	1	59461	\N
18891	3625	2	0	59571	\N
18891	4359	3	0	59572	\N
18962	4088	3	0	59877	\N
18962	4506	4	0	59885	\N
18687	13	1	0	419	\N
18780	228	2	0	2788	\N
18780	4776	3	0	2791	\N
18932	1636	2	0	3114	\N
18932	4416	3	0	3115	\N
18633	367	4	0	3508	\N
18633	5472	5	0	3511	\N
18740	262	3	0	3934	\N
18740	4778	4	0	3936	\N
18757	365	2	0	4690	\N
18757	615	3	0	4697	\N
18729	4178	2	0	6139	\N
18729	4247	3	0	6140	\N
18832	4450	2	0	6159	\N
18929	4178	1	0	6167	\N
18955	4178	1	0	6170	\N
18929	4450	2	0	6172	\N
18955	4450	2	0	6174	\N
18639	4172	4	0	8676	\N
18639	5476	5	0	8677	\N
18676	4172	3	0	8678	\N
18682	4172	6	0	8679	\N
18676	4440	4	0	8680	\N
18682	4365	7	0	8681	\N
18749	4172	2	0	8687	\N
18798	4172	3	0	8693	\N
18798	4275	4	0	8696	\N
18825	4172	2	0	8698	\N
18843	4172	3	0	8699	\N
18825	4191	3	0	8700	\N
18843	4440	4	0	8701	\N
18917	4172	1	0	8709	\N
18917	4201	2	0	8710	\N
18775	391	2	0	10686	\N
18894	391	2	0	10687	\N
18775	1381	3	0	10690	\N
18894	1381	3	0	10691	\N
18785	2717	6	0	11521	\N
18880	108	1	0	11784	\N
18880	109	2	0	11785	\N
18700	77	4	0	13264	\N
18700	5497	5	0	13267	\N
18752	58	2	0	13576	\N
18752	2853	3	0	13578	\N
18778	258	3	0	14510	\N
18778	4401	4	0	14514	\N
18792	173	2	0	14802	\N
18792	2102	3	0	14803	\N
18770	235	2	0	15870	\N
18698	38	3	0	16541	\N
18698	3457	4	0	16542	\N
18719	142	4	0	18703	\N
18719	3446	5	0	18704	\N
18665	62	2	0	19875	\N
18669	62	0	0	19876	\N
18665	2191	3	0	19880	\N
18953	198	2	0	20231	\N
18953	746	3	0	20234	\N
18920	164	46	0	21278	\N
18920	5530	47	0	21279	\N
18744	488	3	0	21552	\N
18768	336	2	0	22900	\N
18768	3332	3	0	22905	\N
18703	82	2	0	23902	\N
18703	3401	3	0	23903	\N
18946	140	1	0	24179	\N
18946	141	2	0	24181	\N
18855	69	2	0	24893	\N
18855	500	3	0	24894	\N
18691	224	7	0	25625	\N
18712	224	10	0	25635	\N
18712	1822	11	0	25636	\N
18787	16	2	0	28751	\N
18837	320	1	0	29226	\N
18837	334	2	0	29227	\N
18747	96	5	0	29719	\N
18747	5504	6	0	29722	\N
18660	449	3	0	29900	\N
18660	4760	4	0	29901	\N
18863	54	2	0	30257	\N
18863	3351	3	0	30258	\N
18915	54	2	0	30264	\N
18915	3351	3	0	30265	\N
18694	20	4	0	30572	\N
18694	2292	5	0	30574	\N
18873	287	2	0	32292	\N
18827	6	1	0	36342	\N
18827	194	2	0	36345	\N
18654	23	4	0	40893	\N
18800	23	2	0	40894	\N
18654	5479	5	0	40896	\N
18888	27	1	0	41110	\N
18888	28	2	0	41111	\N
18636	40	2	0	42077	\N
18636	282	3	0	42078	\N
18828	51	1	0	43611	\N
18862	51	2	0	43612	\N
18828	52	2	0	43614	\N
17958	56	4	0	44299	\N
18117	56	11	0	44312	\N
18795	5329	12	0	44335	\N
18841	56	2	0	44336	\N
18841	2795	3	0	44337	\N
18741	71	5	0	44930	\N
18741	5503	6	0	44931	\N
18839	71	1	0	44932	\N
18839	72	2	0	44934	\N
18765	75	3	0	45488	\N
18765	3855	4	0	45489	\N
18808	75	3	0	45496	\N
18845	75	3	0	45497	\N
18808	3855	4	0	45498	\N
18845	713	4	0	45499	\N
18726	121	3	0	49096	\N
18726	4471	4	0	49098	\N
18810	135	2	0	49640	\N
18810	2722	3	0	49641	\N
18697	137	3	0	49919	\N
18697	3633	4	0	49925	\N
18906	181	1	0	51054	\N
18906	530	2	0	51055	\N
18854	260	1	0	52451	\N
18854	261	2	0	52454	\N
18777	285	3	0	53675	\N
18777	4496	4	0	53676	\N
18847	316	1	0	54082	\N
18847	317	2	0	54083	\N
18702	435	5	0	55094	\N
18702	2354	6	0	55096	\N
18746	1021	2	0	56471	\N
18746	4432	3	0	56472	\N
18789	793	5	0	56798	\N
18789	5143	6	0	56803	\N
18890	841	2	0	57157	\N
18890	1161	3	0	57158	\N
18734	908	7	0	57730	\N
18734	3552	8	0	57742	\N
18761	2351	3	0	59062	\N
18761	2845	4	0	59065	\N
18875	2782	1	0	59404	\N
18875	3873	2	0	59407	\N
18691	5492	9	1	59454	\N
18882	963	2	0	2324	\N
18904	110	4	0	2681	\N
18893	626	3	0	2683	\N
18904	5526	5	0	2690	\N
18681	5487	93	0	3916	\N
18739	262	4	0	3933	\N
18739	4607	5	0	3937	\N
18812	35	5	0	4218	\N
18822	35	1	0	4219	\N
18805	4178	2	0	6146	\N
18805	4247	3	0	6147	\N
18826	4178	1	0	6153	\N
18826	4450	2	0	6154	\N
18834	4178	2	0	6160	\N
18834	4247	3	0	6161	\N
18853	4178	1	0	6162	\N
18853	4450	2	0	6163	\N
18922	4178	1	0	6166	\N
18718	4172	3	0	8684	\N
18718	4275	4	0	8685	\N
18764	4172	3	0	8692	\N
18807	4172	3	0	8694	\N
18764	4275	4	0	8695	\N
18807	4275	4	0	8697	\N
18877	4172	1	0	8706	\N
18877	4201	2	0	8707	\N
18831	132	3	0	11528	\N
18831	5516	4	0	11529	\N
18899	108	2	0	11791	\N
18899	3340	3	0	11793	\N
18774	123	2	0	12915	\N
18774	1868	3	0	12916	\N
18754	173	4	0	14794	\N
18754	3857	5	0	14795	\N
18824	173	2	0	14808	\N
18824	2102	3	0	14809	\N
18857	192	1	0	15410	\N
18699	5495	32	0	16539	\N
18699	38	38	0	16548	\N
18699	5496	39	0	16549	\N
18850	167	1	0	17828	\N
18850	533	2	0	17830	\N
18721	30	3	0	18132	\N
18721	3640	4	0	18137	\N
18907	60	5	0	19605	\N
18907	5528	6	0	19611	\N
18860	62	3	0	19879	\N
18860	5484	4	0	19884	\N
18684	164	3	0	21260	\N
18695	1495	3	0	21384	\N
18695	5494	4	0	21385	\N
18731	336	5	0	22899	\N
18731	3283	6	0	22906	\N
18736	214	7	0	24562	\N
18736	5502	8	0	24563	\N
18815	214	1	0	24566	\N
18815	215	2	0	24567	\N
18817	69	1	0	24885	\N
18817	70	2	0	24886	\N
18821	69	1	0	24889	\N
18821	70	2	0	24890	\N
18902	5527	7	0	24929	\N
18691	5490	8	1	25627	\N
18794	94	6	0	26969	\N
18794	5513	7	0	26970	\N
18711	42	27	0	27735	\N
18711	5498	28	0	27736	\N
18708	16	5	0	28749	\N
18708	4240	6	0	28750	\N
18829	16	1	0	28757	\N
18859	16	1	0	28758	\N
18829	17	2	0	28759	\N
18859	17	2	0	28760	\N
18865	155	3	0	28764	\N
18693	20	4	0	30571	\N
18693	2292	5	0	30573	\N
18813	20	5	0	30589	\N
18813	2820	6	0	30593	\N
18836	151	1	0	30849	\N
18836	302	2	0	30851	\N
18724	33	3	0	31886	\N
18912	33	2	0	31887	\N
18724	3342	4	0	31889	\N
18912	34	3	0	31890	\N
18686	25	1	0	36067	\N
18686	4	3	0	36075	\N
18686	3114	4	0	36076	\N
18690	14	0	0	39323	\N
18842	14	2	0	39339	\N
18842	383	3	0	39341	\N
18756	18	2	0	40229	\N
18756	1685	3	0	40231	\N
18803	18	5	0	40235	\N
18833	18	1	0	40236	\N
18833	19	2	0	40237	\N
18803	3550	6	0	40239	\N
18844	18	1	0	40240	\N
18909	18	0	0	40245	\N
18800	3443	3	0	40895	\N
18716	40	2	0	42152	\N
18867	40	2	0	42209	\N
18867	282	3	0	42211	\N
18963	40	1	0	42245	\N
18963	41	2	0	42248	\N
18862	1260	3	0	43615	\N
18869	56	3	0	44338	\N
18869	1188	4	0	44341	\N
18870	88	3	0	47339	\N
18901	88	1	0	47340	\N
18901	89	2	0	47341	\N
18870	249	4	0	47343	\N
18881	100	2	0	47722	\N
18892	119	2	0	48741	\N
18892	1879	3	0	48747	\N
18710	121	1	0	49095	\N
18710	122	2	0	49097	\N
18816	125	1	0	49309	\N
18816	195	2	0	49312	\N
18811	137	2	0	49920	\N
19000	137	1	0	49921	\N
19000	138	2	0	49923	\N
18811	2721	3	0	49924	\N
18886	170	1	0	50676	\N
18886	398	2	0	50678	\N
18751	273	2	0	53089	\N
18751	1413	3	0	53090	\N
18771	279	2	0	53286	\N
18771	4525	3	0	53289	\N
18872	285	1	0	53679	\N
18872	286	2	0	53680	\N
18984	285	1	0	53683	\N
18984	286	2	0	53684	\N
18849	324	2	0	54314	\N
18849	2808	3	0	54315	\N
18835	353	1	0	54709	\N
18835	354	2	0	54710	\N
18937	451	1	0	55429	\N
18937	584	2	0	55430	\N
18973	595	2	0	55767	\N
18973	3285	3	0	55775	\N
18991	597	2	0	56042	\N
18991	3286	3	0	56054	\N
18878	841	3	0	57154	\N
18878	5522	4	0	57156	\N
18923	852	1	0	57342	\N
18923	913	2	0	57344	\N
18840	2578	1	0	58615	\N
18840	5518	2	0	58616	\N
18804	2636	2	0	58877	\N
18804	2836	3	0	58878	\N
18895	3628	2	0	59762	\N
18895	4360	3	0	59766	\N
18889	4233	2	0	60001	\N
18889	5525	3	0	60003	\N
18926	5532	2	0	60404	\N
18743	5055	5	0	1615	\N
18921	2013	2	0	1656	\N
18987	3767	4	0	2293	\N
18987	3768	5	0	2297	\N
18896	110	4	0	2679	\N
18896	5526	5	0	2689	\N
18763	373	3	0	5368	\N
18763	3590	4	0	5371	\N
18767	4178	3	0	6145	\N
18767	5507	4	0	6149	\N
18809	4178	2	0	6151	\N
18823	4178	2	0	6152	\N
18809	4247	3	0	6155	\N
18914	4178	2	0	6165	\N
18947	4178	3	0	6168	\N
18914	4247	3	0	6175	\N
18947	4441	4	0	6177	\N
18758	4172	2	0	8690	\N
18758	4191	3	0	8691	\N
18866	4172	1	0	8702	\N
18866	4201	2	0	8703	\N
18871	4172	3	0	8704	\N
18871	4440	4	0	8705	\N
18916	4172	2	0	8708	\N
18916	4191	3	0	8711	\N
18930	392	2	0	10689	\N
18965	132	1	0	11540	\N
18965	455	2	0	11541	\N
18970	132	2	0	11546	\N
18970	133	3	0	11547	\N
18887	77	3	0	13265	\N
18887	2161	4	0	13266	\N
18982	77	2	0	13274	\N
18982	3853	3	0	13275	\N
18995	77	1	0	13287	\N
18995	78	2	0	13288	\N
18730	173	0	0	14786	\N
18928	236	2	0	15893	\N
18799	44	3	0	16149	\N
18799	3631	4	0	16152	\N
18838	326	3	0	17524	\N
18838	5517	4	0	17525	\N
18738	167	4	0	17808	\N
18738	4048	5	0	17810	\N
18745	167	2	0	17818	\N
18745	3322	3	0	17819	\N
18935	30	1	0	18133	\N
18935	418	2	0	18136	\N
18791	313	2	0	18733	\N
18864	62	2	0	19893	\N
18864	683	3	0	19894	\N
18911	62	2	0	19902	\N
18911	2191	3	0	19904	\N
18723	64	6	0	20822	\N
18723	4057	7	0	20823	\N
18876	5520	35	0	21244	\N
18874	164	1	0	21261	\N
18919	164	2	0	21262	\N
18874	165	2	0	21263	\N
18919	1124	3	0	21265	\N
18876	164	72	0	21267	\N
18884	488	1	0	21564	\N
18884	489	2	0	21565	\N
18707	73	7	0	22675	\N
18707	5104	8	0	22676	\N
18733	149	4	0	23290	\N
18733	5500	5	0	23291	\N
18900	214	2	0	24570	\N
18900	1259	3	0	24571	\N
18950	69	1	0	24897	\N
18950	70	2	0	24899	\N
18784	411	3	0	25351	\N
18784	3596	4	0	25356	\N
18715	2794	3	0	26967	\N
18814	16	5	0	28754	\N
18814	3455	6	0	28755	\N
18898	16	1	0	28762	\N
18898	17	2	0	28763	\N
18802	2	5	0	35199	\N
18802	3624	6	0	35201	\N
18852	4	1	0	36085	\N
18954	4	3	0	36086	\N
18852	25	2	0	36087	\N
18954	5535	4	0	36088	\N
18713	14	10	0	39337	\N
18728	1785	3	0	39340	\N
18713	5499	11	0	39342	\N
18856	14	2	0	39351	\N
18856	1785	3	0	39352	\N
18786	18	5	0	40234	\N
18786	3550	6	0	40238	\N
18879	18	1	0	40242	\N
18879	19	2	0	40244	\N
18996	40	1	0	42246	\N
18996	41	2	0	42249	\N
19063	40	10	0	42293	\N
19063	5548	11	0	42294	\N
19082	40	2	0	42324	\N
19082	282	3	0	42325	\N
18945	56	2	0	44339	\N
18945	169	3	0	44340	\N
18990	56	1	0	44344	\N
18990	57	2	0	44345	\N
19042	56	6	0	44348	\N
19042	5541	7	0	44349	\N
19077	56	2	0	44350	\N
19077	2795	3	0	44351	\N
19013	75	2	0	45521	\N
19013	284	3	0	45525	\N
19014	79	2	0	46512	\N
19014	616	3	0	46515	\N
19035	88	1	0	47355	\N
19035	89	2	0	47356	\N
19059	113	2	0	48403	\N
19059	1899	3	0	48407	\N
18974	147	2	0	50093	\N
18974	3287	3	0	50097	\N
18925	156	2	0	50311	\N
18925	4485	3	0	50312	\N
18975	181	2	0	51065	\N
18975	3313	3	0	51066	\N
18999	181	2	0	51073	\N
18999	3313	3	0	51075	\N
18988	242	4	0	52228	\N
18988	3512	5	0	52229	\N
18934	279	1	0	53287	\N
18934	473	2	0	53288	\N
19032	316	1	0	54086	\N
19032	317	2	0	54089	\N
18976	435	2	0	55099	\N
18976	3413	3	0	55101	\N
18992	595	2	0	55768	\N
18992	3285	3	0	55776	\N
18972	597	2	0	56041	\N
19045	597	1	0	56043	\N
19045	598	2	0	56052	\N
18972	3286	3	0	56053	\N
19009	1470	1	0	58357	\N
19009	1471	2	0	58358	\N
19022	4983	1	0	59067	\N
18931	2351	2	0	59072	\N
19022	2351	2	0	59073	\N
18931	2754	3	0	59076	\N
19029	4233	3	0	60002	\N
19029	5539	4	0	60004	\N
19034	2804	3	0	432	\N
19038	5540	3	0	2374	\N
18903	110	3	0	2680	\N
18903	3328	4	0	2686	\N
18938	228	2	0	2789	\N
18938	4776	3	0	2792	\N
18948	262	3	0	3935	\N
18948	1579	4	0	3938	\N
18913	4178	2	0	6164	\N
18949	4178	1	0	6169	\N
18922	4450	2	0	6171	\N
18949	4450	2	0	6173	\N
18913	5529	3	0	6176	\N
18983	4247	3	0	6182	\N
19039	4178	2	0	6186	\N
19039	4247	3	0	6187	\N
19068	4178	1	0	6191	\N
19070	4178	1	0	6192	\N
19068	4450	2	0	6193	\N
19070	4450	2	0	6194	\N
18939	4172	2	0	8712	\N
18940	4172	1	0	8713	\N
18940	4201	2	0	8714	\N
18939	4191	3	0	8715	\N
18942	5534	4	0	8716	\N
19041	4172	0	0	8718	\N
18989	391	1	0	10698	\N
19025	391	1	0	10699	\N
18989	392	2	0	10700	\N
19025	392	2	0	10701	\N
19088	391	1	0	10708	\N
18997	132	1	0	11554	\N
18997	455	2	0	11555	\N
18966	300	2	0	12283	\N
18966	2786	3	0	12285	\N
18961	233	3	0	13872	\N
18961	3704	4	0	13873	\N
18918	1148	3	0	14240	\N
19040	402	1	0	14244	\N
19040	403	2	0	14245	\N
18927	258	1	0	14511	\N
18927	309	2	0	14512	\N
18933	44	2	0	16150	\N
18933	1910	3	0	16151	\N
18924	38	1	0	16550	\N
18924	399	2	0	16551	\N
18952	115	2	0	16821	\N
18952	636	3	0	16823	\N
18905	62	1	0	19901	\N
18943	62	2	0	19907	\N
19016	62	2	0	19909	\N
19016	2191	3	0	19912	\N
18943	683	3	0	19914	\N
18980	64	1	0	20832	\N
18981	64	0	0	20833	\N
18980	65	2	0	20834	\N
19005	73	30	0	22677	\N
19005	5537	31	0	22680	\N
18978	336	1	0	22901	\N
19007	336	1	0	22902	\N
18978	356	2	0	22903	\N
18941	5533	4	0	23292	\N
18941	149	5	0	23301	\N
18944	140	2	0	24178	\N
18998	140	2	0	24180	\N
18998	3183	3	0	24182	\N
18944	487	3	0	24183	\N
18977	214	5	0	24572	\N
18977	5536	6	0	24573	\N
18951	69	0	0	24898	\N
18957	411	1	0	25352	\N
18959	411	0	0	25353	\N
18957	412	2	0	25354	\N
19018	95	3	0	26972	\N
18956	16	1	0	28765	\N
18985	16	1	0	28766	\N
18956	17	2	0	28769	\N
18985	17	2	0	28770	\N
18968	320	2	0	29251	\N
18968	1937	3	0	29252	\N
19073	320	2	0	29284	\N
19073	1937	3	0	29285	\N
19017	449	2	0	29913	\N
19017	646	3	0	29914	\N
18986	202	4	0	31215	\N
18960	2	3	0	35223	\N
19010	2	1	0	35224	\N
19026	2	5	0	35225	\N
19010	26	2	0	35226	\N
18960	3548	4	0	35227	\N
19026	3914	6	0	35229	\N
19085	4	8	0	36093	\N
19085	5552	9	0	36094	\N
18908	18	0	0	40243	\N
18958	18	1	0	40246	\N
18958	19	2	0	40248	\N
19031	40	1	0	42247	\N
19031	41	2	0	42250	\N
19079	40	1	0	42310	\N
19079	41	2	0	42311	\N
19093	51	3	0	43613	\N
19093	3533	4	0	43616	\N
18964	57	2	0	44343	\N
19037	56	1	0	44346	\N
19037	57	2	0	44347	\N
18979	71	1	0	44933	\N
18979	72	2	0	44935	\N
19061	75	2	0	45522	\N
19075	75	1	0	45523	\N
19075	76	2	0	45524	\N
19061	284	3	0	45526	\N
19097	113	3	0	48404	\N
19097	3620	4	0	48409	\N
19002	119	0	0	48742	\N
19071	119	2	0	48743	\N
19071	1879	3	0	48748	\N
19012	121	2	0	49099	\N
19012	2498	3	0	49100	\N
19001	135	1	0	49652	\N
19001	136	2	0	49653	\N
18993	147	2	0	50094	\N
19047	147	1	0	50095	\N
19047	599	2	0	50096	\N
18993	3287	3	0	50098	\N
19055	147	2	0	50128	\N
19055	3287	3	0	50135	\N
18971	268	1	0	52866	\N
18971	269	2	0	52867	\N
19049	273	5	0	53095	\N
19049	5544	6	0	53096	\N
19086	316	8	0	54087	\N
19086	5553	9	0	54091	\N
19044	435	4	0	55100	\N
19044	5543	5	0	55102	\N
19095	451	3	0	55440	\N
19096	451	24	0	55441	\N
19095	3934	4	0	55444	\N
19096	5556	25	0	55446	\N
19046	595	1	0	55769	\N
19057	595	2	0	55770	\N
19046	596	2	0	55773	\N
19057	3285	3	0	55777	\N
19056	597	2	0	56044	\N
19056	3286	3	0	56055	\N
19036	1021	1	0	56488	\N
19036	1022	2	0	56489	\N
19015	1470	2	0	58363	\N
19015	3368	3	0	58367	\N
19090	3505	29	0	58456	\N
19091	3505	6	0	58457	\N
19091	5555	7	0	58458	\N
19090	5554	30	0	58459	\N
19023	4983	1	0	59068	\N
19024	4983	1	0	59069	\N
19023	2351	2	0	59074	\N
19024	2351	2	0	59075	\N
19004	3625	0	0	59597	\N
19074	3625	2	0	59603	\N
19074	4359	3	0	59606	\N
19003	3628	0	0	59763	\N
19072	3628	2	0	59764	\N
19072	4360	3	0	59767	\N
19062	4787	10	0	60308	\N
19062	5547	11	0	60309	\N
19108	5561	7	0	60407	\N
19067	5550	3	0	440	\N
19110	3410	4	0	1616	\N
19103	5557	6	0	1841	\N
19103	5558	7	0	1842	\N
19083	1141	3	0	5154	\N
19083	5551	4	0	5155	\N
18967	4178	2	0	6178	\N
19027	4178	2	0	6180	\N
18967	4247	3	0	6181	\N
19027	4247	3	0	6183	\N
19030	4178	1	0	6184	\N
19030	4450	2	0	6185	\N
19051	4178	1	0	6188	\N
19052	4178	3	0	6190	\N
19052	4441	4	0	6195	\N
19081	4178	1	0	6196	\N
19081	4450	2	0	6197	\N
19087	4178	1	0	6198	\N
19089	4178	7	0	6199	\N
19087	4450	2	0	6200	\N
19089	4708	8	0	6201	\N
19099	4178	3	0	6204	\N
19099	4211	4	0	6205	\N
19102	4178	6	0	6206	\N
19102	4250	7	0	6207	\N
19048	4191	3	0	8720	\N
19058	4172	2	0	8721	\N
19058	4191	3	0	8722	\N
19066	4172	2	0	8723	\N
19084	4172	8	0	8724	\N
19100	4172	6	0	8725	\N
19107	4172	6	0	8726	\N
19109	4172	3	0	8727	\N
19109	4275	4	0	8728	\N
19100	4197	7	0	8729	\N
19107	4365	7	0	8730	\N
19084	5165	9	0	8731	\N
19088	392	2	0	10709	\N
19054	108	6	0	11792	\N
19054	5546	7	0	11794	\N
19105	300	4	0	12284	\N
19105	2992	5	0	12286	\N
19028	258	1	0	14520	\N
19028	309	2	0	14521	\N
19104	173	2	0	14818	\N
19104	3179	3	0	14819	\N
19050	30	5	0	18134	\N
19050	5545	6	0	18140	\N
19011	62	2	0	19908	\N
19064	198	1	0	20232	\N
19064	199	2	0	20233	\N
19006	73	2	0	22678	\N
19006	2766	3	0	22679	\N
19021	149	4	0	23299	\N
19021	5500	5	0	23300	\N
19078	214	2	0	24574	\N
19078	1259	3	0	24575	\N
19008	224	1	0	25646	\N
19080	224	1	0	25647	\N
19008	225	2	0	25649	\N
19080	225	2	0	25650	\N
18994	2773	3	0	25871	\N
19069	206	1	0	25874	\N
19069	207	2	0	25875	\N
19043	94	6	0	26973	\N
19060	94	2	0	26974	\N
19060	2794	3	0	26976	\N
19043	5542	7	0	26979	\N
18969	244	2	0	27411	\N
18969	3308	3	0	27414	\N
19033	16	1	0	28767	\N
19033	17	2	0	28771	\N
19019	96	0	0	29726	\N
19020	5538	5	0	29734	\N
19076	14	1	0	39363	\N
19076	15	2	0	39364	\N
19053	18	3	0	40247	\N
19053	609	4	0	40249	\N
19065	27	4	0	41135	\N
19065	3717	5	0	41136	\N
19116	40	6	0	42344	\N
19116	2777	7	0	42345	\N
19125	40	2	0	42375	\N
19139	40	4	0	42376	\N
19125	282	3	0	42377	\N
19139	3381	5	0	42378	\N
19145	40	3	0	42399	\N
19145	372	4	0	42400	\N
19167	40	7	0	42421	\N
19167	4718	8	0	42422	\N
19136	75	3	0	45533	\N
19136	3855	4	0	45534	\N
19165	75	3	0	45541	\N
19165	3855	4	0	45543	\N
19115	113	0	0	48405	\N
19210	121	4	0	49102	\N
19210	4099	5	0	49106	\N
19173	181	14	0	51074	\N
19173	5572	15	0	51076	\N
19124	200	2	0	51694	\N
19124	276	3	0	51695	\N
19152	201	1	0	51696	\N
19152	200	5	0	51697	\N
19152	5569	6	0	51698	\N
19172	210	3	0	51981	\N
19172	3539	4	0	51982	\N
19106	242	8	0	52236	\N
19106	5559	9	0	52237	\N
19128	242	2	0	52251	\N
19128	3425	3	0	52255	\N
19166	268	7	0	52872	\N
19166	5254	8	0	52875	\N
19120	279	2	0	53300	\N
19120	4525	3	0	53301	\N
19092	285	3	0	53692	\N
19092	4496	4	0	53698	\N
19121	5563	27	0	57159	\N
19123	841	4	0	57160	\N
19123	2774	5	0	57168	\N
19121	841	29	0	57170	\N
19121	2907	30	0	57171	\N
19137	908	4	0	57732	\N
19138	908	3	0	57733	\N
19142	908	7	0	57734	\N
19143	908	5	0	57735	\N
19138	3591	4	0	57737	\N
19137	3488	5	0	57738	\N
19143	5076	6	0	57739	\N
19142	4078	8	0	57740	\N
19141	1914	3	0	58507	\N
19141	3637	4	0	58508	\N
19140	2578	3	0	58619	\N
19140	4431	4	0	58620	\N
19112	2636	1	0	58880	\N
19112	3207	2	0	58885	\N
19135	4204	4	0	450	\N
19158	5571	4	0	1735	\N
19119	996	2	0	1878	\N
19119	5562	3	0	1879	\N
19127	1636	2	0	3069	\N
19127	4416	3	0	3071	\N
19144	35	3	0	4230	\N
19098	4178	3	0	6202	\N
19098	4211	4	0	6203	\N
19134	4178	10	0	6208	\N
19134	4665	11	0	6209	\N
19156	4178	4	0	6210	\N
19156	4205	5	0	6211	\N
19168	4178	7	0	6212	\N
19168	4396	8	0	6213	\N
19122	4172	4	0	8733	\N
19122	4252	5	0	8734	\N
19147	4172	3	0	8735	\N
19147	4275	4	0	8736	\N
19162	4172	3	0	8738	\N
19162	4275	4	0	8739	\N
19197	4172	7	0	8746	\N
19197	4614	8	0	8747	\N
19217	4537	7	0	8748	\N
19208	4172	3	0	8750	\N
19217	4172	11	0	8757	\N
19217	4940	12	0	8758	\N
19101	391	6	0	10714	\N
19132	391	6	0	10715	\N
19101	3521	7	0	10720	\N
19132	3521	7	0	10721	\N
19154	455	1	0	11556	\N
19155	455	1	0	11557	\N
19154	132	5	0	11564	\N
19155	132	5	0	11565	\N
19154	1423	6	0	11566	\N
19155	1423	6	0	11567	\N
19153	78	1	0	13290	\N
19151	77	5	0	13302	\N
19153	77	5	0	13303	\N
19151	5568	6	0	13304	\N
19153	5568	6	0	13305	\N
19170	58	3	0	13588	\N
19170	3665	4	0	13589	\N
19148	960	4	0	15225	\N
19148	5566	5	0	15228	\N
19129	44	2	0	16187	\N
19129	1910	3	0	16188	\N
19214	115	20	0	16835	\N
19150	326	19	0	17533	\N
19150	5567	20	0	17534	\N
19218	5588	7	0	19057	\N
19218	290	11	0	19071	\N
19117	60	2	0	19616	\N
19117	4544	3	0	19625	\N
19133	198	6	0	20237	\N
19133	5565	7	0	20238	\N
19131	164	6	0	21276	\N
19131	3583	7	0	21277	\N
19183	164	4	0	21291	\N
19183	5576	5	0	21294	\N
19163	1103	4	0	21574	\N
19130	145	53	0	22082	\N
19130	5564	54	0	22087	\N
19146	224	3	0	25648	\N
19146	3603	4	0	25651	\N
19149	224	4	0	25659	\N
19149	3806	5	0	25660	\N
19159	94	4	0	26975	\N
19159	4677	5	0	26977	\N
19114	16	0	0	28768	\N
19160	202	6	0	31216	\N
19161	202	8	0	31217	\N
19161	4609	9	0	31224	\N
19118	360	2	0	31629	\N
19118	2767	3	0	31632	\N
19094	33	3	0	31899	\N
19094	3342	4	0	31901	\N
19113	322	1	0	32510	\N
19113	2968	2	0	32511	\N
19176	322	3	0	32517	\N
19176	1105	4	0	32518	\N
19169	453	3	0	32887	\N
19169	2838	4	0	32890	\N
19171	431	3	0	34842	\N
19164	2	3	0	35239	\N
19164	3548	4	0	35242	\N
19126	6	2	0	36343	\N
19126	2805	3	0	36346	\N
19111	18	2	0	40250	\N
19111	1685	3	0	40251	\N
19157	18	3	0	40252	\N
19157	3621	4	0	40253	\N
19231	2714	6	0	42450	\N
19239	40	3	0	42474	\N
19239	372	4	0	42476	\N
19460	40	2	0	42569	\N
19460	282	3	0	42571	\N
19458	75	10	0	45577	\N
19458	4874	11	0	45578	\N
19222	102	6	0	48012	\N
19222	5086	7	0	48015	\N
19317	102	8	0	48035	\N
19317	5616	9	0	48036	\N
19455	125	3	0	49310	\N
19455	4170	4	0	49313	\N
19181	170	5	0	50691	\N
19382	170	2	0	50693	\N
19382	1380	3	0	50695	\N
19181	5102	6	0	50696	\N
19412	186	0	0	51411	\N
19392	273	2	0	53106	\N
19392	5658	3	0	53107	\N
19297	285	3	0	53693	\N
19297	4496	4	0	53699	\N
19370	324	5	0	54372	\N
19370	3680	6	0	54373	\N
19394	324	0	0	54385	\N
19403	324	2	0	54387	\N
19403	2808	3	0	54389	\N
19448	353	7	0	54715	\N
19448	4909	8	0	54717	\N
19225	595	5	0	55771	\N
19225	4930	6	0	55784	\N
19312	595	3	0	55791	\N
19312	3654	4	0	55792	\N
19230	597	5	0	56045	\N
19276	597	3	0	56046	\N
19276	3656	4	0	56056	\N
19230	4929	6	0	56062	\N
19269	3495	3	0	56256	\N
19266	1109	16	0	56271	\N
19269	1109	4	0	56274	\N
19266	5605	17	0	56275	\N
19337	2636	3	0	58884	\N
19337	2837	4	0	58886	\N
19347	2636	4	0	58891	\N
19347	3617	5	0	58894	\N
19302	5611	0	0	59797	\N
19185	4233	2	0	60009	\N
19185	5577	3	0	60010	\N
19202	4233	5	0	60017	\N
19202	4518	6	0	60018	\N
19357	424	15	0	1000	\N
19357	5645	16	0	1006	\N
19198	117	7	0	2151	\N
19198	5276	8	0	2155	\N
19415	367	3	0	3520	\N
19415	3683	4	0	3523	\N
19397	35	4	0	4240	\N
19321	189	46	0	5001	\N
19321	5618	47	0	5005	\N
19190	4178	3	0	6216	\N
19190	4211	4	0	6217	\N
19195	4178	3	0	6218	\N
19195	4211	4	0	6219	\N
19244	4178	7	0	6228	\N
19244	4509	8	0	6229	\N
19261	4178	10	0	6231	\N
19261	4665	11	0	6233	\N
19287	4178	8	0	6238	\N
19287	5610	9	0	6241	\N
19325	4178	9	0	6246	\N
19325	5622	10	0	6248	\N
19373	4178	3	0	6260	\N
19409	4178	3	0	6261	\N
19373	4211	4	0	6262	\N
19409	4211	4	0	6263	\N
19430	5667	11	0	6269	\N
19443	4178	3	0	6272	\N
19443	4211	4	0	6275	\N
19452	4178	5	0	6277	\N
19452	4202	6	0	6279	\N
19463	4178	2	0	6284	\N
19463	4247	3	0	6289	\N
19193	4172	3	0	8742	\N
19193	4275	4	0	8744	\N
19290	4172	7	0	8752	\N
19290	4614	8	0	8756	\N
19188	391	3	0	10716	\N
19188	3660	4	0	10718	\N
19344	3660	4	0	10719	\N
19425	391	4	0	10738	\N
19425	3913	5	0	10743	\N
19235	108	3	0	11803	\N
19235	4171	4	0	11804	\N
19319	108	3	0	11812	\N
19319	4171	4	0	11813	\N
19332	108	4	0	11819	\N
19332	4060	5	0	11820	\N
19450	108	5	0	11833	\N
19450	5674	6	0	11836	\N
19295	1877	4	0	13299	\N
19340	402	10	0	14252	\N
19340	5634	11	0	14257	\N
19407	173	4	0	14826	\N
19407	3614	5	0	14827	\N
19247	92	3	0	15131	\N
19247	4410	4	0	15133	\N
19263	92	3	0	15139	\N
19263	4410	4	0	15140	\N
19385	38	4	0	16554	\N
19385	5656	5	0	16558	\N
19375	115	3	0	16845	\N
19433	142	8	0	18714	\N
19433	5668	9	0	18716	\N
19218	5589	12	0	19072	\N
19299	145	3	0	22049	\N
19299	4908	4	0	22050	\N
19277	145	4	0	22083	\N
19277	5607	5	0	22084	\N
19457	224	4	0	25672	\N
19457	3806	5	0	25673	\N
19378	206	3	0	25878	\N
19378	4584	4	0	25879	\N
19322	5209	105	0	26188	\N
19322	5619	127	0	26207	\N
19342	16	10	0	28784	\N
19342	5636	11	0	28787	\N
19292	320	7	0	29303	\N
19292	4827	8	0	29304	\N
19421	20	7	0	30590	\N
19421	4714	8	0	30592	\N
19254	322	8	0	32526	\N
19254	5596	9	0	32527	\N
19282	322	4	0	32530	\N
19282	5447	5	0	32531	\N
19360	322	3	0	32534	\N
19350	2	3	0	35269	\N
19350	3548	4	0	35273	\N
19249	6	7	0	36344	\N
19249	5595	8	0	36347	\N
19307	6	7	0	36360	\N
19307	5595	8	0	36361	\N
19363	14	5	0	39369	\N
19363	5648	6	0	39370	\N
19417	14	4	0	39382	\N
19417	3498	5	0	39387	\N
19174	27	4	0	41151	\N
19174	3717	5	0	41152	\N
19187	5579	8	0	42423	\N
19187	40	10	0	42436	\N
19187	1383	11	0	42437	\N
19283	40	7	0	42493	\N
19283	4488	8	0	42494	\N
19404	40	4	0	42550	\N
19404	3381	5	0	42553	\N
19428	51	3	0	43624	\N
19428	3533	4	0	43634	\N
19270	4109	3	0	44352	\N
19306	56	20	0	44353	\N
19308	56	7	0	44354	\N
19270	56	4	0	44357	\N
19308	4791	8	0	44360	\N
19306	5614	21	0	44361	\N
19335	75	15	0	45554	\N
19335	5632	16	0	45555	\N
19465	75	4	0	45585	\N
19223	102	6	0	48013	\N
19223	5086	7	0	48016	\N
19300	102	4	0	48021	\N
19300	3572	5	0	48022	\N
19175	121	3	0	49101	\N
19175	4471	4	0	49104	\N
19358	121	15	0	49107	\N
19358	5646	16	0	49114	\N
19461	137	3	0	49922	\N
19461	3633	4	0	49926	\N
19226	147	5	0	50129	\N
19313	147	3	0	50131	\N
19313	3657	4	0	50137	\N
19226	4932	6	0	50140	\N
19180	5573	47	0	50679	\N
19180	170	126	0	50697	\N
19180	5574	127	0	50698	\N
19264	268	4	0	52873	\N
19264	3897	5	0	52874	\N
19236	273	3	0	53105	\N
19236	3638	4	0	53108	\N
19211	324	4	0	54326	\N
19211	3500	5	0	54327	\N
19393	324	2	0	54384	\N
19393	3000	3	0	54388	\N
19446	353	5	0	54714	\N
19273	595	3	0	55772	\N
19273	3654	4	0	55782	\N
19267	3495	3	0	56254	\N
19267	1109	4	0	56272	\N
19240	1021	3	0	56497	\N
19240	4551	4	0	56499	\N
19422	841	3	0	57162	\N
19422	5666	4	0	57165	\N
19248	5594	4	0	58667	\N
19257	2351	10	0	59079	\N
19368	2351	7	0	59081	\N
19368	5652	8	0	59083	\N
19257	5603	11	0	59084	\N
19184	4233	3	0	60008	\N
19184	4425	4	0	60011	\N
19333	5631	5	0	109	\N
19200	5580	58	0	2147	\N
19200	117	126	0	2164	\N
19200	5581	127	0	2165	\N
19330	5627	4	0	2331	\N
19330	5628	11	0	2332	\N
19330	5629	12	0	2333	\N
19280	228	3	0	2802	\N
19298	228	3	0	2803	\N
19280	3186	4	0	2804	\N
19298	3186	4	0	2805	\N
19341	228	10	0	2812	\N
19341	5635	11	0	2813	\N
19233	5320	4	0	3653	\N
19349	5639	23	0	4735	\N
19401	5660	2	1	4736	\N
19320	189	4	0	5000	\N
19320	3992	5	0	5003	\N
19349	5638	9	0	5006	\N
19348	189	0	0	5010	\N
19349	189	22	0	5017	\N
19401	189	1	0	5050	\N
19401	1970	2	0	5148	\N
19213	4178	3	0	6221	\N
19213	4211	4	0	6222	\N
19328	5625	12	0	6249	\N
19343	4178	10	0	6251	\N
19343	5637	11	0	6255	\N
19351	4178	3	0	6256	\N
19366	4178	3	0	6257	\N
19351	4211	4	0	6258	\N
19366	4211	4	0	6259	\N
19453	4178	10	0	6278	\N
19453	5637	11	0	6281	\N
19456	4178	3	0	6282	\N
19456	4211	4	0	6283	\N
19196	4172	3	0	8743	\N
19361	4172	4	0	8762	\N
19405	4172	5	0	8763	\N
19361	4219	5	0	8764	\N
19405	4634	6	0	8765	\N
19371	391	5	0	10728	\N
19371	3558	6	0	10730	\N
19451	108	2	0	11834	\N
19451	3340	3	0	11835	\N
19318	258	8	0	14533	\N
19388	258	5	0	14534	\N
19388	5657	6	0	14537	\N
19318	5617	9	0	14538	\N
19192	4144	8	0	16198	\N
19439	38	18	0	16555	\N
19439	5671	19	0	16560	\N
19206	115	3	0	16829	\N
19206	3483	4	0	16832	\N
19215	115	14	0	16836	\N
19278	115	6	0	16837	\N
19278	4693	7	0	16838	\N
19215	5586	15	0	16839	\N
19182	167	4	0	17829	\N
19182	5575	5	0	17831	\N
19441	167	4	0	17842	\N
19376	142	3	0	18713	\N
19376	4254	4	0	18715	\N
19291	241	7	0	20475	\N
19434	241	0	0	20477	\N
19291	4987	8	0	20481	\N
19285	140	8	0	24194	\N
19285	5609	9	0	24197	\N
19431	140	3	0	24214	\N
19431	4149	4	0	24215	\N
19323	90	9	0	26202	\N
19323	5620	10	0	26205	\N
19303	42	20	0	27718	\N
19310	16	3	0	28780	\N
19310	3634	4	0	28781	\N
19391	16	5	0	28785	\N
19391	4240	6	0	28786	\N
19398	16	4	0	28788	\N
19398	3546	5	0	28791	\N
19255	320	8	0	29302	\N
19255	5597	9	0	29305	\N
19252	360	3	0	31630	\N
19252	3602	4	0	31634	\N
19444	230	0	0	32291	\N
19178	322	3	0	32521	\N
19260	18	10	0	40254	\N
19426	18	4	0	40255	\N
19426	2302	5	0	40256	\N
19260	4919	11	0	40257	\N
19286	40	8	0	42504	\N
19286	5163	9	0	42505	\N
19384	40	4	0	42538	\N
19384	3381	5	0	42539	\N
19414	40	3	0	42551	\N
19414	372	4	0	42552	\N
19253	75	3	0	45542	\N
19253	3855	4	0	45544	\N
19329	75	11	0	45553	\N
19329	5626	12	0	45556	\N
19221	102	4	0	48011	\N
19221	5013	5	0	48014	\N
19362	113	4	0	48406	\N
19362	3677	5	0	48410	\N
19467	125	11	0	49311	\N
19467	5675	12	0	49314	\N
19454	181	3	0	51083	\N
19454	4184	4	0	51084	\N
19327	285	11	0	53694	\N
19327	5624	12	0	53702	\N
19209	316	3	0	54088	\N
19209	4249	4	0	54090	\N
19402	324	4	0	54386	\N
19402	3500	5	0	54390	\N
19353	1109	1	0	56249	\N
19353	2971	2	0	56250	\N
19356	5643	12	0	56596	\N
19420	841	7	0	57161	\N
19420	5065	8	0	57169	\N
19419	5664	3	0	57172	\N
19419	842	4	0	57173	\N
19256	5599	85	0	58404	\N
19256	5601	86	0	58673	\N
19224	2636	4	0	58881	\N
19229	2636	5	0	58882	\N
19229	3780	6	0	58889	\N
19224	5592	5	0	58890	\N
19367	2351	7	0	59080	\N
19367	5652	8	0	59082	\N
19201	4233	7	0	60016	\N
19201	5582	8	0	60019	\N
19419	5663	3	0	60397	\N
19177	3003	4	0	108	\N
19399	4043	5	0	462	\N
19374	424	3	0	1001	\N
19374	3611	4	0	1003	\N
19438	5669	0	0	1631	\N
19419	5665	4	1	1695	\N
19191	1636	7	0	3070	\N
19191	4720	8	0	3072	\N
19246	35	3	0	4231	\N
19246	3563	4	0	4234	\N
19346	3545	5	0	4235	\N
19377	189	3	0	5011	\N
19380	189	2	0	5012	\N
19400	189	4	0	5013	\N
19380	3441	3	0	5014	\N
19377	3782	4	0	5015	\N
19400	3992	5	0	5016	\N
19396	716	4	0	5296	\N
19396	5659	5	0	5297	\N
19256	5602	86	1	5304	\N
19256	5598	78	0	5366	\N
19256	5600	85	0	5373	\N
19438	5670	0	0	5378	\N
19189	4178	3	0	6214	\N
19189	4211	4	0	6215	\N
19199	4396	8	0	6223	\N
19242	4178	3	0	6224	\N
19242	4211	4	0	6225	\N
19243	4178	5	0	6226	\N
19243	4429	6	0	6227	\N
19251	4178	3	0	6230	\N
19251	4211	4	0	6232	\N
19275	4178	3	0	6234	\N
19275	4211	4	0	6236	\N
19309	4178	2	0	6242	\N
19309	4527	3	0	6243	\N
19316	4178	7	0	6244	\N
19411	4178	7	0	6264	\N
19411	4396	8	0	6265	\N
19437	4178	3	0	6271	\N
19437	4211	4	0	6274	\N
19486	4178	3	0	6287	\N
19486	4211	4	0	6290	\N
19186	5578	8	0	8737	\N
19186	4172	10	0	8740	\N
19186	5004	11	0	8741	\N
19203	4172	6	0	8749	\N
19203	4197	7	0	8755	\N
19301	4172	3	0	8759	\N
19416	4172	4	0	8769	\N
19416	4219	5	0	8770	\N
19462	4172	2	0	8777	\N
19462	4191	3	0	8778	\N
19259	132	10	0	11562	\N
19259	5050	11	0	11568	\N
19194	123	3	0	12923	\N
19194	2856	4	0	12924	\N
19356	5642	11	0	13286	\N
19356	5644	12	0	13301	\N
19204	258	6	0	14525	\N
19204	5583	7	0	14526	\N
19207	2797	3	0	16831	\N
19470	142	3	0	18724	\N
19470	4254	4	0	18728	\N
19227	60	5	0	19617	\N
19227	5473	6	0	19629	\N
19482	198	3	0	20240	\N
19482	4263	4	0	20244	\N
19272	488	4	0	21573	\N
19272	5606	5	0	21575	\N
19464	488	4	0	21583	\N
19464	5606	5	0	21584	\N
19472	488	4	0	21597	\N
19205	73	17	0	22681	\N
19205	5584	18	0	22682	\N
19294	336	3	0	22925	\N
19339	336	10	0	22926	\N
19294	3400	4	0	22929	\N
19339	5633	11	0	22931	\N
19387	214	14	0	24346	\N
19387	2338	15	0	24347	\N
19179	16	5	0	28772	\N
19179	4240	6	0	28773	\N
19265	16	3	0	28775	\N
19265	3634	4	0	28777	\N
19289	3455	15	0	28779	\N
19324	16	9	0	28782	\N
19324	5621	10	0	28783	\N
19386	449	3	0	29931	\N
19386	4760	4	0	29932	\N
19488	202	4	0	31231	\N
19296	360	7	0	31631	\N
19296	4970	8	0	31635	\N
19427	33	4	0	31900	\N
19427	5122	5	0	31902	\N
19365	230	3	0	32290	\N
19365	4181	4	0	32293	\N
19372	3548	4	0	35289	\N
19305	6	20	0	36355	\N
19305	5613	21	0	36357	\N
19479	1618	7	0	40258	\N
19479	18	9	0	40259	\N
19479	1426	10	0	40260	\N
19390	23	5	0	40899	\N
19390	4564	6	0	40902	\N
19216	40	20	0	42434	\N
19216	5587	21	0	42435	\N
19271	40	3	0	42475	\N
19271	372	4	0	42477	\N
19354	40	12	0	42520	\N
19354	5640	13	0	42521	\N
19389	40	5	0	42549	\N
19389	2714	6	0	42554	\N
19406	56	3	0	44355	\N
19406	4109	4	0	44358	\N
19465	3959	5	0	45588	\N
19408	5661	98	0	47358	\N
19410	88	3	0	47363	\N
19410	3655	4	0	47369	\N
19408	88	126	0	47375	\N
19408	5662	127	0	47376	\N
19497	100	3	0	47734	\N
19497	3836	4	0	47736	\N
19212	121	3	0	49103	\N
19212	4471	4	0	49105	\N
19274	147	3	0	50130	\N
19499	147	4	0	50132	\N
19274	3657	4	0	50136	\N
19499	3877	5	0	50138	\N
19381	170	2	0	50692	\N
19381	1380	3	0	50694	\N
19503	260	4	0	52452	\N
19503	3728	5	0	52455	\N
19238	279	2	0	53312	\N
19238	5593	3	0	53314	\N
19219	5590	7	0	54316	\N
19220	5590	7	0	54317	\N
19219	324	11	0	54328	\N
19220	324	11	0	54329	\N
19219	5591	12	0	54330	\N
19220	5591	12	0	54331	\N
19492	435	5	0	55105	\N
19492	2354	6	0	55106	\N
19445	451	0	0	55442	\N
19314	597	3	0	56047	\N
19314	3656	4	0	56057	\N
19352	1109	3	0	56248	\N
19352	3495	4	0	56251	\N
19268	3495	3	0	56255	\N
19268	1109	4	0	56273	\N
19364	1699	5	0	56591	\N
19383	1470	4	0	58364	\N
19383	5655	5	0	58368	\N
19336	2636	4	0	58883	\N
19336	3617	5	0	58887	\N
19364	5651	5	1	59790	\N
19364	5650	4	1	60459	\N
19424	3712	7	0	1005	\N
19485	5678	4	0	1828	\N
19364	4408	6	0	2328	\N
19311	262	11	0	3951	\N
19311	5615	12	0	3952	\N
19359	262	15	0	3960	\N
19359	5647	16	0	3964	\N
19279	365	6	0	4691	\N
19279	4759	7	0	4701	\N
19379	5654	5	0	5027	\N
19379	4225	6	0	5028	\N
19281	4178	3	0	6235	\N
19281	4211	4	0	6237	\N
19288	4205	5	0	6240	\N
19334	4178	4	0	6250	\N
19345	4178	3	0	6252	\N
19345	4211	4	0	6253	\N
19334	4205	5	0	6254	\N
19418	4178	3	0	6266	\N
19418	4211	4	0	6267	\N
19432	4178	3	0	6270	\N
19432	4211	4	0	6273	\N
19449	4178	7	0	6276	\N
19449	4396	8	0	6280	\N
19477	4178	5	0	6285	\N
19234	4172	3	0	8751	\N
19234	4275	4	0	8754	\N
19326	4172	11	0	8761	\N
19326	5623	12	0	8766	\N
19413	4172	6	0	8767	\N
19413	4197	7	0	8768	\N
19429	4172	3	0	8771	\N
19429	4275	4	0	8772	\N
19436	4172	3	0	8773	\N
19436	4275	4	0	8774	\N
19442	4172	4	0	8775	\N
19442	4634	5	0	8776	\N
19395	3352	5	0	10731	\N
19459	391	3	0	10739	\N
19471	391	3	0	10740	\N
19459	3660	4	0	10741	\N
19471	3660	4	0	10742	\N
19440	132	18	0	11563	\N
19440	5672	19	0	11569	\N
19478	3709	7	0	11570	\N
19478	132	9	0	11579	\N
19478	3116	10	0	11581	\N
19237	528	3	0	12591	\N
19258	528	10	0	12592	\N
19237	4262	4	0	12597	\N
19466	4262	4	0	12598	\N
19258	5604	11	0	12602	\N
19355	77	15	0	13298	\N
19355	5641	16	0	13300	\N
19476	77	4	0	13313	\N
19476	3619	5	0	13314	\N
19379	5653	5	0	13579	\N
19293	192	3	0	15416	\N
19293	3790	4	0	15417	\N
19474	115	7	0	16846	\N
19474	5676	8	0	16848	\N
19369	4695	4	0	16982	\N
19469	142	1	0	18723	\N
19469	143	2	0	18727	\N
19250	290	3	0	19068	\N
19250	3635	4	0	19069	\N
19232	60	1	0	19618	\N
19232	5088	2	0	19624	\N
19473	62	3	0	19910	\N
19473	3344	4	0	19913	\N
19315	241	3	0	20476	\N
19435	241	8	0	20478	\N
19315	3613	4	0	20480	\N
19331	2443	4	0	22255	\N
19331	67	11	0	22261	\N
19331	5630	12	0	22262	\N
19245	336	4	0	22917	\N
19245	3947	5	0	22918	\N
19338	140	4	0	24195	\N
19338	3821	5	0	24196	\N
19284	94	7	0	26980	\N
19284	5608	8	0	26996	\N
19241	16	3	0	28774	\N
19241	3634	4	0	28776	\N
19423	16	7	0	28789	\N
19507	16	6	0	28794	\N
19364	5649	4	0	31967	\N
19364	230	3	0	32289	\N
19447	230	7	0	32294	\N
19447	5285	8	0	32299	\N
19262	2	3	0	35256	\N
19262	3548	4	0	35258	\N
19304	6	20	0	36354	\N
19304	5613	21	0	36356	\N
19481	27	2	0	41166	\N
19481	645	3	0	41167	\N
19468	40	3	0	42570	\N
19468	372	4	0	42572	\N
19480	40	1	0	42593	\N
19487	40	4	0	42594	\N
19480	1383	2	0	42596	\N
19487	2796	5	0	42597	\N
19591	40	3	0	42639	\N
19591	372	4	0	42640	\N
19617	128	3	0	42641	\N
19617	5698	10	0	42661	\N
19669	40	8	0	42682	\N
19669	5163	9	0	42687	\N
19644	56	7	0	44362	\N
19644	4791	8	0	44363	\N
19683	56	9	0	44365	\N
19683	5731	10	0	44369	\N
19667	71	10	0	44938	\N
19667	5715	11	0	44939	\N
19657	75	7	0	45627	\N
19657	2859	8	0	45628	\N
19728	75	6	0	45645	\N
19728	4694	7	0	45648	\N
19739	79	3	0	46081	\N
19739	3652	4	0	46083	\N
19552	79	6	0	46514	\N
19552	4253	7	0	46516	\N
19624	79	7	0	46563	\N
19624	5706	8	0	46565	\N
19647	5712	32	0	47357	\N
19692	88	8	0	47365	\N
19737	88	2	0	47367	\N
19737	3010	3	0	47368	\N
19692	5740	9	0	47372	\N
19647	88	109	0	47373	\N
19647	5713	110	1	47448	\N
19511	121	4	0	49108	\N
19559	121	2	0	49110	\N
19559	2498	3	0	49111	\N
19732	156	3	0	50327	\N
19732	4594	4	0	50330	\N
19716	170	9	0	50707	\N
19716	5756	10	0	50708	\N
19526	279	3	0	53313	\N
19526	3641	4	0	53315	\N
19714	285	3	0	53696	\N
19714	4496	4	0	53700	\N
19587	324	3	0	54407	\N
19587	4514	4	0	54411	\N
19719	353	4	0	54720	\N
19719	2724	5	0	54722	\N
19528	595	4	0	55796	\N
19528	3878	5	0	55799	\N
19762	852	3	0	57343	\N
19762	3612	4	0	57346	\N
19617	5697	10	0	58406	\N
19744	2351	7	0	59091	\N
19744	5652	8	0	59092	\N
19519	2782	3	0	59406	\N
19519	3659	4	0	59408	\N
19711	266	3	0	1332	\N
19489	228	4	0	2818	\N
19489	5679	5	0	2823	\N
19674	262	18	0	3961	\N
19674	5721	19	0	3965	\N
19750	35	3	0	4242	\N
19736	365	2	0	4693	\N
19736	5072	3	0	4696	\N
19484	4178	3	0	6286	\N
19484	4941	4	0	6288	\N
19537	4178	3	0	6298	\N
19537	4211	4	0	6299	\N
19611	4178	7	0	6308	\N
19611	4396	8	0	6311	\N
19745	4178	12	0	6330	\N
19745	5083	13	0	6331	\N
19748	4178	3	0	6332	\N
19748	4211	4	0	6334	\N
19502	4172	4	0	8779	\N
19502	4219	5	0	8780	\N
19555	4172	4	0	8781	\N
19555	4219	5	0	8784	\N
19514	391	3	0	10751	\N
19514	3660	4	0	10754	\N
19630	391	3	0	10766	\N
19508	108	4	0	11849	\N
19704	108	6	0	11851	\N
19508	4060	5	0	11852	\N
19704	5748	7	0	11853	\N
19699	300	3	0	12289	\N
19699	3747	4	0	12290	\N
19707	5750	5	0	12615	\N
19707	528	6	0	12634	\N
19475	77	5	0	13312	\N
19475	5677	6	0	13315	\N
19549	58	7	0	13584	\N
19549	4764	8	0	13586	\N
19702	233	126	0	13890	\N
19702	5747	127	0	13891	\N
19569	402	3	0	14253	\N
19569	4077	4	0	14256	\N
19709	5749	5	0	15142	\N
19709	92	6	0	15150	\N
19642	44	3	0	16192	\N
19642	3631	4	0	16195	\N
19678	5725	6	0	18141	\N
19678	30	9	0	18145	\N
19678	2980	10	0	18146	\N
19662	290	5	0	19082	\N
19755	3176	3	0	19086	\N
19662	5714	6	0	19089	\N
19535	60	0	0	19619	\N
19496	62	3	0	19923	\N
19496	3344	4	0	19924	\N
19483	198	3	0	20241	\N
19506	198	6	0	20242	\N
19483	4263	4	0	20245	\N
19506	5565	7	0	20247	\N
19614	241	9	0	20479	\N
19614	5694	10	0	20483	\N
19622	241	7	0	20491	\N
19608	2544	7	0	20625	\N
19608	5692	8	0	20627	\N
19757	336	0	0	22927	\N
19742	140	3	0	24232	\N
19742	4149	4	0	24233	\N
19561	411	4	0	25365	\N
19561	4858	5	0	25366	\N
19625	90	13	0	26218	\N
19625	5707	14	0	26219	\N
19507	3369	7	0	28795	\N
19753	16	3	0	28805	\N
19753	3634	4	0	28809	\N
19539	3954	5	0	32298	\N
19639	230	3	0	32302	\N
19639	4181	4	0	32304	\N
19652	453	6	0	32902	\N
19652	4091	7	0	32904	\N
19599	4	3	0	36104	\N
19685	4	10	0	36105	\N
19721	4	3	0	36108	\N
19599	3837	4	0	36113	\N
19721	3837	4	0	36114	\N
19685	5733	11	0	36119	\N
19491	14	5	0	39384	\N
19595	4272	4	0	39386	\N
19491	5648	6	0	39389	\N
19517	18	4	0	40261	\N
19517	2302	5	0	40262	\N
19530	3381	5	0	42615	\N
19600	40	7	0	42659	\N
19600	4718	8	0	42660	\N
19548	56	3	0	44356	\N
19548	4109	4	0	44359	\N
19513	75	4	0	45586	\N
19562	75	4	0	45587	\N
19513	3959	5	0	45589	\N
19562	3959	5	0	45590	\N
19661	75	3	0	45639	\N
19661	3855	4	0	45640	\N
19551	79	79	0	46513	\N
19551	5684	80	0	46517	\N
19734	88	3	0	47366	\N
19734	3655	4	0	47370	\N
19738	5760	49	0	47385	\N
19738	88	95	0	47391	\N
19738	632	96	0	47392	\N
19602	100	3	0	47735	\N
19602	3836	4	0	47737	\N
19498	113	3	0	48417	\N
19498	3620	4	0	48418	\N
19511	4099	5	0	49112	\N
19527	147	4	0	50133	\N
19527	3877	5	0	50139	\N
19567	181	3	0	51089	\N
19567	4184	4	0	51092	\N
19531	210	3	0	52000	\N
19531	3539	4	0	52001	\N
19574	210	1	0	52014	\N
19574	2926	2	0	52015	\N
19717	210	3	0	52025	\N
19717	3539	4	0	52026	\N
19584	273	4	0	53116	\N
19584	3777	5	0	53117	\N
19589	324	0	0	54408	\N
19572	435	4	0	55108	\N
19572	2810	5	0	55110	\N
19501	597	4	0	56048	\N
19501	3733	5	0	56059	\N
19731	1021	3	0	56498	\N
19731	4551	4	0	56500	\N
19518	2782	8	0	59405	\N
19518	5680	9	0	59409	\N
19632	3628	7	0	59765	\N
19632	3629	8	0	59768	\N
19701	4088	3	0	59878	\N
19701	4506	4	0	59886	\N
19710	5751	3	0	60239	\N
19557	5650	39	1	60458	\N
19687	424	9	0	1011	\N
19687	5735	10	0	1021	\N
19710	5753	4	1	1126	\N
19710	5752	3	0	1330	\N
19590	251	3	0	1620	\N
19590	3514	4	0	1623	\N
19710	5726	4	0	1644	\N
19534	248	1	0	2142	\N
19534	117	4	0	2152	\N
19534	5439	5	0	2154	\N
19581	117	3	0	2169	\N
19581	3653	4	0	2170	\N
19672	3464	5	0	3226	\N
19749	35	84	0	4241	\N
19593	189	0	0	5031	\N
19722	189	3	0	5032	\N
19722	3782	4	0	5035	\N
19516	4178	4	0	6292	\N
19523	4178	3	0	6294	\N
19523	4211	4	0	6296	\N
19516	4205	5	0	6297	\N
19613	4178	7	0	6312	\N
19613	4396	8	0	6313	\N
19627	4178	13	0	6314	\N
19627	4782	14	0	6317	\N
19634	4178	3	0	6318	\N
19634	4211	4	0	6319	\N
19605	4172	3	0	8782	\N
19605	4275	4	0	8783	\N
19656	4172	3	0	8785	\N
19656	4275	4	0	8786	\N
19698	4172	18	0	8789	\N
19698	5720	19	0	8790	\N
19505	391	6	0	10750	\N
19522	391	3	0	10752	\N
19522	3660	4	0	10755	\N
19505	3521	7	0	10757	\N
19695	5744	10	0	11582	\N
19643	108	7	0	11850	\N
19643	4905	8	0	11854	\N
19570	402	1	0	14254	\N
19570	2889	2	0	14255	\N
19640	92	3	0	15147	\N
19640	4410	4	0	15148	\N
19648	192	7	0	15424	\N
19648	4713	8	0	15425	\N
19668	115	10	0	16853	\N
19668	5716	11	0	16861	\N
19597	326	10	0	17541	\N
19629	30	3	0	18135	\N
19629	3640	4	0	18138	\N
19663	290	3	0	19083	\N
19663	364	4	0	19088	\N
19557	5685	39	0	19345	\N
19536	60	3	0	19620	\N
19553	60	3	0	19622	\N
19553	3585	4	0	19627	\N
19619	1493	3	0	19631	\N
19557	2323	7	0	19633	\N
19619	60	10	0	19643	\N
19619	5704	11	0	19644	\N
19620	5705	95	0	19646	\N
19620	60	126	0	19651	\N
19620	1493	127	0	19652	\N
19521	62	3	0	19928	\N
19521	3344	4	0	19930	\N
19607	2544	11	0	20624	\N
19607	5691	12	0	20628	\N
19675	164	18	0	21303	\N
19675	5722	19	0	21307	\N
19510	264	4	0	23660	\N
19510	3684	5	0	23663	\N
19680	214	8	0	24366	\N
19576	411	4	0	25371	\N
19576	4858	5	0	25372	\N
19525	86	3	0	26635	\N
19525	3746	4	0	26637	\N
19565	16	3	0	28796	\N
19565	3634	4	0	28798	\N
19727	16	4	0	28802	\N
19727	2575	5	0	28803	\N
19729	16	2	0	28804	\N
19729	388	3	0	28807	\N
19579	96	1	0	29729	\N
19579	2899	2	0	29731	\N
19544	230	10	0	32301	\N
19544	5683	11	0	32306	\N
19653	453	6	0	32903	\N
19653	4091	7	0	32905	\N
19688	4	9	0	36106	\N
19725	4	2	0	36109	\N
19725	2751	3	0	36112	\N
19688	5736	10	0	36118	\N
19532	27	7	0	41192	\N
19532	5681	8	0	41193	\N
19616	27	9	0	41211	\N
19616	5696	10	0	41214	\N
19515	40	6	0	42595	\N
19515	4255	7	0	42598	\N
19671	56	8	0	44364	\N
19743	56	2	0	44366	\N
19743	2795	3	0	44367	\N
19671	5718	9	0	44368	\N
19563	71	3	0	44936	\N
19563	3770	4	0	44937	\N
19646	75	6	0	45619	\N
19646	4694	7	0	45620	\N
19819	75	4	0	45646	\N
19819	2357	5	0	45647	\N
19585	79	4	0	46562	\N
19585	3678	5	0	46564	\N
19815	113	7	0	48428	\N
19815	5779	8	0	48430	\N
19682	119	9	0	48745	\N
19682	5730	10	0	48751	\N
19558	121	4	0	49109	\N
19558	4099	5	0	49113	\N
19649	181	3	0	51091	\N
19649	4184	4	0	51093	\N
19610	210	3	0	52023	\N
19610	3539	4	0	52024	\N
19713	285	2	0	53695	\N
19713	3036	3	0	53697	\N
19586	353	3	0	54718	\N
19586	3766	4	0	54719	\N
19664	451	3	0	55443	\N
19664	826	4	0	55445	\N
19500	595	4	0	55795	\N
19500	3878	5	0	55798	\N
19529	597	4	0	56049	\N
19691	908	8	0	57751	\N
19691	5739	9	0	57752	\N
19799	3625	8	0	59605	\N
19799	5772	9	0	59610	\N
19684	3628	8	0	59769	\N
19684	5732	9	0	59770	\N
19801	3628	8	0	59771	\N
19801	5774	9	0	59772	\N
19546	5297	11	0	1625	\N
19638	5514	4	0	3079	\N
19735	365	3	0	4692	\N
19752	365	0	0	4695	\N
19735	3839	4	0	4699	\N
19808	365	3	0	4706	\N
19808	3839	4	0	4707	\N
19512	189	4	0	5029	\N
19512	3992	5	0	5036	\N
19723	189	96	0	5051	\N
19723	5757	97	0	5056	\N
19730	373	5	0	5369	\N
19730	5759	6	0	5372	\N
19520	4211	4	0	6295	\N
19541	4178	4	0	6300	\N
19541	4205	5	0	6303	\N
19606	4178	3	0	6307	\N
19606	4211	4	0	6310	\N
19676	4178	18	0	6322	\N
19676	5723	19	0	6323	\N
19696	4178	9	0	6324	\N
19696	4318	10	0	6325	\N
19718	4178	3	0	6326	\N
19718	4211	4	0	6327	\N
19761	4178	6	0	6333	\N
19673	4172	18	0	8787	\N
19673	5720	19	0	8788	\N
19747	4172	3	0	8793	\N
19747	4275	4	0	8794	\N
19756	4172	3	0	8795	\N
19756	4275	4	0	8796	\N
19623	391	3	0	10753	\N
19623	3660	4	0	10756	\N
19789	391	3	0	10777	\N
19789	3660	4	0	10778	\N
19779	132	7	0	11572	\N
19779	3709	8	0	11580	\N
19814	3340	3	0	11860	\N
19601	300	7	0	12287	\N
19601	5054	8	0	12288	\N
19568	5686	86	0	14246	\N
19568	402	126	0	14258	\N
19568	5687	127	0	14259	\N
19493	173	4	0	14834	\N
19493	3614	5	0	14839	\N
19706	5749	5	0	15141	\N
19706	92	6	0	15149	\N
19787	92	7	0	15157	\N
19787	5768	8	0	15164	\N
19598	3790	4	0	15421	\N
19666	235	10	0	15891	\N
19666	5146	11	0	15894	\N
19782	38	0	0	16557	\N
19556	212	4	0	17259	\N
19759	212	3	0	17260	\N
19759	3639	4	0	17262	\N
19556	3732	5	0	17263	\N
19504	167	6	0	17851	\N
19504	5066	7	0	17859	\N
19754	290	3	0	19084	\N
19754	3635	4	0	19087	\N
19536	3585	4	0	19626	\N
19554	3894	5	0	19628	\N
19621	241	7	0	20490	\N
19621	4987	8	0	20492	\N
19651	4217	3	0	20825	\N
19651	64	4	0	20836	\N
19635	164	7	0	21292	\N
19635	5711	8	0	21293	\N
19795	145	3	0	21808	\N
19795	4908	4	0	21809	\N
19641	140	3	0	24226	\N
19641	4149	4	0	24227	\N
19689	5737	11	0	24383	\N
19741	411	3	0	25378	\N
19741	3596	4	0	25381	\N
19509	224	4	0	25682	\N
19509	3806	5	0	25683	\N
19566	224	4	0	25692	\N
19566	3806	5	0	25693	\N
19770	206	3	0	25887	\N
19770	4584	4	0	25888	\N
19524	86	2	0	26634	\N
19524	3321	3	0	26636	\N
19654	86	3	0	26646	\N
19495	16	10	0	28790	\N
19495	4835	11	0	28793	\N
19577	16	4	0	28797	\N
19577	2575	5	0	28799	\N
19603	16	3	0	28800	\N
19603	3634	4	0	28801	\N
19580	96	2	0	29730	\N
19580	2942	3	0	29732	\N
19582	202	3	0	31241	\N
19582	4857	4	0	31244	\N
19543	230	7	0	32300	\N
19543	5228	8	0	32305	\N
19560	2789	3	0	35303	\N
19490	14	4	0	39383	\N
19490	2291	5	0	39388	\N
19659	18	3	0	40264	\N
19659	3621	4	0	40265	\N
19494	23	3	0	40900	\N
19494	3497	4	0	40901	\N
19824	23	3	0	40907	\N
19824	3497	4	0	40908	\N
19545	40	10	0	42626	\N
19545	4104	11	0	42627	\N
19604	51	3	0	43625	\N
19604	3533	4	0	43635	\N
19726	79	6	0	46080	\N
19775	79	3	0	46082	\N
19775	3652	4	0	46084	\N
19726	4253	7	0	46085	\N
19645	88	6	0	47364	\N
19645	5263	7	0	47371	\N
19694	5742	49	0	47374	\N
19694	88	126	0	47383	\N
19694	5743	127	0	47384	\N
19636	113	3	0	48427	\N
19636	3620	4	0	48429	\N
19631	119	7	0	48744	\N
19631	4891	8	0	48749	\N
19697	125	17	0	49324	\N
19697	5745	18	0	49325	\N
19660	156	3	0	50319	\N
19660	4594	4	0	50320	\N
19583	181	4	0	51090	\N
19583	4058	5	0	51094	\N
19571	210	4	0	52013	\N
19571	4993	5	0	52016	\N
19596	260	4	0	52453	\N
19596	3728	5	0	52456	\N
19733	260	6	0	52459	\N
19733	5311	7	0	52460	\N
19715	5754	109	0	53685	\N
19715	285	126	0	53703	\N
19715	5755	127	0	53704	\N
19720	353	6	0	54721	\N
19720	4876	7	0	54723	\N
19778	353	7	0	54726	\N
19778	4909	8	0	54727	\N
19529	3733	5	0	56060	\N
19575	793	4	0	56800	\N
19575	5688	5	0	56802	\N
19677	793	18	0	56810	\N
19677	5724	19	0	56823	\N
19618	5599	10	0	58405	\N
19618	5703	11	1	58420	\N
19765	2636	10	0	58892	\N
19765	5762	11	0	58895	\N
19633	5709	14	0	59598	\N
19681	3625	10	0	59604	\N
19681	5729	11	0	59607	\N
19633	3625	69	0	59608	\N
19633	5710	70	0	59609	\N
19612	424	7	0	1008	\N
19547	3611	4	0	1015	\N
19612	4986	8	0	1019	\N
19686	5734	11	0	1022	\N
19626	266	13	0	1331	\N
19783	266	3	0	1333	\N
19783	3474	4	0	1336	\N
19626	5708	14	0	1337	\N
19679	5726	10	0	1639	\N
19670	3464	8	0	3225	\N
19670	5717	9	0	3228	\N
19751	365	3	0	4694	\N
19751	3839	4	0	4700	\N
19724	189	12	0	5033	\N
19592	3782	4	0	5034	\N
19724	5758	13	0	5037	\N
19768	5764	86	0	5038	\N
19767	189	10	0	5052	\N
19767	5763	11	0	5053	\N
19768	189	94	0	5054	\N
19768	5765	95	0	5055	\N
19766	189	6	0	5072	\N
19766	3103	7	0	5073	\N
19542	4178	3	0	6301	\N
19542	4211	4	0	6302	\N
19564	4211	4	0	6305	\N
19588	4178	3	0	6306	\N
19588	4211	4	0	6309	\N
19628	4178	7	0	6315	\N
19628	4396	8	0	6316	\N
19665	4178	9	0	6320	\N
19665	5622	10	0	6321	\N
19740	4178	3	0	6328	\N
19740	4211	4	0	6329	\N
19777	4178	3	0	6336	\N
19777	4211	4	0	6337	\N
19705	4172	6	0	8791	\N
19769	4172	3	0	8797	\N
19780	4172	7	0	8798	\N
19769	4275	4	0	8799	\N
19780	4614	8	0	8800	\N
19578	5689	4	0	12600	\N
19578	528	7	0	12613	\N
19578	3238	8	0	12614	\N
19708	5750	5	0	12616	\N
19708	528	6	0	12635	\N
19550	58	7	0	13585	\N
19550	4764	8	0	13587	\N
19703	233	3	0	13888	\N
19658	258	3	0	14535	\N
19658	4401	4	0	14536	\N
19573	173	2	0	14835	\N
19573	2102	3	0	14837	\N
19781	38	9	0	16556	\N
19781	5766	10	0	16559	\N
19615	115	9	0	16852	\N
19615	5695	10	0	16858	\N
19712	326	3	0	17549	\N
19712	3339	4	0	17550	\N
19776	142	3	0	18725	\N
19776	4254	4	0	18729	\N
19538	60	36	0	19621	\N
19618	1493	3	0	19630	\N
19538	5682	37	0	19632	\N
19618	5701	10	0	19642	\N
19609	2544	19	0	20626	\N
19609	5693	20	0	20629	\N
19650	4217	3	0	20824	\N
19650	64	4	0	20835	\N
19763	164	0	0	21304	\N
19693	488	8	0	21601	\N
19693	5741	9	0	21606	\N
19758	336	3	0	22928	\N
19772	140	6	0	24240	\N
19772	5056	7	0	24241	\N
19679	214	9	0	24365	\N
19679	5727	10	1	24576	\N
19655	411	3	0	25377	\N
19655	3596	4	0	25380	\N
19786	86	7	0	26650	\N
19594	94	3	0	26981	\N
19594	2864	4	0	26991	\N
19533	43	1	0	27711	\N
19700	42	3	0	27719	\N
19533	42	4	0	27723	\N
19700	3645	4	0	27726	\N
19760	16	2	0	28806	\N
19760	388	3	0	28808	\N
19540	230	3	0	32296	\N
19540	4181	4	0	32297	\N
19746	2	3	0	35312	\N
19746	3548	4	0	35313	\N
19773	2	7	0	35328	\N
19773	2858	8	0	35329	\N
19690	4	7	0	36107	\N
19690	5738	8	0	36117	\N
19785	4180	6	0	40263	\N
19820	66	2	0	42663	\N
19794	40	3	0	42683	\N
19794	372	4	0	42684	\N
19820	40	7	0	42685	\N
19820	2796	8	0	42686	\N
19872	40	3	0	42733	\N
19872	372	4	0	42735	\N
19923	40	1	0	42797	\N
19923	1383	2	0	42798	\N
20011	51	3	0	43628	\N
20030	51	0	0	43633	\N
20011	3533	4	0	43638	\N
19871	56	3	0	44370	\N
19871	4109	4	0	44373	\N
19826	75	2	0	45657	\N
19826	284	3	0	45659	\N
19804	79	10	0	46124	\N
19804	5776	11	0	46129	\N
19891	88	11	0	47389	\N
19891	5801	12	0	47390	\N
19800	119	8	0	48746	\N
19800	5773	9	0	48752	\N
19902	242	7	0	52252	\N
19919	242	7	0	52253	\N
19902	4592	8	0	52256	\N
19919	5808	8	0	52257	\N
19813	268	2	0	52882	\N
19813	2800	3	0	52883	\N
19940	273	3	0	53126	\N
19940	3638	4	0	53127	\N
19948	273	15	0	53132	\N
19948	5813	16	0	53135	\N
19855	324	0	0	54449	\N
19771	353	3	0	54724	\N
19771	3766	4	0	54725	\N
19900	3531	4	0	55107	\N
19900	435	5	0	55109	\N
19971	597	7	0	56050	\N
19971	5820	8	0	56063	\N
20020	852	4	0	57371	\N
20020	4162	5	0	57372	\N
19911	1470	6	0	58365	\N
19911	5803	7	0	58370	\N
19953	2636	10	0	58893	\N
19953	5295	11	0	58896	\N
19842	2351	3	0	59093	\N
19842	2845	4	0	59095	\N
19950	2782	3	0	59415	\N
19950	3659	4	0	59416	\N
20039	4088	0	0	59879	\N
19838	3611	4	0	1017	\N
19774	5037	4	0	1089	\N
19860	5789	3	0	1880	\N
19860	1736	6	0	1883	\N
19860	5790	7	0	1884	\N
19792	117	4	0	2178	\N
19792	3835	5	0	2179	\N
19897	3835	4	0	2180	\N
19897	117	5	0	2190	\N
20046	228	7	0	2834	\N
20046	5491	8	0	2835	\N
19816	262	5	0	3962	\N
19816	4539	6	0	3963	\N
19954	5815	14	0	3995	\N
19875	189	16	0	5068	\N
19875	5798	17	0	5071	\N
20006	189	5	0	5090	\N
20006	5837	6	0	5092	\N
19790	4178	3	0	6340	\N
19790	4211	4	0	6342	\N
19851	4178	5	0	6344	\N
19864	4178	3	0	6345	\N
19864	4211	4	0	6346	\N
19851	4429	6	0	6347	\N
19956	4178	11	0	6355	\N
19985	4178	3	0	6364	\N
19997	4178	5	0	6366	\N
19985	4941	4	0	6367	\N
19997	5828	6	0	6369	\N
19811	4172	1	0	8805	\N
19811	4201	2	0	8806	\N
20018	4172	4	0	8827	\N
20018	4219	5	0	8831	\N
20044	4172	4	0	8835	\N
20044	4219	5	0	8836	\N
19835	391	4	0	10791	\N
19835	3913	5	0	10792	\N
19840	3913	5	0	10804	\N
19928	108	3	0	11865	\N
19928	4171	4	0	11868	\N
19916	173	5	0	14842	\N
19916	4902	6	0	14843	\N
19930	192	5	0	15444	\N
19930	3284	6	0	15445	\N
19829	38	3	0	16563	\N
19829	5259	4	0	16565	\N
19784	30	3	0	18149	\N
19784	3640	4	0	18150	\N
19791	30	3	0	18151	\N
19806	4838	4	0	18244	\N
19806	5777	5	0	18245	\N
20026	198	5	0	20243	\N
20026	5843	6	0	20246	\N
19821	241	5	0	20503	\N
19822	241	2	0	20504	\N
19822	634	3	0	20505	\N
19821	5780	6	0	20506	\N
19894	241	4	0	20513	\N
19894	4582	5	0	20515	\N
19764	164	3	0	21305	\N
19764	3385	4	0	21306	\N
20048	164	3	0	21326	\N
20048	3385	4	0	21327	\N
19966	4152	5	0	21328	\N
19798	149	8	0	23304	\N
19798	5771	9	0	23307	\N
19988	82	5	0	23904	\N
19988	5024	6	0	23905	\N
19786	5767	8	0	26651	\N
19886	86	3	0	26653	\N
19886	3746	4	0	26656	\N
20053	86	3	0	26660	\N
19809	94	3	0	26982	\N
19817	16	2	0	28810	\N
19817	388	3	0	28812	\N
19910	16	4	0	28818	\N
19926	16	3	0	28819	\N
19926	3634	4	0	28820	\N
19910	5446	5	0	28821	\N
19947	16	7	0	28823	\N
19947	4723	8	0	28825	\N
20015	16	3	0	28828	\N
20035	16	3	0	28829	\N
20015	3634	4	0	28830	\N
20035	3634	4	0	28831	\N
19857	4055	7	0	29940	\N
20032	230	4	0	32308	\N
20032	3954	5	0	32309	\N
19999	453	5	0	32912	\N
19999	5830	6	0	32914	\N
19825	431	2	0	34844	\N
19825	2772	3	0	34845	\N
19807	2	3	0	35345	\N
19807	3548	4	0	35347	\N
19978	4	9	0	36110	\N
19978	5824	10	0	36116	\N
19812	6	2	0	36366	\N
19823	40	5	0	42698	\N
19823	2714	6	0	42699	\N
19856	40	6	0	42715	\N
19856	4717	7	0	42716	\N
19917	40	5	0	42781	\N
19917	5806	6	0	42783	\N
20027	51	5	0	43630	\N
20027	4392	6	0	43639	\N
19949	56	15	0	44372	\N
19949	5814	16	0	44374	\N
19976	56	7	0	44377	\N
19976	4791	8	0	44380	\N
19984	75	4	0	45658	\N
19984	3959	5	0	45660	\N
19836	88	3	0	47381	\N
19836	3655	4	0	47382	\N
19850	100	6	0	47472	\N
19850	5787	7	0	47474	\N
19827	102	3	0	48047	\N
19827	5781	4	0	48052	\N
20021	113	4	0	48439	\N
20021	3677	5	0	48440	\N
20010	273	6	0	53133	\N
20010	5841	7	0	53134	\N
20050	451	3	0	55484	\N
20050	3934	4	0	55486	\N
19867	793	20	0	56811	\N
19867	5795	21	0	56822	\N
19952	852	3	0	57358	\N
20008	852	5	0	57360	\N
19952	3612	4	0	57361	\N
20008	5839	6	0	57364	\N
19889	908	7	0	57755	\N
19889	4078	8	0	57756	\N
19992	908	9	0	57760	\N
19992	5827	10	0	57761	\N
20084	1470	8	0	58380	\N
20084	5857	9	0	58382	\N
19844	2351	3	0	59094	\N
19844	2845	4	0	59096	\N
20070	4233	4	0	60022	\N
20070	4234	5	0	60023	\N
19810	5778	4	0	1678	\N
19873	5797	3	0	1830	\N
19899	3835	4	0	2181	\N
20042	117	3	0	2188	\N
20042	3653	4	0	2189	\N
19899	117	5	0	2191	\N
19869	228	3	0	2819	\N
19869	3186	4	0	2821	\N
20005	367	5	0	3521	\N
20005	5836	6	0	3524	\N
19955	262	5	0	3993	\N
19955	5816	6	0	3994	\N
19944	5810	35	0	4246	\N
19920	189	4	0	5089	\N
19920	3992	5	0	5091	\N
19788	4178	4	0	6338	\N
19788	4205	5	0	6339	\N
19892	4178	4	0	6350	\N
19892	4205	5	0	6351	\N
19908	4178	4	0	6353	\N
19908	4468	5	0	6359	\N
19967	4178	6	0	6360	\N
19967	4250	7	0	6361	\N
19970	4178	3	0	6362	\N
19970	4211	4	0	6363	\N
20054	4178	4	0	6372	\N
20054	4205	5	0	6374	\N
20072	4178	4	0	6376	\N
20072	4205	5	0	6379	\N
19802	4172	4	0	8801	\N
19802	4252	5	0	8802	\N
19805	4172	3	0	8803	\N
19805	4275	4	0	8804	\N
19818	4172	2	0	8807	\N
19818	4191	3	0	8808	\N
19896	4172	4	0	8813	\N
19896	4219	5	0	8815	\N
19936	4172	2	0	8817	\N
19936	4191	3	0	8820	\N
19982	4172	3	0	8825	\N
19982	4940	4	0	8828	\N
20033	4172	3	0	8833	\N
20033	4275	4	0	8834	\N
20091	4172	19	0	8840	\N
20091	5864	20	0	8842	\N
19797	391	3	0	10783	\N
19797	3660	4	0	10784	\N
19932	391	5	0	10802	\N
19932	5462	6	0	10806	\N
19882	132	3	0	11573	\N
19986	132	3	0	11575	\N
19986	1423	4	0	11576	\N
19882	3729	4	0	11578	\N
19828	459	3	0	11990	\N
19828	5782	4	0	11991	\N
20076	300	3	0	12291	\N
20076	3747	4	0	12294	\N
19862	2856	3	0	12918	\N
19862	123	6	0	12925	\N
19862	4862	7	0	12928	\N
19994	123	3	0	12931	\N
20041	233	3	0	13898	\N
20041	3704	4	0	13907	\N
19803	192	10	0	15434	\N
19803	5775	11	0	15435	\N
19973	235	7	0	15914	\N
19973	5822	8	0	15918	\N
20063	115	3	0	16854	\N
20063	3483	4	0	16857	\N
19878	326	3	0	17559	\N
19878	3339	4	0	17560	\N
20016	326	3	0	17562	\N
20016	3339	4	0	17565	\N
19960	3344	4	0	19941	\N
19841	64	4	0	20845	\N
19841	3911	5	0	20846	\N
19881	164	3	0	21319	\N
19881	3385	4	0	21320	\N
20047	5847	0	0	21330	\N
20059	488	3	0	21602	\N
20059	1103	4	0	21604	\N
20013	73	3	0	22683	\N
20013	3040	4	0	22684	\N
19793	1153	2	0	24958	\N
19796	1153	3	0	24959	\N
19796	5770	4	0	24961	\N
20047	5846	0	0	25038	\N
19962	86	3	0	26658	\N
19962	3746	4	0	26659	\N
19934	16	4	0	28822	\N
19934	3546	5	0	28824	\N
19884	96	7	0	29735	\N
19884	3750	8	0	29736	\N
20024	449	4	0	29943	\N
20024	5343	5	0	29944	\N
19853	151	6	0	30850	\N
19853	3588	7	0	30852	\N
19938	4857	4	0	31245	\N
19906	230	10	0	32303	\N
19906	5683	11	0	32307	\N
19903	453	3	0	32911	\N
19903	2838	4	0	32913	\N
20003	14	5	0	39406	\N
20003	5835	6	0	39407	\N
19785	1426	9	0	40267	\N
19861	372	3	0	42717	\N
19861	40	6	0	42734	\N
19861	3034	7	0	42736	\N
19877	40	2	0	42752	\N
19877	282	3	0	42753	\N
19890	40	11	0	42770	\N
19890	5800	12	0	42771	\N
19893	40	4	0	42780	\N
19893	3381	5	0	42782	\N
19939	40	3	0	42819	\N
20043	40	4	0	42820	\N
19939	372	4	0	42822	\N
20043	3381	5	0	42823	\N
19843	51	3	0	43626	\N
19845	51	3	0	43627	\N
20025	51	0	0	43629	\N
20028	51	0	0	43631	\N
19843	3533	4	0	43636	\N
19845	3533	4	0	43637	\N
19961	71	3	0	44940	\N
19961	3770	4	0	44941	\N
19989	75	5	0	45665	\N
20001	75	5	0	45666	\N
20061	75	15	0	45667	\N
19989	4484	6	0	45668	\N
20061	5850	16	0	45669	\N
20001	5833	6	0	45671	\N
20086	75	12	0	45680	\N
20086	5859	13	0	45686	\N
19974	147	7	0	50134	\N
19974	5823	8	0	50141	\N
19874	170	4	0	50713	\N
19874	4680	5	0	50716	\N
20031	285	4	0	53718	\N
20031	3674	5	0	53719	\N
19846	324	7	0	54409	\N
19846	5784	8	0	54412	\N
19847	5785	25	0	54414	\N
19854	324	6	0	54428	\N
19854	5241	7	0	54430	\N
19847	324	26	0	54432	\N
19831	1109	3	0	56266	\N
19831	2961	4	0	56269	\N
20017	841	4	0	57163	\N
20017	3886	5	0	57166	\N
19868	852	20	0	57357	\N
19868	5796	21	0	57362	\N
19849	2351	6	0	59097	\N
19849	5786	7	0	59098	\N
19907	5802	11	0	1020	\N
20038	5845	6	0	1626	\N
19913	262	4	0	3979	\N
19913	5805	5	0	3980	\N
19876	189	4	0	5069	\N
19876	3992	5	0	5070	\N
19921	189	15	0	5093	\N
19921	5809	16	0	5094	\N
19848	4178	3	0	6341	\N
19848	4211	4	0	6343	\N
19865	4178	4	0	6348	\N
19925	4178	3	0	6354	\N
19925	4211	4	0	6356	\N
20019	4205	5	0	6373	\N
19858	4172	4	0	8809	\N
19858	5456	5	0	8810	\N
19859	4172	5	0	8811	\N
19859	4634	6	0	8812	\N
19927	4172	4	0	8814	\N
19927	4219	5	0	8816	\N
19946	4172	3	0	8819	\N
19946	4275	4	0	8822	\N
19963	4172	3	0	8823	\N
20014	4172	3	0	8826	\N
19963	4275	4	0	8829	\N
20064	4172	3	0	8837	\N
20064	4275	4	0	8838	\N
20073	4172	4	0	8839	\N
20073	4219	5	0	8841	\N
19995	132	3	0	11583	\N
19995	3729	4	0	11586	\N
19863	2856	3	0	12919	\N
19863	123	6	0	12926	\N
19839	58	3	0	13600	\N
19839	3665	4	0	13601	\N
19834	173	3	0	14836	\N
19834	3796	4	0	14838	\N
20022	5842	11	0	14845	\N
19866	235	20	0	15892	\N
19866	5794	21	0	15895	\N
20085	115	8	0	16855	\N
20085	5858	9	0	16860	\N
19987	167	5	0	17853	\N
19987	2851	6	0	17858	\N
19965	142	4	0	18726	\N
19965	3950	5	0	18730	\N
19909	290	4	0	19098	\N
19909	5450	5	0	19099	\N
19958	5817	22	0	19925	\N
19958	5818	127	0	19933	\N
19977	64	0	0	20854	\N
19880	164	51	0	21318	\N
20089	145	13	0	21777	\N
19980	264	6	0	23661	\N
19980	5480	7	0	23664	\N
19830	214	3	0	24400	\N
19830	4991	4	0	24404	\N
20052	1885	14	0	25696	\N
20052	224	32	0	25703	\N
20052	5848	33	0	25704	\N
19870	206	3	0	25897	\N
19937	206	2	0	25901	\N
19937	2773	3	0	25903	\N
19885	86	2	0	26652	\N
19915	86	3	0	26654	\N
19885	3321	3	0	26655	\N
19915	3746	4	0	26657	\N
19983	94	3	0	26983	\N
19983	2128	4	0	26988	\N
19832	16	3	0	28811	\N
19832	3634	4	0	28813	\N
19901	16	7	0	28815	\N
19901	4723	8	0	28817	\N
19968	4723	8	0	28827	\N
20077	16	3	0	28834	\N
20077	3634	4	0	28835	\N
20079	16	5	0	28836	\N
20079	4240	6	0	28837	\N
19837	20	3	0	30598	\N
19837	2844	4	0	30599	\N
19833	1731	3	0	30927	\N
19833	5783	4	0	30928	\N
19852	360	6	0	31639	\N
19918	360	7	0	31640	\N
19852	5788	7	0	31641	\N
19904	431	3	0	34846	\N
19904	3933	4	0	34847	\N
20034	2	3	0	35362	\N
20060	2	14	0	35363	\N
20034	3548	4	0	35364	\N
20060	1060	15	0	35365	\N
20055	6	28	0	36372	\N
20057	6	28	0	36373	\N
20055	5849	29	0	36375	\N
20057	5849	29	0	36376	\N
19879	18	7	0	40268	\N
19879	1618	8	0	40269	\N
19943	3621	4	0	40273	\N
20071	40	4	0	42821	\N
20071	3381	5	0	42824	\N
20081	40	7	0	42831	\N
20081	5853	8	0	42832	\N
20029	51	0	0	43632	\N
19914	56	4	0	44371	\N
19914	1978	5	0	44375	\N
20067	5851	79	0	44376	\N
20067	56	96	0	44381	\N
20067	3543	97	0	44382	\N
20090	71	4	0	44943	\N
20090	5863	5	0	44946	\N
20098	159	2	0	45670	\N
20092	75	19	0	45681	\N
20098	75	8	0	45684	\N
20098	5870	9	0	45685	\N
20092	5865	20	0	45687	\N
20049	79	3	0	46125	\N
20049	3652	4	0	46127	\N
19945	5812	7	0	53701	\N
19945	285	8	0	53709	\N
20069	285	4	0	53722	\N
20069	3674	5	0	53723	\N
20117	324	7	0	54429	\N
20117	2981	8	0	54431	\N
20009	451	11	0	55461	\N
20009	5840	12	0	55462	\N
20045	451	4	0	55483	\N
20045	3666	5	0	55487	\N
19972	595	7	0	55797	\N
19972	5821	8	0	55800	\N
20078	1021	3	0	56510	\N
20078	5852	4	0	56511	\N
19951	793	3	0	56812	\N
20065	793	2	0	56813	\N
20066	793	3	0	56814	\N
20068	793	2	0	56815	\N
20111	793	7	0	56816	\N
20065	4363	3	0	56817	\N
20068	4363	3	0	56818	\N
19951	2644	4	0	56819	\N
20066	2644	4	0	56820	\N
20111	5878	8	0	56821	\N
20007	852	4	0	57359	\N
20007	5838	5	0	57363	\N
19991	908	12	0	57759	\N
19991	5826	13	0	57762	\N
20012	908	3	0	57765	\N
20012	3591	4	0	57766	\N
20083	2171	10	1	57983	\N
20023	1470	9	0	58366	\N
20023	5139	10	0	58369	\N
20083	1470	8	0	58379	\N
20083	5856	10	0	58381	\N
20101	2636	11	0	58897	\N
20101	5873	12	0	58898	\N
20058	3611	4	0	1018	\N
20087	5860	40	0	1338	\N
20083	5855	9	0	1643	\N
19887	228	3	0	2820	\N
19887	3186	4	0	2822	\N
20083	1970	9	1	5143	\N
19865	5793	5	1	6349	\N
19905	4178	10	0	6352	\N
19905	4665	11	0	6358	\N
19993	4178	3	0	6365	\N
19993	4211	4	0	6368	\N
20004	4178	5	0	6370	\N
20004	5828	6	0	6375	\N
20075	4211	4	0	6378	\N
20082	5854	6	0	6380	\N
20080	4178	7	0	6381	\N
20082	4178	8	0	6382	\N
20082	4460	9	0	6383	\N
20080	5210	8	0	6384	\N
20102	4178	11	0	6385	\N
20104	4178	9	0	6386	\N
20102	5874	12	0	6388	\N
20118	4178	7	0	6389	\N
20118	4396	8	0	6390	\N
19941	4172	3	0	8818	\N
19975	4172	7	0	8824	\N
19975	4614	8	0	8832	\N
20105	4172	9	0	8843	\N
20105	5876	10	0	8846	\N
20051	391	4	0	10803	\N
20051	3913	5	0	10805	\N
20062	391	3	0	10811	\N
20062	3660	4	0	10813	\N
19883	132	2	0	11574	\N
19883	2756	3	0	11577	\N
19929	108	1	0	11866	\N
19929	3022	2	0	11867	\N
19935	2765	3	0	12633	\N
19959	528	3	0	12642	\N
19959	4262	4	0	12643	\N
20036	123	3	0	12932	\N
20036	2856	4	0	12937	\N
19898	3979	4	0	15151	\N
19898	92	5	0	15161	\N
19969	192	3	0	15448	\N
19969	3790	4	0	15450	\N
19912	235	6	0	15908	\N
19912	5804	7	0	15909	\N
19924	167	1	0	17852	\N
19981	30	6	0	18153	\N
19981	2931	7	0	18154	\N
19998	30	5	0	18155	\N
19998	5829	6	0	18158	\N
19957	62	4	0	19929	\N
19957	4059	5	0	19931	\N
20093	62	17	0	19939	\N
20093	5866	18	0	19942	\N
19880	5799	52	0	21321	\N
19964	5819	10	0	21322	\N
19964	164	11	0	21329	\N
20088	67	13	0	22259	\N
20037	336	5	0	22938	\N
20037	5844	6	0	22939	\N
19888	149	3	0	23305	\N
19888	4189	4	0	23306	\N
19933	69	4	0	24912	\N
19933	4041	5	0	24913	\N
20099	69	12	0	24914	\N
20099	5871	13	0	24915	\N
20053	3746	4	0	26661	\N
19895	16	4	0	28814	\N
19895	3546	5	0	28816	\N
20040	16	3	0	28832	\N
20123	320	8	0	29234	\N
19922	449	4	0	29938	\N
19922	5343	5	0	29939	\N
19931	202	5	0	31242	\N
19931	5374	6	0	31246	\N
20000	5831	78	0	32906	\N
20000	453	113	0	32915	\N
20000	5832	114	0	32916	\N
20002	2	5	0	35346	\N
20002	5834	6	0	35348	\N
19979	4	9	0	36111	\N
19979	5825	10	0	36115	\N
19996	4823	4	0	36374	\N
20056	6	3	0	36381	\N
20056	4823	4	0	36382	\N
19990	14	3	0	39398	\N
19990	4272	4	0	39399	\N
20074	18	4	0	40271	\N
20074	2302	5	0	40275	\N
20140	40	3	0	42839	\N
20140	372	4	0	42844	\N
20193	56	5	0	44378	\N
20193	3551	6	0	44379	\N
20097	401	2	0	44942	\N
20097	71	8	0	44944	\N
20097	5869	9	0	44945	\N
20293	75	7	0	45706	\N
20293	2859	8	0	45714	\N
20215	79	7	0	46177	\N
20215	5706	8	0	46181	\N
20299	79	3	0	46252	\N
20299	3652	4	0	46253	\N
20198	113	4	0	48448	\N
20198	5924	5	0	48451	\N
20180	121	3	0	49115	\N
20180	4471	4	0	49117	\N
20148	125	3	0	49132	\N
20148	4170	4	0	49133	\N
20261	200	4	0	51452	\N
20261	4683	5	0	51456	\N
20223	273	10	0	53142	\N
20223	5932	11	0	53143	\N
20153	285	6	0	53362	\N
20153	3903	7	0	53363	\N
20312	316	3	0	54100	\N
20312	4249	4	0	54104	\N
20116	324	5	0	54410	\N
20116	700	6	0	54413	\N
20115	5882	0	0	54452	\N
20126	852	11	0	57382	\N
20126	5891	12	0	57387	\N
20224	1470	3	0	58387	\N
20224	3838	4	0	58391	\N
20115	5881	0	0	58448	\N
20103	2636	9	0	58899	\N
20103	5875	10	0	58902	\N
20249	2351	3	0	59101	\N
20249	2845	4	0	59102	\N
20200	5885	3	0	60465	\N
20200	5926	4	0	60467	\N
20110	3028	3	0	461	\N
20107	117	4	0	2194	\N
20107	4169	5	0	2196	\N
20314	110	3	0	2382	\N
20314	2995	4	0	2383	\N
20275	367	7	0	3528	\N
20275	4792	8	0	3529	\N
20196	262	6	0	3990	\N
20196	2828	7	0	3991	\N
20130	5892	8	0	4415	\N
20130	365	7	0	4713	\N
20258	365	7	0	4720	\N
20258	5248	8	0	4721	\N
20119	4178	3	0	6391	\N
20119	4211	4	0	6392	\N
20122	4178	8	0	6393	\N
20122	5883	9	0	6394	\N
20135	4178	10	0	6395	\N
20137	4178	2	0	6396	\N
20137	4247	3	0	6397	\N
20135	5897	11	0	6398	\N
20139	4178	3	0	6399	\N
20139	4211	4	0	6401	\N
20143	4178	6	0	6403	\N
20143	5900	7	0	6404	\N
20187	4211	4	0	6410	\N
20247	4237	8	0	6425	\N
20247	4178	10	0	6426	\N
20247	4460	11	0	6427	\N
20280	4178	4	0	6432	\N
20280	4205	5	0	6433	\N
20108	4172	4	0	8844	\N
20108	4252	5	0	8845	\N
20175	4172	5	0	8857	\N
20175	4634	6	0	8858	\N
20207	4172	3	0	8863	\N
20207	4275	4	0	8864	\N
20241	4172	4	0	8869	\N
20241	4252	5	0	8871	\N
20218	4614	8	0	8872	\N
20253	4172	13	0	8875	\N
20253	5454	14	0	8882	\N
20301	4172	3	0	8885	\N
20301	4275	4	0	8886	\N
20322	4172	4	0	8887	\N
20270	391	5	0	10819	\N
20270	3558	6	0	10820	\N
20112	132	2	0	11584	\N
20112	2756	3	0	11585	\N
20132	5894	7	0	11874	\N
20290	300	7	0	12293	\N
20290	5054	8	0	12296	\N
20235	528	4	0	12436	\N
20235	5689	5	0	12441	\N
20144	123	5	0	12934	\N
20144	5901	6	0	12940	\N
20172	58	2	0	13610	\N
20172	3228	3	0	13611	\N
20095	38	17	0	16564	\N
20095	5868	18	0	16570	\N
20120	212	7	0	17261	\N
20210	326	3	0	17563	\N
20210	3339	4	0	17566	\N
20113	290	4	0	19115	\N
20113	5879	5	0	19116	\N
20167	62	6	0	19946	\N
20167	4781	7	0	19947	\N
20159	198	15	0	20250	\N
20159	2324	16	0	20251	\N
20238	64	3	0	20864	\N
20238	4217	4	0	20865	\N
20089	5862	14	0	21778	\N
20178	264	4	0	23376	\N
20309	82	3	0	23906	\N
20309	4505	4	0	23907	\N
20205	214	3	0	24401	\N
20205	3496	4	0	24405	\N
20164	69	13	0	24916	\N
20164	5912	14	0	24917	\N
20246	224	7	0	25394	\N
20246	5003	8	0	25396	\N
20141	94	3	0	26984	\N
20141	2864	4	0	26993	\N
20255	42	3	0	27721	\N
20255	3645	4	0	27728	\N
20133	5895	7	0	28840	\N
20227	20	6	0	30602	\N
20227	5933	7	0	30605	\N
20125	5887	8	0	30904	\N
20229	202	4	0	30959	\N
20229	3673	5	0	30960	\N
20134	33	10	0	31667	\N
20134	5896	11	0	31675	\N
20156	2	3	0	35382	\N
20156	3548	4	0	35384	\N
20284	298	3	0	35392	\N
20284	2	7	0	35408	\N
20317	6	4	0	36391	\N
20317	3487	5	0	36393	\N
20319	5954	11	0	36394	\N
20319	6	13	0	36407	\N
20319	2261	14	0	36408	\N
20184	18	3	0	40272	\N
20184	3621	4	0	40274	\N
20257	18	3	0	40277	\N
20257	3621	4	0	40279	\N
20166	40	6	0	42840	\N
20306	40	7	0	42843	\N
20166	4718	7	0	42847	\N
20306	4718	8	0	42848	\N
20157	51	6	0	43447	\N
20157	5906	7	0	43453	\N
20252	56	7	0	44387	\N
20252	4791	8	0	44388	\N
20325	56	4	0	44393	\N
20325	3127	5	0	44396	\N
20109	75	2	0	45682	\N
20109	284	3	0	45683	\N
20121	75	7	0	45700	\N
20121	3439	8	0	45701	\N
20158	79	6	0	46126	\N
20158	4253	7	0	46128	\N
20163	79	13	0	46175	\N
20163	5911	14	0	46182	\N
20336	102	6	0	48048	\N
20336	5086	7	0	48055	\N
20234	156	4	0	50329	\N
20234	5935	5	0	50332	\N
20150	170	3	0	50714	\N
20150	4148	4	0	50715	\N
20387	186	3	0	51144	\N
20387	4294	4	0	51148	\N
20147	5904	68	0	52238	\N
20147	242	99	0	52259	\N
20147	1135	100	0	52260	\N
20363	435	6	0	55113	\N
20363	5969	7	0	55116	\N
20396	597	3	0	56051	\N
20396	3656	4	0	56058	\N
20219	1109	7	0	56267	\N
20219	4145	8	0	56270	\N
20129	793	7	0	56826	\N
20129	4590	8	0	56828	\N
20338	841	6	0	57164	\N
20338	5958	7	0	57167	\N
20127	852	11	0	57383	\N
20127	5891	12	0	57388	\N
20174	908	5	0	57772	\N
20174	5915	6	0	57773	\N
20245	1952	6	0	58530	\N
20245	5939	7	0	58531	\N
20168	2351	9	0	59099	\N
20125	5888	9	1	60180	\N
20409	4787	6	0	60268	\N
20409	5982	7	0	60270	\N
20124	5886	7	0	60464	\N
20358	5965	7	0	643	\N
20341	5959	39	0	1348	\N
20265	117	7	0	2195	\N
20265	5276	8	0	2197	\N
20420	1636	6	0	3078	\N
20420	5988	7	0	3081	\N
20371	367	17	0	3532	\N
20371	4083	18	0	3539	\N
20152	4178	4	0	6405	\N
20152	4205	5	0	6406	\N
20169	4178	9	0	6407	\N
20169	5897	10	0	6412	\N
20214	4178	3	0	6413	\N
20240	4178	4	0	6421	\N
20240	4331	5	0	6424	\N
20295	4178	3	0	6437	\N
20295	4211	4	0	6438	\N
20298	4178	3	0	6439	\N
20311	4178	3	0	6440	\N
20298	4211	4	0	6441	\N
20311	4211	4	0	6442	\N
20400	4178	3	0	6455	\N
20400	4211	4	0	6458	\N
20422	4178	3	0	6460	\N
20422	4211	4	0	6461	\N
20161	4172	9	0	8849	\N
20114	5880	8	0	8852	\N
20161	5908	10	0	8853	\N
20202	4172	3	0	8861	\N
20202	4275	4	0	8862	\N
20222	4172	10	0	8868	\N
20242	4172	7	0	8870	\N
20222	4663	11	0	8873	\N
20242	5880	8	0	8874	\N
20330	4172	4	0	8891	\N
20330	4219	5	0	8893	\N
20346	4172	3	0	8895	\N
20355	4201	1	0	8897	\N
20355	4172	4	0	8899	\N
20355	5961	5	0	8900	\N
20365	4172	3	0	8902	\N
20365	4275	4	0	8903	\N
20413	183	16	0	10065	\N
20413	5984	17	0	10066	\N
20189	132	3	0	11098	\N
20189	3729	4	0	11099	\N
20360	132	3	0	11113	\N
20360	3729	4	0	11114	\N
20177	528	10	0	12389	\N
20204	528	3	0	12403	\N
20204	4262	4	0	12405	\N
20212	528	6	0	12417	\N
20212	4824	7	0	12418	\N
20100	528	12	0	12647	\N
20100	5872	13	0	12648	\N
20106	123	9	0	12933	\N
20106	5877	10	0	12939	\N
20289	233	7	0	13899	\N
20289	5948	8	0	13909	\N
20171	192	4	0	15449	\N
20171	3895	5	0	15451	\N
20209	3343	4	0	15917	\N
20192	167	4	0	17854	\N
20192	4048	5	0	17856	\N
20355	5963	6	0	17857	\N
20355	5962	5	1	18374	\N
20094	62	17	0	19940	\N
20094	5867	18	0	19943	\N
20260	62	3	0	19950	\N
20260	3344	4	0	19952	\N
20195	198	6	0	20257	\N
20195	5923	7	0	20259	\N
20292	214	7	0	24402	\N
20149	411	3	0	25379	\N
20149	3596	4	0	25382	\N
20138	224	3	0	25711	\N
20138	3603	4	0	25712	\N
20237	90	3	0	26222	\N
20237	4074	4	0	26223	\N
20226	42	3	0	27720	\N
20226	3645	4	0	27727	\N
20321	42	6	0	27733	\N
20321	1090	7	0	27734	\N
20343	16	5	0	28844	\N
20343	4240	6	0	28845	\N
20096	320	4	0	29236	\N
20096	3058	5	0	29237	\N
20155	54	3	0	30269	\N
20155	3041	4	0	30270	\N
20125	5890	10	1	30906	\N
20197	2	4	0	35383	\N
20197	2830	5	0	35385	\N
20279	2	4	0	35405	\N
20368	2	6	0	35406	\N
20279	3510	5	0	35407	\N
20368	4825	7	0	35410	\N
20316	6	2	0	36390	\N
20208	40	3	0	42841	\N
20208	372	4	0	42845	\N
20351	40	3	0	42872	\N
20372	40	4	0	42873	\N
20351	372	4	0	42874	\N
20372	2796	5	0	42876	\N
20162	5910	126	1	44015	\N
20162	5909	109	0	44383	\N
20239	56	4	0	44384	\N
20239	3556	5	0	44385	\N
20162	56	125	0	44386	\N
20382	56	3	0	44394	\N
20382	4109	4	0	44395	\N
20176	75	5	0	45705	\N
20176	4034	6	0	45712	\N
20272	88	5	0	47041	\N
20272	5942	6	0	47051	\N
20181	121	99	0	49116	\N
20181	5916	100	0	49118	\N
20395	147	3	0	50104	\N
20395	3657	4	0	50111	\N
20231	156	3	0	50328	\N
20231	4594	4	0	50331	\N
20251	210	7	0	51720	\N
20251	5940	8	0	51727	\N
20146	242	5	0	52254	\N
20146	5903	6	0	52258	\N
20160	273	9	0	53138	\N
20160	5907	10	0	53139	\N
20186	285	10	0	53369	\N
20186	5921	11	0	53370	\N
20264	285	7	0	53375	\N
20264	5812	8	0	53380	\N
20217	316	5	0	54096	\N
20217	5929	6	0	54097	\N
20345	1021	3	0	56525	\N
20345	4551	4	0	56529	\N
20131	793	7	0	56827	\N
20131	4590	8	0	56829	\N
20389	2636	9	0	58900	\N
20389	5079	10	0	58901	\N
20168	5914	10	0	59100	\N
20288	4088	7	0	59880	\N
20288	5947	8	0	59889	\N
20399	5975	89	0	60410	\N
20244	5885	8	0	60466	\N
20244	5938	9	0	60468	\N
20294	5885	3	0	60469	\N
20294	5926	4	0	60471	\N
20278	288	126	0	111	\N
20324	266	4	0	1339	\N
20324	4100	5	0	1341	\N
20162	5238	126	0	1385	\N
20375	1636	3	0	3077	\N
20375	5514	4	0	3080	\N
20128	365	7	0	4712	\N
20199	365	8	0	4714	\N
20128	5248	8	0	4715	\N
20199	5925	9	0	4716	\N
20142	4178	5	0	6400	\N
20142	5899	6	0	6402	\N
20315	4178	4	0	6443	\N
20370	4178	17	0	6451	\N
20370	4218	18	0	6452	\N
20145	4172	5	0	8848	\N
20170	4172	6	0	8850	\N
20170	4197	7	0	8851	\N
20145	5902	6	0	8854	\N
20173	4172	3	0	8855	\N
20173	4275	4	0	8856	\N
20183	4172	10	0	8859	\N
20183	4663	11	0	8860	\N
20267	4172	3	0	8876	\N
20277	4172	6	0	8877	\N
20277	4197	7	0	8880	\N
20297	4172	7	0	8883	\N
20297	4614	8	0	8884	\N
20335	4172	6	0	8892	\N
20335	4197	7	0	8894	\N
20342	391	5	0	10827	\N
20357	391	3	0	10828	\N
20357	3660	4	0	10829	\N
20342	5462	6	0	10830	\N
20384	391	3	0	10839	\N
20384	3660	4	0	10840	\N
20379	132	6	0	11120	\N
20151	132	3	0	11587	\N
20151	3729	4	0	11588	\N
20291	5949	7	0	12321	\N
20236	5936	37	0	12419	\N
20236	528	54	0	12444	\N
20236	5937	55	0	12445	\N
20291	5950	7	0	13892	\N
20291	5948	8	0	13893	\N
20233	173	4	0	14846	\N
20233	3614	5	0	14848	\N
20328	92	5	0	15158	\N
20328	5955	6	0	15163	\N
20274	5822	8	0	15919	\N
20377	44	3	0	16193	\N
20377	3631	4	0	16196	\N
20154	1656	3	0	16946	\N
20154	5905	4	0	16947	\N
20386	167	3	0	17869	\N
20386	4028	4	0	17870	\N
20399	973	90	0	18373	\N
20263	62	4	0	19951	\N
20263	4059	5	0	19953	\N
20332	62	3	0	19960	\N
20332	3344	4	0	19961	\N
20269	4217	4	0	20879	\N
20221	164	10	0	21333	\N
20362	164	6	0	21334	\N
20362	5968	7	0	21335	\N
20221	5931	11	0	21336	\N
20162	1075	127	0	21772	\N
20305	67	3	0	22266	\N
20305	3749	4	0	22267	\N
20283	1316	6	0	22335	\N
20283	5945	7	0	22338	\N
20320	225	1	0	25398	\N
20320	224	13	0	25401	\N
20256	42	2	0	27722	\N
20256	3310	3	0	27724	\N
20136	16	10	0	28839	\N
20136	5898	11	0	28841	\N
20399	5976	89	1	29200	\N
20123	5884	9	0	29239	\N
20191	54	9	0	30273	\N
20191	5922	10	0	30274	\N
20194	230	6	0	32310	\N
20194	4549	7	0	32313	\N
20165	453	26	0	32623	\N
20165	5913	27	0	32624	\N
20348	3837	4	0	36129	\N
20318	6	8	0	36405	\N
20318	5953	9	0	36406	\N
20367	14	3	0	38962	\N
20367	1786	4	0	38963	\N
20286	609	3	0	40276	\N
20300	18	7	0	40278	\N
20286	18	7	0	40280	\N
20286	5946	8	0	40281	\N
20300	1618	8	0	40282	\N
20303	18	3	0	40283	\N
20308	18	3	0	40284	\N
20308	3621	4	0	40286	\N
20262	40	4	0	42842	\N
20262	3381	5	0	42846	\N
20326	40	4	0	42857	\N
20326	3381	5	0	42858	\N
20340	40	6	0	42871	\N
20340	4717	7	0	42875	\N
20182	56	43	0	44389	\N
20182	5917	44	0	44390	\N
20310	56	7	0	44391	\N
20310	4791	8	0	44392	\N
20383	56	2	0	44397	\N
20383	2795	3	0	44398	\N
20361	71	4	0	44947	\N
20361	5967	5	0	44948	\N
20353	75	3	0	45707	\N
20353	3855	4	0	45711	\N
20203	79	3	0	46176	\N
20250	79	3	0	46178	\N
20203	3652	4	0	46179	\N
20250	3652	4	0	46180	\N
20271	88	3	0	47040	\N
20271	3655	4	0	47048	\N
20254	100	13	0	47473	\N
20254	5941	14	0	47475	\N
20266	113	3	0	48449	\N
20266	3620	4	0	48450	\N
20392	125	9	0	49140	\N
20392	5974	10	0	49145	\N
20220	200	10	0	51699	\N
20220	5930	11	0	51700	\N
20388	1109	0	0	56268	\N
20369	1021	16	0	56526	\N
20369	5970	17	0	56531	\N
20334	852	7	0	57384	\N
20334	3799	8	0	57385	\N
20391	2351	9	0	59103	\N
20391	5973	10	0	59104	\N
20313	5611	2	0	59798	\N
20313	5952	3	0	59799	\N
20185	5919	126	0	60240	\N
20380	5885	3	0	60470	\N
20380	5926	4	0	60472	\N
20304	4043	5	0	468	\N
20282	3712	7	0	1024	\N
20394	424	1	0	1025	\N
20397	424	3	0	1026	\N
20394	425	2	0	1028	\N
20397	3611	4	0	1029	\N
20339	266	6	0	1340	\N
20339	1912	7	0	1342	\N
20248	4872	8	0	2836	\N
20248	228	10	0	2855	\N
20248	1432	11	0	2856	\N
20185	5920	126	1	4114	\N
20185	5918	35	0	4142	\N
20268	365	3	0	4722	\N
20268	3839	4	0	4724	\N
20190	4178	4	0	6409	\N
20190	4205	5	0	6411	\N
20216	4178	7	0	6415	\N
20225	4178	3	0	6416	\N
20225	4211	4	0	6417	\N
20216	4396	8	0	6418	\N
20228	4178	6	0	6419	\N
20228	4250	7	0	6420	\N
20243	4178	3	0	6422	\N
20243	4211	4	0	6423	\N
20259	4211	4	0	6429	\N
20285	4441	3	0	6430	\N
20273	4178	7	0	6431	\N
20285	4178	7	0	6434	\N
20285	4941	8	0	6435	\N
20273	4396	8	0	6436	\N
20323	4178	4	0	6444	\N
20344	4178	6	0	6445	\N
20323	4205	5	0	6447	\N
20344	4250	7	0	6448	\N
20350	4178	3	0	6449	\N
20350	4211	4	0	6450	\N
20381	4178	3	0	6454	\N
20374	4211	4	0	6456	\N
20381	4211	4	0	6457	\N
20213	4172	8	0	8865	\N
20213	5928	9	0	8866	\N
20296	4172	9	0	8878	\N
20296	4977	10	0	8881	\N
20327	4172	5	0	8888	\N
20322	4219	5	0	8889	\N
20327	4415	6	0	8890	\N
20349	4172	3	0	8898	\N
20349	4275	4	0	8901	\N
20373	4275	4	0	8905	\N
20201	391	3	0	10812	\N
20201	3660	4	0	10814	\N
20359	5966	46	0	11100	\N
20359	132	47	0	11115	\N
20378	132	58	0	11122	\N
20378	5971	59	0	11123	\N
20287	300	5	0	12292	\N
20287	5389	6	0	12295	\N
20179	528	4	0	12395	\N
20179	5689	5	0	12396	\N
20206	528	75	0	12404	\N
20211	528	3	0	12415	\N
20211	4262	4	0	12416	\N
20333	123	3	0	12935	\N
20333	2856	4	0	12938	\N
20366	77	3	0	13282	\N
20366	1877	4	0	13284	\N
20347	173	9	0	14847	\N
20347	5960	10	0	14849	\N
20188	192	3	0	15454	\N
20188	3790	4	0	15462	\N
20232	115	6	0	16856	\N
20232	5934	7	0	16859	\N
20385	5972	29	0	17871	\N
20354	62	2	0	19962	\N
20354	2191	3	0	19963	\N
20307	64	3	0	20888	\N
20307	4217	4	0	20891	\N
20302	488	3	0	21603	\N
20302	1103	4	0	21605	\N
20329	1075	127	1	21776	\N
20356	153	1	0	21779	\N
20185	1075	127	0	21782	\N
20356	145	4	0	21784	\N
20356	5964	5	0	21785	\N
20276	4257	7	0	22361	\N
20405	82	12	0	23689	\N
20281	244	1	0	27412	\N
20281	2960	2	0	27413	\N
20331	16	4	0	28842	\N
20331	3546	5	0	28843	\N
20352	16	3	0	28846	\N
20364	16	3	0	28847	\N
20352	3634	4	0	28848	\N
20364	3634	4	0	28849	\N
20329	5956	90	0	29213	\N
20329	320	126	0	29240	\N
20390	54	3	0	30283	\N
20390	3041	4	0	30284	\N
20337	360	4	0	31273	\N
20337	3513	5	0	31274	\N
20230	23	3	0	40911	\N
20230	3497	4	0	40912	\N
20376	27	3	0	41212	\N
20376	4636	4	0	41213	\N
20613	40	3	0	42897	\N
20613	372	4	0	42904	\N
20513	79	3	0	46411	\N
20513	3652	4	0	46416	\N
20445	88	2	0	47042	\N
20445	2799	3	0	47046	\N
20580	102	3	0	48049	\N
20580	3597	4	0	48053	\N
20404	113	12	0	48456	\N
20440	113	3	0	48457	\N
20620	113	23	0	48459	\N
20440	3620	4	0	48461	\N
20404	5979	13	0	48462	\N
20620	6060	24	0	48463	\N
20571	121	6	0	48810	\N
20571	6038	7	0	48824	\N
20401	125	3	0	49141	\N
20401	4170	4	0	49143	\N
20546	135	3	0	49414	\N
20546	3630	4	0	49415	\N
20547	137	3	0	49661	\N
20547	3633	4	0	49670	\N
20470	156	3	0	50341	\N
20470	4594	4	0	50342	\N
20454	200	6	0	51453	\N
20454	4701	7	0	51457	\N
20528	210	4	0	51722	\N
20528	4413	5	0	51725	\N
20398	260	2	0	52463	\N
20398	3184	3	0	52464	\N
20538	285	6	0	53377	\N
20538	3903	7	0	53379	\N
20556	285	4	0	53387	\N
20556	3674	5	0	53397	\N
20393	595	3	0	55805	\N
20499	595	4	0	55806	\N
20393	3654	4	0	55807	\N
20499	3878	5	0	55808	\N
20428	2872	2	0	57386	\N
20428	852	4	0	57397	\N
20428	2945	5	0	57398	\N
20424	3368	2	0	58383	\N
20424	1470	4	0	58389	\N
20424	5990	5	0	58392	\N
20552	1470	3	0	58395	\N
20552	3838	4	0	58397	\N
20473	2782	4	0	59423	\N
20473	3872	5	0	59424	\N
20586	2782	10	0	59427	\N
20586	6051	11	0	59428	\N
20517	6012	11	0	59527	\N
20517	3625	23	0	59569	\N
20517	4359	24	0	59570	\N
20408	4787	5	0	60267	\N
20408	5981	6	0	60269	\N
20452	5885	6	0	60473	\N
20627	5885	5	0	60474	\N
20627	6065	6	0	60475	\N
20452	5997	7	0	60476	\N
20443	5996	3	0	1092	\N
20506	266	0	0	1346	\N
20576	117	4	0	2030	\N
20576	6043	5	0	2032	\N
20595	1722	6	0	2279	\N
20595	6054	7	0	2280	\N
20626	110	6	0	2404	\N
20626	4135	7	0	2406	\N
20562	1636	2	0	3095	\N
20562	6032	3	0	3097	\N
20518	367	4	0	3533	\N
20518	5472	5	0	3537	\N
20567	262	8	0	3667	\N
20456	365	3	0	4723	\N
20456	3839	4	0	4725	\N
20480	365	0	0	4726	\N
20416	4178	5	0	6459	\N
20416	4202	6	0	6462	\N
20446	4178	4	0	6465	\N
20446	4205	5	0	6466	\N
20539	4172	3	0	8916	\N
20539	4275	4	0	8917	\N
20591	4172	3	0	8926	\N
20591	4275	4	0	8928	\N
20406	391	3	0	10845	\N
20426	1381	2	0	10847	\N
20448	391	3	0	10852	\N
20426	391	4	0	10853	\N
20426	1420	5	0	10854	\N
20448	3660	4	0	10855	\N
20478	6000	66	0	11124	\N
20478	132	126	0	11133	\N
20478	6001	127	0	11134	\N
20625	132	7	0	11163	\N
20625	6064	8	0	11164	\N
20402	108	31	0	11885	\N
20403	108	3	0	11886	\N
20402	5978	32	0	11888	\N
20551	77	7	0	13283	\N
20551	6022	8	0	13285	\N
20484	402	5	0	14262	\N
20484	4487	6	0	14268	\N
20601	92	3	0	15174	\N
20601	4410	4	0	15175	\N
20421	44	6	0	16194	\N
20421	5989	7	0	16197	\N
20415	38	10	0	16239	\N
20489	38	4	0	16241	\N
20489	6006	5	0	16244	\N
20435	927	10	0	19167	\N
20437	927	11	0	19168	\N
20435	5994	11	0	19174	\N
20437	5995	12	0	19175	\N
20450	164	3	0	20965	\N
20450	3385	4	0	20967	\N
20481	149	2	0	23313	\N
20481	1379	3	0	23314	\N
20596	6055	85	0	23315	\N
20596	149	126	0	23321	\N
20596	1664	127	0	23322	\N
20590	224	3	0	25418	\N
20606	224	2	0	25420	\N
20602	3150	3	0	25424	\N
20606	3150	3	0	25425	\N
20590	3603	4	0	25426	\N
20459	90	3	0	26228	\N
20459	4074	4	0	26237	\N
20465	42	3	0	27740	\N
20465	3645	4	0	27742	\N
20399	320	126	0	29261	\N
20399	5977	127	0	29262	\N
20432	96	6	0	29737	\N
20432	3698	7	0	29740	\N
20412	4055	7	0	29761	\N
20533	151	5	0	30855	\N
20533	6018	6	0	30858	\N
20410	33	6	0	31668	\N
20410	5983	7	0	31673	\N
20522	322	4	0	32548	\N
20522	5447	5	0	32549	\N
20509	453	2	0	32633	\N
20509	3133	3	0	32634	\N
20492	6	9	0	36218	\N
20492	6007	10	0	36221	\N
20418	18	5	0	40287	\N
20423	23	3	0	40917	\N
20423	3497	4	0	40918	\N
20628	27	12	0	41283	\N
20628	6066	13	0	41284	\N
20458	40	3	0	42889	\N
20458	372	4	0	42890	\N
20615	40	3	0	42898	\N
20615	372	4	0	42905	\N
20411	56	6	0	44399	\N
20469	56	4	0	44400	\N
20469	3127	5	0	44402	\N
20411	3398	7	0	44403	\N
20617	71	5	0	44949	\N
20617	4288	6	0	44950	\N
20407	79	6	0	46304	\N
20407	4253	7	0	46305	\N
20433	79	6	0	46361	\N
20433	5992	7	0	46364	\N
20457	79	3	0	46409	\N
20457	3652	4	0	46415	\N
20467	5999	100	0	47476	\N
20598	100	3	0	47497	\N
20598	3836	4	0	47498	\N
20467	100	126	0	47499	\N
20467	4826	127	0	47500	\N
20572	121	8	0	48811	\N
20572	6039	9	0	48828	\N
20417	125	5	0	49142	\N
20417	5987	6	0	49144	\N
20490	170	3	0	50721	\N
20496	170	2	0	50722	\N
20496	1380	3	0	50724	\N
20490	4148	4	0	50725	\N
20623	6063	27	0	51095	\N
20553	181	3	0	51104	\N
20553	4184	4	0	51107	\N
20623	181	80	0	51110	\N
20623	3833	81	0	51111	\N
20683	6083	73	0	51112	\N
20683	181	126	0	51117	\N
20683	3833	127	0	51118	\N
20540	210	5	0	51723	\N
20540	4413	6	0	51726	\N
20557	285	3	0	53388	\N
20557	4496	4	0	53396	\N
20430	324	8	0	54444	\N
20609	324	6	0	54445	\N
20609	5241	7	0	54447	\N
20430	5427	9	0	54448	\N
20501	597	4	0	56085	\N
20501	3733	5	0	56096	\N
20640	1021	3	0	56528	\N
20640	4551	4	0	56530	\N
20651	6075	74	0	57399	\N
20651	852	126	0	57418	\N
20651	6076	127	0	57419	\N
20679	4678	3	0	58466	\N
20679	4679	4	0	58467	\N
20511	2351	2	0	59106	\N
20511	4711	3	0	59107	\N
20667	3625	13	0	59577	\N
20667	6079	14	0	59596	\N
20661	4088	3	0	59881	\N
20661	4506	4	0	59887	\N
20541	4233	2	0	59952	\N
20541	5577	3	0	59953	\N
20564	6033	0	0	60181	\N
20646	6073	126	0	60401	\N
20578	6045	4	0	60611	\N
20502	3611	4	0	1030	\N
20646	2132	124	0	1692	\N
20534	117	5	0	2029	\N
20534	6019	6	0	2031	\N
20646	2583	126	1	2336	\N
20519	110	6	0	2388	\N
20583	110	7	0	2391	\N
20519	3917	7	0	2394	\N
20583	4758	8	0	2396	\N
20439	4178	3	0	6463	\N
20439	4211	4	0	6464	\N
20453	4178	6	0	6467	\N
20453	4250	7	0	6468	\N
20529	4178	4	0	6471	\N
20462	4211	4	0	6472	\N
20529	4429	5	0	6473	\N
20588	4178	4	0	6477	\N
20588	4331	5	0	6478	\N
20610	4178	10	0	6480	\N
20610	4665	11	0	6481	\N
20673	4178	3	0	6489	\N
20673	4211	4	0	6490	\N
20419	4172	6	0	8906	\N
20419	4197	7	0	8909	\N
20530	4172	3	0	8913	\N
20599	4172	4	0	8927	\N
20599	4219	5	0	8929	\N
20634	4172	3	0	8935	\N
20634	4275	4	0	8936	\N
20656	4172	4	0	8940	\N
20656	4219	5	0	8944	\N
20477	132	4	0	11131	\N
20477	3293	5	0	11132	\N
20646	4912	124	1	11630	\N
20564	6034	0	0	11897	\N
20616	300	5	0	12297	\N
20616	6057	6	0	12298	\N
20523	5689	5	0	12442	\N
20593	92	6	0	15159	\N
20593	6052	7	0	15165	\N
20563	44	3	0	15952	\N
20563	3631	4	0	15959	\N
20668	212	3	0	17008	\N
20668	3639	4	0	17009	\N
20646	6072	38	0	17567	\N
20646	326	123	0	17575	\N
20646	6074	127	0	17576	\N
20558	167	14	0	17879	\N
20558	6023	15	0	17880	\N
20461	5998	4	0	18408	\N
20646	3108	125	1	18795	\N
20471	145	3	0	21783	\N
20471	4908	4	0	21786	\N
20568	145	8	0	21790	\N
20568	4934	9	0	21799	\N
20405	5980	13	0	23695	\N
20493	224	4	0	25409	\N
20493	3806	5	0	25411	\N
20460	90	2	0	26229	\N
20460	3442	3	0	26235	\N
20464	42	2	0	27739	\N
20466	16	5	0	28852	\N
20466	4240	6	0	28853	\N
20604	16	2	0	28856	\N
20604	388	3	0	28857	\N
20641	16	6	0	28858	\N
20641	3369	7	0	28859	\N
20674	360	9	0	31284	\N
20674	6080	10	0	31293	\N
20485	322	5	0	32540	\N
20485	6003	6	0	32541	\N
20507	453	4	0	32632	\N
20507	4108	5	0	32635	\N
20414	5985	11	0	35442	\N
20444	2	2	0	35464	\N
20444	2789	3	0	35466	\N
20584	2	10	0	35482	\N
20584	6049	11	0	35489	\N
20642	4	3	0	35835	\N
20642	3837	4	0	35836	\N
20449	6	3	0	36217	\N
20647	6	0	0	36219	\N
20449	4823	4	0	36220	\N
20548	14	0	0	38974	\N
20531	40	3	0	42896	\N
20664	40	2	0	42900	\N
20664	282	3	0	42902	\N
20531	372	4	0	42903	\N
20535	56	5	0	44401	\N
20535	3930	6	0	44404	\N
20694	56	8	0	44408	\N
20694	6085	9	0	44412	\N
20438	75	10	0	45708	\N
20438	3945	11	0	45713	\N
20434	79	5	0	46362	\N
20434	5993	6	0	46363	\N
20482	88	2	0	47043	\N
20505	88	3	0	47044	\N
20482	2799	3	0	47047	\N
20505	3655	4	0	47049	\N
20515	6010	11	0	48489	\N
20515	119	23	0	48496	\N
20515	1879	24	0	48497	\N
20500	147	4	0	50105	\N
20500	3877	5	0	50113	\N
20705	156	8	0	50353	\N
20705	6095	9	0	50354	\N
20622	181	7	0	51105	\N
20622	6062	8	0	51109	\N
20431	186	8	0	51145	\N
20431	5991	9	0	51149	\N
20474	186	1	0	51155	\N
20475	186	2	0	51156	\N
20475	1850	3	0	51158	\N
20544	200	3	0	51454	\N
20544	3338	4	0	51455	\N
20447	210	3	0	51721	\N
20447	3539	4	0	51724	\N
20633	210	11	0	51745	\N
20633	6071	12	0	51746	\N
20455	285	6	0	53376	\N
20455	3903	7	0	53378	\N
20429	324	1	0	54443	\N
20429	939	2	0	54446	\N
20608	324	23	0	54453	\N
20608	690	24	0	54460	\N
20542	1109	4	0	56278	\N
20542	3816	5	0	56279	\N
20645	1109	3	0	56284	\N
20645	3495	4	0	56285	\N
20427	4363	2	0	56830	\N
20427	793	4	0	56837	\N
20427	2972	5	0	56838	\N
20678	908	3	0	57556	\N
20678	3591	4	0	57558	\N
20559	6028	64	1	58100	\N
20425	3368	2	0	58384	\N
20543	1470	9	0	58388	\N
20425	1470	4	0	58390	\N
20425	5990	5	0	58393	\N
20543	6021	10	0	58394	\N
20655	5885	3	0	60477	\N
20655	5926	4	0	60481	\N
20687	741	3	0	1374	\N
20704	251	3	0	1406	\N
20704	3514	4	0	1407	\N
20514	251	3	0	1622	\N
20514	3514	4	0	1624	\N
20524	110	4	0	2389	\N
20582	110	8	0	2390	\N
20524	4134	5	0	2392	\N
20582	6048	9	0	2397	\N
20700	1636	8	0	3096	\N
20700	6092	9	0	3098	\N
20441	35	2	0	4132	\N
20525	35	13	0	4133	\N
20525	6014	14	0	4135	\N
20710	4178	4	0	6493	\N
20451	4172	3	0	8907	\N
20451	4275	4	0	8908	\N
20468	4172	4	0	8910	\N
20468	4219	5	0	8911	\N
20472	4172	4	0	8912	\N
20472	4219	5	0	8915	\N
20565	4172	8	0	8924	\N
20565	4500	9	0	8925	\N
20614	4172	3	0	8930	\N
20614	4275	4	0	8931	\N
20639	4275	4	0	8938	\N
20581	132	3	0	11151	\N
20581	3729	4	0	11152	\N
20559	6026	63	1	11589	\N
20672	459	3	0	11934	\N
20672	3178	4	0	11940	\N
20666	300	13	0	12299	\N
20666	6078	14	0	12300	\N
20660	233	3	0	13900	\N
20660	3704	4	0	13908	\N
20569	402	8	0	14264	\N
20569	6037	9	0	14269	\N
20573	402	99	0	14285	\N
20573	6041	100	0	14286	\N
20476	173	4	0	14850	\N
20476	3857	5	0	14852	\N
20487	38	6	0	16240	\N
20549	38	0	0	16242	\N
20487	6005	7	0	16249	\N
20706	1792	2	0	16586	\N
20706	6096	3	0	16589	\N
20559	6030	65	1	17589	\N
20559	6024	14	0	17872	\N
20559	167	62	0	17883	\N
20463	290	3	0	18848	\N
20463	3635	4	0	18850	\N
20554	60	3	0	19640	\N
20554	3585	4	0	19641	\N
20638	241	4	0	20527	\N
20638	4582	5	0	20529	\N
20559	6025	63	0	21725	\N
20603	145	2	0	21791	\N
20603	1108	3	0	21795	\N
20597	149	2	0	23319	\N
20597	1379	3	0	23320	\N
20520	264	6	0	23377	\N
20587	224	4	0	25417	\N
20587	3281	5	0	25428	\N
20607	90	2	0	26231	\N
20607	3442	3	0	26236	\N
20671	107	1	0	26978	\N
20671	94	4	0	26989	\N
20671	2043	5	0	26994	\N
20436	16	11	0	28850	\N
20436	155	12	0	28851	\N
20688	16	4	0	28861	\N
20688	3546	5	0	28863	\N
20536	320	21	0	29289	\N
20495	20	2	0	30603	\N
20495	369	3	0	30604	\N
20621	151	5	0	30856	\N
20621	6061	6	0	30857	\N
20442	230	3	0	32311	\N
20442	4181	4	0	32312	\N
20577	230	3	0	32314	\N
20577	4181	4	0	32315	\N
20659	322	4	0	32553	\N
20659	5447	5	0	32554	\N
20682	322	3	0	32564	\N
20682	1105	4	0	32566	\N
20677	5824	10	0	35844	\N
20650	6	0	0	36227	\N
20592	27	3	0	41268	\N
20592	4636	4	0	41269	\N
20662	40	1	0	42899	\N
20662	1383	2	0	42901	\N
20734	40	3	0	42910	\N
20734	372	4	0	42911	\N
20574	56	4	0	44405	\N
20574	3127	5	0	44406	\N
20600	56	3	0	44407	\N
20600	4109	4	0	44411	\N
20512	79	2	0	46410	\N
20537	79	6	0	46412	\N
20696	79	6	0	46413	\N
20512	616	3	0	46414	\N
20537	4253	7	0	46417	\N
20696	6088	7	0	46418	\N
20619	113	5	0	48458	\N
20619	6059	6	0	48460	\N
20665	119	13	0	48492	\N
20665	6077	14	0	48495	\N
20741	156	7	0	50359	\N
20741	6106	8	0	50360	\N
20681	181	3	0	51106	\N
20474	1080	2	0	51157	\N
20497	186	1	0	51165	\N
20498	186	2	0	51166	\N
20497	1080	2	0	51168	\N
20498	1850	3	0	51169	\N
20717	200	3	0	51464	\N
20717	3338	4	0	51466	\N
20532	1021	5	0	56527	\N
20532	6017	6	0	56532	\N
20649	852	4	0	57414	\N
20649	4162	5	0	57416	\N
20680	6081	21	0	58465	\N
20680	4678	33	0	58468	\N
20680	6082	34	0	58469	\N
20629	1952	7	0	58532	\N
20629	6067	8	0	58533	\N
20510	2351	3	0	59105	\N
20510	2845	4	0	59108	\N
20713	3625	3	0	59578	\N
20713	3784	4	0	59587	\N
20727	4088	10	0	59902	\N
20727	6102	11	0	59921	\N
20657	4043	5	0	474	\N
20503	3474	4	0	1347	\N
20589	117	4	0	2039	\N
20589	4169	5	0	2044	\N
20521	367	6	0	3534	\N
20521	6013	7	0	3538	\N
20585	262	10	0	3668	\N
20585	6050	11	0	3676	\N
20479	365	26	0	4442	\N
20479	6002	27	0	4443	\N
20516	6011	11	0	6469	\N
20516	4178	23	0	6474	\N
20516	4247	24	0	6475	\N
20560	6031	15	0	6479	\N
20636	4178	2	0	6482	\N
20636	4247	3	0	6483	\N
20637	4178	4	0	6484	\N
20637	4205	5	0	6485	\N
20654	4178	3	0	6486	\N
20654	4211	4	0	6487	\N
20658	4178	4	0	6488	\N
20658	4205	5	0	6491	\N
20676	4178	9	0	6492	\N
20676	4682	10	0	6496	\N
20545	4172	3	0	8918	\N
20545	4275	4	0	8920	\N
20555	4219	5	0	8921	\N
20561	4172	3	0	8922	\N
20561	4275	4	0	8923	\N
20630	6068	9	0	8932	\N
20630	4172	13	0	8933	\N
20630	4940	14	0	8934	\N
20643	4172	3	0	8939	\N
20643	4275	4	0	8942	\N
20579	6046	66	0	11135	\N
20579	132	101	0	11153	\N
20579	6047	102	0	11154	\N
20566	6035	9	0	11896	\N
20675	58	9	0	13618	\N
20675	3755	10	0	13619	\N
20486	402	30	0	14263	\N
20486	6004	31	0	14270	\N
20575	258	4	0	14347	\N
20575	6042	5	0	14350	\N
20594	92	4	0	15160	\N
20594	6053	5	0	15162	\N
20702	44	8	0	15953	\N
20702	6094	9	0	15961	\N
20708	1792	0	0	16587	\N
20749	6111	7	0	17022	\N
20550	326	0	0	17564	\N
20644	326	3	0	17568	\N
20644	3339	4	0	17574	\N
20754	290	5	0	18856	\N
20670	63	1	0	19964	\N
20670	62	4	0	19965	\N
20670	1880	5	0	19966	\N
20618	241	7	0	20514	\N
20618	6058	8	0	20516	\N
20663	145	2	0	21792	\N
20663	1108	3	0	21796	\N
20691	3632	4	0	23389	\N
20635	140	3	0	24244	\N
20635	4149	4	0	24247	\N
20653	214	3	0	24403	\N
20653	3496	4	0	24406	\N
20605	90	1	0	26230	\N
20712	90	4	0	26232	\N
20740	90	10	0	26233	\N
20605	2897	2	0	26234	\N
20712	3731	5	0	26238	\N
20740	6105	11	0	26239	\N
20570	94	8	0	26985	\N
20527	42	4	0	27747	\N
20527	6016	5	0	27748	\N
20491	16	3	0	28854	\N
20491	3634	4	0	28855	\N
20669	16	3	0	28860	\N
20669	3634	4	0	28862	\N
20612	20	3	0	30608	\N
20612	2844	4	0	30609	\N
20483	202	5	0	30969	\N
20483	5374	6	0	30973	\N
20632	33	11	0	31669	\N
20632	6070	12	0	31676	\N
20611	6056	11	0	32555	\N
20508	6008	20	0	32625	\N
20508	453	126	0	32636	\N
20508	6009	127	0	32637	\N
20685	4	3	0	35842	\N
20685	3837	4	0	35843	\N
20648	6	4	0	36226	\N
20652	6	0	0	36228	\N
20648	3487	5	0	36229	\N
20722	14	0	0	38976	\N
20526	18	8	0	40288	\N
20526	6015	9	0	40290	\N
20631	6069	13	0	40292	\N
20728	18	10	0	40293	\N
20728	4919	11	0	40295	\N
20488	27	6	0	41236	\N
20488	3715	7	0	41237	\N
20494	27	3	0	41254	\N
20494	4636	4	0	41255	\N
18133	56	2	0	44314	\N
20699	6091	9	0	44958	\N
20723	75	0	0	45709	\N
20729	75	10	0	45710	\N
20729	4874	11	0	45715	\N
20779	75	2	0	45725	\N
20779	284	3	0	45726	\N
20738	88	4	0	47045	\N
20738	3809	5	0	47050	\N
20718	102	3	0	48050	\N
20718	3597	4	0	48054	\N
20733	102	3	0	48063	\N
20735	102	4	0	48064	\N
20733	3597	4	0	48065	\N
20735	2549	5	0	48066	\N
20851	195	1	0	49152	\N
20841	125	3	0	49168	\N
20851	125	4	0	49171	\N
20851	2902	5	0	49172	\N
20841	2846	4	0	49174	\N
20811	137	2	0	49662	\N
20811	2721	3	0	49668	\N
20870	156	3	0	50187	\N
20870	4594	4	0	50188	\N
20781	170	2	0	50747	\N
20781	1380	3	0	50748	\N
20681	4184	4	0	51108	\N
20714	316	3	0	54101	\N
20714	4249	4	0	54105	\N
20747	451	7	0	55485	\N
20747	6110	8	0	55488	\N
20778	1952	5	0	58535	\N
20778	6137	6	0	58536	\N
20716	2519	80	1	58570	\N
20692	2351	3	0	59109	\N
20692	2845	4	0	59110	\N
20806	2351	2	0	59111	\N
20806	2754	3	0	59113	\N
20753	3625	5	0	59579	\N
20753	6114	6	0	59591	\N
20763	6124	39	1	59792	\N
20857	4787	4	0	60279	\N
20857	6163	5	0	60290	\N
20716	5975	66	0	60411	\N
20703	5885	3	0	60478	\N
20703	5926	4	0	60482	\N
20824	6045	4	0	60612	\N
20880	6170	21	0	2737	\N
20880	6171	91	0	2750	\N
20773	367	12	0	3535	\N
20773	6133	13	0	3541	\N
20701	189	8	0	4775	\N
20701	6093	9	0	4782	\N
20695	1970	30	0	5137	\N
20698	1151	2	0	5196	\N
20698	6090	3	0	5197	\N
20730	4178	10	0	6494	\N
20730	4665	11	0	6497	\N
20748	4178	6	0	6498	\N
20748	5854	7	0	6503	\N
20805	5507	8	0	6511	\N
20816	4178	2	0	6514	\N
20816	4247	3	0	6517	\N
20895	4178	2	0	6523	\N
20895	4247	3	0	6524	\N
20898	4178	3	0	6525	\N
20898	4211	4	0	6526	\N
20689	4172	3	0	8941	\N
20689	4275	4	0	8943	\N
20693	4172	8	0	8945	\N
20693	6084	9	0	8946	\N
20707	4172	2	0	8947	\N
20739	4172	10	0	8949	\N
20707	4191	3	0	8953	\N
20724	4663	11	0	8955	\N
20797	392	1	0	10872	\N
20797	391	2	0	10879	\N
20791	108	4	0	11892	\N
20791	6142	5	0	11895	\N
20872	300	2	0	12303	\N
20872	2786	3	0	12306	\N
20831	528	3	0	12455	\N
20831	4262	4	0	12457	\N
20716	3251	67	0	13612	\N
20886	2853	3	0	13627	\N
20726	233	10	0	13902	\N
20901	233	2	0	13903	\N
20901	1849	3	0	13905	\N
20726	6101	11	0	13911	\N
20798	402	2	0	14265	\N
20798	2760	3	0	14266	\N
20889	2760	2	0	14267	\N
20889	402	3	0	14281	\N
20721	6100	95	0	15176	\N
20721	6099	126	0	15194	\N
20721	180	127	0	15195	\N
20913	192	4	0	15456	\N
20882	6172	5	0	15465	\N
20913	6172	5	0	15466	\N
20709	1792	0	0	16588	\N
20893	115	3	0	16875	\N
20893	3483	4	0	16881	\N
20763	6125	40	0	17882	\N
20711	488	4	0	21613	\N
20711	5606	5	0	21614	\N
20742	488	7	0	21615	\N
20742	2883	8	0	21618	\N
20863	73	5	0	22381	\N
20690	264	2	0	23384	\N
20690	2780	3	0	23387	\N
20736	69	3	0	24602	\N
20736	4536	4	0	24603	\N
20920	90	4	0	26242	\N
20763	6123	39	0	27182	\N
20763	6122	14	0	27415	\N
20767	244	14	0	27420	\N
20767	6129	15	0	27425	\N
20763	244	38	0	27426	\N
20848	244	4	0	27444	\N
20848	2501	5	0	27445	\N
20785	5895	7	0	28869	\N
20716	6098	80	0	29201	\N
20716	6097	66	1	29202	\N
20716	320	79	0	29311	\N
20843	96	2	0	29738	\N
20843	2347	3	0	29739	\N
20695	6086	27	0	30285	\N
20697	54	6	0	30290	\N
20697	6089	7	0	30299	\N
20695	54	29	0	30300	\N
20695	6087	30	1	30315	\N
20875	33	4	0	31670	\N
20686	322	3	0	32565	\N
20686	1105	4	0	32567	\N
20835	2	2	0	34905	\N
20835	2789	3	0	34906	\N
20684	14	3	0	38975	\N
20684	4272	4	0	38977	\N
20904	14	2	0	38988	\N
20904	1785	3	0	38989	\N
20865	40	2	0	41366	\N
20865	282	3	0	41367	\N
20891	282	2	0	41368	\N
20907	40	5	0	41376	\N
20907	2714	6	0	41380	\N
20780	40	8	0	41427	\N
20780	3438	9	0	41428	\N
18377	56	2	0	44328	\N
20917	3373	6	0	44416	\N
20921	56	2	0	44417	\N
20921	2795	3	0	44418	\N
20952	71	2	0	44952	\N
20952	1125	3	0	44955	\N
20719	102	0	0	48051	\N
20814	102	2	0	48080	\N
20814	3053	3	0	48081	\N
20752	119	5	0	48493	\N
20752	6113	6	0	48494	\N
20827	125	2	0	49150	\N
20827	3297	3	0	49151	\N
20737	170	3	0	50723	\N
20737	4148	4	0	50726	\N
20761	181	14	0	51115	\N
20761	6118	15	0	51116	\N
20762	6120	73	0	51119	\N
20762	181	119	0	51124	\N
20762	6121	120	0	51125	\N
20861	451	3	0	55497	\N
20861	5274	4	0	55498	\N
20783	841	6	0	56912	\N
20813	841	3	0	56913	\N
20813	3604	4	0	56914	\N
20783	6139	7	0	56915	\N
20915	841	4	0	56923	\N
20915	2774	5	0	56925	\N
20960	852	3	0	57415	\N
20960	6192	4	0	57417	\N
20745	908	5	0	57557	\N
20745	6108	6	0	57559	\N
20751	1470	8	0	58396	\N
20751	6112	9	0	58398	\N
20777	1952	6	0	58534	\N
20777	6136	7	0	58537	\N
20855	3625	4	0	59580	\N
20855	6161	5	0	59594	\N
20836	6156	40	0	59788	\N
20795	4233	7	0	59962	\N
20796	4233	6	0	59963	\N
20796	6144	7	0	59964	\N
20795	6143	8	0	59965	\N
20836	5352	38	0	60260	\N
20830	5885	3	0	60479	\N
20830	5926	4	0	60483	\N
20823	6153	2	0	60610	\N
20808	6147	4	0	1898	\N
20840	6158	4	0	2043	\N
20809	674	2	0	2283	\N
20809	6148	3	0	2284	\N
20836	6155	39	0	2365	\N
20772	1636	12	0	3106	\N
20772	6132	13	0	3111	\N
20775	367	6	0	3536	\N
20775	6135	7	0	3540	\N
20710	4205	5	0	6495	\N
20771	4178	12	0	6500	\N
20790	4178	3	0	6501	\N
20790	4441	4	0	6502	\N
20794	4178	6	0	6506	\N
20794	4297	7	0	6507	\N
20800	4178	3	0	6508	\N
20800	4211	4	0	6509	\N
20810	4178	2	0	6513	\N
20743	4172	6	0	8950	\N
20765	4172	7	0	8951	\N
20743	6107	7	0	8956	\N
20739	6104	11	0	8957	\N
20765	6127	8	0	8958	\N
20908	4172	2	0	8971	\N
20908	4191	3	0	8972	\N
20919	4191	3	0	8977	\N
20945	4172	7	0	8980	\N
20950	4172	2	0	8981	\N
20950	4191	3	0	8985	\N
20945	4537	8	0	8989	\N
20776	391	5	0	10870	\N
20776	2235	6	0	10871	\N
20845	391	2	0	10883	\N
20845	1381	3	0	10886	\N
20757	459	0	0	11935	\N
20803	300	2	0	12301	\N
20853	300	10	0	12302	\N
20853	6160	11	0	12308	\N
20770	528	2	0	12439	\N
20770	2765	3	0	12440	\N
20878	77	3	0	12985	\N
20878	1877	4	0	12986	\N
20725	233	10	0	13901	\N
20926	233	2	0	13904	\N
20926	1849	3	0	13906	\N
20725	6101	11	0	13910	\N
20732	173	7	0	14851	\N
20732	6103	8	0	14853	\N
20834	173	4	0	14854	\N
20720	6099	2	0	15192	\N
20720	2763	3	0	15193	\N
20715	38	3	0	16243	\N
20715	3457	4	0	16246	\N
20784	326	0	0	17569	\N
20761	6119	15	1	17881	\N
20899	167	2	0	17898	\N
20903	167	2	0	17899	\N
20899	3322	3	0	17907	\N
20903	3322	3	0	17908	\N
20912	6175	61	0	18223	\N
20912	6173	126	0	18229	\N
20761	3108	16	0	18757	\N
20789	60	5	0	19649	\N
20789	5528	6	0	19650	\N
20852	60	4	0	19655	\N
20852	2771	5	0	19656	\N
20871	164	4	0	20966	\N
20871	4345	5	0	20968	\N
20766	73	5	0	22368	\N
20766	6128	6	0	22371	\N
20939	73	6	0	22382	\N
20939	6183	7	0	22383	\N
20801	140	2	0	24245	\N
20746	224	7	0	25421	\N
20746	6109	8	0	25429	\N
20788	90	1	0	26240	\N
20788	344	2	0	26241	\N
20836	6154	38	1	27183	\N
20849	244	5	0	27422	\N
20849	6159	6	0	27424	\N
20836	244	37	0	27440	\N
20802	42	7	0	27467	\N
20802	6145	8	0	27468	\N
20750	16	6	0	28864	\N
20750	5895	7	0	28865	\N
20756	6116	7	0	29769	\N
20836	3079	39	1	30324	\N
20906	202	5	0	30971	\N
20906	5374	6	0	30974	\N
20804	2	2	0	34899	\N
20804	2789	3	0	34900	\N
20934	4	9	0	35849	\N
20934	6180	10	0	35850	\N
20869	14	3	0	38987	\N
20869	4272	4	0	38990	\N
20744	18	6	0	40294	\N
20744	4566	7	0	40296	\N
20864	3550	6	0	40298	\N
20731	27	10	0	41302	\N
20731	4830	11	0	41305	\N
20828	56	2	0	44409	\N
20828	2795	3	0	44410	\N
20909	56	7	0	44413	\N
20909	4512	8	0	44414	\N
20842	75	3	0	45731	\N
20842	713	4	0	45732	\N
20879	75	2	0	45743	\N
20879	284	3	0	45744	\N
20818	6151	97	0	48067	\N
20818	102	126	0	48082	\N
20818	6152	127	0	48083	\N
20856	119	4	0	48504	\N
20856	6162	5	0	48505	\N
20812	135	2	0	49409	\N
20812	2722	3	0	49411	\N
20819	170	0	0	50498	\N
20820	170	2	0	50499	\N
20820	1380	3	0	50500	\N
20884	181	4	0	51122	\N
20884	2356	5	0	51123	\N
20792	200	4	0	51465	\N
20792	2811	5	0	51467	\N
20930	6178	6	0	51747	\N
20930	210	9	0	51755	\N
20930	6179	10	0	51757	\N
20787	260	2	0	52469	\N
20815	260	2	0	52470	\N
20787	3184	3	0	52473	\N
20815	3184	3	0	52474	\N
20838	273	5	0	53146	\N
20838	6157	6	0	53147	\N
20888	1413	2	0	53148	\N
20888	273	3	0	53151	\N
20866	285	2	0	53389	\N
20866	3036	3	0	53394	\N
20874	451	3	0	55505	\N
20874	3934	4	0	55506	\N
20759	1109	0	0	56295	\N
20953	1021	2	0	56401	\N
20953	4432	3	0	56402	\N
20924	841	5	0	56924	\N
20924	6177	6	0	56926	\N
20958	908	3	0	57568	\N
20958	6190	4	0	57573	\N
20935	1470	9	0	58399	\N
20935	6181	10	0	58401	\N
20868	2351	3	0	58939	\N
20868	2845	4	0	58942	\N
20807	2351	3	0	59112	\N
20807	2845	4	0	59114	\N
20902	4088	2	0	59903	\N
20927	4088	2	0	59904	\N
20927	4332	3	0	59913	\N
20860	4233	3	0	59968	\N
20860	4425	4	0	59969	\N
20929	2804	3	0	473	\N
20932	4416	3	0	3108	\N
20942	35	5	0	4146	\N
20942	6185	6	0	4148	\N
20873	365	2	0	4452	\N
20873	615	3	0	4453	\N
20755	4178	6	0	6499	\N
20755	5854	7	0	6504	\N
20850	4450	1	0	6512	\N
20850	4178	4	0	6515	\N
20810	4247	3	0	6516	\N
20850	4527	5	0	6518	\N
20859	4178	15	0	6519	\N
20894	4178	3	0	6521	\N
20894	4211	4	0	6522	\N
20910	4178	7	0	6527	\N
20910	4509	8	0	6528	\N
20821	4172	2	0	8952	\N
20821	4191	3	0	8954	\N
20829	4172	3	0	8959	\N
20829	4275	4	0	8960	\N
20854	4172	10	0	8961	\N
20854	4474	11	0	8962	\N
20862	4172	5	0	8963	\N
20862	6107	6	0	8965	\N
20896	4172	2	0	8967	\N
20896	4191	3	0	8969	\N
20883	4252	5	0	8970	\N
20822	391	2	0	10882	\N
20822	1381	3	0	10885	\N
20769	528	3	0	12438	\N
20769	6130	4	0	12443	\N
20786	5653	39	0	13613	\N
20774	44	12	0	15954	\N
20774	6134	13	0	15962	\N
20825	38	2	0	16252	\N
20826	38	3	0	16253	\N
20826	3457	4	0	16258	\N
20881	115	1	0	16867	\N
20881	116	2	0	16868	\N
20786	6140	38	0	17577	\N
20786	6141	39	0	17580	\N
20754	6115	6	0	18860	\N
20955	60	2	0	19659	\N
20955	4544	3	0	19664	\N
20782	198	6	0	20258	\N
20782	6138	7	0	20260	\N
20892	488	2	0	21616	\N
20892	2791	3	0	21617	\N
20922	1108	3	0	21797	\N
20817	6149	2	0	22311	\N
20817	6150	3	0	22312	\N
20768	73	5	0	22369	\N
20768	6128	6	0	22372	\N
20858	264	2	0	23386	\N
20858	2780	3	0	23388	\N
20946	264	7	0	23402	\N
20946	6187	8	0	23403	\N
20887	94	2	0	26986	\N
20887	2794	3	0	26990	\N
20837	244	2	0	27421	\N
20900	42	2	0	27471	\N
20900	3310	3	0	27472	\N
20793	16	2	0	28867	\N
20793	388	3	0	28868	\N
20833	16	3	0	28870	\N
20876	16	4	0	28871	\N
20833	1045	4	0	28872	\N
20876	2575	5	0	28873	\N
20760	2627	60	0	29177	\N
20764	2627	12	0	29178	\N
20764	6126	13	0	29183	\N
20760	6117	61	0	29184	\N
20961	6193	4	0	29785	\N
20897	202	3	0	30970	\N
20897	4857	4	0	30972	\N
20877	6168	48	0	31662	\N
20877	33	102	0	31677	\N
20877	6169	103	0	31678	\N
20844	14	1	0	38979	\N
20846	14	2	0	38980	\N
20844	15	2	0	38981	\N
20846	1785	3	0	38982	\N
20948	14	3	0	38994	\N
20948	4272	4	0	38995	\N
20867	27	107	0	41306	\N
20867	6167	108	0	41307	\N
20832	40	3	0	41358	\N
20839	40	5	0	41359	\N
20847	40	4	0	41360	\N
20832	372	4	0	41361	\N
20847	3381	5	0	41362	\N
20839	5806	6	0	41363	\N
20987	51	2	0	43448	\N
20987	1260	3	0	43451	\N
20978	56	3	0	44419	\N
20978	4109	4	0	44423	\N
20971	102	2	0	48086	\N
20971	3053	3	0	48087	\N
20972	102	4	0	48088	\N
20972	6201	5	0	48089	\N
20991	113	2	0	48184	\N
20991	1899	3	0	48188	\N
20999	135	13	0	49410	\N
20999	6206	14	0	49412	\N
20998	137	13	0	49663	\N
20998	6205	14	0	49676	\N
20973	170	6	0	50507	\N
20973	6202	7	0	50508	\N
20918	186	2	0	51167	\N
20918	1850	3	0	51170	\N
20931	6178	6	0	51748	\N
20931	210	9	0	51756	\N
20931	6179	10	0	51758	\N
20966	6198	4	1	53345	\N
20966	285	2	0	53390	\N
20969	285	2	0	53391	\N
20970	285	2	0	53392	\N
21001	285	5	0	53393	\N
20970	3036	3	0	53395	\N
21001	5103	6	0	53398	\N
20969	6200	3	0	53401	\N
20965	852	5	0	57426	\N
20965	4420	6	0	57427	\N
20966	6196	3	1	58099	\N
20937	1470	9	0	58400	\N
20937	6181	10	0	58402	\N
20966	6197	4	0	58418	\N
20974	2578	2	0	58621	\N
20974	4325	3	0	58622	\N
20993	2782	2	0	59226	\N
20996	2782	4	0	59227	\N
20993	6203	3	0	59228	\N
20996	2783	5	0	59229	\N
20902	4332	3	0	59912	\N
20994	4787	4	0	60280	\N
20995	4787	4	0	60281	\N
20994	4847	5	0	60287	\N
20995	4847	5	0	60288	\N
20966	6195	3	0	60455	\N
20949	6044	2	0	60613	\N
20949	6188	3	0	60614	\N
21005	4416	3	0	3121	\N
20936	6182	10	0	4147	\N
20928	4178	3	0	6529	\N
20928	4211	4	0	6530	\N
20938	4178	3	0	6531	\N
20938	5507	4	0	6532	\N
20947	4178	7	0	6533	\N
20979	4178	2	0	6534	\N
20979	4247	3	0	6535	\N
20947	4509	8	0	6536	\N
20916	4172	5	0	8973	\N
20940	4172	4	0	8975	\N
20916	4644	6	0	8978	\N
20982	4172	2	0	8982	\N
20983	4172	2	0	8983	\N
20989	4172	2	0	8984	\N
20982	4191	3	0	8986	\N
20983	4191	3	0	8987	\N
20989	4191	3	0	8988	\N
21004	4172	2	0	8990	\N
21004	4191	3	0	8994	\N
20925	391	3	0	10884	\N
20925	503	4	0	10887	\N
20981	391	2	0	10892	\N
20981	1381	3	0	10893	\N
20984	1381	3	0	10899	\N
21003	391	2	0	10902	\N
21003	1381	3	0	10905	\N
20976	132	3	0	11172	\N
20976	5516	4	0	11173	\N
20990	459	2	0	11936	\N
20990	3860	3	0	11938	\N
20980	300	2	0	12304	\N
20980	2786	3	0	12307	\N
20967	77	2	0	12995	\N
20968	77	2	0	12996	\N
20967	3853	3	0	12997	\N
20986	58	2	0	13636	\N
20986	2853	3	0	13638	\N
20964	173	16	0	14856	\N
20964	6194	17	0	14859	\N
21011	6209	95	0	15196	\N
21010	92	2	0	15207	\N
21010	2763	3	0	15208	\N
20933	44	2	0	15955	\N
21006	44	2	0	15956	\N
20933	1910	3	0	15957	\N
21006	1910	3	0	15958	\N
20985	38	3	0	16254	\N
20959	115	3	0	16876	\N
21007	115	5	0	16877	\N
21009	115	3	0	16878	\N
21009	1115	4	0	16882	\N
21007	5025	6	0	16883	\N
20959	6191	4	0	16884	\N
21002	167	5	0	17900	\N
21002	2851	6	0	17912	\N
20911	6173	2	0	18225	\N
20911	6174	3	0	18227	\N
20966	6199	5	0	18784	\N
21000	6207	36	0	19967	\N
20997	6204	14	0	19971	\N
21000	62	126	0	19972	\N
21000	6208	127	0	19973	\N
21008	241	5	0	20528	\N
21008	4586	6	0	20530	\N
20966	5358	5	1	21768	\N
20969	1075	3	1	21789	\N
20963	145	2	0	21794	\N
20963	1108	3	0	21798	\N
20992	1316	3	0	22336	\N
20992	4837	4	0	22337	\N
20977	73	3	0	22394	\N
20943	336	5	0	22942	\N
20943	6186	6	0	22943	\N
20920	3435	5	0	26243	\N
20923	16	3	0	28874	\N
20923	1045	4	0	28875	\N
20944	16	4	0	28876	\N
20944	2575	5	0	28877	\N
20962	16	4	0	28878	\N
20962	2575	5	0	28879	\N
20957	151	7	0	30863	\N
20957	6189	8	0	30864	\N
20954	2	3	0	34920	\N
20905	14	5	0	38993	\N
20905	5648	6	0	38996	\N
20951	18	2	0	40299	\N
20951	1685	3	0	40300	\N
20914	40	4	0	41377	\N
20914	2796	5	0	41379	\N
20941	40	2	0	41387	\N
20941	282	3	0	41388	\N
20956	40	2	0	41391	\N
20956	282	3	0	41392	\N
20975	40	3	0	41396	\N
20988	40	2	0	41397	\N
20975	1921	4	0	41399	\N
18609	56	2	0	44330	\N
21081	56	2	0	44421	\N
21081	2795	3	0	44422	\N
21016	3551	6	0	44424	\N
21056	71	2	0	44953	\N
21056	1125	3	0	44956	\N
21125	75	2	0	45766	\N
21125	2989	3	0	45767	\N
21139	75	4	0	45777	\N
21139	2357	5	0	45780	\N
21123	79	2	0	46454	\N
21123	3180	3	0	46457	\N
21160	102	2	0	48092	\N
21160	3053	3	0	48094	\N
21249	102	8	0	48104	\N
21249	5616	9	0	48109	\N
21053	121	2	0	48813	\N
21137	121	2	0	48815	\N
21053	2498	3	0	48821	\N
21137	625	3	0	48825	\N
21084	4352	4	0	49655	\N
21084	137	6	0	49673	\N
21084	3261	7	0	49674	\N
21079	170	3	0	50517	\N
21079	4148	4	0	50518	\N
21244	451	2	0	55162	\N
21244	3317	3	0	55165	\N
21036	451	0	0	55508	\N
21195	598	1	0	56061	\N
21093	597	4	0	56086	\N
21195	597	3	0	56092	\N
21195	2956	4	0	56093	\N
21093	6224	5	0	56099	\N
21239	852	10	0	57434	\N
21239	6249	11	0	57435	\N
21232	1470	2	0	58153	\N
21232	3368	3	0	58154	\N
21253	2636	1	0	58686	\N
21253	3980	2	0	58687	\N
21023	4233	6	0	59972	\N
21026	4233	6	0	59973	\N
21027	4233	6	0	59974	\N
21023	6213	7	0	59975	\N
21026	6213	7	0	59976	\N
21027	6213	7	0	59977	\N
21015	5885	5	0	60480	\N
21015	6212	6	0	60484	\N
21013	6147	4	0	1903	\N
21188	228	108	0	2777	\N
21188	6237	109	0	2778	\N
21029	719	2	0	5171	\N
21029	6214	3	0	5172	\N
21108	4178	4	0	6548	\N
21111	4178	1	0	6549	\N
21115	4178	2	0	6550	\N
21111	4450	2	0	6555	\N
21115	4247	3	0	6556	\N
21108	4331	5	0	6560	\N
21165	4178	2	0	6564	\N
21173	4178	2	0	6565	\N
21173	4247	3	0	6569	\N
21216	4178	2	0	6577	\N
21216	4247	3	0	6578	\N
21252	4178	8	0	6592	\N
21252	5610	9	0	6597	\N
21025	4172	6	0	8991	\N
21047	4172	3	0	8992	\N
21047	4275	4	0	8996	\N
21025	4365	7	0	8997	\N
21135	4172	4	0	9008	\N
21135	4252	5	0	9013	\N
21180	4172	2	0	9016	\N
21242	78	1	0	13006	\N
21242	77	3	0	13019	\N
21242	2934	4	0	13021	\N
21011	92	126	0	15209	\N
21011	6210	127	0	15210	\N
21155	38	2	0	16264	\N
21155	4009	3	0	16273	\N
21141	115	2	0	16879	\N
21141	2797	3	0	16880	\N
21157	326	2	0	17571	\N
21157	393	3	0	17573	\N
21021	167	6	0	17901	\N
21024	167	6	0	17903	\N
21021	3314	7	0	17913	\N
21022	3314	7	0	17914	\N
21024	3314	7	0	17915	\N
21193	177	3	0	18342	\N
21193	3538	4	0	18347	\N
21100	198	3	0	20267	\N
21100	4263	4	0	20269	\N
21219	241	2	0	20540	\N
21219	281	3	0	20547	\N
21150	488	6	0	21428	\N
21150	3315	7	0	21429	\N
21014	6211	8	0	21803	\N
21120	73	3	0	22402	\N
21120	3040	4	0	22404	\N
21067	336	3	0	22950	\N
21067	3400	4	0	22951	\N
21130	336	3	0	22954	\N
21130	3400	4	0	22957	\N
21063	149	10	0	23327	\N
21063	6218	11	0	23334	\N
21214	82	2	0	23698	\N
21214	3401	3	0	23701	\N
21059	16	5	0	28884	\N
21101	16	1	0	28888	\N
21101	17	2	0	28889	\N
21212	16	2	0	28894	\N
21212	388	3	0	28896	\N
21178	96	5	0	29742	\N
21200	96	1	0	29743	\N
21200	2899	2	0	29745	\N
21178	3800	6	0	29748	\N
21018	54	2	0	30291	\N
21018	3351	3	0	30295	\N
21012	20	3	0	30346	\N
21012	2844	4	0	30347	\N
21207	369	3	0	30356	\N
21167	33	2	0	31671	\N
21167	2822	3	0	31672	\N
21227	322	4	0	32570	\N
21227	3429	5	0	32574	\N
21171	4	8	0	35860	\N
21171	6235	9	0	35866	\N
21237	4	10	0	35880	\N
21237	6247	11	0	35881	\N
21040	14	3	0	39007	\N
21040	4272	4	0	39008	\N
21054	14	4	0	39021	\N
21020	18	2	0	40301	\N
21020	1685	3	0	40304	\N
21205	6243	106	0	41308	\N
21205	27	126	0	41311	\N
21205	6244	127	0	41312	\N
21019	40	2	0	41401	\N
21019	282	3	0	41402	\N
21042	40	3	0	41408	\N
21042	372	4	0	41411	\N
21106	40	7	0	41429	\N
21106	4488	8	0	41434	\N
21117	40	2	0	41443	\N
21147	40	0	0	41455	\N
21152	40	2	0	41471	\N
21152	282	3	0	41475	\N
21235	56	2	0	44427	\N
21235	2795	3	0	44428	\N
21228	71	4	0	44959	\N
21228	2776	5	0	44960	\N
21028	75	6	0	45749	\N
21046	75	2	0	45751	\N
21109	75	4	0	45753	\N
21046	284	3	0	45757	\N
21109	2357	5	0	45758	\N
21028	3361	7	0	45759	\N
21161	102	2	0	48093	\N
21161	3053	3	0	48095	\N
21050	121	2	0	48812	\N
21050	2498	3	0	48820	\N
21085	4353	4	0	49413	\N
21085	135	6	0	49424	\N
21085	3262	7	0	49425	\N
21075	137	2	0	49664	\N
21075	2721	3	0	49669	\N
21113	210	3	0	51763	\N
21113	3539	4	0	51765	\N
21034	451	2	0	55507	\N
21037	451	0	0	55509	\N
21034	3317	3	0	55510	\N
21094	595	4	0	55810	\N
21094	6225	5	0	55813	\N
21288	2636	4	0	58696	\N
21288	3617	5	0	58697	\N
21198	5996	3	0	1093	\N
21124	6231	4	0	1681	\N
21172	110	2	0	2428	\N
21172	626	3	0	2430	\N
21065	6219	57	0	2751	\N
21065	228	126	0	2758	\N
21065	6220	127	0	2759	\N
21072	4178	3	0	6541	\N
21072	4211	4	0	6542	\N
21148	4178	2	0	6552	\N
21148	4247	3	0	6558	\N
21230	4178	1	0	6584	\N
21230	4450	2	0	6585	\N
21233	4247	3	0	6590	\N
21254	4178	1	0	6593	\N
21258	4178	2	0	6594	\N
21254	4450	2	0	6595	\N
21258	4247	3	0	6596	\N
21271	4178	9	0	6600	\N
21271	4682	10	0	6601	\N
21283	4429	5	0	6603	\N
21298	4178	3	0	6604	\N
21298	4211	4	0	6606	\N
21283	4178	7	0	6609	\N
21283	4460	8	0	6610	\N
21057	4191	3	0	8995	\N
21126	4172	2	0	9001	\N
21126	4191	3	0	9004	\N
21213	4172	2	0	9022	\N
21289	4172	4	0	9024	\N
21296	4172	6	0	9025	\N
21213	4191	3	0	9026	\N
21289	4219	5	0	9027	\N
21296	4197	7	0	9029	\N
21210	391	2	0	10914	\N
21210	1381	3	0	10915	\N
21118	108	3	0	11893	\N
21265	300	4	0	12039	\N
21265	2992	5	0	12042	\N
21144	6232	4	0	12968	\N
21144	6233	5	0	12969	\N
21043	77	5	0	13003	\N
21043	6215	6	0	13004	\N
21270	77	1	0	13016	\N
21270	2934	2	0	13017	\N
21068	233	3	0	13929	\N
21104	233	3	0	13930	\N
21068	3704	4	0	13932	\N
21104	3704	4	0	13933	\N
21032	4077	4	0	14283	\N
21278	402	4	0	14292	\N
21280	402	56	0	14294	\N
21278	4731	5	0	14297	\N
21280	6263	57	0	14301	\N
21168	235	2	0	15922	\N
21168	2757	3	0	15923	\N
21215	38	2	0	16265	\N
21266	38	4	0	16266	\N
21267	38	4	0	16267	\N
21215	4009	3	0	16274	\N
21266	6259	5	0	16278	\N
21286	326	3	0	17578	\N
21286	3339	4	0	17579	\N
21262	142	8	0	18459	\N
21262	6258	9	0	18461	\N
21086	60	2	0	19660	\N
21086	4544	3	0	19665	\N
21217	241	0	0	20539	\N
21153	336	2	0	22955	\N
21153	3332	3	0	22956	\N
21041	264	3	0	23418	\N
21041	3632	4	0	23423	\N
21131	69	3	0	24616	\N
21088	90	2	0	26246	\N
21088	3442	3	0	26250	\N
21264	86	4	0	26662	\N
21264	2576	5	0	26667	\N
21070	16	6	0	28886	\N
21070	6221	7	0	28887	\N
21142	16	2	0	28890	\N
21174	16	2	0	28891	\N
21142	388	3	0	28892	\N
21174	388	3	0	28893	\N
21222	16	2	0	28895	\N
21222	388	3	0	28897	\N
21293	3546	5	0	28899	\N
21291	449	6	0	29781	\N
21256	202	2	0	30984	\N
21256	2764	3	0	30986	\N
21263	360	8	0	31286	\N
21263	6257	9	0	31295	\N
21169	6234	72	0	31679	\N
21169	33	126	0	31695	\N
21169	6168	127	0	31696	\N
21250	230	8	0	31982	\N
21250	6255	9	0	31991	\N
21186	453	2	0	32661	\N
21048	2	3	0	34930	\N
21048	3548	4	0	34931	\N
21128	2	2	0	34938	\N
21128	2789	3	0	34939	\N
21238	4	10	0	35861	\N
21238	6248	11	0	35865	\N
21277	4	32	0	35900	\N
21277	6262	33	0	35901	\N
21274	6	27	0	36242	\N
21274	6261	28	0	36243	\N
21183	18	2	0	40307	\N
21183	1685	3	0	40308	\N
21191	6241	9	0	40310	\N
21285	18	4	0	40313	\N
21285	2302	5	0	40314	\N
21055	40	4	0	41409	\N
21055	2796	5	0	41412	\N
21116	40	2	0	41431	\N
21116	282	3	0	41432	\N
21176	40	5	0	41472	\N
21176	5806	6	0	41476	\N
18795	56	11	0	44334	\N
21151	4703	6	0	44426	\N
21073	71	2	0	44954	\N
21073	1125	3	0	44957	\N
21102	75	1	0	45752	\N
21102	76	2	0	45755	\N
21129	75	2	0	45776	\N
21129	284	3	0	45779	\N
21268	75	4	0	45784	\N
21268	2357	5	0	45785	\N
21347	79	0	0	46456	\N
21345	79	6	0	46523	\N
21345	4253	7	0	46527	\N
21122	156	6	0	50205	\N
21122	6229	7	0	50206	\N
21158	156	2	0	50214	\N
21158	4485	3	0	50215	\N
21138	242	4	0	52043	\N
21138	4364	5	0	52046	\N
21087	324	2	0	54454	\N
21089	324	2	0	54455	\N
21087	2808	3	0	54457	\N
21089	2808	3	0	54458	\N
21251	324	8	0	54464	\N
21251	6256	9	0	54465	\N
21349	324	4	0	54475	\N
21349	3500	5	0	54480	\N
21243	451	18	0	55161	\N
21245	451	2	0	55163	\N
21245	3317	3	0	55166	\N
21243	6253	19	0	55168	\N
21272	451	10	0	55191	\N
21272	6260	11	0	55194	\N
21329	451	3	0	55201	\N
21329	3934	4	0	55204	\N
21196	596	1	0	55809	\N
21196	595	3	0	55811	\N
21196	2958	4	0	55812	\N
21082	1021	2	0	56409	\N
21082	4432	3	0	56410	\N
21240	1675	3	0	58102	\N
21069	4088	3	0	59905	\N
21105	4088	3	0	59906	\N
21069	4506	4	0	59914	\N
21105	4506	4	0	59915	\N
21189	6238	76	0	60245	\N
21189	4605	126	0	60250	\N
21189	6239	127	0	60251	\N
21319	262	13	0	3671	\N
21319	5815	14	0	3675	\N
21091	1141	5	0	5157	\N
21091	6222	6	0	5158	\N
21039	4178	1	0	6537	\N
21039	4450	2	0	6538	\N
21044	4178	2	0	6539	\N
21044	4247	3	0	6540	\N
21127	4178	2	0	6551	\N
21127	4247	3	0	6557	\N
21163	4178	2	0	6562	\N
21163	4247	3	0	6563	\N
21184	4178	6	0	6567	\N
21194	4178	2	0	6573	\N
21194	4247	3	0	6574	\N
21202	4178	6	0	6576	\N
21202	4358	7	0	6579	\N
21225	4178	2	0	6582	\N
21225	4247	3	0	6583	\N
21231	4178	4	0	6586	\N
21231	4331	5	0	6587	\N
21247	4178	2	0	6589	\N
21247	4247	3	0	6591	\N
21259	4178	2	0	6598	\N
21259	4247	3	0	6599	\N
21062	5249	7	0	9006	\N
21132	4172	3	0	9007	\N
21143	4172	2	0	9009	\N
21143	4191	3	0	9010	\N
21132	4275	4	0	9011	\N
21162	4172	2	0	9015	\N
21181	4172	4	0	9017	\N
21162	4191	3	0	9018	\N
21181	4252	5	0	9020	\N
21229	4172	4	0	9023	\N
21229	4252	5	0	9028	\N
21077	391	2	0	10904	\N
21269	77	2	0	13015	\N
21269	3853	3	0	13022	\N
21114	456	3	0	13397	\N
21114	6227	4	0	13400	\N
21204	58	2	0	13637	\N
21204	2853	3	0	13639	\N
21033	402	4	0	14280	\N
21033	2548	5	0	14284	\N
21095	402	4	0	14290	\N
21095	2548	5	0	14298	\N
21307	212	3	0	17020	\N
21307	3639	4	0	17021	\N
21316	3339	4	0	17582	\N
21300	62	4	0	19974	\N
21300	4059	5	0	19975	\N
21098	198	3	0	20266	\N
21098	4263	4	0	20268	\N
21342	198	3	0	20283	\N
21342	4263	4	0	20284	\N
21175	64	2	0	20898	\N
21175	277	3	0	20900	\N
21299	149	3	0	23329	\N
21299	4189	4	0	23331	\N
21223	411	2	0	25165	\N
21136	206	0	0	25902	\N
21311	244	3	0	27433	\N
21311	4075	4	0	27437	\N
21051	16	2	0	28880	\N
21051	388	3	0	28881	\N
21177	96	5	0	29741	\N
21201	96	1	0	29744	\N
21201	2899	2	0	29746	\N
21177	3800	6	0	29747	\N
21199	96	10	0	29749	\N
21199	2055	11	0	29750	\N
21291	5168	7	0	29784	\N
21206	3015	3	0	30355	\N
21208	230	2	0	31974	\N
21208	3307	3	0	31975	\N
21338	230	3	0	31984	\N
21338	4181	4	0	31988	\N
21187	453	2	0	32662	\N
21187	2838	3	0	32664	\N
21275	4	4	0	35862	\N
21275	4117	5	0	35864	\N
21119	6	4	0	36236	\N
21119	6228	5	0	36237	\N
21352	14	6	0	39023	\N
21064	2381	7	0	40306	\N
21305	18	3	0	40315	\N
21305	3621	4	0	40316	\N
21324	23	4	0	40924	\N
21324	3189	5	0	40926	\N
21030	40	2	0	41407	\N
21030	282	3	0	41410	\N
21060	40	4	0	41421	\N
21060	6216	5	0	41422	\N
21107	40	5	0	41430	\N
21107	2714	6	0	41433	\N
21121	40	3	0	41449	\N
21240	41	1	0	41456	\N
21240	6250	3	0	41473	\N
20917	56	5	0	44415	\N
21038	284	3	0	45756	\N
21140	75	7	0	45778	\N
21140	3331	8	0	45781	\N
21257	79	2	0	46455	\N
21257	616	3	0	46458	\N
21134	121	4	0	48814	\N
21134	4356	5	0	48826	\N
21076	135	2	0	49421	\N
21076	2722	3	0	49423	\N
21197	599	1	0	50087	\N
21096	147	4	0	50106	\N
21197	147	3	0	50109	\N
21197	2957	4	0	50110	\N
21096	6226	5	0	50115	\N
21303	181	3	0	51130	\N
21303	4184	4	0	51132	\N
21090	324	2	0	54456	\N
21090	2808	3	0	54459	\N
21246	451	2	0	55164	\N
21246	3317	3	0	55167	\N
21273	451	2	0	55192	\N
21273	452	3	0	55193	\N
21330	451	2	0	55202	\N
21330	5006	3	0	55203	\N
21164	1470	2	0	58149	\N
21164	3368	3	0	58150	\N
21331	1470	5	0	58161	\N
21331	5803	6	0	58164	\N
21045	2578	2	0	58623	\N
21045	4325	3	0	58626	\N
21179	2782	2	0	59236	\N
21179	2784	3	0	59237	\N
21071	4787	3	0	60282	\N
21209	4787	2	0	60283	\N
21209	6245	3	0	60285	\N
21071	4788	4	0	60286	\N
21192	5885	3	0	60485	\N
21192	6242	4	0	60486	\N
21284	5885	3	0	60487	\N
21284	5926	4	0	60488	\N
21145	6044	3	0	60615	\N
21145	6045	4	0	60616	\N
21035	1851	3	0	1415	\N
21097	3354	5	0	1429	\N
21339	1636	3	0	3118	\N
21318	262	13	0	3670	\N
21318	5815	14	0	3674	\N
21083	4331	4	0	6543	\N
21083	4178	6	0	6544	\N
21083	4460	7	0	6545	\N
21103	4178	2	0	6546	\N
21103	4247	3	0	6547	\N
21149	4178	6	0	6553	\N
21154	4178	2	0	6554	\N
21154	4247	3	0	6559	\N
21182	4178	2	0	6566	\N
21182	4247	3	0	6570	\N
21190	4178	8	0	6572	\N
21190	6240	9	0	6575	\N
21221	4178	6	0	6580	\N
21221	4358	7	0	6581	\N
21074	4172	2	0	8999	\N
21080	4172	2	0	9000	\N
21074	4191	3	0	9002	\N
21080	4191	3	0	9003	\N
21146	5069	2	0	9005	\N
21146	4172	11	0	9012	\N
21185	4172	6	0	9021	\N
21185	4365	7	0	9030	\N
21052	391	2	0	10903	\N
21052	1381	3	0	10906	\N
21287	300	3	0	12040	\N
21287	3747	4	0	12041	\N
21241	78	1	0	13005	\N
21241	77	3	0	13018	\N
21241	2934	4	0	13020	\N
21301	77	4	0	13032	\N
21301	3619	5	0	13033	\N
21066	233	2	0	13928	\N
21031	402	3	0	14278	\N
21031	4077	4	0	14282	\N
21092	402	6	0	14289	\N
21276	402	0	0	14291	\N
21279	402	0	0	14293	\N
21281	402	0	0	14295	\N
21092	6223	7	0	14300	\N
21110	258	1	0	14348	\N
21110	309	2	0	14349	\N
21308	115	1	0	16892	\N
21308	2908	2	0	16898	\N
21310	6267	46	0	17010	\N
21310	6268	127	0	17024	\N
21156	326	2	0	17570	\N
21156	393	3	0	17572	\N
21234	142	2	0	18458	\N
21234	4418	3	0	18460	\N
21333	142	3	0	18466	\N
21333	6273	4	0	18467	\N
21248	62	6	0	19969	\N
21248	6254	7	0	19970	\N
21159	198	6	0	20273	\N
21159	5923	7	0	20274	\N
21218	577	4	0	20344	\N
21078	241	3	0	20538	\N
21220	241	0	0	20541	\N
21078	3613	4	0	20545	\N
21166	64	2	0	20889	\N
21166	277	3	0	20890	\N
21314	145	4	0	21810	\N
21314	5607	5	0	21820	\N
21061	149	67	0	23326	\N
21061	6217	68	0	23335	\N
21133	264	3	0	23419	\N
21133	3632	4	0	23424	\N
21203	214	6	0	24420	\N
21224	411	2	0	25166	\N
21224	3370	3	0	25168	\N
21226	206	4	0	25912	\N
21226	3348	5	0	25913	\N
21211	42	2	0	27480	\N
21211	3310	3	0	27481	\N
21058	16	2	0	28882	\N
21058	388	3	0	28883	\N
21322	16	3	0	28901	\N
21327	16	3	0	28902	\N
21322	3634	4	0	28905	\N
21327	3634	4	0	28906	\N
21099	2844	4	0	30357	\N
21255	202	2	0	30983	\N
21255	2764	3	0	30985	\N
21261	360	8	0	31285	\N
21261	6257	9	0	31294	\N
21236	2	2	0	34948	\N
21236	2789	3	0	34949	\N
21294	2	6	0	34964	\N
21294	4825	7	0	34970	\N
21170	4	2	0	35859	\N
21170	2751	3	0	35863	\N
21049	18	3	0	40302	\N
21260	18	2	0	40311	\N
21260	1685	3	0	40312	\N
21112	23	3	0	40923	\N
21112	3497	4	0	40925	\N
21282	2714	5	0	41477	\N
21282	40	7	0	41486	\N
21282	1383	8	0	41487	\N
21016	56	5	0	44420	\N
21320	3259	5	0	44430	\N
21443	56	8	0	44435	\N
21443	2431	9	0	44436	\N
21390	71	3	0	44961	\N
21390	3770	4	0	44962	\N
21404	75	7	0	45788	\N
21404	3439	8	0	45789	\N
21420	75	3	0	45792	\N
21420	3855	4	0	45793	\N
21341	102	3	0	48105	\N
21341	3597	4	0	48106	\N
21363	5013	4	0	48108	\N
21363	102	7	0	48121	\N
21363	3574	8	0	48123	\N
21477	147	4	0	50107	\N
21477	3877	5	0	50114	\N
21503	273	4	0	53155	\N
21503	3390	5	0	53156	\N
21323	279	3	0	53176	\N
21323	3641	4	0	53177	\N
21508	279	4	0	53183	\N
21508	3502	5	0	53186	\N
21449	285	4	0	53416	\N
21449	5030	5	0	53417	\N
21461	316	3	0	54102	\N
21461	4249	4	0	54106	\N
21328	6271	4	0	55150	\N
21328	6270	3	0	55200	\N
21451	451	4	0	55213	\N
21451	3666	5	0	55214	\N
21488	451	3	0	55226	\N
21488	3934	4	0	55227	\N
21480	595	4	0	55814	\N
21480	3878	5	0	55817	\N
21416	5643	12	0	56597	\N
21416	6295	13	0	56603	\N
21407	2351	4	0	58941	\N
21407	3494	5	0	58944	\N
21466	2351	10	0	58947	\N
21466	5603	11	0	58948	\N
21295	6044	6	0	60617	\N
21295	6264	7	0	60620	\N
21313	6269	3	0	1095	\N
21514	3474	4	0	1160	\N
21522	3295	3	0	1722	\N
21522	6318	4	0	1724	\N
21321	110	4	0	2429	\N
21321	4552	5	0	2431	\N
21302	6265	106	0	3112	\N
21302	1636	126	0	3126	\N
21302	6266	127	0	3127	\N
21470	35	3	0	4156	\N
21470	3563	4	0	4158	\N
21388	365	4	0	4462	\N
21388	3298	5	0	4464	\N
21367	3992	5	0	4779	\N
21438	189	4	0	4787	\N
21438	3992	5	0	4788	\N
21472	189	3	0	4805	\N
21472	3782	4	0	4807	\N
21486	4178	3	0	6624	\N
21486	4211	4	0	6625	\N
21535	4178	3	0	6632	\N
21535	4211	4	0	6635	\N
21474	4172	0	0	8968	\N
21315	4172	4	0	9031	\N
21315	4252	5	0	9032	\N
21337	4275	4	0	9034	\N
21425	4172	4	0	9039	\N
21441	4172	6	0	9040	\N
21425	4219	5	0	9044	\N
21441	4365	7	0	9046	\N
21491	4172	1	0	9047	\N
21491	4201	2	0	9048	\N
21468	391	10	0	10926	\N
21468	6306	11	0	10932	\N
21409	1532	5	0	11058	\N
21409	6290	6	0	11060	\N
21377	132	4	0	11189	\N
21515	6314	108	0	12681	\N
21515	123	126	0	12686	\N
21515	6315	127	0	12693	\N
21414	92	3	0	14913	\N
21414	4410	4	0	14915	\N
21292	192	4	0	15457	\N
21292	3895	5	0	15463	\N
21356	235	3	0	15608	\N
21356	3343	4	0	15609	\N
21400	235	11	0	15612	\N
21400	6285	12	0	15617	\N
21304	44	3	0	15969	\N
21290	115	6	0	16887	\N
21290	4693	7	0	16888	\N
21306	115	3	0	16891	\N
21312	115	3	0	16893	\N
21306	3483	4	0	16900	\N
21312	3483	4	0	16901	\N
21519	212	3	0	17038	\N
21519	3639	4	0	17039	\N
21332	142	5	0	18465	\N
21332	6272	6	0	18468	\N
21328	3265	3	0	18758	\N
21365	3268	8	1	18785	\N
21374	62	4	0	19977	\N
21374	4059	5	0	19979	\N
21381	64	6	0	20899	\N
21381	5183	7	0	20901	\N
21515	6316	127	1	21775	\N
21297	149	3	0	23328	\N
21297	4189	4	0	23330	\N
21334	264	2	0	23420	\N
21335	264	4	0	23421	\N
21334	3026	3	0	23422	\N
21335	6274	5	0	23425	\N
21325	141	1	0	24248	\N
21325	140	4	0	24252	\N
21326	140	4	0	24253	\N
21325	2910	5	0	24254	\N
21326	2910	5	0	24255	\N
21481	140	4	0	24260	\N
21481	3821	5	0	24262	\N
21365	6280	8	0	25725	\N
21365	3348	4	0	25746	\N
21365	206	7	0	25763	\N
21309	244	3	0	27432	\N
21309	4075	4	0	27436	\N
21431	16	3	0	28911	\N
21416	6293	8	0	30865	\N
21416	6294	12	0	30870	\N
21428	453	10	0	32670	\N
21498	453	2	0	32671	\N
21498	3366	3	0	32672	\N
21428	5309	11	0	32673	\N
21344	2	6	0	34965	\N
21344	4825	7	0	34971	\N
21455	4	3	0	35878	\N
21455	3837	4	0	35879	\N
21351	14	6	0	39022	\N
21351	6277	7	0	39025	\N
21493	19	2	0	40340	\N
21526	18	1	0	40344	\N
21526	19	2	0	40345	\N
21495	40	3	0	41513	\N
21495	372	4	0	41514	\N
21501	40	2	0	41519	\N
21501	282	3	0	41521	\N
21151	56	5	0	44425	\N
21460	3855	4	0	45801	\N
21427	79	6	0	46525	\N
21427	4253	7	0	46528	\N
21525	79	3	0	46580	\N
21525	3652	4	0	46581	\N
21528	88	2	0	47056	\N
21530	88	3	0	47058	\N
21528	2799	3	0	47059	\N
21530	3655	4	0	47061	\N
21565	88	4	0	47074	\N
21565	3809	5	0	47077	\N
21584	102	3	0	48129	\N
21584	3597	4	0	48130	\N
21562	119	3	0	48508	\N
21562	2860	4	0	48512	\N
21353	156	4	0	50222	\N
21353	5935	5	0	50223	\N
21585	186	3	0	51175	\N
21585	4294	4	0	51184	\N
21343	260	6	0	52471	\N
21343	5311	7	0	52475	\N
21435	279	6	0	53182	\N
21435	5117	7	0	53187	\N
21437	285	1	0	53405	\N
21437	3112	2	0	53406	\N
21346	324	6	0	54473	\N
21346	5241	7	0	54474	\N
21555	416	3	0	54953	\N
21555	4423	4	0	54954	\N
21479	597	4	0	56087	\N
21479	3733	5	0	56097	\N
21395	1109	4	0	56296	\N
21395	3816	5	0	56303	\N
21568	1021	3	0	56424	\N
21568	4551	4	0	56427	\N
21463	793	3	0	56835	\N
21463	2644	4	0	56839	\N
21392	2519	127	0	58545	\N
21500	2636	2	0	58704	\N
21500	2836	3	0	58705	\N
21399	2782	11	0	59247	\N
21399	6284	12	0	59252	\N
21532	6320	4	1	59779	\N
21548	4233	2	0	59989	\N
21548	5577	3	0	59990	\N
21348	6276	13	0	60405	\N
21392	6283	126	1	60457	\N
21532	424	3	0	702	\N
21424	3474	4	0	1154	\N
21559	6331	3	0	1788	\N
21559	6332	4	0	1790	\N
21591	6337	106	0	3128	\N
21591	1636	126	0	3131	\N
21524	367	3	0	3278	\N
21524	3683	4	0	3281	\N
21465	262	10	0	3685	\N
21465	5412	11	0	3688	\N
21369	189	4	0	4778	\N
21369	3992	5	0	4781	\N
21458	4178	7	0	6618	\N
21483	4178	4	0	6620	\N
21485	4178	7	0	6621	\N
21483	4205	5	0	6622	\N
21485	4396	8	0	6623	\N
21497	4178	5	0	6626	\N
21497	4333	6	0	6627	\N
21502	4178	2	0	6628	\N
21502	4247	3	0	6630	\N
21408	4172	5	0	9035	\N
21408	6289	6	0	9036	\N
21446	4172	3	0	9041	\N
21446	4275	4	0	9043	\N
21521	4172	3	0	9051	\N
21517	4275	4	0	9054	\N
21521	4275	4	0	9055	\N
21564	4172	4	0	9057	\N
21564	4219	5	0	9058	\N
21360	391	19	0	10918	\N
21360	6279	20	0	10919	\N
21543	391	7	0	10927	\N
21543	6327	8	0	10929	\N
21476	528	10	0	12456	\N
21476	5604	11	0	12458	\N
21440	402	6	0	14296	\N
21552	402	2	0	14310	\N
21575	402	3	0	14311	\N
21552	3244	3	0	14312	\N
21575	4077	4	0	14313	\N
21582	92	11	0	14927	\N
21582	6333	12	0	14928	\N
21454	326	3	0	17585	\N
21454	3339	4	0	17586	\N
21386	167	3	0	17905	\N
21386	4028	4	0	17910	\N
21573	167	3	0	17938	\N
21573	4028	4	0	17939	\N
21532	3268	6	0	18786	\N
21392	6282	126	0	18843	\N
21392	6281	111	0	18854	\N
21392	290	125	0	18865	\N
21546	290	3	0	18867	\N
21546	364	4	0	18871	\N
21576	60	3	0	19661	\N
21576	3585	4	0	19666	\N
21566	62	4	0	19743	\N
21566	4059	5	0	19755	\N
21415	6292	8	0	20275	\N
21418	6292	8	0	20276	\N
21418	198	12	0	20286	\N
21415	3181	13	0	20287	\N
21418	3181	13	0	20288	\N
21539	241	3	0	20542	\N
21539	3613	4	0	20546	\N
21532	6319	4	0	21721	\N
21532	6322	6	1	21767	\N
21570	264	3	0	23432	\N
21570	3632	4	0	23434	\N
21554	6329	109	0	24618	\N
21553	69	2	0	24625	\N
21553	2920	3	0	24628	\N
21554	6330	127	0	24632	\N
21506	411	6	0	25149	\N
21506	6310	7	0	25150	\N
21549	411	2	0	25155	\N
21549	2988	3	0	25156	\N
21541	6325	108	0	26244	\N
21541	90	126	0	26252	\N
21541	6326	127	0	26253	\N
21560	94	3	0	26998	\N
21560	2864	4	0	26999	\N
21380	16	4	0	28904	\N
21380	3546	5	0	28907	\N
21537	3634	4	0	28917	\N
21430	20	3	0	30369	\N
21430	2844	4	0	30374	\N
21336	230	3	0	31983	\N
21336	4181	4	0	31987	\N
21413	322	3	0	32571	\N
21511	322	6	0	32572	\N
21413	1105	4	0	32573	\N
21511	6313	7	0	32575	\N
21397	18	2	0	40327	\N
21397	1685	3	0	40328	\N
21453	18	18	0	40331	\N
21490	40	2	0	41497	\N
21490	282	3	0	41498	\N
21340	56	5	0	44431	\N
21340	6275	6	0	44432	\N
21645	71	5	0	44964	\N
21494	75	2	0	45797	\N
21637	75	4	0	45799	\N
21494	284	3	0	45800	\N
21637	172	5	0	45803	\N
21362	5013	4	0	48107	\N
21362	102	7	0	48120	\N
21362	3574	8	0	48122	\N
21505	102	6	0	48128	\N
21505	6309	7	0	48131	\N
21439	135	5	0	49422	\N
21439	3347	6	0	49426	\N
21422	156	3	0	50230	\N
21422	4594	4	0	50231	\N
21613	181	3	0	51134	\N
21613	4184	4	0	51136	\N
21398	279	2	0	53181	\N
21398	4525	3	0	53185	\N
21520	316	4	0	54103	\N
21520	5437	5	0	54107	\N
21534	595	3	0	55815	\N
21534	3654	4	0	55816	\N
21464	793	3	0	56836	\N
21464	2644	4	0	56840	\N
21572	852	4	0	57438	\N
21572	4162	5	0	57439	\N
21406	2351	4	0	58940	\N
21406	3494	5	0	58943	\N
21445	2782	3	0	59249	\N
21445	3659	4	0	59251	\N
21510	2782	7	0	59257	\N
21510	6312	8	0	59258	\N
21561	3625	3	0	59581	\N
21561	3784	4	0	59588	\N
21355	4233	4	0	59983	\N
21355	4234	5	0	59985	\N
21545	4233	3	0	59988	\N
21545	4425	4	0	59991	\N
21536	3611	4	0	707	\N
21402	6287	12	0	2446	\N
21339	5514	4	0	3122	\N
21591	6266	127	0	3132	\N
21389	365	4	0	4463	\N
21389	3298	5	0	4465	\N
21366	4331	4	0	6602	\N
21394	4178	4	0	6605	\N
21394	4205	5	0	6607	\N
21366	4178	7	0	6608	\N
21366	4527	8	0	6611	\N
21608	4178	1	0	6637	\N
21608	4450	2	0	6638	\N
21631	4441	4	0	6647	\N
21473	4172	0	0	8964	\N
21419	4172	3	0	9037	\N
21419	4275	4	0	9038	\N
21448	4172	4	0	9042	\N
21448	4252	5	0	9045	\N
21551	4172	2	0	9052	\N
21551	4285	3	0	9053	\N
21597	4172	3	0	9062	\N
21597	4275	4	0	9063	\N
21599	4172	3	0	9064	\N
21622	4172	6	0	9066	\N
21622	4197	7	0	9073	\N
21383	391	7	0	10924	\N
21403	391	7	0	10925	\N
21383	3662	8	0	10931	\N
21403	6288	8	0	10933	\N
21574	391	6	0	10936	\N
21574	3521	7	0	10939	\N
21586	132	3	0	11198	\N
21586	3729	4	0	11199	\N
21602	132	3	0	11208	\N
21557	108	3	0	11900	\N
21557	4171	4	0	11901	\N
21484	3860	3	0	11939	\N
21606	2396	0	0	11995	\N
21516	123	3	0	12684	\N
21516	2856	4	0	12685	\N
21593	6339	6	0	12973	\N
21593	6340	7	0	12975	\N
21371	58	6	0	13655	\N
21371	3575	7	0	13657	\N
21396	58	3	0	13666	\N
21396	3665	4	0	13667	\N
21412	92	3	0	14912	\N
21412	4410	4	0	14914	\N
21592	5215	4	0	15960	\N
21592	44	8	0	15974	\N
21592	6338	9	0	15975	\N
21518	6317	46	0	17025	\N
21518	212	126	0	17041	\N
21518	6268	127	0	17042	\N
21350	326	4	0	17583	\N
21350	3519	5	0	17584	\N
21385	167	3	0	17904	\N
21387	167	3	0	17906	\N
21385	4028	4	0	17909	\N
21387	4028	4	0	17911	\N
21606	6341	0	0	18875	\N
21507	208	4	0	19191	\N
21507	6311	5	0	19199	\N
21499	1107	2	0	19340	\N
21499	6308	3	0	19341	\N
21373	62	4	0	19976	\N
21373	4059	5	0	19978	\N
21540	241	2	0	20543	\N
21540	634	3	0	20544	\N
21547	1018	0	0	21804	\N
21469	145	3	0	21811	\N
21487	145	3	0	21812	\N
21504	1108	3	0	21814	\N
21469	4908	4	0	21818	\N
21487	4908	4	0	21819	\N
21635	149	5	0	23339	\N
21635	6348	6	0	23341	\N
21376	264	4	0	23430	\N
21376	3684	5	0	23435	\N
21467	140	10	0	24259	\N
21467	6305	11	0	24263	\N
21579	69	3	0	24627	\N
21579	4536	4	0	24630	\N
21434	94	6	0	26987	\N
21364	2575	4	0	28900	\N
21359	16	19	0	28903	\N
21364	16	7	0	28908	\N
21364	2974	8	0	28909	\N
21359	5512	20	0	28910	\N
21605	54	3	0	30293	\N
21605	3041	4	0	30297	\N
21615	20	3	0	30370	\N
21615	2844	4	0	30375	\N
21625	360	6	0	31288	\N
21625	5788	7	0	31292	\N
21628	322	3	0	32576	\N
21581	431	1	0	34848	\N
21581	432	2	0	34849	\N
21457	14	7	0	39037	\N
21457	3882	8	0	39038	\N
21643	14	3	0	39052	\N
21643	4272	4	0	39055	\N
21527	23	6	0	40718	\N
21527	4632	7	0	40719	\N
21513	40	4	0	41520	\N
21513	3381	5	0	41522	\N
21357	56	10	0	44433	\N
21357	4602	11	0	44434	\N
21544	56	9	0	44437	\N
21544	5173	10	0	44438	\N
21423	79	3	0	46524	\N
21423	3652	4	0	46526	\N
21542	79	10	0	46623	\N
21542	4707	11	0	46624	\N
21529	88	3	0	47057	\N
21529	3655	4	0	47060	\N
21444	100	6	0	47513	\N
21444	6298	7	0	47514	\N
21659	102	3	0	48137	\N
21659	3597	4	0	48139	\N
21496	113	5	0	48185	\N
21496	6307	6	0	48191	\N
21533	147	3	0	50108	\N
21533	3657	4	0	50112	\N
21588	156	3	0	50238	\N
21588	4594	4	0	50239	\N
21654	181	9	0	51135	\N
21654	6359	10	0	51137	\N
21610	242	5	0	52044	\N
21610	6342	6	0	52045	\N
21436	285	7	0	53404	\N
21436	5812	8	0	53407	\N
21450	285	11	0	53415	\N
21450	6299	12	0	53418	\N
21633	316	4	0	54110	\N
21633	2790	5	0	54111	\N
21401	324	11	0	54476	\N
21462	324	3	0	54477	\N
21462	4514	4	0	54479	\N
21401	6286	12	0	54482	\N
21432	1021	3	0	56423	\N
21432	4551	4	0	56426	\N
21617	793	3	0	56845	\N
21617	2644	4	0	56847	\N
21456	1675	43	0	58103	\N
21492	2351	2	0	58953	\N
21492	2754	3	0	58957	\N
21421	2782	3	0	59248	\N
21421	3659	4	0	59250	\N
21563	3628	2	0	59637	\N
21563	4360	3	0	59638	\N
21354	4233	4	0	59982	\N
21354	4234	5	0	59984	\N
21583	4787	11	0	60284	\N
21583	6334	12	0	60289	\N
21652	4787	3	0	60304	\N
21652	4788	4	0	60306	\N
21452	6044	3	0	60618	\N
21452	6045	4	0	60619	\N
21630	6044	3	0	60621	\N
21630	6045	4	0	60622	\N
21538	6324	2	0	3215	\N
21523	3329	3	0	3280	\N
21595	35	6	0	4157	\N
21595	5084	7	0	4159	\N
21368	189	4	0	4777	\N
21368	3992	5	0	4780	\N
21410	4178	3	0	6612	\N
21426	4178	4	0	6613	\N
21426	4205	5	0	6614	\N
21410	5202	4	0	6615	\N
21429	4178	10	0	6616	\N
21429	4665	11	0	6617	\N
21509	4178	3	0	6629	\N
21550	4178	3	0	6633	\N
21550	4941	4	0	6634	\N
21569	4178	3	0	6636	\N
21569	4211	4	0	6639	\N
21621	4178	4	0	6640	\N
21621	4331	5	0	6643	\N
21475	4172	0	0	8976	\N
21512	4172	4	0	9049	\N
21512	4219	5	0	9056	\N
21590	4252	4	0	9059	\N
21590	4172	8	0	9060	\N
21558	391	3	0	10928	\N
21580	391	8	0	10950	\N
21580	3922	9	0	10953	\N
21375	132	4	0	11188	\N
21375	3716	5	0	11190	\N
21602	3729	4	0	11210	\N
21384	300	3	0	12045	\N
21384	3747	4	0	12047	\N
21647	1132	4	0	13024	\N
21647	77	9	0	13035	\N
21647	6352	10	0	13037	\N
21370	58	6	0	13654	\N
21370	3575	7	0	13656	\N
21604	4077	4	0	14321	\N
21372	192	4	0	15458	\N
21378	192	0	0	15459	\N
21372	3895	5	0	15464	\N
21391	290	3	0	18857	\N
21391	3635	4	0	18859	\N
21577	60	3	0	19662	\N
21577	3585	4	0	19667	\N
21666	6362	89	0	20969	\N
21664	164	1	0	20981	\N
21664	165	2	0	20983	\N
21590	6322	11	0	21816	\N
21433	3040	4	0	22405	\N
21405	336	4	0	22958	\N
21405	3947	5	0	22960	\N
21567	264	2	0	23431	\N
21567	2780	3	0	23433	\N
21447	5024	5	0	23703	\N
21447	82	8	0	23709	\N
21447	4753	9	0	23710	\N
21393	140	4	0	24258	\N
21393	3821	5	0	24261	\N
21482	214	4	0	24432	\N
21482	3807	5	0	24441	\N
21578	70	2	0	24629	\N
21571	90	2	0	26247	\N
21571	3039	3	0	26249	\N
21459	6303	3	0	26321	\N
21459	6304	4	0	26322	\N
21489	2575	4	0	28913	\N
21489	16	5	0	28914	\N
21417	6296	8	0	30866	\N
21417	151	13	0	30871	\N
21417	6297	14	0	30872	\N
21601	453	3	0	32688	\N
21601	2838	4	0	32691	\N
21478	3510	5	0	34968	\N
21456	6301	42	0	35902	\N
21456	6302	43	0	35909	\N
21352	6277	7	0	39026	\N
21471	14	3	0	39045	\N
21471	4272	4	0	39046	\N
21556	14	3	0	39051	\N
21556	4272	4	0	39054	\N
21358	18	7	0	40317	\N
21358	6278	8	0	40320	\N
21619	18	0	0	40362	\N
21382	23	7	0	40931	\N
21411	6291	106	0	41313	\N
21411	27	123	0	41314	\N
21411	1502	124	0	41315	\N
21361	2796	4	0	41488	\N
21361	40	7	0	41499	\N
21361	3034	8	0	41500	\N
21650	40	3	0	41537	\N
21650	372	4	0	41539	\N
21834	2795	3	0	44447	\N
21642	71	3	0	44963	\N
21642	3770	4	0	44965	\N
21620	75	0	0	45754	\N
21589	75	3	0	45798	\N
21589	3855	4	0	45802	\N
21795	6402	39	0	47516	\N
21795	100	126	0	47530	\N
21795	6403	127	0	47531	\N
21785	121	3	0	48817	\N
21785	4471	4	0	48823	\N
21741	135	6	0	49452	\N
21741	6389	7	0	49459	\N
21851	156	3	0	50247	\N
21851	4594	4	0	50250	\N
21600	181	3	0	51131	\N
21600	4184	4	0	51133	\N
21609	200	3	0	51472	\N
21609	3338	4	0	51475	\N
21677	273	4	0	53159	\N
21677	3390	5	0	53160	\N
21653	6357	91	0	55111	\N
21653	435	126	0	55117	\N
21653	6358	127	0	55118	\N
21846	6413	91	0	55119	\N
21846	435	126	0	55131	\N
21846	6358	127	0	55132	\N
21824	1470	6	0	58162	\N
21824	6409	7	0	58163	\N
21788	3522	3	0	58546	\N
21788	3526	4	1	58573	\N
21832	2351	2	0	58954	\N
21832	2754	3	0	58958	\N
21587	4233	3	0	59996	\N
21587	4425	4	0	59998	\N
21818	4787	6	0	60305	\N
21818	5075	7	0	60307	\N
21680	3459	15	0	481	\N
21754	6391	8	0	501	\N
21784	251	2	0	1434	\N
21784	1851	3	0	1435	\N
21708	117	3	0	2041	\N
21708	3653	4	0	2042	\N
21641	110	3	0	2452	\N
21641	2995	4	0	2455	\N
21675	110	3	0	2462	\N
21675	2995	4	0	2463	\N
21624	262	6	0	3686	\N
21624	4248	7	0	3687	\N
21790	189	8	0	4806	\N
21627	4178	2	0	6641	\N
21627	4247	3	0	6642	\N
21702	4178	3	0	6645	\N
21702	4211	4	0	6646	\N
21590	6336	9	1	9061	\N
21611	4172	3	0	9065	\N
21656	4172	3	0	9068	\N
21611	4275	4	0	9070	\N
21656	4275	4	0	9072	\N
21663	4172	4	0	9074	\N
21663	4252	5	0	9075	\N
21798	4172	6	0	9084	\N
21802	4172	6	0	9086	\N
21813	4172	6	0	9087	\N
21802	4197	7	0	9091	\N
21813	4197	7	0	9092	\N
21629	132	8	0	11209	\N
21629	6347	9	0	11211	\N
21756	132	3	0	11221	\N
21773	132	3	0	11222	\N
21844	132	6	0	11223	\N
21756	3729	4	0	11224	\N
21773	3729	4	0	11225	\N
21844	4690	7	0	11226	\N
21640	6350	5	0	12048	\N
21705	123	3	0	12690	\N
21705	2856	4	0	12692	\N
21596	6339	6	0	12974	\N
21596	6340	7	0	12976	\N
21612	173	3	0	14857	\N
21612	3796	4	0	14858	\N
21750	44	3	0	15970	\N
21750	3631	4	0	15973	\N
21837	38	3	0	16268	\N
21837	3457	4	0	16275	\N
21598	115	3	0	16894	\N
21732	212	0	0	17047	\N
21590	5963	10	0	17940	\N
21607	290	3	0	18868	\N
21607	3635	4	0	18869	\N
21632	290	3	0	18876	\N
21634	290	4	0	18877	\N
21632	504	4	0	18883	\N
21634	2759	5	0	18885	\N
21770	64	3	0	20906	\N
21770	4217	4	0	20910	\N
21805	164	6	0	20995	\N
21805	3583	7	0	20997	\N
21618	488	126	0	21438	\N
21618	6344	127	0	21439	\N
21636	149	6	0	23340	\N
21636	6349	7	0	23342	\N
21700	82	2	0	23717	\N
21700	3401	3	0	23720	\N
21736	140	9	0	24267	\N
21736	6384	10	0	24269	\N
21668	69	6	0	24637	\N
21668	4084	7	0	24647	\N
21788	6398	4	0	25969	\N
21788	6397	3	0	26245	\N
21726	6381	3	0	26324	\N
21691	6375	9	0	27482	\N
21768	42	6	0	27489	\N
21768	1090	7	0	27490	\N
21691	42	12	0	27491	\N
21691	3440	13	0	27492	\N
21616	16	3	0	28916	\N
21616	3634	4	0	28918	\N
21739	16	6	0	28926	\N
21763	16	4	0	28928	\N
21763	3546	5	0	28931	\N
21739	3369	7	0	28932	\N
21840	3634	4	0	28938	\N
21860	449	3	0	29782	\N
21603	54	2	0	30292	\N
21603	3351	3	0	30296	\N
21854	202	9	0	30999	\N
21854	3798	10	0	31002	\N
21626	6345	107	0	31275	\N
21623	360	4	0	31287	\N
21623	4330	5	0	31291	\N
21626	360	126	0	31296	\N
21626	6346	127	0	31297	\N
21638	230	4	0	31985	\N
21638	3954	5	0	31989	\N
21639	3389	6	0	31990	\N
21689	453	5	0	32690	\N
21689	6370	6	0	32693	\N
21644	14	5	0	39053	\N
21644	6351	6	0	39056	\N
21594	18	2	0	40359	\N
21594	3817	3	0	40360	\N
21614	40	3	0	41529	\N
21614	372	4	0	41530	\N
21703	40	12	0	41538	\N
21703	5640	13	0	41540	\N
21678	56	3	0	44439	\N
21678	4109	4	0	44440	\N
21682	56	3	0	44441	\N
21682	4109	4	0	44442	\N
21645	4033	6	0	44966	\N
21899	71	6	0	44968	\N
21899	4738	7	0	44970	\N
21762	75	3	0	45806	\N
21849	75	9	0	45807	\N
21762	3855	4	0	45809	\N
21849	4685	10	0	45810	\N
21707	79	8	0	46620	\N
21707	6378	9	0	46622	\N
21835	79	6	0	46659	\N
21835	4253	7	0	46660	\N
21863	79	3	0	46693	\N
21863	3652	4	0	46694	\N
21906	79	3	0	46732	\N
21906	3652	4	0	46733	\N
21749	88	3	0	47086	\N
21749	3655	4	0	47087	\N
21671	102	6	0	48140	\N
21671	5086	7	0	48141	\N
21686	119	1	0	48509	\N
21686	891	2	0	48513	\N
21740	137	6	0	49665	\N
21740	6388	7	0	49675	\N
21779	242	3	0	52060	\N
21779	2839	4	0	52062	\N
21777	324	6	0	54478	\N
21777	5241	7	0	54481	\N
21886	451	3	0	55242	\N
21886	3934	4	0	55243	\N
21875	6425	18	0	56286	\N
21875	1109	19	0	56304	\N
21657	1021	4	0	56425	\N
21657	6360	5	0	56428	\N
21799	841	6	0	56937	\N
21799	3769	7	0	56945	\N
21720	2636	3	0	58716	\N
21720	2837	4	0	58717	\N
21911	2351	3	0	58955	\N
21683	3625	4	0	59582	\N
21694	3625	6	0	59583	\N
21694	3642	7	0	59592	\N
21683	6161	5	0	59595	\N
21669	4233	6	0	59997	\N
21669	6364	7	0	59999	\N
21870	6418	125	0	60462	\N
21825	5885	6	0	60489	\N
21825	5997	7	0	60490	\N
21870	6417	124	1	60603	\N
21752	4204	4	0	498	\N
21822	6407	13	0	2049	\N
21870	6419	126	0	2338	\N
21811	1858	3	0	3023	\N
21811	4273	4	0	3028	\N
21809	35	3	0	4164	\N
21809	3563	4	0	4165	\N
21861	365	3	0	4479	\N
21861	3839	4	0	4481	\N
21870	4916	126	1	5287	\N
21722	4178	3	0	6649	\N
21722	4211	4	0	6650	\N
21729	4178	0	0	6652	\N
21738	4250	7	0	6654	\N
21791	4178	7	0	6658	\N
21816	4178	6	0	6660	\N
21791	6399	8	0	6661	\N
21816	4250	7	0	6663	\N
21876	4178	3	0	6668	\N
21876	4211	4	0	6670	\N
21893	4178	3	0	6671	\N
21893	4211	4	0	6678	\N
21648	4172	3	0	9067	\N
21648	4275	4	0	9071	\N
21755	4172	3	0	9077	\N
21833	4172	2	0	9089	\N
21833	4191	3	0	9090	\N
21878	4172	3	0	9095	\N
21878	4275	4	0	9097	\N
21883	4172	3	0	9098	\N
21888	4172	3	0	9099	\N
21883	4275	4	0	9100	\N
21888	4275	4	0	9101	\N
21733	6382	40	0	10966	\N
21733	391	126	0	10973	\N
21733	6383	127	0	10974	\N
21704	123	2	0	12689	\N
21841	233	3	0	13938	\N
21841	3704	4	0	13944	\N
21873	235	8	0	15613	\N
21874	235	8	0	15614	\N
21873	6424	9	0	15615	\N
21874	6424	9	0	15616	\N
21743	326	3	0	17324	\N
21743	3339	4	0	17326	\N
21870	4952	125	1	18224	\N
21710	290	5	0	18878	\N
21710	6379	6	0	18886	\N
21767	60	6	0	19366	\N
21845	241	6	0	20557	\N
21845	6412	7	0	20560	\N
21665	164	3	0	20982	\N
21665	3385	4	0	20984	\N
21870	4098	127	0	21815	\N
21889	145	3	0	21831	\N
21889	4908	4	0	21834	\N
21814	149	6	0	23348	\N
21814	4737	7	0	23349	\N
21734	140	9	0	24266	\N
21734	6384	10	0	24268	\N
21885	411	3	0	25179	\N
21793	94	7	0	27001	\N
21793	6401	8	0	27002	\N
21870	6416	124	0	27448	\N
21870	1009	12	0	27483	\N
21870	42	123	0	27493	\N
21714	16	6	0	28920	\N
21717	16	12	0	28921	\N
21714	3369	7	0	28922	\N
21717	4890	13	0	28924	\N
21884	16	3	0	28939	\N
21884	3634	4	0	28940	\N
21897	16	3	0	28942	\N
21904	96	3	0	29438	\N
21904	2803	4	0	29440	\N
21860	4760	4	0	29783	\N
21660	33	2	0	31689	\N
21662	33	3	0	31691	\N
21660	2822	3	0	31692	\N
21662	3342	4	0	31694	\N
21819	2	6	0	34989	\N
21819	4825	7	0	34996	\N
21865	4823	3	0	36244	\N
21866	6	1	0	36251	\N
21866	2261	2	0	36252	\N
21868	4272	3	0	39059	\N
21868	14	4	0	39067	\N
21676	18	0	0	40365	\N
21747	40	3	0	41560	\N
21747	372	4	0	41561	\N
21760	40	2	0	41570	\N
21760	282	3	0	41571	\N
21803	40	6	0	41580	\N
21847	40	9	0	41581	\N
21803	4255	7	0	41588	\N
21847	4712	10	0	41590	\N
21320	56	4	0	44429	\N
21914	1088	2	0	44445	\N
21744	71	3	0	44967	\N
21744	3770	4	0	44969	\N
21651	6354	3	0	48133	\N
21649	102	3	0	48134	\N
21649	3597	4	0	48136	\N
21672	102	0	0	48138	\N
21850	113	3	0	48186	\N
21850	3620	4	0	48189	\N
21687	119	1	0	48510	\N
21695	119	4	0	48511	\N
21687	891	2	0	48514	\N
21695	4373	5	0	48515	\N
21792	125	68	0	49169	\N
21792	6400	69	0	49179	\N
21905	126	3	0	49180	\N
21701	242	3	0	52059	\N
21701	2839	4	0	52061	\N
21797	285	6	0	53433	\N
21797	3903	7	0	53438	\N
21699	316	3	0	54112	\N
21699	4249	4	0	54113	\N
21902	316	3	0	54114	\N
21902	4249	4	0	54115	\N
21820	793	6	0	56846	\N
21820	3719	7	0	56848	\N
21919	841	6	0	56938	\N
21919	3769	7	0	56946	\N
21929	2782	2	0	59262	\N
21929	2784	3	0	59263	\N
21758	4233	3	0	60012	\N
21758	4425	4	0	60013	\N
21651	6353	3	0	60738	\N
21679	4204	4	0	480	\N
21937	5037	4	0	1098	\N
21858	251	3	0	1448	\N
21858	3514	4	0	1452	\N
21718	3101	3	0	1887	\N
21718	6380	4	0	1888	\N
21812	1858	3	0	3024	\N
21812	4273	4	0	3029	\N
21810	365	3	0	4478	\N
21810	3839	4	0	4480	\N
21907	365	6	0	4488	\N
21907	4759	7	0	4489	\N
21774	4178	3	0	6655	\N
21853	4178	9	0	6665	\N
21853	4682	10	0	6666	\N
21896	4178	3	0	6672	\N
21932	4178	2	0	6674	\N
21932	4247	3	0	6677	\N
21896	4211	4	0	6679	\N
21725	4172	2	0	9076	\N
21725	4285	3	0	9078	\N
21761	4172	3	0	9080	\N
21761	4275	4	0	9082	\N
21839	4172	3	0	9094	\N
21839	4275	4	0	9096	\N
21901	3729	4	0	11239	\N
21895	459	4	0	11946	\N
21895	6428	5	0	11947	\N
21765	348	3	0	12319	\N
21765	6393	4	0	12320	\N
21646	1132	4	0	13023	\N
21646	77	9	0	13034	\N
21646	6352	10	0	13036	\N
21848	58	9	0	13676	\N
21848	3755	10	0	13681	\N
21916	93	2	0	14939	\N
21916	92	7	0	14956	\N
21843	326	3	0	17325	\N
21843	3339	4	0	17327	\N
21829	167	6	0	17941	\N
21829	5066	7	0	17942	\N
21737	4952	127	1	18231	\N
21723	290	3	0	18896	\N
21723	3635	4	0	18902	\N
21715	208	6	0	19210	\N
21827	208	6	0	19211	\N
21856	208	9	0	19212	\N
21880	208	6	0	19213	\N
21909	208	6	0	19214	\N
21827	5118	7	0	19221	\N
21880	5118	7	0	19222	\N
21909	5118	7	0	19223	\N
21856	4893	10	0	19224	\N
21674	60	3	0	19663	\N
21674	3585	4	0	19668	\N
21882	198	6	0	20304	\N
21882	5565	7	0	20305	\N
21806	164	12	0	20996	\N
21806	6405	13	0	20998	\N
21737	6387	127	0	21387	\N
21737	6386	62	0	21427	\N
21872	6422	0	0	21629	\N
21887	67	3	0	22099	\N
21887	3749	4	0	22100	\N
21735	264	9	0	23442	\N
21772	264	3	0	23443	\N
21735	6385	10	0	23444	\N
21772	3632	4	0	23445	\N
21667	69	4	0	24636	\N
21667	3564	5	0	24646	\N
21712	411	3	0	25161	\N
21712	3596	4	0	25162	\N
21801	224	3	0	25422	\N
21787	90	3	0	26248	\N
21787	4074	4	0	26251	\N
21808	244	6	0	27434	\N
21808	6406	7	0	27439	\N
21869	42	0	0	27508	\N
21872	6423	0	0	27515	\N
21655	16	9	0	28919	\N
21655	3636	10	0	28923	\N
21721	16	3	0	28925	\N
21748	16	3	0	28927	\N
21721	3634	4	0	28929	\N
21748	3634	4	0	28930	\N
21775	3636	10	0	28934	\N
21943	16	7	0	28947	\N
21903	96	3	0	29437	\N
21903	2803	4	0	29439	\N
21730	151	0	0	30869	\N
21877	1163	3	0	30938	\N
21877	6426	4	0	30940	\N
21661	33	3	0	31690	\N
21661	3342	4	0	31693	\N
21781	33	3	0	31704	\N
21892	33	3	0	31706	\N
21781	3342	4	0	31708	\N
21670	453	6	0	32689	\N
21670	4091	7	0	32692	\N
21862	453	3	0	32702	\N
21862	2838	4	0	32703	\N
21697	2	5	0	34967	\N
21697	6376	6	0	34969	\N
21658	4	4	0	35898	\N
21658	6361	5	0	35899	\N
21764	18	0	0	40368	\N
21800	18	0	0	40371	\N
21684	23	4	0	40724	\N
21684	6367	5	0	40727	\N
21923	6432	22	0	40741	\N
21900	40	3	0	41582	\N
21900	372	4	0	41587	\N
21834	56	2	0	44443	\N
21917	56	3	0	44450	\N
21713	75	2	0	45805	\N
21713	284	3	0	45808	\N
21910	75	3	0	45813	\N
21910	3855	4	0	45814	\N
21706	79	5	0	46619	\N
21706	6377	6	0	46621	\N
21693	88	3	0	47075	\N
21693	3655	4	0	47076	\N
21796	1525	13	0	47515	\N
21796	100	121	0	47528	\N
21796	6404	122	0	47529	\N
21728	102	2	0	48142	\N
21728	3574	3	0	48143	\N
21852	113	3	0	48187	\N
21852	3620	4	0	48190	\N
21783	121	3	0	48816	\N
21783	4471	4	0	48822	\N
21905	6429	127	0	49183	\N
21905	125	126	0	49193	\N
21940	137	3	0	49667	\N
21940	3633	4	0	49672	\N
21766	156	3	0	50246	\N
21766	4594	4	0	50249	\N
21931	156	5	0	50256	\N
21931	4295	6	0	50258	\N
21817	273	6	0	53161	\N
21817	4212	7	0	53163	\N
21716	279	6	0	53184	\N
21716	5117	7	0	53188	\N
21826	279	6	0	53191	\N
21855	279	9	0	53192	\N
21879	279	6	0	53193	\N
21826	5117	7	0	53194	\N
21879	5117	7	0	53195	\N
21855	4892	10	0	53196	\N
21908	279	6	0	53199	\N
21908	5117	7	0	53202	\N
21780	285	3	0	53432	\N
21780	4496	4	0	53436	\N
21912	2351	0	0	58956	\N
21927	2782	3	0	59261	\N
21927	3659	4	0	59264	\N
21685	3628	4	0	59661	\N
21688	3628	7	0	59662	\N
21685	6368	5	0	59663	\N
21688	6369	8	0	59664	\N
21696	3628	6	0	59675	\N
21696	3643	7	0	59679	\N
21842	4088	3	0	59907	\N
21936	4088	3	0	59908	\N
21842	4506	4	0	59916	\N
21936	4506	4	0	59917	\N
21753	6390	100	0	60000	\N
21751	4233	3	0	60005	\N
21751	4425	4	0	60006	\N
21753	4233	101	0	60007	\N
21759	4233	9	0	60014	\N
21759	6392	10	0	60015	\N
21690	6373	13	1	60736	\N
21924	367	3	0	3279	\N
21836	1970	120	0	5131	\N
21709	4178	5	0	6648	\N
21709	4429	6	0	6651	\N
21789	4178	8	0	6657	\N
21804	4178	6	0	6659	\N
21804	4250	7	0	6662	\N
21789	4218	9	0	6664	\N
21857	4178	3	0	6667	\N
21857	4211	4	0	6669	\N
21794	4172	6	0	9081	\N
21794	4197	7	0	9083	\N
21823	4172	12	0	9088	\N
21681	6365	40	0	10954	\N
21681	391	126	0	10964	\N
21681	6366	127	0	10965	\N
21776	6395	40	0	10975	\N
21776	391	70	0	10986	\N
21776	6396	71	0	10987	\N
21786	3340	2	0	11902	\N
21786	108	4	0	11907	\N
21786	3022	5	0	11908	\N
21864	6414	4	0	12371	\N
21673	77	3	0	13044	\N
21673	1877	4	0	13045	\N
21898	3606	7	0	14861	\N
21757	6099	3	0	14936	\N
21757	4410	4	0	14937	\N
21915	93	2	0	14938	\N
21915	92	7	0	14955	\N
21915	6430	8	0	14957	\N
21831	44	9	0	15971	\N
21831	3765	10	0	15976	\N
21836	6410	112	0	16263	\N
21836	38	119	0	16282	\N
21836	6411	120	1	16581	\N
21871	3108	12	1	18796	\N
21711	504	4	0	18884	\N
21771	198	3	0	20294	\N
21771	4263	4	0	20295	\N
21666	164	126	0	20985	\N
21666	6363	127	0	20986	\N
21871	6025	11	1	21727	\N
21690	6374	14	0	21817	\N
21905	1075	127	1	21823	\N
21698	145	3	0	21830	\N
21698	4908	4	0	21833	\N
21871	1075	35	1	21948	\N
21742	73	3	0	22412	\N
21690	6372	13	0	23023	\N
21690	6371	9	0	23332	\N
21692	6371	9	0	23333	\N
21690	149	12	0	23343	\N
21692	149	12	0	23344	\N
21692	5008	13	0	23345	\N
21838	264	3	0	23454	\N
21838	3632	4	0	23455	\N
21731	214	0	0	24433	\N
21934	214	2	0	24434	\N
21934	1259	3	0	24438	\N
21859	206	3	0	25761	\N
21769	94	6	0	27000	\N
21769	4696	7	0	27003	\N
21807	94	6	0	27004	\N
21807	4696	7	0	27005	\N
21871	6420	11	0	27447	\N
21871	6421	35	0	27464	\N
21871	42	34	0	27509	\N
21828	16	2	0	28935	\N
21828	2974	3	0	28937	\N
21894	16	3	0	28941	\N
21894	3634	4	0	28943	\N
21727	20	2	0	30371	\N
21891	33	2	0	31705	\N
21891	6427	3	0	31707	\N
21724	322	3	0	32577	\N
21746	322	3	0	32578	\N
21724	1105	4	0	32580	\N
21746	1105	4	0	32581	\N
21864	4272	3	0	39057	\N
21867	4272	3	0	39058	\N
21864	6415	4	0	39064	\N
21867	14	4	0	39066	\N
21745	23	3	0	40725	\N
21745	3497	4	0	40726	\N
21719	372	4	0	41546	\N
21920	40	6	0	41583	\N
21914	56	1	0	44444	\N
22004	4109	4	0	44452	\N
22042	56	4	0	44453	\N
22082	56	69	0	44454	\N
22042	3127	5	0	44460	\N
22082	6454	70	0	44464	\N
21944	75	3	0	45819	\N
21944	3855	4	0	45820	\N
21958	75	9	0	45831	\N
21958	4685	10	0	45832	\N
22034	75	3	0	45836	\N
22034	3855	4	0	45838	\N
21956	79	9	0	46756	\N
21957	79	9	0	46757	\N
21956	3758	10	0	46760	\N
21957	3758	10	0	46761	\N
21999	6439	127	0	49184	\N
21999	126	3	0	49194	\N
21999	125	126	0	49201	\N
21928	135	3	0	49453	\N
21939	135	3	0	49454	\N
21928	3630	4	0	49456	\N
21939	3630	4	0	49457	\N
21930	137	3	0	49666	\N
21930	3633	4	0	49671	\N
21959	242	9	0	52068	\N
21959	6434	10	0	52072	\N
22056	324	0	0	54485	\N
21951	1021	9	0	56435	\N
21951	6433	10	0	56437	\N
21921	841	4	0	56939	\N
21921	6431	5	0	56942	\N
21974	908	6	0	57569	\N
21976	908	6	0	57570	\N
21974	3555	7	0	57571	\N
21976	3555	7	0	57572	\N
22049	1470	4	0	58170	\N
22049	5655	5	0	58172	\N
22118	5233	7	0	58174	\N
22118	1470	8	0	58185	\N
21911	2845	4	0	58959	\N
21965	2782	3	0	59267	\N
21968	2782	6	0	59268	\N
21965	3659	4	0	59272	\N
21968	5009	7	0	59274	\N
22142	6471	5	0	59443	\N
22163	4787	13	0	60310	\N
22165	4787	3	0	60311	\N
22165	4788	4	0	60312	\N
22163	6479	14	0	60313	\N
21971	228	0	0	2746	\N
22029	4776	3	0	2748	\N
22100	719	7	0	5174	\N
22100	6458	8	0	5175	\N
21925	4178	3	0	6673	\N
21950	4178	9	0	6676	\N
21925	4211	4	0	6680	\N
21950	4682	10	0	6682	\N
21953	4178	6	0	6683	\N
21953	4250	7	0	6684	\N
21997	4178	3	0	6691	\N
21997	4211	4	0	6692	\N
22032	4178	2	0	6700	\N
22032	4247	3	0	6702	\N
22039	4247	3	0	6703	\N
22146	4178	4	0	6715	\N
22146	4205	5	0	6716	\N
22149	4178	3	0	6717	\N
22149	4211	4	0	6718	\N
22158	4178	2	0	6720	\N
22158	4247	3	0	6721	\N
21941	4172	3	0	9102	\N
21941	4275	4	0	9103	\N
21945	4172	3	0	9104	\N
21945	4275	4	0	9105	\N
22022	4275	4	0	9112	\N
22058	4172	3	0	9114	\N
22058	4275	4	0	9117	\N
22108	4172	3	0	9120	\N
22108	4275	4	0	9122	\N
22123	4172	3	0	9126	\N
22123	4275	4	0	9129	\N
22011	455	1	0	11228	\N
22011	132	4	0	11237	\N
22011	2927	5	0	11240	\N
22145	300	7	0	12052	\N
22145	5054	8	0	12055	\N
22024	2856	4	0	12707	\N
21926	58	3	0	13677	\N
21926	3665	4	0	13679	\N
21938	233	3	0	13939	\N
22018	233	4	0	13940	\N
21938	3704	4	0	13945	\N
22018	3775	5	0	13946	\N
22168	173	5	0	14865	\N
22168	6480	6	0	14868	\N
22097	92	3	0	14985	\N
22097	4410	4	0	14986	\N
22172	235	4	0	15620	\N
21978	4254	4	0	18479	\N
22110	198	3	0	20308	\N
22110	4263	4	0	20309	\N
22060	1098	3	0	20330	\N
22060	6446	4	0	20331	\N
22091	241	2	0	20568	\N
22091	2923	3	0	20569	\N
22131	64	6	0	20909	\N
22131	5183	7	0	20913	\N
21999	1075	127	1	21840	\N
21918	73	6	0	22413	\N
21918	4257	7	0	22415	\N
21987	264	3	0	23462	\N
21987	3632	4	0	23463	\N
22139	224	3	0	25449	\N
22139	3603	4	0	25450	\N
21933	16	2	0	28945	\N
21933	388	3	0	28946	\N
21947	16	3	0	28949	\N
22077	16	6	0	28951	\N
21947	3634	4	0	28952	\N
22077	3369	7	0	28954	\N
22094	16	3	0	28955	\N
22102	16	3	0	28956	\N
22102	3634	4	0	28958	\N
22152	54	10	0	30032	\N
22155	54	10	0	30033	\N
22152	6472	11	0	30034	\N
22155	6472	11	0	30035	\N
21990	54	3	0	30294	\N
21990	3041	4	0	30298	\N
22061	20	10	0	30372	\N
22061	6447	11	0	30376	\N
22076	322	6	0	32586	\N
22076	6453	7	0	32588	\N
22009	26	1	0	34972	\N
22009	2990	5	0	34995	\N
22068	2	6	0	35025	\N
22068	4825	7	0	35026	\N
21913	14	3	0	39065	\N
21913	4272	4	0	39068	\N
22045	18	14	0	40318	\N
22045	1513	15	0	40319	\N
22092	6456	9	0	40756	\N
22092	23	15	0	40763	\N
22092	3227	16	0	40764	\N
21920	4255	7	0	41589	\N
21964	40	3	0	41613	\N
21993	56	3	0	44448	\N
21993	4109	4	0	44451	\N
22057	75	4	0	45854	\N
22057	3959	5	0	45855	\N
22129	75	7	0	45864	\N
22129	2859	8	0	45865	\N
22204	75	4	0	45873	\N
22204	3959	5	0	45875	\N
22040	113	4	0	48202	\N
22040	3677	5	0	48203	\N
22186	113	3	0	48211	\N
22186	3620	4	0	48212	\N
22214	113	9	0	48220	\N
22214	6490	10	0	48226	\N
21973	119	4	0	48525	\N
21973	4373	5	0	48551	\N
22215	125	3	0	49170	\N
22215	4170	4	0	49173	\N
22107	156	8	0	50266	\N
22107	6460	9	0	50269	\N
22147	156	3	0	50279	\N
22147	4594	4	0	50281	\N
22055	170	3	0	50523	\N
22055	4148	4	0	50524	\N
22020	279	4	0	53205	\N
22020	3502	5	0	53215	\N
21966	324	3	0	54483	\N
21966	4514	4	0	54487	\N
22171	451	3	0	55253	\N
22171	3934	4	0	55254	\N
22135	597	4	0	56089	\N
22135	3733	5	0	56098	\N
22199	1558	6	0	56441	\N
22199	1021	126	0	56452	\N
22199	6488	127	0	56453	\N
22205	908	4	0	57601	\N
22205	3488	5	0	57602	\N
22051	6445	0	0	58165	\N
22052	1470	4	0	58171	\N
22052	5655	5	0	58173	\N
22119	5233	7	0	58175	\N
22119	1470	8	0	58186	\N
22099	2578	7	0	58625	\N
22099	6457	8	0	58627	\N
22015	2782	3	0	59270	\N
22015	3659	4	0	59273	\N
21975	3628	6	0	59676	\N
21975	3643	7	0	59680	\N
22017	4088	4	0	59909	\N
22017	4089	5	0	59918	\N
22093	4233	3	0	60020	\N
22093	4425	4	0	60021	\N
22206	4233	3	0	60025	\N
22206	4425	4	0	60026	\N
22074	6451	7	0	60754	\N
22225	4204	4	0	507	\N
22174	228	7	0	2756	\N
22174	5491	8	0	2757	\N
22137	189	10	0	4824	\N
22137	6468	11	0	4825	\N
21942	4178	3	0	6675	\N
21942	4211	4	0	6681	\N
21955	4178	9	0	6685	\N
21992	4178	3	0	6686	\N
21992	4211	4	0	6688	\N
21955	4682	10	0	6690	\N
22001	4178	3	0	6693	\N
22001	4211	4	0	6695	\N
22187	4202	6	0	6724	\N
22194	4178	4	0	6726	\N
22194	4205	5	0	6727	\N
22012	4172	3	0	9107	\N
22012	4275	4	0	9111	\N
22062	4172	3	0	9115	\N
22062	4275	4	0	9118	\N
22116	4172	5	0	9121	\N
22116	4644	6	0	9123	\N
22209	4172	10	0	9138	\N
22209	4663	11	0	9139	\N
22228	4172	5	0	9141	\N
22141	300	11	0	12051	\N
22141	6470	12	0	12056	\N
22126	1890	4	0	12341	\N
22126	6465	5	0	12342	\N
22025	123	1	0	12705	\N
22025	124	2	0	12706	\N
22176	258	3	0	14358	\N
22176	4401	4	0	14359	\N
22125	173	3	0	14864	\N
22125	3796	4	0	14867	\N
22172	3615	5	0	15621	\N
21981	6436	64	0	18469	\N
21981	6437	127	0	18482	\N
22090	241	2	0	20567	\N
22090	634	3	0	20570	\N
22178	241	6	0	20594	\N
22178	6412	7	0	20595	\N
22051	6422	0	0	21630	\N
21996	67	3	0	22112	\N
21996	3749	4	0	22113	\N
22067	73	3	0	22425	\N
22067	3040	4	0	22426	\N
22213	336	9	0	22961	\N
22213	3568	10	0	22962	\N
22104	5255	8	0	23351	\N
22190	264	3	0	23478	\N
22190	3632	4	0	23479	\N
22217	140	8	0	24274	\N
22217	6491	9	0	24275	\N
22033	214	3	0	24435	\N
22033	3496	4	0	24439	\N
22154	1171	10	0	26279	\N
22154	6477	11	0	26283	\N
21983	6303	6	0	26325	\N
21983	6438	7	0	26326	\N
22231	6495	47	0	26327	\N
22132	42	6	0	27516	\N
22132	1090	7	0	27518	\N
22160	16	5	0	28961	\N
22162	16	3	0	28962	\N
22162	3634	4	0	28965	\N
22160	5175	6	0	28966	\N
22031	54	14	0	30305	\N
22031	2868	15	0	30306	\N
22035	360	4	0	31289	\N
22035	3513	5	0	31290	\N
22028	230	3	0	32003	\N
22046	230	3	0	32004	\N
22046	4181	4	0	32006	\N
21962	2	3	0	34990	\N
21962	3548	4	0	34993	\N
22166	2	5	0	35059	\N
22166	4304	6	0	35062	\N
22200	2	6	0	35076	\N
22200	4825	7	0	35077	\N
22150	14	3	0	39076	\N
22150	4272	4	0	39077	\N
21949	23	3	0	40754	\N
21949	3497	4	0	40755	\N
22216	40	0	0	41584	\N
21988	40	2	0	41623	\N
21988	282	3	0	41624	\N
22081	40	3	0	41641	\N
22081	372	4	0	41642	\N
22182	40	6	0	41650	\N
22182	4255	7	0	41652	\N
22191	40	4	0	41657	\N
22191	3381	5	0	41658	\N
22086	56	3	0	44467	\N
22086	4109	4	0	44468	\N
22112	6462	45	0	44469	\N
22112	56	60	0	44476	\N
22112	6463	61	0	44477	\N
22127	75	3	0	45859	\N
22127	3855	4	0	45861	\N
22198	75	3	0	45869	\N
22198	3139	4	0	45870	\N
22251	75	6	0	45874	\N
22251	4694	7	0	45876	\N
22096	102	4	0	48144	\N
22096	3572	5	0	48145	\N
22114	102	4	0	48147	\N
22114	3572	5	0	48149	\N
22212	113	9	0	48219	\N
22212	6490	10	0	48225	\N
22079	170	2	0	50534	\N
22079	2986	3	0	50535	\N
21946	186	3	0	51176	\N
21946	4294	4	0	51185	\N
21967	324	2	0	54484	\N
21967	6435	3	0	54486	\N
22075	597	6	0	56088	\N
22075	6452	7	0	56100	\N
22208	1558	6	0	56454	\N
22208	1021	61	0	56469	\N
22208	6489	62	0	56470	\N
22211	852	6	0	57442	\N
22211	4687	7	0	57443	\N
22120	5233	7	0	58176	\N
22120	1470	8	0	58187	\N
22144	1470	7	0	58193	\N
22144	5261	8	0	58194	\N
22044	2578	14	0	58624	\N
22044	6444	15	0	58628	\N
22175	2636	7	0	58724	\N
22175	6483	8	0	58737	\N
22201	4233	6	0	60024	\N
22201	6364	7	0	60027	\N
22136	6467	5	0	60752	\N
22070	4043	5	0	499	\N
22196	906	11	0	1958	\N
21989	117	6	0	2063	\N
21989	3804	7	0	2064	\N
22261	228	2	0	2773	\N
22261	4776	3	0	2774	\N
22277	373	3	0	5374	\N
22277	3590	4	0	5376	\N
21994	4178	6	0	6687	\N
21994	4250	7	0	6689	\N
22013	4178	3	0	6694	\N
22013	4211	4	0	6696	\N
22043	4178	2	0	6705	\N
22072	4178	6	0	6707	\N
22088	4178	3	0	6708	\N
22088	4211	4	0	6709	\N
22072	5854	7	0	6710	\N
22151	4178	0	0	6719	\N
22167	4178	5	0	6722	\N
22167	4299	6	0	6725	\N
22269	4178	3	0	6730	\N
22269	4211	4	0	6731	\N
22271	4178	3	0	6732	\N
22271	4211	4	0	6733	\N
22293	4178	7	0	6745	\N
22122	4172	3	0	9124	\N
22122	4275	4	0	9125	\N
22177	4172	7	0	9134	\N
22177	4614	8	0	9135	\N
22236	108	8	0	11912	\N
22236	6500	9	0	11920	\N
22203	300	4	0	12053	\N
22203	6350	5	0	12054	\N
22117	44	10	0	15993	\N
22117	6464	11	0	15994	\N
22138	44	6	0	15999	\N
22138	5989	7	0	16000	\N
22148	4144	8	0	16006	\N
22296	6518	63	0	17657	\N
22296	167	126	0	17665	\N
22296	6519	127	0	17666	\N
21982	208	3	0	19215	\N
22021	208	4	0	19216	\N
21982	4490	4	0	19218	\N
22021	6311	5	0	19219	\N
22101	60	3	0	19367	\N
22101	3585	4	0	19368	\N
22130	62	6	0	19744	\N
22130	6466	7	0	19757	\N
22008	3613	4	0	20559	\N
22002	64	3	0	20907	\N
22002	4217	4	0	20911	\N
22229	73	5	0	22445	\N
22229	6494	6	0	22450	\N
22193	411	7	0	25187	\N
22193	6487	8	0	25188	\N
21963	224	3	0	25434	\N
22026	224	3	0	25435	\N
21963	3603	4	0	25437	\N
22026	3603	4	0	25438	\N
22041	206	4	0	25780	\N
22169	206	6	0	25795	\N
22169	6481	7	0	25796	\N
22185	693	2	0	25797	\N
22185	206	8	0	25805	\N
22185	6486	9	0	25806	\N
22222	206	4	0	25816	\N
22222	6493	5	0	25817	\N
21984	90	3	0	26254	\N
21984	4074	4	0	26255	\N
22084	90	7	0	26257	\N
22084	4849	8	0	26267	\N
22231	6496	71	0	26331	\N
21986	2864	4	0	27007	\N
22003	94	3	0	27008	\N
22003	2864	4	0	27009	\N
22053	94	3	0	27010	\N
22053	2864	4	0	27011	\N
21943	4130	8	0	28948	\N
22180	16	3	0	28968	\N
22180	3634	4	0	28969	\N
22038	2627	4	0	29179	\N
22038	6443	5	0	29181	\N
21977	2	3	0	34991	\N
21977	3548	4	0	34994	\N
22065	3548	4	0	35014	\N
22286	2	3	0	35094	\N
22286	3548	4	0	35096	\N
22254	4	3	0	35907	\N
22254	3837	4	0	35908	\N
22183	18	6	0	40321	\N
22188	18	3	0	40322	\N
22188	3621	4	0	40325	\N
22183	4180	7	0	40326	\N
21948	23	0	0	40753	\N
21952	40	6	0	41597	\N
21952	4255	7	0	41598	\N
21960	372	4	0	41608	\N
22006	40	3	0	41631	\N
22047	40	3	0	41632	\N
22063	40	3	0	41633	\N
22006	372	4	0	41634	\N
22047	372	4	0	41635	\N
22063	372	4	0	41636	\N
22105	40	4	0	41649	\N
22105	2796	5	0	41651	\N
21917	4102	2	0	44446	\N
21961	3855	4	0	45837	\N
22089	75	3	0	45858	\N
22089	3855	4	0	45860	\N
22037	88	9	0	47098	\N
22037	4692	10	0	47099	\N
22069	88	6	0	47110	\N
22069	5263	7	0	47113	\N
22113	102	3	0	48146	\N
22113	5781	4	0	48148	\N
22245	156	9	0	50267	\N
22245	2225	10	0	50270	\N
22109	156	3	0	50278	\N
22109	4594	4	0	50280	\N
22078	170	3	0	50533	\N
22078	4148	4	0	50536	\N
22272	181	8	0	50978	\N
22272	5425	9	0	50979	\N
22170	273	8	0	53162	\N
22170	6482	9	0	53164	\N
21980	279	3	0	53200	\N
21980	3641	4	0	53201	\N
22054	324	3	0	54208	\N
22054	4514	4	0	54212	\N
22115	451	4	0	55252	\N
22115	3666	5	0	55255	\N
22073	595	6	0	55818	\N
22134	595	4	0	55819	\N
22134	3878	5	0	55820	\N
22073	6449	7	0	55821	\N
22227	1109	3	0	56298	\N
22184	6484	6	0	56429	\N
22184	1021	126	0	56439	\N
22184	6485	127	0	56440	\N
21995	908	3	0	57587	\N
21995	3591	4	0	57588	\N
22140	1470	11	0	58192	\N
22140	6469	12	0	58195	\N
22014	2782	2	0	59269	\N
22014	2784	3	0	59271	\N
22189	2782	3	0	59277	\N
22189	3659	4	0	59278	\N
21972	3625	6	0	59584	\N
22257	3625	4	0	59585	\N
22257	3802	5	0	59589	\N
21972	3642	7	0	59593	\N
22259	3628	4	0	59677	\N
22259	3803	5	0	59678	\N
22005	5885	7	0	60491	\N
22005	6440	8	0	60492	\N
22071	6448	12	0	509	\N
22016	4205	5	0	6698	\N
22030	4178	7	0	6699	\N
22030	4659	8	0	6704	\N
22095	4178	3	0	6711	\N
22095	4211	4	0	6712	\N
22124	4178	3	0	6713	\N
22124	4211	4	0	6714	\N
22247	4178	4	0	6728	\N
22247	4205	5	0	6729	\N
22282	4178	4	0	6740	\N
21991	4172	3	0	9106	\N
22027	4172	3	0	9109	\N
22027	4275	4	0	9113	\N
22080	4172	4	0	9116	\N
22080	4252	5	0	9119	\N
22143	4172	7	0	9127	\N
22159	4172	5	0	9128	\N
22159	4634	6	0	9130	\N
22143	4614	8	0	9131	\N
22173	4172	3	0	9132	\N
22173	4275	4	0	9133	\N
22202	4172	3	0	9136	\N
22202	4275	4	0	9137	\N
22224	4172	3	0	9140	\N
22010	455	1	0	11227	\N
22010	132	3	0	11236	\N
22010	3116	4	0	11238	\N
21985	108	3	0	11911	\N
21985	4171	4	0	11917	\N
22007	77	3	0	13052	\N
22007	1877	4	0	13054	\N
22000	173	3	0	14862	\N
22000	3796	4	0	14863	\N
22023	92	3	0	14976	\N
22023	4410	4	0	14977	\N
22221	235	5	0	15625	\N
22275	235	6	0	15637	\N
22275	3622	7	0	15638	\N
22087	44	7	0	15985	\N
22087	4144	8	0	15986	\N
22103	167	10	0	17943	\N
22103	6459	11	0	17944	\N
22106	167	4	0	17945	\N
22106	3428	5	0	17946	\N
22085	177	7	0	18343	\N
22085	3708	8	0	18348	\N
22181	142	4	0	18478	\N
22181	3950	5	0	18480	\N
22252	6504	8	0	18492	\N
22153	241	10	0	20586	\N
22157	241	10	0	20587	\N
22157	6478	11	0	20589	\N
22019	64	4	0	20908	\N
22019	3911	5	0	20912	\N
22066	73	4	0	22424	\N
22066	2284	5	0	22427	\N
22128	73	3	0	22437	\N
22128	1958	4	0	22438	\N
22059	264	3	0	23470	\N
22059	3632	4	0	23471	\N
22048	3496	4	0	24440	\N
22098	224	7	0	25448	\N
22098	5003	8	0	25457	\N
22083	90	5	0	26256	\N
22192	90	4	0	26258	\N
22192	3731	5	0	26263	\N
22083	6455	6	0	26266	\N
22232	6303	5	0	26328	\N
22232	6497	6	0	26329	\N
22233	42	6	0	27517	\N
22233	1090	7	0	27519	\N
22133	42	0	0	27535	\N
22064	3634	4	0	28953	\N
22121	16	5	0	28959	\N
22121	4240	6	0	28960	\N
22179	16	6	0	28963	\N
22179	3369	7	0	28967	\N
22195	16	4	0	28970	\N
22195	3546	5	0	28976	\N
22164	96	3	0	29447	\N
22164	2803	4	0	29449	\N
22036	6441	107	0	31298	\N
22036	360	126	0	31307	\N
22036	6442	127	0	31308	\N
22210	5683	11	0	32022	\N
21998	322	3	0	32585	\N
21998	1105	4	0	32587	\N
21979	453	3	0	32711	\N
21979	2838	4	0	32719	\N
22111	2	5	0	35035	\N
22111	6461	6	0	35036	\N
22161	2	3	0	35043	\N
22161	3548	4	0	35044	\N
22238	23	3	0	40775	\N
22238	3497	4	0	40776	\N
22207	40	4	0	41685	\N
22004	56	3	0	44449	\N
22302	3652	4	0	46759	\N
22414	88	3	0	47111	\N
22414	3655	4	0	47112	\N
22307	113	3	0	48221	\N
22307	3620	4	0	48223	\N
22342	121	7	0	48819	\N
22342	6543	8	0	48827	\N
22235	125	8	0	49185	\N
22334	125	10	0	49186	\N
22334	6539	11	0	49187	\N
22235	6499	9	0	49188	\N
22337	135	3	0	49455	\N
22337	3630	4	0	49458	\N
22242	156	4	0	50248	\N
22242	2543	5	0	50251	\N
22243	156	4	0	50257	\N
22243	2543	5	0	50259	\N
22246	156	9	0	50268	\N
22246	2225	10	0	50271	\N
22234	156	6	0	50293	\N
22234	6498	7	0	50294	\N
22241	156	3	0	50301	\N
22241	4594	4	0	50302	\N
22244	156	8	0	50309	\N
22244	6503	9	0	50310	\N
22376	170	7	0	50557	\N
22376	4591	8	0	50560	\N
22340	181	10	0	50994	\N
22340	6541	11	0	51003	\N
22250	200	6	0	51473	\N
22250	4701	7	0	51477	\N
22226	1109	2	0	56297	\N
22226	2809	3	0	56300	\N
22227	3495	4	0	56302	\N
22237	852	8	0	57446	\N
22237	6501	9	0	57447	\N
22349	852	2	0	57461	\N
22349	2872	3	0	57463	\N
22267	908	3	0	57615	\N
22267	3591	4	0	57616	\N
22329	1368	3	0	57855	\N
22421	1470	7	0	58200	\N
22421	5261	8	0	58207	\N
22369	2636	7	0	58725	\N
22369	6483	8	0	58738	\N
22248	2782	4	0	59284	\N
22248	3872	5	0	59286	\N
22153	6474	11	1	59455	\N
22455	3625	4	0	59586	\N
22455	3802	5	0	59590	\N
22309	6522	71	0	60028	\N
22309	4233	104	0	60031	\N
22309	6523	105	0	60032	\N
22356	5885	3	0	60493	\N
22356	5926	4	0	60495	\N
22223	2804	3	0	506	\N
22295	3354	5	0	1455	\N
22239	110	7	0	2474	\N
22239	6502	8	0	2477	\N
22361	4776	2	0	2776	\N
22361	228	5	0	2798	\N
22361	3589	6	0	2799	\N
22270	365	8	0	4500	\N
22270	6507	9	0	4501	\N
22354	365	10	0	4507	\N
22354	6547	11	0	4510	\N
22278	4178	3	0	6735	\N
22278	4211	4	0	6737	\N
22280	4527	3	0	6739	\N
22290	4441	3	0	6744	\N
22290	4178	8	0	6746	\N
22290	6516	9	0	6747	\N
22300	4178	3	0	6750	\N
22300	4211	4	0	6753	\N
22339	4178	4	0	6757	\N
22339	4205	5	0	6758	\N
22412	4178	10	0	6765	\N
22412	4665	11	0	6766	\N
22428	4178	3	0	6768	\N
22428	4211	4	0	6770	\N
22273	4275	4	0	9146	\N
22373	4172	7	0	9152	\N
22373	4614	8	0	9153	\N
22379	4172	3	0	9154	\N
22379	4275	4	0	9155	\N
22448	4172	3	0	9158	\N
22448	4275	4	0	9161	\N
22363	132	9	0	11235	\N
22363	6548	10	0	11241	\N
22395	92	3	0	14996	\N
22395	4410	4	0	14997	\N
22305	192	3	0	15480	\N
22283	212	4	0	17048	\N
22283	3732	5	0	17052	\N
22153	6476	12	1	18761	\N
22381	290	4	0	18909	\N
22381	5879	5	0	18911	\N
22240	164	7	0	21007	\N
22240	3939	8	0	21008	\N
22230	73	4	0	22446	\N
22230	2284	5	0	22449	\N
22288	264	3	0	23484	\N
22288	3632	4	0	23486	\N
22253	214	7	0	24437	\N
22388	6550	12	0	25189	\N
22386	411	3	0	25194	\N
22386	3596	4	0	25195	\N
22388	411	82	0	25196	\N
22388	6551	83	0	25197	\N
22402	411	7	0	25204	\N
22402	6487	8	0	25207	\N
22404	411	26	0	25208	\N
22404	6553	27	0	25209	\N
22317	94	8	0	27012	\N
22317	5303	9	0	27017	\N
22314	42	4	0	27536	\N
22256	16	3	0	28971	\N
22264	16	5	0	28972	\N
22256	3634	4	0	28975	\N
22264	5175	6	0	28977	\N
22329	6537	3	0	29445	\N
22329	2803	4	0	29446	\N
22462	449	3	0	29800	\N
22462	4760	4	0	29801	\N
22430	54	3	0	29984	\N
22430	3041	4	0	29985	\N
22446	54	4	0	30016	\N
22446	3685	5	0	30017	\N
22262	3602	4	0	31305	\N
22433	453	4	0	32712	\N
22433	4108	5	0	32721	\N
22398	4	6	0	35919	\N
22398	6552	7	0	35923	\N
22323	6	5	0	36261	\N
22393	18	4	0	40334	\N
22393	2302	5	0	40336	\N
22265	23	11	0	40781	\N
22265	6505	12	0	40782	\N
22331	27	2	0	41303	\N
22331	3164	3	0	41304	\N
22255	40	3	0	41704	\N
22255	372	4	0	41705	\N
22312	40	3	0	41716	\N
22312	372	4	0	41717	\N
22320	4488	7	0	41718	\N
22320	40	12	0	41733	\N
22320	6531	14	0	41734	\N
22527	79	6	0	46132	\N
22527	4253	7	0	46135	\N
22258	119	4	0	48526	\N
22456	119	4	0	48527	\N
22258	3518	5	0	48547	\N
22456	3518	5	0	48548	\N
22454	121	2	0	48843	\N
22454	2498	3	0	48844	\N
22530	135	7	0	49470	\N
22530	4721	8	0	49475	\N
22276	200	3	0	51474	\N
22276	3338	4	0	51476	\N
22512	210	3	0	51771	\N
22512	3539	4	0	51772	\N
22510	273	4	0	52925	\N
22510	3390	5	0	52926	\N
22487	279	18	0	53206	\N
22487	6573	19	0	53218	\N
22479	316	9	0	53869	\N
22479	6566	10	0	53870	\N
22327	389	7	0	54933	\N
22327	6535	8	0	54936	\N
22281	451	2	0	55261	\N
22281	5006	3	0	55272	\N
22434	852	4	0	57469	\N
22434	4162	5	0	57475	\N
22435	852	12	0	57479	\N
22435	1647	13	0	57480	\N
22422	1470	5	0	58201	\N
22422	6556	6	0	58206	\N
22266	2578	11	0	58629	\N
22266	6506	12	0	58634	\N
22493	2636	8	0	58726	\N
22493	6576	9	0	58739	\N
22306	4233	3	0	60029	\N
22306	4425	4	0	60030	\N
22437	6557	93	0	60033	\N
22437	4233	126	0	60036	\N
22437	6523	127	0	60037	\N
22343	6544	8	0	1099	\N
22442	3474	4	0	1173	\N
22291	6158	3	0	1960	\N
22291	117	8	0	1968	\N
22291	6517	9	0	1970	\N
22444	2995	3	0	2464	\N
22444	110	4	0	2475	\N
22325	6534	8	1	2730	\N
22260	228	3	0	2772	\N
22260	3186	4	0	2775	\N
22325	228	7	0	2796	\N
22407	262	2	0	3697	\N
22407	2743	3	0	3699	\N
22357	3839	4	0	4509	\N
22382	365	1	0	4525	\N
22382	1424	2	0	4526	\N
22426	365	7	0	4535	\N
22426	5248	8	0	4537	\N
22274	4178	3	0	6734	\N
22274	4211	4	0	6736	\N
22310	4178	4	0	6751	\N
22310	4205	5	0	6754	\N
22419	4178	2	0	6767	\N
22419	4247	3	0	6769	\N
22465	4178	4	0	6771	\N
22474	4178	13	0	6773	\N
22474	4782	14	0	6774	\N
22475	4178	6	0	6775	\N
22475	5854	7	0	6776	\N
22481	4178	8	0	6777	\N
22481	5610	9	0	6779	\N
22515	4178	4	0	6782	\N
22515	4205	5	0	6783	\N
22520	4178	9	0	6785	\N
22520	4318	10	0	6786	\N
22532	4441	3	0	6791	\N
22268	4172	3	0	9142	\N
22364	4172	4	0	9148	\N
22364	4219	5	0	9149	\N
22451	4172	6	0	9162	\N
22451	4197	7	0	9163	\N
22458	4172	3	0	9165	\N
22458	4275	4	0	9169	\N
22321	6527	7	0	11609	\N
22321	687	12	0	11623	\N
22321	6528	13	0	11625	\N
22377	5399	6	0	11996	\N
22377	6549	7	0	11997	\N
22292	173	0	0	14866	\N
22332	4982	8	0	14870	\N
22471	235	7	0	15645	\N
22471	5822	8	0	15646	\N
22320	6530	13	1	16956	\N
22325	6532	8	0	16968	\N
22467	6562	63	0	17667	\N
22467	167	126	0	17689	\N
22467	6563	127	0	17690	\N
22482	6567	12	0	18159	\N
22482	30	19	0	18160	\N
22482	2931	20	0	18161	\N
22263	142	3	0	18488	\N
22263	4254	4	0	18490	\N
22374	4254	4	0	18491	\N
22335	290	7	0	18897	\N
22335	6540	8	0	18905	\N
22486	208	18	0	19217	\N
22486	6572	19	0	19225	\N
22477	62	8	0	19747	\N
22477	6564	9	0	19758	\N
22391	164	3	0	21017	\N
22391	3385	4	0	21018	\N
22440	6559	20	0	24443	\N
22440	214	97	0	24466	\N
22449	69	3	0	24638	\N
22449	4536	4	0	24643	\N
22469	224	3	0	25469	\N
22469	3603	4	0	25471	\N
22387	94	3	0	27013	\N
22387	2864	4	0	27015	\N
22345	16	5	0	28978	\N
22345	5175	6	0	28979	\N
22403	16	7	0	28980	\N
22403	4723	8	0	28981	\N
22447	16	4	0	28983	\N
22447	3546	5	0	28992	\N
22384	2803	4	0	29458	\N
22517	151	6	0	30643	\N
22517	6587	7	0	30644	\N
22285	360	3	0	31317	\N
22285	3602	4	0	31318	\N
22489	360	8	0	31323	\N
22489	6575	9	0	31325	\N
22297	431	3	0	34850	\N
22297	3933	4	0	34851	\N
22405	2	2	0	35115	\N
22405	2789	3	0	35117	\N
22323	6533	6	1	36263	\N
22371	15	2	0	39095	\N
22380	14	3	0	39102	\N
22380	4272	4	0	39105	\N
22496	14	3	0	39122	\N
22496	1786	4	0	39124	\N
22366	40	3	0	41766	\N
22366	372	4	0	41767	\N
22484	6569	9	0	41808	\N
22484	6570	10	0	41809	\N
22460	40	3	0	41810	\N
22460	372	4	0	41812	\N
22328	6536	3	0	44719	\N
22328	3770	4	0	44720	\N
22591	71	16	0	44730	\N
22591	6615	17	0	44731	\N
22378	75	4	0	45880	\N
22378	3959	5	0	45882	\N
22560	75	3	0	45889	\N
22560	3855	4	0	45891	\N
22528	79	4	0	46133	\N
22528	2758	5	0	46134	\N
22411	102	10	0	47889	\N
22411	6554	11	0	47898	\N
22554	113	3	0	48222	\N
22554	3620	4	0	48224	\N
22453	121	3	0	48842	\N
22453	4471	4	0	48845	\N
22336	137	3	0	49691	\N
22336	3633	4	0	49695	\N
22545	200	5	0	51494	\N
22545	6598	6	0	51495	\N
22316	210	8	0	51764	\N
22316	6525	9	0	51766	\N
22418	242	16	0	52070	\N
22418	6555	17	0	52073	\N
22578	242	11	0	52079	\N
22578	6607	12	0	52080	\N
22432	273	4	0	52919	\N
22432	3777	5	0	52920	\N
22502	279	9	0	53207	\N
22502	6581	10	0	53217	\N
22565	841	3	0	56940	\N
22565	3604	4	0	56943	\N
22328	1368	3	0	57854	\N
22457	3628	4	0	59698	\N
22457	3803	5	0	59699	\N
22400	4088	6	0	59910	\N
22400	4246	7	0	59919	\N
22436	4233	3	0	60034	\N
22436	4425	4	0	60035	\N
22289	6510	8	0	60604	\N
22543	4204	4	0	513	\N
22441	2103	3	0	1172	\N
22464	251	3	0	1450	\N
22464	3514	4	0	1453	\N
22289	6158	3	0	1959	\N
22289	6511	8	0	1967	\N
22409	117	3	0	1972	\N
22409	3653	4	0	1975	\N
22445	2995	3	0	2465	\N
22445	110	4	0	2476	\N
22347	262	4	0	3696	\N
22347	4607	5	0	3701	\N
22392	35	4	0	4170	\N
22383	365	4	0	4523	\N
22383	4049	5	0	4524	\N
22425	365	0	0	4536	\N
22504	189	17	0	4838	\N
22504	6582	18	0	4840	\N
22282	4205	5	0	6741	\N
22287	4178	3	0	6742	\N
22287	4211	4	0	6743	\N
22311	4178	3	0	6755	\N
22311	4211	4	0	6756	\N
22353	4178	4	0	6759	\N
22353	4205	5	0	6760	\N
22410	4211	4	0	6764	\N
22485	4178	10	0	6778	\N
22485	6571	11	0	6780	\N
22491	4178	8	0	6781	\N
22491	4237	9	0	6784	\N
22521	4178	13	0	6787	\N
22521	6589	14	0	6788	\N
22532	4178	7	0	6792	\N
22532	4941	8	0	6793	\N
22548	4178	13	0	6795	\N
22559	4178	3	0	6796	\N
22559	4211	4	0	6798	\N
22372	4172	3	0	9150	\N
22372	4275	4	0	9151	\N
22390	4172	3	0	9156	\N
22390	4275	4	0	9160	\N
22561	4172	8	0	9175	\N
22561	5928	9	0	9178	\N
22573	4172	10	0	9180	\N
22573	6603	11	0	9181	\N
22468	108	2	0	11913	\N
22468	3340	3	0	11916	\N
22552	77	6	0	13053	\N
22552	6600	7	0	13055	\N
22397	4245	7	0	13948	\N
22594	402	4	0	14318	\N
22594	2548	5	0	14322	\N
22368	38	7	0	16283	\N
22413	38	4	0	16284	\N
22413	5656	5	0	16286	\N
22368	5071	8	0	16290	\N
22284	6508	45	0	17040	\N
22284	212	126	0	17054	\N
22284	6509	127	0	17055	\N
22294	167	6	0	17663	\N
22294	5066	7	0	17664	\N
22571	3635	4	0	18918	\N
22583	1815	9	0	19333	\N
22583	6612	10	0	19336	\N
22416	62	3	0	19746	\N
22416	3344	4	0	19754	\N
22509	241	20	0	20412	\N
22509	6586	21	0	20414	\N
22299	145	14	0	21832	\N
22299	6520	15	0	21835	\N
22401	67	6	0	22120	\N
22401	3607	7	0	22121	\N
22351	264	3	0	23485	\N
22394	264	3	0	23497	\N
22394	3632	4	0	23498	\N
22549	82	3	0	23718	\N
22549	4505	4	0	23721	\N
22576	82	17	0	23725	\N
22576	6605	18	0	23733	\N
22439	214	8	0	24464	\N
22439	6558	9	0	24465	\N
22322	224	7	0	25468	\N
22322	5003	8	0	25474	\N
22333	206	11	0	25821	\N
22333	6538	12	0	25826	\N
22599	6620	16	0	29194	\N
22534	20	8	0	30381	\N
22534	6595	9	0	30382	\N
22551	20	6	0	30390	\N
22551	5933	7	0	30395	\N
22547	360	13	0	31324	\N
22547	6599	14	0	31326	\N
22360	2789	2	0	35098	\N
22360	2	5	0	35116	\N
22360	2990	6	0	35118	\N
22488	6	9	0	36270	\N
22488	6574	10	0	36272	\N
22497	2291	5	0	39125	\N
22461	18	4	0	40335	\N
22461	2302	5	0	40337	\N
22523	18	9	0	40341	\N
22523	6591	10	0	40343	\N
22537	18	12	0	40346	\N
22537	6596	13	0	40358	\N
22568	27	12	0	41309	\N
22568	6066	13	0	41310	\N
22601	40	4	0	41850	\N
26443	56	6	0	44592	\N
22308	3855	4	0	45881	\N
22585	79	9	0	46143	\N
22615	79	4	0	46217	\N
22615	3678	5	0	46221	\N
22341	121	10	0	48818	\N
22341	6542	11	0	48829	\N
22420	125	2	0	49197	\N
22420	3297	3	0	49198	\N
22359	156	3	0	50317	\N
22359	4594	4	0	50318	\N
22318	170	12	0	50548	\N
22318	6526	13	0	50549	\N
22348	200	4	0	51484	\N
22348	4683	5	0	51485	\N
22417	242	3	0	52069	\N
22417	2839	4	0	52071	\N
22516	316	4	0	53878	\N
22516	5437	5	0	53881	\N
22443	793	3	0	56853	\N
22443	2644	4	0	56854	\N
22350	852	64	0	57462	\N
22350	6546	65	0	57464	\N
22618	852	3	0	57471	\N
22618	3612	4	0	57474	\N
22622	1470	4	0	58203	\N
22611	2636	2	0	58727	\N
22611	2836	3	0	58732	\N
22525	4787	4	0	60314	\N
22525	5041	5	0	60315	\N
22313	6044	4	0	60623	\N
22313	6524	5	0	60626	\N
22470	3514	4	0	1454	\N
22423	117	7	0	1973	\N
22480	117	8	0	1974	\N
22423	5276	8	0	1976	\N
22480	1878	9	0	1977	\N
22324	228	7	0	2795	\N
22324	5491	8	0	2801	\N
22408	262	3	0	3698	\N
22408	4778	4	0	3700	\N
22506	2074	2	0	5144	\N
22298	4178	3	0	6749	\N
22298	4211	4	0	6752	\N
22355	4178	3	0	6761	\N
22539	4178	3	0	6794	\N
22539	4211	4	0	6797	\N
22406	4172	2	0	9157	\N
22406	4191	3	0	9159	\N
22452	4172	3	0	9164	\N
22499	4172	28	0	9167	\N
22452	4275	4	0	9168	\N
22499	6579	29	0	9171	\N
22613	4172	7	0	9184	\N
22613	6628	8	0	9185	\N
22536	132	3	0	11254	\N
22536	3729	4	0	11255	\N
22319	687	12	0	11622	\N
22319	6528	13	0	11624	\N
22459	6232	3	0	12970	\N
22459	6561	4	0	12971	\N
22358	258	3	0	14367	\N
22358	4401	4	0	14368	\N
22375	173	7	0	14871	\N
22375	6103	8	0	14872	\N
22304	192	11	0	15461	\N
22304	6521	12	0	15467	\N
22563	2761	2	0	15469	\N
22563	192	4	0	15482	\N
22289	6513	9	1	16955	\N
22438	212	8	0	17049	\N
22463	212	3	0	17050	\N
22463	3639	4	0	17051	\N
22438	4031	9	0	17053	\N
22518	326	9	0	17333	\N
22518	2581	10	0	17334	\N
22466	167	4	0	17681	\N
22466	4048	5	0	17688	\N
22303	30	3	0	18156	\N
22303	3640	4	0	18157	\N
22501	208	9	0	19239	\N
22415	62	2	0	19745	\N
22478	62	9	0	19748	\N
22415	2191	3	0	19753	\N
22478	6565	10	0	19759	\N
22508	241	20	0	20411	\N
22508	6586	21	0	20413	\N
22365	64	4	0	20682	\N
22424	64	7	0	20683	\N
22365	3911	5	0	20684	\N
22424	5286	8	0	20685	\N
22429	67	3	0	22127	\N
22429	3749	4	0	22129	\N
22389	336	3	0	22964	\N
22389	3400	4	0	22967	\N
22344	6545	10	0	22970	\N
22362	1379	2	0	23352	\N
22362	149	5	0	23353	\N
22362	5008	6	0	23354	\N
22476	264	6	0	23504	\N
22476	4660	7	0	23507	\N
22580	214	4	0	24494	\N
22580	6608	5	0	24495	\N
22541	69	1	0	24639	\N
22541	70	2	0	24642	\N
22396	3778	5	0	27438	\N
22556	244	4	0	27442	\N
22556	3778	5	0	27443	\N
22450	16	3	0	28984	\N
22472	16	7	0	28985	\N
22558	16	3	0	28987	\N
22450	3634	4	0	28989	\N
22558	3634	4	0	28990	\N
22472	4723	8	0	28994	\N
22330	96	6	0	29448	\N
22330	3698	7	0	29450	\N
22511	96	4	0	29468	\N
22575	449	3	0	29810	\N
22575	4760	4	0	29811	\N
22431	54	4	0	30008	\N
22431	3685	5	0	30009	\N
22620	20	3	0	30391	\N
22620	2844	4	0	30393	\N
22338	2	3	0	35095	\N
22338	3548	4	0	35097	\N
22533	2	13	0	35131	\N
22533	6594	14	0	35133	\N
22346	4	4	0	35918	\N
22346	4117	5	0	35921	\N
22326	5595	8	0	36264	\N
22385	6	3	0	36269	\N
22385	4823	4	0	36271	\N
22490	14	6	0	39103	\N
22494	14	8	0	39104	\N
22490	2720	7	0	39106	\N
22494	6577	9	0	39107	\N
22566	14	3	0	39138	\N
22566	4272	4	0	39139	\N
22301	18	3	0	40329	\N
22301	3621	4	0	40330	\N
22370	18	7	0	40333	\N
22367	40	7	0	41795	\N
22367	4718	8	0	41796	\N
22506	41	1	0	41797	\N
22506	6584	2	0	41811	\N
22601	2796	5	0	41851	\N
26457	56	3	0	44595	\N
22524	3770	4	0	44722	\N
22679	71	3	0	44736	\N
22679	3770	4	0	44737	\N
22716	71	3	0	44750	\N
22716	3770	4	0	44751	\N
22648	75	7	0	45895	\N
22648	2859	8	0	45898	\N
22585	6614	10	0	46144	\N
22623	79	4	0	46218	\N
22623	3678	5	0	46222	\N
22657	121	3	0	48862	\N
22657	4471	4	0	48866	\N
22684	125	3	0	49204	\N
22684	4170	4	0	49205	\N
22531	137	9	0	49692	\N
22531	6593	10	0	49696	\N
22607	170	7	0	50558	\N
22607	6624	8	0	50561	\N
22674	170	3	0	50581	\N
22674	4148	4	0	50582	\N
22550	200	4	0	51503	\N
22550	4683	5	0	51504	\N
22588	242	3	0	52086	\N
22588	2839	4	0	52087	\N
22633	279	4	0	53208	\N
22633	3502	5	0	53216	\N
22644	324	3	0	54209	\N
22644	4514	4	0	54213	\N
22544	1109	2	0	56299	\N
22544	2809	3	0	56301	\N
22538	793	12	0	56859	\N
22538	6597	13	0	56860	\N
22617	852	4	0	57470	\N
22617	4162	5	0	57476	\N
22609	1470	6	0	58202	\N
22609	6626	7	0	58204	\N
22630	1470	4	0	58214	\N
22630	5655	5	0	58215	\N
22612	2636	6	0	58728	\N
22612	6627	7	0	58736	\N
22713	4088	6	0	59911	\N
22713	4246	7	0	59920	\N
22555	4233	4	0	60038	\N
22569	4233	3	0	60039	\N
22569	4425	4	0	60040	\N
22555	4234	5	0	60041	\N
22540	5885	3	0	60494	\N
22540	5926	4	0	60496	\N
22606	2804	3	0	512	\N
22677	3474	4	0	1174	\N
22593	110	4	0	2482	\N
22595	110	5	0	2483	\N
22593	4552	5	0	2484	\N
22595	6619	6	0	2485	\N
22507	368	1	0	3283	\N
22507	367	12	0	3294	\N
22507	6585	13	0	3296	\N
22726	6643	4	0	3690	\N
22726	262	5	0	3703	\N
22505	189	19	0	4839	\N
22505	6583	20	0	4841	\N
22626	189	3	0	4856	\N
22626	3782	4	0	4859	\N
22625	3992	5	0	4862	\N
22529	4178	9	0	6789	\N
22529	6592	10	0	6790	\N
22598	4178	15	0	6800	\N
22598	4570	16	0	6801	\N
22603	4178	6	0	6802	\N
22603	6623	7	0	6803	\N
22492	4172	8	0	9166	\N
22492	4500	9	0	9170	\N
22514	4172	4	0	9172	\N
22535	4172	3	0	9174	\N
22535	4275	4	0	9176	\N
22514	4219	5	0	9177	\N
22519	6588	10	0	9179	\N
22650	4172	3	0	9186	\N
22650	4275	4	0	9187	\N
22672	4172	3	0	9188	\N
22672	4275	4	0	9189	\N
22579	132	5	0	11263	\N
22579	4384	6	0	11264	\N
22596	300	3	0	12063	\N
22596	3747	4	0	12064	\N
22498	528	3	0	12469	\N
22498	6578	4	0	12472	\N
22495	3353	5	0	12474	\N
22564	58	3	0	13678	\N
22564	3665	4	0	13680	\N
22711	233	6	0	13942	\N
22711	4245	7	0	13949	\N
22592	6617	18	0	14093	\N
22592	6616	14	0	14314	\N
22592	402	17	0	14323	\N
22562	2761	2	0	15468	\N
22562	192	4	0	15481	\N
22652	44	3	0	16032	\N
22652	3631	4	0	16036	\N
22586	290	4	0	18924	\N
22586	5879	5	0	18925	\N
22708	290	2	0	18934	\N
22708	1909	3	0	18935	\N
22731	6645	3	0	20332	\N
22731	6646	4	0	20333	\N
22574	241	10	0	20422	\N
22574	6604	11	0	20425	\N
22592	6618	18	1	22054	\N
22682	73	7	0	22447	\N
22639	336	4	0	22966	\N
22639	3947	5	0	22969	\N
22581	6609	49	0	24468	\N
22581	214	126	0	24496	\N
22581	6610	127	0	24497	\N
22542	69	3	0	24640	\N
22542	4536	4	0	24644	\N
22662	206	10	0	25823	\N
22662	4819	11	0	25825	\N
22602	90	6	0	26259	\N
22602	6622	7	0	26265	\N
22640	3634	3	0	28982	\N
22628	16	6	0	28988	\N
22628	3369	7	0	28993	\N
22522	6590	14	0	28995	\N
22706	16	2	0	28999	\N
22706	388	3	0	29001	\N
22600	911	11	0	29188	\N
22600	6621	12	0	29193	\N
22572	6601	3	0	31264	\N
22572	6602	4	0	31265	\N
22567	2	12	0	35163	\N
22604	2	2	0	35164	\N
22604	2789	3	0	35166	\N
22723	2	4	0	35187	\N
22723	3510	5	0	35188	\N
22667	4	4	0	35933	\N
22667	4117	5	0	35935	\N
22614	18	7	0	40347	\N
22614	6629	8	0	40355	\N
22557	23	3	0	40790	\N
22557	3497	4	0	40796	\N
22589	40	3	0	41827	\N
22589	1921	4	0	41828	\N
22669	40	3	0	41924	\N
22669	372	4	0	41925	\N
22686	2796	5	0	41950	\N
22745	113	5	0	48233	\N
22745	3786	6	0	48234	\N
22847	113	3	0	48245	\N
22847	3620	4	0	48246	\N
22748	125	3	0	49216	\N
22748	4170	4	0	49217	\N
22721	135	2	0	49471	\N
22721	2722	3	0	49473	\N
22803	156	3	0	50323	\N
22803	4594	4	0	50326	\N
22608	170	10	0	50559	\N
22608	6625	11	0	50562	\N
22717	181	3	0	50995	\N
22717	4184	4	0	50999	\N
22751	186	2	0	51177	\N
22752	186	3	0	51178	\N
22751	1850	3	0	51182	\N
22752	4294	4	0	51186	\N
22824	200	0	0	51519	\N
22822	210	3	0	51779	\N
22822	3539	4	0	51780	\N
22858	268	5	0	52613	\N
22858	6673	6	0	52617	\N
22597	273	3	0	52933	\N
22597	3638	4	0	52935	\N
22829	285	4	0	53434	\N
22829	3674	5	0	53437	\N
22760	6650	8	1	56590	\N
22832	852	4	0	57472	\N
22832	4162	5	0	57477	\N
22760	4017	8	0	57957	\N
22797	2578	6	0	58630	\N
22797	4795	7	0	58633	\N
22637	2636	4	0	58729	\N
22637	3617	5	0	58734	\N
22655	2782	4	0	59285	\N
22655	3872	5	0	59287	\N
22805	4787	3	0	60316	\N
22805	4788	4	0	60319	\N
22700	6640	5	0	2291	\N
22869	4134	5	0	2504	\N
22651	1636	3	0	3119	\N
22651	5514	4	0	3123	\N
22754	6648	81	0	4538	\N
22754	365	121	0	4555	\N
22754	6649	122	0	4558	\N
22732	373	3	0	5375	\N
22732	3590	4	0	5377	\N
22709	4178	5	0	6810	\N
22729	4178	2	0	6812	\N
22729	4247	3	0	6814	\N
22709	4429	6	0	6816	\N
22740	4205	5	0	6819	\N
22849	4178	3	0	6841	\N
22849	4211	4	0	6844	\N
22582	4172	6	0	9182	\N
22582	6611	7	0	9183	\N
22694	4172	6	0	9191	\N
22694	5278	7	0	9193	\N
22707	4172	2	0	9194	\N
22757	4172	3	0	9196	\N
22707	4191	3	0	9197	\N
22757	4275	4	0	9198	\N
22759	4172	4	0	9200	\N
22819	4614	8	0	9211	\N
22642	108	3	0	11914	\N
22663	108	9	0	11915	\N
22642	4171	4	0	11918	\N
22663	6634	10	0	11919	\N
22577	77	11	0	13060	\N
22577	6606	12	0	13066	\N
22714	58	4	0	13686	\N
22714	2781	5	0	13687	\N
22807	58	6	0	13693	\N
22807	3575	7	0	13694	\N
22675	92	4	0	15011	\N
22570	192	3	0	15491	\N
22570	3790	4	0	15493	\N
22653	235	4	0	15653	\N
22653	3615	5	0	15656	\N
22670	212	3	0	17062	\N
22719	212	2	0	17063	\N
22719	3616	3	0	17064	\N
22670	3639	4	0	17065	\N
22864	212	5	0	17075	\N
22864	6675	6	0	17077	\N
22841	167	0	0	17683	\N
22852	167	0	0	17686	\N
22737	6647	15	0	18170	\N
22704	765	7	0	18410	\N
22704	6642	8	0	18411	\N
22815	208	3	0	19247	\N
22815	4490	4	0	19249	\N
22834	60	3	0	19397	\N
22834	3585	4	0	19400	\N
22762	198	0	0	20312	\N
22646	64	7	0	20693	\N
22646	5286	8	0	20697	\N
22685	1316	3	0	22339	\N
22685	4837	4	0	22340	\N
22605	3183	3	0	23969	\N
22673	214	3	0	24512	\N
22673	3496	4	0	24514	\N
22697	69	4	0	24641	\N
22697	4041	5	0	24645	\N
22587	206	4	0	25822	\N
22587	3511	5	0	25824	\N
22584	6303	9	0	26332	\N
22584	6613	10	0	26339	\N
22863	94	4	0	27018	\N
22863	4677	5	0	27021	\N
22616	104	2	0	27155	\N
22712	244	6	0	27234	\N
22712	6406	7	0	27238	\N
22665	16	0	0	28973	\N
22658	16	3	0	28998	\N
22658	3634	4	0	29002	\N
22742	16	6	0	29004	\N
22742	3369	7	0	29005	\N
22760	2575	4	0	29008	\N
22827	16	3	0	29010	\N
22827	3634	4	0	29013	\N
22760	16	7	0	29015	\N
22760	6651	9	0	29016	\N
22621	6631	6	0	30394	\N
22631	33	4	0	31719	\N
22810	33	3	0	31720	\N
22810	3342	4	0	31722	\N
22631	4806	5	0	31723	\N
22635	453	6	0	32713	\N
22635	4091	7	0	32723	\N
22689	2	2	0	35165	\N
22689	2789	3	0	35167	\N
22624	4	4	0	35920	\N
22624	4117	5	0	35922	\N
22786	4	4	0	35934	\N
22735	18	0	0	40324	\N
22619	18	4	0	40348	\N
22743	18	5	0	40351	\N
22619	2302	5	0	40352	\N
22743	3550	6	0	40356	\N
22610	40	2	0	41865	\N
22610	282	3	0	41866	\N
22668	40	4	0	41901	\N
22668	3381	5	0	41902	\N
22836	40	2	0	41965	\N
22836	282	3	0	41969	\N
28146	56	18	0	44626	\N
22813	3770	4	0	44765	\N
22636	75	6	0	45890	\N
22636	4694	7	0	45892	\N
22790	75	7	0	45903	\N
22790	2859	8	0	45904	\N
22880	75	4	0	45910	\N
22880	3959	5	0	45914	\N
22795	79	6	0	46264	\N
22795	4253	7	0	46274	\N
22659	121	2	0	48863	\N
22659	2498	3	0	48865	\N
22722	137	1	0	49693	\N
22722	138	2	0	49694	\N
22768	137	4	0	49713	\N
22768	3697	5	0	49720	\N
22851	186	3	0	51179	\N
22851	4294	4	0	51187	\N
22691	200	8	0	51517	\N
22823	200	1	0	51518	\N
22823	201	2	0	51521	\N
22691	6636	9	0	51523	\N
22671	260	7	0	52472	\N
22671	4589	8	0	52476	\N
22885	419	2	0	52477	\N
22885	260	7	0	52488	\N
22885	6680	8	0	52489	\N
22783	268	7	0	52612	\N
22783	6658	8	0	52618	\N
22736	273	14	0	52934	\N
22736	274	15	0	52936	\N
22777	273	4	0	52943	\N
22777	3777	5	0	52944	\N
22816	279	2	0	53209	\N
22816	5593	3	0	53212	\N
22688	1109	4	0	56307	\N
22710	1109	5	0	56308	\N
22688	4535	5	0	56309	\N
22710	5040	6	0	56310	\N
22656	841	3	0	56941	\N
22656	3604	4	0	56944	\N
22855	908	5	0	57625	\N
22855	5076	6	0	57628	\N
22889	908	4	0	57639	\N
22889	3488	5	0	57641	\N
22883	6678	4	0	58106	\N
22883	6679	5	0	58107	\N
22622	2798	5	0	58205	\N
22681	1470	7	0	58228	\N
22681	5261	8	0	58229	\N
22865	2782	5	0	59291	\N
22865	6676	6	0	59292	\N
22806	4787	1	0	60317	\N
22806	6663	2	0	60318	\N
22860	5885	4	0	60499	\N
22860	6674	5	0	60500	\N
22840	3611	4	0	709	\N
22747	3474	4	0	1183	\N
22837	251	3	0	1464	\N
22837	3514	4	0	1465	\N
22800	6661	4	0	2311	\N
22800	6662	5	0	2312	\N
22873	228	5	0	2797	\N
22873	6677	6	0	2800	\N
22895	1636	3	0	3129	\N
22895	5514	4	0	3130	\N
22811	367	3	0	3293	\N
22811	3683	4	0	3295	\N
22725	6643	4	0	3689	\N
22780	262	4	0	3712	\N
22780	4607	5	0	3713	\N
22872	262	3	0	3726	\N
22872	4778	4	0	3727	\N
22756	365	10	0	4545	\N
22756	3791	11	0	4554	\N
22696	4178	9	0	6805	\N
22696	6639	10	0	6807	\N
22718	4178	2	0	6811	\N
22718	4247	3	0	6813	\N
22770	4178	4	0	6824	\N
22770	4205	5	0	6825	\N
22818	4202	6	0	6838	\N
22877	4178	4	0	6847	\N
22887	4178	4	0	6848	\N
22877	4205	5	0	6853	\N
22887	4205	5	0	6854	\N
22676	4172	3	0	9190	\N
22676	4275	4	0	9192	\N
22739	4172	4	0	9195	\N
22739	4219	5	0	9199	\N
22882	4172	3	0	9213	\N
22882	4275	4	0	9214	\N
22750	123	2	0	12715	\N
22750	1868	3	0	12717	\N
22763	6652	6	0	12718	\N
22861	233	4	0	13943	\N
22861	3775	5	0	13947	\N
22629	173	3	0	14873	\N
22629	3796	4	0	14874	\N
22693	92	6	0	15017	\N
22693	6637	7	0	15022	\N
22741	38	4	0	16291	\N
22741	5656	5	0	16300	\N
22843	167	0	0	17685	\N
22632	208	4	0	19246	\N
22641	3749	3	0	22122	\N
22641	67	4	0	22130	\N
22638	336	4	0	22965	\N
22638	3947	5	0	22968	\N
22643	336	3	0	22971	\N
22645	336	2	0	22972	\N
22645	3332	3	0	22973	\N
22643	3400	4	0	22974	\N
22878	82	4	0	23726	\N
22878	3508	5	0	23729	\N
22728	69	2	0	24654	\N
22728	3350	3	0	24660	\N
22634	6438	7	0	26338	\N
22666	16	0	0	28974	\N
22733	16	3	0	29000	\N
22733	3634	4	0	29003	\N
22758	16	3	0	29006	\N
22758	3634	4	0	29007	\N
22848	16	3	0	29021	\N
22886	16	3	0	29022	\N
22848	3634	4	0	29023	\N
22886	3634	4	0	29024	\N
22894	16	3	0	29025	\N
22894	3634	4	0	29027	\N
22875	5168	7	0	29832	\N
22828	151	3	0	30647	\N
22828	3046	4	0	30648	\N
22627	202	6	0	31000	\N
22627	4079	7	0	31001	\N
22699	360	4	0	31337	\N
22699	3513	5	0	31344	\N
22876	2	4	0	35240	\N
22876	3510	5	0	35244	\N
22703	6	6	0	36285	\N
22703	6641	7	0	36286	\N
22734	18	0	0	40323	\N
22761	18	5	0	40361	\N
22774	18	21	0	40363	\N
22774	6656	22	0	40364	\N
22772	40	21	0	41946	\N
22772	6654	22	0	41955	\N
22793	40	6	0	41964	\N
22793	4255	7	0	41973	\N
22687	2776	5	0	44745	\N
22918	71	4	0	44772	\N
22918	3887	5	0	44773	\N
22746	75	4	0	45896	\N
22746	3959	5	0	45897	\N
22680	79	3	0	46219	\N
22680	3652	4	0	46220	\N
22891	113	3	0	48252	\N
22891	3620	4	0	48255	\N
22893	279	2	0	53210	\N
22893	4525	3	0	53213	\N
22649	316	3	0	53879	\N
22649	4249	4	0	53880	\N
22765	451	5	0	55263	\N
22765	6653	6	0	55277	\N
22903	5643	9	0	56599	\N
22835	6671	5	0	56602	\N
22903	6683	10	0	56604	\N
22856	908	4	0	57626	\N
22856	6672	5	0	57627	\N
22901	3628	3	0	59665	\N
22901	3785	4	0	59666	\N
22782	5885	7	0	60497	\N
22782	6657	8	0	60502	\N
22896	5631	5	0	110	\N
22923	4204	4	0	260	\N
22835	749	4	0	612	\N
22660	46	7	0	647	\N
22660	6632	8	0	658	\N
22804	424	3	0	704	\N
22804	3611	4	0	708	\N
22870	110	5	0	2500	\N
22870	3916	6	0	2507	\N
22825	1636	10	0	3120	\N
22825	6666	11	0	3124	\N
22727	6643	4	0	3691	\N
22727	262	5	0	3704	\N
22692	3563	4	0	4181	\N
22654	4178	3	0	6804	\N
22654	4211	4	0	6806	\N
22698	4178	4	0	6808	\N
22705	4178	7	0	6809	\N
22698	4205	5	0	6815	\N
22705	4509	8	0	6817	\N
22755	4178	10	0	6820	\N
22755	4665	11	0	6821	\N
22808	4178	3	0	6835	\N
22808	4211	4	0	6836	\N
22859	4178	5	0	6842	\N
22871	4211	4	0	6845	\N
22859	4429	6	0	6846	\N
22927	4178	3	0	6850	\N
22789	4172	8	0	9202	\N
22789	4347	9	0	9203	\N
22799	4172	4	0	9204	\N
22799	4219	5	0	9205	\N
22817	4172	5	0	9208	\N
22817	4634	6	0	9210	\N
22854	4172	5	0	9212	\N
22854	4415	6	0	9215	\N
22905	4172	3	0	9216	\N
22905	4275	4	0	9218	\N
22913	4663	11	0	9219	\N
22879	132	4	0	11273	\N
22879	3716	5	0	11274	\N
22908	132	12	0	11284	\N
22908	3826	13	0	11285	\N
22776	123	3	0	12724	\N
22776	2856	4	0	12726	\N
22767	402	2	0	14319	\N
22767	2760	3	0	14320	\N
22884	585	2	0	14360	\N
22884	258	7	0	14369	\N
22690	192	8	0	15492	\N
22690	4393	9	0	15494	\N
22715	235	2	0	15654	\N
22715	2757	3	0	15655	\N
22916	44	2	0	16034	\N
22916	6686	3	0	16035	\N
22720	115	2	0	16895	\N
22720	2797	3	0	16899	\N
22839	167	3	0	17682	\N
22842	167	0	0	17684	\N
22839	4028	4	0	17687	\N
22853	167	1	0	17696	\N
22850	167	3	0	17698	\N
22850	4028	4	0	17699	\N
22835	60	3	0	19398	\N
22835	6670	4	1	19675	\N
22830	145	4	0	21855	\N
22830	3867	5	0	21856	\N
22744	336	7	0	22975	\N
22820	336	3	0	22976	\N
22820	3400	4	0	22977	\N
22744	3690	8	0	22978	\N
22925	149	4	0	23359	\N
22925	4040	5	0	23362	\N
22922	4040	5	0	23364	\N
22874	264	6	0	23505	\N
22874	5480	7	0	23506	\N
22702	140	6	0	23977	\N
22702	5056	7	0	23982	\N
22867	90	4	0	26260	\N
22867	3731	5	0	26264	\N
22730	94	4	0	27014	\N
22730	6644	5	0	27016	\N
22664	16	0	0	28964	\N
22640	16	4	0	28991	\N
22647	16	7	0	28996	\N
22906	16	3	0	29026	\N
22906	3634	4	0	29028	\N
22920	16	4	0	29033	\N
22920	3546	5	0	29036	\N
22661	96	10	0	29469	\N
22924	96	4	0	29470	\N
22661	6633	11	0	29475	\N
22724	449	2	0	29822	\N
22724	646	3	0	29823	\N
22784	230	7	0	32020	\N
22784	5228	8	0	32021	\N
22787	453	4	0	32714	\N
22881	431	2	0	34852	\N
22881	2772	3	0	34853	\N
22738	2	6	0	35200	\N
22738	4825	7	0	35202	\N
22695	18	6	0	40349	\N
22701	18	4	0	40350	\N
22701	2302	5	0	40353	\N
22695	6638	7	0	40354	\N
22779	18	3	0	40366	\N
22779	3621	4	0	40367	\N
22903	6684	10	1	40631	\N
22903	3227	5	0	40783	\N
22753	23	2	0	40792	\N
22903	6682	9	0	40794	\N
22753	3443	3	0	40795	\N
22749	3497	4	0	40797	\N
22678	40	3	0	41944	\N
22792	40	3	0	41947	\N
22678	372	4	0	41948	\N
22792	372	4	0	41949	\N
22845	40	4	0	41966	\N
22898	40	3	0	41967	\N
22898	372	4	0	41970	\N
22845	2796	5	0	41972	\N
22959	56	4	0	44456	\N
22959	3127	5	0	44461	\N
22812	75	3	0	45909	\N
22812	3855	4	0	45912	\N
22888	88	4	0	47118	\N
22888	3809	5	0	47120	\N
22866	102	4	0	47890	\N
22866	3572	5	0	47896	\N
22902	119	3	0	48528	\N
22902	2860	4	0	48541	\N
22769	135	4	0	49472	\N
22769	3696	5	0	49474	\N
23025	135	3	0	49480	\N
23025	3630	4	0	49482	\N
23027	137	1	0	49714	\N
23027	138	2	0	49718	\N
22979	170	2	0	50596	\N
22979	1380	3	0	50600	\N
22897	210	4	0	51786	\N
22897	3536	5	0	51787	\N
22995	210	6	0	51793	\N
22995	3721	7	0	51794	\N
22996	285	14	0	53435	\N
22996	2118	15	0	53439	\N
22764	451	5	0	55262	\N
22764	6653	6	0	55276	\N
22833	6669	5	0	56598	\N
22890	908	47	0	57640	\N
22890	6681	48	0	57642	\N
22934	1470	4	0	58244	\N
22934	5655	5	0	58245	\N
22868	2578	4	0	58631	\N
22868	3902	5	0	58632	\N
22900	3625	3	0	59486	\N
22862	4088	4	0	59924	\N
22862	4089	5	0	59927	\N
22943	4233	6	0	60043	\N
22943	6704	7	0	60044	\N
22963	4233	3	0	60046	\N
22963	4425	4	0	60049	\N
22985	4233	10	0	60051	\N
22985	6719	11	0	60055	\N
22857	5885	5	0	60498	\N
22857	6212	6	0	60501	\N
22933	6692	4	1	60564	\N
22833	6668	4	1	60566	\N
22809	6665	4	0	60833	\N
23005	6724	4	0	60850	\N
23011	6726	9	0	1065	\N
23002	3514	4	0	1471	\N
22939	189	3	0	4857	\N
22939	3782	4	0	4860	\N
22785	373	3	0	5379	\N
22785	3590	4	0	5380	\N
22766	4178	3	0	6822	\N
22766	4211	4	0	6823	\N
22773	4178	21	0	6826	\N
22778	4178	3	0	6827	\N
22778	4211	4	0	6828	\N
22791	4450	1	0	6829	\N
22773	6655	22	0	6830	\N
22791	4178	12	0	6832	\N
22781	4205	5	0	6833	\N
22791	6660	13	0	6834	\N
22846	4178	5	0	6839	\N
22846	4429	6	0	6840	\N
22968	4178	6	0	6864	\N
22968	4250	7	0	6866	\N
22982	4178	8	0	6867	\N
22982	4237	9	0	6870	\N
23022	4178	3	0	6874	\N
23022	4211	4	0	6875	\N
22759	4219	5	0	9201	\N
22802	4275	4	0	9207	\N
22936	4172	4	0	9220	\N
22936	4219	5	0	9222	\N
23018	108	13	0	11744	\N
23018	6731	14	0	11746	\N
22794	108	6	0	11923	\N
22796	108	2	0	11924	\N
22796	501	3	0	11925	\N
22794	5748	7	0	11926	\N
22987	528	6	0	12470	\N
22987	6720	7	0	12475	\N
22775	123	3	0	12723	\N
23007	77	3	0	13061	\N
23008	77	2	0	13062	\N
23008	3853	3	0	13063	\N
23007	1877	4	0	13064	\N
22826	44	7	0	16033	\N
22826	4511	8	0	16037	\N
22976	38	2	0	16310	\N
22976	4009	3	0	16312	\N
22933	6691	4	0	16962	\N
22798	212	6	0	17074	\N
22798	3554	7	0	17079	\N
22949	30	3	0	18164	\N
22933	6700	5	0	18395	\N
22892	208	3	0	19248	\N
22892	4490	4	0	19250	\N
22833	60	3	0	19396	\N
22833	6667	4	0	19399	\N
22974	64	3	0	20694	\N
22974	4217	4	0	20695	\N
22801	164	4	0	21025	\N
22801	4152	5	0	21027	\N
22933	6701	5	1	21734	\N
22929	440	63	0	21746	\N
22933	440	3	0	21748	\N
22899	145	3	0	21902	\N
22899	4908	4	0	21903	\N
22926	145	4	0	21933	\N
22926	3867	5	0	21934	\N
22919	149	29	0	23355	\N
22921	149	4	0	23356	\N
22921	4040	5	0	23357	\N
22919	6688	30	0	23358	\N
22814	16	3	0	29009	\N
22831	16	4	0	29011	\N
22814	3634	4	0	29012	\N
22831	3546	5	0	29014	\N
22838	4723	8	0	29018	\N
22844	16	3	0	29019	\N
22844	3634	4	0	29020	\N
22909	16	3	0	29029	\N
22909	3634	4	0	29030	\N
22914	16	4	0	29031	\N
22914	3546	5	0	29032	\N
22924	3515	5	0	29472	\N
22946	20	3	0	30401	\N
22946	2844	4	0	30408	\N
22788	453	3	0	32715	\N
22941	453	97	0	32717	\N
22941	6702	98	0	32724	\N
22955	453	3	0	32734	\N
22955	2838	4	0	32735	\N
22771	2	6	0	35228	\N
22771	4825	7	0	35230	\N
22938	2	3	0	35241	\N
22938	3548	4	0	35243	\N
22998	2	3	0	35257	\N
22998	3548	4	0	35259	\N
22821	27	4	0	40954	\N
22821	3717	5	0	40955	\N
22911	40	3	0	41968	\N
23013	40	3	0	41992	\N
23013	372	4	0	41994	\N
22952	56	8	0	44455	\N
22977	56	2	0	44457	\N
22981	56	8	0	44458	\N
22977	2795	3	0	44459	\N
22952	6708	9	0	44462	\N
22981	4150	9	0	44463	\N
22993	56	3	0	44465	\N
22993	4109	4	0	44466	\N
22980	6716	102	0	50583	\N
22980	170	121	0	50604	\N
22980	6717	122	0	50605	\N
22991	186	5	0	51180	\N
22991	3280	6	0	51188	\N
22972	279	2	0	53211	\N
22972	4525	3	0	53214	\N
22999	1470	3	0	58254	\N
22999	3838	4	0	58255	\N
22900	3784	4	0	59489	\N
22942	4233	8	0	60042	\N
22942	6703	9	0	60045	\N
22965	4233	2	0	60047	\N
22965	6713	3	0	60048	\N
22984	4233	3	0	60050	\N
22986	4233	2	0	60052	\N
22986	6713	3	0	60053	\N
22984	4425	4	0	60054	\N
22930	6692	4	1	60567	\N
23010	6044	8	0	60624	\N
23012	6044	7	0	60625	\N
23012	6727	8	0	60627	\N
23010	6725	9	0	60628	\N
23017	6729	14	1	60735	\N
22915	4118	5	0	3136	\N
22969	262	2	0	3746	\N
22969	2743	3	0	3748	\N
22958	4607	5	0	3749	\N
22966	35	4	0	4186	\N
22967	35	3	0	4187	\N
22967	3563	4	0	4188	\N
22966	3545	5	0	4189	\N
22917	373	4	0	5381	\N
22917	6687	5	0	5382	\N
22912	4178	3	0	6849	\N
22912	4211	4	0	6851	\N
22927	4211	4	0	6852	\N
22944	4178	16	0	6856	\N
22947	4178	3	0	6857	\N
22951	4178	8	0	6858	\N
22947	4211	4	0	6859	\N
22937	4205	5	0	6860	\N
22951	4218	9	0	6861	\N
22944	4708	17	0	6862	\N
22962	4178	3	0	6863	\N
22962	4211	4	0	6865	\N
22994	4178	4	0	6868	\N
22994	4205	5	0	6869	\N
23001	4178	3	0	6871	\N
23001	4211	4	0	6873	\N
22957	4172	19	0	9221	\N
22957	6603	20	0	9223	\N
23003	4172	3	0	9224	\N
23021	4172	0	0	9225	\N
23023	4172	0	0	9226	\N
23003	4275	4	0	9227	\N
22907	132	15	0	11283	\N
22907	6685	16	0	11286	\N
23017	6728	14	0	11633	\N
23017	108	13	0	11743	\N
23019	108	13	0	11745	\N
22960	300	4	0	12074	\N
22960	6350	5	0	12075	\N
22988	528	4	0	12471	\N
22988	5689	5	0	12473	\N
23006	123	3	0	12735	\N
23006	2856	4	0	12738	\N
22970	58	2	0	13488	\N
22970	2853	3	0	13490	\N
22910	92	3	0	15018	\N
22910	4410	4	0	15020	\N
22989	192	5	0	15498	\N
22989	6721	6	0	15501	\N
22975	3457	4	0	16313	\N
22931	6697	2	0	16954	\N
22930	6691	4	0	16958	\N
22950	6706	48	0	17335	\N
22948	326	3	0	17345	\N
22948	3339	4	0	17346	\N
22950	326	126	0	17347	\N
22950	6707	127	0	17348	\N
22931	6695	1	0	18375	\N
22932	6695	0	0	18376	\N
22930	6693	5	0	18377	\N
22973	6695	5	0	18378	\N
23017	6730	15	0	18768	\N
22971	208	2	0	19258	\N
22971	4524	3	0	19262	\N
22973	3911	4	0	20686	\N
22973	6714	5	0	20696	\N
23014	64	3	0	20708	\N
23015	64	1	0	20709	\N
23015	65	2	0	20713	\N
23014	4217	4	0	20715	\N
22945	164	16	0	21026	\N
22945	6705	17	0	21028	\N
22964	164	3	0	21040	\N
22978	517	2	0	21625	\N
22978	6715	3	0	21626	\N
22931	6696	1	0	21743	\N
22932	6696	0	0	21744	\N
22928	440	20	0	21745	\N
22930	440	3	0	21747	\N
22930	6694	5	1	21753	\N
22931	6699	3	0	21754	\N
22928	6689	21	0	21756	\N
22954	149	3	0	23360	\N
22954	4189	4	0	23361	\N
22953	6709	14	0	23365	\N
22953	149	53	0	23370	\N
22953	6710	54	0	23371	\N
23020	149	58	0	23372	\N
23020	6732	59	0	23373	\N
22961	140	3	0	23978	\N
22961	4149	4	0	23981	\N
23004	42	4	0	27544	\N
23004	3896	5	0	27545	\N
22983	449	7	0	29831	\N
22983	6718	8	0	29833	\N
22935	202	4	0	31009	\N
22935	3673	5	0	31015	\N
22990	6722	5	0	32583	\N
22940	453	3	0	32716	\N
22940	2838	4	0	32720	\N
22956	6711	22	0	32725	\N
22956	453	40	0	32736	\N
22956	6712	41	0	32737	\N
23000	2	3	0	35270	\N
23000	3548	4	0	35274	\N
22992	18	5	0	40369	\N
22992	3550	6	0	40370	\N
23024	18	3	0	40372	\N
23024	3621	4	0	40381	\N
22904	3189	5	0	40798	\N
22997	40	3	0	41990	\N
23009	40	8	0	41991	\N
22997	372	4	0	41993	\N
23009	3718	9	0	41995	\N
23031	56	3	0	44470	\N
23031	4109	4	0	44473	\N
23046	75	3	0	45911	\N
23046	3855	4	0	45913	\N
23051	121	3	0	48864	\N
23051	4471	4	0	48867	\N
23034	125	10	0	49231	\N
23034	6733	11	0	49232	\N
23087	135	3	0	49481	\N
23087	3630	4	0	49483	\N
23088	137	3	0	49715	\N
23142	137	7	0	49716	\N
23088	3633	4	0	49719	\N
23142	4722	8	0	49722	\N
23030	181	3	0	50996	\N
23044	181	4	0	50997	\N
23070	181	3	0	50998	\N
23030	4184	4	0	51000	\N
23070	4184	4	0	51001	\N
23044	4058	5	0	51002	\N
23053	200	7	0	51520	\N
23053	5445	8	0	51522	\N
23048	210	7	0	51803	\N
23048	5940	8	0	51806	\N
23067	285	6	0	53447	\N
23067	3903	7	0	53449	\N
23162	285	5	0	53459	\N
23162	5103	6	0	53460	\N
23085	451	2	0	55264	\N
23086	451	3	0	55265	\N
23085	3317	3	0	55273	\N
23086	3934	4	0	55275	\N
23054	1109	7	0	56313	\N
23054	4145	8	0	56318	\N
23052	637	2	0	56360	\N
23052	6738	3	0	56361	\N
23131	793	5	0	56865	\N
23131	6750	6	0	56868	\N
23115	852	10	0	57473	\N
23115	6744	11	0	57478	\N
23064	908	4	0	57651	\N
23064	3488	5	0	57652	\N
23041	1130	3	0	57826	\N
23041	6736	4	0	57828	\N
23132	6751	7	0	60574	\N
23161	6763	3	0	60849	\N
23078	6739	5	0	60851	\N
23081	3611	4	0	710	\N
23068	4183	7	0	1472	\N
23037	954	10	0	1819	\N
23037	6735	11	0	1820	\N
23039	4178	7	0	6876	\N
23045	4178	4	0	6877	\N
23045	4205	5	0	6878	\N
23039	4396	8	0	6879	\N
23058	4211	3	0	6880	\N
23058	4178	5	0	6881	\N
23058	4460	6	0	6882	\N
23061	4178	6	0	6883	\N
23074	4178	3	0	6884	\N
23061	4250	7	0	6888	\N
23112	4178	3	0	6889	\N
23112	4211	4	0	6890	\N
23029	4172	2	0	9228	\N
23029	4191	3	0	9229	\N
23040	4172	3	0	9230	\N
23040	4275	4	0	9231	\N
23050	4172	3	0	9232	\N
23082	4172	4	0	9233	\N
23050	4275	4	0	9234	\N
23082	4219	5	0	9235	\N
23093	4172	7	0	9236	\N
23073	132	4	0	11302	\N
23150	132	3	0	11303	\N
23150	3729	4	0	11305	\N
23073	3716	5	0	11307	\N
23042	528	3	0	12487	\N
23042	4262	4	0	12491	\N
23077	123	5	0	12736	\N
23079	123	4	0	12737	\N
23079	4090	5	0	12739	\N
23077	6652	6	0	12740	\N
23136	77	76	0	13071	\N
23136	6756	77	0	13075	\N
23080	4077	4	0	14330	\N
23072	92	4	0	15019	\N
23072	3979	5	0	15021	\N
23062	38	6	0	16316	\N
23062	6005	7	0	16318	\N
23143	38	3	0	16324	\N
23143	3457	4	0	16330	\N
23065	115	4	0	16896	\N
23065	4844	5	0	16903	\N
23167	3208	2	0	18387	\N
23167	6767	3	0	18392	\N
23047	142	23	0	18506	\N
23049	6504	8	0	18508	\N
23059	4254	3	0	18509	\N
23047	6737	24	0	18510	\N
23071	142	3	0	18520	\N
23059	142	5	0	18524	\N
23071	4254	4	0	18525	\N
23059	3117	6	0	18527	\N
23057	142	0	0	18528	\N
23069	142	0	0	18540	\N
23066	149	4	0	23367	\N
23026	4189	4	0	23368	\N
23066	4040	5	0	23369	\N
23043	4074	4	0	26262	\N
23089	94	72	0	27019	\N
23089	6740	73	0	27023	\N
23122	244	3	0	27236	\N
23122	4075	4	0	27237	\N
23155	244	2	0	27246	\N
23155	3308	3	0	27250	\N
23035	42	10	0	27555	\N
23076	42	2	0	27556	\N
23076	3310	3	0	27557	\N
23035	6734	11	0	27558	\N
23055	16	3	0	29034	\N
23075	16	3	0	29037	\N
23075	3634	4	0	29038	\N
23083	16	3	0	29039	\N
23083	3634	4	0	29040	\N
23090	16	17	0	29041	\N
23090	6741	18	0	29042	\N
23137	16	9	0	29046	\N
23137	6757	10	0	29052	\N
23038	96	7	0	29471	\N
23038	3750	8	0	29474	\N
23056	96	3	0	29480	\N
23056	2803	4	0	29481	\N
23036	6472	11	0	30029	\N
23033	33	7	0	31721	\N
23033	5284	8	0	31724	\N
23060	3548	3	0	35260	\N
23060	2	5	0	35275	\N
23060	1091	6	0	35277	\N
23132	2291	4	0	39126	\N
23132	6752	7	0	39140	\N
23032	18	3	0	40373	\N
23100	18	1	0	40374	\N
23100	1426	2	0	40379	\N
23032	3621	4	0	40382	\N
23128	6746	6	0	40809	\N
23084	40	10	0	42014	\N
23084	4104	11	0	42015	\N
23203	56	4	0	44472	\N
23203	3556	5	0	44475	\N
23216	56	3	0	44478	\N
23216	1188	4	0	44479	\N
23307	56	2	0	44482	\N
23307	2795	3	0	44483	\N
23124	75	7	0	45921	\N
23124	2859	8	0	45922	\N
23264	75	3	0	45926	\N
23264	3855	4	0	45931	\N
23196	79	3	0	46266	\N
23196	3652	4	0	46272	\N
23337	79	2	0	46328	\N
23337	616	3	0	46329	\N
23360	195	1	0	49242	\N
23360	125	3	0	49248	\N
23360	1185	4	0	49249	\N
23207	451	2	0	55266	\N
23211	451	1	0	55267	\N
23211	3260	2	0	55271	\N
23207	3317	3	0	55274	\N
23178	908	2	0	57660	\N
23178	2832	3	0	57661	\N
23321	2636	2	0	58744	\N
23321	2836	3	0	58746	\N
23269	2351	2	0	58962	\N
23269	2754	3	0	58966	\N
23306	2782	2	0	59296	\N
23306	2784	3	0	59298	\N
23343	5611	5	0	59795	\N
23343	6814	6	0	59796	\N
23192	5885	3	0	60503	\N
23192	5926	4	0	60505	\N
23248	6795	3	0	60727	\N
23248	6373	3	1	60731	\N
23374	6825	3	0	60748	\N
23336	424	2	0	722	\N
23227	6790	6	0	732	\N
23237	266	2	0	1192	\N
23237	2103	3	0	1193	\N
23099	6742	3	0	1908	\N
23099	6743	4	0	1909	\N
23096	1636	3	0	3134	\N
23096	5514	4	0	3135	\N
23104	1636	3	0	3137	\N
23104	5514	4	0	3138	\N
23222	6785	32	0	3297	\N
23222	367	68	0	3304	\N
23222	6786	69	0	3305	\N
23113	4607	5	0	3750	\N
23148	365	3	0	4546	\N
23288	365	2	0	4547	\N
23288	615	3	0	4549	\N
23148	3839	4	0	4550	\N
23101	189	3	0	4858	\N
23101	3782	4	0	4861	\N
23153	189	4	0	4868	\N
23153	3992	5	0	4869	\N
23314	373	0	0	5384	\N
23140	4178	7	0	6891	\N
23140	4396	8	0	6893	\N
23172	4211	4	0	6899	\N
23217	4178	2	0	6905	\N
23217	4247	3	0	6909	\N
23253	4178	2	0	6916	\N
23253	4247	3	0	6919	\N
23268	4178	2	0	6922	\N
23268	4247	3	0	6925	\N
23295	4178	4	0	6926	\N
23295	4331	5	0	6927	\N
23331	4178	2	0	6930	\N
23331	4247	3	0	6931	\N
23369	4178	4	0	6936	\N
23116	4172	4	0	9237	\N
23116	4219	5	0	9238	\N
23212	4172	2	0	9251	\N
23212	4191	3	0	9252	\N
23281	4172	2	0	9254	\N
23281	4191	3	0	9256	\N
23344	108	2	0	11755	\N
23344	3340	3	0	11757	\N
23252	258	2	0	14384	\N
23252	3275	3	0	14386	\N
23258	167	2	0	17720	\N
23258	3322	3	0	17721	\N
23179	177	126	0	18349	\N
23179	6771	127	0	18350	\N
23121	241	3	0	20423	\N
23121	3613	4	0	20424	\N
23191	241	2	0	20434	\N
23191	634	3	0	20436	\N
23248	6797	4	1	21955	\N
23308	149	4	0	23080	\N
23308	5500	5	0	23081	\N
23354	149	2	0	23087	\N
23354	1379	3	0	23090	\N
23385	264	2	0	23530	\N
23186	3345	6	0	25206	\N
23091	224	3	0	25470	\N
23091	3603	4	0	25472	\N
23315	224	4	0	25494	\N
23315	3281	5	0	25498	\N
23232	86	2	0	26663	\N
23232	3321	3	0	26665	\N
23157	244	1	0	27247	\N
23157	245	2	0	27249	\N
23373	42	2	0	27575	\N
23373	3310	3	0	27577	\N
23109	16	4	0	29045	\N
23342	16	4	0	29058	\N
23342	2575	5	0	29063	\N
23158	96	7	0	29491	\N
23158	6762	8	0	29497	\N
23248	6796	4	0	30389	\N
23187	20	2	0	30402	\N
23248	20	2	0	30403	\N
23187	369	3	0	30406	\N
23242	151	2	0	30653	\N
23242	2854	3	0	30654	\N
23094	2	7	0	35271	\N
23146	2	3	0	35272	\N
23094	2858	8	0	35278	\N
23185	2	7	0	35288	\N
23185	6780	8	0	35290	\N
23243	2	2	0	35314	\N
23243	2789	3	0	35315	\N
23302	6807	88	0	35952	\N
23350	4	4	0	35958	\N
23350	6361	5	0	35961	\N
23302	4	126	0	35962	\N
23302	6779	127	0	35963	\N
23134	2291	4	0	39128	\N
23134	14	10	0	39142	\N
23181	588	4	0	39157	\N
23181	14	13	0	39166	\N
23181	6775	14	0	39168	\N
23327	18	0	0	40394	\N
23106	40	3	0	42027	\N
23106	372	4	0	42028	\N
23231	40	2	0	42048	\N
23231	282	3	0	42049	\N
23275	40	2	0	42072	\N
23275	282	3	0	42075	\N
23361	40	3	0	42092	\N
23361	372	4	0	42093	\N
23379	282	3	0	42113	\N
23292	56	2	0	44480	\N
23292	2795	3	0	44481	\N
23340	56	4	0	44484	\N
23340	3556	5	0	44488	\N
23260	75	2	0	45925	\N
23260	284	3	0	45929	\N
23318	88	4	0	47119	\N
23318	5262	5	0	47121	\N
23266	119	2	0	48529	\N
23266	1879	3	0	48539	\N
23141	135	7	0	49492	\N
23141	4721	8	0	49496	\N
23329	137	4	0	49717	\N
23329	4352	5	0	49721	\N
23364	260	2	0	52484	\N
23364	3184	3	0	52486	\N
23189	285	2	0	53470	\N
23189	3036	3	0	53473	\N
23198	324	2	0	54210	\N
23198	2808	3	0	54211	\N
23346	324	1	0	54251	\N
23346	939	2	0	54253	\N
23214	6781	127	0	54919	\N
23376	595	2	0	55822	\N
23376	3285	3	0	55823	\N
23117	1109	1	0	56314	\N
23117	2971	2	0	56316	\N
23219	1109	5	0	56321	\N
23219	6783	6	0	56322	\N
23130	6747	121	1	56588	\N
23130	1699	126	1	56589	\N
23334	793	2	0	56866	\N
23334	4363	3	0	56867	\N
23111	2578	3	0	58635	\N
23111	4431	4	0	58636	\N
23107	2636	4	0	58730	\N
23107	3617	5	0	58735	\N
23271	2351	1	0	58963	\N
23271	2925	2	0	58965	\N
23304	2782	2	0	59295	\N
23304	2784	3	0	59297	\N
23358	6817	2	0	59481	\N
23285	5885	6	0	60504	\N
23285	6803	7	0	60506	\N
23240	6723	2	0	60853	\N
23240	6763	3	0	60859	\N
23272	6800	7	0	60914	\N
23261	2842	3	0	107	\N
23095	4926	8	0	1184	\N
23205	110	4	0	2501	\N
23377	110	5	0	2502	\N
23205	4552	5	0	2505	\N
23377	6619	6	0	2508	\N
23125	228	1	0	2808	\N
23125	1432	2	0	2810	\N
23311	367	1	0	3311	\N
23311	368	2	0	3312	\N
23290	6805	81	0	4411	\N
23290	365	126	0	4572	\N
23290	3420	127	0	4573	\N
23159	4509	8	0	6894	\N
23194	4178	3	0	6902	\N
23234	4178	1	0	6906	\N
23234	4460	2	0	6907	\N
23194	4211	4	0	6910	\N
23278	4178	1	0	6923	\N
23278	4450	2	0	6924	\N
23310	4178	2	0	6928	\N
23310	4247	3	0	6929	\N
23352	4178	4	0	6932	\N
23352	4331	5	0	6933	\N
23365	4178	4	0	6934	\N
23382	4178	2	0	6940	\N
23299	4172	2	0	9255	\N
23299	4191	3	0	9257	\N
23293	528	4	0	12488	\N
23293	3353	5	0	12492	\N
23135	5497	4	0	13065	\N
23154	77	0	0	13072	\N
23135	77	8	0	13073	\N
23135	5568	9	0	13074	\N
23209	173	2	0	14654	\N
23209	2102	3	0	14662	\N
23097	44	3	0	16028	\N
23097	3631	4	0	16030	\N
23105	3631	4	0	16031	\N
23246	115	4	0	16897	\N
23246	6794	5	0	16904	\N
23165	212	4	0	17076	\N
23165	4574	5	0	17078	\N
23371	167	2	0	17739	\N
23371	3322	3	0	17743	\N
23290	4952	81	1	18236	\N
23130	6029	121	0	18383	\N
23130	6698	126	0	18384	\N
23279	208	2	0	19259	\N
23229	62	0	0	19751	\N
23199	164	2	0	21041	\N
23199	1124	3	0	21042	\N
23174	6768	67	0	22979	\N
23174	336	126	0	22982	\N
23174	6769	127	0	22983	\N
23102	214	4	0	24513	\N
23102	3807	5	0	24515	\N
23127	69	5	0	24655	\N
23127	6745	6	0	24661	\N
23291	224	4	0	25478	\N
23291	3281	5	0	25480	\N
23250	206	7	0	25834	\N
23250	6798	8	0	25839	\N
23214	6782	127	1	26668	\N
23214	1279	50	0	27024	\N
23214	94	126	0	27031	\N
23284	6802	50	0	27032	\N
23284	94	111	0	27035	\N
23284	2018	112	0	27036	\N
23119	244	6	0	27235	\N
23119	6406	7	0	27239	\N
23298	16	4	0	29055	\N
23298	2575	5	0	29056	\N
23317	2575	5	0	29062	\N
23092	54	3	0	30038	\N
23092	3041	4	0	30039	\N
23297	33	2	0	31735	\N
23297	2822	3	0	31738	\N
23149	230	3	0	32037	\N
23149	4181	4	0	32038	\N
23225	2	5	0	35302	\N
23225	6461	6	0	35304	\N
23358	26	1	0	35316	\N
23358	6818	2	0	35330	\N
23183	684	4	0	35937	\N
23183	6777	14	0	35949	\N
23175	14	3	0	39152	\N
23175	1786	4	0	39154	\N
23339	14	2	0	39216	\N
23339	1785	3	0	39217	\N
23324	18	1	0	40391	\N
23324	1426	2	0	40392	\N
23130	6748	122	0	40799	\N
23130	23	125	0	40810	\N
23130	6749	127	0	40811	\N
23255	27	2	0	40964	\N
23255	645	3	0	40966	\N
23170	372	4	0	42050	\N
23235	40	2	0	42071	\N
23235	282	3	0	42074	\N
23110	56	3	0	44471	\N
23110	4109	4	0	44474	\N
23129	79	5	0	46265	\N
23197	79	1	0	46267	\N
23208	79	2	0	46268	\N
23338	79	0	0	46269	\N
23197	1126	2	0	46270	\N
23208	616	3	0	46271	\N
23129	5993	6	0	46273	\N
23356	125	4	0	49240	\N
23356	3356	5	0	49241	\N
23380	125	2	0	49247	\N
23380	3297	3	0	49250	\N
23328	135	0	0	49493	\N
23188	156	2	0	50324	\N
23188	4485	3	0	50325	\N
23363	186	2	0	51181	\N
23363	1850	3	0	51183	\N
23171	210	3	0	51804	\N
23171	3539	4	0	51805	\N
23139	285	7	0	53448	\N
23139	5812	8	0	53450	\N
23296	285	2	0	53471	\N
23296	3036	3	0	53474	\N
23276	324	2	0	54242	\N
23276	2808	3	0	54243	\N
23333	6813	0	0	55112	\N
23375	597	2	0	56090	\N
23375	3286	3	0	56094	\N
23120	1109	6	0	56315	\N
23120	4548	7	0	56317	\N
23386	841	2	0	56964	\N
23386	3316	3	0	56967	\N
23218	852	2	0	57481	\N
23218	2872	3	0	57482	\N
23345	2636	2	0	58745	\N
23345	2836	3	0	58747	\N
23333	6812	0	0	59437	\N
23265	3625	2	0	59487	\N
23265	4359	3	0	59488	\N
23138	6044	9	0	60629	\N
23138	6758	10	0	60630	\N
23223	6787	0	0	60733	\N
23164	6766	5	0	60912	\N
23387	251	4	0	1477	\N
23126	228	3	0	2809	\N
23126	3186	4	0	2811	\N
23233	6323	2	0	3214	\N
23233	6792	3	0	3216	\N
23151	6648	81	0	4539	\N
23151	365	126	0	4556	\N
23151	6759	127	0	4557	\N
23282	1151	2	0	5198	\N
23282	6801	3	0	5199	\N
23223	6788	0	0	5383	\N
23103	4178	3	0	6885	\N
23103	4211	4	0	6887	\N
23213	4247	3	0	6908	\N
23238	4178	2	0	6914	\N
23238	4247	3	0	6917	\N
23144	4172	4	0	9240	\N
23144	4219	5	0	9241	\N
23145	4172	3	0	9242	\N
23145	4275	4	0	9243	\N
23147	4172	10	0	9244	\N
23147	4663	11	0	9245	\N
23177	4172	4	0	9247	\N
23177	4219	5	0	9249	\N
23193	4172	3	0	9250	\N
23309	4172	2	0	9259	\N
23381	4172	2	0	9260	\N
23309	4191	3	0	9262	\N
23381	4191	3	0	9264	\N
23390	4172	10	0	9265	\N
23390	6829	11	0	9266	\N
23322	528	2	0	12489	\N
23322	2765	3	0	12490	\N
23160	123	2	0	12752	\N
23239	123	2	0	12753	\N
23160	1868	3	0	12754	\N
23239	1868	3	0	12755	\N
23156	77	48	0	13091	\N
23156	6761	49	0	13092	\N
23166	58	2	0	13489	\N
23166	2853	3	0	13491	\N
23249	58	2	0	13504	\N
23249	2853	3	0	13505	\N
23332	6810	86	0	15023	\N
23332	92	99	0	15034	\N
23332	6811	100	0	15035	\N
23283	38	2	0	16334	\N
23283	4009	3	0	16337	\N
23245	167	4	0	17719	\N
23370	167	0	0	17738	\N
23163	30	5	0	18165	\N
23163	6764	6	0	18168	\N
23228	6791	124	0	19736	\N
23224	62	0	0	19749	\N
23228	62	126	0	19761	\N
23228	3130	127	0	19762	\N
23362	488	2	0	21435	\N
23362	2791	3	0	21436	\N
23180	6774	10	0	21935	\N
23204	145	4	0	21949	\N
23204	5607	5	0	21952	\N
23355	2780	3	0	23515	\N
23357	140	2	0	23979	\N
23357	3183	3	0	23980	\N
23277	244	4	0	27248	\N
23277	3447	5	0	27251	\N
23098	16	6	0	29043	\N
23098	3369	7	0	29044	\N
23254	6799	2	0	29053	\N
23254	388	3	0	29054	\N
23351	16	4	0	29059	\N
23351	2575	5	0	29064	\N
23123	449	3	0	29842	\N
23108	230	4	0	32032	\N
23108	3954	5	0	32033	\N
23259	322	2	0	32590	\N
23259	1866	3	0	32593	\N
23316	431	4	0	34854	\N
23316	3565	5	0	34855	\N
23184	6778	88	0	35938	\N
23184	4	126	0	35950	\N
23184	6779	127	0	35951	\N
23289	6	2	0	36293	\N
23289	2805	3	0	36294	\N
23133	2291	4	0	39127	\N
23133	6755	11	0	39144	\N
23176	14	5	0	39153	\N
23176	5648	6	0	39155	\N
23180	588	4	0	39156	\N
23180	14	8	0	39165	\N
23270	14	2	0	39182	\N
23270	1785	3	0	39183	\N
23303	14	2	0	39197	\N
23323	14	2	0	39199	\N
23303	1785	3	0	39200	\N
23323	1785	3	0	39202	\N
23118	18	0	0	40342	\N
23244	6793	7	0	40385	\N
23388	18	1	0	40397	\N
23388	19	2	0	40398	\N
23152	40	4	0	42045	\N
23152	3381	5	0	42051	\N
23391	40	10	0	42111	\N
23325	75	2	0	45927	\N
23325	284	3	0	45930	\N
23450	6842	12	0	46059	\N
23395	79	2	0	46379	\N
23395	3180	3	0	46383	\N
23450	80	2	0	46387	\N
23450	79	11	0	46432	\N
23257	100	2	0	47525	\N
23257	633	3	0	47526	\N
23195	268	3	0	52614	\N
23195	3815	4	0	52616	\N
23286	268	6	0	52623	\N
23286	6804	7	0	52626	\N
23442	268	2	0	52632	\N
23442	2800	3	0	52643	\N
23201	273	3	0	52950	\N
23201	3638	4	0	52951	\N
23280	279	2	0	53221	\N
23280	4525	3	0	53222	\N
23313	285	5	0	53472	\N
23313	5103	6	0	53475	\N
23220	1109	2	0	56323	\N
23220	2809	3	0	56324	\N
23427	852	2	0	57483	\N
23427	2872	3	0	57484	\N
23320	908	2	0	57672	\N
23320	2832	3	0	57673	\N
23300	2636	2	0	58731	\N
23300	2836	3	0	58733	\N
23450	6843	12	1	59482	\N
23267	3628	2	0	59681	\N
23267	4360	3	0	59688	\N
23366	6819	1	0	60460	\N
23366	6822	2	1	60461	\N
23417	5885	2	0	60507	\N
23417	6838	3	0	60509	\N
23366	6821	2	0	60732	\N
23458	6723	3	0	60854	\N
23458	6724	4	0	60860	\N
23341	288	4	0	117	\N
23383	3248	12	0	1055	\N
23383	6826	13	0	1056	\N
23453	266	2	0	1198	\N
23453	2103	3	0	1199	\N
23353	2583	106	0	2342	\N
23378	110	4	0	2503	\N
23378	4552	5	0	2506	\N
23221	367	3	0	3302	\N
23221	6784	4	0	3303	\N
23312	6808	90	0	3306	\N
23312	367	110	0	3313	\N
23312	6809	111	0	3314	\N
23366	6820	1	0	5389	\N
23182	4179	4	0	6895	\N
23190	4178	2	0	6897	\N
23190	4247	3	0	6898	\N
23182	4178	13	0	6900	\N
23182	6776	14	0	6901	\N
23202	4178	4	0	6903	\N
23202	4331	5	0	6911	\N
23236	4178	2	0	6912	\N
23236	4247	3	0	6913	\N
23241	4178	2	0	6915	\N
23241	4247	3	0	6918	\N
23263	4211	4	0	6921	\N
23372	4178	2	0	6937	\N
23372	4247	3	0	6938	\N
23169	4172	3	0	9246	\N
23169	4275	4	0	9248	\N
23359	4201	1	0	9258	\N
23359	4172	3	0	9261	\N
23359	5004	4	0	9263	\N
23413	3818	4	0	11948	\N
23462	6845	108	0	12978	\N
23409	77	2	0	13089	\N
23409	3853	3	0	13090	\N
23461	1877	4	0	13104	\N
23335	58	2	0	13523	\N
23335	2853	3	0	13524	\N
23347	173	1	0	14655	\N
23347	1927	2	0	14656	\N
23330	92	2	0	15028	\N
23330	2763	3	0	15031	\N
23348	235	2	0	15665	\N
23348	2757	3	0	15666	\N
23273	212	6	0	17104	\N
23273	4266	7	0	17105	\N
23430	212	2	0	17128	\N
23287	167	2	0	17731	\N
23287	3322	3	0	17732	\N
23353	4915	105	0	18222	\N
23462	973	108	1	18396	\N
23353	6816	104	1	18397	\N
23353	6199	105	1	18742	\N
23366	3268	3	0	18799	\N
23455	290	3	0	18948	\N
23455	3635	4	0	18949	\N
23226	62	5	0	19750	\N
23368	62	4	0	19752	\N
23368	6824	5	0	19756	\N
23200	164	2	0	21054	\N
23200	1124	3	0	21055	\N
23262	488	2	0	21425	\N
23262	2791	3	0	21426	\N
23413	6836	4	0	22443	\N
23413	2827	5	0	22444	\N
23173	336	2	0	22980	\N
23173	3332	3	0	22981	\N
23349	336	4	0	22984	\N
23349	3378	5	0	22986	\N
23384	140	4	0	23991	\N
23384	6827	5	0	23992	\N
23230	411	2	0	25216	\N
23230	3370	3	0	25220	\N
23367	94	4	0	27020	\N
23367	6644	5	0	27022	\N
23247	16	4	0	29047	\N
23256	16	2	0	29048	\N
23256	388	3	0	29049	\N
23247	2575	5	0	29051	\N
23403	16	2	0	29060	\N
23403	388	3	0	29061	\N
23251	20	2	0	30404	\N
23251	369	3	0	30407	\N
23274	33	2	0	31734	\N
23206	2822	3	0	31736	\N
23274	2822	3	0	31737	\N
23294	230	4	0	32042	\N
23294	6806	5	0	32044	\N
23210	322	1	0	32589	\N
23210	2968	2	0	32592	\N
23353	6815	104	0	35827	\N
23301	4	2	0	35946	\N
23301	2751	3	0	35947	\N
23353	6778	88	0	35964	\N
23353	4	103	0	35977	\N
23404	5953	9	0	36300	\N
23305	14	2	0	39198	\N
23305	1785	3	0	39201	\N
23215	40	3	0	42047	\N
23215	1921	4	0	42052	\N
23319	40	2	0	42073	\N
23319	282	3	0	42076	\N
23326	40	4	0	42091	\N
23326	2796	5	0	42094	\N
23398	40	2	0	42112	\N
23398	282	3	0	42114	\N
23648	40	4	0	42205	\N
23648	3381	5	0	42206	\N
23419	56	3	0	44486	\N
23419	1188	4	0	44487	\N
23471	56	4	0	44490	\N
23471	3127	5	0	44492	\N
23602	56	3	0	44494	\N
23602	4109	4	0	44495	\N
22524	71	3	0	44721	\N
22687	71	4	0	44744	\N
23422	3361	7	0	45932	\N
23463	75	9	0	45935	\N
23463	4685	10	0	45936	\N
23412	160	1	0	47527	\N
23412	100	3	0	47540	\N
23412	2895	4	0	47541	\N
23663	121	2	0	48874	\N
23663	2498	3	0	48875	\N
23579	186	4	0	51200	\N
23579	6866	5	0	51201	\N
23641	260	3	0	52492	\N
23641	3399	4	0	52494	\N
23436	279	2	0	53227	\N
23436	4525	3	0	53229	\N
23482	285	3	0	53492	\N
23482	4496	4	0	53494	\N
23570	451	4	0	55270	\N
23570	3391	5	0	55280	\N
23529	1109	15	0	56332	\N
23529	6859	16	0	56334	\N
23656	793	3	0	56869	\N
23656	2644	4	0	56871	\N
23393	1470	4	0	58268	\N
23393	2798	5	0	58270	\N
23429	2351	2	0	58964	\N
23429	2754	3	0	58967	\N
23651	6881	4	0	58982	\N
23651	2351	8	0	58987	\N
23651	2845	9	0	58991	\N
23425	2782	2	0	59303	\N
23425	2784	3	0	59306	\N
23519	2782	8	0	59314	\N
23519	5680	9	0	59321	\N
23585	3628	4	0	59682	\N
23585	3803	5	0	59694	\N
23476	6847	4	0	60750	\N
23551	6861	8	0	60913	\N
23444	6148	3	0	2286	\N
23618	5514	4	0	3146	\N
23399	4178	2	0	6941	\N
23434	4178	2	0	6942	\N
23441	4178	2	0	6943	\N
23448	4178	2	0	6944	\N
23468	4178	3	0	6945	\N
23382	4247	3	0	6946	\N
23399	4247	3	0	6947	\N
23434	4247	3	0	6948	\N
23441	4247	3	0	6949	\N
23448	4247	3	0	6950	\N
23468	4211	4	0	6951	\N
23558	6623	7	0	6973	\N
23594	4178	6	0	6974	\N
23594	4250	7	0	6981	\N
23629	4178	3	0	6986	\N
23639	4178	9	0	6987	\N
23644	4178	7	0	6988	\N
23646	4178	3	0	6989	\N
23629	4211	4	0	6992	\N
23646	4211	4	0	6993	\N
23644	4396	8	0	6995	\N
23639	6592	10	0	6997	\N
23470	4172	4	0	9274	\N
23510	4172	4	0	9277	\N
23522	4172	10	0	9278	\N
23543	4172	3	0	9279	\N
23543	4275	4	0	9280	\N
23510	4219	5	0	9281	\N
23522	4663	11	0	9282	\N
23531	391	4	0	10937	\N
23531	3913	5	0	10938	\N
23563	391	4	0	10948	\N
23563	3352	5	0	10952	\N
23462	6846	115	0	12980	\N
23410	6834	109	0	13093	\N
23410	6835	127	0	13107	\N
23462	77	114	0	13127	\N
23515	233	4	0	13960	\N
23515	3775	5	0	13961	\N
23416	173	32	0	14670	\N
23416	6837	33	0	14678	\N
23457	92	3	0	15029	\N
23498	92	4	0	15030	\N
23457	4410	4	0	15032	\N
23498	3979	5	0	15033	\N
23573	44	3	0	16018	\N
23573	3631	4	0	16021	\N
23568	6005	7	0	16349	\N
23631	1792	2	0	16590	\N
23631	6096	3	0	16592	\N
23605	115	3	0	16907	\N
23605	3483	4	0	16909	\N
23462	4952	109	0	18217	\N
23462	3108	115	1	18792	\N
23581	208	3	0	19261	\N
23581	4490	4	0	19265	\N
23624	60	11	0	19411	\N
23624	6874	12	0	19415	\N
23598	64	32	0	20711	\N
23507	164	3	0	21064	\N
23507	3385	4	0	21066	\N
23465	145	4	0	21950	\N
23465	3867	5	0	21951	\N
23600	73	14	0	22460	\N
23600	6870	15	0	22462	\N
23445	69	0	0	24658	\N
23466	411	4	0	25218	\N
23466	4858	5	0	25223	\N
23588	224	3	0	25495	\N
23588	3603	4	0	25497	\N
23503	42	7	0	27576	\N
23621	16	4	0	29068	\N
23621	3546	5	0	29071	\N
23533	20	3	0	30405	\N
23533	2844	4	0	30409	\N
23636	20	7	0	30413	\N
23636	4714	8	0	30414	\N
23617	360	6	0	31341	\N
23617	5788	7	0	31346	\N
23495	230	4	0	32051	\N
23495	3954	5	0	32054	\N
23626	6875	21	0	32584	\N
23626	322	126	0	32595	\N
23437	2	2	0	35367	\N
23437	2789	3	0	35372	\N
23575	4	4	0	35972	\N
23575	4117	5	0	35976	\N
23452	14	2	0	39227	\N
23486	14	0	0	39228	\N
23452	1785	3	0	39232	\N
23389	18	0	0	40404	\N
23657	18	5	0	40429	\N
23657	6885	6	0	40431	\N
23561	23	4	0	40807	\N
23561	3189	5	0	40808	\N
23565	3379	5	0	40975	\N
23490	40	3	0	42134	\N
23490	372	4	0	42136	\N
23587	40	3	0	42186	\N
23633	40	3	0	42187	\N
23587	372	4	0	42188	\N
23633	372	4	0	42189	\N
23659	40	10	0	42241	\N
23659	4104	11	0	42244	\N
23635	56	3	0	44496	\N
23635	4109	4	0	44498	\N
23596	75	7	0	45939	\N
23596	2859	8	0	45940	\N
23420	79	2	0	46381	\N
23420	616	3	0	46384	\N
23493	88	6	0	47126	\N
23493	5263	7	0	47129	\N
23583	88	4	0	47146	\N
23583	3809	5	0	47147	\N
23405	100	8	0	47539	\N
23405	6832	9	0	47542	\N
23549	102	7	0	47891	\N
23549	5310	8	0	47897	\N
23661	121	3	0	48873	\N
23661	4471	4	0	48876	\N
23511	135	4	0	49494	\N
23511	3696	5	0	49495	\N
23674	137	5	0	49753	\N
23674	3346	6	0	49759	\N
23556	170	6	0	50597	\N
23556	6862	7	0	50603	\N
23536	181	9	0	51013	\N
23536	6860	10	0	51014	\N
23615	181	6	0	51040	\N
23615	4256	7	0	51043	\N
23451	200	2	0	51533	\N
23451	276	3	0	51534	\N
23401	260	2	0	52485	\N
23401	3184	3	0	52487	\N
23418	268	2	0	52624	\N
23418	2800	3	0	52625	\N
23686	273	3	0	52970	\N
23686	3638	4	0	52971	\N
23647	316	3	0	53890	\N
23647	4249	4	0	53891	\N
23569	451	4	0	55269	\N
23569	3391	5	0	55279	\N
23475	597	3	0	56091	\N
23475	3656	4	0	56095	\N
23592	2351	6	0	58972	\N
23595	2351	13	0	58973	\N
23592	6867	7	0	58974	\N
23595	6868	14	0	58975	\N
23652	6881	4	0	58983	\N
23652	2351	7	0	58988	\N
23652	2754	8	0	58989	\N
23423	2782	1	0	59301	\N
23423	3873	2	0	59305	\N
23679	4088	0	0	59809	\N
23439	5885	2	0	60508	\N
23439	6838	3	0	60510	\N
23654	6882	4	0	60729	\N
23431	6841	3	0	60910	\N
23547	4204	4	0	261	\N
23534	266	3	0	1208	\N
23534	3474	4	0	1211	\N
23689	117	4	0	1988	\N
23689	3835	5	0	1990	\N
23397	2583	100	0	2343	\N
23671	110	7	0	2522	\N
23671	4621	8	0	2524	\N
23508	1636	3	0	3139	\N
23508	5514	4	0	3140	\N
23397	6831	99	0	4412	\N
23397	6830	81	0	4414	\N
23392	365	4	0	4548	\N
23397	365	98	0	4592	\N
23484	4178	6	0	6954	\N
23484	4250	7	0	6955	\N
23520	4178	8	0	6958	\N
23520	6776	9	0	6961	\N
23524	4178	3	0	6962	\N
23524	4211	4	0	6963	\N
23532	4178	4	0	6964	\N
23532	4205	5	0	6967	\N
23544	4178	3	0	6968	\N
23544	4211	4	0	6969	\N
23613	4178	10	0	6977	\N
23627	4178	7	0	6984	\N
23627	4396	8	0	6985	\N
23407	4172	4	0	9267	\N
23407	4252	5	0	9268	\N
23464	4172	6	0	9271	\N
23464	4197	7	0	9272	\N
23554	4172	6	0	9283	\N
23554	4197	7	0	9284	\N
23589	4172	4	0	9285	\N
23589	4219	5	0	9291	\N
23459	123	3	0	12771	\N
23459	2856	4	0	12780	\N
23517	6854	6	0	13531	\N
23682	92	8	0	15044	\N
23682	6888	9	0	15045	\N
23654	6883	4	1	16985	\N
23654	212	3	0	17130	\N
23642	326	3	0	17353	\N
23642	3339	4	0	17354	\N
23397	3108	99	1	18797	\N
23473	290	3	0	18954	\N
23435	208	2	0	19260	\N
23435	4524	3	0	19264	\N
23610	60	3	0	19409	\N
23610	3585	4	0	19413	\N
23622	6872	9	0	19414	\N
23637	577	7	0	20346	\N
23637	6878	8	0	20347	\N
23668	164	3	0	21089	\N
23668	3385	4	0	21091	\N
23414	73	4	0	22448	\N
23414	2827	5	0	22451	\N
23385	2780	3	0	23531	\N
23527	930	0	0	23920	\N
23443	69	0	0	24657	\N
23446	69	0	0	24659	\N
23630	69	7	0	24686	\N
23630	3711	8	0	24688	\N
23537	3672	11	0	24689	\N
23432	411	2	0	25217	\N
23432	3370	3	0	25221	\N
23491	206	3	0	25829	\N
23501	206	3	0	25830	\N
23491	4584	4	0	25831	\N
23501	4584	4	0	25832	\N
23539	6303	3	0	26334	\N
23539	6304	4	0	26336	\N
23576	94	4	0	27027	\N
23640	244	9	0	27258	\N
23640	6880	10	0	27259	\N
23496	54	4	0	30062	\N
23496	3685	5	0	30064	\N
23400	2	2	0	35349	\N
23400	2789	3	0	35350	\N
23454	6844	95	0	39218	\N
23454	14	96	0	39234	\N
23607	18	7	0	40422	\N
23607	2506	8	0	40425	\N
23571	23	3	0	40818	\N
23571	3497	4	0	40819	\N
23472	3717	5	0	40974	\N
23504	40	3	0	42135	\N
23504	372	4	0	42137	\N
23564	40	4	0	42185	\N
23564	2796	5	0	42190	\N
23653	40	3	0	42223	\N
23653	372	4	0	42224	\N
23415	56	4	0	44485	\N
23415	3556	5	0	44489	\N
23685	56	3	0	44497	\N
23685	4109	4	0	44499	\N
23396	79	4	0	46380	\N
23421	79	37	0	46382	\N
23396	2758	5	0	46385	\N
23421	6839	38	0	46386	\N
23449	79	2	0	46430	\N
23449	616	3	0	46431	\N
23698	79	11	0	46475	\N
23698	6891	12	0	46478	\N
23512	137	4	0	49752	\N
23512	3697	5	0	49758	\N
23514	156	4	0	50335	\N
23514	5935	5	0	50339	\N
23606	181	3	0	51029	\N
23606	4184	4	0	51030	\N
23691	273	3	0	52978	\N
23691	3638	4	0	52979	\N
23525	285	3	0	53493	\N
23525	4496	4	0	53495	\N
23612	285	10	0	53500	\N
23612	5921	11	0	53501	\N
23394	451	4	0	55268	\N
23394	3391	5	0	55278	\N
23474	595	3	0	55824	\N
23474	3654	4	0	55825	\N
23528	1109	15	0	56331	\N
23499	5643	18	0	56600	\N
23528	863	17	0	56601	\N
23555	852	6	0	57485	\N
23555	4687	7	0	57488	\N
23614	2351	0	0	58980	\N
23424	2782	8	0	59302	\N
23426	2782	2	0	59304	\N
23426	2784	3	0	59307	\N
23424	6840	9	0	59308	\N
23591	2782	6	0	59315	\N
23703	2782	2	0	59316	\N
23703	2784	3	0	59319	\N
23591	5009	7	0	59322	\N
23582	3625	4	0	59506	\N
23582	3802	5	0	59511	\N
23516	4088	2	0	59925	\N
23516	4332	3	0	59926	\N
23523	6856	15	0	60056	\N
23521	4233	10	0	60057	\N
23521	6855	11	0	60058	\N
23523	4233	62	0	60059	\N
23523	6390	63	0	60060	\N
23586	4787	3	0	60320	\N
23586	4788	4	0	60321	\N
23411	6044	2	0	60631	\N
23411	6188	3	0	60632	\N
23433	6044	2	0	60633	\N
23433	6188	3	0	60634	\N
23483	6849	3	0	60834	\N
23483	6850	4	0	60835	\N
23601	6871	15	0	1213	\N
23499	6852	18	0	1492	\N
23480	117	10	0	1980	\N
23480	6848	11	0	1981	\N
23469	4178	3	0	6952	\N
23469	4211	4	0	6953	\N
23541	4178	3	0	6965	\N
23541	4211	4	0	6966	\N
23603	4178	3	0	6975	\N
23609	4178	3	0	6976	\N
23603	4211	4	0	6979	\N
23609	4211	4	0	6980	\N
23649	4178	4	0	6990	\N
23447	4172	2	0	9269	\N
23447	4191	3	0	9270	\N
23467	4172	3	0	9273	\N
23467	4275	4	0	9275	\N
23634	4172	3	0	9288	\N
23634	4275	4	0	9290	\N
23708	391	4	0	10949	\N
23688	132	3	0	11304	\N
23688	3729	4	0	11306	\N
23562	6864	4	0	12367	\N
23562	6865	5	0	12370	\N
23611	233	3	0	13784	\N
23408	235	2	0	15679	\N
23408	2757	3	0	15686	\N
23619	44	3	0	16019	\N
23619	3631	4	0	16022	\N
23632	1792	3	0	16591	\N
23632	6877	4	0	16593	\N
23550	212	0	0	17129	\N
23473	3635	4	0	18955	\N
23481	241	3	0	20435	\N
23481	3613	4	0	20437	\N
23406	64	8	0	20710	\N
23599	64	2	0	20712	\N
23406	6833	9	0	20716	\N
23545	164	4	0	21065	\N
23545	4152	5	0	21067	\N
23667	164	2	0	21088	\N
23667	1124	3	0	21090	\N
23677	164	3	0	21097	\N
23677	3385	4	0	21100	\N
23681	145	8	0	21836	\N
23681	6887	9	0	21839	\N
23485	214	6	0	24530	\N
23485	4681	7	0	24533	\N
23440	69	2	0	24684	\N
23666	206	4	0	25835	\N
23666	3511	5	0	25838	\N
23506	94	3	0	27026	\N
23506	2864	4	0	27028	\N
23658	54	10	0	30063	\N
23658	6472	11	0	30065	\N
23670	20	7	0	30419	\N
23670	4714	8	0	30422	\N
23557	202	6	0	31010	\N
23557	6863	7	0	31016	\N
23477	360	3	0	31338	\N
23548	360	3	0	31339	\N
23548	3602	4	0	31343	\N
23660	360	3	0	31353	\N
23660	3602	4	0	31355	\N
23478	230	0	0	32043	\N
23530	453	3	0	32749	\N
23530	2838	4	0	32750	\N
23694	3565	4	0	34856	\N
23694	431	8	0	34857	\N
23694	6890	9	0	34858	\N
23428	2	2	0	35366	\N
23428	2789	3	0	35371	\N
23456	4	3	0	35959	\N
23487	14	4	0	39229	\N
23488	14	0	0	39230	\N
23489	14	0	0	39231	\N
23487	3498	5	0	39233	\N
23479	18	1	0	40406	\N
23479	19	2	0	40407	\N
23535	18	7	0	40416	\N
23535	2506	8	0	40417	\N
23580	23	4	0	40825	\N
23580	5479	5	0	40829	\N
23402	27	2	0	40965	\N
23402	645	3	0	40967	\N
23590	56	4	0	44491	\N
23590	3127	5	0	44493	\N
23736	75	3	0	45945	\N
23736	3855	4	0	45946	\N
23513	113	1	0	48253	\N
23513	1102	2	0	48254	\N
23584	119	4	0	48530	\N
23584	3518	5	0	48549	\N
23559	121	6	0	48872	\N
23559	6038	7	0	48877	\N
23727	121	3	0	48898	\N
23727	4471	4	0	48899	\N
23673	135	7	0	49505	\N
23673	4721	8	0	49508	\N
23764	156	5	0	50337	\N
23764	3152	6	0	50338	\N
23620	285	4	0	53510	\N
23620	3674	5	0	53511	\N
23628	285	3	0	53519	\N
23628	4496	4	0	53520	\N
23730	285	10	0	53529	\N
23730	5921	11	0	53530	\N
23578	324	3	0	54252	\N
23578	4514	4	0	54254	\N
23665	435	3	0	55114	\N
23665	3504	4	0	55115	\N
23747	841	7	0	56965	\N
23747	5065	8	0	56968	\N
23669	1130	4	0	57827	\N
23669	6886	5	0	57829	\N
23650	6881	4	0	58981	\N
23650	2351	8	0	58986	\N
23650	2845	9	0	58990	\N
23502	2782	7	0	59313	\N
23502	6312	8	0	59324	\N
23715	4233	3	0	60062	\N
23715	4425	4	0	60064	\N
23623	6044	11	0	60635	\N
23623	6873	12	0	60640	\N
23655	6884	4	0	60911	\N
23574	117	4	0	1987	\N
23567	3804	7	0	1991	\N
23664	110	4	0	2521	\N
23664	4134	5	0	2523	\N
23705	228	3	0	2816	\N
23705	3186	4	0	2817	\N
23572	1636	3	0	3142	\N
23572	5514	4	0	3145	\N
23743	262	2	0	3777	\N
23743	2743	3	0	3778	\N
23542	35	2	0	4199	\N
23542	1191	3	0	4202	\N
23497	4178	4	0	6956	\N
23505	4211	4	0	6959	\N
23497	4205	5	0	6960	\N
23552	4178	7	0	6970	\N
23552	4396	8	0	6971	\N
23625	4178	9	0	6978	\N
23625	6592	10	0	6982	\N
23687	4178	7	0	6991	\N
23687	4396	8	0	6996	\N
23729	4178	3	0	7002	\N
23729	4211	4	0	7003	\N
23750	4178	1	0	7006	\N
23750	4460	2	0	7008	\N
23597	4172	2	0	9287	\N
23597	4191	3	0	9289	\N
23593	4197	7	0	9292	\N
23662	4172	3	0	9293	\N
23672	4172	7	0	9294	\N
23702	4172	4	0	9296	\N
23662	4275	4	0	9297	\N
23702	4219	5	0	9299	\N
23672	4614	8	0	9300	\N
23712	4172	4	0	9301	\N
23712	4219	5	0	9302	\N
23546	528	3	0	12501	\N
23546	4262	4	0	12503	\N
23719	4262	4	0	12504	\N
23518	58	1	0	13529	\N
23518	59	2	0	13530	\N
23678	233	4	0	13796	\N
23678	3775	5	0	13797	\N
23740	233	4	0	13813	\N
23740	3775	5	0	13814	\N
23733	6898	80	0	14371	\N
23733	258	126	0	14388	\N
23733	6899	127	0	14389	\N
23697	4479	4	0	15668	\N
23697	235	8	0	15691	\N
23697	3774	9	0	15693	\N
23717	6894	9	0	15695	\N
23509	44	3	0	16017	\N
23509	3631	4	0	16020	\N
23731	115	6	0	16908	\N
23731	4693	7	0	16910	\N
23645	290	3	0	18961	\N
23645	3635	4	0	18962	\N
23684	290	9	0	18969	\N
23684	6889	10	0	18970	\N
23604	60	2	0	19408	\N
23693	3273	4	0	20012	\N
23696	3273	4	0	20013	\N
23638	198	9	0	20018	\N
23693	198	8	0	20023	\N
23696	198	8	0	20024	\N
23693	3181	9	0	20025	\N
23696	3181	9	0	20026	\N
23638	6879	10	0	20027	\N
23492	241	3	0	20446	\N
23492	3613	4	0	20447	\N
23676	164	2	0	21096	\N
23676	1124	3	0	21099	\N
23726	4861	8	0	21858	\N
23553	73	6	0	22459	\N
23553	4257	7	0	22461	\N
23643	73	7	0	22467	\N
23643	6635	8	0	22468	\N
23762	6909	105	0	23082	\N
23762	149	126	0	23093	\N
23762	697	127	0	23094	\N
23716	140	3	0	24004	\N
23716	4149	4	0	24010	\N
23494	94	6	0	27025	\N
23494	4696	7	0	27030	\N
23577	3645	4	0	27589	\N
23560	16	6	0	29065	\N
23560	3369	7	0	29066	\N
23608	16	3	0	29067	\N
23608	3634	4	0	29070	\N
23675	54	3	0	30070	\N
23675	3041	4	0	30071	\N
23707	151	3	0	30659	\N
23707	3046	4	0	30660	\N
23616	360	6	0	31340	\N
23616	5788	7	0	31345	\N
23724	360	6	0	31354	\N
23690	2	3	0	35368	\N
23690	3548	4	0	35373	\N
23540	4	3	0	35971	\N
23540	3837	4	0	35974	\N
23710	14	3	0	39248	\N
23710	4272	4	0	39250	\N
23680	18	0	0	40434	\N
23700	18	0	0	40437	\N
23538	40	10	0	42171	\N
23538	4104	11	0	42172	\N
23767	41	1	0	42225	\N
23767	40	5	0	42242	\N
23767	3247	6	0	42243	\N
23755	56	3	0	44500	\N
23755	4109	4	0	44502	\N
23884	56	3	0	44508	\N
23884	4109	4	0	44510	\N
23776	75	3	0	45949	\N
23840	75	3	0	45950	\N
23776	3855	4	0	45951	\N
23840	3855	4	0	45952	\N
23875	75	10	0	45957	\N
23875	4874	11	0	45958	\N
23699	79	8	0	46476	\N
23725	79	8	0	46539	\N
23725	3701	9	0	46540	\N
23772	79	4	0	46594	\N
23772	2758	5	0	46596	\N
23908	88	4	0	47158	\N
23908	3809	5	0	47161	\N
23765	242	7	0	52104	\N
23935	242	2	0	52105	\N
23935	3425	3	0	52107	\N
23765	4592	8	0	52109	\N
23928	260	4	0	52493	\N
23928	3728	5	0	52495	\N
23819	6919	7	0	53225	\N
23819	3707	8	0	53226	\N
23921	285	3	0	53560	\N
23921	4496	4	0	53562	\N
23846	316	3	0	53903	\N
23846	4249	4	0	53904	\N
23865	597	3	0	55834	\N
23865	3656	4	0	55835	\N
23816	1109	4	0	56342	\N
23816	3816	5	0	56344	\N
23752	841	3	0	56978	\N
23752	3604	4	0	56980	\N
23916	2435	99	0	57956	\N
23877	2435	126	0	57965	\N
23862	1470	10	0	58269	\N
23862	3375	11	0	58271	\N
23877	2519	127	1	58541	\N
23704	2782	3	0	59317	\N
23704	3659	4	0	59320	\N
23791	3625	3	0	59507	\N
23791	3784	4	0	59510	\N
23858	6931	0	0	59789	\N
23900	4233	3	0	60065	\N
23949	4233	6	0	60066	\N
23900	4425	4	0	60070	\N
23949	6364	7	0	60072	\N
23916	6668	99	1	60565	\N
23802	6916	8	0	30	\N
23738	6902	7	0	1998	\N
23858	6932	0	0	2366	\N
23856	110	0	0	2531	\N
23798	228	4	0	2826	\N
23798	5679	5	0	2833	\N
23744	367	3	0	3323	\N
23744	3683	4	0	3324	\N
23877	6937	126	1	4115	\N
23877	6936	40	0	4190	\N
23877	35	125	0	4205	\N
23886	189	3	0	4884	\N
23886	3782	4	0	4885	\N
23723	4250	7	0	7004	\N
23735	4178	5	0	7005	\N
23778	4178	3	0	7007	\N
23778	4211	4	0	7009	\N
23735	4202	6	0	7010	\N
23692	4172	3	0	9295	\N
23692	4275	4	0	9298	\N
23851	4172	3	0	9306	\N
23851	4275	4	0	9307	\N
23870	391	3	0	10980	\N
23870	3660	4	0	10983	\N
23903	132	3	0	11312	\N
23821	58	2	0	13548	\N
23821	2853	3	0	13550	\N
23825	58	8	0	13559	\N
23825	6923	9	0	13562	\N
23953	58	6	0	13569	\N
23953	6952	7	0	13572	\N
23913	233	7	0	13841	\N
23913	5948	8	0	13847	\N
23916	6942	80	0	14413	\N
23916	258	98	0	14429	\N
23916	6943	100	0	14432	\N
23814	92	3	0	15063	\N
23695	4479	4	0	15667	\N
23829	235	7	0	15682	\N
23937	235	4	0	15683	\N
23937	3615	5	0	15688	\N
23695	235	8	0	15690	\N
23695	3774	9	0	15692	\N
23829	5822	8	0	15694	\N
23773	38	7	0	16360	\N
23773	5071	8	0	16363	\N
23770	326	2	0	17363	\N
23770	6910	3	0	17364	\N
23838	290	3	0	18975	\N
23892	290	3	0	19006	\N
23892	3635	4	0	19009	\N
23877	6938	127	0	19157	\N
23872	62	6	0	19769	\N
23872	6466	7	0	19770	\N
23895	64	3	0	20728	\N
23895	4217	4	0	20731	\N
23942	164	6	0	21115	\N
23942	3583	7	0	21117	\N
23916	1075	100	1	21807	\N
23711	145	6	0	21837	\N
23711	5341	7	0	21838	\N
23732	6897	6	0	22987	\N
23760	149	6	0	23088	\N
23963	149	3	0	23089	\N
23963	4189	4	0	23091	\N
23760	4737	7	0	23092	\N
23819	4348	7	0	23723	\N
23714	140	2	0	24003	\N
23714	3183	3	0	24009	\N
23701	69	10	0	24698	\N
23701	6893	11	0	24699	\N
23807	69	5	0	24711	\N
23807	6917	6	0	24713	\N
23955	4536	4	0	24743	\N
23706	94	3	0	27033	\N
23706	2864	4	0	27034	\N
23783	16	6	0	29069	\N
23783	3369	7	0	29072	\N
23833	16	7	0	29075	\N
23880	16	14	0	29076	\N
23833	4723	8	0	29077	\N
23880	707	15	0	29078	\N
23795	54	3	0	30077	\N
23795	3041	4	0	30079	\N
23930	33	10	0	31753	\N
23785	2	4	0	35386	\N
23809	2	3	0	35387	\N
23945	2	3	0	35388	\N
23809	3548	4	0	35394	\N
23945	3548	4	0	35395	\N
23785	3510	5	0	35396	\N
23774	4	3	0	35973	\N
23774	3837	4	0	35975	\N
23709	14	4	0	39247	\N
23709	3498	5	0	39251	\N
23769	40	3	0	42289	\N
23769	372	4	0	42291	\N
23850	40	4	0	42322	\N
23850	3381	5	0	42323	\N
23973	40	8	0	42340	\N
23973	5163	9	0	42343	\N
23842	56	3	0	44504	\N
23842	4109	4	0	44505	\N
23879	75	7	0	45967	\N
23879	2859	8	0	45972	\N
23771	6912	4	0	46593	\N
23786	79	4	0	46637	\N
23786	3678	5	0	46641	\N
23793	119	3	0	48531	\N
23793	2860	4	0	48542	\N
23950	125	6	0	49255	\N
23950	6951	7	0	49258	\N
23938	170	5	0	50613	\N
23938	6948	6	0	50616	\N
23734	181	5	0	51041	\N
23734	6900	6	0	51042	\N
23980	186	29	0	51228	\N
23982	186	1	0	51230	\N
23982	187	2	0	51231	\N
23980	6962	30	0	51233	\N
23936	242	3	0	52106	\N
23936	2839	4	0	52108	\N
23966	242	4	0	52120	\N
23966	4364	5	0	52122	\N
23766	273	5	0	52990	\N
23766	6157	6	0	52991	\N
23803	273	3	0	52998	\N
23803	3638	4	0	52999	\N
23999	273	9	0	53004	\N
23999	6965	10	0	53005	\N
23799	285	4	0	53542	\N
23915	285	12	0	53543	\N
23799	5030	5	0	53544	\N
23915	6941	13	0	53545	\N
23907	316	1	0	53909	\N
23907	3115	2	0	53910	\N
23748	841	55	0	56966	\N
23748	6904	56	0	56969	\N
23951	852	9	0	57486	\N
23951	4046	10	0	57490	\N
23912	4088	7	0	59811	\N
23912	5947	8	0	59813	\N
23713	4233	2	0	60061	\N
23713	5577	3	0	60063	\N
23790	4787	5	0	60322	\N
23790	5349	6	0	60325	\N
23771	6911	4	0	60599	\N
23897	6044	1	0	60637	\N
23897	6153	2	0	60638	\N
23722	6895	7	0	273	\N
23808	6918	6	0	733	\N
23779	251	0	0	1505	\N
23861	6933	7	0	2367	\N
23861	6934	8	0	2368	\N
23889	366	1	0	4553	\N
23889	365	4	0	4568	\N
23889	5072	5	0	4571	\N
23718	4178	8	0	6998	\N
23874	4178	0	0	6999	\N
23718	4218	9	0	7000	\N
23741	4178	4	0	7012	\N
23741	4205	5	0	7013	\N
23812	4211	4	0	7018	\N
23968	4178	13	0	7021	\N
23968	6957	14	0	7023	\N
24010	4178	6	0	7029	\N
24010	4250	7	0	7033	\N
23780	4172	4	0	9303	\N
23780	4219	5	0	9304	\N
23831	4172	7	0	9305	\N
23831	4614	8	0	9308	\N
23864	4172	7	0	9309	\N
23864	4614	8	0	9310	\N
23971	4172	10	0	9319	\N
23708	3913	5	0	10951	\N
23789	391	5	0	10962	\N
23789	5462	6	0	10963	\N
23975	108	3	0	11756	\N
23975	4171	4	0	11758	\N
23987	300	2	0	12094	\N
23987	2786	3	0	12095	\N
23823	58	5	0	13558	\N
23823	6921	6	0	13561	\N
23737	233	6	0	13812	\N
23737	6901	7	0	13815	\N
23781	402	2	0	14333	\N
23781	3244	3	0	14337	\N
23835	6925	7	0	14339	\N
23759	6907	80	0	14390	\N
23759	258	126	0	14401	\N
23759	6908	127	0	14402	\N
23828	235	1	0	15681	\N
23828	6924	2	0	15696	\N
23817	39	2	0	16364	\N
23817	38	7	0	16372	\N
23853	6929	106	0	18162	\N
23853	30	126	0	18171	\N
23853	6930	127	0	18172	\N
23891	3635	4	0	19008	\N
23820	208	7	0	19268	\N
23820	6920	8	0	19269	\N
23894	64	1	0	20727	\N
23894	1428	2	0	20730	\N
23883	164	3	0	21114	\N
23883	3385	4	0	21116	\N
23958	164	3	0	21122	\N
23958	3385	4	0	21125	\N
23813	67	3	0	22128	\N
23813	3749	4	0	22131	\N
23914	336	3	0	22988	\N
23855	140	0	0	24005	\N
23796	69	4	0	24710	\N
23796	3564	5	0	24712	\N
23996	86	3	0	26664	\N
23996	3746	4	0	26666	\N
23960	94	3	0	27037	\N
23960	2864	4	0	27038	\N
24008	94	2	0	27040	\N
24008	2794	3	0	27041	\N
23810	244	3	0	27268	\N
23810	4075	4	0	27270	\N
23811	16	3	0	29073	\N
24013	16	3	0	29079	\N
24013	3634	4	0	29080	\N
23792	54	2	0	30076	\N
23792	6915	3	0	30078	\N
23751	20	3	0	30420	\N
23751	2844	4	0	30421	\N
23754	202	3	0	31011	\N
23754	4857	4	0	31013	\N
23869	322	3	0	32591	\N
23869	1105	4	0	32594	\N
23899	322	3	0	32597	\N
23899	1105	4	0	32600	\N
23728	6896	8	0	32760	\N
23787	453	4	0	32770	\N
23787	4108	5	0	32772	\N
23845	453	3	0	32777	\N
23845	2838	4	0	32779	\N
23805	14	4	0	39249	\N
23805	3498	5	0	39252	\N
23720	23	3	0	40826	\N
23720	3497	4	0	40828	\N
23815	372	4	0	42292	\N
23826	40	3	0	42308	\N
23859	40	7	0	42338	\N
23863	40	10	0	42339	\N
23859	4718	8	0	42341	\N
23863	4104	11	0	42342	\N
23986	40	3	0	42367	\N
23986	372	4	0	42373	\N
23761	56	6	0	44501	\N
23761	4703	7	0	44503	\N
23852	56	3	0	44506	\N
23852	4109	4	0	44509	\N
23873	71	6	0	44784	\N
23873	4738	7	0	44789	\N
23932	79	3	0	46638	\N
23932	3652	4	0	46640	\N
23757	6906	126	0	48152	\N
23757	6905	60	0	48256	\N
23756	113	3	0	48266	\N
23756	3620	4	0	48267	\N
23757	113	125	0	48268	\N
23763	156	7	0	50336	\N
23763	4672	8	0	50340	\N
23804	170	3	0	50598	\N
23919	170	3	0	50599	\N
23804	4148	4	0	50601	\N
23919	4148	4	0	50602	\N
23837	186	2	0	51211	\N
23837	3068	3	0	51212	\N
23981	186	3	0	51229	\N
23981	4294	4	0	51232	\N
23806	210	6	0	51811	\N
23806	3721	7	0	51812	\N
23841	210	7	0	51819	\N
23841	5940	8	0	51820	\N
23866	595	3	0	55549	\N
23866	3654	4	0	55551	\N
23788	1109	4	0	56341	\N
23788	3816	5	0	56343	\N
23857	1109	0	0	56351	\N
23824	841	8	0	56979	\N
23824	6922	9	0	56981	\N
23753	841	3	0	56982	\N
23753	3604	4	0	56983	\N
23749	3505	3	0	58460	\N
23749	3506	4	0	58461	\N
23794	3628	3	0	59683	\N
23794	3785	4	0	59693	\N
23742	4088	2	0	59810	\N
23742	4332	3	0	59812	\N
23827	3003	4	0	28	\N
23974	288	4	0	33	\N
23974	6960	5	0	34	\N
23839	12	3	0	269	\N
23839	4204	4	0	271	\N
23909	424	3	0	724	\N
23911	424	4	0	725	\N
23909	3611	4	0	730	\N
23911	3188	5	0	731	\N
23739	117	4	0	1995	\N
23739	3835	5	0	1997	\N
23962	117	7	0	2005	\N
23962	6954	8	0	2006	\N
23941	367	6	0	3334	\N
23926	3683	4	0	3338	\N
23941	6013	7	0	3340	\N
23944	2111	3	0	4097	\N
23944	6950	4	0	4099	\N
23801	4178	7	0	7011	\N
23801	4396	8	0	7014	\N
23844	4178	3	0	7016	\N
23878	4178	0	0	7017	\N
23844	4211	4	0	7019	\N
23929	4178	4	0	7020	\N
23929	6946	5	0	7022	\N
23887	4172	8	0	9311	\N
23887	5928	9	0	9312	\N
23924	4172	3	0	9313	\N
23940	4172	5	0	9314	\N
23924	4275	4	0	9315	\N
23940	4634	6	0	9316	\N
23967	4172	2	0	9317	\N
23967	4285	3	0	9318	\N
23995	391	1	0	10224	\N
23995	392	2	0	10225	\N
23854	391	3	0	10971	\N
23854	3660	4	0	10972	\N
23957	391	3	0	10982	\N
23957	3660	4	0	10984	\N
23904	3913	5	0	10985	\N
23797	300	4	0	12093	\N
23797	2992	5	0	12096	\N
23777	77	3	0	13101	\N
23777	1877	4	0	13105	\N
23822	58	3	0	13549	\N
23822	3665	4	0	13551	\N
23881	58	9	0	13560	\N
23881	3755	10	0	13563	\N
23782	402	6	0	14334	\N
23834	4731	5	0	14338	\N
23782	4068	7	0	14340	\N
23847	6927	11	0	14680	\N
23847	173	126	0	14694	\N
23847	6928	127	0	14695	\N
23746	92	23	0	15054	\N
23746	6903	24	0	15055	\N
23871	92	3	0	15064	\N
23871	4410	4	0	15071	\N
23818	39	2	0	16365	\N
23818	38	7	0	16373	\N
23817	6006	8	0	16374	\N
23906	115	1	0	16920	\N
23906	2908	2	0	16922	\N
23757	973	126	1	18398	\N
23988	142	3	0	18521	\N
23988	4254	4	0	18526	\N
23849	290	3	0	18997	\N
23849	3635	4	0	18998	\N
23922	60	3	0	19426	\N
23922	3585	4	0	19427	\N
23800	488	4	0	21454	\N
23800	5021	5	0	21455	\N
23757	1075	127	0	21821	\N
23775	3040	4	0	22500	\N
23948	336	0	0	22990	\N
23917	140	11	0	24006	\N
23917	6944	12	0	24013	\N
23890	215	1	0	24516	\N
23890	214	4	0	24531	\N
23890	2979	5	0	24532	\N
23830	224	7	0	25502	\N
23830	5003	8	0	25505	\N
23979	206	3	0	25836	\N
23979	4584	4	0	25837	\N
23868	54	6	0	30090	\N
23991	54	3	0	30104	\N
23991	3041	4	0	30105	\N
23901	360	3	0	31365	\N
23901	3602	4	0	31366	\N
23758	33	4	0	31747	\N
23758	4806	5	0	31748	\N
23784	453	2	0	32769	\N
23784	3133	3	0	32771	\N
23934	18	4	0	40376	\N
23934	2302	5	0	40383	\N
23947	27	3	0	41000	\N
23947	4636	4	0	41005	\N
23826	372	4	0	42309	\N
23992	40	3	0	42368	\N
24045	40	2	0	42369	\N
24045	3034	3	0	42372	\N
23992	372	4	0	42374	\N
23860	56	7	0	44507	\N
23860	4791	8	0	44511	\N
23902	71	3	0	44785	\N
23902	3770	4	0	44788	\N
24005	79	5	0	46639	\N
24005	5993	6	0	46642	\N
24016	88	0	0	47128	\N
23910	88	3	0	47159	\N
23910	3655	4	0	47160	\N
24014	88	3	0	47164	\N
24014	3655	4	0	47165	\N
24032	156	3	0	50345	\N
24032	4594	4	0	50350	\N
23836	186	6	0	51210	\N
23836	6926	7	0	51213	\N
23898	200	3	0	51541	\N
23898	3338	4	0	51542	\N
23843	210	7	0	51847	\N
23843	5940	8	0	51848	\N
23989	210	3	0	51857	\N
23989	3539	4	0	51858	\N
23965	242	3	0	52119	\N
23965	5519	4	0	52121	\N
24019	4344	4	0	52627	\N
24019	268	5	0	52646	\N
24024	285	6	0	53561	\N
24024	6968	7	0	53563	\N
23927	324	3	0	54265	\N
23927	4514	4	0	54266	\N
23848	451	10	0	55292	\N
23848	4808	11	0	55293	\N
23893	1109	3	0	56352	\N
23893	3495	4	0	56353	\N
23970	1021	10	0	56436	\N
23970	6959	11	0	56438	\N
24064	1021	0	0	56451	\N
23952	852	6	0	57487	\N
23952	4044	7	0	57489	\N
23997	852	3	0	57491	\N
23997	3612	4	0	57493	\N
24029	908	3	0	57680	\N
24029	3591	4	0	57681	\N
23976	4015	3	0	57867	\N
24027	6971	12	0	59214	\N
24047	2782	6	0	59318	\N
24047	5009	7	0	59323	\N
23976	3740	4	1	59477	\N
24001	4233	1	0	60067	\N
24001	5087	2	0	60069	\N
24020	6674	4	0	60511	\N
24020	5885	5	0	60513	\N
23896	6044	4	0	60636	\N
23896	6524	5	0	60639	\N
23867	6847	4	0	60751	\N
23925	4204	4	0	272	\N
23954	6953	7	0	1791	\N
23882	6939	7	0	1889	\N
23882	6940	8	0	1890	\N
23918	117	11	0	1996	\N
23918	6945	12	0	1999	\N
24003	367	3	0	3335	\N
24003	3683	4	0	3339	\N
23876	35	20	0	4200	\N
23876	6935	21	0	4204	\N
23888	366	1	0	4552	\N
23888	365	4	0	4567	\N
23888	5072	5	0	4570	\N
23984	3782	4	0	4892	\N
23994	4178	3	0	7024	\N
23994	4211	4	0	7025	\N
24007	4178	2	0	7028	\N
24007	4247	3	0	7030	\N
24022	4178	3	0	7034	\N
24022	4211	4	0	7035	\N
24027	6972	12	0	7036	\N
24027	6973	13	0	7037	\N
24038	4178	2	0	7038	\N
24038	4247	3	0	7040	\N
24050	4178	4	0	7042	\N
23972	4172	8	0	9320	\N
23972	5165	9	0	9323	\N
24041	391	2	0	10153	\N
24006	132	3	0	11313	\N
24006	3729	4	0	11315	\N
23976	3340	4	0	11632	\N
23976	6961	3	0	11754	\N
23983	108	3	0	11765	\N
24067	108	6	0	11767	\N
23983	4171	4	0	11768	\N
24067	6978	7	0	11770	\N
23923	528	3	0	12513	\N
23978	192	3	0	15499	\N
23978	3790	4	0	15500	\N
23939	235	5	0	15684	\N
23939	6949	6	0	15689	\N
23905	115	4	0	16919	\N
23905	4844	5	0	16924	\N
24039	142	2	0	18522	\N
24039	4418	3	0	18523	\N
23956	64	3	0	20729	\N
23956	4217	4	0	20732	\N
23832	164	7	0	21098	\N
23832	5711	8	0	21101	\N
23959	3085	3	0	21124	\N
24036	164	3	0	21130	\N
24036	3385	4	0	21136	\N
23943	145	3	0	21904	\N
23943	4908	4	0	21906	\N
24012	67	3	0	22142	\N
24012	3749	4	0	22146	\N
23964	6955	105	0	23095	\N
23964	149	126	0	23110	\N
23964	6956	127	0	23111	\N
23946	69	3	0	24732	\N
23946	4536	4	0	24733	\N
23985	3596	4	0	25222	\N
23969	94	14	0	27039	\N
23969	6958	15	0	27042	\N
24057	94	2	0	27043	\N
24057	2794	3	0	27044	\N
23885	244	7	0	27269	\N
23885	4608	8	0	27271	\N
23993	6963	118	0	30661	\N
23990	151	3	0	30672	\N
24062	151	2	0	30673	\N
24062	2854	3	0	30678	\N
23990	3046	4	0	30679	\N
23993	6964	127	0	30683	\N
23931	202	3	0	31012	\N
23931	4857	4	0	31014	\N
23961	360	6	0	31379	\N
23961	5788	7	0	31380	\N
23998	360	9	0	31385	\N
23998	6080	10	0	31388	\N
23977	230	3	0	32052	\N
23977	4181	4	0	32053	\N
23920	453	4	0	32778	\N
23920	4108	5	0	32780	\N
23933	4823	3	0	36301	\N
24026	23	6	0	40827	\N
24026	6970	7	0	40831	\N
24034	27	6	0	41001	\N
24034	3715	7	0	41006	\N
24236	3381	5	0	42420	\N
24077	71	2	0	44786	\N
24077	1125	3	0	44787	\N
24223	71	3	0	44794	\N
24223	3770	4	0	44797	\N
24011	75	4	0	45968	\N
24106	75	3	0	45969	\N
24106	3855	4	0	45970	\N
24011	2357	5	0	45971	\N
24079	79	6	0	46699	\N
24079	4997	7	0	46704	\N
24251	79	7	0	46768	\N
24272	79	4	0	46769	\N
24272	2758	5	0	46770	\N
24251	5706	8	0	46771	\N
24120	119	2	0	48532	\N
24120	1879	3	0	48540	\N
24103	135	2	0	49506	\N
24103	2722	3	0	49507	\N
24248	181	13	0	50874	\N
24248	7005	14	0	50875	\N
24245	186	6	0	51266	\N
24245	7004	7	0	51267	\N
24115	273	1	0	53009	\N
24115	1417	2	0	53011	\N
24023	6967	6	0	53550	\N
24023	6968	7	0	53551	\N
24059	285	2	0	53568	\N
24059	3036	3	0	53569	\N
24189	285	2	0	53576	\N
24189	3036	3	0	53579	\N
24087	597	8	0	55848	\N
24087	6981	9	0	55853	\N
24268	1021	0	0	56484	\N
24070	793	4	0	56870	\N
24070	5688	5	0	56872	\N
24073	793	2	0	56873	\N
24073	4363	3	0	56874	\N
24200	852	4	0	57492	\N
24200	4162	5	0	57494	\N
24293	852	3	0	57495	\N
24293	3612	4	0	57496	\N
24194	2636	3	0	58753	\N
24194	2837	4	0	58757	\N
24002	4233	3	0	60068	\N
24002	4425	4	0	60071	\N
24118	4233	10	0	60073	\N
24118	6719	11	0	60074	\N
24228	4787	4	0	60323	\N
24228	5041	5	0	60324	\N
24044	3028	3	0	284	\N
24125	365	2	0	4566	\N
24125	615	3	0	4569	\N
24173	6999	8	0	5145	\N
24173	7000	9	0	5146	\N
24004	4178	5	0	7027	\N
24000	4211	4	0	7031	\N
24004	4202	6	0	7032	\N
24061	4178	2	0	7044	\N
24061	4247	3	0	7046	\N
24083	4178	4	0	7049	\N
24083	4331	5	0	7051	\N
24197	4178	6	0	7060	\N
24241	4178	3	0	7066	\N
24241	4211	4	0	7070	\N
24035	4172	3	0	9321	\N
24035	4275	4	0	9322	\N
24042	4172	3	0	9325	\N
24042	4275	4	0	9327	\N
24168	4172	6	0	9330	\N
24168	4197	7	0	9334	\N
24234	4172	3	0	9342	\N
24234	4275	4	0	9344	\N
24151	391	1	0	10161	\N
24151	392	2	0	10162	\N
24214	3660	4	0	10185	\N
24066	108	6	0	11766	\N
24066	6978	7	0	11769	\N
24056	469	2	0	12353	\N
24056	6976	3	0	12354	\N
24204	4824	6	0	12505	\N
24204	7003	7	0	12519	\N
24053	233	4	0	13842	\N
24053	6975	5	0	13845	\N
24165	92	2	0	15067	\N
24165	2763	3	0	15069	\N
24094	235	2	0	15685	\N
24021	3362	4	0	17365	\N
24021	326	5	0	17376	\N
24277	326	4	0	17395	\N
24277	3519	5	0	17399	\N
24204	6695	7	0	18379	\N
24025	3265	6	0	18762	\N
24081	60	2	0	19437	\N
24133	60	6	0	19439	\N
24081	4544	3	0	19440	\N
24133	6394	7	0	19442	\N
24099	164	2	0	21131	\N
24099	1124	3	0	21134	\N
24078	3315	7	0	21468	\N
24028	73	3	0	22495	\N
24037	73	2	0	22496	\N
24037	2766	3	0	22498	\N
24028	3040	4	0	22501	\N
24046	336	3	0	22991	\N
24046	3400	4	0	22992	\N
24142	149	4	0	23108	\N
24142	5500	5	0	23109	\N
24209	149	7	0	23120	\N
24209	5255	8	0	23123	\N
24299	264	6	0	23552	\N
24163	6996	9	0	26057	\N
24009	244	2	0	27283	\N
24009	3308	3	0	27287	\N
24266	42	15	0	27584	\N
24266	7011	16	0	27592	\N
24091	16	2	0	29083	\N
24091	388	3	0	29084	\N
24160	16	2	0	29086	\N
24160	388	3	0	29088	\N
24280	16	4	0	29092	\N
24280	3546	5	0	29093	\N
24146	151	0	0	30674	\N
24225	3499	5	0	30681	\N
24063	6977	118	0	30684	\N
24063	151	126	0	30699	\N
24063	6964	127	0	30700	\N
24148	151	52	0	30712	\N
24148	6992	53	0	30713	\N
24282	360	3	0	31395	\N
24282	3602	4	0	31396	\N
24018	33	3	0	31759	\N
24018	3342	4	0	31760	\N
24156	230	3	0	32061	\N
24156	4181	4	0	32062	\N
24033	2838	4	0	32793	\N
24190	4	2	0	35986	\N
24190	2751	3	0	35987	\N
24075	14	2	0	39259	\N
24075	1785	3	0	39260	\N
24232	18	3	0	40395	\N
24232	3621	4	0	40396	\N
24025	6969	6	0	40824	\N
24025	6970	7	0	40830	\N
24110	27	0	0	41004	\N
24108	27	1	0	41018	\N
24108	2885	2	0	41019	\N
24119	40	10	0	42395	\N
24126	40	4	0	42396	\N
24126	2796	5	0	42397	\N
24119	6986	11	0	42398	\N
24130	40	2	0	42411	\N
24193	40	2	0	42413	\N
24216	40	3	0	42414	\N
24130	282	3	0	42416	\N
24193	282	3	0	42418	\N
24216	372	4	0	42419	\N
24054	79	4	0	46669	\N
24054	2758	5	0	46671	\N
24138	79	4	0	46701	\N
24138	2758	5	0	46703	\N
24167	79	6	0	46742	\N
24167	4253	7	0	46743	\N
24015	88	0	0	47127	\N
24105	113	2	0	48275	\N
24105	1899	3	0	48277	\N
24233	125	3	0	49273	\N
24233	4170	4	0	49274	\N
24071	156	2	0	50346	\N
24071	4485	3	0	50349	\N
24201	186	31	0	51250	\N
24201	7002	32	0	51251	\N
24031	210	3	0	51867	\N
24255	210	0	0	51868	\N
24031	3539	4	0	51870	\N
24048	268	5	0	52633	\N
24048	6673	6	0	52648	\N
24128	316	2	0	53915	\N
24128	1900	3	0	53917	\N
24181	451	2	0	55305	\N
24181	3317	3	0	55309	\N
24086	595	8	0	55550	\N
24086	6980	9	0	55552	\N
24084	793	1	0	56875	\N
24084	2972	2	0	56876	\N
24080	841	2	0	56991	\N
24080	3316	3	0	56992	\N
24136	908	2	0	57690	\N
24170	908	2	0	57691	\N
24136	2832	3	0	57692	\N
24170	2832	3	0	57693	\N
24068	6678	10	0	58108	\N
24068	6979	11	0	58109	\N
24121	3625	2	0	59508	\N
24121	4359	3	0	59509	\N
24051	4088	4	0	59818	\N
24240	4088	3	0	59819	\N
24240	4506	4	0	59821	\N
24051	6974	5	0	59823	\N
24150	6044	1	0	60641	\N
24221	6044	3	0	60643	\N
24150	6993	2	0	60652	\N
24221	6045	4	0	60655	\N
24088	6982	9	0	60755	\N
24263	6723	3	0	60855	\N
24131	6987	9	0	60915	\N
24177	251	2	0	1479	\N
24177	1851	3	0	1481	\N
24227	228	4	0	2827	\N
24227	4800	5	0	2832	\N
24098	367	2	0	3336	\N
24098	3329	3	0	3337	\N
24208	367	3	0	3354	\N
24208	3683	4	0	3355	\N
24247	373	3	0	5385	\N
24247	3590	4	0	5386	\N
24134	4178	2	0	7054	\N
24134	4247	3	0	7055	\N
24178	4178	7	0	7057	\N
24231	4178	3	0	7065	\N
24253	4178	8	0	7067	\N
24231	4211	4	0	7069	\N
24253	5610	9	0	7072	\N
24055	4172	4	0	9326	\N
24055	4219	5	0	9328	\N
24095	4172	2	0	9329	\N
24095	4191	3	0	9332	\N
24211	4172	7	0	9336	\N
24211	4614	8	0	9338	\N
24157	391	3	0	10173	\N
24162	391	0	0	10174	\N
24199	391	4	0	10179	\N
24199	3913	5	0	10187	\N
24243	132	3	0	11343	\N
24243	3729	4	0	11344	\N
24127	108	2	0	11779	\N
24127	3340	3	0	11780	\N
24060	300	2	0	12103	\N
24060	2786	3	0	12104	\N
24183	58	3	0	13570	\N
24183	3665	4	0	13571	\N
24250	58	7	0	13580	\N
24250	4764	8	0	13581	\N
24260	3775	5	0	13867	\N
24141	92	2	0	15065	\N
24143	92	4	0	15066	\N
24141	3060	3	0	15068	\N
24143	6053	5	0	15072	\N
24213	235	3	0	15702	\N
24213	3343	4	0	15703	\N
24114	115	1	0	16921	\N
24114	2908	2	0	16923	\N
24100	6984	1	0	18816	\N
24100	6985	2	0	18817	\N
24101	60	2	0	19438	\N
24218	164	3	0	21133	\N
24218	3385	4	0	21137	\N
24090	488	2	0	21482	\N
24090	2791	3	0	21483	\N
24017	145	3	0	21905	\N
24017	4908	4	0	21907	\N
24144	4098	105	1	21985	\N
24144	3009	110	1	21990	\N
24185	73	2	0	22497	\N
24185	2766	3	0	22499	\N
24144	6990	105	0	23046	\N
24144	6991	110	0	23047	\N
24238	214	3	0	24549	\N
24238	3496	4	0	24551	\N
24153	94	5	0	27045	\N
24258	94	13	0	27046	\N
24153	4547	6	0	27054	\N
24258	7008	14	0	27055	\N
24030	16	3	0	29081	\N
24065	16	0	0	29082	\N
24030	3634	4	0	29085	\N
24222	16	4	0	29090	\N
24222	3546	5	0	29091	\N
24111	2899	1	0	29482	\N
24111	96	2	0	29492	\N
24113	96	2	0	29494	\N
24093	54	4	0	30119	\N
24093	2570	5	0	30120	\N
24149	151	0	0	30675	\N
24196	360	4	0	31386	\N
24196	3513	5	0	31387	\N
24076	33	2	0	31765	\N
24076	2822	3	0	31766	\N
24123	453	4	0	32804	\N
24123	3294	5	0	32805	\N
24145	2	2	0	35437	\N
24188	4	0	0	35985	\N
24155	18	4	0	40378	\N
24155	3779	5	0	40384	\N
24109	27	0	0	41003	\N
24117	40	1	0	42370	\N
24117	1383	2	0	42371	\N
24166	40	2	0	42412	\N
24166	282	3	0	42417	\N
24291	40	4	0	42431	\N
24291	3381	5	0	42433	\N
24147	56	2	0	44512	\N
24147	2795	3	0	44513	\N
24261	56	3	0	44514	\N
24261	4109	4	0	44515	\N
24212	75	7	0	45975	\N
24275	75	4	0	45976	\N
24212	2859	8	0	45977	\N
24275	7012	5	0	45978	\N
24052	79	2	0	46668	\N
24052	80	3	0	46670	\N
24137	79	2	0	46700	\N
24137	3180	3	0	46702	\N
24379	79	1	0	46855	\N
24104	113	2	0	48274	\N
24104	1899	3	0	48276	\N
24273	121	4	0	48914	\N
24273	4356	5	0	48916	\N
24359	135	2	0	49515	\N
24359	2722	3	0	49526	\N
24102	137	2	0	49754	\N
24102	2721	3	0	49756	\N
24202	186	3	0	51240	\N
24202	4294	4	0	51247	\N
24357	285	3	0	53577	\N
24357	4496	4	0	53580	\N
24179	451	1	0	55304	\N
24179	584	2	0	55308	\N
24174	1021	2	0	56463	\N
24264	1021	7	0	56464	\N
24174	4432	3	0	56466	\N
24264	7009	8	0	56468	\N
24374	793	3	0	56877	\N
24374	2644	4	0	56878	\N
24294	908	10	0	57698	\N
24294	7013	11	0	57701	\N
24306	7021	10	0	57838	\N
24326	1470	3	0	58277	\N
24326	3838	4	0	58278	\N
24089	2351	8	0	58998	\N
24348	2351	3	0	58999	\N
24348	2845	4	0	59001	\N
24089	6983	9	0	59003	\N
24122	3628	2	0	59684	\N
24122	4360	3	0	59689	\N
24049	5885	5	0	60512	\N
24049	6212	6	0	60514	\N
24219	6044	4	0	60642	\N
24287	6044	3	0	60644	\N
24287	6045	4	0	60656	\N
24219	6524	5	0	60658	\N
24331	7026	12	0	60756	\N
24135	2842	3	0	40	\N
24345	3474	4	0	1212	\N
24154	35	3	0	4201	\N
24154	3563	4	0	4203	\N
24229	365	4	0	4586	\N
24229	4049	5	0	4590	\N
24306	7019	9	0	5135	\N
24043	4178	4	0	7039	\N
24043	4205	5	0	7041	\N
24058	4178	2	0	7043	\N
24058	4247	3	0	7045	\N
24074	4178	2	0	7048	\N
24074	4247	3	0	7050	\N
24092	4247	3	0	7053	\N
24224	4178	3	0	7062	\N
24224	4211	4	0	7063	\N
24226	4178	4	0	7064	\N
24256	4178	0	0	7068	\N
24226	4205	5	0	7071	\N
24191	4172	2	0	9335	\N
24191	4191	3	0	9337	\N
24364	4172	3	0	9353	\N
24364	4275	4	0	9356	\N
24041	1381	3	0	10154	\N
24205	3521	6	0	10176	\N
24278	132	4	0	11337	\N
24278	3716	5	0	11341	\N
24239	6975	13	0	13816	\N
24242	233	3	0	13843	\N
24242	3704	4	0	13844	\N
24239	233	14	0	13846	\N
24289	192	4	0	15505	\N
24289	3895	5	0	15506	\N
24132	212	8	0	17131	\N
24132	6988	9	0	17133	\N
24316	290	3	0	19007	\N
24316	3635	4	0	19010	\N
24313	67	9	0	22144	\N
24085	394	3	0	22145	\N
24313	7022	10	0	22147	\N
24324	264	5	0	23559	\N
24324	5480	6	0	23564	\N
24069	82	2	0	23727	\N
24069	3401	3	0	23728	\N
24140	69	6	0	24742	\N
24140	6989	7	0	24744	\N
24372	69	2	0	24764	\N
24372	3350	3	0	24766	\N
24161	206	2	0	25841	\N
24271	206	4	0	25849	\N
24271	3511	5	0	25850	\N
24097	90	2	0	26047	\N
24097	3442	3	0	26048	\N
24164	6995	8	0	26056	\N
24164	6996	9	0	26058	\N
24152	6303	5	0	26335	\N
24152	6994	6	0	26337	\N
24311	94	3	0	27047	\N
24311	2864	4	0	27052	\N
24370	7035	8	0	27056	\N
24370	7036	9	0	27065	\N
24340	388	3	0	29099	\N
24112	2899	1	0	29483	\N
24112	96	2	0	29493	\N
24129	20	2	0	30427	\N
24129	369	3	0	30428	\N
24301	151	3	0	30677	\N
24301	3046	4	0	30680	\N
24306	7017	3	0	31018	\N
24306	202	8	0	31029	\N
24306	7020	9	1	31263	\N
24283	2	0	0	35370	\N
24072	2	2	0	35389	\N
24072	2789	3	0	35393	\N
24139	2	2	0	35411	\N
24139	2789	3	0	35412	\N
24124	14	4	0	39265	\N
24124	2291	5	0	39267	\N
24096	18	2	0	40377	\N
24096	1685	3	0	40380	\N
24158	18	3	0	40386	\N
24176	18	2	0	40387	\N
24176	1685	3	0	40388	\N
24249	18	13	0	40399	\N
24361	18	2	0	40400	\N
24249	4730	14	0	40403	\N
24186	23	3	0	40838	\N
24186	3497	4	0	40839	\N
24107	27	0	0	41002	\N
24171	27	5	0	41061	\N
24171	6997	6	0	41065	\N
24279	40	2	0	42430	\N
24279	282	3	0	42432	\N
24321	40	4	0	42447	\N
24321	3381	5	0	42448	\N
24363	56	3	0	44516	\N
24296	71	10	0	44795	\N
24296	7014	11	0	44799	\N
24317	75	7	0	45982	\N
24317	2859	8	0	45983	\N
24330	79	4	0	46802	\N
24330	3678	5	0	46803	\N
24356	79	3	0	46834	\N
24356	3652	4	0	46835	\N
24284	102	3	0	47892	\N
24284	3597	4	0	47894	\N
24203	125	3	0	49256	\N
24203	4170	4	0	49257	\N
24360	137	2	0	49755	\N
24360	2721	3	0	49757	\N
24303	156	3	0	50347	\N
24335	156	11	0	50348	\N
24303	4594	4	0	50351	\N
24335	7030	12	0	50352	\N
24347	170	3	0	50614	\N
24347	4148	4	0	50615	\N
24246	186	3	0	51241	\N
24246	4294	4	0	51248	\N
24274	200	4	0	51551	\N
24274	3473	5	0	51556	\N
24217	435	3	0	55120	\N
24217	3504	4	0	55127	\N
24332	595	11	0	55555	\N
24352	595	2	0	55556	\N
24352	3285	3	0	55562	\N
24332	7027	12	0	55568	\N
24252	841	8	0	57001	\N
24252	7006	9	0	57002	\N
24295	908	1	0	57699	\N
24295	3149	2	0	57700	\N
24314	1470	7	0	58276	\N
24314	5261	8	0	58279	\N
24254	4678	0	0	58470	\N
24182	2636	3	0	58752	\N
24182	2837	4	0	58756	\N
24257	2647	13	0	59433	\N
24257	7007	14	0	59434	\N
24259	4088	4	0	59820	\N
24259	4089	5	0	59822	\N
24237	4233	2	0	60075	\N
24237	5577	3	0	60076	\N
24327	6723	3	0	60856	\N
24263	6724	4	0	60861	\N
24327	6724	4	0	60862	\N
24159	4247	3	0	7058	\N
24288	4178	3	0	7074	\N
24288	4211	4	0	7075	\N
24276	4205	5	0	7076	\N
24292	4178	3	0	7077	\N
24309	4178	3	0	7078	\N
24292	4211	4	0	7079	\N
24309	4211	4	0	7080	\N
24312	4178	9	0	7081	\N
24337	4178	3	0	7082	\N
24337	4211	4	0	7083	\N
24339	4450	1	0	7084	\N
24312	4682	10	0	7085	\N
24339	4527	5	0	7087	\N
24343	4178	3	0	7088	\N
24343	4211	4	0	7089	\N
24344	4178	3	0	7090	\N
24344	4211	4	0	7093	\N
24184	4172	2	0	9331	\N
24184	4191	3	0	9333	\N
24220	4172	3	0	9339	\N
24220	4275	4	0	9340	\N
24230	4172	4	0	9341	\N
24244	4172	4	0	9343	\N
24230	4219	5	0	9345	\N
24267	4172	3	0	9347	\N
24267	4275	4	0	9348	\N
24342	4172	3	0	9349	\N
24342	4275	4	0	9350	\N
24355	4172	2	0	9351	\N
24355	4191	3	0	9352	\N
24235	391	4	0	10181	\N
24298	391	6	0	10182	\N
24334	391	11	0	10183	\N
24235	3913	5	0	10188	\N
24298	3521	7	0	10190	\N
24334	7029	12	0	10191	\N
24195	3729	4	0	11330	\N
24318	108	6	0	11787	\N
24318	5748	7	0	11788	\N
24290	300	4	0	12111	\N
24290	6350	5	0	12115	\N
24206	4824	6	0	12506	\N
24206	528	7	0	12520	\N
24262	123	3	0	12772	\N
24262	2856	4	0	12781	\N
24315	92	7	0	15079	\N
24315	5768	8	0	15080	\N
24270	38	4	0	16379	\N
24265	142	15	0	18539	\N
24265	7010	16	0	18541	\N
24350	290	6	0	19020	\N
24350	7031	7	0	19021	\N
24319	208	13	0	19273	\N
24319	7023	14	0	19301	\N
24169	62	2	0	19781	\N
24169	2191	3	0	19785	\N
24192	164	2	0	21132	\N
24192	1124	3	0	21135	\N
24198	488	3	0	21491	\N
24198	1103	4	0	21492	\N
24215	3400	4	0	22994	\N
24172	264	5	0	23541	\N
24172	6998	6	0	23542	\N
24297	264	8	0	23551	\N
24297	7015	9	0	23554	\N
24269	140	4	0	24007	\N
24269	3821	5	0	24012	\N
24175	214	2	0	24548	\N
24175	1259	3	0	24550	\N
24338	412	1	0	25224	\N
24338	411	4	0	25232	\N
24338	2988	5	0	25233	\N
24354	3310	3	0	27588	\N
24180	16	2	0	29087	\N
24180	388	3	0	29089	\N
24307	1045	3	0	29094	\N
24307	16	8	0	29095	\N
24307	3118	9	0	29096	\N
24329	16	3	0	29097	\N
24329	3634	4	0	29100	\N
24362	16	2	0	29101	\N
24362	388	3	0	29102	\N
24302	360	3	0	31405	\N
24302	3602	4	0	31412	\N
24336	3342	4	0	31775	\N
24323	230	7	0	32072	\N
24323	3952	8	0	32077	\N
24281	2	0	0	35369	\N
24285	2	0	0	35390	\N
24187	4	34	0	35984	\N
24187	7001	35	0	35988	\N
24158	3621	4	0	40389	\N
24207	4180	6	0	40390	\N
24207	18	7	0	40393	\N
24392	40	5	0	42460	\N
24427	40	2	0	42462	\N
24473	40	2	0	42465	\N
24427	282	3	0	42467	\N
24473	66	3	0	42470	\N
24392	2714	6	0	42472	\N
24515	75	7	0	45991	\N
24515	3331	8	0	45999	\N
24470	79	2	0	46891	\N
24470	616	3	0	46893	\N
24571	88	3	0	47172	\N
24571	3655	4	0	47173	\N
24507	125	5	0	49278	\N
24507	2847	6	0	49280	\N
24358	181	2	0	50888	\N
24358	3313	3	0	50890	\N
24418	260	2	0	52498	\N
24418	3184	3	0	52499	\N
24403	273	3	0	53010	\N
24403	3638	4	0	53012	\N
24413	273	2	0	53018	\N
24413	1413	3	0	53019	\N
24320	279	13	0	53228	\N
24320	7024	14	0	53230	\N
24495	324	1	0	54276	\N
24495	325	2	0	54278	\N
24416	435	2	0	55121	\N
24416	3413	3	0	55125	\N
24333	597	11	0	55849	\N
24353	597	2	0	55850	\N
24353	3286	3	0	55851	\N
24333	7028	12	0	55854	\N
24377	793	3	0	56879	\N
24377	7038	4	0	56880	\N
24482	2782	0	0	59331	\N
24450	5885	4	0	60515	\N
24450	6674	5	0	60520	\N
24394	6044	2	0	60645	\N
24394	6188	3	0	60653	\N
24351	6825	3	0	60749	\N
24577	7079	3	0	60844	\N
24325	7025	8	0	39	\N
24300	835	4	0	1035	\N
24300	7016	5	0	1036	\N
24400	251	3	0	1490	\N
24400	3514	4	0	1491	\N
24437	367	7	0	3362	\N
24437	7051	8	0	3364	\N
24341	365	3	0	4587	\N
24341	3839	4	0	4589	\N
24401	189	3	0	4902	\N
24401	7043	4	0	4903	\N
24432	189	3	0	4918	\N
24432	3782	4	0	4925	\N
24368	4247	3	0	7092	\N
24375	4178	3	0	7094	\N
24375	5507	4	0	7097	\N
24411	4178	3	0	7098	\N
24411	4441	4	0	7099	\N
24512	4178	5	0	7107	\N
24512	4429	6	0	7109	\N
24548	4178	2	0	7114	\N
24548	4247	3	0	7115	\N
24562	4178	2	0	7116	\N
24562	4247	3	0	7117	\N
24568	4178	4	0	7118	\N
24440	4172	2	0	9363	\N
24440	4191	3	0	9364	\N
24445	4172	2	0	9365	\N
24479	4172	2	0	9367	\N
24445	4191	3	0	9368	\N
24479	4191	3	0	9369	\N
24408	391	3	0	10184	\N
24408	3660	4	0	10186	\N
24521	391	2	0	10200	\N
24521	1381	3	0	10202	\N
24575	391	2	0	10206	\N
24575	1381	3	0	10207	\N
24500	3340	3	0	11798	\N
24462	300	0	0	12112	\N
24388	528	2	0	12514	\N
24388	2765	3	0	12516	\N
24328	123	3	0	12773	\N
24328	2856	4	0	12782	\N
24378	38	30	0	16387	\N
24378	7039	31	0	16395	\N
24349	115	6	0	16678	\N
24349	4693	7	0	16684	\N
24385	326	7	0	17396	\N
24385	7041	8	0	17400	\N
24322	5668	8	0	18547	\N
24539	208	6	0	19274	\N
24572	208	9	0	19275	\N
24539	7074	7	0	19299	\N
24572	7077	10	0	19300	\N
24455	60	3	0	19446	\N
24455	3585	4	0	19447	\N
24555	62	5	0	19784	\N
24555	4422	6	0	19788	\N
24387	198	2	0	20019	\N
24428	198	3	0	20020	\N
24387	513	3	0	20021	\N
24421	7047	79	0	20734	\N
24304	164	3	0	21144	\N
24304	3385	4	0	21151	\N
24299	5480	7	0	23553	\N
24406	82	2	0	23734	\N
24406	3401	3	0	23737	\N
24310	69	3	0	24751	\N
24310	4536	4	0	24752	\N
24373	69	0	0	24765	\N
24382	411	4	0	25231	\N
24382	2806	5	0	25234	\N
24380	16	1	0	29103	\N
24557	7076	117	0	30148	\N
24557	54	126	0	30164	\N
24557	2152	127	0	30165	\N
24484	20	2	0	30443	\N
24484	369	3	0	30444	\N
24305	7017	3	0	31017	\N
24308	7017	3	0	31019	\N
24346	202	7	0	31026	\N
24305	202	8	0	31028	\N
24308	202	8	0	31030	\N
24305	7018	9	0	31031	\N
24308	7018	9	0	31032	\N
24367	322	2	0	32598	\N
24367	1866	3	0	32599	\N
24524	453	2	0	32813	\N
24524	3366	3	0	32815	\N
24458	2	4	0	35438	\N
24460	2	2	0	35439	\N
24460	2789	3	0	35441	\N
24458	2830	5	0	35443	\N
24534	6	4	0	36317	\N
24534	6228	5	0	36319	\N
24384	14	7	0	39266	\N
24384	7040	8	0	39268	\N
24542	2291	5	0	39276	\N
24365	18	5	0	40401	\N
24365	7032	6	0	40405	\N
24404	18	3	0	40408	\N
24419	18	2	0	40409	\N
24498	18	6	0	40411	\N
24419	1685	3	0	40412	\N
24404	3621	4	0	40413	\N
24498	4180	7	0	40415	\N
24443	40	4	0	42464	\N
24491	40	2	0	42466	\N
24491	282	3	0	42468	\N
24443	2796	5	0	42471	\N
24503	40	2	0	42491	\N
24503	282	3	0	42492	\N
24537	7072	0	0	42503	\N
24363	4109	4	0	44517	\N
24409	56	1	0	44518	\N
24409	1088	2	0	44519	\N
24434	56	0	0	44520	\N
24549	56	2	0	44522	\N
24549	2795	3	0	44525	\N
24467	71	3	0	44796	\N
24467	3770	4	0	44798	\N
24436	79	7	0	46869	\N
24436	4063	8	0	46870	\N
24477	79	3	0	46892	\N
24477	3652	4	0	46894	\N
24492	79	3	0	46918	\N
24492	3652	4	0	46920	\N
24464	88	7	0	47168	\N
24464	5323	8	0	47169	\N
24486	100	5	0	47547	\N
24486	7057	6	0	47548	\N
24488	100	3	0	47559	\N
24488	3836	4	0	47560	\N
24508	102	2	0	47916	\N
24508	3053	3	0	47918	\N
24461	121	2	0	48927	\N
24461	2498	3	0	48929	\N
24466	200	3	0	51552	\N
24466	3338	4	0	51554	\N
24553	260	2	0	52504	\N
24553	3184	3	0	52505	\N
24573	279	9	0	53240	\N
24573	7078	10	0	53242	\N
24496	324	2	0	54277	\N
24496	2808	3	0	54279	\N
24447	451	3	0	55307	\N
24447	3934	4	0	55310	\N
24399	793	3	0	56881	\N
24399	2644	4	0	56885	\N
24366	841	6	0	57013	\N
24366	7033	7	0	57014	\N
24414	908	2	0	57707	\N
24414	2832	3	0	57708	\N
24493	908	3	0	57713	\N
24493	3591	4	0	57715	\N
24475	2578	4	0	58637	\N
24475	7054	5	0	58641	\N
24480	2782	0	0	59329	\N
24611	2782	3	0	59336	\N
24611	3659	4	0	59338	\N
24369	4233	8	0	60077	\N
24369	7034	9	0	60078	\N
24592	4787	7	0	60326	\N
24599	4787	1	0	60328	\N
24599	6663	2	0	60333	\N
24592	7089	8	0	60337	\N
24585	7084	5	0	60852	\N
24585	6723	8	0	60864	\N
24585	7085	9	0	60865	\N
24425	110	2	0	2547	\N
24453	35	3	0	4212	\N
24453	3563	4	0	4213	\N
24422	4178	7	0	7100	\N
24441	4178	2	0	7101	\N
24441	4247	3	0	7102	\N
24422	4509	8	0	7103	\N
24471	4178	2	0	7104	\N
24471	4247	3	0	7105	\N
24529	4178	5	0	7110	\N
24529	4429	6	0	7111	\N
24581	4178	5	0	7123	\N
24581	4429	6	0	7124	\N
24389	4191	3	0	9355	\N
24402	4172	2	0	9357	\N
24402	4191	3	0	9358	\N
24459	4172	4	0	9366	\N
24459	4252	5	0	9370	\N
24513	4172	5	0	9371	\N
24528	4172	2	0	9372	\N
24528	4191	3	0	9374	\N
24513	4415	6	0	9376	\N
24429	391	3	0	10196	\N
24429	3660	4	0	10197	\N
24565	391	2	0	10201	\N
24606	391	7	0	10228	\N
24606	3662	8	0	10229	\N
24485	455	1	0	11328	\N
24386	132	7	0	11338	\N
24485	132	3	0	11339	\N
24386	4559	8	0	11342	\N
24397	108	2	0	11795	\N
24397	3340	3	0	11797	\N
24463	300	3	0	12113	\N
24463	3747	4	0	12114	\N
24531	300	2	0	12126	\N
24531	2786	3	0	12127	\N
24469	38	2	0	16389	\N
24469	4009	3	0	16391	\N
24376	7037	4	0	16394	\N
24448	290	4	0	19038	\N
24448	2759	5	0	19040	\N
24474	60	0	0	19454	\N
24430	62	3	0	19783	\N
24430	3344	4	0	19787	\N
24421	64	126	0	20749	\N
24421	7048	127	0	20750	\N
24395	488	2	0	21500	\N
24395	2791	3	0	21501	\N
24454	149	3	0	23121	\N
24454	2374	4	0	23122	\N
24560	264	1	0	23560	\N
24560	270	2	0	23562	\N
24371	69	0	0	24763	\N
24433	206	2	0	25764	\N
24433	2773	3	0	25765	\N
24438	206	2	0	25782	\N
24438	2773	3	0	25783	\N
24587	7083	5	0	26060	\N
24587	90	8	0	26072	\N
24587	3039	9	0	26074	\N
24511	94	2	0	27049	\N
24478	2794	3	0	27050	\N
24511	2794	3	0	27051	\N
24615	16	3	0	29111	\N
24424	449	7	0	29843	\N
24424	6718	8	0	29845	\N
24501	54	3	0	30144	\N
24556	54	5	0	30160	\N
24556	7075	6	0	30163	\N
24489	202	4	0	31040	\N
24489	2293	5	0	31041	\N
24417	33	7	0	31774	\N
24525	7066	39	0	32806	\N
24525	453	126	0	32817	\N
24525	7067	127	0	32818	\N
24518	2	2	0	35462	\N
24518	2789	3	0	35465	\N
24535	6	20	0	36318	\N
24535	7070	21	0	36320	\N
24569	14	4	0	39274	\N
24569	2291	5	0	39277	\N
24451	18	4	0	40410	\N
24451	3779	5	0	40414	\N
24456	27	3	0	41062	\N
24393	40	3	0	42461	\N
24442	40	8	0	42463	\N
24393	372	4	0	42469	\N
24442	3438	9	0	42473	\N
24595	40	2	0	42513	\N
24640	40	8	0	42515	\N
24595	282	3	0	42517	\N
24640	5163	9	0	42519	\N
24644	40	4	0	42530	\N
24644	7107	5	0	42537	\N
24379	81	2	0	46856	\N
24547	79	5	0	46919	\N
24547	3341	6	0	46921	\N
24637	81	1	0	46924	\N
24604	79	2	0	46935	\N
24637	79	5	0	46938	\N
24604	616	3	0	46939	\N
24637	7097	6	0	46942	\N
24607	100	3	0	47567	\N
24607	3836	4	0	47569	\N
24412	102	3	0	47893	\N
24412	3597	4	0	47895	\N
24566	113	4	0	48284	\N
24566	5924	5	0	48286	\N
24435	121	0	0	48915	\N
24532	121	2	0	48928	\N
24532	2498	3	0	48930	\N
24558	125	2	0	49288	\N
24558	3297	3	0	49290	\N
24423	156	7	0	50357	\N
24423	5375	8	0	50358	\N
24660	200	3	0	51553	\N
24660	3338	4	0	51555	\N
24670	210	4	0	51869	\N
24670	3536	5	0	51871	\N
24449	268	4	0	52634	\N
24449	4344	5	0	52647	\N
24444	273	2	0	53036	\N
24444	1413	3	0	53037	\N
24538	279	6	0	53239	\N
24538	7073	7	0	53241	\N
24540	285	9	0	53578	\N
24540	3421	10	0	53581	\N
24446	451	9	0	55306	\N
24446	7052	10	0	55311	\N
24622	451	6	0	55325	\N
24622	7094	7	0	55327	\N
24481	2782	5	0	59330	\N
24483	2782	0	0	59332	\N
24481	2865	6	0	59333	\N
24624	3628	2	0	59685	\N
24624	4360	3	0	59690	\N
24651	4233	4	0	60079	\N
24651	7109	5	0	60084	\N
24597	4787	2	0	60327	\N
24597	6245	3	0	60334	\N
24685	6044	10	0	60646	\N
24685	7118	11	0	60660	\N
24663	7114	5	0	60966	\N
24506	424	2	0	727	\N
24668	251	3	0	1497	\N
24668	3514	4	0	1501	\N
24675	228	3	0	2829	\N
24675	3186	4	0	2831	\N
24617	367	17	0	3363	\N
24617	7092	18	0	3365	\N
24407	4178	6	0	7095	\N
24407	6623	7	0	7096	\N
24602	4178	3	0	7127	\N
24602	4441	4	0	7128	\N
24649	4178	4	0	7135	\N
24649	4205	5	0	7141	\N
24410	4172	2	0	9359	\N
24439	4172	4	0	9360	\N
24410	4191	3	0	9361	\N
24439	4252	5	0	9362	\N
24570	4172	4	0	9377	\N
24570	4252	5	0	9380	\N
24680	4172	3	0	9383	\N
24680	4275	4	0	9384	\N
24681	4644	5	0	9385	\N
24681	4172	12	0	9386	\N
24681	7116	13	0	9387	\N
24578	391	2	0	10212	\N
24593	300	7	0	12135	\N
24593	7090	8	0	12138	\N
24689	528	4	0	12515	\N
24689	5689	5	0	12518	\N
24405	77	2	0	13102	\N
24405	3853	3	0	13103	\N
24452	58	3	0	13590	\N
24452	3665	4	0	13592	\N
24457	402	4	0	14033	\N
24457	2548	5	0	14034	\N
24468	38	3	0	16388	\N
24468	3457	4	0	16393	\N
24398	1909	3	0	19031	\N
24472	60	4	0	19453	\N
24472	2771	5	0	19455	\N
24415	62	2	0	19782	\N
24415	2191	3	0	19786	\N
24582	7082	5	0	20014	\N
24582	198	8	0	20028	\N
24582	3084	9	0	20030	\N
24420	7045	11	0	20733	\N
24420	64	48	0	20747	\N
24420	7046	49	0	20748	\N
24613	164	3	0	21145	\N
24396	67	61	0	22158	\N
24396	7042	62	0	22163	\N
24426	7049	2	0	22342	\N
24426	7050	3	0	22343	\N
24465	336	8	0	22997	\N
24465	7053	9	0	22998	\N
24561	264	2	0	23561	\N
24561	2780	3	0	23563	\N
24619	140	3	0	24008	\N
24619	4149	4	0	24011	\N
24658	140	3	0	24019	\N
24658	4149	4	0	24020	\N
24391	3596	4	0	25244	\N
24431	90	3	0	26068	\N
24431	4074	4	0	26070	\N
24522	1171	2	0	26280	\N
24522	7065	3	0	26281	\N
24666	86	2	0	26425	\N
24666	3321	3	0	26426	\N
24550	244	2	0	27284	\N
24550	3308	3	0	27288	\N
24390	16	2	0	29104	\N
24476	16	4	0	29105	\N
24487	16	4	0	29106	\N
24476	2575	5	0	29109	\N
24487	2575	5	0	29110	\N
24501	3041	4	0	30145	\N
24381	20	3	0	30433	\N
24381	2844	4	0	30434	\N
24519	151	2	0	30689	\N
24519	2854	3	0	30694	\N
24509	7061	2	0	31054	\N
24509	2764	3	0	31055	\N
24673	202	12	0	31056	\N
24673	7115	13	0	31057	\N
24526	453	2	0	32814	\N
24554	18	2	0	40418	\N
24563	18	3	0	40419	\N
24554	1685	3	0	40420	\N
24563	3621	4	0	40421	\N
24574	40	2	0	42512	\N
24629	40	3	0	42514	\N
24574	282	3	0	42516	\N
24629	372	4	0	42518	\N
24497	56	6	0	44521	\N
24667	56	2	0	44523	\N
24667	2795	3	0	44526	\N
24497	4703	7	0	44527	\N
24600	71	3	0	44809	\N
24695	71	5	0	44810	\N
24600	3770	4	0	44813	\N
24695	5503	6	0	44814	\N
24551	75	2	0	45992	\N
24551	284	3	0	45995	\N
24635	81	1	0	46922	\N
24635	79	5	0	46936	\N
24635	7097	6	0	46940	\N
24707	102	10	0	47917	\N
24707	7128	11	0	47919	\N
24623	119	3	0	48533	\N
24623	2860	4	0	48543	\N
24632	137	3	0	49771	\N
24632	3633	4	0	49772	\N
24612	156	3	0	50363	\N
24612	4594	4	0	50365	\N
24536	170	0	0	50636	\N
24620	170	3	0	50647	\N
24620	4148	4	0	50651	\N
24523	186	2	0	51242	\N
24523	1850	3	0	51246	\N
24517	7064	30	0	51268	\N
24517	186	31	0	51283	\N
24699	268	5	0	52635	\N
24699	7121	6	0	52649	\N
24594	273	7	0	53047	\N
24594	7091	8	0	53048	\N
24608	316	3	0	53916	\N
24608	4249	4	0	53918	\N
24625	451	3	0	55319	\N
24625	3934	4	0	55322	\N
24688	793	3	0	56882	\N
24688	5510	4	0	56884	\N
24603	852	3	0	57497	\N
24603	1848	4	0	57498	\N
24530	1368	0	0	57856	\N
24596	2636	2	0	58754	\N
24596	2836	3	0	58755	\N
24647	4088	4	0	59838	\N
24647	4089	5	0	59842	\N
24577	7080	4	0	60845	\N
24653	6765	4	0	60916	\N
24653	7111	5	0	60921	\N
24494	7058	3	0	1632	\N
24514	7062	54	0	3141	\N
24516	1636	7	0	3144	\N
24516	4510	8	0	3147	\N
24514	1636	126	0	3148	\N
24514	7063	127	0	3149	\N
24662	1636	4	0	3150	\N
24662	4118	5	0	3155	\N
24598	262	2	0	3802	\N
24598	2743	3	0	3803	\N
24610	262	3	0	3815	\N
24610	4778	4	0	3821	\N
24504	4178	2	0	7106	\N
24541	4178	4	0	7112	\N
24541	4331	5	0	7113	\N
24579	4178	2	0	7119	\N
24579	4247	3	0	7121	\N
24601	4178	3	0	7125	\N
24601	4211	4	0	7126	\N
24609	4178	3	0	7129	\N
24630	4178	3	0	7130	\N
24645	4178	4	0	7131	\N
24609	4211	4	0	7132	\N
24630	4211	4	0	7133	\N
24645	4468	5	0	7134	\N
24559	4275	4	0	9375	\N
24679	4172	5	0	9381	\N
24679	4634	6	0	9382	\N
24693	4172	6	0	9390	\N
24693	4197	7	0	9391	\N
24590	391	6	0	10222	\N
24590	4361	7	0	10223	\N
24618	391	17	0	10232	\N
24618	7093	18	0	10235	\N
24530	7069	0	0	12125	\N
24591	7088	0	0	12128	\N
24583	4427	5	0	12756	\N
24583	4862	9	0	12787	\N
24533	77	5	0	13124	\N
24533	6215	6	0	13125	\N
24576	58	3	0	13591	\N
24576	3665	4	0	13593	\N
24648	233	4	0	13864	\N
24648	3775	5	0	13868	\N
24520	92	2	0	15089	\N
24527	92	79	0	15090	\N
24520	2763	3	0	15092	\N
24527	7068	80	0	15094	\N
24677	235	4	0	15710	\N
24605	38	2	0	16390	\N
24605	4009	3	0	16392	\N
24641	115	8	0	16679	\N
24641	7100	9	0	16685	\N
24591	7087	0	0	16966	\N
24586	6698	9	1	18399	\N
24586	7086	9	0	19982	\N
24586	7082	5	0	20015	\N
24586	198	8	0	20029	\N
24646	198	4	0	20038	\N
24646	7108	5	0	20049	\N
24627	241	4	0	20455	\N
24616	164	2	0	21146	\N
24616	3085	3	0	21150	\N
24543	145	0	0	21936	\N
24545	145	0	0	21937	\N
24638	1075	6	1	21968	\N
24614	73	3	0	22508	\N
24614	3040	4	0	22510	\N
24564	336	2	0	22999	\N
24564	3332	3	0	23000	\N
24510	69	2	0	24775	\N
24510	3350	3	0	24780	\N
24499	224	2	0	25503	\N
24584	7083	5	0	26059	\N
24584	90	8	0	26071	\N
24584	3039	9	0	26073	\N
24686	16	10	0	29114	\N
24686	4835	11	0	29115	\N
24638	7098	6	0	29459	\N
24634	97	1	0	29495	\N
24638	97	1	0	29496	\N
24634	96	5	0	29506	\N
24638	96	5	0	29507	\N
24634	3131	6	0	29508	\N
24502	7060	117	0	30121	\N
24502	2152	127	0	30147	\N
24588	202	2	0	31046	\N
24589	202	2	0	31047	\N
24588	2764	3	0	31048	\N
24589	2764	3	0	31049	\N
24567	2	4	0	35463	\N
24567	2830	5	0	35467	\N
24580	14	8	0	39275	\N
24580	7081	9	0	39278	\N
24672	18	4	0	40426	\N
24672	2302	5	0	40428	\N
24719	40	8	0	42532	\N
24719	5163	9	0	42536	\N
24722	56	0	0	44524	\N
24869	56	3	0	44534	\N
24869	4109	4	0	44537	\N
24758	75	3	0	45993	\N
24758	3855	4	0	45996	\N
24767	79	3	0	46225	\N
24767	3652	4	0	46228	\N
24636	81	1	0	46923	\N
24636	79	5	0	46937	\N
24636	7097	6	0	46941	\N
24737	100	8	0	47583	\N
24737	3793	9	0	47590	\N
24864	102	3	0	47954	\N
24864	3597	4	0	47956	\N
24631	135	3	0	49516	\N
24631	3630	4	0	49528	\N
24665	260	1	0	52366	\N
24665	1904	2	0	52369	\N
24628	316	10	0	53925	\N
24628	7095	11	0	53926	\N
24655	316	9	0	53933	\N
24655	7112	10	0	53934	\N
24633	2782	6	0	59337	\N
24633	7096	7	0	59339	\N
24725	2782	44	0	59342	\N
24725	7140	45	0	59345	\N
24642	7101	8	0	59472	\N
24621	3625	3	0	59516	\N
24621	3784	4	0	59521	\N
24857	4926	8	0	1229	\N
24802	367	3	0	3380	\N
24802	3683	4	0	3381	\N
24812	367	5	0	3392	\N
24812	4414	6	0	3401	\N
24684	262	10	0	3816	\N
24828	262	3	0	3819	\N
24828	4778	4	0	3823	\N
24684	5412	11	0	3824	\N
24884	262	3	0	3829	\N
24884	4778	4	0	3831	\N
24815	7165	82	0	4904	\N
24815	189	126	0	4930	\N
24730	373	0	0	5390	\N
24691	4178	4	0	7139	\N
24691	4205	5	0	7144	\N
24703	4178	27	0	7149	\N
24703	7124	28	0	7150	\N
24727	4178	6	0	7153	\N
24727	5854	7	0	7154	\N
24739	4178	7	0	7155	\N
24739	5210	8	0	7156	\N
24764	4331	4	0	7157	\N
24764	4178	8	0	7161	\N
24764	4941	9	0	7163	\N
24833	4211	4	0	7172	\N
24839	4178	7	0	7175	\N
24839	4396	8	0	7176	\N
24848	4178	4	0	7177	\N
24848	4205	5	0	7179	\N
24851	4178	7	0	7181	\N
24851	4396	8	0	7182	\N
24875	4178	3	0	7183	\N
24875	4211	4	0	7184	\N
24886	4178	3	0	7186	\N
24886	4211	4	0	7188	\N
24683	4172	3	0	9388	\N
24710	7130	6	0	9392	\N
24696	4172	5	0	9393	\N
24715	4172	3	0	9394	\N
24715	4275	4	0	9395	\N
24696	4644	6	0	9396	\N
24735	7141	3	0	9397	\N
24710	4172	9	0	9398	\N
24710	4285	10	0	9399	\N
24735	4172	8	0	9402	\N
24735	4252	9	0	9403	\N
24835	4172	3	0	9407	\N
24835	4275	4	0	9408	\N
24858	4275	4	0	9412	\N
24861	391	8	0	10243	\N
24861	3922	9	0	10244	\N
24790	300	4	0	12136	\N
24790	6350	5	0	12137	\N
24712	528	7	0	12527	\N
24712	7132	8	0	12530	\N
24754	258	3	0	14385	\N
24754	4401	4	0	14387	\N
24794	92	10	0	15124	\N
24794	7158	11	0	15125	\N
24744	235	8	0	15718	\N
24643	7105	65	0	16666	\N
24642	7102	8	0	16677	\N
24643	115	126	0	16686	\N
24643	7106	127	0	16687	\N
24642	7104	9	1	16929	\N
24657	326	3	0	17397	\N
24657	3339	4	0	17398	\N
24729	142	3	0	18558	\N
24729	4254	4	0	18559	\N
24752	1107	4	0	19342	\N
24752	7151	5	0	19343	\N
24836	6872	9	0	19456	\N
24836	5088	12	0	19472	\N
24639	198	8	0	20037	\N
24639	7099	9	0	20047	\N
24747	488	8	0	21510	\N
24879	73	3	0	22509	\N
24879	3040	4	0	22511	\N
24746	336	8	0	22995	\N
24746	7147	9	0	22996	\N
24797	264	4	0	23582	\N
24797	3684	5	0	23583	\N
24866	6303	2	0	26340	\N
24866	7173	3	0	26345	\N
24792	7157	11	0	27064	\N
24774	244	2	0	27285	\N
24774	3308	3	0	27289	\N
24824	42	3	0	27586	\N
24824	3645	4	0	27590	\N
24615	3634	4	0	29112	\N
24654	16	4	0	29113	\N
24654	5446	5	0	29116	\N
24717	16	6	0	29117	\N
24717	7135	7	0	29118	\N
24816	16	3	0	29124	\N
24816	3634	4	0	29125	\N
24843	3634	4	0	29127	\N
24749	33	8	0	31783	\N
24749	7149	9	0	31785	\N
24734	876	3	0	32063	\N
24736	876	3	0	32064	\N
24734	230	9	0	32078	\N
24736	230	8	0	32079	\N
24736	6806	9	0	32080	\N
24734	3961	10	0	32081	\N
24761	322	7	0	32360	\N
24761	2857	8	0	32368	\N
24720	2	8	0	35483	\N
24626	18	3	0	40423	\N
24626	3621	4	0	40424	\N
24700	18	8	0	40427	\N
24700	7122	9	0	40430	\N
24732	18	7	0	40435	\N
24732	4459	8	0	40436	\N
24751	40	8	0	42533	\N
24751	3503	9	0	42535	\N
24760	56	5	0	44528	\N
24760	3551	6	0	44531	\N
24682	4645	5	0	45984	\N
24682	75	12	0	45998	\N
24682	7117	13	0	46000	\N
24768	7153	2	0	46223	\N
24768	616	3	0	46224	\N
24678	100	3	0	47568	\N
24678	3836	4	0	47570	\N
24753	102	4	0	47938	\N
24753	3572	5	0	47940	\N
24795	125	7	0	49301	\N
24795	4719	8	0	49305	\N
24777	156	4	0	50364	\N
24777	5935	5	0	50366	\N
24846	170	2	0	50649	\N
24846	1380	3	0	50650	\N
24650	181	4	0	50889	\N
24650	4058	5	0	50891	\N
24765	2356	4	0	50900	\N
24765	181	8	0	50911	\N
24765	5260	9	0	50912	\N
24705	268	27	0	52636	\N
24705	7126	28	0	52655	\N
24800	273	4	0	53055	\N
24800	3390	5	0	53056	\N
24865	273	3	0	53060	\N
24865	3638	4	0	53062	\N
24920	316	3	0	53953	\N
24920	4249	4	0	53954	\N
24907	597	4	0	55867	\N
24907	3733	5	0	55870	\N
24690	793	4	0	56883	\N
24690	3618	5	0	56886	\N
24810	7161	112	0	58575	\N
24900	2636	4	0	58767	\N
24900	3617	5	0	58769	\N
24829	3625	3	0	59517	\N
24829	3784	4	0	59522	\N
24841	4787	3	0	60329	\N
24844	4787	0	0	60330	\N
24841	4788	4	0	60336	\N
24698	5885	5	0	60516	\N
24698	7120	6	0	60521	\N
24915	6723	3	0	60857	\N
24915	6724	4	0	60863	\N
24880	2272	5	0	292	\N
24819	3474	4	0	1221	\N
24711	2079	7	0	2303	\N
24711	7131	8	0	2305	\N
24656	228	3	0	2828	\N
24656	3186	4	0	2830	\N
24755	262	3	0	3817	\N
24757	262	2	0	3818	\N
24757	2743	3	0	3820	\N
24755	4778	4	0	3822	\N
24785	35	4	0	4223	\N
24785	3545	5	0	4224	\N
24731	373	0	0	5391	\N
24661	4178	4	0	7137	\N
24671	4178	4	0	7138	\N
24659	4211	4	0	7140	\N
24661	4205	5	0	7142	\N
24671	4205	5	0	7143	\N
24701	4178	7	0	7146	\N
24701	5210	8	0	7148	\N
24726	4178	17	0	7151	\N
24726	5883	18	0	7152	\N
24827	4178	8	0	7167	\N
24827	4237	9	0	7168	\N
24882	4178	3	0	7185	\N
24887	4178	3	0	7189	\N
24887	4211	4	0	7191	\N
24669	4172	3	0	9378	\N
24669	4275	4	0	9379	\N
24748	4172	4	0	9400	\N
24748	4252	5	0	9401	\N
24762	4172	7	0	9404	\N
24762	4614	8	0	9405	\N
24807	4172	3	0	9406	\N
24807	4440	4	0	9409	\N
24891	4172	2	0	9414	\N
24891	4285	3	0	9415	\N
24897	3913	5	0	10249	\N
24706	132	7	0	11349	\N
24706	7127	8	0	11350	\N
24741	132	18	0	11355	\N
24741	7144	19	0	11358	\N
24788	300	0	0	12139	\N
24709	77	3	0	13136	\N
24709	1877	4	0	13137	\N
24822	402	3	0	14045	\N
24822	4077	4	0	14049	\N
24793	258	4	0	14397	\N
24793	3057	5	0	14399	\N
24859	173	8	0	14672	\N
24859	7170	9	0	14677	\N
24702	7123	28	0	14679	\N
24780	92	4	0	15091	\N
24780	3979	5	0	15093	\N
24768	5281	2	0	15219	\N
24769	192	3	0	15272	\N
24769	3790	4	0	15273	\N
24664	44	4	0	16047	\N
24664	3486	5	0	16048	\N
24714	38	7	0	16402	\N
24714	7133	8	0	16407	\N
24652	7110	5	0	17071	\N
24876	212	3	0	17085	\N
24876	3639	4	0	17087	\N
24810	7164	113	1	17700	\N
24759	62	7	0	19798	\N
24759	4781	8	0	19802	\N
24775	241	2	0	20486	\N
24775	634	3	0	20487	\N
24873	488	4	0	21511	\N
24873	5606	5	0	21512	\N
24747	7148	9	0	21513	\N
24912	145	3	0	21939	\N
24862	67	7	0	22160	\N
24862	3608	8	0	22162	\N
24805	149	4	0	23136	\N
24805	5500	5	0	23139	\N
24724	264	44	0	23581	\N
24724	7139	45	0	23586	\N
24687	69	4	0	24776	\N
24687	4041	5	0	24781	\N
24902	224	6	0	25514	\N
24902	7176	7	0	25515	\N
24854	90	3	0	26081	\N
24854	4074	4	0	26082	\N
24870	7174	2	0	26344	\N
24894	16	3	0	29128	\N
24894	3634	4	0	29129	\N
24810	7162	112	0	29522	\N
24810	7163	113	0	29554	\N
24918	2844	3	0	30446	\N
24676	20	4	0	30453	\N
24918	20	5	0	30455	\N
24676	3995	5	0	30456	\N
24918	2975	6	0	30458	\N
24674	202	0	0	31027	\N
24803	202	6	0	31066	\N
24743	14	8	0	39293	\N
24743	3967	9	0	39297	\N
24694	40	5	0	42531	\N
24694	5806	6	0	42534	\N
24801	40	5	0	42547	\N
24801	2714	6	0	42548	\N
24798	56	4	0	44529	\N
24798	3127	5	0	44530	\N
24826	56	8	0	44532	\N
24853	56	3	0	44533	\N
24853	4109	4	0	44536	\N
24826	4150	9	0	44539	\N
24773	75	3	0	45994	\N
24773	3855	4	0	45997	\N
24728	79	3	0	46444	\N
24728	3652	4	0	46445	\N
24723	79	44	0	46479	\N
24723	7138	45	0	46480	\N
24940	88	6	0	47176	\N
24940	5263	7	0	47177	\N
24950	100	0	0	47587	\N
24784	113	17	0	48285	\N
24784	7156	18	0	48287	\N
24883	170	3	0	50657	\N
24883	4148	4	0	50658	\N
24937	170	3	0	50671	\N
24937	4148	4	0	50672	\N
24697	181	5	0	50898	\N
24697	7119	6	0	50899	\N
24809	200	2	0	51563	\N
24809	3109	3	0	51564	\N
24778	285	6	0	53590	\N
24778	3903	7	0	53593	\N
24804	316	6	0	53939	\N
24804	7160	7	0	53942	\N
24772	435	3	0	55122	\N
24772	3504	4	0	55128	\N
24968	842	1	0	57015	\N
24756	841	3	0	57027	\N
24968	841	4	0	57031	\N
24756	3604	4	0	57032	\N
24968	7190	5	0	57033	\N
24770	2636	4	0	58762	\N
24770	3617	5	0	58763	\N
24979	3625	3	0	59518	\N
24979	3784	4	0	59523	\N
24831	3628	2	0	59686	\N
24981	3628	2	0	59687	\N
24831	4360	3	0	59691	\N
24981	4360	3	0	59692	\N
24985	3628	3	0	59700	\N
24985	3785	4	0	59708	\N
24992	4233	2	0	60080	\N
24992	5577	3	0	60082	\N
24704	5885	27	0	60517	\N
24704	7125	28	0	60522	\N
24878	6765	3	0	60917	\N
24878	6884	4	0	60919	\N
24977	3514	4	0	1502	\N
24713	7131	8	0	2306	\N
24716	35	7	0	4222	\N
24716	7134	8	0	4225	\N
24814	189	5	0	4919	\N
24814	4540	6	0	4927	\N
24733	373	0	0	5392	\N
24692	4250	7	0	7147	\N
24776	4178	4	0	7158	\N
24779	4178	6	0	7159	\N
24776	4205	5	0	7160	\N
24779	4250	7	0	7162	\N
24818	4178	5	0	7164	\N
24821	4178	13	0	7166	\N
24821	7167	14	0	7169	\N
24850	4178	7	0	7178	\N
24850	4396	8	0	7180	\N
24832	391	3	0	10238	\N
24832	3660	4	0	10239	\N
24823	132	3	0	11356	\N
24823	3729	4	0	11357	\N
24708	2400	6	0	13126	\N
24708	77	9	0	13138	\N
24708	7129	10	0	13139	\N
24856	58	7	0	13602	\N
24856	4764	8	0	13604	\N
24962	4820	9	0	13605	\N
24781	7154	23	0	15095	\N
24782	92	3	0	15100	\N
24782	4410	4	0	15101	\N
24781	92	56	0	15102	\N
24781	7155	57	0	15103	\N
24786	92	6	0	15112	\N
24786	3651	7	0	15113	\N
24928	326	7	0	17410	\N
24928	7041	8	0	17413	\N
24721	290	8	0	19049	\N
24872	3635	4	0	19051	\N
24721	7137	9	0	19052	\N
24909	198	3	0	20039	\N
24933	198	3	0	20041	\N
24909	4263	4	0	20043	\N
24933	4263	4	0	20045	\N
24953	198	26	0	20072	\N
24953	7183	27	0	20073	\N
24742	241	18	0	20466	\N
24742	7145	19	0	20467	\N
24964	488	3	0	21521	\N
24964	1103	4	0	21522	\N
24889	3040	4	0	22519	\N
24766	336	3	0	22773	\N
24766	3400	4	0	22774	\N
24789	149	4	0	23135	\N
24789	4040	5	0	23138	\N
24763	140	10	0	24035	\N
24763	7152	11	0	24036	\N
24740	214	18	0	24320	\N
24740	7143	19	0	24323	\N
24847	411	4	0	25254	\N
24847	4858	5	0	25255	\N
24970	411	2	0	25260	\N
24738	90	8	0	26069	\N
24738	7142	9	0	26075	\N
24890	94	3	0	27058	\N
24890	2864	4	0	27063	\N
24796	16	3	0	29119	\N
24796	3634	4	0	29120	\N
24799	17	1	0	29121	\N
24799	16	4	0	29122	\N
24799	2974	5	0	29123	\N
24808	96	4	0	29523	\N
24996	96	5	0	29525	\N
24994	96	2	0	29548	\N
24806	54	4	0	30161	\N
24806	2570	5	0	30162	\N
24838	360	7	0	31406	\N
24838	4970	8	0	31417	\N
24935	230	3	0	32086	\N
24935	4181	4	0	32087	\N
24771	322	4	0	32361	\N
24893	322	9	0	32362	\N
24771	5447	5	0	32366	\N
24893	3756	10	0	32369	\N
24986	2	11	0	35517	\N
24986	7192	12	0	35518	\N
24745	3967	9	0	39298	\N
24718	18	8	0	40432	\N
24718	6015	9	0	40433	\N
24750	27	8	0	41063	\N
24750	7150	9	0	41066	\N
24961	27	3	0	41085	\N
24961	4636	4	0	41086	\N
24849	40	10	0	42567	\N
24849	6986	11	0	42568	\N
24965	40	3	0	42591	\N
24965	372	4	0	42592	\N
24901	56	4	0	44535	\N
24901	3127	5	0	44538	\N
24868	71	1	0	44811	\N
24868	3035	2	0	44812	\N
25009	79	2	0	46226	\N
25009	616	3	0	46227	\N
24971	88	3	0	47180	\N
24971	3655	4	0	47183	\N
24946	100	0	0	47584	\N
24947	100	4	0	47585	\N
24949	100	0	0	47586	\N
24947	3776	5	0	47589	\N
24855	102	7	0	47939	\N
24855	5310	8	0	47941	\N
24896	102	3	0	47955	\N
24896	3597	4	0	47957	\N
24904	113	3	0	48296	\N
24904	3620	4	0	48304	\N
24830	119	3	0	48534	\N
24980	119	3	0	48535	\N
24830	2860	4	0	48544	\N
24980	2860	4	0	48545	\N
25001	135	8	0	49517	\N
25001	7203	9	0	49535	\N
24845	170	3	0	50648	\N
24845	4148	4	0	50652	\N
24877	181	3	0	50918	\N
24877	4184	4	0	50920	\N
24834	316	7	0	53940	\N
24834	3866	8	0	53941	\N
24914	324	3	0	54284	\N
24914	4514	4	0	54285	\N
24987	451	11	0	55320	\N
24987	7193	12	0	55324	\N
24908	595	4	0	55557	\N
24908	3878	5	0	55563	\N
24874	1109	4	0	56354	\N
24874	3816	5	0	56356	\N
24973	908	8	0	57714	\N
24973	3509	9	0	57716	\N
24932	1470	4	0	58284	\N
24932	5655	5	0	58285	\N
24967	7185	4	0	58409	\N
24967	7187	5	1	58411	\N
24955	2782	3	0	59343	\N
24955	3659	4	0	59344	\N
25017	4787	0	0	60332	\N
24903	6044	6	0	60647	\N
24903	6264	7	0	60659	\N
24906	6467	5	0	60753	\N
24860	7171	9	0	48	\N
24885	3474	4	0	1228	\N
24888	373	3	0	5393	\N
24888	3590	4	0	5395	\N
24837	4682	9	0	7170	\N
24837	4178	11	0	7173	\N
24837	4460	12	0	7174	\N
24892	4178	9	0	7190	\N
24892	4682	10	0	7192	\N
24898	4178	6	0	7193	\N
24898	4250	7	0	7194	\N
24925	4178	7	0	7195	\N
24925	4509	8	0	7196	\N
24967	7186	4	0	7198	\N
25013	4178	2	0	7202	\N
25013	4247	3	0	7205	\N
24840	4172	7	0	9410	\N
24840	4614	8	0	9413	\N
24929	4172	4	0	9418	\N
24957	4172	4	0	9420	\N
24963	4172	8	0	9421	\N
24929	7178	5	0	9426	\N
24957	4219	5	0	9427	\N
24963	4500	9	0	9429	\N
24820	391	13	0	10233	\N
24881	391	4	0	10247	\N
24881	3352	5	0	10250	\N
24899	108	4	0	11805	\N
24899	4060	5	0	11808	\N
24913	123	3	0	12774	\N
24916	123	3	0	12775	\N
24913	2856	4	0	12783	\N
24916	2856	4	0	12784	\N
24825	192	8	0	15280	\N
24958	192	3	0	15281	\N
24958	3790	4	0	15282	\N
24825	7168	9	0	15283	\N
24934	3457	4	0	16405	\N
24905	212	3	0	17086	\N
24905	3639	4	0	17088	\N
24967	7189	6	1	18218	\N
24927	927	7	0	19169	\N
24927	7177	8	0	19178	\N
25007	60	3	0	19464	\N
25007	3585	4	0	19468	\N
24997	62	7	0	19799	\N
24997	7200	8	0	19803	\N
24911	198	3	0	20040	\N
24952	198	3	0	20042	\N
24952	4263	4	0	20046	\N
24936	7181	8	0	20048	\N
24936	198	31	0	20058	\N
24936	7182	32	0	20059	\N
24923	164	7	0	21148	\N
24923	5711	8	0	21154	\N
25002	145	3	0	21940	\N
25002	4908	4	0	21942	\N
24811	67	4	0	22159	\N
24811	5267	5	0	22161	\N
24910	336	3	0	22789	\N
24910	3400	4	0	22790	\N
24871	264	17	0	23584	\N
24871	2941	18	0	23585	\N
24921	82	4	0	23735	\N
24921	3508	5	0	23738	\N
25018	672	0	0	23910	\N
24960	90	3	0	26090	\N
24960	4074	4	0	26094	\N
24867	6303	3	0	26341	\N
24867	6304	4	0	26346	\N
24863	42	5	0	27587	\N
24863	7172	6	0	27591	\N
24919	16	3	0	29130	\N
24808	3515	5	0	29530	\N
24895	449	3	0	29856	\N
24895	4760	4	0	29860	\N
24917	2844	3	0	30445	\N
24917	20	5	0	30454	\N
24917	2975	6	0	30457	\N
24852	33	4	0	31784	\N
24852	7169	5	0	31786	\N
24943	230	0	0	32075	\N
24941	230	6	0	32094	\N
24941	4182	7	0	32099	\N
24813	453	5	0	32831	\N
24842	453	3	0	32846	\N
24842	2838	4	0	32848	\N
24817	2	5	0	35484	\N
24817	3624	6	0	35487	\N
24982	2	5	0	35507	\N
24982	6376	6	0	35508	\N
24938	14	4	0	39295	\N
24938	3498	5	0	39296	\N
24969	18	4	0	40438	\N
25026	40	2	0	42610	\N
25026	282	3	0	42612	\N
25180	56	0	0	44541	\N
25182	56	0	0	44543	\N
25130	56	3	0	44548	\N
25130	4109	4	0	44550	\N
25154	56	4	0	44553	\N
25154	3127	5	0	44554	\N
25122	79	3	0	46276	\N
25122	3652	4	0	46282	\N
24951	100	0	0	47588	\N
25041	113	1	0	48298	\N
25041	1102	2	0	48302	\N
24983	119	5	0	48536	\N
25165	119	3	0	48537	\N
25165	2860	4	0	48546	\N
24983	6113	6	0	48550	\N
25085	156	13	0	50375	\N
25085	7222	14	0	50384	\N
25114	181	3	0	50919	\N
25114	4184	4	0	50921	\N
25070	186	7	0	51243	\N
25071	186	3	0	51244	\N
25071	7219	4	0	51245	\N
25070	4595	8	0	51249	\N
24954	200	3	0	51569	\N
24954	3338	4	0	51571	\N
24926	210	7	0	51882	\N
24926	4558	8	0	51885	\N
24966	242	10	0	52128	\N
24966	7184	11	0	52129	\N
25050	242	2	0	52144	\N
25050	3425	3	0	52146	\N
25185	242	11	0	52162	\N
25185	6607	12	0	52165	\N
25027	416	2	0	54955	\N
25027	7211	3	0	54956	\N
24988	7194	62	0	55312	\N
24988	451	126	0	55326	\N
24988	7195	127	0	55328	\N
25134	595	7	0	55558	\N
25134	5821	8	0	55565	\N
25073	1021	7	0	56465	\N
25073	7220	8	0	56467	\N
25038	7185	32	0	58410	\N
24956	2636	4	0	58768	\N
24956	3617	5	0	58770	\N
25057	2351	3	0	59000	\N
25057	2845	4	0	59002	\N
25163	3625	3	0	59520	\N
25163	3784	4	0	59524	\N
24993	4233	3	0	60081	\N
24993	4425	4	0	60083	\N
25099	4233	3	0	60085	\N
25099	4425	4	0	60094	\N
25014	2842	3	0	46	\N
25107	7228	11	0	56	\N
25052	12	2	0	297	\N
25052	2804	3	0	299	\N
25094	117	3	0	2014	\N
25094	3653	4	0	2017	\N
25197	110	3	0	2548	\N
25003	228	3	0	2839	\N
25003	3186	4	0	2848	\N
25096	7225	3	0	4035	\N
25096	7226	4	0	4037	\N
25119	189	6	0	4920	\N
25119	3713	7	0	4928	\N
24978	4178	3	0	7200	\N
24978	4211	4	0	7201	\N
25025	4178	1	0	7203	\N
25025	4450	2	0	7204	\N
25037	4178	2	0	7208	\N
25037	4247	3	0	7209	\N
25067	4178	3	0	7210	\N
25067	4211	4	0	7211	\N
24924	4172	2	0	9416	\N
24924	4285	3	0	9417	\N
24948	4172	3	0	9419	\N
25023	4172	4	0	9422	\N
25033	4285	3	0	9424	\N
24948	4940	4	0	9425	\N
25023	4252	5	0	9428	\N
25127	4172	3	0	9434	\N
25127	4275	4	0	9435	\N
25034	391	3	0	10257	\N
25177	391	3	0	10260	\N
25177	3660	4	0	10263	\N
25034	503	4	0	10264	\N
25152	528	4	0	12537	\N
25152	7242	5	0	12540	\N
24989	123	10	0	12776	\N
25060	58	3	0	13614	\N
25060	3665	4	0	13615	\N
25172	173	4	0	14691	\N
25172	3857	5	0	14692	\N
25109	940	3	0	16046	\N
25109	44	14	0	16057	\N
25109	7229	15	0	16058	\N
24930	7179	117	0	17401	\N
24930	326	126	0	17414	\N
24930	7180	127	0	17415	\N
25038	7212	24	0	18560	\N
25038	7213	32	0	18581	\N
24931	927	0	0	19170	\N
24991	60	3	0	19463	\N
24991	3585	4	0	19467	\N
24998	62	5	0	19800	\N
24998	6466	6	0	19801	\N
24922	164	3	0	21147	\N
24922	3385	4	0	21153	\N
25021	164	7	0	21163	\N
25148	164	3	0	21166	\N
25148	3385	4	0	21169	\N
25021	7210	8	0	21170	\N
25112	145	3	0	21953	\N
24974	336	8	0	22797	\N
24974	7191	9	0	22799	\N
25005	264	7	0	23591	\N
25005	7204	8	0	23594	\N
25145	83	1	0	23739	\N
25088	7224	6	0	23740	\N
25062	82	3	0	23747	\N
25145	82	4	0	23748	\N
25062	4505	4	0	23750	\N
25088	82	7	0	23751	\N
25132	69	7	0	24777	\N
25132	3711	8	0	24782	\N
25010	90	2	0	26091	\N
24959	3442	3	0	26092	\N
25010	3442	3	0	26093	\N
24972	94	1	0	27059	\N
24972	107	2	0	27061	\N
25168	96	4	0	29542	\N
25168	3515	5	0	29545	\N
25032	449	2	0	29857	\N
25032	646	3	0	29859	\N
25191	479	1	0	31397	\N
25191	360	5	0	31410	\N
25191	7249	6	0	31643	\N
24942	230	0	0	32074	\N
24944	230	0	0	32076	\N
25136	230	3	0	32095	\N
25136	4181	4	0	32097	\N
24945	2	3	0	35485	\N
24945	3548	4	0	35486	\N
25195	6	4	0	36336	\N
25195	7253	5	0	36337	\N
25199	40	3	0	42653	\N
25199	372	4	0	42656	\N
25065	56	4	0	44540	\N
25065	3127	5	0	44544	\N
25215	56	3	0	44556	\N
25215	4109	4	0	44557	\N
25178	71	3	0	44819	\N
25178	3770	4	0	44820	\N
25031	75	2	0	44987	\N
25031	284	3	0	44988	\N
25042	100	6	0	47602	\N
25042	7216	7	0	47603	\N
25087	5086	6	0	47958	\N
25089	5086	6	0	47959	\N
25087	102	7	0	47974	\N
25089	102	7	0	47975	\N
25040	113	2	0	48297	\N
25040	1899	3	0	48303	\N
25000	137	7	0	49789	\N
25000	7202	8	0	49792	\N
25064	156	3	0	50369	\N
25064	4594	4	0	50370	\N
25051	200	3	0	51570	\N
25051	3338	4	0	51572	\N
25049	242	1	0	52143	\N
25049	253	2	0	52145	\N
25077	260	4	0	52367	\N
25077	3728	5	0	52370	\N
25218	260	4	0	52374	\N
25218	3728	5	0	52375	\N
25183	268	30	0	52638	\N
25187	268	11	0	52639	\N
25187	7247	12	0	52651	\N
25183	7245	31	0	52654	\N
24976	316	3	0	53959	\N
24976	4249	4	0	53960	\N
25075	451	3	0	55321	\N
25075	3934	4	0	55323	\N
25157	1109	6	0	56355	\N
25157	4145	7	0	56357	\N
25201	841	7	0	57028	\N
25201	5065	8	0	57036	\N
25012	7185	4	0	58412	\N
25038	7215	33	1	58419	\N
25123	2782	3	0	59354	\N
25123	3659	4	0	59355	\N
24984	3625	5	0	59519	\N
24984	6114	6	0	59525	\N
25141	5885	3	0	60518	\N
25141	5926	4	0	60519	\N
24990	6723	10	0	60858	\N
24990	7197	11	0	60866	\N
25084	7221	14	0	741	\N
24975	6851	9	0	1504	\N
25016	117	2	0	2013	\N
25175	117	3	0	2015	\N
25016	1257	3	0	2016	\N
25175	3653	4	0	2018	\N
25053	1636	2	0	3151	\N
25101	1636	3	0	3152	\N
25053	4416	3	0	3153	\N
25101	5514	4	0	3154	\N
25211	7225	3	0	4036	\N
25211	7226	4	0	4038	\N
25203	35	7	0	4236	\N
25072	4178	7	0	7212	\N
25110	4178	3	0	7213	\N
25110	4211	4	0	7214	\N
25072	4509	8	0	7215	\N
25159	4178	3	0	7222	\N
25159	4211	4	0	7223	\N
25233	4178	5	0	7231	\N
25233	4202	6	0	7232	\N
25237	7259	0	0	7233	\N
25242	4178	3	0	7234	\N
25242	4211	4	0	7235	\N
25250	4178	7	0	7238	\N
25055	4219	5	0	9431	\N
25170	4172	3	0	9443	\N
25170	4275	4	0	9445	\N
25235	391	5	0	10268	\N
25235	3558	6	0	10271	\N
25103	132	3	0	11368	\N
25105	132	3	0	11369	\N
25125	132	4	0	11370	\N
25103	3729	4	0	11371	\N
25105	3729	4	0	11372	\N
25125	3716	5	0	11373	\N
25019	528	9	0	12528	\N
25068	7218	7	0	15291	\N
25068	4713	8	0	15292	\N
25054	44	2	0	16015	\N
25054	1910	3	0	16016	\N
25222	38	4	0	16404	\N
25222	5656	5	0	16406	\N
25058	212	4	0	17110	\N
25058	3732	5	0	17119	\N
25081	30	8	0	18166	\N
25081	4030	9	0	18169	\N
25038	7214	33	0	18427	\N
25036	142	2	0	18565	\N
25080	290	8	0	19075	\N
25080	4155	9	0	19080	\N
25209	208	3	0	19277	\N
25209	4490	4	0	19290	\N
25011	60	2	0	19465	\N
25011	4544	3	0	19466	\N
25006	164	7	0	21149	\N
25006	5968	8	0	21155	\N
25143	164	3	0	21164	\N
25143	3385	4	0	21167	\N
25030	73	5	0	22527	\N
25030	4931	6	0	22531	\N
25044	3632	4	0	23593	\N
25237	4348	0	0	23756	\N
25022	214	4	0	24321	\N
25022	3355	5	0	24322	\N
25153	86	4	0	26435	\N
25153	7243	5	0	26437	\N
25161	86	4	0	26440	\N
25161	4052	5	0	26441	\N
25012	107	1	0	27053	\N
25012	7205	4	0	27060	\N
25012	7207	6	0	27062	\N
25045	16	2	0	29132	\N
25047	16	2	0	29134	\N
25047	388	3	0	29135	\N
25150	16	42	0	29137	\N
25150	1902	43	0	29142	\N
24995	96	25	0	29524	\N
25078	96	2	0	29526	\N
25078	2347	3	0	29528	\N
24995	7199	26	0	29532	\N
25090	360	3	0	31407	\N
25092	360	4	0	31408	\N
25090	3602	4	0	31413	\N
25024	33	1	0	31791	\N
25024	163	2	0	31793	\N
25155	5284	7	0	31794	\N
25189	431	6	0	34860	\N
25189	4092	7	0	34861	\N
25115	4	3	0	36005	\N
25115	7230	4	0	36006	\N
24969	2302	5	0	40439	\N
25196	18	8	0	40442	\N
25196	3937	9	0	40443	\N
25220	18	3	0	40444	\N
25220	3621	4	0	40445	\N
25056	40	8	0	42611	\N
25056	3503	9	0	42613	\N
25142	40	3	0	42624	\N
25142	372	4	0	42625	\N
25174	40	3	0	42637	\N
25174	372	4	0	42638	\N
25219	40	3	0	42654	\N
25219	372	4	0	42657	\N
25066	56	3	0	44545	\N
25066	4109	4	0	44546	\N
25124	56	4	0	44547	\N
25149	56	5	0	44549	\N
25124	3127	5	0	44551	\N
25149	6463	6	0	44552	\N
25091	88	4	0	47181	\N
25093	88	4	0	47182	\N
25091	3809	5	0	47184	\N
25093	3809	5	0	47185	\N
25204	88	3	0	47202	\N
25204	3655	4	0	47203	\N
25228	88	5	0	47208	\N
25228	5942	6	0	47216	\N
25224	102	3	0	47989	\N
25224	3597	4	0	47996	\N
25184	125	11	0	49315	\N
25184	5675	12	0	49322	\N
25138	170	3	0	50680	\N
25138	4148	4	0	50685	\N
25167	210	4	0	51883	\N
25167	3536	5	0	51884	\N
25169	242	3	0	52151	\N
25171	242	2	0	52152	\N
25171	4576	3	0	52153	\N
25169	2839	4	0	52154	\N
25188	242	8	0	52163	\N
25188	7248	9	0	52164	\N
25140	268	3	0	52637	\N
25140	3815	4	0	52644	\N
25111	273	4	0	53061	\N
25111	3777	5	0	53063	\N
25097	279	3	0	53245	\N
25097	3641	4	0	53246	\N
25069	324	3	0	54297	\N
25069	4514	4	0	54298	\N
25074	1021	3	0	56476	\N
25074	4551	4	0	56482	\N
25221	908	4	0	57719	\N
25221	3488	5	0	57721	\N
25120	2519	127	1	58543	\N
25126	2636	3	0	58775	\N
25126	2837	4	0	58776	\N
25102	4233	2	0	60086	\N
25102	6713	3	0	60091	\N
25015	4787	2	0	60331	\N
25015	6245	3	0	60335	\N
25186	5885	11	0	60523	\N
25186	7246	12	0	60536	\N
25120	7234	126	1	60737	\N
25059	6765	4	0	60918	\N
25059	7217	5	0	60920	\N
25048	3514	4	0	1503	\N
25120	7233	126	0	4732	\N
25120	189	125	0	4940	\N
25158	373	6	0	5394	\N
25158	7244	7	0	5398	\N
25029	4178	5	0	7206	\N
25029	4429	6	0	7207	\N
25117	4178	6	0	7216	\N
25121	4178	3	0	7217	\N
25117	4250	7	0	7221	\N
25106	4172	4	0	9432	\N
25118	4172	6	0	9433	\N
25106	4219	5	0	9436	\N
25108	4172	6	0	9439	\N
25108	4365	7	0	9441	\N
25248	4172	3	0	9444	\N
25028	391	2	0	10253	\N
25028	1381	3	0	10254	\N
25100	391	3	0	10258	\N
25113	391	3	0	10259	\N
25100	3660	4	0	10261	\N
25113	3660	4	0	10262	\N
25241	528	4	0	12538	\N
25241	5689	5	0	12539	\N
25131	77	7	0	13146	\N
25039	402	2	0	14046	\N
25039	2760	3	0	14048	\N
25043	173	5	0	14673	\N
25043	4902	6	0	14676	\N
25156	173	6	0	14690	\N
25156	6103	7	0	14693	\N
25035	235	3	0	15724	\N
25035	5466	4	0	15725	\N
25104	44	46	0	16042	\N
25104	7227	47	0	16045	\N
25120	6693	127	0	18382	\N
25120	7232	82	1	18403	\N
25076	5879	5	0	19065	\N
25086	4071	4	0	19161	\N
25086	7223	5	0	19162	\N
25095	208	3	0	19276	\N
25095	4490	4	0	19289	\N
25098	62	3	0	19818	\N
25098	3344	4	0	19820	\N
25083	198	3	0	20056	\N
25083	4263	4	0	20057	\N
25020	164	9	0	21162	\N
25147	164	3	0	21165	\N
25147	3385	4	0	21168	\N
25116	145	6	0	21959	\N
25116	5341	7	0	21960	\N
24999	336	8	0	22798	\N
24999	7201	9	0	22800	\N
25207	149	7	0	23137	\N
25207	5255	8	0	23140	\N
25129	140	3	0	24049	\N
25129	4149	4	0	24050	\N
25179	214	3	0	24344	\N
25179	3496	4	0	24345	\N
25151	86	3	0	26434	\N
25151	7241	4	0	26436	\N
25232	7243	6	0	26445	\N
25082	244	3	0	27286	\N
25082	4075	4	0	27290	\N
25046	42	1	0	27601	\N
25236	42	5	0	27602	\N
25046	43	2	0	27606	\N
25236	7172	6	0	27610	\N
25061	16	3	0	29136	\N
25061	3634	4	0	29141	\N
25160	380	4	0	29143	\N
25160	16	15	0	29148	\N
25160	1045	16	0	29149	\N
25079	2803	4	0	29529	\N
24996	5078	6	0	29531	\N
25004	151	3	0	30690	\N
25234	151	5	0	30691	\N
25004	3046	4	0	30695	\N
25234	7258	6	0	30697	\N
25193	479	1	0	31398	\N
25193	360	5	0	31411	\N
25092	3513	5	0	31415	\N
25193	7251	6	0	31416	\N
25008	453	3	0	32847	\N
25008	2838	4	0	32849	\N
25190	6641	7	0	36327	\N
25063	18	3	0	40440	\N
25063	3621	4	0	40441	\N
25240	40	8	0	42655	\N
25240	3718	9	0	42658	\N
25181	56	0	0	44542	\N
25202	56	7	0	44555	\N
25202	4791	8	0	44558	\N
25266	56	17	0	44559	\N
25266	5718	18	0	44560	\N
25282	56	3	0	44561	\N
25282	4109	4	0	44562	\N
25238	7260	0	0	46275	\N
25239	79	8	0	46277	\N
25239	3701	9	0	46286	\N
25230	88	4	0	47209	\N
25230	3809	5	0	47215	\N
25285	119	6	0	48538	\N
25285	3644	7	0	48552	\N
25247	121	7	0	48939	\N
25247	7263	8	0	48944	\N
25290	125	2	0	49316	\N
25290	2902	3	0	49318	\N
25223	181	3	0	50928	\N
25223	4184	4	0	50931	\N
25213	186	4	0	51263	\N
25213	4733	5	0	51264	\N
25194	7252	4	0	51276	\N
25194	7002	5	0	51281	\N
25137	200	3	0	51577	\N
25137	3338	4	0	51578	\N
25259	242	4	0	52171	\N
25259	3512	5	0	52176	\N
25216	260	6	0	52368	\N
25216	7255	7	0	52371	\N
25212	279	3	0	53255	\N
25212	3641	4	0	53259	\N
25206	324	7	0	54312	\N
25206	5784	8	0	54313	\N
25270	595	7	0	55559	\N
25278	595	6	0	55560	\N
25278	4698	7	0	55564	\N
25270	5821	8	0	55566	\N
25135	597	7	0	55868	\N
25275	597	4	0	55869	\N
25275	6224	5	0	55872	\N
25135	5820	8	0	55873	\N
25238	1368	0	0	57857	\N
25227	2351	5	0	59008	\N
25231	2351	3	0	59009	\N
25254	2351	4	0	59010	\N
25231	2845	4	0	59011	\N
25254	3494	5	0	59012	\N
25227	7256	6	0	59013	\N
25283	3625	6	0	59555	\N
25283	3642	7	0	59567	\N
25164	3628	3	0	59701	\N
25164	3785	4	0	59709	\N
25265	4787	17	0	60338	\N
25265	7265	18	0	60341	\N
25133	6450	7	0	60757	\N
25133	7235	8	0	60758	\N
25268	6450	7	0	60761	\N
25277	6450	6	0	60762	\N
25277	7269	7	0	60778	\N
25268	7235	8	0	60781	\N
25176	4043	5	0	300	\N
25197	2995	4	0	2550	\N
25200	110	127	0	2554	\N
25210	35	3	0	4247	\N
25246	1572	7	0	5208	\N
25246	7262	8	0	5211	\N
25146	7240	4	1	5216	\N
25146	7237	3	0	5217	\N
25205	4178	0	0	7120	\N
25128	4178	4	0	7218	\N
25121	4211	4	0	7219	\N
25128	4205	5	0	7220	\N
25173	4178	4	0	7224	\N
25173	4205	5	0	7225	\N
25192	4450	1	0	7226	\N
25192	4178	5	0	7227	\N
25192	4941	6	0	7228	\N
25214	4178	3	0	7229	\N
25214	4211	4	0	7230	\N
25244	4178	7	0	7236	\N
25244	4396	8	0	7237	\N
25256	4178	3	0	7240	\N
25256	4211	4	0	7241	\N
25144	4172	5	0	9438	\N
25144	4634	6	0	9440	\N
25248	4275	4	0	9446	\N
25162	4219	5	0	9447	\N
25251	4172	3	0	9448	\N
25251	4275	4	0	9449	\N
25257	4172	3	0	9450	\N
25257	4275	4	0	9451	\N
25208	391	3	0	10267	\N
25267	391	6	0	10269	\N
25208	3660	4	0	10270	\N
25267	3521	7	0	10272	\N
25289	391	2	0	10277	\N
25289	2966	3	0	10278	\N
25261	3716	5	0	11384	\N
25281	58	4	0	13620	\N
25281	4213	5	0	13623	\N
25274	92	4	0	15135	\N
25274	3979	5	0	15136	\N
25252	235	10	0	15734	\N
25252	7264	11	0	15737	\N
25217	142	4	0	18566	\N
25217	3950	5	0	18580	\N
25146	6730	5	0	18769	\N
25245	290	7	0	19076	\N
25245	6540	8	0	19079	\N
25249	6412	7	0	20496	\N
25263	241	4	0	20507	\N
25263	4582	5	0	20508	\N
25295	164	4	0	21188	\N
25295	4152	5	0	21189	\N
25198	488	3	0	21530	\N
25198	1103	4	0	21532	\N
25276	73	6	0	22528	\N
25276	4257	7	0	22532	\N
25146	7238	3	0	22811	\N
25146	7239	4	0	23001	\N
25226	411	5	0	25271	\N
25225	206	1	0	25798	\N
25225	207	2	0	25799	\N
25229	94	5	0	27066	\N
25229	7257	6	0	27067	\N
25166	16	8	0	29152	\N
25166	4130	9	0	29153	\N
25243	7261	105	0	29154	\N
25243	16	126	0	29159	\N
25243	155	127	0	29160	\N
25291	7270	105	0	29161	\N
25291	16	126	0	29170	\N
25291	155	127	0	29171	\N
25139	3041	4	0	30191	\N
25255	151	4	0	30692	\N
25255	3499	5	0	30696	\N
25253	453	10	0	32863	\N
25253	5309	11	0	32864	\N
25287	2	3	0	35524	\N
25287	3548	4	0	35525	\N
25294	2	3	0	35541	\N
25264	18	2	0	40446	\N
25264	1685	3	0	40447	\N
25272	18	3	0	40448	\N
25272	3621	4	0	40449	\N
25288	40	3	0	42678	\N
25288	372	4	0	42680	\N
25331	56	3	0	44563	\N
25331	4109	4	0	44564	\N
25350	71	4	0	44829	\N
25350	3887	5	0	44834	\N
25329	75	4	0	44993	\N
25329	7287	5	0	44994	\N
25328	113	4	0	48299	\N
25328	7286	5	0	48307	\N
25339	121	3	0	48940	\N
25341	121	2	0	48941	\N
25341	2498	3	0	48942	\N
25339	4471	4	0	48943	\N
25301	210	3	0	51890	\N
25349	210	4	0	51891	\N
25301	3539	4	0	51893	\N
25349	3536	5	0	51894	\N
25309	595	0	0	55561	\N
25311	595	0	0	55579	\N
25308	7273	3	0	55852	\N
25271	7267	13	0	55855	\N
25308	7274	4	0	55871	\N
25271	597	110	0	55874	\N
25271	7268	111	0	55875	\N
25344	908	8	0	57720	\N
25344	7291	9	0	57722	\N
25313	2435	6	0	57912	\N
25313	7279	6	1	57984	\N
25312	7277	0	0	57986	\N
25347	2578	6	0	58638	\N
25347	7292	7	0	58642	\N
25302	2636	3	0	58779	\N
25302	2837	4	0	58780	\N
25284	3628	6	0	59702	\N
25284	3643	7	0	59714	\N
25320	4233	4	0	60087	\N
25321	4233	2	0	60088	\N
25322	4233	2	0	60089	\N
25321	5577	3	0	60092	\N
25322	5577	3	0	60093	\N
25320	4234	5	0	60095	\N
25334	4787	6	0	60339	\N
25336	4787	8	0	60340	\N
25334	7289	7	0	60342	\N
25336	7290	9	0	60343	\N
25310	7275	3	0	60760	\N
25310	6450	6	0	60775	\N
25310	7276	7	0	60777	\N
25262	5055	5	0	1525	\N
25303	4049	5	0	4591	\N
25351	189	1	0	4921	\N
25352	189	1	0	4922	\N
25353	189	4	0	4923	\N
25352	7294	2	0	4924	\N
25353	3992	5	0	4926	\N
25351	4224	2	0	4929	\N
25250	4396	8	0	7239	\N
25319	4178	4	0	7242	\N
25319	4205	5	0	7243	\N
25323	4178	9	0	7244	\N
25323	4682	10	0	7245	\N
25335	4178	8	0	7247	\N
25354	4178	7	0	7248	\N
25325	4665	11	0	7249	\N
25354	5089	8	0	7250	\N
25335	5883	9	0	7251	\N
25260	4172	4	0	9452	\N
25306	4172	2	0	9453	\N
25306	4285	3	0	9454	\N
25260	4219	5	0	9455	\N
25312	7278	0	0	9456	\N
25333	4172	4	0	9457	\N
25345	4172	1	0	9458	\N
25333	7288	5	0	9460	\N
25293	391	3	0	10282	\N
25293	3660	4	0	10283	\N
25342	391	3	0	10295	\N
25346	391	3	0	10296	\N
25342	3660	4	0	10298	\N
25346	3660	4	0	10299	\N
25297	528	2	0	12549	\N
25299	528	3	0	12550	\N
25297	2765	3	0	12551	\N
25299	4262	4	0	12552	\N
25300	58	3	0	13621	\N
25286	258	4	0	14398	\N
25286	4409	5	0	14400	\N
25327	258	4	0	14416	\N
25327	6042	5	0	14421	\N
25340	173	3	0	14707	\N
25340	3796	4	0	14712	\N
25305	1453	3	0	15245	\N
25305	7272	4	0	15246	\N
25292	235	4	0	15735	\N
25292	3615	5	0	15736	\N
25304	44	3	0	16043	\N
25304	3631	4	0	16044	\N
25326	3457	4	0	16414	\N
25296	7271	18	0	17733	\N
25298	167	3	0	17740	\N
25298	4028	4	0	17744	\N
25296	167	19	0	17749	\N
25317	30	5	0	18173	\N
25317	1106	6	0	18183	\N
25355	142	3	0	18567	\N
25356	142	2	0	18568	\N
25356	4418	3	0	18574	\N
25355	4254	4	0	18578	\N
25308	1018	4	0	21961	\N
25280	73	4	0	22529	\N
25280	2284	5	0	22530	\N
25313	7280	7	0	23499	\N
25313	264	5	0	23601	\N
25318	264	5	0	23602	\N
25318	7284	6	0	23604	\N
25315	140	5	0	24056	\N
25315	7282	6	0	24057	\N
25314	411	5	0	25272	\N
25314	2874	6	0	25277	\N
25316	224	5	0	25520	\N
25316	7283	6	0	25522	\N
25273	2864	4	0	27069	\N
25348	320	6	0	29235	\N
25348	7293	7	0	29238	\N
25269	151	7	0	30693	\N
25269	7266	8	0	30698	\N
25258	360	3	0	31409	\N
25258	3602	4	0	31414	\N
25324	360	10	0	31422	\N
25324	7285	11	0	31423	\N
25357	360	3	0	31430	\N
25357	3602	4	0	31433	\N
25294	3548	4	0	35542	\N
25337	3548	4	0	35552	\N
25330	14	3	0	39309	\N
25332	14	3	0	39310	\N
25338	14	3	0	39311	\N
25343	14	5	0	39312	\N
25330	4272	4	0	39314	\N
25332	4272	4	0	39315	\N
25338	4272	4	0	39316	\N
25343	6351	6	0	39318	\N
25358	18	3	0	40451	\N
25358	3621	4	0	40452	\N
25279	4180	7	0	40453	\N
25359	7295	5	0	40455	\N
25374	40	5	0	42679	\N
25374	7299	6	0	42681	\N
25400	40	8	0	42710	\N
25400	3718	9	0	42714	\N
25370	56	3	0	44565	\N
25370	4109	4	0	44567	\N
25599	56	3	0	44570	\N
25599	4109	4	0	44572	\N
25466	75	4	0	45012	\N
25466	3959	5	0	45013	\N
25366	79	4	0	46278	\N
25366	3678	5	0	46284	\N
25578	88	3	0	47211	\N
25578	3655	4	0	47214	\N
25504	135	3	0	49518	\N
25563	135	3	0	49519	\N
25504	3630	4	0	49529	\N
25563	3630	4	0	49530	\N
25514	156	3	0	50378	\N
25514	4594	4	0	50382	\N
25531	170	3	0	50683	\N
25531	4148	4	0	50687	\N
25546	285	3	0	53591	\N
25546	4496	4	0	53592	\N
25373	451	3	0	55333	\N
25373	3934	4	0	55334	\N
25605	597	6	0	55881	\N
25605	4697	7	0	55883	\N
25369	908	4	0	57727	\N
25369	7298	5	0	57728	\N
25428	908	4	0	57745	\N
25428	7309	5	0	57750	\N
25479	2578	3	0	58639	\N
25479	4431	4	0	58640	\N
25502	2782	3	0	59358	\N
25502	3659	4	0	59359	\N
25573	7336	3	0	59360	\N
25573	2782	10	0	59365	\N
25573	7337	11	0	59366	\N
25575	7338	11	0	59778	\N
25493	4088	6	0	59840	\N
25493	4246	7	0	59843	\N
25430	7311	7	0	60601	\N
25430	7312	8	0	60602	\N
25495	6450	3	0	60763	\N
25495	6847	4	0	60770	\N
25536	4204	4	0	308	\N
25529	7321	10	0	2854	\N
25391	367	3	0	3394	\N
25391	3683	4	0	3399	\N
25515	262	3	0	3853	\N
25515	4778	4	0	3856	\N
25441	7225	3	0	4041	\N
25441	7226	4	0	4042	\N
25526	365	3	0	4597	\N
25526	3839	4	0	4609	\N
25432	189	3	0	4938	\N
25432	3782	4	0	4939	\N
25375	1970	14	0	5149	\N
25566	7329	10	0	5160	\N
25360	4178	10	0	7252	\N
25360	4665	11	0	7253	\N
25363	4178	6	0	7254	\N
25363	4250	7	0	7255	\N
25367	4178	4	0	7256	\N
25372	4178	3	0	7257	\N
25372	4211	4	0	7258	\N
25367	4205	5	0	7259	\N
25443	4178	3	0	7265	\N
25443	4211	4	0	7269	\N
25511	4178	3	0	7276	\N
25616	4178	3	0	7286	\N
25616	4211	4	0	7289	\N
25365	4172	2	0	9461	\N
25393	4172	3	0	9462	\N
25365	4285	3	0	9463	\N
25393	4940	4	0	9464	\N
25423	4172	2	0	9465	\N
25423	4191	3	0	9467	\N
25524	4172	3	0	9472	\N
25524	4275	4	0	9477	\N
25361	3729	3	0	11374	\N
25362	3729	3	0	11375	\N
25362	132	5	0	11382	\N
25361	3116	6	0	11385	\N
25498	108	3	0	11814	\N
25498	4171	4	0	11815	\N
25481	77	3	0	13147	\N
25481	1877	4	0	13148	\N
25376	233	3	0	13865	\N
25376	3704	4	0	13866	\N
25592	960	4	0	15226	\N
25592	5566	5	0	15229	\N
25453	192	3	0	15307	\N
25453	3790	4	0	15311	\N
25611	6949	6	0	15745	\N
25450	115	3	0	16694	\N
25450	3483	4	0	16696	\N
25482	167	1	0	17741	\N
25482	1444	2	0	17747	\N
25439	208	3	0	19278	\N
25439	4490	4	0	19291	\N
25556	7326	94	0	19473	\N
25554	60	6	0	19482	\N
25554	6394	7	0	19487	\N
25556	60	126	0	19490	\N
25556	7327	127	0	19491	\N
25551	241	79	0	20520	\N
25551	7324	80	0	20521	\N
25364	64	6	0	20741	\N
25364	5183	7	0	20745	\N
25488	164	3	0	21200	\N
25488	3385	4	0	21210	\N
25435	73	3	0	22538	\N
25435	3040	4	0	22540	\N
25368	140	4	0	24067	\N
25368	3821	5	0	24068	\N
25371	214	3	0	24362	\N
25371	3496	4	0	24363	\N
25475	411	5	0	25274	\N
25475	7318	6	0	25275	\N
25549	86	1	0	26460	\N
25549	2967	2	0	26461	\N
25486	94	3	0	27070	\N
25486	2864	4	0	27071	\N
25375	7300	14	1	28082	\N
25375	16	13	0	29174	\N
25520	54	3	0	30187	\N
25520	3041	4	0	30192	\N
25568	33	6	0	31803	\N
25580	33	0	0	31804	\N
25583	33	3	0	31822	\N
25583	3342	4	0	31823	\N
25541	230	5	0	32096	\N
25541	3389	6	0	32098	\N
25390	453	3	0	32873	\N
25390	2838	4	0	32874	\N
25575	7339	11	1	38957	\N
25461	14	4	0	39313	\N
25461	3498	5	0	39317	\N
25575	306	3	0	39320	\N
25575	14	10	0	39331	\N
25509	18	3	0	40463	\N
25576	18	15	0	40472	\N
25576	4566	16	0	40475	\N
25448	27	5	0	41128	\N
25448	4203	6	0	41133	\N
25388	372	4	0	42712	\N
25446	40	5	0	42728	\N
25446	3999	6	0	42731	\N
25521	40	3	0	42746	\N
25521	372	4	0	42749	\N
25618	40	3	0	42765	\N
25618	372	4	0	42768	\N
25507	75	3	0	45020	\N
25507	3855	4	0	45021	\N
25669	75	3	0	45042	\N
25669	3855	4	0	45044	\N
25621	79	6	0	46281	\N
25621	4253	7	0	46285	\N
25398	113	3	0	48301	\N
25398	3620	4	0	48305	\N
25415	156	1	0	50377	\N
25552	156	3	0	50379	\N
25415	3012	2	0	50380	\N
25552	4594	4	0	50383	\N
25632	156	6	0	50387	\N
25687	156	6	0	50401	\N
25687	6498	7	0	50404	\N
25626	170	10	0	50699	\N
25626	7344	11	0	50702	\N
25537	181	6	0	50930	\N
25537	4256	7	0	50933	\N
25394	200	7	0	51583	\N
25394	5445	8	0	51592	\N
25602	210	6	0	51892	\N
25602	3721	7	0	51895	\N
25595	242	0	0	52172	\N
25651	242	3	0	52173	\N
25651	2839	4	0	52175	\N
25581	260	3	0	52378	\N
25581	3399	4	0	52380	\N
25386	268	3	0	52640	\N
25386	3815	4	0	52645	\N
25532	410	1	0	53064	\N
25464	273	3	0	53071	\N
25532	273	4	0	53072	\N
25464	3638	4	0	53073	\N
25532	5658	5	0	53074	\N
25442	279	3	0	53256	\N
25442	3641	4	0	53260	\N
25644	285	6	0	53604	\N
25644	3903	7	0	53608	\N
25405	324	11	0	54321	\N
25405	7306	12	0	54325	\N
25499	595	3	0	55580	\N
25499	3654	4	0	55583	\N
25647	597	3	0	55897	\N
25647	3656	4	0	55898	\N
25635	852	12	0	57304	\N
25635	7347	13	0	57305	\N
25426	908	10	0	57743	\N
25426	7013	11	0	57749	\N
25500	908	3	0	57753	\N
25500	3591	4	0	57754	\N
25681	2636	10	0	58788	\N
25681	5295	11	0	58796	\N
25569	3004	3	0	59466	\N
25569	5266	4	0	59468	\N
25379	4088	3	0	59839	\N
25379	4506	4	0	59841	\N
25593	4233	2	0	60097	\N
25593	5577	3	0	60099	\N
25628	4787	6	0	60346	\N
25628	5075	7	0	60347	\N
25656	7351	2	0	60759	\N
25649	6450	3	0	60765	\N
25649	6847	4	0	60771	\N
25656	6450	7	0	60774	\N
25656	7352	8	0	60780	\N
25588	6723	12	0	60867	\N
25588	7342	13	0	60868	\N
25477	7319	6	0	60964	\N
25396	7302	8	0	1526	\N
25677	7359	4	0	1839	\N
25419	1636	5	0	3156	\N
25421	1636	3	0	3157	\N
25421	5514	4	0	3160	\N
25419	7307	6	0	3161	\N
25385	367	0	0	3393	\N
25455	367	2	0	3395	\N
25455	3329	3	0	3398	\N
25403	262	7	0	3830	\N
25403	7304	8	0	3832	\N
25383	35	3	0	4248	\N
25436	4178	3	0	7264	\N
25457	4178	4	0	7267	\N
25436	4211	4	0	7268	\N
25457	4468	5	0	7271	\N
25525	4178	3	0	7278	\N
25525	4211	4	0	7279	\N
25590	4178	3	0	7284	\N
25590	4211	4	0	7285	\N
25624	4178	10	0	7287	\N
25624	5897	11	0	7291	\N
25667	4178	3	0	7294	\N
25685	4178	6	0	7295	\N
25667	4211	4	0	7298	\N
25544	4172	6	0	9474	\N
25544	4197	7	0	9478	\N
25459	132	0	0	11393	\N
25542	132	1	0	11419	\N
25542	3116	2	0	11420	\N
25597	132	0	0	11432	\N
25417	6130	3	0	12542	\N
25417	528	6	0	12554	\N
25417	3238	7	0	12555	\N
25607	123	0	0	12816	\N
25469	58	3	0	13628	\N
25469	3665	4	0	13631	\N
25381	3343	4	0	15744	\N
25522	38	1	0	16431	\N
25522	2906	2	0	16432	\N
25377	142	2	0	18569	\N
25377	4418	3	0	18575	\N
25477	7320	6	1	20348	\N
25477	333	1	0	20509	\N
25477	241	5	0	20518	\N
25629	73	5	0	22539	\N
25629	4931	6	0	22541	\N
25614	214	3	0	24378	\N
25614	3496	4	0	24379	\N
25637	7348	4	0	26272	\N
25484	6303	3	0	26343	\N
25484	6304	4	0	26347	\N
25534	202	3	0	31080	\N
25534	4857	4	0	31081	\N
25473	163	1	0	31795	\N
25585	33	0	0	31807	\N
25473	33	5	0	31808	\N
25473	7317	6	0	31810	\N
25411	322	4	0	32363	\N
25411	5447	5	0	32367	\N
25433	453	4	0	32881	\N
25690	2	3	0	35574	\N
25690	3548	4	0	35576	\N
25437	4	0	0	36017	\N
25572	306	3	0	39319	\N
25623	14	6	0	39326	\N
25623	6277	7	0	39329	\N
25572	14	10	0	39330	\N
25572	7335	11	0	39332	\N
25539	18	2	0	40467	\N
25539	1685	3	0	40469	\N
25408	27	3	0	41108	\N
25408	4636	4	0	41109	\N
25384	40	4	0	42696	\N
25384	3381	5	0	42697	\N
25468	40	3	0	42729	\N
25468	372	4	0	42730	\N
25561	40	3	0	42764	\N
25561	372	4	0	42767	\N
25382	56	3	0	44566	\N
25382	4109	4	0	44568	\N
25425	75	3	0	45002	\N
25425	3855	4	0	45003	\N
25642	75	3	0	45041	\N
25642	3855	4	0	45043	\N
25620	79	0	0	46280	\N
25688	79	2	0	46330	\N
25688	616	3	0	46331	\N
25506	88	3	0	47210	\N
25506	3655	4	0	47213	\N
25395	113	7	0	48300	\N
25395	5779	8	0	48306	\N
25414	156	3	0	50376	\N
25414	4594	4	0	50381	\N
25632	6498	7	0	50388	\N
25470	170	3	0	50681	\N
25470	4148	4	0	50686	\N
25508	181	3	0	50929	\N
25508	4184	4	0	50932	\N
25672	242	2	0	52186	\N
25672	3425	3	0	52188	\N
25404	324	7	0	54320	\N
25404	7305	8	0	54324	\N
25540	7322	3	0	55517	\N
25604	595	6	0	55581	\N
25604	4698	7	0	55587	\N
25497	597	3	0	55880	\N
25497	3656	4	0	55882	\N
25657	767	2	0	55899	\N
25657	597	7	0	55926	\N
25657	7353	8	0	55927	\N
25472	908	3	0	57746	\N
25472	3591	4	0	57748	\N
25571	7333	4	0	57846	\N
25463	6678	6	0	58110	\N
25463	7316	7	0	58111	\N
25660	2578	12	0	58643	\N
25660	7356	13	0	58644	\N
25510	3625	3	0	59556	\N
25510	3784	4	0	59562	\N
25513	3628	3	0	59703	\N
25513	3785	4	0	59710	\N
25594	4233	3	0	60098	\N
25594	4425	4	0	60100	\N
25389	5885	3	0	60524	\N
25389	5926	4	0	60530	\N
25609	6723	6	0	60870	\N
25609	7343	7	0	60875	\N
25678	7360	5	0	1840	\N
25548	6048	9	0	2580	\N
25456	367	3	0	3396	\N
25558	367	6	0	3397	\N
25456	3683	4	0	3400	\N
25558	6013	7	0	3402	\N
25407	4178	3	0	7262	\N
25407	4211	4	0	7263	\N
25452	4178	3	0	7266	\N
25452	4211	4	0	7270	\N
25639	4178	3	0	7288	\N
25639	4211	4	0	7290	\N
25434	4172	3	0	9466	\N
25449	4172	7	0	9469	\N
25449	4614	8	0	9470	\N
25538	4172	2	0	9473	\N
25538	4191	3	0	9475	\N
25589	4172	3	0	9479	\N
25589	4275	4	0	9483	\N
25490	391	3	0	10297	\N
25490	3660	4	0	10300	\N
25683	391	10	0	10307	\N
25683	6306	11	0	10308	\N
25460	132	0	0	11394	\N
25543	132	1	0	11407	\N
25598	132	0	0	11427	\N
25416	6130	3	0	12541	\N
25416	528	4	0	12553	\N
25587	123	12	0	12778	\N
25587	7341	13	0	12789	\N
25640	77	3	0	13154	\N
25640	1877	4	0	13157	\N
25674	233	3	0	13877	\N
25674	3704	4	0	13880	\N
25410	173	4	0	14708	\N
25410	3614	5	0	14713	\N
25519	38	3	0	16430	\N
25445	115	3	0	16681	\N
25445	3483	4	0	16683	\N
25696	167	1	0	17742	\N
25698	533	1	0	17746	\N
25696	1444	2	0	17748	\N
25483	167	3	0	17756	\N
25483	4028	4	0	17759	\N
25378	142	3	0	18570	\N
25378	4254	4	0	18579	\N
25665	290	2	0	19090	\N
25665	1909	3	0	19092	\N
25465	62	3	0	19819	\N
25418	198	5	0	20068	\N
25418	5843	6	0	20070	\N
25641	241	3	0	20531	\N
25631	73	6	0	22549	\N
25631	4257	7	0	22552	\N
25402	69	7	0	24778	\N
25565	69	9	0	24779	\N
25565	7328	10	0	24783	\N
25402	7303	8	0	24784	\N
25571	877	3	0	26096	\N
25571	7334	4	0	26106	\N
25501	86	3	0	26454	\N
25659	94	7	0	27072	\N
25659	5005	8	0	27073	\N
25596	16	2	0	29144	\N
25625	16	10	0	29145	\N
25596	388	3	0	29146	\N
25625	5898	11	0	29147	\N
25627	320	10	0	29255	\N
25627	7345	11	0	29260	\N
25517	20	3	0	30463	\N
25601	20	6	0	30464	\N
25517	2844	4	0	30472	\N
25601	5933	7	0	30474	\N
25582	33	0	0	31805	\N
25584	33	0	0	31806	\N
25474	33	5	0	31809	\N
25474	7317	6	0	31811	\N
25615	33	3	0	31829	\N
25615	3342	4	0	31830	\N
25606	2	3	0	35551	\N
25606	3548	4	0	35553	\N
25679	2	6	0	35566	\N
25679	4550	7	0	35569	\N
25654	14	2	0	39344	\N
25654	1421	3	0	39346	\N
25420	4010	6	0	40457	\N
25476	19	1	0	40458	\N
25476	18	5	0	40460	\N
25476	5946	6	0	40462	\N
25682	23	10	0	40845	\N
25682	7362	11	0	40853	\N
25663	27	2	0	41147	\N
25663	645	3	0	41149	\N
25424	40	3	0	42711	\N
25424	372	4	0	42713	\N
25533	41	1	0	42732	\N
25545	40	3	0	42747	\N
25533	40	4	0	42748	\N
25533	3034	5	0	42750	\N
25545	372	4	0	42751	\N
25527	56	3	0	44569	\N
25527	4109	4	0	44571	\N
25387	79	3	0	46279	\N
25387	3652	4	0	46283	\N
25512	119	3	0	48592	\N
25512	2860	4	0	48599	\N
25503	137	3	0	49790	\N
25503	3633	4	0	49791	\N
25564	137	3	0	49802	\N
25564	3633	4	0	49805	\N
25471	170	2	0	50682	\N
25471	2986	3	0	50684	\N
25671	181	3	0	50947	\N
25671	4184	4	0	50949	\N
25496	186	3	0	51277	\N
25496	4294	4	0	51279	\N
25673	242	3	0	52187	\N
25673	2839	4	0	52189	\N
25567	316	9	0	53968	\N
25567	4279	10	0	53979	\N
25392	378	3	0	54910	\N
25392	7301	4	0	54915	\N
25431	435	7	0	55123	\N
25431	7313	8	0	55129	\N
25658	768	2	0	55567	\N
25658	595	7	0	55585	\N
25427	908	1	0	57744	\N
25427	3149	2	0	57747	\N
25658	2171	9	0	57988	\N
25454	2351	3	0	59029	\N
25454	2845	4	0	59030	\N
25447	4233	5	0	60090	\N
25447	7314	6	0	60096	\N
25600	4787	6	0	60344	\N
25600	5075	7	0	60345	\N
25570	7331	4	0	60734	\N
25603	6450	6	0	60764	\N
25603	7269	7	0	60779	\N
25516	3611	4	0	750	\N
25676	7358	3	0	1838	\N
25399	110	6	0	2560	\N
25401	110	8	0	2561	\N
25399	3917	7	0	2562	\N
25401	3710	9	0	2563	\N
25467	262	3	0	3852	\N
25467	4778	4	0	3855	\N
25422	2111	4	0	4098	\N
25422	7308	5	0	4100	\N
25406	4178	11	0	7260	\N
25406	5625	12	0	7261	\N
25485	4178	3	0	7272	\N
25485	4211	4	0	7274	\N
25487	4211	4	0	7275	\N
25535	4178	3	0	7280	\N
25577	4178	3	0	7281	\N
25535	4211	4	0	7282	\N
25577	4211	4	0	7283	\N
25655	4178	3	0	7292	\N
25655	4211	4	0	7293	\N
25505	4172	3	0	9471	\N
25505	4275	4	0	9476	\N
25610	4172	5	0	9480	\N
25612	4172	3	0	9481	\N
25612	4275	4	0	9484	\N
25610	4634	6	0	9485	\N
25646	4197	7	0	9486	\N
25458	132	4	0	11392	\N
25458	7315	5	0	11402	\N
25413	108	1	0	11806	\N
25413	3022	2	0	11807	\N
25560	459	3	0	11959	\N
25560	3178	4	0	11961	\N
25586	123	3	0	12777	\N
25608	123	4	0	12779	\N
25608	4507	5	0	12785	\N
25494	233	6	0	13876	\N
25494	4245	7	0	13883	\N
25689	402	3	0	14047	\N
25689	4077	4	0	14050	\N
25380	258	3	0	14417	\N
25380	4401	4	0	14420	\N
25444	115	2	0	16680	\N
25444	2797	3	0	16682	\N
25451	115	4	0	16695	\N
25451	4844	5	0	16697	\N
25557	115	3	0	16702	\N
25557	3483	4	0	16703	\N
25697	167	4	0	17757	\N
25478	290	3	0	19077	\N
25478	3635	4	0	19078	\N
25666	290	3	0	19091	\N
25666	3635	4	0	19093	\N
25643	7350	124	0	20448	\N
25550	241	3	0	20517	\N
25550	3613	4	0	20519	\N
25643	7349	96	0	20522	\N
25641	3613	4	0	20532	\N
25643	241	123	0	20534	\N
25480	64	3	0	20742	\N
25489	164	1	0	21201	\N
25489	3092	2	0	21208	\N
25555	488	6	0	21531	\N
25555	7325	7	0	21533	\N
25643	1075	124	1	22018	\N
25662	336	3	0	22812	\N
25662	3400	4	0	22814	\N
25429	82	7	0	23762	\N
25429	7310	8	0	23763	\N
25409	140	4	0	24077	\N
25409	3821	5	0	24078	\N
25570	877	3	0	26095	\N
25591	16	2	0	29138	\N
25591	388	3	0	29140	\N
25523	202	7	0	31074	\N
25523	4543	8	0	31075	\N
25684	2	3	0	35567	\N
25684	3548	4	0	35568	\N
25438	4	3	0	36018	\N
25438	3837	4	0	36021	\N
25492	14	6	0	39324	\N
25492	6277	7	0	39328	\N
25653	14	1	0	39343	\N
25653	1926	2	0	39345	\N
25440	3621	4	0	40461	\N
25518	18	3	0	40465	\N
25518	3621	4	0	40466	\N
25562	18	3	0	40468	\N
25562	3621	4	0	40470	\N
25574	127	3	0	40471	\N
25574	18	10	0	40473	\N
25574	4404	11	0	40474	\N
25579	18	3	0	40476	\N
25579	3621	4	0	40479	\N
25412	27	4	0	41127	\N
25462	27	4	0	41129	\N
25412	3717	5	0	41131	\N
25462	3717	5	0	41132	\N
25530	5696	10	0	41134	\N
25664	27	3	0	41148	\N
25664	4636	4	0	41150	\N
25630	40	3	0	42766	\N
25630	372	4	0	42769	\N
25787	40	3	0	42778	\N
25787	372	4	0	42779	\N
25839	40	3	0	42805	\N
25857	40	3	0	42807	\N
25839	372	4	0	42815	\N
25857	372	4	0	42817	\N
25670	56	3	0	44573	\N
25670	4109	4	0	44574	\N
25668	71	3	0	44830	\N
25801	71	3	0	44831	\N
25668	3770	4	0	44832	\N
25801	3770	4	0	44833	\N
25638	75	3	0	45033	\N
25638	3855	4	0	45034	\N
25717	75	3	0	45055	\N
25717	3855	4	0	45057	\N
25820	75	2	0	45079	\N
25820	284	3	0	45080	\N
25633	88	6	0	47212	\N
25633	5263	7	0	47217	\N
25872	88	1	0	47228	\N
25872	2896	2	0	47231	\N
25922	119	2	0	48593	\N
25922	1879	3	0	48598	\N
25710	135	7	0	49520	\N
25842	135	4	0	49522	\N
25842	3696	5	0	49532	\N
25710	4721	8	0	49534	\N
25900	181	3	0	50966	\N
25900	7394	4	0	50969	\N
25852	210	3	0	51911	\N
25852	3539	4	0	51912	\N
25652	242	4	0	52174	\N
25652	3512	5	0	52177	\N
25755	242	3	0	52194	\N
25755	2839	4	0	52195	\N
25648	595	3	0	55582	\N
25648	3654	4	0	55584	\N
25762	595	3	0	55610	\N
25762	3654	4	0	55611	\N
25854	595	3	0	55635	\N
25854	3654	4	0	55640	\N
25844	908	4	0	57768	\N
25844	3488	5	0	57770	\N
25617	2636	3	0	58787	\N
25617	2837	4	0	58793	\N
25920	3625	2	0	59557	\N
25920	4359	3	0	59561	\N
25675	4088	3	0	59855	\N
25675	4506	4	0	59860	\N
25636	6044	3	0	60648	\N
25636	6045	4	0	60657	\N
25766	4204	4	0	317	\N
25634	741	12	0	1375	\N
25634	7346	13	0	1377	\N
25863	251	8	0	1518	\N
25863	7386	9	0	1527	\N
25740	117	5	0	2025	\N
25740	7370	6	0	2026	\N
25895	7392	12	1	2329	\N
25770	367	3	0	3421	\N
25770	3683	4	0	3423	\N
25613	262	3	0	3854	\N
25613	4778	4	0	3857	\N
25705	7225	3	0	4052	\N
25818	35	12	0	4249	\N
25759	189	3	0	4954	\N
25759	3782	4	0	4956	\N
25775	4178	6	0	7297	\N
25775	4250	7	0	7301	\N
25833	4178	4	0	7310	\N
25876	4178	6	0	7312	\N
25884	4178	2	0	7314	\N
25884	4247	3	0	7315	\N
25833	4205	5	0	7317	\N
25876	4250	7	0	7319	\N
25907	4178	7	0	7327	\N
25907	4509	8	0	7329	\N
25909	4178	2	0	7330	\N
25918	4178	2	0	7331	\N
25909	4247	3	0	7332	\N
25918	4247	3	0	7333	\N
25925	4178	6	0	7334	\N
25925	4358	7	0	7335	\N
25895	7391	12	0	8147	\N
25895	7390	11	0	9505	\N
25904	4172	2	0	9507	\N
25904	4191	3	0	9508	\N
25800	391	2	0	10331	\N
25886	391	2	0	10352	\N
25886	1381	3	0	10353	\N
25746	132	4	0	11435	\N
25746	7371	5	0	11436	\N
25768	132	1	0	11447	\N
25768	3116	2	0	11448	\N
25753	108	3	0	11822	\N
25753	4171	4	0	11824	\N
25744	234	1	0	13869	\N
25744	233	4	0	13879	\N
25744	2987	5	0	13881	\N
25897	235	2	0	15771	\N
25645	44	6	0	16055	\N
25645	5989	7	0	16056	\N
25777	212	5	0	17111	\N
25777	7378	6	0	17115	\N
25835	30	8	0	18185	\N
25835	7385	9	0	18186	\N
25722	3208	6	0	18388	\N
25722	7368	7	0	18393	\N
25816	241	6	0	20548	\N
25816	6412	7	0	20552	\N
25893	82	2	0	23766	\N
25893	3401	3	0	23768	\N
25792	4041	5	0	24794	\N
25692	224	10	0	25521	\N
25692	7363	11	0	25526	\N
25661	86	6	0	26465	\N
25661	7357	7	0	26466	\N
25811	86	3	0	26469	\N
25811	3746	4	0	26474	\N
25694	244	3	0	27298	\N
25694	4075	4	0	27302	\N
25719	42	3	0	27603	\N
25891	42	2	0	27605	\N
25891	3310	3	0	27607	\N
25686	16	6	0	29150	\N
25686	3369	7	0	29151	\N
25868	16	3	0	29163	\N
25868	3634	4	0	29167	\N
25735	151	6	0	30708	\N
25879	151	6	0	30709	\N
25735	3588	7	0	30710	\N
25879	7389	7	0	30711	\N
25808	202	4	0	31088	\N
25808	3673	5	0	31089	\N
25619	33	7	0	31836	\N
25619	5284	8	0	31837	\N
25691	4182	7	0	32108	\N
25622	14	2	0	39325	\N
25622	1421	3	0	39327	\N
25650	18	4	0	40477	\N
25650	2302	5	0	40481	\N
25911	18	2	0	40482	\N
25911	1685	3	0	40483	\N
25680	23	6	0	40844	\N
25680	7361	7	0	40852	\N
25853	40	3	0	42806	\N
25862	40	8	0	42808	\N
25885	40	2	0	42809	\N
25919	40	2	0	42810	\N
25923	40	2	0	42811	\N
25885	282	3	0	42812	\N
25919	282	3	0	42813	\N
25923	282	3	0	42814	\N
25853	372	4	0	42816	\N
25862	3503	9	0	42818	\N
25958	56	4	0	44581	\N
25958	3556	5	0	44582	\N
25723	75	6	0	45056	\N
25723	4694	7	0	45058	\N
25736	75	6	0	45077	\N
25736	4694	7	0	45082	\N
25781	79	6	0	46433	\N
25781	4253	7	0	46434	\N
25912	102	2	0	47990	\N
25914	102	1	0	47991	\N
25914	103	2	0	47993	\N
25912	3053	3	0	47994	\N
25749	125	2	0	49317	\N
25749	3297	3	0	49319	\N
25776	125	6	0	49326	\N
25776	6951	7	0	49330	\N
25711	137	7	0	49803	\N
25711	4722	8	0	49807	\N
25707	181	3	0	50948	\N
25707	4184	4	0	50950	\N
25827	181	3	0	50959	\N
25827	4184	4	0	50960	\N
25928	260	4	0	52379	\N
25928	7396	5	0	52381	\N
25695	7364	3	0	55352	\N
25695	3934	4	0	55353	\N
25796	595	2	0	55634	\N
25796	3285	3	0	55638	\N
25941	7397	7	0	57017	\N
25941	841	10	0	57037	\N
25941	7190	11	0	57038	\N
25769	852	3	0	57337	\N
25769	3612	4	0	57338	\N
25729	2647	9	0	59435	\N
25729	7369	10	0	59436	\N
25921	3628	2	0	59704	\N
25921	4360	3	0	59707	\N
25745	7374	1	0	59844	\N
25745	4088	4	0	59859	\N
25745	7375	5	0	59861	\N
25953	4233	2	0	60101	\N
25953	5577	3	0	60102	\N
25856	6450	3	0	60768	\N
25856	6847	4	0	60773	\N
25874	6450	6	0	60782	\N
25874	7269	7	0	60809	\N
25910	110	2	0	2601	\N
25771	367	9	0	3422	\N
25771	3571	10	0	3425	\N
25784	7225	6	0	4053	\N
25784	7379	7	0	4059	\N
25848	35	2	0	4250	\N
25945	365	5	0	4599	\N
25945	7402	6	0	4611	\N
25726	189	6	0	4946	\N
25726	3713	7	0	4947	\N
25760	189	3	0	4955	\N
25760	3782	4	0	4957	\N
25869	4178	3	0	7311	\N
25878	4178	6	0	7313	\N
25869	4211	4	0	7316	\N
25878	4358	7	0	7320	\N
25890	4178	2	0	7322	\N
25890	4247	3	0	7323	\N
25899	4178	3	0	7326	\N
25899	4441	4	0	7328	\N
25982	4178	2	0	7342	\N
25982	4247	3	0	7343	\N
25709	4172	7	0	9487	\N
25709	4614	8	0	9488	\N
25747	4172	5	0	9491	\N
25845	4172	2	0	9500	\N
25845	4191	3	0	9501	\N
25860	4172	8	0	9506	\N
25860	4500	9	0	9509	\N
25963	4172	5	0	9513	\N
25963	4415	6	0	9518	\N
25704	391	4	0	10313	\N
25704	3913	5	0	10314	\N
25850	391	10	0	10343	\N
25850	6306	11	0	10344	\N
25896	391	11	0	10359	\N
25896	5330	12	0	10360	\N
25765	3116	2	0	11462	\N
25718	300	3	0	12156	\N
25718	3747	4	0	12157	\N
25967	300	4	0	12164	\N
25967	6350	5	0	12165	\N
25767	528	3	0	12575	\N
25767	4262	4	0	12577	\N
25788	402	3	0	14060	\N
25788	4077	4	0	14064	\N
25883	258	2	0	14418	\N
25883	3275	3	0	14419	\N
25905	258	2	0	14437	\N
25786	192	3	0	15308	\N
25786	3790	4	0	15312	\N
25716	44	3	0	16074	\N
25716	3631	4	0	16075	\N
25832	115	4	0	16713	\N
25832	4844	5	0	16714	\N
25960	167	2	0	17767	\N
25960	3322	3	0	17768	\N
25758	164	3	0	21203	\N
25758	3385	4	0	21211	\N
25933	67	4	0	22171	\N
25933	5001	5	0	22174	\N
25867	3040	4	0	22562	\N
25877	73	6	0	22567	\N
25877	4257	7	0	22568	\N
25917	336	2	0	22822	\N
25917	3332	3	0	22824	\N
25819	930	12	0	23921	\N
25819	7383	13	0	23925	\N
25693	6303	3	0	26348	\N
25693	6304	4	0	26351	\N
25974	94	2	0	27081	\N
25974	2794	3	0	27082	\N
25702	16	4	0	29155	\N
25836	3634	4	0	29157	\N
25702	3546	5	0	29158	\N
25951	360	4	0	31431	\N
25951	4330	5	0	31435	\N
25734	33	6	0	31846	\N
25734	7330	7	0	31850	\N
25834	2	4	0	35584	\N
25834	3510	5	0	35587	\N
25864	2	3	0	35595	\N
25864	3548	4	0	35596	\N
25977	2	2	0	35609	\N
25977	2789	3	0	35610	\N
25892	1785	3	0	39356	\N
25930	18	2	0	40484	\N
25930	1685	3	0	40485	\N
25979	18	2	0	40487	\N
25979	1685	3	0	40488	\N
25756	23	3	0	40846	\N
25756	3497	4	0	40850	\N
25931	40	5	0	42829	\N
25931	5806	6	0	42830	\N
25937	40	1	0	42837	\N
25937	41	2	0	42838	\N
25889	56	4	0	44579	\N
25889	3556	5	0	44580	\N
25728	75	3	0	45069	\N
25728	3855	4	0	45070	\N
25943	75	1	0	45096	\N
25943	76	2	0	45097	\N
25871	88	3	0	47227	\N
25871	3655	4	0	47232	\N
25973	100	2	0	47618	\N
25973	633	3	0	47619	\N
25731	135	3	0	49521	\N
25731	3630	4	0	49531	\N
25902	156	2	0	50402	\N
25902	4485	3	0	50403	\N
25866	170	6	0	50700	\N
25866	7388	7	0	50701	\N
25916	186	4	0	51278	\N
25916	6866	5	0	51280	\N
25882	200	2	0	51586	\N
25882	276	3	0	51588	\N
25824	242	9	0	52201	\N
25824	6434	10	0	52202	\N
25708	279	3	0	53257	\N
25708	3641	4	0	53261	\N
25873	595	6	0	55636	\N
25873	4698	7	0	55641	\N
25763	597	3	0	55910	\N
25798	597	2	0	55911	\N
25855	597	3	0	55912	\N
25798	3286	3	0	55919	\N
25763	3656	4	0	55921	\N
25855	3656	4	0	55922	\N
25938	7397	7	0	57016	\N
25938	7398	8	0	57026	\N
25806	908	6	0	57757	\N
25806	3555	7	0	57758	\N
25938	7372	8	0	57848	\N
25939	7399	7	0	57969	\N
25942	7399	7	0	57970	\N
25939	1225	10	0	57975	\N
25942	1225	10	0	57976	\N
25942	7401	11	0	57977	\N
25932	1470	4	0	58295	\N
25932	2798	5	0	58296	\N
25880	2782	2	0	59363	\N
25880	2784	3	0	59364	\N
25898	2782	3	0	59369	\N
25898	7393	4	0	59370	\N
25821	4787	7	0	60348	\N
25821	7384	8	0	60349	\N
25939	6692	11	0	60570	\N
25983	6044	2	0	60649	\N
25983	6188	3	0	60654	\N
25778	6765	3	0	60922	\N
25778	6884	4	0	60923	\N
25961	251	2	0	1519	\N
25969	228	4	0	2841	\N
25969	4800	5	0	2851	\N
25715	1858	9	0	3032	\N
25715	7367	10	0	3037	\N
25908	2349	7	0	3241	\N
25908	7395	8	0	3242	\N
25713	367	9	0	3420	\N
25713	3571	10	0	3424	\N
25849	262	6	0	3870	\N
25849	4248	7	0	3871	\N
25949	365	0	0	4601	\N
25773	7376	3	0	5180	\N
25780	4178	3	0	7302	\N
25780	4211	4	0	7303	\N
25829	4178	7	0	7307	\N
25829	4396	8	0	7308	\N
25894	4247	2	0	7318	\N
25894	4178	3	0	7324	\N
25957	4172	4	0	9512	\N
25957	4252	5	0	9517	\N
25804	391	3	0	10332	\N
25804	3660	4	0	10334	\N
25978	391	4	0	10384	\N
25978	3352	5	0	10385	\N
25838	3729	4	0	11398	\N
25742	132	4	0	11443	\N
25742	7371	5	0	11444	\N
25926	173	2	0	14709	\N
25926	2102	3	0	14711	\N
25720	235	3	0	15755	\N
25720	3343	4	0	15756	\N
25733	44	3	0	16091	\N
25733	3631	4	0	16092	\N
25809	44	4	0	16111	\N
25809	3486	5	0	16114	\N
25697	7365	5	1	17947	\N
25948	765	4	0	18416	\N
25948	7404	5	0	18417	\N
25946	7403	6	0	18418	\N
25738	290	5	0	19100	\N
25934	290	2	0	19101	\N
25934	1909	3	0	19102	\N
25738	6115	6	0	19103	\N
25706	208	3	0	19279	\N
25783	208	6	0	19280	\N
25706	4490	4	0	19292	\N
25783	5118	7	0	19295	\N
25887	488	4	0	21543	\N
25956	67	3	0	22172	\N
25751	73	4	0	22550	\N
25751	2284	5	0	22551	\N
25952	73	4	0	22575	\N
25952	2827	5	0	22576	\N
25795	7381	14	0	24364	\N
25795	214	18	0	24380	\N
25795	4991	19	0	24381	\N
25831	214	3	0	24396	\N
25831	3496	4	0	24398	\N
25986	69	2	0	24792	\N
25959	206	4	0	25808	\N
25813	94	3	0	27076	\N
25813	2864	4	0	27077	\N
25954	16	3	0	29164	\N
25954	1045	4	0	29168	\N
25975	16	1	0	29172	\N
25975	1087	2	0	29173	\N
25826	449	3	0	29858	\N
25826	4760	4	0	29861	\N
25929	20	2	0	30466	\N
25929	369	3	0	30469	\N
25699	453	3	0	32893	\N
25701	453	2	0	32895	\N
25699	2838	4	0	32897	\N
25764	2	3	0	35575	\N
25764	3548	4	0	35577	\N
25807	2	6	0	35582	\N
25840	2	4	0	35585	\N
25840	3510	5	0	35588	\N
25807	4825	7	0	35589	\N
25790	14	4	0	39353	\N
25802	14	3	0	39354	\N
25802	4272	4	0	39357	\N
25790	3498	5	0	39358	\N
25725	18	3	0	40478	\N
25859	23	1	0	40848	\N
25859	1089	2	0	40849	\N
25847	27	2	0	41161	\N
25847	645	3	0	41163	\N
25830	40	3	0	42795	\N
25830	372	4	0	42796	\N
26023	40	2	0	42869	\N
26023	282	3	0	42870	\N
25743	1088	1	0	44575	\N
25743	7373	2	0	44576	\N
25739	56	3	0	44577	\N
25739	4102	4	0	44578	\N
25741	75	5	0	45078	\N
25741	4034	6	0	45081	\N
25990	75	2	0	45109	\N
25990	284	3	0	45114	\N
25752	79	3	0	46388	\N
25752	3652	4	0	46389	\N
25815	79	6	0	46481	\N
25815	4253	7	0	46487	\N
25964	100	5	0	47617	\N
25964	7057	6	0	47620	\N
25915	113	4	0	48312	\N
25915	5924	5	0	48318	\N
25980	121	2	0	48951	\N
25980	2498	3	0	48952	\N
25732	137	3	0	49804	\N
25732	3633	4	0	49806	\N
25841	137	4	0	49819	\N
26004	137	1	0	49820	\N
26004	138	2	0	49821	\N
25841	3697	5	0	49822	\N
25865	7387	79	0	50688	\N
25865	170	126	0	50703	\N
25865	7344	127	0	50704	\N
25985	186	6	0	51290	\N
25985	7407	7	0	51291	\N
25730	200	3	0	51584	\N
25812	200	3	0	51585	\N
25730	3338	4	0	51589	\N
25812	3338	4	0	51590	\N
25785	279	6	0	53258	\N
25785	5117	7	0	53262	\N
25927	435	2	0	55124	\N
25927	3413	3	0	55126	\N
25972	483	2	0	55519	\N
25972	7322	3	0	55520	\N
25875	597	6	0	55913	\N
25875	4697	7	0	55928	\N
25814	908	3	0	57763	\N
25814	3591	4	0	57764	\N
25843	908	4	0	57767	\N
25843	3488	5	0	57769	\N
25743	7372	2	0	57847	\N
26028	1470	2	0	58301	\N
26028	3368	3	0	58305	\N
25803	2636	3	0	58789	\N
25803	2837	4	0	58794	\N
25761	6450	3	0	60766	\N
25797	6450	2	0	60767	\N
25797	6825	3	0	60769	\N
25761	6847	4	0	60772	\N
25714	7366	10	0	751	\N
25748	5002	6	0	762	\N
25837	110	3	0	2605	\N
25881	110	2	0	2606	\N
25881	626	3	0	2607	\N
25837	2995	4	0	2608	\N
25906	367	7	0	3431	\N
25906	7051	8	0	3436	\N
25727	4178	3	0	7296	\N
25727	4211	4	0	7299	\N
25799	4178	2	0	7304	\N
25799	4247	3	0	7305	\N
25823	4178	9	0	7306	\N
25888	4178	4	0	7321	\N
25888	4331	5	0	7325	\N
25968	4178	4	0	7337	\N
25968	4205	5	0	7340	\N
25724	4172	3	0	9489	\N
25724	4275	4	0	9490	\N
25750	4172	4	0	9492	\N
25793	4172	4	0	9493	\N
25750	4219	5	0	9494	\N
25793	4219	5	0	9495	\N
25810	4172	3	0	9497	\N
25810	4275	4	0	9498	\N
25828	4614	8	0	9502	\N
25851	4172	6	0	9503	\N
25851	4197	7	0	9504	\N
25913	4172	2	0	9510	\N
25913	4191	3	0	9511	\N
25970	4172	2	0	9514	\N
25970	4191	3	0	9516	\N
26030	4172	2	0	9524	\N
26030	4191	3	0	9525	\N
25721	391	3	0	10321	\N
25721	3660	4	0	10322	\N
25870	391	3	0	10351	\N
25712	108	6	0	11821	\N
25712	6978	7	0	11826	\N
26014	7408	85	0	11949	\N
26014	459	126	0	11963	\N
26014	7409	127	0	11964	\N
25789	402	4	0	14061	\N
25791	402	2	0	14062	\N
25791	3244	3	0	14063	\N
25789	4731	5	0	14065	\N
25779	212	3	0	17112	\N
25779	3639	4	0	17118	\N
25698	167	4	0	17758	\N
25703	30	2	0	18174	\N
25703	2980	3	0	18179	\N
25901	60	2	0	19483	\N
25901	4544	3	0	19486	\N
25757	164	6	0	21202	\N
25822	164	7	0	21204	\N
25757	3583	7	0	21213	\N
25822	5711	8	0	21214	\N
25995	488	4	0	21544	\N
25995	5021	5	0	21547	\N
25956	7405	4	0	22173	\N
25861	336	8	0	22813	\N
26012	69	4	0	24800	\N
26012	4041	5	0	24804	\N
25782	411	6	0	25273	\N
25782	5252	7	0	25278	\N
25794	7380	14	0	25279	\N
25794	411	18	0	25285	\N
25794	7318	19	0	25286	\N
25805	206	3	0	25807	\N
25805	4584	4	0	25810	\N
25774	94	3	0	27074	\N
25774	2864	4	0	27075	\N
25817	94	0	0	27078	\N
25924	2794	3	0	27080	\N
25754	42	3	0	27604	\N
25754	3645	4	0	27609	\N
25903	16	0	0	29139	\N
25846	16	2	0	29162	\N
25846	388	3	0	29166	\N
25772	20	3	0	30465	\N
25772	2844	4	0	30473	\N
26021	151	2	0	30730	\N
26021	2854	3	0	30731	\N
25700	453	3	0	32894	\N
25700	2838	4	0	32898	\N
25825	3548	4	0	35586	\N
25737	4	5	0	36019	\N
25737	4387	6	0	36023	\N
25858	23	3	0	40847	\N
25858	3497	4	0	40851	\N
25989	56	2	0	44583	\N
25989	2795	3	0	44584	\N
25936	75	6	0	45088	\N
25936	3361	7	0	45089	\N
26169	75	3	0	45111	\N
26169	3139	4	0	45112	\N
26164	100	6	0	47629	\N
26164	7216	7	0	47630	\N
25935	102	2	0	47992	\N
25935	3053	3	0	47995	\N
26003	113	4	0	48325	\N
26182	119	3	0	48594	\N
26182	2860	4	0	48600	\N
26152	121	6	0	48966	\N
26152	4686	7	0	48971	\N
26190	7449	117	0	49323	\N
26190	125	126	0	49332	\N
26190	7450	127	0	49333	\N
26225	7455	117	0	49334	\N
26009	156	3	0	50407	\N
26009	4594	4	0	50408	\N
26157	186	5	0	51307	\N
26157	4005	6	0	51309	\N
26172	210	0	0	51932	\N
26220	210	4	0	51933	\N
26220	3536	5	0	51935	\N
25976	260	2	0	52392	\N
25976	3184	3	0	52393	\N
26051	285	10	0	53605	\N
26051	7415	11	0	53609	\N
26075	595	2	0	55637	\N
26075	3285	3	0	55639	\N
26195	793	6	0	56659	\N
26195	3719	7	0	56660	\N
25940	7400	7	0	57771	\N
25940	908	10	0	57774	\N
25940	3025	11	0	57775	\N
25996	908	0	0	57776	\N
26119	2636	4	0	58791	\N
26119	7436	5	0	58795	\N
26184	3628	3	0	59705	\N
26184	3785	4	0	59711	\N
25992	4233	2	0	60104	\N
25992	5577	3	0	60108	\N
26166	4787	3	0	60350	\N
26166	4788	4	0	60353	\N
26174	6044	14	0	60650	\N
26174	7444	16	0	60664	\N
26161	12	6	0	324	\N
26174	7443	15	0	608	\N
26060	7419	58	0	763	\N
26060	424	64	0	777	\N
26060	4000	65	0	778	\N
26087	251	2	0	1520	\N
26087	1851	3	0	1523	\N
26070	117	6	0	2034	\N
26070	3325	7	0	2035	\N
26143	117	2	0	2050	\N
26143	1257	3	0	2053	\N
26016	228	3	0	2842	\N
26016	3186	4	0	2849	\N
25947	365	0	0	4600	\N
25950	365	0	0	4602	\N
25955	4178	3	0	7336	\N
25981	4178	2	0	7338	\N
25981	4247	3	0	7339	\N
25955	4441	4	0	7341	\N
25987	4178	2	0	7344	\N
25987	4247	3	0	7345	\N
26079	4178	2	0	7348	\N
26079	4247	3	0	7349	\N
26094	4178	2	0	7352	\N
26094	4247	3	0	7353	\N
26106	4331	5	0	7357	\N
26204	4178	4	0	7383	\N
26212	4178	3	0	7384	\N
26212	4211	4	0	7385	\N
26204	4205	5	0	7386	\N
26006	4172	7	0	9515	\N
26006	4614	8	0	9519	\N
26040	4172	2	0	9526	\N
26040	4191	3	0	9527	\N
26159	4172	8	0	9537	\N
26159	5928	9	0	9541	\N
26205	4172	13	0	9542	\N
26215	4172	4	0	9546	\N
26215	4219	5	0	9547	\N
26222	4172	3	0	9548	\N
26222	4275	4	0	9549	\N
25971	391	2	0	10373	\N
25971	1381	3	0	10374	\N
26140	391	2	0	10409	\N
26140	1381	3	0	10412	\N
26053	528	10	0	12576	\N
26053	7416	11	0	12578	\N
26056	77	2	0	13155	\N
26056	3853	3	0	13156	\N
25999	5113	6	0	15786	\N
26111	44	2	0	16112	\N
26111	1910	3	0	16113	\N
26018	38	3	0	16442	\N
26138	38	2	0	16444	\N
26188	38	4	0	16445	\N
26138	4009	3	0	16448	\N
26018	3457	4	0	16449	\N
26188	5656	5	0	16450	\N
26129	7440	3	1	16605	\N
26129	115	2	0	16728	\N
26135	290	2	0	19117	\N
26129	6025	3	0	21728	\N
26174	6025	15	1	21733	\N
26174	7445	16	1	21943	\N
25994	73	4	0	22585	\N
25994	2827	5	0	22586	\N
26001	264	7	0	23603	\N
26001	6187	8	0	23605	\N
26115	411	2	0	25283	\N
26115	3370	3	0	25284	\N
26025	224	2	0	25534	\N
26025	3150	3	0	25539	\N
25966	206	5	0	25809	\N
26063	94	4	0	27083	\N
26063	6644	5	0	27089	\N
26067	320	6	0	29256	\N
26067	7424	7	0	29259	\N
25962	96	5	0	29543	\N
25962	5504	6	0	29546	\N
26027	33	0	0	31847	\N
26032	33	0	0	31848	\N
26150	33	6	0	31864	\N
26150	7330	7	0	31870	\N
25991	230	2	0	32112	\N
25991	3307	3	0	32113	\N
26096	453	126	0	32909	\N
26096	7432	127	0	32910	\N
26109	14	2	0	39372	\N
26109	1785	3	0	39375	\N
25965	18	5	0	40486	\N
25965	3550	6	0	40489	\N
26020	18	3	0	40490	\N
26020	3621	4	0	40491	\N
25997	23	0	0	40858	\N
26217	23	4	0	40869	\N
26217	3189	5	0	40871	\N
26121	40	2	0	41425	\N
26179	40	2	0	41440	\N
26179	282	3	0	41442	\N
25993	40	2	0	42855	\N
25993	282	3	0	42856	\N
26216	56	4	0	44587	\N
26216	3127	5	0	44590	\N
26223	79	7	0	46483	\N
26223	5706	8	0	46488	\N
26209	100	4	0	47640	\N
26209	3776	5	0	47644	\N
26285	102	2	0	48041	\N
26285	3053	3	0	48043	\N
26000	113	7	0	48313	\N
26002	113	9	0	48314	\N
26002	5363	10	0	48317	\N
26000	5779	8	0	48319	\N
26088	121	2	0	48958	\N
26088	2498	3	0	48959	\N
26225	125	126	0	49345	\N
26225	7456	127	0	49346	\N
26005	135	2	0	49523	\N
26005	2722	3	0	49527	\N
26160	170	8	0	50709	\N
26160	3904	9	0	50710	\N
26123	186	2	0	51298	\N
26123	1850	3	0	51300	\N
26010	200	3	0	51587	\N
26010	3338	4	0	51591	\N
26276	260	4	0	52396	\N
26276	3728	5	0	52400	\N
26103	273	4	0	53079	\N
26103	3390	5	0	53082	\N
26052	285	2	0	53606	\N
26052	3036	3	0	53607	\N
25988	316	2	0	53969	\N
26189	316	4	0	53971	\N
25988	1900	3	0	53974	\N
26189	5437	5	0	53977	\N
26280	7468	76	0	55130	\N
26280	435	126	0	55135	\N
26280	7469	127	0	55136	\N
26258	793	3	0	56669	\N
26258	2644	4	0	56673	\N
26026	2578	2	0	58645	\N
26026	4325	3	0	58646	\N
26114	2578	2	0	58647	\N
26114	4325	3	0	58648	\N
26175	6044	14	0	60651	\N
26175	7446	15	0	60661	\N
26110	6765	2	0	60924	\N
26110	6841	3	0	60928	\N
26228	4204	4	0	336	\N
26243	12	18	0	347	\N
26243	7460	19	0	348	\N
26250	12	4	0	355	\N
26059	424	6	0	775	\N
26059	7418	7	0	776	\N
26192	424	5	0	788	\N
26192	7451	6	0	789	\N
26288	266	7	0	1238	\N
26288	7471	8	0	1240	\N
26238	5570	3	0	1734	\N
26238	5571	4	0	1736	\N
26069	117	8	0	2033	\N
26241	365	0	0	4608	\N
26086	1572	2	0	5209	\N
26086	3453	3	0	5210	\N
26117	4178	4	0	7360	\N
26117	4331	5	0	7361	\N
26120	4178	2	0	7362	\N
26120	4247	3	0	7364	\N
26132	4178	2	0	7369	\N
26132	4247	3	0	7371	\N
26255	4178	3	0	7398	\N
26265	4178	7	0	7399	\N
26255	4211	4	0	7401	\N
26125	4172	2	0	9529	\N
26125	4191	3	0	9531	\N
26211	4172	3	0	9544	\N
26211	4275	4	0	9545	\N
26242	4172	3	0	9550	\N
26242	4275	4	0	9551	\N
26007	391	3	0	10392	\N
26007	3660	4	0	10393	\N
26201	391	2	0	10410	\N
26201	2966	3	0	10411	\N
26139	132	2	0	11396	\N
26139	2756	3	0	11397	\N
26180	7447	6	0	14448	\N
26283	173	7	0	14710	\N
26283	4982	8	0	14714	\N
25998	235	0	0	15784	\N
26151	235	6	0	15791	\N
26151	3622	7	0	15792	\N
26017	38	0	0	16441	\N
26019	38	1	0	16443	\N
26019	2906	2	0	16446	\N
26197	115	5	0	16729	\N
26197	7454	6	0	16731	\N
26107	212	58	0	17136	\N
26061	167	11	0	17779	\N
26061	7420	12	0	17780	\N
26078	167	2	0	17784	\N
26078	3322	3	0	17787	\N
26206	198	3	0	20082	\N
26206	4263	4	0	20083	\N
26213	164	3	0	21207	\N
26213	3385	4	0	21212	\N
26141	488	2	0	21561	\N
26141	2791	3	0	21562	\N
26156	149	5	0	23146	\N
26156	7442	6	0	23147	\N
26234	7459	8	0	23618	\N
26226	140	24	0	24087	\N
26226	7457	25	0	24088	\N
25986	3350	3	0	24793	\N
26168	411	3	0	25305	\N
26168	3596	4	0	25306	\N
26046	42	4	0	27617	\N
26046	2821	5	0	27618	\N
26100	320	2	0	29257	\N
26100	1937	3	0	29258	\N
26136	151	2	0	30738	\N
26144	151	2	0	30739	\N
26144	2854	3	0	30742	\N
26165	360	3	0	31432	\N
26165	3602	4	0	31434	\N
26034	33	0	0	31849	\N
26029	33	2	0	31862	\N
26029	2822	3	0	31867	\N
26095	453	2	0	32907	\N
26095	3366	3	0	32908	\N
26245	453	3	0	32917	\N
26245	2838	4	0	32919	\N
26146	6	3	0	36348	\N
26146	4823	4	0	36349	\N
26037	2291	5	0	39366	\N
26287	14	2	0	39390	\N
26287	1785	3	0	39391	\N
26173	18	0	0	40497	\N
26260	18	3	0	40498	\N
26260	3621	4	0	40500	\N
26232	27	3	0	41162	\N
26232	4636	4	0	41164	\N
26263	27	7	0	41180	\N
26263	5681	8	0	41189	\N
26072	40	4	0	41415	\N
26072	2796	5	0	41420	\N
26218	4255	7	0	41448	\N
26044	40	2	0	42887	\N
26044	282	3	0	42888	\N
26254	56	3	0	44588	\N
26254	4109	4	0	44589	\N
26066	75	9	0	45110	\N
26066	7423	10	0	45115	\N
26178	75	7	0	45130	\N
26178	2859	8	0	45149	\N
26214	79	4	0	46482	\N
26214	3678	5	0	46486	\N
26207	100	4	0	47639	\N
26207	3776	5	0	47643	\N
26003	5924	5	0	48327	\N
26089	156	2	0	50409	\N
26089	4485	3	0	50411	\N
26199	170	3	0	50717	\N
26199	4148	4	0	50718	\N
26108	186	2	0	51297	\N
26108	1850	3	0	51299	\N
26031	260	2	0	52395	\N
26031	3184	3	0	52398	\N
26081	473	1	0	53265	\N
26081	279	3	0	53281	\N
26081	3110	4	0	53282	\N
26282	285	7	0	53614	\N
26282	7470	8	0	53622	\N
26022	316	2	0	53970	\N
26022	1900	3	0	53975	\N
26011	841	3	0	57029	\N
26011	3604	4	0	57034	\N
26300	2578	5	0	58649	\N
26149	2351	30	0	59034	\N
26149	7441	31	0	59036	\N
26185	2351	82	0	59043	\N
26185	7448	83	0	59044	\N
26171	2815	0	0	59445	\N
26181	3625	3	0	59558	\N
26181	3784	4	0	59563	\N
26077	6450	2	0	60783	\N
26077	6825	3	0	60798	\N
26047	7413	3	0	60969	\N
26124	7412	2	0	60972	\N
26124	7430	3	0	60975	\N
26244	7461	3	0	61203	\N
26013	4043	5	0	318	\N
26289	12	3	0	365	\N
26289	4204	4	0	366	\N
26193	7452	120	0	779	\N
26193	424	126	0	790	\N
26193	7453	127	0	791	\N
26261	251	6	0	1542	\N
26261	5272	7	0	1543	\N
26227	365	24	0	4603	\N
26236	365	3	0	4605	\N
26240	365	0	0	4607	\N
26236	3839	4	0	4610	\N
26227	7458	25	0	4612	\N
26062	4331	5	0	7347	\N
26093	4178	2	0	7350	\N
26093	4247	3	0	7351	\N
26098	4178	2	0	7354	\N
26098	4247	3	0	7355	\N
26126	4450	1	0	7366	\N
26126	4178	3	0	7367	\N
26126	4460	4	0	7368	\N
26221	4178	3	0	7387	\N
26224	4178	7	0	7388	\N
26221	4211	4	0	7389	\N
26224	4396	8	0	7390	\N
26229	4211	4	0	7392	\N
26237	4178	3	0	7397	\N
26237	4211	4	0	7400	\N
26297	4178	2	0	7414	\N
26297	4247	3	0	7415	\N
26008	4172	6	0	9520	\N
26008	4197	7	0	9521	\N
26024	4172	2	0	9522	\N
26024	4191	3	0	9523	\N
26142	4172	2	0	9532	\N
26142	4191	3	0	9533	\N
26147	4172	6	0	9534	\N
26251	4172	13	0	9552	\N
26251	5454	14	0	9553	\N
26274	4172	4	0	9554	\N
26274	4219	5	0	9555	\N
26118	391	4	0	10398	\N
26118	3352	5	0	10399	\N
26194	132	6	0	11409	\N
26194	4690	7	0	11415	\N
26015	459	3	0	11960	\N
26015	3178	4	0	11962	\N
26130	459	2	0	11970	\N
26130	3860	3	0	11971	\N
26128	2797	3	0	16730	\N
26219	115	4	0	16739	\N
26219	4844	5	0	16740	\N
26101	6173	4	0	18226	\N
26101	7433	5	0	18228	\N
26042	142	2	0	18571	\N
26292	142	2	0	18572	\N
26042	4418	3	0	18576	\N
26292	4418	3	0	18577	\N
26083	209	1	0	19270	\N
26083	208	3	0	19287	\N
26083	7429	4	0	19288	\N
26176	5416	8	0	20071	\N
26050	333	1	0	20533	\N
26050	241	11	0	20550	\N
26050	2586	12	0	20553	\N
26084	64	8	0	20743	\N
26084	6833	9	0	20746	\N
26055	164	0	0	21205	\N
26057	164	2	0	21206	\N
26057	1124	3	0	21209	\N
26137	411	4	0	25296	\N
26137	2806	5	0	25297	\N
26279	411	3	0	25311	\N
26210	224	4	0	25536	\N
26210	3806	5	0	25541	\N
26286	42	2	0	27625	\N
26286	3310	3	0	27626	\N
26038	16	4	0	29165	\N
26038	2575	5	0	29169	\N
26187	54	4	0	30188	\N
26198	54	5	0	30189	\N
26187	3685	5	0	30193	\N
26198	3787	6	0	30194	\N
26105	20	2	0	30468	\N
26105	369	3	0	30471	\N
26091	2	2	0	34895	\N
26091	2789	3	0	34897	\N
26133	2	2	0	34903	\N
26133	2789	3	0	34904	\N
26154	2	6	0	34913	\N
26269	2	3	0	34915	\N
26269	3548	4	0	34916	\N
26271	2789	2	0	34917	\N
26154	4825	7	0	34918	\N
26271	2	5	0	34928	\N
26244	7462	3	0	39371	\N
26163	18	3	0	40496	\N
26074	40	2	0	41416	\N
26074	282	3	0	41418	\N
26284	40	7	0	41463	\N
26296	40	11	0	41464	\N
26284	4488	8	0	41469	\N
26296	7473	12	0	41470	\N
26048	56	2	0	44585	\N
26048	169	3	0	44586	\N
26249	79	3	0	46484	\N
26249	3652	4	0	46485	\N
26036	102	2	0	48009	\N
26036	3053	3	0	48010	\N
26186	102	4	0	48019	\N
26186	3572	5	0	48020	\N
26248	102	3	0	48033	\N
26248	3597	4	0	48034	\N
26264	200	3	0	51599	\N
26264	3338	4	0	51600	\N
26278	210	4	0	51934	\N
26278	3536	5	0	51936	\N
26080	317	1	0	53961	\N
26080	316	3	0	53973	\N
26080	3115	4	0	53976	\N
26295	451	11	0	55361	\N
26076	597	2	0	55914	\N
26076	3286	3	0	55920	\N
26054	1109	10	0	56114	\N
26054	7417	11	0	56117	\N
26270	1021	3	0	56477	\N
26270	4551	4	0	56483	\N
26043	2636	2	0	58790	\N
26043	2836	3	0	58792	\N
26148	2351	3	0	59033	\N
26148	2845	4	0	59035	\N
26183	2351	3	0	59041	\N
26183	2845	4	0	59042	\N
26097	4233	2	0	60105	\N
26097	5577	3	0	60109	\N
26281	4787	7	0	60351	\N
26281	7089	8	0	60355	\N
26065	6849	9	0	60836	\N
26065	7422	10	0	60837	\N
26071	7426	5	0	60970	\N
26090	7412	2	0	60971	\N
26170	7412	0	0	60973	\N
26090	7430	3	0	60974	\N
26259	7412	3	0	60976	\N
26259	7466	4	0	60979	\N
26253	7016	5	0	1038	\N
26202	3235	3	0	1239	\N
26092	251	2	0	1521	\N
26092	1851	3	0	1524	\N
26085	117	2	0	2045	\N
26085	1257	3	0	2046	\N
26045	1636	2	0	3158	\N
26045	4416	3	0	3159	\N
26082	7427	1	0	4034	\N
26082	7225	3	0	4039	\N
26082	7428	4	0	4040	\N
26266	35	3	0	4251	\N
26235	365	0	0	4604	\N
26239	365	0	0	4606	\N
26116	4178	2	0	7358	\N
26116	4247	3	0	7359	\N
26122	4178	4	0	7363	\N
26122	4331	5	0	7365	\N
26145	4178	2	0	7370	\N
26145	4247	3	0	7372	\N
26153	4178	6	0	7373	\N
26162	4178	3	0	7374	\N
26162	4211	4	0	7375	\N
26153	4250	7	0	7376	\N
26167	4178	8	0	7377	\N
26177	4178	7	0	7379	\N
26200	4178	3	0	7380	\N
26200	4211	4	0	7381	\N
26177	4396	8	0	7382	\N
26230	4178	7	0	7393	\N
26230	4396	8	0	7394	\N
26233	4178	7	0	7395	\N
26233	4396	8	0	7396	\N
26267	4178	3	0	7403	\N
26273	4178	3	0	7404	\N
26267	4211	4	0	7405	\N
26273	4211	4	0	7406	\N
26277	4178	6	0	7408	\N
26275	4205	5	0	7409	\N
26277	4250	7	0	7410	\N
26041	4172	2	0	9528	\N
26041	4191	3	0	9530	\N
26155	4172	5	0	9536	\N
26203	4172	4	0	9538	\N
26203	4219	5	0	9539	\N
26155	4634	6	0	9540	\N
26290	4172	2	0	9556	\N
26290	4191	3	0	9557	\N
26256	391	3	0	10420	\N
26262	391	7	0	10431	\N
26262	3662	8	0	10432	\N
26127	7439	3	1	11927	\N
26127	7438	2	0	11969	\N
26073	258	2	0	14438	\N
26073	3275	3	0	14440	\N
26196	192	5	0	15309	\N
26196	3871	6	0	15313	\N
26112	212	2	0	17113	\N
26112	3616	3	0	17116	\N
26039	241	4	0	20549	\N
26039	2122	5	0	20551	\N
26268	4217	4	0	20756	\N
26064	488	15	0	21545	\N
26064	7421	16	0	21548	\N
26127	7437	2	0	21641	\N
26127	6025	3	0	21726	\N
26102	930	4	0	23929	\N
26102	7434	5	0	23930	\N
26208	224	4	0	25535	\N
26208	3806	5	0	25540	\N
26291	86	2	0	26470	\N
26291	3321	3	0	26473	\N
26134	94	2	0	27084	\N
26134	2794	3	0	27087	\N
26158	7257	6	0	27088	\N
26252	320	3	0	29287	\N
26252	4821	4	0	29288	\N
26068	449	6	0	29873	\N
26068	6116	7	0	29874	\N
26104	20	2	0	30467	\N
26104	369	3	0	30470	\N
26033	7410	64	0	31851	\N
26033	33	126	0	31871	\N
26033	7411	127	0	31872	\N
26113	2	2	0	34896	\N
26231	2	7	0	34914	\N
26231	2858	8	0	34919	\N
26246	14	3	0	39373	\N
26244	7465	5	0	39374	\N
26246	4272	4	0	39376	\N
26049	18	11	0	40492	\N
26049	7414	12	0	40493	\N
26058	18	2	0	40494	\N
26058	1685	3	0	40495	\N
26191	23	11	0	40859	\N
26191	6505	12	0	40860	\N
26247	27	3	0	41178	\N
26247	4636	4	0	41184	\N
26257	4636	4	0	41185	\N
26099	40	3	0	41417	\N
26099	372	4	0	41419	\N
26131	40	2	0	41439	\N
26131	282	3	0	41441	\N
26272	40	2	0	41453	\N
26272	282	3	0	41454	\N
26443	4703	7	0	44594	\N
26477	4109	3	0	44597	\N
26477	56	5	0	44598	\N
26477	1088	6	0	44599	\N
26515	56	3	0	44601	\N
26515	4109	4	0	44603	\N
26406	71	21	0	44839	\N
26406	7498	22	0	44846	\N
26494	7521	96	0	44847	\N
26494	71	126	0	44864	\N
26494	7522	127	0	44865	\N
26509	7523	96	0	44866	\N
26509	71	105	0	44875	\N
26509	7524	106	0	44876	\N
26378	75	3	0	45132	\N
26428	75	3	0	45133	\N
26512	75	4	0	45135	\N
26378	3855	4	0	45144	\N
26428	3855	4	0	45145	\N
26512	3959	5	0	45146	\N
26315	79	3	0	46541	\N
26507	79	3	0	46542	\N
26315	3652	4	0	46543	\N
26507	3652	4	0	46544	\N
26384	119	4	0	48595	\N
26384	3518	5	0	48603	\N
26327	121	1	0	48967	\N
26327	122	2	0	48969	\N
26426	156	3	0	50413	\N
26426	4594	4	0	50414	\N
26451	170	3	0	50728	\N
26451	4148	4	0	50730	\N
26302	186	6	0	51308	\N
26302	7407	7	0	51310	\N
26387	210	3	0	51949	\N
26387	3539	4	0	51950	\N
26301	242	5	0	52207	\N
26346	242	3	0	52208	\N
26348	242	2	0	52209	\N
26348	3425	3	0	52210	\N
26346	2839	4	0	52211	\N
26301	4562	6	0	52212	\N
26311	7476	7	0	52606	\N
26311	268	6	0	52641	\N
26523	268	3	0	52659	\N
26523	3815	4	0	52667	\N
26295	7193	12	0	55362	\N
26343	1021	2	0	56478	\N
26343	4432	3	0	56480	\N
26456	1021	4	0	56492	\N
26456	4752	5	0	56493	\N
26324	793	5	0	56670	\N
26324	5143	6	0	56676	\N
26399	841	4	0	57030	\N
26399	3886	5	0	57035	\N
26299	1470	5	0	58302	\N
26299	6556	6	0	58306	\N
26305	4425	3	0	60103	\N
26305	4233	4	0	60110	\N
26447	7412	4	0	60988	\N
26447	7499	5	0	60991	\N
26311	7463	8	0	61205	\N
26311	7477	7	1	61298	\N
26349	7481	2	0	60	\N
26316	3329	3	0	3434	\N
26423	262	3	0	3889	\N
26423	4778	4	0	3892	\N
26468	7515	56	0	4959	\N
26466	189	3	0	4964	\N
26466	3782	4	0	4966	\N
26468	189	126	0	4970	\N
26468	7516	127	0	4971	\N
26293	4178	2	0	7411	\N
26293	4247	3	0	7412	\N
26294	4178	11	0	7413	\N
26294	7472	12	0	7416	\N
26335	4211	4	0	7419	\N
26419	4178	7	0	7443	\N
26419	4396	8	0	7444	\N
26485	4178	3	0	7451	\N
26485	4211	4	0	7452	\N
26486	4178	3	0	7453	\N
26486	4211	4	0	7454	\N
26489	4178	7	0	7455	\N
26489	4396	8	0	7458	\N
26519	4178	4	0	7462	\N
26519	4205	5	0	7464	\N
26307	4172	0	0	9558	\N
26322	4172	5	0	9560	\N
26326	4172	2	0	9561	\N
26362	4172	3	0	9562	\N
26365	4172	0	0	9563	\N
26326	4191	3	0	9564	\N
26362	4275	4	0	9565	\N
26318	4415	6	0	9566	\N
26322	4415	6	0	9567	\N
26440	4172	3	0	9579	\N
26453	4172	2	0	9580	\N
26453	4191	3	0	9581	\N
26440	4275	4	0	9582	\N
26435	133	2	0	11401	\N
26433	132	8	0	11412	\N
26435	132	8	0	11414	\N
26433	7504	9	0	11416	\N
26435	7504	9	0	11418	\N
26404	108	4	0	11823	\N
26404	4060	5	0	11825	\N
26476	58	6	0	13629	\N
26476	6952	7	0	13632	\N
26414	38	18	0	16460	\N
26414	5671	19	0	16463	\N
26499	38	7	0	16470	\N
26320	115	5	0	16748	\N
26320	5025	6	0	16749	\N
26518	326	3	0	17438	\N
26518	3339	4	0	17439	\N
26321	167	5	0	17785	\N
26321	2851	6	0	17789	\N
26310	241	0	0	20562	\N
26528	1628	3	0	21621	\N
26528	7527	4	0	21622	\N
26391	69	7	0	24801	\N
26391	3711	8	0	24805	\N
26510	7083	5	0	26125	\N
26510	7525	12	0	26135	\N
26332	6303	5	0	26350	\N
26332	6994	6	0	26353	\N
26368	6303	3	0	26354	\N
26368	7480	4	0	26356	\N
26376	86	8	0	26471	\N
26376	3905	9	0	26475	\N
26413	94	3	0	27091	\N
26413	2864	4	0	27092	\N
26502	42	7	0	27638	\N
26502	6853	8	0	27642	\N
26417	320	4	0	29307	\N
26458	151	7	0	30740	\N
26458	7266	8	0	30743	\N
26329	360	3	0	31444	\N
26329	7479	4	0	31449	\N
26304	6	2	0	36362	\N
26304	2805	3	0	36363	\N
26317	14	5	0	39400	\N
26317	5648	6	0	39403	\N
26336	40	4	0	41466	\N
26336	2796	5	0	41468	\N
26534	40	9	0	41481	\N
26534	4712	10	0	41485	\N
26457	4109	4	0	44596	\N
26530	79	3	0	46597	\N
26530	3652	4	0	46598	\N
26357	88	7	0	47229	\N
26357	5323	8	0	47234	\N
26328	121	2	0	48968	\N
26328	2498	3	0	48970	\N
26393	156	7	0	50410	\N
26393	4672	8	0	50412	\N
26543	156	2	0	50417	\N
26543	3093	3	0	50420	\N
26313	268	6	0	52642	\N
26313	6804	7	0	52650	\N
26567	273	3	0	53080	\N
26567	3638	4	0	53081	\N
26398	1021	2	0	56479	\N
26398	4432	3	0	56481	\N
26563	793	3	0	56671	\N
26563	2644	4	0	56674	\N
26425	841	3	0	57054	\N
26425	3604	4	0	57055	\N
26345	852	3	0	57347	\N
26347	852	2	0	57348	\N
26347	4236	3	0	57351	\N
26345	3612	4	0	57352	\N
26352	7482	7	0	57500	\N
26352	7483	8	0	57503	\N
26383	3625	4	0	59559	\N
26383	3802	5	0	59565	\N
26472	4088	3	0	59856	\N
26472	4506	4	0	59862	\N
26306	4233	1	0	60106	\N
26306	5087	2	0	60107	\N
26522	5885	3	0	60526	\N
26522	5926	4	0	60531	\N
26354	6765	2	0	60925	\N
26484	6765	3	0	60926	\N
26354	6841	3	0	60929	\N
26484	6884	4	0	60930	\N
26401	7412	3	0	60983	\N
26401	7466	4	0	60984	\N
26442	7412	6	0	60987	\N
26442	7507	7	0	60994	\N
26541	7412	7	0	60996	\N
26554	7412	6	0	60998	\N
26554	7507	7	0	61001	\N
26541	7528	8	0	61002	\N
26568	7412	3	0	61003	\N
26571	7412	7	0	61004	\N
26571	7528	8	0	61006	\N
26573	4100	5	0	1256	\N
26416	7502	5	0	2335	\N
26314	367	3	0	3432	\N
26314	3683	4	0	3435	\N
26551	367	3	0	3447	\N
26551	3683	4	0	3449	\N
26338	35	1	0	4266	\N
26467	7514	79	0	4958	\N
26467	189	120	0	4968	\N
26467	849	121	0	4969	\N
26359	4178	3	0	7425	\N
26359	4211	4	0	7426	\N
26367	4178	4	0	7429	\N
26367	4331	5	0	7430	\N
26418	4178	3	0	7440	\N
26418	4211	4	0	7442	\N
26439	4178	4	0	7446	\N
26439	4205	5	0	7448	\N
26465	4178	3	0	7449	\N
26465	4211	4	0	7450	\N
26538	4178	7	0	7467	\N
26538	4396	8	0	7468	\N
26546	4178	10	0	7469	\N
26546	4665	11	0	7470	\N
26390	4172	7	0	9568	\N
26410	4172	4	0	9572	\N
26430	4172	4	0	9573	\N
26410	4219	5	0	9574	\N
26430	4219	5	0	9575	\N
26470	4172	8	0	9583	\N
26475	4172	6	0	9584	\N
26488	4172	3	0	9585	\N
26488	4275	4	0	9586	\N
26475	5278	7	0	9587	\N
26470	5928	9	0	9588	\N
26491	4172	3	0	9589	\N
26491	4275	4	0	9590	\N
26504	4275	4	0	9595	\N
26342	391	2	0	10443	\N
26342	1381	3	0	10444	\N
26474	459	6	0	11977	\N
26474	7518	7	0	11978	\N
26370	528	6	0	12604	\N
26370	7486	7	0	12605	\N
26375	192	8	0	15310	\N
26375	7488	9	0	15314	\N
26514	192	3	0	15320	\N
26514	3790	4	0	15322	\N
26422	235	3	0	15800	\N
26364	326	2	0	17411	\N
26364	393	3	0	17412	\N
26506	326	4	0	17425	\N
26506	3519	5	0	17426	\N
26396	61	1	0	19469	\N
26396	60	8	0	19484	\N
26396	7497	9	0	19488	\N
26496	198	3	0	20096	\N
26496	4263	4	0	20099	\N
26544	73	2	0	22593	\N
26544	3243	3	0	22594	\N
26559	73	4	0	22599	\N
26446	336	4	0	22823	\N
26446	3947	5	0	22825	\N
26540	336	9	0	22834	\N
26540	6545	10	0	22835	\N
26561	82	3	0	23767	\N
26561	4505	4	0	23769	\N
26386	90	3	0	26115	\N
26386	4074	4	0	26116	\N
26569	90	3	0	26130	\N
26569	4074	4	0	26132	\N
26408	94	6	0	27086	\N
26408	4696	7	0	27090	\N
26463	4696	7	0	27096	\N
26525	320	3	0	29326	\N
26525	4821	4	0	29330	\N
26533	54	9	0	30205	\N
26533	5922	10	0	30206	\N
26460	20	3	0	30481	\N
26460	2844	4	0	30482	\N
26331	360	5	0	31445	\N
26331	3586	6	0	31451	\N
26558	230	4	0	32122	\N
26558	3954	5	0	32123	\N
26565	322	3	0	32364	\N
26553	2	7	0	34943	\N
26553	2858	8	0	34946	\N
26380	4	3	0	36035	\N
26380	3837	4	0	36037	\N
26325	14	2	0	39401	\N
26325	1785	3	0	39402	\N
26517	18	3	0	40506	\N
26517	3621	4	0	40508	\N
26557	18	3	0	40510	\N
26557	3621	4	0	40513	\N
26298	40	2	0	41465	\N
26298	282	3	0	41467	\N
26403	56	3	0	44591	\N
26403	4109	4	0	44593	\N
26481	56	5	0	44600	\N
26481	6463	6	0	44605	\N
26498	75	1	0	45134	\N
26498	1427	2	0	45139	\N
26601	79	5	0	46643	\N
26601	5993	6	0	46644	\N
26358	7484	77	0	47218	\N
26358	88	126	0	47235	\N
26358	7485	127	0	47236	\N
26536	135	9	0	49524	\N
26536	5189	10	0	49536	\N
26508	156	3	0	50415	\N
26508	4594	4	0	50416	\N
26421	170	3	0	50727	\N
26421	4148	4	0	50729	\N
26334	181	4	0	50967	\N
26334	4058	5	0	50968	\N
26570	186	7	0	51328	\N
26570	4595	8	0	51336	\N
26389	210	6	0	51963	\N
26389	3721	7	0	51964	\N
26575	242	3	0	52217	\N
26575	2839	4	0	52218	\N
26448	285	4	0	53616	\N
26462	285	6	0	53618	\N
26448	3674	5	0	53620	\N
26462	3903	7	0	53621	\N
26585	3903	6	0	53624	\N
26585	285	8	0	53641	\N
26585	3112	9	0	53643	\N
26377	324	3	0	54322	\N
26377	4514	4	0	54323	\N
26392	7494	118	0	56592	\N
26392	7495	118	1	58417	\N
26300	7474	6	0	58650	\N
26303	2636	5	0	58804	\N
26303	3780	6	0	58805	\N
26312	5885	6	0	60525	\N
26312	6803	7	0	60535	\N
26501	6044	7	0	60662	\N
26501	6727	8	0	60663	\N
26308	7412	0	0	60977	\N
26323	7412	5	0	60978	\N
26323	7478	6	0	60980	\N
26361	7412	2	0	60981	\N
26361	7430	3	0	60982	\N
26568	7466	4	0	61005	\N
26537	2224	6	0	68	\N
26444	46	6	0	662	\N
26444	5965	7	0	670	\N
26464	117	3	0	2051	\N
26464	3191	4	0	2052	\N
26479	228	4	0	2843	\N
26479	4800	5	0	2852	\N
26366	262	7	0	3878	\N
26366	4888	8	0	3879	\N
26580	2111	6	0	4102	\N
26580	7534	7	0	4103	\N
26337	35	2	0	4265	\N
26319	4178	5	0	7417	\N
26319	4429	6	0	7420	\N
26344	4178	3	0	7421	\N
26351	4178	7	0	7422	\N
26344	4211	4	0	7423	\N
26351	4509	8	0	7424	\N
26379	4178	3	0	7431	\N
26379	4211	4	0	7432	\N
26382	4178	4	0	7433	\N
26395	4178	4	0	7434	\N
26382	4205	5	0	7435	\N
26395	4205	5	0	7436	\N
26412	4178	3	0	7439	\N
26516	4178	3	0	7461	\N
26516	4211	4	0	7463	\N
26527	4178	4	0	7465	\N
26527	4205	5	0	7466	\N
26572	4178	4	0	7472	\N
26587	4178	6	0	7474	\N
26572	4205	5	0	7477	\N
26587	4250	7	0	7478	\N
26432	5069	2	0	9576	\N
26432	4172	8	0	9577	\N
26432	5070	9	0	9578	\N
26455	7509	68	0	10445	\N
26455	7510	89	0	10461	\N
26583	4875	6	0	12167	\N
26583	300	8	0	12174	\N
26583	3168	9	0	12177	\N
26436	7506	7	0	13119	\N
26436	7505	6	0	13165	\N
26437	77	6	0	13166	\N
26437	6600	7	0	13167	\N
26513	77	7	0	13178	\N
26513	6022	8	0	13179	\N
26471	233	3	0	13878	\N
26471	3704	4	0	13882	\N
26521	2760	3	0	14092	\N
26450	192	3	0	15319	\N
26450	3790	4	0	15321	\N
26459	7513	119	0	15577	\N
26459	7511	115	0	15578	\N
26459	7512	118	0	15579	\N
26374	44	6	0	16127	\N
26374	5989	7	0	16128	\N
26592	38	4	0	16478	\N
26592	5656	5	0	16479	\N
26353	212	2	0	17114	\N
26353	3616	3	0	17117	\N
26333	6764	6	0	18184	\N
26459	3108	119	1	18783	\N
26596	208	6	0	19281	\N
26596	5118	7	0	19296	\N
26309	241	39	0	20561	\N
26309	7475	40	0	20563	\N
26400	64	4	0	20759	\N
26400	3911	5	0	20760	\N
26392	7493	117	1	21732	\N
26392	1018	116	0	21962	\N
26436	1018	6	0	21963	\N
26429	145	4	0	21969	\N
26436	4098	7	1	22002	\N
26392	1075	119	1	22003	\N
26392	7496	119	0	24745	\N
26392	7490	77	0	24795	\N
26392	7491	116	0	24806	\N
26330	6303	3	0	26349	\N
26330	7480	4	0	26352	\N
26350	42	1	0	27637	\N
26350	2823	2	0	27640	\N
26503	320	3	0	29308	\N
26503	4821	4	0	29309	\N
26339	96	5	0	29544	\N
26469	54	8	0	30190	\N
26469	7517	9	0	30195	\N
26532	54	0	0	30204	\N
26604	20	10	0	30490	\N
26356	2	7	0	34936	\N
26356	5463	8	0	34937	\N
26372	14	6	0	39408	\N
26372	7487	7	0	39410	\N
26493	14	3	0	39414	\N
26493	4272	4	0	39416	\N
26340	18	5	0	40502	\N
26340	3550	6	0	40503	\N
26589	4255	7	0	41511	\N
26539	56	4	0	44602	\N
26539	3127	5	0	44604	\N
26373	75	6	0	45131	\N
26373	3303	7	0	45147	\N
26420	88	3	0	47230	\N
26420	3655	4	0	47233	\N
26424	7484	77	0	47237	\N
26424	88	89	0	47250	\N
26424	7503	90	0	47251	\N
26371	113	6	0	48315	\N
26371	5057	7	0	48316	\N
26409	7449	117	0	49347	\N
26409	125	118	0	49356	\N
26535	137	9	0	49830	\N
26535	5190	10	0	49835	\N
26497	181	3	0	50980	\N
26497	4184	4	0	50981	\N
26529	200	3	0	51613	\N
26590	200	4	0	51614	\N
26529	3338	4	0	51615	\N
26590	4683	5	0	51616	\N
26574	242	0	0	52216	\N
26594	279	6	0	53278	\N
26594	5117	7	0	53283	\N
26586	7537	9	0	53507	\N
26445	285	0	0	53615	\N
26449	285	2	0	53617	\N
26449	4282	3	0	53619	\N
26586	3903	6	0	53625	\N
26461	285	0	0	53636	\N
26586	285	8	0	53642	\N
26531	316	4	0	53972	\N
26531	5437	5	0	53978	\N
26487	841	4	0	57064	\N
26487	3886	5	0	57065	\N
26452	7482	3	0	57501	\N
26452	7508	4	0	57502	\N
26431	3004	3	0	59469	\N
26431	5266	4	0	59470	\N
26385	3628	4	0	59706	\N
26385	3803	5	0	59712	\N
26595	4233	6	0	60112	\N
26595	6364	7	0	60114	\N
26411	7412	4	0	60985	\N
26411	7499	5	0	60986	\N
26454	7412	4	0	60989	\N
26480	7412	5	0	60990	\N
26454	7499	5	0	60992	\N
26480	7519	6	0	60993	\N
26524	7412	3	0	60995	\N
26545	7412	2	0	60997	\N
26545	7529	3	0	60999	\N
26524	7466	4	0	61000	\N
26388	4926	8	0	1248	\N
26579	5292	7	0	4104	\N
26360	4178	2	0	7427	\N
26360	4247	3	0	7428	\N
26402	4178	3	0	7437	\N
26402	4211	4	0	7438	\N
26427	4178	3	0	7445	\N
26427	4211	4	0	7447	\N
26492	4178	3	0	7456	\N
26492	4211	4	0	7457	\N
26500	4178	3	0	7459	\N
26500	4211	4	0	7460	\N
26560	4178	4	0	7471	\N
26591	4178	6	0	7475	\N
26560	4205	5	0	7476	\N
26591	4250	7	0	7479	\N
26577	7533	13	0	7480	\N
26394	4172	3	0	9570	\N
26394	4275	4	0	9571	\N
26495	4172	10	0	9591	\N
26495	4663	11	0	9592	\N
26556	4172	3	0	9594	\N
26556	4275	4	0	9596	\N
26562	4172	3	0	9597	\N
26562	4275	4	0	9598	\N
26564	391	126	0	10471	\N
26564	7510	127	0	10472	\N
26434	133	2	0	11400	\N
26434	132	8	0	11413	\N
26434	7504	9	0	11417	\N
26582	4875	6	0	12166	\N
26584	4875	6	0	12168	\N
26582	300	8	0	12173	\N
26584	300	8	0	12175	\N
26582	3168	9	0	12176	\N
26584	3168	9	0	12178	\N
26520	92	3	0	15143	\N
26552	235	3	0	15801	\N
26552	3343	4	0	15803	\N
26505	44	3	0	16135	\N
26505	3631	4	0	16136	\N
26483	212	3	0	17137	\N
26483	3639	4	0	17148	\N
26405	290	4	0	19123	\N
26405	5879	5	0	19125	\N
26397	61	1	0	19470	\N
26397	60	8	0	19485	\N
26397	7497	9	0	19489	\N
26438	62	4	0	19828	\N
26586	1075	9	1	22035	\N
26547	356	1	0	22836	\N
26548	356	1	0	22837	\N
26547	336	4	0	22852	\N
26548	336	4	0	22853	\N
26547	7530	5	0	22854	\N
26548	7530	5	0	22855	\N
26355	149	2	0	23154	\N
26355	1379	3	0	23155	\N
26526	69	3	0	24802	\N
26526	4536	4	0	24803	\N
26415	224	18	0	25549	\N
26441	90	3	0	26123	\N
26441	4074	4	0	26124	\N
26369	6303	5	0	26355	\N
26369	6994	6	0	26357	\N
26381	6303	4	0	26358	\N
26381	7489	5	0	26359	\N
26576	86	12	0	26472	\N
26576	7532	13	0	26476	\N
26555	20	3	0	30489	\N
26555	2844	4	0	30491	\N
26482	33	3	0	31865	\N
26482	3342	4	0	31869	\N
26478	4108	5	0	32920	\N
26490	431	7	0	34859	\N
26490	7520	8	0	34862	\N
26407	2	6	0	34942	\N
26407	4825	7	0	34945	\N
26363	4	3	0	36020	\N
26363	3837	4	0	36022	\N
26550	4	4	0	36036	\N
26550	4117	5	0	36038	\N
26473	14	7	0	39409	\N
26473	3882	8	0	39411	\N
26511	3964	5	0	40501	\N
26511	7526	12	0	40505	\N
26542	18	7	0	40507	\N
26542	1618	8	0	40509	\N
26341	40	5	0	41480	\N
26549	40	2	0	41482	\N
26549	282	3	0	41483	\N
26341	2714	6	0	41484	\N
26566	40	4	0	41495	\N
26566	3381	5	0	41496	\N
26597	40	6	0	41508	\N
26611	56	3	0	44606	\N
26611	4109	4	0	44607	\N
26834	75	2	0	45137	\N
26834	284	3	0	45143	\N
26605	79	4	0	46672	\N
26607	79	3	0	46673	\N
26607	3652	4	0	46674	\N
26605	3678	5	0	46675	\N
26668	891	2	0	48553	\N
26668	119	8	0	48604	\N
26668	7561	9	0	48607	\N
26655	200	4	0	51624	\N
26655	4683	5	0	51625	\N
26623	210	3	0	51969	\N
26623	3539	4	0	51971	\N
26581	3903	6	0	53623	\N
26581	7535	8	0	53640	\N
26793	595	3	0	55665	\N
26793	3654	4	0	55673	\N
26763	793	4	0	56672	\N
26763	3618	5	0	56675	\N
26829	2351	3	0	59059	\N
26829	2845	4	0	59060	\N
26635	4088	4	0	59857	\N
26635	4089	5	0	59864	\N
26593	4233	4	0	60111	\N
26593	7538	5	0	60113	\N
26581	6751	8	0	60576	\N
26581	7536	9	0	60591	\N
26665	7558	9	0	60597	\N
26660	6044	8	0	60665	\N
26660	6725	9	0	60666	\N
26770	6044	20	0	60671	\N
26770	7586	21	0	60674	\N
26621	7545	21	0	60869	\N
26621	6723	23	0	60876	\N
26621	7546	24	0	60877	\N
26788	6765	4	0	60932	\N
26788	7217	5	0	60933	\N
26629	7412	7	0	61007	\N
26629	7528	8	0	61011	\N
26698	7412	3	0	61017	\N
26698	7466	4	0	61018	\N
26805	7412	4	0	61023	\N
26805	7426	5	0	61024	\N
26813	7412	7	0	61025	\N
26813	7528	8	0	61030	\N
26638	3188	5	0	802	\N
26746	4986	8	0	816	\N
26600	228	4	0	2844	\N
26600	4800	5	0	2853	\N
26644	367	6	0	3448	\N
26644	6013	7	0	3450	\N
26696	367	4	0	3459	\N
26696	3679	5	0	3460	\N
26832	365	3	0	4617	\N
26832	3839	4	0	4619	\N
26599	4178	4	0	7481	\N
26599	4205	5	0	7482	\N
26622	7547	21	0	7485	\N
26622	4460	24	0	7491	\N
26625	4178	3	0	7492	\N
26625	4211	4	0	7493	\N
26640	4178	9	0	7496	\N
26640	4682	10	0	7499	\N
26844	4178	4	0	7543	\N
26844	4205	5	0	7544	\N
26616	4172	8	0	9600	\N
26679	4172	3	0	9602	\N
26679	4275	4	0	9605	\N
26616	7540	9	0	9607	\N
26728	4172	7	0	9610	\N
26651	7555	106	0	10473	\N
26651	391	126	0	10482	\N
26651	7510	127	0	10483	\N
26681	391	6	0	10493	\N
26681	2680	7	0	10494	\N
26755	132	4	0	11410	\N
26755	3716	5	0	11411	\N
26716	469	4	0	12355	\N
26716	7579	5	0	12356	\N
26620	7544	21	0	12790	\N
26825	123	4	0	12797	\N
26825	4090	5	0	12810	\N
26620	2275	24	0	12814	\N
26637	233	4	0	13894	\N
26637	3775	5	0	13895	\N
26837	192	3	0	15328	\N
26837	3790	4	0	15332	\N
26709	7576	58	0	16480	\N
26709	38	126	0	16487	\N
26709	7577	127	0	16488	\N
26750	212	3	0	17138	\N
26752	212	2	0	17139	\N
26752	4193	3	0	17146	\N
26750	3639	4	0	17149	\N
26578	4048	5	0	17788	\N
26802	60	3	0	19503	\N
26802	3585	4	0	19504	\N
26608	164	3	0	21231	\N
26740	164	3	0	21233	\N
26742	164	4	0	21234	\N
26608	3385	4	0	21235	\N
26740	3385	4	0	21236	\N
26742	4152	5	0	21237	\N
26619	264	8	0	23615	\N
26619	7543	9	0	23617	\N
26729	214	7	0	24397	\N
26782	214	3	0	24418	\N
26782	3496	4	0	24419	\N
26711	90	3	0	26131	\N
26711	4074	4	0	26133	\N
26845	94	13	0	27099	\N
26748	54	3	0	30213	\N
26748	3041	4	0	30215	\N
26665	7559	9	1	30946	\N
26665	812	2	0	31090	\N
26665	202	8	0	31099	\N
26808	202	3	0	31108	\N
26808	4857	4	0	31112	\N
26786	3954	5	0	32132	\N
26768	453	6	0	32921	\N
26768	4091	7	0	32922	\N
26588	2	6	0	34960	\N
26588	4825	7	0	34962	\N
26674	2	4	0	35007	\N
26674	3510	5	0	35011	\N
26701	2	3	0	35023	\N
26701	3548	4	0	35024	\N
26759	2	0	0	35031	\N
26628	4	7	0	36049	\N
26630	4	4	0	36050	\N
26628	4716	8	0	36052	\N
26676	4	3	0	36059	\N
26676	3837	4	0	36060	\N
26612	14	6	0	39415	\N
26612	7487	7	0	39417	\N
26602	18	5	0	40511	\N
26602	4010	6	0	40515	\N
26597	4255	7	0	41512	\N
26703	40	7	0	41527	\N
26703	4718	8	0	41528	\N
26737	40	3	0	41543	\N
26737	372	4	0	41544	\N
26800	372	4	0	41557	\N
26839	40	4	0	41564	\N
26839	3381	5	0	41568	\N
26856	7601	112	0	44608	\N
26856	56	126	0	44624	\N
26856	3127	127	0	44625	\N
26652	71	3	0	44840	\N
26652	3770	4	0	44843	\N
26881	88	3	0	47258	\N
26677	100	3	0	47641	\N
26677	3836	4	0	47642	\N
26852	119	3	0	48596	\N
26852	2860	4	0	48601	\N
26648	170	4	0	50737	\N
26648	4680	5	0	50740	\N
26868	260	3	0	52397	\N
26868	3399	4	0	52399	\N
26877	595	3	0	55666	\N
26877	3654	4	0	55674	\N
26641	597	9	0	55915	\N
26880	597	3	0	55917	\N
26880	3656	4	0	55924	\N
26641	7551	10	0	55929	\N
26662	852	8	0	57349	\N
26749	852	3	0	57350	\N
26749	3612	4	0	57353	\N
26662	7557	9	0	57354	\N
26685	1470	8	0	58325	\N
26690	1470	10	0	58326	\N
26685	3813	9	0	58329	\N
26690	3375	11	0	58330	\N
26626	2636	3	0	58808	\N
26626	2837	4	0	58809	\N
26731	2782	3	0	59375	\N
26792	2782	10	0	59376	\N
26731	3659	4	0	59377	\N
26792	7593	11	0	59378	\N
26669	7562	2	0	59695	\N
26669	3628	8	0	59713	\N
26669	7563	9	0	59715	\N
26855	3628	3	0	59728	\N
26855	3785	4	0	59740	\N
26861	7603	79	0	60115	\N
26861	4233	126	0	60122	\N
26861	6719	127	0	60123	\N
26614	5885	8	0	60527	\N
26614	7539	9	0	60533	\N
26710	6044	3	0	60670	\N
26710	6045	4	0	60672	\N
26751	6765	3	0	60927	\N
26751	6884	4	0	60931	\N
26705	7571	13	0	61295	\N
26705	7572	13	1	61305	\N
26741	7016	5	0	1040	\N
26659	4776	3	0	2847	\N
26848	262	3	0	3891	\N
26848	4778	4	0	3893	\N
26598	7225	6	0	4043	\N
26598	7379	7	0	4050	\N
26790	7591	3	0	4728	\N
26790	7592	4	0	4729	\N
26774	189	6	0	4965	\N
26774	3713	7	0	4967	\N
26603	4178	3	0	7483	\N
26603	4211	4	0	7484	\N
26609	4178	3	0	7486	\N
26631	4178	4	0	7494	\N
26636	4178	4	0	7495	\N
26631	4205	5	0	7497	\N
26636	4205	5	0	7498	\N
26713	4178	6	0	7507	\N
26722	4178	4	0	7508	\N
26722	4205	5	0	7510	\N
26713	4250	7	0	7511	\N
26771	4178	20	0	7522	\N
26771	5874	21	0	7525	\N
26785	4178	3	0	7526	\N
26785	4211	4	0	7527	\N
26807	4211	4	0	7531	\N
26828	4178	2	0	7537	\N
26828	4247	3	0	7538	\N
26831	4178	4	0	7539	\N
26831	4205	5	0	7540	\N
26843	4178	3	0	7541	\N
26843	4211	4	0	7542	\N
26847	4178	7	0	7545	\N
26847	4396	8	0	7546	\N
26854	4178	3	0	7547	\N
26854	4211	4	0	7550	\N
26680	4172	7	0	9603	\N
26683	4172	9	0	9609	\N
26683	4977	10	0	9614	\N
26736	4172	6	0	9615	\N
26736	4197	7	0	9616	\N
26811	4172	3	0	9623	\N
26811	4275	4	0	9625	\N
26815	4201	1	0	9628	\N
26815	4172	5	0	9630	\N
26815	4940	6	0	9631	\N
26866	4172	3	0	9634	\N
26866	4275	4	0	9636	\N
26765	108	7	0	11838	\N
26857	173	10	0	14721	\N
26857	7602	11	0	14722	\N
26849	7598	3	0	16173	\N
26849	3631	4	0	16174	\N
26705	7569	12	0	18426	\N
26705	142	11	0	18589	\N
26739	60	4	0	19501	\N
26739	3894	5	0	19505	\N
26836	62	3	0	19829	\N
26836	3344	4	0	19830	\N
26875	64	3	0	20765	\N
26875	4217	4	0	20767	\N
26869	3385	4	0	21252	\N
26715	149	4	0	23172	\N
26715	4040	5	0	23175	\N
26687	82	8	0	23772	\N
26687	7567	9	0	23774	\N
26617	6303	8	0	26360	\N
26617	7541	9	0	26361	\N
26725	94	4	0	27097	\N
26725	4677	5	0	27098	\N
26845	7008	14	0	27100	\N
26606	42	3	0	27639	\N
26606	3645	4	0	27641	\N
26865	6853	8	0	27651	\N
26613	96	2	0	29555	\N
26613	2942	3	0	29556	\N
26720	449	3	0	29883	\N
26799	449	4	0	29884	\N
26720	4760	4	0	29886	\N
26799	5343	5	0	29887	\N
26827	54	4	0	30214	\N
26827	3685	5	0	30216	\N
26705	7570	12	1	30323	\N
26871	202	3	0	31109	\N
26871	4857	4	0	31113	\N
26817	3602	4	0	31448	\N
26819	431	4	0	34863	\N
26819	3565	5	0	34872	\N
26754	2	15	0	34961	\N
26754	2858	16	0	34963	\N
26633	2	3	0	34985	\N
26633	3548	4	0	34987	\N
26864	14	7	0	39424	\N
26864	3882	8	0	39425	\N
26734	40	5	0	41535	\N
26734	3999	6	0	41536	\N
26858	40	3	0	41574	\N
26894	7611	32	0	43663	\N
26894	7610	16	0	44634	\N
26894	56	31	0	44642	\N
26646	88	4	0	47245	\N
26646	7554	5	0	47247	\N
26618	268	8	0	52660	\N
26618	7542	9	0	52672	\N
26639	595	9	0	55664	\N
26639	7550	10	0	55678	\N
26795	597	3	0	55916	\N
26795	3656	4	0	55923	\N
26874	1109	5	0	56115	\N
26874	6783	6	0	56116	\N
26634	1470	2	0	58303	\N
26634	7549	3	0	58304	\N
26678	1470	3	0	58314	\N
26678	3838	4	0	58315	\N
26850	4431	3	0	58651	\N
26850	2578	4	0	58652	\N
26670	7564	2	0	59526	\N
26853	3625	3	0	59560	\N
26853	3784	4	0	59564	\N
26670	3625	8	0	59566	\N
26670	7565	9	0	59568	\N
26783	4233	3	0	60117	\N
26783	4425	4	0	60119	\N
26673	6044	4	0	60667	\N
26673	6524	5	0	60668	\N
26691	6044	10	0	60669	\N
26691	7118	11	0	60673	\N
26642	6450	9	0	60784	\N
26642	7552	10	0	60812	\N
26671	7412	3	0	61009	\N
26671	7466	4	0	61010	\N
26695	7412	3	0	61015	\N
26695	7466	4	0	61016	\N
26745	7412	7	0	61020	\N
26745	7528	8	0	61022	\N
26876	7412	3	0	61027	\N
26876	7466	4	0	61028	\N
26901	6895	7	0	390	\N
26820	7595	5	0	2298	\N
26784	1858	19	0	3033	\N
26784	7590	20	0	3036	\N
26776	7515	56	0	4973	\N
26776	189	126	0	4985	\N
26776	850	127	0	4987	\N
26615	4178	8	0	7487	\N
26615	6776	9	0	7489	\N
26650	4178	3	0	7500	\N
26650	4211	4	0	7501	\N
26700	4178	3	0	7506	\N
26700	4211	4	0	7509	\N
26726	4211	4	0	7515	\N
26762	4178	3	0	7518	\N
26762	4211	4	0	7520	\N
26778	4178	3	0	7523	\N
26778	4211	4	0	7524	\N
26791	4178	3	0	7528	\N
26791	4211	4	0	7530	\N
26816	4450	1	0	7532	\N
26810	4178	3	0	7533	\N
26816	4178	5	0	7534	\N
26810	4211	4	0	7535	\N
26816	4941	6	0	7536	\N
26900	7472	12	0	7556	\N
26911	4178	3	0	7557	\N
26911	4211	4	0	7559	\N
26610	4172	3	0	9599	\N
26610	4275	4	0	9604	\N
26735	4172	4	0	9611	\N
26735	4219	5	0	9612	\N
26779	5534	4	0	9617	\N
26779	4172	13	0	9620	\N
26779	7589	14	0	9621	\N
26890	4172	3	0	9637	\N
26890	4275	4	0	9639	\N
26781	3729	4	0	11430	\N
26796	92	3	0	15152	\N
26796	4410	4	0	15153	\N
26714	44	6	0	16141	\N
26714	5989	7	0	16142	\N
26718	44	3	0	16147	\N
26718	3631	4	0	16148	\N
26708	38	7	0	16485	\N
26708	5071	8	0	16486	\N
26706	7573	38	0	18582	\N
26706	142	126	0	18592	\N
26706	7574	127	0	18593	\N
26812	6504	8	0	18603	\N
26894	3108	32	1	18798	\N
26743	60	4	0	19502	\N
26743	3894	5	0	19506	\N
26897	264	7	0	23616	\N
26897	7459	8	0	23619	\N
26627	69	7	0	24828	\N
26627	3711	8	0	24829	\N
26686	69	8	0	24853	\N
26772	69	6	0	24854	\N
26772	4084	7	0	24867	\N
26686	7566	9	0	24868	\N
26902	3596	4	0	25324	\N
26758	90	6	0	26144	\N
26758	7581	7	0	26149	\N
26653	6303	3	0	26362	\N
26653	6304	4	0	26364	\N
26657	94	3	0	27094	\N
26657	2864	4	0	27095	\N
26867	911	4	0	29189	\N
26867	7604	5	0	29190	\N
26767	320	10	0	29327	\N
26767	7584	11	0	29333	\N
26766	96	10	0	29563	\N
26907	96	6	0	29575	\N
26907	5078	7	0	29578	\N
26664	449	3	0	29882	\N
26664	4760	4	0	29885	\N
26841	449	3	0	29893	\N
26841	4760	4	0	29894	\N
26747	54	18	0	30211	\N
26747	7580	19	0	30212	\N
26604	6447	11	0	30492	\N
26883	151	10	0	30748	\N
26883	7606	11	0	30749	\N
26667	812	2	0	31092	\N
26730	4857	4	0	31098	\N
26667	202	8	0	31101	\N
26667	7560	9	0	31103	\N
26818	360	4	0	31447	\N
26818	4330	5	0	31450	\N
26797	322	2	0	32377	\N
26797	1866	3	0	32380	\N
26756	2	12	0	34986	\N
26756	2830	13	0	34988	\N
26822	2	3	0	35033	\N
26822	3548	4	0	35034	\N
26643	6	4	0	36368	\N
26804	14	4	0	39420	\N
26804	3498	5	0	39421	\N
26624	18	3	0	40512	\N
26624	3621	4	0	40514	\N
26632	40	4	0	41509	\N
26632	3381	5	0	41510	\N
26688	40	3	0	41517	\N
26688	372	4	0	41518	\N
26824	40	4	0	41555	\N
26824	3381	5	0	41559	\N
26882	56	94	0	44632	\N
26882	7605	95	0	44633	\N
26780	75	3	0	45136	\N
26780	3139	4	0	45141	\N
26645	88	6	0	47244	\N
26760	88	6	0	47246	\N
26645	5263	7	0	47248	\N
26760	5263	7	0	47249	\N
26872	156	3	0	50418	\N
26872	4594	4	0	50421	\N
26647	186	4	0	51329	\N
26899	186	11	0	51330	\N
26647	4733	5	0	51335	\N
26899	7614	12	0	51337	\N
26886	260	4	0	52403	\N
26886	3728	5	0	52406	\N
26833	316	3	0	53992	\N
26833	4249	4	0	53993	\N
26699	324	3	0	54334	\N
26699	4514	4	0	54336	\N
26873	793	3	0	56692	\N
26873	2644	4	0	56693	\N
26798	852	2	0	57365	\N
26798	2872	3	0	57366	\N
26846	908	2	0	57777	\N
26846	2832	3	0	57778	\N
26809	2636	3	0	58812	\N
26809	2837	4	0	58814	\N
26801	2351	3	0	59051	\N
26801	2845	4	0	59052	\N
26727	4233	7	0	60116	\N
26859	4233	3	0	60118	\N
26859	4425	4	0	60120	\N
26727	5582	8	0	60121	\N
26794	6450	3	0	60785	\N
26878	6450	3	0	60786	\N
26794	6847	4	0	60802	\N
26878	6847	4	0	60803	\N
26826	6723	4	0	60871	\N
26826	6739	5	0	60874	\N
26661	7412	8	0	61008	\N
26661	7556	9	0	61012	\N
26692	7412	10	0	61013	\N
26692	7568	11	0	61014	\N
26717	7412	3	0	61019	\N
26717	7466	4	0	61021	\N
26830	7412	4	0	61026	\N
26830	7499	5	0	61029	\N
26702	3003	4	0	67	\N
26682	7366	10	0	803	\N
26821	3767	69	0	2295	\N
26821	7596	70	0	2299	\N
26658	228	3	0	2845	\N
26658	3186	4	0	2850	\N
26769	228	6	0	2860	\N
26769	7585	7	0	2861	\N
26777	1636	4	0	3162	\N
26777	4118	5	0	3163	\N
26697	262	4	0	3890	\N
26697	4607	5	0	3894	\N
26775	7588	85	0	4972	\N
26775	1755	127	0	4986	\N
26654	4178	3	0	7502	\N
26654	4211	4	0	7503	\N
26663	4178	3	0	7504	\N
26663	4211	4	0	7505	\N
26724	4178	8	0	7512	\N
26724	4237	9	0	7513	\N
26732	4178	3	0	7516	\N
26733	4178	5	0	7517	\N
26732	4211	4	0	7519	\N
26733	4202	6	0	7521	\N
26860	4178	3	0	7548	\N
26891	4178	3	0	7553	\N
26891	4211	4	0	7554	\N
26675	4172	4	0	9601	\N
26675	4219	5	0	9606	\N
26744	4172	7	0	9618	\N
26744	4614	8	0	9619	\N
26789	4172	3	0	9622	\N
26789	4275	4	0	9624	\N
26814	4172	13	0	9626	\N
26814	5454	14	0	9627	\N
26840	4172	4	0	9629	\N
26840	4219	5	0	9632	\N
26862	4275	4	0	9635	\N
26879	391	3	0	10458	\N
26879	3660	4	0	10459	\N
26889	391	3	0	10469	\N
26889	3660	4	0	10470	\N
26764	108	10	0	11837	\N
26764	7582	11	0	11846	\N
26906	58	6	0	13630	\N
26906	3575	7	0	13633	\N
26910	233	3	0	13912	\N
26910	3704	4	0	13915	\N
26787	212	4	0	17140	\N
26914	326	3	0	17449	\N
26914	3339	4	0	17450	\N
26888	7607	4	0	18367	\N
26888	7608	5	0	18368	\N
26707	142	11	0	18590	\N
26707	7575	12	0	18591	\N
26806	60	10	0	19519	\N
26806	7594	11	0	19520	\N
26738	164	0	0	21232	\N
26863	336	7	0	22864	\N
26863	3690	8	0	22865	\N
26704	4737	6	0	23156	\N
26803	140	3	0	24109	\N
26803	4149	4	0	24114	\N
26672	69	3	0	24836	\N
26672	4536	4	0	24837	\N
26712	6303	7	0	26363	\N
26712	7578	8	0	26365	\N
26835	6303	10	0	26366	\N
26835	7597	11	0	26367	\N
26719	244	3	0	27299	\N
26721	244	2	0	27300	\N
26721	3308	3	0	27301	\N
26719	4075	4	0	27303	\N
26656	3896	5	0	27650	\N
26823	54	3	0	30224	\N
26823	3041	4	0	30225	\N
26773	1163	6	0	30939	\N
26773	7587	7	0	30941	\N
26666	812	2	0	31091	\N
26666	202	8	0	31100	\N
26666	7560	9	0	31102	\N
26893	431	4	0	34864	\N
26893	7609	5	0	34870	\N
26753	2	15	0	34944	\N
26753	2858	16	0	34947	\N
26757	2	5	0	35009	\N
26757	3029	6	0	35010	\N
26694	3510	5	0	35012	\N
26761	2	0	0	35032	\N
26885	14	3	0	39428	\N
26885	4272	4	0	39430	\N
26649	23	4	0	40870	\N
26649	3189	5	0	40872	\N
26838	40	3	0	41556	\N
26838	372	4	0	41558	\N
26842	40	3	0	41565	\N
26851	40	7	0	41566	\N
26870	40	3	0	41575	\N
26870	372	4	0	41578	\N
22813	71	3	0	44764	\N
26975	3652	3	0	46708	\N
26975	79	4	0	46745	\N
27026	88	2	0	47260	\N
27026	3010	3	0	47261	\N
26881	3655	4	0	47262	\N
26892	102	4	0	48042	\N
26892	3572	5	0	48044	\N
26998	102	3	0	48057	\N
26998	3597	4	0	48060	\N
27010	121	1	0	48992	\N
27010	3098	2	0	48996	\N
27028	137	4	0	49831	\N
27028	4352	5	0	49834	\N
26951	156	3	0	50419	\N
26951	4594	4	0	50422	\N
27117	170	3	0	50749	\N
27117	4148	4	0	50754	\N
27097	200	0	0	51638	\N
26905	210	3	0	51970	\N
26905	3539	4	0	51972	\N
27006	268	6	0	52661	\N
27006	4801	7	0	52673	\N
26895	6965	9	0	53083	\N
26895	273	10	0	53092	\N
27088	279	6	0	53279	\N
27088	5117	7	0	53284	\N
26991	595	3	0	55667	\N
26991	3654	4	0	55675	\N
27110	7651	58	0	56508	\N
27110	1021	126	0	56520	\N
27110	7652	127	0	56521	\N
27036	793	4	0	56702	\N
27036	3618	5	0	56709	\N
27015	913	1	0	57367	\N
27015	852	4	0	57375	\N
27015	4236	5	0	57378	\N
27024	2636	3	0	58813	\N
27024	2837	4	0	58815	\N
27119	2782	3	0	59383	\N
27119	3659	4	0	59384	\N
26973	3628	3	0	59729	\N
26973	3785	4	0	59741	\N
26909	4088	3	0	59858	\N
26909	4506	4	0	59863	\N
26944	4233	3	0	60124	\N
26944	4425	4	0	60126	\N
26935	4787	3	0	60352	\N
26935	4788	4	0	60354	\N
26948	6723	3	0	60872	\N
26948	6724	4	0	60873	\N
27038	6723	5	0	60878	\N
27038	7631	6	0	60883	\N
26969	6765	3	0	60935	\N
26969	6884	4	0	60938	\N
26952	7412	3	0	61031	\N
26965	7412	3	0	61032	\N
26952	7466	4	0	61033	\N
26965	7466	4	0	61034	\N
27043	7412	5	0	61035	\N
27043	7519	6	0	61036	\N
27039	7632	5	0	1902	\N
26912	2995	4	0	2600	\N
27030	7629	33	0	3912	\N
27034	262	2	0	3927	\N
27034	2743	3	0	3929	\N
27030	7630	34	0	3932	\N
27120	262	3	0	3947	\N
27120	4778	4	0	3949	\N
27003	365	3	0	4625	\N
27003	3839	4	0	4626	\N
26887	4178	4	0	7549	\N
26887	4205	5	0	7552	\N
26923	4178	3	0	7563	\N
26940	4178	3	0	7566	\N
26940	4211	4	0	7570	\N
26993	4178	3	0	7577	\N
26995	4178	3	0	7578	\N
26993	4211	4	0	7579	\N
26995	4211	4	0	7580	\N
27056	4178	6	0	7589	\N
27056	4250	7	0	7590	\N
27122	4178	5	0	7603	\N
27122	4202	6	0	7604	\N
26904	4172	3	0	9638	\N
26904	4275	4	0	9640	\N
26925	4275	4	0	9643	\N
27012	4172	6	0	9646	\N
27012	4197	7	0	9648	\N
27017	4172	2	0	9649	\N
27017	4191	3	0	9650	\N
27084	391	6	0	10491	\N
27084	3521	7	0	10492	\N
26983	132	6	0	11429	\N
26983	4690	7	0	11431	\N
26949	123	3	0	12798	\N
26949	2856	4	0	12807	\N
26898	77	11	0	13186	\N
27103	6600	7	0	13188	\N
26898	7613	12	0	13189	\N
27125	58	3	0	13641	\N
27125	3665	4	0	13642	\N
26933	233	6	0	13913	\N
26933	4245	7	0	13917	\N
26917	44	3	0	16163	\N
26917	3631	4	0	16164	\N
26908	38	3	0	16493	\N
26962	38	5	0	16494	\N
26908	3457	4	0	16496	\N
26962	5398	6	0	16498	\N
26913	3483	4	0	16759	\N
26968	212	3	0	17141	\N
26968	3639	4	0	17150	\N
27019	142	2	0	18616	\N
27019	4418	3	0	18618	\N
27030	3265	34	0	18765	\N
26996	60	8	0	19529	\N
26996	7625	9	0	19530	\N
27100	488	6	0	21568	\N
27100	7325	7	0	21570	\N
27059	67	3	0	22179	\N
27059	3749	4	0	22180	\N
27033	3632	4	0	23627	\N
27112	206	2	0	25740	\N
27112	2773	3	0	25741	\N
26946	1099	3	0	26271	\N
26946	7348	4	0	26273	\N
26903	320	3	0	29328	\N
26903	4821	4	0	29331	\N
26915	33	2	0	31866	\N
26915	2822	3	0	31868	\N
26938	4	3	0	36069	\N
26938	3837	4	0	36072	\N
26988	6	3	0	36377	\N
26918	14	6	0	39429	\N
26918	6277	7	0	39431	\N
26930	6015	8	0	40516	\N
26930	18	10	0	40517	\N
26930	1426	11	0	40518	\N
26896	7612	9	0	40873	\N
26896	23	10	0	40880	\N
26884	40	3	0	41576	\N
26884	372	4	0	41579	\N
26931	40	6	0	41593	\N
26931	4255	7	0	41596	\N
26950	40	3	0	41601	\N
26950	372	4	0	41604	\N
26953	3381	5	0	41605	\N
27079	71	3	0	44842	\N
27079	3770	4	0	44844	\N
27149	1427	1	0	45113	\N
27047	75	6	0	45138	\N
27149	75	5	0	45140	\N
27149	7658	6	1	45142	\N
27047	4694	7	0	45148	\N
26954	79	4	0	46705	\N
26954	3678	5	0	46706	\N
27004	79	3	0	46772	\N
27159	79	3	0	46773	\N
27004	3652	4	0	46774	\N
27159	3652	4	0	46775	\N
27094	88	3	0	47270	\N
27094	3655	4	0	47271	\N
27013	103	1	0	48045	\N
27013	102	4	0	48058	\N
27013	3574	5	0	48061	\N
27161	121	3	0	48994	\N
27161	4471	4	0	48998	\N
27106	4148	3	0	50741	\N
27106	170	4	0	50753	\N
26963	181	5	0	51004	\N
26963	7620	6	0	51005	\N
27098	200	0	0	51639	\N
27127	210	3	0	51979	\N
27127	3539	4	0	51980	\N
27062	273	8	0	53097	\N
27062	7638	9	0	53098	\N
27133	1109	3	0	56118	\N
27134	1109	2	0	56119	\N
27134	7654	3	0	56128	\N
27133	3495	4	0	56130	\N
27007	841	6	0	57070	\N
27007	3769	7	0	57071	\N
26978	3612	3	0	57368	\N
26978	852	4	0	57377	\N
26971	3625	3	0	59574	\N
26971	3784	4	0	59575	\N
26992	6450	3	0	60787	\N
26992	6847	4	0	60804	\N
26997	7626	9	0	70	\N
27057	6895	7	0	401	\N
27144	734	8	0	1100	\N
27144	7656	9	0	1101	\N
27150	7660	62	0	1544	\N
27150	251	126	0	1559	\N
27150	7661	127	0	1560	\N
27164	367	6	0	3478	\N
27164	7665	7	0	3479	\N
26960	262	7	0	3910	\N
26960	4093	8	0	3911	\N
26926	365	3	0	4618	\N
26926	3839	4	0	4620	\N
26980	3143	3	0	4983	\N
27052	189	1	0	4994	\N
27052	7294	2	0	4995	\N
27146	1599	3	0	5235	\N
27146	7657	4	0	5236	\N
26919	4178	6	0	7558	\N
26919	4250	7	0	7560	\N
26922	4178	3	0	7561	\N
26922	4211	4	0	7562	\N
26942	4178	9	0	7567	\N
26942	4682	10	0	7571	\N
26986	4178	3	0	7574	\N
27101	4178	6	0	7595	\N
27101	4250	7	0	7596	\N
27104	4211	3	0	7597	\N
27104	4178	4	0	7598	\N
27128	4178	3	0	7605	\N
27130	4178	9	0	7606	\N
27128	4211	4	0	7607	\N
27130	4682	10	0	7608	\N
27139	4178	3	0	7609	\N
27139	4211	4	0	7610	\N
27153	4450	1	0	7611	\N
27153	4178	13	0	7613	\N
26928	4172	3	0	9642	\N
26928	4275	4	0	9644	\N
27022	4172	3	0	9652	\N
27022	4275	4	0	9654	\N
27074	4172	3	0	9656	\N
27074	4275	4	0	9658	\N
27123	4172	5	0	9661	\N
27123	4634	6	0	9666	\N
27152	7662	1	0	11998	\N
27152	5399	13	0	12000	\N
27152	7663	14	0	12002	\N
27040	123	5	0	12799	\N
27142	2856	4	0	12808	\N
27040	6652	6	0	12812	\N
26929	7616	8	0	15154	\N
26929	92	10	0	15170	\N
26929	1078	11	0	15171	\N
27069	7644	127	0	16986	\N
27067	213	1	0	17120	\N
27067	212	7	0	17147	\N
27067	6675	8	0	17153	\N
27069	7643	101	0	17178	\N
27069	212	126	0	17190	\N
27020	142	3	0	18617	\N
27131	142	9	0	18633	\N
27131	7653	10	0	18636	\N
27069	3108	127	1	18790	\N
27055	241	8	0	20571	\N
27055	4832	9	0	20576	\N
27149	4098	8	0	21973	\N
26921	73	3	0	22600	\N
26921	3040	4	0	22603	\N
26976	4189	3	0	23176	\N
27162	149	3	0	23189	\N
26976	149	4	0	23190	\N
27149	7659	7	0	24932	\N
27108	3596	4	0	25330	\N
27115	224	4	0	25550	\N
27115	3281	5	0	25553	\N
27001	244	2	0	27307	\N
27001	3308	3	0	27313	\N
26999	449	3	0	29903	\N
26999	4760	4	0	29904	\N
26994	20	3	0	30501	\N
26994	2844	4	0	30502	\N
27147	202	3	0	31110	\N
27147	4857	4	0	31114	\N
27054	360	8	0	31461	\N
27140	360	3	0	31483	\N
27140	3602	4	0	31487	\N
26989	33	6	0	31877	\N
26989	7330	7	0	31878	\N
27076	230	5	0	32131	\N
27076	7647	6	0	32133	\N
26941	453	9	0	32923	\N
26941	7617	10	0	32924	\N
27085	453	6	0	32927	\N
27085	4091	7	0	32930	\N
26916	4	3	0	36068	\N
26916	3837	4	0	36071	\N
27081	3621	4	0	40521	\N
27091	18	3	0	40523	\N
27091	3621	4	0	40524	\N
27135	18	3	0	40527	\N
27145	18	8	0	40528	\N
27135	3621	4	0	40530	\N
27145	6015	9	0	40532	\N
26936	40	3	0	41594	\N
26936	372	4	0	41595	\N
26920	56	71	0	44649	\N
26920	7615	72	0	44650	\N
26974	3652	3	0	46707	\N
26974	7623	4	0	46744	\N
27184	81	1	0	46777	\N
27184	79	7	0	46805	\N
27184	5993	8	0	46807	\N
27025	88	3	0	47259	\N
27025	3655	4	0	47263	\N
26972	119	3	0	48597	\N
26972	2860	4	0	48602	\N
26945	121	3	0	48975	\N
26945	4471	4	0	48976	\N
27011	121	3	0	48993	\N
27171	121	3	0	48995	\N
27011	4471	4	0	48997	\N
27171	4471	4	0	48999	\N
27029	135	4	0	49525	\N
27029	4353	5	0	49533	\N
26977	4594	3	0	50423	\N
26977	156	4	0	50425	\N
27060	170	3	0	50738	\N
27060	4148	4	0	50739	\N
27107	4148	3	0	50742	\N
27107	7650	4	0	50752	\N
27188	170	3	0	50758	\N
27188	4148	4	0	50763	\N
27075	200	3	0	51637	\N
27075	3338	4	0	51642	\N
26961	285	7	0	53637	\N
27129	285	3	0	53638	\N
27129	4496	4	0	53639	\N
26961	7619	8	0	53644	\N
27072	7645	2	0	54943	\N
27065	7640	2	0	55527	\N
27167	1109	3	0	56120	\N
27167	3495	4	0	56131	\N
27027	7627	58	0	56494	\N
27027	1021	126	0	56505	\N
27027	7628	127	0	56506	\N
27037	793	3	0	56703	\N
27037	2644	4	0	56706	\N
26939	908	3	0	57779	\N
26939	3591	4	0	57780	\N
27048	2636	6	0	58820	\N
27048	5080	7	0	58821	\N
26932	4088	6	0	59871	\N
26932	4246	7	0	59872	\N
27070	4787	6	0	60356	\N
27070	5075	7	0	60358	\N
27008	5885	6	0	60528	\N
27008	5997	7	0	60534	\N
27138	6751	0	0	60577	\N
27065	7639	1	0	60934	\N
27065	7641	2	0	60937	\N
27148	7412	3	0	61046	\N
27148	7466	4	0	61047	\N
27107	7649	4	0	61209	\N
27183	7667	8	1	61286	\N
27169	2224	6	0	69	\N
27180	251	126	0	1578	\N
27180	7661	127	0	1579	\N
27045	367	3	0	3468	\N
27045	3683	4	0	3469	\N
27165	367	3	0	3476	\N
27165	3683	4	0	3477	\N
27072	7646	2	0	3924	\N
27072	2743	3	0	3925	\N
27031	262	3	0	3926	\N
27031	4778	4	0	3930	\N
26927	4178	3	0	7565	\N
26943	4178	13	0	7568	\N
26943	4782	14	0	7572	\N
27018	4178	3	0	7585	\N
27018	4211	4	0	7587	\N
27118	4178	3	0	7601	\N
27118	4211	4	0	7602	\N
27157	4178	6	0	7616	\N
27157	4250	7	0	7617	\N
27174	4178	3	0	7620	\N
27174	4211	4	0	7621	\N
27183	7666	8	0	8144	\N
27021	4172	3	0	9651	\N
27021	4275	4	0	9653	\N
27136	4172	3	0	9662	\N
27077	4275	4	0	9663	\N
27136	4275	4	0	9665	\N
27160	4172	9	0	9669	\N
27160	4977	10	0	9670	\N
27183	4201	1	0	9671	\N
27178	4172	6	0	9672	\N
27183	4172	7	0	9674	\N
27178	4197	7	0	9676	\N
26966	391	3	0	10480	\N
26966	3660	4	0	10481	\N
27089	391	3	0	10499	\N
27191	108	3	0	11839	\N
27191	4171	4	0	11842	\N
27102	58	6	0	13640	\N
27102	3575	7	0	13643	\N
26984	92	3	0	15166	\N
26985	92	2	0	15167	\N
26985	3060	3	0	15168	\N
26984	4410	4	0	15169	\N
27014	193	1	0	15323	\N
27014	192	4	0	15330	\N
27014	2193	5	0	15333	\N
27126	326	3	0	17476	\N
26958	167	3	0	17804	\N
26958	4028	4	0	17805	\N
27095	142	3	0	18632	\N
27095	4254	4	0	18635	\N
26974	3265	4	0	18764	\N
27086	208	6	0	19282	\N
27086	5118	7	0	19297	\N
26955	62	4	0	19842	\N
26955	4059	5	0	19847	\N
27066	153	1	0	21964	\N
27066	145	7	0	21970	\N
27066	4391	8	0	21972	\N
26947	4189	4	0	23174	\N
27175	82	3	0	23777	\N
27175	4505	4	0	23778	\N
26937	6303	3	0	26368	\N
26937	6304	4	0	26371	\N
26924	86	3	0	26479	\N
26924	3746	4	0	26480	\N
27111	86	2	0	26483	\N
27111	3321	3	0	26487	\N
27189	320	2	0	29343	\N
27189	4528	3	0	29344	\N
27138	7655	0	0	31489	\N
26981	5832	8	0	32926	\N
27172	453	3	0	32928	\N
27172	2838	4	0	32929	\N
27170	6	5	0	36383	\N
27170	2852	6	0	36385	\N
26934	18	6	0	40519	\N
26934	4180	7	0	40522	\N
27035	40	4	0	41611	\N
27035	3381	5	0	41612	\N
27050	40	3	0	41617	\N
27113	40	3	0	41618	\N
27050	372	4	0	41620	\N
27177	40	6	0	41628	\N
27177	4255	7	0	41630	\N
27187	40	3	0	41645	\N
27187	372	4	0	41648	\N
27041	7634	43	1	44014	\N
27041	7633	38	0	44651	\N
27041	56	41	0	44658	\N
26956	3887	5	0	44845	\N
27151	75	2	0	45158	\N
27151	2989	3	0	45159	\N
27204	88	7	0	47280	\N
27204	4949	8	0	47285	\N
27016	103	1	0	48046	\N
27016	102	4	0	48059	\N
27016	3574	5	0	48062	\N
27000	113	2	0	48324	\N
27000	1899	3	0	48326	\N
27092	156	3	0	50424	\N
27092	4594	4	0	50426	\N
27181	156	3	0	50427	\N
27181	4594	4	0	50428	\N
27090	186	3	0	51331	\N
27090	4294	4	0	51333	\N
27099	200	0	0	51640	\N
27209	268	3	0	52662	\N
27209	3815	4	0	52668	\N
27078	324	3	0	54335	\N
27078	4514	4	0	54337	\N
26990	597	3	0	55918	\N
26990	3656	4	0	55925	\N
27216	2435	71	0	57962	\N
26987	2351	2	0	59070	\N
26987	4711	3	0	59071	\N
26964	4233	3	0	60125	\N
26964	4425	4	0	60127	\N
27193	4233	6	0	60128	\N
27193	6364	7	0	60129	\N
27071	4787	6	0	60357	\N
27071	5075	7	0	60359	\N
27219	7677	9	0	60838	\N
27219	7678	10	0	60841	\N
27141	6723	3	0	60879	\N
27141	6724	4	0	60881	\N
27068	7642	1	0	61037	\N
27114	7412	2	0	61038	\N
27114	7529	3	0	61039	\N
27068	7412	7	0	61040	\N
27068	7519	8	0	61041	\N
27137	7412	3	0	61042	\N
27143	7412	3	0	61043	\N
27137	7466	4	0	61044	\N
27143	7466	4	0	61045	\N
27179	7412	6	0	61048	\N
27179	7507	7	0	61049	\N
27192	12	3	0	398	\N
27049	6895	7	0	400	\N
27230	424	3	0	830	\N
27042	6146	5	0	1901	\N
27042	7635	6	0	1904	\N
27044	367	14	0	3467	\N
27044	7636	15	0	3470	\N
27073	262	3	0	3928	\N
27073	4778	4	0	3931	\N
27087	7225	6	0	4044	\N
27087	7379	7	0	4051	\N
27061	35	6	0	4271	\N
27041	7250	43	0	5238	\N
26959	4178	16	0	7573	\N
26959	4708	17	0	7576	\N
27005	4178	6	0	7581	\N
27009	4178	3	0	7582	\N
27009	4211	4	0	7583	\N
27005	4250	7	0	7584	\N
27046	4178	6	0	7586	\N
27046	4250	7	0	7588	\N
27063	4178	3	0	7591	\N
27063	4211	4	0	7592	\N
27082	4178	3	0	7593	\N
27082	4211	4	0	7594	\N
27109	4211	4	0	7600	\N
27154	4178	6	0	7612	\N
27154	5854	7	0	7614	\N
27163	4178	3	0	7618	\N
27163	4211	4	0	7619	\N
27197	4178	3	0	7622	\N
27197	4211	4	0	7623	\N
27223	4178	3	0	7626	\N
27223	4211	4	0	7628	\N
26967	4172	3	0	9645	\N
26967	4275	4	0	9647	\N
27051	4172	3	0	9655	\N
27096	4172	3	0	9660	\N
27096	4275	4	0	9664	\N
27155	4172	3	0	9667	\N
27155	4275	4	0	9668	\N
27214	391	21	0	10507	\N
27214	7673	22	0	10510	\N
27216	7676	71	1	14574	\N
27195	7668	36	0	14723	\N
27195	173	126	0	14736	\N
27195	7669	127	0	14737	\N
27216	7675	36	0	14738	\N
27216	173	70	0	14745	\N
27121	4693	7	0	16760	\N
26970	7621	101	0	17157	\N
26970	212	126	0	17177	\N
26970	7622	127	0	17183	\N
27041	973	42	1	18369	\N
26957	62	3	0	19843	\N
26957	7618	4	0	19845	\N
27023	198	3	0	20097	\N
27173	198	3	0	20098	\N
27023	4263	4	0	20100	\N
27173	4263	4	0	20101	\N
26982	64	9	0	20766	\N
26979	1103	3	0	21563	\N
26979	488	4	0	21569	\N
27041	6025	42	0	21720	\N
26970	1075	127	1	21958	\N
27221	4505	3	0	23780	\N
27221	82	4	0	23794	\N
27116	224	3	0	25551	\N
27116	3603	4	0	25552	\N
27190	224	3	0	25576	\N
27190	3603	4	0	25580	\N
27080	1563	8	0	27101	\N
27080	94	45	0	27104	\N
27199	244	5	0	27308	\N
27201	244	2	0	27309	\N
27201	7671	3	0	27312	\N
27199	7670	6	0	27316	\N
27083	42	10	0	27649	\N
27083	6734	11	0	27652	\N
27053	360	17	0	31460	\N
27053	7637	18	0	31463	\N
27058	33	3	0	31891	\N
27132	33	3	0	31892	\N
27058	3342	4	0	31893	\N
27132	3342	4	0	31894	\N
27032	3548	4	0	35042	\N
27093	18	6	0	40525	\N
27093	4180	7	0	40526	\N
27196	18	6	0	40529	\N
27196	4180	7	0	40531	\N
27002	40	4	0	41603	\N
27002	3381	5	0	41606	\N
27124	40	3	0	41619	\N
27124	372	4	0	41622	\N
27158	40	6	0	41627	\N
27158	4255	7	0	41629	\N
27185	40	3	0	41639	\N
26956	71	4	0	44841	\N
27269	75	63	0	45174	\N
27269	2610	64	0	45177	\N
27423	4207	29	0	45245	\N
27423	75	42	0	45254	\N
27182	81	1	0	46776	\N
27182	79	7	0	46804	\N
27182	5993	8	0	46806	\N
27205	79	3	0	46836	\N
27205	3652	4	0	46837	\N
27256	79	3	0	46857	\N
27256	3652	4	0	46858	\N
27403	125	3	0	49337	\N
27403	4170	4	0	49342	\N
27385	135	3	0	49574	\N
27385	3630	4	0	49576	\N
27264	268	3	0	52663	\N
27264	3815	4	0	52669	\N
27324	273	3	0	53110	\N
27324	3638	4	0	53113	\N
27337	285	3	0	53677	\N
27337	4496	4	0	53678	\N
27229	324	6	0	54346	\N
27229	5241	7	0	54347	\N
27296	451	3	0	55367	\N
27296	3934	4	0	55369	\N
27213	7672	91	1	56379	\N
27213	7627	58	0	56522	\N
27213	1021	90	0	56536	\N
27327	7701	3	0	56700	\N
27327	2644	4	0	56701	\N
27323	908	3	0	57781	\N
27323	3591	4	0	57782	\N
27213	2171	91	0	58097	\N
27273	2636	6	0	58824	\N
27273	5080	7	0	58825	\N
27408	4088	3	0	59891	\N
27422	4088	9	0	59893	\N
27408	4506	4	0	59897	\N
27422	7711	10	0	59901	\N
27224	7681	4	0	60572	\N
27246	6751	2	0	60578	\N
27246	6153	1	0	60675	\N
27356	6044	9	0	60677	\N
27246	7686	2	0	60679	\N
27356	7702	10	0	60682	\N
27373	7412	3	0	61050	\N
27373	7466	4	0	61051	\N
27392	228	3	0	2871	\N
27392	3186	4	0	2881	\N
27398	3186	4	0	2882	\N
27306	365	3	0	4641	\N
27306	3839	4	0	4642	\N
27284	7696	126	1	5303	\N
27284	7695	97	0	5388	\N
27284	373	125	0	5399	\N
27217	4178	9	0	7624	\N
27217	4682	10	0	7625	\N
27239	4178	9	0	7627	\N
27239	4682	10	0	7629	\N
27242	4178	4	0	7630	\N
27268	4211	4	0	7632	\N
27242	4205	5	0	7633	\N
27318	4178	6	0	7639	\N
27345	4178	3	0	7640	\N
27345	4211	4	0	7642	\N
27318	4250	7	0	7643	\N
27379	4178	3	0	7644	\N
27379	4211	4	0	7647	\N
27202	4172	3	0	9673	\N
27202	4275	4	0	9675	\N
27215	4172	21	0	9677	\N
27215	7674	22	0	9678	\N
27276	4275	4	0	9691	\N
27395	391	15	0	10535	\N
27395	2680	16	0	10536	\N
27233	132	3	0	11437	\N
27235	132	1	0	11438	\N
27235	455	2	0	11440	\N
27233	3729	4	0	11441	\N
27410	132	3	0	11449	\N
27410	3729	4	0	11456	\N
27198	300	5	0	12183	\N
27198	6057	6	0	12184	\N
27327	7699	3	0	12344	\N
27417	3665	4	0	13661	\N
27421	233	9	0	13951	\N
27421	7710	10	0	13955	\N
27224	7679	3	0	18219	\N
27423	6698	43	0	18400	\N
27284	973	126	0	18404	\N
27423	3108	44	1	18744	\N
27321	6412	6	0	20577	\N
27321	241	7	0	20590	\N
27284	4098	127	0	21974	\N
27281	145	9	0	21983	\N
27281	7692	10	0	21984	\N
27332	4908	4	0	21989	\N
27287	73	2	0	22601	\N
27287	2766	3	0	22602	\N
27162	4189	4	0	23191	\N
27371	411	3	0	25337	\N
27371	3596	4	0	25338	\N
27176	224	3	0	25567	\N
27176	3603	4	0	25568	\N
27186	224	2	0	25575	\N
27186	3150	3	0	25579	\N
27237	206	2	0	25747	\N
27237	2773	3	0	25749	\N
27405	4075	4	0	27315	\N
27200	42	5	0	27665	\N
27361	42	9	0	27667	\N
27200	7172	6	0	27669	\N
27361	7706	10	0	27670	\N
27168	320	3	0	29329	\N
27168	4821	4	0	29332	\N
27352	54	9	0	30226	\N
27352	5922	10	0	30227	\N
27257	20	0	0	30515	\N
27260	20	0	0	30517	\N
27224	7682	4	1	31266	\N
27222	3342	3	0	31896	\N
27222	33	4	0	31904	\N
27166	230	3	0	32142	\N
27166	4181	4	0	32144	\N
27249	322	3	0	32378	\N
27249	1105	4	0	32381	\N
27341	322	3	0	32385	\N
27341	1105	4	0	32389	\N
27263	2	2	0	35055	\N
27263	2789	3	0	35057	\N
27374	2	15	0	35158	\N
27374	1566	16	0	35159	\N
27210	3837	4	0	36079	\N
27382	18	9	0	40535	\N
27382	4047	10	0	40536	\N
27194	40	2	0	41646	\N
27194	282	3	0	41647	\N
27207	40	5	0	41655	\N
27207	2714	6	0	41656	\N
27228	40	6	0	41663	\N
27253	40	3	0	41664	\N
27255	40	3	0	41665	\N
27253	372	4	0	41669	\N
27255	372	4	0	41670	\N
27368	40	3	0	41721	\N
27368	372	4	0	41723	\N
27358	71	9	0	44860	\N
27452	71	3	0	44861	\N
27452	3770	4	0	44862	\N
27358	7704	10	0	44863	\N
27456	71	3	0	44873	\N
27456	3770	4	0	44874	\N
27267	75	0	0	45165	\N
27367	75	62	0	45243	\N
27367	7012	63	0	45244	\N
27336	79	9	0	46871	\N
27336	3758	10	0	46872	\N
27381	100	9	0	47655	\N
27381	7708	10	0	47657	\N
27376	125	6	0	49327	\N
27376	6951	7	0	49331	\N
27386	137	3	0	49832	\N
27386	3633	4	0	49833	\N
27425	137	9	0	49841	\N
27425	5190	10	0	49848	\N
27406	156	3	0	50429	\N
27406	4594	4	0	50430	\N
27438	170	1	0	50750	\N
27438	1072	2	0	50751	\N
27443	170	1	0	50760	\N
27443	1072	2	0	50762	\N
27240	170	2	0	50775	\N
27444	170	1	0	50776	\N
27444	1072	2	0	50777	\N
27240	1380	3	0	50778	\N
27442	170	7	0	50789	\N
27442	4591	8	0	50791	\N
27297	181	6	0	51015	\N
27297	4256	7	0	51018	\N
27212	186	3	0	51332	\N
27212	4294	4	0	51334	\N
27271	186	3	0	51351	\N
27271	4294	4	0	51354	\N
27275	200	3	0	51641	\N
27275	3338	4	0	51643	\N
27437	200	3	0	51652	\N
27437	3338	4	0	51653	\N
27427	268	3	0	52665	\N
27427	3815	4	0	52671	\N
27308	273	3	0	53109	\N
27308	3638	4	0	53112	\N
27295	451	1	0	55366	\N
27295	3260	2	0	55368	\N
27423	5889	44	0	58094	\N
27370	4088	3	0	59890	\N
27414	4088	3	0	59892	\N
27450	4088	6	0	59894	\N
27370	4506	4	0	59896	\N
27414	4506	4	0	59898	\N
27450	4246	7	0	59900	\N
27211	5885	3	0	60529	\N
27211	5926	4	0	60532	\N
27383	5885	3	0	60538	\N
27383	5926	4	0	60541	\N
27225	6692	4	1	60573	\N
27247	6044	3	0	60676	\N
27247	6045	4	0	60680	\N
27440	6765	7	0	60936	\N
27440	6861	8	0	60939	\N
27390	7412	6	0	61052	\N
27390	7507	7	0	61053	\N
27206	3611	4	0	831	\N
27428	3611	4	0	863	\N
27292	266	2	0	1261	\N
27292	2103	3	0	1262	\N
27436	367	3	0	3492	\N
27436	3683	4	0	3496	\N
27231	365	3	0	4633	\N
27231	3839	4	0	4634	\N
27360	7705	11	0	4636	\N
27360	365	13	0	4644	\N
27360	1424	14	0	4646	\N
27415	365	3	0	4654	\N
27415	3839	4	0	4656	\N
27317	4211	4	0	7641	\N
27388	4178	6	0	7645	\N
27388	4250	7	0	7649	\N
27432	4178	3	0	7655	\N
27432	4211	4	0	7657	\N
27446	4178	6	0	7660	\N
27446	4250	7	0	7663	\N
27218	4172	9	0	9679	\N
27218	4977	10	0	9682	\N
27245	4172	3	0	9683	\N
27245	4275	4	0	9684	\N
27259	4172	3	0	9685	\N
27401	4172	3	0	9705	\N
27401	4275	4	0	9707	\N
27434	4172	3	0	9709	\N
27434	4275	4	0	9712	\N
27243	391	4	0	10519	\N
27347	391	3	0	10520	\N
27347	3660	4	0	10522	\N
27243	3913	5	0	10523	\N
27378	132	3	0	11439	\N
27378	3729	4	0	11442	\N
27419	528	3	0	12617	\N
27419	4262	4	0	12625	\N
27448	233	6	0	13952	\N
27413	3704	4	0	13953	\N
27448	4245	7	0	13954	\N
27225	7685	5	0	14002	\N
27457	44	3	0	16181	\N
27457	3631	4	0	16184	\N
27277	38	3	0	16495	\N
27277	3457	4	0	16497	\N
27329	326	3	0	17504	\N
27329	3339	4	0	17507	\N
27325	30	3	0	18176	\N
27325	3640	4	0	18180	\N
27225	7684	4	0	19346	\N
27225	7683	3	0	19539	\N
27298	241	6	0	20573	\N
27298	6412	7	0	20575	\N
27305	64	3	0	20775	\N
27305	4217	4	0	20776	\N
27423	1075	45	0	21975	\N
27203	145	7	0	21978	\N
27203	4861	8	0	21979	\N
27430	140	3	0	24110	\N
27430	4149	4	0	24115	\N
27261	20	0	0	30518	\N
27365	7707	4	0	30918	\N
27314	202	6	0	31111	\N
27314	4079	7	0	31115	\N
27226	360	3	0	31484	\N
27226	3602	4	0	31488	\N
27220	3342	3	0	31895	\N
27220	33	4	0	31903	\N
27389	453	6	0	32932	\N
27389	4091	7	0	32934	\N
27346	2	3	0	35126	\N
27346	3548	4	0	35128	\N
27208	4	0	0	36070	\N
27309	23	3	0	40878	\N
27309	3497	4	0	40879	\N
27251	7687	79	0	41165	\N
27250	27	3	0	41181	\N
27250	4636	4	0	41186	\N
27251	27	126	0	41190	\N
27251	7688	127	0	41191	\N
27333	40	4	0	41710	\N
27333	3381	5	0	41711	\N
27455	40	3	0	41738	\N
27455	372	4	0	41743	\N
27270	7689	42	0	44973	\N
27270	4694	24	0	45178	\N
27270	75	40	0	45193	\N
27289	75	1	0	45233	\N
27289	1427	2	0	45234	\N
27484	100	24	0	47668	\N
27484	7734	25	0	47669	\N
27304	102	3	0	48068	\N
27304	3597	4	0	48076	\N
27424	135	9	0	49575	\N
27424	5189	10	0	49577	\N
27441	170	1	0	50759	\N
27441	1072	2	0	50761	\N
27375	186	15	0	51352	\N
27375	621	16	0	51356	\N
27335	242	3	0	52224	\N
27335	2839	4	0	52225	\N
27495	273	3	0	53119	\N
27495	3638	4	0	53121	\N
27252	285	3	0	53662	\N
27252	4496	4	0	53663	\N
27362	451	3	0	55380	\N
27362	3934	4	0	55381	\N
27328	793	3	0	56704	\N
27399	793	3	0	56705	\N
27328	2644	4	0	56707	\N
27399	2644	4	0	56708	\N
27248	841	3	0	57077	\N
27248	3604	4	0	57078	\N
27279	2782	3	0	59387	\N
27279	3659	4	0	59388	\N
27265	5885	3	0	60537	\N
27426	5885	3	0	60539	\N
27265	5926	4	0	60540	\N
27426	5926	4	0	60542	\N
27270	6668	41	0	60563	\N
27270	7690	42	1	60598	\N
27285	7697	5	0	60842	\N
27285	7698	6	0	60843	\N
27447	7412	6	0	61054	\N
27447	7507	7	0	61056	\N
27241	2842	3	0	73	\N
27411	3003	4	0	84	\N
27254	12	3	0	411	\N
27254	4204	4	0	412	\N
27338	424	3	0	841	\N
27338	3611	4	0	842	\N
27396	424	6	0	849	\N
27396	3712	7	0	850	\N
27380	117	3	0	2065	\N
27380	3653	4	0	2066	\N
27350	1858	3	0	3034	\N
27350	4273	4	0	3035	\N
27453	262	3	0	3948	\N
27359	7705	11	0	4635	\N
27359	365	13	0	4643	\N
27359	1424	14	0	4645	\N
27429	4178	3	0	7654	\N
27429	4211	4	0	7656	\N
27433	4178	3	0	7658	\N
27433	4211	4	0	7659	\N
27471	4178	7	0	7668	\N
27471	7728	8	0	7670	\N
27506	4178	3	0	7682	\N
27506	4211	4	0	7683	\N
27244	4172	4	0	9680	\N
27266	4172	3	0	9687	\N
27266	4275	4	0	9688	\N
27294	4172	4	0	9690	\N
27294	4252	5	0	9692	\N
27302	4172	6	0	9693	\N
27302	4197	7	0	9694	\N
27343	4172	3	0	9695	\N
27343	4275	4	0	9696	\N
27372	4172	3	0	9699	\N
27400	4172	3	0	9701	\N
27372	4275	4	0	9702	\N
27400	4275	4	0	9703	\N
27418	4275	4	0	9708	\N
27480	4172	18	0	9710	\N
27236	391	3	0	10508	\N
27236	3660	4	0	10509	\N
27353	391	6	0	10521	\N
27353	3521	7	0	10524	\N
27464	132	5	0	11451	\N
27464	7504	6	0	11455	\N
27412	300	3	0	12189	\N
27412	3747	4	0	12190	\N
27465	300	8	0	12205	\N
27465	7724	9	0	12206	\N
27492	77	4	0	13195	\N
27478	7731	27	0	13196	\N
27492	7737	5	0	13230	\N
27369	233	3	0	13914	\N
27369	3704	4	0	13916	\N
27274	44	6	0	16175	\N
27348	44	3	0	16176	\N
27348	3631	4	0	16177	\N
27274	5989	7	0	16178	\N
27270	7691	43	0	18221	\N
27270	3108	43	1	18743	\N
27227	60	3	0	19540	\N
27330	62	3	0	19844	\N
27330	3344	4	0	19846	\N
27288	241	2	0	20572	\N
27288	634	3	0	20574	\N
27282	264	2	0	23625	\N
27282	3026	3	0	23626	\N
27458	264	14	0	23656	\N
27458	7718	15	0	23658	\N
27322	4086	6	0	24089	\N
27461	140	9	0	24111	\N
27461	7721	10	0	24116	\N
27322	140	7	0	24117	\N
27319	224	6	0	25578	\N
27232	3603	4	0	25581	\N
27319	7176	7	0	25582	\N
27364	224	4	0	25587	\N
27364	3806	5	0	25588	\N
27354	90	6	0	26145	\N
27354	7581	7	0	26150	\N
27357	6303	9	0	26369	\N
27357	7703	10	0	26373	\N
27234	42	3	0	27666	\N
27234	3645	4	0	27668	\N
27270	7570	41	1	30321	\N
27262	20	0	0	30519	\N
27258	2844	4	0	30521	\N
27307	151	3	0	30758	\N
27307	3046	4	0	30760	\N
27311	2	3	0	35056	\N
27311	3548	4	0	35058	\N
27316	2	3	0	35090	\N
27316	3548	4	0	35091	\N
27387	2	6	0	35181	\N
27387	4825	7	0	35183	\N
27469	14	8	0	39444	\N
27469	7727	9	0	39445	\N
27497	23	3	0	40891	\N
27497	3497	4	0	40892	\N
27299	40	3	0	41667	\N
27299	372	4	0	41671	\N
27488	2192	14	0	41724	\N
27451	40	3	0	41737	\N
27451	372	4	0	41742	\N
27488	40	28	0	41746	\N
27488	3381	29	0	41747	\N
16906	71	3	0	44900	\N
27283	75	10	0	45210	\N
27342	79	6	0	46895	\N
27342	4253	7	0	46896	\N
27449	79	6	0	46925	\N
27449	4253	7	0	46926	\N
27496	100	3	0	47675	\N
27496	3836	4	0	47679	\N
27511	113	3	0	48332	\N
27511	3620	4	0	48335	\N
27499	156	4	0	50431	\N
27499	5935	5	0	50432	\N
27445	530	1	0	51006	\N
27445	181	4	0	51016	\N
27384	268	3	0	52664	\N
27384	3815	4	0	52670	\N
27394	273	0	0	53111	\N
27435	273	3	0	53118	\N
27435	3638	4	0	53120	\N
27290	285	2	0	53673	\N
27290	3036	3	0	53674	\N
27409	316	3	0	54000	\N
27409	4249	4	0	54001	\N
27431	451	3	0	55397	\N
27431	3934	4	0	55398	\N
27476	1109	0	0	56121	\N
27291	2782	2	0	59391	\N
27291	2784	3	0	59395	\N
27483	4233	6	0	60130	\N
27483	7733	7	0	60131	\N
27523	7412	7	0	61055	\N
27523	7528	8	0	61057	\N
27513	7717	4	0	61300	\N
27339	3474	4	0	1272	\N
27466	7725	9	0	1858	\N
27513	248	1	0	2067	\N
27513	117	3	0	2074	\N
27300	228	3	0	2870	\N
27300	3186	4	0	2880	\N
27397	1463	3	0	4107	\N
27397	7709	4	0	4110	\N
27286	4178	2	0	7634	\N
27315	4178	3	0	7635	\N
27286	4247	3	0	7636	\N
27315	4211	4	0	7637	\N
27402	4178	3	0	7646	\N
27416	4178	3	0	7650	\N
27420	4178	9	0	7651	\N
27416	4211	4	0	7652	\N
27420	4682	10	0	7653	\N
27454	4178	3	0	7661	\N
27454	4211	4	0	7662	\N
27477	4178	26	0	7669	\N
27477	5160	27	0	7671	\N
27479	4178	8	0	7672	\N
27479	6776	9	0	7673	\N
27482	4178	9	0	7674	\N
27482	7720	10	0	7675	\N
27494	4250	7	0	7677	\N
27498	4178	4	0	7678	\N
27498	4205	5	0	7681	\N
27521	4178	4	0	7684	\N
27548	4178	6	0	7688	\N
27548	4250	7	0	7689	\N
27349	4172	3	0	9697	\N
27349	4275	4	0	9698	\N
27377	4172	6	0	9700	\N
27377	4197	7	0	9704	\N
27491	4172	3	0	9711	\N
27491	4275	4	0	9713	\N
27501	4172	3	0	9716	\N
27539	4172	3	0	9718	\N
27501	4275	4	0	9720	\N
27539	4275	4	0	9723	\N
27462	132	9	0	11450	\N
27462	7722	10	0	11459	\N
27541	108	3	0	11840	\N
27541	3255	4	0	11844	\N
27326	7699	3	0	12343	\N
27407	233	3	0	13934	\N
27407	3704	4	0	13935	\N
27283	7694	11	1	14010	\N
27547	44	9	0	16182	\N
27547	3765	10	0	16186	\N
27486	6191	14	0	16761	\N
27278	115	3	0	16772	\N
27278	3483	4	0	16773	\N
27486	115	28	0	16774	\N
27486	4844	29	0	16775	\N
27544	115	4	0	16783	\N
27544	6794	5	0	16789	\N
27439	212	7	0	17142	\N
27439	7713	8	0	17154	\N
27301	326	3	0	17490	\N
27326	7700	3	0	17502	\N
27326	3339	4	0	17503	\N
27487	6737	14	0	18620	\N
27489	6737	14	0	18621	\N
27487	142	28	0	18637	\N
27489	142	28	0	18638	\N
27487	3950	29	0	18639	\N
27489	3950	29	0	18640	\N
27363	198	3	0	20110	\N
27363	4263	4	0	20111	\N
27528	7741	87	0	20591	\N
27528	241	89	0	20604	\N
27504	145	3	0	22004	\N
27504	4908	4	0	22005	\N
27366	73	3	0	22615	\N
27366	3040	4	0	22618	\N
27331	264	3	0	23655	\N
27331	3632	4	0	23657	\N
27481	224	18	0	25595	\N
27481	7732	19	0	25596	\N
27503	224	6	0	25606	\N
27503	7176	7	0	25607	\N
27468	86	24	0	26484	\N
27468	7726	25	0	26490	\N
27404	4075	4	0	27314	\N
27391	96	3	0	29576	\N
27391	2803	4	0	29577	\N
27520	230	14	0	32143	\N
27520	1703	15	0	32145	\N
27303	322	3	0	32379	\N
27303	1105	4	0	32382	\N
27340	453	3	0	32931	\N
27340	2838	4	0	32933	\N
27517	453	3	0	32935	\N
27518	453	2	0	32936	\N
27518	3366	3	0	32937	\N
27560	431	4	0	34866	\N
27312	2	3	0	35069	\N
27312	3548	4	0	35070	\N
27344	2	3	0	35111	\N
27344	3548	4	0	35112	\N
27355	2	9	0	35127	\N
27355	3650	10	0	35129	\N
27509	14	9	0	39452	\N
27509	5082	10	0	39453	\N
27320	18	3	0	40533	\N
27320	3621	4	0	40534	\N
27293	40	2	0	41666	\N
27310	40	3	0	41689	\N
27310	372	4	0	41690	\N
27334	40	3	0	41720	\N
27334	372	4	0	41722	\N
27475	71	0	0	44883	\N
27493	79	4	0	46075	\N
27695	79	2	0	46158	\N
27695	616	3	0	46159	\N
27493	7738	5	0	46210	\N
27474	100	0	0	47656	\N
27527	100	2	0	47677	\N
27527	633	3	0	47678	\N
27676	156	4	0	50433	\N
27676	2843	5	0	50436	\N
27445	7715	6	1	51017	\N
27519	181	6	0	51031	\N
27519	4256	7	0	51032	\N
27672	181	2	0	51044	\N
27672	3245	3	0	51046	\N
27557	200	2	0	51656	\N
27557	3109	3	0	51658	\N
27578	242	1	0	52231	\N
27583	242	6	0	52232	\N
27578	2768	2	0	52233	\N
27583	7749	7	0	52234	\N
27582	242	0	0	52239	\N
27686	279	7	0	53280	\N
27686	7770	8	0	53285	\N
27619	316	3	0	54012	\N
27619	4249	4	0	54014	\N
27596	324	9	0	54354	\N
27596	7752	10	0	54355	\N
27608	324	12	0	54358	\N
27608	7755	13	0	54359	\N
27603	451	9	0	55412	\N
27603	7754	10	0	55413	\N
27621	852	1	0	57373	\N
27621	913	2	0	57376	\N
27534	2171	75	0	58095	\N
27505	1470	6	0	58327	\N
27505	6409	7	0	58328	\N
27647	1470	6	0	58340	\N
27647	6409	7	0	58341	\N
27697	2351	2	0	59077	\N
27697	2754	3	0	59078	\N
27534	3740	76	0	59478	\N
27592	4088	6	0	59895	\N
27592	7750	7	0	59899	\N
27553	6765	4	0	60940	\N
27553	7217	5	0	60944	\N
27626	7412	6	0	61058	\N
27688	7412	6	0	61059	\N
27626	7507	7	0	61060	\N
27688	7507	7	0	61061	\N
27445	7716	7	0	61288	\N
27445	7717	7	1	61299	\N
27537	7746	8	0	61388	\N
27515	117	4	0	2075	\N
27623	117	3	0	2086	\N
27623	3653	4	0	2087	\N
27532	35	3	0	4277	\N
27460	4178	9	0	7664	\N
27467	4178	24	0	7665	\N
27460	7720	10	0	7666	\N
27467	4297	25	0	7667	\N
27500	4178	3	0	7679	\N
27500	4211	4	0	7680	\N
27559	4178	4	0	7690	\N
27559	4205	5	0	7691	\N
27566	4178	3	0	7693	\N
27566	4211	4	0	7695	\N
27631	4178	3	0	7701	\N
27633	4178	3	0	7702	\N
27631	4211	4	0	7704	\N
27633	4211	4	0	7705	\N
27678	4178	3	0	7708	\N
27678	4211	4	0	7710	\N
27526	4172	3	0	9717	\N
27526	4275	4	0	9722	\N
27589	4172	2	0	9728	\N
27589	4191	3	0	9729	\N
27640	4172	12	0	9735	\N
27653	4275	4	0	9737	\N
27640	6408	13	0	9738	\N
27485	391	8	0	10544	\N
27485	7735	9	0	10545	\N
27564	391	3	0	10550	\N
27564	3660	4	0	10552	\N
27587	300	4	0	12211	\N
27587	2992	5	0	12213	\N
27602	528	6	0	12618	\N
27602	4824	7	0	12626	\N
27555	123	4	0	12801	\N
27555	4090	5	0	12811	\N
27605	1877	4	0	13206	\N
27543	58	4	0	13659	\N
27543	2781	5	0	13662	\N
27591	233	6	0	13962	\N
27591	6901	7	0	13970	\N
27473	402	7	0	14090	\N
27473	7730	8	0	14091	\N
27594	258	3	0	14456	\N
27534	7742	75	1	16943	\N
27643	212	12	0	17145	\N
27643	7761	13	0	17156	\N
27562	326	4	0	17505	\N
27507	142	15	0	18634	\N
27507	7010	16	0	18641	\N
27571	64	3	0	20797	\N
27571	4217	4	0	20805	\N
27445	7714	5	1	21642	\N
27463	140	6	0	24112	\N
27463	7723	7	0	24113	\N
27569	411	3	0	25341	\N
27569	3596	4	0	25342	\N
27702	206	6	0	25766	\N
27568	6303	6	0	26370	\N
27568	6438	7	0	26372	\N
27546	42	9	0	27679	\N
27502	3645	4	0	27681	\N
27546	7706	10	0	27685	\N
27490	96	10	0	29591	\N
27490	7736	11	0	29592	\N
27658	151	3	0	30759	\N
27658	3046	4	0	30761	\N
27651	7765	52	0	32939	\N
27651	453	126	0	32942	\N
27651	7766	127	0	32943	\N
27683	7768	52	0	32944	\N
27683	453	78	0	32947	\N
27472	431	7	0	34865	\N
27472	7729	8	0	34868	\N
27560	7609	5	0	34871	\N
27700	2	6	0	35212	\N
27700	4550	7	0	35222	\N
27574	14	3	0	39456	\N
27574	4272	4	0	39458	\N
27530	18	6	0	40539	\N
27530	4180	7	0	40540	\N
27580	18	6	0	40543	\N
27580	4180	7	0	40546	\N
27628	18	4	0	40547	\N
27550	23	3	0	40897	\N
27550	3497	4	0	40898	\N
27534	7743	76	1	40942	\N
27534	27	74	0	41210	\N
27508	40	15	0	41739	\N
27538	40	3	0	41740	\N
27575	40	3	0	41741	\N
27538	372	4	0	41744	\N
27575	372	4	0	41745	\N
27508	522	16	0	41748	\N
10430	71	3	0	44903	\N
27577	4645	24	0	45269	\N
27693	79	3	0	46101	\N
27693	3652	4	0	46102	\N
27713	79	4	0	46242	\N
27713	2758	5	0	46245	\N
27525	100	3	0	47676	\N
27525	3836	4	0	47680	\N
27561	102	4	0	48069	\N
27561	3572	5	0	48078	\N
27512	113	2	0	48333	\N
27512	1899	3	0	48334	\N
27661	113	3	0	48344	\N
27661	3620	4	0	48346	\N
27711	135	2	0	49597	\N
27711	2722	3	0	49604	\N
27754	242	2	0	52261	\N
27754	3425	3	0	52267	\N
27617	285	17	0	53681	\N
27617	7760	18	0	53682	\N
27639	597	0	0	55957	\N
27743	597	2	0	55958	\N
27743	3286	3	0	55960	\N
27666	793	3	0	56717	\N
27666	2644	4	0	56720	\N
27716	852	2	0	57389	\N
27733	852	2	0	57390	\N
27716	2872	3	0	57391	\N
27733	2872	3	0	57392	\N
27725	1470	4	0	58353	\N
27725	2798	5	0	58356	\N
27675	2636	3	0	58829	\N
27675	2837	4	0	58832	\N
27601	2782	0	0	59393	\N
27668	2782	3	0	59394	\N
27668	3659	4	0	59396	\N
27681	6044	3	0	60683	\N
27681	6045	4	0	60684	\N
27636	6450	0	0	60788	\N
27552	6723	4	0	60880	\N
27552	6739	5	0	60882	\N
27644	6765	12	0	60941	\N
27644	7762	13	0	60945	\N
27703	7412	8	0	61062	\N
27703	7773	9	0	61063	\N
27731	7412	2	0	61064	\N
27731	7430	3	0	61066	\N
27549	4204	4	0	424	\N
27516	1951	4	0	1072	\N
27516	7740	5	0	1073	\N
27540	262	3	0	3955	\N
27540	4778	4	0	3957	\N
27598	7753	7	0	4280	\N
27598	35	8	0	4287	\N
27745	1191	3	0	4293	\N
27684	189	0	0	5009	\N
27521	4205	5	0	7685	\N
27531	4178	2	0	7686	\N
27531	4247	3	0	7687	\N
27563	4178	3	0	7692	\N
27563	4211	4	0	7694	\N
27645	4178	4	0	7703	\N
27645	4331	5	0	7706	\N
27709	4178	2	0	7713	\N
27709	4247	3	0	7715	\N
27724	4178	3	0	7719	\N
27724	4441	4	0	7720	\N
27734	4178	6	0	7721	\N
27734	4358	7	0	7722	\N
27514	4201	1	0	9714	\N
27514	4172	4	0	9719	\N
27514	4285	5	0	9721	\N
27542	4252	5	0	9725	\N
27556	4172	3	0	9726	\N
27556	4275	4	0	9727	\N
27629	4172	6	0	9732	\N
27629	4197	7	0	9733	\N
27704	4172	10	0	9743	\N
27704	6603	11	0	9744	\N
27607	391	0	0	10566	\N
27611	4912	81	0	11627	\N
27588	300	6	0	12212	\N
27588	4875	7	0	12214	\N
27737	123	2	0	12802	\N
27654	1877	4	0	13222	\N
27595	58	9	0	13668	\N
27679	58	2	0	13669	\N
27679	2853	3	0	13671	\N
27595	7751	10	0	13673	\N
27551	7747	2	0	14108	\N
27551	2760	3	0	14109	\N
27593	235	3	0	15814	\N
27593	3343	4	0	15815	\N
27750	1656	2	0	16948	\N
27750	7779	3	0	16950	\N
27554	212	4	0	17143	\N
27554	3732	5	0	17152	\N
27641	7761	13	0	17155	\N
27691	1376	3	0	17958	\N
27691	4768	4	0	17962	\N
27535	60	7	0	19551	\N
27624	60	6	0	19552	\N
27624	6394	7	0	19554	\N
27535	7744	8	0	19556	\N
27611	7759	81	1	19680	\N
27611	7758	19	0	19848	\N
27611	62	80	0	19856	\N
27529	241	6	0	20596	\N
27565	64	3	0	20789	\N
27565	4217	4	0	20790	\N
27706	64	10	0	20799	\N
27706	7774	11	0	20810	\N
27558	67	2	0	22185	\N
27558	7748	3	0	22186	\N
27756	73	2	0	22616	\N
27756	2766	3	0	22617	\N
27524	69	3	0	24855	\N
27524	4536	4	0	24864	\N
27522	206	3	0	25748	\N
27522	4584	4	0	25750	\N
27720	7776	70	0	26136	\N
27718	90	2	0	26146	\N
27718	3442	3	0	26148	\N
27720	90	126	0	26152	\N
27720	7777	127	0	26153	\N
27729	42	4	0	27680	\N
27729	2821	5	0	27683	\N
27616	96	12	0	29597	\N
27616	5245	13	0	29602	\N
27510	678	3	0	30919	\N
27510	7707	4	0	30921	\N
27659	202	3	0	31130	\N
27722	322	2	0	32386	\N
27722	1866	3	0	32388	\N
27536	2	7	0	35182	\N
27536	5463	8	0	35184	\N
27656	2	3	0	35197	\N
27656	3548	4	0	35198	\N
27673	2	3	0	35211	\N
27673	3548	4	0	35220	\N
27545	18	9	0	40541	\N
27545	4047	10	0	40542	\N
27586	18	3	0	40544	\N
27586	3621	4	0	40545	\N
27648	27	6	0	41183	\N
27533	4636	4	0	41187	\N
27648	3715	7	0	41188	\N
20699	71	8	0	44951	\N
27572	4253	7	0	46076	\N
27663	79	8	0	46100	\N
27663	3701	9	0	46103	\N
27590	88	5	0	47281	\N
27590	5942	6	0	47284	\N
27614	113	3	0	48343	\N
27614	3620	4	0	48345	\N
27696	121	2	0	49009	\N
27698	121	99	0	49010	\N
27696	2498	3	0	49013	\N
27698	7771	100	0	49015	\N
27606	125	3	0	49338	\N
27747	125	4	0	49339	\N
27606	4170	4	0	49343	\N
27747	3356	5	0	49344	\N
27710	137	2	0	49842	\N
27710	2721	3	0	49845	\N
27677	156	3	0	50434	\N
27677	4594	4	0	50435	\N
27727	285	4	0	53686	\N
27727	5030	5	0	53691	\N
27630	324	3	0	54362	\N
27630	4514	4	0	54363	\N
27674	324	3	0	54368	\N
27674	4514	4	0	54370	\N
27637	595	0	0	55668	\N
27622	852	3	0	57374	\N
27622	3612	4	0	57379	\N
27689	4766	3	0	58523	\N
27689	4767	4	0	58524	\N
27670	2636	3	0	58828	\N
27707	2636	4	0	58830	\N
27670	2837	4	0	58831	\N
27707	7436	5	0	58833	\N
27600	2782	6	0	59392	\N
27600	5009	7	0	59397	\N
27627	4233	4	0	60132	\N
27627	4234	5	0	60133	\N
27655	6044	3	0	60678	\N
27655	6045	4	0	60681	\N
27742	6450	2	0	60789	\N
27742	6825	3	0	60799	\N
27736	6723	2	0	60884	\N
27736	6763	3	0	60890	\N
27649	7763	0	0	61306	\N
27634	424	3	0	862	\N
27730	424	2	0	873	\N
27730	2755	3	0	874	\N
27613	266	3	0	1277	\N
27613	3474	4	0	1278	\N
27669	266	3	0	1281	\N
27669	3474	4	0	1283	\N
27657	367	3	0	3493	\N
27657	3683	4	0	3497	\N
27599	262	6	0	3956	\N
27599	4248	7	0	3958	\N
27685	7769	8	1	4033	\N
27685	7225	7	0	4045	\N
27597	35	8	0	4286	\N
27579	4178	6	0	7696	\N
27579	4250	7	0	7697	\N
27604	4178	0	0	7698	\N
27615	4178	4	0	7699	\N
27615	4179	5	0	7700	\N
27671	4178	3	0	7707	\N
27671	4211	4	0	7709	\N
27694	4178	2	0	7711	\N
27705	4178	10	0	7712	\N
27694	4247	3	0	7714	\N
27705	6571	11	0	7716	\N
27717	4247	3	0	7718	\N
27625	4172	6	0	9730	\N
27625	4197	7	0	9731	\N
27638	4172	0	0	9734	\N
27665	4172	3	0	9739	\N
27665	4275	4	0	9740	\N
27680	4172	2	0	9741	\N
27680	4191	3	0	9742	\N
27753	4172	2	0	9748	\N
27753	4191	3	0	9750	\N
27758	4172	2	0	9751	\N
27758	4191	3	0	9754	\N
27581	3521	7	0	10553	\N
27687	391	6	0	10575	\N
27687	3521	7	0	10578	\N
27620	132	3	0	11452	\N
27620	3729	4	0	11457	\N
27685	4912	9	0	11607	\N
27584	58	4	0	13660	\N
27584	2781	5	0	13663	\N
27721	402	2	0	14116	\N
27721	2760	3	0	14117	\N
27594	4401	4	0	14459	\N
27585	44	4	0	16183	\N
27612	115	3	0	16784	\N
27612	3483	4	0	16787	\N
27728	326	4	0	17506	\N
27728	3362	5	0	17509	\N
27567	30	3	0	18177	\N
27660	30	3	0	18178	\N
27567	3640	4	0	18181	\N
27660	3640	4	0	18182	\N
27570	142	3	0	18652	\N
27570	4254	4	0	18654	\N
27708	60	6	0	19553	\N
27708	7775	7	0	19555	\N
27609	62	3	0	19854	\N
27609	3344	4	0	19855	\N
27610	62	126	0	19857	\N
27610	7757	127	0	19858	\N
27667	64	3	0	20798	\N
27667	4217	4	0	20806	\N
27576	164	3	0	21249	\N
27576	3385	4	0	21253	\N
27635	67	3	0	22195	\N
27635	3749	4	0	22198	\N
27618	149	3	0	23198	\N
27618	4189	4	0	23199	\N
27740	1379	3	0	23211	\N
27690	140	3	0	24125	\N
27690	4149	4	0	24127	\N
27749	411	2	0	25345	\N
27749	3370	3	0	25347	\N
27646	96	4	0	29598	\N
27646	5538	5	0	29601	\N
27652	449	10	0	29915	\N
27719	449	2	0	29916	\N
27719	646	3	0	29920	\N
27652	7767	11	0	29926	\N
27699	151	6	0	30770	\N
27664	33	3	0	31907	\N
27664	3342	4	0	31909	\N
27650	453	10	0	32940	\N
27650	3360	11	0	32941	\N
27682	453	3	0	32945	\N
27682	2838	4	0	32946	\N
27701	6	6	0	36384	\N
27701	3320	7	0	36386	\N
27632	14	3	0	39457	\N
27632	4272	4	0	39459	\N
27692	18	3	0	40548	\N
27692	3621	4	0	40549	\N
27642	40	12	0	41775	\N
27662	40	8	0	41776	\N
27662	3718	9	0	41777	\N
27642	5640	13	0	41778	\N
27768	71	2	0	44884	\N
27768	1125	3	0	44888	\N
17501	5166	8	0	45345	\N
18344	5391	3	0	46353	\N
23699	5992	9	0	46477	\N
23771	6913	5	0	46595	\N
21651	6355	4	0	48135	\N
27780	7782	3	0	48554	\N
27780	119	5	0	48605	\N
27780	3128	6	0	48606	\N
27759	125	10	0	49352	\N
27759	7780	11	0	49355	\N
27773	170	7	0	50790	\N
27773	6624	8	0	50792	\N
13488	3760	5	1	51238	\N
27738	242	2	0	52240	\N
27738	3425	3	0	52241	\N
27755	242	1	0	52262	\N
27755	2768	2	0	52265	\N
27748	260	2	0	52404	\N
27748	3184	3	0	52405	\N
8784	2002	4	0	53326	\N
9076	2100	9	0	54728	\N
2604	882	3	0	54941	\N
27776	451	4	0	55427	\N
27776	3391	5	0	55428	\N
27744	595	2	0	55669	\N
27744	3285	3	0	55672	\N
10931	2644	3	0	56613	\N
4553	1211	16	1	56888	\N
5180	1211	7	0	56889	\N
12837	3406	2	1	56893	\N
18881	5523	3	0	57499	\N
4553	1281	17	0	57859	\N
5774	1461	4	0	57860	\N
20125	2435	9	0	57866	\N
9137	2115	4	1	57979	\N
5774	1459	3	0	57980	\N
20125	5889	10	0	57985	\N
5253	1404	4	1	58114	\N
18342	4842	10	0	58124	\N
24485	7055	4	0	58408	\N
10988	2659	5	0	58919	\N
27741	2782	14	0	59402	\N
27741	7778	15	0	59403	\N
27782	7785	3	0	59576	\N
27782	3625	5	0	59600	\N
27782	7786	6	0	59601	\N
27781	7783	3	0	59716	\N
27781	3628	5	0	59743	\N
27781	7784	6	0	59744	\N
18484	4914	11	1	59774	\N
19979	4914	10	1	59775	\N
14020	4014	11	1	59780	\N
15551	4014	10	1	59784	\N
25012	6668	5	0	60568	\N
23132	6753	8	0	60575	\N
22289	6512	9	0	60605	\N
22320	6529	13	0	60606	\N
23528	6857	16	0	60728	\N
23180	6772	9	0	60730	\N
27762	6765	2	0	60942	\N
27762	6841	3	0	60943	\N
27735	7412	2	0	61065	\N
27735	7430	3	0	61067	\N
27764	7412	2	0	61068	\N
27764	7430	3	0	61069	\N
27775	7412	2	0	61070	\N
27775	7430	3	0	61071	\N
5180	749	6	1	622	\N
27777	424	2	0	879	\N
27777	2755	3	0	881	\N
17747	5238	7	0	1382	\N
19865	5238	5	0	1383	\N
16813	4964	12	0	1683	\N
18691	5491	9	0	2765	\N
27751	262	2	0	3968	\N
27751	2743	3	0	3971	\N
8992	1970	3	0	5141	\N
18691	2037	8	0	5142	\N
24967	1970	5	0	5147	\N
24967	7188	6	0	7199	\N
27761	4247	3	0	7724	\N
27766	4178	2	0	7725	\N
27766	4247	3	0	7727	\N
27712	4172	4	0	9745	\N
27712	4252	5	0	9746	\N
27732	4172	2	0	9747	\N
27732	4191	3	0	9749	\N
27778	4172	2	0	9752	\N
27778	4191	3	0	9755	\N
8784	2000	3	0	11598	\N
27774	528	2	0	12619	\N
27774	2765	3	0	12623	\N
19863	5791	7	0	12927	\N
13211	3593	4	0	13501	\N
27757	58	2	0	13670	\N
27757	2853	3	0	13672	\N
10988	2660	5	1	13999	\N
27746	92	4	0	15177	\N
27746	6053	5	0	15180	\N
27739	192	2	0	15329	\N
27739	2761	3	0	15331	\N
27765	192	2	0	15339	\N
27765	2761	3	0	15340	\N
9037	2084	4	0	15441	\N
27763	212	2	0	17173	\N
27763	3616	3	0	17175	\N
27772	326	4	0	17519	\N
27772	3362	5	0	17520	\N
10412	2503	4	1	17889	\N
11600	2913	3	1	18212	\N
15349	777	2	1	18214	\N
18005	4952	7	1	18215	\N
2604	884	4	0	18239	\N
19446	973	6	1	18372	\N
12501	3264	3	1	18746	\N
15516	3108	4	1	18752	\N
27767	60	2	0	19563	\N
27767	4544	3	0	19566	\N
27771	62	0	0	19870	\N
27779	198	2	0	20118	\N
27779	513	3	0	20119	\N
22153	6475	12	0	20588	\N
10321	2478	5	0	20933	\N
5253	1355	3	1	21639	\N
21590	6335	9	0	21640	\N
27769	264	2	0	23667	\N
27769	2780	3	0	23668	\N
14679	4309	26	0	23814	\N
15153	4464	3	0	24327	\N
13661	3849	15	1	26297	\N
27723	244	2	0	27326	\N
27723	3308	3	0	27329	\N
27770	96	2	0	29599	\N
27770	2347	3	0	29600	\N
22153	6473	11	0	30929	\N
12681	3349	6	0	33684	\N
13211	3594	4	1	33811	\N
10412	2502	4	0	34747	\N
27714	2	2	0	35213	\N
27714	2789	3	0	35217	\N
27752	18	2	0	40551	\N
27752	1685	3	0	40552	\N
27760	23	10	0	40903	\N
27760	7781	11	0	40906	\N
21240	6251	4	0	41474	\N
27715	40	2	0	41800	\N
27715	282	3	0	41801	\N
12501	3263	3	0	43496	\N
27828	79	3	0	46243	\N
27828	3652	4	0	46244	\N
27922	79	3	0	46294	\N
27922	3652	4	0	46297	\N
27825	260	3	0	52411	\N
27959	260	5	0	52412	\N
27825	3399	4	0	52413	\N
27959	4447	6	0	52414	\N
27904	273	3	0	53129	\N
27904	3638	4	0	53130	\N
27833	279	3	0	53290	\N
27833	3641	4	0	53296	\N
13661	2368	15	0	54492	\N
2534	859	3	0	54940	\N
10455	497	15	0	55470	\N
27808	597	6	0	55959	\N
27808	4697	7	0	55961	\N
27849	597	3	0	55971	\N
27849	3656	4	0	55973	\N
27815	1109	6	0	56122	\N
27815	4548	7	0	56133	\N
10992	2664	5	0	56935	\N
12837	3405	2	0	57841	\N
14679	4307	25	0	57865	\N
27149	2435	6	0	57868	\N
27445	2435	5	0	57869	\N
26271	2171	6	1	57989	\N
27445	7187	6	0	58414	\N
27783	2782	7	0	59410	\N
27783	7787	8	0	59411	\N
27916	4194	3	0	59945	\N
27916	7804	3	0	60360	\N
27916	4788	4	0	60361	\N
27889	7798	3	0	60569	\N
27889	6692	4	0	60571	\N
27804	7412	6	0	61072	\N
27804	7507	7	0	61073	\N
27918	7805	3	0	61078	\N
27830	7412	12	0	61079	\N
27918	7412	10	0	61082	\N
27918	7806	11	0	61083	\N
27830	7791	13	0	61085	\N
26244	7463	4	0	61204	\N
26851	7599	8	0	61307	\N
27919	4204	4	0	425	\N
27907	424	6	0	880	\N
27907	3712	7	0	882	\N
27910	5114	3	0	3040	\N
27910	7800	4	0	3041	\N
27962	7225	7	0	4055	\N
27962	7810	8	0	4063	\N
27149	7250	7	1	5218	\N
27789	4178	2	0	7729	\N
27789	4247	3	0	7730	\N
27843	4178	9	0	7737	\N
27843	4682	10	0	7738	\N
27878	4178	3	0	7747	\N
27895	4178	7	0	7755	\N
27898	4178	3	0	7756	\N
27901	4178	6	0	7757	\N
27898	4211	4	0	7758	\N
27901	4250	7	0	7759	\N
27895	4396	8	0	7760	\N
27928	4178	3	0	7763	\N
27934	4178	7	0	7765	\N
27928	4211	4	0	7766	\N
27934	4396	8	0	7768	\N
27940	4178	3	0	7771	\N
27940	4211	4	0	7772	\N
27947	4178	6	0	7774	\N
27944	4211	4	0	7777	\N
27947	4250	7	0	7779	\N
27791	4172	3	0	9757	\N
27791	5278	4	0	9760	\N
27846	4172	3	0	9761	\N
27846	4275	4	0	9763	\N
27886	4365	6	0	9769	\N
27886	4172	10	0	9772	\N
27886	4940	11	0	9773	\N
27892	4172	3	0	9774	\N
27892	4275	4	0	9775	\N
27931	4172	9	0	9777	\N
27909	4275	4	0	9778	\N
27931	7807	10	0	9779	\N
27950	4172	0	0	9784	\N
27953	4172	6	0	9785	\N
27956	4172	6	0	9786	\N
27953	4197	7	0	9787	\N
27956	4197	7	0	9788	\N
27937	391	3	0	10584	\N
27937	3660	4	0	10585	\N
14020	4013	11	0	13097	\N
27786	235	2	0	15824	\N
27795	44	3	0	16209	\N
27795	3631	4	0	16210	\N
27889	116	4	1	16791	\N
12681	1992	6	1	18213	\N
25658	7354	8	0	18380	\N
27889	7799	3	0	18423	\N
27888	765	3	0	18424	\N
27888	5998	4	0	18425	\N
27822	142	3	0	18653	\N
27822	4254	4	0	18655	\N
25145	3268	5	1	18763	\N
12994	3449	5	0	18995	\N
27867	3635	4	0	19134	\N
27870	164	3	0	21250	\N
27870	3385	4	0	21254	\N
27894	145	3	0	21850	\N
27894	4908	4	0	21854	\N
27800	73	4	0	22621	\N
27800	2284	5	0	22622	\N
27861	224	3	0	25621	\N
27861	3603	4	0	25622	\N
27801	206	4	0	25767	\N
27876	206	3	0	25768	\N
27876	4584	4	0	25769	\N
27819	94	3	0	27102	\N
27819	2864	4	0	27103	\N
27837	94	3	0	27106	\N
27837	2864	4	0	27107	\N
27864	94	3	0	27108	\N
27864	2864	4	0	27109	\N
27965	244	11	0	27328	\N
27965	7811	12	0	27330	\N
13488	1615	5	0	29415	\N
27882	54	31	0	30237	\N
27882	7796	32	0	30240	\N
27852	230	3	0	32150	\N
27798	453	4	0	32949	\N
27925	453	4	0	32950	\N
27798	4108	5	0	32951	\N
27925	3294	5	0	32952	\N
27855	14	6	0	39465	\N
27855	6277	7	0	39469	\N
27792	18	3	0	40553	\N
27813	18	3	0	40554	\N
27813	3621	4	0	40555	\N
27792	6638	4	0	40556	\N
27913	18	3	0	40559	\N
27913	3621	4	0	40560	\N
27816	4636	4	0	41207	\N
27810	40	6	0	41821	\N
27810	4255	7	0	41822	\N
27858	40	3	0	41889	\N
27858	372	4	0	41890	\N
27423	7712	43	1	44972	\N
27923	616	3	0	46296	\N
27958	79	2	0	46348	\N
27958	3180	3	0	46349	\N
27979	100	3	0	47695	\N
27979	3836	4	0	47696	\N
27985	113	3	0	48359	\N
27985	3620	4	0	48360	\N
27926	125	4	0	49357	\N
27926	3356	5	0	49360	\N
27793	156	3	0	50437	\N
27793	4594	4	0	50438	\N
27840	170	3	0	50803	\N
27840	4148	4	0	50805	\N
27989	7820	9	0	52652	\N
27973	268	11	0	52666	\N
27989	268	10	0	52674	\N
27973	7247	12	0	52676	\N
27961	279	7	0	53292	\N
27961	7770	8	0	53299	\N
27838	324	6	0	54369	\N
27838	5241	7	0	54371	\N
27807	595	6	0	55670	\N
27807	4698	7	0	55677	\N
27997	597	3	0	55972	\N
27997	3656	4	0	55974	\N
27939	841	3	0	57087	\N
27939	3604	4	0	57090	\N
27831	852	12	0	57400	\N
27831	7347	13	0	57403	\N
27991	7821	3	0	57822	\N
27880	2578	8	0	58654	\N
27880	7795	9	0	58656	\N
27988	5079	9	0	58834	\N
27988	2636	10	0	58843	\N
27887	4194	3	0	59944	\N
27971	5885	11	0	60543	\N
27971	7246	12	0	60544	\N
27995	6450	3	0	60792	\N
27995	6847	4	0	60806	\N
27797	6765	3	0	60946	\N
27797	6884	4	0	60948	\N
27823	7412	3	0	61074	\N
27823	7466	4	0	61075	\N
27826	7412	3	0	61076	\N
27826	7466	4	0	61077	\N
27914	7801	4	0	85	\N
27980	3611	4	0	897	\N
27897	251	7	0	1549	\N
27897	3883	8	0	1557	\N
27829	246	12	0	1866	\N
27829	7790	13	0	1867	\N
27929	7225	3	0	4047	\N
27929	7226	4	0	4049	\N
27784	365	4	0	4655	\N
27784	3298	5	0	4657	\N
27820	4178	3	0	7731	\N
27820	4211	4	0	7732	\N
27890	4178	3	0	7751	\N
27911	4178	6	0	7761	\N
27911	4250	7	0	7762	\N
27932	4178	3	0	7764	\N
27932	4211	4	0	7767	\N
27955	4178	6	0	7775	\N
27982	4178	3	0	7776	\N
27982	4211	4	0	7778	\N
27955	4250	7	0	7780	\N
27983	4178	6	0	7781	\N
27983	4250	7	0	7782	\N
27992	4178	3	0	7783	\N
27992	4211	4	0	7785	\N
27811	4275	4	0	9759	\N
27859	4172	6	0	9762	\N
27859	4197	7	0	9764	\N
27873	4172	3	0	9770	\N
27873	4275	4	0	9771	\N
27943	4172	9	0	9780	\N
27943	4977	10	0	9781	\N
27974	4172	3	0	9790	\N
27974	4275	4	0	9791	\N
27986	4172	6	0	9794	\N
27986	4197	7	0	9796	\N
27967	459	11	0	11986	\N
27970	528	6	0	12620	\N
27970	6720	7	0	12627	\N
27874	38	3	0	16515	\N
27935	38	7	0	16516	\N
27874	3457	4	0	16519	\N
27935	5071	8	0	16524	\N
27802	115	3	0	16785	\N
27884	115	9	0	16786	\N
27802	3483	4	0	16788	\N
27884	5695	10	0	16790	\N
27868	1656	3	0	16949	\N
27868	5905	4	0	16951	\N
27887	5998	4	0	18422	\N
27790	290	3	0	19124	\N
27790	7789	4	0	19126	\N
27877	290	3	0	19135	\N
27877	3635	4	0	19137	\N
27991	7822	3	0	20126	\N
27991	4263	4	0	20127	\N
27994	198	3	0	20128	\N
27994	4263	4	0	20134	\N
27952	241	6	0	20599	\N
27952	6412	7	0	20603	\N
28000	64	3	0	20801	\N
27976	164	3	0	21251	\N
27976	3385	4	0	21255	\N
27871	164	126	0	21256	\N
27871	7794	127	0	21257	\N
27977	7793	46	0	21258	\N
27977	164	126	0	21273	\N
27977	7817	127	0	21274	\N
27817	73	3	0	22627	\N
27817	3040	4	0	22628	\N
27968	336	11	0	22844	\N
27968	7814	12	0	22847	\N
27832	930	3	0	23932	\N
27814	140	6	0	24126	\N
27814	4086	7	0	24128	\N
27853	141	1	0	24129	\N
27853	140	4	0	24137	\N
27853	2910	5	0	24139	\N
27905	90	19	0	26147	\N
27905	6105	20	0	26151	\N
27787	86	5	0	26485	\N
27787	7788	6	0	26489	\N
27941	1137	4	0	27177	\N
27941	7808	5	0	27178	\N
27964	244	0	0	27327	\N
27902	4857	4	0	31133	\N
27899	4	3	0	36078	\N
27899	3837	4	0	36080	\N
27908	14	3	0	39466	\N
27908	4272	4	0	39468	\N
27844	18	6	0	40557	\N
27844	4180	7	0	40558	\N
27949	18	6	0	40563	\N
27949	4180	7	0	40564	\N
27835	40	3	0	41838	\N
27835	372	4	0	41839	\N
27856	40	6	0	41859	\N
27865	40	4	0	41909	\N
27865	3381	5	0	41910	\N
27946	40	3	0	41934	\N
27946	372	4	0	41937	\N
27283	7693	11	0	44974	\N
27957	3652	4	0	46350	\N
27803	88	3	0	47282	\N
27803	3655	4	0	47283	\N
27812	88	6	0	47290	\N
27812	5263	7	0	47291	\N
27933	113	3	0	48351	\N
27933	3620	4	0	48352	\N
27942	181	6	0	51045	\N
27942	4256	7	0	51047	\N
27799	273	4	0	53128	\N
27799	3777	5	0	53131	\N
27930	279	3	0	53291	\N
27930	3641	4	0	53297	\N
27879	285	3	0	53687	\N
27879	4496	4	0	53690	\N
28018	316	9	0	54013	\N
28018	4279	10	0	54015	\N
27920	324	3	0	54377	\N
27920	4514	4	0	54381	\N
27851	595	3	0	55671	\N
27851	3654	4	0	55676	\N
27845	852	3	0	57401	\N
27845	3612	4	0	57402	\N
27841	2636	3	0	58837	\N
27938	2636	3	0	58838	\N
27841	2837	4	0	58841	\N
27938	2837	4	0	58842	\N
27917	4787	3	0	60362	\N
27917	4788	4	0	60363	\N
27806	6450	6	0	60790	\N
27850	6450	3	0	60791	\N
27850	6847	4	0	60805	\N
27806	7269	7	0	60810	\N
27954	7412	6	0	61080	\N
27954	7507	7	0	61081	\N
27875	3474	4	0	1284	\N
27900	3474	4	0	1288	\N
27912	228	6	0	2873	\N
27912	7585	7	0	2885	\N
27966	2246	4	0	3172	\N
27966	7812	5	0	3173	\N
27834	7225	3	0	4046	\N
27834	7226	4	0	4048	\N
27818	189	3	0	5021	\N
27818	3782	4	0	5025	\N
27785	4178	4	0	7726	\N
27785	4331	5	0	7728	\N
27827	4178	3	0	7733	\N
27836	4178	3	0	7735	\N
27836	4211	4	0	7736	\N
27847	4178	3	0	7739	\N
27847	4211	4	0	7740	\N
27857	4178	3	0	7741	\N
27860	4178	3	0	7742	\N
27857	4211	4	0	7743	\N
27860	4211	4	0	7744	\N
27866	4178	7	0	7745	\N
27866	4396	8	0	7746	\N
27885	4178	3	0	7749	\N
27885	4211	4	0	7750	\N
27891	4211	4	0	7754	\N
27936	4178	6	0	7769	\N
27936	4250	7	0	7770	\N
27788	4172	5	0	9753	\N
27788	4415	6	0	9756	\N
27862	4172	3	0	9765	\N
27863	4172	3	0	9766	\N
27862	4275	4	0	9767	\N
27863	4275	4	0	9768	\N
27945	4172	3	0	9782	\N
27945	4275	4	0	9783	\N
27969	4172	11	0	9789	\N
28021	4172	2	0	9798	\N
28021	4191	3	0	9799	\N
27839	391	3	0	10576	\N
27839	3660	4	0	10577	\N
27842	391	9	0	10583	\N
27842	4107	10	0	10586	\N
27972	528	11	0	12621	\N
27972	7816	12	0	12628	\N
27809	38	6	0	16514	\N
27809	6005	7	0	16522	\N
27796	212	3	0	17174	\N
27796	3639	4	0	17176	\N
27881	4030	9	0	18188	\N
27924	30	3	0	18189	\N
27924	3640	4	0	18190	\N
28015	1448	3	0	18802	\N
28015	7826	4	0	18803	\N
27960	208	5	0	19283	\N
27960	7809	6	0	19298	\N
28024	62	6	0	19885	\N
28024	6466	7	0	19890	\N
27848	6645	3	0	20334	\N
27848	6646	4	0	20335	\N
27821	241	3	0	20597	\N
27821	3613	4	0	20600	\N
27951	6412	7	0	20602	\N
28000	4217	4	0	20807	\N
28009	7824	46	0	21275	\N
28009	164	85	0	21289	\N
28009	7825	86	0	21290	\N
27854	141	1	0	24130	\N
27854	140	4	0	24138	\N
27854	2910	5	0	24140	\N
27794	214	6	0	24430	\N
27794	4681	7	0	24431	\N
27805	214	6	0	24458	\N
27975	3496	4	0	24461	\N
27805	4681	7	0	24462	\N
27893	69	3	0	24856	\N
27893	4536	4	0	24865	\N
27906	6303	3	0	26374	\N
27906	6304	4	0	26375	\N
27872	86	3	0	26486	\N
27872	3746	4	0	26488	\N
27915	7802	3	0	27671	\N
27915	42	7	0	27682	\N
27915	7803	8	0	27684	\N
28003	42	1	0	27694	\N
27824	449	3	0	29917	\N
27824	4760	4	0	29922	\N
27883	54	3	0	30238	\N
27883	3041	4	0	30239	\N
28012	202	3	0	31138	\N
28012	4857	4	0	31139	\N
28027	33	3	0	31912	\N
28030	33	0	0	31914	\N
28027	3342	4	0	31918	\N
27903	230	3	0	32158	\N
27903	4181	4	0	32159	\N
27927	230	3	0	32172	\N
27896	322	7	0	32387	\N
27896	2857	8	0	32390	\N
27948	322	6	0	32393	\N
27948	6313	7	0	32396	\N
27978	453	8	0	32953	\N
27978	7818	9	0	32954	\N
27921	18	3	0	40561	\N
27921	3621	4	0	40562	\N
27963	18	7	0	40565	\N
27963	4538	8	0	40568	\N
28006	18	6	0	40570	\N
28006	4180	7	0	40575	\N
27869	4636	4	0	41233	\N
28146	3415	19	0	44631	\N
28171	56	4	0	44646	\N
28171	3259	5	0	44647	\N
28111	75	7	0	45166	\N
28147	75	2	0	45167	\N
28147	284	3	0	45168	\N
28111	2859	8	0	45169	\N
28156	75	10	0	45175	\N
28156	4628	11	0	45176	\N
28040	79	3	0	46400	\N
28040	3652	4	0	46402	\N
28115	100	6	0	47707	\N
28115	7216	7	0	47708	\N
28004	156	5	0	50439	\N
28005	156	6	0	50440	\N
28004	7823	6	0	50441	\N
28005	6498	7	0	50442	\N
27990	7820	9	0	52653	\N
27990	268	10	0	52675	\N
28139	435	2	0	55133	\N
28139	3413	3	0	55134	\N
27996	595	3	0	55693	\N
28184	595	3	0	55695	\N
27996	3654	4	0	55698	\N
28184	3654	4	0	55700	\N
28058	597	3	0	55981	\N
28058	3656	4	0	55983	\N
28141	637	2	0	56362	\N
28141	7850	3	0	56363	\N
28108	841	3	0	57088	\N
28108	3604	4	0	57091	\N
28064	852	3	0	57428	\N
28064	3612	4	0	57431	\N
28088	4088	4	0	59922	\N
28088	4089	5	0	59923	\N
28117	4233	3	0	60134	\N
28117	4425	4	0	60138	\N
27987	7819	9	0	60545	\N
27987	5885	10	0	60548	\N
28067	6044	6	0	60685	\N
28067	6264	7	0	60686	\N
28049	6765	3	0	60947	\N
28049	6884	4	0	60949	\N
28102	7412	3	0	61089	\N
28102	7466	4	0	61091	\N
28136	7412	4	0	61093	\N
28136	7499	5	0	61094	\N
28186	7412	3	0	61095	\N
28186	7466	4	0	61097	\N
28169	7856	27	0	61301	\N
28127	626	3	0	2617	\N
28079	35	19	0	4303	\N
28079	7834	20	0	4306	\N
27998	4178	3	0	7784	\N
27998	4211	4	0	7786	\N
28022	4178	3	0	7787	\N
28052	4178	3	0	7788	\N
28022	4211	4	0	7789	\N
28052	4211	4	0	7790	\N
28114	4178	7	0	7795	\N
28118	4178	4	0	7796	\N
28118	4205	5	0	7797	\N
28114	4396	8	0	7798	\N
28167	4178	2	0	7799	\N
28187	4178	2	0	7800	\N
28167	4247	3	0	7801	\N
28187	4247	3	0	7802	\N
28197	4178	2	0	7805	\N
28197	4247	3	0	7806	\N
27981	4172	3	0	9793	\N
27981	4275	4	0	9795	\N
28008	4172	3	0	9797	\N
28008	4275	4	0	9800	\N
28043	4172	2	0	9801	\N
28043	4285	3	0	9802	\N
28207	4191	3	0	9817	\N
28061	391	3	0	10594	\N
28061	3660	4	0	10595	\N
28145	687	3	0	11620	\N
28145	7852	4	0	11621	\N
28192	528	2	0	12622	\N
28192	2765	3	0	12624	\N
28011	258	2	0	14457	\N
28011	3275	3	0	14458	\N
28007	192	3	0	15346	\N
28007	3790	4	0	15349	\N
28129	44	1	0	16207	\N
28046	167	0	0	17816	\N
28165	167	2	0	17822	\N
28165	3322	3	0	17826	\N
28169	7857	27	0	18191	\N
28169	7858	28	0	18194	\N
28082	177	3	0	18344	\N
28082	3703	4	0	18345	\N
28121	142	2	0	18666	\N
28133	142	3	0	18669	\N
28121	4418	3	0	18671	\N
28133	1044	4	0	18675	\N
27984	60	6	0	19564	\N
28019	7827	1	0	19581	\N
28019	61	2	0	19583	\N
27999	64	0	0	20800	\N
28001	64	0	0	20802	\N
28010	164	3	0	21271	\N
28010	3385	4	0	21272	\N
28073	7828	23	0	21582	\N
28073	488	126	0	21595	\N
28073	7829	127	0	21596	\N
28034	214	15	0	24460	\N
28034	2138	16	0	24463	\N
28109	214	3	0	24492	\N
28169	7859	28	1	24939	\N
28013	411	6	0	25346	\N
28013	5252	7	0	25348	\N
28103	90	3	0	26166	\N
28103	4074	4	0	26167	\N
28076	86	15	0	26496	\N
28076	7832	16	0	26500	\N
28055	54	3	0	30249	\N
28055	3041	4	0	30253	\N
28070	151	4	0	30771	\N
28070	1876	5	0	30773	\N
28150	151	5	0	30790	\N
28153	151	2	0	30798	\N
28153	2854	3	0	30799	\N
28085	202	6	0	31148	\N
28085	4079	7	0	31150	\N
28031	33	0	0	31915	\N
28123	453	2	0	32956	\N
28125	453	2	0	32958	\N
28123	3366	3	0	32959	\N
28125	3366	3	0	32961	\N
27993	431	3	0	34867	\N
27993	3933	4	0	34869	\N
28025	14	6	0	39467	\N
28002	18	3	0	40566	\N
28002	3621	4	0	40567	\N
28016	23	3	0	40904	\N
28016	3497	4	0	40905	\N
28037	27	3	0	41228	\N
28037	4636	4	0	41234	\N
28091	40	3	0	41935	\N
28099	40	10	0	41936	\N
28091	372	4	0	41938	\N
28099	4104	11	0	41939	\N
28112	40	4	0	41958	\N
28112	2796	5	0	41959	\N
28193	56	0	0	44662	\N
28231	88	6	0	47302	\N
28231	5263	7	0	47308	\N
28142	100	2	0	47726	\N
28142	633	3	0	47728	\N
28014	102	3	0	48070	\N
28014	3597	4	0	48077	\N
28056	113	3	0	48375	\N
28056	3620	4	0	48376	\N
28144	125	2	0	49358	\N
28144	3297	3	0	49359	\N
28096	170	4	0	50804	\N
28096	4680	5	0	50806	\N
28172	170	7	0	50807	\N
28188	170	2	0	50808	\N
28188	1380	3	0	50809	\N
28172	6624	8	0	50810	\N
28205	210	2	0	51985	\N
28205	1874	3	0	51995	\N
28041	242	3	0	52263	\N
28041	2839	4	0	52268	\N
28105	242	7	0	52273	\N
28134	242	3	0	52274	\N
28134	5519	4	0	52280	\N
28105	4592	8	0	52282	\N
28212	273	2	0	53136	\N
28212	1413	3	0	53137	\N
28059	595	3	0	55694	\N
28059	3654	4	0	55699	\N
28185	597	3	0	55982	\N
28185	3656	4	0	55984	\N
28149	793	2	0	56718	\N
28149	4363	3	0	56719	\N
28038	852	3	0	57420	\N
28038	3612	4	0	57421	\N
28236	2636	2	0	58839	\N
28217	6203	2	0	59413	\N
28217	2782	4	0	59418	\N
28217	2959	5	0	59421	\N
28177	3625	2	0	59611	\N
28177	4359	3	0	59619	\N
28086	3628	6	0	59730	\N
28086	7840	7	1	59745	\N
28179	4233	2	0	60135	\N
28179	5577	3	0	60137	\N
28166	7854	3	0	60412	\N
28083	7837	3	0	60687	\N
28083	6044	11	0	60688	\N
28083	7838	12	0	60689	\N
28035	7466	3	0	61084	\N
28035	7412	4	0	61086	\N
28092	7412	3	0	61087	\N
28092	7466	4	0	61088	\N
28200	110	2	0	2615	\N
28200	626	3	0	2618	\N
28047	262	3	0	3969	\N
28047	4778	4	0	3972	\N
28163	189	7	0	5022	\N
28163	7853	8	0	5026	\N
28120	7237	6	0	5219	\N
28120	7846	7	0	5221	\N
28120	7844	4	0	5387	\N
28120	7845	6	0	5396	\N
28120	7847	7	1	5397	\N
28214	4178	3	0	7811	\N
28214	4211	4	0	7812	\N
28219	4247	3	0	7814	\N
28065	4172	9	0	9804	\N
28065	4977	10	0	9806	\N
28164	4201	1	0	9807	\N
28164	4172	4	0	9810	\N
28164	4285	5	0	9812	\N
28242	4172	3	0	9818	\N
28242	4275	4	0	9819	\N
28247	4172	3	0	9820	\N
28247	4275	4	0	9821	\N
28068	132	4	0	11453	\N
28068	3716	5	0	11458	\N
28195	4171	4	0	11843	\N
28226	300	2	0	12222	\N
28226	2786	3	0	12223	\N
28249	123	3	0	12803	\N
28249	2856	4	0	12809	\N
28138	58	3	0	13682	\N
28138	3665	4	0	13683	\N
28089	233	4	0	13963	\N
28089	3775	5	0	13969	\N
28053	402	2	0	14123	\N
28053	2760	3	0	14127	\N
28080	258	19	0	14476	\N
28198	235	3	0	15831	\N
28198	3343	4	0	15832	\N
28044	167	6	0	17814	\N
28044	5066	7	0	17817	\N
28166	167	2	0	17823	\N
28166	7855	3	1	17825	\N
28074	3208	15	0	18389	\N
28077	3208	5	0	18390	\N
28077	7833	6	0	18391	\N
28074	7830	16	0	18394	\N
28122	142	2	0	18667	\N
28126	142	2	0	18668	\N
28126	4418	3	0	18673	\N
28020	7827	2	0	19582	\N
28020	4544	3	0	19584	\N
28023	73	3	0	22631	\N
28023	3040	4	0	22632	\N
28017	336	3	0	22845	\N
28017	3400	4	0	22846	\N
28062	336	3	0	22858	\N
28062	3400	4	0	22859	\N
28152	264	5	0	23671	\N
28152	6998	6	0	23672	\N
28160	264	7	0	23673	\N
28135	140	3	0	24149	\N
28135	7849	4	0	24150	\N
28228	140	2	0	24161	\N
28228	3183	3	0	24162	\N
28086	7839	7	0	24933	\N
28075	86	10	0	26495	\N
28075	7831	11	0	26499	\N
28032	94	4	0	27110	\N
28032	4677	5	0	27111	\N
28238	94	4	0	27116	\N
28238	6644	5	0	27120	\N
28050	54	8	0	30255	\N
28071	151	6	0	30772	\N
28071	3588	7	0	30774	\N
28132	151	3	0	30781	\N
28132	3046	4	0	30783	\N
28209	678	3	0	30920	\N
28209	7707	4	0	30922	\N
28026	33	0	0	31908	\N
28029	33	0	0	31913	\N
28174	33	2	0	31916	\N
28174	2822	3	0	31917	\N
28124	453	2	0	32957	\N
28124	3366	3	0	32960	\N
28158	5832	8	0	32972	\N
28168	4	0	0	36095	\N
28210	4	3	0	36120	\N
28210	3837	4	0	36124	\N
28155	40	3	0	41984	\N
28155	372	4	0	41985	\N
28181	40	2	0	42021	\N
28181	282	3	0	42022	\N
28221	40	2	0	42058	\N
28221	282	3	0	42061	\N
19617	5699	11	0	42662	\N
28078	56	1	0	44609	\N
28078	1088	2	0	44617	\N
28154	56	3	0	44640	\N
28154	4102	4	0	44641	\N
28191	56	4	0	44655	\N
28191	3259	5	0	44656	\N
28128	71	1	0	44885	\N
28180	71	6	0	44886	\N
28128	72	2	0	44887	\N
28180	4738	7	0	44889	\N
28162	75	7	0	45185	\N
28162	3331	8	0	45192	\N
28039	79	2	0	46399	\N
28039	616	3	0	46401	\N
28116	79	3	0	46442	\N
28116	3652	4	0	46443	\N
28260	79	3	0	46507	\N
28260	3652	4	0	46509	\N
18881	5524	3	1	47723	\N
15349	4513	2	0	47858	\N
28084	119	6	0	48623	\N
28175	119	2	0	48624	\N
28175	1879	3	0	48636	\N
28084	3644	7	0	48642	\N
28148	200	2	0	51657	\N
28148	276	3	0	51659	\N
28042	242	2	0	52264	\N
28042	4576	3	0	52266	\N
17747	5240	7	1	54271	\N
19446	5673	6	0	54716	\N
28262	435	3	0	55137	\N
28262	3504	4	0	55140	\N
16813	4965	12	1	56194	\N
17699	5225	2	0	56775	\N
28173	841	7	0	57089	\N
28173	4489	8	0	57092	\N
28113	908	7	0	57783	\N
28113	4078	8	0	57784	\N
28236	2836	3	0	58840	\N
28100	2351	10	0	59085	\N
28100	5603	11	0	59090	\N
28087	3625	6	0	59599	\N
28087	3642	7	0	59602	\N
28178	3628	2	0	59731	\N
28178	4360	3	0	59738	\N
28107	6044	3	0	60690	\N
28107	6045	4	0	60694	\N
28057	6450	3	0	60793	\N
28183	6450	3	0	60794	\N
28057	6847	4	0	60807	\N
28183	6847	4	0	60808	\N
28248	6723	3	0	60885	\N
28248	6724	4	0	60893	\N
28119	7412	3	0	61090	\N
28119	7843	4	0	61092	\N
28274	7412	2	0	61101	\N
28274	7430	3	0	61102	\N
28137	2804	3	0	434	\N
28199	110	3	0	2614	\N
28199	3328	4	0	2619	\N
28190	228	5	0	2874	\N
28190	7860	6	0	2884	\N
28104	7841	63	0	4658	\N
28106	365	7	0	4665	\N
28106	5248	8	0	4666	\N
28104	365	126	0	4667	\N
28104	7842	127	0	4668	\N
28245	189	2	0	5023	\N
28245	3441	3	0	5024	\N
16339	4805	5	1	5729	\N
28095	4178	3	0	7792	\N
28095	4211	4	0	7793	\N
28066	4250	7	0	7794	\N
28189	4178	5	0	7803	\N
28189	4429	6	0	7804	\N
28202	4178	1	0	7807	\N
28202	4460	2	0	7809	\N
28063	4172	3	0	9803	\N
28063	4275	4	0	9805	\N
28093	4172	3	0	9808	\N
28098	4172	10	0	9809	\N
28093	4275	4	0	9811	\N
28176	4172	2	0	9814	\N
28176	4191	3	0	9816	\N
28033	391	15	0	10593	\N
28033	2680	16	0	10596	\N
28159	391	7	0	10604	\N
28159	3334	8	0	10607	\N
28110	132	7	0	11454	\N
28110	3709	8	0	11460	\N
16339	2466	5	0	11974	\N
28051	402	1	0	14122	\N
28054	402	3	0	14124	\N
28051	403	2	0	14126	\N
28060	258	3	0	14470	\N
28060	4401	4	0	14471	\N
28201	192	1	0	15347	\N
28201	2944	2	0	15348	\N
28097	38	4	0	16517	\N
28097	5656	5	0	16520	\N
28048	212	3	0	17186	\N
28048	3639	4	0	17189	\N
28045	167	0	0	17815	\N
28194	4451	2	0	18740	\N
28194	7861	3	0	18741	\N
28090	64	4	0	20803	\N
28036	7828	23	0	21571	\N
28036	488	126	0	21580	\N
28036	7829	127	0	21581	\N
14510	4244	8	0	26577	\N
28081	94	19	0	27112	\N
28081	7836	20	0	27113	\N
28161	94	7	0	27114	\N
28161	5608	8	0	27115	\N
18484	5429	11	0	27400	\N
28101	20	3	0	30520	\N
28101	2844	4	0	30522	\N
28182	20	3	0	30529	\N
28131	151	2	0	30780	\N
28131	7848	3	0	30782	\N
18005	5307	7	0	30844	\N
28143	202	6	0	31149	\N
28143	7851	7	0	31151	\N
28240	360	2	0	31485	\N
28240	2767	3	0	31486	\N
28072	453	6	0	32955	\N
28072	4091	7	0	32962	\N
28151	453	2	0	32963	\N
28151	3366	3	0	32964	\N
28069	4	4	0	36089	\N
28170	4	2	0	36096	\N
28170	2751	3	0	36097	\N
28258	6	2	0	36395	\N
28258	2805	3	0	36399	\N
28140	14	2	0	39477	\N
28140	1785	3	0	39479	\N
28094	18	3	0	40571	\N
28265	18	2	0	40572	\N
28265	1685	3	0	40573	\N
28094	3621	4	0	40574	\N
28157	40	4	0	42004	\N
28157	2796	5	0	42005	\N
28196	282	3	0	42038	\N
28239	40	2	0	42059	\N
28252	40	6	0	42060	\N
28239	282	3	0	42062	\N
28252	4255	7	0	42063	\N
28268	56	17	0	44666	\N
28268	7865	18	0	44667	\N
28468	56	2	0	44683	\N
28468	2914	3	0	44684	\N
28316	100	5	0	47727	\N
28316	7057	6	0	47729	\N
28293	121	0	0	49011	\N
28277	135	2	0	49598	\N
28306	135	4	0	49599	\N
28277	2722	3	0	49605	\N
28306	4353	5	0	49608	\N
28369	156	2	0	50446	\N
28369	4485	3	0	50449	\N
28344	181	2	0	51059	\N
28344	3313	3	0	51060	\N
28234	186	3	0	51353	\N
28234	4294	4	0	51355	\N
28366	273	2	0	53140	\N
28366	1413	3	0	53141	\N
28220	316	2	0	54020	\N
28312	316	2	0	54021	\N
28220	1900	3	0	54022	\N
28312	1900	3	0	54023	\N
28347	324	8	0	54378	\N
28347	7873	9	0	54382	\N
28352	435	2	0	55138	\N
28352	3413	3	0	55139	\N
25658	7355	8	1	55586	\N
23528	6858	16	1	56333	\N
28461	793	2	0	56735	\N
28461	4363	3	0	56736	\N
28408	908	3	0	57785	\N
28408	7883	4	0	57786	\N
21240	6252	4	1	58104	\N
28388	1470	3	0	58354	\N
28388	5036	4	0	58355	\N
25012	7206	5	1	58413	\N
28218	6203	2	0	59414	\N
28218	2782	4	0	59419	\N
28218	2959	5	0	59422	\N
19863	5792	7	1	59787	\N
28342	4787	8	0	60365	\N
28342	7871	9	0	60369	\N
23771	6914	5	1	60600	\N
28333	6450	2	0	60795	\N
28333	6825	3	0	60800	\N
28250	6723	53	0	60886	\N
28250	7864	54	0	60895	\N
28263	7412	2	0	61099	\N
28263	7430	3	0	61100	\N
28429	7412	4	0	61104	\N
28429	7426	5	0	61106	\N
28470	7412	4	0	61107	\N
28470	7426	5	0	61108	\N
26244	7464	4	1	61287	\N
28241	2755	3	0	894	\N
28376	228	3	0	2877	\N
28376	1432	4	0	2879	\N
28417	657	2	0	3055	\N
28417	7888	3	0	3056	\N
23699	6892	9	1	4032	\N
28406	7225	2	0	4056	\N
28406	7882	3	0	4060	\N
28208	4178	2	0	7808	\N
28208	4247	3	0	7810	\N
28237	4178	2	0	7815	\N
28237	4247	3	0	7819	\N
28451	4178	2	0	7856	\N
28465	4178	2	0	7859	\N
28465	4247	3	0	7860	\N
28281	4172	3	0	9824	\N
28281	4275	4	0	9825	\N
28290	4172	3	0	9827	\N
28290	4275	4	0	9831	\N
28394	4172	2	0	9832	\N
28394	4191	3	0	9833	\N
28399	4172	3	0	9834	\N
28404	4172	2	0	9835	\N
28434	4172	7	0	9836	\N
28404	4191	3	0	9837	\N
28434	4537	8	0	9839	\N
28452	4172	6	0	9840	\N
28452	4365	7	0	9841	\N
24485	7056	4	1	11340	\N
25362	7297	6	1	11383	\N
28232	132	6	0	11471	\N
28302	132	6	0	11472	\N
28232	4690	7	0	11473	\N
28302	4690	7	0	11474	\N
28379	132	2	0	11481	\N
28379	2756	3	0	11482	\N
28457	233	2	0	13964	\N
28324	402	2	0	14143	\N
28324	2760	3	0	14147	\N
28243	192	2	0	15358	\N
28328	192	2	0	15359	\N
28243	2761	3	0	15360	\N
28328	2761	3	0	15361	\N
28215	38	3	0	16518	\N
28215	3445	4	0	16521	\N
28227	38	2	0	16535	\N
28227	4009	3	0	16537	\N
28381	212	2	0	17187	\N
28381	3616	3	0	17188	\N
28377	7876	25	0	17530	\N
28336	167	8	0	17839	\N
28336	7870	9	0	17841	\N
28412	167	2	0	17862	\N
28412	3322	3	0	17864	\N
21651	6356	4	1	18760	\N
28229	290	3	0	19136	\N
28229	3635	4	0	19138	\N
28446	208	4	0	19284	\N
28446	7894	5	0	19294	\N
28270	60	2	0	19565	\N
28270	4544	3	0	19567	\N
28321	2191	3	0	19889	\N
28222	198	2	0	20129	\N
28222	513	3	0	20132	\N
28203	241	1	0	20606	\N
28203	3094	2	0	20610	\N
28359	64	2	0	20828	\N
28359	277	3	0	20830	\N
28420	64	4	0	20839	\N
28420	7890	5	0	20843	\N
28224	164	3	0	21287	\N
28224	3385	4	0	21288	\N
28377	1018	25	0	21826	\N
28289	140	2	0	24174	\N
28441	140	3	0	24175	\N
28289	3183	3	0	24176	\N
28441	4149	4	0	24177	\N
22289	6514	10	0	24931	\N
28275	90	2	0	26173	\N
28275	3442	3	0	26176	\N
28373	244	2	0	27337	\N
28373	3308	3	0	27339	\N
28424	54	14	0	30251	\N
28424	2868	15	0	30254	\N
28206	20	2	0	30530	\N
26271	7467	6	0	34929	\N
28453	2	2	0	35215	\N
28453	2789	3	0	35218	\N
28266	4	2	0	36121	\N
28266	2751	3	0	36123	\N
23132	6754	8	1	39143	\N
23180	6773	9	1	39167	\N
26851	7600	8	1	41569	\N
974	75	1	0	45098	\N
16558	75	3	0	45195	\N
28480	284	3	0	45231	\N
28251	79	6	0	46506	\N
28251	4253	7	0	46511	\N
28425	79	2	0	46558	\N
28425	616	3	0	46560	\N
28273	102	2	0	48072	\N
28273	3053	3	0	48075	\N
28400	102	3	0	48084	\N
28400	3597	4	0	48085	\N
28405	7881	2	0	48096	\N
28405	3053	3	0	48097	\N
28314	113	54	0	48383	\N
28314	7867	55	0	48390	\N
28295	121	2	0	49012	\N
28295	2498	3	0	49014	\N
28389	121	7	0	49024	\N
28389	7878	8	0	49029	\N
28345	125	2	0	49363	\N
28345	3297	3	0	49366	\N
28439	135	2	0	49600	\N
28439	2722	3	0	49606	\N
28276	137	2	0	49843	\N
28276	2721	3	0	49846	\N
28230	156	6	0	50443	\N
28230	6498	7	0	50444	\N
28459	210	2	0	51986	\N
28459	1874	3	0	51996	\N
28449	279	4	0	53294	\N
28449	3430	5	0	53298	\N
28395	324	2	0	54379	\N
28395	2808	3	0	54380	\N
28334	597	2	0	56012	\N
28334	3286	3	0	56014	\N
28233	1109	6	0	56123	\N
28233	4548	7	0	56134	\N
28308	841	2	0	57098	\N
28308	3316	3	0	57099	\N
25362	7296	6	0	57987	\N
19617	5700	11	1	58407	\N
12994	3450	5	1	58671	\N
14510	3843	8	1	59125	\N
28216	6203	2	0	59412	\N
28216	2782	4	0	59417	\N
28216	2959	5	0	59420	\N
28327	2782	2	0	59425	\N
28327	2784	3	0	59426	\N
28458	4088	2	0	59928	\N
28458	4332	3	0	59929	\N
28462	5885	2	0	60546	\N
28387	6723	2	0	60887	\N
28387	6763	3	0	60891	\N
28391	6765	3	0	60951	\N
28391	7879	4	0	60960	\N
28204	7412	5	0	61096	\N
28204	7478	6	0	61098	\N
28487	7412	2	0	61110	\N
28487	7430	3	0	61112	\N
28246	3003	4	0	89	\N
28284	2842	3	0	93	\N
28415	288	5	0	99	\N
28415	7887	6	0	100	\N
28287	12	2	0	442	\N
28350	12	2	0	443	\N
28287	2804	3	0	446	\N
28350	2804	3	0	447	\N
28339	46	2	0	663	\N
28339	2348	3	0	668	\N
28298	424	5	0	893	\N
28298	5002	6	0	898	\N
28235	7862	2	0	1634	\N
28473	189	3	0	5066	\N
28473	7896	4	0	5067	\N
28494	373	2	0	5400	\N
28255	4178	2	0	7816	\N
28255	4247	3	0	7820	\N
28264	4178	2	0	7823	\N
28264	4247	3	0	7824	\N
28309	4178	11	0	7828	\N
28309	6011	12	0	7830	\N
28409	4178	3	0	7849	\N
28409	4441	4	0	7854	\N
28447	4178	4	0	7855	\N
28282	4172	3	0	9826	\N
28282	4275	4	0	9830	\N
28478	4172	2	0	9844	\N
28478	4191	3	0	9847	\N
28257	391	2	0	10605	\N
28257	1381	3	0	10606	\N
28319	391	2	0	10623	\N
28319	1381	3	0	10624	\N
28490	391	7	0	10632	\N
28490	7898	8	0	10634	\N
28303	132	2	0	11477	\N
28303	2756	3	0	11478	\N
28225	300	2	0	12221	\N
28225	706	3	0	12224	\N
28384	123	2	0	12804	\N
28384	1868	3	0	12806	\N
28435	58	2	0	13688	\N
28435	2853	3	0	13689	\N
28300	44	2	0	16211	\N
28300	1910	3	0	16213	\N
28244	115	2	0	16796	\N
28244	2797	3	0	16797	\N
28492	212	7	0	17198	\N
28492	7900	8	0	17204	\N
28269	3322	3	0	17827	\N
28364	7874	6	0	17847	\N
28364	3314	7	0	17849	\N
28329	198	2	0	20130	\N
28329	513	3	0	20133	\N
28354	64	2	0	20820	\N
28354	277	3	0	20821	\N
28418	64	5	0	20829	\N
28418	7889	6	0	20831	\N
28476	73	2	0	22643	\N
28476	2766	3	0	22647	\N
28213	149	2	0	23207	\N
28213	1379	3	0	23212	\N
28367	1379	3	0	23213	\N
28211	82	2	0	23792	\N
28211	3401	3	0	23793	\N
28437	214	2	0	24506	\N
28437	1259	3	0	24509	\N
28371	206	2	0	25786	\N
28371	2773	3	0	25788	\N
28322	94	5	0	27122	\N
28322	3153	6	0	27123	\N
28271	96	2	0	29613	\N
28271	2347	3	0	29615	\N
28421	3351	3	0	30252	\N
28444	20	5	0	30531	\N
28444	7893	6	0	30534	\N
28454	202	2	0	31176	\N
28454	2764	3	0	31177	\N
28370	33	2	0	31925	\N
28370	2822	3	0	31927	\N
28357	453	2	0	32966	\N
28357	3366	3	0	32969	\N
28489	2	2	0	35216	\N
28489	2789	3	0	35219	\N
28253	14	2	0	39478	\N
28432	28	1	0	41208	\N
28432	27	3	0	41229	\N
28432	2885	4	0	41231	\N
28402	40	4	0	42143	\N
28423	56	5	0	44674	\N
28423	2727	6	0	44679	\N
28397	75	1	0	45187	\N
28397	1427	2	0	45189	\N
28431	75	2	0	45208	\N
28431	284	3	0	45209	\N
16579	75	10	0	45211	\N
28480	75	2	0	45229	\N
28297	3341	6	0	46510	\N
28428	79	37	0	46559	\N
28428	7891	38	0	46561	\N
28259	102	2	0	48071	\N
28346	102	8	0	48073	\N
28259	3053	3	0	48074	\N
28346	7872	9	0	48079	\N
28392	121	3	0	49025	\N
28392	2317	4	0	49027	\N
28305	137	4	0	49844	\N
28305	4352	5	0	49847	\N
28438	137	2	0	49868	\N
28438	2721	3	0	49875	\N
28326	156	2	0	50445	\N
28326	4485	3	0	50448	\N
28272	170	3	0	50811	\N
28272	4148	4	0	50812	\N
28450	200	2	0	51662	\N
28450	276	3	0	51664	\N
28353	242	0	0	52276	\N
28474	242	2	0	52277	\N
28474	3425	3	0	52279	\N
28463	268	2	0	52680	\N
28463	2800	3	0	52685	\N
28349	316	4	0	54032	\N
28349	2790	5	0	54033	\N
28307	841	3	0	57097	\N
28307	3604	4	0	57100	\N
28483	1914	2	0	58511	\N
28483	1916	3	0	58512	\N
28286	4787	2	0	60364	\N
28286	6245	3	0	60367	\N
28462	6838	3	0	60547	\N
28427	7412	2	0	61103	\N
28427	7430	3	0	61105	\N
28440	2842	3	0	116	\N
28311	2103	3	0	1305	\N
28448	7225	4	0	4057	\N
28501	7225	3	0	4058	\N
28501	7226	4	0	4061	\N
28448	7895	5	0	4062	\N
28358	35	2	0	4304	\N
28358	1191	3	0	4305	\N
28256	4178	2	0	7817	\N
28261	4178	3	0	7818	\N
28256	4247	3	0	7821	\N
28261	4211	4	0	7822	\N
28279	4178	2	0	7825	\N
28313	4178	2	0	7831	\N
28313	4247	3	0	7832	\N
28341	4178	8	0	7833	\N
28372	4178	2	0	7834	\N
28372	4247	3	0	7838	\N
28341	6240	9	0	7839	\N
28386	4178	2	0	7840	\N
28398	4178	2	0	7841	\N
28386	4247	3	0	7842	\N
28398	4247	3	0	7843	\N
28401	4178	4	0	7844	\N
28403	4178	2	0	7845	\N
28401	4331	5	0	7848	\N
28443	4178	2	0	7851	\N
28443	4247	3	0	7853	\N
28471	4178	4	0	7861	\N
28471	4331	5	0	7862	\N
28479	4178	2	0	7863	\N
28506	4178	3	0	7864	\N
28479	4247	3	0	7866	\N
28506	4211	4	0	7867	\N
28267	4172	3	0	9822	\N
28267	4275	4	0	9823	\N
28318	4172	2	0	9828	\N
28496	4172	2	0	9848	\N
28496	4191	3	0	9849	\N
28299	391	2	0	10612	\N
28299	1381	3	0	10613	\N
28469	391	4	0	10631	\N
28469	3352	5	0	10633	\N
28508	300	21	0	12234	\N
28508	7901	22	0	12236	\N
28304	402	3	0	14125	\N
28304	4077	4	0	14129	\N
28504	235	3	0	15837	\N
28504	3343	4	0	15839	\N
28288	4009	3	0	16538	\N
28414	6697	43	0	16959	\N
28475	326	2	0	17527	\N
28475	393	3	0	17529	\N
28363	7874	4	0	17846	\N
28363	3428	5	0	17848	\N
28414	7885	19	0	17850	\N
28414	167	42	0	17866	\N
28414	7886	43	1	17867	\N
28436	30	41	0	18200	\N
28436	7892	42	0	18201	\N
28338	142	2	0	18670	\N
28481	142	2	0	18683	\N
28481	4418	3	0	18684	\N
28456	241	2	0	20607	\N
28456	634	3	0	20611	\N
28445	64	5	0	20840	\N
28499	64	2	0	20841	\N
28499	277	3	0	20842	\N
28445	7889	6	0	20844	\N
28368	145	2	0	21851	\N
28368	1108	3	0	21852	\N
28422	67	2	0	22196	\N
28422	394	3	0	22197	\N
28383	1958	4	0	22636	\N
28390	149	3	0	23209	\N
28390	2374	4	0	23214	\N
28486	214	2	0	24507	\N
28486	1259	3	0	24510	\N
28331	411	6	0	25357	\N
28411	411	3	0	25358	\N
28411	7884	4	0	25361	\N
28331	6310	7	0	25362	\N
28361	6303	2	0	26376	\N
28361	7173	3	0	26378	\N
28254	202	2	0	31158	\N
28292	202	2	0	31166	\N
28356	202	2	0	31167	\N
28292	2764	3	0	31168	\N
28356	2764	3	0	31169	\N
28340	360	2	0	31500	\N
28340	2767	3	0	31501	\N
28464	14	2	0	39486	\N
28464	1785	3	0	39490	\N
28323	7868	4	0	40569	\N
28323	18	8	0	40576	\N
28323	5946	9	0	40577	\N
28433	28	1	0	41209	\N
28433	2885	4	0	41232	\N
28343	40	8	0	42082	\N
28343	3438	9	0	42084	\N
28375	41	1	0	42103	\N
28375	40	3	0	42120	\N
28375	1383	4	0	42121	\N
28467	40	2	0	42156	\N
28348	56	16	0	44670	\N
28348	4791	17	0	44672	\N
28317	75	5	0	45186	\N
28413	75	1	0	45188	\N
28413	1427	2	0	45190	\N
28317	4484	6	0	45191	\N
28566	75	7	0	45264	\N
28566	2859	8	0	45267	\N
28493	79	2	0	46609	\N
28520	79	3	0	46610	\N
28493	616	3	0	46612	\N
28520	3652	4	0	46613	\N
28564	88	7	0	47304	\N
28564	4949	8	0	47309	\N
28360	100	2	0	47738	\N
28360	633	3	0	47739	\N
28315	113	2	0	48384	\N
28315	1899	3	0	48387	\N
28337	125	8	0	49361	\N
28337	6499	9	0	49362	\N
28396	125	2	0	49364	\N
28396	3297	3	0	49367	\N
28525	135	5	0	49601	\N
28525	7905	6	0	49611	\N
28524	137	5	0	49869	\N
28524	7904	6	0	49883	\N
28498	170	7	0	50813	\N
28498	6624	8	0	50814	\N
28562	210	9	0	51987	\N
28562	7912	10	0	51998	\N
28351	242	2	0	52275	\N
28351	3425	3	0	52278	\N
28407	279	2	0	53293	\N
28407	4525	3	0	53295	\N
28335	595	2	0	55696	\N
28335	3285	3	0	55697	\N
28539	597	2	0	56013	\N
28539	3286	3	0	56015	\N
28581	637	5	0	56364	\N
28472	1021	2	0	56502	\N
28472	4432	3	0	56503	\N
28426	2636	2	0	58846	\N
28426	2836	3	0	58849	\N
28552	3628	2	0	59732	\N
28552	4360	3	0	59739	\N
28416	4787	2	0	60366	\N
28416	6245	3	0	60368	\N
28380	6765	2	0	60950	\N
28491	6765	7	0	60952	\N
28380	6841	3	0	60957	\N
28491	7899	8	0	60962	\N
28541	7642	1	0	61109	\N
28541	7412	3	0	61111	\N
28541	7908	4	0	61113	\N
28280	424	2	0	892	\N
28280	2755	3	0	896	\N
28482	117	2	0	2096	\N
28482	1257	3	0	2101	\N
28460	110	2	0	2628	\N
28460	626	3	0	2630	\N
28374	229	1	0	2862	\N
28374	228	3	0	2876	\N
28374	1432	4	0	2878	\N
28382	367	2	0	3494	\N
28382	3329	3	0	3495	\N
28385	1463	2	0	4108	\N
28385	7877	3	0	4109	\N
28332	4362	7	0	5049	\N
28546	189	2	0	5081	\N
28546	3441	3	0	5084	\N
28285	4178	2	0	7827	\N
28285	4247	3	0	7829	\N
28430	4178	2	0	7850	\N
28430	4247	3	0	7852	\N
28518	4178	4	0	7865	\N
28518	4205	5	0	7868	\N
28455	4172	2	0	9842	\N
28466	4172	2	0	9843	\N
28455	4191	3	0	9845	\N
28527	4172	4	0	9850	\N
28527	4219	5	0	9853	\N
28536	4172	4	0	9856	\N
28536	4219	5	0	9857	\N
28535	132	2	0	11487	\N
28535	2756	3	0	11489	\N
28507	300	2	0	12233	\N
28507	2786	3	0	12235	\N
28325	402	2	0	14144	\N
28325	2760	3	0	14148	\N
28532	258	2	0	14477	\N
28532	3275	3	0	14479	\N
28362	2763	3	0	15179	\N
28513	960	5	0	15231	\N
28513	7902	6	0	15232	\N
28393	212	3	0	17197	\N
28393	7880	4	0	17203	\N
28378	326	2	0	17526	\N
28378	393	3	0	17528	\N
28294	167	2	0	17838	\N
28294	3322	3	0	17840	\N
28283	2081	3	0	18810	\N
28283	7866	4	0	18811	\N
28330	290	6	0	19139	\N
28576	60	7	0	19585	\N
28576	4613	8	0	19593	\N
28320	62	3	0	19886	\N
28320	7618	4	0	19888	\N
28291	64	3	0	20804	\N
28291	4217	4	0	20808	\N
28522	140	3	0	24191	\N
28522	4149	4	0	24193	\N
28516	69	4	0	24857	\N
28516	4041	5	0	24866	\N
28365	224	2	0	25629	\N
28365	3150	3	0	25630	\N
28572	7176	7	0	25639	\N
28554	90	4	0	26174	\N
28554	3731	5	0	26177	\N
28529	345	4	0	26304	\N
28543	345	5	0	26305	\N
28529	7906	5	0	26306	\N
28543	7910	6	0	26307	\N
28488	244	3	0	27338	\N
28488	7897	4	0	27340	\N
28534	244	2	0	27353	\N
28534	3308	3	0	27355	\N
28503	54	3	0	30262	\N
28509	202	3	0	31188	\N
28509	4857	4	0	31191	\N
28419	230	4	0	32178	\N
28419	6806	5	0	32179	\N
28477	322	2	0	32394	\N
28477	1866	3	0	32395	\N
28296	2	5	0	35214	\N
28296	3624	6	0	35221	\N
28442	14	2	0	39485	\N
28548	14	2	0	39487	\N
28442	1785	3	0	39489	\N
28548	1785	3	0	39491	\N
28310	4564	6	0	40910	\N
28301	40	6	0	42081	\N
28301	4255	7	0	42083	\N
28355	40	5	0	42101	\N
28355	5806	6	0	42102	\N
28410	40	3	0	42155	\N
28484	40	2	0	42177	\N
28484	282	3	0	42179	\N
28687	40	4	0	42259	\N
28727	40	0	0	42260	\N
28757	40	4	0	42264	\N
28687	3381	5	0	42277	\N
28757	3381	5	0	42278	\N
28753	56	1	0	44613	\N
28753	57	2	0	44621	\N
28626	56	13	0	44698	\N
28626	7930	17	1	44699	\N
28682	56	1	0	44704	\N
28682	1088	2	0	44705	\N
28519	75	3	0	45230	\N
28519	3855	4	0	45232	\N
28558	75	7	0	45252	\N
28558	2859	8	0	45253	\N
28553	79	4	0	46611	\N
28553	3678	5	0	46614	\N
28605	79	4	0	46652	\N
28605	3678	5	0	46654	\N
28505	88	3	0	47303	\N
28505	3655	4	0	47307	\N
28710	100	0	0	47740	\N
28673	113	4	0	48385	\N
28673	5924	5	0	48388	\N
28561	121	9	0	49026	\N
28561	7911	10	0	49028	\N
28575	135	6	0	49602	\N
28575	6389	7	0	49609	\N
28610	137	2	0	49871	\N
28610	2721	3	0	49876	\N
28596	279	9	0	53305	\N
28596	7924	10	0	53311	\N
28623	451	26	0	55436	\N
28623	7925	27	0	55439	\N
28660	451	0	0	55495	\N
28555	1109	4	0	56124	\N
28555	3816	5	0	56132	\N
28581	7921	6	0	56365	\N
28676	908	4	0	57787	\N
28676	6672	5	0	57792	\N
28626	7915	17	0	58554	\N
28733	2636	3	0	58847	\N
28733	2837	4	0	58850	\N
28626	7928	16	0	59458	\N
28696	7954	3	0	59471	\N
28551	3625	2	0	59612	\N
28551	4359	3	0	59620	\N
28617	4233	3	0	60136	\N
28617	4425	4	0	60139	\N
28735	4787	4	0	60371	\N
28735	4847	5	0	60373	\N
28626	7854	15	0	60413	\N
28745	6765	2	0	60953	\N
28745	6841	3	0	60958	\N
28626	7926	14	0	61302	\N
28545	189	3	0	5080	\N
28626	7929	16	1	5233	\N
28571	4178	6	0	7873	\N
28585	4178	9	0	7876	\N
28571	4250	7	0	7878	\N
28585	4682	10	0	7880	\N
28587	4178	3	0	7881	\N
28587	4211	4	0	7882	\N
28590	4450	1	0	7883	\N
28590	4178	4	0	7885	\N
28590	4527	5	0	7886	\N
28603	4178	3	0	7888	\N
28603	4211	4	0	7889	\N
28640	4247	3	0	7896	\N
28678	4178	4	0	7898	\N
28678	4331	5	0	7899	\N
28680	4178	4	0	7900	\N
28703	4178	4	0	7901	\N
28680	4205	5	0	7902	\N
28703	4205	5	0	7903	\N
28714	4178	1	0	7904	\N
28714	4460	2	0	7906	\N
28755	4178	2	0	7909	\N
28755	4247	3	0	7911	\N
28531	4172	8	0	9854	\N
28740	4172	2	0	9866	\N
28740	4191	3	0	9870	\N
28515	391	4	0	10647	\N
28515	3913	5	0	10649	\N
28668	391	4	0	10669	\N
28668	3352	5	0	10670	\N
28638	300	2	0	12245	\N
28638	2786	3	0	12247	\N
28760	123	2	0	12821	\N
28720	402	4	0	14146	\N
28720	4731	5	0	14150	\N
28689	258	2	0	14478	\N
28547	92	2	0	15187	\N
28547	2763	3	0	15188	\N
28485	192	2	0	15368	\N
28485	2761	3	0	15369	\N
28649	192	1	0	15378	\N
28649	193	2	0	15380	\N
28696	7955	3	0	16798	\N
28696	3483	4	0	16799	\N
28698	115	3	0	16807	\N
28698	3483	4	0	16809	\N
28742	212	2	0	17199	\N
28742	3616	3	0	17201	\N
28580	290	5	0	19140	\N
28580	6379	6	0	19141	\N
28584	290	4	0	19143	\N
28584	5879	5	0	19146	\N
28500	208	3	0	19285	\N
28500	4490	4	0	19293	\N
28511	67	3	0	22203	\N
28511	3749	4	0	22205	\N
28692	336	3	0	22873	\N
28692	3400	4	0	22878	\N
28626	7927	15	1	24941	\N
28573	7917	51	0	25637	\N
28573	7918	99	0	25653	\N
28671	224	3	0	25655	\N
28671	3603	4	0	25656	\N
28598	449	3	0	29918	\N
28598	4760	4	0	29923	\N
28563	54	3	0	30267	\N
28563	3041	4	0	30268	\N
28592	54	4	0	30271	\N
28592	3685	5	0	30272	\N
28722	54	7	0	30276	\N
28722	4922	8	0	30282	\N
28626	7570	14	1	30318	\N
28614	7266	8	0	30813	\N
28495	230	2	0	32185	\N
28588	230	0	0	32186	\N
28608	230	2	0	32187	\N
28495	3307	3	0	32190	\N
28608	3307	3	0	32191	\N
28607	230	5	0	32200	\N
28607	1703	6	0	32207	\N
28612	230	0	0	32216	\N
28578	431	7	0	34873	\N
28578	7520	8	0	34874	\N
28538	2	2	0	35250	\N
28538	2789	3	0	35253	\N
28631	2789	3	0	35254	\N
28601	4	3	0	36130	\N
28601	3837	4	0	36135	\N
28652	18	5	0	40584	\N
28652	3550	6	0	40585	\N
28526	40	6	0	42178	\N
28526	4717	7	0	42180	\N
28641	40	2	0	42230	\N
28641	282	3	0	42231	\N
28734	40	5	0	42263	\N
28773	40	1	0	42266	\N
28773	1383	2	0	42272	\N
28734	2192	6	0	42280	\N
28752	56	1	0	44612	\N
28754	56	1	0	44614	\N
28763	56	2	0	44615	\N
28752	57	2	0	44620	\N
28754	57	2	0	44622	\N
28763	2795	3	0	44623	\N
28579	7920	2	0	44696	\N
28579	2914	3	0	44697	\N
28510	71	3	0	44896	\N
28510	3770	4	0	44897	\N
28557	75	3	0	45241	\N
28557	3855	4	0	45242	\N
28667	75	2	0	45280	\N
28667	284	3	0	45281	\N
28721	75	4	0	45289	\N
28762	75	4	0	45290	\N
28721	3959	5	0	45292	\N
28762	7287	5	0	45293	\N
28715	100	0	0	47741	\N
28717	100	0	0	47743	\N
28743	121	2	0	49052	\N
28743	2498	3	0	49053	\N
28611	135	2	0	49603	\N
28611	2722	3	0	49607	\N
28633	181	2	0	51068	\N
28633	3313	3	0	51070	\N
28782	181	6	0	51077	\N
28568	268	9	0	52681	\N
28568	7820	10	0	52687	\N
28502	279	3	0	53304	\N
28502	3641	4	0	53308	\N
28650	285	1	0	53688	\N
28650	286	2	0	53689	\N
28741	7958	52	0	54383	\N
28741	324	126	0	54405	\N
28741	7959	127	0	54406	\N
28540	595	2	0	55712	\N
28540	3285	3	0	55726	\N
28767	598	1	0	56016	\N
28767	597	9	0	56024	\N
28767	3789	10	0	56027	\N
28723	1109	7	0	56126	\N
28756	1109	2	0	56127	\N
28756	2809	3	0	56129	\N
28723	4145	8	0	56135	\N
28600	1021	3	0	56512	\N
28600	4551	4	0	56514	\N
28690	793	4	0	56741	\N
28690	3618	5	0	56742	\N
28709	908	1	0	57789	\N
28709	3149	2	0	57791	\N
28579	7919	2	0	59457	\N
28625	4233	4	0	60140	\N
28625	4234	5	0	60146	\N
28704	5885	3	0	60550	\N
28704	5926	4	0	60556	\N
28537	6450	2	0	60796	\N
28537	6825	3	0	60801	\N
28726	7412	2	0	61114	\N
28726	7430	3	0	61116	\N
28550	1257	3	0	2102	\N
28637	3464	3	0	3232	\N
28544	35	3	0	4309	\N
28544	3563	4	0	4310	\N
28616	189	2	0	5083	\N
28616	3441	3	0	5085	\N
28494	4967	3	0	5401	\N
28521	4178	3	0	7869	\N
28533	4178	2	0	7870	\N
28533	4247	3	0	7871	\N
28521	4211	4	0	7872	\N
28577	4178	7	0	7874	\N
28577	4396	8	0	7879	\N
28661	4178	1	0	7893	\N
28661	4450	2	0	7894	\N
28648	4211	4	0	7897	\N
28779	4178	6	0	7910	\N
28779	4250	7	0	7913	\N
28530	4172	3	0	9851	\N
28530	4275	4	0	9852	\N
28713	4172	1	0	9862	\N
28713	5004	2	0	9864	\N
28769	4172	7	0	9869	\N
28769	4614	8	0	9873	\N
28570	132	9	0	11488	\N
28781	528	6	0	12636	\N
28781	4824	7	0	12641	\N
28760	1868	3	0	12825	\N
28618	77	4	0	13219	\N
28683	77	3	0	13220	\N
28683	1877	4	0	13223	\N
28618	3619	5	0	13224	\N
28758	192	4	0	15379	\N
28758	3895	5	0	15381	\N
28697	115	3	0	16806	\N
28697	3483	4	0	16808	\N
28785	212	3	0	17200	\N
28681	326	2	0	17535	\N
28681	393	3	0	17536	\N
28542	30	17	0	18205	\N
28542	7909	18	0	18206	\N
28775	142	3	0	18689	\N
28775	4254	4	0	18691	\N
28594	208	9	0	19286	\N
28594	7922	10	0	19302	\N
28732	198	3	0	20131	\N
28732	4263	4	0	20135	\N
28663	336	3	0	22860	\N
28663	3400	4	0	22861	\N
28655	7940	7	0	23215	\N
28528	82	4	0	23799	\N
28528	3508	5	0	23800	\N
28591	83	1	0	23801	\N
28591	82	4	0	23810	\N
28591	4753	5	0	23811	\N
28657	82	6	0	23818	\N
28657	3392	7	0	23829	\N
28497	140	2	0	24190	\N
28497	3183	3	0	24192	\N
28764	140	4	0	24212	\N
28764	3821	5	0	24213	\N
28517	2920	3	0	24861	\N
28523	20	5	0	30543	\N
28523	7903	6	0	30544	\N
28560	360	3	0	31510	\N
28560	3602	4	0	31511	\N
28646	360	3	0	31518	\N
28646	3602	4	0	31522	\N
28620	453	4	0	32967	\N
28620	4108	5	0	32971	\N
28512	2	5	0	35237	\N
28512	6376	6	0	35238	\N
28699	2	4	0	35267	\N
28514	18	5	0	40578	\N
28565	18	7	0	40579	\N
28514	4010	6	0	40580	\N
28565	1618	8	0	40581	\N
28686	18	4	0	40586	\N
28686	2302	5	0	40589	\N
28774	23	3	0	40913	\N
28776	23	1	0	40914	\N
28776	1089	2	0	40915	\N
28774	3497	4	0	40916	\N
28606	40	4	0	42195	\N
28606	3381	5	0	42197	\N
28622	40	3	0	42215	\N
28622	372	4	0	42216	\N
28746	56	0	0	44610	\N
28569	7913	5	0	44688	\N
28569	56	22	0	44693	\N
28569	7916	25	1	44695	\N
28630	56	1	0	44700	\N
28630	1088	2	0	44701	\N
28677	56	11	0	44702	\N
28677	2795	12	0	44703	\N
28635	71	6	0	44909	\N
28635	4738	7	0	44912	\N
28651	75	4	0	45265	\N
28651	2357	5	0	45266	\N
28693	75	3	0	45288	\N
28693	3855	4	0	45291	\N
28586	79	3	0	46651	\N
28586	3652	4	0	46653	\N
28599	102	3	0	48090	\N
28599	3597	4	0	48091	\N
28549	119	2	0	48625	\N
28711	119	1	0	48626	\N
28711	3128	2	0	48635	\N
28549	1879	3	0	48637	\N
28574	137	6	0	49870	\N
28574	6388	7	0	49880	\N
28615	181	2	0	51067	\N
28615	3313	3	0	51069	\N
28823	7967	14	0	51357	\N
28823	7968	15	0	51364	\N
28705	268	3	0	52682	\N
28705	3815	4	0	52686	\N
28656	285	6	0	53705	\N
28656	7941	7	0	53708	\N
28624	451	1	0	55437	\N
28624	584	2	0	55438	\N
28644	451	4	0	55455	\N
28659	451	2	0	55456	\N
28659	3317	3	0	55457	\N
28644	3391	5	0	55458	\N
28662	451	1	0	55473	\N
28662	584	2	0	55477	\N
28556	1109	0	0	56125	\N
28627	841	4	0	57107	\N
28627	3886	5	0	57108	\N
28665	2171	69	0	57991	\N
28665	7935	69	1	58416	\N
28569	7915	25	0	58549	\N
28691	4241	3	0	59126	\N
28691	7951	5	1	59127	\N
28569	6474	24	0	59456	\N
28707	3625	1	0	59613	\N
28707	7786	2	0	59617	\N
28670	4233	3	0	60141	\N
28796	4233	3	0	60142	\N
28670	4425	4	0	60144	\N
28796	4425	4	0	60145	\N
28730	4787	4	0	60370	\N
28730	5041	5	0	60372	\N
28567	5885	9	0	60549	\N
28567	7819	10	0	60561	\N
28691	7949	4	0	60579	\N
28665	7944	70	0	60596	\N
28766	7960	1	0	60776	\N
28766	6450	9	0	60797	\N
28766	7961	10	0	60811	\N
28700	3186	4	0	2889	\N
28724	4792	8	0	3505	\N
28595	7225	9	0	4064	\N
28595	7923	10	0	4075	\N
28604	189	3	0	5082	\N
28604	3782	4	0	5087	\N
28569	7846	24	1	5220	\N
28800	4178	0	0	7835	\N
28804	4178	0	0	7846	\N
28582	4178	5	0	7875	\N
28582	4429	6	0	7877	\N
28597	4178	3	0	7884	\N
28597	4211	4	0	7887	\N
28609	4247	3	0	7895	\N
28737	4178	2	0	7905	\N
28737	4247	3	0	7907	\N
28679	4172	4	0	9859	\N
28679	4219	5	0	9860	\N
28744	4172	2	0	9867	\N
28750	4172	3	0	9868	\N
28744	4191	3	0	9871	\N
28750	4275	4	0	9872	\N
28820	4172	2	0	9876	\N
28820	4191	3	0	9877	\N
28593	391	9	0	10648	\N
28664	391	2	0	10661	\N
28664	1381	3	0	10662	\N
28759	108	2	0	11855	\N
28759	3340	3	0	11856	\N
28809	469	3	0	12357	\N
28809	7966	4	0	12359	\N
28684	77	0	0	13221	\N
28719	402	3	0	14145	\N
28719	4077	4	0	14149	\N
28748	402	3	0	14158	\N
28748	4077	4	0	14159	\N
28688	235	3	0	15838	\N
28569	3108	26	0	18766	\N
28691	3264	5	0	18771	\N
28739	290	2	0	19144	\N
28739	1909	3	0	19145	\N
28569	1075	26	1	21827	\N
28665	3009	71	0	21828	\N
28823	1018	15	0	21853	\N
28811	145	3	0	21866	\N
28811	4908	4	0	21867	\N
28802	67	4	0	22204	\N
28802	5267	5	0	22206	\N
28771	82	3	0	23819	\N
28695	69	2	0	24859	\N
28695	3350	3	0	24863	\N
28569	7914	23	1	24940	\N
28672	7946	79	0	25654	\N
28672	224	119	0	25661	\N
28672	7947	120	0	25662	\N
28665	7943	30	0	27126	\N
28665	94	68	0	27129	\N
28665	7945	70	1	27130	\N
28602	96	3	0	29614	\N
28602	2803	4	0	29616	\N
28702	7956	2	0	29640	\N
28778	449	8	0	29919	\N
28632	54	2	0	30275	\N
28632	3351	3	0	30279	\N
28569	7570	23	0	30316	\N
28559	360	13	0	31509	\N
28559	6599	14	0	31512	\N
28589	287	1	0	32180	\N
28613	230	3	0	32188	\N
28589	230	4	0	32189	\N
28589	3006	5	0	32192	\N
28613	4181	4	0	32193	\N
28813	230	3	0	32202	\N
28642	2	4	0	35252	\N
28642	2830	5	0	35255	\N
28583	4	4	0	36122	\N
28583	4117	5	0	36125	\N
28675	14	4	0	39488	\N
28675	2291	5	0	39492	\N
28691	7948	3	0	41252	\N
28691	7950	4	1	41253	\N
28621	40	4	0	42196	\N
28621	3381	5	0	42198	\N
28728	40	0	0	42261	\N
28729	40	0	0	42262	\N
28765	40	0	0	42265	\N
28795	40	3	0	42267	\N
28828	40	7	0	42268	\N
28883	40	3	0	42271	\N
28795	372	4	0	42273	\N
28883	372	4	0	42276	\N
28828	4718	8	0	42279	\N
28747	56	1	0	44611	\N
28747	57	2	0	44619	\N
28787	75	4	0	45304	\N
28787	3959	5	0	45305	\N
28736	79	2	0	46685	\N
28797	79	3	0	46686	\N
28736	616	3	0	46687	\N
28797	3652	4	0	46688	\N
28716	100	1	0	47742	\N
28718	100	0	0	47744	\N
28716	2895	2	0	47745	\N
28867	100	5	0	47746	\N
28867	7057	6	0	47747	\N
28853	113	6	0	48386	\N
28853	3587	7	0	48389	\N
28647	121	3	0	49038	\N
28647	4471	4	0	49039	\N
28780	121	6	0	49062	\N
28780	4686	7	0	49065	\N
28842	137	7	0	49872	\N
28842	4722	8	0	49881	\N
28829	260	7	0	52419	\N
28829	4589	8	0	52422	\N
28706	268	2	0	52683	\N
28706	7957	3	0	52684	\N
28738	324	2	0	54395	\N
28738	2808	3	0	54400	\N
28873	435	5	0	55141	\N
28873	2354	6	0	55142	\N
28643	451	4	0	55459	\N
28643	7939	5	0	55460	\N
28658	451	5	0	55481	\N
28658	7942	6	0	55482	\N
28639	7937	87	0	55528	\N
28768	596	1	0	55701	\N
28768	595	9	0	55725	\N
28768	7962	10	0	55733	\N
28832	793	7	0	56749	\N
28832	4590	8	0	56752	\N
28666	841	2	0	57113	\N
28666	3316	3	0	57116	\N
28879	852	5	0	57429	\N
28879	4420	6	0	57433	\N
28708	908	0	0	57788	\N
28639	2171	85	1	57990	\N
28639	7935	86	0	58415	\N
28817	2636	3	0	58848	\N
28817	2837	4	0	58851	\N
28694	4241	2	0	59128	\N
28712	3628	1	0	59733	\N
28712	7784	2	0	59736	\N
28639	7936	86	1	60595	\N
28761	6723	2	0	60888	\N
28761	6763	3	0	60892	\N
28790	7412	2	0	61115	\N
28790	7430	3	0	61117	\N
28827	7412	3	0	61118	\N
28827	7466	4	0	61119	\N
28839	7412	3	0	61120	\N
28839	7466	4	0	61123	\N
28653	7471	8	0	1306	\N
28793	3920	6	0	1315	\N
28830	117	7	0	2098	\N
28685	228	4	0	2875	\N
28685	4800	5	0	2883	\N
28636	7932	2	0	3229	\N
28636	3464	3	0	3231	\N
28619	4049	5	0	4676	\N
28749	4178	3	0	7908	\N
28749	4211	4	0	7912	\N
28822	4178	2	0	7916	\N
28822	4247	3	0	7917	\N
28865	4178	3	0	7920	\N
28875	4211	4	0	7923	\N
28865	4441	4	0	7925	\N
28654	4172	6	0	9858	\N
28654	4365	7	0	9861	\N
28731	4172	4	0	9863	\N
28731	4219	5	0	9865	\N
28791	4172	4	0	9874	\N
28791	4219	5	0	9875	\N
28834	4172	6	0	9878	\N
28834	4197	7	0	9879	\N
28819	391	3	0	10683	\N
28819	3660	4	0	10684	\N
28772	4060	5	0	11862	\N
28639	7933	67	0	12237	\N
28639	300	84	0	12249	\N
28639	7934	85	0	12250	\N
28901	7976	29	0	14482	\N
28669	173	3	0	14732	\N
28860	173	3	0	14733	\N
28669	3796	4	0	14734	\N
28860	3796	4	0	14735	\N
28777	44	8	0	16212	\N
28777	6094	9	0	16214	\N
28805	4463	5	0	16215	\N
28805	2997	8	0	16221	\N
28634	38	6	0	16546	\N
28634	6005	7	0	16547	\N
28798	115	3	0	16816	\N
28798	7965	4	0	16818	\N
28751	167	2	0	17863	\N
28751	3322	3	0	17865	\N
28694	6199	3	1	18772	\N
28856	2081	17	0	18812	\N
28856	7971	18	0	18813	\N
28818	60	3	0	19586	\N
28818	3585	4	0	19591	\N
28694	7952	2	0	24852	\N
28694	7953	3	0	24862	\N
28848	69	0	0	24872	\N
28629	6303	12	0	26377	\N
28629	7931	13	0	26379	\N
28701	7956	0	0	29639	\N
28778	7963	9	0	29925	\N
28850	54	6	0	30278	\N
28850	5204	7	0	30281	\N
28807	20	3	0	30548	\N
28807	2844	4	0	30552	\N
28645	360	2	0	31517	\N
28784	33	5	0	31926	\N
28784	4492	6	0	31928	\N
28815	33	3	0	31934	\N
28815	3342	4	0	31937	\N
28674	230	4	0	32201	\N
28674	6806	5	0	32205	\N
28725	453	2	0	32968	\N
28725	3366	3	0	32970	\N
28808	2	3	0	35297	\N
28808	3548	4	0	35299	\N
28628	18	3	0	40582	\N
28628	3621	4	0	40583	\N
28788	1685	3	0	40588	\N
28894	23	4	0	40919	\N
28894	3189	5	0	40922	\N
28770	27	3	0	41266	\N
28770	3714	4	0	41267	\N
28881	40	3	0	42270	\N
28881	372	4	0	42275	\N
28955	40	3	0	42314	\N
29002	40	4	0	42315	\N
28955	372	4	0	42316	\N
29002	3381	5	0	42317	\N
28799	56	2	0	44616	\N
28799	2914	3	0	44618	\N
28812	56	2	0	44627	\N
28812	2795	3	0	44629	\N
29022	56	4	0	44635	\N
29022	3127	5	0	44638	\N
28806	4484	5	0	45306	\N
28806	75	7	0	45313	\N
28806	1427	8	0	45314	\N
28897	79	4	0	46724	\N
28897	3678	5	0	46727	\N
29029	79	6	0	46816	\N
29014	100	6	0	47750	\N
29014	7216	7	0	47752	\N
28886	3347	5	0	49610	\N
28886	135	8	0	49617	\N
28886	3088	9	0	49619	\N
28950	135	1	0	49634	\N
28950	136	2	0	49635	\N
28931	170	7	0	50815	\N
28936	170	3	0	50816	\N
28936	4148	4	0	50817	\N
28931	4591	8	0	50818	\N
28997	170	3	0	50819	\N
28997	4148	4	0	50825	\N
28833	181	1	0	51078	\N
28833	2898	2	0	51079	\N
28782	4256	7	0	51080	\N
28838	181	3	0	51085	\N
28838	4184	4	0	51086	\N
28926	181	7	0	51096	\N
28926	4137	8	0	51099	\N
28826	186	8	0	51362	\N
28826	5991	9	0	51363	\N
28914	210	1	0	51988	\N
28914	2926	2	0	51993	\N
29016	285	3	0	53706	\N
29016	4496	4	0	53707	\N
28789	908	10	0	57790	\N
28789	7013	11	0	57793	\N
28872	1470	5	0	58359	\N
28872	6556	6	0	58362	\N
28987	3843	4	1	59129	\N
28863	4233	4	0	60143	\N
28863	4234	5	0	60147	\N
28945	4233	3	0	60150	\N
29005	4233	7	0	60151	\N
28945	4425	4	0	60156	\N
29005	5582	8	0	60159	\N
28958	4787	7	0	60375	\N
28958	7384	8	0	60381	\N
28786	6765	3	0	60954	\N
28922	6765	5	0	60955	\N
28786	6884	4	0	60959	\N
28922	7983	6	0	60961	\N
28843	7412	2	0	61121	\N
28843	7430	3	0	61122	\N
28907	7412	3	0	61126	\N
28989	7412	2	0	61127	\N
28907	7466	4	0	61128	\N
28989	7990	3	0	61129	\N
28993	3653	4	0	2103	\N
28924	5491	8	0	2895	\N
28824	35	8	0	4313	\N
28824	3956	9	0	4318	\N
28801	4178	0	0	7836	\N
28803	4178	0	0	7837	\N
28821	4178	3	0	7914	\N
28821	4211	4	0	7915	\N
28932	4178	3	0	7935	\N
28946	4178	10	0	7942	\N
28946	4665	11	0	7943	\N
28857	4172	17	0	9880	\N
28868	4172	2	0	9881	\N
28857	7972	18	0	9883	\N
28816	391	3	0	10677	\N
28816	3660	4	0	10678	\N
28810	469	3	0	12358	\N
28810	7966	4	0	12360	\N
28861	528	3	0	12637	\N
28861	4262	4	0	12640	\N
28962	233	3	0	13965	\N
28962	3704	4	0	13968	\N
28901	258	52	0	14498	\N
28901	2725	53	0	14499	\N
28903	92	9	0	15197	\N
28912	192	1	0	15395	\N
28912	2944	2	0	15396	\N
28977	192	3	0	15403	\N
28977	3790	4	0	15406	\N
28987	235	3	0	15853	\N
28987	7989	4	0	15857	\N
28923	44	5	0	16216	\N
28923	4463	6	0	16219	\N
28938	38	3	0	16552	\N
28938	3457	4	0	16553	\N
28921	212	5	0	17209	\N
28921	4580	6	0	17210	\N
28870	3339	4	0	17545	\N
28893	290	4	0	19147	\N
28893	5879	5	0	19150	\N
28974	198	3	0	20142	\N
28974	4263	4	0	20143	\N
28794	64	5	0	20851	\N
28794	7964	6	0	20852	\N
28917	140	2	0	24219	\N
28968	140	3	0	24220	\N
28917	2910	3	0	24222	\N
28968	4149	4	0	24223	\N
28972	140	4	0	24230	\N
28845	69	4	0	24871	\N
28970	69	4	0	24875	\N
28845	4041	5	0	24882	\N
28970	4041	5	0	24883	\N
28966	224	5	0	25665	\N
28966	4419	6	0	25669	\N
28831	90	7	0	26175	\N
28831	4849	8	0	26178	\N
29020	94	2	0	27131	\N
29020	2794	3	0	27132	\N
28905	7978	44	0	29906	\N
28905	449	64	0	29927	\N
28792	54	5	0	30277	\N
28792	7075	6	0	30280	\N
28910	54	3	0	30287	\N
28910	3041	4	0	30288	\N
28836	20	3	0	30549	\N
29025	20	5	0	30550	\N
29027	20	5	0	30551	\N
28836	2844	4	0	30553	\N
29025	6631	6	0	30554	\N
29027	6631	6	0	30555	\N
28814	33	1	0	31933	\N
28814	3119	2	0	31936	\N
28908	3342	4	0	31945	\N
28783	2	4	0	35285	\N
28783	3510	5	0	35286	\N
29011	2	4	0	35308	\N
29011	3510	5	0	35310	\N
28874	18	1	0	40590	\N
28874	1426	2	0	40591	\N
28895	23	3	0	40920	\N
28895	3497	4	0	40921	\N
28876	40	3	0	42269	\N
28876	372	4	0	42274	\N
28928	40	4	0	42298	\N
28928	3381	5	0	42299	\N
29038	40	4	0	42328	\N
29038	3381	5	0	42329	\N
29053	40	3	0	42349	\N
29053	372	4	0	42352	\N
29000	75	3	0	45326	\N
29058	75	3	0	45327	\N
29000	3855	4	0	45330	\N
29058	3855	4	0	45331	\N
29062	79	9	0	46817	\N
29029	4253	7	0	46823	\N
29062	3758	10	0	46825	\N
28980	100	3	0	47748	\N
28980	3836	4	0	47749	\N
28976	121	6	0	49068	\N
28976	4686	7	0	49074	\N
28888	125	4	0	49365	\N
28888	4056	5	0	49368	\N
28915	210	2	0	51989	\N
28915	6179	3	0	51994	\N
29077	210	4	0	52010	\N
29077	3536	5	0	52012	\N
29006	260	3	0	52420	\N
29006	3399	4	0	52421	\N
29061	268	9	0	52694	\N
29061	7820	10	0	52697	\N
29093	324	3	0	54397	\N
29093	4514	4	0	54402	\N
29067	597	4	0	56023	\N
29067	3733	5	0	56025	\N
28978	1021	3	0	56513	\N
28978	4551	4	0	56515	\N
29024	908	5	0	57800	\N
29024	5076	6	0	57803	\N
29083	1587	3	0	58435	\N
29083	7996	4	0	58436	\N
28913	2636	2	0	58858	\N
28919	2636	0	0	58859	\N
28940	2636	3	0	58860	\N
28913	7981	3	0	58862	\N
28940	2837	4	0	58864	\N
29052	3628	3	0	59734	\N
29052	3785	4	0	59742	\N
29047	4088	6	0	59931	\N
29110	4088	4	0	59932	\N
29110	4089	5	0	59934	\N
29047	4246	7	0	59935	\N
28855	7412	10	0	61124	\N
28855	7568	11	0	61125	\N
29036	839	2	0	666	\N
28918	251	2	0	1551	\N
28918	3011	3	0	1554	\N
28825	6851	9	0	1558	\N
28866	110	3	0	2629	\N
28866	2995	4	0	2631	\N
29041	110	3	0	2648	\N
29041	2995	4	0	2649	\N
28837	367	3	0	3514	\N
28892	367	6	0	3516	\N
28837	3683	4	0	3517	\N
28892	6013	7	0	3518	\N
29106	367	4	0	3530	\N
28942	189	2	0	5097	\N
28942	3441	3	0	5104	\N
28880	4178	3	0	7922	\N
28880	4211	4	0	7924	\N
28890	4178	6	0	7930	\N
28899	4178	3	0	7931	\N
28899	4211	4	0	7932	\N
28890	4250	7	0	7933	\N
28944	4178	3	0	7940	\N
28944	4211	4	0	7941	\N
28991	4178	3	0	7945	\N
28991	4211	4	0	7948	\N
29044	4178	3	0	7959	\N
29044	4211	4	0	7960	\N
29034	4331	5	0	7961	\N
29049	4178	3	0	7962	\N
29049	4211	4	0	7963	\N
29085	4178	4	0	7966	\N
29099	4178	2	0	7967	\N
29099	4247	3	0	7968	\N
29085	4205	5	0	7970	\N
29119	4247	2	0	7971	\N
29119	4178	5	0	7975	\N
29119	4527	6	0	7976	\N
29120	4429	6	0	7978	\N
28878	4172	5	0	9884	\N
28878	4415	6	0	9885	\N
28930	4172	7	0	9886	\N
28930	4614	8	0	9887	\N
28983	7987	4	0	9888	\N
28965	4172	5	0	9890	\N
29037	4172	2	0	9892	\N
29037	4191	3	0	9894	\N
28965	4415	6	0	9895	\N
28983	4172	9	0	9897	\N
28983	7178	10	0	9898	\N
29102	4663	11	0	9904	\N
29104	4172	2	0	9905	\N
29104	4191	3	0	9906	\N
28835	391	6	0	10695	\N
28835	3521	7	0	10696	\N
29097	77	4	0	13239	\N
29097	3619	5	0	13245	\N
28985	235	3	0	15852	\N
28985	3343	4	0	15858	\N
29087	38	2	0	16561	\N
29087	4009	3	0	16562	\N
28851	370	6	0	16598	\N
28956	326	3	0	17544	\N
28956	3339	4	0	17546	\N
29048	30	6	0	18197	\N
29048	2931	7	0	18199	\N
28998	290	3	0	19148	\N
28998	3635	4	0	19149	\N
29008	64	5	0	20857	\N
29008	7964	6	0	20861	\N
29115	488	8	0	21578	\N
29115	8002	9	0	21579	\N
29070	214	3	0	24508	\N
29070	3496	4	0	24511	\N
28859	69	3	0	24874	\N
28859	4536	4	0	24879	\N
28960	6303	3	0	26380	\N
28960	6304	4	0	26381	\N
29075	3308	2	0	27357	\N
29127	244	12	0	27365	\N
29075	244	4	0	27366	\N
29075	2960	5	0	27367	\N
29045	360	3	0	31519	\N
29045	3602	4	0	31523	\N
28871	33	4	0	31935	\N
28871	5122	5	0	31938	\N
29043	4182	7	0	32206	\N
28954	322	3	0	32401	\N
28954	1105	4	0	32402	\N
29013	4	3	0	36131	\N
29013	3837	4	0	36136	\N
29032	6	3	0	36396	\N
29032	4823	4	0	36400	\N
28846	14	4	0	39496	\N
28846	3498	5	0	39497	\N
29114	14	8	0	39500	\N
29114	6577	9	0	39505	\N
28902	40	9	0	42297	\N
28902	4712	10	0	42300	\N
29042	40	6	0	42348	\N
29042	4255	7	0	42354	\N
28869	56	3	0	44628	\N
28869	4109	4	0	44630	\N
28858	75	17	0	45323	\N
28882	75	3	0	45324	\N
28882	3855	4	0	45328	\N
28858	7973	18	0	45332	\N
28898	79	3	0	46725	\N
28898	3652	4	0	46726	\N
28925	79	7	0	46752	\N
28925	5706	8	0	46753	\N
29039	102	4	0	48098	\N
29039	3572	5	0	48103	\N
29144	113	3	0	48400	\N
29144	3620	4	0	48401	\N
29050	119	3	0	48627	\N
29050	2860	4	0	48639	\N
28906	121	6	0	49063	\N
28906	7980	7	0	49064	\N
28841	135	7	0	49616	\N
28841	4721	8	0	49618	\N
28885	3346	5	0	49849	\N
28949	137	2	0	49873	\N
28994	137	3	0	49874	\N
28949	2721	3	0	49877	\N
28994	3633	4	0	49878	\N
28885	137	8	0	49879	\N
28885	3089	9	0	49882	\N
28951	181	5	0	51097	\N
28951	7985	6	0	51098	\N
28947	210	10	0	51990	\N
28947	7984	11	0	51999	\N
29074	3425	2	0	52281	\N
29074	242	4	0	52290	\N
29074	2768	5	0	52291	\N
29141	260	3	0	52425	\N
29141	3399	4	0	52428	\N
28929	908	2	0	57794	\N
28929	2832	3	0	57795	\N
29001	908	6	0	57798	\N
29001	3555	7	0	57799	\N
29026	908	5	0	57801	\N
29026	5076	6	0	57804	\N
28887	7974	2	0	58098	\N
29163	3625	2	0	59615	\N
29163	8015	3	0	59618	\N
28877	4233	3	0	60148	\N
28877	4425	4	0	60149	\N
29056	4233	6	0	60152	\N
29154	4233	3	0	60154	\N
29154	4425	4	0	60157	\N
29056	6364	7	0	60158	\N
29059	5885	9	0	60551	\N
29059	7819	10	0	60562	\N
29065	6450	4	0	60813	\N
29065	6467	5	0	60823	\N
28963	7412	4	0	61130	\N
28963	7499	5	0	61133	\N
28920	7982	4	0	445	\N
28916	3038	3	0	906	\N
29089	424	4	0	918	\N
29089	3188	5	0	919	\N
28830	5276	8	0	2104	\N
29138	117	6	0	2122	\N
29138	3804	7	0	2123	\N
29086	228	4	0	2893	\N
29086	4800	5	0	2894	\N
28889	367	0	0	3515	\N
28896	35	4	0	4314	\N
29135	35	7	0	4315	\N
28896	3545	5	0	4316	\N
28852	4211	3	0	7918	\N
28852	4178	4	0	7919	\N
28884	4178	5	0	7926	\N
28884	4429	6	0	7927	\N
28887	7975	2	0	7928	\N
28887	4247	3	0	7929	\N
28927	4178	4	0	7934	\N
28935	4178	4	0	7936	\N
28927	4205	5	0	7938	\N
28935	4205	5	0	7939	\N
28981	4178	3	0	7944	\N
28996	4178	3	0	7946	\N
28996	4211	4	0	7949	\N
29003	4178	2	0	7950	\N
29003	4247	3	0	7951	\N
29012	4178	3	0	7954	\N
29012	4211	4	0	7955	\N
29019	4178	3	0	7956	\N
29019	4211	4	0	7957	\N
28959	4172	7	0	9889	\N
28959	4614	8	0	9896	\N
29080	4172	3	0	9899	\N
29080	4275	4	0	9901	\N
29082	300	3	0	12246	\N
29078	77	4	0	13237	\N
29078	3619	5	0	13244	\N
29030	92	6	0	15198	\N
29030	3651	7	0	15199	\N
28967	44	5	0	16217	\N
28967	4463	6	0	16220	\N
29063	326	9	0	17551	\N
29167	326	2	0	17552	\N
29167	6910	3	0	17554	\N
29063	4073	10	0	17555	\N
28840	30	7	0	18192	\N
28840	3942	8	0	18193	\N
28862	3640	4	0	18198	\N
28854	927	6	0	19171	\N
28854	7970	7	0	19176	\N
28937	62	3	0	19895	\N
28979	62	3	0	19896	\N
28937	3344	4	0	19897	\N
28979	3344	4	0	19898	\N
29017	62	7	0	19905	\N
29017	7992	8	0	19906	\N
28933	241	3	0	20608	\N
28933	3613	4	0	20613	\N
28953	149	2	0	23222	\N
28847	140	4	0	24218	\N
28847	3821	5	0	24224	\N
28849	69	0	0	24873	\N
28971	69	3	0	24876	\N
28971	4536	4	0	24880	\N
28909	224	3	0	25663	\N
28909	3603	4	0	25668	\N
28864	86	3	0	26497	\N
28864	5465	4	0	26498	\N
28900	94	2	0	27117	\N
28904	94	6	0	27118	\N
28900	2794	3	0	27119	\N
28911	94	5	0	27124	\N
28911	3153	6	0	27125	\N
29054	244	3	0	27354	\N
29054	4075	4	0	27356	\N
29127	8006	13	0	27368	\N
29132	244	10	0	27380	\N
29132	8009	11	0	27381	\N
28891	54	6	0	30286	\N
28891	5204	7	0	30289	\N
29010	5887	4	0	30905	\N
29010	7991	5	0	30907	\N
28999	322	3	0	32407	\N
28986	2	3	0	35298	\N
28986	3548	4	0	35300	\N
29131	40	8	0	42350	\N
29131	3718	9	0	42355	\N
29186	40	6	0	42381	\N
29186	4255	7	0	42384	\N
28939	75	3	0	45325	\N
28939	3855	4	0	45329	\N
29091	75	6	0	45342	\N
29091	3361	7	0	45343	\N
28992	79	3	0	46788	\N
28992	3652	4	0	46789	\N
29116	79	8	0	46819	\N
29116	4238	9	0	46824	\N
29166	119	0	0	48628	\N
28952	125	4	0	49369	\N
28952	4056	5	0	49370	\N
28995	135	3	0	49644	\N
28995	3630	4	0	49648	\N
29023	156	4	0	50447	\N
29023	5935	5	0	50450	\N
29031	156	3	0	50451	\N
29031	4594	4	0	50452	\N
28948	210	0	0	51991	\N
29004	210	7	0	51992	\N
29004	5940	8	0	51997	\N
29121	285	4	0	53710	\N
29121	3674	5	0	53714	\N
29146	324	2	0	54398	\N
29146	2808	3	0	54401	\N
29159	8011	32	0	55496	\N
29159	451	46	0	55503	\N
29159	8012	47	0	55504	\N
28957	908	7	0	57796	\N
28957	4078	8	0	57797	\N
28941	2636	2	0	58861	\N
28941	2836	3	0	58863	\N
29051	3625	3	0	59614	\N
29051	3784	4	0	59622	\N
28961	4088	3	0	59930	\N
28961	4506	4	0	59933	\N
29071	4787	1	0	60376	\N
29071	7995	2	0	60378	\N
28988	7412	2	0	61131	\N
28990	7412	2	0	61132	\N
28988	7990	3	0	61134	\N
28990	7990	3	0	61135	\N
29112	7412	3	0	61136	\N
29112	7466	4	0	61137	\N
29130	7171	9	0	122	\N
29133	2804	3	0	456	\N
29126	8004	63	0	1123	\N
29126	8005	64	0	1124	\N
29176	266	2	0	1310	\N
29176	2103	3	0	1314	\N
29064	117	9	0	2100	\N
29064	7994	10	0	2105	\N
29191	228	4	0	2902	\N
29191	4800	5	0	2904	\N
29098	7998	1	0	3959	\N
29098	262	13	0	3977	\N
29098	7999	14	0	3978	\N
29033	189	3	0	5099	\N
28943	3782	4	0	5105	\N
29033	3782	4	0	5106	\N
28932	4211	4	0	7937	\N
29007	4178	5	0	7952	\N
29007	4429	6	0	7953	\N
29057	4178	3	0	7964	\N
29060	4178	9	0	7965	\N
29057	4211	4	0	7969	\N
29060	4682	10	0	7972	\N
29021	4172	2	0	9891	\N
29021	4191	3	0	9893	\N
29123	4219	5	0	9908	\N
29181	4172	3	0	9913	\N
29181	4275	4	0	9914	\N
28982	7986	4	0	10697	\N
28982	391	9	0	10706	\N
28982	3123	10	0	10707	\N
29055	391	6	0	10712	\N
29055	3521	7	0	10713	\N
29066	391	4	0	10726	\N
29066	3913	5	0	10727	\N
29173	391	3	0	10748	\N
29173	3660	4	0	10749	\N
29122	3716	5	0	11507	\N
29079	77	3	0	13238	\N
29079	1877	4	0	13243	\N
29046	233	6	0	13966	\N
29046	4245	7	0	13971	\N
29159	8013	47	1	14001	\N
28975	173	6	0	14743	\N
28975	3606	7	0	14744	\N
28984	235	60	0	15851	\N
28984	7988	61	0	15863	\N
29178	44	3	0	16222	\N
29178	3631	4	0	16223	\N
29040	3483	4	0	16819	\N
29107	115	3	0	16826	\N
29107	3483	4	0	16827	\N
29028	142	7	0	18690	\N
29028	7993	8	0	18692	\N
29170	60	5	0	19589	\N
29170	8017	6	0	19595	\N
29096	62	4	0	19915	\N
29096	4059	5	0	19920	\N
28934	241	2	0	20609	\N
28934	634	3	0	20612	\N
29009	145	4	0	21914	\N
29018	67	3	0	22213	\N
29018	3749	4	0	22214	\N
29184	254	54	0	22318	\N
29184	8021	55	0	22321	\N
29073	1379	2	0	23224	\N
29073	149	4	0	23233	\N
29073	2985	5	0	23234	\N
28969	140	4	0	24221	\N
28969	3821	5	0	24225	\N
29109	140	5	0	24242	\N
29109	5000	6	0	24243	\N
29143	214	9	0	24525	\N
28964	224	1	0	25664	\N
29125	224	6	0	25666	\N
28964	2813	2	0	25667	\N
29125	7176	7	0	25670	\N
28973	206	4	0	25787	\N
28973	3511	5	0	25789	\N
29188	6303	3	0	26382	\N
29188	6304	4	0	26383	\N
29149	86	6	0	26503	\N
29149	7357	7	0	26504	\N
29151	86	3	0	26507	\N
29151	3746	4	0	26508	\N
29015	4696	7	0	27128	\N
29095	54	4	0	30301	\N
29095	3685	5	0	30303	\N
29172	202	8	0	31203	\N
29172	8018	9	0	31210	\N
29157	33	2	0	31943	\N
29157	2822	3	0	31944	\N
29035	2	4	0	35309	\N
29035	2830	5	0	35311	\N
29100	2	2	0	35320	\N
29100	2789	3	0	35324	\N
29118	8003	116	0	39498	\N
29118	7465	127	0	39507	\N
29139	23	3	0	40927	\N
29139	3497	4	0	40929	\N
29084	3652	4	0	46822	\N
29320	79	3	0	46843	\N
29320	3652	4	0	46846	\N
29145	113	2	0	48415	\N
29145	1899	3	0	48416	\N
29249	113	3	0	48422	\N
29249	3620	4	0	48424	\N
29101	121	10	0	49069	\N
29101	6542	11	0	49075	\N
29289	121	7	0	49078	\N
29289	7263	8	0	49079	\N
29304	181	5	0	51113	\N
29304	7620	6	0	51114	\N
29076	210	4	0	52009	\N
29076	3536	5	0	52011	\N
29090	324	6	0	54396	\N
29090	7997	7	0	54404	\N
29068	595	4	0	55713	\N
29205	595	6	0	55714	\N
29068	3878	5	0	55728	\N
29205	8025	7	0	55731	\N
29206	8026	6	0	56022	\N
29206	8028	7	1	56026	\N
29238	597	4	0	56065	\N
29238	3733	5	0	56066	\N
29203	7277	7	0	57992	\N
29206	7277	6	0	57993	\N
29206	8029	8	0	57994	\N
29210	8036	4	1	58002	\N
29165	2351	2	0	59086	\N
29165	4711	3	0	59088	\N
29072	6245	2	0	60374	\N
29072	4787	4	0	60379	\N
29072	6663	5	0	60380	\N
29206	7949	8	1	60580	\N
29113	7412	6	0	61138	\N
29113	7507	7	0	61139	\N
29212	3611	4	0	938	\N
29232	3514	4	0	1556	\N
29247	367	4	0	3542	\N
29247	3679	5	0	3543	\N
29094	262	4	0	3970	\N
29094	4607	5	0	3973	\N
29203	2828	6	0	3975	\N
29203	8024	7	0	3985	\N
29103	4178	2	0	7973	\N
29103	4247	3	0	7974	\N
29124	4178	3	0	7979	\N
29124	4211	4	0	7980	\N
29129	4178	4	0	7981	\N
29262	4178	12	0	7993	\N
29262	5083	13	0	7994	\N
29275	4178	3	0	7997	\N
29275	4211	4	0	8000	\N
29311	4178	7	0	8001	\N
29311	4396	8	0	8002	\N
29318	4178	2	0	8005	\N
29318	4247	3	0	8006	\N
29088	4172	3	0	9900	\N
29088	4275	4	0	9902	\N
29142	4172	9	0	9909	\N
29142	4977	10	0	9910	\N
29175	4275	4	0	9912	\N
29244	4172	3	0	9925	\N
29244	4275	4	0	9927	\N
29258	4172	3	0	9929	\N
29258	4275	4	0	9930	\N
29285	4172	3	0	9933	\N
29306	4172	4	0	9936	\N
29285	4275	4	0	9938	\N
29306	4219	5	0	9939	\N
29140	391	3	0	10736	\N
29140	3660	4	0	10737	\N
29108	132	3	0	11502	\N
29111	233	4	0	13974	\N
29111	3775	5	0	13979	\N
29128	8007	103	0	14500	\N
29128	258	126	0	14506	\N
29128	8008	127	0	14507	\N
29162	8014	103	0	14508	\N
29162	258	126	0	14518	\N
29162	2725	127	0	14519	\N
29271	258	20	0	14523	\N
29271	8042	21	0	14524	\N
29197	173	4	0	14754	\N
29197	3614	5	0	14755	\N
29256	3457	4	0	16568	\N
29208	8031	83	0	18195	\N
29208	30	126	0	18202	\N
29208	8032	127	0	18203	\N
29092	142	3	0	18697	\N
29092	4254	4	0	18698	\N
29152	60	3	0	19587	\N
29169	60	8	0	19588	\N
29171	60	3	0	19590	\N
29152	3585	4	0	19592	\N
29171	1493	4	0	19594	\N
29169	7625	9	0	19596	\N
29254	3344	4	0	19919	\N
29194	73	5	0	22644	\N
29194	4931	6	0	22650	\N
29214	336	4	0	22874	\N
29214	3947	5	0	22879	\N
29200	8022	6	0	23005	\N
29202	8022	6	0	23007	\N
29200	1935	9	0	23015	\N
29202	1935	9	0	23017	\N
29200	8023	10	0	23019	\N
29202	8023	10	0	23021	\N
29189	149	2	0	23241	\N
29081	140	2	0	24238	\N
29081	3183	3	0	24239	\N
29206	8027	7	0	24934	\N
29137	224	6	0	25675	\N
29137	7176	7	0	25681	\N
29105	8000	73	0	25772	\N
29105	206	126	0	25790	\N
29105	8001	127	0	25791	\N
29210	90	3	0	26194	\N
29211	90	3	0	26195	\N
29210	8035	4	0	26197	\N
29211	4074	4	0	26198	\N
29323	3746	4	0	26517	\N
29227	244	3	0	27391	\N
29227	4075	4	0	27392	\N
29069	202	2	0	31189	\N
29069	2764	3	0	31190	\N
29179	202	3	0	31204	\N
29225	202	3	0	31205	\N
29179	4857	4	0	31207	\N
29225	4857	4	0	31208	\N
29148	360	4	0	31520	\N
29148	3513	5	0	31524	\N
29283	230	3	0	32214	\N
29187	2	6	0	35321	\N
29280	2	7	0	35323	\N
29187	4825	7	0	35325	\N
29280	2858	8	0	35326	\N
29223	4	3	0	36133	\N
29223	3837	4	0	36137	\N
29156	18	9	0	40592	\N
29251	18	2	0	40593	\N
29251	1685	3	0	40594	\N
29156	4047	10	0	40595	\N
29117	27	8	0	41279	\N
29117	7150	9	0	41281	\N
29150	40	5	0	42351	\N
29150	2714	6	0	42353	\N
29296	40	4	0	42406	\N
29296	3381	5	0	42408	\N
29329	40	7	0	42441	\N
29329	4718	8	0	42442	\N
29340	40	3	0	42454	\N
29340	372	4	0	42455	\N
29344	40	6	0	42480	\N
29344	4255	7	0	42482	\N
29243	56	3	0	44636	\N
29243	4109	4	0	44637	\N
29331	8054	64	0	44915	\N
29331	71	126	0	44926	\N
29331	8055	127	0	44927	\N
29136	79	2	0	46820	\N
29136	616	3	0	46821	\N
29282	79	3	0	46842	\N
29282	3652	4	0	46845	\N
29363	79	3	0	46873	\N
29363	3652	4	0	46874	\N
29371	79	3	0	46897	\N
29371	3652	4	0	46900	\N
29327	119	2	0	48629	\N
29327	1879	3	0	48638	\N
29347	125	3	0	49372	\N
29347	4170	4	0	49373	\N
29288	135	3	0	49645	\N
29288	3630	4	0	49649	\N
29339	170	4	0	50820	\N
29339	4680	5	0	50826	\N
29196	186	3	0	51378	\N
29196	3722	4	0	51383	\N
29190	210	4	0	52017	\N
29190	3536	5	0	52020	\N
29357	242	4	0	52287	\N
29357	3512	5	0	52293	\N
29160	451	2	0	55474	\N
29160	3317	3	0	55478	\N
29292	2435	5	0	57870	\N
29147	2636	4	0	58867	\N
29147	3617	5	0	58870	\N
29180	2351	3	0	59087	\N
29180	2845	4	0	59089	\N
29164	3628	2	0	59735	\N
29164	8016	3	0	59737	\N
29356	4088	4	0	59936	\N
29356	4089	5	0	59937	\N
29153	4233	2	0	60153	\N
29153	5577	3	0	60155	\N
29207	6450	6	0	60814	\N
29207	8030	7	0	60826	\N
29276	7412	3	0	61140	\N
29299	7412	5	0	61141	\N
29305	7412	4	0	61142	\N
29307	7412	1	0	61143	\N
29345	7412	3	0	61144	\N
29307	7642	2	0	61145	\N
29276	7466	4	0	61146	\N
29345	7466	4	0	61147	\N
29305	7499	5	0	61148	\N
29299	7478	6	0	61149	\N
29209	8033	3	0	61206	\N
29158	424	2	0	933	\N
29158	2755	3	0	936	\N
29213	2755	3	0	937	\N
29240	424	2	0	956	\N
29240	2755	3	0	957	\N
29174	251	3	0	1552	\N
29174	3514	4	0	1555	\N
29268	1949	4	0	1743	\N
29268	8040	5	0	1744	\N
29322	657	4	0	3057	\N
29322	8053	5	0	3058	\N
29199	2828	6	0	3974	\N
29199	262	9	0	3986	\N
29309	262	3	0	3998	\N
29309	4778	4	0	3999	\N
29217	189	3	0	5100	\N
29217	3782	4	0	5107	\N
29168	4178	5	0	7983	\N
29215	4178	4	0	7984	\N
29215	4205	5	0	7985	\N
29168	4333	6	0	7986	\N
29236	4178	4	0	7989	\N
29236	4205	5	0	7991	\N
29290	4178	2	0	7998	\N
29290	4247	3	0	7999	\N
29335	4205	5	0	8008	\N
29341	4178	3	0	8009	\N
29341	4211	4	0	8010	\N
29343	4178	6	0	8011	\N
29343	4250	7	0	8012	\N
29192	4172	4	0	9915	\N
29192	4219	5	0	9916	\N
29229	4172	5	0	9918	\N
29229	4415	6	0	9920	\N
29245	4172	3	0	9926	\N
29245	4275	4	0	9928	\N
29302	4172	5	0	9935	\N
29325	4172	3	0	9943	\N
29334	4172	3	0	9944	\N
29325	4275	4	0	9946	\N
29334	4275	4	0	9947	\N
29372	4172	3	0	9949	\N
29372	4275	4	0	9950	\N
29368	391	3	0	10761	\N
29368	3660	4	0	10763	\N
29134	132	2	0	11504	\N
29134	2756	3	0	11505	\N
29351	5399	6	0	11999	\N
29351	6549	7	0	12001	\N
29336	6350	5	0	12260	\N
29355	233	4	0	13975	\N
29366	402	3	0	14176	\N
29366	4077	4	0	14178	\N
29292	236	1	0	15860	\N
29292	235	4	0	15879	\N
29292	8048	5	1	15882	\N
29373	142	3	0	18701	\N
29315	440	3	0	21752	\N
29315	4581	4	0	21755	\N
29183	254	2	0	22317	\N
29183	8020	3	0	22320	\N
29369	4189	4	0	23252	\N
29273	140	6	0	24250	\N
29273	4086	7	0	24251	\N
29209	8034	3	0	25784	\N
29209	4584	4	0	25785	\N
29353	6303	3	0	26384	\N
29353	6304	4	0	26386	\N
29161	94	2	0	27133	\N
29161	2043	3	0	27134	\N
29294	245	1	0	27393	\N
29231	244	4	0	27401	\N
29259	244	3	0	27402	\N
29259	4075	4	0	27404	\N
29294	7671	5	0	27405	\N
29231	3778	5	0	27406	\N
29286	54	3	0	30307	\N
29286	3041	4	0	30308	\N
29155	202	9	0	31198	\N
29155	3798	10	0	31199	\N
29185	33	6	0	31948	\N
29185	7330	7	0	31949	\N
29263	2	12	0	35322	\N
29263	8037	13	0	35327	\N
29338	2	4	0	35341	\N
29242	40	3	0	42405	\N
29242	372	4	0	42407	\N
29384	40	7	0	42497	\N
29384	4718	8	0	42498	\N
29274	8044	64	0	44898	\N
29274	71	126	0	44913	\N
29274	8045	127	0	44914	\N
29362	79	3	0	46859	\N
29362	3652	4	0	46860	\N
29453	88	4	0	47305	\N
29453	8077	5	0	47311	\N
29248	113	4	0	48421	\N
29248	3677	5	0	48425	\N
29177	121	3	0	49070	\N
29195	121	5	0	49071	\N
29177	4471	4	0	49072	\N
29195	4430	6	0	49073	\N
29386	156	12	0	50453	\N
29386	8058	13	0	50454	\N
29193	186	0	0	51384	\N
29226	242	3	0	52286	\N
29226	2839	4	0	52292	\N
29270	273	12	0	53144	\N
29270	8041	13	0	53145	\N
29370	273	3	0	53149	\N
29370	3638	4	0	53150	\N
29261	316	4	0	54043	\N
29261	4531	5	0	54044	\N
29421	324	3	0	54399	\N
29421	4514	4	0	54403	\N
29413	435	9	0	55147	\N
29413	8063	10	0	55148	\N
29235	595	4	0	55715	\N
29235	3878	5	0	55729	\N
29278	8046	69	0	56504	\N
29278	1021	109	0	56516	\N
29278	8047	110	0	56517	\N
29391	8060	86	0	56519	\N
29391	1021	126	0	56534	\N
29391	8047	127	0	56535	\N
29441	908	14	0	57802	\N
29441	8072	15	0	57805	\N
29378	2435	10	0	57872	\N
29332	2636	3	0	58868	\N
29332	2837	4	0	58869	\N
29328	3628	2	0	59750	\N
29328	4360	3	0	59755	\N
29451	4787	7	0	60377	\N
29451	7384	8	0	60382	\N
29301	6723	5	0	60889	\N
29301	8052	6	0	60894	\N
29398	6723	3	0	60896	\N
29398	6724	4	0	60900	\N
29277	3474	4	0	1321	\N
29257	3514	4	0	1577	\N
29267	1949	6	0	1742	\N
29267	3527	7	0	1745	\N
29233	110	6	0	2671	\N
29233	3917	7	0	2672	\N
29204	2828	6	0	3976	\N
29204	262	9	0	3987	\N
29204	3027	10	0	3989	\N
29411	263	1	0	4000	\N
29411	262	10	0	4003	\N
29411	4093	11	0	4004	\N
29399	35	3	0	4327	\N
29252	365	3	0	4674	\N
29252	3839	4	0	4675	\N
29218	189	2	0	5101	\N
29218	3143	3	0	5103	\N
29265	4178	4	0	7995	\N
29265	4205	5	0	7996	\N
29312	4178	2	0	8003	\N
29312	4247	3	0	8004	\N
29376	4178	9	0	8015	\N
29390	4178	4	0	8016	\N
29390	4205	5	0	8017	\N
29376	4682	10	0	8018	\N
29396	4211	4	0	8020	\N
29425	4178	5	0	8021	\N
29425	4333	6	0	8022	\N
29224	4172	3	0	9917	\N
29224	4275	4	0	9919	\N
29291	4172	2	0	9934	\N
29291	4191	3	0	9937	\N
29401	4172	4	0	9951	\N
29401	4219	5	0	9952	\N
29342	391	6	0	10760	\N
29342	3521	7	0	10765	\N
29378	132	9	0	11514	\N
29437	108	4	0	11869	\N
29437	8070	5	0	11870	\N
29381	528	2	0	12638	\N
29381	2765	3	0	12639	\N
29397	123	3	0	12823	\N
29397	2856	4	0	12826	\N
29439	256	3	0	13324	\N
29439	8071	4	0	13325	\N
29220	235	3	0	15855	\N
29220	3343	4	0	15859	\N
29272	44	12	0	16224	\N
29272	8043	13	0	16226	\N
29349	5066	7	0	17878	\N
29373	4254	4	0	18702	\N
29316	241	3	0	20614	\N
29316	3613	4	0	20615	\N
29255	488	2	0	21593	\N
29255	2791	3	0	21594	\N
29314	440	0	0	21751	\N
29354	67	3	0	22221	\N
29354	3749	4	0	22223	\N
29182	254	6	0	22316	\N
29182	8019	7	0	22322	\N
29408	73	4	0	22645	\N
29408	2284	5	0	22648	\N
29427	8067	5	0	22649	\N
29198	8022	6	0	23004	\N
29201	8022	6	0	23006	\N
29198	1935	9	0	23014	\N
29201	1935	9	0	23016	\N
29198	8023	10	0	23018	\N
29201	8023	10	0	23020	\N
29423	149	4	0	23259	\N
29423	5500	5	0	23265	\N
29435	264	3	0	23677	\N
29435	3632	4	0	23678	\N
29374	4419	6	0	25680	\N
29409	86	4	0	26516	\N
29409	4052	5	0	26518	\N
29308	244	1	0	27416	\N
29308	245	2	0	27417	\N
29284	20	3	0	30564	\N
29284	2844	4	0	30566	\N
29429	202	3	0	31235	\N
29429	4857	4	0	31238	\N
29455	453	4	0	32973	\N
29455	4108	5	0	32974	\N
29222	4	2	0	36132	\N
29298	6	5	0	36397	\N
29298	2852	6	0	36402	\N
29319	14	3	0	39501	\N
29365	14	3	0	39502	\N
29319	4272	4	0	39503	\N
29365	4272	4	0	39504	\N
29388	14	8	0	39515	\N
29388	6577	9	0	39516	\N
29417	14	1	0	39519	\N
29417	15	2	0	39520	\N
29241	40	3	0	42382	\N
29241	372	4	0	42383	\N
29324	40	3	0	42426	\N
29324	372	4	0	42427	\N
29474	40	7	0	42508	\N
29474	4488	8	0	42509	\N
29410	57	1	0	44639	\N
29456	56	3	0	44643	\N
29410	56	10	0	44644	\N
29456	4109	4	0	44645	\N
29410	6708	11	0	44648	\N
29348	79	3	0	46844	\N
29348	3652	4	0	46847	\N
29392	79	2	0	46898	\N
29392	616	3	0	46899	\N
29467	79	4	0	46927	\N
29467	8083	5	0	46928	\N
29484	79	3	0	46943	\N
29487	100	6	0	47751	\N
29487	7216	7	0	47753	\N
29297	121	3	0	49085	\N
29297	4471	4	0	49086	\N
29287	137	3	0	49894	\N
29287	3633	4	0	49896	\N
29431	181	3	0	51120	\N
29431	4184	4	0	51121	\N
29405	285	33	0	53712	\N
29405	8062	34	0	53717	\N
29361	316	3	0	54050	\N
29361	4249	4	0	54052	\N
29266	435	5	0	55143	\N
29266	8039	6	0	55146	\N
29419	597	4	0	56101	\N
29419	3733	5	0	56102	\N
29383	1109	3	0	56140	\N
29383	3495	4	0	56142	\N
29293	4015	4	0	57871	\N
29414	2636	11	0	58875	\N
29414	8064	12	0	58876	\N
29326	3625	2	0	59616	\N
29326	4359	3	0	59621	\N
29337	5539	3	0	60160	\N
29337	4233	7	0	60161	\N
29337	8056	8	0	60162	\N
29462	5885	3	0	60552	\N
29462	5926	4	0	60557	\N
29237	6450	4	0	60815	\N
29237	6467	5	0	60824	\N
29426	7677	5	0	60839	\N
29426	8066	6	0	60840	\N
29407	7412	3	0	61154	\N
29407	7466	4	0	61155	\N
29317	110	4	0	2691	\N
29303	228	4	0	2903	\N
29303	4800	5	0	2905	\N
29385	228	2	0	2910	\N
29385	4776	3	0	2911	\N
29460	7225	7	0	4065	\N
29460	8081	8	0	4074	\N
29221	189	3	0	5102	\N
29221	3782	4	0	5108	\N
29216	4178	3	0	7987	\N
29216	4211	4	0	7988	\N
29246	4178	6	0	7990	\N
29246	4250	7	0	7992	\N
29346	4211	4	0	8014	\N
29471	4178	3	0	8024	\N
29471	4211	4	0	8026	\N
29500	4178	2	0	8029	\N
29500	4247	3	0	8032	\N
29506	4178	5	0	8035	\N
29230	4172	4	0	9921	\N
29230	4219	5	0	9922	\N
29234	4172	7	0	9923	\N
29234	4614	8	0	9924	\N
29269	4172	6	0	9931	\N
29269	4197	7	0	9932	\N
29321	4275	4	0	9942	\N
29352	4172	6	0	9945	\N
29352	4197	7	0	9948	\N
29469	4172	8	0	9956	\N
29489	4172	7	0	9957	\N
29489	4614	8	0	9960	\N
29469	7815	9	0	9961	\N
29504	4172	3	0	9963	\N
29504	4275	4	0	9964	\N
29350	132	6	0	11512	\N
29350	4690	7	0	11515	\N
29403	132	1	0	11525	\N
29300	123	5	0	12822	\N
29300	3908	6	0	12828	\N
29250	77	2	0	13240	\N
29250	3853	3	0	13242	\N
29219	235	2	0	15854	\N
29219	2757	3	0	15856	\N
29293	236	1	0	15861	\N
29295	236	1	0	15862	\N
29293	8049	4	0	15878	\N
29295	235	4	0	15880	\N
29293	8050	5	0	15881	\N
29295	5467	5	0	15883	\N
29433	4254	4	0	18708	\N
29313	440	0	0	21750	\N
29359	264	2	0	23674	\N
29359	2780	3	0	23675	\N
29458	82	7	0	23820	\N
29458	8079	8	0	23828	\N
29279	214	6	0	24526	\N
29279	4681	7	0	24527	\N
29476	8086	11	0	26521	\N
29478	8086	11	0	26522	\N
29476	86	12	0	26549	\N
29478	86	12	0	26550	\N
29264	94	12	0	27136	\N
29464	94	3	0	27137	\N
29464	2864	4	0	27139	\N
29239	4677	5	0	27140	\N
29264	8038	13	0	27142	\N
29253	54	4	0	30302	\N
29253	3685	5	0	30304	\N
29228	20	5	0	30563	\N
29502	20	4	0	30565	\N
29502	3995	5	0	30567	\N
29228	6631	6	0	30568	\N
29310	151	3	0	30822	\N
29281	202	3	0	31206	\N
29281	4857	4	0	31209	\N
29380	202	4	0	31229	\N
29380	3673	5	0	31230	\N
29260	322	3	0	32414	\N
29260	3071	4	0	32415	\N
29438	322	3	0	32423	\N
29438	1105	4	0	32424	\N
29447	322	3	0	32433	\N
29447	1105	4	0	32434	\N
29394	431	5	0	34875	\N
29394	8061	6	0	34877	\N
29333	3548	4	0	35342	\N
29480	7192	11	0	35344	\N
29480	2	12	0	35361	\N
29330	4	5	0	36140	\N
29330	4387	6	0	36141	\N
29465	4	8	0	36147	\N
29465	4377	9	0	36148	\N
29387	14	12	0	39514	\N
29387	8059	13	0	39517	\N
29416	14	3	0	39518	\N
29416	4272	4	0	39521	\N
29375	40	0	0	42481	\N
29488	40	7	0	42524	\N
29488	4718	8	0	42526	\N
29677	40	12	0	42576	\N
29574	56	3	0	44653	\N
29574	4109	4	0	44654	\N
29591	56	5	0	44659	\N
29633	56	11	0	44660	\N
29591	3551	6	0	44663	\N
29633	8123	12	0	44665	\N
29406	75	5	0	45354	\N
29406	4484	6	0	45355	\N
29470	75	4	0	45372	\N
29470	2357	5	0	45374	\N
29602	75	3	0	45388	\N
29602	3855	4	0	45389	\N
29624	75	6	0	45408	\N
29624	8120	7	0	45412	\N
29484	3652	4	0	46945	\N
29572	79	3	0	46955	\N
29572	3652	4	0	46958	\N
29595	79	12	0	46963	\N
29595	8107	13	0	46968	\N
29449	102	2	0	48099	\N
29449	3053	3	0	48101	\N
29511	102	7	0	48110	\N
29511	5310	8	0	48117	\N
29446	113	6	0	48423	\N
29446	8074	7	0	48426	\N
29358	170	2	0	50821	\N
29360	170	0	0	50822	\N
29358	1380	3	0	50824	\N
29616	186	1	0	51380	\N
29616	1080	2	0	51381	\N
29436	200	4	0	51663	\N
29436	8069	5	0	51665	\N
29493	260	2	0	52426	\N
29493	3184	3	0	52427	\N
29461	268	3	0	52695	\N
29461	3815	4	0	52696	\N
29459	279	7	0	53306	\N
29459	8080	8	0	53310	\N
29404	285	5	0	53711	\N
29404	5103	6	0	53716	\N
29551	316	8	0	54051	\N
29551	8095	9	0	54053	\N
29585	597	3	0	56103	\N
29585	3656	4	0	56106	\N
29382	852	3	0	57430	\N
29382	3612	4	0	57432	\N
29444	852	2	0	57436	\N
29444	2872	3	0	57437	\N
29415	8065	11	0	58873	\N
29415	8064	12	0	58874	\N
29519	2351	2	0	58905	\N
29519	4711	3	0	58906	\N
29499	4233	2	0	60163	\N
29499	5577	3	0	60164	\N
29420	6450	4	0	60816	\N
29420	6467	5	0	60825	\N
29379	7412	3	0	61150	\N
29379	7466	4	0	61151	\N
29389	7412	4	0	61152	\N
29389	7499	5	0	61153	\N
29658	7412	14	0	61166	\N
29658	8135	15	0	61167	\N
29557	8098	4	0	61387	\N
29457	8078	8	0	128	\N
29576	424	5	0	972	\N
29495	3611	4	0	973	\N
29576	6790	6	0	974	\N
29637	228	2	0	2915	\N
29637	4776	3	0	2917	\N
29472	367	3	0	3548	\N
29472	3683	4	0	3549	\N
29497	7225	3	0	4066	\N
29497	7226	4	0	4070	\N
29482	8088	11	0	5088	\N
29482	189	12	0	5109	\N
29520	4178	2	0	8037	\N
29635	4211	4	0	8056	\N
29424	4172	4	0	9953	\N
29424	4252	5	0	9954	\N
29442	4172	14	0	9955	\N
29501	4172	2	0	9958	\N
29501	4191	3	0	9959	\N
29442	8073	15	0	9962	\N
29395	391	5	0	10762	\N
29395	3558	6	0	10764	\N
29377	132	9	0	11513	\N
29377	6548	10	0	11517	\N
29402	132	2	0	11524	\N
29415	7699	11	0	12345	\N
29400	528	6	0	12644	\N
29400	4824	7	0	12645	\N
29515	6130	3	0	12646	\N
29515	528	8	0	12649	\N
29515	8090	9	0	12650	\N
29507	123	3	0	12824	\N
29507	2856	4	0	12827	\N
29440	58	14	0	13695	\N
29440	1358	15	0	13697	\N
29355	3775	5	0	13980	\N
29422	173	4	0	14764	\N
29644	44	3	0	16228	\N
29644	3631	4	0	16232	\N
29555	8096	83	0	18204	\N
29555	30	126	0	18207	\N
29555	8097	127	0	18208	\N
29546	488	7	0	21608	\N
29546	4729	8	0	21611	\N
29588	67	8	0	22222	\N
29588	4151	9	0	22224	\N
29642	336	2	0	22907	\N
29642	3332	3	0	22909	\N
29475	82	7	0	23821	\N
29582	140	11	0	24256	\N
29582	8104	12	0	24257	\N
29529	8094	94	0	25349	\N
29529	411	98	0	25363	\N
29529	2014	99	0	25364	\N
29503	224	2	0	25690	\N
29503	3150	3	0	25691	\N
29490	206	7	0	25800	\N
29490	8089	8	0	25801	\N
29629	206	3	0	25813	\N
29629	4584	4	0	25814	\N
29367	6303	3	0	26387	\N
29647	86	5	0	26543	\N
29647	7243	6	0	26544	\N
29527	94	4	0	27138	\N
29527	4677	5	0	27141	\N
29570	96	6	0	29652	\N
29570	5078	7	0	29653	\N
29618	54	9	0	30309	\N
29618	8117	10	0	30310	\N
29364	360	3	0	31536	\N
29364	3602	4	0	31537	\N
29509	360	4	0	31544	\N
29509	3513	5	0	31545	\N
29491	4258	13	0	32218	\N
29393	2	2	0	35357	\N
29568	2	6	0	35358	\N
29393	2789	3	0	35359	\N
29568	4825	7	0	35360	\N
29454	4	2	0	36143	\N
29454	2751	3	0	36144	\N
29498	18	4	0	40596	\N
29498	2302	5	0	40597	\N
29550	40	2	0	42541	\N
29550	282	3	0	42542	\N
29677	8148	13	0	42584	\N
29428	75	4	0	45371	\N
29428	8068	5	0	45373	\N
29485	79	3	0	46944	\N
29485	3652	4	0	46946	\N
29521	100	2	0	47756	\N
29521	2918	3	0	47758	\N
29450	102	3	0	48100	\N
29450	3597	4	0	48102	\N
29652	125	7	0	49375	\N
29652	8128	8	0	49377	\N
29466	156	8	0	50455	\N
29466	8082	9	0	50462	\N
29560	8099	46	0	51666	\N
29560	200	110	0	51671	\N
29560	8100	111	0	51672	\N
29567	210	6	0	52018	\N
29567	3721	7	0	52022	\N
29649	268	9	0	52704	\N
29649	8125	10	0	52705	\N
29496	279	3	0	53307	\N
29496	3641	4	0	53309	\N
29645	316	4	0	54060	\N
29645	5437	5	0	54061	\N
29552	324	6	0	54422	\N
29552	5241	7	0	54426	\N
29418	595	4	0	55716	\N
29584	595	3	0	55717	\N
29584	3654	4	0	55727	\N
29418	3878	5	0	55730	\N
29575	852	4	0	57440	\N
29575	4162	5	0	57441	\N
29634	852	3	0	57444	\N
29634	3612	4	0	57445	\N
29606	908	3	0	57808	\N
29606	3591	4	0	57810	\N
29463	1470	3	0	58360	\N
29463	3838	4	0	58361	\N
29662	1470	9	0	58372	\N
29662	8138	10	0	58376	\N
29530	3625	4	0	59623	\N
29530	3802	5	0	59625	\N
29534	3628	4	0	59751	\N
29534	3803	5	0	59756	\N
29578	4088	2	0	59938	\N
29578	4332	3	0	59939	\N
29692	6044	3	0	60692	\N
29692	8156	4	0	60693	\N
29448	7412	9	0	61156	\N
29448	8075	10	0	61157	\N
29468	7412	8	0	61158	\N
29468	8084	9	0	61159	\N
29707	7412	7	0	61170	\N
29443	2842	3	0	127	\N
29532	266	4	0	1326	\N
29532	4100	5	0	1328	\N
29445	251	2	0	1590	\N
29656	251	9	0	1591	\N
29656	8133	10	0	1592	\N
29445	1851	3	0	1593	\N
29477	8087	11	0	4005	\N
29479	8087	11	0	4006	\N
29481	8087	11	0	4007	\N
29477	262	12	0	4010	\N
29479	262	12	0	4011	\N
29481	262	12	0	4012	\N
29430	4211	4	0	8025	\N
29483	4178	3	0	8027	\N
29492	4178	2	0	8028	\N
29505	4178	3	0	8030	\N
29492	4247	3	0	8031	\N
29483	4211	4	0	8033	\N
29505	4211	4	0	8034	\N
29548	4178	7	0	8041	\N
29558	4178	3	0	8042	\N
29558	4211	4	0	8043	\N
29548	4396	8	0	8044	\N
29621	4178	6	0	8050	\N
29621	4250	7	0	8053	\N
29639	4178	5	0	8057	\N
29639	4202	6	0	8058	\N
29514	4172	4	0	9965	\N
29526	4172	4	0	9966	\N
29554	4172	8	0	9967	\N
29514	4219	5	0	9971	\N
29526	4219	5	0	9972	\N
29554	5928	9	0	9974	\N
29628	4172	2	0	9979	\N
29664	4172	7	0	9980	\N
29628	4285	3	0	9981	\N
29690	4172	7	0	9984	\N
29690	6628	8	0	9985	\N
29473	391	4	0	10775	\N
29473	3913	5	0	10776	\N
29512	132	7	0	11530	\N
29641	132	3	0	11531	\N
29641	3729	4	0	11535	\N
29512	3709	8	0	11537	\N
29494	108	3	0	11875	\N
29494	4171	4	0	11879	\N
29565	77	4	0	13260	\N
29565	3619	5	0	13261	\N
29626	8121	14	0	16227	\N
29619	212	9	0	17217	\N
29619	8118	10	0	17218	\N
29703	167	9	0	17892	\N
29703	8158	10	0	17895	\N
29434	142	3	0	18706	\N
29510	142	7	0	18707	\N
29434	4254	4	0	18709	\N
29510	6504	8	0	18710	\N
29590	290	5	0	19153	\N
29590	6379	6	0	19154	\N
29452	488	4	0	21599	\N
29563	7437	2	0	21643	\N
29563	8101	2	0	22872	\N
29563	3332	3	0	22876	\N
29528	411	2	0	25359	\N
29528	3370	3	0	25360	\N
29540	224	0	0	25679	\N
29536	224	3	0	25697	\N
29536	3603	4	0	25699	\N
29683	7788	5	0	26520	\N
29683	86	18	0	26546	\N
29683	3746	19	0	26548	\N
29679	244	12	0	27428	\N
29623	96	6	0	29664	\N
29623	8119	7	0	29665	\N
29432	202	3	0	31236	\N
29432	4857	4	0	31239	\N
29517	2290	3	0	32219	\N
29604	230	2	0	32226	\N
29604	3307	3	0	32227	\N
29517	230	8	0	32228	\N
29517	8092	9	0	32229	\N
29654	2	20	0	35379	\N
29654	8130	21	0	35381	\N
29538	18	3	0	40598	\N
29598	1685	3	0	40601	\N
29538	3621	4	0	40602	\N
29614	18	3	0	40604	\N
29614	3621	4	0	40605	\N
29486	27	9	0	41280	\N
29486	5696	10	0	41282	\N
29698	27	6	0	41294	\N
29698	3302	7	0	41298	\N
29541	40	7	0	42525	\N
29541	4718	8	0	42527	\N
29733	40	7	0	42577	\N
29741	40	9	0	42578	\N
29733	3595	8	0	42580	\N
29741	8185	10	0	42582	\N
29674	56	15	0	44661	\N
29674	3418	16	0	44664	\N
29573	79	2	0	46956	\N
29573	616	3	0	46957	\N
29518	100	11	0	47754	\N
29518	8093	12	0	47755	\N
29562	6733	10	0	49371	\N
29562	125	11	0	49374	\N
29718	181	27	0	51126	\N
29718	6359	28	0	51128	\N
29680	273	12	0	53152	\N
29680	586	13	0	53153	\N
29758	1150	1	0	56766	\N
29756	5688	4	0	56767	\N
29758	793	25	0	56777	\N
29756	793	19	0	56778	\N
29756	8194	20	0	56780	\N
29758	8203	26	0	56782	\N
29525	908	6	0	57806	\N
29525	3555	7	0	57807	\N
29612	908	7	0	57809	\N
29612	4078	8	0	57811	\N
29758	2435	26	1	57873	\N
29756	4017	20	1	57877	\N
29756	8197	22	0	57998	\N
29661	1470	6	0	58371	\N
29661	6626	7	0	58375	\N
29756	7915	22	1	58550	\N
29743	4233	12	0	60167	\N
29743	8186	13	0	60173	\N
29580	4787	3	0	60383	\N
29580	4788	4	0	60386	\N
29586	6450	3	0	60817	\N
29586	6847	4	0	60822	\N
29508	6723	3	0	60897	\N
29673	6723	18	0	60898	\N
29508	6724	4	0	60901	\N
29673	8145	19	0	60903	\N
29516	7843	3	0	61160	\N
29537	7412	3	0	61161	\N
29537	7466	4	0	61162	\N
29516	7412	8	0	61163	\N
29516	8091	9	0	61164	\N
29657	7412	22	0	61165	\N
29657	8134	23	0	61168	\N
29702	7412	9	0	61169	\N
29702	8157	10	0	61173	\N
29756	8198	23	0	61210	\N
29756	8195	21	0	61308	\N
29523	3028	3	0	455	\N
29699	1912	7	0	1329	\N
29756	8196	21	1	1353	\N
29543	117	6	0	2130	\N
29543	3804	7	0	2131	\N
29686	117	10	0	2143	\N
29686	8153	11	0	2146	\N
29711	117	30	0	2156	\N
29711	8163	31	0	2162	\N
29650	110	19	0	2705	\N
29650	8126	20	0	2706	\N
29636	228	3	0	2914	\N
29636	3186	4	0	2918	\N
29545	4178	3	0	8038	\N
29545	4211	4	0	8040	\N
29583	4178	3	0	8045	\N
29583	4211	4	0	8046	\N
29625	4178	13	0	8051	\N
29625	4782	14	0	8054	\N
29569	4172	6	0	9968	\N
29569	4197	7	0	9973	\N
29596	4172	12	0	9976	\N
29596	6408	13	0	9978	\N
29684	4415	5	0	9983	\N
29684	4172	18	0	9986	\N
29708	4172	6	0	9990	\N
29708	7116	7	0	9992	\N
29513	391	4	0	10781	\N
29513	3913	5	0	10782	\N
29632	391	11	0	10789	\N
29632	8122	12	0	10790	\N
29706	391	7	0	10799	\N
29706	3927	8	0	10800	\N
29608	6864	3	0	12368	\N
29608	8112	4	0	12369	\N
29716	2765	2	0	12652	\N
29716	528	20	0	12655	\N
29559	77	4	0	13241	\N
29559	3619	5	0	13246	\N
29666	216	2	0	13262	\N
29667	216	2	0	13263	\N
29666	77	19	0	13270	\N
29667	77	19	0	13271	\N
29666	6761	20	0	13272	\N
29667	6761	20	0	13273	\N
29592	173	6	0	14765	\N
29592	3606	7	0	14768	\N
29721	235	9	0	15876	\N
29721	8173	10	0	15885	\N
29756	8199	23	1	21875	\N
29655	8131	12	0	22225	\N
29655	67	31	0	22230	\N
29655	8132	32	0	22231	\N
29564	336	2	0	22875	\N
29564	3332	3	0	22877	\N
29643	336	3	0	22908	\N
29643	3400	4	0	22910	\N
29659	264	15	0	23679	\N
29659	8136	16	0	23680	\N
29622	214	6	0	24541	\N
29622	4681	7	0	24544	\N
29640	4536	4	0	24881	\N
29663	69	9	0	24887	\N
29663	8139	10	0	24888	\N
29676	224	9	0	25698	\N
29676	8147	10	0	25700	\N
29726	90	17	0	26216	\N
29726	8178	18	0	26217	\N
29600	6303	3	0	26390	\N
29600	6304	4	0	26391	\N
29682	7788	5	0	26519	\N
29682	86	18	0	26545	\N
29682	3746	19	0	26547	\N
29688	5280	7	0	27144	\N
29746	94	18	0	27145	\N
29746	8187	19	0	27151	\N
29678	244	9	0	27427	\N
29678	8149	10	0	27429	\N
29669	20	9	0	30576	\N
29669	8141	10	0	30582	\N
29571	8102	3	0	30930	\N
29571	8103	4	0	30931	\N
29594	202	3	0	31237	\N
29594	4857	4	0	31240	\N
29610	202	3	0	31249	\N
29671	33	18	0	31958	\N
29671	8143	19	0	31963	\N
29627	14	3	0	39524	\N
29627	4272	4	0	39527	\N
29549	18	7	0	40599	\N
29549	1618	8	0	40603	\N
29620	23	6	0	40928	\N
29620	4632	7	0	40930	\N
29665	40	29	0	42559	\N
29665	8140	30	0	42561	\N
29544	56	6	0	44652	\N
29544	4703	7	0	44657	\N
29579	71	4	0	44910	\N
29579	3887	5	0	44911	\N
29736	79	5	0	46965	\N
29736	5993	6	0	46966	\N
29689	100	8	0	47757	\N
29689	5431	9	0	47759	\N
29712	102	30	0	48112	\N
29777	102	15	0	48113	\N
29712	8164	31	0	48119	\N
29531	119	4	0	48630	\N
29531	3518	5	0	48640	\N
29759	125	23	0	49376	\N
29759	8205	24	0	49378	\N
29615	186	3	0	51379	\N
29615	4294	4	0	51382	\N
29603	8109	62	0	51675	\N
29603	200	123	0	51680	\N
29603	8110	124	0	51681	\N
29553	324	8	0	54423	\N
29553	5427	9	0	54427	\N
29653	451	7	0	55475	\N
29653	8129	8	0	55479	\N
29670	793	9	0	56750	\N
29670	8142	10	0	56751	\N
29757	5688	4	0	56768	\N
29757	793	19	0	56779	\N
29757	8200	20	0	56781	\N
29734	852	7	0	57448	\N
29734	8182	8	0	57457	\N
29757	4307	20	1	57874	\N
29771	2435	17	0	57879	\N
29758	8204	27	0	57997	\N
29757	8201	21	1	57999	\N
29759	2171	24	1	58000	\N
29771	8210	18	0	58004	\N
29758	3526	27	1	58547	\N
29757	7915	22	0	58551	\N
29771	8212	19	0	58556	\N
29720	8171	65	0	58653	\N
29720	2578	126	0	58659	\N
29720	8172	127	0	58660	\N
29771	8213	17	1	60182	\N
29648	5885	6	0	60553	\N
29648	8124	7	0	60558	\N
29691	6044	10	0	60691	\N
29691	8155	11	0	60695	\N
29617	6765	9	0	60956	\N
29617	8116	10	0	60963	\N
29745	7412	18	0	61171	\N
29745	8075	19	0	61174	\N
29757	8195	21	0	61309	\N
29687	117	9	0	2144	\N
29722	117	9	0	2157	\N
29767	117	19	0	2158	\N
29769	117	17	0	2159	\N
29769	8209	18	0	2160	\N
29767	6848	20	0	2161	\N
29722	8174	10	0	2163	\N
29771	6013	6	0	3545	\N
29771	367	16	0	3551	\N
29771	8214	18	1	3552	\N
29651	262	7	0	4013	\N
29651	8127	8	0	4014	\N
29607	35	3	0	4331	\N
29520	4527	3	0	8039	\N
29597	4450	1	0	8047	\N
29597	4178	7	0	8048	\N
29597	4202	8	0	8049	\N
29646	4178	5	0	8059	\N
29646	4202	6	0	8060	\N
29675	4178	18	0	8061	\N
29675	8146	19	0	8062	\N
29709	4178	30	0	8064	\N
29709	5304	31	0	8066	\N
29739	4237	8	0	8069	\N
29739	4178	38	0	8072	\N
29581	4172	3	0	9969	\N
29581	4275	4	0	9970	\N
29587	4172	8	0	9975	\N
29587	5928	9	0	9977	\N
29696	4172	6	0	9989	\N
29696	5278	7	0	9995	\N
29730	108	7	0	11876	\N
29730	8180	8	0	11880	\N
29672	123	18	0	12834	\N
29672	8144	19	0	12837	\N
29605	256	4	0	13393	\N
29605	8111	5	0	13394	\N
29577	1849	3	0	13978	\N
29566	192	6	0	15404	\N
29566	4669	7	0	15407	\N
29704	167	6	0	17893	\N
29704	8159	7	0	17894	\N
29589	8105	83	0	18209	\N
29589	30	97	0	18210	\N
29589	8106	98	0	18211	\N
29556	290	3	0	19151	\N
29556	7789	4	0	19152	\N
29561	60	2	0	19612	\N
29561	4544	3	0	19613	\N
29732	62	7	0	19918	\N
29732	8181	8	0	19921	\N
29524	6466	7	0	19922	\N
29533	198	4	0	20154	\N
29533	4161	5	0	20155	\N
29681	4082	5	0	20156	\N
29752	198	8	0	20165	\N
29752	8191	9	0	20167	\N
29681	198	18	0	20168	\N
29681	4263	19	0	20169	\N
29522	488	2	0	21607	\N
29522	2991	3	0	21610	\N
29757	8202	22	1	21871	\N
29759	1075	25	0	21872	\N
29771	6316	19	1	21877	\N
29609	336	3	0	22884	\N
29609	8113	4	0	22885	\N
29754	336	8	0	22919	\N
29754	8192	9	0	22921	\N
29714	8166	25	0	23254	\N
29714	149	126	0	23270	\N
29714	8167	127	0	23271	\N
29593	214	6	0	24540	\N
29593	4681	7	0	24543	\N
29542	4084	7	0	24884	\N
29535	224	0	0	25677	\N
29539	224	0	0	25678	\N
29601	90	5	0	26196	\N
29601	8108	6	0	26199	\N
29611	345	13	0	26308	\N
29611	8115	14	0	26309	\N
29599	6303	4	0	26389	\N
29599	7489	5	0	26392	\N
29728	54	6	0	30311	\N
29728	3507	7	0	30313	\N
29668	20	9	0	30575	\N
29547	360	7	0	31550	\N
29547	4970	8	0	31551	\N
29613	2	7	0	35378	\N
29613	2858	8	0	35380	\N
29660	2	8	0	35403	\N
29660	8137	9	0	35404	\N
29685	2	10	0	35429	\N
29685	8152	11	0	35433	\N
29697	56	6	0	44668	\N
29697	3398	7	0	44669	\N
29865	56	9	0	44675	\N
29887	56	9	0	44676	\N
29865	8303	10	0	44677	\N
29887	8303	10	0	44678	\N
29731	79	7	0	46964	\N
29731	3682	8	0	46967	\N
29710	102	22	0	48111	\N
29779	102	13	0	48114	\N
29779	5013	14	0	48115	\N
29710	8162	23	0	48118	\N
29844	113	5	0	48445	\N
29846	113	0	0	48446	\N
29844	3786	6	0	48447	\N
29825	119	11	0	48631	\N
29825	8264	12	0	48645	\N
29821	125	10	0	49379	\N
29821	8261	11	0	49380	\N
29883	135	20	0	49646	\N
29883	8323	21	0	49651	\N
29778	156	15	0	50456	\N
29834	156	5	0	50457	\N
29834	7823	6	0	50459	\N
29778	6498	16	0	50461	\N
29832	170	17	0	50823	\N
29832	8267	18	0	50827	\N
29705	242	9	0	52288	\N
29705	8160	10	0	52294	\N
29761	378	12	0	54912	\N
29763	378	11	0	54913	\N
29761	7301	13	0	54916	\N
29763	8207	12	0	54917	\N
29878	8316	20	0	56507	\N
29878	1021	21	0	56518	\N
29891	841	9	0	57114	\N
29891	8325	10	0	57118	\N
29735	852	9	0	57449	\N
29737	852	6	0	57450	\N
29796	852	9	0	57452	\N
29737	8184	7	0	57456	\N
29735	8183	10	0	57458	\N
29796	8183	10	0	57459	\N
29902	852	8	0	57466	\N
29902	8335	9	0	57467	\N
29770	2435	29	0	57878	\N
29798	2435	10	0	57883	\N
29848	2435	39	0	57889	\N
29904	4017	10	0	57895	\N
29770	8210	29	1	58003	\N
29798	8242	12	1	58008	\N
29848	8197	41	1	58014	\N
29860	2171	12	0	58018	\N
29904	8029	12	1	58025	\N
29816	1470	29	0	58374	\N
29816	8254	30	0	58378	\N
29836	1470	5	0	58385	\N
29836	8268	6	0	58386	\N
29770	8212	30	1	58555	\N
29798	3526	13	0	58560	\N
29848	8279	42	1	58567	\N
29900	2351	10	0	58913	\N
29900	8333	11	0	58914	\N
29765	8208	13	0	1059	\N
29770	6013	6	0	3544	\N
29770	367	28	0	3550	\N
29770	8211	30	0	3553	\N
29694	4178	6	0	8063	\N
29694	6623	7	0	8065	\N
29727	4178	9	0	8070	\N
29727	7720	10	0	8071	\N
29742	4178	16	0	8076	\N
29742	4509	17	0	8077	\N
29808	4178	5	0	8081	\N
29808	4202	6	0	8082	\N
29842	4172	21	0	9997	\N
29860	391	10	0	10817	\N
29860	8297	11	0	10818	\N
29787	132	29	0	11542	\N
29787	8231	30	0	11543	\N
29827	300	9	0	12259	\N
29827	4770	10	0	12261	\N
29723	77	9	0	13278	\N
29723	8175	10	0	13281	\N
29772	192	31	0	15405	\N
29772	8215	32	0	15408	\N
29775	2081	28	0	18814	\N
29775	8218	29	0	18815	\N
29725	8177	10	0	20863	\N
29798	1355	10	1	21646	\N
29848	6025	39	1	21652	\N
29904	1355	10	1	21657	\N
29770	6316	31	0	21876	\N
29772	1075	32	1	21878	\N
29773	1075	32	1	21879	\N
29848	8282	43	1	21888	\N
29713	149	30	0	23260	\N
29713	8165	31	0	23266	\N
29814	214	11	0	24542	\N
29814	8252	12	0	24545	\N
29896	8329	11	0	24892	\N
29791	785	13	0	26319	\N
29791	8233	14	0	26320	\N
29812	6303	0	0	26385	\N
29729	54	9	0	30312	\N
29729	8179	10	0	30314	\N
29904	360	9	0	31558	\N
29904	8336	13	0	31559	\N
29838	2	23	0	35431	\N
29838	3914	24	0	35434	\N
29848	8280	9	0	35435	\N
29872	2	14	0	35456	\N
29872	5834	15	0	35460	\N
29848	8281	40	1	35461	\N
29823	14	9	0	39530	\N
29823	8262	10	0	39531	\N
29768	27	19	0	41295	\N
29889	27	10	0	41296	\N
29889	6167	11	0	41300	\N
29768	4830	20	0	41301	\N
29798	8243	14	0	59133	\N
29848	8243	43	0	59139	\N
29860	8299	13	0	59141	\N
29904	8225	14	0	59146	\N
29869	8306	11	0	59759	\N
29744	4233	18	0	60168	\N
29744	6392	19	0	60174	\N
29798	8241	12	0	60186	\N
29848	8213	41	0	60192	\N
29904	8258	12	0	60197	\N
29773	5560	31	0	60408	\N
29773	8216	32	0	60409	\N
29798	8220	11	1	60417	\N
29904	8236	11	1	60426	\N
29748	6044	24	0	60697	\N
29750	6044	5	0	60698	\N
29748	8189	25	0	60701	\N
29798	6044	9	0	60702	\N
29798	8244	14	1	60706	\N
29780	7412	15	0	61176	\N
29780	7507	16	0	61182	\N
29798	8224	13	1	61214	\N
29860	8198	12	1	61222	\N
29904	8239	13	1	61227	\N
29848	8278	42	0	61290	\N
29798	8240	11	0	61312	\N
29848	8195	40	0	61318	\N
29860	8298	11	1	61320	\N
29837	8270	11	1	42581	\N
29820	113	19	0	48437	\N
29820	8260	20	0	48438	\N
29755	137	5	0	49895	\N
29755	8193	6	0	49897	\N
29795	242	12	0	52289	\N
29795	5519	13	0	52295	\N
29797	8234	50	0	52296	\N
29797	242	61	0	52299	\N
29797	8238	64	0	52300	\N
29852	242	15	0	52309	\N
29852	1630	16	0	52316	\N
29863	324	9	0	54424	\N
29863	8301	10	0	54425	\N
29760	378	14	0	54911	\N
29760	8206	15	0	54918	\N
29762	451	14	0	55476	\N
29762	3743	15	0	55480	\N
29738	793	7	0	56764	\N
29738	3547	8	0	56765	\N
29801	908	11	0	57812	\N
29807	908	1	0	57814	\N
29807	909	2	0	57815	\N
29801	988	12	0	57817	\N
29782	4307	14	0	57880	\N
29784	4307	14	0	57881	\N
29797	8235	62	0	57882	\N
29837	2435	9	0	57887	\N
29850	2435	10	0	57891	\N
29859	8292	12	1	57892	\N
29880	8292	12	0	57894	\N
29782	8210	16	1	58005	\N
29784	8210	17	0	58006	\N
29797	8226	63	1	58007	\N
29837	8201	12	1	58012	\N
29850	8226	10	1	58016	\N
29859	8294	15	0	58017	\N
29782	8222	17	0	58557	\N
29784	8222	17	1	58558	\N
29797	7915	64	1	58559	\N
29837	8212	13	0	58565	\N
29859	3526	16	0	58568	\N
29719	2578	21	0	58655	\N
29719	8170	22	0	58657	\N
29782	8225	18	1	59130	\N
29784	8225	18	1	59131	\N
29797	8225	65	1	59132	\N
29837	8225	14	0	59137	\N
29859	8225	17	0	59140	\N
29938	8364	32	0	59746	\N
29782	8221	16	0	60183	\N
29784	8221	16	1	60184	\N
29797	8237	63	0	60185	\N
29837	8271	12	0	60190	\N
29859	8271	14	1	60193	\N
29782	8220	15	1	60414	\N
29784	8220	16	0	60415	\N
29797	8236	62	1	60416	\N
29837	8220	11	0	60421	\N
29859	8293	14	0	60422	\N
29747	6044	16	0	60696	\N
29747	8188	17	0	60700	\N
29707	8161	8	0	61172	\N
29810	7412	5	0	61177	\N
29810	7519	6	0	61180	\N
29782	8224	18	0	61211	\N
29784	8224	18	0	61212	\N
29797	8239	65	0	61213	\N
29837	8224	13	1	61218	\N
29850	8284	11	1	61220	\N
29859	8296	16	1	61221	\N
29859	8295	15	1	61291	\N
29782	8219	15	0	61310	\N
29784	8219	15	1	61311	\N
29837	8269	10	0	61316	\N
29859	8256	13	1	61319	\N
29874	8308	11	0	136	\N
29845	8275	6	0	669	\N
29917	424	10	0	978	\N
29917	8346	11	0	979	\N
29837	8196	10	1	1355	\N
29717	4178	15	0	8067	\N
29717	4250	16	0	8068	\N
29740	4178	9	0	8074	\N
29740	7720	10	0	8075	\N
29766	4178	13	0	8078	\N
29766	4331	14	0	8079	\N
29776	4178	14	0	8080	\N
29776	4429	15	0	8083	\N
29840	4682	28	0	8087	\N
29850	4178	9	0	8088	\N
29868	4178	10	0	8089	\N
29850	8285	11	0	8090	\N
29868	5637	11	0	8091	\N
29870	4178	20	0	8092	\N
29870	7664	21	0	8093	\N
29906	4178	11	0	8104	\N
29919	4178	9	0	8105	\N
29923	4178	8	0	8106	\N
29923	6776	9	0	8109	\N
29919	7720	10	0	8110	\N
29753	4172	3	0	9991	\N
29753	4275	4	0	9993	\N
29782	2756	2	0	11523	\N
29782	132	13	0	11534	\N
29782	8223	17	1	11536	\N
29859	6057	5	0	12262	\N
29859	300	11	0	12275	\N
29859	8291	12	0	12276	\N
29715	2765	2	0	12651	\N
29715	528	21	0	12654	\N
29715	8168	22	0	12657	\N
29724	77	6	0	13279	\N
29908	402	1	0	14186	\N
29908	2889	2	0	14189	\N
29857	44	7	0	16229	\N
29857	4120	8	0	16235	\N
29751	198	2	0	20164	\N
29751	513	3	0	20166	\N
29803	198	19	0	20174	\N
29803	4829	20	0	20175	\N
29880	277	2	0	20853	\N
29880	64	11	0	20859	\N
29782	6025	14	1	21644	\N
29784	6025	15	0	21645	\N
29859	6335	13	0	21653	\N
29774	1075	32	1	21880	\N
29782	6316	19	0	21881	\N
29784	6316	19	0	21882	\N
29797	3009	66	0	21883	\N
29837	8272	14	1	21886	\N
29859	2465	17	1	21889	\N
29904	7281	14	1	21894	\N
29915	90	7	0	26224	\N
29915	8344	8	0	26226	\N
29805	86	9	0	26560	\N
29805	8248	10	0	26562	\N
29774	8217	32	0	27152	\N
29784	646	2	0	29905	\N
29784	449	13	0	29921	\N
29784	8229	14	1	29924	\N
29793	20	12	0	30577	\N
29793	1931	13	0	30584	\N
29764	14	11	0	39525	\N
29764	1785	12	0	39526	\N
29749	18	24	0	40606	\N
29921	18	9	0	40608	\N
29921	7719	10	0	40609	\N
29749	2381	25	0	40611	\N
29862	40	19	0	42618	\N
29862	4104	20	0	42619	\N
29843	56	6	0	44671	\N
29843	3398	7	0	44673	\N
29777	5086	16	0	48116	\N
29867	119	10	0	48632	\N
29894	119	10	0	48633	\N
29894	8328	11	0	48641	\N
29867	8305	11	0	48643	\N
29884	137	20	0	49910	\N
29884	8324	21	0	49913	\N
29992	156	10	0	50458	\N
29992	8411	11	0	50460	\N
29929	186	24	0	51393	\N
29929	7407	25	0	51394	\N
29835	242	5	0	52303	\N
29835	6342	6	0	52304	\N
29924	285	8	0	53713	\N
29924	8353	9	0	53715	\N
29907	435	11	0	55144	\N
29907	481	12	0	55145	\N
29892	841	8	0	57115	\N
29892	8326	9	0	57117	\N
29794	852	12	0	57451	\N
29830	852	0	0	57453	\N
29794	1848	13	0	57460	\N
29901	852	10	0	57465	\N
29901	8334	11	0	57468	\N
29783	4307	75	0	57875	\N
29876	4017	122	0	57886	\N
29905	4017	10	0	57896	\N
30001	2435	122	0	57900	\N
29783	8226	75	1	57996	\N
29800	2171	103	0	58001	\N
29876	8312	124	1	58011	\N
29880	8029	15	0	58021	\N
30001	8251	55	1	58024	\N
29905	8029	13	0	58026	\N
29783	7915	76	1	58552	\N
29876	8212	125	1	58563	\N
29856	2351	10	0	58909	\N
29856	8290	11	0	58910	\N
29977	2351	20	0	58923	\N
29977	8397	21	0	58924	\N
29876	8314	127	0	59135	\N
29880	8225	16	0	59144	\N
29905	8225	14	0	59147	\N
29824	3625	11	0	59624	\N
29824	8263	12	0	59626	\N
29826	3628	6	0	59752	\N
29897	3628	10	0	59754	\N
29826	3643	7	0	59758	\N
29876	8311	124	0	60188	\N
29880	8319	14	1	60195	\N
29905	8258	12	1	60198	\N
29876	8236	123	1	60420	\N
29880	8293	14	0	60424	\N
29905	8236	11	1	60427	\N
29800	6044	102	0	60704	\N
29800	8246	103	1	60708	\N
29964	7412	5	0	61179	\N
29964	7519	6	0	61181	\N
29783	8227	76	0	61207	\N
29876	8224	126	1	61217	\N
29880	8284	15	1	61225	\N
29905	8239	13	1	61228	\N
29876	8298	123	0	61314	\N
29880	8318	13	0	61323	\N
30001	8195	54	1	61326	\N
29905	8269	11	0	61328	\N
30001	8256	123	0	61329	\N
29985	5802	20	0	988	\N
29881	6945	21	0	2172	\N
29819	4178	19	0	8084	\N
29819	5637	20	0	8086	\N
29886	4178	9	0	8095	\N
29895	4178	10	0	8097	\N
29886	7720	10	0	8099	\N
29895	6660	11	0	8102	\N
29817	4219	4	0	9987	\N
29817	4172	5	0	9994	\N
29885	4172	9	0	10003	\N
29898	4172	10	0	10004	\N
29935	4172	10	0	10006	\N
29935	8362	11	0	10010	\N
29898	8331	11	0	10011	\N
29974	4172	18	0	10012	\N
29983	4172	19	0	10013	\N
29974	4977	19	0	10016	\N
29983	4663	20	0	10017	\N
29802	391	11	0	10809	\N
29802	406	12	0	10810	\N
29783	455	1	0	11522	\N
29783	132	74	0	11533	\N
29783	8228	77	0	11539	\N
29788	132	8	0	11544	\N
29912	132	8	0	11549	\N
29912	8341	9	0	11550	\N
29914	132	8	0	11552	\N
29914	8343	9	0	11553	\N
29876	8309	6	0	12658	\N
29873	528	7	0	12659	\N
29988	528	14	0	12662	\N
29873	5937	8	0	12665	\N
29988	5750	15	0	12666	\N
29876	528	121	0	12669	\N
29876	8313	125	0	12670	\N
29909	402	4	0	14187	\N
29854	235	9	0	15877	\N
29854	8288	10	0	15884	\N
29961	142	5	0	18717	\N
29961	8389	6	0	18718	\N
29783	3108	77	1	18773	\N
29876	3108	126	0	18774	\N
29785	60	29	0	19634	\N
29785	8230	30	0	19636	\N
29937	62	10	0	19934	\N
29939	62	5	0	19935	\N
29939	8367	6	0	19936	\N
29937	8363	11	0	19937	\N
29876	8310	122	1	21648	\N
29880	8317	12	1	21655	\N
29905	1355	10	1	21658	\N
30001	6025	54	0	21660	\N
30001	6319	122	1	21665	\N
29800	1075	104	0	21873	\N
29783	6316	78	0	21874	\N
29876	8202	127	1	21885	\N
29880	8272	16	1	21891	\N
29905	7281	14	1	21895	\N
29965	145	17	0	21915	\N
29965	6887	18	0	21917	\N
30001	149	121	0	23281	\N
29828	82	9	0	23822	\N
29828	8265	10	0	23825	\N
29811	6303	5	0	26393	\N
29811	6497	6	0	26396	\N
29994	20	9	0	30579	\N
29994	8141	10	0	30583	\N
29952	230	0	0	32240	\N
29954	230	10	0	32252	\N
29954	8376	11	0	32253	\N
29972	322	9	0	32440	\N
29972	8395	10	0	32443	\N
29905	8337	12	0	32976	\N
29927	14	19	0	39537	\N
29927	8355	20	0	39539	\N
29781	23	20	0	40933	\N
29781	6505	21	0	40934	\N
29847	8276	9	0	42583	\N
29847	40	43	0	42604	\N
29847	8277	45	1	42605	\N
30006	40	20	0	42645	\N
30006	8426	21	0	42649	\N
30008	186	9	0	51404	\N
30008	8427	10	0	51405	\N
29864	260	9	0	52431	\N
29864	8302	10	0	52434	\N
30003	316	9	0	54069	\N
30003	4094	10	0	54073	\N
29831	852	4	0	57454	\N
29831	4162	5	0	57455	\N
29806	908	6	0	57813	\N
29806	8249	7	0	57816	\N
29813	4307	125	0	57876	\N
29799	2435	9	0	57884	\N
29818	4017	11	0	57885	\N
29847	2435	44	0	57888	\N
29849	2435	10	0	57890	\N
29879	8292	12	0	57893	\N
29932	4307	16	0	57901	\N
29813	8251	126	0	57995	\N
29799	8242	11	1	58009	\N
29818	8201	14	1	58010	\N
29847	8197	46	1	58013	\N
29849	8226	11	0	58015	\N
29861	2171	11	1	58019	\N
29879	8029	14	1	58020	\N
29932	8197	18	1	58028	\N
30001	8351	125	1	58030	\N
29815	1470	18	0	58373	\N
29815	8253	19	0	58377	\N
29813	7915	126	1	58553	\N
29799	3526	12	0	58561	\N
29818	8212	15	0	58562	\N
29847	8279	47	1	58566	\N
29799	8243	13	0	59134	\N
29818	8225	16	0	59136	\N
29847	8243	48	0	59138	\N
29861	8299	13	0	59142	\N
29879	8225	16	0	59143	\N
30001	8423	127	0	59206	\N
29866	3625	10	0	59627	\N
29893	3625	10	0	59628	\N
29893	8327	11	0	59630	\N
29866	8304	11	0	59631	\N
29799	8241	11	0	60187	\N
29818	8258	14	0	60189	\N
29847	8213	46	0	60191	\N
29879	8319	14	0	60194	\N
29932	8359	18	0	60199	\N
30001	8213	125	0	60205	\N
30001	8422	126	0	60256	\N
29799	8220	10	1	60418	\N
29818	8236	13	1	60419	\N
29879	8293	13	1	60423	\N
29932	8236	17	1	60428	\N
30001	8293	124	1	60431	\N
29799	6044	8	0	60703	\N
29799	8245	13	1	60705	\N
29839	7412	23	0	61178	\N
29839	8273	24	0	61183	\N
29799	8224	12	1	61215	\N
29818	8224	15	1	61216	\N
29849	8284	11	1	61219	\N
29861	8198	12	1	61223	\N
29879	8284	15	1	61224	\N
30001	8239	126	1	61233	\N
29847	8278	47	0	61289	\N
29799	8240	10	0	61313	\N
29818	8256	12	1	61315	\N
29847	8195	45	0	61317	\N
29861	8298	11	0	61321	\N
29879	8318	13	0	61322	\N
29932	8256	17	0	61331	\N
30001	8421	124	0	1360	\N
29851	8286	15	0	2919	\N
29879	4247	2	0	8094	\N
29888	4178	10	0	8096	\N
29879	4178	11	0	8098	\N
29879	8320	15	0	8100	\N
29888	6660	11	0	8101	\N
29822	4172	9	0	9996	\N
29822	5365	10	0	9998	\N
29849	4172	9	0	10000	\N
29849	8283	10	1	10001	\N
29855	4172	10	0	10002	\N
29855	8289	11	0	10009	\N
29789	8231	30	0	11538	\N
29871	108	20	0	11877	\N
29899	108	10	0	11878	\N
29871	8307	21	0	11881	\N
29899	8332	11	0	11882	\N
29875	528	6	0	12660	\N
29875	7486	7	0	12664	\N
29903	665	11	0	13690	\N
29903	58	12	0	13696	\N
29853	402	19	0	14177	\N
29853	8287	20	0	14179	\N
29910	402	9	0	14188	\N
29818	38	10	0	16567	\N
29818	8255	12	0	16569	\N
29786	60	29	0	19635	\N
29786	8230	30	0	19637	\N
29882	62	20	0	19926	\N
29882	8322	21	0	19927	\N
29799	1355	9	1	21647	\N
29818	6319	11	1	21649	\N
29847	6025	44	1	21651	\N
29879	8317	12	1	21654	\N
29932	8317	16	1	21662	\N
29813	5348	127	0	21870	\N
29847	7281	48	1	21887	\N
29879	8272	16	1	21890	\N
29877	336	19	0	22920	\N
29877	8315	20	0	22922	\N
29918	149	4	0	23261	\N
29918	4040	5	0	23263	\N
30001	8420	123	1	23282	\N
30010	82	9	0	23823	\N
30010	8265	10	0	23826	\N
29792	140	13	0	24264	\N
29792	6827	14	0	24265	\N
29813	649	4	0	24529	\N
29813	8250	125	1	24547	\N
29829	224	6	0	25705	\N
29829	8266	7	0	25707	\N
29833	90	6	0	26220	\N
29833	6622	7	0	26221	\N
29916	90	10	0	26225	\N
29916	8345	11	0	26227	\N
29790	785	0	0	26318	\N
29804	86	6	0	26559	\N
29804	8247	7	0	26561	\N
29841	86	9	0	26567	\N
29841	8274	10	0	26568	\N
29858	8248	10	0	26574	\N
29861	322	10	0	32439	\N
29861	8300	12	0	32444	\N
29809	2	5	0	35430	\N
29809	6376	6	0	35432	\N
29925	14	5	0	39536	\N
29925	5648	6	0	39538	\N
29932	14	15	0	39542	\N
29932	8360	19	0	39543	\N
29913	18	10	0	40607	\N
29913	8342	11	0	40610	\N
29890	27	6	0	41297	\N
29962	40	5	0	42630	\N
29962	3999	6	0	42631	\N
29966	40	19	0	42644	\N
29966	8391	20	0	42647	\N
29955	56	10	0	44681	\N
29955	8377	11	0	44686	\N
29936	119	10	0	48634	\N
29936	8305	11	0	48644	\N
29928	170	19	0	50828	\N
29928	6625	20	0	50829	\N
29930	8356	91	0	51385	\N
29930	186	96	0	51396	\N
29930	8357	100	0	51397	\N
30038	285	10	0	53724	\N
30038	8442	11	0	53725	\N
29945	316	8	0	54068	\N
30004	316	8	0	54070	\N
29945	8370	9	0	54071	\N
30004	8370	9	0	54072	\N
29920	4017	79	0	57897	\N
29930	4017	97	0	57898	\N
29938	2435	56	0	57899	\N
29933	4307	16	0	57902	\N
29959	4015	7	0	57905	\N
29998	8292	21	0	57909	\N
29930	5889	99	1	58022	\N
29920	8351	82	0	58023	\N
29938	8242	58	1	58027	\N
29933	8197	19	0	58029	\N
29957	8381	14	1	58035	\N
29998	8201	23	1	58037	\N
29968	2578	13	0	58661	\N
29968	7054	14	0	58663	\N
29930	8358	101	0	59145	\N
29920	8352	83	0	59148	\N
29932	8225	20	0	59149	\N
29933	8225	20	0	59150	\N
29938	8225	59	1	59151	\N
29957	8383	15	1	59153	\N
29998	8415	24	1	59158	\N
29934	3625	10	0	59629	\N
29934	8304	11	0	59632	\N
29897	8330	11	0	59757	\N
29938	3628	55	0	59760	\N
29938	8365	60	0	59761	\N
29930	8319	99	0	60196	\N
29933	8359	18	1	60200	\N
29920	8350	81	1	60201	\N
29938	8319	58	0	60202	\N
29957	8380	14	0	60204	\N
29959	8213	9	0	60207	\N
29998	8271	23	0	60210	\N
30000	8380	12	0	60212	\N
30034	8213	13	0	60215	\N
29920	8349	81	0	60425	\N
29933	8236	18	0	60429	\N
29938	8236	57	1	60430	\N
29957	8220	13	1	60433	\N
29959	8349	8	1	60435	\N
29998	8349	22	1	60438	\N
29998	6727	7	0	60707	\N
29998	6044	20	0	60709	\N
29998	8416	25	0	60710	\N
29930	8224	100	1	61226	\N
29920	8239	82	1	61229	\N
29938	8198	59	0	61230	\N
29932	8239	19	1	61231	\N
29933	8239	19	1	61232	\N
29957	8382	15	0	61237	\N
29998	8224	24	0	61240	\N
30034	8198	13	1	61245	\N
29930	8298	98	0	61324	\N
29920	8256	80	0	61325	\N
29938	8298	57	0	61330	\N
29933	8256	17	1	61332	\N
29957	8378	13	0	61337	\N
29998	8298	22	0	61339	\N
30034	8195	12	1	61344	\N
29963	8390	6	0	457	\N
29959	8387	7	0	2711	\N
29959	8388	8	0	2712	\N
29926	228	19	0	2923	\N
29926	8354	20	0	2926	\N
29922	4172	8	0	10005	\N
29922	7540	9	0	10007	\N
30031	4172	19	0	10018	\N
30031	4663	20	0	10019	\N
29911	132	10	0	11548	\N
29911	8340	11	0	11551	\N
30036	132	2	0	11560	\N
30036	2927	3	0	11561	\N
29989	528	19	0	12663	\N
29987	5604	20	0	12667	\N
29989	5604	20	0	12668	\N
29930	6335	97	1	21656	\N
29920	8310	79	1	21659	\N
29938	8310	56	1	21661	\N
29933	8317	16	1	21663	\N
29957	8310	12	0	21667	\N
29998	6335	21	1	21669	\N
30000	6025	11	0	21671	\N
29930	6374	101	1	21892	\N
29920	8272	83	1	21893	\N
29932	8259	20	1	21897	\N
29933	8259	20	1	21898	\N
29957	8366	16	0	21901	\N
29998	8366	25	1	21919	\N
29967	73	13	0	22653	\N
29967	2827	14	0	22654	\N
29969	336	9	0	22932	\N
29920	8347	11	0	23253	\N
30000	149	10	0	23262	\N
30000	8418	11	1	23264	\N
29920	149	78	0	23267	\N
29920	8348	80	1	23268	\N
30013	8147	10	0	25708	\N
29950	86	19	0	26580	\N
29950	8374	20	0	26581	\N
30034	86	11	0	26586	\N
30034	8439	12	0	26587	\N
29991	94	14	0	27147	\N
29991	4547	15	0	27150	\N
29951	96	9	0	29672	\N
29951	8375	10	0	29673	\N
29993	20	7	0	30578	\N
29993	8412	8	0	30580	\N
29947	360	10	0	31567	\N
29996	33	6	0	31959	\N
29996	5983	7	0	31961	\N
29940	230	6	0	32236	\N
29941	230	0	0	32237	\N
29943	230	0	0	32239	\N
29940	8368	7	0	32241	\N
29953	230	0	0	32251	\N
30007	2	10	0	35479	\N
30007	8152	11	0	35480	\N
30042	14	21	0	39552	\N
30045	14	20	0	39553	\N
30045	8448	21	0	39555	\N
29933	18	15	0	40612	\N
29949	18	9	0	40613	\N
29949	7719	10	0	40614	\N
29957	1685	2	0	40615	\N
29933	8361	17	0	40616	\N
30002	18	9	0	40617	\N
29957	18	11	0	40618	\N
30002	7719	10	0	40619	\N
29957	8384	12	1	40620	\N
29970	23	9	0	40935	\N
29970	8393	10	0	40940	\N
30033	2796	4	0	42632	\N
30033	40	19	0	42646	\N
30033	8438	22	0	42648	\N
29999	4791	7	0	44680	\N
29999	56	20	0	44687	\N
29999	8417	24	0	44689	\N
29960	79	4	0	46130	\N
29960	3678	5	0	46131	\N
30044	88	21	0	47306	\N
30044	8447	22	0	47310	\N
30043	181	21	0	51127	\N
30043	8446	22	0	51129	\N
29944	200	7	0	51669	\N
29944	8369	8	0	51670	\N
29984	285	19	0	53720	\N
29984	5921	20	0	53721	\N
30047	316	20	0	54079	\N
30047	8449	21	0	54081	\N
30015	595	0	0	55718	\N
30018	595	0	0	55719	\N
30021	595	0	0	55720	\N
30023	595	0	0	55721	\N
30019	597	30	0	56104	\N
30019	8434	31	0	56108	\N
29990	908	14	0	57818	\N
29990	5076	15	0	57819	\N
30048	908	10	0	57820	\N
30048	8450	11	0	57821	\N
29958	4015	6	0	57904	\N
29986	2435	123	0	57906	\N
29979	2435	21	0	57908	\N
29999	8292	21	0	57910	\N
30012	4307	10	0	57913	\N
30033	2435	20	0	57914	\N
29986	8407	125	0	58033	\N
29956	8381	14	1	58034	\N
29979	8401	24	0	58036	\N
29999	8201	23	1	58038	\N
30012	8429	12	1	58040	\N
30033	8251	23	0	58041	\N
29979	8398	3	0	58658	\N
29979	2578	20	0	58662	\N
29979	8399	22	1	58664	\N
29956	8383	15	1	59152	\N
29979	8402	25	0	59154	\N
29980	3843	11	1	59155	\N
29981	3843	10	1	59156	\N
29982	3843	11	1	59157	\N
29999	8415	25	0	59159	\N
30012	8431	14	0	59160	\N
30033	8402	24	0	59162	\N
29986	8409	126	1	59205	\N
29956	8380	14	0	60203	\N
29958	8213	7	1	60206	\N
29979	8400	23	1	60208	\N
29986	8319	124	1	60209	\N
29999	8271	23	0	60211	\N
30012	8380	12	0	60213	\N
30033	8380	22	1	60214	\N
30035	8213	12	1	60216	\N
29956	8220	13	1	60432	\N
29958	8349	7	0	60434	\N
29979	8349	23	0	60437	\N
29999	8349	22	1	60439	\N
30012	8293	11	1	60440	\N
30033	8220	21	1	60441	\N
30017	6450	30	0	60818	\N
30017	8433	31	0	60829	\N
30011	8428	29	0	61175	\N
30011	7412	30	0	61184	\N
30041	7412	22	0	61185	\N
29986	424	122	0	989	\N
30039	117	22	0	2182	\N
30039	8443	23	0	2183	\N
29948	4341	11	0	2315	\N
29948	8373	12	0	2316	\N
30024	262	8	0	4015	\N
30025	262	7	0	4016	\N
30026	262	2	0	4017	\N
30026	2743	3	0	4018	\N
30025	8127	8	0	4019	\N
30024	8436	9	0	4020	\N
29958	8385	6	0	8103	\N
29978	4178	20	0	8107	\N
29978	7664	21	0	8112	\N
29980	4178	10	0	8113	\N
30012	4178	9	0	8114	\N
30012	8430	13	0	8115	\N
29980	8403	11	0	8116	\N
30014	4178	9	0	8117	\N
30014	7720	10	0	8118	\N
30030	4172	13	0	10014	\N
30030	4252	14	0	10015	\N
30035	132	11	0	11558	\N
30035	8440	13	0	11559	\N
29981	38	9	0	16571	\N
29981	8404	10	0	16573	\N
29982	8405	11	0	16574	\N
30020	62	30	0	19944	\N
30020	8435	31	0	19945	\N
29956	277	2	0	20862	\N
29956	64	11	0	20876	\N
29956	8379	13	0	20877	\N
29975	164	18	0	21299	\N
29976	164	9	0	21300	\N
29976	5968	10	0	21301	\N
29975	8396	19	0	21302	\N
29986	7714	123	1	21664	\N
29979	8310	21	1	21668	\N
29999	6335	21	1	21670	\N
30012	8317	10	1	21675	\N
30033	6025	20	1	21676	\N
29986	8410	127	0	21899	\N
29956	8366	16	0	21900	\N
29979	5348	25	1	21918	\N
29999	8366	25	1	21920	\N
30012	3388	14	1	21921	\N
29969	8392	10	0	22934	\N
30005	8424	20	0	24895	\N
30005	8425	21	0	24896	\N
30028	8437	7	0	25370	\N
29946	360	11	0	31566	\N
29946	8371	12	0	31579	\N
29997	33	8	0	31960	\N
29997	8414	9	0	31962	\N
29942	230	0	0	32238	\N
30016	230	30	0	32260	\N
30016	8432	31	0	32262	\N
29995	431	8	0	34876	\N
29995	8413	9	0	34878	\N
29971	2	9	0	35457	\N
29971	8394	10	0	35458	\N
30009	8262	10	0	39554	\N
29973	23	5	0	40936	\N
29973	6746	6	0	40938	\N
30041	8445	23	0	61188	\N
29986	8239	126	0	61234	\N
29956	8382	15	0	61236	\N
29979	8239	24	1	61239	\N
29999	8224	24	1	61241	\N
30012	8224	13	1	61242	\N
30033	8224	23	1	61244	\N
30035	8198	13	1	61246	\N
29986	8318	124	0	61335	\N
29979	8256	22	0	61338	\N
29999	8298	22	0	61340	\N
30012	8269	11	0	61342	\N
30033	8195	21	0	61343	\N
30035	8195	12	0	61345	\N
30083	372	3	0	42650	\N
30037	40	10	0	42666	\N
30046	40	20	0	42667	\N
30094	40	9	0	42668	\N
30083	40	10	0	42669	\N
30083	8470	12	1	42670	\N
30094	8185	10	0	42671	\N
30037	8441	11	0	42672	\N
30046	8426	21	0	42673	\N
30057	79	20	0	46183	\N
30057	6891	21	0	46192	\N
30050	113	0	0	48455	\N
30087	186	9	0	51413	\N
30087	8427	10	0	51414	\N
30032	200	19	0	51676	\N
30032	5930	20	0	51677	\N
30040	285	22	0	53726	\N
30040	8444	23	0	53727	\N
30065	8461	9	0	54078	\N
30065	8462	10	1	54080	\N
30051	4307	18	0	57915	\N
30052	4307	18	0	57916	\N
30063	4017	10	0	57917	\N
30064	4017	10	0	57918	\N
30065	4015	9	0	57919	\N
30080	4307	11	0	57920	\N
30081	4307	11	0	57921	\N
30082	4307	11	0	57922	\N
30083	4307	11	0	57923	\N
30051	8351	20	1	58042	\N
30052	8351	21	0	58043	\N
30063	8460	12	0	58044	\N
30064	8460	12	0	58045	\N
30065	5889	11	0	58046	\N
30080	8407	13	1	58047	\N
30081	8407	13	0	58048	\N
30082	8407	13	0	58049	\N
30083	8407	13	1	58050	\N
30051	8453	21	1	59163	\N
30052	8453	21	1	59164	\N
30063	3843	13	0	59165	\N
30064	3843	13	0	59166	\N
30065	3843	12	0	59167	\N
30080	7951	14	1	59168	\N
30081	7951	14	1	59169	\N
30082	7951	14	1	59170	\N
30083	7951	14	1	59171	\N
30076	4088	5	0	59940	\N
30076	4436	6	0	59941	\N
30063	7733	6	0	60165	\N
30064	7733	6	0	60166	\N
30063	4233	9	0	60169	\N
30064	4233	9	0	60170	\N
30063	8459	10	1	60171	\N
30064	8459	10	1	60172	\N
30051	8380	20	0	60218	\N
30052	8380	20	1	60219	\N
30080	8359	13	0	60220	\N
30081	8359	12	1	60221	\N
30082	8359	12	1	60222	\N
30083	8359	13	0	60223	\N
30051	8236	19	1	60442	\N
30052	8236	20	0	60443	\N
30063	8349	11	1	60444	\N
30064	8349	11	1	60445	\N
30072	7412	8	0	61186	\N
30072	8464	9	0	61187	\N
30063	8382	12	1	61247	\N
30064	8382	12	1	61248	\N
30065	8198	11	1	61249	\N
30080	8284	14	0	61250	\N
30081	8284	14	0	61251	\N
30082	8284	14	0	61252	\N
30083	8284	14	0	61253	\N
30051	8298	19	0	61346	\N
30052	8298	19	0	61347	\N
30053	8308	11	0	140	\N
30049	8451	11	0	3031	\N
30051	4178	17	0	8119	\N
30060	4178	8	0	8120	\N
30060	6776	9	0	8121	\N
30051	8452	21	0	8122	\N
30074	4178	19	0	8123	\N
30074	4665	20	0	8126	\N
30058	4172	19	0	10020	\N
30058	4663	20	0	10021	\N
30066	4172	11	0	10022	\N
30066	5069	12	0	10023	\N
30067	4172	8	0	10024	\N
30080	4275	3	0	10026	\N
30069	4172	11	0	10027	\N
30080	4172	10	0	10028	\N
30080	8468	12	1	10029	\N
30069	5069	12	0	10030	\N
30098	4172	26	0	10034	\N
30075	233	19	0	13977	\N
30075	6101	20	0	13981	\N
30068	235	6	0	15896	\N
30071	235	11	0	15897	\N
30068	8463	7	0	15899	\N
30071	1061	12	0	15900	\N
30027	3486	5	0	16233	\N
30077	62	9	0	19948	\N
30077	8466	10	0	19949	\N
30052	198	17	0	20180	\N
30052	8454	19	1	20181	\N
30056	198	20	0	20187	\N
30056	8456	21	0	20188	\N
30078	198	10	0	20197	\N
30079	198	11	0	20198	\N
30078	8467	11	0	20199	\N
30079	746	12	0	20200	\N
30051	7714	18	1	21677	\N
30063	6025	11	0	21679	\N
30064	6025	11	0	21680	\N
30080	8310	11	1	21681	\N
30081	8310	11	1	21682	\N
30082	8310	11	1	21683	\N
30083	8310	11	1	21684	\N
30080	3009	15	0	21923	\N
30081	3009	15	0	21924	\N
30082	3009	15	0	21925	\N
30083	3009	15	0	21926	\N
30070	140	11	0	24270	\N
30070	487	12	0	24271	\N
30059	3672	20	0	24909	\N
30029	411	5	0	25368	\N
30029	2874	6	0	25369	\N
30061	151	9	0	30823	\N
30062	151	32	0	30824	\N
30061	8457	10	0	30826	\N
30062	8458	33	0	30827	\N
30073	230	11	0	32261	\N
30073	8465	12	0	32263	\N
30055	4	20	0	36154	\N
30055	8455	21	0	36162	\N
30091	6	9	0	36398	\N
30081	4272	3	0	39557	\N
30082	4272	3	0	39558	\N
30081	14	10	0	39563	\N
30082	14	10	0	39564	\N
30081	8469	13	1	39567	\N
30082	8469	13	1	39568	\N
30054	18	10	0	40621	\N
30054	8342	11	0	40624	\N
30065	8195	10	0	61348	\N
30080	8195	12	0	61349	\N
30081	8195	12	0	61350	\N
30082	8195	12	0	61351	\N
30244	40	1	0	42703	\N
30244	1244	2	0	42704	\N
30195	75	24	0	45410	\N
30195	8554	25	0	45413	\N
30168	125	8	0	49381	\N
30168	8528	10	0	49382	\N
30101	137	2	0	49911	\N
30101	2721	3	0	49912	\N
30201	242	0	0	52319	\N
30250	260	9	0	52433	\N
30250	8302	10	0	52435	\N
30213	8570	19	0	53729	\N
30214	8570	19	0	53730	\N
30213	285	34	0	53736	\N
30214	285	34	0	53737	\N
30213	8572	38	1	53739	\N
30214	8572	38	1	53740	\N
30172	597	8	0	56105	\N
30172	8532	9	0	56107	\N
30265	1109	9	0	56156	\N
30265	3580	10	0	56158	\N
30084	4017	9	0	57924	\N
30126	4307	20	0	57926	\N
30168	8292	9	0	57931	\N
30213	2435	35	0	57937	\N
30214	2435	35	0	57938	\N
30216	2435	11	0	57940	\N
30219	2435	11	0	57943	\N
30256	4017	19	0	57947	\N
30084	8460	11	0	58051	\N
30126	8242	22	1	58054	\N
30166	8226	43	1	58061	\N
30168	8242	11	0	58063	\N
30213	8226	37	1	58071	\N
30214	8226	37	1	58072	\N
30216	5889	13	1	58074	\N
30219	5889	13	1	58077	\N
30240	8251	5	1	58081	\N
30254	7296	12	0	58083	\N
30256	8407	22	0	58085	\N
30084	7951	12	1	59172	\N
30126	7951	24	0	59175	\N
30168	8527	12	0	59178	\N
30213	3843	39	1	59184	\N
30214	3843	39	1	59185	\N
30216	7951	14	0	59187	\N
30219	7951	14	0	59190	\N
30240	3843	7	1	59194	\N
30254	3843	13	1	59196	\N
30256	8402	23	0	59198	\N
30084	8471	10	1	60224	\N
30166	8521	43	0	60228	\N
30168	8521	10	1	60230	\N
30256	8237	21	1	60236	\N
30263	4787	1	0	60394	\N
30263	8611	2	0	60395	\N
30267	8349	115	1	60447	\N
30213	8568	36	1	60453	\N
30214	8568	36	1	60454	\N
30166	6753	44	0	60586	\N
30193	6044	24	0	60719	\N
30193	8552	25	0	60726	\N
30126	8196	21	1	1358	\N
30137	4539	15	0	4026	\N
30219	35	10	0	4334	\N
30219	8577	13	0	4338	\N
30213	7846	38	0	5227	\N
30214	7846	38	0	5228	\N
30240	7846	6	1	5230	\N
30098	4347	27	0	10036	\N
30186	4172	7	0	10046	\N
30186	6628	8	0	10047	\N
30261	391	49	0	10843	\N
30261	8609	50	0	10844	\N
30216	4912	12	0	11613	\N
30254	8508	8	0	14784	\N
30254	173	10	0	14792	\N
30254	8601	12	1	14793	\N
30115	8489	11	0	16576	\N
30115	38	53	0	16578	\N
30115	8493	54	0	16580	\N
30117	62	11	0	19955	\N
30117	683	12	0	19959	\N
30174	64	9	0	20886	\N
30174	8534	10	0	20887	\N
30256	488	18	0	21609	\N
30256	8604	20	0	21612	\N
30126	1355	20	1	21688	\N
30166	6025	41	0	21692	\N
30168	6335	9	1	21695	\N
30213	7714	35	1	21703	\N
30214	7714	35	1	21704	\N
30216	7714	11	1	21706	\N
30219	7714	11	1	21709	\N
30254	6025	11	0	21711	\N
30256	8310	19	1	21713	\N
30084	4098	13	0	21922	\N
30166	8524	30	0	24273	\N
30166	140	40	0	24277	\N
30126	69	19	0	24903	\N
30126	8501	23	0	24908	\N
30256	7839	21	0	24936	\N
30184	224	8	0	25714	\N
30184	8542	9	0	25715	\N
30085	206	9	0	25818	\N
30085	8473	10	0	25819	\N
30135	6303	10	0	26394	\N
30135	8503	11	0	26398	\N
30124	7811	20	0	27431	\N
30124	244	21	0	27441	\N
30240	360	4	0	31571	\N
30128	4	6	0	36155	\N
30128	8502	7	0	36159	\N
30084	4272	3	0	39559	\N
30199	14	20	0	39562	\N
30084	14	8	0	39565	\N
30084	8472	11	1	39566	\N
30199	8556	21	0	39569	\N
30170	6450	8	0	60819	\N
30216	6450	10	0	60820	\N
30170	8530	9	0	60827	\N
30216	8574	13	0	60828	\N
30122	6723	23	0	60899	\N
30242	7412	10	0	61195	\N
30242	8590	11	0	61197	\N
30247	7412	19	0	61199	\N
30247	7568	20	0	61200	\N
30084	8284	12	0	61254	\N
30126	8284	23	1	61256	\N
30166	8198	44	1	61261	\N
30168	8284	11	1	61264	\N
30213	8224	39	0	61272	\N
30214	8224	39	0	61273	\N
30240	8284	7	0	61276	\N
30254	8198	13	0	61278	\N
30084	8195	10	0	61353	\N
30126	8298	21	0	61355	\N
30166	8298	41	1	61359	\N
30213	8195	36	0	61365	\N
30214	8195	36	0	61366	\N
30216	8195	12	1	61368	\N
30219	8195	12	1	61371	\N
30240	8195	5	0	61375	\N
30254	8195	11	1	61377	\N
30256	8195	20	1	61379	\N
30126	8500	22	0	61400	\N
30166	8500	42	1	61405	\N
30214	8500	37	0	61412	\N
30196	40	5	0	42691	\N
30196	8555	6	0	42692	\N
30151	56	0	0	44682	\N
30177	79	19	0	46184	\N
30177	4707	20	0	46191	\N
30090	88	9	0	47328	\N
30090	8475	10	0	47330	\N
30096	102	9	0	48124	\N
30097	102	2	0	48125	\N
30097	3053	3	0	48126	\N
30096	4601	10	0	48127	\N
30198	242	7	0	52311	\N
30198	4364	8	0	52314	\N
30099	8478	96	0	53154	\N
30233	279	10	0	53318	\N
30233	8589	11	0	53322	\N
30132	451	11	0	55491	\N
30132	452	12	0	55494	\N
30215	595	10	0	55723	\N
30215	8573	13	0	55734	\N
30181	1109	8	0	56141	\N
30181	8541	9	0	56143	\N
30160	8518	0	0	56533	\N
30125	4307	20	0	57925	\N
30207	8292	122	0	57929	\N
30169	8292	10	0	57932	\N
30188	8292	22	0	57933	\N
30215	2435	11	0	57939	\N
30218	2435	12	0	57942	\N
30125	8242	23	0	58053	\N
30207	8204	125	1	58057	\N
30164	8226	43	0	58059	\N
30169	8242	12	0	58064	\N
30188	8226	25	0	58065	\N
30191	8251	12	1	58067	\N
30215	5889	13	1	58073	\N
30218	5889	14	1	58076	\N
30125	7951	24	0	59174	\N
30207	8453	127	0	59176	\N
30169	8527	13	0	59179	\N
30188	8453	26	0	59180	\N
30215	7951	14	0	59186	\N
30218	7951	15	0	59189	\N
30164	8521	42	1	60226	\N
30169	8521	11	1	60231	\N
30188	8237	24	1	60232	\N
30085	8349	10	1	60446	\N
30207	8293	124	0	60448	\N
30188	8547	24	0	60449	\N
30226	5885	11	0	60554	\N
30226	6674	12	0	60560	\N
30207	7949	126	0	60582	\N
30164	6753	43	1	60584	\N
30188	8546	15	0	60711	\N
30188	6044	21	0	60715	\N
30188	8548	26	1	60717	\N
30194	6044	12	0	60720	\N
30194	8553	13	0	60725	\N
30179	7412	19	0	61189	\N
30179	7568	20	0	61190	\N
30125	8284	23	1	61255	\N
30164	8198	44	1	61259	\N
30207	8198	126	1	61262	\N
30169	8284	12	1	61265	\N
30188	8284	25	1	61266	\N
30191	8198	14	0	61268	\N
30160	8517	0	0	61304	\N
30125	8298	21	0	61354	\N
30164	8298	41	1	61357	\N
30207	8298	123	0	61360	\N
30188	8298	23	1	61361	\N
30215	8195	12	1	61367	\N
30218	8195	13	1	61370	\N
30108	8484	16	0	61390	\N
30106	8482	3	0	61391	\N
30173	8533	10	0	144	\N
30207	8563	123	1	1359	\N
30158	8515	8	0	1646	\N
30158	8516	9	0	1647	\N
30207	8562	35	0	2173	\N
30207	117	121	0	2184	\N
30207	8564	124	1	2185	\N
30224	228	9	0	2924	\N
30224	8587	10	0	2925	\N
30218	35	11	0	4333	\N
30218	8576	14	0	4339	\N
30191	7250	13	0	5222	\N
30134	4178	15	0	8127	\N
30086	4172	28	0	10031	\N
30086	6829	29	0	10032	\N
30095	4172	9	0	10033	\N
30095	5365	10	0	10035	\N
30125	4172	19	0	10038	\N
30125	8499	22	0	10039	\N
30149	4172	10	0	10042	\N
30149	8289	11	0	10043	\N
30162	4172	11	0	10044	\N
30162	5069	12	0	10045	\N
30191	4172	10	0	10048	\N
30203	4172	21	0	10049	\N
30203	5876	22	0	10051	\N
30221	4172	9	0	10052	\N
30221	5365	10	0	10053	\N
30188	4912	23	0	11610	\N
30215	4912	12	0	11612	\N
30218	4912	13	0	11615	\N
30147	173	8	0	14779	\N
30147	8508	9	0	14781	\N
30112	8489	11	0	16575	\N
30112	38	31	0	16577	\N
30112	4771	32	0	16579	\N
30164	8519	30	0	17897	\N
30164	8523	44	0	17937	\N
30111	7575	11	0	18711	\N
30111	142	53	0	18719	\N
30111	6737	54	0	18721	\N
30191	3108	13	1	18775	\N
30118	62	10	0	19956	\N
30118	63	11	0	19958	\N
30120	198	23	0	20207	\N
30120	8495	24	0	20208	\N
30125	1355	20	1	21687	\N
30164	6025	41	0	21690	\N
30207	6025	122	1	21693	\N
30188	6025	22	1	21697	\N
30191	6025	11	0	21699	\N
30215	7714	11	1	21705	\N
30218	7714	12	1	21708	\N
30169	73	9	0	22657	\N
30169	8529	11	0	22658	\N
30145	264	10	0	23681	\N
30145	8506	11	0	23682	\N
30205	82	12	0	23824	\N
30205	8560	13	0	23831	\N
30088	151	9	0	30834	\N
30088	8474	10	0	30838	\N
30092	8476	10	0	31254	\N
30156	360	10	0	31568	\N
30156	8372	11	0	31578	\N
30130	4	11	0	36157	\N
30130	579	12	0	36161	\N
30175	18	10	0	40625	\N
30175	8342	11	0	40626	\N
30106	8483	4	0	61392	\N
30108	8482	36	0	61394	\N
30108	8486	37	0	61396	\N
30125	8500	22	1	61399	\N
30164	8500	42	0	61403	\N
30191	8500	12	0	61407	\N
30212	40	0	0	42560	\N
30119	40	11	0	42690	\N
30119	66	12	0	42693	\N
30152	102	0	0	48132	\N
30104	135	9	0	49647	\N
30104	8481	10	0	49650	\N
30200	242	20	0	52312	\N
30200	8557	21	0	52315	\N
30099	273	123	0	53157	\N
30099	8479	125	1	53158	\N
30139	285	12	0	53732	\N
30139	8504	13	0	53733	\N
30133	451	5	0	55492	\N
30133	6653	6	0	55493	\N
30217	597	10	0	56109	\N
30217	8575	13	0	56111	\N
30223	2435	50	0	57903	\N
30223	2435	98	0	57907	\N
30099	2435	124	0	57911	\N
30154	2435	50	0	57928	\N
30210	2435	35	0	57935	\N
30217	2435	11	0	57941	\N
30220	2435	11	0	57944	\N
30223	8251	53	0	58031	\N
30223	2171	103	0	58032	\N
30099	5889	126	1	58039	\N
30154	8251	50	1	58056	\N
30165	8226	43	1	58060	\N
30210	8226	37	1	58069	\N
30217	5889	13	1	58075	\N
30220	5889	13	0	58078	\N
30114	8491	28	0	58462	\N
30099	8453	127	1	59161	\N
30210	3843	39	1	59182	\N
30217	7951	14	0	59188	\N
30220	7951	14	0	59191	\N
30223	8225	55	0	59207	\N
30223	8299	107	1	59208	\N
30099	8471	126	0	60217	\N
30165	8521	43	0	60227	\N
30223	8582	53	1	60257	\N
30223	8585	103	1	60258	\N
30204	4787	12	0	60384	\N
30208	4787	2	0	60385	\N
30208	8565	3	0	60387	\N
30204	8559	13	0	60388	\N
30223	8220	52	1	60436	\N
30210	8568	36	1	60451	\N
30165	6753	44	0	60585	\N
30187	6044	8	0	60713	\N
30187	6725	9	0	60714	\N
30206	7412	12	0	61193	\N
30206	8561	13	0	61198	\N
30223	7463	104	1	61208	\N
30223	8239	54	1	61235	\N
30223	8284	107	0	61238	\N
30099	8239	127	0	61243	\N
30165	8198	44	1	61260	\N
30210	8224	39	0	61270	\N
30154	8512	51	0	61293	\N
30223	8586	106	1	61303	\N
30223	8298	51	0	61333	\N
30223	8195	100	1	61334	\N
30099	8298	125	0	61341	\N
30165	8298	41	1	61358	\N
30210	8195	36	0	61363	\N
30217	8195	12	1	61369	\N
30220	8195	12	1	61372	\N
30107	8484	16	0	61389	\N
30107	8482	23	0	61393	\N
30107	8485	24	0	61395	\N
30223	8583	98	1	61398	\N
30223	8500	102	0	61401	\N
30165	8500	42	1	61404	\N
30210	8500	37	0	61409	\N
30114	8490	11	0	1850	\N
30114	8492	28	1	1861	\N
30141	262	6	0	4023	\N
30141	4403	7	0	4024	\N
30223	7250	105	0	5224	\N
30210	7846	38	1	5225	\N
30127	4178	8	0	8124	\N
30127	6776	9	0	8125	\N
30210	5897	19	0	8129	\N
30210	4178	34	0	8134	\N
30210	8569	38	0	8135	\N
30109	7815	11	0	10037	\N
30109	4172	53	0	10040	\N
30230	391	27	0	10824	\N
30230	3553	28	0	10825	\N
30217	4912	12	0	11614	\N
30220	4912	12	0	11617	\N
30223	6026	100	0	11618	\N
30223	2466	102	1	11979	\N
30220	528	10	0	12671	\N
30220	8578	13	1	12672	\N
30180	77	8	0	13293	\N
30182	77	4	0	13294	\N
30182	3619	5	0	13295	\N
30180	8540	9	0	13296	\N
30161	173	8	0	14780	\N
30161	8508	9	0	14782	\N
30223	636	105	1	16828	\N
30223	6697	99	1	16960	\N
30154	326	49	0	17553	\N
30154	8513	51	1	17556	\N
30113	7575	11	0	18712	\N
30113	142	53	0	18720	\N
30223	6476	54	0	18779	\N
30223	6476	106	0	18780	\N
30100	164	9	0	21314	\N
30105	164	5	0	21315	\N
30100	8480	10	0	21317	\N
30223	7493	50	1	21672	\N
30099	6025	124	1	21673	\N
30223	7714	99	0	21674	\N
30165	6025	41	0	21691	\N
30210	7714	35	1	21701	\N
30217	7714	11	1	21707	\N
30220	7714	11	1	21710	\N
30225	336	11	0	22933	\N
30225	3378	12	0	22935	\N
30223	8580	51	1	23283	\N
30223	149	97	0	23293	\N
30165	8524	30	0	24272	\N
30165	140	40	0	24276	\N
30165	8525	42	0	24278	\N
30102	69	9	0	24901	\N
30103	69	8	0	24902	\N
30103	5298	9	0	24906	\N
30102	8139	10	0	24907	\N
30143	411	4	0	25374	\N
30143	4858	5	0	25375	\N
30232	6303	10	0	26399	\N
30235	6303	6	0	26400	\N
30235	8591	7	0	26401	\N
30223	7570	101	1	30317	\N
30089	151	5	0	30835	\N
30089	7258	6	0	30837	\N
30093	202	8	0	31251	\N
30093	8477	9	0	31253	\N
30157	360	8	0	31569	\N
30157	8514	9	0	31576	\N
30110	8488	11	0	35481	\N
30110	2	53	0	35505	\N
30110	3914	54	0	35506	\N
30129	4	9	0	36156	\N
30202	4	21	0	36158	\N
30202	8558	22	0	36163	\N
30189	56	11	0	44690	\N
30189	8549	12	0	44694	\N
30159	75	6	0	45409	\N
30159	3303	7	0	45411	\N
30178	79	10	0	46185	\N
30231	79	10	0	46186	\N
30237	79	5	0	46187	\N
30237	8593	6	0	46188	\N
30231	8588	11	0	46189	\N
30178	8539	11	0	46190	\N
30197	242	9	0	52310	\N
30197	3425	10	0	52313	\N
30246	260	19	0	52432	\N
30246	5270	20	0	52436	\N
30227	268	9	0	52713	\N
30229	268	11	0	52714	\N
30227	8125	10	0	52717	\N
30229	4344	12	0	52718	\N
30211	8570	19	0	53728	\N
30138	285	14	0	53731	\N
30138	5103	15	0	53734	\N
30211	285	33	0	53735	\N
30211	8571	37	1	53738	\N
30171	595	8	0	55722	\N
30171	8531	9	0	55732	\N
30264	1109	5	0	56155	\N
30264	6783	6	0	56157	\N
30176	8535	9	0	56541	\N
30176	8538	11	0	56542	\N
30153	2435	50	0	57927	\N
30167	8292	10	0	57930	\N
30190	8292	22	0	57934	\N
30211	2435	34	0	57936	\N
30238	2435	25	0	57945	\N
30153	8251	51	0	58055	\N
30163	8251	43	1	58058	\N
30167	8242	11	1	58062	\N
30190	8226	25	0	58066	\N
30192	8251	12	1	58068	\N
30211	8226	36	1	58070	\N
30238	5889	27	1	58079	\N
30239	8251	9	1	58080	\N
30167	8527	13	0	59177	\N
30190	8453	26	0	59181	\N
30211	3843	38	1	59183	\N
30238	7951	29	0	59192	\N
30239	3843	11	1	59193	\N
30243	4233	7	0	60175	\N
30243	8598	8	0	60176	\N
30163	8521	43	0	60225	\N
30167	8521	11	0	60229	\N
30190	8237	24	1	60233	\N
30238	8521	27	0	60234	\N
30258	4787	41	0	60389	\N
30258	8606	42	0	60392	\N
30190	8547	24	0	60450	\N
30211	8568	35	1	60452	\N
30238	5650	26	1	60456	\N
30176	6751	9	0	60581	\N
30163	6753	44	0	60583	\N
30176	8537	10	1	60590	\N
30185	8545	77	0	60592	\N
30190	8546	15	0	60712	\N
30190	6044	21	0	60716	\N
30190	8548	26	1	60718	\N
30192	7412	10	0	61191	\N
30192	8551	11	1	61192	\N
30234	7412	10	0	61194	\N
30234	8590	11	0	61196	\N
30148	8509	9	0	1793	\N
30140	731	12	0	4025	\N
30236	7225	10	0	4067	\N
30249	7225	11	0	4068	\N
30236	8592	11	0	4072	\N
30249	8599	12	0	4073	\N
30150	35	10	0	4332	\N
30259	35	41	0	4335	\N
30150	8510	11	0	4337	\N
30259	8607	42	0	4340	\N
30192	7250	13	0	5223	\N
30211	7846	37	0	5226	\N
30239	7846	10	1	5229	\N
30228	4178	11	0	8131	\N
30144	6660	11	0	8132	\N
30228	4331	12	0	8133	\N
30238	8122	11	0	10826	\N
30238	391	24	0	10837	\N
30238	8594	25	1	10838	\N
30190	4912	23	0	11611	\N
30121	123	23	0	12842	\N
30121	8496	24	0	12843	\N
30163	8519	30	0	17896	\N
30146	167	8	0	17928	\N
30146	8507	9	0	17931	\N
30163	8522	44	1	17936	\N
30113	6737	54	0	18722	\N
30192	3108	13	1	18776	\N
30238	3268	28	0	18777	\N
30116	62	7	0	19954	\N
30116	8494	8	0	19957	\N
30163	6025	41	1	21689	\N
30167	6335	10	1	21694	\N
30190	6025	22	1	21698	\N
30192	6025	11	0	21700	\N
30211	7714	34	1	21702	\N
30253	67	10	0	22236	\N
30222	149	8	0	23279	\N
30222	8579	9	0	23280	\N
30142	411	9	0	25373	\N
30142	8505	10	0	25376	\N
30183	224	9	0	25713	\N
30183	8147	10	0	25716	\N
30136	6303	5	0	26395	\N
30136	6497	6	0	26397	\N
30185	8543	63	0	27696	\N
30185	42	75	0	27704	\N
30185	8544	76	0	27705	\N
30209	8567	0	0	27712	\N
30153	8511	50	1	30839	\N
30123	202	28	0	31252	\N
30123	8498	29	0	31255	\N
30239	360	8	0	31570	\N
30239	8595	10	0	31575	\N
30167	431	9	0	34879	\N
30167	8526	12	0	34880	\N
30155	2	10	0	35503	\N
30155	5985	11	0	35504	\N
30245	2	19	0	35515	\N
30245	5296	20	0	35516	\N
30131	18	3	0	40622	\N
30251	18	11	0	40627	\N
30163	8198	45	0	61258	\N
30167	8284	12	1	61263	\N
30190	8284	25	1	61267	\N
30192	8198	14	0	61269	\N
30211	8224	38	0	61271	\N
30238	8198	28	1	61274	\N
30239	8284	11	0	61275	\N
30153	8512	51	1	61292	\N
30176	8536	10	0	61296	\N
30185	8536	76	1	61297	\N
30163	8195	42	0	61356	\N
30211	8195	35	0	61364	\N
30238	8298	26	0	61373	\N
30239	8195	9	0	61374	\N
30163	8520	41	0	61397	\N
30163	8500	42	1	61402	\N
30192	8500	12	0	61408	\N
30211	8500	36	0	61410	\N
30284	40	2	0	42724	\N
30284	282	3	0	42725	\N
30312	79	1	0	46255	\N
30312	81	2	0	46256	\N
30305	88	7	0	47329	\N
30305	4949	8	0	47331	\N
30276	6229	24	0	50463	\N
30276	156	33	0	50464	\N
30276	8622	37	0	50465	\N
30271	210	11	0	52019	\N
30271	8618	12	0	52021	\N
30280	8628	11	0	52706	\N
30280	268	12	0	52719	\N
30248	279	11	0	53319	\N
30286	279	6	0	53320	\N
30286	8629	7	0	53321	\N
30248	280	12	0	53323	\N
30255	4017	19	0	57946	\N
30257	4017	19	0	57948	\N
30266	4017	35	0	57949	\N
30268	2435	21	0	57950	\N
30269	2435	12	0	57951	\N
30277	2435	12	0	57952	\N
30267	8226	126	0	58052	\N
30241	8251	3	1	58082	\N
30255	8407	21	1	58084	\N
30257	8407	21	1	58086	\N
30266	8226	37	0	58087	\N
30268	2171	22	1	58088	\N
30269	2171	13	1	58089	\N
30276	8226	35	1	58090	\N
30277	8407	14	1	58091	\N
30267	3843	127	0	59173	\N
30241	3843	5	1	59195	\N
30255	8402	23	0	59197	\N
30257	8402	23	0	59199	\N
30266	7951	38	0	59200	\N
30276	8624	38	0	59201	\N
30277	8431	17	0	59202	\N
30255	8237	21	0	60235	\N
30257	8237	21	0	60237	\N
30277	8237	14	0	60238	\N
30260	4787	2	0	60390	\N
30260	8608	3	0	60391	\N
30262	4787	20	0	60393	\N
30262	8610	21	0	60396	\N
30279	5885	8	0	60555	\N
30279	7539	9	0	60559	\N
30266	7690	37	1	60587	\N
30268	7690	23	0	60588	\N
30269	7690	14	0	60589	\N
30276	6753	36	1	60593	\N
30277	7690	15	0	60594	\N
30309	6044	2	0	60721	\N
30311	6044	1	0	60722	\N
30311	6993	2	0	60723	\N
30309	6188	3	0	60724	\N
30299	6450	10	0	60821	\N
30299	8637	11	0	60830	\N
30293	7412	13	0	61201	\N
30293	8633	14	0	61202	\N
30267	8284	126	1	61257	\N
30241	8284	5	0	61277	\N
30255	8603	22	1	61279	\N
30257	8603	22	1	61281	\N
30276	8623	37	1	61282	\N
30277	8626	16	1	61283	\N
30276	8512	36	0	61294	\N
30241	8195	3	0	61376	\N
30255	8195	20	0	61378	\N
30257	8195	20	0	61380	\N
30266	8195	36	0	61381	\N
30268	8298	22	0	61382	\N
30269	8298	13	0	61383	\N
30276	8195	34	1	61384	\N
30267	8615	125	1	464	\N
30277	7250	15	1	5232	\N
30252	4178	9	0	8136	\N
30257	4178	18	0	8137	\N
30252	7720	10	0	8138	\N
30257	8605	22	0	8139	\N
30282	4178	5	0	8140	\N
30282	4202	6	0	8142	\N
30270	4172	19	0	10054	\N
30270	8362	20	0	10055	\N
30289	4172	13	0	10057	\N
30301	4172	10	0	10058	\N
30289	5534	14	0	10060	\N
30310	391	2	0	10850	\N
30310	1381	3	0	10851	\N
30277	4912	13	0	11619	\N
30302	528	7	0	12673	\N
30303	528	3	0	12674	\N
30303	4262	4	0	12675	\N
30302	5937	8	0	12676	\N
30307	402	2	0	14205	\N
30307	2760	3	0	14206	\N
30296	258	7	0	14496	\N
30296	8635	8	0	14497	\N
30266	8612	14	0	15409	\N
30266	8613	36	1	15415	\N
30291	235	13	0	15898	\N
30291	8632	14	0	15901	\N
30275	44	4	0	16231	\N
30275	3486	5	0	16234	\N
30313	167	5	0	17929	\N
30315	167	5	0	17930	\N
30315	8507	6	0	17933	\N
30277	3108	16	0	18778	\N
30267	6025	125	0	21686	\N
30255	8310	19	1	21712	\N
30257	8310	19	1	21714	\N
30276	7714	34	0	21716	\N
30277	6335	12	1	21717	\N
30266	1075	38	1	21927	\N
30268	1075	23	1	21928	\N
30269	1075	14	1	21929	\N
30276	1075	38	1	21930	\N
30274	69	39	0	24905	\N
30274	8621	40	0	24911	\N
30255	7839	20	1	24935	\N
30257	7839	20	1	24937	\N
30276	8027	35	0	24938	\N
30295	411	7	0	25383	\N
30306	411	8	0	25385	\N
30295	8634	8	0	25386	\N
30304	6487	8	0	25387	\N
30306	8640	9	0	25388	\N
30288	224	5	0	25721	\N
30290	224	13	0	25722	\N
30288	4419	6	0	25723	\N
30290	8631	14	0	25724	\N
30272	94	11	0	27148	\N
30272	8619	12	0	27149	\N
30241	360	2	0	31572	\N
30241	8597	4	0	31573	\N
30269	230	11	0	32271	\N
30269	8617	12	1	32272	\N
30268	8616	21	1	32273	\N
30255	322	18	0	32441	\N
30292	322	13	0	32442	\N
30292	6722	14	0	32445	\N
30255	8602	22	0	32446	\N
30277	2	11	0	35522	\N
30277	8625	13	1	35523	\N
30314	18	5	0	40628	\N
30314	8641	6	0	40629	\N
30251	218	12	0	40630	\N
30278	8627	9	0	40939	\N
146	51	1	0	43441	1000000000
243	51	1	0	43442	1000000000
30317	2795	2	0	44685	\N
30317	56	4	0	44691	\N
30317	8642	6	1	44692	\N
30316	75	2	0	45424	\N
30316	284	3	0	45425	\N
30308	79	2	0	46254	\N
30308	616	3	0	46257	\N
92	113	2	0	48153	1000000000
694	113	1	0	48154	1000000000
96	119	1	0	48490	1000000000
1065	121	1	0	48786	1000000000
100	125	3	0	49119	1000000000
114	135	1	0	49385	1000000000
187	135	2	0	49386	1000000000
458	135	1	0	49388	1000000000
486	135	1	0	49389	1000000000
857	135	1	0	49390	1000000000
1236	135	1	0	49391	1000000000
1056	147	17	0	49940	1000000000
1112	147	2	0	49941	1000000000
1271	147	1	0	49942	1000000000
167	181	4	0	50830	1000000000
170	186	1	0	51139	1000000000
254	242	0	0	52028	1000000000
30283	260	6	0	52439	\N
30283	7255	7	0	52440	\N
30287	8630	7	0	4071	\N
30297	4178	5	0	8141	\N
30297	4202	6	0	8143	\N
30285	4172	6	0	10056	\N
30285	5278	7	0	10059	\N
30313	8507	6	0	17932	\N
30317	6335	5	1	21718	\N
30318	6335	5	1	21719	\N
30317	1075	8	0	21931	\N
30318	2766	2	0	22659	\N
30318	73	4	0	22664	\N
30318	8644	6	0	22665	\N
30273	69	22	0	24904	\N
30273	8620	23	0	24910	\N
2	1	0	0	32979	1000000000
3	2	4	0	34881	1000000000
30294	2	7	0	35539	\N
30294	6780	8	0	35540	\N
6	8	1	0	36435	1000000000
9	14	1	0	38958	1000000000
257	27	1	0	40946	1000000000
30	40	1	0	41319	1000000000
54	40	2	0	41320	1000000000
174	40	1	0	41323	1000000000
182	40	1	0	41324	1000000000
293	268	1	0	52607	1000000000
30281	268	8	0	52715	\N
30281	7542	9	0	52716	\N
778	279	1	0	53167	1000000000
437	285	1	0	53350	1000000000
586	285	1	0	53351	1000000000
954	285	1	0	53352	1000000000
991	285	1	0	53353	1000000000
380	316	1	0	53843	1000000000
392	324	1	0	54117	1000000000
479	362	2	0	54731	1000000000
540	362	1	0	54732	1000000000
512	378	1	0	54905	1000000000
637	416	1	0	54947	1000000000
692	435	1	0	54957	1000000000
804	435	2	0	54958	1000000000
728	451	2	0	55151	1000000000
834	483	1	0	55511	1000000000
11866	483	1	0	55512	1000000000
13720	483	4	0	55513	1000000000
1269	595	1	0	55533	1000000000
1409	595	1	0	55534	1000000000
30298	595	5	0	55724	\N
30298	8636	6	0	55735	\N
1410	597	1	0	55827	1000000000
1640	597	1	0	55828	1000000000
2157	597	2	0	55829	1000000000
30300	597	10	0	56110	\N
30300	8638	11	0	56112	\N
1467	637	1	0	56358	1000000000
1777	704	1	0	56366	1000000000
2056	756	1	0	56582	1000000000
5919	756	3	0	56583	1000000000
9064	756	3	0	56584	1000000000
2246	793	0	0	56607	1000000000
2479	841	1	0	56904	1000000000
2739	852	1	0	57175	1000000000
2941	852	1	0	57176	1000000000
2586	878	0	0	57504	1000000000
2823	878	0	0	57505	1000000000
2594	880	1	0	57506	1000000000
11588	880	1	0	57507	1000000000
3775	1130	1	0	57823	1000000000
30317	4017	5	0	57953	\N
30318	4017	5	0	57954	\N
4348	1225	3	0	57967	1000000000
30317	8251	6	0	58092	\N
30318	8251	6	1	58093	\N
6364	1545	1	0	58425	1000000000
6575	1587	2	0	58431	1000000000
6646	1602	2	0	58437	1000000000
8113	1602	1	0	58438	1000000000
8297	1914	1	0	58473	1000000000
8298	1914	2	0	58474	1000000000
8424	1952	0	0	58525	1000000000
9715	2248	120	0	58665	1000000000
10004	2351	2	0	58903	1000000000
30317	8431	7	1	59203	\N
30318	8431	7	1	59204	\N
10157	2426	2	0	59210	1000000000
11230	2426	5	0	59211	1000000000
10730	2594	1	0	59218	1000000000
10954	2647	5	0	59429	1000000000
11422	2815	4	0	59441	1000000000
13263	3625	7	0	59484	1000000000
13265	3628	7	0	59633	1000000000
14387	4185	0	0	59942	1000000000
14411	4194	2	0	59943	1000000000
22074	6450	6	0	60739	1000000000
22136	6450	4	0	60740	1000000000
23374	6450	2	0	60741	1000000000
23476	6450	3	0	60742	1000000000
23867	6450	3	0	60743	1000000000
24088	6450	8	0	60744	1000000000
24331	6450	11	0	60745	1000000000
24351	6450	2	0	60746	1000000000
22809	6664	3	0	60832	1000000000
24663	7113	4	0	60965	1000000000
30317	8643	7	0	61284	\N
30318	8643	7	0	61285	\N
8314	1922	1	0	1	\N
11789	3003	127	1	3	\N
325	288	2	0	4	\N
325	289	3	0	5	\N
557	288	1	0	6	\N
1290	288	1	0	7	\N
1473	288	2	0	8	\N
1618	288	1	0	12	\N
1779	288	1	0	13	\N
2196	288	1	0	14	\N
2321	288	1	0	16	\N
2405	288	1	0	17	\N
1779	400	2	0	19	\N
2196	400	2	0	20	\N
3319	288	2	0	23	\N
3468	288	0	0	25	\N
23802	288	7	0	26	\N
23827	288	3	0	27	\N
23974	400	1	0	29	\N
3760	288	1	0	31	\N
3831	288	2	0	35	\N
24135	288	2	0	37	\N
24325	288	7	0	38	\N
4074	288	1	0	41	\N
24490	288	4	0	43	\N
24860	288	8	0	44	\N
25014	288	2	0	45	\N
24490	5098	5	0	47	\N
4715	288	1	0	49	\N
4846	288	1	0	50	\N
5264	288	2	0	51	\N
25107	288	10	0	55	\N
5506	288	0	0	57	\N
25984	288	2	0	58	\N
26349	288	1	0	59	\N
25984	2842	3	0	61	\N
26537	288	5	0	63	\N
26702	288	3	0	64	\N
26997	288	8	0	65	\N
27169	288	5	0	66	\N
5573	288	0	0	71	\N
27241	288	2	0	72	\N
6237	288	2	0	74	\N
6397	288	0	0	75	\N
6713	288	2	0	76	\N
6190	400	2	0	80	\N
5632	288	0	0	81	\N
27411	288	3	0	82	\N
27914	288	3	0	83	\N
6958	288	2	0	86	\N
28246	288	3	0	88	\N
6996	288	2	0	90	\N
28284	288	2	0	92	\N
18653	288	4	0	94	\N
20278	5943	73	0	96	\N
7044	288	4	0	97	\N
19177	288	3	0	101	\N
19333	288	4	0	102	\N
22896	288	4	0	103	\N
23168	288	2	0	104	\N
23261	288	2	0	105	\N
23168	2842	3	0	106	\N
20278	5944	127	0	112	\N
7286	288	1	0	113	\N
28440	288	2	0	115	\N
23341	5098	5	0	118	\N
7750	288	2	0	119	\N
29130	288	8	0	121	\N
8663	288	1	0	123	\N
29443	288	2	0	125	\N
29457	288	7	0	126	\N
8912	288	2	0	129	\N
9062	288	4	0	130	\N
9097	289	3	0	133	\N
29874	288	10	0	135	\N
9105	288	2	0	137	\N
30053	288	10	0	139	\N
9219	288	4	0	141	\N
30173	288	9	0	143	\N
9610	288	5	0	145	\N
9755	288	2	0	146	\N
9762	288	7	0	149	\N
9795	288	2	0	151	\N
10167	288	2	0	153	\N
10562	288	2	0	154	\N
10742	289	2	0	157	\N
10742	400	5	0	159	\N
11119	288	4	0	160	\N
11127	288	2	0	162	\N
11477	288	2	0	163	\N
13990	3996	4	0	166	\N
14182	288	6	0	168	\N
14570	288	6	0	169	\N
14613	288	3	0	170	\N
14845	288	2	0	171	\N
11789	288	126	0	176	\N
14984	288	1	0	177	\N
15668	288	6	0	179	\N
82	102	1	0	47763	1000000000
115	137	1	0	49656	1000000000
1059	550	38	0	49937	1000000000
25540	483	2	0	55514	1000000000
2729	908	1	0	57512	1000000000
6785	1658	0	0	58445	1000000000
19248	2249	3	0	58666	1000000000
10457	2522	6	0	59216	1000000000
10458	2522	5	0	59217	1000000000
22142	2815	4	0	59442	1000000000
13106	3516	0	0	59483	1000000000
13292	3628	6	0	59634	1000000000
14190	4088	4	0	59801	1000000000
14515	4088	6	0	59802	1000000000
14707	4088	2	0	59803	1000000000
14751	4088	2	0	59804	1000000000
14493	4233	4	0	59946	1000000000
14988	4233	3	0	59948	1000000000
15718	4605	10	0	60241	1000000000
15719	4605	10	0	60242	1000000000
16170	4740	4	0	60252	1000000000
16171	4742	4	0	60254	1000000000
16299	4787	3	0	60263	1000000000
16499	4787	4	0	60264	1000000000
17955	5289	3	0	60399	1000000000
18926	5531	1	0	60402	1000000000
21348	5531	12	0	60403	1000000000
19108	5560	6	0	60406	1000000000
20124	5885	6	0	60463	1000000000
20578	6044	3	0	60607	1000000000
20823	6044	1	0	60608	1000000000
24906	6450	4	0	60747	1000000000
22484	6568	9	0	60831	1000000000
23005	6723	3	0	60846	1000000000
23078	6723	4	0	60847	1000000000
23161	6723	2	0	60848	1000000000
23164	6765	4	0	60904	1000000000
23272	6765	6	0	60905	1000000000
23431	6765	2	0	60906	1000000000
23551	6765	7	0	60907	1000000000
23655	6765	3	0	60908	1000000000
24131	6765	8	0	60909	1000000000
26047	7412	2	0	60967	1000000000
26071	7412	4	0	60968	1000000000
27537	7745	7	0	61385	1000000000
30209	8566	0	0	61413	1000000000
14984	400	2	0	180	\N
15686	288	3	0	183	\N
16318	288	5	0	184	\N
16991	288	3	0	187	\N
17056	288	5	0	189	\N
17228	288	6	0	191	\N
17332	288	4	0	192	\N
17576	288	3	0	195	\N
17877	288	3	0	196	\N
17894	288	3	0	199	\N
18505	288	3	0	201	\N
18687	5488	4	0	203	\N
8	12	1	0	204	\N
240	12	1	0	205	\N
375	12	1	0	206	\N
469	12	4	0	207	\N
617	12	1	0	212	\N
687	12	2	0	213	\N
905	12	2	0	214	\N
994	12	1	0	215	\N
10739	12	2	0	220	\N
10740	12	2	0	221	\N
1119	12	2	0	224	\N
1567	12	2	0	225	\N
11035	12	1	0	228	\N
11037	12	2	0	229	\N
11396	12	2	0	230	\N
11409	12	3	0	231	\N
11580	12	1	0	232	\N
11799	12	1	0	233	\N
2193	12	4	0	242	\N
2195	12	62	0	244	\N
1843	13	2	0	245	\N
1845	433	3	0	246	\N
11831	12	2	0	249	\N
11904	12	1	0	256	\N
22923	12	3	0	258	\N
23547	12	3	0	259	\N
2518	12	3	0	262	\N
2610	12	2	0	263	\N
12101	12	2	0	266	\N
23722	12	6	0	268	\N
23925	12	3	0	270	\N
2644	12	1	0	274	\N
12167	12	0	0	276	\N
12169	12	1	0	277	\N
13003	12	6	0	278	\N
13005	3454	6	0	281	\N
24044	12	2	0	283	\N
3418	12	1	0	285	\N
13017	12	5	0	289	\N
24880	12	4	0	291	\N
4332	12	1	0	293	\N
13394	12	7	0	295	\N
25176	12	4	0	298	\N
4643	12	18	0	301	\N
4644	12	1	0	302	\N
13416	12	10	0	304	\N
25536	12	3	0	307	\N
4862	12	4	0	309	\N
13972	12	8	0	311	\N
13973	12	2	0	312	\N
25766	12	3	0	315	\N
26013	12	4	0	316	\N
5255	1410	0	0	319	\N
5256	12	2	0	320	\N
14030	12	6	0	322	\N
26161	4026	7	0	325	\N
5259	12	0	0	326	\N
5257	12	0	0	327	\N
5425	12	0	0	329	\N
5426	12	0	0	330	\N
14072	12	4	0	331	\N
14116	12	4	0	332	\N
26228	12	3	0	335	\N
26243	782	3	0	337	\N
5709	12	0	0	338	\N
5803	13	2	0	340	\N
14402	12	4	0	341	\N
14424	12	3	0	343	\N
6112	12	1	0	349	\N
15016	12	1	0	351	\N
26250	4043	5	0	356	\N
6128	12	1	0	357	\N
6262	12	1	0	358	\N
6546	12	6	0	359	\N
15046	12	2	0	363	\N
6846	12	6	0	368	\N
6941	12	2	0	370	\N
6943	12	1	0	371	\N
15254	12	4	0	377	\N
15582	12	1	0	378	\N
15849	12	10	0	379	\N
16042	12	4	0	380	\N
16186	12	11	0	381	\N
16497	12	3	0	382	\N
26901	12	6	0	389	\N
7457	12	1	0	391	\N
8460	1577	6	0	393	\N
17575	12	3	0	394	\N
27049	12	6	0	396	\N
27057	12	6	0	397	\N
27192	4204	4	0	399	\N
7554	12	1	0	402	\N
8458	12	1	0	403	\N
8460	12	7	0	406	\N
17941	12	4	0	408	\N
8659	12	1	0	413	\N
8716	12	0	0	414	\N
18128	12	7	0	416	\N
18688	13	1	0	420	\N
27549	12	3	0	422	\N
27919	12	3	0	423	\N
8717	12	2	0	426	\N
19034	12	2	0	428	\N
18687	12	3	0	429	\N
18688	2903	4	0	431	\N
28137	12	2	0	433	\N
8727	12	2	0	435	\N
8781	357	4	0	438	\N
19067	12	2	0	439	\N
28920	12	3	0	444	\N
8780	1996	5	0	448	\N
19135	12	3	0	449	\N
30267	8614	115	0	451	\N
29133	12	2	0	452	\N
29523	12	2	0	453	\N
29963	12	5	0	454	\N
8940	12	0	0	458	\N
19399	12	4	0	459	\N
20110	12	2	0	460	\N
30267	12	124	0	463	\N
20304	12	4	0	467	\N
9316	12	4	0	469	\N
20657	12	4	0	471	\N
20929	12	2	0	472	\N
9455	12	2	0	475	\N
9456	12	0	0	476	\N
21679	12	3	0	478	\N
21680	12	14	0	479	\N
9536	12	3	0	482	\N
9740	12	7	0	485	\N
9742	12	4	0	486	\N
10169	12	2	0	487	\N
10213	12	6	0	488	\N
9652	433	3	0	489	\N
21752	12	3	0	496	\N
22070	12	4	0	497	\N
21754	12	7	0	500	\N
10417	12	3	0	502	\N
10417	782	4	0	503	\N
22223	12	2	0	504	\N
22225	12	3	0	505	\N
22071	12	11	0	508	\N
22543	12	3	0	510	\N
22606	12	2	0	511	\N
2174	776	2	0	514	\N
371	220	2	0	517	\N
722	220	1	0	519	\N
787	220	3	0	521	\N
1205	220	1	0	522	\N
1298	220	4	0	523	\N
1421	220	1	0	524	\N
2351	220	2	0	535	\N
2614	220	5	0	536	\N
3136	220	1	0	537	\N
3288	220	8	0	538	\N
3522	220	0	0	540	\N
3615	220	0	0	541	\N
3823	220	2	0	542	\N
4089	220	2	0	548	\N
4160	220	1	0	549	\N
4224	220	2	0	551	\N
4587	220	5	0	552	\N
4589	220	88	0	553	\N
4835	220	3	0	554	\N
5353	221	2	0	569	\N
5719	220	0	0	570	\N
6060	220	2	0	571	\N
6763	220	5	0	576	\N
7210	220	1	0	581	\N
7496	220	2	0	583	\N
7562	220	1	0	585	\N
7609	220	0	0	586	\N
7611	220	3	0	588	\N
7800	220	1	0	592	\N
7822	220	2	0	593	\N
8176	220	2	0	596	\N
8503	220	1	0	597	\N
8562	220	2	0	600	\N
9617	220	2	0	606	\N
26392	7492	117	0	609	\N
2760	917	118	0	610	\N
2485	846	104	0	613	\N
25697	923	5	0	615	\N
17698	874	3	1	616	\N
2534	861	4	0	620	\N
9179	844	7	0	623	\N
9179	2125	8	0	624	\N
17699	749	2	1	625	\N
25895	844	11	0	626	\N
29292	7443	6	0	627	\N
29293	8051	5	1	628	\N
27685	749	8	0	629	\N
2703	874	127	0	631	\N
2032	749	3	1	632	\N
4306	749	127	1	633	\N
23397	749	81	1	634	\N
10000	46	2	0	636	\N
11125	46	78	0	637	\N
11511	46	2	0	638	\N
20358	46	6	0	640	\N
12209	3172	7	0	645	\N
7296	46	0	0	651	\N
7297	46	0	0	652	\N
8343	46	3	0	653	\N
9071	46	2	0	661	\N
29036	46	1	0	664	\N
29845	46	5	0	665	\N
21532	6321	5	1	671	\N
772	424	3	0	674	\N
951	424	2	0	678	\N
10424	424	2	0	680	\N
10424	520	3	0	681	\N
1084	424	1	0	682	\N
11011	424	6	0	688	\N
1423	424	2	0	693	\N
21536	424	3	0	703	\N
22840	424	3	0	705	\N
23081	424	3	0	706	\N
12001	424	2	0	719	\N
23227	424	5	0	721	\N
23808	424	5	0	723	\N
24505	424	0	0	726	\N
23336	2755	3	0	728	\N
24506	2755	3	0	729	\N
12200	424	1	0	737	\N
25084	424	13	0	740	\N
3246	424	2	0	743	\N
25516	424	3	0	748	\N
25714	424	9	0	749	\N
12488	424	1	0	754	\N
12631	424	2	0	755	\N
12632	424	2	0	756	\N
12848	3411	17	0	760	\N
25748	424	5	0	761	\N
4404	424	10	0	765	\N
4512	424	2	0	766	\N
4257	425	2	0	767	\N
12847	424	2	0	770	\N
12848	3412	91	0	773	\N
12880	3423	53	0	774	\N
4759	424	2	0	781	\N
12879	424	2	0	784	\N
6039	425	1	0	794	\N
6040	425	1	0	795	\N
12928	424	2	0	796	\N
12930	3437	62	0	799	\N
26638	424	4	0	800	\N
26682	424	9	0	801	\N
6632	425	1	0	806	\N
13235	424	1	0	807	\N
13237	424	3	0	808	\N
13235	425	2	0	811	\N
26746	424	7	0	815	\N
6280	424	1	0	817	\N
6688	424	4	0	820	\N
13457	424	8	0	826	\N
13917	3611	3	0	828	\N
27206	424	3	0	829	\N
27230	3611	4	0	832	\N
13985	3994	7	0	840	\N
6854	424	4	0	851	\N
14234	424	4	0	857	\N
27428	424	3	0	861	\N
27634	3611	4	0	864	\N
14530	424	2	0	868	\N
14695	424	4	0	877	\N
27980	424	3	0	889	\N
28241	424	2	0	890	\N
28278	424	2	0	891	\N
28278	2755	3	0	895	\N
7191	520	3	0	902	\N
28916	424	2	0	905	\N
7214	424	1	0	907	\N
15485	424	3	0	909	\N
15486	424	0	0	910	\N
15748	424	14	0	911	\N
15843	3188	5	0	914	\N
16401	520	2	0	915	\N
16402	520	2	0	916	\N
16053	424	6	0	922	\N
16077	424	0	0	923	\N
16078	424	1	0	924	\N
16160	3611	4	0	927	\N
16401	4000	9	0	931	\N
16402	4000	9	0	932	\N
29212	424	3	0	934	\N
29213	424	2	0	935	\N
8610	1964	22	0	945	\N
16546	424	14	0	946	\N
16910	424	7	0	947	\N
16912	424	7	0	948	\N
16990	424	2	0	950	\N
8112	424	1	0	962	\N
7760	520	3	0	967	\N
17009	424	5	0	969	\N
29495	424	3	0	971	\N
8684	425	2	0	976	\N
29986	8406	46	0	980	\N
17493	424	2	0	985	\N
29985	424	19	0	987	\N
29986	8408	125	1	990	\N
9671	424	2	0	991	\N
17619	424	3	0	993	\N
17932	424	7	0	994	\N
18221	424	2	0	997	\N
19228	424	5	0	999	\N
19424	424	6	0	1002	\N
19228	5002	6	0	1004	\N
19547	424	3	0	1007	\N
19637	424	3	0	1009	\N
19686	424	10	0	1010	\N
19838	424	3	0	1012	\N
19907	424	10	0	1013	\N
20058	424	3	0	1014	\N
19637	3611	4	0	1016	\N
20282	424	6	0	1023	\N
20502	424	3	0	1027	\N
2424	835	1	0	1031	\N
8978	2061	3	0	1034	\N
26253	835	4	0	1037	\N
26741	835	4	0	1039	\N
5156	514	1	0	1042	\N
18781	514	2	0	1047	\N
13327	3663	111	0	1049	\N
19647	5243	110	0	1050	\N
17751	5243	71	0	1051	\N
12428	3248	0	0	1052	\N
29765	1433	12	0	1058	\N
6383	1549	1	0	1060	\N
15983	1549	3	0	1062	\N
23011	1549	8	0	1064	\N
1028	534	1	0	1066	\N
16956	534	6	0	1068	\N
27516	7739	1	0	1071	\N
1948	735	3	0	1075	\N
15776	734	8	0	1083	\N
17131	734	3	0	1084	\N
19774	734	3	0	1088	\N
20443	734	2	0	1090	\N
21198	734	2	0	1091	\N
21313	734	2	0	1094	\N
21937	734	3	0	1096	\N
22343	734	7	0	1097	\N
14025	3891	10	0	1104	\N
13761	3891	1	0	1105	\N
13762	3891	4	0	1106	\N
20559	6027	64	0	1110	\N
20646	3013	125	0	1111	\N
21871	3013	12	0	1112	\N
18187	3013	6	0	1113	\N
11809	1654	1	0	1115	\N
12129	1654	1	0	1118	\N
24537	7071	0	0	1122	\N
577	266	3	0	1133	\N
10190	266	5	0	1135	\N
10234	266	3	0	1139	\N
10410	266	5	0	1142	\N
10301	405	4	0	1144	\N
10907	266	5	0	1149	\N
21424	266	3	0	1153	\N
21514	266	3	0	1159	\N
11440	266	4	0	1161	\N
4552	266	0	0	1165	\N
22441	266	2	0	1169	\N
22442	266	3	0	1170	\N
22677	266	3	0	1171	\N
12105	266	1	0	1175	\N
5131	266	1	0	1178	\N
22747	266	3	0	1181	\N
23095	266	7	0	1182	\N
5843	405	4	0	1191	\N
12281	266	1	0	1194	\N
12333	266	1	0	1200	\N
12558	266	2	0	1202	\N
23601	266	14	0	1209	\N
24345	266	3	0	1210	\N
13023	266	2	0	1215	\N
24819	266	3	0	1220	\N
24857	266	7	0	1226	\N
24885	266	3	0	1227	\N
13684	266	2	0	1230	\N
13697	266	2	0	1231	\N
26202	266	2	0	1237	\N
13810	266	5	0	1241	\N
26388	266	7	0	1247	\N
26573	266	4	0	1255	\N
14215	266	4	0	1263	\N
14278	266	10	0	1264	\N
27339	266	3	0	1271	\N
14531	266	2	0	1274	\N
27875	266	3	0	1282	\N
27900	266	3	0	1287	\N
16723	266	7	0	1294	\N
16768	266	4	0	1295	\N
28311	266	2	0	1303	\N
28653	266	7	0	1304	\N
28793	266	5	0	1309	\N
29693	266	0	0	1311	\N
29700	266	0	0	1312	\N
29701	266	0	0	1313	\N
17775	266	10	0	1316	\N
29277	266	3	0	1320	\N
18309	266	19	0	1322	\N
29699	266	6	0	1327	\N
20087	266	39	0	1334	\N
19711	3474	4	0	1335	\N
20341	266	38	0	1343	\N
20503	266	3	0	1344	\N
20504	266	0	0	1345	\N
9948	2326	0	0	1351	\N
29818	8257	13	0	1354	\N
29930	8196	98	1	1356	\N
30125	8196	21	1	1357	\N
30223	8581	52	0	1361	\N
2009	741	1	0	1362	\N
8149	741	2	0	1364	\N
8151	741	4	0	1365	\N
20687	4190	4	0	1376	\N
17740	5238	9	0	1378	\N
18006	5238	7	0	1379	\N
17501	5167	8	1	1381	\N
19349	5238	23	1	1384	\N
10702	251	2	0	1398	\N
1413	251	3	0	1403	\N
1558	251	1	0	1412	\N
21035	251	2	0	1414	\N
11784	251	1	0	1416	\N
1574	251	1	0	1419	\N
1761	251	1	0	1420	\N
21097	251	4	0	1428	\N
2371	251	2	0	1432	\N
11936	251	1	0	1436	\N
2809	251	1	0	1444	\N
22295	251	4	0	1449	\N
22470	251	3	0	1451	\N
2832	251	2	0	1462	\N
13749	251	7	0	1466	\N
3201	251	0	0	1468	\N
23002	251	3	0	1469	\N
23068	251	6	0	1470	\N
24082	251	2	0	1478	\N
24082	1851	3	0	1480	\N
23387	6828	5	0	1482	\N
23499	6851	17	0	1483	\N
14924	251	1	0	1485	\N
14924	252	2	0	1487	\N
24975	251	8	0	1498	\N
24977	251	3	0	1499	\N
25048	251	3	0	1500	\N
15382	251	0	0	1508	\N
15862	4673	42	0	1512	\N
4347	828	2	0	1515	\N
25262	251	4	0	1516	\N
25396	251	7	0	1517	\N
25961	1851	3	0	1522	\N
15156	251	2	0	1528	\N
15390	251	0	0	1530	\N
15493	251	4	0	1531	\N
5724	251	0	0	1537	\N
16119	4183	7	0	1546	\N
6470	251	1	0	1547	\N
28825	251	8	0	1550	\N
29232	251	3	0	1553	\N
27180	7660	62	0	1561	\N
17177	251	4	0	1564	\N
17266	251	3	0	1565	\N
6481	251	2	0	1572	\N
29257	251	3	0	1576	\N
17515	251	3	0	1580	\N
7695	251	1	0	1587	\N
17891	5272	7	0	1595	\N
7905	251	2	0	1596	\N
18121	3514	4	0	1608	\N
9033	251	3	0	1609	\N
9203	251	2	0	1610	\N
18743	251	4	0	1613	\N
19110	251	3	0	1614	\N
19546	251	10	0	1619	\N
20038	251	5	0	1621	\N
24494	7059	4	0	1633	\N
28235	7863	3	0	1635	\N
20130	5893	8	1	1645	\N
18921	2011	1	0	1655	\N
16586	4878	63	0	1658	\N
16585	1096	8	0	1661	\N
3537	1096	0	0	1665	\N
16586	4879	127	0	1669	\N
5947	536	2	0	1672	\N
8006	536	2	0	1674	\N
19810	536	3	0	1677	\N
21124	6230	3	0	1680	\N
16812	4961	12	1	1684	\N
2034	750	2	0	1687	\N
2912	750	52	0	1688	\N
14856	4385	4	0	1696	\N
198	205	2	0	1700	\N
1134	204	2	0	1707	\N
1160	205	2	0	1710	\N
1716	204	1	0	1716	\N
10374	2490	3	0	1732	\N
19158	5570	3	0	1733	\N
85	84	3	0	1749	\N
1230	84	2	0	1761	\N
2200	85	2	0	1783	\N
23954	6331	6	0	1789	\N
30148	6331	8	0	1792	\N
3897	691	1	0	1795	\N
2912	949	51	0	1801	\N
2913	952	5	0	1802	\N
2914	954	5	0	1806	\N
19485	819	3	0	1827	\N
19873	819	2	0	1829	\N
25676	5185	2	0	1835	\N
25677	5185	3	0	1836	\N
25678	5185	4	0	1837	\N
27466	461	8	0	1855	\N
14363	461	4	0	1857	\N
30114	461	27	0	1860	\N
6749	246	4	0	1863	\N
3154	996	1	0	1869	\N
8624	997	2	0	1874	\N
20808	6146	3	0	1897	\N
21013	6146	3	0	1899	\N
27039	6146	4	0	1900	\N
11820	3018	1	0	1905	\N
263	248	2	0	1919	\N
1553	117	3	0	1928	\N
2210	175	3	0	1941	\N
2380	248	2	0	1945	\N
2703	903	28	0	1946	\N
22196	117	10	0	1957	\N
2728	907	94	0	1966	\N
22289	6515	10	1	1969	\N
3849	117	2	0	1982	\N
23567	117	6	0	1986	\N
23574	3835	5	0	1989	\N
4021	117	2	0	1992	\N
23738	117	6	0	1994	\N
4178	117	2	0	2001	\N
4407	1243	122	0	2004	\N
4407	118	127	0	2012	\N
26069	7425	9	0	2036	\N
20840	117	3	0	2040	\N
21822	117	12	0	2048	\N
27515	248	1	0	2068	\N
16755	117	3	0	2071	\N
27515	5439	5	0	2076	\N
6909	117	1	0	2088	\N
28550	117	2	0	2097	\N
28993	117	3	0	2099	\N
8082	117	4	0	2109	\N
18509	117	3	0	2116	\N
8127	117	1	0	2124	\N
18583	117	4	0	2128	\N
18130	117	3	0	2136	\N
29687	8154	10	0	2145	\N
29881	117	20	0	2171	\N
10861	117	4	0	2201	\N
11428	117	5	0	2206	\N
13584	117	5	0	2218	\N
14365	117	4	0	2241	\N
14598	117	3	0	2245	\N
15488	117	0	0	2257	\N
15489	117	1	0	2258	\N
23444	674	2	0	2285	\N
22700	1000	4	0	2290	\N
13496	3767	4	0	2292	\N
26820	3767	4	0	2294	\N
9014	2079	2	0	2301	\N
24713	2079	7	0	2304	\N
10230	2079	76	0	2309	\N
14716	4341	2	0	2313	\N
18397	962	2	0	2319	\N
18882	962	1	0	2323	\N
24642	7103	9	0	2330	\N
26416	7501	4	0	2334	\N
10880	2622	5	0	2346	\N
10879	2621	7	0	2359	\N
19038	1793	2	0	2372	\N
9846	1039	6	0	2393	\N
10433	110	4	0	2411	\N
10573	110	3	0	2413	\N
20758	110	0	0	2414	\N
826	110	2	0	2420	\N
21402	110	11	0	2444	\N
11265	110	11	0	2454	\N
12439	110	0	0	2486	\N
12644	110	3	0	2488	\N
22869	110	4	0	2499	\N
13206	110	1	0	2510	\N
13832	110	21	0	2525	\N
14287	110	4	0	2534	\N
25200	7254	126	0	2542	\N
3222	110	1	0	2543	\N
24425	626	3	0	2549	\N
5135	110	2	0	2573	\N
25548	110	8	0	2579	\N
15755	110	8	0	2582	\N
26912	110	3	0	2599	\N
25910	626	3	0	2602	\N
28127	110	2	0	2612	\N
28130	110	1	0	2613	\N
28130	134	2	0	2616	\N
6849	110	6	0	2650	\N
6850	110	7	0	2651	\N
18593	3328	3	0	2669	\N
18893	110	2	0	2678	\N
29317	4134	5	0	2692	\N
7413	110	2	0	2698	\N
7164	134	2	0	2699	\N
14794	4366	0	0	2729	\N
17283	228	3	0	2738	\N
855	228	3	0	2741	\N
21969	228	0	0	2744	\N
21970	228	0	0	2745	\N
22029	228	2	0	2747	\N
20880	228	90	0	2749	\N
21188	6236	57	0	2760	\N
17499	228	2	0	2761	\N
17878	228	3	0	2781	\N
18050	3186	4	0	2787	\N
17735	5234	8	0	2790	\N
25529	228	9	0	2840	\N
26659	228	2	0	2846	\N
28376	229	1	0	2863	\N
27398	228	3	0	2872	\N
28700	228	3	0	2888	\N
28924	228	7	0	2892	\N
4882	228	3	0	2897	\N
5101	229	2	0	2909	\N
29851	228	14	0	2916	\N
6502	228	2	0	2935	\N
12244	3186	4	0	2981	\N
13203	228	2	0	2983	\N
14797	228	3	0	2992	\N
15233	228	3	0	2998	\N
16250	228	2	0	3009	\N
7954	1858	1	0	3017	\N
30049	1858	10	0	3030	\N
24023	6966	6	0	3054	\N
19638	1636	3	0	3076	\N
15338	1636	7	0	3083	\N
18114	1636	2	0	3100	\N
20932	1636	2	0	3107	\N
18797	5514	4	0	3116	\N
21005	1636	2	0	3117	\N
22915	1636	4	0	3133	\N
23618	1636	3	0	3143	\N
9438	2188	20	0	3164	\N
11949	2982	2	0	3177	\N
13085	2982	4	0	3193	\N
21538	6323	1	0	3213	\N
14718	790	2	0	3219	\N
15893	4684	4	0	3222	\N
19672	5719	6	0	3227	\N
28637	7932	2	0	3230	\N
509	295	2	0	3236	\N
665	368	2	0	3253	\N
21523	367	2	0	3277	\N
21924	3683	4	0	3282	\N
3045	367	1	0	3300	\N
23926	367	3	0	3333	\N
4617	367	99	0	3360	\N
14108	367	4	0	3371	\N
14935	4414	6	0	3411	\N
14683	4316	31	0	3426	\N
26316	367	2	0	3433	\N
16132	367	2	0	3437	\N
16731	367	2	0	3453	\N
17884	4792	8	0	3482	\N
28724	367	7	0	3504	\N
29106	3679	5	0	3531	\N
979	527	2	0	3557	\N
1303	604	4	0	3563	\N
1479	237	3	0	3566	\N
7166	237	1	0	3622	\N
8568	527	2	0	3641	\N
9162	1569	5	0	3647	\N
19233	5319	3	0	3651	\N
332	263	2	0	3665	\N
21317	262	13	0	3669	\N
20567	6036	9	0	3672	\N
21317	5815	14	0	3673	\N
22725	262	5	0	3702	\N
10929	262	8	0	3714	\N
10933	731	3	0	3719	\N
2394	262	2	0	3723	\N
11629	262	1	0	3728	\N
11903	262	2	0	3730	\N
22958	262	4	0	3745	\N
23113	262	4	0	3747	\N
12948	262	2	0	3756	\N
15196	4476	78	0	3799	\N
4212	263	2	0	3814	\N
17328	262	68	0	3874	\N
6322	263	2	0	3887	\N
18415	262	10	0	3896	\N
6960	262	2	0	3900	\N
27453	4778	4	0	3950	\N
29199	3027	10	0	3988	\N
19954	262	13	0	3992	\N
9844	731	3	0	4009	\N
30137	262	14	0	4021	\N
30140	262	11	0	4022	\N
25705	7226	4	0	4054	\N
30287	7225	6	0	4069	\N
3494	1077	0	0	4078	\N
7245	714	2	0	4082	\N
5880	1394	3	0	4085	\N
26579	2111	6	0	4101	\N
607	340	2	0	4120	\N
1575	340	2	0	4129	\N
20441	1191	3	0	4134	\N
20936	35	9	0	4145	\N
20185	35	125	0	4151	\N
17300	35	6	0	4152	\N
22392	3545	5	0	4171	\N
4116	1176	3	0	4177	\N
22692	35	3	0	4180	\N
4398	35	10	0	4206	\N
4584	35	1	0	4215	\N
18822	340	2	0	4220	\N
18812	5515	6	0	4221	\N
4688	340	2	0	4228	\N
4654	36	3	0	4229	\N
19346	35	4	0	4232	\N
19144	3563	4	0	4233	\N
25203	5077	8	0	4237	\N
4762	340	2	0	4239	\N
19750	3563	4	0	4243	\N
19397	3545	5	0	4244	\N
19749	5761	85	0	4245	\N
25848	1191	3	0	4252	\N
25210	3563	4	0	4253	\N
25383	3563	4	0	4254	\N
26266	3563	4	0	4255	\N
25818	7382	13	0	4256	\N
6021	1499	4	0	4260	\N
19942	35	3	0	4261	\N
19942	3563	4	0	4262	\N
19944	35	126	0	4263	\N
19944	5811	127	0	4264	\N
26338	340	2	0	4267	\N
26337	1191	3	0	4268	\N
7835	340	2	0	4270	\N
27061	5084	7	0	4272	\N
8074	35	4	0	4274	\N
27532	3563	4	0	4278	\N
27597	7753	7	0	4279	\N
8181	36	3	0	4284	\N
8300	35	1	0	4288	\N
8300	340	2	0	4290	\N
8382	36	3	0	4291	\N
27745	35	2	0	4292	\N
8539	340	2	0	4297	\N
28028	35	3	0	4299	\N
28028	3563	4	0	4300	\N
8796	36	3	0	4308	\N
29135	5077	8	0	4317	\N
29399	3563	4	0	4328	\N
10747	36	3	0	4330	\N
29607	3563	4	0	4336	\N
11243	1191	3	0	4346	\N
11677	35	1	0	4350	\N
12875	1875	5	0	4367	\N
15148	3323	7	0	4399	\N
2339	818	2	0	4413	\N
950	519	3	0	4425	\N
11023	365	1	0	4426	\N
1163	366	2	0	4436	\N
2059	365	1	0	4449	\N
3989	365	1	0	4484	\N
12294	365	10	0	4491	\N
22357	365	3	0	4508	\N
23392	3298	5	0	4551	\N
14618	365	3	0	4576	\N
25303	365	4	0	4588	\N
6163	1509	4	0	4596	\N
25944	365	0	0	4598	\N
15246	365	2	0	4628	\N
15682	365	3	0	4637	\N
8386	365	1	0	4663	\N
9907	365	0	0	4672	\N
28619	365	4	0	4673	\N
17909	5072	3	0	4681	\N
10491	365	0	0	4718	\N
25120	7231	82	0	4730	\N
12120	189	0	0	4764	\N
21367	189	4	0	4776	\N
12953	189	2	0	4783	\N
13533	3782	4	0	4794	\N
2364	827	4	0	4801	\N
21790	3953	9	0	4808	\N
13871	311	3	0	4814	\N
13870	3953	9	0	4815	\N
14431	190	2	0	4829	\N
2753	190	2	0	4836	\N
22625	189	4	0	4855	\N
4345	1223	40	0	4883	\N
23984	189	3	0	4891	\N
4895	1349	86	0	4907	\N
24815	7166	127	0	4931	\N
5300	311	3	0	4963	\N
17872	3782	4	0	4978	\N
26980	189	2	0	4982	\N
26775	189	126	0	4984	\N
18194	189	5	0	4999	\N
18182	3782	4	0	5002	\N
19592	189	3	0	5030	\N
28332	189	6	0	5048	\N
28545	3782	4	0	5086	\N
28943	189	3	0	5098	\N
8838	849	5	0	5119	\N
12593	1970	5	0	5133	\N
13234	1970	57	0	5136	\N
25566	1141	9	0	5159	\N
1862	719	1	0	5168	\N
25773	7377	4	0	5181	\N
14300	4140	6	0	5182	\N
12106	1572	1	0	5203	\N
13004	1572	2	0	5204	\N
25191	7250	6	1	5215	\N
30241	7846	4	1	5231	\N
6634	1600	3	0	5237	\N
2706	222	1	0	5252	\N
3068	222	2	0	5258	\N
6902	232	3	0	5271	\N
16784	4916	19	1	5285	\N
1837	716	1	0	5288	\N
7619	1819	1	0	5299	\N
23366	6823	3	1	5305	\N
504	374	2	0	5307	\N
10054	373	1	0	5338	\N
14378	4178	4	0	5402	\N
14445	4211	4	0	5411	\N
14526	4247	3	0	5429	\N
14626	4178	3	0	5436	\N
14708	4178	5	0	5450	\N
14772	4247	3	0	5462	\N
14827	4178	2	0	5470	\N
14954	4178	3	0	5496	\N
14919	4211	4	0	5501	\N
14958	4211	4	0	5503	\N
15149	4178	7	0	5530	\N
15216	4178	2	0	5542	\N
15279	4178	3	0	5554	\N
15292	4211	4	0	5561	\N
15306	4178	8	0	5562	\N
15476	4247	3	0	5605	\N
15537	4250	7	0	5609	\N
15561	4178	6	0	5610	\N
15602	4247	3	0	5617	\N
15726	4178	4	0	5631	\N
15805	4429	6	0	5645	\N
15937	4178	3	0	5656	\N
15942	4250	7	0	5659	\N
16007	4708	17	0	5669	\N
16029	4211	4	0	5672	\N
16131	4178	4	0	5697	\N
16243	4211	4	0	5711	\N
16313	4178	3	0	5716	\N
16333	4178	4	0	5724	\N
16413	4178	4	0	5740	\N
16420	4205	5	0	5744	\N
16505	4178	3	0	5774	\N
16589	4358	6	0	5791	\N
16638	4178	7	0	5800	\N
16751	4178	4	0	5821	\N
16842	4178	3	0	5833	\N
16942	4178	1	0	5844	\N
17019	4178	3	0	5857	\N
17050	4178	3	0	5863	\N
17121	4211	4	0	5872	\N
17259	4178	4	0	5887	\N
17323	5089	8	0	5904	\N
17378	4178	6	0	5906	\N
17487	5160	9	0	5921	\N
17461	4318	10	0	5922	\N
17503	4211	4	0	5926	\N
17608	4247	3	0	5945	\N
17722	4178	2	0	5971	\N
17799	4211	4	0	5987	\N
18020	4205	5	0	6019	\N
18273	4178	5	0	6050	\N
18324	4178	2	0	6053	\N
18373	4178	2	0	6066	\N
18426	4211	4	0	6088	\N
18502	4211	4	0	6096	\N
18524	4205	5	0	6103	\N
18572	4178	4	0	6118	\N
18627	4178	5	0	6127	\N
18720	4247	3	0	6137	\N
18823	4247	3	0	6156	\N
18832	4178	1	0	6158	\N
18983	4178	2	0	6179	\N
19051	4450	2	0	6189	\N
19199	4178	7	0	6220	\N
19288	4178	4	0	6239	\N
19316	4396	8	0	6245	\N
19328	4178	11	0	6247	\N
19430	4178	10	0	6268	\N
19477	4202	6	0	6291	\N
19520	4178	3	0	6293	\N
19564	4178	3	0	6304	\N
19761	4250	7	0	6335	\N
19956	5529	12	0	6357	\N
20019	4178	4	0	6371	\N
20075	4178	3	0	6377	\N
20104	5622	10	0	6387	\N
20187	4178	3	0	6408	\N
20214	4211	4	0	6414	\N
20259	4178	3	0	6428	\N
20315	4205	5	0	6446	\N
20374	4178	3	0	6453	\N
20462	4178	3	0	6470	\N
20560	4178	14	0	6476	\N
20771	6131	13	0	6505	\N
20805	4178	7	0	6510	\N
20859	6164	16	0	6520	\N
21149	4358	7	0	6561	\N
21165	4247	3	0	6568	\N
21184	4358	7	0	6571	\N
21233	4178	2	0	6588	\N
21458	4396	8	0	6619	\N
21509	4211	4	0	6631	\N
21631	4178	3	0	6644	\N
21738	4178	6	0	6653	\N
21774	4211	4	0	6656	\N
22016	4178	4	0	6697	\N
22039	4178	2	0	6701	\N
22043	4247	3	0	6706	\N
22187	4178	5	0	6723	\N
22280	4178	2	0	6738	\N
22293	4396	8	0	6748	\N
22410	4178	3	0	6762	\N
22355	4211	4	0	6763	\N
22465	4205	5	0	6772	\N
22548	4782	14	0	6799	\N
22740	4178	4	0	6818	\N
22781	4178	4	0	6831	\N
22818	4178	5	0	6837	\N
22871	4178	3	0	6843	\N
22937	4178	4	0	6855	\N
23016	4178	0	0	6872	\N
23074	4211	4	0	6886	\N
23159	4178	7	0	6892	\N
23172	4178	3	0	6896	\N
23213	4178	2	0	6904	\N
23263	4178	3	0	6920	\N
23365	4331	5	0	6935	\N
23369	4331	5	0	6939	\N
23505	4178	3	0	6957	\N
23558	4178	6	0	6972	\N
23613	4665	11	0	6983	\N
23649	4205	5	0	6994	\N
23723	4178	6	0	7001	\N
23812	4178	3	0	7015	\N
24000	4178	3	0	7026	\N
24050	4331	5	0	7047	\N
24092	4178	2	0	7052	\N
24159	4178	2	0	7056	\N
24178	4509	8	0	7059	\N
24197	4250	7	0	7061	\N
24276	4178	4	0	7073	\N
24339	4178	4	0	7086	\N
24368	4178	2	0	7091	\N
24504	4247	3	0	7108	\N
24568	4331	5	0	7122	\N
24659	4178	3	0	7136	\N
24692	4178	6	0	7145	\N
24818	4429	6	0	7165	\N
24833	4178	3	0	7171	\N
24882	4211	4	0	7187	\N
24967	4450	1	0	7197	\N
25325	4178	10	0	7246	\N
25487	4178	3	0	7273	\N
25511	4211	4	0	7277	\N
25685	4250	7	0	7300	\N
25823	4682	10	0	7309	\N
26062	4178	4	0	7346	\N
26106	4178	4	0	7356	\N
26167	4218	9	0	7378	\N
26229	4178	3	0	7391	\N
26265	4396	8	0	7402	\N
26275	4178	4	0	7407	\N
26335	4178	3	0	7418	\N
26412	4211	4	0	7441	\N
26577	4178	12	0	7473	\N
26609	4211	4	0	7488	\N
26622	4178	23	0	7490	\N
26726	4178	3	0	7514	\N
26807	4178	3	0	7529	\N
26860	4211	4	0	7551	\N
26900	4178	11	0	7555	\N
26923	4211	4	0	7564	\N
26927	4211	4	0	7569	\N
26986	4211	4	0	7575	\N
27109	4178	3	0	7599	\N
27153	7664	14	0	7615	\N
27268	4178	3	0	7631	\N
27317	4178	3	0	7638	\N
27402	4211	4	0	7648	\N
27494	4178	6	0	7676	\N
27717	4178	2	0	7717	\N
27761	4178	2	0	7723	\N
27827	4211	4	0	7734	\N
27878	4211	4	0	7748	\N
27890	4211	4	0	7752	\N
27891	4178	3	0	7753	\N
27944	4178	3	0	7773	\N
28066	4178	6	0	7791	\N
28219	4178	2	0	7813	\N
28279	4247	3	0	7826	\N
28403	4247	3	0	7847	\N
28451	4247	3	0	7857	\N
28447	4331	5	0	7858	\N
28609	4178	2	0	7890	\N
28640	4178	2	0	7891	\N
28648	4178	3	0	7892	\N
28875	4178	3	0	7921	\N
28981	4211	4	0	7947	\N
29034	4178	4	0	7958	\N
29120	4178	5	0	7977	\N
29129	4331	5	0	7982	\N
29335	4178	4	0	8007	\N
29346	4178	3	0	8013	\N
29396	4178	3	0	8019	\N
29430	4178	3	0	8023	\N
29506	4429	6	0	8036	\N
29630	4178	0	0	8052	\N
29635	4178	3	0	8055	\N
29739	4841	39	0	8073	\N
29840	4178	27	0	8085	\N
29958	8386	8	0	8108	\N
29906	5529	12	0	8111	\N
30134	4250	16	0	8128	\N
30144	4178	10	0	8130	\N
16682	4901	9	0	8146	\N
14487	4219	5	0	8161	\N
14604	4172	3	0	8174	\N
14703	4172	4	0	8190	\N
14733	4172	8	0	8193	\N
14853	4172	2	0	8200	\N
14875	4191	3	0	8207	\N
14975	4252	5	0	8221	\N
15134	4172	3	0	8241	\N
15189	4172	11	0	8244	\N
15199	4275	4	0	8255	\N
15343	4172	2	0	8272	\N
15542	4172	4	0	8302	\N
15647	4172	6	0	8315	\N
15798	4275	4	0	8338	\N
15947	4172	3	0	8361	\N
16092	4614	8	0	8371	\N
16124	4172	7	0	8375	\N
16268	4614	8	0	8395	\N
16307	4275	4	0	8397	\N
16330	4803	22	0	8401	\N
16779	4172	3	0	8446	\N
16819	4191	3	0	8459	\N
17030	4172	5	0	8477	\N
17396	4191	3	0	8511	\N
17475	4172	3	0	8525	\N
17649	4201	1	0	8542	\N
17668	4191	3	0	8549	\N
17796	4172	2	0	8560	\N
17783	4275	4	0	8562	\N
17998	4172	2	0	8581	\N
18206	5365	7	0	8616	\N
18271	4415	6	0	8618	\N
18285	4275	4	0	8622	\N
18410	4172	3	0	8634	\N
18558	4172	4	0	8655	\N
18606	4172	2	0	8668	\N
18626	4191	3	0	8673	\N
18749	4191	3	0	8688	\N
18942	4172	5	0	8717	\N
19048	4172	2	0	8719	\N
19066	5549	3	0	8732	\N
19196	4275	4	0	8745	\N
19208	4275	4	0	8753	\N
19301	4275	4	0	8760	\N
19705	4197	7	0	8792	\N
19941	4275	4	0	8821	\N
20014	4275	4	0	8830	\N
20114	4172	7	0	8847	\N
20218	4172	7	0	8867	\N
20267	4275	4	0	8879	\N
20346	4275	4	0	8896	\N
20373	4172	3	0	8904	\N
20530	4275	4	0	8914	\N
20555	4172	4	0	8919	\N
20639	4172	3	0	8937	\N
20724	4172	10	0	8948	\N
20883	4172	4	0	8966	\N
20919	4172	2	0	8974	\N
20940	6184	5	0	8979	\N
21057	4172	2	0	8993	\N
21062	4172	6	0	8998	\N
21146	4500	12	0	9014	\N
21180	4191	3	0	9019	\N
21337	4172	3	0	9033	\N
21517	4172	3	0	9050	\N
21599	4275	4	0	9069	\N
21755	4275	4	0	9079	\N
21798	4197	7	0	9085	\N
21823	6408	13	0	9093	\N
22022	4172	3	0	9108	\N
21991	4275	4	0	9110	\N
22273	4172	3	0	9143	\N
22224	4275	4	0	9144	\N
22268	4275	4	0	9145	\N
22228	4634	6	0	9147	\N
22519	4172	9	0	9173	\N
22802	4172	3	0	9206	\N
22819	4172	7	0	9209	\N
22913	4172	10	0	9217	\N
23093	4614	8	0	9239	\N
23193	4275	4	0	9253	\N
23470	4219	5	0	9276	\N
23593	4172	6	0	9286	\N
23971	6603	11	0	9324	\N
24244	4219	5	0	9346	\N
24389	4172	2	0	9354	\N
24559	4172	3	0	9373	\N
24683	4275	4	0	9389	\N
24858	4172	3	0	9411	\N
25033	4172	2	0	9423	\N
25055	4172	4	0	9430	\N
25118	4197	7	0	9437	\N
25162	4172	4	0	9442	\N
25345	5004	2	0	9459	\N
25434	4275	4	0	9468	\N
25646	4172	6	0	9482	\N
25747	4415	6	0	9496	\N
25828	4172	7	0	9499	\N
26147	4197	7	0	9535	\N
26205	5454	14	0	9543	\N
26318	4172	5	0	9559	\N
26390	4614	8	0	9569	\N
26504	4172	3	0	9593	\N
26680	4614	8	0	9608	\N
26728	4614	8	0	9613	\N
26862	4172	3	0	9633	\N
26925	4172	3	0	9641	\N
27051	4275	4	0	9657	\N
27077	4172	3	0	9659	\N
27244	4219	5	0	9681	\N
27259	4275	4	0	9686	\N
27276	4172	3	0	9689	\N
27418	4172	3	0	9706	\N
27480	4977	19	0	9715	\N
27542	4172	4	0	9724	\N
27653	4172	3	0	9736	\N
27811	4172	3	0	9758	\N
27909	4172	3	0	9776	\N
27969	7815	12	0	9792	\N
28098	4663	11	0	9813	\N
28207	4172	2	0	9815	\N
28318	4191	3	0	9829	\N
28399	4275	4	0	9838	\N
28466	4191	3	0	9846	\N
28531	7907	9	0	9855	\N
28868	4191	3	0	9882	\N
29102	4172	10	0	9903	\N
29123	4172	4	0	9907	\N
29175	4172	3	0	9911	\N
29302	4415	6	0	9940	\N
29321	4172	3	0	9941	\N
29664	6628	8	0	9982	\N
29684	8151	19	0	9988	\N
29842	4440	22	0	9999	\N
29885	5365	10	0	10008	\N
30067	7540	9	0	10025	\N
30109	8487	54	0	10041	\N
30191	8550	11	1	10050	\N
30301	8639	11	0	10061	\N
168	183	4	0	10062	\N
790	392	2	0	10088	\N
1246	392	2	0	10114	\N
1427	392	2	0	10124	\N
1670	406	3	0	10134	\N
2074	391	1	0	10151	\N
2177	391	1	0	10155	\N
2400	391	1	0	10163	\N
24157	3660	4	0	10175	\N
24214	391	3	0	10180	\N
24205	391	7	0	10189	\N
24565	1381	3	0	10203	\N
2896	406	3	0	10205	\N
24578	1381	3	0	10213	\N
3234	391	8	0	10217	\N
3357	392	2	0	10231	\N
24820	1511	14	0	10234	\N
24897	391	4	0	10248	\N
3853	391	1	0	10265	\N
3879	391	1	0	10273	\N
3943	406	3	0	10276	\N
13784	3521	7	0	10318	\N
25800	1381	3	0	10333	\N
13820	391	7	0	10335	\N
25870	3660	4	0	10354	\N
5023	1367	3	0	10358	\N
14241	4107	10	0	10380	\N
14374	3660	4	0	10404	\N
5729	391	0	0	10417	\N
26256	3660	4	0	10421	\N
6087	391	1	0	10435	\N
26455	391	88	0	10460	\N
26564	7531	106	0	10462	\N
15326	391	3	0	10464	\N
15660	391	3	0	10476	\N
6318	392	2	0	10490	\N
27089	3660	4	0	10500	\N
6899	391	2	0	10515	\N
27581	391	6	0	10551	\N
7142	391	3	0	10559	\N
7261	391	3	0	10573	\N
7355	391	9	0	10591	\N
7495	406	3	0	10603	\N
17244	391	3	0	10614	\N
17489	391	9	0	10625	\N
17725	3660	4	0	10641	\N
7771	391	1	0	10643	\N
28593	3553	10	0	10650	\N
8092	391	1	0	10681	\N
18930	391	1	0	10688	\N
19344	391	3	0	10717	\N
19395	391	4	0	10729	\N
19630	3660	4	0	10767	\N
8643	391	1	0	10768	\N
19840	391	4	0	10801	\N
9311	391	3	0	10831	\N
20406	3660	4	0	10846	\N
9797	391	3	0	10860	\N
10003	391	2	0	10874	\N
10061	2371	15	0	10878	\N
10380	391	4	0	10894	\N
20984	391	2	0	10898	\N
21077	1381	3	0	10907	\N
21558	3660	4	0	10930	\N
10778	581	4	0	10935	\N
10839	406	3	0	10944	\N
23904	391	4	0	10981	\N
12570	391	2	0	11036	\N
109	133	3	0	11063	\N
10407	132	2	0	11080	\N
10745	132	2	0	11086	\N
10971	455	2	0	11088	\N
11155	133	3	0	11095	\N
20379	4690	7	0	11121	\N
12231	3116	2	0	11141	\N
13071	132	5	0	11175	\N
4241	132	1	0	11180	\N
21377	3716	5	0	11191	\N
13397	3709	8	0	11195	\N
6391	132	1	0	11231	\N
21901	132	3	0	11234	\N
6840	132	4	0	11259	\N
15909	132	2	0	11308	\N
23903	3729	4	0	11314	\N
15918	132	6	0	11316	\N
7708	133	3	0	11326	\N
7882	133	3	0	11327	\N
24195	132	3	0	11329	\N
8281	132	1	0	11335	\N
25261	132	4	0	11380	\N
25361	132	5	0	11381	\N
16689	3709	8	0	11387	\N
25838	132	3	0	11395	\N
26433	133	2	0	11399	\N
25543	3116	2	0	11408	\N
17109	132	4	0	11422	\N
26781	132	3	0	11428	\N
25765	132	1	0	11461	\N
17329	132	11	0	11464	\N
17407	132	6	0	11466	\N
17394	2717	6	0	11467	\N
28570	6548	10	0	11490	\N
17907	132	2	0	11491	\N
18154	132	16	0	11497	\N
29122	132	4	0	11503	\N
29108	3729	4	0	11506	\N
29378	8057	10	1	11516	\N
18785	132	5	0	11519	\N
29403	3116	2	0	11526	\N
29402	2756	3	0	11527	\N
29789	132	29	0	11532	\N
29788	8232	9	0	11545	\N
19695	132	9	0	11571	\N
11281	2746	6	0	11590	\N
2655	897	88	1	11592	\N
15153	4465	3	1	11603	\N
22319	6527	7	0	11608	\N
30219	4912	12	0	11616	\N
88	108	1	0	11634	\N
2939	108	0	0	11661	\N
3429	109	2	0	11674	\N
5436	108	0	0	11702	\N
5289	109	2	0	11704	\N
5841	109	2	0	11715	\N
12663	108	1	0	11717	\N
12790	3340	3	0	11724	\N
14881	4398	10	0	11742	\N
23019	6731	14	0	11747	\N
6539	108	2	0	11759	\N
16490	4060	5	0	11764	\N
6719	669	5	0	11772	\N
7182	108	1	0	11781	\N
24500	108	2	0	11796	\N
28195	108	3	0	11841	\N
26765	7583	8	0	11845	\N
9352	108	2	0	11857	\N
19814	108	2	0	11859	\N
28772	108	4	0	11861	\N
9486	501	3	0	11872	\N
20132	108	6	0	11873	\N
20403	4171	4	0	11887	\N
20566	108	8	0	11891	\N
21118	4171	4	0	11894	\N
10267	501	3	0	11910	\N
10336	108	2	0	11921	\N
1080	460	1	0	11928	\N
21484	459	2	0	11937	\N
27967	7813	12	0	11987	\N
4228	300	1	0	12033	\N
3972	355	2	0	12035	\N
21640	300	4	0	12046	\N
12332	3168	2	0	12062	\N
6234	706	3	0	12087	\N
12670	300	2	0	12091	\N
12682	300	2	0	12101	\N
9114	1712	5	0	12149	\N
9548	300	2	0	12179	\N
15430	300	3	0	12187	\N
10131	300	3	0	12194	\N
11354	300	2	0	12225	\N
16343	300	3	0	12227	\N
11597	2909	2	0	12241	\N
16753	300	3	0	12243	\N
29082	3747	4	0	12248	\N
11596	300	3	0	12251	\N
29336	300	4	0	12258	\N
20803	2786	3	0	12305	\N
443	348	3	0	12314	\N
16743	4935	68	0	12328	\N
16744	1852	1	0	12330	\N
4319	1221	2	0	12351	\N
11454	2432	3	0	12363	\N
20177	5604	11	0	12390	\N
1772	613	3	0	12392	\N
2536	529	2	0	12400	\N
20206	5927	76	0	12406	\N
12013	3104	68	0	12434	\N
20523	528	4	0	12437	\N
3624	528	0	0	12460	\N
4782	529	2	0	12465	\N
22495	528	4	0	12468	\N
5701	528	0	0	12477	\N
13809	529	2	0	12483	\N
5758	529	2	0	12496	\N
23719	528	3	0	12502	\N
14632	528	9	0	12509	\N
14837	2765	3	0	12511	\N
23923	4262	4	0	12517	\N
6390	528	1	0	12521	\N
15276	3353	5	0	12525	\N
25019	7208	10	0	12529	\N
15457	2765	3	0	12535	\N
19466	528	3	0	12593	\N
9821	528	10	0	12608	\N
19935	528	2	0	12632	\N
29716	8169	21	0	12656	\N
29987	528	19	0	12661	\N
21704	1868	3	0	12691	\N
22024	123	3	0	12704	\N
802	123	1	0	12710	\N
22763	123	5	0	12716	\N
22775	2856	4	0	12725	\N
12059	3120	56	0	12730	\N
14195	124	2	0	12763	\N
14193	4090	5	0	12764	\N
24583	123	8	0	12786	\N
24989	7196	11	0	12788	\N
25586	7340	4	0	12791	\N
14976	123	3	0	12792	\N
4460	123	4	0	12795	\N
27142	123	3	0	12800	\N
27737	1868	3	0	12805	\N
26620	123	23	0	12813	\N
6035	1500	4	0	12851	\N
17065	5015	1	0	12876	\N
7576	123	1	0	12890	\N
8022	384	3	0	12906	\N
18389	2856	4	0	12909	\N
19994	2856	4	0	12936	\N
9467	123	2	0	12949	\N
20968	3853	3	0	12998	\N
10103	77	6	0	12999	\N
11916	77	1	0	13038	\N
12238	2934	2	0	13048	\N
2239	216	3	0	13051	\N
2854	77	2	0	13058	\N
23156	6760	31	0	13076	\N
3392	77	1	0	13086	\N
23461	77	3	0	13100	\N
23410	77	126	0	13106	\N
25131	6022	8	0	13149	\N
15711	77	1	0	13168	\N
5002	77	1	0	13174	\N
27103	77	6	0	13187	\N
27478	77	26	0	13194	\N
17069	1877	4	0	13199	\N
27605	77	3	0	13205	\N
27654	77	3	0	13218	\N
17581	1877	4	0	13228	\N
6624	1132	5	0	13235	\N
9293	77	3	0	13276	\N
29724	8176	7	0	13280	\N
19151	78	1	0	13289	\N
19295	77	3	0	13297	\N
9704	77	4	0	13307	\N
1162	256	2	0	13326	\N
1288	335	3	0	13329	\N
1660	680	5	0	13335	\N
2037	256	2	0	13341	\N
2355	256	2	0	13344	\N
9275	256	2	0	13385	\N
11053	1660	5	0	13445	\N
4297	59	2	0	13467	\N
4675	58	1	0	13476	\N
4950	58	5	0	13485	\N
13184	3575	7	0	13500	\N
18367	5402	126	0	13503	\N
5311	58	1	0	13506	\N
15298	58	2	0	13515	\N
13545	3665	4	0	13519	\N
23517	58	5	0	13528	\N
16228	58	10	0	13537	\N
16298	58	3	0	13538	\N
16857	58	7	0	13555	\N
18384	5409	0	0	13564	\N
24962	58	8	0	13603	\N
25300	3665	4	0	13622	\N
20886	58	2	0	13626	\N
8826	2015	7	0	13652	\N
27417	58	3	0	13658	\N
10023	58	12	0	13684	\N
346	299	4	0	13707	\N
11489	233	1	0	13725	\N
11745	233	2	0	13727	\N
12981	233	2	0	13744	\N
14706	1849	3	0	13759	\N
15034	233	5	0	13768	\N
23611	3704	4	0	13785	\N
16533	233	3	0	13807	\N
18146	1849	3	0	13856	\N
18413	3704	4	0	13859	\N
17193	1418	2	0	13862	\N
24260	233	4	0	13863	\N
19702	5746	81	0	13875	\N
19703	3704	4	0	13889	\N
21066	1849	3	0	13931	\N
22397	233	6	0	13941	\N
27413	233	3	0	13950	\N
7094	233	1	0	13956	\N
28457	1849	3	0	13967	\N
29577	233	2	0	13976	\N
7903	1849	3	0	13985	\N
1050	540	3	0	13994	\N
2252	722	0	0	13996	\N
30223	1158	104	0	14003	\N
1694	403	2	0	14028	\N
2626	402	1	0	14039	\N
3153	402	1	0	14040	\N
13258	402	4	0	14052	\N
14156	402	0	0	14068	\N
14140	402	126	0	14071	\N
4079	1148	3	0	14084	\N
26521	402	2	0	14088	\N
27470	402	0	0	14089	\N
6069	403	2	0	14121	\N
28054	4077	4	0	14128	\N
16000	402	9	0	14160	\N
7306	402	2	0	14165	\N
6684	1378	5	0	14173	\N
16008	4709	17	0	14183	\N
29909	8338	5	0	14190	\N
29910	8339	10	0	14191	\N
17232	1148	2	0	14198	\N
9100	1148	3	0	14204	\N
18017	4077	4	0	14225	\N
18918	402	2	0	14239	\N
10530	2548	5	0	14242	\N
20573	6040	89	0	14271	\N
21032	402	3	0	14279	\N
21440	3382	7	0	14299	\N
21604	402	3	0	14317	\N
23080	402	3	0	14329	\N
12136	2889	2	0	14332	\N
23834	402	4	0	14335	\N
23835	402	6	0	14336	\N
658	258	1	0	14344	\N
1221	258	2	0	14356	\N
11163	258	6	0	14362	\N
22884	3057	8	0	14370	\N
1459	635	5	0	14383	\N
25905	3275	3	0	14439	\N
26180	258	5	0	14447	\N
5024	258	1	0	14468	\N
28689	3275	3	0	14480	\N
28080	7835	20	0	14481	\N
15757	258	3	0	14483	\N
17858	258	3	0	14501	\N
7037	258	2	0	14546	\N
460	352	2	0	14571	\N
2097	760	3	0	14573	\N
583	173	1	0	14581	\N
925	173	1	0	14592	\N
11840	1927	2	0	14606	\N
12218	173	2	0	14609	\N
3740	396	2	0	14623	\N
13381	173	15	0	14634	\N
4985	173	3	0	14658	\N
24702	173	27	0	14671	\N
15590	4573	7	0	14703	\N
16061	173	4	0	14716	\N
6654	173	6	0	14741	\N
17358	173	3	0	14747	\N
7301	396	2	0	14763	\N
29422	3857	5	0	14767	\N
7870	173	2	0	14774	\N
18783	173	3	0	14798	\N
8647	480	3	0	14806	\N
20022	173	10	0	14844	\N
20834	3857	5	0	14855	\N
21898	173	6	0	14860	\N
22332	173	7	0	14869	\N
3704	1117	2	0	14875	\N
508	191	2	0	14889	\N
820	191	2	0	14893	\N
11152	93	3	0	14903	\N
11520	2866	29	0	14910	\N
3356	1055	48	0	14946	\N
21916	6430	8	0	14958	\N
13850	191	2	0	14992	\N
13301	92	95	0	14994	\N
3766	93	3	0	15005	\N
22675	3979	5	0	15012	\N
16805	92	3	0	15060	\N
23814	4410	4	0	15070	\N
6094	92	3	0	15096	\N
7555	191	2	0	15127	\N
26520	4410	4	0	15144	\N
28362	92	2	0	15178	\N
28903	7977	10	0	15200	\N
10311	2475	5	0	15205	\N
10734	93	3	0	15212	\N
10828	92	4	0	15213	\N
2948	961	2	0	15227	\N
12512	3274	5	0	15244	\N
2112	764	2	0	15248	\N
7466	763	1	0	15249	\N
181	192	1	0	15256	\N
17383	3790	4	0	15363	\N
6251	192	1	0	15365	\N
17880	2761	2	0	15372	\N
6479	838	3	0	15376	\N
7663	192	2	0	15399	\N
18857	193	2	0	15411	\N
30266	192	34	0	15414	\N
19598	192	3	0	15420	\N
8473	193	2	0	15431	\N
9038	193	4	0	15443	\N
20882	192	4	0	15455	\N
21379	192	0	0	15460	\N
22305	3790	4	0	15483	\N
22562	2944	5	0	15484	\N
22563	2944	5	0	15485	\N
9465	627	4	0	15489	\N
9723	2256	43	0	15497	\N
10237	838	3	0	15513	\N
12289	192	1	0	15541	\N
12360	192	1	0	15552	\N
12771	2761	3	0	15559	\N
13596	3790	4	0	15571	\N
16871	4976	14	0	15585	\N
1391	235	1	0	15592	\N
3214	235	1	0	15610	\N
22221	6492	6	0	15626	\N
5501	235	0	0	15669	\N
23717	235	8	0	15680	\N
24094	2757	3	0	15687	\N
5954	235	2	0	15704	\N
14111	235	4	0	15706	\N
24677	3615	5	0	15711	\N
24744	7146	9	0	15719	\N
6224	236	2	0	15728	\N
14748	235	2	0	15731	\N
25381	235	3	0	15742	\N
25611	235	5	0	15743	\N
6799	1061	3	0	15747	\N
7783	235	1	0	15757	\N
16709	4918	127	0	15769	\N
25897	2757	3	0	15772	\N
25999	235	5	0	15785	\N
8087	235	1	0	15793	\N
26422	3343	4	0	15802	\N
8571	235	2	0	15818	\N
27786	2757	3	0	15825	\N
9208	235	2	0	15833	\N
18239	2757	3	0	15836	\N
28688	3343	4	0	15840	\N
9640	235	2	0	15842	\N
18770	2757	3	0	15871	\N
18928	235	1	0	15890	\N
20209	235	3	0	15915	\N
20274	235	7	0	15916	\N
8786	2007	3	0	15936	\N
35	45	2	0	15940	\N
10977	44	2	0	15945	\N
1081	45	2	0	15968	\N
21304	3631	4	0	15972	\N
12366	2997	2	0	15996	\N
22148	44	7	0	16005	\N
23105	44	3	0	16029	\N
13838	44	20	0	16039	\N
4665	44	1	0	16077	\N
14943	1910	3	0	16086	\N
5034	44	2	0	16096	\N
5839	44	5	0	16101	\N
16075	44	7	0	16131	\N
16469	44	4	0	16132	\N
17262	44	3	0	16144	\N
17655	44	4	0	16153	\N
8110	44	2	0	16161	\N
8827	44	6	0	16165	\N
27585	5215	5	0	16185	\N
9073	161	3	0	16190	\N
19192	44	7	0	16191	\N
9620	44	9	0	16203	\N
28129	45	2	0	16208	\N
28805	44	7	0	16218	\N
29626	44	13	0	16225	\N
30027	44	4	0	16230	\N
10402	38	1	0	16238	\N
20415	5986	11	0	16250	\N
20825	4009	3	0	16257	\N
20985	3457	4	0	16259	\N
10619	39	3	0	16261	\N
21267	6259	5	0	16279	\N
11650	38	2	0	16295	\N
11846	38	1	0	16304	\N
22975	38	3	0	16309	\N
1830	399	2	0	16329	\N
13547	38	1	0	16341	\N
23568	38	6	0	16345	\N
2451	399	2	0	16350	\N
3548	38	0	0	16362	\N
23818	6006	8	0	16375	\N
24270	5656	5	0	16380	\N
24376	38	3	0	16386	\N
24934	38	3	0	16403	\N
15400	4009	3	0	16410	\N
25326	38	3	0	16413	\N
15407	38	4	0	16415	\N
25519	3457	4	0	16434	\N
16240	38	29	0	16451	\N
16803	38	3	0	16454	\N
26499	5071	8	0	16471	\N
7635	38	1	0	16491	\N
17813	5259	4	0	16502	\N
8261	39	3	0	16511	\N
9002	38	2	0	16532	\N
28288	38	2	0	16536	\N
29256	38	3	0	16566	\N
29982	38	10	0	16572	\N
2769	925	2	0	16597	\N
28851	7969	7	0	16599	\N
93	115	1	0	16606	\N
2348	115	1	0	16636	\N
2668	636	3	0	16639	\N
3255	115	2	0	16643	\N
14443	3483	4	0	16659	\N
14554	3483	4	0	16673	\N
15385	115	3	0	16689	\N
5356	115	1	0	16692	\N
15864	4674	4	0	16700	\N
15838	2797	3	0	16707	\N
26128	115	2	0	16727	\N
6613	115	0	0	16735	\N
26913	115	3	0	16757	\N
27121	115	6	0	16758	\N
17096	115	5	0	16762	\N
8142	115	1	0	16804	\N
18436	3483	4	0	16813	\N
29040	115	3	0	16817	\N
19207	115	2	0	16830	\N
19214	5585	21	0	16840	\N
19375	3483	4	0	16847	\N
9180	636	8	0	16865	\N
21598	3483	4	0	16902	\N
12565	2797	3	0	16926	\N
9774	2282	0	0	16952	\N
22323	6532	6	0	16957	\N
19369	98	3	0	16980	\N
10948	212	6	0	16991	\N
1417	212	1	0	16997	\N
11719	212	1	0	17013	\N
20749	212	6	0	17019	\N
21310	212	126	0	17023	\N
2199	784	4	0	17029	\N
11930	3070	4	0	17036	\N
24652	212	4	0	17066	\N
4002	212	1	0	17106	\N
4429	213	2	0	17109	\N
14043	212	2	0	17122	\N
23430	3616	3	0	17132	\N
27641	212	12	0	17144	\N
26787	3732	5	0	17151	\N
26107	7435	59	0	17158	\N
14409	212	2	0	17162	\N
14238	213	2	0	17166	\N
3395	1063	127	0	17170	\N
28785	3639	4	0	17202	\N
15592	212	4	0	17205	\N
6583	784	4	0	17216	\N
16489	3639	4	0	17220	\N
15824	212	20	0	17222	\N
17612	3732	5	0	17240	\N
20120	3312	8	0	17265	\N
10018	566	3	0	17276	\N
17063	5014	26	1	17282	\N
394	326	1	0	17284	\N
2266	747	3	0	17299	\N
3941	326	1	0	17312	\N
4136	326	1	0	17313	\N
4820	326	1	0	17320	\N
5479	326	0	0	17337	\N
13108	3519	5	0	17362	\N
6105	326	5	0	17368	\N
13585	3805	6	0	17375	\N
14259	326	4	0	17386	\N
14847	326	2	0	17420	\N
6748	1638	5	0	17428	\N
17062	326	4	0	17443	\N
27126	3339	4	0	17477	\N
16772	326	127	0	17489	\N
27301	3339	4	0	17491	\N
10179	2438	7	0	17496	\N
27562	3519	5	0	17508	\N
28377	7875	24	0	17521	\N
19597	5690	11	0	17542	\N
28870	326	3	0	17543	\N
21316	326	3	0	17581	\N
10701	2584	10	1	17587	\N
2915	957	2	1	17591	\N
2627	533	2	0	17626	\N
11611	2922	4	0	17629	\N
12084	2260	3	0	17636	\N
2717	533	2	0	17638	\N
3384	167	1	0	17661	\N
22853	2503	2	0	17697	\N
23245	3428	5	0	17722	\N
25697	533	1	0	17745	\N
4760	167	1	0	17752	\N
25698	2260	5	0	17760	\N
4918	533	2	0	17766	\N
5218	167	2	0	17774	\N
17234	167	7	0	17781	\N
26578	167	4	0	17786	\N
5894	167	1	0	17795	\N
28269	167	2	0	17824	\N
19441	4048	5	0	17843	\N
19924	2503	2	0	17855	\N
20385	167	28	0	17868	\N
29349	167	6	0	17877	\N
21022	167	6	0	17902	\N
10831	168	3	0	17923	\N
10858	168	3	0	17924	\N
30163	167	40	0	17934	\N
30164	167	40	0	17935	\N
21532	2922	5	0	17950	\N
1196	418	2	0	17977	\N
4696	1319	4	0	17999	\N
3640	30	5	0	18000	\N
4801	418	2	0	18008	\N
4966	31	3	0	18009	\N
5899	30	1	0	18015	\N
6680	31	2	0	18031	\N
7121	1729	6	0	18036	\N
10919	2635	9	0	18064	\N
11273	30	2	0	18070	\N
12203	3171	4	0	18081	\N
12809	30	3	0	18083	\N
13928	3640	4	0	18095	\N
14211	4095	5	0	18103	\N
15244	30	2	0	18110	\N
18459	30	4	0	18131	\N
19791	3640	4	0	18152	\N
22737	30	14	0	18163	\N
22949	3640	4	0	18167	\N
26333	30	5	0	18175	\N
27881	30	8	0	18187	\N
28862	30	3	0	18196	\N
27225	7679	3	0	18220	\N
20912	6176	127	0	18230	\N
10074	2377	0	0	18240	\N
329	293	2	0	18251	\N
603	293	2	0	18255	\N
721	446	4	0	18263	\N
1769	293	2	0	18277	\N
2013	498	2	0	18294	\N
7007	178	3	0	18296	\N
4798	1329	8	0	18298	\N
11539	177	7	0	18312	\N
13385	3703	4	0	18329	\N
23179	6770	98	0	18340	\N
22931	6698	2	1	18381	\N
12288	3209	2	0	18386	\N
20559	6029	65	0	18401	\N
20461	765	3	0	18406	\N
25946	765	5	0	18415	\N
27887	7797	3	0	18421	\N
1595	142	1	0	18435	\N
1944	143	2	0	18446	\N
10438	2510	5	0	18451	\N
11044	142	2	0	18470	\N
21978	142	3	0	18477	\N
21981	142	126	0	18481	\N
4156	1181	3	0	18486	\N
22252	142	7	0	18487	\N
22374	142	3	0	18489	\N
23049	142	7	0	18507	\N
13779	142	0	0	18532	\N
24322	142	7	0	18546	\N
25036	4418	3	0	18573	\N
26812	142	7	0	18602	\N
6239	142	2	0	18614	\N
27020	4254	4	0	18619	\N
16607	142	3	0	18642	\N
8530	656	3	0	18651	\N
17122	4418	3	0	18660	\N
17597	4254	4	0	18663	\N
28122	4418	3	0	18672	\N
28338	4418	3	0	18674	\N
18230	4418	3	0	18679	\N
29433	142	3	0	18705	\N
18791	5511	3	0	18735	\N
15516	3265	3	0	18751	\N
18367	3108	127	0	18756	\N
21590	3108	10	1	18759	\N
25191	3268	7	0	18767	\N
28626	6730	18	0	18770	\N
21328	3108	4	1	18788	\N
1092	561	9	0	18806	\N
14813	4125	9	0	18830	\N
15157	4467	3	0	18836	\N
378	290	1	0	18855	\N
10647	290	2	0	18861	\N
21547	6328	0	0	18874	\N
21711	290	3	0	18879	\N
10952	290	1	0	18890	\N
1657	290	1	0	18914	\N
22571	290	3	0	18916	\N
11313	1909	3	0	18933	\N
3010	575	3	0	18957	\N
23838	3635	4	0	18976	\N
3915	290	0	0	18984	\N
12994	3448	4	0	18989	\N
12957	290	2	0	18991	\N
3912	290	2	0	18999	\N
23891	290	3	0	19005	\N
24398	290	2	0	19030	\N
24872	290	3	0	19050	\N
16348	3635	4	0	19055	\N
25076	290	4	0	19064	\N
7360	290	9	0	19074	\N
19755	290	2	0	19085	\N
7374	290	1	0	19094	\N
8278	290	2	0	19107	\N
26135	1909	3	0	19118	\N
27867	290	3	0	19133	\N
28330	7869	7	0	19142	\N
2318	774	0	0	19156	\N
15249	4490	4	0	19195	\N
18456	4490	4	0	19198	\N
17541	5182	6	0	19200	\N
864	209	2	0	19207	\N
21715	5118	7	0	19220	\N
1909	209	2	0	19236	\N
22501	6580	10	0	19240	\N
2507	208	2	0	19242	\N
22632	6311	5	0	19251	\N
23279	4524	3	0	19263	\N
19618	5702	11	0	19344	\N
21767	6394	7	0	19369	\N
23622	60	8	0	19410	\N
23604	4544	3	0	19412	\N
13198	60	3	0	19421	\N
14550	60	10	0	19431	\N
24101	4544	3	0	19441	\N
15391	3585	4	0	19445	\N
24836	60	11	0	19471	\N
5161	61	2	0	19494	\N
5820	60	1	0	19508	\N
27227	3585	4	0	19541	\N
17566	3585	4	0	19550	\N
7727	60	2	0	19557	\N
27984	6394	7	0	19568	\N
19554	60	4	0	19623	\N
9017	1687	5	0	19639	\N
19557	60	38	0	19645	\N
10908	1451	2	0	19673	\N
50	63	2	0	19678	\N
12393	3130	2	0	19723	\N
6379	62	2	0	19738	\N
14121	62	4	0	19741	\N
23226	6789	6	0	19760	\N
14437	62	3	0	19766	\N
8703	1981	6	0	19793	\N
16238	62	5	0	19810	\N
25465	3344	4	0	19821	\N
16262	62	7	0	19825	\N
26438	4059	5	0	19831	\N
9450	2191	3	0	19833	\N
27610	7756	55	0	19849	\N
18674	62	3	0	19877	\N
28321	62	2	0	19887	\N
18905	63	2	0	19903	\N
19011	2191	3	0	19911	\N
29254	62	3	0	19916	\N
29524	62	6	0	19917	\N
19958	62	126	0	19932	\N
19960	62	3	0	19938	\N
20997	62	13	0	19968	\N
193	199	2	0	19984	\N
1352	198	1	0	19997	\N
24428	4263	4	0	20022	\N
24911	4263	4	0	20044	\N
13821	3601	8	0	20066	\N
26176	198	7	0	20069	\N
14359	198	4	0	20085	\N
14362	4165	127	0	20094	\N
6293	199	2	0	20114	\N
16199	4263	4	0	20161	\N
7906	198	1	0	20182	\N
16880	4263	4	0	20186	\N
8135	199	2	0	20193	\N
8170	199	2	0	20203	\N
8374	199	2	0	20204	\N
17372	4263	4	0	20206	\N
17787	198	0	0	20214	\N
8674	198	0	0	20230	\N
9133	746	3	0	20254	\N
21415	198	12	0	20285	\N
11450	198	1	0	20298	\N
11908	2829	2	0	20314	\N
12509	198	4	0	20324	\N
1720	578	2	0	20339	\N
21218	6246	5	0	20345	\N
567	333	2	0	20362	\N
4106	241	2	0	20384	\N
2777	281	3	0	20389	\N
12085	241	2	0	20392	\N
12907	241	4	0	20399	\N
4840	333	2	0	20416	\N
15650	4586	5	0	20420	\N
6311	241	2	0	20438	\N
24627	4582	5	0	20456	\N
19435	4230	9	0	20482	\N
8706	241	4	0	20488	\N
19622	4987	8	0	20493	\N
25249	241	6	0	20495	\N
25551	7323	49	0	20510	\N
22008	241	3	0	20558	\N
11762	241	2	0	20592	\N
27951	241	6	0	20598	\N
27529	6412	7	0	20601	\N
27528	3094	90	0	20605	\N
104	130	4	0	20635	\N
12416	64	1	0	20657	\N
2512	162	3	0	20692	\N
23599	277	3	0	20714	\N
23598	6869	33	0	20717	\N
14596	4217	4	0	20723	\N
3164	64	1	0	20738	\N
25480	4217	4	0	20744	\N
3421	64	2	0	20753	\N
26268	64	3	0	20755	\N
16327	64	4	0	20761	\N
26982	7624	10	0	20768	\N
4263	65	1	0	20774	\N
17008	277	3	0	20778	\N
4386	162	3	0	20788	\N
28090	3911	5	0	20809	\N
5900	65	2	0	20827	\N
29725	64	9	0	20858	\N
29880	8321	13	1	20860	\N
7970	64	1	0	20869	\N
20269	64	3	0	20878	\N
8317	1925	6	0	20884	\N
10328	2482	6	0	20923	\N
1187	164	3	0	20937	\N
916	512	3	0	20943	\N
1541	165	2	0	20953	\N
22964	3385	4	0	21043	\N
13392	164	3	0	21058	\N
13195	226	3	0	21060	\N
23959	164	2	0	21123	\N
5107	165	2	0	21143	\N
24613	3385	4	0	21152	\N
25020	7209	10	0	21171	\N
16377	164	3	0	21172	\N
16715	165	1	0	21184	\N
16719	164	4	0	21193	\N
18108	164	3	0	21221	\N
27871	7793	46	0	21238	\N
26869	164	3	0	21248	\N
18683	164	2	0	21259	\N
18684	1807	4	0	21266	\N
18876	5521	73	0	21268	\N
5892	1485	6	0	21286	\N
6595	164	2	0	21296	\N
30105	4626	6	0	21316	\N
7339	164	1	0	21323	\N
19966	164	4	0	21325	\N
7403	307	4	0	21332	\N
7532	165	2	0	21340	\N
7884	165	2	0	21349	\N
8842	662	7	0	21364	\N
9175	164	2	0	21365	\N
9371	226	3	0	21368	\N
9547	1582	5	0	21372	\N
10046	164	2	0	21376	\N
9918	488	3	0	21390	\N
3480	488	0	0	21401	\N
4071	488	1	0	21413	\N
21618	6343	62	0	21430	\N
11540	488	7	0	21431	\N
21737	488	126	0	21437	\N
12125	488	1	0	21457	\N
24078	488	6	0	21467	\N
13568	3795	41	0	21487	\N
6037	729	3	0	21490	\N
16024	2791	2	0	21495	\N
7173	488	2	0	21507	\N
25887	5021	5	0	21546	\N
18203	488	6	0	21551	\N
18178	2791	3	0	21553	\N
18744	1103	4	0	21554	\N
16767	4942	65	0	21558	\N
19163	488	3	0	21572	\N
19472	5606	5	0	21598	\N
29452	8076	5	0	21600	\N
6692	1629	5	0	21620	\N
29837	7714	9	1	21650	\N
29956	8310	12	0	21666	\N
30052	7714	18	1	21678	\N
30084	8310	9	1	21685	\N
30169	6335	10	1	21696	\N
30266	6335	35	1	21715	\N
3112	989	2	0	21722	\N
5656	1355	14	0	21729	\N
712	440	5	0	21735	\N
714	440	1	0	21737	\N
22929	6690	64	0	21757	\N
13366	3689	14	0	21761	\N
20922	145	2	0	21793	\N
21014	145	7	0	21802	\N
1484	153	2	0	21806	\N
21504	145	2	0	21813	\N
28639	7938	87	1	21829	\N
2630	145	2	0	21844	\N
2482	331	3	0	21846	\N
23726	145	7	0	21857	\N
3350	1018	80	0	21862	\N
29684	1075	19	1	21868	\N
29758	5348	28	0	21869	\N
29818	8259	16	1	21884	\N
29938	8366	60	1	21896	\N
29009	3867	5	0	21916	\N
30318	1075	8	0	21932	\N
24546	145	0	0	21938	\N
24912	4908	4	0	21941	\N
25112	4908	4	0	21954	\N
4361	153	2	0	21957	\N
26429	3867	5	0	21971	\N
27332	145	3	0	21988	\N
25313	7281	7	1	22026	\N
14783	145	2	0	22047	\N
14862	4391	6	0	22053	\N
14745	4098	102	1	22090	\N
12838	1075	3	1	22091	\N
14335	4151	9	0	22135	\N
24085	67	2	0	22143	\N
2102	478	2	0	22156	\N
4251	478	2	0	22194	\N
4712	478	2	0	22219	\N
17863	5267	5	0	22233	\N
5301	478	2	0	22235	\N
30253	8600	11	0	22237	\N
5340	478	2	0	22243	\N
20088	5861	14	0	22263	\N
7041	67	2	0	22269	\N
7697	67	1	0	22284	\N
10905	67	4	0	22301	\N
11195	67	2	0	22302	\N
275	255	2	0	22319	\N
10245	73	4	0	22354	\N
20276	73	6	0	22358	\N
10553	2556	8	0	22373	\N
10551	73	43	0	22374	\N
1227	74	2	0	22380	\N
20863	6165	6	0	22384	\N
20977	3040	4	0	22395	\N
21433	73	3	0	22403	\N
1943	73	2	0	22408	\N
2357	74	2	0	22410	\N
21742	3040	4	0	22414	\N
12622	73	4	0	22439	\N
22682	6635	8	0	22452	\N
2807	703	3	0	22457	\N
3672	73	0	0	22476	\N
3851	703	3	0	22491	\N
23775	73	3	0	22494	\N
24889	73	3	0	22518	\N
14058	73	3	0	22534	\N
6158	74	2	0	22558	\N
25867	73	3	0	22561	\N
26559	2284	5	0	22604	\N
9779	2284	5	0	22611	\N
15761	73	9	0	22619	\N
28383	73	3	0	22635	\N
29427	73	4	0	22646	\N
17868	4622	10	0	22656	\N
18018	3040	4	0	22663	\N
18234	2766	3	0	22670	\N
420	337	4	0	22686	\N
830	356	2	0	22697	\N
2530	336	1	0	22705	\N
4018	336	1	0	22716	\N
12653	336	2	0	22720	\N
5050	336	1	0	22734	\N
5455	336	0	0	22746	\N
13555	336	0	0	22755	\N
5797	356	2	0	22760	\N
6253	336	1	0	22765	\N
13934	336	4	0	22776	\N
15708	3400	4	0	22783	\N
15296	4497	11	0	22786	\N
25861	7201	9	0	22815	\N
16916	3400	4	0	22819	\N
17264	336	0	0	22828	\N
9645	740	3	0	22881	\N
10510	740	3	0	22897	\N
19007	356	2	0	22904	\N
19758	3400	4	0	22930	\N
11906	2970	2	0	22937	\N
12272	2970	2	0	22949	\N
21954	336	0	0	22959	\N
22344	336	9	0	22963	\N
23732	336	5	0	22985	\N
23914	3400	4	0	22989	\N
24215	336	3	0	22993	\N
13731	3876	5	0	23003	\N
1021	149	1	0	23029	\N
2882	149	2	0	23040	\N
3196	149	1	0	23042	\N
24144	149	109	0	23124	\N
6169	499	2	0	23129	\N
15267	3808	6	0	23134	\N
6566	697	3	0	23149	\N
16146	149	6	0	23159	\N
26704	149	7	0	23163	\N
17158	149	7	0	23168	\N
26947	149	3	0	23173	\N
7492	149	1	0	23179	\N
27740	149	2	0	23206	\N
28367	149	2	0	23208	\N
28655	149	6	0	23210	\N
28953	1379	3	0	23223	\N
29189	1379	3	0	23242	\N
29369	149	3	0	23251	\N
30001	8419	55	0	23269	\N
30223	8584	101	0	23294	\N
10809	2605	127	0	23298	\N
11683	2963	10	0	23312	\N
12185	3163	104	0	23347	\N
22104	149	7	0	23350	\N
22922	149	4	0	23363	\N
23026	149	3	0	23366	\N
20178	3684	5	0	23378	\N
20520	5480	7	0	23379	\N
9927	2321	6	0	23381	\N
20691	264	3	0	23385	\N
1763	264	1	0	23397	\N
10097	2398	5	0	23405	\N
10498	264	11	0	23406	\N
3082	270	2	0	23440	\N
11215	1748	4	0	23459	\N
3969	264	1	0	23460	\N
11659	2941	2	0	23474	\N
22351	3632	4	0	23487	\N
13176	3567	11	0	23494	\N
4681	270	2	0	23496	\N
5640	264	0	0	23511	\N
23355	264	2	0	23514	\N
13960	264	11	0	23519	\N
13358	2780	3	0	23520	\N
14520	264	2	0	23544	\N
24871	7175	15	0	23565	\N
14573	2780	3	0	23573	\N
25044	264	3	0	23592	\N
15569	264	3	0	23596	\N
26234	264	7	0	23614	\N
9534	264	2	0	23622	\N
27033	264	3	0	23624	\N
17803	264	1	0	23636	\N
18259	3632	4	0	23649	\N
18755	2780	3	0	23662	\N
28160	6187	8	0	23676	\N
433	343	3	0	23686	\N
10829	82	1	0	23708	\N
1562	83	2	0	23715	\N
2010	83	2	0	23716	\N
25145	7236	5	0	23749	\N
12050	2951	2	0	23754	\N
12802	3401	3	0	23781	\N
4794	83	2	0	23798	\N
28771	5468	4	0	23827	\N
29475	8085	8	0	23830	\N
14979	82	2	0	23836	\N
7641	83	2	0	23848	\N
8449	82	3	0	23859	\N
17167	82	10	0	23873	\N
9605	82	6	0	23881	\N
18266	82	3	0	23887	\N
13443	672	7	0	23915	\N
27832	7792	4	0	23934	\N
117	140	1	0	23938	\N
1342	140	1	0	23956	\N
22605	140	2	0	23968	\N
12999	3183	3	0	23972	\N
15106	4453	9	0	24026	\N
3188	140	1	0	24027	\N
3258	140	1	0	24028	\N
16052	4086	7	0	24044	\N
4472	140	3	0	24060	\N
4245	140	81	0	24065	\N
16808	140	3	0	24069	\N
7122	140	6	0	24082	\N
7776	141	2	0	24084	\N
8772	1730	7	0	24108	\N
18382	141	1	0	24155	\N
18174	5000	6	0	24156	\N
11485	140	1	0	24203	\N
11600	2912	3	0	24205	\N
28972	3821	5	0	24231	\N
20801	3183	3	0	24246	\N
21326	141	1	0	24249	\N
30166	8525	42	0	24279	\N
10101	215	2	0	24298	\N
14648	214	126	0	24328	\N
11526	214	6	0	24334	\N
19680	5728	9	0	24367	\N
19689	214	10	0	24382	\N
16181	214	2	0	24384	\N
26729	5951	8	0	24399	\N
20292	5951	8	0	24407	\N
21203	2871	7	0	24421	\N
16421	214	4	0	24422	\N
22048	214	3	0	24436	\N
22253	5951	8	0	24442	\N
13018	214	6	0	24452	\N
6308	1537	6	0	24457	\N
27975	214	3	0	24459	\N
22440	6560	98	0	24467	\N
17271	214	0	0	24472	\N
6524	227	3	0	24490	\N
28109	3496	4	0	24493	\N
17274	3496	4	0	24499	\N
4084	215	2	0	24501	\N
29143	8010	10	0	24528	\N
17587	214	6	0	24534	\N
29813	214	124	0	24546	\N
10172	69	1	0	24579	\N
10209	594	4	0	24588	\N
10445	2512	11	0	24591	\N
10486	500	3	0	24598	\N
21131	4536	4	0	24617	\N
1083	70	2	0	24621	\N
21578	69	1	0	24626	\N
21554	69	126	0	24631	\N
23438	69	0	0	24656	\N
3772	70	2	0	24676	\N
23537	69	10	0	24685	\N
23440	3350	3	0	24687	\N
12689	3350	3	0	24696	\N
4947	70	2	0	24717	\N
14179	4084	7	0	24730	\N
23955	69	3	0	24741	\N
25792	69	4	0	24791	\N
15800	4536	4	0	24799	\N
16766	69	2	0	24831	\N
17973	5298	9	0	24849	\N
28517	69	2	0	24858	\N
28844	69	0	0	24860	\N
29542	69	6	0	24877	\N
29640	69	3	0	24878	\N
29896	69	10	0	24891	\N
30059	69	19	0	24900	\N
18902	2185	6	0	24928	\N
3887	1154	3	0	24951	\N
19793	5769	3	0	24960	\N
4874	1345	112	0	24964	\N
39	49	1	0	24965	\N
1730	49	2	0	24987	\N
11607	49	2	0	24995	\N
2962	50	2	0	25009	\N
3281	328	3	0	25015	\N
13966	49	1	0	25019	\N
13472	3751	5	0	25022	\N
3347	1049	11	0	25025	\N
13994	49	8	0	25026	\N
4674	1315	114	0	25050	\N
5112	49	1	0	25058	\N
7803	50	2	0	25102	\N
739	412	2	0	25131	\N
21223	3370	3	0	25167	\N
2645	412	2	0	25174	\N
21885	3596	4	0	25180	\N
11758	411	2	0	25182	\N
23186	411	5	0	25205	\N
23985	411	3	0	25219	\N
13601	412	2	0	25238	\N
24391	411	3	0	25243	\N
6809	411	4	0	25250	\N
7021	1665	5	0	25253	\N
14592	3596	4	0	25257	\N
24970	3370	3	0	25261	\N
25475	412	1	0	25262	\N
25226	2874	6	0	25276	\N
15327	3370	3	0	25288	\N
8818	411	3	0	25289	\N
9250	2143	6	0	25295	\N
26279	3596	4	0	25312	\N
9765	2277	12	0	25322	\N
26902	411	3	0	25323	\N
27108	411	3	0	25329	\N
30028	411	6	0	25367	\N
30304	411	7	0	25384	\N
20320	3150	14	0	25403	\N
10783	224	4	0	25404	\N
11165	224	2	0	25405	\N
937	224	1	0	25416	\N
20602	224	2	0	25419	\N
21801	3603	4	0	25427	\N
11955	224	2	0	25440	\N
12114	224	1	0	25441	\N
2277	225	2	0	25460	\N
2623	508	3	0	25475	\N
14324	3806	5	0	25501	\N
24499	3150	3	0	25504	\N
26415	7500	19	0	25558	\N
27232	224	3	0	25577	\N
5781	225	2	0	25586	\N
17112	224	2	0	25597	\N
6307	224	5	0	25608	\N
17691	3150	3	0	25614	\N
18557	5455	5	0	25619	\N
28572	224	6	0	25638	\N
28573	224	98	0	25652	\N
8076	508	3	0	25658	\N
29374	224	5	0	25676	\N
8546	224	2	0	25685	\N
30013	224	9	0	25706	\N
9163	224	4	0	25709	\N
199	206	1	0	25726	\N
821	207	2	0	25732	\N
1247	207	2	0	25737	\N
21859	4584	4	0	25762	\N
27801	3511	5	0	25770	\N
27702	7772	7	0	25771	\N
3983	206	1	0	25775	\N
3176	999	3	0	25778	\N
22041	3511	5	0	25781	\N
5217	207	2	0	25803	\N
25959	3348	5	0	25811	\N
25966	7406	6	0	25812	\N
23114	206	0	0	25828	\N
24161	2773	3	0	25842	\N
7327	206	1	0	25854	\N
7147	207	2	0	25855	\N
8116	207	2	0	25861	\N
8285	206	1	0	25863	\N
18994	206	2	0	25870	\N
8832	2020	7	0	25877	\N
19870	4584	4	0	25898	\N
11336	2773	3	0	25908	\N
11913	206	1	0	25919	\N
14392	206	1	0	25930	\N
15722	206	3	0	25943	\N
16561	4584	4	0	25950	\N
17049	5010	3	0	25959	\N
17179	4584	4	0	25962	\N
17628	206	6	0	25963	\N
1833	344	2	0	25989	\N
12552	3291	127	0	26002	\N
13434	3731	5	0	26024	\N
3361	90	2	0	26026	\N
4533	1274	5	0	26037	\N
24163	6995	8	0	26055	\N
14562	4264	25	0	26065	\N
24959	90	2	0	26089	\N
15222	90	2	0	26098	\N
25570	7332	4	0	26105	\N
7669	91	3	0	26121	\N
26510	90	11	0	26134	\N
15567	91	3	0	26138	\N
16509	90	7	0	26179	\N
16844	90	3	0	26180	\N
16961	4074	4	0	26185	\N
17639	90	126	0	26187	\N
9600	90	3	0	26191	\N
18236	90	2	0	26201	\N
19322	90	126	0	26206	\N
23043	90	3	0	26261	\N
25637	1099	3	0	26270	\N
4055	345	2	0	26288	\N
21726	6303	2	0	26323	\N
22231	6303	70	0	26330	\N
22634	6303	6	0	26333	\N
24870	6303	1	0	26342	\N
29367	6304	4	0	26388	\N
30232	8503	11	0	26402	\N
1199	87	2	0	26409	\N
2319	87	2	0	26423	\N
5209	86	2	0	26442	\N
25232	86	5	0	26444	\N
25501	3746	4	0	26455	\N
29323	86	3	0	26515	\N
10544	86	2	0	26534	\N
11093	509	3	0	26566	\N
29858	86	9	0	26573	\N
15341	86	3	0	26582	\N
12012	2967	2	0	26595	\N
16295	4052	5	0	26598	\N
12624	86	0	0	26609	\N
18501	86	3	0	26626	\N
12822	87	2	0	26631	\N
19654	3746	4	0	26647	\N
461	94	1	0	26675	\N
545	107	2	0	26679	\N
2443	94	1	0	26704	\N
2842	95	3	0	26715	\N
5749	107	2	0	26755	\N
7398	94	1	0	26784	\N
9349	94	6	0	26805	\N
8945	94	2	0	26816	\N
9374	94	3	0	26818	\N
9405	94	2	0	26819	\N
10666	95	3	0	26855	\N
11449	107	2	0	26867	\N
11371	2794	3	0	26868	\N
12708	94	2	0	26895	\N
13053	94	2	0	26899	\N
13259	107	2	0	26906	\N
15568	94	3	0	26920	\N
16622	94	3	0	26936	\N
17914	94	6	0	26949	\N
18715	94	2	0	26966	\N
19018	94	2	0	26971	\N
19809	2864	4	0	26992	\N
21434	4696	7	0	26995	\N
20570	5303	9	0	26997	\N
21986	94	3	0	27006	\N
23576	4677	5	0	27029	\N
24478	94	2	0	27048	\N
24792	94	10	0	27057	\N
25273	94	3	0	27068	\N
25924	94	2	0	27079	\N
26158	94	5	0	27085	\N
26463	94	6	0	27093	\N
27080	7648	46	0	27105	\N
28904	3277	7	0	27121	\N
29015	94	6	0	27127	\N
29239	94	4	0	27135	\N
29688	94	6	0	27143	\N
29774	94	31	0	27146	\N
22616	6630	3	0	27156	\N
18585	2183	4	0	27167	\N
696	244	1	0	27188	\N
10784	2598	112	0	27205	\N
2903	245	2	0	27212	\N
3658	244	0	0	27229	\N
10854	244	116	0	27232	\N
4258	245	2	0	27243	\N
5371	244	0	0	27272	\N
15024	244	10	0	27292	\N
5654	244	0	0	27304	\N
27404	244	3	0	27310	\N
27405	244	3	0	27311	\N
17034	244	2	0	27348	\N
8180	244	1	0	27370	\N
6819	438	3	0	27372	\N
8283	245	2	0	27383	\N
8657	244	1	0	27394	\N
29294	244	4	0	27403	\N
20837	3308	3	0	27423	\N
29679	8150	13	0	27430	\N
22396	244	4	0	27435	\N
1663	42	2	0	27462	\N
12951	42	4	0	27504	\N
22314	3896	5	0	27537	\N
5253	42	2	0	27539	\N
13508	3645	4	0	27543	\N
14026	42	10	0	27561	\N
23503	6853	8	0	27578	\N
23577	42	3	0	27583	\N
24354	42	2	0	27585	\N
5910	42	1	0	27593	\N
25719	3645	4	0	27608	\N
26656	42	4	0	27647	\N
26865	42	7	0	27648	\N
27502	42	3	0	27678	\N
28003	43	2	0	27695	\N
18310	5386	20	0	27710	\N
19533	3440	5	0	27725	\N
19303	5612	21	0	27729	\N
20464	3310	3	0	27741	\N
11	17	2	0	27757	\N
283	16	1	0	27770	\N
575	16	1	0	27788	\N
720	445	3	0	27809	\N
1024	17	2	0	27832	\N
1067	16	1	0	27834	\N
1332	17	2	0	27849	\N
1460	380	5	0	27853	\N
1638	17	1	0	27862	\N
1696	17	2	0	27869	\N
1924	16	1	0	27879	\N
2433	16	1	0	27904	\N
2590	155	3	0	27916	\N
2946	16	1	0	27941	\N
3123	359	4	0	27951	\N
3280	16	2	0	27965	\N
3450	16	0	0	27975	\N
4501	16	1	0	27988	\N
4713	17	2	0	28002	\N
4892	17	2	0	28008	\N
4987	359	4	0	28014	\N
5187	16	1	0	28023	\N
5188	16	2	0	28024	\N
5226	16	1	0	28029	\N
5470	16	0	0	28050	\N
5739	17	2	0	28064	\N
5898	17	2	0	28074	\N
5953	16	1	0	28077	\N
6054	16	1	0	28083	\N
6162	16	1	0	28085	\N
6180	17	2	0	28089	\N
6219	16	1	0	28090	\N
6454	155	3	0	28109	\N
6473	16	2	0	28111	\N
6900	16	2	0	28132	\N
6938	16	2	0	28139	\N
6978	155	3	0	28145	\N
7288	155	3	0	28164	\N
7452	16	2	0	28175	\N
7558	17	2	0	28186	\N
7633	17	2	0	28191	\N
8143	16	1	0	28225	\N
8280	16	2	0	28232	\N
8462	16	1	0	28246	\N
8535	16	1	0	28250	\N
9210	359	4	0	28274	\N
9459	155	3	0	28281	\N
9487	155	3	0	28283	\N
9512	16	3	0	28286	\N
9598	380	5	0	28296	\N
9845	16	2	0	28312	\N
9894	707	6	0	28317	\N
10542	16	2	0	28325	\N
9985	2339	29	0	28330	\N
10657	380	5	0	28347	\N
10720	155	3	0	28351	\N
11092	359	4	0	28369	\N
11316	16	1	0	28381	\N
11609	2921	4	0	28397	\N
11702	16	1	0	28398	\N
12036	16	2	0	28418	\N
12100	16	2	0	28422	\N
12490	16	1	0	28444	\N
12609	16	2	0	28450	\N
12642	388	3	0	28454	\N
12824	16	1	0	28464	\N
13052	3455	6	0	28485	\N
13463	16	3	0	28506	\N
13747	17	2	0	28518	\N
13892	17	2	0	28519	\N
13953	2921	4	0	28521	\N
14605	3634	4	0	28553	\N
14835	16	2	0	28566	\N
15188	16	1	0	28580	\N
15662	3369	7	0	28597	\N
15868	3634	4	0	28607	\N
16151	3546	5	0	28636	\N
16644	16	12	0	28656	\N
17078	3634	4	0	28670	\N
17445	3369	7	0	28700	\N
18032	16	2	0	28718	\N
18251	16	2	0	28729	\N
18528	16	3	0	28739	\N
18787	388	3	0	28752	\N
18865	16	2	0	28761	\N
19289	16	14	0	28778	\N
19423	4723	8	0	28792	\N
19968	16	7	0	28826	\N
20040	3634	4	0	28833	\N
20133	16	6	0	28838	\N
20785	16	6	0	28866	\N
21059	4240	6	0	28885	\N
21293	16	4	0	28898	\N
21431	3634	4	0	28912	\N
21537	16	3	0	28915	\N
21775	16	9	0	28933	\N
21840	16	3	0	28936	\N
21897	3634	4	0	28944	\N
22064	16	3	0	28950	\N
22094	3634	4	0	28957	\N
22522	16	13	0	28986	\N
22647	4723	8	0	28997	\N
22838	16	7	0	29017	\N
23055	3634	4	0	29035	\N
23109	3546	5	0	29050	\N
23317	16	4	0	29057	\N
23811	3634	4	0	29074	\N
24340	16	2	0	29098	\N
24380	17	2	0	29107	\N
24390	388	3	0	29108	\N
24843	16	3	0	29126	\N
24919	3634	4	0	29131	\N
25045	388	3	0	29133	\N
25836	16	3	0	29156	\N
22599	911	15	0	29187	\N
3792	525	1	0	29198	\N
414	320	1	0	29207	\N
20096	1937	2	0	29212	\N
15498	320	0	0	29216	\N
835	320	1	0	29220	\N
20329	5957	127	0	29241	\N
8595	1937	3	0	29243	\N
16406	320	3	0	29244	\N
16433	4827	8	0	29270	\N
17908	320	2	0	29277	\N
20536	6020	22	0	29290	\N
26417	3824	5	0	29310	\N
2684	334	2	0	29321	\N
2252	794	0	0	29322	\N
10223	2446	22	0	29349	\N
14927	320	2	0	29380	\N
6751	1640	2	0	29394	\N
581	97	2	0	29422	\N
2104	96	1	0	29433	\N
2420	96	3	0	29441	\N
2828	96	8	0	29452	\N
22384	96	3	0	29457	\N
12744	96	2	0	29464	\N
13104	3515	5	0	29467	\N
22511	5538	5	0	29473	\N
13288	2803	4	0	29479	\N
24113	2899	1	0	29484	\N
4458	1261	4	0	29487	\N
25079	96	3	0	29527	\N
6348	96	1	0	29535	\N
13580	3800	5	0	29541	\N
26339	5504	6	0	29547	\N
24994	7198	3	0	29549	\N
6591	482	3	0	29551	\N
26766	6633	11	0	29564	\N
7548	96	1	0	29567	\N
8967	2055	5	0	29594	\N
14575	96	2	0	29595	\N
14957	2803	4	0	29622	\N
10944	482	3	0	29631	\N
28702	2347	3	0	29641	\N
11391	97	1	0	29645	\N
15651	96	3	0	29647	\N
15934	96	3	0	29662	\N
11899	2942	3	0	29677	\N
11953	3081	5	0	29683	\N
12153	2899	2	0	29693	\N
17912	3698	7	0	29712	\N
19020	96	4	0	29728	\N
20412	449	6	0	29760	\N
20756	449	6	0	29768	\N
2261	801	4	0	29777	\N
20961	449	3	0	29780	\N
1682	450	2	0	29790	\N
3496	449	1	0	29803	\N
16220	4760	4	0	29821	\N
22875	449	6	0	29830	\N
23123	4760	4	0	29844	\N
4834	449	2	0	29846	\N
16943	449	1	0	29850	\N
17341	4760	4	0	29854	\N
14410	449	1	0	29871	\N
18641	5478	8	0	29902	\N
28905	7979	65	0	29928	\N
19857	449	6	0	29937	\N
161	176	3	0	29947	\N
1375	54	1	0	29968	\N
1846	54	1	0	29979	\N
3737	55	2	0	30002	\N
4307	55	2	0	30015	\N
4714	54	1	0	30023	\N
23036	54	10	0	30028	\N
5265	54	1	0	30055	\N
13419	3041	4	0	30073	\N
23868	5204	7	0	30091	\N
6880	54	5	0	30095	\N
6879	1678	4	0	30102	\N
13964	54	13	0	30107	\N
14199	54	3	0	30108	\N
9095	54	1	0	30134	\N
9079	55	2	0	30136	\N
24502	54	126	0	30146	\N
25139	54	3	0	30186	\N
18060	54	6	0	30228	\N
10479	485	3	0	30235	\N
10478	2532	3	0	30236	\N
28421	54	2	0	30250	\N
28050	7517	9	0	30256	\N
28503	3041	4	0	30263	\N
24	20	3	0	30326	\N
949	144	2	0	30341	\N
11042	20	2	0	30342	\N
21099	20	3	0	30352	\N
21206	20	2	0	30353	\N
21207	20	2	0	30354	\N
11715	20	1	0	30365	\N
21727	3111	3	0	30373	\N
22621	20	5	0	30392	\N
12908	369	3	0	30418	\N
3365	702	3	0	30430	\N
13610	20	9	0	30431	\N
15098	2975	2	0	30462	\N
17279	369	2	0	30499	\N
17377	20	3	0	30508	\N
27258	20	3	0	30516	\N
28206	369	3	0	30532	\N
28182	2844	4	0	30533	\N
7269	144	2	0	30538	\N
8136	20	1	0	30558	\N
29668	8141	10	0	30581	\N
9733	2268	14	0	30613	\N
10007	20	17	0	30619	\N
800	151	1	0	30634	\N
1291	302	2	0	30641	\N
1916	302	2	0	30651	\N
1994	302	2	0	30657	\N
2368	302	2	0	30658	\N
3027	302	2	0	30667	\N
24225	151	4	0	30676	\N
23993	151	126	0	30682	\N
4886	576	3	0	30706	\N
6092	151	3	0	30715	\N
13083	151	4	0	30724	\N
26136	2854	3	0	30741	\N
27699	7389	7	0	30775	\N
16593	3046	4	0	30788	\N
28150	5026	6	0	30791	\N
8075	151	4	0	30800	\N
17853	151	4	0	30808	\N
28614	151	7	0	30812	\N
8162	1510	5	0	30817	\N
29310	3046	4	0	30825	\N
8251	302	2	0	30830	\N
17950	3046	4	0	30833	\N
30153	151	49	0	30836	\N
9021	302	2	0	30847	\N
10651	151	4	0	30877	\N
11442	151	4	0	30886	\N
27365	678	3	0	30917	\N
221	203	2	0	30950	\N
10058	812	3	0	30956	\N
24346	4898	8	0	31033	\N
3097	202	3	0	31060	\N
24803	7159	7	0	31067	\N
4008	202	1	0	31084	\N
14770	2293	5	0	31094	\N
26730	202	3	0	31097	\N
4352	203	2	0	31129	\N
27902	202	3	0	31131	\N
27659	4857	4	0	31132	\N
15793	3673	5	0	31135	\N
15892	202	4	0	31140	\N
4986	987	4	0	31146	\N
6547	812	3	0	31157	\N
28254	2764	3	0	31159	\N
16518	2764	3	0	31162	\N
17076	202	4	0	31178	\N
7706	202	1	0	31182	\N
17897	202	17	0	31200	\N
18244	2764	3	0	31218	\N
18986	3673	5	0	31220	\N
19160	4079	7	0	31223	\N
19488	2293	5	0	31232	\N
19938	202	3	0	31243	\N
30092	202	9	0	31250	\N
29610	8114	4	0	31256	\N
9809	202	4	0	31261	\N
10197	360	2	0	31270	\N
22262	360	3	0	31304	\N
10870	2618	42	0	31306	\N
11384	2767	3	0	31315	\N
1532	479	2	0	31332	\N
11551	2886	2	0	31336	\N
23477	3602	4	0	31342	\N
23724	5788	7	0	31356	\N
12971	360	2	0	31371	\N
2359	479	2	0	31382	\N
2927	479	2	0	31426	\N
13741	360	20	0	31428	\N
3212	360	1	0	31438	\N
26817	360	3	0	31446	\N
27054	6575	9	0	31462	\N
4182	360	1	0	31469	\N
27224	7680	3	0	31482	\N
4679	479	2	0	31504	\N
28645	2943	3	0	31521	\N
16350	360	3	0	31541	\N
6961	360	1	0	31560	\N
16843	4970	8	0	31565	\N
30240	8596	6	0	31574	\N
29947	8372	11	0	31577	\N
8140	360	2	0	31590	\N
7797	479	2	0	31593	\N
7192	479	4	0	31595	\N
18573	360	0	0	31618	\N
9298	510	3	0	31638	\N
19918	5807	8	0	31642	\N
428	163	2	0	31655	\N
20875	5122	5	0	31674	\N
12149	3119	2	0	31687	\N
11434	2822	3	0	31688	\N
21892	3342	4	0	31709	\N
1522	33	2	0	31710	\N
12562	2822	3	0	31716	\N
12563	33	9	0	31717	\N
23206	33	2	0	31733	\N
13607	33	8	0	31743	\N
14448	33	6	0	31751	\N
23930	6947	11	0	31754	\N
24336	33	3	0	31773	\N
24417	7044	8	0	31776	\N
14766	33	5	0	31780	\N
25155	33	6	0	31792	\N
25474	163	1	0	31796	\N
15268	4492	6	0	31801	\N
25568	7330	7	0	31812	\N
5043	33	1	0	31815	\N
17432	5124	127	0	31845	\N
26035	33	0	0	31863	\N
6290	163	2	0	31882	\N
6448	34	3	0	31906	\N
8427	33	0	0	31940	\N
28908	33	3	0	31942	\N
8762	33	2	0	31951	\N
501	287	2	0	31973	\N
1812	230	2	0	31979	\N
21639	230	5	0	31986	\N
10793	2601	6	0	32001	\N
22028	4181	4	0	32005	\N
2659	230	1	0	32010	\N
11124	230	2	0	32015	\N
22210	230	10	0	32019	\N
24939	230	0	0	32073	\N
12898	3307	3	0	32089	\N
5216	287	2	0	32093	\N
13868	230	2	0	32100	\N
25691	230	6	0	32107	\N
26786	230	4	0	32130	\N
27852	4181	4	0	32151	\N
14384	230	6	0	32152	\N
7471	287	2	0	32157	\N
27927	4181	4	0	32173	\N
29043	230	6	0	32203	\N
28813	4181	4	0	32204	\N
9432	231	3	0	32213	\N
29491	230	12	0	32215	\N
29283	4181	4	0	32217	\N
17535	5176	7	0	32258	\N
30268	230	20	0	32270	\N
18873	230	1	0	32288	\N
19539	230	4	0	32295	\N
26565	1105	4	0	32365	\N
6704	322	6	0	32373	\N
7036	833	3	0	32400	\N
7120	833	3	0	32406	\N
28999	1105	4	0	32408	\N
7132	322	2	0	32411	\N
14256	3919	7	0	32418	\N
8012	1866	3	0	32432	\N
18525	5447	5	0	32513	\N
19178	1105	4	0	32522	\N
19360	1105	4	0	32535	\N
20611	322	10	0	32552	\N
21628	1105	4	0	32579	\N
22990	322	4	0	32582	\N
23626	6876	127	0	32596	\N
984	454	2	0	32606	\N
2681	453	1	0	32639	\N
12240	3095	2	0	32655	\N
21186	2838	3	0	32663	\N
12715	453	6	0	32683	\N
12728	3366	3	0	32699	\N
22788	6659	4	0	32718	\N
22787	4108	5	0	32722	\N
14736	4350	9	0	32758	\N
23728	453	7	0	32759	\N
15163	453	1	0	32766	\N
6866	453	0	0	32782	\N
24033	453	3	0	32792	\N
24526	3366	3	0	32816	\N
24813	2364	6	0	32832	\N
18008	4108	5	0	32840	\N
18151	453	16	0	32858	\N
18420	2838	4	0	32872	\N
18515	453	5	0	32878	\N
25433	4108	5	0	32882	\N
25701	3366	3	0	32896	\N
26096	7431	92	0	32899	\N
9784	453	2	0	32900	\N
26478	453	4	0	32918	\N
26981	453	7	0	32925	\N
27517	2838	4	0	32938	\N
27683	6896	79	0	32948	\N
28158	453	7	0	32965	\N
29905	453	9	0	32975	\N
8731	1991	3	0	32977	\N
91	112	3	0	32993	\N
84	48	4	0	32995	\N
226	1	1	0	33006	\N
274	53	2	0	33013	\N
354	48	4	0	33031	\N
600	1	1	0	33062	\N
625	112	3	0	33075	\N
661	1	4	0	33081	\N
749	53	2	0	33097	\N
828	1	1	0	33105	\N
917	1	4	0	33124	\N
964	1	2	0	33145	\N
10593	112	3	0	33156	\N
10615	112	3	0	33159	\N
1057	548	18	0	33177	\N
10671	1	6	0	33179	\N
1069	53	2	0	33183	\N
1147	1	1	0	33202	\N
10846	1	2	0	33221	\N
1260	1	1	0	33247	\N
11071	1	2	0	33258	\N
1358	1	1	0	33283	\N
11241	2723	7	0	33293	\N
1407	1	2	0	33296	\N
11256	1	0	0	33306	\N
11421	2814	5	0	33335	\N
1589	53	2	0	33355	\N
11543	283	3	0	33364	\N
11579	1085	2	0	33373	\N
1621	53	2	0	33382	\N
1722	422	5	0	33388	\N
11623	1	3	0	33402	\N
11675	1085	2	0	33411	\N
1917	53	2	0	33414	\N
2016	48	4	0	33446	\N
11876	1085	2	0	33458	\N
11922	1085	2	0	33462	\N
2198	53	2	0	33489	\N
2375	53	2	0	33507	\N
12134	1	3	0	33514	\N
2473	53	2	0	33522	\N
12163	1	5	0	33529	\N
2625	53	2	0	33557	\N
12296	1	4	0	33577	\N
2730	1	1	0	33587	\N
2772	53	2	0	33600	\N
12519	1	2	0	33642	\N
12566	283	3	0	33651	\N
12571	1	2	0	33654	\N
3009	1	0	0	33667	\N
3047	1	2	0	33671	\N
12748	2382	6	0	33699	\N
3098	1	1	0	33701	\N
3100	1	1	0	33702	\N
12805	283	3	0	33727	\N
12844	283	3	0	33735	\N
12912	3432	9	0	33742	\N
3279	112	3	0	33760	\N
3393	1	1	0	33779	\N
13091	1	1	0	33783	\N
13146	1336	8	0	33795	\N
3444	1	2	0	33799	\N
13227	1	0	0	33819	\N
13266	1	0	0	33824	\N
3605	1	0	0	33828	\N
13363	1	1	0	33836	\N
3701	1	4	0	33857	\N
13478	1	1	0	33860	\N
3763	1	1	0	33867	\N
13856	1	8	0	33907	\N
13867	1	8	0	33922	\N
3871	53	2	0	33930	\N
3894	1	2	0	33946	\N
14117	1	4	0	33956	\N
3953	53	2	0	33974	\N
14208	3820	5	0	33976	\N
4043	53	2	0	33992	\N
14322	1	7	0	34011	\N
14336	1	4	0	34017	\N
4085	1	1	0	34025	\N
4271	1	1	0	34050	\N
4281	1	1	0	34054	\N
4299	1	2	0	34058	\N
4309	1	1	0	34063	\N
4408	968	11	0	34087	\N
4576	1	2	0	34112	\N
4634	1	1	0	34120	\N
4810	1	1	0	34139	\N
4824	1	2	0	34143	\N
4959	1	1	0	34152	\N
5859	1	0	0	34164	\N
5876	1	1	0	34168	\N
4976	48	4	0	34173	\N
5959	1	5	0	34177	\N
6007	1	2	0	34185	\N
6013	53	2	0	34190	\N
6028	48	4	0	34195	\N
6375	1	1	0	34230	\N
6404	1	4	0	34234	\N
6586	1	5	0	34252	\N
6721	1	4	0	34270	\N
7103	1	2	0	34304	\N
7218	53	2	0	34327	\N
7320	1	1	0	34342	\N
7337	1	5	0	34345	\N
7324	53	2	0	34349	\N
7497	1	1	0	34372	\N
7806	1	1	0	34394	\N
7989	1	2	0	34421	\N
8053	53	2	0	34428	\N
8033	1871	13	0	34429	\N
8175	112	3	0	34441	\N
8380	1942	5	0	34465	\N
8408	53	2	0	34467	\N
8450	711	4	0	34477	\N
8696	53	2	0	34502	\N
8908	1	2	0	34524	\N
8954	1	4	0	34526	\N
8997	523	7	0	34545	\N
9036	112	3	0	34557	\N
9118	422	5	0	34560	\N
9150	422	5	0	34569	\N
9383	1	2	0	34590	\N
9395	1	4	0	34592	\N
9397	1	2	0	34594	\N
9518	112	3	0	34617	\N
9960	1	0	0	34634	\N
9757	112	3	0	34655	\N
9902	1	2	0	34670	\N
10027	1	3	0	34692	\N
10052	112	3	0	34705	\N
10147	1	2	0	34714	\N
10227	1	1	0	34723	\N
10292	1	3	0	34736	\N
10296	112	3	0	34741	\N
10366	1	4	0	34744	\N
685	431	1	0	34754	\N
1431	432	2	0	34759	\N
6870	431	3	0	34777	\N
11626	431	2	0	34804	\N
11996	3096	2	0	34809	\N
13834	431	3	0	34814	\N
17214	3933	4	0	34833	\N
19171	3933	4	0	34843	\N
153	26	2	0	34894	\N
26113	2789	3	0	34898	\N
20954	3548	4	0	34921	\N
350	2	1	0	34922	\N
379	2	4	0	34924	\N
21478	2	4	0	34966	\N
22009	2	4	0	34992	\N
26694	2	4	0	35008	\N
22065	2	3	0	35013	\N
16051	2	3	0	35021	\N
27032	2	3	0	35041	\N
1153	572	4	0	35052	\N
16424	4825	7	0	35054	\N
16592	3548	4	0	35067	\N
1817	2	4	0	35100	\N
2214	26	2	0	35140	\N
1969	131	3	0	35141	\N
17516	2789	3	0	35145	\N
11110	2	3	0	35151	\N
10791	1566	7	0	35156	\N
22567	3541	13	0	35168	\N
11411	2	3	0	35177	\N
2349	131	3	0	35190	\N
17935	3548	4	0	35193	\N
28631	2	2	0	35251	\N
28699	3510	5	0	35268	\N
23146	3548	4	0	35276	\N
2836	2	4	0	35279	\N
19372	2	3	0	35287	\N
19560	2	2	0	35301	\N
3119	26	2	0	35318	\N
12119	2	2	0	35335	\N
12173	3129	4	0	35339	\N
29333	2	3	0	35340	\N
29338	3510	5	0	35343	\N
24286	2	0	0	35391	\N
20284	3129	8	0	35409	\N
20414	2	10	0	35436	\N
24145	2789	3	0	35440	\N
3546	2	0	0	35445	\N
29848	2	38	0	35459	\N
13800	3914	6	0	35474	\N
24720	7136	9	0	35488	\N
14081	2	0	0	35495	\N
14305	2	7	0	35498	\N
4453	2	2	0	35543	\N
14912	3510	5	0	35549	\N
25337	2	3	0	35550	\N
4808	2	1	0	35578	\N
25825	2	3	0	35583	\N
15474	2	2	0	35600	\N
15497	2	6	0	35601	\N
5416	2	1	0	35639	\N
5535	2	0	0	35642	\N
6337	26	2	0	35655	\N
6816	2	4	0	35674	\N
6752	131	3	0	35675	\N
6758	131	3	0	35676	\N
7035	315	5	0	35689	\N
7711	26	2	0	35709	\N
7781	26	2	0	35713	\N
8390	1911	3	0	35741	\N
8766	131	3	0	35749	\N
8915	2	1	0	35755	\N
9137	2114	4	0	35765	\N
9157	131	3	0	35769	\N
9501	131	3	0	35787	\N
9763	2	3	0	35796	\N
9893	2	1	0	35806	\N
10343	131	3	0	35825	\N
20677	4	9	0	35841	\N
284	4	1	0	35867	\N
1125	567	28	0	35873	\N
14854	1538	3	0	35930	\N
22786	4117	5	0	35936	\N
23183	4	13	0	35948	\N
23456	3837	4	0	35960	\N
16080	3837	4	0	35997	\N
16058	4716	8	0	36000	\N
3410	579	3	0	36026	\N
26630	7548	5	0	36051	\N
18689	4	0	0	36074	\N
27210	4	3	0	36077	\N
28069	4117	5	0	36090	\N
20348	4	3	0	36128	\N
29222	2751	3	0	36134	\N
30129	7548	10	0	36160	\N
8310	1694	9	0	36175	\N
8308	1918	4	0	36176	\N
11282	6	5	0	36215	\N
11399	6	2	0	36224	\N
21865	6	4	0	36253	\N
22326	6	7	0	36262	\N
13066	6	4	0	36283	\N
2640	194	2	0	36288	\N
15118	6	2	0	36297	\N
23404	6	8	0	36299	\N
23933	6	4	0	36310	\N
2844	194	2	0	36312	\N
3435	6	0	0	36321	\N
25190	6	6	0	36326	\N
3632	6	2	0	36328	\N
18423	6	4	0	36332	\N
3988	6	1	0	36339	\N
19812	2805	3	0	36367	\N
26643	7553	5	0	36369	\N
5254	6	0	0	36370	\N
19996	6	3	0	36371	\N
26988	4823	4	0	36378	\N
20316	1101	3	0	36392	\N
30091	7553	10	0	36401	\N
6127	194	2	0	36415	\N
7112	670	5	0	36420	\N
9723	2261	46	0	36432	\N
13	8	0	0	36436	1000000000
28	8	2	0	36437	1000000000
4040	739	4	0	36475	\N
33	11	2	0	36502	\N
148	10	1	0	36520	\N
175	10	1	0	36527	\N
282	11	2	0	36548	\N
344	297	4	0	36568	\N
415	10	2	0	36584	\N
441	10	3	0	36585	\N
494	11	2	0	36597	\N
558	11	2	0	36611	\N
595	11	2	0	36621	\N
663	10	1	0	36646	\N
10463	10	5	0	36652	\N
10575	10	3	0	36669	\N
704	29	3	0	36675	\N
10591	600	5	0	36683	\N
745	10	1	0	36694	\N
823	10	2	0	36704	\N
10680	10	2	0	36714	\N
879	29	3	0	36726	\N
897	10	1	0	36729	\N
10708	29	3	0	36732	\N
934	11	2	0	36758	\N
986	10	1	0	36775	\N
10877	10	5	0	36785	\N
10899	11	2	0	36794	\N
1106	10	1	0	36806	\N
11062	10	4	0	36834	\N
11016	2669	14	0	36839	\N
1182	11	2	0	36842	\N
1235	10	1	0	36872	\N
11211	10	3	0	36876	\N
11226	10	2	0	36877	\N
1309	10	0	0	36896	\N
1368	10	1	0	36919	\N
11350	10	2	0	36923	\N
11418	275	3	0	36941	\N
11542	275	3	0	36967	\N
11560	10	2	0	36970	\N
1494	11	2	0	36973	\N
11578	10	2	0	36975	\N
11564	1416	2	0	36976	\N
11582	10	0	0	36980	\N
1521	29	3	0	36991	\N
1535	10	1	0	36999	\N
1592	10	1	0	37022	\N
11732	1416	2	0	37034	\N
1729	11	2	0	37055	\N
11821	10	2	0	37068	\N
1882	11	2	0	37089	\N
1906	11	2	0	37098	\N
11872	2917	4	0	37103	\N
1950	10	1	0	37107	\N
1998	11	2	0	37131	\N
2048	10	1	0	37145	\N
11958	10	1	0	37148	\N
2096	29	3	0	37173	\N
2105	10	1	0	37180	\N
2285	11	2	0	37217	\N
2232	29	3	0	37218	\N
12193	10	1	0	37226	\N
12191	2917	4	0	37228	\N
12210	10	3	0	37243	\N
2414	10	1	0	37251	\N
2422	11	2	0	37256	\N
2431	11	2	0	37262	\N
12280	1416	2	0	37268	\N
12293	3169	3	0	37273	\N
12410	10	1	0	37300	\N
2839	10	0	0	37349	\N
12555	2718	7	0	37358	\N
3029	11	2	0	37372	\N
12574	275	3	0	37374	\N
3071	10	1	0	37382	\N
3139	10	4	0	37400	\N
12679	10	2	0	37414	\N
12688	10	2	0	37415	\N
12810	10	0	0	37456	\N
3305	10	5	0	37468	\N
12853	275	3	0	37471	\N
12914	275	3	0	37487	\N
12923	275	3	0	37497	\N
13069	10	8	0	37520	\N
13090	3173	4	0	37534	\N
13189	10	9	0	37549	\N
13210	10	7	0	37558	\N
3586	10	0	0	37572	\N
13376	10	4	0	37576	\N
13393	10	7	0	37584	\N
3697	10	1	0	37592	\N
3729	11	2	0	37602	\N
13505	3173	4	0	37620	\N
3820	10	1	0	37635	\N
13531	3173	4	0	37640	\N
3976	10	1	0	37671	\N
13646	10	3	0	37685	\N
13708	10	4	0	37693	\N
4066	11	2	0	37707	\N
4102	10	2	0	37713	\N
13757	3889	9	0	37728	\N
4132	10	1	0	37729	\N
13776	10	16	0	37740	\N
13819	10	1	0	37748	\N
4221	11	2	0	37756	\N
4266	10	1	0	37771	\N
13998	3493	5	0	37791	\N
4411	10	10	0	37835	\N
4440	11	2	0	37842	\N
14210	10	4	0	37847	\N
4502	10	2	0	37857	\N
4609	29	3	0	37887	\N
14318	3173	4	0	37890	\N
4629	10	1	0	37893	\N
4728	29	3	0	37918	\N
4912	10	1	0	37949	\N
4983	10	1	0	37963	\N
5014	10	1	0	37971	\N
5019	10	2	0	37973	\N
5139	792	3	0	38006	\N
5171	11	2	0	38009	\N
5221	10	2	0	38014	\N
5247	11	2	0	38020	\N
5288	10	2	0	38029	\N
5358	11	2	0	38044	\N
5496	10	0	0	38063	\N
5539	1239	2	0	38070	\N
5753	347	4	0	38089	\N
5763	347	4	0	38093	\N
5833	10	1	0	38098	\N
6011	10	1	0	38123	\N
6115	11	2	0	38144	\N
6151	11	2	0	38156	\N
6176	11	2	0	38159	\N
6202	1519	12	0	38167	\N
6214	1522	5	0	38170	\N
6327	11	2	0	38181	\N
6424	29	3	0	38203	\N
6590	29	3	0	38235	\N
6603	10	4	0	38239	\N
6677	10	2	0	38251	\N
6769	10	4	0	38277	\N
6862	600	5	0	38292	\N
6865	1298	6	0	38296	\N
6969	11	2	0	38309	\N
7016	10	4	0	38317	\N
7152	29	3	0	38332	\N
7203	10	2	0	38341	\N
7284	10	2	0	38350	\N
7474	10	2	0	38384	\N
7510	1798	5	0	38399	\N
7583	10	1	0	38413	\N
7678	10	1	0	38434	\N
7682	11	2	0	38442	\N
7731	11	2	0	38446	\N
7732	11	2	0	38447	\N
7846	10	1	0	38461	\N
7852	347	4	0	38470	\N
7888	10	1	0	38478	\N
7948	11	2	0	38485	\N
7997	11	2	0	38503	\N
8065	10	2	0	38517	\N
8125	11	2	0	38531	\N
8155	11	2	0	38535	\N
8215	11	2	0	38549	\N
8311	10	1	0	38566	\N
8411	10	3	0	38581	\N
8493	10	1	0	38591	\N
8547	29	3	0	38605	\N
8596	10	1	0	38620	\N
8644	10	2	0	38625	\N
8653	29	3	0	38631	\N
8734	29	3	0	38639	\N
8742	29	3	0	38646	\N
8907	10	4	0	38680	\N
8952	10	2	0	38694	\N
8998	10	6	0	38700	\N
9046	10	4	0	38708	\N
9072	1298	6	0	38711	\N
9220	29	3	0	38745	\N
9243	347	4	0	38752	\N
9251	2145	26	0	38756	\N
9263	10	15	0	38757	\N
9389	10	4	0	38774	\N
9407	29	3	0	38781	\N
9466	600	5	0	38791	\N
9654	10	3	0	38818	\N
9685	10	2	0	38827	\N
9695	10	3	0	38829	\N
9790	1772	9	0	38851	\N
9860	10	2	0	38861	\N
9934	10	4	0	38878	\N
10002	10	2	0	38882	\N
10011	10	3	0	38889	\N
10076	2274	8	0	38908	\N
10109	10	3	0	38913	\N
10282	10	11	0	38927	\N
10352	10	4	0	38943	\N
10383	792	3	0	38948	\N
10411	10	2	0	38951	\N
589	14	1	0	38984	\N
10155	14	4	0	38998	\N
1217	15	2	0	39006	\N
21054	2291	5	0	39024	\N
11395	1785	3	0	39031	\N
1604	14	2	0	39034	\N
11447	14	1	0	39039	\N
12276	14	0	0	39082	\N
2761	383	2	0	39093	\N
22371	14	1	0	39094	\N
3190	588	5	0	39121	\N
22497	14	4	0	39123	\N
13899	3966	32	0	39134	\N
23133	14	10	0	39141	\N
23134	6755	11	0	39145	\N
3337	14	3	0	39149	\N
14594	14	3	0	39158	\N
3481	14	0	0	39164	\N
14754	1785	3	0	39176	\N
15626	4272	4	0	39178	\N
15556	4565	7	0	39180	\N
3882	15	2	0	39208	\N
3785	14	3	0	39211	\N
4001	15	2	0	39240	\N
17209	4272	4	0	39245	\N
4232	14	5	0	39261	\N
17296	14	9	0	39263	\N
24542	14	4	0	39273	\N
17667	1785	3	0	39287	\N
24745	14	8	0	39294	\N
4504	14	1	0	39300	\N
4580	15	2	0	39304	\N
18670	2291	5	0	39308	\N
18728	14	2	0	39338	\N
25892	14	2	0	39355	\N
26037	14	4	0	39365	\N
5418	1421	3	0	39380	\N
19595	14	3	0	39385	\N
5881	14	1	0	39394	\N
6261	14	1	0	39418	\N
7419	14	3	0	39437	\N
7267	15	2	0	39440	\N
28025	6277	7	0	39470	\N
8262	1901	7	0	39474	\N
28253	1785	3	0	39480	\N
29118	14	126	0	39506	\N
30009	14	9	0	39551	\N
30042	8059	22	0	39556	\N
12	18	1	0	39583	1000000000
101	127	4	0	39592	\N
215	218	3	0	39594	\N
308	18	1	0	39595	\N
434	18	2	0	39605	\N
395	19	2	0	39607	\N
969	19	2	0	39629	\N
15827	4656	21	0	39631	\N
1194	218	3	0	39640	\N
1325	18	3	0	39642	\N
1693	18	2	0	39660	\N
2027	19	2	0	39685	\N
2621	18	1	0	39698	\N
3040	18	1	0	39704	\N
4658	19	2	0	39743	\N
4786	18	1	0	39746	\N
4324	1222	3	0	39753	\N
4901	19	2	0	39759	\N
5960	18	1	0	39784	\N
6435	218	3	0	39806	\N
7242	18	0	0	39818	\N
7990	218	3	0	39852	\N
8100	18	2	0	39856	\N
8341	19	2	0	39865	\N
8797	18	2	0	39875	\N
8820	18	3	0	39876	\N
8857	18	2	0	39877	\N
9269	2156	12	0	39897	\N
9354	18	2	0	39898	\N
9418	18	4	0	39902	\N
9588	18	2	0	39913	\N
9798	127	4	0	39927	\N
10138	2423	7	0	39946	\N
13148	18	5	0	39968	\N
13274	1685	3	0	39982	\N
14157	3621	4	0	40024	\N
14328	18	4	0	40033	\N
14381	218	12	0	40036	\N
14868	18	2	0	40053	\N
14893	4404	10	0	40057	\N
15079	18	5	0	40065	\N
15633	3621	4	0	40085	\N
15663	18	3	0	40088	\N
15906	4180	6	0	40101	\N
16063	18	4	0	40105	\N
16265	18	3	0	40121	\N
16300	3621	4	0	40124	\N
16506	3621	4	0	40137	\N
16869	4730	14	0	40154	\N
16941	3621	4	0	40163	\N
17340	3621	4	0	40173	\N
18093	18	3	0	40200	\N
18140	1685	3	0	40208	\N
18337	3550	6	0	40215	\N
18628	18	5	0	40224	\N
18844	19	2	0	40241	\N
19785	18	8	0	40266	\N
19943	18	3	0	40270	\N
20303	3621	4	0	40285	\N
20418	4010	6	0	40289	\N
20631	18	12	0	40291	\N
20864	18	5	0	40297	\N
21064	18	6	0	40303	\N
21049	3621	4	0	40305	\N
21191	18	8	0	40309	\N
21453	6300	19	0	40332	\N
22370	1618	8	0	40338	\N
21493	18	1	0	40339	\N
22761	3779	4	0	40357	\N
23244	18	6	0	40375	\N
24361	1685	3	0	40402	\N
25279	18	6	0	40450	\N
25359	18	4	0	40454	\N
25420	18	5	0	40456	\N
25440	18	3	0	40459	\N
25509	3621	4	0	40464	\N
25725	3621	4	0	40480	\N
26163	3621	4	0	40499	\N
26511	18	11	0	40504	\N
27081	18	3	0	40520	\N
27459	18	9	0	40537	\N
27459	7719	10	0	40538	\N
27628	2302	5	0	40550	\N
28788	18	2	0	40587	\N
29598	18	2	0	40600	\N
30131	3621	4	0	40623	\N
4395	650	6	0	40691	\N
13244	23	4	0	40712	\N
6918	23	2	0	40734	\N
21923	23	21	0	40740	\N
7625	24	3	0	40751	\N
9019	23	2	0	40786	\N
22749	23	3	0	40791	\N
22904	23	4	0	40793	\N
9268	23	9	0	40804	\N
23128	23	5	0	40806	\N
16909	23	7	0	40833	\N
17525	23	8	0	40861	\N
9817	23	12	0	40863	\N
17898	3190	18	0	40890	\N
28310	23	5	0	40909	\N
21382	4146	8	0	40932	\N
30278	23	8	0	40937	\N
496	28	2	0	40951	\N
1043	28	2	0	40959	\N
6256	27	4	0	40962	\N
1584	28	2	0	40969	\N
23472	27	4	0	40972	\N
23565	27	4	0	40973	\N
13337	27	12	0	40979	\N
1751	27	1	0	40984	\N
1864	28	2	0	40987	\N
6462	27	4	0	40988	\N
6551	619	3	0	40993	\N
6663	1270	4	0	40994	\N
6681	619	2	0	40999	\N
24456	4636	4	0	41064	\N
13707	27	2	0	41074	\N
13986	3717	5	0	41090	\N
10369	27	6	0	41124	\N
25530	27	9	0	41130	\N
14576	645	3	0	41155	\N
26257	27	3	0	41179	\N
27533	27	3	0	41182	\N
4487	28	2	0	41201	\N
27816	27	3	0	41206	\N
27869	27	3	0	41227	\N
28433	27	3	0	41230	\N
27649	7764	0	0	41235	\N
12257	2885	2	0	41265	\N
20867	6166	87	0	41285	\N
29890	3302	7	0	41299	\N
564	40	1	0	41369	\N
20891	40	3	0	41378	\N
959	40	6	0	41389	\N
20988	282	3	0	41398	\N
26121	282	3	0	41426	\N
21117	282	3	0	41444	\N
26218	40	6	0	41447	\N
21121	372	4	0	41450	\N
26589	40	6	0	41507	\N
1447	40	1	0	41515	\N
21719	40	3	0	41545	\N
26800	40	3	0	41554	\N
26842	372	4	0	41567	\N
26858	372	4	0	41577	\N
22219	40	0	0	41585	\N
22220	40	0	0	41586	\N
26953	40	4	0	41602	\N
21960	40	3	0	41607	\N
2072	40	2	0	41609	\N
21964	372	4	0	41614	\N
27113	372	4	0	41621	\N
27185	372	4	0	41640	\N
2197	40	1	0	41660	\N
27293	282	3	0	41668	\N
27228	4255	7	0	41672	\N
15823	2314	7	0	41673	\N
10584	66	2	0	41683	\N
10500	569	12	0	41684	\N
22207	3381	5	0	41686	\N
2205	66	3	0	41688	\N
10555	2557	10	0	41703	\N
2222	41	2	0	41708	\N
15941	372	4	0	41726	\N
10683	40	2	0	41761	\N
10925	66	2	0	41765	\N
11160	40	0	0	41789	\N
2336	40	5	0	41799	\N
10963	66	3	0	41806	\N
18014	4718	8	0	41818	\N
18159	40	7	0	41829	\N
18202	2777	7	0	41855	\N
2373	41	2	0	41857	\N
27856	4255	7	0	41860	\N
2392	41	2	0	41885	\N
18308	5384	20	0	41886	\N
16365	4813	12	0	41896	\N
16492	40	4	0	41911	\N
16524	40	4	0	41913	\N
3160	40	1	0	41932	\N
22686	40	4	0	41945	\N
16575	3381	5	0	41961	\N
11209	66	3	0	41963	\N
22911	372	4	0	41971	\N
3299	40	2	0	41978	\N
16630	372	4	0	41987	\N
18551	4104	11	0	41997	\N
3327	66	3	0	42002	\N
16679	372	4	0	42010	\N
18622	40	2	0	42030	\N
28196	40	2	0	42037	\N
23170	40	3	0	42046	\N
3608	40	0	0	42057	\N
17059	372	4	0	42106	\N
23379	40	2	0	42110	\N
23391	3566	11	0	42115	\N
3751	41	2	0	42119	\N
11445	41	2	0	42132	\N
11451	2796	5	0	42133	\N
18701	2796	5	0	42139	\N
3755	41	2	0	42141	\N
28402	2796	5	0	42144	\N
17195	3381	5	0	42146	\N
17981	4255	7	0	42148	\N
23526	40	0	0	42151	\N
18716	282	3	0	42153	\N
3784	40	3	0	42154	\N
28467	282	3	0	42157	\N
28410	1921	4	0	42158	\N
11527	40	5	0	42165	\N
27577	75	23	0	45268	\N
3351	75	1	0	45440	\N
18473	75	3	0	45468	\N
11412	75	2	0	45654	\N
21038	75	2	0	45750	\N
21460	75	3	0	45796	\N
21961	75	3	0	45835	\N
22308	75	3	0	45879	\N
23422	75	6	0	45928	\N
69	79	1	0	46061	1000000000
27572	79	6	0	46074	\N
27923	79	2	0	46295	\N
27957	79	3	0	46347	\N
28297	79	5	0	46508	\N
2656	79	1	0	46582	\N
22302	79	3	0	46758	\N
29084	79	3	0	46818	\N
188	137	2	0	49657	1000000000
932	147	2	0	49939	1000000000
1927	285	3	0	53354	1000000000
1270	597	1	0	55826	1000000000
2503	852	4	0	57174	1000000000
12770	1587	2	0	58432	1000000000
11791	3004	2	0	59463	1000000000
29869	3628	10	0	59753	\N
14983	4233	1	0	59947	1000000000
20824	6044	3	0	60609	1000000000
29750	8190	6	0	60699	\N
30122	8497	24	0	60902	\N
30256	8603	22	1	61280	\N
29904	8269	11	0	61327	\N
29956	8378	12	1	61336	\N
30083	8195	12	0	61352	\N
30190	8298	23	1	61362	\N
29557	7745	3	0	61386	1000000000
30207	8500	125	0	61406	\N
30213	8500	37	0	61411	\N
\.


--
-- Data for Name: blocks_user_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.blocks_user_commands (block_id, user_command_id, sequence_no, status, failure_reason, fee_payer_account_creation_fee_paid, receiver_account_creation_fee_paid, created_token, fee_payer_balance, source_balance, receiver_balance) FROM stdin;
3	3	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	61416	61416	\N
3	4	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	61417	61417	\N
4	5	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61418	61418	\N
4	6	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	61419	61419	\N
5	7	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61420	61420	\N
5	8	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	61421	61421	\N
5	9	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	61422	61422	\N
7	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61424	61424	\N
8	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61425	61425	\N
9	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61426	61426	\N
10	11	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61427	61427	\N
11	11	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61428	61428	\N
12	12	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61429	61429	\N
18	14	1	applied	\N	\N	\N	\N	61431	61431	61431
19	15	0	applied	\N	\N	\N	\N	61432	61432	61432
20	15	0	applied	\N	\N	\N	\N	61433	61433	61433
21	15	0	applied	\N	\N	\N	\N	61434	61434	61434
22	16	0	applied	\N	\N	\N	\N	61435	61435	229621
22	17	1	applied	\N	\N	\N	\N	61436	61436	61436
23	16	0	applied	\N	\N	\N	\N	61437	61437	229622
23	17	1	applied	\N	\N	\N	\N	61438	61438	61438
24	18	0	applied	\N	\N	\N	\N	61439	61439	61439
24	19	1	applied	\N	\N	\N	\N	61440	61440	229623
24	20	2	applied	\N	\N	\N	\N	61441	61441	229624
25	21	0	applied	\N	\N	\N	\N	61442	61442	229625
25	22	1	applied	\N	\N	\N	\N	61443	61443	229626
26	21	0	applied	\N	\N	\N	\N	61444	61444	229627
26	22	1	applied	\N	\N	\N	\N	61445	61445	229628
27	23	0	applied	\N	\N	\N	\N	61446	61446	229629
28	24	0	applied	\N	\N	\N	\N	61447	61447	229630
28	25	1	applied	\N	\N	\N	\N	61448	61448	229631
29	24	0	applied	\N	\N	\N	\N	61449	61449	229632
29	25	1	applied	\N	\N	\N	\N	61450	61450	229633
30	26	0	applied	\N	\N	\N	\N	61451	61451	229634
31	26	0	applied	\N	\N	\N	\N	61452	61452	229635
32	27	0	applied	\N	\N	\N	\N	61453	61453	229636
33	28	0	applied	\N	\N	\N	\N	61454	61454	229637
34	28	0	applied	\N	\N	\N	\N	61455	61455	229638
36	30	0	applied	\N	\N	\N	\N	61457	61457	229640
37	31	0	applied	\N	\N	\N	\N	61458	61458	229641
37	32	1	applied	\N	\N	\N	\N	61459	61459	229642
37	33	2	applied	\N	\N	\N	\N	61460	61460	229643
38	34	0	applied	\N	\N	\N	\N	61461	61461	229644
38	35	1	applied	\N	\N	\N	\N	61462	61462	229645
38	36	2	applied	\N	\N	\N	\N	61463	61463	229646
39	37	0	applied	\N	\N	\N	\N	61464	61464	229647
40	37	0	applied	\N	\N	\N	\N	61465	61465	229648
41	38	0	applied	\N	\N	\N	\N	61466	61466	229649
42	38	0	applied	\N	\N	\N	\N	61467	61467	229650
43	38	0	applied	\N	\N	\N	\N	61468	61468	229651
44	39	0	applied	\N	\N	\N	\N	61469	61469	229652
45	39	0	applied	\N	\N	\N	\N	61470	61470	229653
46	39	0	applied	\N	\N	\N	\N	61471	61471	229654
47	39	0	applied	\N	\N	\N	\N	61472	61472	229655
49	40	0	applied	\N	\N	\N	\N	61474	61474	229657
50	40	0	applied	\N	\N	\N	\N	61475	61475	229658
51	41	0	applied	\N	\N	\N	\N	61476	61476	229659
52	42	0	applied	\N	\N	\N	\N	61477	61477	229660
53	42	0	applied	\N	\N	\N	\N	61478	61478	229661
54	43	0	applied	\N	\N	\N	\N	61479	61479	229662
54	44	1	applied	\N	\N	\N	\N	61480	61480	229663
55	43	0	applied	\N	\N	\N	\N	61481	61481	229664
55	44	1	applied	\N	\N	\N	\N	61482	61482	229665
56	45	0	applied	\N	\N	\N	\N	61483	61483	229666
57	46	0	applied	\N	\N	\N	\N	61484	61484	229667
58	46	0	applied	\N	\N	\N	\N	61485	61485	229668
59	47	0	applied	\N	\N	\N	\N	61486	61486	229669
60	48	0	applied	\N	\N	\N	\N	61487	61487	229670
61	48	0	applied	\N	\N	\N	\N	61488	61488	229671
62	48	0	applied	\N	\N	\N	\N	61489	61489	229672
64	49	0	applied	\N	\N	\N	\N	61491	61491	229674
65	49	0	applied	\N	\N	\N	\N	61492	61492	229675
66	50	0	applied	\N	\N	\N	\N	61493	61493	229676
67	51	0	applied	\N	\N	\N	\N	61494	61494	229677
67	52	1	applied	\N	\N	\N	\N	61495	61495	229678
68	51	0	applied	\N	\N	\N	\N	61496	61496	229679
68	52	1	applied	\N	\N	\N	\N	61497	61497	229680
69	53	0	applied	\N	\N	\N	\N	61498	61498	229681
70	54	0	applied	\N	\N	\N	\N	61499	61499	229682
71	55	0	applied	\N	\N	\N	\N	61500	61500	229683
72	55	0	applied	\N	\N	\N	\N	61501	61501	229684
73	56	0	applied	\N	\N	\N	\N	61502	61502	229685
74	57	0	applied	\N	\N	\N	\N	61503	61503	229686
75	58	0	applied	\N	\N	\N	\N	61504	61504	229687
76	59	0	applied	\N	\N	\N	\N	61505	61505	229688
76	60	1	applied	\N	\N	\N	\N	61506	61506	229689
77	62	1	applied	\N	\N	\N	\N	61508	61508	229691
78	61	0	applied	\N	\N	\N	\N	61509	61509	229692
78	62	1	applied	\N	\N	\N	\N	61510	61510	229693
79	63	0	applied	\N	\N	\N	\N	61511	61511	229694
80	64	0	applied	\N	\N	\N	\N	61512	61512	229695
81	65	0	applied	\N	\N	\N	\N	61513	61513	229696
81	66	1	applied	\N	\N	\N	\N	61514	61514	229697
82	67	0	applied	\N	\N	\N	\N	61515	61515	229698
83	68	0	applied	\N	\N	\N	\N	61516	61516	229699
84	69	0	applied	\N	\N	\N	\N	61517	61517	229700
84	70	1	applied	\N	\N	\N	\N	61518	61518	229701
84	71	2	applied	\N	\N	\N	\N	61519	61519	229702
85	69	0	applied	\N	\N	\N	\N	61520	61520	229703
85	70	1	applied	\N	\N	\N	\N	61521	61521	229704
85	71	2	applied	\N	\N	\N	\N	61522	61522	229705
86	72	0	applied	\N	\N	\N	\N	61523	61523	229706
87	74	0	applied	\N	\N	\N	\N	61525	61525	229708
18	13	0	applied	\N	\N	1000000000	\N	61430	61430	229620
3	2	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	61415	61415	\N
90	78	0	applied	\N	\N	1000000000	\N	61529	61529	229712
90	79	1	applied	\N	\N	\N	\N	61530	61530	229713
91	78	0	applied	\N	\N	1000000000	\N	61531	61531	229714
91	79	1	applied	\N	\N	\N	\N	61532	61532	229715
92	78	0	applied	\N	\N	1000000000	\N	61533	61533	229716
92	79	1	applied	\N	\N	\N	\N	61534	61534	229717
93	80	0	applied	\N	\N	\N	\N	61535	61535	229718
94	81	0	applied	\N	\N	\N	\N	61536	61536	229719
94	82	1	applied	\N	\N	\N	\N	61537	61537	229720
94	83	2	applied	\N	\N	\N	\N	61538	61538	229721
95	84	0	applied	\N	\N	\N	\N	61539	61539	229722
97	84	0	applied	\N	\N	\N	\N	61541	61541	229724
98	84	0	applied	\N	\N	\N	\N	61542	61542	229725
99	85	0	applied	\N	\N	\N	\N	61543	61543	229726
100	86	0	applied	\N	\N	\N	\N	61544	61544	229727
100	87	1	applied	\N	\N	\N	\N	61545	61545	229728
100	88	2	applied	\N	\N	\N	\N	61546	61546	229729
101	86	0	applied	\N	\N	\N	\N	61547	61547	229730
101	87	1	applied	\N	\N	\N	\N	61548	61548	229731
101	88	2	applied	\N	\N	\N	\N	61549	61549	229732
102	89	0	applied	\N	\N	\N	\N	61550	61550	229733
102	90	1	applied	\N	\N	\N	\N	61551	61551	229734
102	91	2	applied	\N	\N	\N	\N	61552	61552	229735
103	89	0	applied	\N	\N	\N	\N	61553	61553	229736
103	90	1	applied	\N	\N	\N	\N	61554	61554	229737
103	91	2	applied	\N	\N	\N	\N	61555	61555	229738
104	89	0	applied	\N	\N	\N	\N	61556	61556	229739
104	91	2	applied	\N	\N	\N	\N	61558	61558	229741
105	92	0	applied	\N	\N	\N	\N	61559	61559	229742
106	93	0	applied	\N	\N	\N	\N	61560	61560	229743
106	94	1	applied	\N	\N	\N	\N	61561	61561	229744
107	95	0	applied	\N	\N	\N	\N	61562	61562	229745
107	96	1	applied	\N	\N	\N	\N	61563	61563	229746
108	95	0	applied	\N	\N	\N	\N	61564	61564	229747
108	96	1	applied	\N	\N	\N	\N	61565	61565	229748
109	95	0	applied	\N	\N	\N	\N	61566	61566	229749
109	96	1	applied	\N	\N	\N	\N	61567	61567	229750
110	97	0	applied	\N	\N	\N	\N	61568	61568	229751
111	97	0	applied	\N	\N	\N	\N	61569	61569	229752
112	98	0	applied	\N	\N	\N	\N	61570	61570	229753
113	98	0	applied	\N	\N	\N	\N	61571	61571	229754
114	98	0	applied	\N	\N	\N	\N	61572	61572	229755
115	98	0	applied	\N	\N	\N	\N	61573	61573	229756
116	100	1	applied	\N	\N	\N	\N	61575	61575	229758
116	101	2	applied	\N	\N	\N	\N	61576	61576	229759
116	102	3	applied	\N	\N	\N	\N	61577	61577	229760
117	103	0	applied	\N	\N	\N	\N	61578	61578	229761
118	103	0	applied	\N	\N	\N	\N	61579	61579	229762
119	104	0	applied	\N	\N	\N	\N	61580	61580	229763
120	104	0	applied	\N	\N	\N	\N	61581	61581	229764
121	105	0	applied	\N	\N	\N	\N	61582	61582	229765
122	105	0	applied	\N	\N	\N	\N	61583	61583	229766
123	105	0	applied	\N	\N	\N	\N	61584	61584	229767
124	106	0	applied	\N	\N	\N	\N	61585	61585	229768
124	107	1	applied	\N	\N	\N	\N	61586	61586	229769
124	108	2	applied	\N	\N	\N	\N	61587	61587	229770
125	106	0	applied	\N	\N	\N	\N	61588	61588	229771
125	107	1	applied	\N	\N	\N	\N	61589	61589	229772
125	108	2	applied	\N	\N	\N	\N	61590	61590	229773
126	107	1	applied	\N	\N	\N	\N	61592	61592	229775
126	108	2	applied	\N	\N	\N	\N	61593	61593	229776
127	109	0	applied	\N	\N	\N	\N	61594	61594	229777
127	110	1	applied	\N	\N	\N	\N	61595	61595	229778
127	111	2	applied	\N	\N	\N	\N	61596	61596	229779
128	112	0	applied	\N	\N	\N	\N	61597	61597	229780
129	113	0	applied	\N	\N	\N	\N	61598	61598	229781
129	114	1	applied	\N	\N	\N	\N	61599	61599	229782
130	113	0	applied	\N	\N	\N	\N	61600	61600	229783
130	114	1	applied	\N	\N	\N	\N	61601	61601	229784
131	115	0	applied	\N	\N	\N	\N	61602	61602	229785
131	116	1	applied	\N	\N	\N	\N	61603	61603	229786
132	117	0	applied	\N	\N	\N	\N	61604	61604	229787
133	118	0	applied	\N	\N	\N	\N	61605	61605	229788
134	119	0	applied	\N	\N	\N	\N	61606	61606	229789
134	120	1	applied	\N	\N	\N	\N	61607	61607	229790
135	120	1	applied	\N	\N	\N	\N	61609	61609	229792
136	121	0	applied	\N	\N	\N	\N	61610	61610	229793
137	121	0	applied	\N	\N	\N	\N	61611	61611	229794
138	121	0	applied	\N	\N	\N	\N	61612	61612	229795
139	122	0	applied	\N	\N	\N	\N	61613	61613	229796
139	123	1	applied	\N	\N	\N	\N	61614	61614	229797
140	122	0	applied	\N	\N	\N	\N	61615	61615	229798
140	123	1	applied	\N	\N	\N	\N	61616	61616	229799
141	124	0	applied	\N	\N	\N	\N	61617	61617	229800
142	125	0	applied	\N	\N	\N	\N	61618	61618	229801
143	125	0	applied	\N	\N	\N	\N	61619	61619	229802
144	126	0	applied	\N	\N	\N	\N	61620	61620	229803
145	127	0	applied	\N	\N	\N	\N	61621	61621	229804
146	128	0	applied	\N	\N	\N	\N	61622	61622	229805
147	128	0	applied	\N	\N	\N	\N	61623	61623	229806
148	129	0	applied	\N	\N	\N	\N	61624	61624	229807
149	131	1	applied	\N	\N	\N	\N	61626	61626	229809
150	130	0	applied	\N	\N	\N	\N	61627	61627	229810
150	131	1	applied	\N	\N	\N	\N	61628	61628	229811
151	130	0	applied	\N	\N	\N	\N	61629	61629	229812
151	131	1	applied	\N	\N	\N	\N	61630	61630	229813
152	132	0	applied	\N	\N	\N	\N	61631	61631	229814
153	133	0	applied	\N	\N	\N	\N	61632	61632	229815
154	133	0	applied	\N	\N	\N	\N	61633	61633	229816
155	134	0	applied	\N	\N	\N	\N	61634	61634	229817
156	135	0	applied	\N	\N	\N	\N	61635	61635	229818
156	136	1	applied	\N	\N	\N	\N	61636	61636	229819
157	137	0	applied	\N	\N	\N	\N	61637	61637	229820
157	138	1	applied	\N	\N	\N	\N	61638	61638	229821
157	139	2	applied	\N	\N	\N	\N	61639	61639	229822
157	140	3	applied	\N	\N	\N	\N	61640	61640	229823
158	137	0	applied	\N	\N	\N	\N	61641	61641	229824
158	139	2	applied	\N	\N	\N	\N	61643	61643	229826
158	140	3	applied	\N	\N	\N	\N	61644	61644	229827
89	76	0	applied	\N	\N	\N	\N	61527	61527	229710
89	77	1	applied	\N	\N	\N	\N	61528	61528	229711
160	144	0	applied	\N	\N	\N	\N	61648	61648	229831
160	145	1	applied	\N	\N	\N	\N	61649	61649	229832
161	144	0	applied	\N	\N	\N	\N	61650	61650	229833
161	145	1	applied	\N	\N	\N	\N	61651	61651	229834
162	144	0	applied	\N	\N	\N	\N	61652	61652	229835
162	145	1	applied	\N	\N	\N	\N	61653	61653	229836
163	146	0	applied	\N	\N	\N	\N	61654	61654	229837
163	147	1	applied	\N	\N	\N	\N	61655	61655	229838
164	148	0	applied	\N	\N	\N	\N	61656	61656	229839
165	150	1	applied	\N	\N	\N	\N	61658	61658	229841
165	151	2	applied	\N	\N	\N	\N	61659	61659	229842
166	152	0	applied	\N	\N	\N	\N	61660	61660	229843
167	153	0	applied	\N	\N	1000000000	\N	61661	61661	229844
167	154	1	applied	\N	\N	\N	\N	61662	61662	229845
167	155	2	applied	\N	\N	\N	\N	61663	61663	229846
167	156	3	applied	\N	\N	\N	\N	61664	61664	229847
259	230	0	applied	\N	\N	\N	\N	61794	61794	229974
168	153	0	applied	\N	\N	1000000000	\N	61665	61665	229848
168	154	1	applied	\N	\N	\N	\N	61666	61666	229849
168	155	2	applied	\N	\N	\N	\N	61667	61667	229850
168	156	3	applied	\N	\N	\N	\N	61668	61668	229851
169	153	0	applied	\N	\N	1000000000	\N	61669	61669	229852
169	154	1	applied	\N	\N	\N	\N	61670	61670	229853
169	155	2	applied	\N	\N	\N	\N	61671	61671	229854
169	156	3	applied	\N	\N	\N	\N	61672	61672	229855
170	157	0	applied	\N	\N	\N	\N	61673	61673	229856
172	158	0	applied	\N	\N	\N	\N	61675	61675	229858
172	159	1	applied	\N	\N	\N	\N	61676	61676	229859
173	158	0	applied	\N	\N	\N	\N	61677	61677	229860
173	159	1	applied	\N	\N	\N	\N	61678	61678	229861
174	160	0	applied	\N	\N	\N	\N	61679	61679	229862
175	160	0	applied	\N	\N	\N	\N	61680	61680	229863
176	160	0	applied	\N	\N	\N	\N	61681	61681	229864
177	161	0	applied	\N	\N	\N	\N	61682	61682	229865
178	161	0	applied	\N	\N	\N	\N	61683	61683	229866
179	162	0	applied	\N	\N	\N	\N	61684	61684	229867
180	163	0	applied	\N	\N	\N	\N	61685	61685	229868
181	164	0	applied	\N	\N	\N	\N	61686	61686	229869
182	164	0	applied	\N	\N	\N	\N	61687	61687	229870
183	165	0	applied	\N	\N	\N	\N	61688	61688	229871
184	166	0	applied	\N	\N	\N	\N	61689	61689	229872
184	167	1	applied	\N	\N	\N	\N	61690	61690	229873
185	169	2	applied	\N	\N	\N	\N	61692	61692	229875
185	170	3	applied	\N	\N	\N	\N	61693	61693	229876
186	168	0	applied	\N	\N	\N	\N	61694	61694	229877
186	169	2	applied	\N	\N	\N	\N	61695	61695	229878
186	170	3	applied	\N	\N	\N	\N	61696	61696	229879
187	171	0	applied	\N	\N	\N	\N	61697	61697	229880
187	172	1	applied	\N	\N	\N	\N	61698	61698	229881
188	171	0	applied	\N	\N	\N	\N	61699	61699	229882
188	172	1	applied	\N	\N	\N	\N	61700	61700	229883
189	173	0	applied	\N	\N	\N	\N	61701	61701	229884
190	173	0	applied	\N	\N	\N	\N	61702	61702	229885
191	173	0	applied	\N	\N	\N	\N	61703	61703	229886
193	174	0	applied	\N	\N	\N	\N	61704	61704	229887
194	174	0	applied	\N	\N	\N	\N	61705	61705	229888
195	174	0	applied	\N	\N	\N	\N	61706	61706	229889
196	175	0	applied	\N	\N	\N	\N	61707	61707	229890
198	176	0	applied	\N	\N	\N	\N	61709	61709	229892
199	176	0	applied	\N	\N	\N	\N	61710	61710	229893
200	177	0	applied	\N	\N	\N	\N	61711	61711	229894
201	177	0	applied	\N	\N	\N	\N	61712	61712	229895
202	178	0	applied	\N	\N	\N	\N	61713	61713	229896
202	179	1	applied	\N	\N	\N	\N	61714	61714	229897
203	180	0	applied	\N	\N	\N	\N	61715	61715	229898
204	180	0	applied	\N	\N	\N	\N	61716	61716	229899
205	181	0	applied	\N	\N	\N	\N	61717	61717	229900
206	181	0	applied	\N	\N	\N	\N	61718	61718	229901
207	181	0	applied	\N	\N	\N	\N	61719	61719	229902
208	182	0	applied	\N	\N	\N	\N	61720	61720	229903
209	182	0	applied	\N	\N	\N	\N	61721	61721	229904
210	183	0	applied	\N	\N	\N	\N	61722	61722	229905
210	184	1	applied	\N	\N	\N	\N	61723	61723	229906
211	183	0	applied	\N	\N	\N	\N	61724	61724	229907
212	185	0	applied	\N	\N	\N	\N	61726	61726	229909
213	185	0	applied	\N	\N	\N	\N	61727	61727	229910
214	186	0	applied	\N	\N	\N	\N	61728	61728	229911
215	187	0	applied	\N	\N	\N	\N	61729	61729	229912
215	188	1	applied	\N	\N	\N	\N	61730	61730	229913
216	189	0	applied	\N	\N	\N	\N	61731	61731	61731
216	190	1	applied	\N	\N	\N	\N	61732	61732	229914
216	191	2	applied	\N	\N	\N	\N	61733	61733	229915
217	192	0	applied	\N	\N	\N	\N	61734	61734	229916
218	193	0	applied	\N	\N	\N	\N	61735	61735	229917
219	194	0	applied	\N	\N	\N	\N	61736	61736	229918
220	194	0	applied	\N	\N	\N	\N	61737	61737	229919
221	195	0	applied	\N	\N	\N	\N	61738	61738	229920
222	195	0	applied	\N	\N	\N	\N	61739	61739	229921
223	196	0	applied	\N	\N	\N	\N	61740	61740	229922
224	196	0	applied	\N	\N	\N	\N	61741	61741	229923
226	198	0	applied	\N	\N	\N	\N	61743	61743	229925
227	198	0	applied	\N	\N	\N	\N	61744	61744	229926
228	199	0	applied	\N	\N	\N	\N	61745	61745	229927
228	200	1	applied	\N	\N	\N	\N	61746	61746	229928
229	199	0	applied	\N	\N	\N	\N	61747	61747	229929
229	200	1	applied	\N	\N	\N	\N	61748	61748	229930
230	201	0	applied	\N	\N	\N	\N	61749	61749	229931
230	202	1	applied	\N	\N	1000000000	\N	61750	61750	229932
231	203	0	applied	\N	\N	\N	\N	61751	61751	229933
232	203	0	applied	\N	\N	\N	\N	61752	61752	229934
233	204	0	applied	\N	\N	\N	\N	61753	61753	229935
234	204	0	applied	\N	\N	\N	\N	61754	61754	229936
235	205	0	applied	\N	\N	\N	\N	61755	61755	229937
235	206	1	applied	\N	\N	\N	\N	61756	61756	229938
236	207	0	applied	\N	\N	\N	\N	61757	61757	229939
236	208	1	applied	\N	\N	\N	\N	61758	61758	229940
237	210	1	applied	\N	\N	\N	\N	61760	61760	229942
238	209	0	applied	\N	\N	\N	\N	61761	61761	229943
238	210	1	applied	\N	\N	\N	\N	61762	61762	229944
239	209	0	applied	\N	\N	\N	\N	61763	61763	229945
159	142	1	applied	\N	\N	\N	\N	61646	61646	229829
159	143	2	applied	\N	\N	\N	\N	61647	61647	229830
242	212	0	applied	\N	\N	\N	\N	61767	61767	229949
244	213	0	applied	\N	\N	\N	\N	61769	61769	229951
245	213	0	applied	\N	\N	\N	\N	61770	61770	229952
246	215	1	applied	\N	\N	\N	\N	61772	61772	229953
246	216	2	applied	\N	\N	\N	\N	61773	61773	229954
246	217	3	applied	\N	\N	\N	\N	61774	61774	229955
247	215	1	applied	\N	\N	\N	\N	61776	61776	229956
247	214	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61775	61775	\N
247	216	2	applied	\N	\N	\N	\N	61777	61777	229957
247	217	3	applied	\N	\N	\N	\N	61778	61778	229958
248	218	0	applied	\N	\N	\N	\N	61779	61779	229959
248	219	1	applied	\N	\N	\N	\N	61780	61780	229960
249	218	0	applied	\N	\N	\N	\N	61781	61781	229961
249	219	1	applied	\N	\N	\N	\N	61782	61782	229962
250	220	0	applied	\N	\N	\N	\N	61783	61783	229963
250	221	1	applied	\N	\N	\N	\N	61784	61784	229964
255	223	0	applied	\N	\N	\N	\N	61786	61786	229966
255	224	1	applied	\N	\N	\N	\N	61787	61787	229967
255	225	2	applied	\N	\N	\N	\N	61788	61788	229968
255	226	3	applied	\N	\N	\N	\N	61789	61789	229969
255	227	4	applied	\N	\N	\N	\N	61790	61790	229970
256	228	0	applied	\N	\N	\N	\N	61791	61791	229971
257	229	0	applied	\N	\N	\N	\N	61792	61792	229972
258	230	0	applied	\N	\N	\N	\N	61793	61793	229973
260	230	0	applied	\N	\N	\N	\N	61795	61795	229975
261	230	0	applied	\N	\N	\N	\N	61796	61796	229976
262	231	0	applied	\N	\N	\N	\N	61797	61797	229977
263	231	0	applied	\N	\N	\N	\N	61798	61798	229978
265	231	0	applied	\N	\N	\N	\N	61799	61799	229979
265	232	1	applied	\N	\N	\N	\N	61800	61800	229980
265	233	2	applied	\N	\N	\N	\N	61801	61801	229981
266	235	1	applied	\N	\N	\N	\N	61803	61803	229983
266	236	2	applied	\N	\N	\N	\N	61804	61804	229984
267	234	0	applied	\N	\N	\N	\N	61805	61805	229985
267	235	1	applied	\N	\N	\N	\N	61806	61806	229986
267	236	2	applied	\N	\N	\N	\N	61807	61807	229987
268	237	0	applied	\N	\N	\N	\N	61808	61808	229988
269	237	0	applied	\N	\N	\N	\N	61809	61809	229989
270	238	0	applied	\N	\N	\N	\N	61810	61810	229990
271	239	0	applied	\N	\N	\N	\N	61811	61811	229991
272	239	0	applied	\N	\N	\N	\N	61812	61812	229992
273	240	0	applied	\N	\N	\N	\N	61813	61813	229993
274	240	0	applied	\N	\N	\N	\N	61814	61814	229994
275	240	0	applied	\N	\N	\N	\N	61815	61815	229995
276	241	0	applied	\N	\N	\N	\N	61816	61816	229996
277	241	0	applied	\N	\N	\N	\N	61817	61817	229997
278	242	0	applied	\N	\N	\N	\N	61818	61818	229998
281	243	0	applied	\N	\N	\N	\N	61820	61820	230000
282	244	0	applied	\N	\N	\N	\N	61821	61821	230001
283	244	0	applied	\N	\N	\N	\N	61822	61822	230002
284	245	0	applied	\N	\N	\N	\N	61823	61823	230003
285	245	0	applied	\N	\N	\N	\N	61824	61824	230004
286	245	0	applied	\N	\N	\N	\N	61825	61825	230005
287	245	0	applied	\N	\N	\N	\N	61826	61826	230006
288	246	0	applied	\N	\N	\N	\N	61827	61827	230007
289	246	0	applied	\N	\N	\N	\N	61828	61828	230008
290	247	0	applied	\N	\N	\N	\N	61829	61829	230009
290	248	1	applied	\N	\N	\N	\N	61830	61830	230010
291	249	0	applied	\N	\N	\N	\N	61831	61831	230011
292	250	0	applied	\N	\N	\N	\N	61832	61832	230012
293	250	0	applied	\N	\N	\N	\N	61833	61833	230013
294	251	0	applied	\N	\N	\N	\N	61834	61834	230014
295	252	0	applied	\N	\N	\N	\N	61835	61835	230015
296	254	0	applied	\N	\N	\N	\N	61837	61837	230017
296	255	1	applied	\N	\N	\N	\N	61838	61838	230018
296	256	2	applied	\N	\N	\N	\N	61839	61839	230019
297	254	0	applied	\N	\N	\N	\N	61840	61840	230020
297	255	1	applied	\N	\N	\N	\N	61841	61841	230021
297	256	2	applied	\N	\N	\N	\N	61842	61842	230022
298	254	0	applied	\N	\N	\N	\N	61843	61843	230023
298	255	1	applied	\N	\N	\N	\N	61844	61844	230024
298	256	2	applied	\N	\N	\N	\N	61845	61845	230025
299	257	0	applied	\N	\N	\N	\N	61846	61846	230026
300	258	0	applied	\N	\N	\N	\N	61847	61847	230027
301	258	0	applied	\N	\N	\N	\N	61848	61848	230028
302	258	0	applied	\N	\N	\N	\N	61849	61849	230029
303	259	0	applied	\N	\N	\N	\N	61850	61850	230030
303	260	1	applied	\N	\N	\N	\N	61851	61851	230031
303	261	2	applied	\N	\N	\N	\N	61852	61852	230032
304	263	1	applied	\N	\N	\N	\N	61854	61854	230034
304	264	2	applied	\N	\N	\N	\N	61855	61855	230035
304	265	3	applied	\N	\N	\N	\N	61856	61856	230036
304	266	4	applied	\N	\N	\N	\N	61857	61857	230037
305	267	0	applied	\N	\N	\N	\N	61858	61858	230038
305	268	1	applied	\N	\N	\N	\N	61859	61859	230039
307	267	0	applied	\N	\N	\N	\N	61862	61862	230042
307	268	1	applied	\N	\N	\N	\N	61863	61863	230043
308	269	0	applied	\N	\N	\N	\N	61864	61864	230044
309	270	0	applied	\N	\N	\N	\N	61865	61865	230045
310	271	0	applied	\N	\N	\N	\N	61866	61866	230046
311	271	0	applied	\N	\N	\N	\N	61867	61867	230047
314	274	0	applied	\N	\N	\N	\N	61872	61872	230052
314	275	1	applied	\N	\N	\N	\N	61873	61873	230053
315	274	0	applied	\N	\N	\N	\N	61874	61874	230054
315	275	1	applied	\N	\N	\N	\N	61875	61875	230055
317	278	1	applied	\N	\N	\N	\N	61878	61878	230058
318	277	0	applied	\N	\N	\N	\N	61879	61879	230059
318	278	1	applied	\N	\N	\N	\N	61880	61880	230060
321	279	0	applied	\N	\N	\N	\N	61884	61884	230064
322	280	0	applied	\N	\N	\N	\N	61885	61885	230065
322	281	1	applied	\N	\N	\N	\N	61886	61886	230066
325	283	0	applied	\N	\N	\N	\N	61890	61890	230070
325	284	1	applied	\N	\N	\N	\N	61891	61891	230071
328	287	0	applied	\N	\N	\N	\N	61896	61896	230076
329	287	0	applied	\N	\N	\N	\N	61897	61897	230077
331	289	0	applied	\N	\N	\N	\N	61899	61899	230079
332	289	0	applied	\N	\N	\N	\N	61900	61900	230080
240	211	0	applied	\N	\N	\N	\N	61765	61765	229947
241	211	0	applied	\N	\N	\N	\N	61766	61766	229948
312	273	1	applied	\N	\N	\N	\N	61869	61869	230049
313	274	0	applied	\N	\N	\N	\N	61870	61870	230050
313	275	1	applied	\N	\N	\N	\N	61871	61871	230051
316	276	0	applied	\N	\N	\N	\N	61876	61876	230056
319	277	0	applied	\N	\N	\N	\N	61881	61881	230061
319	278	1	applied	\N	\N	\N	\N	61882	61882	230062
320	279	0	applied	\N	\N	\N	\N	61883	61883	230063
323	282	0	applied	\N	\N	\N	\N	61887	61887	230067
324	283	0	applied	\N	\N	\N	\N	61888	61888	230068
324	284	1	applied	\N	\N	\N	\N	61889	61889	230069
326	283	0	applied	\N	\N	\N	\N	61892	61892	230072
327	285	0	applied	\N	\N	\N	\N	61894	61894	230074
327	286	1	applied	\N	\N	\N	\N	61895	61895	230075
330	288	0	applied	\N	\N	\N	\N	61898	61898	230078
333	289	0	applied	\N	\N	\N	\N	61901	61901	230081
334	290	0	applied	\N	\N	\N	\N	61902	61902	230082
335	290	0	applied	\N	\N	\N	\N	61903	61903	230083
336	291	0	applied	\N	\N	\N	\N	61904	61904	230084
336	292	1	applied	\N	\N	\N	\N	61905	61905	230085
337	291	0	applied	\N	\N	\N	\N	61906	61906	230086
337	292	1	applied	\N	\N	\N	\N	61907	61907	230087
338	291	0	applied	\N	\N	\N	\N	61908	61908	230088
338	292	1	applied	\N	\N	\N	\N	61909	61909	230089
339	293	0	applied	\N	\N	\N	\N	61910	61910	230090
340	293	0	applied	\N	\N	\N	\N	61911	61911	230091
341	294	0	applied	\N	\N	\N	\N	61912	61912	230092
341	295	1	applied	\N	\N	\N	\N	61913	61913	230093
342	295	1	applied	\N	\N	\N	\N	61915	61915	230095
343	296	0	applied	\N	\N	\N	\N	61916	61916	230096
344	297	0	applied	\N	\N	\N	\N	61917	61917	230097
344	298	1	applied	\N	\N	\N	\N	61918	61918	230098
344	299	2	applied	\N	\N	\N	\N	61919	61919	230099
345	297	0	applied	\N	\N	\N	\N	61920	61920	230100
345	298	1	applied	\N	\N	\N	\N	61921	61921	230101
345	299	2	applied	\N	\N	\N	\N	61922	61922	230102
346	297	0	applied	\N	\N	\N	\N	61923	61923	230103
346	298	1	applied	\N	\N	\N	\N	61924	61924	230104
346	299	2	applied	\N	\N	\N	\N	61925	61925	230105
347	300	0	applied	\N	\N	\N	\N	61926	61926	230106
348	301	0	applied	\N	\N	\N	\N	61927	61927	230107
349	302	0	applied	\N	\N	\N	\N	61928	61928	230108
349	304	2	applied	\N	\N	1000000000	\N	61930	61930	230110
350	305	0	applied	\N	\N	\N	\N	61931	61931	230111
351	305	0	applied	\N	\N	\N	\N	61932	61932	230112
353	305	0	applied	\N	\N	\N	\N	61933	61933	230113
354	306	0	applied	\N	\N	\N	\N	61934	61934	230114
354	307	1	applied	\N	\N	\N	\N	61935	61935	230115
354	308	2	applied	\N	\N	\N	\N	61936	61936	230116
355	306	0	applied	\N	\N	\N	\N	61937	61937	230117
355	307	1	applied	\N	\N	\N	\N	61938	61938	230118
355	308	2	applied	\N	\N	\N	\N	61939	61939	230119
356	309	0	applied	\N	\N	\N	\N	61940	61940	230120
356	310	1	applied	\N	\N	\N	\N	61941	61941	230121
356	311	2	applied	\N	\N	\N	\N	61942	61942	230122
357	309	0	applied	\N	\N	\N	\N	61943	61943	230123
357	310	1	applied	\N	\N	\N	\N	61944	61944	230124
357	311	2	applied	\N	\N	\N	\N	61945	61945	230125
358	312	0	applied	\N	\N	\N	\N	61946	61946	230126
358	313	1	applied	\N	\N	\N	\N	61947	61947	230127
358	314	2	applied	\N	\N	\N	\N	61948	61948	230128
358	315	3	applied	\N	\N	\N	\N	61949	61949	230129
359	317	1	applied	\N	\N	\N	\N	61951	61951	230131
360	316	0	applied	\N	\N	\N	\N	61952	61952	230132
360	317	1	applied	\N	\N	\N	\N	61953	61953	230133
361	318	0	applied	\N	\N	\N	\N	61954	61954	230134
362	319	0	applied	\N	\N	\N	\N	61955	61955	230135
362	320	1	applied	\N	\N	\N	\N	61956	61956	230136
363	319	0	applied	\N	\N	\N	\N	61957	61957	230137
364	321	0	applied	\N	\N	\N	\N	61958	61958	230138
365	321	0	applied	\N	\N	\N	\N	61959	61959	230139
366	322	0	applied	\N	\N	\N	\N	61960	61960	230140
366	323	1	applied	\N	\N	\N	\N	61961	61961	230141
367	322	0	applied	\N	\N	\N	\N	61962	61962	230142
367	323	1	applied	\N	\N	\N	\N	61963	61963	230143
368	322	0	applied	\N	\N	\N	\N	61964	61964	230144
368	323	1	applied	\N	\N	\N	\N	61965	61965	230145
369	324	0	applied	\N	\N	\N	\N	61966	61966	230146
370	324	0	applied	\N	\N	\N	\N	61968	61968	230148
370	325	1	applied	\N	\N	\N	\N	61969	61969	230149
371	326	0	applied	\N	\N	\N	\N	61970	61970	230150
371	327	1	applied	\N	\N	\N	\N	61971	61971	230151
372	328	0	applied	\N	\N	\N	\N	61972	61972	230152
373	329	0	applied	\N	\N	\N	\N	61973	61973	230153
374	329	0	applied	\N	\N	\N	\N	61974	61974	230154
375	329	0	applied	\N	\N	\N	\N	61975	61975	230155
376	329	0	applied	\N	\N	\N	\N	61976	61976	230156
377	329	0	applied	\N	\N	\N	\N	61977	61977	230157
378	330	0	applied	\N	\N	\N	\N	61978	61978	230158
379	331	0	applied	\N	\N	\N	\N	61979	61979	230159
379	332	1	applied	\N	\N	\N	\N	61980	61980	230160
379	333	2	applied	\N	\N	1000000000	\N	61981	61981	230161
379	334	3	applied	\N	\N	\N	\N	61982	61982	230162
380	335	0	applied	\N	\N	\N	\N	61983	61983	230163
382	337	0	applied	\N	\N	\N	\N	61985	61985	230165
383	337	0	applied	\N	\N	\N	\N	61986	61986	230166
384	337	0	applied	\N	\N	\N	\N	61987	61987	230167
385	338	0	applied	\N	\N	\N	\N	61988	61988	230168
385	339	2	applied	\N	\N	\N	\N	61989	61989	230169
385	340	3	applied	\N	\N	\N	\N	61990	61990	230170
385	341	4	applied	\N	\N	\N	\N	61991	61991	230171
385	342	5	applied	\N	\N	\N	\N	61992	61992	230172
386	343	0	applied	\N	\N	\N	\N	61993	61993	230173
387	344	0	applied	\N	\N	\N	\N	61994	61994	230174
387	345	1	applied	\N	\N	\N	\N	61995	61995	230175
388	344	0	applied	\N	\N	\N	\N	61996	61996	230176
388	345	1	applied	\N	\N	\N	\N	61997	61997	230177
389	344	0	applied	\N	\N	\N	\N	61998	61998	230178
389	345	1	applied	\N	\N	\N	\N	61999	61999	230179
390	346	0	applied	\N	\N	\N	\N	62000	62000	230180
306	268	1	applied	\N	\N	\N	\N	61861	61861	230041
312	272	0	applied	\N	\N	\N	\N	61868	61868	230048
395	349	0	applied	\N	\N	\N	\N	62005	62005	230185
396	350	0	applied	\N	\N	\N	\N	62006	62006	230186
396	351	1	applied	\N	\N	\N	\N	62007	62007	230187
397	350	0	applied	\N	\N	\N	\N	62008	62008	230188
397	351	1	applied	\N	\N	\N	\N	62009	62009	230189
398	350	0	applied	\N	\N	\N	\N	62010	62010	230190
398	351	1	applied	\N	\N	\N	\N	62011	62011	230191
399	352	0	applied	\N	\N	\N	\N	62012	62012	230192
399	353	1	applied	\N	\N	\N	\N	62013	62013	230193
400	352	0	applied	\N	\N	\N	\N	62015	62015	230195
400	353	1	applied	\N	\N	\N	\N	62016	62016	230196
400	354	2	applied	\N	\N	\N	\N	62017	62017	230197
401	352	0	applied	\N	\N	\N	\N	62018	62018	230198
401	353	1	applied	\N	\N	\N	\N	62019	62019	230199
401	354	2	applied	\N	\N	\N	\N	62020	62020	230200
402	355	0	applied	\N	\N	\N	\N	62021	62021	230201
402	356	1	applied	\N	\N	\N	\N	62022	62022	230202
403	357	0	applied	\N	\N	\N	\N	62023	62023	230203
403	358	1	applied	\N	\N	\N	\N	62024	62024	230204
404	359	0	applied	\N	\N	\N	\N	62025	62025	230205
404	360	1	applied	\N	\N	\N	\N	62026	62026	230206
405	359	0	applied	\N	\N	\N	\N	62027	62027	230207
405	360	1	applied	\N	\N	\N	\N	62028	62028	230208
406	359	0	applied	\N	\N	\N	\N	62029	62029	230209
406	360	1	applied	\N	\N	\N	\N	62030	62030	230210
408	362	0	applied	\N	\N	\N	\N	62032	62032	230212
409	363	0	applied	\N	\N	\N	\N	62033	62033	230213
410	363	0	applied	\N	\N	\N	\N	62034	62034	230214
411	364	0	applied	\N	\N	\N	\N	62035	62035	230215
412	364	0	applied	\N	\N	\N	\N	62036	62036	230216
413	365	0	applied	\N	\N	\N	\N	62037	62037	230217
413	366	1	applied	\N	\N	\N	\N	62038	62038	230218
414	367	0	applied	\N	\N	\N	\N	62039	62039	230219
415	368	0	applied	\N	\N	\N	\N	62040	62040	230220
415	369	1	applied	\N	\N	\N	\N	62041	62041	230221
416	368	0	applied	\N	\N	\N	\N	62042	62042	230222
416	369	1	applied	\N	\N	\N	\N	62043	62043	230223
417	370	0	applied	\N	\N	\N	\N	62044	62044	230224
417	371	1	applied	\N	\N	\N	\N	62045	62045	230225
418	373	1	applied	\N	\N	1000000000	\N	62047	62047	230227
418	374	2	applied	\N	\N	\N	\N	62048	62048	230228
419	372	0	applied	\N	\N	1000000000	\N	62049	62049	230229
419	373	1	applied	\N	\N	1000000000	\N	62050	62050	230230
419	374	2	applied	\N	\N	\N	\N	62051	62051	230231
420	375	0	applied	\N	\N	\N	\N	62052	62052	230232
420	376	1	applied	\N	\N	\N	\N	62053	62053	230233
420	377	2	applied	\N	\N	\N	\N	62054	62054	230234
421	375	0	applied	\N	\N	\N	\N	62055	62055	230235
421	376	1	applied	\N	\N	\N	\N	62056	62056	230236
421	377	2	applied	\N	\N	\N	\N	62057	62057	230237
422	378	0	applied	\N	\N	\N	\N	62058	62058	230238
423	378	0	applied	\N	\N	\N	\N	62059	62059	230239
424	379	0	applied	\N	\N	\N	\N	62060	62060	230240
425	379	0	applied	\N	\N	\N	\N	62061	62061	230241
426	379	0	applied	\N	\N	\N	\N	62062	62062	230242
427	380	0	applied	\N	\N	\N	\N	62063	62063	230243
428	381	0	applied	\N	\N	\N	\N	62064	62064	230244
429	381	0	applied	\N	\N	\N	\N	62065	62065	230245
430	382	0	applied	\N	\N	\N	\N	62066	62066	230246
432	382	0	applied	\N	\N	\N	\N	62068	62068	230248
433	383	0	applied	\N	\N	\N	\N	62069	62069	230249
433	384	1	applied	\N	\N	\N	\N	62070	62070	230250
434	383	0	applied	\N	\N	\N	\N	62071	62071	230251
434	384	1	applied	\N	\N	\N	\N	62072	62072	230252
435	385	0	applied	\N	\N	\N	\N	62073	62073	230253
436	385	0	applied	\N	\N	\N	\N	62074	62074	230254
437	386	0	applied	\N	\N	\N	\N	62075	62075	230255
438	386	0	applied	\N	\N	\N	\N	62076	62076	230256
439	386	0	applied	\N	\N	\N	\N	62077	62077	230257
440	387	0	applied	\N	\N	\N	\N	62078	62078	230258
440	388	1	applied	\N	\N	\N	\N	62079	62079	230259
440	389	2	applied	\N	\N	\N	\N	62080	62080	230260
441	387	0	applied	\N	\N	\N	\N	62081	62081	230261
441	388	1	applied	\N	\N	\N	\N	62082	62082	230262
441	389	2	applied	\N	\N	\N	\N	62083	62083	230263
442	388	1	applied	\N	\N	\N	\N	62085	62085	230265
442	389	2	applied	\N	\N	\N	\N	62086	62086	230266
443	387	0	applied	\N	\N	\N	\N	62087	62087	230267
443	388	1	applied	\N	\N	\N	\N	62088	62088	230268
443	389	2	applied	\N	\N	\N	\N	62089	62089	230269
444	387	0	applied	\N	\N	\N	\N	62090	62090	230270
444	388	1	applied	\N	\N	\N	\N	62091	62091	230271
444	389	2	applied	\N	\N	\N	\N	62092	62092	230272
445	387	0	applied	\N	\N	\N	\N	62093	62093	230273
445	388	1	applied	\N	\N	\N	\N	62094	62094	230274
445	389	2	applied	\N	\N	\N	\N	62095	62095	230275
446	390	0	applied	\N	\N	\N	\N	62096	62096	230276
446	391	1	applied	\N	\N	\N	\N	62097	62097	230277
447	392	0	applied	\N	\N	\N	\N	62098	62098	230278
448	393	0	applied	\N	\N	\N	\N	62099	62099	230279
449	394	0	applied	\N	\N	\N	\N	62100	62100	230280
450	396	2	applied	\N	\N	\N	\N	62102	62102	230282
451	397	0	applied	\N	\N	\N	\N	62103	62103	230283
452	397	0	applied	\N	\N	\N	\N	62104	62104	230284
453	397	0	applied	\N	\N	\N	\N	62105	62105	230285
454	398	0	applied	\N	\N	\N	\N	62106	62106	230286
454	399	1	applied	\N	\N	\N	\N	62107	62107	230287
455	398	0	applied	\N	\N	\N	\N	62108	62108	230288
455	399	1	applied	\N	\N	\N	\N	62109	62109	230289
456	400	0	applied	\N	\N	\N	\N	62110	62110	230290
457	400	0	applied	\N	\N	\N	\N	62111	62111	230291
458	400	0	applied	\N	\N	\N	\N	62112	62112	230292
459	400	0	applied	\N	\N	\N	\N	62113	62113	230293
460	401	0	applied	\N	\N	\N	\N	62114	62114	230294
461	401	0	applied	\N	\N	\N	\N	62115	62115	230295
462	402	0	applied	\N	\N	\N	\N	62116	62116	230296
463	403	0	applied	\N	\N	\N	\N	62117	62117	230297
465	404	0	applied	\N	\N	\N	\N	62119	62119	230299
466	405	0	applied	\N	\N	\N	\N	62120	62120	230300
393	348	0	applied	\N	\N	\N	\N	62003	62003	230183
394	349	0	applied	\N	\N	\N	\N	62004	62004	230184
469	407	1	applied	\N	\N	\N	\N	62124	62124	230304
469	408	2	applied	\N	\N	\N	\N	62125	62125	230305
469	409	3	applied	\N	\N	\N	\N	62126	62126	230306
470	407	1	applied	\N	\N	\N	\N	62128	62128	230308
470	408	2	applied	\N	\N	\N	\N	62129	62129	230309
470	409	3	applied	\N	\N	\N	\N	62130	62130	230310
471	410	0	applied	\N	\N	\N	\N	62131	62131	230311
472	410	0	applied	\N	\N	\N	\N	62132	62132	230312
473	411	0	applied	\N	\N	\N	\N	62133	62133	230313
473	412	1	applied	\N	\N	\N	\N	62134	62134	230314
473	413	2	applied	\N	\N	\N	\N	62135	62135	230315
474	411	0	applied	\N	\N	\N	\N	62136	62136	230316
474	412	1	applied	\N	\N	\N	\N	62137	62137	230317
474	413	2	applied	\N	\N	\N	\N	62138	62138	230318
475	411	0	applied	\N	\N	\N	\N	62139	62139	230319
475	412	1	applied	\N	\N	\N	\N	62140	62140	230320
475	413	2	applied	\N	\N	\N	\N	62141	62141	230321
476	411	0	applied	\N	\N	\N	\N	62142	62142	230322
476	412	1	applied	\N	\N	\N	\N	62143	62143	230323
477	414	0	applied	\N	\N	\N	\N	62145	62145	230325
477	415	1	applied	\N	\N	\N	\N	62146	62146	230326
478	416	0	applied	\N	\N	1000000000	\N	62147	62147	230327
478	417	1	applied	\N	\N	\N	\N	62148	62148	230328
479	416	0	applied	\N	\N	1000000000	\N	62149	62149	230329
479	417	1	applied	\N	\N	\N	\N	62150	62150	230330
480	418	0	applied	\N	\N	\N	\N	62151	62151	230331
481	419	0	applied	\N	\N	\N	\N	62152	62152	230332
482	420	0	applied	\N	\N	\N	\N	62153	62153	230333
483	420	0	applied	\N	\N	\N	\N	62154	62154	230334
484	421	0	applied	\N	\N	\N	\N	62155	62155	230335
485	421	0	applied	\N	\N	\N	\N	62156	62156	230336
486	421	0	applied	\N	\N	\N	\N	62157	62157	230337
487	421	0	applied	\N	\N	\N	\N	62158	62158	230338
488	421	0	applied	\N	\N	\N	\N	62159	62159	230339
489	422	0	applied	\N	\N	\N	\N	62160	62160	230340
489	424	2	applied	\N	\N	\N	\N	62162	62162	230342
490	422	0	applied	\N	\N	\N	\N	62163	62163	230343
490	423	1	applied	\N	\N	\N	\N	62164	62164	230344
490	424	2	applied	\N	\N	\N	\N	62165	62165	230345
491	425	0	applied	\N	\N	\N	\N	62166	62166	230346
492	425	0	applied	\N	\N	\N	\N	62167	62167	230347
493	426	0	applied	\N	\N	\N	\N	62168	62168	230348
494	426	0	applied	\N	\N	\N	\N	62169	62169	230349
495	427	0	applied	\N	\N	\N	\N	62170	62170	230350
495	428	1	applied	\N	\N	\N	\N	62171	62171	230351
495	429	2	applied	\N	\N	\N	\N	62172	62172	230352
496	430	0	applied	\N	\N	\N	\N	62173	62173	230353
497	431	0	applied	\N	\N	\N	\N	62174	62174	230354
497	432	1	applied	\N	\N	\N	\N	62175	62175	230355
498	433	0	applied	\N	\N	\N	\N	62176	62176	230356
499	435	0	applied	\N	\N	\N	\N	62178	62178	230358
500	436	0	applied	\N	\N	\N	\N	62179	62179	230359
501	436	0	applied	\N	\N	\N	\N	62180	62180	230360
502	437	0	applied	\N	\N	\N	\N	62181	62181	230361
502	438	1	applied	\N	\N	\N	\N	62182	62182	230362
503	439	0	applied	\N	\N	\N	\N	62183	62183	230363
503	440	1	applied	\N	\N	1000000000	\N	62184	62184	230364
503	441	2	applied	\N	\N	1000000000	\N	62185	62185	230365
504	442	0	applied	\N	\N	\N	\N	62186	62186	230366
505	443	0	applied	\N	\N	\N	\N	62187	62187	230367
505	444	1	applied	\N	\N	\N	\N	62188	62188	230368
505	445	2	applied	\N	\N	\N	\N	62189	62189	230369
506	443	0	applied	\N	\N	\N	\N	62190	62190	230370
506	444	1	applied	\N	\N	\N	\N	62191	62191	230371
506	445	2	applied	\N	\N	\N	\N	62192	62192	230372
507	443	0	applied	\N	\N	\N	\N	62193	62193	230373
507	444	1	applied	\N	\N	\N	\N	62194	62194	230374
507	445	2	applied	\N	\N	\N	\N	62195	62195	230375
508	446	0	applied	\N	\N	\N	\N	62196	62196	230376
510	447	0	applied	\N	\N	\N	\N	62198	62198	230378
511	447	0	applied	\N	\N	\N	\N	62199	62199	230379
512	447	0	applied	\N	\N	\N	\N	62200	62200	230380
513	448	0	applied	\N	\N	\N	\N	62201	62201	230381
513	449	1	applied	\N	\N	\N	\N	62202	62202	230382
513	450	2	applied	\N	\N	\N	\N	62203	62203	230383
513	451	3	applied	\N	\N	\N	\N	62204	62204	230384
514	452	0	applied	\N	\N	\N	\N	62205	62205	230385
515	452	0	applied	\N	\N	\N	\N	62206	62206	230386
517	453	0	applied	\N	\N	\N	\N	62207	62207	230387
517	454	1	applied	\N	\N	\N	\N	62208	62208	230388
517	455	2	applied	\N	\N	\N	\N	62209	62209	230389
518	456	0	applied	\N	\N	\N	\N	62210	62210	230390
518	457	1	applied	\N	\N	\N	\N	62211	62211	230391
519	456	0	applied	\N	\N	\N	\N	62212	62212	230392
519	457	1	applied	\N	\N	\N	\N	62213	62213	230393
520	459	1	applied	\N	\N	\N	\N	62215	62215	230395
520	460	2	applied	\N	\N	\N	\N	62216	62216	230396
520	461	3	applied	\N	\N	\N	\N	62217	62217	230397
520	462	4	applied	\N	\N	\N	\N	62218	62218	230398
521	458	0	applied	\N	\N	\N	\N	62219	62219	230399
521	459	1	applied	\N	\N	\N	\N	62220	62220	230400
521	460	2	applied	\N	\N	\N	\N	62221	62221	230401
521	461	3	applied	\N	\N	\N	\N	62222	62222	230402
521	462	4	applied	\N	\N	\N	\N	62223	62223	230403
522	463	0	applied	\N	\N	\N	\N	62224	62224	230404
522	464	1	applied	\N	\N	\N	\N	62225	62225	230405
523	465	0	applied	\N	\N	\N	\N	62226	62226	230406
523	466	1	applied	\N	\N	\N	\N	62227	62227	230407
523	467	2	applied	\N	\N	\N	\N	62228	62228	230408
524	468	0	applied	\N	\N	\N	\N	62229	62229	230409
525	469	0	applied	\N	\N	\N	\N	62230	62230	230410
526	471	1	applied	\N	\N	1000000000	\N	62232	62232	230412
527	470	0	applied	\N	\N	\N	\N	62233	62233	230413
527	471	1	applied	\N	\N	1000000000	\N	62234	62234	230414
528	472	0	applied	\N	\N	\N	\N	62235	62235	230415
529	473	0	applied	\N	\N	\N	\N	62236	62236	230416
530	474	0	applied	\N	\N	\N	\N	62237	62237	230417
531	475	0	applied	\N	\N	\N	\N	62238	62238	230418
532	476	0	applied	\N	\N	\N	\N	62239	62239	230419
468	405	0	applied	\N	\N	\N	\N	62122	62122	230302
469	406	0	applied	\N	\N	\N	\N	62123	62123	230303
536	478	0	applied	\N	\N	\N	\N	62243	62243	230423
537	479	0	applied	\N	\N	\N	\N	62244	62244	230424
537	480	1	applied	\N	\N	\N	\N	62245	62245	230425
538	480	1	applied	\N	\N	\N	\N	62247	62247	230427
539	479	0	applied	\N	\N	\N	\N	62248	62248	230428
539	480	1	applied	\N	\N	\N	\N	62249	62249	230429
540	481	0	applied	\N	\N	\N	\N	62250	62250	230430
541	482	0	applied	\N	\N	\N	\N	62251	62251	230431
542	482	0	applied	\N	\N	\N	\N	62252	62252	230432
543	482	0	applied	\N	\N	\N	\N	62253	62253	230433
544	483	0	applied	\N	\N	\N	\N	62254	62254	230434
545	483	0	applied	\N	\N	\N	\N	62255	62255	230435
546	484	0	applied	\N	\N	\N	\N	62256	62256	230436
546	485	1	applied	\N	\N	\N	\N	62257	62257	230437
546	486	2	applied	\N	\N	\N	\N	62258	62258	230438
547	484	0	applied	\N	\N	\N	\N	62259	62259	230439
547	485	1	applied	\N	\N	\N	\N	62260	62260	230440
547	486	2	applied	\N	\N	\N	\N	62261	62261	230441
548	487	0	applied	\N	\N	\N	\N	62262	62262	230442
550	488	0	applied	\N	\N	\N	\N	62264	62264	230444
551	489	0	applied	\N	\N	\N	\N	62265	62265	230445
552	490	0	applied	\N	\N	\N	\N	62266	62266	230446
553	490	0	applied	\N	\N	\N	\N	62267	62267	230447
554	490	0	applied	\N	\N	\N	\N	62268	62268	230448
555	490	0	applied	\N	\N	\N	\N	62269	62269	230449
556	491	0	applied	\N	\N	\N	\N	62270	62270	230450
557	491	0	applied	\N	\N	\N	\N	62271	62271	230451
558	492	0	applied	\N	\N	\N	\N	62272	62272	230452
559	493	0	applied	\N	\N	\N	\N	62273	62273	230453
560	494	0	applied	\N	\N	\N	\N	62274	62274	230454
560	495	1	applied	\N	\N	\N	\N	62275	62275	230455
561	494	0	applied	\N	\N	\N	\N	62276	62276	230456
561	495	1	applied	\N	\N	\N	\N	62277	62277	230457
562	494	0	applied	\N	\N	\N	\N	62278	62278	230458
562	495	1	applied	\N	\N	\N	\N	62279	62279	230459
564	497	0	applied	\N	\N	\N	\N	62281	62281	230461
565	497	0	applied	\N	\N	\N	\N	62282	62282	230462
566	498	0	applied	\N	\N	\N	\N	62283	62283	230463
567	498	0	applied	\N	\N	\N	\N	62284	62284	230464
568	499	0	applied	\N	\N	\N	\N	62285	62285	230465
569	499	0	applied	\N	\N	\N	\N	62286	62286	230466
570	500	0	applied	\N	\N	\N	\N	62287	62287	230467
571	501	0	applied	\N	\N	\N	\N	62288	62288	230468
572	502	0	applied	\N	\N	\N	\N	62289	62289	230469
573	502	0	applied	\N	\N	\N	\N	62290	62290	230470
574	502	0	applied	\N	\N	\N	\N	62291	62291	230471
575	502	0	applied	\N	\N	\N	\N	62292	62292	230472
576	503	0	applied	\N	\N	\N	\N	62293	62293	230473
576	504	1	applied	\N	\N	\N	\N	62294	62294	230474
576	505	2	applied	\N	\N	\N	\N	62295	62295	230475
577	503	0	applied	\N	\N	\N	\N	62296	62296	230476
577	505	2	applied	\N	\N	\N	\N	62298	62298	230478
578	506	0	applied	\N	\N	\N	\N	62299	62299	230479
579	509	1	applied	\N	\N	\N	\N	62302	62302	230480
578	507	1	failed	Receiver_not_present	\N	\N	\N	62300	62300	\N
579	508	0	failed	Receiver_not_present	\N	\N	\N	62301	62301	\N
579	510	2	applied	\N	\N	\N	\N	62303	62303	230481
580	509	1	applied	\N	\N	\N	\N	62305	62305	230482
670	575	3	applied	\N	\N	\N	\N	62433	62433	230610
580	508	0	failed	Receiver_not_present	\N	\N	\N	62304	62304	\N
580	510	2	applied	\N	\N	\N	\N	62306	62306	230483
581	511	0	applied	\N	\N	\N	\N	62307	62307	230484
582	512	0	applied	\N	\N	\N	\N	62308	62308	230485
583	513	0	applied	\N	\N	\N	\N	62309	62309	230486
584	513	0	applied	\N	\N	\N	\N	62310	62310	230487
585	513	0	applied	\N	\N	\N	\N	62311	62311	230488
586	514	0	applied	\N	\N	\N	\N	62312	62312	230489
587	514	0	applied	\N	\N	\N	\N	62313	62313	230490
589	516	0	applied	\N	\N	\N	\N	62315	62315	230492
590	517	0	applied	\N	\N	\N	\N	62316	62316	230493
591	518	0	applied	\N	\N	\N	\N	62317	62317	230494
591	519	1	applied	\N	\N	1000000000	\N	62318	62318	230495
591	520	2	applied	\N	\N	\N	\N	62319	62319	230496
592	521	0	applied	\N	\N	\N	\N	62320	62320	230497
593	521	0	applied	\N	\N	\N	\N	62321	62321	230498
594	521	0	applied	\N	\N	\N	\N	62322	62322	230499
595	522	0	applied	\N	\N	\N	\N	62323	62323	230500
596	523	0	applied	\N	\N	\N	\N	62324	62324	230501
596	524	1	applied	\N	\N	\N	\N	62325	62325	230502
597	525	0	applied	\N	\N	\N	\N	62326	62326	230503
598	525	0	applied	\N	\N	\N	\N	62327	62327	230504
599	526	0	applied	\N	\N	\N	\N	62328	62328	230505
600	527	0	applied	\N	\N	\N	\N	62329	62329	230506
601	527	0	applied	\N	\N	\N	\N	62330	62330	230507
603	528	0	applied	\N	\N	\N	\N	62332	62332	230509
604	528	0	applied	\N	\N	\N	\N	62333	62333	230510
605	528	0	applied	\N	\N	\N	\N	62334	62334	230511
606	529	0	applied	\N	\N	\N	\N	62335	62335	230512
607	529	0	applied	\N	\N	\N	\N	62336	62336	230513
608	529	0	applied	\N	\N	\N	\N	62337	62337	230514
609	530	0	applied	\N	\N	\N	\N	62338	62338	230515
610	530	0	applied	\N	\N	\N	\N	62339	62339	230516
611	531	0	applied	\N	\N	\N	\N	62340	62340	230517
612	531	0	applied	\N	\N	\N	\N	62341	62341	230518
613	531	0	applied	\N	\N	\N	\N	62342	62342	230519
614	532	0	applied	\N	\N	\N	\N	62343	62343	230520
615	532	0	applied	\N	\N	\N	\N	62344	62344	230521
616	532	0	applied	\N	\N	\N	\N	62345	62345	230522
617	533	0	applied	\N	\N	\N	\N	62346	62346	230523
618	533	0	applied	\N	\N	\N	\N	62347	62347	230524
622	535	0	applied	\N	\N	\N	\N	62349	62349	230526
622	536	1	applied	\N	\N	\N	\N	62350	62350	230527
623	537	0	applied	\N	\N	\N	\N	62351	62351	230528
624	538	0	applied	\N	\N	\N	\N	62352	62352	230529
625	538	0	applied	\N	\N	\N	\N	62354	62354	230531
625	539	1	applied	\N	\N	\N	\N	62355	62355	230532
627	540	0	applied	\N	\N	\N	\N	62358	62358	230535
627	541	1	applied	\N	\N	\N	\N	62359	62359	230536
628	542	0	applied	\N	\N	\N	\N	62360	62360	230537
629	542	0	applied	\N	\N	\N	\N	62361	62361	230538
534	477	0	applied	\N	\N	\N	\N	62241	62241	230421
535	478	0	applied	\N	\N	\N	\N	62242	62242	230422
631	543	0	applied	\N	\N	\N	\N	62363	62363	230540
632	543	0	applied	\N	\N	\N	\N	62364	62364	230541
633	544	0	applied	\N	\N	\N	\N	62365	62365	230542
634	545	0	applied	\N	\N	\N	\N	62366	62366	230543
635	545	0	applied	\N	\N	\N	\N	62367	62367	230544
636	545	0	applied	\N	\N	\N	\N	62368	62368	230545
637	546	0	applied	\N	\N	\N	\N	62369	62369	230546
638	547	0	applied	\N	\N	\N	\N	62370	62370	230547
639	548	0	applied	\N	\N	\N	\N	62371	62371	230548
640	548	0	applied	\N	\N	\N	\N	62372	62372	230549
641	549	0	applied	\N	\N	\N	\N	62373	62373	230550
642	549	0	applied	\N	\N	\N	\N	62374	62374	230551
643	549	0	applied	\N	\N	\N	\N	62375	62375	230552
644	550	0	applied	\N	\N	\N	\N	62376	62376	230553
645	551	0	applied	\N	\N	\N	\N	62377	62377	230554
645	552	1	applied	\N	\N	\N	\N	62378	62378	230555
646	552	1	applied	\N	\N	\N	\N	62380	62380	230557
647	553	0	applied	\N	\N	\N	\N	62381	62381	230558
647	554	1	applied	\N	\N	\N	\N	62382	62382	230559
648	555	0	applied	\N	\N	\N	\N	62383	62383	230560
649	555	0	applied	\N	\N	\N	\N	62384	62384	230561
650	555	0	applied	\N	\N	\N	\N	62385	62385	230562
651	556	0	applied	\N	\N	\N	\N	62386	62386	230563
651	557	1	applied	\N	\N	\N	\N	62387	62387	230564
651	558	3	applied	\N	\N	\N	\N	62388	62388	230565
651	559	4	applied	\N	\N	\N	\N	62389	62389	230566
652	556	0	applied	\N	\N	\N	\N	62390	62390	230567
652	557	1	applied	\N	\N	\N	\N	62391	62391	230568
652	558	3	applied	\N	\N	\N	\N	62392	62392	230569
652	559	4	applied	\N	\N	\N	\N	62393	62393	230570
653	556	0	applied	\N	\N	\N	\N	62394	62394	230571
653	557	1	applied	\N	\N	\N	\N	62395	62395	230572
653	559	4	applied	\N	\N	\N	\N	62397	62397	230574
654	556	0	applied	\N	\N	\N	\N	62398	62398	230575
654	557	1	applied	\N	\N	\N	\N	62399	62399	230576
654	558	3	applied	\N	\N	\N	\N	62400	62400	230577
654	559	4	applied	\N	\N	\N	\N	62401	62401	230578
655	560	0	applied	\N	\N	\N	\N	62402	62402	230579
655	561	1	applied	\N	\N	\N	\N	62403	62403	230580
656	560	0	applied	\N	\N	\N	\N	62404	62404	230581
656	561	1	applied	\N	\N	\N	\N	62405	62405	230582
657	560	0	applied	\N	\N	\N	\N	62406	62406	230583
657	561	1	applied	\N	\N	\N	\N	62407	62407	230584
658	562	0	applied	\N	\N	\N	\N	62408	62408	230585
659	562	0	applied	\N	\N	\N	\N	62409	62409	230586
660	563	0	applied	\N	\N	\N	\N	62410	62410	230587
660	564	1	applied	\N	\N	\N	\N	62411	62411	230588
660	565	2	applied	\N	\N	\N	\N	62412	62412	230589
661	563	0	applied	\N	\N	\N	\N	62414	62414	230591
661	564	1	applied	\N	\N	\N	\N	62415	62415	230592
661	565	2	applied	\N	\N	\N	\N	62416	62416	230593
661	566	3	applied	\N	\N	\N	\N	62417	62417	230594
662	563	0	applied	\N	\N	\N	\N	62418	62418	230595
662	564	1	applied	\N	\N	\N	\N	62419	62419	230596
662	565	2	applied	\N	\N	\N	\N	62420	62420	230597
662	566	3	applied	\N	\N	\N	\N	62421	62421	230598
663	567	0	applied	\N	\N	\N	\N	62422	62422	230599
664	567	0	applied	\N	\N	\N	\N	62423	62423	230600
665	568	0	applied	\N	\N	\N	\N	62424	62424	230601
666	568	0	applied	\N	\N	\N	\N	62425	62425	230602
667	569	0	applied	\N	\N	\N	\N	62426	62426	230603
668	569	0	applied	\N	\N	\N	\N	62427	62427	230604
669	570	0	applied	\N	\N	\N	\N	62428	62428	230605
669	571	1	applied	\N	\N	\N	\N	62429	62429	230606
670	573	1	applied	\N	\N	\N	\N	62431	62431	230608
670	574	2	applied	\N	\N	\N	\N	62432	62432	230609
670	576	4	applied	\N	\N	\N	\N	62434	62434	230611
670	577	5	applied	\N	\N	\N	\N	62435	62435	230612
671	578	0	applied	\N	\N	\N	\N	62436	62436	230613
672	578	0	applied	\N	\N	\N	\N	62437	62437	230614
673	579	0	applied	\N	\N	\N	\N	62438	62438	230615
674	580	0	applied	\N	\N	\N	\N	62439	62439	230616
675	580	0	applied	\N	\N	\N	\N	62440	62440	230617
676	581	0	applied	\N	\N	\N	\N	62441	62441	230618
676	582	1	applied	\N	\N	\N	\N	62442	62442	230619
676	583	2	applied	\N	\N	\N	\N	62443	62443	230620
676	584	3	applied	\N	\N	\N	\N	62444	62444	230621
676	585	4	applied	\N	\N	\N	\N	62445	62445	230622
677	586	0	applied	\N	\N	\N	\N	62446	62446	230623
679	587	0	applied	\N	\N	\N	\N	62448	62448	230625
679	588	1	applied	\N	\N	\N	\N	62449	62449	230626
680	587	0	applied	\N	\N	\N	\N	62450	62450	230627
680	588	1	applied	\N	\N	\N	\N	62451	62451	230628
681	589	0	applied	\N	\N	\N	\N	62452	62452	230629
681	590	1	applied	\N	\N	\N	\N	62453	62453	230630
682	591	0	applied	\N	\N	\N	\N	62454	62454	230631
683	592	0	applied	\N	\N	\N	\N	62455	62455	230632
684	592	0	applied	\N	\N	\N	\N	62456	62456	230633
685	593	0	applied	\N	\N	\N	\N	62457	62457	230634
686	593	0	applied	\N	\N	\N	\N	62458	62458	230635
687	594	0	applied	\N	\N	\N	\N	62459	62459	230636
687	595	1	applied	\N	\N	\N	\N	62460	62460	230637
688	594	0	applied	\N	\N	\N	\N	62461	62461	230638
688	595	1	applied	\N	\N	\N	\N	62462	62462	230639
689	596	0	applied	\N	\N	\N	\N	62463	62463	230640
691	596	0	applied	\N	\N	\N	\N	62465	62465	230642
692	596	0	applied	\N	\N	\N	\N	62466	62466	230643
693	597	0	applied	\N	\N	\N	\N	62467	62467	230644
695	598	0	applied	\N	\N	\N	\N	62469	62469	230646
696	598	0	applied	\N	\N	\N	\N	62470	62470	230647
697	599	0	applied	\N	\N	\N	\N	62471	62471	230648
697	600	1	applied	\N	\N	\N	\N	62472	62472	230649
701	603	0	applied	\N	\N	\N	\N	62478	62478	230655
702	604	0	applied	\N	\N	\N	\N	62479	62479	230656
702	605	1	applied	\N	\N	\N	\N	62480	62480	230657
702	606	2	applied	\N	\N	\N	\N	62481	62481	230658
706	610	0	applied	\N	\N	\N	\N	62488	62488	230665
711	616	0	applied	\N	\N	\N	\N	62495	62495	230672
714	616	0	applied	\N	\N	\N	\N	62504	62504	230681
626	538	0	applied	\N	\N	\N	\N	62356	62356	230533
626	539	1	applied	\N	\N	\N	\N	62357	62357	230534
699	602	1	applied	\N	\N	\N	\N	62476	62476	230653
700	603	0	applied	\N	\N	\N	\N	62477	62477	230654
703	604	0	applied	\N	\N	\N	\N	62482	62482	230659
703	605	1	applied	\N	\N	\N	\N	62483	62483	230660
703	606	2	applied	\N	\N	\N	\N	62484	62484	230661
704	607	0	applied	\N	\N	\N	\N	62485	62485	230662
704	608	1	applied	\N	\N	\N	\N	62486	62486	230663
705	609	0	applied	\N	\N	\N	\N	62487	62487	230664
707	611	0	applied	\N	\N	\N	\N	62489	62489	230666
707	612	1	applied	\N	\N	\N	\N	62490	62490	230667
707	613	2	applied	\N	\N	\N	\N	62491	62491	230668
708	614	0	applied	\N	\N	\N	\N	62492	62492	230669
709	615	0	applied	\N	\N	\N	\N	62493	62493	230670
710	615	0	applied	\N	\N	\N	\N	62494	62494	230671
712	587	0	applied	\N	\N	\N	\N	62496	62496	230673
712	518	2	applied	\N	\N	\N	\N	62498	62498	230675
712	519	3	applied	\N	\N	1000000000	\N	62499	62499	230676
712	556	4	applied	\N	\N	\N	\N	62500	62500	230677
713	587	0	applied	\N	\N	\N	\N	62501	62501	230678
713	589	1	applied	\N	\N	\N	\N	62502	62502	230679
713	556	2	applied	\N	\N	\N	\N	62503	62503	230680
717	617	0	applied	\N	\N	\N	\N	62505	62505	230682
717	618	1	applied	\N	\N	\N	\N	62506	62506	230683
717	619	2	applied	\N	\N	\N	\N	62507	62507	230684
718	620	0	applied	\N	\N	\N	\N	62508	62508	230685
718	621	1	applied	\N	\N	\N	\N	62509	62509	230686
718	622	2	applied	\N	\N	\N	\N	62510	62510	230687
719	624	1	applied	\N	\N	\N	\N	62512	62512	230688
720	624	1	applied	\N	\N	\N	\N	62514	62514	230689
720	623	0	failed	Receiver_not_present	\N	\N	\N	62513	62513	\N
721	626	1	applied	\N	\N	\N	\N	62516	62516	230690
721	625	0	failed	Receiver_not_present	\N	\N	\N	62515	62515	\N
721	627	2	applied	\N	\N	\N	\N	62517	62517	230691
722	628	0	applied	\N	\N	\N	\N	62518	62518	230692
723	628	0	applied	\N	\N	\N	\N	62519	62519	230693
724	630	1	applied	\N	\N	\N	\N	62521	62521	230694
724	629	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	62520	62520	\N
724	631	2	applied	\N	\N	\N	\N	62522	62522	230695
724	632	3	applied	\N	\N	\N	\N	62523	62523	230696
725	630	1	applied	\N	\N	\N	\N	62525	62525	230697
725	629	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	62524	62524	\N
725	631	2	applied	\N	\N	\N	\N	62526	62526	230698
725	632	3	applied	\N	\N	\N	\N	62527	62527	230699
726	633	0	applied	\N	\N	\N	\N	62528	62528	230700
727	633	0	applied	\N	\N	\N	\N	62529	62529	230701
728	634	0	applied	\N	\N	\N	\N	62530	62530	230702
728	635	1	applied	\N	\N	\N	\N	62531	62531	230703
729	636	0	applied	\N	\N	\N	\N	62532	62532	230704
730	637	0	applied	\N	\N	\N	\N	62533	62533	230705
731	638	0	applied	\N	\N	\N	\N	62534	62534	230706
732	638	0	applied	\N	\N	\N	\N	62535	62535	230707
734	639	0	applied	\N	\N	\N	\N	62537	62537	230709
735	640	0	applied	\N	\N	\N	\N	62538	62538	230710
736	641	0	applied	\N	\N	\N	\N	62539	62539	230711
736	642	1	applied	\N	\N	\N	\N	62540	62540	230712
737	643	0	applied	\N	\N	\N	\N	62541	62541	230713
738	643	0	applied	\N	\N	\N	\N	62542	62542	230714
739	643	0	applied	\N	\N	\N	\N	62543	62543	230715
740	643	0	applied	\N	\N	\N	\N	62544	62544	230716
741	644	0	applied	\N	\N	\N	\N	62545	62545	230717
741	645	1	applied	\N	\N	\N	\N	62546	62546	230718
742	646	0	applied	\N	\N	\N	\N	62547	62547	230719
743	647	0	applied	\N	\N	\N	\N	62548	62548	230720
743	648	1	applied	\N	\N	\N	\N	62549	62549	230721
744	649	0	applied	\N	\N	\N	\N	62550	62550	230722
745	649	0	applied	\N	\N	\N	\N	62551	62551	230723
746	649	0	applied	\N	\N	\N	\N	62552	62552	230724
748	650	0	applied	\N	\N	\N	\N	62554	62554	230726
749	651	0	applied	\N	\N	\N	\N	62555	62555	230727
750	651	0	applied	\N	\N	\N	\N	62556	62556	230728
751	651	0	applied	\N	\N	\N	\N	62557	62557	230729
752	652	0	applied	\N	\N	\N	\N	62558	62558	230730
753	652	0	applied	\N	\N	\N	\N	62559	62559	230731
754	653	0	applied	\N	\N	\N	\N	62560	62560	230732
755	653	0	applied	\N	\N	\N	\N	62561	62561	230733
756	654	0	applied	\N	\N	\N	\N	62562	62562	230734
756	655	1	applied	\N	\N	\N	\N	62563	62563	230735
757	654	0	applied	\N	\N	\N	\N	62564	62564	230736
757	655	1	applied	\N	\N	\N	\N	62565	62565	230737
758	656	0	applied	\N	\N	\N	\N	62566	62566	230738
759	656	0	applied	\N	\N	\N	\N	62567	62567	230739
760	656	0	applied	\N	\N	\N	\N	62568	62568	230740
761	656	0	applied	\N	\N	\N	\N	62569	62569	230741
762	589	1	applied	\N	\N	\N	\N	62571	62571	230743
762	627	5	applied	\N	\N	\N	\N	62575	62575	230744
762	625	2	failed	Receiver_not_present	\N	\N	\N	62572	62572	\N
762	623	3	failed	Receiver_not_present	\N	\N	\N	62573	62573	\N
762	629	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	62574	62574	\N
763	656	0	applied	\N	\N	\N	\N	62576	62576	230745
764	657	0	applied	\N	\N	\N	\N	62577	62577	230746
765	658	0	applied	\N	\N	\N	\N	62578	62578	230747
765	659	1	applied	\N	\N	1000000000	\N	62579	62579	230748
765	660	2	applied	\N	\N	\N	\N	62580	62580	230749
766	658	0	applied	\N	\N	\N	\N	62581	62581	230750
766	659	1	applied	\N	\N	1000000000	\N	62582	62582	230751
766	660	2	applied	\N	\N	\N	\N	62583	62583	230752
767	658	0	applied	\N	\N	\N	\N	62584	62584	230753
767	660	2	applied	\N	\N	\N	\N	62586	62586	230755
768	661	0	applied	\N	\N	\N	\N	62587	62587	230756
769	661	0	applied	\N	\N	\N	\N	62588	62588	230757
770	662	0	applied	\N	\N	\N	\N	62589	62589	230758
770	663	1	applied	\N	\N	\N	\N	62590	62590	230759
770	664	2	applied	\N	\N	\N	\N	62591	62591	230760
770	665	3	applied	\N	\N	\N	\N	62592	62592	230761
771	662	0	applied	\N	\N	\N	\N	62593	62593	230762
771	663	1	applied	\N	\N	\N	\N	62594	62594	230763
771	664	2	applied	\N	\N	\N	\N	62595	62595	230764
698	599	0	applied	\N	\N	\N	\N	62473	62473	230650
699	601	0	applied	\N	\N	\N	\N	62475	62475	230652
773	669	0	applied	\N	\N	\N	\N	62600	62600	230769
774	670	0	applied	\N	\N	\N	\N	62601	62601	230770
774	671	1	applied	\N	\N	\N	\N	62602	62602	230771
775	670	0	applied	\N	\N	\N	\N	62603	62603	230772
775	671	1	applied	\N	\N	\N	\N	62604	62604	230773
776	670	0	applied	\N	\N	\N	\N	62605	62605	230774
776	671	1	applied	\N	\N	\N	\N	62606	62606	230775
777	672	0	applied	\N	\N	\N	\N	62607	62607	230776
778	672	0	applied	\N	\N	\N	\N	62608	62608	230777
779	672	0	applied	\N	\N	\N	\N	62609	62609	230778
780	673	0	applied	\N	\N	\N	\N	62610	62610	230779
780	674	1	applied	\N	\N	\N	\N	62611	62611	230780
780	675	2	applied	\N	\N	\N	\N	62612	62612	230781
781	673	0	applied	\N	\N	\N	\N	62613	62613	230782
781	674	1	applied	\N	\N	\N	\N	62614	62614	230783
781	675	2	applied	\N	\N	\N	\N	62615	62615	230784
782	674	1	applied	\N	\N	\N	\N	62617	62617	230786
782	675	2	applied	\N	\N	\N	\N	62618	62618	230787
784	676	0	applied	\N	\N	\N	\N	62619	62619	230788
784	677	1	applied	\N	\N	\N	\N	62620	62620	230789
784	678	2	applied	\N	\N	\N	\N	62621	62621	230790
785	676	0	applied	\N	\N	\N	\N	62622	62622	230791
785	677	1	applied	\N	\N	\N	\N	62623	62623	230792
785	678	2	applied	\N	\N	\N	\N	62624	62624	230793
786	676	0	applied	\N	\N	\N	\N	62625	62625	230794
786	677	1	applied	\N	\N	\N	\N	62626	62626	230795
786	678	2	applied	\N	\N	\N	\N	62627	62627	230796
787	676	0	applied	\N	\N	\N	\N	62628	62628	230797
787	677	1	applied	\N	\N	\N	\N	62629	62629	230798
787	678	2	applied	\N	\N	\N	\N	62630	62630	230799
788	679	0	applied	\N	\N	\N	\N	62631	62631	230800
789	679	0	applied	\N	\N	\N	\N	62632	62632	230801
791	681	0	applied	\N	\N	\N	\N	62634	62634	230803
792	681	0	applied	\N	\N	\N	\N	62635	62635	230804
793	682	0	applied	\N	\N	\N	\N	62636	62636	230805
794	683	0	applied	\N	\N	\N	\N	62637	62637	230806
794	684	1	applied	\N	\N	\N	\N	62638	62638	230807
795	685	0	applied	\N	\N	\N	\N	62639	62639	230808
796	685	0	applied	\N	\N	\N	\N	62640	62640	230809
797	686	0	applied	\N	\N	\N	\N	62641	62641	230810
798	686	0	applied	\N	\N	\N	\N	62642	62642	230811
799	686	0	applied	\N	\N	\N	\N	62643	62643	230812
800	687	0	applied	\N	\N	\N	\N	62644	62644	230813
801	687	0	applied	\N	\N	\N	\N	62645	62645	230814
802	687	0	applied	\N	\N	\N	\N	62646	62646	230815
803	688	0	applied	\N	\N	\N	\N	62647	62647	230816
803	689	1	applied	\N	\N	\N	\N	62648	62648	230817
804	688	0	applied	\N	\N	\N	\N	62649	62649	230818
805	690	0	applied	\N	\N	\N	\N	62651	62651	230820
806	691	0	applied	\N	\N	\N	\N	62652	62652	230821
806	692	1	applied	\N	\N	\N	\N	62653	62653	230822
806	693	2	applied	\N	\N	\N	\N	62654	62654	230823
807	691	0	applied	\N	\N	\N	\N	62655	62655	230824
807	692	1	applied	\N	\N	\N	\N	62656	62656	230825
807	693	2	applied	\N	\N	\N	\N	62657	62657	230826
808	694	0	applied	\N	\N	\N	\N	62658	62658	230827
809	695	0	applied	\N	\N	\N	\N	62659	62659	230828
809	696	1	applied	\N	\N	\N	\N	62660	62660	230829
810	695	0	applied	\N	\N	\N	\N	62661	62661	230830
810	696	1	applied	\N	\N	\N	\N	62662	62662	230831
811	697	0	applied	\N	\N	\N	\N	62663	62663	230832
812	697	0	applied	\N	\N	\N	\N	62664	62664	230833
813	698	0	applied	\N	\N	\N	\N	62665	62665	230834
814	698	0	applied	\N	\N	\N	\N	62666	62666	230835
816	699	0	applied	\N	\N	\N	\N	62668	62668	230837
817	700	0	applied	\N	\N	\N	\N	62669	62669	230838
817	701	1	applied	\N	\N	\N	\N	62670	62670	230839
818	702	0	applied	\N	\N	\N	\N	62671	62671	230840
819	702	0	applied	\N	\N	\N	\N	62672	62672	230841
820	703	0	applied	\N	\N	\N	\N	62673	62673	230842
821	703	0	applied	\N	\N	\N	\N	62674	62674	230843
822	703	0	applied	\N	\N	\N	\N	62675	62675	230844
823	704	0	applied	\N	\N	\N	\N	62676	62676	230845
823	705	1	applied	\N	\N	\N	\N	62677	62677	230846
824	704	0	applied	\N	\N	\N	\N	62678	62678	230847
824	705	1	applied	\N	\N	\N	\N	62679	62679	230848
825	704	0	applied	\N	\N	\N	\N	62680	62680	230849
825	705	1	applied	\N	\N	\N	\N	62681	62681	230850
826	704	0	applied	\N	\N	\N	\N	62682	62682	230851
826	705	1	applied	\N	\N	\N	\N	62683	62683	230852
828	706	0	applied	\N	\N	\N	\N	62685	62685	230854
829	707	0	applied	\N	\N	\N	\N	62686	62686	230855
830	708	0	applied	\N	\N	\N	\N	62687	62687	230856
831	708	0	applied	\N	\N	\N	\N	62688	62688	230857
832	708	0	applied	\N	\N	\N	\N	62689	62689	230858
833	709	0	applied	\N	\N	\N	\N	62690	62690	230859
834	709	0	applied	\N	\N	\N	\N	62691	62691	230860
835	710	0	applied	\N	\N	\N	\N	62692	62692	230861
836	710	0	applied	\N	\N	\N	\N	62693	62693	230862
837	711	0	applied	\N	\N	\N	\N	62694	62694	230863
837	712	1	applied	\N	\N	\N	\N	62695	62695	230864
838	713	0	applied	\N	\N	\N	\N	62696	62696	230865
838	714	1	applied	\N	\N	\N	\N	62697	62697	230866
839	715	0	applied	\N	\N	\N	\N	62698	62698	230867
839	716	1	applied	\N	\N	\N	\N	62699	62699	230868
840	715	0	applied	\N	\N	\N	\N	62700	62700	230869
841	717	0	applied	\N	\N	\N	\N	62702	62702	230871
842	717	0	applied	\N	\N	\N	\N	62703	62703	230872
843	718	0	applied	\N	\N	\N	\N	62704	62704	230873
844	718	0	applied	\N	\N	\N	\N	62705	62705	230874
845	719	0	applied	\N	\N	\N	\N	62706	62706	230875
846	720	0	applied	\N	\N	\N	\N	62707	62707	230876
847	721	0	applied	\N	\N	\N	\N	62708	62708	230877
847	722	1	applied	\N	\N	\N	\N	62709	62709	230878
848	723	0	applied	\N	\N	\N	\N	62710	62710	230879
849	724	0	applied	\N	\N	\N	\N	62711	62711	230880
850	725	0	applied	\N	\N	\N	\N	62712	62712	230881
851	726	0	applied	\N	\N	\N	\N	62713	62713	230882
853	727	0	applied	\N	\N	\N	\N	62714	62714	230883
853	728	1	applied	\N	\N	\N	\N	62715	62715	230884
772	666	0	applied	\N	\N	\N	\N	62597	62597	230766
772	667	1	applied	\N	\N	\N	\N	62598	62598	230767
854	729	2	applied	\N	\N	\N	\N	62720	62720	230889
854	730	3	applied	\N	\N	\N	\N	62721	62721	230890
855	731	0	applied	\N	\N	\N	\N	62722	62722	230891
855	732	1	applied	\N	\N	\N	\N	62723	62723	230892
855	733	2	applied	\N	\N	\N	\N	62724	62724	230893
856	731	0	applied	\N	\N	\N	\N	62725	62725	230894
856	732	1	applied	\N	\N	\N	\N	62726	62726	230895
856	733	2	applied	\N	\N	\N	\N	62727	62727	230896
857	734	0	applied	\N	\N	\N	\N	62728	62728	230897
858	734	0	applied	\N	\N	\N	\N	62729	62729	230898
859	734	0	applied	\N	\N	\N	\N	62730	62730	230899
860	735	0	applied	\N	\N	\N	\N	62731	62731	230900
860	736	1	applied	\N	\N	\N	\N	62732	62732	230901
860	737	2	applied	\N	\N	\N	\N	62733	62733	230902
860	738	3	applied	\N	\N	\N	\N	62734	62734	230903
861	736	1	applied	\N	\N	\N	\N	62736	62736	230905
861	737	2	applied	\N	\N	\N	\N	62737	62737	230906
861	738	3	applied	\N	\N	\N	\N	62738	62738	230907
862	739	0	applied	\N	\N	\N	\N	62739	62739	230908
863	739	0	applied	\N	\N	\N	\N	62740	62740	230909
864	739	0	applied	\N	\N	\N	\N	62741	62741	230910
865	740	0	applied	\N	\N	\N	\N	62742	62742	230911
865	741	1	applied	\N	\N	\N	\N	62743	62743	230912
866	740	0	applied	\N	\N	\N	\N	62744	62744	230913
866	741	1	applied	\N	\N	\N	\N	62745	62745	230914
867	742	0	applied	\N	\N	\N	\N	62746	62746	230915
868	743	0	applied	\N	\N	\N	\N	62747	62747	230916
869	744	0	applied	\N	\N	\N	\N	62748	62748	230917
870	744	0	applied	\N	\N	\N	\N	62749	62749	230918
871	745	0	applied	\N	\N	\N	\N	62750	62750	230919
872	745	0	applied	\N	\N	\N	\N	62751	62751	230920
874	746	0	applied	\N	\N	\N	\N	62753	62753	230922
874	747	1	applied	\N	\N	\N	\N	62754	62754	230923
875	748	0	applied	\N	\N	\N	\N	62755	62755	230924
875	749	1	applied	\N	\N	\N	\N	62756	62756	230925
876	750	0	applied	\N	\N	\N	\N	62757	62757	230926
876	751	1	applied	\N	\N	\N	\N	62758	62758	230927
877	752	0	applied	\N	\N	\N	\N	62759	62759	230928
877	753	1	applied	\N	\N	\N	\N	62760	62760	230929
877	754	2	applied	\N	\N	\N	\N	62761	62761	230930
878	755	0	applied	\N	\N	\N	\N	62762	62762	230931
879	756	0	applied	\N	\N	\N	\N	62763	62763	230932
879	757	1	applied	\N	\N	\N	\N	62764	62764	230933
880	756	0	applied	\N	\N	\N	\N	62765	62765	230934
880	757	1	applied	\N	\N	\N	\N	62766	62766	230935
881	758	0	applied	\N	\N	\N	\N	62767	62767	230936
882	758	0	applied	\N	\N	\N	\N	62768	62768	230937
884	760	0	applied	\N	\N	\N	\N	62770	62770	230939
885	761	0	applied	\N	\N	\N	\N	62771	62771	230940
885	762	1	applied	\N	\N	\N	\N	62772	62772	230941
886	761	0	applied	\N	\N	\N	\N	62773	62773	230942
886	762	1	applied	\N	\N	\N	\N	62774	62774	230943
887	761	0	applied	\N	\N	\N	\N	62775	62775	230944
887	762	1	applied	\N	\N	\N	\N	62776	62776	230945
888	761	0	applied	\N	\N	\N	\N	62777	62777	230946
888	762	1	applied	\N	\N	\N	\N	62778	62778	230947
889	763	0	applied	\N	\N	\N	\N	62779	62779	230948
890	764	0	applied	\N	\N	\N	\N	62780	62780	230949
890	765	1	applied	\N	\N	\N	\N	62781	62781	230950
890	766	2	applied	\N	\N	1000000000	\N	62782	62782	230951
891	764	0	applied	\N	\N	\N	\N	62783	62783	230952
891	765	1	applied	\N	\N	\N	\N	62784	62784	230953
892	764	0	applied	\N	\N	\N	\N	62786	62786	230955
892	765	1	applied	\N	\N	\N	\N	62787	62787	230956
892	766	2	applied	\N	\N	1000000000	\N	62788	62788	230957
893	767	0	applied	\N	\N	\N	\N	62789	62789	230958
894	767	0	applied	\N	\N	\N	\N	62790	62790	230959
895	768	0	applied	\N	\N	\N	\N	62791	62791	230960
895	769	1	applied	\N	\N	\N	\N	62792	62792	230961
895	770	2	applied	\N	\N	1000000000	\N	62793	62793	230962
896	771	0	applied	\N	\N	\N	\N	62794	62794	230963
896	772	1	applied	\N	\N	\N	\N	62795	62795	230964
897	773	0	applied	\N	\N	\N	\N	62796	62796	230965
898	774	0	applied	\N	\N	\N	\N	62797	62797	230966
899	774	0	applied	\N	\N	\N	\N	62798	62798	230967
900	775	0	applied	\N	\N	\N	\N	62799	62799	230968
901	775	0	applied	\N	\N	\N	\N	62800	62800	230969
902	776	0	applied	\N	\N	\N	\N	62801	62801	230970
902	777	1	applied	\N	\N	\N	\N	62802	62802	230971
902	778	2	applied	\N	\N	\N	\N	62803	62803	230972
903	776	0	applied	\N	\N	\N	\N	62804	62804	230973
904	776	0	applied	\N	\N	\N	\N	62807	62807	230976
904	777	1	applied	\N	\N	\N	\N	62808	62808	230977
904	778	2	applied	\N	\N	\N	\N	62809	62809	230978
905	779	0	applied	\N	\N	\N	\N	62810	62810	230979
905	780	1	applied	\N	\N	\N	\N	62811	62811	230980
907	781	0	applied	\N	\N	\N	\N	62814	62814	230983
908	782	0	applied	\N	\N	\N	\N	62815	62815	230984
910	783	0	applied	\N	\N	\N	\N	62817	62817	230986
910	784	1	applied	\N	\N	\N	\N	62818	62818	230987
911	785	0	applied	\N	\N	\N	\N	62819	62819	230988
911	786	1	applied	\N	\N	\N	\N	62820	62820	230989
912	785	0	applied	\N	\N	\N	\N	62821	62821	230990
912	786	1	applied	\N	\N	\N	\N	62822	62822	230991
913	785	0	applied	\N	\N	\N	\N	62823	62823	230992
913	786	1	applied	\N	\N	\N	\N	62824	62824	230993
914	787	0	applied	\N	\N	\N	\N	62825	62825	230994
916	789	1	applied	\N	\N	\N	\N	62829	62829	230998
917	790	0	applied	\N	\N	\N	\N	62830	62830	230999
917	791	1	applied	\N	\N	\N	\N	62831	62831	231000
917	792	2	applied	\N	\N	\N	\N	62832	62832	231001
917	793	3	applied	\N	\N	\N	\N	62833	62833	231002
918	794	0	applied	\N	\N	\N	\N	62834	62834	231003
919	794	0	applied	\N	\N	\N	\N	62835	62835	231004
921	795	0	applied	\N	\N	\N	\N	62837	62837	231006
922	796	0	applied	\N	\N	\N	\N	62838	62838	231007
925	800	0	applied	\N	\N	\N	\N	62842	62842	231010
927	800	0	applied	\N	\N	\N	\N	62844	62844	231012
853	730	3	applied	\N	\N	\N	\N	62717	62717	230886
854	728	1	applied	\N	\N	\N	\N	62719	62719	230888
915	788	0	applied	\N	\N	1000000000	\N	62826	62826	230995
915	789	1	applied	\N	\N	\N	\N	62827	62827	230996
920	794	0	applied	\N	\N	\N	\N	62836	62836	231005
923	798	0	applied	\N	\N	\N	\N	62840	62840	231008
924	799	0	applied	\N	\N	\N	\N	62841	62841	231009
926	800	0	applied	\N	\N	\N	\N	62843	62843	231011
928	801	0	applied	\N	\N	\N	\N	62845	62845	231013
929	801	0	applied	\N	\N	\N	\N	62846	62846	231014
930	802	0	applied	\N	\N	\N	\N	62847	62847	231015
930	803	1	applied	\N	\N	\N	\N	62848	62848	231016
931	802	0	applied	\N	\N	\N	\N	62849	62849	231017
931	803	1	applied	\N	\N	\N	\N	62850	62850	231018
932	804	0	applied	\N	\N	\N	\N	62851	62851	231019
932	805	1	applied	\N	\N	\N	\N	62852	62852	231020
933	805	1	applied	\N	\N	\N	\N	62854	62854	231022
934	806	0	applied	\N	\N	\N	\N	62855	62855	231023
935	806	0	applied	\N	\N	\N	\N	62856	62856	231024
936	806	0	applied	\N	\N	\N	\N	62857	62857	231025
937	807	0	applied	\N	\N	\N	\N	62858	62858	231026
938	808	0	applied	\N	\N	\N	\N	62859	62859	231027
939	809	0	applied	\N	\N	\N	\N	62860	62860	231028
940	809	0	applied	\N	\N	\N	\N	62861	62861	231029
941	809	0	applied	\N	\N	\N	\N	62862	62862	231030
942	810	0	applied	\N	\N	\N	\N	62863	62863	231031
942	811	1	applied	\N	\N	\N	\N	62864	62864	231032
942	812	2	applied	\N	\N	\N	\N	62865	62865	231033
943	813	0	applied	\N	\N	\N	\N	62866	62866	231034
944	813	0	applied	\N	\N	\N	\N	62867	62867	231035
945	814	0	applied	\N	\N	\N	\N	62868	62868	231036
946	815	0	applied	\N	\N	\N	\N	62869	62869	231037
947	817	0	applied	\N	\N	\N	\N	62871	62871	231039
948	817	0	applied	\N	\N	\N	\N	62872	62872	231040
949	818	0	applied	\N	\N	\N	\N	62873	62873	231041
950	819	0	applied	\N	\N	\N	\N	62874	62874	231042
950	820	1	applied	\N	\N	\N	\N	62875	62875	231043
951	819	0	applied	\N	\N	\N	\N	62876	62876	231044
951	820	1	applied	\N	\N	\N	\N	62877	62877	231045
952	821	0	applied	\N	\N	\N	\N	62878	62878	231046
952	822	1	applied	\N	\N	\N	\N	62879	62879	231047
953	823	0	applied	\N	\N	\N	\N	62880	62880	231048
954	823	0	applied	\N	\N	\N	\N	62881	62881	231049
955	823	0	applied	\N	\N	\N	\N	62882	62882	231050
956	824	0	applied	\N	\N	\N	\N	62883	62883	231051
956	825	1	applied	\N	\N	\N	\N	62884	62884	231052
956	826	2	applied	\N	\N	\N	\N	62885	62885	231053
957	827	0	applied	\N	\N	\N	\N	62886	62886	231054
959	828	0	applied	\N	\N	\N	\N	62888	62888	231056
959	829	1	applied	\N	\N	\N	\N	62889	62889	231057
959	830	2	applied	\N	\N	\N	\N	62890	62890	231058
959	831	3	applied	\N	\N	\N	\N	62891	62891	231059
959	832	4	applied	\N	\N	\N	\N	62892	62892	231060
959	833	5	applied	\N	\N	\N	\N	62893	62893	231061
960	828	0	applied	\N	\N	\N	\N	62894	62894	231062
960	829	1	applied	\N	\N	\N	\N	62895	62895	231063
960	830	2	applied	\N	\N	\N	\N	62896	62896	231064
960	831	3	applied	\N	\N	\N	\N	62897	62897	231065
960	832	4	applied	\N	\N	\N	\N	62898	62898	231066
960	833	5	applied	\N	\N	\N	\N	62899	62899	231067
961	834	0	applied	\N	\N	\N	\N	62900	62900	231068
961	835	1	applied	\N	\N	\N	\N	62901	62901	231069
962	834	0	applied	\N	\N	\N	\N	62902	62902	231070
962	835	1	applied	\N	\N	\N	\N	62903	62903	231071
963	835	1	applied	\N	\N	\N	\N	62905	62905	231073
964	836	0	applied	\N	\N	\N	\N	62906	62906	231074
964	837	1	applied	\N	\N	\N	\N	62907	62907	231075
965	838	0	applied	\N	\N	\N	\N	62908	62908	231076
966	838	0	applied	\N	\N	\N	\N	62909	62909	231077
967	839	0	applied	\N	\N	\N	\N	62910	62910	231078
968	839	0	applied	\N	\N	\N	\N	62911	62911	231079
969	839	0	applied	\N	\N	\N	\N	62912	62912	231080
970	840	0	applied	\N	\N	\N	\N	62913	62913	231081
971	840	0	applied	\N	\N	\N	\N	62914	62914	231082
972	841	0	applied	\N	\N	\N	\N	62915	62915	231083
973	841	0	applied	\N	\N	\N	\N	62916	62916	231084
974	841	0	applied	\N	\N	\N	\N	62917	62917	231085
975	842	0	applied	\N	\N	\N	\N	62918	62918	231086
976	842	0	applied	\N	\N	\N	\N	62919	62919	231087
977	842	0	applied	\N	\N	\N	\N	62920	62920	231088
979	844	0	applied	\N	\N	\N	\N	62922	62922	231090
980	844	0	applied	\N	\N	\N	\N	62923	62923	231091
981	844	0	applied	\N	\N	\N	\N	62924	62924	231092
982	844	0	applied	\N	\N	\N	\N	62925	62925	231093
983	845	0	applied	\N	\N	\N	\N	62926	62926	231094
984	845	0	applied	\N	\N	\N	\N	62927	62927	231095
985	846	0	applied	\N	\N	\N	\N	62928	62928	231096
986	846	0	applied	\N	\N	\N	\N	62929	62929	231097
987	846	0	applied	\N	\N	\N	\N	62930	62930	231098
988	846	0	applied	\N	\N	\N	\N	62931	62931	231099
989	847	0	applied	\N	\N	\N	\N	62932	62932	231100
990	847	0	applied	\N	\N	\N	\N	62933	62933	231101
991	847	0	applied	\N	\N	\N	\N	62934	62934	231102
992	847	0	applied	\N	\N	\N	\N	62935	62935	231103
993	848	0	applied	\N	\N	\N	\N	62936	62936	231104
994	848	0	applied	\N	\N	\N	\N	62937	62937	231105
996	849	0	applied	\N	\N	\N	\N	62939	62939	231107
1000	853	0	applied	\N	\N	\N	\N	62943	62943	231111
1003	855	0	applied	\N	\N	\N	\N	62946	62946	231114
1009	863	0	applied	\N	\N	\N	\N	62956	62956	231124
1011	863	0	applied	\N	\N	\N	\N	62958	62958	231126
1012	863	0	applied	\N	\N	\N	\N	62959	62959	231127
1012	864	1	applied	\N	\N	\N	\N	62960	62960	231128
1018	867	0	applied	\N	\N	\N	\N	62966	62966	231134
1021	870	0	applied	\N	\N	\N	\N	62969	62969	231137
1024	871	0	applied	\N	\N	\N	\N	62972	62972	231140
1027	874	0	applied	\N	\N	\N	\N	62977	62977	231145
1031	876	0	applied	\N	\N	\N	\N	62981	62981	231149
1032	877	0	applied	\N	\N	\N	\N	62982	62982	231150
1033	878	0	applied	\N	\N	\N	\N	62983	62983	231151
1036	881	0	applied	\N	\N	\N	\N	62986	62986	231154
1039	883	0	applied	\N	\N	\N	\N	62989	62989	231157
909	782	0	applied	\N	\N	\N	\N	62816	62816	230985
1002	854	0	applied	\N	\N	\N	\N	62945	62945	231113
1004	855	0	applied	\N	\N	\N	\N	62947	62947	231115
1006	856	0	applied	\N	\N	\N	\N	62948	62948	231116
1007	856	0	applied	\N	\N	\N	\N	62949	62949	231117
1007	857	1	applied	\N	\N	\N	\N	62950	62950	231118
1008	858	0	applied	\N	\N	\N	\N	62951	62951	231119
1008	859	1	applied	\N	\N	\N	\N	62952	62952	231120
1008	860	2	applied	\N	\N	\N	\N	62953	62953	231121
1008	861	3	applied	\N	\N	\N	\N	62954	62954	231122
1008	862	4	applied	\N	\N	\N	\N	62955	62955	231123
1010	863	0	applied	\N	\N	\N	\N	62957	62957	231125
1013	864	0	applied	\N	\N	\N	\N	62961	62961	231129
1014	865	0	applied	\N	\N	\N	\N	62962	62962	231130
1015	865	0	applied	\N	\N	\N	\N	62963	62963	231131
1016	866	0	applied	\N	\N	\N	\N	62964	62964	231132
1017	867	0	applied	\N	\N	\N	\N	62965	62965	231133
1023	871	0	applied	\N	\N	\N	\N	62971	62971	231139
1026	872	0	applied	\N	\N	\N	\N	62975	62975	231143
1026	873	1	applied	\N	\N	\N	\N	62976	62976	231144
1029	875	0	applied	\N	\N	\N	\N	62979	62979	231147
1030	876	0	applied	\N	\N	\N	\N	62980	62980	231148
1035	880	0	applied	\N	\N	\N	\N	62985	62985	231153
1040	883	0	applied	\N	\N	\N	\N	62990	62990	231158
1042	884	0	applied	\N	\N	\N	\N	62992	62992	231160
1043	884	0	applied	\N	\N	\N	\N	62993	62993	231161
1045	885	0	applied	\N	\N	\N	\N	62995	62995	231163
1046	886	0	applied	\N	\N	\N	\N	62996	62996	231164
1047	886	0	applied	\N	\N	\N	\N	62997	62997	231165
1049	887	0	applied	\N	\N	\N	\N	63002	63002	231170
1049	888	1	applied	\N	\N	\N	\N	63003	63003	231171
1049	889	2	applied	\N	\N	\N	\N	63004	63004	231172
1049	890	3	applied	\N	\N	\N	\N	63005	63005	231173
1050	892	1	applied	\N	\N	\N	\N	63007	63007	231175
1052	893	0	applied	\N	\N	\N	\N	63017	63017	231185
1052	894	1	applied	\N	\N	\N	\N	63018	63018	231186
1052	895	2	applied	\N	\N	\N	\N	63019	63019	231187
1052	896	3	applied	\N	\N	\N	\N	63020	63020	231188
1052	897	4	applied	\N	\N	\N	\N	63021	63021	231189
1052	898	5	applied	\N	\N	\N	\N	63022	63022	231190
1052	899	6	applied	\N	\N	\N	\N	63023	63023	231191
1052	900	7	applied	\N	\N	\N	\N	63024	63024	231192
1052	901	8	applied	\N	\N	\N	\N	63025	63025	231193
1053	902	0	applied	\N	\N	\N	\N	63026	63026	231194
1053	903	1	applied	\N	\N	\N	\N	63027	63027	231195
1053	904	2	applied	\N	\N	\N	\N	63028	63028	231196
1053	905	3	applied	\N	\N	\N	\N	63029	63029	231197
1053	906	4	applied	\N	\N	\N	\N	63030	63030	231198
1053	907	5	applied	\N	\N	\N	\N	63031	63031	231199
1053	909	7	applied	\N	\N	\N	\N	63033	63033	231201
1053	910	8	applied	\N	\N	\N	\N	63034	63034	231202
1053	911	9	applied	\N	\N	\N	\N	63035	63035	231203
1053	912	10	applied	\N	\N	\N	\N	63036	63036	231204
1053	913	11	applied	\N	\N	\N	\N	63037	63037	231205
1053	914	12	applied	\N	\N	\N	\N	63038	63038	231206
1053	915	13	applied	\N	\N	\N	\N	63039	63039	231207
1053	916	14	applied	\N	\N	\N	\N	63040	63040	231208
1053	917	15	applied	\N	\N	\N	\N	63041	63041	231209
1053	918	16	applied	\N	\N	\N	\N	63042	63042	231210
1053	919	17	applied	\N	\N	\N	\N	63043	63043	231211
1053	920	18	applied	\N	\N	\N	\N	63044	63044	231212
1053	921	19	applied	\N	\N	\N	\N	63045	63045	231213
1053	922	20	applied	\N	\N	\N	\N	63046	63046	231214
1053	923	21	applied	\N	\N	\N	\N	63047	63047	231215
1053	924	22	applied	\N	\N	\N	\N	63048	63048	231216
1053	926	24	applied	\N	\N	\N	\N	63050	63050	231218
1053	927	25	applied	\N	\N	\N	\N	63051	63051	231219
1053	928	26	applied	\N	\N	\N	\N	63052	63052	231220
1053	929	27	applied	\N	\N	\N	\N	63053	63053	231221
1053	930	28	applied	\N	\N	\N	\N	63054	63054	231222
1053	931	29	applied	\N	\N	\N	\N	63055	63055	231223
1053	932	30	applied	\N	\N	\N	\N	63056	63056	231224
1053	933	31	applied	\N	\N	\N	\N	63057	63057	231225
1053	934	32	applied	\N	\N	\N	\N	63058	63058	231226
1053	935	33	applied	\N	\N	\N	\N	63059	63059	231227
1053	936	34	applied	\N	\N	\N	\N	63060	63060	231228
1053	937	35	applied	\N	\N	\N	\N	63061	63061	231229
1055	902	0	applied	\N	\N	\N	\N	63098	63098	231266
1055	903	1	applied	\N	\N	\N	\N	63099	63099	231267
1055	904	2	applied	\N	\N	\N	\N	63100	63100	231268
1055	905	3	applied	\N	\N	\N	\N	63101	63101	231269
1055	907	5	applied	\N	\N	\N	\N	63103	63103	231271
1055	908	6	applied	\N	\N	\N	\N	63104	63104	231272
1055	909	7	applied	\N	\N	\N	\N	63105	63105	231273
1055	910	8	applied	\N	\N	\N	\N	63106	63106	231274
1055	911	9	applied	\N	\N	\N	\N	63107	63107	231275
1055	912	10	applied	\N	\N	\N	\N	63108	63108	231276
1055	913	11	applied	\N	\N	\N	\N	63109	63109	231277
1055	914	12	applied	\N	\N	\N	\N	63110	63110	231278
1055	915	13	applied	\N	\N	\N	\N	63111	63111	231279
1055	916	14	applied	\N	\N	\N	\N	63112	63112	231280
1055	917	15	applied	\N	\N	\N	\N	63113	63113	231281
1055	918	16	applied	\N	\N	\N	\N	63114	63114	231282
1055	919	17	applied	\N	\N	\N	\N	63115	63115	231283
1055	920	18	applied	\N	\N	\N	\N	63116	63116	231284
1055	921	19	applied	\N	\N	\N	\N	63117	63117	231285
1055	922	20	applied	\N	\N	\N	\N	63118	63118	231286
1055	924	22	applied	\N	\N	\N	\N	63120	63120	231288
1055	925	23	applied	\N	\N	\N	\N	63121	63121	231289
1055	926	24	applied	\N	\N	\N	\N	63122	63122	231290
1055	927	25	applied	\N	\N	\N	\N	63123	63123	231291
1055	928	26	applied	\N	\N	\N	\N	63124	63124	231292
1055	929	27	applied	\N	\N	\N	\N	63125	63125	231293
1055	930	28	applied	\N	\N	\N	\N	63126	63126	231294
1055	931	29	applied	\N	\N	\N	\N	63127	63127	231295
1055	932	30	applied	\N	\N	\N	\N	63128	63128	231296
1055	933	31	applied	\N	\N	\N	\N	63129	63129	231297
1055	934	32	applied	\N	\N	\N	\N	63130	63130	231298
1055	935	33	applied	\N	\N	\N	\N	63131	63131	231299
1055	936	34	applied	\N	\N	\N	\N	63132	63132	231300
1055	937	35	applied	\N	\N	\N	\N	63133	63133	231301
998	851	0	applied	\N	\N	\N	\N	62941	62941	231109
999	852	0	applied	\N	\N	\N	\N	62942	62942	231110
1028	874	0	applied	\N	\N	\N	\N	62978	62978	231146
1034	879	0	applied	\N	\N	\N	\N	62984	62984	231152
1037	881	0	applied	\N	\N	\N	\N	62987	62987	231155
1038	882	0	applied	\N	\N	\N	\N	62988	62988	231156
1041	884	0	applied	\N	\N	\N	\N	62991	62991	231159
1044	885	0	applied	\N	\N	\N	\N	62994	62994	231162
1048	887	0	applied	\N	\N	\N	\N	62998	62998	231166
1048	888	1	applied	\N	\N	\N	\N	62999	62999	231167
1048	889	2	applied	\N	\N	\N	\N	63000	63000	231168
1048	890	3	applied	\N	\N	\N	\N	63001	63001	231169
1051	893	0	applied	\N	\N	\N	\N	63008	63008	231176
1051	894	1	applied	\N	\N	\N	\N	63009	63009	231177
1051	895	2	applied	\N	\N	\N	\N	63010	63010	231178
1051	896	3	applied	\N	\N	\N	\N	63011	63011	231179
1051	897	4	applied	\N	\N	\N	\N	63012	63012	231180
1051	898	5	applied	\N	\N	\N	\N	63013	63013	231181
1051	900	7	applied	\N	\N	\N	\N	63015	63015	231183
1051	901	8	applied	\N	\N	\N	\N	63016	63016	231184
1054	902	0	applied	\N	\N	\N	\N	63062	63062	231230
1054	903	1	applied	\N	\N	\N	\N	63063	63063	231231
1054	904	2	applied	\N	\N	\N	\N	63064	63064	231232
1054	905	3	applied	\N	\N	\N	\N	63065	63065	231233
1054	906	4	applied	\N	\N	\N	\N	63066	63066	231234
1054	907	5	applied	\N	\N	\N	\N	63067	63067	231235
1054	908	6	applied	\N	\N	\N	\N	63068	63068	231236
1054	909	7	applied	\N	\N	\N	\N	63069	63069	231237
1054	910	8	applied	\N	\N	\N	\N	63070	63070	231238
1054	911	9	applied	\N	\N	\N	\N	63071	63071	231239
1054	912	10	applied	\N	\N	\N	\N	63072	63072	231240
1054	913	11	applied	\N	\N	\N	\N	63073	63073	231241
1054	914	12	applied	\N	\N	\N	\N	63074	63074	231242
1054	915	13	applied	\N	\N	\N	\N	63075	63075	231243
1054	917	15	applied	\N	\N	\N	\N	63077	63077	231245
1054	918	16	applied	\N	\N	\N	\N	63078	63078	231246
1054	919	17	applied	\N	\N	\N	\N	63079	63079	231247
1054	920	18	applied	\N	\N	\N	\N	63080	63080	231248
1054	921	19	applied	\N	\N	\N	\N	63081	63081	231249
1054	922	20	applied	\N	\N	\N	\N	63082	63082	231250
1054	923	21	applied	\N	\N	\N	\N	63083	63083	231251
1054	924	22	applied	\N	\N	\N	\N	63084	63084	231252
1054	925	23	applied	\N	\N	\N	\N	63085	63085	231253
1054	926	24	applied	\N	\N	\N	\N	63086	63086	231254
1054	927	25	applied	\N	\N	\N	\N	63087	63087	231255
1054	928	26	applied	\N	\N	\N	\N	63088	63088	231256
1054	929	27	applied	\N	\N	\N	\N	63089	63089	231257
1054	930	28	applied	\N	\N	\N	\N	63090	63090	231258
1054	931	29	applied	\N	\N	\N	\N	63091	63091	231259
1054	932	30	applied	\N	\N	\N	\N	63092	63092	231260
1054	934	32	applied	\N	\N	\N	\N	63094	63094	231262
1054	935	33	applied	\N	\N	\N	\N	63095	63095	231263
1054	936	34	applied	\N	\N	\N	\N	63096	63096	231264
1054	937	35	applied	\N	\N	\N	\N	63097	63097	231265
1056	938	0	applied	\N	\N	\N	\N	63134	63134	231302
1056	939	1	applied	\N	\N	\N	\N	63135	63135	231303
1056	940	2	applied	\N	\N	\N	\N	63136	63136	231304
1056	941	3	applied	\N	\N	\N	\N	63137	63137	231305
1056	942	4	applied	\N	\N	\N	\N	63138	63138	231306
1056	943	5	applied	\N	\N	\N	\N	63139	63139	231307
1056	944	6	applied	\N	\N	\N	\N	63140	63140	231308
1056	945	7	applied	\N	\N	\N	\N	63141	63141	231309
1056	946	8	applied	\N	\N	\N	\N	63142	63142	231310
1056	947	9	applied	\N	\N	\N	\N	63143	63143	231311
1056	948	10	applied	\N	\N	\N	\N	63144	63144	231312
1056	949	11	applied	\N	\N	\N	\N	63145	63145	231313
1056	951	13	applied	\N	\N	\N	\N	63147	63147	231315
1056	952	14	applied	\N	\N	\N	\N	63148	63148	231316
1056	953	15	applied	\N	\N	\N	\N	63149	63149	231317
1056	954	16	applied	\N	\N	\N	\N	63150	63150	231318
1057	938	0	applied	\N	\N	\N	\N	63151	63151	231319
1057	939	1	applied	\N	\N	\N	\N	63152	63152	231320
1057	940	2	applied	\N	\N	\N	\N	63153	63153	231321
1057	941	3	applied	\N	\N	\N	\N	63154	63154	231322
1057	942	4	applied	\N	\N	\N	\N	63155	63155	231323
1057	943	5	applied	\N	\N	\N	\N	63156	63156	231324
1057	944	6	applied	\N	\N	\N	\N	63157	63157	231325
1057	945	7	applied	\N	\N	\N	\N	63158	63158	231326
1057	946	8	applied	\N	\N	\N	\N	63159	63159	231327
1057	947	9	applied	\N	\N	\N	\N	63160	63160	231328
1057	948	10	applied	\N	\N	\N	\N	63161	63161	231329
1057	949	11	applied	\N	\N	\N	\N	63162	63162	231330
1057	951	13	applied	\N	\N	\N	\N	63164	63164	231332
1057	952	14	applied	\N	\N	\N	\N	63165	63165	231333
1057	953	15	applied	\N	\N	\N	\N	63166	63166	231334
1057	954	16	applied	\N	\N	\N	\N	63167	63167	231335
1058	938	0	applied	\N	\N	\N	\N	63168	63168	231336
1058	939	1	applied	\N	\N	\N	\N	63169	63169	231337
1058	940	2	applied	\N	\N	\N	\N	63170	63170	231338
1058	941	3	applied	\N	\N	\N	\N	63171	63171	231339
1058	942	4	applied	\N	\N	\N	\N	63172	63172	231340
1058	943	5	applied	\N	\N	\N	\N	63173	63173	231341
1058	944	6	applied	\N	\N	\N	\N	63174	63174	231342
1058	945	7	applied	\N	\N	\N	\N	63175	63175	231343
1058	946	8	applied	\N	\N	\N	\N	63176	63176	231344
1058	947	9	applied	\N	\N	\N	\N	63177	63177	231345
1058	948	10	applied	\N	\N	\N	\N	63178	63178	231346
1058	949	11	applied	\N	\N	\N	\N	63179	63179	231347
1058	951	13	applied	\N	\N	\N	\N	63181	63181	231349
1058	952	14	applied	\N	\N	\N	\N	63182	63182	231350
1058	953	15	applied	\N	\N	\N	\N	63183	63183	231351
1058	954	16	applied	\N	\N	\N	\N	63184	63184	231352
1059	902	0	applied	\N	\N	\N	\N	63185	63185	231353
1059	891	1	applied	\N	\N	\N	\N	63186	63186	231354
1059	893	2	applied	\N	\N	\N	\N	63187	63187	231355
1059	894	3	applied	\N	\N	\N	\N	63188	63188	231356
1059	895	4	applied	\N	\N	\N	\N	63189	63189	231357
1059	896	5	applied	\N	\N	\N	\N	63190	63190	231358
1059	897	6	applied	\N	\N	\N	\N	63191	63191	231359
1059	898	7	applied	\N	\N	\N	\N	63192	63192	231360
1059	899	8	applied	\N	\N	\N	\N	63193	63193	231361
1059	900	9	applied	\N	\N	\N	\N	63194	63194	231362
1022	870	0	applied	\N	\N	\N	\N	62970	62970	231138
1025	872	0	applied	\N	\N	\N	\N	62973	62973	231141
1059	907	14	applied	\N	\N	\N	\N	63199	63199	231367
1059	908	15	applied	\N	\N	\N	\N	63200	63200	231368
1059	909	16	applied	\N	\N	\N	\N	63201	63201	231369
1059	910	17	applied	\N	\N	\N	\N	63202	63202	231370
1059	911	18	applied	\N	\N	\N	\N	63203	63203	231371
1059	912	19	applied	\N	\N	\N	\N	63204	63204	231372
1059	913	20	applied	\N	\N	\N	\N	63205	63205	231373
1059	914	21	applied	\N	\N	\N	\N	63206	63206	231374
1059	915	22	applied	\N	\N	\N	\N	63207	63207	231375
1059	916	23	applied	\N	\N	\N	\N	63208	63208	231376
1059	917	24	applied	\N	\N	\N	\N	63209	63209	231377
1059	918	25	applied	\N	\N	\N	\N	63210	63210	231378
1059	919	26	applied	\N	\N	\N	\N	63211	63211	231379
1059	920	27	applied	\N	\N	\N	\N	63212	63212	231380
1059	921	28	applied	\N	\N	\N	\N	63213	63213	231381
1059	922	29	applied	\N	\N	\N	\N	63214	63214	231382
1059	924	31	applied	\N	\N	\N	\N	63216	63216	231384
1059	925	32	applied	\N	\N	\N	\N	63217	63217	231385
1059	926	33	applied	\N	\N	\N	\N	63218	63218	231386
1059	927	34	applied	\N	\N	\N	\N	63219	63219	231387
1059	928	35	applied	\N	\N	\N	\N	63220	63220	231388
1059	929	36	applied	\N	\N	\N	\N	63221	63221	231389
1059	930	37	applied	\N	\N	\N	\N	63222	63222	231390
1059	931	39	applied	\N	\N	\N	\N	63223	63223	231391
1059	932	40	applied	\N	\N	\N	\N	63224	63224	231392
1059	933	41	applied	\N	\N	\N	\N	63225	63225	231393
1059	934	42	applied	\N	\N	\N	\N	63226	63226	231394
1060	955	0	applied	\N	\N	\N	\N	63227	63227	231395
1060	956	1	applied	\N	\N	\N	\N	63228	63228	231396
1060	957	2	applied	\N	\N	\N	\N	63229	63229	231397
1060	958	3	applied	\N	\N	\N	\N	63230	63230	231398
1060	959	4	applied	\N	\N	\N	\N	63231	63231	231399
1060	961	6	applied	\N	\N	\N	\N	63233	63233	231401
1060	962	7	applied	\N	\N	\N	\N	63234	63234	231402
1060	963	8	applied	\N	\N	\N	\N	63235	63235	231403
1060	964	9	applied	\N	\N	\N	\N	63236	63236	231404
1060	965	10	applied	\N	\N	\N	\N	63237	63237	231405
1060	966	11	applied	\N	\N	\N	\N	63238	63238	231406
1060	967	12	applied	\N	\N	\N	\N	63239	63239	231407
1060	968	13	applied	\N	\N	\N	\N	63240	63240	231408
1060	969	14	applied	\N	\N	\N	\N	63241	63241	231409
1060	970	15	applied	\N	\N	\N	\N	63242	63242	231410
1061	971	0	applied	\N	\N	\N	\N	63243	63243	231411
1061	972	1	applied	\N	\N	\N	\N	63244	63244	231412
1061	973	2	applied	\N	\N	\N	\N	63245	63245	231413
1062	971	0	applied	\N	\N	\N	\N	63246	63246	231414
1062	972	1	applied	\N	\N	\N	\N	63247	63247	231415
1062	973	2	applied	\N	\N	\N	\N	63248	63248	231416
1063	972	1	applied	\N	\N	\N	\N	63250	63250	231418
1063	973	2	applied	\N	\N	\N	\N	63251	63251	231419
1064	974	0	applied	\N	\N	\N	\N	63252	63252	231420
1064	975	1	applied	\N	\N	\N	\N	63253	63253	231421
1065	976	0	applied	\N	\N	\N	\N	63254	63254	231422
1066	977	0	applied	\N	\N	\N	\N	63255	63255	231423
1067	977	0	applied	\N	\N	\N	\N	63256	63256	231424
1068	978	0	applied	\N	\N	\N	\N	63257	63257	231425
1069	979	0	applied	\N	\N	\N	\N	63258	63258	231426
1070	979	0	applied	\N	\N	\N	\N	63259	63259	231427
1071	979	0	applied	\N	\N	\N	\N	63260	63260	231428
1072	979	0	applied	\N	\N	\N	\N	63261	63261	231429
1073	980	0	applied	\N	\N	\N	\N	63262	63262	231430
1073	981	1	applied	\N	\N	\N	\N	63263	63263	231431
1074	980	0	applied	\N	\N	\N	\N	63264	63264	231432
1074	981	1	applied	\N	\N	\N	\N	63265	63265	231433
1076	983	0	applied	\N	\N	\N	\N	63267	63267	231435
1077	984	0	applied	\N	\N	\N	\N	63268	63268	231436
1078	985	0	applied	\N	\N	\N	\N	63269	63269	231437
1078	986	1	applied	\N	\N	\N	\N	63270	63270	231438
1078	987	2	applied	\N	\N	\N	\N	63271	63271	231439
1079	985	0	applied	\N	\N	\N	\N	63272	63272	231440
1079	986	1	applied	\N	\N	\N	\N	63273	63273	231441
1079	987	2	applied	\N	\N	\N	\N	63274	63274	231442
1080	988	0	applied	\N	\N	\N	\N	63275	63275	231443
1081	989	0	applied	\N	\N	\N	\N	63276	63276	231444
1082	990	0	applied	\N	\N	\N	\N	63277	63277	231445
1083	990	0	applied	\N	\N	\N	\N	63278	63278	231446
1084	990	0	applied	\N	\N	\N	\N	63279	63279	231447
1085	990	0	applied	\N	\N	\N	\N	63280	63280	231448
1086	991	0	applied	\N	\N	\N	\N	63281	63281	231449
1088	991	0	applied	\N	\N	\N	\N	63282	63282	231450
1089	993	1	applied	\N	\N	\N	\N	63284	63284	231452
1089	994	2	applied	\N	\N	\N	\N	63285	63285	231453
1089	995	3	applied	\N	\N	\N	\N	63286	63286	231454
1089	996	4	applied	\N	\N	\N	\N	63287	63287	231455
1089	997	5	applied	\N	\N	\N	\N	63288	63288	231456
1089	998	6	applied	\N	\N	\N	\N	63289	63289	231457
1089	999	7	applied	\N	\N	\N	\N	63290	63290	231458
1089	1000	8	applied	\N	\N	\N	\N	63291	63291	231459
1089	1001	9	applied	\N	\N	\N	\N	63292	63292	231460
1089	1002	10	applied	\N	\N	\N	\N	63293	63293	231461
1089	1003	11	applied	\N	\N	\N	\N	63294	63294	231462
1089	1004	12	applied	\N	\N	\N	\N	63295	63295	231463
1089	1005	13	applied	\N	\N	\N	\N	63296	63296	231464
1089	1006	14	applied	\N	\N	\N	\N	63297	63297	231465
1089	1007	15	applied	\N	\N	\N	\N	63298	63298	231466
1090	1008	0	applied	\N	\N	\N	\N	63299	63299	231467
1091	1010	1	applied	\N	\N	\N	\N	63309	63309	231477
1091	1011	2	applied	\N	\N	\N	\N	63310	63310	231478
1091	1012	3	applied	\N	\N	\N	\N	63311	63311	231479
1091	1013	4	applied	\N	\N	\N	\N	63312	63312	231480
1091	1014	5	applied	\N	\N	\N	\N	63313	63313	231481
1091	1015	6	applied	\N	\N	\N	\N	63314	63314	231482
1091	1016	7	applied	\N	\N	\N	\N	63315	63315	231483
1094	1027	0	applied	\N	\N	\N	\N	63335	63335	231503
1094	1028	1	applied	\N	\N	\N	\N	63336	63336	231504
1094	1029	2	applied	\N	\N	\N	\N	63337	63337	231505
1094	1030	3	applied	\N	\N	\N	\N	63338	63338	231506
1097	1031	0	applied	\N	\N	\N	\N	63347	63347	231515
1102	1034	0	applied	\N	\N	\N	\N	63352	63352	231520
1105	1035	0	applied	\N	\N	\N	\N	63355	63355	231523
1059	904	11	applied	\N	\N	\N	\N	63196	63196	231364
1059	905	12	applied	\N	\N	\N	\N	63197	63197	231365
1090	1013	5	applied	\N	\N	\N	\N	63304	63304	231472
1090	1014	6	applied	\N	\N	\N	\N	63305	63305	231473
1090	1015	7	applied	\N	\N	\N	\N	63306	63306	231474
1090	1016	8	applied	\N	\N	\N	\N	63307	63307	231475
1092	1008	0	applied	\N	\N	\N	\N	63316	63316	231484
1092	1009	1	applied	\N	\N	\N	\N	63317	63317	231485
1092	1010	2	applied	\N	\N	\N	\N	63318	63318	231486
1092	1011	3	applied	\N	\N	\N	\N	63319	63319	231487
1092	1012	4	applied	\N	\N	\N	\N	63320	63320	231488
1092	1013	5	applied	\N	\N	\N	\N	63321	63321	231489
1092	1014	6	applied	\N	\N	\N	\N	63322	63322	231490
1092	1015	7	applied	\N	\N	\N	\N	63323	63323	231491
1092	1016	8	applied	\N	\N	\N	\N	63324	63324	231492
1093	1017	0	applied	\N	\N	\N	\N	63325	63325	231493
1093	1018	1	applied	\N	\N	\N	\N	63326	63326	231494
1093	1019	2	applied	\N	\N	\N	\N	63327	63327	231495
1093	1021	4	applied	\N	\N	\N	\N	63329	63329	231497
1093	1022	5	applied	\N	\N	\N	\N	63330	63330	231498
1093	1023	6	applied	\N	\N	\N	\N	63331	63331	231499
1093	1024	7	applied	\N	\N	\N	\N	63332	63332	231500
1093	1025	8	applied	\N	\N	\N	\N	63333	63333	231501
1093	1026	9	applied	\N	\N	\N	\N	63334	63334	231502
1095	1027	0	applied	\N	\N	\N	\N	63339	63339	231507
1095	1028	1	applied	\N	\N	\N	\N	63340	63340	231508
1095	1029	2	applied	\N	\N	\N	\N	63341	63341	231509
1095	1030	3	applied	\N	\N	\N	\N	63342	63342	231510
1096	1027	0	applied	\N	\N	\N	\N	63343	63343	231511
1096	1028	1	applied	\N	\N	\N	\N	63344	63344	231512
1096	1029	2	applied	\N	\N	\N	\N	63345	63345	231513
1096	1030	3	applied	\N	\N	\N	\N	63346	63346	231514
1098	1031	0	applied	\N	\N	\N	\N	63348	63348	231516
1099	1031	0	applied	\N	\N	\N	\N	63349	63349	231517
1101	1033	0	applied	\N	\N	\N	\N	63351	63351	231519
1103	1034	0	applied	\N	\N	\N	\N	63353	63353	231521
1104	1035	0	applied	\N	\N	\N	\N	63354	63354	231522
1106	1036	0	applied	\N	\N	\N	\N	63356	63356	231524
1107	1036	0	applied	\N	\N	\N	\N	63357	63357	231525
1108	1037	0	applied	\N	\N	\N	\N	63358	63358	231526
1109	1037	0	applied	\N	\N	\N	\N	63359	63359	231527
1110	1037	0	applied	\N	\N	\N	\N	63360	63360	231528
1111	1037	0	applied	\N	\N	\N	\N	63361	63361	231529
1112	1038	0	applied	\N	\N	\N	\N	63362	63362	231530
1112	1039	1	applied	\N	\N	\N	\N	63363	63363	231531
1113	1038	0	applied	\N	\N	\N	\N	63364	63364	231532
1113	1039	1	applied	\N	\N	\N	\N	63365	63365	231533
1114	1038	0	applied	\N	\N	\N	\N	63366	63366	231534
1114	1039	1	applied	\N	\N	\N	\N	63367	63367	231535
1115	1040	0	applied	\N	\N	\N	\N	63368	63368	231536
1117	1041	0	applied	\N	\N	\N	\N	63370	63370	231538
1118	1041	0	applied	\N	\N	\N	\N	63371	63371	231539
1119	1042	0	applied	\N	\N	\N	\N	63372	63372	231540
1119	1043	1	applied	\N	\N	\N	\N	63373	63373	231541
1120	1042	0	applied	\N	\N	\N	\N	63374	63374	231542
1120	1043	1	applied	\N	\N	\N	\N	63375	63375	231543
1121	1042	0	applied	\N	\N	\N	\N	63376	63376	231544
1121	1043	1	applied	\N	\N	\N	\N	63377	63377	231545
1122	1044	0	applied	\N	\N	\N	\N	63378	63378	231546
1122	1045	1	applied	\N	\N	\N	\N	63379	63379	231547
1124	1046	0	applied	\N	\N	\N	\N	63381	63381	231549
1125	992	0	applied	\N	\N	\N	\N	63382	63382	231550
1125	977	1	applied	\N	\N	\N	\N	63383	63383	231551
1125	978	2	applied	\N	\N	\N	\N	63384	63384	231552
1125	979	3	applied	\N	\N	\N	\N	63385	63385	231553
1125	980	4	applied	\N	\N	\N	\N	63386	63386	231554
1125	982	6	applied	\N	\N	\N	\N	63388	63388	231556
1125	983	7	applied	\N	\N	\N	\N	63389	63389	231557
1125	984	8	applied	\N	\N	\N	\N	63390	63390	231558
1125	985	9	applied	\N	\N	\N	\N	63391	63391	231559
1125	986	10	applied	\N	\N	\N	\N	63392	63392	231560
1125	987	11	applied	\N	\N	\N	\N	63393	63393	231561
1125	988	12	applied	\N	\N	\N	\N	63394	63394	231562
1125	993	13	applied	\N	\N	\N	\N	63395	63395	231563
1125	994	14	applied	\N	\N	\N	\N	63396	63396	231564
1125	995	15	applied	\N	\N	\N	\N	63397	63397	231565
1125	996	16	applied	\N	\N	\N	\N	63398	63398	231566
1125	997	17	applied	\N	\N	\N	\N	63399	63399	231567
1125	1000	18	applied	\N	\N	\N	\N	63400	63400	231568
1125	1001	19	applied	\N	\N	\N	\N	63401	63401	231569
1125	1002	20	applied	\N	\N	\N	\N	63402	63402	231570
1125	1003	21	applied	\N	\N	\N	\N	63403	63403	231571
1125	1005	23	applied	\N	\N	\N	\N	63405	63405	231573
1125	1006	24	applied	\N	\N	\N	\N	63406	63406	231574
1125	1007	25	applied	\N	\N	\N	\N	63407	63407	231575
1125	1009	26	applied	\N	\N	\N	\N	63408	63408	231576
1125	1010	27	applied	\N	\N	\N	\N	63409	63409	231577
1125	1011	29	applied	\N	\N	\N	\N	63410	63410	231578
1125	1012	30	applied	\N	\N	\N	\N	63411	63411	231579
1125	1013	31	applied	\N	\N	\N	\N	63412	63412	231580
1125	1014	32	applied	\N	\N	\N	\N	63413	63413	231581
1125	1015	33	applied	\N	\N	\N	\N	63414	63414	231582
1125	1016	34	applied	\N	\N	\N	\N	63415	63415	231583
1125	1018	35	applied	\N	\N	\N	\N	63416	63416	231584
1125	1019	36	applied	\N	\N	\N	\N	63417	63417	231585
1125	1020	37	applied	\N	\N	\N	\N	63418	63418	231586
1125	1021	38	applied	\N	\N	\N	\N	63419	63419	231587
1125	1022	39	applied	\N	\N	\N	\N	63420	63420	231588
1125	1024	41	applied	\N	\N	\N	\N	63422	63422	231590
1125	1025	42	applied	\N	\N	\N	\N	63423	63423	231591
1125	1026	43	applied	\N	\N	\N	\N	63424	63424	231592
1125	1028	44	applied	\N	\N	\N	\N	63425	63425	231593
1125	1029	45	applied	\N	\N	\N	\N	63426	63426	231594
1125	1030	46	applied	\N	\N	\N	\N	63427	63427	231595
1125	989	47	applied	\N	\N	\N	\N	63428	63428	231596
1125	990	48	applied	\N	\N	\N	\N	63429	63429	231597
1125	991	49	applied	\N	\N	\N	\N	63430	63430	231598
1125	998	50	applied	\N	\N	\N	\N	63431	63431	231599
1125	999	51	applied	\N	\N	\N	\N	63432	63432	231600
1125	1008	52	applied	\N	\N	\N	\N	63433	63433	231601
1125	1017	53	applied	\N	\N	\N	\N	63434	63434	231602
1125	1027	54	applied	\N	\N	\N	\N	63435	63435	231603
1090	1010	2	applied	\N	\N	\N	\N	63301	63301	231469
1090	1011	3	applied	\N	\N	\N	\N	63302	63302	231470
1125	1034	58	applied	\N	\N	\N	\N	63439	63439	231607
1125	1035	59	applied	\N	\N	\N	\N	63440	63440	231608
1125	1036	60	applied	\N	\N	\N	\N	63441	63441	231609
1125	1037	61	applied	\N	\N	\N	\N	63442	63442	231610
1125	1038	62	applied	\N	\N	\N	\N	63443	63443	231611
1125	1039	63	applied	\N	\N	\N	\N	63444	63444	231612
1125	1040	64	applied	\N	\N	\N	\N	63445	63445	231613
1125	1041	65	applied	\N	\N	\N	\N	63446	63446	231614
1125	1042	66	applied	\N	\N	\N	\N	63447	63447	231615
1125	1043	67	applied	\N	\N	\N	\N	63448	63448	231616
1125	1044	68	applied	\N	\N	\N	\N	63449	63449	231617
1125	1045	69	applied	\N	\N	\N	\N	63450	63450	231618
1125	1046	70	applied	\N	\N	\N	\N	63451	63451	231619
1126	1047	0	applied	\N	\N	\N	\N	63452	63452	231620
1126	1048	1	applied	\N	\N	\N	\N	63453	63453	231621
1127	1049	0	applied	\N	\N	\N	\N	63454	63454	231622
1129	1050	0	applied	\N	\N	\N	\N	63456	63456	231624
1130	1051	0	applied	\N	\N	\N	\N	63457	63457	231625
1131	1052	0	applied	\N	\N	\N	\N	63458	63458	231626
1132	1053	0	applied	\N	\N	\N	\N	63459	63459	231627
1132	1054	1	applied	\N	\N	\N	\N	63460	63460	231628
1133	1055	0	applied	\N	\N	\N	\N	63461	63461	231629
1134	1056	0	applied	\N	\N	\N	\N	63462	63462	231630
1134	1057	1	applied	\N	\N	\N	\N	63463	63463	231631
1135	1056	0	applied	\N	\N	\N	\N	63464	63464	231632
1135	1057	1	applied	\N	\N	\N	\N	63465	63465	231633
1136	1058	0	applied	\N	\N	\N	\N	63466	63466	231634
1137	1058	0	applied	\N	\N	\N	\N	63467	63467	231635
1138	1059	0	applied	\N	\N	\N	\N	63468	63468	231636
1139	1059	0	applied	\N	\N	\N	\N	63469	63469	231637
1140	1059	0	applied	\N	\N	\N	\N	63470	63470	231638
1141	1060	0	applied	\N	\N	\N	\N	63471	63471	231639
1143	1061	0	applied	\N	\N	\N	\N	63473	63473	231641
1144	1061	0	applied	\N	\N	\N	\N	63474	63474	231642
1145	1061	0	applied	\N	\N	\N	\N	63475	63475	231643
1146	1062	0	applied	\N	\N	\N	\N	63476	63476	231644
1147	1062	0	applied	\N	\N	\N	\N	63477	63477	231645
1148	1062	0	applied	\N	\N	\N	\N	63478	63478	231646
1149	1062	0	applied	\N	\N	\N	\N	63479	63479	231647
1150	1063	0	applied	\N	\N	\N	\N	63480	63480	231648
1151	1064	0	applied	\N	\N	\N	\N	63481	63481	231649
1151	1065	1	applied	\N	\N	\N	\N	63482	63482	231650
1152	1066	0	applied	\N	\N	\N	\N	63483	63483	231651
1152	1067	1	applied	\N	\N	\N	\N	63484	63484	231652
1152	1068	2	applied	\N	\N	\N	\N	63485	63485	231653
1153	1066	0	applied	\N	\N	\N	\N	63486	63486	231654
1153	1067	1	applied	\N	\N	\N	\N	63487	63487	231655
1153	1068	2	applied	\N	\N	\N	\N	63488	63488	231656
1154	1067	1	applied	\N	\N	\N	\N	63490	63490	231658
1154	1068	2	applied	\N	\N	\N	\N	63491	63491	231659
1155	1069	0	applied	\N	\N	\N	\N	63492	63492	231660
1156	1069	0	applied	\N	\N	\N	\N	63493	63493	231661
1157	1070	0	applied	\N	\N	\N	\N	63494	63494	231662
1158	1071	0	applied	\N	\N	\N	\N	63495	63495	231663
1159	1072	0	applied	\N	\N	\N	\N	63496	63496	231664
1160	1072	0	applied	\N	\N	\N	\N	63497	63497	231665
1161	1073	0	applied	\N	\N	\N	\N	63498	63498	231666
1161	1074	1	applied	\N	\N	\N	\N	63499	63499	231667
1162	1073	0	applied	\N	\N	\N	\N	63500	63500	231668
1162	1074	1	applied	\N	\N	\N	\N	63501	63501	231669
1163	1075	0	applied	\N	\N	\N	\N	63502	63502	231670
1164	1075	0	applied	\N	\N	\N	\N	63503	63503	231671
1165	1076	0	applied	\N	\N	\N	\N	63504	63504	231672
1165	1077	1	applied	\N	\N	\N	\N	63505	63505	231673
1168	1078	0	applied	\N	\N	\N	\N	63509	63509	231677
1170	1078	0	applied	\N	\N	\N	\N	63511	63511	231679
1171	1079	0	applied	\N	\N	\N	\N	63512	63512	231680
1172	1080	0	applied	\N	\N	\N	\N	63513	63513	231681
1175	1082	0	applied	\N	\N	\N	\N	63517	63517	231685
1175	1083	1	applied	\N	\N	\N	\N	63518	63518	231686
1176	1084	0	applied	\N	\N	\N	\N	63519	63519	231687
1179	1086	0	applied	\N	\N	\N	\N	63523	63523	231691
1179	1087	1	applied	\N	\N	\N	\N	63524	63524	231692
1180	1088	0	applied	\N	\N	\N	\N	63525	63525	231693
1182	1090	0	applied	\N	\N	\N	\N	63527	63527	231695
1183	1090	0	applied	\N	\N	\N	\N	63528	63528	231696
1186	1093	0	applied	\N	\N	\N	\N	63534	63534	231702
1186	1094	1	applied	\N	\N	\N	\N	63535	63535	231703
1186	1095	2	applied	\N	\N	\N	\N	63536	63536	231704
1187	1096	0	applied	\N	\N	\N	\N	63537	63537	231705
1187	1098	2	applied	\N	\N	\N	\N	63539	63539	231707
1190	1099	0	applied	\N	\N	\N	\N	63540	63540	231708
1192	1100	0	applied	\N	\N	\N	\N	63543	63543	231711
1192	1101	1	applied	\N	\N	\N	\N	63544	63544	231712
1193	1100	0	applied	\N	\N	\N	\N	63545	63545	231713
1193	1101	1	applied	\N	\N	\N	\N	63546	63546	231714
1195	1102	0	applied	\N	\N	\N	\N	63549	63549	231717
1196	1102	0	applied	\N	\N	\N	\N	63550	63550	231718
1198	1103	0	applied	\N	\N	\N	\N	63552	63552	231720
1199	1104	0	applied	\N	\N	\N	\N	63553	63553	231721
1201	1105	0	applied	\N	\N	\N	\N	63555	63555	231723
1202	1106	0	applied	\N	\N	\N	\N	63556	63556	231724
1204	1107	0	applied	\N	\N	\N	\N	63558	63558	231726
1205	1107	0	applied	\N	\N	\N	\N	63559	63559	231727
1207	1108	0	applied	\N	\N	\N	\N	63561	63561	231729
1207	1109	1	applied	\N	\N	\N	\N	63562	63562	231730
1211	1111	0	applied	\N	\N	\N	\N	63566	63566	231734
1214	1112	0	applied	\N	\N	\N	\N	63569	63569	231737
1215	1113	0	applied	\N	\N	\N	\N	63570	63570	231738
1215	1114	1	applied	\N	\N	\N	\N	63571	63571	231739
1215	1115	2	applied	\N	\N	\N	\N	63572	63572	231740
1217	1116	0	applied	\N	\N	\N	\N	63574	63574	231742
1220	1118	0	applied	\N	\N	\N	\N	63577	63577	231745
1223	1121	0	applied	\N	\N	\N	\N	63583	63583	231751
1223	1122	1	applied	\N	\N	\N	\N	63584	63584	231752
1223	1123	2	applied	\N	\N	\N	\N	63585	63585	231753
1226	1125	0	applied	\N	\N	\N	\N	63590	63590	231758
1229	1127	0	applied	\N	\N	\N	\N	63593	63593	231761
1232	1130	0	applied	\N	\N	\N	\N	63598	63598	231766
1235	1134	0	applied	\N	\N	\N	\N	63602	63602	231770
1125	1031	55	applied	\N	\N	\N	\N	63436	63436	231604
1125	1032	56	applied	\N	\N	\N	\N	63437	63437	231605
1174	1082	0	applied	\N	\N	\N	\N	63515	63515	231683
1174	1083	1	applied	\N	\N	\N	\N	63516	63516	231684
1177	1085	0	applied	\N	\N	\N	\N	63520	63520	231688
1178	1086	0	applied	\N	\N	\N	\N	63521	63521	231689
1178	1087	1	applied	\N	\N	\N	\N	63522	63522	231690
1181	1089	0	applied	\N	\N	\N	\N	63526	63526	231694
1184	1091	0	applied	\N	\N	\N	\N	63529	63529	231697
1184	1092	1	applied	\N	\N	\N	\N	63530	63530	231698
1185	1093	0	applied	\N	\N	\N	\N	63531	63531	231699
1185	1094	1	applied	\N	\N	\N	\N	63532	63532	231700
1185	1095	2	applied	\N	\N	\N	\N	63533	63533	231701
1191	1100	0	applied	\N	\N	\N	\N	63541	63541	231709
1191	1101	1	applied	\N	\N	\N	\N	63542	63542	231710
1194	1100	0	applied	\N	\N	\N	\N	63547	63547	231715
1194	1101	1	applied	\N	\N	\N	\N	63548	63548	231716
1197	1103	0	applied	\N	\N	\N	\N	63551	63551	231719
1203	1107	0	applied	\N	\N	\N	\N	63557	63557	231725
1206	1107	0	applied	\N	\N	\N	\N	63560	63560	231728
1209	1110	0	applied	\N	\N	\N	\N	63564	63564	231732
1210	1110	0	applied	\N	\N	\N	\N	63565	63565	231733
1212	1111	0	applied	\N	\N	\N	\N	63567	63567	231735
1213	1111	0	applied	\N	\N	\N	\N	63568	63568	231736
1216	1116	0	applied	\N	\N	\N	\N	63573	63573	231741
1218	1116	0	applied	\N	\N	\N	\N	63575	63575	231743
1219	1117	0	applied	\N	\N	\N	\N	63576	63576	231744
1221	1119	0	applied	\N	\N	\N	\N	63578	63578	231746
1221	1120	1	applied	\N	\N	\N	\N	63579	63579	231747
1222	1121	0	applied	\N	\N	\N	\N	63580	63580	231748
1222	1122	1	applied	\N	\N	\N	\N	63581	63581	231749
1222	1123	2	applied	\N	\N	\N	\N	63582	63582	231750
1224	1121	0	applied	\N	\N	\N	\N	63586	63586	231754
1224	1122	1	applied	\N	\N	\N	\N	63587	63587	231755
1225	1124	0	applied	\N	\N	\N	\N	63589	63589	231757
1227	1125	0	applied	\N	\N	\N	\N	63591	63591	231759
1228	1126	0	applied	\N	\N	\N	\N	63592	63592	231760
1230	1128	0	applied	\N	\N	\N	\N	63594	63594	231762
1230	1129	1	applied	\N	\N	\N	\N	63595	63595	231763
1231	1128	0	applied	\N	\N	\N	\N	63596	63596	231764
1231	1129	1	applied	\N	\N	\N	\N	63597	63597	231765
1233	1131	0	applied	\N	\N	\N	\N	63599	63599	231767
1234	1132	0	applied	\N	\N	\N	\N	63600	63600	231768
1234	1133	1	applied	\N	\N	\N	\N	63601	63601	231769
1236	1135	0	applied	\N	\N	\N	\N	63603	63603	231771
1237	1135	0	applied	\N	\N	\N	\N	63604	63604	231772
1238	1136	0	applied	\N	\N	\N	\N	63605	63605	231773
1239	1136	0	applied	\N	\N	\N	\N	63606	63606	231774
1240	1136	0	applied	\N	\N	\N	\N	63607	63607	231775
1241	1137	0	applied	\N	\N	\N	\N	63608	63608	231776
1243	1139	0	applied	\N	\N	\N	\N	63610	63610	231778
1244	1140	0	applied	\N	\N	\N	\N	63611	63611	231779
1245	1141	0	applied	\N	\N	\N	\N	63612	63612	231780
1246	1141	0	applied	\N	\N	\N	\N	63613	63613	231781
1247	1141	0	applied	\N	\N	\N	\N	63614	63614	231782
1248	1142	0	applied	\N	\N	\N	\N	63615	63615	231783
1249	1142	0	applied	\N	\N	\N	\N	63616	63616	231784
1250	1143	0	applied	\N	\N	\N	\N	63617	63617	231785
1251	1143	0	applied	\N	\N	\N	\N	63618	63618	231786
1252	1144	0	applied	\N	\N	\N	\N	63619	63619	231787
1252	1145	1	applied	\N	\N	\N	\N	63620	63620	231788
1253	1144	0	applied	\N	\N	\N	\N	63621	63621	231789
1253	1145	1	applied	\N	\N	\N	\N	63622	63622	231790
1255	1146	0	applied	\N	\N	\N	\N	63623	63623	231791
1256	1146	0	applied	\N	\N	\N	\N	63624	63624	231792
1257	1147	0	applied	\N	\N	\N	\N	63625	63625	231793
1258	1149	1	applied	\N	\N	\N	\N	63627	63627	231795
1258	1150	2	applied	\N	\N	\N	\N	63628	63628	231796
1258	1151	3	applied	\N	\N	\N	\N	63629	63629	231797
1259	1152	0	applied	\N	\N	\N	\N	63630	63630	231798
1260	1152	0	applied	\N	\N	\N	\N	63631	63631	231799
1261	1152	0	applied	\N	\N	\N	\N	63632	63632	231800
1262	1153	0	applied	\N	\N	\N	\N	63633	63633	231801
1262	1154	1	applied	\N	\N	\N	\N	63634	63634	231802
1262	1155	2	applied	\N	\N	\N	\N	63635	63635	231803
1262	1156	3	applied	\N	\N	\N	\N	63636	63636	231804
1263	1153	0	applied	\N	\N	\N	\N	63637	63637	231805
1263	1154	1	applied	\N	\N	\N	\N	63638	63638	231806
1263	1155	2	applied	\N	\N	\N	\N	63639	63639	231807
1263	1156	3	applied	\N	\N	\N	\N	63640	63640	231808
1264	1153	0	applied	\N	\N	\N	\N	63641	63641	231809
1264	1154	1	applied	\N	\N	\N	\N	63642	63642	231810
1264	1156	3	applied	\N	\N	\N	\N	63644	63644	231812
1265	1139	0	applied	\N	\N	\N	\N	63645	63645	231813
1265	1140	1	applied	\N	\N	\N	\N	63646	63646	231814
1265	1141	2	applied	\N	\N	\N	\N	63647	63647	231815
1265	1142	3	applied	\N	\N	\N	\N	63648	63648	231816
1265	1143	4	applied	\N	\N	\N	\N	63649	63649	231817
1265	1144	5	applied	\N	\N	\N	\N	63650	63650	231818
1265	1145	6	applied	\N	\N	\N	\N	63651	63651	231819
1265	1146	7	applied	\N	\N	\N	\N	63652	63652	231820
1265	1147	8	applied	\N	\N	\N	\N	63653	63653	231821
1265	1148	9	applied	\N	\N	\N	\N	63654	63654	231822
1265	1149	10	applied	\N	\N	\N	\N	63655	63655	231823
1265	1150	11	applied	\N	\N	\N	\N	63656	63656	231824
1265	1151	12	applied	\N	\N	\N	\N	63657	63657	231825
1265	1152	13	applied	\N	\N	\N	\N	63658	63658	231826
1265	1153	14	applied	\N	\N	\N	\N	63659	63659	231827
1265	1155	16	applied	\N	\N	\N	\N	63661	63661	231829
1265	1156	17	applied	\N	\N	\N	\N	63662	63662	231830
1265	1157	18	applied	\N	\N	\N	\N	63663	63663	231831
1266	1157	0	applied	\N	\N	\N	\N	63664	63664	231832
1266	1158	1	applied	\N	\N	\N	\N	63665	63665	231833
1266	1159	2	applied	\N	\N	\N	\N	63666	63666	231834
1267	1157	0	applied	\N	\N	\N	\N	63667	63667	231835
1267	1158	1	applied	\N	\N	\N	\N	63668	63668	231836
1267	1159	2	applied	\N	\N	\N	\N	63669	63669	231837
1268	1160	0	applied	\N	\N	\N	\N	63670	63670	231838
1269	1161	0	applied	\N	\N	\N	\N	63671	63671	231839
1270	1161	0	applied	\N	\N	\N	\N	63672	63672	231840
1271	1161	0	applied	\N	\N	\N	\N	63673	63673	231841
1272	1162	0	applied	\N	\N	\N	\N	63674	63674	231842
1167	1078	0	applied	\N	\N	\N	\N	63508	63508	231676
1169	1078	0	applied	\N	\N	\N	\N	63510	63510	231678
1277	1165	0	applied	\N	\N	\N	\N	63679	63679	231847
1278	1165	0	applied	\N	\N	\N	\N	63680	63680	231848
1279	1166	0	applied	\N	\N	\N	\N	63681	63681	231849
1280	1167	0	applied	\N	\N	\N	\N	63682	63682	231850
1281	1168	0	applied	\N	\N	\N	\N	63683	63683	231851
1282	1169	0	applied	\N	\N	\N	\N	63684	63684	231852
1283	1169	0	applied	\N	\N	\N	\N	63685	63685	231853
1284	1169	0	applied	\N	\N	\N	\N	63686	63686	231854
1285	1169	0	applied	\N	\N	\N	\N	63687	63687	231855
1286	1169	0	applied	\N	\N	\N	\N	63688	63688	231856
1287	1170	0	applied	\N	\N	\N	\N	63689	63689	231857
1288	1171	0	applied	\N	\N	\N	\N	63690	63690	231858
1288	1172	1	applied	\N	\N	\N	\N	63691	63691	231859
1289	1173	0	applied	\N	\N	\N	\N	63692	63692	231860
1291	1174	0	applied	\N	\N	\N	\N	63694	63694	231862
1292	1174	0	applied	\N	\N	\N	\N	63695	63695	231863
1293	1175	0	applied	\N	\N	\N	\N	63696	63696	231864
1293	1176	1	applied	\N	\N	\N	\N	63697	63697	231865
1294	1175	0	applied	\N	\N	\N	\N	63698	63698	231866
1294	1176	1	applied	\N	\N	\N	\N	63699	63699	231867
1295	1177	0	applied	\N	\N	\N	\N	63700	63700	231868
1296	1178	0	applied	\N	\N	\N	\N	63701	63701	231869
1296	1179	1	applied	\N	\N	\N	\N	63702	63702	231870
1296	1180	2	applied	\N	\N	\N	\N	63703	63703	231871
1296	1181	3	applied	\N	\N	\N	\N	63704	63704	231872
1297	1178	0	applied	\N	\N	\N	\N	63705	63705	231873
1297	1179	1	applied	\N	\N	\N	\N	63706	63706	231874
1297	1180	2	applied	\N	\N	\N	\N	63707	63707	231875
1297	1181	3	applied	\N	\N	\N	\N	63708	63708	231876
1298	1178	0	applied	\N	\N	\N	\N	63709	63709	231877
1298	1180	2	applied	\N	\N	\N	\N	63711	63711	231879
1298	1181	3	applied	\N	\N	\N	\N	63712	63712	231880
1299	1178	0	applied	\N	\N	\N	\N	63713	63713	231881
1299	1179	1	applied	\N	\N	\N	\N	63714	63714	231882
1299	1180	2	applied	\N	\N	\N	\N	63715	63715	231883
1299	1181	3	applied	\N	\N	\N	\N	63716	63716	231884
1300	1178	0	applied	\N	\N	\N	\N	63717	63717	231885
1300	1179	1	applied	\N	\N	\N	\N	63718	63718	231886
1300	1180	2	applied	\N	\N	\N	\N	63719	63719	231887
1300	1181	3	applied	\N	\N	\N	\N	63720	63720	231888
1301	1182	0	applied	\N	\N	\N	\N	63721	63721	231889
1302	1182	0	applied	\N	\N	\N	\N	63722	63722	231890
1303	1183	0	applied	\N	\N	\N	\N	63723	63723	231891
1303	1184	1	applied	\N	\N	\N	\N	63724	63724	231892
1303	1185	2	applied	\N	\N	\N	\N	63725	63725	231893
1304	1186	0	applied	\N	\N	\N	\N	63726	63726	231894
1306	1188	0	applied	\N	\N	\N	\N	63728	63728	231896
1306	1189	1	applied	\N	\N	\N	\N	63729	63729	231897
1306	1190	2	applied	\N	\N	\N	\N	63730	63730	231898
1310	1191	0	applied	\N	\N	\N	\N	63731	63731	231899
1311	1191	0	applied	\N	\N	\N	\N	63732	63732	231900
1312	1192	0	applied	\N	\N	\N	\N	63733	63733	231901
1313	1193	0	applied	\N	\N	\N	\N	63734	63734	231902
1314	1193	0	applied	\N	\N	\N	\N	63735	63735	231903
1315	1193	0	applied	\N	\N	\N	\N	63736	63736	231904
1316	1194	0	applied	\N	\N	\N	\N	63737	63737	231905
1317	1194	0	applied	\N	\N	\N	\N	63738	63738	231906
1318	1195	0	applied	\N	\N	\N	\N	63739	63739	231907
1319	1195	0	applied	\N	\N	\N	\N	63740	63740	231908
1320	1196	0	applied	\N	\N	\N	\N	63741	63741	231909
1320	1197	1	applied	\N	\N	\N	\N	63742	63742	231910
1320	1198	2	applied	\N	\N	\N	\N	63743	63743	231911
1320	1200	4	applied	\N	\N	\N	\N	63745	63745	231913
1321	1196	0	applied	\N	\N	\N	\N	63746	63746	231914
1321	1197	1	applied	\N	\N	\N	\N	63747	63747	231915
1321	1198	2	applied	\N	\N	\N	\N	63748	63748	231916
1321	1199	3	applied	\N	\N	\N	\N	63749	63749	231917
1321	1200	4	applied	\N	\N	\N	\N	63750	63750	231918
1324	1201	0	applied	\N	\N	\N	\N	63751	63751	231919
1324	1202	1	applied	\N	\N	\N	\N	63752	63752	231920
1324	1203	2	applied	\N	\N	1000000000	\N	63753	63753	231921
1325	1201	0	applied	\N	\N	\N	\N	63754	63754	231922
1325	1202	1	applied	\N	\N	\N	\N	63755	63755	231923
1326	1204	0	applied	\N	\N	\N	\N	63757	63757	231925
1326	1205	1	applied	\N	\N	\N	\N	63758	63758	231926
1326	1206	2	applied	\N	\N	\N	\N	63759	63759	231927
1327	1207	0	applied	\N	\N	\N	\N	63760	63760	231928
1329	1208	0	applied	\N	\N	\N	\N	63762	63762	231930
1331	1209	0	applied	\N	\N	\N	\N	63764	63764	231932
1332	1210	0	applied	\N	\N	\N	\N	63765	63765	231933
1333	1210	0	applied	\N	\N	\N	\N	63766	63766	231934
1336	1213	0	applied	\N	\N	\N	\N	63823	63823	231991
1339	1212	0	applied	\N	\N	\N	\N	63826	63826	231994
1339	1213	1	applied	\N	\N	\N	\N	63827	63827	231995
1339	1214	2	applied	\N	\N	\N	\N	63828	63828	231996
1343	1217	0	applied	\N	\N	\N	\N	63832	63832	232000
1344	1215	0	applied	\N	\N	\N	\N	63833	63833	232001
1344	1216	1	applied	\N	\N	\N	\N	63834	63834	232002
1344	1217	2	applied	\N	\N	\N	\N	63835	63835	232003
1346	1218	0	applied	\N	\N	\N	\N	63837	63837	232005
1348	1218	0	applied	\N	\N	\N	\N	63839	63839	232007
1349	1218	0	applied	\N	\N	\N	\N	63840	63840	232008
1352	1220	0	applied	\N	\N	\N	\N	63843	63843	232011
1353	1220	0	applied	\N	\N	\N	\N	63844	63844	232012
1355	1222	1	applied	\N	\N	\N	\N	63848	63848	232016
1356	1223	0	applied	\N	\N	\N	\N	63849	63849	232017
1356	1224	1	applied	\N	\N	\N	\N	63850	63850	232018
1356	1225	2	applied	\N	\N	\N	\N	63851	63851	232019
1356	1226	3	applied	\N	\N	\N	\N	63852	63852	232020
1357	1227	0	applied	\N	\N	\N	\N	63853	63853	232021
1358	1227	0	applied	\N	\N	\N	\N	63854	63854	232022
1360	1228	0	applied	\N	\N	\N	\N	63856	63856	232024
1361	1228	0	applied	\N	\N	\N	\N	63857	63857	232025
1363	1229	0	applied	\N	\N	\N	\N	63860	63860	232028
1363	1230	1	applied	\N	\N	\N	\N	63861	63861	232029
1364	1229	0	applied	\N	\N	\N	\N	63862	63862	232030
1364	1230	1	applied	\N	\N	\N	\N	63863	63863	232031
1367	1232	0	applied	\N	\N	\N	\N	63866	63866	232034
1368	1233	0	applied	\N	\N	\N	\N	63867	63867	232035
1370	1234	0	applied	\N	\N	\N	\N	63869	63869	232037
1276	1164	0	applied	\N	\N	\N	\N	63678	63678	231846
1334	1160	2	applied	\N	\N	\N	\N	63769	63769	231937
1334	1161	3	applied	\N	\N	\N	\N	63770	63770	231938
1334	1162	4	applied	\N	\N	\N	\N	63771	63771	231939
1334	1163	5	applied	\N	\N	\N	\N	63772	63772	231940
1334	1164	6	applied	\N	\N	\N	\N	63773	63773	231941
1334	1165	7	applied	\N	\N	\N	\N	63774	63774	231942
1334	1166	8	applied	\N	\N	\N	\N	63775	63775	231943
1334	1167	9	applied	\N	\N	\N	\N	63776	63776	231944
1334	1168	10	applied	\N	\N	\N	\N	63777	63777	231945
1334	1169	11	applied	\N	\N	\N	\N	63778	63778	231946
1334	1170	12	applied	\N	\N	\N	\N	63779	63779	231947
1334	1176	13	applied	\N	\N	\N	\N	63780	63780	231948
1334	1171	14	applied	\N	\N	\N	\N	63781	63781	231949
1334	1172	15	applied	\N	\N	\N	\N	63782	63782	231950
1334	1174	17	applied	\N	\N	\N	\N	63784	63784	231952
1334	1175	18	applied	\N	\N	\N	\N	63785	63785	231953
1334	1177	19	applied	\N	\N	\N	\N	63786	63786	231954
1334	1178	20	applied	\N	\N	\N	\N	63787	63787	231955
1334	1179	21	applied	\N	\N	\N	\N	63788	63788	231956
1334	1180	22	applied	\N	\N	\N	\N	63789	63789	231957
1334	1181	23	applied	\N	\N	\N	\N	63790	63790	231958
1334	1182	24	applied	\N	\N	\N	\N	63791	63791	231959
1334	1183	25	applied	\N	\N	\N	\N	63792	63792	231960
1334	1184	26	applied	\N	\N	\N	\N	63793	63793	231961
1334	1186	27	applied	\N	\N	\N	\N	63794	63794	231962
1334	1187	28	applied	\N	\N	\N	\N	63795	63795	231963
1334	1188	29	applied	\N	\N	\N	\N	63796	63796	231964
1334	1189	30	applied	\N	\N	\N	\N	63797	63797	231965
1334	1191	31	applied	\N	\N	\N	\N	63798	63798	231966
1334	1192	32	applied	\N	\N	\N	\N	63799	63799	231967
1334	1194	34	applied	\N	\N	\N	\N	63801	63801	231969
1334	1195	36	applied	\N	\N	\N	\N	63802	63802	231970
1334	1196	37	applied	\N	\N	\N	\N	63803	63803	231971
1334	1197	38	applied	\N	\N	\N	\N	63804	63804	231972
1334	1198	39	applied	\N	\N	\N	\N	63805	63805	231973
1334	1199	40	applied	\N	\N	\N	\N	63806	63806	231974
1334	1200	41	applied	\N	\N	\N	\N	63807	63807	231975
1334	1201	42	applied	\N	\N	\N	\N	63808	63808	231976
1334	1202	43	applied	\N	\N	\N	\N	63809	63809	231977
1334	1204	44	applied	\N	\N	\N	\N	63810	63810	231978
1334	1205	45	applied	\N	\N	\N	\N	63811	63811	231979
1334	1206	46	applied	\N	\N	\N	\N	63812	63812	231980
1334	1207	47	applied	\N	\N	\N	\N	63813	63813	231981
1334	1208	48	applied	\N	\N	\N	\N	63814	63814	231982
1334	1209	49	applied	\N	\N	\N	\N	63815	63815	231983
1334	1210	50	applied	\N	\N	\N	\N	63816	63816	231984
1334	1185	52	applied	\N	\N	\N	\N	63818	63818	231986
1334	1203	53	applied	\N	\N	1000000000	\N	63819	63819	231987
1334	1190	54	applied	\N	\N	\N	\N	63820	63820	231988
1335	1211	0	applied	\N	\N	\N	\N	63821	63821	231989
1335	1212	1	applied	\N	\N	\N	\N	63822	63822	231990
1337	1213	0	applied	\N	\N	\N	\N	63824	63824	231992
1338	1214	0	applied	\N	\N	\N	\N	63825	63825	231993
1340	1214	0	applied	\N	\N	\N	\N	63829	63829	231997
1341	1215	0	applied	\N	\N	\N	\N	63830	63830	231998
1342	1216	0	applied	\N	\N	\N	\N	63831	63831	231999
1345	1217	0	applied	\N	\N	\N	\N	63836	63836	232004
1347	1218	0	applied	\N	\N	\N	\N	63838	63838	232006
1350	1218	0	applied	\N	\N	\N	\N	63841	63841	232009
1351	1219	0	applied	\N	\N	\N	\N	63842	63842	232010
1354	1221	0	applied	\N	\N	\N	\N	63845	63845	232013
1354	1222	1	applied	\N	\N	\N	\N	63846	63846	232014
1362	1229	0	applied	\N	\N	\N	\N	63858	63858	232026
1362	1230	1	applied	\N	\N	\N	\N	63859	63859	232027
1365	1231	0	applied	\N	\N	\N	\N	63864	63864	232032
1366	1232	0	applied	\N	\N	\N	\N	63865	63865	232033
1369	1233	0	applied	\N	\N	\N	\N	63868	63868	232036
1371	1234	0	applied	\N	\N	\N	\N	63870	63870	232038
1372	1235	0	applied	\N	\N	\N	\N	63871	63871	232039
1373	1235	0	applied	\N	\N	\N	\N	63872	63872	232040
1374	1236	0	applied	\N	\N	\N	\N	63873	63873	232041
1374	1237	1	applied	\N	\N	\N	\N	63874	63874	232042
1375	1238	0	applied	\N	\N	\N	\N	63875	63875	232043
1376	1238	0	applied	\N	\N	\N	\N	63876	63876	232044
1377	1238	0	applied	\N	\N	\N	\N	63877	63877	232045
1378	1239	0	applied	\N	\N	\N	\N	63878	63878	232046
1379	1240	0	applied	\N	\N	\N	\N	63879	63879	232047
1379	1241	1	applied	\N	\N	\N	\N	63880	63880	232048
1380	1240	0	applied	\N	\N	\N	\N	63882	63882	232050
1380	1218	1	applied	\N	\N	\N	\N	63883	63883	232051
1380	1219	2	applied	\N	\N	\N	\N	63884	63884	232052
1380	1220	3	applied	\N	\N	\N	\N	63885	63885	232053
1380	1221	4	applied	\N	\N	\N	\N	63886	63886	232054
1380	1222	5	applied	\N	\N	\N	\N	63887	63887	232055
1380	1223	6	applied	\N	\N	\N	\N	63888	63888	232056
1380	1224	7	applied	\N	\N	\N	\N	63889	63889	232057
1380	1225	8	applied	\N	\N	\N	\N	63890	63890	232058
1380	1227	9	applied	\N	\N	\N	\N	63891	63891	232059
1380	1228	10	applied	\N	\N	\N	\N	63892	63892	232060
1380	1229	11	applied	\N	\N	\N	\N	63893	63893	232061
1380	1231	12	applied	\N	\N	\N	\N	63894	63894	232062
1380	1232	13	applied	\N	\N	\N	\N	63895	63895	232063
1380	1233	14	applied	\N	\N	\N	\N	63896	63896	232064
1380	1234	15	applied	\N	\N	\N	\N	63897	63897	232065
1380	1236	17	applied	\N	\N	\N	\N	63899	63899	232067
1380	1237	18	applied	\N	\N	\N	\N	63900	63900	232068
1380	1238	19	applied	\N	\N	\N	\N	63901	63901	232069
1380	1239	20	applied	\N	\N	\N	\N	63902	63902	232070
1380	1241	21	applied	\N	\N	\N	\N	63903	63903	232071
1380	1242	22	applied	\N	\N	\N	\N	63904	63904	232072
1380	1243	23	applied	\N	\N	\N	\N	63905	63905	232073
1380	1244	24	applied	\N	\N	\N	\N	63906	63906	232074
1380	1226	25	applied	\N	\N	\N	\N	63907	63907	232075
1383	1245	0	applied	\N	\N	\N	\N	63912	63912	232080
1383	1246	1	applied	\N	\N	\N	\N	63913	63913	232081
1383	1247	2	applied	\N	\N	\N	\N	63914	63914	232082
1383	1248	3	applied	\N	\N	\N	\N	63915	63915	232083
1383	1249	4	applied	\N	\N	\N	\N	63916	63916	232084
1383	1250	5	applied	\N	\N	\N	\N	63917	63917	232085
1328	1208	0	applied	\N	\N	\N	\N	63761	63761	231929
1334	1159	1	applied	\N	\N	\N	\N	63768	63768	231936
1387	1253	0	applied	\N	\N	\N	\N	63926	63926	232094
1387	1254	1	applied	\N	\N	\N	\N	63927	63927	232095
1387	1255	2	applied	\N	\N	\N	\N	63928	63928	232096
1387	1256	3	applied	\N	\N	\N	\N	63929	63929	232097
1387	1258	5	applied	\N	\N	\N	\N	63931	63931	232099
1388	1253	0	applied	\N	\N	\N	\N	63932	63932	232100
1388	1254	1	applied	\N	\N	\N	\N	63933	63933	232101
1388	1255	2	applied	\N	\N	\N	\N	63934	63934	232102
1388	1256	3	applied	\N	\N	\N	\N	63935	63935	232103
1388	1257	4	applied	\N	\N	\N	\N	63936	63936	232104
1388	1258	5	applied	\N	\N	\N	\N	63937	63937	232105
1390	1259	0	applied	\N	\N	\N	\N	63939	63939	232107
1391	1259	0	applied	\N	\N	\N	\N	63940	63940	232108
1393	1259	0	applied	\N	\N	\N	\N	63942	63942	232110
1394	1260	0	applied	\N	\N	\N	\N	63943	63943	232111
1396	1260	0	applied	\N	\N	\N	\N	63945	63945	232113
1397	1261	0	applied	\N	\N	\N	\N	63946	63946	232114
1397	1262	1	applied	\N	\N	\N	\N	63947	63947	232115
1398	1261	0	applied	\N	\N	\N	\N	63948	63948	232116
1398	1262	1	applied	\N	\N	\N	\N	63949	63949	232117
1403	1269	0	applied	\N	\N	\N	\N	63958	63958	232126
1405	1270	0	applied	\N	\N	\N	\N	63960	63960	232128
1405	1271	1	applied	\N	\N	1000000000	\N	63961	63961	232129
1406	1270	0	applied	\N	\N	\N	\N	63962	63962	232130
1406	1271	1	applied	\N	\N	1000000000	\N	63963	63963	232131
1407	1270	0	applied	\N	\N	\N	\N	63964	63964	232132
1407	1271	1	applied	\N	\N	1000000000	\N	63965	63965	232133
1408	1270	0	applied	\N	\N	\N	\N	63966	63966	232134
1408	1271	1	applied	\N	\N	1000000000	\N	63967	63967	232135
1410	1272	0	applied	\N	\N	\N	\N	63969	63969	232137
1411	1272	0	applied	\N	\N	\N	\N	63970	63970	232138
1413	1274	1	applied	\N	\N	\N	\N	63975	63975	232141
1413	1275	2	applied	\N	\N	\N	\N	63976	63976	232142
1415	1276	0	applied	\N	\N	\N	\N	63978	63978	232144
1417	1276	0	applied	\N	\N	\N	\N	63980	63980	232146
1418	1277	0	applied	\N	\N	\N	\N	63981	63981	232147
1420	1277	0	applied	\N	\N	\N	\N	63984	63984	232150
1421	1279	0	applied	\N	\N	\N	\N	63985	63985	232151
1424	1280	0	applied	\N	\N	\N	\N	63988	63988	232154
1424	1281	1	applied	\N	\N	\N	\N	63989	63989	232155
1425	1280	0	applied	\N	\N	\N	\N	63990	63990	232156
1425	1281	1	applied	\N	\N	\N	\N	63991	63991	232157
1425	1282	2	applied	\N	\N	\N	\N	63992	63992	232158
1427	1283	0	applied	\N	\N	\N	\N	63996	63996	232162
1430	1285	0	applied	\N	\N	\N	\N	63999	63999	232165
1430	1286	1	applied	\N	\N	\N	\N	64000	64000	232166
1430	1287	2	applied	\N	\N	\N	\N	64001	64001	232167
1432	1289	0	applied	\N	\N	\N	\N	64003	64003	232169
1432	1290	1	applied	\N	\N	\N	\N	64004	64004	232170
1432	1291	2	applied	\N	\N	\N	\N	64005	64005	232171
1435	1292	0	applied	\N	\N	\N	\N	64010	64010	232176
1436	1293	0	applied	\N	\N	\N	\N	64011	64011	232177
1436	1294	1	applied	\N	\N	\N	\N	64012	64012	232178
1438	1295	0	applied	\N	\N	\N	\N	64015	64015	232181
1438	1296	1	applied	\N	\N	\N	\N	64016	64016	232182
1439	1297	0	applied	\N	\N	\N	\N	64017	64017	232183
1440	1297	0	applied	\N	\N	\N	\N	64018	64018	232184
1441	1298	0	applied	\N	\N	\N	\N	64019	64019	232185
1441	1299	1	applied	\N	\N	\N	\N	64020	64020	232186
1443	1298	0	applied	\N	\N	\N	\N	64023	64023	232189
1444	1271	0	applied	\N	\N	1000000000	\N	64025	64025	232191
1444	1245	2	applied	\N	\N	\N	\N	64027	64027	232192
1444	1273	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	64026	64026	\N
1444	1246	3	applied	\N	\N	\N	\N	64028	64028	232193
1444	1247	4	applied	\N	\N	\N	\N	64029	64029	232194
1444	1248	5	applied	\N	\N	\N	\N	64030	64030	232195
1445	1298	0	applied	\N	\N	\N	\N	64080	64080	232245
1445	1299	1	applied	\N	\N	\N	\N	64081	64081	232246
1451	1306	0	applied	\N	\N	\N	\N	64089	64089	232254
1454	1311	0	applied	\N	\N	\N	\N	64094	64094	232259
1454	1312	1	applied	\N	\N	1000000000	\N	64095	64095	232260
1457	1311	0	applied	\N	\N	\N	\N	64100	64100	232265
1457	1312	1	applied	\N	\N	1000000000	\N	64101	64101	232266
1460	1314	0	applied	\N	\N	\N	\N	64107	64107	232272
1460	1315	1	applied	\N	\N	\N	\N	64108	64108	232273
1460	1316	2	applied	\N	\N	\N	\N	64109	64109	232274
1466	1321	0	applied	\N	\N	\N	\N	64115	64115	232280
1466	1322	1	applied	\N	\N	\N	\N	64116	64116	232281
1469	1308	0	applied	\N	\N	\N	\N	64119	64119	232284
1469	1300	1	applied	\N	\N	\N	\N	64120	64120	232285
1469	1301	2	applied	\N	\N	\N	\N	64121	64121	232286
1469	1302	3	applied	\N	\N	\N	\N	64122	64122	232287
1469	1303	4	applied	\N	\N	\N	\N	64123	64123	232288
1469	1304	5	applied	\N	\N	\N	\N	64124	64124	232289
1469	1306	6	applied	\N	\N	\N	\N	64125	64125	232290
1469	1307	7	applied	\N	\N	\N	\N	64126	64126	232291
1469	1309	8	applied	\N	\N	\N	\N	64127	64127	232292
1469	1310	9	applied	\N	\N	\N	\N	64128	64128	232293
1469	1311	10	applied	\N	\N	\N	\N	64129	64129	232294
1469	1313	12	applied	\N	\N	\N	\N	64130	64130	232295
1469	1314	13	applied	\N	\N	\N	\N	64131	64131	232296
1469	1315	14	applied	\N	\N	\N	\N	64132	64132	232297
1469	1317	16	applied	\N	\N	\N	\N	64134	64134	232299
1469	1318	17	applied	\N	\N	\N	\N	64135	64135	232300
1469	1319	18	applied	\N	\N	\N	\N	64136	64136	232301
1469	1320	19	applied	\N	\N	\N	\N	64137	64137	232302
1469	1321	20	applied	\N	\N	\N	\N	64138	64138	232303
1469	1322	21	applied	\N	\N	\N	\N	64139	64139	232304
1469	1323	22	applied	\N	\N	\N	\N	64140	64140	232305
1469	1324	23	applied	\N	\N	\N	\N	64141	64141	232306
1469	1305	24	applied	\N	\N	\N	\N	64142	64142	232307
1473	1327	0	applied	\N	\N	\N	\N	64146	64146	232311
1473	1328	1	applied	\N	\N	\N	\N	64147	64147	232312
1474	1329	0	applied	\N	\N	\N	\N	64148	64148	232313
1474	1330	1	applied	\N	\N	\N	\N	64149	64149	232314
1474	1331	2	applied	\N	\N	\N	\N	64150	64150	232315
1474	1332	3	applied	\N	\N	\N	\N	64151	64151	232316
1474	1333	4	applied	\N	\N	\N	\N	64152	64152	232317
1381	1244	1	applied	\N	\N	\N	\N	63909	63909	232077
1384	1251	0	applied	\N	\N	\N	\N	63918	63918	232086
1386	1253	0	applied	\N	\N	\N	\N	63920	63920	232088
1386	1255	2	applied	\N	\N	\N	\N	63922	63922	232090
1386	1256	3	applied	\N	\N	\N	\N	63923	63923	232091
1386	1257	4	applied	\N	\N	\N	\N	63924	63924	232092
1386	1258	5	applied	\N	\N	\N	\N	63925	63925	232093
1389	1259	0	applied	\N	\N	\N	\N	63938	63938	232106
1392	1259	0	applied	\N	\N	\N	\N	63941	63941	232109
1395	1260	0	applied	\N	\N	\N	\N	63944	63944	232112
1399	1263	0	applied	\N	\N	\N	\N	63950	63950	232118
1399	1264	1	applied	\N	\N	\N	\N	63951	63951	232119
1399	1265	2	applied	\N	\N	\N	\N	63952	63952	232120
1399	1266	3	applied	\N	\N	\N	\N	63953	63953	232121
1399	1267	4	applied	\N	\N	\N	\N	63954	63954	232122
1400	1268	0	applied	\N	\N	\N	\N	63955	63955	232123
1402	1269	0	applied	\N	\N	\N	\N	63957	63957	232125
1404	1269	0	applied	\N	\N	\N	\N	63959	63959	232127
1409	1272	0	applied	\N	\N	\N	\N	63968	63968	232136
1412	1274	1	applied	\N	\N	\N	\N	63972	63972	232139
1412	1275	2	applied	\N	\N	\N	\N	63973	63973	232140
1414	1276	0	applied	\N	\N	\N	\N	63977	63977	232143
1416	1276	0	applied	\N	\N	\N	\N	63979	63979	232145
1419	1277	0	applied	\N	\N	\N	\N	63982	63982	232148
1419	1278	1	applied	\N	\N	1000000000	\N	63983	63983	232149
1423	1280	0	applied	\N	\N	\N	\N	63986	63986	232152
1423	1281	1	applied	\N	\N	\N	\N	63987	63987	232153
1426	1280	0	applied	\N	\N	\N	\N	63993	63993	232159
1426	1281	1	applied	\N	\N	\N	\N	63994	63994	232160
1426	1282	2	applied	\N	\N	\N	\N	63995	63995	232161
1428	1283	0	applied	\N	\N	\N	\N	63997	63997	232163
1429	1284	0	applied	\N	\N	\N	\N	63998	63998	232164
1431	1288	0	applied	\N	\N	\N	\N	64002	64002	232168
1433	1289	0	applied	\N	\N	\N	\N	64006	64006	232172
1433	1290	1	applied	\N	\N	\N	\N	64007	64007	232173
1433	1291	2	applied	\N	\N	\N	\N	64008	64008	232174
1434	1292	0	applied	\N	\N	\N	\N	64009	64009	232175
1437	1295	0	applied	\N	\N	\N	\N	64013	64013	232179
1437	1296	1	applied	\N	\N	\N	\N	64014	64014	232180
1442	1298	0	applied	\N	\N	\N	\N	64021	64021	232187
1442	1299	1	applied	\N	\N	\N	\N	64022	64022	232188
1444	1249	6	applied	\N	\N	\N	\N	64031	64031	232196
1444	1250	7	applied	\N	\N	\N	\N	64032	64032	232197
1444	1252	9	applied	\N	\N	\N	\N	64034	64034	232199
1444	1253	10	applied	\N	\N	\N	\N	64035	64035	232200
1444	1254	11	applied	\N	\N	\N	\N	64036	64036	232201
1444	1255	12	applied	\N	\N	\N	\N	64037	64037	232202
1444	1256	13	applied	\N	\N	\N	\N	64038	64038	232203
1444	1257	14	applied	\N	\N	\N	\N	64039	64039	232204
1444	1258	15	applied	\N	\N	\N	\N	64040	64040	232205
1444	1259	16	applied	\N	\N	\N	\N	64041	64041	232206
1444	1260	17	applied	\N	\N	\N	\N	64042	64042	232207
1444	1261	18	applied	\N	\N	\N	\N	64043	64043	232208
1444	1262	19	applied	\N	\N	\N	\N	64044	64044	232209
1444	1263	20	applied	\N	\N	\N	\N	64045	64045	232210
1444	1264	21	applied	\N	\N	\N	\N	64046	64046	232211
1444	1265	22	applied	\N	\N	\N	\N	64047	64047	232212
1444	1266	23	applied	\N	\N	\N	\N	64048	64048	232213
1444	1267	24	applied	\N	\N	\N	\N	64049	64049	232214
1444	1269	26	applied	\N	\N	\N	\N	64051	64051	232216
1444	1270	27	applied	\N	\N	\N	\N	64052	64052	232217
1444	1272	28	applied	\N	\N	\N	\N	64053	64053	232218
1444	1274	29	applied	\N	\N	\N	\N	64054	64054	232219
1444	1275	30	applied	\N	\N	\N	\N	64055	64055	232220
1444	1276	31	applied	\N	\N	\N	\N	64056	64056	232221
1444	1277	32	applied	\N	\N	\N	\N	64057	64057	232222
1444	1279	33	applied	\N	\N	\N	\N	64058	64058	232223
1444	1280	34	applied	\N	\N	\N	\N	64059	64059	232224
1444	1281	35	applied	\N	\N	\N	\N	64060	64060	232225
1444	1282	36	applied	\N	\N	\N	\N	64061	64061	232226
1444	1283	37	applied	\N	\N	\N	\N	64062	64062	232227
1444	1284	38	applied	\N	\N	\N	\N	64063	64063	232228
1444	1285	39	applied	\N	\N	\N	\N	64064	64064	232229
1444	1286	40	applied	\N	\N	\N	\N	64065	64065	232230
1444	1287	41	applied	\N	\N	\N	\N	64066	64066	232231
1444	1289	43	applied	\N	\N	\N	\N	64068	64068	232233
1444	1290	44	applied	\N	\N	\N	\N	64069	64069	232234
1444	1291	45	applied	\N	\N	\N	\N	64070	64070	232235
1444	1292	46	applied	\N	\N	\N	\N	64071	64071	232236
1444	1293	47	applied	\N	\N	\N	\N	64072	64072	232237
1444	1294	48	applied	\N	\N	\N	\N	64073	64073	232238
1444	1295	49	applied	\N	\N	\N	\N	64074	64074	232239
1444	1296	50	applied	\N	\N	\N	\N	64075	64075	232240
1444	1297	51	applied	\N	\N	\N	\N	64076	64076	232241
1444	1298	52	applied	\N	\N	\N	\N	64077	64077	232242
1444	1299	53	applied	\N	\N	\N	\N	64078	64078	232243
1444	1278	54	applied	\N	\N	1000000000	\N	64079	64079	232244
1446	1300	0	applied	\N	\N	\N	\N	64082	64082	232247
1447	1301	0	applied	\N	\N	\N	\N	64083	64083	232248
1448	1301	0	applied	\N	\N	\N	\N	64084	64084	232249
1449	1302	0	applied	\N	\N	\N	\N	64085	64085	232250
1450	1304	1	applied	\N	\N	\N	\N	64087	64087	232252
1450	1305	2	applied	\N	\N	\N	\N	64088	64088	232253
1452	1307	0	applied	\N	\N	\N	\N	64090	64090	232255
1453	1308	0	applied	\N	\N	\N	\N	64091	64091	232256
1456	1311	0	applied	\N	\N	\N	\N	64098	64098	232263
1456	1312	1	applied	\N	\N	1000000000	\N	64099	64099	232264
1458	1313	0	applied	\N	\N	\N	\N	64102	64102	232267
1461	1318	0	applied	\N	\N	\N	\N	64111	64111	232276
1464	1319	0	applied	\N	\N	\N	\N	64113	64113	232278
1467	1323	0	applied	\N	\N	\N	\N	64117	64117	232282
1470	1325	0	applied	\N	\N	\N	\N	64143	64143	232308
1472	1326	0	applied	\N	\N	\N	\N	64145	64145	232310
1476	1329	0	applied	\N	\N	\N	\N	64158	64158	232323
1476	1330	1	applied	\N	\N	\N	\N	64159	64159	232324
1476	1331	2	applied	\N	\N	\N	\N	64160	64160	232325
1476	1332	3	applied	\N	\N	\N	\N	64161	64161	232326
1478	1334	0	applied	\N	\N	\N	\N	64164	64164	232329
1480	1335	0	applied	\N	\N	\N	\N	64168	64168	232333
1480	1336	1	applied	\N	\N	\N	\N	64169	64169	232334
1480	1337	2	applied	\N	\N	1000000000	\N	64170	64170	232335
1382	1244	1	applied	\N	\N	\N	\N	63911	63911	232079
1385	1252	0	applied	\N	\N	\N	\N	63919	63919	232087
1455	1312	1	applied	\N	\N	1000000000	\N	64097	64097	232262
1459	1314	0	applied	\N	\N	\N	\N	64103	64103	232268
1459	1315	1	applied	\N	\N	\N	\N	64104	64104	232269
1459	1316	2	applied	\N	\N	\N	\N	64105	64105	232270
1459	1317	3	applied	\N	\N	\N	\N	64106	64106	232271
1462	1318	0	applied	\N	\N	\N	\N	64112	64112	232277
1465	1320	0	applied	\N	\N	\N	\N	64114	64114	232279
1468	1324	0	applied	\N	\N	\N	\N	64118	64118	232283
1471	1326	0	applied	\N	\N	\N	\N	64144	64144	232309
1475	1330	1	applied	\N	\N	\N	\N	64154	64154	232319
1475	1331	2	applied	\N	\N	\N	\N	64155	64155	232320
1475	1332	3	applied	\N	\N	\N	\N	64156	64156	232321
1475	1333	4	applied	\N	\N	\N	\N	64157	64157	232322
1479	1335	0	applied	\N	\N	\N	\N	64165	64165	232330
1479	1336	1	applied	\N	\N	\N	\N	64166	64166	232331
1479	1337	2	applied	\N	\N	1000000000	\N	64167	64167	232332
1481	1338	0	applied	\N	\N	\N	\N	64171	64171	232336
1481	1339	1	applied	\N	\N	\N	\N	64172	64172	232337
1482	1338	0	applied	\N	\N	\N	\N	64173	64173	232338
1482	1339	1	applied	\N	\N	\N	\N	64174	64174	232339
1483	1340	0	applied	\N	\N	\N	\N	64175	64175	232340
1484	1341	0	applied	\N	\N	\N	\N	64176	64176	232341
1485	1342	0	applied	\N	\N	\N	\N	64177	64177	232342
1485	1343	1	applied	\N	\N	\N	\N	64178	64178	232343
1486	1342	0	applied	\N	\N	\N	\N	64179	64179	232344
1487	1344	0	applied	\N	\N	\N	\N	64181	64181	232346
1487	1345	1	applied	\N	\N	\N	\N	64182	64182	232347
1488	1344	0	applied	\N	\N	\N	\N	64183	64183	232348
1488	1345	1	applied	\N	\N	\N	\N	64184	64184	232349
1489	1346	0	applied	\N	\N	\N	\N	64185	64185	232350
1489	1347	1	applied	\N	\N	\N	\N	64186	64186	232351
1490	1346	0	applied	\N	\N	\N	\N	64187	64187	232352
1490	1347	1	applied	\N	\N	\N	\N	64188	64188	232353
1491	1348	0	applied	\N	\N	\N	\N	64189	64189	232354
1492	1349	0	applied	\N	\N	\N	\N	64190	64190	232355
1493	1350	0	applied	\N	\N	\N	\N	64191	64191	232356
1494	1351	0	applied	\N	\N	\N	\N	64192	64192	232357
1495	1325	0	applied	\N	\N	\N	\N	64193	64193	232358
1495	1326	1	applied	\N	\N	\N	\N	64194	64194	232359
1495	1327	2	applied	\N	\N	\N	\N	64195	64195	232360
1495	1328	3	applied	\N	\N	\N	\N	64196	64196	232361
1495	1330	5	applied	\N	\N	\N	\N	64198	64198	232363
1495	1331	6	applied	\N	\N	\N	\N	64199	64199	232364
1495	1332	7	applied	\N	\N	\N	\N	64200	64200	232365
1495	1333	8	applied	\N	\N	\N	\N	64201	64201	232366
1495	1334	9	applied	\N	\N	\N	\N	64202	64202	232367
1495	1335	10	applied	\N	\N	\N	\N	64203	64203	232368
1495	1336	11	applied	\N	\N	\N	\N	64204	64204	232369
1495	1338	12	applied	\N	\N	\N	\N	64205	64205	232370
1495	1339	13	applied	\N	\N	\N	\N	64206	64206	232371
1495	1340	14	applied	\N	\N	\N	\N	64207	64207	232372
1495	1341	15	applied	\N	\N	\N	\N	64208	64208	232373
1495	1342	16	applied	\N	\N	\N	\N	64209	64209	232374
1495	1344	17	applied	\N	\N	\N	\N	64210	64210	232375
1495	1345	18	applied	\N	\N	\N	\N	64211	64211	232376
1495	1346	19	applied	\N	\N	\N	\N	64212	64212	232377
1495	1348	20	applied	\N	\N	\N	\N	64213	64213	232378
1495	1350	22	applied	\N	\N	\N	\N	64215	64215	232380
1495	1351	23	applied	\N	\N	\N	\N	64216	64216	232381
1495	1352	24	applied	\N	\N	\N	\N	64217	64217	232382
1496	1352	0	applied	\N	\N	\N	\N	64218	64218	232383
1496	1353	1	applied	\N	\N	\N	\N	64219	64219	232384
1496	1354	2	applied	\N	\N	\N	\N	64220	64220	232385
1496	1355	3	applied	\N	\N	1000000000	\N	64221	64221	232386
1498	1352	0	applied	\N	\N	\N	\N	64226	64226	232391
1498	1353	1	applied	\N	\N	\N	\N	64227	64227	232392
1498	1354	2	applied	\N	\N	\N	\N	64228	64228	232393
1498	1355	3	applied	\N	\N	1000000000	\N	64229	64229	232394
1499	1356	0	applied	\N	\N	\N	\N	64230	64230	232395
1504	1362	0	applied	\N	\N	\N	\N	64236	64236	232401
1510	1365	0	applied	\N	\N	\N	\N	64242	64242	232407
1510	1366	1	applied	\N	\N	\N	\N	64243	64243	232408
1513	1367	0	applied	\N	\N	\N	\N	64248	64248	232413
1518	1375	0	applied	\N	\N	\N	\N	64259	64259	232424
1520	1376	0	applied	\N	\N	\N	\N	64262	64262	232427
1520	1377	1	applied	\N	\N	\N	\N	64263	64263	232428
1521	1378	0	applied	\N	\N	\N	\N	64264	64264	232429
1521	1379	1	applied	\N	\N	\N	\N	64265	64265	232430
1523	1378	0	applied	\N	\N	\N	\N	64268	64268	232433
1523	1379	1	applied	\N	\N	\N	\N	64269	64269	232434
1524	1380	0	applied	\N	\N	\N	\N	64270	64270	232435
1525	1381	0	applied	\N	\N	\N	\N	64271	64271	232436
1525	1382	1	applied	\N	\N	\N	\N	64272	64272	232437
1525	1383	2	applied	\N	\N	\N	\N	64273	64273	232438
1525	1384	3	applied	\N	\N	\N	\N	64274	64274	232439
1528	1386	0	applied	\N	\N	\N	\N	64280	64280	232445
1531	1387	0	applied	\N	\N	\N	\N	64283	64283	232448
1533	1388	0	applied	\N	\N	\N	\N	64285	64285	232450
1534	1388	0	applied	\N	\N	\N	\N	64286	64286	232451
1541	1390	0	applied	\N	\N	\N	\N	64292	64292	232457
1546	1392	0	applied	\N	\N	\N	\N	64295	64295	232460
1548	1393	0	applied	\N	\N	\N	\N	64336	64336	232501
1553	1394	0	applied	\N	\N	\N	\N	64338	64338	232503
1553	1395	1	applied	\N	\N	\N	\N	64339	64339	232504
1553	1396	2	applied	\N	\N	\N	\N	64340	64340	232505
1556	1394	0	applied	\N	\N	\N	\N	64347	64347	232512
1556	1395	1	applied	\N	\N	\N	\N	64348	64348	232513
1556	1396	2	applied	\N	\N	\N	\N	64349	64349	232514
1559	1399	0	applied	\N	\N	\N	\N	64352	64352	232517
1559	1400	1	applied	\N	\N	\N	\N	64353	64353	232518
1564	1402	0	applied	\N	\N	\N	\N	64359	64359	232524
1565	1403	0	applied	\N	\N	\N	\N	64360	64360	232525
1568	1406	0	applied	\N	\N	\N	\N	64364	64364	232529
1571	1408	0	applied	\N	\N	\N	\N	64367	64367	232532
1574	1409	0	applied	\N	\N	\N	\N	64370	64370	232535
1577	1411	0	applied	\N	\N	\N	\N	64373	64373	232538
1580	1412	0	applied	\N	\N	\N	\N	64376	64376	232541
1580	1413	1	applied	\N	\N	\N	\N	64377	64377	232542
1580	1414	2	applied	\N	\N	\N	\N	64378	64378	232543
1453	1310	2	applied	\N	\N	\N	\N	64093	64093	232258
1455	1311	0	applied	\N	\N	\N	\N	64096	64096	232261
1501	1359	0	applied	\N	\N	\N	\N	64233	64233	232398
1502	1360	0	applied	\N	\N	\N	\N	64234	64234	232399
1505	1363	0	applied	\N	\N	\N	\N	64237	64237	232402
1507	1364	0	applied	\N	\N	\N	\N	64239	64239	232404
1509	1364	0	applied	\N	\N	\N	\N	64241	64241	232406
1517	1375	0	applied	\N	\N	\N	\N	64258	64258	232423
1522	1378	0	applied	\N	\N	\N	\N	64266	64266	232431
1522	1379	1	applied	\N	\N	\N	\N	64267	64267	232432
1527	1385	0	applied	\N	\N	\N	\N	64279	64279	232444
1529	1386	0	applied	\N	\N	\N	\N	64281	64281	232446
1530	1386	0	applied	\N	\N	\N	\N	64282	64282	232447
1536	1389	0	applied	\N	\N	\N	\N	64288	64288	232453
1542	1391	0	applied	\N	\N	\N	\N	64293	64293	232458
1545	1392	0	applied	\N	\N	\N	\N	64294	64294	232459
1549	1393	0	applied	\N	\N	\N	\N	64337	64337	232502
1555	1394	0	applied	\N	\N	\N	\N	64344	64344	232509
1555	1395	1	applied	\N	\N	\N	\N	64345	64345	232510
1555	1396	2	applied	\N	\N	\N	\N	64346	64346	232511
1557	1397	0	applied	\N	\N	\N	\N	64350	64350	232515
1560	1399	0	applied	\N	\N	\N	\N	64354	64354	232519
1560	1400	1	applied	\N	\N	\N	\N	64355	64355	232520
1561	1401	0	applied	\N	\N	\N	\N	64356	64356	232521
1566	1403	0	applied	\N	\N	\N	\N	64361	64361	232526
1567	1404	0	applied	\N	\N	\N	\N	64362	64362	232527
1567	1405	1	applied	\N	\N	\N	\N	64363	64363	232528
1570	1407	0	applied	\N	\N	\N	\N	64366	64366	232531
1573	1409	0	applied	\N	\N	\N	\N	64369	64369	232534
1578	1411	0	applied	\N	\N	\N	\N	64374	64374	232539
1581	1412	0	applied	\N	\N	\N	\N	64379	64379	232544
1581	1413	1	applied	\N	\N	\N	\N	64380	64380	232545
1581	1414	2	applied	\N	\N	\N	\N	64381	64381	232546
1582	1415	0	applied	\N	\N	\N	\N	64382	64382	232547
1584	1415	0	applied	\N	\N	\N	\N	64384	64384	232549
1586	1416	0	applied	\N	\N	\N	\N	64386	64386	232551
1587	1416	0	applied	\N	\N	\N	\N	64387	64387	232552
1588	1417	0	applied	\N	\N	\N	\N	64388	64388	232553
1591	1419	0	applied	\N	\N	\N	\N	64391	64391	232556
1591	1420	1	applied	\N	\N	\N	\N	64392	64392	232557
1592	1421	0	applied	\N	\N	\N	\N	64393	64393	232558
1593	1421	0	applied	\N	\N	\N	\N	64394	64394	232559
1594	1308	0	applied	\N	\N	\N	\N	64395	64395	232560
1594	1298	1	applied	\N	\N	\N	\N	64396	64396	232561
1594	1358	3	applied	\N	\N	\N	\N	64398	64398	232563
1594	1371	4	applied	\N	\N	\N	\N	64399	64399	232564
1594	1299	5	applied	\N	\N	\N	\N	64400	64400	232565
1594	1300	6	applied	\N	\N	\N	\N	64401	64401	232566
1594	1301	7	applied	\N	\N	\N	\N	64402	64402	232567
1594	1302	8	applied	\N	\N	\N	\N	64403	64403	232568
1594	1303	9	applied	\N	\N	\N	\N	64404	64404	232569
1594	1304	10	applied	\N	\N	\N	\N	64405	64405	232570
1594	1306	11	applied	\N	\N	\N	\N	64406	64406	232571
1594	1307	12	applied	\N	\N	\N	\N	64407	64407	232572
1594	1309	13	applied	\N	\N	\N	\N	64408	64408	232573
1594	1310	14	applied	\N	\N	\N	\N	64409	64409	232574
1594	1311	15	applied	\N	\N	\N	\N	64410	64410	232575
1594	1313	16	applied	\N	\N	\N	\N	64411	64411	232576
1594	1314	17	applied	\N	\N	\N	\N	64412	64412	232577
1594	1315	18	applied	\N	\N	\N	\N	64413	64413	232578
1594	1316	19	applied	\N	\N	\N	\N	64414	64414	232579
1594	1317	20	applied	\N	\N	\N	\N	64415	64415	232580
1594	1318	21	applied	\N	\N	\N	\N	64416	64416	232581
1594	1319	22	applied	\N	\N	\N	\N	64417	64417	232582
1594	1321	24	applied	\N	\N	\N	\N	64419	64419	232584
1594	1322	25	applied	\N	\N	\N	\N	64420	64420	232585
1594	1323	26	applied	\N	\N	\N	\N	64421	64421	232586
1594	1324	27	applied	\N	\N	\N	\N	64422	64422	232587
1594	1325	28	applied	\N	\N	\N	\N	64423	64423	232588
1594	1326	29	applied	\N	\N	\N	\N	64424	64424	232589
1594	1327	30	applied	\N	\N	\N	\N	64425	64425	232590
1594	1328	31	applied	\N	\N	\N	\N	64426	64426	232591
1594	1329	32	applied	\N	\N	\N	\N	64427	64427	232592
1594	1330	33	applied	\N	\N	\N	\N	64428	64428	232593
1594	1331	34	applied	\N	\N	\N	\N	64429	64429	232594
1594	1332	35	applied	\N	\N	\N	\N	64430	64430	232595
1594	1333	36	applied	\N	\N	\N	\N	64431	64431	232596
1594	1334	37	applied	\N	\N	\N	\N	64432	64432	232597
1594	1335	38	applied	\N	\N	\N	\N	64433	64433	232598
1594	1336	39	applied	\N	\N	\N	\N	64434	64434	232599
1594	1339	41	applied	\N	\N	\N	\N	64436	64436	232601
1594	1340	42	applied	\N	\N	\N	\N	64437	64437	232602
1594	1341	43	applied	\N	\N	\N	\N	64438	64438	232603
1594	1342	44	applied	\N	\N	\N	\N	64439	64439	232604
1594	1344	45	applied	\N	\N	\N	\N	64440	64440	232605
1594	1345	46	applied	\N	\N	\N	\N	64441	64441	232606
1594	1346	47	applied	\N	\N	\N	\N	64442	64442	232607
1594	1348	48	applied	\N	\N	\N	\N	64443	64443	232608
1594	1349	49	applied	\N	\N	\N	\N	64444	64444	232609
1594	1350	50	applied	\N	\N	\N	\N	64445	64445	232610
1594	1351	51	applied	\N	\N	\N	\N	64446	64446	232611
1594	1352	52	applied	\N	\N	\N	\N	64447	64447	232612
1594	1353	53	applied	\N	\N	\N	\N	64448	64448	232613
1594	1354	54	applied	\N	\N	\N	\N	64449	64449	232614
1594	1356	55	applied	\N	\N	\N	\N	64450	64450	232615
1594	1357	56	applied	\N	\N	\N	\N	64451	64451	232616
1594	1360	58	applied	\N	\N	\N	\N	64453	64453	232618
1594	1361	59	applied	\N	\N	\N	\N	64454	64454	232619
1594	1362	60	applied	\N	\N	\N	\N	64455	64455	232620
1594	1363	61	applied	\N	\N	\N	\N	64456	64456	232621
1594	1364	62	applied	\N	\N	\N	\N	64457	64457	232622
1594	1365	63	applied	\N	\N	\N	\N	64458	64458	232623
1594	1366	64	applied	\N	\N	\N	\N	64459	64459	232624
1594	1367	65	applied	\N	\N	\N	\N	64460	64460	232625
1594	1368	66	applied	\N	\N	\N	\N	64461	64461	232626
1594	1369	67	applied	\N	\N	\N	\N	64462	64462	232627
1595	1421	0	applied	\N	\N	\N	\N	64483	64483	232648
1597	1421	0	applied	\N	\N	\N	\N	64485	64485	232650
1598	1421	0	applied	\N	\N	\N	\N	64486	64486	232651
1600	1392	0	applied	\N	\N	\N	\N	64488	64488	232653
1600	1393	1	applied	\N	\N	\N	\N	64489	64489	232654
1497	1353	1	applied	\N	\N	\N	\N	64223	64223	232388
1497	1355	3	applied	\N	\N	1000000000	\N	64225	64225	232390
1508	1364	0	applied	\N	\N	\N	\N	64240	64240	232405
1511	1365	0	applied	\N	\N	\N	\N	64244	64244	232409
1511	1366	1	applied	\N	\N	\N	\N	64245	64245	232410
1512	1365	0	applied	\N	\N	\N	\N	64246	64246	232411
1512	1366	1	applied	\N	\N	\N	\N	64247	64247	232412
1514	1367	0	applied	\N	\N	\N	\N	64250	64250	232415
1514	1368	1	applied	\N	\N	\N	\N	64251	64251	232416
1515	1369	0	applied	\N	\N	\N	\N	64252	64252	232417
1516	1370	0	applied	\N	\N	\N	\N	64253	64253	232418
1516	1371	1	applied	\N	\N	\N	\N	64254	64254	232419
1516	1372	2	applied	\N	\N	\N	\N	64255	64255	232420
1516	1373	3	applied	\N	\N	\N	\N	64256	64256	232421
1516	1374	4	applied	\N	\N	\N	\N	64257	64257	232422
1519	1376	0	applied	\N	\N	\N	\N	64260	64260	232425
1526	1381	0	applied	\N	\N	\N	\N	64275	64275	232440
1526	1382	1	applied	\N	\N	\N	\N	64276	64276	232441
1526	1383	2	applied	\N	\N	\N	\N	64277	64277	232442
1526	1384	3	applied	\N	\N	\N	\N	64278	64278	232443
1532	1388	0	applied	\N	\N	\N	\N	64284	64284	232449
1535	1389	0	applied	\N	\N	\N	\N	64287	64287	232452
1538	1390	0	applied	\N	\N	\N	\N	64290	64290	232455
1547	1353	0	applied	\N	\N	\N	\N	64296	64296	232461
1547	1354	1	applied	\N	\N	\N	\N	64297	64297	232462
1547	1355	2	applied	\N	\N	1000000000	\N	64298	64298	232463
1547	1356	3	applied	\N	\N	\N	\N	64299	64299	232464
1547	1357	4	applied	\N	\N	\N	\N	64300	64300	232465
1547	1359	5	applied	\N	\N	\N	\N	64301	64301	232466
1547	1360	6	applied	\N	\N	\N	\N	64302	64302	232467
1547	1361	7	applied	\N	\N	\N	\N	64303	64303	232468
1547	1358	8	applied	\N	\N	\N	\N	64304	64304	232469
1547	1362	10	applied	\N	\N	\N	\N	64306	64306	232471
1547	1363	11	applied	\N	\N	\N	\N	64307	64307	232472
1547	1364	12	applied	\N	\N	\N	\N	64308	64308	232473
1547	1365	13	applied	\N	\N	\N	\N	64309	64309	232474
1547	1366	14	applied	\N	\N	\N	\N	64310	64310	232475
1547	1367	15	applied	\N	\N	\N	\N	64311	64311	232476
1547	1368	16	applied	\N	\N	\N	\N	64312	64312	232477
1547	1369	17	applied	\N	\N	\N	\N	64313	64313	232478
1547	1370	18	applied	\N	\N	\N	\N	64314	64314	232479
1547	1372	19	applied	\N	\N	\N	\N	64315	64315	232480
1547	1373	20	applied	\N	\N	\N	\N	64316	64316	232481
1547	1374	21	applied	\N	\N	\N	\N	64317	64317	232482
1547	1375	22	applied	\N	\N	\N	\N	64318	64318	232483
1547	1376	23	applied	\N	\N	\N	\N	64319	64319	232484
1547	1377	24	applied	\N	\N	\N	\N	64320	64320	232485
1547	1378	25	applied	\N	\N	\N	\N	64321	64321	232486
1547	1380	27	applied	\N	\N	\N	\N	64323	64323	232488
1547	1381	28	applied	\N	\N	\N	\N	64324	64324	232489
1547	1382	29	applied	\N	\N	\N	\N	64325	64325	232490
1547	1383	30	applied	\N	\N	\N	\N	64326	64326	232491
1547	1384	31	applied	\N	\N	\N	\N	64327	64327	232492
1547	1385	32	applied	\N	\N	\N	\N	64328	64328	232493
1547	1386	33	applied	\N	\N	\N	\N	64329	64329	232494
1547	1387	34	applied	\N	\N	\N	\N	64330	64330	232495
1547	1388	35	applied	\N	\N	\N	\N	64331	64331	232496
1547	1389	36	applied	\N	\N	\N	\N	64332	64332	232497
1547	1390	37	applied	\N	\N	\N	\N	64333	64333	232498
1547	1391	38	applied	\N	\N	\N	\N	64334	64334	232499
1547	1392	39	applied	\N	\N	\N	\N	64335	64335	232500
1554	1394	0	applied	\N	\N	\N	\N	64341	64341	232506
1554	1395	1	applied	\N	\N	\N	\N	64342	64342	232507
1554	1396	2	applied	\N	\N	\N	\N	64343	64343	232508
1562	1401	0	applied	\N	\N	\N	\N	64357	64357	232522
1563	1402	0	applied	\N	\N	\N	\N	64358	64358	232523
1569	1407	0	applied	\N	\N	\N	\N	64365	64365	232530
1572	1408	0	applied	\N	\N	\N	\N	64368	64368	232533
1575	1410	0	applied	\N	\N	\N	\N	64371	64371	232536
1583	1415	0	applied	\N	\N	\N	\N	64383	64383	232548
1585	1415	0	applied	\N	\N	\N	\N	64385	64385	232550
1589	1417	0	applied	\N	\N	\N	\N	64389	64389	232554
1590	1418	0	applied	\N	\N	\N	\N	64390	64390	232555
1594	1370	68	applied	\N	\N	\N	\N	64463	64463	232628
1594	1372	69	applied	\N	\N	\N	\N	64464	64464	232629
1594	1373	70	applied	\N	\N	\N	\N	64465	64465	232630
1594	1374	71	applied	\N	\N	\N	\N	64466	64466	232631
1594	1375	72	applied	\N	\N	\N	\N	64467	64467	232632
1594	1376	73	applied	\N	\N	\N	\N	64468	64468	232633
1594	1377	74	applied	\N	\N	\N	\N	64469	64469	232634
1594	1379	76	applied	\N	\N	\N	\N	64471	64471	232636
1594	1380	77	applied	\N	\N	\N	\N	64472	64472	232637
1594	1381	78	applied	\N	\N	\N	\N	64473	64473	232638
1594	1382	79	applied	\N	\N	\N	\N	64474	64474	232639
1594	1383	80	applied	\N	\N	\N	\N	64475	64475	232640
1594	1384	81	applied	\N	\N	\N	\N	64476	64476	232641
1594	1385	82	applied	\N	\N	\N	\N	64477	64477	232642
1594	1386	83	applied	\N	\N	\N	\N	64478	64478	232643
1594	1387	84	applied	\N	\N	\N	\N	64479	64479	232644
1594	1388	85	applied	\N	\N	\N	\N	64480	64480	232645
1594	1389	86	applied	\N	\N	\N	\N	64481	64481	232646
1594	1390	87	applied	\N	\N	\N	\N	64482	64482	232647
1596	1421	0	applied	\N	\N	\N	\N	64484	64484	232649
1599	1421	0	applied	\N	\N	\N	\N	64487	64487	232652
1600	1394	2	applied	\N	\N	\N	\N	64490	64490	232655
1600	1395	3	applied	\N	\N	\N	\N	64491	64491	232656
1600	1397	5	applied	\N	\N	\N	\N	64493	64493	232658
1601	1422	0	applied	\N	\N	\N	\N	64494	64494	232659
1601	1423	1	applied	\N	\N	\N	\N	64495	64495	232660
1602	1422	0	applied	\N	\N	\N	\N	64496	64496	232661
1602	1423	1	applied	\N	\N	\N	\N	64497	64497	232662
1603	1411	0	applied	\N	\N	\N	\N	64498	64498	232663
1603	1412	1	applied	\N	\N	\N	\N	64499	64499	232664
1603	1413	2	applied	\N	\N	\N	\N	64500	64500	232665
1603	1414	3	applied	\N	\N	\N	\N	64501	64501	232666
1603	1415	4	applied	\N	\N	\N	\N	64502	64502	232667
1603	1416	5	applied	\N	\N	\N	\N	64503	64503	232668
1603	1417	6	applied	\N	\N	\N	\N	64504	64504	232669
1603	1418	7	applied	\N	\N	\N	\N	64505	64505	232670
1603	1419	8	applied	\N	\N	\N	\N	64506	64506	232671
1603	1420	9	applied	\N	\N	\N	\N	64507	64507	232672
1603	1421	10	applied	\N	\N	\N	\N	64508	64508	232673
1506	1364	0	applied	\N	\N	\N	\N	64238	64238	232403
1606	1424	0	applied	\N	\N	\N	\N	64513	64513	232678
1606	1425	1	applied	\N	\N	\N	\N	64514	64514	232679
1607	1426	0	applied	\N	\N	\N	\N	64515	64515	232680
1608	1308	0	applied	\N	\N	\N	\N	64516	64516	232681
1608	1355	1	applied	\N	\N	1000000000	\N	64517	64517	232682
1608	1358	2	applied	\N	\N	\N	\N	64518	64518	232683
1608	1371	3	applied	\N	\N	\N	\N	64519	64519	232684
1608	1295	4	applied	\N	\N	\N	\N	64520	64520	232685
1608	1296	5	applied	\N	\N	\N	\N	64521	64521	232686
1608	1297	6	applied	\N	\N	\N	\N	64522	64522	232687
1608	1298	7	applied	\N	\N	\N	\N	64523	64523	232688
1608	1299	8	applied	\N	\N	\N	\N	64524	64524	232689
1608	1300	9	applied	\N	\N	\N	\N	64525	64525	232690
1608	1301	10	applied	\N	\N	\N	\N	64526	64526	232691
1608	1303	12	applied	\N	\N	\N	\N	64528	64528	232693
1608	1304	13	applied	\N	\N	\N	\N	64529	64529	232694
1608	1306	14	applied	\N	\N	\N	\N	64530	64530	232695
1608	1307	15	applied	\N	\N	\N	\N	64531	64531	232696
1608	1309	16	applied	\N	\N	\N	\N	64532	64532	232697
1608	1310	17	applied	\N	\N	\N	\N	64533	64533	232698
1608	1311	18	applied	\N	\N	\N	\N	64534	64534	232699
1608	1313	19	applied	\N	\N	\N	\N	64535	64535	232700
1608	1314	20	applied	\N	\N	\N	\N	64536	64536	232701
1608	1315	21	applied	\N	\N	\N	\N	64537	64537	232702
1608	1316	22	applied	\N	\N	\N	\N	64538	64538	232703
1608	1317	23	applied	\N	\N	\N	\N	64539	64539	232704
1608	1318	24	applied	\N	\N	\N	\N	64540	64540	232705
1608	1319	25	applied	\N	\N	\N	\N	64541	64541	232706
1608	1320	26	applied	\N	\N	\N	\N	64542	64542	232707
1608	1321	27	applied	\N	\N	\N	\N	64543	64543	232708
1608	1323	29	applied	\N	\N	\N	\N	64545	64545	232710
1608	1324	30	applied	\N	\N	\N	\N	64546	64546	232711
1608	1325	31	applied	\N	\N	\N	\N	64547	64547	232712
1608	1326	32	applied	\N	\N	\N	\N	64548	64548	232713
1608	1327	33	applied	\N	\N	\N	\N	64549	64549	232714
1608	1328	34	applied	\N	\N	\N	\N	64550	64550	232715
1608	1329	35	applied	\N	\N	\N	\N	64551	64551	232716
1608	1330	36	applied	\N	\N	\N	\N	64552	64552	232717
1608	1331	37	applied	\N	\N	\N	\N	64553	64553	232718
1608	1332	38	applied	\N	\N	\N	\N	64554	64554	232719
1608	1333	39	applied	\N	\N	\N	\N	64555	64555	232720
1608	1334	40	applied	\N	\N	\N	\N	64556	64556	232721
1608	1335	41	applied	\N	\N	\N	\N	64557	64557	232722
1608	1336	42	applied	\N	\N	\N	\N	64558	64558	232723
1608	1338	43	applied	\N	\N	\N	\N	64559	64559	232724
1608	1339	44	applied	\N	\N	\N	\N	64560	64560	232725
1608	1341	46	applied	\N	\N	\N	\N	64562	64562	232727
1608	1342	47	applied	\N	\N	\N	\N	64563	64563	232728
1608	1344	48	applied	\N	\N	\N	\N	64564	64564	232729
1608	1345	49	applied	\N	\N	\N	\N	64565	64565	232730
1608	1346	50	applied	\N	\N	\N	\N	64566	64566	232731
1608	1348	51	applied	\N	\N	\N	\N	64567	64567	232732
1608	1349	52	applied	\N	\N	\N	\N	64568	64568	232733
1608	1350	53	applied	\N	\N	\N	\N	64569	64569	232734
1608	1351	54	applied	\N	\N	\N	\N	64570	64570	232735
1608	1352	55	applied	\N	\N	\N	\N	64571	64571	232736
1608	1353	56	applied	\N	\N	\N	\N	64572	64572	232737
1608	1354	57	applied	\N	\N	\N	\N	64573	64573	232738
1608	1356	58	applied	\N	\N	\N	\N	64574	64574	232739
1608	1357	59	applied	\N	\N	\N	\N	64575	64575	232740
1608	1359	60	applied	\N	\N	\N	\N	64576	64576	232741
1608	1360	61	applied	\N	\N	\N	\N	64577	64577	232742
1608	1362	63	applied	\N	\N	\N	\N	64579	64579	232744
1608	1363	64	applied	\N	\N	\N	\N	64580	64580	232745
1608	1364	65	applied	\N	\N	\N	\N	64581	64581	232746
1608	1365	66	applied	\N	\N	\N	\N	64582	64582	232747
1608	1366	67	applied	\N	\N	\N	\N	64583	64583	232748
1608	1367	68	applied	\N	\N	\N	\N	64584	64584	232749
1608	1368	69	applied	\N	\N	\N	\N	64585	64585	232750
1608	1369	70	applied	\N	\N	\N	\N	64586	64586	232751
1608	1370	71	applied	\N	\N	\N	\N	64587	64587	232752
1608	1372	72	applied	\N	\N	\N	\N	64588	64588	232753
1608	1373	73	applied	\N	\N	\N	\N	64589	64589	232754
1608	1374	74	applied	\N	\N	\N	\N	64590	64590	232755
1608	1375	75	applied	\N	\N	\N	\N	64591	64591	232756
1608	1376	76	applied	\N	\N	\N	\N	64592	64592	232757
1608	1377	77	applied	\N	\N	\N	\N	64593	64593	232758
1608	1378	78	applied	\N	\N	\N	\N	64594	64594	232759
1608	1380	80	applied	\N	\N	\N	\N	64596	64596	232761
1608	1381	81	applied	\N	\N	\N	\N	64597	64597	232762
1608	1382	82	applied	\N	\N	\N	\N	64598	64598	232763
1608	1383	83	applied	\N	\N	\N	\N	64599	64599	232764
1608	1384	84	applied	\N	\N	\N	\N	64600	64600	232765
1608	1385	85	applied	\N	\N	\N	\N	64601	64601	232766
1608	1386	86	applied	\N	\N	\N	\N	64602	64602	232767
1608	1387	87	applied	\N	\N	\N	\N	64603	64603	232768
1608	1388	88	applied	\N	\N	\N	\N	64604	64604	232769
1608	1389	89	applied	\N	\N	\N	\N	64605	64605	232770
1608	1390	90	applied	\N	\N	\N	\N	64606	64606	232771
1608	1391	91	applied	\N	\N	\N	\N	64607	64607	232772
1608	1392	92	applied	\N	\N	\N	\N	64608	64608	232773
1608	1393	93	applied	\N	\N	\N	\N	64609	64609	232774
1608	1394	94	applied	\N	\N	\N	\N	64610	64610	232775
1608	1395	96	applied	\N	\N	\N	\N	64611	64611	232776
1608	1397	98	applied	\N	\N	\N	\N	64613	64613	232778
1608	1398	99	applied	\N	\N	\N	\N	64614	64614	232779
1608	1399	100	applied	\N	\N	\N	\N	64615	64615	232780
1608	1400	101	applied	\N	\N	\N	\N	64616	64616	232781
1608	1401	102	applied	\N	\N	\N	\N	64617	64617	232782
1608	1402	103	applied	\N	\N	\N	\N	64618	64618	232783
1608	1403	104	applied	\N	\N	\N	\N	64619	64619	232784
1608	1404	105	applied	\N	\N	\N	\N	64620	64620	232785
1608	1405	106	applied	\N	\N	\N	\N	64621	64621	232786
1608	1406	107	applied	\N	\N	\N	\N	64622	64622	232787
1608	1407	108	applied	\N	\N	\N	\N	64623	64623	232788
1608	1408	109	applied	\N	\N	\N	\N	64624	64624	232789
1608	1409	110	applied	\N	\N	\N	\N	64625	64625	232790
1608	1410	111	applied	\N	\N	\N	\N	64626	64626	232791
1608	1411	112	applied	\N	\N	\N	\N	64627	64627	232792
1608	1412	113	applied	\N	\N	\N	\N	64628	64628	232793
1605	1425	1	applied	\N	\N	\N	\N	64512	64512	232677
1608	1417	118	applied	\N	\N	\N	\N	64633	64633	232798
1608	1418	119	applied	\N	\N	\N	\N	64634	64634	232799
1608	1419	120	applied	\N	\N	\N	\N	64635	64635	232800
1608	1420	121	applied	\N	\N	\N	\N	64636	64636	232801
1608	1421	122	applied	\N	\N	\N	\N	64637	64637	232802
1608	1422	123	applied	\N	\N	\N	\N	64638	64638	232803
1608	1423	124	applied	\N	\N	\N	\N	64639	64639	232804
1608	1424	125	applied	\N	\N	\N	\N	64640	64640	232805
1609	1427	0	applied	\N	\N	\N	\N	64641	64641	232806
1609	1428	1	applied	\N	\N	\N	\N	64642	64642	232807
1612	1430	0	applied	\N	\N	\N	\N	64644	64644	232809
1612	1431	1	applied	\N	\N	\N	\N	64645	64645	232810
1612	1432	2	applied	\N	\N	\N	\N	64646	64646	232811
1612	1433	3	applied	\N	\N	\N	\N	64647	64647	232812
1613	1430	0	applied	\N	\N	\N	\N	64648	64648	232813
1613	1431	1	applied	\N	\N	\N	\N	64649	64649	232814
1613	1433	3	applied	\N	\N	\N	\N	64651	64651	232816
1615	1434	0	applied	\N	\N	\N	\N	64653	64653	232818
1616	1434	0	applied	\N	\N	\N	\N	64654	64654	232819
1618	1435	0	applied	\N	\N	\N	\N	64656	64656	232821
1619	1435	0	applied	\N	\N	\N	\N	64657	64657	232822
1621	1436	0	applied	\N	\N	\N	\N	64659	64659	232824
1622	1437	0	applied	\N	\N	\N	\N	64660	64660	232825
1623	1437	0	applied	\N	\N	\N	\N	64661	64661	232826
1624	1393	0	applied	\N	\N	\N	\N	64662	64662	232827
1624	1394	1	applied	\N	\N	\N	\N	64663	64663	232828
1624	1395	2	applied	\N	\N	\N	\N	64664	64664	232829
1624	1396	3	applied	\N	\N	\N	\N	64665	64665	232830
1624	1397	4	applied	\N	\N	\N	\N	64666	64666	232831
1624	1398	5	applied	\N	\N	\N	\N	64667	64667	232832
1624	1399	6	applied	\N	\N	\N	\N	64668	64668	232833
1624	1400	7	applied	\N	\N	\N	\N	64669	64669	232834
1624	1402	9	applied	\N	\N	\N	\N	64671	64671	232836
1624	1403	10	applied	\N	\N	\N	\N	64672	64672	232837
1624	1404	11	applied	\N	\N	\N	\N	64673	64673	232838
1624	1405	12	applied	\N	\N	\N	\N	64674	64674	232839
1624	1406	13	applied	\N	\N	\N	\N	64675	64675	232840
1624	1407	14	applied	\N	\N	\N	\N	64676	64676	232841
1624	1408	15	applied	\N	\N	\N	\N	64677	64677	232842
1624	1409	16	applied	\N	\N	\N	\N	64678	64678	232843
1624	1410	17	applied	\N	\N	\N	\N	64679	64679	232844
1624	1411	18	applied	\N	\N	\N	\N	64680	64680	232845
1624	1412	19	applied	\N	\N	\N	\N	64681	64681	232846
1624	1413	20	applied	\N	\N	\N	\N	64682	64682	232847
1624	1414	21	applied	\N	\N	\N	\N	64683	64683	232848
1624	1415	22	applied	\N	\N	\N	\N	64684	64684	232849
1624	1416	23	applied	\N	\N	\N	\N	64685	64685	232850
1624	1417	24	applied	\N	\N	\N	\N	64686	64686	232851
1624	1419	26	applied	\N	\N	\N	\N	64688	64688	232853
1624	1420	27	applied	\N	\N	\N	\N	64689	64689	232854
1624	1421	28	applied	\N	\N	\N	\N	64690	64690	232855
1624	1422	29	applied	\N	\N	\N	\N	64691	64691	232856
1624	1423	30	applied	\N	\N	\N	\N	64692	64692	232857
1624	1424	31	applied	\N	\N	\N	\N	64693	64693	232858
1624	1425	32	applied	\N	\N	\N	\N	64694	64694	232859
1624	1426	33	applied	\N	\N	\N	\N	64695	64695	232860
1624	1427	34	applied	\N	\N	\N	\N	64696	64696	232861
1624	1428	35	applied	\N	\N	\N	\N	64697	64697	232862
1624	1429	36	applied	\N	\N	\N	\N	64698	64698	232863
1624	1430	37	applied	\N	\N	\N	\N	64699	64699	232864
1624	1431	38	applied	\N	\N	\N	\N	64700	64700	232865
1624	1432	39	applied	\N	\N	\N	\N	64701	64701	232866
1624	1433	40	applied	\N	\N	\N	\N	64702	64702	232867
1624	1434	41	applied	\N	\N	\N	\N	64703	64703	232868
1624	1436	44	applied	\N	\N	\N	\N	64705	64705	232870
1624	1437	45	applied	\N	\N	\N	\N	64706	64706	232871
1627	1439	0	applied	\N	\N	\N	\N	64709	64709	232874
1630	1440	0	applied	\N	\N	\N	\N	64712	64712	232877
1632	1440	0	applied	\N	\N	\N	\N	64714	64714	232879
1633	1441	0	applied	\N	\N	\N	\N	64715	64715	232880
1633	1442	1	applied	\N	\N	\N	\N	64716	64716	232881
1634	1441	0	applied	\N	\N	\N	\N	64717	64717	232882
1634	1442	1	applied	\N	\N	\N	\N	64718	64718	232883
1635	1443	0	applied	\N	\N	\N	\N	64719	64719	232884
1635	1444	1	applied	\N	\N	\N	\N	64720	64720	232885
1637	1445	0	applied	\N	\N	\N	\N	64722	64722	232887
1638	1446	0	applied	\N	\N	\N	\N	64723	64723	232888
1640	1448	0	applied	\N	\N	\N	\N	64725	64725	232890
1642	1448	0	applied	\N	\N	\N	\N	64727	64727	232892
1644	1449	0	applied	\N	\N	\N	\N	64729	64729	232894
1647	1438	0	applied	\N	\N	\N	\N	64731	64731	232896
1647	1439	1	applied	\N	\N	\N	\N	64732	64732	232897
1647	1440	2	applied	\N	\N	\N	\N	64733	64733	232898
1647	1441	3	applied	\N	\N	\N	\N	64734	64734	232899
1647	1442	4	applied	\N	\N	\N	\N	64735	64735	232900
1647	1443	5	applied	\N	\N	\N	\N	64736	64736	232901
1647	1444	6	applied	\N	\N	\N	\N	64737	64737	232902
1647	1445	7	applied	\N	\N	\N	\N	64738	64738	232903
1647	1446	8	applied	\N	\N	\N	\N	64739	64739	232904
1647	1447	9	applied	\N	\N	\N	\N	64740	64740	232905
1647	1448	10	applied	\N	\N	\N	\N	64741	64741	232906
1647	1449	11	applied	\N	\N	\N	\N	64742	64742	232907
1648	1450	0	applied	\N	\N	\N	\N	64743	64743	232908
1649	1451	0	applied	\N	\N	\N	\N	64744	64744	232909
1650	1451	0	applied	\N	\N	\N	\N	64745	64745	232910
1651	1452	0	applied	\N	\N	\N	\N	64746	64746	232911
1653	1453	0	applied	\N	\N	\N	\N	64748	64748	232913
1654	1450	0	applied	\N	\N	\N	\N	64749	64749	232914
1654	1451	1	applied	\N	\N	\N	\N	64750	64750	232915
1654	1452	2	applied	\N	\N	\N	\N	64751	64751	232916
1654	1453	3	applied	\N	\N	\N	\N	64752	64752	232917
1654	1454	4	applied	\N	\N	\N	\N	64753	64753	232918
1655	1454	0	applied	\N	\N	\N	\N	64754	64754	232919
1657	1457	0	applied	\N	\N	\N	\N	64757	64757	232922
1658	1457	0	applied	\N	\N	\N	\N	64758	64758	232923
1659	1457	0	applied	\N	\N	\N	\N	64759	64759	232924
1661	1458	0	applied	\N	\N	\N	\N	64764	64764	232929
1662	1458	0	applied	\N	\N	\N	\N	64768	64768	232933
1662	1459	1	applied	\N	\N	\N	\N	64769	64769	232934
1662	1460	2	applied	\N	\N	\N	\N	64770	64770	232935
1608	1414	115	applied	\N	\N	\N	\N	64630	64630	232795
1608	1415	116	applied	\N	\N	\N	\N	64631	64631	232796
1625	1437	0	applied	\N	\N	\N	\N	64707	64707	232872
1626	1438	0	applied	\N	\N	\N	\N	64708	64708	232873
1628	1439	0	applied	\N	\N	\N	\N	64710	64710	232875
1629	1440	0	applied	\N	\N	\N	\N	64711	64711	232876
1631	1440	0	applied	\N	\N	\N	\N	64713	64713	232878
1636	1445	0	applied	\N	\N	\N	\N	64721	64721	232886
1639	1447	0	applied	\N	\N	\N	\N	64724	64724	232889
1641	1448	0	applied	\N	\N	\N	\N	64726	64726	232891
1643	1448	0	applied	\N	\N	\N	\N	64728	64728	232893
1656	1455	0	applied	\N	\N	\N	\N	64755	64755	232920
1656	1456	1	applied	\N	\N	\N	\N	64756	64756	232921
1660	1458	0	applied	\N	\N	\N	\N	64760	64760	232925
1660	1459	1	applied	\N	\N	\N	\N	64761	64761	232926
1660	1460	2	applied	\N	\N	\N	\N	64762	64762	232927
1660	1461	3	applied	\N	\N	\N	\N	64763	64763	232928
1661	1459	1	applied	\N	\N	\N	\N	64765	64765	232930
1661	1461	3	applied	\N	\N	\N	\N	64767	64767	232932
1662	1461	3	applied	\N	\N	\N	\N	64771	64771	232936
1663	1462	0	applied	\N	\N	\N	\N	64772	64772	232937
1663	1463	1	applied	\N	\N	\N	\N	64773	64773	232938
1664	1451	0	applied	\N	\N	\N	\N	64774	64774	232939
1664	1452	1	applied	\N	\N	\N	\N	64775	64775	232940
1664	1453	2	applied	\N	\N	\N	\N	64776	64776	232941
1664	1454	3	applied	\N	\N	\N	\N	64777	64777	232942
1664	1455	4	applied	\N	\N	\N	\N	64778	64778	232943
1664	1456	5	applied	\N	\N	\N	\N	64779	64779	232944
1664	1457	6	applied	\N	\N	\N	\N	64780	64780	232945
1664	1458	7	applied	\N	\N	\N	\N	64781	64781	232946
1664	1459	8	applied	\N	\N	\N	\N	64782	64782	232947
1664	1460	9	applied	\N	\N	\N	\N	64783	64783	232948
1664	1461	10	applied	\N	\N	\N	\N	64784	64784	232949
1664	1462	11	applied	\N	\N	\N	\N	64785	64785	232950
1665	1462	0	applied	\N	\N	\N	\N	64787	64787	232952
1665	1463	1	applied	\N	\N	\N	\N	64788	64788	232953
1666	1462	0	applied	\N	\N	\N	\N	64789	64789	232954
1666	1463	1	applied	\N	\N	\N	\N	64790	64790	232955
1667	1462	0	applied	\N	\N	\N	\N	64791	64791	232956
1667	1463	1	applied	\N	\N	\N	\N	64792	64792	232957
1668	1464	0	applied	\N	\N	\N	\N	64793	64793	232958
1668	1465	1	applied	\N	\N	\N	\N	64794	64794	232959
1669	1464	0	applied	\N	\N	\N	\N	64795	64795	232960
1669	1465	1	applied	\N	\N	\N	\N	64796	64796	232961
1670	1466	0	applied	\N	\N	\N	\N	64797	64797	232962
1670	1467	1	applied	\N	\N	\N	\N	64798	64798	232963
1671	1468	0	applied	\N	\N	\N	\N	64799	64799	232964
1672	1468	0	applied	\N	\N	\N	\N	64800	64800	232965
1673	1469	0	applied	\N	\N	\N	\N	64801	64801	232966
1673	1470	1	applied	\N	\N	\N	\N	64802	64802	232967
1673	1472	3	applied	\N	\N	\N	\N	64804	64804	232969
1674	1469	0	applied	\N	\N	\N	\N	64805	64805	232970
1674	1470	1	applied	\N	\N	\N	\N	64806	64806	232971
1674	1471	2	applied	\N	\N	\N	\N	64807	64807	232972
1674	1472	3	applied	\N	\N	\N	\N	64808	64808	232973
1675	1469	0	applied	\N	\N	\N	\N	64809	64809	232974
1675	1470	1	applied	\N	\N	\N	\N	64810	64810	232975
1675	1471	2	applied	\N	\N	\N	\N	64811	64811	232976
1675	1472	3	applied	\N	\N	\N	\N	64812	64812	232977
1676	1473	0	applied	\N	\N	\N	\N	64813	64813	232978
1677	1473	0	applied	\N	\N	\N	\N	64814	64814	232979
1678	1474	0	applied	\N	\N	\N	\N	64815	64815	232980
1679	1474	0	applied	\N	\N	\N	\N	64816	64816	232981
1681	1475	0	applied	\N	\N	\N	\N	64817	64817	232982
1682	1476	0	applied	\N	\N	\N	\N	64818	64818	232983
1683	1476	0	applied	\N	\N	\N	\N	64819	64819	232984
1685	1478	0	applied	\N	\N	\N	\N	64821	64821	232986
1686	1479	0	applied	\N	\N	\N	\N	64822	64822	232987
1687	1479	0	applied	\N	\N	\N	\N	64823	64823	232988
1688	1480	0	applied	\N	\N	\N	\N	64824	64824	232989
1689	1481	0	applied	\N	\N	\N	\N	64825	64825	232990
1690	1482	0	applied	\N	\N	\N	\N	64826	64826	232991
1690	1483	1	applied	\N	\N	\N	\N	64827	64827	232992
1691	1455	0	applied	\N	\N	\N	\N	64828	64828	232993
1691	1456	1	applied	\N	\N	\N	\N	64829	64829	232994
1691	1457	2	applied	\N	\N	\N	\N	64830	64830	232995
1692	1484	0	applied	\N	\N	\N	\N	64836	64836	233001
1692	1485	1	applied	\N	\N	\N	\N	64837	64837	233002
1693	1484	0	applied	\N	\N	\N	\N	64838	64838	233003
1693	1485	1	applied	\N	\N	\N	\N	64839	64839	233004
1695	1487	0	applied	\N	\N	\N	\N	64841	64841	233006
1696	1488	0	applied	\N	\N	\N	\N	64842	64842	233007
1701	1489	0	applied	\N	\N	\N	\N	64848	64848	233013
1701	1490	1	applied	\N	\N	\N	\N	64849	64849	233014
1701	1464	2	applied	\N	\N	\N	\N	64850	64850	233015
1701	1465	3	applied	\N	\N	\N	\N	64851	64851	233016
1701	1466	4	applied	\N	\N	\N	\N	64852	64852	233017
1701	1467	5	applied	\N	\N	\N	\N	64853	64853	233018
1701	1468	6	applied	\N	\N	\N	\N	64854	64854	233019
1701	1469	7	applied	\N	\N	\N	\N	64855	64855	233020
1701	1470	8	applied	\N	\N	\N	\N	64856	64856	233021
1701	1471	9	applied	\N	\N	\N	\N	64857	64857	233022
1701	1472	10	applied	\N	\N	\N	\N	64858	64858	233023
1701	1473	11	applied	\N	\N	\N	\N	64859	64859	233024
1701	1474	12	applied	\N	\N	\N	\N	64860	64860	233025
1701	1475	13	applied	\N	\N	\N	\N	64861	64861	233026
1701	1476	14	applied	\N	\N	\N	\N	64862	64862	233027
1701	1477	15	applied	\N	\N	\N	\N	64863	64863	233028
1701	1479	17	applied	\N	\N	\N	\N	64865	64865	233030
1701	1480	18	applied	\N	\N	\N	\N	64866	64866	233031
1701	1481	19	applied	\N	\N	\N	\N	64867	64867	233032
1701	1482	20	applied	\N	\N	\N	\N	64868	64868	233033
1701	1483	21	applied	\N	\N	\N	\N	64869	64869	233034
1701	1484	22	applied	\N	\N	\N	\N	64870	64870	233035
1701	1485	23	applied	\N	\N	\N	\N	64871	64871	233036
1701	1486	24	applied	\N	\N	\N	\N	64872	64872	233037
1701	1487	25	applied	\N	\N	\N	\N	64873	64873	233038
1701	1488	26	applied	\N	\N	\N	\N	64874	64874	233039
1701	1491	27	applied	\N	\N	\N	\N	64875	64875	233040
1701	1492	28	applied	\N	\N	\N	\N	64876	64876	233041
1701	1493	29	applied	\N	\N	\N	\N	64877	64877	233042
1701	1494	30	applied	\N	\N	\N	\N	64878	64878	233043
1614	1434	0	applied	\N	\N	\N	\N	64652	64652	232817
1617	1435	0	applied	\N	\N	\N	\N	64655	64655	232820
1691	1461	6	applied	\N	\N	\N	\N	64834	64834	232999
1691	1462	7	applied	\N	\N	\N	\N	64835	64835	233000
1694	1486	0	applied	\N	\N	\N	\N	64840	64840	233005
1697	1489	0	applied	\N	\N	\N	\N	64843	64843	233008
1697	1490	1	applied	\N	\N	\N	\N	64844	64844	233009
1697	1491	2	applied	\N	\N	\N	\N	64845	64845	233010
1697	1492	3	applied	\N	\N	\N	\N	64846	64846	233011
1702	1494	0	applied	\N	\N	\N	\N	64879	64879	233044
1703	1494	0	applied	\N	\N	\N	\N	64880	64880	233045
1704	1494	0	applied	\N	\N	\N	\N	64881	64881	233046
1706	1494	0	applied	\N	\N	\N	\N	64882	64882	233047
1706	1495	1	applied	\N	\N	\N	\N	64883	64883	233048
1707	1494	0	applied	\N	\N	\N	\N	64884	64884	233049
1708	1425	0	applied	\N	\N	\N	\N	64886	64886	233051
1708	1426	1	applied	\N	\N	\N	\N	64887	64887	233052
1708	1427	2	applied	\N	\N	\N	\N	64888	64888	233053
1708	1428	3	applied	\N	\N	\N	\N	64889	64889	233054
1708	1429	4	applied	\N	\N	\N	\N	64890	64890	233055
1708	1430	5	applied	\N	\N	\N	\N	64891	64891	233056
1708	1431	6	applied	\N	\N	\N	\N	64892	64892	233057
1708	1432	7	applied	\N	\N	\N	\N	64893	64893	233058
1708	1433	8	applied	\N	\N	\N	\N	64894	64894	233059
1708	1434	9	applied	\N	\N	\N	\N	64895	64895	233060
1708	1435	10	applied	\N	\N	\N	\N	64896	64896	233061
1708	1436	11	applied	\N	\N	\N	\N	64897	64897	233062
1708	1437	12	applied	\N	\N	\N	\N	64898	64898	233063
1708	1438	13	applied	\N	\N	\N	\N	64899	64899	233064
1708	1439	14	applied	\N	\N	\N	\N	64900	64900	233065
1708	1440	15	applied	\N	\N	\N	\N	64901	64901	233066
1708	1442	17	applied	\N	\N	\N	\N	64903	64903	233068
1708	1443	18	applied	\N	\N	\N	\N	64904	64904	233069
1708	1444	19	applied	\N	\N	\N	\N	64905	64905	233070
1708	1445	20	applied	\N	\N	\N	\N	64906	64906	233071
1708	1446	21	applied	\N	\N	\N	\N	64907	64907	233072
1708	1447	22	applied	\N	\N	\N	\N	64908	64908	233073
1708	1448	23	applied	\N	\N	\N	\N	64909	64909	233074
1708	1449	24	applied	\N	\N	\N	\N	64910	64910	233075
1708	1450	25	applied	\N	\N	\N	\N	64911	64911	233076
1708	1451	26	applied	\N	\N	\N	\N	64912	64912	233077
1708	1452	27	applied	\N	\N	\N	\N	64913	64913	233078
1708	1453	28	applied	\N	\N	\N	\N	64914	64914	233079
1708	1454	29	applied	\N	\N	\N	\N	64915	64915	233080
1708	1455	30	applied	\N	\N	\N	\N	64916	64916	233081
1708	1456	31	applied	\N	\N	\N	\N	64917	64917	233082
1708	1457	32	applied	\N	\N	\N	\N	64918	64918	233083
1708	1459	34	applied	\N	\N	\N	\N	64920	64920	233085
1708	1460	35	applied	\N	\N	\N	\N	64921	64921	233086
1708	1461	36	applied	\N	\N	\N	\N	64922	64922	233087
1708	1462	37	applied	\N	\N	\N	\N	64923	64923	233088
1708	1463	38	applied	\N	\N	\N	\N	64924	64924	233089
1708	1464	39	applied	\N	\N	\N	\N	64925	64925	233090
1708	1465	40	applied	\N	\N	\N	\N	64926	64926	233091
1708	1466	41	applied	\N	\N	\N	\N	64927	64927	233092
1708	1467	42	applied	\N	\N	\N	\N	64928	64928	233093
1708	1468	43	applied	\N	\N	\N	\N	64929	64929	233094
1708	1469	44	applied	\N	\N	\N	\N	64930	64930	233095
1708	1470	45	applied	\N	\N	\N	\N	64931	64931	233096
1708	1471	46	applied	\N	\N	\N	\N	64932	64932	233097
1708	1472	47	applied	\N	\N	\N	\N	64933	64933	233098
1708	1473	48	applied	\N	\N	\N	\N	64934	64934	233099
1708	1474	49	applied	\N	\N	\N	\N	64935	64935	233100
1708	1476	51	applied	\N	\N	\N	\N	64937	64937	233102
1708	1477	52	applied	\N	\N	\N	\N	64938	64938	233103
1708	1478	53	applied	\N	\N	\N	\N	64939	64939	233104
1708	1479	54	applied	\N	\N	\N	\N	64940	64940	233105
1708	1480	55	applied	\N	\N	\N	\N	64941	64941	233106
1708	1481	56	applied	\N	\N	\N	\N	64942	64942	233107
1708	1482	57	applied	\N	\N	\N	\N	64943	64943	233108
1708	1483	58	applied	\N	\N	\N	\N	64944	64944	233109
1708	1484	59	applied	\N	\N	\N	\N	64945	64945	233110
1708	1485	60	applied	\N	\N	\N	\N	64946	64946	233111
1708	1486	61	applied	\N	\N	\N	\N	64947	64947	233112
1708	1487	62	applied	\N	\N	\N	\N	64948	64948	233113
1708	1488	63	applied	\N	\N	\N	\N	64949	64949	233114
1708	1491	64	applied	\N	\N	\N	\N	64950	64950	233115
1708	1492	65	applied	\N	\N	\N	\N	64951	64951	233116
1708	1493	66	applied	\N	\N	\N	\N	64952	64952	233117
1708	1495	68	applied	\N	\N	\N	\N	64954	64954	233119
1708	1496	69	applied	\N	\N	\N	\N	64955	64955	233120
1708	1305	70	applied	\N	\N	\N	\N	64956	64956	233121
1708	1489	71	applied	\N	\N	\N	\N	64957	64957	233122
1708	1490	72	applied	\N	\N	\N	\N	64958	64958	233123
1709	1496	0	applied	\N	\N	\N	\N	64959	64959	233124
1709	1497	1	applied	\N	\N	\N	\N	64960	64960	233125
1709	1498	2	applied	\N	\N	\N	\N	64961	64961	233126
1709	1499	3	applied	\N	\N	\N	\N	64962	64962	233127
1710	1500	0	applied	\N	\N	\N	\N	64963	64963	233128
1710	1501	1	applied	\N	\N	1000000000	\N	64964	64964	233129
1711	1500	0	applied	\N	\N	\N	\N	64965	64965	233130
1711	1501	1	applied	\N	\N	1000000000	\N	64966	64966	233131
1715	1502	0	applied	\N	\N	\N	\N	64967	64967	233132
1715	1503	1	applied	\N	\N	\N	\N	64968	64968	233133
1719	1505	0	applied	\N	\N	\N	\N	64982	64982	233147
1721	1506	0	applied	\N	\N	\N	\N	64984	64984	233149
1721	1507	1	applied	\N	\N	\N	\N	64985	64985	233150
1721	1508	2	applied	\N	\N	\N	\N	64986	64986	233151
1721	1509	3	applied	\N	\N	\N	\N	64987	64987	233152
1727	1514	0	applied	\N	\N	\N	\N	64998	64998	233163
1730	1516	0	applied	\N	\N	\N	\N	65009	65009	233174
1730	1517	1	applied	\N	\N	\N	\N	65010	65010	233175
1735	1518	0	applied	\N	\N	\N	\N	65016	65016	233181
1736	1519	0	applied	\N	\N	\N	\N	65017	65017	233182
1741	1520	0	applied	\N	\N	\N	\N	65022	65022	233187
1741	1521	1	applied	\N	\N	\N	\N	65023	65023	233188
1742	1522	0	applied	\N	\N	\N	\N	65024	65024	233189
1747	1524	0	applied	\N	\N	\N	\N	65030	65030	233195
1747	1525	1	applied	\N	\N	\N	\N	65031	65031	233196
1749	1524	0	applied	\N	\N	\N	\N	65034	65034	233199
1749	1525	1	applied	\N	\N	\N	\N	65035	65035	233200
1691	1459	4	applied	\N	\N	\N	\N	64832	64832	232997
1691	1460	5	applied	\N	\N	\N	\N	64833	64833	232998
1718	1496	2	applied	\N	\N	\N	\N	64973	64973	233138
1718	1498	3	applied	\N	\N	\N	\N	64974	64974	233139
1718	1501	4	applied	\N	\N	1000000000	\N	64975	64975	233140
1718	1499	5	applied	\N	\N	\N	\N	64976	64976	233141
1718	1500	6	applied	\N	\N	\N	\N	64977	64977	233142
1718	1502	7	applied	\N	\N	\N	\N	64978	64978	233143
1718	1503	8	applied	\N	\N	\N	\N	64979	64979	233144
1718	1504	9	applied	\N	\N	\N	\N	64980	64980	233145
1718	1505	10	applied	\N	\N	\N	\N	64981	64981	233146
1724	1510	0	applied	\N	\N	\N	\N	64994	64994	233159
1724	1511	1	applied	\N	\N	\N	\N	64995	64995	233160
1725	1512	0	applied	\N	\N	\N	\N	64996	64996	233161
1731	1516	0	applied	\N	\N	\N	\N	65011	65011	233176
1733	1518	0	applied	\N	\N	\N	\N	65014	65014	233179
1737	1519	0	applied	\N	\N	\N	\N	65018	65018	233183
1739	1520	0	applied	\N	\N	\N	\N	65019	65019	233184
1740	1520	0	applied	\N	\N	\N	\N	65020	65020	233185
1740	1521	1	applied	\N	\N	\N	\N	65021	65021	233186
1743	1522	0	applied	\N	\N	\N	\N	65025	65025	233190
1745	1523	0	applied	\N	\N	\N	\N	65027	65027	233192
1746	1524	0	applied	\N	\N	\N	\N	65028	65028	233193
1746	1525	1	applied	\N	\N	\N	\N	65029	65029	233194
1748	1524	0	applied	\N	\N	\N	\N	65032	65032	233197
1748	1525	1	applied	\N	\N	\N	\N	65033	65033	233198
1754	1527	0	applied	\N	\N	\N	\N	65040	65040	233205
1755	1528	0	applied	\N	\N	\N	\N	65041	65041	233206
1756	1528	0	applied	\N	\N	\N	\N	65042	65042	233207
1757	1529	0	applied	\N	\N	\N	\N	65043	65043	233208
1757	1530	1	applied	\N	\N	\N	\N	65044	65044	233209
1761	1531	0	applied	\N	\N	\N	\N	65049	65049	233214
1763	1535	0	applied	\N	\N	\N	\N	65053	65053	233218
1764	1536	0	applied	\N	\N	\N	\N	65054	65054	233219
1767	1538	0	applied	\N	\N	\N	\N	65056	65056	233221
1769	1539	0	applied	\N	\N	\N	\N	65057	65057	233222
1770	1540	0	applied	\N	\N	\N	\N	65058	65058	233223
1770	1541	1	applied	\N	\N	\N	\N	65059	65059	233224
1770	1542	2	applied	\N	\N	\N	\N	65060	65060	233225
1772	1545	0	applied	\N	\N	\N	\N	65063	65063	233228
1772	1546	1	applied	\N	\N	\N	\N	65064	65064	233229
1773	1547	0	applied	\N	\N	\N	\N	65065	65065	233230
1774	1547	0	applied	\N	\N	\N	\N	65066	65066	233231
1775	1547	0	applied	\N	\N	\N	\N	65067	65067	233232
1776	1547	0	applied	\N	\N	\N	\N	65068	65068	233233
1778	1548	0	applied	\N	\N	\N	\N	65070	65070	233235
1779	1548	0	applied	\N	\N	\N	\N	65071	65071	233236
1781	1550	1	applied	\N	\N	\N	\N	65074	65074	233239
1784	1551	0	applied	\N	\N	\N	\N	65079	65079	233244
1787	1552	0	applied	\N	\N	\N	\N	65086	65086	233251
1787	1553	1	applied	\N	\N	\N	\N	65087	65087	233252
1787	1554	2	applied	\N	\N	\N	\N	65088	65088	233253
1787	1555	3	applied	\N	\N	\N	\N	65089	65089	233254
1787	1556	4	applied	\N	\N	\N	\N	65090	65090	233255
1789	1557	0	applied	\N	\N	\N	\N	65092	65092	233257
1790	1557	0	applied	\N	\N	\N	\N	65093	65093	233258
1793	1488	0	applied	\N	\N	\N	\N	65097	65097	233262
1793	1501	1	applied	\N	\N	1000000000	\N	65098	65098	233263
1793	1491	2	applied	\N	\N	\N	\N	65099	65099	233264
1793	1492	3	applied	\N	\N	\N	\N	65100	65100	233265
1793	1493	4	applied	\N	\N	\N	\N	65101	65101	233266
1793	1494	5	applied	\N	\N	\N	\N	65102	65102	233267
1793	1495	6	applied	\N	\N	\N	\N	65103	65103	233268
1793	1498	8	applied	\N	\N	\N	\N	65105	65105	233270
1793	1499	9	applied	\N	\N	\N	\N	65106	65106	233271
1793	1500	10	applied	\N	\N	\N	\N	65107	65107	233272
1793	1502	11	applied	\N	\N	\N	\N	65108	65108	233273
1793	1503	12	applied	\N	\N	\N	\N	65109	65109	233274
1793	1504	13	applied	\N	\N	\N	\N	65110	65110	233275
1793	1505	14	applied	\N	\N	\N	\N	65111	65111	233276
1793	1506	15	applied	\N	\N	\N	\N	65112	65112	233277
1793	1507	16	applied	\N	\N	\N	\N	65113	65113	233278
1793	1508	17	applied	\N	\N	\N	\N	65114	65114	233279
1793	1509	18	applied	\N	\N	\N	\N	65115	65115	233280
1793	1510	19	applied	\N	\N	\N	\N	65116	65116	233281
1793	1511	20	applied	\N	\N	\N	\N	65117	65117	233282
1793	1512	21	applied	\N	\N	\N	\N	65118	65118	233283
1793	1513	22	applied	\N	\N	\N	\N	65119	65119	233284
1793	1514	23	applied	\N	\N	\N	\N	65120	65120	233285
1793	1516	25	applied	\N	\N	\N	\N	65122	65122	233287
1796	1560	0	applied	\N	\N	\N	\N	65124	65124	233289
1796	1561	1	applied	\N	\N	\N	\N	65125	65125	233290
1796	1562	2	applied	\N	\N	\N	\N	65126	65126	233291
1802	1568	0	applied	\N	\N	\N	\N	65136	65136	233301
1806	1572	0	applied	\N	\N	\N	\N	65144	65144	233309
1810	1574	0	applied	\N	\N	\N	\N	65148	65148	233313
1811	1574	0	applied	\N	\N	\N	\N	65149	65149	233314
1815	1578	0	applied	\N	\N	\N	\N	65154	65154	233319
1815	1579	1	applied	\N	\N	\N	\N	65155	65155	233320
1819	1583	0	applied	\N	\N	\N	\N	65161	65161	233326
1819	1584	1	applied	\N	\N	\N	\N	65162	65162	233327
1821	1585	0	applied	\N	\N	\N	\N	65164	65164	233329
1825	1585	0	applied	\N	\N	\N	\N	65166	65166	233331
1828	1588	0	applied	\N	\N	\N	\N	65169	65169	233334
1830	1588	0	applied	\N	\N	\N	\N	65171	65171	233336
1833	1589	0	applied	\N	\N	\N	\N	65174	65174	233339
1837	1591	0	applied	\N	\N	\N	\N	65178	65178	233343
1840	1593	0	applied	\N	\N	\N	\N	65181	65181	233346
1842	1594	0	applied	\N	\N	\N	\N	65183	65183	233348
1843	1595	0	applied	\N	\N	\N	\N	65184	65184	233349
1846	1596	0	applied	\N	\N	\N	\N	65188	65188	233353
1849	1596	0	applied	\N	\N	\N	\N	65191	65191	233356
1851	1597	0	applied	\N	\N	\N	\N	65193	65193	233358
1852	1597	0	applied	\N	\N	\N	\N	65194	65194	233359
1855	1599	0	applied	\N	\N	\N	\N	65197	65197	233362
1858	1601	0	applied	\N	\N	\N	\N	65200	65200	233365
1858	1602	1	applied	\N	\N	\N	\N	65201	65201	233366
1861	1603	0	applied	\N	\N	\N	\N	65206	65206	233371
1864	1604	0	applied	\N	\N	\N	\N	65209	65209	233374
1867	1606	0	applied	\N	\N	\N	\N	65212	65212	233377
1869	1607	0	applied	\N	\N	\N	\N	65293	65293	233458
1718	1497	0	applied	\N	\N	\N	\N	64971	64971	233136
1718	1495	1	applied	\N	\N	\N	\N	64972	64972	233137
1722	1508	2	applied	\N	\N	\N	\N	64990	64990	233155
1722	1509	3	applied	\N	\N	\N	\N	64991	64991	233156
1723	1510	0	applied	\N	\N	\N	\N	64992	64992	233157
1723	1511	1	applied	\N	\N	\N	\N	64993	64993	233158
1726	1513	0	applied	\N	\N	\N	\N	64997	64997	233162
1728	1506	0	applied	\N	\N	\N	\N	64999	64999	233164
1728	1507	1	applied	\N	\N	\N	\N	65000	65000	233165
1728	1508	2	applied	\N	\N	\N	\N	65001	65001	233166
1728	1509	3	applied	\N	\N	\N	\N	65002	65002	233167
1728	1510	4	applied	\N	\N	\N	\N	65003	65003	233168
1728	1511	5	applied	\N	\N	\N	\N	65004	65004	233169
1728	1512	6	applied	\N	\N	\N	\N	65005	65005	233170
1728	1513	7	applied	\N	\N	\N	\N	65006	65006	233171
1729	1515	0	applied	\N	\N	\N	\N	65008	65008	233173
1732	1518	0	applied	\N	\N	\N	\N	65013	65013	233178
1734	1518	0	applied	\N	\N	\N	\N	65015	65015	233180
1744	1523	0	applied	\N	\N	\N	\N	65026	65026	233191
1750	1526	0	applied	\N	\N	\N	\N	65036	65036	233201
1752	1526	0	applied	\N	\N	\N	\N	65038	65038	233203
1753	1527	0	applied	\N	\N	\N	\N	65039	65039	233204
1758	1529	0	applied	\N	\N	\N	\N	65045	65045	233210
1758	1530	1	applied	\N	\N	\N	\N	65046	65046	233211
1759	1531	0	applied	\N	\N	\N	\N	65047	65047	233212
1762	1532	0	applied	\N	\N	\N	\N	65050	65050	233215
1762	1533	1	applied	\N	\N	\N	\N	65051	65051	233216
1762	1534	2	applied	\N	\N	\N	\N	65052	65052	233217
1765	1537	0	applied	\N	\N	\N	\N	65055	65055	233220
1771	1543	0	applied	\N	\N	\N	\N	65061	65061	233226
1771	1544	1	applied	\N	\N	\N	\N	65062	65062	233227
1780	1548	0	applied	\N	\N	\N	\N	65072	65072	233237
1782	1549	0	applied	\N	\N	\N	\N	65075	65075	233240
1782	1550	1	applied	\N	\N	\N	\N	65076	65076	233241
1783	1549	0	applied	\N	\N	\N	\N	65077	65077	233242
1783	1550	1	applied	\N	\N	\N	\N	65078	65078	233243
1785	1551	0	applied	\N	\N	\N	\N	65080	65080	233245
1786	1552	0	applied	\N	\N	\N	\N	65081	65081	233246
1786	1553	1	applied	\N	\N	\N	\N	65082	65082	233247
1786	1554	2	applied	\N	\N	\N	\N	65083	65083	233248
1786	1555	3	applied	\N	\N	\N	\N	65084	65084	233249
1786	1556	4	applied	\N	\N	\N	\N	65085	65085	233250
1788	1557	0	applied	\N	\N	\N	\N	65091	65091	233256
1791	1558	0	applied	\N	\N	\N	\N	65094	65094	233259
1791	1559	1	applied	\N	\N	\N	\N	65095	65095	233260
1792	1560	0	applied	\N	\N	\N	\N	65096	65096	233261
1795	1560	0	applied	\N	\N	\N	\N	65123	65123	233288
1798	1564	0	applied	\N	\N	1000000000	\N	65128	65128	233293
1798	1565	1	applied	\N	\N	\N	\N	65129	65129	233294
1798	1566	2	applied	\N	\N	\N	\N	65130	65130	233295
1799	1564	0	applied	\N	\N	1000000000	\N	65131	65131	233296
1799	1565	1	applied	\N	\N	\N	\N	65132	65132	233297
1799	1566	2	applied	\N	\N	\N	\N	65133	65133	233298
1800	1567	0	applied	\N	\N	\N	\N	65134	65134	233299
1801	1568	0	applied	\N	\N	\N	\N	65135	65135	233300
1803	1568	0	applied	\N	\N	\N	\N	65137	65137	233302
1804	1569	0	applied	\N	\N	\N	\N	65138	65138	233303
1804	1570	1	applied	\N	\N	\N	\N	65139	65139	233304
1804	1571	2	applied	\N	\N	\N	\N	65140	65140	233305
1805	1569	0	applied	\N	\N	\N	\N	65141	65141	233306
1805	1570	1	applied	\N	\N	\N	\N	65142	65142	233307
1805	1571	2	applied	\N	\N	\N	\N	65143	65143	233308
1807	1573	0	applied	\N	\N	\N	\N	65145	65145	233310
1809	1574	0	applied	\N	\N	\N	\N	65147	65147	233312
1812	1575	0	applied	\N	\N	\N	\N	65150	65150	233315
1812	1576	1	applied	\N	\N	\N	\N	65151	65151	233316
1813	1577	0	applied	\N	\N	\N	\N	65152	65152	233317
1814	1577	0	applied	\N	\N	\N	\N	65153	65153	233318
1817	1578	0	applied	\N	\N	\N	\N	65156	65156	233321
1817	1579	1	applied	\N	\N	\N	\N	65157	65157	233322
1817	1580	2	applied	\N	\N	\N	\N	65158	65158	233323
1817	1581	3	applied	\N	\N	\N	\N	65159	65159	233324
1818	1582	0	applied	\N	\N	\N	\N	65160	65160	233325
1820	1585	0	applied	\N	\N	\N	\N	65163	65163	233328
1824	1585	0	applied	\N	\N	\N	\N	65165	65165	233330
1826	1586	0	applied	\N	\N	\N	\N	65167	65167	233332
1827	1587	0	applied	\N	\N	\N	\N	65168	65168	233333
1829	1588	0	applied	\N	\N	\N	\N	65170	65170	233335
1832	1589	0	applied	\N	\N	\N	\N	65173	65173	233338
1835	1590	1	applied	\N	\N	\N	\N	65176	65176	233341
1836	1591	0	applied	\N	\N	\N	\N	65177	65177	233342
1838	1592	0	applied	\N	\N	\N	\N	65179	65179	233344
1839	1593	0	applied	\N	\N	\N	\N	65180	65180	233345
1841	1594	0	applied	\N	\N	\N	\N	65182	65182	233347
1844	1595	0	applied	\N	\N	\N	\N	65185	65185	233350
1845	1594	0	applied	\N	\N	\N	\N	65186	65186	233351
1845	1595	1	applied	\N	\N	\N	\N	65187	65187	233352
1847	1596	0	applied	\N	\N	\N	\N	65189	65189	233354
1848	1596	0	applied	\N	\N	\N	\N	65190	65190	233355
1850	1597	0	applied	\N	\N	\N	\N	65192	65192	233357
1853	1598	0	applied	\N	\N	\N	\N	65195	65195	233360
1854	1598	0	applied	\N	\N	\N	\N	65196	65196	233361
1856	1599	0	applied	\N	\N	\N	\N	65198	65198	233363
1857	1600	0	applied	\N	\N	\N	\N	65199	65199	233364
1859	1601	0	applied	\N	\N	\N	\N	65202	65202	233367
1860	1601	0	applied	\N	\N	\N	\N	65204	65204	233369
1860	1602	1	applied	\N	\N	\N	\N	65205	65205	233370
1862	1603	0	applied	\N	\N	\N	\N	65207	65207	233372
1863	1604	0	applied	\N	\N	\N	\N	65208	65208	233373
1865	1605	0	applied	\N	\N	\N	\N	65210	65210	233375
1866	1605	0	applied	\N	\N	\N	\N	65211	65211	233376
1868	1522	0	applied	\N	\N	\N	\N	65213	65213	233378
1868	1523	1	applied	\N	\N	\N	\N	65214	65214	233379
1868	1524	2	applied	\N	\N	\N	\N	65215	65215	233380
1868	1525	3	applied	\N	\N	\N	\N	65216	65216	233381
1868	1526	4	applied	\N	\N	\N	\N	65217	65217	233382
1868	1527	5	applied	\N	\N	\N	\N	65218	65218	233383
1868	1528	6	applied	\N	\N	\N	\N	65219	65219	233384
1868	1529	7	applied	\N	\N	\N	\N	65220	65220	233385
1868	1530	8	applied	\N	\N	\N	\N	65221	65221	233386
1868	1531	9	applied	\N	\N	\N	\N	65222	65222	233387
1722	1506	0	applied	\N	\N	\N	\N	64988	64988	233153
1722	1507	1	applied	\N	\N	\N	\N	64989	64989	233154
1868	1537	15	applied	\N	\N	\N	\N	65228	65228	233393
1868	1538	16	applied	\N	\N	\N	\N	65229	65229	233394
1868	1539	17	applied	\N	\N	\N	\N	65230	65230	233395
1868	1540	18	applied	\N	\N	\N	\N	65231	65231	233396
1868	1541	19	applied	\N	\N	\N	\N	65232	65232	233397
1868	1542	20	applied	\N	\N	\N	\N	65233	65233	233398
1868	1543	21	applied	\N	\N	\N	\N	65234	65234	233399
1868	1544	22	applied	\N	\N	\N	\N	65235	65235	233400
1868	1545	23	applied	\N	\N	\N	\N	65236	65236	233401
1868	1546	24	applied	\N	\N	\N	\N	65237	65237	233402
1868	1547	25	applied	\N	\N	\N	\N	65238	65238	233403
1868	1548	26	applied	\N	\N	\N	\N	65239	65239	233404
1868	1549	27	applied	\N	\N	\N	\N	65240	65240	233405
1868	1550	28	applied	\N	\N	\N	\N	65241	65241	233406
1868	1551	29	applied	\N	\N	\N	\N	65242	65242	233407
1868	1552	30	applied	\N	\N	\N	\N	65243	65243	233408
1868	1554	32	applied	\N	\N	\N	\N	65245	65245	233410
1868	1555	33	applied	\N	\N	\N	\N	65246	65246	233411
1868	1556	34	applied	\N	\N	\N	\N	65247	65247	233412
1868	1557	35	applied	\N	\N	\N	\N	65248	65248	233413
1868	1558	36	applied	\N	\N	\N	\N	65249	65249	233414
1868	1559	37	applied	\N	\N	\N	\N	65250	65250	233415
1868	1560	38	applied	\N	\N	\N	\N	65251	65251	233416
1868	1561	39	applied	\N	\N	\N	\N	65252	65252	233417
1868	1562	40	applied	\N	\N	\N	\N	65253	65253	233418
1868	1563	41	applied	\N	\N	\N	\N	65254	65254	233419
1868	1565	42	applied	\N	\N	\N	\N	65255	65255	233420
1868	1566	43	applied	\N	\N	\N	\N	65256	65256	233421
1868	1567	44	applied	\N	\N	\N	\N	65257	65257	233422
1868	1568	45	applied	\N	\N	\N	\N	65258	65258	233423
1868	1569	46	applied	\N	\N	\N	\N	65259	65259	233424
1868	1570	47	applied	\N	\N	\N	\N	65260	65260	233425
1868	1573	49	applied	\N	\N	\N	\N	65262	65262	233427
1868	1574	50	applied	\N	\N	\N	\N	65263	65263	233428
1868	1575	51	applied	\N	\N	\N	\N	65264	65264	233429
1868	1576	52	applied	\N	\N	\N	\N	65265	65265	233430
1868	1577	53	applied	\N	\N	\N	\N	65266	65266	233431
1868	1578	54	applied	\N	\N	\N	\N	65267	65267	233432
1868	1579	55	applied	\N	\N	\N	\N	65268	65268	233433
1868	1580	56	applied	\N	\N	\N	\N	65269	65269	233434
1868	1581	57	applied	\N	\N	\N	\N	65270	65270	233435
1868	1582	58	applied	\N	\N	\N	\N	65271	65271	233436
1868	1583	59	applied	\N	\N	\N	\N	65272	65272	233437
1868	1584	60	applied	\N	\N	\N	\N	65273	65273	233438
1868	1585	61	applied	\N	\N	\N	\N	65274	65274	233439
1868	1586	62	applied	\N	\N	\N	\N	65275	65275	233440
1868	1587	63	applied	\N	\N	\N	\N	65276	65276	233441
1868	1588	64	applied	\N	\N	\N	\N	65277	65277	233442
1868	1590	66	applied	\N	\N	\N	\N	65279	65279	233444
1868	1591	67	applied	\N	\N	\N	\N	65280	65280	233445
1868	1592	68	applied	\N	\N	\N	\N	65281	65281	233446
1868	1593	69	applied	\N	\N	\N	\N	65282	65282	233447
1868	1594	70	applied	\N	\N	\N	\N	65283	65283	233448
1868	1595	71	applied	\N	\N	\N	\N	65284	65284	233449
1868	1596	72	applied	\N	\N	\N	\N	65285	65285	233450
1868	1597	73	applied	\N	\N	\N	\N	65286	65286	233451
1868	1598	74	applied	\N	\N	\N	\N	65287	65287	233452
1868	1599	75	applied	\N	\N	\N	\N	65288	65288	233453
1868	1600	76	applied	\N	\N	\N	\N	65289	65289	233454
1868	1601	77	applied	\N	\N	\N	\N	65290	65290	233455
1868	1602	78	applied	\N	\N	\N	\N	65291	65291	233456
1868	1603	79	applied	\N	\N	\N	\N	65292	65292	233457
1871	1607	0	applied	\N	\N	\N	\N	65295	65295	233460
1872	1608	0	applied	\N	\N	\N	\N	65296	65296	233461
1873	1608	0	applied	\N	\N	\N	\N	65298	65298	233463
1873	1609	2	applied	\N	\N	\N	\N	65299	65299	233464
1874	1608	0	applied	\N	\N	\N	\N	65300	65300	233465
1874	1609	2	applied	\N	\N	\N	\N	65301	65301	233466
1875	1610	0	applied	\N	\N	\N	\N	65302	65302	233467
1876	1610	0	applied	\N	\N	\N	\N	65303	65303	233468
1877	1610	0	applied	\N	\N	\N	\N	65304	65304	233469
1878	1610	0	applied	\N	\N	\N	\N	65305	65305	233470
1879	1611	0	applied	\N	\N	\N	\N	65306	65306	233471
1879	1612	1	applied	\N	\N	\N	\N	65307	65307	233472
1880	1613	0	applied	\N	\N	\N	\N	65308	65308	233473
1881	1613	0	applied	\N	\N	\N	\N	65309	65309	233474
1882	1614	0	applied	\N	\N	\N	\N	65310	65310	233475
1883	1615	0	applied	\N	\N	\N	\N	65311	65311	233476
1884	1615	0	applied	\N	\N	\N	\N	65312	65312	233477
1885	1615	0	applied	\N	\N	\N	\N	65313	65313	233478
1886	1617	1	applied	\N	\N	\N	\N	65315	65315	233480
1887	1618	0	applied	\N	\N	\N	\N	65316	65316	233481
1888	1618	0	applied	\N	\N	\N	\N	65317	65317	233482
1889	1619	0	applied	\N	\N	\N	\N	65318	65318	233483
1890	1619	0	applied	\N	\N	\N	\N	65319	65319	233484
1891	1620	0	applied	\N	\N	\N	\N	65320	65320	233485
1892	1621	0	applied	\N	\N	\N	\N	65321	65321	233486
1893	1622	0	applied	\N	\N	\N	\N	65322	65322	233487
1894	1622	0	applied	\N	\N	\N	\N	65323	65323	233488
1895	1623	0	applied	\N	\N	\N	\N	65324	65324	233489
1896	1624	0	applied	\N	\N	\N	\N	65325	65325	233490
1896	1625	1	applied	\N	\N	\N	\N	65326	65326	233491
1896	1626	2	applied	\N	\N	\N	\N	65327	65327	233492
1897	1627	0	applied	\N	\N	\N	\N	65328	65328	233493
1898	1627	0	applied	\N	\N	\N	\N	65329	65329	233494
1899	1628	0	applied	\N	\N	\N	\N	65330	65330	233495
1899	1630	2	applied	\N	\N	\N	\N	65332	65332	233497
1900	1631	0	applied	\N	\N	\N	\N	65333	65333	233498
1901	1631	0	applied	\N	\N	\N	\N	65334	65334	233499
1902	1631	0	applied	\N	\N	\N	\N	65335	65335	233500
1903	1632	0	applied	\N	\N	\N	\N	65336	65336	233501
1904	1632	0	applied	\N	\N	\N	\N	65337	65337	233502
1905	1633	0	applied	\N	\N	\N	\N	65338	65338	233503
1906	1633	0	applied	\N	\N	\N	\N	65339	65339	233504
1907	1633	0	applied	\N	\N	\N	\N	65340	65340	233505
1908	1634	0	applied	\N	\N	\N	\N	65341	65341	233506
1909	1634	0	applied	\N	\N	\N	\N	65342	65342	233507
1910	1634	0	applied	\N	\N	\N	\N	65343	65343	233508
1911	1635	0	applied	\N	\N	\N	\N	65344	65344	233509
1911	1636	1	applied	\N	\N	\N	\N	65345	65345	233510
1868	1534	12	applied	\N	\N	\N	\N	65225	65225	233390
1868	1535	13	applied	\N	\N	\N	\N	65226	65226	233391
1914	1641	1	applied	\N	\N	\N	\N	65350	65350	233515
1915	1640	0	applied	\N	\N	\N	\N	65351	65351	233516
1915	1641	1	applied	\N	\N	\N	\N	65352	65352	233517
1916	1642	0	applied	\N	\N	\N	\N	65353	65353	233518
1917	1643	0	applied	\N	\N	\N	\N	65354	65354	233519
1918	1644	0	applied	\N	\N	\N	\N	65355	65355	233520
1919	1644	0	applied	\N	\N	\N	\N	65356	65356	233521
1920	1644	0	applied	\N	\N	\N	\N	65357	65357	233522
1921	1644	0	applied	\N	\N	\N	\N	65358	65358	233523
1922	1645	0	applied	\N	\N	\N	\N	65359	65359	233524
1923	1645	0	applied	\N	\N	\N	\N	65360	65360	233525
1924	1645	0	applied	\N	\N	\N	\N	65361	65361	233526
1925	1645	0	applied	\N	\N	\N	\N	65362	65362	233527
1926	1646	0	applied	\N	\N	\N	\N	65363	65363	233528
1926	1647	1	applied	\N	\N	\N	\N	65364	65364	233529
1926	1648	2	applied	\N	\N	\N	\N	65365	65365	233530
1927	1647	1	applied	\N	\N	\N	\N	65367	65367	233532
1927	1648	2	applied	\N	\N	\N	\N	65368	65368	233533
1928	1646	0	applied	\N	\N	\N	\N	65369	65369	233534
1928	1647	1	applied	\N	\N	\N	\N	65370	65370	233535
1928	1648	2	applied	\N	\N	\N	\N	65371	65371	233536
1929	1649	0	applied	\N	\N	\N	\N	65372	65372	233537
1930	1649	0	applied	\N	\N	\N	\N	65373	65373	233538
1931	1650	0	applied	\N	\N	\N	\N	65374	65374	233539
1931	1651	1	applied	\N	\N	\N	\N	65375	65375	233540
1932	1652	0	applied	\N	\N	\N	\N	65376	65376	233541
1933	1652	0	applied	\N	\N	\N	\N	65377	65377	233542
1934	1652	0	applied	\N	\N	\N	\N	65378	65378	233543
1935	1650	0	applied	\N	\N	\N	\N	65379	65379	233544
1935	1651	1	applied	\N	\N	\N	\N	65380	65380	233545
1935	1652	2	applied	\N	\N	\N	\N	65381	65381	233546
1936	1653	0	applied	\N	\N	\N	\N	65382	65382	233547
1938	1653	0	applied	\N	\N	\N	\N	65384	65384	233549
1939	1654	0	applied	\N	\N	\N	\N	65385	65385	233550
1942	1655	0	applied	\N	\N	\N	\N	65388	65388	233553
1942	1656	1	applied	\N	\N	\N	\N	65389	65389	233554
1946	1636	0	applied	\N	\N	\N	\N	65394	65394	233559
1946	1610	1	applied	\N	\N	\N	\N	65395	65395	233560
1946	1611	2	applied	\N	\N	\N	\N	65396	65396	233561
1946	1612	3	applied	\N	\N	\N	\N	65397	65397	233562
1946	1613	4	applied	\N	\N	\N	\N	65398	65398	233563
1946	1614	5	applied	\N	\N	\N	\N	65399	65399	233564
1946	1615	6	applied	\N	\N	\N	\N	65400	65400	233565
1946	1616	7	applied	\N	\N	\N	\N	65401	65401	233566
1946	1617	8	applied	\N	\N	\N	\N	65402	65402	233567
1946	1618	9	applied	\N	\N	\N	\N	65403	65403	233568
1946	1619	10	applied	\N	\N	\N	\N	65404	65404	233569
1946	1620	11	applied	\N	\N	\N	\N	65405	65405	233570
1946	1622	13	applied	\N	\N	\N	\N	65407	65407	233572
1946	1623	14	applied	\N	\N	\N	\N	65408	65408	233573
1946	1624	15	applied	\N	\N	\N	\N	65409	65409	233574
1946	1625	16	applied	\N	\N	\N	\N	65410	65410	233575
1946	1626	17	applied	\N	\N	\N	\N	65411	65411	233576
1946	1627	18	applied	\N	\N	\N	\N	65412	65412	233577
1946	1628	19	applied	\N	\N	\N	\N	65413	65413	233578
1946	1629	20	applied	\N	\N	\N	\N	65414	65414	233579
1946	1630	21	applied	\N	\N	\N	\N	65415	65415	233580
1946	1631	22	applied	\N	\N	\N	\N	65416	65416	233581
1946	1632	23	applied	\N	\N	\N	\N	65417	65417	233582
1946	1633	24	applied	\N	\N	\N	\N	65418	65418	233583
1946	1634	25	applied	\N	\N	\N	\N	65419	65419	233584
1946	1635	26	applied	\N	\N	\N	\N	65420	65420	233585
1946	1637	27	applied	\N	\N	\N	\N	65421	65421	233586
1946	1638	28	applied	\N	\N	\N	\N	65422	65422	233587
1946	1640	30	applied	\N	\N	\N	\N	65424	65424	233589
1946	1642	31	applied	\N	\N	\N	\N	65425	65425	233590
1946	1643	32	applied	\N	\N	\N	\N	65426	65426	233591
1946	1644	33	applied	\N	\N	\N	\N	65427	65427	233592
1946	1645	34	applied	\N	\N	\N	\N	65428	65428	233593
1946	1646	35	applied	\N	\N	\N	\N	65429	65429	233594
1946	1647	36	applied	\N	\N	\N	\N	65430	65430	233595
1946	1648	37	applied	\N	\N	\N	\N	65431	65431	233596
1946	1649	38	applied	\N	\N	\N	\N	65432	65432	233597
1946	1650	39	applied	\N	\N	\N	\N	65433	65433	233598
1946	1651	40	applied	\N	\N	\N	\N	65434	65434	233599
1946	1652	41	applied	\N	\N	\N	\N	65435	65435	233600
1946	1653	42	applied	\N	\N	\N	\N	65436	65436	233601
1946	1654	43	applied	\N	\N	\N	\N	65437	65437	233602
1946	1655	44	applied	\N	\N	\N	\N	65438	65438	233603
1946	1656	45	applied	\N	\N	\N	\N	65439	65439	233604
1948	1658	0	applied	\N	\N	\N	\N	65442	65442	233607
1948	1659	1	applied	\N	\N	\N	\N	65443	65443	233608
1950	1660	0	applied	\N	\N	\N	\N	65445	65445	233610
1951	1660	0	applied	\N	\N	\N	\N	65446	65446	233611
1954	1661	0	applied	\N	\N	\N	\N	65449	65449	233614
1957	1664	0	applied	\N	\N	\N	\N	65454	65454	233619
1959	1664	0	applied	\N	\N	\N	\N	65456	65456	233621
1960	1665	0	applied	\N	\N	\N	\N	65457	65457	233622
1960	1666	1	applied	\N	\N	\N	\N	65458	65458	233623
1965	1667	0	applied	\N	\N	\N	\N	65464	65464	233629
1966	1668	0	applied	\N	\N	\N	\N	65465	65465	233630
1966	1669	1	applied	\N	\N	\N	\N	65466	65466	233631
1966	1670	2	applied	\N	\N	\N	\N	65467	65467	233632
1966	1671	3	applied	\N	\N	\N	\N	65468	65468	233633
1966	1672	4	applied	\N	\N	\N	\N	65469	65469	233634
1966	1673	5	applied	\N	\N	\N	\N	65470	65470	233635
1968	1675	1	applied	\N	\N	\N	\N	65474	65474	233639
1972	1677	0	applied	\N	\N	\N	\N	65479	65479	233644
1978	1679	0	applied	\N	\N	\N	\N	65609	65609	233774
1981	1683	0	applied	\N	\N	\N	\N	65614	65614	233779
1984	1685	0	applied	\N	\N	\N	\N	65617	65617	233782
1984	1686	1	applied	\N	\N	\N	\N	65618	65618	233783
1988	1688	0	applied	\N	\N	\N	\N	65623	65623	233788
1990	1689	0	applied	\N	\N	\N	\N	65625	65625	233790
1994	1691	0	applied	\N	\N	\N	\N	65629	65629	233794
1998	1694	0	applied	\N	\N	\N	\N	65635	65635	233800
2004	1697	0	applied	\N	\N	\N	\N	65693	65693	233858
2004	1698	1	applied	\N	\N	\N	\N	65694	65694	233859
2008	1699	0	applied	\N	\N	\N	\N	65701	65701	233866
2008	1700	1	applied	\N	\N	\N	\N	65702	65702	233867
1912	1638	0	applied	\N	\N	\N	\N	65347	65347	233512
1913	1639	0	applied	\N	\N	\N	\N	65348	65348	233513
1947	1657	0	applied	\N	\N	\N	\N	65441	65441	233606
1953	1661	0	applied	\N	\N	\N	\N	65448	65448	233613
1956	1662	0	applied	\N	\N	\N	\N	65452	65452	233617
1956	1663	1	applied	\N	\N	\N	\N	65453	65453	233618
1958	1664	0	applied	\N	\N	\N	\N	65455	65455	233620
1962	1667	0	applied	\N	\N	\N	\N	65461	65461	233626
1971	1676	0	applied	\N	\N	\N	\N	65478	65478	233643
1973	1677	0	applied	\N	\N	\N	\N	65480	65480	233645
1975	1636	0	applied	\N	\N	\N	\N	65482	65482	233647
1975	1515	1	applied	\N	\N	\N	\N	65483	65483	233648
1975	1516	2	applied	\N	\N	\N	\N	65484	65484	233649
1975	1517	3	applied	\N	\N	\N	\N	65485	65485	233650
1975	1518	4	applied	\N	\N	\N	\N	65486	65486	233651
1975	1519	5	applied	\N	\N	\N	\N	65487	65487	233652
1975	1520	6	applied	\N	\N	\N	\N	65488	65488	233653
1975	1521	7	applied	\N	\N	\N	\N	65489	65489	233654
1975	1523	9	applied	\N	\N	\N	\N	65491	65491	233656
1975	1524	10	applied	\N	\N	\N	\N	65492	65492	233657
1975	1525	11	applied	\N	\N	\N	\N	65493	65493	233658
1975	1526	12	applied	\N	\N	\N	\N	65494	65494	233659
1975	1527	13	applied	\N	\N	\N	\N	65495	65495	233660
1975	1528	14	applied	\N	\N	\N	\N	65496	65496	233661
1975	1529	15	applied	\N	\N	\N	\N	65497	65497	233662
1975	1530	16	applied	\N	\N	\N	\N	65498	65498	233663
1975	1531	17	applied	\N	\N	\N	\N	65499	65499	233664
1975	1532	18	applied	\N	\N	\N	\N	65500	65500	233665
1975	1533	19	applied	\N	\N	\N	\N	65501	65501	233666
1975	1534	20	applied	\N	\N	\N	\N	65502	65502	233667
1975	1535	21	applied	\N	\N	\N	\N	65503	65503	233668
1975	1536	22	applied	\N	\N	\N	\N	65504	65504	233669
1975	1537	23	applied	\N	\N	\N	\N	65505	65505	233670
1975	1538	24	applied	\N	\N	\N	\N	65506	65506	233671
1975	1540	26	applied	\N	\N	\N	\N	65508	65508	233673
1975	1541	27	applied	\N	\N	\N	\N	65509	65509	233674
1975	1542	28	applied	\N	\N	\N	\N	65510	65510	233675
1975	1543	29	applied	\N	\N	\N	\N	65511	65511	233676
1975	1544	30	applied	\N	\N	\N	\N	65512	65512	233677
1975	1545	31	applied	\N	\N	\N	\N	65513	65513	233678
1975	1546	32	applied	\N	\N	\N	\N	65514	65514	233679
1975	1547	33	applied	\N	\N	\N	\N	65515	65515	233680
1975	1548	34	applied	\N	\N	\N	\N	65516	65516	233681
1975	1549	35	applied	\N	\N	\N	\N	65517	65517	233682
1975	1550	36	applied	\N	\N	\N	\N	65518	65518	233683
1975	1551	37	applied	\N	\N	\N	\N	65519	65519	233684
1975	1552	38	applied	\N	\N	\N	\N	65520	65520	233685
1975	1553	39	applied	\N	\N	\N	\N	65521	65521	233686
1975	1554	40	applied	\N	\N	\N	\N	65522	65522	233687
1975	1555	41	applied	\N	\N	\N	\N	65523	65523	233688
1975	1557	44	applied	\N	\N	\N	\N	65525	65525	233690
1975	1558	45	applied	\N	\N	\N	\N	65526	65526	233691
1975	1559	46	applied	\N	\N	\N	\N	65527	65527	233692
1975	1560	47	applied	\N	\N	\N	\N	65528	65528	233693
1975	1561	48	applied	\N	\N	\N	\N	65529	65529	233694
1975	1562	49	applied	\N	\N	\N	\N	65530	65530	233695
1975	1563	50	applied	\N	\N	\N	\N	65531	65531	233696
1975	1565	51	applied	\N	\N	\N	\N	65532	65532	233697
1975	1566	52	applied	\N	\N	\N	\N	65533	65533	233698
1975	1567	53	applied	\N	\N	\N	\N	65534	65534	233699
1975	1568	54	applied	\N	\N	\N	\N	65535	65535	233700
1975	1569	55	applied	\N	\N	\N	\N	65536	65536	233701
1975	1570	56	applied	\N	\N	\N	\N	65537	65537	233702
1975	1572	57	applied	\N	\N	\N	\N	65538	65538	233703
1975	1573	58	applied	\N	\N	\N	\N	65539	65539	233704
1975	1574	59	applied	\N	\N	\N	\N	65540	65540	233705
1975	1576	61	applied	\N	\N	\N	\N	65542	65542	233707
1975	1577	62	applied	\N	\N	\N	\N	65543	65543	233708
1975	1578	63	applied	\N	\N	\N	\N	65544	65544	233709
1975	1579	64	applied	\N	\N	\N	\N	65545	65545	233710
1975	1580	65	applied	\N	\N	\N	\N	65546	65546	233711
1975	1581	66	applied	\N	\N	\N	\N	65547	65547	233712
1975	1582	67	applied	\N	\N	\N	\N	65548	65548	233713
1975	1583	68	applied	\N	\N	\N	\N	65549	65549	233714
1975	1584	69	applied	\N	\N	\N	\N	65550	65550	233715
2008	1701	2	applied	\N	\N	\N	\N	65703	65703	233868
2011	1578	0	applied	\N	\N	\N	\N	65706	65706	233871
2011	1636	1	applied	\N	\N	\N	\N	65707	65707	233872
2011	1579	2	applied	\N	\N	\N	\N	65708	65708	233873
2011	1580	3	applied	\N	\N	\N	\N	65709	65709	233874
2011	1581	4	applied	\N	\N	\N	\N	65710	65710	233875
2011	1582	5	applied	\N	\N	\N	\N	65711	65711	233876
2011	1584	7	applied	\N	\N	\N	\N	65713	65713	233878
2011	1585	8	applied	\N	\N	\N	\N	65714	65714	233879
2011	1586	9	applied	\N	\N	\N	\N	65715	65715	233880
2011	1587	10	applied	\N	\N	\N	\N	65716	65716	233881
2011	1588	11	applied	\N	\N	\N	\N	65717	65717	233882
2011	1589	12	applied	\N	\N	\N	\N	65718	65718	233883
2011	1590	13	applied	\N	\N	\N	\N	65719	65719	233884
2011	1591	14	applied	\N	\N	\N	\N	65720	65720	233885
2011	1592	15	applied	\N	\N	\N	\N	65721	65721	233886
2011	1593	16	applied	\N	\N	\N	\N	65722	65722	233887
2011	1594	17	applied	\N	\N	\N	\N	65723	65723	233888
2011	1595	18	applied	\N	\N	\N	\N	65724	65724	233889
2011	1596	19	applied	\N	\N	\N	\N	65725	65725	233890
2011	1597	20	applied	\N	\N	\N	\N	65726	65726	233891
2011	1598	21	applied	\N	\N	\N	\N	65727	65727	233892
2011	1599	22	applied	\N	\N	\N	\N	65728	65728	233893
2011	1601	24	applied	\N	\N	\N	\N	65730	65730	233895
2011	1602	25	applied	\N	\N	\N	\N	65731	65731	233896
2011	1603	26	applied	\N	\N	\N	\N	65732	65732	233897
2011	1604	27	applied	\N	\N	\N	\N	65733	65733	233898
2011	1605	28	applied	\N	\N	\N	\N	65734	65734	233899
2011	1606	29	applied	\N	\N	\N	\N	65735	65735	233900
2011	1607	30	applied	\N	\N	\N	\N	65736	65736	233901
2011	1608	31	applied	\N	\N	\N	\N	65737	65737	233902
2011	1609	32	applied	\N	\N	\N	\N	65738	65738	233903
2011	1610	33	applied	\N	\N	\N	\N	65739	65739	233904
2011	1611	34	applied	\N	\N	\N	\N	65740	65740	233905
2011	1612	35	applied	\N	\N	\N	\N	65741	65741	233906
2011	1613	36	applied	\N	\N	\N	\N	65742	65742	233907
2011	1614	37	applied	\N	\N	\N	\N	65743	65743	233908
1943	1655	0	applied	\N	\N	\N	\N	65390	65390	233555
1943	1656	1	applied	\N	\N	\N	\N	65391	65391	233556
1955	1662	0	applied	\N	\N	\N	\N	65450	65450	233615
1955	1663	1	applied	\N	\N	\N	\N	65451	65451	233616
1961	1665	0	applied	\N	\N	\N	\N	65459	65459	233624
1961	1666	1	applied	\N	\N	\N	\N	65460	65460	233625
1963	1667	0	applied	\N	\N	\N	\N	65462	65462	233627
1964	1667	0	applied	\N	\N	\N	\N	65463	65463	233628
1967	1674	0	applied	\N	\N	\N	\N	65471	65471	233636
1967	1675	1	applied	\N	\N	\N	\N	65472	65472	233637
1969	1674	0	applied	\N	\N	\N	\N	65475	65475	233640
1969	1675	1	applied	\N	\N	\N	\N	65476	65476	233641
1970	1676	0	applied	\N	\N	\N	\N	65477	65477	233642
1974	1677	0	applied	\N	\N	\N	\N	65481	65481	233646
1975	1585	70	applied	\N	\N	\N	\N	65551	65551	233716
1975	1586	71	applied	\N	\N	\N	\N	65552	65552	233717
1975	1587	72	applied	\N	\N	\N	\N	65553	65553	233718
1975	1588	73	applied	\N	\N	\N	\N	65554	65554	233719
1975	1590	75	applied	\N	\N	\N	\N	65556	65556	233721
1975	1591	76	applied	\N	\N	\N	\N	65557	65557	233722
1975	1592	77	applied	\N	\N	\N	\N	65558	65558	233723
1975	1593	78	applied	\N	\N	\N	\N	65559	65559	233724
1975	1594	79	applied	\N	\N	\N	\N	65560	65560	233725
1975	1595	80	applied	\N	\N	\N	\N	65561	65561	233726
1975	1596	81	applied	\N	\N	\N	\N	65562	65562	233727
1975	1597	82	applied	\N	\N	\N	\N	65563	65563	233728
1975	1598	83	applied	\N	\N	\N	\N	65564	65564	233729
1975	1599	84	applied	\N	\N	\N	\N	65565	65565	233730
1975	1600	85	applied	\N	\N	\N	\N	65566	65566	233731
1975	1601	86	applied	\N	\N	\N	\N	65567	65567	233732
1975	1602	87	applied	\N	\N	\N	\N	65568	65568	233733
1975	1603	88	applied	\N	\N	\N	\N	65569	65569	233734
1975	1604	89	applied	\N	\N	\N	\N	65570	65570	233735
1975	1605	90	applied	\N	\N	\N	\N	65571	65571	233736
1975	1607	92	applied	\N	\N	\N	\N	65573	65573	233738
1975	1608	93	applied	\N	\N	\N	\N	65574	65574	233739
1975	1609	94	applied	\N	\N	\N	\N	65575	65575	233740
1975	1610	95	applied	\N	\N	\N	\N	65576	65576	233741
1975	1611	96	applied	\N	\N	\N	\N	65577	65577	233742
1975	1612	97	applied	\N	\N	\N	\N	65578	65578	233743
1975	1613	98	applied	\N	\N	\N	\N	65579	65579	233744
1975	1614	99	applied	\N	\N	\N	\N	65580	65580	233745
1975	1615	100	applied	\N	\N	\N	\N	65581	65581	233746
1975	1616	101	applied	\N	\N	\N	\N	65582	65582	233747
1975	1617	102	applied	\N	\N	\N	\N	65583	65583	233748
1975	1618	103	applied	\N	\N	\N	\N	65584	65584	233749
1975	1619	104	applied	\N	\N	\N	\N	65585	65585	233750
1975	1620	105	applied	\N	\N	\N	\N	65586	65586	233751
1975	1621	106	applied	\N	\N	\N	\N	65587	65587	233752
1975	1622	107	applied	\N	\N	\N	\N	65588	65588	233753
1976	1678	0	applied	\N	\N	\N	\N	65607	65607	233772
1979	1680	0	applied	\N	\N	\N	\N	65610	65610	233775
1979	1681	1	applied	\N	\N	\N	\N	65611	65611	233776
1979	1682	2	applied	\N	\N	\N	\N	65612	65612	233777
1985	1685	0	applied	\N	\N	\N	\N	65619	65619	233784
1985	1686	1	applied	\N	\N	\N	\N	65620	65620	233785
1987	1688	0	applied	\N	\N	\N	\N	65622	65622	233787
1989	1688	0	applied	\N	\N	\N	\N	65624	65624	233789
1992	1689	0	applied	\N	\N	\N	\N	65627	65627	233792
1997	1692	0	applied	\N	\N	\N	\N	65633	65633	233798
1997	1693	1	applied	\N	\N	\N	\N	65634	65634	233799
2000	1695	0	applied	\N	\N	\N	\N	65637	65637	233802
2002	1643	0	applied	\N	\N	\N	\N	65639	65639	233804
2002	1644	1	applied	\N	\N	\N	\N	65640	65640	233805
2002	1645	2	applied	\N	\N	\N	\N	65641	65641	233806
2002	1646	3	applied	\N	\N	\N	\N	65642	65642	233807
2002	1648	5	applied	\N	\N	\N	\N	65644	65644	233809
2002	1649	6	applied	\N	\N	\N	\N	65645	65645	233810
2002	1650	7	applied	\N	\N	\N	\N	65646	65646	233811
2002	1651	8	applied	\N	\N	\N	\N	65647	65647	233812
2002	1652	9	applied	\N	\N	\N	\N	65648	65648	233813
2002	1653	10	applied	\N	\N	\N	\N	65649	65649	233814
2002	1654	11	applied	\N	\N	\N	\N	65650	65650	233815
2002	1655	12	applied	\N	\N	\N	\N	65651	65651	233816
2002	1656	13	applied	\N	\N	\N	\N	65652	65652	233817
2002	1657	14	applied	\N	\N	\N	\N	65653	65653	233818
2002	1658	15	applied	\N	\N	\N	\N	65654	65654	233819
2002	1659	16	applied	\N	\N	\N	\N	65655	65655	233820
2002	1660	17	applied	\N	\N	\N	\N	65656	65656	233821
2002	1661	18	applied	\N	\N	\N	\N	65657	65657	233822
2002	1662	19	applied	\N	\N	\N	\N	65658	65658	233823
2002	1663	20	applied	\N	\N	\N	\N	65659	65659	233824
2002	1665	22	applied	\N	\N	\N	\N	65661	65661	233826
2002	1666	23	applied	\N	\N	\N	\N	65662	65662	233827
2002	1667	24	applied	\N	\N	\N	\N	65663	65663	233828
2002	1668	25	applied	\N	\N	\N	\N	65664	65664	233829
2002	1669	26	applied	\N	\N	\N	\N	65665	65665	233830
2002	1670	27	applied	\N	\N	\N	\N	65666	65666	233831
2002	1671	28	applied	\N	\N	\N	\N	65667	65667	233832
2002	1672	29	applied	\N	\N	\N	\N	65668	65668	233833
2002	1673	30	applied	\N	\N	\N	\N	65669	65669	233834
2002	1674	31	applied	\N	\N	\N	\N	65670	65670	233835
2002	1675	32	applied	\N	\N	\N	\N	65671	65671	233836
2002	1676	33	applied	\N	\N	\N	\N	65672	65672	233837
2002	1677	34	applied	\N	\N	\N	\N	65673	65673	233838
2002	1678	35	applied	\N	\N	\N	\N	65674	65674	233839
2002	1679	36	applied	\N	\N	\N	\N	65675	65675	233840
2002	1680	37	applied	\N	\N	\N	\N	65676	65676	233841
2002	1682	39	applied	\N	\N	\N	\N	65678	65678	233843
2002	1683	40	applied	\N	\N	\N	\N	65679	65679	233844
2002	1684	41	applied	\N	\N	\N	\N	65680	65680	233845
2002	1685	43	applied	\N	\N	\N	\N	65681	65681	233846
2002	1686	44	applied	\N	\N	\N	\N	65682	65682	233847
2002	1687	45	applied	\N	\N	\N	\N	65683	65683	233848
2002	1688	46	applied	\N	\N	\N	\N	65684	65684	233849
2002	1689	47	applied	\N	\N	\N	\N	65685	65685	233850
2002	1690	48	applied	\N	\N	\N	\N	65686	65686	233851
2002	1691	49	applied	\N	\N	\N	\N	65687	65687	233852
2002	1692	50	applied	\N	\N	\N	\N	65688	65688	233853
2002	1693	51	applied	\N	\N	\N	\N	65689	65689	233854
2002	1694	52	applied	\N	\N	\N	\N	65690	65690	233855
2002	1695	53	applied	\N	\N	\N	\N	65691	65691	233856
1945	1657	0	applied	\N	\N	\N	\N	65393	65393	233558
1949	1660	0	applied	\N	\N	\N	\N	65444	65444	233609
1975	1628	113	applied	\N	\N	\N	\N	65594	65594	233759
1975	1629	114	applied	\N	\N	\N	\N	65595	65595	233760
1975	1630	115	applied	\N	\N	\N	\N	65596	65596	233761
1975	1631	116	applied	\N	\N	\N	\N	65597	65597	233762
1975	1632	117	applied	\N	\N	\N	\N	65598	65598	233763
1975	1633	118	applied	\N	\N	\N	\N	65599	65599	233764
1975	1634	119	applied	\N	\N	\N	\N	65600	65600	233765
1975	1635	120	applied	\N	\N	\N	\N	65601	65601	233766
1975	1637	121	applied	\N	\N	\N	\N	65602	65602	233767
1975	1638	122	applied	\N	\N	\N	\N	65603	65603	233768
1975	1639	123	applied	\N	\N	\N	\N	65604	65604	233769
1975	1640	124	applied	\N	\N	\N	\N	65605	65605	233770
1975	1642	125	applied	\N	\N	\N	\N	65606	65606	233771
1977	1679	0	applied	\N	\N	\N	\N	65608	65608	233773
1980	1683	0	applied	\N	\N	\N	\N	65613	65613	233778
1982	1683	0	applied	\N	\N	\N	\N	65615	65615	233780
1986	1687	0	applied	\N	\N	\N	\N	65621	65621	233786
1991	1689	0	applied	\N	\N	\N	\N	65626	65626	233791
1993	1690	0	applied	\N	\N	\N	\N	65628	65628	233793
1995	1691	0	applied	\N	\N	\N	\N	65630	65630	233795
1996	1692	0	applied	\N	\N	\N	\N	65631	65631	233796
1996	1693	1	applied	\N	\N	\N	\N	65632	65632	233797
1999	1695	0	applied	\N	\N	\N	\N	65636	65636	233801
2001	1695	0	applied	\N	\N	\N	\N	65638	65638	233803
2003	1696	0	applied	\N	\N	\N	\N	65692	65692	233857
2005	1697	0	applied	\N	\N	\N	\N	65695	65695	233860
2005	1698	1	applied	\N	\N	\N	\N	65696	65696	233861
2006	1697	0	applied	\N	\N	\N	\N	65697	65697	233862
2006	1698	1	applied	\N	\N	\N	\N	65698	65698	233863
2007	1697	0	applied	\N	\N	\N	\N	65699	65699	233864
2007	1698	1	applied	\N	\N	\N	\N	65700	65700	233865
2009	1702	0	applied	\N	\N	\N	\N	65704	65704	233869
2011	1615	38	applied	\N	\N	\N	\N	65744	65744	233909
2011	1616	39	applied	\N	\N	\N	\N	65745	65745	233910
2011	1617	40	applied	\N	\N	\N	\N	65746	65746	233911
2011	1618	41	applied	\N	\N	\N	\N	65747	65747	233912
2011	1619	42	applied	\N	\N	\N	\N	65748	65748	233913
2011	1620	43	applied	\N	\N	\N	\N	65749	65749	233914
2011	1621	44	applied	\N	\N	\N	\N	65750	65750	233915
2011	1622	45	applied	\N	\N	\N	\N	65751	65751	233916
2011	1623	46	applied	\N	\N	\N	\N	65752	65752	233917
2011	1624	47	applied	\N	\N	\N	\N	65753	65753	233918
2011	1625	48	applied	\N	\N	\N	\N	65754	65754	233919
2011	1626	49	applied	\N	\N	\N	\N	65755	65755	233920
2011	1627	50	applied	\N	\N	\N	\N	65756	65756	233921
2011	1628	51	applied	\N	\N	\N	\N	65757	65757	233922
2011	1629	52	applied	\N	\N	\N	\N	65758	65758	233923
2011	1630	53	applied	\N	\N	\N	\N	65759	65759	233924
2011	1632	55	applied	\N	\N	\N	\N	65761	65761	233926
2011	1633	56	applied	\N	\N	\N	\N	65762	65762	233927
2011	1634	57	applied	\N	\N	\N	\N	65763	65763	233928
2011	1635	58	applied	\N	\N	\N	\N	65764	65764	233929
2011	1637	59	applied	\N	\N	\N	\N	65765	65765	233930
2011	1638	60	applied	\N	\N	\N	\N	65766	65766	233931
2011	1639	61	applied	\N	\N	\N	\N	65767	65767	233932
2011	1640	62	applied	\N	\N	\N	\N	65768	65768	233933
2011	1642	63	applied	\N	\N	\N	\N	65769	65769	233934
2011	1643	64	applied	\N	\N	\N	\N	65770	65770	233935
2011	1644	65	applied	\N	\N	\N	\N	65771	65771	233936
2011	1645	66	applied	\N	\N	\N	\N	65772	65772	233937
2011	1646	67	applied	\N	\N	\N	\N	65773	65773	233938
2011	1647	68	applied	\N	\N	\N	\N	65774	65774	233939
2011	1648	69	applied	\N	\N	\N	\N	65775	65775	233940
2011	1649	70	applied	\N	\N	\N	\N	65776	65776	233941
2011	1651	72	applied	\N	\N	\N	\N	65778	65778	233943
2011	1652	73	applied	\N	\N	\N	\N	65779	65779	233944
2011	1653	74	applied	\N	\N	\N	\N	65780	65780	233945
2011	1654	75	applied	\N	\N	\N	\N	65781	65781	233946
2011	1655	76	applied	\N	\N	\N	\N	65782	65782	233947
2011	1656	77	applied	\N	\N	\N	\N	65783	65783	233948
2011	1657	78	applied	\N	\N	\N	\N	65784	65784	233949
2011	1658	79	applied	\N	\N	\N	\N	65785	65785	233950
2011	1659	80	applied	\N	\N	\N	\N	65786	65786	233951
2012	1703	0	applied	\N	\N	\N	\N	65787	65787	233952
2013	1703	0	applied	\N	\N	\N	\N	65788	65788	233953
2014	1703	0	applied	\N	\N	\N	\N	65789	65789	233954
2015	1704	0	applied	\N	\N	\N	\N	65790	65790	233955
2015	1705	1	applied	\N	\N	\N	\N	65791	65791	233956
2015	1706	2	applied	\N	\N	\N	\N	65792	65792	233957
2016	1704	0	applied	\N	\N	\N	\N	65793	65793	233958
2016	1706	2	applied	\N	\N	\N	\N	65795	65795	233960
2017	1707	0	applied	\N	\N	\N	\N	65796	65796	233961
2018	1708	0	applied	\N	\N	\N	\N	65797	65797	233962
2019	1708	0	applied	\N	\N	\N	\N	65798	65798	233963
2020	1708	0	applied	\N	\N	\N	\N	65799	65799	233964
2021	1709	0	applied	\N	\N	\N	\N	65800	65800	233965
2021	1710	1	applied	\N	\N	\N	\N	65801	65801	233966
2022	1709	0	applied	\N	\N	\N	\N	65802	65802	233967
2022	1710	1	applied	\N	\N	\N	\N	65803	65803	233968
2023	1709	0	applied	\N	\N	\N	\N	65804	65804	233969
2023	1710	1	applied	\N	\N	\N	\N	65805	65805	233970
2024	1711	0	applied	\N	\N	\N	\N	65806	65806	233971
2024	1712	1	applied	\N	\N	\N	\N	65807	65807	233972
2025	1713	0	applied	\N	\N	\N	\N	65808	65808	233973
2025	1714	1	applied	\N	\N	\N	\N	65809	65809	233974
2026	1713	0	applied	\N	\N	\N	\N	65810	65810	233975
2027	1715	0	applied	\N	\N	\N	\N	65812	65812	233977
2028	1716	0	applied	\N	\N	\N	\N	65813	65813	233978
2029	1717	0	applied	\N	\N	\N	\N	65814	65814	233979
2030	1717	0	applied	\N	\N	\N	\N	65815	65815	233980
2031	1718	0	applied	\N	\N	\N	\N	65816	65816	233981
2032	1718	0	applied	\N	\N	\N	\N	65817	65817	233982
2032	1719	1	applied	\N	\N	\N	\N	65818	65818	233983
2033	1718	0	applied	\N	\N	\N	\N	65819	65819	233984
2033	1719	1	applied	\N	\N	\N	\N	65820	65820	233985
2034	1718	0	applied	\N	\N	\N	\N	65821	65821	233986
2034	1719	1	applied	\N	\N	\N	\N	65822	65822	233987
2035	1720	0	applied	\N	\N	\N	\N	65823	65823	233988
2036	1721	0	applied	\N	\N	\N	\N	65824	65824	233989
2036	1722	1	applied	\N	\N	\N	\N	65825	65825	233990
1975	1625	110	applied	\N	\N	\N	\N	65591	65591	233756
1975	1626	111	applied	\N	\N	\N	\N	65592	65592	233757
2039	1725	0	applied	\N	\N	\N	\N	65830	65830	233995
2040	1726	0	applied	\N	\N	\N	\N	65831	65831	233996
2040	1727	1	applied	\N	\N	\N	\N	65832	65832	233997
2041	1726	0	applied	\N	\N	\N	\N	65833	65833	233998
2041	1727	1	applied	\N	\N	\N	\N	65834	65834	233999
2042	1728	0	applied	\N	\N	\N	\N	65835	65835	234000
2043	1729	0	applied	\N	\N	\N	\N	65836	65836	234001
2044	1729	0	applied	\N	\N	\N	\N	65837	65837	234002
2045	1655	0	applied	\N	\N	\N	\N	65838	65838	234003
2045	1656	1	applied	\N	\N	\N	\N	65839	65839	234004
2045	1657	2	applied	\N	\N	\N	\N	65840	65840	234005
2045	1658	3	applied	\N	\N	\N	\N	65841	65841	234006
2045	1659	4	applied	\N	\N	\N	\N	65842	65842	234007
2045	1660	5	applied	\N	\N	\N	\N	65843	65843	234008
2045	1661	6	applied	\N	\N	\N	\N	65844	65844	234009
2045	1662	7	applied	\N	\N	\N	\N	65845	65845	234010
2045	1664	9	applied	\N	\N	\N	\N	65847	65847	234012
2045	1665	10	applied	\N	\N	\N	\N	65848	65848	234013
2045	1666	11	applied	\N	\N	\N	\N	65849	65849	234014
2045	1667	12	applied	\N	\N	\N	\N	65850	65850	234015
2045	1668	14	applied	\N	\N	\N	\N	65851	65851	234016
2045	1669	15	applied	\N	\N	\N	\N	65852	65852	234017
2045	1670	16	applied	\N	\N	\N	\N	65853	65853	234018
2045	1671	17	applied	\N	\N	\N	\N	65854	65854	234019
2045	1672	18	applied	\N	\N	\N	\N	65855	65855	234020
2045	1673	19	applied	\N	\N	\N	\N	65856	65856	234021
2045	1674	20	applied	\N	\N	\N	\N	65857	65857	234022
2045	1675	21	applied	\N	\N	\N	\N	65858	65858	234023
2045	1676	22	applied	\N	\N	\N	\N	65859	65859	234024
2045	1677	23	applied	\N	\N	\N	\N	65860	65860	234025
2045	1678	24	applied	\N	\N	\N	\N	65861	65861	234026
2045	1679	25	applied	\N	\N	\N	\N	65862	65862	234027
2045	1681	27	applied	\N	\N	\N	\N	65864	65864	234029
2045	1682	28	applied	\N	\N	\N	\N	65865	65865	234030
2045	1683	29	applied	\N	\N	\N	\N	65866	65866	234031
2045	1684	30	applied	\N	\N	\N	\N	65867	65867	234032
2045	1685	31	applied	\N	\N	\N	\N	65868	65868	234033
2045	1686	32	applied	\N	\N	\N	\N	65869	65869	234034
2045	1687	33	applied	\N	\N	\N	\N	65870	65870	234035
2045	1688	34	applied	\N	\N	\N	\N	65871	65871	234036
2045	1689	35	applied	\N	\N	\N	\N	65872	65872	234037
2045	1690	36	applied	\N	\N	\N	\N	65873	65873	234038
2045	1691	37	applied	\N	\N	\N	\N	65874	65874	234039
2045	1692	38	applied	\N	\N	\N	\N	65875	65875	234040
2045	1693	39	applied	\N	\N	\N	\N	65876	65876	234041
2045	1694	40	applied	\N	\N	\N	\N	65877	65877	234042
2045	1695	41	applied	\N	\N	\N	\N	65878	65878	234043
2045	1696	42	applied	\N	\N	\N	\N	65879	65879	234044
2045	1698	44	applied	\N	\N	\N	\N	65881	65881	234046
2045	1699	45	applied	\N	\N	\N	\N	65882	65882	234047
2045	1700	46	applied	\N	\N	\N	\N	65883	65883	234048
2045	1701	47	applied	\N	\N	\N	\N	65884	65884	234049
2045	1702	48	applied	\N	\N	\N	\N	65885	65885	234050
2047	1736	0	applied	\N	\N	\N	\N	65892	65892	234057
2052	1739	0	applied	\N	\N	\N	\N	65898	65898	234063
2052	1740	1	applied	\N	\N	\N	\N	65899	65899	234064
2056	1742	0	applied	\N	\N	\N	\N	65903	65903	234068
2059	1743	0	applied	\N	\N	\N	\N	65906	65906	234071
2062	1746	0	applied	\N	\N	\N	\N	65909	65909	234074
2065	1747	0	applied	\N	\N	\N	\N	65912	65912	234077
2069	1749	0	applied	\N	\N	\N	\N	65916	65916	234081
2072	1751	0	applied	\N	\N	\N	\N	65919	65919	234084
2072	1752	1	applied	\N	\N	\N	\N	65920	65920	234085
2075	1753	0	applied	\N	\N	\N	\N	65924	65924	234089
2083	1756	0	applied	\N	\N	\N	\N	65932	65932	234097
2090	1765	0	applied	\N	\N	\N	\N	65942	65942	234107
2091	1766	0	applied	\N	\N	\N	\N	65943	65943	234108
2094	1766	0	applied	\N	\N	\N	\N	65946	65946	234111
2097	1767	0	applied	\N	\N	\N	\N	65951	65951	234116
2097	1768	1	applied	\N	\N	\N	\N	65952	65952	234117
2099	1771	0	applied	\N	\N	\N	\N	65955	65955	234120
2101	1772	0	applied	\N	\N	\N	\N	65957	65957	234122
2105	1773	0	applied	\N	\N	\N	\N	65961	65961	234126
2108	1774	0	applied	\N	\N	\N	\N	66088	66088	234253
2111	1775	0	applied	\N	\N	\N	\N	66091	66091	234256
2112	1776	0	applied	\N	\N	\N	\N	66092	66092	234257
2114	1777	0	applied	\N	\N	\N	\N	66094	66094	234259
2115	1778	0	applied	\N	\N	\N	\N	66095	66095	234260
2115	1779	1	applied	\N	\N	\N	\N	66096	66096	234261
2117	1780	0	applied	\N	\N	\N	\N	66099	66099	234264
2119	1782	0	applied	\N	\N	\N	\N	66102	66102	234267
2123	1784	0	applied	\N	\N	\N	\N	66106	66106	234271
2129	1790	0	applied	\N	\N	\N	\N	66114	66114	234279
2134	1793	0	applied	\N	\N	\N	\N	66119	66119	234284
2138	1794	0	applied	\N	\N	\N	\N	66125	66125	234290
2144	1797	0	applied	\N	\N	\N	\N	66131	66131	234296
2146	1799	0	applied	\N	\N	\N	\N	66133	66133	234298
2146	1800	1	applied	\N	\N	\N	\N	66134	66134	234299
2149	1804	0	applied	\N	\N	\N	\N	66138	66138	234303
2150	1805	0	applied	\N	\N	\N	\N	66139	66139	234304
2150	1806	1	applied	\N	\N	\N	\N	66140	66140	234305
2152	1805	0	applied	\N	\N	\N	\N	66141	66141	234306
2152	1806	1	applied	\N	\N	\N	\N	66142	66142	234307
2154	1808	0	applied	\N	\N	\N	\N	66144	66144	234309
2154	1809	1	applied	\N	\N	\N	\N	66145	66145	234310
2156	1810	0	applied	\N	\N	\N	\N	66146	66146	234311
2159	1810	0	applied	\N	\N	\N	\N	66152	66152	234317
2159	1811	1	applied	\N	\N	\N	\N	66153	66153	234318
2161	1812	0	applied	\N	\N	\N	\N	66155	66155	234320
2169	1815	0	applied	\N	\N	\N	\N	66165	66165	234330
2169	1816	1	applied	\N	\N	\N	\N	66166	66166	234331
2171	1817	0	applied	\N	\N	\N	\N	66168	66168	234333
2176	1821	0	applied	\N	\N	\N	\N	66174	66174	234339
2177	1822	0	applied	\N	\N	\N	\N	66175	66175	234340
2180	1826	0	applied	\N	\N	\N	\N	66180	66180	234345
2180	1827	1	applied	\N	\N	\N	\N	66181	66181	234346
2184	1828	0	applied	\N	\N	\N	\N	66186	66186	234351
2187	1829	0	applied	\N	\N	\N	\N	66202	66202	234367
2187	1830	1	applied	\N	\N	\N	\N	66203	66203	234368
2190	1832	0	applied	\N	\N	\N	\N	66206	66206	234371
2037	1722	1	applied	\N	\N	\N	\N	65827	65827	233992
2038	1723	0	applied	\N	\N	\N	\N	65828	65828	233993
2046	1734	4	applied	\N	\N	\N	\N	65890	65890	234055
2046	1735	5	applied	\N	\N	\N	\N	65891	65891	234056
2048	1737	0	applied	\N	\N	\N	\N	65893	65893	234058
2049	1737	0	applied	\N	\N	\N	\N	65894	65894	234059
2050	1738	0	applied	\N	\N	\N	\N	65895	65895	234060
2054	1741	0	applied	\N	\N	\N	\N	65901	65901	234066
2055	1742	0	applied	\N	\N	\N	\N	65902	65902	234067
2058	1743	0	applied	\N	\N	\N	\N	65905	65905	234070
2060	1744	0	applied	\N	\N	\N	\N	65907	65907	234072
2061	1745	0	applied	\N	\N	\N	\N	65908	65908	234073
2064	1746	0	applied	\N	\N	\N	\N	65911	65911	234076
2066	1748	0	applied	\N	\N	\N	\N	65913	65913	234078
2067	1748	0	applied	\N	\N	\N	\N	65914	65914	234079
2068	1749	0	applied	\N	\N	\N	\N	65915	65915	234080
2071	1750	0	applied	\N	\N	\N	\N	65918	65918	234083
2074	1753	0	applied	\N	\N	\N	\N	65923	65923	234088
2079	1755	0	applied	\N	\N	\N	\N	65928	65928	234093
2080	1755	0	applied	\N	\N	\N	\N	65929	65929	234094
2082	1756	0	applied	\N	\N	\N	\N	65931	65931	234096
2085	1757	0	applied	\N	\N	\N	\N	65934	65934	234099
2087	1759	0	applied	\N	\N	\N	\N	65936	65936	234101
2087	1760	1	applied	\N	\N	\N	\N	65937	65937	234102
2087	1761	2	applied	\N	\N	\N	\N	65938	65938	234103
2089	1762	0	applied	\N	\N	\N	\N	65939	65939	234104
2089	1763	1	applied	\N	\N	\N	\N	65940	65940	234105
2089	1764	2	applied	\N	\N	\N	\N	65941	65941	234106
2093	1766	0	applied	\N	\N	\N	\N	65945	65945	234110
2096	1767	0	applied	\N	\N	\N	\N	65949	65949	234114
2096	1768	1	applied	\N	\N	\N	\N	65950	65950	234115
2098	1769	0	applied	\N	\N	\N	\N	65953	65953	234118
2098	1770	1	applied	\N	\N	\N	\N	65954	65954	234119
2100	1772	0	applied	\N	\N	\N	\N	65956	65956	234121
2106	1773	0	applied	\N	\N	\N	\N	65962	65962	234127
2107	1619	0	applied	\N	\N	\N	\N	65963	65963	234128
2107	1620	1	applied	\N	\N	\N	\N	65964	65964	234129
2107	1621	2	applied	\N	\N	\N	\N	65965	65965	234130
2107	1636	3	applied	\N	\N	\N	\N	65966	65966	234131
2107	1622	4	applied	\N	\N	\N	\N	65967	65967	234132
2107	1623	5	applied	\N	\N	\N	\N	65968	65968	234133
2107	1624	6	applied	\N	\N	\N	\N	65969	65969	234134
2107	1625	7	applied	\N	\N	\N	\N	65970	65970	234135
2107	1626	8	applied	\N	\N	\N	\N	65971	65971	234136
2107	1627	9	applied	\N	\N	\N	\N	65972	65972	234137
2107	1628	10	applied	\N	\N	\N	\N	65973	65973	234138
2107	1629	11	applied	\N	\N	\N	\N	65974	65974	234139
2107	1630	12	applied	\N	\N	\N	\N	65975	65975	234140
2107	1631	13	applied	\N	\N	\N	\N	65976	65976	234141
2107	1632	14	applied	\N	\N	\N	\N	65977	65977	234142
2107	1634	16	applied	\N	\N	\N	\N	65979	65979	234144
2107	1635	17	applied	\N	\N	\N	\N	65980	65980	234145
2107	1637	18	applied	\N	\N	\N	\N	65981	65981	234146
2107	1638	19	applied	\N	\N	\N	\N	65982	65982	234147
2107	1639	20	applied	\N	\N	\N	\N	65983	65983	234148
2107	1640	21	applied	\N	\N	\N	\N	65984	65984	234149
2107	1642	22	applied	\N	\N	\N	\N	65985	65985	234150
2107	1643	23	applied	\N	\N	\N	\N	65986	65986	234151
2107	1644	24	applied	\N	\N	\N	\N	65987	65987	234152
2107	1645	25	applied	\N	\N	\N	\N	65988	65988	234153
2107	1646	26	applied	\N	\N	\N	\N	65989	65989	234154
2107	1647	27	applied	\N	\N	\N	\N	65990	65990	234155
2107	1648	28	applied	\N	\N	\N	\N	65991	65991	234156
2107	1649	29	applied	\N	\N	\N	\N	65992	65992	234157
2107	1650	30	applied	\N	\N	\N	\N	65993	65993	234158
2107	1651	31	applied	\N	\N	\N	\N	65994	65994	234159
2107	1653	33	applied	\N	\N	\N	\N	65996	65996	234161
2107	1654	34	applied	\N	\N	\N	\N	65997	65997	234162
2107	1655	35	applied	\N	\N	\N	\N	65998	65998	234163
2107	1656	36	applied	\N	\N	\N	\N	65999	65999	234164
2107	1657	37	applied	\N	\N	\N	\N	66000	66000	234165
2107	1658	38	applied	\N	\N	\N	\N	66001	66001	234166
2107	1659	39	applied	\N	\N	\N	\N	66002	66002	234167
2107	1660	40	applied	\N	\N	\N	\N	66003	66003	234168
2107	1661	41	applied	\N	\N	\N	\N	66004	66004	234169
2107	1662	42	applied	\N	\N	\N	\N	66005	66005	234170
2107	1663	43	applied	\N	\N	\N	\N	66006	66006	234171
2107	1664	44	applied	\N	\N	\N	\N	66007	66007	234172
2107	1665	45	applied	\N	\N	\N	\N	66008	66008	234173
2107	1666	46	applied	\N	\N	\N	\N	66009	66009	234174
2107	1667	47	applied	\N	\N	\N	\N	66010	66010	234175
2107	1668	48	applied	\N	\N	\N	\N	66011	66011	234176
2107	1670	50	applied	\N	\N	\N	\N	66013	66013	234178
2107	1671	51	applied	\N	\N	\N	\N	66014	66014	234179
2107	1672	52	applied	\N	\N	\N	\N	66015	66015	234180
2107	1673	53	applied	\N	\N	\N	\N	66016	66016	234181
2107	1674	54	applied	\N	\N	\N	\N	66017	66017	234182
2107	1675	55	applied	\N	\N	\N	\N	66018	66018	234183
2107	1676	56	applied	\N	\N	\N	\N	66019	66019	234184
2107	1677	57	applied	\N	\N	\N	\N	66020	66020	234185
2107	1678	58	applied	\N	\N	\N	\N	66021	66021	234186
2107	1679	59	applied	\N	\N	\N	\N	66022	66022	234187
2107	1680	60	applied	\N	\N	\N	\N	66023	66023	234188
2107	1681	61	applied	\N	\N	\N	\N	66024	66024	234189
2107	1682	62	applied	\N	\N	\N	\N	66025	66025	234190
2107	1683	63	applied	\N	\N	\N	\N	66026	66026	234191
2107	1684	64	applied	\N	\N	\N	\N	66027	66027	234192
2107	1685	65	applied	\N	\N	\N	\N	66028	66028	234193
2107	1687	67	applied	\N	\N	\N	\N	66030	66030	234195
2107	1688	68	applied	\N	\N	\N	\N	66031	66031	234196
2107	1689	69	applied	\N	\N	\N	\N	66032	66032	234197
2107	1690	70	applied	\N	\N	\N	\N	66033	66033	234198
2107	1691	71	applied	\N	\N	\N	\N	66034	66034	234199
2107	1692	72	applied	\N	\N	\N	\N	66035	66035	234200
2107	1693	73	applied	\N	\N	\N	\N	66036	66036	234201
2107	1694	74	applied	\N	\N	\N	\N	66037	66037	234202
2107	1695	75	applied	\N	\N	\N	\N	66038	66038	234203
2192	1833	0	applied	\N	\N	\N	\N	66208	66208	234373
2193	1833	0	applied	\N	\N	\N	\N	66209	66209	234374
2193	1834	1	applied	\N	\N	\N	\N	66210	66210	234375
2193	1835	2	applied	\N	\N	\N	\N	66211	66211	234376
2193	1836	3	applied	\N	\N	\N	\N	66212	66212	234377
2046	1731	1	applied	\N	\N	\N	\N	65887	65887	234052
2046	1732	2	applied	\N	\N	\N	\N	65888	65888	234053
2063	1746	0	applied	\N	\N	\N	\N	65910	65910	234075
2070	1749	0	applied	\N	\N	\N	\N	65917	65917	234082
2073	1751	0	applied	\N	\N	\N	\N	65921	65921	234086
2073	1752	1	applied	\N	\N	\N	\N	65922	65922	234087
2076	1753	0	applied	\N	\N	\N	\N	65925	65925	234090
2081	1756	0	applied	\N	\N	\N	\N	65930	65930	234095
2084	1757	0	applied	\N	\N	\N	\N	65933	65933	234098
2086	1758	0	applied	\N	\N	\N	\N	65935	65935	234100
2092	1766	0	applied	\N	\N	\N	\N	65944	65944	234109
2095	1767	0	applied	\N	\N	\N	\N	65947	65947	234112
2095	1768	1	applied	\N	\N	\N	\N	65948	65948	234113
2102	1772	0	applied	\N	\N	\N	\N	65958	65958	234123
2104	1773	0	applied	\N	\N	\N	\N	65960	65960	234125
2107	1696	76	applied	\N	\N	\N	\N	66039	66039	234204
2107	1697	77	applied	\N	\N	\N	\N	66040	66040	234205
2107	1698	78	applied	\N	\N	\N	\N	66041	66041	234206
2107	1700	80	applied	\N	\N	\N	\N	66043	66043	234208
2107	1701	81	applied	\N	\N	\N	\N	66044	66044	234209
2107	1702	82	applied	\N	\N	\N	\N	66045	66045	234210
2107	1703	83	applied	\N	\N	\N	\N	66046	66046	234211
2107	1704	84	applied	\N	\N	\N	\N	66047	66047	234212
2107	1705	85	applied	\N	\N	\N	\N	66048	66048	234213
2107	1706	86	applied	\N	\N	\N	\N	66049	66049	234214
2107	1707	87	applied	\N	\N	\N	\N	66050	66050	234215
2107	1708	88	applied	\N	\N	\N	\N	66051	66051	234216
2107	1709	89	applied	\N	\N	\N	\N	66052	66052	234217
2107	1710	90	applied	\N	\N	\N	\N	66053	66053	234218
2107	1711	91	applied	\N	\N	\N	\N	66054	66054	234219
2107	1712	92	applied	\N	\N	\N	\N	66055	66055	234220
2107	1713	93	applied	\N	\N	\N	\N	66056	66056	234221
2107	1714	94	applied	\N	\N	\N	\N	66057	66057	234222
2107	1715	95	applied	\N	\N	\N	\N	66058	66058	234223
2107	1717	97	applied	\N	\N	\N	\N	66060	66060	234225
2107	1718	98	applied	\N	\N	\N	\N	66061	66061	234226
2107	1719	99	applied	\N	\N	\N	\N	66062	66062	234227
2107	1720	100	applied	\N	\N	\N	\N	66063	66063	234228
2107	1721	102	applied	\N	\N	\N	\N	66064	66064	234229
2107	1722	103	applied	\N	\N	\N	\N	66065	66065	234230
2107	1723	104	applied	\N	\N	\N	\N	66066	66066	234231
2107	1724	105	applied	\N	\N	\N	\N	66067	66067	234232
2107	1725	106	applied	\N	\N	\N	\N	66068	66068	234233
2107	1726	107	applied	\N	\N	\N	\N	66069	66069	234234
2107	1727	108	applied	\N	\N	\N	\N	66070	66070	234235
2107	1728	109	applied	\N	\N	\N	\N	66071	66071	234236
2107	1729	110	applied	\N	\N	\N	\N	66072	66072	234237
2107	1730	111	applied	\N	\N	\N	\N	66073	66073	234238
2107	1731	112	applied	\N	\N	\N	\N	66074	66074	234239
2107	1732	113	applied	\N	\N	\N	\N	66075	66075	234240
2107	1734	115	applied	\N	\N	\N	\N	66077	66077	234242
2107	1735	116	applied	\N	\N	\N	\N	66078	66078	234243
2107	1736	117	applied	\N	\N	\N	\N	66079	66079	234244
2107	1737	118	applied	\N	\N	\N	\N	66080	66080	234245
2107	1738	119	applied	\N	\N	\N	\N	66081	66081	234246
2107	1739	120	applied	\N	\N	\N	\N	66082	66082	234247
2107	1740	121	applied	\N	\N	\N	\N	66083	66083	234248
2107	1741	122	applied	\N	\N	\N	\N	66084	66084	234249
2107	1742	123	applied	\N	\N	\N	\N	66085	66085	234250
2107	1743	124	applied	\N	\N	\N	\N	66086	66086	234251
2107	1744	125	applied	\N	\N	\N	\N	66087	66087	234252
2109	1774	0	applied	\N	\N	\N	\N	66089	66089	234254
2110	1775	0	applied	\N	\N	\N	\N	66090	66090	234255
2113	1776	0	applied	\N	\N	\N	\N	66093	66093	234258
2116	1780	0	applied	\N	\N	\N	\N	66097	66097	234262
2116	1781	1	applied	\N	\N	\N	\N	66098	66098	234263
2120	1783	0	applied	\N	\N	\N	\N	66103	66103	234268
2121	1783	0	applied	\N	\N	\N	\N	66104	66104	234269
2122	1783	0	applied	\N	\N	\N	\N	66105	66105	234270
2124	1785	0	applied	\N	\N	\N	\N	66107	66107	234272
2124	1786	1	applied	\N	\N	\N	\N	66108	66108	234273
2125	1785	0	applied	\N	\N	\N	\N	66109	66109	234274
2125	1786	1	applied	\N	\N	\N	\N	66110	66110	234275
2126	1787	0	applied	\N	\N	\N	\N	66111	66111	234276
2127	1788	0	applied	\N	\N	\N	\N	66112	66112	234277
2130	1791	0	applied	\N	\N	\N	\N	66115	66115	234280
2136	1791	0	applied	\N	\N	\N	\N	66121	66121	234286
2136	1792	1	applied	\N	\N	\N	\N	66122	66122	234287
2136	1793	2	applied	\N	\N	\N	\N	66123	66123	234288
2139	1794	0	applied	\N	\N	\N	\N	66126	66126	234291
2141	1795	0	applied	\N	\N	\N	\N	66128	66128	234293
2148	1803	0	applied	\N	\N	\N	\N	66137	66137	234302
2157	1810	0	applied	\N	\N	\N	\N	66148	66148	234313
2157	1811	1	applied	\N	\N	\N	\N	66149	66149	234314
2162	1812	0	applied	\N	\N	\N	\N	66156	66156	234321
2164	1814	0	applied	\N	\N	\N	\N	66158	66158	234323
2167	1815	0	applied	\N	\N	\N	\N	66161	66161	234326
2167	1816	1	applied	\N	\N	\N	\N	66162	66162	234327
2170	1817	0	applied	\N	\N	\N	\N	66167	66167	234332
2178	1822	0	applied	\N	\N	\N	\N	66176	66176	234341
2179	1823	0	applied	\N	\N	\N	\N	66177	66177	234342
2179	1824	1	applied	\N	\N	\N	\N	66178	66178	234343
2179	1825	2	applied	\N	\N	\N	\N	66179	66179	234344
2182	1828	0	applied	\N	\N	\N	\N	66184	66184	234349
2185	1829	0	applied	\N	\N	\N	\N	66187	66187	234352
2185	1830	1	applied	\N	\N	\N	\N	66188	66188	234353
2186	1815	0	applied	\N	\N	\N	\N	66189	66189	234354
2186	1660	1	applied	\N	\N	\N	\N	66190	66190	234355
2186	1662	3	applied	\N	\N	\N	\N	66192	66192	234357
2186	1663	4	applied	\N	\N	\N	\N	66193	66193	234358
2186	1664	5	applied	\N	\N	\N	\N	66194	66194	234359
2186	1665	6	applied	\N	\N	\N	\N	66195	66195	234360
2186	1666	7	applied	\N	\N	\N	\N	66196	66196	234361
2186	1667	8	applied	\N	\N	\N	\N	66197	66197	234362
2186	1668	9	applied	\N	\N	\N	\N	66198	66198	234363
2186	1669	10	applied	\N	\N	\N	\N	66199	66199	234364
2186	1670	11	applied	\N	\N	\N	\N	66200	66200	234365
2186	1671	12	applied	\N	\N	\N	\N	66201	66201	234366
2189	1832	0	applied	\N	\N	\N	\N	66205	66205	234370
2194	1834	0	applied	\N	\N	\N	\N	66213	66213	234378
2194	1835	1	applied	\N	\N	\N	\N	66214	66214	234379
2194	1836	2	applied	\N	\N	\N	\N	66215	66215	234380
2051	1740	1	applied	\N	\N	\N	\N	65897	65897	234062
2053	1741	0	applied	\N	\N	\N	\N	65900	65900	234065
2135	1793	0	applied	\N	\N	\N	\N	66120	66120	234285
2137	1793	0	applied	\N	\N	\N	\N	66124	66124	234289
2140	1794	0	applied	\N	\N	\N	\N	66127	66127	234292
2142	1795	0	applied	\N	\N	\N	\N	66129	66129	234294
2143	1796	0	applied	\N	\N	\N	\N	66130	66130	234295
2145	1798	0	applied	\N	\N	\N	\N	66132	66132	234297
2147	1801	0	applied	\N	\N	\N	\N	66135	66135	234300
2147	1802	1	applied	\N	\N	\N	\N	66136	66136	234301
2158	1810	0	applied	\N	\N	\N	\N	66150	66150	234315
2158	1811	1	applied	\N	\N	\N	\N	66151	66151	234316
2160	1812	0	applied	\N	\N	\N	\N	66154	66154	234319
2163	1813	0	applied	\N	\N	\N	\N	66157	66157	234322
2165	1814	0	applied	\N	\N	\N	\N	66159	66159	234324
2166	1814	0	applied	\N	\N	\N	\N	66160	66160	234325
2168	1815	0	applied	\N	\N	\N	\N	66163	66163	234328
2168	1816	1	applied	\N	\N	\N	\N	66164	66164	234329
2172	1819	1	applied	\N	\N	\N	\N	66170	66170	234335
2172	1820	2	applied	\N	\N	\N	\N	66171	66171	234336
2174	1821	0	applied	\N	\N	\N	\N	66172	66172	234337
2175	1821	0	applied	\N	\N	\N	\N	66173	66173	234338
2181	1826	0	applied	\N	\N	\N	\N	66182	66182	234347
2181	1827	1	applied	\N	\N	\N	\N	66183	66183	234348
2183	1828	0	applied	\N	\N	\N	\N	66185	66185	234350
2188	1831	0	applied	\N	\N	\N	\N	66204	66204	234369
2191	1833	0	applied	\N	\N	\N	\N	66207	66207	234372
2195	1815	0	applied	\N	\N	\N	\N	66216	66216	234381
2195	1775	1	applied	\N	\N	\N	\N	66217	66217	234382
2195	1776	2	applied	\N	\N	\N	\N	66218	66218	234383
2195	1777	3	applied	\N	\N	\N	\N	66219	66219	234384
2195	1778	4	applied	\N	\N	\N	\N	66220	66220	234385
2195	1779	5	applied	\N	\N	\N	\N	66221	66221	234386
2195	1780	6	applied	\N	\N	\N	\N	66222	66222	234387
2195	1782	8	applied	\N	\N	\N	\N	66224	66224	234389
2195	1783	9	applied	\N	\N	\N	\N	66225	66225	234390
2195	1784	10	applied	\N	\N	\N	\N	66226	66226	234391
2195	1785	11	applied	\N	\N	\N	\N	66227	66227	234392
2195	1786	12	applied	\N	\N	\N	\N	66228	66228	234393
2195	1787	13	applied	\N	\N	\N	\N	66229	66229	234394
2195	1788	14	applied	\N	\N	\N	\N	66230	66230	234395
2195	1789	15	applied	\N	\N	\N	\N	66231	66231	234396
2195	1790	16	applied	\N	\N	\N	\N	66232	66232	234397
2195	1791	17	applied	\N	\N	\N	\N	66233	66233	234398
2195	1792	18	applied	\N	\N	\N	\N	66234	66234	234399
2195	1793	19	applied	\N	\N	\N	\N	66235	66235	234400
2195	1794	20	applied	\N	\N	\N	\N	66236	66236	234401
2195	1795	21	applied	\N	\N	\N	\N	66237	66237	234402
2195	1796	22	applied	\N	\N	\N	\N	66238	66238	234403
2195	1797	23	applied	\N	\N	\N	\N	66239	66239	234404
2195	1799	25	applied	\N	\N	\N	\N	66241	66241	234406
2195	1800	26	applied	\N	\N	\N	\N	66242	66242	234407
2195	1801	27	applied	\N	\N	\N	\N	66243	66243	234408
2195	1802	28	applied	\N	\N	\N	\N	66244	66244	234409
2195	1803	29	applied	\N	\N	\N	\N	66245	66245	234410
2195	1804	30	applied	\N	\N	\N	\N	66246	66246	234411
2195	1805	31	applied	\N	\N	\N	\N	66247	66247	234412
2195	1806	32	applied	\N	\N	\N	\N	66248	66248	234413
2195	1807	33	applied	\N	\N	\N	\N	66249	66249	234414
2195	1808	34	applied	\N	\N	\N	\N	66250	66250	234415
2195	1809	35	applied	\N	\N	\N	\N	66251	66251	234416
2195	1810	36	applied	\N	\N	\N	\N	66252	66252	234417
2195	1811	37	applied	\N	\N	\N	\N	66253	66253	234418
2195	1812	38	applied	\N	\N	\N	\N	66254	66254	234419
2195	1813	39	applied	\N	\N	\N	\N	66255	66255	234420
2195	1814	40	applied	\N	\N	\N	\N	66256	66256	234421
2195	1817	42	applied	\N	\N	\N	\N	66258	66258	234423
2195	1818	43	applied	\N	\N	\N	\N	66259	66259	234424
2195	1819	44	applied	\N	\N	\N	\N	66260	66260	234425
2195	1820	45	applied	\N	\N	\N	\N	66261	66261	234426
2195	1821	46	applied	\N	\N	\N	\N	66262	66262	234427
2195	1822	47	applied	\N	\N	\N	\N	66263	66263	234428
2195	1823	48	applied	\N	\N	\N	\N	66264	66264	234429
2195	1824	49	applied	\N	\N	\N	\N	66265	66265	234430
2195	1825	50	applied	\N	\N	\N	\N	66266	66266	234431
2195	1826	51	applied	\N	\N	\N	\N	66267	66267	234432
2195	1827	52	applied	\N	\N	\N	\N	66268	66268	234433
2195	1828	53	applied	\N	\N	\N	\N	66269	66269	234434
2195	1829	54	applied	\N	\N	\N	\N	66270	66270	234435
2195	1830	55	applied	\N	\N	\N	\N	66271	66271	234436
2195	1831	56	applied	\N	\N	\N	\N	66272	66272	234437
2195	1832	57	applied	\N	\N	\N	\N	66273	66273	234438
2195	1834	59	applied	\N	\N	\N	\N	66275	66275	234440
2195	1835	60	applied	\N	\N	\N	\N	66276	66276	234441
2195	1836	61	applied	\N	\N	\N	\N	66277	66277	234442
2196	1837	0	applied	\N	\N	\N	\N	66278	66278	234443
2197	1837	0	applied	\N	\N	\N	\N	66279	66279	234444
2198	1837	0	applied	\N	\N	\N	\N	66280	66280	234445
2199	1838	0	applied	\N	\N	\N	\N	66281	66281	234446
2199	1839	1	applied	\N	\N	\N	\N	66282	66282	234447
2199	1840	2	applied	\N	\N	\N	\N	66283	66283	234448
2200	1841	0	applied	\N	\N	\N	\N	66284	66284	234449
2201	1841	0	applied	\N	\N	\N	\N	66285	66285	234450
2202	1841	0	applied	\N	\N	\N	\N	66286	66286	234451
2203	1841	0	applied	\N	\N	\N	\N	66287	66287	234452
2204	1842	0	applied	\N	\N	\N	\N	66288	66288	234453
2204	1843	1	applied	\N	\N	\N	\N	66289	66289	234454
2205	1842	0	applied	\N	\N	\N	\N	66290	66290	234455
2206	1844	0	applied	\N	\N	\N	\N	66292	66292	234457
2207	1845	0	applied	\N	\N	\N	\N	66293	66293	234458
2207	1846	1	applied	\N	\N	\N	\N	66294	66294	234459
2208	1845	0	applied	\N	\N	\N	\N	66295	66295	234460
2208	1846	1	applied	\N	\N	\N	\N	66296	66296	234461
2209	1845	0	applied	\N	\N	\N	\N	66297	66297	234462
2209	1846	1	applied	\N	\N	\N	\N	66298	66298	234463
2210	1847	0	applied	\N	\N	\N	\N	66299	66299	234464
2210	1848	1	applied	\N	\N	\N	\N	66300	66300	234465
2211	1844	0	applied	\N	\N	\N	\N	66301	66301	234466
2212	1849	0	applied	\N	\N	\N	\N	66302	66302	234467
2213	1850	0	applied	\N	\N	\N	\N	66303	66303	234468
2214	1851	0	applied	\N	\N	\N	\N	66304	66304	234469
2215	1851	0	applied	\N	\N	\N	\N	66305	66305	234470
2131	1792	0	applied	\N	\N	\N	\N	66116	66116	234281
2132	1792	0	applied	\N	\N	\N	\N	66117	66117	234282
2217	1852	0	applied	\N	\N	\N	\N	66309	66309	234474
2218	1852	0	applied	\N	\N	\N	\N	66310	66310	234475
2219	1853	0	applied	\N	\N	\N	\N	66311	66311	234476
2221	1854	0	applied	\N	\N	\N	\N	66313	66313	234478
2222	1854	0	applied	\N	\N	\N	\N	66314	66314	234479
2223	1855	0	applied	\N	\N	\N	\N	66315	66315	234480
2224	1856	0	applied	\N	\N	\N	\N	66316	66316	234481
2224	1857	1	applied	\N	\N	\N	\N	66317	66317	234482
2224	1858	2	applied	\N	\N	\N	\N	66318	66318	234483
2224	1859	3	applied	\N	\N	\N	\N	66319	66319	234484
2224	1860	4	applied	\N	\N	\N	\N	66320	66320	234485
2225	1861	0	applied	\N	\N	\N	\N	66321	66321	234486
2225	1862	1	applied	\N	\N	\N	\N	66322	66322	234487
2226	1863	0	applied	\N	\N	\N	\N	66323	66323	234488
2227	1864	0	applied	\N	\N	\N	\N	66324	66324	234489
2228	1864	0	applied	\N	\N	\N	\N	66325	66325	234490
2229	1865	0	applied	\N	\N	\N	\N	66326	66326	234491
2230	1865	0	applied	\N	\N	\N	\N	66327	66327	234492
2232	1866	0	applied	\N	\N	\N	\N	66328	66328	234493
2233	1866	0	applied	\N	\N	\N	\N	66330	66330	234495
2233	1867	1	applied	\N	\N	\N	\N	66331	66331	234496
2234	1868	0	applied	\N	\N	1000000000	\N	66332	66332	234497
2234	1869	1	applied	\N	\N	\N	\N	66333	66333	234498
2235	1868	0	applied	\N	\N	1000000000	\N	66334	66334	234499
2235	1869	1	applied	\N	\N	\N	\N	66335	66335	234500
2236	1870	0	applied	\N	\N	\N	\N	66336	66336	234501
2237	1870	0	applied	\N	\N	\N	\N	66337	66337	234502
2238	1870	0	applied	\N	\N	\N	\N	66338	66338	234503
2239	1871	0	applied	\N	\N	\N	\N	66339	66339	234504
2239	1872	1	applied	\N	\N	\N	\N	66340	66340	234505
2240	1873	0	applied	\N	\N	\N	\N	66341	66341	234506
2240	1874	1	applied	\N	\N	\N	\N	66342	66342	234507
2241	1856	0	applied	\N	\N	\N	\N	66343	66343	234508
2241	1815	1	applied	\N	\N	\N	\N	66344	66344	234509
2241	1636	2	applied	\N	\N	\N	\N	66345	66345	234510
2242	1876	1	applied	\N	\N	\N	\N	66347	66347	234512
2243	1875	0	applied	\N	\N	1000000000	\N	66348	66348	234513
2243	1876	1	applied	\N	\N	\N	\N	66349	66349	234514
2251	1877	0	applied	\N	\N	\N	\N	66350	66350	234515
2251	1878	1	applied	\N	\N	\N	\N	66351	66351	234516
2251	1879	2	applied	\N	\N	\N	\N	66352	66352	234517
2253	1877	0	applied	\N	\N	\N	\N	66353	66353	234518
2253	1878	1	applied	\N	\N	\N	\N	66354	66354	234519
2253	1879	2	applied	\N	\N	\N	\N	66355	66355	234520
2254	1877	0	applied	\N	\N	\N	\N	66356	66356	234521
2254	1878	1	applied	\N	\N	\N	\N	66357	66357	234522
2254	1879	2	applied	\N	\N	\N	\N	66358	66358	234523
2255	1877	0	applied	\N	\N	\N	\N	66359	66359	234524
2255	1878	1	applied	\N	\N	\N	\N	66360	66360	234525
2255	1879	2	applied	\N	\N	\N	\N	66361	66361	234526
2256	1877	0	applied	\N	\N	\N	\N	66362	66362	234527
2256	1878	1	applied	\N	\N	\N	\N	66363	66363	234528
2256	1879	2	applied	\N	\N	\N	\N	66364	66364	234529
2258	1880	0	applied	\N	\N	\N	\N	66366	66366	234531
2259	1881	0	applied	\N	\N	\N	\N	66367	66367	234532
2259	1882	1	applied	\N	\N	\N	\N	66368	66368	234533
2259	1883	2	applied	\N	\N	\N	\N	66369	66369	234534
2259	1884	3	applied	\N	\N	1000000000	\N	66370	66370	234535
2260	1885	0	applied	\N	\N	\N	\N	66371	66371	234536
2260	1886	1	applied	\N	\N	1000000000	\N	66372	66372	234537
2261	1856	0	applied	\N	\N	\N	\N	66373	66373	234538
2261	1884	1	applied	\N	\N	1000000000	\N	66374	66374	234539
2263	1887	0	applied	\N	\N	\N	\N	66379	66379	234544
2263	1888	1	applied	\N	\N	\N	\N	66380	66380	234545
2263	1889	2	applied	\N	\N	\N	\N	66381	66381	234546
2263	1890	3	applied	\N	\N	\N	\N	66382	66382	234547
2264	1891	0	applied	\N	\N	\N	\N	66383	66383	234548
2264	1892	1	applied	\N	\N	\N	\N	66384	66384	234549
2267	1893	0	applied	\N	\N	\N	\N	66389	66389	234554
2274	1895	0	applied	\N	\N	\N	\N	66397	66397	234562
2274	1896	1	applied	\N	\N	\N	\N	66398	66398	234563
2276	1895	0	applied	\N	\N	\N	\N	66400	66400	234565
2278	1897	0	applied	\N	\N	\N	\N	66402	66402	234567
2279	1898	0	applied	\N	\N	\N	\N	66403	66403	234568
2282	1899	0	applied	\N	\N	\N	\N	66415	66415	234580
2282	1900	1	applied	\N	\N	\N	\N	66416	66416	234581
2285	1901	0	applied	\N	\N	\N	\N	66418	66418	234583
2291	1905	0	applied	\N	\N	\N	\N	66423	66423	234588
2293	1906	0	applied	\N	\N	\N	\N	66427	66427	234592
2293	1907	1	applied	\N	\N	\N	\N	66428	66428	234593
2293	1908	2	applied	\N	\N	\N	\N	66429	66429	234594
2296	1909	0	applied	\N	\N	\N	\N	66435	66435	234600
2296	1910	1	applied	\N	\N	\N	\N	66436	66436	234601
2297	1911	0	applied	\N	\N	\N	\N	66437	66437	234602
2299	1912	0	applied	\N	\N	\N	\N	66439	66439	234604
2313	1906	0	applied	\N	\N	\N	\N	66577	66577	234742
2313	1907	1	applied	\N	\N	\N	\N	66578	66578	234743
2313	1908	2	applied	\N	\N	\N	\N	66579	66579	234744
2313	1909	3	applied	\N	\N	\N	\N	66580	66580	234745
2313	1910	4	applied	\N	\N	\N	\N	66581	66581	234746
2313	1911	5	applied	\N	\N	\N	\N	66582	66582	234747
2313	1912	6	applied	\N	\N	\N	\N	66583	66583	234748
2313	1913	7	applied	\N	\N	\N	\N	66584	66584	234749
2313	1914	8	applied	\N	\N	\N	\N	66585	66585	234750
2313	1915	9	applied	\N	\N	\N	\N	66586	66586	234751
2313	1916	10	applied	\N	\N	\N	\N	66587	66587	234752
2313	1917	11	applied	\N	\N	\N	\N	66588	66588	234753
2313	1918	12	applied	\N	\N	\N	\N	66589	66589	234754
2319	1924	0	applied	\N	\N	\N	\N	66596	66596	234761
2325	1928	0	applied	\N	\N	\N	\N	66602	66602	234767
2327	1929	0	applied	\N	\N	\N	\N	66605	66605	234770
2332	1931	0	applied	\N	\N	\N	\N	66614	66614	234779
2332	1932	1	applied	\N	\N	\N	\N	66615	66615	234780
2332	1933	2	applied	\N	\N	\N	\N	66616	66616	234781
2339	1935	0	applied	\N	\N	\N	\N	66631	66631	234796
2340	1935	0	applied	\N	\N	\N	\N	66632	66632	234797
2340	1936	1	applied	\N	\N	\N	\N	66633	66633	234798
2340	1937	2	applied	\N	\N	\N	\N	66634	66634	234799
2343	1938	0	applied	\N	\N	\N	\N	66640	66640	234805
2216	1851	1	applied	\N	\N	\N	\N	66307	66307	234472
2216	1852	2	applied	\N	\N	\N	\N	66308	66308	234473
2265	1891	0	applied	\N	\N	\N	\N	66385	66385	234550
2265	1892	1	applied	\N	\N	\N	\N	66386	66386	234551
2269	1893	0	applied	\N	\N	\N	\N	66390	66390	234555
2269	1894	1	applied	\N	\N	\N	\N	66391	66391	234556
2272	1895	0	applied	\N	\N	\N	\N	66393	66393	234558
2272	1896	1	applied	\N	\N	\N	\N	66394	66394	234559
2275	1895	0	applied	\N	\N	\N	\N	66399	66399	234564
2280	1898	0	applied	\N	\N	\N	\N	66404	66404	234569
2281	1856	0	applied	\N	\N	\N	\N	66405	66405	234570
2281	1815	1	applied	\N	\N	\N	\N	66406	66406	234571
2281	1636	2	applied	\N	\N	\N	\N	66407	66407	234572
2281	1634	3	applied	\N	\N	\N	\N	66408	66408	234573
2281	1884	5	applied	\N	\N	1000000000	\N	66410	66410	234575
2281	1637	6	applied	\N	\N	\N	\N	66411	66411	234576
2281	1638	7	applied	\N	\N	\N	\N	66412	66412	234577
2281	1639	8	applied	\N	\N	\N	\N	66413	66413	234578
2281	1640	9	applied	\N	\N	\N	\N	66414	66414	234579
2287	1904	0	applied	\N	\N	\N	\N	66421	66421	234586
2294	1906	0	applied	\N	\N	\N	\N	66430	66430	234595
2294	1907	1	applied	\N	\N	\N	\N	66431	66431	234596
2294	1908	2	applied	\N	\N	\N	\N	66432	66432	234597
2301	1856	0	applied	\N	\N	\N	\N	66441	66441	234606
2301	1815	1	applied	\N	\N	\N	\N	66442	66442	234607
2301	1737	2	applied	\N	\N	\N	\N	66443	66443	234608
2301	1738	3	applied	\N	\N	\N	\N	66444	66444	234609
2301	1739	4	applied	\N	\N	\N	\N	66445	66445	234610
2301	1740	5	applied	\N	\N	\N	\N	66446	66446	234611
2301	1741	6	applied	\N	\N	\N	\N	66447	66447	234612
2301	1742	8	applied	\N	\N	\N	\N	66449	66449	234614
2301	1743	9	applied	\N	\N	\N	\N	66450	66450	234615
2301	1744	10	applied	\N	\N	\N	\N	66451	66451	234616
2301	1745	11	applied	\N	\N	\N	\N	66452	66452	234617
2301	1746	12	applied	\N	\N	\N	\N	66453	66453	234618
2301	1747	13	applied	\N	\N	\N	\N	66454	66454	234619
2301	1748	14	applied	\N	\N	\N	\N	66455	66455	234620
2301	1749	15	applied	\N	\N	\N	\N	66456	66456	234621
2301	1750	16	applied	\N	\N	\N	\N	66457	66457	234622
2301	1751	17	applied	\N	\N	\N	\N	66458	66458	234623
2301	1752	18	applied	\N	\N	\N	\N	66459	66459	234624
2301	1753	19	applied	\N	\N	\N	\N	66460	66460	234625
2301	1754	20	applied	\N	\N	\N	\N	66461	66461	234626
2301	1755	21	applied	\N	\N	\N	\N	66462	66462	234627
2301	1756	22	applied	\N	\N	\N	\N	66463	66463	234628
2301	1757	23	applied	\N	\N	\N	\N	66464	66464	234629
2301	1758	24	applied	\N	\N	\N	\N	66465	66465	234630
2301	1759	25	applied	\N	\N	\N	\N	66466	66466	234631
2301	1761	27	applied	\N	\N	\N	\N	66468	66468	234633
2301	1762	28	applied	\N	\N	\N	\N	66469	66469	234634
2301	1763	29	applied	\N	\N	\N	\N	66470	66470	234635
2301	1764	30	applied	\N	\N	\N	\N	66471	66471	234636
2301	1765	31	applied	\N	\N	\N	\N	66472	66472	234637
2301	1766	32	applied	\N	\N	\N	\N	66473	66473	234638
2301	1767	33	applied	\N	\N	\N	\N	66474	66474	234639
2301	1768	34	applied	\N	\N	\N	\N	66475	66475	234640
2301	1769	35	applied	\N	\N	\N	\N	66476	66476	234641
2301	1770	36	applied	\N	\N	\N	\N	66477	66477	234642
2301	1771	37	applied	\N	\N	\N	\N	66478	66478	234643
2301	1772	38	applied	\N	\N	\N	\N	66479	66479	234644
2301	1773	39	applied	\N	\N	\N	\N	66480	66480	234645
2301	1774	40	applied	\N	\N	\N	\N	66481	66481	234646
2301	1775	41	applied	\N	\N	\N	\N	66482	66482	234647
2301	1776	42	applied	\N	\N	\N	\N	66483	66483	234648
2301	1778	44	applied	\N	\N	\N	\N	66485	66485	234650
2301	1779	45	applied	\N	\N	\N	\N	66486	66486	234651
2301	1780	46	applied	\N	\N	\N	\N	66487	66487	234652
2301	1781	47	applied	\N	\N	\N	\N	66488	66488	234653
2301	1782	48	applied	\N	\N	\N	\N	66489	66489	234654
2301	1783	49	applied	\N	\N	\N	\N	66490	66490	234655
2301	1784	50	applied	\N	\N	\N	\N	66491	66491	234656
2301	1785	51	applied	\N	\N	\N	\N	66492	66492	234657
2301	1786	52	applied	\N	\N	\N	\N	66493	66493	234658
2301	1787	53	applied	\N	\N	\N	\N	66494	66494	234659
2301	1788	54	applied	\N	\N	\N	\N	66495	66495	234660
2301	1789	55	applied	\N	\N	\N	\N	66496	66496	234661
2301	1790	56	applied	\N	\N	\N	\N	66497	66497	234662
2301	1791	57	applied	\N	\N	\N	\N	66498	66498	234663
2301	1792	58	applied	\N	\N	\N	\N	66499	66499	234664
2301	1793	59	applied	\N	\N	\N	\N	66500	66500	234665
2301	1795	61	applied	\N	\N	\N	\N	66502	66502	234667
2301	1796	62	applied	\N	\N	\N	\N	66503	66503	234668
2301	1797	63	applied	\N	\N	\N	\N	66504	66504	234669
2301	1798	64	applied	\N	\N	\N	\N	66505	66505	234670
2301	1799	65	applied	\N	\N	\N	\N	66506	66506	234671
2301	1800	66	applied	\N	\N	\N	\N	66507	66507	234672
2301	1801	67	applied	\N	\N	\N	\N	66508	66508	234673
2301	1802	68	applied	\N	\N	\N	\N	66509	66509	234674
2301	1803	69	applied	\N	\N	\N	\N	66510	66510	234675
2301	1804	70	applied	\N	\N	\N	\N	66511	66511	234676
2301	1805	71	applied	\N	\N	\N	\N	66512	66512	234677
2301	1806	72	applied	\N	\N	\N	\N	66513	66513	234678
2301	1807	73	applied	\N	\N	\N	\N	66514	66514	234679
2301	1808	74	applied	\N	\N	\N	\N	66515	66515	234680
2301	1809	75	applied	\N	\N	\N	\N	66516	66516	234681
2343	1939	1	applied	\N	\N	\N	\N	66641	66641	234806
2349	1947	1	applied	\N	\N	\N	\N	66650	66650	234815
2352	1946	0	applied	\N	\N	\N	\N	66655	66655	234820
2352	1947	1	applied	\N	\N	\N	\N	66656	66656	234821
2355	1949	0	applied	\N	\N	\N	\N	66658	66658	234823
2355	1950	1	applied	\N	\N	\N	\N	66659	66659	234824
2358	1952	0	applied	\N	\N	\N	\N	66663	66663	234828
2360	1953	0	applied	\N	\N	\N	\N	66665	66665	234830
2361	1953	0	applied	\N	\N	\N	\N	66666	66666	234831
2366	1957	0	applied	\N	\N	\N	\N	66799	66799	234964
2367	1958	0	applied	\N	\N	\N	\N	66800	66800	234965
2369	1958	0	applied	\N	\N	\N	\N	66802	66802	234967
2370	1959	0	applied	\N	\N	\N	\N	66803	66803	234968
2370	1960	1	applied	\N	\N	\N	\N	66804	66804	234969
2373	1962	0	applied	\N	\N	\N	\N	66808	66808	234973
2379	1967	0	applied	\N	\N	\N	\N	66814	66814	234979
2262	1888	1	applied	\N	\N	\N	\N	66376	66376	234541
2262	1890	3	applied	\N	\N	\N	\N	66378	66378	234543
2277	1897	0	applied	\N	\N	\N	\N	66401	66401	234566
2283	1901	0	applied	\N	\N	\N	\N	66417	66417	234582
2286	1902	0	applied	\N	\N	\N	\N	66419	66419	234584
2286	1903	1	applied	\N	\N	\N	\N	66420	66420	234585
2288	1904	0	applied	\N	\N	\N	\N	66422	66422	234587
2292	1906	0	applied	\N	\N	\N	\N	66424	66424	234589
2292	1907	1	applied	\N	\N	\N	\N	66425	66425	234590
2292	1908	2	applied	\N	\N	\N	\N	66426	66426	234591
2295	1909	0	applied	\N	\N	\N	\N	66433	66433	234598
2295	1910	1	applied	\N	\N	\N	\N	66434	66434	234599
2298	1912	0	applied	\N	\N	\N	\N	66438	66438	234603
2300	1912	0	applied	\N	\N	\N	\N	66440	66440	234605
2301	1810	76	applied	\N	\N	\N	\N	66517	66517	234682
2301	1811	77	applied	\N	\N	\N	\N	66518	66518	234683
2301	1812	78	applied	\N	\N	\N	\N	66519	66519	234684
2301	1813	79	applied	\N	\N	\N	\N	66520	66520	234685
2301	1816	81	applied	\N	\N	\N	\N	66522	66522	234687
2301	1817	82	applied	\N	\N	\N	\N	66523	66523	234688
2301	1818	83	applied	\N	\N	\N	\N	66524	66524	234689
2301	1819	84	applied	\N	\N	\N	\N	66525	66525	234690
2301	1820	86	applied	\N	\N	\N	\N	66526	66526	234691
2301	1821	87	applied	\N	\N	\N	\N	66527	66527	234692
2301	1822	88	applied	\N	\N	\N	\N	66528	66528	234693
2301	1823	89	applied	\N	\N	\N	\N	66529	66529	234694
2301	1824	90	applied	\N	\N	\N	\N	66530	66530	234695
2301	1825	91	applied	\N	\N	\N	\N	66531	66531	234696
2301	1826	92	applied	\N	\N	\N	\N	66532	66532	234697
2301	1827	93	applied	\N	\N	\N	\N	66533	66533	234698
2301	1828	94	applied	\N	\N	\N	\N	66534	66534	234699
2301	1829	95	applied	\N	\N	\N	\N	66535	66535	234700
2301	1830	96	applied	\N	\N	\N	\N	66536	66536	234701
2301	1831	97	applied	\N	\N	\N	\N	66537	66537	234702
2301	1833	99	applied	\N	\N	\N	\N	66539	66539	234704
2301	1834	100	applied	\N	\N	\N	\N	66540	66540	234705
2301	1835	101	applied	\N	\N	\N	\N	66541	66541	234706
2301	1836	102	applied	\N	\N	\N	\N	66542	66542	234707
2301	1837	103	applied	\N	\N	\N	\N	66543	66543	234708
2301	1838	104	applied	\N	\N	\N	\N	66544	66544	234709
2301	1839	105	applied	\N	\N	\N	\N	66545	66545	234710
2301	1840	106	applied	\N	\N	\N	\N	66546	66546	234711
2301	1841	107	applied	\N	\N	\N	\N	66547	66547	234712
2301	1842	108	applied	\N	\N	\N	\N	66548	66548	234713
2301	1843	109	applied	\N	\N	\N	\N	66549	66549	234714
2301	1844	110	applied	\N	\N	\N	\N	66550	66550	234715
2301	1845	111	applied	\N	\N	\N	\N	66551	66551	234716
2301	1846	112	applied	\N	\N	\N	\N	66552	66552	234717
2301	1847	113	applied	\N	\N	\N	\N	66553	66553	234718
2301	1848	114	applied	\N	\N	\N	\N	66554	66554	234719
2301	1850	116	applied	\N	\N	\N	\N	66556	66556	234721
2301	1851	117	applied	\N	\N	\N	\N	66557	66557	234722
2301	1852	118	applied	\N	\N	\N	\N	66558	66558	234723
2301	1853	119	applied	\N	\N	\N	\N	66559	66559	234724
2301	1854	120	applied	\N	\N	\N	\N	66560	66560	234725
2301	1855	121	applied	\N	\N	\N	\N	66561	66561	234726
2301	1857	122	applied	\N	\N	\N	\N	66562	66562	234727
2301	1858	123	applied	\N	\N	\N	\N	66563	66563	234728
2301	1859	124	applied	\N	\N	\N	\N	66564	66564	234729
2301	1860	125	applied	\N	\N	\N	\N	66565	66565	234730
2302	1913	0	applied	\N	\N	\N	\N	66566	66566	234731
2303	1913	0	applied	\N	\N	\N	\N	66567	66567	234732
2304	1914	0	applied	\N	\N	\N	\N	66568	66568	234733
2308	1915	0	applied	\N	\N	\N	\N	66570	66570	234735
2311	1916	0	applied	\N	\N	\N	\N	66571	66571	234736
2311	1917	1	applied	\N	\N	\N	\N	66572	66572	234737
2312	1916	0	applied	\N	\N	\N	\N	66574	66574	234739
2312	1917	1	applied	\N	\N	\N	\N	66575	66575	234740
2312	1918	2	applied	\N	\N	\N	\N	66576	66576	234741
2314	1919	0	applied	\N	\N	\N	\N	66590	66590	234755
2315	1919	0	applied	\N	\N	\N	\N	66591	66591	234756
2316	1920	0	applied	\N	\N	\N	\N	66592	66592	234757
2316	1921	1	applied	\N	\N	\N	\N	66593	66593	234758
2317	1922	0	applied	\N	\N	\N	\N	66594	66594	234759
2317	1923	1	applied	\N	\N	\N	\N	66595	66595	234760
2320	1924	0	applied	\N	\N	\N	\N	66597	66597	234762
2321	1925	0	applied	\N	\N	\N	\N	66598	66598	234763
2322	1925	0	applied	\N	\N	\N	\N	66599	66599	234764
2323	1926	0	applied	\N	\N	\N	\N	66600	66600	234765
2324	1927	0	applied	\N	\N	\N	\N	66601	66601	234766
2326	1929	0	applied	\N	\N	\N	\N	66603	66603	234768
2326	1930	1	applied	\N	\N	\N	\N	66604	66604	234769
2328	1930	1	applied	\N	\N	\N	\N	66608	66608	234773
2329	1929	0	applied	\N	\N	\N	\N	66609	66609	234774
2329	1930	1	applied	\N	\N	\N	\N	66610	66610	234775
2331	1931	0	applied	\N	\N	\N	\N	66611	66611	234776
2331	1932	1	applied	\N	\N	\N	\N	66612	66612	234777
2333	1931	0	applied	\N	\N	\N	\N	66617	66617	234782
2333	1932	1	applied	\N	\N	\N	\N	66618	66618	234783
2333	1933	2	applied	\N	\N	\N	\N	66619	66619	234784
2336	1931	0	applied	\N	\N	\N	\N	66626	66626	234791
2336	1932	1	applied	\N	\N	\N	\N	66627	66627	234792
2336	1933	2	applied	\N	\N	\N	\N	66628	66628	234793
2336	1934	3	applied	\N	\N	\N	\N	66629	66629	234794
2341	1935	0	applied	\N	\N	\N	\N	66635	66635	234800
2341	1936	1	applied	\N	\N	\N	\N	66636	66636	234801
2341	1937	2	applied	\N	\N	\N	\N	66637	66637	234802
2342	1938	0	applied	\N	\N	\N	\N	66638	66638	234803
2345	1943	0	applied	\N	\N	\N	\N	66645	66645	234810
2348	1945	0	applied	\N	\N	\N	\N	66648	66648	234813
2350	1946	0	applied	\N	\N	\N	\N	66651	66651	234816
2350	1947	1	applied	\N	\N	\N	\N	66652	66652	234817
2357	1951	0	applied	\N	\N	\N	\N	66662	66662	234827
2363	1954	0	applied	\N	\N	\N	\N	66792	66792	234957
2363	1955	1	applied	\N	\N	\N	\N	66793	66793	234958
2363	1956	2	applied	\N	\N	\N	\N	66794	66794	234959
2368	1958	0	applied	\N	\N	\N	\N	66801	66801	234966
2371	1959	0	applied	\N	\N	\N	\N	66805	66805	234970
2371	1960	1	applied	\N	\N	\N	\N	66806	66806	234971
2372	1961	0	applied	\N	\N	\N	\N	66807	66807	234972
2375	1964	0	applied	\N	\N	\N	\N	66810	66810	234975
2378	1966	0	applied	\N	\N	\N	\N	66813	66813	234978
2266	1892	1	applied	\N	\N	\N	\N	66388	66388	234553
2273	1895	0	applied	\N	\N	\N	\N	66395	66395	234560
2335	1931	0	applied	\N	\N	\N	\N	66623	66623	234788
2335	1932	1	applied	\N	\N	\N	\N	66624	66624	234789
2335	1933	2	applied	\N	\N	\N	\N	66625	66625	234790
2338	1935	0	applied	\N	\N	\N	\N	66630	66630	234795
2344	1940	0	applied	\N	\N	\N	\N	66642	66642	234807
2344	1941	1	applied	\N	\N	\N	\N	66643	66643	234808
2344	1942	2	applied	\N	\N	\N	\N	66644	66644	234809
2346	1943	0	applied	\N	\N	\N	\N	66646	66646	234811
2347	1944	0	applied	\N	\N	\N	\N	66647	66647	234812
2351	1946	0	applied	\N	\N	\N	\N	66653	66653	234818
2351	1947	1	applied	\N	\N	\N	\N	66654	66654	234819
2353	1948	0	applied	\N	\N	\N	\N	66657	66657	234822
2356	1949	0	applied	\N	\N	\N	\N	66660	66660	234825
2356	1950	1	applied	\N	\N	\N	\N	66661	66661	234826
2362	1856	0	applied	\N	\N	\N	\N	66667	66667	234832
2362	1815	1	applied	\N	\N	\N	\N	66668	66668	234833
2362	1703	2	applied	\N	\N	\N	\N	66669	66669	234834
2362	1704	3	applied	\N	\N	\N	\N	66670	66670	234835
2362	1705	4	applied	\N	\N	\N	\N	66671	66671	234836
2362	1884	5	applied	\N	\N	1000000000	\N	66672	66672	234837
2362	1706	6	applied	\N	\N	\N	\N	66673	66673	234838
2362	1707	7	applied	\N	\N	\N	\N	66674	66674	234839
2362	1708	8	applied	\N	\N	\N	\N	66675	66675	234840
2362	1709	9	applied	\N	\N	\N	\N	66676	66676	234841
2362	1710	10	applied	\N	\N	\N	\N	66677	66677	234842
2362	1711	11	applied	\N	\N	\N	\N	66678	66678	234843
2362	1712	12	applied	\N	\N	\N	\N	66679	66679	234844
2362	1713	13	applied	\N	\N	\N	\N	66680	66680	234845
2362	1714	14	applied	\N	\N	\N	\N	66681	66681	234846
2362	1715	15	applied	\N	\N	\N	\N	66682	66682	234847
2362	1717	17	applied	\N	\N	\N	\N	66684	66684	234849
2362	1718	18	applied	\N	\N	\N	\N	66685	66685	234850
2362	1719	19	applied	\N	\N	\N	\N	66686	66686	234851
2362	1720	20	applied	\N	\N	\N	\N	66687	66687	234852
2362	1721	21	applied	\N	\N	\N	\N	66688	66688	234853
2362	1722	22	applied	\N	\N	\N	\N	66689	66689	234854
2362	1723	23	applied	\N	\N	\N	\N	66690	66690	234855
2362	1724	24	applied	\N	\N	\N	\N	66691	66691	234856
2362	1725	25	applied	\N	\N	\N	\N	66692	66692	234857
2362	1726	26	applied	\N	\N	\N	\N	66693	66693	234858
2362	1727	27	applied	\N	\N	\N	\N	66694	66694	234859
2362	1728	28	applied	\N	\N	\N	\N	66695	66695	234860
2362	1729	29	applied	\N	\N	\N	\N	66696	66696	234861
2362	1730	30	applied	\N	\N	\N	\N	66697	66697	234862
2362	1731	32	applied	\N	\N	\N	\N	66698	66698	234863
2362	1732	33	applied	\N	\N	\N	\N	66699	66699	234864
2362	1734	35	applied	\N	\N	\N	\N	66701	66701	234866
2362	1735	36	applied	\N	\N	\N	\N	66702	66702	234867
2362	1736	37	applied	\N	\N	\N	\N	66703	66703	234868
2362	1737	38	applied	\N	\N	\N	\N	66704	66704	234869
2362	1738	39	applied	\N	\N	\N	\N	66705	66705	234870
2362	1739	40	applied	\N	\N	\N	\N	66706	66706	234871
2362	1740	41	applied	\N	\N	\N	\N	66707	66707	234872
2362	1741	42	applied	\N	\N	\N	\N	66708	66708	234873
2362	1742	43	applied	\N	\N	\N	\N	66709	66709	234874
2362	1743	44	applied	\N	\N	\N	\N	66710	66710	234875
2362	1744	45	applied	\N	\N	\N	\N	66711	66711	234876
2362	1745	46	applied	\N	\N	\N	\N	66712	66712	234877
2362	1746	47	applied	\N	\N	\N	\N	66713	66713	234878
2362	1747	48	applied	\N	\N	\N	\N	66714	66714	234879
2362	1748	49	applied	\N	\N	\N	\N	66715	66715	234880
2362	1749	50	applied	\N	\N	\N	\N	66716	66716	234881
2362	1751	52	applied	\N	\N	\N	\N	66718	66718	234883
2362	1752	53	applied	\N	\N	\N	\N	66719	66719	234884
2362	1753	54	applied	\N	\N	\N	\N	66720	66720	234885
2362	1754	55	applied	\N	\N	\N	\N	66721	66721	234886
2362	1755	56	applied	\N	\N	\N	\N	66722	66722	234887
2362	1756	57	applied	\N	\N	\N	\N	66723	66723	234888
2362	1757	58	applied	\N	\N	\N	\N	66724	66724	234889
2362	1758	59	applied	\N	\N	\N	\N	66725	66725	234890
2362	1759	60	applied	\N	\N	\N	\N	66726	66726	234891
2362	1760	61	applied	\N	\N	\N	\N	66727	66727	234892
2362	1761	62	applied	\N	\N	\N	\N	66728	66728	234893
2362	1762	63	applied	\N	\N	\N	\N	66729	66729	234894
2362	1763	64	applied	\N	\N	\N	\N	66730	66730	234895
2362	1764	65	applied	\N	\N	\N	\N	66731	66731	234896
2362	1765	66	applied	\N	\N	\N	\N	66732	66732	234897
2362	1766	67	applied	\N	\N	\N	\N	66733	66733	234898
2362	1768	69	applied	\N	\N	\N	\N	66735	66735	234900
2362	1769	70	applied	\N	\N	\N	\N	66736	66736	234901
2362	1770	71	applied	\N	\N	\N	\N	66737	66737	234902
2362	1771	72	applied	\N	\N	\N	\N	66738	66738	234903
2362	1772	73	applied	\N	\N	\N	\N	66739	66739	234904
2362	1773	74	applied	\N	\N	\N	\N	66740	66740	234905
2362	1774	75	applied	\N	\N	\N	\N	66741	66741	234906
2362	1775	76	applied	\N	\N	\N	\N	66742	66742	234907
2362	1776	77	applied	\N	\N	\N	\N	66743	66743	234908
2362	1777	78	applied	\N	\N	\N	\N	66744	66744	234909
2362	1778	79	applied	\N	\N	\N	\N	66745	66745	234910
2362	1779	80	applied	\N	\N	\N	\N	66746	66746	234911
2362	1780	81	applied	\N	\N	\N	\N	66747	66747	234912
2362	1781	82	applied	\N	\N	\N	\N	66748	66748	234913
2362	1782	83	applied	\N	\N	\N	\N	66749	66749	234914
2362	1783	84	applied	\N	\N	\N	\N	66750	66750	234915
2362	1785	86	applied	\N	\N	\N	\N	66752	66752	234917
2362	1786	87	applied	\N	\N	\N	\N	66753	66753	234918
2362	1787	88	applied	\N	\N	\N	\N	66754	66754	234919
2362	1788	89	applied	\N	\N	\N	\N	66755	66755	234920
2362	1789	90	applied	\N	\N	\N	\N	66756	66756	234921
2362	1790	91	applied	\N	\N	\N	\N	66757	66757	234922
2362	1791	92	applied	\N	\N	\N	\N	66758	66758	234923
2362	1792	93	applied	\N	\N	\N	\N	66759	66759	234924
2362	1793	94	applied	\N	\N	\N	\N	66760	66760	234925
2362	1794	95	applied	\N	\N	\N	\N	66761	66761	234926
2362	1795	96	applied	\N	\N	\N	\N	66762	66762	234927
2362	1796	97	applied	\N	\N	\N	\N	66763	66763	234928
2362	1797	98	applied	\N	\N	\N	\N	66764	66764	234929
2362	1798	99	applied	\N	\N	\N	\N	66765	66765	234930
2362	1799	100	applied	\N	\N	\N	\N	66766	66766	234931
2362	1800	101	applied	\N	\N	\N	\N	66767	66767	234932
2334	1933	2	applied	\N	\N	\N	\N	66622	66622	234787
2362	1805	106	applied	\N	\N	\N	\N	66772	66772	234937
2362	1806	107	applied	\N	\N	\N	\N	66773	66773	234938
2362	1807	108	applied	\N	\N	\N	\N	66774	66774	234939
2362	1808	109	applied	\N	\N	\N	\N	66775	66775	234940
2362	1809	110	applied	\N	\N	\N	\N	66776	66776	234941
2362	1810	111	applied	\N	\N	\N	\N	66777	66777	234942
2362	1811	112	applied	\N	\N	\N	\N	66778	66778	234943
2362	1812	113	applied	\N	\N	\N	\N	66779	66779	234944
2362	1813	114	applied	\N	\N	\N	\N	66780	66780	234945
2362	1814	115	applied	\N	\N	\N	\N	66781	66781	234946
2362	1816	116	applied	\N	\N	\N	\N	66782	66782	234947
2362	1817	117	applied	\N	\N	\N	\N	66783	66783	234948
2362	1818	118	applied	\N	\N	\N	\N	66784	66784	234949
2362	1819	119	applied	\N	\N	\N	\N	66785	66785	234950
2362	1820	120	applied	\N	\N	\N	\N	66786	66786	234951
2362	1821	121	applied	\N	\N	\N	\N	66787	66787	234952
2362	1823	123	applied	\N	\N	\N	\N	66789	66789	234954
2362	1824	124	applied	\N	\N	\N	\N	66790	66790	234955
2362	1825	125	applied	\N	\N	\N	\N	66791	66791	234956
2364	1954	0	applied	\N	\N	\N	\N	66795	66795	234960
2364	1955	1	applied	\N	\N	\N	\N	66796	66796	234961
2364	1956	2	applied	\N	\N	\N	\N	66797	66797	234962
2365	1957	0	applied	\N	\N	\N	\N	66798	66798	234963
2374	1963	0	applied	\N	\N	\N	\N	66809	66809	234974
2376	1964	0	applied	\N	\N	\N	\N	66811	66811	234976
2377	1965	0	applied	\N	\N	\N	\N	66812	66812	234977
2380	1968	0	applied	\N	\N	\N	\N	66815	66815	234980
2381	1968	0	applied	\N	\N	\N	\N	66816	66816	234981
2382	1968	0	applied	\N	\N	\N	\N	66817	66817	234982
2383	1968	0	applied	\N	\N	\N	\N	66818	66818	234983
2384	1968	0	applied	\N	\N	\N	\N	66819	66819	234984
2385	1969	0	applied	\N	\N	\N	\N	66820	66820	234985
2387	1969	0	applied	\N	\N	\N	\N	66822	66822	234987
2388	1969	0	applied	\N	\N	\N	\N	66823	66823	234988
2389	1970	0	applied	\N	\N	\N	\N	66824	66824	234989
2390	1971	0	applied	\N	\N	\N	\N	66825	66825	234990
2390	1972	1	applied	\N	\N	\N	\N	66826	66826	234991
2392	1973	0	applied	\N	\N	\N	\N	66827	66827	234992
2393	1973	0	applied	\N	\N	\N	\N	66828	66828	234993
2394	1973	0	applied	\N	\N	\N	\N	66829	66829	234994
2394	1974	1	applied	\N	\N	\N	\N	66830	66830	234995
2395	1975	0	applied	\N	\N	\N	\N	66831	66831	234996
2395	1976	1	applied	\N	\N	\N	\N	66832	66832	234997
2395	1977	2	applied	\N	\N	\N	\N	66833	66833	234998
2395	1978	3	applied	\N	\N	\N	\N	66834	66834	234999
2396	1979	0	applied	\N	\N	\N	\N	66835	66835	235000
2397	1980	0	applied	\N	\N	\N	\N	66836	66836	235001
2397	1981	1	applied	\N	\N	\N	\N	66837	66837	235002
2399	1982	0	applied	\N	\N	\N	\N	66839	66839	235004
2400	1982	0	applied	\N	\N	\N	\N	66840	66840	235005
2401	1983	0	applied	\N	\N	\N	\N	66841	66841	235006
2402	1983	0	applied	\N	\N	\N	\N	66842	66842	235007
2403	1983	0	applied	\N	\N	\N	\N	66843	66843	235008
2404	1984	0	applied	\N	\N	\N	\N	66844	66844	235009
2405	1985	0	applied	\N	\N	\N	\N	66845	66845	235010
2406	1985	0	applied	\N	\N	\N	\N	66846	66846	235011
2407	1986	0	applied	\N	\N	\N	\N	66847	66847	235012
2407	1987	1	applied	\N	\N	\N	\N	66848	66848	235013
2408	1988	0	applied	\N	\N	\N	\N	66849	66849	235014
2409	1988	0	applied	\N	\N	\N	\N	66850	66850	235015
2410	1989	0	applied	\N	\N	\N	\N	66851	66851	235016
2411	1989	0	applied	\N	\N	\N	\N	66852	66852	235017
2412	1990	0	applied	\N	\N	\N	\N	66853	66853	235018
2412	1991	1	applied	\N	\N	\N	\N	66854	66854	235019
2414	1992	0	applied	\N	\N	\N	\N	66856	66856	235021
2415	1993	0	applied	\N	\N	\N	\N	66857	66857	235022
2416	1994	0	applied	\N	\N	\N	\N	66858	66858	235023
2416	1995	1	applied	\N	\N	\N	\N	66859	66859	235024
2419	1996	0	applied	\N	\N	\N	\N	66864	66864	235029
2419	1997	1	applied	\N	\N	\N	\N	66865	66865	235030
2419	1998	2	applied	\N	\N	\N	\N	66866	66866	235031
2425	2003	0	applied	\N	\N	\N	\N	66875	66875	235040
2430	2005	0	applied	\N	\N	\N	\N	66880	66880	235045
2431	2006	0	applied	\N	\N	\N	\N	66881	66881	235046
2434	2007	0	applied	\N	\N	\N	\N	66884	66884	235049
2434	2008	1	applied	\N	\N	\N	\N	66885	66885	235050
2438	2009	0	applied	\N	\N	\N	\N	66894	66894	235059
2438	2010	1	applied	\N	\N	\N	\N	66895	66895	235060
2438	2011	2	applied	\N	\N	\N	\N	66896	66896	235061
2440	2012	0	applied	\N	\N	\N	\N	66898	66898	235063
2447	2016	0	applied	\N	\N	\N	\N	66905	66905	235070
2454	2021	0	applied	\N	\N	\N	\N	66913	66913	235078
2456	2022	0	applied	\N	\N	\N	\N	66915	66915	235080
2456	2023	1	applied	\N	\N	\N	\N	66916	66916	235081
2456	2024	2	applied	\N	\N	\N	\N	66917	66917	235082
2456	2025	3	applied	\N	\N	\N	\N	66918	66918	235083
2459	2027	0	applied	\N	\N	\N	\N	66921	66921	235086
2465	2031	0	applied	\N	\N	\N	\N	66929	66929	235094
2468	2035	0	applied	\N	\N	\N	\N	66933	66933	235098
2471	2036	0	applied	\N	\N	\N	\N	66936	66936	235101
2475	2038	0	applied	\N	\N	\N	\N	66940	66940	235105
2475	2039	1	applied	\N	\N	\N	\N	66941	66941	235106
2475	2040	2	applied	\N	\N	\N	\N	66942	66942	235107
2475	2041	3	applied	\N	\N	\N	\N	66943	66943	235108
2475	2042	4	applied	\N	\N	\N	\N	66944	66944	235109
2477	2044	0	applied	\N	\N	\N	\N	66946	66946	235111
2480	2046	1	applied	\N	\N	\N	\N	66950	66950	235115
2482	2047	0	applied	\N	\N	\N	\N	66951	66951	235116
2482	2048	1	applied	\N	\N	\N	\N	66952	66952	235117
2485	1971	0	applied	\N	\N	\N	\N	66955	66955	235120
2485	1996	1	applied	\N	\N	\N	\N	66956	66956	235121
2485	1948	2	applied	\N	\N	\N	\N	66957	66957	235122
2485	1949	3	applied	\N	\N	\N	\N	66958	66958	235123
2485	1950	4	applied	\N	\N	\N	\N	66959	66959	235124
2485	1956	5	applied	\N	\N	\N	\N	66960	66960	235125
2485	1951	6	applied	\N	\N	\N	\N	66961	66961	235126
2485	1952	7	applied	\N	\N	\N	\N	66962	66962	235127
2485	1953	8	applied	\N	\N	\N	\N	66963	66963	235128
2485	1954	9	applied	\N	\N	\N	\N	66964	66964	235129
2485	1955	10	applied	\N	\N	\N	\N	66965	66965	235130
2362	1802	103	applied	\N	\N	\N	\N	66769	66769	234934
2362	1803	104	applied	\N	\N	\N	\N	66770	66770	234935
2420	1998	2	applied	\N	\N	\N	\N	66869	66869	235034
2421	1999	0	applied	\N	\N	\N	\N	66870	66870	235035
2424	2002	0	applied	\N	\N	\N	\N	66874	66874	235039
2426	2003	0	applied	\N	\N	\N	\N	66876	66876	235041
2427	2004	0	applied	\N	\N	\N	\N	66877	66877	235042
2432	2006	0	applied	\N	\N	\N	\N	66882	66882	235047
2436	2009	0	applied	\N	\N	\N	\N	66888	66888	235053
2436	2010	1	applied	\N	\N	\N	\N	66889	66889	235054
2436	2011	2	applied	\N	\N	\N	\N	66890	66890	235055
2439	2012	0	applied	\N	\N	\N	\N	66897	66897	235062
2441	2013	0	applied	\N	\N	\N	\N	66899	66899	235064
2444	2014	0	applied	\N	\N	\N	\N	66902	66902	235067
2445	2015	0	applied	\N	\N	\N	\N	66903	66903	235068
2446	2015	0	applied	\N	\N	\N	\N	66904	66904	235069
2455	2021	0	applied	\N	\N	\N	\N	66914	66914	235079
2457	2026	0	applied	\N	\N	\N	\N	66919	66919	235084
2458	2027	0	applied	\N	\N	\N	\N	66920	66920	235085
2460	2028	0	applied	\N	\N	\N	\N	66922	66922	235087
2462	2029	0	applied	\N	\N	\N	\N	66924	66924	235089
2462	2030	1	applied	\N	\N	\N	\N	66925	66925	235090
2463	2029	0	applied	\N	\N	\N	\N	66926	66926	235091
2463	2030	1	applied	\N	\N	\N	\N	66927	66927	235092
2464	2031	0	applied	\N	\N	\N	\N	66928	66928	235093
2467	2033	0	applied	\N	\N	\N	\N	66931	66931	235096
2467	2034	1	applied	\N	\N	\N	\N	66932	66932	235097
2470	2036	0	applied	\N	\N	\N	\N	66935	66935	235100
2473	2037	0	applied	\N	\N	\N	\N	66938	66938	235103
2478	2044	0	applied	\N	\N	\N	\N	66947	66947	235112
2483	2047	0	applied	\N	\N	\N	\N	66953	66953	235118
2483	2048	1	applied	\N	\N	\N	\N	66954	66954	235119
2485	1958	12	applied	\N	\N	\N	\N	66967	66967	235132
2485	1959	13	applied	\N	\N	\N	\N	66968	66968	235133
2485	1960	14	applied	\N	\N	\N	\N	66969	66969	235134
2485	1961	15	applied	\N	\N	\N	\N	66970	66970	235135
2485	1962	16	applied	\N	\N	\N	\N	66971	66971	235136
2485	1963	17	applied	\N	\N	\N	\N	66972	66972	235137
2485	1964	18	applied	\N	\N	\N	\N	66973	66973	235138
2485	1965	19	applied	\N	\N	\N	\N	66974	66974	235139
2485	1966	20	applied	\N	\N	\N	\N	66975	66975	235140
2485	1967	21	applied	\N	\N	\N	\N	66976	66976	235141
2485	1968	22	applied	\N	\N	\N	\N	66977	66977	235142
2485	1969	23	applied	\N	\N	\N	\N	66978	66978	235143
2485	1970	24	applied	\N	\N	\N	\N	66979	66979	235144
2485	1972	25	applied	\N	\N	\N	\N	66980	66980	235145
2485	1973	26	applied	\N	\N	\N	\N	66981	66981	235146
2485	1974	27	applied	\N	\N	\N	\N	66982	66982	235147
2485	1976	29	applied	\N	\N	\N	\N	66984	66984	235149
2485	1977	30	applied	\N	\N	\N	\N	66985	66985	235150
2485	1978	31	applied	\N	\N	\N	\N	66986	66986	235151
2485	1979	32	applied	\N	\N	\N	\N	66987	66987	235152
2485	1980	33	applied	\N	\N	\N	\N	66988	66988	235153
2485	1981	34	applied	\N	\N	\N	\N	66989	66989	235154
2485	1982	35	applied	\N	\N	\N	\N	66990	66990	235155
2485	1983	36	applied	\N	\N	\N	\N	66991	66991	235156
2485	1984	37	applied	\N	\N	\N	\N	66992	66992	235157
2485	1985	38	applied	\N	\N	\N	\N	66993	66993	235158
2485	1986	39	applied	\N	\N	\N	\N	66994	66994	235159
2485	1987	40	applied	\N	\N	\N	\N	66995	66995	235160
2485	1988	41	applied	\N	\N	\N	\N	66996	66996	235161
2485	1989	42	applied	\N	\N	\N	\N	66997	66997	235162
2485	1990	43	applied	\N	\N	\N	\N	66998	66998	235163
2485	1991	44	applied	\N	\N	\N	\N	66999	66999	235164
2485	1993	46	applied	\N	\N	\N	\N	67001	67001	235166
2485	1994	47	applied	\N	\N	\N	\N	67002	67002	235167
2485	1995	48	applied	\N	\N	\N	\N	67003	67003	235168
2485	1997	49	applied	\N	\N	\N	\N	67004	67004	235169
2485	1998	50	applied	\N	\N	\N	\N	67005	67005	235170
2485	1999	51	applied	\N	\N	\N	\N	67006	67006	235171
2485	2000	52	applied	\N	\N	\N	\N	67007	67007	235172
2485	2001	53	applied	\N	\N	\N	\N	67008	67008	235173
2485	2002	54	applied	\N	\N	\N	\N	67009	67009	235174
2485	2003	55	applied	\N	\N	\N	\N	67010	67010	235175
2485	2004	56	applied	\N	\N	\N	\N	67011	67011	235176
2485	2005	57	applied	\N	\N	\N	\N	67012	67012	235177
2485	2006	58	applied	\N	\N	\N	\N	67013	67013	235178
2485	2007	59	applied	\N	\N	\N	\N	67014	67014	235179
2485	2008	60	applied	\N	\N	\N	\N	67015	67015	235180
2485	2009	61	applied	\N	\N	\N	\N	67016	67016	235181
2485	2011	63	applied	\N	\N	\N	\N	67018	67018	235183
2485	2012	64	applied	\N	\N	\N	\N	67019	67019	235184
2485	2013	65	applied	\N	\N	\N	\N	67020	67020	235185
2485	2014	66	applied	\N	\N	\N	\N	67021	67021	235186
2485	2015	67	applied	\N	\N	\N	\N	67022	67022	235187
2485	2016	68	applied	\N	\N	\N	\N	67023	67023	235188
2485	2017	69	applied	\N	\N	\N	\N	67024	67024	235189
2485	2018	70	applied	\N	\N	\N	\N	67025	67025	235190
2485	2019	71	applied	\N	\N	\N	\N	67026	67026	235191
2485	2020	72	applied	\N	\N	\N	\N	67027	67027	235192
2485	2021	73	applied	\N	\N	\N	\N	67028	67028	235193
2485	2022	74	applied	\N	\N	\N	\N	67029	67029	235194
2485	2023	75	applied	\N	\N	\N	\N	67030	67030	235195
2485	2024	76	applied	\N	\N	\N	\N	67031	67031	235196
2485	2025	77	applied	\N	\N	\N	\N	67032	67032	235197
2485	2026	78	applied	\N	\N	\N	\N	67033	67033	235198
2485	2028	80	applied	\N	\N	\N	\N	67035	67035	235200
2485	2029	81	applied	\N	\N	\N	\N	67036	67036	235201
2485	2030	82	applied	\N	\N	\N	\N	67037	67037	235202
2485	2031	83	applied	\N	\N	\N	\N	67038	67038	235203
2485	2032	84	applied	\N	\N	\N	\N	67039	67039	235204
2486	2047	0	applied	\N	\N	\N	\N	67057	67057	235222
2486	2048	1	applied	\N	\N	\N	\N	67058	67058	235223
2486	2049	2	applied	\N	\N	\N	\N	67059	67059	235224
2488	2050	0	applied	\N	\N	\N	\N	67061	67061	235226
2494	2053	0	applied	\N	\N	\N	\N	67067	67067	235232
2494	2054	1	applied	\N	\N	1000000000	\N	67068	67068	235233
2498	2059	0	applied	\N	\N	\N	\N	67076	67076	235241
2499	2060	0	applied	\N	\N	\N	\N	67077	67077	235242
2500	2061	0	applied	\N	\N	\N	\N	67078	67078	235243
2500	2062	1	applied	\N	\N	\N	\N	67079	67079	235244
2500	2063	2	applied	\N	\N	\N	\N	67080	67080	235245
2420	1997	1	applied	\N	\N	\N	\N	66868	66868	235033
2423	2000	0	applied	\N	\N	\N	\N	66872	66872	235037
2423	2001	1	applied	\N	\N	\N	\N	66873	66873	235038
2428	2004	0	applied	\N	\N	\N	\N	66878	66878	235043
2429	2005	0	applied	\N	\N	\N	\N	66879	66879	235044
2433	2006	0	applied	\N	\N	\N	\N	66883	66883	235048
2435	2007	0	applied	\N	\N	\N	\N	66886	66886	235051
2435	2008	1	applied	\N	\N	\N	\N	66887	66887	235052
2437	2010	1	applied	\N	\N	\N	\N	66892	66892	235057
2437	2011	2	applied	\N	\N	\N	\N	66893	66893	235058
2442	2013	0	applied	\N	\N	\N	\N	66900	66900	235065
2448	2017	0	applied	\N	\N	\N	\N	66906	66906	235071
2449	2017	0	applied	\N	\N	\N	\N	66907	66907	235072
2451	2018	0	applied	\N	\N	\N	\N	66909	66909	235074
2452	2019	0	applied	\N	\N	\N	\N	66910	66910	235075
2452	2020	1	applied	\N	\N	\N	\N	66911	66911	235076
2453	2021	0	applied	\N	\N	\N	\N	66912	66912	235077
2461	2028	0	applied	\N	\N	\N	\N	66923	66923	235088
2466	2032	0	applied	\N	\N	\N	\N	66930	66930	235095
2469	2036	0	applied	\N	\N	\N	\N	66934	66934	235099
2472	2037	0	applied	\N	\N	\N	\N	66937	66937	235102
2474	2037	0	applied	\N	\N	\N	\N	66939	66939	235104
2476	2043	0	applied	\N	\N	\N	\N	66945	66945	235110
2479	2044	0	applied	\N	\N	\N	\N	66948	66948	235113
2492	2052	0	applied	\N	\N	\N	\N	67065	67065	235230
2495	2053	0	applied	\N	\N	\N	\N	67069	67069	235234
2495	2054	1	applied	\N	\N	1000000000	\N	67070	67070	235235
2497	2059	0	applied	\N	\N	\N	\N	67075	67075	235240
2500	2064	3	applied	\N	\N	\N	\N	67081	67081	235246
2503	2065	0	applied	\N	\N	\N	\N	67155	67155	235320
2503	2066	1	applied	\N	\N	\N	\N	67156	67156	235321
2503	2067	2	applied	\N	\N	\N	\N	67157	67157	235322
2503	2068	3	applied	\N	\N	\N	\N	67158	67158	235323
2504	2069	0	applied	\N	\N	\N	\N	67159	67159	235324
2505	2070	0	applied	\N	\N	\N	\N	67160	67160	235325
2506	2071	0	applied	\N	\N	\N	\N	67161	67161	235326
2509	2074	0	applied	\N	\N	\N	\N	67167	67167	235332
2509	2075	1	applied	\N	\N	\N	\N	67168	67168	235333
2509	2076	2	applied	\N	\N	\N	\N	67169	67169	235334
2511	2078	0	applied	\N	\N	\N	\N	67171	67171	235336
2513	2080	0	applied	\N	\N	\N	\N	67175	67175	235340
2516	2082	0	applied	\N	\N	\N	\N	67178	67178	235343
2517	2083	0	applied	\N	\N	\N	\N	67179	67179	235344
2517	2084	1	applied	\N	\N	\N	\N	67180	67180	235345
2517	2085	2	applied	\N	\N	\N	\N	67181	67181	235346
2520	2086	0	applied	\N	\N	\N	\N	67188	67188	235353
2520	2087	1	applied	\N	\N	\N	\N	67189	67189	235354
2520	2088	2	applied	\N	\N	\N	\N	67190	67190	235355
2520	2089	3	applied	\N	\N	1000000000	\N	67191	67191	235356
2521	2086	0	applied	\N	\N	\N	\N	67192	67192	235357
2521	2087	1	applied	\N	\N	\N	\N	67193	67193	235358
2521	2088	2	applied	\N	\N	\N	\N	67194	67194	235359
2521	2089	3	applied	\N	\N	1000000000	\N	67195	67195	235360
2523	2091	0	applied	\N	\N	\N	\N	67197	67197	235362
2524	2092	0	applied	\N	\N	\N	\N	67198	67198	235363
2524	2093	1	applied	\N	\N	\N	\N	67199	67199	235364
2526	2097	0	applied	\N	\N	\N	\N	67203	67203	235368
2527	2097	0	applied	\N	\N	\N	\N	67204	67204	235369
2529	2098	0	applied	\N	\N	\N	\N	67206	67206	235371
2531	2100	0	applied	\N	\N	\N	\N	67208	67208	235373
2532	2065	0	applied	\N	\N	\N	\N	67209	67209	235374
2532	2054	1	applied	\N	\N	1000000000	\N	67210	67210	235375
2532	2089	2	applied	\N	\N	1000000000	\N	67211	67211	235376
2532	2051	3	applied	\N	\N	\N	\N	67212	67212	235377
2532	2052	4	applied	\N	\N	\N	\N	67213	67213	235378
2532	2053	5	applied	\N	\N	\N	\N	67214	67214	235379
2532	2055	6	applied	\N	\N	\N	\N	67215	67215	235380
2532	2056	7	applied	\N	\N	\N	\N	67216	67216	235381
2532	2057	8	applied	\N	\N	\N	\N	67217	67217	235382
2532	2058	9	applied	\N	\N	\N	\N	67218	67218	235383
2532	2059	10	applied	\N	\N	\N	\N	67219	67219	235384
2532	2060	11	applied	\N	\N	\N	\N	67220	67220	235385
2532	2062	13	applied	\N	\N	\N	\N	67222	67222	235387
2532	2063	14	applied	\N	\N	\N	\N	67223	67223	235388
2532	2064	15	applied	\N	\N	\N	\N	67224	67224	235389
2532	2066	16	applied	\N	\N	\N	\N	67225	67225	235390
2532	2067	17	applied	\N	\N	\N	\N	67226	67226	235391
2532	2068	18	applied	\N	\N	\N	\N	67227	67227	235392
2532	2069	19	applied	\N	\N	\N	\N	67228	67228	235393
2532	2070	20	applied	\N	\N	\N	\N	67229	67229	235394
2532	2071	21	applied	\N	\N	\N	\N	67230	67230	235395
2532	2072	22	applied	\N	\N	\N	\N	67231	67231	235396
2532	2073	23	applied	\N	\N	\N	\N	67232	67232	235397
2532	2074	24	applied	\N	\N	\N	\N	67233	67233	235398
2532	2075	25	applied	\N	\N	\N	\N	67234	67234	235399
2532	2076	26	applied	\N	\N	\N	\N	67235	67235	235400
2532	2077	27	applied	\N	\N	\N	\N	67236	67236	235401
2532	2078	28	applied	\N	\N	\N	\N	67237	67237	235402
2532	2080	30	applied	\N	\N	\N	\N	67239	67239	235404
2532	2081	31	applied	\N	\N	\N	\N	67240	67240	235405
2532	2082	32	applied	\N	\N	\N	\N	67241	67241	235406
2532	2083	33	applied	\N	\N	\N	\N	67242	67242	235407
2532	2084	34	applied	\N	\N	\N	\N	67243	67243	235408
2532	2085	35	applied	\N	\N	\N	\N	67244	67244	235409
2534	2101	0	applied	\N	\N	\N	\N	67260	67260	235425
2534	2102	1	applied	\N	\N	\N	\N	67261	67261	235426
2537	2104	0	applied	\N	\N	\N	\N	67265	67265	235430
2537	2105	1	applied	\N	\N	\N	\N	67266	67266	235431
2540	2106	0	applied	\N	\N	\N	\N	67270	67270	235435
2543	2108	0	applied	\N	\N	\N	\N	67273	67273	235438
2549	2111	0	applied	\N	\N	\N	\N	67281	67281	235446
2549	2112	1	applied	\N	\N	\N	\N	67282	67282	235447
2549	2113	2	applied	\N	\N	\N	\N	67283	67283	235448
2549	2114	3	applied	\N	\N	\N	\N	67284	67284	235449
2556	2121	0	applied	\N	\N	\N	\N	67373	67373	235538
2559	2125	0	applied	\N	\N	\N	\N	67377	67377	235542
2562	2126	0	applied	\N	\N	\N	\N	67426	67426	235591
2562	2127	1	applied	\N	\N	\N	\N	67427	67427	235592
2564	2126	0	applied	\N	\N	\N	\N	67430	67430	235595
2564	2127	1	applied	\N	\N	\N	\N	67431	67431	235596
2418	1995	1	applied	\N	\N	\N	\N	66863	66863	235028
2422	1999	0	applied	\N	\N	\N	\N	66871	66871	235036
2485	2036	88	applied	\N	\N	\N	\N	67043	67043	235208
2485	2037	89	applied	\N	\N	\N	\N	67044	67044	235209
2485	2038	90	applied	\N	\N	\N	\N	67045	67045	235210
2485	2039	91	applied	\N	\N	\N	\N	67046	67046	235211
2485	2040	92	applied	\N	\N	\N	\N	67047	67047	235212
2485	2041	93	applied	\N	\N	\N	\N	67048	67048	235213
2485	2042	94	applied	\N	\N	\N	\N	67049	67049	235214
2485	2043	95	applied	\N	\N	\N	\N	67050	67050	235215
2485	2044	96	applied	\N	\N	\N	\N	67051	67051	235216
2485	2045	97	applied	\N	\N	\N	\N	67052	67052	235217
2485	2046	99	applied	\N	\N	\N	\N	67053	67053	235218
2485	2047	100	applied	\N	\N	\N	\N	67054	67054	235219
2485	2048	101	applied	\N	\N	\N	\N	67055	67055	235220
2487	2050	0	applied	\N	\N	\N	\N	67060	67060	235225
2489	2051	0	applied	\N	\N	\N	\N	67062	67062	235227
2490	2051	0	applied	\N	\N	\N	\N	67063	67063	235228
2493	2052	0	applied	\N	\N	\N	\N	67066	67066	235231
2496	2055	0	applied	\N	\N	\N	\N	67071	67071	235236
2496	2056	1	applied	\N	\N	\N	\N	67072	67072	235237
2496	2057	2	applied	\N	\N	\N	\N	67073	67073	235238
2496	2058	3	applied	\N	\N	\N	\N	67074	67074	235239
2501	1996	0	applied	\N	\N	\N	\N	67082	67082	235247
2501	2054	1	applied	\N	\N	1000000000	\N	67083	67083	235248
2501	1997	2	applied	\N	\N	\N	\N	67084	67084	235249
2501	1998	3	applied	\N	\N	\N	\N	67085	67085	235250
2501	1999	4	applied	\N	\N	\N	\N	67086	67086	235251
2501	2000	5	applied	\N	\N	\N	\N	67087	67087	235252
2501	2001	6	applied	\N	\N	\N	\N	67088	67088	235253
2501	2002	7	applied	\N	\N	\N	\N	67089	67089	235254
2501	2004	9	applied	\N	\N	\N	\N	67091	67091	235256
2501	2005	10	applied	\N	\N	\N	\N	67092	67092	235257
2501	2006	11	applied	\N	\N	\N	\N	67093	67093	235258
2501	2007	12	applied	\N	\N	\N	\N	67094	67094	235259
2501	2008	13	applied	\N	\N	\N	\N	67095	67095	235260
2501	2009	14	applied	\N	\N	\N	\N	67096	67096	235261
2501	2010	15	applied	\N	\N	\N	\N	67097	67097	235262
2501	2011	16	applied	\N	\N	\N	\N	67098	67098	235263
2501	2012	17	applied	\N	\N	\N	\N	67099	67099	235264
2501	2013	18	applied	\N	\N	\N	\N	67100	67100	235265
2501	2014	19	applied	\N	\N	\N	\N	67101	67101	235266
2501	2015	20	applied	\N	\N	\N	\N	67102	67102	235267
2501	2016	21	applied	\N	\N	\N	\N	67103	67103	235268
2501	2017	22	applied	\N	\N	\N	\N	67104	67104	235269
2501	2018	23	applied	\N	\N	\N	\N	67105	67105	235270
2501	2019	24	applied	\N	\N	\N	\N	67106	67106	235271
2501	2021	26	applied	\N	\N	\N	\N	67108	67108	235273
2501	2022	27	applied	\N	\N	\N	\N	67109	67109	235274
2501	2023	28	applied	\N	\N	\N	\N	67110	67110	235275
2501	2024	29	applied	\N	\N	\N	\N	67111	67111	235276
2501	2025	30	applied	\N	\N	\N	\N	67112	67112	235277
2501	2026	31	applied	\N	\N	\N	\N	67113	67113	235278
2501	2027	32	applied	\N	\N	\N	\N	67114	67114	235279
2501	2028	33	applied	\N	\N	\N	\N	67115	67115	235280
2501	2029	34	applied	\N	\N	\N	\N	67116	67116	235281
2501	2030	35	applied	\N	\N	\N	\N	67117	67117	235282
2501	2031	36	applied	\N	\N	\N	\N	67118	67118	235283
2501	2032	37	applied	\N	\N	\N	\N	67119	67119	235284
2501	2033	38	applied	\N	\N	\N	\N	67120	67120	235285
2501	2034	39	applied	\N	\N	\N	\N	67121	67121	235286
2501	2035	40	applied	\N	\N	\N	\N	67122	67122	235287
2501	2036	41	applied	\N	\N	\N	\N	67123	67123	235288
2501	2038	43	applied	\N	\N	\N	\N	67125	67125	235290
2501	2039	44	applied	\N	\N	\N	\N	67126	67126	235291
2501	2040	45	applied	\N	\N	\N	\N	67127	67127	235292
2501	2041	46	applied	\N	\N	\N	\N	67128	67128	235293
2501	2042	47	applied	\N	\N	\N	\N	67129	67129	235294
2501	2043	48	applied	\N	\N	\N	\N	67130	67130	235295
2501	2044	49	applied	\N	\N	\N	\N	67131	67131	235296
2532	2086	36	applied	\N	\N	\N	\N	67245	67245	235410
2532	2087	37	applied	\N	\N	\N	\N	67246	67246	235411
2532	2088	38	applied	\N	\N	\N	\N	67247	67247	235412
2532	2090	39	applied	\N	\N	\N	\N	67248	67248	235413
2532	2091	40	applied	\N	\N	\N	\N	67249	67249	235414
2532	2092	41	applied	\N	\N	\N	\N	67250	67250	235415
2532	2093	42	applied	\N	\N	\N	\N	67251	67251	235416
2532	2094	43	applied	\N	\N	\N	\N	67252	67252	235417
2532	2095	44	applied	\N	\N	\N	\N	67253	67253	235418
2532	2097	46	applied	\N	\N	\N	\N	67255	67255	235420
2532	2098	47	applied	\N	\N	\N	\N	67256	67256	235421
2532	2099	48	applied	\N	\N	\N	\N	67257	67257	235422
2532	2100	49	applied	\N	\N	\N	\N	67258	67258	235423
2532	2101	50	applied	\N	\N	\N	\N	67259	67259	235424
2535	2101	0	applied	\N	\N	\N	\N	67262	67262	235427
2535	2102	1	applied	\N	\N	\N	\N	67263	67263	235428
2536	2103	0	applied	\N	\N	\N	\N	67264	67264	235429
2539	2106	0	applied	\N	\N	\N	\N	67269	67269	235434
2541	2106	0	applied	\N	\N	\N	\N	67271	67271	235436
2542	2107	0	applied	\N	\N	\N	\N	67272	67272	235437
2545	2110	0	applied	\N	\N	\N	\N	67275	67275	235440
2548	2111	0	applied	\N	\N	\N	\N	67277	67277	235442
2548	2112	1	applied	\N	\N	\N	\N	67278	67278	235443
2548	2113	2	applied	\N	\N	\N	\N	67279	67279	235444
2548	2114	3	applied	\N	\N	\N	\N	67280	67280	235445
2551	2117	1	applied	\N	\N	\N	\N	67287	67287	235452
2555	2119	0	applied	\N	\N	\N	\N	67371	67371	235536
2555	2120	1	applied	\N	\N	\N	\N	67372	67372	235537
2558	2124	0	applied	\N	\N	\N	\N	67376	67376	235541
2561	2104	0	applied	\N	\N	\N	\N	67380	67380	235545
2561	2082	1	applied	\N	\N	\N	\N	67381	67381	235546
2561	2089	2	applied	\N	\N	1000000000	\N	67382	67382	235547
2561	2083	3	applied	\N	\N	\N	\N	67383	67383	235548
2561	2084	4	applied	\N	\N	\N	\N	67384	67384	235549
2561	2085	5	applied	\N	\N	\N	\N	67385	67385	235550
2561	2086	6	applied	\N	\N	\N	\N	67386	67386	235551
2561	2087	7	applied	\N	\N	\N	\N	67387	67387	235552
2561	2088	8	applied	\N	\N	\N	\N	67388	67388	235553
2561	2090	9	applied	\N	\N	\N	\N	67389	67389	235554
2561	2091	10	applied	\N	\N	\N	\N	67390	67390	235555
2561	2092	11	applied	\N	\N	\N	\N	67391	67391	235556
2485	2034	86	applied	\N	\N	\N	\N	67041	67041	235206
2485	2035	87	applied	\N	\N	\N	\N	67042	67042	235207
2501	2048	53	applied	\N	\N	\N	\N	67135	67135	235300
2501	2049	54	applied	\N	\N	\N	\N	67136	67136	235301
2501	2050	55	applied	\N	\N	\N	\N	67137	67137	235302
2501	2051	56	applied	\N	\N	\N	\N	67138	67138	235303
2501	2052	57	applied	\N	\N	\N	\N	67139	67139	235304
2501	2053	58	applied	\N	\N	\N	\N	67140	67140	235305
2501	2055	59	applied	\N	\N	\N	\N	67141	67141	235306
2501	2056	60	applied	\N	\N	\N	\N	67142	67142	235307
2501	2057	61	applied	\N	\N	\N	\N	67143	67143	235308
2501	2058	62	applied	\N	\N	\N	\N	67144	67144	235309
2501	2059	63	applied	\N	\N	\N	\N	67145	67145	235310
2501	2060	64	applied	\N	\N	\N	\N	67146	67146	235311
2501	2061	65	applied	\N	\N	\N	\N	67147	67147	235312
2501	2063	67	applied	\N	\N	\N	\N	67149	67149	235314
2501	2064	68	applied	\N	\N	\N	\N	67150	67150	235315
2502	2065	0	applied	\N	\N	\N	\N	67151	67151	235316
2502	2066	1	applied	\N	\N	\N	\N	67152	67152	235317
2502	2067	2	applied	\N	\N	\N	\N	67153	67153	235318
2502	2068	3	applied	\N	\N	\N	\N	67154	67154	235319
2507	2072	0	applied	\N	\N	\N	\N	67162	67162	235327
2507	2073	1	applied	\N	\N	\N	\N	67163	67163	235328
2508	2074	0	applied	\N	\N	\N	\N	67164	67164	235329
2508	2075	1	applied	\N	\N	\N	\N	67165	67165	235330
2508	2076	2	applied	\N	\N	\N	\N	67166	67166	235331
2510	2077	0	applied	\N	\N	\N	\N	67170	67170	235335
2512	2078	0	applied	\N	\N	\N	\N	67173	67173	235338
2512	2079	1	applied	\N	\N	\N	\N	67174	67174	235339
2514	2081	0	applied	\N	\N	\N	\N	67176	67176	235341
2515	2082	0	applied	\N	\N	\N	\N	67177	67177	235342
2518	2084	1	applied	\N	\N	\N	\N	67183	67183	235348
2518	2085	2	applied	\N	\N	\N	\N	67184	67184	235349
2519	2083	0	applied	\N	\N	\N	\N	67185	67185	235350
2519	2084	1	applied	\N	\N	\N	\N	67186	67186	235351
2519	2085	2	applied	\N	\N	\N	\N	67187	67187	235352
2522	2090	0	applied	\N	\N	\N	\N	67196	67196	235361
2525	2095	0	applied	\N	\N	\N	\N	67201	67201	235366
2525	2096	1	applied	\N	\N	\N	\N	67202	67202	235367
2528	2097	0	applied	\N	\N	\N	\N	67205	67205	235370
2530	2099	0	applied	\N	\N	\N	\N	67207	67207	235372
2538	2104	0	applied	\N	\N	\N	\N	67267	67267	235432
2538	2105	1	applied	\N	\N	\N	\N	67268	67268	235433
2544	2109	0	applied	\N	\N	\N	\N	67274	67274	235439
2546	2110	0	applied	\N	\N	\N	\N	67276	67276	235441
2550	2115	0	applied	\N	\N	\N	\N	67285	67285	235450
2553	2104	0	applied	\N	\N	\N	\N	67289	67289	235454
2553	2054	2	applied	\N	\N	1000000000	\N	67291	67291	235456
2553	2013	3	applied	\N	\N	\N	\N	67292	67292	235457
2553	2014	4	applied	\N	\N	\N	\N	67293	67293	235458
2553	2015	5	applied	\N	\N	\N	\N	67294	67294	235459
2553	2016	6	applied	\N	\N	\N	\N	67295	67295	235460
2553	2017	7	applied	\N	\N	\N	\N	67296	67296	235461
2553	2018	8	applied	\N	\N	\N	\N	67297	67297	235462
2553	2019	9	applied	\N	\N	\N	\N	67298	67298	235463
2553	2020	10	applied	\N	\N	\N	\N	67299	67299	235464
2553	2089	11	applied	\N	\N	1000000000	\N	67300	67300	235465
2553	2021	12	applied	\N	\N	\N	\N	67301	67301	235466
2553	2022	13	applied	\N	\N	\N	\N	67302	67302	235467
2553	2023	14	applied	\N	\N	\N	\N	67303	67303	235468
2553	2024	15	applied	\N	\N	\N	\N	67304	67304	235469
2553	2025	16	applied	\N	\N	\N	\N	67305	67305	235470
2553	2026	17	applied	\N	\N	\N	\N	67306	67306	235471
2553	2028	19	applied	\N	\N	\N	\N	67308	67308	235473
2553	2029	20	applied	\N	\N	\N	\N	67309	67309	235474
2553	2030	21	applied	\N	\N	\N	\N	67310	67310	235475
2553	2031	22	applied	\N	\N	\N	\N	67311	67311	235476
2553	2032	23	applied	\N	\N	\N	\N	67312	67312	235477
2553	2033	24	applied	\N	\N	\N	\N	67313	67313	235478
2553	2034	25	applied	\N	\N	\N	\N	67314	67314	235479
2553	2035	26	applied	\N	\N	\N	\N	67315	67315	235480
2553	2036	27	applied	\N	\N	\N	\N	67316	67316	235481
2553	2037	28	applied	\N	\N	\N	\N	67317	67317	235482
2553	2038	29	applied	\N	\N	\N	\N	67318	67318	235483
2553	2039	30	applied	\N	\N	\N	\N	67319	67319	235484
2553	2040	31	applied	\N	\N	\N	\N	67320	67320	235485
2553	2041	32	applied	\N	\N	\N	\N	67321	67321	235486
2553	2042	33	applied	\N	\N	\N	\N	67322	67322	235487
2553	2043	34	applied	\N	\N	\N	\N	67323	67323	235488
2553	2045	36	applied	\N	\N	\N	\N	67325	67325	235490
2553	2046	37	applied	\N	\N	\N	\N	67326	67326	235491
2553	2047	38	applied	\N	\N	\N	\N	67327	67327	235492
2553	2048	39	applied	\N	\N	\N	\N	67328	67328	235493
2553	2049	40	applied	\N	\N	\N	\N	67329	67329	235494
2553	2050	41	applied	\N	\N	\N	\N	67330	67330	235495
2553	2051	42	applied	\N	\N	\N	\N	67331	67331	235496
2553	2052	43	applied	\N	\N	\N	\N	67332	67332	235497
2553	2053	44	applied	\N	\N	\N	\N	67333	67333	235498
2553	2055	45	applied	\N	\N	\N	\N	67334	67334	235499
2553	2056	46	applied	\N	\N	\N	\N	67335	67335	235500
2553	2057	47	applied	\N	\N	\N	\N	67336	67336	235501
2553	2058	48	applied	\N	\N	\N	\N	67337	67337	235502
2553	2059	49	applied	\N	\N	\N	\N	67338	67338	235503
2553	2060	50	applied	\N	\N	\N	\N	67339	67339	235504
2553	2061	51	applied	\N	\N	\N	\N	67340	67340	235505
2553	2063	53	applied	\N	\N	\N	\N	67342	67342	235507
2553	2064	54	applied	\N	\N	\N	\N	67343	67343	235508
2553	2066	55	applied	\N	\N	\N	\N	67344	67344	235509
2553	2067	56	applied	\N	\N	\N	\N	67345	67345	235510
2553	2068	57	applied	\N	\N	\N	\N	67346	67346	235511
2553	2069	58	applied	\N	\N	\N	\N	67347	67347	235512
2553	2070	59	applied	\N	\N	\N	\N	67348	67348	235513
2553	2071	60	applied	\N	\N	\N	\N	67349	67349	235514
2553	2072	61	applied	\N	\N	\N	\N	67350	67350	235515
2553	2073	62	applied	\N	\N	\N	\N	67351	67351	235516
2553	2074	63	applied	\N	\N	\N	\N	67352	67352	235517
2553	2075	64	applied	\N	\N	\N	\N	67353	67353	235518
2553	2076	65	applied	\N	\N	\N	\N	67354	67354	235519
2553	2077	66	applied	\N	\N	\N	\N	67355	67355	235520
2553	2078	67	applied	\N	\N	\N	\N	67356	67356	235521
2553	2079	69	applied	\N	\N	\N	\N	67357	67357	235522
2501	2046	51	applied	\N	\N	\N	\N	67133	67133	235298
2501	2047	52	applied	\N	\N	\N	\N	67134	67134	235299
2553	2085	75	applied	\N	\N	\N	\N	67363	67363	235528
2553	2086	76	applied	\N	\N	\N	\N	67364	67364	235529
2553	2087	77	applied	\N	\N	\N	\N	67365	67365	235530
2553	2088	78	applied	\N	\N	\N	\N	67366	67366	235531
2553	2090	79	applied	\N	\N	\N	\N	67367	67367	235532
2553	2091	80	applied	\N	\N	\N	\N	67368	67368	235533
2554	2119	0	applied	\N	\N	\N	\N	67369	67369	235534
2554	2120	1	applied	\N	\N	\N	\N	67370	67370	235535
2557	2122	0	applied	\N	\N	\N	\N	67374	67374	235539
2557	2123	1	applied	\N	\N	\N	\N	67375	67375	235540
2560	2126	0	applied	\N	\N	\N	\N	67378	67378	235543
2560	2127	1	applied	\N	\N	\N	\N	67379	67379	235544
2561	2094	13	applied	\N	\N	\N	\N	67393	67393	235558
2561	2095	14	applied	\N	\N	\N	\N	67394	67394	235559
2561	2097	16	applied	\N	\N	\N	\N	67396	67396	235561
2561	2098	17	applied	\N	\N	\N	\N	67397	67397	235562
2561	2099	18	applied	\N	\N	\N	\N	67398	67398	235563
2561	2100	19	applied	\N	\N	\N	\N	67399	67399	235564
2561	2101	20	applied	\N	\N	\N	\N	67400	67400	235565
2561	2102	21	applied	\N	\N	\N	\N	67401	67401	235566
2561	2103	22	applied	\N	\N	\N	\N	67402	67402	235567
2561	2105	23	applied	\N	\N	\N	\N	67403	67403	235568
2561	2106	24	applied	\N	\N	\N	\N	67404	67404	235569
2561	2107	25	applied	\N	\N	\N	\N	67405	67405	235570
2561	2108	26	applied	\N	\N	\N	\N	67406	67406	235571
2561	2109	27	applied	\N	\N	\N	\N	67407	67407	235572
2561	2110	28	applied	\N	\N	\N	\N	67408	67408	235573
2561	2111	29	applied	\N	\N	\N	\N	67409	67409	235574
2561	2112	30	applied	\N	\N	\N	\N	67410	67410	235575
2561	2113	31	applied	\N	\N	\N	\N	67411	67411	235576
2561	2115	33	applied	\N	\N	\N	\N	67413	67413	235578
2561	2116	34	applied	\N	\N	\N	\N	67414	67414	235579
2561	2117	35	applied	\N	\N	\N	\N	67415	67415	235580
2561	2118	36	applied	\N	\N	\N	\N	67416	67416	235581
2561	2119	37	applied	\N	\N	\N	\N	67417	67417	235582
2561	2120	38	applied	\N	\N	\N	\N	67418	67418	235583
2561	2121	39	applied	\N	\N	\N	\N	67419	67419	235584
2561	2122	40	applied	\N	\N	\N	\N	67420	67420	235585
2561	2123	42	applied	\N	\N	\N	\N	67421	67421	235586
2561	2124	43	applied	\N	\N	\N	\N	67422	67422	235587
2561	2125	44	applied	\N	\N	\N	\N	67423	67423	235588
2561	2126	45	applied	\N	\N	\N	\N	67424	67424	235589
2561	2127	46	applied	\N	\N	\N	\N	67425	67425	235590
2563	2126	0	applied	\N	\N	\N	\N	67428	67428	235593
2563	2127	1	applied	\N	\N	\N	\N	67429	67429	235594
2565	2128	0	applied	\N	\N	\N	\N	67432	67432	235597
2567	2130	0	applied	\N	\N	\N	\N	67434	67434	235599
2568	2130	0	applied	\N	\N	\N	\N	67435	67435	235600
2569	1856	0	applied	\N	\N	\N	\N	67436	67436	235601
2569	2104	1	applied	\N	\N	\N	\N	67437	67437	235602
2569	1815	2	applied	\N	\N	\N	\N	67438	67438	235603
2569	1996	3	applied	\N	\N	\N	\N	67439	67439	235604
2569	1816	4	applied	\N	\N	\N	\N	67440	67440	235605
2569	2054	5	applied	\N	\N	1000000000	\N	67441	67441	235606
2569	1817	6	applied	\N	\N	\N	\N	67442	67442	235607
2569	1818	7	applied	\N	\N	\N	\N	67443	67443	235608
2569	1819	8	applied	\N	\N	\N	\N	67444	67444	235609
2569	1820	9	applied	\N	\N	\N	\N	67445	67445	235610
2569	1821	10	applied	\N	\N	\N	\N	67446	67446	235611
2569	1822	12	applied	\N	\N	\N	\N	67447	67447	235612
2570	2130	0	applied	\N	\N	\N	\N	67448	67448	235613
2571	2131	0	applied	\N	\N	\N	\N	67449	67449	235614
2572	2133	0	applied	\N	\N	\N	\N	67451	67451	235616
2572	2134	1	applied	\N	\N	\N	\N	67452	67452	235617
2573	2135	0	applied	\N	\N	\N	\N	67453	67453	235618
2573	2136	1	applied	\N	\N	\N	\N	67454	67454	235619
2574	2137	0	applied	\N	\N	\N	\N	67455	67455	235620
2574	2138	1	applied	\N	\N	\N	\N	67456	67456	235621
2575	2139	0	applied	\N	\N	\N	\N	67457	67457	235622
2576	2140	0	applied	\N	\N	\N	\N	67458	67458	235623
2577	2140	0	applied	\N	\N	\N	\N	67459	67459	235624
2579	2141	0	applied	\N	\N	\N	\N	67460	67460	235625
2579	2142	1	applied	\N	\N	\N	\N	67461	67461	235626
2579	2143	2	applied	\N	\N	\N	\N	67462	67462	235627
2580	2141	0	applied	\N	\N	\N	\N	67463	67463	235628
2580	2142	1	applied	\N	\N	\N	\N	67464	67464	235629
2580	2143	2	applied	\N	\N	\N	\N	67465	67465	235630
2581	2144	0	applied	\N	\N	\N	\N	67466	67466	235631
2583	2145	0	applied	\N	\N	\N	\N	67468	67468	235633
2584	2145	0	applied	\N	\N	\N	\N	67469	67469	235634
2585	2145	0	applied	\N	\N	\N	\N	67470	67470	235635
2587	2146	0	applied	\N	\N	\N	\N	67471	67471	235636
2588	2146	0	applied	\N	\N	\N	\N	67472	67472	235637
2589	2147	0	applied	\N	\N	\N	\N	67473	67473	235638
2589	2148	1	applied	\N	\N	\N	\N	67474	67474	235639
2590	2147	0	applied	\N	\N	\N	\N	67475	67475	235640
2590	2148	1	applied	\N	\N	\N	\N	67476	67476	235641
2591	2149	0	applied	\N	\N	\N	\N	67477	67477	235642
2592	2150	0	applied	\N	\N	\N	\N	67478	67478	235643
2593	2150	0	applied	\N	\N	\N	\N	67479	67479	235644
2594	2150	0	applied	\N	\N	\N	\N	67480	67480	235645
2595	2151	0	applied	\N	\N	\N	\N	67481	67481	235646
2595	2152	1	applied	\N	\N	\N	\N	67482	67482	235647
2596	2151	0	applied	\N	\N	\N	\N	67483	67483	235648
2597	2151	0	applied	\N	\N	\N	\N	67485	67485	235650
2597	2152	1	applied	\N	\N	\N	\N	67486	67486	235651
2598	2153	0	applied	\N	\N	\N	\N	67487	67487	235652
2603	2154	0	applied	\N	\N	\N	\N	67488	67488	235653
2603	2155	1	applied	\N	\N	\N	\N	67489	67489	235654
2604	2154	0	applied	\N	\N	\N	\N	67490	67490	235655
2604	2155	1	applied	\N	\N	\N	\N	67491	67491	235656
2605	2156	0	applied	\N	\N	\N	\N	67492	67492	235657
2605	2157	1	applied	\N	\N	\N	\N	67493	67493	235658
2606	2156	0	applied	\N	\N	\N	\N	67494	67494	235659
2606	2157	1	applied	\N	\N	\N	\N	67495	67495	235660
2607	2158	0	applied	\N	\N	\N	\N	67496	67496	235661
2608	2158	0	applied	\N	\N	\N	\N	67497	67497	235662
2609	2128	0	applied	\N	\N	\N	\N	67498	67498	235663
2609	2129	1	applied	\N	\N	\N	\N	67499	67499	235664
2609	2130	2	applied	\N	\N	\N	\N	67500	67500	235665
2553	2084	74	applied	\N	\N	\N	\N	67362	67362	235527
2609	2135	7	applied	\N	\N	\N	\N	67505	67505	235670
2609	2136	8	applied	\N	\N	\N	\N	67506	67506	235671
2609	2137	9	applied	\N	\N	\N	\N	67507	67507	235672
2609	2138	10	applied	\N	\N	\N	\N	67508	67508	235673
2609	2139	11	applied	\N	\N	\N	\N	67509	67509	235674
2609	2140	12	applied	\N	\N	\N	\N	67510	67510	235675
2609	2141	13	applied	\N	\N	\N	\N	67511	67511	235676
2609	2142	14	applied	\N	\N	\N	\N	67512	67512	235677
2609	2143	15	applied	\N	\N	\N	\N	67513	67513	235678
2609	2144	16	applied	\N	\N	\N	\N	67514	67514	235679
2609	2145	17	applied	\N	\N	\N	\N	67515	67515	235680
2609	2146	18	applied	\N	\N	\N	\N	67516	67516	235681
2609	2147	19	applied	\N	\N	\N	\N	67517	67517	235682
2609	2148	20	applied	\N	\N	\N	\N	67518	67518	235683
2609	2150	22	applied	\N	\N	\N	\N	67520	67520	235685
2609	2151	23	applied	\N	\N	\N	\N	67521	67521	235686
2609	2152	24	applied	\N	\N	\N	\N	67522	67522	235687
2609	2153	25	applied	\N	\N	\N	\N	67523	67523	235688
2609	2154	26	applied	\N	\N	\N	\N	67524	67524	235689
2609	2155	27	applied	\N	\N	\N	\N	67525	67525	235690
2609	2156	28	applied	\N	\N	\N	\N	67526	67526	235691
2609	2157	29	applied	\N	\N	\N	\N	67527	67527	235692
2609	2158	30	applied	\N	\N	\N	\N	67528	67528	235693
2612	2161	0	applied	\N	\N	\N	\N	67533	67533	235698
2613	2162	0	applied	\N	\N	\N	\N	67534	67534	235699
2613	2163	1	applied	\N	\N	\N	\N	67535	67535	235700
2613	2164	2	applied	\N	\N	\N	\N	67536	67536	235701
2613	2165	3	applied	\N	\N	\N	\N	67537	67537	235702
2613	2166	4	applied	\N	\N	\N	\N	67538	67538	235703
2616	2168	0	applied	\N	\N	\N	\N	67545	67545	235710
2622	2169	0	applied	\N	\N	\N	\N	67549	67549	235714
2625	2174	0	applied	\N	\N	\N	\N	67554	67554	235719
2628	2175	0	applied	\N	\N	\N	\N	67557	67557	235722
2631	2177	0	applied	\N	\N	\N	\N	67561	67561	235726
2631	2178	1	applied	\N	\N	\N	\N	67562	67562	235727
2634	2180	0	applied	\N	\N	\N	\N	67565	67565	235730
2637	2181	0	applied	\N	\N	\N	\N	67568	67568	235733
2643	2184	0	applied	\N	\N	\N	\N	67574	67574	235739
2643	2185	1	applied	\N	\N	\N	\N	67575	67575	235740
2646	2187	0	applied	\N	\N	\N	\N	67578	67578	235743
2649	2189	0	applied	\N	\N	\N	\N	67581	67581	235746
2652	2190	0	applied	\N	\N	\N	\N	67585	67585	235750
2652	2191	1	applied	\N	\N	\N	\N	67586	67586	235751
2655	2104	0	applied	\N	\N	\N	\N	67594	67594	235759
2655	2065	1	applied	\N	\N	\N	\N	67595	67595	235760
2655	2066	3	applied	\N	\N	\N	\N	67597	67597	235762
2655	2067	4	applied	\N	\N	\N	\N	67598	67598	235763
2655	2068	5	applied	\N	\N	\N	\N	67599	67599	235764
2655	2069	6	applied	\N	\N	\N	\N	67600	67600	235765
2655	2070	7	applied	\N	\N	\N	\N	67601	67601	235766
2655	2071	8	applied	\N	\N	\N	\N	67602	67602	235767
2655	2072	9	applied	\N	\N	\N	\N	67603	67603	235768
2655	2073	10	applied	\N	\N	\N	\N	67604	67604	235769
2655	2074	11	applied	\N	\N	\N	\N	67605	67605	235770
2655	2075	12	applied	\N	\N	\N	\N	67606	67606	235771
2655	2076	13	applied	\N	\N	\N	\N	67607	67607	235772
2655	2077	14	applied	\N	\N	\N	\N	67608	67608	235773
2655	2078	15	applied	\N	\N	\N	\N	67609	67609	235774
2655	2079	16	applied	\N	\N	\N	\N	67610	67610	235775
2655	2080	17	applied	\N	\N	\N	\N	67611	67611	235776
2655	2081	18	applied	\N	\N	\N	\N	67612	67612	235777
2655	2082	19	applied	\N	\N	\N	\N	67613	67613	235778
2655	2083	20	applied	\N	\N	\N	\N	67614	67614	235779
2655	2084	21	applied	\N	\N	\N	\N	67615	67615	235780
2655	2086	23	applied	\N	\N	\N	\N	67617	67617	235782
2655	2087	24	applied	\N	\N	\N	\N	67618	67618	235783
2655	2088	25	applied	\N	\N	\N	\N	67619	67619	235784
2655	2090	26	applied	\N	\N	\N	\N	67620	67620	235785
2655	2091	27	applied	\N	\N	\N	\N	67621	67621	235786
2655	2092	28	applied	\N	\N	\N	\N	67622	67622	235787
2655	2093	29	applied	\N	\N	\N	\N	67623	67623	235788
2655	2094	30	applied	\N	\N	\N	\N	67624	67624	235789
2655	2095	31	applied	\N	\N	\N	\N	67625	67625	235790
2655	2096	32	applied	\N	\N	\N	\N	67626	67626	235791
2655	2097	33	applied	\N	\N	\N	\N	67627	67627	235792
2655	2098	34	applied	\N	\N	\N	\N	67628	67628	235793
2655	2099	35	applied	\N	\N	\N	\N	67629	67629	235794
2655	2100	37	applied	\N	\N	\N	\N	67630	67630	235795
2655	2101	38	applied	\N	\N	\N	\N	67631	67631	235796
2655	2102	39	applied	\N	\N	\N	\N	67632	67632	235797
2655	2105	41	applied	\N	\N	\N	\N	67634	67634	235799
2655	2106	42	applied	\N	\N	\N	\N	67635	67635	235800
2655	2107	43	applied	\N	\N	\N	\N	67636	67636	235801
2655	2108	44	applied	\N	\N	\N	\N	67637	67637	235802
2655	2109	45	applied	\N	\N	\N	\N	67638	67638	235803
2655	2110	46	applied	\N	\N	\N	\N	67639	67639	235804
2655	2111	47	applied	\N	\N	\N	\N	67640	67640	235805
2655	2112	48	applied	\N	\N	\N	\N	67641	67641	235806
2655	2113	49	applied	\N	\N	\N	\N	67642	67642	235807
2655	2114	50	applied	\N	\N	\N	\N	67643	67643	235808
2655	2115	51	applied	\N	\N	\N	\N	67644	67644	235809
2655	2116	52	applied	\N	\N	\N	\N	67645	67645	235810
2655	2117	53	applied	\N	\N	\N	\N	67646	67646	235811
2655	2118	54	applied	\N	\N	\N	\N	67647	67647	235812
2655	2119	55	applied	\N	\N	\N	\N	67648	67648	235813
2655	2120	56	applied	\N	\N	\N	\N	67649	67649	235814
2655	2122	58	applied	\N	\N	\N	\N	67651	67651	235816
2655	2123	59	applied	\N	\N	\N	\N	67652	67652	235817
2655	2124	60	applied	\N	\N	\N	\N	67653	67653	235818
2655	2125	61	applied	\N	\N	\N	\N	67654	67654	235819
2655	2126	62	applied	\N	\N	\N	\N	67655	67655	235820
2655	2127	63	applied	\N	\N	\N	\N	67656	67656	235821
2655	2128	64	applied	\N	\N	\N	\N	67657	67657	235822
2655	2129	65	applied	\N	\N	\N	\N	67658	67658	235823
2655	2130	66	applied	\N	\N	\N	\N	67659	67659	235824
2655	2131	67	applied	\N	\N	\N	\N	67660	67660	235825
2655	2132	68	applied	\N	\N	\N	\N	67661	67661	235826
2655	2133	69	applied	\N	\N	\N	\N	67662	67662	235827
2655	2134	70	applied	\N	\N	\N	\N	67663	67663	235828
2655	2135	71	applied	\N	\N	\N	\N	67664	67664	235829
2609	2133	5	applied	\N	\N	\N	\N	67503	67503	235668
2609	2134	6	applied	\N	\N	\N	\N	67504	67504	235669
2614	2162	0	applied	\N	\N	\N	\N	67539	67539	235704
2614	2163	1	applied	\N	\N	\N	\N	67540	67540	235705
2614	2164	2	applied	\N	\N	\N	\N	67541	67541	235706
2614	2165	3	applied	\N	\N	\N	\N	67542	67542	235707
2614	2166	4	applied	\N	\N	\N	\N	67543	67543	235708
2615	2167	0	applied	\N	\N	\N	\N	67544	67544	235709
2618	2169	0	applied	\N	\N	\N	\N	67546	67546	235711
2621	2169	0	applied	\N	\N	\N	\N	67548	67548	235713
2623	2170	0	applied	\N	\N	\N	\N	67550	67550	235715
2623	2171	1	applied	\N	\N	\N	\N	67551	67551	235716
2624	2172	0	applied	\N	\N	\N	\N	67552	67552	235717
2624	2173	1	applied	\N	\N	\N	\N	67553	67553	235718
2626	2174	0	applied	\N	\N	\N	\N	67555	67555	235720
2627	2174	0	applied	\N	\N	\N	\N	67556	67556	235721
2629	2176	0	applied	\N	\N	\N	\N	67558	67558	235723
2630	2177	0	applied	\N	\N	\N	\N	67559	67559	235724
2632	2179	0	applied	\N	\N	\N	\N	67563	67563	235728
2633	2179	0	applied	\N	\N	\N	\N	67564	67564	235729
2635	2180	0	applied	\N	\N	\N	\N	67566	67566	235731
2636	2181	0	applied	\N	\N	\N	\N	67567	67567	235732
2638	2182	0	applied	\N	\N	\N	\N	67569	67569	235734
2639	2182	0	applied	\N	\N	\N	\N	67570	67570	235735
2640	2182	0	applied	\N	\N	\N	\N	67571	67571	235736
2641	2182	0	applied	\N	\N	\N	\N	67572	67572	235737
2642	2183	0	applied	\N	\N	\N	\N	67573	67573	235738
2644	2186	0	applied	\N	\N	\N	\N	67576	67576	235741
2645	2187	0	applied	\N	\N	\N	\N	67577	67577	235742
2647	2188	0	applied	\N	\N	\N	\N	67579	67579	235744
2648	2188	0	applied	\N	\N	\N	\N	67580	67580	235745
2650	2189	0	applied	\N	\N	\N	\N	67582	67582	235747
2651	2190	0	applied	\N	\N	\N	\N	67583	67583	235748
2651	2191	1	applied	\N	\N	\N	\N	67584	67584	235749
2653	2191	1	applied	\N	\N	\N	\N	67588	67588	235753
2654	2192	0	applied	\N	\N	\N	\N	67589	67589	235754
2654	2193	1	applied	\N	\N	\N	\N	67590	67590	235755
2654	2194	2	applied	\N	\N	\N	\N	67591	67591	235756
2654	2195	3	applied	\N	\N	\N	\N	67592	67592	235757
2654	2196	4	applied	\N	\N	\N	\N	67593	67593	235758
2655	2136	72	applied	\N	\N	\N	\N	67665	67665	235830
2655	2137	73	applied	\N	\N	\N	\N	67666	67666	235831
2655	2138	74	applied	\N	\N	\N	\N	67667	67667	235832
2655	2139	75	applied	\N	\N	\N	\N	67668	67668	235833
2655	2140	76	applied	\N	\N	\N	\N	67669	67669	235834
2655	2141	77	applied	\N	\N	\N	\N	67670	67670	235835
2655	2142	78	applied	\N	\N	\N	\N	67671	67671	235836
2655	2143	79	applied	\N	\N	\N	\N	67672	67672	235837
2655	2144	80	applied	\N	\N	\N	\N	67673	67673	235838
2655	2145	81	applied	\N	\N	\N	\N	67674	67674	235839
2655	2147	83	applied	\N	\N	\N	\N	67676	67676	235841
2655	2148	84	applied	\N	\N	\N	\N	67677	67677	235842
2655	2149	85	applied	\N	\N	\N	\N	67678	67678	235843
2655	2150	86	applied	\N	\N	\N	\N	67679	67679	235844
2656	2197	0	applied	\N	\N	\N	\N	67680	67680	235845
2657	2197	0	applied	\N	\N	\N	\N	67681	67681	235846
2658	2197	0	applied	\N	\N	\N	\N	67682	67682	235847
2659	2198	0	applied	\N	\N	\N	\N	67683	67683	235848
2660	2198	0	applied	\N	\N	\N	\N	67684	67684	235849
2661	2198	0	applied	\N	\N	\N	\N	67685	67685	235850
2662	2199	0	applied	\N	\N	\N	\N	67686	67686	235851
2663	2199	0	applied	\N	\N	\N	\N	67688	67688	235853
2663	2200	1	applied	\N	\N	\N	\N	67689	67689	235854
2665	2201	0	applied	\N	\N	\N	\N	67691	67691	235856
2666	2201	0	applied	\N	\N	\N	\N	67692	67692	235857
2667	2202	0	applied	\N	\N	\N	\N	67693	67693	235858
2668	2204	1	applied	\N	\N	\N	\N	67695	67695	235860
2670	2203	0	applied	\N	\N	\N	\N	67698	67698	235863
2670	2204	1	applied	\N	\N	\N	\N	67699	67699	235864
2671	2205	0	applied	\N	\N	\N	\N	67700	67700	235865
2672	2206	0	applied	\N	\N	\N	\N	67701	67701	235866
2674	2207	0	applied	\N	\N	\N	\N	67703	67703	235868
2675	2208	0	applied	\N	\N	\N	\N	67704	67704	235869
2675	2209	1	applied	\N	\N	\N	\N	67705	67705	235870
2675	2210	2	applied	\N	\N	\N	\N	67706	67706	235871
2675	2211	3	applied	\N	\N	\N	\N	67707	67707	235872
2677	2208	0	applied	\N	\N	\N	\N	67712	67712	235877
2677	2209	1	applied	\N	\N	\N	\N	67713	67713	235878
2677	2210	2	applied	\N	\N	\N	\N	67714	67714	235879
2677	2211	3	applied	\N	\N	\N	\N	67715	67715	235880
2678	2212	0	applied	\N	\N	\N	\N	67716	67716	235881
2678	2213	1	applied	\N	\N	\N	\N	67717	67717	235882
2681	2215	0	applied	\N	\N	\N	\N	67720	67720	235885
2683	2216	0	applied	\N	\N	\N	\N	67815	67815	235980
2684	2216	0	applied	\N	\N	\N	\N	67816	67816	235981
2686	2217	0	applied	\N	\N	\N	\N	67818	67818	235983
2687	2218	0	applied	\N	\N	\N	\N	67819	67819	235984
2689	2218	0	applied	\N	\N	\N	\N	67821	67821	235986
2690	2218	0	applied	\N	\N	\N	\N	67822	67822	235987
2692	2220	0	applied	\N	\N	\N	\N	67824	67824	235989
2692	2221	1	applied	\N	\N	\N	\N	67825	67825	235990
2693	2220	0	applied	\N	\N	\N	\N	67826	67826	235991
2693	2221	1	applied	\N	\N	\N	\N	67827	67827	235992
2695	2223	0	applied	\N	\N	\N	\N	67829	67829	235994
2695	2224	1	applied	\N	\N	\N	\N	67830	67830	235995
2696	2225	0	applied	\N	\N	\N	\N	67831	67831	235996
2698	2226	0	applied	\N	\N	\N	\N	67833	67833	235998
2699	2226	0	applied	\N	\N	\N	\N	67834	67834	235999
2702	2227	0	applied	\N	\N	\N	\N	67837	67837	236002
2704	2228	0	applied	\N	\N	\N	\N	67963	67963	236128
2705	2230	0	applied	\N	\N	\N	\N	67965	67965	236130
2708	2231	0	applied	\N	\N	\N	\N	67968	67968	236133
2711	2233	0	applied	\N	\N	\N	\N	67971	67971	236136
2714	2234	0	applied	\N	\N	\N	\N	67973	67973	236138
2717	2239	0	applied	\N	\N	\N	\N	67978	67978	236143
2720	2240	0	applied	\N	\N	\N	\N	67982	67982	236147
2720	2241	1	applied	\N	\N	\N	\N	67983	67983	236148
2720	2242	2	applied	\N	\N	\N	\N	67984	67984	236149
2723	2244	0	applied	\N	\N	\N	\N	67988	67988	236153
2723	2245	1	applied	\N	\N	\N	\N	67989	67989	236154
2726	2244	0	applied	\N	\N	\N	\N	67994	67994	236159
2726	2245	1	applied	\N	\N	\N	\N	67995	67995	236160
2610	2160	1	applied	\N	\N	\N	\N	67530	67530	235695
2611	2159	0	applied	\N	\N	\N	\N	67531	67531	235696
2673	2206	0	applied	\N	\N	\N	\N	67702	67702	235867
2676	2208	0	applied	\N	\N	\N	\N	67708	67708	235873
2676	2209	1	applied	\N	\N	\N	\N	67709	67709	235874
2676	2210	2	applied	\N	\N	\N	\N	67710	67710	235875
2676	2211	3	applied	\N	\N	\N	\N	67711	67711	235876
2679	2214	0	applied	\N	\N	\N	\N	67718	67718	235883
2682	2104	0	applied	\N	\N	\N	\N	67721	67721	235886
2682	2065	1	applied	\N	\N	\N	\N	67722	67722	235887
2682	2002	2	applied	\N	\N	\N	\N	67723	67723	235888
2682	2054	3	applied	\N	\N	1000000000	\N	67724	67724	235889
2682	2003	4	applied	\N	\N	\N	\N	67725	67725	235890
2682	2004	6	applied	\N	\N	\N	\N	67727	67727	235892
2682	2005	7	applied	\N	\N	\N	\N	67728	67728	235893
2682	2006	8	applied	\N	\N	\N	\N	67729	67729	235894
2682	2007	9	applied	\N	\N	\N	\N	67730	67730	235895
2682	2008	10	applied	\N	\N	\N	\N	67731	67731	235896
2682	2009	11	applied	\N	\N	\N	\N	67732	67732	235897
2682	2010	12	applied	\N	\N	\N	\N	67733	67733	235898
2682	2011	13	applied	\N	\N	\N	\N	67734	67734	235899
2682	2012	14	applied	\N	\N	\N	\N	67735	67735	235900
2682	2013	15	applied	\N	\N	\N	\N	67736	67736	235901
2682	2014	16	applied	\N	\N	\N	\N	67737	67737	235902
2682	2015	17	applied	\N	\N	\N	\N	67738	67738	235903
2682	2016	18	applied	\N	\N	\N	\N	67739	67739	235904
2682	2017	19	applied	\N	\N	\N	\N	67740	67740	235905
2682	2018	20	applied	\N	\N	\N	\N	67741	67741	235906
2682	2019	21	applied	\N	\N	\N	\N	67742	67742	235907
2682	2020	22	applied	\N	\N	\N	\N	67743	67743	235908
2682	2021	23	applied	\N	\N	\N	\N	67744	67744	235909
2682	2022	24	applied	\N	\N	\N	\N	67745	67745	235910
2682	2024	26	applied	\N	\N	\N	\N	67747	67747	235912
2682	2025	27	applied	\N	\N	\N	\N	67748	67748	235913
2704	2229	1	applied	\N	\N	\N	\N	67964	67964	236129
2707	2231	0	applied	\N	\N	\N	\N	67967	67967	236132
2710	2233	0	applied	\N	\N	\N	\N	67970	67970	236135
2716	2238	0	applied	\N	\N	\N	\N	67977	67977	236142
2719	2240	0	applied	\N	\N	\N	\N	67980	67980	236145
2719	2241	1	applied	\N	\N	\N	\N	67981	67981	236146
2722	2243	0	applied	\N	\N	\N	\N	67987	67987	236152
2724	2244	0	applied	\N	\N	\N	\N	67990	67990	236155
2724	2245	1	applied	\N	\N	\N	\N	67991	67991	236156
2725	2244	0	applied	\N	\N	\N	\N	67992	67992	236157
2725	2245	1	applied	\N	\N	\N	\N	67993	67993	236158
2728	2154	0	applied	\N	\N	\N	\N	67998	67998	236163
2728	2155	1	applied	\N	\N	\N	\N	67999	67999	236164
2728	2156	2	applied	\N	\N	\N	\N	68000	68000	236165
2728	2158	4	applied	\N	\N	\N	\N	68002	68002	236167
2728	2159	5	applied	\N	\N	\N	\N	68003	68003	236168
2728	2160	6	applied	\N	\N	\N	\N	68004	68004	236169
2728	2161	7	applied	\N	\N	\N	\N	68005	68005	236170
2728	2162	8	applied	\N	\N	\N	\N	68006	68006	236171
2728	2163	9	applied	\N	\N	\N	\N	68007	68007	236172
2728	2164	10	applied	\N	\N	\N	\N	68008	68008	236173
2728	2165	11	applied	\N	\N	\N	\N	68009	68009	236174
2728	2166	12	applied	\N	\N	\N	\N	68010	68010	236175
2728	2167	13	applied	\N	\N	\N	\N	68011	68011	236176
2728	2168	14	applied	\N	\N	\N	\N	68012	68012	236177
2728	2169	15	applied	\N	\N	\N	\N	68013	68013	236178
2728	2170	16	applied	\N	\N	\N	\N	68014	68014	236179
2728	2171	17	applied	\N	\N	\N	\N	68015	68015	236180
2728	2172	18	applied	\N	\N	\N	\N	68016	68016	236181
2728	2173	19	applied	\N	\N	\N	\N	68017	68017	236182
2728	2175	21	applied	\N	\N	\N	\N	68019	68019	236184
2728	2176	22	applied	\N	\N	\N	\N	68020	68020	236185
2728	2177	23	applied	\N	\N	\N	\N	68021	68021	236186
2728	2178	24	applied	\N	\N	\N	\N	68022	68022	236187
2728	2179	25	applied	\N	\N	\N	\N	68023	68023	236188
2728	2180	26	applied	\N	\N	\N	\N	68024	68024	236189
2728	2181	27	applied	\N	\N	\N	\N	68025	68025	236190
2728	2182	29	applied	\N	\N	\N	\N	68026	68026	236191
2728	2183	30	applied	\N	\N	\N	\N	68027	68027	236192
2728	2184	31	applied	\N	\N	\N	\N	68028	68028	236193
2728	2185	32	applied	\N	\N	\N	\N	68029	68029	236194
2728	2186	33	applied	\N	\N	\N	\N	68030	68030	236195
2728	2187	34	applied	\N	\N	\N	\N	68031	68031	236196
2728	2188	35	applied	\N	\N	\N	\N	68032	68032	236197
2728	2189	36	applied	\N	\N	\N	\N	68033	68033	236198
2728	2190	37	applied	\N	\N	\N	\N	68034	68034	236199
2728	2192	39	applied	\N	\N	\N	\N	68036	68036	236201
2728	2193	40	applied	\N	\N	\N	\N	68037	68037	236202
2728	2194	41	applied	\N	\N	\N	\N	68038	68038	236203
2728	2195	42	applied	\N	\N	\N	\N	68039	68039	236204
2728	2196	43	applied	\N	\N	\N	\N	68040	68040	236205
2728	2197	44	applied	\N	\N	\N	\N	68041	68041	236206
2728	2198	45	applied	\N	\N	\N	\N	68042	68042	236207
2728	2199	46	applied	\N	\N	\N	\N	68043	68043	236208
2728	2200	47	applied	\N	\N	\N	\N	68044	68044	236209
2728	2201	48	applied	\N	\N	\N	\N	68045	68045	236210
2728	2202	49	applied	\N	\N	\N	\N	68046	68046	236211
2728	2203	50	applied	\N	\N	\N	\N	68047	68047	236212
2728	2204	51	applied	\N	\N	\N	\N	68048	68048	236213
2728	2205	52	applied	\N	\N	\N	\N	68049	68049	236214
2728	2206	53	applied	\N	\N	\N	\N	68050	68050	236215
2728	2207	54	applied	\N	\N	\N	\N	68051	68051	236216
2728	2209	56	applied	\N	\N	\N	\N	68053	68053	236218
2728	2210	57	applied	\N	\N	\N	\N	68054	68054	236219
2728	2211	58	applied	\N	\N	\N	\N	68055	68055	236220
2728	2212	59	applied	\N	\N	\N	\N	68056	68056	236221
2728	2213	60	applied	\N	\N	\N	\N	68057	68057	236222
2728	2214	61	applied	\N	\N	\N	\N	68058	68058	236223
2728	2215	62	applied	\N	\N	\N	\N	68059	68059	236224
2728	2216	63	applied	\N	\N	\N	\N	68060	68060	236225
2728	2217	64	applied	\N	\N	\N	\N	68061	68061	236226
2728	2218	65	applied	\N	\N	\N	\N	68062	68062	236227
2728	2219	66	applied	\N	\N	\N	\N	68063	68063	236228
2728	2220	67	applied	\N	\N	\N	\N	68064	68064	236229
2728	2221	68	applied	\N	\N	\N	\N	68065	68065	236230
2728	2222	69	applied	\N	\N	\N	\N	68066	68066	236231
2728	2223	70	applied	\N	\N	\N	\N	68067	68067	236232
2664	2201	0	applied	\N	\N	\N	\N	67690	67690	235855
2669	2204	1	applied	\N	\N	\N	\N	67697	67697	235862
2682	2029	31	applied	\N	\N	\N	\N	67752	67752	235917
2682	2030	32	applied	\N	\N	\N	\N	67753	67753	235918
2682	2031	33	applied	\N	\N	\N	\N	67754	67754	235919
2682	2032	34	applied	\N	\N	\N	\N	67755	67755	235920
2682	2033	35	applied	\N	\N	\N	\N	67756	67756	235921
2682	2034	36	applied	\N	\N	\N	\N	67757	67757	235922
2682	2035	37	applied	\N	\N	\N	\N	67758	67758	235923
2682	2036	38	applied	\N	\N	\N	\N	67759	67759	235924
2682	2037	39	applied	\N	\N	\N	\N	67760	67760	235925
2682	2038	40	applied	\N	\N	\N	\N	67761	67761	235926
2682	2039	41	applied	\N	\N	\N	\N	67762	67762	235927
2682	2040	42	applied	\N	\N	\N	\N	67763	67763	235928
2682	2041	43	applied	\N	\N	\N	\N	67764	67764	235929
2682	2043	45	applied	\N	\N	\N	\N	67766	67766	235931
2682	2044	46	applied	\N	\N	\N	\N	67767	67767	235932
2682	2045	47	applied	\N	\N	\N	\N	67768	67768	235933
2682	2046	48	applied	\N	\N	\N	\N	67769	67769	235934
2682	2047	49	applied	\N	\N	\N	\N	67770	67770	235935
2682	2048	50	applied	\N	\N	\N	\N	67771	67771	235936
2682	2049	51	applied	\N	\N	\N	\N	67772	67772	235937
2682	2050	52	applied	\N	\N	\N	\N	67773	67773	235938
2682	2051	53	applied	\N	\N	\N	\N	67774	67774	235939
2682	2052	54	applied	\N	\N	\N	\N	67775	67775	235940
2682	2053	55	applied	\N	\N	\N	\N	67776	67776	235941
2682	2055	56	applied	\N	\N	\N	\N	67777	67777	235942
2682	2056	57	applied	\N	\N	\N	\N	67778	67778	235943
2682	2057	58	applied	\N	\N	\N	\N	67779	67779	235944
2682	2058	59	applied	\N	\N	\N	\N	67780	67780	235945
2682	2059	60	applied	\N	\N	\N	\N	67781	67781	235946
2682	2061	62	applied	\N	\N	\N	\N	67783	67783	235948
2682	2062	63	applied	\N	\N	\N	\N	67784	67784	235949
2682	2063	64	applied	\N	\N	\N	\N	67785	67785	235950
2682	2064	65	applied	\N	\N	\N	\N	67786	67786	235951
2682	2066	66	applied	\N	\N	\N	\N	67787	67787	235952
2682	2067	67	applied	\N	\N	\N	\N	67788	67788	235953
2682	2068	68	applied	\N	\N	\N	\N	67789	67789	235954
2682	2069	69	applied	\N	\N	\N	\N	67790	67790	235955
2682	2070	70	applied	\N	\N	\N	\N	67791	67791	235956
2682	2071	71	applied	\N	\N	\N	\N	67792	67792	235957
2682	2072	72	applied	\N	\N	\N	\N	67793	67793	235958
2682	2073	73	applied	\N	\N	\N	\N	67794	67794	235959
2682	2074	74	applied	\N	\N	\N	\N	67795	67795	235960
2682	2075	75	applied	\N	\N	\N	\N	67796	67796	235961
2682	2076	76	applied	\N	\N	\N	\N	67797	67797	235962
2682	2077	77	applied	\N	\N	\N	\N	67798	67798	235963
2682	2079	79	applied	\N	\N	\N	\N	67800	67800	235965
2682	2080	80	applied	\N	\N	\N	\N	67801	67801	235966
2682	2081	81	applied	\N	\N	\N	\N	67802	67802	235967
2682	2082	82	applied	\N	\N	\N	\N	67803	67803	235968
2682	2083	83	applied	\N	\N	\N	\N	67804	67804	235969
2682	2084	84	applied	\N	\N	\N	\N	67805	67805	235970
2682	2085	85	applied	\N	\N	\N	\N	67806	67806	235971
2682	2086	86	applied	\N	\N	\N	\N	67807	67807	235972
2682	2087	87	applied	\N	\N	\N	\N	67808	67808	235973
2682	2088	88	applied	\N	\N	\N	\N	67809	67809	235974
2682	2090	89	applied	\N	\N	\N	\N	67810	67810	235975
2682	2091	90	applied	\N	\N	\N	\N	67811	67811	235976
2682	2092	91	applied	\N	\N	\N	\N	67812	67812	235977
2682	2093	92	applied	\N	\N	\N	\N	67813	67813	235978
2682	2094	93	applied	\N	\N	\N	\N	67814	67814	235979
2685	2217	0	applied	\N	\N	\N	\N	67817	67817	235982
2691	2219	0	applied	\N	\N	\N	\N	67823	67823	235988
2694	2222	0	applied	\N	\N	\N	\N	67828	67828	235993
2697	2226	0	applied	\N	\N	\N	\N	67832	67832	235997
2700	2227	0	applied	\N	\N	\N	\N	67835	67835	236000
2703	2104	0	applied	\N	\N	\N	\N	67838	67838	236003
2703	2065	1	applied	\N	\N	\N	\N	67839	67839	236004
2703	2054	2	applied	\N	\N	1000000000	\N	67840	67840	236005
2703	2089	3	applied	\N	\N	1000000000	\N	67841	67841	236006
2703	2029	4	applied	\N	\N	\N	\N	67842	67842	236007
2703	2030	5	applied	\N	\N	\N	\N	67843	67843	236008
2703	2031	6	applied	\N	\N	\N	\N	67844	67844	236009
2703	2032	7	applied	\N	\N	\N	\N	67845	67845	236010
2703	2033	8	applied	\N	\N	\N	\N	67846	67846	236011
2703	2034	9	applied	\N	\N	\N	\N	67847	67847	236012
2703	2035	10	applied	\N	\N	\N	\N	67848	67848	236013
2703	2036	11	applied	\N	\N	\N	\N	67849	67849	236014
2703	2038	13	applied	\N	\N	\N	\N	67851	67851	236016
2703	2039	14	applied	\N	\N	\N	\N	67852	67852	236017
2703	2040	15	applied	\N	\N	\N	\N	67853	67853	236018
2703	2041	16	applied	\N	\N	\N	\N	67854	67854	236019
2703	2042	17	applied	\N	\N	\N	\N	67855	67855	236020
2703	2043	18	applied	\N	\N	\N	\N	67856	67856	236021
2703	2044	19	applied	\N	\N	\N	\N	67857	67857	236022
2703	2045	20	applied	\N	\N	\N	\N	67858	67858	236023
2703	2046	21	applied	\N	\N	\N	\N	67859	67859	236024
2703	2047	22	applied	\N	\N	\N	\N	67860	67860	236025
2703	2048	23	applied	\N	\N	\N	\N	67861	67861	236026
2703	2049	24	applied	\N	\N	\N	\N	67862	67862	236027
2703	2050	25	applied	\N	\N	\N	\N	67863	67863	236028
2703	2051	26	applied	\N	\N	\N	\N	67864	67864	236029
2703	2052	27	applied	\N	\N	\N	\N	67865	67865	236030
2703	2053	29	applied	\N	\N	\N	\N	67866	67866	236031
2703	2056	31	applied	\N	\N	\N	\N	67868	67868	236033
2703	2057	32	applied	\N	\N	\N	\N	67869	67869	236034
2703	2058	33	applied	\N	\N	\N	\N	67870	67870	236035
2703	2059	34	applied	\N	\N	\N	\N	67871	67871	236036
2703	2060	35	applied	\N	\N	\N	\N	67872	67872	236037
2703	2061	36	applied	\N	\N	\N	\N	67873	67873	236038
2703	2062	37	applied	\N	\N	\N	\N	67874	67874	236039
2703	2063	38	applied	\N	\N	\N	\N	67875	67875	236040
2703	2064	39	applied	\N	\N	\N	\N	67876	67876	236041
2703	2066	40	applied	\N	\N	\N	\N	67877	67877	236042
2703	2067	41	applied	\N	\N	\N	\N	67878	67878	236043
2703	2068	42	applied	\N	\N	\N	\N	67879	67879	236044
2703	2069	43	applied	\N	\N	\N	\N	67880	67880	236045
2703	2070	44	applied	\N	\N	\N	\N	67881	67881	236046
2703	2071	45	applied	\N	\N	\N	\N	67882	67882	236047
2703	2072	46	applied	\N	\N	\N	\N	67883	67883	236048
2682	2027	29	applied	\N	\N	\N	\N	67750	67750	235915
2682	2028	30	applied	\N	\N	\N	\N	67751	67751	235916
2703	2078	52	applied	\N	\N	\N	\N	67889	67889	236054
2703	2079	53	applied	\N	\N	\N	\N	67890	67890	236055
2703	2080	54	applied	\N	\N	\N	\N	67891	67891	236056
2703	2081	55	applied	\N	\N	\N	\N	67892	67892	236057
2703	2082	56	applied	\N	\N	\N	\N	67893	67893	236058
2703	2083	57	applied	\N	\N	\N	\N	67894	67894	236059
2703	2084	58	applied	\N	\N	\N	\N	67895	67895	236060
2703	2085	59	applied	\N	\N	\N	\N	67896	67896	236061
2703	2086	60	applied	\N	\N	\N	\N	67897	67897	236062
2703	2087	61	applied	\N	\N	\N	\N	67898	67898	236063
2703	2088	62	applied	\N	\N	\N	\N	67899	67899	236064
2703	2090	63	applied	\N	\N	\N	\N	67900	67900	236065
2703	2091	64	applied	\N	\N	\N	\N	67901	67901	236066
2703	2092	65	applied	\N	\N	\N	\N	67902	67902	236067
2703	2093	66	applied	\N	\N	\N	\N	67903	67903	236068
2703	2094	67	applied	\N	\N	\N	\N	67904	67904	236069
2703	2096	69	applied	\N	\N	\N	\N	67906	67906	236071
2703	2097	70	applied	\N	\N	\N	\N	67907	67907	236072
2703	2098	71	applied	\N	\N	\N	\N	67908	67908	236073
2703	2099	72	applied	\N	\N	\N	\N	67909	67909	236074
2703	2100	73	applied	\N	\N	\N	\N	67910	67910	236075
2703	2101	74	applied	\N	\N	\N	\N	67911	67911	236076
2703	2102	75	applied	\N	\N	\N	\N	67912	67912	236077
2703	2103	76	applied	\N	\N	\N	\N	67913	67913	236078
2703	2105	77	applied	\N	\N	\N	\N	67914	67914	236079
2703	2106	78	applied	\N	\N	\N	\N	67915	67915	236080
2703	2107	79	applied	\N	\N	\N	\N	67916	67916	236081
2703	2108	80	applied	\N	\N	\N	\N	67917	67917	236082
2703	2109	81	applied	\N	\N	\N	\N	67918	67918	236083
2703	2110	82	applied	\N	\N	\N	\N	67919	67919	236084
2703	2111	83	applied	\N	\N	\N	\N	67920	67920	236085
2703	2112	84	applied	\N	\N	\N	\N	67921	67921	236086
2703	2114	86	applied	\N	\N	\N	\N	67923	67923	236088
2703	2115	87	applied	\N	\N	\N	\N	67924	67924	236089
2703	2116	88	applied	\N	\N	\N	\N	67925	67925	236090
2703	2117	89	applied	\N	\N	\N	\N	67926	67926	236091
2703	2118	90	applied	\N	\N	\N	\N	67927	67927	236092
2703	2119	91	applied	\N	\N	\N	\N	67928	67928	236093
2703	2120	92	applied	\N	\N	\N	\N	67929	67929	236094
2703	2121	93	applied	\N	\N	\N	\N	67930	67930	236095
2703	2122	94	applied	\N	\N	\N	\N	67931	67931	236096
2703	2123	95	applied	\N	\N	\N	\N	67932	67932	236097
2703	2124	96	applied	\N	\N	\N	\N	67933	67933	236098
2703	2125	97	applied	\N	\N	\N	\N	67934	67934	236099
2703	2126	98	applied	\N	\N	\N	\N	67935	67935	236100
2703	2127	99	applied	\N	\N	\N	\N	67936	67936	236101
2703	2128	100	applied	\N	\N	\N	\N	67937	67937	236102
2703	2129	101	applied	\N	\N	\N	\N	67938	67938	236103
2703	2131	103	applied	\N	\N	\N	\N	67940	67940	236105
2703	2132	104	applied	\N	\N	\N	\N	67941	67941	236106
2703	2133	105	applied	\N	\N	\N	\N	67942	67942	236107
2703	2134	106	applied	\N	\N	\N	\N	67943	67943	236108
2703	2135	107	applied	\N	\N	\N	\N	67944	67944	236109
2703	2136	108	applied	\N	\N	\N	\N	67945	67945	236110
2703	2137	109	applied	\N	\N	\N	\N	67946	67946	236111
2703	2138	110	applied	\N	\N	\N	\N	67947	67947	236112
2703	2139	111	applied	\N	\N	\N	\N	67948	67948	236113
2703	2140	112	applied	\N	\N	\N	\N	67949	67949	236114
2703	2141	113	applied	\N	\N	\N	\N	67950	67950	236115
2703	2142	114	applied	\N	\N	\N	\N	67951	67951	236116
2703	2143	115	applied	\N	\N	\N	\N	67952	67952	236117
2703	2144	116	applied	\N	\N	\N	\N	67953	67953	236118
2703	2145	117	applied	\N	\N	\N	\N	67954	67954	236119
2703	2146	118	applied	\N	\N	\N	\N	67955	67955	236120
2703	2148	120	applied	\N	\N	\N	\N	67957	67957	236122
2703	2149	121	applied	\N	\N	\N	\N	67958	67958	236123
2703	2150	122	applied	\N	\N	\N	\N	67959	67959	236124
2703	2151	123	applied	\N	\N	\N	\N	67960	67960	236125
2703	2152	124	applied	\N	\N	\N	\N	67961	67961	236126
2703	2153	125	applied	\N	\N	\N	\N	67962	67962	236127
2706	2231	0	applied	\N	\N	\N	\N	67966	67966	236131
2709	2232	0	applied	\N	\N	\N	\N	67969	67969	236134
2712	2233	0	applied	\N	\N	\N	\N	67972	67972	236137
2715	2235	0	applied	\N	\N	\N	\N	67974	67974	236139
2715	2236	1	applied	\N	\N	\N	\N	67975	67975	236140
2715	2237	2	applied	\N	\N	\N	\N	67976	67976	236141
2718	2239	0	applied	\N	\N	\N	\N	67979	67979	236144
2721	2240	0	applied	\N	\N	\N	\N	67985	67985	236150
2721	2241	1	applied	\N	\N	\N	\N	67986	67986	236151
2727	2244	0	applied	\N	\N	\N	\N	67996	67996	236161
2728	2224	71	applied	\N	\N	\N	\N	68068	68068	236233
2728	2225	72	applied	\N	\N	\N	\N	68069	68069	236234
2728	2226	73	applied	\N	\N	\N	\N	68070	68070	236235
2728	2227	74	applied	\N	\N	\N	\N	68071	68071	236236
2728	2228	75	applied	\N	\N	\N	\N	68072	68072	236237
2728	2229	76	applied	\N	\N	\N	\N	68073	68073	236238
2728	2230	77	applied	\N	\N	\N	\N	68074	68074	236239
2728	2231	78	applied	\N	\N	\N	\N	68075	68075	236240
2728	2232	79	applied	\N	\N	\N	\N	68076	68076	236241
2728	2233	80	applied	\N	\N	\N	\N	68077	68077	236242
2728	2234	81	applied	\N	\N	\N	\N	68078	68078	236243
2728	2235	82	applied	\N	\N	\N	\N	68079	68079	236244
2728	2236	83	applied	\N	\N	\N	\N	68080	68080	236245
2728	2237	84	applied	\N	\N	\N	\N	68081	68081	236246
2728	2238	85	applied	\N	\N	\N	\N	68082	68082	236247
2728	2239	86	applied	\N	\N	\N	\N	68083	68083	236248
2728	2241	88	applied	\N	\N	\N	\N	68085	68085	236250
2728	2242	89	applied	\N	\N	\N	\N	68086	68086	236251
2728	2243	90	applied	\N	\N	\N	\N	68087	68087	236252
2728	2244	91	applied	\N	\N	\N	\N	68088	68088	236253
2728	2245	92	applied	\N	\N	\N	\N	68089	68089	236254
2729	2246	0	applied	\N	\N	\N	\N	68090	68090	236255
2730	2247	0	applied	\N	\N	\N	\N	68091	68091	236256
2731	2248	0	applied	\N	\N	\N	\N	68092	68092	236257
2731	2249	1	applied	\N	\N	\N	\N	68093	68093	236258
2732	2248	0	applied	\N	\N	\N	\N	68094	68094	236259
2732	2249	1	applied	\N	\N	\N	\N	68095	68095	236260
2733	2250	0	applied	\N	\N	\N	\N	68096	68096	236261
2734	2251	0	applied	\N	\N	\N	\N	68097	68097	236262
2734	2252	1	applied	\N	\N	\N	\N	68098	68098	236263
2703	2075	49	applied	\N	\N	\N	\N	67886	67886	236051
2703	2076	50	applied	\N	\N	\N	\N	67887	67887	236052
2738	2253	0	applied	\N	\N	\N	\N	68103	68103	236268
2739	2254	0	applied	\N	\N	\N	\N	68104	68104	236269
2740	2254	0	applied	\N	\N	\N	\N	68105	68105	236270
2741	2255	0	applied	\N	\N	\N	\N	68106	68106	236271
2741	2256	1	applied	\N	\N	\N	\N	68107	68107	236272
2742	2255	0	applied	\N	\N	\N	\N	68108	68108	236273
2742	2256	1	applied	\N	\N	\N	\N	68109	68109	236274
2743	2187	0	applied	\N	\N	\N	\N	68110	68110	236275
2743	2188	1	applied	\N	\N	\N	\N	68111	68111	236276
2743	2189	2	applied	\N	\N	\N	\N	68112	68112	236277
2743	2190	3	applied	\N	\N	\N	\N	68113	68113	236278
2743	2191	4	applied	\N	\N	\N	\N	68114	68114	236279
2743	2192	5	applied	\N	\N	\N	\N	68115	68115	236280
2743	2193	6	applied	\N	\N	\N	\N	68116	68116	236281
2743	2194	7	applied	\N	\N	\N	\N	68117	68117	236282
2743	2195	8	applied	\N	\N	\N	\N	68118	68118	236283
2743	2197	10	applied	\N	\N	\N	\N	68120	68120	236285
2743	2198	11	applied	\N	\N	\N	\N	68121	68121	236286
2743	2199	12	applied	\N	\N	\N	\N	68122	68122	236287
2743	2200	13	applied	\N	\N	\N	\N	68123	68123	236288
2743	2201	14	applied	\N	\N	\N	\N	68124	68124	236289
2743	2202	15	applied	\N	\N	\N	\N	68125	68125	236290
2743	2203	16	applied	\N	\N	\N	\N	68126	68126	236291
2743	2204	17	applied	\N	\N	\N	\N	68127	68127	236292
2743	2205	18	applied	\N	\N	\N	\N	68128	68128	236293
2743	2206	19	applied	\N	\N	\N	\N	68129	68129	236294
2743	2207	20	applied	\N	\N	\N	\N	68130	68130	236295
2743	2208	21	applied	\N	\N	\N	\N	68131	68131	236296
2743	2209	22	applied	\N	\N	\N	\N	68132	68132	236297
2743	2210	23	applied	\N	\N	\N	\N	68133	68133	236298
2743	2211	24	applied	\N	\N	\N	\N	68134	68134	236299
2743	2212	25	applied	\N	\N	\N	\N	68135	68135	236300
2743	2214	27	applied	\N	\N	\N	\N	68137	68137	236302
2743	2215	28	applied	\N	\N	\N	\N	68138	68138	236303
2743	2216	29	applied	\N	\N	\N	\N	68139	68139	236304
2743	2217	30	applied	\N	\N	\N	\N	68140	68140	236305
2743	2218	31	applied	\N	\N	\N	\N	68141	68141	236306
2743	2219	32	applied	\N	\N	\N	\N	68142	68142	236307
2743	2220	33	applied	\N	\N	\N	\N	68143	68143	236308
2743	2221	34	applied	\N	\N	\N	\N	68144	68144	236309
2743	2222	35	applied	\N	\N	\N	\N	68145	68145	236310
2743	2223	36	applied	\N	\N	\N	\N	68146	68146	236311
2743	2224	37	applied	\N	\N	\N	\N	68147	68147	236312
2743	2225	38	applied	\N	\N	\N	\N	68148	68148	236313
2743	2226	39	applied	\N	\N	\N	\N	68149	68149	236314
2743	2227	40	applied	\N	\N	\N	\N	68150	68150	236315
2743	2228	41	applied	\N	\N	\N	\N	68151	68151	236316
2743	2229	42	applied	\N	\N	\N	\N	68152	68152	236317
2743	2231	44	applied	\N	\N	\N	\N	68154	68154	236319
2743	2232	45	applied	\N	\N	\N	\N	68155	68155	236320
2743	2233	46	applied	\N	\N	\N	\N	68156	68156	236321
2743	2234	47	applied	\N	\N	\N	\N	68157	68157	236322
2743	2235	49	applied	\N	\N	\N	\N	68158	68158	236323
2743	2236	50	applied	\N	\N	\N	\N	68159	68159	236324
2743	2237	51	applied	\N	\N	\N	\N	68160	68160	236325
2743	2238	52	applied	\N	\N	\N	\N	68161	68161	236326
2743	2239	53	applied	\N	\N	\N	\N	68162	68162	236327
2743	2240	54	applied	\N	\N	\N	\N	68163	68163	236328
2743	2241	55	applied	\N	\N	\N	\N	68164	68164	236329
2743	2242	56	applied	\N	\N	\N	\N	68165	68165	236330
2743	2243	57	applied	\N	\N	\N	\N	68166	68166	236331
2743	2244	58	applied	\N	\N	\N	\N	68167	68167	236332
2743	2245	59	applied	\N	\N	\N	\N	68168	68168	236333
2743	2246	60	applied	\N	\N	\N	\N	68169	68169	236334
2743	2248	62	applied	\N	\N	\N	\N	68171	68171	236336
2743	2249	63	applied	\N	\N	\N	\N	68172	68172	236337
2743	2250	64	applied	\N	\N	\N	\N	68173	68173	236338
2743	2251	65	applied	\N	\N	\N	\N	68174	68174	236339
2743	2252	66	applied	\N	\N	\N	\N	68175	68175	236340
2743	2253	67	applied	\N	\N	\N	\N	68176	68176	236341
2743	2254	68	applied	\N	\N	\N	\N	68177	68177	236342
2743	2255	69	applied	\N	\N	\N	\N	68178	68178	236343
2743	2256	70	applied	\N	\N	\N	\N	68179	68179	236344
2744	2257	0	applied	\N	\N	\N	\N	68180	68180	236345
2745	2257	0	applied	\N	\N	\N	\N	68181	68181	236346
2746	2257	0	applied	\N	\N	\N	\N	68182	68182	236347
2747	2257	0	applied	\N	\N	\N	\N	68183	68183	236348
2749	2258	0	applied	\N	\N	\N	\N	68184	68184	236349
2750	2258	0	applied	\N	\N	\N	\N	68185	68185	236350
2753	2258	0	applied	\N	\N	\N	\N	68186	68186	236351
2755	2259	1	applied	\N	\N	\N	\N	68188	68188	236353
2757	2258	0	applied	\N	\N	\N	\N	68190	68190	236355
2757	2259	1	applied	\N	\N	\N	\N	68191	68191	236356
2758	2258	0	applied	\N	\N	\N	\N	68192	68192	236357
2758	2259	1	applied	\N	\N	\N	\N	68193	68193	236358
2762	2264	0	applied	\N	\N	\N	\N	68321	68321	236486
2765	2265	0	applied	\N	\N	\N	\N	68324	68324	236489
2770	2271	0	applied	\N	\N	\N	\N	68330	68330	236495
2773	2274	0	applied	\N	\N	\N	\N	68333	68333	236498
2776	2276	0	applied	\N	\N	\N	\N	68337	68337	236502
2776	2277	1	applied	\N	\N	\N	\N	68338	68338	236503
2778	2276	0	applied	\N	\N	\N	\N	68341	68341	236506
2778	2277	1	applied	\N	\N	\N	\N	68342	68342	236507
2779	2278	0	applied	\N	\N	\N	\N	68343	68343	236508
2779	2279	1	applied	\N	\N	\N	\N	68344	68344	236509
2785	2283	0	applied	\N	\N	\N	\N	68350	68350	236515
2794	2288	0	applied	\N	\N	\N	\N	68485	68485	236650
2797	2289	0	applied	\N	\N	\N	\N	68488	68488	236653
2800	2290	0	applied	\N	\N	\N	\N	68497	68497	236662
2800	2291	1	applied	\N	\N	\N	\N	68498	68498	236663
2800	2292	2	applied	\N	\N	\N	\N	68499	68499	236664
2800	2293	3	applied	\N	\N	\N	\N	68500	68500	236665
2802	2294	0	applied	\N	\N	\N	\N	68504	68504	236669
2802	2295	1	applied	\N	\N	\N	\N	68505	68505	236670
2802	2296	2	applied	\N	\N	\N	\N	68506	68506	236671
2803	2294	0	applied	\N	\N	\N	\N	68507	68507	236672
2803	2295	1	applied	\N	\N	\N	\N	68508	68508	236673
2803	2296	2	applied	\N	\N	\N	\N	68509	68509	236674
2805	2294	0	applied	\N	\N	\N	\N	68635	68635	236800
2805	2295	1	applied	\N	\N	\N	\N	68636	68636	236801
2735	2252	1	applied	\N	\N	\N	\N	68100	68100	236265
2736	2253	0	applied	\N	\N	\N	\N	68101	68101	236266
2760	2054	2	applied	\N	\N	1000000000	\N	68198	68198	236363
2760	2089	3	applied	\N	\N	1000000000	\N	68199	68199	236364
2760	2050	4	applied	\N	\N	\N	\N	68200	68200	236365
2760	2051	5	applied	\N	\N	\N	\N	68201	68201	236366
2760	2052	6	applied	\N	\N	\N	\N	68202	68202	236367
2760	2053	7	applied	\N	\N	\N	\N	68203	68203	236368
2760	2055	8	applied	\N	\N	\N	\N	68204	68204	236369
2760	2056	9	applied	\N	\N	\N	\N	68205	68205	236370
2760	2057	10	applied	\N	\N	\N	\N	68206	68206	236371
2760	2058	11	applied	\N	\N	\N	\N	68207	68207	236372
2760	2059	12	applied	\N	\N	\N	\N	68208	68208	236373
2760	2060	13	applied	\N	\N	\N	\N	68209	68209	236374
2760	2061	14	applied	\N	\N	\N	\N	68210	68210	236375
2760	2063	16	applied	\N	\N	\N	\N	68212	68212	236377
2760	2064	17	applied	\N	\N	\N	\N	68213	68213	236378
2760	2066	18	applied	\N	\N	\N	\N	68214	68214	236379
2760	2067	19	applied	\N	\N	\N	\N	68215	68215	236380
2760	2068	20	applied	\N	\N	\N	\N	68216	68216	236381
2760	2069	21	applied	\N	\N	\N	\N	68217	68217	236382
2760	2070	22	applied	\N	\N	\N	\N	68218	68218	236383
2760	2071	23	applied	\N	\N	\N	\N	68219	68219	236384
2760	2072	24	applied	\N	\N	\N	\N	68220	68220	236385
2760	2073	25	applied	\N	\N	\N	\N	68221	68221	236386
2760	2074	26	applied	\N	\N	\N	\N	68222	68222	236387
2760	2075	27	applied	\N	\N	\N	\N	68223	68223	236388
2760	2076	28	applied	\N	\N	\N	\N	68224	68224	236389
2760	2077	29	applied	\N	\N	\N	\N	68225	68225	236390
2760	2078	30	applied	\N	\N	\N	\N	68226	68226	236391
2760	2079	31	applied	\N	\N	\N	\N	68227	68227	236392
2760	2081	33	applied	\N	\N	\N	\N	68229	68229	236394
2760	2082	34	applied	\N	\N	\N	\N	68230	68230	236395
2760	2083	35	applied	\N	\N	\N	\N	68231	68231	236396
2760	2084	36	applied	\N	\N	\N	\N	68232	68232	236397
2760	2085	37	applied	\N	\N	\N	\N	68233	68233	236398
2760	2086	38	applied	\N	\N	\N	\N	68234	68234	236399
2760	2087	39	applied	\N	\N	\N	\N	68235	68235	236400
2760	2088	40	applied	\N	\N	\N	\N	68236	68236	236401
2760	2090	41	applied	\N	\N	\N	\N	68237	68237	236402
2760	2091	42	applied	\N	\N	\N	\N	68238	68238	236403
2760	2092	43	applied	\N	\N	\N	\N	68239	68239	236404
2760	2093	44	applied	\N	\N	\N	\N	68240	68240	236405
2760	2094	45	applied	\N	\N	\N	\N	68241	68241	236406
2760	2095	46	applied	\N	\N	\N	\N	68242	68242	236407
2760	2096	47	applied	\N	\N	\N	\N	68243	68243	236408
2760	2097	48	applied	\N	\N	\N	\N	68244	68244	236409
2760	2099	50	applied	\N	\N	\N	\N	68246	68246	236411
2760	2100	51	applied	\N	\N	\N	\N	68247	68247	236412
2760	2101	52	applied	\N	\N	\N	\N	68248	68248	236413
2760	2102	53	applied	\N	\N	\N	\N	68249	68249	236414
2805	2296	2	applied	\N	\N	\N	\N	68637	68637	236802
2806	2297	0	applied	\N	\N	\N	\N	68638	68638	236803
2809	2300	0	applied	\N	\N	\N	\N	68643	68643	236808
2812	2303	0	applied	\N	\N	\N	\N	68646	68646	236811
2815	2304	0	applied	\N	\N	\N	\N	68648	68648	236813
2829	2311	0	applied	\N	\N	\N	\N	68663	68663	236828
2829	2312	1	applied	\N	\N	\N	\N	68664	68664	236829
2829	2313	2	applied	\N	\N	\N	\N	68665	68665	236830
2829	2314	3	applied	\N	\N	\N	\N	68666	68666	236831
2829	2315	4	applied	\N	\N	\N	\N	68667	68667	236832
2829	2316	5	applied	\N	\N	\N	\N	68668	68668	236833
2829	2317	6	applied	\N	\N	\N	\N	68669	68669	236834
2832	2319	0	applied	\N	\N	\N	\N	68671	68671	236836
2832	2320	1	applied	\N	\N	\N	\N	68672	68672	236837
2834	2321	0	applied	\N	\N	\N	\N	68676	68676	236841
2838	2326	0	applied	\N	\N	\N	\N	68681	68681	236846
2838	2327	1	applied	\N	\N	\N	\N	68682	68682	236847
2838	2328	2	applied	\N	\N	\N	\N	68683	68683	236848
2841	2330	0	applied	\N	\N	\N	\N	68685	68685	236850
2841	2331	1	applied	\N	\N	\N	\N	68686	68686	236851
2844	2335	0	applied	\N	\N	\N	\N	68690	68690	236855
2847	2337	0	applied	\N	\N	\N	\N	68693	68693	236858
2847	2338	1	applied	\N	\N	\N	\N	68694	68694	236859
2850	2340	0	applied	\N	\N	\N	\N	68696	68696	236861
2856	2343	0	applied	\N	\N	\N	\N	68702	68702	236867
2856	2344	1	applied	\N	\N	\N	\N	68703	68703	236868
2856	2345	2	applied	\N	\N	\N	\N	68704	68704	236869
2858	2343	0	applied	\N	\N	\N	\N	68708	68708	236873
2858	2345	2	applied	\N	\N	\N	\N	68710	68710	236875
2859	2345	0	applied	\N	\N	\N	\N	68711	68711	236876
2862	2207	0	applied	\N	\N	\N	\N	68716	68716	236881
2863	2347	0	applied	\N	\N	\N	\N	68717	68717	236882
2863	2348	1	applied	\N	\N	\N	\N	68718	68718	236883
2866	2350	0	applied	\N	\N	\N	\N	68721	68721	236886
2866	2351	1	applied	\N	\N	\N	\N	68722	68722	236887
2866	2352	2	applied	\N	\N	\N	\N	68723	68723	236888
2869	2353	0	applied	\N	\N	\N	\N	68727	68727	236892
2872	2353	0	applied	\N	\N	\N	\N	68730	68730	236895
2872	2354	1	applied	\N	\N	\N	\N	68731	68731	236896
2875	2356	0	applied	\N	\N	\N	\N	68733	68733	236898
2878	2357	0	applied	\N	\N	\N	\N	68736	68736	236901
2881	2357	0	applied	\N	\N	\N	\N	68738	68738	236903
2881	2358	1	applied	\N	\N	\N	\N	68739	68739	236904
2883	2357	0	applied	\N	\N	\N	\N	68742	68742	236907
2884	2359	0	applied	\N	\N	\N	\N	68744	68744	236909
2886	2359	0	applied	\N	\N	\N	\N	68746	68746	236911
2887	2360	0	applied	\N	\N	\N	\N	68747	68747	236912
2890	2362	0	applied	\N	\N	\N	\N	68750	68750	236915
2892	2362	0	applied	\N	\N	\N	\N	68752	68752	236917
2896	2366	0	applied	\N	\N	\N	\N	68758	68758	236923
2896	2367	1	applied	\N	\N	\N	\N	68759	68759	236924
2899	2369	0	applied	\N	\N	\N	\N	68762	68762	236927
2902	2370	0	applied	\N	\N	\N	\N	68764	68764	236929
2906	2372	0	applied	\N	\N	\N	\N	68771	68771	236936
2906	2373	1	applied	\N	\N	\N	\N	68772	68772	236937
2906	2374	2	applied	\N	\N	\N	\N	68773	68773	236938
2906	2375	3	applied	\N	\N	\N	\N	68774	68774	236939
2909	2372	0	applied	\N	\N	\N	\N	68779	68779	236944
2909	2373	1	applied	\N	\N	\N	\N	68780	68780	236945
2909	2374	2	applied	\N	\N	\N	\N	68781	68781	236946
2760	2104	0	applied	\N	\N	\N	\N	68196	68196	236361
2760	2065	1	applied	\N	\N	\N	\N	68197	68197	236362
2760	2106	56	applied	\N	\N	\N	\N	68252	68252	236417
2760	2107	57	applied	\N	\N	\N	\N	68253	68253	236418
2760	2108	58	applied	\N	\N	\N	\N	68254	68254	236419
2760	2109	59	applied	\N	\N	\N	\N	68255	68255	236420
2760	2110	60	applied	\N	\N	\N	\N	68256	68256	236421
2760	2111	61	applied	\N	\N	\N	\N	68257	68257	236422
2760	2112	62	applied	\N	\N	\N	\N	68258	68258	236423
2760	2113	63	applied	\N	\N	\N	\N	68259	68259	236424
2760	2114	64	applied	\N	\N	\N	\N	68260	68260	236425
2760	2115	65	applied	\N	\N	\N	\N	68261	68261	236426
2760	2116	66	applied	\N	\N	\N	\N	68262	68262	236427
2760	2117	67	applied	\N	\N	\N	\N	68263	68263	236428
2760	2118	68	applied	\N	\N	\N	\N	68264	68264	236429
2760	2119	69	applied	\N	\N	\N	\N	68265	68265	236430
2760	2120	70	applied	\N	\N	\N	\N	68266	68266	236431
2760	2121	71	applied	\N	\N	\N	\N	68267	68267	236432
2760	2123	73	applied	\N	\N	\N	\N	68269	68269	236434
2760	2124	74	applied	\N	\N	\N	\N	68270	68270	236435
2760	2125	75	applied	\N	\N	\N	\N	68271	68271	236436
2760	2126	76	applied	\N	\N	\N	\N	68272	68272	236437
2760	2127	77	applied	\N	\N	\N	\N	68273	68273	236438
2760	2128	78	applied	\N	\N	\N	\N	68274	68274	236439
2760	2129	79	applied	\N	\N	\N	\N	68275	68275	236440
2760	2130	80	applied	\N	\N	\N	\N	68276	68276	236441
2760	2131	81	applied	\N	\N	\N	\N	68277	68277	236442
2760	2132	82	applied	\N	\N	\N	\N	68278	68278	236443
2760	2133	83	applied	\N	\N	\N	\N	68279	68279	236444
2760	2134	84	applied	\N	\N	\N	\N	68280	68280	236445
2760	2135	85	applied	\N	\N	\N	\N	68281	68281	236446
2760	2136	86	applied	\N	\N	\N	\N	68282	68282	236447
2760	2137	87	applied	\N	\N	\N	\N	68283	68283	236448
2760	2138	88	applied	\N	\N	\N	\N	68284	68284	236449
2760	2140	90	applied	\N	\N	\N	\N	68286	68286	236451
2760	2141	91	applied	\N	\N	\N	\N	68287	68287	236452
2760	2142	92	applied	\N	\N	\N	\N	68288	68288	236453
2760	2143	93	applied	\N	\N	\N	\N	68289	68289	236454
2760	2144	94	applied	\N	\N	\N	\N	68290	68290	236455
2760	2145	95	applied	\N	\N	\N	\N	68291	68291	236456
2760	2146	96	applied	\N	\N	\N	\N	68292	68292	236457
2760	2147	97	applied	\N	\N	\N	\N	68293	68293	236458
2760	2148	98	applied	\N	\N	\N	\N	68294	68294	236459
2760	2149	99	applied	\N	\N	\N	\N	68295	68295	236460
2760	2150	100	applied	\N	\N	\N	\N	68296	68296	236461
2760	2151	101	applied	\N	\N	\N	\N	68297	68297	236462
2760	2152	102	applied	\N	\N	\N	\N	68298	68298	236463
2760	2153	103	applied	\N	\N	\N	\N	68299	68299	236464
2760	2154	104	applied	\N	\N	\N	\N	68300	68300	236465
2760	2155	105	applied	\N	\N	\N	\N	68301	68301	236466
2760	2157	107	applied	\N	\N	\N	\N	68303	68303	236468
2760	2158	108	applied	\N	\N	\N	\N	68304	68304	236469
2760	2159	109	applied	\N	\N	\N	\N	68305	68305	236470
2760	2160	110	applied	\N	\N	\N	\N	68306	68306	236471
2760	2161	111	applied	\N	\N	\N	\N	68307	68307	236472
2760	2162	112	applied	\N	\N	\N	\N	68308	68308	236473
2760	2163	113	applied	\N	\N	\N	\N	68309	68309	236474
2760	2164	114	applied	\N	\N	\N	\N	68310	68310	236475
2760	2165	115	applied	\N	\N	\N	\N	68311	68311	236476
2760	2166	116	applied	\N	\N	\N	\N	68312	68312	236477
2760	2167	122	applied	\N	\N	\N	\N	68313	68313	236478
2763	2264	0	applied	\N	\N	\N	\N	68322	68322	236487
2769	2270	0	applied	\N	\N	\N	\N	68329	68329	236494
2771	2272	0	applied	\N	\N	\N	\N	68331	68331	236496
2774	2275	0	applied	\N	\N	\N	\N	68334	68334	236499
2780	2278	0	applied	\N	\N	\N	\N	68345	68345	236510
2783	2281	0	applied	\N	\N	\N	\N	68348	68348	236513
2786	2283	0	applied	\N	\N	\N	\N	68351	68351	236516
2788	2104	0	applied	\N	\N	\N	\N	68354	68354	236519
2788	2101	1	applied	\N	\N	\N	\N	68355	68355	236520
2788	2102	2	applied	\N	\N	\N	\N	68356	68356	236521
2788	2285	3	applied	\N	\N	\N	\N	68357	68357	236522
2788	2103	4	applied	\N	\N	\N	\N	68358	68358	236523
2788	2105	5	applied	\N	\N	\N	\N	68359	68359	236524
2788	2106	6	applied	\N	\N	\N	\N	68360	68360	236525
2788	2107	7	applied	\N	\N	\N	\N	68361	68361	236526
2788	2108	8	applied	\N	\N	\N	\N	68362	68362	236527
2788	2109	9	applied	\N	\N	\N	\N	68363	68363	236528
2788	2110	10	applied	\N	\N	\N	\N	68364	68364	236529
2788	2111	11	applied	\N	\N	\N	\N	68365	68365	236530
2788	2112	12	applied	\N	\N	\N	\N	68366	68366	236531
2788	2113	13	applied	\N	\N	\N	\N	68367	68367	236532
2788	2115	15	applied	\N	\N	\N	\N	68369	68369	236534
2788	2116	16	applied	\N	\N	\N	\N	68370	68370	236535
2788	2117	17	applied	\N	\N	\N	\N	68371	68371	236536
2788	2118	18	applied	\N	\N	\N	\N	68372	68372	236537
2788	2119	19	applied	\N	\N	\N	\N	68373	68373	236538
2788	2120	20	applied	\N	\N	\N	\N	68374	68374	236539
2788	2121	21	applied	\N	\N	\N	\N	68375	68375	236540
2788	2122	22	applied	\N	\N	\N	\N	68376	68376	236541
2788	2123	23	applied	\N	\N	\N	\N	68377	68377	236542
2788	2124	24	applied	\N	\N	\N	\N	68378	68378	236543
2788	2125	25	applied	\N	\N	\N	\N	68379	68379	236544
2788	2126	26	applied	\N	\N	\N	\N	68380	68380	236545
2788	2127	27	applied	\N	\N	\N	\N	68381	68381	236546
2788	2128	28	applied	\N	\N	\N	\N	68382	68382	236547
2788	2129	29	applied	\N	\N	\N	\N	68383	68383	236548
2788	2130	30	applied	\N	\N	\N	\N	68384	68384	236549
2788	2132	32	applied	\N	\N	\N	\N	68386	68386	236551
2788	2133	33	applied	\N	\N	\N	\N	68387	68387	236552
2788	2134	34	applied	\N	\N	\N	\N	68388	68388	236553
2788	2135	35	applied	\N	\N	\N	\N	68389	68389	236554
2788	2136	36	applied	\N	\N	\N	\N	68390	68390	236555
2788	2137	37	applied	\N	\N	\N	\N	68391	68391	236556
2788	2138	38	applied	\N	\N	\N	\N	68392	68392	236557
2788	2139	39	applied	\N	\N	\N	\N	68393	68393	236558
2788	2140	40	applied	\N	\N	\N	\N	68394	68394	236559
2788	2141	41	applied	\N	\N	\N	\N	68395	68395	236560
2788	2142	42	applied	\N	\N	\N	\N	68396	68396	236561
2788	2143	43	applied	\N	\N	\N	\N	68397	68397	236562
2788	2144	44	applied	\N	\N	\N	\N	68398	68398	236563
2788	2145	45	applied	\N	\N	\N	\N	68399	68399	236564
2759	2259	1	applied	\N	\N	\N	\N	68195	68195	236360
2760	2103	54	applied	\N	\N	\N	\N	68250	68250	236415
2761	2261	1	applied	\N	\N	\N	\N	68318	68318	236483
2761	2262	3	applied	\N	\N	\N	\N	68319	68319	236484
2761	2263	4	applied	\N	\N	\N	\N	68320	68320	236485
2764	2265	0	applied	\N	\N	\N	\N	68323	68323	236488
2767	2266	0	applied	\N	\N	\N	\N	68325	68325	236490
2767	2267	1	applied	\N	\N	\N	\N	68326	68326	236491
2767	2268	2	applied	\N	\N	\N	\N	68327	68327	236492
2767	2269	3	applied	\N	\N	\N	\N	68328	68328	236493
2772	2273	0	applied	\N	\N	\N	\N	68332	68332	236497
2775	2276	0	applied	\N	\N	\N	\N	68335	68335	236500
2775	2277	1	applied	\N	\N	\N	\N	68336	68336	236501
2777	2276	0	applied	\N	\N	\N	\N	68339	68339	236504
2777	2277	1	applied	\N	\N	\N	\N	68340	68340	236505
2781	2280	0	applied	\N	\N	\N	\N	68347	68347	236512
2787	2284	0	applied	\N	\N	\N	\N	68352	68352	236517
2787	2285	1	applied	\N	\N	\N	\N	68353	68353	236518
2788	2146	46	applied	\N	\N	\N	\N	68400	68400	236565
2788	2147	47	applied	\N	\N	\N	\N	68401	68401	236566
2788	2148	48	applied	\N	\N	\N	\N	68402	68402	236567
2788	2149	49	applied	\N	\N	\N	\N	68403	68403	236568
2788	2150	50	applied	\N	\N	\N	\N	68404	68404	236569
2788	2151	51	applied	\N	\N	\N	\N	68405	68405	236570
2788	2152	52	applied	\N	\N	\N	\N	68406	68406	236571
2788	2153	53	applied	\N	\N	\N	\N	68407	68407	236572
2788	2154	54	applied	\N	\N	\N	\N	68408	68408	236573
2788	2155	55	applied	\N	\N	\N	\N	68409	68409	236574
2788	2156	56	applied	\N	\N	\N	\N	68410	68410	236575
2788	2157	57	applied	\N	\N	\N	\N	68411	68411	236576
2788	2158	58	applied	\N	\N	\N	\N	68412	68412	236577
2788	2159	59	applied	\N	\N	\N	\N	68413	68413	236578
2788	2161	61	applied	\N	\N	\N	\N	68415	68415	236580
2788	2162	62	applied	\N	\N	\N	\N	68416	68416	236581
2788	2163	63	applied	\N	\N	\N	\N	68417	68417	236582
2788	2164	64	applied	\N	\N	\N	\N	68418	68418	236583
2788	2165	65	applied	\N	\N	\N	\N	68419	68419	236584
2788	2166	66	applied	\N	\N	\N	\N	68420	68420	236585
2788	2167	67	applied	\N	\N	\N	\N	68421	68421	236586
2788	2168	68	applied	\N	\N	\N	\N	68422	68422	236587
2788	2169	69	applied	\N	\N	\N	\N	68423	68423	236588
2788	2170	70	applied	\N	\N	\N	\N	68424	68424	236589
2788	2171	71	applied	\N	\N	\N	\N	68425	68425	236590
2788	2172	72	applied	\N	\N	\N	\N	68426	68426	236591
2788	2173	73	applied	\N	\N	\N	\N	68427	68427	236592
2788	2174	74	applied	\N	\N	\N	\N	68428	68428	236593
2788	2175	75	applied	\N	\N	\N	\N	68429	68429	236594
2788	2176	76	applied	\N	\N	\N	\N	68430	68430	236595
2788	2178	78	applied	\N	\N	\N	\N	68432	68432	236597
2788	2179	79	applied	\N	\N	\N	\N	68433	68433	236598
2788	2180	80	applied	\N	\N	\N	\N	68434	68434	236599
2788	2181	81	applied	\N	\N	\N	\N	68435	68435	236600
2788	2182	82	applied	\N	\N	\N	\N	68436	68436	236601
2788	2183	83	applied	\N	\N	\N	\N	68437	68437	236602
2788	2184	84	applied	\N	\N	\N	\N	68438	68438	236603
2788	2185	85	applied	\N	\N	\N	\N	68439	68439	236604
2788	2186	86	applied	\N	\N	\N	\N	68440	68440	236605
2788	2187	87	applied	\N	\N	\N	\N	68441	68441	236606
2788	2188	88	applied	\N	\N	\N	\N	68442	68442	236607
2788	2189	89	applied	\N	\N	\N	\N	68443	68443	236608
2788	2190	90	applied	\N	\N	\N	\N	68444	68444	236609
2788	2191	91	applied	\N	\N	\N	\N	68445	68445	236610
2788	2192	92	applied	\N	\N	\N	\N	68446	68446	236611
2788	2193	93	applied	\N	\N	\N	\N	68447	68447	236612
2788	2195	95	applied	\N	\N	\N	\N	68449	68449	236614
2788	2196	96	applied	\N	\N	\N	\N	68450	68450	236615
2788	2197	97	applied	\N	\N	\N	\N	68451	68451	236616
2788	2198	98	applied	\N	\N	\N	\N	68452	68452	236617
2788	2199	99	applied	\N	\N	\N	\N	68453	68453	236618
2788	2200	100	applied	\N	\N	\N	\N	68454	68454	236619
2788	2201	101	applied	\N	\N	\N	\N	68455	68455	236620
2788	2202	102	applied	\N	\N	\N	\N	68456	68456	236621
2788	2203	103	applied	\N	\N	\N	\N	68457	68457	236622
2788	2204	104	applied	\N	\N	\N	\N	68458	68458	236623
2788	2205	105	applied	\N	\N	\N	\N	68459	68459	236624
2788	2206	106	applied	\N	\N	\N	\N	68460	68460	236625
2788	2207	107	applied	\N	\N	\N	\N	68461	68461	236626
2788	2208	108	applied	\N	\N	\N	\N	68462	68462	236627
2788	2209	109	applied	\N	\N	\N	\N	68463	68463	236628
2790	2286	0	applied	\N	\N	\N	\N	68481	68481	236646
2796	2289	0	applied	\N	\N	\N	\N	68487	68487	236652
2799	2290	0	applied	\N	\N	\N	\N	68493	68493	236658
2799	2291	1	applied	\N	\N	\N	\N	68494	68494	236659
2799	2292	2	applied	\N	\N	\N	\N	68495	68495	236660
2799	2293	3	applied	\N	\N	\N	\N	68496	68496	236661
2808	2298	0	applied	\N	\N	\N	\N	68641	68641	236806
2808	2299	1	applied	\N	\N	\N	\N	68642	68642	236807
2811	2302	0	applied	\N	\N	\N	\N	68645	68645	236810
2817	2305	0	applied	\N	\N	\N	\N	68649	68649	236814
2817	2306	1	applied	\N	\N	\N	\N	68650	68650	236815
2822	2307	0	applied	\N	\N	1000000000	\N	68651	68651	236816
2822	2308	1	applied	\N	\N	\N	\N	68652	68652	236817
2825	2309	0	applied	\N	\N	\N	\N	68653	68653	236818
2825	2310	1	applied	\N	\N	\N	\N	68654	68654	236819
2828	2311	0	applied	\N	\N	\N	\N	68655	68655	236820
2828	2312	1	applied	\N	\N	\N	\N	68656	68656	236821
2828	2314	3	applied	\N	\N	\N	\N	68658	68658	236823
2828	2315	4	applied	\N	\N	\N	\N	68659	68659	236824
2828	2316	5	applied	\N	\N	\N	\N	68660	68660	236825
2828	2317	6	applied	\N	\N	\N	\N	68661	68661	236826
2828	2318	7	applied	\N	\N	\N	\N	68662	68662	236827
2836	2322	0	applied	\N	\N	\N	\N	68677	68677	236842
2836	2323	1	applied	\N	\N	\N	\N	68678	68678	236843
2836	2324	2	applied	\N	\N	\N	\N	68679	68679	236844
2836	2325	3	applied	\N	\N	\N	\N	68680	68680	236845
2840	2329	0	applied	\N	\N	\N	\N	68684	68684	236849
2843	2334	0	applied	\N	\N	\N	\N	68689	68689	236854
2846	2336	0	applied	\N	\N	\N	\N	68692	68692	236857
2849	2339	0	applied	\N	\N	\N	\N	68695	68695	236860
2852	2340	0	applied	\N	\N	\N	\N	68697	68697	236862
2855	2341	0	applied	\N	\N	\N	\N	68700	68700	236865
2855	2342	1	applied	\N	\N	\N	\N	68701	68701	236866
2761	2260	0	applied	\N	\N	\N	\N	68317	68317	236482
2788	2214	114	applied	\N	\N	\N	\N	68468	68468	236633
2788	2215	115	applied	\N	\N	\N	\N	68469	68469	236634
2788	2216	116	applied	\N	\N	\N	\N	68470	68470	236635
2788	2217	117	applied	\N	\N	\N	\N	68471	68471	236636
2788	2218	118	applied	\N	\N	\N	\N	68472	68472	236637
2788	2219	119	applied	\N	\N	\N	\N	68473	68473	236638
2788	2220	120	applied	\N	\N	\N	\N	68474	68474	236639
2788	2221	121	applied	\N	\N	\N	\N	68475	68475	236640
2788	2222	122	applied	\N	\N	\N	\N	68476	68476	236641
2788	2223	123	applied	\N	\N	\N	\N	68477	68477	236642
2788	2224	124	applied	\N	\N	\N	\N	68478	68478	236643
2788	2225	125	applied	\N	\N	\N	\N	68479	68479	236644
2789	2286	0	applied	\N	\N	\N	\N	68480	68480	236645
2792	2288	0	applied	\N	\N	\N	\N	68483	68483	236648
2795	2289	0	applied	\N	\N	\N	\N	68486	68486	236651
2798	2290	0	applied	\N	\N	\N	\N	68489	68489	236654
2798	2292	2	applied	\N	\N	\N	\N	68491	68491	236656
2798	2293	3	applied	\N	\N	\N	\N	68492	68492	236657
2801	2294	0	applied	\N	\N	\N	\N	68501	68501	236666
2801	2295	1	applied	\N	\N	\N	\N	68502	68502	236667
2801	2296	2	applied	\N	\N	\N	\N	68503	68503	236668
2804	2104	0	applied	\N	\N	\N	\N	68510	68510	236675
2804	2285	1	applied	\N	\N	\N	\N	68511	68511	236676
2804	2103	2	applied	\N	\N	\N	\N	68512	68512	236677
2804	2105	3	applied	\N	\N	\N	\N	68513	68513	236678
2804	2106	4	applied	\N	\N	\N	\N	68514	68514	236679
2804	2107	5	applied	\N	\N	\N	\N	68515	68515	236680
2804	2108	6	applied	\N	\N	\N	\N	68516	68516	236681
2804	2109	7	applied	\N	\N	\N	\N	68517	68517	236682
2804	2110	8	applied	\N	\N	\N	\N	68518	68518	236683
2804	2111	9	applied	\N	\N	\N	\N	68519	68519	236684
2804	2112	10	applied	\N	\N	\N	\N	68520	68520	236685
2804	2114	12	applied	\N	\N	\N	\N	68522	68522	236687
2804	2115	13	applied	\N	\N	\N	\N	68523	68523	236688
2804	2116	14	applied	\N	\N	\N	\N	68524	68524	236689
2804	2117	15	applied	\N	\N	\N	\N	68525	68525	236690
2804	2118	16	applied	\N	\N	\N	\N	68526	68526	236691
2804	2119	17	applied	\N	\N	\N	\N	68527	68527	236692
2804	2120	18	applied	\N	\N	\N	\N	68528	68528	236693
2804	2121	19	applied	\N	\N	\N	\N	68529	68529	236694
2804	2122	20	applied	\N	\N	\N	\N	68530	68530	236695
2804	2123	21	applied	\N	\N	\N	\N	68531	68531	236696
2804	2124	22	applied	\N	\N	\N	\N	68532	68532	236697
2804	2125	23	applied	\N	\N	\N	\N	68533	68533	236698
2804	2126	24	applied	\N	\N	\N	\N	68534	68534	236699
2804	2127	25	applied	\N	\N	\N	\N	68535	68535	236700
2804	2128	26	applied	\N	\N	\N	\N	68536	68536	236701
2804	2129	27	applied	\N	\N	\N	\N	68537	68537	236702
2804	2131	29	applied	\N	\N	\N	\N	68539	68539	236704
2804	2132	30	applied	\N	\N	\N	\N	68540	68540	236705
2804	2133	31	applied	\N	\N	\N	\N	68541	68541	236706
2804	2134	32	applied	\N	\N	\N	\N	68542	68542	236707
2804	2135	33	applied	\N	\N	\N	\N	68543	68543	236708
2804	2136	34	applied	\N	\N	\N	\N	68544	68544	236709
2804	2137	35	applied	\N	\N	\N	\N	68545	68545	236710
2804	2138	36	applied	\N	\N	\N	\N	68546	68546	236711
2804	2139	37	applied	\N	\N	\N	\N	68547	68547	236712
2804	2140	38	applied	\N	\N	\N	\N	68548	68548	236713
2804	2141	39	applied	\N	\N	\N	\N	68549	68549	236714
2804	2142	40	applied	\N	\N	\N	\N	68550	68550	236715
2804	2143	41	applied	\N	\N	\N	\N	68551	68551	236716
2804	2144	42	applied	\N	\N	\N	\N	68552	68552	236717
2804	2145	43	applied	\N	\N	\N	\N	68553	68553	236718
2804	2146	44	applied	\N	\N	\N	\N	68554	68554	236719
2804	2148	46	applied	\N	\N	\N	\N	68556	68556	236721
2804	2149	47	applied	\N	\N	\N	\N	68557	68557	236722
2804	2150	48	applied	\N	\N	\N	\N	68558	68558	236723
2804	2151	49	applied	\N	\N	\N	\N	68559	68559	236724
2804	2152	50	applied	\N	\N	\N	\N	68560	68560	236725
2804	2153	51	applied	\N	\N	\N	\N	68561	68561	236726
2804	2154	52	applied	\N	\N	\N	\N	68562	68562	236727
2804	2155	53	applied	\N	\N	\N	\N	68563	68563	236728
2804	2156	54	applied	\N	\N	\N	\N	68564	68564	236729
2804	2157	55	applied	\N	\N	\N	\N	68565	68565	236730
2804	2158	56	applied	\N	\N	\N	\N	68566	68566	236731
2804	2159	57	applied	\N	\N	\N	\N	68567	68567	236732
2804	2160	58	applied	\N	\N	\N	\N	68568	68568	236733
2804	2161	59	applied	\N	\N	\N	\N	68569	68569	236734
2804	2162	60	applied	\N	\N	\N	\N	68570	68570	236735
2804	2163	61	applied	\N	\N	\N	\N	68571	68571	236736
2804	2165	63	applied	\N	\N	\N	\N	68573	68573	236738
2804	2166	64	applied	\N	\N	\N	\N	68574	68574	236739
2804	2167	65	applied	\N	\N	\N	\N	68575	68575	236740
2804	2168	66	applied	\N	\N	\N	\N	68576	68576	236741
2804	2169	67	applied	\N	\N	\N	\N	68577	68577	236742
2804	2170	68	applied	\N	\N	\N	\N	68578	68578	236743
2804	2171	69	applied	\N	\N	\N	\N	68579	68579	236744
2804	2172	70	applied	\N	\N	\N	\N	68580	68580	236745
2804	2173	71	applied	\N	\N	\N	\N	68581	68581	236746
2804	2174	72	applied	\N	\N	\N	\N	68582	68582	236747
2804	2175	73	applied	\N	\N	\N	\N	68583	68583	236748
2804	2176	74	applied	\N	\N	\N	\N	68584	68584	236749
2804	2177	75	applied	\N	\N	\N	\N	68585	68585	236750
2804	2178	76	applied	\N	\N	\N	\N	68586	68586	236751
2804	2179	77	applied	\N	\N	\N	\N	68587	68587	236752
2860	2343	0	applied	\N	\N	\N	\N	68712	68712	236877
2860	2345	2	applied	\N	\N	\N	\N	68714	68714	236879
2861	2346	0	applied	\N	\N	\N	\N	68715	68715	236880
2865	2349	0	applied	\N	\N	\N	\N	68720	68720	236885
2871	2353	0	applied	\N	\N	\N	\N	68728	68728	236893
2871	2354	1	applied	\N	\N	\N	\N	68729	68729	236894
2877	2357	0	applied	\N	\N	\N	\N	68735	68735	236900
2889	2361	0	applied	\N	\N	\N	\N	68749	68749	236914
2891	2362	0	applied	\N	\N	\N	\N	68751	68751	236916
2893	2362	0	applied	\N	\N	\N	\N	68753	68753	236918
2895	2363	0	applied	\N	\N	\N	\N	68755	68755	236920
2895	2364	1	applied	\N	\N	\N	\N	68756	68756	236921
2895	2365	2	applied	\N	\N	\N	\N	68757	68757	236922
2898	2368	0	applied	\N	\N	\N	\N	68761	68761	236926
2904	2371	0	applied	\N	\N	\N	\N	68766	68766	236931
2788	2211	111	applied	\N	\N	\N	\N	68465	68465	236630
2788	2212	112	applied	\N	\N	\N	\N	68466	68466	236631
2804	2184	82	applied	\N	\N	\N	\N	68592	68592	236757
2804	2185	83	applied	\N	\N	\N	\N	68593	68593	236758
2804	2186	84	applied	\N	\N	\N	\N	68594	68594	236759
2804	2187	85	applied	\N	\N	\N	\N	68595	68595	236760
2804	2188	86	applied	\N	\N	\N	\N	68596	68596	236761
2804	2189	87	applied	\N	\N	\N	\N	68597	68597	236762
2804	2190	88	applied	\N	\N	\N	\N	68598	68598	236763
2804	2191	89	applied	\N	\N	\N	\N	68599	68599	236764
2804	2192	90	applied	\N	\N	\N	\N	68600	68600	236765
2804	2193	91	applied	\N	\N	\N	\N	68601	68601	236766
2804	2194	92	applied	\N	\N	\N	\N	68602	68602	236767
2804	2195	93	applied	\N	\N	\N	\N	68603	68603	236768
2804	2196	94	applied	\N	\N	\N	\N	68604	68604	236769
2804	2197	95	applied	\N	\N	\N	\N	68605	68605	236770
2804	2199	97	applied	\N	\N	\N	\N	68607	68607	236772
2804	2200	98	applied	\N	\N	\N	\N	68608	68608	236773
2804	2201	99	applied	\N	\N	\N	\N	68609	68609	236774
2804	2202	100	applied	\N	\N	\N	\N	68610	68610	236775
2804	2203	101	applied	\N	\N	\N	\N	68611	68611	236776
2804	2204	102	applied	\N	\N	\N	\N	68612	68612	236777
2804	2205	103	applied	\N	\N	\N	\N	68613	68613	236778
2804	2206	104	applied	\N	\N	\N	\N	68614	68614	236779
2804	2207	105	applied	\N	\N	\N	\N	68615	68615	236780
2804	2208	106	applied	\N	\N	\N	\N	68616	68616	236781
2804	2209	107	applied	\N	\N	\N	\N	68617	68617	236782
2804	2210	108	applied	\N	\N	\N	\N	68618	68618	236783
2804	2211	109	applied	\N	\N	\N	\N	68619	68619	236784
2804	2212	110	applied	\N	\N	\N	\N	68620	68620	236785
2804	2213	111	applied	\N	\N	\N	\N	68621	68621	236786
2804	2214	112	applied	\N	\N	\N	\N	68622	68622	236787
2804	2216	114	applied	\N	\N	\N	\N	68624	68624	236789
2804	2217	115	applied	\N	\N	\N	\N	68625	68625	236790
2804	2218	116	applied	\N	\N	\N	\N	68626	68626	236791
2804	2219	117	applied	\N	\N	\N	\N	68627	68627	236792
2804	2220	118	applied	\N	\N	\N	\N	68628	68628	236793
2804	2221	119	applied	\N	\N	\N	\N	68629	68629	236794
2804	2222	120	applied	\N	\N	\N	\N	68630	68630	236795
2804	2223	122	applied	\N	\N	\N	\N	68631	68631	236796
2804	2224	123	applied	\N	\N	\N	\N	68632	68632	236797
2804	2225	124	applied	\N	\N	\N	\N	68633	68633	236798
2804	2226	125	applied	\N	\N	\N	\N	68634	68634	236799
2807	2298	0	applied	\N	\N	\N	\N	68639	68639	236804
2807	2299	1	applied	\N	\N	\N	\N	68640	68640	236805
2810	2301	0	applied	\N	\N	\N	\N	68644	68644	236809
2813	2303	0	applied	\N	\N	\N	\N	68647	68647	236812
2833	2319	0	applied	\N	\N	\N	\N	68673	68673	236838
2833	2321	2	applied	\N	\N	\N	\N	68675	68675	236840
2842	2332	0	applied	\N	\N	\N	\N	68687	68687	236852
2842	2333	1	applied	\N	\N	\N	\N	68688	68688	236853
2845	2336	0	applied	\N	\N	\N	\N	68691	68691	236856
2854	2341	0	applied	\N	\N	\N	\N	68698	68698	236863
2854	2342	1	applied	\N	\N	\N	\N	68699	68699	236864
2857	2343	0	applied	\N	\N	\N	\N	68705	68705	236870
2857	2344	1	applied	\N	\N	\N	\N	68706	68706	236871
2857	2345	2	applied	\N	\N	\N	\N	68707	68707	236872
2864	2349	0	applied	\N	\N	\N	\N	68719	68719	236884
2867	2350	0	applied	\N	\N	\N	\N	68724	68724	236889
2867	2351	1	applied	\N	\N	\N	\N	68725	68725	236890
2867	2352	2	applied	\N	\N	\N	\N	68726	68726	236891
2873	2355	0	applied	\N	\N	\N	\N	68732	68732	236897
2876	2356	0	applied	\N	\N	\N	\N	68734	68734	236899
2879	2357	0	applied	\N	\N	\N	\N	68737	68737	236902
2882	2358	1	applied	\N	\N	\N	\N	68741	68741	236906
2885	2359	0	applied	\N	\N	\N	\N	68745	68745	236910
2888	2361	0	applied	\N	\N	\N	\N	68748	68748	236913
2894	2362	0	applied	\N	\N	\N	\N	68754	68754	236919
2897	2368	0	applied	\N	\N	\N	\N	68760	68760	236925
2900	2369	0	applied	\N	\N	\N	\N	68763	68763	236928
2903	2370	0	applied	\N	\N	\N	\N	68765	68765	236930
2905	2372	0	applied	\N	\N	\N	\N	68767	68767	236932
2905	2373	1	applied	\N	\N	\N	\N	68768	68768	236933
2905	2374	2	applied	\N	\N	\N	\N	68769	68769	236934
2905	2375	3	applied	\N	\N	\N	\N	68770	68770	236935
2908	2372	0	applied	\N	\N	\N	\N	68775	68775	236940
2908	2373	1	applied	\N	\N	\N	\N	68776	68776	236941
2908	2374	2	applied	\N	\N	\N	\N	68777	68777	236942
2908	2375	3	applied	\N	\N	\N	\N	68778	68778	236943
2911	2376	0	applied	\N	\N	\N	\N	68783	68783	236948
2911	2378	2	applied	\N	\N	\N	\N	68785	68785	236950
2911	2379	3	applied	\N	\N	\N	\N	68786	68786	236951
2911	2380	4	applied	\N	\N	\N	\N	68787	68787	236952
2912	2307	0	applied	\N	\N	1000000000	\N	68788	68788	236953
2912	2294	1	applied	\N	\N	\N	\N	68789	68789	236954
2912	2295	2	applied	\N	\N	\N	\N	68790	68790	236955
2912	2296	3	applied	\N	\N	\N	\N	68791	68791	236956
2912	2297	4	applied	\N	\N	\N	\N	68792	68792	236957
2912	2298	5	applied	\N	\N	\N	\N	68793	68793	236958
2912	2299	6	applied	\N	\N	\N	\N	68794	68794	236959
2912	2300	7	applied	\N	\N	\N	\N	68795	68795	236960
2912	2309	8	applied	\N	\N	\N	\N	68796	68796	236961
2912	2301	9	applied	\N	\N	\N	\N	68797	68797	236962
2912	2302	10	applied	\N	\N	\N	\N	68798	68798	236963
2912	2303	11	applied	\N	\N	\N	\N	68799	68799	236964
2912	2304	12	applied	\N	\N	\N	\N	68800	68800	236965
2912	2306	14	applied	\N	\N	\N	\N	68802	68802	236967
2912	2308	15	applied	\N	\N	\N	\N	68803	68803	236968
2912	2311	16	applied	\N	\N	\N	\N	68804	68804	236969
2912	2312	17	applied	\N	\N	\N	\N	68805	68805	236970
2912	2313	18	applied	\N	\N	\N	\N	68806	68806	236971
2912	2314	19	applied	\N	\N	\N	\N	68807	68807	236972
2912	2315	20	applied	\N	\N	\N	\N	68808	68808	236973
2912	2316	21	applied	\N	\N	\N	\N	68809	68809	236974
2912	2317	22	applied	\N	\N	\N	\N	68810	68810	236975
2912	2318	23	applied	\N	\N	\N	\N	68811	68811	236976
2912	2319	24	applied	\N	\N	\N	\N	68812	68812	236977
2912	2320	25	applied	\N	\N	\N	\N	68813	68813	236978
2912	2321	26	applied	\N	\N	\N	\N	68814	68814	236979
2912	2322	27	applied	\N	\N	\N	\N	68815	68815	236980
2912	2323	28	applied	\N	\N	\N	\N	68816	68816	236981
2912	2324	29	applied	\N	\N	\N	\N	68817	68817	236982
2804	2183	81	applied	\N	\N	\N	\N	68591	68591	236756
2912	2330	34	applied	\N	\N	\N	\N	68822	68822	236987
2912	2331	35	applied	\N	\N	\N	\N	68823	68823	236988
2912	2332	36	applied	\N	\N	\N	\N	68824	68824	236989
2912	2333	37	applied	\N	\N	\N	\N	68825	68825	236990
2912	2334	38	applied	\N	\N	\N	\N	68826	68826	236991
2912	2335	39	applied	\N	\N	\N	\N	68827	68827	236992
2912	2336	40	applied	\N	\N	\N	\N	68828	68828	236993
2912	2337	41	applied	\N	\N	\N	\N	68829	68829	236994
2912	2338	42	applied	\N	\N	\N	\N	68830	68830	236995
2912	2339	43	applied	\N	\N	\N	\N	68831	68831	236996
2912	2340	44	applied	\N	\N	\N	\N	68832	68832	236997
2912	2341	45	applied	\N	\N	\N	\N	68833	68833	236998
2912	2342	46	applied	\N	\N	\N	\N	68834	68834	236999
2912	2343	47	applied	\N	\N	\N	\N	68835	68835	237000
2912	2346	49	applied	\N	\N	\N	\N	68837	68837	237002
2912	2347	50	applied	\N	\N	\N	\N	68838	68838	237003
2913	2376	0	applied	\N	\N	\N	\N	68839	68839	237004
2913	2377	1	applied	\N	\N	\N	\N	68840	68840	237005
2913	2378	2	applied	\N	\N	\N	\N	68841	68841	237006
2913	2379	3	applied	\N	\N	\N	\N	68842	68842	237007
2913	2380	4	applied	\N	\N	\N	\N	68843	68843	237008
2914	2376	0	applied	\N	\N	\N	\N	68844	68844	237009
2914	2377	1	applied	\N	\N	\N	\N	68845	68845	237010
2914	2378	2	applied	\N	\N	\N	\N	68846	68846	237011
2914	2379	3	applied	\N	\N	\N	\N	68847	68847	237012
2914	2380	4	applied	\N	\N	\N	\N	68848	68848	237013
2915	2381	0	applied	\N	\N	\N	\N	68849	68849	237014
2916	2381	0	applied	\N	\N	\N	\N	68850	68850	237015
2918	2382	0	applied	\N	\N	\N	\N	68851	68851	237016
2918	2383	1	applied	\N	\N	\N	\N	68852	68852	237017
2919	2385	0	applied	\N	\N	\N	\N	68854	68854	237019
2921	2246	0	applied	\N	\N	\N	\N	68855	68855	237020
2921	2247	1	applied	\N	\N	\N	\N	68856	68856	237021
2921	2248	2	applied	\N	\N	\N	\N	68857	68857	237022
2921	2285	3	applied	\N	\N	\N	\N	68858	68858	237023
2921	2307	4	applied	\N	\N	1000000000	\N	68859	68859	237024
2921	2309	5	applied	\N	\N	\N	\N	68860	68860	237025
2921	2249	6	applied	\N	\N	\N	\N	68861	68861	237026
2921	2250	7	applied	\N	\N	\N	\N	68862	68862	237027
2921	2251	8	applied	\N	\N	\N	\N	68863	68863	237028
2921	2252	9	applied	\N	\N	\N	\N	68864	68864	237029
2921	2253	10	applied	\N	\N	\N	\N	68865	68865	237030
2921	2254	11	applied	\N	\N	\N	\N	68866	68866	237031
2921	2255	12	applied	\N	\N	\N	\N	68867	68867	237032
2921	2256	13	applied	\N	\N	\N	\N	68868	68868	237033
2921	2257	14	applied	\N	\N	\N	\N	68869	68869	237034
2921	2259	16	applied	\N	\N	\N	\N	68871	68871	237036
2921	2260	17	applied	\N	\N	\N	\N	68872	68872	237037
2921	2261	18	applied	\N	\N	\N	\N	68873	68873	237038
2921	2262	19	applied	\N	\N	\N	\N	68874	68874	237039
2921	2263	20	applied	\N	\N	\N	\N	68875	68875	237040
2921	2264	21	applied	\N	\N	\N	\N	68876	68876	237041
2921	2265	22	applied	\N	\N	\N	\N	68877	68877	237042
2921	2266	23	applied	\N	\N	\N	\N	68878	68878	237043
2921	2267	24	applied	\N	\N	\N	\N	68879	68879	237044
2921	2268	25	applied	\N	\N	\N	\N	68880	68880	237045
2921	2269	26	applied	\N	\N	\N	\N	68881	68881	237046
2921	2270	27	applied	\N	\N	\N	\N	68882	68882	237047
2921	2271	28	applied	\N	\N	\N	\N	68883	68883	237048
2921	2272	29	applied	\N	\N	\N	\N	68884	68884	237049
2921	2273	30	applied	\N	\N	\N	\N	68885	68885	237050
2921	2274	31	applied	\N	\N	\N	\N	68886	68886	237051
2921	2276	33	applied	\N	\N	\N	\N	68888	68888	237053
2921	2277	34	applied	\N	\N	\N	\N	68889	68889	237054
2921	2278	35	applied	\N	\N	\N	\N	68890	68890	237055
2921	2279	36	applied	\N	\N	\N	\N	68891	68891	237056
2921	2280	38	applied	\N	\N	\N	\N	68892	68892	237057
2921	2281	39	applied	\N	\N	\N	\N	68893	68893	237058
2921	2282	40	applied	\N	\N	\N	\N	68894	68894	237059
2921	2283	41	applied	\N	\N	\N	\N	68895	68895	237060
2921	2284	42	applied	\N	\N	\N	\N	68896	68896	237061
2921	2286	43	applied	\N	\N	\N	\N	68897	68897	237062
2921	2287	44	applied	\N	\N	\N	\N	68898	68898	237063
2921	2288	45	applied	\N	\N	\N	\N	68899	68899	237064
2921	2289	46	applied	\N	\N	\N	\N	68900	68900	237065
2921	2290	47	applied	\N	\N	\N	\N	68901	68901	237066
2921	2291	48	applied	\N	\N	\N	\N	68902	68902	237067
2921	2292	49	applied	\N	\N	\N	\N	68903	68903	237068
2921	2294	51	applied	\N	\N	\N	\N	68905	68905	237070
2921	2295	52	applied	\N	\N	\N	\N	68906	68906	237071
2921	2296	53	applied	\N	\N	\N	\N	68907	68907	237072
2921	2297	54	applied	\N	\N	\N	\N	68908	68908	237073
2921	2298	55	applied	\N	\N	\N	\N	68909	68909	237074
2921	2299	56	applied	\N	\N	\N	\N	68910	68910	237075
2921	2300	57	applied	\N	\N	\N	\N	68911	68911	237076
2921	2301	58	applied	\N	\N	\N	\N	68912	68912	237077
2921	2302	59	applied	\N	\N	\N	\N	68913	68913	237078
2921	2303	60	applied	\N	\N	\N	\N	68914	68914	237079
2921	2304	61	applied	\N	\N	\N	\N	68915	68915	237080
2921	2305	62	applied	\N	\N	\N	\N	68916	68916	237081
2921	2306	63	applied	\N	\N	\N	\N	68917	68917	237082
2921	2308	64	applied	\N	\N	\N	\N	68918	68918	237083
2921	2311	65	applied	\N	\N	\N	\N	68919	68919	237084
2921	2312	66	applied	\N	\N	\N	\N	68920	68920	237085
2921	2314	68	applied	\N	\N	\N	\N	68922	68922	237087
2921	2315	69	applied	\N	\N	\N	\N	68923	68923	237088
2921	2316	70	applied	\N	\N	\N	\N	68924	68924	237089
2921	2317	71	applied	\N	\N	\N	\N	68925	68925	237090
2921	2318	72	applied	\N	\N	\N	\N	68926	68926	237091
2921	2319	73	applied	\N	\N	\N	\N	68927	68927	237092
2921	2320	74	applied	\N	\N	\N	\N	68928	68928	237093
2921	2321	75	applied	\N	\N	\N	\N	68929	68929	237094
2921	2322	76	applied	\N	\N	\N	\N	68930	68930	237095
2921	2323	77	applied	\N	\N	\N	\N	68931	68931	237096
2921	2324	78	applied	\N	\N	\N	\N	68932	68932	237097
2921	2326	79	applied	\N	\N	\N	\N	68933	68933	237098
2921	2327	80	applied	\N	\N	\N	\N	68934	68934	237099
2921	2328	81	applied	\N	\N	\N	\N	68935	68935	237100
2921	2329	82	applied	\N	\N	\N	\N	68936	68936	237101
2921	2330	83	applied	\N	\N	\N	\N	68937	68937	237102
2912	2329	33	applied	\N	\N	\N	\N	68821	68821	236986
2921	2334	87	applied	\N	\N	\N	\N	68941	68941	237106
2921	2335	88	applied	\N	\N	\N	\N	68942	68942	237107
2921	2336	89	applied	\N	\N	\N	\N	68943	68943	237108
2921	2337	90	applied	\N	\N	\N	\N	68944	68944	237109
2921	2338	91	applied	\N	\N	\N	\N	68945	68945	237110
2921	2339	92	applied	\N	\N	\N	\N	68946	68946	237111
2921	2340	93	applied	\N	\N	\N	\N	68947	68947	237112
2921	2341	94	applied	\N	\N	\N	\N	68948	68948	237113
2921	2342	95	applied	\N	\N	\N	\N	68949	68949	237114
2921	2343	96	applied	\N	\N	\N	\N	68950	68950	237115
2921	2344	97	applied	\N	\N	\N	\N	68951	68951	237116
2921	2347	99	applied	\N	\N	\N	\N	68953	68953	237118
2921	2348	100	applied	\N	\N	\N	\N	68954	68954	237119
2921	2349	101	applied	\N	\N	\N	\N	68955	68955	237120
2921	2350	102	applied	\N	\N	\N	\N	68956	68956	237121
2921	2351	103	applied	\N	\N	\N	\N	68957	68957	237122
2921	2352	104	applied	\N	\N	\N	\N	68958	68958	237123
2921	2353	105	applied	\N	\N	\N	\N	68959	68959	237124
2921	2354	106	applied	\N	\N	\N	\N	68960	68960	237125
2921	2355	107	applied	\N	\N	\N	\N	68961	68961	237126
2921	2356	108	applied	\N	\N	\N	\N	68962	68962	237127
2921	2357	109	applied	\N	\N	\N	\N	68963	68963	237128
2921	2358	110	applied	\N	\N	\N	\N	68964	68964	237129
2921	2359	111	applied	\N	\N	\N	\N	68965	68965	237130
2921	2360	112	applied	\N	\N	\N	\N	68966	68966	237131
2921	2361	113	applied	\N	\N	\N	\N	68967	68967	237132
2921	2362	114	applied	\N	\N	\N	\N	68968	68968	237133
2921	2364	116	applied	\N	\N	\N	\N	68970	68970	237135
2921	2365	117	applied	\N	\N	\N	\N	68971	68971	237136
2921	2366	118	applied	\N	\N	\N	\N	68972	68972	237137
2921	2367	119	applied	\N	\N	\N	\N	68973	68973	237138
2921	2368	120	applied	\N	\N	\N	\N	68974	68974	237139
2921	2369	121	applied	\N	\N	\N	\N	68975	68975	237140
2921	2370	122	applied	\N	\N	\N	\N	68976	68976	237141
2921	2371	123	applied	\N	\N	\N	\N	68977	68977	237142
2921	2372	124	applied	\N	\N	\N	\N	68978	68978	237143
2921	2373	125	applied	\N	\N	\N	\N	68979	68979	237144
2924	2386	0	applied	\N	\N	\N	\N	68984	68984	237149
2924	2387	1	applied	\N	\N	\N	\N	68985	68985	237150
2929	2388	0	applied	\N	\N	\N	\N	68990	68990	237155
2929	2389	1	applied	\N	\N	\N	\N	68991	68991	237156
2932	2390	0	applied	\N	\N	\N	\N	68996	68996	237161
2932	2391	1	applied	\N	\N	\N	\N	68997	68997	237162
2935	2393	1	applied	\N	\N	\N	\N	69000	69000	237165
2941	2395	0	applied	\N	\N	\N	\N	69002	69002	237167
2947	2398	0	applied	\N	\N	\N	\N	69007	69007	237172
2949	2399	0	applied	\N	\N	\N	\N	69009	69009	237174
2952	2404	0	applied	\N	\N	\N	\N	69014	69014	237179
2952	2405	1	applied	\N	\N	\N	\N	69015	69015	237180
2952	2406	2	applied	\N	\N	\N	\N	69016	69016	237181
2952	2407	3	applied	\N	\N	\N	\N	69017	69017	237182
2959	2410	0	applied	\N	\N	\N	\N	69023	69023	237188
2961	2410	0	applied	\N	\N	\N	\N	69025	69025	237190
2963	2411	0	applied	\N	\N	\N	\N	69027	69027	237192
2966	2412	0	applied	\N	\N	\N	\N	69030	69030	237195
2969	2415	0	applied	\N	\N	\N	\N	69033	69033	237198
2969	2416	1	applied	\N	\N	\N	\N	69034	69034	237199
2969	2417	2	applied	\N	\N	\N	\N	69035	69035	237200
2972	2419	0	applied	\N	\N	\N	\N	69040	69040	237205
2972	2421	2	applied	\N	\N	\N	\N	69042	69042	237207
2975	2423	0	applied	\N	\N	\N	\N	69045	69045	237210
2975	2424	1	applied	\N	\N	\N	\N	69046	69046	237211
2979	2426	0	applied	\N	\N	\N	\N	69049	69049	237214
2982	2428	0	applied	\N	\N	\N	\N	69052	69052	237217
2985	2429	0	applied	\N	\N	\N	\N	69055	69055	237220
2988	2430	0	applied	\N	\N	\N	\N	69058	69058	237223
2991	2431	0	applied	\N	\N	\N	\N	69062	69062	237227
2991	2432	2	applied	\N	\N	\N	\N	69063	69063	237228
2991	2433	3	applied	\N	\N	\N	\N	69064	69064	237229
2994	2435	0	applied	\N	\N	\N	\N	69067	69067	237232
2997	2438	0	applied	\N	\N	\N	\N	69072	69072	237237
3012	2441	0	applied	\N	\N	\N	\N	69146	69146	237311
3015	2442	0	applied	\N	\N	\N	\N	69149	69149	237314
3017	2443	0	applied	\N	\N	\N	\N	69151	69151	237316
3018	2444	0	applied	\N	\N	\N	\N	69152	69152	237317
3024	2448	0	applied	\N	\N	\N	\N	69158	69158	237323
3026	2449	0	applied	\N	\N	\N	\N	69160	69160	237325
3027	2449	0	applied	\N	\N	\N	\N	69161	69161	237326
3030	2451	0	applied	\N	\N	\N	\N	69164	69164	237329
3033	2452	0	applied	\N	\N	\N	\N	69167	69167	237332
3036	2454	0	applied	\N	\N	\N	\N	69170	69170	237335
3036	2455	1	applied	\N	\N	\N	\N	69171	69171	237336
3039	2457	0	applied	\N	\N	\N	\N	69174	69174	237339
3044	2460	0	applied	\N	\N	\N	\N	69180	69180	237345
3044	2461	1	applied	\N	\N	\N	\N	69181	69181	237346
3047	2463	0	applied	\N	\N	\N	\N	69217	69217	237382
3047	2464	1	applied	\N	\N	\N	\N	69218	69218	237383
3050	2466	0	applied	\N	\N	\N	\N	69222	69222	237387
3050	2467	1	applied	\N	\N	\N	\N	69223	69223	237388
3050	2468	2	applied	\N	\N	\N	\N	69224	69224	237389
3053	2472	0	applied	\N	\N	\N	\N	69228	69228	237393
3065	2478	0	applied	\N	\N	\N	\N	69237	69237	237402
3068	2480	0	applied	\N	\N	\N	\N	69239	69239	237404
3068	2481	1	applied	\N	\N	\N	\N	69240	69240	237405
3071	2484	0	applied	\N	\N	\N	\N	69243	69243	237408
3076	2438	0	applied	\N	\N	\N	\N	69248	69248	237413
3076	2473	1	applied	\N	\N	1000000000	\N	69249	69249	237414
3076	2307	2	applied	\N	\N	1000000000	\N	69250	69250	237415
3076	2305	3	applied	\N	\N	\N	\N	69251	69251	237416
3076	2306	4	applied	\N	\N	\N	\N	69252	69252	237417
3076	2308	5	applied	\N	\N	\N	\N	69253	69253	237418
3076	2311	6	applied	\N	\N	\N	\N	69254	69254	237419
3076	2312	7	applied	\N	\N	\N	\N	69255	69255	237420
3076	2313	8	applied	\N	\N	\N	\N	69256	69256	237421
3076	2309	9	applied	\N	\N	\N	\N	69257	69257	237422
3076	2314	10	applied	\N	\N	\N	\N	69258	69258	237423
3076	2315	11	applied	\N	\N	\N	\N	69259	69259	237424
3076	2316	12	applied	\N	\N	\N	\N	69260	69260	237425
3076	2317	13	applied	\N	\N	\N	\N	69261	69261	237426
2921	2332	85	applied	\N	\N	\N	\N	68939	68939	237104
2921	2333	86	applied	\N	\N	\N	\N	68940	68940	237105
2927	2388	0	applied	\N	\N	\N	\N	68988	68988	237153
2928	2388	0	applied	\N	\N	\N	\N	68989	68989	237154
2931	2388	0	applied	\N	\N	\N	\N	68994	68994	237159
2931	2389	1	applied	\N	\N	\N	\N	68995	68995	237160
2934	2392	0	applied	\N	\N	\N	\N	68998	68998	237163
2936	2394	0	applied	\N	\N	\N	\N	69001	69001	237166
2943	2396	0	applied	\N	\N	\N	\N	69004	69004	237169
2945	2397	0	applied	\N	\N	\N	\N	69005	69005	237170
2946	2397	0	applied	\N	\N	\N	\N	69006	69006	237171
2948	2399	0	applied	\N	\N	\N	\N	69008	69008	237173
2950	2400	0	applied	\N	\N	\N	\N	69010	69010	237175
2950	2401	1	applied	\N	\N	\N	\N	69011	69011	237176
2950	2402	2	applied	\N	\N	\N	\N	69012	69012	237177
2950	2403	3	applied	\N	\N	\N	\N	69013	69013	237178
2955	2409	0	applied	\N	\N	\N	\N	69020	69020	237185
2956	2409	0	applied	\N	\N	\N	\N	69021	69021	237186
2958	2410	0	applied	\N	\N	\N	\N	69022	69022	237187
2960	2410	0	applied	\N	\N	\N	\N	69024	69024	237189
2964	2412	0	applied	\N	\N	\N	\N	69028	69028	237193
2967	2413	0	applied	\N	\N	\N	\N	69031	69031	237196
2970	2418	0	applied	\N	\N	\N	\N	69036	69036	237201
2973	2422	0	applied	\N	\N	\N	\N	69043	69043	237208
2976	2425	0	applied	\N	\N	\N	\N	69047	69047	237212
2983	2429	0	applied	\N	\N	\N	\N	69053	69053	237218
2986	2429	0	applied	\N	\N	\N	\N	69056	69056	237221
2992	2434	0	applied	\N	\N	\N	\N	69065	69065	237230
2995	2436	0	applied	\N	\N	\N	\N	69068	69068	237233
2995	2437	1	applied	\N	\N	\N	\N	69069	69069	237234
2998	2438	0	applied	\N	\N	\N	\N	69073	69073	237238
3004	2438	0	applied	\N	\N	\N	\N	69075	69075	237240
3004	2141	2	applied	\N	\N	\N	\N	69077	69077	237242
3004	2142	3	applied	\N	\N	\N	\N	69078	69078	237243
3004	2143	4	applied	\N	\N	\N	\N	69079	69079	237244
3004	2144	5	applied	\N	\N	\N	\N	69080	69080	237245
3004	2145	6	applied	\N	\N	\N	\N	69081	69081	237246
3004	2146	7	applied	\N	\N	\N	\N	69082	69082	237247
3004	2285	8	applied	\N	\N	\N	\N	69083	69083	237248
3004	2307	9	applied	\N	\N	1000000000	\N	69084	69084	237249
3004	2309	10	applied	\N	\N	\N	\N	69085	69085	237250
3004	2147	11	applied	\N	\N	\N	\N	69086	69086	237251
3004	2148	12	applied	\N	\N	\N	\N	69087	69087	237252
3004	2149	13	applied	\N	\N	\N	\N	69088	69088	237253
3004	2150	14	applied	\N	\N	\N	\N	69089	69089	237254
3004	2151	15	applied	\N	\N	\N	\N	69090	69090	237255
3004	2152	16	applied	\N	\N	\N	\N	69091	69091	237256
3004	2153	17	applied	\N	\N	\N	\N	69092	69092	237257
3004	2155	19	applied	\N	\N	\N	\N	69094	69094	237259
3004	2156	20	applied	\N	\N	\N	\N	69095	69095	237260
3004	2157	21	applied	\N	\N	\N	\N	69096	69096	237261
3004	2158	22	applied	\N	\N	\N	\N	69097	69097	237262
3004	2159	23	applied	\N	\N	\N	\N	69098	69098	237263
3004	2160	24	applied	\N	\N	\N	\N	69099	69099	237264
3004	2161	25	applied	\N	\N	\N	\N	69100	69100	237265
3004	2162	26	applied	\N	\N	\N	\N	69101	69101	237266
3004	2163	27	applied	\N	\N	\N	\N	69102	69102	237267
3004	2164	28	applied	\N	\N	\N	\N	69103	69103	237268
3004	2165	29	applied	\N	\N	\N	\N	69104	69104	237269
3004	2166	30	applied	\N	\N	\N	\N	69105	69105	237270
3004	2167	31	applied	\N	\N	\N	\N	69106	69106	237271
3004	2168	32	applied	\N	\N	\N	\N	69107	69107	237272
3004	2169	33	applied	\N	\N	\N	\N	69108	69108	237273
3004	2170	35	applied	\N	\N	\N	\N	69109	69109	237274
3004	2172	37	applied	\N	\N	\N	\N	69111	69111	237276
3004	2173	38	applied	\N	\N	\N	\N	69112	69112	237277
3004	2174	39	applied	\N	\N	\N	\N	69113	69113	237278
3004	2175	40	applied	\N	\N	\N	\N	69114	69114	237279
3004	2176	41	applied	\N	\N	\N	\N	69115	69115	237280
3004	2177	42	applied	\N	\N	\N	\N	69116	69116	237281
3004	2178	43	applied	\N	\N	\N	\N	69117	69117	237282
3004	2179	44	applied	\N	\N	\N	\N	69118	69118	237283
3004	2180	45	applied	\N	\N	\N	\N	69119	69119	237284
3004	2181	46	applied	\N	\N	\N	\N	69120	69120	237285
3004	2182	47	applied	\N	\N	\N	\N	69121	69121	237286
3004	2183	48	applied	\N	\N	\N	\N	69122	69122	237287
3004	2184	49	applied	\N	\N	\N	\N	69123	69123	237288
3004	2185	50	applied	\N	\N	\N	\N	69124	69124	237289
3004	2186	51	applied	\N	\N	\N	\N	69125	69125	237290
3004	2187	52	applied	\N	\N	\N	\N	69126	69126	237291
3004	2189	54	applied	\N	\N	\N	\N	69128	69128	237293
3004	2190	55	applied	\N	\N	\N	\N	69129	69129	237294
3004	2191	56	applied	\N	\N	\N	\N	69130	69130	237295
3004	2192	57	applied	\N	\N	\N	\N	69131	69131	237296
3004	2193	58	applied	\N	\N	\N	\N	69132	69132	237297
3004	2194	59	applied	\N	\N	\N	\N	69133	69133	237298
3004	2195	60	applied	\N	\N	\N	\N	69134	69134	237299
3004	2196	61	applied	\N	\N	\N	\N	69135	69135	237300
3004	2197	62	applied	\N	\N	\N	\N	69136	69136	237301
3004	2198	63	applied	\N	\N	\N	\N	69137	69137	237302
3004	2199	64	applied	\N	\N	\N	\N	69138	69138	237303
3004	2200	65	applied	\N	\N	\N	\N	69139	69139	237304
3004	2201	66	applied	\N	\N	\N	\N	69140	69140	237305
3004	2202	67	applied	\N	\N	\N	\N	69141	69141	237306
3004	2203	68	applied	\N	\N	\N	\N	69142	69142	237307
3010	2439	0	applied	\N	\N	\N	\N	69143	69143	237308
3076	2319	15	applied	\N	\N	\N	\N	69263	69263	237428
3076	2320	16	applied	\N	\N	\N	\N	69264	69264	237429
3076	2321	17	applied	\N	\N	\N	\N	69265	69265	237430
3076	2322	18	applied	\N	\N	\N	\N	69266	69266	237431
3076	2323	19	applied	\N	\N	\N	\N	69267	69267	237432
3076	2324	20	applied	\N	\N	\N	\N	69268	69268	237433
3076	2326	21	applied	\N	\N	\N	\N	69269	69269	237434
3076	2327	22	applied	\N	\N	\N	\N	69270	69270	237435
3076	2328	23	applied	\N	\N	\N	\N	69271	69271	237436
3076	2329	25	applied	\N	\N	\N	\N	69272	69272	237437
3076	2330	26	applied	\N	\N	\N	\N	69273	69273	237438
3076	2331	27	applied	\N	\N	\N	\N	69274	69274	237439
3076	2332	28	applied	\N	\N	\N	\N	69275	69275	237440
3076	2333	29	applied	\N	\N	\N	\N	69276	69276	237441
3076	2334	30	applied	\N	\N	\N	\N	69277	69277	237442
3076	2335	31	applied	\N	\N	\N	\N	69278	69278	237443
2923	2387	1	applied	\N	\N	\N	\N	68983	68983	237148
2930	2389	1	applied	\N	\N	\N	\N	68993	68993	237158
2942	2395	0	applied	\N	\N	\N	\N	69003	69003	237168
2954	2409	0	applied	\N	\N	\N	\N	69019	69019	237184
2962	2411	0	applied	\N	\N	\N	\N	69026	69026	237191
2965	2412	0	applied	\N	\N	\N	\N	69029	69029	237194
2968	2414	0	applied	\N	\N	\N	\N	69032	69032	237197
2971	2419	0	applied	\N	\N	\N	\N	69037	69037	237202
2971	2420	1	applied	\N	\N	\N	\N	69038	69038	237203
2971	2421	2	applied	\N	\N	\N	\N	69039	69039	237204
2974	2422	0	applied	\N	\N	\N	\N	69044	69044	237209
2978	2426	0	applied	\N	\N	\N	\N	69048	69048	237213
2980	2426	0	applied	\N	\N	\N	\N	69050	69050	237215
2981	2427	0	applied	\N	\N	\N	\N	69051	69051	237216
2987	2430	0	applied	\N	\N	\N	\N	69057	69057	237222
2990	2431	0	applied	\N	\N	\N	\N	69059	69059	237224
2990	2432	2	applied	\N	\N	\N	\N	69060	69060	237225
2990	2433	3	applied	\N	\N	\N	\N	69061	69061	237226
2993	2434	0	applied	\N	\N	\N	\N	69066	69066	237231
2996	2436	0	applied	\N	\N	\N	\N	69070	69070	237235
2996	2437	1	applied	\N	\N	\N	\N	69071	69071	237236
2999	2438	0	applied	\N	\N	\N	\N	69074	69074	237239
3011	2441	0	applied	\N	\N	\N	\N	69145	69145	237310
3013	2442	0	applied	\N	\N	\N	\N	69147	69147	237312
3014	2442	0	applied	\N	\N	\N	\N	69148	69148	237313
3016	2443	0	applied	\N	\N	\N	\N	69150	69150	237315
3019	2444	0	applied	\N	\N	\N	\N	69153	69153	237318
3020	2445	0	applied	\N	\N	\N	\N	69154	69154	237319
3022	2446	0	applied	\N	\N	\N	\N	69156	69156	237321
3023	2447	0	applied	\N	\N	\N	\N	69157	69157	237322
3028	2449	0	applied	\N	\N	\N	\N	69162	69162	237327
3029	2450	0	applied	\N	\N	\N	\N	69163	69163	237328
3031	2452	0	applied	\N	\N	\N	\N	69165	69165	237330
3032	2452	0	applied	\N	\N	\N	\N	69166	69166	237331
3034	2453	0	applied	\N	\N	\N	\N	69168	69168	237333
3035	2453	0	applied	\N	\N	\N	\N	69169	69169	237334
3037	2456	0	applied	\N	\N	\N	\N	69172	69172	237337
3038	2456	0	applied	\N	\N	\N	\N	69173	69173	237338
3040	2457	0	applied	\N	\N	\N	\N	69175	69175	237340
3042	2458	0	applied	\N	\N	\N	\N	69176	69176	237341
3042	2459	1	applied	\N	\N	\N	\N	69177	69177	237342
3043	2460	0	applied	\N	\N	\N	\N	69178	69178	237343
3043	2461	1	applied	\N	\N	\N	\N	69179	69179	237344
3045	2462	0	applied	\N	\N	\N	\N	69182	69182	237347
3046	2438	0	applied	\N	\N	\N	\N	69183	69183	237348
3046	2429	1	applied	\N	\N	\N	\N	69184	69184	237349
3046	2431	3	applied	\N	\N	\N	\N	69186	69186	237351
3046	2432	4	applied	\N	\N	\N	\N	69187	69187	237352
3046	2433	5	applied	\N	\N	\N	\N	69188	69188	237353
3046	2434	6	applied	\N	\N	\N	\N	69189	69189	237354
3046	2435	8	applied	\N	\N	\N	\N	69190	69190	237355
3046	2436	9	applied	\N	\N	\N	\N	69191	69191	237356
3046	2437	10	applied	\N	\N	\N	\N	69192	69192	237357
3046	2439	11	applied	\N	\N	\N	\N	69193	69193	237358
3046	2440	12	applied	\N	\N	\N	\N	69194	69194	237359
3046	2441	13	applied	\N	\N	\N	\N	69195	69195	237360
3046	2442	14	applied	\N	\N	\N	\N	69196	69196	237361
3046	2443	15	applied	\N	\N	\N	\N	69197	69197	237362
3046	2444	16	applied	\N	\N	\N	\N	69198	69198	237363
3046	2445	17	applied	\N	\N	\N	\N	69199	69199	237364
3046	2446	18	applied	\N	\N	\N	\N	69200	69200	237365
3046	2447	19	applied	\N	\N	\N	\N	69201	69201	237366
3046	2449	21	applied	\N	\N	\N	\N	69203	69203	237368
3046	2450	22	applied	\N	\N	\N	\N	69204	69204	237369
3046	2451	23	applied	\N	\N	\N	\N	69205	69205	237370
3046	2452	24	applied	\N	\N	\N	\N	69206	69206	237371
3046	2453	25	applied	\N	\N	\N	\N	69207	69207	237372
3046	2454	26	applied	\N	\N	\N	\N	69208	69208	237373
3046	2455	27	applied	\N	\N	\N	\N	69209	69209	237374
3046	2456	28	applied	\N	\N	\N	\N	69210	69210	237375
3046	2457	29	applied	\N	\N	\N	\N	69211	69211	237376
3046	2458	30	applied	\N	\N	\N	\N	69212	69212	237377
3046	2459	31	applied	\N	\N	\N	\N	69213	69213	237378
3046	2460	32	applied	\N	\N	\N	\N	69214	69214	237379
3046	2461	33	applied	\N	\N	\N	\N	69215	69215	237380
3046	2462	34	applied	\N	\N	\N	\N	69216	69216	237381
3048	2463	0	applied	\N	\N	\N	\N	69219	69219	237384
3048	2464	1	applied	\N	\N	\N	\N	69220	69220	237385
3051	2469	0	applied	\N	\N	\N	\N	69225	69225	237390
3052	2470	0	applied	\N	\N	\N	\N	69226	69226	237391
3052	2471	1	applied	\N	\N	\N	\N	69227	69227	237392
3055	2472	0	applied	\N	\N	\N	\N	69230	69230	237395
3058	2473	0	applied	\N	\N	1000000000	\N	69231	69231	237396
3058	2474	1	applied	\N	\N	\N	\N	69232	69232	237397
3058	2475	2	applied	\N	\N	\N	\N	69233	69233	237398
3064	2477	0	applied	\N	\N	\N	\N	69236	69236	237401
3067	2479	0	applied	\N	\N	\N	\N	69238	69238	237403
3070	2482	0	applied	\N	\N	\N	\N	69241	69241	237406
3070	2483	1	applied	\N	\N	\N	\N	69242	69242	237407
3073	2485	0	applied	\N	\N	\N	\N	69245	69245	237410
3085	2487	0	applied	\N	\N	\N	\N	69404	69404	237569
3088	2489	0	applied	\N	\N	\N	\N	69408	69408	237573
3088	2490	1	applied	\N	\N	\N	\N	69409	69409	237574
3091	2493	0	applied	\N	\N	\N	\N	69412	69412	237577
3093	2495	1	applied	\N	\N	\N	\N	69540	69540	237705
3093	2496	2	applied	\N	\N	\N	\N	69541	69541	237706
3093	2497	3	applied	\N	\N	\N	\N	69542	69542	237707
3093	2498	4	applied	\N	\N	\N	\N	69543	69543	237708
3093	2499	5	applied	\N	\N	\N	\N	69544	69544	237709
3093	2500	6	applied	\N	\N	\N	\N	69545	69545	237710
3093	2501	7	applied	\N	\N	1000000000	\N	69546	69546	237711
3096	2502	0	applied	\N	\N	\N	\N	69563	69563	237728
3096	2503	1	applied	\N	\N	\N	\N	69564	69564	237729
3096	2504	2	applied	\N	\N	\N	\N	69565	69565	237730
3099	2505	0	applied	\N	\N	\N	\N	69570	69570	237735
3102	2507	0	applied	\N	\N	\N	\N	69573	69573	237738
3108	2512	0	applied	\N	\N	\N	\N	69579	69579	237744
3108	2513	1	applied	\N	\N	\N	\N	69580	69580	237745
3108	2514	2	applied	\N	\N	\N	\N	69581	69581	237746
3114	2518	0	applied	\N	\N	\N	\N	69592	69592	237757
2925	2387	1	applied	\N	\N	\N	\N	68987	68987	237152
2930	2388	0	applied	\N	\N	\N	\N	68992	68992	237157
3074	2485	0	applied	\N	\N	\N	\N	69246	69246	237411
3075	2485	0	applied	\N	\N	\N	\N	69247	69247	237412
3076	2336	32	applied	\N	\N	\N	\N	69279	69279	237444
3076	2337	33	applied	\N	\N	\N	\N	69280	69280	237445
3076	2338	34	applied	\N	\N	\N	\N	69281	69281	237446
3076	2339	35	applied	\N	\N	\N	\N	69282	69282	237447
3076	2340	36	applied	\N	\N	\N	\N	69283	69283	237448
3076	2341	37	applied	\N	\N	\N	\N	69284	69284	237449
3076	2342	38	applied	\N	\N	\N	\N	69285	69285	237450
3076	2343	39	applied	\N	\N	\N	\N	69286	69286	237451
3076	2344	40	applied	\N	\N	\N	\N	69287	69287	237452
3076	2346	41	applied	\N	\N	\N	\N	69288	69288	237453
3076	2347	42	applied	\N	\N	\N	\N	69289	69289	237454
3076	2349	44	applied	\N	\N	\N	\N	69291	69291	237456
3076	2350	45	applied	\N	\N	\N	\N	69292	69292	237457
3076	2351	46	applied	\N	\N	\N	\N	69293	69293	237458
3076	2352	47	applied	\N	\N	\N	\N	69294	69294	237459
3076	2353	48	applied	\N	\N	\N	\N	69295	69295	237460
3076	2354	49	applied	\N	\N	\N	\N	69296	69296	237461
3076	2355	50	applied	\N	\N	\N	\N	69297	69297	237462
3076	2356	51	applied	\N	\N	\N	\N	69298	69298	237463
3076	2357	52	applied	\N	\N	\N	\N	69299	69299	237464
3076	2358	53	applied	\N	\N	\N	\N	69300	69300	237465
3076	2359	54	applied	\N	\N	\N	\N	69301	69301	237466
3076	2360	55	applied	\N	\N	\N	\N	69302	69302	237467
3076	2361	56	applied	\N	\N	\N	\N	69303	69303	237468
3076	2362	57	applied	\N	\N	\N	\N	69304	69304	237469
3076	2363	58	applied	\N	\N	\N	\N	69305	69305	237470
3076	2364	59	applied	\N	\N	\N	\N	69306	69306	237471
3076	2366	61	applied	\N	\N	\N	\N	69308	69308	237473
3076	2367	62	applied	\N	\N	\N	\N	69309	69309	237474
3076	2368	63	applied	\N	\N	\N	\N	69310	69310	237475
3076	2369	64	applied	\N	\N	\N	\N	69311	69311	237476
3076	2370	65	applied	\N	\N	\N	\N	69312	69312	237477
3076	2371	66	applied	\N	\N	\N	\N	69313	69313	237478
3076	2372	67	applied	\N	\N	\N	\N	69314	69314	237479
3076	2373	68	applied	\N	\N	\N	\N	69315	69315	237480
3076	2374	69	applied	\N	\N	\N	\N	69316	69316	237481
3076	2375	70	applied	\N	\N	\N	\N	69317	69317	237482
3076	2376	71	applied	\N	\N	\N	\N	69318	69318	237483
3076	2377	72	applied	\N	\N	\N	\N	69319	69319	237484
3076	2378	73	applied	\N	\N	\N	\N	69320	69320	237485
3078	2487	0	applied	\N	\N	\N	\N	69374	69374	237539
3080	2487	0	applied	\N	\N	\N	\N	69376	69376	237541
3081	2487	0	applied	\N	\N	\N	\N	69377	69377	237542
3084	2463	1	applied	\N	\N	\N	\N	69381	69381	237546
3084	2464	2	applied	\N	\N	\N	\N	69382	69382	237547
3084	2465	3	applied	\N	\N	\N	\N	69383	69383	237548
3084	2466	4	applied	\N	\N	\N	\N	69384	69384	237549
3084	2467	5	applied	\N	\N	\N	\N	69385	69385	237550
3084	2468	6	applied	\N	\N	\N	\N	69386	69386	237551
3084	2469	7	applied	\N	\N	\N	\N	69387	69387	237552
3084	2470	8	applied	\N	\N	\N	\N	69388	69388	237553
3084	2471	9	applied	\N	\N	\N	\N	69389	69389	237554
3084	2472	10	applied	\N	\N	\N	\N	69390	69390	237555
3084	2474	11	applied	\N	\N	\N	\N	69391	69391	237556
3084	2475	12	applied	\N	\N	\N	\N	69392	69392	237557
3084	2476	13	applied	\N	\N	\N	\N	69393	69393	237558
3084	2477	14	applied	\N	\N	\N	\N	69394	69394	237559
3084	2478	15	applied	\N	\N	\N	\N	69395	69395	237560
3084	2479	16	applied	\N	\N	\N	\N	69396	69396	237561
3084	2480	17	applied	\N	\N	\N	\N	69397	69397	237562
3084	2481	18	applied	\N	\N	\N	\N	69398	69398	237563
3084	2483	20	applied	\N	\N	\N	\N	69400	69400	237565
3084	2484	21	applied	\N	\N	\N	\N	69401	69401	237566
3084	2485	22	applied	\N	\N	\N	\N	69402	69402	237567
3084	2486	23	applied	\N	\N	\N	\N	69403	69403	237568
3087	2489	0	applied	\N	\N	\N	\N	69406	69406	237571
3087	2490	1	applied	\N	\N	\N	\N	69407	69407	237572
3090	2492	0	applied	\N	\N	\N	\N	69411	69411	237576
3095	2494	0	applied	\N	\N	\N	\N	69555	69555	237720
3095	2495	1	applied	\N	\N	\N	\N	69556	69556	237721
3095	2496	2	applied	\N	\N	\N	\N	69557	69557	237722
3095	2497	3	applied	\N	\N	\N	\N	69558	69558	237723
3095	2498	4	applied	\N	\N	\N	\N	69559	69559	237724
3095	2499	5	applied	\N	\N	\N	\N	69560	69560	237725
3095	2500	6	applied	\N	\N	\N	\N	69561	69561	237726
3098	2505	0	applied	\N	\N	\N	\N	69569	69569	237734
3101	2506	0	applied	\N	\N	\N	\N	69572	69572	237737
3104	2510	0	applied	\N	\N	\N	\N	69576	69576	237741
3106	2510	0	applied	\N	\N	\N	\N	69577	69577	237742
3107	2511	0	applied	\N	\N	\N	\N	69578	69578	237743
3109	2512	0	applied	\N	\N	\N	\N	69582	69582	237747
3109	2513	1	applied	\N	\N	\N	\N	69583	69583	237748
3109	2514	2	applied	\N	\N	\N	\N	69584	69584	237749
3110	2515	0	applied	\N	\N	\N	\N	69585	69585	237750
3110	2516	1	applied	\N	\N	\N	\N	69586	69586	237751
3113	2517	0	applied	\N	\N	\N	\N	69591	69591	237756
3116	2519	0	applied	\N	\N	\N	\N	69596	69596	237761
3116	2520	1	applied	\N	\N	\N	\N	69597	69597	237762
3116	2521	2	applied	\N	\N	\N	\N	69598	69598	237763
3117	2523	1	applied	\N	\N	\N	\N	69600	69600	237765
3119	2525	0	applied	\N	\N	\N	\N	69602	69602	237767
3120	2526	0	applied	\N	\N	\N	\N	69603	69603	237768
3120	2527	1	applied	\N	\N	\N	\N	69604	69604	237769
3120	2528	2	applied	\N	\N	\N	\N	69605	69605	237770
3120	2529	3	applied	\N	\N	\N	\N	69606	69606	237771
3120	2531	5	applied	\N	\N	\N	\N	69608	69608	237773
3120	2532	6	applied	\N	\N	\N	\N	69609	69609	237774
3120	2533	7	applied	\N	\N	\N	\N	69610	69610	237775
3120	2534	8	applied	\N	\N	\N	\N	69611	69611	237776
3120	2535	9	applied	\N	\N	\N	\N	69612	69612	237777
3120	2536	10	applied	\N	\N	\N	\N	69613	69613	237778
3120	2537	11	applied	\N	\N	\N	\N	69614	69614	237779
3122	2538	0	applied	\N	\N	\N	\N	69627	69627	237792
3122	2539	1	applied	\N	\N	\N	\N	69628	69628	237793
3122	2540	2	applied	\N	\N	\N	\N	69629	69629	237794
3123	2538	0	applied	\N	\N	\N	\N	69630	69630	237795
3123	2539	1	applied	\N	\N	\N	\N	69631	69631	237796
3123	2540	2	applied	\N	\N	\N	\N	69632	69632	237797
3063	2476	0	applied	\N	\N	\N	\N	69235	69235	237400
3072	2485	0	applied	\N	\N	\N	\N	69244	69244	237409
3076	2382	77	applied	\N	\N	\N	\N	69324	69324	237489
3076	2383	78	applied	\N	\N	\N	\N	69325	69325	237490
3076	2384	79	applied	\N	\N	\N	\N	69326	69326	237491
3076	2385	80	applied	\N	\N	\N	\N	69327	69327	237492
3076	2386	81	applied	\N	\N	\N	\N	69328	69328	237493
3076	2387	82	applied	\N	\N	\N	\N	69329	69329	237494
3076	2388	83	applied	\N	\N	\N	\N	69330	69330	237495
3076	2389	84	applied	\N	\N	\N	\N	69331	69331	237496
3076	2390	85	applied	\N	\N	\N	\N	69332	69332	237497
3076	2391	86	applied	\N	\N	\N	\N	69333	69333	237498
3076	2392	87	applied	\N	\N	\N	\N	69334	69334	237499
3076	2393	88	applied	\N	\N	\N	\N	69335	69335	237500
3076	2394	89	applied	\N	\N	\N	\N	69336	69336	237501
3076	2396	91	applied	\N	\N	\N	\N	69338	69338	237503
3076	2397	92	applied	\N	\N	\N	\N	69339	69339	237504
3076	2398	93	applied	\N	\N	\N	\N	69340	69340	237505
3076	2399	94	applied	\N	\N	\N	\N	69341	69341	237506
3076	2400	95	applied	\N	\N	\N	\N	69342	69342	237507
3076	2401	96	applied	\N	\N	\N	\N	69343	69343	237508
3076	2402	97	applied	\N	\N	\N	\N	69344	69344	237509
3076	2403	98	applied	\N	\N	\N	\N	69345	69345	237510
3076	2404	99	applied	\N	\N	\N	\N	69346	69346	237511
3076	2405	100	applied	\N	\N	\N	\N	69347	69347	237512
3076	2406	101	applied	\N	\N	\N	\N	69348	69348	237513
3076	2407	102	applied	\N	\N	\N	\N	69349	69349	237514
3076	2408	103	applied	\N	\N	\N	\N	69350	69350	237515
3076	2409	104	applied	\N	\N	\N	\N	69351	69351	237516
3076	2410	105	applied	\N	\N	\N	\N	69352	69352	237517
3076	2411	106	applied	\N	\N	\N	\N	69353	69353	237518
3076	2413	108	applied	\N	\N	\N	\N	69355	69355	237520
3076	2414	109	applied	\N	\N	\N	\N	69356	69356	237521
3076	2415	110	applied	\N	\N	\N	\N	69357	69357	237522
3076	2416	111	applied	\N	\N	\N	\N	69358	69358	237523
3076	2417	112	applied	\N	\N	\N	\N	69359	69359	237524
3076	2418	113	applied	\N	\N	\N	\N	69360	69360	237525
3076	2419	114	applied	\N	\N	\N	\N	69361	69361	237526
3076	2420	115	applied	\N	\N	\N	\N	69362	69362	237527
3076	2421	116	applied	\N	\N	\N	\N	69363	69363	237528
3076	2422	117	applied	\N	\N	\N	\N	69364	69364	237529
3076	2423	118	applied	\N	\N	\N	\N	69365	69365	237530
3076	2424	119	applied	\N	\N	\N	\N	69366	69366	237531
3076	2425	120	applied	\N	\N	\N	\N	69367	69367	237532
3076	2426	121	applied	\N	\N	\N	\N	69368	69368	237533
3076	2427	122	applied	\N	\N	\N	\N	69369	69369	237534
3076	2428	123	applied	\N	\N	\N	\N	69370	69370	237535
3076	2430	125	applied	\N	\N	\N	\N	69372	69372	237537
3077	2486	0	applied	\N	\N	\N	\N	69373	69373	237538
3079	2487	0	applied	\N	\N	\N	\N	69375	69375	237540
3082	2487	0	applied	\N	\N	\N	\N	69378	69378	237543
3083	2487	0	applied	\N	\N	\N	\N	69379	69379	237544
3086	2488	0	applied	\N	\N	\N	\N	69405	69405	237570
3089	2491	0	applied	\N	\N	\N	\N	69410	69410	237575
3092	2438	0	applied	\N	\N	\N	\N	69413	69413	237578
3092	2473	1	applied	\N	\N	1000000000	\N	69414	69414	237579
3092	2307	2	applied	\N	\N	1000000000	\N	69415	69415	237580
3092	2226	3	applied	\N	\N	\N	\N	69416	69416	237581
3092	2227	4	applied	\N	\N	\N	\N	69417	69417	237582
3092	2228	5	applied	\N	\N	\N	\N	69418	69418	237583
3092	2229	6	applied	\N	\N	\N	\N	69419	69419	237584
3092	2230	7	applied	\N	\N	\N	\N	69420	69420	237585
3092	2231	8	applied	\N	\N	\N	\N	69421	69421	237586
3092	2233	10	applied	\N	\N	\N	\N	69423	69423	237588
3092	2234	11	applied	\N	\N	\N	\N	69424	69424	237589
3092	2235	12	applied	\N	\N	\N	\N	69425	69425	237590
3092	2236	13	applied	\N	\N	\N	\N	69426	69426	237591
3092	2237	14	applied	\N	\N	\N	\N	69427	69427	237592
3092	2309	15	applied	\N	\N	\N	\N	69428	69428	237593
3092	2238	16	applied	\N	\N	\N	\N	69429	69429	237594
3092	2239	17	applied	\N	\N	\N	\N	69430	69430	237595
3092	2240	18	applied	\N	\N	\N	\N	69431	69431	237596
3092	2241	19	applied	\N	\N	\N	\N	69432	69432	237597
3092	2242	20	applied	\N	\N	\N	\N	69433	69433	237598
3092	2243	21	applied	\N	\N	\N	\N	69434	69434	237599
3092	2244	22	applied	\N	\N	\N	\N	69435	69435	237600
3092	2245	23	applied	\N	\N	\N	\N	69436	69436	237601
3092	2246	24	applied	\N	\N	\N	\N	69437	69437	237602
3092	2247	25	applied	\N	\N	\N	\N	69438	69438	237603
3092	2249	27	applied	\N	\N	\N	\N	69440	69440	237605
3092	2250	28	applied	\N	\N	\N	\N	69441	69441	237606
3092	2251	29	applied	\N	\N	\N	\N	69442	69442	237607
3092	2252	30	applied	\N	\N	\N	\N	69443	69443	237608
3092	2253	31	applied	\N	\N	\N	\N	69444	69444	237609
3092	2254	32	applied	\N	\N	\N	\N	69445	69445	237610
3092	2255	33	applied	\N	\N	\N	\N	69446	69446	237611
3092	2256	34	applied	\N	\N	\N	\N	69447	69447	237612
3092	2257	35	applied	\N	\N	\N	\N	69448	69448	237613
3092	2258	36	applied	\N	\N	\N	\N	69449	69449	237614
3092	2259	37	applied	\N	\N	\N	\N	69450	69450	237615
3092	2260	38	applied	\N	\N	\N	\N	69451	69451	237616
3092	2261	39	applied	\N	\N	\N	\N	69452	69452	237617
3092	2262	40	applied	\N	\N	\N	\N	69453	69453	237618
3092	2263	41	applied	\N	\N	\N	\N	69454	69454	237619
3092	2264	42	applied	\N	\N	\N	\N	69455	69455	237620
3092	2266	44	applied	\N	\N	\N	\N	69457	69457	237622
3092	2267	45	applied	\N	\N	\N	\N	69458	69458	237623
3092	2268	46	applied	\N	\N	\N	\N	69459	69459	237624
3092	2269	47	applied	\N	\N	\N	\N	69460	69460	237625
3092	2270	48	applied	\N	\N	\N	\N	69461	69461	237626
3092	2271	49	applied	\N	\N	\N	\N	69462	69462	237627
3092	2272	50	applied	\N	\N	\N	\N	69463	69463	237628
3092	2273	51	applied	\N	\N	\N	\N	69464	69464	237629
3092	2274	52	applied	\N	\N	\N	\N	69465	69465	237630
3092	2275	53	applied	\N	\N	\N	\N	69466	69466	237631
3092	2276	54	applied	\N	\N	\N	\N	69467	69467	237632
3092	2277	55	applied	\N	\N	\N	\N	69468	69468	237633
3092	2278	56	applied	\N	\N	\N	\N	69469	69469	237634
3092	2279	57	applied	\N	\N	\N	\N	69470	69470	237635
3092	2280	58	applied	\N	\N	\N	\N	69471	69471	237636
3092	2281	59	applied	\N	\N	\N	\N	69472	69472	237637
3076	2380	75	applied	\N	\N	\N	\N	69322	69322	237487
3076	2381	76	applied	\N	\N	\N	\N	69323	69323	237488
3092	2287	64	applied	\N	\N	\N	\N	69477	69477	237642
3092	2288	65	applied	\N	\N	\N	\N	69478	69478	237643
3092	2289	66	applied	\N	\N	\N	\N	69479	69479	237644
3092	2290	67	applied	\N	\N	\N	\N	69480	69480	237645
3092	2291	68	applied	\N	\N	\N	\N	69481	69481	237646
3092	2292	69	applied	\N	\N	\N	\N	69482	69482	237647
3092	2293	70	applied	\N	\N	\N	\N	69483	69483	237648
3092	2294	71	applied	\N	\N	\N	\N	69484	69484	237649
3092	2295	72	applied	\N	\N	\N	\N	69485	69485	237650
3092	2296	73	applied	\N	\N	\N	\N	69486	69486	237651
3092	2297	74	applied	\N	\N	\N	\N	69487	69487	237652
3092	2298	75	applied	\N	\N	\N	\N	69488	69488	237653
3092	2299	76	applied	\N	\N	\N	\N	69489	69489	237654
3092	2301	78	applied	\N	\N	\N	\N	69491	69491	237656
3092	2302	79	applied	\N	\N	\N	\N	69492	69492	237657
3092	2303	80	applied	\N	\N	\N	\N	69493	69493	237658
3092	2304	81	applied	\N	\N	\N	\N	69494	69494	237659
3092	2305	82	applied	\N	\N	\N	\N	69495	69495	237660
3092	2306	83	applied	\N	\N	\N	\N	69496	69496	237661
3092	2308	84	applied	\N	\N	\N	\N	69497	69497	237662
3092	2311	85	applied	\N	\N	\N	\N	69498	69498	237663
3092	2312	86	applied	\N	\N	\N	\N	69499	69499	237664
3092	2313	87	applied	\N	\N	\N	\N	69500	69500	237665
3092	2314	88	applied	\N	\N	\N	\N	69501	69501	237666
3092	2315	89	applied	\N	\N	\N	\N	69502	69502	237667
3092	2316	90	applied	\N	\N	\N	\N	69503	69503	237668
3092	2317	91	applied	\N	\N	\N	\N	69504	69504	237669
3092	2318	92	applied	\N	\N	\N	\N	69505	69505	237670
3092	2319	93	applied	\N	\N	\N	\N	69506	69506	237671
3092	2321	95	applied	\N	\N	\N	\N	69508	69508	237673
3092	2322	96	applied	\N	\N	\N	\N	69509	69509	237674
3092	2323	97	applied	\N	\N	\N	\N	69510	69510	237675
3092	2324	98	applied	\N	\N	\N	\N	69511	69511	237676
3092	2326	99	applied	\N	\N	\N	\N	69512	69512	237677
3092	2327	100	applied	\N	\N	\N	\N	69513	69513	237678
3092	2328	101	applied	\N	\N	\N	\N	69514	69514	237679
3092	2329	102	applied	\N	\N	\N	\N	69515	69515	237680
3092	2330	103	applied	\N	\N	\N	\N	69516	69516	237681
3092	2331	104	applied	\N	\N	\N	\N	69517	69517	237682
3092	2332	105	applied	\N	\N	\N	\N	69518	69518	237683
3092	2333	106	applied	\N	\N	\N	\N	69519	69519	237684
3092	2334	107	applied	\N	\N	\N	\N	69520	69520	237685
3092	2335	108	applied	\N	\N	\N	\N	69521	69521	237686
3092	2336	109	applied	\N	\N	\N	\N	69522	69522	237687
3092	2337	110	applied	\N	\N	\N	\N	69523	69523	237688
3092	2339	112	applied	\N	\N	\N	\N	69525	69525	237690
3092	2340	113	applied	\N	\N	\N	\N	69526	69526	237691
3092	2341	114	applied	\N	\N	\N	\N	69527	69527	237692
3092	2342	115	applied	\N	\N	\N	\N	69528	69528	237693
3092	2343	116	applied	\N	\N	\N	\N	69529	69529	237694
3092	2344	117	applied	\N	\N	\N	\N	69530	69530	237695
3092	2346	118	applied	\N	\N	\N	\N	69531	69531	237696
3092	2347	119	applied	\N	\N	\N	\N	69532	69532	237697
3092	2348	120	applied	\N	\N	\N	\N	69533	69533	237698
3092	2349	121	applied	\N	\N	\N	\N	69534	69534	237699
3092	2350	122	applied	\N	\N	\N	\N	69535	69535	237700
3092	2351	123	applied	\N	\N	\N	\N	69536	69536	237701
3092	2352	124	applied	\N	\N	\N	\N	69537	69537	237702
3092	2353	125	applied	\N	\N	\N	\N	69538	69538	237703
3094	2494	0	applied	\N	\N	\N	\N	69547	69547	237712
3094	2495	1	applied	\N	\N	\N	\N	69548	69548	237713
3094	2497	3	applied	\N	\N	\N	\N	69550	69550	237715
3094	2498	4	applied	\N	\N	\N	\N	69551	69551	237716
3094	2499	5	applied	\N	\N	\N	\N	69552	69552	237717
3094	2500	6	applied	\N	\N	\N	\N	69553	69553	237718
3094	2501	7	applied	\N	\N	1000000000	\N	69554	69554	237719
3097	2502	0	applied	\N	\N	\N	\N	69566	69566	237731
3097	2503	1	applied	\N	\N	\N	\N	69567	69567	237732
3097	2504	2	applied	\N	\N	\N	\N	69568	69568	237733
3100	2506	0	applied	\N	\N	\N	\N	69571	69571	237736
3103	2508	0	applied	\N	\N	\N	\N	69574	69574	237739
3103	2509	1	applied	\N	\N	\N	\N	69575	69575	237740
3111	2515	0	applied	\N	\N	\N	\N	69587	69587	237752
3111	2516	1	applied	\N	\N	\N	\N	69588	69588	237753
3112	2515	0	applied	\N	\N	\N	\N	69589	69589	237754
3112	2516	1	applied	\N	\N	\N	\N	69590	69590	237755
3115	2519	0	applied	\N	\N	\N	\N	69593	69593	237758
3115	2521	2	applied	\N	\N	\N	\N	69595	69595	237760
3118	2524	0	applied	\N	\N	\N	\N	69601	69601	237766
3121	2526	0	applied	\N	\N	\N	\N	69615	69615	237780
3121	2527	1	applied	\N	\N	\N	\N	69616	69616	237781
3121	2528	2	applied	\N	\N	\N	\N	69617	69617	237782
3121	2529	3	applied	\N	\N	\N	\N	69618	69618	237783
3121	2530	4	applied	\N	\N	\N	\N	69619	69619	237784
3121	2531	5	applied	\N	\N	\N	\N	69620	69620	237785
3121	2532	6	applied	\N	\N	\N	\N	69621	69621	237786
3121	2533	7	applied	\N	\N	\N	\N	69622	69622	237787
3121	2534	8	applied	\N	\N	\N	\N	69623	69623	237788
3121	2535	9	applied	\N	\N	\N	\N	69624	69624	237789
3121	2536	10	applied	\N	\N	\N	\N	69625	69625	237790
3121	2537	11	applied	\N	\N	\N	\N	69626	69626	237791
3124	2541	0	applied	\N	\N	\N	\N	69633	69633	237798
3124	2542	1	applied	\N	\N	\N	\N	69634	69634	237799
3124	2544	3	applied	\N	\N	\N	\N	69636	69636	237801
3125	2545	0	applied	\N	\N	\N	\N	69637	69637	237802
3125	2546	1	applied	\N	\N	\N	\N	69638	69638	237803
3125	2547	2	applied	\N	\N	\N	\N	69639	69639	237804
3128	2548	0	applied	\N	\N	\N	\N	69640	69640	237805
3128	2549	1	applied	\N	\N	\N	\N	69641	69641	237806
3128	2550	2	applied	\N	\N	\N	\N	69642	69642	237807
3128	2551	3	applied	\N	\N	\N	\N	69643	69643	237808
3129	2552	0	applied	\N	\N	\N	\N	69644	69644	237809
3130	2552	0	applied	\N	\N	\N	\N	69645	69645	237810
3131	2501	0	applied	\N	\N	1000000000	\N	69646	69646	237811
3131	2504	1	applied	\N	\N	\N	\N	69647	69647	237812
3131	2526	2	applied	\N	\N	\N	\N	69648	69648	237813
3131	2527	3	applied	\N	\N	\N	\N	69649	69649	237814
3131	2530	4	applied	\N	\N	\N	\N	69650	69650	237815
3131	2531	5	applied	\N	\N	\N	\N	69651	69651	237816
3092	2284	62	applied	\N	\N	\N	\N	69475	69475	237640
3092	2286	63	applied	\N	\N	\N	\N	69476	69476	237641
3131	2537	11	applied	\N	\N	\N	\N	69657	69657	237822
3131	2544	12	applied	\N	\N	\N	\N	69658	69658	237823
3132	2553	0	applied	\N	\N	\N	\N	69659	69659	237824
3133	2553	0	applied	\N	\N	\N	\N	69660	69660	237825
3134	2554	0	applied	\N	\N	\N	\N	69661	69661	237826
3135	2555	0	applied	\N	\N	\N	\N	69662	69662	237827
3136	2555	0	applied	\N	\N	\N	\N	69663	69663	237828
3137	2555	0	applied	\N	\N	\N	\N	69664	69664	237829
3138	2556	0	applied	\N	\N	\N	\N	69665	69665	237830
3138	2557	1	applied	\N	\N	\N	\N	69666	69666	237831
3138	2558	2	applied	\N	\N	\N	\N	69667	69667	237832
3138	2559	3	applied	\N	\N	\N	\N	69668	69668	237833
3139	2556	0	applied	\N	\N	\N	\N	69669	69669	237834
3139	2557	1	applied	\N	\N	\N	\N	69670	69670	237835
3139	2559	3	applied	\N	\N	\N	\N	69672	69672	237837
3140	2560	0	applied	\N	\N	\N	\N	69673	69673	237838
3140	2561	1	applied	\N	\N	\N	\N	69674	69674	237839
3141	2562	0	applied	\N	\N	\N	\N	69675	69675	237840
3141	2563	1	applied	\N	\N	\N	\N	69676	69676	237841
3141	2564	2	applied	\N	\N	\N	\N	69677	69677	237842
3141	2565	3	applied	\N	\N	\N	\N	69678	69678	237843
3141	2566	4	applied	\N	\N	\N	\N	69679	69679	237844
3142	2567	0	applied	\N	\N	\N	\N	69680	69680	237845
3143	2567	0	applied	\N	\N	\N	\N	69681	69681	237846
3144	2567	0	applied	\N	\N	\N	\N	69682	69682	237847
3145	2567	0	applied	\N	\N	\N	\N	69683	69683	237848
3146	2568	0	applied	\N	\N	\N	\N	69684	69684	237849
3147	2568	0	applied	\N	\N	\N	\N	69685	69685	237850
3148	2569	0	applied	\N	\N	\N	\N	69686	69686	237851
3148	2570	1	applied	\N	\N	\N	\N	69687	69687	237852
3149	2570	1	applied	\N	\N	\N	\N	69689	69689	237854
3150	2571	0	applied	\N	\N	\N	\N	69690	69690	237855
3151	2569	0	applied	\N	\N	\N	\N	69691	69691	237856
3151	2570	1	applied	\N	\N	\N	\N	69692	69692	237857
3151	2571	2	applied	\N	\N	\N	\N	69693	69693	237858
3152	2571	0	applied	\N	\N	\N	\N	69694	69694	237859
3153	2572	0	applied	\N	\N	\N	\N	69695	69695	237860
3154	2573	0	applied	\N	\N	\N	\N	69696	69696	237861
3155	2574	0	applied	\N	\N	\N	\N	69697	69697	237862
3156	2574	0	applied	\N	\N	\N	\N	69698	69698	237863
3157	2574	0	applied	\N	\N	\N	\N	69699	69699	237864
3158	2574	0	applied	\N	\N	\N	\N	69700	69700	237865
3159	2575	0	applied	\N	\N	\N	\N	69701	69701	237866
3160	2575	0	applied	\N	\N	\N	\N	69702	69702	237867
3161	2575	0	applied	\N	\N	\N	\N	69703	69703	237868
3162	2575	0	applied	\N	\N	\N	\N	69704	69704	237869
3164	2577	0	applied	\N	\N	\N	\N	69706	69706	237871
3165	2578	0	applied	\N	\N	\N	\N	69707	69707	237872
3165	2579	1	applied	\N	\N	\N	\N	69708	69708	237873
3165	2580	2	applied	\N	\N	\N	\N	69709	69709	237874
3165	2581	3	applied	\N	\N	\N	\N	69710	69710	237875
3165	2582	4	applied	\N	\N	\N	\N	69711	69711	237876
3166	2583	0	applied	\N	\N	\N	\N	69712	69712	237877
3167	2583	0	applied	\N	\N	\N	\N	69713	69713	237878
3168	2584	0	applied	\N	\N	\N	\N	69714	69714	237879
3169	2584	0	applied	\N	\N	\N	\N	69715	69715	237880
3170	2585	0	applied	\N	\N	\N	\N	69716	69716	237881
3171	2585	0	applied	\N	\N	\N	\N	69717	69717	237882
3172	2585	0	applied	\N	\N	\N	\N	69718	69718	237883
3173	2585	0	applied	\N	\N	\N	\N	69719	69719	237884
3174	2586	0	applied	\N	\N	\N	\N	69720	69720	237885
3175	2586	0	applied	\N	\N	\N	\N	69721	69721	237886
3176	2473	1	applied	\N	\N	1000000000	\N	69723	69723	237888
3177	2587	0	applied	\N	\N	\N	\N	69724	69724	237889
3177	2588	1	applied	\N	\N	\N	\N	69725	69725	237890
3178	2587	0	applied	\N	\N	\N	\N	69726	69726	237891
3178	2588	1	applied	\N	\N	\N	\N	69727	69727	237892
3179	2589	0	applied	\N	\N	\N	\N	69728	69728	237893
3179	2590	1	applied	\N	\N	\N	\N	69729	69729	237894
3180	2589	0	applied	\N	\N	\N	\N	69730	69730	237895
3180	2590	1	applied	\N	\N	\N	\N	69731	69731	237896
3188	2594	0	applied	\N	\N	\N	\N	69739	69739	237904
3191	2599	0	applied	\N	\N	\N	\N	69745	69745	237910
3195	2600	0	applied	\N	\N	\N	\N	69749	69749	237914
3197	2602	0	applied	\N	\N	\N	\N	69751	69751	237916
3197	2603	1	applied	\N	\N	\N	\N	69752	69752	237917
3199	2604	0	applied	\N	\N	\N	\N	69755	69755	237920
3202	2605	0	applied	\N	\N	\N	\N	69757	69757	237922
3202	2607	2	applied	\N	\N	\N	\N	69759	69759	237924
3202	2608	3	applied	\N	\N	\N	\N	69760	69760	237925
3202	2609	4	applied	\N	\N	\N	\N	69761	69761	237926
3202	2610	5	applied	\N	\N	\N	\N	69762	69762	237927
3202	2611	6	applied	\N	\N	\N	\N	69763	69763	237928
3205	2613	0	applied	\N	\N	\N	\N	69772	69772	237937
3208	2614	0	applied	\N	\N	\N	\N	69775	69775	237940
3210	2615	0	applied	\N	\N	\N	\N	69901	69901	238066
3210	2616	1	applied	\N	\N	\N	\N	69902	69902	238067
3214	2621	0	applied	\N	\N	\N	\N	69907	69907	238072
3215	2621	0	applied	\N	\N	\N	\N	69908	69908	238073
3216	2622	0	applied	\N	\N	\N	\N	69909	69909	238074
3216	2623	1	applied	\N	\N	\N	\N	69910	69910	238075
3218	2624	0	applied	\N	\N	\N	\N	69913	69913	238078
3220	2625	0	applied	\N	\N	\N	\N	69915	69915	238080
3223	2625	0	applied	\N	\N	\N	\N	69918	69918	238083
3230	2640	1	applied	\N	\N	\N	\N	69965	69965	238130
3230	2641	2	applied	\N	\N	\N	\N	69966	69966	238131
3230	2642	3	applied	\N	\N	\N	\N	69967	69967	238132
3230	2643	4	applied	\N	\N	\N	\N	69968	69968	238133
3230	2644	5	applied	\N	\N	\N	\N	69969	69969	238134
3237	2667	0	applied	\N	\N	\N	\N	70003	70003	238168
3240	2668	0	applied	\N	\N	\N	\N	70023	70023	238188
3240	2669	1	applied	\N	\N	\N	\N	70024	70024	238189
3240	2670	2	applied	\N	\N	\N	\N	70025	70025	238190
3240	2671	3	applied	\N	\N	\N	\N	70026	70026	238191
3240	2672	4	applied	\N	\N	\N	\N	70027	70027	238192
3240	2673	5	applied	\N	\N	\N	\N	70028	70028	238193
3240	2674	6	applied	\N	\N	\N	\N	70029	70029	238194
3240	2675	7	applied	\N	\N	\N	\N	70030	70030	238195
3240	2676	8	applied	\N	\N	\N	\N	70031	70031	238196
3240	2677	9	applied	\N	\N	\N	\N	70032	70032	238197
3131	2536	10	applied	\N	\N	\N	\N	69656	69656	237821
3186	2593	0	applied	\N	\N	\N	\N	69737	69737	237902
3190	2595	0	applied	\N	\N	\N	\N	69741	69741	237906
3190	2596	1	applied	\N	\N	\N	\N	69742	69742	237907
3190	2597	2	applied	\N	\N	\N	\N	69743	69743	237908
3190	2598	3	applied	\N	\N	\N	\N	69744	69744	237909
3192	2599	0	applied	\N	\N	\N	\N	69746	69746	237911
3193	2600	0	applied	\N	\N	\N	\N	69747	69747	237912
3198	2602	0	applied	\N	\N	\N	\N	69753	69753	237918
3198	2603	1	applied	\N	\N	\N	\N	69754	69754	237919
3200	2604	0	applied	\N	\N	\N	\N	69756	69756	237921
3203	2605	0	applied	\N	\N	\N	\N	69764	69764	237929
3203	2606	1	applied	\N	\N	\N	\N	69765	69765	237930
3203	2607	2	applied	\N	\N	\N	\N	69766	69766	237931
3203	2608	3	applied	\N	\N	\N	\N	69767	69767	237932
3203	2610	5	applied	\N	\N	\N	\N	69769	69769	237934
3203	2611	6	applied	\N	\N	\N	\N	69770	69770	237935
3206	2614	0	applied	\N	\N	\N	\N	69773	69773	237938
3209	2487	0	applied	\N	\N	\N	\N	69776	69776	237941
3209	2488	1	applied	\N	\N	\N	\N	69777	69777	237942
3209	2489	2	applied	\N	\N	\N	\N	69778	69778	237943
3209	2490	3	applied	\N	\N	\N	\N	69779	69779	237944
3209	2491	4	applied	\N	\N	\N	\N	69780	69780	237945
3209	2492	5	applied	\N	\N	\N	\N	69781	69781	237946
3209	2493	6	applied	\N	\N	\N	\N	69782	69782	237947
3209	2494	7	applied	\N	\N	\N	\N	69783	69783	237948
3209	2495	8	applied	\N	\N	\N	\N	69784	69784	237949
3209	2496	9	applied	\N	\N	\N	\N	69785	69785	237950
3209	2497	10	applied	\N	\N	\N	\N	69786	69786	237951
3209	2498	11	applied	\N	\N	\N	\N	69787	69787	237952
3209	2499	12	applied	\N	\N	\N	\N	69788	69788	237953
3209	2502	14	applied	\N	\N	\N	\N	69790	69790	237955
3209	2503	15	applied	\N	\N	\N	\N	69791	69791	237956
3209	2505	16	applied	\N	\N	\N	\N	69792	69792	237957
3209	2501	17	applied	\N	\N	1000000000	\N	69793	69793	237958
3209	2506	18	applied	\N	\N	\N	\N	69794	69794	237959
3209	2507	19	applied	\N	\N	\N	\N	69795	69795	237960
3240	2678	10	applied	\N	\N	\N	\N	70033	70033	238198
3240	2679	11	applied	\N	\N	\N	\N	70034	70034	238199
3240	2680	12	applied	\N	\N	\N	\N	70035	70035	238200
3240	2681	13	applied	\N	\N	\N	\N	70036	70036	238201
3240	2682	14	applied	\N	\N	\N	\N	70037	70037	238202
3240	2683	15	applied	\N	\N	\N	\N	70038	70038	238203
3240	2684	16	applied	\N	\N	\N	\N	70039	70039	238204
3240	2685	17	applied	\N	\N	\N	\N	70040	70040	238205
3242	2686	0	applied	\N	\N	\N	\N	70044	70044	238209
3242	2687	1	applied	\N	\N	\N	\N	70045	70045	238210
3243	2689	0	applied	\N	\N	\N	\N	70047	70047	238212
3245	2690	0	applied	\N	\N	\N	\N	70049	70049	238214
3245	2691	1	applied	\N	\N	\N	\N	70050	70050	238215
3247	2626	0	applied	\N	\N	\N	\N	70053	70053	238218
3247	2627	1	applied	\N	\N	\N	\N	70054	70054	238219
3247	2628	2	applied	\N	\N	\N	\N	70055	70055	238220
3247	2639	3	applied	\N	\N	\N	\N	70056	70056	238221
3247	2647	4	applied	\N	\N	\N	\N	70057	70057	238222
3247	2648	5	applied	\N	\N	\N	\N	70058	70058	238223
3247	2649	6	applied	\N	\N	\N	\N	70059	70059	238224
3247	2650	7	applied	\N	\N	\N	\N	70060	70060	238225
3247	2658	8	applied	\N	\N	\N	\N	70061	70061	238226
3247	2659	9	applied	\N	\N	\N	\N	70062	70062	238227
3247	2663	10	applied	\N	\N	\N	\N	70063	70063	238228
3247	2667	11	applied	\N	\N	\N	\N	70064	70064	238229
3247	2681	12	applied	\N	\N	\N	\N	70065	70065	238230
3247	2683	14	applied	\N	\N	\N	\N	70067	70067	238232
3247	2686	15	applied	\N	\N	\N	\N	70068	70068	238233
3247	2689	16	applied	\N	\N	\N	\N	70069	70069	238234
3247	2690	17	applied	\N	\N	\N	\N	70070	70070	238235
3247	2691	18	applied	\N	\N	\N	\N	70071	70071	238236
3247	2629	19	applied	\N	\N	\N	\N	70072	70072	238237
3247	2630	20	applied	\N	\N	\N	\N	70073	70073	238238
3247	2631	21	applied	\N	\N	\N	\N	70074	70074	238239
3247	2632	22	applied	\N	\N	\N	\N	70075	70075	238240
3247	2633	23	applied	\N	\N	\N	\N	70076	70076	238241
3247	2634	24	applied	\N	\N	\N	\N	70077	70077	238242
3247	2635	25	applied	\N	\N	\N	\N	70078	70078	238243
3247	2636	26	applied	\N	\N	\N	\N	70079	70079	238244
3247	2637	27	applied	\N	\N	\N	\N	70080	70080	238245
3247	2638	28	applied	\N	\N	\N	\N	70081	70081	238246
3247	2640	29	applied	\N	\N	\N	\N	70082	70082	238247
3247	2642	31	applied	\N	\N	\N	\N	70084	70084	238249
3247	2643	32	applied	\N	\N	\N	\N	70085	70085	238250
3247	2644	33	applied	\N	\N	\N	\N	70086	70086	238251
3247	2645	34	applied	\N	\N	\N	\N	70087	70087	238252
3247	2646	35	applied	\N	\N	\N	\N	70088	70088	238253
3247	2651	36	applied	\N	\N	\N	\N	70089	70089	238254
3247	2652	37	applied	\N	\N	\N	\N	70090	70090	238255
3247	2653	38	applied	\N	\N	\N	\N	70091	70091	238256
3247	2654	39	applied	\N	\N	\N	\N	70092	70092	238257
3247	2655	40	applied	\N	\N	\N	\N	70093	70093	238258
3247	2656	41	applied	\N	\N	\N	\N	70094	70094	238259
3247	2657	42	applied	\N	\N	\N	\N	70095	70095	238260
3247	2660	43	applied	\N	\N	\N	\N	70096	70096	238261
3247	2661	44	applied	\N	\N	\N	\N	70097	70097	238262
3247	2662	45	applied	\N	\N	\N	\N	70098	70098	238263
3247	2664	46	applied	\N	\N	\N	\N	70099	70099	238264
3247	2666	48	applied	\N	\N	\N	\N	70101	70101	238266
3247	2668	49	applied	\N	\N	\N	\N	70102	70102	238267
3247	2669	50	applied	\N	\N	\N	\N	70103	70103	238268
3247	2670	51	applied	\N	\N	\N	\N	70104	70104	238269
3247	2671	52	applied	\N	\N	\N	\N	70105	70105	238270
3247	2672	53	applied	\N	\N	\N	\N	70106	70106	238271
3247	2673	54	applied	\N	\N	\N	\N	70107	70107	238272
3247	2674	55	applied	\N	\N	\N	\N	70108	70108	238273
3247	2675	56	applied	\N	\N	\N	\N	70109	70109	238274
3247	2676	57	applied	\N	\N	\N	\N	70110	70110	238275
3247	2677	58	applied	\N	\N	\N	\N	70111	70111	238276
3247	2678	59	applied	\N	\N	\N	\N	70112	70112	238277
3247	2679	60	applied	\N	\N	\N	\N	70113	70113	238278
3247	2680	61	applied	\N	\N	\N	\N	70114	70114	238279
3247	2684	62	applied	\N	\N	\N	\N	70115	70115	238280
3247	2685	63	applied	\N	\N	\N	\N	70116	70116	238281
3185	2592	0	applied	\N	\N	\N	\N	69736	69736	237901
3196	2601	0	applied	\N	\N	\N	\N	69750	69750	237915
3204	2612	0	applied	\N	\N	\N	\N	69771	69771	237936
3207	2614	0	applied	\N	\N	\N	\N	69774	69774	237939
3209	2508	20	applied	\N	\N	\N	\N	69796	69796	237961
3209	2504	21	applied	\N	\N	\N	\N	69797	69797	237962
3209	2526	22	applied	\N	\N	\N	\N	69798	69798	237963
3209	2527	23	applied	\N	\N	\N	\N	69799	69799	237964
3209	2530	24	applied	\N	\N	\N	\N	69800	69800	237965
3209	2531	25	applied	\N	\N	\N	\N	69801	69801	237966
3209	2532	26	applied	\N	\N	\N	\N	69802	69802	237967
3209	2533	27	applied	\N	\N	\N	\N	69803	69803	237968
3209	2534	28	applied	\N	\N	\N	\N	69804	69804	237969
3209	2535	29	applied	\N	\N	\N	\N	69805	69805	237970
3209	2536	30	applied	\N	\N	\N	\N	69806	69806	237971
3209	2544	32	applied	\N	\N	\N	\N	69808	69808	237973
3209	2509	33	applied	\N	\N	\N	\N	69809	69809	237974
3209	2510	34	applied	\N	\N	\N	\N	69810	69810	237975
3209	2511	35	applied	\N	\N	\N	\N	69811	69811	237976
3209	2512	36	applied	\N	\N	\N	\N	69812	69812	237977
3209	2513	37	applied	\N	\N	\N	\N	69813	69813	237978
3209	2514	38	applied	\N	\N	\N	\N	69814	69814	237979
3209	2515	39	applied	\N	\N	\N	\N	69815	69815	237980
3209	2516	40	applied	\N	\N	\N	\N	69816	69816	237981
3209	2517	41	applied	\N	\N	\N	\N	69817	69817	237982
3209	2518	42	applied	\N	\N	\N	\N	69818	69818	237983
3209	2519	43	applied	\N	\N	\N	\N	69819	69819	237984
3209	2520	44	applied	\N	\N	\N	\N	69820	69820	237985
3209	2521	45	applied	\N	\N	\N	\N	69821	69821	237986
3209	2522	46	applied	\N	\N	\N	\N	69822	69822	237987
3209	2523	47	applied	\N	\N	\N	\N	69823	69823	237988
3209	2525	49	applied	\N	\N	\N	\N	69825	69825	237990
3209	2528	50	applied	\N	\N	\N	\N	69826	69826	237991
3209	2529	51	applied	\N	\N	\N	\N	69827	69827	237992
3209	2538	52	applied	\N	\N	\N	\N	69828	69828	237993
3209	2539	53	applied	\N	\N	\N	\N	69829	69829	237994
3209	2540	54	applied	\N	\N	\N	\N	69830	69830	237995
3209	2541	55	applied	\N	\N	\N	\N	69831	69831	237996
3209	2542	56	applied	\N	\N	\N	\N	69832	69832	237997
3209	2543	57	applied	\N	\N	\N	\N	69833	69833	237998
3209	2545	58	applied	\N	\N	\N	\N	69834	69834	237999
3209	2546	59	applied	\N	\N	\N	\N	69835	69835	238000
3209	2547	60	applied	\N	\N	\N	\N	69836	69836	238001
3209	2548	61	applied	\N	\N	\N	\N	69837	69837	238002
3209	2549	62	applied	\N	\N	\N	\N	69838	69838	238003
3209	2550	63	applied	\N	\N	\N	\N	69839	69839	238004
3209	2551	64	applied	\N	\N	\N	\N	69840	69840	238005
3209	2553	66	applied	\N	\N	\N	\N	69842	69842	238007
3209	2554	67	applied	\N	\N	\N	\N	69843	69843	238008
3209	2555	68	applied	\N	\N	\N	\N	69844	69844	238009
3209	2556	69	applied	\N	\N	\N	\N	69845	69845	238010
3209	2557	70	applied	\N	\N	\N	\N	69846	69846	238011
3209	2558	71	applied	\N	\N	\N	\N	69847	69847	238012
3209	2559	73	applied	\N	\N	\N	\N	69848	69848	238013
3209	2560	74	applied	\N	\N	\N	\N	69849	69849	238014
3209	2561	75	applied	\N	\N	\N	\N	69850	69850	238015
3209	2562	76	applied	\N	\N	\N	\N	69851	69851	238016
3209	2563	77	applied	\N	\N	\N	\N	69852	69852	238017
3209	2564	78	applied	\N	\N	\N	\N	69853	69853	238018
3209	2565	79	applied	\N	\N	\N	\N	69854	69854	238019
3209	2566	80	applied	\N	\N	\N	\N	69855	69855	238020
3209	2567	81	applied	\N	\N	\N	\N	69856	69856	238021
3209	2568	82	applied	\N	\N	\N	\N	69857	69857	238022
3209	2570	84	applied	\N	\N	\N	\N	69859	69859	238024
3209	2571	85	applied	\N	\N	\N	\N	69860	69860	238025
3209	2572	86	applied	\N	\N	\N	\N	69861	69861	238026
3209	2573	87	applied	\N	\N	\N	\N	69862	69862	238027
3209	2574	88	applied	\N	\N	\N	\N	69863	69863	238028
3209	2575	89	applied	\N	\N	\N	\N	69864	69864	238029
3209	2576	90	applied	\N	\N	\N	\N	69865	69865	238030
3209	2577	91	applied	\N	\N	\N	\N	69866	69866	238031
3209	2578	92	applied	\N	\N	\N	\N	69867	69867	238032
3209	2579	93	applied	\N	\N	\N	\N	69868	69868	238033
3209	2580	94	applied	\N	\N	\N	\N	69869	69869	238034
3209	2581	95	applied	\N	\N	\N	\N	69870	69870	238035
3209	2582	96	applied	\N	\N	\N	\N	69871	69871	238036
3209	2583	97	applied	\N	\N	\N	\N	69872	69872	238037
3209	2584	98	applied	\N	\N	\N	\N	69873	69873	238038
3222	2625	0	applied	\N	\N	\N	\N	69917	69917	238082
3229	2626	0	applied	\N	\N	\N	\N	69960	69960	238125
3229	2627	1	applied	\N	\N	\N	\N	69961	69961	238126
3229	2628	2	applied	\N	\N	\N	\N	69962	69962	238127
3229	2629	3	applied	\N	\N	\N	\N	69963	69963	238128
3233	2438	0	applied	\N	\N	\N	\N	69980	69980	238145
3233	2626	1	applied	\N	\N	\N	\N	69981	69981	238146
3233	2473	2	applied	\N	\N	1000000000	\N	69982	69982	238147
3233	2428	3	applied	\N	\N	\N	\N	69983	69983	238148
3233	2429	4	applied	\N	\N	\N	\N	69984	69984	238149
3233	2430	5	applied	\N	\N	\N	\N	69985	69985	238150
3233	2431	6	applied	\N	\N	\N	\N	69986	69986	238151
3233	2432	7	applied	\N	\N	\N	\N	69987	69987	238152
3233	2433	8	applied	\N	\N	\N	\N	69988	69988	238153
3233	2434	9	applied	\N	\N	\N	\N	69989	69989	238154
3234	2655	0	applied	\N	\N	\N	\N	69990	69990	238155
3234	2656	1	applied	\N	\N	\N	\N	69991	69991	238156
3234	2658	3	applied	\N	\N	\N	\N	69993	69993	238158
3234	2659	4	applied	\N	\N	\N	\N	69994	69994	238159
3234	2660	5	applied	\N	\N	\N	\N	69995	69995	238160
3234	2661	6	applied	\N	\N	\N	\N	69996	69996	238161
3234	2662	7	applied	\N	\N	\N	\N	69997	69997	238162
3236	2667	0	applied	\N	\N	\N	\N	70002	70002	238167
3246	2690	0	applied	\N	\N	\N	\N	70051	70051	238216
3246	2691	1	applied	\N	\N	\N	\N	70052	70052	238217
3248	2692	0	applied	\N	\N	\N	\N	70119	70119	238284
3250	2693	0	applied	\N	\N	\N	\N	70121	70121	238286
3253	2698	0	applied	\N	\N	\N	\N	70126	70126	238291
3255	2699	0	applied	\N	\N	\N	\N	70129	70129	238294
3255	2700	1	applied	\N	\N	\N	\N	70130	70130	238295
3258	2701	0	applied	\N	\N	\N	\N	70134	70134	238299
3261	2703	0	applied	\N	\N	\N	\N	70137	70137	238302
3263	2709	0	applied	\N	\N	\N	\N	70143	70143	238308
3194	2600	0	applied	\N	\N	\N	\N	69748	69748	237913
3209	2589	103	applied	\N	\N	\N	\N	69878	69878	238043
3209	2590	104	applied	\N	\N	\N	\N	69879	69879	238044
3209	2591	105	applied	\N	\N	\N	\N	69880	69880	238045
3209	2592	106	applied	\N	\N	\N	\N	69881	69881	238046
3209	2593	107	applied	\N	\N	\N	\N	69882	69882	238047
3209	2594	108	applied	\N	\N	\N	\N	69883	69883	238048
3209	2595	109	applied	\N	\N	\N	\N	69884	69884	238049
3209	2596	110	applied	\N	\N	\N	\N	69885	69885	238050
3209	2597	111	applied	\N	\N	\N	\N	69886	69886	238051
3209	2598	112	applied	\N	\N	\N	\N	69887	69887	238052
3209	2599	113	applied	\N	\N	\N	\N	69888	69888	238053
3209	2600	114	applied	\N	\N	\N	\N	69889	69889	238054
3209	2601	115	applied	\N	\N	\N	\N	69890	69890	238055
3209	2602	116	applied	\N	\N	\N	\N	69891	69891	238056
3209	2604	118	applied	\N	\N	\N	\N	69893	69893	238058
3209	2605	119	applied	\N	\N	\N	\N	69894	69894	238059
3209	2606	120	applied	\N	\N	\N	\N	69895	69895	238060
3209	2607	121	applied	\N	\N	\N	\N	69896	69896	238061
3209	2608	122	applied	\N	\N	\N	\N	69897	69897	238062
3209	2609	123	applied	\N	\N	\N	\N	69898	69898	238063
3209	2610	124	applied	\N	\N	\N	\N	69899	69899	238064
3209	2611	125	applied	\N	\N	\N	\N	69900	69900	238065
3211	2617	0	applied	\N	\N	\N	\N	69903	69903	238068
3212	2618	0	applied	\N	\N	\N	\N	69904	69904	238069
3213	2619	0	applied	\N	\N	\N	\N	69905	69905	238070
3213	2620	1	applied	\N	\N	\N	\N	69906	69906	238071
3217	2622	0	applied	\N	\N	\N	\N	69911	69911	238076
3217	2623	1	applied	\N	\N	\N	\N	69912	69912	238077
3219	2624	0	applied	\N	\N	\N	\N	69914	69914	238079
3221	2625	0	applied	\N	\N	\N	\N	69916	69916	238081
3226	2626	0	applied	\N	\N	\N	\N	69921	69921	238086
3226	2627	1	applied	\N	\N	\N	\N	69922	69922	238087
3226	2628	2	applied	\N	\N	\N	\N	69923	69923	238088
3226	2629	3	applied	\N	\N	\N	\N	69924	69924	238089
3226	2630	4	applied	\N	\N	\N	\N	69925	69925	238090
3226	2631	5	applied	\N	\N	\N	\N	69926	69926	238091
3226	2632	6	applied	\N	\N	\N	\N	69927	69927	238092
3266	2710	0	applied	\N	\N	\N	\N	70146	70146	238311
3268	2711	0	applied	\N	\N	\N	\N	70148	70148	238313
3270	2626	0	applied	\N	\N	\N	\N	70150	70150	238315
3270	2629	1	applied	\N	\N	\N	\N	70151	70151	238316
3270	2630	2	applied	\N	\N	\N	\N	70152	70152	238317
3270	2631	3	applied	\N	\N	\N	\N	70153	70153	238318
3270	2632	4	applied	\N	\N	\N	\N	70154	70154	238319
3270	2633	5	applied	\N	\N	\N	\N	70155	70155	238320
3270	2634	6	applied	\N	\N	\N	\N	70156	70156	238321
3270	2636	8	applied	\N	\N	\N	\N	70158	70158	238323
3270	2637	9	applied	\N	\N	\N	\N	70159	70159	238324
3270	2638	10	applied	\N	\N	\N	\N	70160	70160	238325
3270	2640	11	applied	\N	\N	\N	\N	70161	70161	238326
3270	2641	12	applied	\N	\N	\N	\N	70162	70162	238327
3270	2642	13	applied	\N	\N	\N	\N	70163	70163	238328
3270	2643	14	applied	\N	\N	\N	\N	70164	70164	238329
3270	2644	15	applied	\N	\N	\N	\N	70165	70165	238330
3270	2645	16	applied	\N	\N	\N	\N	70166	70166	238331
3270	2646	17	applied	\N	\N	\N	\N	70167	70167	238332
3270	2651	18	applied	\N	\N	\N	\N	70168	70168	238333
3270	2652	19	applied	\N	\N	\N	\N	70169	70169	238334
3270	2653	20	applied	\N	\N	\N	\N	70170	70170	238335
3270	2654	21	applied	\N	\N	\N	\N	70171	70171	238336
3270	2655	22	applied	\N	\N	\N	\N	70172	70172	238337
3270	2656	23	applied	\N	\N	\N	\N	70173	70173	238338
3270	2660	25	applied	\N	\N	\N	\N	70175	70175	238340
3270	2661	26	applied	\N	\N	\N	\N	70176	70176	238341
3270	2662	27	applied	\N	\N	\N	\N	70177	70177	238342
3270	2664	28	applied	\N	\N	\N	\N	70178	70178	238343
3270	2665	29	applied	\N	\N	\N	\N	70179	70179	238344
3270	2666	30	applied	\N	\N	\N	\N	70180	70180	238345
3270	2668	31	applied	\N	\N	\N	\N	70181	70181	238346
3270	2669	32	applied	\N	\N	\N	\N	70182	70182	238347
3270	2670	33	applied	\N	\N	\N	\N	70183	70183	238348
3270	2671	34	applied	\N	\N	\N	\N	70184	70184	238349
3270	2672	35	applied	\N	\N	\N	\N	70185	70185	238350
3270	2673	36	applied	\N	\N	\N	\N	70186	70186	238351
3270	2674	37	applied	\N	\N	\N	\N	70187	70187	238352
3270	2675	38	applied	\N	\N	\N	\N	70188	70188	238353
3270	2676	39	applied	\N	\N	\N	\N	70189	70189	238354
3270	2677	40	applied	\N	\N	\N	\N	70190	70190	238355
3270	2679	42	applied	\N	\N	\N	\N	70192	70192	238357
3270	2680	43	applied	\N	\N	\N	\N	70193	70193	238358
3270	2684	44	applied	\N	\N	\N	\N	70194	70194	238359
3270	2685	45	applied	\N	\N	\N	\N	70195	70195	238360
3270	2687	46	applied	\N	\N	\N	\N	70196	70196	238361
3270	2688	47	applied	\N	\N	\N	\N	70197	70197	238362
3270	2704	48	applied	\N	\N	\N	\N	70198	70198	238363
3270	2705	49	applied	\N	\N	\N	\N	70199	70199	238364
3271	2712	0	applied	\N	\N	\N	\N	70200	70200	238365
3271	2713	1	applied	\N	\N	\N	\N	70201	70201	238366
3273	2714	0	applied	\N	\N	\N	\N	70204	70204	238369
3273	2715	1	applied	\N	\N	\N	\N	70205	70205	238370
3275	2716	0	applied	\N	\N	\N	\N	70208	70208	238373
3278	2717	0	applied	\N	\N	\N	\N	70217	70217	238382
3278	2718	1	applied	\N	\N	\N	\N	70218	70218	238383
3278	2719	2	applied	\N	\N	\N	\N	70219	70219	238384
3279	2721	0	applied	\N	\N	\N	\N	70221	70221	238386
3279	2722	1	applied	\N	\N	\N	\N	70222	70222	238387
3280	2723	0	applied	\N	\N	\N	\N	70223	70223	238388
3280	2724	1	applied	\N	\N	\N	\N	70224	70224	238389
3283	2727	0	applied	\N	\N	\N	\N	70230	70230	238395
3283	2728	1	applied	\N	\N	\N	\N	70231	70231	238396
3283	2729	2	applied	\N	\N	\N	\N	70232	70232	238397
3285	2730	0	applied	\N	\N	\N	\N	70235	70235	238400
3285	2731	1	applied	\N	\N	\N	\N	70236	70236	238401
3286	2738	6	applied	\N	\N	\N	\N	70243	70243	238408
3209	2588	102	applied	\N	\N	\N	\N	69877	69877	238042
3226	2637	11	applied	\N	\N	\N	\N	69932	69932	238097
3226	2638	12	applied	\N	\N	\N	\N	69933	69933	238098
3227	2626	0	applied	\N	\N	\N	\N	69934	69934	238099
3227	2627	1	applied	\N	\N	\N	\N	69935	69935	238100
3227	2628	2	applied	\N	\N	\N	\N	69936	69936	238101
3227	2629	3	applied	\N	\N	\N	\N	69937	69937	238102
3227	2630	4	applied	\N	\N	\N	\N	69938	69938	238103
3227	2631	5	applied	\N	\N	\N	\N	69939	69939	238104
3227	2632	6	applied	\N	\N	\N	\N	69940	69940	238105
3227	2633	7	applied	\N	\N	\N	\N	69941	69941	238106
3227	2634	8	applied	\N	\N	\N	\N	69942	69942	238107
3227	2635	9	applied	\N	\N	\N	\N	69943	69943	238108
3227	2636	10	applied	\N	\N	\N	\N	69944	69944	238109
3227	2637	11	applied	\N	\N	\N	\N	69945	69945	238110
3227	2638	12	applied	\N	\N	\N	\N	69946	69946	238111
3228	2626	0	applied	\N	\N	\N	\N	69947	69947	238112
3228	2628	2	applied	\N	\N	\N	\N	69949	69949	238114
3228	2629	3	applied	\N	\N	\N	\N	69950	69950	238115
3228	2630	4	applied	\N	\N	\N	\N	69951	69951	238116
3228	2631	5	applied	\N	\N	\N	\N	69952	69952	238117
3228	2632	6	applied	\N	\N	\N	\N	69953	69953	238118
3228	2633	7	applied	\N	\N	\N	\N	69954	69954	238119
3228	2634	8	applied	\N	\N	\N	\N	69955	69955	238120
3228	2635	9	applied	\N	\N	\N	\N	69956	69956	238121
3228	2636	10	applied	\N	\N	\N	\N	69957	69957	238122
3228	2637	11	applied	\N	\N	\N	\N	69958	69958	238123
3228	2638	12	applied	\N	\N	\N	\N	69959	69959	238124
3231	2645	0	applied	\N	\N	\N	\N	69970	69970	238135
3231	2646	1	applied	\N	\N	\N	\N	69971	69971	238136
3231	2647	2	applied	\N	\N	\N	\N	69972	69972	238137
3231	2648	3	applied	\N	\N	\N	\N	69973	69973	238138
3232	2649	0	applied	\N	\N	\N	\N	69974	69974	238139
3232	2651	2	applied	\N	\N	\N	\N	69976	69976	238141
3232	2652	3	applied	\N	\N	\N	\N	69977	69977	238142
3232	2653	4	applied	\N	\N	\N	\N	69978	69978	238143
3232	2654	5	applied	\N	\N	\N	\N	69979	69979	238144
3235	2663	0	applied	\N	\N	\N	\N	69998	69998	238163
3235	2664	1	applied	\N	\N	\N	\N	69999	69999	238164
3235	2665	2	applied	\N	\N	\N	\N	70000	70000	238165
3235	2666	3	applied	\N	\N	\N	\N	70001	70001	238166
3238	2667	0	applied	\N	\N	\N	\N	70004	70004	238169
3239	2668	0	applied	\N	\N	\N	\N	70005	70005	238170
3239	2669	1	applied	\N	\N	\N	\N	70006	70006	238171
3239	2670	2	applied	\N	\N	\N	\N	70007	70007	238172
3239	2671	3	applied	\N	\N	\N	\N	70008	70008	238173
3239	2672	4	applied	\N	\N	\N	\N	70009	70009	238174
3239	2673	5	applied	\N	\N	\N	\N	70010	70010	238175
3239	2674	6	applied	\N	\N	\N	\N	70011	70011	238176
3239	2676	8	applied	\N	\N	\N	\N	70013	70013	238178
3239	2677	9	applied	\N	\N	\N	\N	70014	70014	238179
3239	2678	10	applied	\N	\N	\N	\N	70015	70015	238180
3239	2679	11	applied	\N	\N	\N	\N	70016	70016	238181
3239	2680	12	applied	\N	\N	\N	\N	70017	70017	238182
3239	2681	13	applied	\N	\N	\N	\N	70018	70018	238183
3239	2682	14	applied	\N	\N	\N	\N	70019	70019	238184
3239	2683	15	applied	\N	\N	\N	\N	70020	70020	238185
3239	2684	16	applied	\N	\N	\N	\N	70021	70021	238186
3239	2685	17	applied	\N	\N	\N	\N	70022	70022	238187
3241	2686	0	applied	\N	\N	\N	\N	70041	70041	238206
3241	2687	1	applied	\N	\N	\N	\N	70042	70042	238207
3241	2688	2	applied	\N	\N	\N	\N	70043	70043	238208
3244	2689	0	applied	\N	\N	\N	\N	70048	70048	238213
3247	2687	64	applied	\N	\N	\N	\N	70117	70117	238282
3247	2688	65	applied	\N	\N	\N	\N	70118	70118	238283
3251	2694	0	applied	\N	\N	\N	\N	70122	70122	238287
3251	2695	1	applied	\N	\N	\N	\N	70123	70123	238288
3252	2696	0	applied	\N	\N	\N	\N	70124	70124	238289
3252	2697	1	applied	\N	\N	\N	\N	70125	70125	238290
3254	2699	0	applied	\N	\N	\N	\N	70127	70127	238292
3254	2700	1	applied	\N	\N	\N	\N	70128	70128	238293
3256	2699	0	applied	\N	\N	\N	\N	70131	70131	238296
3256	2700	1	applied	\N	\N	\N	\N	70132	70132	238297
3257	2701	0	applied	\N	\N	\N	\N	70133	70133	238298
3259	2702	0	applied	\N	\N	\N	\N	70135	70135	238300
3260	2703	0	applied	\N	\N	\N	\N	70136	70136	238301
3262	2704	0	applied	\N	\N	\N	\N	70138	70138	238303
3262	2705	1	applied	\N	\N	\N	\N	70139	70139	238304
3262	2706	2	applied	\N	\N	\N	\N	70140	70140	238305
3262	2707	3	applied	\N	\N	\N	\N	70141	70141	238306
3262	2708	4	applied	\N	\N	\N	\N	70142	70142	238307
3269	2711	0	applied	\N	\N	\N	\N	70149	70149	238314
3276	2717	0	applied	\N	\N	\N	\N	70209	70209	238374
3276	2718	1	applied	\N	\N	\N	\N	70210	70210	238375
3276	2719	2	applied	\N	\N	\N	\N	70211	70211	238376
3276	2720	3	applied	\N	\N	\N	\N	70212	70212	238377
3284	2730	0	applied	\N	\N	\N	\N	70233	70233	238398
3284	2731	1	applied	\N	\N	\N	\N	70234	70234	238399
3293	2740	0	applied	\N	\N	\N	\N	70274	70274	238439
3298	2747	1	applied	\N	\N	\N	\N	70283	70283	238448
3301	2751	1	applied	\N	\N	\N	\N	70289	70289	238454
3301	2752	2	applied	\N	\N	\N	\N	70290	70290	238455
3301	2753	3	applied	\N	\N	\N	\N	70291	70291	238456
3310	2762	0	applied	\N	\N	\N	\N	70307	70307	238472
3317	2765	0	applied	\N	\N	\N	\N	70319	70319	238484
3317	2766	1	applied	\N	\N	\N	\N	70320	70320	238485
3319	2767	0	applied	\N	\N	\N	\N	70323	70323	238488
3319	2768	1	applied	\N	\N	\N	\N	70324	70324	238489
3322	2778	0	applied	\N	\N	\N	\N	70336	70336	238501
3322	2779	1	applied	\N	\N	\N	\N	70337	70337	238502
3322	2780	2	applied	\N	\N	\N	\N	70338	70338	238503
3322	2781	3	applied	\N	\N	\N	\N	70339	70339	238504
3322	2782	4	applied	\N	\N	\N	\N	70340	70340	238505
3322	2783	5	applied	\N	\N	\N	\N	70341	70341	238506
3226	2634	8	applied	\N	\N	\N	\N	69929	69929	238094
3226	2635	9	applied	\N	\N	\N	\N	69930	69930	238095
3272	2713	1	applied	\N	\N	\N	\N	70203	70203	238368
3274	2714	0	applied	\N	\N	\N	\N	70206	70206	238371
3274	2715	1	applied	\N	\N	\N	\N	70207	70207	238372
3277	2717	0	applied	\N	\N	\N	\N	70213	70213	238378
3277	2718	1	applied	\N	\N	\N	\N	70214	70214	238379
3277	2719	2	applied	\N	\N	\N	\N	70215	70215	238380
3277	2720	3	applied	\N	\N	\N	\N	70216	70216	238381
3281	2726	1	applied	\N	\N	\N	\N	70226	70226	238391
3282	2727	0	applied	\N	\N	\N	\N	70227	70227	238392
3282	2728	1	applied	\N	\N	\N	\N	70228	70228	238393
3282	2729	2	applied	\N	\N	\N	\N	70229	70229	238394
3287	2732	0	applied	\N	\N	1000000000	\N	70245	70245	238410
3322	2784	6	applied	\N	\N	\N	\N	70342	70342	238507
3322	2786	8	applied	\N	\N	\N	\N	70344	70344	238509
3322	2787	9	applied	\N	\N	\N	\N	70345	70345	238510
3322	2788	10	applied	\N	\N	\N	\N	70346	70346	238511
3322	2789	11	applied	\N	\N	\N	\N	70347	70347	238512
3322	2790	12	applied	\N	\N	\N	\N	70348	70348	238513
3322	2791	13	applied	\N	\N	\N	\N	70349	70349	238514
3322	2792	14	applied	\N	\N	\N	\N	70350	70350	238515
3322	2793	15	applied	\N	\N	\N	\N	70351	70351	238516
3322	2794	16	applied	\N	\N	\N	\N	70352	70352	238517
3322	2795	17	applied	\N	\N	\N	\N	70353	70353	238518
3322	2796	18	applied	\N	\N	\N	\N	70354	70354	238519
3325	2797	0	applied	\N	\N	\N	\N	70379	70379	238544
3325	2798	1	applied	\N	\N	\N	\N	70380	70380	238545
3325	2799	2	applied	\N	\N	\N	\N	70381	70381	238546
3325	2800	3	applied	\N	\N	\N	\N	70382	70382	238547
3325	2801	4	applied	\N	\N	\N	\N	70383	70383	238548
3328	2806	1	applied	\N	\N	\N	\N	70388	70388	238553
3328	2807	2	applied	\N	\N	\N	\N	70389	70389	238554
3328	2808	3	applied	\N	\N	\N	\N	70390	70390	238555
3328	2809	4	applied	\N	\N	\N	\N	70391	70391	238556
3328	2810	5	applied	\N	\N	\N	\N	70392	70392	238557
3328	2811	6	applied	\N	\N	\N	\N	70393	70393	238558
3331	2756	0	applied	\N	\N	\N	\N	70408	70408	238573
3331	2757	1	applied	\N	\N	\N	\N	70409	70409	238574
3331	2763	2	applied	\N	\N	\N	\N	70410	70410	238575
3331	2758	3	applied	\N	\N	1000000000	\N	70411	70411	238576
3331	2755	4	applied	\N	\N	\N	\N	70412	70412	238577
3332	2814	0	applied	\N	\N	\N	\N	70413	70413	238578
3332	2815	1	applied	\N	\N	\N	\N	70414	70414	238579
3332	2816	2	applied	\N	\N	\N	\N	70415	70415	238580
3332	2817	3	applied	\N	\N	\N	\N	70416	70416	238581
3335	2821	0	applied	\N	\N	\N	\N	70424	70424	238589
3338	2826	1	applied	\N	\N	\N	\N	70432	70432	238597
3341	2830	0	applied	\N	\N	\N	\N	70437	70437	238602
3344	2834	0	applied	\N	\N	\N	\N	70444	70444	238609
3346	2835	0	applied	\N	\N	\N	\N	70451	70451	238616
3346	2836	1	applied	\N	\N	\N	\N	70452	70452	238617
3346	2837	2	applied	\N	\N	\N	\N	70453	70453	238618
3346	2838	3	applied	\N	\N	\N	\N	70454	70454	238619
3346	2839	5	applied	\N	\N	\N	\N	70455	70455	238620
3346	2840	6	applied	\N	\N	\N	\N	70456	70456	238621
3347	2841	0	applied	\N	\N	\N	\N	70457	70457	238622
3347	2842	1	applied	\N	\N	\N	\N	70458	70458	238623
3347	2843	2	applied	\N	\N	\N	\N	70459	70459	238624
3347	2844	3	applied	\N	\N	\N	\N	70460	70460	238625
3347	2845	4	applied	\N	\N	\N	\N	70461	70461	238626
3347	2846	5	applied	\N	\N	\N	\N	70462	70462	238627
3347	2847	6	applied	\N	\N	\N	\N	70463	70463	238628
3347	2849	8	applied	\N	\N	\N	\N	70465	70465	238630
3347	2850	9	applied	\N	\N	\N	\N	70466	70466	238631
3350	2756	0	applied	\N	\N	\N	\N	70477	70477	238642
3350	2757	1	applied	\N	\N	\N	\N	70478	70478	238643
3350	2763	2	applied	\N	\N	\N	\N	70479	70479	238644
3350	2626	3	applied	\N	\N	\N	\N	70480	70480	238645
3350	2758	4	applied	\N	\N	1000000000	\N	70481	70481	238646
3350	2755	5	applied	\N	\N	\N	\N	70482	70482	238647
3350	2629	6	applied	\N	\N	\N	\N	70483	70483	238648
3350	2630	7	applied	\N	\N	\N	\N	70484	70484	238649
3350	2631	8	applied	\N	\N	\N	\N	70485	70485	238650
3350	2632	9	applied	\N	\N	\N	\N	70486	70486	238651
3350	2633	10	applied	\N	\N	\N	\N	70487	70487	238652
3350	2634	11	applied	\N	\N	\N	\N	70488	70488	238653
3350	2635	12	applied	\N	\N	\N	\N	70489	70489	238654
3350	2636	13	applied	\N	\N	\N	\N	70490	70490	238655
3350	2638	15	applied	\N	\N	\N	\N	70492	70492	238657
3350	2640	16	applied	\N	\N	\N	\N	70493	70493	238658
3350	2641	17	applied	\N	\N	\N	\N	70494	70494	238659
3350	2642	18	applied	\N	\N	\N	\N	70495	70495	238660
3350	2643	19	applied	\N	\N	\N	\N	70496	70496	238661
3350	2644	20	applied	\N	\N	\N	\N	70497	70497	238662
3267	2711	0	applied	\N	\N	\N	\N	70147	70147	238312
3272	2712	0	applied	\N	\N	\N	\N	70202	70202	238367
3299	2748	0	applied	\N	\N	\N	\N	70284	70284	238449
3299	2749	1	applied	\N	\N	\N	\N	70285	70285	238450
3300	2748	0	applied	\N	\N	\N	\N	70286	70286	238451
3300	2749	1	applied	\N	\N	\N	\N	70287	70287	238452
3302	2750	0	applied	\N	\N	\N	\N	70292	70292	238457
3302	2751	1	applied	\N	\N	\N	\N	70293	70293	238458
3302	2752	2	applied	\N	\N	\N	\N	70294	70294	238459
3302	2753	3	applied	\N	\N	\N	\N	70295	70295	238460
3303	2754	0	applied	\N	\N	\N	\N	70296	70296	238461
3303	2755	1	applied	\N	\N	\N	\N	70297	70297	238462
3305	2756	0	applied	\N	\N	\N	\N	70298	70298	238463
3305	2757	1	applied	\N	\N	\N	\N	70299	70299	238464
3305	2759	3	applied	\N	\N	\N	\N	70301	70301	238466
3305	2760	4	applied	\N	\N	\N	\N	70302	70302	238467
3306	2761	0	applied	\N	\N	\N	\N	70303	70303	238468
3307	2761	0	applied	\N	\N	\N	\N	70304	70304	238469
3308	2761	0	applied	\N	\N	\N	\N	70305	70305	238470
3309	2761	0	applied	\N	\N	\N	\N	70306	70306	238471
3311	2762	0	applied	\N	\N	\N	\N	70308	70308	238473
3312	2763	0	applied	\N	\N	\N	\N	70309	70309	238474
3312	2764	1	applied	\N	\N	\N	\N	70310	70310	238475
3313	2763	0	applied	\N	\N	\N	\N	70311	70311	238476
3313	2764	1	applied	\N	\N	\N	\N	70312	70312	238477
3314	2763	0	applied	\N	\N	\N	\N	70313	70313	238478
3314	2764	1	applied	\N	\N	\N	\N	70314	70314	238479
3315	2765	0	applied	\N	\N	\N	\N	70315	70315	238480
3315	2766	1	applied	\N	\N	\N	\N	70316	70316	238481
3316	2765	0	applied	\N	\N	\N	\N	70317	70317	238482
3316	2766	1	applied	\N	\N	\N	\N	70318	70318	238483
3318	2765	0	applied	\N	\N	\N	\N	70321	70321	238486
3318	2766	1	applied	\N	\N	\N	\N	70322	70322	238487
3320	2768	1	applied	\N	\N	\N	\N	70326	70326	238491
3321	2769	0	applied	\N	\N	\N	\N	70327	70327	238492
3321	2770	1	applied	\N	\N	\N	\N	70328	70328	238493
3321	2771	2	applied	\N	\N	\N	\N	70329	70329	238494
3321	2772	3	applied	\N	\N	\N	\N	70330	70330	238495
3321	2773	4	applied	\N	\N	\N	\N	70331	70331	238496
3321	2774	5	applied	\N	\N	\N	\N	70332	70332	238497
3321	2775	6	applied	\N	\N	\N	\N	70333	70333	238498
3321	2776	7	applied	\N	\N	\N	\N	70334	70334	238499
3321	2777	8	applied	\N	\N	\N	\N	70335	70335	238500
3323	2778	0	applied	\N	\N	\N	\N	70355	70355	238520
3323	2779	1	applied	\N	\N	\N	\N	70356	70356	238521
3323	2780	2	applied	\N	\N	\N	\N	70357	70357	238522
3323	2781	3	applied	\N	\N	\N	\N	70358	70358	238523
3323	2782	4	applied	\N	\N	\N	\N	70359	70359	238524
3323	2783	5	applied	\N	\N	\N	\N	70360	70360	238525
3323	2785	7	applied	\N	\N	\N	\N	70362	70362	238527
3323	2786	8	applied	\N	\N	\N	\N	70363	70363	238528
3323	2787	9	applied	\N	\N	\N	\N	70364	70364	238529
3323	2788	10	applied	\N	\N	\N	\N	70365	70365	238530
3323	2789	11	applied	\N	\N	\N	\N	70366	70366	238531
3323	2790	12	applied	\N	\N	\N	\N	70367	70367	238532
3323	2791	13	applied	\N	\N	\N	\N	70368	70368	238533
3323	2792	14	applied	\N	\N	\N	\N	70369	70369	238534
3323	2793	15	applied	\N	\N	\N	\N	70370	70370	238535
3323	2794	16	applied	\N	\N	\N	\N	70371	70371	238536
3323	2795	17	applied	\N	\N	\N	\N	70372	70372	238537
3323	2796	18	applied	\N	\N	\N	\N	70373	70373	238538
3324	2797	0	applied	\N	\N	\N	\N	70374	70374	238539
3324	2798	1	applied	\N	\N	\N	\N	70375	70375	238540
3324	2799	2	applied	\N	\N	\N	\N	70376	70376	238541
3324	2800	3	applied	\N	\N	\N	\N	70377	70377	238542
3326	2802	0	applied	\N	\N	\N	\N	70384	70384	238549
3327	2803	0	applied	\N	\N	\N	\N	70385	70385	238550
3327	2804	1	applied	\N	\N	\N	\N	70386	70386	238551
3329	2797	0	applied	\N	\N	\N	\N	70394	70394	238559
3329	2802	1	applied	\N	\N	\N	\N	70395	70395	238560
3329	2798	2	applied	\N	\N	\N	\N	70396	70396	238561
3329	2799	3	applied	\N	\N	\N	\N	70397	70397	238562
3329	2804	4	applied	\N	\N	\N	\N	70398	70398	238563
3329	2805	5	applied	\N	\N	\N	\N	70399	70399	238564
3329	2812	6	applied	\N	\N	\N	\N	70400	70400	238565
3329	2806	7	applied	\N	\N	\N	\N	70401	70401	238566
3329	2807	8	applied	\N	\N	\N	\N	70402	70402	238567
3329	2800	9	applied	\N	\N	\N	\N	70403	70403	238568
3329	2801	10	applied	\N	\N	\N	\N	70404	70404	238569
3329	2803	11	applied	\N	\N	\N	\N	70405	70405	238570
3330	2812	0	applied	\N	\N	\N	\N	70406	70406	238571
3333	2814	0	applied	\N	\N	\N	\N	70417	70417	238582
3333	2815	1	applied	\N	\N	\N	\N	70418	70418	238583
3333	2816	2	applied	\N	\N	\N	\N	70419	70419	238584
3333	2817	3	applied	\N	\N	\N	\N	70420	70420	238585
3334	2818	0	applied	\N	\N	\N	\N	70421	70421	238586
3334	2819	1	applied	\N	\N	\N	\N	70422	70422	238587
3334	2820	2	applied	\N	\N	\N	\N	70423	70423	238588
3336	2822	0	applied	\N	\N	\N	\N	70425	70425	238590
3336	2823	1	applied	\N	\N	\N	\N	70426	70426	238591
3336	2824	2	applied	\N	\N	\N	\N	70427	70427	238592
3337	2822	0	applied	\N	\N	\N	\N	70428	70428	238593
3337	2823	1	applied	\N	\N	\N	\N	70429	70429	238594
3337	2824	2	applied	\N	\N	\N	\N	70430	70430	238595
3339	2827	0	applied	\N	\N	\N	\N	70433	70433	238598
3339	2828	1	applied	\N	\N	\N	\N	70434	70434	238599
3339	2829	2	applied	\N	\N	\N	\N	70435	70435	238600
3342	2831	0	applied	\N	\N	\N	\N	70438	70438	238603
3342	2832	1	applied	\N	\N	\N	\N	70439	70439	238604
3342	2833	2	applied	\N	\N	\N	\N	70440	70440	238605
3343	2831	0	applied	\N	\N	\N	\N	70441	70441	238606
3343	2832	1	applied	\N	\N	\N	\N	70442	70442	238607
3343	2833	2	applied	\N	\N	\N	\N	70443	70443	238608
3345	2835	0	applied	\N	\N	\N	\N	70445	70445	238610
3345	2836	1	applied	\N	\N	\N	\N	70446	70446	238611
3345	2837	2	applied	\N	\N	\N	\N	70447	70447	238612
3345	2838	3	applied	\N	\N	\N	\N	70448	70448	238613
3349	2851	0	applied	\N	\N	\N	\N	70472	70472	238637
3349	2852	1	applied	\N	\N	\N	\N	70473	70473	238638
3349	2853	2	applied	\N	\N	\N	\N	70474	70474	238639
3349	2854	3	applied	\N	\N	\N	\N	70475	70475	238640
3291	2744	12	applied	\N	\N	\N	\N	70273	70273	238438
3296	2745	0	applied	\N	\N	\N	\N	70279	70279	238444
3348	2852	1	applied	\N	\N	\N	\N	70468	70468	238633
3348	2853	2	applied	\N	\N	\N	\N	70469	70469	238634
3348	2854	3	applied	\N	\N	\N	\N	70470	70470	238635
3348	2855	4	applied	\N	\N	1000000000	\N	70471	70471	238636
3350	2645	21	applied	\N	\N	\N	\N	70498	70498	238663
3350	2646	22	applied	\N	\N	\N	\N	70499	70499	238664
3350	2651	23	applied	\N	\N	\N	\N	70500	70500	238665
3350	2652	24	applied	\N	\N	\N	\N	70501	70501	238666
3350	2653	25	applied	\N	\N	\N	\N	70502	70502	238667
3350	2654	26	applied	\N	\N	\N	\N	70503	70503	238668
3350	2655	27	applied	\N	\N	\N	\N	70504	70504	238669
3350	2656	28	applied	\N	\N	\N	\N	70505	70505	238670
3350	2657	29	applied	\N	\N	\N	\N	70506	70506	238671
3350	2661	31	applied	\N	\N	\N	\N	70508	70508	238673
3350	2662	32	applied	\N	\N	\N	\N	70509	70509	238674
3350	2664	33	applied	\N	\N	\N	\N	70510	70510	238675
3350	2665	34	applied	\N	\N	\N	\N	70511	70511	238676
3350	2666	35	applied	\N	\N	\N	\N	70512	70512	238677
3350	2668	36	applied	\N	\N	\N	\N	70513	70513	238678
3350	2669	37	applied	\N	\N	\N	\N	70514	70514	238679
3350	2670	38	applied	\N	\N	\N	\N	70515	70515	238680
3350	2671	39	applied	\N	\N	\N	\N	70516	70516	238681
3350	2672	40	applied	\N	\N	\N	\N	70517	70517	238682
3350	2673	41	applied	\N	\N	\N	\N	70518	70518	238683
3350	2674	42	applied	\N	\N	\N	\N	70519	70519	238684
3350	2675	43	applied	\N	\N	\N	\N	70520	70520	238685
3350	2676	44	applied	\N	\N	\N	\N	70521	70521	238686
3350	2677	45	applied	\N	\N	\N	\N	70522	70522	238687
3350	2678	46	applied	\N	\N	\N	\N	70523	70523	238688
3350	2680	48	applied	\N	\N	\N	\N	70525	70525	238690
3350	2684	49	applied	\N	\N	\N	\N	70526	70526	238691
3350	2685	50	applied	\N	\N	\N	\N	70527	70527	238692
3350	2687	51	applied	\N	\N	\N	\N	70528	70528	238693
3350	2688	52	applied	\N	\N	\N	\N	70529	70529	238694
3350	2704	53	applied	\N	\N	\N	\N	70530	70530	238695
3350	2705	54	applied	\N	\N	\N	\N	70531	70531	238696
3350	2717	55	applied	\N	\N	\N	\N	70532	70532	238697
3350	2719	56	applied	\N	\N	\N	\N	70533	70533	238698
3350	2720	57	applied	\N	\N	\N	\N	70534	70534	238699
3350	2731	58	applied	\N	\N	\N	\N	70535	70535	238700
3350	2733	59	applied	\N	\N	\N	\N	70536	70536	238701
3350	2734	60	applied	\N	\N	\N	\N	70537	70537	238702
3350	2735	61	applied	\N	\N	\N	\N	70538	70538	238703
3350	2736	62	applied	\N	\N	\N	\N	70539	70539	238704
3350	2737	63	applied	\N	\N	\N	\N	70540	70540	238705
3350	2740	65	applied	\N	\N	\N	\N	70542	70542	238707
3350	2741	66	applied	\N	\N	\N	\N	70543	70543	238708
3350	2742	67	applied	\N	\N	\N	\N	70544	70544	238709
3350	2743	68	applied	\N	\N	\N	\N	70545	70545	238710
3350	2750	69	applied	\N	\N	\N	\N	70546	70546	238711
3350	2751	70	applied	\N	\N	\N	\N	70547	70547	238712
3350	2752	71	applied	\N	\N	\N	\N	70548	70548	238713
3350	2768	72	applied	\N	\N	\N	\N	70549	70549	238714
3350	2770	73	applied	\N	\N	\N	\N	70550	70550	238715
3350	2771	74	applied	\N	\N	\N	\N	70551	70551	238716
3350	2772	75	applied	\N	\N	\N	\N	70552	70552	238717
3350	2773	76	applied	\N	\N	\N	\N	70553	70553	238718
3350	2774	77	applied	\N	\N	\N	\N	70554	70554	238719
3350	2775	78	applied	\N	\N	\N	\N	70555	70555	238720
3351	2856	0	applied	\N	\N	\N	\N	70556	70556	238721
3352	2857	0	applied	\N	\N	\N	\N	70557	70557	238722
3352	2858	2	applied	\N	\N	\N	\N	70559	70559	238724
3353	2859	0	applied	\N	\N	\N	\N	70560	70560	238725
3353	2860	1	applied	\N	\N	\N	\N	70561	70561	238726
3353	2861	2	applied	\N	\N	\N	\N	70562	70562	238727
3354	2862	0	applied	\N	\N	\N	\N	70563	70563	238728
3354	2863	1	applied	\N	\N	\N	\N	70564	70564	238729
3355	2862	0	applied	\N	\N	\N	\N	70565	70565	238730
3355	2863	1	applied	\N	\N	\N	\N	70566	70566	238731
3356	2756	0	applied	\N	\N	\N	\N	70567	70567	238732
3356	2757	1	applied	\N	\N	\N	\N	70568	70568	238733
3356	2763	2	applied	\N	\N	\N	\N	70569	70569	238734
3356	2626	3	applied	\N	\N	\N	\N	70570	70570	238735
3356	2758	4	applied	\N	\N	1000000000	\N	70571	70571	238736
3356	2755	5	applied	\N	\N	\N	\N	70572	70572	238737
3356	2629	6	applied	\N	\N	\N	\N	70573	70573	238738
3356	2630	7	applied	\N	\N	\N	\N	70574	70574	238739
3356	2632	9	applied	\N	\N	\N	\N	70576	70576	238741
3356	2633	10	applied	\N	\N	\N	\N	70577	70577	238742
3356	2634	11	applied	\N	\N	\N	\N	70578	70578	238743
3356	2635	12	applied	\N	\N	\N	\N	70579	70579	238744
3356	2636	13	applied	\N	\N	\N	\N	70580	70580	238745
3356	2637	14	applied	\N	\N	\N	\N	70581	70581	238746
3356	2638	15	applied	\N	\N	\N	\N	70582	70582	238747
3356	2640	16	applied	\N	\N	\N	\N	70583	70583	238748
3356	2641	17	applied	\N	\N	\N	\N	70584	70584	238749
3356	2642	18	applied	\N	\N	\N	\N	70585	70585	238750
3356	2643	19	applied	\N	\N	\N	\N	70586	70586	238751
3356	2644	20	applied	\N	\N	\N	\N	70587	70587	238752
3356	2645	21	applied	\N	\N	\N	\N	70588	70588	238753
3356	2646	22	applied	\N	\N	\N	\N	70589	70589	238754
3356	2651	23	applied	\N	\N	\N	\N	70590	70590	238755
3356	2652	24	applied	\N	\N	\N	\N	70591	70591	238756
3356	2654	26	applied	\N	\N	\N	\N	70593	70593	238758
3356	2655	27	applied	\N	\N	\N	\N	70594	70594	238759
3356	2656	28	applied	\N	\N	\N	\N	70595	70595	238760
3356	2657	29	applied	\N	\N	\N	\N	70596	70596	238761
3356	2660	30	applied	\N	\N	\N	\N	70597	70597	238762
3356	2661	31	applied	\N	\N	\N	\N	70598	70598	238763
3356	2662	32	applied	\N	\N	\N	\N	70599	70599	238764
3356	2664	33	applied	\N	\N	\N	\N	70600	70600	238765
3356	2665	34	applied	\N	\N	\N	\N	70601	70601	238766
3356	2666	35	applied	\N	\N	\N	\N	70602	70602	238767
3356	2668	36	applied	\N	\N	\N	\N	70603	70603	238768
3356	2669	37	applied	\N	\N	\N	\N	70604	70604	238769
3356	2670	38	applied	\N	\N	\N	\N	70605	70605	238770
3356	2671	39	applied	\N	\N	\N	\N	70606	70606	238771
3356	2672	40	applied	\N	\N	\N	\N	70607	70607	238772
3356	2673	41	applied	\N	\N	\N	\N	70608	70608	238773
3345	2840	6	applied	\N	\N	\N	\N	70450	70450	238615
3348	2851	0	applied	\N	\N	\N	\N	70467	70467	238632
3356	2679	47	applied	\N	\N	\N	\N	70614	70614	238779
3357	2864	0	applied	\N	\N	\N	\N	70615	70615	238780
3358	2864	0	applied	\N	\N	\N	\N	70616	70616	238781
3359	2865	0	applied	\N	\N	\N	\N	70617	70617	238782
3360	2866	0	applied	\N	\N	\N	\N	70618	70618	238783
3360	2867	1	applied	\N	\N	\N	\N	70619	70619	238784
3363	2871	0	applied	\N	\N	\N	\N	70623	70623	238788
3366	2874	0	applied	\N	\N	\N	\N	70627	70627	238792
3372	2878	0	applied	\N	\N	\N	\N	70694	70694	238859
3375	2884	0	applied	\N	\N	\N	\N	70702	70702	238867
3375	2885	1	applied	\N	\N	\N	\N	70703	70703	238868
3383	2889	0	applied	\N	\N	\N	\N	70835	70835	239000
3384	2889	0	applied	\N	\N	\N	\N	70836	70836	239001
3387	2891	0	applied	\N	\N	\N	\N	70838	70838	239003
3393	2895	0	applied	\N	\N	\N	\N	70873	70873	239038
3396	2896	0	applied	\N	\N	\N	\N	71000	71000	239165
3402	2859	0	applied	\N	\N	\N	\N	71009	71009	239174
3402	2857	1	applied	\N	\N	\N	\N	71010	71010	239175
3402	2856	2	applied	\N	\N	\N	\N	71011	71011	239176
3402	2858	3	applied	\N	\N	\N	\N	71012	71012	239177
3402	2860	4	applied	\N	\N	\N	\N	71013	71013	239178
3402	2861	5	applied	\N	\N	\N	\N	71014	71014	239179
3402	2862	6	applied	\N	\N	\N	\N	71015	71015	239180
3402	2863	7	applied	\N	\N	\N	\N	71016	71016	239181
3402	2864	8	applied	\N	\N	\N	\N	71017	71017	239182
3402	2865	9	applied	\N	\N	\N	\N	71018	71018	239183
3402	2866	10	applied	\N	\N	\N	\N	71019	71019	239184
3402	2867	11	applied	\N	\N	\N	\N	71020	71020	239185
3402	2868	12	applied	\N	\N	\N	\N	71021	71021	239186
3402	2869	13	applied	\N	\N	\N	\N	71022	71022	239187
3402	2870	14	applied	\N	\N	\N	\N	71023	71023	239188
3402	2871	15	applied	\N	\N	\N	\N	71024	71024	239189
3402	2873	17	applied	\N	\N	\N	\N	71026	71026	239191
3402	2874	18	applied	\N	\N	\N	\N	71027	71027	239192
3402	2875	19	applied	\N	\N	\N	\N	71028	71028	239193
3402	2876	20	applied	\N	\N	\N	\N	71029	71029	239194
3402	2877	21	applied	\N	\N	\N	\N	71030	71030	239195
3402	2878	22	applied	\N	\N	\N	\N	71031	71031	239196
3402	2879	23	applied	\N	\N	\N	\N	71032	71032	239197
3402	2880	24	applied	\N	\N	\N	\N	71033	71033	239198
3402	2881	25	applied	\N	\N	\N	\N	71034	71034	239199
3402	2882	26	applied	\N	\N	\N	\N	71035	71035	239200
3402	2884	27	applied	\N	\N	\N	\N	71036	71036	239201
3402	2885	28	applied	\N	\N	\N	\N	71037	71037	239202
3402	2886	29	applied	\N	\N	\N	\N	71038	71038	239203
3402	2887	30	applied	\N	\N	\N	\N	71039	71039	239204
3402	2888	31	applied	\N	\N	\N	\N	71040	71040	239205
3402	2889	32	applied	\N	\N	\N	\N	71041	71041	239206
3402	2891	34	applied	\N	\N	\N	\N	71043	71043	239208
3402	2892	35	applied	\N	\N	\N	\N	71044	71044	239209
3402	2893	36	applied	\N	\N	\N	\N	71045	71045	239210
3402	2894	37	applied	\N	\N	\N	\N	71046	71046	239211
3402	2895	38	applied	\N	\N	\N	\N	71047	71047	239212
3402	2896	39	applied	\N	\N	\N	\N	71048	71048	239213
3402	2883	40	applied	\N	\N	\N	\N	71049	71049	239214
3408	2894	0	applied	\N	\N	\N	\N	71052	71052	239217
3408	2895	1	applied	\N	\N	\N	\N	71053	71053	239218
3408	2896	2	applied	\N	\N	\N	\N	71054	71054	239219
3408	2897	3	applied	\N	\N	\N	\N	71055	71055	239220
3408	2898	4	applied	\N	\N	\N	\N	71056	71056	239221
3408	2899	5	applied	\N	\N	\N	\N	71057	71057	239222
3408	2900	6	applied	\N	\N	\N	\N	71058	71058	239223
3408	2901	7	applied	\N	\N	\N	\N	71059	71059	239224
3411	2900	0	applied	\N	\N	\N	\N	71064	71064	239229
3414	2903	0	applied	\N	\N	\N	\N	71069	71069	239234
3417	2905	0	applied	\N	\N	\N	\N	71072	71072	239237
3420	2906	0	applied	\N	\N	\N	\N	71075	71075	239240
3420	2907	1	applied	\N	\N	\N	\N	71076	71076	239241
3424	2908	0	applied	\N	\N	\N	\N	71080	71080	239245
3427	2908	0	applied	\N	\N	\N	\N	71087	71087	239252
3427	2909	1	applied	\N	\N	\N	\N	71088	71088	239253
3427	2910	2	applied	\N	\N	\N	\N	71089	71089	239254
3430	2911	0	applied	\N	\N	\N	\N	71094	71094	239259
3431	2912	0	applied	\N	\N	\N	\N	71095	71095	239260
3446	2915	0	applied	\N	\N	\N	\N	71099	71099	239264
3496	2917	0	applied	\N	\N	\N	\N	71408	71408	239573
3499	2854	0	applied	\N	\N	\N	\N	71410	71410	239575
3499	2856	1	applied	\N	\N	\N	\N	71411	71411	239576
3499	2858	2	applied	\N	\N	\N	\N	71412	71412	239577
3499	2860	3	applied	\N	\N	\N	\N	71413	71413	239578
3499	2862	5	applied	\N	\N	\N	\N	71415	71415	239580
3499	2863	6	applied	\N	\N	\N	\N	71416	71416	239581
3499	2864	7	applied	\N	\N	\N	\N	71417	71417	239582
3499	2865	8	applied	\N	\N	\N	\N	71418	71418	239583
3499	2866	9	applied	\N	\N	\N	\N	71419	71419	239584
3499	2867	10	applied	\N	\N	\N	\N	71420	71420	239585
3499	2868	11	applied	\N	\N	\N	\N	71421	71421	239586
3499	2869	12	applied	\N	\N	\N	\N	71422	71422	239587
3499	2870	13	applied	\N	\N	\N	\N	71423	71423	239588
3499	2871	15	applied	\N	\N	\N	\N	71424	71424	239589
3499	2872	16	applied	\N	\N	\N	\N	71425	71425	239590
3499	2873	17	applied	\N	\N	\N	\N	71426	71426	239591
3499	2874	18	applied	\N	\N	\N	\N	71427	71427	239592
3499	2875	19	applied	\N	\N	\N	\N	71428	71428	239593
3499	2876	20	applied	\N	\N	\N	\N	71429	71429	239594
3499	2877	21	applied	\N	\N	\N	\N	71430	71430	239595
3499	2879	23	applied	\N	\N	\N	\N	71432	71432	239597
3499	2880	24	applied	\N	\N	\N	\N	71433	71433	239598
3499	2881	25	applied	\N	\N	\N	\N	71434	71434	239599
3499	2882	26	applied	\N	\N	\N	\N	71435	71435	239600
3499	2884	27	applied	\N	\N	\N	\N	71436	71436	239601
3499	2885	28	applied	\N	\N	\N	\N	71437	71437	239602
3499	2886	29	applied	\N	\N	\N	\N	71438	71438	239603
3499	2887	30	applied	\N	\N	\N	\N	71439	71439	239604
3499	2888	31	applied	\N	\N	\N	\N	71440	71440	239605
3499	2889	32	applied	\N	\N	\N	\N	71441	71441	239606
3499	2890	33	applied	\N	\N	\N	\N	71442	71442	239607
3499	2891	34	applied	\N	\N	\N	\N	71443	71443	239608
3499	2892	35	applied	\N	\N	\N	\N	71444	71444	239609
3499	2893	36	applied	\N	\N	\N	\N	71445	71445	239610
3356	2676	44	applied	\N	\N	\N	\N	70611	70611	238776
3356	2677	45	applied	\N	\N	\N	\N	70612	70612	238777
3367	2875	0	applied	\N	\N	\N	\N	70628	70628	238793
3369	2756	0	applied	\N	\N	\N	\N	70631	70631	238796
3369	2757	1	applied	\N	\N	\N	\N	70632	70632	238797
3369	2763	2	applied	\N	\N	\N	\N	70633	70633	238798
3369	2758	3	applied	\N	\N	1000000000	\N	70634	70634	238799
3369	2732	4	applied	\N	\N	1000000000	\N	70635	70635	238800
3369	2731	5	applied	\N	\N	\N	\N	70636	70636	238801
3369	2755	6	applied	\N	\N	\N	\N	70637	70637	238802
3369	2733	7	applied	\N	\N	\N	\N	70638	70638	238803
3369	2734	8	applied	\N	\N	\N	\N	70639	70639	238804
3369	2735	9	applied	\N	\N	\N	\N	70640	70640	238805
3369	2737	11	applied	\N	\N	\N	\N	70642	70642	238807
3369	2738	12	applied	\N	\N	\N	\N	70643	70643	238808
3369	2740	13	applied	\N	\N	\N	\N	70644	70644	238809
3369	2741	14	applied	\N	\N	\N	\N	70645	70645	238810
3369	2742	15	applied	\N	\N	\N	\N	70646	70646	238811
3369	2743	16	applied	\N	\N	\N	\N	70647	70647	238812
3369	2750	17	applied	\N	\N	\N	\N	70648	70648	238813
3369	2751	18	applied	\N	\N	\N	\N	70649	70649	238814
3369	2752	19	applied	\N	\N	\N	\N	70650	70650	238815
3369	2721	20	applied	\N	\N	\N	\N	70651	70651	238816
3369	2722	21	applied	\N	\N	\N	\N	70652	70652	238817
3369	2723	22	applied	\N	\N	\N	\N	70653	70653	238818
3369	2724	23	applied	\N	\N	\N	\N	70654	70654	238819
3369	2725	24	applied	\N	\N	\N	\N	70655	70655	238820
3369	2726	25	applied	\N	\N	\N	\N	70656	70656	238821
3369	2727	26	applied	\N	\N	\N	\N	70657	70657	238822
3369	2729	28	applied	\N	\N	\N	\N	70659	70659	238824
3369	2730	29	applied	\N	\N	\N	\N	70660	70660	238825
3369	2739	30	applied	\N	\N	\N	\N	70661	70661	238826
3369	2744	31	applied	\N	\N	\N	\N	70662	70662	238827
3369	2745	32	applied	\N	\N	\N	\N	70663	70663	238828
3369	2746	33	applied	\N	\N	\N	\N	70664	70664	238829
3369	2747	34	applied	\N	\N	\N	\N	70665	70665	238830
3369	2748	35	applied	\N	\N	\N	\N	70666	70666	238831
3369	2749	36	applied	\N	\N	\N	\N	70667	70667	238832
3369	2753	37	applied	\N	\N	\N	\N	70668	70668	238833
3369	2754	38	applied	\N	\N	\N	\N	70669	70669	238834
3369	2759	39	applied	\N	\N	\N	\N	70670	70670	238835
3369	2760	40	applied	\N	\N	\N	\N	70671	70671	238836
3369	2761	41	applied	\N	\N	\N	\N	70672	70672	238837
3369	2762	42	applied	\N	\N	\N	\N	70673	70673	238838
3369	2764	43	applied	\N	\N	\N	\N	70674	70674	238839
3369	2766	45	applied	\N	\N	\N	\N	70676	70676	238841
3369	2767	46	applied	\N	\N	\N	\N	70677	70677	238842
3369	2769	47	applied	\N	\N	\N	\N	70678	70678	238843
3369	2778	48	applied	\N	\N	\N	\N	70679	70679	238844
3369	2779	49	applied	\N	\N	\N	\N	70680	70680	238845
3369	2797	50	applied	\N	\N	\N	\N	70681	70681	238846
3369	2802	51	applied	\N	\N	\N	\N	70682	70682	238847
3369	2804	52	applied	\N	\N	\N	\N	70683	70683	238848
3369	2805	53	applied	\N	\N	\N	\N	70684	70684	238849
3369	2812	54	applied	\N	\N	\N	\N	70685	70685	238850
3369	2813	55	applied	\N	\N	\N	\N	70686	70686	238851
3369	2814	56	applied	\N	\N	\N	\N	70687	70687	238852
3369	2816	57	applied	\N	\N	\N	\N	70688	70688	238853
3369	2819	58	applied	\N	\N	\N	\N	70689	70689	238854
3369	2820	60	applied	\N	\N	\N	\N	70690	70690	238855
3370	2876	0	applied	\N	\N	\N	\N	70691	70691	238856
3373	2879	0	applied	\N	\N	\N	\N	70695	70695	238860
3373	2880	1	applied	\N	\N	\N	\N	70696	70696	238861
3373	2881	2	applied	\N	\N	\N	\N	70697	70697	238862
3373	2882	3	applied	\N	\N	\N	\N	70698	70698	238863
3373	2883	4	applied	\N	\N	\N	\N	70699	70699	238864
3376	2756	0	applied	\N	\N	\N	\N	70704	70704	238869
3376	2757	1	applied	\N	\N	\N	\N	70705	70705	238870
3376	2763	2	applied	\N	\N	\N	\N	70706	70706	238871
3376	2626	3	applied	\N	\N	\N	\N	70707	70707	238872
3376	2758	4	applied	\N	\N	1000000000	\N	70708	70708	238873
3376	2508	5	applied	\N	\N	\N	\N	70709	70709	238874
3376	2526	6	applied	\N	\N	\N	\N	70710	70710	238875
3376	2527	7	applied	\N	\N	\N	\N	70711	70711	238876
3376	2755	8	applied	\N	\N	\N	\N	70712	70712	238877
3376	2530	9	applied	\N	\N	\N	\N	70713	70713	238878
3376	2531	10	applied	\N	\N	\N	\N	70714	70714	238879
3376	2533	12	applied	\N	\N	\N	\N	70716	70716	238881
3376	2534	13	applied	\N	\N	\N	\N	70717	70717	238882
3376	2535	14	applied	\N	\N	\N	\N	70718	70718	238883
3376	2536	15	applied	\N	\N	\N	\N	70719	70719	238884
3376	2537	16	applied	\N	\N	\N	\N	70720	70720	238885
3376	2544	17	applied	\N	\N	\N	\N	70721	70721	238886
3376	2509	18	applied	\N	\N	\N	\N	70722	70722	238887
3376	2510	19	applied	\N	\N	\N	\N	70723	70723	238888
3376	2511	20	applied	\N	\N	\N	\N	70724	70724	238889
3376	2512	21	applied	\N	\N	\N	\N	70725	70725	238890
3376	2513	22	applied	\N	\N	\N	\N	70726	70726	238891
3376	2514	23	applied	\N	\N	\N	\N	70727	70727	238892
3376	2515	24	applied	\N	\N	\N	\N	70728	70728	238893
3376	2516	25	applied	\N	\N	\N	\N	70729	70729	238894
3376	2517	26	applied	\N	\N	\N	\N	70730	70730	238895
3376	2518	27	applied	\N	\N	\N	\N	70731	70731	238896
3376	2520	29	applied	\N	\N	\N	\N	70733	70733	238898
3376	2521	30	applied	\N	\N	\N	\N	70734	70734	238899
3376	2522	31	applied	\N	\N	\N	\N	70735	70735	238900
3376	2523	32	applied	\N	\N	\N	\N	70736	70736	238901
3376	2524	33	applied	\N	\N	\N	\N	70737	70737	238902
3376	2525	34	applied	\N	\N	\N	\N	70738	70738	238903
3376	2528	35	applied	\N	\N	\N	\N	70739	70739	238904
3376	2529	36	applied	\N	\N	\N	\N	70740	70740	238905
3376	2538	37	applied	\N	\N	\N	\N	70741	70741	238906
3376	2539	38	applied	\N	\N	\N	\N	70742	70742	238907
3376	2540	39	applied	\N	\N	\N	\N	70743	70743	238908
3499	2894	37	applied	\N	\N	\N	\N	71446	71446	239611
3499	2895	38	applied	\N	\N	\N	\N	71447	71447	239612
3499	2896	39	applied	\N	\N	\N	\N	71448	71448	239613
3499	2897	40	applied	\N	\N	\N	\N	71449	71449	239614
3499	2898	41	applied	\N	\N	\N	\N	71450	71450	239615
3499	2900	43	applied	\N	\N	\N	\N	71452	71452	239617
3499	2901	44	applied	\N	\N	\N	\N	71453	71453	239618
3361	2869	1	applied	\N	\N	\N	\N	70621	70621	238786
3364	2871	0	applied	\N	\N	\N	\N	70624	70624	238789
3368	2877	1	applied	\N	\N	\N	\N	70630	70630	238795
3371	2878	0	applied	\N	\N	\N	\N	70693	70693	238858
3374	2884	0	applied	\N	\N	\N	\N	70700	70700	238865
3374	2885	1	applied	\N	\N	\N	\N	70701	70701	238866
3376	2541	40	applied	\N	\N	\N	\N	70744	70744	238909
3376	2542	41	applied	\N	\N	\N	\N	70745	70745	238910
3376	2543	42	applied	\N	\N	\N	\N	70746	70746	238911
3376	2545	43	applied	\N	\N	\N	\N	70747	70747	238912
3376	2546	44	applied	\N	\N	\N	\N	70748	70748	238913
3376	2547	45	applied	\N	\N	\N	\N	70749	70749	238914
3376	2548	46	applied	\N	\N	\N	\N	70750	70750	238915
3376	2549	47	applied	\N	\N	\N	\N	70751	70751	238916
3377	2886	0	applied	\N	\N	\N	\N	70829	70829	238994
3380	2888	0	applied	\N	\N	\N	\N	70832	70832	238997
3386	2890	0	applied	\N	\N	\N	\N	70837	70837	239002
3389	2864	0	applied	\N	\N	\N	\N	70840	70840	239005
3389	2866	2	applied	\N	\N	\N	\N	70842	70842	239007
3389	2867	3	applied	\N	\N	\N	\N	70843	70843	239008
3389	2868	4	applied	\N	\N	\N	\N	70844	70844	239009
3389	2869	5	applied	\N	\N	\N	\N	70845	70845	239010
3389	2870	6	applied	\N	\N	\N	\N	70846	70846	239011
3389	2871	7	applied	\N	\N	\N	\N	70847	70847	239012
3389	2872	8	applied	\N	\N	\N	\N	70848	70848	239013
3389	2873	9	applied	\N	\N	\N	\N	70849	70849	239014
3389	2874	10	applied	\N	\N	\N	\N	70850	70850	239015
3389	2875	11	applied	\N	\N	\N	\N	70851	70851	239016
3389	2876	12	applied	\N	\N	\N	\N	70852	70852	239017
3389	2877	13	applied	\N	\N	\N	\N	70853	70853	239018
3389	2878	14	applied	\N	\N	\N	\N	70854	70854	239019
3389	2879	15	applied	\N	\N	\N	\N	70855	70855	239020
3389	2880	16	applied	\N	\N	\N	\N	70856	70856	239021
3389	2881	17	applied	\N	\N	\N	\N	70857	70857	239022
3389	2884	19	applied	\N	\N	\N	\N	70859	70859	239024
3389	2885	20	applied	\N	\N	\N	\N	70860	70860	239025
3389	2886	21	applied	\N	\N	\N	\N	70861	70861	239026
3389	2887	22	applied	\N	\N	\N	\N	70862	70862	239027
3389	2888	23	applied	\N	\N	\N	\N	70863	70863	239028
3389	2889	24	applied	\N	\N	\N	\N	70864	70864	239029
3389	2890	25	applied	\N	\N	\N	\N	70865	70865	239030
3389	2891	26	applied	\N	\N	\N	\N	70866	70866	239031
3389	2892	27	applied	\N	\N	\N	\N	70867	70867	239032
3389	2893	28	applied	\N	\N	\N	\N	70868	70868	239033
3389	2883	29	applied	\N	\N	\N	\N	70869	70869	239034
3392	2894	0	applied	\N	\N	\N	\N	70872	70872	239037
3395	2551	0	applied	\N	\N	\N	\N	70875	70875	239040
3395	2552	1	applied	\N	\N	\N	\N	70876	70876	239041
3395	2553	2	applied	\N	\N	\N	\N	70877	70877	239042
3395	2554	3	applied	\N	\N	\N	\N	70878	70878	239043
3395	2556	5	applied	\N	\N	\N	\N	70880	70880	239045
3395	2557	6	applied	\N	\N	\N	\N	70881	70881	239046
3395	2558	7	applied	\N	\N	\N	\N	70882	70882	239047
3395	2559	8	applied	\N	\N	\N	\N	70883	70883	239048
3395	2560	9	applied	\N	\N	\N	\N	70884	70884	239049
3395	2561	10	applied	\N	\N	\N	\N	70885	70885	239050
3395	2562	11	applied	\N	\N	\N	\N	70886	70886	239051
3395	2563	12	applied	\N	\N	\N	\N	70887	70887	239052
3395	2564	13	applied	\N	\N	\N	\N	70888	70888	239053
3395	2565	14	applied	\N	\N	\N	\N	70889	70889	239054
3395	2566	15	applied	\N	\N	\N	\N	70890	70890	239055
3395	2567	16	applied	\N	\N	\N	\N	70891	70891	239056
3395	2568	17	applied	\N	\N	\N	\N	70892	70892	239057
3395	2569	18	applied	\N	\N	\N	\N	70893	70893	239058
3395	2570	19	applied	\N	\N	\N	\N	70894	70894	239059
3395	2571	20	applied	\N	\N	\N	\N	70895	70895	239060
3395	2573	22	applied	\N	\N	\N	\N	70897	70897	239062
3395	2574	23	applied	\N	\N	\N	\N	70898	70898	239063
3395	2575	24	applied	\N	\N	\N	\N	70899	70899	239064
3395	2576	25	applied	\N	\N	\N	\N	70900	70900	239065
3395	2577	26	applied	\N	\N	\N	\N	70901	70901	239066
3395	2578	27	applied	\N	\N	\N	\N	70902	70902	239067
3395	2579	28	applied	\N	\N	\N	\N	70903	70903	239068
3395	2580	29	applied	\N	\N	\N	\N	70904	70904	239069
3395	2581	30	applied	\N	\N	\N	\N	70905	70905	239070
3395	2582	31	applied	\N	\N	\N	\N	70906	70906	239071
3395	2583	32	applied	\N	\N	\N	\N	70907	70907	239072
3395	2584	33	applied	\N	\N	\N	\N	70908	70908	239073
3395	2585	34	applied	\N	\N	\N	\N	70909	70909	239074
3395	2586	35	applied	\N	\N	\N	\N	70910	70910	239075
3395	2587	36	applied	\N	\N	\N	\N	70911	70911	239076
3395	2588	37	applied	\N	\N	\N	\N	70912	70912	239077
3395	2590	39	applied	\N	\N	\N	\N	70914	70914	239079
3395	2591	40	applied	\N	\N	\N	\N	70915	70915	239080
3395	2592	41	applied	\N	\N	\N	\N	70916	70916	239081
3395	2593	42	applied	\N	\N	\N	\N	70917	70917	239082
3395	2594	43	applied	\N	\N	\N	\N	70918	70918	239083
3395	2595	44	applied	\N	\N	\N	\N	70919	70919	239084
3395	2596	45	applied	\N	\N	\N	\N	70920	70920	239085
3395	2597	46	applied	\N	\N	\N	\N	70921	70921	239086
3395	2598	47	applied	\N	\N	\N	\N	70922	70922	239087
3395	2599	48	applied	\N	\N	\N	\N	70923	70923	239088
3395	2600	49	applied	\N	\N	\N	\N	70924	70924	239089
3395	2601	50	applied	\N	\N	\N	\N	70925	70925	239090
3395	2602	51	applied	\N	\N	\N	\N	70926	70926	239091
3395	2603	52	applied	\N	\N	\N	\N	70927	70927	239092
3395	2604	53	applied	\N	\N	\N	\N	70928	70928	239093
3395	2605	54	applied	\N	\N	\N	\N	70929	70929	239094
3395	2607	56	applied	\N	\N	\N	\N	70931	70931	239096
3395	2608	57	applied	\N	\N	\N	\N	70932	70932	239097
3395	2609	58	applied	\N	\N	\N	\N	70933	70933	239098
3395	2610	59	applied	\N	\N	\N	\N	70934	70934	239099
3395	2611	60	applied	\N	\N	\N	\N	70935	70935	239100
3395	2612	61	applied	\N	\N	\N	\N	70936	70936	239101
3395	2613	62	applied	\N	\N	\N	\N	70937	70937	239102
3395	2614	63	applied	\N	\N	\N	\N	70938	70938	239103
3395	2615	64	applied	\N	\N	\N	\N	70939	70939	239104
3395	2616	65	applied	\N	\N	\N	\N	70940	70940	239105
3395	2617	66	applied	\N	\N	\N	\N	70941	70941	239106
3395	2618	67	applied	\N	\N	\N	\N	70942	70942	239107
3395	2619	68	applied	\N	\N	\N	\N	70943	70943	239108
3395	2620	69	applied	\N	\N	\N	\N	70944	70944	239109
3365	2872	0	applied	\N	\N	\N	\N	70625	70625	238790
3365	2873	1	applied	\N	\N	\N	\N	70626	70626	238791
3376	2631	51	applied	\N	\N	\N	\N	70755	70755	238920
3376	2632	52	applied	\N	\N	\N	\N	70756	70756	238921
3376	2633	53	applied	\N	\N	\N	\N	70757	70757	238922
3376	2634	54	applied	\N	\N	\N	\N	70758	70758	238923
3376	2635	55	applied	\N	\N	\N	\N	70759	70759	238924
3376	2637	57	applied	\N	\N	\N	\N	70761	70761	238926
3376	2638	58	applied	\N	\N	\N	\N	70762	70762	238927
3376	2640	59	applied	\N	\N	\N	\N	70763	70763	238928
3376	2641	60	applied	\N	\N	\N	\N	70764	70764	238929
3376	2642	61	applied	\N	\N	\N	\N	70765	70765	238930
3376	2643	62	applied	\N	\N	\N	\N	70766	70766	238931
3376	2644	63	applied	\N	\N	\N	\N	70767	70767	238932
3376	2645	64	applied	\N	\N	\N	\N	70768	70768	238933
3376	2646	65	applied	\N	\N	\N	\N	70769	70769	238934
3376	2651	66	applied	\N	\N	\N	\N	70770	70770	238935
3376	2652	67	applied	\N	\N	\N	\N	70771	70771	238936
3376	2653	68	applied	\N	\N	\N	\N	70772	70772	238937
3376	2654	69	applied	\N	\N	\N	\N	70773	70773	238938
3376	2655	71	applied	\N	\N	\N	\N	70774	70774	238939
3376	2656	72	applied	\N	\N	\N	\N	70775	70775	238940
3376	2657	73	applied	\N	\N	\N	\N	70776	70776	238941
3376	2661	75	applied	\N	\N	\N	\N	70778	70778	238943
3376	2662	76	applied	\N	\N	\N	\N	70779	70779	238944
3376	2664	77	applied	\N	\N	\N	\N	70780	70780	238945
3376	2665	78	applied	\N	\N	\N	\N	70781	70781	238946
3376	2666	79	applied	\N	\N	\N	\N	70782	70782	238947
3376	2668	80	applied	\N	\N	\N	\N	70783	70783	238948
3376	2669	81	applied	\N	\N	\N	\N	70784	70784	238949
3376	2670	82	applied	\N	\N	\N	\N	70785	70785	238950
3376	2671	83	applied	\N	\N	\N	\N	70786	70786	238951
3376	2672	84	applied	\N	\N	\N	\N	70787	70787	238952
3376	2673	85	applied	\N	\N	\N	\N	70788	70788	238953
3376	2674	86	applied	\N	\N	\N	\N	70789	70789	238954
3376	2675	87	applied	\N	\N	\N	\N	70790	70790	238955
3376	2676	88	applied	\N	\N	\N	\N	70791	70791	238956
3376	2677	89	applied	\N	\N	\N	\N	70792	70792	238957
3376	2678	90	applied	\N	\N	\N	\N	70793	70793	238958
3376	2680	92	applied	\N	\N	\N	\N	70795	70795	238960
3376	2684	93	applied	\N	\N	\N	\N	70796	70796	238961
3376	2685	94	applied	\N	\N	\N	\N	70797	70797	238962
3376	2687	95	applied	\N	\N	\N	\N	70798	70798	238963
3376	2688	96	applied	\N	\N	\N	\N	70799	70799	238964
3376	2704	97	applied	\N	\N	\N	\N	70800	70800	238965
3376	2705	98	applied	\N	\N	\N	\N	70801	70801	238966
3376	2717	99	applied	\N	\N	\N	\N	70802	70802	238967
3376	2719	100	applied	\N	\N	\N	\N	70803	70803	238968
3376	2720	101	applied	\N	\N	\N	\N	70804	70804	238969
3376	2731	102	applied	\N	\N	\N	\N	70805	70805	238970
3376	2733	103	applied	\N	\N	\N	\N	70806	70806	238971
3376	2734	104	applied	\N	\N	\N	\N	70807	70807	238972
3376	2735	105	applied	\N	\N	\N	\N	70808	70808	238973
3376	2736	106	applied	\N	\N	\N	\N	70809	70809	238974
3376	2737	107	applied	\N	\N	\N	\N	70810	70810	238975
3376	2740	109	applied	\N	\N	\N	\N	70812	70812	238977
3376	2741	110	applied	\N	\N	\N	\N	70813	70813	238978
3376	2742	111	applied	\N	\N	\N	\N	70814	70814	238979
3376	2743	112	applied	\N	\N	\N	\N	70815	70815	238980
3376	2750	113	applied	\N	\N	\N	\N	70816	70816	238981
3376	2751	114	applied	\N	\N	\N	\N	70817	70817	238982
3376	2752	115	applied	\N	\N	\N	\N	70818	70818	238983
3376	2768	116	applied	\N	\N	\N	\N	70819	70819	238984
3376	2770	117	applied	\N	\N	\N	\N	70820	70820	238985
3376	2771	118	applied	\N	\N	\N	\N	70821	70821	238986
3376	2772	119	applied	\N	\N	\N	\N	70822	70822	238987
3376	2773	120	applied	\N	\N	\N	\N	70823	70823	238988
3376	2774	121	applied	\N	\N	\N	\N	70824	70824	238989
3376	2775	122	applied	\N	\N	\N	\N	70825	70825	238990
3376	2776	123	applied	\N	\N	\N	\N	70826	70826	238991
3376	2777	124	applied	\N	\N	\N	\N	70827	70827	238992
3379	2886	0	applied	\N	\N	\N	\N	70830	70830	238995
3379	2887	1	applied	\N	\N	\N	\N	70831	70831	238996
3381	2888	0	applied	\N	\N	\N	\N	70833	70833	238998
3382	2889	0	applied	\N	\N	\N	\N	70834	70834	238999
3388	2892	0	applied	\N	\N	\N	\N	70839	70839	239004
3390	2893	0	applied	\N	\N	\N	\N	70870	70870	239035
3391	2893	0	applied	\N	\N	\N	\N	70871	70871	239036
3394	2895	0	applied	\N	\N	\N	\N	70874	70874	239039
3395	2621	71	applied	\N	\N	\N	\N	70945	70945	239110
3395	2622	72	applied	\N	\N	\N	\N	70946	70946	239111
3395	2623	73	applied	\N	\N	\N	\N	70947	70947	239112
3395	2624	74	applied	\N	\N	\N	\N	70948	70948	239113
3395	2625	75	applied	\N	\N	\N	\N	70949	70949	239114
3395	2627	76	applied	\N	\N	\N	\N	70950	70950	239115
3395	2628	77	applied	\N	\N	\N	\N	70951	70951	239116
3395	2639	78	applied	\N	\N	\N	\N	70952	70952	239117
3403	2898	0	applied	\N	\N	\N	\N	71050	71050	239215
3415	2904	0	applied	\N	\N	\N	\N	71070	71070	239235
3421	2906	0	applied	\N	\N	\N	\N	71077	71077	239242
3421	2907	1	applied	\N	\N	\N	\N	71078	71078	239243
3426	2908	0	applied	\N	\N	\N	\N	71084	71084	239249
3426	2909	1	applied	\N	\N	\N	\N	71085	71085	239250
3426	2910	2	applied	\N	\N	\N	\N	71086	71086	239251
3429	2911	0	applied	\N	\N	\N	\N	71093	71093	239258
3444	2913	0	applied	\N	\N	\N	\N	71096	71096	239261
3444	2914	1	applied	\N	\N	\N	\N	71097	71097	239262
3488	2916	0	applied	\N	\N	1000000000	\N	71227	71227	239392
3503	2919	0	applied	\N	\N	\N	\N	71471	71471	239636
3509	2920	0	applied	\N	\N	\N	\N	71475	71475	239640
3521	2923	0	applied	\N	\N	\N	\N	71479	71479	239643
3532	2925	0	applied	\N	\N	\N	\N	71490	71490	239653
3532	2926	1	applied	\N	\N	\N	\N	71491	71491	239654
3543	2913	1	applied	\N	\N	\N	\N	71495	71495	239658
3543	2920	2	applied	\N	\N	\N	\N	71496	71496	239659
3543	2914	3	applied	\N	\N	\N	\N	71497	71497	239660
3543	2915	4	applied	\N	\N	\N	\N	71498	71498	239661
3543	2826	6	applied	\N	\N	\N	\N	71500	71500	239662
3543	2923	7	applied	\N	\N	\N	\N	71501	71501	239663
3543	2916	8	applied	\N	\N	1000000000	\N	71502	71502	239664
3376	2629	49	applied	\N	\N	\N	\N	70753	70753	238918
3376	2630	50	applied	\N	\N	\N	\N	70754	70754	238919
3395	2650	82	applied	\N	\N	\N	\N	70956	70956	239121
3395	2658	83	applied	\N	\N	\N	\N	70957	70957	239122
3395	2659	84	applied	\N	\N	\N	\N	70958	70958	239123
3395	2663	85	applied	\N	\N	\N	\N	70959	70959	239124
3395	2667	86	applied	\N	\N	\N	\N	70960	70960	239125
3395	2681	87	applied	\N	\N	\N	\N	70961	70961	239126
3395	2682	88	applied	\N	\N	\N	\N	70962	70962	239127
3395	2686	90	applied	\N	\N	\N	\N	70964	70964	239129
3395	2689	91	applied	\N	\N	\N	\N	70965	70965	239130
3395	2690	92	applied	\N	\N	\N	\N	70966	70966	239131
3395	2691	93	applied	\N	\N	\N	\N	70967	70967	239132
3395	2692	94	applied	\N	\N	\N	\N	70968	70968	239133
3395	2693	95	applied	\N	\N	\N	\N	70969	70969	239134
3395	2694	96	applied	\N	\N	\N	\N	70970	70970	239135
3395	2695	97	applied	\N	\N	\N	\N	70971	70971	239136
3395	2696	98	applied	\N	\N	\N	\N	70972	70972	239137
3395	2697	99	applied	\N	\N	\N	\N	70973	70973	239138
3395	2698	100	applied	\N	\N	\N	\N	70974	70974	239139
3395	2699	101	applied	\N	\N	\N	\N	70975	70975	239140
3395	2700	102	applied	\N	\N	\N	\N	70976	70976	239141
3395	2701	103	applied	\N	\N	\N	\N	70977	70977	239142
3395	2702	104	applied	\N	\N	\N	\N	70978	70978	239143
3395	2703	105	applied	\N	\N	\N	\N	70979	70979	239144
3395	2707	107	applied	\N	\N	\N	\N	70981	70981	239146
3395	2708	108	applied	\N	\N	\N	\N	70982	70982	239147
3395	2709	109	applied	\N	\N	\N	\N	70983	70983	239148
3395	2710	110	applied	\N	\N	\N	\N	70984	70984	239149
3395	2711	111	applied	\N	\N	\N	\N	70985	70985	239150
3395	2712	112	applied	\N	\N	\N	\N	70986	70986	239151
3395	2713	113	applied	\N	\N	\N	\N	70987	70987	239152
3395	2714	114	applied	\N	\N	\N	\N	70988	70988	239153
3395	2715	115	applied	\N	\N	\N	\N	70989	70989	239154
3395	2716	116	applied	\N	\N	\N	\N	70990	70990	239155
3395	2718	117	applied	\N	\N	\N	\N	70991	70991	239156
3395	2721	118	applied	\N	\N	\N	\N	70992	70992	239157
3395	2722	119	applied	\N	\N	\N	\N	70993	70993	239158
3395	2723	120	applied	\N	\N	\N	\N	70994	70994	239159
3395	2724	121	applied	\N	\N	\N	\N	70995	70995	239160
3395	2725	122	applied	\N	\N	\N	\N	70996	70996	239161
3395	2727	124	applied	\N	\N	\N	\N	70998	70998	239163
3395	2728	125	applied	\N	\N	\N	\N	70999	70999	239164
3398	2893	0	applied	\N	\N	\N	\N	71002	71002	239167
3398	2894	1	applied	\N	\N	\N	\N	71003	71003	239168
3398	2895	2	applied	\N	\N	\N	\N	71004	71004	239169
3398	2896	3	applied	\N	\N	\N	\N	71005	71005	239170
3400	2897	0	applied	\N	\N	\N	\N	71007	71007	239172
3401	2897	0	applied	\N	\N	\N	\N	71008	71008	239173
3404	2899	0	applied	\N	\N	\N	\N	71051	71051	239216
3409	2900	0	applied	\N	\N	\N	\N	71060	71060	239225
3409	2901	1	applied	\N	\N	\N	\N	71061	71061	239226
3410	2900	0	applied	\N	\N	\N	\N	71062	71062	239227
3410	2901	1	applied	\N	\N	\N	\N	71063	71063	239228
3413	2900	0	applied	\N	\N	\N	\N	71066	71066	239231
3413	2901	1	applied	\N	\N	\N	\N	71067	71067	239232
3413	2902	2	applied	\N	\N	\N	\N	71068	71068	239233
3418	2905	0	applied	\N	\N	\N	\N	71073	71073	239238
3419	2905	0	applied	\N	\N	\N	\N	71074	71074	239239
3422	2908	0	applied	\N	\N	\N	\N	71079	71079	239244
3425	2908	0	applied	\N	\N	\N	\N	71081	71081	239246
3425	2909	1	applied	\N	\N	\N	\N	71082	71082	239247
3425	2910	2	applied	\N	\N	\N	\N	71083	71083	239248
3428	2908	0	applied	\N	\N	\N	\N	71090	71090	239255
3428	2909	1	applied	\N	\N	\N	\N	71091	71091	239256
3428	2910	2	applied	\N	\N	\N	\N	71092	71092	239257
3445	2915	0	applied	\N	\N	\N	\N	71098	71098	239263
3447	2915	0	applied	\N	\N	\N	\N	71100	71100	239265
3448	2915	0	applied	\N	\N	\N	\N	71101	71101	239266
3456	2756	0	applied	\N	\N	\N	\N	71102	71102	239267
3456	2757	1	applied	\N	\N	\N	\N	71103	71103	239268
3456	2763	2	applied	\N	\N	\N	\N	71104	71104	239269
3456	2732	4	applied	\N	\N	1000000000	\N	71106	71106	239271
3456	2755	5	applied	\N	\N	\N	\N	71107	71107	239272
3456	2704	6	applied	\N	\N	\N	\N	71108	71108	239273
3456	2913	7	applied	\N	\N	\N	\N	71109	71109	239274
3456	2692	8	applied	\N	\N	\N	\N	71110	71110	239275
3456	2693	9	applied	\N	\N	\N	\N	71111	71111	239276
3456	2694	10	applied	\N	\N	\N	\N	71112	71112	239277
3456	2914	11	applied	\N	\N	\N	\N	71113	71113	239278
3456	2915	12	applied	\N	\N	\N	\N	71114	71114	239279
3456	2695	13	applied	\N	\N	\N	\N	71115	71115	239280
3456	2696	15	applied	\N	\N	\N	\N	71116	71116	239281
3456	2697	16	applied	\N	\N	\N	\N	71117	71117	239282
3456	2698	17	applied	\N	\N	\N	\N	71118	71118	239283
3456	2699	18	applied	\N	\N	\N	\N	71119	71119	239284
3456	2700	19	applied	\N	\N	\N	\N	71120	71120	239285
3456	2701	20	applied	\N	\N	\N	\N	71121	71121	239286
3456	2702	21	applied	\N	\N	\N	\N	71122	71122	239287
3456	2703	22	applied	\N	\N	\N	\N	71123	71123	239288
3456	2705	23	applied	\N	\N	\N	\N	71124	71124	239289
3456	2719	25	applied	\N	\N	\N	\N	71126	71126	239291
3456	2720	26	applied	\N	\N	\N	\N	71127	71127	239292
3456	2731	27	applied	\N	\N	\N	\N	71128	71128	239293
3456	2733	28	applied	\N	\N	\N	\N	71129	71129	239294
3456	2734	29	applied	\N	\N	\N	\N	71130	71130	239295
3456	2735	30	applied	\N	\N	\N	\N	71131	71131	239296
3456	2736	31	applied	\N	\N	\N	\N	71132	71132	239297
3456	2737	32	applied	\N	\N	\N	\N	71133	71133	239298
3456	2738	33	applied	\N	\N	\N	\N	71134	71134	239299
3456	2740	34	applied	\N	\N	\N	\N	71135	71135	239300
3456	2741	35	applied	\N	\N	\N	\N	71136	71136	239301
3456	2742	36	applied	\N	\N	\N	\N	71137	71137	239302
3456	2743	37	applied	\N	\N	\N	\N	71138	71138	239303
3636	2930	0	applied	\N	\N	1000000000	\N	71510	71510	239672
3636	2931	1	applied	\N	\N	\N	\N	71511	71511	239673
3636	2932	2	applied	\N	\N	\N	\N	71512	71512	239674
3640	2927	1	applied	\N	\N	\N	\N	71517	71517	239679
3640	2928	2	applied	\N	\N	1000000000	\N	71518	71518	239680
3640	2929	3	applied	\N	\N	\N	\N	71519	71519	239681
3640	2931	4	applied	\N	\N	\N	\N	71520	71520	239682
3395	2648	80	applied	\N	\N	\N	\N	70954	70954	239119
3395	2649	81	applied	\N	\N	\N	\N	70955	70955	239120
3456	2706	41	applied	\N	\N	\N	\N	71142	71142	239307
3456	2707	42	applied	\N	\N	\N	\N	71143	71143	239308
3456	2708	43	applied	\N	\N	\N	\N	71144	71144	239309
3456	2709	44	applied	\N	\N	\N	\N	71145	71145	239310
3456	2710	45	applied	\N	\N	\N	\N	71146	71146	239311
3456	2711	46	applied	\N	\N	\N	\N	71147	71147	239312
3456	2712	47	applied	\N	\N	\N	\N	71148	71148	239313
3456	2713	48	applied	\N	\N	\N	\N	71149	71149	239314
3456	2714	49	applied	\N	\N	\N	\N	71150	71150	239315
3456	2715	50	applied	\N	\N	\N	\N	71151	71151	239316
3456	2716	51	applied	\N	\N	\N	\N	71152	71152	239317
3456	2718	52	applied	\N	\N	\N	\N	71153	71153	239318
3456	2721	53	applied	\N	\N	\N	\N	71154	71154	239319
3456	2723	55	applied	\N	\N	\N	\N	71156	71156	239321
3456	2724	56	applied	\N	\N	\N	\N	71157	71157	239322
3456	2725	57	applied	\N	\N	\N	\N	71158	71158	239323
3456	2726	58	applied	\N	\N	\N	\N	71159	71159	239324
3456	2727	59	applied	\N	\N	\N	\N	71160	71160	239325
3456	2728	60	applied	\N	\N	\N	\N	71161	71161	239326
3456	2729	61	applied	\N	\N	\N	\N	71162	71162	239327
3456	2730	62	applied	\N	\N	\N	\N	71163	71163	239328
3456	2739	63	applied	\N	\N	\N	\N	71164	71164	239329
3456	2744	64	applied	\N	\N	\N	\N	71165	71165	239330
3456	2745	65	applied	\N	\N	\N	\N	71166	71166	239331
3456	2746	66	applied	\N	\N	\N	\N	71167	71167	239332
3456	2747	67	applied	\N	\N	\N	\N	71168	71168	239333
3456	2748	68	applied	\N	\N	\N	\N	71169	71169	239334
3456	2749	69	applied	\N	\N	\N	\N	71170	71170	239335
3456	2753	70	applied	\N	\N	\N	\N	71171	71171	239336
3456	2759	72	applied	\N	\N	\N	\N	71173	71173	239338
3456	2760	73	applied	\N	\N	\N	\N	71174	71174	239339
3456	2761	74	applied	\N	\N	\N	\N	71175	71175	239340
3456	2762	75	applied	\N	\N	\N	\N	71176	71176	239341
3456	2764	76	applied	\N	\N	\N	\N	71177	71177	239342
3456	2765	77	applied	\N	\N	\N	\N	71178	71178	239343
3456	2766	78	applied	\N	\N	\N	\N	71179	71179	239344
3456	2767	79	applied	\N	\N	\N	\N	71180	71180	239345
3456	2769	80	applied	\N	\N	\N	\N	71181	71181	239346
3456	2778	81	applied	\N	\N	\N	\N	71182	71182	239347
3456	2779	82	applied	\N	\N	\N	\N	71183	71183	239348
3456	2797	83	applied	\N	\N	\N	\N	71184	71184	239349
3456	2802	84	applied	\N	\N	\N	\N	71185	71185	239350
3456	2804	85	applied	\N	\N	\N	\N	71186	71186	239351
3456	2805	86	applied	\N	\N	\N	\N	71187	71187	239352
3456	2812	87	applied	\N	\N	\N	\N	71188	71188	239353
3456	2814	89	applied	\N	\N	\N	\N	71190	71190	239355
3456	2816	90	applied	\N	\N	\N	\N	71191	71191	239356
3456	2819	91	applied	\N	\N	\N	\N	71192	71192	239357
3456	2820	92	applied	\N	\N	\N	\N	71193	71193	239358
3456	2821	93	applied	\N	\N	\N	\N	71194	71194	239359
3456	2823	94	applied	\N	\N	\N	\N	71195	71195	239360
3456	2824	95	applied	\N	\N	\N	\N	71196	71196	239361
3456	2825	96	applied	\N	\N	\N	\N	71197	71197	239362
3456	2827	97	applied	\N	\N	\N	\N	71198	71198	239363
3456	2828	98	applied	\N	\N	\N	\N	71199	71199	239364
3456	2829	99	applied	\N	\N	\N	\N	71200	71200	239365
3456	2830	100	applied	\N	\N	\N	\N	71201	71201	239366
3456	2831	101	applied	\N	\N	\N	\N	71202	71202	239367
3456	2832	102	applied	\N	\N	\N	\N	71203	71203	239368
3456	2834	103	applied	\N	\N	\N	\N	71204	71204	239369
3456	2835	104	applied	\N	\N	\N	\N	71205	71205	239370
3456	2768	106	applied	\N	\N	\N	\N	71207	71207	239372
3456	2770	107	applied	\N	\N	\N	\N	71208	71208	239373
3456	2771	108	applied	\N	\N	\N	\N	71209	71209	239374
3456	2772	109	applied	\N	\N	\N	\N	71210	71210	239375
3456	2773	110	applied	\N	\N	\N	\N	71211	71211	239376
3456	2774	111	applied	\N	\N	\N	\N	71212	71212	239377
3456	2775	112	applied	\N	\N	\N	\N	71213	71213	239378
3456	2776	113	applied	\N	\N	\N	\N	71214	71214	239379
3456	2777	114	applied	\N	\N	\N	\N	71215	71215	239380
3456	2780	115	applied	\N	\N	\N	\N	71216	71216	239381
3456	2781	116	applied	\N	\N	\N	\N	71217	71217	239382
3456	2782	117	applied	\N	\N	\N	\N	71218	71218	239383
3456	2783	118	applied	\N	\N	\N	\N	71219	71219	239384
3456	2784	119	applied	\N	\N	\N	\N	71220	71220	239385
3456	2785	120	applied	\N	\N	\N	\N	71221	71221	239386
3456	2786	121	applied	\N	\N	\N	\N	71222	71222	239387
3456	2788	123	applied	\N	\N	\N	\N	71224	71224	239389
3456	2789	124	applied	\N	\N	\N	\N	71225	71225	239390
3456	2790	125	applied	\N	\N	\N	\N	71226	71226	239391
3489	2756	0	applied	\N	\N	\N	\N	71228	71228	239393
3489	2757	1	applied	\N	\N	\N	\N	71229	71229	239394
3489	2763	2	applied	\N	\N	\N	\N	71230	71230	239395
3489	2758	3	applied	\N	\N	1000000000	\N	71231	71231	239396
3489	2732	4	applied	\N	\N	1000000000	\N	71232	71232	239397
3489	2717	5	applied	\N	\N	\N	\N	71233	71233	239398
3489	2716	6	applied	\N	\N	\N	\N	71234	71234	239399
3489	2755	7	applied	\N	\N	\N	\N	71235	71235	239400
3489	2913	8	applied	\N	\N	\N	\N	71236	71236	239401
3489	2718	9	applied	\N	\N	\N	\N	71237	71237	239402
3489	2914	10	applied	\N	\N	\N	\N	71238	71238	239403
3489	2915	11	applied	\N	\N	\N	\N	71239	71239	239404
3489	2721	12	applied	\N	\N	\N	\N	71240	71240	239405
3489	2723	14	applied	\N	\N	\N	\N	71242	71242	239407
3489	2724	15	applied	\N	\N	\N	\N	71243	71243	239408
3489	2719	16	applied	\N	\N	\N	\N	71244	71244	239409
3489	2720	17	applied	\N	\N	\N	\N	71245	71245	239410
3489	2731	18	applied	\N	\N	\N	\N	71246	71246	239411
3489	2733	19	applied	\N	\N	\N	\N	71247	71247	239412
3489	2734	20	applied	\N	\N	\N	\N	71248	71248	239413
3489	2735	21	applied	\N	\N	\N	\N	71249	71249	239414
3489	2736	22	applied	\N	\N	\N	\N	71250	71250	239415
3489	2737	23	applied	\N	\N	\N	\N	71251	71251	239416
3489	2738	24	applied	\N	\N	\N	\N	71252	71252	239417
3489	2740	25	applied	\N	\N	\N	\N	71253	71253	239418
3489	2741	26	applied	\N	\N	\N	\N	71254	71254	239419
3489	2742	27	applied	\N	\N	\N	\N	71255	71255	239420
3489	2743	28	applied	\N	\N	\N	\N	71256	71256	239421
3489	2750	29	applied	\N	\N	\N	\N	71257	71257	239422
3456	2751	39	applied	\N	\N	\N	\N	71140	71140	239305
3456	2752	40	applied	\N	\N	\N	\N	71141	71141	239306
3489	2728	35	applied	\N	\N	\N	\N	71263	71263	239428
3489	2729	36	applied	\N	\N	\N	\N	71264	71264	239429
3489	2730	37	applied	\N	\N	\N	\N	71265	71265	239430
3489	2739	38	applied	\N	\N	\N	\N	71266	71266	239431
3489	2744	39	applied	\N	\N	\N	\N	71267	71267	239432
3489	2745	40	applied	\N	\N	\N	\N	71268	71268	239433
3489	2746	41	applied	\N	\N	\N	\N	71269	71269	239434
3489	2747	42	applied	\N	\N	\N	\N	71270	71270	239435
3489	2748	43	applied	\N	\N	\N	\N	71271	71271	239436
3489	2749	44	applied	\N	\N	\N	\N	71272	71272	239437
3489	2753	45	applied	\N	\N	\N	\N	71273	71273	239438
3489	2754	46	applied	\N	\N	\N	\N	71274	71274	239439
3489	2759	47	applied	\N	\N	\N	\N	71275	71275	239440
3489	2760	48	applied	\N	\N	\N	\N	71276	71276	239441
3489	2761	49	applied	\N	\N	\N	\N	71277	71277	239442
3489	2762	50	applied	\N	\N	\N	\N	71278	71278	239443
3489	2765	52	applied	\N	\N	\N	\N	71280	71280	239445
3489	2766	53	applied	\N	\N	\N	\N	71281	71281	239446
3489	2767	54	applied	\N	\N	\N	\N	71282	71282	239447
3489	2769	55	applied	\N	\N	\N	\N	71283	71283	239448
3489	2778	56	applied	\N	\N	\N	\N	71284	71284	239449
3489	2779	57	applied	\N	\N	\N	\N	71285	71285	239450
3489	2797	58	applied	\N	\N	\N	\N	71286	71286	239451
3489	2802	59	applied	\N	\N	\N	\N	71287	71287	239452
3489	2804	60	applied	\N	\N	\N	\N	71288	71288	239453
3489	2805	61	applied	\N	\N	\N	\N	71289	71289	239454
3489	2812	62	applied	\N	\N	\N	\N	71290	71290	239455
3489	2813	63	applied	\N	\N	\N	\N	71291	71291	239456
3489	2814	64	applied	\N	\N	\N	\N	71292	71292	239457
3489	2816	65	applied	\N	\N	\N	\N	71293	71293	239458
3489	2819	66	applied	\N	\N	\N	\N	71294	71294	239459
3489	2820	67	applied	\N	\N	\N	\N	71295	71295	239460
3489	2823	70	applied	\N	\N	\N	\N	71297	71297	239462
3489	2824	71	applied	\N	\N	\N	\N	71298	71298	239463
3489	2825	72	applied	\N	\N	\N	\N	71299	71299	239464
3489	2827	73	applied	\N	\N	\N	\N	71300	71300	239465
3489	2828	74	applied	\N	\N	\N	\N	71301	71301	239466
3489	2829	75	applied	\N	\N	\N	\N	71302	71302	239467
3489	2830	76	applied	\N	\N	\N	\N	71303	71303	239468
3489	2831	77	applied	\N	\N	\N	\N	71304	71304	239469
3489	2832	78	applied	\N	\N	\N	\N	71305	71305	239470
3489	2834	79	applied	\N	\N	\N	\N	71306	71306	239471
3489	2835	80	applied	\N	\N	\N	\N	71307	71307	239472
3489	2841	81	applied	\N	\N	\N	\N	71308	71308	239473
3489	2768	82	applied	\N	\N	\N	\N	71309	71309	239474
3489	2770	83	applied	\N	\N	\N	\N	71310	71310	239475
3489	2771	84	applied	\N	\N	\N	\N	71311	71311	239476
3493	2913	0	applied	\N	\N	\N	\N	71312	71312	239477
3493	2729	2	applied	\N	\N	\N	\N	71314	71314	239479
3493	2730	3	applied	\N	\N	\N	\N	71315	71315	239480
3493	2739	4	applied	\N	\N	\N	\N	71316	71316	239481
3493	2744	5	applied	\N	\N	\N	\N	71317	71317	239482
3493	2745	6	applied	\N	\N	\N	\N	71318	71318	239483
3493	2746	7	applied	\N	\N	\N	\N	71319	71319	239484
3493	2747	8	applied	\N	\N	\N	\N	71320	71320	239485
3493	2748	9	applied	\N	\N	\N	\N	71321	71321	239486
3493	2749	10	applied	\N	\N	\N	\N	71322	71322	239487
3493	2753	11	applied	\N	\N	\N	\N	71323	71323	239488
3493	2754	12	applied	\N	\N	\N	\N	71324	71324	239489
3493	2759	13	applied	\N	\N	\N	\N	71325	71325	239490
3493	2760	14	applied	\N	\N	\N	\N	71326	71326	239491
3493	2761	15	applied	\N	\N	\N	\N	71327	71327	239492
3493	2762	16	applied	\N	\N	\N	\N	71328	71328	239493
3493	2764	17	applied	\N	\N	\N	\N	71329	71329	239494
3493	2766	19	applied	\N	\N	\N	\N	71331	71331	239496
3493	2767	20	applied	\N	\N	\N	\N	71332	71332	239497
3493	2769	21	applied	\N	\N	\N	\N	71333	71333	239498
3493	2778	22	applied	\N	\N	\N	\N	71334	71334	239499
3493	2779	23	applied	\N	\N	\N	\N	71335	71335	239500
3493	2797	24	applied	\N	\N	\N	\N	71336	71336	239501
3493	2802	25	applied	\N	\N	\N	\N	71337	71337	239502
3493	2804	26	applied	\N	\N	\N	\N	71338	71338	239503
3493	2805	27	applied	\N	\N	\N	\N	71339	71339	239504
3493	2812	28	applied	\N	\N	\N	\N	71340	71340	239505
3493	2813	29	applied	\N	\N	\N	\N	71341	71341	239506
3493	2814	30	applied	\N	\N	\N	\N	71342	71342	239507
3493	2816	31	applied	\N	\N	\N	\N	71343	71343	239508
3493	2819	32	applied	\N	\N	\N	\N	71344	71344	239509
3493	2820	33	applied	\N	\N	\N	\N	71345	71345	239510
3493	2821	34	applied	\N	\N	\N	\N	71346	71346	239511
3493	2824	36	applied	\N	\N	\N	\N	71348	71348	239513
3493	2825	37	applied	\N	\N	\N	\N	71349	71349	239514
3493	2827	38	applied	\N	\N	\N	\N	71350	71350	239515
3493	2828	39	applied	\N	\N	\N	\N	71351	71351	239516
3493	2829	40	applied	\N	\N	\N	\N	71352	71352	239517
3493	2830	41	applied	\N	\N	\N	\N	71353	71353	239518
3493	2831	42	applied	\N	\N	\N	\N	71354	71354	239519
3493	2832	43	applied	\N	\N	\N	\N	71355	71355	239520
3493	2834	44	applied	\N	\N	\N	\N	71356	71356	239521
3493	2835	45	applied	\N	\N	\N	\N	71357	71357	239522
3493	2841	46	applied	\N	\N	\N	\N	71358	71358	239523
3493	2854	47	applied	\N	\N	\N	\N	71359	71359	239524
3493	2856	48	applied	\N	\N	\N	\N	71360	71360	239525
3493	2858	49	applied	\N	\N	\N	\N	71361	71361	239526
3493	2860	50	applied	\N	\N	\N	\N	71362	71362	239527
3493	2861	51	applied	\N	\N	\N	\N	71363	71363	239528
3493	2863	53	applied	\N	\N	\N	\N	71365	71365	239530
3493	2864	54	applied	\N	\N	\N	\N	71366	71366	239531
3493	2865	55	applied	\N	\N	\N	\N	71367	71367	239532
3493	2866	56	applied	\N	\N	\N	\N	71368	71368	239533
3493	2867	57	applied	\N	\N	\N	\N	71369	71369	239534
3493	2868	58	applied	\N	\N	\N	\N	71370	71370	239535
3493	2869	59	applied	\N	\N	\N	\N	71371	71371	239536
3493	2870	60	applied	\N	\N	\N	\N	71372	71372	239537
3493	2871	61	applied	\N	\N	\N	\N	71373	71373	239538
3493	2872	62	applied	\N	\N	\N	\N	71374	71374	239539
3493	2873	63	applied	\N	\N	\N	\N	71375	71375	239540
3493	2874	64	applied	\N	\N	\N	\N	71376	71376	239541
3493	2875	65	applied	\N	\N	\N	\N	71377	71377	239542
3493	2876	66	applied	\N	\N	\N	\N	71378	71378	239543
3489	2725	32	applied	\N	\N	\N	\N	71260	71260	239425
3489	2726	33	applied	\N	\N	\N	\N	71261	71261	239426
3493	2881	72	applied	\N	\N	\N	\N	71383	71383	239548
3493	2882	73	applied	\N	\N	\N	\N	71384	71384	239549
3493	2884	74	applied	\N	\N	\N	\N	71385	71385	239550
3493	2885	75	applied	\N	\N	\N	\N	71386	71386	239551
3493	2886	76	applied	\N	\N	\N	\N	71387	71387	239552
3493	2887	77	applied	\N	\N	\N	\N	71388	71388	239553
3493	2888	78	applied	\N	\N	\N	\N	71389	71389	239554
3493	2889	79	applied	\N	\N	\N	\N	71390	71390	239555
3493	2890	80	applied	\N	\N	\N	\N	71391	71391	239556
3493	2891	81	applied	\N	\N	\N	\N	71392	71392	239557
3493	2892	82	applied	\N	\N	\N	\N	71393	71393	239558
3493	2893	83	applied	\N	\N	\N	\N	71394	71394	239559
3493	2894	84	applied	\N	\N	\N	\N	71395	71395	239560
3493	2895	85	applied	\N	\N	\N	\N	71396	71396	239561
3493	2896	86	applied	\N	\N	\N	\N	71397	71397	239562
3493	2897	87	applied	\N	\N	\N	\N	71398	71398	239563
3493	2899	89	applied	\N	\N	\N	\N	71400	71400	239565
3493	2900	90	applied	\N	\N	\N	\N	71401	71401	239566
3493	2901	91	applied	\N	\N	\N	\N	71402	71402	239567
3493	2902	92	applied	\N	\N	\N	\N	71403	71403	239568
3493	2903	93	applied	\N	\N	\N	\N	71404	71404	239569
3493	2904	94	applied	\N	\N	\N	\N	71405	71405	239570
3493	2905	95	applied	\N	\N	\N	\N	71406	71406	239571
3495	2917	0	applied	\N	\N	\N	\N	71407	71407	239572
3498	2918	0	applied	\N	\N	\N	\N	71409	71409	239574
3499	2902	45	applied	\N	\N	\N	\N	71454	71454	239619
3499	2903	46	applied	\N	\N	\N	\N	71455	71455	239620
3499	2904	47	applied	\N	\N	\N	\N	71456	71456	239621
3499	2905	48	applied	\N	\N	\N	\N	71457	71457	239622
3499	2906	49	applied	\N	\N	\N	\N	71458	71458	239623
3499	2907	50	applied	\N	\N	\N	\N	71459	71459	239624
3499	2908	51	applied	\N	\N	\N	\N	71460	71460	239625
3499	2910	53	applied	\N	\N	\N	\N	71462	71462	239627
3499	2911	54	applied	\N	\N	\N	\N	71463	71463	239628
3499	2912	55	applied	\N	\N	\N	\N	71464	71464	239629
3499	2917	56	applied	\N	\N	\N	\N	71465	71465	239630
3499	2826	57	applied	\N	\N	\N	\N	71466	71466	239631
3499	2833	58	applied	\N	\N	\N	\N	71467	71467	239632
3499	2855	59	applied	\N	\N	1000000000	\N	71468	71468	239633
3499	2918	60	applied	\N	\N	\N	\N	71469	71469	239634
3499	2916	61	applied	\N	\N	1000000000	\N	71470	71470	239635
3504	2919	0	applied	\N	\N	\N	\N	71472	71472	239637
3505	2919	0	applied	\N	\N	\N	\N	71473	71473	239638
3508	2920	0	applied	\N	\N	\N	\N	71474	71474	239639
3510	2920	0	applied	\N	\N	\N	\N	71476	71476	239641
3519	2921	0	applied	\N	\N	\N	\N	71477	71477	239642
3526	2920	0	applied	\N	\N	\N	\N	71480	71480	239644
3526	2917	2	applied	\N	\N	\N	\N	71482	71482	239645
3526	2922	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	71481	71481	\N
3526	2923	3	applied	\N	\N	\N	\N	71483	71483	239646
3526	2918	4	applied	\N	\N	\N	\N	71484	71484	239647
3526	2916	5	applied	\N	\N	1000000000	\N	71485	71485	239648
3528	2924	0	applied	\N	\N	\N	\N	71486	71486	239649
3529	2924	0	applied	\N	\N	\N	\N	71487	71487	239650
3530	2924	0	applied	\N	\N	\N	\N	71488	71488	239651
3531	2924	0	applied	\N	\N	\N	\N	71489	71489	239652
3533	2925	0	applied	\N	\N	\N	\N	71492	71492	239655
3533	2926	1	applied	\N	\N	\N	\N	71493	71493	239656
3628	2925	0	applied	\N	\N	\N	\N	71503	71503	239665
3632	2927	0	applied	\N	\N	\N	\N	71504	71504	239666
3632	2928	1	applied	\N	\N	1000000000	\N	71505	71505	239667
3633	2929	0	applied	\N	\N	\N	\N	71506	71506	239668
3635	2930	0	applied	\N	\N	1000000000	\N	71507	71507	239669
3635	2931	1	applied	\N	\N	\N	\N	71508	71508	239670
3635	2932	2	applied	\N	\N	\N	\N	71509	71509	239671
3637	2930	0	applied	\N	\N	1000000000	\N	71513	71513	239675
3637	2931	1	applied	\N	\N	\N	\N	71514	71514	239676
3637	2932	2	applied	\N	\N	\N	\N	71515	71515	239677
3644	2933	0	applied	\N	\N	\N	\N	71521	71521	239683
3653	2934	0	applied	\N	\N	\N	\N	71522	71522	239684
3666	2935	0	applied	\N	\N	1000000000	\N	71524	71524	239686
3669	2936	0	applied	\N	\N	\N	\N	71525	71525	239687
3669	2937	1	applied	\N	\N	\N	\N	71526	71526	239688
3669	2938	2	applied	\N	\N	1000000000	\N	71527	71527	239689
3670	2939	0	applied	\N	\N	\N	\N	71528	71528	239690
3671	2940	0	applied	\N	\N	\N	\N	71529	71529	239691
3673	2940	0	applied	\N	\N	\N	\N	71530	71530	239692
3674	2941	0	applied	\N	\N	\N	\N	71531	71531	239693
3675	2941	0	applied	\N	\N	\N	\N	71532	71532	239694
3676	2941	0	applied	\N	\N	\N	\N	71533	71533	239695
3677	2941	0	applied	\N	\N	\N	\N	71534	71534	239696
3678	2942	0	applied	\N	\N	\N	\N	71535	71535	239697
3679	2943	0	applied	\N	\N	\N	\N	71536	71536	239698
3680	2944	0	applied	\N	\N	\N	\N	71537	71537	239699
3681	2944	0	applied	\N	\N	\N	\N	71538	71538	239700
3682	2945	0	applied	\N	\N	\N	\N	71539	71539	239701
3683	2946	0	applied	\N	\N	\N	\N	71540	71540	239702
3684	2947	0	applied	\N	\N	\N	\N	71541	71541	239703
3684	2948	1	applied	\N	\N	\N	\N	71542	71542	239704
3684	2949	2	applied	\N	\N	\N	\N	71543	71543	239705
3685	2948	1	applied	\N	\N	\N	\N	71545	71545	239707
3685	2949	2	applied	\N	\N	\N	\N	71546	71546	239708
3686	2950	0	applied	\N	\N	\N	\N	71547	71547	239709
3686	2951	1	applied	\N	\N	\N	\N	71548	71548	239710
3687	2950	0	applied	\N	\N	\N	\N	71549	71549	239711
3687	2951	1	applied	\N	\N	\N	\N	71550	71550	239712
3688	2950	0	applied	\N	\N	\N	\N	71551	71551	239713
3688	2951	1	applied	\N	\N	\N	\N	71552	71552	239714
3689	2952	0	applied	\N	\N	\N	\N	71553	71553	239715
3690	2952	0	applied	\N	\N	\N	\N	71554	71554	239716
3691	2952	0	applied	\N	\N	\N	\N	71555	71555	239717
3692	2952	0	applied	\N	\N	\N	\N	71556	71556	239718
3693	2953	0	applied	\N	\N	\N	\N	71557	71557	239719
3694	2954	0	applied	\N	\N	\N	\N	71558	71558	239720
3695	2955	0	applied	\N	\N	\N	\N	71559	71559	239721
3695	2956	1	applied	\N	\N	\N	\N	71560	71560	239722
3696	2955	0	applied	\N	\N	\N	\N	71562	71562	239724
3696	2956	1	applied	\N	\N	\N	\N	71563	71563	239725
3493	2878	68	applied	\N	\N	\N	\N	71380	71380	239545
3493	2879	69	applied	\N	\N	\N	\N	71381	71381	239546
3699	2959	0	applied	\N	\N	\N	\N	71567	71567	239729
3700	2959	0	applied	\N	\N	\N	\N	71568	71568	239730
3701	2960	0	applied	\N	\N	\N	\N	71569	71569	239731
3701	2961	1	applied	\N	\N	\N	\N	71570	71570	239732
3701	2962	2	applied	\N	\N	\N	\N	71571	71571	239733
3702	2961	1	applied	\N	\N	\N	\N	71573	71573	239735
3702	2962	2	applied	\N	\N	\N	\N	71574	71574	239736
3703	2960	0	applied	\N	\N	\N	\N	71575	71575	239737
3703	2961	1	applied	\N	\N	\N	\N	71576	71576	239738
3703	2962	2	applied	\N	\N	\N	\N	71577	71577	239739
3704	2963	0	applied	\N	\N	\N	\N	71578	71578	239740
3705	2963	0	applied	\N	\N	\N	\N	71579	71579	239741
3706	2963	0	applied	\N	\N	\N	\N	71580	71580	239742
3707	2964	0	applied	\N	\N	\N	\N	71581	71581	239743
3708	2965	0	applied	\N	\N	\N	\N	71582	71582	239744
3709	2966	0	applied	\N	\N	\N	\N	71583	71583	239745
3709	2967	1	applied	\N	\N	\N	\N	71584	71584	239746
3709	2968	2	applied	\N	\N	\N	\N	71585	71585	239747
3709	2969	3	applied	\N	\N	\N	\N	71586	71586	239748
3710	2970	0	applied	\N	\N	\N	\N	71587	71587	239749
3710	2971	1	applied	\N	\N	\N	\N	71588	71588	239750
3711	2971	1	applied	\N	\N	\N	\N	71590	71590	239752
3712	2970	0	applied	\N	\N	\N	\N	71591	71591	239753
3712	2971	1	applied	\N	\N	\N	\N	71592	71592	239754
3713	2972	0	applied	\N	\N	\N	\N	71593	71593	239755
3714	2972	0	applied	\N	\N	\N	\N	71594	71594	239756
3715	2973	0	applied	\N	\N	\N	\N	71595	71595	239757
3716	2974	0	applied	\N	\N	\N	\N	71596	71596	239758
3717	2974	0	applied	\N	\N	\N	\N	71597	71597	239759
3718	2974	0	applied	\N	\N	\N	\N	71598	71598	239760
3719	2974	0	applied	\N	\N	\N	\N	71599	71599	239761
3720	2960	0	applied	\N	\N	\N	\N	71600	71600	239762
3720	2961	1	applied	\N	\N	\N	\N	71601	71601	239763
3720	2963	2	applied	\N	\N	\N	\N	71602	71602	239764
3720	2964	4	applied	\N	\N	\N	\N	71603	71603	239765
3720	2965	5	applied	\N	\N	\N	\N	71604	71604	239766
3720	2966	6	applied	\N	\N	\N	\N	71605	71605	239767
3720	2968	8	applied	\N	\N	\N	\N	71607	71607	239769
3720	2969	9	applied	\N	\N	\N	\N	71608	71608	239770
3720	2970	10	applied	\N	\N	\N	\N	71609	71609	239771
3720	2971	11	applied	\N	\N	\N	\N	71610	71610	239772
3722	2975	0	applied	\N	\N	\N	\N	71612	71612	239774
3725	2977	0	applied	\N	\N	\N	\N	71615	71615	239777
3729	2979	0	applied	\N	\N	\N	\N	71619	71619	239781
3731	2980	0	applied	\N	\N	\N	\N	71621	71621	239783
3733	2980	0	applied	\N	\N	\N	\N	71623	71623	239785
3736	2982	0	applied	\N	\N	\N	\N	71627	71627	239789
3736	2983	1	applied	\N	\N	\N	\N	71628	71628	239790
3738	2984	0	applied	\N	\N	\N	\N	71630	71630	239792
3741	2985	0	applied	\N	\N	\N	\N	71633	71633	239795
3747	2988	0	applied	\N	\N	\N	\N	71643	71643	239805
3747	2989	1	applied	\N	\N	\N	\N	71644	71644	239806
3760	3000	0	applied	\N	\N	\N	\N	71663	71663	239825
3768	3006	1	applied	\N	\N	\N	\N	71676	71676	239838
3775	3010	0	applied	\N	\N	\N	\N	71682	71682	239844
3780	3012	0	applied	\N	\N	\N	\N	71685	71685	239847
3782	3013	0	applied	\N	\N	\N	\N	71687	71687	239849
3782	3014	1	applied	\N	\N	\N	\N	71688	71688	239850
3785	3013	0	applied	\N	\N	\N	\N	71693	71693	239855
3785	3014	1	applied	\N	\N	\N	\N	71694	71694	239856
3786	3013	0	applied	\N	\N	\N	\N	71695	71695	239857
3786	3014	1	applied	\N	\N	\N	\N	71696	71696	239858
3790	3018	0	applied	\N	\N	\N	\N	71704	71704	239866
3790	3019	1	applied	\N	\N	\N	\N	71705	71705	239867
3790	3020	2	applied	\N	\N	\N	\N	71706	71706	239868
3790	3021	3	applied	\N	\N	\N	\N	71707	71707	239869
3792	3022	0	applied	\N	\N	\N	\N	71708	71708	239870
3794	3023	0	applied	\N	\N	\N	\N	71710	71710	239872
3797	3026	0	applied	\N	\N	\N	\N	71713	71713	239875
3805	3031	0	applied	\N	\N	\N	\N	71726	71726	239888
3805	3032	1	applied	\N	\N	\N	\N	71727	71727	239889
3805	3033	2	applied	\N	\N	\N	\N	71728	71728	239890
3807	3034	0	applied	\N	\N	\N	\N	71732	71732	239894
3812	3038	0	applied	\N	\N	\N	\N	71737	71737	239899
3812	3039	1	applied	\N	\N	\N	\N	71738	71738	239900
3817	3040	0	applied	\N	\N	\N	\N	71746	71746	239908
3821	3042	0	applied	\N	\N	\N	\N	71750	71750	239912
3824	3046	0	applied	\N	\N	\N	\N	71754	71754	239916
3824	3047	1	applied	\N	\N	\N	\N	71755	71755	239917
3826	2925	0	applied	\N	\N	\N	\N	71758	71758	239920
3826	2936	1	applied	\N	\N	\N	\N	71759	71759	239921
3826	2937	2	applied	\N	\N	\N	\N	71760	71760	239922
3826	2920	3	applied	\N	\N	\N	\N	71761	71761	239923
3826	2960	5	applied	\N	\N	\N	\N	71763	71763	239925
3826	2939	6	applied	\N	\N	\N	\N	71764	71764	239926
3826	2940	7	applied	\N	\N	\N	\N	71765	71765	239927
3826	2941	8	applied	\N	\N	\N	\N	71766	71766	239928
3826	2942	9	applied	\N	\N	\N	\N	71767	71767	239929
3826	2943	10	applied	\N	\N	\N	\N	71768	71768	239930
3826	2930	12	applied	\N	\N	1000000000	\N	71770	71770	239931
3826	2922	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	71769	71769	\N
3826	2933	13	applied	\N	\N	\N	\N	71771	71771	239932
3826	2944	14	applied	\N	\N	\N	\N	71772	71772	239933
3826	2945	15	applied	\N	\N	\N	\N	71773	71773	239934
3826	2946	16	applied	\N	\N	\N	\N	71774	71774	239935
3826	2948	17	applied	\N	\N	\N	\N	71775	71775	239936
3826	2949	18	applied	\N	\N	\N	\N	71776	71776	239937
3826	2950	19	applied	\N	\N	\N	\N	71777	71777	239938
3826	2951	20	applied	\N	\N	\N	\N	71778	71778	239939
3826	2952	21	applied	\N	\N	\N	\N	71779	71779	239940
3826	2953	22	applied	\N	\N	\N	\N	71780	71780	239941
3826	2954	23	applied	\N	\N	\N	\N	71781	71781	239942
3826	2955	24	applied	\N	\N	\N	\N	71782	71782	239943
3826	2958	26	applied	\N	\N	\N	\N	71784	71784	239945
3826	2959	27	applied	\N	\N	\N	\N	71785	71785	239946
3826	2961	28	applied	\N	\N	\N	\N	71786	71786	239947
3826	2963	29	applied	\N	\N	\N	\N	71787	71787	239948
3826	2964	30	applied	\N	\N	\N	\N	71788	71788	239949
3826	2965	31	applied	\N	\N	\N	\N	71789	71789	239950
3697	2958	0	applied	\N	\N	\N	\N	71565	71565	239727
3698	2958	0	applied	\N	\N	\N	\N	71566	71566	239728
3735	2982	0	applied	\N	\N	\N	\N	71625	71625	239787
3735	2983	1	applied	\N	\N	\N	\N	71626	71626	239788
3737	2984	0	applied	\N	\N	\N	\N	71629	71629	239791
3739	2984	0	applied	\N	\N	\N	\N	71631	71631	239793
3744	2986	0	applied	\N	\N	\N	\N	71637	71637	239799
3744	2987	1	applied	\N	\N	\N	\N	71638	71638	239800
3746	2988	0	applied	\N	\N	\N	\N	71641	71641	239803
3746	2989	1	applied	\N	\N	\N	\N	71642	71642	239804
3749	2991	0	applied	\N	\N	\N	\N	71646	71646	239808
3749	2992	1	applied	\N	\N	\N	\N	71647	71647	239809
3751	2993	0	applied	\N	\N	\N	\N	71650	71650	239812
3756	2996	0	applied	\N	\N	\N	\N	71655	71655	239817
3756	2997	1	applied	\N	\N	\N	\N	71656	71656	239818
3761	3001	0	applied	\N	\N	\N	\N	71664	71664	239826
3764	3003	0	applied	\N	\N	\N	\N	71667	71667	239829
3764	3004	1	applied	\N	\N	\N	\N	71668	71668	239830
3769	3008	1	applied	\N	\N	\N	\N	71678	71678	239840
3771	3009	0	applied	\N	\N	\N	\N	71680	71680	239842
3783	3013	0	applied	\N	\N	\N	\N	71689	71689	239851
3783	3014	1	applied	\N	\N	\N	\N	71690	71690	239852
3795	3024	0	applied	\N	\N	\N	\N	71711	71711	239873
3800	3028	0	applied	\N	\N	\N	\N	71716	71716	239878
3800	3029	1	applied	\N	\N	\N	\N	71717	71717	239879
3802	3028	0	applied	\N	\N	\N	\N	71720	71720	239882
3802	3029	1	applied	\N	\N	\N	\N	71721	71721	239883
3810	3037	0	applied	\N	\N	\N	\N	71735	71735	239897
3815	3038	0	applied	\N	\N	\N	\N	71743	71743	239905
3815	3039	1	applied	\N	\N	\N	\N	71744	71744	239906
3819	3041	0	applied	\N	\N	\N	\N	71748	71748	239910
3826	2966	32	applied	\N	\N	\N	\N	71790	71790	239951
3826	2967	33	applied	\N	\N	\N	\N	71791	71791	239952
3826	2968	34	applied	\N	\N	\N	\N	71792	71792	239953
3826	2970	36	applied	\N	\N	\N	\N	71794	71794	239955
3826	2971	37	applied	\N	\N	\N	\N	71795	71795	239956
3826	2972	38	applied	\N	\N	\N	\N	71796	71796	239957
3826	2973	39	applied	\N	\N	\N	\N	71797	71797	239958
3826	2974	40	applied	\N	\N	\N	\N	71798	71798	239959
3826	2975	41	applied	\N	\N	\N	\N	71799	71799	239960
3826	2976	42	applied	\N	\N	\N	\N	71800	71800	239961
3826	2977	43	applied	\N	\N	\N	\N	71801	71801	239962
3826	2978	44	applied	\N	\N	\N	\N	71802	71802	239963
3826	2979	45	applied	\N	\N	\N	\N	71803	71803	239964
3826	2980	46	applied	\N	\N	\N	\N	71804	71804	239965
3826	2981	47	applied	\N	\N	\N	\N	71805	71805	239966
3826	2982	48	applied	\N	\N	\N	\N	71806	71806	239967
3826	2983	49	applied	\N	\N	\N	\N	71807	71807	239968
3826	2984	50	applied	\N	\N	\N	\N	71808	71808	239969
3826	2985	51	applied	\N	\N	\N	\N	71809	71809	239970
3826	2988	53	applied	\N	\N	\N	\N	71811	71811	239972
3826	2989	54	applied	\N	\N	\N	\N	71812	71812	239973
3826	2990	55	applied	\N	\N	\N	\N	71813	71813	239974
3826	2991	56	applied	\N	\N	\N	\N	71814	71814	239975
3826	2992	57	applied	\N	\N	\N	\N	71815	71815	239976
3826	2993	58	applied	\N	\N	\N	\N	71816	71816	239977
3826	2994	59	applied	\N	\N	\N	\N	71817	71817	239978
3826	2995	60	applied	\N	\N	\N	\N	71818	71818	239979
3826	2996	61	applied	\N	\N	\N	\N	71819	71819	239980
3826	2997	62	applied	\N	\N	\N	\N	71820	71820	239981
3826	2998	63	applied	\N	\N	\N	\N	71821	71821	239982
3826	2999	64	applied	\N	\N	\N	\N	71822	71822	239983
3826	3000	65	applied	\N	\N	\N	\N	71823	71823	239984
3826	3001	66	applied	\N	\N	\N	\N	71824	71824	239985
3826	3002	67	applied	\N	\N	\N	\N	71825	71825	239986
3826	3003	68	applied	\N	\N	\N	\N	71826	71826	239987
3826	3005	70	applied	\N	\N	\N	\N	71828	71828	239989
3826	3006	71	applied	\N	\N	\N	\N	71829	71829	239990
3826	3007	72	applied	\N	\N	\N	\N	71830	71830	239991
3827	3050	0	applied	\N	\N	\N	\N	71869	71869	240030
3827	3051	1	applied	\N	\N	\N	\N	71870	71870	240031
3833	3060	0	applied	\N	\N	\N	\N	71881	71881	240042
3833	3061	1	applied	\N	\N	\N	\N	71882	71882	240043
3836	3065	0	applied	\N	\N	\N	\N	71886	71886	240047
3836	3066	1	applied	\N	\N	\N	\N	71887	71887	240048
3839	3068	0	applied	\N	\N	\N	\N	71890	71890	240051
3841	3069	0	applied	\N	\N	\N	\N	72016	72016	240177
3844	3070	0	applied	\N	\N	\N	\N	72021	72021	240182
3844	3071	1	applied	\N	\N	\N	\N	72022	72022	240183
3850	3073	0	applied	\N	\N	\N	\N	72031	72031	240192
3850	3074	1	applied	\N	\N	\N	\N	72032	72032	240193
3858	3081	0	applied	\N	\N	\N	\N	72047	72047	240208
3863	3084	0	applied	\N	\N	\N	\N	72052	72052	240213
3863	3085	1	applied	\N	\N	\N	\N	72053	72053	240214
3863	3086	2	applied	\N	\N	\N	\N	72054	72054	240215
3865	3084	0	applied	\N	\N	\N	\N	72058	72058	240219
3865	3085	1	applied	\N	\N	\N	\N	72059	72059	240220
3865	3086	2	applied	\N	\N	\N	\N	72060	72060	240221
3868	3088	0	applied	\N	\N	\N	\N	72064	72064	240225
3868	3089	1	applied	\N	\N	\N	\N	72065	72065	240226
3875	3094	0	applied	\N	\N	\N	\N	72072	72072	240233
3878	3095	0	applied	\N	\N	\N	\N	72075	72075	240236
3882	3098	0	applied	\N	\N	\N	\N	72079	72079	240240
3885	3101	0	applied	\N	\N	\N	\N	72084	72084	240245
3894	3105	0	applied	\N	\N	\N	\N	72091	72091	240252
3894	3106	1	applied	\N	\N	\N	\N	72092	72092	240253
3897	3107	0	applied	\N	\N	\N	\N	72096	72096	240257
3899	3108	0	applied	\N	\N	\N	\N	72098	72098	240259
3907	3114	0	applied	\N	\N	\N	\N	72109	72109	240270
3907	3115	1	applied	\N	\N	\N	\N	72110	72110	240271
3911	3117	0	applied	\N	\N	\N	\N	72114	72114	240275
3911	3118	1	applied	\N	\N	\N	\N	72115	72115	240276
3918	3120	0	applied	\N	\N	\N	\N	72119	72119	240280
3921	3121	0	applied	\N	\N	\N	\N	72122	72122	240283
3923	3123	0	applied	\N	\N	\N	\N	72124	72124	240285
3923	3124	1	applied	\N	\N	\N	\N	72125	72125	240286
3926	3123	0	applied	\N	\N	\N	\N	72130	72130	240291
3926	3124	1	applied	\N	\N	\N	\N	72131	72131	240292
3935	3131	0	applied	\N	\N	\N	\N	72205	72205	240366
3938	3134	0	applied	\N	\N	\N	\N	72208	72208	240369
3938	3135	1	applied	\N	\N	\N	\N	72209	72209	240370
3941	3138	0	applied	\N	\N	\N	\N	72212	72212	240373
3723	2976	0	applied	\N	\N	\N	\N	71613	71613	239775
3730	2980	0	applied	\N	\N	\N	\N	71620	71620	239782
3742	2985	0	applied	\N	\N	\N	\N	71634	71634	239796
3750	2991	0	applied	\N	\N	\N	\N	71648	71648	239810
3750	2992	1	applied	\N	\N	\N	\N	71649	71649	239811
3752	2987	0	applied	\N	\N	\N	\N	71651	71651	239813
3754	2994	0	applied	\N	\N	\N	\N	71653	71653	239815
3757	2998	0	applied	\N	\N	\N	\N	71657	71657	239819
3757	2999	1	applied	\N	\N	\N	\N	71658	71658	239820
3759	2933	0	applied	\N	\N	\N	\N	71661	71661	239823
3759	2987	1	applied	\N	\N	\N	\N	71662	71662	239824
3762	3002	0	applied	\N	\N	\N	\N	71665	71665	239827
3765	3005	0	applied	\N	\N	\N	\N	71669	71669	239831
3765	3006	1	applied	\N	\N	\N	\N	71670	71670	239832
3767	3005	0	applied	\N	\N	\N	\N	71673	71673	239835
3767	3006	1	applied	\N	\N	\N	\N	71674	71674	239836
3778	3011	0	applied	\N	\N	\N	\N	71683	71683	239845
3784	3013	0	applied	\N	\N	\N	\N	71691	71691	239853
3784	3014	1	applied	\N	\N	\N	\N	71692	71692	239854
3787	3015	0	applied	\N	\N	\N	\N	71697	71697	239859
3793	3022	0	applied	\N	\N	\N	\N	71709	71709	239871
3798	3026	0	applied	\N	\N	\N	\N	71714	71714	239876
3801	3028	0	applied	\N	\N	\N	\N	71718	71718	239880
3801	3029	1	applied	\N	\N	\N	\N	71719	71719	239881
3803	3030	0	applied	\N	\N	\N	\N	71722	71722	239884
3808	3035	0	applied	\N	\N	\N	\N	71733	71733	239895
3811	3037	0	applied	\N	\N	\N	\N	71736	71736	239898
3813	3038	0	applied	\N	\N	\N	\N	71739	71739	239901
3813	3039	1	applied	\N	\N	\N	\N	71740	71740	239902
3820	3041	0	applied	\N	\N	\N	\N	71749	71749	239911
3822	3043	0	applied	\N	\N	\N	\N	71751	71751	239913
3825	3048	0	applied	\N	\N	\N	\N	71756	71756	239918
3830	3054	0	applied	\N	\N	1000000000	\N	71873	71873	240034
3830	3055	1	applied	\N	\N	\N	\N	71874	71874	240035
3834	3062	0	applied	\N	\N	\N	\N	71883	71883	240044
3834	3063	1	applied	\N	\N	\N	\N	71884	71884	240045
3837	3067	0	applied	\N	\N	\N	\N	71888	71888	240049
3842	3070	0	applied	\N	\N	\N	\N	72017	72017	240178
3842	3071	1	applied	\N	\N	\N	\N	72018	72018	240179
3848	3072	0	applied	\N	\N	\N	\N	72028	72028	240189
3851	3073	0	applied	\N	\N	\N	\N	72033	72033	240194
3851	3074	1	applied	\N	\N	\N	\N	72034	72034	240195
3853	3075	0	applied	\N	\N	\N	\N	72036	72036	240197
3856	3077	0	applied	\N	\N	\N	\N	72042	72042	240203
3856	3078	1	applied	\N	\N	\N	\N	72043	72043	240204
3856	3079	2	applied	\N	\N	\N	\N	72044	72044	240205
3856	3080	3	applied	\N	\N	\N	\N	72045	72045	240206
3861	3083	0	applied	\N	\N	\N	\N	72050	72050	240211
3864	3085	1	applied	\N	\N	\N	\N	72056	72056	240217
3864	3086	2	applied	\N	\N	\N	\N	72057	72057	240218
3866	3087	0	applied	\N	\N	\N	\N	72061	72061	240222
3871	3091	0	applied	\N	\N	\N	\N	72068	72068	240229
3873	3092	0	applied	\N	\N	\N	\N	72070	72070	240231
3876	3094	0	applied	\N	\N	\N	\N	72073	72073	240234
3880	3096	0	applied	\N	\N	\N	\N	72077	72077	240238
3883	3099	0	applied	\N	\N	\N	\N	72080	72080	240241
3883	3100	1	applied	\N	\N	\N	\N	72081	72081	240242
3886	3101	0	applied	\N	\N	\N	\N	72085	72085	240246
3904	3111	0	applied	\N	\N	\N	\N	72104	72104	240265
3904	3112	1	applied	\N	\N	\N	\N	72105	72105	240266
3909	3116	0	applied	\N	\N	\N	\N	72113	72113	240274
3912	3117	0	applied	\N	\N	\N	\N	72116	72116	240277
3912	3118	1	applied	\N	\N	\N	\N	72117	72117	240278
3919	3120	0	applied	\N	\N	\N	\N	72120	72120	240281
3931	3128	0	applied	\N	\N	\N	\N	72199	72199	240360
3931	3129	1	applied	\N	\N	\N	\N	72200	72200	240361
3933	3130	0	applied	\N	\N	\N	\N	72203	72203	240364
3939	3136	0	applied	\N	\N	\N	\N	72210	72210	240371
3939	3137	1	applied	\N	\N	\N	\N	72211	72211	240372
3943	3139	0	applied	\N	\N	\N	\N	72214	72214	240375
3943	3140	1	applied	\N	\N	\N	\N	72215	72215	240376
3946	3144	0	applied	\N	\N	\N	\N	72221	72221	240382
3946	3145	1	applied	\N	\N	\N	\N	72222	72222	240383
3946	3146	2	applied	\N	\N	\N	\N	72223	72223	240384
3946	3147	3	applied	\N	\N	\N	\N	72224	72224	240385
3946	3148	4	applied	\N	\N	\N	\N	72225	72225	240386
3949	3151	0	applied	\N	\N	\N	\N	72228	72228	240389
3949	3152	1	applied	\N	\N	\N	\N	72229	72229	240390
3949	3153	2	applied	\N	\N	\N	\N	72230	72230	240391
3950	3154	0	applied	\N	\N	\N	\N	72231	72231	240392
3954	3157	0	applied	\N	\N	\N	\N	72235	72235	240396
3955	3157	0	applied	\N	\N	\N	\N	72236	72236	240397
3957	3158	0	applied	\N	\N	\N	\N	72238	72238	240399
3959	3160	0	applied	\N	\N	\N	\N	72240	72240	240401
3961	3160	0	applied	\N	\N	\N	\N	72242	72242	240403
3963	3161	0	applied	\N	\N	\N	\N	72244	72244	240405
3965	3161	0	applied	\N	\N	\N	\N	72246	72246	240407
3968	3164	0	applied	\N	\N	\N	\N	72255	72255	240416
3970	3165	0	applied	\N	\N	\N	\N	72257	72257	240418
3973	3166	0	applied	\N	\N	\N	\N	72260	72260	240421
3977	3167	0	applied	\N	\N	\N	\N	72264	72264	240425
3982	3171	0	applied	\N	\N	\N	\N	72270	72270	240431
3985	3172	0	applied	\N	\N	\N	\N	72274	72274	240435
3985	3173	1	applied	\N	\N	\N	\N	72275	72275	240436
3987	3175	0	applied	\N	\N	\N	\N	72277	72277	240438
3989	3176	0	applied	\N	\N	\N	\N	72279	72279	240440
4001	3181	0	applied	\N	\N	\N	\N	72292	72292	240453
4005	3183	0	applied	\N	\N	\N	\N	72296	72296	240457
4008	3187	0	applied	\N	\N	\N	\N	72300	72300	240461
4022	3196	0	applied	\N	\N	\N	\N	72319	72319	240480
4022	3197	1	applied	\N	\N	\N	\N	72320	72320	240481
4025	3200	0	applied	\N	\N	\N	\N	72323	72323	240484
4027	3201	0	applied	\N	\N	\N	\N	72325	72325	240486
4034	3205	0	applied	\N	\N	\N	\N	72332	72332	240493
4042	3211	0	applied	\N	\N	\N	\N	72343	72343	240504
4042	3212	1	applied	\N	\N	\N	\N	72344	72344	240505
4047	3215	0	applied	\N	\N	\N	\N	72349	72349	240510
4047	3216	1	applied	\N	\N	\N	\N	72350	72350	240511
4047	3217	2	applied	\N	\N	\N	\N	72351	72351	240512
4053	3222	0	applied	\N	\N	\N	\N	72358	72358	240519
4053	3223	1	applied	\N	\N	\N	\N	72359	72359	240520
4063	3230	0	applied	\N	\N	\N	\N	72375	72375	240536
3740	2985	0	applied	\N	\N	\N	\N	71632	71632	239794
3743	2987	1	applied	\N	\N	\N	\N	71636	71636	239798
3745	2986	0	applied	\N	\N	\N	\N	71639	71639	239801
3745	2987	1	applied	\N	\N	\N	\N	71640	71640	239802
3748	2990	0	applied	\N	\N	\N	\N	71645	71645	239807
3753	2994	0	applied	\N	\N	\N	\N	71652	71652	239814
3755	2995	0	applied	\N	\N	\N	\N	71654	71654	239816
3758	2998	0	applied	\N	\N	\N	\N	71659	71659	239821
3758	2999	1	applied	\N	\N	\N	\N	71660	71660	239822
3763	3002	0	applied	\N	\N	\N	\N	71666	71666	239828
3766	3005	0	applied	\N	\N	\N	\N	71671	71671	239833
3766	3006	1	applied	\N	\N	\N	\N	71672	71672	239834
3770	3009	0	applied	\N	\N	\N	\N	71679	71679	239841
3779	3012	0	applied	\N	\N	\N	\N	71684	71684	239846
3788	3016	0	applied	\N	\N	\N	\N	71698	71698	239860
3788	3017	1	applied	\N	\N	\N	\N	71699	71699	239861
3789	3018	0	applied	\N	\N	\N	\N	71700	71700	239862
3789	3019	1	applied	\N	\N	\N	\N	71701	71701	239863
3789	3020	2	applied	\N	\N	\N	\N	71702	71702	239864
3789	3021	3	applied	\N	\N	\N	\N	71703	71703	239865
3796	3025	0	applied	\N	\N	\N	\N	71712	71712	239874
3804	3031	0	applied	\N	\N	\N	\N	71723	71723	239885
3804	3032	1	applied	\N	\N	\N	\N	71724	71724	239886
3804	3033	2	applied	\N	\N	\N	\N	71725	71725	239887
3806	3031	0	applied	\N	\N	\N	\N	71729	71729	239891
3806	3032	1	applied	\N	\N	\N	\N	71730	71730	239892
3806	3033	2	applied	\N	\N	\N	\N	71731	71731	239893
3809	3036	0	applied	\N	\N	\N	\N	71734	71734	239896
3814	3038	0	applied	\N	\N	\N	\N	71741	71741	239903
3814	3039	1	applied	\N	\N	\N	\N	71742	71742	239904
3818	3040	0	applied	\N	\N	\N	\N	71747	71747	239909
3823	3044	0	applied	\N	\N	\N	\N	71752	71752	239914
3823	3045	1	applied	\N	\N	\N	\N	71753	71753	239915
3828	3052	0	applied	\N	\N	\N	\N	71871	71871	240032
3840	3054	0	applied	\N	\N	1000000000	\N	71891	71891	240052
3840	3050	1	applied	\N	\N	\N	\N	71892	71892	240053
3840	2933	2	applied	\N	\N	\N	\N	71893	71893	240054
3840	2936	3	applied	\N	\N	\N	\N	71894	71894	240055
3840	2937	4	applied	\N	\N	\N	\N	71895	71895	240056
3840	2935	5	applied	\N	\N	1000000000	\N	71896	71896	240057
3840	2960	6	applied	\N	\N	\N	\N	71897	71897	240058
3840	2939	7	applied	\N	\N	\N	\N	71898	71898	240059
3840	2940	8	applied	\N	\N	\N	\N	71899	71899	240060
3840	2941	9	applied	\N	\N	\N	\N	71900	71900	240061
3840	2942	10	applied	\N	\N	\N	\N	71901	71901	240062
3840	2943	11	applied	\N	\N	\N	\N	71902	71902	240063
3840	2945	13	applied	\N	\N	\N	\N	71904	71904	240065
3840	2946	14	applied	\N	\N	\N	\N	71905	71905	240066
3840	2948	15	applied	\N	\N	\N	\N	71906	71906	240067
3840	2949	16	applied	\N	\N	\N	\N	71907	71907	240068
3840	2950	17	applied	\N	\N	\N	\N	71908	71908	240069
3840	2951	18	applied	\N	\N	\N	\N	71909	71909	240070
3840	2952	19	applied	\N	\N	\N	\N	71910	71910	240071
3840	2953	20	applied	\N	\N	\N	\N	71911	71911	240072
3840	2954	21	applied	\N	\N	\N	\N	71912	71912	240073
3840	2955	22	applied	\N	\N	\N	\N	71913	71913	240074
3840	2956	23	applied	\N	\N	\N	\N	71914	71914	240075
3840	2958	24	applied	\N	\N	\N	\N	71915	71915	240076
3840	2959	25	applied	\N	\N	\N	\N	71916	71916	240077
3840	2961	26	applied	\N	\N	\N	\N	71917	71917	240078
3840	2963	27	applied	\N	\N	\N	\N	71918	71918	240079
3840	2964	28	applied	\N	\N	\N	\N	71919	71919	240080
3840	2966	30	applied	\N	\N	\N	\N	71921	71921	240082
3840	2967	31	applied	\N	\N	\N	\N	71922	71922	240083
3840	2968	32	applied	\N	\N	\N	\N	71923	71923	240084
3840	2969	33	applied	\N	\N	\N	\N	71924	71924	240085
3840	2970	34	applied	\N	\N	\N	\N	71925	71925	240086
3840	2971	35	applied	\N	\N	\N	\N	71926	71926	240087
3840	2972	36	applied	\N	\N	\N	\N	71927	71927	240088
3840	2973	37	applied	\N	\N	\N	\N	71928	71928	240089
3840	2974	38	applied	\N	\N	\N	\N	71929	71929	240090
3840	2975	39	applied	\N	\N	\N	\N	71930	71930	240091
3960	3160	0	applied	\N	\N	\N	\N	72241	72241	240402
3975	3166	0	applied	\N	\N	\N	\N	72262	72262	240423
3978	3168	0	applied	\N	\N	\N	\N	72265	72265	240426
3978	3169	1	applied	\N	\N	\N	\N	72266	72266	240427
3980	3170	0	applied	\N	\N	\N	\N	72268	72268	240429
3990	3176	0	applied	\N	\N	\N	\N	72280	72280	240441
3994	3177	0	applied	\N	\N	\N	\N	72284	72284	240445
3999	3181	0	applied	\N	\N	\N	\N	72290	72290	240451
4003	3182	0	applied	\N	\N	\N	\N	72294	72294	240455
4006	3184	0	applied	\N	\N	\N	\N	72297	72297	240458
4006	3185	1	applied	\N	\N	\N	\N	72298	72298	240459
4011	3188	0	applied	\N	\N	\N	\N	72302	72302	240463
4011	3189	1	applied	\N	\N	\N	\N	72303	72303	240464
4013	3188	0	applied	\N	\N	\N	\N	72306	72306	240467
4013	3189	1	applied	\N	\N	\N	\N	72307	72307	240468
4015	3190	0	applied	\N	\N	\N	\N	72310	72310	240471
4017	3190	0	applied	\N	\N	\N	\N	72312	72312	240473
4020	3192	0	applied	\N	\N	\N	\N	72315	72315	240476
4020	3193	1	applied	\N	\N	\N	\N	72316	72316	240477
4023	3198	0	applied	\N	\N	\N	\N	72321	72321	240482
4030	3203	0	applied	\N	\N	\N	\N	72328	72328	240489
4032	3203	0	applied	\N	\N	\N	\N	72330	72330	240491
4039	3207	0	applied	\N	\N	\N	\N	72336	72336	240497
4040	3208	0	applied	\N	\N	\N	\N	72337	72337	240498
4040	3209	1	applied	\N	\N	\N	\N	72338	72338	240499
4040	3210	2	applied	\N	\N	\N	\N	72339	72339	240500
4045	3214	0	applied	\N	\N	\N	\N	72347	72347	240508
4048	3218	0	applied	\N	\N	\N	\N	72352	72352	240513
4054	3222	0	applied	\N	\N	\N	\N	72360	72360	240521
4054	3223	1	applied	\N	\N	\N	\N	72361	72361	240522
4055	3222	0	applied	\N	\N	\N	\N	72362	72362	240523
4055	3223	1	applied	\N	\N	\N	\N	72363	72363	240524
4059	3228	0	applied	\N	\N	\N	\N	72369	72369	240530
4065	3233	0	applied	\N	\N	\N	\N	72379	72379	240540
4068	3235	0	applied	\N	\N	\N	\N	72382	72382	240543
4069	3236	0	applied	\N	\N	\N	\N	72383	72383	240544
4069	3237	1	applied	\N	\N	\N	\N	72384	72384	240545
4077	3241	0	applied	\N	\N	\N	\N	72392	72392	240553
3734	2981	0	applied	\N	\N	\N	\N	71624	71624	239786
3743	2986	0	applied	\N	\N	\N	\N	71635	71635	239797
3826	3012	77	applied	\N	\N	\N	\N	71835	71835	239996
3826	3013	78	applied	\N	\N	\N	\N	71836	71836	239997
3826	3014	79	applied	\N	\N	\N	\N	71837	71837	239998
3826	3015	80	applied	\N	\N	\N	\N	71838	71838	239999
3826	3016	82	applied	\N	\N	\N	\N	71839	71839	240000
3826	3017	83	applied	\N	\N	\N	\N	71840	71840	240001
3826	3018	84	applied	\N	\N	\N	\N	71841	71841	240002
3826	3019	85	applied	\N	\N	\N	\N	71842	71842	240003
3826	3020	86	applied	\N	\N	\N	\N	71843	71843	240004
3826	3021	87	applied	\N	\N	\N	\N	71844	71844	240005
3826	3022	88	applied	\N	\N	\N	\N	71845	71845	240006
3826	3023	89	applied	\N	\N	\N	\N	71846	71846	240007
3826	3024	90	applied	\N	\N	\N	\N	71847	71847	240008
3826	3025	91	applied	\N	\N	\N	\N	71848	71848	240009
3826	3027	93	applied	\N	\N	\N	\N	71850	71850	240011
3826	3028	94	applied	\N	\N	\N	\N	71851	71851	240012
3826	3029	95	applied	\N	\N	\N	\N	71852	71852	240013
3826	3030	96	applied	\N	\N	\N	\N	71853	71853	240014
3826	3031	97	applied	\N	\N	\N	\N	71854	71854	240015
3826	3032	98	applied	\N	\N	\N	\N	71855	71855	240016
3826	3033	99	applied	\N	\N	\N	\N	71856	71856	240017
3826	3034	100	applied	\N	\N	\N	\N	71857	71857	240018
3826	3035	101	applied	\N	\N	\N	\N	71858	71858	240019
3826	3036	102	applied	\N	\N	\N	\N	71859	71859	240020
3826	3037	103	applied	\N	\N	\N	\N	71860	71860	240021
3826	3038	104	applied	\N	\N	\N	\N	71861	71861	240022
3826	3039	105	applied	\N	\N	\N	\N	71862	71862	240023
3826	3040	106	applied	\N	\N	\N	\N	71863	71863	240024
3826	3041	107	applied	\N	\N	\N	\N	71864	71864	240025
3826	3042	108	applied	\N	\N	\N	\N	71865	71865	240026
3826	3044	110	applied	\N	\N	\N	\N	71867	71867	240028
3826	3045	111	applied	\N	\N	\N	\N	71868	71868	240029
3829	3053	0	applied	\N	\N	\N	\N	71872	71872	240033
3831	3054	0	applied	\N	\N	1000000000	\N	71875	71875	240036
3831	3055	1	applied	\N	\N	\N	\N	71876	71876	240037
3832	3056	0	applied	\N	\N	\N	\N	71877	71877	240038
3832	3057	1	applied	\N	\N	\N	\N	71878	71878	240039
3832	3058	2	applied	\N	\N	\N	\N	71879	71879	240040
3832	3059	3	applied	\N	\N	\N	\N	71880	71880	240041
3835	3064	0	applied	\N	\N	\N	\N	71885	71885	240046
3838	3068	0	applied	\N	\N	\N	\N	71889	71889	240050
3840	2976	40	applied	\N	\N	\N	\N	71931	71931	240092
3840	2977	41	applied	\N	\N	\N	\N	71932	71932	240093
3840	2978	42	applied	\N	\N	\N	\N	71933	71933	240094
3840	2979	43	applied	\N	\N	\N	\N	71934	71934	240095
3840	2980	44	applied	\N	\N	\N	\N	71935	71935	240096
3840	2982	46	applied	\N	\N	\N	\N	71937	71937	240098
3840	2983	47	applied	\N	\N	\N	\N	71938	71938	240099
3840	2984	48	applied	\N	\N	\N	\N	71939	71939	240100
3840	2985	49	applied	\N	\N	\N	\N	71940	71940	240101
3840	2986	50	applied	\N	\N	\N	\N	71941	71941	240102
3840	2988	51	applied	\N	\N	\N	\N	71942	71942	240103
3840	2989	52	applied	\N	\N	\N	\N	71943	71943	240104
3840	2990	53	applied	\N	\N	\N	\N	71944	71944	240105
3840	2991	54	applied	\N	\N	\N	\N	71945	71945	240106
3840	2992	55	applied	\N	\N	\N	\N	71946	71946	240107
3840	2993	56	applied	\N	\N	\N	\N	71947	71947	240108
3840	2994	57	applied	\N	\N	\N	\N	71948	71948	240109
3840	2995	58	applied	\N	\N	\N	\N	71949	71949	240110
3840	2996	59	applied	\N	\N	\N	\N	71950	71950	240111
3840	2997	60	applied	\N	\N	\N	\N	71951	71951	240112
3840	2998	61	applied	\N	\N	\N	\N	71952	71952	240113
3840	3000	63	applied	\N	\N	\N	\N	71954	71954	240115
3840	3001	64	applied	\N	\N	\N	\N	71955	71955	240116
3840	3002	65	applied	\N	\N	\N	\N	71956	71956	240117
3840	3003	66	applied	\N	\N	\N	\N	71957	71957	240118
3840	3004	67	applied	\N	\N	\N	\N	71958	71958	240119
3840	3005	68	applied	\N	\N	\N	\N	71959	71959	240120
3840	3006	69	applied	\N	\N	\N	\N	71960	71960	240121
3840	3007	70	applied	\N	\N	\N	\N	71961	71961	240122
3840	3008	71	applied	\N	\N	\N	\N	71962	71962	240123
3840	3009	72	applied	\N	\N	\N	\N	71963	71963	240124
3840	3010	73	applied	\N	\N	\N	\N	71964	71964	240125
3840	3011	74	applied	\N	\N	\N	\N	71965	71965	240126
3840	3012	75	applied	\N	\N	\N	\N	71966	71966	240127
3840	3013	76	applied	\N	\N	\N	\N	71967	71967	240128
3840	3014	77	applied	\N	\N	\N	\N	71968	71968	240129
3840	3015	78	applied	\N	\N	\N	\N	71969	71969	240130
3840	3017	80	applied	\N	\N	\N	\N	71971	71971	240132
3846	3070	0	applied	\N	\N	\N	\N	72025	72025	240186
3846	3071	1	applied	\N	\N	\N	\N	72026	72026	240187
3847	3072	0	applied	\N	\N	\N	\N	72027	72027	240188
3852	3075	0	applied	\N	\N	\N	\N	72035	72035	240196
3854	3076	0	applied	\N	\N	\N	\N	72037	72037	240198
3855	3077	0	applied	\N	\N	\N	\N	72038	72038	240199
3855	3078	1	applied	\N	\N	\N	\N	72039	72039	240200
3855	3079	2	applied	\N	\N	\N	\N	72040	72040	240201
3855	3080	3	applied	\N	\N	\N	\N	72041	72041	240202
3862	3083	0	applied	\N	\N	\N	\N	72051	72051	240212
3870	3091	0	applied	\N	\N	\N	\N	72067	72067	240228
3872	3091	0	applied	\N	\N	\N	\N	72069	72069	240230
3877	3095	0	applied	\N	\N	\N	\N	72074	72074	240235
3879	3095	0	applied	\N	\N	\N	\N	72076	72076	240237
3884	3099	0	applied	\N	\N	\N	\N	72082	72082	240243
3887	3102	0	applied	\N	\N	\N	\N	72086	72086	240247
3887	3103	1	applied	\N	\N	\N	\N	72087	72087	240248
3889	3102	0	applied	\N	\N	\N	\N	72088	72088	240249
3889	3103	1	applied	\N	\N	\N	\N	72089	72089	240250
3893	3104	0	applied	\N	\N	\N	\N	72090	72090	240251
3896	3107	0	applied	\N	\N	\N	\N	72095	72095	240256
3898	3108	0	applied	\N	\N	\N	\N	72097	72097	240258
3903	3111	0	applied	\N	\N	\N	\N	72102	72102	240263
3903	3112	1	applied	\N	\N	\N	\N	72103	72103	240264
3906	3114	0	applied	\N	\N	\N	\N	72107	72107	240268
3906	3115	1	applied	\N	\N	\N	\N	72108	72108	240269
3920	3121	0	applied	\N	\N	\N	\N	72121	72121	240282
3922	3122	0	applied	\N	\N	\N	\N	72123	72123	240284
3925	3123	0	applied	\N	\N	\N	\N	72128	72128	240289
3925	3124	1	applied	\N	\N	\N	\N	72129	72129	240290
3927	3067	0	applied	\N	\N	\N	\N	72132	72132	240293
3826	3011	76	applied	\N	\N	\N	\N	71834	71834	239995
3840	3022	86	applied	\N	\N	\N	\N	71976	71976	240137
3840	3023	87	applied	\N	\N	\N	\N	71977	71977	240138
3840	3024	88	applied	\N	\N	\N	\N	71978	71978	240139
3840	3025	89	applied	\N	\N	\N	\N	71979	71979	240140
3840	3026	90	applied	\N	\N	\N	\N	71980	71980	240141
3840	3027	91	applied	\N	\N	\N	\N	71981	71981	240142
3840	3028	92	applied	\N	\N	\N	\N	71982	71982	240143
3840	3029	93	applied	\N	\N	\N	\N	71983	71983	240144
3840	3030	94	applied	\N	\N	\N	\N	71984	71984	240145
3840	3031	95	applied	\N	\N	\N	\N	71985	71985	240146
3840	3032	96	applied	\N	\N	\N	\N	71986	71986	240147
3840	3033	97	applied	\N	\N	\N	\N	71987	71987	240148
3840	3034	98	applied	\N	\N	\N	\N	71988	71988	240149
3840	3035	99	applied	\N	\N	\N	\N	71989	71989	240150
3840	3037	101	applied	\N	\N	\N	\N	71991	71991	240152
3840	3038	102	applied	\N	\N	\N	\N	71992	71992	240153
3840	3039	103	applied	\N	\N	\N	\N	71993	71993	240154
3840	3040	104	applied	\N	\N	\N	\N	71994	71994	240155
3840	3041	105	applied	\N	\N	\N	\N	71995	71995	240156
3840	3042	106	applied	\N	\N	\N	\N	71996	71996	240157
3840	3043	107	applied	\N	\N	\N	\N	71997	71997	240158
3840	3044	108	applied	\N	\N	\N	\N	71998	71998	240159
3840	3045	109	applied	\N	\N	\N	\N	71999	71999	240160
3840	3047	110	applied	\N	\N	\N	\N	72000	72000	240161
3840	3049	111	applied	\N	\N	\N	\N	72001	72001	240162
3840	3051	112	applied	\N	\N	\N	\N	72002	72002	240163
3840	3052	113	applied	\N	\N	\N	\N	72003	72003	240164
3840	3053	114	applied	\N	\N	\N	\N	72004	72004	240165
3840	3055	115	applied	\N	\N	\N	\N	72005	72005	240166
3840	3057	116	applied	\N	\N	\N	\N	72006	72006	240167
3840	3059	118	applied	\N	\N	\N	\N	72008	72008	240169
3840	3060	119	applied	\N	\N	\N	\N	72009	72009	240170
3840	3061	120	applied	\N	\N	\N	\N	72010	72010	240171
3840	3062	121	applied	\N	\N	\N	\N	72011	72011	240172
3840	3063	122	applied	\N	\N	\N	\N	72012	72012	240173
3840	3064	123	applied	\N	\N	\N	\N	72013	72013	240174
3840	3065	124	applied	\N	\N	\N	\N	72014	72014	240175
3840	3066	125	applied	\N	\N	\N	\N	72015	72015	240176
3843	3070	0	applied	\N	\N	\N	\N	72019	72019	240180
3843	3071	1	applied	\N	\N	\N	\N	72020	72020	240181
3845	3070	0	applied	\N	\N	\N	\N	72023	72023	240184
3845	3071	1	applied	\N	\N	\N	\N	72024	72024	240185
3849	3073	0	applied	\N	\N	\N	\N	72029	72029	240190
3849	3074	1	applied	\N	\N	\N	\N	72030	72030	240191
3857	3081	0	applied	\N	\N	\N	\N	72046	72046	240207
3859	3081	0	applied	\N	\N	\N	\N	72048	72048	240209
3867	3089	1	applied	\N	\N	\N	\N	72063	72063	240224
3869	3090	0	applied	\N	\N	\N	\N	72066	72066	240227
3874	3093	0	applied	\N	\N	\N	\N	72071	72071	240232
3881	3097	0	applied	\N	\N	\N	\N	72078	72078	240239
3895	3105	0	applied	\N	\N	\N	\N	72093	72093	240254
3895	3106	1	applied	\N	\N	\N	\N	72094	72094	240255
3900	3109	0	applied	\N	\N	\N	\N	72099	72099	240260
3902	3110	0	applied	\N	\N	\N	\N	72101	72101	240262
3905	3113	0	applied	\N	\N	\N	\N	72106	72106	240267
3908	3114	0	applied	\N	\N	\N	\N	72111	72111	240272
3908	3115	1	applied	\N	\N	\N	\N	72112	72112	240273
3917	3119	0	applied	\N	\N	\N	\N	72118	72118	240279
3924	3123	0	applied	\N	\N	\N	\N	72126	72126	240287
3924	3124	1	applied	\N	\N	\N	\N	72127	72127	240288
3927	3068	1	applied	\N	\N	\N	\N	72133	72133	240294
3927	3069	2	applied	\N	\N	\N	\N	72134	72134	240295
3927	3071	4	applied	\N	\N	\N	\N	72136	72136	240297
3927	3072	5	applied	\N	\N	\N	\N	72137	72137	240298
3927	3073	6	applied	\N	\N	\N	\N	72138	72138	240299
3927	3074	7	applied	\N	\N	\N	\N	72139	72139	240300
3927	3075	8	applied	\N	\N	\N	\N	72140	72140	240301
3927	3076	9	applied	\N	\N	\N	\N	72141	72141	240302
3927	3077	10	applied	\N	\N	\N	\N	72142	72142	240303
3927	3078	11	applied	\N	\N	\N	\N	72143	72143	240304
3927	3079	12	applied	\N	\N	\N	\N	72144	72144	240305
3927	3080	13	applied	\N	\N	\N	\N	72145	72145	240306
3927	3081	14	applied	\N	\N	\N	\N	72146	72146	240307
3927	3082	15	applied	\N	\N	\N	\N	72147	72147	240308
3927	3083	16	applied	\N	\N	\N	\N	72148	72148	240309
3927	3084	17	applied	\N	\N	\N	\N	72149	72149	240310
3927	3085	18	applied	\N	\N	\N	\N	72150	72150	240311
3927	3086	19	applied	\N	\N	\N	\N	72151	72151	240312
3927	3088	21	applied	\N	\N	\N	\N	72153	72153	240314
3927	3089	22	applied	\N	\N	\N	\N	72154	72154	240315
3927	3090	23	applied	\N	\N	\N	\N	72155	72155	240316
3927	3091	24	applied	\N	\N	\N	\N	72156	72156	240317
3927	3092	25	applied	\N	\N	\N	\N	72157	72157	240318
3927	3093	26	applied	\N	\N	\N	\N	72158	72158	240319
3927	3094	27	applied	\N	\N	\N	\N	72159	72159	240320
3927	3095	28	applied	\N	\N	\N	\N	72160	72160	240321
3927	3096	29	applied	\N	\N	\N	\N	72161	72161	240322
3927	3097	30	applied	\N	\N	\N	\N	72162	72162	240323
3927	3098	31	applied	\N	\N	\N	\N	72163	72163	240324
3927	3099	32	applied	\N	\N	\N	\N	72164	72164	240325
3927	3100	33	applied	\N	\N	\N	\N	72165	72165	240326
3927	3101	34	applied	\N	\N	\N	\N	72166	72166	240327
3927	3102	35	applied	\N	\N	\N	\N	72167	72167	240328
3927	3103	36	applied	\N	\N	\N	\N	72168	72168	240329
3927	3105	38	applied	\N	\N	\N	\N	72170	72170	240331
3927	3106	39	applied	\N	\N	\N	\N	72171	72171	240332
3927	3107	40	applied	\N	\N	\N	\N	72172	72172	240333
3927	3108	41	applied	\N	\N	\N	\N	72173	72173	240334
3929	3126	0	applied	\N	\N	\N	\N	72195	72195	240356
3929	3127	1	applied	\N	\N	\N	\N	72196	72196	240357
3934	3131	0	applied	\N	\N	\N	\N	72204	72204	240365
3936	3132	0	applied	\N	\N	\N	\N	72206	72206	240367
3944	3139	0	applied	\N	\N	\N	\N	72216	72216	240377
3944	3140	1	applied	\N	\N	\N	\N	72217	72217	240378
3947	3149	0	applied	\N	\N	\N	\N	72226	72226	240387
3953	3156	0	applied	\N	\N	\N	\N	72234	72234	240395
3956	3157	0	applied	\N	\N	\N	\N	72237	72237	240398
3962	3161	0	applied	\N	\N	\N	\N	72243	72243	240404
3964	3161	0	applied	\N	\N	\N	\N	72245	72245	240406
3840	3020	84	applied	\N	\N	\N	\N	71974	71974	240135
3840	3021	85	applied	\N	\N	\N	\N	71975	71975	240136
3927	3113	46	applied	\N	\N	\N	\N	72178	72178	240339
3927	3114	47	applied	\N	\N	\N	\N	72179	72179	240340
3927	3115	48	applied	\N	\N	\N	\N	72180	72180	240341
3927	3116	49	applied	\N	\N	\N	\N	72181	72181	240342
3927	3117	50	applied	\N	\N	\N	\N	72182	72182	240343
3927	3118	51	applied	\N	\N	\N	\N	72183	72183	240344
3927	3119	52	applied	\N	\N	\N	\N	72184	72184	240345
3927	3120	53	applied	\N	\N	\N	\N	72185	72185	240346
3927	3121	54	applied	\N	\N	\N	\N	72186	72186	240347
3927	3122	55	applied	\N	\N	\N	\N	72187	72187	240348
3927	3123	56	applied	\N	\N	\N	\N	72188	72188	240349
3927	3124	57	applied	\N	\N	\N	\N	72189	72189	240350
3927	2987	58	applied	\N	\N	\N	\N	72190	72190	240351
3927	2957	60	applied	\N	\N	\N	\N	72192	72192	240353
3927	2962	61	applied	\N	\N	\N	\N	72193	72193	240354
3930	3128	0	applied	\N	\N	\N	\N	72197	72197	240358
3930	3129	1	applied	\N	\N	\N	\N	72198	72198	240359
3932	3128	0	applied	\N	\N	\N	\N	72201	72201	240362
3932	3129	1	applied	\N	\N	\N	\N	72202	72202	240363
3937	3133	0	applied	\N	\N	\N	\N	72207	72207	240368
3942	3138	0	applied	\N	\N	\N	\N	72213	72213	240374
3945	3141	0	applied	\N	\N	\N	\N	72218	72218	240379
3945	3142	1	applied	\N	\N	\N	\N	72219	72219	240380
3945	3143	2	applied	\N	\N	\N	\N	72220	72220	240381
3948	3150	0	applied	\N	\N	\N	\N	72227	72227	240388
3951	3155	0	applied	\N	\N	\N	\N	72232	72232	240393
3958	3159	0	applied	\N	\N	\N	\N	72239	72239	240400
3966	3143	1	applied	\N	\N	\N	\N	72248	72248	240409
3966	3145	2	applied	\N	\N	\N	\N	72249	72249	240410
3966	3146	3	applied	\N	\N	\N	\N	72250	72250	240411
3966	3147	4	applied	\N	\N	\N	\N	72251	72251	240412
3966	3148	5	applied	\N	\N	\N	\N	72252	72252	240413
3967	3163	1	applied	\N	\N	\N	\N	72254	72254	240415
3969	3164	0	applied	\N	\N	\N	\N	72256	72256	240417
3971	3165	0	applied	\N	\N	\N	\N	72258	72258	240419
3972	3166	0	applied	\N	\N	\N	\N	72259	72259	240420
3974	3166	0	applied	\N	\N	\N	\N	72261	72261	240422
3976	3167	0	applied	\N	\N	\N	\N	72263	72263	240424
3979	3170	0	applied	\N	\N	\N	\N	72267	72267	240428
3981	3171	0	applied	\N	\N	\N	\N	72269	72269	240430
3983	3171	0	applied	\N	\N	\N	\N	72271	72271	240432
3984	3172	0	applied	\N	\N	\N	\N	72272	72272	240433
3984	3173	1	applied	\N	\N	\N	\N	72273	72273	240434
3986	3174	0	applied	\N	\N	\N	\N	72276	72276	240437
3988	3175	0	applied	\N	\N	\N	\N	72278	72278	240439
3991	3176	0	applied	\N	\N	\N	\N	72281	72281	240442
3993	3176	0	applied	\N	\N	\N	\N	72283	72283	240444
3995	3178	0	applied	\N	\N	\N	\N	72285	72285	240446
3998	3179	0	applied	\N	\N	\N	\N	72288	72288	240449
3998	3180	1	applied	\N	\N	\N	\N	72289	72289	240450
4000	3181	0	applied	\N	\N	\N	\N	72291	72291	240452
4002	3182	0	applied	\N	\N	\N	\N	72293	72293	240454
4004	3183	0	applied	\N	\N	\N	\N	72295	72295	240456
4007	3186	0	applied	\N	\N	\N	\N	72299	72299	240460
4009	3187	0	applied	\N	\N	\N	\N	72301	72301	240462
4012	3188	0	applied	\N	\N	\N	\N	72304	72304	240465
4012	3189	1	applied	\N	\N	\N	\N	72305	72305	240466
4014	3188	0	applied	\N	\N	\N	\N	72308	72308	240469
4014	3189	1	applied	\N	\N	\N	\N	72309	72309	240470
4016	3190	0	applied	\N	\N	\N	\N	72311	72311	240472
4018	3191	0	applied	\N	\N	\N	\N	72313	72313	240474
4019	3191	0	applied	\N	\N	\N	\N	72314	72314	240475
4021	3194	0	applied	\N	\N	\N	\N	72317	72317	240478
4021	3195	1	applied	\N	\N	\N	\N	72318	72318	240479
4026	3201	0	applied	\N	\N	\N	\N	72324	72324	240485
4028	3201	0	applied	\N	\N	\N	\N	72326	72326	240487
4029	3202	0	applied	\N	\N	\N	\N	72327	72327	240488
4031	3203	0	applied	\N	\N	\N	\N	72329	72329	240490
4033	3204	0	applied	\N	\N	\N	\N	72331	72331	240492
4036	3205	0	applied	\N	\N	\N	\N	72334	72334	240495
4038	3206	0	applied	\N	\N	\N	\N	72335	72335	240496
4041	3208	0	applied	\N	\N	\N	\N	72340	72340	240501
4041	3209	1	applied	\N	\N	\N	\N	72341	72341	240502
4041	3210	2	applied	\N	\N	\N	\N	72342	72342	240503
4043	3213	0	applied	\N	\N	\N	\N	72345	72345	240506
4044	3213	0	applied	\N	\N	\N	\N	72346	72346	240507
4046	3214	0	applied	\N	\N	\N	\N	72348	72348	240509
4049	3218	0	applied	\N	\N	\N	\N	72353	72353	240514
4050	3218	0	applied	\N	\N	\N	\N	72354	72354	240515
4051	3219	0	applied	\N	\N	\N	\N	72355	72355	240516
4052	3221	1	applied	\N	\N	\N	\N	72357	72357	240518
4056	3224	0	applied	\N	\N	\N	\N	72364	72364	240525
4056	3225	1	applied	\N	\N	\N	\N	72365	72365	240526
4056	3226	2	applied	\N	\N	\N	\N	72366	72366	240527
4057	3227	0	applied	\N	\N	\N	\N	72367	72367	240528
4058	3227	0	applied	\N	\N	\N	\N	72368	72368	240529
4060	3228	0	applied	\N	\N	\N	\N	72370	72370	240531
4061	3229	0	applied	\N	\N	\N	\N	72371	72371	240532
4062	3230	0	applied	\N	\N	\N	\N	72372	72372	240533
4062	3231	1	applied	\N	\N	\N	\N	72373	72373	240534
4062	3232	2	applied	\N	\N	\N	\N	72374	72374	240535
4066	3234	0	applied	\N	\N	\N	\N	72380	72380	240541
4067	3235	0	applied	\N	\N	\N	\N	72381	72381	240542
4070	3238	0	applied	\N	\N	\N	\N	72385	72385	240546
4071	3238	0	applied	\N	\N	\N	\N	72386	72386	240547
4072	3239	0	applied	\N	\N	\N	\N	72387	72387	240548
4074	3239	0	applied	\N	\N	\N	\N	72389	72389	240550
4078	3242	0	applied	\N	\N	\N	\N	72393	72393	240554
4078	3243	1	applied	\N	\N	\N	\N	72394	72394	240555
4081	3242	0	applied	\N	\N	\N	\N	72399	72399	240560
4083	3244	0	applied	\N	\N	\N	\N	72402	72402	240563
4084	3245	0	applied	\N	\N	\N	\N	72403	72403	240564
4088	3247	0	applied	\N	\N	\N	\N	72407	72407	240568
4090	3248	0	applied	\N	\N	\N	\N	72410	72410	240571
4090	3249	1	applied	\N	\N	\N	\N	72411	72411	240572
4095	3257	0	applied	\N	\N	\N	\N	72424	72424	240585
4098	3260	0	applied	\N	\N	\N	\N	72428	72428	240589
4098	3261	1	applied	\N	\N	\N	\N	72429	72429	240590
4100	3262	0	applied	\N	\N	\N	\N	72432	72432	240593
4103	3263	0	applied	\N	\N	\N	\N	72436	72436	240597
3927	3111	44	applied	\N	\N	\N	\N	72176	72176	240337
3927	3112	45	applied	\N	\N	\N	\N	72177	72177	240338
4075	3240	0	applied	\N	\N	\N	\N	72390	72390	240551
4076	3240	0	applied	\N	\N	\N	\N	72391	72391	240552
4079	3242	0	applied	\N	\N	\N	\N	72395	72395	240556
4079	3243	1	applied	\N	\N	\N	\N	72396	72396	240557
4080	3243	1	applied	\N	\N	\N	\N	72398	72398	240559
4087	3247	0	applied	\N	\N	\N	\N	72406	72406	240567
4091	3250	0	applied	\N	\N	1000000000	\N	72412	72412	240573
4091	3251	1	applied	\N	\N	\N	\N	72413	72413	240574
4091	3252	2	applied	\N	\N	\N	\N	72414	72414	240575
4091	3253	3	applied	\N	\N	\N	\N	72415	72415	240576
4091	3254	4	applied	\N	\N	\N	\N	72416	72416	240577
4093	3255	0	applied	\N	\N	\N	\N	72422	72422	240583
4096	3257	0	applied	\N	\N	\N	\N	72425	72425	240586
4099	3261	1	applied	\N	\N	\N	\N	72431	72431	240592
4101	3262	0	applied	\N	\N	\N	\N	72433	72433	240594
4103	3264	1	applied	\N	\N	\N	\N	72437	72437	240598
4104	3263	0	applied	\N	\N	\N	\N	72438	72438	240599
4104	3264	1	applied	\N	\N	\N	\N	72439	72439	240600
4106	3263	0	applied	\N	\N	\N	\N	72443	72443	240604
4106	3264	1	applied	\N	\N	\N	\N	72444	72444	240605
4107	3265	0	applied	\N	\N	\N	\N	72445	72445	240606
4107	3266	1	applied	\N	\N	\N	\N	72446	72446	240607
4108	3267	0	applied	\N	\N	\N	\N	72447	72447	240608
4109	3268	0	applied	\N	\N	\N	\N	72448	72448	240609
4109	3269	1	applied	\N	\N	1000000000	\N	72449	72449	240610
4110	3270	0	applied	\N	\N	\N	\N	72450	72450	240611
4111	3270	0	applied	\N	\N	\N	\N	72451	72451	240612
4112	3270	0	applied	\N	\N	\N	\N	72452	72452	240613
4114	3271	0	applied	\N	\N	\N	\N	72454	72454	240615
4116	3273	1	applied	\N	\N	\N	\N	72457	72457	240618
4117	3265	0	applied	\N	\N	\N	\N	72458	72458	240619
4117	3263	1	applied	\N	\N	\N	\N	72459	72459	240620
4117	3196	2	applied	\N	\N	\N	\N	72460	72460	240621
4117	3272	3	applied	\N	\N	\N	\N	72461	72461	240622
4117	3128	4	applied	\N	\N	\N	\N	72462	72462	240623
4117	3129	5	applied	\N	\N	\N	\N	72463	72463	240624
4117	3130	6	applied	\N	\N	\N	\N	72464	72464	240625
4117	3131	7	applied	\N	\N	\N	\N	72465	72465	240626
4117	3132	8	applied	\N	\N	\N	\N	72466	72466	240627
4117	3133	9	applied	\N	\N	\N	\N	72467	72467	240628
4117	3134	10	applied	\N	\N	\N	\N	72468	72468	240629
4117	3135	11	applied	\N	\N	\N	\N	72469	72469	240630
4117	3136	12	applied	\N	\N	\N	\N	72470	72470	240631
4117	3137	13	applied	\N	\N	\N	\N	72471	72471	240632
4117	3138	14	applied	\N	\N	\N	\N	72472	72472	240633
4117	3140	16	applied	\N	\N	\N	\N	72474	72474	240635
4117	3141	17	applied	\N	\N	\N	\N	72475	72475	240636
4117	3142	18	applied	\N	\N	\N	\N	72476	72476	240637
4117	3144	19	applied	\N	\N	\N	\N	72477	72477	240638
4117	3149	20	applied	\N	\N	\N	\N	72478	72478	240639
4117	3150	21	applied	\N	\N	\N	\N	72479	72479	240640
4117	3151	22	applied	\N	\N	\N	\N	72480	72480	240641
4117	3152	23	applied	\N	\N	\N	\N	72481	72481	240642
4117	3153	24	applied	\N	\N	\N	\N	72482	72482	240643
4117	3154	25	applied	\N	\N	\N	\N	72483	72483	240644
4117	3155	26	applied	\N	\N	\N	\N	72484	72484	240645
4117	3156	27	applied	\N	\N	\N	\N	72485	72485	240646
4117	3157	28	applied	\N	\N	\N	\N	72486	72486	240647
4117	3158	29	applied	\N	\N	\N	\N	72487	72487	240648
4117	3159	30	applied	\N	\N	\N	\N	72488	72488	240649
4117	3160	31	applied	\N	\N	\N	\N	72489	72489	240650
4117	3162	33	applied	\N	\N	\N	\N	72491	72491	240652
4117	3163	34	applied	\N	\N	\N	\N	72492	72492	240653
4117	3164	35	applied	\N	\N	\N	\N	72493	72493	240654
4117	3165	36	applied	\N	\N	\N	\N	72494	72494	240655
4117	3166	37	applied	\N	\N	\N	\N	72495	72495	240656
4117	3167	38	applied	\N	\N	\N	\N	72496	72496	240657
4117	3168	39	applied	\N	\N	\N	\N	72497	72497	240658
4117	3169	40	applied	\N	\N	\N	\N	72498	72498	240659
4117	3170	41	applied	\N	\N	\N	\N	72499	72499	240660
4117	3171	42	applied	\N	\N	\N	\N	72500	72500	240661
4117	3172	43	applied	\N	\N	\N	\N	72501	72501	240662
4117	3173	44	applied	\N	\N	\N	\N	72502	72502	240663
4117	3174	45	applied	\N	\N	\N	\N	72503	72503	240664
4117	3175	46	applied	\N	\N	\N	\N	72504	72504	240665
4117	3176	47	applied	\N	\N	\N	\N	72505	72505	240666
4117	3177	48	applied	\N	\N	\N	\N	72506	72506	240667
4117	3179	50	applied	\N	\N	\N	\N	72508	72508	240669
4117	3180	51	applied	\N	\N	\N	\N	72509	72509	240670
4117	3181	52	applied	\N	\N	\N	\N	72510	72510	240671
4117	3182	53	applied	\N	\N	\N	\N	72511	72511	240672
4117	3183	54	applied	\N	\N	\N	\N	72512	72512	240673
4117	3184	55	applied	\N	\N	\N	\N	72513	72513	240674
4117	3185	56	applied	\N	\N	\N	\N	72514	72514	240675
4117	3186	57	applied	\N	\N	\N	\N	72515	72515	240676
4117	3187	58	applied	\N	\N	\N	\N	72516	72516	240677
4117	3188	59	applied	\N	\N	\N	\N	72517	72517	240678
4117	3189	60	applied	\N	\N	\N	\N	72518	72518	240679
4117	3190	61	applied	\N	\N	\N	\N	72519	72519	240680
4117	3191	62	applied	\N	\N	\N	\N	72520	72520	240681
4117	3192	63	applied	\N	\N	\N	\N	72521	72521	240682
4117	3193	64	applied	\N	\N	\N	\N	72522	72522	240683
4117	3194	65	applied	\N	\N	\N	\N	72523	72523	240684
4117	3197	67	applied	\N	\N	\N	\N	72525	72525	240686
4117	3198	68	applied	\N	\N	\N	\N	72526	72526	240687
4117	3199	69	applied	\N	\N	\N	\N	72527	72527	240688
4117	3200	70	applied	\N	\N	\N	\N	72528	72528	240689
4117	3201	71	applied	\N	\N	\N	\N	72529	72529	240690
4117	3202	72	applied	\N	\N	\N	\N	72530	72530	240691
4117	3203	73	applied	\N	\N	\N	\N	72531	72531	240692
4117	3204	74	applied	\N	\N	\N	\N	72532	72532	240693
4117	3205	75	applied	\N	\N	\N	\N	72533	72533	240694
4117	3206	76	applied	\N	\N	\N	\N	72534	72534	240695
4117	3207	77	applied	\N	\N	\N	\N	72535	72535	240696
4117	3208	78	applied	\N	\N	\N	\N	72536	72536	240697
4117	3209	79	applied	\N	\N	\N	\N	72537	72537	240698
4117	3210	80	applied	\N	\N	\N	\N	72538	72538	240699
4117	3211	81	applied	\N	\N	\N	\N	72539	72539	240700
4117	3212	82	applied	\N	\N	\N	\N	72540	72540	240701
4063	3232	2	applied	\N	\N	\N	\N	72377	72377	240538
4064	3233	0	applied	\N	\N	\N	\N	72378	72378	240539
4086	3246	0	applied	\N	\N	\N	\N	72405	72405	240566
4089	3248	0	applied	\N	\N	\N	\N	72408	72408	240569
4089	3249	1	applied	\N	\N	\N	\N	72409	72409	240570
4092	3250	0	applied	\N	\N	1000000000	\N	72417	72417	240578
4092	3251	1	applied	\N	\N	\N	\N	72418	72418	240579
4092	3252	2	applied	\N	\N	\N	\N	72419	72419	240580
4092	3253	3	applied	\N	\N	\N	\N	72420	72420	240581
4092	3254	4	applied	\N	\N	\N	\N	72421	72421	240582
4097	3258	0	applied	\N	\N	\N	\N	72426	72426	240587
4097	3259	1	applied	\N	\N	\N	\N	72427	72427	240588
4102	3263	0	applied	\N	\N	\N	\N	72434	72434	240595
4102	3264	1	applied	\N	\N	\N	\N	72435	72435	240596
4105	3263	0	applied	\N	\N	\N	\N	72440	72440	240601
4105	3196	1	applied	\N	\N	\N	\N	72441	72441	240602
4105	3226	2	applied	\N	\N	\N	\N	72442	72442	240603
4113	3271	0	applied	\N	\N	\N	\N	72453	72453	240614
4115	3271	0	applied	\N	\N	\N	\N	72455	72455	240616
4117	3214	84	applied	\N	\N	\N	\N	72542	72542	240703
4117	3215	85	applied	\N	\N	\N	\N	72543	72543	240704
4117	3216	86	applied	\N	\N	\N	\N	72544	72544	240705
4117	3217	87	applied	\N	\N	\N	\N	72545	72545	240706
4117	3218	88	applied	\N	\N	\N	\N	72546	72546	240707
4117	3219	89	applied	\N	\N	\N	\N	72547	72547	240708
4117	3220	90	applied	\N	\N	\N	\N	72548	72548	240709
4117	3222	92	applied	\N	\N	\N	\N	72550	72550	240711
4117	3223	93	applied	\N	\N	\N	\N	72551	72551	240712
4117	3224	94	applied	\N	\N	\N	\N	72552	72552	240713
4117	3225	95	applied	\N	\N	\N	\N	72553	72553	240714
4117	3227	96	applied	\N	\N	\N	\N	72554	72554	240715
4117	3228	97	applied	\N	\N	\N	\N	72555	72555	240716
4117	3229	98	applied	\N	\N	\N	\N	72556	72556	240717
4117	3230	99	applied	\N	\N	\N	\N	72557	72557	240718
4117	3231	100	applied	\N	\N	\N	\N	72558	72558	240719
4117	3232	101	applied	\N	\N	\N	\N	72559	72559	240720
4117	3233	102	applied	\N	\N	\N	\N	72560	72560	240721
4117	3234	103	applied	\N	\N	\N	\N	72561	72561	240722
4117	3235	104	applied	\N	\N	\N	\N	72562	72562	240723
4117	3236	105	applied	\N	\N	\N	\N	72563	72563	240724
4117	3237	106	applied	\N	\N	\N	\N	72564	72564	240725
4117	3238	107	applied	\N	\N	\N	\N	72565	72565	240726
4117	3240	109	applied	\N	\N	\N	\N	72567	72567	240728
4117	3241	110	applied	\N	\N	\N	\N	72568	72568	240729
4117	3242	111	applied	\N	\N	\N	\N	72569	72569	240730
4117	3243	112	applied	\N	\N	\N	\N	72570	72570	240731
4117	3244	114	applied	\N	\N	\N	\N	72571	72571	240732
4117	3245	115	applied	\N	\N	\N	\N	72572	72572	240733
4117	3246	116	applied	\N	\N	\N	\N	72573	72573	240734
4117	3247	117	applied	\N	\N	\N	\N	72574	72574	240735
4117	3249	118	applied	\N	\N	\N	\N	72575	72575	240736
4117	3251	119	applied	\N	\N	\N	\N	72576	72576	240737
4117	3252	120	applied	\N	\N	\N	\N	72577	72577	240738
4117	3253	121	applied	\N	\N	\N	\N	72578	72578	240739
4117	3254	122	applied	\N	\N	\N	\N	72579	72579	240740
4117	3255	123	applied	\N	\N	\N	\N	72580	72580	240741
4117	3256	124	applied	\N	\N	\N	\N	72581	72581	240742
4117	3257	125	applied	\N	\N	\N	\N	72582	72582	240743
4118	3275	1	applied	\N	\N	\N	\N	72584	72584	240745
4119	3276	0	applied	\N	\N	\N	\N	72585	72585	240746
4119	3277	1	applied	\N	\N	\N	\N	72586	72586	240747
4120	3276	0	applied	\N	\N	\N	\N	72587	72587	240748
4120	3277	1	applied	\N	\N	\N	\N	72588	72588	240749
4121	3278	0	applied	\N	\N	\N	\N	72589	72589	240750
4122	3279	0	applied	\N	\N	\N	\N	72590	72590	240751
4122	3280	1	applied	\N	\N	\N	\N	72591	72591	240752
4123	3281	0	applied	\N	\N	\N	\N	72592	72592	240753
4124	3281	0	applied	\N	\N	\N	\N	72593	72593	240754
4125	3281	0	applied	\N	\N	\N	\N	72594	72594	240755
4126	3282	0	applied	\N	\N	\N	\N	72595	72595	240756
4128	3283	0	applied	\N	\N	\N	\N	72596	72596	240757
4128	3284	1	applied	\N	\N	\N	\N	72597	72597	240758
4129	3283	0	applied	\N	\N	\N	\N	72598	72598	240759
4129	3284	1	applied	\N	\N	\N	\N	72599	72599	240760
4130	3286	1	applied	\N	\N	\N	\N	72601	72601	240762
4131	3287	0	applied	\N	\N	\N	\N	72602	72602	240763
4132	3288	0	applied	\N	\N	\N	\N	72603	72603	240764
4133	3288	0	applied	\N	\N	\N	\N	72604	72604	240765
4134	3289	0	applied	\N	\N	\N	\N	72605	72605	240766
4135	3289	0	applied	\N	\N	\N	\N	72606	72606	240767
4136	3289	0	applied	\N	\N	\N	\N	72607	72607	240768
4137	3290	0	applied	\N	\N	\N	\N	72608	72608	240769
4138	3291	0	applied	\N	\N	1000000000	\N	72609	72609	240770
4138	3292	1	applied	\N	\N	1000000000	\N	72610	72610	240771
4138	3293	2	applied	\N	\N	1000000000	\N	72611	72611	240772
4138	3294	3	applied	\N	\N	1000000000	\N	72612	72612	240773
4138	3295	4	applied	\N	\N	1000000000	\N	72613	72613	240774
4138	3296	5	applied	\N	\N	1000000000	\N	72614	72614	240775
4138	3297	6	applied	\N	\N	\N	\N	72615	72615	240776
4138	3298	7	applied	\N	\N	\N	\N	72616	72616	240777
4139	3291	0	applied	\N	\N	1000000000	\N	72618	72618	240779
4139	3292	1	applied	\N	\N	1000000000	\N	72619	72619	240780
4139	3293	2	applied	\N	\N	1000000000	\N	72620	72620	240781
4139	3294	3	applied	\N	\N	1000000000	\N	72621	72621	240782
4139	3295	4	applied	\N	\N	1000000000	\N	72622	72622	240783
4139	3296	5	applied	\N	\N	1000000000	\N	72623	72623	240784
4139	3297	6	applied	\N	\N	\N	\N	72624	72624	240785
4139	3298	7	applied	\N	\N	\N	\N	72625	72625	240786
4139	3299	8	applied	\N	\N	\N	\N	72626	72626	240787
4140	3300	0	applied	\N	\N	\N	\N	72627	72627	240788
4140	3301	1	applied	\N	\N	\N	\N	72628	72628	240789
4141	3300	0	applied	\N	\N	\N	\N	72629	72629	240790
4141	3301	1	applied	\N	\N	\N	\N	72630	72630	240791
4142	3302	0	applied	\N	\N	\N	\N	72631	72631	240792
4143	3302	0	applied	\N	\N	\N	\N	72632	72632	240793
4144	3302	0	applied	\N	\N	\N	\N	72633	72633	240794
4145	3304	1	applied	\N	\N	\N	\N	72635	72635	240796
4146	3305	0	applied	\N	\N	\N	\N	72636	72636	240797
4147	3306	0	applied	\N	\N	\N	\N	72637	72637	240798
4147	3307	1	applied	\N	\N	\N	\N	72638	72638	240799
4082	3244	0	applied	\N	\N	\N	\N	72401	72401	240562
4085	3246	0	applied	\N	\N	\N	\N	72404	72404	240565
4151	3309	0	applied	\N	\N	\N	\N	72642	72642	240803
4152	3309	0	applied	\N	\N	\N	\N	72643	72643	240804
4153	3309	0	applied	\N	\N	\N	\N	72644	72644	240805
4154	3309	0	applied	\N	\N	\N	\N	72645	72645	240806
4155	3310	0	applied	\N	\N	\N	\N	72646	72646	240807
4156	3311	0	applied	\N	\N	1000000000	\N	72647	72647	240808
4156	3312	1	applied	\N	\N	\N	\N	72648	72648	240809
4157	3312	1	applied	\N	\N	\N	\N	72650	72650	240811
4158	3313	0	applied	\N	\N	\N	\N	72651	72651	240812
4159	3313	0	applied	\N	\N	\N	\N	72652	72652	240813
4160	3313	0	applied	\N	\N	\N	\N	72653	72653	240814
4161	3314	0	applied	\N	\N	\N	\N	72654	72654	240815
4162	3315	0	applied	\N	\N	\N	\N	72655	72655	240816
4163	3315	0	applied	\N	\N	\N	\N	72656	72656	240817
4164	3316	0	applied	\N	\N	\N	\N	72657	72657	240818
4164	3317	1	applied	\N	\N	\N	\N	72658	72658	240819
4165	3316	0	applied	\N	\N	\N	\N	72659	72659	240820
4165	3317	1	applied	\N	\N	\N	\N	72660	72660	240821
4166	3316	0	applied	\N	\N	\N	\N	72661	72661	240822
4166	3317	1	applied	\N	\N	\N	\N	72662	72662	240823
4167	3318	0	applied	\N	\N	\N	\N	72663	72663	240824
4168	3319	0	applied	\N	\N	\N	\N	72664	72664	240825
4168	3320	1	applied	\N	\N	\N	\N	72665	72665	240826
4168	3321	2	applied	\N	\N	\N	\N	72666	72666	240827
4168	3322	3	applied	\N	\N	\N	\N	72667	72667	240828
4169	3323	0	applied	\N	\N	\N	\N	72668	72668	240829
4170	3324	0	applied	\N	\N	\N	\N	72669	72669	240830
4172	3325	0	applied	\N	\N	\N	\N	72671	72671	240832
4173	3326	0	applied	\N	\N	\N	\N	72672	72672	240833
4174	3326	0	applied	\N	\N	\N	\N	72673	72673	240834
4175	3327	0	applied	\N	\N	\N	\N	72674	72674	240835
4176	3328	0	applied	\N	\N	\N	\N	72675	72675	240836
4176	3329	1	applied	\N	\N	\N	\N	72676	72676	240837
4176	3330	2	applied	\N	\N	\N	\N	72677	72677	240838
4177	3328	0	applied	\N	\N	\N	\N	72678	72678	240839
4177	3329	1	applied	\N	\N	\N	\N	72679	72679	240840
4177	3330	2	applied	\N	\N	\N	\N	72680	72680	240841
4178	3331	0	applied	\N	\N	\N	\N	72681	72681	240842
4178	3332	1	applied	\N	\N	\N	\N	72682	72682	240843
4179	3333	0	applied	\N	\N	\N	\N	72683	72683	240844
4179	3334	1	applied	\N	\N	\N	\N	72684	72684	240845
4186	3338	0	applied	\N	\N	\N	\N	72774	72774	240935
4186	3339	1	applied	\N	\N	\N	\N	72775	72775	240936
4191	3346	0	applied	\N	\N	\N	\N	72789	72789	240950
4191	3347	1	applied	\N	\N	\N	\N	72790	72790	240951
4194	3348	0	applied	\N	\N	1000000000	\N	72799	72799	240960
4194	3349	1	applied	\N	\N	\N	\N	72800	72800	240961
4194	3350	2	applied	\N	\N	\N	\N	72801	72801	240962
4194	3351	3	applied	\N	\N	\N	\N	72802	72802	240963
4194	3352	4	applied	\N	\N	\N	\N	72803	72803	240964
4194	3353	5	applied	\N	\N	\N	\N	72804	72804	240965
4197	3355	0	applied	\N	\N	\N	\N	72808	72808	240969
4197	3356	1	applied	\N	\N	\N	\N	72809	72809	240970
4202	3361	0	applied	\N	\N	\N	\N	72820	72820	240981
4207	3367	0	applied	\N	\N	\N	\N	72834	72834	240995
4209	3368	0	applied	\N	\N	\N	\N	72836	72836	240997
4216	3370	0	applied	\N	\N	\N	\N	72843	72843	241004
4218	3370	0	applied	\N	\N	\N	\N	72845	72845	241006
4220	3371	0	applied	\N	\N	\N	\N	72847	72847	241008
4228	3384	0	applied	\N	\N	\N	\N	72868	72868	241029
4231	3385	0	applied	\N	\N	\N	\N	72871	72871	241032
4231	3386	1	applied	\N	\N	\N	\N	72872	72872	241033
4231	3387	2	applied	\N	\N	\N	\N	72873	72873	241034
4231	3388	3	applied	\N	\N	\N	\N	72874	72874	72874
4232	3389	0	applied	\N	\N	1000000000	\N	72875	72875	241035
4232	3390	1	applied	\N	\N	\N	\N	72876	72876	241036
4232	3391	2	applied	\N	\N	\N	\N	72877	72877	241037
4232	3392	3	applied	\N	\N	\N	\N	72878	72878	241038
4232	3393	4	applied	\N	\N	\N	\N	72879	72879	241039
4234	3394	0	applied	\N	\N	\N	\N	72885	72885	241045
4236	3394	0	applied	\N	\N	\N	\N	72887	72887	241047
4243	3397	0	applied	\N	\N	\N	\N	72898	72898	241057
4245	3316	0	applied	\N	\N	\N	\N	72900	72900	241059
4245	3375	1	applied	\N	\N	\N	\N	72901	72901	241060
4245	3376	2	applied	\N	\N	\N	\N	72902	72902	241061
4245	3378	4	applied	\N	\N	\N	\N	72904	72904	241063
4245	3331	5	applied	\N	\N	\N	\N	72905	72905	241064
4245	3313	6	applied	\N	\N	\N	\N	72906	72906	241065
4245	3314	7	applied	\N	\N	\N	\N	72907	72907	241066
4245	3315	8	applied	\N	\N	\N	\N	72908	72908	241067
4245	3388	9	applied	\N	\N	\N	\N	72909	72909	72909
4245	3317	10	applied	\N	\N	\N	\N	72910	72910	241068
4245	3318	11	applied	\N	\N	\N	\N	72911	72911	241069
4245	3319	12	applied	\N	\N	\N	\N	72912	72912	241070
4245	3320	13	applied	\N	\N	\N	\N	72913	72913	241071
4245	3321	14	applied	\N	\N	\N	\N	72914	72914	241072
4245	3323	15	applied	\N	\N	\N	\N	72915	72915	241073
4245	3324	16	applied	\N	\N	\N	\N	72916	72916	241074
4245	3325	17	applied	\N	\N	\N	\N	72917	72917	241075
4245	3326	18	applied	\N	\N	\N	\N	72918	72918	241076
4245	3327	19	applied	\N	\N	\N	\N	72919	72919	241077
4245	3329	21	applied	\N	\N	\N	\N	72921	72921	241079
4245	3330	22	applied	\N	\N	\N	\N	72922	72922	241080
4245	3332	23	applied	\N	\N	\N	\N	72923	72923	241081
4245	3333	24	applied	\N	\N	\N	\N	72924	72924	241082
4245	3335	25	applied	\N	\N	\N	\N	72925	72925	241083
4245	3338	26	applied	\N	\N	\N	\N	72926	72926	241084
4245	3339	27	applied	\N	\N	\N	\N	72927	72927	241085
4245	3342	28	applied	\N	\N	\N	\N	72928	72928	241086
4245	3343	29	applied	\N	\N	\N	\N	72929	72929	241087
4245	3344	30	applied	\N	\N	\N	\N	72930	72930	241088
4245	3346	31	applied	\N	\N	\N	\N	72931	72931	241089
4245	3347	32	applied	\N	\N	\N	\N	72932	72932	241090
4245	3350	33	applied	\N	\N	\N	\N	72933	72933	241091
4245	3351	34	applied	\N	\N	\N	\N	72934	72934	241092
4245	3352	35	applied	\N	\N	\N	\N	72935	72935	241093
4245	3354	36	applied	\N	\N	\N	\N	72936	72936	241094
4245	3356	38	applied	\N	\N	\N	\N	72938	72938	241096
4245	3358	39	applied	\N	\N	\N	\N	72939	72939	241097
4149	3309	0	applied	\N	\N	\N	\N	72640	72640	240801
4150	3309	0	applied	\N	\N	\N	\N	72641	72641	240802
4180	3259	4	applied	\N	\N	\N	\N	72689	72689	240850
4180	3260	5	applied	\N	\N	\N	\N	72690	72690	240851
4180	3261	6	applied	\N	\N	\N	\N	72691	72691	240852
4180	3262	7	applied	\N	\N	\N	\N	72692	72692	240853
4180	3264	8	applied	\N	\N	\N	\N	72693	72693	240854
4180	3266	9	applied	\N	\N	\N	\N	72694	72694	240855
4180	3267	10	applied	\N	\N	\N	\N	72695	72695	240856
4180	3268	11	applied	\N	\N	\N	\N	72696	72696	240857
4180	3270	12	applied	\N	\N	\N	\N	72697	72697	240858
4180	3271	13	applied	\N	\N	\N	\N	72698	72698	240859
4180	3273	14	applied	\N	\N	\N	\N	72699	72699	240860
4180	3274	15	applied	\N	\N	\N	\N	72700	72700	240861
4180	3275	16	applied	\N	\N	\N	\N	72701	72701	240862
4180	3276	17	applied	\N	\N	\N	\N	72702	72702	240863
4180	3278	19	applied	\N	\N	\N	\N	72704	72704	240865
4180	3279	20	applied	\N	\N	\N	\N	72705	72705	240866
4180	3280	21	applied	\N	\N	\N	\N	72706	72706	240867
4180	3281	22	applied	\N	\N	\N	\N	72707	72707	240868
4180	3282	23	applied	\N	\N	\N	\N	72708	72708	240869
4180	3283	24	applied	\N	\N	\N	\N	72709	72709	240870
4180	3284	25	applied	\N	\N	\N	\N	72710	72710	240871
4180	3285	26	applied	\N	\N	\N	\N	72711	72711	240872
4180	3286	27	applied	\N	\N	\N	\N	72712	72712	240873
4180	3287	28	applied	\N	\N	\N	\N	72713	72713	240874
4180	3288	29	applied	\N	\N	\N	\N	72714	72714	240875
4180	3289	30	applied	\N	\N	\N	\N	72715	72715	240876
4180	3290	31	applied	\N	\N	\N	\N	72716	72716	240877
4180	3297	32	applied	\N	\N	\N	\N	72717	72717	240878
4180	3298	33	applied	\N	\N	\N	\N	72718	72718	240879
4180	3299	34	applied	\N	\N	\N	\N	72719	72719	240880
4180	3301	36	applied	\N	\N	\N	\N	72721	72721	240882
4180	3302	37	applied	\N	\N	\N	\N	72722	72722	240883
4180	3303	38	applied	\N	\N	\N	\N	72723	72723	240884
4180	3304	39	applied	\N	\N	\N	\N	72724	72724	240885
4180	3305	40	applied	\N	\N	\N	\N	72725	72725	240886
4180	3306	41	applied	\N	\N	\N	\N	72726	72726	240887
4180	3307	42	applied	\N	\N	\N	\N	72727	72727	240888
4180	3308	43	applied	\N	\N	\N	\N	72728	72728	240889
4180	3309	44	applied	\N	\N	\N	\N	72729	72729	240890
4180	3310	45	applied	\N	\N	\N	\N	72730	72730	240891
4180	3312	46	applied	\N	\N	\N	\N	72731	72731	240892
4180	3313	47	applied	\N	\N	\N	\N	72732	72732	240893
4180	3314	48	applied	\N	\N	\N	\N	72733	72733	240894
4180	3315	49	applied	\N	\N	\N	\N	72734	72734	240895
4180	3317	50	applied	\N	\N	\N	\N	72735	72735	240896
4180	3318	51	applied	\N	\N	\N	\N	72736	72736	240897
4180	3320	53	applied	\N	\N	\N	\N	72738	72738	240899
4180	3321	54	applied	\N	\N	\N	\N	72739	72739	240900
4180	3323	55	applied	\N	\N	\N	\N	72740	72740	240901
4180	3324	56	applied	\N	\N	\N	\N	72741	72741	240902
4180	3325	57	applied	\N	\N	\N	\N	72742	72742	240903
4180	3326	58	applied	\N	\N	\N	\N	72743	72743	240904
4180	3327	59	applied	\N	\N	\N	\N	72744	72744	240905
4180	3328	60	applied	\N	\N	\N	\N	72745	72745	240906
4180	3329	61	applied	\N	\N	\N	\N	72746	72746	240907
4180	3330	62	applied	\N	\N	\N	\N	72747	72747	240908
4180	3332	63	applied	\N	\N	\N	\N	72748	72748	240909
4180	3333	64	applied	\N	\N	\N	\N	72749	72749	240910
4180	3143	65	applied	\N	\N	\N	\N	72750	72750	240911
4180	3226	66	applied	\N	\N	\N	\N	72751	72751	240912
4180	3145	67	applied	\N	\N	\N	\N	72752	72752	240913
4180	3334	68	applied	\N	\N	\N	\N	72753	72753	240914
4180	3269	70	applied	\N	\N	1000000000	\N	72755	72755	240916
4180	3147	71	applied	\N	\N	\N	\N	72756	72756	240917
4180	3322	72	applied	\N	\N	\N	\N	72757	72757	240918
4180	3148	73	applied	\N	\N	\N	\N	72758	72758	240919
4245	3359	40	applied	\N	\N	\N	\N	72940	72940	241098
4245	3360	41	applied	\N	\N	\N	\N	72941	72941	241099
4245	3361	42	applied	\N	\N	\N	\N	72942	72942	241100
4245	3363	43	applied	\N	\N	\N	\N	72943	72943	241101
4245	3364	44	applied	\N	\N	\N	\N	72944	72944	241102
4245	3365	45	applied	\N	\N	\N	\N	72945	72945	241103
4245	3366	46	applied	\N	\N	\N	\N	72946	72946	241104
4245	3367	47	applied	\N	\N	\N	\N	72947	72947	241105
4245	3368	48	applied	\N	\N	\N	\N	72948	72948	241106
4245	3369	49	applied	\N	\N	\N	\N	72949	72949	241107
4245	3370	50	applied	\N	\N	\N	\N	72950	72950	241108
4245	3371	51	applied	\N	\N	\N	\N	72951	72951	241109
4245	3373	53	applied	\N	\N	\N	\N	72953	72953	241111
4245	3374	54	applied	\N	\N	\N	\N	72954	72954	241112
4245	3379	55	applied	\N	\N	\N	\N	72955	72955	241113
4245	3380	56	applied	\N	\N	\N	\N	72956	72956	241114
4245	3381	57	applied	\N	\N	\N	\N	72957	72957	241115
4245	3382	58	applied	\N	\N	\N	\N	72958	72958	241116
4245	3383	59	applied	\N	\N	\N	\N	72959	72959	241117
4245	3384	60	applied	\N	\N	\N	\N	72960	72960	241118
4245	3385	61	applied	\N	\N	\N	\N	72961	72961	241119
4245	3386	62	applied	\N	\N	\N	\N	72962	72962	241120
4245	3387	63	applied	\N	\N	\N	\N	72963	72963	241121
4245	3390	64	applied	\N	\N	\N	\N	72964	72964	241122
4245	3391	66	applied	\N	\N	\N	\N	72965	72965	241123
4245	3392	67	applied	\N	\N	\N	\N	72966	72966	241124
4245	3393	68	applied	\N	\N	\N	\N	72967	72967	241125
4245	3394	69	applied	\N	\N	\N	\N	72968	72968	241126
4245	3396	71	applied	\N	\N	\N	\N	72970	72970	241128
4245	3397	72	applied	\N	\N	\N	\N	72971	72971	241129
4245	3398	73	applied	\N	\N	\N	\N	72972	72972	241130
4245	3334	74	applied	\N	\N	\N	\N	72973	72973	241131
4245	3336	75	applied	\N	\N	\N	\N	72974	72974	241132
4245	3337	76	applied	\N	\N	\N	\N	72975	72975	241133
4245	3349	77	applied	\N	\N	\N	\N	72976	72976	241134
4245	3353	78	applied	\N	\N	\N	\N	72977	72977	241135
4245	3345	79	applied	\N	\N	\N	\N	72978	72978	241136
4245	3322	80	applied	\N	\N	\N	\N	72979	72979	241137
4250	3402	0	applied	\N	\N	\N	\N	72996	72996	241154
4250	3403	1	applied	\N	\N	\N	\N	72997	72997	241155
4256	3410	0	applied	\N	\N	\N	\N	73008	73008	241166
4258	3410	0	applied	\N	\N	\N	\N	73010	73010	241168
4272	3418	0	applied	\N	\N	\N	\N	73028	73028	241186
4180	3316	1	applied	\N	\N	\N	\N	72686	72686	240847
4180	3258	3	applied	\N	\N	\N	\N	72688	72688	240849
4184	3296	2	applied	\N	\N	1000000000	\N	72763	72763	240924
4184	3316	3	applied	\N	\N	\N	\N	72764	72764	240925
4184	3331	4	applied	\N	\N	\N	\N	72765	72765	240926
4184	3334	5	applied	\N	\N	\N	\N	72766	72766	240927
4184	3269	6	applied	\N	\N	1000000000	\N	72767	72767	240928
4184	3336	7	applied	\N	\N	\N	\N	72768	72768	240929
4184	3337	8	applied	\N	\N	\N	\N	72769	72769	240930
4184	3322	9	applied	\N	\N	\N	\N	72770	72770	240931
4185	3338	0	applied	\N	\N	\N	\N	72771	72771	240932
4185	3339	1	applied	\N	\N	\N	\N	72772	72772	240933
4187	3340	0	applied	\N	\N	1000000000	\N	72777	72777	240938
4187	3341	1	applied	\N	\N	1000000000	\N	72778	72778	240939
4187	3342	2	applied	\N	\N	\N	\N	72779	72779	240940
4187	3343	3	applied	\N	\N	\N	\N	72780	72780	240941
4189	3344	0	applied	\N	\N	\N	\N	72785	72785	240946
4189	3345	1	applied	\N	\N	\N	\N	72786	72786	240947
4192	3346	0	applied	\N	\N	\N	\N	72791	72791	240952
4192	3347	1	applied	\N	\N	\N	\N	72792	72792	240953
4193	3348	0	applied	\N	\N	1000000000	\N	72793	72793	240954
4193	3349	1	applied	\N	\N	\N	\N	72794	72794	240955
4193	3350	2	applied	\N	\N	\N	\N	72795	72795	240956
4193	3351	3	applied	\N	\N	\N	\N	72796	72796	240957
4193	3352	4	applied	\N	\N	\N	\N	72797	72797	240958
4193	3353	5	applied	\N	\N	\N	\N	72798	72798	240959
4195	3354	0	applied	\N	\N	\N	\N	72805	72805	240966
4198	3358	1	applied	\N	\N	\N	\N	72811	72811	240972
4198	3359	2	applied	\N	\N	\N	\N	72812	72812	240973
4198	3360	3	applied	\N	\N	\N	\N	72813	72813	240974
4199	3357	0	applied	\N	\N	1000000000	\N	72814	72814	240975
4199	3358	1	applied	\N	\N	\N	\N	72815	72815	240976
4199	3359	2	applied	\N	\N	\N	\N	72816	72816	240977
4199	3360	3	applied	\N	\N	\N	\N	72817	72817	240978
4200	3361	0	applied	\N	\N	\N	\N	72818	72818	240979
4201	3361	0	applied	\N	\N	\N	\N	72819	72819	240980
4203	3361	0	applied	\N	\N	\N	\N	72821	72821	240982
4205	3362	0	applied	\N	\N	1000000000	\N	72827	72827	240988
4205	3363	1	applied	\N	\N	\N	\N	72828	72828	240989
4205	3364	2	applied	\N	\N	\N	\N	72829	72829	240990
4205	3365	3	applied	\N	\N	\N	\N	72830	72830	240991
4205	3366	4	applied	\N	\N	\N	\N	72831	72831	240992
4208	3368	0	applied	\N	\N	\N	\N	72835	72835	240996
4210	3369	0	applied	\N	\N	\N	\N	72837	72837	240998
4212	3369	0	applied	\N	\N	\N	\N	72839	72839	241000
4214	3370	0	applied	\N	\N	\N	\N	72841	72841	241002
4219	3371	0	applied	\N	\N	\N	\N	72846	72846	241007
4221	3371	0	applied	\N	\N	\N	\N	72848	72848	241009
4223	3373	0	applied	\N	\N	\N	\N	72850	72850	241011
4223	3374	1	applied	\N	\N	\N	\N	72851	72851	241012
4225	3373	0	applied	\N	\N	\N	\N	72854	72854	241015
4225	3374	1	applied	\N	\N	\N	\N	72855	72855	241016
4226	3349	0	applied	\N	\N	\N	\N	72856	72856	241017
4226	3353	1	applied	\N	\N	\N	\N	72857	72857	241018
4226	3345	2	applied	\N	\N	\N	\N	72858	72858	241019
4227	3375	0	applied	\N	\N	\N	\N	72859	72859	241020
4227	3376	1	applied	\N	\N	\N	\N	72860	72860	241021
4227	3377	2	applied	\N	\N	\N	\N	72861	72861	241022
4227	3378	3	applied	\N	\N	\N	\N	72862	72862	241023
4227	3379	4	applied	\N	\N	\N	\N	72863	72863	241024
4227	3380	5	applied	\N	\N	\N	\N	72864	72864	241025
4227	3381	6	applied	\N	\N	\N	\N	72865	72865	241026
4227	3383	8	applied	\N	\N	\N	\N	72867	72867	241028
4229	3384	0	applied	\N	\N	\N	\N	72869	72869	241030
4233	3389	0	applied	\N	\N	1000000000	\N	72880	72880	241040
4233	3390	1	applied	\N	\N	\N	\N	72881	72881	241041
4233	3391	2	applied	\N	\N	\N	\N	72882	72882	241042
4233	3392	3	applied	\N	\N	\N	\N	72883	72883	241043
4233	3393	4	applied	\N	\N	\N	\N	72884	72884	241044
4235	3394	0	applied	\N	\N	\N	\N	72886	72886	241046
4237	3395	0	applied	\N	\N	\N	\N	72888	72888	241048
4239	3395	0	applied	\N	\N	\N	\N	72894	72894	241053
4241	3395	0	applied	\N	\N	\N	\N	72896	72896	241055
4244	3397	0	applied	\N	\N	\N	\N	72899	72899	241058
4246	3399	0	applied	\N	\N	\N	\N	72980	72980	241138
4246	3398	1	applied	\N	\N	\N	\N	72981	72981	241139
4246	3400	2	applied	\N	\N	\N	\N	72982	72982	241140
4246	3401	3	applied	\N	\N	\N	\N	72983	72983	241141
4247	3398	1	applied	\N	\N	\N	\N	72985	72985	241143
4247	3400	2	applied	\N	\N	\N	\N	72986	72986	241144
4247	3401	3	applied	\N	\N	\N	\N	72987	72987	241145
4248	3399	0	applied	\N	\N	\N	\N	72988	72988	241146
4248	3398	1	applied	\N	\N	\N	\N	72989	72989	241147
4252	3405	0	applied	\N	\N	\N	\N	72999	72999	241157
4252	3406	1	applied	\N	\N	\N	\N	73000	73000	241158
4254	3405	0	applied	\N	\N	\N	\N	73003	73003	241161
4254	3406	1	applied	\N	\N	\N	\N	73004	73004	241162
4268	3414	0	applied	\N	\N	\N	\N	73023	73023	241181
4273	3419	0	applied	\N	\N	1000000000	\N	73029	73029	241187
4273	3420	1	applied	\N	\N	\N	\N	73030	73030	241188
4275	3419	0	applied	\N	\N	1000000000	\N	73033	73033	241191
4275	3420	1	applied	\N	\N	\N	\N	73034	73034	241192
4280	3423	0	applied	\N	\N	\N	\N	73121	73121	241278
4292	3432	0	applied	\N	\N	\N	\N	73143	73143	241300
4304	3439	0	applied	\N	\N	\N	\N	73153	73153	241310
4309	3445	0	applied	\N	\N	\N	\N	73284	73284	241440
4323	3453	0	applied	\N	\N	\N	\N	73301	73301	241457
4323	3454	1	applied	\N	\N	\N	\N	73302	73302	241458
4326	3457	0	applied	\N	\N	\N	\N	73307	73307	241463
4328	3458	0	applied	\N	\N	\N	\N	73309	73309	241465
4338	3464	0	applied	\N	\N	\N	\N	73318	73318	241474
4338	3465	1	applied	\N	\N	\N	\N	73319	73319	241475
4338	3466	2	applied	\N	\N	\N	\N	73320	73320	241476
4341	3467	0	applied	\N	\N	\N	\N	73325	73325	241481
4358	3482	0	applied	\N	\N	\N	\N	73509	73509	241664
4360	3483	0	applied	\N	\N	1000000000	\N	73511	73511	241666
4360	3484	1	applied	\N	\N	\N	\N	73512	73512	241667
4363	3487	0	applied	\N	\N	\N	\N	73515	73515	241670
4363	3488	1	applied	\N	\N	\N	\N	73516	73516	241671
4368	3490	0	applied	\N	\N	\N	\N	73522	73522	241677
4184	3265	0	applied	\N	\N	\N	\N	72761	72761	240922
4184	3272	1	applied	\N	\N	\N	\N	72762	72762	240923
4188	3342	2	applied	\N	\N	\N	\N	72783	72783	240944
4188	3343	3	applied	\N	\N	\N	\N	72784	72784	240945
4190	3344	0	applied	\N	\N	\N	\N	72787	72787	240948
4190	3345	1	applied	\N	\N	\N	\N	72788	72788	240949
4196	3355	0	applied	\N	\N	\N	\N	72806	72806	240967
4196	3356	1	applied	\N	\N	\N	\N	72807	72807	240968
4204	3362	0	applied	\N	\N	1000000000	\N	72822	72822	240983
4204	3363	1	applied	\N	\N	\N	\N	72823	72823	240984
4204	3364	2	applied	\N	\N	\N	\N	72824	72824	240985
4204	3366	4	applied	\N	\N	\N	\N	72826	72826	240987
4206	3363	0	applied	\N	\N	\N	\N	72832	72832	240993
4206	3364	1	applied	\N	\N	\N	\N	72833	72833	240994
4211	3369	0	applied	\N	\N	\N	\N	72838	72838	240999
4213	3370	0	applied	\N	\N	\N	\N	72840	72840	241001
4215	3370	0	applied	\N	\N	\N	\N	72842	72842	241003
4224	3373	0	applied	\N	\N	\N	\N	72852	72852	241013
4224	3374	1	applied	\N	\N	\N	\N	72853	72853	241014
4230	3384	0	applied	\N	\N	\N	\N	72870	72870	241031
4238	3375	0	applied	\N	\N	\N	\N	72889	72889	241049
4238	3376	1	applied	\N	\N	\N	\N	72890	72890	241050
4238	3377	2	applied	\N	\N	\N	\N	72891	72891	241051
4238	3378	3	applied	\N	\N	\N	\N	72892	72892	241052
4238	3388	4	applied	\N	\N	\N	\N	72893	72893	72893
4240	3395	0	applied	\N	\N	\N	\N	72895	72895	241054
4242	3396	0	applied	\N	\N	\N	\N	72897	72897	241056
4249	3398	1	applied	\N	\N	\N	\N	72993	72993	241151
4249	3400	2	applied	\N	\N	\N	\N	72994	72994	241152
4249	3401	3	applied	\N	\N	\N	\N	72995	72995	241153
4253	3405	0	applied	\N	\N	\N	\N	73001	73001	241159
4253	3406	1	applied	\N	\N	\N	\N	73002	73002	241160
4255	3407	0	applied	\N	\N	\N	\N	73005	73005	241163
4255	3408	1	applied	\N	\N	\N	\N	73006	73006	241164
4255	3409	2	applied	\N	\N	\N	\N	73007	73007	241165
4260	3411	0	applied	\N	\N	\N	\N	73012	73012	241170
4262	3411	0	applied	\N	\N	\N	\N	73014	73014	241172
4262	3412	2	applied	\N	\N	\N	\N	73015	73015	241173
4264	3412	0	applied	\N	\N	\N	\N	73018	73018	241176
4264	3413	1	applied	\N	\N	\N	\N	73019	73019	241177
4266	3413	0	applied	\N	\N	\N	\N	73021	73021	241179
4269	3414	0	applied	\N	\N	\N	\N	73024	73024	241182
4271	3417	0	applied	\N	\N	\N	\N	73027	73027	241185
4274	3420	1	applied	\N	\N	\N	\N	73032	73032	241190
4276	3399	0	applied	\N	\N	\N	\N	73035	73035	241193
4276	3375	1	applied	\N	\N	\N	\N	73036	73036	241194
4276	3376	2	applied	\N	\N	\N	\N	73037	73037	241195
4276	3377	3	applied	\N	\N	\N	\N	73038	73038	241196
4276	3378	4	applied	\N	\N	\N	\N	73039	73039	241197
4276	3388	5	applied	\N	\N	\N	\N	73040	73040	73040
4276	3335	6	applied	\N	\N	\N	\N	73041	73041	241198
4276	3338	7	applied	\N	\N	\N	\N	73042	73042	241199
4276	3339	8	applied	\N	\N	\N	\N	73043	73043	241200
4276	3342	9	applied	\N	\N	\N	\N	73044	73044	241201
4276	3343	10	applied	\N	\N	\N	\N	73045	73045	241202
4276	3344	11	applied	\N	\N	\N	\N	73046	73046	241203
4276	3346	12	applied	\N	\N	\N	\N	73047	73047	241204
4276	3347	13	applied	\N	\N	\N	\N	73048	73048	241205
4276	3350	14	applied	\N	\N	\N	\N	73049	73049	241206
4276	3351	15	applied	\N	\N	\N	\N	73050	73050	241207
4276	3352	16	applied	\N	\N	\N	\N	73051	73051	241208
4276	3355	18	applied	\N	\N	\N	\N	73053	73053	241210
4276	3356	19	applied	\N	\N	\N	\N	73054	73054	241211
4276	3358	20	applied	\N	\N	\N	\N	73055	73055	241212
4276	3359	21	applied	\N	\N	\N	\N	73056	73056	241213
4276	3360	22	applied	\N	\N	\N	\N	73057	73057	241214
4276	3361	23	applied	\N	\N	\N	\N	73058	73058	241215
4276	3363	24	applied	\N	\N	\N	\N	73059	73059	241216
4276	3364	25	applied	\N	\N	\N	\N	73060	73060	241217
4276	3365	26	applied	\N	\N	\N	\N	73061	73061	241218
4276	3366	27	applied	\N	\N	\N	\N	73062	73062	241219
4276	3367	28	applied	\N	\N	\N	\N	73063	73063	241220
4276	3368	29	applied	\N	\N	\N	\N	73064	73064	241221
4276	3369	30	applied	\N	\N	\N	\N	73065	73065	241222
4276	3370	31	applied	\N	\N	\N	\N	73066	73066	241223
4276	3371	32	applied	\N	\N	\N	\N	73067	73067	241224
4276	3372	33	applied	\N	\N	\N	\N	73068	73068	241225
4276	3374	35	applied	\N	\N	\N	\N	73070	73070	241227
4368	3492	2	applied	\N	\N	\N	\N	73524	73524	241679
4368	3493	3	applied	\N	\N	\N	\N	73525	73525	241680
4368	3494	4	applied	\N	\N	\N	\N	73526	73526	241681
4375	3498	0	applied	\N	\N	\N	\N	73532	73532	241687
4377	3498	0	applied	\N	\N	\N	\N	73534	73534	241689
4380	3501	0	applied	\N	\N	\N	\N	73537	73537	241692
4382	3502	0	applied	\N	\N	\N	\N	73539	73539	241694
4384	3502	0	applied	\N	\N	\N	\N	73541	73541	241696
4389	3506	0	applied	\N	\N	\N	\N	73624	73624	241776
4389	3507	1	applied	\N	\N	\N	\N	73625	73625	241777
4389	3508	2	applied	\N	\N	\N	\N	73626	73626	241778
4391	3509	0	applied	\N	\N	\N	\N	73630	73630	241782
4391	3510	1	applied	\N	\N	\N	\N	73631	73631	241783
4391	3511	2	applied	\N	\N	\N	\N	73632	73632	241784
4391	3512	3	applied	\N	\N	\N	\N	73633	73633	241785
4398	3537	1	applied	\N	\N	\N	\N	73692	73692	241844
4398	3538	2	applied	\N	\N	\N	\N	73693	73693	241845
4398	3539	3	applied	\N	\N	\N	\N	73694	73694	241846
4398	3540	4	applied	\N	\N	\N	\N	73695	73695	241847
4398	3541	5	applied	\N	\N	\N	\N	73696	73696	241848
4398	3542	6	applied	\N	\N	\N	\N	73697	73697	241849
4398	3543	7	applied	\N	\N	\N	\N	73698	73698	241850
4398	3544	8	applied	\N	\N	\N	\N	73699	73699	241851
4398	3545	9	applied	\N	\N	\N	\N	73700	73700	241852
4402	3546	0	applied	\N	\N	\N	\N	73731	73731	241883
4402	3547	1	applied	\N	\N	\N	\N	73732	73732	241884
4402	3548	2	applied	\N	\N	\N	\N	73733	73733	241885
4402	3549	3	applied	\N	\N	\N	\N	73734	73734	241886
4402	3550	4	applied	\N	\N	\N	\N	73735	73735	241887
4402	3551	5	applied	\N	\N	\N	\N	73736	73736	241888
4402	3552	6	applied	\N	\N	\N	\N	73737	73737	241889
4402	3554	8	applied	\N	\N	\N	\N	73739	73739	241891
4402	3555	9	applied	\N	\N	\N	\N	73740	73740	241892
4188	3340	0	applied	\N	\N	1000000000	\N	72781	72781	240942
4188	3341	1	applied	\N	\N	1000000000	\N	72782	72782	240943
4257	3410	0	applied	\N	\N	\N	\N	73009	73009	241167
4259	3410	0	applied	\N	\N	\N	\N	73011	73011	241169
4261	3412	0	applied	\N	\N	\N	\N	73013	73013	241171
4263	3411	0	applied	\N	\N	\N	\N	73016	73016	241174
4263	3412	2	applied	\N	\N	\N	\N	73017	73017	241175
4265	3413	0	applied	\N	\N	\N	\N	73020	73020	241178
4267	3413	0	applied	\N	\N	\N	\N	73022	73022	241180
4270	3415	0	applied	\N	\N	\N	\N	73025	73025	241183
4270	3416	1	applied	\N	\N	\N	\N	73026	73026	241184
4276	3379	36	applied	\N	\N	\N	\N	73071	73071	241228
4276	3380	38	applied	\N	\N	\N	\N	73072	73072	241229
4276	3382	40	applied	\N	\N	\N	\N	73074	73074	241231
4276	3383	41	applied	\N	\N	\N	\N	73075	73075	241232
4276	3384	42	applied	\N	\N	\N	\N	73076	73076	241233
4276	3385	43	applied	\N	\N	\N	\N	73077	73077	241234
4276	3386	44	applied	\N	\N	\N	\N	73078	73078	241235
4276	3387	45	applied	\N	\N	\N	\N	73079	73079	241236
4276	3390	46	applied	\N	\N	\N	\N	73080	73080	241237
4276	3391	47	applied	\N	\N	\N	\N	73081	73081	241238
4276	3392	48	applied	\N	\N	\N	\N	73082	73082	241239
4276	3393	49	applied	\N	\N	\N	\N	73083	73083	241240
4276	3394	50	applied	\N	\N	\N	\N	73084	73084	241241
4276	3395	51	applied	\N	\N	\N	\N	73085	73085	241242
4276	3396	52	applied	\N	\N	\N	\N	73086	73086	241243
4276	3397	53	applied	\N	\N	\N	\N	73087	73087	241244
4276	3398	54	applied	\N	\N	\N	\N	73088	73088	241245
4276	3400	55	applied	\N	\N	\N	\N	73089	73089	241246
4276	3402	57	applied	\N	\N	\N	\N	73091	73091	241248
4276	3403	58	applied	\N	\N	\N	\N	73092	73092	241249
4276	3404	59	applied	\N	\N	\N	\N	73093	73093	241250
4276	3405	60	applied	\N	\N	\N	\N	73094	73094	241251
4276	3406	61	applied	\N	\N	\N	\N	73095	73095	241252
4276	3407	62	applied	\N	\N	\N	\N	73096	73096	241253
4276	3408	63	applied	\N	\N	\N	\N	73097	73097	241254
4276	3409	64	applied	\N	\N	\N	\N	73098	73098	241255
4276	3410	65	applied	\N	\N	\N	\N	73099	73099	241256
4276	3411	66	applied	\N	\N	\N	\N	73100	73100	241257
4276	3412	67	applied	\N	\N	\N	\N	73101	73101	241258
4276	3413	68	applied	\N	\N	\N	\N	73102	73102	241259
4276	3414	69	applied	\N	\N	\N	\N	73103	73103	241260
4276	3415	70	applied	\N	\N	\N	\N	73104	73104	241261
4276	3416	71	applied	\N	\N	\N	\N	73105	73105	241262
4277	3420	1	applied	\N	\N	\N	\N	73115	73115	241272
4277	3421	2	applied	\N	\N	\N	\N	73116	73116	241273
4282	3425	0	applied	\N	\N	\N	\N	73123	73123	241280
4285	3426	0	applied	\N	\N	\N	\N	73128	73128	241285
4285	3427	1	applied	\N	\N	\N	\N	73129	73129	241286
4285	3428	2	applied	\N	\N	\N	\N	73130	73130	241287
4287	3426	0	applied	\N	\N	\N	\N	73134	73134	241291
4287	3427	1	applied	\N	\N	\N	\N	73135	73135	241292
4287	3428	2	applied	\N	\N	\N	\N	73136	73136	241293
4289	3429	0	applied	\N	\N	\N	\N	73140	73140	241297
4294	3435	0	applied	\N	\N	\N	\N	73146	73146	241303
4299	3437	0	applied	\N	\N	1000000000	\N	73150	73150	241307
4299	3438	1	applied	\N	\N	\N	\N	73151	73151	241308
4306	3265	0	applied	\N	\N	\N	\N	73156	73156	241313
4306	3399	1	applied	\N	\N	\N	\N	73157	73157	241314
4306	3375	3	applied	\N	\N	\N	\N	73158	73158	241315
4306	3376	4	applied	\N	\N	\N	\N	73159	73159	241316
4306	3263	5	applied	\N	\N	\N	\N	73160	73160	241317
4306	3196	6	applied	\N	\N	\N	\N	73161	73161	241318
4306	3378	8	applied	\N	\N	\N	\N	73163	73163	241320
4306	3272	9	applied	\N	\N	\N	\N	73164	73164	241321
4306	3296	10	applied	\N	\N	1000000000	\N	73165	73165	241322
4306	3316	11	applied	\N	\N	\N	\N	73166	73166	241323
4306	3331	12	applied	\N	\N	\N	\N	73167	73167	241324
4306	3069	13	applied	\N	\N	\N	\N	73168	73168	241325
4306	3388	14	applied	\N	\N	\N	\N	73169	73169	73169
4306	3070	15	applied	\N	\N	\N	\N	73170	73170	241326
4306	3071	16	applied	\N	\N	\N	\N	73171	73171	241327
4306	3072	17	applied	\N	\N	\N	\N	73172	73172	241328
4306	3073	18	applied	\N	\N	\N	\N	73173	73173	241329
4306	3074	19	applied	\N	\N	\N	\N	73174	73174	241330
4306	3075	20	applied	\N	\N	\N	\N	73175	73175	241331
4306	3076	21	applied	\N	\N	\N	\N	73176	73176	241332
4306	3077	22	applied	\N	\N	\N	\N	73177	73177	241333
4306	3078	23	applied	\N	\N	\N	\N	73178	73178	241334
4306	3080	25	applied	\N	\N	\N	\N	73180	73180	241336
4306	3081	26	applied	\N	\N	\N	\N	73181	73181	241337
4306	3082	27	applied	\N	\N	\N	\N	73182	73182	241338
4306	3083	28	applied	\N	\N	\N	\N	73183	73183	241339
4306	3084	29	applied	\N	\N	\N	\N	73184	73184	241340
4306	3085	30	applied	\N	\N	\N	\N	73185	73185	241341
4306	3086	31	applied	\N	\N	\N	\N	73186	73186	241342
4306	3087	32	applied	\N	\N	\N	\N	73187	73187	241343
4306	3088	33	applied	\N	\N	\N	\N	73188	73188	241344
4306	3089	34	applied	\N	\N	\N	\N	73189	73189	241345
4306	3090	35	applied	\N	\N	\N	\N	73190	73190	241346
4306	3091	36	applied	\N	\N	\N	\N	73191	73191	241347
4306	3092	37	applied	\N	\N	\N	\N	73192	73192	241348
4306	3093	38	applied	\N	\N	\N	\N	73193	73193	241349
4306	3094	39	applied	\N	\N	\N	\N	73194	73194	241350
4306	3095	40	applied	\N	\N	\N	\N	73195	73195	241351
4306	3097	42	applied	\N	\N	\N	\N	73197	73197	241353
4306	3098	43	applied	\N	\N	\N	\N	73198	73198	241354
4306	3099	44	applied	\N	\N	\N	\N	73199	73199	241355
4306	3100	45	applied	\N	\N	\N	\N	73200	73200	241356
4306	3101	46	applied	\N	\N	\N	\N	73201	73201	241357
4306	3102	47	applied	\N	\N	\N	\N	73202	73202	241358
4306	3103	48	applied	\N	\N	\N	\N	73203	73203	241359
4306	3104	49	applied	\N	\N	\N	\N	73204	73204	241360
4306	3105	50	applied	\N	\N	\N	\N	73205	73205	241361
4306	3106	51	applied	\N	\N	\N	\N	73206	73206	241362
4306	3107	52	applied	\N	\N	\N	\N	73207	73207	241363
4306	3108	53	applied	\N	\N	\N	\N	73208	73208	241364
4306	3109	54	applied	\N	\N	\N	\N	73209	73209	241365
4306	3110	55	applied	\N	\N	\N	\N	73210	73210	241366
4306	3111	56	applied	\N	\N	\N	\N	73211	73211	241367
4306	3112	57	applied	\N	\N	\N	\N	73212	73212	241368
4248	3401	3	applied	\N	\N	\N	\N	72991	72991	241149
4251	3404	0	applied	\N	\N	\N	\N	72998	72998	241156
4276	3336	75	applied	\N	\N	\N	\N	73109	73109	241266
4276	3337	76	applied	\N	\N	\N	\N	73110	73110	241267
4276	3349	77	applied	\N	\N	\N	\N	73111	73111	241268
4276	3353	78	applied	\N	\N	\N	\N	73112	73112	241269
4276	3345	79	applied	\N	\N	\N	\N	73113	73113	241270
4278	3421	0	applied	\N	\N	\N	\N	73117	73117	241274
4278	3422	1	applied	\N	\N	\N	\N	73118	73118	241275
4283	3425	0	applied	\N	\N	\N	\N	73124	73124	241281
4290	3430	0	applied	\N	\N	\N	\N	73141	73141	241298
4293	3434	1	applied	\N	\N	\N	\N	73145	73145	241302
4295	3435	0	applied	\N	\N	\N	\N	73147	73147	241304
4306	3114	59	applied	\N	\N	\N	\N	73214	73214	241370
4306	3115	60	applied	\N	\N	\N	\N	73215	73215	241371
4306	3116	61	applied	\N	\N	\N	\N	73216	73216	241372
4306	3117	62	applied	\N	\N	\N	\N	73217	73217	241373
4306	3118	63	applied	\N	\N	\N	\N	73218	73218	241374
4306	3119	64	applied	\N	\N	\N	\N	73219	73219	241375
4306	3120	65	applied	\N	\N	\N	\N	73220	73220	241376
4306	3121	66	applied	\N	\N	\N	\N	73221	73221	241377
4306	3122	67	applied	\N	\N	\N	\N	73222	73222	241378
4306	3123	68	applied	\N	\N	\N	\N	73223	73223	241379
4306	3124	69	applied	\N	\N	\N	\N	73224	73224	241380
4306	3125	70	applied	\N	\N	\N	\N	73225	73225	241381
4306	3126	71	applied	\N	\N	\N	\N	73226	73226	241382
4306	3127	72	applied	\N	\N	\N	\N	73227	73227	241383
4306	3128	73	applied	\N	\N	\N	\N	73228	73228	241384
4306	3129	74	applied	\N	\N	\N	\N	73229	73229	241385
4306	3130	75	applied	\N	\N	\N	\N	73230	73230	241386
4306	3131	76	applied	\N	\N	\N	\N	73231	73231	241387
4306	3133	78	applied	\N	\N	\N	\N	73233	73233	241389
4306	3134	79	applied	\N	\N	\N	\N	73234	73234	241390
4306	3135	80	applied	\N	\N	\N	\N	73235	73235	241391
4306	3136	81	applied	\N	\N	\N	\N	73236	73236	241392
4306	3137	82	applied	\N	\N	\N	\N	73237	73237	241393
4306	3138	83	applied	\N	\N	\N	\N	73238	73238	241394
4306	3139	84	applied	\N	\N	\N	\N	73239	73239	241395
4306	3140	85	applied	\N	\N	\N	\N	73240	73240	241396
4306	3141	86	applied	\N	\N	\N	\N	73241	73241	241397
4306	3142	87	applied	\N	\N	\N	\N	73242	73242	241398
4306	3144	88	applied	\N	\N	\N	\N	73243	73243	241399
4306	3149	89	applied	\N	\N	\N	\N	73244	73244	241400
4306	3150	90	applied	\N	\N	\N	\N	73245	73245	241401
4306	3151	91	applied	\N	\N	\N	\N	73246	73246	241402
4306	3152	92	applied	\N	\N	\N	\N	73247	73247	241403
4306	3153	93	applied	\N	\N	\N	\N	73248	73248	241404
4312	3446	0	applied	\N	\N	\N	\N	73286	73286	241442
4312	3447	1	applied	\N	\N	\N	\N	73287	73287	241443
4314	3446	0	applied	\N	\N	\N	\N	73290	73290	241446
4314	3447	1	applied	\N	\N	\N	\N	73291	73291	241447
4317	3451	0	applied	\N	\N	\N	\N	73296	73296	241452
4319	3452	0	applied	\N	\N	\N	\N	73298	73298	241454
4324	3399	0	applied	\N	\N	\N	\N	73303	73303	241459
4324	3444	1	applied	\N	\N	\N	\N	73304	73304	241460
4329	3458	0	applied	\N	\N	\N	\N	73310	73310	241466
4331	3459	0	applied	\N	\N	\N	\N	73312	73312	241468
4333	3460	0	applied	\N	\N	\N	\N	73314	73314	241470
4339	3464	0	applied	\N	\N	\N	\N	73321	73321	241477
4339	3465	1	applied	\N	\N	\N	\N	73322	73322	241478
4339	3466	2	applied	\N	\N	\N	\N	73323	73323	241479
4342	3467	0	applied	\N	\N	\N	\N	73326	73326	241482
4343	3468	0	applied	\N	\N	\N	\N	73327	73327	241483
4345	3265	1	applied	\N	\N	\N	\N	73330	73330	241486
4345	3399	2	applied	\N	\N	\N	\N	73331	73331	241487
4345	3375	3	applied	\N	\N	\N	\N	73332	73332	241488
4345	3376	4	applied	\N	\N	\N	\N	73333	73333	241489
4345	3263	5	applied	\N	\N	\N	\N	73334	73334	241490
4345	3377	6	applied	\N	\N	\N	\N	73335	73335	241491
4345	3378	7	applied	\N	\N	\N	\N	73336	73336	241492
4345	3291	9	applied	\N	\N	1000000000	\N	73338	73338	241494
4345	3292	10	applied	\N	\N	1000000000	\N	73339	73339	241495
4345	3293	11	applied	\N	\N	1000000000	\N	73340	73340	241496
4345	3294	12	applied	\N	\N	1000000000	\N	73341	73341	241497
4345	3295	13	applied	\N	\N	1000000000	\N	73342	73342	241498
4345	3311	14	applied	\N	\N	1000000000	\N	73343	73343	241499
4345	3341	16	applied	\N	\N	1000000000	\N	73345	73345	241501
4345	3272	17	applied	\N	\N	\N	\N	73346	73346	241502
4345	3296	18	applied	\N	\N	1000000000	\N	73347	73347	241503
4345	3316	19	applied	\N	\N	\N	\N	73348	73348	241504
4345	3348	20	applied	\N	\N	1000000000	\N	73349	73349	241505
4345	3357	21	applied	\N	\N	1000000000	\N	73350	73350	241506
4345	3362	22	applied	\N	\N	1000000000	\N	73351	73351	241507
4345	3389	23	applied	\N	\N	1000000000	\N	73352	73352	241508
4345	3419	24	applied	\N	\N	1000000000	\N	73353	73353	241509
4345	3433	25	applied	\N	\N	1000000000	\N	73354	73354	241510
4345	3437	26	applied	\N	\N	1000000000	\N	73355	73355	241511
4345	3440	27	applied	\N	\N	1000000000	\N	73356	73356	241512
4345	3331	28	applied	\N	\N	\N	\N	73357	73357	241513
4345	3388	29	applied	\N	\N	\N	\N	73358	73358	73358
4345	3444	30	applied	\N	\N	\N	\N	73359	73359	241514
4345	3334	31	applied	\N	\N	\N	\N	73360	73360	241515
4345	3269	32	applied	\N	\N	1000000000	\N	73361	73361	241516
4345	3336	33	applied	\N	\N	\N	\N	73362	73362	241517
4345	3337	34	applied	\N	\N	\N	\N	73363	73363	241518
4345	3349	35	applied	\N	\N	\N	\N	73364	73364	241519
4345	3345	37	applied	\N	\N	\N	\N	73366	73366	241521
4345	3322	38	applied	\N	\N	\N	\N	73367	73367	241522
4348	3469	0	applied	\N	\N	\N	\N	73494	73494	241649
4348	3470	1	applied	\N	\N	\N	\N	73495	73495	241650
4348	3471	2	applied	\N	\N	\N	\N	73496	73496	241651
4351	3473	0	applied	\N	\N	\N	\N	73498	73498	241653
4351	3474	1	applied	\N	\N	\N	\N	73499	73499	241654
4351	3475	2	applied	\N	\N	\N	\N	73500	73500	241655
4351	3476	3	applied	\N	\N	\N	\N	73501	73501	241656
4356	3481	0	applied	\N	\N	\N	\N	73507	73507	241662
4361	3485	0	applied	\N	\N	\N	\N	73513	73513	241668
4366	3489	0	applied	\N	\N	\N	\N	73520	73520	241675
4369	3495	0	applied	\N	\N	\N	\N	73527	73527	241682
4276	3418	73	applied	\N	\N	\N	\N	73107	73107	241264
4276	3420	74	applied	\N	\N	\N	\N	73108	73108	241265
4284	3426	0	applied	\N	\N	\N	\N	73125	73125	241282
4284	3427	1	applied	\N	\N	\N	\N	73126	73126	241283
4284	3428	2	applied	\N	\N	\N	\N	73127	73127	241284
4286	3427	1	applied	\N	\N	\N	\N	73132	73132	241289
4286	3428	2	applied	\N	\N	\N	\N	73133	73133	241290
4288	3426	0	applied	\N	\N	\N	\N	73137	73137	241294
4288	3427	1	applied	\N	\N	\N	\N	73138	73138	241295
4288	3428	2	applied	\N	\N	\N	\N	73139	73139	241296
4291	3431	0	applied	\N	\N	\N	\N	73142	73142	241299
4296	3436	0	applied	\N	\N	\N	\N	73148	73148	241305
4303	3439	0	applied	\N	\N	\N	\N	73152	73152	241309
4305	3440	0	applied	\N	\N	1000000000	\N	73154	73154	241311
4305	3441	1	applied	\N	\N	\N	\N	73155	73155	241312
4310	3445	0	applied	\N	\N	\N	\N	73285	73285	241441
4315	3448	0	applied	\N	\N	\N	\N	73292	73292	241448
4315	3449	1	applied	\N	\N	\N	\N	73293	73293	241449
4315	3450	2	applied	\N	\N	\N	\N	73294	73294	241450
4322	3452	0	applied	\N	\N	\N	\N	73300	73300	241456
4327	3457	0	applied	\N	\N	\N	\N	73308	73308	241464
4332	3459	0	applied	\N	\N	\N	\N	73313	73313	241469
4334	3461	0	applied	\N	\N	\N	\N	73315	73315	241471
4334	3462	1	applied	\N	\N	\N	\N	73316	73316	241472
4346	3468	0	applied	\N	\N	\N	\N	73368	73368	241523
4349	3472	0	applied	\N	\N	\N	\N	73497	73497	241652
4352	3477	0	applied	\N	\N	\N	\N	73502	73502	241657
4354	3478	0	applied	\N	\N	1000000000	\N	73504	73504	241659
4354	3479	1	applied	\N	\N	\N	\N	73505	73505	241660
4357	3481	0	applied	\N	\N	\N	\N	73508	73508	241663
4359	3482	0	applied	\N	\N	\N	\N	73510	73510	241665
4364	3487	0	applied	\N	\N	\N	\N	73517	73517	241672
4364	3488	1	applied	\N	\N	\N	\N	73518	73518	241673
4371	3496	0	applied	\N	\N	\N	\N	73529	73529	241684
4372	3497	0	applied	\N	\N	\N	\N	73530	73530	241685
4374	3497	0	applied	\N	\N	\N	\N	73531	73531	241686
4376	3498	0	applied	\N	\N	\N	\N	73533	73533	241688
4381	3502	0	applied	\N	\N	\N	\N	73538	73538	241693
4383	3502	0	applied	\N	\N	\N	\N	73540	73540	241695
4385	3503	0	applied	\N	\N	\N	\N	73542	73542	241697
4385	3504	1	applied	\N	\N	\N	\N	73543	73543	73543
4387	3505	0	applied	\N	\N	\N	\N	73546	73546	241699
4388	3433	0	applied	\N	\N	1000000000	\N	73547	73547	241700
4388	3437	1	applied	\N	\N	1000000000	\N	73548	73548	241701
4388	3440	2	applied	\N	\N	1000000000	\N	73549	73549	241702
4388	3478	3	applied	\N	\N	1000000000	\N	73550	73550	241703
4388	3483	4	applied	\N	\N	1000000000	\N	73551	73551	241704
4388	3429	5	applied	\N	\N	\N	\N	73552	73552	241705
4388	3492	6	applied	\N	\N	\N	\N	73553	73553	241706
4388	3430	7	applied	\N	\N	\N	\N	73554	73554	241707
4388	3431	8	applied	\N	\N	\N	\N	73555	73555	241708
4388	3432	9	applied	\N	\N	\N	\N	73556	73556	241709
4388	3434	10	applied	\N	\N	\N	\N	73557	73557	241710
4388	3436	12	applied	\N	\N	\N	\N	73559	73559	241712
4388	3438	13	applied	\N	\N	\N	\N	73560	73560	241713
4388	3439	14	applied	\N	\N	\N	\N	73561	73561	241714
4388	3441	15	applied	\N	\N	\N	\N	73562	73562	241715
4388	3442	16	applied	\N	\N	\N	\N	73563	73563	241716
4388	3443	17	applied	\N	\N	\N	\N	73564	73564	241717
4388	3445	18	applied	\N	\N	\N	\N	73565	73565	241718
4388	3446	19	applied	\N	\N	\N	\N	73566	73566	241719
4388	3447	20	applied	\N	\N	\N	\N	73567	73567	241720
4388	3448	21	applied	\N	\N	\N	\N	73568	73568	241721
4388	3493	22	applied	\N	\N	\N	\N	73569	73569	241722
4388	3504	23	applied	\N	\N	\N	\N	73570	73570	73570
4388	3449	24	applied	\N	\N	\N	\N	73571	73571	241723
4388	3450	25	applied	\N	\N	\N	\N	73572	73572	241724
4388	3451	26	applied	\N	\N	\N	\N	73573	73573	241725
4388	3452	27	applied	\N	\N	\N	\N	73574	73574	241726
4388	3454	29	applied	\N	\N	\N	\N	73576	73576	241728
4388	3455	30	applied	\N	\N	\N	\N	73577	73577	241729
4388	3456	31	applied	\N	\N	\N	\N	73578	73578	241730
4388	3457	32	applied	\N	\N	\N	\N	73579	73579	241731
4388	3458	33	applied	\N	\N	\N	\N	73580	73580	241732
4388	3459	34	applied	\N	\N	\N	\N	73581	73581	241733
4388	3444	35	applied	\N	\N	\N	\N	73582	73582	241734
4388	3460	36	applied	\N	\N	\N	\N	73583	73583	241735
4388	3461	37	applied	\N	\N	\N	\N	73584	73584	241736
4388	3462	38	applied	\N	\N	\N	\N	73585	73585	241737
4388	3463	39	applied	\N	\N	\N	\N	73586	73586	241738
4388	3464	40	applied	\N	\N	\N	\N	73587	73587	241739
4388	3465	41	applied	\N	\N	\N	\N	73588	73588	241740
4388	3466	42	applied	\N	\N	\N	\N	73589	73589	241741
4394	3525	0	applied	\N	\N	\N	\N	73654	73654	241806
4394	3526	1	applied	\N	\N	\N	\N	73655	73655	241807
4394	3528	3	applied	\N	\N	\N	\N	73657	73657	241809
4394	3529	4	applied	\N	\N	\N	\N	73658	73658	241810
4394	3530	5	applied	\N	\N	\N	\N	73659	73659	241811
4394	3531	7	applied	\N	\N	\N	\N	73660	73660	241812
4394	3532	8	applied	\N	\N	\N	\N	73661	73661	241813
4394	3533	9	applied	\N	\N	\N	\N	73662	73662	241814
4394	3534	10	applied	\N	\N	\N	\N	73663	73663	241815
4394	3535	11	applied	\N	\N	\N	\N	73664	73664	241816
4396	3525	0	applied	\N	\N	\N	\N	73670	73670	241822
4396	3526	1	applied	\N	\N	\N	\N	73671	73671	241823
4396	3527	2	applied	\N	\N	\N	\N	73672	73672	241824
4396	3528	3	applied	\N	\N	\N	\N	73673	73673	241825
4396	3529	4	applied	\N	\N	\N	\N	73674	73674	241826
4396	3530	5	applied	\N	\N	\N	\N	73675	73675	241827
4396	3531	7	applied	\N	\N	\N	\N	73676	73676	241828
4396	3532	8	applied	\N	\N	\N	\N	73677	73677	241829
4396	3534	10	applied	\N	\N	\N	\N	73679	73679	241831
4396	3535	11	applied	\N	\N	\N	\N	73680	73680	241832
4401	3546	0	applied	\N	\N	\N	\N	73721	73721	241873
4401	3547	1	applied	\N	\N	\N	\N	73722	73722	241874
4401	3548	2	applied	\N	\N	\N	\N	73723	73723	241875
4401	3549	3	applied	\N	\N	\N	\N	73724	73724	241876
4401	3550	4	applied	\N	\N	\N	\N	73725	73725	241877
4401	3551	5	applied	\N	\N	\N	\N	73726	73726	241878
4401	3552	6	applied	\N	\N	\N	\N	73727	73727	241879
4401	3553	7	applied	\N	\N	\N	\N	73728	73728	241880
4279	3422	1	applied	\N	\N	\N	\N	73120	73120	241277
4281	3424	0	applied	\N	\N	\N	\N	73122	73122	241279
4306	3158	98	applied	\N	\N	\N	\N	73253	73253	241409
4306	3159	99	applied	\N	\N	\N	\N	73254	73254	241410
4306	3160	100	applied	\N	\N	\N	\N	73255	73255	241411
4306	3161	101	applied	\N	\N	\N	\N	73256	73256	241412
4306	3162	102	applied	\N	\N	\N	\N	73257	73257	241413
4306	3163	103	applied	\N	\N	\N	\N	73258	73258	241414
4306	3164	104	applied	\N	\N	\N	\N	73259	73259	241415
4306	3165	105	applied	\N	\N	\N	\N	73260	73260	241416
4306	3166	106	applied	\N	\N	\N	\N	73261	73261	241417
4306	3167	107	applied	\N	\N	\N	\N	73262	73262	241418
4306	3168	108	applied	\N	\N	\N	\N	73263	73263	241419
4306	3169	109	applied	\N	\N	\N	\N	73264	73264	241420
4306	3170	110	applied	\N	\N	\N	\N	73265	73265	241421
4306	3171	111	applied	\N	\N	\N	\N	73266	73266	241422
4306	3172	112	applied	\N	\N	\N	\N	73267	73267	241423
4306	3173	113	applied	\N	\N	\N	\N	73268	73268	241424
4306	3175	115	applied	\N	\N	\N	\N	73270	73270	241426
4306	3176	116	applied	\N	\N	\N	\N	73271	73271	241427
4306	3177	117	applied	\N	\N	\N	\N	73272	73272	241428
4306	3178	118	applied	\N	\N	\N	\N	73273	73273	241429
4306	3179	119	applied	\N	\N	\N	\N	73274	73274	241430
4306	3180	120	applied	\N	\N	\N	\N	73275	73275	241431
4306	3181	121	applied	\N	\N	\N	\N	73276	73276	241432
4306	3182	122	applied	\N	\N	\N	\N	73277	73277	241433
4306	3183	123	applied	\N	\N	\N	\N	73278	73278	241434
4306	3184	124	applied	\N	\N	\N	\N	73279	73279	241435
4306	3185	125	applied	\N	\N	\N	\N	73280	73280	241436
4308	3443	0	applied	\N	\N	\N	\N	73282	73282	241438
4308	3444	1	applied	\N	\N	\N	\N	73283	73283	241439
4313	3446	0	applied	\N	\N	\N	\N	73288	73288	241444
4313	3447	1	applied	\N	\N	\N	\N	73289	73289	241445
4316	3451	0	applied	\N	\N	\N	\N	73295	73295	241451
4320	3452	0	applied	\N	\N	\N	\N	73299	73299	241455
4325	3455	0	applied	\N	\N	\N	\N	73305	73305	241461
4325	3456	1	applied	\N	\N	\N	\N	73306	73306	241462
4335	3463	0	applied	\N	\N	\N	\N	73317	73317	241473
4340	3467	0	applied	\N	\N	\N	\N	73324	73324	241480
4344	3468	0	applied	\N	\N	\N	\N	73328	73328	241484
4347	3186	0	applied	\N	\N	\N	\N	73369	73369	241524
4347	3187	1	applied	\N	\N	\N	\N	73370	73370	241525
4347	3188	3	applied	\N	\N	\N	\N	73371	73371	241526
4347	3189	4	applied	\N	\N	\N	\N	73372	73372	241527
4347	3190	5	applied	\N	\N	\N	\N	73373	73373	241528
4347	3191	6	applied	\N	\N	\N	\N	73374	73374	241529
4347	3192	7	applied	\N	\N	\N	\N	73375	73375	241530
4347	3193	8	applied	\N	\N	\N	\N	73376	73376	241531
4347	3194	9	applied	\N	\N	\N	\N	73377	73377	241532
4347	3195	10	applied	\N	\N	\N	\N	73378	73378	241533
4347	3198	12	applied	\N	\N	\N	\N	73380	73380	241535
4347	3444	13	applied	\N	\N	\N	\N	73381	73381	241536
4347	3199	14	applied	\N	\N	\N	\N	73382	73382	241537
4347	3200	15	applied	\N	\N	\N	\N	73383	73383	241538
4347	3201	16	applied	\N	\N	\N	\N	73384	73384	241539
4347	3202	17	applied	\N	\N	\N	\N	73385	73385	241540
4347	3203	18	applied	\N	\N	\N	\N	73386	73386	241541
4347	3204	19	applied	\N	\N	\N	\N	73387	73387	241542
4347	3205	20	applied	\N	\N	\N	\N	73388	73388	241543
4347	3206	21	applied	\N	\N	\N	\N	73389	73389	241544
4347	3207	22	applied	\N	\N	\N	\N	73390	73390	241545
4347	3208	23	applied	\N	\N	\N	\N	73391	73391	241546
4347	3209	24	applied	\N	\N	\N	\N	73392	73392	241547
4347	3210	25	applied	\N	\N	\N	\N	73393	73393	241548
4347	3211	26	applied	\N	\N	\N	\N	73394	73394	241549
4347	3212	27	applied	\N	\N	\N	\N	73395	73395	241550
4347	3214	29	applied	\N	\N	\N	\N	73397	73397	241552
4347	3215	30	applied	\N	\N	\N	\N	73398	73398	241553
4347	3216	31	applied	\N	\N	\N	\N	73399	73399	241554
4347	3217	32	applied	\N	\N	\N	\N	73400	73400	241555
4347	3218	33	applied	\N	\N	\N	\N	73401	73401	241556
4347	3219	34	applied	\N	\N	\N	\N	73402	73402	241557
4347	3220	35	applied	\N	\N	\N	\N	73403	73403	241558
4347	3221	36	applied	\N	\N	\N	\N	73404	73404	241559
4347	3222	37	applied	\N	\N	\N	\N	73405	73405	241560
4347	3223	38	applied	\N	\N	\N	\N	73406	73406	241561
4347	3224	39	applied	\N	\N	\N	\N	73407	73407	241562
4347	3225	40	applied	\N	\N	\N	\N	73408	73408	241563
4347	3227	41	applied	\N	\N	\N	\N	73409	73409	241564
4388	3467	43	applied	\N	\N	\N	\N	73590	73590	241742
4388	3468	44	applied	\N	\N	\N	\N	73591	73591	241743
4388	3469	45	applied	\N	\N	\N	\N	73592	73592	241744
4388	3471	47	applied	\N	\N	\N	\N	73594	73594	241746
4388	3472	48	applied	\N	\N	\N	\N	73595	73595	241747
4388	3473	49	applied	\N	\N	\N	\N	73596	73596	241748
4388	3474	50	applied	\N	\N	\N	\N	73597	73597	241749
4388	3475	51	applied	\N	\N	\N	\N	73598	73598	241750
4388	3476	52	applied	\N	\N	\N	\N	73599	73599	241751
4388	3477	53	applied	\N	\N	\N	\N	73600	73600	241752
4388	3479	54	applied	\N	\N	\N	\N	73601	73601	241753
4388	3480	55	applied	\N	\N	\N	\N	73602	73602	241754
4388	3481	56	applied	\N	\N	\N	\N	73603	73603	241755
4388	3482	57	applied	\N	\N	\N	\N	73604	73604	241756
4388	3484	58	applied	\N	\N	\N	\N	73605	73605	241757
4388	3485	59	applied	\N	\N	\N	\N	73606	73606	241758
4388	3486	60	applied	\N	\N	\N	\N	73607	73607	241759
4388	3487	61	applied	\N	\N	\N	\N	73608	73608	241760
4388	3488	62	applied	\N	\N	\N	\N	73609	73609	241761
4388	3490	64	applied	\N	\N	\N	\N	73611	73611	241763
4388	3491	65	applied	\N	\N	\N	\N	73612	73612	241764
4388	3494	66	applied	\N	\N	\N	\N	73613	73613	241765
4388	3495	67	applied	\N	\N	\N	\N	73614	73614	241766
4388	3496	68	applied	\N	\N	\N	\N	73615	73615	241767
4388	3497	69	applied	\N	\N	\N	\N	73616	73616	241768
4388	3498	70	applied	\N	\N	\N	\N	73617	73617	241769
4388	3499	71	applied	\N	\N	\N	\N	73618	73618	241770
4388	3500	72	applied	\N	\N	\N	\N	73619	73619	241771
4388	3501	73	applied	\N	\N	\N	\N	73620	73620	241772
4388	3502	74	applied	\N	\N	\N	\N	73621	73621	241773
4388	3503	75	applied	\N	\N	\N	\N	73622	73622	241774
4388	3505	76	applied	\N	\N	\N	\N	73623	73623	241775
4390	3506	0	applied	\N	\N	\N	\N	73627	73627	241779
4306	3155	95	applied	\N	\N	\N	\N	73250	73250	241406
4306	3156	96	applied	\N	\N	\N	\N	73251	73251	241407
4347	3232	46	applied	\N	\N	\N	\N	73414	73414	241569
4347	3233	47	applied	\N	\N	\N	\N	73415	73415	241570
4347	3234	48	applied	\N	\N	\N	\N	73416	73416	241571
4347	3235	49	applied	\N	\N	\N	\N	73417	73417	241572
4347	3236	50	applied	\N	\N	\N	\N	73418	73418	241573
4347	3237	51	applied	\N	\N	\N	\N	73419	73419	241574
4347	3238	52	applied	\N	\N	\N	\N	73420	73420	241575
4347	3239	53	applied	\N	\N	\N	\N	73421	73421	241576
4347	3240	54	applied	\N	\N	\N	\N	73422	73422	241577
4347	3241	55	applied	\N	\N	\N	\N	73423	73423	241578
4347	3242	56	applied	\N	\N	\N	\N	73424	73424	241579
4347	3243	57	applied	\N	\N	\N	\N	73425	73425	241580
4347	3244	58	applied	\N	\N	\N	\N	73426	73426	241581
4347	3245	59	applied	\N	\N	\N	\N	73427	73427	241582
4347	3246	60	applied	\N	\N	\N	\N	73428	73428	241583
4347	3247	61	applied	\N	\N	\N	\N	73429	73429	241584
4347	3251	63	applied	\N	\N	\N	\N	73431	73431	241586
4347	3252	64	applied	\N	\N	\N	\N	73432	73432	241587
4347	3253	65	applied	\N	\N	\N	\N	73433	73433	241588
4347	3254	66	applied	\N	\N	\N	\N	73434	73434	241589
4347	3255	67	applied	\N	\N	\N	\N	73435	73435	241590
4347	3256	68	applied	\N	\N	\N	\N	73436	73436	241591
4347	3257	69	applied	\N	\N	\N	\N	73437	73437	241592
4347	3258	70	applied	\N	\N	\N	\N	73438	73438	241593
4347	3259	71	applied	\N	\N	\N	\N	73439	73439	241594
4347	3260	72	applied	\N	\N	\N	\N	73440	73440	241595
4347	3261	73	applied	\N	\N	\N	\N	73441	73441	241596
4347	3262	74	applied	\N	\N	\N	\N	73442	73442	241597
4347	3264	75	applied	\N	\N	\N	\N	73443	73443	241598
4347	3266	76	applied	\N	\N	\N	\N	73444	73444	241599
4347	3267	77	applied	\N	\N	\N	\N	73445	73445	241600
4347	3268	78	applied	\N	\N	\N	\N	73446	73446	241601
4347	3271	80	applied	\N	\N	\N	\N	73448	73448	241603
4347	3273	81	applied	\N	\N	\N	\N	73449	73449	241604
4347	3274	82	applied	\N	\N	\N	\N	73450	73450	241605
4347	3275	83	applied	\N	\N	\N	\N	73451	73451	241606
4347	3276	84	applied	\N	\N	\N	\N	73452	73452	241607
4347	3277	85	applied	\N	\N	\N	\N	73453	73453	241608
4347	3278	86	applied	\N	\N	\N	\N	73454	73454	241609
4347	3279	87	applied	\N	\N	\N	\N	73455	73455	241610
4347	3280	88	applied	\N	\N	\N	\N	73456	73456	241611
4347	3281	89	applied	\N	\N	\N	\N	73457	73457	241612
4347	3282	90	applied	\N	\N	\N	\N	73458	73458	241613
4347	3283	91	applied	\N	\N	\N	\N	73459	73459	241614
4347	3284	92	applied	\N	\N	\N	\N	73460	73460	241615
4347	3285	93	applied	\N	\N	\N	\N	73461	73461	241616
4347	3286	94	applied	\N	\N	\N	\N	73462	73462	241617
4347	3287	95	applied	\N	\N	\N	\N	73463	73463	241618
4347	3289	97	applied	\N	\N	\N	\N	73465	73465	241620
4347	3290	98	applied	\N	\N	\N	\N	73466	73466	241621
4347	3297	99	applied	\N	\N	\N	\N	73467	73467	241622
4347	3298	100	applied	\N	\N	\N	\N	73468	73468	241623
4347	3299	101	applied	\N	\N	\N	\N	73469	73469	241624
4347	3300	102	applied	\N	\N	\N	\N	73470	73470	241625
4347	3301	103	applied	\N	\N	\N	\N	73471	73471	241626
4347	3302	104	applied	\N	\N	\N	\N	73472	73472	241627
4347	3303	105	applied	\N	\N	\N	\N	73473	73473	241628
4347	3304	106	applied	\N	\N	\N	\N	73474	73474	241629
4347	3305	107	applied	\N	\N	\N	\N	73475	73475	241630
4347	3306	108	applied	\N	\N	\N	\N	73476	73476	241631
4347	3307	109	applied	\N	\N	\N	\N	73477	73477	241632
4347	3308	110	applied	\N	\N	\N	\N	73478	73478	241633
4347	3309	111	applied	\N	\N	\N	\N	73479	73479	241634
4347	3310	112	applied	\N	\N	\N	\N	73480	73480	241635
4347	3313	114	applied	\N	\N	\N	\N	73482	73482	241637
4347	3314	115	applied	\N	\N	\N	\N	73483	73483	241638
4347	3315	116	applied	\N	\N	\N	\N	73484	73484	241639
4347	3317	117	applied	\N	\N	\N	\N	73485	73485	241640
4347	3318	118	applied	\N	\N	\N	\N	73486	73486	241641
4347	3319	119	applied	\N	\N	\N	\N	73487	73487	241642
4347	3320	120	applied	\N	\N	\N	\N	73488	73488	241643
4347	3321	121	applied	\N	\N	\N	\N	73489	73489	241644
4347	3323	122	applied	\N	\N	\N	\N	73490	73490	241645
4347	3324	123	applied	\N	\N	\N	\N	73491	73491	241646
4347	3325	124	applied	\N	\N	\N	\N	73492	73492	241647
4347	3326	125	applied	\N	\N	\N	\N	73493	73493	241648
4353	3477	0	applied	\N	\N	\N	\N	73503	73503	241658
4355	3480	0	applied	\N	\N	\N	\N	73506	73506	241661
4362	3486	0	applied	\N	\N	\N	\N	73514	73514	241669
4365	3489	0	applied	\N	\N	\N	\N	73519	73519	241674
4370	3496	0	applied	\N	\N	\N	\N	73528	73528	241683
4379	3500	0	applied	\N	\N	\N	\N	73536	73536	241691
4386	3503	0	applied	\N	\N	\N	\N	73544	73544	241698
4386	3504	1	applied	\N	\N	\N	\N	73545	73545	73545
4393	3513	0	applied	\N	\N	\N	\N	73642	73642	241794
4393	3514	1	applied	\N	\N	\N	\N	73643	73643	241795
4393	3515	2	applied	\N	\N	\N	\N	73644	73644	241796
4393	3516	3	applied	\N	\N	\N	\N	73645	73645	241797
4393	3517	4	applied	\N	\N	\N	\N	73646	73646	241798
4393	3518	5	applied	\N	\N	\N	\N	73647	73647	241799
4393	3519	6	applied	\N	\N	\N	\N	73648	73648	241800
4393	3520	7	applied	\N	\N	\N	\N	73649	73649	241801
4393	3521	8	applied	\N	\N	\N	\N	73650	73650	241802
4393	3522	9	applied	\N	\N	\N	\N	73651	73651	241803
4393	3523	10	applied	\N	\N	\N	\N	73652	73652	241804
4393	3524	11	applied	\N	\N	\N	\N	73653	73653	241805
4400	3547	1	applied	\N	\N	\N	\N	73712	73712	241864
4400	3548	2	applied	\N	\N	\N	\N	73713	73713	241865
4400	3549	3	applied	\N	\N	\N	\N	73714	73714	241866
4400	3550	4	applied	\N	\N	\N	\N	73715	73715	241867
4400	3551	5	applied	\N	\N	\N	\N	73716	73716	241868
4400	3552	6	applied	\N	\N	\N	\N	73717	73717	241869
4400	3553	7	applied	\N	\N	\N	\N	73718	73718	241870
4400	3554	8	applied	\N	\N	\N	\N	73719	73719	241871
4400	3555	9	applied	\N	\N	\N	\N	73720	73720	241872
4404	3556	0	applied	\N	\N	\N	\N	73751	73751	241903
4404	3557	1	applied	\N	\N	\N	\N	73752	73752	241904
4404	3558	2	applied	\N	\N	\N	\N	73753	73753	241905
4404	3559	3	applied	\N	\N	\N	\N	73754	73754	241906
4404	3560	4	applied	\N	\N	\N	\N	73755	73755	241907
4347	3229	43	applied	\N	\N	\N	\N	73411	73411	241566
4347	3230	44	applied	\N	\N	\N	\N	73412	73412	241567
4392	3507	1	applied	\N	\N	\N	\N	73635	73635	241787
4392	3509	2	applied	\N	\N	\N	\N	73636	73636	241788
4392	3510	3	applied	\N	\N	\N	\N	73637	73637	241789
4392	3505	4	applied	\N	\N	\N	\N	73638	73638	241790
4392	3508	5	applied	\N	\N	\N	\N	73639	73639	241791
4392	3512	7	applied	\N	\N	\N	\N	73641	73641	241793
4395	3525	0	applied	\N	\N	\N	\N	73665	73665	241817
4395	3526	1	applied	\N	\N	\N	\N	73666	73666	241818
4395	3527	2	applied	\N	\N	\N	\N	73667	73667	241819
4395	3528	3	applied	\N	\N	\N	\N	73668	73668	241820
4395	3529	4	applied	\N	\N	\N	\N	73669	73669	241821
4397	3536	0	applied	\N	\N	\N	\N	73681	73681	241833
4397	3537	1	applied	\N	\N	\N	\N	73682	73682	241834
4397	3538	2	applied	\N	\N	\N	\N	73683	73683	241835
4397	3539	3	applied	\N	\N	\N	\N	73684	73684	241836
4397	3540	4	applied	\N	\N	\N	\N	73685	73685	241837
4397	3541	5	applied	\N	\N	\N	\N	73686	73686	241838
4397	3542	6	applied	\N	\N	\N	\N	73687	73687	241839
4397	3543	7	applied	\N	\N	\N	\N	73688	73688	241840
4397	3544	8	applied	\N	\N	\N	\N	73689	73689	241841
4397	3545	9	applied	\N	\N	\N	\N	73690	73690	241842
4399	3547	1	applied	\N	\N	\N	\N	73702	73702	241854
4399	3548	2	applied	\N	\N	\N	\N	73703	73703	241855
4399	3549	3	applied	\N	\N	\N	\N	73704	73704	241856
4399	3550	4	applied	\N	\N	\N	\N	73705	73705	241857
4399	3551	5	applied	\N	\N	\N	\N	73706	73706	241858
4399	3552	6	applied	\N	\N	\N	\N	73707	73707	241859
4399	3553	7	applied	\N	\N	\N	\N	73708	73708	241860
4399	3554	8	applied	\N	\N	\N	\N	73709	73709	241861
4399	3555	9	applied	\N	\N	\N	\N	73710	73710	241862
4401	3554	8	applied	\N	\N	\N	\N	73729	73729	241881
4401	3555	9	applied	\N	\N	\N	\N	73730	73730	241882
4403	3556	0	applied	\N	\N	\N	\N	73741	73741	241893
4403	3557	1	applied	\N	\N	\N	\N	73742	73742	241894
4403	3558	2	applied	\N	\N	\N	\N	73743	73743	241895
4403	3559	3	applied	\N	\N	\N	\N	73744	73744	241896
4403	3560	4	applied	\N	\N	\N	\N	73745	73745	241897
4403	3562	6	applied	\N	\N	\N	\N	73747	73747	241899
4403	3563	7	applied	\N	\N	\N	\N	73748	73748	241900
4403	3564	8	applied	\N	\N	\N	\N	73749	73749	241901
4403	3565	9	applied	\N	\N	\N	\N	73750	73750	241902
4404	3561	5	applied	\N	\N	\N	\N	73756	73756	241908
4404	3562	6	applied	\N	\N	\N	\N	73757	73757	241909
4404	3563	7	applied	\N	\N	\N	\N	73758	73758	241910
4404	3564	8	applied	\N	\N	\N	\N	73759	73759	241911
4404	3565	9	applied	\N	\N	\N	\N	73760	73760	241912
4405	3566	0	applied	\N	\N	\N	\N	73761	73761	241913
4405	3567	1	applied	\N	\N	\N	\N	73762	73762	241914
4405	3568	2	applied	\N	\N	\N	\N	73763	73763	241915
4405	3569	3	applied	\N	\N	\N	\N	73764	73764	241916
4405	3570	4	applied	\N	\N	\N	\N	73765	73765	241917
4405	3571	5	applied	\N	\N	\N	\N	73766	73766	241918
4405	3572	6	applied	\N	\N	\N	\N	73767	73767	241919
4405	3574	8	applied	\N	\N	\N	\N	73769	73769	241921
4406	3566	0	applied	\N	\N	\N	\N	73770	73770	241922
4406	3567	1	applied	\N	\N	\N	\N	73771	73771	241923
4406	3568	2	applied	\N	\N	\N	\N	73772	73772	241924
4406	3569	3	applied	\N	\N	\N	\N	73773	73773	241925
4406	3570	4	applied	\N	\N	\N	\N	73774	73774	241926
4406	3571	5	applied	\N	\N	\N	\N	73775	73775	241927
4406	3572	6	applied	\N	\N	\N	\N	73776	73776	241928
4406	3573	7	applied	\N	\N	\N	\N	73777	73777	241929
4406	3574	8	applied	\N	\N	\N	\N	73778	73778	241930
4407	3419	0	applied	\N	\N	1000000000	\N	73779	73779	241931
4407	3433	1	applied	\N	\N	1000000000	\N	73780	73780	241932
4407	3437	2	applied	\N	\N	1000000000	\N	73781	73781	241933
4407	3440	3	applied	\N	\N	1000000000	\N	73782	73782	241934
4407	3483	5	applied	\N	\N	1000000000	\N	73784	73784	241936
4407	3414	6	applied	\N	\N	\N	\N	73785	73785	241937
4407	3492	7	applied	\N	\N	\N	\N	73786	73786	241938
4407	3493	8	applied	\N	\N	\N	\N	73787	73787	241939
4407	3415	9	applied	\N	\N	\N	\N	73788	73788	241940
4407	3416	10	applied	\N	\N	\N	\N	73789	73789	241941
4407	3417	11	applied	\N	\N	\N	\N	73790	73790	241942
4407	3418	12	applied	\N	\N	\N	\N	73791	73791	241943
4407	3420	13	applied	\N	\N	\N	\N	73792	73792	241944
4407	3421	14	applied	\N	\N	\N	\N	73793	73793	241945
4407	3422	15	applied	\N	\N	\N	\N	73794	73794	241946
4407	3423	16	applied	\N	\N	\N	\N	73795	73795	241947
4407	3424	17	applied	\N	\N	\N	\N	73796	73796	241948
4407	3504	18	applied	\N	\N	\N	\N	73797	73797	73797
4407	3506	19	applied	\N	\N	\N	\N	73798	73798	241949
4407	3513	20	applied	\N	\N	\N	\N	73799	73799	241950
4407	3514	21	applied	\N	\N	\N	\N	73800	73800	241951
4407	3526	22	applied	\N	\N	\N	\N	73801	73801	241952
4407	3425	23	applied	\N	\N	\N	\N	73802	73802	241953
4407	3426	24	applied	\N	\N	\N	\N	73803	73803	241954
4407	3428	26	applied	\N	\N	\N	\N	73805	73805	241956
4407	3429	27	applied	\N	\N	\N	\N	73806	73806	241957
4407	3430	28	applied	\N	\N	\N	\N	73807	73807	241958
4407	3431	29	applied	\N	\N	\N	\N	73808	73808	241959
4407	3432	30	applied	\N	\N	\N	\N	73809	73809	241960
4407	3434	31	applied	\N	\N	\N	\N	73810	73810	241961
4407	3435	32	applied	\N	\N	\N	\N	73811	73811	241962
4407	3436	33	applied	\N	\N	\N	\N	73812	73812	241963
4407	3438	34	applied	\N	\N	\N	\N	73813	73813	241964
4407	3439	35	applied	\N	\N	\N	\N	73814	73814	241965
4407	3441	36	applied	\N	\N	\N	\N	73815	73815	241966
4407	3442	37	applied	\N	\N	\N	\N	73816	73816	241967
4407	3443	38	applied	\N	\N	\N	\N	73817	73817	241968
4407	3445	39	applied	\N	\N	\N	\N	73818	73818	241969
4407	3446	40	applied	\N	\N	\N	\N	73819	73819	241970
4407	3447	41	applied	\N	\N	\N	\N	73820	73820	241971
4407	3449	43	applied	\N	\N	\N	\N	73822	73822	241973
4407	3450	44	applied	\N	\N	\N	\N	73823	73823	241974
4407	3451	45	applied	\N	\N	\N	\N	73824	73824	241975
4407	3452	46	applied	\N	\N	\N	\N	73825	73825	241976
4407	3453	47	applied	\N	\N	\N	\N	73826	73826	241977
4407	3454	48	applied	\N	\N	\N	\N	73827	73827	241978
4390	3508	2	applied	\N	\N	\N	\N	73629	73629	241781
4392	3506	0	applied	\N	\N	\N	\N	73634	73634	241786
4407	3458	52	applied	\N	\N	\N	\N	73831	73831	241982
4407	3459	53	applied	\N	\N	\N	\N	73832	73832	241983
4407	3444	54	applied	\N	\N	\N	\N	73833	73833	241984
4407	3507	55	applied	\N	\N	\N	\N	73834	73834	241985
4407	3509	56	applied	\N	\N	\N	\N	73835	73835	241986
4407	3510	57	applied	\N	\N	\N	\N	73836	73836	241987
4407	3512	58	applied	\N	\N	\N	\N	73837	73837	241988
4407	3516	59	applied	\N	\N	\N	\N	73838	73838	241989
4407	3517	60	applied	\N	\N	\N	\N	73839	73839	241990
4407	3518	61	applied	\N	\N	\N	\N	73840	73840	241991
4407	3519	62	applied	\N	\N	\N	\N	73841	73841	241992
4407	3521	64	applied	\N	\N	\N	\N	73843	73843	241994
4407	3522	65	applied	\N	\N	\N	\N	73844	73844	241995
4407	3523	66	applied	\N	\N	\N	\N	73845	73845	241996
4407	3524	67	applied	\N	\N	\N	\N	73846	73846	241997
4407	3525	68	applied	\N	\N	\N	\N	73847	73847	241998
4407	3527	69	applied	\N	\N	\N	\N	73848	73848	241999
4407	3529	70	applied	\N	\N	\N	\N	73849	73849	242000
4407	3530	71	applied	\N	\N	\N	\N	73850	73850	242001
4407	3531	72	applied	\N	\N	\N	\N	73851	73851	242002
4407	3532	73	applied	\N	\N	\N	\N	73852	73852	242003
4407	3533	74	applied	\N	\N	\N	\N	73853	73853	242004
4407	3534	75	applied	\N	\N	\N	\N	73854	73854	242005
4407	3535	76	applied	\N	\N	\N	\N	73855	73855	242006
4407	3537	77	applied	\N	\N	\N	\N	73856	73856	242007
4407	3538	78	applied	\N	\N	\N	\N	73857	73857	242008
4407	3539	79	applied	\N	\N	\N	\N	73858	73858	242009
4407	3541	81	applied	\N	\N	\N	\N	73860	73860	242011
4407	3542	82	applied	\N	\N	\N	\N	73861	73861	242012
4407	3543	83	applied	\N	\N	\N	\N	73862	73862	242013
4407	3544	84	applied	\N	\N	\N	\N	73863	73863	242014
4407	3545	85	applied	\N	\N	\N	\N	73864	73864	242015
4407	3547	86	applied	\N	\N	\N	\N	73865	73865	242016
4407	3548	87	applied	\N	\N	\N	\N	73866	73866	242017
4407	3549	88	applied	\N	\N	\N	\N	73867	73867	242018
4407	3550	89	applied	\N	\N	\N	\N	73868	73868	242019
4407	3551	90	applied	\N	\N	\N	\N	73869	73869	242020
4407	3460	91	applied	\N	\N	\N	\N	73870	73870	242021
4407	3461	92	applied	\N	\N	\N	\N	73871	73871	242022
4407	3462	93	applied	\N	\N	\N	\N	73872	73872	242023
4407	3463	94	applied	\N	\N	\N	\N	73873	73873	242024
4407	3464	95	applied	\N	\N	\N	\N	73874	73874	242025
4407	3465	96	applied	\N	\N	\N	\N	73875	73875	242026
4407	3467	98	applied	\N	\N	\N	\N	73877	73877	242028
4407	3468	99	applied	\N	\N	\N	\N	73878	73878	242029
4407	3469	100	applied	\N	\N	\N	\N	73879	73879	242030
4407	3470	101	applied	\N	\N	\N	\N	73880	73880	242031
4407	3471	102	applied	\N	\N	\N	\N	73881	73881	242032
4407	3472	103	applied	\N	\N	\N	\N	73882	73882	242033
4407	3473	104	applied	\N	\N	\N	\N	73883	73883	242034
4407	3474	105	applied	\N	\N	\N	\N	73884	73884	242035
4407	3475	106	applied	\N	\N	\N	\N	73885	73885	242036
4407	3476	107	applied	\N	\N	\N	\N	73886	73886	242037
4407	3477	108	applied	\N	\N	\N	\N	73887	73887	242038
4407	3479	109	applied	\N	\N	\N	\N	73888	73888	242039
4407	3480	110	applied	\N	\N	\N	\N	73889	73889	242040
4407	3481	111	applied	\N	\N	\N	\N	73890	73890	242041
4407	3482	112	applied	\N	\N	\N	\N	73891	73891	242042
4407	3484	113	applied	\N	\N	\N	\N	73892	73892	242043
4407	3486	115	applied	\N	\N	\N	\N	73894	73894	242045
4407	3487	116	applied	\N	\N	\N	\N	73895	73895	242046
4407	3488	117	applied	\N	\N	\N	\N	73896	73896	242047
4407	3489	118	applied	\N	\N	\N	\N	73897	73897	242048
4407	3490	119	applied	\N	\N	\N	\N	73898	73898	242049
4407	3491	120	applied	\N	\N	\N	\N	73899	73899	242050
4407	3494	121	applied	\N	\N	\N	\N	73900	73900	242051
4407	3495	123	applied	\N	\N	\N	\N	73901	73901	242052
4407	3496	124	applied	\N	\N	\N	\N	73902	73902	242053
4407	3497	125	applied	\N	\N	\N	\N	73903	73903	242054
4408	3575	0	applied	\N	\N	\N	\N	73904	73904	242055
4408	3576	1	applied	\N	\N	\N	\N	73905	73905	242056
4408	3577	2	applied	\N	\N	\N	\N	73906	73906	242057
4408	3578	3	applied	\N	\N	\N	\N	73907	73907	242058
4408	3579	4	applied	\N	\N	\N	\N	73908	73908	242059
4408	3580	5	applied	\N	\N	\N	\N	73909	73909	242060
4408	3582	7	applied	\N	\N	\N	\N	73911	73911	242062
4408	3583	8	applied	\N	\N	\N	\N	73912	73912	242063
4408	3584	9	applied	\N	\N	\N	\N	73913	73913	242064
4409	3585	0	applied	\N	\N	\N	\N	73914	73914	242065
4409	3586	1	applied	\N	\N	\N	\N	73915	73915	242066
4409	3587	2	applied	\N	\N	\N	\N	73916	73916	242067
4409	3588	3	applied	\N	\N	\N	\N	73917	73917	242068
4409	3589	4	applied	\N	\N	\N	\N	73918	73918	242069
4409	3590	5	applied	\N	\N	\N	\N	73919	73919	242070
4409	3591	6	applied	\N	\N	\N	\N	73920	73920	242071
4409	3592	7	applied	\N	\N	\N	\N	73921	73921	242072
4409	3593	8	applied	\N	\N	\N	\N	73922	73922	242073
4409	3594	9	applied	\N	\N	\N	\N	73923	73923	242074
4410	3595	0	applied	\N	\N	\N	\N	73924	73924	242075
4410	3596	1	applied	\N	\N	\N	\N	73925	73925	242076
4410	3597	2	applied	\N	\N	\N	\N	73926	73926	242077
4410	3599	4	applied	\N	\N	\N	\N	73928	73928	242079
4410	3600	5	applied	\N	\N	\N	\N	73929	73929	242080
4410	3601	6	applied	\N	\N	\N	\N	73930	73930	242081
4410	3602	7	applied	\N	\N	\N	\N	73931	73931	242082
4410	3603	8	applied	\N	\N	\N	\N	73932	73932	242083
4410	3604	9	applied	\N	\N	\N	\N	73933	73933	242084
4412	3605	0	applied	\N	\N	\N	\N	73944	73944	242095
4412	3606	1	applied	\N	\N	\N	\N	73945	73945	242096
4412	3607	2	applied	\N	\N	\N	\N	73946	73946	242097
4412	3608	3	applied	\N	\N	\N	\N	73947	73947	242098
4412	3609	4	applied	\N	\N	\N	\N	73948	73948	242099
4412	3610	5	applied	\N	\N	\N	\N	73949	73949	242100
4412	3611	6	applied	\N	\N	\N	\N	73950	73950	242101
4412	3612	7	applied	\N	\N	\N	\N	73951	73951	242102
4412	3613	8	applied	\N	\N	\N	\N	73952	73952	242103
4412	3614	9	applied	\N	\N	\N	\N	73953	73953	242104
4413	3616	1	applied	\N	\N	1000000000	\N	73955	73955	242106
4413	3617	2	applied	\N	\N	1000000000	\N	73956	73956	242107
4407	3456	50	applied	\N	\N	\N	\N	73829	73829	241980
4407	3457	51	applied	\N	\N	\N	\N	73830	73830	241981
4411	3608	3	applied	\N	\N	\N	\N	73937	73937	242088
4411	3609	4	applied	\N	\N	\N	\N	73938	73938	242089
4411	3610	5	applied	\N	\N	\N	\N	73939	73939	242090
4411	3611	6	applied	\N	\N	\N	\N	73940	73940	242091
4411	3612	7	applied	\N	\N	\N	\N	73941	73941	242092
4411	3613	8	applied	\N	\N	\N	\N	73942	73942	242093
4411	3614	9	applied	\N	\N	\N	\N	73943	73943	242094
4413	3618	3	applied	\N	\N	\N	\N	73957	73957	242108
4413	3619	4	applied	\N	\N	\N	\N	73958	73958	242109
4413	3620	5	applied	\N	\N	\N	\N	73959	73959	242110
4413	3622	7	applied	\N	\N	\N	\N	73961	73961	242112
4413	3623	8	applied	\N	\N	\N	\N	73962	73962	242113
4413	3624	9	applied	\N	\N	\N	\N	73963	73963	242114
4413	3625	10	applied	\N	\N	\N	\N	73964	73964	242115
4413	3626	11	applied	\N	\N	\N	\N	73965	73965	242116
4413	3627	12	applied	\N	\N	\N	\N	73966	73966	242117
4414	3628	0	applied	\N	\N	\N	\N	73967	73967	242118
4414	3629	1	applied	\N	\N	\N	\N	73968	73968	242119
4414	3630	2	applied	\N	\N	\N	\N	73969	73969	242120
4414	3631	3	applied	\N	\N	\N	\N	73970	73970	242121
4414	3632	4	applied	\N	\N	\N	\N	73971	73971	242122
4414	3633	5	applied	\N	\N	\N	\N	73972	73972	242123
4414	3634	6	applied	\N	\N	\N	\N	73973	73973	242124
4414	3635	7	applied	\N	\N	\N	\N	73974	73974	242125
4414	3636	8	applied	\N	\N	\N	\N	73975	73975	242126
4415	3628	0	applied	\N	\N	\N	\N	73976	73976	242127
4415	3630	2	applied	\N	\N	\N	\N	73978	73978	242129
4415	3631	3	applied	\N	\N	\N	\N	73979	73979	242130
4415	3632	4	applied	\N	\N	\N	\N	73980	73980	242131
4415	3633	5	applied	\N	\N	\N	\N	73981	73981	242132
4415	3634	6	applied	\N	\N	\N	\N	73982	73982	242133
4415	3635	7	applied	\N	\N	\N	\N	73983	73983	242134
4415	3636	8	applied	\N	\N	\N	\N	73984	73984	242135
4415	3637	9	applied	\N	\N	\N	\N	73985	73985	242136
4415	3638	11	applied	\N	\N	\N	\N	73986	73986	242137
4415	3639	12	applied	\N	\N	\N	\N	73987	73987	242138
4416	3628	0	applied	\N	\N	\N	\N	73988	73988	242139
4416	3629	1	applied	\N	\N	\N	\N	73989	73989	242140
4416	3630	2	applied	\N	\N	\N	\N	73990	73990	242141
4416	3631	3	applied	\N	\N	\N	\N	73991	73991	242142
4416	3632	4	applied	\N	\N	\N	\N	73992	73992	242143
4416	3633	5	applied	\N	\N	\N	\N	73993	73993	242144
4416	3635	7	applied	\N	\N	\N	\N	73995	73995	242146
4416	3636	8	applied	\N	\N	\N	\N	73996	73996	242147
4416	3637	9	applied	\N	\N	\N	\N	73997	73997	242148
4416	3638	11	applied	\N	\N	\N	\N	73998	73998	242149
4416	3639	12	applied	\N	\N	\N	\N	73999	73999	242150
4417	3640	0	applied	\N	\N	\N	\N	74000	74000	242151
4417	3637	1	applied	\N	\N	\N	\N	74001	74001	242152
4417	3638	2	applied	\N	\N	\N	\N	74002	74002	242153
4417	3641	3	applied	\N	\N	\N	\N	74003	74003	242154
4417	3639	4	applied	\N	\N	\N	\N	74004	74004	242155
4417	3642	5	applied	\N	\N	\N	\N	74005	74005	242156
4417	3643	6	applied	\N	\N	\N	\N	74006	74006	242157
4417	3644	7	applied	\N	\N	\N	\N	74007	74007	74007
4417	3645	8	applied	\N	\N	\N	\N	74008	74008	242158
4419	3640	0	applied	\N	\N	\N	\N	74009	74009	242159
4419	3637	1	applied	\N	\N	\N	\N	74010	74010	242160
4419	3641	3	applied	\N	\N	\N	\N	74012	74012	242162
4419	3639	4	applied	\N	\N	\N	\N	74013	74013	242163
4419	3642	5	applied	\N	\N	\N	\N	74014	74014	242164
4419	3643	6	applied	\N	\N	\N	\N	74015	74015	242165
4419	3644	7	applied	\N	\N	\N	\N	74016	74016	74016
4419	3645	8	applied	\N	\N	\N	\N	74017	74017	242166
4424	3478	0	applied	\N	\N	1000000000	\N	74026	74026	242175
4424	3483	1	applied	\N	\N	1000000000	\N	74027	74027	242176
4424	3615	2	applied	\N	\N	1000000000	\N	74028	74028	242177
4424	3616	3	applied	\N	\N	1000000000	\N	74029	74029	242178
4424	3617	4	applied	\N	\N	1000000000	\N	74030	74030	242179
4424	3618	5	applied	\N	\N	\N	\N	74031	74031	242180
4424	3646	6	applied	\N	\N	1000000000	\N	74032	74032	242181
4424	3652	7	applied	\N	\N	1000000000	\N	74033	74033	242182
4424	3507	8	applied	\N	\N	\N	\N	74034	74034	242183
4424	3509	9	applied	\N	\N	\N	\N	74035	74035	242184
4424	3492	11	applied	\N	\N	\N	\N	74037	74037	242186
4424	3493	12	applied	\N	\N	\N	\N	74038	74038	242187
4424	3504	13	applied	\N	\N	\N	\N	74039	74039	74039
4424	3506	14	applied	\N	\N	\N	\N	74040	74040	242188
4424	3513	15	applied	\N	\N	\N	\N	74041	74041	242189
4424	3514	16	applied	\N	\N	\N	\N	74042	74042	242190
4424	3526	17	applied	\N	\N	\N	\N	74043	74043	242191
4424	3512	18	applied	\N	\N	\N	\N	74044	74044	242192
4424	3516	19	applied	\N	\N	\N	\N	74045	74045	242193
4424	3517	20	applied	\N	\N	\N	\N	74046	74046	242194
4424	3518	21	applied	\N	\N	\N	\N	74047	74047	242195
4429	3656	0	applied	\N	\N	\N	\N	74053	74053	242201
4431	3615	0	applied	\N	\N	1000000000	\N	74055	74055	242203
4431	3616	1	applied	\N	\N	1000000000	\N	74056	74056	242204
4431	3618	3	applied	\N	\N	\N	\N	74058	74058	242206
4431	3646	4	applied	\N	\N	1000000000	\N	74059	74059	242207
4431	3652	5	applied	\N	\N	1000000000	\N	74060	74060	242208
4431	3566	6	applied	\N	\N	\N	\N	74061	74061	242209
4431	3575	7	applied	\N	\N	\N	\N	74062	74062	242210
4431	3586	8	applied	\N	\N	\N	\N	74063	74063	242211
4431	3598	9	applied	\N	\N	\N	\N	74064	74064	242212
4431	3605	10	applied	\N	\N	\N	\N	74065	74065	242213
4431	3621	11	applied	\N	\N	\N	\N	74066	74066	242214
4431	3630	12	applied	\N	\N	\N	\N	74067	74067	242215
4431	3631	13	applied	\N	\N	\N	\N	74068	74068	242216
4431	3632	14	applied	\N	\N	\N	\N	74069	74069	242217
4431	3633	15	applied	\N	\N	\N	\N	74070	74070	242218
4431	3640	16	applied	\N	\N	\N	\N	74071	74071	242219
4431	3641	17	applied	\N	\N	\N	\N	74072	74072	242220
4431	3648	18	applied	\N	\N	\N	\N	74073	74073	242221
4431	3649	19	applied	\N	\N	\N	\N	74074	74074	242222
4431	3650	20	applied	\N	\N	\N	\N	74075	74075	242223
4431	3651	21	applied	\N	\N	\N	\N	74076	74076	242224
4431	3653	22	applied	\N	\N	\N	\N	74077	74077	242225
4411	3606	1	applied	\N	\N	\N	\N	73935	73935	242086
4411	3607	2	applied	\N	\N	\N	\N	73936	73936	242087
4423	3651	0	applied	\N	\N	\N	\N	74025	74025	242174
4428	3655	0	applied	\N	\N	\N	\N	74052	74052	242200
4430	3656	0	applied	\N	\N	\N	\N	74054	74054	242202
4431	3655	24	applied	\N	\N	\N	\N	74079	74079	242227
4431	3656	25	applied	\N	\N	\N	\N	74080	74080	242228
4431	3643	26	applied	\N	\N	\N	\N	74081	74081	242229
4431	3645	28	applied	\N	\N	\N	\N	74083	74083	242230
4433	3657	0	applied	\N	\N	1000000000	\N	74088	74088	242235
4433	3658	1	applied	\N	\N	\N	\N	74089	74089	242236
4433	3659	2	applied	\N	\N	\N	\N	74090	74090	242237
4433	3660	3	applied	\N	\N	\N	\N	74091	74091	242238
4434	3661	0	applied	\N	\N	\N	\N	74092	74092	242239
4434	3662	1	applied	\N	\N	\N	\N	74093	74093	242240
4435	3661	0	applied	\N	\N	\N	\N	74094	74094	242241
4435	3662	1	applied	\N	\N	\N	\N	74095	74095	242242
4436	3661	0	applied	\N	\N	\N	\N	74096	74096	242243
4436	3662	1	applied	\N	\N	\N	\N	74097	74097	242244
4438	3663	0	applied	\N	\N	\N	\N	74100	74100	242247
4438	3664	1	applied	\N	\N	\N	\N	74101	74101	242248
4440	3666	0	applied	\N	\N	\N	\N	74103	74103	242250
4441	3666	0	applied	\N	\N	\N	\N	74104	74104	242251
4442	3668	1	applied	\N	\N	\N	\N	74106	74106	242253
4442	3669	2	applied	\N	\N	\N	\N	74107	74107	242254
4442	3670	3	applied	\N	\N	1000000000	\N	74108	74108	242255
4447	3671	0	applied	\N	\N	\N	\N	74121	74121	242266
4452	3675	0	applied	\N	\N	\N	\N	74153	74153	242294
4447	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	74122	74122	\N
4453	3676	0	applied	\N	\N	\N	\N	74154	74154	242295
4453	3677	1	applied	\N	\N	\N	\N	74155	74155	242296
4456	3679	0	applied	\N	\N	\N	\N	74158	74158	242299
4458	3680	0	applied	\N	\N	1000000000	\N	74160	74160	242301
4458	3681	1	applied	\N	\N	\N	\N	74161	74161	242302
4458	3682	2	applied	\N	\N	\N	\N	74162	74162	242303
4459	3683	0	applied	\N	\N	\N	\N	74163	74163	242304
4461	3389	0	applied	\N	\N	1000000000	\N	74168	74168	242309
4461	3399	1	applied	\N	\N	\N	\N	74169	74169	242310
4461	3419	2	applied	\N	\N	1000000000	\N	74170	74170	242311
4461	3433	3	applied	\N	\N	1000000000	\N	74171	74171	242312
4461	3440	5	applied	\N	\N	1000000000	\N	74173	74173	242314
4461	3478	6	applied	\N	\N	1000000000	\N	74174	74174	242315
4461	3483	7	applied	\N	\N	1000000000	\N	74175	74175	242316
4461	3615	8	applied	\N	\N	1000000000	\N	74176	74176	242317
4461	3616	9	applied	\N	\N	1000000000	\N	74177	74177	242318
4461	3617	10	applied	\N	\N	1000000000	\N	74178	74178	242319
4461	3618	11	applied	\N	\N	\N	\N	74179	74179	242320
4461	3646	12	applied	\N	\N	1000000000	\N	74180	74180	242321
4461	3652	13	applied	\N	\N	1000000000	\N	74181	74181	242322
4461	3657	14	applied	\N	\N	1000000000	\N	74182	74182	242323
4461	3667	15	applied	\N	\N	1000000000	\N	74183	74183	242324
4461	3668	16	applied	\N	\N	\N	\N	74184	74184	242325
4461	3680	17	applied	\N	\N	1000000000	\N	74185	74185	242326
4461	3684	18	applied	\N	\N	1000000000	\N	74186	74186	242327
4461	3685	19	applied	\N	\N	1000000000	\N	74187	74187	242328
4461	3492	20	applied	\N	\N	\N	\N	74188	74188	242329
4461	3493	21	applied	\N	\N	\N	\N	74189	74189	242330
4461	3504	22	applied	\N	\N	\N	\N	74190	74190	74190
4464	3688	0	applied	\N	\N	\N	\N	74295	74295	242435
4471	3693	0	applied	\N	\N	\N	\N	74303	74303	242443
4471	3695	2	applied	\N	\N	\N	\N	74305	74305	242445
4479	3703	0	applied	\N	\N	\N	\N	74320	74320	74320
4479	3704	2	applied	\N	\N	\N	\N	74321	74321	242459
4479	3705	3	applied	\N	\N	\N	\N	74322	74322	242460
4483	3706	0	applied	\N	\N	\N	\N	74331	74331	242466
4488	3709	0	applied	\N	\N	\N	\N	74336	74336	242471
4490	3710	0	applied	\N	\N	\N	\N	74338	74338	242473
4495	3711	0	applied	\N	\N	\N	\N	74348	74348	242483
4495	3712	1	applied	\N	\N	\N	\N	74349	74349	242484
4495	3713	2	applied	\N	\N	\N	\N	74350	74350	242485
4497	3714	0	applied	\N	\N	1000000000	\N	74356	74356	242491
4497	3715	1	applied	\N	\N	\N	\N	74357	74357	242492
4497	3716	2	applied	\N	\N	\N	\N	74358	74358	242493
4497	3717	3	applied	\N	\N	\N	\N	74359	74359	242494
4497	3718	4	applied	\N	\N	\N	\N	74360	74360	242495
4499	3712	0	applied	\N	\N	\N	\N	74366	74366	242501
4503	3724	0	applied	\N	\N	\N	\N	74375	74375	242510
4503	3725	1	applied	\N	\N	\N	\N	74376	74376	242511
4507	3727	0	applied	\N	\N	\N	\N	74380	74380	242515
4509	3727	0	applied	\N	\N	\N	\N	74382	74382	242517
4511	3680	0	applied	\N	\N	1000000000	\N	74384	74384	242519
4511	3684	1	applied	\N	\N	1000000000	\N	74385	74385	242520
4511	3685	2	applied	\N	\N	1000000000	\N	74386	74386	242521
4511	3693	3	applied	\N	\N	\N	\N	74387	74387	242522
4511	3714	4	applied	\N	\N	1000000000	\N	74388	74388	242523
4511	3719	5	applied	\N	\N	\N	\N	74389	74389	242524
4511	3696	6	applied	\N	\N	1000000000	\N	74390	74390	242525
4511	3687	7	applied	\N	\N	\N	\N	74391	74391	242526
4511	3712	8	applied	\N	\N	\N	\N	74392	74392	242527
4511	3677	9	applied	\N	\N	\N	\N	74393	74393	242528
4511	3715	10	applied	\N	\N	\N	\N	74394	74394	242529
4511	3713	11	applied	\N	\N	\N	\N	74395	74395	242530
4511	3675	13	applied	\N	\N	\N	\N	74397	74397	242532
4511	3676	14	applied	\N	\N	\N	\N	74398	74398	242533
4511	3718	15	applied	\N	\N	\N	\N	74399	74399	242534
4511	3678	16	applied	\N	\N	\N	\N	74400	74400	242535
4511	3679	17	applied	\N	\N	\N	\N	74401	74401	242536
4511	3681	18	applied	\N	\N	\N	\N	74402	74402	242537
4511	3682	19	applied	\N	\N	\N	\N	74403	74403	242538
4511	3683	20	applied	\N	\N	\N	\N	74404	74404	242539
4511	3686	21	applied	\N	\N	\N	\N	74405	74405	242540
4511	3688	22	applied	\N	\N	\N	\N	74406	74406	242541
4511	3689	23	applied	\N	\N	\N	\N	74407	74407	242542
4511	3690	24	applied	\N	\N	\N	\N	74408	74408	242543
4511	3691	25	applied	\N	\N	\N	\N	74409	74409	242544
4511	3692	26	applied	\N	\N	\N	\N	74410	74410	242545
4511	3694	27	applied	\N	\N	\N	\N	74411	74411	242546
4511	3695	28	applied	\N	\N	\N	\N	74412	74412	242547
4420	3647	1	applied	\N	\N	\N	\N	74019	74019	242168
4420	3648	2	applied	\N	\N	\N	\N	74020	74020	242169
4443	3668	1	applied	\N	\N	\N	\N	74110	74110	242257
4443	3669	2	applied	\N	\N	\N	\N	74111	74111	242258
4443	3670	3	applied	\N	\N	1000000000	\N	74112	74112	242259
4445	3671	0	applied	\N	\N	\N	\N	74117	74117	242264
4448	3671	0	applied	\N	\N	\N	\N	74123	74123	242267
4450	3671	0	applied	\N	\N	\N	\N	74149	74149	242292
4448	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	74124	74124	\N
4451	3673	0	applied	\N	\N	\N	\N	74151	74151	242293
4450	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	74150	74150	\N
4454	3678	0	applied	\N	\N	\N	\N	74156	74156	242297
4451	3674	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	74152	74152	\N
4460	3684	0	applied	\N	\N	1000000000	\N	74164	74164	242305
4460	3685	1	applied	\N	\N	1000000000	\N	74165	74165	242306
4460	3686	2	applied	\N	\N	\N	\N	74166	74166	242307
4460	3687	3	applied	\N	\N	\N	\N	74167	74167	242308
4469	3689	0	applied	\N	\N	\N	\N	74299	74299	242439
4469	3690	1	applied	\N	\N	\N	\N	74300	74300	242440
4469	3691	2	applied	\N	\N	\N	\N	74301	74301	242441
4473	3696	0	applied	\N	\N	1000000000	\N	74309	74309	242449
4473	3697	1	applied	\N	\N	\N	\N	74310	74310	242450
4473	3698	2	applied	\N	\N	\N	\N	74311	74311	242451
4473	3699	3	applied	\N	\N	\N	\N	74312	74312	242452
4473	3700	4	applied	\N	\N	\N	\N	74313	74313	242453
4473	3701	5	applied	\N	\N	\N	\N	74314	74314	242454
4482	3703	0	applied	\N	\N	\N	\N	74328	74328	74328
4482	3704	2	applied	\N	\N	\N	\N	74329	74329	242464
4482	3705	3	applied	\N	\N	\N	\N	74330	74330	242465
4484	3706	0	applied	\N	\N	\N	\N	74332	74332	242467
4487	3708	0	applied	\N	\N	\N	\N	74335	74335	242470
4492	3711	0	applied	\N	\N	\N	\N	74342	74342	242477
4492	3712	1	applied	\N	\N	\N	\N	74343	74343	242478
4492	3713	2	applied	\N	\N	\N	\N	74344	74344	242479
4496	3714	0	applied	\N	\N	1000000000	\N	74351	74351	242486
4496	3715	1	applied	\N	\N	\N	\N	74352	74352	242487
4496	3716	2	applied	\N	\N	\N	\N	74353	74353	242488
4496	3717	3	applied	\N	\N	\N	\N	74354	74354	242489
4496	3718	4	applied	\N	\N	\N	\N	74355	74355	242490
4498	3714	0	applied	\N	\N	1000000000	\N	74361	74361	242496
4498	3715	1	applied	\N	\N	\N	\N	74362	74362	242497
4498	3716	2	applied	\N	\N	\N	\N	74363	74363	242498
4498	3717	3	applied	\N	\N	\N	\N	74364	74364	242499
4498	3718	4	applied	\N	\N	\N	\N	74365	74365	242500
4501	3723	0	applied	\N	\N	\N	\N	74372	74372	242507
4506	3726	0	applied	\N	\N	\N	\N	74379	74379	242514
4511	3698	30	applied	\N	\N	\N	\N	74414	74414	242549
4511	3700	32	applied	\N	\N	\N	\N	74416	74416	242551
4511	3701	33	applied	\N	\N	\N	\N	74417	74417	242552
4511	3702	34	applied	\N	\N	\N	\N	74418	74418	242553
4511	3704	35	applied	\N	\N	\N	\N	74419	74419	242554
4511	3705	36	applied	\N	\N	\N	\N	74420	74420	242555
4511	3706	37	applied	\N	\N	\N	\N	74421	74421	242556
4511	3707	38	applied	\N	\N	\N	\N	74422	74422	242557
4511	3708	39	applied	\N	\N	\N	\N	74423	74423	242558
4511	3709	40	applied	\N	\N	\N	\N	74424	74424	242559
4511	3710	41	applied	\N	\N	\N	\N	74425	74425	242560
4511	3711	42	applied	\N	\N	\N	\N	74426	74426	242561
4511	3716	43	applied	\N	\N	\N	\N	74427	74427	242562
4511	3717	44	applied	\N	\N	\N	\N	74428	74428	242563
4511	3720	45	applied	\N	\N	\N	\N	74429	74429	242564
4511	3721	46	applied	\N	\N	\N	\N	74430	74430	242565
4511	3722	47	applied	\N	\N	\N	\N	74431	74431	242566
4511	3724	49	applied	\N	\N	\N	\N	74433	74433	242568
4511	3725	50	applied	\N	\N	\N	\N	74434	74434	242569
4511	3726	51	applied	\N	\N	\N	\N	74435	74435	242570
4511	3727	52	applied	\N	\N	\N	\N	74436	74436	242571
4515	3731	0	applied	\N	\N	\N	\N	74443	74443	242577
4511	3674	53	failed	Amount_insufficient_to_create_account	\N	\N	\N	74437	74437	\N
4516	3731	0	applied	\N	\N	\N	\N	74444	74444	242578
4517	3731	0	applied	\N	\N	\N	\N	74445	74445	242579
4518	3731	0	applied	\N	\N	\N	\N	74446	74446	242580
4521	3735	0	applied	\N	\N	\N	\N	74450	74450	242584
4522	3736	0	applied	\N	\N	\N	\N	74451	74451	242585
4528	3739	0	applied	\N	\N	\N	\N	74457	74457	242591
4530	3739	0	applied	\N	\N	\N	\N	74459	74459	242593
4531	3740	0	applied	\N	\N	\N	\N	74460	74460	242594
4532	3740	0	applied	\N	\N	\N	\N	74461	74461	242595
4537	3742	0	applied	\N	\N	\N	\N	74478	74478	242612
4540	3744	0	applied	\N	\N	\N	\N	74481	74481	242615
4543	3746	0	applied	\N	\N	\N	\N	74484	74484	242618
4543	3747	1	applied	\N	\N	\N	\N	74485	74485	242619
4544	3748	0	applied	\N	\N	1000000000	\N	74486	74486	242620
4544	3749	1	applied	\N	\N	\N	\N	74487	74487	242621
4545	3750	0	applied	\N	\N	\N	\N	74488	74488	242622
4545	3751	1	applied	\N	\N	\N	\N	74489	74489	242623
4547	3752	0	applied	\N	\N	\N	\N	74490	74490	242624
4555	3756	0	applied	\N	\N	1000000000	\N	74509	74509	242643
4555	3757	1	applied	\N	\N	\N	\N	74510	74510	242644
4558	3770	0	applied	\N	\N	\N	\N	74523	74523	242657
4562	3770	0	applied	\N	\N	\N	\N	74553	74553	242687
4567	3775	0	applied	\N	\N	\N	\N	74562	74562	242696
4567	3777	1	applied	\N	\N	\N	\N	74563	74563	242697
4572	3780	0	applied	\N	\N	\N	\N	74692	74692	242825
4572	3781	1	applied	\N	\N	\N	\N	74693	74693	242826
4577	3786	1	applied	\N	\N	\N	\N	74701	74701	242834
4579	3787	0	applied	\N	\N	\N	\N	74703	74703	242836
4589	3774	0	applied	\N	\N	\N	\N	74729	74729	242862
4589	3714	1	applied	\N	\N	1000000000	\N	74730	74730	242863
4589	3756	2	applied	\N	\N	1000000000	\N	74731	74731	242864
4589	3757	3	applied	\N	\N	\N	\N	74732	74732	242865
4589	3758	4	applied	\N	\N	\N	\N	74733	74733	242866
4589	3759	5	applied	\N	\N	\N	\N	74734	74734	242867
4589	3760	6	applied	\N	\N	\N	\N	74735	74735	242868
4589	3761	7	applied	\N	\N	\N	\N	74736	74736	242869
4589	3762	8	applied	\N	\N	\N	\N	74737	74737	242870
4589	3763	9	applied	\N	\N	\N	\N	74738	74738	242871
4589	3764	10	applied	\N	\N	\N	\N	74739	74739	242872
4421	3650	1	applied	\N	\N	\N	\N	74022	74022	242171
4426	3654	0	applied	\N	\N	\N	\N	74050	74050	242198
4427	3655	0	applied	\N	\N	\N	\N	74051	74051	242199
4432	3657	0	applied	\N	\N	1000000000	\N	74084	74084	242231
4432	3658	1	applied	\N	\N	\N	\N	74085	74085	242232
4432	3659	2	applied	\N	\N	\N	\N	74086	74086	242233
4432	3660	3	applied	\N	\N	\N	\N	74087	74087	242234
4437	3663	0	applied	\N	\N	\N	\N	74098	74098	242245
4437	3664	1	applied	\N	\N	\N	\N	74099	74099	242246
4439	3665	0	applied	\N	\N	\N	\N	74102	74102	242249
4444	3667	0	applied	\N	\N	1000000000	\N	74113	74113	242260
4444	3668	1	applied	\N	\N	\N	\N	74114	74114	242261
4444	3669	2	applied	\N	\N	\N	\N	74115	74115	242262
4444	3670	3	applied	\N	\N	1000000000	\N	74116	74116	242263
4446	3671	0	applied	\N	\N	\N	\N	74119	74119	242265
4449	3615	0	applied	\N	\N	1000000000	\N	74125	74125	242268
4449	3616	1	applied	\N	\N	1000000000	\N	74126	74126	242269
4449	3617	2	applied	\N	\N	1000000000	\N	74127	74127	242270
4449	3618	3	applied	\N	\N	\N	\N	74128	74128	242271
4449	3646	4	applied	\N	\N	1000000000	\N	74129	74129	242272
4449	3652	5	applied	\N	\N	1000000000	\N	74130	74130	242273
4449	3657	6	applied	\N	\N	1000000000	\N	74131	74131	242274
4449	3667	7	applied	\N	\N	1000000000	\N	74132	74132	242275
4449	3668	8	applied	\N	\N	\N	\N	74133	74133	242276
4449	3498	9	applied	\N	\N	\N	\N	74134	74134	242277
4449	3499	10	applied	\N	\N	\N	\N	74135	74135	242278
4449	3500	11	applied	\N	\N	\N	\N	74136	74136	242279
4449	3501	12	applied	\N	\N	\N	\N	74137	74137	242280
4449	3502	13	applied	\N	\N	\N	\N	74138	74138	242281
4449	3503	14	applied	\N	\N	\N	\N	74139	74139	242282
4449	3505	15	applied	\N	\N	\N	\N	74140	74140	242283
4449	3508	16	applied	\N	\N	\N	\N	74141	74141	242284
4449	3511	17	applied	\N	\N	\N	\N	74142	74142	242285
4449	3515	18	applied	\N	\N	\N	\N	74143	74143	242286
4449	3528	19	applied	\N	\N	\N	\N	74144	74144	242287
4449	3536	20	applied	\N	\N	\N	\N	74145	74145	242288
4449	3546	21	applied	\N	\N	\N	\N	74146	74146	242289
4449	3557	22	applied	\N	\N	\N	\N	74147	74147	242290
4449	3566	23	applied	\N	\N	\N	\N	74148	74148	242291
4455	3679	0	applied	\N	\N	\N	\N	74157	74157	242298
4457	3679	0	applied	\N	\N	\N	\N	74159	74159	242300
4462	3688	0	applied	\N	\N	\N	\N	74293	74293	242433
4465	3688	0	applied	\N	\N	\N	\N	74296	74296	242436
4466	3689	0	applied	\N	\N	\N	\N	74297	74297	242437
4472	3694	1	applied	\N	\N	\N	\N	74307	74307	242447
4472	3695	2	applied	\N	\N	\N	\N	74308	74308	242448
4475	3702	0	applied	\N	\N	\N	\N	74316	74316	242456
4477	3703	0	applied	\N	\N	\N	\N	74318	74318	74318
4477	3704	1	applied	\N	\N	\N	\N	74319	74319	242458
4480	3703	0	applied	\N	\N	\N	\N	74323	74323	74323
4480	3704	2	applied	\N	\N	\N	\N	74324	74324	242461
4480	3705	3	applied	\N	\N	\N	\N	74325	74325	242462
4486	3708	0	applied	\N	\N	\N	\N	74334	74334	242469
4491	3711	0	applied	\N	\N	\N	\N	74339	74339	242474
4491	3712	1	applied	\N	\N	\N	\N	74340	74340	242475
4491	3713	2	applied	\N	\N	\N	\N	74341	74341	242476
4500	3719	0	applied	\N	\N	\N	\N	74368	74368	242503
4500	3720	1	applied	\N	\N	\N	\N	74369	74369	242504
4500	3721	2	applied	\N	\N	\N	\N	74370	74370	242505
4500	3722	3	applied	\N	\N	\N	\N	74371	74371	242506
4508	3727	0	applied	\N	\N	\N	\N	74381	74381	242516
4510	3727	0	applied	\N	\N	\N	\N	74383	74383	242518
4512	3728	0	applied	\N	\N	\N	\N	74438	74438	242572
4512	3729	1	applied	\N	\N	\N	\N	74439	74439	242573
4514	3730	0	applied	\N	\N	\N	\N	74442	74442	242576
4519	3732	0	applied	\N	\N	\N	\N	74447	74447	242581
4519	3733	1	applied	\N	\N	\N	\N	74448	74448	242582
4524	3737	0	applied	\N	\N	\N	\N	74453	74453	242587
4526	3738	0	applied	\N	\N	\N	\N	74455	74455	242589
4529	3739	0	applied	\N	\N	\N	\N	74458	74458	242592
4533	3728	0	applied	\N	\N	\N	\N	74462	74462	242596
4533	3729	1	applied	\N	\N	\N	\N	74463	74463	242597
4533	3730	2	applied	\N	\N	\N	\N	74464	74464	242598
4533	3731	3	applied	\N	\N	\N	\N	74465	74465	242599
4589	3765	11	applied	\N	\N	\N	\N	74740	74740	242873
4589	3766	12	applied	\N	\N	\N	\N	74741	74741	242874
4589	3782	14	applied	\N	\N	\N	\N	74743	74743	242876
4589	3790	15	applied	\N	\N	1000000000	\N	74744	74744	242877
4589	3748	16	applied	\N	\N	1000000000	\N	74745	74745	242878
4589	3753	17	applied	\N	\N	\N	\N	74746	74746	242879
4589	3719	18	applied	\N	\N	\N	\N	74747	74747	242880
4589	3707	19	applied	\N	\N	\N	\N	74748	74748	242881
4589	3708	20	applied	\N	\N	\N	\N	74749	74749	242882
4589	3709	21	applied	\N	\N	\N	\N	74750	74750	242883
4589	3712	22	applied	\N	\N	\N	\N	74751	74751	242884
4589	3715	23	applied	\N	\N	\N	\N	74752	74752	242885
4589	3713	24	applied	\N	\N	\N	\N	74753	74753	242886
4589	3710	25	applied	\N	\N	\N	\N	74754	74754	242887
4589	3711	26	applied	\N	\N	\N	\N	74755	74755	242888
4589	3716	27	applied	\N	\N	\N	\N	74756	74756	242889
4589	3717	28	applied	\N	\N	\N	\N	74757	74757	242890
4589	3720	29	applied	\N	\N	\N	\N	74758	74758	242891
4589	3722	31	applied	\N	\N	\N	\N	74760	74760	242893
4589	3723	32	applied	\N	\N	\N	\N	74761	74761	242894
4589	3724	33	applied	\N	\N	\N	\N	74762	74762	242895
4589	3725	34	applied	\N	\N	\N	\N	74763	74763	242896
4589	3726	35	applied	\N	\N	\N	\N	74764	74764	242897
4589	3727	36	applied	\N	\N	\N	\N	74765	74765	242898
4589	3728	37	applied	\N	\N	\N	\N	74766	74766	242899
4589	3729	38	applied	\N	\N	\N	\N	74767	74767	242900
4589	3730	39	applied	\N	\N	\N	\N	74768	74768	242901
4589	3731	40	applied	\N	\N	\N	\N	74769	74769	242902
4589	3732	41	applied	\N	\N	\N	\N	74770	74770	242903
4589	3733	42	applied	\N	\N	\N	\N	74771	74771	242904
4589	3734	43	applied	\N	\N	\N	\N	74772	74772	242905
4589	3735	44	applied	\N	\N	\N	\N	74773	74773	242906
4589	3736	45	applied	\N	\N	\N	\N	74774	74774	242907
4589	3737	46	applied	\N	\N	\N	\N	74775	74775	242908
4589	3739	48	applied	\N	\N	\N	\N	74777	74777	242910
4589	3740	49	applied	\N	\N	\N	\N	74778	74778	242911
4422	3650	1	applied	\N	\N	\N	\N	74024	74024	242173
4425	3653	1	applied	\N	\N	\N	\N	74049	74049	242197
4461	3526	26	applied	\N	\N	\N	\N	74194	74194	242334
4461	3444	27	applied	\N	\N	\N	\N	74195	74195	242335
4461	3507	28	applied	\N	\N	\N	\N	74196	74196	242336
4461	3509	29	applied	\N	\N	\N	\N	74197	74197	242337
4461	3510	30	applied	\N	\N	\N	\N	74198	74198	242338
4461	3512	31	applied	\N	\N	\N	\N	74199	74199	242339
4461	3516	32	applied	\N	\N	\N	\N	74200	74200	242340
4461	3517	33	applied	\N	\N	\N	\N	74201	74201	242341
4461	3518	34	applied	\N	\N	\N	\N	74202	74202	242342
4461	3519	35	applied	\N	\N	\N	\N	74203	74203	242343
4461	3520	36	applied	\N	\N	\N	\N	74204	74204	242344
4461	3521	37	applied	\N	\N	\N	\N	74205	74205	242345
4461	3522	38	applied	\N	\N	\N	\N	74206	74206	242346
4461	3524	40	applied	\N	\N	\N	\N	74208	74208	242348
4461	3525	41	applied	\N	\N	\N	\N	74209	74209	242349
4461	3527	42	applied	\N	\N	\N	\N	74210	74210	242350
4461	3529	43	applied	\N	\N	\N	\N	74211	74211	242351
4461	3530	44	applied	\N	\N	\N	\N	74212	74212	242352
4461	3531	45	applied	\N	\N	\N	\N	74213	74213	242353
4461	3532	46	applied	\N	\N	\N	\N	74214	74214	242354
4461	3533	47	applied	\N	\N	\N	\N	74215	74215	242355
4461	3534	48	applied	\N	\N	\N	\N	74216	74216	242356
4461	3535	49	applied	\N	\N	\N	\N	74217	74217	242357
4461	3537	50	applied	\N	\N	\N	\N	74218	74218	242358
4461	3538	51	applied	\N	\N	\N	\N	74219	74219	242359
4461	3539	52	applied	\N	\N	\N	\N	74220	74220	242360
4461	3540	53	applied	\N	\N	\N	\N	74221	74221	242361
4461	3541	54	applied	\N	\N	\N	\N	74222	74222	242362
4461	3542	55	applied	\N	\N	\N	\N	74223	74223	242363
4461	3544	57	applied	\N	\N	\N	\N	74225	74225	242365
4461	3545	58	applied	\N	\N	\N	\N	74226	74226	242366
4461	3547	59	applied	\N	\N	\N	\N	74227	74227	242367
4461	3548	60	applied	\N	\N	\N	\N	74228	74228	242368
4461	3549	61	applied	\N	\N	\N	\N	74229	74229	242369
4461	3550	62	applied	\N	\N	\N	\N	74230	74230	242370
4461	3551	63	applied	\N	\N	\N	\N	74231	74231	242371
4461	3552	64	applied	\N	\N	\N	\N	74232	74232	242372
4461	3553	65	applied	\N	\N	\N	\N	74233	74233	242373
4461	3554	66	applied	\N	\N	\N	\N	74234	74234	242374
4461	3555	67	applied	\N	\N	\N	\N	74235	74235	242375
4461	3556	68	applied	\N	\N	\N	\N	74236	74236	242376
4461	3558	69	applied	\N	\N	\N	\N	74237	74237	242377
4461	3559	70	applied	\N	\N	\N	\N	74238	74238	242378
4461	3560	71	applied	\N	\N	\N	\N	74239	74239	242379
4461	3561	72	applied	\N	\N	\N	\N	74240	74240	242380
4461	3563	74	applied	\N	\N	\N	\N	74242	74242	242382
4461	3564	76	applied	\N	\N	\N	\N	74243	74243	242383
4461	3565	77	applied	\N	\N	\N	\N	74244	74244	242384
4461	3567	78	applied	\N	\N	\N	\N	74245	74245	242385
4461	3568	79	applied	\N	\N	\N	\N	74246	74246	242386
4461	3569	80	applied	\N	\N	\N	\N	74247	74247	242387
4461	3570	81	applied	\N	\N	\N	\N	74248	74248	242388
4461	3571	82	applied	\N	\N	\N	\N	74249	74249	242389
4461	3572	83	applied	\N	\N	\N	\N	74250	74250	242390
4461	3573	84	applied	\N	\N	\N	\N	74251	74251	242391
4461	3574	85	applied	\N	\N	\N	\N	74252	74252	242392
4461	3576	86	applied	\N	\N	\N	\N	74253	74253	242393
4461	3577	87	applied	\N	\N	\N	\N	74254	74254	242394
4461	3578	88	applied	\N	\N	\N	\N	74255	74255	242395
4461	3579	89	applied	\N	\N	\N	\N	74256	74256	242396
4461	3580	90	applied	\N	\N	\N	\N	74257	74257	242397
4461	3582	92	applied	\N	\N	\N	\N	74259	74259	242399
4461	3583	93	applied	\N	\N	\N	\N	74260	74260	242400
4461	3584	94	applied	\N	\N	\N	\N	74261	74261	242401
4461	3585	95	applied	\N	\N	\N	\N	74262	74262	242402
4461	3587	96	applied	\N	\N	\N	\N	74263	74263	242403
4461	3588	97	applied	\N	\N	\N	\N	74264	74264	242404
4461	3589	98	applied	\N	\N	\N	\N	74265	74265	242405
4461	3590	99	applied	\N	\N	\N	\N	74266	74266	242406
4461	3591	100	applied	\N	\N	\N	\N	74267	74267	242407
4461	3592	101	applied	\N	\N	\N	\N	74268	74268	242408
4461	3593	102	applied	\N	\N	\N	\N	74269	74269	242409
4461	3594	103	applied	\N	\N	\N	\N	74270	74270	242410
4533	3732	4	applied	\N	\N	\N	\N	74466	74466	242600
4533	3733	6	applied	\N	\N	\N	\N	74467	74467	242601
4533	3734	7	applied	\N	\N	\N	\N	74468	74468	242602
4533	3735	8	applied	\N	\N	\N	\N	74469	74469	242603
4533	3737	10	applied	\N	\N	\N	\N	74471	74471	242605
4533	3738	11	applied	\N	\N	\N	\N	74472	74472	242606
4533	3739	12	applied	\N	\N	\N	\N	74473	74473	242607
4533	3740	13	applied	\N	\N	\N	\N	74474	74474	242608
4535	3741	0	applied	\N	\N	\N	\N	74476	74476	242610
4538	3742	0	applied	\N	\N	\N	\N	74479	74479	242613
4542	3745	0	applied	\N	\N	\N	\N	74483	74483	242617
4548	3753	0	applied	\N	\N	\N	\N	74491	74491	242625
4548	3754	1	applied	\N	\N	\N	\N	74492	74492	242626
4550	3755	0	applied	\N	\N	\N	\N	74494	74494	242628
4553	3756	0	applied	\N	\N	1000000000	\N	74495	74495	242629
4553	3757	1	applied	\N	\N	\N	\N	74496	74496	242630
4553	3758	2	applied	\N	\N	\N	\N	74497	74497	242631
4553	3759	3	applied	\N	\N	\N	\N	74498	74498	242632
4553	3760	4	applied	\N	\N	\N	\N	74499	74499	242633
4553	3761	6	applied	\N	\N	\N	\N	74500	74500	242634
4553	3763	8	applied	\N	\N	\N	\N	74502	74502	242636
4553	3764	9	applied	\N	\N	\N	\N	74503	74503	242637
4553	3765	10	applied	\N	\N	\N	\N	74504	74504	242638
4553	3766	11	applied	\N	\N	\N	\N	74505	74505	242639
4553	3767	12	applied	\N	\N	\N	\N	74506	74506	242640
4553	3768	13	applied	\N	\N	\N	\N	74507	74507	242641
4553	3769	14	applied	\N	\N	\N	\N	74508	74508	242642
4560	3756	0	applied	\N	\N	1000000000	\N	74525	74525	242659
4560	3757	1	applied	\N	\N	\N	\N	74526	74526	242660
4560	3758	2	applied	\N	\N	\N	\N	74527	74527	242661
4560	3759	3	applied	\N	\N	\N	\N	74528	74528	242662
4560	3760	4	applied	\N	\N	\N	\N	74529	74529	242663
4560	3761	6	applied	\N	\N	\N	\N	74530	74530	242664
4560	3762	7	applied	\N	\N	\N	\N	74531	74531	242665
4560	3763	8	applied	\N	\N	\N	\N	74532	74532	242666
4560	3764	9	applied	\N	\N	\N	\N	74533	74533	242667
4461	3513	24	applied	\N	\N	\N	\N	74192	74192	242332
4461	3514	25	applied	\N	\N	\N	\N	74193	74193	242333
4461	3599	107	applied	\N	\N	\N	\N	74274	74274	242414
4461	3600	108	applied	\N	\N	\N	\N	74275	74275	242415
4461	3601	109	applied	\N	\N	\N	\N	74276	74276	242416
4461	3602	110	applied	\N	\N	\N	\N	74277	74277	242417
4461	3603	111	applied	\N	\N	\N	\N	74278	74278	242418
4461	3604	112	applied	\N	\N	\N	\N	74279	74279	242419
4461	3606	113	applied	\N	\N	\N	\N	74280	74280	242420
4461	3608	115	applied	\N	\N	\N	\N	74282	74282	242422
4461	3609	116	applied	\N	\N	\N	\N	74283	74283	242423
4461	3610	117	applied	\N	\N	\N	\N	74284	74284	242424
4461	3611	118	applied	\N	\N	\N	\N	74285	74285	242425
4461	3612	119	applied	\N	\N	\N	\N	74286	74286	242426
4461	3613	120	applied	\N	\N	\N	\N	74287	74287	242427
4461	3614	121	applied	\N	\N	\N	\N	74288	74288	242428
4461	3619	122	applied	\N	\N	\N	\N	74289	74289	242429
4461	3620	123	applied	\N	\N	\N	\N	74290	74290	242430
4461	3622	124	applied	\N	\N	\N	\N	74291	74291	242431
4461	3623	125	applied	\N	\N	\N	\N	74292	74292	242432
4463	3688	0	applied	\N	\N	\N	\N	74294	74294	242434
4467	3689	0	applied	\N	\N	\N	\N	74298	74298	242438
4470	3692	0	applied	\N	\N	\N	\N	74302	74302	242442
4474	3702	0	applied	\N	\N	\N	\N	74315	74315	242455
4476	3702	0	applied	\N	\N	\N	\N	74317	74317	242457
4481	3704	2	applied	\N	\N	\N	\N	74327	74327	242463
4485	3707	0	applied	\N	\N	\N	\N	74333	74333	242468
4494	3711	0	applied	\N	\N	\N	\N	74345	74345	242480
4494	3712	1	applied	\N	\N	\N	\N	74346	74346	242481
4494	3713	2	applied	\N	\N	\N	\N	74347	74347	242482
4502	3724	0	applied	\N	\N	\N	\N	74373	74373	242508
4502	3725	1	applied	\N	\N	\N	\N	74374	74374	242509
4504	3726	0	applied	\N	\N	\N	\N	74377	74377	242512
4513	3728	0	applied	\N	\N	\N	\N	74440	74440	242574
4513	3729	1	applied	\N	\N	\N	\N	74441	74441	242575
4520	3734	0	applied	\N	\N	\N	\N	74449	74449	242583
4523	3736	0	applied	\N	\N	\N	\N	74452	74452	242586
4525	3737	0	applied	\N	\N	\N	\N	74454	74454	242588
4527	3738	0	applied	\N	\N	\N	\N	74456	74456	242590
4534	3741	0	applied	\N	\N	\N	\N	74475	74475	242609
4536	3742	0	applied	\N	\N	\N	\N	74477	74477	242611
4549	3755	0	applied	\N	\N	\N	\N	74493	74493	242627
4555	3758	2	applied	\N	\N	\N	\N	74511	74511	242645
4555	3759	3	applied	\N	\N	\N	\N	74512	74512	242646
4555	3760	4	applied	\N	\N	\N	\N	74513	74513	242647
4555	3761	6	applied	\N	\N	\N	\N	74514	74514	242648
4555	3762	7	applied	\N	\N	\N	\N	74515	74515	242649
4555	3763	8	applied	\N	\N	\N	\N	74516	74516	242650
4555	3764	9	applied	\N	\N	\N	\N	74517	74517	242651
4555	3765	10	applied	\N	\N	\N	\N	74518	74518	242652
4555	3766	11	applied	\N	\N	\N	\N	74519	74519	242653
4565	3774	0	applied	\N	\N	\N	\N	74557	74557	242691
4565	3775	1	applied	\N	\N	\N	\N	74558	74558	242692
4565	3776	2	applied	\N	\N	\N	\N	74559	74559	242693
4570	3779	0	applied	\N	\N	\N	\N	74566	74566	242700
4575	3784	0	applied	\N	\N	\N	\N	74697	74697	242830
4580	3788	0	applied	\N	\N	\N	\N	74704	74704	242837
4584	3789	0	applied	\N	\N	\N	\N	74708	74708	242841
4585	3790	0	applied	\N	\N	1000000000	\N	74709	74709	242842
4585	3791	1	applied	\N	\N	\N	\N	74710	74710	242843
4585	3792	2	applied	\N	\N	\N	\N	74711	74711	242844
4585	3793	3	applied	\N	\N	\N	\N	74712	74712	242845
4585	3794	4	applied	\N	\N	\N	\N	74713	74713	242846
4588	3790	0	applied	\N	\N	1000000000	\N	74724	74724	242857
4588	3791	1	applied	\N	\N	\N	\N	74725	74725	242858
4588	3792	2	applied	\N	\N	\N	\N	74726	74726	242859
4588	3793	3	applied	\N	\N	\N	\N	74727	74727	242860
4588	3794	4	applied	\N	\N	\N	\N	74728	74728	242861
4590	3795	0	applied	\N	\N	\N	\N	74817	74817	242950
4590	3796	1	applied	\N	\N	\N	\N	74818	74818	242951
4590	3797	2	applied	\N	\N	\N	\N	74819	74819	242952
4590	3798	3	applied	\N	\N	\N	\N	74820	74820	242953
4593	3800	0	applied	\N	\N	\N	\N	74848	74848	242980
4596	3804	0	applied	\N	\N	\N	\N	74855	74855	242987
4596	3805	1	applied	\N	\N	\N	\N	74856	74856	242988
4596	3806	2	applied	\N	\N	\N	\N	74857	74857	242989
4598	3807	0	applied	\N	\N	\N	\N	74858	74858	242990
4599	3808	0	applied	\N	\N	\N	\N	74859	74859	242991
4599	3809	1	applied	\N	\N	\N	\N	74860	74860	242992
4599	3810	2	applied	\N	\N	\N	\N	74861	74861	242993
4604	3815	0	applied	\N	\N	\N	\N	74867	74867	242999
4606	3816	0	applied	\N	\N	\N	\N	74869	74869	243001
4609	3818	0	applied	\N	\N	\N	\N	74872	74872	243004
4609	3819	1	applied	\N	\N	\N	\N	74873	74873	243005
4612	3821	0	applied	\N	\N	\N	\N	74876	74876	243008
4616	3822	0	applied	\N	\N	\N	\N	74881	74881	243013
4616	3823	1	applied	\N	\N	\N	\N	74882	74882	243014
4616	3824	2	applied	\N	\N	\N	\N	74883	74883	243015
4618	3825	0	applied	\N	\N	\N	\N	74982	74982	243114
4634	3833	0	applied	\N	\N	\N	\N	75002	75002	243134
4643	3774	0	applied	\N	\N	\N	\N	75012	75012	243144
4643	3822	1	applied	\N	\N	\N	\N	75013	75013	243145
4643	3756	2	applied	\N	\N	1000000000	\N	75014	75014	243146
4643	3757	3	applied	\N	\N	\N	\N	75015	75015	243147
4643	3758	4	applied	\N	\N	\N	\N	75016	75016	243148
4643	3759	5	applied	\N	\N	\N	\N	75017	75017	243149
4643	3760	6	applied	\N	\N	\N	\N	75018	75018	243150
4643	3761	7	applied	\N	\N	\N	\N	75019	75019	243151
4643	3762	8	applied	\N	\N	\N	\N	75020	75020	243152
4643	3763	9	applied	\N	\N	\N	\N	75021	75021	243153
4643	3764	10	applied	\N	\N	\N	\N	75022	75022	243154
4643	3765	11	applied	\N	\N	\N	\N	75023	75023	243155
4643	3766	12	applied	\N	\N	\N	\N	75024	75024	243156
4643	3775	13	applied	\N	\N	\N	\N	75025	75025	243157
4643	3782	14	applied	\N	\N	\N	\N	75026	75026	243158
4643	3748	16	applied	\N	\N	1000000000	\N	75028	75028	243160
4643	3753	17	applied	\N	\N	\N	\N	75029	75029	243161
4646	3838	0	applied	\N	\N	\N	\N	75032	75032	243164
4650	3839	0	applied	\N	\N	\N	\N	75036	75036	243168
4652	3843	0	applied	\N	\N	\N	\N	75040	75040	243172
4652	3844	1	applied	\N	\N	\N	\N	75041	75041	243173
4461	3596	105	applied	\N	\N	\N	\N	74272	74272	242412
4461	3597	106	applied	\N	\N	\N	\N	74273	74273	242413
4559	3770	0	applied	\N	\N	\N	\N	74524	74524	242658
4560	3766	11	applied	\N	\N	\N	\N	74535	74535	242669
4560	3768	13	applied	\N	\N	\N	\N	74537	74537	242671
4560	3769	14	applied	\N	\N	\N	\N	74538	74538	242672
4561	3756	0	applied	\N	\N	1000000000	\N	74539	74539	242673
4561	3757	1	applied	\N	\N	\N	\N	74540	74540	242674
4561	3758	2	applied	\N	\N	\N	\N	74541	74541	242675
4561	3759	3	applied	\N	\N	\N	\N	74542	74542	242676
4561	3760	4	applied	\N	\N	\N	\N	74543	74543	242677
4561	3761	6	applied	\N	\N	\N	\N	74544	74544	242678
4561	3762	7	applied	\N	\N	\N	\N	74545	74545	242679
4561	3763	8	applied	\N	\N	\N	\N	74546	74546	242680
4561	3764	9	applied	\N	\N	\N	\N	74547	74547	242681
4561	3765	10	applied	\N	\N	\N	\N	74548	74548	242682
4561	3766	11	applied	\N	\N	\N	\N	74549	74549	242683
4561	3767	12	applied	\N	\N	\N	\N	74550	74550	242684
4561	3768	13	applied	\N	\N	\N	\N	74551	74551	242685
4561	3769	14	applied	\N	\N	\N	\N	74552	74552	242686
4564	3772	0	applied	\N	\N	\N	\N	74555	74555	242689
4564	3773	1	applied	\N	\N	\N	\N	74556	74556	242690
4566	3774	0	applied	\N	\N	\N	\N	74560	74560	242694
4566	3776	1	applied	\N	\N	\N	\N	74561	74561	242695
4568	3778	0	applied	\N	\N	\N	\N	74564	74564	242698
4569	3778	0	applied	\N	\N	\N	\N	74565	74565	242699
4571	3774	0	applied	\N	\N	\N	\N	74567	74567	242701
4571	3483	1	applied	\N	\N	1000000000	\N	74568	74568	242702
4571	3615	2	applied	\N	\N	1000000000	\N	74569	74569	242703
4571	3616	3	applied	\N	\N	1000000000	\N	74570	74570	242704
4571	3617	4	applied	\N	\N	1000000000	\N	74571	74571	242705
4571	3618	5	applied	\N	\N	\N	\N	74572	74572	242706
4571	3646	6	applied	\N	\N	1000000000	\N	74573	74573	242707
4571	3652	7	applied	\N	\N	1000000000	\N	74574	74574	242708
4571	3667	9	applied	\N	\N	1000000000	\N	74576	74576	242710
4571	3668	10	applied	\N	\N	\N	\N	74577	74577	242711
4571	3680	11	applied	\N	\N	1000000000	\N	74578	74578	242712
4571	3684	12	applied	\N	\N	1000000000	\N	74579	74579	242713
4571	3685	13	applied	\N	\N	1000000000	\N	74580	74580	242714
4571	3693	14	applied	\N	\N	\N	\N	74581	74581	242715
4571	3714	15	applied	\N	\N	1000000000	\N	74582	74582	242716
4571	3756	16	applied	\N	\N	1000000000	\N	74583	74583	242717
4571	3757	17	applied	\N	\N	\N	\N	74584	74584	242718
4571	3758	18	applied	\N	\N	\N	\N	74585	74585	242719
4571	3759	19	applied	\N	\N	\N	\N	74586	74586	242720
4571	3760	20	applied	\N	\N	\N	\N	74587	74587	242721
4571	3761	21	applied	\N	\N	\N	\N	74588	74588	242722
4571	3762	22	applied	\N	\N	\N	\N	74589	74589	242723
4571	3763	23	applied	\N	\N	\N	\N	74590	74590	242724
4571	3764	24	applied	\N	\N	\N	\N	74591	74591	242725
4571	3765	25	applied	\N	\N	\N	\N	74592	74592	242726
4571	3766	26	applied	\N	\N	\N	\N	74593	74593	242727
4571	3775	27	applied	\N	\N	\N	\N	74594	74594	242728
4571	3753	29	applied	\N	\N	\N	\N	74596	74596	242730
4571	3507	30	applied	\N	\N	\N	\N	74597	74597	242731
4571	3509	31	applied	\N	\N	\N	\N	74598	74598	242732
4571	3510	32	applied	\N	\N	\N	\N	74599	74599	242733
4571	3660	33	applied	\N	\N	\N	\N	74600	74600	242734
4571	3484	34	applied	\N	\N	\N	\N	74601	74601	242735
4571	3485	35	applied	\N	\N	\N	\N	74602	74602	242736
4571	3492	36	applied	\N	\N	\N	\N	74603	74603	242737
4571	3493	37	applied	\N	\N	\N	\N	74604	74604	242738
4571	3504	38	applied	\N	\N	\N	\N	74605	74605	74605
4571	3506	39	applied	\N	\N	\N	\N	74606	74606	242739
4571	3513	40	applied	\N	\N	\N	\N	74607	74607	242740
4571	3514	41	applied	\N	\N	\N	\N	74608	74608	242741
4571	3526	42	applied	\N	\N	\N	\N	74609	74609	242742
4571	3512	43	applied	\N	\N	\N	\N	74610	74610	242743
4571	3516	44	applied	\N	\N	\N	\N	74611	74611	242744
4571	3517	45	applied	\N	\N	\N	\N	74612	74612	242745
4571	3518	46	applied	\N	\N	\N	\N	74613	74613	242746
4571	3519	47	applied	\N	\N	\N	\N	74614	74614	242747
4571	3521	49	applied	\N	\N	\N	\N	74616	74616	242749
4571	3522	50	applied	\N	\N	\N	\N	74617	74617	242750
4571	3523	51	applied	\N	\N	\N	\N	74618	74618	242751
4571	3524	52	applied	\N	\N	\N	\N	74619	74619	242752
4571	3525	53	applied	\N	\N	\N	\N	74620	74620	242753
4571	3527	54	applied	\N	\N	\N	\N	74621	74621	242754
4571	3529	55	applied	\N	\N	\N	\N	74622	74622	242755
4571	3530	56	applied	\N	\N	\N	\N	74623	74623	242756
4571	3531	57	applied	\N	\N	\N	\N	74624	74624	242757
4573	3782	0	applied	\N	\N	\N	\N	74694	74694	242827
4573	3783	1	applied	\N	\N	\N	\N	74695	74695	242828
4576	3785	0	applied	\N	\N	\N	\N	74698	74698	242831
4576	3786	1	applied	\N	\N	\N	\N	74699	74699	242832
4578	3787	0	applied	\N	\N	\N	\N	74702	74702	242835
4581	3788	0	applied	\N	\N	\N	\N	74705	74705	242838
4586	3791	1	applied	\N	\N	\N	\N	74715	74715	242848
4586	3792	2	applied	\N	\N	\N	\N	74716	74716	242849
4586	3793	3	applied	\N	\N	\N	\N	74717	74717	242850
4586	3794	4	applied	\N	\N	\N	\N	74718	74718	242851
4602	3814	0	applied	\N	\N	\N	\N	74865	74865	242997
4610	3820	0	applied	\N	\N	\N	\N	74874	74874	243006
4621	3826	0	applied	\N	\N	\N	\N	74985	74985	243117
4623	3827	0	applied	\N	\N	\N	\N	74987	74987	243119
4625	3827	0	applied	\N	\N	\N	\N	74989	74989	243121
4628	3828	0	applied	\N	\N	\N	\N	74994	74994	243126
4628	3829	1	applied	\N	\N	\N	\N	74995	74995	243127
4628	3830	2	applied	\N	\N	\N	\N	74996	74996	243128
4631	3832	0	applied	\N	\N	\N	\N	74999	74999	243131
4633	3832	0	applied	\N	\N	\N	\N	75001	75001	243133
4635	3833	0	applied	\N	\N	\N	\N	75003	75003	243135
4637	3834	0	applied	\N	\N	\N	\N	75005	75005	243137
4637	3835	1	applied	\N	\N	\N	\N	75006	75006	243138
4640	3836	0	applied	\N	\N	\N	\N	75009	75009	243141
4648	3838	0	applied	\N	\N	\N	\N	75034	75034	243166
4651	3841	1	applied	\N	\N	\N	\N	75038	75038	243170
4651	3842	2	applied	\N	\N	\N	\N	75039	75039	243171
4654	3843	0	applied	\N	\N	\N	\N	75044	75044	243176
4654	3844	1	applied	\N	\N	\N	\N	75045	75045	243177
4555	3768	13	applied	\N	\N	\N	\N	74521	74521	242655
4555	3769	14	applied	\N	\N	\N	\N	74522	74522	242656
4571	3535	61	applied	\N	\N	\N	\N	74628	74628	242761
4571	3537	62	applied	\N	\N	\N	\N	74629	74629	242762
4571	3538	63	applied	\N	\N	\N	\N	74630	74630	242763
4571	3539	64	applied	\N	\N	\N	\N	74631	74631	242764
4571	3540	65	applied	\N	\N	\N	\N	74632	74632	242765
4571	3541	66	applied	\N	\N	\N	\N	74633	74633	242766
4571	3542	67	applied	\N	\N	\N	\N	74634	74634	242767
4571	3543	68	applied	\N	\N	\N	\N	74635	74635	242768
4571	3544	69	applied	\N	\N	\N	\N	74636	74636	242769
4571	3545	70	applied	\N	\N	\N	\N	74637	74637	242770
4571	3547	71	applied	\N	\N	\N	\N	74638	74638	242771
4571	3548	72	applied	\N	\N	\N	\N	74639	74639	242772
4571	3550	74	applied	\N	\N	\N	\N	74641	74641	242774
4571	3551	75	applied	\N	\N	\N	\N	74642	74642	242775
4571	3552	76	applied	\N	\N	\N	\N	74643	74643	242776
4571	3553	77	applied	\N	\N	\N	\N	74644	74644	242777
4571	3554	78	applied	\N	\N	\N	\N	74645	74645	242778
4571	3555	79	applied	\N	\N	\N	\N	74646	74646	242779
4571	3556	80	applied	\N	\N	\N	\N	74647	74647	242780
4571	3558	81	applied	\N	\N	\N	\N	74648	74648	242781
4571	3559	82	applied	\N	\N	\N	\N	74649	74649	242782
4571	3560	83	applied	\N	\N	\N	\N	74650	74650	242783
4571	3561	84	applied	\N	\N	\N	\N	74651	74651	242784
4571	3562	85	applied	\N	\N	\N	\N	74652	74652	242785
4571	3563	87	applied	\N	\N	\N	\N	74653	74653	242786
4571	3564	88	applied	\N	\N	\N	\N	74654	74654	242787
4571	3565	89	applied	\N	\N	\N	\N	74655	74655	242788
4571	3567	90	applied	\N	\N	\N	\N	74656	74656	242789
4571	3569	92	applied	\N	\N	\N	\N	74658	74658	242791
4571	3570	93	applied	\N	\N	\N	\N	74659	74659	242792
4571	3571	94	applied	\N	\N	\N	\N	74660	74660	242793
4571	3572	95	applied	\N	\N	\N	\N	74661	74661	242794
4571	3573	96	applied	\N	\N	\N	\N	74662	74662	242795
4571	3574	97	applied	\N	\N	\N	\N	74663	74663	242796
4571	3576	98	applied	\N	\N	\N	\N	74664	74664	242797
4571	3577	99	applied	\N	\N	\N	\N	74665	74665	242798
4571	3578	100	applied	\N	\N	\N	\N	74666	74666	242799
4571	3579	101	applied	\N	\N	\N	\N	74667	74667	242800
4571	3580	102	applied	\N	\N	\N	\N	74668	74668	242801
4571	3581	103	applied	\N	\N	\N	\N	74669	74669	242802
4571	3582	104	applied	\N	\N	\N	\N	74670	74670	242803
4571	3583	105	applied	\N	\N	\N	\N	74671	74671	242804
4571	3584	106	applied	\N	\N	\N	\N	74672	74672	242805
4571	3585	107	applied	\N	\N	\N	\N	74673	74673	242806
4571	3588	109	applied	\N	\N	\N	\N	74675	74675	242808
4571	3589	110	applied	\N	\N	\N	\N	74676	74676	242809
4571	3590	111	applied	\N	\N	\N	\N	74677	74677	242810
4571	3591	112	applied	\N	\N	\N	\N	74678	74678	242811
4571	3592	113	applied	\N	\N	\N	\N	74679	74679	242812
4571	3593	114	applied	\N	\N	\N	\N	74680	74680	242813
4571	3594	115	applied	\N	\N	\N	\N	74681	74681	242814
4571	3595	116	applied	\N	\N	\N	\N	74682	74682	242815
4571	3596	117	applied	\N	\N	\N	\N	74683	74683	242816
4571	3597	118	applied	\N	\N	\N	\N	74684	74684	242817
4571	3599	119	applied	\N	\N	\N	\N	74685	74685	242818
4571	3600	120	applied	\N	\N	\N	\N	74686	74686	242819
4571	3601	121	applied	\N	\N	\N	\N	74687	74687	242820
4571	3602	122	applied	\N	\N	\N	\N	74688	74688	242821
4571	3603	123	applied	\N	\N	\N	\N	74689	74689	242822
4571	3604	124	applied	\N	\N	\N	\N	74690	74690	242823
4574	3784	0	applied	\N	\N	\N	\N	74696	74696	242829
4583	3788	0	applied	\N	\N	\N	\N	74707	74707	242840
4587	3790	0	applied	\N	\N	1000000000	\N	74719	74719	242852
4587	3791	1	applied	\N	\N	\N	\N	74720	74720	242853
4587	3792	2	applied	\N	\N	\N	\N	74721	74721	242854
4587	3793	3	applied	\N	\N	\N	\N	74722	74722	242855
4587	3794	4	applied	\N	\N	\N	\N	74723	74723	242856
4591	3774	0	applied	\N	\N	\N	\N	74821	74821	242954
4591	3693	1	applied	\N	\N	\N	\N	74822	74822	242955
4591	3714	2	applied	\N	\N	1000000000	\N	74823	74823	242956
4591	3756	3	applied	\N	\N	1000000000	\N	74824	74824	242957
4591	3757	4	applied	\N	\N	\N	\N	74825	74825	242958
4591	3758	5	applied	\N	\N	\N	\N	74826	74826	242959
4591	3759	6	applied	\N	\N	\N	\N	74827	74827	242960
4591	3760	7	applied	\N	\N	\N	\N	74828	74828	242961
4591	3761	8	applied	\N	\N	\N	\N	74829	74829	242962
4591	3763	10	applied	\N	\N	\N	\N	74831	74831	242964
4591	3764	11	applied	\N	\N	\N	\N	74832	74832	242965
4591	3765	12	applied	\N	\N	\N	\N	74833	74833	242966
4591	3766	13	applied	\N	\N	\N	\N	74834	74834	242967
4591	3775	14	applied	\N	\N	\N	\N	74835	74835	242968
4591	3782	15	applied	\N	\N	\N	\N	74836	74836	242969
4591	3790	16	applied	\N	\N	1000000000	\N	74837	74837	242970
4591	3748	17	applied	\N	\N	1000000000	\N	74838	74838	242971
4591	3753	18	applied	\N	\N	\N	\N	74839	74839	242972
4591	3719	19	applied	\N	\N	1000000000	\N	74840	74840	242973
4591	3715	20	applied	\N	\N	\N	\N	74841	74841	242974
4591	3713	21	applied	\N	\N	\N	\N	74842	74842	242975
4591	3718	22	applied	\N	\N	\N	\N	74843	74843	242976
4591	3643	23	applied	\N	\N	\N	\N	74844	74844	242977
4591	3644	24	applied	\N	\N	\N	\N	74845	74845	74845
4591	3645	25	applied	\N	\N	\N	\N	74846	74846	242978
4594	3803	1	applied	\N	\N	\N	\N	74851	74851	242983
4600	3811	0	applied	\N	\N	\N	\N	74862	74862	242994
4603	3814	0	applied	\N	\N	\N	\N	74866	74866	242998
4605	3815	0	applied	\N	\N	\N	\N	74868	74868	243000
4607	3816	0	applied	\N	\N	\N	\N	74870	74870	243002
4615	3822	0	applied	\N	\N	\N	\N	74878	74878	243010
4615	3823	1	applied	\N	\N	\N	\N	74879	74879	243011
4615	3824	2	applied	\N	\N	\N	\N	74880	74880	243012
4617	3774	0	applied	\N	\N	\N	\N	74884	74884	243016
4617	3822	1	applied	\N	\N	\N	\N	74885	74885	243017
4617	3657	2	applied	\N	\N	1000000000	\N	74886	74886	243018
4617	3667	3	applied	\N	\N	1000000000	\N	74887	74887	243019
4617	3668	4	applied	\N	\N	\N	\N	74888	74888	243020
4617	3680	5	applied	\N	\N	1000000000	\N	74889	74889	243021
4617	3685	7	applied	\N	\N	1000000000	\N	74891	74891	243023
4617	3693	8	applied	\N	\N	\N	\N	74892	74892	243024
4571	3533	59	applied	\N	\N	\N	\N	74626	74626	242759
4571	3534	60	applied	\N	\N	\N	\N	74627	74627	242760
4589	3744	53	applied	\N	\N	\N	\N	74782	74782	242915
4589	3745	54	applied	\N	\N	\N	\N	74783	74783	242916
4589	3746	55	applied	\N	\N	\N	\N	74784	74784	242917
4589	3747	56	applied	\N	\N	\N	\N	74785	74785	242918
4589	3749	57	applied	\N	\N	\N	\N	74786	74786	242919
4589	3750	58	applied	\N	\N	\N	\N	74787	74787	242920
4589	3751	59	applied	\N	\N	\N	\N	74788	74788	242921
4589	3754	61	applied	\N	\N	\N	\N	74790	74790	242923
4589	3755	62	applied	\N	\N	\N	\N	74791	74791	242924
4589	3767	63	applied	\N	\N	\N	\N	74792	74792	242925
4589	3768	64	applied	\N	\N	\N	\N	74793	74793	242926
4589	3769	65	applied	\N	\N	\N	\N	74794	74794	242927
4589	3770	66	applied	\N	\N	\N	\N	74795	74795	242928
4589	3771	67	applied	\N	\N	\N	\N	74796	74796	242929
4589	3772	68	applied	\N	\N	\N	\N	74797	74797	242930
4589	3773	69	applied	\N	\N	\N	\N	74798	74798	242931
4589	3776	70	applied	\N	\N	\N	\N	74799	74799	242932
4589	3777	71	applied	\N	\N	\N	\N	74800	74800	242933
4589	3778	72	applied	\N	\N	\N	\N	74801	74801	242934
4589	3779	73	applied	\N	\N	\N	\N	74802	74802	242935
4589	3780	74	applied	\N	\N	\N	\N	74803	74803	242936
4589	3781	75	applied	\N	\N	\N	\N	74804	74804	242937
4589	3783	76	applied	\N	\N	\N	\N	74805	74805	242938
4589	3785	78	applied	\N	\N	\N	\N	74807	74807	242940
4589	3786	79	applied	\N	\N	\N	\N	74808	74808	242941
4589	3787	80	applied	\N	\N	\N	\N	74809	74809	242942
4589	3788	81	applied	\N	\N	\N	\N	74810	74810	242943
4589	3789	82	applied	\N	\N	\N	\N	74811	74811	242944
4589	3791	83	applied	\N	\N	\N	\N	74812	74812	242945
4589	3792	84	applied	\N	\N	\N	\N	74813	74813	242946
4589	3793	85	applied	\N	\N	\N	\N	74814	74814	242947
4589	3794	86	applied	\N	\N	\N	\N	74815	74815	242948
4589	3718	87	applied	\N	\N	\N	\N	74816	74816	242949
4592	3799	0	applied	\N	\N	\N	\N	74847	74847	242979
4595	3804	0	applied	\N	\N	\N	\N	74852	74852	242984
4595	3805	1	applied	\N	\N	\N	\N	74853	74853	242985
4595	3806	2	applied	\N	\N	\N	\N	74854	74854	242986
4601	3812	0	applied	\N	\N	\N	\N	74863	74863	242995
4601	3813	1	applied	\N	\N	\N	\N	74864	74864	242996
4611	3821	0	applied	\N	\N	\N	\N	74875	74875	243007
4613	3821	0	applied	\N	\N	\N	\N	74877	74877	243009
4617	3714	9	applied	\N	\N	1000000000	\N	74893	74893	243025
4617	3756	10	applied	\N	\N	1000000000	\N	74894	74894	243026
4617	3757	11	applied	\N	\N	\N	\N	74895	74895	243027
4617	3758	12	applied	\N	\N	\N	\N	74896	74896	243028
4617	3759	13	applied	\N	\N	\N	\N	74897	74897	243029
4617	3760	14	applied	\N	\N	\N	\N	74898	74898	243030
4617	3761	15	applied	\N	\N	\N	\N	74899	74899	243031
4617	3762	16	applied	\N	\N	\N	\N	74900	74900	243032
4617	3763	17	applied	\N	\N	\N	\N	74901	74901	243033
4617	3764	18	applied	\N	\N	\N	\N	74902	74902	243034
4617	3765	19	applied	\N	\N	\N	\N	74903	74903	243035
4617	3766	20	applied	\N	\N	\N	\N	74904	74904	243036
4617	3775	21	applied	\N	\N	\N	\N	74905	74905	243037
4617	3782	22	applied	\N	\N	\N	\N	74906	74906	243038
4617	3748	24	applied	\N	\N	1000000000	\N	74908	74908	243040
4617	3753	25	applied	\N	\N	\N	\N	74909	74909	243041
4617	3658	26	applied	\N	\N	\N	\N	74910	74910	243042
4617	3659	27	applied	\N	\N	\N	\N	74911	74911	243043
4617	3660	28	applied	\N	\N	\N	\N	74912	74912	243044
4617	3661	29	applied	\N	\N	\N	\N	74913	74913	243045
4617	3662	30	applied	\N	\N	\N	\N	74914	74914	243046
4617	3663	31	applied	\N	\N	\N	\N	74915	74915	243047
4617	3664	32	applied	\N	\N	\N	\N	74916	74916	243048
4617	3665	33	applied	\N	\N	\N	\N	74917	74917	243049
4617	3666	34	applied	\N	\N	\N	\N	74918	74918	243050
4617	3669	35	applied	\N	\N	\N	\N	74919	74919	243051
4617	3671	36	applied	\N	\N	\N	\N	74920	74920	243052
4617	3673	37	applied	\N	\N	\N	\N	74921	74921	243053
4617	3675	38	applied	\N	\N	\N	\N	74922	74922	243054
4617	3676	39	applied	\N	\N	\N	\N	74923	74923	243055
4617	3678	41	applied	\N	\N	\N	\N	74925	74925	243057
4617	3679	42	applied	\N	\N	\N	\N	74926	74926	243058
4617	3681	43	applied	\N	\N	\N	\N	74927	74927	243059
4617	3682	44	applied	\N	\N	\N	\N	74928	74928	243060
4617	3683	45	applied	\N	\N	\N	\N	74929	74929	243061
4617	3686	46	applied	\N	\N	\N	\N	74930	74930	243062
4617	3688	47	applied	\N	\N	\N	\N	74931	74931	243063
4617	3689	48	applied	\N	\N	\N	\N	74932	74932	243064
4617	3690	49	applied	\N	\N	\N	\N	74933	74933	243065
4617	3691	50	applied	\N	\N	\N	\N	74934	74934	243066
4617	3692	51	applied	\N	\N	\N	\N	74935	74935	243067
4617	3694	52	applied	\N	\N	\N	\N	74936	74936	243068
4617	3695	54	applied	\N	\N	\N	\N	74937	74937	243069
4617	3697	55	applied	\N	\N	\N	\N	74938	74938	243070
4617	3698	56	applied	\N	\N	\N	\N	74939	74939	243071
4617	3699	57	applied	\N	\N	\N	\N	74940	74940	243072
4617	3700	58	applied	\N	\N	\N	\N	74941	74941	243073
4617	3701	59	applied	\N	\N	\N	\N	74942	74942	243074
4617	3702	60	applied	\N	\N	\N	\N	74943	74943	243075
4617	3704	61	applied	\N	\N	\N	\N	74944	74944	243076
4617	3706	63	applied	\N	\N	\N	\N	74946	74946	243078
4617	3707	64	applied	\N	\N	\N	\N	74947	74947	243079
4617	3708	65	applied	\N	\N	\N	\N	74948	74948	243080
4617	3709	66	applied	\N	\N	\N	\N	74949	74949	243081
4617	3710	67	applied	\N	\N	\N	\N	74950	74950	243082
4617	3711	68	applied	\N	\N	\N	\N	74951	74951	243083
4617	3716	69	applied	\N	\N	\N	\N	74952	74952	243084
4617	3717	70	applied	\N	\N	\N	\N	74953	74953	243085
4617	3720	71	applied	\N	\N	\N	\N	74954	74954	243086
4620	3826	0	applied	\N	\N	\N	\N	74984	74984	243116
4622	3826	0	applied	\N	\N	\N	\N	74986	74986	243118
4627	3828	0	applied	\N	\N	\N	\N	74991	74991	243123
4627	3829	1	applied	\N	\N	\N	\N	74992	74992	243124
4627	3830	2	applied	\N	\N	\N	\N	74993	74993	243125
4629	3831	0	applied	\N	\N	\N	\N	74997	74997	243129
4639	3836	0	applied	\N	\N	\N	\N	75008	75008	243140
4647	3838	0	applied	\N	\N	\N	\N	75033	75033	243165
4649	3838	0	applied	\N	\N	\N	\N	75035	75035	243167
4589	3742	51	applied	\N	\N	\N	\N	74780	74780	242913
4589	3743	52	applied	\N	\N	\N	\N	74781	74781	242914
4617	3724	75	applied	\N	\N	\N	\N	74958	74958	243090
4617	3725	76	applied	\N	\N	\N	\N	74959	74959	243091
4617	3726	77	applied	\N	\N	\N	\N	74960	74960	243092
4617	3727	78	applied	\N	\N	\N	\N	74961	74961	243093
4617	3728	79	applied	\N	\N	\N	\N	74962	74962	243094
4617	3729	80	applied	\N	\N	\N	\N	74963	74963	243095
4617	3730	81	applied	\N	\N	\N	\N	74964	74964	243096
4617	3731	82	applied	\N	\N	\N	\N	74965	74965	243097
4617	3732	83	applied	\N	\N	\N	\N	74966	74966	243098
4617	3734	85	applied	\N	\N	\N	\N	74968	74968	243100
4617	3735	86	applied	\N	\N	\N	\N	74969	74969	243101
4617	3736	87	applied	\N	\N	\N	\N	74970	74970	243102
4617	3737	88	applied	\N	\N	\N	\N	74971	74971	243103
4617	3738	89	applied	\N	\N	\N	\N	74972	74972	243104
4617	3739	90	applied	\N	\N	\N	\N	74973	74973	243105
4617	3740	91	applied	\N	\N	\N	\N	74974	74974	243106
4617	3741	92	applied	\N	\N	\N	\N	74975	74975	243107
4617	3742	93	applied	\N	\N	\N	\N	74976	74976	243108
4617	3743	94	applied	\N	\N	\N	\N	74977	74977	243109
4617	3744	95	applied	\N	\N	\N	\N	74978	74978	243110
4617	3745	96	applied	\N	\N	\N	\N	74979	74979	243111
4617	3746	97	applied	\N	\N	\N	\N	74980	74980	243112
4617	3747	98	applied	\N	\N	\N	\N	74981	74981	243113
4619	3825	0	applied	\N	\N	\N	\N	74983	74983	243115
4624	3827	0	applied	\N	\N	\N	\N	74988	74988	243120
4632	3832	0	applied	\N	\N	\N	\N	75000	75000	243132
4636	3833	0	applied	\N	\N	\N	\N	75004	75004	243136
4638	3836	0	applied	\N	\N	\N	\N	75007	75007	243139
4641	3836	0	applied	\N	\N	\N	\N	75010	75010	243142
4642	3837	0	applied	\N	\N	\N	\N	75011	75011	243143
4644	3837	0	applied	\N	\N	\N	\N	75030	75030	243162
4653	3843	0	applied	\N	\N	\N	\N	75042	75042	243174
4653	3844	1	applied	\N	\N	\N	\N	75043	75043	243175
4655	3845	0	applied	\N	\N	\N	\N	75046	75046	243178
4656	3846	0	applied	\N	\N	\N	\N	75047	75047	243179
4656	3847	1	applied	\N	\N	\N	\N	75048	75048	243180
4656	3848	2	applied	\N	\N	\N	\N	75049	75049	243181
4656	3849	3	applied	\N	\N	\N	\N	75050	75050	243182
4656	3850	4	applied	\N	\N	\N	\N	75051	75051	243183
4656	3851	5	applied	\N	\N	\N	\N	75052	75052	243184
4656	3852	6	applied	\N	\N	\N	\N	75053	75053	243185
4658	3854	0	applied	\N	\N	\N	\N	75055	75055	243187
4659	3855	0	applied	\N	\N	\N	\N	75056	75056	243188
4660	3855	0	applied	\N	\N	\N	\N	75057	75057	243189
4661	3856	0	applied	\N	\N	\N	\N	75058	75058	243190
4662	3856	0	applied	\N	\N	\N	\N	75059	75059	243191
4663	3856	0	applied	\N	\N	\N	\N	75060	75060	243192
4664	3857	0	applied	\N	\N	\N	\N	75061	75061	243193
4665	3858	0	applied	\N	\N	\N	\N	75062	75062	243194
4666	3859	0	applied	\N	\N	\N	\N	75063	75063	243195
4667	3859	0	applied	\N	\N	\N	\N	75064	75064	243196
4668	3860	0	applied	\N	\N	\N	\N	75065	75065	243197
4669	3860	0	applied	\N	\N	\N	\N	75066	75066	243198
4670	3861	0	applied	\N	\N	\N	\N	75067	75067	243199
4670	3862	1	applied	\N	\N	\N	\N	75068	75068	243200
4671	3861	0	applied	\N	\N	\N	\N	75069	75069	243201
4671	3862	1	applied	\N	\N	\N	\N	75070	75070	243202
4672	3862	1	applied	\N	\N	\N	\N	75072	75072	243204
4673	3863	0	applied	\N	\N	\N	\N	75073	75073	243205
4674	3774	0	applied	\N	\N	\N	\N	75074	75074	243206
4674	3822	1	applied	\N	\N	\N	\N	75075	75075	243207
4674	3714	2	applied	\N	\N	1000000000	\N	75076	75076	243208
4674	3756	3	applied	\N	\N	1000000000	\N	75077	75077	243209
4674	3757	4	applied	\N	\N	\N	\N	75078	75078	243210
4674	3758	5	applied	\N	\N	\N	\N	75079	75079	243211
4674	3759	6	applied	\N	\N	\N	\N	75080	75080	243212
4674	3760	7	applied	\N	\N	\N	\N	75081	75081	243213
4674	3761	8	applied	\N	\N	\N	\N	75082	75082	243214
4674	3762	9	applied	\N	\N	\N	\N	75083	75083	243215
4674	3763	10	applied	\N	\N	\N	\N	75084	75084	243216
4674	3764	11	applied	\N	\N	\N	\N	75085	75085	243217
4674	3765	12	applied	\N	\N	\N	\N	75086	75086	243218
4674	3766	13	applied	\N	\N	\N	\N	75087	75087	243219
4674	3782	15	applied	\N	\N	\N	\N	75089	75089	243221
4674	3790	16	applied	\N	\N	1000000000	\N	75090	75090	243222
4674	3748	17	applied	\N	\N	1000000000	\N	75091	75091	243223
4674	3753	18	applied	\N	\N	\N	\N	75092	75092	243224
4674	3709	19	applied	\N	\N	\N	\N	75093	75093	243225
4674	3719	20	applied	\N	\N	\N	\N	75094	75094	243226
4674	3844	21	applied	\N	\N	\N	\N	75095	75095	243227
4674	3712	22	applied	\N	\N	\N	\N	75096	75096	243228
4674	3715	23	applied	\N	\N	\N	\N	75097	75097	243229
4674	3713	24	applied	\N	\N	\N	\N	75098	75098	243230
4674	3710	25	applied	\N	\N	\N	\N	75099	75099	243231
4674	3711	26	applied	\N	\N	\N	\N	75100	75100	243232
4674	3716	27	applied	\N	\N	\N	\N	75101	75101	243233
4674	3717	28	applied	\N	\N	\N	\N	75102	75102	243234
4674	3720	29	applied	\N	\N	\N	\N	75103	75103	243235
4674	3721	30	applied	\N	\N	\N	\N	75104	75104	243236
4674	3723	32	applied	\N	\N	\N	\N	75106	75106	243238
4674	3724	33	applied	\N	\N	\N	\N	75107	75107	243239
4674	3725	34	applied	\N	\N	\N	\N	75108	75108	243240
4674	3726	35	applied	\N	\N	\N	\N	75109	75109	243241
4674	3727	36	applied	\N	\N	\N	\N	75110	75110	243242
4674	3728	37	applied	\N	\N	\N	\N	75111	75111	243243
4674	3729	38	applied	\N	\N	\N	\N	75112	75112	243244
4674	3730	39	applied	\N	\N	\N	\N	75113	75113	243245
4674	3731	40	applied	\N	\N	\N	\N	75114	75114	243246
4674	3732	41	applied	\N	\N	\N	\N	75115	75115	243247
4674	3733	42	applied	\N	\N	\N	\N	75116	75116	243248
4674	3734	43	applied	\N	\N	\N	\N	75117	75117	243249
4674	3735	44	applied	\N	\N	\N	\N	75118	75118	243250
4674	3736	45	applied	\N	\N	\N	\N	75119	75119	243251
4674	3737	46	applied	\N	\N	\N	\N	75120	75120	243252
4674	3738	47	applied	\N	\N	\N	\N	75121	75121	243253
4674	3740	49	applied	\N	\N	\N	\N	75123	75123	243255
4674	3741	50	applied	\N	\N	\N	\N	75124	75124	243256
4674	3742	51	applied	\N	\N	\N	\N	75125	75125	243257
4674	3743	52	applied	\N	\N	\N	\N	75126	75126	243258
4617	3722	73	applied	\N	\N	\N	\N	74956	74956	243088
4617	3723	74	applied	\N	\N	\N	\N	74957	74957	243089
4674	3749	57	applied	\N	\N	\N	\N	75131	75131	243263
4674	3750	58	applied	\N	\N	\N	\N	75132	75132	243264
4674	3751	59	applied	\N	\N	\N	\N	75133	75133	243265
4674	3752	60	applied	\N	\N	\N	\N	75134	75134	243266
4674	3754	61	applied	\N	\N	\N	\N	75135	75135	243267
4674	3755	62	applied	\N	\N	\N	\N	75136	75136	243268
4674	3767	63	applied	\N	\N	\N	\N	75137	75137	243269
4674	3768	64	applied	\N	\N	\N	\N	75138	75138	243270
4674	3769	65	applied	\N	\N	\N	\N	75139	75139	243271
4674	3770	66	applied	\N	\N	\N	\N	75140	75140	243272
4674	3771	67	applied	\N	\N	\N	\N	75141	75141	243273
4674	3772	68	applied	\N	\N	\N	\N	75142	75142	243274
4674	3773	69	applied	\N	\N	\N	\N	75143	75143	243275
4674	3776	70	applied	\N	\N	\N	\N	75144	75144	243276
4674	3778	72	applied	\N	\N	\N	\N	75146	75146	243278
4674	3779	73	applied	\N	\N	\N	\N	75147	75147	243279
4674	3780	74	applied	\N	\N	\N	\N	75148	75148	243280
4674	3781	75	applied	\N	\N	\N	\N	75149	75149	243281
4674	3783	76	applied	\N	\N	\N	\N	75150	75150	243282
4674	3784	77	applied	\N	\N	\N	\N	75151	75151	243283
4674	3785	78	applied	\N	\N	\N	\N	75152	75152	243284
4674	3786	79	applied	\N	\N	\N	\N	75153	75153	243285
4674	3787	80	applied	\N	\N	\N	\N	75154	75154	243286
4674	3788	81	applied	\N	\N	\N	\N	75155	75155	243287
4674	3789	82	applied	\N	\N	\N	\N	75156	75156	243288
4674	3791	83	applied	\N	\N	\N	\N	75157	75157	243289
4674	3792	84	applied	\N	\N	\N	\N	75158	75158	243290
4674	3793	85	applied	\N	\N	\N	\N	75159	75159	243291
4674	3794	86	applied	\N	\N	\N	\N	75160	75160	243292
4674	3795	87	applied	\N	\N	\N	\N	75161	75161	243293
4674	3797	89	applied	\N	\N	\N	\N	75163	75163	243295
4674	3798	90	applied	\N	\N	\N	\N	75164	75164	243296
4674	3799	91	applied	\N	\N	\N	\N	75165	75165	243297
4674	3800	92	applied	\N	\N	\N	\N	75166	75166	243298
4674	3801	93	applied	\N	\N	\N	\N	75167	75167	243299
4674	3803	94	applied	\N	\N	\N	\N	75168	75168	243300
4674	3804	95	applied	\N	\N	\N	\N	75169	75169	243301
4674	3806	96	applied	\N	\N	\N	\N	75170	75170	243302
4674	3807	97	applied	\N	\N	\N	\N	75171	75171	243303
4674	3808	98	applied	\N	\N	\N	\N	75172	75172	243304
4674	3809	99	applied	\N	\N	\N	\N	75173	75173	243305
4674	3810	100	applied	\N	\N	\N	\N	75174	75174	243306
4674	3811	101	applied	\N	\N	\N	\N	75175	75175	243307
4674	3812	102	applied	\N	\N	\N	\N	75176	75176	243308
4674	3813	103	applied	\N	\N	\N	\N	75177	75177	243309
4674	3814	104	applied	\N	\N	\N	\N	75178	75178	243310
4674	3816	106	applied	\N	\N	\N	\N	75180	75180	243312
4674	3817	107	applied	\N	\N	\N	\N	75181	75181	243313
4674	3718	108	applied	\N	\N	\N	\N	75182	75182	243314
4674	3818	109	applied	\N	\N	\N	\N	75183	75183	243315
4674	3819	110	applied	\N	\N	\N	\N	75184	75184	243316
4674	3820	111	applied	\N	\N	\N	\N	75185	75185	243317
4674	3821	112	applied	\N	\N	\N	\N	75186	75186	243318
4674	3823	113	applied	\N	\N	\N	\N	75187	75187	243319
4674	3824	115	applied	\N	\N	\N	\N	75188	75188	243320
4674	3825	116	applied	\N	\N	\N	\N	75189	75189	243321
4674	3826	117	applied	\N	\N	\N	\N	75190	75190	243322
4674	3827	118	applied	\N	\N	\N	\N	75191	75191	243323
4674	3828	119	applied	\N	\N	\N	\N	75192	75192	243324
4674	3829	120	applied	\N	\N	\N	\N	75193	75193	243325
4674	3830	121	applied	\N	\N	\N	\N	75194	75194	243326
4674	3831	122	applied	\N	\N	\N	\N	75195	75195	243327
4674	3833	124	applied	\N	\N	\N	\N	75197	75197	243329
4674	3834	125	applied	\N	\N	\N	\N	75198	75198	243330
4675	3864	0	applied	\N	\N	\N	\N	75199	75199	243331
4678	3865	0	applied	\N	\N	\N	\N	75203	75203	243335
4678	3866	1	applied	\N	\N	\N	\N	75204	75204	243336
4682	3868	0	applied	\N	\N	\N	\N	75208	75208	243340
4683	3868	0	applied	\N	\N	\N	\N	75209	75209	243341
4685	3870	0	applied	\N	\N	\N	\N	75211	75211	243343
4687	3871	0	applied	\N	\N	\N	\N	75213	75213	243345
4689	3872	0	applied	\N	\N	\N	\N	75215	75215	243347
4692	3874	0	applied	\N	\N	\N	\N	75222	75222	243354
4697	3878	0	applied	\N	\N	\N	\N	75231	75231	243363
4698	3878	0	applied	\N	\N	\N	\N	75232	75232	243364
4699	3879	0	applied	\N	\N	\N	\N	75233	75233	243365
4701	3879	0	applied	\N	\N	\N	\N	75235	75235	243367
4703	3880	0	applied	\N	\N	\N	\N	75237	75237	243369
4705	3857	1	applied	\N	\N	\N	\N	75240	75240	243372
4705	3858	2	applied	\N	\N	\N	\N	75241	75241	243373
4705	3859	3	applied	\N	\N	\N	\N	75242	75242	243374
4705	3860	4	applied	\N	\N	\N	\N	75243	75243	243375
4705	3877	5	applied	\N	\N	1000000000	\N	75244	75244	243376
4705	3862	6	applied	\N	\N	\N	\N	75245	75245	243377
4705	3863	7	applied	\N	\N	\N	\N	75246	75246	243378
4705	3864	8	applied	\N	\N	\N	\N	75247	75247	243379
4705	3865	9	applied	\N	\N	\N	\N	75248	75248	243380
4705	3866	10	applied	\N	\N	\N	\N	75249	75249	243381
4705	3867	11	applied	\N	\N	\N	\N	75250	75250	243382
4705	3868	12	applied	\N	\N	\N	\N	75251	75251	243383
4705	3869	13	applied	\N	\N	\N	\N	75252	75252	243384
4705	3870	14	applied	\N	\N	\N	\N	75253	75253	243385
4713	3887	0	applied	\N	\N	\N	\N	75271	75271	243403
4731	3900	0	applied	\N	\N	\N	\N	75299	75299	243431
4731	3902	2	applied	\N	\N	\N	\N	75301	75301	243433
4733	3903	0	applied	\N	\N	\N	\N	75305	75305	243437
4736	3904	0	applied	\N	\N	\N	\N	75308	75308	243440
4738	3907	0	applied	\N	\N	\N	\N	75311	75311	243443
4738	3908	1	applied	\N	\N	\N	\N	75312	75312	243444
4743	3912	0	applied	\N	\N	\N	\N	75341	75341	243473
4743	3913	1	applied	\N	\N	\N	\N	75342	75342	243474
4748	3914	0	applied	\N	\N	\N	\N	75350	75350	243482
4748	3915	1	applied	\N	\N	\N	\N	75351	75351	243483
4748	3916	2	applied	\N	\N	\N	\N	75352	75352	243484
4751	3917	0	applied	\N	\N	\N	\N	75357	75357	243489
4760	3924	0	applied	\N	\N	\N	\N	75368	75368	243500
4770	3929	0	applied	\N	\N	\N	\N	75406	75406	243538
4770	3930	1	applied	\N	\N	\N	\N	75407	75407	243539
4770	3931	2	applied	\N	\N	\N	\N	75408	75408	243540
4770	3932	3	applied	\N	\N	\N	\N	75409	75409	243541
4674	3747	56	applied	\N	\N	\N	\N	75130	75130	243262
4688	3872	0	applied	\N	\N	\N	\N	75214	75214	243346
4691	3873	0	applied	\N	\N	\N	\N	75221	75221	243353
4693	3822	0	applied	\N	\N	\N	\N	75223	75223	243355
4693	3861	1	applied	\N	\N	\N	\N	75224	75224	243356
4693	3844	2	applied	\N	\N	\N	\N	75225	75225	243357
4693	3802	3	applied	\N	\N	\N	\N	75226	75226	243358
4693	3805	4	applied	\N	\N	\N	\N	75227	75227	243359
4702	3880	0	applied	\N	\N	\N	\N	75236	75236	243368
4705	3871	15	applied	\N	\N	\N	\N	75254	75254	243386
4705	3872	16	applied	\N	\N	\N	\N	75255	75255	243387
4705	3873	17	applied	\N	\N	\N	\N	75256	75256	243388
4705	3874	18	applied	\N	\N	\N	\N	75257	75257	243389
4705	3876	20	applied	\N	\N	\N	\N	75259	75259	243391
4705	3878	21	applied	\N	\N	\N	\N	75260	75260	243392
4705	3879	22	applied	\N	\N	\N	\N	75261	75261	243393
4705	3880	23	applied	\N	\N	\N	\N	75262	75262	243394
4707	3881	0	applied	\N	\N	\N	\N	75264	75264	243396
4708	3882	0	applied	\N	\N	\N	\N	75265	75265	243397
4709	3883	0	applied	\N	\N	\N	\N	75266	75266	243398
4709	3884	1	applied	\N	\N	\N	\N	75267	75267	243399
4710	3885	0	applied	\N	\N	\N	\N	75268	75268	243400
4712	3886	0	applied	\N	\N	\N	\N	75270	75270	243402
4714	3887	0	applied	\N	\N	\N	\N	75272	75272	243404
4716	3888	0	applied	\N	\N	\N	\N	75274	75274	243406
4717	3889	0	applied	\N	\N	\N	\N	75275	75275	243407
4719	3891	0	applied	\N	\N	\N	\N	75278	75278	243410
4719	3892	1	applied	\N	\N	\N	\N	75279	75279	243411
4720	3893	0	applied	\N	\N	\N	\N	75280	75280	243412
4725	3896	0	applied	\N	\N	\N	\N	75287	75287	243419
4725	3897	1	applied	\N	\N	\N	\N	75288	75288	243420
4726	3896	0	applied	\N	\N	\N	\N	75289	75289	243421
4726	3897	1	applied	\N	\N	\N	\N	75290	75290	243422
4728	3898	0	applied	\N	\N	\N	\N	75293	75293	243425
4728	3899	1	applied	\N	\N	\N	\N	75294	75294	243426
4729	3898	0	applied	\N	\N	\N	\N	75295	75295	243427
4729	3899	1	applied	\N	\N	\N	\N	75296	75296	243428
4730	3898	0	applied	\N	\N	\N	\N	75297	75297	243429
4730	3899	1	applied	\N	\N	\N	\N	75298	75298	243430
4732	3900	0	applied	\N	\N	\N	\N	75302	75302	243434
4732	3901	1	applied	\N	\N	\N	\N	75303	75303	243435
4732	3902	2	applied	\N	\N	\N	\N	75304	75304	243436
4735	3904	0	applied	\N	\N	\N	\N	75307	75307	243439
4737	3905	0	applied	\N	\N	\N	\N	75309	75309	243441
4740	3910	0	applied	\N	\N	\N	\N	75314	75314	243446
4747	3914	0	applied	\N	\N	\N	\N	75347	75347	243479
4747	3915	1	applied	\N	\N	\N	\N	75348	75348	243480
4747	3916	2	applied	\N	\N	\N	\N	75349	75349	243481
4749	3914	0	applied	\N	\N	\N	\N	75353	75353	243485
4749	3915	1	applied	\N	\N	\N	\N	75354	75354	243486
4749	3916	2	applied	\N	\N	\N	\N	75355	75355	243487
4754	3919	0	applied	\N	\N	\N	\N	75360	75360	243492
4756	3920	0	applied	\N	\N	\N	\N	75362	75362	243494
4756	3921	1	applied	\N	\N	\N	\N	75363	75363	243495
4762	3924	0	applied	\N	\N	\N	\N	75370	75370	243502
4763	3925	0	applied	\N	\N	\N	\N	75371	75371	243503
4768	3928	0	applied	\N	\N	\N	\N	75404	75404	243536
4771	3929	0	applied	\N	\N	\N	\N	75410	75410	243542
4771	3930	1	applied	\N	\N	\N	\N	75411	75411	243543
4771	3931	2	applied	\N	\N	\N	\N	75412	75412	243544
4771	3932	3	applied	\N	\N	\N	\N	75413	75413	243545
4783	3940	0	applied	\N	\N	\N	\N	75428	75428	243560
4783	3941	1	applied	\N	\N	\N	\N	75429	75429	243561
4789	3945	0	applied	\N	\N	\N	\N	75436	75436	243568
4789	3946	1	applied	\N	\N	\N	\N	75437	75437	243569
4796	3953	0	applied	\N	\N	\N	\N	75446	75446	243578
4799	3954	0	applied	\N	\N	1000000000	\N	75455	75455	243587
4799	3955	1	applied	\N	\N	1000000000	\N	75456	75456	243588
4799	3956	2	applied	\N	\N	1000000000	\N	75457	75457	243589
4799	3957	3	applied	\N	\N	1000000000	\N	75458	75458	243590
4799	3958	4	applied	\N	\N	1000000000	\N	75459	75459	243591
4799	3959	5	applied	\N	\N	1000000000	\N	75460	75460	243592
4799	3960	6	applied	\N	\N	\N	\N	75461	75461	243593
4801	3961	0	applied	\N	\N	\N	\N	75463	75463	243595
4803	3964	0	applied	\N	\N	\N	\N	75466	75466	243598
4806	3965	0	applied	\N	\N	\N	\N	75469	75469	243601
4808	3967	0	applied	\N	\N	\N	\N	75471	75471	243603
4819	3976	0	applied	\N	\N	\N	\N	75592	75592	243724
4822	3980	0	applied	\N	\N	\N	\N	75597	75597	243729
4826	3983	0	applied	\N	\N	\N	\N	75727	75727	243859
4833	3964	0	applied	\N	\N	\N	\N	75735	75735	243867
4833	3965	1	applied	\N	\N	\N	\N	75736	75736	243868
4833	3966	2	applied	\N	\N	\N	\N	75737	75737	243869
4833	3967	3	applied	\N	\N	\N	\N	75738	75738	243870
4833	3968	4	applied	\N	\N	\N	\N	75739	75739	243871
4833	3969	5	applied	\N	\N	\N	\N	75740	75740	243872
4833	3971	6	applied	\N	\N	\N	\N	75741	75741	243873
4833	3972	7	applied	\N	\N	\N	\N	75742	75742	243874
4833	3973	8	applied	\N	\N	\N	\N	75743	75743	243875
4833	3975	9	applied	\N	\N	\N	\N	75744	75744	243876
4833	3976	10	applied	\N	\N	\N	\N	75745	75745	243877
4833	3978	11	applied	\N	\N	\N	\N	75746	75746	243878
4833	3979	12	applied	\N	\N	\N	\N	75747	75747	243879
4833	3982	14	applied	\N	\N	\N	\N	75749	75749	243881
4833	3983	15	applied	\N	\N	\N	\N	75750	75750	243882
4833	3984	16	applied	\N	\N	\N	\N	75751	75751	243883
4833	3985	17	applied	\N	\N	\N	\N	75752	75752	243884
4833	3986	18	applied	\N	\N	\N	\N	75753	75753	243885
4833	3987	19	applied	\N	\N	\N	\N	75754	75754	243886
4833	3988	20	applied	\N	\N	\N	\N	75755	75755	243887
4837	3989	0	applied	\N	\N	\N	\N	75764	75764	243896
4837	3990	1	applied	\N	\N	\N	\N	75765	75765	243897
4837	3991	2	applied	\N	\N	\N	\N	75766	75766	243898
4843	3822	0	applied	\N	\N	\N	\N	75771	75771	243903
4843	3782	1	applied	\N	\N	\N	\N	75772	75772	243904
4843	3790	2	applied	\N	\N	1000000000	\N	75773	75773	243905
4843	3954	3	applied	\N	\N	1000000000	\N	75774	75774	243906
4843	3956	5	applied	\N	\N	1000000000	\N	75776	75776	243908
4843	3957	6	applied	\N	\N	1000000000	\N	75777	75777	243909
4680	3867	0	applied	\N	\N	\N	\N	75206	75206	243338
4686	3870	0	applied	\N	\N	\N	\N	75212	75212	243344
4684	3869	0	applied	\N	\N	\N	\N	75210	75210	243342
4690	3869	0	applied	\N	\N	\N	\N	75216	75216	243348
4690	3870	1	applied	\N	\N	\N	\N	75217	75217	243349
4690	3871	2	applied	\N	\N	\N	\N	75218	75218	243350
4690	3872	3	applied	\N	\N	\N	\N	75219	75219	243351
4690	3873	4	applied	\N	\N	\N	\N	75220	75220	243352
4696	3875	0	applied	\N	\N	\N	\N	75228	75228	243360
4696	3876	1	applied	\N	\N	\N	\N	75229	75229	243361
4696	3877	2	applied	\N	\N	1000000000	\N	75230	75230	243362
4700	3879	0	applied	\N	\N	\N	\N	75234	75234	243366
4704	3880	0	applied	\N	\N	\N	\N	75238	75238	243370
4706	3881	0	applied	\N	\N	\N	\N	75263	75263	243395
4711	3886	0	applied	\N	\N	\N	\N	75269	75269	243401
4715	3888	0	applied	\N	\N	\N	\N	75273	75273	243405
4718	3889	0	applied	\N	\N	\N	\N	75276	75276	243408
4718	3890	1	applied	\N	\N	\N	\N	75277	75277	243409
4723	3896	0	applied	\N	\N	\N	\N	75283	75283	243415
4723	3897	1	applied	\N	\N	\N	\N	75284	75284	243416
4737	3906	1	applied	\N	\N	\N	\N	75310	75310	243442
4741	3910	0	applied	\N	\N	\N	\N	75316	75316	243448
4741	3911	1	applied	\N	\N	\N	\N	75317	75317	243449
4746	3912	0	applied	\N	\N	\N	\N	75345	75345	243477
4746	3913	1	applied	\N	\N	\N	\N	75346	75346	243478
4750	3917	0	applied	\N	\N	\N	\N	75356	75356	243488
4755	3919	0	applied	\N	\N	\N	\N	75361	75361	243493
4757	3921	0	applied	\N	\N	\N	\N	75364	75364	243496
4759	3922	0	applied	\N	\N	\N	\N	75366	75366	243498
4759	3923	1	applied	\N	\N	\N	\N	75367	75367	243499
4764	3774	0	applied	\N	\N	\N	\N	75372	75372	243504
4764	3822	1	applied	\N	\N	\N	\N	75373	75373	243505
4764	3616	3	applied	\N	\N	1000000000	\N	75375	75375	243507
4764	3617	4	applied	\N	\N	1000000000	\N	75376	75376	243508
4764	3618	5	applied	\N	\N	\N	\N	75377	75377	243509
4764	3646	6	applied	\N	\N	1000000000	\N	75378	75378	243510
4764	3652	7	applied	\N	\N	1000000000	\N	75379	75379	243511
4764	3657	8	applied	\N	\N	1000000000	\N	75380	75380	243512
4764	3667	9	applied	\N	\N	1000000000	\N	75381	75381	243513
4764	3748	10	applied	\N	\N	1000000000	\N	75382	75382	243514
4764	3753	11	applied	\N	\N	\N	\N	75383	75383	243515
4764	3844	12	applied	\N	\N	\N	\N	75384	75384	243516
4764	3513	13	applied	\N	\N	\N	\N	75385	75385	243517
4764	3514	14	applied	\N	\N	\N	\N	75386	75386	243518
4764	3515	15	applied	\N	\N	\N	\N	75387	75387	243519
4764	3660	16	applied	\N	\N	\N	\N	75388	75388	243520
4764	3526	17	applied	\N	\N	\N	\N	75389	75389	243521
4764	3516	18	applied	\N	\N	\N	\N	75390	75390	243522
4764	3528	19	applied	\N	\N	\N	\N	75391	75391	243523
4764	3536	21	applied	\N	\N	\N	\N	75392	75392	243524
4764	3546	22	applied	\N	\N	\N	\N	75393	75393	243525
4764	3557	23	applied	\N	\N	\N	\N	75394	75394	243526
4764	3575	25	applied	\N	\N	\N	\N	75396	75396	243528
4764	3586	26	applied	\N	\N	\N	\N	75397	75397	243529
4764	3598	27	applied	\N	\N	\N	\N	75398	75398	243530
4764	3605	28	applied	\N	\N	\N	\N	75399	75399	243531
4764	3621	29	applied	\N	\N	\N	\N	75400	75400	243532
4766	3926	0	applied	\N	\N	\N	\N	75402	75402	243534
4769	3928	0	applied	\N	\N	\N	\N	75405	75405	243537
4774	3934	0	applied	\N	\N	\N	\N	75415	75415	243547
4774	3935	1	applied	\N	\N	\N	\N	75416	75416	243548
4781	3938	0	applied	\N	\N	\N	\N	75426	75426	243558
4784	3942	0	applied	\N	\N	\N	\N	75430	75430	243562
4786	3943	0	applied	\N	\N	\N	\N	75432	75432	243564
4794	3951	0	applied	\N	\N	\N	\N	75444	75444	243576
4804	3964	0	applied	\N	\N	\N	\N	75467	75467	243599
4815	3973	0	applied	\N	\N	\N	\N	75585	75585	243717
4818	3974	0	applied	\N	\N	\N	\N	75590	75590	243722
4820	3976	0	applied	\N	\N	\N	\N	75593	75593	243725
4825	3954	0	applied	\N	\N	1000000000	\N	75602	75602	243734
4825	3955	1	applied	\N	\N	1000000000	\N	75603	75603	243735
4825	3956	2	applied	\N	\N	1000000000	\N	75604	75604	243736
4825	3957	3	applied	\N	\N	1000000000	\N	75605	75605	243737
4825	3861	4	applied	\N	\N	\N	\N	75606	75606	243738
4825	3958	5	applied	\N	\N	1000000000	\N	75607	75607	243739
4825	3959	6	applied	\N	\N	1000000000	\N	75608	75608	243740
4825	3962	7	applied	\N	\N	\N	\N	75609	75609	243741
4825	3977	8	applied	\N	\N	1000000000	\N	75610	75610	243742
4825	3844	9	applied	\N	\N	\N	\N	75611	75611	243743
4825	3833	10	applied	\N	\N	\N	\N	75612	75612	243744
4825	3834	11	applied	\N	\N	\N	\N	75613	75613	243745
4825	3835	12	applied	\N	\N	\N	\N	75614	75614	243746
4825	3836	13	applied	\N	\N	\N	\N	75615	75615	243747
4825	3837	14	applied	\N	\N	\N	\N	75616	75616	243748
4825	3981	16	applied	\N	\N	\N	\N	75618	75618	243750
4825	3892	17	applied	\N	\N	\N	\N	75619	75619	243751
4825	3899	18	applied	\N	\N	\N	\N	75620	75620	243752
4825	3839	19	applied	\N	\N	\N	\N	75621	75621	243753
4825	3840	20	applied	\N	\N	\N	\N	75622	75622	243754
4825	3841	21	applied	\N	\N	\N	\N	75623	75623	243755
4825	3842	22	applied	\N	\N	\N	\N	75624	75624	243756
4825	3843	23	applied	\N	\N	\N	\N	75625	75625	243757
4825	3845	24	applied	\N	\N	\N	\N	75626	75626	243758
4825	3877	25	applied	\N	\N	1000000000	\N	75627	75627	243759
4825	3906	26	applied	\N	\N	\N	\N	75628	75628	243760
4825	3852	27	applied	\N	\N	\N	\N	75629	75629	243761
4825	3853	28	applied	\N	\N	\N	\N	75630	75630	243762
4825	3854	29	applied	\N	\N	\N	\N	75631	75631	243763
4825	3855	30	applied	\N	\N	\N	\N	75632	75632	243764
4825	3856	31	applied	\N	\N	\N	\N	75633	75633	243765
4825	3858	33	applied	\N	\N	\N	\N	75635	75635	243767
4825	3859	34	applied	\N	\N	\N	\N	75636	75636	243768
4825	3860	35	applied	\N	\N	\N	\N	75637	75637	243769
4825	3862	36	applied	\N	\N	\N	\N	75638	75638	243770
4825	3863	37	applied	\N	\N	\N	\N	75639	75639	243771
4825	3864	38	applied	\N	\N	\N	\N	75640	75640	243772
4825	3865	39	applied	\N	\N	\N	\N	75641	75641	243773
4825	3866	40	applied	\N	\N	\N	\N	75642	75642	243774
4825	3867	41	applied	\N	\N	\N	\N	75643	75643	243775
4825	3868	42	applied	\N	\N	\N	\N	75644	75644	243776
4677	3866	1	applied	\N	\N	\N	\N	75202	75202	243334
4679	3867	0	applied	\N	\N	\N	\N	75205	75205	243337
4727	3899	1	applied	\N	\N	\N	\N	75292	75292	243424
4734	3903	0	applied	\N	\N	\N	\N	75306	75306	243438
4739	3909	0	applied	\N	\N	\N	\N	75313	75313	243445
4742	3888	0	applied	\N	\N	\N	\N	75318	75318	243450
4742	3889	1	applied	\N	\N	\N	\N	75319	75319	243451
4742	3890	2	applied	\N	\N	\N	\N	75320	75320	243452
4742	3906	4	applied	\N	\N	\N	\N	75322	75322	243454
4742	3893	5	applied	\N	\N	\N	\N	75323	75323	243455
4742	3892	6	applied	\N	\N	\N	\N	75324	75324	243456
4742	3899	7	applied	\N	\N	\N	\N	75325	75325	243457
4742	3894	8	applied	\N	\N	\N	\N	75326	75326	243458
4742	3895	9	applied	\N	\N	\N	\N	75327	75327	243459
4742	3896	10	applied	\N	\N	\N	\N	75328	75328	243460
4742	3897	11	applied	\N	\N	\N	\N	75329	75329	243461
4742	3898	12	applied	\N	\N	\N	\N	75330	75330	243462
4742	3901	13	applied	\N	\N	\N	\N	75331	75331	243463
4742	3902	14	applied	\N	\N	\N	\N	75332	75332	243464
4742	3903	15	applied	\N	\N	\N	\N	75333	75333	243465
4742	3904	16	applied	\N	\N	\N	\N	75334	75334	243466
4742	3905	17	applied	\N	\N	\N	\N	75335	75335	243467
4742	3907	18	applied	\N	\N	\N	\N	75336	75336	243468
4742	3908	19	applied	\N	\N	\N	\N	75337	75337	243469
4742	3910	21	applied	\N	\N	\N	\N	75339	75339	243471
4742	3911	22	applied	\N	\N	\N	\N	75340	75340	243472
4744	3912	0	applied	\N	\N	\N	\N	75343	75343	243475
4744	3913	1	applied	\N	\N	\N	\N	75344	75344	243476
4752	3917	0	applied	\N	\N	\N	\N	75358	75358	243490
4753	3918	0	applied	\N	\N	\N	\N	75359	75359	243491
4758	3921	0	applied	\N	\N	\N	\N	75365	75365	243497
4761	3924	0	applied	\N	\N	\N	\N	75369	75369	243501
4765	3926	0	applied	\N	\N	\N	\N	75401	75401	243533
4767	3927	0	applied	\N	\N	\N	\N	75403	75403	243535
4772	3933	0	applied	\N	\N	\N	\N	75414	75414	243546
4775	3934	0	applied	\N	\N	\N	\N	75417	75417	243549
4775	3935	1	applied	\N	\N	\N	\N	75418	75418	243550
4776	3933	0	applied	\N	\N	\N	\N	75419	75419	243551
4776	3934	1	applied	\N	\N	\N	\N	75420	75420	243552
4776	3935	2	applied	\N	\N	\N	\N	75421	75421	243553
4779	3937	0	applied	\N	\N	\N	\N	75424	75424	243556
4780	3937	0	applied	\N	\N	\N	\N	75425	75425	243557
4782	3939	0	applied	\N	\N	\N	\N	75427	75427	243559
4785	3943	0	applied	\N	\N	\N	\N	75431	75431	243563
4787	3944	0	applied	\N	\N	\N	\N	75433	75433	243565
4788	3945	0	applied	\N	\N	\N	\N	75434	75434	243566
4788	3946	1	applied	\N	\N	\N	\N	75435	75435	243567
4790	3947	0	applied	\N	\N	\N	\N	75438	75438	243570
4790	3948	1	applied	\N	\N	\N	\N	75439	75439	243571
4791	3947	0	applied	\N	\N	\N	\N	75440	75440	243572
4791	3948	1	applied	\N	\N	\N	\N	75441	75441	243573
4792	3949	0	applied	\N	\N	\N	\N	75442	75442	243574
4793	3950	0	applied	\N	\N	\N	\N	75443	75443	243575
4795	3952	0	applied	\N	\N	\N	\N	75445	75445	243577
4797	3953	0	applied	\N	\N	\N	\N	75447	75447	243579
4798	3955	1	applied	\N	\N	1000000000	\N	75449	75449	243581
4798	3956	2	applied	\N	\N	1000000000	\N	75450	75450	243582
4798	3957	3	applied	\N	\N	1000000000	\N	75451	75451	243583
4798	3958	4	applied	\N	\N	1000000000	\N	75452	75452	243584
4798	3959	5	applied	\N	\N	1000000000	\N	75453	75453	243585
4798	3960	6	applied	\N	\N	\N	\N	75454	75454	243586
4800	3961	0	applied	\N	\N	\N	\N	75462	75462	243594
4802	3962	0	applied	\N	\N	\N	\N	75464	75464	243596
4802	3963	1	applied	\N	\N	\N	\N	75465	75465	243597
4805	3965	0	applied	\N	\N	\N	\N	75468	75468	243600
4807	3966	0	applied	\N	\N	\N	\N	75470	75470	243602
4809	3968	0	applied	\N	\N	\N	\N	75472	75472	243604
4810	3968	0	applied	\N	\N	\N	\N	75473	75473	243605
4811	3954	0	applied	\N	\N	1000000000	\N	75474	75474	243606
4811	3955	1	applied	\N	\N	1000000000	\N	75475	75475	243607
4811	3956	2	applied	\N	\N	1000000000	\N	75476	75476	243608
4811	3957	3	applied	\N	\N	1000000000	\N	75477	75477	243609
4811	3861	4	applied	\N	\N	\N	\N	75478	75478	243610
4811	3959	6	applied	\N	\N	1000000000	\N	75480	75480	243612
4811	3962	7	applied	\N	\N	\N	\N	75481	75481	243613
4814	3972	0	applied	\N	\N	\N	\N	75584	75584	243716
4817	3974	0	applied	\N	\N	\N	\N	75588	75588	243720
4817	3975	1	applied	\N	\N	\N	\N	75589	75589	243721
4821	3977	0	applied	\N	\N	1000000000	\N	75594	75594	243726
4821	3978	1	applied	\N	\N	\N	\N	75595	75595	243727
4821	3979	2	applied	\N	\N	\N	\N	75596	75596	243728
4824	3981	0	applied	\N	\N	\N	\N	75600	75600	243732
4824	3982	1	applied	\N	\N	\N	\N	75601	75601	243733
4830	3984	0	applied	\N	\N	\N	\N	75730	75730	243862
4830	3985	1	applied	\N	\N	\N	\N	75731	75731	243863
4836	3989	0	applied	\N	\N	\N	\N	75761	75761	243893
4836	3990	1	applied	\N	\N	\N	\N	75762	75762	243894
4836	3991	2	applied	\N	\N	\N	\N	75763	75763	243895
4840	3992	0	applied	\N	\N	\N	\N	75767	75767	243899
4845	3996	0	applied	\N	\N	\N	\N	75897	75897	244029
4854	4003	1	applied	\N	\N	\N	\N	75910	75910	244042
4859	4004	0	applied	\N	\N	\N	\N	75914	75914	244046
4861	4005	0	applied	\N	\N	\N	\N	76036	76036	244168
4861	4006	1	applied	\N	\N	\N	\N	76037	76037	244169
4861	4007	2	applied	\N	\N	\N	\N	76038	76038	244170
4861	4008	3	applied	\N	\N	\N	\N	76039	76039	244171
4868	4013	0	applied	\N	\N	\N	\N	76052	76052	244184
4876	4016	0	applied	\N	\N	\N	\N	76182	76182	244314
4879	4019	0	applied	\N	\N	\N	\N	76185	76185	244317
4879	4020	1	applied	\N	\N	\N	\N	76186	76186	244318
4879	4021	2	applied	\N	\N	\N	\N	76187	76187	244319
4882	4019	0	applied	\N	\N	\N	\N	76194	76194	244326
4882	4020	1	applied	\N	\N	\N	\N	76195	76195	244327
4882	4021	2	applied	\N	\N	\N	\N	76196	76196	244328
4886	4024	0	applied	\N	\N	\N	\N	76202	76202	244334
4886	4025	1	applied	\N	\N	\N	\N	76203	76203	244335
4888	4026	0	applied	\N	\N	\N	\N	76206	76206	244338
4891	4031	0	applied	\N	\N	\N	\N	76211	76211	244343
4893	4031	0	applied	\N	\N	\N	\N	76213	76213	244345
4900	4033	0	applied	\N	\N	\N	\N	76320	76320	244452
4724	3897	1	applied	\N	\N	\N	\N	75286	75286	243418
4727	3898	0	applied	\N	\N	\N	\N	75291	75291	243423
4811	3877	11	applied	\N	\N	1000000000	\N	75485	75485	243617
4811	3906	12	applied	\N	\N	\N	\N	75486	75486	243618
4811	3831	13	applied	\N	\N	\N	\N	75487	75487	243619
4811	3832	14	applied	\N	\N	\N	\N	75488	75488	243620
4811	3833	15	applied	\N	\N	\N	\N	75489	75489	243621
4811	3834	16	applied	\N	\N	\N	\N	75490	75490	243622
4811	3835	17	applied	\N	\N	\N	\N	75491	75491	243623
4811	3836	18	applied	\N	\N	\N	\N	75492	75492	243624
4811	3837	19	applied	\N	\N	\N	\N	75493	75493	243625
4811	3838	20	applied	\N	\N	\N	\N	75494	75494	243626
4811	3839	21	applied	\N	\N	\N	\N	75495	75495	243627
4811	3841	23	applied	\N	\N	\N	\N	75497	75497	243629
4811	3842	24	applied	\N	\N	\N	\N	75498	75498	243630
4811	3843	25	applied	\N	\N	\N	\N	75499	75499	243631
4811	3845	26	applied	\N	\N	\N	\N	75500	75500	243632
4811	3852	27	applied	\N	\N	\N	\N	75501	75501	243633
4811	3853	28	applied	\N	\N	\N	\N	75502	75502	243634
4811	3854	29	applied	\N	\N	\N	\N	75503	75503	243635
4811	3855	30	applied	\N	\N	\N	\N	75504	75504	243636
4811	3856	31	applied	\N	\N	\N	\N	75505	75505	243637
4811	3857	32	applied	\N	\N	\N	\N	75506	75506	243638
4811	3858	33	applied	\N	\N	\N	\N	75507	75507	243639
4811	3859	34	applied	\N	\N	\N	\N	75508	75508	243640
4811	3860	35	applied	\N	\N	\N	\N	75509	75509	243641
4811	3862	36	applied	\N	\N	\N	\N	75510	75510	243642
4811	3863	37	applied	\N	\N	\N	\N	75511	75511	243643
4811	3864	38	applied	\N	\N	\N	\N	75512	75512	243644
4811	3866	40	applied	\N	\N	\N	\N	75514	75514	243646
4811	3867	41	applied	\N	\N	\N	\N	75515	75515	243647
4811	3868	42	applied	\N	\N	\N	\N	75516	75516	243648
4811	3869	43	applied	\N	\N	\N	\N	75517	75517	243649
4811	3870	44	applied	\N	\N	\N	\N	75518	75518	243650
4811	3871	45	applied	\N	\N	\N	\N	75519	75519	243651
4811	3872	46	applied	\N	\N	\N	\N	75520	75520	243652
4811	3873	47	applied	\N	\N	\N	\N	75521	75521	243653
4811	3874	48	applied	\N	\N	\N	\N	75522	75522	243654
4811	3875	49	applied	\N	\N	\N	\N	75523	75523	243655
4811	3876	50	applied	\N	\N	\N	\N	75524	75524	243656
4811	3878	51	applied	\N	\N	\N	\N	75525	75525	243657
4811	3879	52	applied	\N	\N	\N	\N	75526	75526	243658
4811	3880	53	applied	\N	\N	\N	\N	75527	75527	243659
4811	3881	54	applied	\N	\N	\N	\N	75528	75528	243660
4811	3882	55	applied	\N	\N	\N	\N	75529	75529	243661
4811	3884	57	applied	\N	\N	\N	\N	75531	75531	243663
4811	3885	58	applied	\N	\N	\N	\N	75532	75532	243664
4811	3886	59	applied	\N	\N	\N	\N	75533	75533	243665
4811	3887	60	applied	\N	\N	\N	\N	75534	75534	243666
4811	3888	61	applied	\N	\N	\N	\N	75535	75535	243667
4811	3889	62	applied	\N	\N	\N	\N	75536	75536	243668
4811	3890	63	applied	\N	\N	\N	\N	75537	75537	243669
4811	3891	64	applied	\N	\N	\N	\N	75538	75538	243670
4811	3893	65	applied	\N	\N	\N	\N	75539	75539	243671
4811	3894	66	applied	\N	\N	\N	\N	75540	75540	243672
4811	3895	67	applied	\N	\N	\N	\N	75541	75541	243673
4811	3896	68	applied	\N	\N	\N	\N	75542	75542	243674
4811	3897	69	applied	\N	\N	\N	\N	75543	75543	243675
4811	3898	70	applied	\N	\N	\N	\N	75544	75544	243676
4811	3901	71	applied	\N	\N	\N	\N	75545	75545	243677
4811	3902	72	applied	\N	\N	\N	\N	75546	75546	243678
4811	3904	74	applied	\N	\N	\N	\N	75548	75548	243680
4811	3905	75	applied	\N	\N	\N	\N	75549	75549	243681
4811	3907	76	applied	\N	\N	\N	\N	75550	75550	243682
4811	3908	77	applied	\N	\N	\N	\N	75551	75551	243683
4811	3909	78	applied	\N	\N	\N	\N	75552	75552	243684
4811	3910	79	applied	\N	\N	\N	\N	75553	75553	243685
4811	3911	80	applied	\N	\N	\N	\N	75554	75554	243686
4811	3912	81	applied	\N	\N	\N	\N	75555	75555	243687
4811	3913	82	applied	\N	\N	\N	\N	75556	75556	243688
4811	3914	83	applied	\N	\N	\N	\N	75557	75557	243689
4811	3915	84	applied	\N	\N	\N	\N	75558	75558	243690
4811	3916	85	applied	\N	\N	\N	\N	75559	75559	243691
4811	3917	86	applied	\N	\N	\N	\N	75560	75560	243692
4811	3918	87	applied	\N	\N	\N	\N	75561	75561	243693
4811	3919	88	applied	\N	\N	\N	\N	75562	75562	243694
4811	3920	89	applied	\N	\N	\N	\N	75563	75563	243695
4811	3923	91	applied	\N	\N	\N	\N	75565	75565	243697
4811	3924	92	applied	\N	\N	\N	\N	75566	75566	243698
4811	3925	93	applied	\N	\N	\N	\N	75567	75567	243699
4811	3926	94	applied	\N	\N	\N	\N	75568	75568	243700
4811	3927	95	applied	\N	\N	\N	\N	75569	75569	243701
4811	3928	96	applied	\N	\N	\N	\N	75570	75570	243702
4811	3929	97	applied	\N	\N	\N	\N	75571	75571	243703
4811	3930	98	applied	\N	\N	\N	\N	75572	75572	243704
4811	3931	99	applied	\N	\N	\N	\N	75573	75573	243705
4811	3932	100	applied	\N	\N	\N	\N	75574	75574	243706
4811	3933	101	applied	\N	\N	\N	\N	75575	75575	243707
4811	3934	102	applied	\N	\N	\N	\N	75576	75576	243708
4811	3935	103	applied	\N	\N	\N	\N	75577	75577	243709
4811	3936	104	applied	\N	\N	\N	\N	75578	75578	243710
4811	3937	105	applied	\N	\N	\N	\N	75579	75579	243711
4811	3938	106	applied	\N	\N	\N	\N	75580	75580	243712
4813	3971	1	applied	\N	\N	\N	\N	75583	75583	243715
4816	3974	0	applied	\N	\N	\N	\N	75586	75586	243718
4816	3975	1	applied	\N	\N	\N	\N	75587	75587	243719
4823	3981	0	applied	\N	\N	\N	\N	75598	75598	243730
4823	3982	1	applied	\N	\N	\N	\N	75599	75599	243731
4832	3987	0	applied	\N	\N	\N	\N	75733	75733	243865
4832	3988	1	applied	\N	\N	\N	\N	75734	75734	243866
4834	3987	0	applied	\N	\N	\N	\N	75756	75756	243888
4834	3988	1	applied	\N	\N	\N	\N	75757	75757	243889
4835	3989	0	applied	\N	\N	\N	\N	75758	75758	243890
4835	3990	1	applied	\N	\N	\N	\N	75759	75759	243891
4835	3991	2	applied	\N	\N	\N	\N	75760	75760	243892
4842	3994	0	applied	\N	\N	\N	\N	75769	75769	243901
4842	3995	1	applied	\N	\N	\N	\N	75770	75770	243902
4844	3996	0	applied	\N	\N	\N	\N	75896	75896	244028
4849	3998	0	applied	\N	\N	\N	\N	75901	75901	244033
4851	4001	1	applied	\N	\N	\N	\N	75904	75904	244036
4856	4004	0	applied	\N	\N	\N	\N	75912	75912	244044
4811	3892	9	applied	\N	\N	\N	\N	75483	75483	243615
4811	3899	10	applied	\N	\N	\N	\N	75484	75484	243616
4825	3872	46	applied	\N	\N	\N	\N	75648	75648	243780
4825	3873	47	applied	\N	\N	\N	\N	75649	75649	243781
4825	3874	48	applied	\N	\N	\N	\N	75650	75650	243782
4825	3875	49	applied	\N	\N	\N	\N	75651	75651	243783
4825	3876	50	applied	\N	\N	\N	\N	75652	75652	243784
4825	3879	52	applied	\N	\N	\N	\N	75654	75654	243786
4825	3880	53	applied	\N	\N	\N	\N	75655	75655	243787
4825	3881	54	applied	\N	\N	\N	\N	75656	75656	243788
4825	3882	55	applied	\N	\N	\N	\N	75657	75657	243789
4825	3883	56	applied	\N	\N	\N	\N	75658	75658	243790
4825	3884	57	applied	\N	\N	\N	\N	75659	75659	243791
4825	3885	58	applied	\N	\N	\N	\N	75660	75660	243792
4825	3886	59	applied	\N	\N	\N	\N	75661	75661	243793
4825	3887	60	applied	\N	\N	\N	\N	75662	75662	243794
4825	3888	61	applied	\N	\N	\N	\N	75663	75663	243795
4825	3889	62	applied	\N	\N	\N	\N	75664	75664	243796
4825	3890	63	applied	\N	\N	\N	\N	75665	75665	243797
4825	3891	64	applied	\N	\N	\N	\N	75666	75666	243798
4863	4005	0	applied	\N	\N	\N	\N	76044	76044	244176
4863	4006	1	applied	\N	\N	\N	\N	76045	76045	244177
4863	4007	2	applied	\N	\N	\N	\N	76046	76046	244178
4865	4010	0	applied	\N	\N	\N	\N	76049	76049	244181
4873	4014	0	applied	\N	\N	\N	\N	76057	76057	244189
4874	3954	0	applied	\N	\N	1000000000	\N	76058	76058	244190
4874	3955	1	applied	\N	\N	1000000000	\N	76059	76059	244191
4874	3956	2	applied	\N	\N	1000000000	\N	76060	76060	244192
4874	3957	3	applied	\N	\N	1000000000	\N	76061	76061	244193
4874	3977	4	applied	\N	\N	1000000000	\N	76062	76062	244194
4874	3835	5	applied	\N	\N	\N	\N	76063	76063	244195
4874	3836	6	applied	\N	\N	\N	\N	76064	76064	244196
4874	3837	7	applied	\N	\N	\N	\N	76065	76065	244197
4874	3838	8	applied	\N	\N	\N	\N	76066	76066	244198
4874	3981	9	applied	\N	\N	\N	\N	76067	76067	244199
4874	3892	10	applied	\N	\N	\N	\N	76068	76068	244200
4874	3899	11	applied	\N	\N	\N	\N	76069	76069	244201
4874	3839	12	applied	\N	\N	\N	\N	76070	76070	244202
4874	3840	13	applied	\N	\N	\N	\N	76071	76071	244203
4874	3842	15	applied	\N	\N	\N	\N	76073	76073	244205
4874	3843	16	applied	\N	\N	\N	\N	76074	76074	244206
4874	3845	17	applied	\N	\N	\N	\N	76075	76075	244207
4874	3877	18	applied	\N	\N	1000000000	\N	76076	76076	244208
4874	3906	19	applied	\N	\N	\N	\N	76077	76077	244209
4874	3852	20	applied	\N	\N	\N	\N	76078	76078	244210
4874	3853	21	applied	\N	\N	\N	\N	76079	76079	244211
4874	3854	22	applied	\N	\N	\N	\N	76080	76080	244212
4874	3855	23	applied	\N	\N	\N	\N	76081	76081	244213
4874	3856	24	applied	\N	\N	\N	\N	76082	76082	244214
4874	3857	25	applied	\N	\N	\N	\N	76083	76083	244215
4874	3858	26	applied	\N	\N	\N	\N	76084	76084	244216
4874	3859	27	applied	\N	\N	\N	\N	76085	76085	244217
4874	3860	28	applied	\N	\N	\N	\N	76086	76086	244218
4874	3862	29	applied	\N	\N	\N	\N	76087	76087	244219
4874	3863	30	applied	\N	\N	\N	\N	76088	76088	244220
4874	3865	32	applied	\N	\N	\N	\N	76090	76090	244222
4874	3866	33	applied	\N	\N	\N	\N	76091	76091	244223
4874	3867	34	applied	\N	\N	\N	\N	76092	76092	244224
4874	3868	35	applied	\N	\N	\N	\N	76093	76093	244225
4874	3869	36	applied	\N	\N	\N	\N	76094	76094	244226
4874	3870	37	applied	\N	\N	\N	\N	76095	76095	244227
4874	3871	38	applied	\N	\N	\N	\N	76096	76096	244228
4874	3872	39	applied	\N	\N	\N	\N	76097	76097	244229
4874	3873	40	applied	\N	\N	\N	\N	76098	76098	244230
4874	3874	41	applied	\N	\N	\N	\N	76099	76099	244231
4874	3875	42	applied	\N	\N	\N	\N	76100	76100	244232
4874	3876	43	applied	\N	\N	\N	\N	76101	76101	244233
4874	3878	44	applied	\N	\N	\N	\N	76102	76102	244234
4874	3879	45	applied	\N	\N	\N	\N	76103	76103	244235
4874	3880	46	applied	\N	\N	\N	\N	76104	76104	244236
4874	3881	47	applied	\N	\N	\N	\N	76105	76105	244237
4874	3883	49	applied	\N	\N	\N	\N	76107	76107	244239
4874	3884	50	applied	\N	\N	\N	\N	76108	76108	244240
4874	3885	51	applied	\N	\N	\N	\N	76109	76109	244241
4874	3886	52	applied	\N	\N	\N	\N	76110	76110	244242
4874	3887	53	applied	\N	\N	\N	\N	76111	76111	244243
4874	3888	54	applied	\N	\N	\N	\N	76112	76112	244244
4874	3889	55	applied	\N	\N	\N	\N	76113	76113	244245
4874	3890	56	applied	\N	\N	\N	\N	76114	76114	244246
4874	3891	57	applied	\N	\N	\N	\N	76115	76115	244247
4874	3893	58	applied	\N	\N	\N	\N	76116	76116	244248
4874	3894	59	applied	\N	\N	\N	\N	76117	76117	244249
4874	3895	60	applied	\N	\N	\N	\N	76118	76118	244250
4874	3896	61	applied	\N	\N	\N	\N	76119	76119	244251
4874	3897	62	applied	\N	\N	\N	\N	76120	76120	244252
4874	3898	63	applied	\N	\N	\N	\N	76121	76121	244253
4874	3901	64	applied	\N	\N	\N	\N	76122	76122	244254
4874	3903	66	applied	\N	\N	\N	\N	76124	76124	244256
4874	3904	67	applied	\N	\N	\N	\N	76125	76125	244257
4874	3905	68	applied	\N	\N	\N	\N	76126	76126	244258
4874	3907	69	applied	\N	\N	\N	\N	76127	76127	244259
4874	3908	70	applied	\N	\N	\N	\N	76128	76128	244260
4874	3909	71	applied	\N	\N	\N	\N	76129	76129	244261
4874	3910	72	applied	\N	\N	\N	\N	76130	76130	244262
4874	3911	73	applied	\N	\N	\N	\N	76131	76131	244263
4874	3912	74	applied	\N	\N	\N	\N	76132	76132	244264
4874	3913	75	applied	\N	\N	\N	\N	76133	76133	244265
4874	3914	76	applied	\N	\N	\N	\N	76134	76134	244266
4874	3915	77	applied	\N	\N	\N	\N	76135	76135	244267
4874	3916	78	applied	\N	\N	\N	\N	76136	76136	244268
4874	3917	79	applied	\N	\N	\N	\N	76137	76137	244269
4874	3918	80	applied	\N	\N	\N	\N	76138	76138	244270
4874	3919	81	applied	\N	\N	\N	\N	76139	76139	244271
4874	3922	83	applied	\N	\N	\N	\N	76141	76141	244273
4874	3923	84	applied	\N	\N	\N	\N	76142	76142	244274
4874	3924	85	applied	\N	\N	\N	\N	76143	76143	244275
4874	3925	86	applied	\N	\N	\N	\N	76144	76144	244276
4874	3926	87	applied	\N	\N	\N	\N	76145	76145	244277
4874	3927	88	applied	\N	\N	\N	\N	76146	76146	244278
4874	3928	89	applied	\N	\N	\N	\N	76147	76147	244279
4874	3929	90	applied	\N	\N	\N	\N	76148	76148	244280
4825	3870	44	applied	\N	\N	\N	\N	75646	75646	243778
4825	3871	45	applied	\N	\N	\N	\N	75647	75647	243779
4825	3896	68	applied	\N	\N	\N	\N	75670	75670	243802
4825	3897	69	applied	\N	\N	\N	\N	75671	75671	243803
4825	3898	70	applied	\N	\N	\N	\N	75672	75672	243804
4825	3901	71	applied	\N	\N	\N	\N	75673	75673	243805
4825	3902	72	applied	\N	\N	\N	\N	75674	75674	243806
4825	3904	74	applied	\N	\N	\N	\N	75676	75676	243808
4825	3905	75	applied	\N	\N	\N	\N	75677	75677	243809
4825	3907	76	applied	\N	\N	\N	\N	75678	75678	243810
4825	3908	77	applied	\N	\N	\N	\N	75679	75679	243811
4825	3909	78	applied	\N	\N	\N	\N	75680	75680	243812
4825	3910	79	applied	\N	\N	\N	\N	75681	75681	243813
4825	3911	80	applied	\N	\N	\N	\N	75682	75682	243814
4825	3912	81	applied	\N	\N	\N	\N	75683	75683	243815
4825	3913	82	applied	\N	\N	\N	\N	75684	75684	243816
4825	3914	83	applied	\N	\N	\N	\N	75685	75685	243817
4825	3915	84	applied	\N	\N	\N	\N	75686	75686	243818
4825	3916	85	applied	\N	\N	\N	\N	75687	75687	243819
4825	3917	86	applied	\N	\N	\N	\N	75688	75688	243820
4825	3918	87	applied	\N	\N	\N	\N	75689	75689	243821
4825	3919	88	applied	\N	\N	\N	\N	75690	75690	243822
4825	3920	89	applied	\N	\N	\N	\N	75691	75691	243823
4825	3923	91	applied	\N	\N	\N	\N	75693	75693	243825
4825	3924	92	applied	\N	\N	\N	\N	75694	75694	243826
4825	3925	93	applied	\N	\N	\N	\N	75695	75695	243827
4825	3926	94	applied	\N	\N	\N	\N	75696	75696	243828
4825	3927	95	applied	\N	\N	\N	\N	75697	75697	243829
4825	3928	96	applied	\N	\N	\N	\N	75698	75698	243830
4825	3929	97	applied	\N	\N	\N	\N	75699	75699	243831
4825	3930	98	applied	\N	\N	\N	\N	75700	75700	243832
4825	3931	99	applied	\N	\N	\N	\N	75701	75701	243833
4825	3932	100	applied	\N	\N	\N	\N	75702	75702	243834
4825	3933	101	applied	\N	\N	\N	\N	75703	75703	243835
4825	3934	103	applied	\N	\N	\N	\N	75704	75704	243836
4825	3935	104	applied	\N	\N	\N	\N	75705	75705	243837
4825	3936	105	applied	\N	\N	\N	\N	75706	75706	243838
4825	3937	106	applied	\N	\N	\N	\N	75707	75707	243839
4825	3938	107	applied	\N	\N	\N	\N	75708	75708	243840
4825	3940	109	applied	\N	\N	\N	\N	75710	75710	243842
4825	3941	110	applied	\N	\N	\N	\N	75711	75711	243843
4825	3942	111	applied	\N	\N	\N	\N	75712	75712	243844
4825	3943	112	applied	\N	\N	\N	\N	75713	75713	243845
4825	3944	113	applied	\N	\N	\N	\N	75714	75714	243846
4825	3945	114	applied	\N	\N	\N	\N	75715	75715	243847
4825	3946	115	applied	\N	\N	\N	\N	75716	75716	243848
4825	3947	116	applied	\N	\N	\N	\N	75717	75717	243849
4825	3948	117	applied	\N	\N	\N	\N	75718	75718	243850
4825	3949	118	applied	\N	\N	\N	\N	75719	75719	243851
4825	3950	119	applied	\N	\N	\N	\N	75720	75720	243852
4825	3951	120	applied	\N	\N	\N	\N	75721	75721	243853
4825	3952	121	applied	\N	\N	\N	\N	75722	75722	243854
4825	3953	122	applied	\N	\N	\N	\N	75723	75723	243855
4825	3960	123	applied	\N	\N	\N	\N	75724	75724	243856
4825	3961	124	applied	\N	\N	\N	\N	75725	75725	243857
4829	3984	0	applied	\N	\N	\N	\N	75728	75728	243860
4829	3985	1	applied	\N	\N	\N	\N	75729	75729	243861
4831	3986	0	applied	\N	\N	\N	\N	75732	75732	243864
4841	3993	0	applied	\N	\N	\N	\N	75768	75768	243900
4843	3861	7	applied	\N	\N	\N	\N	75778	75778	243910
4843	3958	8	applied	\N	\N	1000000000	\N	75779	75779	243911
4843	3959	9	applied	\N	\N	1000000000	\N	75780	75780	243912
4843	3962	10	applied	\N	\N	\N	\N	75781	75781	243913
4843	3977	11	applied	\N	\N	1000000000	\N	75782	75782	243914
4843	3844	12	applied	\N	\N	\N	\N	75783	75783	243915
4843	3802	13	applied	\N	\N	\N	\N	75784	75784	243916
4843	3981	14	applied	\N	\N	\N	\N	75785	75785	243917
4843	3805	15	applied	\N	\N	\N	\N	75786	75786	243918
4843	3877	16	applied	\N	\N	1000000000	\N	75787	75787	243919
4843	3486	17	applied	\N	\N	\N	\N	75788	75788	243920
4843	3487	18	applied	\N	\N	\N	\N	75789	75789	243921
4843	3489	20	applied	\N	\N	\N	\N	75791	75791	243923
4843	3490	21	applied	\N	\N	\N	\N	75792	75792	243924
4843	3491	22	applied	\N	\N	\N	\N	75793	75793	243925
4843	3494	23	applied	\N	\N	\N	\N	75794	75794	243926
4843	3495	24	applied	\N	\N	\N	\N	75795	75795	243927
4843	3496	25	applied	\N	\N	\N	\N	75796	75796	243928
4843	3497	26	applied	\N	\N	\N	\N	75797	75797	243929
4843	3498	27	applied	\N	\N	\N	\N	75798	75798	243930
4843	3499	28	applied	\N	\N	\N	\N	75799	75799	243931
4848	3998	0	applied	\N	\N	\N	\N	75900	75900	244032
4850	3999	0	applied	\N	\N	\N	\N	75902	75902	244034
4853	4002	0	applied	\N	\N	1000000000	\N	75907	75907	244039
4853	4003	1	applied	\N	\N	\N	\N	75908	75908	244040
4855	4004	0	applied	\N	\N	\N	\N	75911	75911	244043
4864	4009	0	applied	\N	\N	\N	\N	76048	76048	244180
4867	4012	0	applied	\N	\N	\N	\N	76051	76051	244183
4872	4014	0	applied	\N	\N	\N	\N	76056	76056	244188
4877	4017	0	applied	\N	\N	\N	\N	76183	76183	244315
4881	4019	0	applied	\N	\N	\N	\N	76191	76191	244323
4881	4020	1	applied	\N	\N	\N	\N	76192	76192	244324
4881	4021	2	applied	\N	\N	\N	\N	76193	76193	244325
4890	4030	0	applied	\N	\N	\N	\N	76210	76210	244342
4894	4031	0	applied	\N	\N	\N	\N	76214	76214	244346
4906	4035	0	applied	\N	\N	\N	\N	76325	76325	244457
4908	4036	0	applied	\N	\N	\N	\N	76326	76326	244458
4908	4037	1	applied	\N	\N	\N	\N	76327	76327	244459
4908	4038	2	applied	\N	\N	\N	\N	76328	76328	244460
4913	4039	0	applied	\N	\N	\N	\N	76339	76339	244471
4915	4040	0	applied	\N	\N	1000000000	\N	76341	76341	244473
4915	4041	1	applied	\N	\N	\N	\N	76342	76342	244474
4915	4042	2	applied	\N	\N	\N	\N	76343	76343	244475
4915	4043	3	applied	\N	\N	\N	\N	76344	76344	244476
4923	4048	0	applied	\N	\N	\N	\N	76354	76354	244486
4925	4049	0	applied	\N	\N	\N	\N	76356	76356	244488
4927	4051	0	applied	\N	\N	\N	\N	76358	76358	244490
4936	4064	0	applied	\N	\N	\N	\N	76374	76374	244506
4947	4069	0	applied	\N	\N	\N	\N	76401	76401	244533
4950	4071	0	applied	\N	\N	\N	\N	76404	76404	244536
4950	4072	1	applied	\N	\N	\N	\N	76405	76405	244537
4950	4073	2	applied	\N	\N	\N	\N	76406	76406	244538
4825	3894	66	applied	\N	\N	\N	\N	75668	75668	243800
4825	3895	67	applied	\N	\N	\N	\N	75669	75669	243801
4843	3503	32	applied	\N	\N	\N	\N	75803	75803	243935
4843	3505	33	applied	\N	\N	\N	\N	75804	75804	243936
4843	3508	34	applied	\N	\N	\N	\N	75805	75805	243937
4843	3511	35	applied	\N	\N	\N	\N	75806	75806	243938
4843	3515	36	applied	\N	\N	\N	\N	75807	75807	243939
4843	3528	37	applied	\N	\N	\N	\N	75808	75808	243940
4843	3536	38	applied	\N	\N	\N	\N	75809	75809	243941
4843	3546	39	applied	\N	\N	\N	\N	75810	75810	243942
4843	3557	40	applied	\N	\N	\N	\N	75811	75811	243943
4843	3566	41	applied	\N	\N	\N	\N	75812	75812	243944
4843	3575	42	applied	\N	\N	\N	\N	75813	75813	243945
4843	3586	43	applied	\N	\N	\N	\N	75814	75814	243946
4843	3598	44	applied	\N	\N	\N	\N	75815	75815	243947
4843	3605	45	applied	\N	\N	\N	\N	75816	75816	243948
4843	3630	47	applied	\N	\N	\N	\N	75818	75818	243950
4843	3631	48	applied	\N	\N	\N	\N	75819	75819	243951
4843	3632	49	applied	\N	\N	\N	\N	75820	75820	243952
4843	3633	50	applied	\N	\N	\N	\N	75821	75821	243953
4843	3640	51	applied	\N	\N	\N	\N	75822	75822	243954
4843	3641	52	applied	\N	\N	\N	\N	75823	75823	243955
4843	3648	53	applied	\N	\N	\N	\N	75824	75824	243956
4843	3649	54	applied	\N	\N	\N	\N	75825	75825	243957
4843	3650	55	applied	\N	\N	\N	\N	75826	75826	243958
4843	3651	56	applied	\N	\N	\N	\N	75827	75827	243959
4843	3653	57	applied	\N	\N	\N	\N	75828	75828	243960
4843	3654	58	applied	\N	\N	\N	\N	75829	75829	243961
4843	3655	59	applied	\N	\N	\N	\N	75830	75830	243962
4843	3656	60	applied	\N	\N	\N	\N	75831	75831	243963
4843	3658	61	applied	\N	\N	\N	\N	75832	75832	243964
4843	3659	62	applied	\N	\N	\N	\N	75833	75833	243965
4843	3662	64	applied	\N	\N	\N	\N	75835	75835	243967
4843	3663	65	applied	\N	\N	\N	\N	75836	75836	243968
4843	3664	66	applied	\N	\N	\N	\N	75837	75837	243969
4843	3665	67	applied	\N	\N	\N	\N	75838	75838	243970
4843	3666	68	applied	\N	\N	\N	\N	75839	75839	243971
4843	3669	69	applied	\N	\N	\N	\N	75840	75840	243972
4843	3671	70	applied	\N	\N	\N	\N	75841	75841	243973
4843	3673	71	applied	\N	\N	\N	\N	75842	75842	243974
4843	3675	72	applied	\N	\N	\N	\N	75843	75843	243975
4843	3676	73	applied	\N	\N	\N	\N	75844	75844	243976
4843	3678	74	applied	\N	\N	\N	\N	75845	75845	243977
4843	3679	75	applied	\N	\N	\N	\N	75846	75846	243978
4843	3681	76	applied	\N	\N	\N	\N	75847	75847	243979
4843	3682	77	applied	\N	\N	\N	\N	75848	75848	243980
4843	3683	78	applied	\N	\N	\N	\N	75849	75849	243981
4843	3686	79	applied	\N	\N	\N	\N	75850	75850	243982
4843	3689	81	applied	\N	\N	\N	\N	75852	75852	243984
4843	3690	82	applied	\N	\N	\N	\N	75853	75853	243985
4843	3691	83	applied	\N	\N	\N	\N	75854	75854	243986
4843	3692	84	applied	\N	\N	\N	\N	75855	75855	243987
4843	3694	85	applied	\N	\N	\N	\N	75856	75856	243988
4843	3695	87	applied	\N	\N	\N	\N	75857	75857	243989
4843	3697	88	applied	\N	\N	\N	\N	75858	75858	243990
4843	3698	89	applied	\N	\N	\N	\N	75859	75859	243991
4843	3699	90	applied	\N	\N	\N	\N	75860	75860	243992
4843	3700	91	applied	\N	\N	\N	\N	75861	75861	243993
4843	3701	92	applied	\N	\N	\N	\N	75862	75862	243994
4843	3702	93	applied	\N	\N	\N	\N	75863	75863	243995
4843	3704	94	applied	\N	\N	\N	\N	75864	75864	243996
4843	3705	95	applied	\N	\N	\N	\N	75865	75865	243997
4843	3706	96	applied	\N	\N	\N	\N	75866	75866	243998
4843	3707	97	applied	\N	\N	\N	\N	75867	75867	243999
4843	3709	99	applied	\N	\N	\N	\N	75869	75869	244001
4843	3710	100	applied	\N	\N	\N	\N	75870	75870	244002
4843	3711	101	applied	\N	\N	\N	\N	75871	75871	244003
4843	3716	102	applied	\N	\N	\N	\N	75872	75872	244004
4843	3717	103	applied	\N	\N	\N	\N	75873	75873	244005
4843	3720	104	applied	\N	\N	\N	\N	75874	75874	244006
4843	3721	105	applied	\N	\N	\N	\N	75875	75875	244007
4843	3722	106	applied	\N	\N	\N	\N	75876	75876	244008
4843	3723	107	applied	\N	\N	\N	\N	75877	75877	244009
4843	3724	108	applied	\N	\N	\N	\N	75878	75878	244010
4843	3725	109	applied	\N	\N	\N	\N	75879	75879	244011
4843	3726	110	applied	\N	\N	\N	\N	75880	75880	244012
4843	3727	111	applied	\N	\N	\N	\N	75881	75881	244013
4843	3728	112	applied	\N	\N	\N	\N	75882	75882	244014
4843	3729	113	applied	\N	\N	\N	\N	75883	75883	244015
4843	3730	114	applied	\N	\N	\N	\N	75884	75884	244016
4843	3732	116	applied	\N	\N	\N	\N	75886	75886	244018
4843	3733	117	applied	\N	\N	\N	\N	75887	75887	244019
4843	3734	118	applied	\N	\N	\N	\N	75888	75888	244020
4843	3735	119	applied	\N	\N	\N	\N	75889	75889	244021
4843	3736	120	applied	\N	\N	\N	\N	75890	75890	244022
4843	3737	121	applied	\N	\N	\N	\N	75891	75891	244023
4843	3738	122	applied	\N	\N	\N	\N	75892	75892	244024
4843	3739	123	applied	\N	\N	\N	\N	75893	75893	244025
4843	3740	124	applied	\N	\N	\N	\N	75894	75894	244026
4843	3741	125	applied	\N	\N	\N	\N	75895	75895	244027
4846	3996	0	applied	\N	\N	\N	\N	75898	75898	244030
4847	3997	0	applied	\N	\N	\N	\N	75899	75899	244031
4852	4003	1	applied	\N	\N	\N	\N	75906	75906	244038
4858	4004	0	applied	\N	\N	\N	\N	75913	75913	244045
4860	3955	1	applied	\N	\N	1000000000	\N	75916	75916	244048
4860	3956	2	applied	\N	\N	1000000000	\N	75917	75917	244049
4860	3957	3	applied	\N	\N	1000000000	\N	75918	75918	244050
4860	3958	4	applied	\N	\N	1000000000	\N	75919	75919	244051
4860	3959	5	applied	\N	\N	1000000000	\N	75920	75920	244052
4860	3962	6	applied	\N	\N	\N	\N	75921	75921	244053
4860	4000	7	applied	\N	\N	1000000000	\N	75922	75922	244054
4860	4002	8	applied	\N	\N	1000000000	\N	75923	75923	244055
4860	3977	9	applied	\N	\N	1000000000	\N	75924	75924	244056
4860	3880	10	applied	\N	\N	\N	\N	75925	75925	244057
4860	3881	11	applied	\N	\N	\N	\N	75926	75926	244058
4860	3882	12	applied	\N	\N	\N	\N	75927	75927	244059
4860	3883	13	applied	\N	\N	\N	\N	75928	75928	244060
4860	3884	14	applied	\N	\N	\N	\N	75929	75929	244061
4860	3885	15	applied	\N	\N	\N	\N	75930	75930	244062
4860	3906	16	applied	\N	\N	\N	\N	75931	75931	244063
4843	3501	30	applied	\N	\N	\N	\N	75801	75801	243933
4843	3502	31	applied	\N	\N	\N	\N	75802	75802	243934
4860	3890	21	applied	\N	\N	\N	\N	75936	75936	244068
4860	3891	22	applied	\N	\N	\N	\N	75937	75937	244069
4860	3981	23	applied	\N	\N	\N	\N	75938	75938	244070
4860	3893	24	applied	\N	\N	\N	\N	75939	75939	244071
4860	3892	25	applied	\N	\N	\N	\N	75940	75940	244072
4860	3899	26	applied	\N	\N	\N	\N	75941	75941	244073
4860	3894	27	applied	\N	\N	\N	\N	75942	75942	244074
4860	3895	28	applied	\N	\N	\N	\N	75943	75943	244075
4860	3896	29	applied	\N	\N	\N	\N	75944	75944	244076
4860	3897	30	applied	\N	\N	\N	\N	75945	75945	244077
4860	3898	31	applied	\N	\N	\N	\N	75946	75946	244078
4860	3901	32	applied	\N	\N	\N	\N	75947	75947	244079
4860	3902	33	applied	\N	\N	\N	\N	75948	75948	244080
4860	3903	34	applied	\N	\N	\N	\N	75949	75949	244081
4860	3904	35	applied	\N	\N	\N	\N	75950	75950	244082
4860	3905	36	applied	\N	\N	\N	\N	75951	75951	244083
4860	3908	38	applied	\N	\N	\N	\N	75953	75953	244085
4860	3909	39	applied	\N	\N	\N	\N	75954	75954	244086
4860	3910	40	applied	\N	\N	\N	\N	75955	75955	244087
4860	3911	41	applied	\N	\N	\N	\N	75956	75956	244088
4860	3912	42	applied	\N	\N	\N	\N	75957	75957	244089
4860	3913	43	applied	\N	\N	\N	\N	75958	75958	244090
4860	3914	44	applied	\N	\N	\N	\N	75959	75959	244091
4860	3915	45	applied	\N	\N	\N	\N	75960	75960	244092
4860	3916	46	applied	\N	\N	\N	\N	75961	75961	244093
4860	3917	47	applied	\N	\N	\N	\N	75962	75962	244094
4860	3918	48	applied	\N	\N	\N	\N	75963	75963	244095
4860	3919	49	applied	\N	\N	\N	\N	75964	75964	244096
4860	3920	50	applied	\N	\N	\N	\N	75965	75965	244097
4860	3922	51	applied	\N	\N	\N	\N	75966	75966	244098
4860	3923	52	applied	\N	\N	\N	\N	75967	75967	244099
4860	3924	53	applied	\N	\N	\N	\N	75968	75968	244100
4860	3926	55	applied	\N	\N	\N	\N	75970	75970	244102
4860	3927	56	applied	\N	\N	\N	\N	75971	75971	244103
4860	3928	57	applied	\N	\N	\N	\N	75972	75972	244104
4860	3929	58	applied	\N	\N	\N	\N	75973	75973	244105
4860	3930	59	applied	\N	\N	\N	\N	75974	75974	244106
4860	3931	60	applied	\N	\N	\N	\N	75975	75975	244107
4860	3932	61	applied	\N	\N	\N	\N	75976	75976	244108
4860	3933	62	applied	\N	\N	\N	\N	75977	75977	244109
4860	3934	63	applied	\N	\N	\N	\N	75978	75978	244110
4860	3935	64	applied	\N	\N	\N	\N	75979	75979	244111
4860	3936	65	applied	\N	\N	\N	\N	75980	75980	244112
4860	3937	66	applied	\N	\N	\N	\N	75981	75981	244113
4860	3938	67	applied	\N	\N	\N	\N	75982	75982	244114
4860	3939	68	applied	\N	\N	\N	\N	75983	75983	244115
4860	3940	69	applied	\N	\N	\N	\N	75984	75984	244116
4860	3941	70	applied	\N	\N	\N	\N	75985	75985	244117
4860	3943	72	applied	\N	\N	\N	\N	75987	75987	244119
4860	3944	73	applied	\N	\N	\N	\N	75988	75988	244120
4860	3945	74	applied	\N	\N	\N	\N	75989	75989	244121
4860	3946	75	applied	\N	\N	\N	\N	75990	75990	244122
4860	3947	76	applied	\N	\N	\N	\N	75991	75991	244123
4860	3948	77	applied	\N	\N	\N	\N	75992	75992	244124
4860	3949	78	applied	\N	\N	\N	\N	75993	75993	244125
4860	3950	79	applied	\N	\N	\N	\N	75994	75994	244126
4860	3951	80	applied	\N	\N	\N	\N	75995	75995	244127
4860	3952	81	applied	\N	\N	\N	\N	75996	75996	244128
4860	3953	82	applied	\N	\N	\N	\N	75997	75997	244129
4860	3960	83	applied	\N	\N	\N	\N	75998	75998	244130
4860	3961	84	applied	\N	\N	\N	\N	75999	75999	244131
4860	3963	85	applied	\N	\N	\N	\N	76000	76000	244132
4860	3964	86	applied	\N	\N	\N	\N	76001	76001	244133
4860	3965	87	applied	\N	\N	\N	\N	76002	76002	244134
4860	3967	89	applied	\N	\N	\N	\N	76004	76004	244136
4860	3968	90	applied	\N	\N	\N	\N	76005	76005	244137
4860	3969	91	applied	\N	\N	\N	\N	76006	76006	244138
4860	3971	92	applied	\N	\N	\N	\N	76007	76007	244139
4860	3972	93	applied	\N	\N	\N	\N	76008	76008	244140
4860	3973	94	applied	\N	\N	\N	\N	76009	76009	244141
4860	3975	95	applied	\N	\N	\N	\N	76010	76010	244142
4860	3976	96	applied	\N	\N	\N	\N	76011	76011	244143
4860	3978	97	applied	\N	\N	\N	\N	76012	76012	244144
4860	3979	98	applied	\N	\N	\N	\N	76013	76013	244145
4860	3980	99	applied	\N	\N	\N	\N	76014	76014	244146
4860	3982	100	applied	\N	\N	\N	\N	76015	76015	244147
4860	3983	101	applied	\N	\N	\N	\N	76016	76016	244148
4860	3984	102	applied	\N	\N	\N	\N	76017	76017	244149
4860	3985	103	applied	\N	\N	\N	\N	76018	76018	244150
4860	3986	104	applied	\N	\N	\N	\N	76019	76019	244151
4860	3988	106	applied	\N	\N	\N	\N	76021	76021	244153
4860	3989	107	applied	\N	\N	\N	\N	76022	76022	244154
4860	3990	108	applied	\N	\N	\N	\N	76023	76023	244155
4860	3991	109	applied	\N	\N	\N	\N	76024	76024	244156
4860	3992	110	applied	\N	\N	\N	\N	76025	76025	244157
4860	3993	111	applied	\N	\N	\N	\N	76026	76026	244158
4860	3994	112	applied	\N	\N	\N	\N	76027	76027	244159
4860	3995	113	applied	\N	\N	\N	\N	76028	76028	244160
4860	3996	114	applied	\N	\N	\N	\N	76029	76029	244161
4860	3997	115	applied	\N	\N	\N	\N	76030	76030	244162
4860	3998	117	applied	\N	\N	\N	\N	76031	76031	244163
4860	3999	118	applied	\N	\N	\N	\N	76032	76032	244164
4860	4001	119	applied	\N	\N	\N	\N	76033	76033	244165
4860	4003	120	applied	\N	\N	\N	\N	76034	76034	244166
4860	4004	121	applied	\N	\N	\N	\N	76035	76035	244167
4862	4005	0	applied	\N	\N	\N	\N	76040	76040	244172
4862	4007	2	applied	\N	\N	\N	\N	76042	76042	244174
4862	4008	3	applied	\N	\N	\N	\N	76043	76043	244175
4866	4011	0	applied	\N	\N	\N	\N	76050	76050	244182
4869	4013	0	applied	\N	\N	\N	\N	76053	76053	244185
4871	4014	0	applied	\N	\N	\N	\N	76055	76055	244187
4880	4019	0	applied	\N	\N	\N	\N	76188	76188	244320
4880	4020	1	applied	\N	\N	\N	\N	76189	76189	244321
4880	4021	2	applied	\N	\N	\N	\N	76190	76190	244322
4884	4022	0	applied	\N	\N	\N	\N	76200	76200	244332
4887	4024	0	applied	\N	\N	\N	\N	76204	76204	244336
4887	4025	1	applied	\N	\N	\N	\N	76205	76205	244337
4889	4027	0	applied	\N	\N	\N	\N	76207	76207	244339
4889	4028	1	applied	\N	\N	\N	\N	76208	76208	244340
4889	4029	2	applied	\N	\N	\N	\N	76209	76209	244341
4860	3887	18	applied	\N	\N	\N	\N	75933	75933	244065
4860	3888	19	applied	\N	\N	\N	\N	75934	75934	244066
4874	3933	94	applied	\N	\N	\N	\N	76152	76152	244284
4874	3934	95	applied	\N	\N	\N	\N	76153	76153	244285
4874	3935	96	applied	\N	\N	\N	\N	76154	76154	244286
4874	3936	97	applied	\N	\N	\N	\N	76155	76155	244287
4874	3937	98	applied	\N	\N	\N	\N	76156	76156	244288
4874	3938	99	applied	\N	\N	\N	\N	76157	76157	244289
4874	3939	100	applied	\N	\N	\N	\N	76158	76158	244290
4874	3940	101	applied	\N	\N	\N	\N	76159	76159	244291
4874	3941	102	applied	\N	\N	\N	\N	76160	76160	244292
4874	3943	104	applied	\N	\N	\N	\N	76162	76162	244294
4874	3944	105	applied	\N	\N	\N	\N	76163	76163	244295
4874	3945	106	applied	\N	\N	\N	\N	76164	76164	244296
4874	3946	107	applied	\N	\N	\N	\N	76165	76165	244297
4874	3947	108	applied	\N	\N	\N	\N	76166	76166	244298
4874	3948	109	applied	\N	\N	\N	\N	76167	76167	244299
4874	3949	110	applied	\N	\N	\N	\N	76168	76168	244300
4874	3950	111	applied	\N	\N	\N	\N	76169	76169	244301
4874	3951	115	applied	\N	\N	\N	\N	76170	76170	244302
4874	3952	116	applied	\N	\N	\N	\N	76171	76171	244303
4874	3953	117	applied	\N	\N	\N	\N	76172	76172	244304
4874	3960	118	applied	\N	\N	\N	\N	76173	76173	244305
4874	3961	119	applied	\N	\N	\N	\N	76174	76174	244306
4874	3963	120	applied	\N	\N	\N	\N	76175	76175	244307
4874	3964	121	applied	\N	\N	\N	\N	76176	76176	244308
4874	3965	122	applied	\N	\N	\N	\N	76177	76177	244309
4874	3967	124	applied	\N	\N	\N	\N	76179	76179	244311
4874	3968	125	applied	\N	\N	\N	\N	76180	76180	244312
4875	4015	0	applied	\N	\N	\N	\N	76181	76181	244313
4878	4018	0	applied	\N	\N	\N	\N	76184	76184	244316
4883	4019	0	applied	\N	\N	\N	\N	76197	76197	244329
4883	4020	1	applied	\N	\N	\N	\N	76198	76198	244330
4883	4021	2	applied	\N	\N	\N	\N	76199	76199	244331
4885	4023	0	applied	\N	\N	\N	\N	76201	76201	244333
4892	4031	0	applied	\N	\N	\N	\N	76212	76212	244344
4895	4000	0	applied	\N	\N	1000000000	\N	76215	76215	244347
4895	4002	1	applied	\N	\N	1000000000	\N	76216	76216	244348
4895	3742	2	applied	\N	\N	\N	\N	76217	76217	244349
4895	3743	3	applied	\N	\N	\N	\N	76218	76218	244350
4895	3744	4	applied	\N	\N	\N	\N	76219	76219	244351
4895	3745	5	applied	\N	\N	\N	\N	76220	76220	244352
4895	3746	6	applied	\N	\N	\N	\N	76221	76221	244353
4895	3749	8	applied	\N	\N	\N	\N	76223	76223	244355
4895	3750	9	applied	\N	\N	\N	\N	76224	76224	244356
4895	3751	10	applied	\N	\N	\N	\N	76225	76225	244357
4895	3752	11	applied	\N	\N	\N	\N	76226	76226	244358
4895	3754	12	applied	\N	\N	\N	\N	76227	76227	244359
4895	3755	13	applied	\N	\N	\N	\N	76228	76228	244360
4895	3767	14	applied	\N	\N	\N	\N	76229	76229	244361
4895	3768	15	applied	\N	\N	\N	\N	76230	76230	244362
4895	3769	16	applied	\N	\N	\N	\N	76231	76231	244363
4895	3770	17	applied	\N	\N	\N	\N	76232	76232	244364
4895	3771	18	applied	\N	\N	\N	\N	76233	76233	244365
4895	3772	19	applied	\N	\N	\N	\N	76234	76234	244366
4895	3773	20	applied	\N	\N	\N	\N	76235	76235	244367
4895	3776	21	applied	\N	\N	\N	\N	76236	76236	244368
4895	3777	22	applied	\N	\N	\N	\N	76237	76237	244369
4895	3778	23	applied	\N	\N	\N	\N	76238	76238	244370
4895	3780	25	applied	\N	\N	\N	\N	76240	76240	244372
4895	3781	26	applied	\N	\N	\N	\N	76241	76241	244373
4895	3783	27	applied	\N	\N	\N	\N	76242	76242	244374
4895	3784	28	applied	\N	\N	\N	\N	76243	76243	244375
4895	3785	29	applied	\N	\N	\N	\N	76244	76244	244376
4895	3786	30	applied	\N	\N	\N	\N	76245	76245	244377
4895	3787	31	applied	\N	\N	\N	\N	76246	76246	244378
4895	3788	32	applied	\N	\N	\N	\N	76247	76247	244379
4895	3789	33	applied	\N	\N	\N	\N	76248	76248	244380
4895	3791	34	applied	\N	\N	\N	\N	76249	76249	244381
4895	3792	35	applied	\N	\N	\N	\N	76250	76250	244382
4895	3793	36	applied	\N	\N	\N	\N	76251	76251	244383
4895	3794	37	applied	\N	\N	\N	\N	76252	76252	244384
4895	3795	38	applied	\N	\N	\N	\N	76253	76253	244385
4895	3796	39	applied	\N	\N	\N	\N	76254	76254	244386
4895	3797	40	applied	\N	\N	\N	\N	76255	76255	244387
4895	3799	42	applied	\N	\N	\N	\N	76257	76257	244389
4896	4032	0	applied	\N	\N	\N	\N	76318	76318	244450
4901	4033	0	applied	\N	\N	\N	\N	76321	76321	244453
4903	4034	0	applied	\N	\N	\N	\N	76322	76322	244454
4905	4035	0	applied	\N	\N	\N	\N	76324	76324	244456
4911	4036	0	applied	\N	\N	\N	\N	76335	76335	244467
4911	4037	1	applied	\N	\N	\N	\N	76336	76336	244468
4911	4038	2	applied	\N	\N	\N	\N	76337	76337	244469
4912	4039	0	applied	\N	\N	\N	\N	76338	76338	244470
4914	4039	0	applied	\N	\N	\N	\N	76340	76340	244472
4922	4048	0	applied	\N	\N	\N	\N	76353	76353	244485
4924	4049	0	applied	\N	\N	\N	\N	76355	76355	244487
4930	4055	0	applied	\N	\N	\N	\N	76363	76363	244495
4930	4056	1	applied	\N	\N	\N	\N	76364	76364	244496
4933	4061	1	applied	\N	\N	\N	\N	76371	76371	244503
4938	4065	0	applied	\N	\N	\N	\N	76376	76376	244508
4942	4067	0	applied	\N	\N	\N	\N	76396	76396	244528
4949	4070	0	applied	\N	\N	\N	\N	76403	76403	244535
4952	4077	0	applied	\N	\N	\N	\N	76410	76410	244542
4955	4079	0	applied	\N	\N	\N	\N	76413	76413	244545
4957	4081	0	applied	\N	\N	\N	\N	76415	76415	244547
4960	4083	0	applied	\N	\N	1000000000	\N	76418	76418	244550
4960	4084	1	applied	\N	\N	\N	\N	76419	76419	244551
4960	4085	2	applied	\N	\N	\N	\N	76420	76420	244552
4965	4089	0	applied	\N	\N	\N	\N	76428	76428	244560
4965	4090	1	applied	\N	\N	\N	\N	76429	76429	244561
4968	4092	0	applied	\N	\N	\N	\N	76433	76433	244565
4970	4093	0	applied	\N	\N	\N	\N	76436	76436	244568
4970	4094	1	applied	\N	\N	\N	\N	76437	76437	244569
4975	4098	0	applied	\N	\N	\N	\N	76443	76443	244574
4977	4099	0	applied	\N	\N	\N	\N	76447	76447	244578
4977	4100	1	applied	\N	\N	\N	\N	76448	76448	244579
4977	4101	2	applied	\N	\N	\N	\N	76449	76449	244580
4980	4102	0	applied	\N	\N	\N	\N	76457	76457	76457
4980	4104	2	applied	\N	\N	\N	\N	76459	76459	244588
4980	4105	3	applied	\N	\N	\N	\N	76460	76460	244589
4874	3931	92	applied	\N	\N	\N	\N	76150	76150	244282
4874	3932	93	applied	\N	\N	\N	\N	76151	76151	244283
4895	3804	46	applied	\N	\N	\N	\N	76261	76261	244393
4895	3806	47	applied	\N	\N	\N	\N	76262	76262	244394
4895	3807	48	applied	\N	\N	\N	\N	76263	76263	244395
4895	3808	49	applied	\N	\N	\N	\N	76264	76264	244396
4895	3809	50	applied	\N	\N	\N	\N	76265	76265	244397
4895	3810	51	applied	\N	\N	\N	\N	76266	76266	244398
4895	3811	52	applied	\N	\N	\N	\N	76267	76267	244399
4895	3812	53	applied	\N	\N	\N	\N	76268	76268	244400
4895	3813	54	applied	\N	\N	\N	\N	76269	76269	244401
4895	3814	55	applied	\N	\N	\N	\N	76270	76270	244402
4895	3815	56	applied	\N	\N	\N	\N	76271	76271	244403
4895	3816	57	applied	\N	\N	\N	\N	76272	76272	244404
4895	3818	59	applied	\N	\N	\N	\N	76274	76274	244406
4895	3819	60	applied	\N	\N	\N	\N	76275	76275	244407
4895	3820	61	applied	\N	\N	\N	\N	76276	76276	244408
4895	3821	62	applied	\N	\N	\N	\N	76277	76277	244409
4895	3823	63	applied	\N	\N	\N	\N	76278	76278	244410
4895	3824	64	applied	\N	\N	\N	\N	76279	76279	244411
4895	3825	65	applied	\N	\N	\N	\N	76280	76280	244412
4895	3826	66	applied	\N	\N	\N	\N	76281	76281	244413
4895	3827	67	applied	\N	\N	\N	\N	76282	76282	244414
4895	3828	68	applied	\N	\N	\N	\N	76283	76283	244415
4895	3829	69	applied	\N	\N	\N	\N	76284	76284	244416
4895	3830	70	applied	\N	\N	\N	\N	76285	76285	244417
4895	3831	71	applied	\N	\N	\N	\N	76286	76286	244418
4895	3832	72	applied	\N	\N	\N	\N	76287	76287	244419
4895	3833	73	applied	\N	\N	\N	\N	76288	76288	244420
4895	3834	74	applied	\N	\N	\N	\N	76289	76289	244421
4895	3836	76	applied	\N	\N	\N	\N	76291	76291	244423
4895	3837	77	applied	\N	\N	\N	\N	76292	76292	244424
4895	3838	78	applied	\N	\N	\N	\N	76293	76293	244425
4895	3839	79	applied	\N	\N	\N	\N	76294	76294	244426
4895	3840	80	applied	\N	\N	\N	\N	76295	76295	244427
4895	3841	81	applied	\N	\N	\N	\N	76296	76296	244428
4895	3842	82	applied	\N	\N	\N	\N	76297	76297	244429
4895	3843	83	applied	\N	\N	\N	\N	76298	76298	244430
4895	3845	84	applied	\N	\N	\N	\N	76299	76299	244431
4895	3852	85	applied	\N	\N	\N	\N	76300	76300	244432
4895	3853	87	applied	\N	\N	\N	\N	76301	76301	244433
4895	3854	88	applied	\N	\N	\N	\N	76302	76302	244434
4895	3855	89	applied	\N	\N	\N	\N	76303	76303	244435
4895	3856	90	applied	\N	\N	\N	\N	76304	76304	244436
4895	3857	91	applied	\N	\N	\N	\N	76305	76305	244437
4895	3858	92	applied	\N	\N	\N	\N	76306	76306	244438
4895	3860	94	applied	\N	\N	\N	\N	76308	76308	244440
4895	3862	95	applied	\N	\N	\N	\N	76309	76309	244441
4895	3863	96	applied	\N	\N	\N	\N	76310	76310	244442
4895	3864	97	applied	\N	\N	\N	\N	76311	76311	244443
4895	3865	98	applied	\N	\N	\N	\N	76312	76312	244444
4895	3866	99	applied	\N	\N	\N	\N	76313	76313	244445
4895	3867	100	applied	\N	\N	\N	\N	76314	76314	244446
4895	3868	101	applied	\N	\N	\N	\N	76315	76315	244447
4895	3869	102	applied	\N	\N	\N	\N	76316	76316	244448
4895	3870	103	applied	\N	\N	\N	\N	76317	76317	244449
4898	4032	0	applied	\N	\N	\N	\N	76319	76319	244451
4904	4034	0	applied	\N	\N	\N	\N	76323	76323	244455
4909	4036	0	applied	\N	\N	\N	\N	76329	76329	244461
4909	4037	1	applied	\N	\N	\N	\N	76330	76330	244462
4909	4038	2	applied	\N	\N	\N	\N	76331	76331	244463
4910	4037	1	applied	\N	\N	\N	\N	76333	76333	244465
4916	4044	0	applied	\N	\N	\N	\N	76345	76345	244477
4916	4045	1	applied	\N	\N	\N	\N	76346	76346	244478
4917	4044	0	applied	\N	\N	\N	\N	76347	76347	244479
4917	4045	1	applied	\N	\N	\N	\N	76348	76348	244480
4919	4046	0	applied	\N	\N	\N	\N	76350	76350	244482
4920	4046	0	applied	\N	\N	\N	\N	76351	76351	244483
4921	4047	0	applied	\N	\N	\N	\N	76352	76352	244484
4926	4050	0	applied	\N	\N	\N	\N	76357	76357	244489
4928	4051	0	applied	\N	\N	\N	\N	76359	76359	244491
4929	4052	0	applied	\N	\N	\N	\N	76360	76360	244492
4931	4055	0	applied	\N	\N	\N	\N	76365	76365	244497
4931	4056	1	applied	\N	\N	\N	\N	76366	76366	244498
4932	4057	0	applied	\N	\N	\N	\N	76367	76367	244499
4932	4058	1	applied	\N	\N	\N	\N	76368	76368	244500
4932	4059	2	applied	\N	\N	\N	\N	76369	76369	244501
4934	4062	0	applied	\N	\N	\N	\N	76372	76372	244504
4939	3954	0	applied	\N	\N	1000000000	\N	76377	76377	244509
4939	3955	1	applied	\N	\N	1000000000	\N	76378	76378	244510
4939	3956	2	applied	\N	\N	1000000000	\N	76379	76379	244511
4939	3957	3	applied	\N	\N	1000000000	\N	76380	76380	244512
4939	3958	4	applied	\N	\N	1000000000	\N	76381	76381	244513
4939	3959	5	applied	\N	\N	1000000000	\N	76382	76382	244514
4939	3962	6	applied	\N	\N	\N	\N	76383	76383	244515
4939	4000	7	applied	\N	\N	1000000000	\N	76384	76384	244516
4939	4002	8	applied	\N	\N	1000000000	\N	76385	76385	244517
4939	4040	9	applied	\N	\N	1000000000	\N	76386	76386	244518
4939	4060	10	applied	\N	\N	1000000000	\N	76387	76387	244519
4939	3977	11	applied	\N	\N	1000000000	\N	76388	76388	244520
4939	4062	12	applied	\N	\N	\N	\N	76389	76389	244521
4939	3981	13	applied	\N	\N	\N	\N	76390	76390	244522
4939	3892	14	applied	\N	\N	\N	\N	76391	76391	244523
4939	3899	15	applied	\N	\N	\N	\N	76392	76392	244524
4943	4068	0	applied	\N	\N	\N	\N	76397	76397	244529
4945	4069	0	applied	\N	\N	\N	\N	76399	76399	244531
4951	4076	0	applied	\N	\N	\N	\N	76409	76409	244541
4956	4080	0	applied	\N	\N	\N	\N	76414	76414	244546
4959	4082	0	applied	\N	\N	\N	\N	76417	76417	244549
4962	4086	0	applied	\N	\N	\N	\N	76423	76423	244555
4962	4087	1	applied	\N	\N	\N	\N	76424	76424	244556
4969	4093	0	applied	\N	\N	\N	\N	76434	76434	244566
4969	4094	1	applied	\N	\N	\N	\N	76435	76435	244567
4972	4095	0	applied	\N	\N	\N	\N	76439	76439	244571
4978	4099	0	applied	\N	\N	\N	\N	76450	76450	244581
4978	4100	1	applied	\N	\N	\N	\N	76451	76451	244582
4978	4101	2	applied	\N	\N	\N	\N	76452	76452	244583
4981	4102	0	applied	\N	\N	\N	\N	76461	76461	76461
4981	4103	1	applied	\N	\N	\N	\N	76462	76462	244590
4981	4104	2	applied	\N	\N	\N	\N	76463	76463	244591
4895	3801	44	applied	\N	\N	\N	\N	76259	76259	244391
4895	3803	45	applied	\N	\N	\N	\N	76260	76260	244392
4940	4066	0	applied	\N	\N	\N	\N	76394	76394	244526
4941	4067	0	applied	\N	\N	\N	\N	76395	76395	244527
4944	4068	0	applied	\N	\N	\N	\N	76398	76398	244530
4946	4069	0	applied	\N	\N	\N	\N	76400	76400	244532
4948	4070	0	applied	\N	\N	\N	\N	76402	76402	244534
4950	4075	4	applied	\N	\N	\N	\N	76408	76408	244540
4953	4078	0	applied	\N	\N	\N	\N	76411	76411	244543
4954	4079	0	applied	\N	\N	\N	\N	76412	76412	244544
4958	4082	0	applied	\N	\N	\N	\N	76416	76416	244548
4961	4086	0	applied	\N	\N	\N	\N	76421	76421	244553
4961	4087	1	applied	\N	\N	\N	\N	76422	76422	244554
4963	4086	0	applied	\N	\N	\N	\N	76425	76425	244557
4963	4087	1	applied	\N	\N	\N	\N	76426	76426	244558
4964	4088	0	applied	\N	\N	\N	\N	76427	76427	244559
4966	4089	0	applied	\N	\N	\N	\N	76430	76430	244562
4966	4090	1	applied	\N	\N	\N	\N	76431	76431	244563
4967	4091	0	applied	\N	\N	\N	\N	76432	76432	244564
4971	4095	0	applied	\N	\N	\N	\N	76438	76438	244570
4973	4095	0	applied	\N	\N	\N	\N	76440	76440	244572
4974	4096	0	applied	\N	\N	\N	\N	76441	76441	76441
4974	4097	1	applied	\N	\N	\N	\N	76442	76442	244573
4976	4100	1	applied	\N	\N	\N	\N	76445	76445	244576
4976	4101	2	applied	\N	\N	\N	\N	76446	76446	244577
4979	4102	0	applied	\N	\N	\N	\N	76453	76453	76453
4979	4103	1	applied	\N	\N	\N	\N	76454	76454	244584
4979	4104	2	applied	\N	\N	\N	\N	76455	76455	244585
4979	4105	3	applied	\N	\N	\N	\N	76456	76456	244586
4982	4106	0	applied	\N	\N	\N	\N	76465	76465	244593
4983	4106	0	applied	\N	\N	\N	\N	76466	76466	244594
4984	4107	0	applied	\N	\N	\N	\N	76467	76467	244595
4984	4108	1	applied	\N	\N	\N	\N	76468	76468	244596
4984	4109	2	applied	\N	\N	\N	\N	76469	76469	244597
4985	4107	0	applied	\N	\N	\N	\N	76470	76470	244598
4985	4108	1	applied	\N	\N	\N	\N	76471	76471	244599
4985	4109	2	applied	\N	\N	\N	\N	76472	76472	244600
4986	4107	0	applied	\N	\N	\N	\N	76473	76473	244601
4986	4108	1	applied	\N	\N	\N	\N	76474	76474	244602
4987	4107	0	applied	\N	\N	\N	\N	76476	76476	244604
4987	4108	1	applied	\N	\N	\N	\N	76477	76477	244605
4987	4109	2	applied	\N	\N	\N	\N	76478	76478	244606
4988	4110	0	applied	\N	\N	\N	\N	76479	76479	244607
4989	4111	0	applied	\N	\N	\N	\N	76480	76480	244608
4989	4112	1	applied	\N	\N	\N	\N	76481	76481	244609
4990	4113	0	applied	\N	\N	\N	\N	76482	76482	244610
4991	4113	0	applied	\N	\N	\N	\N	76483	76483	244611
4992	4113	0	applied	\N	\N	\N	\N	76484	76484	244612
4993	4114	0	applied	\N	\N	\N	\N	76485	76485	244613
4994	4115	0	applied	\N	\N	1000000000	\N	76486	76486	244614
4994	4116	1	applied	\N	\N	\N	\N	76487	76487	244615
4994	4117	2	applied	\N	\N	\N	\N	76488	76488	244616
4994	4118	3	applied	\N	\N	\N	\N	76489	76489	244617
4995	4116	1	applied	\N	\N	\N	\N	76491	76491	244619
4995	4117	2	applied	\N	\N	\N	\N	76492	76492	244620
4995	4118	3	applied	\N	\N	\N	\N	76493	76493	244621
4996	4119	0	applied	\N	\N	\N	\N	76494	76494	244622
4997	4120	0	applied	\N	\N	\N	\N	76495	76495	76495
4997	4121	1	applied	\N	\N	\N	\N	76496	76496	244623
4997	4122	2	applied	\N	\N	\N	\N	76497	76497	244624
4998	4123	0	applied	\N	\N	\N	\N	76498	76498	244625
4999	4123	0	applied	\N	\N	\N	\N	76499	76499	244626
5000	4124	0	applied	\N	\N	\N	\N	76500	76500	244627
5001	4124	0	applied	\N	\N	\N	\N	76501	76501	244628
5002	4125	0	applied	\N	\N	\N	\N	76502	76502	244629
5003	4125	0	applied	\N	\N	\N	\N	76503	76503	244630
5004	4125	0	applied	\N	\N	\N	\N	76504	76504	244631
5005	4125	0	applied	\N	\N	\N	\N	76505	76505	244632
5006	4125	0	applied	\N	\N	\N	\N	76506	76506	244633
5007	4126	0	applied	\N	\N	1000000000	\N	76507	76507	244634
5007	4127	1	applied	\N	\N	\N	\N	76508	76508	244635
5008	4127	1	applied	\N	\N	\N	\N	76510	76510	244637
5009	4128	0	applied	\N	\N	\N	\N	76511	76511	244638
5010	4129	0	applied	\N	\N	\N	\N	76512	76512	244639
5011	4130	0	applied	\N	\N	\N	\N	76513	76513	244640
5012	4130	0	applied	\N	\N	\N	\N	76514	76514	244641
5013	4131	0	applied	\N	\N	\N	\N	76515	76515	244642
5014	4132	0	applied	\N	\N	\N	\N	76516	76516	244643
5015	4133	0	applied	\N	\N	\N	\N	76517	76517	244644
5016	4134	0	applied	\N	\N	\N	\N	76518	76518	244645
5017	4135	0	applied	\N	\N	\N	\N	76519	76519	244646
5017	4136	1	applied	\N	\N	\N	\N	76520	76520	244647
5018	4137	0	applied	\N	\N	\N	\N	76521	76521	244648
5019	4138	0	applied	\N	\N	\N	\N	76522	76522	244649
5019	4139	1	applied	\N	\N	\N	\N	76523	76523	244650
5020	4140	0	applied	\N	\N	\N	\N	76524	76524	244651
5021	4141	0	applied	\N	\N	\N	\N	76525	76525	244652
5021	4142	1	applied	\N	\N	\N	\N	76526	76526	244653
5022	4143	0	applied	\N	\N	1000000000	\N	76527	76527	244654
5022	4144	1	applied	\N	\N	\N	\N	76528	76528	244655
5023	4144	1	applied	\N	\N	\N	\N	76530	76530	244657
5024	4145	0	applied	\N	\N	\N	\N	76531	76531	244658
5025	4145	0	applied	\N	\N	\N	\N	76532	76532	244659
5026	4145	0	applied	\N	\N	\N	\N	76533	76533	244660
5027	4145	0	applied	\N	\N	\N	\N	76534	76534	244661
5029	4146	0	applied	\N	\N	\N	\N	76535	76535	244662
5030	4146	0	applied	\N	\N	\N	\N	76536	76536	244663
5031	4147	0	applied	\N	\N	\N	\N	76537	76537	244664
5032	4147	0	applied	\N	\N	\N	\N	76538	76538	244665
5033	4148	0	applied	\N	\N	\N	\N	76539	76539	244666
5034	4148	0	applied	\N	\N	\N	\N	76540	76540	244667
5035	4148	0	applied	\N	\N	\N	\N	76541	76541	244668
5036	4148	0	applied	\N	\N	\N	\N	76542	76542	244669
5037	4149	0	applied	\N	\N	\N	\N	76543	76543	244670
5037	4150	1	applied	\N	\N	\N	\N	76544	76544	244671
5038	4149	0	applied	\N	\N	\N	\N	76545	76545	244672
5038	4150	1	applied	\N	\N	\N	\N	76546	76546	244673
5039	4151	0	applied	\N	\N	\N	\N	76547	76547	244674
5039	4152	1	applied	\N	\N	\N	\N	76548	76548	244675
5040	4152	1	applied	\N	\N	\N	\N	76550	76550	244677
5041	4153	0	applied	\N	\N	\N	\N	76551	76551	244678
4929	4054	2	applied	\N	\N	\N	\N	76362	76362	244494
4937	4065	0	applied	\N	\N	\N	\N	76375	76375	244507
5044	4152	1	applied	\N	\N	\N	\N	76555	76555	244682
5044	4153	2	applied	\N	\N	\N	\N	76556	76556	244683
5046	4153	0	applied	\N	\N	\N	\N	76557	76557	244684
5046	4154	1	applied	\N	\N	\N	\N	76558	76558	244685
5047	4155	0	applied	\N	\N	\N	\N	76559	76559	244686
5048	4156	0	applied	\N	\N	\N	\N	76560	76560	244687
5048	4157	1	applied	\N	\N	\N	\N	76561	76561	244688
5048	4158	2	applied	\N	\N	\N	\N	76562	76562	244689
5048	4159	3	applied	\N	\N	\N	\N	76563	76563	244690
5049	4160	0	applied	\N	\N	\N	\N	76564	76564	244691
5050	4161	0	applied	\N	\N	\N	\N	76565	76565	244692
5051	4162	0	applied	\N	\N	\N	\N	76566	76566	244693
5051	4163	1	applied	\N	\N	\N	\N	76567	76567	244694
5053	4166	0	applied	\N	\N	\N	\N	76570	76570	244697
5060	4168	0	applied	\N	\N	\N	\N	76576	76576	244703
5063	4170	0	applied	\N	\N	\N	\N	76579	76579	244706
5067	4173	0	applied	\N	\N	\N	\N	76584	76584	244711
5070	4171	0	applied	\N	\N	\N	\N	76587	76587	244714
5070	4172	1	applied	\N	\N	\N	\N	76588	76588	244715
5070	4173	2	applied	\N	\N	\N	\N	76589	76589	244716
5071	4174	0	applied	\N	\N	\N	\N	76590	76590	244717
5074	4176	0	applied	\N	\N	\N	\N	76593	76593	244720
5078	4184	0	applied	\N	\N	\N	\N	76601	76601	244728
5078	4185	1	applied	\N	\N	\N	\N	76602	76602	244729
5091	4191	0	applied	\N	\N	\N	\N	76623	76623	244750
5091	4192	1	applied	\N	\N	\N	\N	76624	76624	244751
5092	4193	0	applied	\N	\N	\N	\N	76625	76625	244752
5093	4194	0	applied	\N	\N	\N	\N	76626	76626	244753
5096	4197	0	applied	\N	\N	\N	\N	76631	76631	244758
5100	4203	0	applied	\N	\N	\N	\N	76637	76637	244764
5100	4204	1	applied	\N	\N	\N	\N	76638	76638	244765
5104	4206	0	applied	\N	\N	\N	\N	76642	76642	244769
5108	4208	0	applied	\N	\N	\N	\N	76646	76646	244773
5115	4210	0	applied	\N	\N	\N	\N	76653	76653	244780
5115	4211	1	applied	\N	\N	\N	\N	76654	76654	244781
5120	4211	0	applied	\N	\N	\N	\N	76659	76659	244786
5120	4212	1	applied	\N	\N	\N	\N	76660	76660	244787
5127	4218	0	applied	\N	\N	\N	\N	76674	76674	244801
5127	4219	1	applied	\N	\N	\N	\N	76675	76675	244802
5130	4218	0	applied	\N	\N	\N	\N	76680	76680	244807
5130	4219	1	applied	\N	\N	\N	\N	76681	76681	244808
5132	4220	0	applied	\N	\N	\N	\N	76683	76683	244810
5132	4221	1	applied	\N	\N	\N	\N	76684	76684	244811
5132	4222	2	applied	\N	\N	\N	\N	76685	76685	244812
5138	4228	1	applied	\N	\N	\N	\N	76700	76700	244827
5144	4233	0	applied	\N	\N	\N	\N	76711	76711	244838
5145	4234	0	applied	\N	\N	\N	\N	76712	76712	244839
5145	4235	1	applied	\N	\N	\N	\N	76713	76713	244840
5147	4237	0	applied	\N	\N	\N	\N	76715	76715	244842
5149	4238	0	applied	\N	\N	\N	\N	76717	76717	244844
5149	4239	1	applied	\N	\N	\N	\N	76718	76718	244845
5154	4242	0	applied	\N	\N	\N	\N	76724	76724	244851
5155	4243	0	applied	\N	\N	\N	\N	76725	76725	244852
5168	4254	0	applied	\N	\N	\N	\N	76740	76740	244867
5180	4259	0	applied	\N	\N	\N	\N	76758	76758	244885
5180	4260	1	applied	\N	\N	\N	\N	76759	76759	244886
5180	4261	2	applied	\N	\N	\N	\N	76760	76760	244887
5180	4262	3	applied	\N	\N	\N	\N	76761	76761	244888
5180	4263	4	applied	\N	\N	\N	\N	76762	76762	244889
5182	4265	0	applied	\N	\N	\N	\N	76764	76764	244891
5185	4269	0	applied	\N	\N	\N	\N	76768	76768	244895
5187	4270	0	applied	\N	\N	\N	\N	76770	76770	244897
5193	4277	0	applied	\N	\N	\N	\N	76778	76778	244905
5201	4283	0	applied	\N	\N	\N	\N	76788	76788	244915
5201	4284	1	applied	\N	\N	\N	\N	76789	76789	244916
5207	4287	0	applied	\N	\N	\N	\N	76795	76795	244922
5217	4295	0	applied	\N	\N	\N	\N	76803	76803	244930
5224	4299	0	applied	\N	\N	\N	\N	76814	76814	244941
5229	4302	0	applied	\N	\N	\N	\N	76819	76819	244946
5229	4303	1	applied	\N	\N	\N	\N	76820	76820	244947
5231	4302	0	applied	\N	\N	\N	\N	76823	76823	244950
5231	4303	1	applied	\N	\N	\N	\N	76824	76824	244951
5238	4304	0	applied	\N	\N	\N	\N	76828	76828	244955
5238	4305	1	applied	\N	\N	\N	\N	76829	76829	244956
5238	4306	2	applied	\N	\N	\N	\N	76830	76830	244957
5244	4307	0	applied	\N	\N	\N	\N	76837	76837	244964
5256	4313	0	applied	\N	\N	\N	\N	76846	76846	244973
5256	4314	1	applied	\N	\N	\N	\N	76847	76847	244974
5260	4315	0	applied	\N	\N	\N	\N	76848	76848	244975
5263	4319	1	applied	\N	\N	\N	\N	76853	76853	244980
5274	4332	0	applied	\N	\N	\N	\N	76871	76871	244998
5277	4334	0	applied	\N	\N	\N	\N	76875	76875	245002
5277	4335	1	applied	\N	\N	\N	\N	76876	76876	245003
5282	4336	0	applied	\N	\N	\N	\N	76883	76883	245010
5283	4336	0	applied	\N	\N	\N	\N	76884	76884	245011
5293	4343	0	applied	\N	\N	\N	\N	76896	76896	245023
5295	4345	0	applied	\N	\N	\N	\N	76898	76898	245025
5298	4346	0	applied	\N	\N	\N	\N	76901	76901	245028
5305	4352	0	applied	\N	\N	\N	\N	76910	76910	245037
5305	4353	1	applied	\N	\N	\N	\N	76911	76911	245038
5308	4356	0	applied	\N	\N	\N	\N	76915	76915	245042
5317	4362	0	applied	\N	\N	\N	\N	76925	76925	245052
5319	4362	0	applied	\N	\N	\N	\N	76927	76927	245054
5320	4362	0	applied	\N	\N	\N	\N	76928	76928	245055
5330	4365	0	applied	\N	\N	\N	\N	77042	77042	245169
5334	4367	0	applied	\N	\N	\N	\N	77046	77046	245173
5336	4367	0	applied	\N	\N	\N	\N	77048	77048	245175
5341	4369	0	applied	\N	\N	\N	\N	77053	77053	245180
5343	4369	0	applied	\N	\N	\N	\N	77055	77055	245182
5343	4370	1	applied	\N	\N	\N	\N	77056	77056	245183
5343	4371	2	applied	\N	\N	\N	\N	77057	77057	245184
5343	4372	3	applied	\N	\N	\N	\N	77058	77058	245185
5348	4376	0	applied	\N	\N	\N	\N	77065	77065	245192
5351	4377	0	applied	\N	\N	\N	\N	77067	77067	245194
5353	4379	0	applied	\N	\N	\N	\N	77069	77069	245196
5358	4383	0	applied	\N	\N	\N	\N	77075	77075	245202
5363	4388	0	applied	\N	\N	\N	\N	77103	77103	245230
5366	4391	0	applied	\N	\N	\N	\N	77107	77107	245234
5380	4397	0	applied	\N	\N	\N	\N	77114	77114	245241
5043	4153	0	applied	\N	\N	\N	\N	76553	76553	244680
5044	4151	0	applied	\N	\N	\N	\N	76554	76554	244681
5066	4171	0	applied	\N	\N	\N	\N	76582	76582	244709
5066	4172	1	applied	\N	\N	\N	\N	76583	76583	244710
5069	4173	0	applied	\N	\N	\N	\N	76586	76586	244713
5076	4181	0	applied	\N	\N	\N	\N	76598	76598	244725
5076	4182	1	applied	\N	\N	\N	\N	76599	76599	244726
5081	4185	0	applied	\N	\N	\N	\N	76607	76607	244734
5082	4185	0	applied	\N	\N	\N	\N	76608	76608	244735
5084	4186	0	applied	\N	\N	\N	\N	76610	76610	244737
5084	4187	1	applied	\N	\N	\N	\N	76611	76611	244738
5087	4188	0	applied	\N	\N	\N	\N	76616	76616	244743
5087	4189	1	applied	\N	\N	\N	\N	76617	76617	244744
5090	4192	1	applied	\N	\N	\N	\N	76622	76622	244749
5095	4197	0	applied	\N	\N	\N	\N	76629	76629	244756
5095	4198	1	applied	\N	\N	\N	\N	76630	76630	244757
5098	4199	0	applied	\N	\N	\N	\N	76633	76633	244760
5098	4200	1	applied	\N	\N	\N	\N	76634	76634	244761
5098	4201	2	applied	\N	\N	\N	\N	76635	76635	244762
5103	4205	0	applied	\N	\N	\N	\N	76641	76641	244768
5109	4209	0	applied	\N	\N	\N	\N	76647	76647	244774
5112	4210	0	applied	\N	\N	\N	\N	76650	76650	244777
5117	4211	0	applied	\N	\N	\N	\N	76656	76656	244783
5121	4211	0	applied	\N	\N	\N	\N	76661	76661	244788
5121	4212	1	applied	\N	\N	\N	\N	76662	76662	244789
5123	4213	0	applied	\N	\N	\N	\N	76665	76665	244792
5123	4214	1	applied	\N	\N	\N	\N	76666	76666	244793
5126	4218	0	applied	\N	\N	\N	\N	76672	76672	244799
5126	4219	1	applied	\N	\N	\N	\N	76673	76673	244800
5135	4225	0	applied	\N	\N	\N	\N	76694	76694	244821
5135	4226	1	applied	\N	\N	\N	\N	76695	76695	244822
5139	4227	0	applied	\N	\N	1000000000	\N	76701	76701	244828
5139	4228	1	applied	\N	\N	\N	\N	76702	76702	244829
5146	4236	0	applied	\N	\N	\N	\N	76714	76714	244841
5148	4237	0	applied	\N	\N	\N	\N	76716	76716	244843
5151	4240	0	applied	\N	\N	\N	\N	76721	76721	244848
5157	4245	0	applied	\N	\N	\N	\N	76727	76727	244854
5157	4246	1	applied	\N	\N	\N	\N	76728	76728	244855
5158	4247	0	applied	\N	\N	\N	\N	76729	76729	244856
5162	4248	0	applied	\N	\N	\N	\N	76733	76733	244860
5165	4250	0	applied	\N	\N	\N	\N	76736	76736	244863
5169	4254	0	applied	\N	\N	\N	\N	76741	76741	244868
5175	4259	0	applied	\N	\N	\N	\N	76746	76746	244873
5175	4260	1	applied	\N	\N	\N	\N	76747	76747	244874
5183	4266	0	applied	\N	\N	\N	\N	76765	76765	244892
5188	4271	0	applied	\N	\N	\N	\N	76771	76771	244898
5188	4272	1	applied	\N	\N	\N	\N	76772	76772	244899
5191	4276	0	applied	\N	\N	\N	\N	76776	76776	244903
5196	4279	0	applied	\N	\N	\N	\N	76781	76781	244908
5198	4280	0	applied	\N	\N	\N	\N	76783	76783	244910
5203	4285	0	applied	\N	\N	\N	\N	76792	76792	244919
5208	4288	0	applied	\N	\N	\N	\N	76796	76796	244923
5215	4291	0	applied	\N	\N	1000000000	\N	76799	76799	244926
5215	4292	1	applied	\N	\N	\N	\N	76800	76800	244927
5215	4293	2	applied	\N	\N	\N	\N	76801	76801	244928
5218	4296	0	applied	\N	\N	\N	\N	76804	76804	244931
5218	4297	1	applied	\N	\N	\N	\N	76805	76805	244932
5222	4298	0	applied	\N	\N	\N	\N	76812	76812	244939
5225	4299	0	applied	\N	\N	\N	\N	76815	76815	244942
5247	4309	0	applied	\N	\N	\N	\N	76840	76840	244967
5261	4315	0	applied	\N	\N	\N	\N	76849	76849	244976
5264	4321	1	applied	\N	\N	\N	\N	76855	76855	244982
5266	4322	0	applied	\N	\N	\N	\N	76857	76857	244984
5269	4325	0	applied	\N	\N	\N	\N	76862	76862	244989
5269	4326	1	applied	\N	\N	\N	\N	76863	76863	244990
5271	4327	0	applied	\N	\N	\N	\N	76866	76866	244993
5278	4334	0	applied	\N	\N	\N	\N	76877	76877	245004
5278	4335	1	applied	\N	\N	\N	\N	76878	76878	245005
5286	4339	0	applied	\N	\N	\N	\N	76887	76887	245014
5289	4342	0	applied	\N	\N	\N	\N	76892	76892	245019
5291	4343	0	applied	\N	\N	\N	\N	76894	76894	245021
5296	4346	0	applied	\N	\N	\N	\N	76899	76899	245026
5301	4349	0	applied	\N	\N	\N	\N	76906	76906	245033
5303	4350	0	applied	\N	\N	\N	\N	76908	76908	245035
5306	4354	0	applied	\N	\N	\N	\N	76912	76912	245039
5311	4360	0	applied	\N	\N	\N	\N	76919	76919	245046
5313	4360	0	applied	\N	\N	\N	\N	76921	76921	245048
5322	4363	0	applied	\N	\N	\N	\N	76930	76930	245057
5335	4367	0	applied	\N	\N	\N	\N	77047	77047	245174
5337	4367	0	applied	\N	\N	\N	\N	77049	77049	245176
5344	4371	0	applied	\N	\N	\N	\N	77059	77059	245186
5344	4372	1	applied	\N	\N	\N	\N	77060	77060	245187
5344	4373	2	applied	\N	\N	\N	\N	77061	77061	245188
5346	4374	0	applied	\N	\N	\N	\N	77063	77063	245190
5361	4364	0	applied	\N	\N	\N	\N	77079	77079	245206
5361	4365	1	applied	\N	\N	\N	\N	77080	77080	245207
5361	4366	2	applied	\N	\N	\N	\N	77081	77081	245208
5361	4367	3	applied	\N	\N	\N	\N	77082	77082	245209
5361	4368	4	applied	\N	\N	\N	\N	77083	77083	245210
5361	4369	5	applied	\N	\N	\N	\N	77084	77084	245211
5361	4370	6	applied	\N	\N	\N	\N	77085	77085	245212
5361	4371	7	applied	\N	\N	\N	\N	77086	77086	245213
5361	4372	8	applied	\N	\N	\N	\N	77087	77087	245214
5361	4373	9	applied	\N	\N	\N	\N	77088	77088	245215
5361	4374	10	applied	\N	\N	\N	\N	77089	77089	245216
5361	4376	12	applied	\N	\N	\N	\N	77091	77091	245218
5416	4400	0	applied	\N	\N	\N	\N	77131	77131	245258
5449	4403	0	applied	\N	\N	1000000000	\N	77142	77142	245266
5459	4411	0	applied	\N	\N	\N	\N	77197	77197	245321
5539	4414	0	applied	\N	\N	\N	\N	77258	77258	245382
5596	4404	0	applied	\N	\N	1000000000	\N	77262	77262	245386
5596	4414	1	applied	\N	\N	\N	\N	77263	77263	245387
5596	4405	2	applied	\N	\N	1000000000	\N	77264	77264	245388
5596	4406	3	applied	\N	\N	1000000000	\N	77265	77265	245389
5596	4407	4	applied	\N	\N	1000000000	\N	77266	77266	245390
5596	4408	5	applied	\N	\N	1000000000	\N	77267	77267	245391
5596	4409	6	applied	\N	\N	1000000000	\N	77268	77268	245392
5596	4410	7	applied	\N	\N	1000000000	\N	77269	77269	245393
5596	4412	8	applied	\N	\N	\N	\N	77270	77270	245394
5596	4413	9	applied	\N	\N	\N	\N	77271	77271	245395
5059	4168	0	applied	\N	\N	\N	\N	76575	76575	244702
5062	4170	0	applied	\N	\N	\N	\N	76578	76578	244705
5072	4175	0	applied	\N	\N	\N	\N	76591	76591	244718
5079	4184	0	applied	\N	\N	\N	\N	76603	76603	244730
5079	4185	1	applied	\N	\N	\N	\N	76604	76604	244731
5083	4184	0	applied	\N	\N	\N	\N	76609	76609	244736
5085	4188	0	applied	\N	\N	\N	\N	76612	76612	244739
5085	4189	1	applied	\N	\N	\N	\N	76613	76613	244740
5099	4202	0	applied	\N	\N	\N	\N	76636	76636	244763
5105	4206	0	applied	\N	\N	\N	\N	76643	76643	244770
5106	4206	0	applied	\N	\N	\N	\N	76644	76644	244771
5107	4207	0	applied	\N	\N	\N	\N	76645	76645	244772
5111	4209	0	applied	\N	\N	\N	\N	76649	76649	244776
5113	4210	0	applied	\N	\N	\N	\N	76651	76651	244778
5114	4210	0	applied	\N	\N	\N	\N	76652	76652	244779
5119	4211	0	applied	\N	\N	\N	\N	76657	76657	244784
5119	4212	1	applied	\N	\N	\N	\N	76658	76658	244785
5124	4215	0	applied	\N	\N	\N	\N	76667	76667	244794
5124	4216	1	applied	\N	\N	\N	\N	76668	76668	244795
5124	4217	2	applied	\N	\N	\N	\N	76669	76669	244796
5125	4218	0	applied	\N	\N	\N	\N	76670	76670	244797
5125	4219	1	applied	\N	\N	\N	\N	76671	76671	244798
5133	4221	0	applied	\N	\N	\N	\N	76686	76686	244813
5133	4222	1	applied	\N	\N	\N	\N	76687	76687	244814
5133	4223	2	applied	\N	\N	\N	\N	76688	76688	244815
5134	4221	0	applied	\N	\N	\N	\N	76690	76690	244817
5134	4222	1	applied	\N	\N	\N	\N	76691	76691	244818
5134	4223	2	applied	\N	\N	\N	\N	76692	76692	244819
5134	4224	3	applied	\N	\N	\N	\N	76693	76693	244820
5137	4227	0	applied	\N	\N	1000000000	\N	76697	76697	244824
5137	4228	1	applied	\N	\N	\N	\N	76698	76698	244825
5141	4227	0	applied	\N	\N	1000000000	\N	76705	76705	244832
5141	4228	1	applied	\N	\N	\N	\N	76706	76706	244833
5142	4229	0	applied	\N	\N	\N	\N	76707	76707	244834
5142	4230	1	applied	\N	\N	\N	\N	76708	76708	244835
5143	4231	0	applied	\N	\N	\N	\N	76709	76709	244836
5143	4232	1	applied	\N	\N	\N	\N	76710	76710	244837
5153	4241	0	applied	\N	\N	\N	\N	76723	76723	244850
5159	4248	0	applied	\N	\N	\N	\N	76730	76730	244857
5164	4249	0	applied	\N	\N	\N	\N	76735	76735	244862
5166	4251	0	applied	\N	\N	\N	\N	76737	76737	244864
5179	4259	0	applied	\N	\N	\N	\N	76753	76753	244880
5179	4260	1	applied	\N	\N	\N	\N	76754	76754	244881
5179	4261	2	applied	\N	\N	\N	\N	76755	76755	244882
5179	4262	3	applied	\N	\N	\N	\N	76756	76756	244883
5179	4263	4	applied	\N	\N	\N	\N	76757	76757	244884
5181	4264	0	applied	\N	\N	\N	\N	76763	76763	244890
5184	4268	0	applied	\N	\N	\N	\N	76767	76767	244894
5190	4274	0	applied	\N	\N	\N	\N	76774	76774	244901
5190	4275	1	applied	\N	\N	\N	\N	76775	76775	244902
5200	4283	0	applied	\N	\N	\N	\N	76786	76786	244913
5200	4284	1	applied	\N	\N	\N	\N	76787	76787	244914
5202	4283	0	applied	\N	\N	\N	\N	76790	76790	244917
5202	4284	1	applied	\N	\N	\N	\N	76791	76791	244918
5205	4286	0	applied	\N	\N	\N	\N	76794	76794	244921
5216	4294	0	applied	\N	\N	\N	\N	76802	76802	244929
5220	4296	0	applied	\N	\N	\N	\N	76808	76808	244935
5226	4299	0	applied	\N	\N	\N	\N	76816	76816	244943
5228	4301	0	applied	\N	\N	\N	\N	76818	76818	244945
5237	4304	0	applied	\N	\N	\N	\N	76825	76825	244952
5237	4305	1	applied	\N	\N	\N	\N	76826	76826	244953
5237	4306	2	applied	\N	\N	\N	\N	76827	76827	244954
5239	4304	0	applied	\N	\N	\N	\N	76831	76831	244958
5239	4305	1	applied	\N	\N	\N	\N	76832	76832	244959
5239	4306	2	applied	\N	\N	\N	\N	76833	76833	244960
5246	4308	0	applied	\N	\N	\N	\N	76839	76839	244966
5248	4310	0	applied	\N	\N	\N	\N	76841	76841	244968
5253	4311	0	applied	\N	\N	\N	\N	76844	76844	244971
5253	4312	1	applied	\N	\N	\N	\N	76845	76845	244972
5262	4316	0	applied	\N	\N	\N	\N	76850	76850	244977
5262	4317	1	applied	\N	\N	\N	\N	76851	76851	244978
5265	4322	0	applied	\N	\N	\N	\N	76856	76856	244983
5268	4323	0	applied	\N	\N	\N	\N	76860	76860	244987
5273	4330	0	applied	\N	\N	\N	\N	76869	76869	244996
5273	4331	1	applied	\N	\N	\N	\N	76870	76870	244997
5276	4334	0	applied	\N	\N	\N	\N	76873	76873	245000
5276	4335	1	applied	\N	\N	\N	\N	76874	76874	245001
5279	4334	0	applied	\N	\N	\N	\N	76879	76879	245006
5279	4335	1	applied	\N	\N	\N	\N	76880	76880	245007
5281	4336	0	applied	\N	\N	\N	\N	76882	76882	245009
5285	4338	0	applied	\N	\N	\N	\N	76886	76886	245013
5288	4340	0	applied	\N	\N	\N	\N	76890	76890	245017
5288	4341	1	applied	\N	\N	\N	\N	76891	76891	245018
5290	4342	0	applied	\N	\N	\N	\N	76893	76893	245020
5300	4347	0	applied	\N	\N	\N	\N	76904	76904	245031
5300	4348	1	applied	\N	\N	\N	\N	76905	76905	245032
5302	4350	0	applied	\N	\N	\N	\N	76907	76907	245034
5304	4351	0	applied	\N	\N	\N	\N	76909	76909	245036
5307	4356	0	applied	\N	\N	\N	\N	76914	76914	245041
5310	4359	1	applied	\N	\N	\N	\N	76918	76918	245045
5315	4361	0	applied	\N	\N	\N	\N	76923	76923	245050
5324	4363	0	applied	\N	\N	\N	\N	76932	76932	245059
5325	4227	0	applied	\N	\N	1000000000	\N	76933	76933	245060
5325	4291	1	applied	\N	\N	1000000000	\N	76934	76934	245061
5325	4212	2	applied	\N	\N	\N	\N	76935	76935	245062
5325	4323	3	applied	\N	\N	\N	\N	76936	76936	245063
5325	4282	4	applied	\N	\N	\N	\N	76937	76937	245064
5361	4377	13	applied	\N	\N	\N	\N	77092	77092	245219
5361	4378	14	applied	\N	\N	\N	\N	77093	77093	245220
5361	4379	15	applied	\N	\N	\N	\N	77094	77094	245221
5361	4380	16	applied	\N	\N	\N	\N	77095	77095	245222
5361	4381	17	applied	\N	\N	\N	\N	77096	77096	245223
5361	4382	18	applied	\N	\N	\N	\N	77097	77097	245224
5361	4383	19	applied	\N	\N	\N	\N	77098	77098	245225
5361	4384	20	applied	\N	\N	\N	\N	77099	77099	245226
5364	4389	0	applied	\N	\N	\N	\N	77104	77104	245231
5364	4390	1	applied	\N	\N	\N	\N	77105	77105	245232
5367	4392	0	applied	\N	\N	\N	\N	77108	77108	245235
5367	4393	1	applied	\N	\N	\N	\N	77109	77109	245236
5439	4402	0	applied	\N	\N	\N	\N	77138	77138	245262
5450	4403	0	applied	\N	\N	1000000000	\N	77143	77143	245267
5056	4167	0	applied	\N	\N	\N	\N	76573	76573	244700
5064	4170	0	applied	\N	\N	\N	\N	76580	76580	244707
5073	4175	0	applied	\N	\N	\N	\N	76592	76592	244719
5075	4177	0	applied	\N	\N	\N	\N	76594	76594	244721
5075	4178	1	applied	\N	\N	\N	\N	76595	76595	244722
5075	4179	2	applied	\N	\N	\N	\N	76596	76596	244723
5075	4180	3	applied	\N	\N	\N	\N	76597	76597	244724
5077	4183	0	applied	\N	\N	\N	\N	76600	76600	244727
5080	4184	0	applied	\N	\N	\N	\N	76605	76605	244732
5080	4185	1	applied	\N	\N	\N	\N	76606	76606	244733
5086	4188	0	applied	\N	\N	\N	\N	76614	76614	244741
5086	4189	1	applied	\N	\N	\N	\N	76615	76615	244742
5088	4190	0	applied	\N	\N	\N	\N	76618	76618	244745
5089	4191	0	applied	\N	\N	\N	\N	76619	76619	244746
5089	4192	1	applied	\N	\N	\N	\N	76620	76620	244747
5094	4195	0	applied	\N	\N	\N	\N	76627	76627	244754
5102	4205	0	applied	\N	\N	\N	\N	76640	76640	244767
5110	4209	0	applied	\N	\N	\N	\N	76648	76648	244775
5116	4211	0	applied	\N	\N	\N	\N	76655	76655	244782
5122	4213	0	applied	\N	\N	\N	\N	76663	76663	244790
5122	4214	1	applied	\N	\N	\N	\N	76664	76664	244791
5128	4218	0	applied	\N	\N	\N	\N	76676	76676	244803
5128	4219	1	applied	\N	\N	\N	\N	76677	76677	244804
5129	4218	0	applied	\N	\N	\N	\N	76678	76678	244805
5129	4219	1	applied	\N	\N	\N	\N	76679	76679	244806
5136	4225	0	applied	\N	\N	\N	\N	76696	76696	244823
5140	4227	0	applied	\N	\N	1000000000	\N	76703	76703	244830
5140	4228	1	applied	\N	\N	\N	\N	76704	76704	244831
5150	4238	0	applied	\N	\N	\N	\N	76719	76719	244846
5150	4239	1	applied	\N	\N	\N	\N	76720	76720	244847
5152	4240	0	applied	\N	\N	\N	\N	76722	76722	244849
5156	4244	0	applied	\N	\N	\N	\N	76726	76726	244853
5161	4248	0	applied	\N	\N	\N	\N	76732	76732	244859
5163	4249	0	applied	\N	\N	\N	\N	76734	76734	244861
5167	4253	0	applied	\N	\N	\N	\N	76739	76739	244866
5170	4255	0	applied	\N	\N	\N	\N	76742	76742	244869
5170	4256	1	applied	\N	\N	\N	\N	76743	76743	244870
5170	4257	2	applied	\N	\N	\N	\N	76744	76744	244871
5171	4258	0	applied	\N	\N	\N	\N	76745	76745	244872
5176	4259	0	applied	\N	\N	\N	\N	76748	76748	244875
5176	4260	1	applied	\N	\N	\N	\N	76749	76749	244876
5178	4259	0	applied	\N	\N	\N	\N	76750	76750	244877
5178	4260	1	applied	\N	\N	\N	\N	76751	76751	244878
5178	4261	2	applied	\N	\N	\N	\N	76752	76752	244879
5186	4270	0	applied	\N	\N	\N	\N	76769	76769	244896
5189	4273	0	applied	\N	\N	\N	\N	76773	76773	244900
5192	4276	0	applied	\N	\N	\N	\N	76777	76777	244904
5194	4278	0	applied	\N	\N	\N	\N	76779	76779	244906
5199	4281	0	applied	\N	\N	\N	\N	76784	76784	244911
5199	4282	1	applied	\N	\N	\N	\N	76785	76785	244912
5204	4286	0	applied	\N	\N	\N	\N	76793	76793	244920
5209	4289	0	applied	\N	\N	\N	\N	76797	76797	244924
5209	4290	1	applied	\N	\N	\N	\N	76798	76798	244925
5219	4296	0	applied	\N	\N	\N	\N	76806	76806	244933
5219	4297	1	applied	\N	\N	\N	\N	76807	76807	244934
5221	4296	0	applied	\N	\N	\N	\N	76810	76810	244937
5221	4297	1	applied	\N	\N	\N	\N	76811	76811	244938
5223	4298	0	applied	\N	\N	\N	\N	76813	76813	244940
5227	4300	0	applied	\N	\N	\N	\N	76817	76817	244944
5230	4302	0	applied	\N	\N	\N	\N	76821	76821	244948
5230	4303	1	applied	\N	\N	\N	\N	76822	76822	244949
5241	4304	0	applied	\N	\N	\N	\N	76834	76834	244961
5241	4305	1	applied	\N	\N	\N	\N	76835	76835	244962
5241	4306	2	applied	\N	\N	\N	\N	76836	76836	244963
5252	4311	0	applied	\N	\N	\N	\N	76842	76842	244969
5252	4312	1	applied	\N	\N	\N	\N	76843	76843	244970
5267	4323	0	applied	\N	\N	\N	\N	76858	76858	244985
5267	4324	1	applied	\N	\N	\N	\N	76859	76859	244986
5270	4325	0	applied	\N	\N	\N	\N	76864	76864	244991
5270	4326	1	applied	\N	\N	\N	\N	76865	76865	244992
5272	4328	0	applied	\N	\N	\N	\N	76867	76867	244994
5272	4329	1	applied	\N	\N	\N	\N	76868	76868	244995
5275	4333	0	applied	\N	\N	\N	\N	76872	76872	244999
5280	4336	0	applied	\N	\N	\N	\N	76881	76881	245008
5284	4337	0	applied	\N	\N	\N	\N	76885	76885	245012
5287	4340	0	applied	\N	\N	\N	\N	76888	76888	245015
5287	4341	1	applied	\N	\N	\N	\N	76889	76889	245016
5292	4343	0	applied	\N	\N	\N	\N	76895	76895	245022
5294	4344	0	applied	\N	\N	\N	\N	76897	76897	245024
5297	4346	0	applied	\N	\N	\N	\N	76900	76900	245027
5299	4348	1	applied	\N	\N	\N	\N	76903	76903	245030
5309	4357	0	applied	\N	\N	\N	\N	76916	76916	245043
5312	4360	0	applied	\N	\N	\N	\N	76920	76920	245047
5314	4361	0	applied	\N	\N	\N	\N	76922	76922	245049
5316	4361	0	applied	\N	\N	\N	\N	76924	76924	245051
5318	4362	0	applied	\N	\N	\N	\N	76926	76926	245053
5321	4362	0	applied	\N	\N	\N	\N	76929	76929	245056
5323	4363	0	applied	\N	\N	\N	\N	76931	76931	245058
5325	4321	5	applied	\N	\N	\N	\N	76938	76938	245065
5325	4213	6	applied	\N	\N	\N	\N	76939	76939	245066
5325	4214	7	applied	\N	\N	\N	\N	76940	76940	245067
5325	4215	8	applied	\N	\N	\N	\N	76941	76941	245068
5325	4216	9	applied	\N	\N	\N	\N	76942	76942	245069
5325	4235	10	applied	\N	\N	\N	\N	76943	76943	245070
5325	4217	11	applied	\N	\N	\N	\N	76944	76944	245071
5325	4218	12	applied	\N	\N	\N	\N	76945	76945	245072
5325	4220	14	applied	\N	\N	\N	\N	76947	76947	245074
5325	4221	15	applied	\N	\N	\N	\N	76948	76948	245075
5325	4222	16	applied	\N	\N	\N	\N	76949	76949	245076
5325	4223	17	applied	\N	\N	\N	\N	76950	76950	245077
5325	4224	18	applied	\N	\N	\N	\N	76951	76951	245078
5325	4225	19	applied	\N	\N	\N	\N	76952	76952	245079
5326	4364	0	applied	\N	\N	\N	\N	77038	77038	245165
5328	4364	0	applied	\N	\N	\N	\N	77040	77040	245167
5331	4365	0	applied	\N	\N	\N	\N	77043	77043	245170
5339	4368	0	applied	\N	\N	\N	\N	77051	77051	245178
5347	4375	0	applied	\N	\N	\N	\N	77064	77064	245191
5354	4380	0	applied	\N	\N	\N	\N	77070	77070	245197
5356	4380	0	applied	\N	\N	\N	\N	77072	77072	245199
5359	4383	0	applied	\N	\N	\N	\N	77076	77076	245203
5362	4386	0	applied	\N	\N	\N	\N	77101	77101	245228
5362	4387	1	applied	\N	\N	\N	\N	77102	77102	245229
5068	4173	0	applied	\N	\N	\N	\N	76585	76585	244712
5325	4230	23	applied	\N	\N	\N	\N	76956	76956	245083
5325	4231	24	applied	\N	\N	\N	\N	76957	76957	245084
5325	4232	25	applied	\N	\N	\N	\N	76958	76958	245085
5325	4233	26	applied	\N	\N	\N	\N	76959	76959	245086
5325	4234	27	applied	\N	\N	\N	\N	76960	76960	245087
5325	4236	28	applied	\N	\N	\N	\N	76961	76961	245088
5325	4238	30	applied	\N	\N	\N	\N	76963	76963	245090
5325	4239	31	applied	\N	\N	\N	\N	76964	76964	245091
5325	4240	32	applied	\N	\N	\N	\N	76965	76965	245092
5325	4241	33	applied	\N	\N	\N	\N	76966	76966	245093
5325	4242	34	applied	\N	\N	\N	\N	76967	76967	245094
5325	4243	35	applied	\N	\N	\N	\N	76968	76968	245095
5325	4244	36	applied	\N	\N	\N	\N	76969	76969	245096
5325	4245	37	applied	\N	\N	\N	\N	76970	76970	245097
5325	4246	38	applied	\N	\N	\N	\N	76971	76971	245098
5325	4247	39	applied	\N	\N	\N	\N	76972	76972	245099
5325	4248	40	applied	\N	\N	\N	\N	76973	76973	245100
5325	4249	41	applied	\N	\N	\N	\N	76974	76974	245101
5325	4250	42	applied	\N	\N	\N	\N	76975	76975	245102
5325	4251	43	applied	\N	\N	\N	\N	76976	76976	245103
5325	4252	44	applied	\N	\N	\N	\N	76977	76977	245104
5325	4253	45	applied	\N	\N	\N	\N	76978	76978	245105
5325	4255	47	applied	\N	\N	\N	\N	76980	76980	245107
5325	4256	48	applied	\N	\N	\N	\N	76981	76981	245108
5325	4257	49	applied	\N	\N	\N	\N	76982	76982	245109
5325	4258	50	applied	\N	\N	\N	\N	76983	76983	245110
5325	4259	51	applied	\N	\N	\N	\N	76984	76984	245111
5325	4260	52	applied	\N	\N	\N	\N	76985	76985	245112
5325	4261	53	applied	\N	\N	\N	\N	76986	76986	245113
5325	4262	54	applied	\N	\N	\N	\N	76987	76987	245114
5325	4263	55	applied	\N	\N	\N	\N	76988	76988	245115
5325	4264	56	applied	\N	\N	\N	\N	76989	76989	245116
5325	4265	57	applied	\N	\N	\N	\N	76990	76990	245117
5325	4266	58	applied	\N	\N	\N	\N	76991	76991	245118
5325	4267	59	applied	\N	\N	\N	\N	76992	76992	245119
5325	4268	60	applied	\N	\N	\N	\N	76993	76993	245120
5325	4269	61	applied	\N	\N	\N	\N	76994	76994	245121
5325	4270	62	applied	\N	\N	\N	\N	76995	76995	245122
5325	4272	64	applied	\N	\N	\N	\N	76997	76997	245124
5325	4273	65	applied	\N	\N	\N	\N	76998	76998	245125
5325	4274	66	applied	\N	\N	\N	\N	76999	76999	245126
5325	4275	67	applied	\N	\N	\N	\N	77000	77000	245127
5325	4276	68	applied	\N	\N	\N	\N	77001	77001	245128
5325	4277	69	applied	\N	\N	\N	\N	77002	77002	245129
5325	4278	70	applied	\N	\N	\N	\N	77003	77003	245130
5325	4279	71	applied	\N	\N	\N	\N	77004	77004	245131
5325	4280	72	applied	\N	\N	\N	\N	77005	77005	245132
5325	4281	73	applied	\N	\N	\N	\N	77006	77006	245133
5325	4283	74	applied	\N	\N	\N	\N	77007	77007	245134
5325	4284	75	applied	\N	\N	\N	\N	77008	77008	245135
5325	4285	76	applied	\N	\N	\N	\N	77009	77009	245136
5325	4286	77	applied	\N	\N	\N	\N	77010	77010	245137
5325	4287	78	applied	\N	\N	\N	\N	77011	77011	245138
5325	4288	79	applied	\N	\N	\N	\N	77012	77012	245139
5325	4290	81	applied	\N	\N	\N	\N	77014	77014	245141
5325	4292	82	applied	\N	\N	\N	\N	77015	77015	245142
5325	4293	83	applied	\N	\N	\N	\N	77016	77016	245143
5325	4294	84	applied	\N	\N	\N	\N	77017	77017	245144
5325	4295	85	applied	\N	\N	\N	\N	77018	77018	245145
5325	4296	86	applied	\N	\N	\N	\N	77019	77019	245146
5325	4297	87	applied	\N	\N	\N	\N	77020	77020	245147
5325	4298	88	applied	\N	\N	\N	\N	77021	77021	245148
5325	4299	89	applied	\N	\N	\N	\N	77022	77022	245149
5325	4300	90	applied	\N	\N	\N	\N	77023	77023	245150
5325	4301	91	applied	\N	\N	\N	\N	77024	77024	245151
5325	4302	92	applied	\N	\N	\N	\N	77025	77025	245152
5325	4303	93	applied	\N	\N	\N	\N	77026	77026	245153
5325	4304	94	applied	\N	\N	\N	\N	77027	77027	245154
5325	4305	95	applied	\N	\N	\N	\N	77028	77028	245155
5325	4306	96	applied	\N	\N	\N	\N	77029	77029	245156
5325	4308	98	applied	\N	\N	\N	\N	77031	77031	245158
5325	4309	99	applied	\N	\N	\N	\N	77032	77032	245159
5325	4310	100	applied	\N	\N	\N	\N	77033	77033	245160
5325	4311	101	applied	\N	\N	\N	\N	77034	77034	245161
5325	4312	102	applied	\N	\N	\N	\N	77035	77035	245162
5325	4313	103	applied	\N	\N	\N	\N	77036	77036	245163
5325	4314	104	applied	\N	\N	\N	\N	77037	77037	245164
5327	4364	0	applied	\N	\N	\N	\N	77039	77039	245166
5329	4365	0	applied	\N	\N	\N	\N	77041	77041	245168
5333	4366	0	applied	\N	\N	\N	\N	77045	77045	245172
5338	4367	0	applied	\N	\N	\N	\N	77050	77050	245177
5340	4368	0	applied	\N	\N	\N	\N	77052	77052	245179
5342	4370	0	applied	\N	\N	\N	\N	77054	77054	245181
5345	4374	0	applied	\N	\N	\N	\N	77062	77062	245189
5350	4377	0	applied	\N	\N	\N	\N	77066	77066	245193
5352	4378	0	applied	\N	\N	\N	\N	77068	77068	245195
5357	4381	0	applied	\N	\N	\N	\N	77073	77073	245200
5357	4382	1	applied	\N	\N	\N	\N	77074	77074	245201
5360	4384	0	applied	\N	\N	\N	\N	77077	77077	245204
5360	4385	1	applied	\N	\N	\N	\N	77078	77078	245205
5365	4391	0	applied	\N	\N	\N	\N	77106	77106	245233
5368	4394	0	applied	\N	\N	\N	\N	77110	77110	245237
5369	4395	0	applied	\N	\N	\N	\N	77111	77111	245238
5369	4396	1	applied	\N	\N	\N	\N	77112	77112	245239
5379	4397	0	applied	\N	\N	\N	\N	77113	77113	245240
5410	4399	0	applied	\N	\N	\N	\N	77116	77116	245243
5414	4386	0	applied	\N	\N	\N	\N	77117	77117	245244
5414	4387	1	applied	\N	\N	\N	\N	77118	77118	245245
5414	4388	2	applied	\N	\N	\N	\N	77119	77119	245246
5415	4400	0	applied	\N	\N	\N	\N	77130	77130	245257
5418	4398	1	applied	\N	\N	1000000000	\N	77133	77133	245259
5422	4401	0	applied	\N	\N	\N	\N	77134	77134	245260
5432	4398	2	applied	\N	\N	1000000000	\N	77137	77137	245261
5432	4400	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	77135	77135	\N
5432	4401	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77136	77136	\N
5440	4402	0	applied	\N	\N	\N	\N	77139	77139	245263
5442	4402	0	applied	\N	\N	\N	\N	77141	77141	245265
5453	4295	0	applied	\N	\N	\N	\N	77144	77144	245268
5325	4228	21	applied	\N	\N	\N	\N	76954	76954	245081
5325	4229	22	applied	\N	\N	\N	\N	76955	76955	245082
5414	4392	6	applied	\N	\N	\N	\N	77123	77123	245250
5414	4393	7	applied	\N	\N	\N	\N	77124	77124	245251
5414	4395	9	applied	\N	\N	\N	\N	77126	77126	245253
5414	4396	10	applied	\N	\N	\N	\N	77127	77127	245254
5414	4397	11	applied	\N	\N	\N	\N	77128	77128	245255
5414	4398	12	applied	\N	\N	1000000000	\N	77129	77129	245256
5441	4402	0	applied	\N	\N	\N	\N	77140	77140	245264
5453	4296	1	applied	\N	\N	\N	\N	77145	77145	245269
5453	4297	2	applied	\N	\N	\N	\N	77146	77146	245270
5453	4298	3	applied	\N	\N	\N	\N	77147	77147	245271
5453	4299	4	applied	\N	\N	\N	\N	77148	77148	245272
5453	4300	5	applied	\N	\N	\N	\N	77149	77149	245273
5453	4301	6	applied	\N	\N	\N	\N	77150	77150	245274
5453	4302	7	applied	\N	\N	\N	\N	77151	77151	245275
5453	4303	8	applied	\N	\N	\N	\N	77152	77152	245276
5453	4304	9	applied	\N	\N	\N	\N	77153	77153	245277
5453	4305	10	applied	\N	\N	\N	\N	77154	77154	245278
5453	4306	11	applied	\N	\N	\N	\N	77155	77155	245279
5453	4308	13	applied	\N	\N	\N	\N	77157	77157	245281
5453	4309	14	applied	\N	\N	\N	\N	77158	77158	245282
5453	4310	15	applied	\N	\N	\N	\N	77159	77159	245283
5453	4311	16	applied	\N	\N	\N	\N	77160	77160	245284
5453	4312	17	applied	\N	\N	\N	\N	77161	77161	245285
5453	4313	18	applied	\N	\N	\N	\N	77162	77162	245286
5453	4314	19	applied	\N	\N	\N	\N	77163	77163	245287
5453	4315	20	applied	\N	\N	\N	\N	77164	77164	245288
5453	4316	21	applied	\N	\N	\N	\N	77165	77165	245289
5453	4317	22	applied	\N	\N	\N	\N	77166	77166	245290
5453	4318	23	applied	\N	\N	\N	\N	77167	77167	245291
5453	4319	24	applied	\N	\N	\N	\N	77168	77168	245292
5453	4320	25	applied	\N	\N	\N	\N	77169	77169	245293
5453	4322	26	applied	\N	\N	\N	\N	77170	77170	245294
5453	4324	27	applied	\N	\N	\N	\N	77171	77171	245295
5453	4325	28	applied	\N	\N	\N	\N	77172	77172	245296
5453	4327	30	applied	\N	\N	\N	\N	77174	77174	245298
5453	4328	31	applied	\N	\N	\N	\N	77175	77175	245299
5453	4329	32	applied	\N	\N	\N	\N	77176	77176	245300
5453	4330	33	applied	\N	\N	\N	\N	77177	77177	245301
5453	4331	34	applied	\N	\N	\N	\N	77178	77178	245302
5453	4332	35	applied	\N	\N	\N	\N	77179	77179	245303
5453	4333	36	applied	\N	\N	\N	\N	77180	77180	245304
5453	4334	37	applied	\N	\N	\N	\N	77181	77181	245305
5453	4335	38	applied	\N	\N	\N	\N	77182	77182	245306
5458	4404	0	applied	\N	\N	1000000000	\N	77190	77190	245314
5458	4405	1	applied	\N	\N	1000000000	\N	77191	77191	245315
5458	4406	2	applied	\N	\N	1000000000	\N	77192	77192	245316
5458	4407	3	applied	\N	\N	1000000000	\N	77193	77193	245317
5458	4408	4	applied	\N	\N	1000000000	\N	77194	77194	245318
5458	4410	6	applied	\N	\N	1000000000	\N	77196	77196	245320
5504	4412	0	applied	\N	\N	\N	\N	77198	77198	245322
5512	4413	0	applied	\N	\N	\N	\N	77199	77199	245323
5514	4291	0	applied	\N	\N	1000000000	\N	77201	77201	245325
5514	4404	1	applied	\N	\N	1000000000	\N	77202	77202	245326
5514	4405	2	applied	\N	\N	1000000000	\N	77203	77203	245327
5514	4406	3	applied	\N	\N	1000000000	\N	77204	77204	245328
5514	4407	4	applied	\N	\N	1000000000	\N	77205	77205	245329
5514	4408	5	applied	\N	\N	1000000000	\N	77206	77206	245330
5514	4409	6	applied	\N	\N	1000000000	\N	77207	77207	245331
5514	4410	7	applied	\N	\N	1000000000	\N	77208	77208	245332
5514	4412	8	applied	\N	\N	\N	\N	77209	77209	245333
5514	4323	9	applied	\N	\N	\N	\N	77210	77210	245334
5514	4321	10	applied	\N	\N	\N	\N	77211	77211	245335
5514	4287	11	applied	\N	\N	\N	\N	77212	77212	245336
5514	4288	12	applied	\N	\N	\N	\N	77213	77213	245337
5514	4413	13	applied	\N	\N	\N	\N	77214	77214	245338
5514	4289	14	applied	\N	\N	\N	\N	77215	77215	245339
5514	4290	15	applied	\N	\N	\N	\N	77216	77216	245340
5514	4292	16	applied	\N	\N	\N	\N	77217	77217	245341
5514	4294	18	applied	\N	\N	\N	\N	77219	77219	245343
5514	4295	19	applied	\N	\N	\N	\N	77220	77220	245344
5514	4296	20	applied	\N	\N	\N	\N	77221	77221	245345
5514	4297	21	applied	\N	\N	\N	\N	77222	77222	245346
5514	4298	22	applied	\N	\N	\N	\N	77223	77223	245347
5514	4299	23	applied	\N	\N	\N	\N	77224	77224	245348
5514	4300	24	applied	\N	\N	\N	\N	77225	77225	245349
5514	4301	25	applied	\N	\N	\N	\N	77226	77226	245350
5514	4302	26	applied	\N	\N	\N	\N	77227	77227	245351
5514	4303	27	applied	\N	\N	\N	\N	77228	77228	245352
5514	4304	28	applied	\N	\N	\N	\N	77229	77229	245353
5514	4305	29	applied	\N	\N	\N	\N	77230	77230	245354
5514	4306	30	applied	\N	\N	\N	\N	77231	77231	245355
5514	4307	31	applied	\N	\N	\N	\N	77232	77232	245356
5514	4308	32	applied	\N	\N	\N	\N	77233	77233	245357
5514	4309	33	applied	\N	\N	\N	\N	77234	77234	245358
5514	4311	35	applied	\N	\N	\N	\N	77236	77236	245360
5514	4312	36	applied	\N	\N	\N	\N	77237	77237	245361
5514	4313	37	applied	\N	\N	\N	\N	77238	77238	245362
5514	4314	38	applied	\N	\N	\N	\N	77239	77239	245363
5514	4315	39	applied	\N	\N	\N	\N	77240	77240	245364
5514	4316	40	applied	\N	\N	\N	\N	77241	77241	245365
5514	4317	41	applied	\N	\N	\N	\N	77242	77242	245366
5514	4318	42	applied	\N	\N	\N	\N	77243	77243	245367
5514	4319	43	applied	\N	\N	\N	\N	77244	77244	245368
5514	4320	44	applied	\N	\N	\N	\N	77245	77245	245369
5514	4322	45	applied	\N	\N	\N	\N	77246	77246	245370
5514	4324	46	applied	\N	\N	\N	\N	77247	77247	245371
5514	4325	47	applied	\N	\N	\N	\N	77248	77248	245372
5514	4326	48	applied	\N	\N	\N	\N	77249	77249	245373
5514	4327	49	applied	\N	\N	\N	\N	77250	77250	245374
5514	4328	50	applied	\N	\N	\N	\N	77251	77251	245375
5514	4330	52	applied	\N	\N	\N	\N	77253	77253	245377
5514	4331	53	applied	\N	\N	\N	\N	77254	77254	245378
5514	4332	54	applied	\N	\N	\N	\N	77255	77255	245379
5514	4333	55	applied	\N	\N	\N	\N	77256	77256	245380
5514	4334	56	applied	\N	\N	\N	\N	77257	77257	245381
5570	4414	0	applied	\N	\N	\N	\N	77261	77261	245385
5631	4415	0	applied	\N	\N	\N	\N	77274	77274	245398
5766	4450	1	applied	\N	\N	\N	\N	77360	77360	245484
5414	4390	4	applied	\N	\N	\N	\N	77121	77121	245248
5414	4391	5	applied	\N	\N	\N	\N	77122	77122	245249
5457	4407	3	applied	\N	\N	1000000000	\N	77186	77186	245310
5457	4408	4	applied	\N	\N	1000000000	\N	77187	77187	245311
5457	4409	5	applied	\N	\N	1000000000	\N	77188	77188	245312
5457	4410	6	applied	\N	\N	1000000000	\N	77189	77189	245313
5513	4413	0	applied	\N	\N	\N	\N	77200	77200	245324
5540	4414	0	applied	\N	\N	\N	\N	77259	77259	245383
5560	4414	0	applied	\N	\N	\N	\N	77260	77260	245384
5679	4416	0	applied	\N	\N	1000000000	\N	77300	77300	245424
5681	4417	0	applied	\N	\N	\N	\N	77302	77302	245426
5683	4417	0	applied	\N	\N	\N	\N	77304	77304	245428
5700	4418	0	applied	\N	\N	\N	\N	77306	77306	245430
5718	4420	0	applied	\N	\N	\N	\N	77316	77316	245440
5718	4421	1	applied	\N	\N	\N	\N	77317	77317	245441
5726	4422	0	applied	\N	\N	\N	\N	77318	77318	245442
5727	4422	0	applied	\N	\N	\N	\N	77319	77319	245443
5742	4424	0	applied	\N	\N	\N	\N	77323	77323	245447
5744	4425	0	applied	\N	\N	\N	\N	77324	77324	245448
5744	4426	1	applied	\N	\N	\N	\N	77325	77325	245449
5745	4427	0	applied	\N	\N	\N	\N	77326	77326	245450
5748	4430	0	applied	\N	\N	\N	\N	77329	77329	245453
5750	4431	0	applied	\N	\N	\N	\N	77331	77331	245455
5753	4433	0	applied	\N	\N	\N	\N	77334	77334	245458
5753	4434	1	applied	\N	\N	\N	\N	77335	77335	245459
5753	4435	2	applied	\N	\N	\N	\N	77336	77336	245460
5758	4437	0	applied	\N	\N	\N	\N	77342	77342	245466
5759	4438	0	applied	\N	\N	\N	\N	77343	77343	245467
5759	4439	1	applied	\N	\N	\N	\N	77344	77344	245468
5762	4441	0	applied	\N	\N	\N	\N	77348	77348	245472
5762	4442	1	applied	\N	\N	\N	\N	77349	77349	245473
5764	4443	0	applied	\N	\N	\N	\N	77353	77353	245477
5764	4444	1	applied	\N	\N	\N	\N	77354	77354	245478
5766	4449	0	applied	\N	\N	\N	\N	77359	77359	245483
5774	4453	0	applied	\N	\N	\N	\N	77365	77365	245489
5774	4454	1	applied	\N	\N	\N	\N	77366	77366	245490
5778	4461	0	applied	\N	\N	\N	\N	77373	77373	245497
5778	4462	1	applied	\N	\N	\N	\N	77374	77374	245498
5781	4466	0	applied	\N	\N	\N	\N	77378	77378	245502
5784	4469	0	applied	\N	\N	\N	\N	77435	77435	245559
5784	4470	1	applied	\N	\N	\N	\N	77436	77436	245560
5787	4471	0	applied	\N	\N	1000000000	\N	77440	77440	245564
5787	4472	1	applied	\N	\N	1000000000	\N	77441	77441	245565
5787	4473	2	applied	\N	\N	\N	\N	77442	77442	245566
5789	4471	0	applied	\N	\N	1000000000	\N	77446	77446	245570
5789	4472	1	applied	\N	\N	1000000000	\N	77447	77447	245571
5789	4473	2	applied	\N	\N	\N	\N	77448	77448	245572
5791	4474	0	applied	\N	\N	\N	\N	77450	77450	245574
5799	4479	0	applied	\N	\N	\N	\N	77461	77461	245585
5801	4483	0	applied	\N	\N	\N	\N	77465	77465	245589
5809	4488	0	applied	\N	\N	\N	\N	77472	77472	245596
5811	4489	0	applied	\N	\N	\N	\N	77474	77474	245598
5811	4490	1	applied	\N	\N	\N	\N	77475	77475	245599
5813	4491	0	applied	\N	\N	\N	\N	77478	77478	245602
5817	4495	0	applied	\N	\N	\N	\N	77484	77484	245608
5817	4496	1	applied	\N	\N	\N	\N	77485	77485	245609
5822	4498	0	applied	\N	\N	\N	\N	77489	77489	245613
5823	4499	0	applied	\N	\N	\N	\N	77490	77490	245614
5828	4500	0	applied	\N	\N	\N	\N	77495	77495	245619
5830	4503	0	applied	\N	\N	\N	\N	77498	77498	245622
5839	4507	0	applied	\N	\N	1000000000	\N	77516	77516	245640
5839	4508	2	applied	\N	\N	1000000000	\N	77517	77517	245641
5839	4509	3	applied	\N	\N	\N	\N	77518	77518	245642
5839	4510	4	applied	\N	\N	\N	\N	77519	77519	245643
5840	4508	2	applied	\N	\N	1000000000	\N	77521	77521	245645
5840	4509	3	applied	\N	\N	\N	\N	77522	77522	245646
5840	4510	4	applied	\N	\N	\N	\N	77523	77523	245647
5843	4512	0	applied	\N	\N	\N	\N	77528	77528	245652
5843	4513	1	applied	\N	\N	\N	\N	77529	77529	245653
5843	4514	2	applied	\N	\N	\N	\N	77530	77530	245654
5845	4515	0	applied	\N	\N	\N	\N	77532	77532	245656
5848	4516	0	applied	\N	\N	\N	\N	77535	77535	245659
5849	4517	0	applied	\N	\N	\N	\N	77536	77536	245660
5855	4522	0	applied	\N	\N	\N	\N	77543	77543	245667
5857	4523	0	applied	\N	\N	\N	\N	77544	77544	245668
5857	4524	1	applied	\N	\N	\N	\N	77545	77545	245669
5864	4525	0	applied	\N	\N	\N	\N	77548	77548	245672
5864	4526	1	applied	\N	\N	\N	\N	77549	77549	245673
5867	4525	0	applied	\N	\N	\N	\N	77607	77607	245731
5867	4526	1	applied	\N	\N	\N	\N	77608	77608	245732
5868	4527	0	applied	\N	\N	\N	\N	77609	77609	245733
5868	4528	1	applied	\N	\N	\N	\N	77610	77610	245734
5868	4529	2	applied	\N	\N	\N	\N	77611	77611	245735
5877	4538	0	applied	\N	\N	\N	\N	77626	77626	245750
5879	4539	0	applied	\N	\N	\N	\N	77628	77628	245752
5879	4540	1	applied	\N	\N	\N	\N	77629	77629	245753
5881	4541	0	applied	\N	\N	\N	\N	77632	77632	245756
5884	4542	0	applied	\N	\N	1000000000	\N	77633	77633	245757
5884	4543	1	applied	\N	\N	1000000000	\N	77634	77634	245758
5884	4544	2	applied	\N	\N	1000000000	\N	77635	77635	245759
5893	4545	0	applied	\N	\N	\N	\N	77646	77646	245770
5893	4546	1	applied	\N	\N	\N	\N	77647	77647	245771
5893	4547	2	applied	\N	\N	\N	\N	77648	77648	245772
5893	4548	3	applied	\N	\N	\N	\N	77649	77649	245773
5893	4549	4	applied	\N	\N	\N	\N	77650	77650	245774
5894	4550	0	applied	\N	\N	\N	\N	77651	77651	245775
5898	4557	0	applied	\N	\N	\N	\N	77659	77659	245783
5903	4559	0	applied	\N	\N	\N	\N	77664	77664	245788
5905	4560	0	applied	\N	\N	\N	\N	77666	77666	245790
5917	4568	1	applied	\N	\N	\N	\N	77682	77682	245806
5917	4569	2	applied	\N	\N	\N	\N	77683	77683	245807
5921	4570	0	applied	\N	\N	\N	\N	77691	77691	245815
5925	4572	0	applied	\N	\N	\N	\N	77695	77695	245819
5926	4572	0	applied	\N	\N	\N	\N	77696	77696	245820
5929	4573	0	applied	\N	\N	\N	\N	77700	77700	245824
5929	4574	1	applied	\N	\N	\N	\N	77701	77701	245825
5932	4577	0	applied	\N	\N	\N	\N	77706	77706	245830
5934	4578	0	applied	\N	\N	\N	\N	77735	77735	245859
5936	4578	0	applied	\N	\N	\N	\N	77737	77737	245861
5939	4581	0	applied	\N	\N	\N	\N	77740	77740	245864
5457	4405	1	applied	\N	\N	1000000000	\N	77184	77184	245308
5457	4406	2	applied	\N	\N	1000000000	\N	77185	77185	245309
5699	4418	0	applied	\N	\N	\N	\N	77305	77305	245429
5716	4420	0	applied	\N	\N	\N	\N	77312	77312	245436
5716	4421	1	applied	\N	\N	\N	\N	77313	77313	245437
5741	4424	0	applied	\N	\N	\N	\N	77322	77322	245446
5746	4428	0	applied	\N	\N	\N	\N	77327	77327	245451
5749	4430	0	applied	\N	\N	\N	\N	77330	77330	245454
5751	4431	0	applied	\N	\N	\N	\N	77332	77332	245456
5754	4433	0	applied	\N	\N	\N	\N	77337	77337	245461
5754	4434	1	applied	\N	\N	\N	\N	77338	77338	245462
5756	4436	0	applied	\N	\N	\N	\N	77340	77340	245464
5761	4440	0	applied	\N	\N	\N	\N	77347	77347	245471
5765	4446	0	applied	\N	\N	\N	\N	77356	77356	245480
5765	4447	1	applied	\N	\N	\N	\N	77357	77357	245481
5765	4448	2	applied	\N	\N	\N	\N	77358	77358	245482
5770	4452	0	applied	\N	\N	\N	\N	77363	77363	245487
5775	4455	0	applied	\N	\N	\N	\N	77367	77367	245491
5775	4456	1	applied	\N	\N	\N	\N	77368	77368	245492
5782	4467	0	applied	\N	\N	\N	\N	77379	77379	245503
5782	4468	1	applied	\N	\N	\N	\N	77380	77380	245504
5788	4471	0	applied	\N	\N	1000000000	\N	77443	77443	245567
5788	4472	1	applied	\N	\N	1000000000	\N	77444	77444	245568
5788	4473	2	applied	\N	\N	\N	\N	77445	77445	245569
5794	4476	0	applied	\N	\N	\N	\N	77452	77452	245576
5794	4477	1	applied	\N	\N	\N	\N	77453	77453	245577
5802	4483	0	applied	\N	\N	\N	\N	77466	77466	245590
5812	4489	0	applied	\N	\N	\N	\N	77476	77476	245600
5812	4490	1	applied	\N	\N	\N	\N	77477	77477	245601
5814	4492	0	applied	\N	\N	\N	\N	77479	77479	245603
5824	4499	0	applied	\N	\N	\N	\N	77491	77491	245615
5826	4499	0	applied	\N	\N	\N	\N	77493	77493	245617
5831	4504	0	applied	\N	\N	\N	\N	77499	77499	245623
5833	4505	0	applied	\N	\N	\N	\N	77501	77501	245625
5836	4507	0	applied	\N	\N	1000000000	\N	77504	77504	245628
5836	4508	2	applied	\N	\N	1000000000	\N	77505	77505	245629
5836	4509	3	applied	\N	\N	\N	\N	77506	77506	245630
5836	4510	4	applied	\N	\N	\N	\N	77507	77507	245631
5850	4518	0	applied	\N	\N	\N	\N	77537	77537	245661
5852	4519	0	applied	\N	\N	\N	\N	77539	77539	245663
5865	4525	0	applied	\N	\N	\N	\N	77550	77550	245674
5865	4526	1	applied	\N	\N	\N	\N	77551	77551	245675
5869	4527	0	applied	\N	\N	\N	\N	77612	77612	245736
5869	4529	2	applied	\N	\N	\N	\N	77614	77614	245738
5872	4533	0	applied	\N	\N	\N	\N	77618	77618	245742
5872	4534	1	applied	\N	\N	\N	\N	77619	77619	245743
5880	4539	0	applied	\N	\N	\N	\N	77630	77630	245754
5880	4540	1	applied	\N	\N	\N	\N	77631	77631	245755
5896	4551	0	applied	\N	\N	\N	\N	77653	77653	245777
5896	4552	1	applied	\N	\N	\N	\N	77654	77654	245778
5896	4553	2	applied	\N	\N	\N	\N	77655	77655	245779
5896	4554	3	applied	\N	\N	\N	\N	77656	77656	245780
5896	4555	4	applied	\N	\N	\N	\N	77657	77657	245781
5899	4557	0	applied	\N	\N	\N	\N	77660	77660	245784
5910	4564	0	applied	\N	\N	\N	\N	77671	77671	245795
5918	4567	0	applied	\N	\N	\N	\N	77684	77684	245808
5918	4568	1	applied	\N	\N	\N	\N	77685	77685	245809
5918	4569	2	applied	\N	\N	\N	\N	77686	77686	245810
5922	4570	0	applied	\N	\N	\N	\N	77692	77692	245816
5930	4573	0	applied	\N	\N	\N	\N	77702	77702	245826
5930	4574	1	applied	\N	\N	\N	\N	77703	77703	245827
5933	4550	0	applied	\N	\N	\N	\N	77707	77707	245831
5933	4551	1	applied	\N	\N	\N	\N	77708	77708	245832
5933	4552	2	applied	\N	\N	\N	\N	77709	77709	245833
5933	4553	3	applied	\N	\N	\N	\N	77710	77710	245834
5933	4554	4	applied	\N	\N	\N	\N	77711	77711	245835
5933	4555	5	applied	\N	\N	\N	\N	77712	77712	245836
5933	4556	6	applied	\N	\N	\N	\N	77713	77713	245837
5933	4557	7	applied	\N	\N	\N	\N	77714	77714	245838
5933	4558	8	applied	\N	\N	\N	\N	77715	77715	245839
5933	4559	9	applied	\N	\N	\N	\N	77716	77716	245840
5933	4560	10	applied	\N	\N	\N	\N	77717	77717	245841
5933	4561	11	applied	\N	\N	\N	\N	77718	77718	245842
5933	4562	12	applied	\N	\N	\N	\N	77719	77719	245843
5933	4563	13	applied	\N	\N	\N	\N	77720	77720	245844
5933	4565	15	applied	\N	\N	\N	\N	77722	77722	245846
5933	4566	16	applied	\N	\N	\N	\N	77723	77723	245847
5933	4567	17	applied	\N	\N	\N	\N	77724	77724	245848
5933	4568	18	applied	\N	\N	\N	\N	77725	77725	245849
5933	4569	19	applied	\N	\N	\N	\N	77726	77726	245850
5933	4570	20	applied	\N	\N	\N	\N	77727	77727	245851
5933	4571	21	applied	\N	\N	\N	\N	77728	77728	245852
5933	4572	22	applied	\N	\N	\N	\N	77729	77729	245853
5933	4573	23	applied	\N	\N	\N	\N	77730	77730	245854
5933	4574	24	applied	\N	\N	\N	\N	77731	77731	245855
5933	4575	25	applied	\N	\N	\N	\N	77732	77732	245856
5933	4576	26	applied	\N	\N	\N	\N	77733	77733	245857
5933	4577	27	applied	\N	\N	\N	\N	77734	77734	245858
5937	4579	0	applied	\N	\N	\N	\N	77738	77738	245862
5941	4582	0	applied	\N	\N	\N	\N	77744	77744	245868
5941	4583	1	applied	\N	\N	\N	\N	77745	77745	245869
5942	4582	0	applied	\N	\N	\N	\N	77747	77747	245871
5942	4583	1	applied	\N	\N	\N	\N	77748	77748	245872
5942	4584	2	applied	\N	\N	\N	\N	77749	77749	245873
5944	4586	0	applied	\N	\N	\N	\N	77751	77751	245875
5945	4587	0	applied	\N	\N	\N	\N	77752	77752	245876
5945	4588	1	applied	\N	\N	\N	\N	77753	77753	245877
5947	4589	0	applied	\N	\N	\N	\N	77756	77756	245880
5947	4590	1	applied	\N	\N	\N	\N	77757	77757	245881
5948	4591	0	applied	\N	\N	\N	\N	77758	77758	245882
5950	4592	0	applied	\N	\N	\N	\N	77760	77760	245884
5952	4592	0	applied	\N	\N	\N	\N	77762	77762	245886
5957	4597	0	applied	\N	\N	\N	\N	77768	77768	245892
5960	4605	0	applied	\N	\N	\N	\N	77776	77776	245900
5963	4607	0	applied	\N	\N	\N	\N	77779	77779	245903
5965	4607	0	applied	\N	\N	\N	\N	77781	77781	245905
5968	4609	0	applied	\N	\N	\N	\N	77785	77785	245909
5973	4616	0	applied	\N	\N	\N	\N	77794	77794	245918
5975	4617	0	applied	\N	\N	\N	\N	77796	77796	245920
5980	4619	0	applied	\N	\N	\N	\N	77801	77801	245925
5989	4626	0	applied	\N	\N	\N	\N	77815	77815	245939
5630	4415	0	applied	\N	\N	\N	\N	77273	77273	245397
5682	4417	0	applied	\N	\N	\N	\N	77303	77303	245427
5656	4406	3	applied	\N	\N	1000000000	\N	77278	77278	245402
5656	4408	5	applied	\N	\N	1000000000	\N	77280	77280	245404
5656	4409	6	applied	\N	\N	1000000000	\N	77281	77281	245405
5656	4410	7	applied	\N	\N	1000000000	\N	77282	77282	245406
5656	4412	8	applied	\N	\N	\N	\N	77283	77283	245407
5656	4413	9	applied	\N	\N	\N	\N	77284	77284	245408
5656	4403	10	applied	\N	\N	1000000000	\N	77285	77285	245409
5656	4411	12	applied	\N	\N	\N	\N	77286	77286	245410
5678	4404	0	applied	\N	\N	1000000000	\N	77287	77287	245411
5678	4414	1	applied	\N	\N	\N	\N	77288	77288	245412
5678	4405	2	applied	\N	\N	1000000000	\N	77289	77289	245413
5678	4406	3	applied	\N	\N	1000000000	\N	77290	77290	245414
5678	4407	4	applied	\N	\N	1000000000	\N	77291	77291	245415
5678	4408	5	applied	\N	\N	1000000000	\N	77292	77292	245416
5678	4409	6	applied	\N	\N	1000000000	\N	77293	77293	245417
5678	4410	7	applied	\N	\N	1000000000	\N	77294	77294	245418
5678	4412	8	applied	\N	\N	\N	\N	77295	77295	245419
5678	4413	9	applied	\N	\N	\N	\N	77296	77296	245420
5678	4403	10	applied	\N	\N	1000000000	\N	77297	77297	245421
5678	4411	11	applied	\N	\N	\N	\N	77298	77298	245422
5678	4402	12	applied	\N	\N	\N	\N	77299	77299	245423
5710	4419	0	applied	\N	\N	1000000000	\N	77307	77307	245431
5714	4419	0	applied	\N	\N	1000000000	\N	77308	77308	245432
5714	4416	1	applied	\N	\N	1000000000	\N	77309	77309	245433
5714	4417	2	applied	\N	\N	\N	\N	77310	77310	245434
5714	4418	3	applied	\N	\N	\N	\N	77311	77311	245435
5717	4420	0	applied	\N	\N	\N	\N	77314	77314	245438
5717	4421	1	applied	\N	\N	\N	\N	77315	77315	245439
5740	4423	0	applied	\N	\N	\N	\N	77321	77321	245445
5747	4429	0	applied	\N	\N	\N	\N	77328	77328	245452
5752	4432	0	applied	\N	\N	\N	\N	77333	77333	245457
5757	4437	0	applied	\N	\N	\N	\N	77341	77341	245465
5760	4438	0	applied	\N	\N	\N	\N	77345	77345	245469
5760	4439	1	applied	\N	\N	\N	\N	77346	77346	245470
5763	4443	0	applied	\N	\N	\N	\N	77350	77350	245474
5763	4444	1	applied	\N	\N	\N	\N	77351	77351	245475
5763	4445	2	applied	\N	\N	\N	\N	77352	77352	245476
5777	4457	0	applied	\N	\N	\N	\N	77369	77369	245493
5777	4458	1	applied	\N	\N	\N	\N	77370	77370	245494
5777	4459	2	applied	\N	\N	\N	\N	77371	77371	245495
5777	4460	3	applied	\N	\N	\N	\N	77372	77372	245496
5780	4464	0	applied	\N	\N	\N	\N	77376	77376	245500
5780	4465	1	applied	\N	\N	\N	\N	77377	77377	245501
5793	4475	0	applied	\N	\N	\N	\N	77451	77451	245575
5796	4476	0	applied	\N	\N	\N	\N	77456	77456	245580
5796	4477	1	applied	\N	\N	\N	\N	77457	77457	245581
5798	4479	0	applied	\N	\N	\N	\N	77459	77459	245583
5798	4480	1	applied	\N	\N	\N	\N	77460	77460	245584
5803	4484	0	applied	\N	\N	\N	\N	77467	77467	245591
5808	4488	0	applied	\N	\N	\N	\N	77471	77471	245595
5816	4495	0	applied	\N	\N	\N	\N	77482	77482	245606
5816	4496	1	applied	\N	\N	\N	\N	77483	77483	245607
5818	4497	0	applied	\N	\N	\N	\N	77486	77486	245610
5827	4500	0	applied	\N	\N	\N	\N	77494	77494	245618
5835	4506	0	applied	\N	\N	\N	\N	77503	77503	245627
5838	4507	0	applied	\N	\N	1000000000	\N	77512	77512	245636
5838	4508	2	applied	\N	\N	1000000000	\N	77513	77513	245637
5838	4509	3	applied	\N	\N	\N	\N	77514	77514	245638
5838	4510	4	applied	\N	\N	\N	\N	77515	77515	245639
5841	4511	0	applied	\N	\N	\N	\N	77524	77524	245648
5842	4512	0	applied	\N	\N	\N	\N	77525	77525	245649
5842	4513	1	applied	\N	\N	\N	\N	77526	77526	245650
5842	4514	2	applied	\N	\N	\N	\N	77527	77527	245651
5844	4515	0	applied	\N	\N	\N	\N	77531	77531	245655
5847	4516	0	applied	\N	\N	\N	\N	77534	77534	245658
5854	4522	0	applied	\N	\N	\N	\N	77542	77542	245666
5866	4471	0	applied	\N	\N	1000000000	\N	77552	77552	245676
5866	4507	2	applied	\N	\N	1000000000	\N	77554	77554	245678
5866	4508	3	applied	\N	\N	1000000000	\N	77555	77555	245679
5866	4473	4	applied	\N	\N	\N	\N	77556	77556	245680
5866	4474	5	applied	\N	\N	\N	\N	77557	77557	245681
5866	4475	6	applied	\N	\N	\N	\N	77558	77558	245682
5866	4476	7	applied	\N	\N	\N	\N	77559	77559	245683
5866	4477	8	applied	\N	\N	\N	\N	77560	77560	245684
5866	4478	9	applied	\N	\N	\N	\N	77561	77561	245685
5866	4479	10	applied	\N	\N	\N	\N	77562	77562	245686
5866	4480	11	applied	\N	\N	\N	\N	77563	77563	245687
5866	4481	12	applied	\N	\N	\N	\N	77564	77564	245688
5866	4482	13	applied	\N	\N	\N	\N	77565	77565	245689
5866	4483	14	applied	\N	\N	\N	\N	77566	77566	245690
5866	4484	15	applied	\N	\N	\N	\N	77567	77567	245691
5866	4485	16	applied	\N	\N	\N	\N	77568	77568	245692
5866	4486	17	applied	\N	\N	\N	\N	77569	77569	245693
5866	4487	18	applied	\N	\N	\N	\N	77570	77570	245694
5866	4488	19	applied	\N	\N	\N	\N	77571	77571	245695
5866	4489	20	applied	\N	\N	\N	\N	77572	77572	245696
5866	4490	21	applied	\N	\N	\N	\N	77573	77573	245697
5866	4492	23	applied	\N	\N	\N	\N	77575	77575	245699
5866	4493	24	applied	\N	\N	\N	\N	77576	77576	245700
5866	4494	25	applied	\N	\N	\N	\N	77577	77577	245701
5866	4495	26	applied	\N	\N	\N	\N	77578	77578	245702
5866	4496	27	applied	\N	\N	\N	\N	77579	77579	245703
5955	4596	0	applied	\N	\N	\N	\N	77766	77766	245890
5958	4598	0	applied	\N	\N	\N	\N	77769	77769	245893
5958	4599	1	applied	\N	\N	\N	\N	77770	77770	245894
5961	4606	0	applied	\N	\N	\N	\N	77777	77777	245901
5964	4607	0	applied	\N	\N	\N	\N	77780	77780	245904
5971	4613	0	applied	\N	\N	\N	\N	77791	77791	245915
5971	4614	1	applied	\N	\N	\N	\N	77792	77792	245916
5976	4618	0	applied	\N	\N	\N	\N	77797	77797	245921
5978	4619	0	applied	\N	\N	\N	\N	77799	77799	245923
5983	4622	0	applied	\N	\N	\N	\N	77806	77806	245930
5988	4625	0	applied	\N	\N	\N	\N	77814	77814	245938
5993	4629	0	applied	\N	\N	\N	\N	77819	77819	245943
5993	4630	1	applied	\N	\N	\N	\N	77820	77820	245944
5996	4631	0	applied	\N	\N	\N	\N	77825	77825	245949
5996	4632	1	applied	\N	\N	\N	\N	77826	77826	245950
5656	4414	1	applied	\N	\N	\N	\N	77276	77276	245400
5656	4405	2	applied	\N	\N	1000000000	\N	77277	77277	245401
5783	4422	0	applied	\N	\N	\N	\N	77381	77381	245505
5783	4420	1	applied	\N	\N	\N	\N	77382	77382	245506
5783	4421	2	applied	\N	\N	\N	\N	77383	77383	245507
5783	4419	3	applied	\N	\N	1000000000	\N	77384	77384	245508
5783	4423	4	applied	\N	\N	\N	\N	77385	77385	245509
5783	4424	5	applied	\N	\N	\N	\N	77386	77386	245510
5783	4425	6	applied	\N	\N	\N	\N	77387	77387	245511
5783	4427	8	applied	\N	\N	\N	\N	77389	77389	245513
5783	4428	9	applied	\N	\N	\N	\N	77390	77390	245514
5783	4429	10	applied	\N	\N	\N	\N	77391	77391	245515
5783	4430	11	applied	\N	\N	\N	\N	77392	77392	245516
5783	4431	12	applied	\N	\N	\N	\N	77393	77393	245517
5783	4432	13	applied	\N	\N	\N	\N	77394	77394	245518
5783	4433	14	applied	\N	\N	\N	\N	77395	77395	245519
5783	4434	15	applied	\N	\N	\N	\N	77396	77396	245520
5783	4435	16	applied	\N	\N	\N	\N	77397	77397	245521
5783	4436	17	applied	\N	\N	\N	\N	77398	77398	245522
5783	4437	18	applied	\N	\N	\N	\N	77399	77399	245523
5783	4438	19	applied	\N	\N	\N	\N	77400	77400	245524
5783	4439	20	applied	\N	\N	\N	\N	77401	77401	245525
5783	4417	21	applied	\N	\N	\N	\N	77402	77402	245526
5783	4418	22	applied	\N	\N	\N	\N	77403	77403	245527
5783	4440	23	applied	\N	\N	\N	\N	77404	77404	245528
5783	4442	25	applied	\N	\N	\N	\N	77406	77406	245530
5783	4443	26	applied	\N	\N	\N	\N	77407	77407	245531
5783	4444	27	applied	\N	\N	\N	\N	77408	77408	245532
5783	4445	28	applied	\N	\N	\N	\N	77409	77409	245533
5783	4446	29	applied	\N	\N	\N	\N	77410	77410	245534
5783	4447	30	applied	\N	\N	\N	\N	77411	77411	245535
5783	4448	31	applied	\N	\N	\N	\N	77412	77412	245536
5783	4449	32	applied	\N	\N	\N	\N	77413	77413	245537
5783	4450	33	applied	\N	\N	\N	\N	77414	77414	245538
5783	4451	34	applied	\N	\N	\N	\N	77415	77415	245539
5783	4452	35	applied	\N	\N	\N	\N	77416	77416	245540
5783	4453	36	applied	\N	\N	\N	\N	77417	77417	245541
5783	4454	37	applied	\N	\N	\N	\N	77418	77418	245542
5783	4455	38	applied	\N	\N	\N	\N	77419	77419	245543
5783	4456	39	applied	\N	\N	\N	\N	77420	77420	245544
5783	4457	40	applied	\N	\N	\N	\N	77421	77421	245545
5783	4459	42	applied	\N	\N	\N	\N	77423	77423	245547
5783	4460	43	applied	\N	\N	\N	\N	77424	77424	245548
5783	4461	44	applied	\N	\N	\N	\N	77425	77425	245549
5783	4462	45	applied	\N	\N	\N	\N	77426	77426	245550
5783	4463	46	applied	\N	\N	\N	\N	77427	77427	245551
5783	4464	47	applied	\N	\N	\N	\N	77428	77428	245552
5783	4465	48	applied	\N	\N	\N	\N	77429	77429	245553
5783	4466	49	applied	\N	\N	\N	\N	77430	77430	245554
5783	4467	50	applied	\N	\N	\N	\N	77431	77431	245555
5783	4468	51	applied	\N	\N	\N	\N	77432	77432	245556
5783	4469	52	applied	\N	\N	\N	\N	77433	77433	245557
5783	4470	53	applied	\N	\N	\N	\N	77434	77434	245558
5785	4471	0	applied	\N	\N	1000000000	\N	77437	77437	245561
5785	4472	1	applied	\N	\N	1000000000	\N	77438	77438	245562
5785	4473	2	applied	\N	\N	\N	\N	77439	77439	245563
5790	4474	0	applied	\N	\N	\N	\N	77449	77449	245573
5795	4477	1	applied	\N	\N	\N	\N	77455	77455	245579
5797	4478	0	applied	\N	\N	\N	\N	77458	77458	245582
5800	4481	0	applied	\N	\N	\N	\N	77463	77463	245587
5800	4482	1	applied	\N	\N	\N	\N	77464	77464	245588
5805	4485	0	applied	\N	\N	\N	\N	77468	77468	245592
5805	4486	1	applied	\N	\N	\N	\N	77469	77469	245593
5807	4487	0	applied	\N	\N	\N	\N	77470	77470	245594
5815	4493	0	applied	\N	\N	\N	\N	77480	77480	245604
5815	4494	1	applied	\N	\N	\N	\N	77481	77481	245605
5820	4498	0	applied	\N	\N	\N	\N	77487	77487	245611
5825	4499	0	applied	\N	\N	\N	\N	77492	77492	245616
5829	4501	0	applied	\N	\N	\N	\N	77496	77496	245620
5829	4502	1	applied	\N	\N	\N	\N	77497	77497	245621
5832	4504	0	applied	\N	\N	\N	\N	77500	77500	245624
5834	4506	0	applied	\N	\N	\N	\N	77502	77502	245626
5837	4508	2	applied	\N	\N	1000000000	\N	77509	77509	245633
5837	4509	3	applied	\N	\N	\N	\N	77510	77510	245634
5837	4510	4	applied	\N	\N	\N	\N	77511	77511	245635
5846	4516	0	applied	\N	\N	\N	\N	77533	77533	245657
5851	4518	0	applied	\N	\N	\N	\N	77538	77538	245662
5853	4520	0	applied	\N	\N	\N	\N	77540	77540	245664
5853	4521	1	applied	\N	\N	\N	\N	77541	77541	245665
5863	4525	0	applied	\N	\N	\N	\N	77546	77546	245670
5863	4526	1	applied	\N	\N	\N	\N	77547	77547	245671
5866	4497	28	applied	\N	\N	\N	\N	77580	77580	245704
5866	4498	29	applied	\N	\N	\N	\N	77581	77581	245705
5866	4499	30	applied	\N	\N	\N	\N	77582	77582	245706
5866	4500	31	applied	\N	\N	\N	\N	77583	77583	245707
5866	4501	32	applied	\N	\N	\N	\N	77584	77584	245708
5866	4502	33	applied	\N	\N	\N	\N	77585	77585	245709
5866	4503	34	applied	\N	\N	\N	\N	77586	77586	245710
5866	4504	35	applied	\N	\N	\N	\N	77587	77587	245711
5866	4505	36	applied	\N	\N	\N	\N	77588	77588	245712
5866	4506	37	applied	\N	\N	\N	\N	77589	77589	245713
5866	4510	39	applied	\N	\N	\N	\N	77591	77591	245715
5866	4511	40	applied	\N	\N	\N	\N	77592	77592	245716
5866	4512	41	applied	\N	\N	\N	\N	77593	77593	245717
5866	4513	42	applied	\N	\N	\N	\N	77594	77594	245718
5866	4514	43	applied	\N	\N	\N	\N	77595	77595	245719
5873	4535	0	applied	\N	\N	\N	\N	77620	77620	245744
5873	4536	1	applied	\N	\N	\N	\N	77621	77621	245745
5875	4537	0	applied	\N	\N	\N	\N	77624	77624	245748
5891	4545	0	applied	\N	\N	\N	\N	77636	77636	245760
5891	4546	1	applied	\N	\N	\N	\N	77637	77637	245761
5891	4547	2	applied	\N	\N	\N	\N	77638	77638	245762
5891	4548	3	applied	\N	\N	\N	\N	77639	77639	245763
5891	4549	4	applied	\N	\N	\N	\N	77640	77640	245764
5895	4550	0	applied	\N	\N	\N	\N	77652	77652	245776
5900	4557	0	applied	\N	\N	\N	\N	77661	77661	245785
5901	4558	0	applied	\N	\N	\N	\N	77662	77662	245786
5908	4562	1	applied	\N	\N	\N	\N	77669	77669	245793
5911	4564	0	applied	\N	\N	\N	\N	77672	77672	245796
5915	4567	0	applied	\N	\N	\N	\N	77675	77675	245799
5915	4568	1	applied	\N	\N	\N	\N	77676	77676	245800
5771	4452	0	applied	\N	\N	\N	\N	77364	77364	245488
5779	4463	0	applied	\N	\N	\N	\N	77375	77375	245499
5866	4518	47	applied	\N	\N	\N	\N	77599	77599	245723
5866	4519	48	applied	\N	\N	\N	\N	77600	77600	245724
5866	4520	49	applied	\N	\N	\N	\N	77601	77601	245725
5866	4521	50	applied	\N	\N	\N	\N	77602	77602	245726
5866	4523	53	applied	\N	\N	\N	\N	77604	77604	245728
5866	4524	54	applied	\N	\N	\N	\N	77605	77605	245729
5866	4525	55	applied	\N	\N	\N	\N	77606	77606	245730
5870	4530	0	applied	\N	\N	\N	\N	77615	77615	245739
5870	4531	1	applied	\N	\N	\N	\N	77616	77616	245740
5874	4535	0	applied	\N	\N	\N	\N	77622	77622	245746
5874	4536	1	applied	\N	\N	\N	\N	77623	77623	245747
5876	4538	0	applied	\N	\N	\N	\N	77625	77625	245749
5878	4538	0	applied	\N	\N	\N	\N	77627	77627	245751
5892	4545	0	applied	\N	\N	\N	\N	77641	77641	245765
5892	4546	1	applied	\N	\N	\N	\N	77642	77642	245766
5892	4547	2	applied	\N	\N	\N	\N	77643	77643	245767
5892	4548	3	applied	\N	\N	\N	\N	77644	77644	245768
5892	4549	4	applied	\N	\N	\N	\N	77645	77645	245769
5897	4556	0	applied	\N	\N	\N	\N	77658	77658	245782
5902	4559	0	applied	\N	\N	\N	\N	77663	77663	245787
5907	4560	0	applied	\N	\N	\N	\N	77667	77667	245791
5909	4563	0	applied	\N	\N	\N	\N	77670	77670	245794
5913	4565	0	applied	\N	\N	\N	\N	77673	77673	245797
5914	4566	0	applied	\N	\N	\N	\N	77674	77674	245798
5915	4569	2	applied	\N	\N	\N	\N	77677	77677	245801
5916	4567	0	applied	\N	\N	\N	\N	77678	77678	245802
5916	4568	1	applied	\N	\N	\N	\N	77679	77679	245803
5916	4569	2	applied	\N	\N	\N	\N	77680	77680	245804
5919	4567	0	applied	\N	\N	\N	\N	77687	77687	245811
5919	4568	1	applied	\N	\N	\N	\N	77688	77688	245812
5919	4569	2	applied	\N	\N	\N	\N	77689	77689	245813
5920	4570	0	applied	\N	\N	\N	\N	77690	77690	245814
5923	4570	0	applied	\N	\N	\N	\N	77693	77693	245817
5927	4572	0	applied	\N	\N	\N	\N	77697	77697	245821
5928	4573	0	applied	\N	\N	\N	\N	77698	77698	245822
5928	4574	1	applied	\N	\N	\N	\N	77699	77699	245823
5931	4576	1	applied	\N	\N	\N	\N	77705	77705	245829
5935	4578	0	applied	\N	\N	\N	\N	77736	77736	245860
5938	4580	0	applied	\N	\N	\N	\N	77739	77739	245863
5940	4582	0	applied	\N	\N	\N	\N	77741	77741	245865
5940	4583	1	applied	\N	\N	\N	\N	77742	77742	245866
5940	4584	2	applied	\N	\N	\N	\N	77743	77743	245867
5943	4585	0	applied	\N	\N	\N	\N	77750	77750	245874
5946	4589	0	applied	\N	\N	\N	\N	77754	77754	245878
5946	4590	1	applied	\N	\N	\N	\N	77755	77755	245879
5949	4591	0	applied	\N	\N	\N	\N	77759	77759	245883
5951	4592	0	applied	\N	\N	\N	\N	77761	77761	245885
5953	4593	0	applied	\N	\N	\N	\N	77763	77763	245887
5954	4594	0	applied	\N	\N	\N	\N	77764	77764	245888
5954	4595	1	applied	\N	\N	\N	\N	77765	77765	245889
5956	4597	0	applied	\N	\N	\N	\N	77767	77767	245891
5962	4607	0	applied	\N	\N	\N	\N	77778	77778	245902
5967	4610	1	applied	\N	\N	\N	\N	77784	77784	245908
5970	4613	0	applied	\N	\N	\N	\N	77789	77789	245913
5970	4614	1	applied	\N	\N	\N	\N	77790	77790	245914
5972	4615	0	applied	\N	\N	\N	\N	77793	77793	245917
5977	4619	0	applied	\N	\N	\N	\N	77798	77798	245922
5982	4620	0	applied	\N	\N	\N	\N	77804	77804	245928
5982	4621	1	applied	\N	\N	\N	\N	77805	77805	245929
5985	4623	0	applied	\N	\N	\N	\N	77809	77809	245933
5985	4624	1	applied	\N	\N	\N	\N	77810	77810	245934
5987	4625	0	applied	\N	\N	\N	\N	77813	77813	245937
5992	4628	0	applied	\N	\N	\N	\N	77818	77818	245942
5998	4636	0	applied	\N	\N	\N	\N	77835	77835	245959
6005	4643	0	applied	\N	\N	\N	\N	77848	77848	245968
6008	4646	0	applied	\N	\N	\N	\N	77852	77852	245972
6010	4508	1	applied	\N	\N	1000000000	\N	77855	77855	245975
6010	4542	2	applied	\N	\N	1000000000	\N	77856	77856	245976
6010	4543	3	applied	\N	\N	1000000000	\N	77857	77857	245977
6010	4544	4	applied	\N	\N	1000000000	\N	77858	77858	245978
6010	4602	7	applied	\N	\N	\N	\N	77861	77861	245979
6010	4638	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	77859	77859	\N
6010	4639	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	77860	77860	\N
6010	4603	8	applied	\N	\N	\N	\N	77862	77862	245980
6010	4604	9	applied	\N	\N	\N	\N	77863	77863	245981
6012	4647	0	applied	\N	\N	\N	\N	77865	77865	245983
6015	4648	0	applied	\N	\N	\N	\N	77868	77868	245986
6022	4655	0	applied	\N	\N	\N	\N	77877	77877	245994
6022	4656	1	applied	\N	\N	\N	\N	77878	77878	245995
6025	4657	0	applied	\N	\N	\N	\N	77883	77883	246000
6025	4658	1	applied	\N	\N	\N	\N	77884	77884	246001
6025	4659	2	applied	\N	\N	\N	\N	77885	77885	246002
6025	4660	3	applied	\N	\N	\N	\N	77886	77886	246003
6025	4661	4	applied	\N	\N	1000000000	\N	77887	77887	246004
6028	4663	0	applied	\N	\N	\N	\N	77890	77890	246007
6028	4664	1	applied	\N	\N	\N	\N	77891	77891	246008
6030	4663	0	applied	\N	\N	\N	\N	77896	77896	246013
6030	4664	1	applied	\N	\N	\N	\N	77897	77897	246014
6030	4665	2	applied	\N	\N	\N	\N	77898	77898	246015
6033	4670	0	applied	\N	\N	\N	\N	77903	77903	246020
6035	4671	0	applied	\N	\N	1000000000	\N	77905	77905	246022
6035	4672	1	applied	\N	\N	\N	\N	77906	77906	246023
6035	4673	2	applied	\N	\N	\N	\N	77907	77907	246024
6038	4677	0	applied	\N	\N	\N	\N	77911	77911	246028
6038	4678	1	applied	\N	\N	\N	\N	77912	77912	246029
6043	4684	0	applied	\N	\N	\N	\N	77919	77919	246036
6048	4687	0	applied	\N	\N	\N	\N	77924	77924	246041
6053	4690	0	applied	\N	\N	\N	\N	77937	77937	246051
6055	4692	0	applied	\N	\N	\N	\N	77939	77939	246053
6060	4695	0	applied	\N	\N	\N	\N	77945	77945	246059
6060	4696	1	applied	\N	\N	\N	\N	77946	77946	246060
6068	4702	0	applied	\N	\N	\N	\N	77960	77960	246074
6071	4704	0	applied	\N	\N	\N	\N	77964	77964	246078
6075	4707	0	applied	\N	\N	\N	\N	77968	77968	246082
6075	4708	1	applied	\N	\N	\N	\N	77969	77969	246083
6077	4707	0	applied	\N	\N	\N	\N	77972	77972	246086
6077	4708	1	applied	\N	\N	\N	\N	77973	77973	246087
6082	4709	0	applied	\N	\N	\N	\N	77981	77981	246095
5866	4516	45	applied	\N	\N	\N	\N	77597	77597	245721
5866	4517	46	applied	\N	\N	\N	\N	77598	77598	245722
5959	4604	4	applied	\N	\N	\N	\N	77775	77775	245899
5966	4608	0	applied	\N	\N	\N	\N	77782	77782	245906
5969	4611	0	applied	\N	\N	\N	\N	77787	77787	245911
5969	4612	1	applied	\N	\N	\N	\N	77788	77788	245912
5974	4616	0	applied	\N	\N	\N	\N	77795	77795	245919
5979	4619	0	applied	\N	\N	\N	\N	77800	77800	245924
5981	4620	0	applied	\N	\N	\N	\N	77802	77802	245926
5981	4621	1	applied	\N	\N	\N	\N	77803	77803	245927
5984	4623	0	applied	\N	\N	\N	\N	77807	77807	245931
5984	4624	1	applied	\N	\N	\N	\N	77808	77808	245932
5986	4623	0	applied	\N	\N	\N	\N	77811	77811	245935
5986	4624	1	applied	\N	\N	\N	\N	77812	77812	245936
5991	4627	0	applied	\N	\N	\N	\N	77817	77817	245941
5994	4629	0	applied	\N	\N	\N	\N	77821	77821	245945
5995	4629	0	applied	\N	\N	\N	\N	77823	77823	245947
5995	4630	1	applied	\N	\N	\N	\N	77824	77824	245948
5996	4633	2	applied	\N	\N	\N	\N	77827	77827	245951
5996	4634	3	applied	\N	\N	\N	\N	77828	77828	245952
5996	4635	4	applied	\N	\N	\N	\N	77829	77829	245953
5997	4631	0	applied	\N	\N	\N	\N	77830	77830	245954
5997	4632	1	applied	\N	\N	\N	\N	77831	77831	245955
5997	4633	2	applied	\N	\N	\N	\N	77832	77832	245956
5997	4634	3	applied	\N	\N	\N	\N	77833	77833	245957
5997	4635	4	applied	\N	\N	\N	\N	77834	77834	245958
5999	4637	0	applied	\N	\N	\N	\N	77836	77836	245960
6000	4637	0	applied	\N	\N	\N	\N	77840	77840	245962
6000	4640	3	applied	\N	\N	\N	\N	77843	77843	245963
6000	4639	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	77842	77842	\N
6002	4641	0	applied	\N	\N	\N	\N	77845	77845	245965
6004	4642	0	applied	\N	\N	\N	\N	77847	77847	245967
6006	4643	0	applied	\N	\N	\N	\N	77849	77849	245969
6007	4644	0	applied	\N	\N	\N	\N	77850	77850	245970
6007	4645	1	applied	\N	\N	\N	\N	77851	77851	245971
6009	4646	0	applied	\N	\N	\N	\N	77853	77853	245973
6011	4647	0	applied	\N	\N	\N	\N	77864	77864	245982
6014	4648	0	applied	\N	\N	\N	\N	77867	77867	245985
6016	4649	0	applied	\N	\N	\N	\N	77869	77869	245987
6018	4650	0	applied	\N	\N	\N	\N	77871	77871	245989
6019	4650	0	applied	\N	\N	\N	\N	77872	77872	245990
6020	4651	0	applied	\N	\N	\N	\N	77873	77873	245991
6021	4653	1	applied	\N	\N	\N	\N	77875	77875	245992
6021	4652	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	77874	77874	\N
6021	4654	2	applied	\N	\N	\N	\N	77876	77876	245993
6024	4655	0	applied	\N	\N	\N	\N	77881	77881	245998
6024	4656	1	applied	\N	\N	\N	\N	77882	77882	245999
6027	4662	0	applied	\N	\N	\N	\N	77889	77889	246006
6029	4663	0	applied	\N	\N	\N	\N	77893	77893	246010
6029	4664	1	applied	\N	\N	\N	\N	77894	77894	246011
6029	4665	2	applied	\N	\N	\N	\N	77895	77895	246012
6032	4669	0	applied	\N	\N	\N	\N	77902	77902	246019
6037	4675	0	applied	\N	\N	\N	\N	77909	77909	246026
6037	4676	1	applied	\N	\N	\N	\N	77910	77910	246027
6039	4679	0	applied	\N	\N	\N	\N	77913	77913	246030
6040	4679	0	applied	\N	\N	\N	\N	77914	77914	246031
6042	4683	1	applied	\N	\N	\N	\N	77918	77918	246035
6045	4686	0	applied	\N	\N	\N	\N	77921	77921	246038
6047	4687	0	applied	\N	\N	\N	\N	77923	77923	246040
6050	4688	0	applied	\N	\N	\N	\N	77927	77927	246044
6050	4689	1	applied	\N	\N	\N	\N	77928	77928	246045
6052	4690	0	applied	\N	\N	\N	\N	77936	77936	246050
6054	4691	0	applied	\N	\N	\N	\N	77938	77938	246052
6057	4692	0	applied	\N	\N	\N	\N	77941	77941	246055
6058	4692	0	applied	\N	\N	\N	\N	77942	77942	246056
6059	4693	0	applied	\N	\N	\N	\N	77943	77943	246057
6059	4694	1	applied	\N	\N	\N	\N	77944	77944	246058
6062	4695	0	applied	\N	\N	\N	\N	77949	77949	246063
6062	4696	1	applied	\N	\N	\N	\N	77950	77950	246064
6064	4697	0	applied	\N	\N	\N	\N	77952	77952	246066
6067	4699	0	applied	\N	\N	\N	\N	77957	77957	246071
6067	4700	1	applied	\N	\N	\N	\N	77958	77958	246072
6069	4704	0	applied	\N	\N	\N	\N	77962	77962	246076
6070	4704	0	applied	\N	\N	\N	\N	77963	77963	246077
6072	4705	0	applied	\N	\N	\N	\N	77965	77965	246079
6074	4706	0	applied	\N	\N	\N	\N	77967	77967	246081
6079	4709	0	applied	\N	\N	\N	\N	77976	77976	246090
6079	4710	1	applied	\N	\N	\N	\N	77977	77977	246091
6081	4709	0	applied	\N	\N	\N	\N	77979	77979	246093
6081	4710	1	applied	\N	\N	\N	\N	77980	77980	246094
6082	4710	1	applied	\N	\N	\N	\N	77982	77982	246096
6085	4711	0	applied	\N	\N	\N	\N	77983	77983	246097
6086	4711	0	applied	\N	\N	\N	\N	77984	77984	246098
6088	4712	0	applied	\N	\N	\N	\N	77986	77986	246100
6090	4713	0	applied	\N	\N	\N	\N	77988	77988	246102
6090	4714	1	applied	\N	\N	\N	\N	77989	77989	246103
6091	4714	0	applied	\N	\N	\N	\N	77990	77990	246104
6091	4715	1	applied	\N	\N	\N	\N	77991	77991	246105
6092	4714	0	applied	\N	\N	\N	\N	77993	77993	246107
6092	4715	1	applied	\N	\N	\N	\N	77994	77994	246108
6092	4716	2	applied	\N	\N	\N	\N	77995	77995	246109
6093	4714	0	applied	\N	\N	\N	\N	77996	77996	246110
6093	4715	1	applied	\N	\N	\N	\N	77997	77997	246111
6093	4716	2	applied	\N	\N	\N	\N	77998	77998	246112
6094	4717	0	applied	\N	\N	\N	\N	77999	77999	246113
6094	4718	1	applied	\N	\N	\N	\N	78000	78000	246114
6094	4719	2	applied	\N	\N	\N	\N	78001	78001	246115
6096	4720	0	applied	\N	\N	\N	\N	78005	78005	246119
6096	4721	1	applied	\N	\N	\N	\N	78006	78006	246120
6097	4722	0	applied	\N	\N	\N	\N	78007	78007	246121
6097	4723	1	applied	\N	\N	\N	\N	78008	78008	246122
6099	4722	0	applied	\N	\N	\N	\N	78011	78011	246125
6099	4723	1	applied	\N	\N	\N	\N	78012	78012	246126
6101	4724	0	applied	\N	\N	\N	\N	78014	78014	246128
6105	4668	1	applied	\N	\N	1000000000	\N	78019	78019	246132
6105	4652	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78018	78018	\N
6105	4661	2	applied	\N	\N	1000000000	\N	78020	78020	246133
6105	4666	3	applied	\N	\N	\N	\N	78021	78021	246134
6105	4677	4	applied	\N	\N	\N	\N	78022	78022	246135
6166	4761	0	applied	\N	\N	\N	\N	78094	78094	246207
5959	4602	2	applied	\N	\N	\N	\N	77773	77773	245897
5959	4603	3	applied	\N	\N	\N	\N	77774	77774	245898
6001	4641	0	applied	\N	\N	\N	\N	77844	77844	245964
6003	4641	0	applied	\N	\N	\N	\N	77846	77846	245966
6013	4648	0	applied	\N	\N	\N	\N	77866	77866	245984
6017	4649	0	applied	\N	\N	\N	\N	77870	77870	245988
6023	4655	0	applied	\N	\N	\N	\N	77879	77879	245996
6023	4656	1	applied	\N	\N	\N	\N	77880	77880	245997
6026	4662	0	applied	\N	\N	\N	\N	77888	77888	246005
6031	4666	0	applied	\N	\N	\N	\N	77899	77899	246016
6031	4667	1	applied	\N	\N	\N	\N	77900	77900	246017
6031	4668	2	applied	\N	\N	1000000000	\N	77901	77901	246018
6034	4670	0	applied	\N	\N	\N	\N	77904	77904	246021
6036	4674	0	applied	\N	\N	\N	\N	77908	77908	246025
6041	4680	0	applied	\N	\N	\N	\N	77915	77915	246032
6041	4681	1	applied	\N	\N	\N	\N	77916	77916	246033
6044	4685	0	applied	\N	\N	\N	\N	77920	77920	246037
6046	4686	0	applied	\N	\N	\N	\N	77922	77922	246039
6049	4689	1	applied	\N	\N	\N	\N	77926	77926	246043
6051	4668	3	applied	\N	\N	1000000000	\N	77932	77932	246046
6051	4638	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	77929	77929	\N
6051	4639	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77930	77930	\N
6051	4652	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	77931	77931	\N
6051	4661	4	applied	\N	\N	1000000000	\N	77933	77933	246047
6051	4666	5	applied	\N	\N	\N	\N	77934	77934	246048
6051	4677	6	applied	\N	\N	\N	\N	77935	77935	246049
6056	4692	0	applied	\N	\N	\N	\N	77940	77940	246054
6061	4695	0	applied	\N	\N	\N	\N	77947	77947	246061
6061	4696	1	applied	\N	\N	\N	\N	77948	77948	246062
6063	4697	0	applied	\N	\N	\N	\N	77951	77951	246065
6065	4698	0	applied	\N	\N	\N	\N	77953	77953	246067
6066	4699	0	applied	\N	\N	\N	\N	77954	77954	246068
6066	4700	1	applied	\N	\N	\N	\N	77955	77955	246069
6066	4701	2	applied	\N	\N	\N	\N	77956	77956	246070
6076	4707	0	applied	\N	\N	\N	\N	77970	77970	246084
6076	4708	1	applied	\N	\N	\N	\N	77971	77971	246085
6078	4707	0	applied	\N	\N	\N	\N	77974	77974	246088
6078	4708	1	applied	\N	\N	\N	\N	77975	77975	246089
6080	4709	0	applied	\N	\N	\N	\N	77978	77978	246092
6087	4712	0	applied	\N	\N	\N	\N	77985	77985	246099
6089	4713	0	applied	\N	\N	\N	\N	77987	77987	246101
6095	4717	0	applied	\N	\N	\N	\N	78002	78002	246116
6095	4718	1	applied	\N	\N	\N	\N	78003	78003	246117
6095	4719	2	applied	\N	\N	\N	\N	78004	78004	246118
6098	4722	0	applied	\N	\N	\N	\N	78009	78009	246123
6098	4723	1	applied	\N	\N	\N	\N	78010	78010	246124
6100	4724	0	applied	\N	\N	\N	\N	78013	78013	246127
6102	4725	0	applied	\N	\N	\N	\N	78015	78015	246129
6104	4725	0	applied	\N	\N	\N	\N	78017	78017	246131
6106	4725	0	applied	\N	\N	\N	\N	78023	78023	246136
6107	4727	1	applied	\N	\N	1000000000	\N	78025	78025	246138
6107	4728	2	applied	\N	\N	\N	\N	78026	78026	246139
6107	4729	3	applied	\N	\N	\N	\N	78027	78027	246140
6108	4726	0	applied	\N	\N	1000000000	\N	78028	78028	246141
6108	4727	1	applied	\N	\N	1000000000	\N	78029	78029	246142
6108	4728	2	applied	\N	\N	\N	\N	78030	78030	246143
6108	4729	3	applied	\N	\N	\N	\N	78031	78031	246144
6109	4726	0	applied	\N	\N	1000000000	\N	78032	78032	246145
6109	4727	1	applied	\N	\N	1000000000	\N	78033	78033	246146
6109	4728	2	applied	\N	\N	\N	\N	78034	78034	246147
6109	4729	3	applied	\N	\N	\N	\N	78035	78035	246148
6110	4730	0	applied	\N	\N	\N	\N	78036	78036	246149
6111	4730	0	applied	\N	\N	\N	\N	78037	78037	246150
6112	4730	0	applied	\N	\N	\N	\N	78038	78038	246151
6113	4731	0	applied	\N	\N	\N	\N	78039	78039	246152
6114	4731	0	applied	\N	\N	\N	\N	78040	78040	246153
6115	4732	0	applied	\N	\N	\N	\N	78041	78041	246154
6116	4732	0	applied	\N	\N	\N	\N	78042	78042	246155
6118	4734	1	applied	\N	\N	\N	\N	78044	78044	246157
6118	4735	2	applied	\N	\N	\N	\N	78045	78045	246158
6119	4736	0	applied	\N	\N	\N	\N	78046	78046	246159
6120	4736	0	applied	\N	\N	\N	\N	78047	78047	246160
6121	4736	0	applied	\N	\N	\N	\N	78048	78048	246161
6122	4737	0	applied	\N	\N	\N	\N	78049	78049	246162
6123	4738	0	applied	\N	\N	1000000000	\N	78050	78050	246163
6123	4739	1	applied	\N	\N	\N	\N	78051	78051	246164
6125	4740	0	applied	\N	\N	\N	\N	78052	78052	246165
6125	4741	1	applied	\N	\N	\N	\N	78053	78053	246166
6125	4742	2	applied	\N	\N	\N	\N	78054	78054	246167
6126	4743	0	applied	\N	\N	\N	\N	78055	78055	246168
6127	4743	0	applied	\N	\N	\N	\N	78056	78056	246169
6128	4743	0	applied	\N	\N	\N	\N	78057	78057	246170
6129	4744	0	applied	\N	\N	\N	\N	78058	78058	246171
6130	4744	0	applied	\N	\N	\N	\N	78059	78059	246172
6131	4745	1	applied	\N	\N	\N	\N	78061	78061	246174
6132	4744	0	applied	\N	\N	\N	\N	78062	78062	246175
6133	4745	0	applied	\N	\N	\N	\N	78063	78063	246176
6134	4745	0	applied	\N	\N	\N	\N	78064	78064	246177
6135	4746	0	applied	\N	\N	\N	\N	78065	78065	246178
6136	4747	0	applied	\N	\N	\N	\N	78066	78066	246179
6137	4747	0	applied	\N	\N	\N	\N	78067	78067	246180
6138	4747	0	applied	\N	\N	\N	\N	78068	78068	246181
6139	4748	0	applied	\N	\N	\N	\N	78069	78069	246182
6140	4749	0	applied	\N	\N	\N	\N	78070	78070	246183
6141	4749	0	applied	\N	\N	\N	\N	78071	78071	246184
6142	4749	0	applied	\N	\N	\N	\N	78072	78072	246185
6144	4750	0	applied	\N	\N	\N	\N	78073	78073	246186
6145	4750	0	applied	\N	\N	\N	\N	78074	78074	246187
6150	4751	0	applied	\N	\N	\N	\N	78075	78075	246188
6150	4752	1	applied	\N	\N	\N	\N	78076	78076	246189
6152	4753	0	applied	\N	\N	\N	\N	78078	78078	246191
6153	4754	0	applied	\N	\N	\N	\N	78079	78079	246192
6154	4754	0	applied	\N	\N	\N	\N	78080	78080	246193
6155	4754	0	applied	\N	\N	\N	\N	78081	78081	246194
6156	4755	0	applied	\N	\N	\N	\N	78082	78082	246195
6157	4755	0	applied	\N	\N	\N	\N	78083	78083	246196
6159	4756	0	applied	\N	\N	\N	\N	78085	78085	246198
6162	4757	0	applied	\N	\N	\N	\N	78088	78088	246201
6164	4761	0	applied	\N	\N	\N	\N	78092	78092	246205
5999	4640	3	applied	\N	\N	\N	\N	77839	77839	245961
6163	4760	2	applied	\N	\N	\N	\N	78091	78091	246204
6168	4762	0	applied	\N	\N	\N	\N	78096	78096	246209
6169	4762	0	applied	\N	\N	\N	\N	78097	78097	246210
6174	4766	1	applied	\N	\N	\N	\N	78106	78106	246219
6174	4767	2	applied	\N	\N	\N	\N	78107	78107	246220
6174	4768	3	applied	\N	\N	\N	\N	78108	78108	246221
6176	4769	0	applied	\N	\N	\N	\N	78113	78113	246226
6177	4770	0	applied	\N	\N	\N	\N	78114	78114	246227
6177	4771	1	applied	\N	\N	\N	\N	78115	78115	246228
6177	4772	2	applied	\N	\N	\N	\N	78116	78116	246229
6177	4773	3	applied	\N	\N	\N	\N	78117	78117	246230
6177	4774	4	applied	\N	\N	\N	\N	78118	78118	246231
6182	4776	0	applied	\N	\N	\N	\N	78131	78131	246244
6182	4777	1	applied	\N	\N	\N	\N	78132	78132	246245
6184	4776	0	applied	\N	\N	\N	\N	78135	78135	246248
6184	4777	1	applied	\N	\N	\N	\N	78136	78136	246249
6187	4783	0	applied	\N	\N	\N	\N	78142	78142	246255
6187	4784	1	applied	\N	\N	\N	\N	78143	78143	246256
6187	4785	2	applied	\N	\N	\N	\N	78144	78144	246257
6194	4790	0	applied	\N	\N	\N	\N	78155	78155	246268
6197	4791	0	applied	\N	\N	\N	\N	78158	78158	246271
6206	4803	0	applied	\N	\N	\N	\N	78186	78186	246299
6206	4804	1	applied	\N	\N	\N	\N	78187	78187	246300
6210	4806	0	applied	\N	\N	\N	\N	78192	78192	246305
6213	4807	0	applied	\N	\N	\N	\N	78198	78198	246311
6213	4808	1	applied	\N	\N	\N	\N	78199	78199	246312
6213	4809	2	applied	\N	\N	\N	\N	78200	78200	246313
6213	4810	3	applied	\N	\N	\N	\N	78201	78201	246314
6215	4811	0	applied	\N	\N	\N	\N	78206	78206	246319
6220	4815	0	applied	\N	\N	\N	\N	78215	78215	246326
6223	4822	0	applied	\N	\N	\N	\N	78222	78222	246333
6226	4822	0	applied	\N	\N	\N	\N	78225	78225	246336
6236	4830	0	applied	\N	\N	\N	\N	78271	78271	246380
6236	4831	1	applied	\N	\N	\N	\N	78272	78272	246381
6240	4832	0	applied	\N	\N	\N	\N	78279	78279	246388
6243	4835	0	applied	\N	\N	\N	\N	78284	78284	246393
6243	4836	1	applied	\N	\N	\N	\N	78285	78285	246394
6245	4837	0	applied	\N	\N	\N	\N	78287	78287	246396
6247	4839	0	applied	\N	\N	\N	\N	78289	78289	246398
6253	4847	0	applied	\N	\N	\N	\N	78300	78300	246409
6255	4848	0	applied	\N	\N	\N	\N	78303	78303	246412
6255	4849	1	applied	\N	\N	\N	\N	78304	78304	246413
6256	4850	0	applied	\N	\N	\N	\N	78305	78305	246414
6256	4851	1	applied	\N	\N	\N	\N	78306	78306	246415
6256	4852	2	applied	\N	\N	\N	\N	78307	78307	246416
6256	4853	3	applied	\N	\N	\N	\N	78308	78308	246417
6266	4861	0	applied	\N	\N	\N	\N	78320	78320	246429
6266	4862	1	applied	\N	\N	\N	\N	78321	78321	246430
6269	4866	0	applied	\N	\N	\N	\N	78325	78325	246434
6270	4867	0	applied	\N	\N	\N	\N	78326	78326	246435
6270	4868	1	applied	\N	\N	\N	\N	78327	78327	246436
6271	4870	0	applied	\N	\N	\N	\N	78329	78329	246438
6271	4871	1	applied	\N	\N	\N	\N	78330	78330	246439
6271	4872	2	applied	\N	\N	\N	\N	78331	78331	246440
6271	4873	3	applied	\N	\N	\N	\N	78332	78332	246441
6278	4874	0	applied	\N	\N	\N	\N	78351	78351	246460
6284	4877	0	applied	\N	\N	\N	\N	78357	78357	246466
6289	4881	0	applied	\N	\N	\N	\N	78362	78362	246471
6289	4882	1	applied	\N	\N	\N	\N	78363	78363	246472
6295	4884	0	applied	\N	\N	\N	\N	78369	78369	246478
6296	4885	0	applied	\N	\N	\N	\N	78370	78370	246479
6299	4885	0	applied	\N	\N	\N	\N	78373	78373	246482
6305	4889	0	applied	\N	\N	\N	\N	78380	78380	246489
6310	4895	0	applied	\N	\N	\N	\N	78397	78397	246506
6318	4903	0	applied	\N	\N	\N	\N	78410	78410	246519
6320	4903	0	applied	\N	\N	\N	\N	78412	78412	246521
6322	4904	0	applied	\N	\N	\N	\N	78414	78414	246523
6327	4907	0	applied	\N	\N	\N	\N	78419	78419	246528
6329	4908	0	applied	\N	\N	\N	\N	78421	78421	246530
6330	4909	0	applied	\N	\N	\N	\N	78422	78422	246531
6330	4910	1	applied	\N	\N	\N	\N	78423	78423	246532
6330	4911	2	applied	\N	\N	\N	\N	78424	78424	246533
6335	4913	0	applied	\N	\N	\N	\N	78430	78430	246539
6339	4778	0	applied	\N	\N	1000000000	\N	78435	78435	246544
6339	4542	1	applied	\N	\N	1000000000	\N	78436	78436	246545
6339	4543	2	applied	\N	\N	1000000000	\N	78437	78437	246546
6339	4726	3	applied	\N	\N	1000000000	\N	78438	78438	246547
6339	4779	4	applied	\N	\N	\N	\N	78439	78439	246548
6339	4544	5	applied	\N	\N	1000000000	\N	78440	78440	246549
6339	4738	6	applied	\N	\N	1000000000	\N	78441	78441	246550
6339	4816	7	applied	\N	\N	1000000000	\N	78442	78442	246551
6339	4891	9	applied	\N	\N	1000000000	\N	78444	78444	246553
6339	4783	10	applied	\N	\N	\N	\N	78445	78445	246554
6339	4784	11	applied	\N	\N	\N	\N	78446	78446	246555
6339	4787	12	applied	\N	\N	\N	\N	78447	78447	246556
6339	4807	13	applied	\N	\N	\N	\N	78448	78448	246557
6339	4813	14	applied	\N	\N	\N	\N	78449	78449	78449
6339	4539	15	applied	\N	\N	\N	\N	78450	78450	246558
6339	4727	16	applied	\N	\N	1000000000	\N	78451	78451	246559
6339	4602	19	applied	\N	\N	\N	\N	78454	78454	246560
6339	4638	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	78452	78452	\N
6339	4639	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	78453	78453	\N
6339	4668	21	applied	\N	\N	1000000000	\N	78456	78456	246561
6339	4652	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	78455	78455	\N
6339	4540	22	applied	\N	\N	\N	\N	78457	78457	246562
6339	4541	23	applied	\N	\N	\N	\N	78458	78458	246563
6339	4545	24	applied	\N	\N	\N	\N	78459	78459	246564
6339	4661	25	applied	\N	\N	1000000000	\N	78460	78460	246565
6339	4666	26	applied	\N	\N	\N	\N	78461	78461	246566
6339	4677	27	applied	\N	\N	\N	\N	78462	78462	246567
6339	4546	28	applied	\N	\N	\N	\N	78463	78463	246568
6339	4548	30	applied	\N	\N	\N	\N	78465	78465	246570
6339	4549	31	applied	\N	\N	\N	\N	78466	78466	246571
6339	4550	32	applied	\N	\N	\N	\N	78467	78467	246572
6339	4551	33	applied	\N	\N	\N	\N	78468	78468	246573
6339	4552	34	applied	\N	\N	\N	\N	78469	78469	246574
6339	4553	35	applied	\N	\N	\N	\N	78470	78470	246575
6163	4758	0	applied	\N	\N	\N	\N	78089	78089	246202
6163	4759	1	applied	\N	\N	\N	\N	78090	78090	246203
6172	4764	0	applied	\N	\N	\N	\N	78100	78100	246213
6173	4765	0	applied	\N	\N	\N	\N	78101	78101	246214
6173	4766	1	applied	\N	\N	\N	\N	78102	78102	246215
6173	4767	2	applied	\N	\N	\N	\N	78103	78103	246216
6173	4768	3	applied	\N	\N	\N	\N	78104	78104	246217
6178	4771	1	applied	\N	\N	\N	\N	78120	78120	246233
6178	4772	2	applied	\N	\N	\N	\N	78121	78121	246234
6179	4770	0	applied	\N	\N	\N	\N	78124	78124	246237
6179	4771	1	applied	\N	\N	\N	\N	78125	78125	246238
6179	4772	2	applied	\N	\N	\N	\N	78126	78126	246239
6179	4773	3	applied	\N	\N	\N	\N	78127	78127	246240
6179	4774	4	applied	\N	\N	\N	\N	78128	78128	246241
6181	4775	0	applied	\N	\N	\N	\N	78130	78130	246243
6186	4782	0	applied	\N	\N	\N	\N	78141	78141	246254
6188	4783	0	applied	\N	\N	\N	\N	78145	78145	246258
6188	4784	1	applied	\N	\N	\N	\N	78146	78146	246259
6188	4785	2	applied	\N	\N	\N	\N	78147	78147	246260
6190	4786	0	applied	\N	\N	\N	\N	78149	78149	246262
6198	4791	0	applied	\N	\N	\N	\N	78159	78159	246272
6203	4792	0	applied	\N	\N	\N	\N	78172	78172	246285
6203	4793	1	applied	\N	\N	\N	\N	78173	78173	246286
6203	4795	3	applied	\N	\N	\N	\N	78175	78175	246288
6203	4796	4	applied	\N	\N	\N	\N	78176	78176	246289
6203	4797	5	applied	\N	\N	\N	\N	78177	78177	246290
6203	4798	6	applied	\N	\N	\N	\N	78178	78178	246291
6203	4799	7	applied	\N	\N	\N	\N	78179	78179	246292
6203	4800	8	applied	\N	\N	\N	\N	78180	78180	246293
6203	4801	9	applied	\N	\N	\N	\N	78181	78181	246294
6207	4803	0	applied	\N	\N	\N	\N	78188	78188	246301
6207	4804	1	applied	\N	\N	\N	\N	78189	78189	246302
6208	4805	0	applied	\N	\N	\N	\N	78190	78190	246303
6218	4815	0	applied	\N	\N	\N	\N	78213	78213	246324
6224	4822	0	applied	\N	\N	\N	\N	78223	78223	246334
6228	4812	0	applied	\N	\N	\N	\N	78228	78228	246339
6228	4816	1	applied	\N	\N	1000000000	\N	78229	78229	246340
6228	4807	2	applied	\N	\N	\N	\N	78230	78230	246341
6228	4813	3	applied	\N	\N	\N	\N	78231	78231	78231
6228	4806	5	applied	\N	\N	\N	\N	78233	78233	246343
6228	4808	6	applied	\N	\N	\N	\N	78234	78234	246344
6228	4809	7	applied	\N	\N	\N	\N	78235	78235	246345
6228	4810	8	applied	\N	\N	\N	\N	78236	78236	246346
6228	4811	9	applied	\N	\N	\N	\N	78237	78237	246347
6228	4814	10	applied	\N	\N	\N	\N	78238	78238	246348
6228	4815	11	applied	\N	\N	\N	\N	78239	78239	246349
6228	4817	12	applied	\N	\N	\N	\N	78240	78240	246350
6228	4818	13	applied	\N	\N	\N	\N	78241	78241	246351
6228	4819	14	applied	\N	\N	\N	\N	78242	78242	246352
6228	4820	15	applied	\N	\N	\N	\N	78243	78243	246353
6228	4821	16	applied	\N	\N	\N	\N	78244	78244	246354
6228	4822	17	applied	\N	\N	\N	\N	78245	78245	246355
6228	4823	18	applied	\N	\N	\N	\N	78246	78246	246356
6228	4824	19	applied	\N	\N	\N	\N	78247	78247	246357
6231	4826	0	applied	\N	\N	\N	\N	78252	78252	246362
6231	4828	2	applied	\N	\N	\N	\N	78254	78254	246364
6233	4829	0	applied	\N	\N	\N	\N	78266	78266	246375
6248	4839	0	applied	\N	\N	\N	\N	78290	78290	246399
6250	4840	0	applied	\N	\N	\N	\N	78293	78293	246402
6250	4841	1	applied	\N	\N	\N	\N	78294	78294	246403
6259	4856	0	applied	\N	\N	\N	\N	78311	78311	246420
6260	4857	0	applied	\N	\N	\N	\N	78312	78312	246421
6260	4858	1	applied	\N	\N	\N	\N	78313	78313	246422
6262	4859	0	applied	\N	\N	\N	\N	78315	78315	246424
6264	4860	0	applied	\N	\N	\N	\N	78317	78317	246426
6267	4863	0	applied	\N	\N	\N	\N	78322	78322	246431
6272	4870	0	applied	\N	\N	\N	\N	78333	78333	246442
6272	4871	1	applied	\N	\N	\N	\N	78334	78334	246443
6272	4872	2	applied	\N	\N	\N	\N	78335	78335	246444
6272	4873	3	applied	\N	\N	\N	\N	78336	78336	246445
6280	4876	0	applied	\N	\N	\N	\N	78353	78353	246462
6287	4880	0	applied	\N	\N	\N	\N	78360	78360	246469
6290	4883	0	applied	\N	\N	\N	\N	78364	78364	246473
6292	4884	0	applied	\N	\N	\N	\N	78366	78366	246475
6300	4885	0	applied	\N	\N	\N	\N	78374	78374	246483
6306	4890	0	applied	\N	\N	1000000000	\N	78381	78381	246490
6306	4891	1	applied	\N	\N	1000000000	\N	78382	78382	246491
6306	4892	2	applied	\N	\N	\N	\N	78383	78383	246492
6306	4893	3	applied	\N	\N	\N	\N	78384	78384	246493
6306	4894	4	applied	\N	\N	\N	\N	78385	78385	246494
6308	4890	0	applied	\N	\N	1000000000	\N	78391	78391	246500
6308	4891	1	applied	\N	\N	1000000000	\N	78392	78392	246501
6308	4892	2	applied	\N	\N	\N	\N	78393	78393	246502
6308	4893	3	applied	\N	\N	\N	\N	78394	78394	246503
6308	4894	4	applied	\N	\N	\N	\N	78395	78395	246504
6311	4896	0	applied	\N	\N	\N	\N	78398	78398	246507
6311	4897	1	applied	\N	\N	\N	\N	78399	78399	246508
6314	4899	0	applied	\N	\N	\N	\N	78402	78402	246511
6314	4900	1	applied	\N	\N	\N	\N	78403	78403	246512
6314	4901	2	applied	\N	\N	\N	\N	78404	78404	246513
6316	4902	0	applied	\N	\N	\N	\N	78408	78408	246517
6319	4903	0	applied	\N	\N	\N	\N	78411	78411	246520
6323	4904	0	applied	\N	\N	\N	\N	78415	78415	246524
6333	4912	0	applied	\N	\N	\N	\N	78427	78427	246536
6337	4914	0	applied	\N	\N	\N	\N	78432	78432	246541
6344	4919	0	applied	\N	\N	\N	\N	78564	78564	246669
6347	4919	0	applied	\N	\N	\N	\N	78691	78691	246796
6348	4920	0	applied	\N	\N	\N	\N	78692	78692	246797
6351	4922	0	applied	\N	\N	\N	\N	78695	78695	246800
6351	4923	1	applied	\N	\N	\N	\N	78696	78696	246801
6353	4922	0	applied	\N	\N	\N	\N	78699	78699	246804
6353	4923	1	applied	\N	\N	\N	\N	78700	78700	246805
6356	4927	0	applied	\N	\N	\N	\N	78707	78707	246812
6359	4932	0	applied	\N	\N	\N	\N	78712	78712	246817
6362	4935	0	applied	\N	\N	\N	\N	78726	78726	246830
6369	4939	0	applied	\N	\N	\N	\N	78733	78733	246837
6376	4947	0	applied	\N	\N	\N	\N	78746	78746	246850
6377	4948	0	applied	\N	\N	\N	\N	78747	78747	246851
6380	4951	0	applied	\N	\N	1000000000	\N	78751	78751	246855
6380	4952	1	applied	\N	\N	\N	\N	78752	78752	246856
6380	4953	2	applied	\N	\N	\N	\N	78753	78753	246857
6167	4762	0	applied	\N	\N	\N	\N	78095	78095	246208
6170	4763	0	applied	\N	\N	\N	\N	78098	78098	246211
6175	4765	0	applied	\N	\N	\N	\N	78109	78109	246222
6175	4766	1	applied	\N	\N	\N	\N	78110	78110	246223
6178	4774	4	applied	\N	\N	\N	\N	78123	78123	246236
6191	4786	0	applied	\N	\N	\N	\N	78150	78150	246263
6192	4786	0	applied	\N	\N	\N	\N	78151	78151	246264
6195	4791	0	applied	\N	\N	\N	\N	78156	78156	246269
6200	4791	0	applied	\N	\N	\N	\N	78161	78161	246274
6204	4802	0	applied	\N	\N	\N	\N	78182	78182	246295
6209	4806	0	applied	\N	\N	\N	\N	78191	78191	246304
6211	4806	0	applied	\N	\N	\N	\N	78193	78193	246306
6214	4807	0	applied	\N	\N	\N	\N	78202	78202	246315
6214	4808	1	applied	\N	\N	\N	\N	78203	78203	246316
6214	4809	2	applied	\N	\N	\N	\N	78204	78204	246317
6214	4810	3	applied	\N	\N	\N	\N	78205	78205	246318
6216	4812	0	applied	\N	\N	\N	\N	78207	78207	246320
6216	4813	1	applied	\N	\N	\N	\N	78208	78208	78208
6216	4814	2	applied	\N	\N	\N	\N	78209	78209	246321
6219	4815	0	applied	\N	\N	\N	\N	78214	78214	246325
6221	4817	1	applied	\N	\N	\N	\N	78217	78217	246328
6221	4818	2	applied	\N	\N	\N	\N	78218	78218	246329
6221	4819	3	applied	\N	\N	\N	\N	78219	78219	246330
6225	4822	0	applied	\N	\N	\N	\N	78224	78224	246335
6232	4778	0	applied	\N	\N	1000000000	\N	78255	78255	246365
6232	4738	1	applied	\N	\N	1000000000	\N	78256	78256	246366
6232	4816	2	applied	\N	\N	1000000000	\N	78257	78257	246367
6232	4726	3	applied	\N	\N	1000000000	\N	78258	78258	246368
6232	4779	4	applied	\N	\N	\N	\N	78259	78259	246369
6232	4783	5	applied	\N	\N	\N	\N	78260	78260	246370
6232	4784	6	applied	\N	\N	\N	\N	78261	78261	246371
6232	4787	7	applied	\N	\N	\N	\N	78262	78262	246372
6232	4807	8	applied	\N	\N	\N	\N	78263	78263	246373
6232	4813	9	applied	\N	\N	\N	\N	78264	78264	78264
6232	4727	10	applied	\N	\N	1000000000	\N	78265	78265	246374
6234	4830	0	applied	\N	\N	\N	\N	78267	78267	246376
6234	4831	1	applied	\N	\N	\N	\N	78268	78268	246377
6237	4830	0	applied	\N	\N	\N	\N	78273	78273	246382
6241	4834	0	applied	\N	\N	\N	\N	78281	78281	246390
6246	4838	0	applied	\N	\N	\N	\N	78288	78288	246397
6251	4842	0	applied	\N	\N	\N	\N	78295	78295	246404
6254	4848	0	applied	\N	\N	\N	\N	78301	78301	246410
6254	4849	1	applied	\N	\N	\N	\N	78302	78302	246411
6257	4854	0	applied	\N	\N	\N	\N	78309	78309	246418
6263	4859	0	applied	\N	\N	\N	\N	78316	78316	246425
6265	4861	0	applied	\N	\N	\N	\N	78318	78318	246427
6265	4862	1	applied	\N	\N	\N	\N	78319	78319	246428
6268	4864	0	applied	\N	\N	\N	\N	78323	78323	246432
6268	4865	1	applied	\N	\N	\N	\N	78324	78324	246433
6273	4870	0	applied	\N	\N	\N	\N	78337	78337	246446
6273	4871	1	applied	\N	\N	\N	\N	78338	78338	246447
6273	4872	2	applied	\N	\N	\N	\N	78339	78339	246448
6273	4873	3	applied	\N	\N	\N	\N	78340	78340	246449
6275	4870	0	applied	\N	\N	\N	\N	78345	78345	246454
6275	4872	2	applied	\N	\N	\N	\N	78347	78347	246456
6275	4873	3	applied	\N	\N	\N	\N	78348	78348	246457
6276	4874	0	applied	\N	\N	\N	\N	78349	78349	246458
6281	4876	0	applied	\N	\N	\N	\N	78354	78354	246463
6283	4877	0	applied	\N	\N	\N	\N	78356	78356	246465
6285	4878	0	applied	\N	\N	\N	\N	78358	78358	246467
6293	4884	0	applied	\N	\N	\N	\N	78367	78367	246476
6297	4885	0	applied	\N	\N	\N	\N	78371	78371	246480
6301	4886	0	applied	\N	\N	\N	\N	78375	78375	246484
6303	4846	0	applied	\N	\N	1000000000	\N	78377	78377	246486
6309	4895	0	applied	\N	\N	\N	\N	78396	78396	246505
6317	4902	0	applied	\N	\N	\N	\N	78409	78409	246518
6321	4904	0	applied	\N	\N	\N	\N	78413	78413	246522
6328	4907	0	applied	\N	\N	\N	\N	78420	78420	246529
6331	4912	0	applied	\N	\N	\N	\N	78425	78425	246534
6336	4913	0	applied	\N	\N	\N	\N	78431	78431	246540
6338	4916	1	applied	\N	\N	\N	\N	78434	78434	246543
6340	4917	0	applied	\N	\N	\N	\N	78560	78560	246665
6342	4917	0	applied	\N	\N	\N	\N	78562	78562	246667
6349	4920	0	applied	\N	\N	\N	\N	78693	78693	246798
6354	4924	0	applied	\N	\N	\N	\N	78701	78701	246806
6354	4925	1	applied	\N	\N	\N	\N	78702	78702	246807
6354	4926	2	applied	\N	\N	\N	\N	78703	78703	246808
6357	4929	0	applied	\N	\N	\N	\N	78709	78709	246814
6360	4778	0	applied	\N	\N	1000000000	\N	78713	78713	246818
6360	4816	1	applied	\N	\N	1000000000	\N	78714	78714	246819
6360	4779	2	applied	\N	\N	\N	\N	78715	78715	246820
6360	4890	3	applied	\N	\N	1000000000	\N	78716	78716	246821
6360	4891	4	applied	\N	\N	1000000000	\N	78717	78717	246822
6360	4783	5	applied	\N	\N	\N	\N	78718	78718	246823
6360	4784	6	applied	\N	\N	\N	\N	78719	78719	246824
6360	4787	7	applied	\N	\N	\N	\N	78720	78720	246825
6360	4813	9	applied	\N	\N	\N	\N	78722	78722	78722
6360	4846	10	applied	\N	\N	1000000000	\N	78723	78723	246827
6365	4937	0	applied	\N	\N	\N	\N	78729	78729	246833
6367	4938	0	applied	\N	\N	\N	\N	78731	78731	246835
6370	4940	0	applied	\N	\N	\N	\N	78734	78734	246838
6370	4941	1	applied	\N	\N	\N	\N	78735	78735	246839
6370	4942	2	applied	\N	\N	\N	\N	78736	78736	246840
6373	4944	0	applied	\N	\N	\N	\N	78741	78741	246845
6373	4945	1	applied	\N	\N	\N	\N	78742	78742	246846
6373	4946	2	applied	\N	\N	\N	\N	78743	78743	246847
6383	4955	0	applied	\N	\N	\N	\N	78756	78756	246860
6388	4959	0	applied	\N	\N	\N	\N	78761	78761	246865
6388	4960	1	applied	\N	\N	\N	\N	78762	78762	246866
6393	4963	0	applied	\N	\N	\N	\N	78768	78768	246872
6393	4964	1	applied	\N	\N	\N	\N	78769	78769	246873
6402	4968	0	applied	\N	\N	\N	\N	78781	78781	246885
6403	4970	1	applied	\N	\N	\N	\N	78783	78783	246887
6403	4971	2	applied	\N	\N	\N	\N	78784	78784	246888
6403	4972	3	applied	\N	\N	\N	\N	78785	78785	246889
6406	4973	0	applied	\N	\N	\N	\N	78792	78792	246896
6406	4974	1	applied	\N	\N	\N	\N	78793	78793	246897
6406	4975	2	applied	\N	\N	\N	\N	78794	78794	246898
6410	4981	0	applied	\N	\N	\N	\N	78803	78803	246907
6165	4761	0	applied	\N	\N	\N	\N	78093	78093	246206
6171	4763	0	applied	\N	\N	\N	\N	78099	78099	246212
6183	4776	0	applied	\N	\N	\N	\N	78133	78133	246246
6183	4777	1	applied	\N	\N	\N	\N	78134	78134	246247
6185	4778	0	applied	\N	\N	1000000000	\N	78137	78137	246250
6185	4779	1	applied	\N	\N	\N	\N	78138	78138	246251
6185	4780	2	applied	\N	\N	\N	\N	78139	78139	246252
6193	4787	0	applied	\N	\N	\N	\N	78152	78152	246265
6193	4788	1	applied	\N	\N	\N	\N	78153	78153	246266
6193	4789	2	applied	\N	\N	\N	\N	78154	78154	246267
6196	4791	0	applied	\N	\N	\N	\N	78157	78157	246270
6199	4791	0	applied	\N	\N	\N	\N	78160	78160	246273
6202	4792	0	applied	\N	\N	\N	\N	78162	78162	246275
6202	4793	1	applied	\N	\N	\N	\N	78163	78163	246276
6202	4794	2	applied	\N	\N	\N	\N	78164	78164	246277
6202	4795	3	applied	\N	\N	\N	\N	78165	78165	246278
6202	4796	4	applied	\N	\N	\N	\N	78166	78166	246279
6202	4797	5	applied	\N	\N	\N	\N	78167	78167	246280
6202	4798	6	applied	\N	\N	\N	\N	78168	78168	246281
6202	4799	7	applied	\N	\N	\N	\N	78169	78169	246282
6202	4800	8	applied	\N	\N	\N	\N	78170	78170	246283
6202	4801	9	applied	\N	\N	\N	\N	78171	78171	246284
6205	4802	0	applied	\N	\N	\N	\N	78183	78183	246296
6205	4804	2	applied	\N	\N	\N	\N	78185	78185	246298
6212	4807	0	applied	\N	\N	\N	\N	78194	78194	246307
6212	4808	1	applied	\N	\N	\N	\N	78195	78195	246308
6212	4809	2	applied	\N	\N	\N	\N	78196	78196	246309
6212	4810	3	applied	\N	\N	\N	\N	78197	78197	246310
6217	4812	0	applied	\N	\N	\N	\N	78210	78210	246322
6217	4813	1	applied	\N	\N	\N	\N	78211	78211	78211
6217	4814	2	applied	\N	\N	\N	\N	78212	78212	246323
6222	4820	0	applied	\N	\N	\N	\N	78220	78220	246331
6222	4821	1	applied	\N	\N	\N	\N	78221	78221	246332
6227	4823	0	applied	\N	\N	\N	\N	78226	78226	246337
6227	4824	1	applied	\N	\N	\N	\N	78227	78227	246338
6229	4825	0	applied	\N	\N	\N	\N	78248	78248	246358
6230	4826	0	applied	\N	\N	\N	\N	78249	78249	246359
6230	4827	1	applied	\N	\N	\N	\N	78250	78250	246360
6230	4828	2	applied	\N	\N	\N	\N	78251	78251	246361
6235	4831	1	applied	\N	\N	\N	\N	78270	78270	246379
6238	4830	0	applied	\N	\N	\N	\N	78275	78275	246384
6238	4831	1	applied	\N	\N	\N	\N	78276	78276	246385
6239	4832	0	applied	\N	\N	\N	\N	78277	78277	246386
6239	4833	1	applied	\N	\N	\N	\N	78278	78278	246387
6242	4835	0	applied	\N	\N	\N	\N	78282	78282	246391
6242	4836	1	applied	\N	\N	\N	\N	78283	78283	246392
6244	4837	0	applied	\N	\N	\N	\N	78286	78286	246395
6249	4840	0	applied	\N	\N	\N	\N	78291	78291	246400
6249	4841	1	applied	\N	\N	\N	\N	78292	78292	246401
6252	4843	0	applied	\N	\N	\N	\N	78296	78296	246405
6252	4844	1	applied	\N	\N	\N	\N	78297	78297	246406
6252	4845	2	applied	\N	\N	\N	\N	78298	78298	246407
6252	4846	3	applied	\N	\N	1000000000	\N	78299	78299	246408
6258	4855	0	applied	\N	\N	\N	\N	78310	78310	246419
6261	4859	0	applied	\N	\N	\N	\N	78314	78314	246423
6274	4871	1	applied	\N	\N	\N	\N	78342	78342	246451
6274	4872	2	applied	\N	\N	\N	\N	78343	78343	246452
6274	4873	3	applied	\N	\N	\N	\N	78344	78344	246453
6277	4874	0	applied	\N	\N	\N	\N	78350	78350	246459
6279	4875	0	applied	\N	\N	\N	\N	78352	78352	246461
6286	4879	0	applied	\N	\N	\N	\N	78359	78359	246468
6288	4880	0	applied	\N	\N	\N	\N	78361	78361	246470
6291	4884	0	applied	\N	\N	\N	\N	78365	78365	246474
6294	4884	0	applied	\N	\N	\N	\N	78368	78368	246477
6298	4885	0	applied	\N	\N	\N	\N	78372	78372	246481
6302	4886	0	applied	\N	\N	\N	\N	78376	78376	246485
6304	4887	0	applied	\N	\N	\N	\N	78378	78378	246487
6304	4888	1	applied	\N	\N	\N	\N	78379	78379	246488
6307	4890	0	applied	\N	\N	1000000000	\N	78386	78386	246495
6307	4892	2	applied	\N	\N	\N	\N	78388	78388	246497
6307	4893	3	applied	\N	\N	\N	\N	78389	78389	246498
6307	4894	4	applied	\N	\N	\N	\N	78390	78390	246499
6312	4898	0	applied	\N	\N	\N	\N	78400	78400	246509
6315	4899	0	applied	\N	\N	\N	\N	78405	78405	246514
6315	4900	1	applied	\N	\N	\N	\N	78406	78406	246515
6315	4901	2	applied	\N	\N	\N	\N	78407	78407	246516
6324	4905	0	applied	\N	\N	\N	\N	78416	78416	246525
6326	4906	0	applied	\N	\N	\N	\N	78418	78418	246527
6332	4912	0	applied	\N	\N	\N	\N	78426	78426	246535
6334	4890	0	applied	\N	\N	1000000000	\N	78428	78428	246537
6334	4891	1	applied	\N	\N	1000000000	\N	78429	78429	246538
6339	4554	36	applied	\N	\N	\N	\N	78471	78471	246576
6339	4555	37	applied	\N	\N	\N	\N	78472	78472	246577
6339	4556	38	applied	\N	\N	\N	\N	78473	78473	246578
6339	4557	39	applied	\N	\N	\N	\N	78474	78474	246579
6339	4558	40	applied	\N	\N	\N	\N	78475	78475	246580
6345	4919	0	applied	\N	\N	\N	\N	78565	78565	246670
6352	4922	0	applied	\N	\N	\N	\N	78697	78697	246802
6352	4923	1	applied	\N	\N	\N	\N	78698	78698	246803
6355	4925	1	applied	\N	\N	\N	\N	78705	78705	246810
6355	4926	2	applied	\N	\N	\N	\N	78706	78706	246811
6358	4930	0	applied	\N	\N	\N	\N	78710	78710	246815
6358	4931	1	applied	\N	\N	\N	\N	78711	78711	246816
6361	4933	0	applied	\N	\N	\N	\N	78724	78724	246828
6361	4934	1	applied	\N	\N	\N	\N	78725	78725	246829
6363	4936	0	applied	\N	\N	\N	\N	78727	78727	246831
6366	4937	0	applied	\N	\N	\N	\N	78730	78730	246834
6371	4943	0	applied	\N	\N	\N	\N	78737	78737	246841
6374	4947	0	applied	\N	\N	\N	\N	78744	78744	246848
6378	4948	0	applied	\N	\N	\N	\N	78748	78748	246852
6381	4954	0	applied	\N	\N	\N	\N	78754	78754	246858
6386	4958	0	applied	\N	\N	\N	\N	78759	78759	246863
6389	4959	0	applied	\N	\N	\N	\N	78763	78763	246867
6389	4960	1	applied	\N	\N	\N	\N	78764	78764	246868
6391	4962	0	applied	\N	\N	\N	\N	78766	78766	246870
6404	4970	1	applied	\N	\N	\N	\N	78787	78787	246891
6404	4971	2	applied	\N	\N	\N	\N	78788	78788	246892
6404	4972	3	applied	\N	\N	\N	\N	78789	78789	246893
6407	4973	0	applied	\N	\N	\N	\N	78795	78795	246899
6407	4974	1	applied	\N	\N	\N	\N	78796	78796	246900
6407	4975	2	applied	\N	\N	\N	\N	78797	78797	246901
6175	4768	3	applied	\N	\N	\N	\N	78112	78112	246225
6180	4775	0	applied	\N	\N	\N	\N	78129	78129	246242
6339	4563	45	applied	\N	\N	\N	\N	78480	78480	246585
6339	4564	46	applied	\N	\N	\N	\N	78481	78481	246586
6339	4565	47	applied	\N	\N	\N	\N	78482	78482	246587
6339	4566	48	applied	\N	\N	\N	\N	78483	78483	246588
6339	4567	49	applied	\N	\N	\N	\N	78484	78484	246589
6339	4568	50	applied	\N	\N	\N	\N	78485	78485	246590
6339	4603	51	applied	\N	\N	\N	\N	78486	78486	246591
6339	4569	52	applied	\N	\N	\N	\N	78487	78487	246592
6339	4570	53	applied	\N	\N	\N	\N	78488	78488	246593
6339	4571	54	applied	\N	\N	\N	\N	78489	78489	246594
6339	4572	55	applied	\N	\N	\N	\N	78490	78490	246595
6339	4573	56	applied	\N	\N	\N	\N	78491	78491	246596
6339	4574	57	applied	\N	\N	\N	\N	78492	78492	246597
6339	4575	59	applied	\N	\N	\N	\N	78493	78493	246598
6339	4576	60	applied	\N	\N	\N	\N	78494	78494	246599
6339	4577	61	applied	\N	\N	\N	\N	78495	78495	246600
6339	4579	63	applied	\N	\N	\N	\N	78497	78497	246602
6339	4580	64	applied	\N	\N	\N	\N	78498	78498	246603
6339	4581	65	applied	\N	\N	\N	\N	78499	78499	246604
6339	4582	66	applied	\N	\N	\N	\N	78500	78500	246605
6339	4583	67	applied	\N	\N	\N	\N	78501	78501	246606
6339	4584	68	applied	\N	\N	\N	\N	78502	78502	246607
6339	4585	69	applied	\N	\N	\N	\N	78503	78503	246608
6339	4586	70	applied	\N	\N	\N	\N	78504	78504	246609
6339	4587	71	applied	\N	\N	\N	\N	78505	78505	246610
6339	4588	72	applied	\N	\N	\N	\N	78506	78506	246611
6339	4589	73	applied	\N	\N	\N	\N	78507	78507	246612
6339	4590	74	applied	\N	\N	\N	\N	78508	78508	246613
6339	4591	75	applied	\N	\N	\N	\N	78509	78509	246614
6339	4592	76	applied	\N	\N	\N	\N	78510	78510	246615
6339	4593	77	applied	\N	\N	\N	\N	78511	78511	246616
6339	4594	78	applied	\N	\N	\N	\N	78512	78512	246617
6339	4596	80	applied	\N	\N	\N	\N	78514	78514	246619
6339	4597	81	applied	\N	\N	\N	\N	78515	78515	246620
6339	4598	82	applied	\N	\N	\N	\N	78516	78516	246621
6339	4599	83	applied	\N	\N	\N	\N	78517	78517	246622
6339	4600	84	applied	\N	\N	\N	\N	78518	78518	246623
6339	4601	85	applied	\N	\N	\N	\N	78519	78519	246624
6339	4605	86	applied	\N	\N	\N	\N	78520	78520	246625
6339	4606	87	applied	\N	\N	\N	\N	78521	78521	246626
6339	4607	88	applied	\N	\N	\N	\N	78522	78522	246627
6339	4608	89	applied	\N	\N	\N	\N	78523	78523	246628
6339	4609	90	applied	\N	\N	\N	\N	78524	78524	246629
6339	4610	91	applied	\N	\N	\N	\N	78525	78525	246630
6339	4611	92	applied	\N	\N	\N	\N	78526	78526	246631
6339	4612	93	applied	\N	\N	\N	\N	78527	78527	246632
6339	4613	94	applied	\N	\N	\N	\N	78528	78528	246633
6339	4614	95	applied	\N	\N	\N	\N	78529	78529	246634
6339	4616	97	applied	\N	\N	\N	\N	78531	78531	246636
6339	4617	98	applied	\N	\N	\N	\N	78532	78532	246637
6339	4618	99	applied	\N	\N	\N	\N	78533	78533	246638
6339	4619	100	applied	\N	\N	\N	\N	78534	78534	246639
6339	4620	101	applied	\N	\N	\N	\N	78535	78535	246640
6339	4621	102	applied	\N	\N	\N	\N	78536	78536	246641
6339	4622	103	applied	\N	\N	\N	\N	78537	78537	246642
6339	4623	104	applied	\N	\N	\N	\N	78538	78538	246643
6339	4624	105	applied	\N	\N	\N	\N	78539	78539	246644
6339	4625	106	applied	\N	\N	\N	\N	78540	78540	246645
6339	4626	107	applied	\N	\N	\N	\N	78541	78541	246646
6339	4627	108	applied	\N	\N	\N	\N	78542	78542	246647
6339	4628	109	applied	\N	\N	\N	\N	78543	78543	246648
6339	4629	110	applied	\N	\N	\N	\N	78544	78544	246649
6339	4630	111	applied	\N	\N	\N	\N	78545	78545	246650
6339	4631	112	applied	\N	\N	\N	\N	78546	78546	246651
6339	4633	114	applied	\N	\N	\N	\N	78548	78548	246653
6339	4634	115	applied	\N	\N	\N	\N	78549	78549	246654
6339	4635	116	applied	\N	\N	\N	\N	78550	78550	246655
6339	4636	117	applied	\N	\N	\N	\N	78551	78551	246656
6339	4637	118	applied	\N	\N	\N	\N	78552	78552	246657
6339	4640	119	applied	\N	\N	\N	\N	78553	78553	246658
6339	4641	120	applied	\N	\N	\N	\N	78554	78554	246659
6339	4642	121	applied	\N	\N	\N	\N	78555	78555	246660
6339	4643	122	applied	\N	\N	\N	\N	78556	78556	246661
6339	4644	123	applied	\N	\N	\N	\N	78557	78557	246662
6339	4645	124	applied	\N	\N	\N	\N	78558	78558	246663
6339	4646	125	applied	\N	\N	\N	\N	78559	78559	246664
6341	4917	0	applied	\N	\N	\N	\N	78561	78561	246666
6343	4918	0	applied	\N	\N	\N	\N	78563	78563	246668
6346	4647	0	applied	\N	\N	\N	\N	78566	78566	246671
6346	4648	1	applied	\N	\N	\N	\N	78567	78567	246672
6346	4650	3	applied	\N	\N	\N	\N	78569	78569	246674
6346	4651	4	applied	\N	\N	\N	\N	78570	78570	246675
6346	4653	5	applied	\N	\N	\N	\N	78571	78571	246676
6346	4654	6	applied	\N	\N	\N	\N	78572	78572	246677
6346	4655	7	applied	\N	\N	\N	\N	78573	78573	246678
6346	4656	8	applied	\N	\N	\N	\N	78574	78574	246679
6346	4657	9	applied	\N	\N	\N	\N	78575	78575	246680
6346	4658	10	applied	\N	\N	\N	\N	78576	78576	246681
6346	4659	11	applied	\N	\N	\N	\N	78577	78577	246682
6346	4660	12	applied	\N	\N	\N	\N	78578	78578	246683
6346	4662	13	applied	\N	\N	\N	\N	78579	78579	246684
6346	4663	14	applied	\N	\N	\N	\N	78580	78580	246685
6346	4664	15	applied	\N	\N	\N	\N	78581	78581	246686
6346	4665	16	applied	\N	\N	\N	\N	78582	78582	246687
6346	4667	17	applied	\N	\N	\N	\N	78583	78583	246688
6346	4669	18	applied	\N	\N	\N	\N	78584	78584	246689
6346	4672	20	applied	\N	\N	\N	\N	78586	78586	246691
6346	4604	21	applied	\N	\N	\N	\N	78587	78587	246692
6346	4674	22	applied	\N	\N	\N	\N	78588	78588	246693
6346	4676	23	applied	\N	\N	\N	\N	78589	78589	246694
6346	4678	24	applied	\N	\N	\N	\N	78590	78590	246695
6346	4679	25	applied	\N	\N	\N	\N	78591	78591	246696
6346	4681	26	applied	\N	\N	\N	\N	78592	78592	246697
6346	4682	27	applied	\N	\N	\N	\N	78593	78593	246698
6346	4683	28	applied	\N	\N	\N	\N	78594	78594	246699
6346	4684	29	applied	\N	\N	\N	\N	78595	78595	246700
6346	4685	30	applied	\N	\N	\N	\N	78596	78596	246701
6346	4686	31	applied	\N	\N	\N	\N	78597	78597	246702
6346	4687	32	applied	\N	\N	\N	\N	78598	78598	246703
6346	4688	33	applied	\N	\N	\N	\N	78599	78599	246704
6339	4560	42	applied	\N	\N	\N	\N	78477	78477	246582
6339	4561	43	applied	\N	\N	\N	\N	78478	78478	246583
6346	4693	38	applied	\N	\N	\N	\N	78604	78604	246709
6346	4694	39	applied	\N	\N	\N	\N	78605	78605	246710
6346	4695	40	applied	\N	\N	\N	\N	78606	78606	246711
6346	4696	41	applied	\N	\N	\N	\N	78607	78607	246712
6346	4697	42	applied	\N	\N	\N	\N	78608	78608	246713
6346	4698	43	applied	\N	\N	\N	\N	78609	78609	246714
6346	4699	44	applied	\N	\N	\N	\N	78610	78610	246715
6346	4700	45	applied	\N	\N	\N	\N	78611	78611	246716
6346	4701	46	applied	\N	\N	\N	\N	78612	78612	246717
6346	4702	47	applied	\N	\N	\N	\N	78613	78613	246718
6346	4703	48	applied	\N	\N	\N	\N	78614	78614	246719
6346	4704	49	applied	\N	\N	\N	\N	78615	78615	246720
6346	4705	50	applied	\N	\N	\N	\N	78616	78616	246721
6346	4706	51	applied	\N	\N	\N	\N	78617	78617	246722
6346	4708	53	applied	\N	\N	\N	\N	78619	78619	246724
6346	4709	54	applied	\N	\N	\N	\N	78620	78620	246725
6346	4710	55	applied	\N	\N	\N	\N	78621	78621	246726
6346	4711	56	applied	\N	\N	\N	\N	78622	78622	246727
6346	4712	57	applied	\N	\N	\N	\N	78623	78623	246728
6346	4713	59	applied	\N	\N	\N	\N	78624	78624	246729
6346	4714	60	applied	\N	\N	\N	\N	78625	78625	246730
6346	4715	61	applied	\N	\N	\N	\N	78626	78626	246731
6346	4716	62	applied	\N	\N	\N	\N	78627	78627	246732
6346	4717	63	applied	\N	\N	\N	\N	78628	78628	246733
6346	4718	64	applied	\N	\N	\N	\N	78629	78629	246734
6346	4719	65	applied	\N	\N	\N	\N	78630	78630	246735
6346	4720	66	applied	\N	\N	\N	\N	78631	78631	246736
6346	4721	67	applied	\N	\N	\N	\N	78632	78632	246737
6346	4722	68	applied	\N	\N	\N	\N	78633	78633	246738
6346	4723	69	applied	\N	\N	\N	\N	78634	78634	246739
6346	4725	71	applied	\N	\N	\N	\N	78636	78636	246741
6346	4728	72	applied	\N	\N	\N	\N	78637	78637	246742
6346	4729	73	applied	\N	\N	\N	\N	78638	78638	246743
6346	4730	74	applied	\N	\N	\N	\N	78639	78639	246744
6346	4731	75	applied	\N	\N	\N	\N	78640	78640	246745
6346	4732	76	applied	\N	\N	\N	\N	78641	78641	246746
6346	4733	77	applied	\N	\N	\N	\N	78642	78642	246747
6346	4734	78	applied	\N	\N	\N	\N	78643	78643	246748
6346	4735	79	applied	\N	\N	\N	\N	78644	78644	246749
6346	4736	80	applied	\N	\N	\N	\N	78645	78645	246750
6346	4737	81	applied	\N	\N	\N	\N	78646	78646	246751
6346	4739	82	applied	\N	\N	\N	\N	78647	78647	246752
6346	4740	83	applied	\N	\N	\N	\N	78648	78648	246753
6346	4741	84	applied	\N	\N	\N	\N	78649	78649	246754
6346	4742	85	applied	\N	\N	\N	\N	78650	78650	246755
6346	4743	86	applied	\N	\N	\N	\N	78651	78651	246756
6346	4745	88	applied	\N	\N	\N	\N	78653	78653	246758
6346	4746	89	applied	\N	\N	\N	\N	78654	78654	246759
6346	4747	90	applied	\N	\N	\N	\N	78655	78655	246760
6346	4748	91	applied	\N	\N	\N	\N	78656	78656	246761
6346	4749	92	applied	\N	\N	\N	\N	78657	78657	246762
6346	4750	93	applied	\N	\N	\N	\N	78658	78658	246763
6346	4751	94	applied	\N	\N	\N	\N	78659	78659	246764
6346	4752	95	applied	\N	\N	\N	\N	78660	78660	246765
6346	4753	96	applied	\N	\N	\N	\N	78661	78661	246766
6346	4754	97	applied	\N	\N	\N	\N	78662	78662	246767
6346	4755	98	applied	\N	\N	\N	\N	78663	78663	246768
6346	4756	99	applied	\N	\N	\N	\N	78664	78664	246769
6346	4757	100	applied	\N	\N	\N	\N	78665	78665	246770
6346	4758	101	applied	\N	\N	\N	\N	78666	78666	246771
6346	4759	102	applied	\N	\N	\N	\N	78667	78667	246772
6346	4760	103	applied	\N	\N	\N	\N	78668	78668	246773
6346	4762	105	applied	\N	\N	\N	\N	78670	78670	246775
6346	4763	106	applied	\N	\N	\N	\N	78671	78671	246776
6346	4764	107	applied	\N	\N	\N	\N	78672	78672	246777
6346	4765	108	applied	\N	\N	\N	\N	78673	78673	246778
6346	4766	109	applied	\N	\N	\N	\N	78674	78674	246779
6346	4767	110	applied	\N	\N	\N	\N	78675	78675	246780
6346	4768	111	applied	\N	\N	\N	\N	78676	78676	246781
6346	4769	112	applied	\N	\N	\N	\N	78677	78677	246782
6346	4770	113	applied	\N	\N	\N	\N	78678	78678	246783
6346	4771	114	applied	\N	\N	\N	\N	78679	78679	246784
6346	4772	115	applied	\N	\N	\N	\N	78680	78680	246785
6346	4773	116	applied	\N	\N	\N	\N	78681	78681	246786
6346	4774	117	applied	\N	\N	\N	\N	78682	78682	246787
6346	4775	118	applied	\N	\N	\N	\N	78683	78683	246788
6346	4776	119	applied	\N	\N	\N	\N	78684	78684	246789
6346	4777	120	applied	\N	\N	\N	\N	78685	78685	246790
6346	4781	122	applied	\N	\N	\N	\N	78687	78687	246792
6346	4782	123	applied	\N	\N	\N	\N	78688	78688	246793
6346	4785	124	applied	\N	\N	\N	\N	78689	78689	246794
6346	4786	125	applied	\N	\N	\N	\N	78690	78690	246795
6350	4921	0	applied	\N	\N	\N	\N	78694	78694	246799
6364	4936	0	applied	\N	\N	\N	\N	78728	78728	246832
6368	4938	0	applied	\N	\N	\N	\N	78732	78732	246836
6372	4944	0	applied	\N	\N	\N	\N	78738	78738	246842
6372	4945	1	applied	\N	\N	\N	\N	78739	78739	246843
6372	4946	2	applied	\N	\N	\N	\N	78740	78740	246844
6375	4947	0	applied	\N	\N	\N	\N	78745	78745	246849
6379	4949	0	applied	\N	\N	1000000000	\N	78749	78749	246853
6379	4950	1	applied	\N	\N	\N	\N	78750	78750	246854
6382	4955	0	applied	\N	\N	\N	\N	78755	78755	246859
6384	4956	0	applied	\N	\N	\N	\N	78757	78757	246861
6385	4957	0	applied	\N	\N	\N	\N	78758	78758	246862
6390	4961	0	applied	\N	\N	\N	\N	78765	78765	246869
6392	4962	0	applied	\N	\N	\N	\N	78767	78767	246871
6394	4963	0	applied	\N	\N	\N	\N	78770	78770	246874
6394	4964	1	applied	\N	\N	\N	\N	78771	78771	246875
6399	4965	0	applied	\N	\N	\N	\N	78772	78772	246876
6399	4966	1	applied	\N	\N	\N	\N	78773	78773	246877
6399	4967	2	applied	\N	\N	\N	\N	78774	78774	246878
6400	4965	0	applied	\N	\N	\N	\N	78775	78775	246879
6400	4966	1	applied	\N	\N	\N	\N	78776	78776	246880
6400	4967	2	applied	\N	\N	\N	\N	78777	78777	246881
6401	4965	0	applied	\N	\N	\N	\N	78778	78778	246882
6401	4966	1	applied	\N	\N	\N	\N	78779	78779	246883
6401	4967	2	applied	\N	\N	\N	\N	78780	78780	246884
6408	4976	0	applied	\N	\N	\N	\N	78798	78798	246902
6408	4977	1	applied	\N	\N	\N	\N	78799	78799	246903
6408	4978	2	applied	\N	\N	\N	\N	78800	78800	246904
6346	4692	37	applied	\N	\N	\N	\N	78603	78603	246708
6409	4980	0	applied	\N	\N	\N	\N	78802	78802	246906
6411	4984	0	applied	\N	\N	\N	\N	78806	78806	246909
6412	4984	0	applied	\N	\N	\N	\N	78808	78808	246910
6411	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78807	78807	\N
6414	4986	0	applied	\N	\N	\N	\N	78816	78816	246914
6412	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78809	78809	\N
6415	4986	0	applied	\N	\N	\N	\N	78822	78822	246917
6423	4995	1	applied	\N	\N	\N	\N	78934	78934	247011
6423	4994	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78933	78933	\N
6425	4997	1	applied	\N	\N	\N	\N	78938	78938	247013
6425	4996	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78937	78937	\N
6428	5000	2	applied	\N	\N	\N	\N	78953	78953	247016
6428	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78951	78951	\N
6428	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78952	78952	\N
6428	5001	3	applied	\N	\N	\N	\N	78954	78954	247017
6432	5004	0	applied	\N	\N	\N	\N	78965	78965	247023
6434	5004	0	applied	\N	\N	\N	\N	78969	78969	247025
6432	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78966	78966	\N
6437	5006	0	applied	\N	\N	\N	\N	78975	78975	247028
6434	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78970	78970	\N
6439	5011	3	applied	\N	\N	\N	\N	78982	78982	247030
6437	5007	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78976	78976	\N
6439	5008	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78979	78979	\N
6439	5009	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78980	78980	\N
6439	5010	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	78981	78981	\N
6439	5012	4	applied	\N	\N	\N	\N	78983	78983	247031
6439	5013	5	applied	\N	\N	\N	\N	78984	78984	247032
6440	5016	2	applied	\N	\N	\N	\N	78987	78987	247033
6440	5014	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78985	78985	\N
6440	5015	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78986	78986	\N
6440	5018	4	applied	\N	\N	\N	\N	78989	78989	247034
6440	5017	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	78988	78988	\N
6440	5019	5	applied	\N	\N	\N	\N	78990	78990	247035
6445	5023	1	applied	\N	\N	\N	\N	78998	78998	247039
6445	5022	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78997	78997	\N
6447	5026	0	applied	\N	\N	\N	\N	79001	79001	247041
6452	5033	0	applied	\N	\N	\N	\N	79010	79010	247045
6447	5027	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79002	79002	\N
6452	5035	2	applied	\N	\N	\N	\N	79012	79012	247046
6452	5034	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79011	79011	\N
6454	5036	0	applied	\N	\N	\N	\N	79016	79016	247049
6457	5042	0	applied	\N	\N	\N	\N	79022	79022	247052
6454	5037	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79017	79017	\N
6457	5043	1	applied	\N	\N	\N	\N	79023	79023	247053
6460	5046	0	applied	\N	\N	\N	\N	79034	79034	247058
6457	5044	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	79024	79024	\N
6457	5045	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	79025	79025	\N
6460	5047	1	applied	\N	\N	\N	\N	79035	79035	247059
6465	5059	0	applied	\N	\N	\N	\N	79051	79051	247067
6460	5048	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	79036	79036	\N
6460	5049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	79037	79037	\N
6470	5063	0	applied	\N	\N	\N	\N	79058	79058	247074
6474	5069	0	applied	\N	\N	\N	\N	79066	79066	247082
6474	5070	1	applied	\N	\N	\N	\N	79067	79067	247083
6476	5071	0	applied	\N	\N	\N	\N	79070	79070	247086
6476	5072	1	applied	\N	\N	\N	\N	79071	79071	247087
6479	5077	0	applied	\N	\N	\N	\N	79078	79078	247094
6479	5078	1	applied	\N	\N	\N	\N	79079	79079	247095
6481	5077	0	applied	\N	\N	\N	\N	79082	79082	247098
6481	5078	1	applied	\N	\N	\N	\N	79083	79083	247099
6483	5079	0	applied	\N	\N	\N	\N	79086	79086	247102
6483	5080	1	applied	\N	\N	\N	\N	79087	79087	247103
6488	4890	0	applied	\N	\N	1000000000	\N	79096	79096	247112
6488	4891	1	applied	\N	\N	1000000000	\N	79097	79097	247113
6488	4949	2	applied	\N	\N	1000000000	\N	79098	79098	247114
6488	4951	3	applied	\N	\N	1000000000	\N	79099	79099	247115
6592	5206	0	applied	\N	\N	\N	\N	79392	79392	247370
6488	4982	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	79100	79100	\N
6488	4985	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	79101	79101	\N
6488	4987	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	79102	79102	\N
6488	4990	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	79103	79103	\N
6488	4991	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	79104	79104	\N
6488	4993	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	79105	79105	\N
6488	4994	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	79106	79106	\N
6488	4996	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	79107	79107	\N
6488	4998	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	79108	79108	\N
6488	4999	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	79109	79109	\N
6488	5003	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	79110	79110	\N
6488	5005	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	79111	79111	\N
6488	5007	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	79112	79112	\N
6488	5008	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	79113	79113	\N
6488	5009	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	79114	79114	\N
6488	5010	19	failed	Amount_insufficient_to_create_account	\N	\N	\N	79115	79115	\N
6488	5014	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	79116	79116	\N
6488	5015	21	failed	Amount_insufficient_to_create_account	\N	\N	\N	79117	79117	\N
6405	4951	1	applied	\N	\N	1000000000	\N	78791	78791	246895
6408	4979	3	applied	\N	\N	\N	\N	78801	78801	246905
6418	4992	0	applied	\N	\N	\N	\N	78836	78836	246924
6414	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	78821	78821	\N
6427	5000	2	applied	\N	\N	\N	\N	78949	78949	247014
6418	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78837	78837	\N
6427	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78947	78947	\N
6427	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78948	78948	\N
6427	5001	3	applied	\N	\N	\N	\N	78950	78950	247015
6430	5000	2	applied	\N	\N	\N	\N	78961	78961	247020
6430	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78959	78959	\N
6430	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78960	78960	\N
6430	5001	3	applied	\N	\N	\N	\N	78962	78962	247021
6436	5006	0	applied	\N	\N	\N	\N	78973	78973	247027
6442	5021	1	applied	\N	\N	\N	\N	78994	78994	247037
6436	5007	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78974	78974	\N
6442	5020	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78993	78993	\N
6444	5023	1	applied	\N	\N	\N	\N	78996	78996	247038
6444	5022	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78995	78995	\N
6446	5025	1	applied	\N	\N	\N	\N	79000	79000	247040
6446	5024	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78999	78999	\N
6449	5028	0	applied	\N	\N	\N	\N	79005	79005	247043
6456	5040	2	applied	\N	\N	\N	\N	79020	79020	247050
6449	5029	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79006	79006	\N
6451	5032	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79009	79009	\N
6456	5038	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79018	79018	\N
6456	5039	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79019	79019	\N
6456	5041	3	applied	\N	\N	\N	\N	79021	79021	247051
6462	5052	2	applied	\N	\N	\N	\N	79044	79044	247062
6462	5050	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79042	79042	\N
6462	5051	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79043	79043	\N
6462	5053	3	applied	\N	\N	\N	\N	79045	79045	247063
6467	5060	0	applied	\N	\N	\N	\N	79053	79053	247069
6467	5061	1	applied	\N	\N	1000000000	\N	79054	79054	247070
6469	5062	0	applied	\N	\N	\N	\N	79057	79057	247073
6472	5067	0	applied	\N	\N	\N	\N	79062	79062	247078
6472	5068	1	applied	\N	\N	\N	\N	79063	79063	247079
6482	5077	0	applied	\N	\N	\N	\N	79084	79084	247100
6482	5078	1	applied	\N	\N	\N	\N	79085	79085	247101
6486	5081	0	applied	\N	\N	\N	\N	79092	79092	247108
6486	5082	1	applied	\N	\N	\N	\N	79093	79093	247109
6491	5089	0	applied	\N	\N	\N	\N	79158	79158	247136
6491	5090	1	applied	\N	\N	\N	\N	79159	79159	247137
6496	5095	0	applied	\N	\N	\N	\N	79168	79168	247146
6496	5096	1	applied	\N	\N	\N	\N	79169	79169	247147
6496	5097	2	applied	\N	\N	\N	\N	79170	79170	247148
6496	5098	3	applied	\N	\N	\N	\N	79171	79171	247149
6503	5105	0	applied	\N	\N	\N	\N	79184	79184	247162
6503	5106	1	applied	\N	\N	\N	\N	79185	79185	247163
6505	5107	0	applied	\N	\N	\N	\N	79188	79188	247166
6505	5108	1	applied	\N	\N	\N	\N	79189	79189	247167
6512	5115	0	applied	\N	\N	\N	\N	79204	79204	247182
6512	5116	1	applied	\N	\N	\N	\N	79205	79205	247183
6517	5119	0	applied	\N	\N	\N	\N	79216	79216	247194
6517	5120	1	applied	\N	\N	\N	\N	79217	79217	247195
6517	5121	2	applied	\N	\N	\N	\N	79218	79218	247196
6517	5122	3	applied	\N	\N	\N	\N	79219	79219	247197
6520	5125	0	applied	\N	\N	\N	\N	79224	79224	247202
6520	5126	1	applied	\N	\N	\N	\N	79225	79225	247203
6524	5127	0	applied	\N	\N	\N	\N	79232	79232	247210
6524	5128	1	applied	\N	\N	\N	\N	79233	79233	247211
6526	5131	0	applied	\N	\N	\N	\N	79236	79236	247214
6526	5132	1	applied	\N	\N	\N	\N	79237	79237	247215
6529	5135	0	applied	\N	\N	\N	\N	79242	79242	247220
6529	5136	1	applied	\N	\N	\N	\N	79243	79243	247221
6531	5137	0	applied	\N	\N	\N	\N	79246	79246	247224
6531	5138	1	applied	\N	\N	\N	\N	79247	79247	247225
6542	5147	0	applied	\N	\N	\N	\N	79266	79266	247244
6542	5148	1	applied	\N	\N	\N	\N	79267	79267	247245
6550	5161	0	applied	\N	\N	\N	\N	79282	79282	247260
6550	5162	1	applied	\N	\N	\N	\N	79283	79283	247261
6567	5171	0	applied	\N	\N	\N	\N	79314	79314	247292
6567	5172	1	applied	\N	\N	\N	\N	79315	79315	247293
6572	5177	0	applied	\N	\N	\N	\N	79324	79324	247302
6572	5178	1	applied	\N	\N	\N	\N	79325	79325	247303
6572	5179	2	applied	\N	\N	\N	\N	79326	79326	247304
6572	5180	3	applied	\N	\N	\N	\N	79327	79327	247305
6574	5177	0	applied	\N	\N	\N	\N	79332	79332	247310
6574	5178	1	applied	\N	\N	\N	\N	79333	79333	247311
6574	5179	2	applied	\N	\N	\N	\N	79334	79334	247312
6586	5188	0	applied	\N	\N	\N	\N	79364	79364	247342
6586	5189	1	applied	\N	\N	\N	\N	79365	79365	247343
6586	5190	2	applied	\N	\N	\N	\N	79366	79366	247344
6586	5191	3	applied	\N	\N	\N	\N	79367	79367	247345
6586	5192	4	applied	\N	\N	\N	\N	79368	79368	247346
6591	5204	0	applied	\N	\N	\N	\N	79390	79390	247368
6591	5205	1	applied	\N	\N	\N	\N	79391	79391	247369
6594	5206	0	applied	\N	\N	\N	\N	79396	79396	247374
6594	5207	1	applied	\N	\N	\N	\N	79397	79397	247375
6598	5210	0	applied	\N	\N	\N	\N	79404	79404	247382
6598	5211	1	applied	\N	\N	\N	\N	79405	79405	247383
6598	5212	2	applied	\N	\N	\N	\N	79406	79406	247384
6598	5213	3	applied	\N	\N	\N	\N	79407	79407	247385
6600	5210	0	applied	\N	\N	\N	\N	79412	79412	247390
6600	5211	1	applied	\N	\N	\N	\N	79413	79413	247391
6600	5212	2	applied	\N	\N	\N	\N	79414	79414	247392
6602	5210	0	applied	\N	\N	\N	\N	79418	79418	247396
6602	5211	1	applied	\N	\N	\N	\N	79419	79419	247397
6602	5214	2	applied	\N	\N	\N	\N	79420	79420	247398
6602	5212	3	applied	\N	\N	\N	\N	79421	79421	247399
6602	5213	4	applied	\N	\N	\N	\N	79422	79422	247400
6602	5215	5	applied	\N	\N	\N	\N	79423	79423	247401
6605	5220	0	applied	\N	\N	\N	\N	79432	79432	247410
6413	4986	0	applied	\N	\N	\N	\N	78810	78810	246911
6413	4988	2	applied	\N	\N	\N	\N	78812	78812	246912
6413	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	78815	78815	\N
6424	4995	1	applied	\N	\N	\N	\N	78936	78936	247012
6424	4994	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78935	78935	\N
6429	5000	2	applied	\N	\N	\N	\N	78957	78957	247018
6426	4982	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78939	78939	\N
6426	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78940	78940	\N
6426	4987	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	78941	78941	\N
6426	4990	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	78942	78942	\N
6426	4991	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	78943	78943	\N
6426	4993	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	78944	78944	\N
6426	4994	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	78945	78945	\N
6426	4996	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	78946	78946	\N
6429	4998	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78955	78955	\N
6429	4999	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78956	78956	\N
6429	5001	3	applied	\N	\N	\N	\N	78958	78958	247019
6438	5006	0	applied	\N	\N	\N	\N	78977	78977	247029
6450	5031	1	applied	\N	\N	\N	\N	79008	79008	247044
6438	5007	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78978	78978	\N
6450	5030	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79007	79007	\N
6453	5033	0	applied	\N	\N	\N	\N	79013	79013	247047
6453	5035	2	applied	\N	\N	\N	\N	79015	79015	247048
6453	5034	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79014	79014	\N
6458	5046	0	applied	\N	\N	\N	\N	79026	79026	247054
6458	5047	1	applied	\N	\N	\N	\N	79027	79027	247055
6463	5054	0	applied	\N	\N	\N	\N	79046	79046	247064
6458	5048	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	79028	79028	\N
6458	5049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	79029	79029	\N
6466	5059	0	applied	\N	\N	\N	\N	79052	79052	247068
6463	5055	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79047	79047	\N
6468	5060	0	applied	\N	\N	\N	\N	79055	79055	247071
6468	5061	1	applied	\N	\N	1000000000	\N	79056	79056	247072
6471	5064	0	applied	\N	\N	1000000000	\N	79059	79059	247075
6471	5065	1	applied	\N	\N	\N	\N	79060	79060	247076
6471	5066	2	applied	\N	\N	\N	\N	79061	79061	247077
6473	5067	0	applied	\N	\N	\N	\N	79064	79064	247080
6473	5068	1	applied	\N	\N	\N	\N	79065	79065	247081
6478	5073	0	applied	\N	\N	\N	\N	79074	79074	247090
6478	5074	1	applied	\N	\N	\N	\N	79075	79075	247091
6478	5075	2	applied	\N	\N	\N	\N	79076	79076	247092
6478	5076	3	applied	\N	\N	\N	\N	79077	79077	247093
6485	5081	0	applied	\N	\N	\N	\N	79090	79090	247106
6485	5082	1	applied	\N	\N	\N	\N	79091	79091	247107
6487	5083	0	applied	\N	\N	\N	\N	79094	79094	247110
6487	5084	1	applied	\N	\N	\N	\N	79095	79095	247111
6492	5091	0	applied	\N	\N	\N	\N	79160	79160	247138
6492	5092	1	applied	\N	\N	\N	\N	79161	79161	247139
6497	5095	0	applied	\N	\N	\N	\N	79172	79172	247150
6497	5096	1	applied	\N	\N	\N	\N	79173	79173	247151
6497	5097	2	applied	\N	\N	\N	\N	79174	79174	247152
6497	5098	3	applied	\N	\N	\N	\N	79175	79175	247153
6499	5099	0	applied	\N	\N	\N	\N	79176	79176	247154
6499	5100	1	applied	\N	\N	\N	\N	79177	79177	247155
6507	5113	0	applied	\N	\N	\N	\N	79194	79194	247172
6507	5114	1	applied	\N	\N	\N	\N	79195	79195	247173
6509	5115	0	applied	\N	\N	\N	\N	79198	79198	247176
6509	5116	1	applied	\N	\N	\N	\N	79199	79199	247177
6514	5119	0	applied	\N	\N	\N	\N	79208	79208	247186
6514	5120	1	applied	\N	\N	\N	\N	79209	79209	247187
6514	5121	2	applied	\N	\N	\N	\N	79210	79210	247188
6514	5122	3	applied	\N	\N	\N	\N	79211	79211	247189
6518	5123	0	applied	\N	\N	\N	\N	79220	79220	247198
6518	5124	1	applied	\N	\N	\N	\N	79221	79221	247199
6523	5127	0	applied	\N	\N	\N	\N	79230	79230	247208
6523	5128	1	applied	\N	\N	\N	\N	79231	79231	247209
6525	5129	0	applied	\N	\N	\N	\N	79234	79234	247212
6525	5130	1	applied	\N	\N	\N	\N	79235	79235	247213
6532	5137	0	applied	\N	\N	\N	\N	79248	79248	247226
6532	5138	1	applied	\N	\N	\N	\N	79249	79249	247227
6534	5139	0	applied	\N	\N	\N	\N	79252	79252	247230
6534	5140	1	applied	\N	\N	\N	\N	79253	79253	247231
6541	5145	0	applied	\N	\N	\N	\N	79264	79264	247242
6541	5146	1	applied	\N	\N	\N	\N	79265	79265	247243
6546	5151	0	applied	\N	\N	\N	\N	79272	79272	247250
6546	5152	1	applied	\N	\N	\N	\N	79273	79273	247251
6546	5153	2	applied	\N	\N	\N	\N	79274	79274	247252
6546	5154	3	applied	\N	\N	\N	\N	79275	79275	247253
6546	5155	4	applied	\N	\N	\N	\N	79276	79276	247254
6546	5156	5	applied	\N	\N	\N	\N	79277	79277	247255
6552	5161	0	applied	\N	\N	\N	\N	79286	79286	247264
6552	5162	1	applied	\N	\N	\N	\N	79287	79287	247265
6553	5163	0	applied	\N	\N	\N	\N	79288	79288	247266
6553	5164	1	applied	\N	\N	\N	\N	79289	79289	247267
6553	5165	2	applied	\N	\N	1000000000	\N	79290	79290	247268
6558	5166	0	applied	\N	\N	\N	\N	79298	79298	247276
6558	5167	1	applied	\N	\N	\N	\N	79299	79299	247277
6560	5169	0	applied	\N	\N	\N	\N	79301	79301	247279
6560	5170	1	applied	\N	\N	\N	\N	79302	79302	247280
6563	5169	0	applied	\N	\N	\N	\N	79307	79307	247285
6563	5170	1	applied	\N	\N	\N	\N	79308	79308	247286
6566	5169	0	applied	\N	\N	\N	\N	79312	79312	247290
6566	5170	1	applied	\N	\N	\N	\N	79313	79313	247291
6571	5175	0	applied	\N	\N	\N	\N	79322	79322	247300
6571	5176	1	applied	\N	\N	\N	\N	79323	79323	247301
6578	5183	0	applied	\N	\N	\N	\N	79342	79342	247320
6578	5184	1	applied	\N	\N	\N	\N	79343	79343	247321
6582	5165	0	applied	\N	\N	1000000000	\N	79350	79350	247328
6585	5188	0	applied	\N	\N	\N	\N	79359	79359	247337
6585	5189	1	applied	\N	\N	\N	\N	79360	79360	247338
6585	5190	2	applied	\N	\N	\N	\N	79361	79361	247339
6585	5191	3	applied	\N	\N	\N	\N	79362	79362	247340
6585	5192	4	applied	\N	\N	\N	\N	79363	79363	247341
6416	4986	0	applied	\N	\N	\N	\N	78828	78828	246920
6448	5029	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79004	79004	\N
6459	5048	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	79032	79032	\N
6459	5049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	79033	79033	\N
6461	5050	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79038	79038	\N
6461	5051	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79039	79039	\N
6422	4808	18	applied	\N	\N	\N	\N	78862	78862	246941
6422	4809	19	applied	\N	\N	\N	\N	78863	78863	246942
6422	4810	20	applied	\N	\N	\N	\N	78864	78864	246943
6422	4811	21	applied	\N	\N	\N	\N	78865	78865	246944
6422	4814	22	applied	\N	\N	\N	\N	78866	78866	246945
6422	4815	23	applied	\N	\N	\N	\N	78867	78867	246946
6422	4817	24	applied	\N	\N	\N	\N	78868	78868	246947
6422	4818	25	applied	\N	\N	\N	\N	78869	78869	246948
6422	4819	26	applied	\N	\N	\N	\N	78870	78870	246949
6422	4820	27	applied	\N	\N	\N	\N	78871	78871	246950
6422	4821	28	applied	\N	\N	\N	\N	78872	78872	246951
6422	4822	30	applied	\N	\N	\N	\N	78874	78874	246952
6422	4823	31	applied	\N	\N	\N	\N	78875	78875	246953
6422	4824	32	applied	\N	\N	\N	\N	78876	78876	246954
6422	4825	33	applied	\N	\N	\N	\N	78877	78877	246955
6422	4826	34	applied	\N	\N	\N	\N	78878	78878	246956
6422	4827	35	applied	\N	\N	\N	\N	78879	78879	246957
6422	4828	36	applied	\N	\N	\N	\N	78880	78880	246958
6422	4829	37	applied	\N	\N	\N	\N	78881	78881	246959
6422	4830	38	applied	\N	\N	\N	\N	78882	78882	246960
6422	4831	39	applied	\N	\N	\N	\N	78883	78883	246961
6422	4832	40	applied	\N	\N	\N	\N	78884	78884	246962
6422	4993	29	failed	Amount_insufficient_to_create_account	\N	\N	\N	78873	78873	\N
6431	5003	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78964	78964	\N
6433	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78968	78968	\N
6435	5005	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78972	78972	\N
6441	5020	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	78991	78991	\N
6422	4833	41	applied	\N	\N	\N	\N	78885	78885	246963
6431	5002	0	applied	\N	\N	\N	\N	78963	78963	247022
6433	5004	0	applied	\N	\N	\N	\N	78967	78967	247024
6435	5004	0	applied	\N	\N	\N	\N	78971	78971	247026
6441	5021	1	applied	\N	\N	\N	\N	78992	78992	247036
6448	5028	0	applied	\N	\N	\N	\N	79003	79003	247042
6459	5046	0	applied	\N	\N	\N	\N	79030	79030	247056
6459	5047	1	applied	\N	\N	\N	\N	79031	79031	247057
6461	5052	2	applied	\N	\N	\N	\N	79040	79040	247060
6461	5053	3	applied	\N	\N	\N	\N	79041	79041	247061
6475	5069	0	applied	\N	\N	\N	\N	79068	79068	247084
6475	5070	1	applied	\N	\N	\N	\N	79069	79069	247085
6477	5071	0	applied	\N	\N	\N	\N	79072	79072	247088
6477	5072	1	applied	\N	\N	\N	\N	79073	79073	247089
6480	5077	0	applied	\N	\N	\N	\N	79080	79080	247096
6480	5078	1	applied	\N	\N	\N	\N	79081	79081	247097
6484	5079	0	applied	\N	\N	\N	\N	79088	79088	247104
6484	5080	1	applied	\N	\N	\N	\N	79089	79089	247105
6489	5086	0	applied	\N	\N	\N	\N	79150	79150	247128
6488	5022	24	failed	Amount_insufficient_to_create_account	\N	\N	\N	79120	79120	\N
6489	5087	1	applied	\N	\N	\N	\N	79151	79151	247129
6489	5085	2	applied	\N	\N	\N	\N	79152	79152	247130
6489	5088	3	applied	\N	\N	\N	\N	79153	79153	247131
6494	5093	0	applied	\N	\N	\N	\N	79164	79164	247142
6494	5094	1	applied	\N	\N	\N	\N	79165	79165	247143
6501	5101	0	applied	\N	\N	\N	\N	79180	79180	247158
6501	5102	1	applied	\N	\N	\N	\N	79181	79181	247159
6504	5105	0	applied	\N	\N	\N	\N	79186	79186	247164
6504	5106	1	applied	\N	\N	\N	\N	79187	79187	247165
6506	5109	0	applied	\N	\N	\N	\N	79190	79190	247168
6506	5110	1	applied	\N	\N	\N	\N	79191	79191	247169
6506	5111	2	applied	\N	\N	\N	\N	79192	79192	247170
6506	5112	3	applied	\N	\N	\N	\N	79193	79193	247171
6511	5115	0	applied	\N	\N	\N	\N	79202	79202	247180
6511	5116	1	applied	\N	\N	\N	\N	79203	79203	247181
6513	5117	0	applied	\N	\N	\N	\N	79206	79206	247184
6513	5118	1	applied	\N	\N	\N	\N	79207	79207	247185
6522	5127	0	applied	\N	\N	\N	\N	79228	79228	247206
6522	5128	1	applied	\N	\N	\N	\N	79229	79229	247207
6527	5133	0	applied	\N	\N	\N	\N	79238	79238	247216
6527	5134	1	applied	\N	\N	\N	\N	79239	79239	247217
6530	5136	1	applied	\N	\N	\N	\N	79245	79245	247223
6538	5141	0	applied	\N	\N	\N	\N	79258	79258	247236
6538	5142	1	applied	\N	\N	\N	\N	79259	79259	247237
6540	5143	0	applied	\N	\N	\N	\N	79262	79262	247240
6540	5144	1	applied	\N	\N	\N	\N	79263	79263	247241
6543	5147	0	applied	\N	\N	\N	\N	79268	79268	247246
6543	5148	1	applied	\N	\N	\N	\N	79269	79269	247247
6548	5159	0	applied	\N	\N	\N	\N	79280	79280	247258
6548	5160	1	applied	\N	\N	\N	\N	79281	79281	247259
6551	5161	0	applied	\N	\N	\N	\N	79284	79284	247262
6551	5162	1	applied	\N	\N	\N	\N	79285	79285	247263
6555	5166	0	applied	\N	\N	\N	\N	79294	79294	247272
6555	5167	1	applied	\N	\N	\N	\N	79295	79295	247273
6557	5166	0	applied	\N	\N	\N	\N	79296	79296	247274
6557	5167	1	applied	\N	\N	\N	\N	79297	79297	247275
6559	5168	0	applied	\N	\N	\N	\N	79300	79300	247278
6562	5170	1	applied	\N	\N	\N	\N	79306	79306	247284
6565	5169	0	applied	\N	\N	\N	\N	79310	79310	247288
6565	5170	1	applied	\N	\N	\N	\N	79311	79311	247289
6568	5173	0	applied	\N	\N	\N	\N	79316	79316	247294
6568	5174	1	applied	\N	\N	\N	\N	79317	79317	247295
6570	5175	0	applied	\N	\N	\N	\N	79320	79320	247298
6570	5176	1	applied	\N	\N	\N	\N	79321	79321	247299
6573	5177	0	applied	\N	\N	\N	\N	79328	79328	247306
6573	5178	1	applied	\N	\N	\N	\N	79329	79329	247307
6573	5179	2	applied	\N	\N	\N	\N	79330	79330	247308
6573	5180	3	applied	\N	\N	\N	\N	79331	79331	247309
6575	5181	0	applied	\N	\N	\N	\N	79336	79336	247314
6575	5182	1	applied	\N	\N	\N	\N	79337	79337	247315
6577	5183	0	applied	\N	\N	\N	\N	79340	79340	247318
6577	5184	1	applied	\N	\N	\N	\N	79341	79341	247319
6580	5183	0	applied	\N	\N	\N	\N	79346	79346	247324
6584	5188	0	applied	\N	\N	\N	\N	79354	79354	247332
6584	5189	1	applied	\N	\N	\N	\N	79355	79355	247333
6584	5190	2	applied	\N	\N	\N	\N	79356	79356	247334
6584	5191	3	applied	\N	\N	\N	\N	79357	79357	247335
6584	5192	4	applied	\N	\N	\N	\N	79358	79358	247336
6589	5194	0	applied	\N	\N	\N	\N	79379	79379	247357
6589	5195	1	applied	\N	\N	\N	\N	79380	79380	247358
6589	5196	2	applied	\N	\N	\N	\N	79381	79381	247359
6589	5197	3	applied	\N	\N	1000000000	\N	79382	79382	247360
6589	5198	4	applied	\N	\N	\N	\N	79383	79383	247361
6589	5199	5	applied	\N	\N	\N	\N	79384	79384	247362
6589	5200	6	applied	\N	\N	\N	\N	79385	79385	247363
6589	5201	7	applied	\N	\N	\N	\N	79386	79386	247364
6589	5193	8	applied	\N	\N	\N	\N	79387	79387	247365
6597	5213	3	applied	\N	\N	\N	\N	79403	79403	247381
6599	5210	0	applied	\N	\N	\N	\N	79408	79408	247386
6599	5212	2	applied	\N	\N	\N	\N	79410	79410	247388
6599	5213	3	applied	\N	\N	\N	\N	79411	79411	247389
6603	5216	0	applied	\N	\N	\N	\N	79424	79424	247402
6603	5217	1	applied	\N	\N	\N	\N	79425	79425	247403
6603	5218	2	applied	\N	\N	\N	\N	79426	79426	247404
6603	5219	3	applied	\N	\N	\N	\N	79427	79427	247405
6609	5232	0	applied	\N	\N	\N	\N	79452	79452	247430
6609	5233	1	applied	\N	\N	\N	\N	79453	79453	247431
6612	5232	0	applied	\N	\N	\N	\N	79458	79458	247436
6612	5233	1	applied	\N	\N	\N	\N	79459	79459	247437
6620	5242	0	applied	\N	\N	\N	\N	79468	79468	247446
6620	5243	1	applied	\N	\N	\N	\N	79469	79469	247447
6622	5242	0	applied	\N	\N	\N	\N	79472	79472	247450
6622	5243	1	applied	\N	\N	\N	\N	79473	79473	247451
6632	5255	0	applied	\N	\N	\N	\N	79500	79500	247478
6632	5256	2	applied	\N	\N	\N	\N	79501	79501	247479
6632	5258	4	applied	\N	\N	\N	\N	79503	79503	247481
6634	5259	0	applied	\N	\N	\N	\N	79506	79506	247484
6634	5260	1	applied	\N	\N	\N	\N	79507	79507	247485
6637	5261	0	applied	\N	\N	\N	\N	79512	79512	247490
6637	5262	1	applied	\N	\N	\N	\N	79513	79513	247491
6640	5273	0	applied	\N	\N	\N	\N	79524	79524	247502
6640	5274	1	applied	\N	\N	\N	\N	79525	79525	247503
6643	5283	0	applied	\N	\N	\N	\N	79534	79534	247512
6643	5284	1	applied	\N	\N	\N	\N	79535	79535	247513
6646	5285	0	applied	\N	\N	\N	\N	79540	79540	247518
6646	5286	1	applied	\N	\N	\N	\N	79541	79541	247519
6648	5287	0	applied	\N	\N	\N	\N	79544	79544	247522
6648	5288	1	applied	\N	\N	\N	\N	79545	79545	247523
6464	5057	1	applied	\N	\N	\N	\N	79049	79049	247065
6464	5058	2	applied	\N	\N	\N	\N	79050	79050	247066
6488	5029	27	failed	Amount_insufficient_to_create_account	\N	\N	\N	79123	79123	\N
6488	5030	28	failed	Amount_insufficient_to_create_account	\N	\N	\N	79124	79124	\N
6488	5032	29	failed	Amount_insufficient_to_create_account	\N	\N	\N	79125	79125	\N
6488	5034	30	failed	Amount_insufficient_to_create_account	\N	\N	\N	79126	79126	\N
6488	5037	31	failed	Amount_insufficient_to_create_account	\N	\N	\N	79127	79127	\N
6488	5038	32	failed	Amount_insufficient_to_create_account	\N	\N	\N	79128	79128	\N
6488	5039	33	failed	Amount_insufficient_to_create_account	\N	\N	\N	79129	79129	\N
6488	5044	34	failed	Amount_insufficient_to_create_account	\N	\N	\N	79130	79130	\N
6488	5048	36	failed	Amount_insufficient_to_create_account	\N	\N	\N	79132	79132	\N
6488	5049	37	failed	Amount_insufficient_to_create_account	\N	\N	\N	79133	79133	\N
6488	5050	38	failed	Amount_insufficient_to_create_account	\N	\N	\N	79134	79134	\N
6488	5051	39	failed	Amount_insufficient_to_create_account	\N	\N	\N	79135	79135	\N
6488	5055	40	failed	Amount_insufficient_to_create_account	\N	\N	\N	79136	79136	\N
6488	5056	41	failed	Amount_insufficient_to_create_account	\N	\N	\N	79137	79137	\N
6488	5064	43	applied	\N	\N	1000000000	\N	79139	79139	247117
6488	5068	44	applied	\N	\N	\N	\N	79140	79140	247118
6488	5069	45	applied	\N	\N	\N	\N	79141	79141	247119
6488	5072	46	applied	\N	\N	\N	\N	79142	79142	247120
6488	5075	47	applied	\N	\N	\N	\N	79143	79143	247121
6488	5076	48	applied	\N	\N	\N	\N	79144	79144	247122
6488	5077	49	applied	\N	\N	\N	\N	79145	79145	247123
6488	5080	50	applied	\N	\N	\N	\N	79146	79146	247124
6488	5081	51	applied	\N	\N	\N	\N	79147	79147	247125
6488	5084	52	applied	\N	\N	\N	\N	79148	79148	247126
6488	5085	53	applied	\N	\N	\N	\N	79149	79149	247127
6490	5086	0	applied	\N	\N	\N	\N	79154	79154	247132
6490	5087	1	applied	\N	\N	\N	\N	79155	79155	247133
6490	5085	2	applied	\N	\N	\N	\N	79156	79156	247134
6490	5088	3	applied	\N	\N	\N	\N	79157	79157	247135
6493	5091	0	applied	\N	\N	\N	\N	79162	79162	247140
6493	5092	1	applied	\N	\N	\N	\N	79163	79163	247141
6495	5093	0	applied	\N	\N	\N	\N	79166	79166	247144
6495	5094	1	applied	\N	\N	\N	\N	79167	79167	247145
6500	5099	0	applied	\N	\N	\N	\N	79178	79178	247156
6500	5100	1	applied	\N	\N	\N	\N	79179	79179	247157
6502	5103	0	applied	\N	\N	\N	\N	79182	79182	247160
6502	5104	1	applied	\N	\N	\N	\N	79183	79183	247161
6508	5113	0	applied	\N	\N	\N	\N	79196	79196	247174
6508	5114	1	applied	\N	\N	\N	\N	79197	79197	247175
6510	5116	1	applied	\N	\N	\N	\N	79201	79201	247179
6515	5119	0	applied	\N	\N	\N	\N	79212	79212	247190
6515	5120	1	applied	\N	\N	\N	\N	79213	79213	247191
6515	5121	2	applied	\N	\N	\N	\N	79214	79214	247192
6515	5122	3	applied	\N	\N	\N	\N	79215	79215	247193
6519	5125	0	applied	\N	\N	\N	\N	79222	79222	247200
6519	5126	1	applied	\N	\N	\N	\N	79223	79223	247201
6521	5125	0	applied	\N	\N	\N	\N	79226	79226	247204
6521	5126	1	applied	\N	\N	\N	\N	79227	79227	247205
6528	5135	0	applied	\N	\N	\N	\N	79240	79240	247218
6528	5136	1	applied	\N	\N	\N	\N	79241	79241	247219
6533	5137	0	applied	\N	\N	\N	\N	79250	79250	247228
6533	5138	1	applied	\N	\N	\N	\N	79251	79251	247229
6535	5141	0	applied	\N	\N	\N	\N	79254	79254	247232
6535	5142	1	applied	\N	\N	\N	\N	79255	79255	247233
6537	5141	0	applied	\N	\N	\N	\N	79256	79256	247234
6539	5143	0	applied	\N	\N	\N	\N	79260	79260	247238
6539	5144	1	applied	\N	\N	\N	\N	79261	79261	247239
6544	5149	0	applied	\N	\N	\N	\N	79270	79270	247248
6544	5150	1	applied	\N	\N	\N	\N	79271	79271	247249
6547	5157	0	applied	\N	\N	\N	\N	79278	79278	247256
6547	5158	1	applied	\N	\N	\N	\N	79279	79279	247257
6554	5163	0	applied	\N	\N	\N	\N	79291	79291	247269
6554	5164	1	applied	\N	\N	\N	\N	79292	79292	247270
6554	5165	2	applied	\N	\N	1000000000	\N	79293	79293	247271
6561	5169	0	applied	\N	\N	\N	\N	79303	79303	247281
6561	5170	1	applied	\N	\N	\N	\N	79304	79304	247282
6564	5165	0	applied	\N	\N	1000000000	\N	79309	79309	247287
6569	5175	0	applied	\N	\N	\N	\N	79318	79318	247296
6569	5176	1	applied	\N	\N	\N	\N	79319	79319	247297
6576	5181	0	applied	\N	\N	\N	\N	79338	79338	247316
6576	5182	1	applied	\N	\N	\N	\N	79339	79339	247317
6579	5184	1	applied	\N	\N	\N	\N	79345	79345	247323
6581	5183	0	applied	\N	\N	\N	\N	79348	79348	247326
6581	5184	1	applied	\N	\N	\N	\N	79349	79349	247327
6583	5185	0	applied	\N	\N	\N	\N	79351	79351	247329
6583	5186	1	applied	\N	\N	\N	\N	79352	79352	247330
6583	5187	2	applied	\N	\N	\N	\N	79353	79353	247331
6587	5193	0	applied	\N	\N	\N	\N	79369	79369	247347
6588	5194	0	applied	\N	\N	\N	\N	79370	79370	247348
6588	5195	1	applied	\N	\N	\N	\N	79371	79371	247349
6588	5196	2	applied	\N	\N	\N	\N	79372	79372	247350
6588	5197	3	applied	\N	\N	1000000000	\N	79373	79373	247351
6588	5198	4	applied	\N	\N	\N	\N	79374	79374	247352
6588	5199	5	applied	\N	\N	\N	\N	79375	79375	247353
6588	5200	6	applied	\N	\N	\N	\N	79376	79376	247354
6588	5201	7	applied	\N	\N	\N	\N	79377	79377	247355
6588	5193	8	applied	\N	\N	\N	\N	79378	79378	247356
6590	5203	1	applied	\N	\N	\N	\N	79389	79389	247367
6592	5207	1	applied	\N	\N	\N	\N	79393	79393	247371
6593	5206	0	applied	\N	\N	\N	\N	79394	79394	247372
6593	5207	1	applied	\N	\N	\N	\N	79395	79395	247373
6595	5208	0	applied	\N	\N	\N	\N	79398	79398	247376
6595	5209	1	applied	\N	\N	\N	\N	79399	79399	247377
6597	5210	0	applied	\N	\N	\N	\N	79400	79400	247378
6597	5211	1	applied	\N	\N	\N	\N	79401	79401	247379
6597	5212	2	applied	\N	\N	\N	\N	79402	79402	247380
6610	5232	0	applied	\N	\N	\N	\N	79454	79454	247432
6610	5233	1	applied	\N	\N	\N	\N	79455	79455	247433
6616	5234	0	applied	\N	\N	\N	\N	79460	79460	247438
6616	5235	1	applied	\N	\N	\N	\N	79461	79461	247439
6619	5240	0	applied	\N	\N	\N	\N	79466	79466	247444
6619	5241	1	applied	\N	\N	\N	\N	79467	79467	247445
6621	5242	0	applied	\N	\N	\N	\N	79470	79470	247448
6488	5061	42	applied	\N	\N	1000000000	\N	79138	79138	247116
6604	5218	2	applied	\N	\N	\N	\N	79430	79430	247408
6604	5219	3	applied	\N	\N	\N	\N	79431	79431	247409
6605	5221	1	applied	\N	\N	\N	\N	79433	79433	247411
6606	5222	0	applied	\N	\N	\N	\N	79434	79434	247412
6606	5223	1	applied	\N	\N	\N	\N	79435	79435	247413
6606	5224	2	applied	\N	\N	\N	\N	79436	79436	247414
6606	5225	3	applied	\N	\N	\N	\N	79437	79437	247415
6606	5226	4	applied	\N	\N	\N	\N	79438	79438	247416
6606	5227	5	applied	\N	\N	\N	\N	79439	79439	247417
6606	5228	6	applied	\N	\N	\N	\N	79440	79440	247418
6606	5229	7	applied	\N	\N	\N	\N	79441	79441	247419
6607	5222	0	applied	\N	\N	\N	\N	79442	79442	247420
6607	5223	1	applied	\N	\N	\N	\N	79443	79443	247421
6607	5224	2	applied	\N	\N	\N	\N	79444	79444	247422
6607	5225	3	applied	\N	\N	\N	\N	79445	79445	247423
6607	5226	4	applied	\N	\N	\N	\N	79446	79446	247424
6607	5228	6	applied	\N	\N	\N	\N	79448	79448	247426
6607	5229	7	applied	\N	\N	\N	\N	79449	79449	247427
6608	5230	0	applied	\N	\N	\N	\N	79450	79450	247428
6608	5231	1	applied	\N	\N	\N	\N	79451	79451	247429
6611	5232	0	applied	\N	\N	\N	\N	79456	79456	247434
6611	5233	1	applied	\N	\N	\N	\N	79457	79457	247435
6617	5236	0	applied	\N	\N	\N	\N	79462	79462	247440
6617	5237	1	applied	\N	\N	\N	\N	79463	79463	247441
6618	5238	0	applied	\N	\N	\N	\N	79464	79464	247442
6618	5239	1	applied	\N	\N	\N	\N	79465	79465	247443
6623	5244	0	applied	\N	\N	\N	\N	79474	79474	247452
6623	5245	1	applied	\N	\N	\N	\N	79475	79475	247453
6623	5246	2	applied	\N	\N	\N	\N	79476	79476	247454
6623	5247	3	applied	\N	\N	\N	\N	79477	79477	247455
6624	5248	0	applied	\N	\N	\N	\N	79478	79478	247456
6624	5249	1	applied	\N	\N	\N	\N	79479	79479	247457
6624	5251	3	applied	\N	\N	\N	\N	79481	79481	247459
6625	5252	0	applied	\N	\N	\N	\N	79482	79482	247460
6625	5253	1	applied	\N	\N	\N	\N	79483	79483	247461
6625	5254	2	applied	\N	\N	\N	\N	79484	79484	247462
6625	5248	3	applied	\N	\N	\N	\N	79485	79485	247463
6625	5249	4	applied	\N	\N	\N	\N	79486	79486	247464
6625	5250	5	applied	\N	\N	\N	\N	79487	79487	247465
6625	5251	6	applied	\N	\N	\N	\N	79488	79488	247466
6626	5252	0	applied	\N	\N	\N	\N	79489	79489	247467
6626	5253	1	applied	\N	\N	\N	\N	79490	79490	247468
6626	5254	2	applied	\N	\N	\N	\N	79491	79491	247469
6626	5248	3	applied	\N	\N	\N	\N	79492	79492	247470
6626	5249	4	applied	\N	\N	\N	\N	79493	79493	247471
6626	5250	5	applied	\N	\N	\N	\N	79494	79494	247472
6626	5251	6	applied	\N	\N	\N	\N	79495	79495	247473
6635	5259	0	applied	\N	\N	\N	\N	79508	79508	247486
6636	5261	0	applied	\N	\N	\N	\N	79510	79510	247488
6636	5262	1	applied	\N	\N	\N	\N	79511	79511	247489
6639	5269	0	applied	\N	\N	\N	\N	79520	79520	247498
6639	5270	1	applied	\N	\N	\N	\N	79521	79521	247499
6639	5271	2	applied	\N	\N	\N	\N	79522	79522	247500
6639	5272	3	applied	\N	\N	\N	\N	79523	79523	247501
6641	5275	0	applied	\N	\N	\N	\N	79526	79526	247504
6641	5276	1	applied	\N	\N	\N	\N	79527	79527	247505
6641	5277	2	applied	\N	\N	\N	\N	79528	79528	247506
6641	5278	3	applied	\N	\N	\N	\N	79529	79529	247507
6644	5285	0	applied	\N	\N	\N	\N	79536	79536	247514
6644	5286	1	applied	\N	\N	\N	\N	79537	79537	247515
6647	5287	0	applied	\N	\N	\N	\N	79542	79542	247520
6647	5288	1	applied	\N	\N	\N	\N	79543	79543	247521
6650	5293	0	applied	\N	\N	\N	\N	79550	79550	247528
6650	5294	1	applied	\N	\N	\N	\N	79551	79551	247529
6651	5294	1	applied	\N	\N	\N	\N	79553	79553	247531
6652	5295	0	applied	\N	\N	\N	\N	79554	79554	247532
6652	5296	1	applied	\N	\N	\N	\N	79555	79555	247533
6654	5297	0	applied	\N	\N	\N	\N	79558	79558	247536
6654	5298	1	applied	\N	\N	\N	\N	79559	79559	247537
6654	5299	2	applied	\N	\N	\N	\N	79560	79560	247538
6654	5300	3	applied	\N	\N	\N	\N	79561	79561	247539
6654	5301	4	applied	\N	\N	\N	\N	79562	79562	247540
6654	5302	5	applied	\N	\N	\N	\N	79563	79563	247541
6655	5303	0	applied	\N	\N	\N	\N	79564	79564	247542
6655	5304	1	applied	\N	\N	\N	\N	79565	79565	247543
6656	5303	0	applied	\N	\N	\N	\N	79566	79566	247544
6656	5304	1	applied	\N	\N	\N	\N	79567	79567	247545
6658	5303	0	applied	\N	\N	\N	\N	79570	79570	247548
6658	5304	1	applied	\N	\N	\N	\N	79571	79571	247549
6661	5305	0	applied	\N	\N	\N	\N	79575	79575	247553
6664	5305	0	applied	\N	\N	\N	\N	79583	79583	247561
6664	5307	1	applied	\N	\N	\N	\N	79584	79584	247562
6664	5306	2	applied	\N	\N	\N	\N	79585	79585	247563
6664	5308	3	applied	\N	\N	\N	\N	79586	79586	247564
6665	5309	0	applied	\N	\N	\N	\N	79587	79587	247565
6665	5310	1	applied	\N	\N	\N	\N	79588	79588	247566
6667	5309	0	applied	\N	\N	\N	\N	79591	79591	247569
6667	5310	1	applied	\N	\N	\N	\N	79592	79592	247570
6668	5311	0	applied	\N	\N	\N	\N	79593	79593	247571
6668	5312	1	applied	\N	\N	\N	\N	79594	79594	247572
6670	5313	0	applied	\N	\N	\N	\N	79599	79599	247577
6670	5314	1	applied	\N	\N	\N	\N	79600	79600	247578
6670	5315	2	applied	\N	\N	\N	\N	79601	79601	247579
6670	5316	3	applied	\N	\N	\N	\N	79602	79602	247580
6672	5317	0	applied	\N	\N	\N	\N	79607	79607	247585
6672	5318	1	applied	\N	\N	\N	\N	79608	79608	247586
6677	5325	0	applied	\N	\N	\N	\N	79632	79632	247595
6677	5326	1	applied	\N	\N	\N	\N	79633	79633	247596
6680	5329	0	applied	\N	\N	\N	\N	79641	79641	247604
6680	5330	1	applied	\N	\N	\N	\N	79642	79642	247605
6680	5331	3	applied	\N	\N	\N	\N	79643	79643	247606
6680	5332	4	applied	\N	\N	\N	\N	79644	79644	247607
6680	5333	5	applied	\N	\N	\N	\N	79645	79645	247608
6682	5334	0	applied	\N	\N	\N	\N	79651	79651	247614
6682	5335	1	applied	\N	\N	\N	\N	79652	79652	247615
6682	5336	2	applied	\N	\N	\N	\N	79653	79653	247616
6685	5337	0	applied	\N	\N	\N	\N	79662	79662	247625
6685	5338	1	applied	\N	\N	\N	\N	79663	79663	247626
6685	5339	2	applied	\N	\N	\N	\N	79664	79664	247627
6685	5340	3	applied	\N	\N	\N	\N	79665	79665	247628
6601	5193	1	applied	\N	\N	\N	\N	79417	79417	247395
6604	5216	0	applied	\N	\N	\N	\N	79428	79428	247406
6631	5257	3	applied	\N	\N	\N	\N	79498	79498	247476
6631	5258	4	applied	\N	\N	\N	\N	79499	79499	247477
6633	5259	0	applied	\N	\N	\N	\N	79504	79504	247482
6633	5260	1	applied	\N	\N	\N	\N	79505	79505	247483
6638	5263	0	applied	\N	\N	\N	\N	79514	79514	247492
6638	5264	1	applied	\N	\N	\N	\N	79515	79515	247493
6638	5265	2	applied	\N	\N	\N	\N	79516	79516	247494
6638	5266	3	applied	\N	\N	\N	\N	79517	79517	247495
6638	5267	4	applied	\N	\N	\N	\N	79518	79518	247496
6638	5268	5	applied	\N	\N	\N	\N	79519	79519	247497
6642	5279	0	applied	\N	\N	\N	\N	79530	79530	247508
6642	5281	2	applied	\N	\N	\N	\N	79532	79532	247510
6642	5282	3	applied	\N	\N	\N	\N	79533	79533	247511
6645	5285	0	applied	\N	\N	\N	\N	79538	79538	247516
6645	5286	1	applied	\N	\N	\N	\N	79539	79539	247517
6649	5289	0	applied	\N	\N	\N	\N	79546	79546	247524
6649	5290	1	applied	\N	\N	\N	\N	79547	79547	247525
6649	5291	2	applied	\N	\N	\N	\N	79548	79548	247526
6649	5292	3	applied	\N	\N	\N	\N	79549	79549	247527
6657	5303	0	applied	\N	\N	\N	\N	79568	79568	247546
6657	5304	1	applied	\N	\N	\N	\N	79569	79569	247547
6659	5305	0	applied	\N	\N	\N	\N	79572	79572	247550
6659	5306	1	applied	\N	\N	\N	\N	79573	79573	247551
6663	5307	0	applied	\N	\N	\N	\N	79580	79580	247558
6663	5306	1	applied	\N	\N	\N	\N	79581	79581	247559
6663	5308	2	applied	\N	\N	\N	\N	79582	79582	247560
6666	5309	0	applied	\N	\N	\N	\N	79589	79589	247567
6671	5313	0	applied	\N	\N	\N	\N	79603	79603	247581
6671	5314	1	applied	\N	\N	\N	\N	79604	79604	247582
6671	5315	2	applied	\N	\N	\N	\N	79605	79605	247583
6671	5316	3	applied	\N	\N	\N	\N	79606	79606	247584
6673	5320	1	applied	\N	\N	\N	\N	79610	79610	247588
6675	5251	0	applied	\N	\N	\N	\N	79627	79627	247590
6678	5327	0	applied	\N	\N	\N	\N	79634	79634	247597
6678	5328	1	applied	\N	\N	\N	\N	79635	79635	247598
6681	5329	0	applied	\N	\N	\N	\N	79646	79646	247609
6681	5330	1	applied	\N	\N	\N	\N	79647	79647	247610
6681	5331	3	applied	\N	\N	\N	\N	79648	79648	247611
6681	5332	4	applied	\N	\N	\N	\N	79649	79649	247612
6681	5333	5	applied	\N	\N	\N	\N	79650	79650	247613
6683	5337	0	applied	\N	\N	\N	\N	79654	79654	247617
6683	5338	1	applied	\N	\N	\N	\N	79655	79655	247618
6683	5339	2	applied	\N	\N	\N	\N	79656	79656	247619
6686	5329	0	applied	\N	\N	\N	\N	79666	79666	247629
6686	5335	1	applied	\N	\N	\N	\N	79667	79667	247630
6686	5341	2	applied	\N	\N	\N	\N	79668	79668	247631
6686	5342	3	applied	\N	\N	\N	\N	79669	79669	247632
6686	5343	4	applied	\N	\N	\N	\N	79670	79670	247633
6686	5344	5	applied	\N	\N	\N	\N	79671	79671	247634
6686	5345	6	applied	\N	\N	\N	\N	79672	79672	247635
6688	5352	0	applied	\N	\N	\N	\N	79684	79684	247647
6688	5353	1	applied	\N	\N	\N	\N	79685	79685	247648
6688	5354	2	applied	\N	\N	\N	\N	79686	79686	247649
6688	5355	3	applied	\N	\N	\N	\N	79687	79687	247650
6689	5329	0	applied	\N	\N	\N	\N	79688	79688	247651
6689	5335	1	applied	\N	\N	\N	\N	79689	79689	247652
6689	5251	17	applied	\N	\N	\N	\N	79705	79705	247653
6689	5117	60	applied	\N	\N	\N	\N	79748	79748	247681
6689	4999	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	79691	79691	\N
6689	5003	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	79692	79692	\N
6689	5005	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	79693	79693	\N
6689	5007	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	79694	79694	\N
6689	5008	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	79695	79695	\N
6689	5009	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	79696	79696	\N
6689	5010	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	79697	79697	\N
6689	5014	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	79698	79698	\N
6689	5015	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	79699	79699	\N
6689	5017	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	79700	79700	\N
6689	5020	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	79701	79701	\N
6689	5022	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	79702	79702	\N
6689	5024	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	79703	79703	\N
6689	5027	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	79704	79704	\N
6689	5061	33	applied	\N	\N	1000000000	\N	79721	79721	247654
6689	5029	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	79706	79706	\N
6689	5030	19	failed	Amount_insufficient_to_create_account	\N	\N	\N	79707	79707	\N
6689	5032	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	79708	79708	\N
6689	5034	21	failed	Amount_insufficient_to_create_account	\N	\N	\N	79709	79709	\N
6689	5038	23	failed	Amount_insufficient_to_create_account	\N	\N	\N	79711	79711	\N
6689	5039	24	failed	Amount_insufficient_to_create_account	\N	\N	\N	79712	79712	\N
6689	5044	25	failed	Amount_insufficient_to_create_account	\N	\N	\N	79713	79713	\N
6689	5045	26	failed	Amount_insufficient_to_create_account	\N	\N	\N	79714	79714	\N
6689	5048	27	failed	Amount_insufficient_to_create_account	\N	\N	\N	79715	79715	\N
6689	5049	28	failed	Amount_insufficient_to_create_account	\N	\N	\N	79716	79716	\N
6689	5050	29	failed	Amount_insufficient_to_create_account	\N	\N	\N	79717	79717	\N
6689	5051	30	failed	Amount_insufficient_to_create_account	\N	\N	\N	79718	79718	\N
6689	5055	31	failed	Amount_insufficient_to_create_account	\N	\N	\N	79719	79719	\N
6689	5056	32	failed	Amount_insufficient_to_create_account	\N	\N	\N	79720	79720	\N
6689	5064	34	applied	\N	\N	1000000000	\N	79722	79722	247655
6689	5068	35	applied	\N	\N	\N	\N	79723	79723	247656
6689	5069	36	applied	\N	\N	\N	\N	79724	79724	247657
6689	5072	37	applied	\N	\N	\N	\N	79725	79725	247658
6689	5075	38	applied	\N	\N	\N	\N	79726	79726	247659
6689	5076	39	applied	\N	\N	\N	\N	79727	79727	247660
6689	5077	40	applied	\N	\N	\N	\N	79728	79728	247661
6689	5080	41	applied	\N	\N	\N	\N	79729	79729	247662
6689	5081	42	applied	\N	\N	\N	\N	79730	79730	247663
6689	5084	43	applied	\N	\N	\N	\N	79731	79731	247664
6689	5085	44	applied	\N	\N	\N	\N	79732	79732	247665
6631	5255	0	applied	\N	\N	\N	\N	79496	79496	247474
6631	5256	2	applied	\N	\N	\N	\N	79497	79497	247475
6662	5306	1	applied	\N	\N	\N	\N	79578	79578	247556
6662	5308	2	applied	\N	\N	\N	\N	79579	79579	247557
6669	5313	0	applied	\N	\N	\N	\N	79595	79595	247573
6669	5314	1	applied	\N	\N	\N	\N	79596	79596	247574
6669	5315	2	applied	\N	\N	\N	\N	79597	79597	247575
6669	5316	3	applied	\N	\N	\N	\N	79598	79598	247576
6674	5251	5	applied	\N	\N	\N	\N	79616	79616	247589
6674	4982	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79611	79611	\N
6674	4987	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	79613	79613	\N
6674	4990	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	79614	79614	\N
6674	4991	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	79615	79615	\N
6676	5321	0	applied	\N	\N	\N	\N	79628	79628	247591
6674	4993	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	79617	79617	\N
6674	4994	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	79618	79618	\N
6674	4996	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	79619	79619	\N
6674	4998	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	79620	79620	\N
6674	4999	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	79621	79621	\N
6674	5003	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	79622	79622	\N
6674	5005	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	79623	79623	\N
6674	5007	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	79624	79624	\N
6674	5008	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	79625	79625	\N
6674	5009	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	79626	79626	\N
6676	5322	1	applied	\N	\N	\N	\N	79629	79629	247592
6676	5323	2	applied	\N	\N	\N	\N	79630	79630	247593
6676	5324	3	applied	\N	\N	\N	\N	79631	79631	247594
6679	5329	0	applied	\N	\N	\N	\N	79636	79636	247599
6679	5330	1	applied	\N	\N	\N	\N	79637	79637	247600
6679	5331	3	applied	\N	\N	\N	\N	79638	79638	247601
6679	5332	4	applied	\N	\N	\N	\N	79639	79639	247602
6679	5333	5	applied	\N	\N	\N	\N	79640	79640	247603
6684	5337	0	applied	\N	\N	\N	\N	79658	79658	247621
6684	5338	1	applied	\N	\N	\N	\N	79659	79659	247622
6684	5339	2	applied	\N	\N	\N	\N	79660	79660	247623
6684	5340	3	applied	\N	\N	\N	\N	79661	79661	247624
6687	5346	0	applied	\N	\N	\N	\N	79673	79673	247636
6687	5347	1	applied	\N	\N	\N	\N	79674	79674	247637
6687	5348	2	applied	\N	\N	\N	\N	79675	79675	247638
6687	5349	3	applied	\N	\N	\N	\N	79676	79676	247639
6687	5350	4	applied	\N	\N	\N	\N	79677	79677	247640
6687	5341	6	applied	\N	\N	\N	\N	79679	79679	247642
6687	5342	7	applied	\N	\N	\N	\N	79680	79680	247643
6687	5343	8	applied	\N	\N	\N	\N	79681	79681	247644
6687	5344	9	applied	\N	\N	\N	\N	79682	79682	247645
6687	5345	10	applied	\N	\N	\N	\N	79683	79683	247646
6689	5088	45	applied	\N	\N	\N	\N	79733	79733	247666
6689	5089	46	applied	\N	\N	\N	\N	79734	79734	247667
6689	5091	47	applied	\N	\N	\N	\N	79735	79735	247668
6689	5094	48	applied	\N	\N	\N	\N	79736	79736	247669
6689	5095	49	applied	\N	\N	\N	\N	79737	79737	247670
6689	5096	50	applied	\N	\N	\N	\N	79738	79738	247671
6689	5099	51	applied	\N	\N	\N	\N	79739	79739	247672
6689	5102	52	applied	\N	\N	\N	\N	79740	79740	247673
6689	5104	53	applied	\N	\N	\N	\N	79741	79741	247674
6689	5106	54	applied	\N	\N	\N	\N	79742	79742	247675
6689	5108	55	applied	\N	\N	\N	\N	79743	79743	247676
6689	5112	57	applied	\N	\N	\N	\N	79745	79745	247678
6689	5114	58	applied	\N	\N	\N	\N	79746	79746	247679
6689	5116	59	applied	\N	\N	\N	\N	79747	79747	247680
6689	5119	61	applied	\N	\N	\N	\N	79749	79749	247682
6689	5120	62	applied	\N	\N	\N	\N	79750	79750	247683
6689	5123	63	applied	\N	\N	\N	\N	79751	79751	247684
6689	5126	64	applied	\N	\N	\N	\N	79752	79752	247685
6689	5127	65	applied	\N	\N	\N	\N	79753	79753	247686
6689	5129	66	applied	\N	\N	\N	\N	79754	79754	247687
6689	5132	67	applied	\N	\N	\N	\N	79755	79755	247688
6689	5134	68	applied	\N	\N	\N	\N	79756	79756	247689
6689	5135	69	applied	\N	\N	\N	\N	79757	79757	247690
6689	5138	70	applied	\N	\N	\N	\N	79758	79758	247691
6689	5140	71	applied	\N	\N	\N	\N	79759	79759	247692
6689	5141	72	applied	\N	\N	\N	\N	79760	79760	247693
6689	5146	74	applied	\N	\N	\N	\N	79762	79762	247695
6689	5147	75	applied	\N	\N	\N	\N	79763	79763	247696
6689	5149	76	applied	\N	\N	\N	\N	79764	79764	247697
6689	5151	77	applied	\N	\N	\N	\N	79765	79765	247698
6689	5152	78	applied	\N	\N	\N	\N	79766	79766	247699
6689	5156	79	applied	\N	\N	\N	\N	79767	79767	247700
6689	5158	80	applied	\N	\N	\N	\N	79768	79768	247701
6689	5160	81	applied	\N	\N	\N	\N	79769	79769	247702
6689	5162	82	applied	\N	\N	\N	\N	79770	79770	247703
6689	5164	83	applied	\N	\N	\N	\N	79771	79771	247704
6689	5166	84	applied	\N	\N	\N	\N	79772	79772	247705
6689	5170	85	applied	\N	\N	\N	\N	79773	79773	247706
6689	5171	86	applied	\N	\N	\N	\N	79774	79774	247707
6689	5174	87	applied	\N	\N	\N	\N	79775	79775	247708
6689	5176	88	applied	\N	\N	\N	\N	79776	79776	247709
6689	5179	89	applied	\N	\N	\N	\N	79777	79777	247710
6689	5181	91	applied	\N	\N	\N	\N	79779	79779	247712
6689	5183	92	applied	\N	\N	\N	\N	79780	79780	247713
6689	5186	93	applied	\N	\N	\N	\N	79781	79781	247714
6689	5191	94	applied	\N	\N	\N	\N	79782	79782	247715
6689	5192	95	applied	\N	\N	\N	\N	79783	79783	247716
6689	5194	96	applied	\N	\N	\N	\N	79784	79784	247717
6689	5195	97	applied	\N	\N	\N	\N	79785	79785	247718
6689	5198	98	applied	\N	\N	\N	\N	79786	79786	247719
6689	5199	99	applied	\N	\N	\N	\N	79787	79787	247720
6689	5202	100	applied	\N	\N	\N	\N	79788	79788	247721
6689	5204	101	applied	\N	\N	\N	\N	79789	79789	247722
6689	5207	102	applied	\N	\N	\N	\N	79790	79790	247723
6689	5209	103	applied	\N	\N	\N	\N	79791	79791	247724
6689	5212	105	applied	\N	\N	\N	\N	79792	79792	247725
6689	5213	106	applied	\N	\N	\N	\N	79793	79793	247726
6689	5215	107	applied	\N	\N	\N	\N	79794	79794	247727
6653	5296	1	applied	\N	\N	\N	\N	79557	79557	247535
6662	5307	0	applied	\N	\N	\N	\N	79577	79577	247555
6689	5228	113	applied	\N	\N	\N	\N	79800	79800	247733
6689	5229	114	applied	\N	\N	\N	\N	79801	79801	247734
6689	5230	115	applied	\N	\N	\N	\N	79802	79802	247735
6689	5232	116	applied	\N	\N	\N	\N	79803	79803	247736
6689	5234	117	applied	\N	\N	\N	\N	79804	79804	247737
6689	5236	118	applied	\N	\N	\N	\N	79805	79805	247738
6689	5239	119	applied	\N	\N	\N	\N	79806	79806	247739
6689	5241	120	applied	\N	\N	\N	\N	79807	79807	247740
6689	5243	121	applied	\N	\N	\N	\N	79808	79808	247741
6689	5246	122	applied	\N	\N	\N	\N	79809	79809	247742
6689	5247	123	applied	\N	\N	\N	\N	79810	79810	247743
6689	5252	124	applied	\N	\N	\N	\N	79811	79811	247744
6690	5232	0	applied	\N	\N	\N	\N	79812	79812	247745
6690	5234	1	applied	\N	\N	\N	\N	79813	79813	247746
6690	5236	2	applied	\N	\N	\N	\N	79814	79814	247747
6690	5329	3	applied	\N	\N	\N	\N	79815	79815	247748
6690	5233	5	applied	\N	\N	\N	\N	79817	79817	247750
6690	5235	6	applied	\N	\N	\N	\N	79818	79818	247751
6690	5237	7	applied	\N	\N	\N	\N	79819	79819	247752
6690	5238	8	applied	\N	\N	\N	\N	79820	79820	247753
6690	5240	9	applied	\N	\N	\N	\N	79821	79821	247754
6690	5242	10	applied	\N	\N	\N	\N	79822	79822	247755
6690	5244	11	applied	\N	\N	\N	\N	79823	79823	247756
6690	5245	12	applied	\N	\N	\N	\N	79824	79824	247757
6690	5248	13	applied	\N	\N	\N	\N	79825	79825	247758
6690	5239	14	applied	\N	\N	\N	\N	79826	79826	247759
6690	5241	15	applied	\N	\N	\N	\N	79827	79827	247760
6690	5243	16	applied	\N	\N	\N	\N	79828	79828	247761
6690	5246	17	applied	\N	\N	\N	\N	79829	79829	247762
6690	5247	18	applied	\N	\N	\N	\N	79830	79830	247763
6690	5252	19	applied	\N	\N	\N	\N	79831	79831	247764
6690	5253	20	applied	\N	\N	\N	\N	79832	79832	247765
6690	5255	22	applied	\N	\N	\N	\N	79834	79834	247767
6690	5258	23	applied	\N	\N	\N	\N	79835	79835	247768
6690	5260	24	applied	\N	\N	\N	\N	79836	79836	247769
6690	5261	25	applied	\N	\N	\N	\N	79837	79837	247770
6690	5263	26	applied	\N	\N	\N	\N	79838	79838	247771
6690	5267	27	applied	\N	\N	\N	\N	79839	79839	247772
6690	5268	28	applied	\N	\N	\N	\N	79840	79840	247773
6690	5271	29	applied	\N	\N	\N	\N	79841	79841	247774
6690	5272	30	applied	\N	\N	\N	\N	79842	79842	247775
6690	5273	31	applied	\N	\N	\N	\N	79843	79843	247776
6690	5275	32	applied	\N	\N	\N	\N	79844	79844	247777
6690	5276	33	applied	\N	\N	\N	\N	79845	79845	247778
6690	5249	34	applied	\N	\N	\N	\N	79846	79846	247779
6690	5250	35	applied	\N	\N	\N	\N	79847	79847	247780
6690	5256	36	applied	\N	\N	\N	\N	79848	79848	247781
6690	5257	37	applied	\N	\N	\N	\N	79849	79849	247782
6690	5262	39	applied	\N	\N	\N	\N	79851	79851	247784
6690	5264	41	applied	\N	\N	\N	\N	79852	79852	247785
6690	5265	42	applied	\N	\N	\N	\N	79853	79853	247786
6690	5266	43	applied	\N	\N	\N	\N	79854	79854	247787
6690	5269	44	applied	\N	\N	\N	\N	79855	79855	247788
6690	5270	45	applied	\N	\N	\N	\N	79856	79856	247789
6690	5274	46	applied	\N	\N	\N	\N	79857	79857	247790
6690	5277	47	applied	\N	\N	\N	\N	79858	79858	247791
6690	5278	48	applied	\N	\N	\N	\N	79859	79859	247792
6690	5279	49	applied	\N	\N	\N	\N	79860	79860	247793
6690	5280	50	applied	\N	\N	\N	\N	79861	79861	247794
6690	5251	51	applied	\N	\N	\N	\N	79862	79862	247795
6690	5284	52	applied	\N	\N	\N	\N	79863	79863	247796
6690	5285	53	applied	\N	\N	\N	\N	79864	79864	247797
6690	5288	54	applied	\N	\N	\N	\N	79865	79865	247798
6690	5291	55	applied	\N	\N	\N	\N	79866	79866	247799
6690	5293	57	applied	\N	\N	\N	\N	79868	79868	247801
6690	5295	58	applied	\N	\N	\N	\N	79869	79869	247802
6690	5297	59	applied	\N	\N	\N	\N	79870	79870	247803
6690	5298	60	applied	\N	\N	\N	\N	79871	79871	247804
6690	5299	61	applied	\N	\N	\N	\N	79872	79872	247805
6690	5303	62	applied	\N	\N	\N	\N	79873	79873	247806
6690	5306	63	applied	\N	\N	\N	\N	79874	79874	247807
6690	5308	64	applied	\N	\N	\N	\N	79875	79875	247808
6690	5281	65	applied	\N	\N	\N	\N	79876	79876	247809
6690	5282	66	applied	\N	\N	\N	\N	79877	79877	247810
6690	5283	67	applied	\N	\N	\N	\N	79878	79878	247811
6690	5286	68	applied	\N	\N	\N	\N	79879	79879	247812
6690	5287	69	applied	\N	\N	\N	\N	79880	79880	247813
6690	5289	70	applied	\N	\N	\N	\N	79881	79881	247814
6690	5290	71	applied	\N	\N	\N	\N	79882	79882	247815
6690	5294	72	applied	\N	\N	\N	\N	79883	79883	247816
6690	5300	74	applied	\N	\N	\N	\N	79885	79885	247818
6690	5301	75	applied	\N	\N	\N	\N	79886	79886	247819
6690	5302	76	applied	\N	\N	\N	\N	79887	79887	247820
6690	5304	77	applied	\N	\N	\N	\N	79888	79888	247821
6690	5305	78	applied	\N	\N	\N	\N	79889	79889	247822
6690	5307	79	applied	\N	\N	\N	\N	79890	79890	247823
6690	5309	80	applied	\N	\N	\N	\N	79891	79891	247824
6690	5311	81	applied	\N	\N	\N	\N	79892	79892	247825
6690	5315	82	applied	\N	\N	\N	\N	79893	79893	247826
6690	5316	83	applied	\N	\N	\N	\N	79894	79894	247827
6690	5317	84	applied	\N	\N	\N	\N	79895	79895	247828
6690	5319	85	applied	\N	\N	\N	\N	79896	79896	247829
6690	5321	86	applied	\N	\N	\N	\N	79897	79897	247830
6690	5322	87	applied	\N	\N	\N	\N	79898	79898	247831
6690	5326	88	applied	\N	\N	\N	\N	79899	79899	247832
6690	5328	89	applied	\N	\N	\N	\N	79900	79900	247833
6690	5331	91	applied	\N	\N	\N	\N	79902	79902	247835
6690	5336	92	applied	\N	\N	\N	\N	79903	79903	247836
6690	5339	93	applied	\N	\N	\N	\N	79904	79904	247837
6690	5340	94	applied	\N	\N	\N	\N	79905	79905	247838
6690	5346	95	applied	\N	\N	\N	\N	79906	79906	247839
6690	5347	96	applied	\N	\N	\N	\N	79907	79907	247840
6690	5348	97	applied	\N	\N	\N	\N	79908	79908	247841
6690	5352	98	applied	\N	\N	\N	\N	79909	79909	247842
6690	5353	99	applied	\N	\N	\N	\N	79910	79910	247843
6690	5356	100	applied	\N	\N	\N	\N	79911	79911	247844
6690	5310	101	applied	\N	\N	\N	\N	79912	79912	247845
6690	5312	102	applied	\N	\N	\N	\N	79913	79913	247846
6690	5313	103	applied	\N	\N	\N	\N	79914	79914	247847
6690	5314	104	applied	\N	\N	\N	\N	79915	79915	247848
6689	5221	110	applied	\N	\N	\N	\N	79797	79797	247730
6689	5225	111	applied	\N	\N	\N	\N	79798	79798	247731
6690	5324	108	applied	\N	\N	\N	\N	79919	79919	247852
6690	5325	109	applied	\N	\N	\N	\N	79920	79920	247853
6690	5327	110	applied	\N	\N	\N	\N	79921	79921	247854
6690	5332	111	applied	\N	\N	\N	\N	79922	79922	247855
6690	5333	112	applied	\N	\N	\N	\N	79923	79923	247856
6690	5334	113	applied	\N	\N	\N	\N	79924	79924	247857
6690	5337	114	applied	\N	\N	\N	\N	79925	79925	247858
6690	5338	115	applied	\N	\N	\N	\N	79926	79926	247859
6690	5349	116	applied	\N	\N	\N	\N	79927	79927	247860
6690	5350	117	applied	\N	\N	\N	\N	79928	79928	247861
6690	5351	118	applied	\N	\N	\N	\N	79929	79929	247862
6690	5355	120	applied	\N	\N	\N	\N	79931	79931	247864
6690	5357	121	applied	\N	\N	\N	\N	79932	79932	247865
6690	5341	122	applied	\N	\N	\N	\N	79933	79933	247866
6690	5342	123	applied	\N	\N	\N	\N	79934	79934	247867
6690	5343	124	applied	\N	\N	\N	\N	79935	79935	247868
6690	5344	125	applied	\N	\N	\N	\N	79936	79936	247869
6691	5356	0	applied	\N	\N	\N	\N	79937	79937	247870
6691	5358	1	applied	\N	\N	\N	\N	79938	79938	247871
6691	5357	2	applied	\N	\N	\N	\N	79939	79939	247872
6691	5359	3	applied	\N	\N	\N	\N	79940	79940	247873
6692	5356	0	applied	\N	\N	\N	\N	79941	79941	247874
6692	5358	1	applied	\N	\N	\N	\N	79942	79942	247875
6692	5357	2	applied	\N	\N	\N	\N	79943	79943	247876
6692	5359	3	applied	\N	\N	\N	\N	79944	79944	247877
6693	5360	0	applied	\N	\N	\N	\N	79945	79945	247878
6693	5361	1	applied	\N	\N	\N	\N	79946	79946	247879
6694	5363	1	applied	\N	\N	\N	\N	79948	79948	247881
6694	5364	2	applied	\N	\N	\N	\N	79949	79949	247882
6694	5365	3	applied	\N	\N	\N	\N	79950	79950	247883
6694	5366	4	applied	\N	\N	\N	\N	79951	79951	247884
6694	5367	5	applied	\N	\N	\N	\N	79952	79952	247885
6695	5368	0	applied	\N	\N	\N	\N	79953	79953	247886
6695	5369	1	applied	\N	\N	\N	\N	79954	79954	247887
6695	5370	2	applied	\N	\N	\N	\N	79955	79955	247888
6695	5371	3	applied	\N	\N	\N	\N	79956	79956	247889
6696	5368	0	applied	\N	\N	\N	\N	79957	79957	247890
6696	5369	1	applied	\N	\N	\N	\N	79958	79958	247891
6696	5370	2	applied	\N	\N	\N	\N	79959	79959	247892
6696	5371	3	applied	\N	\N	\N	\N	79960	79960	247893
6697	5372	0	applied	\N	\N	\N	\N	79961	79961	247894
6697	5373	1	applied	\N	\N	\N	\N	79962	79962	247895
6697	5374	2	applied	\N	\N	\N	\N	79963	79963	247896
6698	5372	0	applied	\N	\N	\N	\N	79965	79965	247898
6698	5373	1	applied	\N	\N	\N	\N	79966	79966	247899
6698	5374	2	applied	\N	\N	\N	\N	79967	79967	247900
6698	5375	3	applied	\N	\N	\N	\N	79968	79968	247901
6699	5376	0	applied	\N	\N	\N	\N	79969	79969	247902
6699	5377	1	applied	\N	\N	\N	\N	79970	79970	247903
6700	5378	0	applied	\N	\N	\N	\N	79971	79971	247904
6700	5379	1	applied	\N	\N	\N	\N	79972	79972	247905
6701	5378	0	applied	\N	\N	\N	\N	79973	79973	247906
6701	5379	1	applied	\N	\N	\N	\N	79974	79974	247907
6710	5402	0	applied	\N	\N	\N	\N	80122	80122	248055
6710	5403	1	applied	\N	\N	\N	\N	80123	80123	248056
6712	5402	0	applied	\N	\N	\N	\N	80126	80126	248059
6712	5403	1	applied	\N	\N	\N	\N	80127	80127	248060
6715	5406	0	applied	\N	\N	\N	\N	80132	80132	248065
6715	5407	1	applied	\N	\N	\N	\N	80133	80133	248066
6718	5415	1	applied	\N	\N	\N	\N	80141	80141	248074
6718	5416	2	applied	\N	\N	\N	\N	80142	80142	248075
6718	5417	3	applied	\N	\N	\N	\N	80143	80143	248076
6721	5422	0	applied	\N	\N	\N	\N	80160	80160	248093
6721	5423	1	applied	\N	\N	\N	\N	80161	80161	248094
6721	5424	2	applied	\N	\N	\N	\N	80162	80162	248095
6721	5425	3	applied	\N	\N	\N	\N	80163	80163	248096
6723	5426	0	applied	\N	\N	\N	\N	80168	80168	248101
6723	5427	1	applied	\N	\N	\N	\N	80169	80169	248102
6730	5434	0	applied	\N	\N	\N	\N	80180	80180	248113
6730	5435	1	applied	\N	\N	\N	\N	80181	80181	248114
6733	5436	0	applied	\N	\N	\N	\N	80188	80188	248121
6733	5437	1	applied	\N	\N	\N	\N	80189	80189	248122
6733	5438	2	applied	\N	\N	\N	\N	80190	80190	248123
6733	5439	3	applied	\N	\N	\N	\N	80191	80191	248124
6742	5448	0	applied	\N	\N	\N	\N	80208	80208	248141
6752	5462	0	applied	\N	\N	\N	\N	80232	80232	248165
6752	5463	1	applied	\N	\N	\N	\N	80233	80233	248166
6764	5483	0	applied	\N	\N	1000000000	\N	80280	80280	248213
6764	5484	1	applied	\N	\N	\N	\N	80281	80281	248214
6764	5485	2	applied	\N	\N	\N	\N	80282	80282	248215
6766	5486	0	applied	\N	\N	\N	\N	80286	80286	248219
6769	5487	0	applied	\N	\N	\N	\N	80291	80291	248224
6769	5488	1	applied	\N	\N	\N	\N	80292	80292	248225
6769	5489	2	applied	\N	\N	\N	\N	80293	80293	248226
6769	5490	3	applied	\N	\N	\N	\N	80294	80294	248227
6774	5493	0	applied	\N	\N	\N	\N	80301	80301	248234
6774	5494	1	applied	\N	\N	\N	\N	80302	80302	248235
6778	5499	0	applied	\N	\N	\N	\N	80309	80309	248242
6778	5500	1	applied	\N	\N	\N	\N	80310	80310	248243
6783	5505	0	applied	\N	\N	\N	\N	80317	80317	248250
6783	5506	1	applied	\N	\N	\N	\N	80318	80318	248251
6786	5510	1	applied	\N	\N	\N	\N	80322	80322	248255
6786	5511	2	applied	\N	\N	\N	\N	80323	80323	248256
6786	5512	3	applied	\N	\N	\N	\N	80324	80324	248257
6792	5515	0	applied	\N	\N	\N	\N	80339	80339	248272
6792	5516	1	applied	\N	\N	\N	\N	80340	80340	248273
6792	5517	2	applied	\N	\N	\N	\N	80341	80341	248274
6792	5518	3	applied	\N	\N	\N	\N	80342	80342	248275
6800	5533	0	applied	\N	\N	\N	\N	80361	80361	248294
6800	5534	1	applied	\N	\N	\N	\N	80362	80362	248295
6810	5537	0	applied	\N	\N	\N	\N	80380	80380	248313
6810	5538	1	applied	\N	\N	\N	\N	80381	80381	248314
6810	5539	2	applied	\N	\N	\N	\N	80382	80382	248315
6810	5540	3	applied	\N	\N	\N	\N	80383	80383	248316
6811	5541	0	applied	\N	\N	\N	\N	80384	80384	248317
6811	5542	1	applied	\N	\N	\N	\N	80385	80385	248318
6814	5545	0	applied	\N	\N	\N	\N	80392	80392	248325
6814	5547	2	applied	\N	\N	1000000000	\N	80394	80394	248327
6814	5548	3	applied	\N	\N	\N	\N	80395	80395	248328
6690	5320	106	applied	\N	\N	\N	\N	79917	79917	247850
6690	5323	107	applied	\N	\N	\N	\N	79918	79918	247851
6702	5188	4	applied	\N	\N	\N	\N	79978	79978	247911
6702	5197	5	applied	\N	\N	1000000000	\N	79979	79979	247912
6702	5175	6	applied	\N	\N	\N	\N	79980	79980	247913
6702	5177	7	applied	\N	\N	\N	\N	79981	79981	247914
6702	5178	8	applied	\N	\N	\N	\N	79982	79982	247915
6702	5184	10	applied	\N	\N	\N	\N	79984	79984	247917
6702	5187	11	applied	\N	\N	\N	\N	79985	79985	247918
6702	5176	12	applied	\N	\N	\N	\N	79986	79986	247919
6702	5179	13	applied	\N	\N	\N	\N	79987	79987	247920
6702	5189	14	applied	\N	\N	\N	\N	79988	79988	247921
6702	5190	15	applied	\N	\N	\N	\N	79989	79989	247922
6702	5196	16	applied	\N	\N	\N	\N	79990	79990	247923
6702	5200	17	applied	\N	\N	\N	\N	79991	79991	247924
6702	5201	18	applied	\N	\N	\N	\N	79992	79992	247925
6702	5251	19	applied	\N	\N	\N	\N	79993	79993	247926
6702	5203	20	applied	\N	\N	\N	\N	79994	79994	247927
6702	5205	21	applied	\N	\N	\N	\N	79995	79995	247928
6702	5206	22	applied	\N	\N	\N	\N	79996	79996	247929
6702	5208	23	applied	\N	\N	\N	\N	79997	79997	247930
6702	5210	24	applied	\N	\N	\N	\N	79998	79998	247931
6702	5211	25	applied	\N	\N	\N	\N	79999	79999	247932
6702	5216	27	applied	\N	\N	\N	\N	80001	80001	247934
6702	5217	28	applied	\N	\N	\N	\N	80002	80002	247935
6702	5220	29	applied	\N	\N	\N	\N	80003	80003	247936
6702	5222	30	applied	\N	\N	\N	\N	80004	80004	247937
6702	5223	31	applied	\N	\N	\N	\N	80005	80005	247938
6702	5224	32	applied	\N	\N	\N	\N	80006	80006	247939
6702	5226	33	applied	\N	\N	\N	\N	80007	80007	247940
6702	5231	34	applied	\N	\N	\N	\N	80008	80008	247941
6702	5233	35	applied	\N	\N	\N	\N	80009	80009	247942
6702	5235	36	applied	\N	\N	\N	\N	80010	80010	247943
6702	5237	37	applied	\N	\N	\N	\N	80011	80011	247944
6702	5238	38	applied	\N	\N	\N	\N	80012	80012	247945
6702	5240	39	applied	\N	\N	\N	\N	80013	80013	247946
6702	5242	40	applied	\N	\N	\N	\N	80014	80014	247947
6702	5244	41	applied	\N	\N	\N	\N	80015	80015	247948
6702	5245	42	applied	\N	\N	\N	\N	80016	80016	247949
6702	5249	44	applied	\N	\N	\N	\N	80018	80018	247951
6702	5250	45	applied	\N	\N	\N	\N	80019	80019	247952
6702	5256	46	applied	\N	\N	\N	\N	80020	80020	247953
6702	5257	47	applied	\N	\N	\N	\N	80021	80021	247954
6702	5259	48	applied	\N	\N	\N	\N	80022	80022	247955
6702	5262	49	applied	\N	\N	\N	\N	80023	80023	247956
6702	5264	50	applied	\N	\N	\N	\N	80024	80024	247957
6702	5265	51	applied	\N	\N	\N	\N	80025	80025	247958
6702	5266	52	applied	\N	\N	\N	\N	80026	80026	247959
6702	5269	53	applied	\N	\N	\N	\N	80027	80027	247960
6702	5270	54	applied	\N	\N	\N	\N	80028	80028	247961
6702	5274	55	applied	\N	\N	\N	\N	80029	80029	247962
6702	5277	56	applied	\N	\N	\N	\N	80030	80030	247963
6702	5278	57	applied	\N	\N	\N	\N	80031	80031	247964
6702	5279	58	applied	\N	\N	\N	\N	80032	80032	247965
6702	5280	59	applied	\N	\N	\N	\N	80033	80033	247966
6702	5285	61	applied	\N	\N	\N	\N	80035	80035	247968
6702	5288	62	applied	\N	\N	\N	\N	80036	80036	247969
6816	5549	0	applied	\N	\N	\N	\N	80400	80400	248333
6816	5550	1	applied	\N	\N	\N	\N	80401	80401	248334
6816	5551	2	applied	\N	\N	\N	\N	80402	80402	248335
6816	5552	3	applied	\N	\N	\N	\N	80403	80403	248336
6822	5566	0	applied	\N	\N	\N	\N	80419	80419	248352
6822	5567	1	applied	\N	\N	\N	\N	80420	80420	248353
6824	5566	0	applied	\N	\N	\N	\N	80423	80423	248356
6824	5567	1	applied	\N	\N	\N	\N	80424	80424	248357
6826	5568	0	applied	\N	\N	\N	\N	80427	80427	248360
6826	5569	1	applied	\N	\N	\N	\N	80428	80428	248361
6827	5570	0	applied	\N	\N	\N	\N	80429	80429	248362
6827	5571	1	applied	\N	\N	\N	\N	80430	80430	248363
6827	5572	2	applied	\N	\N	\N	\N	80431	80431	248364
6827	5573	3	applied	\N	\N	\N	\N	80432	80432	248365
6827	5575	5	applied	\N	\N	\N	\N	80434	80434	248367
6827	5576	6	applied	\N	\N	\N	\N	80435	80435	248368
6827	5577	7	applied	\N	\N	\N	\N	80436	80436	248369
6830	5578	0	applied	\N	\N	\N	\N	80447	80447	248380
6830	5579	1	applied	\N	\N	\N	\N	80448	80448	248381
6834	5580	0	applied	\N	\N	\N	\N	80454	80454	248387
6834	5581	1	applied	\N	\N	\N	\N	80455	80455	248388
6837	5582	0	applied	\N	\N	\N	\N	80460	80460	248393
6837	5583	1	applied	\N	\N	\N	\N	80461	80461	248394
6843	5588	0	applied	\N	\N	\N	\N	80476	80476	248409
6848	5595	0	applied	\N	\N	\N	\N	80498	80498	248431
6848	5596	1	applied	\N	\N	\N	\N	80499	80499	248432
6848	5597	2	applied	\N	\N	\N	\N	80500	80500	248433
6850	5592	0	applied	\N	\N	\N	\N	80507	80507	248440
6850	5593	1	applied	\N	\N	\N	\N	80508	80508	248441
6850	5594	2	applied	\N	\N	\N	\N	80509	80509	248442
6850	5596	4	applied	\N	\N	\N	\N	80511	80511	248444
6850	5597	5	applied	\N	\N	\N	\N	80512	80512	248445
6850	5598	6	applied	\N	\N	\N	\N	80513	80513	248446
6857	5607	1	applied	\N	\N	\N	\N	80539	80539	248470
6857	5608	2	applied	\N	\N	\N	\N	80540	80540	248471
6857	5609	3	applied	\N	\N	\N	\N	80541	80541	248472
6857	5610	4	applied	\N	\N	\N	\N	80542	80542	248473
6857	5611	5	applied	\N	\N	\N	\N	80543	80543	248474
6857	5612	6	applied	\N	\N	\N	\N	80544	80544	248475
6857	5613	7	applied	\N	\N	\N	\N	80545	80545	248476
6857	5614	8	applied	\N	\N	\N	\N	80546	80546	248477
6859	5615	0	applied	\N	\N	\N	\N	80549	80549	248480
6859	5616	1	applied	\N	\N	\N	\N	80550	80550	248481
6864	5625	0	applied	\N	\N	\N	\N	80561	80561	248492
6864	5626	1	applied	\N	\N	\N	\N	80562	80562	248493
6864	5628	3	applied	\N	\N	1000000000	\N	80564	80564	248495
6864	5629	4	applied	\N	\N	\N	\N	80565	80565	248496
6869	5638	0	applied	\N	\N	\N	\N	80579	80579	248510
6869	5639	1	applied	\N	\N	\N	\N	80580	80580	248511
6872	5638	0	applied	\N	\N	\N	\N	80585	80585	248516
6872	5639	1	applied	\N	\N	\N	\N	80586	80586	248517
6878	5358	0	applied	\N	\N	\N	\N	80597	80597	248528
6878	5359	1	applied	\N	\N	\N	\N	80598	80598	248529
6702	5329	1	applied	\N	\N	\N	\N	79976	79976	247909
6702	5335	3	applied	\N	\N	\N	\N	79977	79977	247910
6702	5295	66	applied	\N	\N	\N	\N	80040	80040	247973
6702	5297	67	applied	\N	\N	\N	\N	80041	80041	247974
6702	5298	68	applied	\N	\N	\N	\N	80042	80042	247975
6702	5299	69	applied	\N	\N	\N	\N	80043	80043	247976
6702	5303	70	applied	\N	\N	\N	\N	80044	80044	247977
6702	5306	71	applied	\N	\N	\N	\N	80045	80045	247978
6702	5308	72	applied	\N	\N	\N	\N	80046	80046	247979
6702	5180	73	applied	\N	\N	\N	\N	80047	80047	247980
6702	5181	74	applied	\N	\N	\N	\N	80048	80048	247981
6702	5183	75	applied	\N	\N	\N	\N	80049	80049	247982
6702	5186	76	applied	\N	\N	\N	\N	80050	80050	247983
6702	5192	78	applied	\N	\N	\N	\N	80052	80052	247985
6702	5194	79	applied	\N	\N	\N	\N	80053	80053	247986
6702	5195	80	applied	\N	\N	\N	\N	80054	80054	247987
6702	5198	81	applied	\N	\N	\N	\N	80055	80055	247988
6702	5199	82	applied	\N	\N	\N	\N	80056	80056	247989
6702	5202	83	applied	\N	\N	\N	\N	80057	80057	247990
6702	5204	84	applied	\N	\N	\N	\N	80058	80058	247991
6702	5207	85	applied	\N	\N	\N	\N	80059	80059	247992
6702	5209	86	applied	\N	\N	\N	\N	80060	80060	247993
6702	5212	87	applied	\N	\N	\N	\N	80061	80061	247994
6702	5213	88	applied	\N	\N	\N	\N	80062	80062	247995
6702	5215	89	applied	\N	\N	\N	\N	80063	80063	247996
6702	5218	90	applied	\N	\N	\N	\N	80064	80064	247997
6702	5219	91	applied	\N	\N	\N	\N	80065	80065	247998
6702	5221	92	applied	\N	\N	\N	\N	80066	80066	247999
6702	5225	93	applied	\N	\N	\N	\N	80067	80067	248000
6702	5228	95	applied	\N	\N	\N	\N	80069	80069	248002
6702	5229	96	applied	\N	\N	\N	\N	80070	80070	248003
6702	5230	97	applied	\N	\N	\N	\N	80071	80071	248004
6702	5232	98	applied	\N	\N	\N	\N	80072	80072	248005
6702	5234	99	applied	\N	\N	\N	\N	80073	80073	248006
6702	5236	100	applied	\N	\N	\N	\N	80074	80074	248007
6702	5239	101	applied	\N	\N	\N	\N	80075	80075	248008
6702	5241	102	applied	\N	\N	\N	\N	80076	80076	248009
6702	5243	103	applied	\N	\N	\N	\N	80077	80077	248010
6702	5246	104	applied	\N	\N	\N	\N	80078	80078	248011
6702	5247	105	applied	\N	\N	\N	\N	80079	80079	248012
6702	5252	106	applied	\N	\N	\N	\N	80080	80080	248013
6702	5253	107	applied	\N	\N	\N	\N	80081	80081	248014
6702	5254	108	applied	\N	\N	\N	\N	80082	80082	248015
6702	5255	109	applied	\N	\N	\N	\N	80083	80083	248016
6702	5258	110	applied	\N	\N	\N	\N	80084	80084	248017
6702	5261	112	applied	\N	\N	\N	\N	80086	80086	248019
6702	5263	113	applied	\N	\N	\N	\N	80087	80087	248020
6702	5267	114	applied	\N	\N	\N	\N	80088	80088	248021
6702	5268	115	applied	\N	\N	\N	\N	80089	80089	248022
6702	5271	116	applied	\N	\N	\N	\N	80090	80090	248023
6702	5272	117	applied	\N	\N	\N	\N	80091	80091	248024
6702	5273	118	applied	\N	\N	\N	\N	80092	80092	248025
6702	5275	119	applied	\N	\N	\N	\N	80093	80093	248026
6702	5276	120	applied	\N	\N	\N	\N	80094	80094	248027
6702	5281	121	applied	\N	\N	\N	\N	80095	80095	248028
6702	5282	122	applied	\N	\N	\N	\N	80096	80096	248029
6702	5283	123	applied	\N	\N	\N	\N	80097	80097	248030
6702	5286	124	applied	\N	\N	\N	\N	80098	80098	248031
6702	5287	125	applied	\N	\N	\N	\N	80099	80099	248032
6705	5390	0	applied	\N	\N	\N	\N	80110	80110	248043
6705	5391	1	applied	\N	\N	\N	\N	80111	80111	248044
6708	5399	1	applied	\N	\N	\N	\N	80119	80119	248052
6713	5404	0	applied	\N	\N	\N	\N	80128	80128	248061
6713	5405	1	applied	\N	\N	\N	\N	80129	80129	248062
6719	5418	0	applied	\N	\N	\N	\N	80144	80144	248077
6719	5419	1	applied	\N	\N	\N	\N	80145	80145	248078
6719	5420	2	applied	\N	\N	\N	\N	80146	80146	248079
6719	5421	3	applied	\N	\N	\N	\N	80147	80147	248080
6726	5428	0	applied	\N	\N	\N	\N	80174	80174	248107
6726	5429	1	applied	\N	\N	\N	\N	80175	80175	248108
6731	5434	0	applied	\N	\N	\N	\N	80182	80182	248115
6731	5435	1	applied	\N	\N	\N	\N	80183	80183	248116
6738	5442	0	applied	\N	\N	\N	\N	80200	80200	248133
6738	5443	1	applied	\N	\N	\N	\N	80201	80201	248134
6740	5444	0	applied	\N	\N	\N	\N	80204	80204	248137
6740	5445	1	applied	\N	\N	\N	\N	80205	80205	248138
6743	5448	0	applied	\N	\N	\N	\N	80210	80210	248143
6747	5454	0	applied	\N	\N	\N	\N	80218	80218	248151
6747	5455	1	applied	\N	\N	\N	\N	80219	80219	248152
6750	5460	0	applied	\N	\N	\N	\N	80228	80228	248161
6750	5461	1	applied	\N	\N	\N	\N	80229	80229	248162
6757	5468	0	applied	\N	\N	\N	\N	80242	80242	248175
6757	5469	1	applied	\N	\N	\N	\N	80243	80243	248176
6760	5470	0	applied	\N	\N	\N	\N	80254	80254	248187
6760	5471	1	applied	\N	\N	\N	\N	80255	80255	248188
6760	5472	2	applied	\N	\N	\N	\N	80256	80256	248189
6760	5473	3	applied	\N	\N	\N	\N	80257	80257	248190
6760	5474	4	applied	\N	\N	\N	\N	80258	80258	248191
6760	5475	5	applied	\N	\N	\N	\N	80259	80259	248192
6760	5476	6	applied	\N	\N	\N	\N	80260	80260	248193
6760	5477	7	applied	\N	\N	\N	\N	80261	80261	248194
6762	5479	1	applied	\N	\N	1000000000	\N	80271	80271	248204
6762	5480	2	applied	\N	\N	\N	\N	80272	80272	248205
6762	5481	3	applied	\N	\N	\N	\N	80273	80273	248206
6762	5482	4	applied	\N	\N	1000000000	\N	80274	80274	248207
6776	5495	0	applied	\N	\N	\N	\N	80305	80305	248238
6776	5496	1	applied	\N	\N	\N	\N	80306	80306	248239
6781	5503	0	applied	\N	\N	\N	\N	80313	80313	248246
6781	5504	1	applied	\N	\N	\N	\N	80314	80314	248247
6787	5509	0	applied	\N	\N	\N	\N	80325	80325	248258
6787	5510	1	applied	\N	\N	\N	\N	80326	80326	248259
6787	5511	2	applied	\N	\N	\N	\N	80327	80327	248260
6787	5512	3	applied	\N	\N	\N	\N	80328	80328	248261
6788	5513	0	applied	\N	\N	\N	\N	80329	80329	248262
6788	5514	1	applied	\N	\N	\N	\N	80330	80330	248263
6790	5513	0	applied	\N	\N	\N	\N	80333	80333	248266
6790	5514	1	applied	\N	\N	\N	\N	80334	80334	248267
6793	5519	0	applied	\N	\N	\N	\N	80343	80343	248276
6793	5520	1	applied	\N	\N	\N	\N	80344	80344	248277
6795	5521	0	applied	\N	\N	\N	\N	80347	80347	248280
6795	5522	1	applied	\N	\N	\N	\N	80348	80348	248281
6702	5292	64	applied	\N	\N	\N	\N	80038	80038	247971
6702	5293	65	applied	\N	\N	\N	\N	80039	80039	247972
6703	5383	3	applied	\N	\N	\N	\N	80103	80103	248036
6704	5384	0	applied	\N	\N	\N	\N	80104	80104	248037
6704	5385	1	applied	\N	\N	\N	\N	80105	80105	248038
6704	5386	2	applied	\N	\N	\N	\N	80106	80106	248039
6704	5387	3	applied	\N	\N	\N	\N	80107	80107	248040
6704	5388	4	applied	\N	\N	\N	\N	80108	80108	248041
6704	5389	5	applied	\N	\N	\N	\N	80109	80109	248042
6707	5392	0	applied	\N	\N	\N	\N	80112	80112	248045
6707	5393	1	applied	\N	\N	\N	\N	80113	80113	248046
6707	5395	3	applied	\N	\N	\N	\N	80115	80115	248048
6707	5396	4	applied	\N	\N	\N	\N	80116	80116	248049
6707	5397	5	applied	\N	\N	\N	\N	80117	80117	248050
6714	5406	0	applied	\N	\N	\N	\N	80130	80130	248063
6714	5407	1	applied	\N	\N	\N	\N	80131	80131	248064
6717	5412	0	applied	\N	\N	\N	\N	80138	80138	248071
6717	5413	1	applied	\N	\N	\N	\N	80139	80139	248072
6720	5185	0	applied	\N	\N	\N	\N	80148	80148	248081
6720	5329	1	applied	\N	\N	\N	\N	80149	80149	248082
6720	5335	2	applied	\N	\N	\N	\N	80150	80150	248083
6720	5188	3	applied	\N	\N	\N	\N	80151	80151	248084
6720	5197	4	applied	\N	\N	1000000000	\N	80152	80152	248085
6720	5251	5	applied	\N	\N	\N	\N	80153	80153	248086
6720	5341	6	applied	\N	\N	\N	\N	80154	80154	248087
6720	5342	7	applied	\N	\N	\N	\N	80155	80155	248088
6720	5193	8	applied	\N	\N	\N	\N	80156	80156	248089
6720	5344	10	applied	\N	\N	\N	\N	80158	80158	248091
6720	5345	11	applied	\N	\N	\N	\N	80159	80159	248092
6725	5426	0	applied	\N	\N	\N	\N	80172	80172	248105
6725	5427	1	applied	\N	\N	\N	\N	80173	80173	248106
6727	5430	0	applied	\N	\N	\N	\N	80176	80176	248109
6727	5431	1	applied	\N	\N	\N	\N	80177	80177	248110
6732	5436	0	applied	\N	\N	\N	\N	80184	80184	248117
6732	5437	1	applied	\N	\N	\N	\N	80185	80185	248118
6732	5438	2	applied	\N	\N	\N	\N	80186	80186	248119
6732	5439	3	applied	\N	\N	\N	\N	80187	80187	248120
6735	5440	0	applied	\N	\N	\N	\N	80194	80194	248127
6735	5441	1	applied	\N	\N	\N	\N	80195	80195	248128
6737	5442	0	applied	\N	\N	\N	\N	80198	80198	248131
6737	5443	1	applied	\N	\N	\N	\N	80199	80199	248132
6739	5444	0	applied	\N	\N	\N	\N	80202	80202	248135
6739	5445	1	applied	\N	\N	\N	\N	80203	80203	248136
6741	5447	1	applied	\N	\N	\N	\N	80207	80207	248140
6744	5448	0	applied	\N	\N	\N	\N	80212	80212	248145
6744	5449	1	applied	\N	\N	\N	\N	80213	80213	248146
6746	5452	0	applied	\N	\N	\N	\N	80216	80216	248149
6746	5453	1	applied	\N	\N	\N	\N	80217	80217	248150
6749	5456	0	applied	\N	\N	\N	\N	80224	80224	248157
6749	5457	1	applied	\N	\N	\N	\N	80225	80225	248158
6749	5458	2	applied	\N	\N	\N	\N	80226	80226	248159
6749	5459	3	applied	\N	\N	\N	\N	80227	80227	248160
6751	5462	0	applied	\N	\N	\N	\N	80230	80230	248163
6751	5463	1	applied	\N	\N	\N	\N	80231	80231	248164
6754	5464	0	applied	\N	\N	\N	\N	80236	80236	248169
6754	5465	1	applied	\N	\N	\N	\N	80237	80237	248170
6756	5466	0	applied	\N	\N	\N	\N	80240	80240	248173
6798	5527	2	applied	\N	\N	\N	\N	80355	80355	248288
6798	5528	3	applied	\N	\N	\N	\N	80356	80356	248289
6798	5529	4	applied	\N	\N	\N	\N	80357	80357	248290
6798	5530	5	applied	\N	\N	\N	\N	80358	80358	248291
6801	5533	0	applied	\N	\N	\N	\N	80363	80363	248296
6801	5534	1	applied	\N	\N	\N	\N	80364	80364	248297
6805	5535	0	applied	\N	\N	\N	\N	80367	80367	248300
6807	5535	0	applied	\N	\N	\N	\N	80370	80370	248303
6807	5536	1	applied	\N	\N	\N	\N	80371	80371	248304
6812	5543	0	applied	\N	\N	\N	\N	80386	80386	248319
6812	5544	1	applied	\N	\N	\N	\N	80387	80387	248320
6817	5553	0	applied	\N	\N	\N	\N	80404	80404	248337
6817	5554	1	applied	\N	\N	\N	\N	80405	80405	248338
6817	5555	2	applied	\N	\N	1000000000	\N	80406	80406	248339
6819	5556	0	applied	\N	\N	\N	\N	80409	80409	248342
6819	5557	1	applied	\N	\N	\N	\N	80410	80410	248343
6828	5570	0	applied	\N	\N	\N	\N	80437	80437	248370
6828	5571	1	applied	\N	\N	\N	\N	80438	80438	248371
6828	5572	2	applied	\N	\N	\N	\N	80439	80439	248372
6828	5573	3	applied	\N	\N	\N	\N	80440	80440	248373
6828	5575	5	applied	\N	\N	\N	\N	80442	80442	248375
6828	5576	6	applied	\N	\N	\N	\N	80443	80443	248376
6828	5577	7	applied	\N	\N	\N	\N	80444	80444	248377
6832	5578	0	applied	\N	\N	\N	\N	80451	80451	248384
6832	5579	1	applied	\N	\N	\N	\N	80452	80452	248385
6839	5584	0	applied	\N	\N	\N	\N	80464	80464	248397
6839	5585	1	applied	\N	\N	\N	\N	80465	80465	248398
6839	5586	2	applied	\N	\N	\N	\N	80466	80466	248399
6839	5587	3	applied	\N	\N	\N	\N	80467	80467	248400
6841	5588	0	applied	\N	\N	\N	\N	80472	80472	248405
6841	5589	1	applied	\N	\N	\N	\N	80473	80473	248406
6846	5592	0	applied	\N	\N	\N	\N	80486	80486	248419
6846	5593	1	applied	\N	\N	\N	\N	80487	80487	248420
6846	5594	2	applied	\N	\N	\N	\N	80488	80488	248421
6846	5595	3	applied	\N	\N	\N	\N	80489	80489	248422
6846	5596	4	applied	\N	\N	\N	\N	80490	80490	248423
6855	5602	0	applied	\N	\N	\N	\N	80525	80525	248458
6855	5603	1	applied	\N	\N	\N	\N	80526	80526	248459
6855	5604	2	applied	\N	\N	\N	\N	80527	80527	248460
6855	5605	3	applied	\N	\N	\N	\N	80528	80528	248461
6862	5619	0	applied	\N	\N	\N	\N	80555	80555	248486
6862	5620	1	applied	\N	\N	\N	\N	80556	80556	248487
6862	5621	2	applied	\N	\N	\N	\N	80557	80557	248488
6862	5622	3	applied	\N	\N	\N	\N	80558	80558	248489
6865	5625	0	applied	\N	\N	\N	\N	80566	80566	248497
6865	5626	1	applied	\N	\N	\N	\N	80567	80567	248498
6865	5627	2	applied	\N	\N	\N	\N	80568	80568	248499
6865	5628	3	applied	\N	\N	1000000000	\N	80569	80569	248500
6865	5629	4	applied	\N	\N	\N	\N	80570	80570	248501
6870	5638	0	applied	\N	\N	\N	\N	80581	80581	248512
6870	5639	1	applied	\N	\N	\N	\N	80582	80582	248513
6873	5638	0	applied	\N	\N	\N	\N	80587	80587	248518
6876	5640	0	applied	\N	\N	\N	\N	80593	80593	248524
6876	5641	1	applied	\N	\N	\N	\N	80594	80594	248525
6703	5381	1	applied	\N	\N	\N	\N	80101	80101	248034
6703	5382	2	applied	\N	\N	\N	\N	80102	80102	248035
6711	5403	1	applied	\N	\N	\N	\N	80125	80125	248058
6716	5408	0	applied	\N	\N	\N	\N	80134	80134	248067
6716	5409	1	applied	\N	\N	\N	\N	80135	80135	248068
6716	5410	2	applied	\N	\N	\N	\N	80136	80136	248069
6716	5411	3	applied	\N	\N	\N	\N	80137	80137	248070
6722	5423	1	applied	\N	\N	\N	\N	80165	80165	248098
6722	5424	2	applied	\N	\N	\N	\N	80166	80166	248099
6722	5425	3	applied	\N	\N	\N	\N	80167	80167	248100
6724	5426	0	applied	\N	\N	\N	\N	80170	80170	248103
6724	5427	1	applied	\N	\N	\N	\N	80171	80171	248104
6729	5432	0	applied	\N	\N	\N	\N	80178	80178	248111
6729	5433	1	applied	\N	\N	\N	\N	80179	80179	248112
6734	5440	0	applied	\N	\N	\N	\N	80192	80192	248125
6734	5441	1	applied	\N	\N	\N	\N	80193	80193	248126
6736	5442	0	applied	\N	\N	\N	\N	80196	80196	248129
6736	5443	1	applied	\N	\N	\N	\N	80197	80197	248130
6745	5450	0	applied	\N	\N	\N	\N	80214	80214	248147
6745	5451	1	applied	\N	\N	\N	\N	80215	80215	248148
6748	5456	0	applied	\N	\N	\N	\N	80220	80220	248153
6748	5457	1	applied	\N	\N	\N	\N	80221	80221	248154
6748	5458	2	applied	\N	\N	\N	\N	80222	80222	248155
6753	5464	0	applied	\N	\N	\N	\N	80234	80234	248167
6753	5465	1	applied	\N	\N	\N	\N	80235	80235	248168
6755	5466	0	applied	\N	\N	\N	\N	80238	80238	248171
6755	5467	1	applied	\N	\N	\N	\N	80239	80239	248172
6756	5467	1	applied	\N	\N	\N	\N	80241	80241	248174
6758	5468	0	applied	\N	\N	\N	\N	80244	80244	248177
6758	5469	1	applied	\N	\N	\N	\N	80245	80245	248178
6759	5470	0	applied	\N	\N	\N	\N	80246	80246	248179
6759	5471	1	applied	\N	\N	\N	\N	80247	80247	248180
6759	5472	2	applied	\N	\N	\N	\N	80248	80248	248181
6759	5473	3	applied	\N	\N	\N	\N	80249	80249	248182
6759	5474	4	applied	\N	\N	\N	\N	80250	80250	248183
6759	5475	5	applied	\N	\N	\N	\N	80251	80251	248184
6759	5476	6	applied	\N	\N	\N	\N	80252	80252	248185
6759	5477	7	applied	\N	\N	\N	\N	80253	80253	248186
6761	5470	0	applied	\N	\N	\N	\N	80262	80262	248195
6761	5472	2	applied	\N	\N	\N	\N	80264	80264	248197
6761	5473	3	applied	\N	\N	\N	\N	80265	80265	248198
6761	5474	4	applied	\N	\N	\N	\N	80266	80266	248199
6761	5475	5	applied	\N	\N	\N	\N	80267	80267	248200
6761	5476	6	applied	\N	\N	\N	\N	80268	80268	248201
6761	5477	7	applied	\N	\N	\N	\N	80269	80269	248202
6763	5478	0	applied	\N	\N	1000000000	\N	80275	80275	248208
6763	5479	1	applied	\N	\N	1000000000	\N	80276	80276	248209
6763	5480	2	applied	\N	\N	\N	\N	80277	80277	248210
6763	5481	3	applied	\N	\N	\N	\N	80278	80278	248211
6763	5482	4	applied	\N	\N	1000000000	\N	80279	80279	248212
6765	5483	0	applied	\N	\N	1000000000	\N	80283	80283	248216
6765	5484	1	applied	\N	\N	\N	\N	80284	80284	248217
6765	5485	2	applied	\N	\N	\N	\N	80285	80285	248218
6768	5487	0	applied	\N	\N	\N	\N	80287	80287	248220
6768	5488	1	applied	\N	\N	\N	\N	80288	80288	248221
6768	5490	3	applied	\N	\N	\N	\N	80290	80290	248223
6770	5491	0	applied	\N	\N	\N	\N	80295	80295	248228
6770	5492	1	applied	\N	\N	\N	\N	80296	80296	248229
6772	5493	0	applied	\N	\N	\N	\N	80297	80297	248230
6772	5494	1	applied	\N	\N	\N	\N	80298	80298	248231
6773	5493	0	applied	\N	\N	\N	\N	80299	80299	248232
6773	5494	1	applied	\N	\N	\N	\N	80300	80300	248233
6775	5493	0	applied	\N	\N	\N	\N	80303	80303	248236
6775	5494	1	applied	\N	\N	\N	\N	80304	80304	248237
6777	5497	0	applied	\N	\N	\N	\N	80307	80307	248240
6777	5498	1	applied	\N	\N	\N	\N	80308	80308	248241
6779	5501	0	applied	\N	\N	\N	\N	80311	80311	248244
6779	5502	1	applied	\N	\N	\N	\N	80312	80312	248245
6782	5505	0	applied	\N	\N	\N	\N	80315	80315	248248
6782	5506	1	applied	\N	\N	\N	\N	80316	80316	248249
6784	5507	0	applied	\N	\N	\N	\N	80319	80319	248252
6789	5513	0	applied	\N	\N	\N	\N	80331	80331	248264
6789	5514	1	applied	\N	\N	\N	\N	80332	80332	248265
6791	5515	0	applied	\N	\N	\N	\N	80335	80335	248268
6791	5516	1	applied	\N	\N	\N	\N	80336	80336	248269
6791	5517	2	applied	\N	\N	\N	\N	80337	80337	248270
6791	5518	3	applied	\N	\N	\N	\N	80338	80338	248271
6794	5521	0	applied	\N	\N	\N	\N	80345	80345	248278
6794	5522	1	applied	\N	\N	\N	\N	80346	80346	248279
6796	5521	0	applied	\N	\N	\N	\N	80349	80349	248282
6796	5522	1	applied	\N	\N	\N	\N	80350	80350	248283
6797	5523	0	applied	\N	\N	\N	\N	80351	80351	248284
6797	5524	1	applied	\N	\N	\N	\N	80352	80352	248285
6799	5531	0	applied	\N	\N	\N	\N	80359	80359	248292
6799	5532	1	applied	\N	\N	\N	\N	80360	80360	248293
6802	5534	0	applied	\N	\N	\N	\N	80365	80365	248298
6804	5534	0	applied	\N	\N	\N	\N	80366	80366	248299
6806	5536	1	applied	\N	\N	\N	\N	80369	80369	248302
6808	5537	0	applied	\N	\N	\N	\N	80372	80372	248305
6808	5538	1	applied	\N	\N	\N	\N	80373	80373	248306
6808	5539	2	applied	\N	\N	\N	\N	80374	80374	248307
6808	5540	3	applied	\N	\N	\N	\N	80375	80375	248308
6809	5537	0	applied	\N	\N	\N	\N	80376	80376	248309
6809	5538	1	applied	\N	\N	\N	\N	80377	80377	248310
6809	5539	2	applied	\N	\N	\N	\N	80378	80378	248311
6809	5540	3	applied	\N	\N	\N	\N	80379	80379	248312
6813	5545	0	applied	\N	\N	\N	\N	80388	80388	248321
6813	5546	1	applied	\N	\N	1000000000	\N	80389	80389	248322
6813	5547	2	applied	\N	\N	1000000000	\N	80390	80390	248323
6813	5548	3	applied	\N	\N	\N	\N	80391	80391	248324
6815	5549	0	applied	\N	\N	\N	\N	80396	80396	248329
6815	5550	1	applied	\N	\N	\N	\N	80397	80397	248330
6815	5551	2	applied	\N	\N	\N	\N	80398	80398	248331
6818	5557	1	applied	\N	\N	\N	\N	80408	80408	248341
6821	5560	0	applied	\N	\N	\N	\N	80413	80413	248346
6821	5561	1	applied	\N	\N	\N	\N	80414	80414	248347
6821	5562	2	applied	\N	\N	\N	\N	80415	80415	248348
6821	5563	3	applied	\N	\N	\N	\N	80416	80416	248349
6821	5564	4	applied	\N	\N	\N	\N	80417	80417	248350
6821	5565	5	applied	\N	\N	\N	\N	80418	80418	248351
6829	5578	0	applied	\N	\N	\N	\N	80445	80445	248378
6709	5401	1	applied	\N	\N	\N	\N	80121	80121	248054
6711	5402	0	applied	\N	\N	\N	\N	80124	80124	248057
6823	5566	0	applied	\N	\N	\N	\N	80421	80421	248354
6823	5567	1	applied	\N	\N	\N	\N	80422	80422	248355
6825	5568	0	applied	\N	\N	\N	\N	80425	80425	248358
6825	5569	1	applied	\N	\N	\N	\N	80426	80426	248359
6829	5579	1	applied	\N	\N	\N	\N	80446	80446	248379
6831	5578	0	applied	\N	\N	\N	\N	80449	80449	248382
6831	5579	1	applied	\N	\N	\N	\N	80450	80450	248383
6833	5579	0	applied	\N	\N	\N	\N	80453	80453	248386
6835	5582	0	applied	\N	\N	\N	\N	80456	80456	248389
6836	5582	0	applied	\N	\N	\N	\N	80458	80458	248391
6836	5583	1	applied	\N	\N	\N	\N	80459	80459	248392
6838	5582	0	applied	\N	\N	\N	\N	80462	80462	248395
6838	5583	1	applied	\N	\N	\N	\N	80463	80463	248396
6840	5584	0	applied	\N	\N	\N	\N	80468	80468	248401
6840	5585	1	applied	\N	\N	\N	\N	80469	80469	248402
6840	5586	2	applied	\N	\N	\N	\N	80470	80470	248403
6840	5587	3	applied	\N	\N	\N	\N	80471	80471	248404
6842	5588	0	applied	\N	\N	\N	\N	80474	80474	248407
6842	5589	1	applied	\N	\N	\N	\N	80475	80475	248408
6844	5590	0	applied	\N	\N	\N	\N	80477	80477	248410
6844	5589	1	applied	\N	\N	\N	\N	80478	80478	248411
6844	5591	2	applied	\N	\N	\N	\N	80479	80479	248412
6845	5592	0	applied	\N	\N	\N	\N	80480	80480	248413
6845	5593	1	applied	\N	\N	\N	\N	80481	80481	248414
6845	5594	2	applied	\N	\N	\N	\N	80482	80482	248415
6845	5596	4	applied	\N	\N	\N	\N	80484	80484	248417
6845	5597	5	applied	\N	\N	\N	\N	80485	80485	248418
6847	5592	0	applied	\N	\N	\N	\N	80492	80492	248425
6847	5593	1	applied	\N	\N	\N	\N	80493	80493	248426
6847	5594	2	applied	\N	\N	\N	\N	80494	80494	248427
6847	5595	3	applied	\N	\N	\N	\N	80495	80495	248428
6847	5596	4	applied	\N	\N	\N	\N	80496	80496	248429
6847	5597	5	applied	\N	\N	\N	\N	80497	80497	248430
6849	5592	0	applied	\N	\N	\N	\N	80501	80501	248434
6849	5593	1	applied	\N	\N	\N	\N	80502	80502	248435
6849	5594	2	applied	\N	\N	\N	\N	80503	80503	248436
6849	5595	3	applied	\N	\N	\N	\N	80504	80504	248437
6849	5596	4	applied	\N	\N	\N	\N	80505	80505	248438
6849	5597	5	applied	\N	\N	\N	\N	80506	80506	248439
6851	5598	0	applied	\N	\N	\N	\N	80514	80514	248447
6851	5599	1	applied	\N	\N	\N	\N	80515	80515	248448
6852	5600	1	applied	\N	\N	\N	\N	80517	80517	248450
6852	5599	2	applied	\N	\N	\N	\N	80518	80518	248451
6853	5601	0	applied	\N	\N	\N	\N	80519	80519	248452
6853	5600	1	applied	\N	\N	\N	\N	80520	80520	248453
6854	5602	0	applied	\N	\N	\N	\N	80521	80521	248454
6854	5603	1	applied	\N	\N	\N	\N	80522	80522	248455
6854	5604	2	applied	\N	\N	\N	\N	80523	80523	248456
6854	5605	3	applied	\N	\N	\N	\N	80524	80524	248457
6856	5607	1	applied	\N	\N	\N	\N	80530	80530	248462
6856	5608	2	applied	\N	\N	\N	\N	80531	80531	248463
6856	5609	3	applied	\N	\N	\N	\N	80532	80532	248464
6856	5610	4	applied	\N	\N	\N	\N	80533	80533	248465
6856	5611	5	applied	\N	\N	\N	\N	80534	80534	248466
6856	5612	6	applied	\N	\N	\N	\N	80535	80535	248467
6856	5613	7	applied	\N	\N	\N	\N	80536	80536	248468
6856	5614	8	applied	\N	\N	\N	\N	80537	80537	248469
6858	5615	0	applied	\N	\N	\N	\N	80547	80547	248478
6858	5616	1	applied	\N	\N	\N	\N	80548	80548	248479
6860	5617	0	applied	\N	\N	\N	\N	80551	80551	248482
6860	5618	1	applied	\N	\N	\N	\N	80552	80552	248483
6861	5617	0	applied	\N	\N	\N	\N	80553	80553	248484
6861	5618	1	applied	\N	\N	\N	\N	80554	80554	248485
6863	5623	0	applied	\N	\N	\N	\N	80559	80559	248490
6863	5624	1	applied	\N	\N	\N	\N	80560	80560	248491
6867	5630	0	applied	\N	\N	\N	\N	80571	80571	248502
6867	5631	1	applied	\N	\N	\N	\N	80572	80572	248503
6868	5632	0	applied	\N	\N	\N	\N	80573	80573	248504
6868	5633	1	applied	\N	\N	\N	\N	80574	80574	248505
6868	5634	2	applied	\N	\N	\N	\N	80575	80575	248506
6868	5635	3	applied	\N	\N	\N	\N	80576	80576	248507
6868	5636	4	applied	\N	\N	\N	\N	80577	80577	248508
6868	5637	5	applied	\N	\N	\N	\N	80578	80578	248509
6871	5638	0	applied	\N	\N	\N	\N	80583	80583	248514
6871	5639	1	applied	\N	\N	\N	\N	80584	80584	248515
6874	5638	0	applied	\N	\N	\N	\N	80589	80589	248520
6874	5639	1	applied	\N	\N	\N	\N	80590	80590	248521
6875	5638	0	applied	\N	\N	\N	\N	80591	80591	248522
6875	5639	1	applied	\N	\N	\N	\N	80592	80592	248523
6877	5642	0	applied	\N	\N	\N	\N	80595	80595	248526
6877	5643	1	applied	\N	\N	\N	\N	80596	80596	248527
6880	5644	0	applied	\N	\N	\N	\N	80725	80725	248656
6880	5647	1	applied	\N	\N	\N	\N	80726	80726	248657
6880	5648	2	applied	\N	\N	\N	\N	80727	80727	248658
6880	5645	3	applied	\N	\N	\N	\N	80728	80728	248659
6880	5646	4	applied	\N	\N	\N	\N	80729	80729	248660
6882	5644	0	applied	\N	\N	\N	\N	80735	80735	248666
6882	5647	1	applied	\N	\N	\N	\N	80736	80736	248667
6882	5648	2	applied	\N	\N	\N	\N	80737	80737	248668
6882	5645	3	applied	\N	\N	\N	\N	80738	80738	248669
6882	5646	4	applied	\N	\N	\N	\N	80739	80739	248670
6886	5649	0	applied	\N	\N	\N	\N	80753	80753	248684
6886	5650	1	applied	\N	\N	\N	\N	80754	80754	248685
6890	5652	0	applied	\N	\N	\N	\N	80761	80761	248692
6890	5651	1	applied	\N	\N	\N	\N	80762	80762	248693
6890	5653	2	applied	\N	\N	\N	\N	80763	80763	248694
6898	5666	0	applied	\N	\N	\N	\N	80780	80780	248711
6905	5676	0	applied	\N	\N	\N	\N	80796	80796	248727
6905	5677	1	applied	\N	\N	\N	\N	80797	80797	248728
6910	5680	0	applied	\N	\N	\N	\N	80805	80805	248736
6910	5681	1	applied	\N	\N	\N	\N	80806	80806	248737
6913	5680	0	applied	\N	\N	\N	\N	80811	80811	248742
6914	5682	0	applied	\N	\N	\N	\N	80812	80812	248743
6914	5683	1	applied	\N	\N	\N	\N	80813	80813	248744
6916	5684	0	applied	\N	\N	\N	\N	80816	80816	248747
6916	5685	1	applied	\N	\N	\N	\N	80817	80817	248748
6923	5686	0	applied	\N	\N	\N	\N	80834	80834	248765
6923	5687	1	applied	\N	\N	\N	\N	80835	80835	248766
6925	5692	0	applied	\N	\N	\N	\N	80838	80838	248769
6925	5693	1	applied	\N	\N	\N	\N	80839	80839	248770
6820	5558	0	applied	\N	\N	\N	\N	80411	80411	248344
6820	5559	2	applied	\N	\N	\N	\N	80412	80412	248345
6878	5370	6	applied	\N	\N	\N	\N	80603	80603	248534
6878	5361	7	applied	\N	\N	\N	\N	80604	80604	248535
6878	5365	8	applied	\N	\N	\N	\N	80605	80605	248536
6878	5366	9	applied	\N	\N	\N	\N	80606	80606	248537
6878	5367	10	applied	\N	\N	\N	\N	80607	80607	248538
6878	5368	11	applied	\N	\N	\N	\N	80608	80608	248539
6878	5369	12	applied	\N	\N	\N	\N	80609	80609	248540
6878	5372	13	applied	\N	\N	\N	\N	80610	80610	248541
6878	5373	14	applied	\N	\N	\N	\N	80611	80611	248542
6878	5377	15	applied	\N	\N	\N	\N	80612	80612	248543
6878	5378	16	applied	\N	\N	\N	\N	80613	80613	248544
6878	5380	17	applied	\N	\N	\N	\N	80614	80614	248545
6878	5381	18	applied	\N	\N	\N	\N	80615	80615	248546
6878	5384	19	applied	\N	\N	\N	\N	80616	80616	248547
6878	5386	21	applied	\N	\N	\N	\N	80618	80618	248549
6878	5390	22	applied	\N	\N	\N	\N	80619	80619	248550
6878	5395	23	applied	\N	\N	\N	\N	80620	80620	248551
6878	5396	24	applied	\N	\N	\N	\N	80621	80621	248552
6878	5397	25	applied	\N	\N	\N	\N	80622	80622	248553
6878	5398	26	applied	\N	\N	\N	\N	80623	80623	248554
6878	5401	27	applied	\N	\N	\N	\N	80624	80624	248555
6878	5402	28	applied	\N	\N	\N	\N	80625	80625	248556
6878	5404	29	applied	\N	\N	\N	\N	80626	80626	248557
6878	5406	30	applied	\N	\N	\N	\N	80627	80627	248558
6878	5408	31	applied	\N	\N	\N	\N	80628	80628	248559
6878	5411	32	applied	\N	\N	\N	\N	80629	80629	248560
6878	5413	33	applied	\N	\N	\N	\N	80630	80630	248561
6878	5414	34	applied	\N	\N	\N	\N	80631	80631	248562
6878	5417	35	applied	\N	\N	\N	\N	80632	80632	248563
6878	5420	36	applied	\N	\N	\N	\N	80633	80633	248564
6878	5423	38	applied	\N	\N	\N	\N	80635	80635	248566
6878	5424	39	applied	\N	\N	\N	\N	80636	80636	248567
6878	5426	41	applied	\N	\N	\N	\N	80637	80637	248568
6878	5428	42	applied	\N	\N	\N	\N	80638	80638	248569
6878	5431	43	applied	\N	\N	\N	\N	80639	80639	248570
6878	5432	44	applied	\N	\N	\N	\N	80640	80640	248571
6878	5434	45	applied	\N	\N	\N	\N	80641	80641	248572
6878	5436	46	applied	\N	\N	\N	\N	80642	80642	248573
6878	5437	47	applied	\N	\N	\N	\N	80643	80643	248574
6878	5441	48	applied	\N	\N	\N	\N	80644	80644	248575
6878	5443	49	applied	\N	\N	\N	\N	80645	80645	248576
6878	5444	50	applied	\N	\N	\N	\N	80646	80646	248577
6878	5446	51	applied	\N	\N	\N	\N	80647	80647	248578
6878	5449	52	applied	\N	\N	\N	\N	80648	80648	248579
6878	5450	53	applied	\N	\N	\N	\N	80649	80649	248580
6878	5453	54	applied	\N	\N	\N	\N	80650	80650	248581
6878	5457	56	applied	\N	\N	\N	\N	80652	80652	248583
6878	5458	57	applied	\N	\N	\N	\N	80653	80653	248584
6878	5461	58	applied	\N	\N	\N	\N	80654	80654	248585
6878	5462	59	applied	\N	\N	\N	\N	80655	80655	248586
6878	5464	60	applied	\N	\N	\N	\N	80656	80656	248587
6878	5467	61	applied	\N	\N	\N	\N	80657	80657	248588
6878	5468	62	applied	\N	\N	\N	\N	80658	80658	248589
6878	5470	63	applied	\N	\N	\N	\N	80659	80659	248590
6879	5645	1	applied	\N	\N	\N	\N	80723	80723	248654
6879	5646	2	applied	\N	\N	\N	\N	80724	80724	248655
6881	5644	0	applied	\N	\N	\N	\N	80730	80730	248661
6881	5647	1	applied	\N	\N	\N	\N	80731	80731	248662
6881	5648	2	applied	\N	\N	\N	\N	80732	80732	248663
6881	5645	3	applied	\N	\N	\N	\N	80733	80733	248664
6881	5646	4	applied	\N	\N	\N	\N	80734	80734	248665
6885	5644	0	applied	\N	\N	\N	\N	80748	80748	248679
6885	5648	2	applied	\N	\N	\N	\N	80750	80750	248681
6885	5645	3	applied	\N	\N	\N	\N	80751	80751	248682
6885	5646	4	applied	\N	\N	\N	\N	80752	80752	248683
6888	5649	0	applied	\N	\N	\N	\N	80757	80757	248688
6888	5650	1	applied	\N	\N	\N	\N	80758	80758	248689
6893	5656	0	applied	\N	\N	\N	\N	80770	80770	248701
6893	5657	1	applied	\N	\N	\N	\N	80771	80771	248702
6893	5658	2	applied	\N	\N	\N	\N	80772	80772	248703
6893	5659	3	applied	\N	\N	\N	\N	80773	80773	248704
6895	5660	0	applied	\N	\N	\N	\N	80774	80774	248705
6895	5661	1	applied	\N	\N	\N	\N	80775	80775	248706
6895	5662	2	applied	\N	\N	\N	\N	80776	80776	248707
6895	5663	3	applied	\N	\N	\N	\N	80777	80777	248708
6900	5668	0	applied	\N	\N	\N	\N	80784	80784	248715
6900	5669	1	applied	\N	\N	\N	\N	80785	80785	248716
6902	5670	0	applied	\N	\N	\N	\N	80788	80788	248719
6907	5678	0	applied	\N	\N	\N	\N	80800	80800	248731
6907	5679	1	applied	\N	\N	\N	\N	80801	80801	248732
6909	5680	0	applied	\N	\N	\N	\N	80804	80804	248735
6912	5680	0	applied	\N	\N	\N	\N	80809	80809	248740
6912	5681	1	applied	\N	\N	\N	\N	80810	80810	248741
6918	5684	0	applied	\N	\N	\N	\N	80820	80820	248751
6918	5685	1	applied	\N	\N	\N	\N	80821	80821	248752
6920	5684	0	applied	\N	\N	\N	\N	80824	80824	248755
6920	5685	1	applied	\N	\N	\N	\N	80825	80825	248756
6922	5686	0	applied	\N	\N	\N	\N	80830	80830	248761
6922	5687	1	applied	\N	\N	\N	\N	80831	80831	248762
6922	5688	2	applied	\N	\N	\N	\N	80832	80832	248763
6922	5689	3	applied	\N	\N	\N	\N	80833	80833	248764
6941	5712	0	applied	\N	\N	\N	\N	80867	80867	248798
6941	5713	1	applied	\N	\N	\N	\N	80868	80868	248799
6946	5718	0	applied	\N	\N	\N	\N	80876	80876	248807
6946	5720	2	applied	\N	\N	\N	\N	80878	80878	248809
6951	5722	0	applied	\N	\N	\N	\N	80886	80886	248817
6951	5723	1	applied	\N	\N	\N	\N	80887	80887	248818
6951	5724	2	applied	\N	\N	\N	\N	80888	80888	248819
6955	5730	0	applied	\N	\N	\N	\N	80979	80979	248910
6955	5725	1	applied	\N	\N	\N	\N	80980	80980	248911
6955	5726	2	applied	\N	\N	\N	\N	80981	80981	248912
6955	5727	3	applied	\N	\N	\N	\N	80982	80982	248913
6955	5728	4	applied	\N	\N	\N	\N	80983	80983	248914
6955	5729	5	applied	\N	\N	\N	\N	80984	80984	248915
6962	5735	0	applied	\N	\N	\N	\N	80996	80996	248927
6962	5736	1	applied	\N	\N	\N	\N	80997	80997	248928
6967	5741	0	applied	\N	\N	\N	\N	81006	81006	248937
6967	5742	1	applied	\N	\N	\N	\N	81007	81007	248938
6969	5745	0	applied	\N	\N	\N	\N	81010	81010	248941
6970	5746	0	applied	\N	\N	\N	\N	81011	81011	248942
6878	5363	4	applied	\N	\N	\N	\N	80601	80601	248532
6878	5364	5	applied	\N	\N	\N	\N	80602	80602	248533
6878	5479	68	applied	\N	\N	1000000000	\N	80664	80664	248595
6878	5481	69	applied	\N	\N	\N	\N	80665	80665	248596
6878	5482	70	applied	\N	\N	1000000000	\N	80666	80666	248597
6878	5483	71	applied	\N	\N	1000000000	\N	80667	80667	248598
6878	5485	72	applied	\N	\N	\N	\N	80668	80668	248599
6878	5489	73	applied	\N	\N	\N	\N	80669	80669	248600
6878	5490	74	applied	\N	\N	\N	\N	80670	80670	248601
6878	5491	75	applied	\N	\N	\N	\N	80671	80671	248602
6878	5493	76	applied	\N	\N	\N	\N	80672	80672	248603
6878	5496	77	applied	\N	\N	\N	\N	80673	80673	248604
6878	5497	78	applied	\N	\N	\N	\N	80674	80674	248605
6878	5499	79	applied	\N	\N	\N	\N	80675	80675	248606
6878	5501	80	applied	\N	\N	\N	\N	80676	80676	248607
6878	5504	81	applied	\N	\N	\N	\N	80677	80677	248608
6878	5505	82	applied	\N	\N	\N	\N	80678	80678	248609
6878	5508	83	applied	\N	\N	\N	\N	80679	80679	248610
6878	5511	84	applied	\N	\N	\N	\N	80680	80680	248611
6878	5512	85	applied	\N	\N	\N	\N	80681	80681	248612
6878	5514	86	applied	\N	\N	\N	\N	80682	80682	248613
6878	5518	88	applied	\N	\N	\N	\N	80684	80684	248615
6878	5520	89	applied	\N	\N	\N	\N	80685	80685	248616
6878	5521	90	applied	\N	\N	\N	\N	80686	80686	248617
6878	5525	91	applied	\N	\N	\N	\N	80687	80687	248618
6878	5526	92	applied	\N	\N	1000000000	\N	80688	80688	248619
6878	5528	93	applied	\N	\N	\N	\N	80689	80689	248620
6878	5529	94	applied	\N	\N	\N	\N	80690	80690	248621
6878	5530	95	applied	\N	\N	\N	\N	80691	80691	248622
6878	5531	96	applied	\N	\N	\N	\N	80692	80692	248623
6878	5533	97	applied	\N	\N	\N	\N	80693	80693	248624
6878	5536	98	applied	\N	\N	\N	\N	80694	80694	248625
6878	5537	99	applied	\N	\N	\N	\N	80695	80695	248626
6878	5540	100	applied	\N	\N	\N	\N	80696	80696	248627
6878	5542	101	applied	\N	\N	\N	\N	80697	80697	248628
6878	5543	102	applied	\N	\N	\N	\N	80698	80698	248629
6878	5545	103	applied	\N	\N	\N	\N	80699	80699	248630
6878	5547	105	applied	\N	\N	1000000000	\N	80701	80701	248632
6878	5549	106	applied	\N	\N	\N	\N	80702	80702	248633
6878	5550	107	applied	\N	\N	\N	\N	80703	80703	248634
6878	5554	108	applied	\N	\N	\N	\N	80704	80704	248635
6878	5555	109	applied	\N	\N	1000000000	\N	80705	80705	248636
6878	5557	110	applied	\N	\N	\N	\N	80706	80706	248637
6878	5559	111	applied	\N	\N	\N	\N	80707	80707	248638
6878	5563	112	applied	\N	\N	\N	\N	80708	80708	248639
6878	5564	113	applied	\N	\N	\N	\N	80709	80709	248640
6878	5565	114	applied	\N	\N	\N	\N	80710	80710	248641
6878	5566	115	applied	\N	\N	\N	\N	80711	80711	248642
6878	5568	116	applied	\N	\N	\N	\N	80712	80712	248643
6878	5571	117	applied	\N	\N	\N	\N	80713	80713	248644
6878	5572	118	applied	\N	\N	\N	\N	80714	80714	248645
6878	5573	119	applied	\N	\N	\N	\N	80715	80715	248646
6878	5574	120	applied	\N	\N	\N	\N	80716	80716	248647
6878	5578	121	applied	\N	\N	\N	\N	80717	80717	248648
6878	5581	122	applied	\N	\N	\N	\N	80718	80718	248649
6878	5586	124	applied	\N	\N	\N	\N	80720	80720	248651
6878	5587	125	applied	\N	\N	\N	\N	80721	80721	248652
6887	5649	0	applied	\N	\N	\N	\N	80755	80755	248686
6887	5650	1	applied	\N	\N	\N	\N	80756	80756	248687
6891	5654	0	applied	\N	\N	\N	\N	80764	80764	248695
6891	5655	1	applied	\N	\N	\N	\N	80765	80765	248696
6896	5664	0	applied	\N	\N	\N	\N	80778	80778	248709
6896	5665	1	applied	\N	\N	\N	\N	80779	80779	248710
6901	5668	0	applied	\N	\N	\N	\N	80786	80786	248717
6901	5669	1	applied	\N	\N	\N	\N	80787	80787	248718
6903	5670	0	applied	\N	\N	\N	\N	80790	80790	248721
6903	5671	1	applied	\N	\N	\N	\N	80791	80791	248722
6906	5676	0	applied	\N	\N	\N	\N	80798	80798	248729
6906	5677	1	applied	\N	\N	\N	\N	80799	80799	248730
6908	5678	0	applied	\N	\N	\N	\N	80802	80802	248733
6908	5679	1	applied	\N	\N	\N	\N	80803	80803	248734
6911	5681	1	applied	\N	\N	\N	\N	80808	80808	248739
6917	5684	0	applied	\N	\N	\N	\N	80818	80818	248749
6917	5685	1	applied	\N	\N	\N	\N	80819	80819	248750
6921	5686	0	applied	\N	\N	\N	\N	80826	80826	248757
6921	5687	1	applied	\N	\N	\N	\N	80827	80827	248758
6921	5688	2	applied	\N	\N	\N	\N	80828	80828	248759
6921	5689	3	applied	\N	\N	\N	\N	80829	80829	248760
6926	5692	0	applied	\N	\N	\N	\N	80840	80840	248771
6928	5694	0	applied	\N	\N	\N	\N	80843	80843	248774
6928	5695	1	applied	\N	\N	\N	\N	80844	80844	248775
6937	5702	0	applied	\N	\N	\N	\N	80857	80857	248788
6937	5703	1	applied	\N	\N	\N	\N	80858	80858	248789
6937	5704	2	applied	\N	\N	\N	\N	80859	80859	248790
6937	5705	3	applied	\N	\N	\N	\N	80860	80860	248791
6940	5710	0	applied	\N	\N	\N	\N	80865	80865	248796
6940	5711	1	applied	\N	\N	\N	\N	80866	80866	248797
6950	5723	1	applied	\N	\N	\N	\N	80884	80884	248815
6950	5724	2	applied	\N	\N	\N	\N	80885	80885	248816
6953	5725	0	applied	\N	\N	\N	\N	80896	80896	248827
6953	5726	1	applied	\N	\N	\N	\N	80897	80897	248828
6953	5722	2	applied	\N	\N	\N	\N	80898	80898	248829
6953	5723	3	applied	\N	\N	\N	\N	80899	80899	248830
6953	5727	4	applied	\N	\N	\N	\N	80900	80900	248831
6953	5728	5	applied	\N	\N	\N	\N	80901	80901	248832
6953	5724	6	applied	\N	\N	\N	\N	80902	80902	248833
6954	5654	0	applied	\N	\N	\N	\N	80903	80903	248834
6954	5656	1	applied	\N	\N	\N	\N	80904	80904	248835
6954	5655	2	applied	\N	\N	\N	\N	80905	80905	248836
6954	5657	3	applied	\N	\N	\N	\N	80906	80906	248837
6954	5658	4	applied	\N	\N	\N	\N	80907	80907	248838
6954	5660	5	applied	\N	\N	\N	\N	80908	80908	248839
6954	5661	6	applied	\N	\N	\N	\N	80909	80909	248840
6954	5667	8	applied	\N	\N	\N	\N	80911	80911	248842
6954	5669	9	applied	\N	\N	\N	\N	80912	80912	248843
6954	5670	10	applied	\N	\N	\N	\N	80913	80913	248844
6954	5672	11	applied	\N	\N	\N	\N	80914	80914	248845
6954	5659	12	applied	\N	\N	\N	\N	80915	80915	248846
6954	5662	13	applied	\N	\N	\N	\N	80916	80916	248847
6954	5663	14	applied	\N	\N	\N	\N	80917	80917	248848
6954	5664	15	applied	\N	\N	\N	\N	80918	80918	248849
6878	5473	65	applied	\N	\N	\N	\N	80661	80661	248592
6878	5474	66	applied	\N	\N	\N	\N	80662	80662	248593
6883	5646	4	applied	\N	\N	\N	\N	80744	80744	248675
6884	5644	0	applied	\N	\N	\N	\N	80745	80745	248676
6884	5645	1	applied	\N	\N	\N	\N	80746	80746	248677
6884	5646	2	applied	\N	\N	\N	\N	80747	80747	248678
6889	5646	0	applied	\N	\N	\N	\N	80759	80759	248690
6889	5651	1	applied	\N	\N	\N	\N	80760	80760	248691
6892	5656	0	applied	\N	\N	\N	\N	80766	80766	248697
6892	5657	1	applied	\N	\N	\N	\N	80767	80767	248698
6892	5658	2	applied	\N	\N	\N	\N	80768	80768	248699
6892	5659	3	applied	\N	\N	\N	\N	80769	80769	248700
6899	5668	0	applied	\N	\N	\N	\N	80782	80782	248713
6899	5669	1	applied	\N	\N	\N	\N	80783	80783	248714
6904	5672	0	applied	\N	\N	\N	\N	80792	80792	248723
6904	5673	1	applied	\N	\N	\N	\N	80793	80793	248724
6904	5675	3	applied	\N	\N	\N	\N	80795	80795	248726
6915	5682	0	applied	\N	\N	\N	\N	80814	80814	248745
6915	5683	1	applied	\N	\N	\N	\N	80815	80815	248746
6919	5684	0	applied	\N	\N	\N	\N	80822	80822	248753
6919	5685	1	applied	\N	\N	\N	\N	80823	80823	248754
6924	5690	0	applied	\N	\N	\N	\N	80836	80836	248767
6924	5691	1	applied	\N	\N	\N	\N	80837	80837	248768
6929	5694	0	applied	\N	\N	\N	\N	80845	80845	248776
6929	5695	1	applied	\N	\N	\N	\N	80846	80846	248777
6931	5696	0	applied	\N	\N	\N	\N	80851	80851	248782
6931	5697	1	applied	\N	\N	\N	\N	80852	80852	248783
6931	5698	2	applied	\N	\N	\N	\N	80853	80853	248784
6931	5699	3	applied	\N	\N	\N	\N	80854	80854	248785
6938	5706	0	applied	\N	\N	\N	\N	80861	80861	248792
6938	5707	1	applied	\N	\N	\N	\N	80862	80862	248793
6943	5713	0	applied	\N	\N	\N	\N	80871	80871	248802
6945	5715	1	applied	\N	\N	\N	\N	80873	80873	248804
6945	5716	2	applied	\N	\N	\N	\N	80874	80874	248805
6945	5717	3	applied	\N	\N	\N	\N	80875	80875	248806
6954	5666	16	applied	\N	\N	\N	\N	80919	80919	248850
6954	5668	17	applied	\N	\N	\N	\N	80920	80920	248851
6954	5674	18	applied	\N	\N	\N	\N	80921	80921	248852
6954	5677	19	applied	\N	\N	\N	\N	80922	80922	248853
6954	5671	20	applied	\N	\N	\N	\N	80923	80923	248854
6954	5673	21	applied	\N	\N	\N	\N	80924	80924	248855
6954	5678	22	applied	\N	\N	\N	\N	80925	80925	248856
6954	5675	23	applied	\N	\N	\N	\N	80926	80926	248857
6954	5676	24	applied	\N	\N	\N	\N	80927	80927	248858
6954	5679	25	applied	\N	\N	\N	\N	80928	80928	248859
6954	5680	26	applied	\N	\N	\N	\N	80929	80929	248860
6954	5681	27	applied	\N	\N	\N	\N	80930	80930	248861
6954	5682	28	applied	\N	\N	\N	\N	80931	80931	248862
6954	5683	30	applied	\N	\N	\N	\N	80933	80933	248864
6954	5685	31	applied	\N	\N	\N	\N	80934	80934	248865
6954	5686	32	applied	\N	\N	\N	\N	80935	80935	248866
6954	5687	33	applied	\N	\N	\N	\N	80936	80936	248867
6954	5691	34	applied	\N	\N	\N	\N	80937	80937	248868
6954	5692	35	applied	\N	\N	\N	\N	80938	80938	248869
6954	5695	36	applied	\N	\N	\N	\N	80939	80939	248870
6954	5698	37	applied	\N	\N	\N	\N	80940	80940	248871
6954	5699	38	applied	\N	\N	\N	\N	80941	80941	248872
6954	5701	39	applied	\N	\N	\N	\N	80942	80942	248873
6954	5704	40	applied	\N	\N	\N	\N	80943	80943	248874
6954	5705	41	applied	\N	\N	\N	\N	80944	80944	248875
6954	5706	42	applied	\N	\N	\N	\N	80945	80945	248876
6954	5708	43	applied	\N	\N	\N	\N	80946	80946	248877
6954	5711	44	applied	\N	\N	\N	\N	80947	80947	248878
6954	5713	45	applied	\N	\N	\N	\N	80948	80948	248879
6954	5717	47	applied	\N	\N	\N	\N	80950	80950	248881
6954	5720	48	applied	\N	\N	\N	\N	80951	80951	248882
6954	5721	49	applied	\N	\N	\N	\N	80952	80952	248883
6954	5722	50	applied	\N	\N	\N	\N	80953	80953	248884
6954	5723	51	applied	\N	\N	\N	\N	80954	80954	248885
6954	5724	52	applied	\N	\N	\N	\N	80955	80955	248886
6954	5688	53	applied	\N	\N	\N	\N	80956	80956	248887
6954	5689	54	applied	\N	\N	\N	\N	80957	80957	248888
6954	5690	55	applied	\N	\N	\N	\N	80958	80958	248889
6954	5693	56	applied	\N	\N	\N	\N	80959	80959	248890
6954	5694	57	applied	\N	\N	\N	\N	80960	80960	248891
6954	5696	58	applied	\N	\N	\N	\N	80961	80961	248892
6954	5697	59	applied	\N	\N	\N	\N	80962	80962	248893
6954	5700	60	applied	\N	\N	\N	\N	80963	80963	248894
6954	5702	61	applied	\N	\N	\N	\N	80964	80964	248895
6954	5703	62	applied	\N	\N	\N	\N	80965	80965	248896
6954	5709	64	applied	\N	\N	\N	\N	80967	80967	248898
6954	5710	65	applied	\N	\N	\N	\N	80968	80968	248899
6954	5712	66	applied	\N	\N	\N	\N	80969	80969	248900
6954	5714	67	applied	\N	\N	\N	\N	80970	80970	248901
6954	5715	68	applied	\N	\N	\N	\N	80971	80971	248902
6954	5718	69	applied	\N	\N	\N	\N	80972	80972	248903
6954	5719	70	applied	\N	\N	1000000000	\N	80973	80973	248904
6954	5725	71	applied	\N	\N	\N	\N	80974	80974	248905
6954	5726	72	applied	\N	\N	\N	\N	80975	80975	248906
6954	5727	73	applied	\N	\N	\N	\N	80976	80976	248907
6954	5728	74	applied	\N	\N	\N	\N	80977	80977	248908
6957	5731	0	applied	\N	\N	\N	\N	80987	80987	248918
6957	5732	1	applied	\N	\N	\N	\N	80988	80988	248919
6960	5733	0	applied	\N	\N	\N	\N	80993	80993	248924
6960	5734	1	applied	\N	\N	\N	\N	80994	80994	248925
6964	5737	0	applied	\N	\N	\N	\N	81000	81000	248931
6966	5741	0	applied	\N	\N	\N	\N	81004	81004	248935
6966	5742	1	applied	\N	\N	\N	\N	81005	81005	248936
6973	5756	0	applied	\N	\N	\N	\N	81023	81023	248954
6973	5755	1	applied	\N	\N	\N	\N	81024	81024	248955
6976	5757	0	applied	\N	\N	\N	\N	81029	81029	248960
6976	5756	1	applied	\N	\N	\N	\N	81030	81030	248961
6976	5758	2	applied	\N	\N	\N	\N	81031	81031	248962
6981	5763	0	applied	\N	\N	\N	\N	81041	81041	248972
6981	5764	1	applied	\N	\N	\N	\N	81042	81042	248973
6981	5765	2	applied	\N	\N	\N	\N	81043	81043	248974
6981	5766	3	applied	\N	\N	\N	\N	81044	81044	248975
6984	5769	0	applied	\N	\N	\N	\N	81051	81051	248982
6984	5770	1	applied	\N	\N	\N	\N	81052	81052	248983
6984	5771	2	applied	\N	\N	\N	\N	81053	81053	248984
6984	5772	3	applied	\N	\N	\N	\N	81054	81054	248985
6989	5779	0	applied	\N	\N	\N	\N	81063	81063	248994
6883	5645	3	applied	\N	\N	\N	\N	80743	80743	248674
6930	5698	2	applied	\N	\N	\N	\N	80849	80849	248780
6930	5699	3	applied	\N	\N	\N	\N	80850	80850	248781
6934	5700	0	applied	\N	\N	\N	\N	80855	80855	248786
6934	5701	1	applied	\N	\N	\N	\N	80856	80856	248787
6939	5708	0	applied	\N	\N	\N	\N	80863	80863	248794
6939	5709	1	applied	\N	\N	\N	\N	80864	80864	248795
6942	5712	0	applied	\N	\N	\N	\N	80869	80869	248800
6942	5713	1	applied	\N	\N	\N	\N	80870	80870	248801
6947	5718	0	applied	\N	\N	\N	\N	80879	80879	248810
6947	5719	1	applied	\N	\N	1000000000	\N	80880	80880	248811
6947	5720	2	applied	\N	\N	\N	\N	80881	80881	248812
6949	5721	0	applied	\N	\N	\N	\N	80882	80882	248813
6952	5726	1	applied	\N	\N	\N	\N	80890	80890	248821
6952	5722	2	applied	\N	\N	\N	\N	80891	80891	248822
6952	5723	3	applied	\N	\N	\N	\N	80892	80892	248823
6952	5727	4	applied	\N	\N	\N	\N	80893	80893	248824
6952	5728	5	applied	\N	\N	\N	\N	80894	80894	248825
6952	5724	6	applied	\N	\N	\N	\N	80895	80895	248826
6956	5731	0	applied	\N	\N	\N	\N	80985	80985	248916
6956	5732	1	applied	\N	\N	\N	\N	80986	80986	248917
6958	5733	0	applied	\N	\N	\N	\N	80989	80989	248920
6958	5734	1	applied	\N	\N	\N	\N	80990	80990	248921
6963	5737	0	applied	\N	\N	\N	\N	80998	80998	248929
6963	5738	1	applied	\N	\N	\N	\N	80999	80999	248930
6965	5739	0	applied	\N	\N	\N	\N	81002	81002	248933
6965	5740	1	applied	\N	\N	\N	\N	81003	81003	248934
6971	5755	0	applied	\N	\N	\N	\N	81020	81020	248951
6975	5756	0	applied	\N	\N	\N	\N	81027	81027	248958
6982	5763	0	applied	\N	\N	\N	\N	81045	81045	248976
6982	5764	1	applied	\N	\N	\N	\N	81046	81046	248977
6982	5765	2	applied	\N	\N	\N	\N	81047	81047	248978
6982	5766	3	applied	\N	\N	\N	\N	81048	81048	248979
6985	5773	0	applied	\N	\N	\N	\N	81055	81055	248986
6985	5774	1	applied	\N	\N	\N	\N	81056	81056	248987
6988	5777	0	applied	\N	\N	\N	\N	81061	81061	248992
6988	5778	1	applied	\N	\N	\N	\N	81062	81062	248993
6989	5780	1	applied	\N	\N	\N	\N	81064	81064	248995
6991	5781	0	applied	\N	\N	\N	\N	81069	81069	249000
6991	5782	1	applied	\N	\N	\N	\N	81070	81070	249001
6991	5783	2	applied	\N	\N	\N	\N	81071	81071	249002
6991	5784	3	applied	\N	\N	\N	\N	81072	81072	249003
6993	5785	0	applied	\N	\N	\N	\N	81082	81082	249013
6993	5787	2	applied	\N	\N	\N	\N	81084	81084	249015
6993	5788	3	applied	\N	\N	\N	\N	81085	81085	249016
6993	5789	4	applied	\N	\N	\N	\N	81086	81086	249017
6993	5790	5	applied	\N	\N	\N	\N	81087	81087	249018
6993	5791	6	applied	\N	\N	\N	\N	81088	81088	249019
6993	5792	7	applied	\N	\N	\N	\N	81089	81089	249020
6993	5793	8	applied	\N	\N	\N	\N	81090	81090	249021
6996	5794	0	applied	\N	\N	\N	\N	81102	81102	249033
6996	5795	1	applied	\N	\N	\N	\N	81103	81103	249034
6997	5796	0	applied	\N	\N	\N	\N	81104	81104	249035
6997	5797	1	applied	\N	\N	\N	\N	81105	81105	249036
6999	5798	0	applied	\N	\N	\N	\N	81106	81106	249037
6999	5799	1	applied	\N	\N	\N	\N	81107	81107	249038
7008	5802	0	applied	\N	\N	\N	\N	81116	81116	249047
7008	5803	1	applied	\N	\N	\N	\N	81117	81117	249048
7008	5804	2	applied	\N	\N	\N	\N	81118	81118	249049
7008	5805	3	applied	\N	\N	\N	\N	81119	81119	249050
7008	5806	4	applied	\N	\N	\N	\N	81120	81120	249051
7009	5802	0	applied	\N	\N	\N	\N	81121	81121	249052
7009	5803	1	applied	\N	\N	\N	\N	81122	81122	249053
7009	5805	3	applied	\N	\N	\N	\N	81124	81124	249055
7009	5806	4	applied	\N	\N	\N	\N	81125	81125	249056
7010	5802	0	applied	\N	\N	\N	\N	81126	81126	249057
7010	5803	1	applied	\N	\N	\N	\N	81127	81127	249058
7010	5804	2	applied	\N	\N	\N	\N	81128	81128	249059
7010	5805	3	applied	\N	\N	\N	\N	81129	81129	249060
7010	5806	4	applied	\N	\N	\N	\N	81130	81130	249061
7012	5807	0	applied	\N	\N	\N	\N	81136	81136	249067
7012	5808	1	applied	\N	\N	\N	\N	81137	81137	249068
7013	5807	0	applied	\N	\N	\N	\N	81138	81138	249069
7013	5808	1	applied	\N	\N	\N	\N	81139	81139	249070
7016	5811	0	applied	\N	\N	\N	\N	81144	81144	249075
7016	5812	1	applied	\N	\N	\N	\N	81145	81145	249076
7016	5813	2	applied	\N	\N	\N	\N	81146	81146	249077
7016	5814	3	applied	\N	\N	\N	\N	81147	81147	249078
7020	5815	0	applied	\N	\N	\N	\N	81160	81160	249091
7020	5817	2	applied	\N	\N	\N	\N	81162	81162	249093
7020	5818	3	applied	\N	\N	\N	\N	81163	81163	249094
7021	5819	0	applied	\N	\N	\N	\N	81164	81164	249095
7025	5829	0	applied	\N	\N	\N	\N	81184	81184	249115
7025	5830	1	applied	\N	\N	\N	\N	81185	81185	249116
7025	5831	2	applied	\N	\N	\N	\N	81186	81186	249117
7025	5832	3	applied	\N	\N	\N	\N	81187	81187	249118
7030	5835	0	applied	\N	\N	\N	\N	81200	81200	249131
7030	5836	1	applied	\N	\N	\N	\N	81201	81201	249132
7030	5837	2	applied	\N	\N	\N	\N	81202	81202	249133
7030	5838	3	applied	\N	\N	\N	\N	81203	81203	249134
7033	5845	0	applied	\N	\N	\N	\N	81210	81210	249141
7033	5846	1	applied	\N	\N	\N	\N	81211	81211	249142
7036	5853	0	applied	\N	\N	\N	\N	81218	81218	249149
7036	5854	1	applied	\N	\N	\N	\N	81219	81219	249150
7039	5857	0	applied	\N	\N	\N	\N	81224	81224	249155
7041	5859	0	applied	\N	\N	\N	\N	81228	81228	249159
7041	5860	1	applied	\N	\N	\N	\N	81229	81229	249160
7044	5866	0	applied	\N	\N	\N	\N	81239	81239	249170
7044	5867	1	applied	\N	\N	\N	\N	81240	81240	249171
7044	5868	2	applied	\N	\N	\N	\N	81241	81241	249172
7044	5869	3	applied	\N	\N	\N	\N	81242	81242	249173
7047	5872	0	applied	\N	\N	\N	\N	81249	81249	249180
7047	5873	1	applied	\N	\N	\N	\N	81250	81250	249181
7047	5874	2	applied	\N	\N	\N	\N	81251	81251	249182
7047	5875	3	applied	\N	\N	\N	\N	81252	81252	249183
7051	5880	0	applied	\N	\N	\N	\N	81261	81261	249192
7051	5881	1	applied	\N	\N	\N	\N	81262	81262	249193
7053	5880	0	applied	\N	\N	\N	\N	81265	81265	249196
7053	5881	1	applied	\N	\N	\N	\N	81266	81266	249197
7056	5886	0	applied	\N	\N	\N	\N	81275	81275	249206
6927	5693	1	applied	\N	\N	\N	\N	80842	80842	248773
6930	5697	1	applied	\N	\N	\N	\N	80848	80848	248779
6961	5735	0	applied	\N	\N	\N	\N	80995	80995	248926
6968	5743	0	applied	\N	\N	\N	\N	81008	81008	248939
6968	5744	1	applied	\N	\N	\N	\N	81009	81009	248940
6972	5756	0	applied	\N	\N	\N	\N	81021	81021	248952
6972	5755	1	applied	\N	\N	\N	\N	81022	81022	248953
6978	5759	0	applied	\N	\N	\N	\N	81035	81035	248966
6978	5760	1	applied	\N	\N	\N	\N	81036	81036	248967
6980	5761	0	applied	\N	\N	\N	\N	81039	81039	248970
6980	5762	1	applied	\N	\N	\N	\N	81040	81040	248971
6983	5768	1	applied	\N	\N	\N	\N	81050	81050	248981
6986	5775	0	applied	\N	\N	\N	\N	81057	81057	248988
6986	5776	1	applied	\N	\N	\N	\N	81058	81058	248989
6992	5785	0	applied	\N	\N	\N	\N	81073	81073	249004
6992	5786	1	applied	\N	\N	1000000000	\N	81074	81074	249005
6992	5787	2	applied	\N	\N	\N	\N	81075	81075	249006
6992	5788	3	applied	\N	\N	\N	\N	81076	81076	249007
6992	5789	4	applied	\N	\N	\N	\N	81077	81077	249008
6992	5790	5	applied	\N	\N	\N	\N	81078	81078	249009
6992	5791	6	applied	\N	\N	\N	\N	81079	81079	249010
6992	5792	7	applied	\N	\N	\N	\N	81080	81080	249011
6992	5793	8	applied	\N	\N	\N	\N	81081	81081	249012
7005	5800	0	applied	\N	\N	\N	\N	81110	81110	249041
7005	5801	1	applied	\N	\N	\N	\N	81111	81111	249042
7007	5800	0	applied	\N	\N	\N	\N	81114	81114	249045
7007	5801	1	applied	\N	\N	\N	\N	81115	81115	249046
7014	5808	1	applied	\N	\N	\N	\N	81141	81141	249072
7017	5811	0	applied	\N	\N	\N	\N	81148	81148	249079
7017	5812	1	applied	\N	\N	\N	\N	81149	81149	249080
7017	5813	2	applied	\N	\N	\N	\N	81150	81150	249081
7017	5814	3	applied	\N	\N	\N	\N	81151	81151	249082
7019	5815	0	applied	\N	\N	\N	\N	81156	81156	249087
7019	5816	1	applied	\N	\N	\N	\N	81157	81157	249088
7019	5817	2	applied	\N	\N	\N	\N	81158	81158	249089
7019	5818	3	applied	\N	\N	\N	\N	81159	81159	249090
7021	5820	1	applied	\N	\N	\N	\N	81165	81165	249096
7021	5821	2	applied	\N	\N	\N	\N	81166	81166	249097
7021	5822	3	applied	\N	\N	\N	\N	81167	81167	249098
7022	5823	0	applied	\N	\N	\N	\N	81168	81168	249099
7022	5824	1	applied	\N	\N	\N	\N	81169	81169	249100
7022	5825	2	applied	\N	\N	\N	\N	81170	81170	249101
7022	5826	3	applied	\N	\N	\N	\N	81171	81171	249102
7022	5828	5	applied	\N	\N	\N	\N	81173	81173	249104
7024	5829	0	applied	\N	\N	\N	\N	81180	81180	249111
7024	5830	1	applied	\N	\N	\N	\N	81181	81181	249112
7024	5831	2	applied	\N	\N	\N	\N	81182	81182	249113
7024	5832	3	applied	\N	\N	\N	\N	81183	81183	249114
7027	5833	0	applied	\N	\N	\N	\N	81192	81192	249123
7027	5834	1	applied	\N	\N	\N	\N	81193	81193	249124
7029	5835	0	applied	\N	\N	\N	\N	81196	81196	249127
7029	5836	1	applied	\N	\N	\N	\N	81197	81197	249128
7029	5837	2	applied	\N	\N	\N	\N	81198	81198	249129
7029	5838	3	applied	\N	\N	\N	\N	81199	81199	249130
7031	5839	0	applied	\N	\N	\N	\N	81204	81204	249135
7031	5840	1	applied	\N	\N	\N	\N	81205	81205	249136
7032	5841	0	applied	\N	\N	\N	\N	81206	81206	249137
7032	5842	1	applied	\N	\N	\N	\N	81207	81207	249138
7032	5843	2	applied	\N	\N	\N	\N	81208	81208	249139
7034	5847	0	applied	\N	\N	\N	\N	81212	81212	249143
7034	5848	1	applied	\N	\N	\N	\N	81213	81213	249144
7035	5849	0	applied	\N	\N	\N	\N	81214	81214	249145
7035	5850	1	applied	\N	\N	\N	\N	81215	81215	249146
7035	5851	2	applied	\N	\N	\N	\N	81216	81216	249147
7035	5852	3	applied	\N	\N	\N	\N	81217	81217	249148
7037	5855	0	applied	\N	\N	\N	\N	81220	81220	249151
7037	5856	1	applied	\N	\N	\N	\N	81221	81221	249152
7038	5857	0	applied	\N	\N	\N	\N	81222	81222	249153
7038	5858	1	applied	\N	\N	\N	\N	81223	81223	249154
7040	5859	0	applied	\N	\N	\N	\N	81226	81226	249157
7040	5860	1	applied	\N	\N	\N	\N	81227	81227	249158
7042	5861	0	applied	\N	\N	1000000000	\N	81230	81230	249161
7042	5862	1	applied	\N	\N	\N	\N	81231	81231	249162
7042	5863	2	applied	\N	\N	\N	\N	81232	81232	249163
7042	5864	4	applied	\N	\N	\N	\N	81233	81233	249164
7043	5866	0	applied	\N	\N	\N	\N	81235	81235	249166
7045	5870	0	applied	\N	\N	\N	\N	81243	81243	249174
7045	5871	1	applied	\N	\N	\N	\N	81244	81244	249175
7048	5872	0	applied	\N	\N	\N	\N	81253	81253	249184
7048	5873	1	applied	\N	\N	\N	\N	81254	81254	249185
7048	5874	2	applied	\N	\N	\N	\N	81255	81255	249186
7048	5875	3	applied	\N	\N	\N	\N	81256	81256	249187
7050	5878	0	applied	\N	\N	\N	\N	81259	81259	249190
7050	5879	1	applied	\N	\N	\N	\N	81260	81260	249191
7055	5882	0	applied	\N	\N	\N	\N	81271	81271	249202
7055	5883	1	applied	\N	\N	\N	\N	81272	81272	249203
7055	5884	2	applied	\N	\N	\N	\N	81273	81273	249204
7055	5885	3	applied	\N	\N	\N	\N	81274	81274	249205
7057	5888	0	applied	\N	\N	\N	\N	81277	81277	249208
7057	5889	1	applied	\N	\N	\N	\N	81278	81278	249209
7060	5892	0	applied	\N	\N	\N	\N	81283	81283	249214
7060	5894	2	applied	\N	\N	\N	\N	81285	81285	249216
7060	5895	3	applied	\N	\N	\N	\N	81286	81286	249217
7065	5898	0	applied	\N	\N	\N	\N	81293	81293	249224
7065	5899	1	applied	\N	\N	\N	\N	81294	81294	249225
7065	5900	2	applied	\N	\N	\N	\N	81295	81295	249226
7065	5901	3	applied	\N	\N	\N	\N	81296	81296	249227
7071	5902	0	applied	\N	\N	\N	\N	81378	81378	249309
7071	5903	1	applied	\N	\N	1000000000	\N	81379	81379	249310
7071	5905	2	applied	\N	\N	1000000000	\N	81380	81380	249311
7071	5906	3	applied	\N	\N	\N	\N	81381	81381	249312
7071	5904	4	applied	\N	\N	\N	\N	81382	81382	249313
7071	5907	5	applied	\N	\N	\N	\N	81383	81383	249314
7077	5911	0	applied	\N	\N	\N	\N	81402	81402	249333
7077	5909	1	applied	\N	\N	\N	\N	81403	81403	249334
7077	5912	2	applied	\N	\N	\N	\N	81404	81404	249335
7077	5913	3	applied	\N	\N	\N	\N	81405	81405	249336
7077	5915	5	applied	\N	\N	\N	\N	81407	81407	249338
7077	5916	6	applied	\N	\N	\N	\N	81408	81408	249339
7077	5910	7	applied	\N	\N	\N	\N	81409	81409	249340
7077	5917	8	applied	\N	\N	\N	\N	81410	81410	249341
6959	5733	0	applied	\N	\N	\N	\N	80991	80991	248922
6959	5734	1	applied	\N	\N	\N	\N	80992	80992	248923
6970	5750	4	applied	\N	\N	\N	\N	81015	81015	248946
6970	5751	5	applied	\N	\N	\N	\N	81016	81016	248947
6970	5752	6	applied	\N	\N	\N	\N	81017	81017	248948
6970	5753	7	applied	\N	\N	\N	\N	81018	81018	248949
6970	5754	8	applied	\N	\N	\N	\N	81019	81019	248950
6974	5756	0	applied	\N	\N	\N	\N	81025	81025	248956
6974	5755	1	applied	\N	\N	\N	\N	81026	81026	248957
6977	5757	0	applied	\N	\N	\N	\N	81032	81032	248963
6977	5756	1	applied	\N	\N	\N	\N	81033	81033	248964
6977	5758	2	applied	\N	\N	\N	\N	81034	81034	248965
6979	5761	0	applied	\N	\N	\N	\N	81037	81037	248968
6987	5777	0	applied	\N	\N	\N	\N	81059	81059	248990
6987	5778	1	applied	\N	\N	\N	\N	81060	81060	248991
6990	5781	0	applied	\N	\N	\N	\N	81065	81065	248996
6990	5782	1	applied	\N	\N	\N	\N	81066	81066	248997
6990	5783	2	applied	\N	\N	\N	\N	81067	81067	248998
6990	5784	3	applied	\N	\N	\N	\N	81068	81068	248999
6994	5785	0	applied	\N	\N	\N	\N	81091	81091	249022
6994	5786	1	applied	\N	\N	1000000000	\N	81092	81092	249023
6994	5787	2	applied	\N	\N	\N	\N	81093	81093	249024
6994	5788	3	applied	\N	\N	\N	\N	81094	81094	249025
6994	5789	4	applied	\N	\N	\N	\N	81095	81095	249026
6994	5790	5	applied	\N	\N	\N	\N	81096	81096	249027
6994	5791	6	applied	\N	\N	\N	\N	81097	81097	249028
6994	5792	7	applied	\N	\N	\N	\N	81098	81098	249029
6994	5793	8	applied	\N	\N	\N	\N	81099	81099	249030
6995	5794	0	applied	\N	\N	\N	\N	81100	81100	249031
7000	5798	0	applied	\N	\N	\N	\N	81108	81108	249039
7000	5799	1	applied	\N	\N	\N	\N	81109	81109	249040
7006	5800	0	applied	\N	\N	\N	\N	81112	81112	249043
7006	5801	1	applied	\N	\N	\N	\N	81113	81113	249044
7011	5802	0	applied	\N	\N	\N	\N	81131	81131	249062
7011	5803	1	applied	\N	\N	\N	\N	81132	81132	249063
7011	5804	2	applied	\N	\N	\N	\N	81133	81133	249064
7011	5805	3	applied	\N	\N	\N	\N	81134	81134	249065
7011	5806	4	applied	\N	\N	\N	\N	81135	81135	249066
7015	5809	0	applied	\N	\N	\N	\N	81142	81142	249073
7015	5810	1	applied	\N	\N	\N	\N	81143	81143	249074
7018	5815	0	applied	\N	\N	\N	\N	81152	81152	249083
7018	5816	1	applied	\N	\N	\N	\N	81153	81153	249084
7018	5817	2	applied	\N	\N	\N	\N	81154	81154	249085
7018	5818	3	applied	\N	\N	\N	\N	81155	81155	249086
7023	5823	0	applied	\N	\N	\N	\N	81174	81174	249105
7023	5825	2	applied	\N	\N	\N	\N	81176	81176	249107
7023	5826	3	applied	\N	\N	\N	\N	81177	81177	249108
7023	5827	4	applied	\N	\N	\N	\N	81178	81178	249109
7023	5828	5	applied	\N	\N	\N	\N	81179	81179	249110
7026	5829	0	applied	\N	\N	\N	\N	81188	81188	249119
7026	5830	1	applied	\N	\N	\N	\N	81189	81189	249120
7026	5831	2	applied	\N	\N	\N	\N	81190	81190	249121
7026	5832	3	applied	\N	\N	\N	\N	81191	81191	249122
7028	5833	0	applied	\N	\N	\N	\N	81194	81194	249125
7028	5834	1	applied	\N	\N	\N	\N	81195	81195	249126
7043	5867	1	applied	\N	\N	\N	\N	81236	81236	249167
7043	5868	2	applied	\N	\N	\N	\N	81237	81237	249168
7043	5869	3	applied	\N	\N	\N	\N	81238	81238	249169
7046	5872	0	applied	\N	\N	\N	\N	81245	81245	249176
7046	5873	1	applied	\N	\N	\N	\N	81246	81246	249177
7046	5874	2	applied	\N	\N	\N	\N	81247	81247	249178
7049	5876	0	applied	\N	\N	\N	\N	81257	81257	249188
7049	5877	1	applied	\N	\N	\N	\N	81258	81258	249189
7052	5880	0	applied	\N	\N	\N	\N	81263	81263	249194
7052	5881	1	applied	\N	\N	\N	\N	81264	81264	249195
7054	5882	0	applied	\N	\N	\N	\N	81267	81267	249198
7054	5883	1	applied	\N	\N	\N	\N	81268	81268	249199
7054	5884	2	applied	\N	\N	\N	\N	81269	81269	249200
7054	5885	3	applied	\N	\N	\N	\N	81270	81270	249201
7058	5890	0	applied	\N	\N	\N	\N	81279	81279	249210
7058	5891	1	applied	\N	\N	\N	\N	81280	81280	249211
7072	5908	0	applied	\N	\N	\N	\N	81384	81384	249315
7074	5909	0	applied	\N	\N	\N	\N	81387	81387	249318
7074	5910	1	applied	\N	\N	\N	\N	81388	81388	249319
7080	5922	0	applied	\N	\N	\N	\N	81541	81541	249472
7080	5923	1	applied	\N	\N	\N	\N	81542	81542	249473
7080	5924	2	applied	\N	\N	\N	\N	81543	81543	249474
7083	5930	0	applied	\N	\N	\N	\N	81553	81553	249484
7083	5931	1	applied	\N	\N	\N	\N	81554	81554	249485
7083	5932	2	applied	\N	\N	\N	\N	81555	81555	249486
7083	5933	3	applied	\N	\N	\N	\N	81556	81556	249487
7085	5934	0	applied	\N	\N	\N	\N	81561	81561	249492
7085	5935	1	applied	\N	\N	\N	\N	81562	81562	249493
7095	5948	0	applied	\N	\N	\N	\N	81581	81581	249512
7095	5949	1	applied	\N	\N	\N	\N	81582	81582	249513
7097	5950	0	applied	\N	\N	\N	\N	81585	81585	249516
7097	5951	1	applied	\N	\N	\N	\N	81586	81586	249517
7100	5952	0	applied	\N	\N	\N	\N	81591	81591	249522
7100	5953	1	applied	\N	\N	\N	\N	81592	81592	249523
7106	5959	0	applied	\N	\N	\N	\N	81603	81603	249534
7106	5960	1	applied	\N	\N	\N	\N	81604	81604	249535
7111	5971	0	applied	\N	\N	\N	\N	81619	81619	249550
7111	5972	1	applied	\N	\N	\N	\N	81620	81620	249551
7111	5974	3	applied	\N	\N	\N	\N	81622	81622	249553
7114	5981	0	applied	\N	\N	\N	\N	81633	81633	249564
7114	5982	1	applied	\N	\N	1000000000	\N	81634	81634	249565
7114	5983	2	applied	\N	\N	\N	\N	81635	81635	249566
7121	6005	0	applied	\N	\N	\N	\N	81670	81670	249601
7121	6006	1	applied	\N	\N	\N	\N	81671	81671	249602
7121	6007	2	applied	\N	\N	\N	\N	81672	81672	249603
7121	6008	3	applied	\N	\N	1000000000	\N	81673	81673	249604
7121	6009	4	applied	\N	\N	\N	\N	81674	81674	249605
7122	6010	0	applied	\N	\N	\N	\N	81675	81675	249606
7122	6011	1	applied	\N	\N	\N	\N	81676	81676	249607
7122	6012	2	applied	\N	\N	\N	\N	81677	81677	249608
7122	6013	3	applied	\N	\N	\N	\N	81678	81678	249609
7122	6014	4	applied	\N	\N	\N	\N	81679	81679	249610
7122	6015	5	applied	\N	\N	\N	\N	81680	81680	249611
7124	6016	0	applied	\N	\N	\N	\N	81687	81687	249618
7129	6022	0	applied	\N	\N	\N	\N	81697	81697	249628
7129	6023	1	applied	\N	\N	\N	\N	81698	81698	249629
6970	5748	2	applied	\N	\N	\N	\N	81013	81013	248944
6970	5749	3	applied	\N	\N	\N	\N	81014	81014	248945
7062	5896	0	applied	\N	\N	\N	\N	81287	81287	249218
7062	5897	1	applied	\N	\N	\N	\N	81288	81288	249219
7064	5898	0	applied	\N	\N	\N	\N	81289	81289	249220
7064	5899	1	applied	\N	\N	\N	\N	81290	81290	249221
7064	5900	2	applied	\N	\N	\N	\N	81291	81291	249222
7064	5901	3	applied	\N	\N	\N	\N	81292	81292	249223
7066	5902	0	applied	\N	\N	\N	\N	81297	81297	249228
7066	5904	2	applied	\N	\N	\N	\N	81299	81299	249230
7067	5902	0	applied	\N	\N	\N	\N	81300	81300	249231
7067	5903	1	applied	\N	\N	1000000000	\N	81301	81301	249232
7067	5904	2	applied	\N	\N	\N	\N	81302	81302	249233
7068	5902	0	applied	\N	\N	\N	\N	81303	81303	249234
7068	5903	1	applied	\N	\N	1000000000	\N	81304	81304	249235
7068	5904	2	applied	\N	\N	\N	\N	81305	81305	249236
7070	5833	0	applied	\N	\N	\N	\N	81306	81306	249237
7070	5837	1	applied	\N	\N	\N	\N	81307	81307	249238
7070	5838	2	applied	\N	\N	\N	\N	81308	81308	249239
7070	5840	3	applied	\N	\N	\N	\N	81309	81309	249240
7070	5841	4	applied	\N	\N	\N	\N	81310	81310	249241
7070	5842	5	applied	\N	\N	\N	\N	81311	81311	249242
7070	5845	6	applied	\N	\N	\N	\N	81312	81312	249243
7070	5834	7	applied	\N	\N	\N	\N	81313	81313	249244
7070	5835	8	applied	\N	\N	\N	\N	81314	81314	249245
7070	5836	9	applied	\N	\N	\N	\N	81315	81315	249246
7070	5839	10	applied	\N	\N	\N	\N	81316	81316	249247
7070	5843	11	applied	\N	\N	\N	\N	81317	81317	249248
7070	5844	12	applied	\N	\N	\N	\N	81318	81318	249249
7070	5847	14	applied	\N	\N	\N	\N	81320	81320	249251
7070	5849	15	applied	\N	\N	\N	\N	81321	81321	249252
7070	5852	16	applied	\N	\N	\N	\N	81322	81322	249253
7070	5853	17	applied	\N	\N	\N	\N	81323	81323	249254
7070	5856	18	applied	\N	\N	\N	\N	81324	81324	249255
7070	5857	19	applied	\N	\N	\N	\N	81325	81325	249256
7070	5859	20	applied	\N	\N	\N	\N	81326	81326	249257
7070	5862	21	applied	\N	\N	\N	\N	81327	81327	249258
7070	5863	22	applied	\N	\N	\N	\N	81328	81328	249259
7070	5868	23	applied	\N	\N	\N	\N	81329	81329	249260
7070	5869	24	applied	\N	\N	\N	\N	81330	81330	249261
7070	5871	25	applied	\N	\N	\N	\N	81331	81331	249262
7070	5872	26	applied	\N	\N	\N	\N	81332	81332	249263
7070	5873	27	applied	\N	\N	\N	\N	81333	81333	249264
7070	5876	28	applied	\N	\N	\N	\N	81334	81334	249265
7070	5878	29	applied	\N	\N	\N	\N	81335	81335	249266
7070	5882	31	applied	\N	\N	\N	\N	81337	81337	249268
7070	5883	32	applied	\N	\N	\N	\N	81338	81338	249269
7070	5886	33	applied	\N	\N	\N	\N	81339	81339	249270
7070	5888	34	applied	\N	\N	\N	\N	81340	81340	249271
7070	5891	35	applied	\N	\N	\N	\N	81341	81341	249272
7070	5892	36	applied	\N	\N	\N	\N	81342	81342	249273
7070	5893	37	applied	\N	\N	\N	\N	81343	81343	249274
7070	5897	38	applied	\N	\N	\N	\N	81344	81344	249275
7070	5900	39	applied	\N	\N	\N	\N	81345	81345	249276
7070	5901	40	applied	\N	\N	\N	\N	81346	81346	249277
7070	5848	41	applied	\N	\N	\N	\N	81347	81347	249278
7070	5850	42	applied	\N	\N	\N	\N	81348	81348	249279
7070	5851	43	applied	\N	\N	\N	\N	81349	81349	249280
7070	5854	44	applied	\N	\N	\N	\N	81350	81350	249281
7070	5855	45	applied	\N	\N	\N	\N	81351	81351	249282
7070	5858	46	applied	\N	\N	\N	\N	81352	81352	249283
7070	5861	48	applied	\N	\N	1000000000	\N	81354	81354	249285
7070	5864	49	applied	\N	\N	\N	\N	81355	81355	249286
7070	5865	50	applied	\N	\N	\N	\N	81356	81356	249287
7070	5866	51	applied	\N	\N	\N	\N	81357	81357	249288
7070	5867	52	applied	\N	\N	\N	\N	81358	81358	249289
7070	5870	54	applied	\N	\N	\N	\N	81359	81359	249290
7070	5874	55	applied	\N	\N	\N	\N	81360	81360	249291
7070	5875	56	applied	\N	\N	\N	\N	81361	81361	249292
7070	5877	57	applied	\N	\N	\N	\N	81362	81362	249293
7070	5879	58	applied	\N	\N	\N	\N	81363	81363	249294
7070	5881	59	applied	\N	\N	\N	\N	81364	81364	249295
7070	5884	60	applied	\N	\N	\N	\N	81365	81365	249296
7073	5909	0	applied	\N	\N	\N	\N	81385	81385	249316
7073	5910	1	applied	\N	\N	\N	\N	81386	81386	249317
7079	5922	0	applied	\N	\N	\N	\N	81537	81537	249468
7079	5923	1	applied	\N	\N	\N	\N	81538	81538	249469
7079	5925	3	applied	\N	\N	\N	\N	81540	81540	249471
7082	5930	0	applied	\N	\N	\N	\N	81549	81549	249480
7082	5931	1	applied	\N	\N	\N	\N	81550	81550	249481
7082	5932	2	applied	\N	\N	\N	\N	81551	81551	249482
7082	5933	3	applied	\N	\N	\N	\N	81552	81552	249483
7084	5930	0	applied	\N	\N	\N	\N	81557	81557	249488
7084	5931	1	applied	\N	\N	\N	\N	81558	81558	249489
7084	5932	2	applied	\N	\N	\N	\N	81559	81559	249490
7084	5933	3	applied	\N	\N	\N	\N	81560	81560	249491
7089	5940	0	applied	\N	\N	\N	\N	81569	81569	249500
7089	5941	1	applied	\N	\N	\N	\N	81570	81570	249501
7094	5948	0	applied	\N	\N	\N	\N	81580	81580	249511
7096	5950	0	applied	\N	\N	\N	\N	81583	81583	249514
7096	5951	1	applied	\N	\N	\N	\N	81584	81584	249515
7102	5952	0	applied	\N	\N	\N	\N	81595	81595	249526
7113	5975	0	applied	\N	\N	\N	\N	81627	81627	249558
7113	5977	2	applied	\N	\N	\N	\N	81629	81629	249560
7113	5978	3	applied	\N	\N	\N	\N	81630	81630	249561
7113	5979	4	applied	\N	\N	\N	\N	81631	81631	249562
7113	5980	5	applied	\N	\N	\N	\N	81632	81632	249563
7116	5988	0	applied	\N	\N	\N	\N	81640	81640	249571
7116	5989	1	applied	\N	\N	\N	\N	81641	81641	249572
7116	5990	2	applied	\N	\N	\N	\N	81642	81642	249573
7116	5991	3	applied	\N	\N	\N	\N	81643	81643	249574
7118	5992	0	applied	\N	\N	\N	\N	81655	81655	249586
7118	5993	1	applied	\N	\N	\N	\N	81656	81656	249587
7118	5994	2	applied	\N	\N	\N	\N	81657	81657	249588
7118	5995	3	applied	\N	\N	\N	\N	81658	81658	249589
7118	5996	4	applied	\N	\N	\N	\N	81659	81659	249590
7118	5997	5	applied	\N	\N	\N	\N	81660	81660	249591
7118	5998	6	applied	\N	\N	\N	\N	81661	81661	249592
7118	5999	7	applied	\N	\N	\N	\N	81662	81662	249593
7118	6001	9	applied	\N	\N	\N	\N	81664	81664	249595
7118	6002	10	applied	\N	\N	\N	\N	81665	81665	249596
7059	5890	0	applied	\N	\N	\N	\N	81281	81281	249212
7059	5891	1	applied	\N	\N	\N	\N	81282	81282	249213
7070	5894	65	applied	\N	\N	\N	\N	81370	81370	249301
7070	5895	66	applied	\N	\N	\N	\N	81371	81371	249302
7070	5896	67	applied	\N	\N	\N	\N	81372	81372	249303
7070	5898	68	applied	\N	\N	\N	\N	81373	81373	249304
7070	5899	69	applied	\N	\N	\N	\N	81374	81374	249305
7070	5902	70	applied	\N	\N	\N	\N	81375	81375	249306
7070	5903	71	applied	\N	\N	1000000000	\N	81376	81376	249307
7070	5904	72	applied	\N	\N	\N	\N	81377	81377	249308
7076	5911	0	applied	\N	\N	\N	\N	81389	81389	249320
7076	5909	1	applied	\N	\N	\N	\N	81390	81390	249321
7076	5912	2	applied	\N	\N	\N	\N	81391	81391	249322
7076	5913	3	applied	\N	\N	\N	\N	81392	81392	249323
7076	5914	4	applied	\N	\N	\N	\N	81393	81393	249324
7076	5915	5	applied	\N	\N	\N	\N	81394	81394	249325
7076	5910	7	applied	\N	\N	\N	\N	81396	81396	249327
7076	5917	8	applied	\N	\N	\N	\N	81397	81397	249328
7076	5918	9	applied	\N	\N	\N	\N	81398	81398	249329
7076	5919	10	applied	\N	\N	\N	\N	81399	81399	249330
7076	5920	11	applied	\N	\N	\N	\N	81400	81400	249331
7076	5921	12	applied	\N	\N	\N	\N	81401	81401	249332
7077	5918	9	applied	\N	\N	\N	\N	81411	81411	249342
7077	5919	10	applied	\N	\N	\N	\N	81412	81412	249343
7077	5920	11	applied	\N	\N	\N	\N	81413	81413	249344
7077	5921	12	applied	\N	\N	\N	\N	81414	81414	249345
7078	5800	0	applied	\N	\N	\N	\N	81415	81415	249346
7078	5801	1	applied	\N	\N	\N	\N	81416	81416	249347
7078	5911	2	applied	\N	\N	\N	\N	81417	81417	249348
7078	5802	3	applied	\N	\N	\N	\N	81418	81418	249349
7078	5803	4	applied	\N	\N	\N	\N	81419	81419	249350
7078	5804	5	applied	\N	\N	\N	\N	81420	81420	249351
7078	5807	7	applied	\N	\N	\N	\N	81422	81422	249353
7078	5809	8	applied	\N	\N	\N	\N	81423	81423	249354
7078	5811	9	applied	\N	\N	\N	\N	81424	81424	249355
7078	5812	10	applied	\N	\N	\N	\N	81425	81425	249356
7078	5816	11	applied	\N	\N	\N	\N	81426	81426	249357
7078	5817	12	applied	\N	\N	\N	\N	81427	81427	249358
7078	5821	13	applied	\N	\N	\N	\N	81428	81428	249359
7078	5822	14	applied	\N	\N	\N	\N	81429	81429	249360
7078	5808	15	applied	\N	\N	\N	\N	81430	81430	249361
7078	5810	16	applied	\N	\N	\N	\N	81431	81431	249362
7078	5813	17	applied	\N	\N	\N	\N	81432	81432	249363
7078	5814	18	applied	\N	\N	\N	\N	81433	81433	249364
7078	5815	19	applied	\N	\N	\N	\N	81434	81434	249365
7078	5825	20	applied	\N	\N	\N	\N	81435	81435	249366
7078	5826	21	applied	\N	\N	\N	\N	81436	81436	249367
7078	5827	22	applied	\N	\N	\N	\N	81437	81437	249368
7078	5832	24	applied	\N	\N	\N	\N	81439	81439	249370
7078	5818	25	applied	\N	\N	\N	\N	81440	81440	249371
7078	5819	26	applied	\N	\N	\N	\N	81441	81441	249372
7078	5820	27	applied	\N	\N	\N	\N	81442	81442	249373
7078	5823	28	applied	\N	\N	\N	\N	81443	81443	249374
7078	5824	29	applied	\N	\N	\N	\N	81444	81444	249375
7078	5828	30	applied	\N	\N	\N	\N	81445	81445	249376
7078	5830	31	applied	\N	\N	\N	\N	81446	81446	249377
7078	5831	32	applied	\N	\N	\N	\N	81447	81447	249378
7078	5833	33	applied	\N	\N	\N	\N	81448	81448	249379
7078	5837	34	applied	\N	\N	\N	\N	81449	81449	249380
7078	5838	35	applied	\N	\N	\N	\N	81450	81450	249381
7078	5840	36	applied	\N	\N	\N	\N	81451	81451	249382
7078	5841	37	applied	\N	\N	\N	\N	81452	81452	249383
7078	5842	38	applied	\N	\N	\N	\N	81453	81453	249384
7078	5845	39	applied	\N	\N	\N	\N	81454	81454	249385
7078	5835	41	applied	\N	\N	\N	\N	81456	81456	249387
7078	5836	42	applied	\N	\N	\N	\N	81457	81457	249388
7078	5839	43	applied	\N	\N	\N	\N	81458	81458	249389
7078	5843	44	applied	\N	\N	\N	\N	81459	81459	249390
7078	5844	45	applied	\N	\N	\N	\N	81460	81460	249391
7078	5846	46	applied	\N	\N	\N	\N	81461	81461	249392
7078	5847	47	applied	\N	\N	\N	\N	81462	81462	249393
7078	5849	48	applied	\N	\N	\N	\N	81463	81463	249394
7078	5852	49	applied	\N	\N	\N	\N	81464	81464	249395
7078	5853	50	applied	\N	\N	\N	\N	81465	81465	249396
7078	5856	51	applied	\N	\N	\N	\N	81466	81466	249397
7078	5857	52	applied	\N	\N	\N	\N	81467	81467	249398
7078	5859	53	applied	\N	\N	\N	\N	81468	81468	249399
7078	5862	54	applied	\N	\N	\N	\N	81469	81469	249400
7078	5863	55	applied	\N	\N	\N	\N	81470	81470	249401
7078	5868	56	applied	\N	\N	\N	\N	81471	81471	249402
7078	5871	58	applied	\N	\N	\N	\N	81473	81473	249404
7078	5872	59	applied	\N	\N	\N	\N	81474	81474	249405
7078	5873	60	applied	\N	\N	\N	\N	81475	81475	249406
7078	5876	61	applied	\N	\N	\N	\N	81476	81476	249407
7078	5878	62	applied	\N	\N	\N	\N	81477	81477	249408
7078	5880	63	applied	\N	\N	\N	\N	81478	81478	249409
7078	5882	64	applied	\N	\N	\N	\N	81479	81479	249410
7078	5883	65	applied	\N	\N	\N	\N	81480	81480	249411
7078	5886	66	applied	\N	\N	\N	\N	81481	81481	249412
7087	5936	0	applied	\N	\N	\N	\N	81565	81565	249496
7087	5937	1	applied	\N	\N	\N	\N	81566	81566	249497
7090	5942	0	applied	\N	\N	\N	\N	81571	81571	249502
7090	5943	1	applied	\N	\N	\N	\N	81572	81572	249503
7092	5945	0	applied	\N	\N	\N	\N	81574	81574	249505
7092	5946	1	applied	\N	\N	\N	\N	81575	81575	249506
7092	5947	2	applied	\N	\N	\N	\N	81576	81576	249507
7099	5953	1	applied	\N	\N	\N	\N	81590	81590	249521
7103	5954	0	applied	\N	\N	\N	\N	81596	81596	249527
7103	5955	1	applied	\N	\N	\N	\N	81597	81597	249528
7104	5956	0	applied	\N	\N	\N	\N	81598	81598	249529
7104	5957	1	applied	\N	\N	\N	\N	81599	81599	249530
7104	5958	2	applied	\N	\N	\N	\N	81600	81600	249531
7105	5959	0	applied	\N	\N	\N	\N	81601	81601	249532
7105	5960	1	applied	\N	\N	\N	\N	81602	81602	249533
7110	5967	0	applied	\N	\N	\N	\N	81615	81615	249546
7110	5968	1	applied	\N	\N	\N	\N	81616	81616	249547
7110	5969	2	applied	\N	\N	\N	\N	81617	81617	249548
7110	5970	3	applied	\N	\N	\N	\N	81618	81618	249549
7126	6018	0	applied	\N	\N	\N	\N	81691	81691	249622
7126	6019	1	applied	\N	\N	\N	\N	81692	81692	249623
7131	6024	0	applied	\N	\N	\N	\N	81701	81701	249632
7131	6025	1	applied	\N	\N	\N	\N	81702	81702	249633
7070	5890	64	applied	\N	\N	\N	\N	81369	81369	249300
7078	5893	70	applied	\N	\N	\N	\N	81485	81485	249416
7078	5897	71	applied	\N	\N	\N	\N	81486	81486	249417
7078	5900	72	applied	\N	\N	\N	\N	81487	81487	249418
7078	5901	73	applied	\N	\N	\N	\N	81488	81488	249419
7078	5848	74	applied	\N	\N	\N	\N	81489	81489	249420
7078	5850	75	applied	\N	\N	\N	\N	81490	81490	249421
7078	5851	76	applied	\N	\N	\N	\N	81491	81491	249422
7078	5854	77	applied	\N	\N	\N	\N	81492	81492	249423
7078	5855	78	applied	\N	\N	\N	\N	81493	81493	249424
7078	5858	79	applied	\N	\N	\N	\N	81494	81494	249425
7078	5860	80	applied	\N	\N	\N	\N	81495	81495	249426
7078	5864	82	applied	\N	\N	\N	\N	81497	81497	249428
7078	5865	83	applied	\N	\N	\N	\N	81498	81498	249429
7078	5866	84	applied	\N	\N	\N	\N	81499	81499	249430
7078	5867	85	applied	\N	\N	\N	\N	81500	81500	249431
7078	5870	86	applied	\N	\N	\N	\N	81501	81501	249432
7078	5874	87	applied	\N	\N	\N	\N	81502	81502	249433
7078	5875	88	applied	\N	\N	\N	\N	81503	81503	249434
7078	5877	89	applied	\N	\N	\N	\N	81504	81504	249435
7078	5879	90	applied	\N	\N	\N	\N	81505	81505	249436
7078	5881	91	applied	\N	\N	\N	\N	81506	81506	249437
7078	5884	92	applied	\N	\N	\N	\N	81507	81507	249438
7078	5885	93	applied	\N	\N	\N	\N	81508	81508	249439
7078	5887	94	applied	\N	\N	\N	\N	81509	81509	249440
7078	5889	95	applied	\N	\N	\N	\N	81510	81510	249441
7078	5890	96	applied	\N	\N	\N	\N	81511	81511	249442
7078	5894	97	applied	\N	\N	\N	\N	81512	81512	249443
7078	5895	98	applied	\N	\N	\N	\N	81513	81513	249444
7078	5896	99	applied	\N	\N	\N	\N	81514	81514	249445
7078	5899	101	applied	\N	\N	\N	\N	81516	81516	249447
7078	5902	102	applied	\N	\N	\N	\N	81517	81517	249448
7078	5903	103	applied	\N	\N	1000000000	\N	81518	81518	249449
7078	5905	105	applied	\N	\N	1000000000	\N	81519	81519	249450
7078	5906	106	applied	\N	\N	\N	\N	81520	81520	249451
7078	5909	107	applied	\N	\N	\N	\N	81521	81521	249452
7078	5912	108	applied	\N	\N	\N	\N	81522	81522	249453
7078	5913	109	applied	\N	\N	\N	\N	81523	81523	249454
7078	5914	110	applied	\N	\N	\N	\N	81524	81524	249455
7078	5915	111	applied	\N	\N	\N	\N	81525	81525	249456
7078	5916	112	applied	\N	\N	\N	\N	81526	81526	249457
7078	5904	113	applied	\N	\N	\N	\N	81527	81527	249458
7078	5907	114	applied	\N	\N	\N	\N	81528	81528	249459
7078	5908	115	applied	\N	\N	\N	\N	81529	81529	249460
7078	5910	116	applied	\N	\N	\N	\N	81530	81530	249461
7078	5917	117	applied	\N	\N	\N	\N	81531	81531	249462
7078	5919	119	applied	\N	\N	\N	\N	81533	81533	249464
7078	5920	120	applied	\N	\N	\N	\N	81534	81534	249465
7078	5921	121	applied	\N	\N	\N	\N	81535	81535	249466
7078	5806	122	applied	\N	\N	\N	\N	81536	81536	249467
7081	5926	0	applied	\N	\N	\N	\N	81545	81545	249476
7081	5927	1	applied	\N	\N	\N	\N	81546	81546	249477
7081	5928	2	applied	\N	\N	\N	\N	81547	81547	249478
7081	5929	3	applied	\N	\N	\N	\N	81548	81548	249479
7086	5934	0	applied	\N	\N	\N	\N	81563	81563	249494
7086	5935	1	applied	\N	\N	\N	\N	81564	81564	249495
7088	5938	0	applied	\N	\N	\N	\N	81567	81567	249498
7088	5939	1	applied	\N	\N	\N	\N	81568	81568	249499
7091	5944	0	applied	\N	\N	\N	\N	81573	81573	249504
7093	5945	0	applied	\N	\N	\N	\N	81577	81577	249508
7093	5946	1	applied	\N	\N	\N	\N	81578	81578	249509
7093	5947	2	applied	\N	\N	\N	\N	81579	81579	249510
7098	5951	1	applied	\N	\N	\N	\N	81588	81588	249519
7101	5952	0	applied	\N	\N	\N	\N	81593	81593	249524
7101	5953	1	applied	\N	\N	\N	\N	81594	81594	249525
7107	5961	0	applied	\N	\N	\N	\N	81605	81605	249536
7107	5962	1	applied	\N	\N	\N	\N	81606	81606	249537
7108	5963	0	applied	\N	\N	\N	\N	81607	81607	249538
7108	5964	1	applied	\N	\N	\N	\N	81608	81608	249539
7108	5965	2	applied	\N	\N	\N	\N	81609	81609	249540
7108	5966	3	applied	\N	\N	\N	\N	81610	81610	249541
7109	5963	0	applied	\N	\N	\N	\N	81611	81611	249542
7109	5964	1	applied	\N	\N	\N	\N	81612	81612	249543
7109	5965	2	applied	\N	\N	\N	\N	81613	81613	249544
7109	5966	3	applied	\N	\N	\N	\N	81614	81614	249545
7112	5971	0	applied	\N	\N	\N	\N	81623	81623	249554
7112	5972	1	applied	\N	\N	\N	\N	81624	81624	249555
7112	5973	2	applied	\N	\N	\N	\N	81625	81625	249556
7115	5984	0	applied	\N	\N	\N	\N	81636	81636	249567
7115	5985	1	applied	\N	\N	\N	\N	81637	81637	249568
7115	5986	2	applied	\N	\N	\N	\N	81638	81638	249569
7115	5987	3	applied	\N	\N	\N	\N	81639	81639	249570
7117	5992	0	applied	\N	\N	\N	\N	81644	81644	249575
7117	5993	1	applied	\N	\N	\N	\N	81645	81645	249576
7117	5994	2	applied	\N	\N	\N	\N	81646	81646	249577
7117	5995	3	applied	\N	\N	\N	\N	81647	81647	249578
7117	5996	4	applied	\N	\N	\N	\N	81648	81648	249579
7117	5997	5	applied	\N	\N	\N	\N	81649	81649	249580
7117	5998	6	applied	\N	\N	\N	\N	81650	81650	249581
7117	5999	7	applied	\N	\N	\N	\N	81651	81651	249582
7117	6000	8	applied	\N	\N	\N	\N	81652	81652	249583
7117	6001	9	applied	\N	\N	\N	\N	81653	81653	249584
7117	6002	10	applied	\N	\N	\N	\N	81654	81654	249585
7119	6003	0	applied	\N	\N	\N	\N	81666	81666	249597
7120	6003	0	applied	\N	\N	\N	\N	81668	81668	249599
7120	6004	1	applied	\N	\N	\N	\N	81669	81669	249600
7123	6010	0	applied	\N	\N	\N	\N	81681	81681	249612
7123	6011	1	applied	\N	\N	\N	\N	81682	81682	249613
7123	6012	2	applied	\N	\N	\N	\N	81683	81683	249614
7123	6013	3	applied	\N	\N	\N	\N	81684	81684	249615
7123	6014	4	applied	\N	\N	\N	\N	81685	81685	249616
7123	6015	5	applied	\N	\N	\N	\N	81686	81686	249617
7125	6016	0	applied	\N	\N	\N	\N	81689	81689	249620
7125	6017	1	applied	\N	\N	\N	\N	81690	81690	249621
7127	6020	0	applied	\N	\N	\N	\N	81693	81693	249624
7127	6021	1	applied	\N	\N	\N	\N	81694	81694	249625
7128	6022	0	applied	\N	\N	\N	\N	81695	81695	249626
7128	6023	1	applied	\N	\N	\N	\N	81696	81696	249627
7130	6024	0	applied	\N	\N	\N	\N	81699	81699	249630
7130	6025	1	applied	\N	\N	\N	\N	81700	81700	249631
7078	5891	68	applied	\N	\N	\N	\N	81483	81483	249414
7078	5892	69	applied	\N	\N	\N	\N	81484	81484	249415
7133	6030	2	applied	\N	\N	\N	\N	81707	81707	249638
7134	6028	0	applied	\N	\N	\N	\N	81708	81708	249639
7134	6029	1	applied	\N	\N	\N	\N	81709	81709	249640
7134	6030	2	applied	\N	\N	\N	\N	81710	81710	249641
7135	6028	0	applied	\N	\N	\N	\N	81711	81711	249642
7135	6029	1	applied	\N	\N	\N	\N	81712	81712	249643
7135	6030	2	applied	\N	\N	\N	\N	81713	81713	249644
7136	6031	0	applied	\N	\N	\N	\N	81714	81714	249645
7136	6032	1	applied	\N	\N	\N	\N	81715	81715	249646
7137	6031	0	applied	\N	\N	\N	\N	81716	81716	249647
7137	6032	1	applied	\N	\N	\N	\N	81717	81717	249648
7138	6032	1	applied	\N	\N	\N	\N	81719	81719	249650
7139	6033	0	applied	\N	\N	\N	\N	81720	81720	249651
7141	6034	0	applied	\N	\N	\N	\N	81721	81721	249652
7142	6035	0	applied	\N	\N	\N	\N	81722	81722	249653
7142	6036	1	applied	\N	\N	\N	\N	81723	81723	249654
7142	6037	2	applied	\N	\N	\N	\N	81724	81724	249655
7143	6035	0	applied	\N	\N	\N	\N	81725	81725	249656
7143	6036	1	applied	\N	\N	\N	\N	81726	81726	249657
7143	6037	2	applied	\N	\N	\N	\N	81727	81727	249658
7144	6038	0	applied	\N	\N	\N	\N	81728	81728	249659
7145	6039	0	applied	\N	\N	\N	\N	81729	81729	249660
7146	6039	0	applied	\N	\N	\N	\N	81730	81730	249661
7147	6039	0	applied	\N	\N	\N	\N	81731	81731	249662
7148	6040	0	applied	\N	\N	1000000000	\N	81732	81732	249663
7148	6041	1	applied	\N	\N	\N	\N	81733	81733	249664
7149	6041	1	applied	\N	\N	\N	\N	81735	81735	249666
7150	5905	0	applied	\N	\N	1000000000	\N	81736	81736	249667
7150	5911	1	applied	\N	\N	\N	\N	81737	81737	249668
7150	5906	2	applied	\N	\N	\N	\N	81738	81738	249669
7150	5909	3	applied	\N	\N	\N	\N	81739	81739	249670
7150	5912	4	applied	\N	\N	\N	\N	81740	81740	249671
7150	5913	5	applied	\N	\N	\N	\N	81741	81741	249672
7150	5914	6	applied	\N	\N	\N	\N	81742	81742	249673
7150	5915	7	applied	\N	\N	\N	\N	81743	81743	249674
7150	5916	8	applied	\N	\N	\N	\N	81744	81744	249675
7150	5922	9	applied	\N	\N	\N	\N	81745	81745	249676
7150	5907	10	applied	\N	\N	\N	\N	81746	81746	249677
7150	5908	11	applied	\N	\N	\N	\N	81747	81747	249678
7150	5910	12	applied	\N	\N	\N	\N	81748	81748	249679
7150	5917	13	applied	\N	\N	\N	\N	81749	81749	249680
7150	5918	14	applied	\N	\N	\N	\N	81750	81750	249681
7150	5919	15	applied	\N	\N	\N	\N	81751	81751	249682
7150	5920	16	applied	\N	\N	\N	\N	81752	81752	249683
7150	5921	17	applied	\N	\N	\N	\N	81753	81753	249684
7150	5924	19	applied	\N	\N	\N	\N	81755	81755	249686
7150	5928	20	applied	\N	\N	\N	\N	81756	81756	249687
7150	5929	21	applied	\N	\N	\N	\N	81757	81757	249688
7150	5930	22	applied	\N	\N	\N	\N	81758	81758	249689
7150	5931	23	applied	\N	\N	\N	\N	81759	81759	249690
7150	5935	24	applied	\N	\N	\N	\N	81760	81760	249691
7150	5937	25	applied	\N	\N	\N	\N	81761	81761	249692
7150	5938	26	applied	\N	\N	\N	\N	81762	81762	249693
7150	5940	27	applied	\N	\N	\N	\N	81763	81763	249694
7150	5943	28	applied	\N	\N	\N	\N	81764	81764	249695
7150	5945	29	applied	\N	\N	\N	\N	81765	81765	249696
7150	5947	30	applied	\N	\N	\N	\N	81766	81766	249697
7150	5948	31	applied	\N	\N	\N	\N	81767	81767	249698
7150	5950	32	applied	\N	\N	\N	\N	81768	81768	249699
7150	5925	33	applied	\N	\N	\N	\N	81769	81769	249700
7150	5926	34	applied	\N	\N	\N	\N	81770	81770	249701
7150	5932	36	applied	\N	\N	\N	\N	81772	81772	249703
7150	5933	37	applied	\N	\N	\N	\N	81773	81773	249704
7150	5934	38	applied	\N	\N	\N	\N	81774	81774	249705
7150	5936	39	applied	\N	\N	\N	\N	81775	81775	249706
7150	5939	40	applied	\N	\N	\N	\N	81776	81776	249707
7150	5941	41	applied	\N	\N	\N	\N	81777	81777	249708
7150	5942	42	applied	\N	\N	\N	\N	81778	81778	249709
7150	5944	43	applied	\N	\N	\N	\N	81779	81779	249710
7150	5946	44	applied	\N	\N	\N	\N	81780	81780	249711
7150	5949	45	applied	\N	\N	\N	\N	81781	81781	249712
7150	5951	46	applied	\N	\N	\N	\N	81782	81782	249713
7150	5952	47	applied	\N	\N	\N	\N	81783	81783	249714
7150	5955	48	applied	\N	\N	\N	\N	81784	81784	249715
7150	5956	49	applied	\N	\N	\N	\N	81785	81785	249716
7150	5957	50	applied	\N	\N	\N	\N	81786	81786	249717
7150	5953	51	applied	\N	\N	\N	\N	81787	81787	249718
7150	5958	53	applied	\N	\N	\N	\N	81789	81789	249720
7150	5959	54	applied	\N	\N	\N	\N	81790	81790	249721
7150	5961	55	applied	\N	\N	\N	\N	81791	81791	249722
7150	5965	56	applied	\N	\N	\N	\N	81792	81792	249723
7150	5966	57	applied	\N	\N	\N	\N	81793	81793	249724
7150	5969	58	applied	\N	\N	\N	\N	81794	81794	249725
7150	5970	59	applied	\N	\N	\N	\N	81795	81795	249726
7150	5971	60	applied	\N	\N	\N	\N	81796	81796	249727
7150	5972	61	applied	\N	\N	\N	\N	81797	81797	249728
7150	5978	62	applied	\N	\N	\N	\N	81798	81798	249729
7150	5979	63	applied	\N	\N	\N	\N	81799	81799	249730
7150	5980	64	applied	\N	\N	\N	\N	81800	81800	249731
7150	5983	65	applied	\N	\N	\N	\N	81801	81801	249732
7150	5986	66	applied	\N	\N	\N	\N	81802	81802	249733
7150	5987	67	applied	\N	\N	\N	\N	81803	81803	249734
7150	5988	68	applied	\N	\N	\N	\N	81804	81804	249735
7150	5996	70	applied	\N	\N	\N	\N	81806	81806	249737
7150	5997	71	applied	\N	\N	\N	\N	81807	81807	249738
7150	5998	72	applied	\N	\N	\N	\N	81808	81808	249739
7150	5999	73	applied	\N	\N	\N	\N	81809	81809	249740
7150	6001	74	applied	\N	\N	\N	\N	81810	81810	249741
7150	6003	75	applied	\N	\N	\N	\N	81811	81811	249742
7150	6005	76	applied	\N	\N	\N	\N	81812	81812	249743
7150	6006	77	applied	\N	\N	\N	\N	81813	81813	249744
7150	6012	78	applied	\N	\N	\N	\N	81814	81814	249745
7150	6013	79	applied	\N	\N	\N	\N	81815	81815	249746
7150	6014	80	applied	\N	\N	\N	\N	81816	81816	249747
7150	6016	81	applied	\N	\N	\N	\N	81817	81817	249748
7150	6018	82	applied	\N	\N	\N	\N	81818	81818	249749
7150	6021	83	applied	\N	\N	\N	\N	81819	81819	249750
7150	6022	84	applied	\N	\N	\N	\N	81820	81820	249751
7150	6024	85	applied	\N	\N	\N	\N	81821	81821	249752
7133	6028	0	applied	\N	\N	\N	\N	81705	81705	249636
7133	6029	1	applied	\N	\N	\N	\N	81706	81706	249637
7150	5962	90	applied	\N	\N	\N	\N	81826	81826	249757
7150	5963	91	applied	\N	\N	\N	\N	81827	81827	249758
7150	5964	92	applied	\N	\N	\N	\N	81828	81828	249759
7150	5967	93	applied	\N	\N	\N	\N	81829	81829	249760
7150	5968	94	applied	\N	\N	\N	\N	81830	81830	249761
7150	5973	95	applied	\N	\N	\N	\N	81831	81831	249762
7150	5974	96	applied	\N	\N	\N	\N	81832	81832	249763
7150	5975	97	applied	\N	\N	\N	\N	81833	81833	249764
7150	5976	98	applied	\N	\N	\N	\N	81834	81834	249765
7150	5981	100	applied	\N	\N	\N	\N	81836	81836	249767
7150	5982	101	applied	\N	\N	1000000000	\N	81837	81837	249768
7150	5984	102	applied	\N	\N	\N	\N	81838	81838	249769
7150	5985	103	applied	\N	\N	\N	\N	81839	81839	249770
7150	5990	104	applied	\N	\N	\N	\N	81840	81840	249771
7150	5991	105	applied	\N	\N	\N	\N	81841	81841	249772
7150	5992	107	applied	\N	\N	\N	\N	81842	81842	249773
7150	5993	108	applied	\N	\N	\N	\N	81843	81843	249774
7150	5994	109	applied	\N	\N	\N	\N	81844	81844	249775
7150	5995	110	applied	\N	\N	\N	\N	81845	81845	249776
7150	6000	111	applied	\N	\N	\N	\N	81846	81846	249777
7150	6004	112	applied	\N	\N	\N	\N	81847	81847	249778
7150	6007	113	applied	\N	\N	\N	\N	81848	81848	249779
7150	6008	114	applied	\N	\N	1000000000	\N	81849	81849	249780
7150	6009	115	applied	\N	\N	\N	\N	81850	81850	249781
7150	6010	116	applied	\N	\N	\N	\N	81851	81851	249782
7150	6015	118	applied	\N	\N	\N	\N	81853	81853	249784
7150	6017	119	applied	\N	\N	\N	\N	81854	81854	249785
7150	6019	120	applied	\N	\N	\N	\N	81855	81855	249786
7150	6020	121	applied	\N	\N	\N	\N	81856	81856	249787
7150	6023	122	applied	\N	\N	\N	\N	81857	81857	249788
7150	6025	123	applied	\N	\N	\N	\N	81858	81858	249789
7150	6027	124	applied	\N	\N	\N	\N	81859	81859	249790
7150	6029	125	applied	\N	\N	\N	\N	81860	81860	249791
7151	6042	0	applied	\N	\N	\N	\N	81861	81861	249792
7151	6043	1	applied	\N	\N	\N	\N	81862	81862	249793
7152	6044	0	applied	\N	\N	\N	\N	81863	81863	249794
7152	6045	1	applied	\N	\N	\N	\N	81864	81864	249795
7154	6046	0	applied	\N	\N	\N	\N	81867	81867	249798
7155	6046	0	applied	\N	\N	\N	\N	81868	81868	249799
7157	6048	1	applied	\N	\N	\N	\N	81871	81871	249802
7157	6049	2	applied	\N	\N	\N	\N	81872	81872	249803
7160	6047	0	applied	\N	\N	1000000000	\N	81879	81879	249810
7160	6048	1	applied	\N	\N	\N	\N	81880	81880	249811
7160	6049	2	applied	\N	\N	\N	\N	81881	81881	249812
7163	6051	0	applied	\N	\N	\N	\N	81886	81886	249817
7165	6052	0	applied	\N	\N	\N	\N	81888	81888	249819
7166	6052	0	applied	\N	\N	\N	\N	81889	81889	249820
7168	6053	0	applied	\N	\N	\N	\N	81891	81891	249822
7170	6054	0	applied	\N	\N	\N	\N	81893	81893	249824
7173	6060	0	applied	\N	\N	\N	\N	81900	81900	249831
7173	6061	1	applied	\N	\N	\N	\N	81901	81901	249832
7174	6060	0	applied	\N	\N	\N	\N	81902	81902	249833
7174	6061	1	applied	\N	\N	\N	\N	81903	81903	249834
7176	6065	0	applied	\N	\N	\N	\N	81907	81907	249838
7177	6065	0	applied	\N	\N	\N	\N	81908	81908	249839
7181	6067	0	applied	\N	\N	\N	\N	81912	81912	249843
7183	6069	0	applied	\N	\N	\N	\N	81914	81914	249845
7184	6070	0	applied	\N	\N	\N	\N	81915	81915	249846
7186	6072	0	applied	\N	\N	\N	\N	81917	81917	249848
7192	6078	0	applied	\N	\N	\N	\N	81924	81924	249855
7192	6079	2	applied	\N	\N	\N	\N	81925	81925	249856
7195	6080	0	applied	\N	\N	\N	\N	81930	81930	249861
7195	6081	1	applied	\N	\N	\N	\N	81931	81931	249862
7200	6084	0	applied	\N	\N	\N	\N	81941	81941	249872
7202	6085	0	applied	\N	\N	\N	\N	81943	81943	249874
7202	6086	1	applied	\N	\N	\N	\N	81944	81944	249875
7205	6085	0	applied	\N	\N	\N	\N	81949	81949	249880
7205	6086	1	applied	\N	\N	\N	\N	81950	81950	249881
7206	6087	0	applied	\N	\N	\N	\N	81951	81951	249882
7207	6088	0	applied	\N	\N	\N	\N	81952	81952	249883
7207	6089	1	applied	\N	\N	\N	\N	81953	81953	249884
7207	6090	2	applied	\N	\N	\N	\N	81954	81954	249885
7212	6093	0	applied	\N	\N	\N	\N	81959	81959	249890
7214	6095	0	applied	\N	\N	\N	\N	81961	81961	249892
7215	6096	0	applied	\N	\N	\N	\N	81962	81962	249893
7215	6098	2	applied	\N	\N	\N	\N	81964	81964	249895
7217	6099	0	applied	\N	\N	\N	\N	81968	81968	249899
7220	6100	0	applied	\N	\N	\N	\N	81971	81971	249902
7224	6101	0	applied	\N	\N	\N	\N	81976	81976	249907
7224	6102	1	applied	\N	\N	\N	\N	81977	81977	249908
7226	6103	0	applied	\N	\N	\N	\N	81980	81980	249911
7231	6106	0	applied	\N	\N	\N	\N	82099	82099	250030
7231	6107	1	applied	\N	\N	\N	\N	82100	82100	250031
7233	6108	0	applied	\N	\N	\N	\N	82103	82103	250034
7236	6109	0	applied	\N	\N	\N	\N	82107	82107	250038
7236	6110	1	applied	\N	\N	\N	\N	82108	82108	250039
7240	6112	0	applied	\N	\N	\N	\N	82112	82112	250043
7243	6113	0	applied	\N	\N	\N	\N	82114	82114	250045
7243	6114	1	applied	\N	\N	\N	\N	82115	82115	250046
7243	6115	2	applied	\N	\N	\N	\N	82116	82116	250047
7246	6118	0	applied	\N	\N	\N	\N	82122	82122	250053
7249	6121	1	applied	\N	\N	\N	\N	82127	82127	250058
7254	6124	0	applied	\N	\N	\N	\N	82132	82132	250063
7256	6126	0	applied	\N	\N	\N	\N	82134	82134	250065
7258	6127	0	applied	\N	\N	\N	\N	82136	82136	250067
7261	6129	0	applied	\N	\N	\N	\N	82263	82263	250194
7261	6130	1	applied	\N	\N	\N	\N	82264	82264	250195
7261	6131	2	applied	\N	\N	\N	\N	82265	82265	250196
7270	6133	0	applied	\N	\N	\N	\N	82274	82274	250205
7273	6136	0	applied	\N	\N	\N	\N	82278	82278	250209
7275	6139	0	applied	\N	\N	\N	\N	82281	82281	250212
7284	6142	0	applied	\N	\N	\N	\N	82290	82290	250221
7284	6143	1	applied	\N	\N	\N	\N	82291	82291	250222
7287	6145	0	applied	\N	\N	\N	\N	82294	82294	250225
7287	6146	1	applied	\N	\N	\N	\N	82295	82295	250226
7289	6147	0	applied	\N	\N	\N	\N	82298	82298	250229
7292	6148	0	applied	\N	\N	\N	\N	82301	82301	250232
7295	6150	1	applied	\N	\N	\N	\N	82307	82307	250238
7301	6154	0	applied	\N	\N	\N	\N	82314	82314	250245
7150	6002	88	applied	\N	\N	\N	\N	81824	81824	249755
7150	5960	89	applied	\N	\N	\N	\N	81825	81825	249756
7158	6047	0	applied	\N	\N	1000000000	\N	81873	81873	249804
7158	6048	1	applied	\N	\N	\N	\N	81874	81874	249805
7158	6049	2	applied	\N	\N	\N	\N	81875	81875	249806
7164	6051	0	applied	\N	\N	\N	\N	81887	81887	249818
7167	6052	0	applied	\N	\N	\N	\N	81890	81890	249821
7171	6054	0	applied	\N	\N	\N	\N	81894	81894	249825
7175	6062	0	applied	\N	\N	\N	\N	81904	81904	249835
7175	6063	1	applied	\N	\N	\N	\N	81905	81905	249836
7175	6064	2	applied	\N	\N	\N	\N	81906	81906	249837
7191	6076	0	applied	\N	\N	\N	\N	81922	81922	249853
7191	6077	1	applied	\N	\N	\N	\N	81923	81923	249854
7194	6078	0	applied	\N	\N	\N	\N	81928	81928	249859
7194	6079	2	applied	\N	\N	\N	\N	81929	81929	249860
7197	6082	0	applied	\N	\N	\N	\N	81934	81934	249865
7197	6083	1	applied	\N	\N	\N	\N	81935	81935	249866
7199	6084	0	applied	\N	\N	\N	\N	81940	81940	249871
7204	6085	0	applied	\N	\N	\N	\N	81947	81947	249878
7204	6086	1	applied	\N	\N	\N	\N	81948	81948	249879
7209	6091	0	applied	\N	\N	\N	\N	81956	81956	249887
7211	6093	0	applied	\N	\N	\N	\N	81958	81958	249889
7219	6100	0	applied	\N	\N	\N	\N	81970	81970	249901
7223	6102	1	applied	\N	\N	\N	\N	81975	81975	249906
7225	6101	0	applied	\N	\N	\N	\N	81978	81978	249909
7225	6102	1	applied	\N	\N	\N	\N	81979	81979	249910
7228	6105	0	applied	\N	\N	\N	\N	81982	81982	249913
7235	6109	0	applied	\N	\N	\N	\N	82105	82105	250036
7235	6110	1	applied	\N	\N	\N	\N	82106	82106	250037
7238	6111	0	applied	\N	\N	\N	\N	82110	82110	250041
7245	6116	0	applied	\N	\N	\N	\N	82120	82120	250051
7245	6117	1	applied	\N	\N	\N	\N	82121	82121	250052
7248	6120	0	applied	\N	\N	\N	\N	82124	82124	250055
7248	6121	1	applied	\N	\N	\N	\N	82125	82125	250056
7251	6122	0	applied	\N	\N	\N	\N	82129	82129	250060
7253	6124	0	applied	\N	\N	\N	\N	82131	82131	250062
7255	6125	0	applied	\N	\N	\N	\N	82133	82133	250064
7264	6132	0	applied	\N	\N	\N	\N	82268	82268	250199
7266	6132	0	applied	\N	\N	\N	\N	82270	82270	250201
7291	6148	0	applied	\N	\N	\N	\N	82300	82300	250231
7294	6149	0	applied	\N	\N	\N	\N	82304	82304	250235
7294	6150	1	applied	\N	\N	\N	\N	82305	82305	250236
7298	6151	0	applied	\N	\N	\N	\N	82308	82308	250239
7298	6152	1	applied	\N	\N	\N	\N	82309	82309	250240
7298	6153	2	applied	\N	\N	\N	\N	82310	82310	250241
7304	6160	0	applied	\N	\N	\N	\N	82325	82325	250256
7306	6160	0	applied	\N	\N	\N	\N	82326	82326	250257
7306	6161	1	applied	\N	\N	\N	\N	82327	82327	250258
7309	6163	0	applied	\N	\N	\N	\N	82331	82331	250262
7309	6164	1	applied	\N	\N	\N	\N	82332	82332	250263
7309	6165	2	applied	\N	\N	\N	\N	82333	82333	250264
7310	6167	1	applied	\N	\N	\N	\N	82335	82335	250265
7310	6168	2	applied	\N	\N	\N	\N	82336	82336	250266
7310	6169	3	applied	\N	\N	\N	\N	82337	82337	250267
7312	6170	0	applied	\N	\N	\N	\N	82342	82342	250271
7315	6172	0	applied	\N	\N	\N	\N	82345	82345	250274
7315	6173	1	applied	\N	\N	\N	\N	82346	82346	250275
7318	6174	0	applied	\N	\N	\N	\N	82352	82352	250281
7318	6175	1	applied	\N	\N	\N	\N	82353	82353	250282
7318	6176	2	applied	\N	\N	\N	\N	82354	82354	250283
7323	6179	0	applied	\N	\N	\N	\N	82359	82359	250288
7330	6182	0	applied	\N	\N	\N	\N	82366	82366	250295
7337	6185	0	applied	\N	\N	\N	\N	82380	82380	250309
7337	6186	1	applied	\N	\N	\N	\N	82381	82381	250310
7337	6187	2	applied	\N	\N	\N	\N	82382	82382	250311
7337	6188	3	applied	\N	\N	\N	\N	82383	82383	250312
7337	6189	4	applied	\N	\N	\N	\N	82384	82384	250313
7339	6193	0	applied	\N	\N	\N	\N	82388	82388	250317
7341	6047	0	applied	\N	\N	1000000000	\N	82395	82395	250323
7341	6101	1	applied	\N	\N	\N	\N	82396	82396	250324
7341	6185	2	applied	\N	\N	\N	\N	82397	82397	250325
7341	6186	3	applied	\N	\N	\N	\N	82398	82398	250326
7341	6187	4	applied	\N	\N	\N	\N	82399	82399	250327
7341	6188	5	applied	\N	\N	\N	\N	82400	82400	250328
7341	6042	6	applied	\N	\N	\N	\N	82401	82401	250329
7341	6044	8	applied	\N	\N	\N	\N	82403	82403	250331
7341	6045	9	applied	\N	\N	\N	\N	82404	82404	250332
7341	6046	10	applied	\N	\N	\N	\N	82405	82405	250333
7341	6059	12	applied	\N	\N	\N	\N	82407	82407	250334
7341	6166	11	failed	Receiver_not_present	\N	\N	\N	82406	82406	\N
7341	6048	13	applied	\N	\N	\N	\N	82408	82408	250335
7341	6049	14	applied	\N	\N	\N	\N	82409	82409	250336
7341	6050	15	applied	\N	\N	\N	\N	82410	82410	250337
7341	6051	16	applied	\N	\N	\N	\N	82411	82411	250338
7341	6052	17	applied	\N	\N	\N	\N	82412	82412	250339
7341	6053	18	applied	\N	\N	\N	\N	82413	82413	250340
7341	6054	19	applied	\N	\N	\N	\N	82414	82414	250341
7341	6055	20	applied	\N	\N	\N	\N	82415	82415	250342
7341	6056	21	applied	\N	\N	\N	\N	82416	82416	250343
7341	6057	22	applied	\N	\N	\N	\N	82417	82417	250344
7341	6058	23	applied	\N	\N	\N	\N	82418	82418	250345
7341	6061	25	applied	\N	\N	\N	\N	82420	82420	250347
7341	6062	26	applied	\N	\N	\N	\N	82421	82421	250348
7341	6063	27	applied	\N	\N	\N	\N	82422	82422	250349
7341	6064	28	applied	\N	\N	\N	\N	82423	82423	250350
7341	6065	29	applied	\N	\N	\N	\N	82424	82424	250351
7341	6066	30	applied	\N	\N	\N	\N	82425	82425	250352
7341	6067	31	applied	\N	\N	\N	\N	82426	82426	250353
7341	6068	32	applied	\N	\N	\N	\N	82427	82427	250354
7341	6069	33	applied	\N	\N	\N	\N	82428	82428	250355
7341	6070	34	applied	\N	\N	\N	\N	82429	82429	250356
7341	6071	35	applied	\N	\N	\N	\N	82430	82430	250357
7341	6072	36	applied	\N	\N	\N	\N	82431	82431	250358
7341	6073	37	applied	\N	\N	\N	\N	82432	82432	250359
7341	6074	38	applied	\N	\N	\N	\N	82433	82433	250360
7341	6075	39	applied	\N	\N	\N	\N	82434	82434	250361
7341	6076	40	applied	\N	\N	\N	\N	82435	82435	250362
7341	6078	42	applied	\N	\N	\N	\N	82437	82437	250364
7341	6079	43	applied	\N	\N	\N	\N	82438	82438	250365
7341	6080	44	applied	\N	\N	\N	\N	82439	82439	250366
7341	6081	45	applied	\N	\N	\N	\N	82440	82440	250367
7153	6045	1	applied	\N	\N	\N	\N	81866	81866	249797
7156	6046	0	applied	\N	\N	\N	\N	81869	81869	249800
7161	6047	0	applied	\N	\N	1000000000	\N	81882	81882	249813
7161	6048	1	applied	\N	\N	\N	\N	81883	81883	249814
7161	6049	2	applied	\N	\N	\N	\N	81884	81884	249815
7162	6050	0	applied	\N	\N	\N	\N	81885	81885	249816
7172	6055	0	applied	\N	\N	\N	\N	81895	81895	249826
7172	6056	1	applied	\N	\N	\N	\N	81896	81896	249827
7172	6057	2	applied	\N	\N	\N	\N	81897	81897	249828
7172	6058	3	applied	\N	\N	\N	\N	81898	81898	249829
7172	6059	4	applied	\N	\N	\N	\N	81899	81899	249830
7179	6065	0	applied	\N	\N	\N	\N	81910	81910	249841
7182	6068	0	applied	\N	\N	\N	\N	81913	81913	249844
7187	6073	0	applied	\N	\N	\N	\N	81918	81918	249849
7201	6084	0	applied	\N	\N	\N	\N	81942	81942	249873
7203	6085	0	applied	\N	\N	\N	\N	81945	81945	249876
7203	6086	1	applied	\N	\N	\N	\N	81946	81946	249877
7210	6092	0	applied	\N	\N	\N	\N	81957	81957	249888
7216	6096	0	applied	\N	\N	\N	\N	81965	81965	249896
7216	6097	1	applied	\N	\N	\N	\N	81966	81966	249897
7216	6098	2	applied	\N	\N	\N	\N	81967	81967	249898
7218	6099	0	applied	\N	\N	\N	\N	81969	81969	249900
7221	6100	0	applied	\N	\N	\N	\N	81972	81972	249903
7229	6105	0	applied	\N	\N	\N	\N	81983	81983	249914
7232	6106	0	applied	\N	\N	\N	\N	82101	82101	250032
7232	6107	1	applied	\N	\N	\N	\N	82102	82102	250033
7241	6112	0	applied	\N	\N	\N	\N	82113	82113	250044
7259	6128	0	applied	\N	\N	\N	\N	82137	82137	250068
7262	6132	0	applied	\N	\N	\N	\N	82266	82266	250197
7265	6132	0	applied	\N	\N	\N	\N	82269	82269	250200
7267	6132	0	applied	\N	\N	\N	\N	82271	82271	250202
7268	6133	0	applied	\N	\N	\N	\N	82272	82272	250203
7276	6139	0	applied	\N	\N	\N	\N	82282	82282	250213
7280	6139	0	applied	\N	\N	\N	\N	82284	82284	250215
7280	6140	1	applied	\N	\N	\N	\N	82285	82285	250216
7282	6141	0	applied	\N	\N	\N	\N	82288	82288	250219
7285	6144	0	applied	\N	\N	\N	\N	82292	82292	250223
7288	6145	0	applied	\N	\N	\N	\N	82296	82296	250227
7288	6146	1	applied	\N	\N	\N	\N	82297	82297	250228
7290	6147	0	applied	\N	\N	\N	\N	82299	82299	250230
7300	6151	0	applied	\N	\N	\N	\N	82311	82311	250242
7300	6152	1	applied	\N	\N	\N	\N	82312	82312	250243
7300	6153	2	applied	\N	\N	\N	\N	82313	82313	250244
7303	6156	1	applied	\N	\N	\N	\N	82321	82321	250252
7303	6157	2	applied	\N	\N	\N	\N	82322	82322	250253
7303	6158	3	applied	\N	\N	\N	\N	82323	82323	250254
7303	6159	4	applied	\N	\N	\N	\N	82324	82324	250255
7319	6177	0	applied	\N	\N	\N	\N	82355	82355	250284
7321	6178	0	applied	\N	\N	\N	\N	82357	82357	250286
7326	6181	0	applied	\N	\N	\N	\N	82362	82362	250291
7328	6182	0	applied	\N	\N	\N	\N	82364	82364	250293
7333	6183	0	applied	\N	\N	\N	\N	82368	82368	250297
7335	6185	0	applied	\N	\N	\N	\N	82370	82370	250299
7335	6186	1	applied	\N	\N	\N	\N	82371	82371	250300
7335	6187	2	applied	\N	\N	\N	\N	82372	82372	250301
7335	6188	3	applied	\N	\N	\N	\N	82373	82373	250302
7335	6189	4	applied	\N	\N	\N	\N	82374	82374	250303
7343	6197	0	applied	\N	\N	\N	\N	82523	82523	250450
7352	6224	0	applied	\N	\N	\N	\N	82574	82574	250499
7352	6226	2	applied	\N	\N	\N	\N	82576	82576	250501
7352	6227	3	applied	\N	\N	\N	\N	82577	82577	250502
7352	6228	4	applied	\N	\N	\N	\N	82578	82578	250503
7352	6229	5	applied	\N	\N	\N	\N	82579	82579	250504
7352	6230	6	applied	\N	\N	\N	\N	82580	82580	250505
7352	6231	7	applied	\N	\N	\N	\N	82581	82581	250506
7357	6241	0	applied	\N	\N	\N	\N	82666	82666	250590
7357	6242	1	applied	\N	\N	\N	\N	82667	82667	250591
7357	6243	2	applied	\N	\N	\N	\N	82668	82668	250592
7357	6244	3	applied	\N	\N	\N	\N	82669	82669	250593
7357	6245	4	applied	\N	\N	\N	\N	82670	82670	250594
7357	6246	5	applied	\N	\N	\N	\N	82671	82671	250595
7357	6247	6	applied	\N	\N	\N	\N	82672	82672	250596
7357	6248	7	applied	\N	\N	\N	\N	82673	82673	250597
7357	6249	8	applied	\N	\N	\N	\N	82674	82674	250598
7357	6250	9	applied	\N	\N	\N	\N	82675	82675	250599
7357	6252	11	applied	\N	\N	\N	\N	82677	82677	250601
7357	6253	12	applied	\N	\N	\N	\N	82678	82678	250602
7357	6254	13	applied	\N	\N	\N	\N	82679	82679	250603
7357	6255	14	applied	\N	\N	\N	\N	82680	82680	250604
7357	6256	15	applied	\N	\N	\N	\N	82681	82681	250605
7357	6257	16	applied	\N	\N	\N	\N	82682	82682	250606
7357	6258	17	applied	\N	\N	\N	\N	82683	82683	250607
7359	6259	0	applied	\N	\N	\N	\N	82702	82702	250626
7359	6260	1	applied	\N	\N	\N	\N	82703	82703	250627
7359	6261	2	applied	\N	\N	\N	\N	82704	82704	250628
7359	6262	3	applied	\N	\N	\N	\N	82705	82705	250629
7359	6263	4	applied	\N	\N	\N	\N	82706	82706	250630
7359	6264	5	applied	\N	\N	\N	\N	82707	82707	250631
7359	6265	6	applied	\N	\N	\N	\N	82708	82708	250632
7359	6266	7	applied	\N	\N	\N	\N	82709	82709	250633
7359	6267	8	applied	\N	\N	\N	\N	82710	82710	250634
7368	6277	1	applied	\N	\N	\N	\N	82776	82776	250700
7368	6278	2	applied	\N	\N	\N	\N	82777	82777	250701
7368	6279	3	applied	\N	\N	\N	\N	82778	82778	250702
7368	6280	4	applied	\N	\N	\N	\N	82779	82779	250703
7368	6281	5	applied	\N	\N	\N	\N	82780	82780	250704
7368	6282	6	applied	\N	\N	\N	\N	82781	82781	250705
7370	6283	0	applied	\N	\N	\N	\N	82789	82789	250713
7370	6284	1	applied	\N	\N	\N	\N	82790	82790	250714
7370	6285	2	applied	\N	\N	\N	\N	82791	82791	250715
7370	6286	3	applied	\N	\N	\N	\N	82792	82792	250716
7370	6287	4	applied	\N	\N	\N	\N	82793	82793	250717
7370	6288	5	applied	\N	\N	\N	\N	82794	82794	250718
7370	6289	6	applied	\N	\N	\N	\N	82795	82795	250719
7373	6291	1	applied	\N	\N	\N	\N	82833	82833	250755
7373	6292	2	applied	\N	\N	1000000000	\N	82834	82834	250756
7373	6293	3	applied	\N	\N	\N	\N	82835	82835	250757
7373	6294	4	applied	\N	\N	\N	\N	82836	82836	250758
7373	6295	5	applied	\N	\N	\N	\N	82837	82837	250759
7373	6296	6	applied	\N	\N	\N	\N	82838	82838	250760
7373	6297	7	applied	\N	\N	\N	\N	82839	82839	250761
7159	6048	1	applied	\N	\N	\N	\N	81877	81877	249808
7159	6049	2	applied	\N	\N	\N	\N	81878	81878	249809
7190	6075	0	applied	\N	\N	\N	\N	81921	81921	249852
7193	6078	0	applied	\N	\N	\N	\N	81926	81926	249857
7193	6079	2	applied	\N	\N	\N	\N	81927	81927	249858
7196	6082	0	applied	\N	\N	\N	\N	81932	81932	249863
7196	6083	1	applied	\N	\N	\N	\N	81933	81933	249864
7198	6080	0	applied	\N	\N	\N	\N	81936	81936	249867
7198	6081	1	applied	\N	\N	\N	\N	81937	81937	249868
7198	6082	2	applied	\N	\N	\N	\N	81938	81938	249869
7198	6083	3	applied	\N	\N	\N	\N	81939	81939	249870
7208	6091	0	applied	\N	\N	\N	\N	81955	81955	249886
7213	6094	0	applied	\N	\N	\N	\N	81960	81960	249891
7227	6104	0	applied	\N	\N	\N	\N	81981	81981	249912
7230	5807	0	applied	\N	\N	\N	\N	81984	81984	249915
7230	5911	1	applied	\N	\N	\N	\N	81985	81985	249916
7230	5809	2	applied	\N	\N	\N	\N	81986	81986	249917
7230	5811	3	applied	\N	\N	\N	\N	81987	81987	249918
7230	5812	4	applied	\N	\N	\N	\N	81988	81988	249919
7230	5816	5	applied	\N	\N	\N	\N	81989	81989	249920
7230	5817	6	applied	\N	\N	\N	\N	81990	81990	249921
7230	5821	7	applied	\N	\N	\N	\N	81991	81991	249922
7230	5822	8	applied	\N	\N	\N	\N	81992	81992	249923
7230	5808	9	applied	\N	\N	\N	\N	81993	81993	249924
7230	5810	10	applied	\N	\N	\N	\N	81994	81994	249925
7230	5813	11	applied	\N	\N	\N	\N	81995	81995	249926
7230	5814	12	applied	\N	\N	\N	\N	81996	81996	249927
7230	5815	13	applied	\N	\N	\N	\N	81997	81997	249928
7230	5825	14	applied	\N	\N	\N	\N	81998	81998	249929
7230	5827	16	applied	\N	\N	\N	\N	82000	82000	249931
7230	5829	17	applied	\N	\N	\N	\N	82001	82001	249932
7230	5832	18	applied	\N	\N	\N	\N	82002	82002	249933
7230	5818	19	applied	\N	\N	\N	\N	82003	82003	249934
7230	5819	20	applied	\N	\N	\N	\N	82004	82004	249935
7230	5820	21	applied	\N	\N	\N	\N	82005	82005	249936
7230	5823	22	applied	\N	\N	\N	\N	82006	82006	249937
7230	5824	23	applied	\N	\N	\N	\N	82007	82007	249938
7230	5828	24	applied	\N	\N	\N	\N	82008	82008	249939
7230	5830	25	applied	\N	\N	\N	\N	82009	82009	249940
7230	5831	26	applied	\N	\N	\N	\N	82010	82010	249941
7230	5833	27	applied	\N	\N	\N	\N	82011	82011	249942
7230	5837	28	applied	\N	\N	\N	\N	82012	82012	249943
7230	5838	29	applied	\N	\N	\N	\N	82013	82013	249944
7230	5840	30	applied	\N	\N	\N	\N	82014	82014	249945
7230	5841	31	applied	\N	\N	\N	\N	82015	82015	249946
7230	5845	33	applied	\N	\N	\N	\N	82017	82017	249948
7230	5834	34	applied	\N	\N	\N	\N	82018	82018	249949
7230	5835	35	applied	\N	\N	\N	\N	82019	82019	249950
7230	5836	36	applied	\N	\N	\N	\N	82020	82020	249951
7230	5839	37	applied	\N	\N	\N	\N	82021	82021	249952
7230	5843	38	applied	\N	\N	\N	\N	82022	82022	249953
7230	5844	39	applied	\N	\N	\N	\N	82023	82023	249954
7230	5846	40	applied	\N	\N	\N	\N	82024	82024	249955
7230	5847	41	applied	\N	\N	\N	\N	82025	82025	249956
7230	5849	42	applied	\N	\N	\N	\N	82026	82026	249957
7230	5852	43	applied	\N	\N	\N	\N	82027	82027	249958
7230	5853	44	applied	\N	\N	\N	\N	82028	82028	249959
7230	5856	45	applied	\N	\N	\N	\N	82029	82029	249960
7230	5857	46	applied	\N	\N	\N	\N	82030	82030	249961
7230	5859	47	applied	\N	\N	\N	\N	82031	82031	249962
7230	5862	48	applied	\N	\N	\N	\N	82032	82032	249963
7230	5868	50	applied	\N	\N	\N	\N	82034	82034	249965
7230	5869	51	applied	\N	\N	\N	\N	82035	82035	249966
7230	5871	52	applied	\N	\N	\N	\N	82036	82036	249967
7230	5872	53	applied	\N	\N	\N	\N	82037	82037	249968
7230	5873	54	applied	\N	\N	\N	\N	82038	82038	249969
7230	5876	55	applied	\N	\N	\N	\N	82039	82039	249970
7230	5878	56	applied	\N	\N	\N	\N	82040	82040	249971
7230	5880	57	applied	\N	\N	\N	\N	82041	82041	249972
7230	5882	58	applied	\N	\N	\N	\N	82042	82042	249973
7230	5883	59	applied	\N	\N	\N	\N	82043	82043	249974
7230	5886	60	applied	\N	\N	\N	\N	82044	82044	249975
7230	5888	61	applied	\N	\N	\N	\N	82045	82045	249976
7230	5891	62	applied	\N	\N	\N	\N	82046	82046	249977
7230	5892	63	applied	\N	\N	\N	\N	82047	82047	249978
7230	5893	64	applied	\N	\N	\N	\N	82048	82048	249979
7230	5897	65	applied	\N	\N	\N	\N	82049	82049	249980
7230	5901	67	applied	\N	\N	\N	\N	82051	82051	249982
7230	5848	68	applied	\N	\N	\N	\N	82052	82052	249983
7230	5850	69	applied	\N	\N	\N	\N	82053	82053	249984
7230	5851	70	applied	\N	\N	\N	\N	82054	82054	249985
7230	5854	71	applied	\N	\N	\N	\N	82055	82055	249986
7230	5855	72	applied	\N	\N	\N	\N	82056	82056	249987
7230	5858	73	applied	\N	\N	\N	\N	82057	82057	249988
7230	5860	74	applied	\N	\N	\N	\N	82058	82058	249989
7230	5861	75	applied	\N	\N	1000000000	\N	82059	82059	249990
7230	5864	76	applied	\N	\N	\N	\N	82060	82060	249991
7230	5865	77	applied	\N	\N	\N	\N	82061	82061	249992
7230	5866	78	applied	\N	\N	\N	\N	82062	82062	249993
7230	5867	79	applied	\N	\N	\N	\N	82063	82063	249994
7230	5870	80	applied	\N	\N	\N	\N	82064	82064	249995
7230	5874	81	applied	\N	\N	\N	\N	82065	82065	249996
7230	5875	82	applied	\N	\N	\N	\N	82066	82066	249997
7230	5879	84	applied	\N	\N	\N	\N	82068	82068	249999
7230	5881	85	applied	\N	\N	\N	\N	82069	82069	250000
7230	5884	86	applied	\N	\N	\N	\N	82070	82070	250001
7230	5885	87	applied	\N	\N	\N	\N	82071	82071	250002
7230	5887	88	applied	\N	\N	\N	\N	82072	82072	250003
7230	5889	89	applied	\N	\N	\N	\N	82073	82073	250004
7230	5890	90	applied	\N	\N	\N	\N	82074	82074	250005
7230	5894	91	applied	\N	\N	\N	\N	82075	82075	250006
7230	5895	92	applied	\N	\N	\N	\N	82076	82076	250007
7230	5896	94	applied	\N	\N	\N	\N	82077	82077	250008
7230	5898	95	applied	\N	\N	\N	\N	82078	82078	250009
7230	5899	96	applied	\N	\N	\N	\N	82079	82079	250010
7230	5902	97	applied	\N	\N	\N	\N	82080	82080	250011
7230	5903	98	applied	\N	\N	1000000000	\N	82081	82081	250012
7230	5906	100	applied	\N	\N	\N	\N	82083	82083	250014
7230	5909	101	applied	\N	\N	\N	\N	82084	82084	250015
7230	5912	102	applied	\N	\N	\N	\N	82085	82085	250016
7230	5913	103	applied	\N	\N	\N	\N	82086	82086	250017
7185	6071	0	applied	\N	\N	\N	\N	81916	81916	249847
7188	6073	0	applied	\N	\N	\N	\N	81919	81919	249850
7230	5904	107	applied	\N	\N	\N	\N	82090	82090	250021
7230	5907	108	applied	\N	\N	\N	\N	82091	82091	250022
7230	5908	109	applied	\N	\N	\N	\N	82092	82092	250023
7230	5910	110	applied	\N	\N	\N	\N	82093	82093	250024
7230	5917	111	applied	\N	\N	\N	\N	82094	82094	250025
7230	5918	112	applied	\N	\N	\N	\N	82095	82095	250026
7230	5919	113	applied	\N	\N	\N	\N	82096	82096	250027
7230	5920	114	applied	\N	\N	\N	\N	82097	82097	250028
7230	5921	115	applied	\N	\N	\N	\N	82098	82098	250029
7234	6108	0	applied	\N	\N	\N	\N	82104	82104	250035
7237	6111	0	applied	\N	\N	\N	\N	82109	82109	250040
7244	6113	0	applied	\N	\N	\N	\N	82117	82117	250048
7244	6114	1	applied	\N	\N	\N	\N	82118	82118	250049
7244	6115	2	applied	\N	\N	\N	\N	82119	82119	250050
7247	6119	0	applied	\N	\N	\N	\N	82123	82123	250054
7250	6122	0	applied	\N	\N	\N	\N	82128	82128	250059
7252	6123	0	applied	\N	\N	\N	\N	82130	82130	250061
7260	6047	0	applied	\N	\N	1000000000	\N	82138	82138	250069
7260	6101	1	applied	\N	\N	\N	\N	82139	82139	250070
7260	5992	2	applied	\N	\N	\N	\N	82140	82140	250071
7260	5993	3	applied	\N	\N	\N	\N	82141	82141	250072
7260	5994	4	applied	\N	\N	\N	\N	82142	82142	250073
7260	5995	5	applied	\N	\N	\N	\N	82143	82143	250074
7260	5996	6	applied	\N	\N	\N	\N	82144	82144	250075
7260	5997	7	applied	\N	\N	\N	\N	82145	82145	250076
7260	5998	8	applied	\N	\N	\N	\N	82146	82146	250077
7260	5999	9	applied	\N	\N	\N	\N	82147	82147	250078
7260	6004	11	applied	\N	\N	\N	\N	82149	82149	250080
7260	6001	12	applied	\N	\N	\N	\N	82150	82150	250081
7260	6003	13	applied	\N	\N	\N	\N	82151	82151	250082
7260	6005	14	applied	\N	\N	\N	\N	82152	82152	250083
7260	6006	15	applied	\N	\N	\N	\N	82153	82153	250084
7260	6012	16	applied	\N	\N	\N	\N	82154	82154	250085
7260	6013	17	applied	\N	\N	\N	\N	82155	82155	250086
7260	6014	18	applied	\N	\N	\N	\N	82156	82156	250087
7260	6016	19	applied	\N	\N	\N	\N	82157	82157	250088
7260	6018	20	applied	\N	\N	\N	\N	82158	82158	250089
7260	6021	21	applied	\N	\N	\N	\N	82159	82159	250090
7260	6022	22	applied	\N	\N	\N	\N	82160	82160	250091
7260	6024	23	applied	\N	\N	\N	\N	82161	82161	250092
7260	6026	24	applied	\N	\N	\N	\N	82162	82162	250093
7260	6028	25	applied	\N	\N	\N	\N	82163	82163	250094
7260	6007	26	applied	\N	\N	\N	\N	82164	82164	250095
7260	6009	28	applied	\N	\N	\N	\N	82166	82166	250097
7260	6010	29	applied	\N	\N	\N	\N	82167	82167	250098
7260	6011	30	applied	\N	\N	\N	\N	82168	82168	250099
7260	6015	31	applied	\N	\N	\N	\N	82169	82169	250100
7260	6017	32	applied	\N	\N	\N	\N	82170	82170	250101
7260	6019	33	applied	\N	\N	\N	\N	82171	82171	250102
7260	6020	34	applied	\N	\N	\N	\N	82172	82172	250103
7260	6023	35	applied	\N	\N	\N	\N	82173	82173	250104
7260	6025	36	applied	\N	\N	\N	\N	82174	82174	250105
7260	6027	37	applied	\N	\N	\N	\N	82175	82175	250106
7260	6029	38	applied	\N	\N	\N	\N	82176	82176	250107
7260	6030	39	applied	\N	\N	\N	\N	82177	82177	250108
7260	6031	40	applied	\N	\N	\N	\N	82178	82178	250109
7260	6032	41	applied	\N	\N	\N	\N	82179	82179	250110
7260	6033	42	applied	\N	\N	\N	\N	82180	82180	250111
7260	6034	44	applied	\N	\N	\N	\N	82181	82181	250112
7260	6036	45	applied	\N	\N	\N	\N	82182	82182	250113
7260	6002	46	applied	\N	\N	\N	\N	82183	82183	250114
7260	6038	48	applied	\N	\N	\N	\N	82185	82185	250116
7260	6039	49	applied	\N	\N	\N	\N	82186	82186	250117
7260	6040	50	applied	\N	\N	1000000000	\N	82187	82187	250118
7260	6041	51	applied	\N	\N	\N	\N	82188	82188	250119
7260	6042	52	applied	\N	\N	\N	\N	82189	82189	250120
7260	6043	53	applied	\N	\N	\N	\N	82190	82190	250121
7260	6044	54	applied	\N	\N	\N	\N	82191	82191	250122
7260	6045	55	applied	\N	\N	\N	\N	82192	82192	250123
7260	6046	56	applied	\N	\N	\N	\N	82193	82193	250124
7260	6048	57	applied	\N	\N	\N	\N	82194	82194	250125
7260	6049	58	applied	\N	\N	\N	\N	82195	82195	250126
7260	6050	59	applied	\N	\N	\N	\N	82196	82196	250127
7260	6051	60	applied	\N	\N	\N	\N	82197	82197	250128
7260	6052	61	applied	\N	\N	\N	\N	82198	82198	250129
7260	6053	62	applied	\N	\N	\N	\N	82199	82199	250130
7260	6054	63	applied	\N	\N	\N	\N	82200	82200	250131
7260	6056	65	applied	\N	\N	\N	\N	82202	82202	250133
7260	6057	66	applied	\N	\N	\N	\N	82203	82203	250134
7260	6058	67	applied	\N	\N	\N	\N	82204	82204	250135
7260	6060	68	applied	\N	\N	\N	\N	82205	82205	250136
7260	6061	69	applied	\N	\N	\N	\N	82206	82206	250137
7260	6062	70	applied	\N	\N	\N	\N	82207	82207	250138
7260	6063	71	applied	\N	\N	\N	\N	82208	82208	250139
7260	6064	72	applied	\N	\N	\N	\N	82209	82209	250140
7260	6065	73	applied	\N	\N	\N	\N	82210	82210	250141
7260	6066	74	applied	\N	\N	\N	\N	82211	82211	250142
7260	6067	75	applied	\N	\N	\N	\N	82212	82212	250143
7260	6068	76	applied	\N	\N	\N	\N	82213	82213	250144
7260	6069	77	applied	\N	\N	\N	\N	82214	82214	250145
7260	6070	78	applied	\N	\N	\N	\N	82215	82215	250146
7260	6071	79	applied	\N	\N	\N	\N	82216	82216	250147
7260	6072	80	applied	\N	\N	\N	\N	82217	82217	250148
7260	6074	82	applied	\N	\N	\N	\N	82219	82219	250150
7260	6075	83	applied	\N	\N	\N	\N	82220	82220	250151
7260	6076	84	applied	\N	\N	\N	\N	82221	82221	250152
7260	6077	85	applied	\N	\N	\N	\N	82222	82222	250153
7260	6078	86	applied	\N	\N	\N	\N	82223	82223	250154
7260	6079	87	applied	\N	\N	\N	\N	82224	82224	250155
7260	6080	88	applied	\N	\N	\N	\N	82225	82225	250156
7260	6081	89	applied	\N	\N	\N	\N	82226	82226	250157
7260	6082	90	applied	\N	\N	\N	\N	82227	82227	250158
7260	6083	91	applied	\N	\N	\N	\N	82228	82228	250159
7260	6084	92	applied	\N	\N	\N	\N	82229	82229	250160
7260	6085	93	applied	\N	\N	\N	\N	82230	82230	250161
7260	6086	94	applied	\N	\N	\N	\N	82231	82231	250162
7260	6087	95	applied	\N	\N	\N	\N	82232	82232	250163
7260	6088	96	applied	\N	\N	\N	\N	82233	82233	250164
7260	6089	97	applied	\N	\N	\N	\N	82234	82234	250165
7230	5915	105	applied	\N	\N	\N	\N	82088	82088	250019
7230	5916	106	applied	\N	\N	\N	\N	82089	82089	250020
7260	6094	102	applied	\N	\N	\N	\N	82239	82239	250170
7260	6095	103	applied	\N	\N	\N	\N	82240	82240	250171
7260	6096	104	applied	\N	\N	\N	\N	82241	82241	250172
7260	6097	105	applied	\N	\N	\N	\N	82242	82242	250173
7260	6098	106	applied	\N	\N	\N	\N	82243	82243	250174
7260	6100	108	applied	\N	\N	\N	\N	82245	82245	250176
7260	6102	109	applied	\N	\N	\N	\N	82246	82246	250177
7260	6103	110	applied	\N	\N	\N	\N	82247	82247	250178
7260	6104	111	applied	\N	\N	\N	\N	82248	82248	250179
7260	6105	112	applied	\N	\N	\N	\N	82249	82249	250180
7260	6106	113	applied	\N	\N	\N	\N	82250	82250	250181
7260	6107	114	applied	\N	\N	\N	\N	82251	82251	250182
7260	6108	115	applied	\N	\N	\N	\N	82252	82252	250183
7260	6109	116	applied	\N	\N	\N	\N	82253	82253	250184
7260	6110	117	applied	\N	\N	\N	\N	82254	82254	250185
7260	6111	118	applied	\N	\N	\N	\N	82255	82255	250186
7260	6112	119	applied	\N	\N	\N	\N	82256	82256	250187
7260	6113	120	applied	\N	\N	\N	\N	82257	82257	250188
7260	6114	121	applied	\N	\N	\N	\N	82258	82258	250189
7260	6115	122	applied	\N	\N	\N	\N	82259	82259	250190
7260	6116	123	applied	\N	\N	\N	\N	82260	82260	250191
7260	6118	125	applied	\N	\N	\N	\N	82262	82262	250193
7263	6132	0	applied	\N	\N	\N	\N	82267	82267	250198
7269	6133	0	applied	\N	\N	\N	\N	82273	82273	250204
7271	6134	0	applied	\N	\N	\N	\N	82275	82275	250206
7271	6135	1	applied	\N	\N	\N	\N	82276	82276	250207
7274	6137	0	applied	\N	\N	\N	\N	82279	82279	250210
7274	6138	1	applied	\N	\N	\N	\N	82280	82280	250211
7277	6139	0	applied	\N	\N	\N	\N	82283	82283	250214
7281	6139	0	applied	\N	\N	\N	\N	82286	82286	250217
7281	6140	1	applied	\N	\N	\N	\N	82287	82287	250218
7283	6141	0	applied	\N	\N	\N	\N	82289	82289	250220
7286	6144	0	applied	\N	\N	\N	\N	82293	82293	250224
7293	6149	0	applied	\N	\N	\N	\N	82302	82302	250233
7293	6150	1	applied	\N	\N	\N	\N	82303	82303	250234
7302	6155	0	applied	\N	\N	\N	\N	82315	82315	250246
7302	6156	1	applied	\N	\N	\N	\N	82316	82316	250247
7302	6158	3	applied	\N	\N	\N	\N	82318	82318	250249
7302	6159	4	applied	\N	\N	\N	\N	82319	82319	250250
7307	6160	0	applied	\N	\N	\N	\N	82328	82328	250259
7307	6161	1	applied	\N	\N	\N	\N	82329	82329	250260
7308	6162	0	applied	\N	\N	\N	\N	82330	82330	250261
7311	6167	1	applied	\N	\N	\N	\N	82339	82339	250268
7311	6166	0	failed	Receiver_not_present	\N	\N	\N	82338	82338	\N
7311	6168	2	applied	\N	\N	\N	\N	82340	82340	250269
7311	6169	3	applied	\N	\N	\N	\N	82341	82341	250270
7313	6170	0	applied	\N	\N	\N	\N	82343	82343	250272
7314	6171	0	applied	\N	\N	\N	\N	82344	82344	250273
7316	6172	0	applied	\N	\N	\N	\N	82347	82347	250276
7317	6174	0	applied	\N	\N	\N	\N	82349	82349	250278
7317	6175	1	applied	\N	\N	\N	\N	82350	82350	250279
7317	6176	2	applied	\N	\N	\N	\N	82351	82351	250280
7320	6177	0	applied	\N	\N	\N	\N	82356	82356	250285
7327	6181	0	applied	\N	\N	\N	\N	82363	82363	250292
7329	6182	0	applied	\N	\N	\N	\N	82365	82365	250294
7336	6185	0	applied	\N	\N	\N	\N	82375	82375	250304
7336	6186	1	applied	\N	\N	\N	\N	82376	82376	250305
7336	6187	2	applied	\N	\N	\N	\N	82377	82377	250306
7336	6188	3	applied	\N	\N	\N	\N	82378	82378	250307
7336	6189	4	applied	\N	\N	\N	\N	82379	82379	250308
7338	6190	0	applied	\N	\N	\N	\N	82385	82385	250314
7338	6191	2	applied	\N	\N	\N	\N	82386	82386	250315
7338	6192	3	applied	\N	\N	\N	\N	82387	82387	250316
7346	6199	0	applied	\N	\N	\N	\N	82526	82526	250453
7346	6200	1	applied	\N	\N	\N	\N	82527	82527	250454
7346	6201	2	applied	\N	\N	\N	\N	82528	82528	250455
7346	6202	3	applied	\N	\N	\N	\N	82529	82529	250456
7346	6203	4	applied	\N	\N	\N	\N	82530	82530	250457
7346	6204	5	applied	\N	\N	\N	\N	82531	82531	250458
7348	6206	0	applied	\N	\N	\N	\N	82540	82540	250465
7348	6207	1	applied	\N	\N	\N	\N	82541	82541	250466
7348	6208	2	applied	\N	\N	\N	\N	82542	82542	250467
7348	6209	3	applied	\N	\N	\N	\N	82543	82543	250468
7348	6210	4	applied	\N	\N	\N	\N	82544	82544	250469
7348	6211	5	applied	\N	\N	\N	\N	82545	82545	250470
7348	6212	6	applied	\N	\N	\N	\N	82546	82546	250471
7348	6213	7	applied	\N	\N	\N	\N	82547	82547	250472
7348	6214	8	applied	\N	\N	\N	\N	82548	82548	250473
7348	6215	9	applied	\N	\N	\N	\N	82549	82549	250474
7351	6216	0	applied	\N	\N	\N	\N	82566	82566	250491
7351	6217	1	applied	\N	\N	\N	\N	82567	82567	250492
7351	6218	2	applied	\N	\N	\N	\N	82568	82568	250493
7351	6219	3	applied	\N	\N	\N	\N	82569	82569	250494
7351	6220	4	applied	\N	\N	\N	\N	82570	82570	250495
7351	6221	5	applied	\N	\N	\N	\N	82571	82571	250496
7351	6222	6	applied	\N	\N	\N	\N	82572	82572	250497
7351	6223	7	applied	\N	\N	\N	\N	82573	82573	250498
7353	6224	0	applied	\N	\N	\N	\N	82582	82582	250507
7353	6225	1	applied	\N	\N	\N	\N	82583	82583	250508
7353	6226	2	applied	\N	\N	\N	\N	82584	82584	250509
7353	6227	3	applied	\N	\N	\N	\N	82585	82585	250510
7353	6228	4	applied	\N	\N	\N	\N	82586	82586	250511
7353	6229	5	applied	\N	\N	\N	\N	82587	82587	250512
7353	6231	7	applied	\N	\N	\N	\N	82589	82589	250514
7355	6232	0	applied	\N	\N	\N	\N	82648	82648	250572
7355	6233	1	applied	\N	\N	\N	\N	82649	82649	250573
7355	6234	2	applied	\N	\N	\N	\N	82650	82650	250574
7355	6235	3	applied	\N	\N	\N	\N	82651	82651	250575
7355	6236	4	applied	\N	\N	\N	\N	82652	82652	250576
7355	6237	5	applied	\N	\N	\N	\N	82653	82653	250577
7355	6238	6	applied	\N	\N	\N	\N	82654	82654	250578
7355	6239	7	applied	\N	\N	\N	\N	82655	82655	250579
7355	6240	8	applied	\N	\N	\N	\N	82656	82656	250580
7361	6259	0	applied	\N	\N	\N	\N	82720	82720	250644
7361	6260	1	applied	\N	\N	\N	\N	82721	82721	250645
7361	6261	2	applied	\N	\N	\N	\N	82722	82722	250646
7361	6262	3	applied	\N	\N	\N	\N	82723	82723	250647
7361	6263	4	applied	\N	\N	\N	\N	82724	82724	250648
7361	6264	5	applied	\N	\N	\N	\N	82725	82725	250649
7260	6092	100	applied	\N	\N	\N	\N	82237	82237	250168
7260	6093	101	applied	\N	\N	\N	\N	82238	82238	250169
7332	6183	0	applied	\N	\N	\N	\N	82367	82367	250296
7334	6184	0	applied	\N	\N	\N	\N	82369	82369	250298
7340	6101	0	applied	\N	\N	\N	\N	82389	82389	250318
7340	6185	1	applied	\N	\N	\N	\N	82390	82390	250319
7340	6186	2	applied	\N	\N	\N	\N	82391	82391	250320
7340	6187	3	applied	\N	\N	\N	\N	82392	82392	250321
7340	6188	4	applied	\N	\N	\N	\N	82393	82393	250322
7341	6082	46	applied	\N	\N	\N	\N	82441	82441	250368
7341	6083	47	applied	\N	\N	\N	\N	82442	82442	250369
7341	6084	48	applied	\N	\N	\N	\N	82443	82443	250370
7341	6085	49	applied	\N	\N	\N	\N	82444	82444	250371
7341	6086	50	applied	\N	\N	\N	\N	82445	82445	250372
7341	6087	51	applied	\N	\N	\N	\N	82446	82446	250373
7341	6088	52	applied	\N	\N	\N	\N	82447	82447	250374
7341	6089	53	applied	\N	\N	\N	\N	82448	82448	250375
7341	6090	54	applied	\N	\N	\N	\N	82449	82449	250376
7341	6091	55	applied	\N	\N	\N	\N	82450	82450	250377
7341	6092	56	applied	\N	\N	\N	\N	82451	82451	250378
7341	6093	57	applied	\N	\N	\N	\N	82452	82452	250379
7341	6094	58	applied	\N	\N	\N	\N	82453	82453	250380
7342	6194	0	applied	\N	\N	\N	\N	82520	82520	250447
7342	6195	1	applied	\N	\N	\N	\N	82521	82521	250448
7342	6196	2	applied	\N	\N	\N	\N	82522	82522	250449
7345	6198	0	applied	\N	\N	\N	\N	82525	82525	250452
7350	6216	0	applied	\N	\N	\N	\N	82558	82558	250483
7350	6217	1	applied	\N	\N	\N	\N	82559	82559	250484
7350	6218	2	applied	\N	\N	\N	\N	82560	82560	250485
7350	6219	3	applied	\N	\N	\N	\N	82561	82561	250486
7350	6220	4	applied	\N	\N	\N	\N	82562	82562	250487
7350	6221	5	applied	\N	\N	\N	\N	82563	82563	250488
7350	6222	6	applied	\N	\N	\N	\N	82564	82564	250489
7358	6241	0	applied	\N	\N	\N	\N	82684	82684	250608
7358	6242	1	applied	\N	\N	\N	\N	82685	82685	250609
7358	6243	2	applied	\N	\N	\N	\N	82686	82686	250610
7358	6244	3	applied	\N	\N	\N	\N	82687	82687	250611
7358	6245	4	applied	\N	\N	\N	\N	82688	82688	250612
7358	6246	5	applied	\N	\N	\N	\N	82689	82689	250613
7358	6247	6	applied	\N	\N	\N	\N	82690	82690	250614
7358	6248	7	applied	\N	\N	\N	\N	82691	82691	250615
7358	6249	8	applied	\N	\N	\N	\N	82692	82692	250616
7358	6250	9	applied	\N	\N	\N	\N	82693	82693	250617
7358	6251	10	applied	\N	\N	\N	\N	82694	82694	250618
7358	6252	11	applied	\N	\N	\N	\N	82695	82695	250619
7358	6253	12	applied	\N	\N	\N	\N	82696	82696	250620
7358	6254	13	applied	\N	\N	\N	\N	82697	82697	250621
7358	6255	14	applied	\N	\N	\N	\N	82698	82698	250622
7358	6256	15	applied	\N	\N	\N	\N	82699	82699	250623
7358	6258	17	applied	\N	\N	\N	\N	82701	82701	250625
7360	6259	0	applied	\N	\N	\N	\N	82711	82711	250635
7360	6260	1	applied	\N	\N	\N	\N	82712	82712	250636
7360	6261	2	applied	\N	\N	\N	\N	82713	82713	250637
7360	6262	3	applied	\N	\N	\N	\N	82714	82714	250638
7360	6263	4	applied	\N	\N	\N	\N	82715	82715	250639
7360	6264	5	applied	\N	\N	\N	\N	82716	82716	250640
7360	6265	6	applied	\N	\N	\N	\N	82717	82717	250641
7360	6266	7	applied	\N	\N	\N	\N	82718	82718	250642
7360	6267	8	applied	\N	\N	\N	\N	82719	82719	250643
7362	6268	0	applied	\N	\N	\N	\N	82729	82729	250653
7362	6269	1	applied	\N	\N	\N	\N	82730	82730	250654
7362	6270	2	applied	\N	\N	\N	\N	82731	82731	250655
7362	6271	3	applied	\N	\N	\N	\N	82732	82732	250656
7362	6272	4	applied	\N	\N	\N	\N	82733	82733	250657
7362	6273	5	applied	\N	\N	\N	\N	82734	82734	250658
7362	6275	7	applied	\N	\N	\N	\N	82736	82736	250660
7365	6268	0	applied	\N	\N	\N	\N	82753	82753	250677
7365	6269	1	applied	\N	\N	\N	\N	82754	82754	250678
7365	6270	2	applied	\N	\N	\N	\N	82755	82755	250679
7365	6271	3	applied	\N	\N	\N	\N	82756	82756	250680
7365	6272	4	applied	\N	\N	\N	\N	82757	82757	250681
7365	6273	5	applied	\N	\N	\N	\N	82758	82758	250682
7365	6274	6	applied	\N	\N	\N	\N	82759	82759	250683
7365	6275	7	applied	\N	\N	\N	\N	82760	82760	250684
7366	6276	0	applied	\N	\N	\N	\N	82761	82761	250685
7366	6277	1	applied	\N	\N	\N	\N	82762	82762	250686
7366	6278	2	applied	\N	\N	\N	\N	82763	82763	250687
7366	6279	3	applied	\N	\N	\N	\N	82764	82764	250688
7366	6280	4	applied	\N	\N	\N	\N	82765	82765	250689
7366	6281	5	applied	\N	\N	\N	\N	82766	82766	250690
7366	6282	6	applied	\N	\N	\N	\N	82767	82767	250691
7371	6284	1	applied	\N	\N	\N	\N	82797	82797	250721
7371	6285	2	applied	\N	\N	\N	\N	82798	82798	250722
7371	6286	3	applied	\N	\N	\N	\N	82799	82799	250723
7371	6287	4	applied	\N	\N	\N	\N	82800	82800	250724
7371	6288	5	applied	\N	\N	\N	\N	82801	82801	250725
7378	6320	0	applied	\N	\N	\N	\N	82865	82865	250787
7380	6321	0	applied	\N	\N	\N	\N	82867	82867	250789
7383	6323	0	applied	\N	\N	\N	\N	82870	82870	250792
7385	6324	0	applied	\N	\N	\N	\N	82872	82872	250794
7385	6325	1	applied	\N	\N	\N	\N	82873	82873	250795
7388	6328	0	applied	\N	\N	\N	\N	82877	82877	250799
7391	6332	0	applied	\N	\N	\N	\N	82886	82886	250808
7391	6333	1	applied	\N	\N	\N	\N	82887	82887	250809
7391	6334	2	applied	\N	\N	\N	\N	82888	82888	250810
7391	6335	3	applied	\N	\N	\N	\N	82889	82889	250811
7391	6336	4	applied	\N	\N	\N	\N	82890	82890	250812
7396	6340	0	applied	\N	\N	\N	\N	82897	82897	250819
7396	6341	1	applied	\N	\N	\N	\N	82898	82898	250820
7398	6342	0	applied	\N	\N	\N	\N	82900	82900	250822
7402	6353	0	applied	\N	\N	\N	\N	82911	82911	250833
7402	6354	1	applied	\N	\N	\N	\N	82912	82912	250834
7402	6355	2	applied	\N	\N	\N	\N	82913	82913	250835
7405	6356	0	applied	\N	\N	\N	\N	82918	82918	250840
7407	6358	0	applied	\N	\N	\N	\N	82920	82920	250842
7413	6364	0	applied	\N	\N	\N	\N	82930	82930	250852
7413	6365	1	applied	\N	\N	\N	\N	82931	82931	250853
7415	6365	0	applied	\N	\N	\N	\N	82934	82934	250856
7415	6366	2	applied	\N	\N	\N	\N	82935	82935	250857
7421	6369	0	applied	\N	\N	\N	\N	82944	82944	250866
7421	6370	1	applied	\N	\N	\N	\N	82945	82945	250867
7324	6179	0	applied	\N	\N	\N	\N	82360	82360	250289
7325	6180	0	applied	\N	\N	\N	\N	82361	82361	250290
7341	6098	62	applied	\N	\N	\N	\N	82457	82457	250384
7341	6099	63	applied	\N	\N	\N	\N	82458	82458	250385
7341	6100	64	applied	\N	\N	\N	\N	82459	82459	250386
7341	6102	65	applied	\N	\N	\N	\N	82460	82460	250387
7341	6103	66	applied	\N	\N	\N	\N	82461	82461	250388
7341	6104	67	applied	\N	\N	\N	\N	82462	82462	250389
7341	6105	68	applied	\N	\N	\N	\N	82463	82463	250390
7341	6106	69	applied	\N	\N	\N	\N	82464	82464	250391
7341	6107	70	applied	\N	\N	\N	\N	82465	82465	250392
7341	6109	72	applied	\N	\N	\N	\N	82467	82467	250394
7341	6110	73	applied	\N	\N	\N	\N	82468	82468	250395
7341	6111	74	applied	\N	\N	\N	\N	82469	82469	250396
7341	6112	75	applied	\N	\N	\N	\N	82470	82470	250397
7341	6113	76	applied	\N	\N	\N	\N	82471	82471	250398
7341	6114	77	applied	\N	\N	\N	\N	82472	82472	250399
7341	6115	78	applied	\N	\N	\N	\N	82473	82473	250400
7341	6116	79	applied	\N	\N	\N	\N	82474	82474	250401
7341	6117	80	applied	\N	\N	\N	\N	82475	82475	250402
7341	6118	81	applied	\N	\N	\N	\N	82476	82476	250403
7341	6119	82	applied	\N	\N	\N	\N	82477	82477	250404
7341	6120	83	applied	\N	\N	\N	\N	82478	82478	250405
7341	6121	84	applied	\N	\N	\N	\N	82479	82479	250406
7341	6122	86	applied	\N	\N	\N	\N	82480	82480	250407
7341	6123	87	applied	\N	\N	\N	\N	82481	82481	250408
7341	6124	88	applied	\N	\N	\N	\N	82482	82482	250409
7341	6126	90	applied	\N	\N	\N	\N	82484	82484	250411
7341	6127	91	applied	\N	\N	\N	\N	82485	82485	250412
7341	6128	92	applied	\N	\N	\N	\N	82486	82486	250413
7341	6129	93	applied	\N	\N	\N	\N	82487	82487	250414
7341	6130	94	applied	\N	\N	\N	\N	82488	82488	250415
7341	6131	95	applied	\N	\N	\N	\N	82489	82489	250416
7341	6132	96	applied	\N	\N	\N	\N	82490	82490	250417
7341	6133	97	applied	\N	\N	\N	\N	82491	82491	250418
7341	6134	98	applied	\N	\N	\N	\N	82492	82492	250419
7341	6135	99	applied	\N	\N	\N	\N	82493	82493	250420
7341	6136	100	applied	\N	\N	\N	\N	82494	82494	250421
7341	6137	101	applied	\N	\N	\N	\N	82495	82495	250422
7341	6138	102	applied	\N	\N	\N	\N	82496	82496	250423
7341	6139	103	applied	\N	\N	\N	\N	82497	82497	250424
7341	6140	104	applied	\N	\N	\N	\N	82498	82498	250425
7341	6141	105	applied	\N	\N	\N	\N	82499	82499	250426
7341	6143	107	applied	\N	\N	\N	\N	82501	82501	250428
7341	6144	108	applied	\N	\N	\N	\N	82502	82502	250429
7341	6145	109	applied	\N	\N	\N	\N	82503	82503	250430
7341	6146	110	applied	\N	\N	\N	\N	82504	82504	250431
7341	6147	111	applied	\N	\N	\N	\N	82505	82505	250432
7341	6148	112	applied	\N	\N	\N	\N	82506	82506	250433
7341	6149	113	applied	\N	\N	\N	\N	82507	82507	250434
7341	6150	114	applied	\N	\N	\N	\N	82508	82508	250435
7341	6151	115	applied	\N	\N	\N	\N	82509	82509	250436
7341	6152	116	applied	\N	\N	\N	\N	82510	82510	250437
7341	6153	117	applied	\N	\N	\N	\N	82511	82511	250438
7341	6154	118	applied	\N	\N	\N	\N	82512	82512	250439
7341	6155	119	applied	\N	\N	\N	\N	82513	82513	250440
7341	6156	120	applied	\N	\N	\N	\N	82514	82514	250441
7341	6157	121	applied	\N	\N	\N	\N	82515	82515	250442
7341	6158	122	applied	\N	\N	\N	\N	82516	82516	250443
7341	6160	124	applied	\N	\N	\N	\N	82518	82518	250445
7341	6161	125	applied	\N	\N	\N	\N	82519	82519	250446
7344	6198	0	applied	\N	\N	\N	\N	82524	82524	250451
7347	6199	0	applied	\N	\N	\N	\N	82533	82533	250459
7347	6200	1	applied	\N	\N	\N	\N	82534	82534	250460
7347	6201	2	applied	\N	\N	\N	\N	82535	82535	250461
7347	6202	3	applied	\N	\N	\N	\N	82536	82536	250462
7347	6203	4	applied	\N	\N	\N	\N	82537	82537	250463
7347	6204	5	applied	\N	\N	\N	\N	82538	82538	250464
7349	6216	0	applied	\N	\N	\N	\N	82550	82550	250475
7349	6217	1	applied	\N	\N	\N	\N	82551	82551	250476
7349	6218	2	applied	\N	\N	\N	\N	82552	82552	250477
7349	6219	3	applied	\N	\N	\N	\N	82553	82553	250478
7349	6220	4	applied	\N	\N	\N	\N	82554	82554	250479
7349	6221	5	applied	\N	\N	\N	\N	82555	82555	250480
7349	6222	6	applied	\N	\N	\N	\N	82556	82556	250481
7349	6223	7	applied	\N	\N	\N	\N	82557	82557	250482
7354	6199	0	applied	\N	\N	\N	\N	82590	82590	250515
7354	6201	1	applied	\N	\N	\N	\N	82591	82591	250516
7354	6202	2	applied	\N	\N	\N	\N	82592	82592	250517
7354	6203	3	applied	\N	\N	\N	\N	82593	82593	250518
7354	6171	4	applied	\N	\N	\N	\N	82594	82594	250519
7354	6172	5	applied	\N	\N	\N	\N	82595	82595	250520
7354	6173	6	applied	\N	\N	\N	\N	82596	82596	250521
7354	6174	7	applied	\N	\N	\N	\N	82597	82597	250522
7354	6175	8	applied	\N	\N	\N	\N	82598	82598	250523
7354	6176	9	applied	\N	\N	\N	\N	82599	82599	250524
7354	6177	10	applied	\N	\N	\N	\N	82600	82600	250525
7354	6185	11	applied	\N	\N	\N	\N	82601	82601	250526
7354	6186	12	applied	\N	\N	\N	\N	82602	82602	250527
7354	6187	13	applied	\N	\N	\N	\N	82603	82603	250528
7354	6188	14	applied	\N	\N	\N	\N	82604	82604	250529
7354	6178	15	applied	\N	\N	\N	\N	82605	82605	250530
7354	6179	16	applied	\N	\N	\N	\N	82606	82606	250531
7354	6180	17	applied	\N	\N	\N	\N	82607	82607	250532
7354	6181	18	applied	\N	\N	\N	\N	82608	82608	250533
7354	6204	19	applied	\N	\N	\N	\N	82609	82609	250534
7354	6207	20	applied	\N	\N	\N	\N	82610	82610	250535
7354	6208	21	applied	\N	\N	\N	\N	82611	82611	250536
7354	6209	22	applied	\N	\N	\N	\N	82612	82612	250537
7354	6211	24	applied	\N	\N	\N	\N	82614	82614	250539
7354	6212	25	applied	\N	\N	\N	\N	82615	82615	250540
7354	6213	26	applied	\N	\N	\N	\N	82616	82616	250541
7354	6214	27	applied	\N	\N	\N	\N	82617	82617	250542
7354	6215	28	applied	\N	\N	\N	\N	82618	82618	250543
7354	6216	29	applied	\N	\N	\N	\N	82619	82619	250544
7354	6217	30	applied	\N	\N	\N	\N	82620	82620	250545
7354	6218	31	applied	\N	\N	\N	\N	82621	82621	250546
7354	6220	32	applied	\N	\N	\N	\N	82622	82622	250547
7354	6221	33	applied	\N	\N	\N	\N	82623	82623	250548
7354	6222	34	applied	\N	\N	\N	\N	82624	82624	250549
7354	6223	35	applied	\N	\N	\N	\N	82625	82625	250550
7354	6224	36	applied	\N	\N	\N	\N	82626	82626	250551
7341	6096	60	applied	\N	\N	\N	\N	82455	82455	250382
7341	6097	61	applied	\N	\N	\N	\N	82456	82456	250383
7354	6228	40	applied	\N	\N	\N	\N	82630	82630	250555
7354	6182	41	applied	\N	\N	\N	\N	82631	82631	250556
7354	6183	42	applied	\N	\N	\N	\N	82632	82632	250557
7354	6189	45	applied	\N	\N	\N	\N	82634	82634	250559
7354	6190	46	applied	\N	\N	\N	\N	82635	82635	250560
7354	6191	47	applied	\N	\N	\N	\N	82636	82636	250561
7354	6192	48	applied	\N	\N	\N	\N	82637	82637	250562
7354	6193	49	applied	\N	\N	\N	\N	82638	82638	250563
7354	6194	50	applied	\N	\N	\N	\N	82639	82639	250564
7354	6195	51	applied	\N	\N	\N	\N	82640	82640	250565
7354	6196	52	applied	\N	\N	\N	\N	82641	82641	250566
7354	6197	53	applied	\N	\N	\N	\N	82642	82642	250567
7354	6198	54	applied	\N	\N	\N	\N	82643	82643	250568
7354	6200	55	applied	\N	\N	\N	\N	82644	82644	250569
7354	6206	56	applied	\N	\N	\N	\N	82645	82645	250570
7354	6219	57	applied	\N	\N	\N	\N	82646	82646	250571
7356	6232	0	applied	\N	\N	\N	\N	82657	82657	250581
7356	6233	1	applied	\N	\N	\N	\N	82658	82658	250582
7356	6234	2	applied	\N	\N	\N	\N	82659	82659	250583
7356	6235	3	applied	\N	\N	\N	\N	82660	82660	250584
7356	6236	4	applied	\N	\N	\N	\N	82661	82661	250585
7356	6237	5	applied	\N	\N	\N	\N	82662	82662	250586
7356	6238	6	applied	\N	\N	\N	\N	82663	82663	250587
7356	6239	7	applied	\N	\N	\N	\N	82664	82664	250588
7356	6240	8	applied	\N	\N	\N	\N	82665	82665	250589
7361	6266	7	applied	\N	\N	\N	\N	82727	82727	250651
7361	6267	8	applied	\N	\N	\N	\N	82728	82728	250652
7363	6268	0	applied	\N	\N	\N	\N	82737	82737	250661
7363	6269	1	applied	\N	\N	\N	\N	82738	82738	250662
7363	6270	2	applied	\N	\N	\N	\N	82739	82739	250663
7363	6271	3	applied	\N	\N	\N	\N	82740	82740	250664
7363	6272	4	applied	\N	\N	\N	\N	82741	82741	250665
7363	6273	5	applied	\N	\N	\N	\N	82742	82742	250666
7363	6274	6	applied	\N	\N	\N	\N	82743	82743	250667
7363	6275	7	applied	\N	\N	\N	\N	82744	82744	250668
7364	6268	0	applied	\N	\N	\N	\N	82745	82745	250669
7364	6269	1	applied	\N	\N	\N	\N	82746	82746	250670
7364	6270	2	applied	\N	\N	\N	\N	82747	82747	250671
7364	6271	3	applied	\N	\N	\N	\N	82748	82748	250672
7364	6272	4	applied	\N	\N	\N	\N	82749	82749	250673
7364	6273	5	applied	\N	\N	\N	\N	82750	82750	250674
7364	6274	6	applied	\N	\N	\N	\N	82751	82751	250675
7364	6275	7	applied	\N	\N	\N	\N	82752	82752	250676
7367	6277	1	applied	\N	\N	\N	\N	82769	82769	250693
7367	6278	2	applied	\N	\N	\N	\N	82770	82770	250694
7372	6291	1	applied	\N	\N	\N	\N	82803	82803	250726
7372	6290	0	failed	Receiver_not_present	\N	\N	\N	82802	82802	\N
7372	6292	2	applied	\N	\N	1000000000	\N	82804	82804	250727
7372	6289	3	applied	\N	\N	\N	\N	82805	82805	250728
7372	6293	4	applied	\N	\N	\N	\N	82806	82806	250729
7372	6294	5	applied	\N	\N	\N	\N	82807	82807	250730
7372	6295	6	applied	\N	\N	\N	\N	82808	82808	250731
7372	6296	7	applied	\N	\N	\N	\N	82809	82809	250732
7372	6297	8	applied	\N	\N	\N	\N	82810	82810	250733
7372	6298	9	applied	\N	\N	\N	\N	82811	82811	250734
7372	6299	10	applied	\N	\N	\N	\N	82812	82812	250735
7372	6300	11	applied	\N	\N	\N	\N	82813	82813	250736
7372	6301	12	applied	\N	\N	\N	\N	82814	82814	250737
7372	6302	13	applied	\N	\N	\N	\N	82815	82815	250738
7372	6304	15	applied	\N	\N	\N	\N	82817	82817	250740
7372	6305	16	applied	\N	\N	\N	\N	82818	82818	250741
7372	6306	17	applied	\N	\N	\N	\N	82819	82819	250742
7372	6307	18	applied	\N	\N	\N	\N	82820	82820	250743
7372	6308	19	applied	\N	\N	\N	\N	82821	82821	250744
7372	6309	20	applied	\N	\N	\N	\N	82822	82822	250745
7372	6310	21	applied	\N	\N	\N	\N	82823	82823	250746
7372	6311	22	applied	\N	\N	\N	\N	82824	82824	250747
7372	6312	23	applied	\N	\N	\N	\N	82825	82825	250748
7372	6313	24	applied	\N	\N	\N	\N	82826	82826	250749
7372	6314	25	applied	\N	\N	\N	\N	82827	82827	250750
7372	6315	26	applied	\N	\N	\N	\N	82828	82828	250751
7372	6316	27	applied	\N	\N	\N	\N	82829	82829	250752
7372	6317	28	applied	\N	\N	\N	\N	82830	82830	250753
7372	6318	29	applied	\N	\N	\N	\N	82831	82831	250754
7375	6319	0	applied	\N	\N	\N	\N	82862	82862	250784
7389	6329	0	applied	\N	\N	\N	\N	82878	82878	250800
7389	6330	1	applied	\N	\N	\N	\N	82879	82879	250801
7389	6331	2	applied	\N	\N	\N	\N	82880	82880	250802
7394	6338	0	applied	\N	\N	\N	\N	82893	82893	250815
7394	6339	1	applied	\N	\N	\N	\N	82894	82894	250816
7399	6343	0	applied	\N	\N	\N	\N	82901	82901	250823
7409	6362	0	applied	\N	\N	\N	\N	82924	82924	250846
7409	6363	1	applied	\N	\N	\N	\N	82925	82925	250847
7411	6364	0	applied	\N	\N	\N	\N	82928	82928	250850
7417	6366	0	applied	\N	\N	\N	\N	82938	82938	250860
7425	6373	0	applied	\N	\N	\N	\N	83073	83073	250993
7425	6374	1	applied	\N	\N	\N	\N	83074	83074	250994
7425	6375	2	applied	\N	\N	\N	\N	83075	83075	250995
7428	6376	0	applied	\N	\N	\N	\N	83081	83081	251001
7428	6377	1	applied	\N	\N	\N	\N	83082	83082	251002
7430	6378	0	applied	\N	\N	\N	\N	83084	83084	251004
7434	6380	0	applied	\N	\N	\N	\N	83089	83089	251009
7437	6384	0	applied	\N	\N	\N	\N	83093	83093	251013
7442	6388	0	applied	\N	\N	\N	\N	83099	83099	251019
7450	6395	0	applied	\N	\N	\N	\N	83108	83108	251028
7450	6396	1	applied	\N	\N	\N	\N	83109	83109	251029
7453	6399	0	applied	\N	\N	\N	\N	83114	83114	251034
7453	6400	1	applied	\N	\N	\N	\N	83115	83115	251035
7453	6401	2	applied	\N	\N	\N	\N	83116	83116	251036
7461	6405	0	applied	\N	\N	\N	\N	83126	83126	251046
7461	6406	1	applied	\N	\N	\N	\N	83127	83127	251047
7461	6407	2	applied	\N	\N	\N	\N	83128	83128	251048
7465	6410	0	applied	\N	\N	\N	\N	83134	83134	251054
7469	6411	0	applied	\N	\N	\N	\N	83138	83138	251058
7470	6412	0	applied	\N	\N	\N	\N	83139	83139	251059
7470	6413	1	applied	\N	\N	\N	\N	83140	83140	251060
7472	6414	0	applied	\N	\N	\N	\N	83142	83142	251062
7475	6418	1	applied	\N	\N	\N	\N	83167	83167	251086
7479	6419	0	applied	\N	\N	\N	\N	83174	83174	251093
7354	6226	38	applied	\N	\N	\N	\N	82628	82628	250553
7354	6227	39	applied	\N	\N	\N	\N	82629	82629	250554
7367	6282	6	applied	\N	\N	\N	\N	82774	82774	250698
7369	6283	0	applied	\N	\N	\N	\N	82782	82782	250706
7369	6284	1	applied	\N	\N	\N	\N	82783	82783	250707
7369	6285	2	applied	\N	\N	\N	\N	82784	82784	250708
7369	6286	3	applied	\N	\N	\N	\N	82785	82785	250709
7369	6287	4	applied	\N	\N	\N	\N	82786	82786	250710
7369	6288	5	applied	\N	\N	\N	\N	82787	82787	250711
7369	6289	6	applied	\N	\N	\N	\N	82788	82788	250712
7373	6298	8	applied	\N	\N	\N	\N	82840	82840	250762
7373	6300	10	applied	\N	\N	\N	\N	82842	82842	250764
7373	6301	11	applied	\N	\N	\N	\N	82843	82843	250765
7373	6302	12	applied	\N	\N	\N	\N	82844	82844	250766
7373	6303	13	applied	\N	\N	\N	\N	82845	82845	250767
7373	6304	14	applied	\N	\N	\N	\N	82846	82846	250768
7373	6305	15	applied	\N	\N	\N	\N	82847	82847	250769
7373	6306	16	applied	\N	\N	\N	\N	82848	82848	250770
7373	6307	17	applied	\N	\N	\N	\N	82849	82849	250771
7373	6308	18	applied	\N	\N	\N	\N	82850	82850	250772
7373	6309	19	applied	\N	\N	\N	\N	82851	82851	250773
7373	6310	20	applied	\N	\N	\N	\N	82852	82852	250774
7373	6311	21	applied	\N	\N	\N	\N	82853	82853	250775
7373	6312	22	applied	\N	\N	\N	\N	82854	82854	250776
7373	6313	23	applied	\N	\N	\N	\N	82855	82855	250777
7373	6314	24	applied	\N	\N	\N	\N	82856	82856	250778
7373	6315	25	applied	\N	\N	\N	\N	82857	82857	250779
7373	6317	27	applied	\N	\N	\N	\N	82859	82859	250781
7373	6318	28	applied	\N	\N	\N	\N	82860	82860	250782
7374	6319	0	applied	\N	\N	\N	\N	82861	82861	250783
7376	6319	0	applied	\N	\N	\N	\N	82863	82863	250785
7377	6320	0	applied	\N	\N	\N	\N	82864	82864	250786
7379	6320	0	applied	\N	\N	\N	\N	82866	82866	250788
7382	6323	0	applied	\N	\N	\N	\N	82869	82869	250791
7384	6323	0	applied	\N	\N	\N	\N	82871	82871	250793
7386	6326	0	applied	\N	\N	\N	\N	82874	82874	250796
7386	6327	1	applied	\N	\N	\N	\N	82875	82875	250797
7387	6328	0	applied	\N	\N	\N	\N	82876	82876	250798
7390	6332	0	applied	\N	\N	\N	\N	82881	82881	250803
7390	6333	1	applied	\N	\N	\N	\N	82882	82882	250804
7390	6334	2	applied	\N	\N	\N	\N	82883	82883	250805
7400	6344	0	applied	\N	\N	\N	\N	82902	82902	250824
7400	6345	1	applied	\N	\N	\N	\N	82903	82903	250825
7400	6347	3	applied	\N	\N	1000000000	\N	82905	82905	250827
7400	6348	4	applied	\N	\N	\N	\N	82906	82906	250828
7400	6349	5	applied	\N	\N	\N	\N	82907	82907	250829
7400	6350	6	applied	\N	\N	\N	\N	82908	82908	250830
7400	6351	7	applied	\N	\N	\N	\N	82909	82909	250831
7403	6353	0	applied	\N	\N	\N	\N	82914	82914	250836
7403	6354	1	applied	\N	\N	\N	\N	82915	82915	250837
7403	6355	2	applied	\N	\N	\N	\N	82916	82916	250838
7408	6359	0	applied	\N	\N	\N	\N	82921	82921	250843
7408	6360	1	applied	\N	\N	\N	\N	82922	82922	250844
7408	6361	2	applied	\N	\N	1000000000	\N	82923	82923	250845
7416	6365	0	applied	\N	\N	\N	\N	82936	82936	250858
7416	6366	2	applied	\N	\N	\N	\N	82937	82937	250859
7422	6371	0	applied	\N	\N	\N	\N	82946	82946	250868
7427	6376	0	applied	\N	\N	\N	\N	83079	83079	250999
7427	6377	1	applied	\N	\N	\N	\N	83080	83080	251000
7429	6378	0	applied	\N	\N	\N	\N	83083	83083	251003
7440	6385	0	applied	\N	\N	\N	\N	83096	83096	251016
7441	6387	1	applied	\N	\N	\N	\N	83098	83098	251018
7444	6389	0	applied	\N	\N	\N	\N	83101	83101	251021
7446	6390	0	applied	\N	\N	\N	\N	83103	83103	251023
7449	6393	0	applied	\N	\N	\N	\N	83106	83106	251026
7449	6394	1	applied	\N	\N	\N	\N	83107	83107	251027
7452	6397	0	applied	\N	\N	\N	\N	83112	83112	251032
7452	6398	1	applied	\N	\N	\N	\N	83113	83113	251033
7455	6402	0	applied	\N	\N	\N	\N	83118	83118	251038
7458	6403	0	applied	\N	\N	\N	\N	83121	83121	251041
7459	6404	0	applied	\N	\N	\N	\N	83122	83122	251042
7460	6405	0	applied	\N	\N	\N	\N	83123	83123	251043
7460	6406	1	applied	\N	\N	\N	\N	83124	83124	251044
7460	6407	2	applied	\N	\N	\N	\N	83125	83125	251045
7468	6411	0	applied	\N	\N	\N	\N	83137	83137	251057
7474	6415	0	applied	\N	\N	\N	\N	83164	83164	251083
7474	6416	1	applied	\N	\N	\N	\N	83165	83165	251084
7481	6421	1	applied	\N	\N	\N	\N	83176	83176	251095
7481	6422	2	applied	\N	\N	\N	\N	83177	83177	251096
7489	6425	0	applied	\N	\N	\N	\N	83191	83191	251110
7489	6426	1	applied	\N	\N	\N	\N	83192	83192	251111
7499	6439	0	applied	\N	\N	\N	\N	83208	83208	251127
7504	6441	0	applied	\N	\N	\N	\N	83214	83214	251133
7504	6442	1	applied	\N	\N	\N	\N	83215	83215	251134
7509	6449	0	applied	\N	\N	\N	\N	83222	83222	251141
7509	6450	1	applied	\N	\N	\N	\N	83223	83223	251142
7509	6451	2	applied	\N	\N	\N	\N	83224	83224	251143
7509	6452	3	applied	\N	\N	\N	\N	83225	83225	251144
7512	6449	0	applied	\N	\N	\N	\N	83346	83346	251265
7512	6450	1	applied	\N	\N	\N	\N	83347	83347	251266
7512	6451	2	applied	\N	\N	\N	\N	83348	83348	251267
7512	6452	3	applied	\N	\N	\N	\N	83349	83349	251268
7516	6455	0	applied	\N	\N	\N	\N	83356	83356	251275
7519	6458	1	applied	\N	\N	\N	\N	83360	83360	251279
7519	6459	2	applied	\N	\N	\N	\N	83361	83361	251280
7533	6465	0	applied	\N	\N	\N	\N	83629	83629	251543
7533	6467	1	applied	\N	\N	\N	\N	83630	83630	251544
7533	6466	2	applied	\N	\N	\N	\N	83631	83631	83631
7535	6468	0	applied	\N	\N	\N	\N	83636	83636	251548
7535	6469	1	applied	\N	\N	\N	\N	83637	83637	83637
7538	6471	0	applied	\N	\N	\N	\N	83640	83640	251551
7550	6481	0	applied	\N	\N	\N	\N	83656	83656	251567
7555	6484	0	applied	\N	\N	\N	\N	83662	83662	251573
7557	6485	0	applied	\N	\N	\N	\N	83664	83664	251575
7568	6490	0	applied	\N	\N	\N	\N	83675	83675	251586
7571	6491	0	applied	\N	\N	\N	\N	83678	83678	251589
7580	6493	0	applied	\N	\N	\N	\N	83742	83742	251649
7582	6493	0	applied	\N	\N	\N	\N	83744	83744	251651
7583	6494	0	applied	\N	\N	\N	\N	83745	83745	251652
7591	6502	1	applied	\N	\N	1000000000	\N	83761	83761	251668
7597	6510	0	applied	\N	\N	\N	\N	83779	83779	251686
7367	6280	4	applied	\N	\N	\N	\N	82772	82772	250696
7367	6281	5	applied	\N	\N	\N	\N	82773	82773	250697
7395	6340	0	applied	\N	\N	\N	\N	82895	82895	250817
7395	6341	1	applied	\N	\N	\N	\N	82896	82896	250818
7397	6342	0	applied	\N	\N	\N	\N	82899	82899	250821
7401	6352	0	applied	\N	\N	\N	\N	82910	82910	250832
7404	6356	0	applied	\N	\N	\N	\N	82917	82917	250839
7406	6357	0	applied	\N	\N	\N	\N	82919	82919	250841
7410	6362	0	applied	\N	\N	\N	\N	82926	82926	250848
7410	6363	1	applied	\N	\N	\N	\N	82927	82927	250849
7412	6364	0	applied	\N	\N	\N	\N	82929	82929	250851
7414	6365	0	applied	\N	\N	\N	\N	82932	82932	250854
7414	6366	2	applied	\N	\N	\N	\N	82933	82933	250855
7418	6367	0	applied	\N	\N	\N	\N	82939	82939	250861
7418	6368	1	applied	\N	\N	\N	\N	82940	82940	250862
7419	6365	0	applied	\N	\N	\N	\N	82941	82941	250863
7419	6368	2	applied	\N	\N	\N	\N	82943	82943	250865
7423	6372	0	applied	\N	\N	\N	\N	82947	82947	250869
7424	5730	1	applied	\N	\N	\N	\N	82949	82949	250871
7424	5911	2	applied	\N	\N	\N	\N	82950	82950	250872
7424	5731	3	applied	\N	\N	\N	\N	82951	82951	250873
7424	6353	4	applied	\N	\N	\N	\N	82952	82952	250874
7424	6185	5	applied	\N	\N	\N	\N	82953	82953	250875
7424	6186	6	applied	\N	\N	\N	\N	82954	82954	250876
7424	6187	7	applied	\N	\N	\N	\N	82955	82955	250877
7424	6188	8	applied	\N	\N	\N	\N	82956	82956	250878
7424	5733	9	applied	\N	\N	\N	\N	82957	82957	250879
7424	6361	10	applied	\N	\N	1000000000	\N	82958	82958	250880
7424	5732	13	applied	\N	\N	\N	\N	82961	82961	250881
7424	6290	12	failed	Receiver_not_present	\N	\N	\N	82960	82960	\N
7424	5734	14	applied	\N	\N	\N	\N	82962	82962	250882
7424	5735	15	applied	\N	\N	\N	\N	82963	82963	250883
7424	5736	16	applied	\N	\N	\N	\N	82964	82964	250884
7424	5737	17	applied	\N	\N	\N	\N	82965	82965	250885
7424	5740	18	applied	\N	\N	\N	\N	82966	82966	250886
7424	5741	19	applied	\N	\N	\N	\N	82967	82967	250887
7424	5744	20	applied	\N	\N	\N	\N	82968	82968	250888
7424	5746	21	applied	\N	\N	\N	\N	82969	82969	250889
7424	5747	22	applied	\N	\N	\N	\N	82970	82970	250890
7424	5752	23	applied	\N	\N	\N	\N	82971	82971	250891
7424	5753	25	applied	\N	\N	\N	\N	82972	82972	250892
7424	5754	26	applied	\N	\N	\N	\N	82973	82973	250893
7424	5756	27	applied	\N	\N	\N	\N	82974	82974	250894
7424	5758	28	applied	\N	\N	\N	\N	82975	82975	250895
7431	6378	0	applied	\N	\N	\N	\N	83085	83085	251005
7431	6379	1	applied	\N	\N	\N	\N	83086	83086	251006
7433	6379	0	applied	\N	\N	\N	\N	83088	83088	251008
7435	6381	0	applied	\N	\N	\N	\N	83090	83090	251010
7435	6382	1	applied	\N	\N	\N	\N	83091	83091	251011
7438	6385	0	applied	\N	\N	\N	\N	83094	83094	251014
7445	6389	0	applied	\N	\N	\N	\N	83102	83102	251022
7447	6391	0	applied	\N	\N	\N	\N	83104	83104	251024
7451	6396	1	applied	\N	\N	\N	\N	83111	83111	251031
7456	6403	0	applied	\N	\N	\N	\N	83119	83119	251039
7463	6408	0	applied	\N	\N	\N	\N	83132	83132	251052
7466	6411	0	applied	\N	\N	\N	\N	83135	83135	251055
7473	6386	1	applied	\N	\N	\N	\N	83144	83144	251063
7473	6290	0	failed	Receiver_not_present	\N	\N	\N	83143	83143	\N
7473	6399	2	applied	\N	\N	\N	\N	83145	83145	251064
7473	6199	3	applied	\N	\N	\N	\N	83146	83146	251065
7473	6201	4	applied	\N	\N	\N	\N	83147	83147	251066
7473	6202	5	applied	\N	\N	\N	\N	83148	83148	251067
7473	6203	6	applied	\N	\N	\N	\N	83149	83149	251068
7473	6353	7	applied	\N	\N	\N	\N	83150	83150	251069
7473	6185	8	applied	\N	\N	\N	\N	83151	83151	251070
7473	6186	9	applied	\N	\N	\N	\N	83152	83152	251071
7473	6187	10	applied	\N	\N	\N	\N	83153	83153	251072
7473	6188	11	applied	\N	\N	\N	\N	83154	83154	251073
7473	6204	13	applied	\N	\N	\N	\N	83156	83156	251075
7473	6207	14	applied	\N	\N	\N	\N	83157	83157	251076
7473	6208	15	applied	\N	\N	\N	\N	83158	83158	251077
7473	6209	16	applied	\N	\N	\N	\N	83159	83159	251078
7473	6210	17	applied	\N	\N	\N	\N	83160	83160	251079
7473	6211	18	applied	\N	\N	\N	\N	83161	83161	251080
7473	6212	19	applied	\N	\N	\N	\N	83162	83162	251081
7473	6213	21	applied	\N	\N	\N	\N	83163	83163	251082
7476	6417	0	applied	\N	\N	\N	\N	83168	83168	251087
7476	6418	1	applied	\N	\N	\N	\N	83169	83169	251088
7482	6420	0	applied	\N	\N	\N	\N	83178	83178	251097
7482	6421	1	applied	\N	\N	\N	\N	83179	83179	251098
7482	6422	2	applied	\N	\N	\N	\N	83180	83180	251099
7485	6423	0	applied	\N	\N	\N	\N	83185	83185	251104
7487	6425	0	applied	\N	\N	\N	\N	83187	83187	251106
7487	6426	1	applied	\N	\N	\N	\N	83188	83188	251107
7492	6427	0	applied	\N	\N	\N	\N	83196	83196	251115
7494	6429	0	applied	\N	\N	\N	\N	83198	83198	251117
7497	6435	0	applied	\N	\N	\N	\N	83204	83204	251123
7500	6439	0	applied	\N	\N	\N	\N	83209	83209	251128
7502	6440	0	applied	\N	\N	\N	\N	83211	83211	251130
7505	6443	0	applied	\N	\N	\N	\N	83216	83216	251135
7505	6444	1	applied	\N	\N	\N	\N	83217	83217	251136
7510	6449	0	applied	\N	\N	\N	\N	83226	83226	251145
7510	6450	1	applied	\N	\N	\N	\N	83227	83227	251146
7510	6451	2	applied	\N	\N	\N	\N	83228	83228	251147
7510	6452	3	applied	\N	\N	\N	\N	83229	83229	251148
7513	6449	0	applied	\N	\N	\N	\N	83350	83350	251269
7513	6450	1	applied	\N	\N	\N	\N	83351	83351	251270
7513	6451	2	applied	\N	\N	\N	\N	83352	83352	251271
7513	6452	3	applied	\N	\N	\N	\N	83353	83353	251272
7514	6453	0	applied	\N	\N	\N	\N	83354	83354	251273
7520	6457	0	applied	\N	\N	\N	\N	83362	83362	251281
7520	6458	1	applied	\N	\N	\N	\N	83363	83363	251282
7524	6462	0	applied	\N	\N	\N	\N	83370	83370	251289
7529	6386	1	applied	\N	\N	\N	\N	83500	83500	251416
7529	6290	0	failed	Receiver_not_present	\N	\N	\N	83499	83499	\N
7529	6399	2	applied	\N	\N	\N	\N	83501	83501	251417
7529	6199	3	applied	\N	\N	\N	\N	83502	83502	251418
7529	6201	4	applied	\N	\N	\N	\N	83503	83503	251419
7529	6202	5	applied	\N	\N	\N	\N	83504	83504	251420
7529	6203	6	applied	\N	\N	\N	\N	83505	83505	251421
7529	6453	7	applied	\N	\N	\N	\N	83506	83506	251422
7390	6336	4	applied	\N	\N	\N	\N	82885	82885	250807
7392	6337	0	applied	\N	\N	\N	\N	82891	82891	250813
7424	5767	33	applied	\N	\N	\N	\N	82980	82980	250900
7424	5771	34	applied	\N	\N	\N	\N	82981	82981	250901
7424	5738	35	applied	\N	\N	\N	\N	82982	82982	250902
7424	5739	36	applied	\N	\N	\N	\N	82983	82983	250903
7424	5772	37	applied	\N	\N	\N	\N	82984	82984	250904
7424	5773	38	applied	\N	\N	\N	\N	82985	82985	250905
7424	5776	39	applied	\N	\N	\N	\N	82986	82986	250906
7424	5777	40	applied	\N	\N	\N	\N	82987	82987	250907
7424	5780	41	applied	\N	\N	\N	\N	82988	82988	250908
7424	5781	42	applied	\N	\N	\N	\N	82989	82989	250909
7424	5783	43	applied	\N	\N	\N	\N	82990	82990	250910
7424	5785	44	applied	\N	\N	\N	\N	82991	82991	250911
7424	5788	46	applied	\N	\N	\N	\N	82993	82993	250913
7424	5792	47	applied	\N	\N	\N	\N	82994	82994	250914
7424	5793	48	applied	\N	\N	\N	\N	82995	82995	250915
7424	5795	49	applied	\N	\N	\N	\N	82996	82996	250916
7424	5742	50	applied	\N	\N	\N	\N	82997	82997	250917
7424	5743	51	applied	\N	\N	\N	\N	82998	82998	250918
7424	5745	52	applied	\N	\N	\N	\N	82999	82999	250919
7424	5748	53	applied	\N	\N	\N	\N	83000	83000	250920
7424	5749	54	applied	\N	\N	\N	\N	83001	83001	250921
7424	5750	55	applied	\N	\N	\N	\N	83002	83002	250922
7424	5751	56	applied	\N	\N	\N	\N	83003	83003	250923
7424	5755	57	applied	\N	\N	\N	\N	83004	83004	250924
7424	5757	58	applied	\N	\N	\N	\N	83005	83005	250925
7424	5759	59	applied	\N	\N	\N	\N	83006	83006	250926
7424	5762	60	applied	\N	\N	\N	\N	83007	83007	250927
7424	5763	61	applied	\N	\N	\N	\N	83008	83008	250928
7424	5764	62	applied	\N	\N	\N	\N	83009	83009	250929
7424	5768	63	applied	\N	\N	\N	\N	83010	83010	250930
7424	5769	64	applied	\N	\N	\N	\N	83011	83011	250931
7424	5770	65	applied	\N	\N	\N	\N	83012	83012	250932
7424	5775	67	applied	\N	\N	\N	\N	83014	83014	250934
7424	5797	68	applied	\N	\N	\N	\N	83015	83015	250935
7424	5799	69	applied	\N	\N	\N	\N	83016	83016	250936
7424	5800	70	applied	\N	\N	\N	\N	83017	83017	250937
7424	5804	71	applied	\N	\N	\N	\N	83018	83018	250938
7424	5805	72	applied	\N	\N	\N	\N	83019	83019	250939
7424	5807	73	applied	\N	\N	\N	\N	83020	83020	250940
7424	5809	74	applied	\N	\N	\N	\N	83021	83021	250941
7424	5811	75	applied	\N	\N	\N	\N	83022	83022	250942
7424	5812	76	applied	\N	\N	\N	\N	83023	83023	250943
7424	5816	77	applied	\N	\N	\N	\N	83024	83024	250944
7424	5817	78	applied	\N	\N	\N	\N	83025	83025	250945
7424	5821	79	applied	\N	\N	\N	\N	83026	83026	250946
7424	5822	80	applied	\N	\N	\N	\N	83027	83027	250947
7424	5825	81	applied	\N	\N	\N	\N	83028	83028	250948
7424	5826	82	applied	\N	\N	\N	\N	83029	83029	250949
7424	5829	84	applied	\N	\N	\N	\N	83031	83031	250951
7424	5832	85	applied	\N	\N	\N	\N	83032	83032	250952
7424	5833	86	applied	\N	\N	\N	\N	83033	83033	250953
7424	5837	87	applied	\N	\N	\N	\N	83034	83034	250954
7424	5838	88	applied	\N	\N	\N	\N	83035	83035	250955
7424	5840	89	applied	\N	\N	\N	\N	83036	83036	250956
7424	5841	90	applied	\N	\N	\N	\N	83037	83037	250957
7424	5842	91	applied	\N	\N	\N	\N	83038	83038	250958
7424	5845	92	applied	\N	\N	\N	\N	83039	83039	250959
7424	6339	93	applied	\N	\N	\N	\N	83040	83040	250960
7424	6002	94	applied	\N	\N	\N	\N	83041	83041	250961
7424	6199	95	applied	\N	\N	\N	\N	83042	83042	250962
7424	6201	96	applied	\N	\N	\N	\N	83043	83043	250963
7424	6202	97	applied	\N	\N	\N	\N	83044	83044	250964
7424	6203	98	applied	\N	\N	\N	\N	83045	83045	250965
7424	6204	99	applied	\N	\N	\N	\N	83046	83046	250966
7424	6208	101	applied	\N	\N	\N	\N	83048	83048	250968
7424	6209	102	applied	\N	\N	\N	\N	83049	83049	250969
7424	6210	103	applied	\N	\N	\N	\N	83050	83050	250970
7424	6211	104	applied	\N	\N	\N	\N	83051	83051	250971
7424	6212	105	applied	\N	\N	\N	\N	83052	83052	250972
7424	6213	106	applied	\N	\N	\N	\N	83053	83053	250973
7424	6214	107	applied	\N	\N	\N	\N	83054	83054	250974
7424	6215	108	applied	\N	\N	\N	\N	83055	83055	250975
7424	6216	109	applied	\N	\N	\N	\N	83056	83056	250976
7424	6217	110	applied	\N	\N	\N	\N	83057	83057	250977
7424	6218	111	applied	\N	\N	\N	\N	83058	83058	250978
7424	6220	112	applied	\N	\N	\N	\N	83059	83059	250979
7424	6221	113	applied	\N	\N	\N	\N	83060	83060	250980
7424	6222	114	applied	\N	\N	\N	\N	83061	83061	250981
7424	6223	115	applied	\N	\N	\N	\N	83062	83062	250982
7424	6224	116	applied	\N	\N	\N	\N	83063	83063	250983
7424	6226	118	applied	\N	\N	\N	\N	83065	83065	250985
7424	6227	119	applied	\N	\N	\N	\N	83066	83066	250986
7424	6228	120	applied	\N	\N	\N	\N	83067	83067	250987
7424	6229	121	applied	\N	\N	\N	\N	83068	83068	250988
7424	6230	122	applied	\N	\N	\N	\N	83069	83069	250989
7424	6232	123	applied	\N	\N	\N	\N	83070	83070	250990
7424	6234	124	applied	\N	\N	\N	\N	83071	83071	250991
7424	6235	125	applied	\N	\N	\N	\N	83072	83072	250992
7426	6373	0	applied	\N	\N	\N	\N	83076	83076	250996
7426	6374	1	applied	\N	\N	\N	\N	83077	83077	250997
7426	6375	2	applied	\N	\N	\N	\N	83078	83078	250998
7436	6383	0	applied	\N	\N	\N	\N	83092	83092	251012
7439	6385	0	applied	\N	\N	\N	\N	83095	83095	251015
7443	6389	0	applied	\N	\N	\N	\N	83100	83100	251020
7448	6392	0	applied	\N	\N	\N	\N	83105	83105	251025
7454	6402	0	applied	\N	\N	\N	\N	83117	83117	251037
7462	6405	0	applied	\N	\N	\N	\N	83129	83129	251049
7462	6406	1	applied	\N	\N	\N	\N	83130	83130	251050
7462	6407	2	applied	\N	\N	\N	\N	83131	83131	251051
7464	6409	0	applied	\N	\N	\N	\N	83133	83133	251053
7467	6411	0	applied	\N	\N	\N	\N	83136	83136	251056
7471	6414	0	applied	\N	\N	\N	\N	83141	83141	251061
7477	6417	0	applied	\N	\N	\N	\N	83170	83170	251089
7477	6418	1	applied	\N	\N	\N	\N	83171	83171	251090
7478	6417	0	applied	\N	\N	\N	\N	83172	83172	251091
7478	6418	1	applied	\N	\N	\N	\N	83173	83173	251092
7483	6420	0	applied	\N	\N	\N	\N	83181	83181	251100
7483	6421	1	applied	\N	\N	\N	\N	83182	83182	251101
7483	6422	2	applied	\N	\N	\N	\N	83183	83183	251102
7488	6425	0	applied	\N	\N	\N	\N	83189	83189	251108
7424	5765	31	applied	\N	\N	\N	\N	82978	82978	250898
7424	5766	32	applied	\N	\N	\N	\N	82979	82979	250899
7490	6425	0	applied	\N	\N	\N	\N	83193	83193	251112
7490	6426	1	applied	\N	\N	\N	\N	83194	83194	251113
7491	6427	0	applied	\N	\N	\N	\N	83195	83195	251114
7493	6428	0	applied	\N	\N	\N	\N	83197	83197	251116
7495	6431	0	applied	\N	\N	\N	\N	83200	83200	251119
7495	6432	1	applied	\N	\N	\N	\N	83201	83201	251120
7496	6433	0	applied	\N	\N	\N	\N	83202	83202	251121
7496	6434	1	applied	\N	\N	\N	\N	83203	83203	251122
7498	6436	0	applied	\N	\N	\N	\N	83205	83205	251124
7498	6437	1	applied	\N	\N	\N	\N	83206	83206	251125
7498	6438	2	applied	\N	\N	\N	\N	83207	83207	251126
7503	6441	0	applied	\N	\N	\N	\N	83212	83212	251131
7503	6442	1	applied	\N	\N	\N	\N	83213	83213	251132
7506	6445	0	applied	\N	\N	\N	\N	83218	83218	251137
7506	6446	1	applied	\N	\N	\N	\N	83219	83219	251138
7507	6447	0	applied	\N	\N	\N	\N	83220	83220	251139
7508	6448	0	applied	\N	\N	\N	\N	83221	83221	251140
7511	6386	0	applied	\N	\N	\N	\N	83230	83230	251149
7511	6399	1	applied	\N	\N	\N	\N	83231	83231	251150
7511	6337	2	applied	\N	\N	\N	\N	83232	83232	251151
7511	6353	3	applied	\N	\N	\N	\N	83233	83233	251152
7511	6338	4	applied	\N	\N	\N	\N	83234	83234	251153
7511	6340	5	applied	\N	\N	\N	\N	83235	83235	251154
7511	6341	6	applied	\N	\N	\N	\N	83236	83236	251155
7511	6361	7	applied	\N	\N	1000000000	\N	83237	83237	251156
7511	6418	8	applied	\N	\N	\N	\N	83238	83238	251157
7511	6342	9	applied	\N	\N	\N	\N	83239	83239	251158
7511	6344	11	applied	\N	\N	\N	\N	83241	83241	251160
7511	6345	12	applied	\N	\N	\N	\N	83242	83242	251161
7511	6346	13	applied	\N	\N	1000000000	\N	83243	83243	251162
7511	6347	14	applied	\N	\N	1000000000	\N	83244	83244	251163
7511	6348	15	applied	\N	\N	\N	\N	83245	83245	251164
7511	6349	16	applied	\N	\N	\N	\N	83246	83246	251165
7511	6350	17	applied	\N	\N	\N	\N	83247	83247	251166
7511	6351	18	applied	\N	\N	\N	\N	83248	83248	251167
7511	6352	19	applied	\N	\N	\N	\N	83249	83249	251168
7511	6354	20	applied	\N	\N	\N	\N	83250	83250	251169
7511	6355	21	applied	\N	\N	\N	\N	83251	83251	251170
7511	6356	22	applied	\N	\N	\N	\N	83252	83252	251171
7511	6357	23	applied	\N	\N	\N	\N	83253	83253	251172
7511	6358	24	applied	\N	\N	\N	\N	83254	83254	251173
7511	6359	25	applied	\N	\N	\N	\N	83255	83255	251174
7511	6360	26	applied	\N	\N	\N	\N	83256	83256	251175
7511	6363	28	applied	\N	\N	\N	\N	83258	83258	251177
7511	6364	29	applied	\N	\N	\N	\N	83259	83259	251178
7511	6365	30	applied	\N	\N	\N	\N	83260	83260	251179
7511	6367	31	applied	\N	\N	\N	\N	83261	83261	251180
7511	6369	32	applied	\N	\N	\N	\N	83262	83262	251181
7511	6370	33	applied	\N	\N	\N	\N	83263	83263	251182
7511	6371	34	applied	\N	\N	\N	\N	83264	83264	251183
7511	6372	35	applied	\N	\N	\N	\N	83265	83265	251184
7511	6373	36	applied	\N	\N	\N	\N	83266	83266	251185
7511	6374	37	applied	\N	\N	\N	\N	83267	83267	251186
7511	6375	38	applied	\N	\N	\N	\N	83268	83268	251187
7511	6376	39	applied	\N	\N	\N	\N	83269	83269	251188
7511	6377	40	applied	\N	\N	\N	\N	83270	83270	251189
7511	6378	41	applied	\N	\N	\N	\N	83271	83271	251190
7511	6379	42	applied	\N	\N	\N	\N	83272	83272	251191
7511	6380	43	applied	\N	\N	\N	\N	83273	83273	251192
7511	6382	45	applied	\N	\N	\N	\N	83275	83275	251194
7511	6383	46	applied	\N	\N	\N	\N	83276	83276	251195
7511	6384	47	applied	\N	\N	\N	\N	83277	83277	251196
7511	6385	48	applied	\N	\N	\N	\N	83278	83278	251197
7511	6387	49	applied	\N	\N	\N	\N	83279	83279	251198
7511	6388	50	applied	\N	\N	\N	\N	83280	83280	251199
7511	6389	51	applied	\N	\N	\N	\N	83281	83281	251200
7511	6390	52	applied	\N	\N	\N	\N	83282	83282	251201
7511	6391	53	applied	\N	\N	\N	\N	83283	83283	251202
7511	6392	54	applied	\N	\N	\N	\N	83284	83284	251203
7511	6393	55	applied	\N	\N	\N	\N	83285	83285	251204
7511	6394	56	applied	\N	\N	\N	\N	83286	83286	251205
7511	6395	58	applied	\N	\N	\N	\N	83287	83287	251206
7511	6396	59	applied	\N	\N	\N	\N	83288	83288	251207
7511	6397	60	applied	\N	\N	\N	\N	83289	83289	251208
7511	6398	61	applied	\N	\N	\N	\N	83290	83290	251209
7511	6401	63	applied	\N	\N	\N	\N	83292	83292	251211
7511	6402	64	applied	\N	\N	\N	\N	83293	83293	251212
7511	6403	65	applied	\N	\N	\N	\N	83294	83294	251213
7511	6404	66	applied	\N	\N	\N	\N	83295	83295	251214
7511	6405	67	applied	\N	\N	\N	\N	83296	83296	251215
7511	6406	68	applied	\N	\N	\N	\N	83297	83297	251216
7511	6407	69	applied	\N	\N	\N	\N	83298	83298	251217
7511	6408	70	applied	\N	\N	\N	\N	83299	83299	251218
7511	6409	71	applied	\N	\N	\N	\N	83300	83300	251219
7511	6410	72	applied	\N	\N	\N	\N	83301	83301	251220
7511	6411	73	applied	\N	\N	\N	\N	83302	83302	251221
7511	6412	74	applied	\N	\N	\N	\N	83303	83303	251222
7511	6413	75	applied	\N	\N	\N	\N	83304	83304	251223
7511	6414	76	applied	\N	\N	\N	\N	83305	83305	251224
7511	6415	77	applied	\N	\N	\N	\N	83306	83306	251225
7511	6416	78	applied	\N	\N	\N	\N	83307	83307	251226
7517	6456	0	applied	\N	\N	\N	\N	83357	83357	251276
7522	6460	0	applied	\N	\N	\N	\N	83368	83368	251287
7525	6462	0	applied	\N	\N	\N	\N	83371	83371	251290
7527	6463	0	applied	\N	\N	\N	\N	83372	83372	251291
7527	6464	1	applied	\N	\N	\N	\N	83373	83373	251292
7534	6465	0	applied	\N	\N	\N	\N	83632	83632	251545
7534	6467	1	applied	\N	\N	\N	\N	83633	83633	251546
7534	6468	2	applied	\N	\N	\N	\N	83634	83634	251547
7534	6466	3	applied	\N	\N	\N	\N	83635	83635	83635
7536	6470	0	applied	\N	\N	\N	\N	83638	83638	251549
7541	6473	0	applied	\N	\N	\N	\N	83643	83643	251554
7544	6474	0	applied	\N	\N	\N	\N	83647	83647	251558
7544	6475	1	applied	\N	\N	\N	\N	83648	83648	251559
7546	6476	0	applied	\N	\N	\N	\N	83651	83651	251562
7556	6485	0	applied	\N	\N	\N	\N	83663	83663	251574
7558	6486	0	applied	\N	\N	\N	\N	83665	83665	251576
7565	6489	0	applied	\N	\N	\N	\N	83672	83672	251583
7572	6453	0	applied	\N	\N	\N	\N	83679	83679	251590
7486	6424	0	applied	\N	\N	\N	\N	83186	83186	251105
7488	6426	1	applied	\N	\N	\N	\N	83190	83190	251109
7511	6423	83	applied	\N	\N	\N	\N	83312	83312	251231
7511	6424	84	applied	\N	\N	\N	\N	83313	83313	251232
7511	6425	85	applied	\N	\N	\N	\N	83314	83314	251233
7511	6427	87	applied	\N	\N	\N	\N	83316	83316	251235
7511	6428	88	applied	\N	\N	\N	\N	83317	83317	251236
7511	6430	89	applied	\N	\N	\N	\N	83318	83318	251237
7511	6431	90	applied	\N	\N	\N	\N	83319	83319	251238
7511	6432	91	applied	\N	\N	\N	\N	83320	83320	251239
7511	6434	92	applied	\N	\N	\N	\N	83321	83321	251240
7511	6435	93	applied	\N	\N	\N	\N	83322	83322	251241
7511	6436	94	applied	\N	\N	\N	\N	83323	83323	251242
7511	6437	95	applied	\N	\N	\N	\N	83324	83324	251243
7511	6339	96	applied	\N	\N	\N	\N	83325	83325	251244
7511	6438	97	applied	\N	\N	\N	\N	83326	83326	251245
7511	6439	98	applied	\N	\N	\N	\N	83327	83327	251246
7511	6440	99	applied	\N	\N	\N	\N	83328	83328	251247
7511	6441	100	applied	\N	\N	\N	\N	83329	83329	251248
7511	6442	101	applied	\N	\N	\N	\N	83330	83330	251249
7511	6443	102	applied	\N	\N	\N	\N	83331	83331	251250
7511	6446	104	applied	\N	\N	\N	\N	83333	83333	251252
7511	6447	105	applied	\N	\N	\N	\N	83334	83334	251253
7511	6448	106	applied	\N	\N	\N	\N	83335	83335	251254
7511	6449	107	applied	\N	\N	\N	\N	83336	83336	251255
7511	6450	108	applied	\N	\N	\N	\N	83337	83337	251256
7511	6451	109	applied	\N	\N	\N	\N	83338	83338	251257
7511	6366	110	applied	\N	\N	\N	\N	83339	83339	251258
7511	6445	111	applied	\N	\N	\N	\N	83340	83340	251259
7511	6452	112	applied	\N	\N	\N	\N	83341	83341	251260
7511	6422	113	applied	\N	\N	\N	\N	83342	83342	251261
7511	6429	114	applied	\N	\N	\N	\N	83343	83343	251262
7511	6433	115	applied	\N	\N	\N	\N	83344	83344	251263
7511	6368	116	applied	\N	\N	\N	\N	83345	83345	251264
7515	6454	0	applied	\N	\N	\N	\N	83355	83355	251274
7518	6456	0	applied	\N	\N	\N	\N	83358	83358	251277
7521	6457	0	applied	\N	\N	\N	\N	83365	83365	251284
7521	6459	2	applied	\N	\N	\N	\N	83367	83367	251286
7523	6461	0	applied	\N	\N	\N	\N	83369	83369	251288
7528	6386	0	applied	\N	\N	\N	\N	83374	83374	251293
7528	6399	1	applied	\N	\N	\N	\N	83375	83375	251294
7528	6199	2	applied	\N	\N	\N	\N	83376	83376	251295
7528	6119	3	applied	\N	\N	\N	\N	83377	83377	251296
7528	6201	4	applied	\N	\N	\N	\N	83378	83378	251297
7528	6202	5	applied	\N	\N	\N	\N	83379	83379	251298
7528	6203	6	applied	\N	\N	\N	\N	83380	83380	251299
7528	6453	7	applied	\N	\N	\N	\N	83381	83381	251300
7528	6353	8	applied	\N	\N	\N	\N	83382	83382	251301
7528	6185	9	applied	\N	\N	\N	\N	83383	83383	251302
7528	6186	10	applied	\N	\N	\N	\N	83384	83384	251303
7528	6187	11	applied	\N	\N	\N	\N	83385	83385	251304
7528	6188	12	applied	\N	\N	\N	\N	83386	83386	251305
7528	6120	16	applied	\N	\N	\N	\N	83390	83390	251307
7528	6166	14	failed	Receiver_not_present	\N	\N	\N	83388	83388	\N
7528	6290	15	failed	Receiver_not_present	\N	\N	\N	83389	83389	\N
7528	6121	17	applied	\N	\N	\N	\N	83391	83391	251308
7528	6122	18	applied	\N	\N	\N	\N	83392	83392	251309
7528	6123	19	applied	\N	\N	\N	\N	83393	83393	251310
7528	6124	20	applied	\N	\N	\N	\N	83394	83394	251311
7528	6125	21	applied	\N	\N	\N	\N	83395	83395	251312
7528	6126	22	applied	\N	\N	\N	\N	83396	83396	251313
7528	6127	23	applied	\N	\N	\N	\N	83397	83397	251314
7528	6128	24	applied	\N	\N	\N	\N	83398	83398	251315
7528	6129	25	applied	\N	\N	\N	\N	83399	83399	251316
7528	6130	26	applied	\N	\N	\N	\N	83400	83400	251317
7528	6131	27	applied	\N	\N	\N	\N	83401	83401	251318
7528	6132	28	applied	\N	\N	\N	\N	83402	83402	251319
7528	6133	29	applied	\N	\N	\N	\N	83403	83403	251320
7528	6134	30	applied	\N	\N	\N	\N	83404	83404	251321
7528	6135	31	applied	\N	\N	\N	\N	83405	83405	251322
7528	6136	32	applied	\N	\N	\N	\N	83406	83406	251323
7528	6138	34	applied	\N	\N	\N	\N	83408	83408	251325
7528	6139	35	applied	\N	\N	\N	\N	83409	83409	251326
7528	6140	36	applied	\N	\N	\N	\N	83410	83410	251327
7528	6141	37	applied	\N	\N	\N	\N	83411	83411	251328
7528	6142	38	applied	\N	\N	\N	\N	83412	83412	251329
7528	6143	39	applied	\N	\N	\N	\N	83413	83413	251330
7528	6144	40	applied	\N	\N	\N	\N	83414	83414	251331
7528	6145	41	applied	\N	\N	\N	\N	83415	83415	251332
7528	6146	42	applied	\N	\N	\N	\N	83416	83416	251333
7528	6147	44	applied	\N	\N	\N	\N	83417	83417	251334
7528	6148	45	applied	\N	\N	\N	\N	83418	83418	251335
7528	6149	46	applied	\N	\N	\N	\N	83419	83419	251336
7528	6150	47	applied	\N	\N	\N	\N	83420	83420	251337
7528	6151	48	applied	\N	\N	\N	\N	83421	83421	251338
7528	6152	49	applied	\N	\N	\N	\N	83422	83422	251339
7528	6153	50	applied	\N	\N	\N	\N	83423	83423	251340
7528	6155	52	applied	\N	\N	\N	\N	83425	83425	251342
7528	6156	53	applied	\N	\N	\N	\N	83426	83426	251343
7528	6157	54	applied	\N	\N	\N	\N	83427	83427	251344
7528	6158	55	applied	\N	\N	\N	\N	83428	83428	251345
7572	6466	1	applied	\N	\N	\N	\N	83680	83680	83680
7572	6469	2	applied	\N	\N	\N	\N	83681	83681	83681
7574	6491	0	applied	\N	\N	\N	\N	83683	83683	251592
7576	6492	0	applied	\N	\N	\N	\N	83685	83685	251594
7578	6493	0	applied	\N	\N	\N	\N	83687	83687	251596
7581	6493	0	applied	\N	\N	\N	\N	83743	83743	251650
7586	6496	0	applied	\N	\N	\N	\N	83751	83751	251658
7586	6497	1	applied	\N	\N	\N	\N	83752	83752	251659
7586	6498	2	applied	\N	\N	\N	\N	83753	83753	251660
7586	6499	3	applied	\N	\N	\N	\N	83754	83754	251661
7588	6500	0	applied	\N	\N	\N	\N	83756	83756	251663
7590	6500	0	applied	\N	\N	\N	\N	83758	83758	251665
7593	6501	0	applied	\N	\N	\N	\N	83763	83763	251670
7593	6503	1	applied	\N	\N	\N	\N	83764	83764	251671
7593	6504	2	applied	\N	\N	\N	\N	83765	83765	251672
7593	6505	3	applied	\N	\N	\N	\N	83766	83766	251673
7593	6506	4	applied	\N	\N	\N	\N	83767	83767	251674
7593	6507	5	applied	\N	\N	1000000000	\N	83768	83768	251675
7593	6508	6	applied	\N	\N	1000000000	\N	83769	83769	251676
7595	6509	0	applied	\N	\N	\N	\N	83777	83777	251684
7511	6420	81	applied	\N	\N	\N	\N	83310	83310	251229
7511	6421	82	applied	\N	\N	\N	\N	83311	83311	251230
7528	6163	60	applied	\N	\N	\N	\N	83433	83433	251350
7528	6164	61	applied	\N	\N	\N	\N	83434	83434	251351
7528	6165	62	applied	\N	\N	\N	\N	83435	83435	251352
7528	6167	63	applied	\N	\N	\N	\N	83436	83436	251353
7528	6168	64	applied	\N	\N	\N	\N	83437	83437	251354
7528	6169	65	applied	\N	\N	\N	\N	83438	83438	251355
7528	6170	66	applied	\N	\N	\N	\N	83439	83439	251356
7528	6171	67	applied	\N	\N	\N	\N	83440	83440	251357
7528	6172	68	applied	\N	\N	\N	\N	83441	83441	251358
7528	6173	69	applied	\N	\N	\N	\N	83442	83442	251359
7528	6174	70	applied	\N	\N	\N	\N	83443	83443	251360
7528	6175	71	applied	\N	\N	\N	\N	83444	83444	251361
7528	6176	72	applied	\N	\N	\N	\N	83445	83445	251362
7528	6177	73	applied	\N	\N	\N	\N	83446	83446	251363
7528	6178	74	applied	\N	\N	\N	\N	83447	83447	251364
7528	6179	75	applied	\N	\N	\N	\N	83448	83448	251365
7528	6181	77	applied	\N	\N	\N	\N	83450	83450	251367
7528	6204	78	applied	\N	\N	\N	\N	83451	83451	251368
7528	6207	79	applied	\N	\N	\N	\N	83452	83452	251369
7528	6208	80	applied	\N	\N	\N	\N	83453	83453	251370
7528	6209	81	applied	\N	\N	\N	\N	83454	83454	251371
7528	6210	82	applied	\N	\N	\N	\N	83455	83455	251372
7528	6211	83	applied	\N	\N	\N	\N	83456	83456	251373
7528	6212	84	applied	\N	\N	\N	\N	83457	83457	251374
7528	6213	85	applied	\N	\N	\N	\N	83458	83458	251375
7528	6214	86	applied	\N	\N	\N	\N	83459	83459	251376
7528	6215	87	applied	\N	\N	\N	\N	83460	83460	251377
7528	6216	88	applied	\N	\N	\N	\N	83461	83461	251378
7528	6217	89	applied	\N	\N	\N	\N	83462	83462	251379
7528	6218	90	applied	\N	\N	\N	\N	83463	83463	251380
7528	6220	91	applied	\N	\N	\N	\N	83464	83464	251381
7528	6221	92	applied	\N	\N	\N	\N	83465	83465	251382
7528	6223	94	applied	\N	\N	\N	\N	83467	83467	251384
7528	6224	95	applied	\N	\N	\N	\N	83468	83468	251385
7528	6225	96	applied	\N	\N	\N	\N	83469	83469	251386
7528	6226	97	applied	\N	\N	\N	\N	83470	83470	251387
7528	6227	98	applied	\N	\N	\N	\N	83471	83471	251388
7528	6228	99	applied	\N	\N	\N	\N	83472	83472	251389
7528	6229	100	applied	\N	\N	\N	\N	83473	83473	251390
7528	6230	101	applied	\N	\N	\N	\N	83474	83474	251391
7528	6232	102	applied	\N	\N	\N	\N	83475	83475	251392
7528	6234	103	applied	\N	\N	\N	\N	83476	83476	251393
7528	6235	104	applied	\N	\N	\N	\N	83477	83477	251394
7528	6339	105	applied	\N	\N	\N	\N	83478	83478	251395
7528	6182	106	applied	\N	\N	\N	\N	83479	83479	251396
7528	6183	107	applied	\N	\N	\N	\N	83480	83480	251397
7528	6184	108	applied	\N	\N	\N	\N	83481	83481	251398
7528	6189	109	applied	\N	\N	\N	\N	83482	83482	251399
7528	6191	111	applied	\N	\N	\N	\N	83484	83484	251401
7528	6192	112	applied	\N	\N	\N	\N	83485	83485	251402
7528	6193	113	applied	\N	\N	\N	\N	83486	83486	251403
7528	6194	114	applied	\N	\N	\N	\N	83487	83487	251404
7528	6195	115	applied	\N	\N	\N	\N	83488	83488	251405
7528	6196	116	applied	\N	\N	\N	\N	83489	83489	251406
7528	6197	117	applied	\N	\N	\N	\N	83490	83490	251407
7528	6198	118	applied	\N	\N	\N	\N	83491	83491	251408
7528	6200	119	applied	\N	\N	\N	\N	83492	83492	251409
7528	6206	120	applied	\N	\N	\N	\N	83493	83493	251410
7528	6219	121	applied	\N	\N	\N	\N	83494	83494	251411
7528	6231	122	applied	\N	\N	\N	\N	83495	83495	251412
7528	6233	123	applied	\N	\N	\N	\N	83496	83496	251413
7528	6242	124	applied	\N	\N	\N	\N	83497	83497	251414
7528	6243	125	applied	\N	\N	\N	\N	83498	83498	251415
7530	6465	0	applied	\N	\N	\N	\N	83624	83624	251540
7532	6467	0	applied	\N	\N	\N	\N	83628	83628	251542
7537	6471	0	applied	\N	\N	\N	\N	83639	83639	251550
7542	6473	0	applied	\N	\N	\N	\N	83644	83644	251555
7545	6474	0	applied	\N	\N	\N	\N	83649	83649	251560
7545	6475	1	applied	\N	\N	\N	\N	83650	83650	251561
7547	6477	0	applied	\N	\N	\N	\N	83652	83652	251563
7547	6478	1	applied	\N	\N	\N	\N	83653	83653	251564
7549	6480	0	applied	\N	\N	\N	\N	83655	83655	251566
7552	6482	0	applied	\N	\N	\N	\N	83658	83658	251569
7552	6483	1	applied	\N	\N	\N	\N	83659	83659	251570
7554	6484	0	applied	\N	\N	\N	\N	83661	83661	251572
7559	6486	0	applied	\N	\N	\N	\N	83666	83666	251577
7561	6487	0	applied	\N	\N	\N	\N	83668	83668	251579
7566	6489	0	applied	\N	\N	\N	\N	83673	83673	251584
7570	6491	0	applied	\N	\N	\N	\N	83677	83677	251588
7573	6491	0	applied	\N	\N	\N	\N	83682	83682	251591
7579	6453	1	applied	\N	\N	\N	\N	83689	83689	251598
7579	6439	2	applied	\N	\N	\N	\N	83690	83690	251599
7579	6440	3	applied	\N	\N	\N	\N	83691	83691	251600
7579	6441	4	applied	\N	\N	\N	\N	83692	83692	251601
7579	6442	5	applied	\N	\N	\N	\N	83693	83693	251602
7579	6443	6	applied	\N	\N	\N	\N	83694	83694	251603
7579	6444	7	applied	\N	\N	\N	\N	83695	83695	251604
7579	6446	8	applied	\N	\N	\N	\N	83696	83696	251605
7579	6447	9	applied	\N	\N	\N	\N	83697	83697	251606
7579	6448	10	applied	\N	\N	\N	\N	83698	83698	251607
7579	6449	11	applied	\N	\N	\N	\N	83699	83699	251608
7579	6450	12	applied	\N	\N	\N	\N	83700	83700	251609
7579	6451	13	applied	\N	\N	\N	\N	83701	83701	251610
7579	6454	14	applied	\N	\N	\N	\N	83702	83702	251611
7579	6455	15	applied	\N	\N	\N	\N	83703	83703	251612
7579	6456	16	applied	\N	\N	\N	\N	83704	83704	251613
7579	6458	18	applied	\N	\N	\N	\N	83706	83706	251615
7579	6459	19	applied	\N	\N	\N	\N	83707	83707	251616
7579	6460	20	applied	\N	\N	\N	\N	83708	83708	251617
7579	6461	21	applied	\N	\N	\N	\N	83709	83709	251618
7579	6462	22	applied	\N	\N	\N	\N	83710	83710	251619
7579	6463	23	applied	\N	\N	\N	\N	83711	83711	251620
7579	6464	24	applied	\N	\N	\N	\N	83712	83712	251621
7579	6465	25	applied	\N	\N	\N	\N	83713	83713	251622
7579	6467	26	applied	\N	\N	\N	\N	83714	83714	251623
7579	6468	27	applied	\N	\N	\N	\N	83715	83715	251624
7579	6470	28	applied	\N	\N	\N	\N	83716	83716	251625
7579	6471	29	applied	\N	\N	\N	\N	83717	83717	251626
7579	6472	30	applied	\N	\N	\N	\N	83718	83718	251627
7579	6473	31	applied	\N	\N	\N	\N	83719	83719	251628
7528	6160	57	applied	\N	\N	\N	\N	83430	83430	251347
7528	6161	58	applied	\N	\N	\N	\N	83431	83431	251348
7529	6164	12	applied	\N	\N	\N	\N	83511	83511	251427
7529	6165	13	applied	\N	\N	\N	\N	83512	83512	251428
7529	6167	14	applied	\N	\N	\N	\N	83513	83513	251429
7529	6168	15	applied	\N	\N	\N	\N	83514	83514	251430
7529	6169	16	applied	\N	\N	\N	\N	83515	83515	251431
7529	6170	17	applied	\N	\N	\N	\N	83516	83516	251432
7529	6171	18	applied	\N	\N	\N	\N	83517	83517	251433
7529	6172	19	applied	\N	\N	\N	\N	83518	83518	251434
7529	6173	20	applied	\N	\N	\N	\N	83519	83519	251435
7529	6174	21	applied	\N	\N	\N	\N	83520	83520	251436
7529	6175	22	applied	\N	\N	\N	\N	83521	83521	251437
7529	6176	23	applied	\N	\N	\N	\N	83522	83522	251438
7529	6177	24	applied	\N	\N	\N	\N	83523	83523	251439
7529	6178	25	applied	\N	\N	\N	\N	83524	83524	251440
7529	6179	26	applied	\N	\N	\N	\N	83525	83525	251441
7529	6180	27	applied	\N	\N	\N	\N	83526	83526	251442
7529	6204	29	applied	\N	\N	\N	\N	83528	83528	251444
7529	6207	30	applied	\N	\N	\N	\N	83529	83529	251445
7529	6208	31	applied	\N	\N	\N	\N	83530	83530	251446
7529	6209	32	applied	\N	\N	\N	\N	83531	83531	251447
7529	6210	33	applied	\N	\N	\N	\N	83532	83532	251448
7529	6211	34	applied	\N	\N	\N	\N	83533	83533	251449
7529	6212	35	applied	\N	\N	\N	\N	83534	83534	251450
7529	6213	36	applied	\N	\N	\N	\N	83535	83535	251451
7529	6214	37	applied	\N	\N	\N	\N	83536	83536	251452
7529	6215	38	applied	\N	\N	\N	\N	83537	83537	251453
7529	6216	39	applied	\N	\N	\N	\N	83538	83538	251454
7529	6217	40	applied	\N	\N	\N	\N	83539	83539	251455
7529	6218	41	applied	\N	\N	\N	\N	83540	83540	251456
7529	6220	42	applied	\N	\N	\N	\N	83541	83541	251457
7529	6221	43	applied	\N	\N	\N	\N	83542	83542	251458
7529	6222	44	applied	\N	\N	\N	\N	83543	83543	251459
7529	6224	46	applied	\N	\N	\N	\N	83545	83545	251461
7529	6225	47	applied	\N	\N	\N	\N	83546	83546	251462
7529	6226	48	applied	\N	\N	\N	\N	83547	83547	251463
7529	6227	49	applied	\N	\N	\N	\N	83548	83548	251464
7529	6228	50	applied	\N	\N	\N	\N	83549	83549	251465
7529	6229	51	applied	\N	\N	\N	\N	83550	83550	251466
7529	6230	52	applied	\N	\N	\N	\N	83551	83551	251467
7529	6232	53	applied	\N	\N	\N	\N	83552	83552	251468
7529	6234	54	applied	\N	\N	\N	\N	83553	83553	251469
7529	6235	55	applied	\N	\N	\N	\N	83554	83554	251470
7529	6339	56	applied	\N	\N	\N	\N	83555	83555	251471
7529	6182	57	applied	\N	\N	\N	\N	83556	83556	251472
7529	6183	58	applied	\N	\N	\N	\N	83557	83557	251473
7529	6184	59	applied	\N	\N	\N	\N	83558	83558	251474
7529	6189	60	applied	\N	\N	\N	\N	83559	83559	251475
7529	6190	61	applied	\N	\N	\N	\N	83560	83560	251476
7529	6192	63	applied	\N	\N	\N	\N	83562	83562	251478
7529	6193	64	applied	\N	\N	\N	\N	83563	83563	251479
7529	6194	65	applied	\N	\N	\N	\N	83564	83564	251480
7529	6195	66	applied	\N	\N	\N	\N	83565	83565	251481
7529	6196	67	applied	\N	\N	\N	\N	83566	83566	251482
7529	6197	68	applied	\N	\N	\N	\N	83567	83567	251483
7529	6198	69	applied	\N	\N	\N	\N	83568	83568	251484
7529	6200	70	applied	\N	\N	\N	\N	83569	83569	251485
7529	6206	71	applied	\N	\N	\N	\N	83570	83570	251486
7529	6219	72	applied	\N	\N	\N	\N	83571	83571	251487
7529	6231	73	applied	\N	\N	\N	\N	83572	83572	251488
7529	6233	74	applied	\N	\N	\N	\N	83573	83573	251489
7529	6242	75	applied	\N	\N	\N	\N	83574	83574	251490
7529	6243	76	applied	\N	\N	\N	\N	83575	83575	251491
7529	6259	77	applied	\N	\N	\N	\N	83576	83576	251492
7529	6272	78	applied	\N	\N	\N	\N	83577	83577	251493
7529	6284	80	applied	\N	\N	\N	\N	83579	83579	251495
7529	6291	81	applied	\N	\N	\N	\N	83580	83580	251496
7529	6317	82	applied	\N	\N	\N	\N	83581	83581	251497
7529	6319	83	applied	\N	\N	\N	\N	83582	83582	251498
7529	6320	84	applied	\N	\N	\N	\N	83583	83583	251499
7529	6321	86	applied	\N	\N	\N	\N	83584	83584	251500
7529	6322	87	applied	\N	\N	\N	\N	83585	83585	251501
7529	6323	88	applied	\N	\N	\N	\N	83586	83586	251502
7529	6324	89	applied	\N	\N	\N	\N	83587	83587	251503
7529	6325	90	applied	\N	\N	\N	\N	83588	83588	251504
7529	6326	91	applied	\N	\N	\N	\N	83589	83589	251505
7529	6327	92	applied	\N	\N	\N	\N	83590	83590	251506
7529	6328	93	applied	\N	\N	\N	\N	83591	83591	251507
7529	6329	94	applied	\N	\N	\N	\N	83592	83592	251508
7529	6236	95	applied	\N	\N	\N	\N	83593	83593	251509
7529	6237	96	applied	\N	\N	\N	\N	83594	83594	251510
7529	6239	98	applied	\N	\N	\N	\N	83596	83596	251512
7529	6240	99	applied	\N	\N	\N	\N	83597	83597	251513
7529	6241	100	applied	\N	\N	\N	\N	83598	83598	251514
7529	6244	101	applied	\N	\N	\N	\N	83599	83599	251515
7529	6245	102	applied	\N	\N	\N	\N	83600	83600	251516
7529	6246	103	applied	\N	\N	\N	\N	83601	83601	251517
7529	6247	104	applied	\N	\N	\N	\N	83602	83602	251518
7529	6248	105	applied	\N	\N	\N	\N	83603	83603	251519
7529	6249	106	applied	\N	\N	\N	\N	83604	83604	251520
7529	6250	107	applied	\N	\N	\N	\N	83605	83605	251521
7579	6474	32	applied	\N	\N	\N	\N	83720	83720	251629
7579	6475	33	applied	\N	\N	\N	\N	83721	83721	251630
7579	6476	34	applied	\N	\N	\N	\N	83722	83722	251631
7579	6477	35	applied	\N	\N	\N	\N	83723	83723	251632
7579	6478	36	applied	\N	\N	\N	\N	83724	83724	251633
7579	6479	37	applied	\N	\N	\N	\N	83725	83725	251634
7579	6481	39	applied	\N	\N	\N	\N	83727	83727	251636
7579	6482	40	applied	\N	\N	\N	\N	83728	83728	251637
7579	6483	41	applied	\N	\N	\N	\N	83729	83729	251638
7579	6484	42	applied	\N	\N	\N	\N	83730	83730	251639
7579	6485	43	applied	\N	\N	\N	\N	83731	83731	251640
7579	6486	44	applied	\N	\N	\N	\N	83732	83732	251641
7579	6487	45	applied	\N	\N	\N	\N	83733	83733	251642
7579	6488	46	applied	\N	\N	\N	\N	83734	83734	251643
7579	6489	47	applied	\N	\N	\N	\N	83735	83735	251644
7579	6490	48	applied	\N	\N	\N	\N	83736	83736	251645
7579	6491	49	applied	\N	\N	\N	\N	83737	83737	251646
7579	6492	50	applied	\N	\N	\N	\N	83738	83738	251647
7579	6452	51	applied	\N	\N	\N	\N	83739	83739	251648
7579	6466	52	applied	\N	\N	\N	\N	83740	83740	83740
7529	6162	10	applied	\N	\N	\N	\N	83509	83509	251425
7529	6163	11	applied	\N	\N	\N	\N	83510	83510	251426
7529	6254	111	applied	\N	\N	\N	\N	83609	83609	251525
7529	6255	112	applied	\N	\N	\N	\N	83610	83610	251526
7529	6256	113	applied	\N	\N	\N	\N	83611	83611	251527
7529	6257	114	applied	\N	\N	\N	\N	83612	83612	251528
7529	6258	115	applied	\N	\N	\N	\N	83613	83613	251529
7529	6261	117	applied	\N	\N	\N	\N	83615	83615	251531
7529	6262	118	applied	\N	\N	\N	\N	83616	83616	251532
7529	6263	119	applied	\N	\N	\N	\N	83617	83617	251533
7529	6264	120	applied	\N	\N	\N	\N	83618	83618	251534
7529	6265	121	applied	\N	\N	\N	\N	83619	83619	251535
7529	6266	122	applied	\N	\N	\N	\N	83620	83620	251536
7529	6267	123	applied	\N	\N	\N	\N	83621	83621	251537
7529	6268	124	applied	\N	\N	\N	\N	83622	83622	251538
7529	6269	125	applied	\N	\N	\N	\N	83623	83623	251539
7531	6465	0	applied	\N	\N	\N	\N	83626	83626	251541
7531	6466	1	applied	\N	\N	\N	\N	83627	83627	83627
7539	6471	0	applied	\N	\N	\N	\N	83641	83641	251552
7540	6472	0	applied	\N	\N	\N	\N	83642	83642	251553
7543	6474	0	applied	\N	\N	\N	\N	83645	83645	251556
7543	6475	1	applied	\N	\N	\N	\N	83646	83646	251557
7548	6479	0	applied	\N	\N	\N	\N	83654	83654	251565
7553	6484	0	applied	\N	\N	\N	\N	83660	83660	251571
7560	6487	0	applied	\N	\N	\N	\N	83667	83667	251578
7562	6488	0	applied	\N	\N	\N	\N	83669	83669	251580
7564	6488	0	applied	\N	\N	\N	\N	83671	83671	251582
7567	6489	0	applied	\N	\N	\N	\N	83674	83674	251585
7569	6490	0	applied	\N	\N	\N	\N	83676	83676	251587
7575	6492	0	applied	\N	\N	\N	\N	83684	83684	251593
7577	6492	0	applied	\N	\N	\N	\N	83686	83686	251595
7579	6469	53	applied	\N	\N	\N	\N	83741	83741	83741
7584	6495	0	applied	\N	\N	\N	\N	83746	83746	251653
7585	6496	0	applied	\N	\N	\N	\N	83747	83747	251654
7585	6497	1	applied	\N	\N	\N	\N	83748	83748	251655
7585	6498	2	applied	\N	\N	\N	\N	83749	83749	251656
7585	6499	3	applied	\N	\N	\N	\N	83750	83750	251657
7587	6500	0	applied	\N	\N	\N	\N	83755	83755	251662
7589	6500	0	applied	\N	\N	\N	\N	83757	83757	251664
7594	6501	0	applied	\N	\N	\N	\N	83770	83770	251677
7594	6503	1	applied	\N	\N	\N	\N	83771	83771	251678
7594	6504	2	applied	\N	\N	\N	\N	83772	83772	251679
7594	6505	3	applied	\N	\N	\N	\N	83773	83773	251680
7594	6506	4	applied	\N	\N	\N	\N	83774	83774	251681
7594	6507	5	applied	\N	\N	1000000000	\N	83775	83775	251682
7594	6508	6	applied	\N	\N	1000000000	\N	83776	83776	251683
7596	6510	0	applied	\N	\N	\N	\N	83778	83778	251685
7598	6454	0	applied	\N	\N	\N	\N	83780	83780	251687
7598	6453	1	applied	\N	\N	\N	\N	83781	83781	251688
7598	6455	2	applied	\N	\N	\N	\N	83782	83782	251689
7598	6456	3	applied	\N	\N	\N	\N	83783	83783	251690
7598	6457	4	applied	\N	\N	\N	\N	83784	83784	251691
7598	6458	5	applied	\N	\N	\N	\N	83785	83785	251692
7598	6459	6	applied	\N	\N	\N	\N	83786	83786	251693
7598	6460	7	applied	\N	\N	\N	\N	83787	83787	251694
7598	6461	8	applied	\N	\N	\N	\N	83788	83788	251695
7598	6462	9	applied	\N	\N	\N	\N	83789	83789	251696
7598	6464	11	applied	\N	\N	\N	\N	83791	83791	251698
7598	6465	12	applied	\N	\N	\N	\N	83792	83792	251699
7598	6467	13	applied	\N	\N	\N	\N	83793	83793	251700
7598	6468	14	applied	\N	\N	\N	\N	83794	83794	251701
7598	6470	15	applied	\N	\N	\N	\N	83795	83795	251702
7598	6471	16	applied	\N	\N	\N	\N	83796	83796	251703
7598	6472	17	applied	\N	\N	\N	\N	83797	83797	251704
7598	6473	18	applied	\N	\N	\N	\N	83798	83798	251705
7598	6474	19	applied	\N	\N	\N	\N	83799	83799	251706
7598	6475	20	applied	\N	\N	\N	\N	83800	83800	251707
7598	6476	21	applied	\N	\N	\N	\N	83801	83801	251708
7598	6477	22	applied	\N	\N	\N	\N	83802	83802	251709
7598	6478	23	applied	\N	\N	\N	\N	83803	83803	251710
7598	6479	24	applied	\N	\N	\N	\N	83804	83804	251711
7598	6480	25	applied	\N	\N	\N	\N	83805	83805	251712
7598	6481	26	applied	\N	\N	\N	\N	83806	83806	251713
7598	6483	28	applied	\N	\N	\N	\N	83808	83808	251715
7598	6484	29	applied	\N	\N	\N	\N	83809	83809	251716
7598	6485	30	applied	\N	\N	\N	\N	83810	83810	251717
7598	6486	31	applied	\N	\N	\N	\N	83811	83811	251718
7598	6487	32	applied	\N	\N	\N	\N	83812	83812	251719
7598	6488	33	applied	\N	\N	\N	\N	83813	83813	251720
7598	6489	34	applied	\N	\N	\N	\N	83814	83814	251721
7598	6490	35	applied	\N	\N	\N	\N	83815	83815	251722
7598	6491	36	applied	\N	\N	\N	\N	83816	83816	251723
7598	6492	37	applied	\N	\N	\N	\N	83817	83817	251724
7598	6493	38	applied	\N	\N	\N	\N	83818	83818	251725
7598	6494	39	applied	\N	\N	\N	\N	83819	83819	251726
7598	6495	40	applied	\N	\N	\N	\N	83820	83820	251727
7598	6496	41	applied	\N	\N	\N	\N	83821	83821	251728
7598	6497	42	applied	\N	\N	\N	\N	83822	83822	251729
7598	6498	43	applied	\N	\N	\N	\N	83823	83823	251730
7598	6500	45	applied	\N	\N	\N	\N	83825	83825	251732
7598	6501	46	applied	\N	\N	\N	\N	83826	83826	251733
7598	6503	47	applied	\N	\N	\N	\N	83827	83827	251734
7598	6504	48	applied	\N	\N	\N	\N	83828	83828	251735
7598	6505	49	applied	\N	\N	\N	\N	83829	83829	251736
7598	6506	50	applied	\N	\N	\N	\N	83830	83830	251737
7598	6507	51	applied	\N	\N	1000000000	\N	83831	83831	251738
7598	6508	52	applied	\N	\N	1000000000	\N	83832	83832	251739
7598	6509	53	applied	\N	\N	\N	\N	83833	83833	251740
7598	6510	54	applied	\N	\N	\N	\N	83834	83834	251741
7598	6466	55	applied	\N	\N	\N	\N	83835	83835	83835
7598	6469	56	applied	\N	\N	\N	\N	83836	83836	83836
7599	6511	0	applied	\N	\N	\N	\N	83837	83837	251742
7600	6512	0	applied	\N	\N	\N	\N	83838	83838	251743
7600	6513	1	applied	\N	\N	\N	\N	83839	83839	251744
7601	6514	0	applied	\N	\N	\N	\N	83840	83840	251745
7601	6516	2	applied	\N	\N	\N	\N	83842	83842	251747
7601	6517	3	applied	\N	\N	1000000000	\N	83843	83843	251748
7601	6518	4	applied	\N	\N	\N	\N	83844	83844	251749
7602	6519	0	applied	\N	\N	\N	\N	83845	83845	251750
7603	6520	0	applied	\N	\N	\N	\N	83846	83846	251751
7604	6521	0	applied	\N	\N	\N	\N	83847	83847	251752
7529	6252	109	applied	\N	\N	\N	\N	83607	83607	251523
7529	6253	110	applied	\N	\N	\N	\N	83608	83608	251524
7610	6524	0	applied	\N	\N	1000000000	\N	83851	83851	251756
7611	6525	0	applied	\N	\N	\N	\N	83852	83852	251757
7611	6526	2	applied	\N	\N	\N	\N	83854	83854	251759
7612	6525	0	applied	\N	\N	\N	\N	83855	83855	251760
7612	6526	1	applied	\N	\N	\N	\N	83856	83856	251761
7612	6527	2	applied	\N	\N	\N	\N	83857	83857	251762
7613	6525	0	applied	\N	\N	\N	\N	83858	83858	251763
7613	6526	1	applied	\N	\N	\N	\N	83859	83859	251764
7613	6527	2	applied	\N	\N	\N	\N	83860	83860	251765
7614	6525	0	applied	\N	\N	\N	\N	83861	83861	251766
7614	6526	1	applied	\N	\N	\N	\N	83862	83862	251767
7614	6527	2	applied	\N	\N	\N	\N	83863	83863	251768
7615	6528	0	applied	\N	\N	\N	\N	83864	83864	251769
7615	6529	1	applied	\N	\N	\N	\N	83865	83865	251770
7616	6528	0	applied	\N	\N	\N	\N	83866	83866	251771
7616	6529	1	applied	\N	\N	\N	\N	83867	83867	251772
7618	6530	0	applied	\N	\N	\N	\N	83868	83868	251773
7619	6530	0	applied	\N	\N	\N	\N	83869	83869	251774
7621	6531	0	applied	\N	\N	\N	\N	83870	83870	251775
7621	6532	1	applied	\N	\N	\N	\N	83871	83871	251776
7621	6533	2	applied	\N	\N	\N	\N	83872	83872	251777
7622	6532	1	applied	\N	\N	\N	\N	83874	83874	251779
7622	6533	2	applied	\N	\N	\N	\N	83875	83875	251780
7623	6534	0	applied	\N	\N	\N	\N	83876	83876	251781
7623	6535	1	applied	\N	\N	\N	\N	83877	83877	251782
7623	6536	2	applied	\N	\N	\N	\N	83878	83878	251783
7623	6537	3	applied	\N	\N	\N	\N	83879	83879	251784
7624	6445	0	applied	\N	\N	\N	\N	83880	83880	251785
7624	6453	1	applied	\N	\N	\N	\N	83881	83881	251786
7624	6502	2	applied	\N	\N	1000000000	\N	83882	83882	251787
7624	6524	3	applied	\N	\N	1000000000	\N	83883	83883	251788
7624	6452	4	applied	\N	\N	\N	\N	83884	83884	251789
7624	6533	5	applied	\N	\N	\N	\N	83885	83885	251790
7625	6538	0	applied	\N	\N	\N	\N	83886	83886	251791
7625	6539	1	applied	\N	\N	\N	\N	83887	83887	251792
7626	6538	0	applied	\N	\N	\N	\N	83888	83888	251793
7626	6539	1	applied	\N	\N	\N	\N	83889	83889	251794
7627	6539	1	applied	\N	\N	\N	\N	83891	83891	251796
7635	6552	0	applied	\N	\N	\N	\N	83904	83904	251809
7638	6553	0	applied	\N	\N	\N	\N	83907	83907	251812
7640	6554	0	applied	\N	\N	\N	\N	83909	83909	251814
7640	6555	1	applied	\N	\N	\N	\N	83910	83910	251815
7640	6556	2	applied	\N	\N	1000000000	\N	83911	83911	251816
7640	6557	3	applied	\N	\N	\N	\N	83912	83912	251817
7640	6558	4	applied	\N	\N	\N	\N	83913	83913	251818
7640	6559	5	applied	\N	\N	\N	\N	83914	83914	251819
7640	6560	6	applied	\N	\N	\N	\N	83915	83915	251820
7640	6561	7	applied	\N	\N	\N	\N	83916	83916	251821
7640	6562	8	applied	\N	\N	\N	\N	83917	83917	251822
7644	6514	0	applied	\N	\N	\N	\N	83937	83937	251842
7644	6511	1	applied	\N	\N	\N	\N	83938	83938	251843
7644	6512	2	applied	\N	\N	\N	\N	83939	83939	251844
7644	6513	3	applied	\N	\N	\N	\N	83940	83940	251845
7644	6516	5	applied	\N	\N	\N	\N	83942	83942	251847
7644	6517	6	applied	\N	\N	1000000000	\N	83943	83943	251848
7644	6518	8	applied	\N	\N	\N	\N	83944	83944	251849
7644	6519	9	applied	\N	\N	\N	\N	83945	83945	251850
7644	6520	10	applied	\N	\N	\N	\N	83946	83946	251851
7644	6521	11	applied	\N	\N	\N	\N	83947	83947	251852
7644	6522	12	applied	\N	\N	\N	\N	83948	83948	251853
7644	6523	13	applied	\N	\N	\N	\N	83949	83949	251854
7644	6525	14	applied	\N	\N	\N	\N	83950	83950	251855
7644	6526	15	applied	\N	\N	\N	\N	83951	83951	251856
7644	6527	16	applied	\N	\N	\N	\N	83952	83952	251857
7644	6528	17	applied	\N	\N	\N	\N	83953	83953	251858
7644	6529	18	applied	\N	\N	\N	\N	83954	83954	251859
7644	6530	19	applied	\N	\N	\N	\N	83955	83955	251860
7644	6531	20	applied	\N	\N	\N	\N	83956	83956	251861
7644	6532	21	applied	\N	\N	\N	\N	83957	83957	251862
7644	6535	23	applied	\N	\N	\N	\N	83959	83959	251864
7644	6536	24	applied	\N	\N	\N	\N	83960	83960	251865
7644	6537	25	applied	\N	\N	\N	\N	83961	83961	251866
7644	6538	26	applied	\N	\N	\N	\N	83962	83962	251867
7644	6539	27	applied	\N	\N	\N	\N	83963	83963	251868
7644	6540	28	applied	\N	\N	\N	\N	83964	83964	251869
7644	6541	29	applied	\N	\N	\N	\N	83965	83965	251870
7644	6542	30	applied	\N	\N	\N	\N	83966	83966	251871
7644	6544	31	applied	\N	\N	\N	\N	83967	83967	251872
7644	6545	32	applied	\N	\N	\N	\N	83968	83968	251873
7644	6546	33	applied	\N	\N	\N	\N	83969	83969	251874
7644	6547	34	applied	\N	\N	\N	\N	83970	83970	251875
7644	6548	35	applied	\N	\N	\N	\N	83971	83971	251876
7644	6549	36	applied	\N	\N	\N	\N	83972	83972	251877
7644	6550	37	applied	\N	\N	\N	\N	83973	83973	251878
7644	6551	38	applied	\N	\N	\N	\N	83974	83974	251879
7644	6553	40	applied	\N	\N	\N	\N	83976	83976	251881
7644	6555	41	applied	\N	\N	\N	\N	83977	83977	251882
7644	6557	42	applied	\N	\N	\N	\N	83978	83978	251883
7644	6533	43	applied	\N	\N	\N	\N	83979	83979	251884
7647	6566	0	applied	\N	\N	\N	\N	83983	83983	251888
7655	6574	0	applied	\N	\N	\N	\N	84003	84003	251908
7655	6575	1	applied	\N	\N	\N	\N	84004	84004	251909
7660	6578	0	applied	\N	\N	\N	\N	84008	84008	251913
7665	6583	0	applied	\N	\N	\N	\N	84017	84017	251922
7665	6584	1	applied	\N	\N	\N	\N	84018	84018	251923
7665	6585	2	applied	\N	\N	\N	\N	84019	84019	251924
7668	6586	0	applied	\N	\N	\N	\N	84024	84024	251929
7668	6587	1	applied	\N	\N	\N	\N	84025	84025	251930
7674	6591	0	applied	\N	\N	\N	\N	84032	84032	251937
7674	6592	1	applied	\N	\N	\N	\N	84033	84033	251938
7674	6594	3	applied	\N	\N	\N	\N	84035	84035	251940
7674	6595	4	applied	\N	\N	\N	\N	84036	84036	251941
7677	6596	0	applied	\N	\N	\N	\N	84042	84042	251947
7677	6597	2	applied	\N	\N	\N	\N	84043	84043	251948
7677	6598	3	applied	\N	\N	\N	\N	84044	84044	251949
7677	6599	4	applied	\N	\N	\N	\N	84045	84045	251950
7685	6605	0	applied	\N	\N	\N	\N	84056	84056	251961
7685	6606	1	applied	\N	\N	\N	\N	84057	84057	251962
7688	6608	0	applied	\N	\N	\N	\N	84060	84060	251965
7606	6523	0	applied	\N	\N	\N	\N	83849	83849	251754
7608	6523	0	applied	\N	\N	\N	\N	83850	83850	251755
7629	6543	3	applied	\N	\N	1000000000	\N	83895	83895	251800
7629	6544	4	applied	\N	\N	\N	\N	83896	83896	251801
7629	6545	5	applied	\N	\N	\N	\N	83897	83897	251802
7632	6549	1	applied	\N	\N	\N	\N	83901	83901	251806
7637	6553	0	applied	\N	\N	\N	\N	83906	83906	251811
7643	6554	0	applied	\N	\N	\N	\N	83928	83928	251833
7643	6555	1	applied	\N	\N	\N	\N	83929	83929	251834
7643	6556	2	applied	\N	\N	1000000000	\N	83930	83930	251835
7643	6557	3	applied	\N	\N	\N	\N	83931	83931	251836
7643	6558	4	applied	\N	\N	\N	\N	83932	83932	251837
7643	6559	5	applied	\N	\N	\N	\N	83933	83933	251838
7643	6560	6	applied	\N	\N	\N	\N	83934	83934	251839
7643	6561	7	applied	\N	\N	\N	\N	83935	83935	251840
7643	6562	8	applied	\N	\N	\N	\N	83936	83936	251841
7646	6564	0	applied	\N	\N	\N	\N	83981	83981	251886
7646	6565	1	applied	\N	\N	\N	\N	83982	83982	251887
7649	6567	0	applied	\N	\N	\N	\N	83986	83986	251891
7649	6568	1	applied	\N	\N	\N	\N	83987	83987	251892
7652	6569	0	applied	\N	\N	\N	\N	83996	83996	251901
7652	6571	2	applied	\N	\N	1000000000	\N	83998	83998	251903
7659	6577	0	applied	\N	\N	\N	\N	84007	84007	251912
7664	6581	0	applied	\N	\N	1000000000	\N	84013	84013	251918
7664	6579	1	applied	\N	\N	\N	\N	84014	84014	251919
7664	6580	2	applied	\N	\N	\N	\N	84015	84015	251920
7664	6582	3	applied	\N	\N	\N	\N	84016	84016	251921
7667	6586	0	applied	\N	\N	\N	\N	84022	84022	251927
7667	6587	1	applied	\N	\N	\N	\N	84023	84023	251928
7671	6588	0	applied	\N	\N	\N	\N	84029	84029	251934
7680	6601	0	applied	\N	\N	\N	\N	84048	84048	251953
7682	6602	0	applied	\N	\N	\N	\N	84049	84049	251954
7687	6608	0	applied	\N	\N	\N	\N	84059	84059	251964
7690	6612	0	applied	\N	\N	\N	\N	84064	84064	251969
7693	6614	0	applied	\N	\N	\N	\N	84066	84066	251971
7693	6613	1	applied	\N	\N	\N	\N	84067	84067	251972
7693	6615	2	applied	\N	\N	\N	\N	84068	84068	251973
7697	6617	0	applied	\N	\N	\N	\N	84072	84072	251977
7700	6618	0	applied	\N	\N	\N	\N	84075	84075	251980
7702	6620	0	applied	\N	\N	\N	\N	84077	84077	251982
7705	6620	0	applied	\N	\N	\N	\N	84080	84080	251985
7706	6621	0	applied	\N	\N	\N	\N	84081	84081	251986
7709	6622	0	applied	\N	\N	\N	\N	84087	84087	251992
7709	6623	1	applied	\N	\N	\N	\N	84088	84088	251993
7711	6624	0	applied	\N	\N	\N	\N	84090	84090	251995
7713	6625	0	applied	\N	\N	\N	\N	84092	84092	251997
7716	6627	0	applied	\N	\N	\N	\N	84095	84095	252000
7718	6628	0	applied	\N	\N	\N	\N	84097	84097	252002
7719	6628	0	applied	\N	\N	\N	\N	84098	84098	252003
7722	6629	0	applied	\N	\N	\N	\N	84101	84101	252006
7723	6629	0	applied	\N	\N	\N	\N	84102	84102	252007
7725	6632	0	applied	\N	\N	\N	\N	84105	84105	252010
7729	6637	1	applied	\N	\N	\N	\N	84110	84110	252015
7729	6638	2	applied	\N	\N	\N	\N	84111	84111	252016
7730	6639	0	applied	\N	\N	\N	\N	84112	84112	252017
7731	6639	0	applied	\N	\N	\N	\N	84113	84113	252018
7733	6641	0	applied	\N	\N	\N	\N	84115	84115	252020
7733	6642	1	applied	\N	\N	\N	\N	84116	84116	252021
7733	6643	2	applied	\N	\N	\N	\N	84117	84117	252022
7734	6644	0	applied	\N	\N	\N	\N	84118	84118	252023
7738	6646	0	applied	\N	\N	\N	\N	84140	84140	252045
7738	6647	1	applied	\N	\N	\N	\N	84141	84141	252046
7741	6649	0	applied	\N	\N	\N	\N	84143	84143	252048
7746	6650	0	applied	\N	\N	\N	\N	84148	84148	252053
7746	6651	1	applied	\N	\N	\N	\N	84149	84149	252054
7746	6652	2	applied	\N	\N	\N	\N	84150	84150	252055
7748	6653	0	applied	\N	\N	\N	\N	84152	84152	252057
7751	6657	0	applied	\N	\N	\N	\N	84156	84156	252061
7758	6660	0	applied	\N	\N	\N	\N	84163	84163	252068
7760	6659	0	applied	\N	\N	\N	\N	84165	84165	252070
7760	6660	1	applied	\N	\N	\N	\N	84166	84166	252071
7762	6662	1	applied	\N	\N	\N	\N	84168	84168	252073
7762	6663	2	applied	\N	\N	\N	\N	84169	84169	252074
7763	6664	0	applied	\N	\N	\N	\N	84170	84170	252075
7765	6664	0	applied	\N	\N	\N	\N	84172	84172	252077
7768	6668	0	applied	\N	\N	\N	\N	84176	84176	252081
7768	6669	1	applied	\N	\N	\N	\N	84177	84177	252082
7768	6670	2	applied	\N	\N	\N	\N	84178	84178	252083
7769	6671	0	applied	\N	\N	\N	\N	84179	84179	252084
7771	6672	0	applied	\N	\N	\N	\N	84181	84181	252086
7772	6672	0	applied	\N	\N	\N	\N	84182	84182	252087
7773	6673	0	applied	\N	\N	\N	\N	84183	84183	252088
7775	6674	0	applied	\N	\N	\N	\N	84185	84185	252090
7776	6674	0	applied	\N	\N	\N	\N	84186	84186	252091
7777	6675	0	applied	\N	\N	\N	\N	84187	84187	252092
7778	6675	0	applied	\N	\N	\N	\N	84188	84188	252093
7782	6677	0	applied	\N	\N	\N	\N	84191	84191	252096
7784	6679	1	applied	\N	\N	\N	\N	84194	84194	252099
7785	6678	0	applied	\N	\N	\N	\N	84195	84195	252100
7785	6679	1	applied	\N	\N	\N	\N	84196	84196	252101
7787	6683	0	applied	\N	\N	\N	\N	84200	84200	252105
7788	6683	0	applied	\N	\N	\N	\N	84201	84201	252106
7789	6684	0	applied	\N	\N	\N	\N	84202	84202	252107
7789	6685	1	applied	\N	\N	1000000000	\N	84203	84203	252108
7789	6686	2	applied	\N	\N	1000000000	\N	84204	84204	252109
7790	6687	0	applied	\N	\N	\N	\N	84205	84205	252110
7792	6688	0	applied	\N	\N	\N	\N	84207	84207	252112
7795	6688	0	applied	\N	\N	\N	\N	84210	84210	252115
7796	6689	0	applied	\N	\N	\N	\N	84211	84211	252116
7799	6691	0	applied	\N	\N	\N	\N	84214	84214	252119
7799	6692	1	applied	\N	\N	\N	\N	84215	84215	252120
7803	6694	0	applied	\N	\N	\N	\N	84219	84219	252124
7804	6695	0	applied	\N	\N	\N	\N	84220	84220	252125
7809	6696	0	applied	\N	\N	\N	\N	84225	84225	252130
7810	6697	0	applied	\N	\N	\N	\N	84226	84226	252131
7811	6697	0	applied	\N	\N	\N	\N	84228	84228	252133
7811	6698	1	applied	\N	\N	\N	\N	84229	84229	252134
7816	6700	0	applied	\N	\N	\N	\N	84234	84234	252139
7821	6706	0	applied	\N	\N	\N	\N	84244	84244	252149
7821	6707	1	applied	\N	\N	\N	\N	84245	84245	252150
7823	6708	0	applied	\N	\N	\N	\N	84248	84248	252153
7629	6541	1	applied	\N	\N	\N	\N	83893	83893	251798
7629	6542	2	applied	\N	\N	\N	\N	83894	83894	251799
7639	6553	0	applied	\N	\N	\N	\N	83908	83908	251813
7641	6556	0	applied	\N	\N	1000000000	\N	83918	83918	251823
7648	6567	0	applied	\N	\N	\N	\N	83984	83984	251889
7648	6568	1	applied	\N	\N	\N	\N	83985	83985	251890
7653	6572	0	applied	\N	\N	\N	\N	83999	83999	251904
7653	6573	1	applied	\N	\N	\N	\N	84000	84000	251905
7656	6576	0	applied	\N	\N	\N	\N	84005	84005	251910
7661	6579	0	applied	\N	\N	\N	\N	84009	84009	251914
7661	6580	1	applied	\N	\N	\N	\N	84010	84010	251915
7663	6580	1	applied	\N	\N	\N	\N	84012	84012	251917
7670	6588	0	applied	\N	\N	\N	\N	84028	84028	251933
7672	6589	0	applied	\N	\N	\N	\N	84030	84030	251935
7675	6591	0	applied	\N	\N	\N	\N	84037	84037	251942
7675	6592	1	applied	\N	\N	\N	\N	84038	84038	251943
7675	6593	2	applied	\N	\N	1000000000	\N	84039	84039	251944
7675	6594	3	applied	\N	\N	\N	\N	84040	84040	251945
7675	6595	4	applied	\N	\N	\N	\N	84041	84041	251946
7678	6600	0	applied	\N	\N	\N	\N	84046	84046	251951
7683	6602	0	applied	\N	\N	\N	\N	84050	84050	251955
7683	6603	1	applied	\N	\N	\N	\N	84051	84051	251956
7683	6604	2	applied	\N	\N	\N	\N	84052	84052	251957
7696	6617	0	applied	\N	\N	\N	\N	84071	84071	251976
7698	6618	0	applied	\N	\N	\N	\N	84073	84073	251978
7703	6620	0	applied	\N	\N	\N	\N	84078	84078	251983
7707	6619	0	applied	\N	\N	\N	\N	84082	84082	251987
7707	6621	2	applied	\N	\N	\N	\N	84084	84084	251989
7712	6624	0	applied	\N	\N	\N	\N	84091	84091	251996
7714	6626	0	applied	\N	\N	\N	\N	84093	84093	251998
7720	6628	0	applied	\N	\N	\N	\N	84099	84099	252004
7726	6633	0	applied	\N	\N	\N	\N	84106	84106	252011
7735	6644	0	applied	\N	\N	\N	\N	84119	84119	252024
7742	6649	0	applied	\N	\N	\N	\N	84144	84144	252049
7749	6654	0	applied	\N	\N	\N	\N	84153	84153	252058
7752	6657	0	applied	\N	\N	\N	\N	84157	84157	252062
7754	6657	0	applied	\N	\N	\N	\N	84159	84159	252064
7756	6658	0	applied	\N	\N	\N	\N	84161	84161	252066
7759	6660	0	applied	\N	\N	\N	\N	84164	84164	252069
7764	6664	0	applied	\N	\N	\N	\N	84171	84171	252076
7779	6675	0	applied	\N	\N	\N	\N	84189	84189	252094
7791	6687	0	applied	\N	\N	\N	\N	84206	84206	252111
7793	6688	0	applied	\N	\N	\N	\N	84208	84208	252113
7800	6693	0	applied	\N	\N	\N	\N	84216	84216	252121
7802	6693	0	applied	\N	\N	\N	\N	84218	84218	252123
7805	6695	0	applied	\N	\N	\N	\N	84221	84221	252126
7807	6696	0	applied	\N	\N	\N	\N	84223	84223	252128
7810	6698	1	applied	\N	\N	\N	\N	84227	84227	252132
7813	6699	0	applied	\N	\N	\N	\N	84231	84231	252136
7815	6700	0	applied	\N	\N	\N	\N	84233	84233	252138
7817	6701	0	applied	\N	\N	\N	\N	84235	84235	252140
7819	6702	0	applied	\N	\N	\N	\N	84236	84236	252141
7819	6703	1	applied	\N	\N	\N	\N	84237	84237	252142
7819	6704	2	applied	\N	\N	\N	\N	84238	84238	252143
7819	6705	3	applied	\N	\N	\N	\N	84239	84239	252144
7820	6702	0	applied	\N	\N	\N	\N	84240	84240	252145
7820	6703	1	applied	\N	\N	\N	\N	84241	84241	252146
7820	6704	2	applied	\N	\N	\N	\N	84242	84242	252147
7820	6705	3	applied	\N	\N	\N	\N	84243	84243	252148
7825	6709	0	applied	\N	\N	\N	\N	84250	84250	252155
7826	6710	0	applied	\N	\N	\N	\N	84251	84251	252156
7829	6712	0	applied	\N	\N	\N	\N	84254	84254	252159
7831	6712	0	applied	\N	\N	\N	\N	84256	84256	252161
7833	6713	0	applied	\N	\N	\N	\N	84258	84258	252163
7835	6714	0	applied	\N	\N	\N	\N	84260	84260	252165
7837	6714	0	applied	\N	\N	\N	\N	84262	84262	252167
7841	6716	0	applied	\N	\N	1000000000	\N	84265	84265	252170
7841	6717	1	applied	\N	\N	\N	\N	84266	84266	252171
7841	6718	2	applied	\N	\N	\N	\N	84267	84267	252172
7841	6719	3	applied	\N	\N	\N	\N	84268	84268	252173
7841	6720	4	applied	\N	\N	\N	\N	84269	84269	252174
7841	6721	5	applied	\N	\N	\N	\N	84270	84270	252175
7843	6722	0	applied	\N	\N	\N	\N	84277	84277	252182
7846	6725	0	applied	\N	\N	\N	\N	84282	84282	252187
7848	6725	0	applied	\N	\N	\N	\N	84284	84284	252189
7854	6733	0	applied	\N	\N	\N	\N	84293	84293	252198
7855	6733	0	applied	\N	\N	\N	\N	84294	84294	252199
7856	6734	0	applied	\N	\N	\N	\N	84295	84295	252200
7858	6735	0	applied	\N	\N	\N	\N	84297	84297	252202
7860	6736	0	applied	\N	\N	\N	\N	84299	84299	252204
7861	6737	0	applied	\N	\N	\N	\N	84300	84300	252205
7862	6737	0	applied	\N	\N	\N	\N	84301	84301	252206
7865	6737	0	applied	\N	\N	\N	\N	84303	84303	252208
7867	6738	0	applied	\N	\N	\N	\N	84320	84320	252224
7869	6740	0	applied	\N	\N	\N	\N	84322	84322	252226
7869	6741	1	applied	\N	\N	\N	\N	84323	84323	252227
7871	6740	0	applied	\N	\N	\N	\N	84326	84326	252230
7871	6741	1	applied	\N	\N	\N	\N	84327	84327	252231
7872	6740	0	applied	\N	\N	\N	\N	84328	84328	252232
7872	6741	1	applied	\N	\N	\N	\N	84329	84329	252233
7873	6742	0	applied	\N	\N	\N	\N	84330	84330	252234
7876	6743	0	applied	\N	\N	\N	\N	84334	84334	252238
7876	6744	1	applied	\N	\N	\N	\N	84335	84335	252239
7878	6745	0	applied	\N	\N	\N	\N	84338	84338	252242
7878	6746	1	applied	\N	\N	\N	\N	84339	84339	252243
7878	6747	2	applied	\N	\N	1000000000	\N	84340	84340	252244
7880	6748	0	applied	\N	\N	\N	\N	84342	84342	252246
7882	6749	0	applied	\N	\N	\N	\N	84344	84344	252248
7882	6750	1	applied	\N	\N	\N	\N	84345	84345	252249
7883	6751	0	applied	\N	\N	\N	\N	84346	84346	252250
7884	6751	0	applied	\N	\N	\N	\N	84347	84347	252251
7888	6754	0	applied	\N	\N	\N	\N	84351	84351	252255
7889	6755	0	applied	\N	\N	\N	\N	84352	84352	252256
7891	6756	0	applied	\N	\N	\N	\N	84354	84354	252258
7893	6756	0	applied	\N	\N	\N	\N	84356	84356	252260
7896	6758	0	applied	\N	\N	\N	\N	84359	84359	252263
7907	6764	0	applied	\N	\N	\N	\N	84377	84377	252281
7915	6771	0	applied	\N	\N	\N	\N	84387	84387	252291
7918	6773	0	applied	\N	\N	\N	\N	84390	84390	252294
7918	6774	1	applied	\N	\N	\N	\N	84391	84391	252295
7918	6775	2	applied	\N	\N	\N	\N	84392	84392	252296
7633	6550	0	applied	\N	\N	\N	\N	83902	83902	251807
7636	6552	0	applied	\N	\N	\N	\N	83905	83905	251810
7642	6555	1	applied	\N	\N	\N	\N	83920	83920	251825
7642	6556	2	applied	\N	\N	1000000000	\N	83921	83921	251826
7642	6557	3	applied	\N	\N	\N	\N	83922	83922	251827
7642	6558	4	applied	\N	\N	\N	\N	83923	83923	251828
7642	6559	5	applied	\N	\N	\N	\N	83924	83924	251829
7642	6560	6	applied	\N	\N	\N	\N	83925	83925	251830
7642	6561	7	applied	\N	\N	\N	\N	83926	83926	251831
7642	6562	8	applied	\N	\N	\N	\N	83927	83927	251832
7645	6563	0	applied	\N	\N	\N	\N	83980	83980	251885
7651	6563	0	applied	\N	\N	\N	\N	83988	83988	251893
7651	6564	1	applied	\N	\N	\N	\N	83989	83989	251894
7651	6565	2	applied	\N	\N	\N	\N	83990	83990	251895
7651	6566	3	applied	\N	\N	\N	\N	83991	83991	251896
7651	6568	5	applied	\N	\N	\N	\N	83993	83993	251898
7651	6569	6	applied	\N	\N	\N	\N	83994	83994	251899
7651	6570	7	applied	\N	\N	\N	\N	83995	83995	251900
7654	6572	0	applied	\N	\N	\N	\N	84001	84001	251906
7654	6573	1	applied	\N	\N	\N	\N	84002	84002	251907
7657	6576	0	applied	\N	\N	\N	\N	84006	84006	251911
7666	6586	0	applied	\N	\N	\N	\N	84020	84020	251925
7666	6587	1	applied	\N	\N	\N	\N	84021	84021	251926
7669	6586	0	applied	\N	\N	\N	\N	84026	84026	251931
7669	6587	1	applied	\N	\N	\N	\N	84027	84027	251932
7673	6590	0	applied	\N	\N	\N	\N	84031	84031	251936
7679	6601	0	applied	\N	\N	\N	\N	84047	84047	251952
7684	6602	0	applied	\N	\N	\N	\N	84053	84053	251958
7684	6603	1	applied	\N	\N	\N	\N	84054	84054	251959
7684	6604	2	applied	\N	\N	\N	\N	84055	84055	251960
7686	6607	0	applied	\N	\N	\N	\N	84058	84058	251963
7689	6610	1	applied	\N	\N	\N	\N	84062	84062	251967
7689	6611	2	applied	\N	\N	\N	\N	84063	84063	251968
7692	6613	0	applied	\N	\N	\N	\N	84065	84065	251970
7694	6616	0	applied	\N	\N	\N	\N	84069	84069	251974
7699	6618	0	applied	\N	\N	\N	\N	84074	84074	251979
7701	6619	0	applied	\N	\N	\N	\N	84076	84076	251981
7704	6620	0	applied	\N	\N	\N	\N	84079	84079	251984
7708	6622	0	applied	\N	\N	\N	\N	84085	84085	251990
7708	6623	1	applied	\N	\N	\N	\N	84086	84086	251991
7710	6624	0	applied	\N	\N	\N	\N	84089	84089	251994
7715	6626	0	applied	\N	\N	\N	\N	84094	84094	251999
7717	6628	0	applied	\N	\N	\N	\N	84096	84096	252001
7721	6628	0	applied	\N	\N	\N	\N	84100	84100	252005
7724	6630	0	applied	\N	\N	\N	\N	84103	84103	252008
7724	6631	1	applied	\N	\N	\N	\N	84104	84104	252009
7727	6634	0	applied	\N	\N	\N	\N	84107	84107	252012
7732	6640	0	applied	\N	\N	\N	\N	84114	84114	252019
7736	6626	0	applied	\N	\N	\N	\N	84120	84120	252025
7736	6627	1	applied	\N	\N	\N	\N	84121	84121	252026
7736	6628	2	applied	\N	\N	\N	\N	84122	84122	252027
7736	6629	3	applied	\N	\N	\N	\N	84123	84123	252028
7736	6630	4	applied	\N	\N	\N	\N	84124	84124	252029
7736	6631	5	applied	\N	\N	\N	\N	84125	84125	252030
7736	6632	6	applied	\N	\N	\N	\N	84126	84126	252031
7736	6633	7	applied	\N	\N	\N	\N	84127	84127	252032
7736	6634	8	applied	\N	\N	\N	\N	84128	84128	252033
7736	6635	9	applied	\N	\N	\N	\N	84129	84129	252034
7736	6636	10	applied	\N	\N	1000000000	\N	84130	84130	252035
7736	6637	11	applied	\N	\N	\N	\N	84131	84131	252036
7736	6638	12	applied	\N	\N	\N	\N	84132	84132	252037
7736	6639	13	applied	\N	\N	\N	\N	84133	84133	252038
7736	6640	14	applied	\N	\N	\N	\N	84134	84134	252039
7736	6642	16	applied	\N	\N	\N	\N	84136	84136	252041
7736	6643	17	applied	\N	\N	\N	\N	84137	84137	252042
7736	6644	18	applied	\N	\N	\N	\N	84138	84138	252043
7737	6645	0	applied	\N	\N	\N	\N	84139	84139	252044
7740	6648	0	applied	\N	\N	\N	\N	84142	84142	252047
7745	6650	0	applied	\N	\N	\N	\N	84145	84145	252050
7745	6651	1	applied	\N	\N	\N	\N	84146	84146	252051
7745	6652	2	applied	\N	\N	\N	\N	84147	84147	252052
7747	6653	0	applied	\N	\N	\N	\N	84151	84151	252056
7895	6757	0	applied	\N	\N	\N	\N	84358	84358	252262
7898	6758	0	applied	\N	\N	\N	\N	84361	84361	252265
7900	6759	0	applied	\N	\N	\N	\N	84364	84364	252268
7900	6760	1	applied	\N	\N	\N	\N	84365	84365	252269
7904	6761	0	applied	\N	\N	\N	\N	84372	84372	252276
7904	6762	1	applied	\N	\N	\N	\N	84373	84373	252277
7906	6763	0	applied	\N	\N	\N	\N	84376	84376	252280
7911	6767	0	applied	\N	\N	\N	\N	84381	84381	252285
7914	6769	0	applied	\N	\N	\N	\N	84385	84385	252289
7914	6770	1	applied	\N	\N	\N	\N	84386	84386	252290
7916	6772	0	applied	\N	\N	\N	\N	84388	84388	252292
7922	6778	0	applied	\N	\N	\N	\N	84400	84400	252304
7922	6779	1	applied	\N	\N	\N	\N	84401	84401	252305
7925	6783	0	applied	\N	\N	\N	\N	84406	84406	252310
7930	6787	0	applied	\N	\N	\N	\N	84413	84413	252317
7933	6784	0	applied	\N	\N	\N	\N	84540	84540	252444
7933	6785	1	applied	\N	\N	\N	\N	84541	84541	252445
7933	6786	2	applied	\N	\N	\N	\N	84542	84542	252446
7933	6787	3	applied	\N	\N	\N	\N	84543	84543	252447
7934	6788	0	applied	\N	\N	\N	\N	84544	84544	252448
7942	6791	0	applied	\N	\N	\N	\N	84552	84552	252456
7943	6792	0	applied	\N	\N	\N	\N	84553	84553	252457
7947	6793	0	applied	\N	\N	\N	\N	84557	84557	252461
7954	6797	0	applied	\N	\N	\N	\N	84564	84564	252468
7957	6801	0	applied	\N	\N	\N	\N	84568	84568	252472
7963	6808	0	applied	\N	\N	\N	\N	84608	84608	252512
7972	6814	0	applied	\N	\N	\N	\N	84621	84621	252525
7976	6821	0	applied	\N	\N	\N	\N	84628	84628	252532
7978	6822	0	applied	\N	\N	\N	\N	84630	84630	252534
7981	6823	0	applied	\N	\N	\N	\N	84635	84635	252539
7981	6824	1	applied	\N	\N	\N	\N	84636	84636	252540
7981	6825	2	applied	\N	\N	\N	\N	84637	84637	252541
7983	6826	0	applied	\N	\N	\N	\N	84641	84641	252545
7987	6836	0	applied	\N	\N	\N	\N	84651	84651	252555
7987	6837	1	applied	\N	\N	\N	\N	84652	84652	252556
7987	6838	2	applied	\N	\N	\N	\N	84653	84653	252557
7990	6839	0	applied	\N	\N	\N	\N	84659	84659	252563
7990	6840	1	applied	\N	\N	\N	\N	84660	84660	252564
7992	6842	0	applied	\N	\N	\N	\N	84662	84662	252566
7634	6551	0	applied	\N	\N	\N	\N	83903	83903	251808
7642	6554	0	applied	\N	\N	\N	\N	83919	83919	251824
7755	6657	0	applied	\N	\N	\N	\N	84160	84160	252065
7757	6659	0	applied	\N	\N	\N	\N	84162	84162	252067
7767	6665	0	applied	\N	\N	\N	\N	84173	84173	252078
7767	6666	1	applied	\N	\N	\N	\N	84174	84174	252079
7767	6667	2	applied	\N	\N	\N	\N	84175	84175	252080
7770	6672	0	applied	\N	\N	\N	\N	84180	84180	252085
7774	6673	0	applied	\N	\N	\N	\N	84184	84184	252089
7781	6676	0	applied	\N	\N	\N	\N	84190	84190	252095
7783	6677	0	applied	\N	\N	\N	\N	84192	84192	252097
7786	6681	1	applied	\N	\N	\N	\N	84198	84198	252103
7786	6682	2	applied	\N	\N	\N	\N	84199	84199	252104
7794	6688	0	applied	\N	\N	\N	\N	84209	84209	252114
7798	6690	0	applied	\N	\N	\N	\N	84213	84213	252118
7801	6693	0	applied	\N	\N	\N	\N	84217	84217	252122
7808	6696	0	applied	\N	\N	\N	\N	84224	84224	252129
7812	6699	0	applied	\N	\N	\N	\N	84230	84230	252135
7814	6700	0	applied	\N	\N	\N	\N	84232	84232	252137
7822	6706	0	applied	\N	\N	\N	\N	84246	84246	252151
7822	6707	1	applied	\N	\N	\N	\N	84247	84247	252152
7827	6710	0	applied	\N	\N	\N	\N	84252	84252	252157
7828	6711	0	applied	\N	\N	\N	\N	84253	84253	252158
7830	6712	0	applied	\N	\N	\N	\N	84255	84255	252160
7832	6712	0	applied	\N	\N	\N	\N	84257	84257	252162
7834	6714	0	applied	\N	\N	\N	\N	84259	84259	252164
7836	6714	0	applied	\N	\N	\N	\N	84261	84261	252166
7839	6715	0	applied	\N	\N	\N	\N	84264	84264	252169
7842	6716	0	applied	\N	\N	1000000000	\N	84271	84271	252176
7842	6717	1	applied	\N	\N	\N	\N	84272	84272	252177
7842	6718	2	applied	\N	\N	\N	\N	84273	84273	252178
7842	6719	3	applied	\N	\N	\N	\N	84274	84274	252179
7842	6720	4	applied	\N	\N	\N	\N	84275	84275	252180
7842	6721	5	applied	\N	\N	\N	\N	84276	84276	252181
7844	6723	0	applied	\N	\N	\N	\N	84278	84278	252183
7844	6724	1	applied	\N	\N	\N	\N	84279	84279	252184
7845	6723	0	applied	\N	\N	\N	\N	84280	84280	252185
7845	6724	1	applied	\N	\N	\N	\N	84281	84281	252186
7847	6725	0	applied	\N	\N	\N	\N	84283	84283	252188
7849	6726	0	applied	\N	\N	\N	\N	84285	84285	252190
7849	6727	1	applied	\N	\N	\N	\N	84286	84286	252191
7850	6728	0	applied	\N	\N	\N	\N	84287	84287	252192
7852	6729	0	applied	\N	\N	\N	\N	84289	84289	252194
7852	6731	2	applied	\N	\N	\N	\N	84291	84291	252196
7853	6732	0	applied	\N	\N	\N	\N	84292	84292	252197
7857	6735	0	applied	\N	\N	\N	\N	84296	84296	252201
7863	6737	0	applied	\N	\N	\N	\N	84302	84302	252207
7866	6583	0	applied	\N	\N	\N	\N	84304	84304	252209
7866	6584	1	applied	\N	\N	\N	\N	84305	84305	252210
7866	6614	2	applied	\N	\N	\N	\N	84306	84306	252211
7866	6585	3	applied	\N	\N	\N	\N	84307	84307	252212
7866	6386	5	applied	\N	\N	\N	\N	84309	84309	252213
7866	6290	4	failed	Receiver_not_present	\N	\N	\N	84308	84308	\N
7866	6399	6	applied	\N	\N	\N	\N	84310	84310	252214
7866	6453	7	applied	\N	\N	\N	\N	84311	84311	252215
7866	6353	8	applied	\N	\N	\N	\N	84312	84312	252216
7866	6361	9	applied	\N	\N	1000000000	\N	84313	84313	252217
7866	6682	10	applied	\N	\N	\N	\N	84314	84314	252218
7866	6339	11	applied	\N	\N	\N	\N	84315	84315	252219
7866	6445	13	applied	\N	\N	\N	\N	84317	84317	252221
7866	6452	14	applied	\N	\N	\N	\N	84318	84318	252222
7866	6533	15	applied	\N	\N	\N	\N	84319	84319	252223
7870	6740	0	applied	\N	\N	\N	\N	84324	84324	252228
7870	6741	1	applied	\N	\N	\N	\N	84325	84325	252229
7877	6743	0	applied	\N	\N	\N	\N	84336	84336	252240
7877	6744	1	applied	\N	\N	\N	\N	84337	84337	252241
7879	6748	0	applied	\N	\N	\N	\N	84341	84341	252245
7886	6752	0	applied	\N	\N	\N	\N	84349	84349	252253
7892	6756	0	applied	\N	\N	\N	\N	84355	84355	252259
7902	6761	0	applied	\N	\N	\N	\N	84368	84368	252272
7902	6762	1	applied	\N	\N	\N	\N	84369	84369	252273
7905	6761	0	applied	\N	\N	\N	\N	84374	84374	252278
7905	6762	1	applied	\N	\N	\N	\N	84375	84375	252279
7917	6772	0	applied	\N	\N	\N	\N	84389	84389	252293
7920	6776	0	applied	\N	\N	\N	\N	84396	84396	252300
7923	6780	0	applied	\N	\N	\N	\N	84402	84402	252306
7923	6781	1	applied	\N	\N	\N	\N	84403	84403	252307
7923	6782	2	applied	\N	\N	\N	\N	84404	84404	252308
7928	6786	0	applied	\N	\N	\N	\N	84411	84411	252315
7931	6787	0	applied	\N	\N	\N	\N	84414	84414	252318
7937	6790	0	applied	\N	\N	\N	\N	84547	84547	252451
7939	6791	0	applied	\N	\N	\N	\N	84549	84549	252453
7944	6792	0	applied	\N	\N	\N	\N	84554	84554	252458
7948	6794	0	applied	\N	\N	\N	\N	84558	84558	252462
7950	6794	0	applied	\N	\N	\N	\N	84560	84560	252464
7953	6796	0	applied	\N	\N	\N	\N	84563	84563	252467
7955	6798	0	applied	\N	\N	\N	\N	84565	84565	252469
7958	6801	0	applied	\N	\N	\N	\N	84569	84569	252473
7960	6801	0	applied	\N	\N	\N	\N	84601	84601	252505
7973	6815	0	applied	\N	\N	\N	\N	84622	84622	252526
7977	6821	0	applied	\N	\N	\N	\N	84629	84629	252533
7982	6824	1	applied	\N	\N	\N	\N	84639	84639	252543
7982	6825	2	applied	\N	\N	\N	\N	84640	84640	252544
7984	6827	0	applied	\N	\N	\N	\N	84642	84642	252546
7984	6828	1	applied	\N	\N	\N	\N	84643	84643	252547
7984	6829	2	applied	\N	\N	\N	\N	84644	84644	252548
7993	6843	0	applied	\N	\N	\N	\N	84663	84663	252567
7993	6844	1	applied	\N	\N	\N	\N	84664	84664	252568
7996	6847	0	applied	\N	\N	\N	\N	84669	84669	252573
8007	6850	0	applied	\N	\N	\N	\N	84680	84680	252584
8007	6851	1	applied	\N	\N	\N	\N	84681	84681	252585
8012	6854	0	applied	\N	\N	\N	\N	84685	84685	252589
8012	6855	1	applied	\N	\N	\N	\N	84686	84686	252590
8015	6854	0	applied	\N	\N	\N	\N	84691	84691	252595
8015	6855	1	applied	\N	\N	\N	\N	84692	84692	252596
8017	6859	0	applied	\N	\N	\N	\N	84696	84696	252600
8020	6862	0	applied	\N	\N	\N	\N	84699	84699	252603
8026	6867	0	applied	\N	\N	\N	\N	84710	84710	252614
8026	6868	1	applied	\N	\N	\N	\N	84711	84711	252615
8028	6869	0	applied	\N	\N	\N	\N	84713	84713	252617
8030	6870	0	applied	\N	\N	\N	\N	84715	84715	252619
7750	6656	1	applied	\N	\N	\N	\N	84155	84155	252060
7753	6657	0	applied	\N	\N	\N	\N	84158	84158	252063
7875	6744	1	applied	\N	\N	\N	\N	84333	84333	252237
7881	6748	0	applied	\N	\N	\N	\N	84343	84343	252247
7885	6751	0	applied	\N	\N	\N	\N	84348	84348	252252
7887	6753	0	applied	\N	\N	\N	\N	84350	84350	252254
7890	6756	0	applied	\N	\N	\N	\N	84353	84353	252257
7897	6758	0	applied	\N	\N	\N	\N	84360	84360	252264
7899	6759	0	applied	\N	\N	\N	\N	84362	84362	252266
7899	6760	1	applied	\N	\N	\N	\N	84363	84363	252267
7901	6759	0	applied	\N	\N	\N	\N	84366	84366	252270
7901	6760	1	applied	\N	\N	\N	\N	84367	84367	252271
7903	6761	0	applied	\N	\N	\N	\N	84370	84370	252274
7903	6762	1	applied	\N	\N	\N	\N	84371	84371	252275
7908	6765	0	applied	\N	\N	\N	\N	84378	84378	252282
7910	6766	0	applied	\N	\N	\N	\N	84380	84380	252284
7913	6769	0	applied	\N	\N	\N	\N	84383	84383	252287
7913	6770	1	applied	\N	\N	\N	\N	84384	84384	252288
7919	6773	0	applied	\N	\N	\N	\N	84393	84393	252297
7919	6774	1	applied	\N	\N	\N	\N	84394	84394	252298
7919	6775	2	applied	\N	\N	\N	\N	84395	84395	252299
7924	6783	0	applied	\N	\N	\N	\N	84405	84405	252309
7927	6784	0	applied	\N	\N	\N	\N	84409	84409	252313
7929	6787	0	applied	\N	\N	\N	\N	84412	84412	252316
7932	6645	0	applied	\N	\N	\N	\N	84415	84415	252319
7932	6646	1	applied	\N	\N	\N	\N	84416	84416	252320
7932	6716	2	applied	\N	\N	1000000000	\N	84417	84417	252321
7932	6647	3	applied	\N	\N	\N	\N	84418	84418	252322
7932	6682	4	applied	\N	\N	\N	\N	84419	84419	252323
7932	6648	5	applied	\N	\N	\N	\N	84420	84420	252324
7932	6649	6	applied	\N	\N	\N	\N	84421	84421	252325
7932	6650	7	applied	\N	\N	\N	\N	84422	84422	252326
7932	6651	8	applied	\N	\N	\N	\N	84423	84423	252327
7932	6652	9	applied	\N	\N	\N	\N	84424	84424	252328
7932	6653	10	applied	\N	\N	\N	\N	84425	84425	252329
7932	6654	11	applied	\N	\N	\N	\N	84426	84426	252330
7932	6655	12	applied	\N	\N	\N	\N	84427	84427	252331
7932	6656	13	applied	\N	\N	\N	\N	84428	84428	252332
7932	6657	14	applied	\N	\N	\N	\N	84429	84429	252333
7932	6659	16	applied	\N	\N	\N	\N	84431	84431	252335
7932	6660	17	applied	\N	\N	\N	\N	84432	84432	252336
7932	6661	18	applied	\N	\N	\N	\N	84433	84433	252337
7932	6662	19	applied	\N	\N	\N	\N	84434	84434	252338
7932	6663	20	applied	\N	\N	\N	\N	84435	84435	252339
7932	6664	21	applied	\N	\N	\N	\N	84436	84436	252340
7932	6665	22	applied	\N	\N	\N	\N	84437	84437	252341
7932	6666	23	applied	\N	\N	\N	\N	84438	84438	252342
7932	6667	24	applied	\N	\N	\N	\N	84439	84439	252343
7932	6668	25	applied	\N	\N	\N	\N	84440	84440	252344
7932	6669	26	applied	\N	\N	\N	\N	84441	84441	252345
7932	6670	27	applied	\N	\N	\N	\N	84442	84442	252346
7932	6671	28	applied	\N	\N	\N	\N	84443	84443	252347
7932	6672	29	applied	\N	\N	\N	\N	84444	84444	252348
7932	6673	30	applied	\N	\N	\N	\N	84445	84445	252349
7932	6674	31	applied	\N	\N	\N	\N	84446	84446	252350
7932	6676	33	applied	\N	\N	\N	\N	84448	84448	252352
7932	6677	34	applied	\N	\N	\N	\N	84449	84449	252353
7932	6678	35	applied	\N	\N	\N	\N	84450	84450	252354
7932	6679	36	applied	\N	\N	\N	\N	84451	84451	252355
7932	6680	38	applied	\N	\N	\N	\N	84452	84452	252356
7932	6681	39	applied	\N	\N	\N	\N	84453	84453	252357
7932	6683	40	applied	\N	\N	\N	\N	84454	84454	252358
7932	6684	41	applied	\N	\N	\N	\N	84455	84455	252359
7932	6685	42	applied	\N	\N	1000000000	\N	84456	84456	252360
7932	6686	43	applied	\N	\N	1000000000	\N	84457	84457	252361
7932	6687	44	applied	\N	\N	\N	\N	84458	84458	252362
7932	6688	45	applied	\N	\N	\N	\N	84459	84459	252363
7932	6689	46	applied	\N	\N	\N	\N	84460	84460	252364
7932	6690	47	applied	\N	\N	\N	\N	84461	84461	252365
7932	6691	48	applied	\N	\N	\N	\N	84462	84462	252366
7932	6692	49	applied	\N	\N	\N	\N	84463	84463	252367
8030	6871	1	applied	\N	\N	\N	\N	84716	84716	252620
8030	6872	2	applied	\N	\N	\N	\N	84717	84717	252621
8037	6883	0	applied	\N	\N	\N	\N	84758	84758	252662
8046	6886	0	applied	\N	\N	\N	\N	84767	84767	252671
8049	6887	0	applied	\N	\N	\N	\N	84770	84770	252674
8051	6888	0	applied	\N	\N	\N	\N	84772	84772	252676
8051	6889	1	applied	\N	\N	\N	\N	84773	84773	252677
8051	6890	2	applied	\N	\N	\N	\N	84774	84774	252678
8054	6891	0	applied	\N	\N	\N	\N	84779	84779	252683
8056	6893	0	applied	\N	\N	\N	\N	84781	84781	252685
8059	6895	0	applied	\N	\N	\N	\N	84785	84785	252689
8059	6896	1	applied	\N	\N	\N	\N	84786	84786	252690
8061	6897	0	applied	\N	\N	\N	\N	84789	84789	252693
8066	6901	0	applied	\N	\N	\N	\N	84797	84797	252701
8066	6902	1	applied	\N	\N	\N	\N	84798	84798	252702
8071	6906	0	applied	\N	\N	\N	\N	84804	84804	252708
8074	6910	0	applied	\N	\N	\N	\N	84810	84810	252714
8074	6911	1	applied	\N	\N	\N	\N	84811	84811	252715
8074	6912	2	applied	\N	\N	\N	\N	84812	84812	252716
8074	6913	3	applied	\N	\N	1000000000	\N	84813	84813	252717
8079	6916	0	applied	\N	\N	\N	\N	84822	84822	252726
8081	6919	0	applied	\N	\N	\N	\N	84825	84825	252729
8081	6920	1	applied	\N	\N	\N	\N	84826	84826	252730
8081	6921	2	applied	\N	\N	1000000000	\N	84827	84827	252731
8084	6926	0	applied	\N	\N	\N	\N	84833	84833	252737
8086	6927	0	applied	\N	\N	\N	\N	84835	84835	252739
8086	6928	1	applied	\N	\N	\N	\N	84836	84836	252740
8089	6930	0	applied	\N	\N	\N	\N	84839	84839	252743
8093	6931	0	applied	\N	\N	\N	\N	84843	84843	252747
8095	6932	0	applied	\N	\N	\N	\N	84845	84845	252749
8095	6933	1	applied	\N	\N	\N	\N	84846	84846	252750
8099	6934	0	applied	\N	\N	\N	\N	84853	84853	252757
8104	6937	0	applied	\N	\N	1000000000	\N	84864	84864	252768
8104	6938	1	applied	\N	\N	\N	\N	84865	84865	252769
8104	6939	2	applied	\N	\N	\N	\N	84866	84866	252770
8104	6940	3	applied	\N	\N	\N	\N	84867	84867	252771
8107	6942	0	applied	\N	\N	\N	\N	84870	84870	252774
8109	6944	0	applied	\N	\N	\N	\N	84872	84872	252776
8112	6947	0	applied	\N	\N	\N	\N	84876	84876	252780
8116	6955	0	applied	\N	\N	\N	\N	84886	84886	252790
7868	6739	0	applied	\N	\N	\N	\N	84321	84321	252225
7875	6743	0	applied	\N	\N	\N	\N	84332	84332	252236
7932	6694	51	applied	\N	\N	\N	\N	84465	84465	252369
7932	6695	52	applied	\N	\N	\N	\N	84466	84466	252370
7932	6696	53	applied	\N	\N	\N	\N	84467	84467	252371
7932	6697	54	applied	\N	\N	\N	\N	84468	84468	252372
7932	6698	55	applied	\N	\N	\N	\N	84469	84469	252373
7932	6699	56	applied	\N	\N	\N	\N	84470	84470	252374
7932	6700	57	applied	\N	\N	\N	\N	84471	84471	252375
7932	6701	58	applied	\N	\N	\N	\N	84472	84472	252376
7932	6702	59	applied	\N	\N	\N	\N	84473	84473	252377
7932	6703	60	applied	\N	\N	\N	\N	84474	84474	252378
7932	6704	61	applied	\N	\N	\N	\N	84475	84475	252379
7932	6705	62	applied	\N	\N	\N	\N	84476	84476	252380
7932	6706	63	applied	\N	\N	\N	\N	84477	84477	252381
7932	6707	64	applied	\N	\N	\N	\N	84478	84478	252382
7932	6709	66	applied	\N	\N	\N	\N	84480	84480	252384
7932	6710	67	applied	\N	\N	\N	\N	84481	84481	252385
7932	6711	68	applied	\N	\N	\N	\N	84482	84482	252386
7932	6712	69	applied	\N	\N	\N	\N	84483	84483	252387
7932	6713	70	applied	\N	\N	\N	\N	84484	84484	252388
7932	6714	71	applied	\N	\N	\N	\N	84485	84485	252389
7932	6715	72	applied	\N	\N	\N	\N	84486	84486	252390
7932	6717	73	applied	\N	\N	\N	\N	84487	84487	252391
7932	6718	74	applied	\N	\N	\N	\N	84488	84488	252392
7932	6719	75	applied	\N	\N	\N	\N	84489	84489	252393
7932	6720	76	applied	\N	\N	\N	\N	84490	84490	252394
7932	6721	77	applied	\N	\N	\N	\N	84491	84491	252395
7932	6722	78	applied	\N	\N	\N	\N	84492	84492	252396
7932	6723	79	applied	\N	\N	\N	\N	84493	84493	252397
7932	6724	80	applied	\N	\N	\N	\N	84494	84494	252398
7932	6725	81	applied	\N	\N	\N	\N	84495	84495	252399
7932	6727	83	applied	\N	\N	\N	\N	84497	84497	252401
7932	6728	84	applied	\N	\N	\N	\N	84498	84498	252402
7932	6729	85	applied	\N	\N	\N	\N	84499	84499	252403
7932	6730	86	applied	\N	\N	\N	\N	84500	84500	252404
7932	6731	87	applied	\N	\N	\N	\N	84501	84501	252405
7932	6732	88	applied	\N	\N	\N	\N	84502	84502	252406
7932	6733	89	applied	\N	\N	\N	\N	84503	84503	252407
7932	6734	90	applied	\N	\N	\N	\N	84504	84504	252408
7932	6735	91	applied	\N	\N	\N	\N	84505	84505	252409
7932	6736	92	applied	\N	\N	\N	\N	84506	84506	252410
7935	6789	0	applied	\N	\N	\N	\N	84545	84545	252449
7938	6790	0	applied	\N	\N	\N	\N	84548	84548	252452
7940	6791	0	applied	\N	\N	\N	\N	84550	84550	252454
7945	6792	0	applied	\N	\N	\N	\N	84555	84555	252459
7956	6799	0	applied	\N	\N	\N	\N	84566	84566	252470
7956	6800	1	applied	\N	\N	\N	\N	84567	84567	252471
7959	6773	1	applied	\N	\N	\N	\N	84571	84571	252475
7959	6774	2	applied	\N	\N	\N	\N	84572	84572	252476
7959	6775	3	applied	\N	\N	\N	\N	84573	84573	252477
7959	6776	4	applied	\N	\N	\N	\N	84574	84574	252478
7959	6777	5	applied	\N	\N	\N	\N	84575	84575	252479
7959	6778	6	applied	\N	\N	\N	\N	84576	84576	252480
7959	6779	7	applied	\N	\N	\N	\N	84577	84577	252481
7959	6780	8	applied	\N	\N	\N	\N	84578	84578	252482
7959	6781	9	applied	\N	\N	\N	\N	84579	84579	252483
7959	6783	10	applied	\N	\N	\N	\N	84580	84580	252484
7959	6784	11	applied	\N	\N	\N	\N	84581	84581	252485
7959	6785	12	applied	\N	\N	\N	\N	84582	84582	252486
7959	6786	13	applied	\N	\N	\N	\N	84583	84583	252487
7959	6787	14	applied	\N	\N	\N	\N	84584	84584	252488
7959	6788	15	applied	\N	\N	\N	\N	84585	84585	252489
7959	6789	16	applied	\N	\N	\N	\N	84586	84586	252490
7959	6791	18	applied	\N	\N	\N	\N	84588	84588	252492
7959	6792	19	applied	\N	\N	\N	\N	84589	84589	252493
7959	6793	20	applied	\N	\N	\N	\N	84590	84590	252494
7959	6794	21	applied	\N	\N	\N	\N	84591	84591	252495
7959	6795	22	applied	\N	\N	\N	\N	84592	84592	252496
7959	6796	23	applied	\N	\N	\N	\N	84593	84593	252497
7959	6797	24	applied	\N	\N	\N	\N	84594	84594	252498
7959	6798	25	applied	\N	\N	\N	\N	84595	84595	252499
7959	6799	26	applied	\N	\N	\N	\N	84596	84596	252500
7959	6800	27	applied	\N	\N	\N	\N	84597	84597	252501
7959	6801	28	applied	\N	\N	\N	\N	84598	84598	252502
7959	6747	29	applied	\N	\N	1000000000	\N	84599	84599	252503
7959	6782	30	applied	\N	\N	\N	\N	84600	84600	252504
7961	6802	0	applied	\N	\N	\N	\N	84602	84602	252506
7961	6803	1	applied	\N	\N	\N	\N	84603	84603	252507
7961	6804	2	applied	\N	\N	\N	\N	84604	84604	252508
7969	6809	0	applied	\N	\N	\N	\N	84610	84610	252514
7969	6810	1	applied	\N	\N	\N	\N	84611	84611	252515
7969	6811	2	applied	\N	\N	\N	\N	84612	84612	252516
7969	6812	3	applied	\N	\N	\N	\N	84613	84613	252517
7969	6813	4	applied	\N	\N	\N	\N	84614	84614	252518
7971	6809	0	applied	\N	\N	\N	\N	84616	84616	252520
7971	6810	1	applied	\N	\N	\N	\N	84617	84617	252521
7971	6811	2	applied	\N	\N	\N	\N	84618	84618	252522
7971	6812	3	applied	\N	\N	\N	\N	84619	84619	252523
7971	6813	4	applied	\N	\N	\N	\N	84620	84620	252524
7974	6816	0	applied	\N	\N	\N	\N	84623	84623	252527
7974	6817	1	applied	\N	\N	\N	\N	84624	84624	252528
7979	6822	0	applied	\N	\N	\N	\N	84631	84631	252535
7985	6830	0	applied	\N	\N	\N	\N	84645	84645	252549
7985	6831	1	applied	\N	\N	\N	\N	84646	84646	252550
7985	6832	2	applied	\N	\N	\N	\N	84647	84647	252551
7988	6837	1	applied	\N	\N	\N	\N	84655	84655	252559
7988	6838	2	applied	\N	\N	\N	\N	84656	84656	252560
7991	6841	0	applied	\N	\N	\N	\N	84661	84661	252565
7994	6843	0	applied	\N	\N	\N	\N	84665	84665	252569
7994	6844	1	applied	\N	\N	\N	\N	84666	84666	252570
7997	6847	0	applied	\N	\N	\N	\N	84670	84670	252574
8000	6847	0	applied	\N	\N	\N	\N	84672	84672	252576
8005	6848	0	applied	\N	\N	\N	\N	84676	84676	252580
8005	6849	1	applied	\N	\N	\N	\N	84677	84677	252581
8010	6852	0	applied	\N	\N	\N	\N	84683	84683	252587
8013	6854	0	applied	\N	\N	\N	\N	84687	84687	252591
8013	6855	1	applied	\N	\N	\N	\N	84688	84688	252592
8023	6866	0	applied	\N	\N	\N	\N	84705	84705	252609
8033	6870	0	applied	\N	\N	\N	\N	84721	84721	252625
8033	6871	1	applied	\N	\N	\N	\N	84722	84722	252626
8033	6872	2	applied	\N	\N	\N	\N	84723	84723	252627
7926	6785	1	applied	\N	\N	\N	\N	84408	84408	252312
7932	6740	96	applied	\N	\N	\N	\N	84510	84510	252414
7932	6741	97	applied	\N	\N	\N	\N	84511	84511	252415
7932	6742	98	applied	\N	\N	\N	\N	84512	84512	252416
7932	6744	100	applied	\N	\N	\N	\N	84514	84514	252418
7932	6745	101	applied	\N	\N	\N	\N	84515	84515	252419
7932	6746	102	applied	\N	\N	\N	\N	84516	84516	252420
7932	6748	103	applied	\N	\N	\N	\N	84517	84517	252421
7932	6749	104	applied	\N	\N	\N	\N	84518	84518	252422
7932	6750	105	applied	\N	\N	\N	\N	84519	84519	252423
7932	6751	106	applied	\N	\N	\N	\N	84520	84520	252424
7932	6752	107	applied	\N	\N	\N	\N	84521	84521	252425
7932	6753	108	applied	\N	\N	\N	\N	84522	84522	252426
7932	6754	109	applied	\N	\N	\N	\N	84523	84523	252427
7932	6755	110	applied	\N	\N	\N	\N	84524	84524	252428
7932	6756	111	applied	\N	\N	\N	\N	84525	84525	252429
7932	6757	112	applied	\N	\N	\N	\N	84526	84526	252430
7932	6758	113	applied	\N	\N	\N	\N	84527	84527	252431
7932	6759	114	applied	\N	\N	\N	\N	84528	84528	252432
7932	6760	115	applied	\N	\N	\N	\N	84529	84529	252433
7932	6763	117	applied	\N	\N	\N	\N	84531	84531	252435
7932	6764	118	applied	\N	\N	\N	\N	84532	84532	252436
7932	6765	119	applied	\N	\N	\N	\N	84533	84533	252437
7932	6766	120	applied	\N	\N	\N	\N	84534	84534	252438
7932	6767	121	applied	\N	\N	\N	\N	84535	84535	252439
7932	6768	122	applied	\N	\N	\N	\N	84536	84536	252440
7932	6769	123	applied	\N	\N	\N	\N	84537	84537	252441
7932	6770	124	applied	\N	\N	\N	\N	84538	84538	252442
7932	6771	125	applied	\N	\N	\N	\N	84539	84539	252443
7936	6789	0	applied	\N	\N	\N	\N	84546	84546	252450
7941	6791	0	applied	\N	\N	\N	\N	84551	84551	252455
7946	6792	0	applied	\N	\N	\N	\N	84556	84556	252460
7949	6794	0	applied	\N	\N	\N	\N	84559	84559	252463
7951	6795	0	applied	\N	\N	\N	\N	84561	84561	252465
7962	6805	0	applied	\N	\N	\N	\N	84605	84605	252509
7962	6806	1	applied	\N	\N	\N	\N	84606	84606	252510
7970	6812	0	applied	\N	\N	\N	\N	84615	84615	252519
7975	6818	0	applied	\N	\N	\N	\N	84625	84625	252529
7975	6819	1	applied	\N	\N	\N	\N	84626	84626	252530
7975	6820	2	applied	\N	\N	\N	\N	84627	84627	252531
7980	6823	0	applied	\N	\N	\N	\N	84632	84632	252536
7980	6824	1	applied	\N	\N	\N	\N	84633	84633	252537
7980	6825	2	applied	\N	\N	\N	\N	84634	84634	252538
7986	6833	0	applied	\N	\N	\N	\N	84648	84648	252552
7986	6834	1	applied	\N	\N	\N	\N	84649	84649	252553
7986	6835	2	applied	\N	\N	\N	\N	84650	84650	252554
7989	6839	0	applied	\N	\N	\N	\N	84657	84657	252561
7989	6840	1	applied	\N	\N	\N	\N	84658	84658	252562
7998	6847	0	applied	\N	\N	\N	\N	84671	84671	252575
8001	6847	0	applied	\N	\N	\N	\N	84673	84673	252577
8006	6848	0	applied	\N	\N	\N	\N	84678	84678	252582
8006	6849	1	applied	\N	\N	\N	\N	84679	84679	252583
8014	6855	1	applied	\N	\N	\N	\N	84690	84690	252594
8018	6860	0	applied	\N	\N	\N	\N	84697	84697	252601
8021	6862	0	applied	\N	\N	\N	\N	84701	84701	252605
8021	6863	1	applied	\N	\N	\N	\N	84702	84702	252606
8024	6867	0	applied	\N	\N	\N	\N	84706	84706	252610
8024	6868	1	applied	\N	\N	\N	\N	84707	84707	252611
8032	6870	0	applied	\N	\N	\N	\N	84718	84718	252622
8032	6871	1	applied	\N	\N	\N	\N	84719	84719	252623
8032	6872	2	applied	\N	\N	\N	\N	84720	84720	252624
8033	6873	3	applied	\N	\N	\N	\N	84724	84724	252628
8033	6874	4	applied	\N	\N	\N	\N	84725	84725	252629
8033	6875	5	applied	\N	\N	1000000000	\N	84726	84726	252630
8033	6876	6	applied	\N	\N	1000000000	\N	84727	84727	252631
8033	6877	7	applied	\N	\N	1000000000	\N	84728	84728	252632
8033	6879	9	applied	\N	\N	\N	\N	84730	84730	252634
8033	6880	10	applied	\N	\N	1000000000	\N	84731	84731	252635
8033	6881	11	applied	\N	\N	\N	\N	84732	84732	252636
8036	6882	0	applied	\N	\N	\N	\N	84757	84757	252661
8038	6883	0	applied	\N	\N	\N	\N	84759	84759	252663
8040	6884	0	applied	\N	\N	\N	\N	84761	84761	252665
8042	6885	0	applied	\N	\N	\N	\N	84763	84763	252667
8043	6885	0	applied	\N	\N	\N	\N	84764	84764	252668
8045	6885	0	applied	\N	\N	\N	\N	84766	84766	252670
8047	6886	0	applied	\N	\N	\N	\N	84768	84768	252672
8050	6887	0	applied	\N	\N	\N	\N	84771	84771	252675
8052	6888	0	applied	\N	\N	\N	\N	84775	84775	252679
8052	6889	1	applied	\N	\N	\N	\N	84776	84776	252680
8052	6890	2	applied	\N	\N	\N	\N	84777	84777	252681
8057	6894	0	applied	\N	\N	\N	\N	84782	84782	252686
8060	6895	0	applied	\N	\N	\N	\N	84787	84787	252691
8060	6896	1	applied	\N	\N	\N	\N	84788	84788	252692
8062	6898	0	applied	\N	\N	\N	\N	84790	84790	252694
8062	6899	1	applied	\N	\N	\N	\N	84791	84791	252695
8064	6900	0	applied	\N	\N	\N	\N	84794	84794	252698
8067	6902	1	applied	\N	\N	\N	\N	84800	84800	252704
8069	6903	0	applied	\N	\N	\N	\N	84801	84801	252705
8072	6906	0	applied	\N	\N	\N	\N	84806	84806	252710
8072	6907	1	applied	\N	\N	\N	\N	84807	84807	252711
8075	6910	0	applied	\N	\N	\N	\N	84814	84814	252718
8075	6911	1	applied	\N	\N	\N	\N	84815	84815	252719
8075	6912	2	applied	\N	\N	\N	\N	84816	84816	252720
8075	6913	3	applied	\N	\N	1000000000	\N	84817	84817	252721
8077	6916	0	applied	\N	\N	\N	\N	84820	84820	252724
8078	6916	0	applied	\N	\N	\N	\N	84821	84821	252725
8080	6917	0	applied	\N	\N	\N	\N	84823	84823	252727
8080	6918	1	applied	\N	\N	1000000000	\N	84824	84824	252728
8082	6922	0	applied	\N	\N	\N	\N	84828	84828	252732
8082	6923	1	applied	\N	\N	\N	\N	84829	84829	252733
8082	6924	2	applied	\N	\N	\N	\N	84830	84830	252734
8082	6925	3	applied	\N	\N	\N	\N	84831	84831	252735
8087	6929	0	applied	\N	\N	\N	\N	84837	84837	252741
8090	6930	0	applied	\N	\N	\N	\N	84840	84840	252744
8091	6931	0	applied	\N	\N	\N	\N	84841	84841	252745
8092	6931	0	applied	\N	\N	\N	\N	84842	84842	252746
8094	6931	0	applied	\N	\N	\N	\N	84844	84844	252748
8096	6932	0	applied	\N	\N	\N	\N	84847	84847	252751
8096	6933	1	applied	\N	\N	\N	\N	84848	84848	252752
8100	6934	0	applied	\N	\N	\N	\N	84855	84855	252759
7932	6738	94	applied	\N	\N	\N	\N	84508	84508	252412
7932	6739	95	applied	\N	\N	\N	\N	84509	84509	252413
8011	6853	0	applied	\N	\N	\N	\N	84684	84684	252588
8016	6856	0	applied	\N	\N	\N	\N	84693	84693	252597
8016	6857	1	applied	\N	\N	\N	\N	84694	84694	252598
8016	6858	2	applied	\N	\N	\N	\N	84695	84695	252599
8019	6861	0	applied	\N	\N	\N	\N	84698	84698	252602
8022	6864	0	applied	\N	\N	\N	\N	84703	84703	252607
8022	6865	1	applied	\N	\N	\N	\N	84704	84704	252608
8025	6867	0	applied	\N	\N	\N	\N	84708	84708	252612
8025	6868	1	applied	\N	\N	\N	\N	84709	84709	252613
8027	6869	0	applied	\N	\N	\N	\N	84712	84712	252616
8029	6869	0	applied	\N	\N	\N	\N	84714	84714	252618
8034	6871	1	applied	\N	\N	\N	\N	84734	84734	252638
8034	6872	2	applied	\N	\N	\N	\N	84735	84735	252639
8034	6873	3	applied	\N	\N	\N	\N	84736	84736	252640
8034	6874	4	applied	\N	\N	\N	\N	84737	84737	252641
8034	6875	5	applied	\N	\N	1000000000	\N	84738	84738	252642
8034	6876	6	applied	\N	\N	1000000000	\N	84739	84739	252643
8034	6877	7	applied	\N	\N	1000000000	\N	84740	84740	252644
8034	6878	8	applied	\N	\N	1000000000	\N	84741	84741	252645
8034	6879	9	applied	\N	\N	\N	\N	84742	84742	252646
8034	6880	10	applied	\N	\N	1000000000	\N	84743	84743	252647
8034	6881	11	applied	\N	\N	\N	\N	84744	84744	252648
8035	6870	0	applied	\N	\N	\N	\N	84745	84745	252649
8035	6871	1	applied	\N	\N	\N	\N	84746	84746	252650
8035	6872	2	applied	\N	\N	\N	\N	84747	84747	252651
8035	6873	3	applied	\N	\N	\N	\N	84748	84748	252652
8035	6874	4	applied	\N	\N	\N	\N	84749	84749	252653
8035	6876	6	applied	\N	\N	1000000000	\N	84751	84751	252655
8035	6877	7	applied	\N	\N	1000000000	\N	84752	84752	252656
8035	6878	8	applied	\N	\N	1000000000	\N	84753	84753	252657
8035	6879	9	applied	\N	\N	\N	\N	84754	84754	252658
8035	6880	10	applied	\N	\N	1000000000	\N	84755	84755	252659
8035	6881	11	applied	\N	\N	\N	\N	84756	84756	252660
8039	6884	0	applied	\N	\N	\N	\N	84760	84760	252664
8041	6885	0	applied	\N	\N	\N	\N	84762	84762	252666
8044	6885	0	applied	\N	\N	\N	\N	84765	84765	252669
8048	6887	0	applied	\N	\N	\N	\N	84769	84769	252673
8053	6891	0	applied	\N	\N	\N	\N	84778	84778	252682
8055	6892	0	applied	\N	\N	\N	\N	84780	84780	252684
8058	6895	0	applied	\N	\N	\N	\N	84783	84783	252687
8058	6896	1	applied	\N	\N	\N	\N	84784	84784	252688
8063	6898	0	applied	\N	\N	\N	\N	84792	84792	252696
8063	6899	1	applied	\N	\N	\N	\N	84793	84793	252697
8065	6901	0	applied	\N	\N	\N	\N	84795	84795	252699
8065	6902	1	applied	\N	\N	\N	\N	84796	84796	252700
8070	6905	1	applied	\N	\N	\N	\N	84803	84803	252707
8073	6908	0	applied	\N	\N	\N	\N	84808	84808	252712
8073	6909	1	applied	\N	\N	\N	\N	84809	84809	252713
8076	6914	0	applied	\N	\N	\N	\N	84818	84818	252722
8076	6915	1	applied	\N	\N	\N	\N	84819	84819	252723
8083	6926	0	applied	\N	\N	\N	\N	84832	84832	252736
8088	6930	0	applied	\N	\N	\N	\N	84838	84838	252742
8097	6932	0	applied	\N	\N	\N	\N	84849	84849	252753
8097	6933	1	applied	\N	\N	\N	\N	84850	84850	252754
8098	6932	0	applied	\N	\N	\N	\N	84851	84851	252755
8098	6933	1	applied	\N	\N	\N	\N	84852	84852	252756
8101	6934	0	applied	\N	\N	\N	\N	84857	84857	252761
8103	6937	0	applied	\N	\N	1000000000	\N	84860	84860	252764
8103	6938	1	applied	\N	\N	\N	\N	84861	84861	252765
8103	6939	2	applied	\N	\N	\N	\N	84862	84862	252766
8103	6940	3	applied	\N	\N	\N	\N	84863	84863	252767
8106	6942	0	applied	\N	\N	\N	\N	84869	84869	252773
8108	6943	0	applied	\N	\N	\N	\N	84871	84871	252775
8111	6947	0	applied	\N	\N	\N	\N	84875	84875	252779
8114	6948	0	applied	\N	\N	\N	\N	84878	84878	252782
8114	6949	1	applied	\N	\N	\N	\N	84879	84879	252783
8114	6950	2	applied	\N	\N	\N	\N	84880	84880	252784
8114	6951	3	applied	\N	\N	\N	\N	84881	84881	252785
8114	6952	4	applied	\N	\N	\N	\N	84882	84882	252786
8114	6953	5	applied	\N	\N	\N	\N	84883	84883	252787
8114	6954	6	applied	\N	\N	\N	\N	84884	84884	252788
8115	6955	0	applied	\N	\N	\N	\N	84885	84885	252789
8119	6957	0	applied	\N	\N	\N	\N	84889	84889	252793
8120	6957	0	applied	\N	\N	\N	\N	84890	84890	252794
8122	6958	0	applied	\N	\N	\N	\N	84891	84891	252795
8122	6959	1	applied	\N	\N	\N	\N	84892	84892	252796
8124	6960	0	applied	\N	\N	\N	\N	84895	84895	252799
8124	6959	2	applied	\N	\N	\N	\N	84897	84897	252801
8124	6961	3	applied	\N	\N	\N	\N	84898	84898	252802
8124	6962	4	applied	\N	\N	\N	\N	84899	84899	252803
8127	6964	0	applied	\N	\N	\N	\N	84902	84902	252806
8130	6964	0	applied	\N	\N	\N	\N	84904	84904	252808
8131	6965	0	applied	\N	\N	\N	\N	84905	84905	252809
8134	6968	0	applied	\N	\N	\N	\N	84910	84910	252814
8134	6969	1	applied	\N	\N	\N	\N	84911	84911	252815
8136	6971	0	applied	\N	\N	\N	\N	84913	84913	252817
8137	6972	0	applied	\N	\N	\N	\N	84914	84914	252818
8137	6973	1	applied	\N	\N	\N	\N	84915	84915	252819
8139	6974	0	applied	\N	\N	\N	\N	84916	84916	252820
8139	6975	1	applied	\N	\N	\N	\N	84917	84917	252821
8140	6974	0	applied	\N	\N	\N	\N	84918	84918	252822
8140	6975	1	applied	\N	\N	\N	\N	84919	84919	252823
8142	6976	0	applied	\N	\N	\N	\N	84921	84921	252825
8144	6978	1	applied	\N	\N	\N	\N	84924	84924	252828
8145	6977	0	applied	\N	\N	\N	\N	84925	84925	252829
8145	6978	1	applied	\N	\N	\N	\N	84926	84926	252830
8146	6977	0	applied	\N	\N	\N	\N	84927	84927	252831
8146	6978	1	applied	\N	\N	\N	\N	84928	84928	252832
8147	6977	0	applied	\N	\N	\N	\N	84929	84929	252833
8147	6978	1	applied	\N	\N	\N	\N	84930	84930	252834
8148	6979	0	applied	\N	\N	\N	\N	84931	84931	252835
8149	6960	0	applied	\N	\N	\N	\N	84932	84932	252836
8149	6954	1	applied	\N	\N	\N	\N	84933	84933	252837
8155	6986	0	applied	\N	\N	\N	\N	84988	84988	252892
8160	6988	0	applied	\N	\N	\N	\N	84993	84993	252897
8165	6991	0	applied	\N	\N	\N	\N	85001	85001	252905
8168	6992	0	applied	\N	\N	\N	\N	85005	85005	252909
8168	6993	1	applied	\N	\N	\N	\N	85006	85006	252910
8004	6848	0	applied	\N	\N	\N	\N	84674	84674	252578
8009	6852	0	applied	\N	\N	\N	\N	84682	84682	252586
8110	6945	0	applied	\N	\N	\N	\N	84873	84873	252777
8110	6946	1	applied	\N	\N	\N	\N	84874	84874	252778
8113	6947	0	applied	\N	\N	\N	\N	84877	84877	252781
8117	6955	0	applied	\N	\N	\N	\N	84887	84887	252791
8118	6956	0	applied	\N	\N	\N	\N	84888	84888	252792
8123	6958	0	applied	\N	\N	\N	\N	84893	84893	252797
8123	6959	1	applied	\N	\N	\N	\N	84894	84894	252798
8126	6963	0	applied	\N	\N	\N	\N	84901	84901	252805
8129	6964	0	applied	\N	\N	\N	\N	84903	84903	252807
8133	6968	0	applied	\N	\N	\N	\N	84908	84908	252812
8133	6969	1	applied	\N	\N	\N	\N	84909	84909	252813
8151	6980	0	applied	\N	\N	\N	\N	84938	84938	252842
8151	6981	1	applied	\N	\N	\N	\N	84939	84939	252843
8151	6982	2	applied	\N	\N	1000000000	\N	84940	84940	252844
8151	6983	3	applied	\N	\N	\N	\N	84941	84941	252845
8153	6960	0	applied	\N	\N	\N	\N	84943	84943	252847
8153	6941	1	applied	\N	\N	\N	\N	84944	84944	252848
8153	6942	2	applied	\N	\N	\N	\N	84945	84945	252849
8153	6943	3	applied	\N	\N	\N	\N	84946	84946	252850
8153	6944	4	applied	\N	\N	\N	\N	84947	84947	252851
8153	6945	5	applied	\N	\N	\N	\N	84948	84948	252852
8153	6946	6	applied	\N	\N	\N	\N	84949	84949	252853
8153	6947	7	applied	\N	\N	\N	\N	84950	84950	252854
8153	6948	8	applied	\N	\N	\N	\N	84951	84951	252855
8153	6949	9	applied	\N	\N	\N	\N	84952	84952	252856
8153	6950	10	applied	\N	\N	\N	\N	84953	84953	252857
8153	6951	11	applied	\N	\N	\N	\N	84954	84954	252858
8153	6953	13	applied	\N	\N	\N	\N	84956	84956	252860
8153	6955	14	applied	\N	\N	\N	\N	84957	84957	252861
8153	6956	15	applied	\N	\N	\N	\N	84958	84958	252862
8153	6957	16	applied	\N	\N	\N	\N	84959	84959	252863
8153	6958	17	applied	\N	\N	\N	\N	84960	84960	252864
8153	6959	18	applied	\N	\N	\N	\N	84961	84961	252865
8153	6961	19	applied	\N	\N	\N	\N	84962	84962	252866
8153	6962	20	applied	\N	\N	\N	\N	84963	84963	252867
8153	6963	21	applied	\N	\N	\N	\N	84964	84964	252868
8153	6964	22	applied	\N	\N	\N	\N	84965	84965	252869
8153	6965	23	applied	\N	\N	\N	\N	84966	84966	252870
8153	6966	24	applied	\N	\N	\N	\N	84967	84967	252871
8153	6967	25	applied	\N	\N	\N	\N	84968	84968	252872
8153	6968	26	applied	\N	\N	\N	\N	84969	84969	252873
8153	6969	27	applied	\N	\N	\N	\N	84970	84970	252874
8153	6970	28	applied	\N	\N	\N	\N	84971	84971	252875
8153	6972	30	applied	\N	\N	\N	\N	84973	84973	252877
8153	6973	31	applied	\N	\N	\N	\N	84974	84974	252878
8153	6974	32	applied	\N	\N	\N	\N	84975	84975	252879
8153	6975	33	applied	\N	\N	\N	\N	84976	84976	252880
8153	6976	34	applied	\N	\N	\N	\N	84977	84977	252881
8153	6977	35	applied	\N	\N	\N	\N	84978	84978	252882
8153	6978	36	applied	\N	\N	\N	\N	84979	84979	252883
8153	6979	37	applied	\N	\N	\N	\N	84980	84980	252884
8153	6980	38	applied	\N	\N	\N	\N	84981	84981	252885
8153	6981	39	applied	\N	\N	\N	\N	84982	84982	252886
8153	6982	40	applied	\N	\N	1000000000	\N	84983	84983	252887
8153	6983	41	applied	\N	\N	\N	\N	84984	84984	252888
8153	6984	42	applied	\N	\N	\N	\N	84985	84985	252889
8153	6954	43	applied	\N	\N	\N	\N	84986	84986	252890
8157	6986	0	applied	\N	\N	\N	\N	84990	84990	252894
8158	6987	0	applied	\N	\N	\N	\N	84991	84991	252895
8162	6985	0	applied	\N	\N	\N	\N	84995	84995	252899
8162	6986	1	applied	\N	\N	\N	\N	84996	84996	252900
8162	6987	2	applied	\N	\N	\N	\N	84997	84997	252901
8162	6988	3	applied	\N	\N	\N	\N	84998	84998	252902
8163	6989	0	applied	\N	\N	\N	\N	84999	84999	252903
8163	6990	1	applied	\N	\N	\N	\N	85000	85000	252904
8166	6991	0	applied	\N	\N	\N	\N	85002	85002	252906
8167	6992	0	applied	\N	\N	\N	\N	85003	85003	252907
8167	6993	1	applied	\N	\N	\N	\N	85004	85004	252908
8169	6992	0	applied	\N	\N	\N	\N	85007	85007	252911
8169	6993	1	applied	\N	\N	\N	\N	85008	85008	252912
8170	6994	0	applied	\N	\N	\N	\N	85009	85009	252913
8172	6994	0	applied	\N	\N	\N	\N	85011	85011	252915
8173	6994	0	applied	\N	\N	\N	\N	85012	85012	252916
8175	6996	0	applied	\N	\N	\N	\N	85014	85014	252918
8175	6997	1	applied	\N	\N	\N	\N	85015	85015	252919
8178	6997	1	applied	\N	\N	\N	\N	85021	85021	252925
8179	6998	0	applied	\N	\N	\N	\N	85022	85022	252926
8181	7000	0	applied	\N	\N	\N	\N	85024	85024	252928
8181	7001	1	applied	\N	\N	\N	\N	85025	85025	252929
8182	7002	0	applied	\N	\N	\N	\N	85026	85026	252930
8182	7003	1	applied	\N	\N	\N	\N	85027	85027	252931
8186	7008	0	applied	\N	\N	\N	\N	85036	85036	252940
8188	7009	0	applied	\N	\N	\N	\N	85038	85038	252942
8191	7011	0	applied	\N	\N	\N	\N	85041	85041	252945
8198	7015	0	applied	\N	\N	\N	\N	85054	85054	252958
8200	7016	0	applied	\N	\N	\N	\N	85056	85056	252960
8207	7023	0	applied	\N	\N	\N	\N	85069	85069	252973
8212	7025	0	applied	\N	\N	\N	\N	85131	85131	253035
8212	7026	1	applied	\N	\N	\N	\N	85132	85132	253036
8220	7029	0	applied	\N	\N	\N	\N	85143	85143	253047
8221	7031	0	applied	\N	\N	\N	\N	85145	85145	253049
8228	7034	0	applied	\N	\N	\N	\N	85152	85152	253056
8231	7036	0	applied	\N	\N	\N	\N	85157	85157	253061
8231	7037	1	applied	\N	\N	\N	\N	85158	85158	253062
8231	7038	2	applied	\N	\N	\N	\N	85159	85159	253063
8235	7039	0	applied	\N	\N	\N	\N	85169	85169	253073
8235	7040	1	applied	\N	\N	\N	\N	85170	85170	253074
8242	7042	0	applied	\N	\N	\N	\N	85175	85175	253079
8256	7048	0	applied	\N	\N	\N	\N	85198	85198	253102
8256	7049	1	applied	\N	\N	\N	\N	85199	85199	253103
8260	7051	0	applied	\N	\N	\N	\N	85203	85203	253107
8260	7052	1	applied	\N	\N	\N	\N	85204	85204	253108
8267	7063	0	applied	\N	\N	\N	\N	85226	85226	253128
8267	7064	1	applied	\N	\N	\N	\N	85227	85227	253129
8267	7065	2	applied	\N	\N	\N	\N	85228	85228	253130
8269	7066	0	applied	\N	\N	\N	\N	85230	85230	253132
8277	7076	0	applied	\N	\N	\N	\N	85244	85244	253146
8277	7077	1	applied	\N	\N	\N	\N	85245	85245	253147
8284	7079	0	applied	\N	\N	\N	\N	85255	85255	253157
8102	6935	0	applied	\N	\N	\N	\N	84858	84858	252762
8102	6936	1	applied	\N	\N	\N	\N	84859	84859	252763
8135	6970	0	applied	\N	\N	\N	\N	84912	84912	252816
8143	6976	0	applied	\N	\N	\N	\N	84922	84922	252826
8150	6980	0	applied	\N	\N	\N	\N	84934	84934	252838
8150	6981	1	applied	\N	\N	\N	\N	84935	84935	252839
8150	6983	3	applied	\N	\N	\N	\N	84937	84937	252841
8152	6984	0	applied	\N	\N	\N	\N	84942	84942	252846
8154	6985	0	applied	\N	\N	\N	\N	84987	84987	252891
8156	6986	0	applied	\N	\N	\N	\N	84989	84989	252893
8161	6988	0	applied	\N	\N	\N	\N	84994	84994	252898
8171	6994	0	applied	\N	\N	\N	\N	85010	85010	252914
8176	6996	0	applied	\N	\N	\N	\N	85016	85016	252920
8176	6997	1	applied	\N	\N	\N	\N	85017	85017	252921
8180	6999	0	applied	\N	\N	\N	\N	85023	85023	252927
8182	7004	2	applied	\N	\N	\N	\N	85028	85028	252932
8182	7005	3	applied	\N	\N	\N	\N	85029	85029	252933
8184	7006	0	applied	\N	\N	\N	\N	85034	85034	252938
8187	7008	0	applied	\N	\N	\N	\N	85037	85037	252941
8189	7010	0	applied	\N	\N	\N	\N	85039	85039	252943
8192	7012	0	applied	\N	\N	\N	\N	85042	85042	252946
8192	7013	1	applied	\N	\N	\N	\N	85043	85043	252947
8194	7012	0	applied	\N	\N	\N	\N	85044	85044	252948
8194	7013	1	applied	\N	\N	\N	\N	85045	85045	252949
8194	7014	2	applied	\N	\N	\N	\N	85046	85046	252950
8195	7013	1	applied	\N	\N	\N	\N	85048	85048	252952
8195	7014	2	applied	\N	\N	\N	\N	85049	85049	252953
8199	7016	0	applied	\N	\N	\N	\N	85055	85055	252959
8201	7017	0	applied	\N	\N	\N	\N	85057	85057	252961
8203	7018	0	applied	\N	\N	1000000000	\N	85061	85061	252965
8203	7019	1	applied	\N	\N	\N	\N	85062	85062	252966
8203	7020	2	applied	\N	\N	\N	\N	85063	85063	252967
8204	7018	0	applied	\N	\N	1000000000	\N	85064	85064	252968
8204	7019	1	applied	\N	\N	\N	\N	85065	85065	252969
8204	7020	2	applied	\N	\N	\N	\N	85066	85066	252970
8205	7021	0	applied	\N	\N	\N	\N	85067	85067	252971
8206	7022	0	applied	\N	\N	\N	\N	85068	85068	252972
8208	7023	0	applied	\N	\N	\N	\N	85070	85070	252974
8213	7027	0	applied	\N	\N	\N	\N	85133	85133	253037
8215	7028	0	applied	\N	\N	\N	\N	85135	85135	253039
8216	7028	0	applied	\N	\N	\N	\N	85136	85136	253040
8217	7030	1	applied	\N	\N	1000000000	\N	85138	85138	253042
8218	7029	0	applied	\N	\N	\N	\N	85139	85139	253043
8218	7030	1	applied	\N	\N	1000000000	\N	85140	85140	253044
8222	7032	0	applied	\N	\N	\N	\N	85146	85146	253050
8224	7033	0	applied	\N	\N	\N	\N	85148	85148	253052
8226	7034	0	applied	\N	\N	\N	\N	85150	85150	253054
8227	7034	0	applied	\N	\N	\N	\N	85151	85151	253055
8229	7035	0	applied	\N	\N	\N	\N	85153	85153	253057
8232	7036	0	applied	\N	\N	\N	\N	85160	85160	253064
8232	7037	1	applied	\N	\N	\N	\N	85161	85161	253065
8232	7038	2	applied	\N	\N	\N	\N	85162	85162	253066
8233	7036	0	applied	\N	\N	\N	\N	85163	85163	253067
8233	7037	1	applied	\N	\N	\N	\N	85164	85164	253068
8233	7038	2	applied	\N	\N	\N	\N	85165	85165	253069
8238	7042	0	applied	\N	\N	\N	\N	85172	85172	253076
8239	7042	0	applied	\N	\N	\N	\N	85173	85173	253077
8243	7043	1	applied	\N	\N	\N	\N	85177	85177	253081
8243	7044	3	applied	\N	\N	\N	\N	85178	85178	253082
8245	7042	0	applied	\N	\N	\N	\N	85181	85181	253085
8245	7043	1	applied	\N	\N	\N	\N	85182	85182	253086
8245	7044	3	applied	\N	\N	\N	\N	85183	85183	253087
8247	7045	0	applied	\N	\N	\N	\N	85187	85187	253091
8249	7046	0	applied	\N	\N	\N	\N	85189	85189	253093
8250	7047	0	applied	\N	\N	\N	\N	85190	85190	253094
8252	7047	0	applied	\N	\N	\N	\N	85192	85192	253096
8253	7047	0	applied	\N	\N	\N	\N	85193	85193	253097
8254	7048	0	applied	\N	\N	\N	\N	85194	85194	253098
8254	7049	1	applied	\N	\N	\N	\N	85195	85195	253099
8258	7050	0	applied	\N	\N	\N	\N	85200	85200	253104
8259	7051	0	applied	\N	\N	\N	\N	85201	85201	253105
8259	7052	1	applied	\N	\N	\N	\N	85202	85202	253106
8261	7051	0	applied	\N	\N	\N	\N	85205	85205	253109
8262	7053	0	applied	\N	\N	\N	\N	85207	85207	85207
8262	7054	1	applied	\N	\N	\N	\N	85208	85208	253111
8262	7055	2	applied	\N	\N	\N	\N	85209	85209	253112
8262	7056	3	applied	\N	\N	\N	\N	85210	85210	253113
8262	7057	4	applied	\N	\N	\N	\N	85211	85211	253114
8262	7058	5	applied	\N	\N	\N	\N	85212	85212	253115
8263	7053	0	applied	\N	\N	\N	\N	85213	85213	85213
8263	7054	1	applied	\N	\N	\N	\N	85214	85214	253116
8263	7055	2	applied	\N	\N	\N	\N	85215	85215	253117
8263	7056	3	applied	\N	\N	\N	\N	85216	85216	253118
8263	7057	4	applied	\N	\N	\N	\N	85217	85217	253119
8263	7058	5	applied	\N	\N	\N	\N	85218	85218	253120
8264	7059	0	applied	\N	\N	\N	\N	85219	85219	253121
8264	7060	1	applied	\N	\N	\N	\N	85220	85220	253122
8265	7061	0	applied	\N	\N	\N	\N	85221	85221	253123
8272	7068	0	applied	\N	\N	\N	\N	85233	85233	253135
8275	7073	1	applied	\N	\N	\N	\N	85241	85241	253143
8275	7074	2	applied	\N	\N	1000000000	\N	85242	85242	253144
8278	7076	0	applied	\N	\N	\N	\N	85246	85246	253148
8278	7077	1	applied	\N	\N	\N	\N	85247	85247	253149
8282	7079	0	applied	\N	\N	\N	\N	85253	85253	253155
8287	7082	0	applied	\N	\N	\N	\N	85259	85259	253161
8296	7088	0	applied	\N	\N	\N	\N	85276	85276	253178
8296	7089	1	applied	\N	\N	\N	\N	85277	85277	253179
8301	7092	0	applied	\N	\N	\N	\N	85283	85283	253185
8310	6987	0	applied	\N	\N	\N	\N	85298	85298	253200
8310	6988	1	applied	\N	\N	\N	\N	85299	85299	253201
8310	6989	2	applied	\N	\N	\N	\N	85300	85300	253202
8310	6990	3	applied	\N	\N	\N	\N	85301	85301	253203
8310	6991	4	applied	\N	\N	\N	\N	85302	85302	253204
8310	6992	5	applied	\N	\N	\N	\N	85303	85303	253205
8310	6993	6	applied	\N	\N	\N	\N	85304	85304	253206
8310	6995	8	applied	\N	\N	\N	\N	85306	85306	253208
8310	6996	10	applied	\N	\N	\N	\N	85307	85307	253209
8310	6997	11	applied	\N	\N	\N	\N	85308	85308	253210
8310	6998	12	applied	\N	\N	\N	\N	85309	85309	253211
8310	6999	13	applied	\N	\N	\N	\N	85310	85310	253212
8310	7000	14	applied	\N	\N	\N	\N	85311	85311	253213
8132	6966	0	applied	\N	\N	\N	\N	84906	84906	252810
8132	6967	1	applied	\N	\N	\N	\N	84907	84907	252811
8183	7002	0	applied	\N	\N	\N	\N	85030	85030	252934
8183	7003	1	applied	\N	\N	\N	\N	85031	85031	252935
8183	7004	2	applied	\N	\N	\N	\N	85032	85032	252936
8183	7005	3	applied	\N	\N	\N	\N	85033	85033	252937
8185	7007	0	applied	\N	\N	\N	\N	85035	85035	252939
8190	7011	0	applied	\N	\N	\N	\N	85040	85040	252944
8196	7012	0	applied	\N	\N	\N	\N	85050	85050	252954
8196	7014	2	applied	\N	\N	\N	\N	85052	85052	252956
8197	7015	0	applied	\N	\N	\N	\N	85053	85053	252957
8202	7018	0	applied	\N	\N	1000000000	\N	85058	85058	252962
8202	7019	1	applied	\N	\N	\N	\N	85059	85059	252963
8202	7020	2	applied	\N	\N	\N	\N	85060	85060	252964
8209	7023	0	applied	\N	\N	\N	\N	85071	85071	252975
8210	6966	0	applied	\N	\N	\N	\N	85072	85072	252976
8210	6967	1	applied	\N	\N	\N	\N	85073	85073	252977
8210	6968	2	applied	\N	\N	\N	\N	85074	85074	252978
8210	6969	3	applied	\N	\N	\N	\N	85075	85075	252979
8210	6970	4	applied	\N	\N	\N	\N	85076	85076	252980
8210	6971	5	applied	\N	\N	\N	\N	85077	85077	252981
8210	6972	6	applied	\N	\N	\N	\N	85078	85078	252982
8210	6973	7	applied	\N	\N	\N	\N	85079	85079	252983
8210	6974	8	applied	\N	\N	\N	\N	85080	85080	252984
8210	6975	9	applied	\N	\N	\N	\N	85081	85081	252985
8210	6977	11	applied	\N	\N	\N	\N	85083	85083	252987
8210	6978	12	applied	\N	\N	\N	\N	85084	85084	252988
8210	6979	13	applied	\N	\N	\N	\N	85085	85085	252989
8210	6980	14	applied	\N	\N	\N	\N	85086	85086	252990
8210	6981	15	applied	\N	\N	\N	\N	85087	85087	252991
8210	6982	16	applied	\N	\N	1000000000	\N	85088	85088	252992
8210	6983	17	applied	\N	\N	\N	\N	85089	85089	252993
8210	6984	18	applied	\N	\N	\N	\N	85090	85090	252994
8210	6985	19	applied	\N	\N	\N	\N	85091	85091	252995
8210	6986	20	applied	\N	\N	\N	\N	85092	85092	252996
8210	6987	21	applied	\N	\N	\N	\N	85093	85093	252997
8210	6988	22	applied	\N	\N	\N	\N	85094	85094	252998
8210	6989	23	applied	\N	\N	\N	\N	85095	85095	252999
8210	6990	24	applied	\N	\N	\N	\N	85096	85096	253000
8210	6991	25	applied	\N	\N	\N	\N	85097	85097	253001
8210	6992	26	applied	\N	\N	\N	\N	85098	85098	253002
8210	6994	28	applied	\N	\N	\N	\N	85100	85100	253004
8210	6995	29	applied	\N	\N	\N	\N	85101	85101	253005
8210	6996	30	applied	\N	\N	\N	\N	85102	85102	253006
8210	6997	31	applied	\N	\N	\N	\N	85103	85103	253007
8210	6998	32	applied	\N	\N	\N	\N	85104	85104	253008
8210	6999	33	applied	\N	\N	\N	\N	85105	85105	253009
8210	7000	34	applied	\N	\N	\N	\N	85106	85106	253010
8210	7001	35	applied	\N	\N	\N	\N	85107	85107	253011
8210	7002	36	applied	\N	\N	\N	\N	85108	85108	253012
8210	7003	37	applied	\N	\N	\N	\N	85109	85109	253013
8210	7004	38	applied	\N	\N	\N	\N	85110	85110	253014
8210	7005	39	applied	\N	\N	\N	\N	85111	85111	253015
8210	7006	40	applied	\N	\N	\N	\N	85112	85112	253016
8210	7007	41	applied	\N	\N	\N	\N	85113	85113	253017
8210	7008	42	applied	\N	\N	\N	\N	85114	85114	253018
8210	7009	43	applied	\N	\N	\N	\N	85115	85115	253019
8210	7011	45	applied	\N	\N	\N	\N	85117	85117	253021
8210	7012	46	applied	\N	\N	\N	\N	85118	85118	253022
8210	7013	47	applied	\N	\N	\N	\N	85119	85119	253023
8210	7014	48	applied	\N	\N	\N	\N	85120	85120	253024
8210	7015	49	applied	\N	\N	\N	\N	85121	85121	253025
8210	7016	50	applied	\N	\N	\N	\N	85122	85122	253026
8210	7017	51	applied	\N	\N	\N	\N	85123	85123	253027
8210	7018	52	applied	\N	\N	1000000000	\N	85124	85124	253028
8210	7019	53	applied	\N	\N	\N	\N	85125	85125	253029
8210	7020	54	applied	\N	\N	\N	\N	85126	85126	253030
8210	7021	55	applied	\N	\N	\N	\N	85127	85127	253031
8210	7022	57	applied	\N	\N	\N	\N	85128	85128	253032
8210	7023	58	applied	\N	\N	\N	\N	85129	85129	253033
8211	7024	0	applied	\N	\N	\N	\N	85130	85130	253034
8214	7027	0	applied	\N	\N	\N	\N	85134	85134	253038
8219	7029	0	applied	\N	\N	\N	\N	85141	85141	253045
8310	7002	16	applied	\N	\N	\N	\N	85313	85313	253215
8310	7003	17	applied	\N	\N	\N	\N	85314	85314	253216
8310	7004	18	applied	\N	\N	\N	\N	85315	85315	253217
8310	7005	19	applied	\N	\N	\N	\N	85316	85316	253218
8310	7006	20	applied	\N	\N	\N	\N	85317	85317	253219
8310	7007	21	applied	\N	\N	\N	\N	85318	85318	253220
8310	7008	22	applied	\N	\N	\N	\N	85319	85319	253221
8310	7009	23	applied	\N	\N	\N	\N	85320	85320	253222
8310	7010	24	applied	\N	\N	\N	\N	85321	85321	253223
8310	7011	25	applied	\N	\N	\N	\N	85322	85322	253224
8310	7012	26	applied	\N	\N	\N	\N	85323	85323	253225
8310	7013	27	applied	\N	\N	\N	\N	85324	85324	253226
8310	7014	28	applied	\N	\N	\N	\N	85325	85325	253227
8310	7015	29	applied	\N	\N	\N	\N	85326	85326	253228
8310	7016	30	applied	\N	\N	\N	\N	85327	85327	253229
8310	7017	31	applied	\N	\N	\N	\N	85328	85328	253230
8310	7019	33	applied	\N	\N	\N	\N	85330	85330	253232
8310	7020	34	applied	\N	\N	\N	\N	85331	85331	253233
8310	7021	35	applied	\N	\N	\N	\N	85332	85332	253234
8310	7022	36	applied	\N	\N	\N	\N	85333	85333	253235
8310	7023	37	applied	\N	\N	\N	\N	85334	85334	253236
8310	7024	38	applied	\N	\N	\N	\N	85335	85335	253237
8310	7025	39	applied	\N	\N	\N	\N	85336	85336	253238
8310	7026	40	applied	\N	\N	\N	\N	85337	85337	253239
8310	7027	41	applied	\N	\N	\N	\N	85338	85338	253240
8310	7028	42	applied	\N	\N	\N	\N	85339	85339	253241
8310	7029	43	applied	\N	\N	\N	\N	85340	85340	253242
8310	7030	44	applied	\N	\N	1000000000	\N	85341	85341	253243
8310	7031	45	applied	\N	\N	\N	\N	85342	85342	253244
8310	7032	46	applied	\N	\N	\N	\N	85343	85343	253245
8310	7033	47	applied	\N	\N	\N	\N	85344	85344	253246
8310	7034	48	applied	\N	\N	\N	\N	85345	85345	253247
8310	7035	49	applied	\N	\N	\N	\N	85346	85346	253248
8310	7036	50	applied	\N	\N	\N	\N	85347	85347	253249
8310	7038	52	applied	\N	\N	\N	\N	85349	85349	253251
8310	7039	53	applied	\N	\N	\N	\N	85350	85350	253252
8310	7040	54	applied	\N	\N	\N	\N	85351	85351	253253
8310	7041	55	applied	\N	\N	\N	\N	85352	85352	253254
8177	6996	0	applied	\N	\N	\N	\N	85018	85018	252922
8177	6997	1	applied	\N	\N	\N	\N	85019	85019	252923
8230	7036	0	applied	\N	\N	\N	\N	85154	85154	253058
8230	7037	1	applied	\N	\N	\N	\N	85155	85155	253059
8230	7038	2	applied	\N	\N	\N	\N	85156	85156	253060
8234	7036	0	applied	\N	\N	\N	\N	85166	85166	253070
8234	7037	1	applied	\N	\N	\N	\N	85167	85167	253071
8234	7038	2	applied	\N	\N	\N	\N	85168	85168	253072
8237	7041	0	applied	\N	\N	\N	\N	85171	85171	253075
8240	7042	0	applied	\N	\N	\N	\N	85174	85174	253078
8244	7042	0	applied	\N	\N	\N	\N	85179	85179	253083
8244	7043	1	applied	\N	\N	\N	\N	85180	85180	253084
8246	7042	0	applied	\N	\N	\N	\N	85184	85184	253088
8246	7043	1	applied	\N	\N	\N	\N	85185	85185	253089
8246	7044	3	applied	\N	\N	\N	\N	85186	85186	253090
8251	7047	0	applied	\N	\N	\N	\N	85191	85191	253095
8255	7048	0	applied	\N	\N	\N	\N	85196	85196	253100
8255	7049	1	applied	\N	\N	\N	\N	85197	85197	253101
8265	7062	1	applied	\N	\N	\N	\N	85222	85222	253124
8266	7063	0	applied	\N	\N	\N	\N	85223	85223	253125
8266	7064	1	applied	\N	\N	\N	\N	85224	85224	253126
8266	7065	2	applied	\N	\N	\N	\N	85225	85225	253127
8268	7066	0	applied	\N	\N	\N	\N	85229	85229	253131
8270	7067	0	applied	\N	\N	\N	\N	85231	85231	253133
8271	7067	0	applied	\N	\N	\N	\N	85232	85232	253134
8273	7069	0	applied	\N	\N	\N	\N	85234	85234	253136
8273	7070	1	applied	\N	\N	\N	\N	85235	85235	253137
8273	7071	2	applied	\N	\N	\N	\N	85236	85236	253138
8274	7069	0	applied	\N	\N	\N	\N	85237	85237	253139
8274	7070	1	applied	\N	\N	\N	\N	85238	85238	253140
8274	7071	2	applied	\N	\N	\N	\N	85239	85239	253141
8279	7076	0	applied	\N	\N	\N	\N	85248	85248	253150
8279	7077	1	applied	\N	\N	\N	\N	85249	85249	253151
8280	7076	0	applied	\N	\N	\N	\N	85250	85250	253152
8280	7077	1	applied	\N	\N	\N	\N	85251	85251	253153
8281	7078	0	applied	\N	\N	\N	\N	85252	85252	253154
8283	7079	0	applied	\N	\N	\N	\N	85254	85254	253156
8288	7083	0	applied	\N	\N	\N	\N	85260	85260	253162
8288	7084	1	applied	\N	\N	1000000000	\N	85261	85261	253163
8290	7085	0	applied	\N	\N	\N	\N	85264	85264	253166
8290	7086	1	applied	\N	\N	\N	\N	85265	85265	253167
8290	7087	2	applied	\N	\N	\N	\N	85266	85266	253168
8293	7088	0	applied	\N	\N	\N	\N	85270	85270	253172
8293	7089	1	applied	\N	\N	\N	\N	85271	85271	253173
8297	7090	0	applied	\N	\N	\N	\N	85278	85278	253180
8299	7092	0	applied	\N	\N	\N	\N	85281	85281	253183
8302	7093	0	applied	\N	\N	\N	\N	85284	85284	253186
8304	7095	0	applied	\N	\N	\N	\N	85288	85288	253190
8306	7095	0	applied	\N	\N	\N	\N	85290	85290	253192
8307	7095	0	applied	\N	\N	\N	\N	85291	85291	253193
8308	7096	0	applied	\N	\N	\N	\N	85292	85292	253194
8308	7097	1	applied	\N	\N	\N	\N	85293	85293	253195
8308	7098	2	applied	\N	\N	\N	\N	85294	85294	253196
8309	7096	0	applied	\N	\N	\N	\N	85295	85295	253197
8309	7097	1	applied	\N	\N	\N	\N	85296	85296	253198
8309	7098	2	applied	\N	\N	\N	\N	85297	85297	253199
8311	7099	0	applied	\N	\N	\N	\N	85402	85402	253304
8313	7100	0	applied	\N	\N	\N	\N	85404	85404	253306
8313	7101	1	applied	\N	\N	\N	\N	85405	85405	253307
8313	7102	2	applied	\N	\N	\N	\N	85406	85406	253308
8316	7104	0	applied	\N	\N	\N	\N	85408	85408	253310
8316	7105	1	applied	\N	\N	\N	\N	85409	85409	253311
8316	7106	2	applied	\N	\N	\N	\N	85410	85410	253312
8316	7108	4	applied	\N	\N	\N	\N	85412	85412	253314
8323	7111	0	applied	\N	\N	\N	\N	85427	85427	253329
8323	7112	1	applied	\N	\N	\N	\N	85428	85428	253330
8326	7115	0	applied	\N	\N	\N	\N	85433	85433	253335
8333	7120	0	applied	\N	\N	\N	\N	85440	85440	253342
8336	7124	0	applied	\N	\N	\N	\N	85444	85444	253346
8339	7125	0	applied	\N	\N	\N	\N	85446	85446	253348
8343	7125	0	applied	\N	\N	\N	\N	85452	85452	253354
8343	7126	1	applied	\N	\N	\N	\N	85453	85453	253355
8343	7127	2	applied	\N	\N	\N	\N	85454	85454	253356
8345	7134	0	applied	\N	\N	\N	\N	85461	85461	253363
8367	7161	0	applied	\N	\N	\N	\N	85508	85508	253409
8372	7164	0	applied	\N	\N	\N	\N	85514	85514	253415
8374	7167	0	applied	\N	\N	\N	\N	85517	85517	253418
8378	7170	0	applied	\N	\N	\N	\N	85528	85528	253429
8378	7171	1	applied	\N	\N	\N	\N	85529	85529	253430
8378	7173	3	applied	\N	\N	\N	\N	85531	85531	253432
8382	7174	0	applied	\N	\N	\N	\N	85542	85542	253443
8382	7175	1	applied	\N	\N	\N	\N	85543	85543	253444
8387	7182	0	applied	\N	\N	\N	\N	85552	85552	253453
8389	7183	0	applied	\N	\N	\N	\N	85679	85679	253580
8389	7184	1	applied	\N	\N	\N	\N	85680	85680	253581
8391	7185	0	applied	\N	\N	\N	\N	85683	85683	253584
8398	7190	0	applied	\N	\N	\N	\N	85693	85693	253594
8409	7196	0	applied	\N	\N	\N	\N	85704	85704	253605
8455	7207	0	applied	\N	\N	\N	\N	85727	85727	253628
8457	7208	0	applied	\N	\N	\N	\N	85729	85729	253630
8461	7209	0	applied	\N	\N	\N	\N	85738	85738	253639
8463	7210	0	applied	\N	\N	\N	\N	85740	85740	253641
8466	7212	0	applied	\N	\N	\N	\N	85743	85743	253644
8469	7213	0	applied	\N	\N	\N	\N	85750	85750	253651
8469	7214	1	applied	\N	\N	\N	\N	85751	85751	253652
8469	7216	3	applied	\N	\N	\N	\N	85753	85753	253654
8469	7217	4	applied	\N	\N	\N	\N	85754	85754	253655
8475	7220	0	applied	\N	\N	\N	\N	85760	85760	253661
8478	7222	0	applied	\N	\N	\N	\N	85764	85764	253665
8478	7223	1	applied	\N	\N	1000000000	\N	85765	85765	253666
8480	7224	0	applied	\N	\N	\N	\N	85767	85767	253668
8485	7227	0	applied	\N	\N	\N	\N	85776	85776	253677
8485	7228	1	applied	\N	\N	\N	\N	85777	85777	253678
8489	7230	0	applied	\N	\N	\N	\N	85782	85782	253683
8494	7235	0	applied	\N	\N	\N	\N	85791	85791	253692
8496	7236	0	applied	\N	\N	\N	\N	85793	85793	253694
8498	7236	0	applied	\N	\N	\N	\N	85795	85795	253696
8503	7239	0	applied	\N	\N	\N	\N	85800	85800	253701
8506	7241	0	applied	\N	\N	\N	\N	85803	85803	253704
8510	7243	0	applied	\N	\N	\N	\N	85807	85807	253708
8515	7247	0	applied	\N	\N	\N	\N	85812	85812	253713
8223	7032	0	applied	\N	\N	\N	\N	85147	85147	253051
8225	7033	0	applied	\N	\N	\N	\N	85149	85149	253053
8291	7085	0	applied	\N	\N	\N	\N	85267	85267	253169
8291	7086	1	applied	\N	\N	\N	\N	85268	85268	253170
8291	7087	2	applied	\N	\N	\N	\N	85269	85269	253171
8294	7088	0	applied	\N	\N	\N	\N	85272	85272	253174
8294	7089	1	applied	\N	\N	\N	\N	85273	85273	253175
8295	7089	1	applied	\N	\N	\N	\N	85275	85275	253177
8298	7091	0	applied	\N	\N	\N	\N	85279	85279	253181
8298	7090	1	applied	\N	\N	\N	\N	85280	85280	253182
8300	7092	0	applied	\N	\N	\N	\N	85282	85282	253184
8303	7093	0	applied	\N	\N	\N	\N	85286	85286	253188
8303	7094	1	applied	\N	\N	\N	\N	85287	85287	253189
8305	7095	0	applied	\N	\N	\N	\N	85289	85289	253191
8312	7099	0	applied	\N	\N	\N	\N	85403	85403	253305
8327	7115	0	applied	\N	\N	\N	\N	85434	85434	253336
8329	7116	0	applied	\N	\N	\N	\N	85436	85436	253338
8332	7119	0	applied	\N	\N	\N	\N	85439	85439	253341
8335	7122	0	applied	\N	\N	\N	\N	85442	85442	253344
8335	7123	1	applied	\N	\N	\N	\N	85443	85443	253345
8341	7125	0	applied	\N	\N	\N	\N	85448	85448	253350
8344	7129	1	applied	\N	\N	\N	\N	85456	85456	253358
8344	7130	2	applied	\N	\N	1000000000	\N	85457	85457	253359
8344	7131	3	applied	\N	\N	1000000000	\N	85458	85458	253360
8344	7132	4	applied	\N	\N	1000000000	\N	85459	85459	253361
8344	7133	5	applied	\N	\N	1000000000	\N	85460	85460	253362
8347	7136	0	applied	\N	\N	\N	\N	85463	85463	253365
8347	7137	1	applied	\N	\N	\N	\N	85464	85464	253366
8347	7138	2	applied	\N	\N	1000000000	\N	85465	85465	253367
8349	7136	0	applied	\N	\N	\N	\N	85469	85469	253371
8349	7137	1	applied	\N	\N	\N	\N	85470	85470	253372
8349	7138	2	applied	\N	\N	1000000000	\N	85471	85471	253373
8352	7139	0	applied	\N	\N	\N	\N	85478	85478	253380
8352	7140	1	applied	\N	\N	\N	\N	85479	85479	253381
8352	7141	2	applied	\N	\N	\N	\N	85480	85480	253382
8354	7142	0	applied	\N	\N	\N	\N	85484	85484	253386
8354	7143	1	applied	\N	\N	\N	\N	85485	85485	253387
8354	7144	2	applied	\N	\N	\N	\N	85486	85486	253388
8357	7148	0	applied	\N	\N	\N	\N	85492	85492	253393
8357	7149	1	applied	\N	\N	\N	\N	85493	85493	253394
8360	7152	0	applied	\N	\N	\N	\N	85498	85498	253399
8360	7153	1	applied	\N	\N	\N	\N	85499	85499	253400
8363	7157	0	applied	\N	\N	\N	\N	85503	85503	253404
8363	7158	1	applied	\N	\N	\N	\N	85504	85504	253405
8369	7161	0	applied	\N	\N	\N	\N	85510	85510	253411
8373	7165	0	applied	\N	\N	\N	\N	85515	85515	253416
8373	7166	1	applied	\N	\N	1000000000	\N	85516	85516	253417
8376	7170	0	applied	\N	\N	\N	\N	85520	85520	253421
8376	7171	1	applied	\N	\N	\N	\N	85521	85521	253422
8376	7172	2	applied	\N	\N	\N	\N	85522	85522	253423
8376	7173	3	applied	\N	\N	\N	\N	85523	85523	253424
8380	7170	0	applied	\N	\N	\N	\N	85536	85536	253437
8380	7171	1	applied	\N	\N	\N	\N	85537	85537	253438
8380	7172	2	applied	\N	\N	\N	\N	85538	85538	253439
8380	7173	3	applied	\N	\N	\N	\N	85539	85539	253440
8383	7176	0	applied	\N	\N	\N	\N	85544	85544	253445
8383	7177	1	applied	\N	\N	\N	\N	85545	85545	253446
8383	7178	2	applied	\N	\N	\N	\N	85546	85546	253447
8383	7179	3	applied	\N	\N	\N	\N	85547	85547	253448
8383	7180	4	applied	\N	\N	\N	\N	85548	85548	253449
8388	6991	0	applied	\N	\N	\N	\N	85553	85553	253454
8388	6992	1	applied	\N	\N	\N	\N	85554	85554	253455
8388	6993	2	applied	\N	\N	\N	\N	85555	85555	253456
8388	6994	3	applied	\N	\N	\N	\N	85556	85556	253457
8388	6995	4	applied	\N	\N	\N	\N	85557	85557	253458
8388	6997	6	applied	\N	\N	\N	\N	85559	85559	253460
8388	6998	7	applied	\N	\N	\N	\N	85560	85560	253461
8388	6999	8	applied	\N	\N	\N	\N	85561	85561	253462
8388	7000	9	applied	\N	\N	\N	\N	85562	85562	253463
8388	7001	10	applied	\N	\N	\N	\N	85563	85563	253464
8388	7002	11	applied	\N	\N	\N	\N	85564	85564	253465
8518	7249	1	applied	\N	\N	\N	\N	85817	85817	253718
8522	7251	0	applied	\N	\N	\N	\N	85823	85823	253724
8522	7252	1	applied	\N	\N	\N	\N	85824	85824	253725
8522	7253	2	applied	\N	\N	\N	\N	85825	85825	253726
8523	7254	0	applied	\N	\N	\N	\N	85826	85826	253727
8523	7255	1	applied	\N	\N	\N	\N	85827	85827	253728
8532	7260	0	applied	\N	\N	\N	\N	85837	85837	253738
8534	7261	0	applied	\N	\N	\N	\N	85839	85839	253740
8540	7267	0	applied	\N	\N	\N	\N	85848	85848	253749
8554	7277	0	applied	\N	\N	\N	\N	85865	85865	253766
8559	7281	0	applied	\N	\N	\N	\N	85870	85870	253771
8562	7283	0	applied	\N	\N	\N	\N	85873	85873	253774
8562	7284	1	applied	\N	\N	\N	\N	85874	85874	253775
8567	7287	0	applied	\N	\N	\N	\N	85881	85881	253782
8569	7288	0	applied	\N	\N	\N	\N	85883	85883	253784
8572	7291	0	applied	\N	\N	\N	\N	85888	85888	253789
8572	7292	1	applied	\N	\N	\N	\N	85889	85889	253790
8574	7293	0	applied	\N	\N	\N	\N	85892	85892	253793
8577	7296	0	applied	\N	\N	\N	\N	85896	85896	253797
8584	7225	0	applied	\N	\N	\N	\N	85903	85903	253804
8584	7200	1	applied	\N	\N	\N	\N	85904	85904	253805
8584	7232	2	applied	\N	\N	\N	\N	85905	85905	253806
8584	7202	3	applied	\N	\N	\N	\N	85906	85906	253807
8584	7203	4	applied	\N	\N	1000000000	\N	85907	85907	253808
8584	7204	5	applied	\N	\N	\N	\N	85908	85908	253809
8584	7205	6	applied	\N	\N	\N	\N	85909	85909	253810
8584	7207	8	applied	\N	\N	\N	\N	85911	85911	253812
8584	7208	9	applied	\N	\N	\N	\N	85912	85912	253813
8584	7209	10	applied	\N	\N	\N	\N	85913	85913	253814
8584	7210	11	applied	\N	\N	\N	\N	85914	85914	253815
8584	7211	12	applied	\N	\N	\N	\N	85915	85915	253816
8584	7212	13	applied	\N	\N	\N	\N	85916	85916	253817
8584	7213	14	applied	\N	\N	\N	\N	85917	85917	253818
8584	7214	15	applied	\N	\N	\N	\N	85918	85918	253819
8584	7215	16	applied	\N	\N	\N	\N	85919	85919	253820
8584	7216	17	applied	\N	\N	\N	\N	85920	85920	253821
8584	7217	18	applied	\N	\N	\N	\N	85921	85921	253822
8584	7218	19	applied	\N	\N	\N	\N	85922	85922	253823
8584	7219	20	applied	\N	\N	\N	\N	85923	85923	253824
8286	7081	1	applied	\N	\N	\N	\N	85258	85258	253160
8289	7083	0	applied	\N	\N	\N	\N	85262	85262	253164
8310	7045	59	applied	\N	\N	\N	\N	85356	85356	253258
8310	7046	60	applied	\N	\N	\N	\N	85357	85357	253259
8310	7047	61	applied	\N	\N	\N	\N	85358	85358	253260
8310	7048	62	applied	\N	\N	\N	\N	85359	85359	253261
8310	7050	63	applied	\N	\N	\N	\N	85360	85360	253262
8310	7052	65	applied	\N	\N	\N	\N	85362	85362	253264
8310	7054	66	applied	\N	\N	\N	\N	85363	85363	253265
8310	7055	67	applied	\N	\N	\N	\N	85364	85364	253266
8310	7056	68	applied	\N	\N	\N	\N	85365	85365	253267
8310	7057	69	applied	\N	\N	\N	\N	85366	85366	253268
8310	7058	70	applied	\N	\N	\N	\N	85367	85367	253269
8310	7059	71	applied	\N	\N	\N	\N	85368	85368	253270
8310	7061	72	applied	\N	\N	\N	\N	85369	85369	253271
8310	7062	73	applied	\N	\N	\N	\N	85370	85370	253272
8310	7063	74	applied	\N	\N	\N	\N	85371	85371	253273
8310	7064	75	applied	\N	\N	\N	\N	85372	85372	253274
8310	7067	76	applied	\N	\N	\N	\N	85373	85373	253275
8310	7068	77	applied	\N	\N	\N	\N	85374	85374	253276
8310	7069	78	applied	\N	\N	\N	\N	85375	85375	253277
8310	7070	79	applied	\N	\N	\N	\N	85376	85376	253278
8310	7071	80	applied	\N	\N	\N	\N	85377	85377	253279
8310	7073	82	applied	\N	\N	\N	\N	85379	85379	253281
8310	7075	83	applied	\N	\N	\N	\N	85380	85380	253282
8310	7076	84	applied	\N	\N	\N	\N	85381	85381	253283
8310	7078	85	applied	\N	\N	\N	\N	85382	85382	253284
8310	7079	86	applied	\N	\N	\N	\N	85383	85383	253285
8310	7080	87	applied	\N	\N	\N	\N	85384	85384	253286
8310	7081	88	applied	\N	\N	\N	\N	85385	85385	253287
8310	7082	89	applied	\N	\N	\N	\N	85386	85386	253288
8310	7083	90	applied	\N	\N	\N	\N	85387	85387	253289
8310	7085	91	applied	\N	\N	\N	\N	85388	85388	253290
8310	7086	92	applied	\N	\N	\N	\N	85389	85389	253291
8310	7088	93	applied	\N	\N	\N	\N	85390	85390	253292
8310	7089	94	applied	\N	\N	\N	\N	85391	85391	253293
8310	7091	95	applied	\N	\N	\N	\N	85392	85392	253294
8310	7092	96	applied	\N	\N	\N	\N	85393	85393	253295
8310	7093	97	applied	\N	\N	\N	\N	85394	85394	253296
8310	7084	99	applied	\N	\N	1000000000	\N	85396	85396	253298
8310	7090	100	applied	\N	\N	\N	\N	85397	85397	253299
8310	7049	101	applied	\N	\N	\N	\N	85398	85398	253300
8310	7065	102	applied	\N	\N	\N	\N	85399	85399	253301
8310	7094	103	applied	\N	\N	\N	\N	85400	85400	253302
8310	7074	104	applied	\N	\N	1000000000	\N	85401	85401	253303
8318	7104	0	applied	\N	\N	\N	\N	85418	85418	253320
8318	7105	1	applied	\N	\N	\N	\N	85419	85419	253321
8318	7106	2	applied	\N	\N	\N	\N	85420	85420	253322
8318	7107	3	applied	\N	\N	\N	\N	85421	85421	253323
8318	7108	4	applied	\N	\N	\N	\N	85422	85422	253324
8320	7110	0	applied	\N	\N	\N	\N	85424	85424	253326
8325	7113	0	applied	\N	\N	\N	\N	85431	85431	253333
8325	7114	1	applied	\N	\N	\N	\N	85432	85432	253334
8328	7115	0	applied	\N	\N	\N	\N	85435	85435	253337
8330	7117	0	applied	\N	\N	\N	\N	85437	85437	253339
8342	7126	1	applied	\N	\N	\N	\N	85450	85450	253352
8342	7127	2	applied	\N	\N	\N	\N	85451	85451	253353
8348	7136	0	applied	\N	\N	\N	\N	85466	85466	253368
8348	7137	1	applied	\N	\N	\N	\N	85467	85467	253369
8348	7138	2	applied	\N	\N	1000000000	\N	85468	85468	253370
8350	7139	0	applied	\N	\N	\N	\N	85472	85472	253374
8350	7140	1	applied	\N	\N	\N	\N	85473	85473	253375
8350	7141	2	applied	\N	\N	\N	\N	85474	85474	253376
8353	7139	0	applied	\N	\N	\N	\N	85481	85481	253383
8353	7140	1	applied	\N	\N	\N	\N	85482	85482	253384
8353	7141	2	applied	\N	\N	\N	\N	85483	85483	253385
8355	7146	0	applied	\N	\N	\N	\N	85488	85488	253389
8355	7147	1	applied	\N	\N	\N	\N	85489	85489	253390
8358	7148	0	applied	\N	\N	\N	\N	85494	85494	253395
8358	7149	1	applied	\N	\N	\N	\N	85495	85495	253396
8361	7154	0	applied	\N	\N	\N	\N	85500	85500	253401
8364	7159	0	applied	\N	\N	\N	\N	85505	85505	253406
8388	7003	12	applied	\N	\N	\N	\N	85565	85565	253466
8388	7004	13	applied	\N	\N	\N	\N	85566	85566	253467
8388	7138	14	applied	\N	\N	1000000000	\N	85567	85567	253468
8388	7005	15	applied	\N	\N	\N	\N	85568	85568	253469
8388	7006	16	applied	\N	\N	\N	\N	85569	85569	253470
8388	7007	17	applied	\N	\N	\N	\N	85570	85570	253471
8388	7008	18	applied	\N	\N	\N	\N	85571	85571	253472
8388	7009	19	applied	\N	\N	\N	\N	85572	85572	253473
8388	7010	20	applied	\N	\N	\N	\N	85573	85573	253474
8388	7011	21	applied	\N	\N	\N	\N	85574	85574	253475
8388	7012	22	applied	\N	\N	\N	\N	85575	85575	253476
8388	7013	23	applied	\N	\N	\N	\N	85576	85576	253477
8388	7014	24	applied	\N	\N	\N	\N	85577	85577	253478
8388	7015	25	applied	\N	\N	\N	\N	85578	85578	253479
8388	7016	26	applied	\N	\N	\N	\N	85579	85579	253480
8388	7018	28	applied	\N	\N	1000000000	\N	85581	85581	253482
8388	7019	29	applied	\N	\N	\N	\N	85582	85582	253483
8388	7020	30	applied	\N	\N	\N	\N	85583	85583	253484
8388	7021	31	applied	\N	\N	\N	\N	85584	85584	253485
8388	7022	32	applied	\N	\N	\N	\N	85585	85585	253486
8388	7023	33	applied	\N	\N	\N	\N	85586	85586	253487
8388	7024	34	applied	\N	\N	\N	\N	85587	85587	253488
8388	7025	35	applied	\N	\N	\N	\N	85588	85588	253489
8388	7026	36	applied	\N	\N	\N	\N	85589	85589	253490
8388	7027	37	applied	\N	\N	\N	\N	85590	85590	253491
8388	7028	38	applied	\N	\N	\N	\N	85591	85591	253492
8388	7029	39	applied	\N	\N	\N	\N	85592	85592	253493
8388	7030	40	applied	\N	\N	1000000000	\N	85593	85593	253494
8388	7031	41	applied	\N	\N	\N	\N	85594	85594	253495
8388	7032	42	applied	\N	\N	\N	\N	85595	85595	253496
8388	7033	43	applied	\N	\N	\N	\N	85596	85596	253497
8388	7035	45	applied	\N	\N	\N	\N	85598	85598	253499
8388	7036	46	applied	\N	\N	\N	\N	85599	85599	253500
8388	7037	47	applied	\N	\N	\N	\N	85600	85600	253501
8388	7038	48	applied	\N	\N	\N	\N	85601	85601	253502
8388	7039	49	applied	\N	\N	\N	\N	85602	85602	253503
8388	7040	50	applied	\N	\N	\N	\N	85603	85603	253504
8388	7041	51	applied	\N	\N	\N	\N	85604	85604	253505
8388	7042	52	applied	\N	\N	\N	\N	85605	85605	253506
8310	7043	57	applied	\N	\N	\N	\N	85354	85354	253256
8310	7044	58	applied	\N	\N	\N	\N	85355	85355	253257
8317	7106	2	applied	\N	\N	\N	\N	85415	85415	253317
8317	7107	3	applied	\N	\N	\N	\N	85416	85416	253318
8317	7108	4	applied	\N	\N	\N	\N	85417	85417	253319
8319	7109	0	applied	\N	\N	\N	\N	85423	85423	253325
8321	7110	0	applied	\N	\N	\N	\N	85425	85425	253327
8322	7110	0	applied	\N	\N	\N	\N	85426	85426	253328
8324	7113	0	applied	\N	\N	\N	\N	85429	85429	253331
8324	7114	1	applied	\N	\N	\N	\N	85430	85430	253332
8331	7118	0	applied	\N	\N	\N	\N	85438	85438	253340
8334	7121	0	applied	\N	\N	\N	\N	85441	85441	253343
8337	7124	0	applied	\N	\N	\N	\N	85445	85445	253347
8346	7135	0	applied	\N	\N	\N	\N	85462	85462	253364
8351	7139	0	applied	\N	\N	\N	\N	85475	85475	253377
8351	7140	1	applied	\N	\N	\N	\N	85476	85476	253378
8351	7141	2	applied	\N	\N	\N	\N	85477	85477	253379
8356	7146	0	applied	\N	\N	\N	\N	85490	85490	253391
8356	7147	1	applied	\N	\N	\N	\N	85491	85491	253392
8359	7150	0	applied	\N	\N	\N	\N	85496	85496	253397
8359	7151	1	applied	\N	\N	\N	\N	85497	85497	253398
8362	7156	0	applied	\N	\N	\N	\N	85502	85502	253403
8365	7159	0	applied	\N	\N	\N	\N	85506	85506	253407
8366	7160	0	applied	\N	\N	\N	\N	85507	85507	253408
8368	7161	0	applied	\N	\N	\N	\N	85509	85509	253410
8370	7162	0	applied	\N	\N	\N	\N	85511	85511	253412
8370	7163	1	applied	\N	\N	\N	\N	85512	85512	253413
8371	7164	0	applied	\N	\N	\N	\N	85513	85513	253414
8375	7168	0	applied	\N	\N	\N	\N	85518	85518	253419
8377	7170	0	applied	\N	\N	\N	\N	85524	85524	253425
8377	7171	1	applied	\N	\N	\N	\N	85525	85525	253426
8377	7172	2	applied	\N	\N	\N	\N	85526	85526	253427
8377	7173	3	applied	\N	\N	\N	\N	85527	85527	253428
8379	7170	0	applied	\N	\N	\N	\N	85532	85532	253433
8379	7171	1	applied	\N	\N	\N	\N	85533	85533	253434
8379	7172	2	applied	\N	\N	\N	\N	85534	85534	253435
8379	7173	3	applied	\N	\N	\N	\N	85535	85535	253436
8381	7174	0	applied	\N	\N	\N	\N	85540	85540	253441
8381	7175	1	applied	\N	\N	\N	\N	85541	85541	253442
8384	7181	0	applied	\N	\N	\N	\N	85549	85549	253450
8385	7181	0	applied	\N	\N	\N	\N	85550	85550	253451
8386	7182	0	applied	\N	\N	\N	\N	85551	85551	253452
8390	7183	0	applied	\N	\N	\N	\N	85681	85681	253582
8390	7184	1	applied	\N	\N	\N	\N	85682	85682	253583
8392	7186	0	applied	\N	\N	\N	\N	85684	85684	253585
8394	7188	1	applied	\N	\N	\N	\N	85687	85687	253588
8396	7187	0	applied	\N	\N	\N	\N	85690	85690	253591
8396	7188	1	applied	\N	\N	\N	\N	85691	85691	253592
8399	7191	0	applied	\N	\N	\N	\N	85694	85694	253595
8400	7191	0	applied	\N	\N	\N	\N	85695	85695	253596
8401	7192	0	applied	\N	\N	\N	\N	85696	85696	253597
8403	7192	0	applied	\N	\N	\N	\N	85698	85698	253599
8405	7194	0	applied	\N	\N	\N	\N	85700	85700	253601
8406	7194	0	applied	\N	\N	\N	\N	85701	85701	253602
8408	7195	0	applied	\N	\N	\N	\N	85703	85703	253604
8410	7196	0	applied	\N	\N	\N	\N	85705	85705	253606
8412	7197	0	applied	\N	\N	\N	\N	85709	85709	253610
8412	7198	1	applied	\N	\N	1000000000	\N	85710	85710	253611
8412	7199	2	applied	\N	\N	\N	\N	85711	85711	253612
8448	7201	0	applied	\N	\N	\N	\N	85716	85716	253617
8449	7202	0	applied	\N	\N	\N	\N	85717	85717	253618
8449	7204	2	applied	\N	\N	\N	\N	85719	85719	253620
8451	7205	0	applied	\N	\N	\N	\N	85723	85723	253624
8452	7205	0	applied	\N	\N	\N	\N	85724	85724	253625
8453	7206	0	applied	\N	\N	\N	\N	85725	85725	253626
8456	7208	0	applied	\N	\N	\N	\N	85728	85728	253629
8458	7208	0	applied	\N	\N	\N	\N	85730	85730	253631
8459	7208	0	applied	\N	\N	\N	\N	85731	85731	253632
8460	7166	0	applied	\N	\N	1000000000	\N	85732	85732	253633
8460	7179	1	applied	\N	\N	\N	\N	85733	85733	253634
8460	7162	2	applied	\N	\N	\N	\N	85734	85734	253635
8460	7163	3	applied	\N	\N	\N	\N	85735	85735	253636
8460	7164	4	applied	\N	\N	\N	\N	85736	85736	253637
8460	7165	5	applied	\N	\N	\N	\N	85737	85737	253638
8462	7209	0	applied	\N	\N	\N	\N	85739	85739	253640
8464	7211	0	applied	\N	\N	\N	\N	85741	85741	253642
8467	7212	0	applied	\N	\N	\N	\N	85744	85744	253645
8470	7218	0	applied	\N	\N	\N	\N	85755	85755	253656
8472	7219	0	applied	\N	\N	\N	\N	85757	85757	253658
8476	7221	0	applied	\N	\N	\N	\N	85761	85761	253662
8481	7225	0	applied	\N	\N	\N	\N	85768	85768	253669
8481	7226	1	applied	\N	\N	\N	\N	85769	85769	253670
8483	7225	0	applied	\N	\N	\N	\N	85772	85772	253673
8483	7226	1	applied	\N	\N	\N	\N	85773	85773	253674
8487	7229	0	applied	\N	\N	\N	\N	85780	85780	253681
8488	7229	0	applied	\N	\N	\N	\N	85781	85781	253682
8490	7231	0	applied	\N	\N	\N	\N	85783	85783	253684
8490	7232	1	applied	\N	\N	\N	\N	85784	85784	253685
8490	7233	2	applied	\N	\N	\N	\N	85785	85785	253686
8491	7231	0	applied	\N	\N	\N	\N	85786	85786	253687
8491	7232	1	applied	\N	\N	\N	\N	85787	85787	253688
8491	7233	2	applied	\N	\N	\N	\N	85788	85788	253689
8492	7234	0	applied	\N	\N	\N	\N	85789	85789	253690
8493	7234	0	applied	\N	\N	\N	\N	85790	85790	253691
8495	7235	0	applied	\N	\N	\N	\N	85792	85792	253693
8499	7237	0	applied	\N	\N	\N	\N	85796	85796	253697
8501	7238	0	applied	\N	\N	\N	\N	85798	85798	253699
8502	7238	0	applied	\N	\N	\N	\N	85799	85799	253700
8504	7240	0	applied	\N	\N	\N	\N	85801	85801	253702
8508	7242	0	applied	\N	\N	\N	\N	85805	85805	253706
8511	7244	0	applied	\N	\N	\N	\N	85808	85808	253709
8513	7245	0	applied	\N	\N	\N	\N	85810	85810	253711
8516	7247	0	applied	\N	\N	\N	\N	85813	85813	253714
8519	7248	0	applied	\N	\N	\N	\N	85818	85818	253719
8519	7249	1	applied	\N	\N	\N	\N	85819	85819	253720
8528	7257	0	applied	\N	\N	\N	\N	85832	85832	253733
8530	7258	0	applied	\N	\N	\N	\N	85833	85833	253734
8530	7259	1	applied	\N	\N	\N	\N	85834	85834	253735
8535	7262	0	applied	\N	\N	\N	\N	85840	85840	253741
8538	7267	0	applied	\N	\N	\N	\N	85846	85846	253747
8543	7269	0	applied	\N	\N	\N	\N	85852	85852	253753
8317	7104	0	applied	\N	\N	\N	\N	85413	85413	253315
8317	7105	1	applied	\N	\N	\N	\N	85414	85414	253316
8388	7046	56	applied	\N	\N	\N	\N	85609	85609	253510
8388	7047	57	applied	\N	\N	\N	\N	85610	85610	253511
8388	7048	58	applied	\N	\N	\N	\N	85611	85611	253512
8388	7050	59	applied	\N	\N	\N	\N	85612	85612	253513
8388	7051	60	applied	\N	\N	\N	\N	85613	85613	253514
8388	7052	61	applied	\N	\N	\N	\N	85614	85614	253515
8388	7054	62	applied	\N	\N	\N	\N	85615	85615	253516
8388	7055	63	applied	\N	\N	\N	\N	85616	85616	253517
8388	7056	64	applied	\N	\N	\N	\N	85617	85617	253518
8388	7057	65	applied	\N	\N	\N	\N	85618	85618	253519
8388	7058	66	applied	\N	\N	\N	\N	85619	85619	253520
8388	7061	68	applied	\N	\N	\N	\N	85621	85621	253522
8388	7062	69	applied	\N	\N	\N	\N	85622	85622	253523
8388	7063	70	applied	\N	\N	\N	\N	85623	85623	253524
8388	7064	71	applied	\N	\N	\N	\N	85624	85624	253525
8388	7067	72	applied	\N	\N	\N	\N	85625	85625	253526
8388	7068	73	applied	\N	\N	\N	\N	85626	85626	253527
8388	7069	74	applied	\N	\N	\N	\N	85627	85627	253528
8388	7070	75	applied	\N	\N	\N	\N	85628	85628	253529
8388	7071	76	applied	\N	\N	\N	\N	85629	85629	253530
8388	7072	77	applied	\N	\N	\N	\N	85630	85630	253531
8388	7073	78	applied	\N	\N	\N	\N	85631	85631	253532
8388	7075	79	applied	\N	\N	\N	\N	85632	85632	253533
8388	7076	80	applied	\N	\N	\N	\N	85633	85633	253534
8388	7078	81	applied	\N	\N	\N	\N	85634	85634	253535
8388	7079	82	applied	\N	\N	\N	\N	85635	85635	253536
8388	7080	83	applied	\N	\N	\N	\N	85636	85636	253537
8388	7082	85	applied	\N	\N	\N	\N	85638	85638	253539
8388	7083	86	applied	\N	\N	\N	\N	85639	85639	253540
8388	7085	87	applied	\N	\N	\N	\N	85640	85640	253541
8388	7086	88	applied	\N	\N	\N	\N	85641	85641	253542
8388	7088	89	applied	\N	\N	\N	\N	85642	85642	253543
8388	7089	90	applied	\N	\N	\N	\N	85643	85643	253544
8388	7091	91	applied	\N	\N	\N	\N	85644	85644	253545
8388	7092	92	applied	\N	\N	\N	\N	85645	85645	253546
8388	7093	93	applied	\N	\N	\N	\N	85646	85646	253547
8388	7095	94	applied	\N	\N	\N	\N	85647	85647	253548
8388	7096	95	applied	\N	\N	\N	\N	85648	85648	253549
8388	7097	96	applied	\N	\N	\N	\N	85649	85649	253550
8388	7099	97	applied	\N	\N	\N	\N	85650	85650	253551
8388	7100	98	applied	\N	\N	\N	\N	85651	85651	253552
8388	7101	99	applied	\N	\N	\N	\N	85652	85652	253553
8388	7103	100	applied	\N	\N	\N	\N	85653	85653	253554
8388	7106	102	applied	\N	\N	\N	\N	85655	85655	253556
8388	7107	103	applied	\N	\N	\N	\N	85656	85656	253557
8388	7109	104	applied	\N	\N	\N	\N	85657	85657	253558
8388	7111	105	applied	\N	\N	\N	\N	85658	85658	253559
8388	7112	106	applied	\N	\N	\N	\N	85659	85659	253560
8388	7113	107	applied	\N	\N	\N	\N	85660	85660	253561
8388	7114	108	applied	\N	\N	\N	\N	85661	85661	253562
8388	7115	109	applied	\N	\N	\N	\N	85662	85662	253563
8388	7116	110	applied	\N	\N	\N	\N	85663	85663	253564
8388	7117	111	applied	\N	\N	\N	\N	85664	85664	253565
8388	7118	112	applied	\N	\N	\N	\N	85665	85665	253566
8388	7119	113	applied	\N	\N	\N	\N	85666	85666	253567
8388	7120	114	applied	\N	\N	\N	\N	85667	85667	253568
8388	7121	115	applied	\N	\N	\N	\N	85668	85668	253569
8388	7122	116	applied	\N	\N	\N	\N	85669	85669	253570
8388	7123	117	applied	\N	\N	\N	\N	85670	85670	253571
8388	7125	119	applied	\N	\N	\N	\N	85672	85672	253573
8388	7126	120	applied	\N	\N	\N	\N	85673	85673	253574
8388	7127	121	applied	\N	\N	\N	\N	85674	85674	253575
8388	7128	122	applied	\N	\N	1000000000	\N	85675	85675	253576
8388	7129	123	applied	\N	\N	\N	\N	85676	85676	253577
8388	7130	124	applied	\N	\N	1000000000	\N	85677	85677	253578
8388	7131	125	applied	\N	\N	1000000000	\N	85678	85678	253579
8393	7186	0	applied	\N	\N	\N	\N	85685	85685	253586
8395	7187	0	applied	\N	\N	\N	\N	85688	85688	253589
8395	7188	1	applied	\N	\N	\N	\N	85689	85689	253590
8397	7189	0	applied	\N	\N	\N	\N	85692	85692	253593
8545	7271	0	applied	\N	\N	\N	\N	85856	85856	253757
8548	7274	0	applied	\N	\N	\N	\N	85861	85861	253762
8550	7275	0	applied	\N	\N	\N	\N	85863	85863	253764
8555	7278	0	applied	\N	\N	\N	\N	85866	85866	253767
8560	7281	0	applied	\N	\N	\N	\N	85871	85871	253772
8563	7286	1	applied	\N	\N	\N	\N	85876	85876	253777
8565	7287	0	applied	\N	\N	\N	\N	85879	85879	253780
8570	7289	0	applied	\N	\N	\N	\N	85884	85884	253785
8570	7290	1	applied	\N	\N	\N	\N	85885	85885	253786
8573	7291	0	applied	\N	\N	\N	\N	85890	85890	253791
8573	7292	1	applied	\N	\N	\N	\N	85891	85891	253792
8575	7293	0	applied	\N	\N	\N	\N	85893	85893	253794
8580	7299	0	applied	\N	\N	\N	\N	85899	85899	253800
8587	7303	0	applied	\N	\N	\N	\N	86006	86006	253907
8589	7303	0	applied	\N	\N	\N	\N	86008	86008	253909
8592	7306	0	applied	\N	\N	\N	\N	86012	86012	253913
8599	7311	0	applied	\N	\N	\N	\N	86020	86020	253921
8601	7312	0	applied	\N	\N	\N	\N	86022	86022	253923
8603	7313	0	applied	\N	\N	\N	\N	86024	86024	253925
8603	7314	1	applied	\N	\N	\N	\N	86025	86025	253926
8603	7315	2	applied	\N	\N	\N	\N	86026	86026	253927
8603	7317	4	applied	\N	\N	\N	\N	86028	86028	253929
8603	7318	5	applied	\N	\N	\N	\N	86029	86029	253930
8603	7319	6	applied	\N	\N	\N	\N	86030	86030	253931
8603	7320	8	applied	\N	\N	\N	\N	86031	86031	253932
8603	7321	9	applied	\N	\N	\N	\N	86032	86032	253933
8603	7322	10	applied	\N	\N	\N	\N	86033	86033	253934
8603	7323	11	applied	\N	\N	\N	\N	86034	86034	253935
8603	7324	12	applied	\N	\N	\N	\N	86035	86035	253936
8603	7325	13	applied	\N	\N	\N	\N	86036	86036	253937
8603	7326	14	applied	\N	\N	\N	\N	86037	86037	253938
8603	7327	15	applied	\N	\N	\N	\N	86038	86038	253939
8603	7328	16	applied	\N	\N	\N	\N	86039	86039	253940
8603	7329	17	applied	\N	\N	\N	\N	86040	86040	253941
8603	7330	18	applied	\N	\N	\N	\N	86041	86041	253942
8606	7301	0	applied	\N	\N	\N	\N	86078	86078	253979
8606	7302	1	applied	\N	\N	\N	\N	86079	86079	253980
8606	7304	3	applied	\N	\N	\N	\N	86081	86081	253982
8606	7305	4	applied	\N	\N	\N	\N	86082	86082	253983
8388	7044	54	applied	\N	\N	\N	\N	85607	85607	253508
8388	7045	55	applied	\N	\N	\N	\N	85608	85608	253509
8411	7197	0	applied	\N	\N	\N	\N	85706	85706	253607
8411	7198	1	applied	\N	\N	1000000000	\N	85707	85707	253608
8411	7199	2	applied	\N	\N	\N	\N	85708	85708	253609
8413	7197	0	applied	\N	\N	\N	\N	85712	85712	253613
8413	7198	1	applied	\N	\N	1000000000	\N	85713	85713	253614
8413	7199	2	applied	\N	\N	\N	\N	85714	85714	253615
8447	7200	0	applied	\N	\N	\N	\N	85715	85715	253616
8450	7203	1	applied	\N	\N	1000000000	\N	85721	85721	253622
8450	7204	2	applied	\N	\N	\N	\N	85722	85722	253623
8454	7206	0	applied	\N	\N	\N	\N	85726	85726	253627
8465	7212	0	applied	\N	\N	\N	\N	85742	85742	253643
8468	7213	0	applied	\N	\N	\N	\N	85745	85745	253646
8468	7214	1	applied	\N	\N	\N	\N	85746	85746	253647
8468	7215	2	applied	\N	\N	\N	\N	85747	85747	253648
8468	7216	3	applied	\N	\N	\N	\N	85748	85748	253649
8468	7217	4	applied	\N	\N	\N	\N	85749	85749	253650
8471	7218	0	applied	\N	\N	\N	\N	85756	85756	253657
8473	7219	0	applied	\N	\N	\N	\N	85758	85758	253659
8477	7222	0	applied	\N	\N	\N	\N	85762	85762	253663
8477	7223	1	applied	\N	\N	1000000000	\N	85763	85763	253664
8479	7224	0	applied	\N	\N	\N	\N	85766	85766	253667
8482	7225	0	applied	\N	\N	\N	\N	85770	85770	253671
8482	7226	1	applied	\N	\N	\N	\N	85771	85771	253672
8484	7228	1	applied	\N	\N	\N	\N	85775	85775	253676
8486	7227	0	applied	\N	\N	\N	\N	85778	85778	253679
8486	7228	1	applied	\N	\N	\N	\N	85779	85779	253680
8500	7237	0	applied	\N	\N	\N	\N	85797	85797	253698
8505	7241	0	applied	\N	\N	\N	\N	85802	85802	253703
8507	7242	0	applied	\N	\N	\N	\N	85804	85804	253705
8509	7242	0	applied	\N	\N	\N	\N	85806	85806	253707
8512	7244	0	applied	\N	\N	\N	\N	85809	85809	253710
8514	7246	0	applied	\N	\N	\N	\N	85811	85811	253712
8517	7248	0	applied	\N	\N	\N	\N	85814	85814	253715
8517	7249	1	applied	\N	\N	\N	\N	85815	85815	253716
8520	7248	0	applied	\N	\N	\N	\N	85820	85820	253721
8520	7249	1	applied	\N	\N	\N	\N	85821	85821	253722
8521	7250	0	applied	\N	\N	\N	\N	85822	85822	253723
8524	7256	0	applied	\N	\N	\N	\N	85828	85828	253729
8525	7256	0	applied	\N	\N	\N	\N	85829	85829	253730
8527	7257	0	applied	\N	\N	\N	\N	85831	85831	253732
8531	7258	0	applied	\N	\N	\N	\N	85835	85835	253736
8531	7259	1	applied	\N	\N	\N	\N	85836	85836	253737
8533	7260	0	applied	\N	\N	\N	\N	85838	85838	253739
8536	7262	0	applied	\N	\N	\N	\N	85841	85841	253742
8537	7263	0	applied	\N	\N	\N	\N	85842	85842	253743
8537	7264	1	applied	\N	\N	\N	\N	85843	85843	253744
8537	7265	2	applied	\N	\N	\N	\N	85844	85844	253745
8537	7266	3	applied	\N	\N	\N	\N	85845	85845	253746
8539	7267	0	applied	\N	\N	\N	\N	85847	85847	253748
8541	7268	0	applied	\N	\N	\N	\N	85849	85849	253750
8542	7269	0	applied	\N	\N	\N	\N	85850	85850	253751
8542	7270	1	applied	\N	\N	\N	\N	85851	85851	253752
8544	7269	0	applied	\N	\N	\N	\N	85854	85854	253755
8544	7270	1	applied	\N	\N	\N	\N	85855	85855	253756
8546	7272	0	applied	\N	\N	\N	\N	85857	85857	253758
8547	7272	0	applied	\N	\N	\N	\N	85859	85859	253760
8547	7273	1	applied	\N	\N	\N	\N	85860	85860	253761
8549	7274	0	applied	\N	\N	\N	\N	85862	85862	253763
8553	7276	0	applied	\N	\N	\N	\N	85864	85864	253765
8556	7279	0	applied	\N	\N	\N	\N	85867	85867	253768
8558	7280	0	applied	\N	\N	\N	\N	85869	85869	253770
8561	7282	0	applied	\N	\N	\N	\N	85872	85872	253773
8564	7285	0	applied	\N	\N	\N	\N	85877	85877	253778
8564	7286	1	applied	\N	\N	\N	\N	85878	85878	253779
8566	7287	0	applied	\N	\N	\N	\N	85880	85880	253781
8568	7288	0	applied	\N	\N	\N	\N	85882	85882	253783
8571	7289	0	applied	\N	\N	\N	\N	85886	85886	253787
8571	7290	1	applied	\N	\N	\N	\N	85887	85887	253788
8576	7294	0	applied	\N	\N	\N	\N	85894	85894	253795
8576	7295	1	applied	\N	\N	\N	\N	85895	85895	253796
8578	7297	0	applied	\N	\N	\N	\N	85897	85897	253798
8581	7299	0	applied	\N	\N	\N	\N	85900	85900	253801
8582	7299	0	applied	\N	\N	\N	\N	85901	85901	253802
8583	7300	0	applied	\N	\N	\N	\N	85902	85902	253803
8585	7301	0	applied	\N	\N	\N	\N	86004	86004	253905
8586	7302	0	applied	\N	\N	\N	\N	86005	86005	253906
8588	7303	0	applied	\N	\N	\N	\N	86007	86007	253908
8590	7304	0	applied	\N	\N	\N	\N	86009	86009	253910
8590	7305	1	applied	\N	\N	\N	\N	86010	86010	253911
8591	7306	0	applied	\N	\N	\N	\N	86011	86011	253912
8593	7306	0	applied	\N	\N	\N	\N	86013	86013	253914
8595	7307	0	applied	\N	\N	\N	\N	86015	86015	253916
8595	7308	1	applied	\N	\N	1000000000	\N	86016	86016	253917
8597	7309	0	applied	\N	\N	\N	\N	86018	86018	253919
8600	7311	0	applied	\N	\N	\N	\N	86021	86021	253922
8602	7312	0	applied	\N	\N	\N	\N	86023	86023	253924
8604	7313	0	applied	\N	\N	\N	\N	86042	86042	253943
8604	7315	2	applied	\N	\N	\N	\N	86044	86044	253945
8604	7316	3	applied	\N	\N	\N	\N	86045	86045	253946
8604	7317	4	applied	\N	\N	\N	\N	86046	86046	253947
8604	7318	5	applied	\N	\N	\N	\N	86047	86047	253948
8604	7319	6	applied	\N	\N	\N	\N	86048	86048	253949
8604	7320	8	applied	\N	\N	\N	\N	86049	86049	253950
8604	7321	9	applied	\N	\N	\N	\N	86050	86050	253951
8604	7322	10	applied	\N	\N	\N	\N	86051	86051	253952
8604	7323	11	applied	\N	\N	\N	\N	86052	86052	253953
8604	7324	12	applied	\N	\N	\N	\N	86053	86053	253954
8604	7325	13	applied	\N	\N	\N	\N	86054	86054	253955
8604	7326	14	applied	\N	\N	\N	\N	86055	86055	253956
8604	7327	15	applied	\N	\N	\N	\N	86056	86056	253957
8604	7328	16	applied	\N	\N	\N	\N	86057	86057	253958
8604	7329	17	applied	\N	\N	\N	\N	86058	86058	253959
8604	7330	18	applied	\N	\N	\N	\N	86059	86059	253960
8605	7314	1	applied	\N	\N	\N	\N	86061	86061	253962
8605	7315	2	applied	\N	\N	\N	\N	86062	86062	253963
8605	7316	3	applied	\N	\N	\N	\N	86063	86063	253964
8605	7317	4	applied	\N	\N	\N	\N	86064	86064	253965
8605	7318	5	applied	\N	\N	\N	\N	86065	86065	253966
8609	7335	0	applied	\N	\N	\N	\N	86116	86116	254017
8404	7193	0	applied	\N	\N	\N	\N	85699	85699	253600
8407	7194	0	applied	\N	\N	\N	\N	85702	85702	253603
8584	7223	24	applied	\N	\N	1000000000	\N	85927	85927	253828
8584	7224	25	applied	\N	\N	\N	\N	85928	85928	253829
8584	7226	26	applied	\N	\N	\N	\N	85929	85929	253830
8584	7227	27	applied	\N	\N	\N	\N	85930	85930	253831
8584	7228	28	applied	\N	\N	\N	\N	85931	85931	253832
8584	7229	29	applied	\N	\N	\N	\N	85932	85932	253833
8584	7230	30	applied	\N	\N	\N	\N	85933	85933	253834
8584	7231	31	applied	\N	\N	\N	\N	85934	85934	253835
8584	7233	32	applied	\N	\N	\N	\N	85935	85935	253836
8584	7234	33	applied	\N	\N	\N	\N	85936	85936	253837
8584	7235	34	applied	\N	\N	\N	\N	85937	85937	253838
8584	7236	35	applied	\N	\N	\N	\N	85938	85938	253839
8584	7237	36	applied	\N	\N	\N	\N	85939	85939	253840
8584	7239	38	applied	\N	\N	\N	\N	85941	85941	253842
8584	7240	39	applied	\N	\N	\N	\N	85942	85942	253843
8584	7241	40	applied	\N	\N	\N	\N	85943	85943	253844
8584	7242	41	applied	\N	\N	\N	\N	85944	85944	253845
8584	7243	42	applied	\N	\N	\N	\N	85945	85945	253846
8584	7244	44	applied	\N	\N	\N	\N	85946	85946	253847
8584	7245	45	applied	\N	\N	\N	\N	85947	85947	253848
8584	7246	46	applied	\N	\N	\N	\N	85948	85948	253849
8584	7247	47	applied	\N	\N	\N	\N	85949	85949	253850
8584	7248	48	applied	\N	\N	\N	\N	85950	85950	253851
8584	7249	49	applied	\N	\N	\N	\N	85951	85951	253852
8584	7250	50	applied	\N	\N	\N	\N	85952	85952	253853
8584	7251	51	applied	\N	\N	\N	\N	85953	85953	253854
8584	7252	52	applied	\N	\N	\N	\N	85954	85954	253855
8584	7254	53	applied	\N	\N	\N	\N	85955	85955	253856
8584	7255	54	applied	\N	\N	\N	\N	85956	85956	253857
8584	7257	56	applied	\N	\N	\N	\N	85958	85958	253859
8584	7258	57	applied	\N	\N	\N	\N	85959	85959	253860
8584	7259	58	applied	\N	\N	\N	\N	85960	85960	253861
8584	7260	59	applied	\N	\N	\N	\N	85961	85961	253862
8584	7261	60	applied	\N	\N	\N	\N	85962	85962	253863
8584	7262	61	applied	\N	\N	\N	\N	85963	85963	253864
8584	7263	62	applied	\N	\N	\N	\N	85964	85964	253865
8584	7264	63	applied	\N	\N	\N	\N	85965	85965	253866
8584	7265	64	applied	\N	\N	\N	\N	85966	85966	253867
8584	7266	65	applied	\N	\N	\N	\N	85967	85967	253868
8584	7267	66	applied	\N	\N	\N	\N	85968	85968	253869
8584	7268	67	applied	\N	\N	\N	\N	85969	85969	253870
8584	7269	68	applied	\N	\N	\N	\N	85970	85970	253871
8584	7270	69	applied	\N	\N	\N	\N	85971	85971	253872
8584	7271	70	applied	\N	\N	\N	\N	85972	85972	253873
8584	7272	71	applied	\N	\N	\N	\N	85973	85973	253874
8584	7274	73	applied	\N	\N	\N	\N	85975	85975	253876
8584	7275	74	applied	\N	\N	\N	\N	85976	85976	253877
8584	7276	75	applied	\N	\N	\N	\N	85977	85977	253878
8584	7277	76	applied	\N	\N	\N	\N	85978	85978	253879
8584	7278	77	applied	\N	\N	\N	\N	85979	85979	253880
8584	7279	78	applied	\N	\N	\N	\N	85980	85980	253881
8584	7280	79	applied	\N	\N	\N	\N	85981	85981	253882
8584	7281	80	applied	\N	\N	\N	\N	85982	85982	253883
8584	7282	81	applied	\N	\N	\N	\N	85983	85983	253884
8584	7283	82	applied	\N	\N	\N	\N	85984	85984	253885
8584	7284	83	applied	\N	\N	\N	\N	85985	85985	253886
8584	7285	84	applied	\N	\N	\N	\N	85986	85986	253887
8584	7286	85	applied	\N	\N	\N	\N	85987	85987	253888
8584	7287	86	applied	\N	\N	\N	\N	85988	85988	253889
8584	7288	87	applied	\N	\N	\N	\N	85989	85989	253890
8584	7289	88	applied	\N	\N	\N	\N	85990	85990	253891
8584	7291	90	applied	\N	\N	\N	\N	85992	85992	253893
8584	7292	91	applied	\N	\N	\N	\N	85993	85993	253894
8584	7293	92	applied	\N	\N	\N	\N	85994	85994	253895
8584	7294	93	applied	\N	\N	\N	\N	85995	85995	253896
8584	7295	94	applied	\N	\N	\N	\N	85996	85996	253897
8584	7296	95	applied	\N	\N	\N	\N	85997	85997	253898
8584	7297	96	applied	\N	\N	\N	\N	85998	85998	253899
8584	7298	97	applied	\N	\N	\N	\N	85999	85999	253900
8584	7299	98	applied	\N	\N	\N	\N	86000	86000	253901
8584	7300	99	applied	\N	\N	\N	\N	86001	86001	253902
8584	7253	100	applied	\N	\N	\N	\N	86002	86002	253903
8584	7201	101	applied	\N	\N	\N	\N	86003	86003	253904
8594	7306	0	applied	\N	\N	\N	\N	86014	86014	253915
8596	7309	0	applied	\N	\N	\N	\N	86017	86017	253918
8598	7310	0	applied	\N	\N	\N	\N	86019	86019	253920
8605	7319	6	applied	\N	\N	\N	\N	86066	86066	253967
8605	7321	9	applied	\N	\N	\N	\N	86068	86068	253969
8605	7322	10	applied	\N	\N	\N	\N	86069	86069	253970
8605	7323	11	applied	\N	\N	\N	\N	86070	86070	253971
8605	7324	12	applied	\N	\N	\N	\N	86071	86071	253972
8605	7325	13	applied	\N	\N	\N	\N	86072	86072	253973
8605	7326	14	applied	\N	\N	\N	\N	86073	86073	253974
8605	7327	15	applied	\N	\N	\N	\N	86074	86074	253975
8605	7328	16	applied	\N	\N	\N	\N	86075	86075	253976
8605	7329	17	applied	\N	\N	\N	\N	86076	86076	253977
8605	7330	18	applied	\N	\N	\N	\N	86077	86077	253978
8607	7331	0	applied	\N	\N	\N	\N	86111	86111	254012
8607	7332	1	applied	\N	\N	\N	\N	86112	86112	254013
8607	7333	2	applied	\N	\N	\N	\N	86113	86113	254014
8607	7334	3	applied	\N	\N	\N	\N	86114	86114	254015
8608	7335	0	applied	\N	\N	\N	\N	86115	86115	254016
8610	7225	0	applied	\N	\N	\N	\N	86117	86117	254018
8610	7232	2	applied	\N	\N	\N	\N	86119	86119	254020
8610	7157	3	applied	\N	\N	\N	\N	86120	86120	254021
8610	7158	4	applied	\N	\N	\N	\N	86121	86121	254022
8610	7159	5	applied	\N	\N	\N	\N	86122	86122	254023
8610	7160	6	applied	\N	\N	\N	\N	86123	86123	254024
8610	7161	7	applied	\N	\N	\N	\N	86124	86124	254025
8610	7166	8	applied	\N	\N	1000000000	\N	86125	86125	254026
8610	7179	9	applied	\N	\N	\N	\N	86126	86126	254027
8610	7162	10	applied	\N	\N	\N	\N	86127	86127	254028
8610	7163	11	applied	\N	\N	\N	\N	86128	86128	254029
8610	7164	12	applied	\N	\N	\N	\N	86129	86129	254030
8610	7165	13	applied	\N	\N	\N	\N	86130	86130	254031
8610	7167	14	applied	\N	\N	\N	\N	86131	86131	254032
8610	7168	15	applied	\N	\N	\N	\N	86132	86132	254033
8610	7172	16	applied	\N	\N	\N	\N	86133	86133	254034
8610	7173	17	applied	\N	\N	\N	\N	86134	86134	254035
8584	7221	22	applied	\N	\N	\N	\N	85925	85925	253826
8584	7222	23	applied	\N	\N	\N	\N	85926	85926	253827
8606	7310	8	applied	\N	\N	\N	\N	86086	86086	253987
8606	7311	9	applied	\N	\N	\N	\N	86087	86087	253988
8606	7312	10	applied	\N	\N	\N	\N	86088	86088	253989
8606	7313	11	applied	\N	\N	\N	\N	86089	86089	253990
8606	7314	12	applied	\N	\N	\N	\N	86090	86090	253991
8606	7315	13	applied	\N	\N	\N	\N	86091	86091	253992
8606	7316	14	applied	\N	\N	\N	\N	86092	86092	253993
8606	7318	16	applied	\N	\N	\N	\N	86094	86094	253995
8606	7319	17	applied	\N	\N	\N	\N	86095	86095	253996
8606	7320	18	applied	\N	\N	\N	\N	86096	86096	253997
8606	7331	19	applied	\N	\N	\N	\N	86097	86097	253998
8606	7332	20	applied	\N	\N	\N	\N	86098	86098	253999
8606	7333	21	applied	\N	\N	\N	\N	86099	86099	254000
8606	7308	22	applied	\N	\N	1000000000	\N	86100	86100	254001
8606	7321	23	applied	\N	\N	\N	\N	86101	86101	254002
8606	7322	24	applied	\N	\N	\N	\N	86102	86102	254003
8606	7323	25	applied	\N	\N	\N	\N	86103	86103	254004
8606	7324	26	applied	\N	\N	\N	\N	86104	86104	254005
8606	7325	27	applied	\N	\N	\N	\N	86105	86105	254006
8606	7326	28	applied	\N	\N	\N	\N	86106	86106	254007
8606	7327	29	applied	\N	\N	\N	\N	86107	86107	254008
8606	7328	30	applied	\N	\N	\N	\N	86108	86108	254009
8606	7329	31	applied	\N	\N	\N	\N	86109	86109	254010
8610	7175	19	applied	\N	\N	\N	\N	86136	86136	254037
8610	7176	20	applied	\N	\N	\N	\N	86137	86137	254038
8610	7177	21	applied	\N	\N	\N	\N	86138	86138	254039
8611	7336	0	applied	\N	\N	\N	\N	86139	86139	254040
8612	7337	0	applied	\N	\N	\N	\N	86140	86140	254041
8612	7338	1	applied	\N	\N	\N	\N	86141	86141	254042
8613	7337	0	applied	\N	\N	\N	\N	86142	86142	254043
8613	7338	1	applied	\N	\N	\N	\N	86143	86143	254044
8614	7337	0	applied	\N	\N	\N	\N	86144	86144	254045
8614	7338	1	applied	\N	\N	\N	\N	86145	86145	254046
8615	7339	0	applied	\N	\N	\N	\N	86146	86146	254047
8616	7339	0	applied	\N	\N	\N	\N	86147	86147	254048
8617	7340	0	applied	\N	\N	\N	\N	86148	86148	254049
8618	7340	0	applied	\N	\N	\N	\N	86149	86149	254050
8619	7341	0	applied	\N	\N	\N	\N	86150	86150	254051
8620	7342	0	applied	\N	\N	\N	\N	86151	86151	254052
8622	7343	0	applied	\N	\N	\N	\N	86153	86153	254054
8624	7344	0	applied	\N	\N	\N	\N	86154	86154	254055
8625	7343	0	applied	\N	\N	\N	\N	86155	86155	254056
8625	7344	1	applied	\N	\N	\N	\N	86156	86156	254057
8626	7225	0	applied	\N	\N	\N	\N	86157	86157	254058
8626	7232	1	applied	\N	\N	\N	\N	86158	86158	254059
8626	7161	2	applied	\N	\N	\N	\N	86159	86159	254060
8626	7166	3	applied	\N	\N	1000000000	\N	86160	86160	254061
8626	7179	4	applied	\N	\N	\N	\N	86161	86161	254062
8626	7162	5	applied	\N	\N	\N	\N	86162	86162	254063
8626	7163	6	applied	\N	\N	\N	\N	86163	86163	254064
8626	7164	7	applied	\N	\N	\N	\N	86164	86164	254065
8626	7165	8	applied	\N	\N	\N	\N	86165	86165	254066
8626	7167	10	applied	\N	\N	\N	\N	86166	86166	254067
8626	7168	11	applied	\N	\N	\N	\N	86167	86167	254068
8626	7172	12	applied	\N	\N	\N	\N	86168	86168	254069
8626	7174	14	applied	\N	\N	\N	\N	86170	86170	254071
8626	7175	15	applied	\N	\N	\N	\N	86171	86171	254072
8626	7176	16	applied	\N	\N	\N	\N	86172	86172	254073
8626	7177	17	applied	\N	\N	\N	\N	86173	86173	254074
8626	7178	18	applied	\N	\N	\N	\N	86174	86174	254075
8626	7181	19	applied	\N	\N	\N	\N	86175	86175	254076
8626	7182	20	applied	\N	\N	\N	\N	86176	86176	254077
8626	7183	21	applied	\N	\N	\N	\N	86177	86177	254078
8626	7185	22	applied	\N	\N	\N	\N	86178	86178	254079
8626	7186	23	applied	\N	\N	\N	\N	86179	86179	254080
8626	7187	24	applied	\N	\N	\N	\N	86180	86180	254081
8626	7189	25	applied	\N	\N	\N	\N	86181	86181	254082
8626	7190	26	applied	\N	\N	\N	\N	86182	86182	254083
8626	7191	27	applied	\N	\N	\N	\N	86183	86183	254084
8626	7192	28	applied	\N	\N	\N	\N	86184	86184	254085
8626	7193	29	applied	\N	\N	\N	\N	86185	86185	254086
8626	7195	31	applied	\N	\N	\N	\N	86187	86187	254088
8626	7196	32	applied	\N	\N	\N	\N	86188	86188	254089
8626	7197	33	applied	\N	\N	\N	\N	86189	86189	254090
8626	7198	34	applied	\N	\N	1000000000	\N	86190	86190	254091
8626	7199	35	applied	\N	\N	\N	\N	86191	86191	254092
8626	7202	36	applied	\N	\N	\N	\N	86192	86192	254093
8626	7203	37	applied	\N	\N	1000000000	\N	86193	86193	254094
8626	7204	38	applied	\N	\N	\N	\N	86194	86194	254095
8626	7205	39	applied	\N	\N	\N	\N	86195	86195	254096
8626	7206	40	applied	\N	\N	\N	\N	86196	86196	254097
8626	7207	41	applied	\N	\N	\N	\N	86197	86197	254098
8626	7208	42	applied	\N	\N	\N	\N	86198	86198	254099
8626	7209	43	applied	\N	\N	\N	\N	86199	86199	254100
8626	7210	44	applied	\N	\N	\N	\N	86200	86200	254101
8626	7211	45	applied	\N	\N	\N	\N	86201	86201	254102
8626	7212	46	applied	\N	\N	\N	\N	86202	86202	254103
8626	7214	48	applied	\N	\N	\N	\N	86204	86204	254105
8626	7215	49	applied	\N	\N	\N	\N	86205	86205	254106
8626	7216	50	applied	\N	\N	\N	\N	86206	86206	254107
8626	7217	51	applied	\N	\N	\N	\N	86207	86207	254108
8626	7218	52	applied	\N	\N	\N	\N	86208	86208	254109
8626	7219	53	applied	\N	\N	\N	\N	86209	86209	254110
8626	7220	54	applied	\N	\N	\N	\N	86210	86210	254111
8626	7221	55	applied	\N	\N	\N	\N	86211	86211	254112
8626	7222	56	applied	\N	\N	\N	\N	86212	86212	254113
8626	7223	57	applied	\N	\N	1000000000	\N	86213	86213	254114
8626	7224	58	applied	\N	\N	\N	\N	86214	86214	254115
8626	7226	59	applied	\N	\N	\N	\N	86215	86215	254116
8626	7227	60	applied	\N	\N	\N	\N	86216	86216	254117
8626	7228	61	applied	\N	\N	\N	\N	86217	86217	254118
8626	7229	62	applied	\N	\N	\N	\N	86218	86218	254119
8626	7230	63	applied	\N	\N	\N	\N	86219	86219	254120
8626	7233	65	applied	\N	\N	\N	\N	86221	86221	254122
8626	7234	66	applied	\N	\N	\N	\N	86222	86222	254123
8626	7235	67	applied	\N	\N	\N	\N	86223	86223	254124
8626	7236	68	applied	\N	\N	\N	\N	86224	86224	254125
8626	7237	69	applied	\N	\N	\N	\N	86225	86225	254126
8626	7238	70	applied	\N	\N	\N	\N	86226	86226	254127
8606	7307	6	applied	\N	\N	\N	\N	86084	86084	253985
8606	7309	7	applied	\N	\N	\N	\N	86085	86085	253986
8626	7243	75	applied	\N	\N	\N	\N	86231	86231	254132
8626	7244	76	applied	\N	\N	\N	\N	86232	86232	254133
8626	7245	77	applied	\N	\N	\N	\N	86233	86233	254134
8626	7246	78	applied	\N	\N	\N	\N	86234	86234	254135
8626	7247	79	applied	\N	\N	\N	\N	86235	86235	254136
8626	7248	80	applied	\N	\N	\N	\N	86236	86236	254137
8626	7249	81	applied	\N	\N	\N	\N	86237	86237	254138
8626	7250	82	applied	\N	\N	\N	\N	86238	86238	254139
8626	7251	83	applied	\N	\N	\N	\N	86239	86239	254140
8626	7252	84	applied	\N	\N	\N	\N	86240	86240	254141
8626	7254	85	applied	\N	\N	\N	\N	86241	86241	254142
8626	7255	86	applied	\N	\N	\N	\N	86242	86242	254143
8626	7256	87	applied	\N	\N	\N	\N	86243	86243	254144
8626	7257	88	applied	\N	\N	\N	\N	86244	86244	254145
8626	7258	89	applied	\N	\N	\N	\N	86245	86245	254146
8626	7259	90	applied	\N	\N	\N	\N	86246	86246	254147
8626	7261	92	applied	\N	\N	\N	\N	86248	86248	254149
8626	7262	93	applied	\N	\N	\N	\N	86249	86249	254150
8626	7263	94	applied	\N	\N	\N	\N	86250	86250	254151
8626	7264	95	applied	\N	\N	\N	\N	86251	86251	254152
8626	7265	96	applied	\N	\N	\N	\N	86252	86252	254153
8626	7266	97	applied	\N	\N	\N	\N	86253	86253	254154
8626	7267	98	applied	\N	\N	\N	\N	86254	86254	254155
8626	7268	99	applied	\N	\N	\N	\N	86255	86255	254156
8626	7269	100	applied	\N	\N	\N	\N	86256	86256	254157
8626	7270	101	applied	\N	\N	\N	\N	86257	86257	254158
8626	7271	102	applied	\N	\N	\N	\N	86258	86258	254159
8626	7272	103	applied	\N	\N	\N	\N	86259	86259	254160
8626	7273	104	applied	\N	\N	\N	\N	86260	86260	254161
8626	7274	105	applied	\N	\N	\N	\N	86261	86261	254162
8626	7275	106	applied	\N	\N	\N	\N	86262	86262	254163
8626	7276	107	applied	\N	\N	\N	\N	86263	86263	254164
8626	7278	109	applied	\N	\N	\N	\N	86265	86265	254166
8626	7279	110	applied	\N	\N	\N	\N	86266	86266	254167
8626	7280	111	applied	\N	\N	\N	\N	86267	86267	254168
8626	7281	112	applied	\N	\N	\N	\N	86268	86268	254169
8626	7282	113	applied	\N	\N	\N	\N	86269	86269	254170
8626	7283	114	applied	\N	\N	\N	\N	86270	86270	254171
8626	7284	115	applied	\N	\N	\N	\N	86271	86271	254172
8626	7285	116	applied	\N	\N	\N	\N	86272	86272	254173
8626	7286	117	applied	\N	\N	\N	\N	86273	86273	254174
8626	7287	118	applied	\N	\N	\N	\N	86274	86274	254175
8626	7288	119	applied	\N	\N	\N	\N	86275	86275	254176
8626	7289	120	applied	\N	\N	\N	\N	86276	86276	254177
8626	7290	121	applied	\N	\N	\N	\N	86277	86277	254178
8626	7291	122	applied	\N	\N	\N	\N	86278	86278	254179
8626	7292	123	applied	\N	\N	\N	\N	86279	86279	254180
8628	7345	0	applied	\N	\N	\N	\N	86282	86282	254183
8637	7351	0	applied	\N	\N	\N	\N	86386	86386	254287
8642	7352	0	applied	\N	\N	\N	\N	86391	86391	254292
8648	7361	0	applied	\N	\N	\N	\N	86403	86403	254304
8648	7362	1	applied	\N	\N	\N	\N	86404	86404	254305
8653	7368	0	applied	\N	\N	\N	\N	86412	86412	254313
8653	7369	1	applied	\N	\N	\N	\N	86413	86413	254314
8659	7370	0	applied	\N	\N	\N	\N	86419	86419	254320
8660	7370	0	applied	\N	\N	\N	\N	86420	86420	254321
8662	7371	0	applied	\N	\N	\N	\N	86422	86422	254323
8667	7375	0	applied	\N	\N	\N	\N	86428	86428	254329
8667	7376	1	applied	\N	\N	\N	\N	86429	86429	254330
8667	7377	2	applied	\N	\N	\N	\N	86430	86430	254331
8667	7378	3	applied	\N	\N	\N	\N	86431	86431	254332
8682	7349	0	applied	\N	\N	\N	\N	86441	86441	254342
8682	7383	1	applied	\N	\N	\N	\N	86442	86442	254343
8682	7378	2	applied	\N	\N	\N	\N	86443	86443	254344
8682	7368	4	applied	\N	\N	\N	\N	86445	86445	254346
8682	7301	5	applied	\N	\N	\N	\N	86446	86446	254347
8682	7302	6	applied	\N	\N	\N	\N	86447	86447	254348
8682	7303	7	applied	\N	\N	\N	\N	86448	86448	254349
8682	7304	8	applied	\N	\N	\N	\N	86449	86449	254350
8682	7305	9	applied	\N	\N	\N	\N	86450	86450	254351
8682	7306	10	applied	\N	\N	\N	\N	86451	86451	254352
8682	7307	11	applied	\N	\N	\N	\N	86452	86452	254353
8682	7309	12	applied	\N	\N	\N	\N	86453	86453	254354
8682	7384	13	applied	\N	\N	\N	\N	86454	86454	254355
8682	7385	14	applied	\N	\N	\N	\N	86455	86455	254356
8682	7386	15	applied	\N	\N	\N	\N	86456	86456	254357
8682	7310	16	applied	\N	\N	\N	\N	86457	86457	254358
8682	7311	17	applied	\N	\N	\N	\N	86458	86458	254359
8682	7312	18	applied	\N	\N	\N	\N	86459	86459	254360
8682	7313	19	applied	\N	\N	\N	\N	86460	86460	254361
8682	7315	21	applied	\N	\N	\N	\N	86462	86462	254363
8682	7316	22	applied	\N	\N	\N	\N	86463	86463	254364
8682	7317	23	applied	\N	\N	\N	\N	86464	86464	254365
8682	7318	24	applied	\N	\N	\N	\N	86465	86465	254366
8682	7319	25	applied	\N	\N	\N	\N	86466	86466	254367
8682	7320	26	applied	\N	\N	\N	\N	86467	86467	254368
8682	7331	27	applied	\N	\N	\N	\N	86468	86468	254369
8682	7332	28	applied	\N	\N	\N	\N	86469	86469	254370
8682	7333	29	applied	\N	\N	\N	\N	86470	86470	254371
8682	7334	30	applied	\N	\N	\N	\N	86471	86471	254372
8682	7335	31	applied	\N	\N	\N	\N	86472	86472	254373
8682	7336	32	applied	\N	\N	\N	\N	86473	86473	254374
8682	7337	33	applied	\N	\N	\N	\N	86474	86474	254375
8682	7338	34	applied	\N	\N	\N	\N	86475	86475	254376
8682	7339	35	applied	\N	\N	\N	\N	86476	86476	254377
8682	7340	36	applied	\N	\N	\N	\N	86477	86477	254378
8682	7342	38	applied	\N	\N	\N	\N	86479	86479	254380
8682	7343	39	applied	\N	\N	\N	\N	86480	86480	254381
8682	7344	40	applied	\N	\N	\N	\N	86481	86481	254382
8682	7345	41	applied	\N	\N	\N	\N	86482	86482	254383
8682	7346	43	applied	\N	\N	\N	\N	86483	86483	254384
8682	7347	44	applied	\N	\N	\N	\N	86484	86484	254385
8682	7348	45	applied	\N	\N	\N	\N	86485	86485	254386
8682	7350	46	applied	\N	\N	\N	\N	86486	86486	254387
8682	7351	47	applied	\N	\N	\N	\N	86487	86487	254388
8682	7352	48	applied	\N	\N	\N	\N	86488	86488	254389
8682	7353	49	applied	\N	\N	\N	\N	86489	86489	254390
8682	7354	50	applied	\N	\N	\N	\N	86490	86490	254391
8682	7355	51	applied	\N	\N	\N	\N	86491	86491	254392
8682	7356	52	applied	\N	\N	\N	\N	86492	86492	254393
8626	7240	72	applied	\N	\N	\N	\N	86228	86228	254129
8626	7241	73	applied	\N	\N	\N	\N	86229	86229	254130
8632	7194	2	applied	\N	\N	\N	\N	86292	86292	254193
8632	7232	3	applied	\N	\N	\N	\N	86293	86293	254194
8632	7195	4	applied	\N	\N	\N	\N	86294	86294	254195
8632	7196	5	applied	\N	\N	\N	\N	86295	86295	254196
8632	7197	6	applied	\N	\N	\N	\N	86296	86296	254197
8632	7198	7	applied	\N	\N	1000000000	\N	86297	86297	254198
8632	7199	8	applied	\N	\N	\N	\N	86298	86298	254199
8632	7202	9	applied	\N	\N	\N	\N	86299	86299	254200
8632	7204	11	applied	\N	\N	\N	\N	86301	86301	254202
8632	7205	12	applied	\N	\N	\N	\N	86302	86302	254203
8632	7206	13	applied	\N	\N	\N	\N	86303	86303	254204
8632	7207	14	applied	\N	\N	\N	\N	86304	86304	254205
8632	7208	15	applied	\N	\N	\N	\N	86305	86305	254206
8632	7209	16	applied	\N	\N	\N	\N	86306	86306	254207
8632	7210	17	applied	\N	\N	\N	\N	86307	86307	254208
8632	7211	18	applied	\N	\N	\N	\N	86308	86308	254209
8632	7212	19	applied	\N	\N	\N	\N	86309	86309	254210
8632	7213	20	applied	\N	\N	\N	\N	86310	86310	254211
8632	7214	21	applied	\N	\N	\N	\N	86311	86311	254212
8632	7215	22	applied	\N	\N	\N	\N	86312	86312	254213
8632	7216	23	applied	\N	\N	\N	\N	86313	86313	254214
8632	7217	24	applied	\N	\N	\N	\N	86314	86314	254215
8632	7218	25	applied	\N	\N	\N	\N	86315	86315	254216
8632	7219	26	applied	\N	\N	\N	\N	86316	86316	254217
8632	7220	27	applied	\N	\N	\N	\N	86317	86317	254218
8632	7221	28	applied	\N	\N	\N	\N	86318	86318	254219
8632	7222	29	applied	\N	\N	\N	\N	86319	86319	254220
8632	7224	31	applied	\N	\N	\N	\N	86321	86321	254222
8632	7226	32	applied	\N	\N	\N	\N	86322	86322	254223
8632	7227	33	applied	\N	\N	\N	\N	86323	86323	254224
8632	7228	34	applied	\N	\N	\N	\N	86324	86324	254225
8632	7229	35	applied	\N	\N	\N	\N	86325	86325	254226
8632	7230	36	applied	\N	\N	\N	\N	86326	86326	254227
8632	7231	37	applied	\N	\N	\N	\N	86327	86327	254228
8632	7233	38	applied	\N	\N	\N	\N	86328	86328	254229
8632	7234	39	applied	\N	\N	\N	\N	86329	86329	254230
8632	7235	40	applied	\N	\N	\N	\N	86330	86330	254231
8632	7236	41	applied	\N	\N	\N	\N	86331	86331	254232
8632	7237	42	applied	\N	\N	\N	\N	86332	86332	254233
8632	7238	43	applied	\N	\N	\N	\N	86333	86333	254234
8632	7239	44	applied	\N	\N	\N	\N	86334	86334	254235
8632	7240	45	applied	\N	\N	\N	\N	86335	86335	254236
8632	7241	46	applied	\N	\N	\N	\N	86336	86336	254237
8632	7242	47	applied	\N	\N	\N	\N	86337	86337	254238
8632	7243	48	applied	\N	\N	\N	\N	86338	86338	254239
8632	7244	49	applied	\N	\N	\N	\N	86339	86339	254240
8632	7246	51	applied	\N	\N	\N	\N	86341	86341	254242
8632	7247	52	applied	\N	\N	\N	\N	86342	86342	254243
8632	7248	53	applied	\N	\N	\N	\N	86343	86343	254244
8632	7249	54	applied	\N	\N	\N	\N	86344	86344	254245
8632	7250	55	applied	\N	\N	\N	\N	86345	86345	254246
8632	7251	56	applied	\N	\N	\N	\N	86346	86346	254247
8632	7252	57	applied	\N	\N	\N	\N	86347	86347	254248
8632	7254	58	applied	\N	\N	\N	\N	86348	86348	254249
8632	7255	59	applied	\N	\N	\N	\N	86349	86349	254250
8632	7256	60	applied	\N	\N	\N	\N	86350	86350	254251
8632	7257	61	applied	\N	\N	\N	\N	86351	86351	254252
8632	7258	62	applied	\N	\N	\N	\N	86352	86352	254253
8632	7259	63	applied	\N	\N	\N	\N	86353	86353	254254
8632	7260	64	applied	\N	\N	\N	\N	86354	86354	254255
8632	7261	65	applied	\N	\N	\N	\N	86355	86355	254256
8632	7262	66	applied	\N	\N	\N	\N	86356	86356	254257
8632	7264	69	applied	\N	\N	\N	\N	86358	86358	254259
8632	7265	70	applied	\N	\N	\N	\N	86359	86359	254260
8632	7266	71	applied	\N	\N	\N	\N	86360	86360	254261
8632	7267	72	applied	\N	\N	\N	\N	86361	86361	254262
8632	7268	73	applied	\N	\N	\N	\N	86362	86362	254263
8632	7269	74	applied	\N	\N	\N	\N	86363	86363	254264
8632	7270	75	applied	\N	\N	\N	\N	86364	86364	254265
8632	7271	76	applied	\N	\N	\N	\N	86365	86365	254266
8632	7272	77	applied	\N	\N	\N	\N	86366	86366	254267
8632	7273	78	applied	\N	\N	\N	\N	86367	86367	254268
8632	7274	79	applied	\N	\N	\N	\N	86368	86368	254269
8632	7275	80	applied	\N	\N	\N	\N	86369	86369	254270
8632	7276	81	applied	\N	\N	\N	\N	86370	86370	254271
8632	7277	82	applied	\N	\N	\N	\N	86371	86371	254272
8632	7278	83	applied	\N	\N	\N	\N	86372	86372	254273
8632	7279	84	applied	\N	\N	\N	\N	86373	86373	254274
8632	7281	86	applied	\N	\N	\N	\N	86375	86375	254276
8632	7282	87	applied	\N	\N	\N	\N	86376	86376	254277
8632	7283	88	applied	\N	\N	\N	\N	86377	86377	254278
8632	7284	89	applied	\N	\N	\N	\N	86378	86378	254279
8632	7285	90	applied	\N	\N	\N	\N	86379	86379	254280
8632	7286	91	applied	\N	\N	\N	\N	86380	86380	254281
8632	7287	92	applied	\N	\N	\N	\N	86381	86381	254282
8632	7288	93	applied	\N	\N	\N	\N	86382	86382	254283
8632	7289	94	applied	\N	\N	\N	\N	86383	86383	254284
8638	7351	0	applied	\N	\N	\N	\N	86387	86387	254288
8640	7352	0	applied	\N	\N	\N	\N	86389	86389	254290
8646	7355	0	applied	\N	\N	\N	\N	86395	86395	254296
8646	7356	1	applied	\N	\N	\N	\N	86396	86396	254297
8646	7357	2	applied	\N	\N	\N	\N	86397	86397	254298
8646	7358	3	applied	\N	\N	\N	\N	86398	86398	254299
8646	7359	4	applied	\N	\N	\N	\N	86399	86399	254300
8650	7367	0	applied	\N	\N	\N	\N	86409	86409	254310
8654	7368	0	applied	\N	\N	\N	\N	86414	86414	254315
8654	7369	1	applied	\N	\N	\N	\N	86415	86415	254316
8657	7370	0	applied	\N	\N	\N	\N	86418	86418	254319
8663	7371	0	applied	\N	\N	\N	\N	86423	86423	254324
8665	7372	0	applied	\N	\N	\N	\N	86425	86425	254326
8665	7373	1	applied	\N	\N	\N	\N	86426	86426	254327
8669	7381	0	applied	\N	\N	\N	\N	86434	86434	254335
8671	7382	0	applied	\N	\N	\N	\N	86435	86435	254336
8679	7385	0	applied	\N	\N	\N	\N	86438	86438	254339
8681	7386	0	applied	\N	\N	\N	\N	86440	86440	254341
8682	7357	53	applied	\N	\N	\N	\N	86493	86493	254394
8682	7358	54	applied	\N	\N	\N	\N	86494	86494	254395
8682	7359	55	applied	\N	\N	\N	\N	86495	86495	254396
8686	7389	0	applied	\N	\N	\N	\N	86530	86530	254431
8627	7346	1	applied	\N	\N	\N	\N	86281	86281	254182
8632	7193	1	applied	\N	\N	\N	\N	86291	86291	254192
8631	7348	1	applied	\N	\N	\N	\N	86289	86289	254190
8643	7352	0	applied	\N	\N	\N	\N	86392	86392	254293
8644	7353	0	applied	\N	\N	\N	\N	86393	86393	254294
8644	7354	1	applied	\N	\N	\N	\N	86394	86394	254295
8649	7363	0	applied	\N	\N	\N	\N	86405	86405	254306
8649	7364	1	applied	\N	\N	\N	\N	86406	86406	254307
8649	7365	2	applied	\N	\N	\N	\N	86407	86407	254308
8649	7366	3	applied	\N	\N	\N	\N	86408	86408	254309
8652	7367	0	applied	\N	\N	\N	\N	86411	86411	254312
8656	7370	0	applied	\N	\N	\N	\N	86417	86417	254318
8668	7379	0	applied	\N	\N	\N	\N	86432	86432	254333
8678	7383	0	applied	\N	\N	\N	\N	86436	86436	254337
8678	7384	1	applied	\N	\N	\N	\N	86437	86437	254338
8683	7387	0	applied	\N	\N	\N	\N	86528	86528	254429
8686	7390	1	applied	\N	\N	\N	\N	86531	86531	254432
8688	7349	0	applied	\N	\N	\N	\N	86534	86534	254435
8688	7383	1	applied	\N	\N	\N	\N	86535	86535	254436
8690	7392	0	applied	\N	\N	\N	\N	86548	86548	254449
8695	7397	0	applied	\N	\N	\N	\N	86555	86555	254456
8697	7397	0	applied	\N	\N	\N	\N	86557	86557	254458
8700	7399	0	applied	\N	\N	\N	\N	86560	86560	254461
8703	7400	0	applied	\N	\N	\N	\N	86567	86567	254467
8703	7401	1	applied	\N	\N	\N	\N	86568	86568	254468
8703	7402	2	applied	\N	\N	\N	\N	86569	86569	254469
8703	7403	3	applied	\N	\N	\N	\N	86570	86570	254470
8703	7404	4	applied	\N	\N	\N	\N	86571	86571	86571
8707	7412	0	applied	\N	\N	\N	\N	86579	86579	254478
8711	7416	0	applied	\N	\N	\N	\N	86591	86591	254490
8711	7417	1	applied	\N	\N	\N	\N	86592	86592	254491
8711	7418	2	applied	\N	\N	\N	\N	86593	86593	254492
8711	7419	3	applied	\N	\N	\N	\N	86594	86594	254493
8711	7420	4	applied	\N	\N	\N	\N	86595	86595	254494
8711	7421	5	applied	\N	\N	\N	\N	86596	86596	254495
8711	7422	6	applied	\N	\N	1000000000	\N	86597	86597	254496
8711	7423	7	applied	\N	\N	\N	\N	86598	86598	254497
8713	7225	0	applied	\N	\N	\N	\N	86601	86601	254500
8713	7200	1	applied	\N	\N	\N	\N	86602	86602	254501
8713	7349	2	applied	\N	\N	\N	\N	86603	86603	254502
8713	7383	3	applied	\N	\N	\N	\N	86604	86604	254503
8713	7232	4	applied	\N	\N	\N	\N	86605	86605	254504
8713	7378	5	applied	\N	\N	\N	\N	86606	86606	254505
8713	7368	6	applied	\N	\N	\N	\N	86607	86607	254506
8713	7384	7	applied	\N	\N	\N	\N	86608	86608	254507
8713	7386	9	applied	\N	\N	\N	\N	86610	86610	254509
8713	7387	10	applied	\N	\N	\N	\N	86611	86611	254510
8713	7388	11	applied	\N	\N	\N	\N	86612	86612	254511
8713	7389	12	applied	\N	\N	\N	\N	86613	86613	254512
8713	7391	13	applied	\N	\N	\N	\N	86614	86614	254513
8713	7392	14	applied	\N	\N	\N	\N	86615	86615	254514
8713	7202	15	applied	\N	\N	\N	\N	86616	86616	254515
8782	7517	0	applied	\N	\N	\N	\N	86883	86883	254782
8713	7203	16	applied	\N	\N	1000000000	\N	86617	86617	254516
8713	7204	17	applied	\N	\N	\N	\N	86618	86618	254517
8713	7205	18	applied	\N	\N	\N	\N	86619	86619	254518
8713	7206	19	applied	\N	\N	\N	\N	86620	86620	254519
8713	7207	20	applied	\N	\N	\N	\N	86621	86621	254520
8713	7208	21	applied	\N	\N	\N	\N	86622	86622	254521
8713	7209	22	applied	\N	\N	\N	\N	86623	86623	254522
8713	7210	23	applied	\N	\N	\N	\N	86624	86624	254523
8713	7211	24	applied	\N	\N	\N	\N	86625	86625	254524
8713	7213	26	applied	\N	\N	\N	\N	86627	86627	254526
8713	7214	27	applied	\N	\N	\N	\N	86628	86628	254527
8713	7215	28	applied	\N	\N	\N	\N	86629	86629	254528
8713	7216	29	applied	\N	\N	\N	\N	86630	86630	254529
8713	7217	30	applied	\N	\N	\N	\N	86631	86631	254530
8713	7218	31	applied	\N	\N	\N	\N	86632	86632	254531
8713	7219	32	applied	\N	\N	\N	\N	86633	86633	254532
8713	7220	33	applied	\N	\N	\N	\N	86634	86634	254533
8713	7221	34	applied	\N	\N	\N	\N	86635	86635	254534
8713	7222	35	applied	\N	\N	\N	\N	86636	86636	254535
8713	7223	37	applied	\N	\N	1000000000	\N	86637	86637	254536
8713	7224	38	applied	\N	\N	\N	\N	86638	86638	254537
8713	7226	39	applied	\N	\N	\N	\N	86639	86639	254538
8713	7227	40	applied	\N	\N	\N	\N	86640	86640	254539
8713	7228	41	applied	\N	\N	\N	\N	86641	86641	254540
8713	7229	42	applied	\N	\N	\N	\N	86642	86642	254541
8713	7231	44	applied	\N	\N	\N	\N	86644	86644	254543
8713	7233	45	applied	\N	\N	\N	\N	86645	86645	254544
8713	7234	46	applied	\N	\N	\N	\N	86646	86646	254545
8713	7235	47	applied	\N	\N	\N	\N	86647	86647	254546
8713	7236	48	applied	\N	\N	\N	\N	86648	86648	254547
8713	7237	49	applied	\N	\N	\N	\N	86649	86649	254548
8713	7238	50	applied	\N	\N	\N	\N	86650	86650	254549
8713	7239	51	applied	\N	\N	\N	\N	86651	86651	254550
8713	7240	52	applied	\N	\N	\N	\N	86652	86652	254551
8713	7241	53	applied	\N	\N	\N	\N	86653	86653	254552
8713	7242	54	applied	\N	\N	\N	\N	86654	86654	254553
8713	7243	55	applied	\N	\N	\N	\N	86655	86655	254554
8713	7244	56	applied	\N	\N	\N	\N	86656	86656	254555
8713	7245	57	applied	\N	\N	\N	\N	86657	86657	254556
8713	7246	58	applied	\N	\N	\N	\N	86658	86658	254557
8713	7247	59	applied	\N	\N	\N	\N	86659	86659	254558
8713	7249	61	applied	\N	\N	\N	\N	86661	86661	254560
8713	7250	62	applied	\N	\N	\N	\N	86662	86662	254561
8713	7251	63	applied	\N	\N	\N	\N	86663	86663	254562
8713	7252	64	applied	\N	\N	\N	\N	86664	86664	254563
8713	7254	65	applied	\N	\N	\N	\N	86665	86665	254564
8713	7255	66	applied	\N	\N	\N	\N	86666	86666	254565
8713	7256	67	applied	\N	\N	\N	\N	86667	86667	254566
8713	7257	68	applied	\N	\N	\N	\N	86668	86668	254567
8713	7258	69	applied	\N	\N	\N	\N	86669	86669	254568
8713	7259	70	applied	\N	\N	\N	\N	86670	86670	254569
8713	7260	71	applied	\N	\N	\N	\N	86671	86671	254570
8713	7261	72	applied	\N	\N	\N	\N	86672	86672	254571
8713	7262	73	applied	\N	\N	\N	\N	86673	86673	254572
8713	7263	74	applied	\N	\N	\N	\N	86674	86674	254573
8713	7264	75	applied	\N	\N	\N	\N	86675	86675	254574
8713	7265	76	applied	\N	\N	\N	\N	86676	86676	254575
8713	7267	78	applied	\N	\N	\N	\N	86678	86678	254577
8713	7268	79	applied	\N	\N	\N	\N	86679	86679	254578
8629	7346	1	applied	\N	\N	\N	\N	86285	86285	254186
8631	7347	0	applied	\N	\N	\N	\N	86288	86288	254189
8636	7350	1	applied	\N	\N	\N	\N	86385	86385	254286
8639	7351	0	applied	\N	\N	\N	\N	86388	86388	254289
8641	7352	0	applied	\N	\N	\N	\N	86390	86390	254291
8647	7361	0	applied	\N	\N	\N	\N	86401	86401	254302
8647	7362	1	applied	\N	\N	\N	\N	86402	86402	254303
8651	7367	0	applied	\N	\N	\N	\N	86410	86410	254311
8655	7370	0	applied	\N	\N	\N	\N	86416	86416	254317
8661	7371	0	applied	\N	\N	\N	\N	86421	86421	254322
8664	7371	0	applied	\N	\N	\N	\N	86424	86424	254325
8680	7385	0	applied	\N	\N	\N	\N	86439	86439	254340
8684	7388	0	applied	\N	\N	\N	\N	86529	86529	254430
8687	7389	0	applied	\N	\N	\N	\N	86532	86532	254433
8687	7390	1	applied	\N	\N	\N	\N	86533	86533	254434
8689	7391	0	applied	\N	\N	\N	\N	86547	86547	254448
8691	7393	0	applied	\N	\N	\N	\N	86549	86549	254450
8694	7396	0	applied	\N	\N	\N	\N	86554	86554	254455
8701	7399	0	applied	\N	\N	\N	\N	86561	86561	254462
8704	7405	0	applied	\N	\N	\N	\N	86572	86572	254471
8704	7406	1	applied	\N	\N	\N	\N	86573	86573	254472
8708	7414	0	applied	\N	\N	\N	\N	86581	86581	254480
8712	7424	0	applied	\N	\N	\N	\N	86599	86599	254498
8712	7425	1	applied	\N	\N	\N	\N	86600	86600	254499
8713	7269	80	applied	\N	\N	\N	\N	86680	86680	254579
8713	7270	81	applied	\N	\N	\N	\N	86681	86681	254580
8713	7271	82	applied	\N	\N	\N	\N	86682	86682	254581
8719	7429	1	applied	\N	\N	\N	\N	86730	86730	254629
8719	7430	2	applied	\N	\N	\N	\N	86731	86731	254630
8719	7431	3	applied	\N	\N	\N	\N	86732	86732	254631
8724	7438	0	applied	\N	\N	\N	\N	86747	86747	254646
8724	7439	1	applied	\N	\N	\N	\N	86748	86748	254647
8724	7440	2	applied	\N	\N	\N	\N	86749	86749	254648
8724	7441	3	applied	\N	\N	\N	\N	86750	86750	254649
8724	7442	4	applied	\N	\N	\N	\N	86751	86751	254650
8724	7443	5	applied	\N	\N	\N	\N	86752	86752	254651
8724	7444	6	applied	\N	\N	\N	\N	86753	86753	254652
8729	7449	0	applied	\N	\N	\N	\N	86759	86759	254658
8731	7451	0	applied	\N	\N	\N	\N	86762	86762	254661
8731	7452	1	applied	\N	\N	\N	\N	86763	86763	254662
8734	7453	0	applied	\N	\N	\N	\N	86768	86768	254667
8734	7454	1	applied	\N	\N	\N	\N	86769	86769	254668
8740	7473	0	applied	\N	\N	\N	\N	86788	86788	254687
8747	7481	0	applied	\N	\N	\N	\N	86802	86802	254701
8747	7482	1	applied	\N	\N	\N	\N	86803	86803	254702
8752	7487	0	applied	\N	\N	\N	\N	86811	86811	254710
8752	7488	1	applied	\N	\N	\N	\N	86812	86812	254711
8756	7491	0	applied	\N	\N	\N	\N	86819	86819	254718
8756	7492	1	applied	\N	\N	\N	\N	86820	86820	254719
8769	7499	0	applied	\N	\N	\N	\N	86845	86845	254744
8769	7500	1	applied	\N	\N	\N	\N	86846	86846	254745
8772	7503	0	applied	\N	\N	\N	\N	86851	86851	254750
8772	7504	1	applied	\N	\N	\N	\N	86852	86852	254751
8772	7505	2	applied	\N	\N	\N	\N	86853	86853	254752
8772	7506	3	applied	\N	\N	\N	\N	86854	86854	254753
8772	7507	4	applied	\N	\N	\N	\N	86855	86855	254754
8772	7508	5	applied	\N	\N	\N	\N	86856	86856	254755
8777	7513	0	applied	\N	\N	\N	\N	86869	86869	254768
8777	7514	1	applied	\N	\N	\N	\N	86870	86870	254769
8779	7516	1	applied	\N	\N	\N	\N	86874	86874	254773
8782	7518	1	applied	\N	\N	1000000000	\N	86884	86884	254783
8782	7519	2	applied	\N	\N	\N	\N	86885	86885	254784
8782	7520	3	applied	\N	\N	1000000000	\N	86886	86886	254785
8787	7521	0	applied	\N	\N	\N	\N	86897	86897	254796
8787	7522	1	applied	\N	\N	\N	\N	86898	86898	254797
8788	7523	0	applied	\N	\N	\N	\N	86899	86899	254798
8788	7524	1	applied	\N	\N	\N	\N	86900	86900	254799
8791	7525	0	applied	\N	\N	\N	\N	86901	86901	254800
8791	7526	1	applied	\N	\N	\N	\N	86902	86902	254801
8791	7527	2	applied	\N	\N	\N	\N	86903	86903	254802
8791	7528	3	applied	\N	\N	\N	\N	86904	86904	254803
8794	7525	0	applied	\N	\N	\N	\N	86913	86913	254812
8794	7526	1	applied	\N	\N	\N	\N	86914	86914	254813
8794	7527	2	applied	\N	\N	\N	\N	86915	86915	254814
8795	7529	0	applied	\N	\N	\N	\N	86917	86917	254816
8795	7530	1	applied	\N	\N	\N	\N	86918	86918	254817
8795	7531	2	applied	\N	\N	\N	\N	86919	86919	254818
8795	7532	3	applied	\N	\N	\N	\N	86920	86920	254819
8798	7535	0	applied	\N	\N	\N	\N	86925	86925	254824
8798	7536	1	applied	\N	\N	\N	\N	86926	86926	254825
8802	7541	0	applied	\N	\N	\N	\N	86933	86933	254832
8802	7542	1	applied	\N	\N	\N	\N	86934	86934	254833
8805	7543	0	applied	\N	\N	\N	\N	86937	86937	254836
8805	7544	1	applied	\N	\N	\N	\N	86938	86938	254837
8805	7545	2	applied	\N	\N	\N	\N	86939	86939	254838
8805	7546	3	applied	\N	\N	\N	\N	86940	86940	254839
8807	7549	0	applied	\N	\N	\N	\N	86943	86943	254842
8807	7550	1	applied	\N	\N	\N	\N	86944	86944	254843
8814	7499	1	applied	\N	\N	\N	\N	86958	86958	254857
8814	7500	2	applied	\N	\N	\N	\N	86959	86959	254858
8814	7502	3	applied	\N	\N	\N	\N	86960	86960	254859
8819	7561	0	applied	\N	\N	\N	\N	86970	86970	254869
8819	7562	1	applied	\N	\N	\N	\N	86971	86971	254870
8819	7563	2	applied	\N	\N	\N	\N	86972	86972	254871
8824	7570	0	applied	\N	\N	\N	\N	86984	86984	254883
8824	7571	1	applied	\N	\N	\N	\N	86985	86985	254884
8827	7575	0	applied	\N	\N	\N	\N	86995	86995	254894
8827	7576	1	applied	\N	\N	\N	\N	86996	86996	254895
8827	7577	2	applied	\N	\N	\N	\N	86997	86997	254896
8827	7578	3	applied	\N	\N	\N	\N	86998	86998	254897
8827	7579	4	applied	\N	\N	\N	\N	86999	86999	254898
8827	7580	5	applied	\N	\N	\N	\N	87000	87000	254899
8831	7581	0	applied	\N	\N	\N	\N	87019	87019	254918
8831	7582	1	applied	\N	\N	\N	\N	87020	87020	254919
8831	7583	2	applied	\N	\N	\N	\N	87021	87021	254920
8832	7584	0	applied	\N	\N	1000000000	\N	87022	87022	254921
8832	7585	1	applied	\N	\N	\N	\N	87023	87023	254922
8832	7586	2	applied	\N	\N	\N	\N	87024	87024	254923
8832	7588	4	applied	\N	\N	\N	\N	87026	87026	254925
8832	7589	5	applied	\N	\N	\N	\N	87027	87027	254926
8630	7348	1	applied	\N	\N	\N	\N	86287	86287	254188
8636	7349	0	applied	\N	\N	\N	\N	86384	86384	254285
8682	7363	59	applied	\N	\N	\N	\N	86499	86499	254400
8682	7364	60	applied	\N	\N	\N	\N	86500	86500	254401
8682	7365	61	applied	\N	\N	\N	\N	86501	86501	254402
8682	7366	62	applied	\N	\N	\N	\N	86502	86502	254403
8682	7367	63	applied	\N	\N	\N	\N	86503	86503	254404
8682	7369	64	applied	\N	\N	\N	\N	86504	86504	254405
8682	7370	65	applied	\N	\N	\N	\N	86505	86505	254406
8682	7371	66	applied	\N	\N	\N	\N	86506	86506	254407
8682	7372	67	applied	\N	\N	\N	\N	86507	86507	254408
8682	7374	69	applied	\N	\N	\N	\N	86509	86509	254410
8682	7375	70	applied	\N	\N	\N	\N	86510	86510	254411
8682	7376	71	applied	\N	\N	\N	\N	86511	86511	254412
8682	7377	72	applied	\N	\N	\N	\N	86512	86512	254413
8682	7379	73	applied	\N	\N	\N	\N	86513	86513	254414
8682	7380	74	applied	\N	\N	\N	\N	86514	86514	254415
8682	7381	75	applied	\N	\N	\N	\N	86515	86515	254416
8682	7382	76	applied	\N	\N	\N	\N	86516	86516	254417
8682	7308	77	applied	\N	\N	1000000000	\N	86517	86517	254418
8682	7321	78	applied	\N	\N	\N	\N	86518	86518	254419
8682	7322	79	applied	\N	\N	\N	\N	86519	86519	254420
8682	7323	80	applied	\N	\N	\N	\N	86520	86520	254421
8682	7324	81	applied	\N	\N	\N	\N	86521	86521	254422
8682	7325	82	applied	\N	\N	\N	\N	86522	86522	254423
8682	7326	83	applied	\N	\N	\N	\N	86523	86523	254424
8682	7327	84	applied	\N	\N	\N	\N	86524	86524	254425
8682	7329	86	applied	\N	\N	\N	\N	86526	86526	254427
8682	7330	87	applied	\N	\N	\N	\N	86527	86527	254428
8692	7394	0	applied	\N	\N	\N	\N	86550	86550	254451
8692	7395	1	applied	\N	\N	\N	\N	86551	86551	254452
8699	7399	0	applied	\N	\N	\N	\N	86559	86559	254460
8702	7400	0	applied	\N	\N	\N	\N	86562	86562	254463
8702	7401	1	applied	\N	\N	\N	\N	86563	86563	254464
8702	7402	2	applied	\N	\N	\N	\N	86564	86564	254465
8702	7403	3	applied	\N	\N	\N	\N	86565	86565	254466
8702	7404	4	applied	\N	\N	\N	\N	86566	86566	86566
8705	7407	0	applied	\N	\N	\N	\N	86574	86574	254473
8706	7408	0	applied	\N	\N	\N	\N	86575	86575	254474
8706	7409	1	applied	\N	\N	\N	\N	86576	86576	254475
8706	7410	2	applied	\N	\N	\N	\N	86577	86577	254476
8706	7411	3	applied	\N	\N	\N	\N	86578	86578	254477
8709	7415	0	applied	\N	\N	\N	\N	86582	86582	254481
8710	7417	1	applied	\N	\N	\N	\N	86584	86584	254483
8710	7418	2	applied	\N	\N	\N	\N	86585	86585	254484
8710	7419	3	applied	\N	\N	\N	\N	86586	86586	254485
8710	7420	4	applied	\N	\N	\N	\N	86587	86587	254486
8710	7421	5	applied	\N	\N	\N	\N	86588	86588	254487
8710	7422	6	applied	\N	\N	1000000000	\N	86589	86589	254488
8710	7423	7	applied	\N	\N	\N	\N	86590	86590	254489
8722	7434	0	applied	\N	\N	\N	\N	86739	86739	254638
8722	7435	1	applied	\N	\N	\N	\N	86740	86740	254639
8722	7436	2	applied	\N	\N	\N	\N	86741	86741	254640
8722	7437	3	applied	\N	\N	\N	\N	86742	86742	254641
8727	7447	0	applied	\N	\N	\N	\N	86756	86756	254655
8727	7448	1	applied	\N	\N	\N	\N	86757	86757	254656
8730	7449	0	applied	\N	\N	\N	\N	86760	86760	254659
8730	7450	2	applied	\N	\N	\N	\N	86761	86761	254660
8737	7463	0	applied	\N	\N	\N	\N	86778	86778	254677
8743	7477	0	applied	\N	\N	\N	\N	86794	86794	254693
8743	7478	1	applied	\N	\N	\N	\N	86795	86795	254694
8750	7485	0	applied	\N	\N	\N	\N	86808	86808	254707
8750	7486	1	applied	\N	\N	\N	\N	86809	86809	254708
8753	7487	0	applied	\N	\N	\N	\N	86813	86813	254712
8753	7488	1	applied	\N	\N	\N	\N	86814	86814	254713
8757	7493	0	applied	\N	\N	\N	\N	86821	86821	254720
8757	7494	1	applied	\N	\N	\N	\N	86822	86822	254721
8759	7493	0	applied	\N	\N	\N	\N	86825	86825	254724
8759	7494	1	applied	\N	\N	\N	\N	86826	86826	254725
8761	7495	0	applied	\N	\N	\N	\N	86829	86829	254728
8761	7496	1	applied	\N	\N	\N	\N	86830	86830	254729
8764	7497	0	applied	\N	\N	\N	\N	86835	86835	254734
8764	7498	1	applied	\N	\N	\N	\N	86836	86836	254735
8773	7503	0	applied	\N	\N	\N	\N	86857	86857	254756
8773	7504	1	applied	\N	\N	\N	\N	86858	86858	254757
8773	7506	3	applied	\N	\N	\N	\N	86860	86860	254759
8773	7507	4	applied	\N	\N	\N	\N	86861	86861	254760
8773	7508	5	applied	\N	\N	\N	\N	86862	86862	254761
8775	7509	0	applied	\N	\N	\N	\N	86865	86865	254764
8775	7510	1	applied	\N	\N	\N	\N	86866	86866	254765
8778	7513	0	applied	\N	\N	\N	\N	86871	86871	254770
8778	7514	1	applied	\N	\N	\N	\N	86872	86872	254771
8780	7517	0	applied	\N	\N	\N	\N	86875	86875	254774
8780	7518	1	applied	\N	\N	1000000000	\N	86876	86876	254775
8780	7519	2	applied	\N	\N	\N	\N	86877	86877	254776
8780	7520	3	applied	\N	\N	1000000000	\N	86878	86878	254777
8784	7521	0	applied	\N	\N	\N	\N	86891	86891	254790
8784	7522	1	applied	\N	\N	\N	\N	86892	86892	254791
8800	7538	0	applied	\N	\N	\N	\N	86929	86929	254828
8803	7541	0	applied	\N	\N	\N	\N	86935	86935	254834
8803	7542	1	applied	\N	\N	\N	\N	86936	86936	254835
8810	7549	1	applied	\N	\N	\N	\N	86950	86950	254849
8810	7551	2	applied	\N	\N	\N	\N	86951	86951	254850
8812	7553	0	applied	\N	\N	\N	\N	86953	86953	254852
8812	7554	1	applied	\N	\N	\N	\N	86954	86954	254853
8820	7561	0	applied	\N	\N	\N	\N	86973	86973	254872
8820	7562	1	applied	\N	\N	\N	\N	86974	86974	254873
8820	7563	2	applied	\N	\N	\N	\N	86975	86975	254874
8821	7564	0	applied	\N	\N	\N	\N	86976	86976	254875
8821	7565	1	applied	\N	\N	\N	\N	86977	86977	254876
8837	7595	0	applied	\N	\N	\N	\N	87038	87038	254937
8837	7596	1	applied	\N	\N	\N	\N	87039	87039	254938
8837	7597	2	applied	\N	\N	\N	\N	87040	87040	254939
8837	7598	3	applied	\N	\N	\N	\N	87041	87041	254940
8838	7595	0	applied	\N	\N	\N	\N	87042	87042	254941
8838	7596	1	applied	\N	\N	\N	\N	87043	87043	254942
8838	7597	2	applied	\N	\N	\N	\N	87044	87044	254943
8840	7595	0	applied	\N	\N	\N	\N	87050	87050	254949
8840	7596	1	applied	\N	\N	\N	\N	87051	87051	254950
8840	7597	2	applied	\N	\N	\N	\N	87052	87052	254951
8844	7605	0	applied	\N	\N	\N	\N	87072	87072	254971
8682	7361	57	applied	\N	\N	\N	\N	86497	86497	254398
8682	7362	58	applied	\N	\N	\N	\N	86498	86498	254399
8688	7385	5	applied	\N	\N	\N	\N	86539	86539	254440
8688	7386	6	applied	\N	\N	\N	\N	86540	86540	254441
8688	7387	7	applied	\N	\N	\N	\N	86541	86541	254442
8688	7388	8	applied	\N	\N	\N	\N	86542	86542	254443
8688	7389	9	applied	\N	\N	\N	\N	86543	86543	254444
8688	7391	10	applied	\N	\N	\N	\N	86544	86544	254445
8688	7308	11	applied	\N	\N	1000000000	\N	86545	86545	254446
8688	7321	12	applied	\N	\N	\N	\N	86546	86546	254447
8693	7394	0	applied	\N	\N	\N	\N	86552	86552	254453
8693	7395	1	applied	\N	\N	\N	\N	86553	86553	254454
8696	7397	0	applied	\N	\N	\N	\N	86556	86556	254457
8714	7424	0	applied	\N	\N	\N	\N	86719	86719	254618
8714	7425	1	applied	\N	\N	\N	\N	86720	86720	254619
8718	7428	0	applied	\N	\N	\N	\N	86725	86725	254624
8718	7429	1	applied	\N	\N	\N	\N	86726	86726	254625
8718	7430	2	applied	\N	\N	\N	\N	86727	86727	254626
8718	7431	3	applied	\N	\N	\N	\N	86728	86728	254627
8721	7434	0	applied	\N	\N	\N	\N	86735	86735	254634
8721	7435	1	applied	\N	\N	\N	\N	86736	86736	254635
8721	7436	2	applied	\N	\N	\N	\N	86737	86737	254636
8721	7437	3	applied	\N	\N	\N	\N	86738	86738	254637
8733	7453	0	applied	\N	\N	\N	\N	86766	86766	254665
8733	7454	1	applied	\N	\N	\N	\N	86767	86767	254666
8736	7461	0	applied	\N	\N	\N	\N	86776	86776	254675
8736	7462	1	applied	\N	\N	\N	\N	86777	86777	254676
8739	7469	0	applied	\N	\N	\N	\N	86784	86784	254683
8739	7470	1	applied	\N	\N	\N	\N	86785	86785	254684
8739	7472	3	applied	\N	\N	\N	\N	86787	86787	254686
8742	7475	0	applied	\N	\N	\N	\N	86792	86792	254691
8742	7476	1	applied	\N	\N	\N	\N	86793	86793	254692
8745	7477	0	applied	\N	\N	\N	\N	86798	86798	254697
8745	7478	1	applied	\N	\N	\N	\N	86799	86799	254698
8746	7479	0	applied	\N	\N	\N	\N	86800	86800	254699
8746	7480	1	applied	\N	\N	\N	\N	86801	86801	254700
8749	7485	0	applied	\N	\N	\N	\N	86806	86806	254705
8749	7486	1	applied	\N	\N	\N	\N	86807	86807	254706
8751	7487	0	applied	\N	\N	\N	\N	86810	86810	254709
8754	7487	0	applied	\N	\N	\N	\N	86815	86815	254714
8754	7488	1	applied	\N	\N	\N	\N	86816	86816	254715
8760	7493	0	applied	\N	\N	\N	\N	86827	86827	254726
8760	7494	1	applied	\N	\N	\N	\N	86828	86828	254727
8763	7497	0	applied	\N	\N	\N	\N	86833	86833	254732
8763	7498	1	applied	\N	\N	\N	\N	86834	86834	254733
8766	7498	1	applied	\N	\N	\N	\N	86840	86840	254739
8768	7497	0	applied	\N	\N	\N	\N	86843	86843	254742
8768	7498	1	applied	\N	\N	\N	\N	86844	86844	254743
8771	7501	0	applied	\N	\N	\N	\N	86849	86849	254748
8771	7502	1	applied	\N	\N	\N	\N	86850	86850	254749
8774	7509	0	applied	\N	\N	\N	\N	86863	86863	254762
8774	7510	1	applied	\N	\N	\N	\N	86864	86864	254763
8776	7511	0	applied	\N	\N	\N	\N	86867	86867	254766
8776	7512	1	applied	\N	\N	\N	\N	86868	86868	254767
8783	7517	0	applied	\N	\N	\N	\N	86887	86887	254786
8783	7518	1	applied	\N	\N	1000000000	\N	86888	86888	254787
8783	7519	2	applied	\N	\N	\N	\N	86889	86889	254788
8783	7520	3	applied	\N	\N	1000000000	\N	86890	86890	254789
8786	7521	0	applied	\N	\N	\N	\N	86895	86895	254794
8786	7522	1	applied	\N	\N	\N	\N	86896	86896	254795
8793	7525	0	applied	\N	\N	\N	\N	86909	86909	254808
8793	7527	2	applied	\N	\N	\N	\N	86911	86911	254810
8793	7528	3	applied	\N	\N	\N	\N	86912	86912	254811
8797	7535	0	applied	\N	\N	\N	\N	86923	86923	254822
8797	7536	1	applied	\N	\N	\N	\N	86924	86924	254823
8799	7537	0	applied	\N	\N	\N	\N	86927	86927	254826
8799	7538	1	applied	\N	\N	\N	\N	86928	86928	254827
8809	7550	0	applied	\N	\N	\N	\N	86948	86948	254847
8811	7552	0	applied	\N	\N	\N	\N	86952	86952	254851
8813	7553	0	applied	\N	\N	\N	\N	86955	86955	254854
8813	7554	1	applied	\N	\N	\N	\N	86956	86956	254855
8818	7561	0	applied	\N	\N	\N	\N	86967	86967	254866
8818	7562	1	applied	\N	\N	\N	\N	86968	86968	254867
8818	7563	2	applied	\N	\N	\N	\N	86969	86969	254868
8823	7570	0	applied	\N	\N	\N	\N	86982	86982	254881
8823	7571	1	applied	\N	\N	\N	\N	86983	86983	254882
8825	7572	0	applied	\N	\N	\N	\N	86986	86986	254885
8825	7574	2	applied	\N	\N	\N	\N	86988	86988	254887
8826	7575	0	applied	\N	\N	\N	\N	86989	86989	254888
8826	7576	1	applied	\N	\N	\N	\N	86990	86990	254889
8826	7577	2	applied	\N	\N	\N	\N	86991	86991	254890
8826	7578	3	applied	\N	\N	\N	\N	86992	86992	254891
8826	7579	4	applied	\N	\N	\N	\N	86993	86993	254892
8826	7580	5	applied	\N	\N	\N	\N	86994	86994	254893
8829	7575	0	applied	\N	\N	\N	\N	87007	87007	254906
8829	7576	1	applied	\N	\N	\N	\N	87008	87008	254907
8829	7577	2	applied	\N	\N	\N	\N	87009	87009	254908
8829	7578	3	applied	\N	\N	\N	\N	87010	87010	254909
8829	7579	4	applied	\N	\N	\N	\N	87011	87011	254910
8829	7580	5	applied	\N	\N	\N	\N	87012	87012	254911
8830	7575	0	applied	\N	\N	\N	\N	87013	87013	254912
8830	7576	1	applied	\N	\N	\N	\N	87014	87014	254913
8830	7577	2	applied	\N	\N	\N	\N	87015	87015	254914
8830	7579	4	applied	\N	\N	\N	\N	87017	87017	254916
8830	7580	5	applied	\N	\N	\N	\N	87018	87018	254917
8834	7590	0	applied	\N	\N	\N	\N	87030	87030	254929
8834	7591	1	applied	\N	\N	\N	\N	87031	87031	254930
8836	7592	0	applied	\N	\N	\N	\N	87035	87035	254934
8836	7593	1	applied	\N	\N	\N	\N	87036	87036	254935
8836	7594	2	applied	\N	\N	\N	\N	87037	87037	254936
8839	7595	0	applied	\N	\N	\N	\N	87046	87046	254945
8839	7596	1	applied	\N	\N	\N	\N	87047	87047	254946
8839	7597	2	applied	\N	\N	\N	\N	87048	87048	254947
8839	7598	3	applied	\N	\N	\N	\N	87049	87049	254948
8842	7599	0	applied	\N	\N	\N	\N	87060	87060	254959
8842	7600	1	applied	\N	\N	\N	\N	87061	87061	254960
8842	7601	2	applied	\N	\N	\N	\N	87062	87062	254961
8842	7602	3	applied	\N	\N	\N	\N	87063	87063	254962
8842	7603	4	applied	\N	\N	\N	\N	87064	87064	254963
8846	7605	0	applied	\N	\N	\N	\N	87075	87075	254974
8851	7611	0	applied	\N	\N	\N	\N	87085	87085	254984
8688	7368	3	applied	\N	\N	\N	\N	86537	86537	254438
8688	7384	4	applied	\N	\N	\N	\N	86538	86538	254439
8713	7276	87	applied	\N	\N	\N	\N	86687	86687	254586
8713	7277	88	applied	\N	\N	\N	\N	86688	86688	254587
8713	7278	89	applied	\N	\N	\N	\N	86689	86689	254588
8713	7279	90	applied	\N	\N	\N	\N	86690	86690	254589
8713	7280	91	applied	\N	\N	\N	\N	86691	86691	254590
8713	7281	92	applied	\N	\N	\N	\N	86692	86692	254591
8713	7282	93	applied	\N	\N	\N	\N	86693	86693	254592
8713	7283	94	applied	\N	\N	\N	\N	86694	86694	254593
8713	7284	95	applied	\N	\N	\N	\N	86695	86695	254594
8713	7285	96	applied	\N	\N	\N	\N	86696	86696	254595
8713	7287	98	applied	\N	\N	\N	\N	86698	86698	254597
8713	7288	99	applied	\N	\N	\N	\N	86699	86699	254598
8713	7289	100	applied	\N	\N	\N	\N	86700	86700	254599
8713	7290	101	applied	\N	\N	\N	\N	86701	86701	254600
8713	7291	102	applied	\N	\N	\N	\N	86702	86702	254601
8713	7292	103	applied	\N	\N	\N	\N	86703	86703	254602
8713	7293	104	applied	\N	\N	\N	\N	86704	86704	254603
8713	7294	105	applied	\N	\N	\N	\N	86705	86705	254604
8713	7295	106	applied	\N	\N	\N	\N	86706	86706	254605
8713	7296	107	applied	\N	\N	\N	\N	86707	86707	254606
8713	7297	108	applied	\N	\N	\N	\N	86708	86708	254607
8713	7298	109	applied	\N	\N	\N	\N	86709	86709	254608
8713	7299	110	applied	\N	\N	\N	\N	86710	86710	254609
8713	7300	111	applied	\N	\N	\N	\N	86711	86711	254610
8713	7301	112	applied	\N	\N	\N	\N	86712	86712	254611
8713	7302	113	applied	\N	\N	\N	\N	86713	86713	254612
8713	7304	115	applied	\N	\N	\N	\N	86715	86715	254614
8713	7305	116	applied	\N	\N	\N	\N	86716	86716	254615
8713	7306	117	applied	\N	\N	\N	\N	86717	86717	254616
8713	7307	118	applied	\N	\N	\N	\N	86718	86718	254617
8715	7426	0	applied	\N	\N	\N	\N	86721	86721	254620
8715	7427	1	applied	\N	\N	\N	\N	86722	86722	254621
8717	7426	0	applied	\N	\N	\N	\N	86723	86723	254622
8717	7427	1	applied	\N	\N	\N	\N	86724	86724	254623
8720	7432	0	applied	\N	\N	\N	\N	86733	86733	254632
8720	7433	1	applied	\N	\N	\N	\N	86734	86734	254633
8723	7434	0	applied	\N	\N	\N	\N	86743	86743	254642
8723	7435	1	applied	\N	\N	\N	\N	86744	86744	254643
8723	7436	2	applied	\N	\N	\N	\N	86745	86745	254644
8723	7437	3	applied	\N	\N	\N	\N	86746	86746	254645
8726	7445	0	applied	\N	\N	\N	\N	86754	86754	254653
8726	7446	1	applied	\N	\N	\N	\N	86755	86755	254654
8732	7451	0	applied	\N	\N	\N	\N	86764	86764	254663
8732	7452	1	applied	\N	\N	\N	\N	86765	86765	254664
8735	7455	0	applied	\N	\N	\N	\N	86770	86770	254669
8735	7456	1	applied	\N	\N	\N	\N	86771	86771	254670
8735	7457	2	applied	\N	\N	\N	\N	86772	86772	254671
8735	7458	3	applied	\N	\N	\N	\N	86773	86773	254672
8735	7459	4	applied	\N	\N	\N	\N	86774	86774	254673
8735	7460	5	applied	\N	\N	\N	\N	86775	86775	254674
8738	7465	0	applied	\N	\N	\N	\N	86780	86780	254679
8738	7466	1	applied	\N	\N	\N	\N	86781	86781	254680
8738	7467	2	applied	\N	\N	\N	\N	86782	86782	254681
8738	7468	3	applied	\N	\N	\N	\N	86783	86783	254682
8741	7475	0	applied	\N	\N	\N	\N	86790	86790	254689
8741	7476	1	applied	\N	\N	\N	\N	86791	86791	254690
8744	7477	0	applied	\N	\N	\N	\N	86796	86796	254695
8744	7478	1	applied	\N	\N	\N	\N	86797	86797	254696
8748	7484	1	applied	\N	\N	\N	\N	86805	86805	254704
8755	7489	0	applied	\N	\N	\N	\N	86817	86817	254716
8755	7490	1	applied	\N	\N	\N	\N	86818	86818	254717
8758	7493	0	applied	\N	\N	\N	\N	86823	86823	254722
8758	7494	1	applied	\N	\N	\N	\N	86824	86824	254723
8762	7497	0	applied	\N	\N	\N	\N	86831	86831	254730
8762	7498	1	applied	\N	\N	\N	\N	86832	86832	254731
8765	7497	0	applied	\N	\N	\N	\N	86837	86837	254736
8765	7498	1	applied	\N	\N	\N	\N	86838	86838	254737
8767	7497	0	applied	\N	\N	\N	\N	86841	86841	254740
8767	7498	1	applied	\N	\N	\N	\N	86842	86842	254741
8770	7499	0	applied	\N	\N	\N	\N	86847	86847	254746
8770	7500	1	applied	\N	\N	\N	\N	86848	86848	254747
8781	7517	0	applied	\N	\N	\N	\N	86879	86879	254778
8781	7519	2	applied	\N	\N	\N	\N	86881	86881	254780
8781	7520	3	applied	\N	\N	1000000000	\N	86882	86882	254781
8785	7521	0	applied	\N	\N	\N	\N	86893	86893	254792
8785	7522	1	applied	\N	\N	\N	\N	86894	86894	254793
8792	7525	0	applied	\N	\N	\N	\N	86905	86905	254804
8792	7526	1	applied	\N	\N	\N	\N	86906	86906	254805
8792	7527	2	applied	\N	\N	\N	\N	86907	86907	254806
8792	7528	3	applied	\N	\N	\N	\N	86908	86908	254807
8796	7533	0	applied	\N	\N	\N	\N	86921	86921	254820
8796	7534	1	applied	\N	\N	\N	\N	86922	86922	254821
8801	7537	0	applied	\N	\N	\N	\N	86930	86930	254829
8801	7539	1	applied	\N	\N	\N	\N	86931	86931	254830
8801	7540	2	applied	\N	\N	\N	\N	86932	86932	254831
8806	7547	0	applied	\N	\N	\N	\N	86941	86941	254840
8806	7548	1	applied	\N	\N	\N	\N	86942	86942	254841
8808	7549	0	applied	\N	\N	\N	\N	86945	86945	254844
8808	7550	1	applied	\N	\N	\N	\N	86946	86946	254845
8808	7551	2	applied	\N	\N	\N	\N	86947	86947	254846
8815	7556	0	applied	\N	\N	\N	\N	86961	86961	254860
8815	7557	2	applied	\N	\N	\N	\N	86963	86963	254862
8817	7558	0	applied	\N	\N	\N	\N	86964	86964	254863
8817	7559	1	applied	\N	\N	\N	\N	86965	86965	254864
8817	7560	2	applied	\N	\N	\N	\N	86966	86966	254865
8822	7566	0	applied	\N	\N	\N	\N	86978	86978	254877
8822	7567	1	applied	\N	\N	\N	\N	86979	86979	254878
8822	7568	2	applied	\N	\N	\N	\N	86980	86980	254879
8822	7569	3	applied	\N	\N	\N	\N	86981	86981	254880
8828	7575	0	applied	\N	\N	\N	\N	87001	87001	254900
8828	7576	1	applied	\N	\N	\N	\N	87002	87002	254901
8828	7577	2	applied	\N	\N	\N	\N	87003	87003	254902
8828	7578	3	applied	\N	\N	\N	\N	87004	87004	254903
8828	7579	4	applied	\N	\N	\N	\N	87005	87005	254904
8828	7580	5	applied	\N	\N	\N	\N	87006	87006	254905
8833	7590	0	applied	\N	\N	\N	\N	87028	87028	254927
8842	7604	5	applied	\N	\N	\N	\N	87065	87065	254964
8853	7611	0	applied	\N	\N	\N	\N	87089	87089	254988
8853	7612	1	applied	\N	\N	\N	\N	87090	87090	254989
8713	7273	84	applied	\N	\N	\N	\N	86684	86684	254583
8713	7275	86	applied	\N	\N	\N	\N	86686	86686	254585
8835	7594	2	applied	\N	\N	\N	\N	87034	87034	254933
8841	7599	0	applied	\N	\N	\N	\N	87054	87054	254953
8841	7600	1	applied	\N	\N	\N	\N	87055	87055	254954
8841	7601	2	applied	\N	\N	\N	\N	87056	87056	254955
8841	7602	3	applied	\N	\N	\N	\N	87057	87057	254956
8841	7603	4	applied	\N	\N	\N	\N	87058	87058	254957
8841	7604	5	applied	\N	\N	\N	\N	87059	87059	254958
8847	7605	0	applied	\N	\N	\N	\N	87076	87076	254975
8847	7606	1	applied	\N	\N	\N	\N	87077	87077	254976
8849	7609	0	applied	\N	\N	\N	\N	87081	87081	254980
8849	7610	1	applied	\N	\N	\N	\N	87082	87082	254981
8852	7611	0	applied	\N	\N	\N	\N	87087	87087	254986
8852	7612	1	applied	\N	\N	\N	\N	87088	87088	254987
8858	7617	0	applied	\N	\N	\N	\N	87099	87099	254998
8858	7618	1	applied	\N	\N	\N	\N	87100	87100	254999
8861	7621	0	applied	\N	\N	\N	\N	87105	87105	255004
8861	7622	1	applied	\N	\N	\N	\N	87106	87106	255005
8864	7623	0	applied	\N	\N	\N	\N	87111	87111	255010
8864	7624	1	applied	\N	\N	\N	\N	87112	87112	255011
8865	7625	0	applied	\N	\N	\N	\N	87113	87113	255012
8865	7626	1	applied	\N	\N	\N	\N	87114	87114	255013
8868	7627	0	applied	\N	\N	\N	\N	87119	87119	255018
8868	7628	1	applied	\N	\N	\N	\N	87120	87120	255019
8870	7634	1	applied	\N	\N	\N	\N	87126	87126	255025
8877	7637	0	applied	\N	\N	\N	\N	87144	87144	255043
8877	7638	1	applied	\N	\N	\N	\N	87145	87145	255044
8877	7639	2	applied	\N	\N	\N	\N	87146	87146	255045
8877	7640	3	applied	\N	\N	\N	\N	87147	87147	255046
8877	7641	4	applied	\N	\N	\N	\N	87148	87148	255047
8879	7572	0	applied	\N	\N	\N	\N	87154	87154	255053
8879	7589	1	applied	\N	\N	\N	\N	87155	87155	255054
8882	7646	0	applied	\N	\N	\N	\N	87164	87164	255063
8882	7647	1	applied	\N	\N	\N	\N	87165	87165	255064
8882	7648	2	applied	\N	\N	\N	\N	87166	87166	255065
8882	7649	3	applied	\N	\N	\N	\N	87167	87167	255066
8885	7656	0	applied	\N	\N	\N	\N	87174	87174	255073
8885	7657	1	applied	\N	\N	\N	\N	87175	87175	255074
8886	7658	0	applied	\N	\N	\N	\N	87176	87176	255075
8886	7659	1	applied	\N	\N	\N	\N	87177	87177	255076
8886	7661	3	applied	\N	\N	\N	\N	87179	87179	255078
8886	7662	4	applied	\N	\N	\N	\N	87180	87180	255079
8886	7663	5	applied	\N	\N	\N	\N	87181	87181	255080
8886	7664	6	applied	\N	\N	\N	\N	87182	87182	255081
8886	7665	7	applied	\N	\N	\N	\N	87183	87183	255082
8900	7678	0	applied	\N	\N	\N	\N	87218	87218	255117
8900	7679	1	applied	\N	\N	\N	\N	87219	87219	255118
8900	7680	2	applied	\N	\N	1000000000	\N	87220	87220	255119
8907	7685	0	applied	\N	\N	\N	\N	87236	87236	255135
8907	7686	1	applied	\N	\N	\N	\N	87237	87237	255136
8907	7687	2	applied	\N	\N	\N	\N	87238	87238	255137
8907	7688	3	applied	\N	\N	\N	\N	87239	87239	255138
8910	7691	0	applied	\N	\N	\N	\N	87244	87244	255143
8910	7692	1	applied	\N	\N	\N	\N	87245	87245	255144
8910	7693	2	applied	\N	\N	\N	\N	87246	87246	255145
8910	7694	3	applied	\N	\N	\N	\N	87247	87247	255146
8910	7696	5	applied	\N	\N	\N	\N	87249	87249	255148
8915	7702	0	applied	\N	\N	\N	\N	87258	87258	255157
8923	7716	0	applied	\N	\N	\N	\N	87282	87282	255181
8923	7707	1	applied	\N	\N	\N	\N	87283	87283	255182
8925	7721	0	applied	\N	\N	\N	\N	87286	87286	255185
8925	7722	1	applied	\N	\N	\N	\N	87287	87287	255186
8928	7723	0	applied	\N	\N	\N	\N	87292	87292	255191
8928	7724	1	applied	\N	\N	\N	\N	87293	87293	255192
8933	7736	0	applied	\N	\N	\N	\N	87305	87305	255203
8933	7737	1	applied	\N	\N	\N	\N	87306	87306	255204
8933	7738	2	applied	\N	\N	\N	\N	87307	87307	255205
8933	7739	3	applied	\N	\N	\N	\N	87308	87308	255206
8935	7740	0	applied	\N	\N	\N	\N	87313	87313	255211
8935	7741	1	applied	\N	\N	\N	\N	87314	87314	255212
8943	7754	0	applied	\N	\N	\N	\N	87335	87335	255233
8943	7755	1	applied	\N	\N	\N	\N	87336	87336	255234
8950	7765	1	applied	\N	\N	\N	\N	87355	87355	255252
8953	7771	0	applied	\N	\N	\N	\N	87361	87361	255257
8953	7772	1	applied	\N	\N	\N	\N	87362	87362	255258
8953	7773	2	applied	\N	\N	\N	\N	87363	87363	255259
8953	7774	3	applied	\N	\N	\N	\N	87364	87364	255260
8958	7756	1	applied	\N	\N	\N	\N	87380	87380	255274
8958	7727	0	failed	Receiver_not_present	\N	\N	\N	87379	87379	\N
8958	7761	2	applied	\N	\N	\N	\N	87381	87381	255275
8958	7581	3	applied	\N	\N	\N	\N	87382	87382	255276
8958	7646	4	applied	\N	\N	\N	\N	87383	87383	255277
8958	7572	5	applied	\N	\N	\N	\N	87384	87384	255278
8958	7555	6	applied	\N	\N	1000000000	\N	87385	87385	255279
8958	7553	7	applied	\N	\N	\N	\N	87386	87386	255280
8958	7554	8	applied	\N	\N	\N	\N	87387	87387	255281
8958	7556	9	applied	\N	\N	\N	\N	87388	87388	255282
8958	7559	10	applied	\N	\N	\N	\N	87389	87389	255283
8958	7562	12	applied	\N	\N	\N	\N	87391	87391	255285
8958	7563	13	applied	\N	\N	\N	\N	87392	87392	255286
8958	7564	14	applied	\N	\N	\N	\N	87393	87393	255287
8958	7557	15	applied	\N	\N	\N	\N	87394	87394	255288
8958	7558	16	applied	\N	\N	\N	\N	87395	87395	255289
8958	7561	17	applied	\N	\N	\N	\N	87396	87396	255290
8958	7565	18	applied	\N	\N	\N	\N	87397	87397	255291
8958	7566	19	applied	\N	\N	\N	\N	87398	87398	255292
8958	7567	20	applied	\N	\N	\N	\N	87399	87399	255293
8958	7568	21	applied	\N	\N	\N	\N	87400	87400	255294
8958	7571	22	applied	\N	\N	\N	\N	87401	87401	255295
8958	7574	23	applied	\N	\N	\N	\N	87402	87402	255296
8958	7576	24	applied	\N	\N	\N	\N	87403	87403	255297
8958	7577	25	applied	\N	\N	\N	\N	87404	87404	255298
8958	7579	26	applied	\N	\N	\N	\N	87405	87405	255299
8958	7582	27	applied	\N	\N	\N	\N	87406	87406	255300
8958	7586	29	applied	\N	\N	\N	\N	87408	87408	255302
8958	7587	30	applied	\N	\N	\N	\N	87409	87409	255303
8958	7591	31	applied	\N	\N	\N	\N	87410	87410	255304
8958	7593	32	applied	\N	\N	\N	\N	87411	87411	255305
8958	7595	33	applied	\N	\N	\N	\N	87412	87412	255306
8958	7596	34	applied	\N	\N	\N	\N	87413	87413	255307
8835	7592	0	applied	\N	\N	\N	\N	87032	87032	254931
8835	7593	1	applied	\N	\N	\N	\N	87033	87033	254932
8843	7602	3	applied	\N	\N	\N	\N	87069	87069	254968
8843	7603	4	applied	\N	\N	\N	\N	87070	87070	254969
8843	7604	5	applied	\N	\N	\N	\N	87071	87071	254970
8848	7607	0	applied	\N	\N	\N	\N	87078	87078	254977
8848	7606	1	applied	\N	\N	\N	\N	87079	87079	254978
8848	7608	2	applied	\N	\N	\N	\N	87080	87080	254979
8850	7609	0	applied	\N	\N	\N	\N	87083	87083	254982
8850	7610	1	applied	\N	\N	\N	\N	87084	87084	254983
8854	7611	0	applied	\N	\N	\N	\N	87091	87091	254990
8854	7612	1	applied	\N	\N	\N	\N	87092	87092	254991
8857	7615	0	applied	\N	\N	\N	\N	87097	87097	254996
8857	7616	1	applied	\N	\N	\N	\N	87098	87098	254997
8862	7623	0	applied	\N	\N	\N	\N	87107	87107	255006
8862	7624	1	applied	\N	\N	\N	\N	87108	87108	255007
8869	7630	1	applied	\N	\N	\N	\N	87122	87122	255021
8869	7631	2	applied	\N	\N	\N	\N	87123	87123	255022
8869	7632	3	applied	\N	\N	\N	\N	87124	87124	255023
8878	7637	0	applied	\N	\N	\N	\N	87149	87149	255048
8878	7638	1	applied	\N	\N	\N	\N	87150	87150	255049
8878	7639	2	applied	\N	\N	\N	\N	87151	87151	255050
8878	7640	3	applied	\N	\N	\N	\N	87152	87152	255051
8878	7641	4	applied	\N	\N	\N	\N	87153	87153	255052
8881	7642	0	applied	\N	\N	\N	\N	87160	87160	255059
8881	7643	1	applied	\N	\N	\N	\N	87161	87161	255060
8881	7644	2	applied	\N	\N	\N	\N	87162	87162	255061
8881	7645	3	applied	\N	\N	\N	\N	87163	87163	255062
8884	7654	0	applied	\N	\N	\N	\N	87172	87172	255071
8884	7655	1	applied	\N	\N	\N	\N	87173	87173	255072
8888	7666	0	applied	\N	\N	\N	\N	87186	87186	255085
8888	7667	1	applied	\N	\N	\N	\N	87187	87187	255086
8893	7669	1	applied	\N	\N	\N	\N	87195	87195	255094
8897	7670	0	applied	\N	\N	\N	\N	87202	87202	255101
8897	7671	1	applied	\N	\N	\N	\N	87203	87203	255102
8897	7672	2	applied	\N	\N	\N	\N	87204	87204	255103
8897	7674	3	applied	\N	\N	\N	\N	87205	87205	255104
8897	7675	4	applied	\N	\N	\N	\N	87206	87206	255105
8897	7673	5	applied	\N	\N	\N	\N	87207	87207	255106
8897	7676	6	applied	\N	\N	\N	\N	87208	87208	255107
8897	7677	7	applied	\N	\N	\N	\N	87209	87209	255108
8899	7674	0	applied	\N	\N	\N	\N	87214	87214	255113
8899	7675	1	applied	\N	\N	\N	\N	87215	87215	255114
8899	7676	2	applied	\N	\N	\N	\N	87216	87216	255115
8899	7677	3	applied	\N	\N	\N	\N	87217	87217	255116
8902	7678	0	applied	\N	\N	\N	\N	87224	87224	255123
8902	7679	1	applied	\N	\N	\N	\N	87225	87225	255124
8905	7681	0	applied	\N	\N	\N	\N	87232	87232	255131
8905	7682	1	applied	\N	\N	\N	\N	87233	87233	255132
8908	7689	0	applied	\N	\N	\N	\N	87240	87240	255139
8908	7690	1	applied	\N	\N	\N	\N	87241	87241	255140
8911	7697	0	applied	\N	\N	\N	\N	87250	87250	255149
8911	7698	1	applied	\N	\N	\N	\N	87251	87251	255150
8916	7703	0	applied	\N	\N	\N	\N	87259	87259	255158
8916	7704	1	applied	\N	\N	\N	\N	87260	87260	255159
8916	7705	2	applied	\N	\N	\N	\N	87261	87261	255160
8916	7706	3	applied	\N	\N	\N	\N	87262	87262	255161
8916	7707	4	applied	\N	\N	\N	\N	87263	87263	255162
8921	7712	0	applied	\N	\N	\N	\N	87275	87275	255174
8921	7713	1	applied	\N	\N	\N	\N	87276	87276	255175
8921	7714	2	applied	\N	\N	\N	\N	87277	87277	255176
8921	7715	3	applied	\N	\N	\N	\N	87278	87278	255177
8921	7716	4	applied	\N	\N	\N	\N	87279	87279	255178
8926	7723	0	applied	\N	\N	\N	\N	87288	87288	255187
8926	7724	1	applied	\N	\N	\N	\N	87289	87289	255188
8931	7730	0	applied	\N	\N	\N	\N	87299	87299	255197
8931	7732	2	applied	\N	\N	\N	\N	87301	87301	255199
8931	7733	3	applied	\N	\N	\N	\N	87302	87302	255200
8936	7740	0	applied	\N	\N	\N	\N	87315	87315	255213
8936	7741	1	applied	\N	\N	\N	\N	87316	87316	255214
8939	7744	0	applied	\N	\N	\N	\N	87319	87319	255217
8939	7745	2	applied	\N	\N	\N	\N	87320	87320	255218
8939	7746	3	applied	\N	\N	\N	\N	87321	87321	255219
8939	7747	4	applied	\N	\N	\N	\N	87322	87322	255220
8944	7756	0	applied	\N	\N	\N	\N	87337	87337	255235
8944	7757	1	applied	\N	\N	\N	\N	87338	87338	255236
8944	7758	2	applied	\N	\N	\N	\N	87339	87339	255237
8958	7599	35	applied	\N	\N	\N	\N	87414	87414	255308
8958	7600	36	applied	\N	\N	\N	\N	87415	87415	255309
8958	7601	37	applied	\N	\N	\N	\N	87416	87416	255310
8959	7779	0	applied	\N	\N	\N	\N	87504	87504	255398
8959	7780	1	applied	\N	\N	\N	\N	87505	87505	255399
8959	7782	3	applied	\N	\N	\N	\N	87507	87507	255401
8959	7783	4	applied	\N	\N	\N	\N	87508	87508	255402
8964	7788	0	applied	\N	\N	\N	\N	87520	87520	255414
8964	7789	1	applied	\N	\N	\N	\N	87521	87521	255415
8964	7790	2	applied	\N	\N	\N	\N	87522	87522	255416
8964	7791	3	applied	\N	\N	\N	\N	87523	87523	255417
8967	7794	0	applied	\N	\N	\N	\N	87527	87527	255421
8967	7795	1	applied	\N	\N	\N	\N	87528	87528	255422
8967	7796	2	applied	\N	\N	\N	\N	87529	87529	255423
8967	7797	3	applied	\N	\N	\N	\N	87530	87530	255424
8984	7821	0	applied	\N	\N	\N	\N	87634	87634	255527
8984	7822	1	applied	\N	\N	\N	\N	87635	87635	255528
8993	7830	0	applied	\N	\N	\N	\N	87675	87675	255562
8993	7831	1	applied	\N	\N	\N	\N	87676	87676	255563
8996	7832	0	applied	\N	\N	\N	\N	87684	87684	255571
8996	7833	1	applied	\N	\N	\N	\N	87685	87685	255572
8996	7835	3	applied	\N	\N	\N	\N	87687	87687	255574
8996	7836	4	applied	\N	\N	\N	\N	87688	87688	255575
9001	7847	0	applied	\N	\N	\N	\N	87707	87707	255594
9001	7848	1	applied	\N	\N	\N	\N	87708	87708	255595
9012	7857	0	applied	\N	\N	\N	\N	87730	87730	255617
9012	7858	1	applied	\N	\N	\N	\N	87731	87731	255618
9015	7865	0	applied	\N	\N	\N	\N	87738	87738	255625
9015	7866	1	applied	\N	\N	\N	\N	87739	87739	255626
9018	7871	0	applied	\N	\N	\N	\N	87746	87746	255633
9018	7872	1	applied	\N	\N	\N	\N	87747	87747	255634
9018	7873	2	applied	\N	\N	\N	\N	87748	87748	255635
9018	7874	3	applied	\N	\N	\N	\N	87749	87749	255636
9018	7875	4	applied	\N	\N	\N	\N	87750	87750	255637
9021	7876	0	applied	\N	\N	\N	\N	87755	87755	255642
8843	7600	1	applied	\N	\N	\N	\N	87067	87067	254966
8843	7601	2	applied	\N	\N	\N	\N	87068	87068	254967
8860	7622	1	applied	\N	\N	\N	\N	87104	87104	255003
8863	7623	0	applied	\N	\N	\N	\N	87109	87109	255008
8863	7624	1	applied	\N	\N	\N	\N	87110	87110	255009
8867	7627	0	applied	\N	\N	\N	\N	87117	87117	255016
8867	7628	1	applied	\N	\N	\N	\N	87118	87118	255017
8872	7633	0	applied	\N	\N	\N	\N	87129	87129	255028
8872	7634	1	applied	\N	\N	\N	\N	87130	87130	255029
8873	7633	0	applied	\N	\N	\N	\N	87131	87131	255030
8873	7634	1	applied	\N	\N	\N	\N	87132	87132	255031
8874	7635	0	applied	\N	\N	\N	\N	87133	87133	255032
8874	7636	1	applied	\N	\N	\N	\N	87134	87134	255033
8876	7627	0	applied	\N	\N	\N	\N	87135	87135	255034
8876	7631	1	applied	\N	\N	\N	\N	87136	87136	255035
8876	7628	2	applied	\N	\N	\N	\N	87137	87137	255036
8876	7629	3	applied	\N	\N	\N	\N	87138	87138	255037
8876	7634	5	applied	\N	\N	\N	\N	87140	87140	255039
8876	7636	6	applied	\N	\N	\N	\N	87141	87141	255040
8876	7632	7	applied	\N	\N	\N	\N	87142	87142	255041
8876	7633	8	applied	\N	\N	\N	\N	87143	87143	255042
8891	7668	0	applied	\N	\N	\N	\N	87190	87190	255089
8891	7669	1	applied	\N	\N	\N	\N	87191	87191	255090
8895	7670	0	applied	\N	\N	\N	\N	87196	87196	255095
8895	7671	1	applied	\N	\N	\N	\N	87197	87197	255096
8895	7672	2	applied	\N	\N	\N	\N	87198	87198	255097
8895	7673	3	applied	\N	\N	\N	\N	87199	87199	255098
8898	7674	0	applied	\N	\N	\N	\N	87210	87210	255109
8898	7675	1	applied	\N	\N	\N	\N	87211	87211	255110
8898	7676	2	applied	\N	\N	\N	\N	87212	87212	255111
8898	7677	3	applied	\N	\N	\N	\N	87213	87213	255112
8903	7678	0	applied	\N	\N	\N	\N	87227	87227	255126
8903	7679	1	applied	\N	\N	\N	\N	87228	87228	255127
8906	7683	0	applied	\N	\N	\N	\N	87234	87234	255133
8906	7684	1	applied	\N	\N	\N	\N	87235	87235	255134
8909	7689	0	applied	\N	\N	\N	\N	87242	87242	255141
8909	7690	1	applied	\N	\N	\N	\N	87243	87243	255142
8912	7697	0	applied	\N	\N	\N	\N	87252	87252	255151
8912	7698	1	applied	\N	\N	\N	\N	87253	87253	255152
8914	7701	0	applied	\N	\N	\N	\N	87256	87256	255155
8914	7702	1	applied	\N	\N	\N	\N	87257	87257	255156
8917	7703	0	applied	\N	\N	\N	\N	87264	87264	255163
8917	7704	1	applied	\N	\N	\N	\N	87265	87265	255164
8917	7705	2	applied	\N	\N	\N	\N	87266	87266	255165
8917	7706	3	applied	\N	\N	\N	\N	87267	87267	255166
8917	7707	4	applied	\N	\N	\N	\N	87268	87268	255167
8919	7708	0	applied	\N	\N	\N	\N	87271	87271	255170
8919	7709	1	applied	\N	\N	\N	\N	87272	87272	255171
8922	7717	0	applied	\N	\N	\N	\N	87280	87280	255179
8922	7718	1	applied	\N	\N	\N	\N	87281	87281	255180
8924	7719	0	applied	\N	\N	\N	\N	87284	87284	255183
8927	7723	0	applied	\N	\N	\N	\N	87290	87290	255189
8927	7724	1	applied	\N	\N	\N	\N	87291	87291	255190
8929	7725	0	applied	\N	\N	\N	\N	87294	87294	255193
8929	7726	1	applied	\N	\N	\N	\N	87295	87295	255194
8932	7734	0	applied	\N	\N	\N	\N	87303	87303	255201
8932	7735	1	applied	\N	\N	\N	\N	87304	87304	255202
8937	7742	0	applied	\N	\N	\N	\N	87317	87317	255215
8937	7743	1	applied	\N	\N	\N	\N	87318	87318	255216
8942	7754	0	applied	\N	\N	\N	\N	87333	87333	255231
8942	7755	1	applied	\N	\N	\N	\N	87334	87334	255232
8945	7756	1	applied	\N	\N	\N	\N	87341	87341	255238
8945	7727	0	failed	Receiver_not_present	\N	\N	\N	87340	87340	\N
8947	7761	0	applied	\N	\N	\N	\N	87344	87344	255241
8947	7759	1	applied	\N	\N	\N	\N	87345	87345	255242
8947	7762	2	applied	\N	\N	\N	\N	87346	87346	255243
8947	7760	3	applied	\N	\N	\N	\N	87347	87347	255244
8952	7769	0	applied	\N	\N	\N	\N	87359	87359	255255
8952	7770	1	applied	\N	\N	\N	\N	87360	87360	255256
8955	7761	1	applied	\N	\N	\N	\N	87370	87370	255265
8955	7766	0	failed	Receiver_not_present	\N	\N	\N	87369	87369	\N
8957	7775	0	applied	\N	\N	\N	\N	87375	87375	255270
8957	7776	1	applied	\N	\N	\N	\N	87376	87376	255271
8957	7777	2	applied	\N	\N	\N	\N	87377	87377	255272
8957	7778	3	applied	\N	\N	\N	\N	87378	87378	255273
8962	7784	0	applied	\N	\N	\N	\N	87516	87516	255410
8962	7785	1	applied	\N	\N	\N	\N	87517	87517	255411
8965	7792	0	applied	\N	\N	\N	\N	87524	87524	255418
8965	7793	1	applied	\N	\N	\N	\N	87525	87525	255419
8968	7794	0	applied	\N	\N	\N	\N	87531	87531	255425
8968	7795	1	applied	\N	\N	\N	\N	87532	87532	255426
8968	7796	2	applied	\N	\N	\N	\N	87533	87533	255427
8968	7797	3	applied	\N	\N	\N	\N	87534	87534	255428
8970	7799	1	applied	\N	\N	\N	\N	87541	87541	255435
8970	7800	2	applied	\N	\N	\N	\N	87542	87542	255436
8970	7801	3	applied	\N	\N	\N	\N	87543	87543	255437
8970	7802	4	applied	\N	\N	1000000000	\N	87544	87544	255438
8973	7811	0	applied	\N	\N	\N	\N	87553	87553	255447
8973	7812	1	applied	\N	\N	\N	\N	87554	87554	255448
8975	7756	1	applied	\N	\N	\N	\N	87558	87558	255451
8975	7727	0	failed	Receiver_not_present	\N	\N	\N	87557	87557	\N
8975	7761	2	applied	\N	\N	\N	\N	87559	87559	255452
8975	7438	3	applied	\N	\N	\N	\N	87560	87560	255453
8975	7375	4	applied	\N	\N	\N	\N	87561	87561	255454
8975	7572	5	applied	\N	\N	\N	\N	87562	87562	255455
8975	7383	6	applied	\N	\N	\N	\N	87563	87563	255456
8975	7376	7	applied	\N	\N	\N	\N	87564	87564	255457
8975	7377	8	applied	\N	\N	\N	\N	87565	87565	255458
8975	7378	10	applied	\N	\N	\N	\N	87567	87567	255460
8975	7379	11	applied	\N	\N	\N	\N	87568	87568	255461
8975	7380	12	applied	\N	\N	\N	\N	87569	87569	255462
8975	7384	13	applied	\N	\N	\N	\N	87570	87570	255463
8975	7385	14	applied	\N	\N	\N	\N	87571	87571	255464
8975	7386	15	applied	\N	\N	\N	\N	87572	87572	255465
8975	7387	16	applied	\N	\N	\N	\N	87573	87573	255466
8975	7388	17	applied	\N	\N	\N	\N	87574	87574	255467
8975	7389	18	applied	\N	\N	\N	\N	87575	87575	255468
8975	7391	19	applied	\N	\N	\N	\N	87576	87576	255469
9023	7880	0	applied	\N	\N	\N	\N	87758	87758	255645
9023	7881	1	applied	\N	\N	\N	\N	87759	87759	255646
9023	7882	2	applied	\N	\N	\N	\N	87760	87760	255647
8855	7611	0	applied	\N	\N	\N	\N	87093	87093	254992
8860	7621	0	applied	\N	\N	\N	\N	87103	87103	255002
8859	7620	1	applied	\N	\N	\N	\N	87102	87102	255001
8866	7626	1	applied	\N	\N	\N	\N	87116	87116	255015
8871	7633	0	applied	\N	\N	\N	\N	87127	87127	255026
8871	7634	1	applied	\N	\N	\N	\N	87128	87128	255027
8880	7642	0	applied	\N	\N	\N	\N	87156	87156	255055
8880	7643	1	applied	\N	\N	\N	\N	87157	87157	255056
8880	7644	2	applied	\N	\N	\N	\N	87158	87158	255057
8880	7645	3	applied	\N	\N	\N	\N	87159	87159	255058
8883	7650	0	applied	\N	\N	\N	\N	87168	87168	255067
8883	7651	1	applied	\N	\N	\N	\N	87169	87169	255068
8883	7652	2	applied	\N	\N	\N	\N	87170	87170	255069
8883	7653	3	applied	\N	\N	\N	\N	87171	87171	255070
8887	7666	0	applied	\N	\N	\N	\N	87184	87184	255083
8887	7667	1	applied	\N	\N	\N	\N	87185	87185	255084
8889	7668	0	applied	\N	\N	\N	\N	87188	87188	255087
8889	7669	1	applied	\N	\N	\N	\N	87189	87189	255088
8892	7668	0	applied	\N	\N	\N	\N	87192	87192	255091
8896	7674	0	applied	\N	\N	\N	\N	87200	87200	255099
8896	7675	1	applied	\N	\N	\N	\N	87201	87201	255100
8901	7678	0	applied	\N	\N	\N	\N	87221	87221	255120
8901	7679	1	applied	\N	\N	\N	\N	87222	87222	255121
8901	7680	2	applied	\N	\N	1000000000	\N	87223	87223	255122
8904	7678	0	applied	\N	\N	\N	\N	87230	87230	255129
8904	7679	1	applied	\N	\N	\N	\N	87231	87231	255130
8913	7699	0	applied	\N	\N	\N	\N	87254	87254	255153
8913	7700	1	applied	\N	\N	\N	\N	87255	87255	255154
8918	7708	0	applied	\N	\N	\N	\N	87269	87269	255168
8918	7709	1	applied	\N	\N	\N	\N	87270	87270	255169
8920	7710	0	applied	\N	\N	\N	\N	87273	87273	255172
8920	7711	1	applied	\N	\N	\N	\N	87274	87274	255173
8930	7728	1	applied	\N	\N	\N	\N	87297	87297	255195
8930	7729	2	applied	\N	\N	\N	\N	87298	87298	255196
8934	7736	0	applied	\N	\N	\N	\N	87309	87309	255207
8934	7737	1	applied	\N	\N	\N	\N	87310	87310	255208
8934	7738	2	applied	\N	\N	\N	\N	87311	87311	255209
8934	7739	3	applied	\N	\N	\N	\N	87312	87312	255210
8941	7744	0	applied	\N	\N	\N	\N	87323	87323	255221
8941	7745	1	applied	\N	\N	\N	\N	87324	87324	255222
8941	7746	2	applied	\N	\N	\N	\N	87325	87325	255223
8941	7748	3	applied	\N	\N	\N	\N	87326	87326	255224
8941	7749	4	applied	\N	\N	\N	\N	87327	87327	255225
8941	7747	5	applied	\N	\N	\N	\N	87328	87328	255226
8941	7750	6	applied	\N	\N	\N	\N	87329	87329	255227
8941	7751	7	applied	\N	\N	\N	\N	87330	87330	255228
8941	7752	8	applied	\N	\N	1000000000	\N	87331	87331	255229
8941	7753	9	applied	\N	\N	1000000000	\N	87332	87332	255230
8946	7759	0	applied	\N	\N	\N	\N	87342	87342	255239
8946	7760	1	applied	\N	\N	\N	\N	87343	87343	255240
8948	7761	0	applied	\N	\N	\N	\N	87349	87349	255246
8948	7759	1	applied	\N	\N	\N	\N	87350	87350	255247
8948	7762	2	applied	\N	\N	\N	\N	87351	87351	255248
8948	7760	3	applied	\N	\N	\N	\N	87352	87352	255249
8948	7763	4	applied	\N	\N	\N	\N	87353	87353	255250
8951	7767	1	applied	\N	\N	\N	\N	87357	87357	255253
8951	7768	2	applied	\N	\N	\N	\N	87358	87358	255254
8954	7771	0	applied	\N	\N	\N	\N	87365	87365	255261
8954	7772	1	applied	\N	\N	\N	\N	87366	87366	255262
8954	7773	2	applied	\N	\N	\N	\N	87367	87367	255263
8954	7774	3	applied	\N	\N	\N	\N	87368	87368	255264
8956	7775	0	applied	\N	\N	\N	\N	87371	87371	255266
8956	7776	1	applied	\N	\N	\N	\N	87372	87372	255267
8956	7777	2	applied	\N	\N	\N	\N	87373	87373	255268
8956	7778	3	applied	\N	\N	\N	\N	87374	87374	255269
8961	7784	0	applied	\N	\N	\N	\N	87514	87514	255408
8961	7785	1	applied	\N	\N	\N	\N	87515	87515	255409
8963	7786	0	applied	\N	\N	\N	\N	87518	87518	255412
8963	7787	1	applied	\N	\N	\N	\N	87519	87519	255413
8966	7783	0	applied	\N	\N	\N	\N	87526	87526	255420
8969	7798	0	applied	\N	\N	\N	\N	87535	87535	255429
8969	7799	1	applied	\N	\N	\N	\N	87536	87536	255430
8969	7800	2	applied	\N	\N	\N	\N	87537	87537	255431
8969	7801	3	applied	\N	\N	\N	\N	87538	87538	255432
8971	7803	0	applied	\N	\N	\N	\N	87545	87545	255439
8971	7804	1	applied	\N	\N	\N	\N	87546	87546	255440
8972	7805	0	applied	\N	\N	\N	\N	87547	87547	255441
8972	7806	1	applied	\N	\N	\N	\N	87548	87548	255442
8972	7807	2	applied	\N	\N	\N	\N	87549	87549	255443
8972	7808	3	applied	\N	\N	\N	\N	87550	87550	255444
8972	7809	4	applied	\N	\N	\N	\N	87551	87551	255445
8972	7810	5	applied	\N	\N	\N	\N	87552	87552	255446
8975	7392	21	applied	\N	\N	\N	\N	87577	87577	255470
8975	7381	22	applied	\N	\N	\N	\N	87578	87578	255471
8975	7382	23	applied	\N	\N	\N	\N	87579	87579	255472
8977	7813	0	applied	\N	\N	\N	\N	87621	87621	255514
8977	7814	1	applied	\N	\N	\N	\N	87622	87622	255515
8979	7817	0	applied	\N	\N	\N	\N	87625	87625	255518
8979	7818	1	applied	\N	\N	\N	\N	87626	87626	255519
8986	7822	0	applied	\N	\N	\N	\N	87637	87637	255530
8986	7823	2	applied	\N	\N	\N	\N	87638	87638	255531
8986	7824	3	applied	\N	\N	\N	\N	87639	87639	255532
8986	7825	4	applied	\N	\N	\N	\N	87640	87640	255533
8986	7827	6	applied	\N	\N	\N	\N	87642	87642	87642
8989	7822	0	applied	\N	\N	\N	\N	87655	87655	255545
8989	7823	2	applied	\N	\N	\N	\N	87656	87656	255546
8989	7824	3	applied	\N	\N	\N	\N	87657	87657	255547
8989	7825	4	applied	\N	\N	\N	\N	87658	87658	255548
8989	7826	5	applied	\N	\N	\N	\N	87659	87659	255549
8989	7827	6	applied	\N	\N	\N	\N	87660	87660	87660
8991	7822	0	applied	\N	\N	\N	\N	87667	87667	255555
8991	7823	2	applied	\N	\N	\N	\N	87668	87668	255556
8991	7824	3	applied	\N	\N	\N	\N	87669	87669	255557
8991	7825	4	applied	\N	\N	\N	\N	87670	87670	255558
8991	7826	5	applied	\N	\N	\N	\N	87671	87671	255559
8991	7827	6	applied	\N	\N	\N	\N	87672	87672	87672
8992	7828	0	applied	\N	\N	\N	\N	87673	87673	255560
8992	7829	1	applied	\N	\N	\N	\N	87674	87674	255561
8994	7830	0	applied	\N	\N	\N	\N	87677	87677	255564
8999	7843	0	applied	\N	\N	\N	\N	87701	87701	255588
8999	7844	1	applied	\N	\N	\N	\N	87702	87702	255589
8856	7614	1	applied	\N	\N	\N	\N	87096	87096	254995
8859	7619	0	applied	\N	\N	\N	\N	87101	87101	255000
8958	7569	42	applied	\N	\N	\N	\N	87421	87421	255315
8958	7570	43	applied	\N	\N	\N	\N	87422	87422	255316
8958	7573	44	applied	\N	\N	\N	\N	87423	87423	255317
8958	7575	45	applied	\N	\N	\N	\N	87424	87424	255318
8958	7578	46	applied	\N	\N	\N	\N	87425	87425	255319
8958	7580	47	applied	\N	\N	\N	\N	87426	87426	255320
8958	7583	48	applied	\N	\N	\N	\N	87427	87427	255321
8958	7585	49	applied	\N	\N	\N	\N	87428	87428	255322
8958	7588	50	applied	\N	\N	\N	\N	87429	87429	255323
8958	7590	51	applied	\N	\N	\N	\N	87430	87430	255324
8958	7594	52	applied	\N	\N	\N	\N	87431	87431	255325
8958	7597	53	applied	\N	\N	\N	\N	87432	87432	255326
8958	7598	54	applied	\N	\N	\N	\N	87433	87433	255327
8958	7602	55	applied	\N	\N	\N	\N	87434	87434	255328
8958	7603	56	applied	\N	\N	\N	\N	87435	87435	255329
8958	7604	57	applied	\N	\N	\N	\N	87436	87436	255330
8958	7607	59	applied	\N	\N	\N	\N	87438	87438	255332
8958	7609	60	applied	\N	\N	\N	\N	87439	87439	255333
8958	7612	61	applied	\N	\N	\N	\N	87440	87440	255334
8958	7613	62	applied	\N	\N	\N	\N	87441	87441	255335
8958	7616	63	applied	\N	\N	\N	\N	87442	87442	255336
8958	7617	64	applied	\N	\N	\N	\N	87443	87443	255337
8958	7620	65	applied	\N	\N	\N	\N	87444	87444	255338
8958	7621	66	applied	\N	\N	\N	\N	87445	87445	255339
8958	7623	68	applied	\N	\N	\N	\N	87446	87446	255340
8958	7625	69	applied	\N	\N	\N	\N	87447	87447	255341
8958	7627	70	applied	\N	\N	\N	\N	87448	87448	255342
8958	7631	71	applied	\N	\N	\N	\N	87449	87449	255343
8958	7589	72	applied	\N	\N	\N	\N	87450	87450	255344
8958	7632	73	applied	\N	\N	\N	\N	87451	87451	255345
8958	7633	74	applied	\N	\N	\N	\N	87452	87452	255346
8958	7635	75	applied	\N	\N	\N	\N	87453	87453	255347
8958	7638	77	applied	\N	\N	\N	\N	87455	87455	255349
8958	7639	78	applied	\N	\N	\N	\N	87456	87456	255350
8958	7643	79	applied	\N	\N	\N	\N	87457	87457	255351
8958	7644	80	applied	\N	\N	\N	\N	87458	87458	255352
8958	7649	81	applied	\N	\N	\N	\N	87459	87459	255353
8958	7651	82	applied	\N	\N	\N	\N	87460	87460	255354
8958	7652	83	applied	\N	\N	\N	\N	87461	87461	255355
8958	7654	84	applied	\N	\N	\N	\N	87462	87462	255356
8958	7657	85	applied	\N	\N	\N	\N	87463	87463	255357
8958	7658	86	applied	\N	\N	\N	\N	87464	87464	255358
8958	7659	87	applied	\N	\N	\N	\N	87465	87465	255359
8958	7661	88	applied	\N	\N	\N	\N	87466	87466	255360
8958	7662	89	applied	\N	\N	\N	\N	87467	87467	255361
8958	7666	90	applied	\N	\N	\N	\N	87468	87468	255362
8958	7669	91	applied	\N	\N	\N	\N	87469	87469	255363
8958	7671	92	applied	\N	\N	\N	\N	87470	87470	255364
8958	7674	94	applied	\N	\N	\N	\N	87472	87472	255366
8958	7675	95	applied	\N	\N	\N	\N	87473	87473	255367
8958	7678	96	applied	\N	\N	\N	\N	87474	87474	255368
8958	7682	97	applied	\N	\N	\N	\N	87475	87475	255369
8958	7683	98	applied	\N	\N	\N	\N	87476	87476	255370
8958	7687	99	applied	\N	\N	\N	\N	87477	87477	255371
8958	7688	100	applied	\N	\N	\N	\N	87478	87478	255372
8958	7689	101	applied	\N	\N	\N	\N	87479	87479	255373
8958	7691	102	applied	\N	\N	\N	\N	87480	87480	255374
8958	7693	103	applied	\N	\N	\N	\N	87481	87481	255375
8958	7694	104	applied	\N	\N	\N	\N	87482	87482	255376
8958	7697	105	applied	\N	\N	\N	\N	87483	87483	255377
8958	7700	106	applied	\N	\N	\N	\N	87484	87484	255378
8958	7702	107	applied	\N	\N	\N	\N	87485	87485	255379
8958	7703	108	applied	\N	\N	\N	\N	87486	87486	255380
8958	7704	109	applied	\N	\N	\N	\N	87487	87487	255381
8958	7710	111	applied	\N	\N	\N	\N	87489	87489	255383
8958	7712	112	applied	\N	\N	\N	\N	87490	87490	255384
8958	7715	113	applied	\N	\N	\N	\N	87491	87491	255385
8958	7717	114	applied	\N	\N	\N	\N	87492	87492	255386
8958	7719	115	applied	\N	\N	\N	\N	87493	87493	255387
8958	7722	116	applied	\N	\N	\N	\N	87494	87494	255388
8958	7724	117	applied	\N	\N	\N	\N	87495	87495	255389
8958	7725	118	applied	\N	\N	\N	\N	87496	87496	255390
8958	7728	119	applied	\N	\N	\N	\N	87497	87497	255391
8958	7732	120	applied	\N	\N	\N	\N	87498	87498	255392
8958	7733	121	applied	\N	\N	\N	\N	87499	87499	255393
8958	7735	122	applied	\N	\N	\N	\N	87500	87500	255394
8958	7738	123	applied	\N	\N	\N	\N	87501	87501	255395
8958	7739	124	applied	\N	\N	\N	\N	87502	87502	255396
8958	7740	125	applied	\N	\N	\N	\N	87503	87503	255397
8960	7779	0	applied	\N	\N	\N	\N	87509	87509	255403
8960	7781	2	applied	\N	\N	\N	\N	87511	87511	255405
8960	7782	3	applied	\N	\N	\N	\N	87512	87512	255406
8960	7783	4	applied	\N	\N	\N	\N	87513	87513	255407
8974	7811	0	applied	\N	\N	\N	\N	87555	87555	255449
8974	7812	1	applied	\N	\N	\N	\N	87556	87556	255450
8976	7813	0	applied	\N	\N	\N	\N	87619	87619	255512
8976	7814	1	applied	\N	\N	\N	\N	87620	87620	255513
8978	7815	0	applied	\N	\N	\N	\N	87623	87623	255516
8978	7816	1	applied	\N	\N	\N	\N	87624	87624	255517
8981	7817	0	applied	\N	\N	\N	\N	87629	87629	255522
8981	7818	1	applied	\N	\N	\N	\N	87630	87630	255523
8983	7820	0	applied	\N	\N	\N	\N	87633	87633	255526
8985	7821	0	applied	\N	\N	\N	\N	87636	87636	255529
8988	7822	0	applied	\N	\N	\N	\N	87649	87649	255540
8988	7823	2	applied	\N	\N	\N	\N	87650	87650	255541
8988	7824	3	applied	\N	\N	\N	\N	87651	87651	255542
8988	7826	5	applied	\N	\N	\N	\N	87653	87653	255544
8988	7827	6	applied	\N	\N	\N	\N	87654	87654	87654
8990	7822	0	applied	\N	\N	\N	\N	87661	87661	255550
8990	7823	2	applied	\N	\N	\N	\N	87662	87662	255551
8990	7824	3	applied	\N	\N	\N	\N	87663	87663	255552
8990	7825	4	applied	\N	\N	\N	\N	87664	87664	255553
8990	7826	5	applied	\N	\N	\N	\N	87665	87665	255554
8990	7827	6	applied	\N	\N	\N	\N	87666	87666	87666
8995	7832	0	applied	\N	\N	\N	\N	87679	87679	255566
8995	7833	1	applied	\N	\N	\N	\N	87680	87680	255567
8995	7834	2	applied	\N	\N	\N	\N	87681	87681	255568
8999	7845	2	applied	\N	\N	\N	\N	87703	87703	255590
8999	7846	3	applied	\N	\N	\N	\N	87704	87704	255591
9002	7847	0	applied	\N	\N	\N	\N	87709	87709	255596
8958	7608	39	applied	\N	\N	\N	\N	87418	87418	255312
8958	7610	40	applied	\N	\N	\N	\N	87419	87419	255313
8975	7425	27	applied	\N	\N	\N	\N	87583	87583	255476
8975	7426	28	applied	\N	\N	\N	\N	87584	87584	255477
8975	7428	29	applied	\N	\N	\N	\N	87585	87585	255478
8975	7429	30	applied	\N	\N	\N	\N	87586	87586	255479
8975	7432	31	applied	\N	\N	\N	\N	87587	87587	255480
8975	7435	33	applied	\N	\N	\N	\N	87589	87589	255482
8975	7439	34	applied	\N	\N	\N	\N	87590	87590	255483
8975	7440	35	applied	\N	\N	\N	\N	87591	87591	255484
8975	7441	36	applied	\N	\N	\N	\N	87592	87592	255485
8975	7446	37	applied	\N	\N	\N	\N	87593	87593	255486
8975	7447	38	applied	\N	\N	\N	\N	87594	87594	255487
8975	7450	39	applied	\N	\N	\N	\N	87595	87595	255488
8975	7452	40	applied	\N	\N	\N	\N	87596	87596	255489
8975	7453	41	applied	\N	\N	\N	\N	87597	87597	255490
8975	7455	42	applied	\N	\N	\N	\N	87598	87598	255491
8975	7457	43	applied	\N	\N	\N	\N	87599	87599	255492
8975	7458	44	applied	\N	\N	\N	\N	87600	87600	255493
8975	7461	45	applied	\N	\N	\N	\N	87601	87601	255494
8975	7463	46	applied	\N	\N	\N	\N	87602	87602	255495
8975	7467	47	applied	\N	\N	\N	\N	87603	87603	255496
8975	7468	48	applied	\N	\N	\N	\N	87604	87604	255497
8975	7470	50	applied	\N	\N	\N	\N	87606	87606	255499
8975	7474	51	applied	\N	\N	\N	\N	87607	87607	255500
8975	7476	52	applied	\N	\N	\N	\N	87608	87608	255501
8975	7478	53	applied	\N	\N	\N	\N	87609	87609	255502
8975	7480	54	applied	\N	\N	\N	\N	87610	87610	255503
8975	7481	55	applied	\N	\N	\N	\N	87611	87611	255504
8975	7483	56	applied	\N	\N	\N	\N	87612	87612	255505
8975	7485	57	applied	\N	\N	\N	\N	87613	87613	255506
8975	7488	58	applied	\N	\N	\N	\N	87614	87614	255507
8975	7489	59	applied	\N	\N	\N	\N	87615	87615	255508
8975	7492	60	applied	\N	\N	\N	\N	87616	87616	255509
8975	7493	61	applied	\N	\N	\N	\N	87617	87617	255510
8975	7495	62	applied	\N	\N	\N	\N	87618	87618	255511
8980	7817	0	applied	\N	\N	\N	\N	87627	87627	255520
8980	7818	1	applied	\N	\N	\N	\N	87628	87628	255521
8982	7819	0	applied	\N	\N	\N	\N	87631	87631	255524
8987	7822	0	applied	\N	\N	\N	\N	87643	87643	255535
8987	7823	2	applied	\N	\N	\N	\N	87644	87644	255536
8987	7824	3	applied	\N	\N	\N	\N	87645	87645	255537
8987	7825	4	applied	\N	\N	\N	\N	87646	87646	255538
8987	7826	5	applied	\N	\N	\N	\N	87647	87647	255539
8987	7827	6	applied	\N	\N	\N	\N	87648	87648	87648
8995	7835	3	applied	\N	\N	\N	\N	87682	87682	255569
8995	7836	4	applied	\N	\N	\N	\N	87683	87683	255570
8997	7837	0	applied	\N	\N	\N	\N	87689	87689	255576
8997	7838	1	applied	\N	\N	\N	\N	87690	87690	255577
8997	7839	2	applied	\N	\N	\N	\N	87691	87691	255578
8997	7840	3	applied	\N	\N	\N	\N	87692	87692	255579
8997	7841	4	applied	\N	\N	\N	\N	87693	87693	255580
8997	7842	5	applied	\N	\N	\N	\N	87694	87694	255581
8998	7837	0	applied	\N	\N	\N	\N	87695	87695	255582
9000	7847	0	applied	\N	\N	\N	\N	87705	87705	255592
9003	7847	0	applied	\N	\N	\N	\N	87711	87711	255598
9004	7849	0	applied	\N	\N	\N	\N	87712	87712	255599
9004	7850	1	applied	\N	\N	\N	\N	87713	87713	255600
9009	7853	0	applied	\N	\N	\N	\N	87718	87718	255605
9009	7854	1	applied	\N	\N	\N	\N	87719	87719	255606
9009	7855	2	applied	\N	\N	\N	\N	87720	87720	255607
9009	7856	3	applied	\N	\N	\N	\N	87721	87721	255608
9014	7863	0	applied	\N	\N	\N	\N	87736	87736	255623
9014	7864	1	applied	\N	\N	\N	\N	87737	87737	255624
9016	7865	0	applied	\N	\N	\N	\N	87740	87740	255627
9016	7866	1	applied	\N	\N	\N	\N	87741	87741	255628
9020	7876	0	applied	\N	\N	\N	\N	87753	87753	255640
9020	7877	1	applied	\N	\N	\N	\N	87754	87754	255641
9029	7888	0	applied	\N	\N	\N	\N	87774	87774	255661
9029	7889	1	applied	\N	\N	\N	\N	87775	87775	255662
9031	7890	0	applied	\N	\N	\N	\N	87778	87778	255665
9031	7892	2	applied	\N	\N	\N	\N	87780	87780	255667
9041	7903	0	applied	\N	\N	\N	\N	87803	87803	255690
9041	7904	1	applied	\N	\N	\N	\N	87804	87804	255691
9051	7927	0	applied	\N	\N	\N	\N	87865	87865	255751
9051	7928	1	applied	\N	\N	\N	\N	87866	87866	255752
9055	7931	0	applied	\N	\N	\N	\N	87873	87873	255759
9055	7932	1	applied	\N	\N	\N	\N	87874	87874	255760
9055	7933	2	applied	\N	\N	\N	\N	87875	87875	255761
9055	7934	3	applied	\N	\N	\N	\N	87876	87876	255762
9055	7935	4	applied	\N	\N	\N	\N	87877	87877	255763
9057	7931	0	applied	\N	\N	\N	\N	87883	87883	255769
9057	7932	1	applied	\N	\N	\N	\N	87884	87884	255770
9057	7933	2	applied	\N	\N	\N	\N	87885	87885	255771
9057	7934	3	applied	\N	\N	\N	\N	87886	87886	255772
9057	7935	4	applied	\N	\N	\N	\N	87887	87887	255773
9062	7940	0	applied	\N	\N	\N	\N	87898	87898	255784
9062	7942	2	applied	\N	\N	\N	\N	87900	87900	255786
9062	7943	3	applied	\N	\N	\N	\N	87901	87901	255787
9064	7944	0	applied	\N	\N	1000000000	\N	87905	87905	255791
9064	7945	1	applied	\N	\N	\N	\N	87906	87906	255792
9064	7946	2	applied	\N	\N	\N	\N	87907	87907	255793
9067	7949	0	applied	\N	\N	1000000000	\N	87910	87910	255796
9067	7950	1	applied	\N	\N	\N	\N	87911	87911	255797
9067	7951	2	applied	\N	\N	\N	\N	87912	87912	255798
9067	7952	3	applied	\N	\N	\N	\N	87913	87913	255799
9067	7953	4	applied	\N	\N	\N	\N	87914	87914	255800
9077	7980	0	applied	\N	\N	\N	\N	87950	87950	255836
9077	7981	1	applied	\N	\N	\N	\N	87951	87951	255837
9077	7982	2	applied	\N	\N	\N	\N	87952	87952	255838
9077	7983	4	applied	\N	\N	\N	\N	87953	87953	255839
9077	7984	5	applied	\N	\N	\N	\N	87954	87954	255840
9077	7985	6	applied	\N	\N	\N	\N	87955	87955	255841
9079	7987	0	applied	\N	\N	\N	\N	87959	87959	255845
9082	7989	0	applied	\N	\N	\N	\N	87968	87968	255854
9082	7990	1	applied	\N	\N	1000000000	\N	87969	87969	255855
9082	7988	2	applied	\N	\N	\N	\N	87970	87970	255856
9083	7989	0	applied	\N	\N	\N	\N	87971	87971	255857
9083	7990	1	applied	\N	\N	1000000000	\N	87972	87972	255858
9085	7992	0	applied	\N	\N	\N	\N	87975	87975	255861
9085	7993	1	applied	\N	\N	1000000000	\N	87976	87976	255862
8975	7422	25	applied	\N	\N	1000000000	\N	87581	87581	255474
8975	7423	26	applied	\N	\N	\N	\N	87582	87582	255475
8998	7841	4	applied	\N	\N	\N	\N	87699	87699	255586
8998	7842	5	applied	\N	\N	\N	\N	87700	87700	255587
9005	7849	0	applied	\N	\N	\N	\N	87714	87714	255601
9005	7850	1	applied	\N	\N	\N	\N	87715	87715	255602
9010	7853	0	applied	\N	\N	\N	\N	87722	87722	255609
9010	7854	1	applied	\N	\N	\N	\N	87723	87723	255610
9010	7855	2	applied	\N	\N	\N	\N	87724	87724	255611
9010	7856	3	applied	\N	\N	\N	\N	87725	87725	255612
9017	7867	0	applied	\N	\N	\N	\N	87742	87742	255629
9017	7868	1	applied	\N	\N	\N	\N	87743	87743	255630
9017	7869	2	applied	\N	\N	\N	\N	87744	87744	255631
9022	7878	0	applied	\N	\N	\N	\N	87756	87756	255643
9022	7879	1	applied	\N	\N	\N	\N	87757	87757	255644
9025	7884	0	applied	\N	\N	\N	\N	87766	87766	255653
9025	7885	1	applied	\N	\N	\N	\N	87767	87767	255654
9027	7886	0	applied	\N	\N	\N	\N	87770	87770	255657
9027	7887	1	applied	\N	\N	\N	\N	87771	87771	255658
9030	7888	0	applied	\N	\N	\N	\N	87776	87776	255663
9030	7889	1	applied	\N	\N	\N	\N	87777	87777	255664
9032	7890	0	applied	\N	\N	\N	\N	87781	87781	255668
9032	7891	1	applied	\N	\N	\N	\N	87782	87782	255669
9032	7892	2	applied	\N	\N	\N	\N	87783	87783	255670
9034	7893	0	applied	\N	\N	\N	\N	87787	87787	255674
9034	7894	1	applied	\N	\N	\N	\N	87788	87788	255675
9034	7895	2	applied	\N	\N	\N	\N	87789	87789	255676
9034	7896	3	applied	\N	\N	\N	\N	87790	87790	255677
9039	7901	0	applied	\N	\N	\N	\N	87799	87799	255686
9044	7905	0	applied	\N	\N	\N	\N	87810	87810	255697
9044	7906	1	applied	\N	\N	\N	\N	87811	87811	255698
9044	7907	2	applied	\N	\N	\N	\N	87812	87812	255699
9044	7908	3	applied	\N	\N	\N	\N	87813	87813	255700
9044	7909	4	applied	\N	\N	1000000000	\N	87814	87814	255701
9046	7910	0	applied	\N	\N	\N	\N	87818	87818	255704
9046	7911	1	applied	\N	\N	\N	\N	87819	87819	255705
9046	7912	2	applied	\N	\N	\N	\N	87820	87820	255706
9046	7913	3	applied	\N	\N	\N	\N	87821	87821	255707
9059	7938	0	applied	\N	\N	\N	\N	87890	87890	255776
9059	7939	1	applied	\N	\N	\N	\N	87891	87891	255777
9069	7954	0	applied	\N	\N	\N	\N	87917	87917	255803
9069	7955	1	applied	\N	\N	\N	\N	87918	87918	255804
9070	7956	0	applied	\N	\N	\N	\N	87919	87919	255805
9070	7957	1	applied	\N	\N	\N	\N	87920	87920	255806
9070	7958	2	applied	\N	\N	\N	\N	87921	87921	255807
9070	7960	4	applied	\N	\N	\N	\N	87923	87923	255809
9070	7961	5	applied	\N	\N	\N	\N	87924	87924	255810
9070	7962	6	applied	\N	\N	\N	\N	87925	87925	255811
9070	7963	7	applied	\N	\N	\N	\N	87926	87926	255812
9070	7964	8	applied	\N	\N	\N	\N	87927	87927	255813
9070	7965	9	applied	\N	\N	\N	\N	87928	87928	255814
9070	7966	10	applied	\N	\N	\N	\N	87929	87929	255815
9073	7974	0	applied	\N	\N	\N	\N	87937	87937	255823
9073	7975	1	applied	\N	\N	\N	\N	87938	87938	255824
9076	7980	0	applied	\N	\N	\N	\N	87943	87943	255829
9076	7981	1	applied	\N	\N	\N	\N	87944	87944	255830
9076	7982	2	applied	\N	\N	\N	\N	87945	87945	255831
9076	7983	4	applied	\N	\N	\N	\N	87946	87946	255832
9076	7984	5	applied	\N	\N	\N	\N	87947	87947	255833
9076	7985	6	applied	\N	\N	\N	\N	87948	87948	255834
9076	7986	7	applied	\N	\N	\N	\N	87949	87949	255835
9078	7988	1	applied	\N	\N	\N	\N	87958	87958	255844
9081	7989	0	applied	\N	\N	\N	\N	87964	87964	255850
9081	7990	1	applied	\N	\N	1000000000	\N	87965	87965	255851
9081	7988	2	applied	\N	\N	\N	\N	87966	87966	255852
9081	7991	3	applied	\N	\N	\N	\N	87967	87967	255853
9087	7994	0	applied	\N	\N	\N	\N	88012	88012	255898
9087	7995	1	applied	\N	\N	\N	\N	88013	88013	255899
9087	7996	2	applied	\N	\N	\N	\N	88014	88014	255900
9087	7997	3	applied	\N	\N	\N	\N	88015	88015	255901
9087	7998	4	applied	\N	\N	\N	\N	88016	88016	255902
9088	7999	0	applied	\N	\N	\N	\N	88017	88017	255903
9090	7999	0	applied	\N	\N	\N	\N	88029	88029	255915
9090	8000	1	applied	\N	\N	\N	\N	88030	88030	255916
9090	8001	2	applied	\N	\N	\N	\N	88031	88031	255917
9090	8002	3	applied	\N	\N	\N	\N	88032	88032	255918
9090	8003	4	applied	\N	\N	\N	\N	88033	88033	255919
9090	8005	6	applied	\N	\N	\N	\N	88035	88035	255921
9090	8006	7	applied	\N	\N	\N	\N	88036	88036	255922
9090	8007	8	applied	\N	\N	1000000000	\N	88037	88037	255923
9090	8008	9	applied	\N	\N	\N	\N	88038	88038	255924
9090	8009	10	applied	\N	\N	\N	\N	88039	88039	255925
9091	7999	0	applied	\N	\N	\N	\N	88040	88040	255926
9091	8000	1	applied	\N	\N	\N	\N	88041	88041	255927
9091	8001	2	applied	\N	\N	\N	\N	88042	88042	255928
9093	7999	0	applied	\N	\N	\N	\N	88062	88062	255948
9096	8010	0	applied	\N	\N	\N	\N	88065	88065	255951
9096	8011	1	applied	\N	\N	\N	\N	88066	88066	255952
9101	8017	0	applied	\N	\N	\N	\N	88076	88076	255962
9101	8018	1	applied	\N	\N	\N	\N	88077	88077	255963
9104	8017	0	applied	\N	\N	\N	\N	88082	88082	255968
9104	8018	1	applied	\N	\N	\N	\N	88083	88083	255969
9105	8019	0	applied	\N	\N	\N	\N	88084	88084	255970
9110	8023	0	applied	\N	\N	\N	\N	88094	88094	255980
9110	8024	1	applied	\N	\N	\N	\N	88095	88095	255981
9113	8027	0	applied	\N	\N	\N	\N	88102	88102	255988
9113	8028	1	applied	\N	\N	\N	\N	88103	88103	255989
9113	8029	2	applied	\N	\N	\N	\N	88104	88104	255990
9113	8030	3	applied	\N	\N	\N	\N	88105	88105	255991
9116	8035	0	applied	\N	\N	\N	\N	88110	88110	255996
9116	8036	1	applied	\N	\N	\N	\N	88111	88111	255997
9116	8037	2	applied	\N	\N	\N	\N	88112	88112	255998
9116	8038	3	applied	\N	\N	\N	\N	88113	88113	255999
9119	8035	0	applied	\N	\N	\N	\N	88122	88122	256008
9119	8036	1	applied	\N	\N	\N	\N	88123	88123	256009
9119	8037	2	applied	\N	\N	\N	\N	88124	88124	256010
9119	8038	3	applied	\N	\N	\N	\N	88125	88125	256011
9122	8039	0	applied	\N	\N	\N	\N	88128	88128	256014
9122	8040	1	applied	\N	\N	\N	\N	88129	88129	256015
9124	8042	1	applied	\N	\N	\N	\N	88133	88133	256019
9124	8043	2	applied	\N	\N	\N	\N	88134	88134	256020
8998	7839	2	applied	\N	\N	\N	\N	87697	87697	255584
8998	7840	3	applied	\N	\N	\N	\N	87698	87698	255585
9011	7853	0	applied	\N	\N	\N	\N	87726	87726	255613
9011	7854	1	applied	\N	\N	\N	\N	87727	87727	255614
9011	7855	2	applied	\N	\N	\N	\N	87728	87728	255615
9013	7859	0	applied	\N	\N	\N	\N	87732	87732	255619
9013	7860	1	applied	\N	\N	\N	\N	87733	87733	255620
9013	7861	2	applied	\N	\N	\N	\N	87734	87734	255621
9013	7862	3	applied	\N	\N	\N	\N	87735	87735	255622
9019	7876	0	applied	\N	\N	\N	\N	87751	87751	255638
9019	7877	1	applied	\N	\N	\N	\N	87752	87752	255639
9024	7880	0	applied	\N	\N	\N	\N	87762	87762	255649
9024	7881	1	applied	\N	\N	\N	\N	87763	87763	255650
9024	7882	2	applied	\N	\N	\N	\N	87764	87764	255651
9024	7883	3	applied	\N	\N	\N	\N	87765	87765	255652
9036	7897	0	applied	\N	\N	\N	\N	87793	87793	255680
9036	7898	1	applied	\N	\N	\N	\N	87794	87794	255681
9038	7899	0	applied	\N	\N	\N	\N	87797	87797	255684
9038	7900	2	applied	\N	\N	\N	\N	87798	87798	255685
9040	7903	0	applied	\N	\N	\N	\N	87801	87801	255688
9040	7904	1	applied	\N	\N	\N	\N	87802	87802	255689
9045	7756	1	applied	\N	\N	\N	\N	87816	87816	255702
9045	7761	2	applied	\N	\N	\N	\N	87817	87817	255703
9049	7914	0	applied	\N	\N	\N	\N	87839	87839	255725
9049	7915	1	applied	\N	\N	\N	\N	87840	87840	255726
9049	7916	2	applied	\N	\N	\N	\N	87841	87841	255727
9049	7917	3	applied	\N	\N	\N	\N	87842	87842	255728
9049	7918	4	applied	\N	\N	\N	\N	87843	87843	255729
9049	7919	5	applied	\N	\N	\N	\N	87844	87844	255730
9049	7920	6	applied	\N	\N	\N	\N	87845	87845	255731
9049	7921	7	applied	\N	\N	\N	\N	87846	87846	255732
9049	7922	8	applied	\N	\N	\N	\N	87847	87847	255733
9049	7923	9	applied	\N	\N	1000000000	\N	87848	87848	255734
9049	7924	10	applied	\N	\N	\N	\N	87849	87849	255735
9049	7925	11	applied	\N	\N	\N	\N	87850	87850	255736
9049	7926	12	applied	\N	\N	\N	\N	87851	87851	255737
9053	7929	0	applied	\N	\N	\N	\N	87869	87869	255755
9053	7930	1	applied	\N	\N	\N	\N	87870	87870	255756
9056	7931	0	applied	\N	\N	\N	\N	87878	87878	255764
9056	7932	1	applied	\N	\N	\N	\N	87879	87879	255765
9056	7933	2	applied	\N	\N	\N	\N	87880	87880	255766
9056	7935	4	applied	\N	\N	\N	\N	87882	87882	255768
9060	7938	0	applied	\N	\N	\N	\N	87892	87892	255778
9060	7939	1	applied	\N	\N	\N	\N	87893	87893	255779
9065	7947	0	applied	\N	\N	\N	\N	87908	87908	255794
9065	7948	1	applied	\N	\N	\N	\N	87909	87909	255795
9071	7967	0	applied	\N	\N	\N	\N	87930	87930	255816
9071	7968	1	applied	\N	\N	\N	\N	87931	87931	255817
9074	7976	0	applied	\N	\N	\N	\N	87939	87939	255825
9074	7977	1	applied	\N	\N	\N	\N	87940	87940	255826
9086	7969	0	applied	\N	\N	\N	\N	87977	87977	255863
9086	7956	1	applied	\N	\N	\N	\N	87978	87978	255864
9086	7980	2	applied	\N	\N	\N	\N	87979	87979	255865
9086	7901	3	applied	\N	\N	\N	\N	87980	87980	255866
9086	7903	4	applied	\N	\N	\N	\N	87981	87981	255867
9086	7915	6	applied	\N	\N	\N	\N	87983	87983	255869
9086	7990	7	applied	\N	\N	1000000000	\N	87984	87984	255870
9086	7983	8	applied	\N	\N	\N	\N	87985	87985	255871
9086	7984	9	applied	\N	\N	\N	\N	87986	87986	255872
9086	7902	10	applied	\N	\N	\N	\N	87987	87987	255873
9086	7904	11	applied	\N	\N	\N	\N	87988	87988	255874
9086	7905	12	applied	\N	\N	\N	\N	87989	87989	255875
9086	7906	13	applied	\N	\N	\N	\N	87990	87990	255876
9086	7910	14	applied	\N	\N	\N	\N	87991	87991	255877
9086	7911	15	applied	\N	\N	\N	\N	87992	87992	255878
9086	7907	16	applied	\N	\N	\N	\N	87993	87993	255879
9086	7908	17	applied	\N	\N	\N	\N	87994	87994	255880
9086	7912	18	applied	\N	\N	\N	\N	87995	87995	255881
9086	7913	19	applied	\N	\N	\N	\N	87996	87996	255882
9086	7914	20	applied	\N	\N	\N	\N	87997	87997	255883
9086	7916	21	applied	\N	\N	\N	\N	87998	87998	255884
9086	7917	22	applied	\N	\N	\N	\N	87999	87999	255885
9086	7918	23	applied	\N	\N	\N	\N	88000	88000	255886
9086	7919	24	applied	\N	\N	\N	\N	88001	88001	255887
9086	7928	25	applied	\N	\N	\N	\N	88002	88002	255888
9086	7931	27	applied	\N	\N	\N	\N	88004	88004	255890
9086	7934	28	applied	\N	\N	\N	\N	88005	88005	255891
9086	7936	29	applied	\N	\N	\N	\N	88006	88006	255892
9086	7939	30	applied	\N	\N	\N	\N	88007	88007	255893
9086	7940	31	applied	\N	\N	\N	\N	88008	88008	255894
9086	7941	32	applied	\N	\N	\N	\N	88009	88009	255895
9086	7946	33	applied	\N	\N	\N	\N	88010	88010	255896
9086	7947	34	applied	\N	\N	\N	\N	88011	88011	255897
9089	7999	0	applied	\N	\N	\N	\N	88018	88018	255904
9089	8000	1	applied	\N	\N	\N	\N	88019	88019	255905
9089	8001	2	applied	\N	\N	\N	\N	88020	88020	255906
9089	8002	3	applied	\N	\N	\N	\N	88021	88021	255907
9089	8003	4	applied	\N	\N	\N	\N	88022	88022	255908
9089	8004	5	applied	\N	\N	\N	\N	88023	88023	255909
9089	8005	6	applied	\N	\N	\N	\N	88024	88024	255910
9089	8006	7	applied	\N	\N	\N	\N	88025	88025	255911
9089	8008	9	applied	\N	\N	\N	\N	88027	88027	255913
9089	8009	10	applied	\N	\N	\N	\N	88028	88028	255914
9092	7999	0	applied	\N	\N	\N	\N	88051	88051	255937
9092	8000	1	applied	\N	\N	\N	\N	88052	88052	255938
9092	8001	2	applied	\N	\N	\N	\N	88053	88053	255939
9092	8002	3	applied	\N	\N	\N	\N	88054	88054	255940
9092	8003	4	applied	\N	\N	\N	\N	88055	88055	255941
9092	8004	5	applied	\N	\N	\N	\N	88056	88056	255942
9092	8005	6	applied	\N	\N	\N	\N	88057	88057	255943
9092	8006	7	applied	\N	\N	\N	\N	88058	88058	255944
9092	8007	8	applied	\N	\N	1000000000	\N	88059	88059	255945
9092	8008	9	applied	\N	\N	\N	\N	88060	88060	255946
9092	8009	10	applied	\N	\N	\N	\N	88061	88061	255947
9095	7999	0	applied	\N	\N	\N	\N	88064	88064	255950
9098	8010	0	applied	\N	\N	\N	\N	88069	88069	255955
9098	8011	1	applied	\N	\N	\N	\N	88070	88070	255956
9102	8017	0	applied	\N	\N	\N	\N	88078	88078	255964
9102	8018	1	applied	\N	\N	\N	\N	88079	88079	255965
9127	8045	0	applied	\N	\N	\N	\N	88142	88142	256028
9127	8046	1	applied	\N	\N	\N	\N	88143	88143	256029
9006	7851	0	applied	\N	\N	\N	\N	87716	87716	255603
9006	7852	1	applied	\N	\N	\N	\N	87717	87717	255604
9028	7886	0	applied	\N	\N	\N	\N	87772	87772	255659
9028	7887	1	applied	\N	\N	\N	\N	87773	87773	255660
9033	7890	0	applied	\N	\N	\N	\N	87784	87784	255671
9033	7891	1	applied	\N	\N	\N	\N	87785	87785	255672
9033	7892	2	applied	\N	\N	\N	\N	87786	87786	255673
9035	7898	1	applied	\N	\N	\N	\N	87792	87792	255679
9037	7899	0	applied	\N	\N	\N	\N	87795	87795	255682
9037	7900	2	applied	\N	\N	\N	\N	87796	87796	255683
9042	7905	0	applied	\N	\N	\N	\N	87805	87805	255692
9042	7906	1	applied	\N	\N	\N	\N	87806	87806	255693
9042	7907	2	applied	\N	\N	\N	\N	87807	87807	255694
9042	7908	3	applied	\N	\N	\N	\N	87808	87808	255695
9042	7909	4	applied	\N	\N	1000000000	\N	87809	87809	255696
9047	7910	0	applied	\N	\N	\N	\N	87822	87822	255708
9047	7911	1	applied	\N	\N	\N	\N	87823	87823	255709
9047	7912	2	applied	\N	\N	\N	\N	87824	87824	255710
9047	7913	3	applied	\N	\N	\N	\N	87825	87825	255711
9048	7914	0	applied	\N	\N	\N	\N	87826	87826	255712
9048	7915	1	applied	\N	\N	\N	\N	87827	87827	255713
9048	7916	2	applied	\N	\N	\N	\N	87828	87828	255714
9048	7917	3	applied	\N	\N	\N	\N	87829	87829	255715
9048	7919	5	applied	\N	\N	\N	\N	87831	87831	255717
9048	7920	6	applied	\N	\N	\N	\N	87832	87832	255718
9048	7921	7	applied	\N	\N	\N	\N	87833	87833	255719
9048	7922	8	applied	\N	\N	\N	\N	87834	87834	255720
9048	7923	9	applied	\N	\N	1000000000	\N	87835	87835	255721
9048	7924	10	applied	\N	\N	\N	\N	87836	87836	255722
9048	7925	11	applied	\N	\N	\N	\N	87837	87837	255723
9048	7926	12	applied	\N	\N	\N	\N	87838	87838	255724
9050	7914	0	applied	\N	\N	\N	\N	87852	87852	255738
9050	7915	1	applied	\N	\N	\N	\N	87853	87853	255739
9050	7916	2	applied	\N	\N	\N	\N	87854	87854	255740
9050	7917	3	applied	\N	\N	\N	\N	87855	87855	255741
9050	7918	4	applied	\N	\N	\N	\N	87856	87856	255742
9050	7919	5	applied	\N	\N	\N	\N	87857	87857	255743
9050	7920	6	applied	\N	\N	\N	\N	87858	87858	255744
9050	7921	7	applied	\N	\N	\N	\N	87859	87859	255745
9050	7923	9	applied	\N	\N	1000000000	\N	87861	87861	255747
9050	7924	10	applied	\N	\N	\N	\N	87862	87862	255748
9050	7925	11	applied	\N	\N	\N	\N	87863	87863	255749
9050	7926	12	applied	\N	\N	\N	\N	87864	87864	255750
9052	7927	0	applied	\N	\N	\N	\N	87867	87867	255753
9052	7928	1	applied	\N	\N	\N	\N	87868	87868	255754
9054	7929	0	applied	\N	\N	\N	\N	87871	87871	255757
9054	7930	1	applied	\N	\N	\N	\N	87872	87872	255758
9058	7936	0	applied	\N	\N	\N	\N	87888	87888	255774
9058	7937	1	applied	\N	\N	\N	\N	87889	87889	255775
9061	7940	0	applied	\N	\N	\N	\N	87894	87894	255780
9061	7941	1	applied	\N	\N	\N	\N	87895	87895	255781
9061	7942	2	applied	\N	\N	\N	\N	87896	87896	255782
9061	7943	3	applied	\N	\N	\N	\N	87897	87897	255783
9063	7945	1	applied	\N	\N	\N	\N	87903	87903	255789
9063	7946	2	applied	\N	\N	\N	\N	87904	87904	255790
9068	7954	0	applied	\N	\N	\N	\N	87915	87915	255801
9068	7955	1	applied	\N	\N	\N	\N	87916	87916	255802
9072	7969	0	applied	\N	\N	\N	\N	87932	87932	255818
9072	7970	1	applied	\N	\N	\N	\N	87933	87933	255819
9072	7971	2	applied	\N	\N	\N	\N	87934	87934	255820
9072	7972	3	applied	\N	\N	\N	\N	87935	87935	255821
9072	7973	4	applied	\N	\N	\N	\N	87936	87936	255822
9075	7978	0	applied	\N	\N	\N	\N	87941	87941	255827
9075	7979	1	applied	\N	\N	\N	\N	87942	87942	255828
9080	7989	0	applied	\N	\N	\N	\N	87960	87960	255846
9080	7990	1	applied	\N	\N	1000000000	\N	87961	87961	255847
9080	7988	2	applied	\N	\N	\N	\N	87962	87962	255848
9080	7991	3	applied	\N	\N	\N	\N	87963	87963	255849
9084	7992	0	applied	\N	\N	\N	\N	87973	87973	255859
9084	7993	1	applied	\N	\N	1000000000	\N	87974	87974	255860
9100	8015	0	applied	\N	\N	\N	\N	88074	88074	255960
9100	8016	1	applied	\N	\N	\N	\N	88075	88075	255961
9103	8017	0	applied	\N	\N	\N	\N	88080	88080	255966
9107	8021	0	applied	\N	\N	\N	\N	88088	88088	255974
9107	8022	1	applied	\N	\N	\N	\N	88089	88089	255975
9109	8023	0	applied	\N	\N	\N	\N	88092	88092	255978
9112	8027	0	applied	\N	\N	\N	\N	88098	88098	255984
9112	8028	1	applied	\N	\N	\N	\N	88099	88099	255985
9112	8029	2	applied	\N	\N	\N	\N	88100	88100	255986
9112	8030	3	applied	\N	\N	\N	\N	88101	88101	255987
9118	8035	0	applied	\N	\N	\N	\N	88118	88118	256004
9118	8036	1	applied	\N	\N	\N	\N	88119	88119	256005
9118	8037	2	applied	\N	\N	\N	\N	88120	88120	256006
9118	8038	3	applied	\N	\N	\N	\N	88121	88121	256007
9121	8039	0	applied	\N	\N	\N	\N	88126	88126	256012
9121	8040	1	applied	\N	\N	\N	\N	88127	88127	256013
9126	8045	0	applied	\N	\N	\N	\N	88140	88140	256026
9126	8046	1	applied	\N	\N	\N	\N	88141	88141	256027
9136	8057	0	applied	\N	\N	\N	\N	88177	88177	256062
9138	8061	0	applied	\N	\N	\N	\N	88181	88181	256066
9138	8062	1	applied	\N	\N	\N	\N	88182	88182	256067
9140	8063	0	applied	\N	\N	\N	\N	88185	88185	256070
9140	8064	1	applied	\N	\N	\N	\N	88186	88186	256071
9147	8079	0	applied	\N	\N	\N	\N	88214	88214	256099
9147	8080	1	applied	\N	\N	\N	\N	88215	88215	256100
9147	8081	2	applied	\N	\N	\N	\N	88216	88216	256101
9147	8082	3	applied	\N	\N	\N	\N	88217	88217	256102
9151	8087	0	applied	\N	\N	\N	\N	88230	88230	256115
9151	8088	1	applied	\N	\N	\N	\N	88231	88231	256116
9153	8089	0	applied	\N	\N	\N	\N	88234	88234	256119
9153	8090	1	applied	\N	\N	\N	\N	88235	88235	256120
9158	8095	0	applied	\N	\N	\N	\N	88244	88244	256129
9158	8096	1	applied	\N	\N	\N	\N	88245	88245	256130
9161	8099	0	applied	\N	\N	\N	\N	88250	88250	256135
9161	8100	1	applied	\N	\N	\N	\N	88251	88251	256136
9161	8102	3	applied	\N	\N	\N	\N	88253	88253	256138
9161	8103	4	applied	\N	\N	\N	\N	88254	88254	256139
9161	8104	5	applied	\N	\N	\N	\N	88255	88255	256140
9161	8105	6	applied	\N	\N	\N	\N	88256	88256	256141
9161	8106	7	applied	\N	\N	\N	\N	88257	88257	256142
9164	8111	0	applied	\N	\N	\N	\N	88266	88266	256151
9026	7884	0	applied	\N	\N	\N	\N	87768	87768	255655
9026	7885	1	applied	\N	\N	\N	\N	87769	87769	255656
9091	8005	6	applied	\N	\N	\N	\N	88046	88046	255932
9091	8006	7	applied	\N	\N	\N	\N	88047	88047	255933
9091	8007	8	applied	\N	\N	1000000000	\N	88048	88048	255934
9091	8008	9	applied	\N	\N	\N	\N	88049	88049	255935
9091	8009	10	applied	\N	\N	\N	\N	88050	88050	255936
9094	7999	0	applied	\N	\N	\N	\N	88063	88063	255949
9097	8010	0	applied	\N	\N	\N	\N	88067	88067	255953
9097	8011	1	applied	\N	\N	\N	\N	88068	88068	255954
9099	8012	0	applied	\N	\N	\N	\N	88071	88071	255957
9099	8014	2	applied	\N	\N	\N	\N	88073	88073	255959
9106	8021	0	applied	\N	\N	\N	\N	88086	88086	255972
9106	8022	1	applied	\N	\N	\N	\N	88087	88087	255973
9108	8023	0	applied	\N	\N	\N	\N	88090	88090	255976
9108	8024	1	applied	\N	\N	\N	\N	88091	88091	255977
9125	8041	0	applied	\N	\N	\N	\N	88136	88136	256022
9125	8042	1	applied	\N	\N	\N	\N	88137	88137	256023
9125	8043	2	applied	\N	\N	\N	\N	88138	88138	256024
9125	8044	3	applied	\N	\N	\N	\N	88139	88139	256025
9132	8053	0	applied	\N	\N	\N	\N	88169	88169	256054
9132	8054	1	applied	\N	\N	\N	\N	88170	88170	256055
9139	8061	0	applied	\N	\N	\N	\N	88183	88183	256068
9139	8062	1	applied	\N	\N	\N	\N	88184	88184	256069
9142	8067	0	applied	\N	\N	1000000000	\N	88189	88189	256074
9142	8068	1	applied	\N	\N	\N	\N	88190	88190	256075
9142	8069	2	applied	\N	\N	\N	\N	88191	88191	256076
9142	8071	4	applied	\N	\N	\N	\N	88193	88193	256078
9145	8079	0	applied	\N	\N	\N	\N	88206	88206	256091
9145	8080	1	applied	\N	\N	\N	\N	88207	88207	256092
9145	8081	2	applied	\N	\N	\N	\N	88208	88208	256093
9145	8082	3	applied	\N	\N	\N	\N	88209	88209	256094
9148	8079	0	applied	\N	\N	\N	\N	88218	88218	256103
9148	8080	1	applied	\N	\N	\N	\N	88219	88219	256104
9148	8081	2	applied	\N	\N	\N	\N	88220	88220	256105
9148	8082	3	applied	\N	\N	\N	\N	88221	88221	256106
9150	8083	0	applied	\N	\N	\N	\N	88226	88226	256111
9150	8084	1	applied	\N	\N	\N	\N	88227	88227	256112
9150	8085	2	applied	\N	\N	\N	\N	88228	88228	256113
9150	8086	3	applied	\N	\N	\N	\N	88229	88229	256114
9157	8095	0	applied	\N	\N	\N	\N	88242	88242	256127
9157	8096	1	applied	\N	\N	\N	\N	88243	88243	256128
9159	8097	0	applied	\N	\N	\N	\N	88246	88246	256131
9164	8112	1	applied	\N	\N	\N	\N	88267	88267	256152
9165	8113	0	applied	\N	\N	\N	\N	88268	88268	256153
9165	8114	1	applied	\N	\N	\N	\N	88269	88269	256154
9169	8117	0	applied	\N	\N	\N	\N	88274	88274	256159
9169	8118	1	applied	\N	\N	\N	\N	88275	88275	256160
9175	8132	0	applied	\N	\N	\N	\N	88294	88294	256179
9175	8133	1	applied	\N	\N	\N	\N	88295	88295	256180
9178	8132	0	applied	\N	\N	\N	\N	88300	88300	256185
9178	8133	1	applied	\N	\N	\N	\N	88301	88301	256186
9182	8140	0	applied	\N	\N	\N	\N	88320	88320	256205
9182	8141	1	applied	\N	\N	\N	\N	88321	88321	256206
9185	8149	0	applied	\N	\N	\N	\N	88329	88329	256214
9185	8150	1	applied	\N	\N	\N	\N	88330	88330	256215
9190	8155	0	applied	\N	\N	\N	\N	88347	88347	256232
9190	8156	1	applied	\N	\N	\N	\N	88348	88348	256233
9190	8157	2	applied	\N	\N	\N	\N	88349	88349	256234
9195	8168	0	applied	\N	\N	\N	\N	88367	88367	256252
9195	8169	1	applied	\N	\N	\N	\N	88368	88368	256253
9195	8170	2	applied	\N	\N	\N	\N	88369	88369	256254
9195	8171	3	applied	\N	\N	\N	\N	88370	88370	256255
9195	8172	4	applied	\N	\N	\N	\N	88371	88371	88371
9197	7969	0	applied	\N	\N	\N	\N	88377	88377	256260
9197	7956	1	applied	\N	\N	\N	\N	88378	88378	256261
9197	7999	2	applied	\N	\N	\N	\N	88379	88379	256262
9197	7980	3	applied	\N	\N	\N	\N	88380	88380	256263
9197	7949	4	applied	\N	\N	1000000000	\N	88381	88381	256264
9197	7742	5	applied	\N	\N	\N	\N	88382	88382	256265
9197	8159	6	applied	\N	\N	\N	\N	88383	88383	256266
9197	7745	7	applied	\N	\N	\N	\N	88384	88384	256267
9197	7891	8	applied	\N	\N	\N	\N	88385	88385	256268
9197	7746	9	applied	\N	\N	\N	\N	88386	88386	256269
9197	7915	10	applied	\N	\N	\N	\N	88387	88387	256270
9197	7749	12	applied	\N	\N	\N	\N	88389	88389	256272
9197	7754	13	applied	\N	\N	\N	\N	88390	88390	256273
9197	8163	14	applied	\N	\N	\N	\N	88391	88391	256274
9197	7990	15	applied	\N	\N	1000000000	\N	88392	88392	256275
9197	8164	16	applied	\N	\N	\N	\N	88393	88393	256276
9197	8165	17	applied	\N	\N	\N	\N	88394	88394	256277
9197	8166	18	applied	\N	\N	\N	\N	88395	88395	256278
9197	8168	19	applied	\N	\N	\N	\N	88396	88396	256279
9197	8170	20	applied	\N	\N	\N	\N	88397	88397	256280
9197	7983	21	applied	\N	\N	\N	\N	88398	88398	256281
9197	7984	22	applied	\N	\N	\N	\N	88399	88399	256282
9197	7758	23	applied	\N	\N	\N	\N	88400	88400	256283
9197	7759	24	applied	\N	\N	\N	\N	88401	88401	256284
9197	7762	25	applied	\N	\N	\N	\N	88402	88402	256285
9197	7764	26	applied	\N	\N	\N	\N	88403	88403	256286
9197	7768	27	applied	\N	\N	\N	\N	88404	88404	256287
9197	7771	29	applied	\N	\N	\N	\N	88406	88406	256289
9197	7772	30	applied	\N	\N	\N	\N	88407	88407	256290
9197	7777	31	applied	\N	\N	\N	\N	88408	88408	256291
9197	7778	32	applied	\N	\N	\N	\N	88409	88409	256292
9197	7780	33	applied	\N	\N	\N	\N	88410	88410	256293
9197	7781	34	applied	\N	\N	\N	\N	88411	88411	256294
9197	7784	35	applied	\N	\N	\N	\N	88412	88412	256295
9197	7787	36	applied	\N	\N	\N	\N	88413	88413	256296
9197	7789	37	applied	\N	\N	\N	\N	88414	88414	256297
9197	7790	38	applied	\N	\N	\N	\N	88415	88415	256298
9197	7792	39	applied	\N	\N	\N	\N	88416	88416	256299
9197	7794	40	applied	\N	\N	\N	\N	88417	88417	256300
9197	7797	41	applied	\N	\N	\N	\N	88418	88418	256301
9197	7798	42	applied	\N	\N	\N	\N	88419	88419	256302
9197	7799	43	applied	\N	\N	\N	\N	88420	88420	256303
9197	7803	44	applied	\N	\N	\N	\N	88421	88421	256304
9197	7806	46	applied	\N	\N	\N	\N	88423	88423	256306
9197	7807	47	applied	\N	\N	\N	\N	88424	88424	256307
9197	7811	48	applied	\N	\N	\N	\N	88425	88425	256308
9197	7814	49	applied	\N	\N	\N	\N	88426	88426	256309
9091	8003	4	applied	\N	\N	\N	\N	88044	88044	255930
9091	8004	5	applied	\N	\N	\N	\N	88045	88045	255931
9114	8031	0	applied	\N	\N	\N	\N	88106	88106	255992
9114	8032	1	applied	\N	\N	\N	\N	88107	88107	255993
9114	8033	2	applied	\N	\N	\N	\N	88108	88108	255994
9117	8035	0	applied	\N	\N	\N	\N	88114	88114	256000
9117	8036	1	applied	\N	\N	\N	\N	88115	88115	256001
9117	8037	2	applied	\N	\N	\N	\N	88116	88116	256002
9117	8038	3	applied	\N	\N	\N	\N	88117	88117	256003
9123	8039	0	applied	\N	\N	\N	\N	88130	88130	256016
9123	8040	1	applied	\N	\N	\N	\N	88131	88131	256017
9128	7969	0	applied	\N	\N	\N	\N	88144	88144	256030
9128	7956	1	applied	\N	\N	\N	\N	88145	88145	256031
9128	7999	2	applied	\N	\N	\N	\N	88146	88146	256032
9128	7980	3	applied	\N	\N	\N	\N	88147	88147	256033
9128	7949	4	applied	\N	\N	1000000000	\N	88148	88148	256034
9128	7891	5	applied	\N	\N	\N	\N	88149	88149	256035
9128	7915	6	applied	\N	\N	\N	\N	88150	88150	256036
9128	7990	7	applied	\N	\N	1000000000	\N	88151	88151	256037
9128	7983	8	applied	\N	\N	\N	\N	88152	88152	256038
9128	7984	9	applied	\N	\N	\N	\N	88153	88153	256039
9128	7875	11	applied	\N	\N	\N	\N	88155	88155	256041
9128	7827	12	applied	\N	\N	\N	\N	88156	88156	88156
9128	7935	13	applied	\N	\N	\N	\N	88157	88157	256042
9128	7993	14	applied	\N	\N	1000000000	\N	88158	88158	256043
9128	8009	15	applied	\N	\N	\N	\N	88159	88159	256044
9128	7909	16	applied	\N	\N	1000000000	\N	88160	88160	256045
9128	7926	17	applied	\N	\N	\N	\N	88161	88161	256046
9130	8051	0	applied	\N	\N	\N	\N	88166	88166	256051
9133	8053	0	applied	\N	\N	\N	\N	88171	88171	256056
9133	8054	1	applied	\N	\N	\N	\N	88172	88172	256057
9135	8057	0	applied	\N	\N	\N	\N	88175	88175	256060
9135	8058	1	applied	\N	\N	\N	\N	88176	88176	256061
9137	8059	0	applied	\N	\N	\N	\N	88179	88179	256064
9137	8060	2	applied	\N	\N	\N	\N	88180	88180	256065
9143	8067	0	applied	\N	\N	1000000000	\N	88194	88194	256079
9143	8068	1	applied	\N	\N	\N	\N	88195	88195	256080
9143	8069	2	applied	\N	\N	\N	\N	88196	88196	256081
9143	8070	3	applied	\N	\N	\N	\N	88197	88197	256082
9146	8079	0	applied	\N	\N	\N	\N	88210	88210	256095
9146	8080	1	applied	\N	\N	\N	\N	88211	88211	256096
9146	8081	2	applied	\N	\N	\N	\N	88212	88212	256097
9146	8082	3	applied	\N	\N	\N	\N	88213	88213	256098
9155	8091	0	applied	\N	\N	\N	\N	88238	88238	256123
9155	8092	1	applied	\N	\N	\N	\N	88239	88239	256124
9160	8097	0	applied	\N	\N	\N	\N	88248	88248	256133
9160	8098	1	applied	\N	\N	\N	\N	88249	88249	256134
9163	8107	0	applied	\N	\N	\N	\N	88262	88262	256147
9163	8108	1	applied	\N	\N	\N	\N	88263	88263	256148
9163	8109	2	applied	\N	\N	\N	\N	88264	88264	256149
9163	8110	3	applied	\N	\N	\N	\N	88265	88265	256150
9166	8115	0	applied	\N	\N	\N	\N	88270	88270	256155
9166	8116	1	applied	\N	\N	\N	\N	88271	88271	256156
9170	8117	0	applied	\N	\N	\N	\N	88276	88276	256161
9170	8118	1	applied	\N	\N	\N	\N	88277	88277	256162
9176	8133	1	applied	\N	\N	\N	\N	88297	88297	256182
9180	8134	0	applied	\N	\N	\N	\N	88308	88308	256193
9180	8135	1	applied	\N	\N	\N	\N	88309	88309	256194
9180	8136	2	applied	\N	\N	\N	\N	88310	88310	256195
9180	8137	3	applied	\N	\N	\N	\N	88311	88311	256196
9180	8138	5	applied	\N	\N	\N	\N	88312	88312	256197
9180	8139	6	applied	\N	\N	\N	\N	88313	88313	256198
9186	8151	0	applied	\N	\N	\N	\N	88331	88331	256216
9186	8152	1	applied	\N	\N	\N	\N	88332	88332	256217
9186	8153	2	applied	\N	\N	\N	\N	88333	88333	256218
9186	8154	3	applied	\N	\N	\N	\N	88334	88334	256219
9188	8151	0	applied	\N	\N	\N	\N	88339	88339	256224
9188	8152	1	applied	\N	\N	\N	\N	88340	88340	256225
9188	8153	2	applied	\N	\N	\N	\N	88341	88341	256226
9188	8154	3	applied	\N	\N	\N	\N	88342	88342	256227
9191	8155	0	applied	\N	\N	\N	\N	88351	88351	256236
9191	8157	2	applied	\N	\N	\N	\N	88353	88353	256238
9191	8158	3	applied	\N	\N	\N	\N	88354	88354	256239
9193	8159	0	applied	\N	\N	\N	\N	88358	88358	256243
9193	8160	1	applied	\N	\N	\N	\N	88359	88359	256244
9193	8161	2	applied	\N	\N	\N	\N	88360	88360	256245
9197	7816	50	applied	\N	\N	\N	\N	88427	88427	256310
9197	7818	51	applied	\N	\N	\N	\N	88428	88428	256311
9197	7820	52	applied	\N	\N	\N	\N	88429	88429	256312
9200	8177	0	applied	\N	\N	\N	\N	88505	88505	256388
9200	8178	1	applied	\N	\N	\N	\N	88506	88506	256389
9206	8185	0	applied	\N	\N	\N	\N	88523	88523	256406
9206	8186	1	applied	\N	\N	\N	\N	88524	88524	256407
9206	8187	2	applied	\N	\N	\N	\N	88525	88525	256408
9206	8188	3	applied	\N	\N	\N	\N	88526	88526	256409
9206	8189	4	applied	\N	\N	\N	\N	88527	88527	256410
9206	8190	5	applied	\N	\N	\N	\N	88528	88528	256411
9206	8192	7	applied	\N	\N	\N	\N	88530	88530	256413
9212	8204	0	applied	\N	\N	\N	\N	88546	88546	256429
9212	8205	1	applied	\N	\N	\N	\N	88547	88547	256430
9212	8206	2	applied	\N	\N	\N	\N	88548	88548	256431
9212	8207	3	applied	\N	\N	\N	\N	88549	88549	256432
9214	8204	0	applied	\N	\N	\N	\N	88554	88554	256437
9214	8205	1	applied	\N	\N	\N	\N	88555	88555	256438
9214	8206	2	applied	\N	\N	\N	\N	88556	88556	256439
9214	8207	3	applied	\N	\N	\N	\N	88557	88557	256440
9217	8208	0	applied	\N	\N	\N	\N	88570	88570	256453
9217	8209	1	applied	\N	\N	\N	\N	88571	88571	256454
9217	8210	2	applied	\N	\N	\N	\N	88572	88572	256455
9217	8211	3	applied	\N	\N	\N	\N	88573	88573	256456
9217	8212	4	applied	\N	\N	\N	\N	88574	88574	256457
9217	8213	5	applied	\N	\N	\N	\N	88575	88575	256458
9223	8220	0	applied	\N	\N	\N	\N	88590	88590	256473
9230	8222	0	applied	\N	\N	1000000000	\N	88606	88606	256489
9230	8223	1	applied	\N	\N	\N	\N	88607	88607	256490
9230	8224	2	applied	\N	\N	\N	\N	88608	88608	256491
9232	8226	0	applied	\N	\N	\N	\N	88610	88610	256493
9232	8227	1	applied	\N	\N	\N	\N	88611	88611	256494
9237	8234	0	applied	\N	\N	\N	\N	88620	88620	256503
9237	8235	1	applied	\N	\N	\N	\N	88621	88621	256504
9237	8236	2	applied	\N	\N	\N	\N	88622	88622	256505
9111	8025	0	applied	\N	\N	\N	\N	88096	88096	255982
9111	8026	1	applied	\N	\N	\N	\N	88097	88097	255983
9129	8050	3	applied	\N	\N	\N	\N	88165	88165	256050
9131	8051	0	applied	\N	\N	\N	\N	88167	88167	256052
9131	8052	1	applied	\N	\N	\N	\N	88168	88168	256053
9134	8055	0	applied	\N	\N	\N	\N	88173	88173	256058
9134	8056	1	applied	\N	\N	\N	\N	88174	88174	256059
9141	8065	0	applied	\N	\N	\N	\N	88187	88187	256072
9141	8066	1	applied	\N	\N	\N	\N	88188	88188	256073
9144	8072	0	applied	\N	\N	\N	\N	88199	88199	256084
9144	8073	1	applied	\N	\N	\N	\N	88200	88200	256085
9144	8074	2	applied	\N	\N	\N	\N	88201	88201	256086
9144	8075	3	applied	\N	\N	\N	\N	88202	88202	256087
9144	8077	5	applied	\N	\N	1000000000	\N	88204	88204	256089
9144	8078	6	applied	\N	\N	\N	\N	88205	88205	256090
9149	8083	0	applied	\N	\N	\N	\N	88222	88222	256107
9149	8084	1	applied	\N	\N	\N	\N	88223	88223	256108
9149	8085	2	applied	\N	\N	\N	\N	88224	88224	256109
9149	8086	3	applied	\N	\N	\N	\N	88225	88225	256110
9152	8087	0	applied	\N	\N	\N	\N	88232	88232	256117
9152	8088	1	applied	\N	\N	\N	\N	88233	88233	256118
9154	8091	0	applied	\N	\N	\N	\N	88236	88236	256121
9154	8092	1	applied	\N	\N	\N	\N	88237	88237	256122
9156	8093	0	applied	\N	\N	\N	\N	88240	88240	256125
9156	8094	1	applied	\N	\N	\N	\N	88241	88241	256126
9162	8107	0	applied	\N	\N	\N	\N	88258	88258	256143
9162	8108	1	applied	\N	\N	\N	\N	88259	88259	256144
9162	8109	2	applied	\N	\N	\N	\N	88260	88260	256145
9162	8110	3	applied	\N	\N	\N	\N	88261	88261	256146
9167	8116	1	applied	\N	\N	\N	\N	88273	88273	256158
9171	8119	0	applied	\N	\N	\N	\N	88278	88278	256163
9171	8120	1	applied	\N	\N	\N	\N	88279	88279	256164
9171	8121	2	applied	\N	\N	\N	\N	88280	88280	256165
9172	8119	0	applied	\N	\N	\N	\N	88281	88281	256166
9172	8120	1	applied	\N	\N	\N	\N	88282	88282	256167
9172	8121	2	applied	\N	\N	\N	\N	88283	88283	256168
9173	8122	0	applied	\N	\N	\N	\N	88284	88284	256169
9173	8123	1	applied	\N	\N	\N	\N	88285	88285	256170
9173	8124	2	applied	\N	\N	\N	\N	88286	88286	256171
9173	8125	3	applied	\N	\N	\N	\N	88287	88287	256172
9174	8126	0	applied	\N	\N	\N	\N	88288	88288	256173
9174	8127	1	applied	\N	\N	\N	\N	88289	88289	256174
9174	8128	2	applied	\N	\N	\N	\N	88290	88290	256175
9174	8129	3	applied	\N	\N	\N	\N	88291	88291	256176
9174	8130	4	applied	\N	\N	\N	\N	88292	88292	256177
9177	8132	0	applied	\N	\N	\N	\N	88298	88298	256183
9177	8133	1	applied	\N	\N	\N	\N	88299	88299	256184
9179	8134	0	applied	\N	\N	\N	\N	88302	88302	256187
9179	8135	1	applied	\N	\N	\N	\N	88303	88303	256188
9179	8136	2	applied	\N	\N	\N	\N	88304	88304	256189
9179	8137	3	applied	\N	\N	\N	\N	88305	88305	256190
9179	8138	5	applied	\N	\N	\N	\N	88306	88306	256191
9179	8139	6	applied	\N	\N	\N	\N	88307	88307	256192
9181	8134	0	applied	\N	\N	\N	\N	88314	88314	256199
9181	8135	1	applied	\N	\N	\N	\N	88315	88315	256200
9194	8162	0	applied	\N	\N	\N	\N	88361	88361	256246
9194	8163	1	applied	\N	\N	\N	\N	88362	88362	256247
9194	8164	2	applied	\N	\N	\N	\N	88363	88363	256248
9194	8165	3	applied	\N	\N	\N	\N	88364	88364	256249
9194	8166	4	applied	\N	\N	\N	\N	88365	88365	256250
9194	8167	5	applied	\N	\N	\N	\N	88366	88366	256251
9199	8176	1	applied	\N	\N	\N	\N	88504	88504	256387
9204	8183	0	applied	\N	\N	\N	\N	88513	88513	256396
9204	8184	1	applied	\N	\N	\N	\N	88514	88514	256397
9205	8185	0	applied	\N	\N	\N	\N	88515	88515	256398
9205	8186	1	applied	\N	\N	\N	\N	88516	88516	256399
9205	8187	2	applied	\N	\N	\N	\N	88517	88517	256400
9205	8188	3	applied	\N	\N	\N	\N	88518	88518	256401
9205	8189	4	applied	\N	\N	\N	\N	88519	88519	256402
9205	8190	5	applied	\N	\N	\N	\N	88520	88520	256403
9205	8191	6	applied	\N	\N	\N	\N	88521	88521	256404
9205	8192	7	applied	\N	\N	\N	\N	88522	88522	256405
9207	8193	0	applied	\N	\N	\N	\N	88531	88531	256414
9207	8194	1	applied	\N	\N	\N	\N	88532	88532	256415
9207	8195	2	applied	\N	\N	\N	\N	88533	88533	256416
9207	8196	3	applied	\N	\N	\N	\N	88534	88534	256417
9210	8201	0	applied	\N	\N	\N	\N	88539	88539	256422
9210	8203	2	applied	\N	\N	1000000000	\N	88541	88541	256424
9213	8204	0	applied	\N	\N	\N	\N	88550	88550	256433
9213	8205	1	applied	\N	\N	\N	\N	88551	88551	256434
9213	8206	2	applied	\N	\N	\N	\N	88552	88552	256435
9213	8207	3	applied	\N	\N	\N	\N	88553	88553	256436
9215	8208	0	applied	\N	\N	\N	\N	88558	88558	256441
9215	8209	1	applied	\N	\N	\N	\N	88559	88559	256442
9215	8210	2	applied	\N	\N	\N	\N	88560	88560	256443
9215	8211	3	applied	\N	\N	\N	\N	88561	88561	256444
9215	8212	4	applied	\N	\N	\N	\N	88562	88562	256445
9215	8213	5	applied	\N	\N	\N	\N	88563	88563	256446
9220	8218	0	applied	\N	\N	\N	\N	88584	88584	256467
9220	8219	1	applied	\N	\N	\N	\N	88585	88585	256468
9224	8220	0	applied	\N	\N	\N	\N	88592	88592	256475
9224	8221	1	applied	\N	\N	\N	\N	88593	88593	256476
9231	8225	0	applied	\N	\N	\N	\N	88609	88609	256492
9233	8228	0	applied	\N	\N	\N	\N	88612	88612	256495
9233	8229	1	applied	\N	\N	\N	\N	88613	88613	256496
9236	8232	0	applied	\N	\N	\N	\N	88618	88618	256501
9236	8233	1	applied	\N	\N	\N	\N	88619	88619	256502
9237	8237	3	applied	\N	\N	\N	\N	88623	88623	256506
9240	8242	0	applied	\N	\N	\N	\N	88628	88628	256511
9240	8243	1	applied	\N	\N	\N	\N	88629	88629	256512
9241	8244	0	applied	\N	\N	\N	\N	88630	88630	256513
9241	8245	1	applied	\N	\N	\N	\N	88631	88631	256514
9246	8249	0	applied	\N	\N	\N	\N	88644	88644	256527
9246	8250	1	applied	\N	\N	\N	\N	88645	88645	256528
9246	8251	2	applied	\N	\N	\N	\N	88646	88646	256529
9246	8252	3	applied	\N	\N	\N	\N	88647	88647	256530
9246	8253	4	applied	\N	\N	\N	\N	88648	88648	256531
9246	8254	5	applied	\N	\N	\N	\N	88649	88649	256532
9246	8255	6	applied	\N	\N	\N	\N	88650	88650	256533
9246	8256	7	applied	\N	\N	\N	\N	88651	88651	256534
9246	8257	8	applied	\N	\N	\N	\N	88652	88652	256535
9129	8048	1	applied	\N	\N	\N	\N	88163	88163	256048
9129	8049	2	applied	\N	\N	\N	\N	88164	88164	256049
9183	8142	0	applied	\N	\N	\N	\N	88322	88322	256207
9183	8143	1	applied	\N	\N	\N	\N	88323	88323	256208
9184	8144	0	applied	\N	\N	\N	\N	88324	88324	256209
9184	8145	1	applied	\N	\N	\N	\N	88325	88325	256210
9184	8146	2	applied	\N	\N	\N	\N	88326	88326	256211
9184	8147	3	applied	\N	\N	\N	\N	88327	88327	256212
9184	8148	4	applied	\N	\N	\N	\N	88328	88328	256213
9187	8151	0	applied	\N	\N	\N	\N	88335	88335	256220
9187	8152	1	applied	\N	\N	\N	\N	88336	88336	256221
9187	8153	2	applied	\N	\N	\N	\N	88337	88337	256222
9187	8154	3	applied	\N	\N	\N	\N	88338	88338	256223
9189	8155	0	applied	\N	\N	\N	\N	88343	88343	256228
9189	8156	1	applied	\N	\N	\N	\N	88344	88344	256229
9189	8157	2	applied	\N	\N	\N	\N	88345	88345	256230
9192	8121	0	applied	\N	\N	\N	\N	88355	88355	256240
9192	8124	1	applied	\N	\N	\N	\N	88356	88356	256241
9192	8125	2	applied	\N	\N	\N	\N	88357	88357	256242
9196	8168	0	applied	\N	\N	\N	\N	88372	88372	256256
9196	8169	1	applied	\N	\N	\N	\N	88373	88373	256257
9196	8170	2	applied	\N	\N	\N	\N	88374	88374	256258
9196	8171	3	applied	\N	\N	\N	\N	88375	88375	256259
9196	8172	4	applied	\N	\N	\N	\N	88376	88376	88376
9197	7821	53	applied	\N	\N	\N	\N	88430	88430	256313
9197	7823	54	applied	\N	\N	\N	\N	88431	88431	256314
9197	7826	55	applied	\N	\N	\N	\N	88432	88432	256315
9197	7829	56	applied	\N	\N	\N	\N	88433	88433	256316
9197	7831	57	applied	\N	\N	\N	\N	88434	88434	256317
9197	7832	58	applied	\N	\N	\N	\N	88435	88435	256318
9197	7835	59	applied	\N	\N	\N	\N	88436	88436	256319
9197	7837	60	applied	\N	\N	\N	\N	88437	88437	256320
9197	7842	62	applied	\N	\N	\N	\N	88439	88439	256322
9197	7845	63	applied	\N	\N	\N	\N	88440	88440	256323
9197	7846	64	applied	\N	\N	\N	\N	88441	88441	256324
9197	7847	65	applied	\N	\N	\N	\N	88442	88442	256325
9197	7850	66	applied	\N	\N	\N	\N	88443	88443	256326
9197	7851	68	applied	\N	\N	\N	\N	88444	88444	256327
9197	7855	69	applied	\N	\N	\N	\N	88445	88445	256328
9197	7856	70	applied	\N	\N	\N	\N	88446	88446	256329
9197	7857	71	applied	\N	\N	\N	\N	88447	88447	256330
9197	7861	72	applied	\N	\N	\N	\N	88448	88448	256331
9197	7862	73	applied	\N	\N	\N	\N	88449	88449	256332
9197	7863	74	applied	\N	\N	\N	\N	88450	88450	256333
9197	7865	75	applied	\N	\N	\N	\N	88451	88451	256334
9197	7869	76	applied	\N	\N	\N	\N	88452	88452	256335
9197	7870	77	applied	\N	\N	\N	\N	88453	88453	256336
9197	7871	78	applied	\N	\N	\N	\N	88454	88454	256337
9197	7877	80	applied	\N	\N	\N	\N	88456	88456	256339
9197	7878	81	applied	\N	\N	\N	\N	88457	88457	256340
9197	7880	82	applied	\N	\N	\N	\N	88458	88458	256341
9197	7881	83	applied	\N	\N	\N	\N	88459	88459	256342
9197	7884	84	applied	\N	\N	\N	\N	88460	88460	256343
9197	7887	85	applied	\N	\N	\N	\N	88461	88461	256344
9197	7889	86	applied	\N	\N	\N	\N	88462	88462	256345
9197	7890	87	applied	\N	\N	\N	\N	88463	88463	256346
9197	7893	88	applied	\N	\N	\N	\N	88464	88464	256347
9197	7894	89	applied	\N	\N	\N	\N	88465	88465	256348
9197	7897	90	applied	\N	\N	\N	\N	88466	88466	256349
9197	7900	91	applied	\N	\N	\N	\N	88467	88467	256350
9197	7901	92	applied	\N	\N	\N	\N	88468	88468	256351
9197	7903	93	applied	\N	\N	\N	\N	88469	88469	256352
9197	7907	94	applied	\N	\N	\N	\N	88470	88470	256353
9197	7908	95	applied	\N	\N	\N	\N	88471	88471	256354
9197	7913	97	applied	\N	\N	\N	\N	88473	88473	256356
9197	7914	98	applied	\N	\N	\N	\N	88474	88474	256357
9197	7916	99	applied	\N	\N	\N	\N	88475	88475	256358
9197	7917	100	applied	\N	\N	\N	\N	88476	88476	256359
9197	7918	101	applied	\N	\N	\N	\N	88477	88477	256360
9197	7919	102	applied	\N	\N	\N	\N	88478	88478	256361
9197	7928	103	applied	\N	\N	\N	\N	88479	88479	256362
9197	7930	104	applied	\N	\N	\N	\N	88480	88480	256363
9197	7931	105	applied	\N	\N	\N	\N	88481	88481	256364
9197	7934	106	applied	\N	\N	\N	\N	88482	88482	256365
9197	7936	107	applied	\N	\N	\N	\N	88483	88483	256366
9197	7939	108	applied	\N	\N	\N	\N	88484	88484	256367
9197	7940	109	applied	\N	\N	\N	\N	88485	88485	256368
9197	7941	110	applied	\N	\N	\N	\N	88486	88486	256369
9197	7946	111	applied	\N	\N	\N	\N	88487	88487	256370
9197	7947	112	applied	\N	\N	\N	\N	88488	88488	256371
9197	7951	114	applied	\N	\N	\N	\N	88490	88490	256373
9197	7954	115	applied	\N	\N	\N	\N	88491	88491	256374
9197	7959	116	applied	\N	\N	\N	\N	88492	88492	256375
9197	7963	117	applied	\N	\N	\N	\N	88493	88493	256376
9197	7964	118	applied	\N	\N	\N	\N	88494	88494	256377
9197	7965	119	applied	\N	\N	\N	\N	88495	88495	256378
9197	7966	120	applied	\N	\N	\N	\N	88496	88496	256379
9197	7968	121	applied	\N	\N	\N	\N	88497	88497	256380
9197	7972	122	applied	\N	\N	\N	\N	88498	88498	256381
9197	7973	123	applied	\N	\N	\N	\N	88499	88499	256382
9197	7974	124	applied	\N	\N	\N	\N	88500	88500	256383
9198	8173	0	applied	\N	\N	\N	\N	88501	88501	256384
9198	8174	1	applied	\N	\N	\N	\N	88502	88502	256385
9201	8177	0	applied	\N	\N	\N	\N	88507	88507	256390
9201	8178	1	applied	\N	\N	\N	\N	88508	88508	256391
9202	8179	0	applied	\N	\N	\N	\N	88509	88509	256392
9203	8182	1	applied	\N	\N	\N	\N	88512	88512	256395
9209	8199	0	applied	\N	\N	\N	\N	88537	88537	256420
9209	8200	1	applied	\N	\N	\N	\N	88538	88538	256421
9219	8214	0	applied	\N	\N	\N	\N	88580	88580	256463
9219	8215	1	applied	\N	\N	\N	\N	88581	88581	256464
9219	8216	2	applied	\N	\N	\N	\N	88582	88582	256465
9219	8217	3	applied	\N	\N	\N	\N	88583	88583	256466
9222	8218	0	applied	\N	\N	\N	\N	88588	88588	256471
9222	8219	1	applied	\N	\N	\N	\N	88589	88589	256472
9226	8222	0	applied	\N	\N	1000000000	\N	88596	88596	256479
9226	8223	1	applied	\N	\N	\N	\N	88597	88597	256480
9226	8224	2	applied	\N	\N	\N	\N	88598	88598	256481
9235	8232	0	applied	\N	\N	\N	\N	88616	88616	256499
9235	8233	1	applied	\N	\N	\N	\N	88617	88617	256500
9238	8238	0	applied	\N	\N	\N	\N	88624	88624	256507
9238	8239	1	applied	\N	\N	\N	\N	88625	88625	256508
9181	8139	6	applied	\N	\N	\N	\N	88319	88319	256204
9211	8204	0	applied	\N	\N	\N	\N	88542	88542	256425
9211	8205	1	applied	\N	\N	\N	\N	88543	88543	256426
9211	8206	2	applied	\N	\N	\N	\N	88544	88544	256427
9211	8207	3	applied	\N	\N	\N	\N	88545	88545	256428
9216	8208	0	applied	\N	\N	\N	\N	88564	88564	256447
9216	8209	1	applied	\N	\N	\N	\N	88565	88565	256448
9216	8210	2	applied	\N	\N	\N	\N	88566	88566	256449
9216	8211	3	applied	\N	\N	\N	\N	88567	88567	256450
9216	8212	4	applied	\N	\N	\N	\N	88568	88568	256451
9216	8213	5	applied	\N	\N	\N	\N	88569	88569	256452
9218	8214	0	applied	\N	\N	\N	\N	88576	88576	256459
9218	8215	1	applied	\N	\N	\N	\N	88577	88577	256460
9218	8216	2	applied	\N	\N	\N	\N	88578	88578	256461
9221	8218	0	applied	\N	\N	\N	\N	88586	88586	256469
9221	8219	1	applied	\N	\N	\N	\N	88587	88587	256470
9225	8220	0	applied	\N	\N	\N	\N	88594	88594	256477
9225	8221	1	applied	\N	\N	\N	\N	88595	88595	256478
9228	8222	0	applied	\N	\N	1000000000	\N	88600	88600	256483
9228	8223	1	applied	\N	\N	\N	\N	88601	88601	256484
9228	8224	2	applied	\N	\N	\N	\N	88602	88602	256485
9229	8222	0	applied	\N	\N	1000000000	\N	88603	88603	256486
9229	8223	1	applied	\N	\N	\N	\N	88604	88604	256487
9229	8224	2	applied	\N	\N	\N	\N	88605	88605	256488
9234	8230	0	applied	\N	\N	\N	\N	88614	88614	256497
9234	8231	1	applied	\N	\N	\N	\N	88615	88615	256498
9239	8240	0	applied	\N	\N	\N	\N	88626	88626	256509
9239	8241	1	applied	\N	\N	\N	\N	88627	88627	256510
9242	8246	0	applied	\N	\N	\N	\N	88632	88632	256515
9242	8247	1	applied	\N	\N	\N	\N	88633	88633	256516
9243	8246	0	applied	\N	\N	\N	\N	88635	88635	256518
9243	8247	1	applied	\N	\N	\N	\N	88636	88636	256519
9243	8248	2	applied	\N	\N	\N	\N	88637	88637	256520
9244	8246	0	applied	\N	\N	\N	\N	88638	88638	256521
9244	8247	1	applied	\N	\N	\N	\N	88639	88639	256522
9244	8248	2	applied	\N	\N	\N	\N	88640	88640	256523
9245	8246	0	applied	\N	\N	\N	\N	88641	88641	256524
9245	8247	1	applied	\N	\N	\N	\N	88642	88642	256525
9245	8248	2	applied	\N	\N	\N	\N	88643	88643	256526
9247	8259	0	applied	\N	\N	\N	\N	88654	88654	256537
9247	8260	1	applied	\N	\N	\N	\N	88655	88655	256538
9247	8261	2	applied	\N	\N	\N	\N	88656	88656	256539
9247	8262	3	applied	\N	\N	\N	\N	88657	88657	256540
9247	8263	4	applied	\N	\N	\N	\N	88658	88658	256541
9247	8264	5	applied	\N	\N	\N	\N	88659	88659	256542
9247	8265	6	applied	\N	\N	\N	\N	88660	88660	256543
9247	8267	8	applied	\N	\N	\N	\N	88662	88662	256545
9247	8268	9	applied	\N	\N	\N	\N	88663	88663	256546
9247	8269	10	applied	\N	\N	\N	\N	88664	88664	256547
9247	8270	11	applied	\N	\N	\N	\N	88665	88665	256548
9247	8271	12	applied	\N	\N	\N	\N	88666	88666	256549
9247	8272	13	applied	\N	\N	\N	\N	88667	88667	256550
9247	8273	14	applied	\N	\N	\N	\N	88668	88668	256551
9247	8274	15	applied	\N	\N	\N	\N	88669	88669	256552
9247	8275	16	applied	\N	\N	\N	\N	88670	88670	256553
9247	8276	17	applied	\N	\N	\N	\N	88671	88671	256554
9247	8277	18	applied	\N	\N	\N	\N	88672	88672	256555
9247	8278	19	applied	\N	\N	\N	\N	88673	88673	256556
9248	8279	0	applied	\N	\N	\N	\N	88674	88674	256557
9248	8280	1	applied	\N	\N	\N	\N	88675	88675	256558
9248	8281	2	applied	\N	\N	\N	\N	88676	88676	256559
9248	8282	3	applied	\N	\N	\N	\N	88677	88677	256560
9248	8284	5	applied	\N	\N	\N	\N	88679	88679	256562
9248	8285	6	applied	\N	\N	\N	\N	88680	88680	256563
9248	8286	7	applied	\N	\N	\N	\N	88681	88681	256564
9249	8287	0	applied	\N	\N	\N	\N	88682	88682	256565
9249	8288	1	applied	\N	\N	\N	\N	88683	88683	256566
9249	8289	2	applied	\N	\N	\N	\N	88684	88684	256567
9249	8290	3	applied	\N	\N	\N	\N	88685	88685	256568
9249	8291	4	applied	\N	\N	\N	\N	88686	88686	256569
9249	8292	5	applied	\N	\N	\N	\N	88687	88687	256570
9249	8293	6	applied	\N	\N	\N	\N	88688	88688	256571
9249	8294	7	applied	\N	\N	\N	\N	88689	88689	256572
9249	8295	8	applied	\N	\N	\N	\N	88690	88690	256573
9249	8296	9	applied	\N	\N	\N	\N	88691	88691	256574
9249	8297	10	applied	\N	\N	\N	\N	88692	88692	256575
9249	8298	11	applied	\N	\N	\N	\N	88693	88693	256576
9249	8299	12	applied	\N	\N	\N	\N	88694	88694	256577
9249	8301	14	applied	\N	\N	\N	\N	88696	88696	256579
9249	8302	15	applied	\N	\N	\N	\N	88697	88697	256580
9250	8303	0	applied	\N	\N	\N	\N	88698	88698	256581
9250	8304	1	applied	\N	\N	\N	\N	88699	88699	256582
9250	8305	2	applied	\N	\N	\N	\N	88700	88700	256583
9250	8306	3	applied	\N	\N	\N	\N	88701	88701	256584
9250	8307	4	applied	\N	\N	\N	\N	88702	88702	256585
9250	8308	5	applied	\N	\N	\N	\N	88703	88703	256586
9250	8309	7	applied	\N	\N	\N	\N	88704	88704	256587
9250	8310	8	applied	\N	\N	\N	\N	88705	88705	256588
9250	8311	9	applied	\N	\N	\N	\N	88706	88706	256589
9250	8312	10	applied	\N	\N	\N	\N	88707	88707	256590
9250	8313	11	applied	\N	\N	\N	\N	88708	88708	256591
9250	8314	12	applied	\N	\N	\N	\N	88709	88709	256592
9250	8315	13	applied	\N	\N	\N	\N	88710	88710	256593
9250	8316	14	applied	\N	\N	\N	\N	88711	88711	256594
9250	8318	16	applied	\N	\N	\N	\N	88713	88713	256596
9250	8319	17	applied	\N	\N	\N	\N	88714	88714	256597
9250	8320	18	applied	\N	\N	\N	\N	88715	88715	256598
9250	8321	19	applied	\N	\N	\N	\N	88716	88716	256599
9250	8322	20	applied	\N	\N	\N	\N	88717	88717	256600
9250	8323	21	applied	\N	\N	\N	\N	88718	88718	256601
9250	8324	22	applied	\N	\N	\N	\N	88719	88719	256602
9250	8325	23	applied	\N	\N	\N	\N	88720	88720	256603
9250	8326	24	applied	\N	\N	\N	\N	88721	88721	256604
9251	8303	0	applied	\N	\N	\N	\N	88722	88722	256605
9251	8304	1	applied	\N	\N	\N	\N	88723	88723	256606
9251	8305	2	applied	\N	\N	\N	\N	88724	88724	256607
9251	8306	3	applied	\N	\N	\N	\N	88725	88725	256608
9251	8307	4	applied	\N	\N	\N	\N	88726	88726	256609
9251	8308	5	applied	\N	\N	\N	\N	88727	88727	256610
9251	8309	7	applied	\N	\N	\N	\N	88728	88728	256611
9208	8197	0	applied	\N	\N	\N	\N	88535	88535	256418
9208	8198	1	applied	\N	\N	\N	\N	88536	88536	256419
9251	8315	13	applied	\N	\N	\N	\N	88734	88734	256617
9251	8316	14	applied	\N	\N	\N	\N	88735	88735	256618
9251	8317	15	applied	\N	\N	\N	\N	88736	88736	256619
9251	8318	16	applied	\N	\N	\N	\N	88737	88737	256620
9251	8319	17	applied	\N	\N	\N	\N	88738	88738	256621
9251	8320	18	applied	\N	\N	\N	\N	88739	88739	256622
9251	8321	19	applied	\N	\N	\N	\N	88740	88740	256623
9251	8322	20	applied	\N	\N	\N	\N	88741	88741	256624
9251	8323	21	applied	\N	\N	\N	\N	88742	88742	256625
9251	8324	22	applied	\N	\N	\N	\N	88743	88743	256626
9251	8325	23	applied	\N	\N	\N	\N	88744	88744	256627
9251	8326	24	applied	\N	\N	\N	\N	88745	88745	256628
9252	8111	0	applied	\N	\N	\N	\N	88746	88746	256629
9252	8112	1	applied	\N	\N	\N	\N	88747	88747	256630
9252	8159	2	applied	\N	\N	\N	\N	88748	88748	256631
9252	8113	3	applied	\N	\N	\N	\N	88749	88749	256632
9252	8117	5	applied	\N	\N	\N	\N	88751	88751	256634
9252	8120	6	applied	\N	\N	\N	\N	88752	88752	256635
9252	8163	7	applied	\N	\N	\N	\N	88753	88753	256636
9252	8248	8	applied	\N	\N	\N	\N	88754	88754	256637
9252	8250	9	applied	\N	\N	\N	\N	88755	88755	256638
9252	8123	10	applied	\N	\N	\N	\N	88756	88756	256639
9252	8164	11	applied	\N	\N	\N	\N	88757	88757	256640
9252	8165	12	applied	\N	\N	\N	\N	88758	88758	256641
9252	8166	13	applied	\N	\N	\N	\N	88759	88759	256642
9252	8168	14	applied	\N	\N	\N	\N	88760	88760	256643
9252	8170	15	applied	\N	\N	\N	\N	88761	88761	256644
9252	8327	16	applied	\N	\N	\N	\N	88762	88762	256645
9252	8114	17	applied	\N	\N	\N	\N	88763	88763	256646
9252	8115	18	applied	\N	\N	\N	\N	88764	88764	256647
9252	8118	19	applied	\N	\N	\N	\N	88765	88765	256648
9252	8119	20	applied	\N	\N	\N	\N	88766	88766	256649
9252	8126	22	applied	\N	\N	\N	\N	88768	88768	256651
9252	8127	23	applied	\N	\N	\N	\N	88769	88769	256652
9252	8132	24	applied	\N	\N	\N	\N	88770	88770	256653
9252	8134	25	applied	\N	\N	\N	\N	88771	88771	256654
9252	8138	26	applied	\N	\N	\N	\N	88772	88772	256655
9252	8139	27	applied	\N	\N	\N	\N	88773	88773	256656
9252	8141	28	applied	\N	\N	\N	\N	88774	88774	256657
9252	8142	29	applied	\N	\N	\N	\N	88775	88775	256658
9252	8144	30	applied	\N	\N	\N	\N	88776	88776	256659
9252	8145	31	applied	\N	\N	\N	\N	88777	88777	256660
9252	8146	32	applied	\N	\N	\N	\N	88778	88778	256661
9252	8150	33	applied	\N	\N	\N	\N	88779	88779	256662
9252	8151	34	applied	\N	\N	\N	\N	88780	88780	256663
9252	8152	35	applied	\N	\N	\N	\N	88781	88781	256664
9252	8157	36	applied	\N	\N	\N	\N	88782	88782	256665
9252	8158	37	applied	\N	\N	\N	\N	88783	88783	256666
9252	8167	39	applied	\N	\N	\N	\N	88785	88785	256668
9252	8171	40	applied	\N	\N	\N	\N	88786	88786	256669
9252	8174	41	applied	\N	\N	\N	\N	88787	88787	256670
9252	8176	42	applied	\N	\N	\N	\N	88788	88788	256671
9252	8177	44	applied	\N	\N	\N	\N	88789	88789	256672
9252	8180	45	applied	\N	\N	\N	\N	88790	88790	256673
9252	8182	46	applied	\N	\N	\N	\N	88791	88791	256674
9252	8183	47	applied	\N	\N	\N	\N	88792	88792	256675
9252	8328	48	applied	\N	\N	\N	\N	88793	88793	256676
9252	8189	49	applied	\N	\N	\N	\N	88794	88794	256677
9252	8190	50	applied	\N	\N	\N	\N	88795	88795	256678
9252	8191	51	applied	\N	\N	\N	\N	88796	88796	256679
9252	8192	52	applied	\N	\N	\N	\N	88797	88797	256680
9252	8195	53	applied	\N	\N	\N	\N	88798	88798	256681
9252	8197	54	applied	\N	\N	\N	\N	88799	88799	256682
9252	8199	55	applied	\N	\N	\N	\N	88800	88800	256683
9252	8204	57	applied	\N	\N	\N	\N	88802	88802	256685
9252	8206	58	applied	\N	\N	\N	\N	88803	88803	256686
9252	8208	59	applied	\N	\N	\N	\N	88804	88804	256687
9252	8209	60	applied	\N	\N	\N	\N	88805	88805	256688
9252	8210	61	applied	\N	\N	\N	\N	88806	88806	256689
9252	8214	62	applied	\N	\N	\N	\N	88807	88807	256690
9252	8215	63	applied	\N	\N	\N	\N	88808	88808	256691
9252	8219	64	applied	\N	\N	\N	\N	88809	88809	256692
9252	8221	65	applied	\N	\N	\N	\N	88810	88810	256693
9252	8130	66	applied	\N	\N	\N	\N	88811	88811	256694
9252	8131	67	applied	\N	\N	\N	\N	88812	88812	256695
9252	8133	68	applied	\N	\N	\N	\N	88813	88813	256696
9252	8135	69	applied	\N	\N	\N	\N	88814	88814	256697
9252	8136	70	applied	\N	\N	\N	\N	88815	88815	256698
9252	8137	71	applied	\N	\N	\N	\N	88816	88816	256699
9252	8140	72	applied	\N	\N	\N	\N	88817	88817	256700
9252	8147	74	applied	\N	\N	\N	\N	88819	88819	256702
9252	8148	75	applied	\N	\N	\N	\N	88820	88820	256703
9252	8149	76	applied	\N	\N	\N	\N	88821	88821	256704
9252	8153	77	applied	\N	\N	\N	\N	88822	88822	256705
9252	8154	78	applied	\N	\N	\N	\N	88823	88823	256706
9252	8155	79	applied	\N	\N	\N	\N	88824	88824	256707
9252	8156	80	applied	\N	\N	\N	\N	88825	88825	256708
9252	8161	81	applied	\N	\N	\N	\N	88826	88826	256709
9252	8162	82	applied	\N	\N	\N	\N	88827	88827	256710
9252	8169	83	applied	\N	\N	\N	\N	88828	88828	256711
9252	8173	84	applied	\N	\N	\N	\N	88829	88829	256712
9252	8175	85	applied	\N	\N	\N	\N	88830	88830	256713
9252	8178	86	applied	\N	\N	\N	\N	88831	88831	256714
9252	8179	87	applied	\N	\N	\N	\N	88832	88832	256715
9252	8181	88	applied	\N	\N	\N	\N	88833	88833	256716
9252	8184	89	applied	\N	\N	\N	\N	88834	88834	256717
9252	8186	91	applied	\N	\N	\N	\N	88836	88836	256719
9252	8187	92	applied	\N	\N	\N	\N	88837	88837	256720
9252	8188	93	applied	\N	\N	\N	\N	88838	88838	256721
9252	8196	94	applied	\N	\N	\N	\N	88839	88839	256722
9252	8198	95	applied	\N	\N	\N	\N	88840	88840	256723
9252	8200	96	applied	\N	\N	\N	\N	88841	88841	256724
9252	8202	97	applied	\N	\N	\N	\N	88842	88842	256725
9252	8205	98	applied	\N	\N	\N	\N	88843	88843	256726
9252	8207	99	applied	\N	\N	\N	\N	88844	88844	256727
9252	8252	100	applied	\N	\N	\N	\N	88845	88845	256728
9252	8253	101	applied	\N	\N	\N	\N	88846	88846	256729
9252	8254	102	applied	\N	\N	\N	\N	88847	88847	256730
9252	8255	103	applied	\N	\N	\N	\N	88848	88848	256731
9252	8256	104	applied	\N	\N	\N	\N	88849	88849	256732
9251	8312	10	applied	\N	\N	\N	\N	88731	88731	256614
9251	8313	11	applied	\N	\N	\N	\N	88732	88732	256615
9252	8269	109	applied	\N	\N	\N	\N	88854	88854	256737
9252	8270	110	applied	\N	\N	\N	\N	88855	88855	256738
9252	8271	111	applied	\N	\N	\N	\N	88856	88856	256739
9252	8272	112	applied	\N	\N	\N	\N	88857	88857	256740
9252	8273	113	applied	\N	\N	\N	\N	88858	88858	256741
9252	8274	114	applied	\N	\N	\N	\N	88859	88859	256742
9252	8275	115	applied	\N	\N	\N	\N	88860	88860	256743
9252	8276	116	applied	\N	\N	\N	\N	88861	88861	256744
9252	8277	117	applied	\N	\N	\N	\N	88862	88862	256745
9252	8278	118	applied	\N	\N	\N	\N	88863	88863	256746
9252	8281	119	applied	\N	\N	\N	\N	88864	88864	256747
9252	8282	120	applied	\N	\N	\N	\N	88865	88865	256748
9252	8283	121	applied	\N	\N	\N	\N	88866	88866	256749
9252	8284	122	applied	\N	\N	\N	\N	88867	88867	256750
9252	8285	123	applied	\N	\N	\N	\N	88868	88868	256751
9252	8286	124	applied	\N	\N	\N	\N	88869	88869	256752
9253	8303	0	applied	\N	\N	\N	\N	88871	88871	256754
9253	8304	1	applied	\N	\N	\N	\N	88872	88872	256755
9253	8305	2	applied	\N	\N	\N	\N	88873	88873	256756
9253	8306	3	applied	\N	\N	\N	\N	88874	88874	256757
9253	8307	4	applied	\N	\N	\N	\N	88875	88875	256758
9253	8308	5	applied	\N	\N	\N	\N	88876	88876	256759
9253	8309	7	applied	\N	\N	\N	\N	88877	88877	256760
9253	8310	8	applied	\N	\N	\N	\N	88878	88878	256761
9253	8311	9	applied	\N	\N	\N	\N	88879	88879	256762
9253	8312	10	applied	\N	\N	\N	\N	88880	88880	256763
9253	8313	11	applied	\N	\N	\N	\N	88881	88881	256764
9253	8314	12	applied	\N	\N	\N	\N	88882	88882	256765
9253	8315	13	applied	\N	\N	\N	\N	88883	88883	256766
9253	8316	14	applied	\N	\N	\N	\N	88884	88884	256767
9253	8317	15	applied	\N	\N	\N	\N	88885	88885	256768
9253	8318	16	applied	\N	\N	\N	\N	88886	88886	256769
9253	8320	18	applied	\N	\N	\N	\N	88888	88888	256771
9253	8321	19	applied	\N	\N	\N	\N	88889	88889	256772
9253	8322	20	applied	\N	\N	\N	\N	88890	88890	256773
9253	8323	21	applied	\N	\N	\N	\N	88891	88891	256774
9253	8324	22	applied	\N	\N	\N	\N	88892	88892	256775
9253	8325	23	applied	\N	\N	\N	\N	88893	88893	256776
9253	8326	24	applied	\N	\N	\N	\N	88894	88894	256777
9254	8329	0	applied	\N	\N	\N	\N	88895	88895	256778
9254	8330	1	applied	\N	\N	\N	\N	88896	88896	256779
9254	8331	2	applied	\N	\N	\N	\N	88897	88897	256780
9254	8332	3	applied	\N	\N	\N	\N	88898	88898	256781
9254	8333	4	applied	\N	\N	\N	\N	88899	88899	256782
9254	8334	5	applied	\N	\N	\N	\N	88900	88900	256783
9254	8335	6	applied	\N	\N	\N	\N	88901	88901	256784
9256	8336	0	applied	\N	\N	\N	\N	88909	88909	256792
9256	8337	1	applied	\N	\N	\N	\N	88910	88910	256793
9256	8339	3	applied	\N	\N	\N	\N	88912	88912	256795
9256	8340	4	applied	\N	\N	\N	\N	88913	88913	256796
9256	8341	5	applied	\N	\N	\N	\N	88914	88914	256797
9256	8342	6	applied	\N	\N	\N	\N	88915	88915	256798
9256	8343	7	applied	\N	\N	\N	\N	88916	88916	256799
9258	8336	0	applied	\N	\N	\N	\N	88925	88925	256808
9258	8337	1	applied	\N	\N	\N	\N	88926	88926	256809
9258	8338	2	applied	\N	\N	\N	\N	88927	88927	256810
9258	8339	3	applied	\N	\N	\N	\N	88928	88928	256811
9258	8340	4	applied	\N	\N	\N	\N	88929	88929	256812
9258	8341	5	applied	\N	\N	\N	\N	88930	88930	256813
9258	8342	6	applied	\N	\N	\N	\N	88931	88931	256814
9258	8343	7	applied	\N	\N	\N	\N	88932	88932	256815
9260	8344	0	applied	\N	\N	\N	\N	88941	88941	256824
9260	8345	1	applied	\N	\N	\N	\N	88942	88942	256825
9260	8346	2	applied	\N	\N	\N	\N	88943	88943	256826
9260	8348	4	applied	\N	\N	\N	\N	88945	88945	256828
9260	8349	5	applied	\N	\N	\N	\N	88946	88946	256829
9260	8350	6	applied	\N	\N	\N	\N	88947	88947	256830
9260	8351	7	applied	\N	\N	\N	\N	88948	88948	256831
9261	8344	0	applied	\N	\N	\N	\N	88949	88949	256832
9261	8345	1	applied	\N	\N	\N	\N	88950	88950	256833
9261	8346	2	applied	\N	\N	\N	\N	88951	88951	256834
9261	8347	3	applied	\N	\N	\N	\N	88952	88952	256835
9261	8348	4	applied	\N	\N	\N	\N	88953	88953	256836
9261	8349	5	applied	\N	\N	\N	\N	88954	88954	256837
9261	8350	6	applied	\N	\N	\N	\N	88955	88955	256838
9261	8351	7	applied	\N	\N	\N	\N	88956	88956	256839
9262	8352	0	applied	\N	\N	\N	\N	88957	88957	256840
9262	8353	1	applied	\N	\N	\N	\N	88958	88958	256841
9262	8354	2	applied	\N	\N	\N	\N	88959	88959	256842
9262	8355	3	applied	\N	\N	\N	\N	88960	88960	256843
9262	8357	5	applied	\N	\N	\N	\N	88962	88962	256845
9262	8358	6	applied	\N	\N	\N	\N	88963	88963	256846
9262	8359	7	applied	\N	\N	\N	\N	88964	88964	256847
9263	8360	0	applied	\N	\N	\N	\N	88965	88965	256848
9263	8361	1	applied	\N	\N	\N	\N	88966	88966	256849
9263	8362	2	applied	\N	\N	\N	\N	88967	88967	256850
9263	8363	3	applied	\N	\N	\N	\N	88968	88968	256851
9263	8364	4	applied	\N	\N	\N	\N	88969	88969	256852
9263	8365	5	applied	\N	\N	\N	\N	88970	88970	256853
9263	8366	6	applied	\N	\N	\N	\N	88971	88971	256854
9263	8367	7	applied	\N	\N	\N	\N	88972	88972	256855
9263	8368	8	applied	\N	\N	\N	\N	88973	88973	256856
9263	8369	9	applied	\N	\N	\N	\N	88974	88974	256857
9263	8370	10	applied	\N	\N	\N	\N	88975	88975	256858
9263	8371	11	applied	\N	\N	\N	\N	88976	88976	256859
9263	8372	12	applied	\N	\N	\N	\N	88977	88977	256860
9263	8374	14	applied	\N	\N	\N	\N	88979	88979	256862
9270	8395	0	applied	\N	\N	\N	\N	89016	89016	256899
9270	8396	1	applied	\N	\N	\N	\N	89017	89017	256900
9270	8397	2	applied	\N	\N	\N	\N	89018	89018	256901
9271	8395	0	applied	\N	\N	\N	\N	89019	89019	256902
9271	8396	1	applied	\N	\N	\N	\N	89020	89020	256903
9271	8397	2	applied	\N	\N	\N	\N	89021	89021	256904
9273	8395	0	applied	\N	\N	\N	\N	89025	89025	256908
9273	8396	1	applied	\N	\N	\N	\N	89026	89026	256909
9273	8397	2	applied	\N	\N	\N	\N	89027	89027	256910
9274	8398	0	applied	\N	\N	\N	\N	89028	89028	256911
9274	8399	1	applied	\N	\N	\N	\N	89029	89029	256912
9275	8400	0	applied	\N	\N	\N	\N	89030	89030	256913
9279	8406	0	applied	\N	\N	\N	\N	89038	89038	256921
9252	8265	106	applied	\N	\N	\N	\N	88851	88851	256734
9252	8267	107	applied	\N	\N	\N	\N	88852	88852	256735
9255	8333	4	applied	\N	\N	\N	\N	88906	88906	256789
9255	8334	5	applied	\N	\N	\N	\N	88907	88907	256790
9255	8335	6	applied	\N	\N	\N	\N	88908	88908	256791
9257	8336	0	applied	\N	\N	\N	\N	88917	88917	256800
9257	8337	1	applied	\N	\N	\N	\N	88918	88918	256801
9257	8338	2	applied	\N	\N	\N	\N	88919	88919	256802
9257	8339	3	applied	\N	\N	\N	\N	88920	88920	256803
9257	8340	4	applied	\N	\N	\N	\N	88921	88921	256804
9257	8341	5	applied	\N	\N	\N	\N	88922	88922	256805
9257	8342	6	applied	\N	\N	\N	\N	88923	88923	256806
9257	8343	7	applied	\N	\N	\N	\N	88924	88924	256807
9259	8336	0	applied	\N	\N	\N	\N	88933	88933	256816
9259	8337	1	applied	\N	\N	\N	\N	88934	88934	256817
9259	8338	2	applied	\N	\N	\N	\N	88935	88935	256818
9259	8340	4	applied	\N	\N	\N	\N	88937	88937	256820
9259	8341	5	applied	\N	\N	\N	\N	88938	88938	256821
9259	8342	6	applied	\N	\N	\N	\N	88939	88939	256822
9259	8343	7	applied	\N	\N	\N	\N	88940	88940	256823
9264	8360	0	applied	\N	\N	\N	\N	88980	88980	256863
9264	8361	1	applied	\N	\N	\N	\N	88981	88981	256864
9264	8362	2	applied	\N	\N	\N	\N	88982	88982	256865
9264	8363	3	applied	\N	\N	\N	\N	88983	88983	256866
9264	8364	4	applied	\N	\N	\N	\N	88984	88984	256867
9264	8365	5	applied	\N	\N	\N	\N	88985	88985	256868
9264	8366	6	applied	\N	\N	\N	\N	88986	88986	256869
9264	8367	7	applied	\N	\N	\N	\N	88987	88987	256870
9264	8368	8	applied	\N	\N	\N	\N	88988	88988	256871
9264	8369	9	applied	\N	\N	\N	\N	88989	88989	256872
9264	8370	10	applied	\N	\N	\N	\N	88990	88990	256873
9264	8371	11	applied	\N	\N	\N	\N	88991	88991	256874
9264	8373	13	applied	\N	\N	\N	\N	88993	88993	256876
9264	8374	14	applied	\N	\N	\N	\N	88994	88994	256877
9267	8375	0	applied	\N	\N	\N	\N	88995	88995	256878
9268	8376	0	applied	\N	\N	\N	\N	88996	88996	256879
9268	8375	1	applied	\N	\N	\N	\N	88997	88997	256880
9268	8377	2	applied	\N	\N	\N	\N	88998	88998	256881
9268	8378	3	applied	\N	\N	\N	\N	88999	88999	256882
9268	8379	4	applied	\N	\N	\N	\N	89000	89000	256883
9268	8380	5	applied	\N	\N	\N	\N	89001	89001	256884
9268	8381	6	applied	\N	\N	\N	\N	89002	89002	256885
9268	8382	7	applied	\N	\N	\N	\N	89003	89003	256886
9268	8383	8	applied	\N	\N	\N	\N	89004	89004	256887
9269	8384	0	applied	\N	\N	\N	\N	89005	89005	256888
9269	8385	1	applied	\N	\N	\N	\N	89006	89006	256889
9269	8386	2	applied	\N	\N	\N	\N	89007	89007	256890
9269	8387	3	applied	\N	\N	\N	\N	89008	89008	256891
9269	8389	5	applied	\N	\N	\N	\N	89010	89010	256893
9269	8390	6	applied	\N	\N	\N	\N	89011	89011	256894
9269	8391	7	applied	\N	\N	\N	\N	89012	89012	256895
9269	8392	8	applied	\N	\N	\N	\N	89013	89013	256896
9269	8393	9	applied	\N	\N	\N	\N	89014	89014	256897
9269	8394	10	applied	\N	\N	\N	\N	89015	89015	256898
9272	8395	0	applied	\N	\N	\N	\N	89022	89022	256905
9272	8396	1	applied	\N	\N	\N	\N	89023	89023	256906
9272	8397	2	applied	\N	\N	\N	\N	89024	89024	256907
9275	8401	1	applied	\N	\N	\N	\N	89031	89031	256914
9276	8400	0	applied	\N	\N	\N	\N	89032	89032	256915
9276	8401	1	applied	\N	\N	\N	\N	89033	89033	256916
9277	8402	0	applied	\N	\N	\N	\N	89034	89034	256917
9277	8403	1	applied	\N	\N	\N	\N	89035	89035	256918
9278	8404	0	applied	\N	\N	\N	\N	89036	89036	256919
9278	8405	1	applied	\N	\N	\N	\N	89037	89037	256920
9280	8407	1	applied	\N	\N	\N	\N	89041	89041	256924
9284	8410	0	applied	\N	\N	\N	\N	89048	89048	256931
9284	8411	1	applied	\N	\N	\N	\N	89049	89049	256932
9287	8415	0	applied	\N	\N	\N	\N	89054	89054	256937
9287	8416	1	applied	\N	\N	\N	\N	89055	89055	256938
9289	8419	0	applied	\N	\N	\N	\N	89058	89058	256941
9289	8420	1	applied	\N	\N	\N	\N	89059	89059	256942
9292	8421	0	applied	\N	\N	\N	\N	89187	89187	257070
9292	8422	1	applied	\N	\N	\N	\N	89188	89188	257071
9292	8423	2	applied	\N	\N	\N	\N	89189	89189	257072
9292	8424	3	applied	\N	\N	\N	\N	89190	89190	257073
9294	8428	0	applied	\N	\N	\N	\N	89194	89194	257077
9294	8429	1	applied	\N	\N	\N	\N	89195	89195	257078
9297	8432	0	applied	\N	\N	\N	\N	89200	89200	257083
9297	8433	1	applied	\N	\N	\N	\N	89201	89201	257084
9303	8444	0	applied	\N	\N	\N	\N	89216	89216	257099
9306	8454	0	applied	\N	\N	\N	\N	89234	89234	257117
9306	8455	1	applied	\N	\N	\N	\N	89235	89235	257118
9306	8456	2	applied	\N	\N	\N	\N	89236	89236	257119
9306	8457	3	applied	\N	\N	1000000000	\N	89237	89237	257120
9315	8462	0	applied	\N	\N	\N	\N	89263	89263	257142
9315	8465	1	applied	\N	\N	\N	\N	89264	89264	257143
9315	8466	2	applied	\N	\N	\N	\N	89265	89265	257144
9315	8464	3	applied	\N	\N	\N	\N	89266	89266	89266
9323	8475	0	applied	\N	\N	\N	\N	89286	89286	257163
9323	8476	1	applied	\N	\N	\N	\N	89287	89287	257164
9323	8477	2	applied	\N	\N	\N	\N	89288	89288	257165
9323	8478	3	applied	\N	\N	\N	\N	89289	89289	257166
9326	8481	0	applied	\N	\N	\N	\N	89293	89293	257170
9326	8482	1	applied	\N	\N	\N	\N	89294	89294	257171
9326	8483	2	applied	\N	\N	\N	\N	89295	89295	257172
9326	8484	3	applied	\N	\N	\N	\N	89296	89296	257173
9329	8491	0	applied	\N	\N	\N	\N	89305	89305	257182
9329	8492	1	applied	\N	\N	\N	\N	89306	89306	257183
9331	8493	0	applied	\N	\N	\N	\N	89309	89309	257186
9331	8494	1	applied	\N	\N	\N	\N	89310	89310	257187
9334	8499	0	applied	\N	\N	\N	\N	89315	89315	257192
9334	8500	1	applied	\N	\N	\N	\N	89316	89316	257193
9334	8501	2	applied	\N	\N	\N	\N	89317	89317	257194
9334	8502	3	applied	\N	\N	\N	\N	89318	89318	257195
9339	8510	0	applied	\N	\N	\N	\N	89335	89335	257212
9339	8511	1	applied	\N	\N	\N	\N	89336	89336	257213
9344	8514	0	applied	\N	\N	\N	\N	89345	89345	257222
9344	8515	1	applied	\N	\N	\N	\N	89346	89346	257223
9346	8518	0	applied	\N	\N	\N	\N	89349	89349	257226
9346	8519	1	applied	\N	\N	\N	\N	89350	89350	257227
9351	8528	0	applied	\N	\N	\N	\N	89363	89363	257239
9351	8529	1	applied	\N	\N	\N	\N	89364	89364	257240
9255	8332	3	applied	\N	\N	\N	\N	88905	88905	256788
9282	8408	0	applied	\N	\N	\N	\N	89044	89044	256927
9282	8409	1	applied	\N	\N	\N	\N	89045	89045	256928
9283	8408	0	applied	\N	\N	\N	\N	89046	89046	256929
9283	8409	1	applied	\N	\N	\N	\N	89047	89047	256930
9285	8411	0	applied	\N	\N	\N	\N	89050	89050	256933
9286	8412	0	applied	\N	\N	\N	\N	89051	89051	256934
9286	8413	1	applied	\N	\N	\N	\N	89052	89052	256935
9286	8414	2	applied	\N	\N	\N	\N	89053	89053	256936
9288	8417	0	applied	\N	\N	\N	\N	89056	89056	256939
9288	8418	1	applied	\N	\N	\N	\N	89057	89057	256940
9290	8419	0	applied	\N	\N	\N	\N	89060	89060	256943
9291	7969	0	applied	\N	\N	\N	\N	89062	89062	256945
9291	7956	1	applied	\N	\N	\N	\N	89063	89063	256946
9291	7999	2	applied	\N	\N	\N	\N	89064	89064	256947
9291	7980	3	applied	\N	\N	\N	\N	89065	89065	256948
9291	7949	4	applied	\N	\N	1000000000	\N	89066	89066	256949
9291	8159	5	applied	\N	\N	\N	\N	89067	89067	256950
9291	7890	6	applied	\N	\N	\N	\N	89068	89068	256951
9291	7893	7	applied	\N	\N	\N	\N	89069	89069	256952
9291	7894	8	applied	\N	\N	\N	\N	89070	89070	256953
9291	7897	9	applied	\N	\N	\N	\N	89071	89071	256954
9291	7900	10	applied	\N	\N	\N	\N	89072	89072	256955
9291	7901	11	applied	\N	\N	\N	\N	89073	89073	256956
9291	7903	12	applied	\N	\N	\N	\N	89074	89074	256957
9291	7891	13	applied	\N	\N	\N	\N	89075	89075	256958
9291	7915	14	applied	\N	\N	\N	\N	89076	89076	256959
9291	8163	15	applied	\N	\N	\N	\N	89077	89077	256960
9291	8250	18	applied	\N	\N	\N	\N	89079	89079	256962
9291	7990	19	applied	\N	\N	1000000000	\N	89080	89080	256963
9291	8164	20	applied	\N	\N	\N	\N	89081	89081	256964
9291	8165	21	applied	\N	\N	\N	\N	89082	89082	256965
9291	8166	22	applied	\N	\N	\N	\N	89083	89083	256966
9291	8168	23	applied	\N	\N	\N	\N	89084	89084	256967
9291	8170	24	applied	\N	\N	\N	\N	89085	89085	256968
9291	7983	25	applied	\N	\N	\N	\N	89086	89086	256969
9291	7984	26	applied	\N	\N	\N	\N	89087	89087	256970
9291	8252	27	applied	\N	\N	\N	\N	89088	89088	256971
9291	8253	28	applied	\N	\N	\N	\N	89089	89089	256972
9291	8254	29	applied	\N	\N	\N	\N	89090	89090	256973
9291	8255	30	applied	\N	\N	\N	\N	89091	89091	256974
9291	8256	31	applied	\N	\N	\N	\N	89092	89092	256975
9291	8264	32	applied	\N	\N	\N	\N	89093	89093	256976
9291	8265	33	applied	\N	\N	\N	\N	89094	89094	256977
9291	8268	35	applied	\N	\N	\N	\N	89096	89096	256979
9291	8269	36	applied	\N	\N	\N	\N	89097	89097	256980
9291	8270	37	applied	\N	\N	\N	\N	89098	89098	256981
9291	8271	38	applied	\N	\N	\N	\N	89099	89099	256982
9291	8272	39	applied	\N	\N	\N	\N	89100	89100	256983
9291	8273	40	applied	\N	\N	\N	\N	89101	89101	256984
9291	8274	41	applied	\N	\N	\N	\N	89102	89102	256985
9291	8275	42	applied	\N	\N	\N	\N	89103	89103	256986
9291	8276	43	applied	\N	\N	\N	\N	89104	89104	256987
9291	8277	44	applied	\N	\N	\N	\N	89105	89105	256988
9302	8444	0	applied	\N	\N	\N	\N	89214	89214	257097
9302	8445	1	applied	\N	\N	\N	\N	89215	89215	257098
9308	8458	0	applied	\N	\N	\N	\N	89242	89242	257125
9308	8459	1	applied	\N	\N	\N	\N	89243	89243	257126
9308	8460	2	applied	\N	\N	\N	\N	89244	89244	257127
9308	8461	3	applied	\N	\N	\N	\N	89245	89245	257128
9311	8463	1	applied	\N	\N	\N	\N	89254	89254	257136
9311	8464	2	applied	\N	\N	\N	\N	89255	89255	89255
9313	8462	0	applied	\N	\N	\N	\N	89259	89259	257139
9313	8463	1	applied	\N	\N	\N	\N	89260	89260	257140
9313	8464	2	applied	\N	\N	\N	\N	89261	89261	89261
9317	8467	0	applied	\N	\N	\N	\N	89271	89271	257148
9317	8468	1	applied	\N	\N	\N	\N	89272	89272	257149
9320	8467	0	applied	\N	\N	\N	\N	89277	89277	257154
9320	8468	1	applied	\N	\N	\N	\N	89278	89278	257155
9322	8469	0	applied	\N	\N	\N	\N	89280	89280	257157
9322	8470	1	applied	\N	\N	\N	\N	89281	89281	257158
9322	8471	2	applied	\N	\N	\N	\N	89282	89282	257159
9322	8472	3	applied	\N	\N	\N	\N	89283	89283	257160
9322	8473	4	applied	\N	\N	\N	\N	89284	89284	257161
9322	8474	5	applied	\N	\N	\N	\N	89285	89285	257162
9324	8479	0	applied	\N	\N	\N	\N	89290	89290	257167
9327	8486	0	applied	\N	\N	\N	\N	89298	89298	257175
9327	8487	1	applied	\N	\N	\N	\N	89299	89299	257176
9327	8488	3	applied	\N	\N	\N	\N	89300	89300	257177
9327	8489	4	applied	\N	\N	\N	\N	89301	89301	257178
9327	8490	5	applied	\N	\N	\N	\N	89302	89302	257179
9335	8499	0	applied	\N	\N	\N	\N	89319	89319	257196
9335	8500	1	applied	\N	\N	\N	\N	89320	89320	257197
9335	8501	2	applied	\N	\N	\N	\N	89321	89321	257198
9335	8503	3	applied	\N	\N	\N	\N	89322	89322	257199
9335	8504	4	applied	\N	\N	\N	\N	89323	89323	257200
9335	8505	5	applied	\N	\N	\N	\N	89324	89324	257201
9335	8502	6	applied	\N	\N	\N	\N	89325	89325	257202
9337	8508	0	applied	\N	\N	\N	\N	89331	89331	257208
9337	8509	1	applied	\N	\N	\N	\N	89332	89332	257209
9340	8510	0	applied	\N	\N	\N	\N	89337	89337	257214
9340	8511	1	applied	\N	\N	\N	\N	89338	89338	257215
9342	8515	1	applied	\N	\N	\N	\N	89342	89342	257219
9349	8520	0	applied	\N	\N	\N	\N	89355	89355	89355
9349	8521	1	applied	\N	\N	\N	\N	89356	89356	257232
9349	8522	2	applied	\N	\N	\N	\N	89357	89357	257233
9349	8523	3	applied	\N	\N	\N	\N	89358	89358	257234
9349	8524	4	applied	\N	\N	\N	\N	89359	89359	257235
9349	8525	5	applied	\N	\N	\N	\N	89360	89360	257236
9354	8530	0	applied	\N	\N	\N	\N	89369	89369	257245
9354	8531	1	applied	\N	\N	\N	\N	89370	89370	257246
9366	8537	0	applied	\N	\N	\N	\N	89382	89382	257258
9366	8538	1	applied	\N	\N	\N	\N	89383	89383	257259
9367	8539	0	applied	\N	\N	\N	\N	89384	89384	257260
9367	8540	1	applied	\N	\N	\N	\N	89385	89385	257261
9372	8547	0	applied	\N	\N	1000000000	\N	89394	89394	257270
9372	8548	1	applied	\N	\N	\N	\N	89395	89395	257271
9375	8551	0	applied	\N	\N	\N	\N	89403	89403	257279
9375	8553	2	applied	\N	\N	\N	\N	89405	89405	257281
9379	8556	0	applied	\N	\N	\N	\N	89413	89413	257289
9281	8408	0	applied	\N	\N	\N	\N	89042	89042	256925
9281	8409	1	applied	\N	\N	\N	\N	89043	89043	256926
9291	8284	49	applied	\N	\N	\N	\N	89110	89110	256993
9291	8285	50	applied	\N	\N	\N	\N	89111	89111	256994
9291	8286	51	applied	\N	\N	\N	\N	89112	89112	256995
9291	8291	52	applied	\N	\N	\N	\N	89113	89113	256996
9291	8292	53	applied	\N	\N	\N	\N	89114	89114	256997
9291	8293	54	applied	\N	\N	\N	\N	89115	89115	256998
9291	8294	55	applied	\N	\N	\N	\N	89116	89116	256999
9291	8295	56	applied	\N	\N	\N	\N	89117	89117	257000
9291	8296	57	applied	\N	\N	\N	\N	89118	89118	257001
9291	8297	58	applied	\N	\N	\N	\N	89119	89119	257002
9291	8298	59	applied	\N	\N	\N	\N	89120	89120	257003
9291	8299	60	applied	\N	\N	\N	\N	89121	89121	257004
9291	8300	61	applied	\N	\N	\N	\N	89122	89122	257005
9291	8301	62	applied	\N	\N	\N	\N	89123	89123	257006
9291	8307	64	applied	\N	\N	\N	\N	89125	89125	257008
9291	8308	65	applied	\N	\N	\N	\N	89126	89126	257009
9291	8309	66	applied	\N	\N	\N	\N	89127	89127	257010
9291	8311	67	applied	\N	\N	\N	\N	89128	89128	257011
9291	8312	68	applied	\N	\N	\N	\N	89129	89129	257012
9291	8313	69	applied	\N	\N	\N	\N	89130	89130	257013
9291	8314	70	applied	\N	\N	\N	\N	89131	89131	257014
9291	8315	71	applied	\N	\N	\N	\N	89132	89132	257015
9291	8317	72	applied	\N	\N	\N	\N	89133	89133	257016
9291	8318	73	applied	\N	\N	\N	\N	89134	89134	257017
9291	8319	74	applied	\N	\N	\N	\N	89135	89135	257018
9291	8320	75	applied	\N	\N	\N	\N	89136	89136	257019
9291	8321	76	applied	\N	\N	\N	\N	89137	89137	257020
9291	8322	77	applied	\N	\N	\N	\N	89138	89138	257021
9291	8323	78	applied	\N	\N	\N	\N	89139	89139	257022
9291	8324	79	applied	\N	\N	\N	\N	89140	89140	257023
9291	8326	81	applied	\N	\N	\N	\N	89142	89142	257025
9291	8331	82	applied	\N	\N	\N	\N	89143	89143	257026
9291	8332	83	applied	\N	\N	\N	\N	89144	89144	257027
9291	8333	84	applied	\N	\N	\N	\N	89145	89145	257028
9291	8334	85	applied	\N	\N	\N	\N	89146	89146	257029
9291	8335	86	applied	\N	\N	\N	\N	89147	89147	257030
9291	7907	87	applied	\N	\N	\N	\N	89148	89148	257031
9291	7908	88	applied	\N	\N	\N	\N	89149	89149	257032
9291	7912	89	applied	\N	\N	\N	\N	89150	89150	257033
9291	7913	90	applied	\N	\N	\N	\N	89151	89151	257034
9291	7914	91	applied	\N	\N	\N	\N	89152	89152	257035
9291	7916	92	applied	\N	\N	\N	\N	89153	89153	257036
9291	7917	93	applied	\N	\N	\N	\N	89154	89154	257037
9291	7918	94	applied	\N	\N	\N	\N	89155	89155	257038
9291	7919	95	applied	\N	\N	\N	\N	89156	89156	257039
9291	7928	96	applied	\N	\N	\N	\N	89157	89157	257040
9291	7931	98	applied	\N	\N	\N	\N	89159	89159	257042
9291	7934	99	applied	\N	\N	\N	\N	89160	89160	257043
9291	7936	100	applied	\N	\N	\N	\N	89161	89161	257044
9291	7939	101	applied	\N	\N	\N	\N	89162	89162	257045
9291	7940	102	applied	\N	\N	\N	\N	89163	89163	257046
9291	7941	103	applied	\N	\N	\N	\N	89164	89164	257047
9291	7946	104	applied	\N	\N	\N	\N	89165	89165	257048
9291	7947	105	applied	\N	\N	\N	\N	89166	89166	257049
9291	7950	106	applied	\N	\N	\N	\N	89167	89167	257050
9291	7951	107	applied	\N	\N	\N	\N	89168	89168	257051
9291	7954	108	applied	\N	\N	\N	\N	89169	89169	257052
9291	7959	109	applied	\N	\N	\N	\N	89170	89170	257053
9291	7963	110	applied	\N	\N	\N	\N	89171	89171	257054
9291	7964	111	applied	\N	\N	\N	\N	89172	89172	257055
9379	8557	1	applied	\N	\N	\N	\N	89414	89414	257290
9379	8558	2	applied	\N	\N	\N	\N	89415	89415	257291
9384	8520	0	applied	\N	\N	\N	\N	89428	89428	89428
9384	8547	1	applied	\N	\N	1000000000	\N	89429	89429	257304
9384	8482	2	applied	\N	\N	\N	\N	89430	89430	257305
9384	8292	3	applied	\N	\N	\N	\N	89431	89431	257306
9384	8293	4	applied	\N	\N	\N	\N	89432	89432	257307
9384	8294	5	applied	\N	\N	\N	\N	89433	89433	257308
9384	8488	6	applied	\N	\N	\N	\N	89434	89434	257309
9384	8295	7	applied	\N	\N	\N	\N	89435	89435	257310
9384	8296	8	applied	\N	\N	\N	\N	89436	89436	257311
9384	8297	9	applied	\N	\N	\N	\N	89437	89437	257312
9384	8298	10	applied	\N	\N	\N	\N	89438	89438	257313
9384	8299	11	applied	\N	\N	\N	\N	89439	89439	257314
9384	8300	12	applied	\N	\N	\N	\N	89440	89440	257315
9384	8301	13	applied	\N	\N	\N	\N	89441	89441	257316
9384	8302	14	applied	\N	\N	\N	\N	89442	89442	257317
9384	8307	15	applied	\N	\N	\N	\N	89443	89443	257318
9384	8309	17	applied	\N	\N	\N	\N	89445	89445	257320
9384	8311	18	applied	\N	\N	\N	\N	89446	89446	257321
9384	8312	19	applied	\N	\N	\N	\N	89447	89447	257322
9384	8313	20	applied	\N	\N	\N	\N	89448	89448	257323
9384	8314	21	applied	\N	\N	\N	\N	89449	89449	257324
9384	8315	22	applied	\N	\N	\N	\N	89450	89450	257325
9384	8317	23	applied	\N	\N	\N	\N	89451	89451	257326
9384	8318	24	applied	\N	\N	\N	\N	89452	89452	257327
9384	8319	25	applied	\N	\N	\N	\N	89453	89453	257328
9384	8320	26	applied	\N	\N	\N	\N	89454	89454	257329
9384	8321	27	applied	\N	\N	\N	\N	89455	89455	257330
9384	8322	28	applied	\N	\N	\N	\N	89456	89456	257331
9384	8323	29	applied	\N	\N	\N	\N	89457	89457	257332
9384	8324	30	applied	\N	\N	\N	\N	89458	89458	257333
9384	8325	31	applied	\N	\N	\N	\N	89459	89459	257334
9384	8326	32	applied	\N	\N	\N	\N	89460	89460	257335
9384	8332	34	applied	\N	\N	\N	\N	89462	89462	257337
9384	8333	35	applied	\N	\N	\N	\N	89463	89463	257338
9384	8334	36	applied	\N	\N	\N	\N	89464	89464	257339
9384	8335	37	applied	\N	\N	\N	\N	89465	89465	257340
9384	8224	38	applied	\N	\N	\N	\N	89466	89466	257341
9384	8225	39	applied	\N	\N	\N	\N	89467	89467	257342
9384	8226	40	applied	\N	\N	\N	\N	89468	89468	257343
9384	8228	41	applied	\N	\N	\N	\N	89469	89469	257344
9384	8230	42	applied	\N	\N	\N	\N	89470	89470	257345
9384	8232	44	applied	\N	\N	\N	\N	89471	89471	257346
9384	8235	45	applied	\N	\N	\N	\N	89472	89472	257347
9384	8236	46	applied	\N	\N	\N	\N	89473	89473	257348
9384	8238	47	applied	\N	\N	\N	\N	89474	89474	257349
9384	8241	48	applied	\N	\N	\N	\N	89475	89475	257350
9384	8242	49	applied	\N	\N	\N	\N	89476	89476	257351
9384	8245	50	applied	\N	\N	\N	\N	89477	89477	257352
9291	8283	48	applied	\N	\N	\N	\N	89109	89109	256992
9291	7973	116	applied	\N	\N	\N	\N	89177	89177	257060
9291	7974	117	applied	\N	\N	\N	\N	89178	89178	257061
9291	7977	118	applied	\N	\N	\N	\N	89179	89179	257062
9291	7979	119	applied	\N	\N	\N	\N	89180	89180	257063
9291	7981	120	applied	\N	\N	\N	\N	89181	89181	257064
9291	7982	121	applied	\N	\N	\N	\N	89182	89182	257065
9291	7987	122	applied	\N	\N	\N	\N	89183	89183	257066
9291	7989	123	applied	\N	\N	\N	\N	89184	89184	257067
9291	7992	124	applied	\N	\N	\N	\N	89185	89185	257068
9291	7997	125	applied	\N	\N	\N	\N	89186	89186	257069
9293	8425	0	applied	\N	\N	\N	\N	89191	89191	257074
9293	8426	1	applied	\N	\N	\N	\N	89192	89192	257075
9293	8427	2	applied	\N	\N	\N	\N	89193	89193	257076
9295	8428	0	applied	\N	\N	\N	\N	89196	89196	257079
9296	8430	0	applied	\N	\N	\N	\N	89198	89198	257081
9296	8431	1	applied	\N	\N	\N	\N	89199	89199	257082
9298	8434	0	applied	\N	\N	\N	\N	89202	89202	257085
9298	8435	1	applied	\N	\N	\N	\N	89203	89203	257086
9299	8434	0	applied	\N	\N	\N	\N	89204	89204	257087
9299	8435	1	applied	\N	\N	\N	\N	89205	89205	257088
9300	8436	0	applied	\N	\N	\N	\N	89206	89206	257089
9300	8437	1	applied	\N	\N	\N	\N	89207	89207	257090
9301	8438	0	applied	\N	\N	\N	\N	89208	89208	257091
9301	8439	1	applied	\N	\N	\N	\N	89209	89209	257092
9301	8440	2	applied	\N	\N	\N	\N	89210	89210	257093
9301	8441	3	applied	\N	\N	\N	\N	89211	89211	257094
9301	8442	4	applied	\N	\N	\N	\N	89212	89212	257095
9301	8443	5	applied	\N	\N	\N	\N	89213	89213	257096
9304	8446	0	applied	\N	\N	\N	\N	89218	89218	257101
9304	8447	1	applied	\N	\N	\N	\N	89219	89219	257102
9304	8449	3	applied	\N	\N	\N	\N	89221	89221	257104
9304	8450	4	applied	\N	\N	\N	\N	89222	89222	257105
9304	8451	5	applied	\N	\N	\N	\N	89223	89223	257106
9304	8452	6	applied	\N	\N	\N	\N	89224	89224	257107
9304	8453	7	applied	\N	\N	\N	\N	89225	89225	257108
9305	8446	0	applied	\N	\N	\N	\N	89226	89226	257109
9305	8447	1	applied	\N	\N	\N	\N	89227	89227	257110
9305	8448	2	applied	\N	\N	\N	\N	89228	89228	257111
9305	8449	3	applied	\N	\N	\N	\N	89229	89229	257112
9305	8450	4	applied	\N	\N	\N	\N	89230	89230	257113
9305	8451	5	applied	\N	\N	\N	\N	89231	89231	257114
9305	8452	6	applied	\N	\N	\N	\N	89232	89232	257115
9305	8453	7	applied	\N	\N	\N	\N	89233	89233	257116
9307	8454	0	applied	\N	\N	\N	\N	89238	89238	257121
9307	8455	1	applied	\N	\N	\N	\N	89239	89239	257122
9307	8456	2	applied	\N	\N	\N	\N	89240	89240	257123
9309	8458	0	applied	\N	\N	\N	\N	89246	89246	257129
9309	8459	1	applied	\N	\N	\N	\N	89247	89247	257130
9309	8460	2	applied	\N	\N	\N	\N	89248	89248	257131
9309	8461	3	applied	\N	\N	\N	\N	89249	89249	257132
9310	8462	0	applied	\N	\N	\N	\N	89250	89250	257133
9310	8463	1	applied	\N	\N	\N	\N	89251	89251	257134
9310	8464	2	applied	\N	\N	\N	\N	89252	89252	89252
9312	8462	0	applied	\N	\N	\N	\N	89256	89256	257137
9312	8463	1	applied	\N	\N	\N	\N	89257	89257	257138
9312	8464	2	applied	\N	\N	\N	\N	89258	89258	89258
9314	8463	0	applied	\N	\N	\N	\N	89262	89262	257141
9316	8462	0	applied	\N	\N	\N	\N	89267	89267	257145
9316	8465	1	applied	\N	\N	\N	\N	89268	89268	257146
9316	8466	2	applied	\N	\N	\N	\N	89269	89269	257147
9316	8464	3	applied	\N	\N	\N	\N	89270	89270	89270
9318	8467	0	applied	\N	\N	\N	\N	89273	89273	257150
9318	8468	1	applied	\N	\N	\N	\N	89274	89274	257151
9319	8467	0	applied	\N	\N	\N	\N	89275	89275	257152
9321	8468	0	applied	\N	\N	\N	\N	89279	89279	257156
9325	8480	0	applied	\N	\N	\N	\N	89292	89292	257169
9328	8491	0	applied	\N	\N	\N	\N	89303	89303	257180
9328	8492	1	applied	\N	\N	\N	\N	89304	89304	257181
9330	8491	0	applied	\N	\N	\N	\N	89307	89307	257184
9330	8492	1	applied	\N	\N	\N	\N	89308	89308	257185
9332	8495	0	applied	\N	\N	\N	\N	89311	89311	257188
9332	8496	1	applied	\N	\N	\N	\N	89312	89312	257189
9333	8497	0	applied	\N	\N	\N	\N	89313	89313	257190
9333	8498	1	applied	\N	\N	\N	\N	89314	89314	257191
9336	8506	0	applied	\N	\N	\N	\N	89326	89326	257203
9338	8508	0	applied	\N	\N	\N	\N	89333	89333	257210
9338	8509	1	applied	\N	\N	\N	\N	89334	89334	257211
9343	8514	0	applied	\N	\N	\N	\N	89343	89343	257220
9343	8515	1	applied	\N	\N	\N	\N	89344	89344	257221
9347	8518	0	applied	\N	\N	\N	\N	89351	89351	257228
9350	8526	0	applied	\N	\N	\N	\N	89361	89361	257237
9350	8527	1	applied	\N	\N	\N	\N	89362	89362	257238
9352	8528	0	applied	\N	\N	\N	\N	89365	89365	257241
9352	8529	1	applied	\N	\N	\N	\N	89366	89366	257242
9363	8535	0	applied	\N	\N	\N	\N	89376	89376	257252
9363	8536	1	applied	\N	\N	\N	\N	89377	89377	257253
9368	8539	0	applied	\N	\N	\N	\N	89386	89386	257262
9368	8540	1	applied	\N	\N	\N	\N	89387	89387	257263
9370	8543	0	applied	\N	\N	\N	\N	89390	89390	257266
9370	8544	1	applied	\N	\N	\N	\N	89391	89391	257267
9377	8554	0	applied	\N	\N	\N	\N	89409	89409	257285
9377	8555	1	applied	\N	\N	\N	\N	89410	89410	257286
9380	8556	0	applied	\N	\N	\N	\N	89417	89417	257293
9380	8557	1	applied	\N	\N	\N	\N	89418	89418	257294
9380	8558	2	applied	\N	\N	\N	\N	89419	89419	257295
9380	8559	4	applied	\N	\N	\N	\N	89420	89420	257296
9386	8562	0	applied	\N	\N	\N	\N	89555	89555	257430
9386	8563	1	applied	\N	\N	\N	\N	89556	89556	257431
9389	8566	0	applied	\N	\N	\N	\N	89561	89561	257436
9389	8567	1	applied	\N	\N	\N	\N	89562	89562	257437
9389	8568	2	applied	\N	\N	\N	\N	89563	89563	257438
9389	8569	3	applied	\N	\N	\N	\N	89564	89564	257439
9392	8577	0	applied	\N	\N	\N	\N	89572	89572	257447
9392	8578	1	applied	\N	\N	\N	\N	89573	89573	257448
9392	8579	2	applied	\N	\N	\N	\N	89574	89574	257449
9392	8580	3	applied	\N	\N	\N	\N	89575	89575	257450
9394	8577	0	applied	\N	\N	\N	\N	89580	89580	257455
9394	8578	1	applied	\N	\N	\N	\N	89581	89581	257456
9394	8579	2	applied	\N	\N	\N	\N	89582	89582	257457
9394	8580	3	applied	\N	\N	\N	\N	89583	89583	257458
9291	7968	114	applied	\N	\N	\N	\N	89175	89175	257058
9291	7972	115	applied	\N	\N	\N	\N	89176	89176	257059
9336	8507	4	applied	\N	\N	\N	\N	89330	89330	257207
9341	8512	0	applied	\N	\N	\N	\N	89339	89339	257216
9341	8513	1	applied	\N	\N	\N	\N	89340	89340	257217
9345	8516	0	applied	\N	\N	\N	\N	89347	89347	257224
9345	8517	1	applied	\N	\N	\N	\N	89348	89348	257225
9348	8519	1	applied	\N	\N	\N	\N	89354	89354	257231
9353	8528	0	applied	\N	\N	\N	\N	89367	89367	257243
9353	8529	1	applied	\N	\N	\N	\N	89368	89368	257244
9355	8532	0	applied	\N	\N	\N	\N	89371	89371	257247
9355	8533	1	applied	\N	\N	\N	\N	89372	89372	257248
9356	8532	0	applied	\N	\N	\N	\N	89373	89373	257249
9356	8533	1	applied	\N	\N	\N	\N	89374	89374	257250
9364	8537	0	applied	\N	\N	\N	\N	89378	89378	257254
9364	8538	1	applied	\N	\N	\N	\N	89379	89379	257255
9371	8545	0	applied	\N	\N	\N	\N	89392	89392	257268
9371	8546	1	applied	\N	\N	\N	\N	89393	89393	257269
9373	8547	0	applied	\N	\N	1000000000	\N	89396	89396	257272
9373	8549	1	applied	\N	\N	\N	\N	89397	89397	257273
9373	8550	2	applied	\N	\N	\N	\N	89398	89398	257274
9373	8548	3	applied	\N	\N	\N	\N	89399	89399	257275
9376	8551	0	applied	\N	\N	\N	\N	89406	89406	257282
9376	8553	2	applied	\N	\N	\N	\N	89408	89408	257284
9378	8554	0	applied	\N	\N	\N	\N	89411	89411	257287
9378	8555	1	applied	\N	\N	\N	\N	89412	89412	257288
9387	8564	0	applied	\N	\N	\N	\N	89557	89557	257432
9387	8565	1	applied	\N	\N	\N	\N	89558	89558	257433
9393	8577	0	applied	\N	\N	\N	\N	89576	89576	257451
9393	8578	1	applied	\N	\N	\N	\N	89577	89577	257452
9393	8579	2	applied	\N	\N	\N	\N	89578	89578	257453
9393	8580	3	applied	\N	\N	\N	\N	89579	89579	257454
9395	8581	0	applied	\N	\N	\N	\N	89584	89584	257459
9395	8582	1	applied	\N	\N	\N	\N	89585	89585	257460
9395	8583	2	applied	\N	\N	\N	\N	89586	89586	257461
9395	8584	3	applied	\N	\N	\N	\N	89587	89587	257462
9398	8592	0	applied	\N	\N	\N	\N	89597	89597	257472
9398	8593	1	applied	\N	\N	\N	\N	89598	89598	257473
9400	8594	0	applied	\N	\N	\N	\N	89601	89601	257476
9400	8596	2	applied	\N	\N	\N	\N	89603	89603	257478
9400	8597	3	applied	\N	\N	\N	\N	89604	89604	257479
9406	8610	0	applied	\N	\N	\N	\N	89627	89627	257502
9406	8611	1	applied	\N	\N	\N	\N	89628	89628	257503
9408	8614	0	applied	\N	\N	\N	\N	89631	89631	257506
9408	8615	1	applied	\N	\N	\N	\N	89632	89632	257507
9409	8616	0	applied	\N	\N	\N	\N	89633	89633	257508
9409	8617	1	applied	\N	\N	\N	\N	89634	89634	257509
9409	8618	2	applied	\N	\N	\N	\N	89635	89635	257510
9409	8619	3	applied	\N	\N	\N	\N	89636	89636	257511
9409	8620	4	applied	\N	\N	\N	\N	89637	89637	257512
9409	8621	5	applied	\N	\N	\N	\N	89638	89638	257513
9409	8622	6	applied	\N	\N	\N	\N	89639	89639	257514
9409	8623	7	applied	\N	\N	\N	\N	89640	89640	257515
9412	8624	0	applied	\N	\N	\N	\N	89645	89645	257520
9412	8625	1	applied	\N	\N	\N	\N	89646	89646	257521
9413	8625	1	applied	\N	\N	\N	\N	89648	89648	257523
9414	8626	0	applied	\N	\N	\N	\N	89649	89649	257524
9414	8627	1	applied	\N	\N	\N	\N	89650	89650	257525
9424	8638	0	applied	\N	\N	\N	\N	89669	89669	257544
9424	8639	1	applied	\N	\N	\N	\N	89670	89670	257545
9425	8640	0	applied	\N	\N	\N	\N	89671	89671	257546
9425	8641	1	applied	\N	\N	\N	\N	89672	89672	257547
9425	8642	2	applied	\N	\N	\N	\N	89673	89673	257548
9425	8643	3	applied	\N	\N	\N	\N	89674	89674	257549
9427	8648	0	applied	\N	\N	\N	\N	89679	89679	257554
9429	8648	0	applied	\N	\N	\N	\N	89682	89682	257557
9432	8652	0	applied	\N	\N	\N	\N	89689	89689	257564
9432	8653	1	applied	\N	\N	1000000000	\N	89690	89690	257565
9435	8652	0	applied	\N	\N	\N	\N	89695	89695	257570
9436	8649	0	applied	\N	\N	\N	\N	89697	89697	257572
9436	8648	1	applied	\N	\N	\N	\N	89698	89698	257573
9440	8657	0	applied	\N	\N	\N	\N	89729	89729	257603
9440	8658	1	applied	\N	\N	\N	\N	89730	89730	257604
9442	8663	0	applied	\N	\N	\N	\N	89735	89735	257609
9442	8664	1	applied	\N	\N	\N	\N	89736	89736	257610
9443	8663	0	applied	\N	\N	\N	\N	89737	89737	257611
9443	8664	1	applied	\N	\N	\N	\N	89738	89738	257612
9445	8665	0	applied	\N	\N	\N	\N	89743	89743	257617
9445	8666	1	applied	\N	\N	\N	\N	89744	89744	257618
9445	8667	2	applied	\N	\N	\N	\N	89745	89745	257619
9445	8668	3	applied	\N	\N	\N	\N	89746	89746	257620
9447	8669	0	applied	\N	\N	\N	\N	89749	89749	257623
9447	8670	1	applied	\N	\N	\N	\N	89750	89750	257624
9450	8673	0	applied	\N	\N	\N	\N	89755	89755	257629
9450	8674	1	applied	\N	\N	\N	\N	89756	89756	257630
9453	8675	0	applied	\N	\N	\N	\N	89767	89767	257641
9453	8676	1	applied	\N	\N	\N	\N	89768	89768	257642
9453	8677	2	applied	\N	\N	\N	\N	89769	89769	257643
9453	8678	3	applied	\N	\N	\N	\N	89770	89770	257644
9454	8680	0	applied	\N	\N	\N	\N	89772	89772	257646
9454	8681	1	applied	\N	\N	\N	\N	89773	89773	257647
9457	8680	0	applied	\N	\N	\N	\N	89776	89776	257650
9457	8681	1	applied	\N	\N	\N	\N	89777	89777	257651
9459	8682	0	applied	\N	\N	\N	\N	89780	89780	257654
9459	8683	1	applied	\N	\N	\N	\N	89781	89781	257655
9461	8684	0	applied	\N	\N	\N	\N	89784	89784	257658
9461	8685	1	applied	\N	\N	\N	\N	89785	89785	257659
9465	8687	0	applied	\N	\N	\N	\N	89791	89791	257665
9465	8688	1	applied	\N	\N	\N	\N	89792	89792	257666
9465	8689	2	applied	\N	\N	\N	\N	89793	89793	257667
9466	8690	0	applied	\N	\N	\N	\N	89794	89794	257668
9466	8691	1	applied	\N	\N	\N	\N	89795	89795	257669
9472	8703	0	applied	\N	\N	1000000000	\N	89839	89839	257713
9472	8704	1	applied	\N	\N	\N	\N	89840	89840	257714
9472	8705	2	applied	\N	\N	\N	\N	89841	89841	257715
9476	8713	1	applied	\N	\N	\N	\N	89975	89975	257848
9478	8714	0	applied	\N	\N	1000000000	\N	89978	89978	257851
9478	8715	1	applied	\N	\N	1000000000	\N	89979	89979	257852
9478	8716	3	applied	\N	\N	\N	\N	89980	89980	257853
9478	8717	4	applied	\N	\N	\N	\N	89981	89981	257854
9483	8720	0	applied	\N	\N	\N	\N	89990	89990	257863
9336	8504	2	applied	\N	\N	\N	\N	89328	89328	257205
9336	8505	3	applied	\N	\N	\N	\N	89329	89329	257206
9369	8541	0	applied	\N	\N	\N	\N	89388	89388	257264
9369	8542	1	applied	\N	\N	\N	\N	89389	89389	257265
9374	8551	0	applied	\N	\N	\N	\N	89400	89400	257276
9374	8552	1	applied	\N	\N	\N	\N	89401	89401	257277
9374	8553	2	applied	\N	\N	\N	\N	89402	89402	257278
9381	8556	0	applied	\N	\N	\N	\N	89421	89421	257297
9381	8557	1	applied	\N	\N	\N	\N	89422	89422	257298
9381	8558	2	applied	\N	\N	\N	\N	89423	89423	257299
9381	8559	4	applied	\N	\N	\N	\N	89424	89424	257300
9383	8561	0	applied	\N	\N	\N	\N	89426	89426	257302
9383	8560	1	applied	\N	\N	\N	\N	89427	89427	257303
9385	8562	0	applied	\N	\N	\N	\N	89553	89553	257428
9385	8563	1	applied	\N	\N	\N	\N	89554	89554	257429
9388	8565	1	applied	\N	\N	\N	\N	89560	89560	257435
9390	8570	0	applied	\N	\N	\N	\N	89565	89565	257440
9390	8571	1	applied	\N	\N	\N	\N	89566	89566	257441
9390	8572	2	applied	\N	\N	\N	\N	89567	89567	257442
9396	8585	0	applied	\N	\N	\N	\N	89588	89588	257463
9396	8586	1	applied	\N	\N	\N	\N	89589	89589	257464
9396	8587	2	applied	\N	\N	1000000000	\N	89590	89590	257465
9396	8588	3	applied	\N	\N	\N	\N	89591	89591	257466
9396	8589	4	applied	\N	\N	\N	\N	89592	89592	257467
9396	8590	5	applied	\N	\N	\N	\N	89593	89593	257468
9396	8591	6	applied	\N	\N	\N	\N	89594	89594	257469
9401	8594	0	applied	\N	\N	\N	\N	89605	89605	257480
9401	8595	1	applied	\N	\N	\N	\N	89606	89606	257481
9401	8596	2	applied	\N	\N	\N	\N	89607	89607	257482
9401	8597	3	applied	\N	\N	\N	\N	89608	89608	257483
9403	8598	0	applied	\N	\N	\N	\N	89613	89613	257488
9404	8600	0	applied	\N	\N	1000000000	\N	89615	89615	257490
9404	8601	1	applied	\N	\N	\N	\N	89616	89616	257491
9404	8602	2	applied	\N	\N	\N	\N	89617	89617	257492
9404	8603	3	applied	\N	\N	\N	\N	89618	89618	257493
9404	8604	4	applied	\N	\N	\N	\N	89619	89619	257494
9404	8605	5	applied	\N	\N	\N	\N	89620	89620	257495
9404	8606	6	applied	\N	\N	\N	\N	89621	89621	257496
9404	8607	7	applied	\N	\N	\N	\N	89622	89622	257497
9404	8608	8	applied	\N	\N	\N	\N	89623	89623	257498
9404	8609	9	applied	\N	\N	\N	\N	89624	89624	257499
9410	8624	0	applied	\N	\N	\N	\N	89641	89641	257516
9410	8625	1	applied	\N	\N	\N	\N	89642	89642	257517
9415	8628	0	applied	\N	\N	\N	\N	89651	89651	257526
9415	8629	1	applied	\N	\N	\N	\N	89652	89652	257527
9415	8630	2	applied	\N	\N	\N	\N	89653	89653	257528
9415	8631	3	applied	\N	\N	\N	\N	89654	89654	257529
9416	8633	1	applied	\N	\N	\N	\N	89656	89656	257531
9416	8634	2	applied	\N	\N	\N	\N	89657	89657	257532
9416	8635	3	applied	\N	\N	\N	\N	89658	89658	257533
9417	8632	0	applied	\N	\N	\N	\N	89659	89659	257534
9417	8633	1	applied	\N	\N	\N	\N	89660	89660	257535
9417	8634	2	applied	\N	\N	\N	\N	89661	89661	257536
9417	8635	3	applied	\N	\N	\N	\N	89662	89662	257537
9420	8636	0	applied	\N	\N	\N	\N	89667	89667	257542
9420	8637	1	applied	\N	\N	\N	\N	89668	89668	257543
9426	8644	0	applied	\N	\N	\N	\N	89675	89675	257550
9426	8645	1	applied	\N	\N	\N	\N	89676	89676	257551
9426	8646	2	applied	\N	\N	\N	\N	89677	89677	257552
9426	8647	3	applied	\N	\N	\N	\N	89678	89678	257553
9428	8649	0	applied	\N	\N	\N	\N	89680	89680	257555
9428	8648	1	applied	\N	\N	\N	\N	89681	89681	257556
9466	8692	2	applied	\N	\N	\N	\N	89796	89796	257670
9469	8696	0	applied	\N	\N	\N	\N	89827	89827	257701
9469	8697	1	applied	\N	\N	\N	\N	89828	89828	257702
9469	8698	2	applied	\N	\N	\N	\N	89829	89829	257703
9469	8699	3	applied	\N	\N	\N	\N	89830	89830	257704
9469	8700	4	applied	\N	\N	\N	\N	89831	89831	257705
9469	8701	5	applied	\N	\N	\N	\N	89832	89832	257706
9469	8702	6	applied	\N	\N	\N	\N	89833	89833	257707
9477	8712	0	applied	\N	\N	\N	\N	89976	89976	257849
9477	8713	1	applied	\N	\N	\N	\N	89977	89977	257850
9479	8718	0	applied	\N	\N	\N	\N	89982	89982	257855
9479	8719	1	applied	\N	\N	\N	\N	89983	89983	257856
9484	8722	0	applied	\N	\N	\N	\N	89992	89992	257865
9484	8723	1	applied	\N	\N	\N	\N	89993	89993	257866
9484	8724	2	applied	\N	\N	\N	\N	89994	89994	257867
9484	8725	3	applied	\N	\N	\N	\N	89995	89995	257868
9484	8726	4	applied	\N	\N	\N	\N	89996	89996	257869
9484	8728	6	applied	\N	\N	\N	\N	89998	89998	257871
9486	8729	0	applied	\N	\N	\N	\N	90006	90006	257879
9486	8730	1	applied	\N	\N	\N	\N	90007	90007	257880
9489	8735	0	applied	\N	\N	\N	\N	90012	90012	257885
9489	8736	1	applied	\N	\N	\N	\N	90013	90013	257886
9491	8737	0	applied	\N	\N	\N	\N	90016	90016	257889
9491	8738	1	applied	\N	\N	\N	\N	90017	90017	257890
9497	8747	0	applied	\N	\N	\N	\N	90035	90035	257908
9497	8748	1	applied	\N	\N	\N	\N	90036	90036	257909
9504	8755	0	applied	\N	\N	\N	\N	90053	90053	257926
9504	8756	1	applied	\N	\N	\N	\N	90054	90054	257927
9504	8757	2	applied	\N	\N	\N	\N	90055	90055	257928
9510	8762	0	applied	\N	\N	\N	\N	90068	90068	257941
9510	8763	1	applied	\N	\N	\N	\N	90069	90069	257942
9510	8764	2	applied	\N	\N	\N	\N	90070	90070	257943
9517	8769	0	applied	\N	\N	\N	\N	90085	90085	257958
9519	8771	0	applied	\N	\N	\N	\N	90089	90089	257962
9519	8772	1	applied	\N	\N	\N	\N	90090	90090	257963
9524	8779	0	applied	\N	\N	\N	\N	90115	90115	257988
9524	8780	1	applied	\N	\N	\N	\N	90116	90116	257989
9524	8781	2	applied	\N	\N	\N	\N	90117	90117	257990
9524	8782	3	applied	\N	\N	\N	\N	90118	90118	257991
9524	8783	4	applied	\N	\N	\N	\N	90119	90119	257992
9529	8791	0	applied	\N	\N	\N	\N	90132	90132	258005
9529	8792	1	applied	\N	\N	\N	\N	90133	90133	258006
9529	8793	2	applied	\N	\N	\N	\N	90134	90134	258007
9529	8794	3	applied	\N	\N	\N	\N	90135	90135	258008
9529	8795	4	applied	\N	\N	\N	\N	90136	90136	258009
9534	8801	0	applied	\N	\N	\N	\N	90154	90154	258027
9534	8802	1	applied	\N	\N	\N	\N	90155	90155	258028
9536	8803	0	applied	\N	\N	\N	\N	90158	90158	258031
9536	8804	1	applied	\N	\N	\N	\N	90159	90159	258032
9365	8537	0	applied	\N	\N	\N	\N	89380	89380	257256
9365	8538	1	applied	\N	\N	\N	\N	89381	89381	257257
9384	8340	54	applied	\N	\N	\N	\N	89481	89481	257356
9384	8341	55	applied	\N	\N	\N	\N	89482	89482	257357
9384	8342	56	applied	\N	\N	\N	\N	89483	89483	257358
9384	8343	57	applied	\N	\N	\N	\N	89484	89484	257359
9384	8344	58	applied	\N	\N	\N	\N	89485	89485	257360
9384	8346	60	applied	\N	\N	\N	\N	89487	89487	257362
9384	8348	61	applied	\N	\N	\N	\N	89488	89488	257363
9384	8349	62	applied	\N	\N	\N	\N	89489	89489	257364
9384	8350	63	applied	\N	\N	\N	\N	89490	89490	257365
9384	8353	64	applied	\N	\N	\N	\N	89491	89491	257366
9384	8355	65	applied	\N	\N	\N	\N	89492	89492	257367
9384	8356	66	applied	\N	\N	\N	\N	89493	89493	257368
9384	8357	67	applied	\N	\N	\N	\N	89494	89494	257369
9384	8358	68	applied	\N	\N	\N	\N	89495	89495	257370
9384	8359	69	applied	\N	\N	\N	\N	89496	89496	257371
9384	8362	70	applied	\N	\N	\N	\N	89497	89497	257372
9384	8365	71	applied	\N	\N	\N	\N	89498	89498	257373
9384	8366	72	applied	\N	\N	\N	\N	89499	89499	257374
9384	8367	73	applied	\N	\N	\N	\N	89500	89500	257375
9384	8368	74	applied	\N	\N	\N	\N	89501	89501	257376
9384	8369	75	applied	\N	\N	\N	\N	89502	89502	257377
9384	8371	77	applied	\N	\N	\N	\N	89504	89504	257379
9384	8372	78	applied	\N	\N	\N	\N	89505	89505	257380
9384	8373	79	applied	\N	\N	\N	\N	89506	89506	257381
9384	8374	80	applied	\N	\N	\N	\N	89507	89507	257382
9384	8376	81	applied	\N	\N	\N	\N	89508	89508	257383
9384	8378	82	applied	\N	\N	\N	\N	89509	89509	257384
9384	8379	83	applied	\N	\N	\N	\N	89510	89510	257385
9384	8380	84	applied	\N	\N	\N	\N	89511	89511	257386
9384	8381	85	applied	\N	\N	\N	\N	89512	89512	257387
9384	8382	86	applied	\N	\N	\N	\N	89513	89513	257388
9384	8384	87	applied	\N	\N	\N	\N	89514	89514	257389
9384	8385	88	applied	\N	\N	\N	\N	89515	89515	257390
9384	8388	89	applied	\N	\N	\N	\N	89516	89516	257391
9384	8390	90	applied	\N	\N	\N	\N	89517	89517	257392
9384	8392	91	applied	\N	\N	\N	\N	89518	89518	257393
9384	8393	92	applied	\N	\N	\N	\N	89519	89519	257394
9384	8211	94	applied	\N	\N	\N	\N	89521	89521	257396
9384	8212	95	applied	\N	\N	\N	\N	89522	89522	257397
9384	8213	96	applied	\N	\N	\N	\N	89523	89523	257398
9384	8216	97	applied	\N	\N	\N	\N	89524	89524	257399
9384	8217	98	applied	\N	\N	\N	\N	89525	89525	257400
9384	8218	99	applied	\N	\N	\N	\N	89526	89526	257401
9384	8220	100	applied	\N	\N	\N	\N	89527	89527	257402
9384	8222	101	applied	\N	\N	1000000000	\N	89528	89528	257403
9384	8223	102	applied	\N	\N	\N	\N	89529	89529	257404
9384	8227	103	applied	\N	\N	\N	\N	89530	89530	257405
9384	8229	104	applied	\N	\N	\N	\N	89531	89531	257406
9384	8231	105	applied	\N	\N	\N	\N	89532	89532	257407
9384	8233	106	applied	\N	\N	\N	\N	89533	89533	257408
9384	8234	107	applied	\N	\N	\N	\N	89534	89534	257409
9384	8237	108	applied	\N	\N	\N	\N	89535	89535	257410
9384	8239	109	applied	\N	\N	\N	\N	89536	89536	257411
9384	8243	111	applied	\N	\N	\N	\N	89538	89538	257413
9384	8244	112	applied	\N	\N	\N	\N	89539	89539	257414
9384	8246	113	applied	\N	\N	\N	\N	89540	89540	257415
9384	8249	114	applied	\N	\N	\N	\N	89541	89541	257416
9384	8251	115	applied	\N	\N	\N	\N	89542	89542	257417
9384	8260	116	applied	\N	\N	\N	\N	89543	89543	257418
9430	8649	0	applied	\N	\N	\N	\N	89683	89683	257558
9430	8650	1	applied	\N	\N	\N	\N	89684	89684	257559
9430	8651	2	applied	\N	\N	\N	\N	89685	89685	257560
9430	8648	3	applied	\N	\N	\N	\N	89686	89686	257561
9433	8652	0	applied	\N	\N	\N	\N	89691	89691	257566
9433	8653	1	applied	\N	\N	1000000000	\N	89692	89692	257567
9438	8520	0	applied	\N	\N	\N	\N	89702	89702	89702
9438	7969	1	applied	\N	\N	\N	\N	89703	89703	257577
9438	7956	2	applied	\N	\N	\N	\N	89704	89704	257578
9438	7813	4	applied	\N	\N	\N	\N	89706	89706	257580
9438	7815	5	applied	\N	\N	\N	\N	89707	89707	257581
9438	7999	6	applied	\N	\N	\N	\N	89708	89708	257582
9438	7980	7	applied	\N	\N	\N	\N	89709	89709	257583
9438	8585	8	applied	\N	\N	\N	\N	89710	89710	257584
9438	7949	9	applied	\N	\N	1000000000	\N	89711	89711	257585
9438	7814	10	applied	\N	\N	\N	\N	89712	89712	257586
9438	7816	11	applied	\N	\N	\N	\N	89713	89713	257587
9438	8159	12	applied	\N	\N	\N	\N	89714	89714	257588
9438	7817	13	applied	\N	\N	\N	\N	89715	89715	257589
9438	7819	14	applied	\N	\N	\N	\N	89716	89716	257590
9438	7822	15	applied	\N	\N	\N	\N	89717	89717	257591
9438	8649	16	applied	\N	\N	\N	\N	89718	89718	257592
9438	8603	17	applied	\N	\N	\N	\N	89719	89719	257593
9438	8572	18	applied	\N	\N	\N	\N	89720	89720	257594
9438	7891	19	applied	\N	\N	\N	\N	89721	89721	257595
9438	7915	21	applied	\N	\N	\N	\N	89722	89722	257596
9438	8163	22	applied	\N	\N	\N	\N	89723	89723	257597
9438	8248	23	applied	\N	\N	\N	\N	89724	89724	257598
9438	7990	25	applied	\N	\N	1000000000	\N	89726	89726	257600
9441	8659	0	applied	\N	\N	\N	\N	89731	89731	257605
9441	8660	1	applied	\N	\N	\N	\N	89732	89732	257606
9441	8661	2	applied	\N	\N	\N	\N	89733	89733	257607
9441	8662	3	applied	\N	\N	\N	\N	89734	89734	257608
9446	8669	0	applied	\N	\N	\N	\N	89747	89747	257621
9446	8670	1	applied	\N	\N	\N	\N	89748	89748	257622
9448	8671	0	applied	\N	\N	\N	\N	89751	89751	257625
9448	8672	1	applied	\N	\N	\N	\N	89752	89752	257626
9451	8675	0	applied	\N	\N	\N	\N	89757	89757	257631
9451	8676	1	applied	\N	\N	\N	\N	89758	89758	257632
9451	8677	2	applied	\N	\N	\N	\N	89759	89759	257633
9451	8678	3	applied	\N	\N	\N	\N	89760	89760	257634
9451	8679	4	applied	\N	\N	\N	\N	89761	89761	257635
9455	8680	0	applied	\N	\N	\N	\N	89774	89774	257648
9455	8681	1	applied	\N	\N	\N	\N	89775	89775	257649
9464	8674	0	applied	\N	\N	\N	\N	89789	89789	257663
9464	8679	1	applied	\N	\N	\N	\N	89790	89790	257664
9467	8694	0	applied	\N	\N	\N	\N	89798	89798	257672
9467	8695	1	applied	\N	\N	\N	\N	89799	89799	257673
9470	8703	0	applied	\N	\N	1000000000	\N	89834	89834	257708
9470	8704	1	applied	\N	\N	\N	\N	89835	89835	257709
9384	8338	52	applied	\N	\N	\N	\N	89479	89479	257354
9384	8339	53	applied	\N	\N	\N	\N	89480	89480	257355
9384	8287	120	applied	\N	\N	\N	\N	89547	89547	257422
9384	8288	121	applied	\N	\N	\N	\N	89548	89548	257423
9384	8304	122	applied	\N	\N	\N	\N	89549	89549	257424
9384	8310	123	applied	\N	\N	\N	\N	89550	89550	257425
9384	8316	124	applied	\N	\N	\N	\N	89551	89551	257426
9384	8330	125	applied	\N	\N	\N	\N	89552	89552	257427
9391	8573	0	applied	\N	\N	\N	\N	89568	89568	257443
9391	8574	1	applied	\N	\N	\N	\N	89569	89569	257444
9391	8575	2	applied	\N	\N	\N	\N	89570	89570	257445
9397	8592	0	applied	\N	\N	\N	\N	89595	89595	257470
9397	8593	1	applied	\N	\N	\N	\N	89596	89596	257471
9399	8592	0	applied	\N	\N	\N	\N	89599	89599	257474
9399	8593	1	applied	\N	\N	\N	\N	89600	89600	257475
9402	8594	0	applied	\N	\N	\N	\N	89609	89609	257484
9402	8595	1	applied	\N	\N	\N	\N	89610	89610	257485
9402	8596	2	applied	\N	\N	\N	\N	89611	89611	257486
9402	8597	3	applied	\N	\N	\N	\N	89612	89612	257487
9405	8610	0	applied	\N	\N	\N	\N	89625	89625	257500
9405	8611	1	applied	\N	\N	\N	\N	89626	89626	257501
9407	8612	0	applied	\N	\N	\N	\N	89629	89629	257504
9407	8613	1	applied	\N	\N	\N	\N	89630	89630	257505
9411	8624	0	applied	\N	\N	\N	\N	89643	89643	257518
9411	8625	1	applied	\N	\N	\N	\N	89644	89644	257519
9418	8632	0	applied	\N	\N	\N	\N	89663	89663	257538
9418	8633	1	applied	\N	\N	\N	\N	89664	89664	257539
9418	8635	3	applied	\N	\N	\N	\N	89666	89666	257541
9431	8652	0	applied	\N	\N	\N	\N	89687	89687	257562
9431	8653	1	applied	\N	\N	1000000000	\N	89688	89688	257563
9434	8652	0	applied	\N	\N	\N	\N	89693	89693	257568
9434	8653	1	applied	\N	\N	1000000000	\N	89694	89694	257569
9437	8654	0	applied	\N	\N	\N	\N	89699	89699	257574
9437	8655	1	applied	\N	\N	1000000000	\N	89700	89700	257575
9437	8656	2	applied	\N	\N	\N	\N	89701	89701	257576
9439	8657	0	applied	\N	\N	\N	\N	89727	89727	257601
9439	8658	1	applied	\N	\N	\N	\N	89728	89728	257602
9444	8665	0	applied	\N	\N	\N	\N	89739	89739	257613
9444	8666	1	applied	\N	\N	\N	\N	89740	89740	257614
9444	8667	2	applied	\N	\N	\N	\N	89741	89741	257615
9444	8668	3	applied	\N	\N	\N	\N	89742	89742	257616
9449	8671	0	applied	\N	\N	\N	\N	89753	89753	257627
9449	8672	1	applied	\N	\N	\N	\N	89754	89754	257628
9452	8676	1	applied	\N	\N	\N	\N	89763	89763	257637
9452	8677	2	applied	\N	\N	\N	\N	89764	89764	257638
9452	8678	3	applied	\N	\N	\N	\N	89765	89765	257639
9452	8679	4	applied	\N	\N	\N	\N	89766	89766	257640
9458	8682	0	applied	\N	\N	\N	\N	89778	89778	257652
9458	8683	1	applied	\N	\N	\N	\N	89779	89779	257653
9460	8684	0	applied	\N	\N	\N	\N	89782	89782	257656
9460	8685	1	applied	\N	\N	\N	\N	89783	89783	257657
9463	8687	0	applied	\N	\N	\N	\N	89787	89787	257661
9463	8686	1	applied	\N	\N	\N	\N	89788	89788	257662
9468	8669	0	applied	\N	\N	\N	\N	89800	89800	257674
9468	8671	1	applied	\N	\N	\N	\N	89801	89801	257675
9468	8673	2	applied	\N	\N	\N	\N	89802	89802	257676
9468	8675	3	applied	\N	\N	\N	\N	89803	89803	257677
9468	8678	4	applied	\N	\N	\N	\N	89804	89804	257678
9468	8680	5	applied	\N	\N	\N	\N	89805	89805	257679
9468	8685	7	applied	\N	\N	\N	\N	89807	89807	257681
9468	8686	8	applied	\N	\N	\N	\N	89808	89808	257682
9468	8688	9	applied	\N	\N	\N	\N	89809	89809	257683
9468	8692	10	applied	\N	\N	\N	\N	89810	89810	257684
9468	8693	11	applied	\N	\N	\N	\N	89811	89811	257685
9468	8695	12	applied	\N	\N	\N	\N	89812	89812	257686
9468	8670	13	applied	\N	\N	\N	\N	89813	89813	257687
9468	8672	14	applied	\N	\N	\N	\N	89814	89814	257688
9468	8676	15	applied	\N	\N	\N	\N	89815	89815	257689
9468	8677	16	applied	\N	\N	\N	\N	89816	89816	257690
9468	8681	17	applied	\N	\N	\N	\N	89817	89817	257691
9468	8682	18	applied	\N	\N	\N	\N	89818	89818	257692
9468	8684	19	applied	\N	\N	\N	\N	89819	89819	257693
9468	8687	20	applied	\N	\N	\N	\N	89820	89820	257694
9468	8689	21	applied	\N	\N	\N	\N	89821	89821	257695
9468	8690	22	applied	\N	\N	\N	\N	89822	89822	257696
9468	8694	24	applied	\N	\N	\N	\N	89824	89824	257698
9468	8674	25	applied	\N	\N	\N	\N	89825	89825	257699
9468	8679	26	applied	\N	\N	\N	\N	89826	89826	257700
9471	8703	0	applied	\N	\N	1000000000	\N	89837	89837	257711
9471	8705	1	applied	\N	\N	\N	\N	89838	89838	257712
9475	8708	0	applied	\N	\N	\N	\N	89970	89970	257843
9475	8709	1	applied	\N	\N	\N	\N	89971	89971	257844
9475	8710	2	applied	\N	\N	\N	\N	89972	89972	257845
9475	8711	3	applied	\N	\N	\N	\N	89973	89973	257846
9481	8718	0	applied	\N	\N	\N	\N	89986	89986	257859
9481	8719	1	applied	\N	\N	\N	\N	89987	89987	257860
9482	8720	0	applied	\N	\N	\N	\N	89988	89988	257861
9482	8721	1	applied	\N	\N	\N	\N	89989	89989	257862
9485	8722	0	applied	\N	\N	\N	\N	89999	89999	257872
9485	8723	1	applied	\N	\N	\N	\N	90000	90000	257873
9485	8724	2	applied	\N	\N	\N	\N	90001	90001	257874
9485	8726	4	applied	\N	\N	\N	\N	90003	90003	257876
9485	8727	5	applied	\N	\N	\N	\N	90004	90004	257877
9485	8728	6	applied	\N	\N	\N	\N	90005	90005	257878
9493	8742	0	applied	\N	\N	\N	\N	90021	90021	257894
9493	8743	1	applied	\N	\N	\N	\N	90022	90022	257895
9493	8744	2	applied	\N	\N	\N	\N	90023	90023	257896
9493	8745	3	applied	\N	\N	\N	\N	90024	90024	257897
9493	8746	4	applied	\N	\N	\N	\N	90025	90025	257898
9495	8747	0	applied	\N	\N	\N	\N	90031	90031	257904
9495	8748	1	applied	\N	\N	\N	\N	90032	90032	257905
9498	8747	0	applied	\N	\N	\N	\N	90037	90037	257910
9498	8748	1	applied	\N	\N	\N	\N	90038	90038	257911
9500	8753	0	applied	\N	\N	\N	\N	90043	90043	257916
9500	8754	1	applied	\N	\N	\N	\N	90044	90044	257917
9502	8755	0	applied	\N	\N	\N	\N	90047	90047	257920
9502	8756	1	applied	\N	\N	\N	\N	90048	90048	257921
9514	8765	0	applied	\N	\N	\N	\N	90079	90079	257952
9514	8766	1	applied	\N	\N	\N	\N	90080	90080	257953
9516	8767	0	applied	\N	\N	\N	\N	90083	90083	257956
9516	8768	1	applied	\N	\N	\N	\N	90084	90084	257957
9384	8262	118	applied	\N	\N	\N	\N	89545	89545	257420
9384	8279	119	applied	\N	\N	\N	\N	89546	89546	257421
9473	8547	2	applied	\N	\N	1000000000	\N	89844	89844	257717
9473	8482	3	applied	\N	\N	\N	\N	89845	89845	257718
9473	8585	4	applied	\N	\N	\N	\N	89846	89846	257719
9473	8021	5	applied	\N	\N	\N	\N	89847	89847	257720
9473	8023	6	applied	\N	\N	\N	\N	89848	89848	257721
9473	8159	7	applied	\N	\N	\N	\N	89849	89849	257722
9473	8022	8	applied	\N	\N	\N	\N	89850	89850	257723
9473	8024	9	applied	\N	\N	\N	\N	89851	89851	257724
9473	8649	10	applied	\N	\N	\N	\N	89852	89852	257725
9473	8603	12	applied	\N	\N	\N	\N	89854	89854	257727
9473	8572	13	applied	\N	\N	\N	\N	89855	89855	257728
9473	8163	14	applied	\N	\N	\N	\N	89856	89856	257729
9473	8248	15	applied	\N	\N	\N	\N	89857	89857	257730
9473	8250	16	applied	\N	\N	\N	\N	89858	89858	257731
9473	8025	17	applied	\N	\N	\N	\N	89859	89859	257732
9473	8027	18	applied	\N	\N	\N	\N	89860	89860	257733
9473	8028	19	applied	\N	\N	\N	\N	89861	89861	257734
9473	8031	20	applied	\N	\N	\N	\N	89862	89862	257735
9473	8033	21	applied	\N	\N	\N	\N	89863	89863	257736
9473	8037	22	applied	\N	\N	\N	\N	89864	89864	257737
9473	8038	23	applied	\N	\N	\N	\N	89865	89865	257738
9473	8039	24	applied	\N	\N	\N	\N	89866	89866	257739
9473	8041	25	applied	\N	\N	\N	\N	89867	89867	257740
9473	8042	26	applied	\N	\N	\N	\N	89868	89868	257741
9473	8045	27	applied	\N	\N	\N	\N	89869	89869	257742
9473	8050	29	applied	\N	\N	\N	\N	89871	89871	257744
9473	8051	30	applied	\N	\N	\N	\N	89872	89872	257745
9473	8053	31	applied	\N	\N	\N	\N	89873	89873	257746
9473	8055	32	applied	\N	\N	\N	\N	89874	89874	257747
9473	8057	33	applied	\N	\N	\N	\N	89875	89875	257748
9473	8059	34	applied	\N	\N	\N	\N	89876	89876	257749
9473	8062	35	applied	\N	\N	\N	\N	89877	89877	257750
9473	8063	36	applied	\N	\N	\N	\N	89878	89878	257751
9473	8065	37	applied	\N	\N	\N	\N	89879	89879	257752
9473	8068	38	applied	\N	\N	\N	\N	89880	89880	257753
9473	8069	39	applied	\N	\N	\N	\N	89881	89881	257754
9473	8072	40	applied	\N	\N	\N	\N	89882	89882	257755
9473	8026	41	applied	\N	\N	\N	\N	89883	89883	257756
9473	8029	42	applied	\N	\N	\N	\N	89884	89884	257757
9473	8030	43	applied	\N	\N	\N	\N	89885	89885	257758
9473	8032	44	applied	\N	\N	\N	\N	89886	89886	257759
9473	8035	46	applied	\N	\N	\N	\N	89888	89888	257761
9473	8036	47	applied	\N	\N	\N	\N	89889	89889	257762
9473	8040	48	applied	\N	\N	\N	\N	89890	89890	257763
9473	8164	49	applied	\N	\N	\N	\N	89891	89891	257764
9473	8165	50	applied	\N	\N	\N	\N	89892	89892	257765
9473	8166	51	applied	\N	\N	\N	\N	89893	89893	257766
9473	8168	52	applied	\N	\N	\N	\N	89894	89894	257767
9473	8170	53	applied	\N	\N	\N	\N	89895	89895	257768
9473	8327	54	applied	\N	\N	\N	\N	89896	89896	257769
9473	8043	55	applied	\N	\N	\N	\N	89897	89897	257770
9473	8044	56	applied	\N	\N	\N	\N	89898	89898	257771
9473	8328	57	applied	\N	\N	\N	\N	89899	89899	257772
9473	8075	58	applied	\N	\N	\N	\N	89900	89900	257773
9473	8076	59	applied	\N	\N	\N	\N	89901	89901	257774
9473	8080	60	applied	\N	\N	\N	\N	89902	89902	257775
9473	8081	61	applied	\N	\N	\N	\N	89903	89903	257776
9473	8085	63	applied	\N	\N	\N	\N	89905	89905	257778
9473	8088	64	applied	\N	\N	\N	\N	89906	89906	257779
9521	8773	0	applied	\N	\N	1000000000	\N	90097	90097	257970
9521	8774	1	applied	\N	\N	\N	\N	90098	90098	257971
9521	8775	2	applied	\N	\N	\N	\N	90099	90099	257972
9521	8776	3	applied	\N	\N	\N	\N	90100	90100	257973
9521	8777	4	applied	\N	\N	\N	\N	90101	90101	257974
9521	8778	5	applied	\N	\N	\N	\N	90102	90102	257975
9533	8801	0	applied	\N	\N	\N	\N	90152	90152	258025
9533	8802	1	applied	\N	\N	\N	\N	90153	90153	258026
9540	8811	0	applied	\N	\N	\N	\N	90171	90171	258044
9540	8812	1	applied	\N	\N	\N	\N	90172	90172	258045
9540	8813	2	applied	\N	\N	\N	\N	90173	90173	258046
9540	8814	3	applied	\N	\N	\N	\N	90174	90174	258047
9545	8819	0	applied	\N	\N	\N	\N	90187	90187	258060
9545	8820	1	applied	\N	\N	\N	\N	90188	90188	258061
9550	8828	1	applied	\N	\N	\N	\N	90200	90200	258073
9559	8834	0	applied	\N	\N	\N	\N	90208	90208	258081
9559	8835	1	applied	\N	\N	\N	\N	90209	90209	258082
9559	8836	2	applied	\N	\N	\N	\N	90210	90210	258083
9559	8837	3	applied	\N	\N	\N	\N	90211	90211	258084
9562	8842	0	applied	\N	\N	\N	\N	90216	90216	258089
9562	8843	1	applied	\N	\N	\N	\N	90217	90217	258090
9562	8844	2	applied	\N	\N	\N	\N	90218	90218	258091
9562	8845	3	applied	\N	\N	\N	\N	90219	90219	258092
9565	8846	0	applied	\N	\N	\N	\N	90227	90227	258100
9565	8847	1	applied	\N	\N	\N	\N	90228	90228	258101
9565	8848	2	applied	\N	\N	\N	\N	90229	90229	258102
9567	8849	0	applied	\N	\N	\N	\N	90232	90232	258105
9567	8850	1	applied	\N	\N	\N	\N	90233	90233	258106
9572	8863	0	applied	\N	\N	\N	\N	90257	90257	258130
9572	8864	1	applied	\N	\N	\N	\N	90258	90258	258131
9575	8868	1	applied	\N	\N	\N	\N	90264	90264	258137
9577	8871	0	applied	\N	\N	\N	\N	90267	90267	258140
9577	8872	1	applied	\N	\N	\N	\N	90268	90268	258141
9580	8873	0	applied	\N	\N	1000000000	\N	90273	90273	258146
9580	8874	1	applied	\N	\N	\N	\N	90274	90274	258147
9580	8875	2	applied	\N	\N	\N	\N	90275	90275	258148
9582	8878	0	applied	\N	\N	\N	\N	90278	90278	258151
9582	8879	1	applied	\N	\N	\N	\N	90279	90279	258152
9587	8886	0	applied	\N	\N	\N	\N	90292	90292	258163
9587	8887	1	applied	\N	\N	\N	\N	90293	90293	258164
9596	8896	0	applied	\N	\N	\N	\N	90312	90312	258183
9596	8897	1	applied	\N	\N	\N	\N	90313	90313	258184
9599	8902	0	applied	\N	\N	\N	\N	90322	90322	258193
9599	8903	1	applied	\N	\N	\N	\N	90323	90323	258194
9599	8904	2	applied	\N	\N	\N	\N	90324	90324	258195
9601	8902	0	applied	\N	\N	\N	\N	90328	90328	258199
9601	8904	2	applied	\N	\N	\N	\N	90330	90330	258201
9604	8909	0	applied	\N	\N	\N	\N	90335	90335	258206
9604	8910	1	applied	\N	\N	\N	\N	90336	90336	258207
9604	8911	2	applied	\N	\N	\N	\N	90337	90337	258208
9473	8703	0	applied	\N	\N	1000000000	\N	89842	89842	257716
9473	8520	1	applied	\N	\N	\N	\N	89843	89843	89843
9473	8098	70	applied	\N	\N	\N	\N	89911	89911	257784
9473	8099	71	applied	\N	\N	\N	\N	89912	89912	257785
9473	8100	72	applied	\N	\N	\N	\N	89913	89913	257786
9473	8101	73	applied	\N	\N	\N	\N	89914	89914	257787
9473	8102	74	applied	\N	\N	\N	\N	89915	89915	257788
9473	8046	75	applied	\N	\N	\N	\N	89916	89916	257789
9473	8047	76	applied	\N	\N	\N	\N	89917	89917	257790
9473	8048	77	applied	\N	\N	\N	\N	89918	89918	257791
9473	8109	78	applied	\N	\N	\N	\N	89919	89919	257792
9473	8110	79	applied	\N	\N	\N	\N	89920	89920	257793
9473	8111	80	applied	\N	\N	\N	\N	89921	89921	257794
9473	8114	81	applied	\N	\N	\N	\N	89922	89922	257795
9473	8115	82	applied	\N	\N	\N	\N	89923	89923	257796
9473	8118	83	applied	\N	\N	\N	\N	89924	89924	257797
9473	8122	85	applied	\N	\N	\N	\N	89926	89926	257799
9473	8126	86	applied	\N	\N	\N	\N	89927	89927	257800
9473	8127	87	applied	\N	\N	\N	\N	89928	89928	257801
9473	8132	88	applied	\N	\N	\N	\N	89929	89929	257802
9473	8134	89	applied	\N	\N	\N	\N	89930	89930	257803
9473	8138	90	applied	\N	\N	\N	\N	89931	89931	257804
9473	8139	91	applied	\N	\N	\N	\N	89932	89932	257805
9473	8141	92	applied	\N	\N	\N	\N	89933	89933	257806
9473	8142	93	applied	\N	\N	\N	\N	89934	89934	257807
9473	8144	94	applied	\N	\N	\N	\N	89935	89935	257808
9473	8145	95	applied	\N	\N	\N	\N	89936	89936	257809
9473	8146	96	applied	\N	\N	\N	\N	89937	89937	257810
9473	8150	97	applied	\N	\N	\N	\N	89938	89938	257811
9473	8151	98	applied	\N	\N	\N	\N	89939	89939	257812
9473	8152	99	applied	\N	\N	\N	\N	89940	89940	257813
9473	8157	100	applied	\N	\N	\N	\N	89941	89941	257814
9473	8160	102	applied	\N	\N	\N	\N	89943	89943	257816
9473	8167	103	applied	\N	\N	\N	\N	89944	89944	257817
9473	8171	104	applied	\N	\N	\N	\N	89945	89945	257818
9473	8174	105	applied	\N	\N	\N	\N	89946	89946	257819
9473	8176	106	applied	\N	\N	\N	\N	89947	89947	257820
9473	8177	107	applied	\N	\N	\N	\N	89948	89948	257821
9473	8180	108	applied	\N	\N	\N	\N	89949	89949	257822
9473	8182	109	applied	\N	\N	\N	\N	89950	89950	257823
9473	8183	110	applied	\N	\N	\N	\N	89951	89951	257824
9473	8189	111	applied	\N	\N	\N	\N	89952	89952	257825
9473	8190	112	applied	\N	\N	\N	\N	89953	89953	257826
9473	8191	113	applied	\N	\N	\N	\N	89954	89954	257827
9473	8192	114	applied	\N	\N	\N	\N	89955	89955	257828
9473	8195	115	applied	\N	\N	\N	\N	89956	89956	257829
9473	8197	116	applied	\N	\N	\N	\N	89957	89957	257830
9473	8199	117	applied	\N	\N	\N	\N	89958	89958	257831
9473	8204	119	applied	\N	\N	\N	\N	89960	89960	257833
9473	8206	120	applied	\N	\N	\N	\N	89961	89961	257834
9473	8208	121	applied	\N	\N	\N	\N	89962	89962	257835
9473	8209	122	applied	\N	\N	\N	\N	89963	89963	257836
9473	8210	123	applied	\N	\N	\N	\N	89964	89964	257837
9473	8214	124	applied	\N	\N	\N	\N	89965	89965	257838
9473	8215	125	applied	\N	\N	\N	\N	89966	89966	257839
9474	8706	0	applied	\N	\N	\N	\N	89967	89967	257840
9474	8704	1	applied	\N	\N	\N	\N	89968	89968	257841
9474	8707	2	applied	\N	\N	\N	\N	89969	89969	257842
9480	8718	0	applied	\N	\N	\N	\N	89984	89984	257857
9480	8719	1	applied	\N	\N	\N	\N	89985	89985	257858
9487	8731	0	applied	\N	\N	\N	\N	90008	90008	257881
9487	8732	1	applied	\N	\N	\N	\N	90009	90009	257882
9490	8735	0	applied	\N	\N	\N	\N	90014	90014	257887
9490	8736	1	applied	\N	\N	\N	\N	90015	90015	257888
9492	8740	1	applied	\N	\N	\N	\N	90019	90019	257892
9492	8741	2	applied	\N	\N	\N	\N	90020	90020	257893
9499	8749	0	applied	\N	\N	\N	\N	90039	90039	257912
9499	8750	1	applied	\N	\N	\N	\N	90040	90040	257913
9499	8751	2	applied	\N	\N	\N	\N	90041	90041	257914
9499	8752	3	applied	\N	\N	\N	\N	90042	90042	257915
9505	8755	0	applied	\N	\N	\N	\N	90056	90056	257929
9505	8756	1	applied	\N	\N	\N	\N	90057	90057	257930
9505	8757	2	applied	\N	\N	\N	\N	90058	90058	257931
9508	8758	0	applied	\N	\N	\N	\N	90064	90064	257937
9508	8759	1	applied	\N	\N	\N	\N	90065	90065	257938
9511	8762	0	applied	\N	\N	\N	\N	90071	90071	257944
9511	8763	1	applied	\N	\N	\N	\N	90072	90072	257945
9511	8764	2	applied	\N	\N	\N	\N	90073	90073	257946
9513	8765	0	applied	\N	\N	\N	\N	90077	90077	257950
9513	8766	1	applied	\N	\N	\N	\N	90078	90078	257951
9515	8768	1	applied	\N	\N	\N	\N	90082	90082	257955
9518	8769	0	applied	\N	\N	\N	\N	90087	90087	257960
9518	8770	1	applied	\N	\N	\N	\N	90088	90088	257961
9520	8773	0	applied	\N	\N	1000000000	\N	90091	90091	257964
9520	8774	1	applied	\N	\N	\N	\N	90092	90092	257965
9520	8775	2	applied	\N	\N	\N	\N	90093	90093	257966
9520	8776	3	applied	\N	\N	\N	\N	90094	90094	257967
9520	8777	4	applied	\N	\N	\N	\N	90095	90095	257968
9520	8778	5	applied	\N	\N	\N	\N	90096	90096	257969
9525	8779	0	applied	\N	\N	\N	\N	90120	90120	257993
9525	8780	1	applied	\N	\N	\N	\N	90121	90121	257994
9525	8781	2	applied	\N	\N	\N	\N	90122	90122	257995
9525	8782	3	applied	\N	\N	\N	\N	90123	90123	257996
9525	8783	4	applied	\N	\N	\N	\N	90124	90124	257997
9527	8789	0	applied	\N	\N	\N	\N	90130	90130	258003
9527	8790	1	applied	\N	\N	\N	\N	90131	90131	258004
9530	8792	1	applied	\N	\N	\N	\N	90138	90138	258011
9530	8793	2	applied	\N	\N	\N	\N	90139	90139	258012
9530	8794	3	applied	\N	\N	\N	\N	90140	90140	258013
9530	8795	4	applied	\N	\N	\N	\N	90141	90141	258014
9532	8796	0	applied	\N	\N	\N	\N	90147	90147	258020
9532	8797	1	applied	\N	\N	\N	\N	90148	90148	258021
9532	8798	2	applied	\N	\N	\N	\N	90149	90149	258022
9532	8799	3	applied	\N	\N	\N	\N	90150	90150	258023
9532	8800	4	applied	\N	\N	\N	\N	90151	90151	258024
9535	8801	0	applied	\N	\N	\N	\N	90156	90156	258029
9535	8802	1	applied	\N	\N	\N	\N	90157	90157	258030
9537	8803	0	applied	\N	\N	\N	\N	90161	90161	258034
9537	8804	1	applied	\N	\N	\N	\N	90162	90162	258035
9537	8805	2	applied	\N	\N	\N	\N	90163	90163	258036
9539	8806	0	applied	\N	\N	\N	\N	90166	90166	258039
9539	8807	1	applied	\N	\N	\N	\N	90167	90167	258040
9473	8096	69	applied	\N	\N	\N	\N	89910	89910	257783
9494	8742	0	applied	\N	\N	\N	\N	90026	90026	257899
9494	8743	1	applied	\N	\N	\N	\N	90027	90027	257900
9494	8744	2	applied	\N	\N	\N	\N	90028	90028	257901
9494	8745	3	applied	\N	\N	\N	\N	90029	90029	257902
9494	8746	4	applied	\N	\N	\N	\N	90030	90030	257903
9496	8747	0	applied	\N	\N	\N	\N	90033	90033	257906
9496	8748	1	applied	\N	\N	\N	\N	90034	90034	257907
9501	8753	0	applied	\N	\N	\N	\N	90045	90045	257918
9501	8754	1	applied	\N	\N	\N	\N	90046	90046	257919
9503	8756	1	applied	\N	\N	\N	\N	90051	90051	257924
9503	8757	2	applied	\N	\N	\N	\N	90052	90052	257925
9506	8755	0	applied	\N	\N	\N	\N	90059	90059	257932
9506	8756	1	applied	\N	\N	\N	\N	90060	90060	257933
9506	8757	2	applied	\N	\N	\N	\N	90061	90061	257934
9507	8758	0	applied	\N	\N	\N	\N	90062	90062	257935
9507	8759	1	applied	\N	\N	\N	\N	90063	90063	257936
9509	8760	0	applied	\N	\N	\N	\N	90066	90066	257939
9509	8761	1	applied	\N	\N	\N	\N	90067	90067	257940
9512	8762	0	applied	\N	\N	\N	\N	90074	90074	257947
9512	8763	1	applied	\N	\N	\N	\N	90075	90075	257948
9512	8764	2	applied	\N	\N	\N	\N	90076	90076	257949
9522	8773	0	applied	\N	\N	1000000000	\N	90103	90103	257976
9522	8774	1	applied	\N	\N	\N	\N	90104	90104	257977
9522	8775	2	applied	\N	\N	\N	\N	90105	90105	257978
9522	8776	3	applied	\N	\N	\N	\N	90106	90106	257979
9522	8778	5	applied	\N	\N	\N	\N	90108	90108	257981
9523	8773	0	applied	\N	\N	1000000000	\N	90109	90109	257982
9523	8774	1	applied	\N	\N	\N	\N	90110	90110	257983
9523	8775	2	applied	\N	\N	\N	\N	90111	90111	257984
9523	8776	3	applied	\N	\N	\N	\N	90112	90112	257985
9523	8777	4	applied	\N	\N	\N	\N	90113	90113	257986
9523	8778	5	applied	\N	\N	\N	\N	90114	90114	257987
9526	8784	0	applied	\N	\N	\N	\N	90125	90125	257998
9526	8785	1	applied	\N	\N	\N	\N	90126	90126	257999
9526	8786	2	applied	\N	\N	\N	\N	90127	90127	258000
9526	8787	3	applied	\N	\N	\N	\N	90128	90128	258001
9526	8788	4	applied	\N	\N	\N	\N	90129	90129	258002
9531	8796	0	applied	\N	\N	\N	\N	90142	90142	258015
9531	8797	1	applied	\N	\N	\N	\N	90143	90143	258016
9531	8798	2	applied	\N	\N	\N	\N	90144	90144	258017
9531	8799	3	applied	\N	\N	\N	\N	90145	90145	258018
9538	8803	0	applied	\N	\N	\N	\N	90164	90164	258037
9538	8804	1	applied	\N	\N	\N	\N	90165	90165	258038
9539	8808	2	applied	\N	\N	\N	\N	90168	90168	258041
9539	8809	3	applied	\N	\N	\N	\N	90169	90169	258042
9539	8810	4	applied	\N	\N	\N	\N	90170	90170	258043
9541	8811	0	applied	\N	\N	\N	\N	90175	90175	258048
9541	8812	1	applied	\N	\N	\N	\N	90176	90176	258049
9541	8813	2	applied	\N	\N	\N	\N	90177	90177	258050
9541	8814	3	applied	\N	\N	\N	\N	90178	90178	258051
9543	8815	0	applied	\N	\N	\N	\N	90183	90183	258056
9543	8816	1	applied	\N	\N	\N	\N	90184	90184	258057
9544	8817	0	applied	\N	\N	\N	\N	90185	90185	258058
9544	8818	1	applied	\N	\N	\N	\N	90186	90186	258059
9546	8819	0	applied	\N	\N	\N	\N	90189	90189	258062
9546	8820	1	applied	\N	\N	\N	\N	90190	90190	258063
9547	8821	0	applied	\N	\N	\N	\N	90191	90191	258064
9547	8823	2	applied	\N	\N	\N	\N	90193	90193	258066
9547	8824	3	applied	\N	\N	\N	\N	90194	90194	258067
9548	8825	0	applied	\N	\N	\N	\N	90195	90195	258068
9548	8826	1	applied	\N	\N	\N	\N	90196	90196	258069
9558	8830	0	applied	\N	\N	\N	\N	90204	90204	258077
9558	8831	1	applied	\N	\N	\N	\N	90205	90205	258078
9558	8832	2	applied	\N	\N	\N	\N	90206	90206	258079
9558	8833	3	applied	\N	\N	\N	\N	90207	90207	258080
9560	8838	0	applied	\N	\N	\N	\N	90212	90212	258085
9560	8839	1	applied	\N	\N	\N	\N	90213	90213	258086
9561	8840	0	applied	\N	\N	\N	\N	90214	90214	258087
9561	8841	1	applied	\N	\N	\N	\N	90215	90215	258088
9564	8846	0	applied	\N	\N	\N	\N	90224	90224	258097
9564	8847	1	applied	\N	\N	\N	\N	90225	90225	258098
9564	8848	2	applied	\N	\N	\N	\N	90226	90226	258099
9566	8849	0	applied	\N	\N	\N	\N	90230	90230	258103
9569	8851	0	applied	\N	\N	\N	\N	90236	90236	258109
9569	8852	1	applied	\N	\N	\N	\N	90237	90237	258110
9569	8853	2	applied	\N	\N	\N	\N	90238	90238	258111
9569	8854	3	applied	\N	\N	\N	\N	90239	90239	258112
9569	8855	4	applied	\N	\N	\N	\N	90240	90240	258113
9569	8856	5	applied	\N	\N	\N	\N	90241	90241	258114
9569	8857	6	applied	\N	\N	\N	\N	90242	90242	258115
9569	8858	7	applied	\N	\N	\N	\N	90243	90243	258116
9569	8859	8	applied	\N	\N	\N	\N	90244	90244	258117
9570	8851	0	applied	\N	\N	\N	\N	90245	90245	258118
9570	8852	1	applied	\N	\N	\N	\N	90246	90246	258119
9570	8853	2	applied	\N	\N	\N	\N	90247	90247	258120
9570	8854	3	applied	\N	\N	\N	\N	90248	90248	258121
9570	8855	4	applied	\N	\N	\N	\N	90249	90249	258122
9570	8856	5	applied	\N	\N	\N	\N	90250	90250	258123
9574	8865	0	applied	\N	\N	\N	\N	90261	90261	258134
9579	8873	0	applied	\N	\N	1000000000	\N	90270	90270	258143
9579	8874	1	applied	\N	\N	\N	\N	90271	90271	258144
9579	8875	2	applied	\N	\N	\N	\N	90272	90272	258145
9581	8876	0	applied	\N	\N	\N	\N	90276	90276	258149
9581	8877	1	applied	\N	\N	\N	\N	90277	90277	258150
9589	8886	0	applied	\N	\N	\N	\N	90296	90296	258167
9589	8887	1	applied	\N	\N	\N	\N	90297	90297	258168
9591	8888	0	applied	\N	\N	\N	\N	90300	90300	258171
9591	8889	1	applied	\N	\N	\N	\N	90301	90301	258172
9594	8890	0	applied	\N	\N	\N	\N	90306	90306	258177
9594	8891	1	applied	\N	\N	\N	\N	90307	90307	258178
9598	8898	0	applied	\N	\N	\N	\N	90318	90318	258189
9598	8899	1	applied	\N	\N	\N	\N	90319	90319	258190
9598	8900	2	applied	\N	\N	\N	\N	90320	90320	258191
9598	8901	3	applied	\N	\N	\N	\N	90321	90321	258192
9603	8907	0	applied	\N	\N	\N	\N	90333	90333	258204
9606	8915	0	applied	\N	\N	\N	\N	90347	90347	258214
9606	8916	1	applied	\N	\N	\N	\N	90348	90348	258215
9606	8917	2	applied	\N	\N	\N	\N	90349	90349	258216
9606	8918	3	applied	\N	\N	\N	\N	90350	90350	258217
9488	8733	0	applied	\N	\N	1000000000	\N	90010	90010	257883
9488	8734	1	applied	\N	\N	\N	\N	90011	90011	257884
9549	8827	0	applied	\N	\N	\N	\N	90197	90197	258070
9549	8828	1	applied	\N	\N	\N	\N	90198	90198	258071
9551	8827	0	applied	\N	\N	\N	\N	90201	90201	258074
9553	8829	0	applied	\N	\N	\N	\N	90202	90202	258075
9555	8829	0	applied	\N	\N	\N	\N	90203	90203	258076
9563	8842	0	applied	\N	\N	\N	\N	90220	90220	258093
9563	8843	1	applied	\N	\N	\N	\N	90221	90221	258094
9563	8844	2	applied	\N	\N	\N	\N	90222	90222	258095
9563	8845	3	applied	\N	\N	\N	\N	90223	90223	258096
9568	8849	0	applied	\N	\N	\N	\N	90234	90234	258107
9568	8850	1	applied	\N	\N	\N	\N	90235	90235	258108
9570	8857	6	applied	\N	\N	\N	\N	90251	90251	258124
9570	8858	7	applied	\N	\N	\N	\N	90252	90252	258125
9570	8859	8	applied	\N	\N	\N	\N	90253	90253	258126
9571	8860	0	applied	\N	\N	\N	\N	90254	90254	258127
9571	8861	1	applied	\N	\N	\N	\N	90255	90255	258128
9573	8863	0	applied	\N	\N	\N	\N	90259	90259	258132
9573	8864	1	applied	\N	\N	\N	\N	90260	90260	258133
9576	8869	0	applied	\N	\N	\N	\N	90265	90265	258138
9576	8870	1	applied	\N	\N	\N	\N	90266	90266	258139
9578	8872	0	applied	\N	\N	\N	\N	90269	90269	258142
9583	8880	0	applied	\N	\N	\N	\N	90280	90280	90280
9583	8881	1	applied	\N	\N	\N	\N	90281	90281	258153
9583	8882	2	applied	\N	\N	\N	\N	90282	90282	258154
9583	8883	3	applied	\N	\N	\N	\N	90283	90283	258155
9584	8880	0	applied	\N	\N	\N	\N	90284	90284	90284
9584	8881	1	applied	\N	\N	\N	\N	90285	90285	258156
9584	8882	2	applied	\N	\N	\N	\N	90286	90286	258157
9584	8883	3	applied	\N	\N	\N	\N	90287	90287	258158
9585	8884	0	applied	\N	\N	\N	\N	90288	90288	258159
9585	8885	1	applied	\N	\N	\N	\N	90289	90289	258160
9586	8884	0	applied	\N	\N	\N	\N	90290	90290	258161
9588	8886	0	applied	\N	\N	\N	\N	90294	90294	258165
9588	8887	1	applied	\N	\N	\N	\N	90295	90295	258166
9590	8888	0	applied	\N	\N	\N	\N	90298	90298	258169
9590	8889	1	applied	\N	\N	\N	\N	90299	90299	258170
9592	8890	0	applied	\N	\N	\N	\N	90302	90302	258173
9592	8891	1	applied	\N	\N	\N	\N	90303	90303	258174
9593	8890	0	applied	\N	\N	\N	\N	90304	90304	258175
9593	8891	1	applied	\N	\N	\N	\N	90305	90305	258176
9595	8892	0	applied	\N	\N	\N	\N	90308	90308	258179
9595	8893	1	applied	\N	\N	\N	\N	90309	90309	258180
9595	8894	2	applied	\N	\N	\N	\N	90310	90310	258181
9595	8895	3	applied	\N	\N	\N	\N	90311	90311	258182
9597	8898	0	applied	\N	\N	\N	\N	90314	90314	258185
9597	8899	1	applied	\N	\N	\N	\N	90315	90315	258186
9597	8900	2	applied	\N	\N	\N	\N	90316	90316	258187
9597	8901	3	applied	\N	\N	\N	\N	90317	90317	258188
9600	8903	1	applied	\N	\N	\N	\N	90326	90326	258197
9600	8904	2	applied	\N	\N	\N	\N	90327	90327	258198
9602	8905	0	applied	\N	\N	\N	\N	90331	90331	258202
9602	8906	1	applied	\N	\N	\N	\N	90332	90332	258203
9605	8909	0	applied	\N	\N	\N	\N	90341	90341	258210
9605	8910	1	applied	\N	\N	\N	\N	90342	90342	258211
9605	8911	2	applied	\N	\N	\N	\N	90343	90343	258212
9605	8912	3	applied	\N	\N	\N	\N	90344	90344	258213
9605	8913	4	applied	\N	\N	\N	\N	90345	90345	90345
9605	8914	5	applied	\N	\N	\N	\N	90346	90346	90346
9607	8915	0	applied	\N	\N	\N	\N	90351	90351	258218
9607	8916	1	applied	\N	\N	\N	\N	90352	90352	258219
9607	8917	2	applied	\N	\N	\N	\N	90353	90353	258220
9607	8918	3	applied	\N	\N	\N	\N	90354	90354	258221
9608	8919	0	applied	\N	\N	\N	\N	90355	90355	258222
9608	8920	1	applied	\N	\N	\N	\N	90356	90356	258223
9608	8922	3	applied	\N	\N	\N	\N	90358	90358	258225
9610	8923	0	applied	\N	\N	\N	\N	90364	90364	258228
9610	8924	1	applied	\N	\N	\N	\N	90365	90365	258229
9610	8925	2	applied	\N	\N	\N	\N	90366	90366	90366
9610	8926	3	applied	\N	\N	\N	\N	90367	90367	90367
9610	8927	4	applied	\N	\N	\N	\N	90368	90368	90368
9612	8928	0	applied	\N	\N	\N	\N	90371	90371	258232
9612	8929	1	applied	\N	\N	\N	\N	90372	90372	258233
9614	8930	0	applied	\N	\N	\N	\N	90375	90375	258236
9614	8931	1	applied	\N	\N	\N	\N	90376	90376	258237
9615	8930	0	applied	\N	\N	\N	\N	90377	90377	258238
9615	8931	1	applied	\N	\N	\N	\N	90378	90378	258239
9617	8932	0	applied	\N	\N	\N	\N	90381	90381	258242
9617	8933	1	applied	\N	\N	\N	\N	90382	90382	258243
9620	8933	0	applied	\N	\N	\N	\N	90393	90393	258254
9620	8934	1	applied	\N	\N	\N	\N	90394	90394	258255
9620	8936	3	applied	\N	\N	\N	\N	90396	90396	258257
9620	8937	4	applied	\N	\N	\N	\N	90397	90397	258258
9620	8938	5	applied	\N	\N	\N	\N	90398	90398	258259
9620	8939	6	applied	\N	\N	\N	\N	90399	90399	258260
9620	8940	7	applied	\N	\N	\N	\N	90400	90400	258261
9620	8941	8	applied	\N	\N	\N	\N	90401	90401	258262
9621	8933	0	applied	\N	\N	\N	\N	90402	90402	258263
9621	8934	1	applied	\N	\N	\N	\N	90403	90403	258264
9621	8935	2	applied	\N	\N	\N	\N	90404	90404	258265
9621	8936	3	applied	\N	\N	\N	\N	90405	90405	258266
9621	8937	4	applied	\N	\N	\N	\N	90406	90406	258267
9621	8938	5	applied	\N	\N	\N	\N	90407	90407	258268
9621	8939	6	applied	\N	\N	\N	\N	90408	90408	258269
9621	8940	7	applied	\N	\N	\N	\N	90409	90409	258270
9621	8941	8	applied	\N	\N	\N	\N	90410	90410	258271
9622	8942	0	applied	\N	\N	\N	\N	90411	90411	258272
9622	8944	2	applied	\N	\N	\N	\N	90413	90413	258274
9622	8945	3	applied	\N	\N	\N	\N	90414	90414	258275
9622	8946	4	applied	\N	\N	\N	\N	90415	90415	258276
9622	8947	5	applied	\N	\N	\N	\N	90416	90416	258277
9626	8960	0	applied	\N	\N	\N	\N	90429	90429	258289
9626	8961	1	applied	\N	\N	\N	\N	90430	90430	258290
9626	8962	2	applied	\N	\N	\N	\N	90431	90431	258291
9626	8963	3	applied	\N	\N	\N	\N	90432	90432	258292
9626	8964	4	applied	\N	\N	\N	\N	90433	90433	258293
9626	8965	5	applied	\N	\N	\N	\N	90434	90434	258294
9626	8966	6	applied	\N	\N	\N	\N	90435	90435	258295
9626	8967	7	applied	\N	\N	\N	\N	90436	90436	258296
9626	8968	8	applied	\N	\N	\N	\N	90437	90437	258297
9626	8969	9	applied	\N	\N	\N	\N	90438	90438	258298
9542	8812	1	applied	\N	\N	\N	\N	90180	90180	258053
9542	8813	2	applied	\N	\N	\N	\N	90181	90181	258054
9609	8924	1	applied	\N	\N	\N	\N	90360	90360	258227
9609	8925	2	applied	\N	\N	\N	\N	90361	90361	90361
9609	8926	3	applied	\N	\N	\N	\N	90362	90362	90362
9609	8927	4	applied	\N	\N	\N	\N	90363	90363	90363
9616	8932	0	applied	\N	\N	\N	\N	90379	90379	258240
9616	8933	1	applied	\N	\N	\N	\N	90380	90380	258241
9618	8932	0	applied	\N	\N	\N	\N	90383	90383	258244
9619	8933	0	applied	\N	\N	\N	\N	90384	90384	258245
9619	8934	1	applied	\N	\N	\N	\N	90385	90385	258246
9619	8935	2	applied	\N	\N	\N	\N	90386	90386	258247
9619	8936	3	applied	\N	\N	\N	\N	90387	90387	258248
9619	8937	4	applied	\N	\N	\N	\N	90388	90388	258249
9619	8938	5	applied	\N	\N	\N	\N	90389	90389	258250
9619	8939	6	applied	\N	\N	\N	\N	90390	90390	258251
9619	8940	7	applied	\N	\N	\N	\N	90391	90391	258252
9619	8941	8	applied	\N	\N	\N	\N	90392	90392	258253
9625	8959	1	applied	\N	\N	\N	\N	90428	90428	258288
9626	8970	10	applied	\N	\N	\N	\N	90439	90439	258299
9626	8971	11	applied	\N	\N	\N	\N	90440	90440	258300
9626	8972	12	applied	\N	\N	\N	\N	90441	90441	258301
9626	8973	13	applied	\N	\N	\N	\N	90442	90442	258302
9626	8974	14	applied	\N	\N	\N	\N	90443	90443	258303
9626	8975	15	applied	\N	\N	\N	\N	90444	90444	258304
9626	8976	16	applied	\N	\N	\N	\N	90445	90445	258305
9626	8977	17	applied	\N	\N	\N	\N	90446	90446	258306
9626	8978	18	applied	\N	\N	\N	\N	90447	90447	258307
9626	8979	19	applied	\N	\N	\N	\N	90448	90448	258308
9626	8980	20	applied	\N	\N	\N	\N	90449	90449	258309
9626	8981	21	applied	\N	\N	\N	\N	90450	90450	258310
9626	8982	22	applied	\N	\N	\N	\N	90451	90451	258311
9626	8983	23	applied	\N	\N	\N	\N	90452	90452	258312
9626	8984	24	applied	\N	\N	\N	\N	90453	90453	258313
9626	8986	26	applied	\N	\N	\N	\N	90455	90455	258315
9626	8987	27	applied	\N	\N	\N	\N	90456	90456	258316
9626	8988	28	applied	\N	\N	\N	\N	90457	90457	258317
9626	8989	29	applied	\N	\N	\N	\N	90458	90458	258318
9626	8990	30	applied	\N	\N	\N	\N	90459	90459	258319
9629	8993	0	applied	\N	\N	\N	\N	90464	90464	258324
9629	8994	1	applied	\N	\N	\N	\N	90465	90465	258325
9629	8995	2	applied	\N	\N	\N	\N	90466	90466	258326
9629	8996	3	applied	\N	\N	\N	\N	90467	90467	258327
9629	8997	4	applied	\N	\N	\N	\N	90468	90468	258328
9629	8998	5	applied	\N	\N	\N	\N	90469	90469	258329
9629	8999	6	applied	\N	\N	\N	\N	90470	90470	258330
9631	9000	0	applied	\N	\N	\N	\N	90478	90478	258338
9631	9001	1	applied	\N	\N	\N	\N	90479	90479	258339
9631	9002	2	applied	\N	\N	\N	\N	90480	90480	258340
9634	9004	0	applied	\N	\N	\N	\N	90483	90483	258343
9634	9006	2	applied	\N	\N	\N	\N	90485	90485	258345
9634	9007	3	applied	\N	\N	\N	\N	90486	90486	258346
9634	9008	4	applied	\N	\N	\N	\N	90487	90487	258347
9634	9009	5	applied	\N	\N	\N	\N	90488	90488	258348
9634	9010	6	applied	\N	\N	\N	\N	90489	90489	258349
9634	9011	7	applied	\N	\N	\N	\N	90490	90490	258350
9634	9012	8	applied	\N	\N	\N	\N	90491	90491	258351
9634	9013	9	applied	\N	\N	\N	\N	90492	90492	258352
9637	9010	0	applied	\N	\N	\N	\N	90501	90501	258361
9637	9011	1	applied	\N	\N	\N	\N	90502	90502	258362
9637	9012	2	applied	\N	\N	\N	\N	90503	90503	258363
9637	9013	3	applied	\N	\N	\N	\N	90504	90504	258364
9639	9018	0	applied	\N	\N	\N	\N	90507	90507	258367
9639	9019	1	applied	\N	\N	\N	\N	90508	90508	258368
9640	9018	0	applied	\N	\N	\N	\N	90509	90509	258369
9640	9019	1	applied	\N	\N	\N	\N	90510	90510	258370
9642	9019	1	applied	\N	\N	\N	\N	90514	90514	258374
9643	9018	0	applied	\N	\N	\N	\N	90515	90515	258375
9643	9019	1	applied	\N	\N	\N	\N	90516	90516	258376
9645	9020	0	applied	\N	\N	\N	\N	90517	90517	258377
9645	9021	1	applied	\N	\N	\N	\N	90518	90518	258378
9647	9024	0	applied	\N	\N	\N	\N	90521	90521	258381
9647	9025	1	applied	\N	\N	\N	\N	90522	90522	258382
9648	9026	0	applied	\N	\N	\N	\N	90523	90523	258383
9648	9027	1	applied	\N	\N	\N	\N	90524	90524	258384
9648	9028	2	applied	\N	\N	\N	\N	90525	90525	258385
9650	9029	0	applied	\N	\N	\N	\N	90529	90529	258389
9652	9031	0	applied	\N	\N	\N	\N	90533	90533	258393
9652	9032	1	applied	\N	\N	\N	\N	90534	90534	258394
9654	9033	0	applied	\N	\N	\N	\N	90537	90537	258397
9654	9034	1	applied	\N	\N	\N	\N	90538	90538	258398
9654	9035	2	applied	\N	\N	\N	\N	90539	90539	258399
9657	9043	1	applied	\N	\N	\N	\N	90547	90547	258407
9657	9044	2	applied	\N	\N	\N	\N	90548	90548	258408
9657	9045	3	applied	\N	\N	\N	\N	90549	90549	258409
9657	9046	4	applied	\N	\N	\N	\N	90550	90550	258410
9657	9047	5	applied	\N	\N	\N	\N	90551	90551	258411
9660	9048	0	applied	\N	\N	\N	\N	90556	90556	258416
9660	9049	1	applied	\N	\N	\N	\N	90557	90557	258417
9662	9052	0	applied	\N	\N	\N	\N	90560	90560	258420
9662	9053	1	applied	\N	\N	\N	\N	90561	90561	258421
9662	9054	2	applied	\N	\N	\N	\N	90562	90562	258422
9669	9063	0	applied	\N	\N	\N	\N	90579	90579	258439
9669	9064	1	applied	\N	\N	\N	\N	90580	90580	258440
9676	9071	0	applied	\N	\N	\N	\N	90605	90605	258465
9676	9072	1	applied	\N	\N	\N	\N	90606	90606	258466
9676	9073	2	applied	\N	\N	\N	\N	90607	90607	258467
9679	9075	0	applied	\N	\N	\N	\N	90618	90618	258478
9679	9077	2	applied	\N	\N	\N	\N	90620	90620	258480
9679	9078	3	applied	\N	\N	\N	\N	90621	90621	258481
9687	9084	0	applied	\N	\N	\N	\N	90643	90643	258503
9687	9085	1	applied	\N	\N	\N	\N	90644	90644	258504
9691	9096	0	applied	\N	\N	\N	\N	90665	90665	258525
9691	9097	1	applied	\N	\N	\N	\N	90666	90666	258526
9691	9098	2	applied	\N	\N	\N	\N	90667	90667	258527
9691	9099	3	applied	\N	\N	\N	\N	90668	90668	258528
9691	9100	4	applied	\N	\N	\N	\N	90669	90669	258529
9691	9101	5	applied	\N	\N	\N	\N	90670	90670	258530
9691	9102	6	applied	\N	\N	\N	\N	90671	90671	258531
9691	9103	7	applied	\N	\N	\N	\N	90672	90672	258532
9691	9104	8	applied	\N	\N	\N	\N	90673	90673	258533
9691	9105	9	applied	\N	\N	\N	\N	90674	90674	258534
9604	8913	4	applied	\N	\N	\N	\N	90339	90339	90339
9604	8914	5	applied	\N	\N	\N	\N	90340	90340	90340
9613	8929	1	applied	\N	\N	\N	\N	90374	90374	258235
9624	8955	0	applied	\N	\N	\N	\N	90424	90424	258284
9624	8956	1	applied	\N	\N	\N	\N	90425	90425	258285
9624	8957	2	applied	\N	\N	1000000000	\N	90426	90426	258286
9627	8991	0	applied	\N	\N	\N	\N	90460	90460	258320
9627	8992	1	applied	\N	\N	\N	\N	90461	90461	258321
9630	8993	0	applied	\N	\N	\N	\N	90471	90471	258331
9630	8994	1	applied	\N	\N	\N	\N	90472	90472	258332
9630	8995	2	applied	\N	\N	\N	\N	90473	90473	258333
9630	8996	3	applied	\N	\N	\N	\N	90474	90474	258334
9630	8997	4	applied	\N	\N	\N	\N	90475	90475	258335
9630	8999	6	applied	\N	\N	\N	\N	90477	90477	258337
9633	9003	0	applied	\N	\N	\N	\N	90482	90482	258342
9636	9014	0	applied	\N	\N	\N	\N	90497	90497	258357
9636	9015	1	applied	\N	\N	\N	\N	90498	90498	258358
9636	9016	2	applied	\N	\N	\N	\N	90499	90499	258359
9636	9017	3	applied	\N	\N	\N	\N	90500	90500	258360
9638	9018	0	applied	\N	\N	\N	\N	90505	90505	258365
9638	9019	1	applied	\N	\N	\N	\N	90506	90506	258366
9641	9018	0	applied	\N	\N	\N	\N	90511	90511	258371
9641	9019	1	applied	\N	\N	\N	\N	90512	90512	258372
9656	9039	0	applied	\N	\N	\N	\N	90543	90543	258403
9656	9040	1	applied	\N	\N	\N	\N	90544	90544	258404
9656	9041	2	applied	\N	\N	\N	\N	90545	90545	258405
9664	9052	0	applied	\N	\N	\N	\N	90566	90566	258426
9664	9053	1	applied	\N	\N	\N	\N	90567	90567	258427
9664	9054	2	applied	\N	\N	\N	\N	90568	90568	258428
9666	9060	1	applied	\N	\N	\N	\N	90574	90574	258434
9671	9063	0	applied	\N	\N	\N	\N	90583	90583	258443
9671	9064	1	applied	\N	\N	\N	\N	90584	90584	258444
9682	9079	0	applied	\N	\N	\N	\N	90632	90632	258492
9682	9080	1	applied	\N	\N	\N	\N	90633	90633	258493
9682	9081	2	applied	\N	\N	\N	\N	90634	90634	258494
9686	9082	0	applied	\N	\N	\N	\N	90641	90641	258501
9686	9083	1	applied	\N	\N	\N	\N	90642	90642	258502
9689	9091	0	applied	\N	\N	1000000000	\N	90650	90650	258510
9689	9092	1	applied	\N	\N	\N	\N	90651	90651	258511
9689	9093	2	applied	\N	\N	\N	\N	90652	90652	258512
9689	9094	3	applied	\N	\N	\N	\N	90653	90653	258513
9689	9095	4	applied	\N	\N	\N	\N	90654	90654	258514
9690	9096	0	applied	\N	\N	\N	\N	90655	90655	258515
9690	9097	1	applied	\N	\N	\N	\N	90656	90656	258516
9690	9098	2	applied	\N	\N	\N	\N	90657	90657	258517
9690	9100	4	applied	\N	\N	\N	\N	90659	90659	258519
9690	9101	5	applied	\N	\N	\N	\N	90660	90660	258520
9690	9102	6	applied	\N	\N	\N	\N	90661	90661	258521
9690	9103	7	applied	\N	\N	\N	\N	90662	90662	258522
9690	9104	8	applied	\N	\N	\N	\N	90663	90663	258523
9690	9105	9	applied	\N	\N	\N	\N	90664	90664	258524
9692	9106	0	applied	\N	\N	\N	\N	90675	90675	258535
9693	9106	0	applied	\N	\N	\N	\N	90676	90676	258536
9695	9107	0	applied	\N	\N	\N	\N	90680	90680	258540
9695	9108	1	applied	\N	\N	\N	\N	90681	90681	258541
9695	9109	2	applied	\N	\N	\N	\N	90682	90682	258542
9697	9110	0	applied	\N	\N	\N	\N	90706	90706	258566
9697	9111	1	applied	\N	\N	\N	\N	90707	90707	258567
9697	9112	2	applied	\N	\N	\N	\N	90708	90708	258568
9699	9110	0	applied	\N	\N	\N	\N	90714	90714	258574
9699	9111	1	applied	\N	\N	\N	\N	90715	90715	258575
9699	9115	3	applied	\N	\N	\N	\N	90717	90717	258577
9699	9113	4	applied	\N	\N	\N	\N	90718	90718	258578
9699	9114	5	applied	\N	\N	\N	\N	90719	90719	258579
9699	9116	6	applied	\N	\N	\N	\N	90720	90720	258580
9699	9117	7	applied	\N	\N	\N	\N	90721	90721	258581
9701	9118	0	applied	\N	\N	\N	\N	90725	90725	258585
9701	9115	1	applied	\N	\N	\N	\N	90726	90726	258586
9701	9119	2	applied	\N	\N	\N	\N	90727	90727	258587
9701	9120	3	applied	\N	\N	\N	\N	90728	90728	258588
9701	9113	4	applied	\N	\N	\N	\N	90729	90729	258589
9701	9114	5	applied	\N	\N	\N	\N	90730	90730	258590
9701	9116	6	applied	\N	\N	\N	\N	90731	90731	258591
9701	9117	7	applied	\N	\N	\N	\N	90732	90732	258592
9702	9121	0	applied	\N	\N	\N	\N	90733	90733	258593
9702	9122	1	applied	\N	\N	\N	\N	90734	90734	258594
9702	9123	2	applied	\N	\N	\N	\N	90735	90735	258595
9704	9126	0	applied	\N	\N	\N	\N	90743	90743	258603
9704	9127	1	applied	\N	\N	\N	\N	90744	90744	258604
9704	9125	2	applied	\N	\N	\N	\N	90745	90745	258605
9704	9128	3	applied	\N	\N	\N	\N	90746	90746	258606
9706	9126	0	applied	\N	\N	\N	\N	90751	90751	258611
9706	9127	1	applied	\N	\N	\N	\N	90752	90752	258612
9706	9125	2	applied	\N	\N	\N	\N	90753	90753	258613
9707	9128	0	applied	\N	\N	\N	\N	90755	90755	258615
9707	9127	1	applied	\N	\N	\N	\N	90756	90756	258616
9711	9132	0	applied	\N	\N	\N	\N	90764	90764	258624
9713	9133	0	applied	\N	\N	\N	\N	90766	90766	258626
9713	9134	1	applied	\N	\N	\N	\N	90767	90767	258627
9713	9135	2	applied	\N	\N	\N	\N	90768	90768	258628
9713	9136	3	applied	\N	\N	\N	\N	90769	90769	258629
9715	8871	0	applied	\N	\N	\N	\N	90774	90774	258634
9715	8880	1	applied	\N	\N	\N	\N	90775	90775	90775
9715	8873	3	applied	\N	\N	1000000000	\N	90777	90777	258636
9715	8874	4	applied	\N	\N	\N	\N	90778	90778	258637
9715	8876	5	applied	\N	\N	\N	\N	90779	90779	258638
9715	8879	6	applied	\N	\N	\N	\N	90780	90780	258639
9715	8881	7	applied	\N	\N	\N	\N	90781	90781	258640
9715	9131	8	applied	\N	\N	\N	\N	90782	90782	258641
9715	9133	9	applied	\N	\N	\N	\N	90783	90783	258642
9715	9135	10	applied	\N	\N	\N	\N	90784	90784	258643
9715	8884	11	applied	\N	\N	\N	\N	90785	90785	258644
9715	8886	12	applied	\N	\N	\N	\N	90786	90786	258645
9715	8888	13	applied	\N	\N	\N	\N	90787	90787	258646
9715	8890	14	applied	\N	\N	\N	\N	90788	90788	258647
9715	8904	15	applied	\N	\N	\N	\N	90789	90789	258648
9715	8892	16	applied	\N	\N	\N	\N	90790	90790	258649
9715	8893	17	applied	\N	\N	\N	\N	90791	90791	258650
9715	8896	18	applied	\N	\N	\N	\N	90792	90792	258651
9715	8900	20	applied	\N	\N	\N	\N	90794	90794	258653
9715	8902	21	applied	\N	\N	\N	\N	90795	90795	258654
9611	8929	1	applied	\N	\N	\N	\N	90370	90370	258231
9613	8928	0	applied	\N	\N	\N	\N	90373	90373	258234
9623	8953	5	applied	\N	\N	\N	\N	90422	90422	258282
9623	8954	6	applied	\N	\N	\N	\N	90423	90423	258283
9628	8991	0	applied	\N	\N	\N	\N	90462	90462	258322
9628	8992	1	applied	\N	\N	\N	\N	90463	90463	258323
9632	9003	0	applied	\N	\N	\N	\N	90481	90481	258341
9635	9014	0	applied	\N	\N	\N	\N	90493	90493	258353
9635	9015	1	applied	\N	\N	\N	\N	90494	90494	258354
9635	9016	2	applied	\N	\N	\N	\N	90495	90495	258355
9635	9017	3	applied	\N	\N	\N	\N	90496	90496	258356
9646	9022	0	applied	\N	\N	\N	\N	90519	90519	258379
9646	9023	1	applied	\N	\N	\N	\N	90520	90520	258380
9649	9026	0	applied	\N	\N	\N	\N	90526	90526	258386
9649	9027	1	applied	\N	\N	\N	\N	90527	90527	258387
9649	9028	2	applied	\N	\N	\N	\N	90528	90528	258388
9651	9029	0	applied	\N	\N	\N	\N	90531	90531	258391
9651	9030	1	applied	\N	\N	\N	\N	90532	90532	258392
9659	9048	0	applied	\N	\N	\N	\N	90554	90554	258414
9659	9049	1	applied	\N	\N	\N	\N	90555	90555	258415
9661	9050	0	applied	\N	\N	\N	\N	90558	90558	258418
9661	9051	1	applied	\N	\N	\N	\N	90559	90559	258419
9668	9061	0	applied	\N	\N	\N	\N	90577	90577	258437
9668	9062	1	applied	\N	\N	\N	\N	90578	90578	258438
9673	9065	0	applied	\N	\N	\N	\N	90590	90590	258450
9673	9066	1	applied	\N	\N	\N	\N	90591	90591	258451
9673	9067	2	applied	\N	\N	\N	\N	90592	90592	258452
9673	9068	3	applied	\N	\N	\N	\N	90593	90593	258453
9673	9069	4	applied	\N	\N	\N	\N	90594	90594	258454
9675	9070	0	applied	\N	\N	\N	\N	90600	90600	258460
9675	9072	2	applied	\N	\N	\N	\N	90602	90602	258462
9675	9073	3	applied	\N	\N	\N	\N	90603	90603	258463
9675	9074	4	applied	\N	\N	\N	\N	90604	90604	258464
9678	9075	0	applied	\N	\N	\N	\N	90612	90612	258472
9678	9070	1	applied	\N	\N	\N	\N	90613	90613	258473
9678	9076	2	applied	\N	\N	\N	\N	90614	90614	258474
9678	9077	3	applied	\N	\N	\N	\N	90615	90615	258475
9678	9074	4	applied	\N	\N	\N	\N	90616	90616	258476
9678	9078	5	applied	\N	\N	\N	\N	90617	90617	258477
9680	9075	0	applied	\N	\N	\N	\N	90622	90622	258482
9680	9070	1	applied	\N	\N	\N	\N	90623	90623	258483
9680	9076	2	applied	\N	\N	\N	\N	90624	90624	258484
9680	9077	3	applied	\N	\N	\N	\N	90625	90625	258485
9680	9074	4	applied	\N	\N	\N	\N	90626	90626	258486
9680	9078	5	applied	\N	\N	\N	\N	90627	90627	258487
9684	9082	0	applied	\N	\N	\N	\N	90637	90637	258497
9694	9107	0	applied	\N	\N	\N	\N	90677	90677	258537
9694	9108	1	applied	\N	\N	\N	\N	90678	90678	258538
9694	9109	2	applied	\N	\N	\N	\N	90679	90679	258539
9700	9110	0	applied	\N	\N	\N	\N	90722	90722	258582
9700	9111	1	applied	\N	\N	\N	\N	90723	90723	258583
9700	9112	2	applied	\N	\N	\N	\N	90724	90724	258584
9703	9121	0	applied	\N	\N	\N	\N	90737	90737	258597
9703	9122	1	applied	\N	\N	\N	\N	90738	90738	258598
9703	9125	2	applied	\N	\N	\N	\N	90739	90739	258599
9703	9123	3	applied	\N	\N	\N	\N	90740	90740	258600
9703	9126	4	applied	\N	\N	\N	\N	90741	90741	258601
9703	9124	5	applied	\N	\N	\N	\N	90742	90742	258602
9706	9128	3	applied	\N	\N	\N	\N	90754	90754	258614
9708	9129	0	applied	\N	\N	\N	\N	90757	90757	258617
9708	9130	1	applied	\N	\N	\N	\N	90758	90758	258618
9708	9131	2	applied	\N	\N	\N	\N	90759	90759	258619
9712	9132	0	applied	\N	\N	\N	\N	90765	90765	258625
9717	9137	0	applied	\N	\N	\N	\N	90903	90903	258756
9717	9138	1	applied	\N	\N	\N	\N	90904	90904	258757
9717	9139	2	applied	\N	\N	\N	\N	90905	90905	258758
9717	9140	3	applied	\N	\N	\N	\N	90906	90906	258759
9717	9141	4	applied	\N	\N	\N	\N	90907	90907	258760
9717	9142	5	applied	\N	\N	\N	\N	90908	90908	258761
9719	9137	0	applied	\N	\N	\N	\N	90915	90915	258768
9719	9139	1	applied	\N	\N	\N	\N	90916	90916	258769
9719	9140	2	applied	\N	\N	\N	\N	90917	90917	258770
9719	9141	3	applied	\N	\N	\N	\N	90918	90918	258771
9719	9142	4	applied	\N	\N	\N	\N	90919	90919	258772
9721	9144	0	applied	\N	\N	\N	\N	90926	90926	258779
9721	9145	1	applied	\N	\N	\N	\N	90927	90927	258780
9721	9146	2	applied	\N	\N	\N	\N	90928	90928	258781
9721	9147	3	applied	\N	\N	\N	\N	90929	90929	258782
9723	8755	1	applied	\N	\N	\N	\N	90935	90935	258788
9723	8739	2	applied	\N	\N	\N	\N	90936	90936	258789
9734	9172	0	applied	\N	\N	\N	\N	91061	91061	258913
9734	9173	1	applied	\N	\N	\N	\N	91062	91062	258914
9734	9174	2	applied	\N	\N	\N	\N	91063	91063	258915
9734	9175	3	applied	\N	\N	\N	\N	91064	91064	258916
9734	9176	4	applied	\N	\N	\N	\N	91065	91065	258917
9734	9177	5	applied	\N	\N	\N	\N	91066	91066	258918
9734	9178	6	applied	\N	\N	\N	\N	91067	91067	258919
9734	9179	7	applied	\N	\N	\N	\N	91068	91068	258920
9734	9180	8	applied	\N	\N	\N	\N	91069	91069	258921
9734	9181	9	applied	\N	\N	\N	\N	91070	91070	258922
9734	9182	10	applied	\N	\N	\N	\N	91071	91071	258923
9734	9183	11	applied	\N	\N	\N	\N	91072	91072	258924
9734	9184	12	applied	\N	\N	1000000000	\N	91073	91073	258925
9741	9195	0	applied	\N	\N	\N	\N	91115	91115	258967
9741	9196	1	applied	\N	\N	\N	\N	91116	91116	258968
9741	9197	2	applied	\N	\N	\N	\N	91117	91117	258969
9741	9199	4	applied	\N	\N	\N	\N	91119	91119	258971
9741	9200	5	applied	\N	\N	\N	\N	91120	91120	258972
9741	9201	6	applied	\N	\N	\N	\N	91121	91121	258973
9745	9204	0	applied	\N	\N	\N	\N	91133	91133	258985
9745	9205	1	applied	\N	\N	\N	\N	91134	91134	258986
9745	9206	2	applied	\N	\N	\N	\N	91135	91135	258987
9745	9207	3	applied	\N	\N	\N	\N	91136	91136	258988
9745	9208	4	applied	\N	\N	\N	\N	91137	91137	258989
9750	9215	0	applied	\N	\N	\N	\N	91148	91148	259000
9750	9216	1	applied	\N	\N	\N	\N	91149	91149	259001
9750	9217	2	applied	\N	\N	\N	\N	91150	91150	259002
9750	9218	3	applied	\N	\N	\N	\N	91151	91151	259003
9755	9224	0	applied	\N	\N	\N	\N	91162	91162	259014
9755	9225	1	applied	\N	\N	\N	\N	91163	91163	259015
9757	9230	0	applied	\N	\N	\N	\N	91168	91168	259020
9623	8949	1	applied	\N	\N	\N	\N	90418	90418	258279
9623	8951	3	applied	\N	\N	\N	\N	90420	90420	258281
9655	9036	0	applied	\N	\N	\N	\N	90540	90540	258400
9655	9037	1	applied	\N	\N	\N	\N	90541	90541	258401
9655	9038	3	applied	\N	\N	\N	\N	90542	90542	258402
9658	9048	0	applied	\N	\N	\N	\N	90552	90552	258412
9658	9049	1	applied	\N	\N	\N	\N	90553	90553	258413
9663	9052	0	applied	\N	\N	\N	\N	90563	90563	258423
9663	9053	1	applied	\N	\N	\N	\N	90564	90564	258424
9663	9054	2	applied	\N	\N	\N	\N	90565	90565	258425
9665	9055	0	applied	\N	\N	\N	\N	90569	90569	258429
9665	9056	1	applied	\N	\N	\N	\N	90570	90570	258430
9665	9057	2	applied	\N	\N	\N	\N	90571	90571	258431
9665	9058	3	applied	\N	\N	\N	\N	90572	90572	258432
9667	9060	1	applied	\N	\N	\N	\N	90576	90576	258436
9670	9063	0	applied	\N	\N	\N	\N	90581	90581	258441
9670	9064	1	applied	\N	\N	\N	\N	90582	90582	258442
9672	9065	0	applied	\N	\N	\N	\N	90585	90585	258445
9672	9066	1	applied	\N	\N	\N	\N	90586	90586	258446
9672	9067	2	applied	\N	\N	\N	\N	90587	90587	258447
9672	9068	3	applied	\N	\N	\N	\N	90588	90588	258448
9672	9069	4	applied	\N	\N	\N	\N	90589	90589	258449
9674	9065	0	applied	\N	\N	\N	\N	90595	90595	258455
9674	9066	1	applied	\N	\N	\N	\N	90596	90596	258456
9674	9067	2	applied	\N	\N	\N	\N	90597	90597	258457
9674	9068	3	applied	\N	\N	\N	\N	90598	90598	258458
9674	9069	4	applied	\N	\N	\N	\N	90599	90599	258459
9677	9075	0	applied	\N	\N	\N	\N	90608	90608	258468
9677	9076	1	applied	\N	\N	\N	\N	90609	90609	258469
9677	9077	2	applied	\N	\N	\N	\N	90610	90610	258470
9681	9075	0	applied	\N	\N	\N	\N	90628	90628	258488
9681	9076	1	applied	\N	\N	\N	\N	90629	90629	258489
9681	9077	2	applied	\N	\N	\N	\N	90630	90630	258490
9681	9078	3	applied	\N	\N	\N	\N	90631	90631	258491
9683	9082	0	applied	\N	\N	\N	\N	90635	90635	258495
9683	9083	1	applied	\N	\N	\N	\N	90636	90636	258496
9685	9082	0	applied	\N	\N	\N	\N	90639	90639	258499
9685	9083	1	applied	\N	\N	\N	\N	90640	90640	258500
9688	9086	0	applied	\N	\N	\N	\N	90645	90645	258505
9688	9087	1	applied	\N	\N	\N	\N	90646	90646	258506
9688	9088	2	applied	\N	\N	\N	\N	90647	90647	258507
9688	9089	3	applied	\N	\N	1000000000	\N	90648	90648	258508
9688	9090	4	applied	\N	\N	\N	\N	90649	90649	258509
9696	9091	0	applied	\N	\N	1000000000	\N	90683	90683	258543
9696	9086	1	applied	\N	\N	\N	\N	90684	90684	258544
9696	9087	2	applied	\N	\N	\N	\N	90685	90685	258545
9696	9094	4	applied	\N	\N	\N	\N	90687	90687	258547
9696	9096	5	applied	\N	\N	\N	\N	90688	90688	258548
9696	9088	6	applied	\N	\N	\N	\N	90689	90689	258549
9696	9089	7	applied	\N	\N	1000000000	\N	90690	90690	258550
9696	9092	8	applied	\N	\N	\N	\N	90691	90691	258551
9696	9095	9	applied	\N	\N	\N	\N	90692	90692	258552
9696	9097	10	applied	\N	\N	\N	\N	90693	90693	258553
9696	9098	11	applied	\N	\N	\N	\N	90694	90694	258554
9696	9099	12	applied	\N	\N	\N	\N	90695	90695	258555
9696	9103	13	applied	\N	\N	\N	\N	90696	90696	258556
9696	9104	14	applied	\N	\N	\N	\N	90697	90697	258557
9696	9106	15	applied	\N	\N	\N	\N	90698	90698	258558
9696	9109	16	applied	\N	\N	\N	\N	90699	90699	258559
9696	9090	17	applied	\N	\N	\N	\N	90700	90700	258560
9696	9093	18	applied	\N	\N	\N	\N	90701	90701	258561
9696	9100	19	applied	\N	\N	\N	\N	90702	90702	258562
9723	8742	3	applied	\N	\N	\N	\N	90937	90937	258790
9723	8722	4	applied	\N	\N	\N	\N	90938	90938	258791
9723	8807	5	applied	\N	\N	\N	\N	90939	90939	258792
9723	8773	6	applied	\N	\N	1000000000	\N	90940	90940	258793
9723	8784	7	applied	\N	\N	\N	\N	90941	90941	258794
9723	8791	8	applied	\N	\N	\N	\N	90942	90942	258795
9723	8796	9	applied	\N	\N	\N	\N	90943	90943	258796
9723	8803	10	applied	\N	\N	\N	\N	90944	90944	258797
9723	8806	11	applied	\N	\N	\N	\N	90945	90945	258798
9723	9091	12	applied	\N	\N	1000000000	\N	90946	90946	258799
9723	9148	13	applied	\N	\N	\N	\N	90947	90947	258800
9723	9075	14	applied	\N	\N	\N	\N	90948	90948	258801
9723	9108	15	applied	\N	\N	\N	\N	90949	90949	258802
9723	8873	16	applied	\N	\N	1000000000	\N	90950	90950	258803
9723	9076	17	applied	\N	\N	\N	\N	90951	90951	258804
9723	9079	18	applied	\N	\N	\N	\N	90952	90952	258805
9723	8785	20	applied	\N	\N	\N	\N	90954	90954	258807
9723	9131	21	applied	\N	\N	\N	\N	90955	90955	258808
9723	9133	22	applied	\N	\N	\N	\N	90956	90956	258809
9723	9145	23	applied	\N	\N	\N	\N	90957	90957	258810
9723	9089	24	applied	\N	\N	1000000000	\N	90958	90958	258811
9723	9135	25	applied	\N	\N	\N	\N	90959	90959	258812
9723	9138	26	applied	\N	\N	\N	\N	90960	90960	258813
9723	8904	27	applied	\N	\N	\N	\N	90961	90961	258814
9723	9119	28	applied	\N	\N	\N	\N	90962	90962	258815
9723	9120	29	applied	\N	\N	\N	\N	90963	90963	258816
9723	9122	30	applied	\N	\N	\N	\N	90964	90964	258817
9723	9149	31	applied	\N	\N	\N	\N	90965	90965	258818
9723	9010	32	applied	\N	\N	\N	\N	90966	90966	258819
9723	9011	33	applied	\N	\N	\N	\N	90967	90967	258820
9723	9012	34	applied	\N	\N	\N	\N	90968	90968	258821
9723	9013	35	applied	\N	\N	\N	\N	90969	90969	258822
9723	9113	38	applied	\N	\N	\N	\N	90972	90972	258824
9723	8952	37	failed	Amount_insufficient_to_create_account	\N	\N	\N	90971	90971	\N
9723	9114	39	applied	\N	\N	\N	\N	90973	90973	258825
9723	9116	41	applied	\N	\N	\N	\N	90974	90974	258826
9723	9117	42	applied	\N	\N	\N	\N	90975	90975	258827
9729	9157	0	applied	\N	\N	\N	\N	91029	91029	258881
9729	9158	1	applied	\N	\N	\N	\N	91030	91030	258882
9729	9159	2	applied	\N	\N	\N	\N	91031	91031	258883
9729	9160	3	applied	\N	\N	\N	\N	91032	91032	258884
9729	9161	4	applied	\N	\N	\N	\N	91033	91033	258885
9729	9162	5	applied	\N	\N	\N	\N	91034	91034	258886
9729	9163	6	applied	\N	\N	\N	\N	91035	91035	258887
9729	9164	7	applied	\N	\N	\N	\N	91036	91036	258888
9729	9165	8	applied	\N	\N	\N	\N	91037	91037	258889
9729	9166	9	applied	\N	\N	\N	\N	91038	91038	258890
9729	9167	10	applied	\N	\N	\N	\N	91039	91039	258891
9653	9031	0	applied	\N	\N	\N	\N	90535	90535	258395
9653	9032	1	applied	\N	\N	\N	\N	90536	90536	258396
9698	9111	1	applied	\N	\N	\N	\N	90710	90710	258570
9698	9112	2	applied	\N	\N	\N	\N	90711	90711	258571
9698	9113	3	applied	\N	\N	\N	\N	90712	90712	258572
9698	9114	4	applied	\N	\N	\N	\N	90713	90713	258573
9705	9126	0	applied	\N	\N	\N	\N	90747	90747	258607
9705	9127	1	applied	\N	\N	\N	\N	90748	90748	258608
9705	9125	2	applied	\N	\N	\N	\N	90749	90749	258609
9709	9129	0	applied	\N	\N	\N	\N	90760	90760	258620
9709	9130	1	applied	\N	\N	\N	\N	90761	90761	258621
9709	9131	2	applied	\N	\N	\N	\N	90762	90762	258622
9714	9133	0	applied	\N	\N	\N	\N	90770	90770	258630
9714	9134	1	applied	\N	\N	\N	\N	90771	90771	258631
9714	9135	2	applied	\N	\N	\N	\N	90772	90772	258632
9714	9136	3	applied	\N	\N	\N	\N	90773	90773	258633
9715	8907	22	applied	\N	\N	\N	\N	90796	90796	258655
9715	8910	23	applied	\N	\N	\N	\N	90797	90797	258656
9715	8911	24	applied	\N	\N	\N	\N	90798	90798	258657
9715	8916	25	applied	\N	\N	\N	\N	90799	90799	258658
9715	9119	26	applied	\N	\N	\N	\N	90800	90800	258659
9715	9120	27	applied	\N	\N	\N	\N	90801	90801	258660
9715	9122	28	applied	\N	\N	\N	\N	90802	90802	258661
9715	9010	29	applied	\N	\N	\N	\N	90803	90803	258662
9715	9011	30	applied	\N	\N	\N	\N	90804	90804	258663
9715	9013	32	applied	\N	\N	\N	\N	90806	90806	258665
9715	9124	33	applied	\N	\N	\N	\N	90807	90807	258666
9715	9113	35	applied	\N	\N	\N	\N	90809	90809	258667
9715	8952	34	failed	Amount_insufficient_to_create_account	\N	\N	\N	90808	90808	\N
9715	9114	36	applied	\N	\N	\N	\N	90810	90810	258668
9715	9116	37	applied	\N	\N	\N	\N	90811	90811	258669
9715	9117	38	applied	\N	\N	\N	\N	90812	90812	258670
9715	8906	39	applied	\N	\N	\N	\N	90813	90813	258671
9715	8918	40	applied	\N	\N	\N	\N	90814	90814	258672
9715	8920	41	applied	\N	\N	\N	\N	90815	90815	258673
9715	8922	42	applied	\N	\N	\N	\N	90816	90816	258674
9715	8924	43	applied	\N	\N	\N	\N	90817	90817	258675
9715	8928	44	applied	\N	\N	\N	\N	90818	90818	258676
9715	8931	45	applied	\N	\N	\N	\N	90819	90819	258677
9715	8932	46	applied	\N	\N	\N	\N	90820	90820	258678
9715	8875	47	applied	\N	\N	\N	\N	90821	90821	258679
9715	8878	49	applied	\N	\N	\N	\N	90823	90823	258681
9715	8882	50	applied	\N	\N	\N	\N	90824	90824	258682
9715	8883	51	applied	\N	\N	\N	\N	90825	90825	258683
9715	8885	52	applied	\N	\N	\N	\N	90826	90826	258684
9715	8887	53	applied	\N	\N	\N	\N	90827	90827	258685
9715	8889	54	applied	\N	\N	\N	\N	90828	90828	258686
9715	8891	55	applied	\N	\N	\N	\N	90829	90829	258687
9715	8894	56	applied	\N	\N	\N	\N	90830	90830	258688
9715	8895	57	applied	\N	\N	\N	\N	90831	90831	258689
9715	8897	58	applied	\N	\N	\N	\N	90832	90832	258690
9715	8899	59	applied	\N	\N	\N	\N	90833	90833	258691
9715	8901	60	applied	\N	\N	\N	\N	90834	90834	258692
9715	8903	61	applied	\N	\N	\N	\N	90835	90835	258693
9715	8905	62	applied	\N	\N	\N	\N	90836	90836	258694
9715	8908	63	applied	\N	\N	\N	\N	90837	90837	258695
9715	8909	64	applied	\N	\N	\N	\N	90838	90838	258696
9715	8915	66	applied	\N	\N	\N	\N	90840	90840	258698
9715	8917	67	applied	\N	\N	\N	\N	90841	90841	258699
9715	8919	68	applied	\N	\N	\N	\N	90842	90842	258700
9715	8921	69	applied	\N	\N	\N	\N	90843	90843	258701
9715	8923	70	applied	\N	\N	\N	\N	90844	90844	258702
9715	8929	71	applied	\N	\N	\N	\N	90845	90845	258703
9715	8938	72	applied	\N	\N	\N	\N	90846	90846	258704
9715	8939	73	applied	\N	\N	\N	\N	90847	90847	258705
9715	8940	74	applied	\N	\N	\N	\N	90848	90848	258706
9715	8941	75	applied	\N	\N	\N	\N	90849	90849	258707
9715	8945	76	applied	\N	\N	\N	\N	90850	90850	258708
9715	8946	77	applied	\N	\N	\N	\N	90851	90851	258709
9715	8947	78	applied	\N	\N	\N	\N	90852	90852	258710
9715	8948	79	applied	\N	\N	\N	\N	90853	90853	258711
9715	8953	80	applied	\N	\N	\N	\N	90854	90854	258712
9715	8954	81	applied	\N	\N	\N	\N	90855	90855	258713
9715	8958	83	applied	\N	\N	\N	\N	90857	90857	258715
9715	8960	84	applied	\N	\N	\N	\N	90858	90858	258716
9715	8992	85	applied	\N	\N	\N	\N	90859	90859	258717
9715	8997	86	applied	\N	\N	\N	\N	90860	90860	258718
9715	8998	87	applied	\N	\N	\N	\N	90861	90861	258719
9715	8999	88	applied	\N	\N	\N	\N	90862	90862	258720
9716	9133	0	applied	\N	\N	\N	\N	90899	90899	258752
9716	9134	1	applied	\N	\N	\N	\N	90900	90900	258753
9716	9135	2	applied	\N	\N	\N	\N	90901	90901	258754
9716	9136	3	applied	\N	\N	\N	\N	90902	90902	258755
9718	9143	0	applied	\N	\N	\N	\N	90909	90909	258762
9718	9137	1	applied	\N	\N	\N	\N	90910	90910	258763
9718	9139	2	applied	\N	\N	\N	\N	90911	90911	258764
9718	9140	3	applied	\N	\N	\N	\N	90912	90912	258765
9718	9141	4	applied	\N	\N	\N	\N	90913	90913	258766
9718	9142	5	applied	\N	\N	\N	\N	90914	90914	258767
9720	9138	1	applied	\N	\N	\N	\N	90921	90921	258774
9720	9139	2	applied	\N	\N	\N	\N	90922	90922	258775
9720	9140	3	applied	\N	\N	\N	\N	90923	90923	258776
9720	9141	4	applied	\N	\N	\N	\N	90924	90924	258777
9720	9142	5	applied	\N	\N	\N	\N	90925	90925	258778
9722	9144	0	applied	\N	\N	\N	\N	90930	90930	258783
9722	9145	1	applied	\N	\N	\N	\N	90931	90931	258784
9722	9146	2	applied	\N	\N	\N	\N	90932	90932	258785
9722	9147	3	applied	\N	\N	\N	\N	90933	90933	258786
9725	9148	0	applied	\N	\N	\N	\N	90985	90985	258837
9725	9150	1	applied	\N	\N	\N	\N	90986	90986	258838
9725	9149	2	applied	\N	\N	\N	\N	90987	90987	258839
9725	9151	3	applied	\N	\N	\N	\N	90988	90988	258840
9725	9152	4	applied	\N	\N	\N	\N	90989	90989	258841
9725	9153	5	applied	\N	\N	\N	\N	90990	90990	258842
9725	9155	7	applied	\N	\N	\N	\N	90992	90992	258844
9725	9156	8	applied	\N	\N	\N	\N	90993	90993	258845
9728	9157	0	applied	\N	\N	\N	\N	91016	91016	258868
9728	9158	1	applied	\N	\N	\N	\N	91017	91017	258869
9728	9159	2	applied	\N	\N	\N	\N	91018	91018	258870
9728	9160	3	applied	\N	\N	\N	\N	91019	91019	258871
9728	9161	4	applied	\N	\N	\N	\N	91020	91020	258872
9696	9107	22	applied	\N	\N	\N	\N	90705	90705	258565
9698	9110	0	applied	\N	\N	\N	\N	90709	90709	258569
9715	9008	92	applied	\N	\N	\N	\N	90866	90866	258724
9715	9009	93	applied	\N	\N	\N	\N	90867	90867	258725
9715	9015	94	applied	\N	\N	\N	\N	90868	90868	258726
9715	9016	95	applied	\N	\N	\N	\N	90869	90869	258727
9715	9019	96	applied	\N	\N	\N	\N	90870	90870	258728
9715	9022	98	applied	\N	\N	\N	\N	90872	90872	258730
9715	9024	99	applied	\N	\N	\N	\N	90873	90873	258731
9715	9028	100	applied	\N	\N	\N	\N	90874	90874	258732
9715	9029	101	applied	\N	\N	\N	\N	90875	90875	258733
9715	9032	102	applied	\N	\N	\N	\N	90876	90876	258734
9715	9034	103	applied	\N	\N	\N	\N	90877	90877	258735
9715	9038	104	applied	\N	\N	\N	\N	90878	90878	258736
9715	9039	105	applied	\N	\N	\N	\N	90879	90879	258737
9715	9042	106	applied	\N	\N	\N	\N	90880	90880	258738
9715	9048	107	applied	\N	\N	\N	\N	90881	90881	258739
9715	9051	108	applied	\N	\N	\N	\N	90882	90882	258740
9715	9053	109	applied	\N	\N	\N	\N	90883	90883	258741
9715	9055	110	applied	\N	\N	\N	\N	90884	90884	258742
9715	9056	111	applied	\N	\N	\N	\N	90885	90885	258743
9715	9060	112	applied	\N	\N	\N	\N	90886	90886	258744
9715	9061	113	applied	\N	\N	\N	\N	90887	90887	258745
9715	8957	115	applied	\N	\N	1000000000	\N	90889	90889	258747
9715	8913	116	applied	\N	\N	\N	\N	90890	90890	90890
9715	8914	117	applied	\N	\N	\N	\N	90891	90891	90891
9715	8925	118	applied	\N	\N	\N	\N	90892	90892	90892
9715	8926	119	applied	\N	\N	\N	\N	90893	90893	90893
9715	8927	121	applied	\N	\N	\N	\N	90894	90894	90894
9715	8962	122	applied	\N	\N	\N	\N	90895	90895	258748
9715	8964	123	applied	\N	\N	\N	\N	90896	90896	258749
9715	8965	124	applied	\N	\N	\N	\N	90897	90897	258750
9715	8966	125	applied	\N	\N	\N	\N	90898	90898	258751
9724	9148	0	applied	\N	\N	\N	\N	90976	90976	258828
9724	9150	1	applied	\N	\N	\N	\N	90977	90977	258829
9724	9149	2	applied	\N	\N	\N	\N	90978	90978	258830
9724	9151	3	applied	\N	\N	\N	\N	90979	90979	258831
9724	9152	4	applied	\N	\N	\N	\N	90980	90980	258832
9724	9153	5	applied	\N	\N	\N	\N	90981	90981	258833
9724	9155	7	applied	\N	\N	\N	\N	90983	90983	258835
9724	9156	8	applied	\N	\N	\N	\N	90984	90984	258836
9726	9148	0	applied	\N	\N	\N	\N	90994	90994	258846
9726	9150	1	applied	\N	\N	\N	\N	90995	90995	258847
9726	9149	2	applied	\N	\N	\N	\N	90996	90996	258848
9726	9151	3	applied	\N	\N	\N	\N	90997	90997	258849
9726	9152	4	applied	\N	\N	\N	\N	90998	90998	258850
9726	9153	5	applied	\N	\N	\N	\N	90999	90999	258851
9726	9154	6	applied	\N	\N	1000000000	\N	91000	91000	258852
9726	9155	7	applied	\N	\N	\N	\N	91001	91001	258853
9726	9156	8	applied	\N	\N	\N	\N	91002	91002	258854
9727	9157	0	applied	\N	\N	\N	\N	91003	91003	258855
9727	9158	1	applied	\N	\N	\N	\N	91004	91004	258856
9727	9159	2	applied	\N	\N	\N	\N	91005	91005	258857
9727	9160	3	applied	\N	\N	\N	\N	91006	91006	258858
9727	9161	4	applied	\N	\N	\N	\N	91007	91007	258859
9727	9162	5	applied	\N	\N	\N	\N	91008	91008	258860
9727	9163	6	applied	\N	\N	\N	\N	91009	91009	258861
9727	9165	8	applied	\N	\N	\N	\N	91011	91011	258863
9727	9166	9	applied	\N	\N	\N	\N	91012	91012	258864
9727	9167	10	applied	\N	\N	\N	\N	91013	91013	258865
9727	9168	11	applied	\N	\N	\N	\N	91014	91014	258866
9727	9169	12	applied	\N	\N	\N	\N	91015	91015	258867
9731	9170	0	applied	\N	\N	\N	\N	91044	91044	258896
9731	9171	1	applied	\N	\N	\N	\N	91045	91045	258897
9735	9172	0	applied	\N	\N	\N	\N	91074	91074	258926
9735	9173	1	applied	\N	\N	\N	\N	91075	91075	258927
9735	9174	2	applied	\N	\N	\N	\N	91076	91076	258928
9735	9175	3	applied	\N	\N	\N	\N	91077	91077	258929
9735	9176	4	applied	\N	\N	\N	\N	91078	91078	258930
9735	9177	5	applied	\N	\N	\N	\N	91079	91079	258931
9735	9178	6	applied	\N	\N	\N	\N	91080	91080	258932
9735	9179	7	applied	\N	\N	\N	\N	91081	91081	258933
9735	9180	8	applied	\N	\N	\N	\N	91082	91082	258934
9735	9182	10	applied	\N	\N	\N	\N	91084	91084	258936
9735	9183	11	applied	\N	\N	\N	\N	91085	91085	258937
9735	9184	12	applied	\N	\N	1000000000	\N	91086	91086	258938
9736	9185	0	applied	\N	\N	\N	\N	91087	91087	258939
9736	9186	1	applied	\N	\N	\N	\N	91088	91088	258940
9736	9187	2	applied	\N	\N	\N	\N	91089	91089	258941
9739	9189	0	applied	\N	\N	\N	\N	91104	91104	258956
9739	9191	1	applied	\N	\N	\N	\N	91105	91105	258957
9739	9184	2	applied	\N	\N	1000000000	\N	91106	91106	258958
9739	9194	3	applied	\N	\N	\N	\N	91107	91107	258959
9743	9202	0	applied	\N	\N	\N	\N	91126	91126	258978
9743	9203	1	applied	\N	\N	\N	\N	91127	91127	258979
9746	9209	0	applied	\N	\N	\N	\N	91138	91138	258990
9746	9210	1	applied	\N	\N	\N	\N	91139	91139	258991
9746	9211	2	applied	\N	\N	\N	\N	91140	91140	258992
9748	9212	0	applied	\N	\N	\N	\N	91144	91144	258996
9748	9214	3	applied	\N	\N	\N	\N	91146	91146	258998
9753	9222	0	applied	\N	\N	\N	\N	91158	91158	259010
9753	9223	1	applied	\N	\N	\N	\N	91159	91159	259011
9758	9230	0	applied	\N	\N	\N	\N	91170	91170	259022
9758	9231	1	applied	\N	\N	\N	\N	91171	91171	259023
9760	9232	0	applied	\N	\N	1000000000	\N	91174	91174	259026
9760	9233	1	applied	\N	\N	\N	\N	91175	91175	259027
9763	9244	0	applied	\N	\N	\N	\N	91186	91186	259038
9763	9245	1	applied	\N	\N	\N	\N	91187	91187	259039
9763	9246	2	applied	\N	\N	\N	\N	91188	91188	259040
9766	9247	0	applied	\N	\N	\N	\N	91203	91203	259050
9766	9248	1	applied	\N	\N	\N	\N	91204	91204	259051
9766	9249	2	applied	\N	\N	\N	\N	91205	91205	259052
9766	9250	3	applied	\N	\N	\N	\N	91206	91206	259053
9766	9251	4	applied	\N	\N	\N	\N	91207	91207	259054
9766	9252	5	applied	\N	\N	\N	\N	91208	91208	259055
9766	9254	7	applied	\N	\N	\N	\N	91210	91210	91210
9766	9255	8	applied	\N	\N	\N	\N	91211	91211	91211
9766	9256	9	applied	\N	\N	\N	\N	91212	91212	91212
9766	9257	10	applied	\N	\N	\N	\N	91213	91213	91213
9770	9258	0	applied	\N	\N	\N	\N	91247	91247	259074
9770	9259	1	applied	\N	\N	\N	\N	91248	91248	259075
9715	9002	90	applied	\N	\N	\N	\N	90864	90864	258722
9715	9007	91	applied	\N	\N	\N	\N	90865	90865	258723
9728	9165	8	applied	\N	\N	\N	\N	91024	91024	258876
9728	9166	9	applied	\N	\N	\N	\N	91025	91025	258877
9728	9167	10	applied	\N	\N	\N	\N	91026	91026	258878
9728	9168	11	applied	\N	\N	\N	\N	91027	91027	258879
9728	9169	12	applied	\N	\N	\N	\N	91028	91028	258880
9732	9170	0	applied	\N	\N	\N	\N	91046	91046	258898
9732	9171	1	applied	\N	\N	\N	\N	91047	91047	258899
9737	9188	0	applied	\N	\N	\N	\N	91090	91090	258942
9737	9189	1	applied	\N	\N	\N	\N	91091	91091	258943
9737	9190	2	applied	\N	\N	\N	\N	91092	91092	258944
9737	9191	3	applied	\N	\N	\N	\N	91093	91093	258945
9737	9193	5	applied	\N	\N	\N	\N	91095	91095	258947
9737	9194	6	applied	\N	\N	\N	\N	91096	91096	258948
9742	9189	0	applied	\N	\N	\N	\N	91122	91122	258974
9742	9191	1	applied	\N	\N	\N	\N	91123	91123	258975
9742	9194	2	applied	\N	\N	\N	\N	91124	91124	258976
9742	9201	3	applied	\N	\N	\N	\N	91125	91125	258977
9744	9204	0	applied	\N	\N	\N	\N	91128	91128	258980
9744	9205	1	applied	\N	\N	\N	\N	91129	91129	258981
9744	9206	2	applied	\N	\N	\N	\N	91130	91130	258982
9744	9207	3	applied	\N	\N	\N	\N	91131	91131	258983
9744	9208	4	applied	\N	\N	\N	\N	91132	91132	258984
9749	9213	0	applied	\N	\N	\N	\N	91147	91147	258999
9751	9219	0	applied	\N	\N	\N	\N	91152	91152	259004
9751	9220	1	applied	\N	\N	\N	\N	91153	91153	259005
9751	9221	2	applied	\N	\N	\N	\N	91154	91154	259006
9756	9226	0	applied	\N	\N	\N	\N	91164	91164	259016
9756	9228	2	applied	\N	\N	\N	\N	91166	91166	259018
9756	9229	3	applied	\N	\N	\N	\N	91167	91167	259019
9764	9244	0	applied	\N	\N	\N	\N	91189	91189	259041
9764	9245	1	applied	\N	\N	\N	\N	91190	91190	259042
9764	9246	2	applied	\N	\N	\N	\N	91191	91191	259043
9768	9247	0	applied	\N	\N	\N	\N	91225	91225	259062
9768	9248	1	applied	\N	\N	\N	\N	91226	91226	259063
9768	9249	2	applied	\N	\N	\N	\N	91227	91227	259064
9768	9250	3	applied	\N	\N	\N	\N	91228	91228	259065
9768	9251	4	applied	\N	\N	\N	\N	91229	91229	259066
9768	9252	5	applied	\N	\N	\N	\N	91230	91230	259067
9768	9253	6	applied	\N	\N	\N	\N	91231	91231	91231
9768	9254	7	applied	\N	\N	\N	\N	91232	91232	91232
9768	9255	8	applied	\N	\N	\N	\N	91233	91233	91233
9768	9256	9	applied	\N	\N	\N	\N	91234	91234	91234
9768	9257	10	applied	\N	\N	\N	\N	91235	91235	91235
9773	9263	1	applied	\N	\N	\N	\N	91254	91254	259081
9775	9264	0	applied	\N	\N	\N	\N	91255	91255	259082
9775	9265	1	applied	\N	\N	\N	\N	91256	91256	259083
9777	9266	0	applied	\N	\N	\N	\N	91259	91259	259086
9777	9267	1	applied	\N	\N	\N	\N	91260	91260	259087
9777	9268	2	applied	\N	\N	\N	\N	91261	91261	259088
9777	9269	3	applied	\N	\N	\N	\N	91262	91262	259089
9777	9270	4	applied	\N	\N	\N	\N	91263	91263	259090
9777	9271	5	applied	\N	\N	\N	\N	91264	91264	259091
9779	9272	0	applied	\N	\N	\N	\N	91269	91269	259096
9779	9273	1	applied	\N	\N	\N	\N	91270	91270	259097
9779	9274	2	applied	\N	\N	\N	\N	91271	91271	259098
9779	9275	3	applied	\N	\N	\N	\N	91272	91272	259099
9780	9276	0	applied	\N	\N	1000000000	\N	91273	91273	259100
9780	9277	1	applied	\N	\N	\N	\N	91274	91274	259101
9780	9278	2	applied	\N	\N	\N	\N	91275	91275	259102
9782	9280	1	applied	\N	\N	\N	\N	91280	91280	259107
9782	9281	2	applied	\N	\N	\N	\N	91281	91281	259108
9782	9282	3	applied	\N	\N	\N	\N	91282	91282	259109
9784	9283	0	applied	\N	\N	\N	\N	91287	91287	259114
9784	9284	1	applied	\N	\N	\N	\N	91288	91288	259115
9785	9285	0	applied	\N	\N	\N	\N	91289	91289	259116
9785	9286	1	applied	\N	\N	\N	\N	91290	91290	259117
9785	9287	2	applied	\N	\N	\N	\N	91291	91291	259118
9787	9292	0	applied	\N	\N	\N	\N	91296	91296	259123
9787	9293	1	applied	\N	\N	\N	\N	91297	91297	259124
9787	9294	2	applied	\N	\N	\N	\N	91298	91298	259125
9787	9295	4	applied	\N	\N	\N	\N	91299	91299	259126
9787	9296	5	applied	\N	\N	\N	\N	91300	91300	259127
9787	9297	6	applied	\N	\N	\N	\N	91301	91301	259128
9787	9298	7	applied	\N	\N	\N	\N	91302	91302	259129
9788	9292	0	applied	\N	\N	\N	\N	91303	91303	259130
9788	9294	2	applied	\N	\N	\N	\N	91305	91305	259132
9788	9295	4	applied	\N	\N	\N	\N	91306	91306	259133
9788	9296	5	applied	\N	\N	\N	\N	91307	91307	259134
9788	9297	6	applied	\N	\N	\N	\N	91308	91308	259135
9788	9298	7	applied	\N	\N	\N	\N	91309	91309	259136
9790	9307	0	applied	\N	\N	\N	\N	91318	91318	259145
9790	9308	1	applied	\N	\N	\N	\N	91319	91319	259146
9790	9309	2	applied	\N	\N	\N	\N	91320	91320	259147
9790	9310	3	applied	\N	\N	\N	\N	91321	91321	259148
9790	9311	4	applied	\N	\N	\N	\N	91322	91322	259149
9790	9312	5	applied	\N	\N	\N	\N	91323	91323	259150
9790	9313	6	applied	\N	\N	\N	\N	91324	91324	259151
9790	9314	7	applied	\N	\N	\N	\N	91325	91325	259152
9793	9318	0	applied	\N	\N	\N	\N	91331	91331	259158
9793	9319	1	applied	\N	\N	\N	\N	91332	91332	259159
9795	9324	0	applied	\N	\N	\N	\N	91337	91337	259164
9796	9326	0	applied	\N	\N	\N	\N	91339	91339	259166
9796	9327	1	applied	\N	\N	\N	\N	91340	91340	259167
9796	9328	2	applied	\N	\N	1000000000	\N	91341	91341	259168
9798	9326	0	applied	\N	\N	\N	\N	91345	91345	259172
9798	9327	1	applied	\N	\N	\N	\N	91346	91346	259173
9798	9328	2	applied	\N	\N	1000000000	\N	91347	91347	259174
9800	9340	0	applied	\N	\N	\N	\N	91359	91359	259184
9800	9341	1	applied	\N	\N	\N	\N	91360	91360	259185
9803	9340	0	applied	\N	\N	\N	\N	91364	91364	259189
9805	9341	0	applied	\N	\N	\N	\N	91367	91367	259192
9805	9342	1	applied	\N	\N	\N	\N	91368	91368	259193
9807	9346	0	applied	\N	\N	\N	\N	91372	91372	259197
9807	9347	1	applied	\N	\N	\N	\N	91373	91373	259198
9807	9348	2	applied	\N	\N	\N	\N	91374	91374	259199
9807	9349	3	applied	\N	\N	\N	\N	91375	91375	259200
9808	9346	0	applied	\N	\N	\N	\N	91376	91376	259201
9808	9348	2	applied	\N	\N	\N	\N	91378	91378	259203
9808	9349	3	applied	\N	\N	\N	\N	91379	91379	259204
9728	9163	6	applied	\N	\N	\N	\N	91022	91022	258874
9728	9164	7	applied	\N	\N	\N	\N	91023	91023	258875
9733	9172	0	applied	\N	\N	\N	\N	91048	91048	258900
9733	9174	2	applied	\N	\N	\N	\N	91050	91050	258902
9733	9175	3	applied	\N	\N	\N	\N	91051	91051	258903
9733	9176	4	applied	\N	\N	\N	\N	91052	91052	258904
9733	9177	5	applied	\N	\N	\N	\N	91053	91053	258905
9733	9178	6	applied	\N	\N	\N	\N	91054	91054	258906
9733	9179	7	applied	\N	\N	\N	\N	91055	91055	258907
9733	9180	8	applied	\N	\N	\N	\N	91056	91056	258908
9733	9181	9	applied	\N	\N	\N	\N	91057	91057	258909
9733	9182	10	applied	\N	\N	\N	\N	91058	91058	258910
9733	9183	11	applied	\N	\N	\N	\N	91059	91059	258911
9733	9184	12	applied	\N	\N	1000000000	\N	91060	91060	258912
9738	9188	0	applied	\N	\N	\N	\N	91097	91097	258949
9738	9189	1	applied	\N	\N	\N	\N	91098	91098	258950
9738	9190	2	applied	\N	\N	\N	\N	91099	91099	258951
9738	9191	3	applied	\N	\N	\N	\N	91100	91100	258952
9738	9192	4	applied	\N	\N	\N	\N	91101	91101	258953
9738	9194	6	applied	\N	\N	\N	\N	91103	91103	258955
9740	9195	0	applied	\N	\N	\N	\N	91108	91108	258960
9740	9196	1	applied	\N	\N	\N	\N	91109	91109	258961
9740	9197	2	applied	\N	\N	\N	\N	91110	91110	258962
9740	9198	3	applied	\N	\N	\N	\N	91111	91111	258963
9740	9199	4	applied	\N	\N	\N	\N	91112	91112	258964
9740	9200	5	applied	\N	\N	\N	\N	91113	91113	258965
9740	9201	6	applied	\N	\N	\N	\N	91114	91114	258966
9747	9209	0	applied	\N	\N	\N	\N	91141	91141	258993
9747	9210	1	applied	\N	\N	\N	\N	91142	91142	258994
9747	9211	2	applied	\N	\N	\N	\N	91143	91143	258995
9752	9219	0	applied	\N	\N	\N	\N	91155	91155	259007
9752	9220	1	applied	\N	\N	\N	\N	91156	91156	259008
9752	9221	2	applied	\N	\N	\N	\N	91157	91157	259009
9754	9222	0	applied	\N	\N	\N	\N	91160	91160	259012
9754	9223	1	applied	\N	\N	\N	\N	91161	91161	259013
9759	9231	1	applied	\N	\N	\N	\N	91173	91173	259025
9761	9234	0	applied	\N	\N	\N	\N	91176	91176	259028
9761	9235	1	applied	\N	\N	\N	\N	91177	91177	259029
9761	9236	2	applied	\N	\N	\N	\N	91178	91178	259030
9767	9247	0	applied	\N	\N	\N	\N	91214	91214	259056
9767	9248	1	applied	\N	\N	\N	\N	91215	91215	259057
9767	9249	2	applied	\N	\N	\N	\N	91216	91216	259058
9767	9250	3	applied	\N	\N	\N	\N	91217	91217	259059
9767	9251	4	applied	\N	\N	\N	\N	91218	91218	259060
9767	9252	5	applied	\N	\N	\N	\N	91219	91219	259061
9767	9253	6	applied	\N	\N	\N	\N	91220	91220	91220
9767	9254	7	applied	\N	\N	\N	\N	91221	91221	91221
9767	9255	8	applied	\N	\N	\N	\N	91222	91222	91222
9767	9256	9	applied	\N	\N	\N	\N	91223	91223	91223
9767	9257	10	applied	\N	\N	\N	\N	91224	91224	91224
9769	9247	0	applied	\N	\N	\N	\N	91236	91236	259068
9769	9249	2	applied	\N	\N	\N	\N	91238	91238	259070
9769	9250	3	applied	\N	\N	\N	\N	91239	91239	259071
9769	9251	4	applied	\N	\N	\N	\N	91240	91240	259072
9769	9252	5	applied	\N	\N	\N	\N	91241	91241	259073
9769	9253	6	applied	\N	\N	\N	\N	91242	91242	91242
9769	9254	7	applied	\N	\N	\N	\N	91243	91243	91243
9769	9255	8	applied	\N	\N	\N	\N	91244	91244	91244
9769	9256	9	applied	\N	\N	\N	\N	91245	91245	91245
9769	9257	10	applied	\N	\N	\N	\N	91246	91246	91246
9771	9260	0	applied	\N	\N	\N	\N	91249	91249	259076
9771	9261	1	applied	\N	\N	\N	\N	91250	91250	259077
9778	9268	0	applied	\N	\N	\N	\N	91265	91265	259092
9778	9269	1	applied	\N	\N	\N	\N	91266	91266	259093
9778	9270	2	applied	\N	\N	\N	\N	91267	91267	259094
9778	9271	3	applied	\N	\N	\N	\N	91268	91268	259095
9781	9277	1	applied	\N	\N	\N	\N	91277	91277	259104
9781	9278	2	applied	\N	\N	\N	\N	91278	91278	259105
9783	9279	0	applied	\N	\N	\N	\N	91283	91283	259110
9783	9280	1	applied	\N	\N	\N	\N	91284	91284	259111
9783	9281	2	applied	\N	\N	\N	\N	91285	91285	259112
9783	9282	3	applied	\N	\N	\N	\N	91286	91286	259113
9786	9288	0	applied	\N	\N	\N	\N	91292	91292	259119
9786	9289	1	applied	\N	\N	\N	\N	91293	91293	259120
9786	9290	2	applied	\N	\N	\N	\N	91294	91294	259121
9786	9291	3	applied	\N	\N	\N	\N	91295	91295	259122
9791	9315	0	applied	\N	\N	\N	\N	91326	91326	259153
9791	9316	1	applied	\N	\N	\N	\N	91327	91327	259154
9791	9317	2	applied	\N	\N	1000000000	\N	91328	91328	259155
9794	9320	0	applied	\N	\N	\N	\N	91333	91333	259160
9794	9321	1	applied	\N	\N	\N	\N	91334	91334	259161
9794	9322	2	applied	\N	\N	\N	\N	91335	91335	259162
9794	9323	3	applied	\N	\N	\N	\N	91336	91336	259163
9797	9326	0	applied	\N	\N	\N	\N	91342	91342	259169
9797	9327	1	applied	\N	\N	\N	\N	91343	91343	259170
9799	9329	0	applied	\N	\N	\N	\N	91348	91348	259175
9799	9330	1	applied	\N	\N	\N	\N	91349	91349	91349
9799	9331	2	applied	\N	\N	\N	\N	91350	91350	259176
9799	9332	3	applied	\N	\N	\N	\N	91351	91351	259177
9799	9334	5	applied	\N	\N	\N	\N	91353	91353	259178
9799	9335	6	applied	\N	\N	\N	\N	91354	91354	259179
9799	9336	7	applied	\N	\N	\N	\N	91355	91355	259180
9799	9337	8	applied	\N	\N	\N	\N	91356	91356	259181
9799	9338	9	applied	\N	\N	\N	\N	91357	91357	259182
9799	9339	10	applied	\N	\N	\N	\N	91358	91358	259183
9801	9340	0	applied	\N	\N	\N	\N	91361	91361	259186
9801	9341	1	applied	\N	\N	\N	\N	91362	91362	259187
9812	9359	0	applied	\N	\N	\N	\N	91402	91402	259227
9812	9360	1	applied	\N	\N	\N	\N	91403	91403	259228
9812	9361	2	applied	\N	\N	\N	\N	91404	91404	259229
9812	9362	3	applied	\N	\N	\N	\N	91405	91405	259230
9812	9363	4	applied	\N	\N	\N	\N	91406	91406	259231
9814	9359	0	applied	\N	\N	\N	\N	91414	91414	259239
9814	9360	1	applied	\N	\N	\N	\N	91415	91415	259240
9814	9361	2	applied	\N	\N	\N	\N	91416	91416	259241
9814	9362	3	applied	\N	\N	\N	\N	91417	91417	259242
9814	9363	4	applied	\N	\N	\N	\N	91418	91418	259243
9814	9364	5	applied	\N	\N	\N	\N	91419	91419	259244
9816	9365	0	applied	\N	\N	\N	\N	91426	91426	259251
9816	9366	1	applied	\N	\N	\N	\N	91427	91427	259252
9730	9170	0	applied	\N	\N	\N	\N	91042	91042	258894
9730	9171	1	applied	\N	\N	\N	\N	91043	91043	258895
9762	9240	3	applied	\N	\N	\N	\N	91182	91182	259034
9762	9241	4	applied	\N	\N	\N	\N	91183	91183	259035
9762	9242	5	applied	\N	\N	\N	\N	91184	91184	259036
9762	9243	6	applied	\N	\N	\N	\N	91185	91185	259037
9765	9247	0	applied	\N	\N	\N	\N	91192	91192	259044
9765	9248	1	applied	\N	\N	\N	\N	91193	91193	259045
9765	9249	2	applied	\N	\N	\N	\N	91194	91194	259046
9765	9250	3	applied	\N	\N	\N	\N	91195	91195	259047
9765	9251	4	applied	\N	\N	\N	\N	91196	91196	259048
9765	9252	5	applied	\N	\N	\N	\N	91197	91197	259049
9765	9253	6	applied	\N	\N	\N	\N	91198	91198	91198
9765	9254	7	applied	\N	\N	\N	\N	91199	91199	91199
9765	9255	8	applied	\N	\N	\N	\N	91200	91200	91200
9765	9256	9	applied	\N	\N	\N	\N	91201	91201	91201
9772	9262	0	applied	\N	\N	\N	\N	91251	91251	259078
9772	9263	1	applied	\N	\N	\N	\N	91252	91252	259079
9776	9264	0	applied	\N	\N	\N	\N	91257	91257	259084
9776	9265	1	applied	\N	\N	\N	\N	91258	91258	259085
9789	9299	0	applied	\N	\N	\N	\N	91310	91310	259137
9789	9300	1	applied	\N	\N	\N	\N	91311	91311	259138
9789	9301	2	applied	\N	\N	\N	\N	91312	91312	259139
9789	9302	3	applied	\N	\N	\N	\N	91313	91313	259140
9789	9303	4	applied	\N	\N	\N	\N	91314	91314	259141
9789	9304	5	applied	\N	\N	\N	\N	91315	91315	259142
9789	9305	6	applied	\N	\N	\N	\N	91316	91316	259143
9789	9306	7	applied	\N	\N	\N	\N	91317	91317	259144
9792	9318	0	applied	\N	\N	\N	\N	91329	91329	259156
9792	9319	1	applied	\N	\N	\N	\N	91330	91330	259157
9802	9340	0	applied	\N	\N	\N	\N	91363	91363	259188
9804	9341	0	applied	\N	\N	\N	\N	91365	91365	259190
9806	9343	0	applied	\N	\N	\N	\N	91369	91369	259194
9806	9344	1	applied	\N	\N	\N	\N	91370	91370	259195
9806	9345	2	applied	\N	\N	\N	\N	91371	91371	259196
9809	9346	0	applied	\N	\N	\N	\N	91380	91380	259205
9809	9347	1	applied	\N	\N	\N	\N	91381	91381	259206
9809	9348	2	applied	\N	\N	\N	\N	91382	91382	259207
9809	9349	3	applied	\N	\N	\N	\N	91383	91383	259208
9810	9350	0	applied	\N	\N	\N	\N	91384	91384	259209
9810	9351	1	applied	\N	\N	\N	\N	91385	91385	259210
9810	9352	2	applied	\N	\N	\N	\N	91386	91386	259211
9810	9353	3	applied	\N	\N	\N	\N	91387	91387	259212
9810	9354	4	applied	\N	\N	\N	\N	91388	91388	259213
9810	9355	5	applied	\N	\N	\N	\N	91389	91389	259214
9810	9356	6	applied	\N	\N	\N	\N	91390	91390	259215
9810	9357	7	applied	\N	\N	\N	\N	91391	91391	259216
9810	9358	8	applied	\N	\N	\N	\N	91392	91392	259217
9811	9351	1	applied	\N	\N	\N	\N	91394	91394	259219
9811	9352	2	applied	\N	\N	\N	\N	91395	91395	259220
9811	9353	3	applied	\N	\N	\N	\N	91396	91396	259221
9811	9354	4	applied	\N	\N	\N	\N	91397	91397	259222
9811	9355	5	applied	\N	\N	\N	\N	91398	91398	259223
9811	9356	6	applied	\N	\N	\N	\N	91399	91399	259224
9811	9357	7	applied	\N	\N	\N	\N	91400	91400	259225
9811	9358	8	applied	\N	\N	\N	\N	91401	91401	259226
9813	9359	0	applied	\N	\N	\N	\N	91408	91408	259233
9813	9360	1	applied	\N	\N	\N	\N	91409	91409	259234
9813	9361	2	applied	\N	\N	\N	\N	91410	91410	259235
9813	9362	3	applied	\N	\N	\N	\N	91411	91411	259236
9813	9363	4	applied	\N	\N	\N	\N	91412	91412	259237
9813	9364	5	applied	\N	\N	\N	\N	91413	91413	259238
9815	9359	0	applied	\N	\N	\N	\N	91420	91420	259245
9815	9360	1	applied	\N	\N	\N	\N	91421	91421	259246
9815	9362	3	applied	\N	\N	\N	\N	91423	91423	259248
9815	9363	4	applied	\N	\N	\N	\N	91424	91424	259249
9815	9364	5	applied	\N	\N	\N	\N	91425	91425	259250
9817	9367	0	applied	\N	\N	\N	\N	91428	91428	259253
9817	9368	1	applied	\N	\N	\N	\N	91429	91429	259254
9817	9369	2	applied	\N	\N	\N	\N	91430	91430	259255
9817	9370	3	applied	\N	\N	\N	\N	91431	91431	259256
9817	9371	4	applied	\N	\N	\N	\N	91432	91432	259257
9817	9372	5	applied	\N	\N	\N	\N	91433	91433	259258
9817	9373	6	applied	\N	\N	\N	\N	91434	91434	259259
9817	9374	7	applied	\N	\N	\N	\N	91435	91435	259260
9817	9375	8	applied	\N	\N	\N	\N	91436	91436	259261
9817	9376	9	applied	\N	\N	\N	\N	91437	91437	259262
9817	9377	10	applied	\N	\N	\N	\N	91438	91438	259263
9817	9378	11	applied	\N	\N	\N	\N	91439	91439	259264
9818	9367	0	applied	\N	\N	\N	\N	91440	91440	259265
9818	9369	2	applied	\N	\N	\N	\N	91442	91442	259267
9818	9370	3	applied	\N	\N	\N	\N	91443	91443	259268
9818	9371	4	applied	\N	\N	\N	\N	91444	91444	259269
9818	9372	5	applied	\N	\N	\N	\N	91445	91445	259270
9818	9373	6	applied	\N	\N	\N	\N	91446	91446	259271
9818	9374	7	applied	\N	\N	\N	\N	91447	91447	259272
9818	9375	8	applied	\N	\N	\N	\N	91448	91448	259273
9818	9376	9	applied	\N	\N	\N	\N	91449	91449	259274
9818	9377	10	applied	\N	\N	\N	\N	91450	91450	259275
9818	9378	11	applied	\N	\N	\N	\N	91451	91451	259276
9819	9367	0	applied	\N	\N	\N	\N	91452	91452	259277
9819	9368	1	applied	\N	\N	\N	\N	91453	91453	259278
9819	9369	2	applied	\N	\N	\N	\N	91454	91454	259279
9819	9370	3	applied	\N	\N	\N	\N	91455	91455	259280
9819	9371	4	applied	\N	\N	\N	\N	91456	91456	259281
9819	9372	5	applied	\N	\N	\N	\N	91457	91457	259282
9819	9374	7	applied	\N	\N	\N	\N	91459	91459	259284
9819	9375	8	applied	\N	\N	\N	\N	91460	91460	259285
9819	9376	9	applied	\N	\N	\N	\N	91461	91461	259286
9819	9377	10	applied	\N	\N	\N	\N	91462	91462	259287
9819	9378	11	applied	\N	\N	\N	\N	91463	91463	259288
9820	9367	0	applied	\N	\N	\N	\N	91464	91464	259289
9820	9368	1	applied	\N	\N	\N	\N	91465	91465	259290
9820	9369	2	applied	\N	\N	\N	\N	91466	91466	259291
9820	9370	3	applied	\N	\N	\N	\N	91467	91467	259292
9820	9371	4	applied	\N	\N	\N	\N	91468	91468	259293
9820	9372	5	applied	\N	\N	\N	\N	91469	91469	259294
9820	9373	6	applied	\N	\N	\N	\N	91470	91470	259295
9820	9374	7	applied	\N	\N	\N	\N	91471	91471	259296
9820	9375	8	applied	\N	\N	\N	\N	91472	91472	259297
9820	9376	9	applied	\N	\N	\N	\N	91473	91473	259298
9820	9377	10	applied	\N	\N	\N	\N	91474	91474	259299
9762	9239	2	applied	\N	\N	1000000000	\N	91181	91181	259033
9821	9381	2	applied	\N	\N	\N	\N	91478	91478	259303
9821	9382	3	applied	\N	\N	\N	\N	91479	91479	259304
9821	9383	4	applied	\N	\N	\N	\N	91480	91480	259305
9821	9385	6	applied	\N	\N	\N	\N	91482	91482	259307
9821	9386	7	applied	\N	\N	\N	\N	91483	91483	259308
9821	9387	8	applied	\N	\N	\N	\N	91484	91484	259309
9822	9379	0	applied	\N	\N	\N	\N	91485	91485	259310
9822	9380	1	applied	\N	\N	\N	\N	91486	91486	259311
9822	9381	2	applied	\N	\N	\N	\N	91487	91487	259312
9822	9382	3	applied	\N	\N	\N	\N	91488	91488	259313
9822	9383	4	applied	\N	\N	\N	\N	91489	91489	259314
9822	9384	5	applied	\N	\N	\N	\N	91490	91490	259315
9822	9385	6	applied	\N	\N	\N	\N	91491	91491	259316
9822	9386	7	applied	\N	\N	\N	\N	91492	91492	259317
9822	9387	8	applied	\N	\N	\N	\N	91493	91493	259318
9822	9388	10	applied	\N	\N	\N	\N	91494	91494	259319
9823	9379	0	applied	\N	\N	\N	\N	91495	91495	259320
9823	9380	1	applied	\N	\N	\N	\N	91496	91496	259321
9823	9381	2	applied	\N	\N	\N	\N	91497	91497	259322
9823	9383	4	applied	\N	\N	\N	\N	91499	91499	259324
9823	9384	5	applied	\N	\N	\N	\N	91500	91500	259325
9823	9385	6	applied	\N	\N	\N	\N	91501	91501	259326
9823	9386	7	applied	\N	\N	\N	\N	91502	91502	259327
9823	9387	8	applied	\N	\N	\N	\N	91503	91503	259328
9823	9388	10	applied	\N	\N	\N	\N	91504	91504	259329
9823	9389	11	applied	\N	\N	\N	\N	91505	91505	259330
9823	9390	12	applied	\N	\N	\N	\N	91506	91506	259331
9823	9391	13	applied	\N	\N	\N	\N	91507	91507	259332
9823	9392	14	applied	\N	\N	\N	\N	91508	91508	259333
9823	9393	15	applied	\N	\N	\N	\N	91509	91509	259334
9823	9394	16	applied	\N	\N	\N	\N	91510	91510	259335
9823	9395	17	applied	\N	\N	\N	\N	91511	91511	259336
9823	9396	18	applied	\N	\N	\N	\N	91512	91512	259337
9823	9397	19	applied	\N	\N	\N	\N	91513	91513	259338
9823	9398	20	applied	\N	\N	\N	\N	91514	91514	259339
9823	9400	22	applied	\N	\N	\N	\N	91516	91516	259341
9824	9329	0	applied	\N	\N	\N	\N	91517	91517	259342
9824	9330	1	applied	\N	\N	\N	\N	91518	91518	91518
9824	9226	2	applied	\N	\N	\N	\N	91519	91519	259343
9824	9091	3	applied	\N	\N	1000000000	\N	91520	91520	259344
9824	9148	4	applied	\N	\N	\N	\N	91521	91521	259345
9824	9157	5	applied	\N	\N	\N	\N	91522	91522	259346
9824	9158	6	applied	\N	\N	\N	\N	91523	91523	259347
9824	9159	7	applied	\N	\N	\N	\N	91524	91524	259348
9824	9174	8	applied	\N	\N	\N	\N	91525	91525	259349
9824	9276	9	applied	\N	\N	1000000000	\N	91526	91526	259350
9824	9293	10	applied	\N	\N	\N	\N	91527	91527	259351
9824	9294	11	applied	\N	\N	\N	\N	91528	91528	259352
9824	9189	12	applied	\N	\N	\N	\N	91529	91529	259353
9824	9108	13	applied	\N	\N	\N	\N	91530	91530	259354
9824	9331	14	applied	\N	\N	\N	\N	91531	91531	259355
9824	9234	16	applied	\N	\N	\N	\N	91533	91533	259357
9824	9237	17	applied	\N	\N	\N	\N	91534	91534	259358
9824	9191	18	applied	\N	\N	\N	\N	91535	91535	259359
9824	9192	19	applied	\N	\N	\N	\N	91536	91536	259360
9824	9193	20	applied	\N	\N	\N	\N	91537	91537	259361
9824	9131	21	applied	\N	\N	\N	\N	91538	91538	259362
9824	9133	22	applied	\N	\N	\N	\N	91539	91539	259363
9824	9145	23	applied	\N	\N	\N	\N	91540	91540	259364
9824	9089	24	applied	\N	\N	1000000000	\N	91541	91541	259365
9824	9092	25	applied	\N	\N	\N	\N	91542	91542	259366
9824	9135	26	applied	\N	\N	\N	\N	91543	91543	259367
9824	9138	27	applied	\N	\N	\N	\N	91544	91544	259368
9824	9173	28	applied	\N	\N	\N	\N	91545	91545	259369
9824	9197	29	applied	\N	\N	\N	\N	91546	91546	259370
9824	9295	30	applied	\N	\N	\N	\N	91547	91547	259371
9824	9178	31	applied	\N	\N	\N	\N	91548	91548	259372
9824	9180	33	applied	\N	\N	\N	\N	91550	91550	259374
9824	9238	34	applied	\N	\N	\N	\N	91551	91551	259375
9824	9239	35	applied	\N	\N	1000000000	\N	91552	91552	259376
9824	9200	36	applied	\N	\N	\N	\N	91553	91553	259377
9824	9119	37	applied	\N	\N	\N	\N	91554	91554	259378
9824	9120	38	applied	\N	\N	\N	\N	91555	91555	259379
9824	9122	39	applied	\N	\N	\N	\N	91556	91556	259380
9824	9149	40	applied	\N	\N	\N	\N	91557	91557	259381
9824	9164	41	applied	\N	\N	\N	\N	91558	91558	259382
9824	9165	42	applied	\N	\N	\N	\N	91559	91559	259383
9824	9166	43	applied	\N	\N	\N	\N	91560	91560	259384
9824	9172	44	applied	\N	\N	\N	\N	91561	91561	259385
9824	9124	45	applied	\N	\N	\N	\N	91562	91562	259386
9824	9297	46	applied	\N	\N	\N	\N	91563	91563	259387
9824	9298	47	applied	\N	\N	\N	\N	91564	91564	259388
9824	9113	48	applied	\N	\N	\N	\N	91565	91565	259389
9824	9116	50	applied	\N	\N	\N	\N	91567	91567	259391
9824	9117	51	applied	\N	\N	\N	\N	91568	91568	259392
9824	9211	52	applied	\N	\N	\N	\N	91569	91569	259393
9824	9215	53	applied	\N	\N	\N	\N	91570	91570	259394
9824	9216	54	applied	\N	\N	\N	\N	91571	91571	259395
9824	9217	55	applied	\N	\N	\N	\N	91572	91572	259396
9824	9301	56	applied	\N	\N	\N	\N	91573	91573	259397
9824	9302	57	applied	\N	\N	\N	\N	91574	91574	259398
9824	9303	58	applied	\N	\N	\N	\N	91575	91575	259399
9824	9304	59	applied	\N	\N	\N	\N	91576	91576	259400
9824	9305	60	applied	\N	\N	\N	\N	91577	91577	259401
9824	9306	61	applied	\N	\N	\N	\N	91578	91578	259402
9824	9310	62	applied	\N	\N	\N	\N	91579	91579	259403
9824	9311	63	applied	\N	\N	\N	\N	91580	91580	259404
9824	9312	64	applied	\N	\N	\N	\N	91581	91581	259405
9824	9338	66	applied	\N	\N	\N	\N	91583	91583	259407
9824	9339	67	applied	\N	\N	\N	\N	91584	91584	259408
9824	9154	68	applied	\N	\N	1000000000	\N	91585	91585	259409
9824	9160	69	applied	\N	\N	\N	\N	91586	91586	259410
9824	9142	70	applied	\N	\N	\N	\N	91587	91587	259411
9824	9273	71	applied	\N	\N	\N	\N	91588	91588	259412
9824	9253	72	applied	\N	\N	\N	\N	91589	91589	91589
9824	9147	73	applied	\N	\N	\N	\N	91590	91590	259413
9824	9345	74	applied	\N	\N	\N	\N	91591	91591	259414
9824	9348	75	applied	\N	\N	\N	\N	91592	91592	259415
9824	9184	76	applied	\N	\N	1000000000	\N	91593	91593	259416
9821	9379	0	applied	\N	\N	\N	\N	91476	91476	259301
9821	9380	1	applied	\N	\N	\N	\N	91477	91477	259302
9824	9255	81	applied	\N	\N	\N	\N	91598	91598	91598
9824	9349	82	applied	\N	\N	\N	\N	91599	91599	259420
9824	9352	83	applied	\N	\N	\N	\N	91600	91600	259421
9824	9353	84	applied	\N	\N	\N	\N	91601	91601	259422
9824	9354	85	applied	\N	\N	\N	\N	91602	91602	259423
9824	9355	86	applied	\N	\N	\N	\N	91603	91603	259424
9824	9356	87	applied	\N	\N	\N	\N	91604	91604	259425
9824	9357	88	applied	\N	\N	\N	\N	91605	91605	259426
9824	9358	89	applied	\N	\N	\N	\N	91606	91606	259427
9824	9364	90	applied	\N	\N	\N	\N	91607	91607	259428
9824	9381	91	applied	\N	\N	\N	\N	91608	91608	259429
9824	9382	92	applied	\N	\N	\N	\N	91609	91609	259430
9824	9383	93	applied	\N	\N	\N	\N	91610	91610	259431
9824	9384	94	applied	\N	\N	\N	\N	91611	91611	259432
9824	9385	95	applied	\N	\N	\N	\N	91612	91612	259433
9824	9387	96	applied	\N	\N	\N	\N	91613	91613	259434
9824	9389	98	applied	\N	\N	\N	\N	91615	91615	259436
9824	9390	99	applied	\N	\N	\N	\N	91616	91616	259437
9824	9208	100	applied	\N	\N	\N	\N	91617	91617	259438
9824	9214	101	applied	\N	\N	\N	\N	91618	91618	259439
9824	9221	102	applied	\N	\N	\N	\N	91619	91619	259440
9824	9229	103	applied	\N	\N	\N	\N	91620	91620	259441
9824	9274	104	applied	\N	\N	\N	\N	91621	91621	259442
9824	9275	105	applied	\N	\N	\N	\N	91622	91622	259443
9824	9156	106	applied	\N	\N	\N	\N	91623	91623	259444
9824	9401	108	applied	\N	\N	\N	\N	91624	91624	259445
9824	9400	109	applied	\N	\N	\N	\N	91625	91625	259446
9824	9256	110	applied	\N	\N	\N	\N	91626	91626	91626
9824	9257	111	applied	\N	\N	\N	\N	91627	91627	91627
9824	9268	112	applied	\N	\N	\N	\N	91628	91628	259447
9824	9269	113	applied	\N	\N	\N	\N	91629	91629	259448
9824	9270	114	applied	\N	\N	\N	\N	91630	91630	259449
9825	9402	0	applied	\N	\N	\N	\N	91632	91632	259451
9826	9403	0	applied	\N	\N	\N	\N	91633	91633	259452
9826	9404	1	applied	\N	\N	\N	\N	91634	91634	259453
9826	9405	2	applied	\N	\N	\N	\N	91635	91635	259454
9826	9406	3	applied	\N	\N	\N	\N	91636	91636	259455
9826	9407	4	applied	\N	\N	\N	\N	91637	91637	259456
9826	9408	5	applied	\N	\N	\N	\N	91638	91638	259457
9826	9409	6	applied	\N	\N	\N	\N	91639	91639	259458
9826	9410	7	applied	\N	\N	\N	\N	91640	91640	259459
9826	9411	8	applied	\N	\N	\N	\N	91641	91641	259460
9826	9412	9	applied	\N	\N	\N	\N	91642	91642	259461
9826	9413	10	applied	\N	\N	\N	\N	91643	91643	259462
9826	9414	11	applied	\N	\N	\N	\N	91644	91644	259463
9826	9388	12	applied	\N	\N	\N	\N	91645	91645	259464
9826	9389	13	applied	\N	\N	\N	\N	91646	91646	259465
9826	9390	14	applied	\N	\N	\N	\N	91647	91647	259466
9826	9392	16	applied	\N	\N	\N	\N	91649	91649	259468
9826	9393	17	applied	\N	\N	\N	\N	91650	91650	259469
9826	9394	18	applied	\N	\N	\N	\N	91651	91651	259470
9826	9395	19	applied	\N	\N	\N	\N	91652	91652	259471
9826	9396	20	applied	\N	\N	\N	\N	91653	91653	259472
9826	9397	21	applied	\N	\N	\N	\N	91654	91654	259473
9826	9398	22	applied	\N	\N	\N	\N	91655	91655	259474
9826	9399	23	applied	\N	\N	\N	\N	91656	91656	259475
9826	9415	24	applied	\N	\N	\N	\N	91657	91657	259476
9826	9400	25	applied	\N	\N	\N	\N	91658	91658	259477
9827	9416	0	applied	\N	\N	\N	\N	91659	91659	259478
9827	9417	1	applied	\N	\N	\N	\N	91660	91660	259479
9827	9418	2	applied	\N	\N	\N	\N	91661	91661	259480
9827	9419	3	applied	\N	\N	\N	\N	91662	91662	259481
9827	9420	4	applied	\N	\N	\N	\N	91663	91663	259482
9827	9421	5	applied	\N	\N	\N	\N	91664	91664	259483
9827	9423	7	applied	\N	\N	\N	\N	91666	91666	259485
9829	9329	0	applied	\N	\N	\N	\N	91668	91668	259487
9829	9330	1	applied	\N	\N	\N	\N	91669	91669	91669
9829	9226	2	applied	\N	\N	\N	\N	91670	91670	259488
9829	9402	3	applied	\N	\N	\N	\N	91671	91671	259489
9829	9403	4	applied	\N	\N	\N	\N	91672	91672	259490
9831	9426	0	applied	\N	\N	\N	\N	91752	91752	259567
9831	9427	1	applied	\N	\N	\N	\N	91753	91753	259568
9831	9428	2	applied	\N	\N	\N	\N	91754	91754	259569
9831	9429	3	applied	\N	\N	\N	\N	91755	91755	259570
9831	9430	4	applied	\N	\N	\N	\N	91756	91756	259571
9831	9431	5	applied	\N	\N	\N	\N	91757	91757	259572
9831	9432	6	applied	\N	\N	\N	\N	91758	91758	259573
9835	9448	0	applied	\N	\N	\N	\N	91777	91777	259592
9835	9449	1	applied	\N	\N	\N	\N	91778	91778	259593
9844	9456	0	applied	\N	\N	\N	\N	91795	91795	259610
9847	9460	0	applied	\N	\N	\N	\N	91804	91804	259619
9847	9461	1	applied	\N	\N	\N	\N	91805	91805	259620
9847	9462	2	applied	\N	\N	\N	\N	91806	91806	259621
9847	9463	3	applied	\N	\N	\N	\N	91807	91807	259622
9847	9464	4	applied	\N	\N	\N	\N	91808	91808	259623
9847	9465	5	applied	\N	\N	\N	\N	91809	91809	259624
9852	9473	0	applied	\N	\N	\N	\N	91818	91818	259633
9852	9474	1	applied	\N	\N	\N	\N	91819	91819	259634
9852	9475	2	applied	\N	\N	\N	\N	91820	91820	259635
9858	9486	0	applied	\N	\N	\N	\N	91834	91834	259649
9858	9487	1	applied	\N	\N	\N	\N	91835	91835	259650
9858	9488	2	applied	\N	\N	\N	\N	91836	91836	259651
9858	9489	3	applied	\N	\N	\N	\N	91837	91837	259652
9858	9490	4	applied	\N	\N	\N	\N	91838	91838	259653
9858	9491	5	applied	\N	\N	\N	\N	91839	91839	259654
9858	9492	6	applied	\N	\N	\N	\N	91840	91840	259655
9861	9500	1	applied	\N	\N	\N	\N	91848	91848	259663
9864	9499	0	applied	\N	\N	\N	\N	91853	91853	259668
9864	9500	1	applied	\N	\N	\N	\N	91854	91854	259669
9865	9501	0	applied	\N	\N	\N	\N	91855	91855	259670
9870	9506	0	applied	\N	\N	\N	\N	91869	91869	259684
9870	9507	1	applied	\N	\N	\N	\N	91870	91870	259685
9889	9523	0	applied	\N	\N	\N	\N	91902	91902	259717
9889	9524	1	applied	\N	\N	\N	\N	91903	91903	259718
9891	9525	0	applied	\N	\N	\N	\N	91906	91906	259721
9891	9526	1	applied	\N	\N	\N	\N	91907	91907	259722
9891	9527	2	applied	\N	\N	\N	\N	91908	91908	259723
9891	9528	3	applied	\N	\N	\N	\N	91909	91909	259724
9896	9534	0	applied	\N	\N	\N	\N	91921	91921	259736
9896	9535	1	applied	\N	\N	\N	\N	91922	91922	259737
9824	9201	78	applied	\N	\N	\N	\N	91595	91595	259418
9824	9155	79	applied	\N	\N	\N	\N	91596	91596	259419
9830	9424	3	applied	\N	\N	\N	\N	91746	91746	259561
9830	9420	4	applied	\N	\N	\N	\N	91747	91747	259562
9830	9421	5	applied	\N	\N	\N	\N	91748	91748	259563
9830	9422	6	applied	\N	\N	\N	\N	91749	91749	259564
9830	9425	7	applied	\N	\N	\N	\N	91750	91750	259565
9830	9423	8	applied	\N	\N	\N	\N	91751	91751	259566
9833	9433	0	applied	\N	\N	\N	\N	91761	91761	259576
9833	9434	1	applied	\N	\N	\N	\N	91762	91762	259577
9833	9435	2	applied	\N	\N	\N	\N	91763	91763	259578
9834	9436	0	applied	\N	\N	\N	\N	91764	91764	259579
9834	9437	1	applied	\N	\N	\N	\N	91765	91765	259580
9834	9438	2	applied	\N	\N	\N	\N	91766	91766	259581
9834	9439	3	applied	\N	\N	\N	\N	91767	91767	259582
9834	9435	4	applied	\N	\N	\N	\N	91768	91768	259583
9834	9440	5	applied	\N	\N	\N	\N	91769	91769	259584
9834	9441	6	applied	\N	\N	\N	\N	91770	91770	259585
9834	9443	8	applied	\N	\N	\N	\N	91772	91772	259587
9834	9444	9	applied	\N	\N	\N	\N	91773	91773	259588
9834	9445	10	applied	\N	\N	\N	\N	91774	91774	259589
9834	9446	11	applied	\N	\N	\N	\N	91775	91775	259590
9834	9447	12	applied	\N	\N	\N	\N	91776	91776	259591
9837	9450	0	applied	\N	\N	\N	\N	91781	91781	259596
9837	9451	1	applied	\N	\N	\N	\N	91782	91782	259597
9839	9452	0	applied	\N	\N	\N	\N	91785	91785	259600
9839	9453	1	applied	\N	\N	\N	\N	91786	91786	259601
9849	9466	0	applied	\N	\N	\N	\N	91811	91811	259626
9854	9476	0	applied	\N	\N	\N	\N	91824	91824	259639
9857	9484	0	applied	\N	\N	\N	\N	91832	91832	259647
9857	9485	1	applied	\N	\N	\N	\N	91833	91833	259648
9860	9497	0	applied	\N	\N	\N	\N	91845	91845	259660
9860	9498	1	applied	\N	\N	\N	\N	91846	91846	259661
9863	9499	0	applied	\N	\N	\N	\N	91851	91851	259666
9867	9502	0	applied	\N	\N	\N	\N	91857	91857	259672
9867	9503	1	applied	\N	\N	\N	\N	91858	91858	259673
9867	9504	2	applied	\N	\N	\N	\N	91859	91859	259674
9867	9505	3	applied	\N	\N	\N	\N	91860	91860	259675
9872	9508	0	applied	\N	\N	\N	\N	91873	91873	259688
9901	9540	0	applied	\N	\N	\N	\N	91931	91931	259746
9901	9541	1	applied	\N	\N	\N	\N	91932	91932	259747
9904	9546	0	applied	\N	\N	\N	\N	91937	91937	259752
9904	9547	1	applied	\N	\N	\N	\N	91938	91938	259753
9906	9548	0	applied	\N	\N	\N	\N	91943	91943	259758
9906	9549	1	applied	\N	\N	\N	\N	91944	91944	259759
9909	9550	0	applied	\N	\N	\N	\N	91945	91945	259760
9909	9551	1	applied	\N	\N	\N	\N	91946	91946	259761
9909	9552	2	applied	\N	\N	\N	\N	91947	91947	259762
9909	9553	3	applied	\N	\N	\N	\N	91948	91948	259763
9909	9554	4	applied	\N	\N	\N	\N	91949	91949	259764
9909	9556	6	applied	\N	\N	\N	\N	91951	91951	259766
9909	9557	7	applied	\N	\N	\N	\N	91952	91952	259767
9912	9560	0	applied	\N	\N	\N	\N	91959	91959	259774
9912	9561	1	applied	\N	\N	\N	\N	91960	91960	259775
9912	9562	2	applied	\N	\N	\N	\N	91961	91961	259776
9912	9563	3	applied	\N	\N	\N	\N	91962	91962	259777
9914	9565	0	applied	\N	\N	\N	\N	91964	91964	259779
9914	9566	1	applied	\N	\N	\N	\N	91965	91965	259780
9917	9573	0	applied	\N	\N	\N	\N	91972	91972	259787
9917	9574	1	applied	\N	\N	\N	\N	91973	91973	259788
9917	9575	2	applied	\N	\N	\N	\N	91974	91974	259789
9920	9583	0	applied	\N	\N	\N	\N	91985	91985	259800
9920	9584	1	applied	\N	\N	\N	\N	91986	91986	259801
9925	9589	0	applied	\N	\N	\N	\N	91995	91995	259810
9925	9590	1	applied	\N	\N	\N	\N	91996	91996	259811
9927	9591	0	applied	\N	\N	\N	\N	92002	92002	259817
9927	9593	2	applied	\N	\N	\N	\N	92004	92004	259819
9927	9594	3	applied	\N	\N	\N	\N	92005	92005	259820
9927	9595	4	applied	\N	\N	\N	\N	92006	92006	259821
9940	9614	0	applied	\N	\N	\N	\N	92042	92042	259857
9940	9615	1	applied	\N	\N	\N	\N	92043	92043	259858
9944	9619	0	applied	\N	\N	\N	\N	92051	92051	259866
9944	9620	1	applied	\N	\N	\N	\N	92052	92052	259867
9953	9641	0	applied	\N	\N	\N	\N	92080	92080	259895
9955	9642	0	applied	\N	\N	\N	\N	92082	92082	259897
9955	9643	1	applied	\N	\N	\N	\N	92083	92083	259898
9955	9644	2	applied	\N	\N	\N	\N	92084	92084	259899
9955	9645	3	applied	\N	\N	\N	\N	92085	92085	259900
9955	9646	4	applied	\N	\N	\N	\N	92086	92086	259901
9964	9639	0	applied	\N	\N	\N	\N	92093	92093	259908
9964	9640	1	applied	\N	\N	\N	\N	92094	92094	259909
9964	9641	2	applied	\N	\N	\N	\N	92095	92095	259910
9964	9643	4	applied	\N	\N	\N	\N	92097	92097	259912
9964	9644	5	applied	\N	\N	\N	\N	92098	92098	259913
9964	9645	6	applied	\N	\N	\N	\N	92099	92099	259914
9964	9648	7	applied	\N	\N	\N	\N	92100	92100	259915
9964	9649	8	applied	\N	\N	\N	\N	92101	92101	259916
9964	9647	9	applied	\N	\N	\N	\N	92102	92102	259917
9964	9650	10	applied	\N	\N	\N	\N	92103	92103	259918
9964	9651	11	applied	\N	\N	\N	\N	92104	92104	259919
9964	9646	12	applied	\N	\N	\N	\N	92105	92105	259920
9968	9650	0	applied	\N	\N	\N	\N	92128	92128	259943
9968	9648	1	applied	\N	\N	\N	\N	92129	92129	259944
9968	9649	2	applied	\N	\N	\N	\N	92130	92130	259945
9968	9652	3	applied	\N	\N	\N	\N	92131	92131	259946
9968	9651	4	applied	\N	\N	\N	\N	92132	92132	259947
9968	9653	5	applied	\N	\N	\N	\N	92133	92133	259948
9968	9654	6	applied	\N	\N	\N	\N	92134	92134	259949
9971	9656	1	applied	\N	\N	\N	\N	92201	92201	260015
9971	9657	2	applied	\N	\N	\N	\N	92202	92202	260016
9971	9658	3	applied	\N	\N	\N	\N	92203	92203	260017
9977	9661	0	applied	\N	\N	\N	\N	92222	92222	260036
9977	9662	1	applied	\N	\N	\N	\N	92223	92223	260037
9977	9663	2	applied	\N	\N	\N	\N	92224	92224	260038
9977	9664	3	applied	\N	\N	\N	\N	92225	92225	260039
9977	9665	4	applied	\N	\N	\N	\N	92226	92226	260040
9980	9668	0	applied	\N	\N	\N	\N	92231	92231	260045
9980	9669	1	applied	\N	\N	\N	\N	92232	92232	260046
9980	9670	2	applied	\N	\N	\N	\N	92233	92233	260047
9980	9671	3	applied	\N	\N	\N	\N	92234	92234	260048
9980	9672	4	applied	\N	\N	\N	\N	92235	92235	260049
9980	9673	5	applied	\N	\N	\N	\N	92236	92236	260050
9830	9417	0	applied	\N	\N	\N	\N	91743	91743	259558
9830	9418	1	applied	\N	\N	\N	\N	91744	91744	259559
9829	9173	8	applied	\N	\N	\N	\N	91676	91676	259494
9829	9174	9	applied	\N	\N	\N	\N	91677	91677	259495
9829	9276	10	applied	\N	\N	1000000000	\N	91678	91678	259496
9829	9293	11	applied	\N	\N	\N	\N	91679	91679	259497
9829	9294	12	applied	\N	\N	\N	\N	91680	91680	259498
9829	9189	13	applied	\N	\N	\N	\N	91681	91681	259499
9829	9331	14	applied	\N	\N	\N	\N	91682	91682	259500
9829	9332	15	applied	\N	\N	\N	\N	91683	91683	259501
9829	9234	16	applied	\N	\N	\N	\N	91684	91684	259502
9829	9360	17	applied	\N	\N	\N	\N	91685	91685	259503
9829	9361	18	applied	\N	\N	\N	\N	91686	91686	259504
9829	9191	20	applied	\N	\N	\N	\N	91688	91688	259506
9829	9192	21	applied	\N	\N	\N	\N	91689	91689	259507
9829	9193	22	applied	\N	\N	\N	\N	91690	91690	259508
9829	9197	23	applied	\N	\N	\N	\N	91691	91691	259509
9829	9295	24	applied	\N	\N	\N	\N	91692	91692	259510
9829	9178	25	applied	\N	\N	\N	\N	91693	91693	259511
9829	9179	26	applied	\N	\N	\N	\N	91694	91694	259512
9829	9180	27	applied	\N	\N	\N	\N	91695	91695	259513
9829	9238	28	applied	\N	\N	\N	\N	91696	91696	259514
9829	9239	29	applied	\N	\N	1000000000	\N	91697	91697	259515
9829	9164	30	applied	\N	\N	\N	\N	91698	91698	259516
9829	9165	31	applied	\N	\N	\N	\N	91699	91699	259517
9829	9166	32	applied	\N	\N	\N	\N	91700	91700	259518
9829	9172	33	applied	\N	\N	\N	\N	91701	91701	259519
9829	9246	34	applied	\N	\N	\N	\N	91702	91702	259520
9829	9186	35	applied	\N	\N	\N	\N	91703	91703	259521
9829	9362	37	applied	\N	\N	\N	\N	91705	91705	259523
9829	9363	38	applied	\N	\N	\N	\N	91706	91706	259524
9829	9297	39	applied	\N	\N	\N	\N	91707	91707	259525
9829	9298	40	applied	\N	\N	\N	\N	91708	91708	259526
9829	9211	41	applied	\N	\N	\N	\N	91709	91709	259527
9829	9215	42	applied	\N	\N	\N	\N	91710	91710	259528
9829	9216	43	applied	\N	\N	\N	\N	91711	91711	259529
9829	9217	44	applied	\N	\N	\N	\N	91712	91712	259530
9829	9232	45	applied	\N	\N	1000000000	\N	91713	91713	259531
9829	9301	46	applied	\N	\N	\N	\N	91714	91714	259532
9872	9509	1	applied	\N	\N	\N	\N	91874	91874	259689
9888	9523	0	applied	\N	\N	\N	\N	91900	91900	259715
9888	9524	1	applied	\N	\N	\N	\N	91901	91901	259716
9898	9536	0	applied	\N	\N	\N	\N	91925	91925	259740
9898	9537	1	applied	\N	\N	\N	\N	91926	91926	259741
9900	9538	0	applied	\N	\N	\N	\N	91929	91929	259744
9903	9544	0	applied	\N	\N	\N	\N	91935	91935	259750
9903	9545	1	applied	\N	\N	\N	\N	91936	91936	259751
9911	9560	0	applied	\N	\N	\N	\N	91955	91955	259770
9911	9561	1	applied	\N	\N	\N	\N	91956	91956	259771
9911	9562	2	applied	\N	\N	\N	\N	91957	91957	259772
9911	9563	3	applied	\N	\N	\N	\N	91958	91958	259773
9922	9585	0	applied	\N	\N	\N	\N	91989	91989	259804
9932	9599	0	applied	\N	\N	\N	\N	92012	92012	259827
9932	9600	1	applied	\N	\N	\N	\N	92013	92013	259828
9937	9607	0	applied	\N	\N	\N	\N	92031	92031	259846
9937	9608	1	applied	\N	\N	\N	\N	92032	92032	259847
9937	9609	2	applied	\N	\N	\N	\N	92033	92033	259848
9937	9610	3	applied	\N	\N	\N	\N	92034	92034	259849
9937	9611	4	applied	\N	\N	\N	\N	92035	92035	259850
9937	9612	5	applied	\N	\N	\N	\N	92036	92036	259851
9937	9613	6	applied	\N	\N	\N	\N	92037	92037	259852
9939	9615	1	applied	\N	\N	\N	\N	92041	92041	259856
9943	9616	0	applied	\N	\N	\N	\N	92048	92048	259863
9943	9617	1	applied	\N	\N	\N	\N	92049	92049	259864
9943	9618	2	applied	\N	\N	\N	\N	92050	92050	259865
9950	9637	0	applied	\N	\N	\N	\N	92075	92075	259890
9950	9638	1	applied	\N	\N	\N	\N	92076	92076	259891
9952	9641	0	applied	\N	\N	\N	\N	92079	92079	259894
9961	9647	0	applied	\N	\N	\N	\N	92092	92092	259907
9966	9650	0	applied	\N	\N	\N	\N	92113	92113	259928
9966	9648	1	applied	\N	\N	\N	\N	92114	92114	259929
9966	9649	2	applied	\N	\N	\N	\N	92115	92115	259930
9966	9652	3	applied	\N	\N	\N	\N	92116	92116	259931
9966	9651	4	applied	\N	\N	\N	\N	92117	92117	259932
9966	9653	5	applied	\N	\N	\N	\N	92118	92118	259933
9966	9654	6	applied	\N	\N	\N	\N	92119	92119	259934
9970	9655	0	applied	\N	\N	\N	\N	92196	92196	260010
9970	9657	2	applied	\N	\N	\N	\N	92198	92198	260012
9970	9658	3	applied	\N	\N	\N	\N	92199	92199	260013
9975	9655	0	applied	\N	\N	\N	\N	92212	92212	260026
9975	9656	1	applied	\N	\N	\N	\N	92213	92213	260027
9975	9660	2	applied	\N	\N	\N	\N	92214	92214	260028
9979	9666	0	applied	\N	\N	\N	\N	92229	92229	260043
9979	9667	1	applied	\N	\N	\N	\N	92230	92230	260044
9984	9674	0	applied	\N	\N	\N	\N	92255	92255	260069
9984	9675	1	applied	\N	\N	\N	\N	92256	92256	260070
9984	9676	2	applied	\N	\N	\N	\N	92257	92257	260071
9984	9677	3	applied	\N	\N	\N	\N	92258	92258	260072
9984	9678	4	applied	\N	\N	\N	\N	92259	92259	260073
9987	9680	0	applied	\N	\N	\N	\N	92294	92294	260108
9987	9681	1	applied	\N	\N	\N	\N	92295	92295	260109
9987	9682	2	applied	\N	\N	\N	\N	92296	92296	260110
9987	9683	3	applied	\N	\N	\N	\N	92297	92297	260111
9987	9685	5	applied	\N	\N	\N	\N	92299	92299	260113
9991	9688	0	applied	\N	\N	\N	\N	92314	92314	260128
9991	9689	1	applied	\N	\N	\N	\N	92315	92315	260129
9994	9698	0	applied	\N	\N	\N	\N	92324	92324	260138
9994	9699	1	applied	\N	\N	\N	\N	92325	92325	260139
9998	9329	0	applied	\N	\N	\N	\N	92363	92363	260177
9998	9330	1	applied	\N	\N	\N	\N	92364	92364	92364
9998	9110	2	applied	\N	\N	\N	\N	92365	92365	260178
9998	9148	3	applied	\N	\N	\N	\N	92366	92366	260179
9998	9157	4	applied	\N	\N	\N	\N	92367	92367	260180
9998	9158	5	applied	\N	\N	\N	\N	92368	92368	260181
9998	9159	6	applied	\N	\N	\N	\N	92369	92369	260182
9998	9226	7	applied	\N	\N	\N	\N	92370	92370	260183
9998	9576	8	applied	\N	\N	\N	\N	92371	92371	260184
9998	9591	9	applied	\N	\N	\N	\N	92372	92372	260185
9998	9592	10	applied	\N	\N	\N	\N	92373	92373	260186
9998	9402	12	applied	\N	\N	\N	\N	92375	92375	260188
9998	9403	13	applied	\N	\N	\N	\N	92376	92376	260189
9829	9405	6	applied	\N	\N	\N	\N	91674	91674	259492
9829	9416	7	applied	\N	\N	\N	\N	91675	91675	259493
9829	9306	51	applied	\N	\N	\N	\N	91719	91719	259537
9829	9310	52	applied	\N	\N	\N	\N	91720	91720	259538
9829	9311	53	applied	\N	\N	\N	\N	91721	91721	259539
9829	9312	54	applied	\N	\N	\N	\N	91722	91722	259540
9829	9328	55	applied	\N	\N	1000000000	\N	91723	91723	259541
9829	9338	56	applied	\N	\N	\N	\N	91724	91724	259542
9829	9339	57	applied	\N	\N	\N	\N	91725	91725	259543
9829	9414	58	applied	\N	\N	\N	\N	91726	91726	259544
9829	9273	59	applied	\N	\N	\N	\N	91727	91727	259545
9829	9253	60	applied	\N	\N	\N	\N	91728	91728	91728
9829	9345	61	applied	\N	\N	\N	\N	91729	91729	259546
9829	9348	62	applied	\N	\N	\N	\N	91730	91730	259547
9829	9194	64	applied	\N	\N	\N	\N	91732	91732	259549
9829	9201	65	applied	\N	\N	\N	\N	91733	91733	259550
9829	9254	66	applied	\N	\N	\N	\N	91734	91734	91734
9829	9255	67	applied	\N	\N	\N	\N	91735	91735	91735
9829	9349	68	applied	\N	\N	\N	\N	91736	91736	259551
9829	9352	69	applied	\N	\N	\N	\N	91737	91737	259552
9829	9353	70	applied	\N	\N	\N	\N	91738	91738	259553
9829	9354	71	applied	\N	\N	\N	\N	91739	91739	259554
9829	9355	72	applied	\N	\N	\N	\N	91740	91740	259555
9829	9356	73	applied	\N	\N	\N	\N	91741	91741	259556
9829	9357	74	applied	\N	\N	\N	\N	91742	91742	259557
9832	9433	0	applied	\N	\N	\N	\N	91759	91759	259574
9832	9434	1	applied	\N	\N	\N	\N	91760	91760	259575
9836	9450	0	applied	\N	\N	\N	\N	91779	91779	259594
9836	9451	1	applied	\N	\N	\N	\N	91780	91780	259595
9838	9452	0	applied	\N	\N	\N	\N	91783	91783	259598
9838	9453	1	applied	\N	\N	\N	\N	91784	91784	259599
9840	9454	0	applied	\N	\N	\N	\N	91787	91787	259602
9841	9454	0	applied	\N	\N	\N	\N	91789	91789	259604
9841	9455	1	applied	\N	\N	\N	\N	91790	91790	259605
9842	9454	0	applied	\N	\N	\N	\N	91791	91791	259606
9842	9455	1	applied	\N	\N	\N	\N	91792	91792	259607
9843	9456	0	applied	\N	\N	\N	\N	91793	91793	259608
9843	9457	1	applied	\N	\N	\N	\N	91794	91794	259609
9845	9458	0	applied	\N	\N	\N	\N	91797	91797	259612
9845	9459	1	applied	\N	\N	\N	\N	91798	91798	259613
9846	9460	0	applied	\N	\N	\N	\N	91799	91799	259614
9846	9461	1	applied	\N	\N	\N	\N	91800	91800	259615
9846	9462	2	applied	\N	\N	\N	\N	91801	91801	259616
9846	9463	3	applied	\N	\N	\N	\N	91802	91802	259617
9846	9464	4	applied	\N	\N	\N	\N	91803	91803	259618
9848	9466	0	applied	\N	\N	\N	\N	91810	91810	259625
9850	9467	0	applied	\N	\N	\N	\N	91812	91812	259627
9850	9468	1	applied	\N	\N	\N	\N	91813	91813	259628
9851	9470	1	applied	\N	\N	\N	\N	91815	91815	259630
9851	9471	2	applied	\N	\N	\N	\N	91816	91816	259631
9851	9472	3	applied	\N	\N	\N	\N	91817	91817	259632
9853	9473	0	applied	\N	\N	\N	\N	91821	91821	259636
9853	9474	1	applied	\N	\N	\N	\N	91822	91822	259637
9853	9475	2	applied	\N	\N	\N	\N	91823	91823	259638
9856	9477	0	applied	\N	\N	\N	\N	91825	91825	259640
9856	9478	1	applied	\N	\N	\N	\N	91826	91826	259641
9856	9479	2	applied	\N	\N	\N	\N	91827	91827	259642
9856	9480	3	applied	\N	\N	\N	\N	91828	91828	259643
9856	9481	4	applied	\N	\N	\N	\N	91829	91829	259644
9856	9482	5	applied	\N	\N	\N	\N	91830	91830	259645
9856	9483	6	applied	\N	\N	\N	\N	91831	91831	259646
9859	9493	0	applied	\N	\N	\N	\N	91841	91841	259656
9859	9494	1	applied	\N	\N	\N	\N	91842	91842	259657
9859	9495	2	applied	\N	\N	\N	\N	91843	91843	259658
9862	9499	0	applied	\N	\N	\N	\N	91849	91849	259664
9862	9500	1	applied	\N	\N	\N	\N	91850	91850	259665
9866	9501	0	applied	\N	\N	\N	\N	91856	91856	259671
9868	9502	0	applied	\N	\N	\N	\N	91861	91861	259676
9868	9503	1	applied	\N	\N	\N	\N	91862	91862	259677
9868	9504	2	applied	\N	\N	\N	\N	91863	91863	259678
9868	9505	3	applied	\N	\N	\N	\N	91864	91864	259679
9869	9502	0	applied	\N	\N	\N	\N	91865	91865	259680
9869	9503	1	applied	\N	\N	\N	\N	91866	91866	259681
9869	9504	2	applied	\N	\N	\N	\N	91867	91867	259682
9869	9505	3	applied	\N	\N	\N	\N	91868	91868	259683
9871	9508	0	applied	\N	\N	\N	\N	91871	91871	259686
9871	9509	1	applied	\N	\N	\N	\N	91872	91872	259687
9873	9510	0	applied	\N	\N	\N	\N	91875	91875	259690
9873	9511	1	applied	\N	\N	\N	\N	91876	91876	259691
9874	9510	0	applied	\N	\N	\N	\N	91877	91877	259692
9875	9512	0	applied	\N	\N	\N	\N	91879	91879	259694
9875	9513	1	applied	\N	\N	\N	\N	91880	91880	259695
9876	9514	0	applied	\N	\N	\N	\N	91881	91881	259696
9876	9515	1	applied	\N	\N	\N	\N	91882	91882	259697
9876	9516	2	applied	\N	\N	\N	\N	91883	91883	259698
9876	9517	3	applied	\N	\N	\N	\N	91884	91884	259699
9876	9518	4	applied	\N	\N	\N	\N	91885	91885	259700
9878	9519	0	applied	\N	\N	\N	\N	91886	91886	259701
9878	9520	1	applied	\N	\N	\N	\N	91887	91887	259702
9879	9519	0	applied	\N	\N	\N	\N	91888	91888	259703
9879	9520	1	applied	\N	\N	\N	\N	91889	91889	259704
9881	9519	0	applied	\N	\N	\N	\N	91890	91890	259705
9881	9520	1	applied	\N	\N	\N	\N	91891	91891	259706
9882	9519	0	applied	\N	\N	\N	\N	91892	91892	259707
9882	9520	1	applied	\N	\N	\N	\N	91893	91893	259708
9885	9521	0	applied	\N	\N	\N	\N	91894	91894	259709
9886	9521	0	applied	\N	\N	\N	\N	91896	91896	259711
9886	9522	1	applied	\N	\N	\N	\N	91897	91897	259712
9887	9521	0	applied	\N	\N	\N	\N	91898	91898	259713
9887	9522	1	applied	\N	\N	\N	\N	91899	91899	259714
9890	9523	0	applied	\N	\N	\N	\N	91904	91904	259719
9890	9524	1	applied	\N	\N	\N	\N	91905	91905	259720
9892	9529	0	applied	\N	\N	\N	\N	91910	91910	259725
9893	9529	0	applied	\N	\N	\N	\N	91911	91911	259726
9895	9530	0	applied	\N	\N	\N	\N	91917	91917	259732
9895	9531	1	applied	\N	\N	\N	\N	91918	91918	259733
9895	9532	2	applied	\N	\N	\N	\N	91919	91919	259734
9895	9533	3	applied	\N	\N	\N	\N	91920	91920	259735
9902	9542	0	applied	\N	\N	\N	\N	91933	91933	259748
9902	9543	1	applied	\N	\N	\N	\N	91934	91934	259749
9910	9558	0	applied	\N	\N	\N	\N	91953	91953	259768
9829	9303	48	applied	\N	\N	\N	\N	91716	91716	259534
9829	9305	50	applied	\N	\N	\N	\N	91718	91718	259536
9894	9528	4	applied	\N	\N	\N	\N	91916	91916	259731
9897	9534	0	applied	\N	\N	\N	\N	91923	91923	259738
9897	9535	1	applied	\N	\N	\N	\N	91924	91924	259739
9899	9538	0	applied	\N	\N	\N	\N	91927	91927	259742
9899	9539	1	applied	\N	\N	\N	\N	91928	91928	259743
9905	9544	0	applied	\N	\N	\N	\N	91939	91939	259754
9905	9545	1	applied	\N	\N	\N	\N	91940	91940	259755
9905	9546	2	applied	\N	\N	\N	\N	91941	91941	259756
9905	9547	3	applied	\N	\N	\N	\N	91942	91942	259757
9910	9559	1	applied	\N	\N	\N	\N	91954	91954	259769
9913	9564	0	applied	\N	\N	\N	\N	91963	91963	259778
9915	9567	0	applied	\N	\N	\N	\N	91966	91966	259781
9915	9568	1	applied	\N	\N	\N	\N	91967	91967	259782
9915	9569	2	applied	\N	\N	\N	\N	91968	91968	259783
9915	9570	3	applied	\N	\N	\N	\N	91969	91969	259784
9916	9571	0	applied	\N	\N	\N	\N	91970	91970	259785
9918	9573	0	applied	\N	\N	\N	\N	91975	91975	259790
9918	9574	1	applied	\N	\N	\N	\N	91976	91976	259791
9918	9575	2	applied	\N	\N	\N	\N	91977	91977	259792
9919	9576	0	applied	\N	\N	\N	\N	91978	91978	259793
9919	9577	1	applied	\N	\N	\N	\N	91979	91979	259794
9919	9578	2	applied	\N	\N	\N	\N	91980	91980	259795
9919	9579	3	applied	\N	\N	\N	\N	91981	91981	259796
9919	9580	4	applied	\N	\N	\N	\N	91982	91982	259797
9919	9581	5	applied	\N	\N	\N	\N	91983	91983	259798
9919	9582	6	applied	\N	\N	\N	\N	91984	91984	259799
9921	9585	0	applied	\N	\N	\N	\N	91987	91987	259802
9921	9586	1	applied	\N	\N	\N	\N	91988	91988	259803
9923	9587	0	applied	\N	\N	\N	\N	91990	91990	259805
9923	9586	1	applied	\N	\N	\N	\N	91991	91991	259806
9923	9588	2	applied	\N	\N	\N	\N	91992	91992	259807
9924	9589	0	applied	\N	\N	\N	\N	91993	91993	259808
9926	9591	0	applied	\N	\N	\N	\N	91997	91997	259812
9926	9592	1	applied	\N	\N	\N	\N	91998	91998	259813
9926	9593	2	applied	\N	\N	\N	\N	91999	91999	259814
9926	9594	3	applied	\N	\N	\N	\N	92000	92000	259815
9926	9595	4	applied	\N	\N	\N	\N	92001	92001	259816
9928	9596	0	applied	\N	\N	\N	\N	92007	92007	259822
9930	9597	0	applied	\N	\N	\N	\N	92008	92008	259823
9930	9598	1	applied	\N	\N	\N	\N	92009	92009	259824
9931	9599	0	applied	\N	\N	\N	\N	92010	92010	259825
9931	9600	1	applied	\N	\N	\N	\N	92011	92011	259826
9933	9601	0	applied	\N	\N	\N	\N	92014	92014	259829
9933	9602	1	applied	\N	\N	\N	\N	92015	92015	259830
9933	9603	2	applied	\N	\N	\N	\N	92016	92016	259831
9933	9604	3	applied	\N	\N	\N	\N	92017	92017	259832
9934	9601	0	applied	\N	\N	\N	\N	92018	92018	259833
9934	9602	1	applied	\N	\N	\N	\N	92019	92019	259834
9934	9604	3	applied	\N	\N	\N	\N	92021	92021	259836
9935	9605	0	applied	\N	\N	\N	\N	92022	92022	259837
9935	9606	1	applied	\N	\N	\N	\N	92023	92023	259838
9936	9607	0	applied	\N	\N	\N	\N	92024	92024	259839
9936	9608	1	applied	\N	\N	\N	\N	92025	92025	259840
9936	9609	2	applied	\N	\N	\N	\N	92026	92026	259841
9936	9610	3	applied	\N	\N	\N	\N	92027	92027	259842
9936	9611	4	applied	\N	\N	\N	\N	92028	92028	259843
9936	9612	5	applied	\N	\N	\N	\N	92029	92029	259844
9936	9613	6	applied	\N	\N	\N	\N	92030	92030	259845
9938	9614	0	applied	\N	\N	\N	\N	92038	92038	259853
9938	9615	1	applied	\N	\N	\N	\N	92039	92039	259854
9941	9614	0	applied	\N	\N	\N	\N	92044	92044	259859
9941	9615	1	applied	\N	\N	\N	\N	92045	92045	259860
9942	9614	0	applied	\N	\N	\N	\N	92046	92046	259861
9942	9615	1	applied	\N	\N	\N	\N	92047	92047	259862
9945	9622	1	applied	\N	\N	\N	\N	92054	92054	259869
9946	9623	0	applied	\N	\N	\N	\N	92055	92055	259870
9946	9624	1	applied	\N	\N	\N	\N	92056	92056	259871
9946	9625	2	applied	\N	\N	\N	\N	92057	92057	259872
9946	9626	3	applied	\N	\N	\N	\N	92058	92058	259873
9946	9627	4	applied	\N	\N	\N	\N	92059	92059	259874
9946	9628	5	applied	\N	\N	\N	\N	92060	92060	259875
9947	9629	0	applied	\N	\N	\N	\N	92061	92061	259876
9947	9630	1	applied	\N	\N	\N	\N	92062	92062	259877
9951	9639	0	applied	\N	\N	\N	\N	92077	92077	259892
9951	9640	1	applied	\N	\N	\N	\N	92078	92078	259893
9954	9641	0	applied	\N	\N	\N	\N	92081	92081	259896
9956	9642	0	applied	\N	\N	\N	\N	92087	92087	259902
9956	9643	1	applied	\N	\N	\N	\N	92088	92088	259903
9956	9644	2	applied	\N	\N	\N	\N	92089	92089	259904
9956	9645	3	applied	\N	\N	\N	\N	92090	92090	259905
9969	9329	0	applied	\N	\N	\N	\N	92135	92135	259950
9969	9330	1	applied	\N	\N	\N	\N	92136	92136	92136
9969	9576	2	applied	\N	\N	\N	\N	92137	92137	259951
9969	9591	3	applied	\N	\N	\N	\N	92138	92138	259952
9969	9592	4	applied	\N	\N	\N	\N	92139	92139	259953
9969	9593	5	applied	\N	\N	\N	\N	92140	92140	259954
9969	9402	6	applied	\N	\N	\N	\N	92141	92141	259955
9969	9403	7	applied	\N	\N	\N	\N	92142	92142	259956
9969	9404	8	applied	\N	\N	\N	\N	92143	92143	259957
9969	9405	9	applied	\N	\N	\N	\N	92144	92144	259958
9969	9416	10	applied	\N	\N	\N	\N	92145	92145	259959
9969	9639	11	applied	\N	\N	\N	\N	92146	92146	259960
9969	9473	12	applied	\N	\N	\N	\N	92147	92147	259961
9969	9331	13	applied	\N	\N	\N	\N	92148	92148	259962
9969	9332	14	applied	\N	\N	\N	\N	92149	92149	259963
9969	9607	15	applied	\N	\N	\N	\N	92150	92150	259964
9969	9360	17	applied	\N	\N	\N	\N	92152	92152	259966
9969	9361	18	applied	\N	\N	\N	\N	92153	92153	259967
9969	9655	19	applied	\N	\N	\N	\N	92154	92154	259968
9969	9656	20	applied	\N	\N	\N	\N	92155	92155	259969
9969	9609	21	applied	\N	\N	\N	\N	92156	92156	259970
9969	9610	22	applied	\N	\N	\N	\N	92157	92157	259971
9969	9612	23	applied	\N	\N	\N	\N	92158	92158	259972
9969	9362	24	applied	\N	\N	\N	\N	92159	92159	259973
9969	9363	25	applied	\N	\N	\N	\N	92160	92160	259974
9969	9613	26	applied	\N	\N	\N	\N	92161	92161	259975
9969	9338	27	applied	\N	\N	\N	\N	92162	92162	259976
9969	9339	28	applied	\N	\N	\N	\N	92163	92163	259977
9969	9489	29	applied	\N	\N	\N	\N	92164	92164	259978
9969	9490	30	applied	\N	\N	\N	\N	92165	92165	259979
9894	9526	1	applied	\N	\N	\N	\N	91913	91913	259728
9894	9527	2	applied	\N	\N	\N	\N	91914	91914	259729
9949	9629	0	applied	\N	\N	\N	\N	92067	92067	259882
9949	9630	1	applied	\N	\N	\N	\N	92068	92068	259883
9949	9635	2	applied	\N	\N	\N	\N	92069	92069	259884
9949	9631	3	applied	\N	\N	\N	\N	92070	92070	259885
9949	9632	4	applied	\N	\N	\N	\N	92071	92071	259886
9949	9633	5	applied	\N	\N	\N	\N	92072	92072	259887
9949	9634	6	applied	\N	\N	\N	\N	92073	92073	259888
9949	9636	7	applied	\N	\N	\N	\N	92074	92074	259889
9965	9650	0	applied	\N	\N	\N	\N	92106	92106	259921
9965	9648	1	applied	\N	\N	\N	\N	92107	92107	259922
9965	9649	2	applied	\N	\N	\N	\N	92108	92108	259923
9965	9652	3	applied	\N	\N	\N	\N	92109	92109	259924
9965	9651	4	applied	\N	\N	\N	\N	92110	92110	259925
9965	9653	5	applied	\N	\N	\N	\N	92111	92111	259926
9965	9654	6	applied	\N	\N	\N	\N	92112	92112	259927
9967	9648	0	applied	\N	\N	\N	\N	92120	92120	259935
9967	9652	2	applied	\N	\N	\N	\N	92122	92122	259937
9967	9647	3	applied	\N	\N	\N	\N	92123	92123	259938
9967	9650	4	applied	\N	\N	\N	\N	92124	92124	259939
9967	9651	5	applied	\N	\N	\N	\N	92125	92125	259940
9967	9653	6	applied	\N	\N	\N	\N	92126	92126	259941
9967	9654	7	applied	\N	\N	\N	\N	92127	92127	259942
9969	9491	31	applied	\N	\N	\N	\N	92166	92166	259980
9969	9414	32	applied	\N	\N	\N	\N	92167	92167	259981
9969	9429	33	applied	\N	\N	\N	\N	92168	92168	259982
9969	9446	34	applied	\N	\N	\N	\N	92169	92169	259983
9969	9447	35	applied	\N	\N	\N	\N	92170	92170	259984
9969	9575	36	applied	\N	\N	\N	\N	92171	92171	259985
9969	9646	37	applied	\N	\N	\N	\N	92172	92172	259986
9969	9654	38	applied	\N	\N	\N	\N	92173	92173	259987
9969	9345	39	applied	\N	\N	\N	\N	92174	92174	259988
9969	9348	40	applied	\N	\N	\N	\N	92175	92175	259989
9969	9352	42	applied	\N	\N	\N	\N	92177	92177	259991
9969	9353	43	applied	\N	\N	\N	\N	92178	92178	259992
9969	9354	44	applied	\N	\N	\N	\N	92179	92179	259993
9969	9355	45	applied	\N	\N	\N	\N	92180	92180	259994
9969	9356	46	applied	\N	\N	\N	\N	92181	92181	259995
9969	9357	47	applied	\N	\N	\N	\N	92182	92182	259996
9969	9358	48	applied	\N	\N	\N	\N	92183	92183	259997
9969	9364	49	applied	\N	\N	\N	\N	92184	92184	259998
9969	9381	50	applied	\N	\N	\N	\N	92185	92185	259999
9969	9382	51	applied	\N	\N	\N	\N	92186	92186	260000
9969	9383	52	applied	\N	\N	\N	\N	92187	92187	260001
9969	9384	53	applied	\N	\N	\N	\N	92188	92188	260002
9969	9385	54	applied	\N	\N	\N	\N	92189	92189	260003
9969	9387	55	applied	\N	\N	\N	\N	92190	92190	260004
9969	9388	56	applied	\N	\N	\N	\N	92191	92191	260005
9969	9389	57	applied	\N	\N	\N	\N	92192	92192	260006
9969	9400	59	applied	\N	\N	\N	\N	92194	92194	260008
9969	9423	60	applied	\N	\N	\N	\N	92195	92195	260009
9972	9655	0	applied	\N	\N	\N	\N	92204	92204	260018
9972	9656	1	applied	\N	\N	\N	\N	92205	92205	260019
9972	9657	2	applied	\N	\N	\N	\N	92206	92206	260020
9972	9658	3	applied	\N	\N	\N	\N	92207	92207	260021
9973	9659	0	applied	\N	\N	\N	\N	92208	92208	260022
9974	9655	0	applied	\N	\N	\N	\N	92209	92209	260023
9974	9656	1	applied	\N	\N	\N	\N	92210	92210	260024
9974	9660	2	applied	\N	\N	\N	\N	92211	92211	260025
9976	9650	0	applied	\N	\N	\N	\N	92215	92215	260029
9976	9648	1	applied	\N	\N	\N	\N	92216	92216	260030
9976	9649	2	applied	\N	\N	\N	\N	92217	92217	260031
9976	9655	3	applied	\N	\N	\N	\N	92218	92218	260032
9976	9651	4	applied	\N	\N	\N	\N	92219	92219	260033
9976	9656	5	applied	\N	\N	\N	\N	92220	92220	260034
9978	9666	0	applied	\N	\N	\N	\N	92227	92227	260041
9978	9667	1	applied	\N	\N	\N	\N	92228	92228	260042
9981	9668	0	applied	\N	\N	\N	\N	92237	92237	260051
9981	9669	1	applied	\N	\N	\N	\N	92238	92238	260052
9982	9668	0	applied	\N	\N	\N	\N	92243	92243	260057
9982	9669	1	applied	\N	\N	\N	\N	92244	92244	260058
9982	9670	2	applied	\N	\N	\N	\N	92245	92245	260059
9982	9671	3	applied	\N	\N	\N	\N	92246	92246	260060
9982	9672	4	applied	\N	\N	\N	\N	92247	92247	260061
9982	9673	5	applied	\N	\N	\N	\N	92248	92248	260062
9986	9680	0	applied	\N	\N	\N	\N	92288	92288	260102
9986	9681	1	applied	\N	\N	\N	\N	92289	92289	260103
9986	9682	2	applied	\N	\N	\N	\N	92290	92290	260104
9986	9683	3	applied	\N	\N	\N	\N	92291	92291	260105
9986	9684	4	applied	\N	\N	\N	\N	92292	92292	260106
9986	9685	5	applied	\N	\N	\N	\N	92293	92293	260107
9988	9681	1	applied	\N	\N	\N	\N	92301	92301	260115
9988	9682	2	applied	\N	\N	\N	\N	92302	92302	260116
9988	9683	3	applied	\N	\N	\N	\N	92303	92303	260117
9988	9684	4	applied	\N	\N	\N	\N	92304	92304	260118
9988	9685	5	applied	\N	\N	\N	\N	92305	92305	260119
9990	9686	0	applied	\N	\N	\N	\N	92312	92312	260126
9990	9687	1	applied	\N	\N	\N	\N	92313	92313	260127
9993	9692	0	applied	\N	\N	\N	\N	92318	92318	260132
9993	9693	1	applied	\N	\N	\N	\N	92319	92319	260133
9993	9694	2	applied	\N	\N	\N	\N	92320	92320	260134
9993	9695	3	applied	\N	\N	\N	\N	92321	92321	260135
9993	9696	4	applied	\N	\N	\N	\N	92322	92322	260136
9993	9697	5	applied	\N	\N	\N	\N	92323	92323	260137
9996	9681	0	applied	\N	\N	\N	\N	92328	92328	260142
9996	9669	1	applied	\N	\N	\N	\N	92329	92329	260143
9996	9666	2	applied	\N	\N	\N	\N	92330	92330	260144
9996	9671	4	applied	\N	\N	\N	\N	92332	92332	260146
9996	9674	5	applied	\N	\N	\N	\N	92333	92333	260147
9996	9667	6	applied	\N	\N	\N	\N	92334	92334	260148
9996	9668	7	applied	\N	\N	\N	\N	92335	92335	260149
9996	9677	8	applied	\N	\N	\N	\N	92336	92336	260150
9996	9680	9	applied	\N	\N	\N	\N	92337	92337	260151
9996	9682	10	applied	\N	\N	\N	\N	92338	92338	260152
9996	9687	11	applied	\N	\N	\N	\N	92339	92339	260153
9996	9688	12	applied	\N	\N	\N	\N	92340	92340	260154
9996	9690	13	applied	\N	\N	\N	\N	92341	92341	260155
9996	9692	14	applied	\N	\N	\N	\N	92342	92342	260156
9996	9693	15	applied	\N	\N	\N	\N	92343	92343	260157
9996	9699	16	applied	\N	\N	\N	\N	92344	92344	260158
9996	9672	17	applied	\N	\N	\N	\N	92345	92345	260159
9947	9632	3	applied	\N	\N	\N	\N	92064	92064	259879
9947	9633	4	applied	\N	\N	\N	\N	92065	92065	259880
9981	9673	5	applied	\N	\N	\N	\N	92242	92242	260056
9983	9668	0	applied	\N	\N	\N	\N	92249	92249	260063
9983	9669	1	applied	\N	\N	\N	\N	92250	92250	260064
9983	9670	2	applied	\N	\N	\N	\N	92251	92251	260065
9983	9671	3	applied	\N	\N	\N	\N	92252	92252	260066
9983	9672	4	applied	\N	\N	\N	\N	92253	92253	260067
9983	9673	5	applied	\N	\N	\N	\N	92254	92254	260068
9985	9652	0	applied	\N	\N	\N	\N	92260	92260	260074
9985	9669	1	applied	\N	\N	\N	\N	92261	92261	260075
9985	9655	2	applied	\N	\N	\N	\N	92262	92262	260076
9985	9656	3	applied	\N	\N	\N	\N	92263	92263	260077
9985	9660	4	applied	\N	\N	\N	\N	92264	92264	260078
9985	9653	5	applied	\N	\N	\N	\N	92265	92265	260079
9985	9662	7	applied	\N	\N	\N	\N	92267	92267	260081
9985	9663	8	applied	\N	\N	\N	\N	92268	92268	260082
9985	9667	9	applied	\N	\N	\N	\N	92269	92269	260083
9985	9668	10	applied	\N	\N	\N	\N	92270	92270	260084
9985	9658	11	applied	\N	\N	\N	\N	92271	92271	260085
9985	9672	12	applied	\N	\N	\N	\N	92272	92272	260086
9985	9676	13	applied	\N	\N	\N	\N	92273	92273	260087
9985	9678	14	applied	\N	\N	\N	\N	92274	92274	260088
9985	9659	15	applied	\N	\N	\N	\N	92275	92275	260089
9985	9661	16	applied	\N	\N	\N	\N	92276	92276	260090
9985	9664	17	applied	\N	\N	\N	\N	92277	92277	260091
9985	9666	18	applied	\N	\N	\N	\N	92278	92278	260092
9985	9670	19	applied	\N	\N	\N	\N	92279	92279	260093
9985	9671	20	applied	\N	\N	\N	\N	92280	92280	260094
9985	9674	21	applied	\N	\N	\N	\N	92281	92281	260095
9985	9677	22	applied	\N	\N	\N	\N	92282	92282	260096
9985	9675	24	applied	\N	\N	\N	\N	92284	92284	260098
9985	9679	25	applied	\N	\N	\N	\N	92285	92285	260099
9985	9654	26	applied	\N	\N	\N	\N	92286	92286	260100
9985	9665	27	applied	\N	\N	\N	\N	92287	92287	260101
9989	9680	0	applied	\N	\N	\N	\N	92306	92306	260120
9989	9681	1	applied	\N	\N	\N	\N	92307	92307	260121
9989	9682	2	applied	\N	\N	\N	\N	92308	92308	260122
9989	9683	3	applied	\N	\N	\N	\N	92309	92309	260123
9989	9684	4	applied	\N	\N	\N	\N	92310	92310	260124
9989	9685	5	applied	\N	\N	\N	\N	92311	92311	260125
9992	9690	0	applied	\N	\N	\N	\N	92316	92316	260130
9992	9691	1	applied	\N	\N	\N	\N	92317	92317	260131
9995	9698	0	applied	\N	\N	\N	\N	92326	92326	260140
9995	9699	1	applied	\N	\N	\N	\N	92327	92327	260141
9997	9698	0	applied	\N	\N	\N	\N	92361	92361	260175
9997	9699	1	applied	\N	\N	\N	\N	92362	92362	260176
10000	9701	1	applied	\N	\N	1000000000	\N	92491	92491	260304
10002	9702	0	applied	\N	\N	\N	\N	92494	92494	260307
10002	9703	1	applied	\N	\N	\N	\N	92495	92495	260308
10005	9706	0	applied	\N	\N	\N	\N	92500	92500	260313
10005	9707	1	applied	\N	\N	\N	\N	92501	92501	260314
10005	9708	2	applied	\N	\N	\N	\N	92502	92502	260315
10005	9709	3	applied	\N	\N	\N	\N	92503	92503	260316
10005	9710	4	applied	\N	\N	\N	\N	92504	92504	260317
10007	9706	0	applied	\N	\N	\N	\N	92521	92521	260334
10007	9707	1	applied	\N	\N	\N	\N	92522	92522	260335
10007	9708	2	applied	\N	\N	\N	\N	92523	92523	260336
10007	9709	3	applied	\N	\N	\N	\N	92524	92524	260337
10007	9710	4	applied	\N	\N	\N	\N	92525	92525	260338
10007	9711	5	applied	\N	\N	\N	\N	92526	92526	260339
10007	9712	7	applied	\N	\N	\N	\N	92527	92527	260340
10007	9713	8	applied	\N	\N	\N	\N	92528	92528	260341
10007	9715	10	applied	\N	\N	\N	\N	92530	92530	260343
10007	9716	11	applied	\N	\N	\N	\N	92531	92531	260344
10007	9717	12	applied	\N	\N	\N	\N	92532	92532	260345
10007	9718	13	applied	\N	\N	\N	\N	92533	92533	260346
10007	9719	14	applied	\N	\N	\N	\N	92534	92534	260347
10007	9720	15	applied	\N	\N	\N	\N	92535	92535	260348
10007	9721	16	applied	\N	\N	\N	\N	92536	92536	260349
10010	9726	0	applied	\N	\N	\N	\N	92541	92541	260354
10010	9727	1	applied	\N	\N	\N	\N	92542	92542	260355
10010	9728	2	applied	\N	\N	\N	\N	92543	92543	260356
10012	9729	0	applied	\N	\N	\N	\N	92547	92547	260360
10012	9730	1	applied	\N	\N	\N	\N	92548	92548	260361
10012	9731	2	applied	\N	\N	\N	\N	92549	92549	260362
10012	9732	3	applied	\N	\N	\N	\N	92550	92550	260363
10015	9738	0	applied	\N	\N	\N	\N	92560	92560	260373
10015	9739	1	applied	\N	\N	\N	\N	92561	92561	260374
10015	9741	3	applied	\N	\N	\N	\N	92563	92563	260376
10015	9742	4	applied	\N	\N	\N	\N	92564	92564	260377
10018	9748	0	applied	\N	\N	\N	\N	92572	92572	260385
10018	9749	1	applied	\N	\N	\N	\N	92573	92573	260386
10020	9750	0	applied	\N	\N	\N	\N	92627	92627	260440
10020	9751	1	applied	\N	\N	\N	\N	92628	92628	260441
10020	9752	2	applied	\N	\N	\N	\N	92629	92629	260442
10020	9753	3	applied	\N	\N	1000000000	\N	92630	92630	260443
10025	9769	0	applied	\N	\N	\N	\N	92662	92662	260475
10025	9770	1	applied	\N	\N	\N	\N	92663	92663	260476
10025	9771	2	applied	\N	\N	\N	\N	92664	92664	260477
10025	9772	3	applied	\N	\N	\N	\N	92665	92665	260478
10025	9773	4	applied	\N	\N	\N	\N	92666	92666	260479
10028	9781	0	applied	\N	\N	\N	\N	92674	92674	260487
10028	9782	1	applied	\N	\N	\N	\N	92675	92675	260488
10028	9783	2	applied	\N	\N	\N	\N	92676	92676	260489
10034	9796	0	applied	\N	\N	\N	\N	92717	92717	260530
10034	9797	1	applied	\N	\N	\N	\N	92718	92718	260531
10034	9798	2	applied	\N	\N	\N	\N	92719	92719	260532
10034	9799	3	applied	\N	\N	\N	\N	92720	92720	260533
10034	9800	4	applied	\N	\N	\N	\N	92721	92721	260534
10035	9796	0	applied	\N	\N	\N	\N	92722	92722	260535
10035	9797	1	applied	\N	\N	\N	\N	92723	92723	260536
10035	9798	2	applied	\N	\N	\N	\N	92724	92724	260537
10035	9799	3	applied	\N	\N	\N	\N	92725	92725	260538
10035	9800	4	applied	\N	\N	\N	\N	92726	92726	260539
10036	9801	0	applied	\N	\N	\N	\N	92727	92727	260540
10036	9802	1	applied	\N	\N	\N	\N	92728	92728	260541
10041	9810	0	applied	\N	\N	\N	\N	92744	92744	260557
10041	9811	1	applied	\N	\N	\N	\N	92745	92745	260558
10048	9812	0	applied	\N	\N	\N	\N	92816	92816	260629
10048	9813	1	applied	\N	\N	\N	\N	92817	92817	260630
9981	9671	3	applied	\N	\N	\N	\N	92240	92240	260054
9981	9672	4	applied	\N	\N	\N	\N	92241	92241	260055
9996	9685	21	applied	\N	\N	\N	\N	92349	92349	260163
9996	9686	22	applied	\N	\N	\N	\N	92350	92350	260164
9996	9673	23	applied	\N	\N	\N	\N	92351	92351	260165
9996	9675	24	applied	\N	\N	\N	\N	92352	92352	260166
9996	9683	25	applied	\N	\N	\N	\N	92353	92353	260167
9996	9684	26	applied	\N	\N	\N	\N	92354	92354	260168
9996	9689	27	applied	\N	\N	\N	\N	92355	92355	260169
9996	9691	28	applied	\N	\N	\N	\N	92356	92356	260170
9996	9695	29	applied	\N	\N	\N	\N	92357	92357	260171
9996	9696	30	applied	\N	\N	\N	\N	92358	92358	260172
9996	9698	31	applied	\N	\N	\N	\N	92359	92359	260173
9999	9700	0	applied	\N	\N	\N	\N	92488	92488	260301
9999	9701	1	applied	\N	\N	1000000000	\N	92489	92489	260302
10001	9700	0	applied	\N	\N	\N	\N	92492	92492	260305
10001	9701	1	applied	\N	\N	1000000000	\N	92493	92493	260306
10004	9704	0	applied	\N	\N	\N	\N	92498	92498	260311
10004	9705	1	applied	\N	\N	\N	\N	92499	92499	260312
10009	9724	0	applied	\N	\N	\N	\N	92539	92539	260352
10009	9725	1	applied	\N	\N	\N	\N	92540	92540	260353
10013	9729	0	applied	\N	\N	\N	\N	92551	92551	260364
10013	9730	1	applied	\N	\N	\N	\N	92552	92552	260365
10013	9731	2	applied	\N	\N	\N	\N	92553	92553	260366
10013	9732	3	applied	\N	\N	\N	\N	92554	92554	260367
10014	9733	0	applied	\N	\N	\N	\N	92555	92555	260368
10014	9734	1	applied	\N	\N	\N	\N	92556	92556	260369
10014	9735	2	applied	\N	\N	\N	\N	92557	92557	260370
10014	9736	3	applied	\N	\N	\N	\N	92558	92558	260371
10016	9743	0	applied	\N	\N	\N	\N	92565	92565	260378
10016	9744	1	applied	\N	\N	\N	\N	92566	92566	260379
10016	9745	2	applied	\N	\N	\N	\N	92567	92567	260380
10016	9746	3	applied	\N	\N	\N	\N	92568	92568	260381
10016	9747	4	applied	\N	\N	\N	\N	92569	92569	260382
10017	9748	0	applied	\N	\N	\N	\N	92570	92570	260383
10017	9749	1	applied	\N	\N	\N	\N	92571	92571	260384
10019	9680	0	applied	\N	\N	\N	\N	92574	92574	260387
10019	9682	1	applied	\N	\N	\N	\N	92575	92575	260388
10019	9683	2	applied	\N	\N	\N	\N	92576	92576	260389
10019	9684	3	applied	\N	\N	\N	\N	92577	92577	260390
10019	9687	4	applied	\N	\N	\N	\N	92578	92578	260391
10019	9688	5	applied	\N	\N	\N	\N	92579	92579	260392
10019	9690	6	applied	\N	\N	\N	\N	92580	92580	260393
10019	9692	7	applied	\N	\N	\N	\N	92581	92581	260394
10019	9693	8	applied	\N	\N	\N	\N	92582	92582	260395
10019	9685	10	applied	\N	\N	\N	\N	92584	92584	260397
10019	9686	11	applied	\N	\N	\N	\N	92585	92585	260398
10019	9700	12	applied	\N	\N	\N	\N	92586	92586	260399
10019	9702	13	applied	\N	\N	\N	\N	92587	92587	260400
10019	9705	14	applied	\N	\N	\N	\N	92588	92588	260401
10019	9707	15	applied	\N	\N	\N	\N	92589	92589	260402
10019	9708	16	applied	\N	\N	\N	\N	92590	92590	260403
10019	9709	17	applied	\N	\N	\N	\N	92591	92591	260404
10019	9722	18	applied	\N	\N	\N	\N	92592	92592	260405
10019	9724	19	applied	\N	\N	\N	\N	92593	92593	260406
10019	9727	20	applied	\N	\N	\N	\N	92594	92594	260407
10019	9728	21	applied	\N	\N	\N	\N	92595	92595	260408
10019	9732	22	applied	\N	\N	\N	\N	92596	92596	260409
10019	9733	23	applied	\N	\N	\N	\N	92597	92597	260410
10019	9738	24	applied	\N	\N	\N	\N	92598	92598	260411
10019	9740	25	applied	\N	\N	\N	\N	92599	92599	260412
10019	9746	27	applied	\N	\N	\N	\N	92601	92601	260414
10019	9748	28	applied	\N	\N	\N	\N	92602	92602	260415
10019	9689	29	applied	\N	\N	\N	\N	92603	92603	260416
10019	9691	30	applied	\N	\N	\N	\N	92604	92604	260417
10019	9695	31	applied	\N	\N	\N	\N	92605	92605	260418
10019	9696	32	applied	\N	\N	\N	\N	92606	92606	260419
10019	9698	33	applied	\N	\N	\N	\N	92607	92607	260420
10019	9703	34	applied	\N	\N	\N	\N	92608	92608	260421
10019	9704	35	applied	\N	\N	\N	\N	92609	92609	260422
10019	9706	36	applied	\N	\N	\N	\N	92610	92610	260423
10019	9710	37	applied	\N	\N	\N	\N	92611	92611	260424
10019	9711	38	applied	\N	\N	\N	\N	92612	92612	260425
10019	9723	39	applied	\N	\N	\N	\N	92613	92613	260426
10019	9725	40	applied	\N	\N	\N	\N	92614	92614	260427
10019	9726	41	applied	\N	\N	\N	\N	92615	92615	260428
10019	9729	42	applied	\N	\N	\N	\N	92616	92616	260429
10019	9741	44	applied	\N	\N	\N	\N	92618	92618	260431
10019	9742	45	applied	\N	\N	\N	\N	92619	92619	260432
10019	9743	46	applied	\N	\N	\N	\N	92620	92620	260433
10019	9745	47	applied	\N	\N	\N	\N	92621	92621	260434
10019	9749	48	applied	\N	\N	\N	\N	92622	92622	260435
10019	9697	49	applied	\N	\N	\N	\N	92623	92623	260436
10019	9712	50	applied	\N	\N	\N	\N	92624	92624	260437
10019	9747	51	applied	\N	\N	\N	\N	92625	92625	260438
10019	9701	52	applied	\N	\N	1000000000	\N	92626	92626	260439
10022	9754	0	applied	\N	\N	\N	\N	92635	92635	260448
10022	9755	1	applied	\N	\N	\N	\N	92636	92636	260449
10022	9756	2	applied	\N	\N	\N	\N	92637	92637	260450
10022	9757	3	applied	\N	\N	\N	\N	92638	92638	260451
10022	9758	4	applied	\N	\N	\N	\N	92639	92639	260452
10022	9759	5	applied	\N	\N	\N	\N	92640	92640	260453
10022	9760	6	applied	\N	\N	\N	\N	92641	92641	260454
10022	9762	8	applied	\N	\N	\N	\N	92643	92643	260456
10022	9763	9	applied	\N	\N	\N	\N	92644	92644	260457
10022	9764	10	applied	\N	\N	\N	\N	92645	92645	260458
10023	9754	0	applied	\N	\N	\N	\N	92647	92647	260460
10023	9755	1	applied	\N	\N	\N	\N	92648	92648	260461
10023	9756	2	applied	\N	\N	\N	\N	92649	92649	260462
10023	9757	3	applied	\N	\N	\N	\N	92650	92650	260463
10023	9758	4	applied	\N	\N	\N	\N	92651	92651	260464
10023	9759	5	applied	\N	\N	\N	\N	92652	92652	260465
10023	9760	6	applied	\N	\N	\N	\N	92653	92653	260466
10023	9761	7	applied	\N	\N	\N	\N	92654	92654	260467
10023	9762	8	applied	\N	\N	\N	\N	92655	92655	260468
10023	9763	9	applied	\N	\N	\N	\N	92656	92656	260469
10023	9764	10	applied	\N	\N	\N	\N	92657	92657	260470
10023	9765	11	applied	\N	\N	\N	\N	92658	92658	260471
10026	9774	0	applied	\N	\N	\N	\N	92667	92667	260480
10026	9776	2	applied	\N	\N	\N	\N	92669	92669	260482
10026	9777	3	applied	\N	\N	\N	\N	92670	92670	260483
9996	9694	19	applied	\N	\N	\N	\N	92347	92347	260161
9996	9678	20	applied	\N	\N	\N	\N	92348	92348	260162
9998	9639	17	applied	\N	\N	\N	\N	92380	92380	260193
9998	9473	18	applied	\N	\N	\N	\N	92381	92381	260194
9998	9174	19	applied	\N	\N	\N	\N	92382	92382	260195
9998	9276	20	applied	\N	\N	1000000000	\N	92383	92383	260196
9998	9293	21	applied	\N	\N	\N	\N	92384	92384	260197
9998	9294	23	applied	\N	\N	\N	\N	92385	92385	260198
9998	9189	24	applied	\N	\N	\N	\N	92386	92386	260199
9998	9112	26	applied	\N	\N	\N	\N	92388	92388	260201
9998	9331	27	applied	\N	\N	\N	\N	92389	92389	260202
9998	9332	28	applied	\N	\N	\N	\N	92390	92390	260203
9998	9234	29	applied	\N	\N	\N	\N	92391	92391	260204
9998	9607	30	applied	\N	\N	\N	\N	92392	92392	260205
9998	9479	31	applied	\N	\N	\N	\N	92393	92393	260206
9998	9360	32	applied	\N	\N	\N	\N	92394	92394	260207
9998	9361	33	applied	\N	\N	\N	\N	92395	92395	260208
9998	9237	34	applied	\N	\N	\N	\N	92396	92396	260209
9998	9191	35	applied	\N	\N	\N	\N	92397	92397	260210
9998	9192	36	applied	\N	\N	\N	\N	92398	92398	260211
9998	9193	37	applied	\N	\N	\N	\N	92399	92399	260212
9998	9669	38	applied	\N	\N	\N	\N	92400	92400	260213
9998	9131	39	applied	\N	\N	\N	\N	92401	92401	260214
9998	9133	40	applied	\N	\N	\N	\N	92402	92402	260215
9998	9145	41	applied	\N	\N	\N	\N	92403	92403	260216
9998	9135	43	applied	\N	\N	\N	\N	92405	92405	260218
9998	9118	44	applied	\N	\N	\N	\N	92406	92406	260219
9998	9121	45	applied	\N	\N	\N	\N	92407	92407	260220
9998	9138	46	applied	\N	\N	\N	\N	92408	92408	260221
9998	9173	47	applied	\N	\N	\N	\N	92409	92409	260222
9998	9197	48	applied	\N	\N	\N	\N	92410	92410	260223
9998	9656	49	applied	\N	\N	\N	\N	92411	92411	260224
9998	9660	50	applied	\N	\N	\N	\N	92412	92412	260225
9998	9295	51	applied	\N	\N	\N	\N	92413	92413	260226
9998	9115	52	applied	\N	\N	\N	\N	92414	92414	260227
9998	9178	53	applied	\N	\N	\N	\N	92415	92415	260228
9998	9179	54	applied	\N	\N	\N	\N	92416	92416	260229
9998	9180	55	applied	\N	\N	\N	\N	92417	92417	260230
9998	9609	56	applied	\N	\N	\N	\N	92418	92418	260231
10029	9785	0	applied	\N	\N	\N	\N	92678	92678	260491
10029	9786	1	applied	\N	\N	\N	\N	92679	92679	260492
10029	9788	3	applied	\N	\N	\N	\N	92681	92681	260494
10032	9792	0	applied	\N	\N	\N	\N	92707	92707	260520
10032	9793	1	applied	\N	\N	\N	\N	92708	92708	260521
10032	9794	2	applied	\N	\N	\N	\N	92709	92709	260522
10032	9795	3	applied	\N	\N	\N	\N	92710	92710	260523
10032	9791	4	applied	\N	\N	\N	\N	92711	92711	260524
10037	9801	0	applied	\N	\N	\N	\N	92729	92729	260542
10037	9802	1	applied	\N	\N	\N	\N	92730	92730	260543
10039	9803	0	applied	\N	\N	\N	\N	92737	92737	260550
10039	9804	1	applied	\N	\N	\N	\N	92738	92738	260551
10039	9805	2	applied	\N	\N	\N	\N	92739	92739	260552
10042	9810	0	applied	\N	\N	\N	\N	92746	92746	260559
10042	9811	1	applied	\N	\N	\N	\N	92747	92747	260560
10044	9810	0	applied	\N	\N	\N	\N	92750	92750	260563
10044	9811	1	applied	\N	\N	\N	\N	92751	92751	260564
10046	9812	0	applied	\N	\N	\N	\N	92812	92812	260625
10050	9814	0	applied	\N	\N	\N	\N	92820	92820	260633
10050	9815	1	applied	\N	\N	\N	\N	92821	92821	260634
10055	9819	0	applied	\N	\N	\N	\N	92828	92828	260641
10055	9820	1	applied	\N	\N	\N	\N	92829	92829	260642
10055	9821	2	applied	\N	\N	\N	\N	92830	92830	260643
10055	9822	3	applied	\N	\N	\N	\N	92831	92831	260644
10061	9826	0	applied	\N	\N	\N	\N	92855	92855	260668
10061	9828	1	applied	\N	\N	\N	\N	92856	92856	260669
10061	9829	2	applied	\N	\N	\N	\N	92857	92857	260670
10061	9830	3	applied	\N	\N	\N	\N	92858	92858	260671
10061	9831	4	applied	\N	\N	\N	\N	92859	92859	260672
10061	9832	5	applied	\N	\N	\N	\N	92860	92860	260673
10061	9833	6	applied	\N	\N	1000000000	\N	92861	92861	260674
10061	9834	7	applied	\N	\N	1000000000	\N	92862	92862	260675
10061	9835	8	applied	\N	\N	\N	\N	92863	92863	260676
10061	9837	10	applied	\N	\N	1000000000	\N	92865	92865	260678
10061	9838	11	applied	\N	\N	\N	\N	92866	92866	260679
10061	9839	12	applied	\N	\N	\N	\N	92867	92867	260680
10061	9840	13	applied	\N	\N	\N	\N	92868	92868	260681
10063	9841	0	applied	\N	\N	\N	\N	92870	92870	260683
10063	9842	1	applied	\N	\N	\N	\N	92871	92871	260684
10063	9843	2	applied	\N	\N	\N	\N	92872	92872	260685
10063	9844	3	applied	\N	\N	\N	\N	92873	92873	260686
10065	9845	0	applied	\N	\N	\N	\N	92878	92878	260691
10065	9846	1	applied	\N	\N	\N	\N	92879	92879	260692
10065	9847	2	applied	\N	\N	\N	\N	92880	92880	260693
10065	9848	3	applied	\N	\N	\N	\N	92881	92881	260694
10065	9849	4	applied	\N	\N	\N	\N	92882	92882	260695
10065	9850	5	applied	\N	\N	\N	\N	92883	92883	260696
10065	9851	6	applied	\N	\N	\N	\N	92884	92884	260697
10065	9852	7	applied	\N	\N	\N	\N	92885	92885	260698
10065	9853	8	applied	\N	\N	\N	\N	92886	92886	260699
10065	9854	9	applied	\N	\N	\N	\N	92887	92887	260700
10067	9841	0	applied	\N	\N	\N	\N	92898	92898	260711
10067	9842	2	applied	\N	\N	\N	\N	92900	92900	260713
10067	9843	3	applied	\N	\N	\N	\N	92901	92901	260714
10067	9846	4	applied	\N	\N	\N	\N	92902	92902	260715
10067	9847	5	applied	\N	\N	\N	\N	92903	92903	260716
10067	9844	6	applied	\N	\N	\N	\N	92904	92904	260717
10067	9845	7	applied	\N	\N	\N	\N	92905	92905	260718
10067	9856	8	applied	\N	\N	\N	\N	92906	92906	260719
10067	9848	9	applied	\N	\N	\N	\N	92907	92907	260720
10067	9849	10	applied	\N	\N	\N	\N	92908	92908	260721
10067	9850	11	applied	\N	\N	\N	\N	92909	92909	260722
10067	9851	12	applied	\N	\N	\N	\N	92910	92910	260723
10067	9852	13	applied	\N	\N	\N	\N	92911	92911	260724
10067	9853	14	applied	\N	\N	\N	\N	92912	92912	260725
10067	9854	15	applied	\N	\N	\N	\N	92913	92913	260726
10067	9857	16	applied	\N	\N	\N	\N	92914	92914	260727
10069	9855	0	applied	\N	\N	\N	\N	92918	92918	260731
10069	9858	2	applied	\N	\N	\N	\N	92920	92920	260733
10076	9896	0	applied	\N	\N	\N	\N	92968	92968	260781
10076	9893	1	applied	\N	\N	\N	\N	92969	92969	260782
10076	9897	2	applied	\N	\N	\N	\N	92970	92970	260783
9998	9405	15	applied	\N	\N	\N	\N	92378	92378	260191
9998	9416	16	applied	\N	\N	\N	\N	92379	92379	260192
9998	9612	60	applied	\N	\N	\N	\N	92422	92422	260235
9998	9125	61	applied	\N	\N	\N	\N	92423	92423	260236
9998	9128	62	applied	\N	\N	\N	\N	92424	92424	260237
9998	9130	63	applied	\N	\N	\N	\N	92425	92425	260238
9998	9134	64	applied	\N	\N	\N	\N	92426	92426	260239
9998	9137	65	applied	\N	\N	\N	\N	92427	92427	260240
9998	9139	66	applied	\N	\N	\N	\N	92428	92428	260241
9998	9144	67	applied	\N	\N	\N	\N	92429	92429	260242
9998	9150	68	applied	\N	\N	\N	\N	92430	92430	260243
9998	9123	69	applied	\N	\N	\N	\N	92431	92431	260244
9998	9126	70	applied	\N	\N	\N	\N	92432	92432	260245
9998	9129	72	applied	\N	\N	\N	\N	92434	92434	260247
9998	9132	73	applied	\N	\N	\N	\N	92435	92435	260248
9998	9136	74	applied	\N	\N	\N	\N	92436	92436	260249
9998	9200	75	applied	\N	\N	\N	\N	92437	92437	260250
9998	9140	76	applied	\N	\N	\N	\N	92438	92438	260251
9998	9141	77	applied	\N	\N	\N	\N	92439	92439	260252
9998	9146	78	applied	\N	\N	\N	\N	92440	92440	260253
9998	9362	79	applied	\N	\N	\N	\N	92441	92441	260254
9998	9363	80	applied	\N	\N	\N	\N	92442	92442	260255
9998	9119	81	applied	\N	\N	\N	\N	92443	92443	260256
9998	9120	82	applied	\N	\N	\N	\N	92444	92444	260257
9998	9122	83	applied	\N	\N	\N	\N	92445	92445	260258
9998	9149	84	applied	\N	\N	\N	\N	92446	92446	260259
9998	9164	85	applied	\N	\N	\N	\N	92447	92447	260260
9998	9165	86	applied	\N	\N	\N	\N	92448	92448	260261
9998	9166	87	applied	\N	\N	\N	\N	92449	92449	260262
9998	9151	89	applied	\N	\N	\N	\N	92451	92451	260264
9998	9124	90	applied	\N	\N	\N	\N	92452	92452	260265
9998	9613	91	applied	\N	\N	\N	\N	92453	92453	260266
9998	9297	92	applied	\N	\N	\N	\N	92454	92454	260267
9998	9298	93	applied	\N	\N	\N	\N	92455	92455	260268
9998	9152	94	applied	\N	\N	\N	\N	92456	92456	260269
9998	9153	95	applied	\N	\N	\N	\N	92457	92457	260270
9998	9161	96	applied	\N	\N	\N	\N	92458	92458	260271
9998	9162	97	applied	\N	\N	\N	\N	92459	92459	260272
9998	9163	98	applied	\N	\N	\N	\N	92460	92460	260273
9998	9170	99	applied	\N	\N	\N	\N	92461	92461	260274
9998	9175	100	applied	\N	\N	\N	\N	92462	92462	260275
9998	9176	101	applied	\N	\N	\N	\N	92463	92463	260276
9998	9177	102	applied	\N	\N	\N	\N	92464	92464	260277
9998	9187	103	applied	\N	\N	\N	\N	92465	92465	260278
9998	9188	104	applied	\N	\N	\N	\N	92466	92466	260279
9998	9199	106	applied	\N	\N	\N	\N	92468	92468	260281
9998	9202	107	applied	\N	\N	\N	\N	92469	92469	260282
9998	9113	108	applied	\N	\N	\N	\N	92470	92470	260283
9998	9114	109	applied	\N	\N	\N	\N	92471	92471	260284
9998	9116	110	applied	\N	\N	\N	\N	92472	92472	260285
9998	9117	111	applied	\N	\N	\N	\N	92473	92473	260286
9998	9211	112	applied	\N	\N	\N	\N	92474	92474	260287
9998	9215	113	applied	\N	\N	\N	\N	92475	92475	260288
9998	9216	114	applied	\N	\N	\N	\N	92476	92476	260289
9998	9217	115	applied	\N	\N	\N	\N	92477	92477	260290
9998	9232	116	applied	\N	\N	1000000000	\N	92478	92478	260291
9998	9301	117	applied	\N	\N	\N	\N	92479	92479	260292
9998	9673	118	applied	\N	\N	\N	\N	92480	92480	260293
9998	9675	119	applied	\N	\N	\N	\N	92481	92481	260294
9998	9683	120	applied	\N	\N	\N	\N	92482	92482	260295
9998	9684	121	applied	\N	\N	\N	\N	92483	92483	260296
9998	9303	123	applied	\N	\N	\N	\N	92485	92485	260298
9998	9304	124	applied	\N	\N	\N	\N	92486	92486	260299
9998	9305	125	applied	\N	\N	\N	\N	92487	92487	260300
10003	9704	0	applied	\N	\N	\N	\N	92496	92496	260309
10003	9705	1	applied	\N	\N	\N	\N	92497	92497	260310
10006	9706	0	applied	\N	\N	\N	\N	92505	92505	260318
10006	9707	1	applied	\N	\N	\N	\N	92506	92506	260319
10006	9708	2	applied	\N	\N	\N	\N	92507	92507	260320
10006	9709	3	applied	\N	\N	\N	\N	92508	92508	260321
10006	9710	4	applied	\N	\N	\N	\N	92509	92509	260322
10006	9711	5	applied	\N	\N	\N	\N	92510	92510	260323
10006	9712	7	applied	\N	\N	\N	\N	92511	92511	260324
10006	9713	8	applied	\N	\N	\N	\N	92512	92512	260325
10006	9714	9	applied	\N	\N	\N	\N	92513	92513	260326
10006	9715	10	applied	\N	\N	\N	\N	92514	92514	260327
10006	9716	11	applied	\N	\N	\N	\N	92515	92515	260328
10006	9718	13	applied	\N	\N	\N	\N	92517	92517	260330
10006	9719	14	applied	\N	\N	\N	\N	92518	92518	260331
10006	9720	15	applied	\N	\N	\N	\N	92519	92519	260332
10006	9721	16	applied	\N	\N	\N	\N	92520	92520	260333
10008	9722	0	applied	\N	\N	\N	\N	92537	92537	260350
10008	9723	1	applied	\N	\N	\N	\N	92538	92538	260351
10011	9726	0	applied	\N	\N	\N	\N	92544	92544	260357
10011	9727	1	applied	\N	\N	\N	\N	92545	92545	260358
10011	9728	2	applied	\N	\N	\N	\N	92546	92546	260359
10021	9750	0	applied	\N	\N	\N	\N	92631	92631	260444
10021	9751	1	applied	\N	\N	\N	\N	92632	92632	260445
10021	9752	2	applied	\N	\N	\N	\N	92633	92633	260446
10021	9753	3	applied	\N	\N	1000000000	\N	92634	92634	260447
10024	9766	0	applied	\N	\N	\N	\N	92659	92659	260472
10024	9767	1	applied	\N	\N	\N	\N	92660	92660	260473
10024	9768	2	applied	\N	\N	\N	\N	92661	92661	260474
10030	9790	1	applied	\N	\N	\N	\N	92683	92683	260496
10040	9806	0	applied	\N	\N	\N	\N	92740	92740	260553
10040	9807	1	applied	\N	\N	\N	\N	92741	92741	260554
10040	9808	2	applied	\N	\N	\N	\N	92742	92742	260555
10040	9809	3	applied	\N	\N	\N	\N	92743	92743	260556
10043	9810	0	applied	\N	\N	\N	\N	92748	92748	260561
10043	9811	1	applied	\N	\N	\N	\N	92749	92749	260562
10047	9812	0	applied	\N	\N	\N	\N	92814	92814	260627
10047	9813	1	applied	\N	\N	\N	\N	92815	92815	260628
10049	9812	0	applied	\N	\N	\N	\N	92818	92818	260631
10049	9813	1	applied	\N	\N	\N	\N	92819	92819	260632
10053	9818	0	applied	\N	\N	\N	\N	92826	92826	260639
10056	9823	0	applied	\N	\N	\N	\N	92832	92832	260645
10056	9824	1	applied	\N	\N	\N	\N	92833	92833	260646
10056	9825	2	applied	\N	\N	\N	\N	92834	92834	260647
10058	9826	0	applied	\N	\N	\N	\N	92838	92838	260651
10070	9767	0	applied	\N	\N	\N	\N	92921	92921	260734
10070	9842	1	applied	\N	\N	\N	\N	92922	92922	260735
9998	9238	58	applied	\N	\N	\N	\N	92420	92420	260233
9998	9239	59	applied	\N	\N	1000000000	\N	92421	92421	260234
10027	9780	2	applied	\N	\N	\N	\N	92673	92673	260486
10031	9681	0	applied	\N	\N	\N	\N	92684	92684	260497
10031	9767	1	applied	\N	\N	\N	\N	92685	92685	260498
10031	9669	2	applied	\N	\N	\N	\N	92686	92686	260499
10031	9768	3	applied	\N	\N	\N	\N	92687	92687	260500
10031	9769	4	applied	\N	\N	\N	\N	92688	92688	260501
10031	9772	5	applied	\N	\N	\N	\N	92689	92689	260502
10031	9694	6	applied	\N	\N	\N	\N	92690	92690	260503
10031	9730	7	applied	\N	\N	\N	\N	92691	92691	260504
10031	9731	8	applied	\N	\N	\N	\N	92692	92692	260505
10031	9739	9	applied	\N	\N	\N	\N	92693	92693	260506
10031	9673	10	applied	\N	\N	\N	\N	92694	92694	260507
10031	9675	11	applied	\N	\N	\N	\N	92695	92695	260508
10031	9684	13	applied	\N	\N	\N	\N	92697	92697	260510
10031	9791	14	applied	\N	\N	\N	\N	92698	92698	260511
10031	9752	15	applied	\N	\N	\N	\N	92699	92699	260512
10031	9759	16	applied	\N	\N	\N	\N	92700	92700	260513
10031	9697	17	applied	\N	\N	\N	\N	92701	92701	260514
10031	9760	18	applied	\N	\N	\N	\N	92702	92702	260515
10031	9701	19	applied	\N	\N	1000000000	\N	92703	92703	260516
10031	9665	20	applied	\N	\N	\N	\N	92704	92704	260517
10031	9712	21	applied	\N	\N	\N	\N	92705	92705	260518
10031	9747	22	applied	\N	\N	\N	\N	92706	92706	260519
10033	9796	0	applied	\N	\N	\N	\N	92712	92712	260525
10033	9797	1	applied	\N	\N	\N	\N	92713	92713	260526
10033	9798	2	applied	\N	\N	\N	\N	92714	92714	260527
10033	9799	3	applied	\N	\N	\N	\N	92715	92715	260528
10033	9800	4	applied	\N	\N	\N	\N	92716	92716	260529
10038	9803	0	applied	\N	\N	\N	\N	92731	92731	260544
10038	9805	2	applied	\N	\N	\N	\N	92733	92733	260546
10038	9806	3	applied	\N	\N	\N	\N	92734	92734	260547
10038	9807	4	applied	\N	\N	\N	\N	92735	92735	260548
10038	9808	5	applied	\N	\N	\N	\N	92736	92736	260549
10045	9576	0	applied	\N	\N	\N	\N	92752	92752	260565
10045	9591	1	applied	\N	\N	\N	\N	92753	92753	260566
10045	9592	2	applied	\N	\N	\N	\N	92754	92754	260567
10045	9593	3	applied	\N	\N	\N	\N	92755	92755	260568
10070	9843	2	applied	\N	\N	\N	\N	92923	92923	260736
10070	9831	3	applied	\N	\N	\N	\N	92924	92924	260737
10070	9750	4	applied	\N	\N	\N	\N	92925	92925	260738
10070	9754	5	applied	\N	\N	\N	\N	92926	92926	260739
10070	9755	6	applied	\N	\N	\N	\N	92927	92927	260740
10070	9756	7	applied	\N	\N	\N	\N	92928	92928	260741
10070	9766	8	applied	\N	\N	\N	\N	92929	92929	260742
10070	9832	9	applied	\N	\N	\N	\N	92930	92930	260743
10077	9901	1	applied	\N	\N	\N	\N	92976	92976	260789
10077	9902	2	applied	\N	\N	\N	\N	92977	92977	260790
10077	9903	3	applied	\N	\N	\N	\N	92978	92978	260791
10077	9904	4	applied	\N	\N	\N	\N	92979	92979	260792
10079	9905	0	applied	\N	\N	\N	\N	92987	92987	260800
10079	9906	1	applied	\N	\N	\N	\N	92988	92988	260801
10079	9907	2	applied	\N	\N	\N	\N	92989	92989	260802
10079	9908	3	applied	\N	\N	\N	\N	92990	92990	260803
10079	9909	4	applied	\N	\N	\N	\N	92991	92991	260804
10079	9910	5	applied	\N	\N	\N	\N	92992	92992	260805
10085	9920	0	applied	\N	\N	\N	\N	93034	93034	260847
10085	9921	1	applied	\N	\N	\N	\N	93035	93035	260848
10085	9922	2	applied	\N	\N	\N	\N	93036	93036	260849
10085	9923	3	applied	\N	\N	\N	\N	93037	93037	260850
10085	9924	4	applied	\N	\N	\N	\N	93038	93038	260851
10085	9925	5	applied	\N	\N	\N	\N	93039	93039	260852
10085	9927	7	applied	\N	\N	\N	\N	93041	93041	260854
10085	9928	8	applied	\N	\N	\N	\N	93042	93042	260855
10085	9929	9	applied	\N	\N	\N	\N	93043	93043	260856
10085	9930	10	applied	\N	\N	\N	\N	93044	93044	260857
10085	9931	11	applied	\N	\N	\N	\N	93045	93045	260858
10085	9932	12	applied	\N	\N	\N	\N	93046	93046	260859
10085	9933	13	applied	\N	\N	\N	\N	93047	93047	260860
10085	9934	14	applied	\N	\N	\N	\N	93048	93048	260861
10085	9935	15	applied	\N	\N	\N	\N	93049	93049	260862
10085	9936	16	applied	\N	\N	\N	\N	93050	93050	260863
10085	9937	17	applied	\N	\N	\N	\N	93051	93051	260864
10085	9938	18	applied	\N	\N	\N	\N	93052	93052	260865
10085	9939	19	applied	\N	\N	\N	\N	93053	93053	260866
10085	9940	20	applied	\N	\N	\N	\N	93054	93054	260867
10085	9941	21	applied	\N	\N	\N	\N	93055	93055	260868
10085	9942	22	applied	\N	\N	\N	\N	93056	93056	260869
10085	9944	24	applied	\N	\N	1000000000	\N	93058	93058	260871
10085	9945	25	applied	\N	\N	\N	\N	93059	93059	260872
10092	9992	0	applied	\N	\N	\N	\N	93263	93263	261076
10092	9993	1	applied	\N	\N	\N	\N	93264	93264	261077
10092	9994	2	applied	\N	\N	\N	\N	93265	93265	261078
10092	9995	3	applied	\N	\N	\N	\N	93266	93266	261079
10092	9996	4	applied	\N	\N	\N	\N	93267	93267	261080
10092	9997	5	applied	\N	\N	\N	\N	93268	93268	261081
10092	9998	6	applied	\N	\N	\N	\N	93269	93269	261082
10092	9999	8	applied	\N	\N	\N	\N	93270	93270	261083
10092	10000	9	applied	\N	\N	\N	\N	93271	93271	261084
10092	10001	10	applied	\N	\N	\N	\N	93272	93272	261085
10092	10002	11	applied	\N	\N	\N	\N	93273	93273	261086
10092	10003	12	applied	\N	\N	\N	\N	93274	93274	261087
10092	10004	13	applied	\N	\N	\N	\N	93275	93275	261088
10092	10005	14	applied	\N	\N	\N	\N	93276	93276	261089
10092	10007	16	applied	\N	\N	\N	\N	93278	93278	261091
10092	10008	17	applied	\N	\N	\N	\N	93279	93279	261092
10092	10009	18	applied	\N	\N	\N	\N	93280	93280	261093
10092	10010	19	applied	\N	\N	\N	\N	93281	93281	261094
10092	10011	20	applied	\N	\N	\N	\N	93282	93282	261095
10092	10012	21	applied	\N	\N	\N	\N	93283	93283	261096
10097	10013	0	applied	\N	\N	\N	\N	93351	93351	261164
10097	10014	1	applied	\N	\N	\N	\N	93352	93352	261165
10097	10015	2	applied	\N	\N	\N	\N	93353	93353	261166
10097	10016	3	applied	\N	\N	\N	\N	93354	93354	261167
10102	10031	0	applied	\N	\N	\N	\N	93369	93369	261182
10105	10038	0	applied	\N	\N	\N	\N	93378	93378	261191
10105	10039	1	applied	\N	\N	\N	\N	93379	93379	261192
10107	10040	0	applied	\N	\N	\N	\N	93382	93382	261195
10107	10041	1	applied	\N	\N	\N	\N	93383	93383	261196
10107	10042	2	applied	\N	\N	\N	\N	93384	93384	261197
10027	9778	0	applied	\N	\N	\N	\N	92671	92671	260484
10027	9779	1	applied	\N	\N	\N	\N	92672	92672	260485
10045	9405	7	applied	\N	\N	\N	\N	92759	92759	260572
10045	9416	8	applied	\N	\N	\N	\N	92760	92760	260573
10045	9639	9	applied	\N	\N	\N	\N	92761	92761	260574
10045	9473	10	applied	\N	\N	\N	\N	92762	92762	260575
10045	9607	11	applied	\N	\N	\N	\N	92763	92763	260576
10045	9767	13	applied	\N	\N	\N	\N	92765	92765	260578
10045	9669	14	applied	\N	\N	\N	\N	92766	92766	260579
10045	9655	15	applied	\N	\N	\N	\N	92767	92767	260580
10045	9656	16	applied	\N	\N	\N	\N	92768	92768	260581
10045	9660	17	applied	\N	\N	\N	\N	92769	92769	260582
10045	9609	18	applied	\N	\N	\N	\N	92770	92770	260583
10045	9610	19	applied	\N	\N	\N	\N	92771	92771	260584
10045	9768	20	applied	\N	\N	\N	\N	92772	92772	260585
10045	9769	21	applied	\N	\N	\N	\N	92773	92773	260586
10045	9612	22	applied	\N	\N	\N	\N	92774	92774	260587
10045	9772	23	applied	\N	\N	\N	\N	92775	92775	260588
10045	9613	24	applied	\N	\N	\N	\N	92776	92776	260589
10045	9673	25	applied	\N	\N	\N	\N	92777	92777	260590
10045	9675	26	applied	\N	\N	\N	\N	92778	92778	260591
10045	9683	27	applied	\N	\N	\N	\N	92779	92779	260592
10045	9684	28	applied	\N	\N	\N	\N	92780	92780	260593
10045	9490	30	applied	\N	\N	\N	\N	92782	92782	260595
10045	9491	31	applied	\N	\N	\N	\N	92783	92783	260596
10045	9679	32	applied	\N	\N	\N	\N	92784	92784	260597
10045	9414	33	applied	\N	\N	\N	\N	92785	92785	260598
10045	9429	34	applied	\N	\N	\N	\N	92786	92786	260599
10045	9446	35	applied	\N	\N	\N	\N	92787	92787	260600
10045	9447	36	applied	\N	\N	\N	\N	92788	92788	260601
10045	9575	37	applied	\N	\N	\N	\N	92789	92789	260602
10045	9646	38	applied	\N	\N	\N	\N	92790	92790	260603
10045	9791	39	applied	\N	\N	\N	\N	92791	92791	260604
10045	9752	40	applied	\N	\N	\N	\N	92792	92792	260605
10045	9759	41	applied	\N	\N	\N	\N	92793	92793	260606
10045	9654	42	applied	\N	\N	\N	\N	92794	92794	260607
10045	9798	43	applied	\N	\N	\N	\N	92795	92795	260608
10045	9760	44	applied	\N	\N	\N	\N	92796	92796	260609
10045	9423	45	applied	\N	\N	\N	\N	92797	92797	260610
10045	9701	47	applied	\N	\N	1000000000	\N	92799	92799	260612
10045	9800	48	applied	\N	\N	\N	\N	92800	92800	260613
10045	9665	49	applied	\N	\N	\N	\N	92801	92801	260614
10045	9712	50	applied	\N	\N	\N	\N	92802	92802	260615
10045	9747	51	applied	\N	\N	\N	\N	92803	92803	260616
10045	9753	52	applied	\N	\N	1000000000	\N	92804	92804	260617
10045	9762	53	applied	\N	\N	\N	\N	92805	92805	260618
10045	9763	54	applied	\N	\N	\N	\N	92806	92806	260619
10045	9764	55	applied	\N	\N	\N	\N	92807	92807	260620
10045	9765	56	applied	\N	\N	\N	\N	92808	92808	260621
10045	9773	57	applied	\N	\N	\N	\N	92809	92809	260622
10045	9777	58	applied	\N	\N	\N	\N	92810	92810	260623
10045	9780	59	applied	\N	\N	\N	\N	92811	92811	260624
10051	9814	0	applied	\N	\N	\N	\N	92822	92822	260635
10051	9815	1	applied	\N	\N	\N	\N	92823	92823	260636
10052	9817	1	applied	\N	\N	\N	\N	92825	92825	260638
10057	9823	0	applied	\N	\N	\N	\N	92835	92835	260648
10057	9824	1	applied	\N	\N	\N	\N	92836	92836	260649
10057	9825	2	applied	\N	\N	\N	\N	92837	92837	260650
10059	9827	0	applied	\N	\N	\N	\N	92840	92840	260653
10060	9826	0	applied	\N	\N	\N	\N	92841	92841	260654
10060	9828	1	applied	\N	\N	\N	\N	92842	92842	260655
10060	9829	2	applied	\N	\N	\N	\N	92843	92843	260656
10060	9830	3	applied	\N	\N	\N	\N	92844	92844	260657
10060	9831	4	applied	\N	\N	\N	\N	92845	92845	260658
10060	9832	5	applied	\N	\N	\N	\N	92846	92846	260659
10060	9833	6	applied	\N	\N	1000000000	\N	92847	92847	260660
10060	9834	7	applied	\N	\N	1000000000	\N	92848	92848	260661
10060	9835	8	applied	\N	\N	\N	\N	92849	92849	260662
10060	9836	9	applied	\N	\N	1000000000	\N	92850	92850	260663
10060	9838	11	applied	\N	\N	\N	\N	92852	92852	260665
10060	9839	12	applied	\N	\N	\N	\N	92853	92853	260666
10060	9840	13	applied	\N	\N	\N	\N	92854	92854	260667
10062	9831	0	applied	\N	\N	\N	\N	92869	92869	260682
10064	9841	0	applied	\N	\N	\N	\N	92874	92874	260687
10064	9842	1	applied	\N	\N	\N	\N	92875	92875	260688
10064	9843	2	applied	\N	\N	\N	\N	92876	92876	260689
10064	9844	3	applied	\N	\N	\N	\N	92877	92877	260690
10066	9845	0	applied	\N	\N	\N	\N	92888	92888	260701
10066	9846	1	applied	\N	\N	\N	\N	92889	92889	260702
10066	9847	2	applied	\N	\N	\N	\N	92890	92890	260703
10066	9848	3	applied	\N	\N	\N	\N	92891	92891	260704
10066	9849	4	applied	\N	\N	\N	\N	92892	92892	260705
10066	9850	5	applied	\N	\N	\N	\N	92893	92893	260706
10066	9851	6	applied	\N	\N	\N	\N	92894	92894	260707
10066	9852	7	applied	\N	\N	\N	\N	92895	92895	260708
10066	9853	8	applied	\N	\N	\N	\N	92896	92896	260709
10066	9854	9	applied	\N	\N	\N	\N	92897	92897	260710
10068	9855	0	applied	\N	\N	\N	\N	92915	92915	260728
10068	9856	1	applied	\N	\N	\N	\N	92916	92916	260729
10071	9859	0	applied	\N	\N	\N	\N	92931	92931	260744
10072	9873	0	applied	\N	\N	\N	\N	92945	92945	260758
10072	9874	1	applied	\N	\N	\N	\N	92946	92946	260759
10072	9875	2	applied	\N	\N	\N	\N	92947	92947	260760
10072	9876	3	applied	\N	\N	\N	\N	92948	92948	260761
10072	9877	4	applied	\N	\N	\N	\N	92949	92949	260762
10072	9878	5	applied	\N	\N	\N	\N	92950	92950	260763
10072	9879	6	applied	\N	\N	\N	\N	92951	92951	260764
10073	9880	0	applied	\N	\N	\N	\N	92952	92952	260765
10073	9881	1	applied	\N	\N	\N	\N	92953	92953	260766
10073	9882	2	applied	\N	\N	\N	\N	92954	92954	260767
10073	9883	3	applied	\N	\N	\N	\N	92955	92955	260768
10073	9884	4	applied	\N	\N	\N	\N	92956	92956	260769
10073	9885	5	applied	\N	\N	\N	\N	92957	92957	260770
10073	9886	6	applied	\N	\N	\N	\N	92958	92958	260771
10073	9887	7	applied	\N	\N	\N	\N	92959	92959	260772
10073	9889	9	applied	\N	\N	\N	\N	92961	92961	260774
10073	9890	10	applied	\N	\N	\N	\N	92962	92962	260775
10073	9891	11	applied	\N	\N	\N	\N	92963	92963	260776
10073	9892	12	applied	\N	\N	\N	\N	92964	92964	260777
10075	9893	0	applied	\N	\N	\N	\N	92965	92965	260778
10075	9894	1	applied	\N	\N	\N	\N	92966	92966	260779
10045	9403	5	applied	\N	\N	\N	\N	92757	92757	260570
10045	9404	6	applied	\N	\N	\N	\N	92758	92758	260571
10071	9863	4	applied	\N	\N	1000000000	\N	92935	92935	260748
10071	9864	5	applied	\N	\N	\N	\N	92936	92936	260749
10071	9865	6	applied	\N	\N	\N	\N	92937	92937	260750
10071	9866	7	applied	\N	\N	1000000000	\N	92938	92938	260751
10071	9867	8	applied	\N	\N	\N	\N	92939	92939	260752
10071	9868	9	applied	\N	\N	\N	\N	92940	92940	260753
10071	9869	10	applied	\N	\N	\N	\N	92941	92941	260754
10071	9870	11	applied	\N	\N	\N	\N	92942	92942	260755
10071	9871	12	applied	\N	\N	\N	\N	92943	92943	260756
10071	9872	13	applied	\N	\N	\N	\N	92944	92944	260757
10075	9895	2	applied	\N	\N	\N	\N	92967	92967	260780
10078	9900	0	applied	\N	\N	\N	\N	92980	92980	260793
10078	9901	1	applied	\N	\N	\N	\N	92981	92981	260794
10078	9906	3	applied	\N	\N	\N	\N	92983	92983	260796
10078	9902	4	applied	\N	\N	\N	\N	92984	92984	260797
10078	9903	5	applied	\N	\N	\N	\N	92985	92985	260798
10078	9904	6	applied	\N	\N	\N	\N	92986	92986	260799
10080	9905	0	applied	\N	\N	\N	\N	92993	92993	260806
10080	9906	1	applied	\N	\N	\N	\N	92994	92994	260807
10080	9907	2	applied	\N	\N	\N	\N	92995	92995	260808
10080	9908	3	applied	\N	\N	\N	\N	92996	92996	260809
10080	9909	4	applied	\N	\N	\N	\N	92997	92997	260810
10080	9910	5	applied	\N	\N	\N	\N	92998	92998	260811
10082	9913	0	applied	\N	\N	\N	\N	93001	93001	260814
10082	9914	1	applied	\N	\N	\N	\N	93002	93002	260815
10082	9915	2	applied	\N	\N	\N	\N	93003	93003	260816
10082	9916	3	applied	\N	\N	\N	\N	93004	93004	260817
10082	9917	4	applied	\N	\N	\N	\N	93005	93005	260818
10083	9918	0	applied	\N	\N	\N	\N	93006	93006	260819
10086	9946	0	applied	\N	\N	\N	\N	93060	93060	260873
10086	9947	1	applied	\N	\N	\N	\N	93061	93061	260874
10086	9948	2	applied	\N	\N	\N	\N	93062	93062	260875
10086	9949	3	applied	\N	\N	\N	\N	93063	93063	260876
10086	9950	4	applied	\N	\N	\N	\N	93064	93064	260877
10086	9951	5	applied	\N	\N	\N	\N	93065	93065	260878
10086	9952	6	applied	\N	\N	\N	\N	93066	93066	260879
10086	9953	7	applied	\N	\N	\N	\N	93067	93067	260880
10086	9954	8	applied	\N	\N	\N	\N	93068	93068	260881
10086	9955	9	applied	\N	\N	\N	\N	93069	93069	260882
10086	9956	10	applied	\N	\N	\N	\N	93070	93070	260883
10086	9957	11	applied	\N	\N	\N	\N	93071	93071	260884
10086	9958	12	applied	\N	\N	\N	\N	93072	93072	260885
10086	9959	13	applied	\N	\N	\N	\N	93073	93073	260886
10086	9960	14	applied	\N	\N	\N	\N	93074	93074	260887
10086	9961	15	applied	\N	\N	\N	\N	93075	93075	260888
10086	9963	17	applied	\N	\N	\N	\N	93077	93077	260890
10086	9964	18	applied	\N	\N	\N	\N	93078	93078	260891
10086	9965	19	applied	\N	\N	\N	\N	93079	93079	260892
10086	9966	20	applied	\N	\N	\N	\N	93080	93080	260893
10086	9967	21	applied	\N	\N	\N	\N	93081	93081	260894
10088	9946	0	applied	\N	\N	\N	\N	93104	93104	260917
10088	9947	1	applied	\N	\N	\N	\N	93105	93105	260918
10088	9948	2	applied	\N	\N	\N	\N	93106	93106	260919
10088	9949	3	applied	\N	\N	\N	\N	93107	93107	260920
10088	9950	4	applied	\N	\N	\N	\N	93108	93108	260921
10088	9951	5	applied	\N	\N	\N	\N	93109	93109	260922
10088	9952	6	applied	\N	\N	\N	\N	93110	93110	260923
10088	9953	7	applied	\N	\N	\N	\N	93111	93111	260924
10088	9954	8	applied	\N	\N	\N	\N	93112	93112	260925
10088	9955	9	applied	\N	\N	\N	\N	93113	93113	260926
10088	9956	10	applied	\N	\N	\N	\N	93114	93114	260927
10088	9958	12	applied	\N	\N	\N	\N	93116	93116	260929
10088	9959	13	applied	\N	\N	\N	\N	93117	93117	260930
10088	9960	14	applied	\N	\N	\N	\N	93118	93118	260931
10088	9961	15	applied	\N	\N	\N	\N	93119	93119	260932
10088	9962	16	applied	\N	\N	\N	\N	93120	93120	260933
10088	9963	17	applied	\N	\N	\N	\N	93121	93121	260934
10101	10030	0	applied	\N	\N	\N	\N	93368	93368	261181
10104	10038	0	applied	\N	\N	\N	\N	93376	93376	261189
10104	10039	1	applied	\N	\N	\N	\N	93377	93377	261190
10111	10043	0	applied	\N	\N	\N	\N	93395	93395	261208
10111	10044	1	applied	\N	\N	\N	\N	93396	93396	261209
10111	10045	2	applied	\N	\N	\N	\N	93397	93397	261210
10111	10046	3	applied	\N	\N	\N	\N	93398	93398	261211
10111	10047	4	applied	\N	\N	\N	\N	93399	93399	261212
10111	10048	5	applied	\N	\N	\N	\N	93400	93400	261213
10111	10049	6	applied	\N	\N	\N	\N	93401	93401	261214
10113	10051	1	applied	\N	\N	\N	\N	93528	93528	261341
10113	10052	2	applied	\N	\N	\N	\N	93529	93529	261342
10113	10053	3	applied	\N	\N	\N	\N	93530	93530	261343
10113	10054	4	applied	\N	\N	\N	\N	93531	93531	261344
10113	10055	5	applied	\N	\N	\N	\N	93532	93532	261345
10113	10056	6	applied	\N	\N	\N	\N	93533	93533	261346
10113	10057	7	applied	\N	\N	\N	\N	93534	93534	261347
10113	10058	8	applied	\N	\N	\N	\N	93535	93535	261348
10113	10059	9	applied	\N	\N	\N	\N	93536	93536	261349
10113	10060	10	applied	\N	\N	\N	\N	93537	93537	261350
10118	10079	0	applied	\N	\N	\N	\N	93567	93567	261380
10118	10080	1	applied	\N	\N	\N	\N	93568	93568	261381
10118	10081	2	applied	\N	\N	\N	\N	93569	93569	261382
10121	10082	0	applied	\N	\N	\N	\N	93576	93576	261389
10121	10083	1	applied	\N	\N	\N	\N	93577	93577	261390
10121	10084	2	applied	\N	\N	\N	\N	93578	93578	261391
10121	10086	4	applied	\N	\N	\N	\N	93580	93580	261393
10121	10087	5	applied	\N	\N	\N	\N	93581	93581	261394
10121	10088	6	applied	\N	\N	\N	\N	93582	93582	261395
10121	10089	7	applied	\N	\N	\N	\N	93583	93583	261396
10121	10090	8	applied	\N	\N	\N	\N	93584	93584	261397
10121	10091	9	applied	\N	\N	\N	\N	93585	93585	261398
10121	10092	10	applied	\N	\N	\N	\N	93586	93586	261399
10121	10093	11	applied	\N	\N	\N	\N	93587	93587	261400
10121	10094	12	applied	\N	\N	\N	\N	93588	93588	261401
10124	10098	0	applied	\N	\N	\N	\N	93727	93727	261540
10124	10097	1	applied	\N	\N	\N	\N	93728	93728	261541
10128	10103	0	applied	\N	\N	\N	\N	93737	93737	261550
10130	10104	0	applied	\N	\N	\N	\N	93740	93740	261553
10130	10103	1	applied	\N	\N	\N	\N	93741	93741	261554
10137	9992	0	applied	\N	\N	\N	\N	93762	93762	261575
10137	10109	1	applied	\N	\N	\N	\N	93763	93763	261576
10071	9861	2	applied	\N	\N	\N	\N	92933	92933	260746
10071	9862	3	applied	\N	\N	\N	\N	92934	92934	260747
10076	9895	6	applied	\N	\N	\N	\N	92974	92974	260787
10081	9911	0	applied	\N	\N	\N	\N	92999	92999	260812
10081	9912	1	applied	\N	\N	\N	\N	93000	93000	260813
10084	9920	0	applied	\N	\N	\N	\N	93008	93008	260821
10084	9921	1	applied	\N	\N	\N	\N	93009	93009	260822
10084	9922	2	applied	\N	\N	\N	\N	93010	93010	260823
10084	9923	3	applied	\N	\N	\N	\N	93011	93011	260824
10084	9924	4	applied	\N	\N	\N	\N	93012	93012	260825
10084	9925	5	applied	\N	\N	\N	\N	93013	93013	260826
10084	9926	6	applied	\N	\N	\N	\N	93014	93014	260827
10084	9927	7	applied	\N	\N	\N	\N	93015	93015	260828
10084	9928	8	applied	\N	\N	\N	\N	93016	93016	260829
10084	9929	9	applied	\N	\N	\N	\N	93017	93017	260830
10084	9931	11	applied	\N	\N	\N	\N	93019	93019	260832
10084	9932	12	applied	\N	\N	\N	\N	93020	93020	260833
10084	9933	13	applied	\N	\N	\N	\N	93021	93021	260834
10084	9934	14	applied	\N	\N	\N	\N	93022	93022	260835
10084	9935	15	applied	\N	\N	\N	\N	93023	93023	260836
10084	9936	16	applied	\N	\N	\N	\N	93024	93024	260837
10084	9937	17	applied	\N	\N	\N	\N	93025	93025	260838
10084	9938	18	applied	\N	\N	\N	\N	93026	93026	260839
10084	9939	19	applied	\N	\N	\N	\N	93027	93027	260840
10084	9940	20	applied	\N	\N	\N	\N	93028	93028	260841
10084	9941	21	applied	\N	\N	\N	\N	93029	93029	260842
10084	9942	22	applied	\N	\N	\N	\N	93030	93030	260843
10084	9943	23	applied	\N	\N	\N	\N	93031	93031	260844
10084	9944	24	applied	\N	\N	1000000000	\N	93032	93032	260845
10084	9945	25	applied	\N	\N	\N	\N	93033	93033	260846
10087	9946	0	applied	\N	\N	\N	\N	93082	93082	260895
10087	9948	2	applied	\N	\N	\N	\N	93084	93084	260897
10087	9949	3	applied	\N	\N	\N	\N	93085	93085	260898
10087	9950	4	applied	\N	\N	\N	\N	93086	93086	260899
10087	9951	5	applied	\N	\N	\N	\N	93087	93087	260900
10087	9952	6	applied	\N	\N	\N	\N	93088	93088	260901
10087	9953	7	applied	\N	\N	\N	\N	93089	93089	260902
10087	9954	8	applied	\N	\N	\N	\N	93090	93090	260903
10087	9955	9	applied	\N	\N	\N	\N	93091	93091	260904
10088	9964	18	applied	\N	\N	\N	\N	93122	93122	260935
10088	9965	19	applied	\N	\N	\N	\N	93123	93123	260936
10088	9966	20	applied	\N	\N	\N	\N	93124	93124	260937
10088	9967	21	applied	\N	\N	\N	\N	93125	93125	260938
10090	9767	0	applied	\N	\N	\N	\N	93138	93138	260951
10090	9669	1	applied	\N	\N	\N	\N	93139	93139	260952
10090	9880	2	applied	\N	\N	\N	\N	93140	93140	260953
10090	9655	3	applied	\N	\N	\N	\N	93141	93141	260954
10090	9660	5	applied	\N	\N	\N	\N	93143	93143	260956
10090	9657	6	applied	\N	\N	\N	\N	93144	93144	260957
10090	9842	7	applied	\N	\N	\N	\N	93145	93145	260958
10090	9843	8	applied	\N	\N	\N	\N	93146	93146	260959
10090	9662	9	applied	\N	\N	\N	\N	93147	93147	260960
10090	9663	10	applied	\N	\N	\N	\N	93148	93148	260961
10090	9923	11	applied	\N	\N	\N	\N	93149	93149	260962
10090	9924	12	applied	\N	\N	\N	\N	93150	93150	260963
10090	9925	13	applied	\N	\N	\N	\N	93151	93151	260964
10090	9926	14	applied	\N	\N	\N	\N	93152	93152	260965
10090	9831	15	applied	\N	\N	\N	\N	93153	93153	260966
10090	9832	16	applied	\N	\N	\N	\N	93154	93154	260967
10090	9667	17	applied	\N	\N	\N	\N	93155	93155	260968
10090	9668	18	applied	\N	\N	\N	\N	93156	93156	260969
10090	9768	19	applied	\N	\N	\N	\N	93157	93157	260970
10090	9769	20	applied	\N	\N	\N	\N	93158	93158	260971
10090	9846	22	applied	\N	\N	\N	\N	93160	93160	260973
10090	9847	23	applied	\N	\N	\N	\N	93161	93161	260974
10090	9658	24	applied	\N	\N	\N	\N	93162	93162	260975
10090	9772	25	applied	\N	\N	\N	\N	93163	93163	260976
10090	9848	26	applied	\N	\N	\N	\N	93164	93164	260977
10090	9849	27	applied	\N	\N	\N	\N	93165	93165	260978
10090	9850	28	applied	\N	\N	\N	\N	93166	93166	260979
10090	9851	29	applied	\N	\N	\N	\N	93167	93167	260980
10090	9852	30	applied	\N	\N	\N	\N	93168	93168	260981
10090	9853	31	applied	\N	\N	\N	\N	93169	93169	260982
10090	9927	32	applied	\N	\N	\N	\N	93170	93170	260983
10090	9928	33	applied	\N	\N	\N	\N	93171	93171	260984
10090	9929	34	applied	\N	\N	\N	\N	93172	93172	260985
10090	9930	35	applied	\N	\N	\N	\N	93173	93173	260986
10090	9931	36	applied	\N	\N	\N	\N	93174	93174	260987
10090	9932	37	applied	\N	\N	\N	\N	93175	93175	260988
10090	9934	39	applied	\N	\N	\N	\N	93177	93177	260990
10090	9935	40	applied	\N	\N	\N	\N	93178	93178	260991
10090	9936	41	applied	\N	\N	\N	\N	93179	93179	260992
10090	9937	42	applied	\N	\N	\N	\N	93180	93180	260993
10090	9938	43	applied	\N	\N	\N	\N	93181	93181	260994
10090	9939	44	applied	\N	\N	\N	\N	93182	93182	260995
10090	9940	45	applied	\N	\N	\N	\N	93183	93183	260996
10090	9941	46	applied	\N	\N	\N	\N	93184	93184	260997
10090	9947	47	applied	\N	\N	\N	\N	93185	93185	260998
10090	9948	48	applied	\N	\N	\N	\N	93186	93186	260999
10090	9949	49	applied	\N	\N	\N	\N	93187	93187	261000
10090	9950	50	applied	\N	\N	\N	\N	93188	93188	261001
10090	9951	51	applied	\N	\N	\N	\N	93189	93189	261002
10090	9952	52	applied	\N	\N	\N	\N	93190	93190	261003
10090	9953	53	applied	\N	\N	\N	\N	93191	93191	261004
10090	9954	54	applied	\N	\N	\N	\N	93192	93192	261005
10090	9956	56	applied	\N	\N	\N	\N	93194	93194	261007
10090	9957	57	applied	\N	\N	\N	\N	93195	93195	261008
10090	9958	58	applied	\N	\N	\N	\N	93196	93196	261009
10090	9959	59	applied	\N	\N	\N	\N	93197	93197	261010
10090	9672	60	applied	\N	\N	\N	\N	93198	93198	261011
10090	9676	61	applied	\N	\N	\N	\N	93199	93199	261012
10090	9854	62	applied	\N	\N	\N	\N	93200	93200	261013
10090	9678	63	applied	\N	\N	\N	\N	93201	93201	261014
10090	9685	64	applied	\N	\N	\N	\N	93202	93202	261015
10090	9686	65	applied	\N	\N	\N	\N	93203	93203	261016
10090	9659	66	applied	\N	\N	\N	\N	93204	93204	261017
10090	9661	67	applied	\N	\N	\N	\N	93205	93205	261018
10090	9664	68	applied	\N	\N	\N	\N	93206	93206	261019
10090	9666	69	applied	\N	\N	\N	\N	93207	93207	261020
10090	9670	70	applied	\N	\N	\N	\N	93208	93208	261021
10090	9671	71	applied	\N	\N	\N	\N	93209	93209	261022
10076	9898	4	applied	\N	\N	\N	\N	92972	92972	260785
10076	9899	5	applied	\N	\N	1000000000	\N	92973	92973	260786
10087	9960	14	applied	\N	\N	\N	\N	93096	93096	260909
10087	9961	15	applied	\N	\N	\N	\N	93097	93097	260910
10087	9962	16	applied	\N	\N	\N	\N	93098	93098	260911
10087	9963	17	applied	\N	\N	\N	\N	93099	93099	260912
10087	9964	18	applied	\N	\N	\N	\N	93100	93100	260913
10087	9965	19	applied	\N	\N	\N	\N	93101	93101	260914
10087	9966	20	applied	\N	\N	\N	\N	93102	93102	260915
10087	9967	21	applied	\N	\N	\N	\N	93103	93103	260916
10089	9968	0	applied	\N	\N	1000000000	\N	93126	93126	260939
10089	9969	1	applied	\N	\N	\N	\N	93127	93127	260940
10089	9970	2	applied	\N	\N	\N	\N	93128	93128	260941
10089	9971	3	applied	\N	\N	\N	\N	93129	93129	260942
10089	9972	4	applied	\N	\N	\N	\N	93130	93130	260943
10089	9973	5	applied	\N	\N	\N	\N	93131	93131	260944
10089	9975	7	applied	\N	\N	\N	\N	93133	93133	260946
10089	9976	8	applied	\N	\N	\N	\N	93134	93134	260947
10089	9977	9	applied	\N	\N	\N	\N	93135	93135	260948
10089	9978	10	applied	\N	\N	\N	\N	93136	93136	260949
10089	9979	11	applied	\N	\N	\N	\N	93137	93137	260950
10090	9677	73	applied	\N	\N	\N	\N	93211	93211	261024
10090	9680	74	applied	\N	\N	\N	\N	93212	93212	261025
10090	9682	75	applied	\N	\N	\N	\N	93213	93213	261026
10090	9687	76	applied	\N	\N	\N	\N	93214	93214	261027
10090	9688	77	applied	\N	\N	\N	\N	93215	93215	261028
10090	9690	78	applied	\N	\N	\N	\N	93216	93216	261029
10090	9692	79	applied	\N	\N	\N	\N	93217	93217	261030
10090	9693	80	applied	\N	\N	\N	\N	93218	93218	261031
10090	9699	81	applied	\N	\N	\N	\N	93219	93219	261032
10090	9700	82	applied	\N	\N	\N	\N	93220	93220	261033
10090	9702	83	applied	\N	\N	\N	\N	93221	93221	261034
10090	9707	86	applied	\N	\N	\N	\N	93223	93223	261036
10090	9708	87	applied	\N	\N	\N	\N	93224	93224	261037
10090	9709	88	applied	\N	\N	\N	\N	93225	93225	261038
10090	9722	89	applied	\N	\N	\N	\N	93226	93226	261039
10090	9724	90	applied	\N	\N	\N	\N	93227	93227	261040
10090	9727	91	applied	\N	\N	\N	\N	93228	93228	261041
10090	9728	92	applied	\N	\N	\N	\N	93229	93229	261042
10090	9732	93	applied	\N	\N	\N	\N	93230	93230	261043
10090	9733	94	applied	\N	\N	\N	\N	93231	93231	261044
10090	9738	95	applied	\N	\N	\N	\N	93232	93232	261045
10090	9740	96	applied	\N	\N	\N	\N	93233	93233	261046
10090	9744	97	applied	\N	\N	\N	\N	93234	93234	261047
10090	9746	98	applied	\N	\N	\N	\N	93235	93235	261048
10090	9748	99	applied	\N	\N	\N	\N	93236	93236	261049
10090	9750	100	applied	\N	\N	\N	\N	93237	93237	261050
10090	9754	101	applied	\N	\N	\N	\N	93238	93238	261051
10090	9756	103	applied	\N	\N	\N	\N	93240	93240	261053
10090	9766	104	applied	\N	\N	\N	\N	93241	93241	261054
10090	9771	105	applied	\N	\N	\N	\N	93242	93242	261055
10090	9774	106	applied	\N	\N	\N	\N	93243	93243	261056
10090	9778	107	applied	\N	\N	\N	\N	93244	93244	261057
10090	9783	108	applied	\N	\N	\N	\N	93245	93245	261058
10090	9784	109	applied	\N	\N	\N	\N	93246	93246	261059
10090	9785	110	applied	\N	\N	\N	\N	93247	93247	261060
10090	9673	111	applied	\N	\N	\N	\N	93248	93248	261061
10090	9675	112	applied	\N	\N	\N	\N	93249	93249	261062
10090	9683	113	applied	\N	\N	\N	\N	93250	93250	261063
10091	9980	0	applied	\N	\N	\N	\N	93251	93251	261064
10091	9981	1	applied	\N	\N	\N	\N	93252	93252	261065
10091	9982	2	applied	\N	\N	\N	\N	93253	93253	261066
10091	9983	3	applied	\N	\N	\N	\N	93254	93254	261067
10091	9984	4	applied	\N	\N	\N	\N	93255	93255	261068
10091	9986	6	applied	\N	\N	\N	\N	93257	93257	261070
10091	9987	7	applied	\N	\N	\N	\N	93258	93258	261071
10091	9988	8	applied	\N	\N	\N	\N	93259	93259	261072
10091	9989	9	applied	\N	\N	\N	\N	93260	93260	261073
10091	9990	10	applied	\N	\N	\N	\N	93261	93261	261074
10091	9991	11	applied	\N	\N	\N	\N	93262	93262	261075
10093	9992	0	applied	\N	\N	\N	\N	93284	93284	261097
10093	9993	1	applied	\N	\N	\N	\N	93285	93285	261098
10093	9994	2	applied	\N	\N	\N	\N	93286	93286	261099
10094	9992	0	applied	\N	\N	\N	\N	93305	93305	261118
10094	9993	1	applied	\N	\N	\N	\N	93306	93306	261119
10094	9994	2	applied	\N	\N	\N	\N	93307	93307	261120
10094	9995	3	applied	\N	\N	\N	\N	93308	93308	261121
10094	9996	4	applied	\N	\N	\N	\N	93309	93309	261122
10094	9997	5	applied	\N	\N	\N	\N	93310	93310	261123
10094	9998	6	applied	\N	\N	\N	\N	93311	93311	261124
10094	10000	9	applied	\N	\N	\N	\N	93313	93313	261126
10094	10001	10	applied	\N	\N	\N	\N	93314	93314	261127
10094	10002	11	applied	\N	\N	\N	\N	93315	93315	261128
10094	10003	12	applied	\N	\N	\N	\N	93316	93316	261129
10094	10004	13	applied	\N	\N	\N	\N	93317	93317	261130
10094	10005	14	applied	\N	\N	\N	\N	93318	93318	261131
10094	10006	15	applied	\N	\N	\N	\N	93319	93319	261132
10094	10007	16	applied	\N	\N	\N	\N	93320	93320	261133
10094	10008	17	applied	\N	\N	\N	\N	93321	93321	261134
10094	10009	18	applied	\N	\N	\N	\N	93322	93322	261135
10094	10010	19	applied	\N	\N	\N	\N	93323	93323	261136
10094	10011	20	applied	\N	\N	\N	\N	93324	93324	261137
10094	10012	21	applied	\N	\N	\N	\N	93325	93325	261138
10095	9992	0	applied	\N	\N	\N	\N	93326	93326	261139
10095	9993	1	applied	\N	\N	\N	\N	93327	93327	261140
10095	9994	2	applied	\N	\N	\N	\N	93328	93328	261141
10095	9996	4	applied	\N	\N	\N	\N	93330	93330	261143
10095	9997	5	applied	\N	\N	\N	\N	93331	93331	261144
10095	9998	6	applied	\N	\N	\N	\N	93332	93332	261145
10095	9999	8	applied	\N	\N	\N	\N	93333	93333	261146
10095	10000	9	applied	\N	\N	\N	\N	93334	93334	261147
10095	10001	10	applied	\N	\N	\N	\N	93335	93335	261148
10095	10002	11	applied	\N	\N	\N	\N	93336	93336	261149
10095	10003	12	applied	\N	\N	\N	\N	93337	93337	261150
10095	10004	13	applied	\N	\N	\N	\N	93338	93338	261151
10095	10005	14	applied	\N	\N	\N	\N	93339	93339	261152
10095	10006	15	applied	\N	\N	\N	\N	93340	93340	261153
10095	10007	16	applied	\N	\N	\N	\N	93341	93341	261154
10095	10008	17	applied	\N	\N	\N	\N	93342	93342	261155
10095	10009	18	applied	\N	\N	\N	\N	93343	93343	261156
10095	10010	19	applied	\N	\N	\N	\N	93344	93344	261157
10095	10011	20	applied	\N	\N	\N	\N	93345	93345	261158
10087	9959	13	applied	\N	\N	\N	\N	93095	93095	260908
10093	9998	6	applied	\N	\N	\N	\N	93290	93290	261103
10093	9999	8	applied	\N	\N	\N	\N	93291	93291	261104
10093	10000	9	applied	\N	\N	\N	\N	93292	93292	261105
10093	10001	10	applied	\N	\N	\N	\N	93293	93293	261106
10093	10002	11	applied	\N	\N	\N	\N	93294	93294	261107
10093	10003	12	applied	\N	\N	\N	\N	93295	93295	261108
10093	10004	13	applied	\N	\N	\N	\N	93296	93296	261109
10093	10005	14	applied	\N	\N	\N	\N	93297	93297	261110
10093	10006	15	applied	\N	\N	\N	\N	93298	93298	261111
10093	10007	16	applied	\N	\N	\N	\N	93299	93299	261112
10093	10008	17	applied	\N	\N	\N	\N	93300	93300	261113
10093	10010	19	applied	\N	\N	\N	\N	93302	93302	261115
10093	10011	20	applied	\N	\N	\N	\N	93303	93303	261116
10093	10012	21	applied	\N	\N	\N	\N	93304	93304	261117
10095	10012	21	applied	\N	\N	\N	\N	93346	93346	261159
10096	10013	0	applied	\N	\N	\N	\N	93347	93347	261160
10096	10014	1	applied	\N	\N	\N	\N	93348	93348	261161
10096	10015	2	applied	\N	\N	\N	\N	93349	93349	261162
10096	10016	3	applied	\N	\N	\N	\N	93350	93350	261163
10098	10017	0	applied	\N	\N	\N	\N	93355	93355	261168
10098	10018	1	applied	\N	\N	\N	\N	93356	93356	261169
10098	10019	2	applied	\N	\N	1000000000	\N	93357	93357	261170
10099	10020	0	applied	\N	\N	\N	\N	93358	93358	261171
10099	10021	1	applied	\N	\N	\N	\N	93359	93359	261172
10099	10022	2	applied	\N	\N	\N	\N	93360	93360	261173
10099	10023	3	applied	\N	\N	\N	\N	93361	93361	261174
10099	10024	4	applied	\N	\N	\N	\N	93362	93362	261175
10099	10026	6	applied	\N	\N	\N	\N	93364	93364	261177
10099	10027	7	applied	\N	\N	\N	\N	93365	93365	261178
10099	10028	8	applied	\N	\N	\N	\N	93366	93366	261179
10099	10029	9	applied	\N	\N	\N	\N	93367	93367	261180
10103	10032	0	applied	\N	\N	\N	\N	93370	93370	261183
10103	10033	1	applied	\N	\N	\N	\N	93371	93371	261184
10103	10034	2	applied	\N	\N	\N	\N	93372	93372	261185
10103	10035	3	applied	\N	\N	\N	\N	93373	93373	261186
10103	10036	4	applied	\N	\N	\N	\N	93374	93374	261187
10103	10037	5	applied	\N	\N	\N	\N	93375	93375	261188
10106	10038	0	applied	\N	\N	\N	\N	93380	93380	261193
10106	10039	1	applied	\N	\N	\N	\N	93381	93381	261194
10109	10040	0	applied	\N	\N	\N	\N	93385	93385	261198
10109	10041	1	applied	\N	\N	\N	\N	93386	93386	261199
10109	10042	2	applied	\N	\N	\N	\N	93387	93387	261200
10110	10043	0	applied	\N	\N	\N	\N	93388	93388	261201
10110	10045	2	applied	\N	\N	\N	\N	93390	93390	261203
10110	10046	3	applied	\N	\N	\N	\N	93391	93391	261204
10110	10047	4	applied	\N	\N	\N	\N	93392	93392	261205
10110	10048	5	applied	\N	\N	\N	\N	93393	93393	261206
10110	10049	6	applied	\N	\N	\N	\N	93394	93394	261207
10112	9992	0	applied	\N	\N	\N	\N	93402	93402	261215
10112	9993	1	applied	\N	\N	\N	\N	93403	93403	261216
10112	10020	2	applied	\N	\N	\N	\N	93404	93404	261217
10112	9980	3	applied	\N	\N	\N	\N	93405	93405	261218
10112	10013	4	applied	\N	\N	\N	\N	93406	93406	261219
10112	10014	5	applied	\N	\N	\N	\N	93407	93407	261220
10112	10015	6	applied	\N	\N	\N	\N	93408	93408	261221
10112	9880	7	applied	\N	\N	\N	\N	93409	93409	261222
10112	10039	8	applied	\N	\N	\N	\N	93410	93410	261223
10112	10025	9	applied	\N	\N	\N	\N	93411	93411	261224
10112	10032	10	applied	\N	\N	\N	\N	93412	93412	261225
10112	9842	12	applied	\N	\N	\N	\N	93414	93414	261227
10112	9843	13	applied	\N	\N	\N	\N	93415	93415	261228
10112	9923	14	applied	\N	\N	\N	\N	93416	93416	261229
10112	9924	15	applied	\N	\N	\N	\N	93417	93417	261230
10112	9925	16	applied	\N	\N	\N	\N	93418	93418	261231
10112	9926	17	applied	\N	\N	\N	\N	93419	93419	261232
10112	9831	18	applied	\N	\N	\N	\N	93420	93420	261233
10112	10042	19	applied	\N	\N	\N	\N	93421	93421	261234
10112	9832	20	applied	\N	\N	\N	\N	93422	93422	261235
10112	9864	21	applied	\N	\N	\N	\N	93423	93423	261236
10115	10061	0	applied	\N	\N	\N	\N	93549	93549	261362
10115	10062	1	applied	\N	\N	\N	\N	93550	93550	261363
10115	10063	2	applied	\N	\N	\N	\N	93551	93551	261364
10115	10064	3	applied	\N	\N	1000000000	\N	93552	93552	261365
10120	10079	0	applied	\N	\N	\N	\N	93573	93573	261386
10120	10080	1	applied	\N	\N	\N	\N	93574	93574	261387
10120	10081	2	applied	\N	\N	\N	\N	93575	93575	261388
10123	10066	0	applied	\N	\N	\N	\N	93602	93602	261415
10123	10067	1	applied	\N	\N	\N	\N	93603	93603	261416
10123	10082	2	applied	\N	\N	\N	\N	93604	93604	261417
10123	10083	3	applied	\N	\N	\N	\N	93605	93605	261418
10123	10084	4	applied	\N	\N	\N	\N	93606	93606	261419
10123	10085	5	applied	\N	\N	\N	\N	93607	93607	261420
10123	9870	6	applied	\N	\N	\N	\N	93608	93608	261421
10123	10050	7	applied	\N	\N	\N	\N	93609	93609	261422
10123	9873	8	applied	\N	\N	\N	\N	93610	93610	261423
10123	10068	9	applied	\N	\N	\N	\N	93611	93611	261424
10123	10071	10	applied	\N	\N	\N	\N	93612	93612	261425
10123	10072	11	applied	\N	\N	\N	\N	93613	93613	261426
10123	10073	12	applied	\N	\N	\N	\N	93614	93614	261427
10123	10052	13	applied	\N	\N	\N	\N	93615	93615	261428
10123	10094	14	applied	\N	\N	\N	\N	93616	93616	261429
10123	10054	15	applied	\N	\N	\N	\N	93617	93617	261430
10123	10055	16	applied	\N	\N	\N	\N	93618	93618	261431
10123	9882	18	applied	\N	\N	\N	\N	93620	93620	261433
10123	9883	19	applied	\N	\N	\N	\N	93621	93621	261434
10123	9884	20	applied	\N	\N	\N	\N	93622	93622	261435
10123	9885	21	applied	\N	\N	\N	\N	93623	93623	261436
10123	9893	22	applied	\N	\N	\N	\N	93624	93624	261437
10123	9897	23	applied	\N	\N	\N	\N	93625	93625	261438
10123	9901	24	applied	\N	\N	\N	\N	93626	93626	261439
10123	9905	25	applied	\N	\N	\N	\N	93627	93627	261440
10123	9909	26	applied	\N	\N	\N	\N	93628	93628	261441
10123	9912	27	applied	\N	\N	\N	\N	93629	93629	261442
10123	9914	28	applied	\N	\N	\N	\N	93630	93630	261443
10123	9919	29	applied	\N	\N	\N	\N	93631	93631	261444
10123	9920	30	applied	\N	\N	\N	\N	93632	93632	261445
10123	9921	31	applied	\N	\N	\N	\N	93633	93633	261446
10123	9922	32	applied	\N	\N	\N	\N	93634	93634	261447
10123	9960	33	applied	\N	\N	\N	\N	93635	93635	261448
10093	9996	4	applied	\N	\N	\N	\N	93288	93288	261101
10093	9997	5	applied	\N	\N	\N	\N	93289	93289	261102
10112	9848	26	applied	\N	\N	\N	\N	93428	93428	261241
10112	9849	27	applied	\N	\N	\N	\N	93429	93429	261242
10112	9850	28	applied	\N	\N	\N	\N	93430	93430	261243
10112	9851	29	applied	\N	\N	\N	\N	93431	93431	261244
10112	9852	30	applied	\N	\N	\N	\N	93432	93432	261245
10112	9853	31	applied	\N	\N	\N	\N	93433	93433	261246
10112	9927	32	applied	\N	\N	\N	\N	93434	93434	261247
10112	9928	33	applied	\N	\N	\N	\N	93435	93435	261248
10112	9929	34	applied	\N	\N	\N	\N	93436	93436	261249
10112	9930	35	applied	\N	\N	\N	\N	93437	93437	261250
10112	9931	36	applied	\N	\N	\N	\N	93438	93438	261251
10112	9932	37	applied	\N	\N	\N	\N	93439	93439	261252
10112	9933	38	applied	\N	\N	\N	\N	93440	93440	261253
10112	9934	39	applied	\N	\N	\N	\N	93441	93441	261254
10112	9935	40	applied	\N	\N	\N	\N	93442	93442	261255
10112	9937	42	applied	\N	\N	\N	\N	93444	93444	261257
10112	9938	43	applied	\N	\N	\N	\N	93445	93445	261258
10112	9939	44	applied	\N	\N	\N	\N	93446	93446	261259
10112	9940	45	applied	\N	\N	\N	\N	93447	93447	261260
10112	9941	46	applied	\N	\N	\N	\N	93448	93448	261261
10112	9947	47	applied	\N	\N	\N	\N	93449	93449	261262
10112	9948	48	applied	\N	\N	\N	\N	93450	93450	261263
10112	9949	49	applied	\N	\N	\N	\N	93451	93451	261264
10112	9950	50	applied	\N	\N	\N	\N	93452	93452	261265
10112	9951	51	applied	\N	\N	\N	\N	93453	93453	261266
10112	9952	52	applied	\N	\N	\N	\N	93454	93454	261267
10112	9953	53	applied	\N	\N	\N	\N	93455	93455	261268
10112	9954	54	applied	\N	\N	\N	\N	93456	93456	261269
10112	9955	55	applied	\N	\N	\N	\N	93457	93457	261270
10112	9956	56	applied	\N	\N	\N	\N	93458	93458	261271
10112	9957	57	applied	\N	\N	\N	\N	93459	93459	261272
10112	9959	59	applied	\N	\N	\N	\N	93461	93461	261274
10112	9854	60	applied	\N	\N	\N	\N	93462	93462	261275
10112	9809	61	applied	\N	\N	\N	\N	93463	93463	261276
10112	9810	62	applied	\N	\N	\N	\N	93464	93464	261277
10112	9812	63	applied	\N	\N	\N	\N	93465	93465	261278
10112	9814	64	applied	\N	\N	\N	\N	93466	93466	261279
10112	9816	65	applied	\N	\N	\N	\N	93467	93467	261280
10112	9818	66	applied	\N	\N	\N	\N	93468	93468	261281
10112	9821	67	applied	\N	\N	\N	\N	93469	93469	261282
10112	9822	68	applied	\N	\N	\N	\N	93470	93470	261283
10112	9823	69	applied	\N	\N	\N	\N	93471	93471	261284
10112	9827	70	applied	\N	\N	\N	\N	93472	93472	261285
10112	9829	71	applied	\N	\N	\N	\N	93473	93473	261286
10112	9830	72	applied	\N	\N	\N	\N	93474	93474	261287
10112	9840	73	applied	\N	\N	\N	\N	93475	93475	261288
10112	9844	74	applied	\N	\N	\N	\N	93476	93476	261289
10112	9856	76	applied	\N	\N	\N	\N	93478	93478	261291
10112	9860	77	applied	\N	\N	\N	\N	93479	93479	261292
10112	9861	78	applied	\N	\N	\N	\N	93480	93480	261293
10112	9815	79	applied	\N	\N	\N	\N	93481	93481	261294
10112	9817	80	applied	\N	\N	\N	\N	93482	93482	261295
10112	9819	81	applied	\N	\N	\N	\N	93483	93483	261296
10112	9820	82	applied	\N	\N	\N	\N	93484	93484	261297
10112	9824	83	applied	\N	\N	\N	\N	93485	93485	261298
10112	9826	84	applied	\N	\N	\N	\N	93486	93486	261299
10112	9828	85	applied	\N	\N	\N	\N	93487	93487	261300
10112	9833	86	applied	\N	\N	1000000000	\N	93488	93488	261301
10112	9834	87	applied	\N	\N	1000000000	\N	93489	93489	261302
10112	9835	88	applied	\N	\N	\N	\N	93490	93490	261303
10112	9836	89	applied	\N	\N	1000000000	\N	93491	93491	261304
10112	9838	91	applied	\N	\N	\N	\N	93493	93493	261306
10112	9839	92	applied	\N	\N	\N	\N	93494	93494	261307
10112	9841	93	applied	\N	\N	\N	\N	93495	93495	261308
10112	9855	94	applied	\N	\N	\N	\N	93496	93496	261309
10112	9862	95	applied	\N	\N	\N	\N	93497	93497	261310
10112	9863	96	applied	\N	\N	1000000000	\N	93498	93498	261311
10112	9865	97	applied	\N	\N	\N	\N	93499	93499	261312
10112	9866	98	applied	\N	\N	1000000000	\N	93500	93500	261313
10112	9867	99	applied	\N	\N	\N	\N	93501	93501	261314
10112	9868	100	applied	\N	\N	\N	\N	93502	93502	261315
10112	9874	101	applied	\N	\N	\N	\N	93503	93503	261316
10112	9886	102	applied	\N	\N	\N	\N	93504	93504	261317
10112	9887	103	applied	\N	\N	\N	\N	93505	93505	261318
10112	9888	104	applied	\N	\N	\N	\N	93506	93506	261319
10112	9894	105	applied	\N	\N	\N	\N	93507	93507	261320
10112	9898	106	applied	\N	\N	\N	\N	93508	93508	261321
10112	9899	107	applied	\N	\N	1000000000	\N	93509	93509	261322
10112	9900	108	applied	\N	\N	\N	\N	93510	93510	261323
10112	9906	109	applied	\N	\N	\N	\N	93511	93511	261324
10112	9907	110	applied	\N	\N	\N	\N	93512	93512	261325
10112	9913	112	applied	\N	\N	\N	\N	93514	93514	261327
10112	9918	113	applied	\N	\N	\N	\N	93515	93515	261328
10112	9942	115	applied	\N	\N	\N	\N	93516	93516	261329
10112	9943	116	applied	\N	\N	\N	\N	93517	93517	261330
10112	9944	117	applied	\N	\N	1000000000	\N	93518	93518	261331
10112	9945	118	applied	\N	\N	\N	\N	93519	93519	261332
10112	9946	119	applied	\N	\N	\N	\N	93520	93520	261333
10112	9962	120	applied	\N	\N	\N	\N	93521	93521	261334
10112	9972	121	applied	\N	\N	\N	\N	93522	93522	261335
10112	9982	122	applied	\N	\N	\N	\N	93523	93523	261336
10112	9995	123	applied	\N	\N	\N	\N	93524	93524	261337
10112	10045	124	applied	\N	\N	\N	\N	93525	93525	261338
10112	9869	125	applied	\N	\N	\N	\N	93526	93526	261339
10114	10050	0	applied	\N	\N	\N	\N	93538	93538	261351
10114	10051	1	applied	\N	\N	\N	\N	93539	93539	261352
10114	10052	2	applied	\N	\N	\N	\N	93540	93540	261353
10114	10054	4	applied	\N	\N	\N	\N	93542	93542	261355
10114	10055	5	applied	\N	\N	\N	\N	93543	93543	261356
10114	10056	6	applied	\N	\N	\N	\N	93544	93544	261357
10114	10057	7	applied	\N	\N	\N	\N	93545	93545	261358
10114	10058	8	applied	\N	\N	\N	\N	93546	93546	261359
10114	10059	9	applied	\N	\N	\N	\N	93547	93547	261360
10114	10060	10	applied	\N	\N	\N	\N	93548	93548	261361
10116	10066	0	applied	\N	\N	\N	\N	93554	93554	261367
10116	10067	1	applied	\N	\N	\N	\N	93555	93555	261368
10116	10068	2	applied	\N	\N	\N	\N	93556	93556	261369
10116	10069	3	applied	\N	\N	1000000000	\N	93557	93557	261370
10116	10070	4	applied	\N	\N	\N	\N	93558	93558	261371
10112	9847	23	applied	\N	\N	\N	\N	93425	93425	261238
10112	9813	25	applied	\N	\N	\N	\N	93427	93427	261240
10116	10075	9	applied	\N	\N	1000000000	\N	93563	93563	261376
10117	10077	1	applied	\N	\N	\N	\N	93565	93565	261378
10117	10078	2	applied	\N	\N	\N	\N	93566	93566	261379
10119	10079	0	applied	\N	\N	\N	\N	93570	93570	261383
10119	10080	1	applied	\N	\N	\N	\N	93571	93571	261384
10119	10081	2	applied	\N	\N	\N	\N	93572	93572	261385
10122	10082	0	applied	\N	\N	\N	\N	93589	93589	261402
10122	10083	1	applied	\N	\N	\N	\N	93590	93590	261403
10122	10084	2	applied	\N	\N	\N	\N	93591	93591	261404
10122	10085	3	applied	\N	\N	\N	\N	93592	93592	261405
10122	10086	4	applied	\N	\N	\N	\N	93593	93593	261406
10122	10087	5	applied	\N	\N	\N	\N	93594	93594	261407
10122	10088	6	applied	\N	\N	\N	\N	93595	93595	261408
10122	10089	7	applied	\N	\N	\N	\N	93596	93596	261409
10122	10091	9	applied	\N	\N	\N	\N	93598	93598	261411
10122	10092	10	applied	\N	\N	\N	\N	93599	93599	261412
10122	10093	11	applied	\N	\N	\N	\N	93600	93600	261413
10122	10094	12	applied	\N	\N	\N	\N	93601	93601	261414
10125	10098	0	applied	\N	\N	\N	\N	93729	93729	261542
10125	10097	1	applied	\N	\N	\N	\N	93730	93730	261543
10129	10104	0	applied	\N	\N	\N	\N	93738	93738	261551
10129	10103	1	applied	\N	\N	\N	\N	93739	93739	261552
10131	10105	0	applied	\N	\N	\N	\N	93742	93742	261555
10131	10106	1	applied	\N	\N	\N	\N	93743	93743	261556
10131	10107	2	applied	\N	\N	\N	\N	93744	93744	261557
10133	10105	0	applied	\N	\N	\N	\N	93749	93749	261562
10133	10108	1	applied	\N	\N	\N	\N	93750	93750	261563
10133	10106	2	applied	\N	\N	\N	\N	93751	93751	261564
10136	10114	0	applied	\N	\N	\N	\N	93758	93758	261571
10136	10115	1	applied	\N	\N	\N	\N	93759	93759	261572
10136	10117	3	applied	\N	\N	\N	\N	93761	93761	261574
10138	10109	0	applied	\N	\N	\N	\N	93887	93887	261700
10138	10110	1	applied	\N	\N	\N	\N	93888	93888	261701
10138	10111	2	applied	\N	\N	\N	\N	93889	93889	261702
10138	10107	3	applied	\N	\N	\N	\N	93890	93890	261703
10138	10112	4	applied	\N	\N	\N	\N	93891	93891	261704
10138	10113	5	applied	\N	\N	\N	\N	93892	93892	261705
10139	10114	0	applied	\N	\N	\N	\N	93893	93893	261706
10139	10115	1	applied	\N	\N	\N	\N	93894	93894	261707
10139	10116	2	applied	\N	\N	\N	\N	93895	93895	261708
10139	10117	3	applied	\N	\N	\N	\N	93896	93896	261709
10142	10118	0	applied	\N	\N	\N	\N	93918	93918	261730
10142	10119	1	applied	\N	\N	\N	\N	93919	93919	261731
10142	10120	2	applied	\N	\N	\N	\N	93920	93920	261732
10143	10121	0	applied	\N	\N	\N	\N	93921	93921	261733
10143	10122	1	applied	\N	\N	\N	\N	93922	93922	261734
10143	10124	3	applied	\N	\N	\N	\N	93924	93924	261736
10143	10125	4	applied	\N	\N	\N	\N	93925	93925	261737
10143	10126	5	applied	\N	\N	\N	\N	93926	93926	261738
10144	10127	0	applied	\N	\N	\N	\N	93927	93927	261739
10144	10128	1	applied	\N	\N	\N	\N	93928	93928	261740
10148	10129	0	applied	\N	\N	\N	\N	93935	93935	261747
10148	10130	1	applied	\N	\N	\N	\N	93936	93936	261748
10149	10129	0	applied	\N	\N	\N	\N	93937	93937	261749
10149	10130	1	applied	\N	\N	\N	\N	93938	93938	261750
10153	10133	0	applied	\N	\N	\N	\N	93945	93945	261757
10153	10134	1	applied	\N	\N	\N	\N	93946	93946	261758
10154	10133	0	applied	\N	\N	\N	\N	93947	93947	261759
10154	10134	1	applied	\N	\N	\N	\N	93948	93948	261760
10155	10135	0	applied	\N	\N	\N	\N	93949	93949	261761
10155	10136	1	applied	\N	\N	\N	\N	93950	93950	261762
10155	10137	2	applied	\N	\N	\N	\N	93951	93951	261763
10158	10139	0	applied	\N	\N	\N	\N	93959	93959	261771
10158	10140	1	applied	\N	\N	\N	\N	93960	93960	261772
10159	10139	0	applied	\N	\N	\N	\N	93961	93961	261773
10159	10140	1	applied	\N	\N	\N	\N	93962	93962	261774
10162	10141	0	applied	\N	\N	\N	\N	93967	93967	261779
10162	10142	1	applied	\N	\N	\N	\N	93968	93968	261780
10163	10143	0	applied	\N	\N	\N	\N	93969	93969	261781
10163	10144	1	applied	\N	\N	\N	\N	93970	93970	261782
10163	10145	2	applied	\N	\N	\N	\N	93971	93971	261783
10163	10146	3	applied	\N	\N	\N	\N	93972	93972	261784
10163	10147	4	applied	\N	\N	\N	\N	93973	93973	261785
10163	10148	5	applied	\N	\N	\N	\N	93974	93974	261786
10163	10149	6	applied	\N	\N	\N	\N	93975	93975	261787
10163	10150	7	applied	\N	\N	\N	\N	93976	93976	261788
10163	10151	8	applied	\N	\N	\N	\N	93977	93977	261789
10163	10152	9	applied	\N	\N	\N	\N	93978	93978	261790
10163	10154	11	applied	\N	\N	\N	\N	93980	93980	261792
10167	10157	0	applied	\N	\N	\N	\N	93997	93997	261809
10167	10158	1	applied	\N	\N	\N	\N	93998	93998	261810
10168	10157	0	applied	\N	\N	\N	\N	93999	93999	261811
10168	10158	1	applied	\N	\N	\N	\N	94000	94000	261812
10172	10159	0	applied	\N	\N	\N	\N	94007	94007	261819
10173	10160	0	applied	\N	\N	\N	\N	94008	94008	261820
10173	10161	1	applied	\N	\N	\N	\N	94009	94009	261821
10173	10162	2	applied	\N	\N	\N	\N	94010	94010	261822
10173	10163	3	applied	\N	\N	\N	\N	94011	94011	261823
10173	10164	4	applied	\N	\N	\N	\N	94012	94012	261824
10173	10165	5	applied	\N	\N	\N	\N	94013	94013	261825
10173	10166	6	applied	\N	\N	\N	\N	94014	94014	261826
10173	10167	7	applied	\N	\N	\N	\N	94015	94015	261827
10173	10168	8	applied	\N	\N	\N	\N	94016	94016	261828
10173	10169	9	applied	\N	\N	\N	\N	94017	94017	261829
10173	10171	11	applied	\N	\N	\N	\N	94019	94019	261831
10173	10172	12	applied	\N	\N	\N	\N	94020	94020	261832
10173	10173	13	applied	\N	\N	\N	\N	94021	94021	261833
10173	10174	14	applied	\N	\N	\N	\N	94022	94022	261834
10173	10175	15	applied	\N	\N	\N	\N	94023	94023	261835
10173	10176	16	applied	\N	\N	\N	\N	94024	94024	261836
10174	10177	0	applied	\N	\N	\N	\N	94025	94025	261837
10178	10181	0	applied	\N	\N	\N	\N	94031	94031	261843
10178	10182	1	applied	\N	\N	\N	\N	94032	94032	261844
10178	10183	2	applied	\N	\N	\N	\N	94033	94033	261845
10178	10184	3	applied	\N	\N	\N	\N	94034	94034	261846
10183	10181	0	applied	\N	\N	\N	\N	94051	94051	261863
10183	10182	1	applied	\N	\N	\N	\N	94052	94052	261864
10183	10183	2	applied	\N	\N	\N	\N	94053	94053	261865
10183	10184	3	applied	\N	\N	\N	\N	94054	94054	261866
10187	10185	0	applied	\N	\N	\N	\N	94062	94062	261874
10116	10074	8	applied	\N	\N	\N	\N	93562	93562	261375
10123	9997	38	applied	\N	\N	\N	\N	93640	93640	261453
10123	10062	39	applied	\N	\N	1000000000	\N	93641	93641	261454
10123	9889	40	applied	\N	\N	\N	\N	93642	93642	261455
10123	9890	41	applied	\N	\N	\N	\N	93643	93643	261456
10123	9891	42	applied	\N	\N	\N	\N	93644	93644	261457
10123	10095	43	applied	\N	\N	\N	\N	93645	93645	261458
10123	10096	44	applied	\N	\N	\N	\N	93646	93646	261459
10123	9904	45	applied	\N	\N	\N	\N	93647	93647	261460
10123	10023	46	applied	\N	\N	\N	\N	93648	93648	261461
10123	9875	48	applied	\N	\N	\N	\N	93650	93650	261463
10123	9876	49	applied	\N	\N	\N	\N	93651	93651	261464
10123	9877	50	applied	\N	\N	\N	\N	93652	93652	261465
10123	10016	51	applied	\N	\N	\N	\N	93653	93653	261466
10123	10018	52	applied	\N	\N	\N	\N	93654	93654	261467
10123	10021	53	applied	\N	\N	\N	\N	93655	93655	261468
10123	10022	54	applied	\N	\N	\N	\N	93656	93656	261469
10123	10028	55	applied	\N	\N	\N	\N	93657	93657	261470
10123	10029	56	applied	\N	\N	\N	\N	93658	93658	261471
10123	10030	57	applied	\N	\N	\N	\N	93659	93659	261472
10123	10031	58	applied	\N	\N	\N	\N	93660	93660	261473
10123	10033	59	applied	\N	\N	\N	\N	93661	93661	261474
10123	10034	60	applied	\N	\N	\N	\N	93662	93662	261475
10123	10038	61	applied	\N	\N	\N	\N	93663	93663	261476
10123	10040	62	applied	\N	\N	\N	\N	93664	93664	261477
10123	10043	63	applied	\N	\N	\N	\N	93665	93665	261478
10123	10051	65	applied	\N	\N	\N	\N	93667	93667	261480
10123	10053	66	applied	\N	\N	\N	\N	93668	93668	261481
10123	10061	67	applied	\N	\N	\N	\N	93669	93669	261482
10123	10074	68	applied	\N	\N	\N	\N	93670	93670	261483
10123	10077	69	applied	\N	\N	\N	\N	93671	93671	261484
10123	10079	70	applied	\N	\N	\N	\N	93672	93672	261485
10123	10086	71	applied	\N	\N	\N	\N	93673	93673	261486
10123	10087	72	applied	\N	\N	\N	\N	93674	93674	261487
10123	10088	73	applied	\N	\N	\N	\N	93675	93675	261488
10123	10092	74	applied	\N	\N	\N	\N	93676	93676	261489
10123	10097	75	applied	\N	\N	\N	\N	93677	93677	261490
10123	9825	76	applied	\N	\N	\N	\N	93678	93678	261491
10123	9963	77	applied	\N	\N	\N	\N	93679	93679	261492
10123	9964	78	applied	\N	\N	\N	\N	93680	93680	261493
10187	10186	1	applied	\N	\N	\N	\N	94063	94063	261875
10188	10187	0	applied	\N	\N	\N	\N	94064	94064	261876
10188	10189	2	applied	\N	\N	1000000000	\N	94066	94066	261878
10188	10190	3	applied	\N	\N	\N	\N	94067	94067	261879
10188	10191	4	applied	\N	\N	\N	\N	94068	94068	261880
10194	10199	0	applied	\N	\N	\N	\N	94097	94097	261909
10194	10200	1	applied	\N	\N	\N	\N	94098	94098	261910
10194	10201	2	applied	\N	\N	\N	\N	94099	94099	261911
10194	10202	3	applied	\N	\N	\N	\N	94100	94100	261912
10199	10205	0	applied	\N	\N	\N	\N	94111	94111	261923
10199	10206	1	applied	\N	\N	\N	\N	94112	94112	261924
10200	10207	0	applied	\N	\N	\N	\N	94113	94113	261925
10200	10208	1	applied	\N	\N	\N	\N	94114	94114	261926
10205	10213	0	applied	\N	\N	\N	\N	94123	94123	261935
10205	10214	1	applied	\N	\N	\N	\N	94124	94124	261936
10210	10217	0	applied	\N	\N	\N	\N	94134	94134	261946
10210	10218	1	applied	\N	\N	\N	\N	94135	94135	261947
10210	10219	2	applied	\N	\N	\N	\N	94136	94136	261948
10212	10221	1	applied	\N	\N	\N	\N	94138	94138	261950
10212	10222	2	applied	\N	\N	\N	\N	94139	94139	261951
10212	10223	3	applied	\N	\N	\N	\N	94140	94140	261952
10212	10224	4	applied	\N	\N	\N	\N	94141	94141	261953
10212	10225	5	applied	\N	\N	\N	\N	94142	94142	261954
10216	10226	0	applied	\N	\N	\N	\N	94157	94157	261969
10216	10227	1	applied	\N	\N	\N	\N	94158	94158	261970
10228	10242	0	applied	\N	\N	\N	\N	94245	94245	262057
10229	10243	0	applied	\N	\N	\N	\N	94246	94246	262058
10229	10244	1	applied	\N	\N	\N	\N	94247	94247	262059
10229	10245	2	applied	\N	\N	\N	\N	94248	94248	262060
10229	10246	3	applied	\N	\N	\N	\N	94249	94249	262061
10230	9329	0	applied	\N	\N	\N	\N	94250	94250	262062
10230	9330	1	applied	\N	\N	\N	\N	94251	94251	94251
10230	9992	2	applied	\N	\N	\N	\N	94252	94252	262063
10230	10109	3	applied	\N	\N	\N	\N	94253	94253	262064
10230	10020	5	applied	\N	\N	\N	\N	94255	94255	262066
10230	9226	6	applied	\N	\N	\N	\N	94256	94256	262067
10230	10066	7	applied	\N	\N	\N	\N	94257	94257	262068
10230	10067	8	applied	\N	\N	\N	\N	94258	94258	262069
10230	10082	9	applied	\N	\N	\N	\N	94259	94259	262070
10230	10192	10	applied	\N	\N	\N	\N	94260	94260	262071
10230	10114	11	applied	\N	\N	\N	\N	94261	94261	262072
10230	9980	12	applied	\N	\N	\N	\N	94262	94262	262073
10230	10115	13	applied	\N	\N	\N	\N	94263	94263	262074
10230	9576	14	applied	\N	\N	\N	\N	94264	94264	262075
10230	9591	16	applied	\N	\N	\N	\N	94265	94265	262076
10230	9592	17	applied	\N	\N	\N	\N	94266	94266	262077
10230	9593	18	applied	\N	\N	\N	\N	94267	94267	262078
10230	10083	19	applied	\N	\N	\N	\N	94268	94268	262079
10230	10013	20	applied	\N	\N	\N	\N	94269	94269	262080
10230	10014	21	applied	\N	\N	\N	\N	94270	94270	262081
10230	9148	23	applied	\N	\N	\N	\N	94272	94272	262083
10230	9157	24	applied	\N	\N	\N	\N	94273	94273	262084
10230	9158	25	applied	\N	\N	\N	\N	94274	94274	262085
10230	9159	26	applied	\N	\N	\N	\N	94275	94275	262086
10230	10015	27	applied	\N	\N	\N	\N	94276	94276	262087
10230	9402	28	applied	\N	\N	\N	\N	94277	94277	262088
10230	9403	29	applied	\N	\N	\N	\N	94278	94278	262089
10230	9404	30	applied	\N	\N	\N	\N	94279	94279	262090
10230	9405	31	applied	\N	\N	\N	\N	94280	94280	262091
10230	9416	32	applied	\N	\N	\N	\N	94281	94281	262092
10230	9639	33	applied	\N	\N	\N	\N	94282	94282	262093
10230	9473	34	applied	\N	\N	\N	\N	94283	94283	262094
10230	9174	35	applied	\N	\N	\N	\N	94284	94284	262095
10230	9276	36	applied	\N	\N	1000000000	\N	94285	94285	262096
10230	9293	37	applied	\N	\N	\N	\N	94286	94286	262097
10230	9294	38	applied	\N	\N	\N	\N	94287	94287	262098
10230	9029	39	applied	\N	\N	\N	\N	94288	94288	262099
10230	9189	40	applied	\N	\N	\N	\N	94289	94289	262100
10230	9108	42	applied	\N	\N	\N	\N	94291	94291	262102
10230	9331	43	applied	\N	\N	\N	\N	94292	94292	262103
10123	9983	36	applied	\N	\N	\N	\N	93638	93638	261451
10123	9996	37	applied	\N	\N	\N	\N	93639	93639	261452
10123	9971	82	applied	\N	\N	\N	\N	93684	93684	261497
10123	9973	83	applied	\N	\N	\N	\N	93685	93685	261498
10123	9974	84	applied	\N	\N	\N	\N	93686	93686	261499
10123	9975	85	applied	\N	\N	\N	\N	93687	93687	261500
10123	9976	86	applied	\N	\N	\N	\N	93688	93688	261501
10123	9977	87	applied	\N	\N	\N	\N	93689	93689	261502
10123	9978	88	applied	\N	\N	\N	\N	93690	93690	261503
10123	9979	89	applied	\N	\N	\N	\N	93691	93691	261504
10123	9981	90	applied	\N	\N	\N	\N	93692	93692	261505
10123	9985	92	applied	\N	\N	\N	\N	93694	93694	261507
10123	9986	93	applied	\N	\N	\N	\N	93695	93695	261508
10123	9987	94	applied	\N	\N	\N	\N	93696	93696	261509
10123	9988	95	applied	\N	\N	\N	\N	93697	93697	261510
10123	9989	96	applied	\N	\N	\N	\N	93698	93698	261511
10123	9990	97	applied	\N	\N	\N	\N	93699	93699	261512
10123	9991	98	applied	\N	\N	\N	\N	93700	93700	261513
10123	9998	99	applied	\N	\N	\N	\N	93701	93701	261514
10123	9999	100	applied	\N	\N	\N	\N	93702	93702	261515
10123	10000	101	applied	\N	\N	\N	\N	93703	93703	261516
10123	10001	102	applied	\N	\N	\N	\N	93704	93704	261517
10123	10002	103	applied	\N	\N	\N	\N	93705	93705	261518
10123	10003	104	applied	\N	\N	\N	\N	93706	93706	261519
10123	10004	105	applied	\N	\N	\N	\N	93707	93707	261520
10123	10005	106	applied	\N	\N	\N	\N	93708	93708	261521
10123	10006	107	applied	\N	\N	\N	\N	93709	93709	261522
10123	9878	109	applied	\N	\N	\N	\N	93711	93711	261524
10123	10063	110	applied	\N	\N	\N	\N	93712	93712	261525
10123	10064	111	applied	\N	\N	1000000000	\N	93713	93713	261526
10123	10065	112	applied	\N	\N	1000000000	\N	93714	93714	261527
10123	10069	113	applied	\N	\N	1000000000	\N	93715	93715	261528
10123	10070	115	applied	\N	\N	\N	\N	93716	93716	261529
10123	10078	116	applied	\N	\N	\N	\N	93717	93717	261530
10123	10080	117	applied	\N	\N	\N	\N	93718	93718	261531
10123	10081	118	applied	\N	\N	\N	\N	93719	93719	261532
10123	10089	119	applied	\N	\N	\N	\N	93720	93720	261533
10123	10090	120	applied	\N	\N	\N	\N	93721	93721	261534
10123	10091	121	applied	\N	\N	\N	\N	93722	93722	261535
10123	10093	122	applied	\N	\N	\N	\N	93723	93723	261536
10123	10098	123	applied	\N	\N	\N	\N	93724	93724	261537
10123	10046	124	applied	\N	\N	\N	\N	93725	93725	261538
10123	10047	125	applied	\N	\N	\N	\N	93726	93726	261539
10126	10097	1	applied	\N	\N	\N	\N	93732	93732	261545
10127	10099	0	applied	\N	\N	\N	\N	93733	93733	261546
10127	10100	1	applied	\N	\N	\N	\N	93734	93734	261547
10127	10101	2	applied	\N	\N	\N	\N	93735	93735	261548
10127	10102	3	applied	\N	\N	1000000000	\N	93736	93736	261549
10132	10105	0	applied	\N	\N	\N	\N	93745	93745	261558
10132	10108	1	applied	\N	\N	\N	\N	93746	93746	261559
10132	10106	2	applied	\N	\N	\N	\N	93747	93747	261560
10132	10107	3	applied	\N	\N	\N	\N	93748	93748	261561
10134	10109	0	applied	\N	\N	\N	\N	93752	93752	261565
10134	10110	1	applied	\N	\N	\N	\N	93753	93753	261566
10134	10111	2	applied	\N	\N	\N	\N	93754	93754	261567
10134	10107	3	applied	\N	\N	\N	\N	93755	93755	261568
10134	10112	4	applied	\N	\N	\N	\N	93756	93756	261569
10134	10113	5	applied	\N	\N	\N	\N	93757	93757	261570
10137	10020	3	applied	\N	\N	\N	\N	93765	93765	261578
10137	10067	5	applied	\N	\N	\N	\N	93767	93767	261580
10137	10082	6	applied	\N	\N	\N	\N	93768	93768	261581
10137	10114	7	applied	\N	\N	\N	\N	93769	93769	261582
10137	9980	8	applied	\N	\N	\N	\N	93770	93770	261583
10137	10115	9	applied	\N	\N	\N	\N	93771	93771	261584
10137	10083	10	applied	\N	\N	\N	\N	93772	93772	261585
10137	10013	11	applied	\N	\N	\N	\N	93773	93773	261586
10137	10014	12	applied	\N	\N	\N	\N	93774	93774	261587
10137	10015	13	applied	\N	\N	\N	\N	93775	93775	261588
10137	10068	14	applied	\N	\N	\N	\N	93776	93776	261589
10137	9767	15	applied	\N	\N	\N	\N	93777	93777	261590
10137	9880	16	applied	\N	\N	\N	\N	93778	93778	261591
10137	10039	17	applied	\N	\N	\N	\N	93779	93779	261592
10137	10025	18	applied	\N	\N	\N	\N	93780	93780	261593
10137	10032	19	applied	\N	\N	\N	\N	93781	93781	261594
10137	10041	20	applied	\N	\N	\N	\N	93782	93782	261595
10137	9843	23	applied	\N	\N	\N	\N	93784	93784	261597
10137	10071	24	applied	\N	\N	\N	\N	93785	93785	261598
10137	10072	25	applied	\N	\N	\N	\N	93786	93786	261599
10137	9923	26	applied	\N	\N	\N	\N	93787	93787	261600
10137	9924	27	applied	\N	\N	\N	\N	93788	93788	261601
10137	9925	28	applied	\N	\N	\N	\N	93789	93789	261602
10137	9926	29	applied	\N	\N	\N	\N	93790	93790	261603
10137	9831	30	applied	\N	\N	\N	\N	93791	93791	261604
10137	10042	31	applied	\N	\N	\N	\N	93792	93792	261605
10137	9832	32	applied	\N	\N	\N	\N	93793	93793	261606
10137	9768	33	applied	\N	\N	\N	\N	93794	93794	261607
10137	9769	34	applied	\N	\N	\N	\N	93795	93795	261608
10137	9864	35	applied	\N	\N	\N	\N	93796	93796	261609
10137	9846	36	applied	\N	\N	\N	\N	93797	93797	261610
10137	9847	37	applied	\N	\N	\N	\N	93798	93798	261611
10137	9772	38	applied	\N	\N	\N	\N	93799	93799	261612
10137	9849	40	applied	\N	\N	\N	\N	93801	93801	261614
10137	9850	41	applied	\N	\N	\N	\N	93802	93802	261615
10137	9851	42	applied	\N	\N	\N	\N	93803	93803	261616
10137	9852	43	applied	\N	\N	\N	\N	93804	93804	261617
10137	9853	44	applied	\N	\N	\N	\N	93805	93805	261618
10137	10094	45	applied	\N	\N	\N	\N	93806	93806	261619
10137	10099	46	applied	\N	\N	\N	\N	93807	93807	261620
10137	10106	47	applied	\N	\N	\N	\N	93808	93808	261621
10140	9329	0	applied	\N	\N	\N	\N	93897	93897	261710
10140	9330	1	applied	\N	\N	\N	\N	93898	93898	93898
10140	9110	2	applied	\N	\N	\N	\N	93899	93899	261711
10140	9148	3	applied	\N	\N	\N	\N	93900	93900	261712
10140	9157	4	applied	\N	\N	\N	\N	93901	93901	261713
10140	9158	5	applied	\N	\N	\N	\N	93902	93902	261714
10140	9159	6	applied	\N	\N	\N	\N	93903	93903	261715
10140	9226	7	applied	\N	\N	\N	\N	93904	93904	261716
10140	9591	9	applied	\N	\N	\N	\N	93906	93906	261718
10140	9592	10	applied	\N	\N	\N	\N	93907	93907	261719
10140	9593	11	applied	\N	\N	\N	\N	93908	93908	261720
10140	9402	12	applied	\N	\N	\N	\N	93909	93909	261721
10123	9966	80	applied	\N	\N	\N	\N	93682	93682	261495
10123	9970	81	applied	\N	\N	\N	\N	93683	93683	261496
10137	9930	51	applied	\N	\N	\N	\N	93812	93812	261625
10137	9931	52	applied	\N	\N	\N	\N	93813	93813	261626
10137	9932	53	applied	\N	\N	\N	\N	93814	93814	261627
10137	9933	54	applied	\N	\N	\N	\N	93815	93815	261628
10137	9934	55	applied	\N	\N	\N	\N	93816	93816	261629
10137	9935	56	applied	\N	\N	\N	\N	93817	93817	261630
10137	9936	57	applied	\N	\N	\N	\N	93818	93818	261631
10137	9937	58	applied	\N	\N	\N	\N	93819	93819	261632
10137	9938	59	applied	\N	\N	\N	\N	93820	93820	261633
10137	9939	60	applied	\N	\N	\N	\N	93821	93821	261634
10137	9940	61	applied	\N	\N	\N	\N	93822	93822	261635
10137	9947	63	applied	\N	\N	\N	\N	93824	93824	261637
10137	9948	64	applied	\N	\N	\N	\N	93825	93825	261638
10137	9949	65	applied	\N	\N	\N	\N	93826	93826	261639
10137	9950	66	applied	\N	\N	\N	\N	93827	93827	261640
10137	9951	67	applied	\N	\N	\N	\N	93828	93828	261641
10137	9952	68	applied	\N	\N	\N	\N	93829	93829	261642
10137	9953	69	applied	\N	\N	\N	\N	93830	93830	261643
10137	9954	70	applied	\N	\N	\N	\N	93831	93831	261644
10137	9955	71	applied	\N	\N	\N	\N	93832	93832	261645
10137	9956	72	applied	\N	\N	\N	\N	93833	93833	261646
10137	9957	73	applied	\N	\N	\N	\N	93834	93834	261647
10137	9958	74	applied	\N	\N	\N	\N	93835	93835	261648
10137	9959	75	applied	\N	\N	\N	\N	93836	93836	261649
10137	10054	76	applied	\N	\N	\N	\N	93837	93837	261650
10137	10055	77	applied	\N	\N	\N	\N	93838	93838	261651
10137	10056	78	applied	\N	\N	\N	\N	93839	93839	261652
10137	10062	80	applied	\N	\N	1000000000	\N	93841	93841	261654
10137	9889	81	applied	\N	\N	\N	\N	93842	93842	261655
10137	9890	82	applied	\N	\N	\N	\N	93843	93843	261656
10137	9891	83	applied	\N	\N	\N	\N	93844	93844	261657
10137	10095	84	applied	\N	\N	\N	\N	93845	93845	261658
10137	10096	85	applied	\N	\N	\N	\N	93846	93846	261659
10137	9904	86	applied	\N	\N	\N	\N	93847	93847	261660
10137	10023	87	applied	\N	\N	\N	\N	93848	93848	261661
10137	10027	88	applied	\N	\N	\N	\N	93849	93849	261662
10137	9875	89	applied	\N	\N	\N	\N	93850	93850	261663
10137	9876	90	applied	\N	\N	\N	\N	93851	93851	261664
10137	9877	91	applied	\N	\N	\N	\N	93852	93852	261665
10137	9310	92	applied	\N	\N	\N	\N	93853	93853	261666
10137	9311	93	applied	\N	\N	\N	\N	93854	93854	261667
10137	9312	94	applied	\N	\N	\N	\N	93855	93855	261668
10137	9857	96	applied	\N	\N	\N	\N	93857	93857	261670
10137	9881	97	applied	\N	\N	\N	\N	93858	93858	261671
10137	9338	98	applied	\N	\N	\N	\N	93859	93859	261672
10137	9206	99	applied	\N	\N	\N	\N	93860	93860	261673
10137	9207	100	applied	\N	\N	\N	\N	93861	93861	261674
10137	9209	101	applied	\N	\N	\N	\N	93862	93862	261675
10137	9825	102	applied	\N	\N	\N	\N	93863	93863	261676
10137	9963	103	applied	\N	\N	\N	\N	93864	93864	261677
10137	9964	104	applied	\N	\N	\N	\N	93865	93865	261678
10137	9965	105	applied	\N	\N	\N	\N	93866	93866	261679
10137	9966	106	applied	\N	\N	\N	\N	93867	93867	261680
10137	9970	107	applied	\N	\N	\N	\N	93868	93868	261681
10137	9971	108	applied	\N	\N	\N	\N	93869	93869	261682
10137	9973	109	applied	\N	\N	\N	\N	93870	93870	261683
10137	9974	110	applied	\N	\N	\N	\N	93871	93871	261684
10137	9975	111	applied	\N	\N	\N	\N	93872	93872	261685
10137	9976	112	applied	\N	\N	\N	\N	93873	93873	261686
10137	9977	113	applied	\N	\N	\N	\N	93874	93874	261687
10137	9978	114	applied	\N	\N	\N	\N	93875	93875	261688
10137	9981	116	applied	\N	\N	\N	\N	93877	93877	261690
10137	9984	117	applied	\N	\N	\N	\N	93878	93878	261691
10137	9985	118	applied	\N	\N	\N	\N	93879	93879	261692
10137	9986	119	applied	\N	\N	\N	\N	93880	93880	261693
10137	9987	120	applied	\N	\N	\N	\N	93881	93881	261694
10137	9988	121	applied	\N	\N	\N	\N	93882	93882	261695
10137	9989	122	applied	\N	\N	\N	\N	93883	93883	261696
10137	9990	123	applied	\N	\N	\N	\N	93884	93884	261697
10137	9991	124	applied	\N	\N	\N	\N	93885	93885	261698
10137	9998	125	applied	\N	\N	\N	\N	93886	93886	261699
10146	10127	0	applied	\N	\N	\N	\N	93931	93931	261743
10146	10128	1	applied	\N	\N	\N	\N	93932	93932	261744
10147	10129	0	applied	\N	\N	\N	\N	93933	93933	261745
10147	10130	1	applied	\N	\N	\N	\N	93934	93934	261746
10151	10131	0	applied	\N	\N	\N	\N	93941	93941	261753
10151	10132	1	applied	\N	\N	\N	\N	93942	93942	261754
10152	10132	1	applied	\N	\N	\N	\N	93944	93944	261756
10157	10139	0	applied	\N	\N	\N	\N	93957	93957	261769
10157	10140	1	applied	\N	\N	\N	\N	93958	93958	261770
10164	10143	0	applied	\N	\N	\N	\N	93981	93981	261793
10164	10144	1	applied	\N	\N	\N	\N	93982	93982	261794
10164	10145	2	applied	\N	\N	\N	\N	93983	93983	261795
10164	10146	3	applied	\N	\N	\N	\N	93984	93984	261796
10164	10147	4	applied	\N	\N	\N	\N	93985	93985	261797
10164	10148	5	applied	\N	\N	\N	\N	93986	93986	261798
10164	10149	6	applied	\N	\N	\N	\N	93987	93987	261799
10164	10150	7	applied	\N	\N	\N	\N	93988	93988	261800
10164	10151	8	applied	\N	\N	\N	\N	93989	93989	261801
10164	10152	9	applied	\N	\N	\N	\N	93990	93990	261802
10164	10153	10	applied	\N	\N	\N	\N	93991	93991	261803
10164	10154	11	applied	\N	\N	\N	\N	93992	93992	261804
10165	10155	0	applied	\N	\N	\N	\N	93993	93993	261805
10169	10157	0	applied	\N	\N	\N	\N	94001	94001	261813
10169	10158	1	applied	\N	\N	\N	\N	94002	94002	261814
10175	10179	0	applied	\N	\N	\N	\N	94027	94027	261839
10175	10180	1	applied	\N	\N	\N	\N	94028	94028	261840
10181	10181	0	applied	\N	\N	\N	\N	94043	94043	261855
10181	10182	1	applied	\N	\N	\N	\N	94044	94044	261856
10181	10183	2	applied	\N	\N	\N	\N	94045	94045	261857
10181	10184	3	applied	\N	\N	\N	\N	94046	94046	261858
10185	10185	0	applied	\N	\N	\N	\N	94058	94058	261870
10185	10186	1	applied	\N	\N	\N	\N	94059	94059	261871
10190	10187	0	applied	\N	\N	\N	\N	94074	94074	261886
10190	10188	1	applied	\N	\N	\N	\N	94075	94075	261887
10190	10189	2	applied	\N	\N	1000000000	\N	94076	94076	261888
10190	10190	3	applied	\N	\N	\N	\N	94077	94077	261889
10190	10191	4	applied	\N	\N	\N	\N	94078	94078	261890
10191	10192	0	applied	\N	\N	\N	\N	94079	94079	261891
10137	9928	49	applied	\N	\N	\N	\N	93810	93810	261623
10137	9929	50	applied	\N	\N	\N	\N	93811	93811	261624
10140	9416	16	applied	\N	\N	\N	\N	93913	93913	261725
10140	9106	17	applied	\N	\N	\N	\N	93914	93914	261726
10140	9639	18	applied	\N	\N	\N	\N	93915	93915	261727
10140	9473	19	applied	\N	\N	\N	\N	93916	93916	261728
10140	9174	20	applied	\N	\N	\N	\N	93917	93917	261729
10145	10127	0	applied	\N	\N	\N	\N	93929	93929	261741
10145	10128	1	applied	\N	\N	\N	\N	93930	93930	261742
10150	10129	0	applied	\N	\N	\N	\N	93939	93939	261751
10150	10130	1	applied	\N	\N	\N	\N	93940	93940	261752
10156	10136	1	applied	\N	\N	\N	\N	93954	93954	261766
10156	10137	2	applied	\N	\N	\N	\N	93955	93955	261767
10156	10138	3	applied	\N	\N	\N	\N	93956	93956	261768
10160	10139	0	applied	\N	\N	\N	\N	93963	93963	261775
10160	10140	1	applied	\N	\N	\N	\N	93964	93964	261776
10161	10141	0	applied	\N	\N	\N	\N	93965	93965	261777
10161	10142	1	applied	\N	\N	\N	\N	93966	93966	261778
10166	10157	0	applied	\N	\N	\N	\N	93995	93995	261807
10166	10158	1	applied	\N	\N	\N	\N	93996	93996	261808
10170	10157	0	applied	\N	\N	\N	\N	94003	94003	261815
10170	10158	1	applied	\N	\N	\N	\N	94004	94004	261816
10171	10159	0	applied	\N	\N	\N	\N	94005	94005	261817
10171	10160	1	applied	\N	\N	\N	\N	94006	94006	261818
10176	10179	0	applied	\N	\N	\N	\N	94029	94029	261841
10176	10180	1	applied	\N	\N	\N	\N	94030	94030	261842
10182	10181	0	applied	\N	\N	\N	\N	94047	94047	261859
10182	10183	2	applied	\N	\N	\N	\N	94049	94049	261861
10182	10184	3	applied	\N	\N	\N	\N	94050	94050	261862
10186	10185	0	applied	\N	\N	\N	\N	94060	94060	261872
10186	10186	1	applied	\N	\N	\N	\N	94061	94061	261873
10191	10194	2	applied	\N	\N	\N	\N	94081	94081	261893
10191	10195	3	applied	\N	\N	\N	\N	94082	94082	261894
10191	10196	4	applied	\N	\N	\N	\N	94083	94083	261895
10191	10197	5	applied	\N	\N	\N	\N	94084	94084	261896
10191	10198	6	applied	\N	\N	\N	\N	94085	94085	261897
10192	10192	0	applied	\N	\N	\N	\N	94086	94086	261898
10192	10193	1	applied	\N	\N	\N	\N	94087	94087	261899
10192	10194	2	applied	\N	\N	\N	\N	94088	94088	261900
10192	10195	3	applied	\N	\N	\N	\N	94089	94089	261901
10192	10196	4	applied	\N	\N	\N	\N	94090	94090	261902
10192	10197	5	applied	\N	\N	\N	\N	94091	94091	261903
10192	10198	6	applied	\N	\N	\N	\N	94092	94092	261904
10193	10200	1	applied	\N	\N	\N	\N	94094	94094	261906
10193	10201	2	applied	\N	\N	\N	\N	94095	94095	261907
10193	10202	3	applied	\N	\N	\N	\N	94096	94096	261908
10197	10203	0	applied	\N	\N	\N	\N	94107	94107	261919
10197	10204	1	applied	\N	\N	\N	\N	94108	94108	261920
10198	10203	0	applied	\N	\N	\N	\N	94109	94109	261921
10198	10204	1	applied	\N	\N	\N	\N	94110	94110	261922
10202	10209	0	applied	\N	\N	\N	\N	94117	94117	261929
10202	10210	1	applied	\N	\N	\N	\N	94118	94118	261930
10203	10211	0	applied	\N	\N	\N	\N	94119	94119	261931
10203	10212	1	applied	\N	\N	\N	\N	94120	94120	261932
10204	10211	0	applied	\N	\N	\N	\N	94121	94121	261933
10204	10212	1	applied	\N	\N	\N	\N	94122	94122	261934
10208	10215	0	applied	\N	\N	\N	\N	94129	94129	261941
10208	10216	1	applied	\N	\N	\N	\N	94130	94130	261942
10209	10217	0	applied	\N	\N	\N	\N	94131	94131	261943
10209	10219	2	applied	\N	\N	\N	\N	94133	94133	261945
10214	10220	0	applied	\N	\N	\N	\N	94149	94149	261961
10214	10221	1	applied	\N	\N	\N	\N	94150	94150	261962
10214	10222	2	applied	\N	\N	\N	\N	94151	94151	261963
10214	10223	3	applied	\N	\N	\N	\N	94152	94152	261964
10214	10224	4	applied	\N	\N	\N	\N	94153	94153	261965
10214	10225	5	applied	\N	\N	\N	\N	94154	94154	261966
10215	10226	0	applied	\N	\N	\N	\N	94155	94155	261967
10215	10227	1	applied	\N	\N	\N	\N	94156	94156	261968
10220	10232	0	applied	\N	\N	\N	\N	94165	94165	261977
10220	10233	1	applied	\N	\N	\N	\N	94166	94166	261978
10221	10232	0	applied	\N	\N	\N	\N	94167	94167	261979
10221	10233	1	applied	\N	\N	\N	\N	94168	94168	261980
10226	10242	0	applied	\N	\N	\N	\N	94243	94243	262055
10227	10242	0	applied	\N	\N	\N	\N	94244	94244	262056
10233	10254	1	applied	\N	\N	\N	\N	94335	94335	262146
10233	10255	2	applied	\N	\N	\N	\N	94336	94336	262147
10234	10253	0	applied	\N	\N	1000000000	\N	94337	94337	262148
10234	10254	1	applied	\N	\N	\N	\N	94338	94338	262149
10234	10255	2	applied	\N	\N	\N	\N	94339	94339	262150
10238	10253	0	applied	\N	\N	1000000000	\N	94345	94345	262156
10238	10243	1	applied	\N	\N	\N	\N	94346	94346	262157
10238	10244	2	applied	\N	\N	\N	\N	94347	94347	262158
10238	10247	3	applied	\N	\N	\N	\N	94348	94348	262159
10238	10248	4	applied	\N	\N	\N	\N	94349	94349	262160
10238	10249	5	applied	\N	\N	\N	\N	94350	94350	262161
10238	10254	6	applied	\N	\N	\N	\N	94351	94351	262162
10238	10256	7	applied	\N	\N	\N	\N	94352	94352	262163
10238	10245	8	applied	\N	\N	\N	\N	94353	94353	262164
10238	10246	9	applied	\N	\N	\N	\N	94354	94354	262165
10238	10250	10	applied	\N	\N	\N	\N	94355	94355	262166
10238	10251	11	applied	\N	\N	\N	\N	94356	94356	262167
10238	10252	12	applied	\N	\N	\N	\N	94357	94357	262168
10238	10255	13	applied	\N	\N	\N	\N	94358	94358	262169
10239	10259	1	applied	\N	\N	\N	\N	94360	94360	262171
10245	10260	0	applied	\N	\N	\N	\N	94367	94367	262178
10245	10261	1	applied	\N	\N	\N	\N	94368	94368	262179
10245	10262	2	applied	\N	\N	\N	\N	94369	94369	262180
10245	10263	3	applied	\N	\N	\N	\N	94370	94370	262181
10253	10281	0	applied	\N	\N	\N	\N	94416	94416	262227
10258	10303	0	applied	\N	\N	1000000000	\N	94440	94440	262251
10258	10304	1	applied	\N	\N	\N	\N	94441	94441	262252
10258	10305	2	applied	\N	\N	\N	\N	94442	94442	262253
10258	10306	3	applied	\N	\N	\N	\N	94443	94443	262254
10258	10307	4	applied	\N	\N	\N	\N	94444	94444	262255
10263	10308	0	applied	\N	\N	\N	\N	94463	94463	262274
10263	10309	1	applied	\N	\N	\N	\N	94464	94464	262275
10263	10310	2	applied	\N	\N	\N	\N	94465	94465	262276
10263	10311	3	applied	\N	\N	\N	\N	94466	94466	262277
10269	10324	0	applied	\N	\N	\N	\N	94489	94489	262300
10270	10326	0	applied	\N	\N	\N	\N	94491	94491	262302
10270	10327	1	applied	\N	\N	\N	\N	94492	94492	262303
10140	9404	14	applied	\N	\N	\N	\N	93911	93911	261723
10140	9405	15	applied	\N	\N	\N	\N	93912	93912	261724
10179	10184	3	applied	\N	\N	\N	\N	94038	94038	261850
10180	10181	0	applied	\N	\N	\N	\N	94039	94039	261851
10180	10182	1	applied	\N	\N	\N	\N	94040	94040	261852
10180	10183	2	applied	\N	\N	\N	\N	94041	94041	261853
10180	10184	3	applied	\N	\N	\N	\N	94042	94042	261854
10184	10181	0	applied	\N	\N	\N	\N	94055	94055	261867
10184	10182	1	applied	\N	\N	\N	\N	94056	94056	261868
10184	10183	2	applied	\N	\N	\N	\N	94057	94057	261869
10189	10187	0	applied	\N	\N	\N	\N	94069	94069	261881
10189	10188	1	applied	\N	\N	\N	\N	94070	94070	261882
10189	10190	3	applied	\N	\N	\N	\N	94072	94072	261884
10189	10191	4	applied	\N	\N	\N	\N	94073	94073	261885
10195	10199	0	applied	\N	\N	\N	\N	94101	94101	261913
10195	10200	1	applied	\N	\N	\N	\N	94102	94102	261914
10195	10201	2	applied	\N	\N	\N	\N	94103	94103	261915
10195	10202	3	applied	\N	\N	\N	\N	94104	94104	261916
10196	10203	0	applied	\N	\N	\N	\N	94105	94105	261917
10196	10204	1	applied	\N	\N	\N	\N	94106	94106	261918
10201	10209	0	applied	\N	\N	\N	\N	94115	94115	261927
10201	10210	1	applied	\N	\N	\N	\N	94116	94116	261928
10206	10213	0	applied	\N	\N	\N	\N	94125	94125	261937
10206	10214	1	applied	\N	\N	\N	\N	94126	94126	261938
10207	10215	0	applied	\N	\N	\N	\N	94127	94127	261939
10207	10216	1	applied	\N	\N	\N	\N	94128	94128	261940
10213	10220	0	applied	\N	\N	\N	\N	94143	94143	261955
10213	10221	1	applied	\N	\N	\N	\N	94144	94144	261956
10213	10222	2	applied	\N	\N	\N	\N	94145	94145	261957
10213	10223	3	applied	\N	\N	\N	\N	94146	94146	261958
10213	10224	4	applied	\N	\N	\N	\N	94147	94147	261959
10213	10225	5	applied	\N	\N	\N	\N	94148	94148	261960
10218	10229	1	applied	\N	\N	\N	\N	94160	94160	261972
10218	10230	2	applied	\N	\N	\N	\N	94161	94161	261973
10218	10231	3	applied	\N	\N	\N	\N	94162	94162	261974
10219	10232	0	applied	\N	\N	\N	\N	94163	94163	261975
10219	10233	1	applied	\N	\N	\N	\N	94164	94164	261976
10223	10192	0	applied	\N	\N	\N	\N	94169	94169	261981
10223	10143	1	applied	\N	\N	\N	\N	94170	94170	261982
10223	10146	2	applied	\N	\N	\N	\N	94171	94171	261983
10223	10147	3	applied	\N	\N	\N	\N	94172	94172	261984
10223	10148	4	applied	\N	\N	\N	\N	94173	94173	261985
10223	10149	5	applied	\N	\N	\N	\N	94174	94174	261986
10223	10150	6	applied	\N	\N	\N	\N	94175	94175	261987
10223	10151	7	applied	\N	\N	\N	\N	94176	94176	261988
10223	9999	8	applied	\N	\N	\N	\N	94177	94177	261989
10223	10000	9	applied	\N	\N	\N	\N	94178	94178	261990
10223	10152	10	applied	\N	\N	\N	\N	94179	94179	261991
10223	10154	12	applied	\N	\N	\N	\N	94181	94181	261993
10223	10001	13	applied	\N	\N	\N	\N	94182	94182	261994
10223	10002	14	applied	\N	\N	\N	\N	94183	94183	261995
10223	10003	15	applied	\N	\N	\N	\N	94184	94184	261996
10223	10004	16	applied	\N	\N	\N	\N	94185	94185	261997
10223	10005	17	applied	\N	\N	\N	\N	94186	94186	261998
10223	9213	18	applied	\N	\N	\N	\N	94187	94187	261999
10223	9218	19	applied	\N	\N	\N	\N	94188	94188	262000
10223	9220	20	applied	\N	\N	\N	\N	94189	94189	262001
10223	9222	21	applied	\N	\N	\N	\N	94190	94190	262002
10223	9224	23	applied	\N	\N	\N	\N	94191	94191	262003
10223	9228	24	applied	\N	\N	\N	\N	94192	94192	262004
10223	9230	25	applied	\N	\N	\N	\N	94193	94193	262005
10223	9233	26	applied	\N	\N	\N	\N	94194	94194	262006
10223	9235	27	applied	\N	\N	\N	\N	94195	94195	262007
10223	9241	28	applied	\N	\N	\N	\N	94196	94196	262008
10223	9245	30	applied	\N	\N	\N	\N	94198	94198	262010
10223	9249	31	applied	\N	\N	\N	\N	94199	94199	262011
10223	9250	32	applied	\N	\N	\N	\N	94200	94200	262012
10223	9251	33	applied	\N	\N	\N	\N	94201	94201	262013
10223	9258	34	applied	\N	\N	\N	\N	94202	94202	262014
10223	9261	35	applied	\N	\N	\N	\N	94203	94203	262015
10223	9263	36	applied	\N	\N	\N	\N	94204	94204	262016
10223	9265	37	applied	\N	\N	\N	\N	94205	94205	262017
10223	9267	38	applied	\N	\N	\N	\N	94206	94206	262018
10223	9272	39	applied	\N	\N	\N	\N	94207	94207	262019
10223	9277	40	applied	\N	\N	\N	\N	94208	94208	262020
10223	9279	41	applied	\N	\N	\N	\N	94209	94209	262021
10223	9282	42	applied	\N	\N	\N	\N	94210	94210	262022
10253	10282	1	applied	\N	\N	\N	\N	94417	94417	262228
10253	10283	2	applied	\N	\N	\N	\N	94418	94418	262229
10253	10284	3	applied	\N	\N	\N	\N	94419	94419	262230
10253	10286	5	applied	\N	\N	\N	\N	94421	94421	262232
10253	10287	6	applied	\N	\N	\N	\N	94422	94422	262233
10253	10288	7	applied	\N	\N	\N	\N	94423	94423	262234
10253	10289	8	applied	\N	\N	\N	\N	94424	94424	262235
10253	10290	9	applied	\N	\N	\N	\N	94425	94425	262236
10253	10291	10	applied	\N	\N	\N	\N	94426	94426	262237
10253	10292	11	applied	\N	\N	\N	\N	94427	94427	262238
10253	10293	12	applied	\N	\N	\N	\N	94428	94428	262239
10253	10294	13	applied	\N	\N	\N	\N	94429	94429	262240
10253	10295	14	applied	\N	\N	\N	\N	94430	94430	262241
10253	10296	15	applied	\N	\N	\N	\N	94431	94431	262242
10253	10297	16	applied	\N	\N	\N	\N	94432	94432	262243
10253	10298	17	applied	\N	\N	\N	\N	94433	94433	262244
10259	10303	0	applied	\N	\N	1000000000	\N	94445	94445	262256
10259	10304	1	applied	\N	\N	\N	\N	94446	94446	262257
10259	10305	2	applied	\N	\N	\N	\N	94447	94447	262258
10259	10307	4	applied	\N	\N	\N	\N	94449	94449	262260
10264	10312	0	applied	\N	\N	\N	\N	94467	94467	262278
10264	10313	1	applied	\N	\N	\N	\N	94468	94468	262279
10265	10314	0	applied	\N	\N	\N	\N	94469	94469	262280
10265	10315	1	applied	\N	\N	\N	\N	94470	94470	262281
10265	10316	2	applied	\N	\N	\N	\N	94471	94471	262282
10265	10317	3	applied	\N	\N	\N	\N	94472	94472	262283
10265	10318	4	applied	\N	\N	\N	\N	94473	94473	262284
10265	10319	5	applied	\N	\N	\N	\N	94474	94474	262285
10265	10320	6	applied	\N	\N	\N	\N	94475	94475	262286
10265	10321	7	applied	\N	\N	\N	\N	94476	94476	262287
10271	10328	0	applied	\N	\N	\N	\N	94493	94493	262304
10271	10329	1	applied	\N	\N	\N	\N	94494	94494	262305
10272	10330	0	applied	\N	\N	\N	\N	94495	94495	262306
10272	10331	1	applied	\N	\N	\N	\N	94496	94496	262307
10179	10181	0	applied	\N	\N	\N	\N	94035	94035	261847
10179	10183	2	applied	\N	\N	\N	\N	94037	94037	261849
10223	9289	46	applied	\N	\N	\N	\N	94214	94214	262026
10223	9296	47	applied	\N	\N	\N	\N	94215	94215	262027
10223	9300	48	applied	\N	\N	\N	\N	94216	94216	262028
10223	9313	49	applied	\N	\N	\N	\N	94217	94217	262029
10223	9314	50	applied	\N	\N	\N	\N	94218	94218	262030
10223	9315	51	applied	\N	\N	\N	\N	94219	94219	262031
10223	9318	52	applied	\N	\N	\N	\N	94220	94220	262032
10223	9320	53	applied	\N	\N	\N	\N	94221	94221	262033
10223	9323	54	applied	\N	\N	\N	\N	94222	94222	262034
10223	9326	56	applied	\N	\N	\N	\N	94224	94224	262036
10223	9334	57	applied	\N	\N	\N	\N	94225	94225	262037
10223	9335	58	applied	\N	\N	\N	\N	94226	94226	262038
10223	9341	59	applied	\N	\N	\N	\N	94227	94227	262039
10223	9342	60	applied	\N	\N	\N	\N	94228	94228	262040
10224	10234	0	applied	\N	\N	\N	\N	94229	94229	262041
10224	10235	1	applied	\N	\N	\N	\N	94230	94230	262042
10224	10236	2	applied	\N	\N	\N	\N	94231	94231	262043
10224	10237	3	applied	\N	\N	\N	\N	94232	94232	262044
10224	10238	4	applied	\N	\N	\N	\N	94233	94233	262045
10224	10239	5	applied	\N	\N	\N	\N	94234	94234	262046
10225	10234	0	applied	\N	\N	\N	\N	94235	94235	262047
10225	10235	1	applied	\N	\N	\N	\N	94236	94236	262048
10225	10236	2	applied	\N	\N	\N	\N	94237	94237	262049
10225	10240	3	applied	\N	\N	\N	\N	94238	94238	262050
10225	10237	4	applied	\N	\N	\N	\N	94239	94239	262051
10225	10239	6	applied	\N	\N	\N	\N	94241	94241	262053
10225	10241	7	applied	\N	\N	\N	\N	94242	94242	262054
10230	9332	44	applied	\N	\N	\N	\N	94293	94293	262104
10230	9234	45	applied	\N	\N	\N	\N	94294	94294	262105
10230	9607	46	applied	\N	\N	\N	\N	94295	94295	262106
10230	9479	47	applied	\N	\N	\N	\N	94296	94296	262107
10230	9237	48	applied	\N	\N	\N	\N	94297	94297	262108
10230	9191	49	applied	\N	\N	\N	\N	94298	94298	262109
10230	9192	50	applied	\N	\N	\N	\N	94299	94299	262110
10230	9193	51	applied	\N	\N	\N	\N	94300	94300	262111
10230	9030	52	applied	\N	\N	\N	\N	94301	94301	262112
10230	9031	53	applied	\N	\N	\N	\N	94302	94302	262113
10230	10068	54	applied	\N	\N	\N	\N	94303	94303	262114
10230	9076	55	applied	\N	\N	\N	\N	94304	94304	262115
10230	9079	56	applied	\N	\N	\N	\N	94305	94305	262116
10230	9360	57	applied	\N	\N	\N	\N	94306	94306	262117
10230	9767	59	applied	\N	\N	\N	\N	94308	94308	262119
10230	9669	60	applied	\N	\N	\N	\N	94309	94309	262120
10230	9131	61	applied	\N	\N	\N	\N	94310	94310	262121
10230	9133	62	applied	\N	\N	\N	\N	94311	94311	262122
10230	9880	63	applied	\N	\N	\N	\N	94312	94312	262123
10230	9145	64	applied	\N	\N	\N	\N	94313	94313	262124
10230	9089	65	applied	\N	\N	1000000000	\N	94314	94314	262125
10230	9092	66	applied	\N	\N	\N	\N	94315	94315	262126
10230	9655	67	applied	\N	\N	\N	\N	94316	94316	262127
10230	9135	68	applied	\N	\N	\N	\N	94317	94317	262128
10230	9033	69	applied	\N	\N	\N	\N	94318	94318	262129
10230	9036	70	applied	\N	\N	\N	\N	94319	94319	262130
10230	9040	71	applied	\N	\N	\N	\N	94320	94320	262131
10230	10025	72	applied	\N	\N	\N	\N	94321	94321	262132
10230	10032	73	applied	\N	\N	\N	\N	94322	94322	262133
10230	10041	74	applied	\N	\N	\N	\N	94323	94323	262134
10231	10247	0	applied	\N	\N	\N	\N	94325	94325	262136
10231	10248	1	applied	\N	\N	\N	\N	94326	94326	262137
10231	10249	2	applied	\N	\N	\N	\N	94327	94327	262138
10231	10250	3	applied	\N	\N	\N	\N	94328	94328	262139
10231	10251	4	applied	\N	\N	\N	\N	94329	94329	262140
10231	10252	5	applied	\N	\N	\N	\N	94330	94330	262141
10232	10253	0	applied	\N	\N	1000000000	\N	94331	94331	262142
10232	10254	1	applied	\N	\N	\N	\N	94332	94332	262143
10232	10255	2	applied	\N	\N	\N	\N	94333	94333	262144
10235	10253	0	applied	\N	\N	1000000000	\N	94340	94340	262151
10235	10254	1	applied	\N	\N	\N	\N	94341	94341	262152
10235	10255	2	applied	\N	\N	\N	\N	94342	94342	262153
10237	10256	0	applied	\N	\N	\N	\N	94343	94343	262154
10237	10257	1	applied	\N	\N	\N	\N	94344	94344	262155
10240	10258	0	applied	\N	\N	\N	\N	94361	94361	262172
10240	10259	1	applied	\N	\N	\N	\N	94362	94362	262173
10242	10261	1	applied	\N	\N	\N	\N	94364	94364	262175
10242	10262	2	applied	\N	\N	\N	\N	94365	94365	262176
10242	10263	3	applied	\N	\N	\N	\N	94366	94366	262177
10247	10264	0	applied	\N	\N	\N	\N	94371	94371	262182
10254	10299	0	applied	\N	\N	\N	\N	94434	94434	262245
10254	10300	1	applied	\N	\N	\N	\N	94435	94435	262246
10260	10303	0	applied	\N	\N	1000000000	\N	94450	94450	262261
10260	10304	1	applied	\N	\N	\N	\N	94451	94451	262262
10260	10305	2	applied	\N	\N	\N	\N	94452	94452	262263
10260	10306	3	applied	\N	\N	\N	\N	94453	94453	262264
10260	10307	4	applied	\N	\N	\N	\N	94454	94454	262265
10261	10308	0	applied	\N	\N	\N	\N	94455	94455	262266
10261	10309	1	applied	\N	\N	\N	\N	94456	94456	262267
10261	10310	2	applied	\N	\N	\N	\N	94457	94457	262268
10261	10311	3	applied	\N	\N	\N	\N	94458	94458	262269
10266	10314	0	applied	\N	\N	\N	\N	94477	94477	262288
10266	10316	2	applied	\N	\N	\N	\N	94479	94479	262290
10266	10317	3	applied	\N	\N	\N	\N	94480	94480	262291
10266	10318	4	applied	\N	\N	\N	\N	94481	94481	262292
10266	10319	5	applied	\N	\N	\N	\N	94482	94482	262293
10266	10320	6	applied	\N	\N	\N	\N	94483	94483	262294
10266	10321	7	applied	\N	\N	\N	\N	94484	94484	262295
10267	10322	0	applied	\N	\N	\N	\N	94485	94485	262296
10267	10323	1	applied	\N	\N	\N	\N	94486	94486	262297
10273	10332	0	applied	\N	\N	\N	\N	94497	94497	262308
10273	10333	1	applied	\N	\N	\N	\N	94498	94498	262309
10274	10334	0	applied	\N	\N	\N	\N	94499	94499	262310
10274	10335	1	applied	\N	\N	\N	\N	94500	94500	262311
10274	10336	2	applied	\N	\N	\N	\N	94501	94501	262312
10275	10337	0	applied	\N	\N	\N	\N	94502	94502	262313
10275	10338	1	applied	\N	\N	\N	\N	94503	94503	262314
10275	10339	2	applied	\N	\N	\N	\N	94504	94504	262315
10275	10341	4	applied	\N	\N	\N	\N	94506	94506	262317
10275	10342	5	applied	\N	\N	\N	\N	94507	94507	262318
10275	10343	6	applied	\N	\N	\N	\N	94508	94508	262319
10275	10344	7	applied	\N	\N	\N	\N	94509	94509	262320
10223	9286	44	applied	\N	\N	\N	\N	94212	94212	262024
10223	9288	45	applied	\N	\N	\N	\N	94213	94213	262025
10248	10268	2	applied	\N	\N	\N	\N	94375	94375	262186
10248	10269	3	applied	\N	\N	\N	\N	94376	94376	262187
10248	10270	4	applied	\N	\N	\N	\N	94377	94377	262188
10248	10271	5	applied	\N	\N	\N	\N	94378	94378	262189
10249	10272	0	applied	\N	\N	\N	\N	94379	94379	262190
10249	10273	1	applied	\N	\N	\N	\N	94380	94380	262191
10250	10253	0	applied	\N	\N	1000000000	\N	94381	94381	262192
10250	9992	1	applied	\N	\N	\N	\N	94382	94382	262193
10250	10109	2	applied	\N	\N	\N	\N	94383	94383	262194
10250	9993	3	applied	\N	\N	\N	\N	94384	94384	262195
10250	10020	4	applied	\N	\N	\N	\N	94385	94385	262196
10250	10067	6	applied	\N	\N	\N	\N	94387	94387	262198
10250	10082	7	applied	\N	\N	\N	\N	94388	94388	262199
10250	10192	8	applied	\N	\N	\N	\N	94389	94389	262200
10250	10114	9	applied	\N	\N	\N	\N	94390	94390	262201
10250	9980	10	applied	\N	\N	\N	\N	94391	94391	262202
10250	10115	11	applied	\N	\N	\N	\N	94392	94392	262203
10250	10083	12	applied	\N	\N	\N	\N	94393	94393	262204
10250	10013	13	applied	\N	\N	\N	\N	94394	94394	262205
10250	10014	14	applied	\N	\N	\N	\N	94395	94395	262206
10250	10015	15	applied	\N	\N	\N	\N	94396	94396	262207
10250	10143	16	applied	\N	\N	\N	\N	94397	94397	262208
10250	10019	17	applied	\N	\N	1000000000	\N	94398	94398	262209
10250	10068	18	applied	\N	\N	\N	\N	94399	94399	262210
10250	10024	19	applied	\N	\N	\N	\N	94400	94400	262211
10250	9880	20	applied	\N	\N	\N	\N	94401	94401	262212
10250	10039	21	applied	\N	\N	\N	\N	94402	94402	262213
10250	10032	23	applied	\N	\N	\N	\N	94404	94404	262215
10250	10041	24	applied	\N	\N	\N	\N	94405	94405	262216
10250	10026	25	applied	\N	\N	\N	\N	94406	94406	262217
10250	10071	26	applied	\N	\N	\N	\N	94407	94407	262218
10250	10072	27	applied	\N	\N	\N	\N	94408	94408	262219
10252	10274	0	applied	\N	\N	1000000000	\N	94409	94409	262220
10252	10275	1	applied	\N	\N	\N	\N	94410	94410	262221
10252	10276	2	applied	\N	\N	\N	\N	94411	94411	262222
10252	10277	3	applied	\N	\N	\N	\N	94412	94412	262223
10252	10278	4	applied	\N	\N	\N	\N	94413	94413	262224
10252	10279	5	applied	\N	\N	\N	\N	94414	94414	262225
10252	10280	6	applied	\N	\N	\N	\N	94415	94415	262226
10255	10299	0	applied	\N	\N	\N	\N	94436	94436	262247
10255	10300	1	applied	\N	\N	\N	\N	94437	94437	262248
10256	10301	0	applied	\N	\N	\N	\N	94438	94438	262249
10256	10302	1	applied	\N	\N	\N	\N	94439	94439	262250
10262	10309	1	applied	\N	\N	\N	\N	94460	94460	262271
10262	10310	2	applied	\N	\N	\N	\N	94461	94461	262272
10262	10311	3	applied	\N	\N	\N	\N	94462	94462	262273
10268	10322	0	applied	\N	\N	\N	\N	94487	94487	262298
10268	10323	1	applied	\N	\N	\N	\N	94488	94488	262299
10276	10345	0	applied	\N	\N	\N	\N	94510	94510	262321
10276	10346	1	applied	\N	\N	\N	\N	94511	94511	262322
10276	10347	3	applied	\N	\N	\N	\N	94512	94512	262323
10276	10348	4	applied	\N	\N	\N	\N	94513	94513	262324
10276	10349	5	applied	\N	\N	\N	\N	94514	94514	262325
10276	10350	6	applied	\N	\N	\N	\N	94515	94515	262326
10276	10351	7	applied	\N	\N	\N	\N	94516	94516	262327
10277	10345	0	applied	\N	\N	\N	\N	94517	94517	262328
10277	10346	1	applied	\N	\N	\N	\N	94518	94518	262329
10277	10347	3	applied	\N	\N	\N	\N	94519	94519	262330
10277	10348	4	applied	\N	\N	\N	\N	94520	94520	262331
10277	10350	6	applied	\N	\N	\N	\N	94522	94522	262333
10277	10351	7	applied	\N	\N	\N	\N	94523	94523	262334
10278	10345	0	applied	\N	\N	\N	\N	94524	94524	262335
10278	10346	1	applied	\N	\N	\N	\N	94525	94525	262336
10278	10347	3	applied	\N	\N	\N	\N	94526	94526	262337
10278	10348	4	applied	\N	\N	\N	\N	94527	94527	262338
10278	10349	5	applied	\N	\N	\N	\N	94528	94528	262339
10278	10350	6	applied	\N	\N	\N	\N	94529	94529	262340
10278	10351	7	applied	\N	\N	\N	\N	94530	94530	262341
10279	10345	0	applied	\N	\N	\N	\N	94531	94531	262342
10279	10346	1	applied	\N	\N	\N	\N	94532	94532	262343
10279	10347	3	applied	\N	\N	\N	\N	94533	94533	262344
10279	10348	4	applied	\N	\N	\N	\N	94534	94534	262345
10279	10349	5	applied	\N	\N	\N	\N	94535	94535	262346
10279	10350	6	applied	\N	\N	\N	\N	94536	94536	262347
10279	10351	7	applied	\N	\N	\N	\N	94537	94537	262348
10280	10346	1	applied	\N	\N	\N	\N	94539	94539	262350
10280	10347	3	applied	\N	\N	\N	\N	94540	94540	262351
10280	10348	4	applied	\N	\N	\N	\N	94541	94541	262352
10280	10349	5	applied	\N	\N	\N	\N	94542	94542	262353
10280	10350	6	applied	\N	\N	\N	\N	94543	94543	262354
10280	10351	7	applied	\N	\N	\N	\N	94544	94544	262355
10281	10352	0	applied	\N	\N	\N	\N	94545	94545	262356
10281	10353	1	applied	\N	\N	\N	\N	94546	94546	262357
10282	10354	0	applied	\N	\N	\N	\N	94547	94547	262358
10282	10355	1	applied	\N	\N	\N	\N	94548	94548	262359
10282	10356	2	applied	\N	\N	\N	\N	94549	94549	262360
10282	10357	3	applied	\N	\N	\N	\N	94550	94550	262361
10282	10358	4	applied	\N	\N	\N	\N	94551	94551	262362
10282	10359	5	applied	\N	\N	\N	\N	94552	94552	262363
10282	10360	6	applied	\N	\N	\N	\N	94553	94553	262364
10282	10361	7	applied	\N	\N	\N	\N	94554	94554	262365
10282	10363	9	applied	\N	\N	\N	\N	94556	94556	262367
10282	10364	10	applied	\N	\N	\N	\N	94557	94557	262368
10283	10365	0	applied	\N	\N	\N	\N	94558	94558	262369
10283	10366	1	applied	\N	\N	\N	\N	94559	94559	262370
10284	10365	0	applied	\N	\N	\N	\N	94560	94560	262371
10284	10366	1	applied	\N	\N	\N	\N	94561	94561	262372
10284	10367	2	applied	\N	\N	\N	\N	94562	94562	262373
10285	10365	0	applied	\N	\N	\N	\N	94563	94563	262374
10285	10366	1	applied	\N	\N	\N	\N	94564	94564	262375
10285	10367	2	applied	\N	\N	\N	\N	94565	94565	262376
10286	10368	0	applied	\N	\N	\N	\N	94566	94566	262377
10286	10369	1	applied	\N	\N	\N	\N	94567	94567	262378
10286	10370	2	applied	\N	\N	\N	\N	94568	94568	262379
10286	10371	3	applied	\N	\N	\N	\N	94569	94569	262380
10291	10372	0	applied	\N	\N	\N	\N	94584	94584	262395
10291	10373	1	applied	\N	\N	\N	\N	94585	94585	262396
10297	10383	0	applied	\N	\N	\N	\N	94607	94607	262418
10297	10384	1	applied	\N	\N	\N	\N	94608	94608	262419
10248	10266	0	applied	\N	\N	\N	\N	94373	94373	262184
10248	10267	1	applied	\N	\N	\N	\N	94374	94374	262185
10287	10371	3	applied	\N	\N	\N	\N	94573	94573	262384
10292	10375	0	applied	\N	\N	\N	\N	94587	94587	262398
10292	10376	1	applied	\N	\N	\N	\N	94588	94588	262399
10304	10397	0	applied	\N	\N	\N	\N	94626	94626	262437
10304	10398	1	applied	\N	\N	\N	\N	94627	94627	262438
10304	10399	2	applied	\N	\N	\N	\N	94628	94628	262439
10304	10400	3	applied	\N	\N	\N	\N	94629	94629	262440
10305	10401	0	applied	\N	\N	\N	\N	94630	94630	262441
10305	10402	1	applied	\N	\N	\N	\N	94631	94631	262442
10305	10404	3	applied	\N	\N	\N	\N	94633	94633	262444
10305	10405	4	applied	\N	\N	\N	\N	94634	94634	262445
10309	10401	0	applied	\N	\N	\N	\N	94652	94652	262463
10309	10402	1	applied	\N	\N	\N	\N	94653	94653	262464
10309	10403	2	applied	\N	\N	\N	\N	94654	94654	262465
10309	10404	3	applied	\N	\N	\N	\N	94655	94655	262466
10309	10405	4	applied	\N	\N	\N	\N	94656	94656	262467
10310	10407	0	applied	\N	\N	\N	\N	94657	94657	262468
10310	10408	1	applied	\N	\N	\N	\N	94658	94658	262469
10310	10406	2	applied	\N	\N	\N	\N	94659	94659	262470
10318	10427	0	applied	\N	\N	\N	\N	94693	94693	262500
10318	10428	1	applied	\N	\N	\N	\N	94694	94694	262501
10318	10429	2	applied	\N	\N	\N	\N	94695	94695	262502
10318	10430	3	applied	\N	\N	\N	\N	94696	94696	262503
10318	10431	4	applied	\N	\N	\N	\N	94697	94697	262504
10318	10432	5	applied	\N	\N	\N	\N	94698	94698	262505
10318	10434	7	applied	\N	\N	\N	\N	94700	94700	262507
10318	10435	8	applied	\N	\N	\N	\N	94701	94701	262508
10318	10436	10	applied	\N	\N	\N	\N	94702	94702	262509
10319	10437	0	applied	\N	\N	\N	\N	94703	94703	262510
10319	10438	1	applied	\N	\N	\N	\N	94704	94704	262511
10320	10439	0	applied	\N	\N	\N	\N	94705	94705	262512
10320	10440	1	applied	\N	\N	\N	\N	94706	94706	262513
10320	10441	2	applied	\N	\N	\N	\N	94707	94707	262514
10320	10442	3	applied	\N	\N	\N	\N	94708	94708	262515
10325	10445	0	applied	\N	\N	\N	\N	94723	94723	262530
10325	10446	1	applied	\N	\N	\N	\N	94724	94724	262531
10325	10447	2	applied	\N	\N	\N	\N	94725	94725	262532
10325	10448	3	applied	\N	\N	\N	\N	94726	94726	262533
10335	10478	0	applied	\N	\N	\N	\N	94768	94768	262575
10335	10479	1	applied	\N	\N	\N	\N	94769	94769	262576
10335	10480	2	applied	\N	\N	\N	\N	94770	94770	262577
10336	10482	1	applied	\N	\N	\N	\N	94772	94772	262579
10342	10489	0	applied	\N	\N	\N	\N	94786	94786	262593
10342	10490	1	applied	\N	\N	\N	\N	94787	94787	262594
10348	10499	0	applied	\N	\N	\N	\N	94806	94806	262613
10348	10500	1	applied	\N	\N	\N	\N	94807	94807	262614
10354	10505	0	applied	\N	\N	\N	\N	94824	94824	262631
10354	10506	1	applied	\N	\N	\N	\N	94825	94825	262632
10369	10515	0	applied	\N	\N	1000000000	\N	94854	94854	262661
10369	10516	1	applied	\N	\N	\N	\N	94855	94855	262662
10369	10517	3	applied	\N	\N	\N	\N	94856	94856	262663
10369	10518	4	applied	\N	\N	\N	\N	94857	94857	262664
10369	10519	5	applied	\N	\N	\N	\N	94858	94858	262665
10373	10521	0	applied	\N	\N	\N	\N	94865	94865	262672
10382	10546	0	applied	\N	\N	\N	\N	94903	94903	262710
10382	10547	1	applied	\N	\N	\N	\N	94904	94904	262711
10382	10548	2	applied	\N	\N	\N	\N	94905	94905	262712
10388	10554	1	applied	\N	\N	\N	\N	95040	95040	262847
10388	10555	2	applied	\N	\N	\N	\N	95041	95041	262848
10392	10560	0	applied	\N	\N	\N	\N	95051	95051	262858
10392	10561	1	applied	\N	\N	\N	\N	95052	95052	262859
10397	10564	0	applied	\N	\N	\N	\N	95062	95062	262869
10397	10565	1	applied	\N	\N	\N	\N	95063	95063	262870
10404	10574	0	applied	\N	\N	\N	\N	95076	95076	262883
10404	10575	1	applied	\N	\N	\N	\N	95077	95077	262884
10405	10576	0	applied	\N	\N	\N	\N	95078	95078	262885
10405	10577	1	applied	\N	\N	\N	\N	95079	95079	262886
10405	10578	2	applied	\N	\N	\N	\N	95080	95080	262887
10405	10579	3	applied	\N	\N	\N	\N	95081	95081	262888
10405	10580	4	applied	\N	\N	\N	\N	95082	95082	262889
10405	10581	5	applied	\N	\N	\N	\N	95083	95083	262890
10406	10582	0	applied	\N	\N	\N	\N	95084	95084	262891
10406	10583	1	applied	\N	\N	\N	\N	95085	95085	262892
10413	10596	2	applied	\N	\N	\N	\N	95107	95107	262914
10415	10604	0	applied	\N	\N	\N	\N	95115	95115	262922
10415	10605	1	applied	\N	\N	\N	\N	95116	95116	262923
10415	10606	2	applied	\N	\N	\N	\N	95117	95117	262924
10415	10607	3	applied	\N	\N	\N	\N	95118	95118	262925
10415	10608	4	applied	\N	\N	\N	\N	95119	95119	262926
10426	10629	0	applied	\N	\N	\N	\N	95177	95177	262984
10426	10630	1	applied	\N	\N	\N	\N	95178	95178	262985
10427	10631	0	applied	\N	\N	\N	\N	95179	95179	262986
10427	10632	1	applied	\N	\N	\N	\N	95180	95180	262987
10427	10633	2	applied	\N	\N	\N	\N	95181	95181	262988
10427	10634	3	applied	\N	\N	\N	\N	95182	95182	262989
10427	10635	4	applied	\N	\N	\N	\N	95183	95183	262990
10427	10636	5	applied	\N	\N	\N	\N	95184	95184	262991
10427	10637	6	applied	\N	\N	\N	\N	95185	95185	262992
10427	10638	7	applied	\N	\N	\N	\N	95186	95186	262993
10427	10640	9	applied	\N	\N	\N	\N	95188	95188	262995
10427	10641	10	applied	\N	\N	\N	\N	95189	95189	262996
10427	10642	11	applied	\N	\N	\N	\N	95190	95190	262997
10427	10643	12	applied	\N	\N	\N	\N	95191	95191	262998
10427	10644	13	applied	\N	\N	\N	\N	95192	95192	262999
10427	10645	14	applied	\N	\N	\N	\N	95193	95193	263000
10429	10646	0	applied	\N	\N	\N	\N	95209	95209	263016
10429	10647	1	applied	\N	\N	\N	\N	95210	95210	263017
10449	10685	0	applied	\N	\N	\N	\N	95415	95415	263222
10449	10686	2	applied	\N	\N	\N	\N	95416	95416	263223
10449	10687	3	applied	\N	\N	\N	\N	95417	95417	263224
10449	10688	4	applied	\N	\N	\N	\N	95418	95418	263225
10449	10689	5	applied	\N	\N	\N	\N	95419	95419	263226
10449	10690	6	applied	\N	\N	\N	\N	95420	95420	263227
10449	10691	7	applied	\N	\N	\N	\N	95421	95421	263228
10449	10692	8	applied	\N	\N	\N	\N	95422	95422	263229
10449	10694	10	applied	\N	\N	1000000000	\N	95424	95424	263231
10449	10695	11	applied	\N	\N	1000000000	\N	95425	95425	263232
10449	10696	12	applied	\N	\N	\N	\N	95426	95426	263233
10449	10697	13	applied	\N	\N	\N	\N	95427	95427	263234
10287	10369	1	applied	\N	\N	\N	\N	94571	94571	262382
10287	10370	2	applied	\N	\N	\N	\N	94572	94572	262383
10292	10377	2	applied	\N	\N	\N	\N	94589	94589	262400
10293	10378	0	applied	\N	\N	\N	\N	94590	94590	262401
10293	10379	1	applied	\N	\N	\N	\N	94591	94591	262402
10293	10380	2	applied	\N	\N	\N	\N	94592	94592	262403
10293	10381	3	applied	\N	\N	\N	\N	94593	94593	262404
10293	10382	4	applied	\N	\N	\N	\N	94594	94594	262405
10294	10378	0	applied	\N	\N	\N	\N	94595	94595	262406
10294	10379	1	applied	\N	\N	\N	\N	94596	94596	262407
10298	10383	0	applied	\N	\N	\N	\N	94609	94609	262420
10298	10384	1	applied	\N	\N	\N	\N	94610	94610	262421
10299	10385	0	applied	\N	\N	\N	\N	94611	94611	262422
10299	10386	1	applied	\N	\N	\N	\N	94612	94612	262423
10299	10387	2	applied	\N	\N	\N	\N	94613	94613	262424
10299	10388	3	applied	\N	\N	\N	\N	94614	94614	262425
10299	10390	5	applied	\N	\N	\N	\N	94616	94616	262427
10299	10391	6	applied	\N	\N	\N	\N	94617	94617	262428
10300	10392	0	applied	\N	\N	\N	\N	94618	94618	262429
10300	10393	1	applied	\N	\N	1000000000	\N	94619	94619	262430
10300	10394	2	applied	\N	\N	\N	\N	94620	94620	262431
10306	10401	0	applied	\N	\N	\N	\N	94635	94635	262446
10306	10402	1	applied	\N	\N	\N	\N	94636	94636	262447
10306	10403	2	applied	\N	\N	\N	\N	94637	94637	262448
10306	10404	3	applied	\N	\N	\N	\N	94638	94638	262449
10306	10406	4	applied	\N	\N	\N	\N	94639	94639	262450
10306	10405	5	applied	\N	\N	\N	\N	94640	94640	262451
10311	10409	0	applied	\N	\N	\N	\N	94660	94660	262471
10311	10410	1	applied	\N	\N	\N	\N	94661	94661	262472
10311	10411	2	applied	\N	\N	\N	\N	94662	94662	262473
10311	10412	3	applied	\N	\N	\N	\N	94663	94663	94663
10312	10413	0	applied	\N	\N	\N	\N	94664	94664	262474
10312	10415	2	applied	\N	\N	\N	\N	94666	94666	94666
10321	10439	0	applied	\N	\N	\N	\N	94709	94709	262516
10321	10440	1	applied	\N	\N	\N	\N	94710	94710	262517
10321	10441	2	applied	\N	\N	\N	\N	94711	94711	262518
10321	10442	3	applied	\N	\N	\N	\N	94712	94712	262519
10326	10445	0	applied	\N	\N	\N	\N	94727	94727	262534
10326	10446	1	applied	\N	\N	\N	\N	94728	94728	262535
10326	10447	2	applied	\N	\N	\N	\N	94729	94729	262536
10326	10448	3	applied	\N	\N	\N	\N	94730	94730	262537
10327	10449	0	applied	\N	\N	\N	\N	94731	94731	262538
10327	10450	1	applied	\N	\N	\N	\N	94732	94732	262539
10327	10451	2	applied	\N	\N	\N	\N	94733	94733	262540
10327	10452	3	applied	\N	\N	\N	\N	94734	94734	262541
10337	10481	0	applied	\N	\N	\N	\N	94773	94773	262580
10337	10482	1	applied	\N	\N	\N	\N	94774	94774	262581
10338	10483	0	applied	\N	\N	\N	\N	94775	94775	262582
10338	10485	2	applied	\N	\N	\N	\N	94777	94777	262584
10338	10486	3	applied	\N	\N	\N	\N	94778	94778	262585
10343	10489	0	applied	\N	\N	\N	\N	94788	94788	262595
10343	10490	1	applied	\N	\N	\N	\N	94789	94789	262596
10344	10491	0	applied	\N	\N	\N	\N	94790	94790	262597
10344	10492	1	applied	\N	\N	\N	\N	94791	94791	262598
10344	10493	2	applied	\N	\N	\N	\N	94792	94792	262599
10344	10494	3	applied	\N	\N	\N	\N	94793	94793	262600
10344	10495	4	applied	\N	\N	\N	\N	94794	94794	262601
10344	10496	5	applied	\N	\N	\N	\N	94795	94795	262602
10345	10491	0	applied	\N	\N	\N	\N	94796	94796	262603
10345	10492	1	applied	\N	\N	\N	\N	94797	94797	262604
10345	10493	2	applied	\N	\N	\N	\N	94798	94798	262605
10345	10494	3	applied	\N	\N	\N	\N	94799	94799	262606
10345	10495	4	applied	\N	\N	\N	\N	94800	94800	262607
10345	10496	5	applied	\N	\N	\N	\N	94801	94801	262608
10349	10500	1	applied	\N	\N	\N	\N	94809	94809	262616
10350	10499	0	applied	\N	\N	\N	\N	94810	94810	262617
10350	10500	1	applied	\N	\N	\N	\N	94811	94811	262618
10350	10501	2	applied	\N	\N	\N	\N	94812	94812	262619
10350	10502	3	applied	\N	\N	\N	\N	94813	94813	262620
10355	10505	0	applied	\N	\N	\N	\N	94826	94826	262633
10355	10506	1	applied	\N	\N	\N	\N	94827	94827	262634
10359	10507	0	applied	\N	\N	\N	\N	94830	94830	262637
10359	10508	1	applied	\N	\N	\N	\N	94831	94831	262638
10364	10509	0	applied	\N	\N	\N	\N	94834	94834	262641
10364	10510	1	applied	\N	\N	\N	\N	94835	94835	262642
10365	10511	0	applied	\N	\N	\N	\N	94836	94836	262643
10365	10512	1	applied	\N	\N	\N	\N	94837	94837	262644
10365	10513	2	applied	\N	\N	\N	\N	94838	94838	262645
10365	10514	3	applied	\N	\N	\N	\N	94839	94839	262646
10370	10520	0	applied	\N	\N	\N	\N	94859	94859	262666
10374	10520	0	applied	\N	\N	\N	\N	94866	94866	262673
10374	10521	1	applied	\N	\N	\N	\N	94867	94867	262674
10375	10521	0	applied	\N	\N	\N	\N	94868	94868	262675
10377	10527	0	applied	\N	\N	\N	\N	94874	94874	262681
10377	10528	1	applied	\N	\N	\N	\N	94875	94875	262682
10377	10529	2	applied	\N	\N	\N	\N	94876	94876	262683
10377	10530	3	applied	\N	\N	\N	\N	94877	94877	262684
10377	10531	4	applied	\N	\N	\N	\N	94878	94878	262685
10377	10532	5	applied	\N	\N	\N	\N	94879	94879	262686
10377	10533	6	applied	\N	\N	\N	\N	94880	94880	262687
10377	10534	7	applied	\N	\N	\N	\N	94881	94881	262688
10377	10535	8	applied	\N	\N	\N	\N	94882	94882	262689
10378	10536	0	applied	\N	\N	\N	\N	94883	94883	262690
10378	10537	1	applied	\N	\N	\N	\N	94884	94884	262691
10378	10538	2	applied	\N	\N	\N	\N	94885	94885	262692
10378	10539	3	applied	\N	\N	\N	\N	94886	94886	262693
10378	10541	5	applied	\N	\N	\N	\N	94888	94888	262695
10383	10546	0	applied	\N	\N	\N	\N	94906	94906	262713
10383	10547	1	applied	\N	\N	\N	\N	94907	94907	262714
10384	10549	0	applied	\N	\N	\N	\N	94908	94908	262715
10384	10550	1	applied	\N	\N	\N	\N	94909	94909	262716
10389	10554	0	applied	\N	\N	\N	\N	95042	95042	262849
10389	10555	1	applied	\N	\N	\N	\N	95043	95043	262850
10393	10560	0	applied	\N	\N	\N	\N	95053	95053	262860
10393	10561	1	applied	\N	\N	\N	\N	95054	95054	262861
10398	10564	0	applied	\N	\N	\N	\N	95064	95064	262871
10398	10565	1	applied	\N	\N	\N	\N	95065	95065	262872
10399	10566	0	applied	\N	\N	\N	\N	95066	95066	262873
10399	10567	1	applied	\N	\N	\N	\N	95067	95067	262874
10407	10582	0	applied	\N	\N	\N	\N	95086	95086	262893
10407	10583	1	applied	\N	\N	\N	\N	95087	95087	262894
10408	10584	0	applied	\N	\N	\N	\N	95088	95088	262895
10288	10371	3	applied	\N	\N	\N	\N	94577	94577	262388
10290	10372	0	applied	\N	\N	\N	\N	94581	94581	262392
10290	10373	1	applied	\N	\N	\N	\N	94582	94582	262393
10290	10374	2	applied	\N	\N	\N	\N	94583	94583	262394
10294	10380	2	applied	\N	\N	\N	\N	94597	94597	262408
10294	10381	3	applied	\N	\N	\N	\N	94598	94598	262409
10294	10382	4	applied	\N	\N	\N	\N	94599	94599	262410
10295	10378	0	applied	\N	\N	\N	\N	94600	94600	262411
10295	10379	1	applied	\N	\N	\N	\N	94601	94601	262412
10295	10380	2	applied	\N	\N	\N	\N	94602	94602	262413
10295	10381	3	applied	\N	\N	\N	\N	94603	94603	262414
10295	10382	4	applied	\N	\N	\N	\N	94604	94604	262415
10301	10393	1	applied	\N	\N	1000000000	\N	94622	94622	262433
10301	10394	2	applied	\N	\N	\N	\N	94623	94623	262434
10307	10401	0	applied	\N	\N	\N	\N	94641	94641	262452
10307	10402	1	applied	\N	\N	\N	\N	94642	94642	262453
10307	10403	2	applied	\N	\N	\N	\N	94643	94643	262454
10307	10404	3	applied	\N	\N	\N	\N	94644	94644	262455
10307	10406	4	applied	\N	\N	\N	\N	94645	94645	262456
10307	10405	5	applied	\N	\N	\N	\N	94646	94646	262457
10313	10413	0	applied	\N	\N	\N	\N	94667	94667	262476
10313	10414	1	applied	\N	\N	\N	\N	94668	94668	262477
10313	10415	2	applied	\N	\N	\N	\N	94669	94669	94669
10322	10439	0	applied	\N	\N	\N	\N	94713	94713	262520
10322	10440	1	applied	\N	\N	\N	\N	94714	94714	262521
10322	10441	2	applied	\N	\N	\N	\N	94715	94715	262522
10322	10442	3	applied	\N	\N	\N	\N	94716	94716	262523
10328	10453	0	applied	\N	\N	\N	\N	94735	94735	262542
10328	10455	2	applied	\N	\N	\N	\N	94737	94737	262544
10328	10456	3	applied	\N	\N	\N	\N	94738	94738	262545
10328	10457	4	applied	\N	\N	\N	\N	94739	94739	262546
10333	10471	0	applied	\N	\N	\N	\N	94758	94758	262565
10333	10472	1	applied	\N	\N	\N	\N	94759	94759	262566
10333	10473	2	applied	\N	\N	\N	\N	94760	94760	262567
10333	10474	3	applied	\N	\N	\N	\N	94761	94761	262568
10333	10475	4	applied	\N	\N	\N	\N	94762	94762	262569
10333	10476	5	applied	\N	\N	\N	\N	94763	94763	262570
10333	10477	6	applied	\N	\N	\N	\N	94764	94764	262571
10339	10487	0	applied	\N	\N	\N	\N	94779	94779	262586
10339	10488	1	applied	\N	\N	\N	\N	94780	94780	262587
10346	10497	0	applied	\N	\N	\N	\N	94802	94802	262609
10346	10498	1	applied	\N	\N	\N	\N	94803	94803	262610
10351	10501	0	applied	\N	\N	\N	\N	94814	94814	262621
10351	10503	1	applied	\N	\N	\N	\N	94815	94815	262622
10351	10504	3	applied	\N	\N	\N	\N	94817	94817	262624
10352	10501	0	applied	\N	\N	\N	\N	94818	94818	262625
10352	10503	1	applied	\N	\N	\N	\N	94819	94819	262626
10352	10502	2	applied	\N	\N	\N	\N	94820	94820	262627
10352	10504	3	applied	\N	\N	\N	\N	94821	94821	262628
10360	10507	0	applied	\N	\N	\N	\N	94832	94832	262639
10360	10508	1	applied	\N	\N	\N	\N	94833	94833	262640
10366	10511	0	applied	\N	\N	\N	\N	94840	94840	262647
10366	10512	1	applied	\N	\N	\N	\N	94841	94841	262648
10366	10513	2	applied	\N	\N	\N	\N	94842	94842	262649
10366	10514	3	applied	\N	\N	\N	\N	94843	94843	262650
10367	10515	0	applied	\N	\N	1000000000	\N	94844	94844	262651
10367	10516	1	applied	\N	\N	\N	\N	94845	94845	262652
10367	10517	3	applied	\N	\N	\N	\N	94846	94846	262653
10367	10518	4	applied	\N	\N	\N	\N	94847	94847	262654
10367	10519	5	applied	\N	\N	\N	\N	94848	94848	262655
10371	10521	1	applied	\N	\N	\N	\N	94862	94862	262669
10376	10522	0	applied	\N	\N	\N	\N	94869	94869	262676
10376	10523	1	applied	\N	\N	\N	\N	94870	94870	262677
10376	10524	2	applied	\N	\N	\N	\N	94871	94871	262678
10376	10525	3	applied	\N	\N	\N	\N	94872	94872	262679
10376	10526	4	applied	\N	\N	\N	\N	94873	94873	262680
10379	10536	0	applied	\N	\N	\N	\N	94889	94889	262696
10379	10537	1	applied	\N	\N	\N	\N	94890	94890	262697
10379	10538	2	applied	\N	\N	\N	\N	94891	94891	262698
10379	10539	3	applied	\N	\N	\N	\N	94892	94892	262699
10379	10540	4	applied	\N	\N	\N	\N	94893	94893	262700
10379	10541	5	applied	\N	\N	\N	\N	94894	94894	262701
10380	10542	0	applied	\N	\N	\N	\N	94895	94895	262702
10380	10543	1	applied	\N	\N	\N	\N	94896	94896	262703
10380	10544	2	applied	\N	\N	\N	\N	94897	94897	262704
10380	10545	3	applied	\N	\N	\N	\N	94898	94898	262705
10385	10552	1	applied	\N	\N	\N	\N	94911	94911	262718
10390	10553	0	applied	\N	\N	\N	\N	95044	95044	262851
10390	10554	1	applied	\N	\N	\N	\N	95045	95045	262852
10390	10555	2	applied	\N	\N	\N	\N	95046	95046	262853
10391	10556	0	applied	\N	\N	\N	\N	95047	95047	262854
10391	10557	1	applied	\N	\N	\N	\N	95048	95048	262855
10391	10558	2	applied	\N	\N	\N	\N	95049	95049	262856
10391	10559	3	applied	\N	\N	\N	\N	95050	95050	262857
10396	10560	0	applied	\N	\N	\N	\N	95059	95059	262866
10396	10562	1	applied	\N	\N	\N	\N	95060	95060	262867
10396	10561	2	applied	\N	\N	\N	\N	95061	95061	262868
10401	10568	0	applied	\N	\N	1000000000	\N	95070	95070	262877
10401	10569	1	applied	\N	\N	\N	\N	95071	95071	262878
10401	10570	2	applied	\N	\N	\N	\N	95072	95072	262879
10402	10571	0	applied	\N	\N	\N	\N	95073	95073	262880
10403	10572	0	applied	\N	\N	\N	\N	95074	95074	262881
10412	10595	0	applied	\N	\N	\N	\N	95104	95104	262911
10412	10596	2	applied	\N	\N	\N	\N	95105	95105	262912
10414	10597	0	applied	\N	\N	\N	\N	95108	95108	262915
10414	10598	1	applied	\N	\N	\N	\N	95109	95109	262916
10414	10599	2	applied	\N	\N	\N	\N	95110	95110	262917
10414	10600	3	applied	\N	\N	\N	\N	95111	95111	262918
10414	10601	4	applied	\N	\N	\N	\N	95112	95112	262919
10414	10602	5	applied	\N	\N	\N	\N	95113	95113	262920
10414	10603	6	applied	\N	\N	\N	\N	95114	95114	262921
10419	10609	0	applied	\N	\N	\N	\N	95131	95131	262938
10419	10610	1	applied	\N	\N	\N	\N	95132	95132	262939
10420	10611	0	applied	\N	\N	\N	\N	95133	95133	262940
10420	10612	1	applied	\N	\N	\N	\N	95134	95134	262941
10420	10613	2	applied	\N	\N	\N	\N	95135	95135	262942
10420	10614	3	applied	\N	\N	\N	\N	95136	95136	262943
10420	10615	4	applied	\N	\N	\N	\N	95137	95137	262944
10420	10617	6	applied	\N	\N	\N	\N	95139	95139	262946
10420	10618	7	applied	\N	\N	\N	\N	95140	95140	262947
10289	10369	1	applied	\N	\N	\N	\N	94579	94579	262390
10289	10371	2	applied	\N	\N	\N	\N	94580	94580	262391
10303	10396	1	applied	\N	\N	\N	\N	94625	94625	262436
10308	10401	0	applied	\N	\N	\N	\N	94647	94647	262458
10308	10402	1	applied	\N	\N	\N	\N	94648	94648	262459
10308	10403	2	applied	\N	\N	\N	\N	94649	94649	262460
10308	10404	3	applied	\N	\N	\N	\N	94650	94650	262461
10308	10405	4	applied	\N	\N	\N	\N	94651	94651	262462
10314	10413	0	applied	\N	\N	\N	\N	94670	94670	262478
10314	10414	1	applied	\N	\N	\N	\N	94671	94671	262479
10314	10415	2	applied	\N	\N	\N	\N	94672	94672	94672
10315	10416	0	applied	\N	\N	\N	\N	94673	94673	262480
10315	10417	1	applied	\N	\N	\N	\N	94674	94674	262481
10315	10418	2	applied	\N	\N	\N	\N	94675	94675	262482
10315	10419	3	applied	\N	\N	\N	\N	94676	94676	262483
10315	10421	5	applied	\N	\N	\N	\N	94678	94678	262485
10316	10422	0	applied	\N	\N	\N	\N	94679	94679	262486
10316	10423	1	applied	\N	\N	\N	\N	94680	94680	262487
10316	10424	2	applied	\N	\N	\N	\N	94681	94681	262488
10316	10425	3	applied	\N	\N	\N	\N	94682	94682	262489
10316	10426	4	applied	\N	\N	\N	\N	94683	94683	262490
10317	10427	0	applied	\N	\N	\N	\N	94684	94684	262491
10317	10428	1	applied	\N	\N	\N	\N	94685	94685	262492
10317	10429	2	applied	\N	\N	\N	\N	94686	94686	262493
10317	10430	3	applied	\N	\N	\N	\N	94687	94687	262494
10317	10431	4	applied	\N	\N	\N	\N	94688	94688	262495
10317	10432	5	applied	\N	\N	\N	\N	94689	94689	262496
10317	10433	6	applied	\N	\N	\N	\N	94690	94690	262497
10317	10434	7	applied	\N	\N	\N	\N	94691	94691	262498
10317	10435	8	applied	\N	\N	\N	\N	94692	94692	262499
10323	10439	0	applied	\N	\N	\N	\N	94717	94717	262524
10323	10441	2	applied	\N	\N	\N	\N	94719	94719	262526
10323	10442	3	applied	\N	\N	\N	\N	94720	94720	262527
10324	10443	0	applied	\N	\N	\N	\N	94721	94721	262528
10324	10444	1	applied	\N	\N	\N	\N	94722	94722	262529
10329	10453	0	applied	\N	\N	\N	\N	94740	94740	262547
10329	10454	1	applied	\N	\N	\N	\N	94741	94741	262548
10329	10455	2	applied	\N	\N	\N	\N	94742	94742	262549
10329	10456	3	applied	\N	\N	\N	\N	94743	94743	262550
10329	10457	4	applied	\N	\N	\N	\N	94744	94744	262551
10330	10458	0	applied	\N	\N	\N	\N	94745	94745	262552
10330	10459	1	applied	\N	\N	\N	\N	94746	94746	262553
10330	10460	2	applied	\N	\N	\N	\N	94747	94747	262554
10330	10461	3	applied	\N	\N	\N	\N	94748	94748	262555
10330	10462	4	applied	\N	\N	\N	\N	94749	94749	262556
10331	10463	0	applied	\N	\N	\N	\N	94750	94750	262557
10331	10464	1	applied	\N	\N	\N	\N	94751	94751	262558
10332	10466	1	applied	\N	\N	\N	\N	94753	94753	262560
10332	10467	2	applied	\N	\N	\N	\N	94754	94754	262561
10332	10468	3	applied	\N	\N	\N	\N	94755	94755	262562
10332	10469	4	applied	\N	\N	\N	\N	94756	94756	262563
10332	10470	5	applied	\N	\N	\N	\N	94757	94757	262564
10334	10478	0	applied	\N	\N	\N	\N	94765	94765	262572
10334	10479	1	applied	\N	\N	\N	\N	94766	94766	262573
10334	10480	2	applied	\N	\N	\N	\N	94767	94767	262574
10340	10487	0	applied	\N	\N	\N	\N	94781	94781	262588
10340	10488	1	applied	\N	\N	\N	\N	94782	94782	262589
10340	10489	2	applied	\N	\N	\N	\N	94783	94783	262590
10341	10489	0	applied	\N	\N	\N	\N	94784	94784	262591
10341	10490	1	applied	\N	\N	\N	\N	94785	94785	262592
10347	10497	0	applied	\N	\N	\N	\N	94804	94804	262611
10347	10498	1	applied	\N	\N	\N	\N	94805	94805	262612
10353	10505	0	applied	\N	\N	\N	\N	94822	94822	262629
10357	10507	0	applied	\N	\N	\N	\N	94828	94828	262635
10357	10508	1	applied	\N	\N	\N	\N	94829	94829	262636
10368	10515	0	applied	\N	\N	1000000000	\N	94849	94849	262656
10368	10516	1	applied	\N	\N	\N	\N	94850	94850	262657
10368	10517	3	applied	\N	\N	\N	\N	94851	94851	262658
10368	10518	4	applied	\N	\N	\N	\N	94852	94852	262659
10368	10519	5	applied	\N	\N	\N	\N	94853	94853	262660
10372	10520	0	applied	\N	\N	\N	\N	94863	94863	262670
10372	10521	1	applied	\N	\N	\N	\N	94864	94864	262671
10381	10542	0	applied	\N	\N	\N	\N	94899	94899	262706
10381	10543	1	applied	\N	\N	\N	\N	94900	94900	262707
10381	10544	2	applied	\N	\N	\N	\N	94901	94901	262708
10381	10545	3	applied	\N	\N	\N	\N	94902	94902	262709
10386	10551	0	applied	\N	\N	\N	\N	94912	94912	262719
10386	10552	1	applied	\N	\N	\N	\N	94913	94913	262720
10387	10522	0	applied	\N	\N	\N	\N	94914	94914	262721
10387	10537	2	applied	\N	\N	\N	\N	94916	94916	262723
10387	10538	3	applied	\N	\N	\N	\N	94917	94917	262724
10387	10539	4	applied	\N	\N	\N	\N	94918	94918	262725
10387	10515	5	applied	\N	\N	1000000000	\N	94919	94919	262726
10387	10546	6	applied	\N	\N	\N	\N	94920	94920	262727
10387	10314	7	applied	\N	\N	\N	\N	94921	94921	262728
10387	10449	8	applied	\N	\N	\N	\N	94922	94922	262729
10387	10315	9	applied	\N	\N	\N	\N	94923	94923	262730
10387	10316	11	applied	\N	\N	\N	\N	94924	94924	262731
10387	10317	12	applied	\N	\N	\N	\N	94925	94925	262732
10387	10337	13	applied	\N	\N	\N	\N	94926	94926	262733
10387	10453	14	applied	\N	\N	\N	\N	94927	94927	262734
10387	10454	15	applied	\N	\N	\N	\N	94928	94928	262735
10387	10455	16	applied	\N	\N	\N	\N	94929	94929	262736
10387	10345	17	applied	\N	\N	\N	\N	94930	94930	262737
10387	10354	18	applied	\N	\N	\N	\N	94931	94931	262738
10387	10378	20	applied	\N	\N	\N	\N	94933	94933	262740
10387	10385	21	applied	\N	\N	\N	\N	94934	94934	262741
10387	10527	22	applied	\N	\N	\N	\N	94935	94935	262742
10387	10281	23	applied	\N	\N	\N	\N	94936	94936	262743
10387	10282	24	applied	\N	\N	\N	\N	94937	94937	262744
10387	10283	25	applied	\N	\N	\N	\N	94938	94938	262745
10387	10284	26	applied	\N	\N	\N	\N	94939	94939	262746
10387	10285	27	applied	\N	\N	\N	\N	94940	94940	262747
10387	10286	28	applied	\N	\N	\N	\N	94941	94941	262748
10387	10287	29	applied	\N	\N	\N	\N	94942	94942	262749
10387	10479	30	applied	\N	\N	\N	\N	94943	94943	262750
10387	10366	31	applied	\N	\N	\N	\N	94944	94944	262751
10387	10402	32	applied	\N	\N	\N	\N	94945	94945	262752
10387	10410	33	applied	\N	\N	\N	\N	94946	94946	262753
10387	10259	34	applied	\N	\N	\N	\N	94947	94947	262754
10387	10260	35	applied	\N	\N	\N	\N	94948	94948	262755
10296	10384	1	applied	\N	\N	\N	\N	94606	94606	262417
10303	10395	0	applied	\N	\N	\N	\N	94624	94624	262435
10387	10262	41	applied	\N	\N	\N	\N	94954	94954	262761
10387	10263	42	applied	\N	\N	\N	\N	94955	94955	262762
10387	10265	43	applied	\N	\N	\N	\N	94956	94956	262763
10387	10266	44	applied	\N	\N	\N	\N	94957	94957	262764
10387	10267	45	applied	\N	\N	\N	\N	94958	94958	262765
10387	10268	46	applied	\N	\N	\N	\N	94959	94959	262766
10387	10273	47	applied	\N	\N	\N	\N	94960	94960	262767
10387	10274	48	applied	\N	\N	1000000000	\N	94961	94961	262768
10387	10275	49	applied	\N	\N	\N	\N	94962	94962	262769
10387	10276	50	applied	\N	\N	\N	\N	94963	94963	262770
10387	10277	51	applied	\N	\N	\N	\N	94964	94964	262771
10387	10291	52	applied	\N	\N	\N	\N	94965	94965	262772
10387	10357	53	applied	\N	\N	\N	\N	94966	94966	262773
10387	10358	54	applied	\N	\N	\N	\N	94967	94967	262774
10387	10360	56	applied	\N	\N	\N	\N	94969	94969	262776
10387	10361	57	applied	\N	\N	\N	\N	94970	94970	262777
10387	10362	58	applied	\N	\N	\N	\N	94971	94971	262778
10387	10341	59	applied	\N	\N	\N	\N	94972	94972	262779
10387	10336	60	applied	\N	\N	\N	\N	94973	94973	262780
10387	10369	61	applied	\N	\N	\N	\N	94974	94974	262781
10387	10370	62	applied	\N	\N	\N	\N	94975	94975	262782
10387	10406	63	applied	\N	\N	\N	\N	94976	94976	262783
10387	10269	64	applied	\N	\N	\N	\N	94977	94977	262784
10387	10270	65	applied	\N	\N	\N	\N	94978	94978	262785
10387	10271	66	applied	\N	\N	\N	\N	94979	94979	262786
10387	10272	67	applied	\N	\N	\N	\N	94980	94980	262787
10387	10295	68	applied	\N	\N	\N	\N	94981	94981	262788
10387	10296	69	applied	\N	\N	\N	\N	94982	94982	262789
10387	10297	70	applied	\N	\N	\N	\N	94983	94983	262790
10387	10278	71	applied	\N	\N	\N	\N	94984	94984	262791
10387	10280	73	applied	\N	\N	\N	\N	94986	94986	262793
10387	10288	74	applied	\N	\N	\N	\N	94987	94987	262794
10387	10289	75	applied	\N	\N	\N	\N	94988	94988	262795
10387	10290	76	applied	\N	\N	\N	\N	94989	94989	262796
10387	10293	77	applied	\N	\N	\N	\N	94990	94990	262797
10387	10294	78	applied	\N	\N	\N	\N	94991	94991	262798
10387	10299	79	applied	\N	\N	\N	\N	94992	94992	262799
10387	10301	80	applied	\N	\N	\N	\N	94993	94993	262800
10387	10304	81	applied	\N	\N	\N	\N	94994	94994	262801
10387	10305	82	applied	\N	\N	\N	\N	94995	94995	262802
10387	10308	83	applied	\N	\N	\N	\N	94996	94996	262803
10387	10309	84	applied	\N	\N	\N	\N	94997	94997	262804
10387	10313	85	applied	\N	\N	\N	\N	94998	94998	262805
10387	10320	86	applied	\N	\N	\N	\N	94999	94999	262806
10387	10321	87	applied	\N	\N	\N	\N	95000	95000	262807
10387	10322	88	applied	\N	\N	\N	\N	95001	95001	262808
10387	10327	90	applied	\N	\N	\N	\N	95003	95003	262810
10387	10329	91	applied	\N	\N	\N	\N	95004	95004	262811
10387	10331	92	applied	\N	\N	\N	\N	95005	95005	262812
10387	10333	93	applied	\N	\N	\N	\N	95006	95006	262813
10387	10334	94	applied	\N	\N	\N	\N	95007	95007	262814
10387	10338	95	applied	\N	\N	\N	\N	95008	95008	262815
10387	10339	96	applied	\N	\N	\N	\N	95009	95009	262816
10387	10340	97	applied	\N	\N	\N	\N	95010	95010	262817
10387	10348	98	applied	\N	\N	\N	\N	95011	95011	262818
10387	10349	99	applied	\N	\N	\N	\N	95012	95012	262819
10387	10350	100	applied	\N	\N	\N	\N	95013	95013	262820
10387	10352	101	applied	\N	\N	\N	\N	95014	95014	262821
10387	10355	102	applied	\N	\N	\N	\N	95015	95015	262822
10387	10356	103	applied	\N	\N	\N	\N	95016	95016	262823
10387	10367	104	applied	\N	\N	\N	\N	95017	95017	262824
10387	10368	105	applied	\N	\N	\N	\N	95018	95018	262825
10387	10376	107	applied	\N	\N	\N	\N	95020	95020	262827
10387	10381	108	applied	\N	\N	\N	\N	95021	95021	262828
10387	10382	109	applied	\N	\N	\N	\N	95022	95022	262829
10387	10384	110	applied	\N	\N	\N	\N	95023	95023	262830
10387	10388	111	applied	\N	\N	\N	\N	95024	95024	262831
10387	10390	112	applied	\N	\N	\N	\N	95025	95025	262832
10387	10391	113	applied	\N	\N	\N	\N	95026	95026	262833
10387	10394	114	applied	\N	\N	\N	\N	95027	95027	262834
10387	10396	115	applied	\N	\N	\N	\N	95028	95028	262835
10387	10398	116	applied	\N	\N	\N	\N	95029	95029	262836
10387	10399	117	applied	\N	\N	\N	\N	95030	95030	262837
10387	10401	118	applied	\N	\N	\N	\N	95031	95031	262838
10387	10405	119	applied	\N	\N	\N	\N	95032	95032	262839
10387	10408	120	applied	\N	\N	\N	\N	95033	95033	262840
10387	10411	121	applied	\N	\N	\N	\N	95034	95034	262841
10387	10414	122	applied	\N	\N	\N	\N	95035	95035	262842
10387	10418	124	applied	\N	\N	\N	\N	95037	95037	262844
10387	10421	125	applied	\N	\N	\N	\N	95038	95038	262845
10394	10560	0	applied	\N	\N	\N	\N	95055	95055	262862
10394	10561	1	applied	\N	\N	\N	\N	95056	95056	262863
10395	10562	0	applied	\N	\N	\N	\N	95057	95057	262864
10395	10563	1	applied	\N	\N	\N	\N	95058	95058	262865
10400	10566	0	applied	\N	\N	\N	\N	95068	95068	262875
10400	10567	1	applied	\N	\N	\N	\N	95069	95069	262876
10408	10585	1	applied	\N	\N	\N	\N	95089	95089	262896
10408	10586	2	applied	\N	\N	\N	\N	95090	95090	262897
10408	10587	3	applied	\N	\N	\N	\N	95091	95091	262898
10409	10588	0	applied	\N	\N	\N	\N	95092	95092	262899
10409	10589	1	applied	\N	\N	\N	\N	95093	95093	262900
10409	10590	2	applied	\N	\N	\N	\N	95094	95094	262901
10410	10588	0	applied	\N	\N	\N	\N	95097	95097	262904
10410	10589	1	applied	\N	\N	\N	\N	95098	95098	262905
10410	10591	3	applied	\N	\N	\N	\N	95100	95100	262907
10410	10592	4	applied	\N	\N	\N	\N	95101	95101	262908
10411	10593	0	applied	\N	\N	\N	\N	95102	95102	262909
10411	10594	1	applied	\N	\N	\N	\N	95103	95103	262910
10418	10609	0	applied	\N	\N	\N	\N	95128	95128	262935
10418	10610	1	applied	\N	\N	\N	\N	95129	95129	262936
10418	10611	2	applied	\N	\N	\N	\N	95130	95130	262937
10422	10611	0	applied	\N	\N	\N	\N	95157	95157	262964
10422	10612	1	applied	\N	\N	\N	\N	95158	95158	262965
10422	10613	2	applied	\N	\N	\N	\N	95159	95159	262966
10422	10614	3	applied	\N	\N	\N	\N	95160	95160	262967
10422	10615	4	applied	\N	\N	\N	\N	95161	95161	262968
10422	10616	5	applied	\N	\N	\N	\N	95162	95162	262969
10422	10617	6	applied	\N	\N	\N	\N	95163	95163	262970
10422	10618	7	applied	\N	\N	\N	\N	95164	95164	262971
10422	10619	8	applied	\N	\N	\N	\N	95165	95165	262972
10387	10258	40	applied	\N	\N	\N	\N	94953	94953	262760
10416	10605	1	applied	\N	\N	\N	\N	95121	95121	262928
10416	10606	2	applied	\N	\N	\N	\N	95122	95122	262929
10416	10607	3	applied	\N	\N	\N	\N	95123	95123	262930
10416	10608	4	applied	\N	\N	\N	\N	95124	95124	262931
10417	10609	0	applied	\N	\N	\N	\N	95125	95125	262932
10417	10610	1	applied	\N	\N	\N	\N	95126	95126	262933
10417	10611	2	applied	\N	\N	\N	\N	95127	95127	262934
10420	10619	8	applied	\N	\N	\N	\N	95141	95141	262948
10420	10620	9	applied	\N	\N	\N	\N	95142	95142	262949
10420	10621	10	applied	\N	\N	\N	\N	95143	95143	262950
10420	10622	11	applied	\N	\N	\N	\N	95144	95144	262951
10421	10611	0	applied	\N	\N	\N	\N	95145	95145	262952
10421	10612	1	applied	\N	\N	\N	\N	95146	95146	262953
10430	10648	0	applied	\N	\N	\N	\N	95211	95211	263018
10430	10650	2	applied	\N	\N	\N	\N	95213	95213	263020
10434	10651	0	applied	\N	\N	\N	\N	95224	95224	263031
10434	10652	1	applied	\N	\N	\N	\N	95225	95225	263032
10436	10651	0	applied	\N	\N	\N	\N	95228	95228	263035
10436	10652	1	applied	\N	\N	\N	\N	95229	95229	263036
10439	10661	0	applied	\N	\N	\N	\N	95238	95238	263045
10439	10662	1	applied	\N	\N	\N	\N	95239	95239	263046
10439	10663	2	applied	\N	\N	\N	\N	95240	95240	263047
10442	10671	0	applied	\N	\N	\N	\N	95248	95248	263055
10442	10669	1	applied	\N	\N	\N	\N	95249	95249	263056
10442	10670	2	applied	\N	\N	\N	\N	95250	95250	263057
10444	10672	0	applied	\N	\N	\N	\N	95254	95254	263061
10444	10673	1	applied	\N	\N	\N	\N	95255	95255	263062
10444	10674	2	applied	\N	\N	\N	\N	95256	95256	263063
10451	10685	0	applied	\N	\N	\N	\N	95441	95441	263248
10451	10686	2	applied	\N	\N	\N	\N	95442	95442	263249
10451	10688	4	applied	\N	\N	\N	\N	95444	95444	263251
10451	10689	5	applied	\N	\N	\N	\N	95445	95445	263252
10451	10690	6	applied	\N	\N	\N	\N	95446	95446	263253
10451	10691	7	applied	\N	\N	\N	\N	95447	95447	263254
10451	10692	8	applied	\N	\N	\N	\N	95448	95448	263255
10451	10694	10	applied	\N	\N	1000000000	\N	95450	95450	263257
10451	10695	11	applied	\N	\N	1000000000	\N	95451	95451	263258
10451	10696	12	applied	\N	\N	\N	\N	95452	95452	263259
10451	10697	13	applied	\N	\N	\N	\N	95453	95453	263260
10452	10685	0	applied	\N	\N	\N	\N	95454	95454	263261
10452	10686	2	applied	\N	\N	\N	\N	95455	95455	263262
10452	10687	3	applied	\N	\N	\N	\N	95456	95456	263263
10452	10688	4	applied	\N	\N	\N	\N	95457	95457	263264
10452	10689	5	applied	\N	\N	\N	\N	95458	95458	263265
10452	10690	6	applied	\N	\N	\N	\N	95459	95459	263266
10452	10692	8	applied	\N	\N	\N	\N	95461	95461	263268
10452	10693	9	applied	\N	\N	1000000000	\N	95462	95462	263269
10452	10694	10	applied	\N	\N	1000000000	\N	95463	95463	263270
10452	10695	11	applied	\N	\N	1000000000	\N	95464	95464	263271
10452	10696	12	applied	\N	\N	\N	\N	95465	95465	263272
10452	10697	13	applied	\N	\N	\N	\N	95466	95466	263273
10455	10685	0	applied	\N	\N	\N	\N	95493	95493	263300
10455	10686	2	applied	\N	\N	\N	\N	95494	95494	263301
10455	10687	3	applied	\N	\N	\N	\N	95495	95495	263302
10455	10688	4	applied	\N	\N	\N	\N	95496	95496	263303
10455	10689	5	applied	\N	\N	\N	\N	95497	95497	263304
10455	10690	6	applied	\N	\N	\N	\N	95498	95498	263305
10455	10691	7	applied	\N	\N	\N	\N	95499	95499	263306
10455	10692	8	applied	\N	\N	\N	\N	95500	95500	263307
10455	10694	10	applied	\N	\N	1000000000	\N	95502	95502	263309
10455	10695	11	applied	\N	\N	1000000000	\N	95503	95503	263310
10455	10696	12	applied	\N	\N	\N	\N	95504	95504	263311
10455	10697	13	applied	\N	\N	\N	\N	95505	95505	263312
10457	10698	0	applied	\N	\N	\N	\N	95519	95519	263326
10457	10699	1	applied	\N	\N	\N	\N	95520	95520	263327
10457	10700	2	applied	\N	\N	\N	\N	95521	95521	263328
10457	10701	3	applied	\N	\N	\N	\N	95522	95522	263329
10457	10702	4	applied	\N	\N	\N	\N	95523	95523	263330
10457	10703	5	applied	\N	\N	\N	\N	95524	95524	263331
10463	10704	0	applied	\N	\N	\N	\N	95558	95558	263365
10463	10703	1	applied	\N	\N	\N	\N	95559	95559	263366
10463	10705	2	applied	\N	\N	\N	\N	95560	95560	263367
10463	10706	3	applied	\N	\N	\N	\N	95561	95561	263368
10463	10707	4	applied	\N	\N	\N	\N	95562	95562	263369
10468	10715	0	applied	\N	\N	\N	\N	95588	95588	263395
10468	10716	1	applied	\N	\N	\N	\N	95589	95589	263396
10468	10717	2	applied	\N	\N	\N	\N	95590	95590	263397
10468	10718	3	applied	\N	\N	\N	\N	95591	95591	263398
10468	10719	4	applied	\N	\N	\N	\N	95592	95592	263399
10468	10721	6	applied	\N	\N	1000000000	\N	95594	95594	263401
10468	10722	7	applied	\N	\N	\N	\N	95595	95595	263402
10468	10723	8	applied	\N	\N	\N	\N	95596	95596	263403
10470	10728	0	applied	\N	\N	\N	\N	95601	95601	263408
10470	10729	1	applied	\N	\N	\N	\N	95602	95602	263409
10470	10730	2	applied	\N	\N	\N	\N	95603	95603	263410
10470	10731	3	applied	\N	\N	\N	\N	95604	95604	263411
10470	10732	4	applied	\N	\N	\N	\N	95605	95605	263412
10470	10733	5	applied	\N	\N	\N	\N	95606	95606	263413
10470	10734	6	applied	\N	\N	\N	\N	95607	95607	263414
10470	10735	7	applied	\N	\N	\N	\N	95608	95608	263415
10470	10736	8	applied	\N	\N	\N	\N	95609	95609	263416
10470	10737	9	applied	\N	\N	\N	\N	95610	95610	263417
10470	10738	10	applied	\N	\N	\N	\N	95611	95611	263418
10470	10739	11	applied	\N	\N	\N	\N	95612	95612	263419
10470	10740	12	applied	\N	\N	\N	\N	95613	95613	263420
10470	10742	14	applied	\N	\N	\N	\N	95615	95615	263422
10470	10743	15	applied	\N	\N	\N	\N	95616	95616	263423
10470	10744	16	applied	\N	\N	\N	\N	95617	95617	263424
10470	10745	17	applied	\N	\N	\N	\N	95618	95618	263425
10470	10746	18	applied	\N	\N	\N	\N	95619	95619	263426
10475	10754	0	applied	\N	\N	\N	\N	95629	95629	263436
10475	10755	1	applied	\N	\N	\N	\N	95630	95630	263437
10475	10756	2	applied	\N	\N	\N	\N	95631	95631	263438
10481	10764	0	applied	\N	\N	\N	\N	95652	95652	263459
10481	10765	1	applied	\N	\N	\N	\N	95653	95653	263460
10481	10766	2	applied	\N	\N	\N	\N	95654	95654	263461
10481	10767	3	applied	\N	\N	\N	\N	95655	95655	263462
10481	10768	4	applied	\N	\N	\N	\N	95656	95656	263463
10409	10592	4	applied	\N	\N	\N	\N	95096	95096	262903
10416	10604	0	applied	\N	\N	\N	\N	95120	95120	262927
10421	10617	6	applied	\N	\N	\N	\N	95151	95151	262958
10421	10618	7	applied	\N	\N	\N	\N	95152	95152	262959
10421	10619	8	applied	\N	\N	\N	\N	95153	95153	262960
10421	10620	9	applied	\N	\N	\N	\N	95154	95154	262961
10421	10621	10	applied	\N	\N	\N	\N	95155	95155	262962
10421	10622	11	applied	\N	\N	\N	\N	95156	95156	262963
10422	10620	9	applied	\N	\N	\N	\N	95166	95166	262973
10422	10621	10	applied	\N	\N	\N	\N	95167	95167	262974
10422	10622	11	applied	\N	\N	\N	\N	95168	95168	262975
10423	10623	0	applied	\N	\N	\N	\N	95169	95169	262976
10423	10624	1	applied	\N	\N	\N	\N	95170	95170	262977
10424	10624	1	applied	\N	\N	\N	\N	95172	95172	262979
10425	10625	0	applied	\N	\N	\N	\N	95173	95173	262980
10425	10626	1	applied	\N	\N	\N	\N	95174	95174	262981
10425	10627	2	applied	\N	\N	\N	\N	95175	95175	262982
10432	10648	0	applied	\N	\N	\N	\N	95217	95217	263024
10432	10649	1	applied	\N	\N	\N	\N	95218	95218	263025
10432	10650	2	applied	\N	\N	\N	\N	95219	95219	263026
10433	10648	0	applied	\N	\N	\N	\N	95220	95220	263027
10433	10651	1	applied	\N	\N	\N	\N	95221	95221	263028
10433	10649	2	applied	\N	\N	\N	\N	95222	95222	263029
10433	10650	3	applied	\N	\N	\N	\N	95223	95223	263030
10438	10657	0	applied	\N	\N	\N	\N	95234	95234	263041
10438	10658	1	applied	\N	\N	\N	\N	95235	95235	263042
10438	10659	2	applied	\N	\N	\N	\N	95236	95236	263043
10438	10660	3	applied	\N	\N	\N	\N	95237	95237	263044
10441	10669	0	applied	\N	\N	\N	\N	95246	95246	263053
10443	10672	0	applied	\N	\N	\N	\N	95251	95251	263058
10443	10673	1	applied	\N	\N	\N	\N	95252	95252	263059
10443	10674	2	applied	\N	\N	\N	\N	95253	95253	263060
10446	10675	0	applied	\N	\N	1000000000	\N	95267	95267	263074
10446	10676	1	applied	\N	\N	\N	\N	95268	95268	263075
10446	10677	2	applied	\N	\N	\N	\N	95269	95269	263076
10446	10678	3	applied	\N	\N	\N	\N	95270	95270	263077
10446	10679	4	applied	\N	\N	\N	\N	95271	95271	263078
10446	10680	5	applied	\N	\N	\N	\N	95272	95272	263079
10446	10681	6	applied	\N	\N	\N	\N	95273	95273	263080
10446	10682	7	applied	\N	\N	\N	\N	95274	95274	263081
10446	10683	8	applied	\N	\N	\N	\N	95275	95275	263082
10446	10684	9	applied	\N	\N	\N	\N	95276	95276	263083
10448	10685	0	applied	\N	\N	\N	\N	95402	95402	263209
10448	10686	2	applied	\N	\N	\N	\N	95403	95403	263210
10448	10687	3	applied	\N	\N	\N	\N	95404	95404	263211
10448	10689	5	applied	\N	\N	\N	\N	95406	95406	263213
10448	10690	6	applied	\N	\N	\N	\N	95407	95407	263214
10448	10691	7	applied	\N	\N	\N	\N	95408	95408	263215
10448	10692	8	applied	\N	\N	\N	\N	95409	95409	263216
10448	10693	9	applied	\N	\N	1000000000	\N	95410	95410	263217
10448	10694	10	applied	\N	\N	1000000000	\N	95411	95411	263218
10448	10695	11	applied	\N	\N	1000000000	\N	95412	95412	263219
10448	10696	12	applied	\N	\N	\N	\N	95413	95413	263220
10448	10697	13	applied	\N	\N	\N	\N	95414	95414	263221
10450	10685	0	applied	\N	\N	\N	\N	95428	95428	263235
10450	10686	2	applied	\N	\N	\N	\N	95429	95429	263236
10450	10687	3	applied	\N	\N	\N	\N	95430	95430	263237
10450	10688	4	applied	\N	\N	\N	\N	95431	95431	263238
10450	10689	5	applied	\N	\N	\N	\N	95432	95432	263239
10450	10690	6	applied	\N	\N	\N	\N	95433	95433	263240
10450	10691	7	applied	\N	\N	\N	\N	95434	95434	263241
10450	10693	9	applied	\N	\N	1000000000	\N	95436	95436	263243
10450	10694	10	applied	\N	\N	1000000000	\N	95437	95437	263244
10447	10038	37	applied	\N	\N	\N	\N	95314	95314	263121
10450	10695	11	applied	\N	\N	1000000000	\N	95438	95438	263245
10450	10696	12	applied	\N	\N	\N	\N	95439	95439	263246
10450	10697	13	applied	\N	\N	\N	\N	95440	95440	263247
10459	10685	0	applied	\N	\N	\N	\N	95530	95530	263337
10459	10686	2	applied	\N	\N	\N	\N	95531	95531	263338
10459	10687	3	applied	\N	\N	\N	\N	95532	95532	263339
10459	10688	4	applied	\N	\N	\N	\N	95533	95533	263340
10459	10689	5	applied	\N	\N	\N	\N	95534	95534	263341
10459	10690	6	applied	\N	\N	\N	\N	95535	95535	263342
10459	10691	7	applied	\N	\N	\N	\N	95536	95536	263343
10459	10692	8	applied	\N	\N	\N	\N	95537	95537	263344
10459	10693	9	applied	\N	\N	1000000000	\N	95538	95538	263345
10459	10695	11	applied	\N	\N	1000000000	\N	95540	95540	263347
10459	10696	12	applied	\N	\N	\N	\N	95541	95541	263348
10459	10697	13	applied	\N	\N	\N	\N	95542	95542	263349
10461	10704	0	applied	\N	\N	\N	\N	95548	95548	263355
10461	10703	1	applied	\N	\N	\N	\N	95549	95549	263356
10461	10705	2	applied	\N	\N	\N	\N	95550	95550	263357
10461	10706	3	applied	\N	\N	\N	\N	95551	95551	263358
10461	10707	4	applied	\N	\N	\N	\N	95552	95552	263359
10465	10708	0	applied	\N	\N	\N	\N	95563	95563	263370
10465	10709	1	applied	\N	\N	\N	\N	95564	95564	263371
10465	10710	2	applied	\N	\N	\N	\N	95565	95565	263372
10465	10711	3	applied	\N	\N	\N	\N	95566	95566	263373
10465	10712	4	applied	\N	\N	\N	\N	95567	95567	263374
10465	10713	5	applied	\N	\N	\N	\N	95568	95568	263375
10465	10714	6	applied	\N	\N	\N	\N	95569	95569	263376
10466	10715	0	applied	\N	\N	\N	\N	95570	95570	263377
10466	10716	1	applied	\N	\N	\N	\N	95571	95571	263378
10466	10717	2	applied	\N	\N	\N	\N	95572	95572	263379
10466	10718	3	applied	\N	\N	\N	\N	95573	95573	263380
10466	10719	4	applied	\N	\N	\N	\N	95574	95574	263381
10466	10721	6	applied	\N	\N	1000000000	\N	95576	95576	263383
10466	10722	7	applied	\N	\N	\N	\N	95577	95577	263384
10466	10723	8	applied	\N	\N	\N	\N	95578	95578	263385
10471	10747	0	applied	\N	\N	\N	\N	95620	95620	263427
10471	10748	1	applied	\N	\N	\N	\N	95621	95621	263428
10476	10754	0	applied	\N	\N	\N	\N	95632	95632	263439
10476	10757	1	applied	\N	\N	\N	\N	95633	95633	263440
10476	10755	2	applied	\N	\N	\N	\N	95634	95634	263441
10476	10758	3	applied	\N	\N	\N	\N	95635	95635	263442
10476	10756	4	applied	\N	\N	\N	\N	95636	95636	263443
10485	10779	0	applied	\N	\N	\N	\N	95682	95682	263489
10485	10780	1	applied	\N	\N	\N	\N	95683	95683	263490
10492	10781	0	applied	\N	\N	\N	\N	95703	95703	263510
10492	10782	1	applied	\N	\N	\N	\N	95704	95704	263511
10492	10783	2	applied	\N	\N	\N	\N	95705	95705	263512
10421	10614	3	applied	\N	\N	\N	\N	95148	95148	262955
10421	10616	5	applied	\N	\N	\N	\N	95150	95150	262957
10428	10633	2	applied	\N	\N	\N	\N	95196	95196	263003
10428	10634	3	applied	\N	\N	\N	\N	95197	95197	263004
10428	10635	4	applied	\N	\N	\N	\N	95198	95198	263005
10428	10636	5	applied	\N	\N	\N	\N	95199	95199	263006
10428	10637	6	applied	\N	\N	\N	\N	95200	95200	263007
10428	10638	7	applied	\N	\N	\N	\N	95201	95201	263008
10428	10639	8	applied	\N	\N	\N	\N	95202	95202	263009
10428	10641	10	applied	\N	\N	\N	\N	95204	95204	263011
10428	10642	11	applied	\N	\N	\N	\N	95205	95205	263012
10428	10643	12	applied	\N	\N	\N	\N	95206	95206	263013
10428	10644	13	applied	\N	\N	\N	\N	95207	95207	263014
10428	10645	14	applied	\N	\N	\N	\N	95208	95208	263015
10431	10648	0	applied	\N	\N	\N	\N	95214	95214	263021
10431	10649	1	applied	\N	\N	\N	\N	95215	95215	263022
10431	10650	2	applied	\N	\N	\N	\N	95216	95216	263023
10435	10651	0	applied	\N	\N	\N	\N	95226	95226	263033
10435	10652	1	applied	\N	\N	\N	\N	95227	95227	263034
10437	10653	0	applied	\N	\N	\N	\N	95230	95230	263037
10437	10654	1	applied	\N	\N	\N	\N	95231	95231	263038
10437	10655	2	applied	\N	\N	\N	\N	95232	95232	263039
10437	10656	3	applied	\N	\N	\N	\N	95233	95233	263040
10440	10664	0	applied	\N	\N	\N	\N	95241	95241	263048
10440	10665	1	applied	\N	\N	\N	\N	95242	95242	263049
10440	10667	3	applied	\N	\N	\N	\N	95244	95244	263051
10440	10668	4	applied	\N	\N	\N	\N	95245	95245	263052
10445	10675	0	applied	\N	\N	1000000000	\N	95257	95257	263064
10445	10676	1	applied	\N	\N	\N	\N	95258	95258	263065
10445	10677	2	applied	\N	\N	\N	\N	95259	95259	263066
10445	10678	3	applied	\N	\N	\N	\N	95260	95260	263067
10445	10679	4	applied	\N	\N	\N	\N	95261	95261	263068
10445	10680	5	applied	\N	\N	\N	\N	95262	95262	263069
10445	10681	6	applied	\N	\N	\N	\N	95263	95263	263070
10445	10682	7	applied	\N	\N	\N	\N	95264	95264	263071
10445	10683	8	applied	\N	\N	\N	\N	95265	95265	263072
10445	10684	9	applied	\N	\N	\N	\N	95266	95266	263073
10447	10522	0	applied	\N	\N	\N	\N	95277	95277	263084
10447	10536	1	applied	\N	\N	\N	\N	95278	95278	263085
10447	10537	2	applied	\N	\N	\N	\N	95279	95279	263086
10447	10538	3	applied	\N	\N	\N	\N	95280	95280	263087
10447	10253	5	applied	\N	\N	1000000000	\N	95282	95282	263089
10447	10109	6	applied	\N	\N	\N	\N	95283	95283	263090
10447	10515	7	applied	\N	\N	1000000000	\N	95284	95284	263091
10447	10546	8	applied	\N	\N	\N	\N	95285	95285	263092
10447	10066	9	applied	\N	\N	\N	\N	95286	95286	263093
10447	10067	10	applied	\N	\N	\N	\N	95287	95287	263094
10447	10082	11	applied	\N	\N	\N	\N	95288	95288	263095
10447	10192	12	applied	\N	\N	\N	\N	95289	95289	263096
10447	10114	13	applied	\N	\N	\N	\N	95290	95290	263097
10447	10314	14	applied	\N	\N	\N	\N	95291	95291	263098
10447	10449	15	applied	\N	\N	\N	\N	95292	95292	263099
10447	10315	16	applied	\N	\N	\N	\N	95293	95293	263100
10447	10316	17	applied	\N	\N	\N	\N	95294	95294	263101
10447	10317	18	applied	\N	\N	\N	\N	95295	95295	263102
10447	10115	19	applied	\N	\N	\N	\N	95296	95296	263103
10447	10116	20	applied	\N	\N	\N	\N	95297	95297	263104
10447	10083	22	applied	\N	\N	\N	\N	95299	95299	263106
10447	10337	23	applied	\N	\N	\N	\N	95300	95300	263107
10447	10453	24	applied	\N	\N	\N	\N	95301	95301	263108
10447	10084	25	applied	\N	\N	\N	\N	95302	95302	263109
10447	10085	26	applied	\N	\N	\N	\N	95303	95303	263110
10447	10454	27	applied	\N	\N	\N	\N	95304	95304	263111
10447	10455	28	applied	\N	\N	\N	\N	95305	95305	263112
10447	10345	29	applied	\N	\N	\N	\N	95306	95306	263113
10447	10354	30	applied	\N	\N	\N	\N	95307	95307	263114
10447	10372	31	applied	\N	\N	\N	\N	95308	95308	263115
10447	10378	32	applied	\N	\N	\N	\N	95309	95309	263116
10447	10385	33	applied	\N	\N	\N	\N	95310	95310	263117
10447	10143	34	applied	\N	\N	\N	\N	95311	95311	263118
10447	10527	35	applied	\N	\N	\N	\N	95312	95312	263119
10447	10672	36	applied	\N	\N	\N	\N	95313	95313	263120
10447	10040	38	applied	\N	\N	\N	\N	95315	95315	263122
10447	10043	39	applied	\N	\N	\N	\N	95316	95316	263123
10447	10076	41	applied	\N	\N	\N	\N	95318	95318	263125
10447	10044	42	applied	\N	\N	\N	\N	95319	95319	263126
10447	10568	43	applied	\N	\N	1000000000	\N	95320	95320	263127
10447	10051	44	applied	\N	\N	\N	\N	95321	95321	263128
10447	10589	45	applied	\N	\N	\N	\N	95322	95322	263129
10447	10068	46	applied	\N	\N	\N	\N	95323	95323	263130
10447	10281	47	applied	\N	\N	\N	\N	95324	95324	263131
10447	10282	48	applied	\N	\N	\N	\N	95325	95325	263132
10447	10283	49	applied	\N	\N	\N	\N	95326	95326	263133
10447	10284	50	applied	\N	\N	\N	\N	95327	95327	263134
10447	10285	51	applied	\N	\N	\N	\N	95328	95328	263135
10447	10286	52	applied	\N	\N	\N	\N	95329	95329	263136
10447	10287	53	applied	\N	\N	\N	\N	95330	95330	263137
10447	10479	54	applied	\N	\N	\N	\N	95331	95331	263138
10447	10366	55	applied	\N	\N	\N	\N	95332	95332	263139
10447	10402	56	applied	\N	\N	\N	\N	95333	95333	263140
10447	10666	58	applied	\N	\N	\N	\N	95335	95335	263142
10447	10598	59	applied	\N	\N	\N	\N	95336	95336	263143
10447	10605	60	applied	\N	\N	\N	\N	95337	95337	263144
10447	10039	61	applied	\N	\N	\N	\N	95338	95338	263145
10447	10041	62	applied	\N	\N	\N	\N	95339	95339	263146
10447	10071	63	applied	\N	\N	\N	\N	95340	95340	263147
10447	10072	64	applied	\N	\N	\N	\N	95341	95341	263148
10447	10073	65	applied	\N	\N	\N	\N	95342	95342	263149
10447	10649	66	applied	\N	\N	\N	\N	95343	95343	263150
10447	10653	67	applied	\N	\N	\N	\N	95344	95344	263151
10447	10042	68	applied	\N	\N	\N	\N	95345	95345	263152
10447	10292	69	applied	\N	\N	\N	\N	95346	95346	263153
10447	10146	70	applied	\N	\N	\N	\N	95347	95347	263154
10447	10147	71	applied	\N	\N	\N	\N	95348	95348	263155
10447	10053	72	applied	\N	\N	\N	\N	95349	95349	263156
10447	10061	73	applied	\N	\N	\N	\N	95350	95350	263157
10447	10050	76	applied	\N	\N	\N	\N	95352	95352	263159
10447	10052	77	applied	\N	\N	\N	\N	95353	95353	263160
10447	10094	78	applied	\N	\N	\N	\N	95354	95354	263161
10447	10099	79	applied	\N	\N	\N	\N	95355	95355	263162
10428	10631	0	applied	\N	\N	\N	\N	95194	95194	263001
10428	10632	1	applied	\N	\N	\N	\N	95195	95195	263002
10447	10148	83	applied	\N	\N	\N	\N	95359	95359	263166
10447	10149	84	applied	\N	\N	\N	\N	95360	95360	263167
10447	10150	85	applied	\N	\N	\N	\N	95361	95361	263168
10447	10054	87	applied	\N	\N	\N	\N	95363	95363	263170
10447	10055	88	applied	\N	\N	\N	\N	95364	95364	263171
10447	10056	89	applied	\N	\N	\N	\N	95365	95365	263172
10447	10074	90	applied	\N	\N	\N	\N	95366	95366	263173
10447	10077	91	applied	\N	\N	\N	\N	95367	95367	263174
10447	10079	92	applied	\N	\N	\N	\N	95368	95368	263175
10447	10086	93	applied	\N	\N	\N	\N	95369	95369	263176
10447	10087	94	applied	\N	\N	\N	\N	95370	95370	263177
10447	10088	95	applied	\N	\N	\N	\N	95371	95371	263178
10447	10092	96	applied	\N	\N	\N	\N	95372	95372	263179
10447	10097	97	applied	\N	\N	\N	\N	95373	95373	263180
10447	10101	98	applied	\N	\N	\N	\N	95374	95374	263181
10447	10103	99	applied	\N	\N	\N	\N	95375	95375	263182
10447	10062	100	applied	\N	\N	\N	\N	95376	95376	263183
10447	10336	101	applied	\N	\N	\N	\N	95377	95377	263184
10447	10369	102	applied	\N	\N	\N	\N	95378	95378	263185
10447	10406	104	applied	\N	\N	\N	\N	95380	95380	263187
10447	10107	105	applied	\N	\N	\N	\N	95381	95381	263188
10447	10112	106	applied	\N	\N	\N	\N	95382	95382	263189
10447	10113	107	applied	\N	\N	\N	\N	95383	95383	263190
10447	10152	108	applied	\N	\N	\N	\N	95384	95384	263191
10447	10153	109	applied	\N	\N	\N	\N	95385	95385	263192
10447	10357	110	applied	\N	\N	\N	\N	95386	95386	263193
10447	10358	111	applied	\N	\N	\N	\N	95387	95387	263194
10447	10359	112	applied	\N	\N	\N	\N	95388	95388	263195
10447	10360	113	applied	\N	\N	\N	\N	95389	95389	263196
10447	10361	114	applied	\N	\N	\N	\N	95390	95390	263197
10447	10362	115	applied	\N	\N	\N	\N	95391	95391	263198
10447	10154	116	applied	\N	\N	\N	\N	95392	95392	263199
10447	10119	117	applied	\N	\N	\N	\N	95393	95393	263200
10447	10121	118	applied	\N	\N	\N	\N	95394	95394	263201
10447	10122	119	applied	\N	\N	\N	\N	95395	95395	263202
10447	10127	121	applied	\N	\N	\N	\N	95397	95397	263204
10447	10130	122	applied	\N	\N	\N	\N	95398	95398	263205
10447	10131	123	applied	\N	\N	\N	\N	95399	95399	263206
10447	10133	124	applied	\N	\N	\N	\N	95400	95400	263207
10447	10136	125	applied	\N	\N	\N	\N	95401	95401	263208
10453	10685	0	applied	\N	\N	\N	\N	95467	95467	263274
10453	10686	2	applied	\N	\N	\N	\N	95468	95468	263275
10453	10687	3	applied	\N	\N	\N	\N	95469	95469	263276
10453	10688	4	applied	\N	\N	\N	\N	95470	95470	263277
10453	10689	5	applied	\N	\N	\N	\N	95471	95471	263278
10453	10690	6	applied	\N	\N	\N	\N	95472	95472	263279
10453	10691	7	applied	\N	\N	\N	\N	95473	95473	263280
10453	10692	8	applied	\N	\N	\N	\N	95474	95474	263281
10453	10693	9	applied	\N	\N	1000000000	\N	95475	95475	263282
10453	10695	11	applied	\N	\N	1000000000	\N	95477	95477	263284
10453	10696	12	applied	\N	\N	\N	\N	95478	95478	263285
10453	10697	13	applied	\N	\N	\N	\N	95479	95479	263286
10454	10685	0	applied	\N	\N	\N	\N	95480	95480	263287
10454	10686	2	applied	\N	\N	\N	\N	95481	95481	263288
10454	10687	3	applied	\N	\N	\N	\N	95482	95482	263289
10454	10688	4	applied	\N	\N	\N	\N	95483	95483	263290
10454	10689	5	applied	\N	\N	\N	\N	95484	95484	263291
10454	10690	6	applied	\N	\N	\N	\N	95485	95485	263292
10456	10685	0	applied	\N	\N	\N	\N	95506	95506	263313
10456	10686	2	applied	\N	\N	\N	\N	95507	95507	263314
10456	10687	3	applied	\N	\N	\N	\N	95508	95508	263315
10456	10688	4	applied	\N	\N	\N	\N	95509	95509	263316
10456	10689	5	applied	\N	\N	\N	\N	95510	95510	263317
10456	10690	6	applied	\N	\N	\N	\N	95511	95511	263318
10456	10691	7	applied	\N	\N	\N	\N	95512	95512	263319
10456	10692	8	applied	\N	\N	\N	\N	95513	95513	263320
10456	10693	9	applied	\N	\N	1000000000	\N	95514	95514	263321
10456	10695	11	applied	\N	\N	1000000000	\N	95516	95516	263323
10456	10696	12	applied	\N	\N	\N	\N	95517	95517	263324
10456	10697	13	applied	\N	\N	\N	\N	95518	95518	263325
10458	10698	0	applied	\N	\N	\N	\N	95525	95525	263332
10458	10699	1	applied	\N	\N	\N	\N	95526	95526	263333
10458	10700	2	applied	\N	\N	\N	\N	95527	95527	263334
10458	10701	3	applied	\N	\N	\N	\N	95528	95528	263335
10458	10702	4	applied	\N	\N	\N	\N	95529	95529	263336
10473	10749	0	applied	\N	\N	\N	\N	95624	95624	263431
10473	10750	1	applied	\N	\N	\N	\N	95625	95625	263432
10473	10751	2	applied	\N	\N	\N	\N	95626	95626	263433
10478	10759	0	applied	\N	\N	1000000000	\N	95642	95642	263449
10478	10756	1	applied	\N	\N	\N	\N	95643	95643	263450
10482	10764	0	applied	\N	\N	\N	\N	95658	95658	263465
10482	10765	1	applied	\N	\N	\N	\N	95659	95659	263466
10482	10766	2	applied	\N	\N	\N	\N	95660	95660	263467
10482	10767	3	applied	\N	\N	\N	\N	95661	95661	263468
10482	10768	4	applied	\N	\N	\N	\N	95662	95662	263469
10482	10769	5	applied	\N	\N	\N	\N	95663	95663	263470
10488	10779	0	applied	\N	\N	\N	\N	95688	95688	263495
10494	10781	0	applied	\N	\N	\N	\N	95747	95747	263554
10494	10782	1	applied	\N	\N	\N	\N	95748	95748	263555
10494	10783	2	applied	\N	\N	\N	\N	95749	95749	263556
10494	10784	3	applied	\N	\N	\N	\N	95750	95750	263557
10494	10785	4	applied	\N	\N	\N	\N	95751	95751	263558
10494	10786	5	applied	\N	\N	\N	\N	95752	95752	263559
10494	10787	6	applied	\N	\N	\N	\N	95753	95753	263560
10494	10788	7	applied	\N	\N	\N	\N	95754	95754	263561
10494	10789	8	applied	\N	\N	\N	\N	95755	95755	263562
10494	10790	9	applied	\N	\N	\N	\N	95756	95756	263563
10494	10791	10	applied	\N	\N	\N	\N	95757	95757	263564
10494	10792	11	applied	\N	\N	\N	\N	95758	95758	263565
10494	10793	12	applied	\N	\N	\N	\N	95759	95759	263566
10494	10794	13	applied	\N	\N	\N	\N	95760	95760	263567
10494	10795	14	applied	\N	\N	\N	\N	95761	95761	263568
10494	10796	15	applied	\N	\N	\N	\N	95762	95762	263569
10494	10798	17	applied	\N	\N	\N	\N	95764	95764	263571
10494	10799	18	applied	\N	\N	\N	\N	95765	95765	263572
10494	10800	19	applied	\N	\N	\N	\N	95766	95766	263573
10494	10801	20	applied	\N	\N	\N	\N	95767	95767	263574
10494	10802	21	applied	\N	\N	\N	\N	95768	95768	263575
10496	10804	0	applied	\N	\N	\N	\N	95770	95770	263577
10447	10611	81	applied	\N	\N	\N	\N	95357	95357	263164
10447	10612	82	applied	\N	\N	\N	\N	95358	95358	263165
10454	10694	10	applied	\N	\N	1000000000	\N	95489	95489	263296
10454	10695	11	applied	\N	\N	1000000000	\N	95490	95490	263297
10454	10696	12	applied	\N	\N	\N	\N	95491	95491	263298
10454	10697	13	applied	\N	\N	\N	\N	95492	95492	263299
10460	10698	0	applied	\N	\N	\N	\N	95543	95543	263350
10460	10699	1	applied	\N	\N	\N	\N	95544	95544	263351
10460	10700	2	applied	\N	\N	\N	\N	95545	95545	263352
10460	10702	4	applied	\N	\N	\N	\N	95547	95547	263354
10462	10698	0	applied	\N	\N	\N	\N	95553	95553	263360
10462	10699	1	applied	\N	\N	\N	\N	95554	95554	263361
10462	10700	2	applied	\N	\N	\N	\N	95555	95555	263362
10462	10701	3	applied	\N	\N	\N	\N	95556	95556	263363
10462	10702	4	applied	\N	\N	\N	\N	95557	95557	263364
10467	10715	0	applied	\N	\N	\N	\N	95579	95579	263386
10467	10716	1	applied	\N	\N	\N	\N	95580	95580	263387
10467	10717	2	applied	\N	\N	\N	\N	95581	95581	263388
10467	10718	3	applied	\N	\N	\N	\N	95582	95582	263389
10467	10719	4	applied	\N	\N	\N	\N	95583	95583	263390
10467	10720	5	applied	\N	\N	\N	\N	95584	95584	263391
10467	10721	6	applied	\N	\N	1000000000	\N	95585	95585	263392
10467	10722	7	applied	\N	\N	\N	\N	95586	95586	263393
10467	10723	8	applied	\N	\N	\N	\N	95587	95587	263394
10469	10724	0	applied	\N	\N	\N	\N	95597	95597	263404
10469	10726	2	applied	\N	\N	\N	\N	95599	95599	263406
10469	10727	3	applied	\N	\N	\N	\N	95600	95600	263407
10472	10747	0	applied	\N	\N	\N	\N	95622	95622	263429
10472	10748	1	applied	\N	\N	\N	\N	95623	95623	263430
10474	10752	0	applied	\N	\N	\N	\N	95627	95627	263434
10474	10753	1	applied	\N	\N	\N	\N	95628	95628	263435
10477	10759	0	applied	\N	\N	1000000000	\N	95637	95637	263444
10477	10757	1	applied	\N	\N	\N	\N	95638	95638	263445
10477	10760	2	applied	\N	\N	\N	\N	95639	95639	263446
10477	10758	3	applied	\N	\N	\N	\N	95640	95640	263447
10477	10761	4	applied	\N	\N	\N	\N	95641	95641	263448
10479	10762	0	applied	\N	\N	\N	\N	95644	95644	263451
10479	10763	1	applied	\N	\N	\N	\N	95645	95645	263452
10480	10764	0	applied	\N	\N	\N	\N	95646	95646	263453
10480	10765	1	applied	\N	\N	\N	\N	95647	95647	263454
10480	10766	2	applied	\N	\N	\N	\N	95648	95648	263455
10480	10768	4	applied	\N	\N	\N	\N	95650	95650	263457
10480	10769	5	applied	\N	\N	\N	\N	95651	95651	263458
10481	10769	5	applied	\N	\N	\N	\N	95657	95657	263464
10483	10770	0	applied	\N	\N	\N	\N	95664	95664	263471
10483	10771	1	applied	\N	\N	\N	\N	95665	95665	263472
10483	10772	2	applied	\N	\N	\N	\N	95666	95666	263473
10483	10773	3	applied	\N	\N	\N	\N	95667	95667	263474
10483	10774	4	applied	\N	\N	\N	\N	95668	95668	263475
10483	10775	5	applied	\N	\N	\N	\N	95669	95669	263476
10483	10776	6	applied	\N	\N	\N	\N	95670	95670	263477
10483	10777	7	applied	\N	\N	\N	\N	95671	95671	263478
10483	10778	8	applied	\N	\N	\N	\N	95672	95672	263479
10484	10770	0	applied	\N	\N	\N	\N	95673	95673	263480
10484	10771	1	applied	\N	\N	\N	\N	95674	95674	263481
10484	10772	2	applied	\N	\N	\N	\N	95675	95675	263482
10484	10773	3	applied	\N	\N	\N	\N	95676	95676	263483
10486	10779	0	applied	\N	\N	\N	\N	95684	95684	263491
10486	10780	1	applied	\N	\N	\N	\N	95685	95685	263492
10489	10779	0	applied	\N	\N	\N	\N	95690	95690	263497
10489	10780	1	applied	\N	\N	\N	\N	95691	95691	263498
10493	10781	0	applied	\N	\N	\N	\N	95725	95725	263532
10493	10782	1	applied	\N	\N	\N	\N	95726	95726	263533
10493	10783	2	applied	\N	\N	\N	\N	95727	95727	263534
10493	10784	3	applied	\N	\N	\N	\N	95728	95728	263535
10493	10785	4	applied	\N	\N	\N	\N	95729	95729	263536
10493	10786	5	applied	\N	\N	\N	\N	95730	95730	263537
10493	10787	6	applied	\N	\N	\N	\N	95731	95731	263538
10493	10788	7	applied	\N	\N	\N	\N	95732	95732	263539
10493	10789	8	applied	\N	\N	\N	\N	95733	95733	263540
10493	10790	9	applied	\N	\N	\N	\N	95734	95734	263541
10493	10791	10	applied	\N	\N	\N	\N	95735	95735	263542
10493	10792	11	applied	\N	\N	\N	\N	95736	95736	263543
10493	10794	13	applied	\N	\N	\N	\N	95738	95738	263545
10493	10795	14	applied	\N	\N	\N	\N	95739	95739	263546
10493	10796	15	applied	\N	\N	\N	\N	95740	95740	263547
10493	10797	16	applied	\N	\N	\N	\N	95741	95741	263548
10493	10798	17	applied	\N	\N	\N	\N	95742	95742	263549
10493	10799	18	applied	\N	\N	\N	\N	95743	95743	263550
10493	10800	19	applied	\N	\N	\N	\N	95744	95744	263551
10493	10801	20	applied	\N	\N	\N	\N	95745	95745	263552
10493	10802	21	applied	\N	\N	\N	\N	95746	95746	263553
10495	10803	0	applied	\N	\N	\N	\N	95769	95769	263576
10502	10817	0	applied	\N	\N	\N	\N	95827	95827	263634
10502	10818	1	applied	\N	\N	\N	\N	95828	95828	263635
10502	10819	2	applied	\N	\N	\N	\N	95829	95829	263636
10502	10820	3	applied	\N	\N	\N	\N	95830	95830	263637
10506	10823	0	applied	\N	\N	\N	\N	95844	95844	263651
10506	10824	1	applied	\N	\N	\N	\N	95845	95845	263652
10506	10826	3	applied	\N	\N	\N	\N	95847	95847	263654
10506	10827	4	applied	\N	\N	\N	\N	95848	95848	263655
10506	10828	5	applied	\N	\N	\N	\N	95849	95849	263656
10506	10829	6	applied	\N	\N	\N	\N	95850	95850	263657
10506	10830	7	applied	\N	\N	\N	\N	95851	95851	263658
10506	10831	8	applied	\N	\N	\N	\N	95852	95852	263659
10511	10833	0	applied	\N	\N	\N	\N	95867	95867	263674
10511	10832	1	applied	\N	\N	\N	\N	95868	95868	263675
10515	10834	0	applied	\N	\N	\N	\N	95881	95881	263688
10515	10835	1	applied	\N	\N	\N	\N	95882	95882	263689
10515	10836	2	applied	\N	\N	\N	\N	95883	95883	263690
10515	10837	3	applied	\N	\N	\N	\N	95884	95884	263691
10515	10838	4	applied	\N	\N	\N	\N	95885	95885	263692
10515	10839	5	applied	\N	\N	\N	\N	95886	95886	263693
10517	10842	0	applied	\N	\N	\N	\N	95889	95889	263696
10517	10843	1	applied	\N	\N	\N	\N	95890	95890	263697
10519	10843	1	applied	\N	\N	\N	\N	95894	95894	263701
10522	10846	0	applied	\N	\N	\N	\N	95901	95901	263708
10522	10847	1	applied	\N	\N	\N	\N	95902	95902	263709
10522	10848	2	applied	\N	\N	\N	\N	95903	95903	263710
10522	10849	3	applied	\N	\N	\N	\N	95904	95904	263711
10527	10823	0	applied	\N	\N	\N	\N	95929	95929	263736
10454	10692	8	applied	\N	\N	\N	\N	95487	95487	263294
10454	10693	9	applied	\N	\N	1000000000	\N	95488	95488	263295
10487	10779	0	applied	\N	\N	\N	\N	95686	95686	263493
10487	10780	1	applied	\N	\N	\N	\N	95687	95687	263494
10490	10770	0	applied	\N	\N	\N	\N	95692	95692	263499
10490	10771	1	applied	\N	\N	\N	\N	95693	95693	263500
10490	10772	2	applied	\N	\N	\N	\N	95694	95694	263501
10490	10773	3	applied	\N	\N	\N	\N	95695	95695	263502
10490	10774	4	applied	\N	\N	\N	\N	95696	95696	263503
10490	10775	5	applied	\N	\N	\N	\N	95697	95697	263504
10490	10779	6	applied	\N	\N	\N	\N	95698	95698	263505
10490	10776	7	applied	\N	\N	\N	\N	95699	95699	263506
10490	10777	8	applied	\N	\N	\N	\N	95700	95700	263507
10490	10778	9	applied	\N	\N	\N	\N	95701	95701	263508
10490	10780	10	applied	\N	\N	\N	\N	95702	95702	263509
10492	10784	3	applied	\N	\N	\N	\N	95706	95706	263513
10492	10786	5	applied	\N	\N	\N	\N	95708	95708	263515
10492	10787	6	applied	\N	\N	\N	\N	95709	95709	263516
10492	10788	7	applied	\N	\N	\N	\N	95710	95710	263517
10492	10789	8	applied	\N	\N	\N	\N	95711	95711	263518
10498	10804	0	applied	\N	\N	\N	\N	95792	95792	263599
10498	10805	1	applied	\N	\N	\N	\N	95793	95793	263600
10498	10806	2	applied	\N	\N	\N	\N	95794	95794	263601
10498	10807	3	applied	\N	\N	\N	\N	95795	95795	263602
10498	10808	4	applied	\N	\N	\N	\N	95796	95796	263603
10498	10809	5	applied	\N	\N	\N	\N	95797	95797	263604
10498	10810	6	applied	\N	\N	\N	\N	95798	95798	263605
10498	10811	7	applied	\N	\N	\N	\N	95799	95799	263606
10498	10812	8	applied	\N	\N	\N	\N	95800	95800	263607
10498	10813	9	applied	\N	\N	\N	\N	95801	95801	263608
10498	10814	10	applied	\N	\N	\N	\N	95802	95802	263609
10500	10804	0	applied	\N	\N	\N	\N	95814	95814	263621
10500	10806	2	applied	\N	\N	\N	\N	95816	95816	263623
10500	10807	3	applied	\N	\N	\N	\N	95817	95817	263624
10500	10808	4	applied	\N	\N	\N	\N	95818	95818	263625
10500	10809	5	applied	\N	\N	\N	\N	95819	95819	263626
10500	10810	6	applied	\N	\N	\N	\N	95820	95820	263627
10500	10811	7	applied	\N	\N	\N	\N	95821	95821	263628
10500	10812	8	applied	\N	\N	\N	\N	95822	95822	263629
10500	10813	9	applied	\N	\N	\N	\N	95823	95823	263630
10500	10814	10	applied	\N	\N	\N	\N	95824	95824	263631
10508	10832	0	applied	\N	\N	\N	\N	95862	95862	263669
10523	10846	0	applied	\N	\N	\N	\N	95905	95905	263712
10523	10847	1	applied	\N	\N	\N	\N	95906	95906	263713
10523	10848	2	applied	\N	\N	\N	\N	95907	95907	263714
10523	10849	3	applied	\N	\N	\N	\N	95908	95908	263715
10525	10850	0	applied	\N	\N	\N	\N	95913	95913	263720
10525	10851	1	applied	\N	\N	\N	\N	95914	95914	263721
10525	10853	3	applied	\N	\N	\N	\N	95916	95916	263723
10525	10854	4	applied	\N	\N	\N	\N	95917	95917	263724
10525	10855	5	applied	\N	\N	\N	\N	95918	95918	263725
10525	10856	6	applied	\N	\N	\N	\N	95919	95919	263726
10525	10857	7	applied	\N	\N	\N	\N	95920	95920	263727
10530	10862	0	applied	\N	\N	\N	\N	95976	95976	263783
10530	10863	1	applied	\N	\N	\N	\N	95977	95977	263784
10530	10864	2	applied	\N	\N	1000000000	\N	95978	95978	263785
10530	10865	3	applied	\N	\N	\N	\N	95979	95979	263786
10533	10870	0	applied	\N	\N	\N	\N	95988	95988	263795
10533	10871	1	applied	\N	\N	\N	\N	95989	95989	263796
10533	10872	2	applied	\N	\N	\N	\N	95990	95990	263797
10533	10873	3	applied	\N	\N	\N	\N	95991	95991	263798
10533	10874	5	applied	\N	\N	\N	\N	95992	95992	263799
10538	10881	0	applied	\N	\N	\N	\N	96001	96001	263808
10538	10882	1	applied	\N	\N	\N	\N	96002	96002	263809
10544	10889	1	applied	\N	\N	\N	\N	96015	96015	263822
10547	10890	0	applied	\N	\N	\N	\N	96022	96022	263829
10547	10891	1	applied	\N	\N	\N	\N	96023	96023	263830
10547	10892	2	applied	\N	\N	\N	\N	96024	96024	263831
10547	10893	3	applied	\N	\N	\N	\N	96025	96025	263832
10547	10894	4	applied	\N	\N	\N	\N	96026	96026	263833
10553	10900	0	applied	\N	\N	\N	\N	96088	96088	263895
10553	10901	1	applied	\N	\N	\N	\N	96089	96089	263896
10553	10902	2	applied	\N	\N	\N	\N	96090	96090	263897
10553	10903	3	applied	\N	\N	\N	\N	96091	96091	263898
10553	10897	4	applied	\N	\N	\N	\N	96092	96092	263899
10553	10898	5	applied	\N	\N	\N	\N	96093	96093	263900
10553	10899	6	applied	\N	\N	\N	\N	96094	96094	263901
10555	10900	0	applied	\N	\N	\N	\N	96097	96097	263904
10555	10901	1	applied	\N	\N	\N	\N	96098	96098	263905
10555	10902	2	applied	\N	\N	\N	\N	96099	96099	263906
10555	10905	4	applied	\N	\N	\N	\N	96101	96101	263908
10555	10897	5	applied	\N	\N	\N	\N	96102	96102	263909
10555	10898	6	applied	\N	\N	\N	\N	96103	96103	263910
10555	10899	7	applied	\N	\N	\N	\N	96104	96104	263911
10555	10904	8	applied	\N	\N	\N	\N	96105	96105	263912
10557	10906	0	applied	\N	\N	\N	\N	96109	96109	263916
10557	10907	1	applied	\N	\N	\N	\N	96110	96110	263917
10557	10908	2	applied	\N	\N	\N	\N	96111	96111	263918
10557	10909	3	applied	\N	\N	\N	\N	96112	96112	263919
10563	10916	0	applied	\N	\N	\N	\N	96246	96246	264053
10563	10917	1	applied	\N	\N	\N	\N	96247	96247	264054
10563	10918	2	applied	\N	\N	\N	\N	96248	96248	264055
10563	10919	3	applied	\N	\N	\N	\N	96249	96249	264056
10565	10922	0	applied	\N	\N	\N	\N	96252	96252	264059
10565	10923	1	applied	\N	\N	\N	\N	96253	96253	264060
10567	10922	0	applied	\N	\N	\N	\N	96256	96256	264063
10569	10922	0	applied	\N	\N	\N	\N	96260	96260	264067
10569	10923	1	applied	\N	\N	\N	\N	96261	96261	264068
10574	10929	0	applied	\N	\N	\N	\N	96271	96271	264078
10574	10930	1	applied	\N	\N	\N	\N	96272	96272	264079
10574	10931	2	applied	\N	\N	\N	\N	96273	96273	264080
10577	10935	0	applied	\N	\N	\N	\N	96279	96279	264086
10577	10936	1	applied	\N	\N	\N	\N	96280	96280	264087
10580	10945	0	applied	\N	\N	\N	\N	96289	96289	264096
10580	10946	1	applied	\N	\N	\N	\N	96290	96290	264097
10583	10947	0	applied	\N	\N	\N	\N	96295	96295	264102
10583	10948	1	applied	\N	\N	\N	\N	96296	96296	264103
10585	10947	0	applied	\N	\N	\N	\N	96299	96299	264106
10585	10948	1	applied	\N	\N	\N	\N	96300	96300	264107
10587	10951	0	applied	\N	\N	\N	\N	96303	96303	264110
10587	10952	1	applied	\N	\N	\N	\N	96304	96304	264111
10590	10955	0	applied	\N	\N	\N	\N	96307	96307	264114
10484	10778	8	applied	\N	\N	\N	\N	95681	95681	263488
10492	10794	13	applied	\N	\N	\N	\N	95716	95716	263523
10492	10795	14	applied	\N	\N	\N	\N	95717	95717	263524
10492	10796	15	applied	\N	\N	\N	\N	95718	95718	263525
10492	10797	16	applied	\N	\N	\N	\N	95719	95719	263526
10492	10798	17	applied	\N	\N	\N	\N	95720	95720	263527
10492	10799	18	applied	\N	\N	\N	\N	95721	95721	263528
10492	10800	19	applied	\N	\N	\N	\N	95722	95722	263529
10492	10801	20	applied	\N	\N	\N	\N	95723	95723	263530
10492	10802	21	applied	\N	\N	\N	\N	95724	95724	263531
10496	10805	1	applied	\N	\N	\N	\N	95771	95771	263578
10496	10806	2	applied	\N	\N	\N	\N	95772	95772	263579
10496	10807	3	applied	\N	\N	\N	\N	95773	95773	263580
10496	10808	4	applied	\N	\N	\N	\N	95774	95774	263581
10496	10809	5	applied	\N	\N	\N	\N	95775	95775	263582
10497	10804	0	applied	\N	\N	\N	\N	95781	95781	263588
10497	10805	1	applied	\N	\N	\N	\N	95782	95782	263589
10497	10806	2	applied	\N	\N	\N	\N	95783	95783	263590
10497	10807	3	applied	\N	\N	\N	\N	95784	95784	263591
10497	10808	4	applied	\N	\N	\N	\N	95785	95785	263592
10497	10809	5	applied	\N	\N	\N	\N	95786	95786	263593
10497	10810	6	applied	\N	\N	\N	\N	95787	95787	263594
10497	10811	7	applied	\N	\N	\N	\N	95788	95788	263595
10497	10812	8	applied	\N	\N	\N	\N	95789	95789	263596
10497	10813	9	applied	\N	\N	\N	\N	95790	95790	263597
10497	10814	10	applied	\N	\N	\N	\N	95791	95791	263598
10499	10804	0	applied	\N	\N	\N	\N	95803	95803	263610
10499	10805	1	applied	\N	\N	\N	\N	95804	95804	263611
10499	10806	2	applied	\N	\N	\N	\N	95805	95805	263612
10499	10807	3	applied	\N	\N	\N	\N	95806	95806	263613
10499	10808	4	applied	\N	\N	\N	\N	95807	95807	263614
10499	10810	6	applied	\N	\N	\N	\N	95809	95809	263616
10499	10811	7	applied	\N	\N	\N	\N	95810	95810	263617
10499	10812	8	applied	\N	\N	\N	\N	95811	95811	263618
10499	10813	9	applied	\N	\N	\N	\N	95812	95812	263619
10499	10814	10	applied	\N	\N	\N	\N	95813	95813	263620
10501	10815	0	applied	\N	\N	\N	\N	95825	95825	263632
10501	10816	1	applied	\N	\N	\N	\N	95826	95826	263633
10504	10821	0	applied	\N	\N	\N	\N	95833	95833	263640
10504	10822	1	applied	\N	\N	\N	\N	95834	95834	263641
10505	10823	0	applied	\N	\N	\N	\N	95835	95835	263642
10505	10824	1	applied	\N	\N	\N	\N	95836	95836	263643
10505	10825	2	applied	\N	\N	\N	\N	95837	95837	263644
10505	10826	3	applied	\N	\N	\N	\N	95838	95838	263645
10505	10827	4	applied	\N	\N	\N	\N	95839	95839	263646
10505	10828	5	applied	\N	\N	\N	\N	95840	95840	263647
10505	10829	6	applied	\N	\N	\N	\N	95841	95841	263648
10505	10831	8	applied	\N	\N	\N	\N	95843	95843	263650
10510	10833	0	applied	\N	\N	\N	\N	95865	95865	263672
10510	10832	1	applied	\N	\N	\N	\N	95866	95866	263673
10514	10834	0	applied	\N	\N	\N	\N	95875	95875	263682
10514	10835	1	applied	\N	\N	\N	\N	95876	95876	263683
10514	10836	2	applied	\N	\N	\N	\N	95877	95877	263684
10514	10837	3	applied	\N	\N	\N	\N	95878	95878	263685
10514	10838	4	applied	\N	\N	\N	\N	95879	95879	263686
10514	10839	5	applied	\N	\N	\N	\N	95880	95880	263687
10516	10840	0	applied	\N	\N	\N	\N	95887	95887	263694
10516	10841	1	applied	\N	\N	\N	\N	95888	95888	263695
10521	10846	0	applied	\N	\N	\N	\N	95897	95897	263704
10521	10847	1	applied	\N	\N	\N	\N	95898	95898	263705
10521	10848	2	applied	\N	\N	\N	\N	95899	95899	263706
10521	10849	3	applied	\N	\N	\N	\N	95900	95900	263707
10526	10850	0	applied	\N	\N	\N	\N	95921	95921	263728
10526	10852	2	applied	\N	\N	\N	\N	95923	95923	263730
10526	10853	3	applied	\N	\N	\N	\N	95924	95924	263731
10526	10854	4	applied	\N	\N	\N	\N	95925	95925	263732
10526	10855	5	applied	\N	\N	\N	\N	95926	95926	263733
10526	10856	6	applied	\N	\N	\N	\N	95927	95927	263734
10526	10857	7	applied	\N	\N	\N	\N	95928	95928	263735
10529	10858	0	applied	\N	\N	\N	\N	95972	95972	263779
10529	10859	1	applied	\N	\N	\N	\N	95973	95973	263780
10529	10860	2	applied	\N	\N	\N	\N	95974	95974	263781
10529	10861	3	applied	\N	\N	\N	\N	95975	95975	263782
10532	10866	0	applied	\N	\N	\N	\N	95984	95984	263791
10532	10867	1	applied	\N	\N	\N	\N	95985	95985	263792
10532	10868	2	applied	\N	\N	\N	\N	95986	95986	263793
10532	10869	3	applied	\N	\N	\N	\N	95987	95987	263794
10534	10875	0	applied	\N	\N	\N	\N	95993	95993	263800
10534	10876	1	applied	\N	\N	\N	\N	95994	95994	263801
10539	10884	1	applied	\N	\N	\N	\N	96004	96004	263811
10539	10885	2	applied	\N	\N	1000000000	\N	96005	96005	263812
10542	10888	0	applied	\N	\N	\N	\N	96010	96010	263817
10542	10889	1	applied	\N	\N	\N	\N	96011	96011	263818
10545	10886	0	applied	\N	\N	\N	\N	96016	96016	263823
10545	10889	1	applied	\N	\N	\N	\N	96017	96017	263824
10545	10887	2	applied	\N	\N	\N	\N	96018	96018	263825
10545	10888	3	applied	\N	\N	\N	\N	96019	96019	263826
10556	10904	0	applied	\N	\N	\N	\N	96106	96106	263913
10556	10905	1	applied	\N	\N	\N	\N	96107	96107	263914
10556	10906	2	applied	\N	\N	\N	\N	96108	96108	263915
10559	10912	0	applied	\N	\N	\N	\N	96238	96238	264045
10559	10913	1	applied	\N	\N	\N	\N	96239	96239	264046
10564	10920	0	applied	\N	\N	\N	\N	96250	96250	264057
10564	10921	1	applied	\N	\N	\N	\N	96251	96251	264058
10571	10924	0	applied	\N	\N	\N	\N	96264	96264	264071
10573	10926	0	applied	\N	\N	\N	\N	96268	96268	264075
10573	10927	1	applied	\N	\N	\N	\N	96269	96269	264076
10573	10928	2	applied	\N	\N	\N	\N	96270	96270	264077
10576	10935	0	applied	\N	\N	\N	\N	96277	96277	264084
10576	10936	1	applied	\N	\N	\N	\N	96278	96278	264085
10579	10943	0	applied	\N	\N	\N	\N	96287	96287	264094
10579	10944	1	applied	\N	\N	\N	\N	96288	96288	264095
10584	10947	0	applied	\N	\N	\N	\N	96297	96297	264104
10584	10948	1	applied	\N	\N	\N	\N	96298	96298	264105
10588	10953	0	applied	\N	\N	\N	\N	96305	96305	264112
10588	10954	1	applied	\N	\N	\N	\N	96306	96306	264113
10591	10955	0	applied	\N	\N	\N	\N	96311	96311	264118
10591	10956	1	applied	\N	\N	\N	\N	96312	96312	264119
10591	10957	2	applied	\N	\N	\N	\N	96313	96313	264120
10591	10958	3	applied	\N	\N	\N	\N	96314	96314	264121
10593	10959	0	applied	\N	\N	\N	\N	96319	96319	264126
10492	10793	12	applied	\N	\N	\N	\N	95715	95715	263522
10496	10814	10	applied	\N	\N	\N	\N	95780	95780	263587
10503	10821	0	applied	\N	\N	\N	\N	95831	95831	263638
10503	10822	1	applied	\N	\N	\N	\N	95832	95832	263639
10507	10823	0	applied	\N	\N	\N	\N	95853	95853	263660
10507	10824	1	applied	\N	\N	\N	\N	95854	95854	263661
10507	10825	2	applied	\N	\N	\N	\N	95855	95855	263662
10507	10826	3	applied	\N	\N	\N	\N	95856	95856	263663
10507	10827	4	applied	\N	\N	\N	\N	95857	95857	263664
10507	10828	5	applied	\N	\N	\N	\N	95858	95858	263665
10507	10829	6	applied	\N	\N	\N	\N	95859	95859	263666
10507	10830	7	applied	\N	\N	\N	\N	95860	95860	263667
10507	10831	8	applied	\N	\N	\N	\N	95861	95861	263668
10509	10833	0	applied	\N	\N	\N	\N	95863	95863	263670
10512	10833	0	applied	\N	\N	\N	\N	95869	95869	263676
10512	10832	1	applied	\N	\N	\N	\N	95870	95870	263677
10513	10833	0	applied	\N	\N	\N	\N	95871	95871	263678
10513	10832	1	applied	\N	\N	\N	\N	95872	95872	263679
10513	10834	2	applied	\N	\N	\N	\N	95873	95873	263680
10513	10835	3	applied	\N	\N	\N	\N	95874	95874	263681
10518	10842	0	applied	\N	\N	\N	\N	95891	95891	263698
10518	10843	1	applied	\N	\N	\N	\N	95892	95892	263699
10520	10844	0	applied	\N	\N	\N	\N	95895	95895	263702
10520	10845	1	applied	\N	\N	\N	\N	95896	95896	263703
10524	10846	0	applied	\N	\N	\N	\N	95909	95909	263716
10524	10847	1	applied	\N	\N	\N	\N	95910	95910	263717
10524	10848	2	applied	\N	\N	\N	\N	95911	95911	263718
10524	10849	3	applied	\N	\N	\N	\N	95912	95912	263719
10527	10824	1	applied	\N	\N	\N	\N	95930	95930	263737
10527	10825	2	applied	\N	\N	\N	\N	95931	95931	263738
10527	10827	4	applied	\N	\N	\N	\N	95933	95933	263740
10527	10832	5	applied	\N	\N	\N	\N	95934	95934	263741
10527	10834	6	applied	\N	\N	\N	\N	95935	95935	263742
10528	10858	0	applied	\N	\N	\N	\N	95968	95968	263775
10528	10859	1	applied	\N	\N	\N	\N	95969	95969	263776
10528	10860	2	applied	\N	\N	\N	\N	95970	95970	263777
10528	10861	3	applied	\N	\N	\N	\N	95971	95971	263778
10531	10866	0	applied	\N	\N	\N	\N	95980	95980	263787
10531	10867	1	applied	\N	\N	\N	\N	95981	95981	263788
10531	10868	2	applied	\N	\N	\N	\N	95982	95982	263789
10531	10869	3	applied	\N	\N	\N	\N	95983	95983	263790
10536	10877	0	applied	\N	\N	\N	\N	95997	95997	263804
10536	10878	1	applied	\N	\N	\N	\N	95998	95998	263805
10541	10888	0	applied	\N	\N	\N	\N	96008	96008	263815
10541	10889	1	applied	\N	\N	\N	\N	96009	96009	263816
10548	10890	0	applied	\N	\N	\N	\N	96027	96027	263834
10548	10892	2	applied	\N	\N	\N	\N	96029	96029	263836
10548	10893	3	applied	\N	\N	\N	\N	96030	96030	263837
10548	10894	4	applied	\N	\N	\N	\N	96031	96031	263838
10550	10895	0	applied	\N	\N	\N	\N	96037	96037	263844
10550	10896	1	applied	\N	\N	\N	\N	96038	96038	263845
10551	10862	0	applied	\N	\N	\N	\N	96039	96039	263846
10551	10866	1	applied	\N	\N	\N	\N	96040	96040	263847
10551	10870	2	applied	\N	\N	\N	\N	96041	96041	263848
10551	10873	3	applied	\N	\N	\N	\N	96042	96042	263849
10551	10875	4	applied	\N	\N	\N	\N	96043	96043	263850
10551	10877	5	applied	\N	\N	\N	\N	96044	96044	263851
10551	10879	6	applied	\N	\N	\N	\N	96045	96045	263852
10551	10863	7	applied	\N	\N	\N	\N	96046	96046	263853
10551	10867	8	applied	\N	\N	\N	\N	96047	96047	263854
10551	10868	9	applied	\N	\N	\N	\N	96048	96048	263855
10551	10871	10	applied	\N	\N	\N	\N	96049	96049	263856
10551	10876	12	applied	\N	\N	\N	\N	96051	96051	263858
10551	10878	13	applied	\N	\N	\N	\N	96052	96052	263859
10551	10880	14	applied	\N	\N	\N	\N	96053	96053	263860
10551	10881	15	applied	\N	\N	\N	\N	96054	96054	263861
10551	10883	16	applied	\N	\N	\N	\N	96055	96055	263862
10551	10887	17	applied	\N	\N	\N	\N	96056	96056	263863
10551	10888	18	applied	\N	\N	\N	\N	96057	96057	263864
10551	10892	19	applied	\N	\N	\N	\N	96058	96058	263865
10551	10893	20	applied	\N	\N	\N	\N	96059	96059	263866
10551	10895	21	applied	\N	\N	\N	\N	96060	96060	263867
10551	10897	22	applied	\N	\N	\N	\N	96061	96061	263868
10551	10898	23	applied	\N	\N	\N	\N	96062	96062	263869
10551	10899	24	applied	\N	\N	\N	\N	96063	96063	263870
10551	10882	25	applied	\N	\N	\N	\N	96064	96064	263871
10551	10884	26	applied	\N	\N	\N	\N	96065	96065	263872
10551	10886	27	applied	\N	\N	\N	\N	96066	96066	263873
10551	10890	29	applied	\N	\N	\N	\N	96068	96068	263875
10551	10891	30	applied	\N	\N	\N	\N	96069	96069	263876
10551	10896	31	applied	\N	\N	\N	\N	96070	96070	263877
10551	10900	33	applied	\N	\N	\N	\N	96071	96071	263878
10551	10901	34	applied	\N	\N	\N	\N	96072	96072	263879
10551	10902	35	applied	\N	\N	\N	\N	96073	96073	263880
10551	10903	36	applied	\N	\N	\N	\N	96074	96074	263881
10551	10869	37	applied	\N	\N	\N	\N	96075	96075	263882
10551	10874	38	applied	\N	\N	\N	\N	96076	96076	263883
10551	10864	39	applied	\N	\N	1000000000	\N	96077	96077	263884
10551	10865	40	applied	\N	\N	\N	\N	96078	96078	263885
10551	10885	41	applied	\N	\N	1000000000	\N	96079	96079	263886
10551	10894	42	applied	\N	\N	\N	\N	96080	96080	263887
10561	10916	0	applied	\N	\N	\N	\N	96242	96242	264049
10561	10917	1	applied	\N	\N	\N	\N	96243	96243	264050
10566	10922	0	applied	\N	\N	\N	\N	96254	96254	264061
10568	10922	0	applied	\N	\N	\N	\N	96258	96258	264065
10568	10923	1	applied	\N	\N	\N	\N	96259	96259	264066
10570	10924	0	applied	\N	\N	\N	\N	96262	96262	264069
10570	10925	1	applied	\N	\N	\N	\N	96263	96263	264070
10572	10926	0	applied	\N	\N	\N	\N	96266	96266	264073
10572	10927	1	applied	\N	\N	\N	\N	96267	96267	264074
10575	10932	0	applied	\N	\N	\N	\N	96274	96274	264081
10575	10933	1	applied	\N	\N	\N	\N	96275	96275	264082
10575	10934	2	applied	\N	\N	\N	\N	96276	96276	264083
10578	10937	0	applied	\N	\N	\N	\N	96281	96281	264088
10578	10938	1	applied	\N	\N	\N	\N	96282	96282	264089
10578	10939	2	applied	\N	\N	\N	\N	96283	96283	264090
10578	10940	3	applied	\N	\N	\N	\N	96284	96284	264091
10578	10941	4	applied	\N	\N	\N	\N	96285	96285	264092
10578	10942	5	applied	\N	\N	\N	\N	96286	96286	264093
10581	10945	0	applied	\N	\N	\N	\N	96291	96291	264098
10496	10812	8	applied	\N	\N	\N	\N	95778	95778	263585
10496	10813	9	applied	\N	\N	\N	\N	95779	95779	263586
10527	10843	10	applied	\N	\N	\N	\N	95939	95939	263746
10527	10845	11	applied	\N	\N	\N	\N	95940	95940	263747
10527	10846	12	applied	\N	\N	\N	\N	95941	95941	263748
10527	10847	13	applied	\N	\N	\N	\N	95942	95942	263749
10527	10851	14	applied	\N	\N	\N	\N	95943	95943	263750
10527	10852	15	applied	\N	\N	\N	\N	95944	95944	263751
10527	10828	16	applied	\N	\N	\N	\N	95945	95945	263752
10527	10829	17	applied	\N	\N	\N	\N	95946	95946	263753
10527	10856	18	applied	\N	\N	\N	\N	95947	95947	263754
10527	10858	20	applied	\N	\N	\N	\N	95949	95949	263756
10527	10859	21	applied	\N	\N	\N	\N	95950	95950	263757
10527	10830	22	applied	\N	\N	\N	\N	95951	95951	263758
10527	10831	23	applied	\N	\N	\N	\N	95952	95952	263759
10527	10833	24	applied	\N	\N	\N	\N	95953	95953	263760
10527	10835	25	applied	\N	\N	\N	\N	95954	95954	263761
10527	10836	26	applied	\N	\N	\N	\N	95955	95955	263762
10527	10837	27	applied	\N	\N	\N	\N	95956	95956	263763
10527	10841	28	applied	\N	\N	\N	\N	95957	95957	263764
10527	10842	29	applied	\N	\N	\N	\N	95958	95958	263765
10527	10844	30	applied	\N	\N	\N	\N	95959	95959	263766
10527	10848	31	applied	\N	\N	\N	\N	95960	95960	263767
10527	10849	32	applied	\N	\N	\N	\N	95961	95961	263768
10527	10850	33	applied	\N	\N	\N	\N	95962	95962	263769
10527	10853	34	applied	\N	\N	\N	\N	95963	95963	263770
10527	10854	35	applied	\N	\N	\N	\N	95964	95964	263771
10527	10860	37	applied	\N	\N	\N	\N	95966	95966	263773
10527	10861	38	applied	\N	\N	\N	\N	95967	95967	263774
10535	10875	0	applied	\N	\N	\N	\N	95995	95995	263802
10535	10876	1	applied	\N	\N	\N	\N	95996	95996	263803
10537	10879	0	applied	\N	\N	\N	\N	95999	95999	263806
10537	10880	1	applied	\N	\N	\N	\N	96000	96000	263807
10540	10886	0	applied	\N	\N	\N	\N	96006	96006	263813
10540	10887	1	applied	\N	\N	\N	\N	96007	96007	263814
10543	10888	0	applied	\N	\N	\N	\N	96012	96012	263819
10543	10889	1	applied	\N	\N	\N	\N	96013	96013	263820
10546	10888	0	applied	\N	\N	\N	\N	96020	96020	263827
10546	10889	1	applied	\N	\N	\N	\N	96021	96021	263828
10549	10890	0	applied	\N	\N	\N	\N	96032	96032	263839
10549	10891	1	applied	\N	\N	\N	\N	96033	96033	263840
10549	10892	2	applied	\N	\N	\N	\N	96034	96034	263841
10549	10893	3	applied	\N	\N	\N	\N	96035	96035	263842
10552	10900	0	applied	\N	\N	\N	\N	96081	96081	263888
10552	10901	1	applied	\N	\N	\N	\N	96082	96082	263889
10552	10902	2	applied	\N	\N	\N	\N	96083	96083	263890
10552	10903	3	applied	\N	\N	\N	\N	96084	96084	263891
10552	10897	4	applied	\N	\N	\N	\N	96085	96085	263892
10552	10898	5	applied	\N	\N	\N	\N	96086	96086	263893
10552	10899	6	applied	\N	\N	\N	\N	96087	96087	263894
10554	10904	0	applied	\N	\N	\N	\N	96095	96095	263902
10554	10905	1	applied	\N	\N	\N	\N	96096	96096	263903
10558	10759	0	applied	\N	\N	1000000000	\N	96113	96113	263920
10558	10675	1	applied	\N	\N	1000000000	\N	96114	96114	263921
10558	10781	2	applied	\N	\N	\N	\N	96115	96115	263922
10558	10672	3	applied	\N	\N	\N	\N	96116	96116	263923
10558	10661	4	applied	\N	\N	\N	\N	96117	96117	263924
10558	10424	5	applied	\N	\N	\N	\N	96118	96118	263925
10558	10425	6	applied	\N	\N	\N	\N	96119	96119	263926
10558	10429	8	applied	\N	\N	\N	\N	96121	96121	263928
10558	10568	9	applied	\N	\N	1000000000	\N	96122	96122	263929
10558	10589	11	applied	\N	\N	\N	\N	96123	96123	263930
10558	10666	12	applied	\N	\N	\N	\N	96124	96124	263931
10558	10598	13	applied	\N	\N	\N	\N	96125	96125	263932
10558	10605	14	applied	\N	\N	\N	\N	96126	96126	263933
10558	10791	15	applied	\N	\N	\N	\N	96127	96127	263934
10558	10649	16	applied	\N	\N	\N	\N	96128	96128	263935
10558	10653	17	applied	\N	\N	\N	\N	96129	96129	263936
10558	10792	18	applied	\N	\N	\N	\N	96130	96130	263937
10558	10793	19	applied	\N	\N	\N	\N	96131	96131	263938
10558	10794	20	applied	\N	\N	\N	\N	96132	96132	263939
10558	10611	21	applied	\N	\N	\N	\N	96133	96133	263940
10558	10612	22	applied	\N	\N	\N	\N	96134	96134	263941
10558	10729	24	applied	\N	\N	\N	\N	96136	96136	263943
10558	10730	25	applied	\N	\N	\N	\N	96137	96137	263944
10558	10733	26	applied	\N	\N	\N	\N	96138	96138	263945
10558	10734	27	applied	\N	\N	\N	\N	96139	96139	263946
10558	10678	28	applied	\N	\N	\N	\N	96140	96140	263947
10558	10679	29	applied	\N	\N	\N	\N	96141	96141	263948
10558	10680	30	applied	\N	\N	\N	\N	96142	96142	263949
10558	10681	31	applied	\N	\N	\N	\N	96143	96143	263950
10558	10682	32	applied	\N	\N	\N	\N	96144	96144	263951
10558	10686	33	applied	\N	\N	\N	\N	96145	96145	263952
10558	10688	34	applied	\N	\N	\N	\N	96146	96146	263953
10558	10689	35	applied	\N	\N	\N	\N	96147	96147	263954
10558	10690	36	applied	\N	\N	\N	\N	96148	96148	263955
10558	10691	37	applied	\N	\N	\N	\N	96149	96149	263956
10558	10692	38	applied	\N	\N	\N	\N	96150	96150	263957
10558	10700	39	applied	\N	\N	\N	\N	96151	96151	263958
10558	10702	40	applied	\N	\N	\N	\N	96152	96152	263959
10558	10703	41	applied	\N	\N	\N	\N	96153	96153	263960
10558	10705	42	applied	\N	\N	\N	\N	96154	96154	263961
10558	10706	43	applied	\N	\N	\N	\N	96155	96155	263962
10558	10911	45	applied	\N	\N	\N	\N	96157	96157	263964
10558	10711	46	applied	\N	\N	\N	\N	96158	96158	263965
10558	10715	47	applied	\N	\N	\N	\N	96159	96159	263966
10558	10720	48	applied	\N	\N	\N	\N	96160	96160	263967
10558	10617	49	applied	\N	\N	\N	\N	96161	96161	263968
10558	10618	50	applied	\N	\N	\N	\N	96162	96162	263969
10558	10625	51	applied	\N	\N	\N	\N	96163	96163	263970
10558	10627	52	applied	\N	\N	\N	\N	96164	96164	263971
10558	10633	53	applied	\N	\N	\N	\N	96165	96165	263972
10558	10634	54	applied	\N	\N	\N	\N	96166	96166	263973
10558	10635	55	applied	\N	\N	\N	\N	96167	96167	263974
10558	10636	56	applied	\N	\N	\N	\N	96168	96168	263975
10558	10641	57	applied	\N	\N	\N	\N	96169	96169	263976
10558	10642	58	applied	\N	\N	\N	\N	96170	96170	263977
10558	10643	59	applied	\N	\N	\N	\N	96171	96171	263978
10558	10644	60	applied	\N	\N	\N	\N	96172	96172	263979
10558	10795	62	applied	\N	\N	\N	\N	96174	96174	263981
10558	10796	63	applied	\N	\N	\N	\N	96175	96175	263982
10527	10839	8	applied	\N	\N	\N	\N	95937	95937	263744
10527	10840	9	applied	\N	\N	\N	\N	95938	95938	263745
10558	10801	68	applied	\N	\N	\N	\N	96180	96180	263987
10558	10804	69	applied	\N	\N	\N	\N	96181	96181	263988
10558	10807	70	applied	\N	\N	\N	\N	96182	96182	263989
10558	10808	71	applied	\N	\N	\N	\N	96183	96183	263990
10558	10809	72	applied	\N	\N	\N	\N	96184	96184	263991
10558	10810	73	applied	\N	\N	\N	\N	96185	96185	263992
10558	10811	74	applied	\N	\N	\N	\N	96186	96186	263993
10558	10812	75	applied	\N	\N	\N	\N	96187	96187	263994
10558	10438	76	applied	\N	\N	\N	\N	96188	96188	263995
10558	10441	77	applied	\N	\N	\N	\N	96189	96189	263996
10558	10442	78	applied	\N	\N	\N	\N	96190	96190	263997
10558	10443	79	applied	\N	\N	\N	\N	96191	96191	263998
10558	10445	80	applied	\N	\N	\N	\N	96192	96192	263999
10558	10446	81	applied	\N	\N	\N	\N	96193	96193	264000
10558	10450	82	applied	\N	\N	\N	\N	96194	96194	264001
10558	10456	83	applied	\N	\N	\N	\N	96195	96195	264002
10558	10459	85	applied	\N	\N	\N	\N	96197	96197	264004
10558	10467	86	applied	\N	\N	\N	\N	96198	96198	264005
10558	10468	87	applied	\N	\N	\N	\N	96199	96199	264006
10558	10469	88	applied	\N	\N	\N	\N	96200	96200	264007
10558	10470	89	applied	\N	\N	\N	\N	96201	96201	264008
10558	10473	90	applied	\N	\N	\N	\N	96202	96202	264009
10558	10474	91	applied	\N	\N	\N	\N	96203	96203	264010
10558	10477	92	applied	\N	\N	\N	\N	96204	96204	264011
10558	10478	93	applied	\N	\N	\N	\N	96205	96205	264012
10558	10481	94	applied	\N	\N	\N	\N	96206	96206	264013
10558	10483	95	applied	\N	\N	\N	\N	96207	96207	264014
10558	10484	96	applied	\N	\N	\N	\N	96208	96208	264015
10558	10487	97	applied	\N	\N	\N	\N	96209	96209	264016
10558	10489	98	applied	\N	\N	\N	\N	96210	96210	264017
10558	10494	99	applied	\N	\N	\N	\N	96211	96211	264018
10558	10495	100	applied	\N	\N	\N	\N	96212	96212	264019
10558	10497	102	applied	\N	\N	\N	\N	96214	96214	264021
10558	10499	103	applied	\N	\N	\N	\N	96215	96215	264022
10558	10502	104	applied	\N	\N	\N	\N	96216	96216	264023
10558	10504	105	applied	\N	\N	\N	\N	96217	96217	264024
10558	10506	106	applied	\N	\N	\N	\N	96218	96218	264025
10558	10508	107	applied	\N	\N	\N	\N	96219	96219	264026
10558	10510	108	applied	\N	\N	\N	\N	96220	96220	264027
10558	10513	109	applied	\N	\N	\N	\N	96221	96221	264028
10558	10514	110	applied	\N	\N	\N	\N	96222	96222	264029
10558	10516	111	applied	\N	\N	\N	\N	96223	96223	264030
10558	10519	112	applied	\N	\N	\N	\N	96224	96224	264031
10558	10521	113	applied	\N	\N	\N	\N	96225	96225	264032
10558	10525	114	applied	\N	\N	\N	\N	96226	96226	264033
10558	10526	115	applied	\N	\N	\N	\N	96227	96227	264034
10558	10529	116	applied	\N	\N	\N	\N	96228	96228	264035
10558	10530	117	applied	\N	\N	\N	\N	96229	96229	264036
10558	10532	119	applied	\N	\N	\N	\N	96231	96231	264038
10558	10541	120	applied	\N	\N	\N	\N	96232	96232	264039
10558	10656	121	applied	\N	\N	\N	\N	96233	96233	264040
10558	10659	122	applied	\N	\N	\N	\N	96234	96234	264041
10558	10671	123	applied	\N	\N	\N	\N	96235	96235	264042
10558	10544	124	applied	\N	\N	\N	\N	96236	96236	264043
10558	10545	125	applied	\N	\N	\N	\N	96237	96237	264044
10560	10914	0	applied	\N	\N	\N	\N	96240	96240	264047
10560	10915	1	applied	\N	\N	\N	\N	96241	96241	264048
10562	10918	0	applied	\N	\N	\N	\N	96244	96244	264051
10562	10919	1	applied	\N	\N	\N	\N	96245	96245	264052
10582	10947	0	applied	\N	\N	\N	\N	96293	96293	264100
10582	10948	1	applied	\N	\N	\N	\N	96294	96294	264101
10586	10949	0	applied	\N	\N	\N	\N	96301	96301	264108
10586	10950	1	applied	\N	\N	\N	\N	96302	96302	264109
10590	10956	1	applied	\N	\N	\N	\N	96308	96308	264115
10590	10958	3	applied	\N	\N	\N	\N	96310	96310	264117
10592	10955	0	applied	\N	\N	\N	\N	96315	96315	264122
10592	10956	1	applied	\N	\N	\N	\N	96316	96316	264123
10592	10957	2	applied	\N	\N	\N	\N	96317	96317	264124
10592	10958	3	applied	\N	\N	\N	\N	96318	96318	264125
10594	10959	0	applied	\N	\N	\N	\N	96321	96321	264128
10594	10960	1	applied	\N	\N	\N	\N	96322	96322	264129
10596	10961	0	applied	\N	\N	\N	\N	96327	96327	264134
10596	10962	1	applied	\N	\N	\N	\N	96328	96328	264135
10596	10963	2	applied	\N	\N	\N	\N	96329	96329	264136
10596	10964	3	applied	\N	\N	\N	\N	96330	96330	264137
10599	10969	0	applied	\N	\N	\N	\N	96335	96335	264142
10601	10971	0	applied	\N	\N	\N	\N	96339	96339	264146
10601	10972	1	applied	\N	\N	\N	\N	96340	96340	264147
10608	10977	0	applied	\N	\N	\N	\N	96353	96353	264160
10608	10978	1	applied	\N	\N	\N	\N	96354	96354	264161
10610	10980	1	applied	\N	\N	\N	\N	96358	96358	264165
10610	10981	2	applied	\N	\N	\N	\N	96359	96359	264166
10610	10982	3	applied	\N	\N	\N	\N	96360	96360	264167
10615	10988	0	applied	\N	\N	\N	\N	96372	96372	264179
10615	10989	1	applied	\N	\N	\N	\N	96373	96373	264180
10617	10990	0	applied	\N	\N	\N	\N	96376	96376	264183
10617	10991	1	applied	\N	\N	\N	\N	96377	96377	264184
10619	10990	0	applied	\N	\N	\N	\N	96413	96413	264220
10619	10991	1	applied	\N	\N	\N	\N	96414	96414	264221
10623	10996	0	applied	\N	\N	\N	\N	96429	96429	264236
10623	10997	1	applied	\N	\N	\N	\N	96430	96430	264237
10623	10998	2	applied	\N	\N	\N	\N	96431	96431	264238
10623	10999	3	applied	\N	\N	\N	\N	96432	96432	264239
10623	11000	4	applied	\N	\N	\N	\N	96433	96433	264240
10623	11001	5	applied	\N	\N	\N	\N	96434	96434	264241
10625	11002	0	applied	\N	\N	\N	\N	96437	96437	264244
10627	11004	0	applied	\N	\N	\N	\N	96441	96441	264248
10627	11005	1	applied	\N	\N	\N	\N	96442	96442	264249
10627	11006	2	applied	\N	\N	\N	\N	96443	96443	264250
10630	11009	0	applied	\N	\N	\N	\N	96447	96447	264254
10630	11010	1	applied	\N	\N	\N	\N	96448	96448	264255
10634	11013	0	applied	\N	\N	\N	\N	96457	96457	264264
10634	11014	1	applied	\N	\N	\N	\N	96458	96458	264265
10636	11016	0	applied	\N	\N	\N	\N	96461	96461	264268
10636	11015	1	applied	\N	\N	\N	\N	96462	96462	264269
10636	11017	2	applied	\N	\N	\N	\N	96463	96463	264270
10637	11018	0	applied	\N	\N	\N	\N	96464	96464	264271
10637	11019	1	applied	\N	\N	\N	\N	96465	96465	264272
10637	11020	2	applied	\N	\N	\N	\N	96466	96466	264273
10637	11021	4	applied	\N	\N	\N	\N	96467	96467	264274
10558	10798	65	applied	\N	\N	\N	\N	96177	96177	263984
10558	10799	66	applied	\N	\N	\N	\N	96178	96178	263985
10599	10970	1	applied	\N	\N	\N	\N	96336	96336	264143
10602	10971	0	applied	\N	\N	\N	\N	96341	96341	264148
10602	10972	1	applied	\N	\N	\N	\N	96342	96342	264149
10603	10971	0	applied	\N	\N	\N	\N	96343	96343	264150
10603	10972	1	applied	\N	\N	\N	\N	96344	96344	264151
10605	10973	0	applied	\N	\N	\N	\N	96347	96347	264154
10606	10975	0	applied	\N	\N	\N	\N	96349	96349	264156
10606	10976	1	applied	\N	\N	\N	\N	96350	96350	264157
10609	10977	0	applied	\N	\N	\N	\N	96355	96355	264162
10613	10983	0	applied	\N	\N	\N	\N	96367	96367	264174
10613	10984	1	applied	\N	\N	\N	\N	96368	96368	264175
10616	10988	0	applied	\N	\N	\N	\N	96374	96374	264181
10616	10989	1	applied	\N	\N	\N	\N	96375	96375	264182
10620	10992	0	applied	\N	\N	\N	\N	96415	96415	264222
10620	10993	1	applied	\N	\N	\N	\N	96416	96416	264223
10620	10994	2	applied	\N	\N	\N	\N	96417	96417	264224
10620	10995	3	applied	\N	\N	\N	\N	96418	96418	264225
10632	11010	0	applied	\N	\N	\N	\N	96451	96451	264258
10632	11011	1	applied	\N	\N	\N	\N	96452	96452	264259
10632	11012	2	applied	\N	\N	1000000000	\N	96453	96453	264260
10635	11013	0	applied	\N	\N	\N	\N	96459	96459	264266
10635	11014	1	applied	\N	\N	\N	\N	96460	96460	264267
10640	11027	0	applied	\N	\N	\N	\N	96475	96475	264282
10640	11028	1	applied	\N	\N	\N	\N	96476	96476	264283
10640	11029	2	applied	\N	\N	\N	\N	96477	96477	264284
10645	11037	1	applied	\N	\N	\N	\N	96517	96517	264324
10645	11038	2	applied	\N	\N	\N	\N	96518	96518	264325
10645	11039	3	applied	\N	\N	\N	\N	96519	96519	264326
10647	11040	0	applied	\N	\N	\N	\N	96522	96522	264329
10647	11041	1	applied	\N	\N	\N	\N	96523	96523	264330
10652	11042	0	applied	\N	\N	\N	\N	96534	96534	264341
10652	11043	1	applied	\N	\N	\N	\N	96535	96535	264342
10652	11044	2	applied	\N	\N	\N	\N	96536	96536	264343
10652	11045	3	applied	\N	\N	\N	\N	96537	96537	264344
10657	11050	0	applied	\N	\N	\N	\N	96550	96550	264357
10657	11051	1	applied	\N	\N	\N	\N	96551	96551	264358
10657	11052	2	applied	\N	\N	\N	\N	96552	96552	264359
10657	11053	3	applied	\N	\N	\N	\N	96553	96553	264360
10661	11055	0	applied	\N	\N	\N	\N	96563	96563	264370
10661	11056	1	applied	\N	\N	\N	\N	96564	96564	264371
10664	11057	0	applied	\N	\N	\N	\N	96567	96567	264374
10668	11059	0	applied	\N	\N	\N	\N	96578	96578	264385
10668	11060	1	applied	\N	\N	\N	\N	96579	96579	264386
10668	11061	2	applied	\N	\N	\N	\N	96580	96580	264387
10668	11062	3	applied	\N	\N	\N	\N	96581	96581	264388
10668	11063	4	applied	\N	\N	\N	\N	96582	96582	264389
10672	11064	0	applied	\N	\N	\N	\N	96600	96600	264407
10672	11065	1	applied	\N	\N	\N	\N	96601	96601	264408
10672	11066	2	applied	\N	\N	\N	\N	96602	96602	264409
10672	11067	3	applied	\N	\N	\N	\N	96603	96603	264410
10672	11068	4	applied	\N	\N	\N	\N	96604	96604	264411
10672	11069	5	applied	\N	\N	\N	\N	96605	96605	264412
10676	11074	0	applied	\N	\N	\N	\N	96620	96620	264427
10676	11075	1	applied	\N	\N	\N	\N	96621	96621	264428
10678	11076	0	applied	\N	\N	\N	\N	96624	96624	264431
10678	11077	1	applied	\N	\N	\N	\N	96625	96625	264432
10680	11078	0	applied	\N	\N	\N	\N	96628	96628	264435
10685	11086	0	applied	\N	\N	\N	\N	96638	96638	264445
10685	11087	1	applied	\N	\N	\N	\N	96639	96639	264446
10685	11088	2	applied	\N	\N	\N	\N	96640	96640	264447
10688	11089	0	applied	\N	\N	\N	\N	96644	96644	264451
10688	11090	1	applied	\N	\N	\N	\N	96645	96645	264452
10690	11094	0	applied	\N	\N	\N	\N	96651	96651	264458
10690	11095	1	applied	\N	\N	\N	\N	96652	96652	264459
10698	11104	0	applied	\N	\N	\N	\N	96673	96673	264480
10698	11105	1	applied	\N	\N	\N	\N	96674	96674	264481
10698	11106	2	applied	\N	\N	\N	\N	96675	96675	264482
10698	11107	3	applied	\N	\N	\N	\N	96676	96676	264483
10698	11108	4	applied	\N	\N	\N	\N	96677	96677	264484
10698	11109	5	applied	\N	\N	\N	\N	96678	96678	264485
10698	11110	6	applied	\N	\N	\N	\N	96679	96679	264486
10698	11111	7	applied	\N	\N	\N	\N	96680	96680	264487
10702	11112	0	applied	\N	\N	\N	\N	96705	96705	264512
10706	11118	0	applied	\N	\N	\N	\N	96722	96722	264529
10706	11119	1	applied	\N	\N	\N	\N	96723	96723	264530
10706	11120	2	applied	\N	\N	\N	\N	96724	96724	264531
10706	11121	3	applied	\N	\N	\N	\N	96725	96725	264532
10706	11122	4	applied	\N	\N	\N	\N	96726	96726	264533
10706	11123	5	applied	\N	\N	\N	\N	96727	96727	264534
10706	11124	6	applied	\N	\N	\N	\N	96728	96728	264535
10706	11125	7	applied	\N	\N	\N	\N	96729	96729	264536
10706	11126	8	applied	\N	\N	1000000000	\N	96730	96730	264537
10710	11130	0	applied	\N	\N	\N	\N	96736	96736	264543
10710	11131	1	applied	\N	\N	\N	\N	96737	96737	264544
10713	11132	0	applied	\N	\N	\N	\N	96742	96742	264549
10713	11133	1	applied	\N	\N	\N	\N	96743	96743	264550
10740	11169	0	applied	\N	\N	\N	\N	96943	96943	264750
10740	11170	1	applied	\N	\N	\N	\N	96944	96944	264751
10743	11175	0	applied	\N	\N	\N	\N	96952	96952	264759
10743	11177	3	applied	\N	\N	\N	\N	96954	96954	264761
10747	11180	0	applied	\N	\N	\N	\N	96961	96961	264768
10747	11181	1	applied	\N	\N	\N	\N	96962	96962	264769
10750	11182	0	applied	\N	\N	\N	\N	96969	96969	264776
10750	11183	1	applied	\N	\N	\N	\N	96970	96970	264777
10750	11184	2	applied	\N	\N	1000000000	\N	96971	96971	264778
10752	11185	0	applied	\N	\N	\N	\N	96975	96975	264782
10752	11186	1	applied	\N	\N	1000000000	\N	96976	96976	264783
10752	11187	2	applied	\N	\N	\N	\N	96977	96977	264784
10752	11188	3	applied	\N	\N	\N	\N	96978	96978	264785
10752	11189	4	applied	\N	\N	\N	\N	96979	96979	264786
10752	11190	5	applied	\N	\N	\N	\N	96980	96980	264787
10752	11191	6	applied	\N	\N	\N	\N	96981	96981	264788
10757	11200	0	applied	\N	\N	\N	\N	96992	96992	264799
10757	11201	1	applied	\N	\N	\N	\N	96993	96993	264800
10761	11204	0	applied	\N	\N	\N	\N	97004	97004	264811
10761	11206	2	applied	\N	\N	\N	\N	97006	97006	264813
10761	11207	3	applied	\N	\N	\N	\N	97007	97007	264814
10765	11212	0	applied	\N	\N	\N	\N	97016	97016	264823
10765	11213	1	applied	\N	\N	\N	\N	97017	97017	264824
10598	10967	0	applied	\N	\N	\N	\N	96333	96333	264140
10598	10968	1	applied	\N	\N	\N	\N	96334	96334	264141
10595	10964	3	applied	\N	\N	\N	\N	96326	96326	264133
10597	10965	0	applied	\N	\N	\N	\N	96331	96331	264138
10597	10966	1	applied	\N	\N	\N	\N	96332	96332	264139
10605	10974	1	applied	\N	\N	\N	\N	96348	96348	264155
10607	10977	0	applied	\N	\N	\N	\N	96351	96351	264158
10607	10978	1	applied	\N	\N	\N	\N	96352	96352	264159
10612	10983	0	applied	\N	\N	\N	\N	96365	96365	264172
10612	10984	1	applied	\N	\N	\N	\N	96366	96366	264173
10614	10985	0	applied	\N	\N	\N	\N	96369	96369	264176
10614	10986	1	applied	\N	\N	\N	\N	96370	96370	264177
10614	10987	2	applied	\N	\N	1000000000	\N	96371	96371	264178
10622	10996	0	applied	\N	\N	\N	\N	96423	96423	264230
10622	10997	1	applied	\N	\N	\N	\N	96424	96424	264231
10622	10999	3	applied	\N	\N	\N	\N	96426	96426	264233
10622	11000	4	applied	\N	\N	\N	\N	96427	96427	264234
10622	11001	5	applied	\N	\N	\N	\N	96428	96428	264235
10624	11002	0	applied	\N	\N	\N	\N	96435	96435	264242
10624	11003	1	applied	\N	\N	\N	\N	96436	96436	264243
10629	11009	0	applied	\N	\N	\N	\N	96446	96446	264253
10631	11009	0	applied	\N	\N	\N	\N	96449	96449	264256
10631	11010	1	applied	\N	\N	\N	\N	96450	96450	264257
10639	11025	0	applied	\N	\N	\N	\N	96473	96473	264280
10639	11026	1	applied	\N	\N	\N	\N	96474	96474	264281
10641	11030	0	applied	\N	\N	\N	\N	96478	96478	264285
10641	11031	1	applied	\N	\N	\N	\N	96479	96479	264286
10646	11036	0	applied	\N	\N	\N	\N	96520	96520	264327
10646	11039	1	applied	\N	\N	\N	\N	96521	96521	264328
10649	11040	0	applied	\N	\N	\N	\N	96526	96526	264333
10649	11041	1	applied	\N	\N	\N	\N	96527	96527	264334
10655	11047	1	applied	\N	\N	\N	\N	96543	96543	264350
10655	11048	2	applied	\N	\N	\N	\N	96544	96544	264351
10655	11049	3	applied	\N	\N	\N	\N	96545	96545	264352
10660	11054	0	applied	\N	\N	\N	\N	96562	96562	264369
10667	11059	0	applied	\N	\N	\N	\N	96573	96573	264380
10667	11060	1	applied	\N	\N	\N	\N	96574	96574	264381
10667	11061	2	applied	\N	\N	\N	\N	96575	96575	264382
10667	11062	3	applied	\N	\N	\N	\N	96576	96576	264383
10667	11063	4	applied	\N	\N	\N	\N	96577	96577	264384
10670	11064	0	applied	\N	\N	\N	\N	96588	96588	264395
10670	11065	1	applied	\N	\N	\N	\N	96589	96589	264396
10670	11066	2	applied	\N	\N	\N	\N	96590	96590	264397
10670	11067	3	applied	\N	\N	\N	\N	96591	96591	264398
10670	11068	4	applied	\N	\N	\N	\N	96592	96592	264399
10670	11069	5	applied	\N	\N	\N	\N	96593	96593	264400
10673	11064	0	applied	\N	\N	\N	\N	96606	96606	264413
10673	11066	2	applied	\N	\N	\N	\N	96608	96608	264415
10673	11070	3	applied	\N	\N	\N	\N	96609	96609	264416
10673	11067	4	applied	\N	\N	\N	\N	96610	96610	264417
10673	11068	5	applied	\N	\N	\N	\N	96611	96611	264418
10673	11069	6	applied	\N	\N	\N	\N	96612	96612	264419
10673	11071	7	applied	\N	\N	\N	\N	96613	96613	264420
10679	11078	0	applied	\N	\N	\N	\N	96626	96626	264433
10679	11079	1	applied	\N	\N	\N	\N	96627	96627	264434
10682	11080	0	applied	\N	\N	\N	\N	96632	96632	264439
10682	11081	1	applied	\N	\N	\N	\N	96633	96633	264440
10684	11084	0	applied	\N	\N	\N	\N	96636	96636	264443
10684	11085	1	applied	\N	\N	\N	\N	96637	96637	264444
10692	11094	0	applied	\N	\N	\N	\N	96655	96655	264462
10692	11095	1	applied	\N	\N	\N	\N	96656	96656	264463
10709	11129	0	applied	\N	\N	\N	\N	96735	96735	264542
10711	11130	0	applied	\N	\N	\N	\N	96738	96738	264545
10718	11134	0	applied	\N	\N	\N	\N	96752	96752	264559
10718	11135	1	applied	\N	\N	\N	\N	96753	96753	264560
10720	11136	0	applied	\N	\N	\N	\N	96756	96756	264563
10720	11137	1	applied	\N	\N	\N	\N	96757	96757	264564
10729	11155	0	applied	\N	\N	\N	\N	96917	96917	264724
10729	11156	1	applied	\N	\N	\N	\N	96918	96918	264725
10732	11155	0	applied	\N	\N	\N	\N	96922	96922	264729
10732	11156	1	applied	\N	\N	\N	\N	96923	96923	264730
10733	11156	0	applied	\N	\N	\N	\N	96924	96924	264731
10733	11157	1	applied	\N	\N	\N	\N	96925	96925	264732
10733	11158	2	applied	\N	\N	\N	\N	96926	96926	264733
10736	11161	0	applied	\N	\N	\N	\N	96931	96931	264738
10736	11162	1	applied	\N	\N	\N	\N	96932	96932	264739
10736	11163	2	applied	\N	\N	\N	\N	96933	96933	264740
10736	11164	3	applied	\N	\N	\N	\N	96934	96934	264741
10739	11169	0	applied	\N	\N	\N	\N	96941	96941	264748
10741	11171	0	applied	\N	\N	\N	\N	96945	96945	264752
10741	11172	1	applied	\N	\N	\N	\N	96946	96946	264753
10741	11173	2	applied	\N	\N	\N	\N	96947	96947	264754
10741	11174	3	applied	\N	\N	\N	\N	96948	96948	264755
10746	11180	0	applied	\N	\N	\N	\N	96959	96959	264766
10746	11181	1	applied	\N	\N	\N	\N	96960	96960	264767
10748	11182	0	applied	\N	\N	\N	\N	96963	96963	264770
10748	11183	1	applied	\N	\N	\N	\N	96964	96964	264771
10748	11184	2	applied	\N	\N	1000000000	\N	96965	96965	264772
10754	11198	0	applied	\N	\N	\N	\N	96988	96988	264795
10754	11199	1	applied	\N	\N	\N	\N	96989	96989	264796
10756	11200	0	applied	\N	\N	\N	\N	96990	96990	264797
10756	11201	1	applied	\N	\N	\N	\N	96991	96991	264798
10759	11204	0	applied	\N	\N	\N	\N	96996	96996	264803
10759	11205	1	applied	\N	\N	\N	\N	96997	96997	264804
10759	11206	2	applied	\N	\N	\N	\N	96998	96998	264805
10762	11204	0	applied	\N	\N	\N	\N	97008	97008	264815
10762	11205	1	applied	\N	\N	\N	\N	97009	97009	264816
10762	11206	2	applied	\N	\N	\N	\N	97010	97010	264817
10762	11207	3	applied	\N	\N	\N	\N	97011	97011	264818
10763	11208	0	applied	\N	\N	\N	\N	97012	97012	264819
10763	11209	1	applied	\N	\N	\N	\N	97013	97013	264820
10767	11212	0	applied	\N	\N	\N	\N	97024	97024	264831
10767	11213	1	applied	\N	\N	\N	\N	97025	97025	264832
10767	11214	2	applied	\N	\N	\N	\N	97026	97026	264833
10767	11215	3	applied	\N	\N	\N	\N	97027	97027	264834
10768	11216	0	applied	\N	\N	\N	\N	97028	97028	264835
10768	11217	1	applied	\N	\N	\N	\N	97029	97029	264836
10773	11222	0	applied	\N	\N	\N	\N	97046	97046	264853
10773	11223	1	applied	\N	\N	\N	\N	97047	97047	264854
10773	11224	2	applied	\N	\N	\N	\N	97048	97048	264855
10773	11225	3	applied	\N	\N	\N	\N	97049	97049	264856
10595	10962	1	applied	\N	\N	\N	\N	96324	96324	264131
10595	10963	2	applied	\N	\N	\N	\N	96325	96325	264132
10604	10974	1	applied	\N	\N	\N	\N	96346	96346	264153
10611	10979	0	applied	\N	\N	\N	\N	96361	96361	264168
10611	10980	1	applied	\N	\N	\N	\N	96362	96362	264169
10611	10981	2	applied	\N	\N	\N	\N	96363	96363	264170
10611	10982	3	applied	\N	\N	\N	\N	96364	96364	264171
10618	10548	0	applied	\N	\N	\N	\N	96378	96378	264185
10618	10549	1	applied	\N	\N	\N	\N	96379	96379	264186
10618	10551	2	applied	\N	\N	\N	\N	96380	96380	264187
10618	10554	3	applied	\N	\N	\N	\N	96381	96381	264188
10618	10559	5	applied	\N	\N	\N	\N	96383	96383	264190
10618	10561	6	applied	\N	\N	\N	\N	96384	96384	264191
10618	10563	7	applied	\N	\N	\N	\N	96385	96385	264192
10618	10565	8	applied	\N	\N	\N	\N	96386	96386	264193
10618	10566	9	applied	\N	\N	\N	\N	96387	96387	264194
10618	10570	11	applied	\N	\N	\N	\N	96388	96388	264195
10618	10573	12	applied	\N	\N	\N	\N	96389	96389	264196
10618	10575	13	applied	\N	\N	\N	\N	96390	96390	264197
10618	10577	14	applied	\N	\N	\N	\N	96391	96391	264198
10618	10578	15	applied	\N	\N	\N	\N	96392	96392	264199
10618	10579	16	applied	\N	\N	\N	\N	96393	96393	264200
10618	10582	17	applied	\N	\N	\N	\N	96394	96394	264201
10618	10584	18	applied	\N	\N	\N	\N	96395	96395	264202
10618	10586	19	applied	\N	\N	\N	\N	96396	96396	264203
10618	10591	20	applied	\N	\N	\N	\N	96397	96397	264204
10618	10592	21	applied	\N	\N	\N	\N	96398	96398	264205
10618	10595	23	applied	\N	\N	\N	\N	96400	96400	264207
10618	10597	24	applied	\N	\N	\N	\N	96401	96401	264208
10618	10599	25	applied	\N	\N	\N	\N	96402	96402	264209
10618	10600	26	applied	\N	\N	\N	\N	96403	96403	264210
10618	10604	27	applied	\N	\N	\N	\N	96404	96404	264211
10618	10607	28	applied	\N	\N	\N	\N	96405	96405	264212
10618	10610	29	applied	\N	\N	\N	\N	96406	96406	264213
10618	10619	30	applied	\N	\N	\N	\N	96407	96407	264214
10618	10620	31	applied	\N	\N	\N	\N	96408	96408	264215
10618	10621	32	applied	\N	\N	\N	\N	96409	96409	264216
10618	10622	33	applied	\N	\N	\N	\N	96410	96410	264217
10618	10623	34	applied	\N	\N	\N	\N	96411	96411	264218
10618	10628	35	applied	\N	\N	\N	\N	96412	96412	264219
10621	10992	0	applied	\N	\N	\N	\N	96419	96419	264226
10621	10993	1	applied	\N	\N	\N	\N	96420	96420	264227
10621	10994	2	applied	\N	\N	\N	\N	96421	96421	264228
10626	11002	0	applied	\N	\N	\N	\N	96439	96439	264246
10626	11003	1	applied	\N	\N	\N	\N	96440	96440	264247
10628	11007	0	applied	\N	\N	\N	\N	96444	96444	264251
10628	11008	1	applied	\N	\N	\N	\N	96445	96445	264252
10633	11013	0	applied	\N	\N	\N	\N	96454	96454	264261
10633	11014	1	applied	\N	\N	\N	\N	96455	96455	264262
10633	11015	2	applied	\N	\N	\N	\N	96456	96456	264263
10637	11022	5	applied	\N	\N	\N	\N	96468	96468	264275
10637	11023	6	applied	\N	\N	\N	\N	96469	96469	264276
10637	11024	7	applied	\N	\N	\N	\N	96470	96470	264277
10638	11025	0	applied	\N	\N	\N	\N	96471	96471	264278
10638	11026	1	applied	\N	\N	\N	\N	96472	96472	264279
10642	11030	0	applied	\N	\N	\N	\N	96480	96480	264287
10642	11031	1	applied	\N	\N	\N	\N	96481	96481	264288
10643	10781	0	applied	\N	\N	\N	\N	96482	96482	264289
10643	10791	1	applied	\N	\N	\N	\N	96483	96483	264290
10643	10793	3	applied	\N	\N	\N	\N	96485	96485	264292
10643	10794	4	applied	\N	\N	\N	\N	96486	96486	264293
10643	10795	5	applied	\N	\N	\N	\N	96487	96487	264294
10643	10796	6	applied	\N	\N	\N	\N	96488	96488	264295
10643	10797	7	applied	\N	\N	\N	\N	96489	96489	264296
10643	10798	8	applied	\N	\N	\N	\N	96490	96490	264297
10643	10799	9	applied	\N	\N	\N	\N	96491	96491	264298
10643	10800	10	applied	\N	\N	\N	\N	96492	96492	264299
10643	10801	11	applied	\N	\N	\N	\N	96493	96493	264300
10643	10804	12	applied	\N	\N	\N	\N	96494	96494	264301
10643	10807	13	applied	\N	\N	\N	\N	96495	96495	264302
10643	10808	14	applied	\N	\N	\N	\N	96496	96496	264303
10643	10809	15	applied	\N	\N	\N	\N	96497	96497	264304
10643	10810	16	applied	\N	\N	\N	\N	96498	96498	264305
10643	10811	17	applied	\N	\N	\N	\N	96499	96499	264306
10643	10812	18	applied	\N	\N	\N	\N	96500	96500	264307
10643	11024	20	applied	\N	\N	\N	\N	96502	96502	264309
10643	11029	21	applied	\N	\N	\N	\N	96503	96503	264310
10643	10874	22	applied	\N	\N	\N	\N	96504	96504	264311
10643	10864	23	applied	\N	\N	1000000000	\N	96505	96505	264312
10643	10865	24	applied	\N	\N	\N	\N	96506	96506	264313
10643	10885	25	applied	\N	\N	1000000000	\N	96507	96507	264314
10643	10894	26	applied	\N	\N	\N	\N	96508	96508	264315
10643	10987	27	applied	\N	\N	1000000000	\N	96509	96509	264316
10643	11006	28	applied	\N	\N	\N	\N	96510	96510	264317
10643	11012	29	applied	\N	\N	1000000000	\N	96511	96511	264318
10644	11032	0	applied	\N	\N	\N	\N	96512	96512	264319
10648	11040	0	applied	\N	\N	\N	\N	96524	96524	264331
10648	11041	1	applied	\N	\N	\N	\N	96525	96525	264332
10653	11042	0	applied	\N	\N	\N	\N	96538	96538	264345
10653	11043	1	applied	\N	\N	\N	\N	96539	96539	264346
10653	11044	2	applied	\N	\N	\N	\N	96540	96540	264347
10658	11050	0	applied	\N	\N	\N	\N	96554	96554	264361
10658	11051	1	applied	\N	\N	\N	\N	96555	96555	264362
10658	11052	2	applied	\N	\N	\N	\N	96556	96556	264363
10658	11053	3	applied	\N	\N	\N	\N	96557	96557	264364
10666	11057	0	applied	\N	\N	\N	\N	96571	96571	264378
10666	11058	1	applied	\N	\N	\N	\N	96572	96572	264379
10669	11059	0	applied	\N	\N	\N	\N	96583	96583	264390
10669	11060	1	applied	\N	\N	\N	\N	96584	96584	264391
10669	11061	2	applied	\N	\N	\N	\N	96585	96585	264392
10669	11062	3	applied	\N	\N	\N	\N	96586	96586	264393
10669	11063	4	applied	\N	\N	\N	\N	96587	96587	264394
10674	11071	0	applied	\N	\N	\N	\N	96614	96614	264421
10674	11072	1	applied	\N	\N	\N	\N	96615	96615	264422
10674	11070	2	applied	\N	\N	\N	\N	96616	96616	264423
10674	11073	3	applied	\N	\N	\N	\N	96617	96617	264424
10677	11074	0	applied	\N	\N	\N	\N	96622	96622	264429
10681	11080	0	applied	\N	\N	\N	\N	96630	96630	264437
10681	11081	1	applied	\N	\N	\N	\N	96631	96631	264438
10683	11082	0	applied	\N	\N	\N	\N	96634	96634	264441
10683	11083	1	applied	\N	\N	\N	\N	96635	96635	264442
10600	10970	1	applied	\N	\N	\N	\N	96338	96338	264145
10604	10973	0	applied	\N	\N	\N	\N	96345	96345	264152
10650	11041	1	applied	\N	\N	\N	\N	96529	96529	264336
10651	11042	0	applied	\N	\N	\N	\N	96530	96530	264337
10651	11043	1	applied	\N	\N	\N	\N	96531	96531	264338
10651	11044	2	applied	\N	\N	\N	\N	96532	96532	264339
10651	11045	3	applied	\N	\N	\N	\N	96533	96533	264340
10656	11050	0	applied	\N	\N	\N	\N	96546	96546	264353
10656	11051	1	applied	\N	\N	\N	\N	96547	96547	264354
10656	11052	2	applied	\N	\N	\N	\N	96548	96548	264355
10656	11053	3	applied	\N	\N	\N	\N	96549	96549	264356
10659	11050	0	applied	\N	\N	\N	\N	96558	96558	264365
10659	11051	1	applied	\N	\N	\N	\N	96559	96559	264366
10659	11052	2	applied	\N	\N	\N	\N	96560	96560	264367
10659	11053	3	applied	\N	\N	\N	\N	96561	96561	264368
10663	11057	0	applied	\N	\N	\N	\N	96565	96565	264372
10665	11057	0	applied	\N	\N	\N	\N	96569	96569	264376
10665	11058	1	applied	\N	\N	\N	\N	96570	96570	264377
10671	11064	0	applied	\N	\N	\N	\N	96594	96594	264401
10671	11065	1	applied	\N	\N	\N	\N	96595	96595	264402
10671	11066	2	applied	\N	\N	\N	\N	96596	96596	264403
10671	11067	3	applied	\N	\N	\N	\N	96597	96597	264404
10671	11068	4	applied	\N	\N	\N	\N	96598	96598	264405
10671	11069	5	applied	\N	\N	\N	\N	96599	96599	264406
10675	11074	0	applied	\N	\N	\N	\N	96618	96618	264425
10675	11075	1	applied	\N	\N	\N	\N	96619	96619	264426
10686	11086	0	applied	\N	\N	\N	\N	96641	96641	264448
10686	11087	1	applied	\N	\N	\N	\N	96642	96642	264449
10686	11088	2	applied	\N	\N	\N	\N	96643	96643	264450
10689	11089	0	applied	\N	\N	\N	\N	96646	96646	264453
10689	11090	1	applied	\N	\N	\N	\N	96647	96647	264454
10689	11091	2	applied	\N	\N	\N	\N	96648	96648	264455
10689	11093	4	applied	\N	\N	\N	\N	96650	96650	264457
10691	11094	0	applied	\N	\N	\N	\N	96653	96653	264460
10691	11095	1	applied	\N	\N	\N	\N	96654	96654	264461
10695	11096	0	applied	\N	\N	\N	\N	96657	96657	264464
10697	11104	0	applied	\N	\N	\N	\N	96665	96665	264472
10697	11105	1	applied	\N	\N	\N	\N	96666	96666	264473
10697	11106	2	applied	\N	\N	\N	\N	96667	96667	264474
10697	11107	3	applied	\N	\N	\N	\N	96668	96668	264475
10697	11108	4	applied	\N	\N	\N	\N	96669	96669	264476
10697	11109	5	applied	\N	\N	\N	\N	96670	96670	264477
10697	11110	6	applied	\N	\N	\N	\N	96671	96671	264478
10697	11111	7	applied	\N	\N	\N	\N	96672	96672	264479
10700	11104	0	applied	\N	\N	\N	\N	96689	96689	264496
10700	11105	1	applied	\N	\N	\N	\N	96690	96690	264497
10700	11106	2	applied	\N	\N	\N	\N	96691	96691	264498
10700	11107	3	applied	\N	\N	\N	\N	96692	96692	264499
10700	11109	5	applied	\N	\N	\N	\N	96694	96694	264501
10700	11110	6	applied	\N	\N	\N	\N	96695	96695	264502
10700	11111	7	applied	\N	\N	\N	\N	96696	96696	264503
10701	11104	0	applied	\N	\N	\N	\N	96697	96697	264504
10701	11105	1	applied	\N	\N	\N	\N	96698	96698	264505
10701	11106	2	applied	\N	\N	\N	\N	96699	96699	264506
10701	11107	3	applied	\N	\N	\N	\N	96700	96700	264507
10701	11108	4	applied	\N	\N	\N	\N	96701	96701	264508
10701	11109	5	applied	\N	\N	\N	\N	96702	96702	264509
10701	11110	6	applied	\N	\N	\N	\N	96703	96703	264510
10701	11111	7	applied	\N	\N	\N	\N	96704	96704	264511
10704	11114	0	applied	\N	\N	\N	\N	96709	96709	264516
10704	11115	1	applied	\N	\N	\N	\N	96710	96710	264517
10704	11116	2	applied	\N	\N	\N	\N	96711	96711	264518
10704	11117	3	applied	\N	\N	\N	\N	96712	96712	264519
10705	11118	0	applied	\N	\N	\N	\N	96713	96713	264520
10705	11120	2	applied	\N	\N	\N	\N	96715	96715	264522
10705	11121	3	applied	\N	\N	\N	\N	96716	96716	264523
10705	11122	4	applied	\N	\N	\N	\N	96717	96717	264524
10705	11123	5	applied	\N	\N	\N	\N	96718	96718	264525
10705	11124	6	applied	\N	\N	\N	\N	96719	96719	264526
10705	11125	7	applied	\N	\N	\N	\N	96720	96720	264527
10705	11126	8	applied	\N	\N	1000000000	\N	96721	96721	264528
10707	11127	0	applied	\N	\N	\N	\N	96731	96731	264538
10707	11128	1	applied	\N	\N	\N	\N	96732	96732	264539
10708	11127	0	applied	\N	\N	\N	\N	96733	96733	264540
10708	11128	1	applied	\N	\N	\N	\N	96734	96734	264541
10712	11132	0	applied	\N	\N	\N	\N	96740	96740	264547
10712	11133	1	applied	\N	\N	\N	\N	96741	96741	264548
10716	11132	0	applied	\N	\N	\N	\N	96748	96748	264555
10716	11133	1	applied	\N	\N	\N	\N	96749	96749	264556
10719	11134	0	applied	\N	\N	\N	\N	96754	96754	264561
10721	11138	0	applied	\N	\N	\N	\N	96758	96758	264565
10721	11139	1	applied	\N	\N	\N	\N	96759	96759	264566
10721	11140	2	applied	\N	\N	\N	\N	96760	96760	264567
10721	11141	3	applied	\N	\N	\N	\N	96761	96761	264568
10721	11142	4	applied	\N	\N	\N	\N	96762	96762	264569
10721	11143	5	applied	\N	\N	\N	\N	96763	96763	264570
10723	11144	0	applied	\N	\N	\N	\N	96770	96770	264577
10723	11145	1	applied	\N	\N	\N	\N	96771	96771	264578
10725	11138	0	applied	\N	\N	\N	\N	96774	96774	264581
10725	10781	1	applied	\N	\N	\N	\N	96775	96775	264582
10725	10791	2	applied	\N	\N	\N	\N	96776	96776	264583
10725	10792	3	applied	\N	\N	\N	\N	96777	96777	264584
10725	10793	4	applied	\N	\N	\N	\N	96778	96778	264585
10725	10794	5	applied	\N	\N	\N	\N	96779	96779	264586
10725	10764	6	applied	\N	\N	\N	\N	96780	96780	264587
10725	10765	7	applied	\N	\N	\N	\N	96781	96781	264588
10725	10771	9	applied	\N	\N	\N	\N	96783	96783	264590
10725	10772	10	applied	\N	\N	\N	\N	96784	96784	264591
10725	10773	11	applied	\N	\N	\N	\N	96785	96785	264592
10725	10774	12	applied	\N	\N	\N	\N	96786	96786	264593
10725	10775	13	applied	\N	\N	\N	\N	96787	96787	264594
10725	10779	14	applied	\N	\N	\N	\N	96788	96788	264595
10725	10786	15	applied	\N	\N	\N	\N	96789	96789	264596
10725	10787	16	applied	\N	\N	\N	\N	96790	96790	264597
10725	10788	17	applied	\N	\N	\N	\N	96791	96791	264598
10725	10789	18	applied	\N	\N	\N	\N	96792	96792	264599
10725	10790	19	applied	\N	\N	\N	\N	96793	96793	264600
10725	10767	20	applied	\N	\N	\N	\N	96794	96794	264601
10725	10768	21	applied	\N	\N	\N	\N	96795	96795	264602
10725	10769	22	applied	\N	\N	\N	\N	96796	96796	264603
10725	10770	24	applied	\N	\N	\N	\N	96797	96797	264604
10725	10776	25	applied	\N	\N	\N	\N	96798	96798	264605
10650	11040	0	applied	\N	\N	\N	\N	96528	96528	264335
10695	11100	4	applied	\N	\N	\N	\N	96661	96661	264468
10696	11101	0	applied	\N	\N	\N	\N	96662	96662	264469
10696	11102	1	applied	\N	\N	\N	\N	96663	96663	264470
10699	11104	0	applied	\N	\N	\N	\N	96681	96681	264488
10699	11105	1	applied	\N	\N	\N	\N	96682	96682	264489
10699	11106	2	applied	\N	\N	\N	\N	96683	96683	264490
10699	11107	3	applied	\N	\N	\N	\N	96684	96684	264491
10699	11108	4	applied	\N	\N	\N	\N	96685	96685	264492
10699	11109	5	applied	\N	\N	\N	\N	96686	96686	264493
10699	11110	6	applied	\N	\N	\N	\N	96687	96687	264494
10699	11111	7	applied	\N	\N	\N	\N	96688	96688	264495
10703	11112	0	applied	\N	\N	\N	\N	96707	96707	264514
10703	11113	1	applied	\N	\N	\N	\N	96708	96708	264515
10714	11132	0	applied	\N	\N	\N	\N	96744	96744	264551
10714	11133	1	applied	\N	\N	\N	\N	96745	96745	264552
10715	11132	0	applied	\N	\N	\N	\N	96746	96746	264553
10715	11133	1	applied	\N	\N	\N	\N	96747	96747	264554
10717	11134	0	applied	\N	\N	\N	\N	96750	96750	264557
10717	11135	1	applied	\N	\N	\N	\N	96751	96751	264558
10722	11139	1	applied	\N	\N	\N	\N	96765	96765	264572
10722	11140	2	applied	\N	\N	\N	\N	96766	96766	264573
10722	11141	3	applied	\N	\N	\N	\N	96767	96767	264574
10722	11142	4	applied	\N	\N	\N	\N	96768	96768	264575
10722	11143	5	applied	\N	\N	\N	\N	96769	96769	264576
10724	11144	0	applied	\N	\N	\N	\N	96772	96772	264579
10724	11145	1	applied	\N	\N	\N	\N	96773	96773	264580
10725	10777	26	applied	\N	\N	\N	\N	96799	96799	264606
10725	10778	27	applied	\N	\N	\N	\N	96800	96800	264607
10725	10780	28	applied	\N	\N	\N	\N	96801	96801	264608
10725	10782	29	applied	\N	\N	\N	\N	96802	96802	264609
10725	10783	30	applied	\N	\N	\N	\N	96803	96803	264610
10725	10784	31	applied	\N	\N	\N	\N	96804	96804	264611
10726	11146	0	applied	\N	\N	\N	\N	96899	96899	264706
10726	11147	1	applied	\N	\N	\N	\N	96900	96900	264707
10726	11148	2	applied	\N	\N	\N	\N	96901	96901	264708
10726	11150	4	applied	\N	\N	\N	\N	96903	96903	264710
10726	11151	5	applied	\N	\N	\N	\N	96904	96904	264711
10726	11152	6	applied	\N	\N	\N	\N	96905	96905	264712
10728	11153	0	applied	\N	\N	\N	\N	96915	96915	264722
10728	11154	1	applied	\N	\N	\N	\N	96916	96916	264723
10731	11155	0	applied	\N	\N	\N	\N	96920	96920	264727
10731	11156	1	applied	\N	\N	\N	\N	96921	96921	264728
10735	11159	0	applied	\N	\N	\N	\N	96929	96929	264736
10735	11160	1	applied	\N	\N	\N	\N	96930	96930	264737
10738	11169	0	applied	\N	\N	\N	\N	96939	96939	264746
10738	11170	1	applied	\N	\N	\N	\N	96940	96940	264747
10751	11182	0	applied	\N	\N	\N	\N	96972	96972	264779
10751	11183	1	applied	\N	\N	\N	\N	96973	96973	264780
10751	11184	2	applied	\N	\N	1000000000	\N	96974	96974	264781
10753	11192	0	applied	\N	\N	\N	\N	96982	96982	264789
10753	11193	1	applied	\N	\N	\N	\N	96983	96983	264790
10753	11195	3	applied	\N	\N	\N	\N	96985	96985	264792
10753	11196	4	applied	\N	\N	\N	\N	96986	96986	264793
10753	11197	5	applied	\N	\N	\N	\N	96987	96987	264794
10758	11202	0	applied	\N	\N	\N	\N	96994	96994	264801
10758	11203	1	applied	\N	\N	\N	\N	96995	96995	264802
10766	11212	0	applied	\N	\N	\N	\N	97020	97020	264827
10766	11213	1	applied	\N	\N	\N	\N	97021	97021	264828
10766	11214	2	applied	\N	\N	\N	\N	97022	97022	264829
10766	11215	3	applied	\N	\N	\N	\N	97023	97023	264830
10771	11218	0	applied	\N	\N	\N	\N	97038	97038	264845
10771	11219	1	applied	\N	\N	\N	\N	97039	97039	264846
10771	11220	2	applied	\N	\N	\N	\N	97040	97040	264847
10771	11221	3	applied	\N	\N	\N	\N	97041	97041	264848
10775	11230	0	applied	\N	\N	\N	\N	97054	97054	264861
10775	11231	1	applied	\N	\N	\N	\N	97055	97055	264862
10775	11232	2	applied	\N	\N	\N	\N	97056	97056	264863
10775	11234	4	applied	\N	\N	\N	\N	97058	97058	264865
10783	11239	0	applied	\N	\N	\N	\N	97082	97082	264889
10783	11240	1	applied	\N	\N	\N	\N	97083	97083	264890
10783	11241	2	applied	\N	\N	\N	\N	97084	97084	264891
10783	11242	3	applied	\N	\N	\N	\N	97085	97085	264892
10787	11248	0	applied	\N	\N	\N	\N	97218	97218	265025
10787	11249	1	applied	\N	\N	\N	\N	97219	97219	265026
10787	11250	2	applied	\N	\N	\N	\N	97220	97220	265027
10790	11257	0	applied	\N	\N	\N	\N	97227	97227	265034
10790	11258	1	applied	\N	\N	\N	\N	97228	97228	265035
10790	11259	2	applied	\N	\N	\N	\N	97229	97229	265036
10790	11260	3	applied	\N	\N	\N	\N	97230	97230	265037
10790	11261	4	applied	\N	\N	\N	\N	97231	97231	265038
10793	11268	0	applied	\N	\N	\N	\N	97244	97244	265051
10793	11269	1	applied	\N	\N	\N	\N	97245	97245	265052
10793	11270	2	applied	\N	\N	\N	\N	97246	97246	265053
10793	11272	4	applied	\N	\N	\N	\N	97248	97248	265055
10800	11275	0	applied	\N	\N	\N	\N	97267	97267	265074
10800	11276	1	applied	\N	\N	\N	\N	97268	97268	265075
10800	11277	2	applied	\N	\N	\N	\N	97269	97269	265076
10800	11278	3	applied	\N	\N	\N	\N	97270	97270	265077
10800	11279	4	applied	\N	\N	\N	\N	97271	97271	265078
10803	11284	0	applied	\N	\N	\N	\N	97401	97401	265208
10803	11285	1	applied	\N	\N	\N	\N	97402	97402	265209
10803	11286	2	applied	\N	\N	\N	\N	97403	97403	265210
10803	11287	3	applied	\N	\N	\N	\N	97404	97404	265211
10817	11309	1	applied	\N	\N	\N	\N	97569	97569	265375
10817	11310	2	applied	\N	\N	\N	\N	97570	97570	265376
10819	11311	0	applied	\N	\N	\N	\N	97574	97574	265379
10819	11312	1	applied	\N	\N	\N	\N	97575	97575	265380
10824	11316	0	applied	\N	\N	1000000000	\N	97586	97586	265391
10824	11317	1	applied	\N	\N	1000000000	\N	97587	97587	265392
10824	11318	2	applied	\N	\N	\N	\N	97588	97588	265393
10834	11335	0	applied	\N	\N	\N	\N	97617	97617	265422
10834	11336	1	applied	\N	\N	\N	\N	97618	97618	265423
10834	11337	2	applied	\N	\N	\N	\N	97619	97619	265424
10834	11338	3	applied	\N	\N	\N	\N	97620	97620	265425
10837	11339	0	applied	\N	\N	\N	\N	97631	97631	265436
10837	11340	1	applied	\N	\N	\N	\N	97632	97632	265437
10837	11341	2	applied	\N	\N	\N	\N	97633	97633	265438
10837	11342	3	applied	\N	\N	\N	\N	97634	97634	265439
10837	11343	4	applied	\N	\N	\N	\N	97635	97635	265440
10695	11098	2	applied	\N	\N	\N	\N	96659	96659	264466
10695	11099	3	applied	\N	\N	\N	\N	96660	96660	264467
10725	10798	36	applied	\N	\N	\N	\N	96809	96809	264616
10725	10799	37	applied	\N	\N	\N	\N	96810	96810	264617
10725	10800	38	applied	\N	\N	\N	\N	96811	96811	264618
10725	10801	39	applied	\N	\N	\N	\N	96812	96812	264619
10725	10804	40	applied	\N	\N	\N	\N	96813	96813	264620
10725	10807	41	applied	\N	\N	\N	\N	96814	96814	264621
10725	10808	42	applied	\N	\N	\N	\N	96815	96815	264622
10725	10809	43	applied	\N	\N	\N	\N	96816	96816	264623
10725	10810	44	applied	\N	\N	\N	\N	96817	96817	264624
10725	10811	45	applied	\N	\N	\N	\N	96818	96818	264625
10725	10812	46	applied	\N	\N	\N	\N	96819	96819	264626
10725	10813	47	applied	\N	\N	\N	\N	96820	96820	264627
10725	10814	48	applied	\N	\N	\N	\N	96821	96821	264628
10725	10816	49	applied	\N	\N	\N	\N	96822	96822	264629
10725	10820	51	applied	\N	\N	\N	\N	96824	96824	264631
10725	10821	52	applied	\N	\N	\N	\N	96825	96825	264632
10725	10828	53	applied	\N	\N	\N	\N	96826	96826	264633
10725	10829	54	applied	\N	\N	\N	\N	96827	96827	264634
10725	10830	55	applied	\N	\N	\N	\N	96828	96828	264635
10725	10831	56	applied	\N	\N	\N	\N	96829	96829	264636
10725	10833	57	applied	\N	\N	\N	\N	96830	96830	264637
10725	10835	58	applied	\N	\N	\N	\N	96831	96831	264638
10725	10836	59	applied	\N	\N	\N	\N	96832	96832	264639
10725	10837	60	applied	\N	\N	\N	\N	96833	96833	264640
10725	10841	61	applied	\N	\N	\N	\N	96834	96834	264641
10725	10842	62	applied	\N	\N	\N	\N	96835	96835	264642
10725	10844	63	applied	\N	\N	\N	\N	96836	96836	264643
10725	10802	64	applied	\N	\N	\N	\N	96837	96837	264644
10725	10803	65	applied	\N	\N	\N	\N	96838	96838	264645
10725	10805	66	applied	\N	\N	\N	\N	96839	96839	264646
10725	10815	68	applied	\N	\N	\N	\N	96841	96841	264648
10725	10817	69	applied	\N	\N	\N	\N	96842	96842	264649
10725	10818	70	applied	\N	\N	\N	\N	96843	96843	264650
10725	10822	71	applied	\N	\N	\N	\N	96844	96844	264651
10725	10823	72	applied	\N	\N	\N	\N	96845	96845	264652
10725	10824	73	applied	\N	\N	\N	\N	96846	96846	264653
10725	10825	74	applied	\N	\N	\N	\N	96847	96847	264654
10725	10826	75	applied	\N	\N	\N	\N	96848	96848	264655
10725	10827	76	applied	\N	\N	\N	\N	96849	96849	264656
10725	10832	77	applied	\N	\N	\N	\N	96850	96850	264657
10725	10834	78	applied	\N	\N	\N	\N	96851	96851	264658
10725	10838	79	applied	\N	\N	\N	\N	96852	96852	264659
10725	10839	80	applied	\N	\N	\N	\N	96853	96853	264660
10725	10840	81	applied	\N	\N	\N	\N	96854	96854	264661
10725	10843	82	applied	\N	\N	\N	\N	96855	96855	264662
10725	10845	83	applied	\N	\N	\N	\N	96856	96856	264663
10725	10847	85	applied	\N	\N	\N	\N	96858	96858	264665
10725	10851	86	applied	\N	\N	\N	\N	96859	96859	264666
10725	10852	87	applied	\N	\N	\N	\N	96860	96860	264667
10725	10856	88	applied	\N	\N	\N	\N	96861	96861	264668
10725	10857	89	applied	\N	\N	\N	\N	96862	96862	264669
10725	10858	90	applied	\N	\N	\N	\N	96863	96863	264670
10725	10859	91	applied	\N	\N	\N	\N	96864	96864	264671
10725	10862	92	applied	\N	\N	\N	\N	96865	96865	264672
10725	10866	93	applied	\N	\N	\N	\N	96866	96866	264673
10725	10870	94	applied	\N	\N	\N	\N	96867	96867	264674
10725	10873	95	applied	\N	\N	\N	\N	96868	96868	264675
10725	10875	96	applied	\N	\N	\N	\N	96869	96869	264676
10725	10877	97	applied	\N	\N	\N	\N	96870	96870	264677
10725	10879	98	applied	\N	\N	\N	\N	96871	96871	264678
10725	10848	99	applied	\N	\N	\N	\N	96872	96872	264679
10725	10849	100	applied	\N	\N	\N	\N	96873	96873	264680
10725	10853	102	applied	\N	\N	\N	\N	96875	96875	264682
10725	10854	103	applied	\N	\N	\N	\N	96876	96876	264683
10725	10855	104	applied	\N	\N	\N	\N	96877	96877	264684
10725	10860	105	applied	\N	\N	\N	\N	96878	96878	264685
10725	10861	106	applied	\N	\N	\N	\N	96879	96879	264686
10725	10863	107	applied	\N	\N	\N	\N	96880	96880	264687
10725	10867	108	applied	\N	\N	\N	\N	96881	96881	264688
10725	10868	109	applied	\N	\N	\N	\N	96882	96882	264689
10725	10871	110	applied	\N	\N	\N	\N	96883	96883	264690
10725	10872	111	applied	\N	\N	\N	\N	96884	96884	264691
10725	10876	112	applied	\N	\N	\N	\N	96885	96885	264692
10725	10878	113	applied	\N	\N	\N	\N	96886	96886	264693
10725	10880	114	applied	\N	\N	\N	\N	96887	96887	264694
10725	10881	115	applied	\N	\N	\N	\N	96888	96888	264695
10725	10883	116	applied	\N	\N	\N	\N	96889	96889	264696
10725	10887	117	applied	\N	\N	\N	\N	96890	96890	264697
10725	10892	119	applied	\N	\N	\N	\N	96892	96892	264699
10725	10893	120	applied	\N	\N	\N	\N	96893	96893	264700
10725	10895	121	applied	\N	\N	\N	\N	96894	96894	264701
10725	10897	122	applied	\N	\N	\N	\N	96895	96895	264702
10725	10898	123	applied	\N	\N	\N	\N	96896	96896	264703
10725	10899	124	applied	\N	\N	\N	\N	96897	96897	264704
10725	10904	125	applied	\N	\N	\N	\N	96898	96898	264705
10727	11146	0	applied	\N	\N	\N	\N	96906	96906	264713
10727	11147	1	applied	\N	\N	\N	\N	96907	96907	264714
10727	11144	2	applied	\N	\N	\N	\N	96908	96908	264715
10727	11145	3	applied	\N	\N	\N	\N	96909	96909	264716
10727	11148	4	applied	\N	\N	\N	\N	96910	96910	264717
10727	11149	5	applied	\N	\N	\N	\N	96911	96911	264718
10727	11150	6	applied	\N	\N	\N	\N	96912	96912	264719
10727	11151	7	applied	\N	\N	\N	\N	96913	96913	264720
10727	11152	8	applied	\N	\N	\N	\N	96914	96914	264721
10734	11159	0	applied	\N	\N	\N	\N	96927	96927	264734
10734	11160	1	applied	\N	\N	\N	\N	96928	96928	264735
10737	11165	0	applied	\N	\N	\N	\N	96935	96935	264742
10737	11166	1	applied	\N	\N	\N	\N	96936	96936	264743
10737	11167	2	applied	\N	\N	\N	\N	96937	96937	264744
10737	11168	3	applied	\N	\N	\N	\N	96938	96938	264745
10742	11175	0	applied	\N	\N	\N	\N	96949	96949	264756
10742	11176	1	applied	\N	\N	\N	\N	96950	96950	264757
10742	11177	3	applied	\N	\N	\N	\N	96951	96951	264758
10744	11178	0	applied	\N	\N	\N	\N	96955	96955	264762
10744	11179	1	applied	\N	\N	\N	\N	96956	96956	264763
10745	11178	0	applied	\N	\N	\N	\N	96957	96957	264764
10745	11179	1	applied	\N	\N	\N	\N	96958	96958	264765
10749	11182	0	applied	\N	\N	\N	\N	96966	96966	264773
10749	11183	1	applied	\N	\N	\N	\N	96967	96967	264774
10725	10796	34	applied	\N	\N	\N	\N	96807	96807	264614
10725	10797	35	applied	\N	\N	\N	\N	96808	96808	264615
10764	11210	0	applied	\N	\N	\N	\N	97014	97014	264821
10764	11211	1	applied	\N	\N	\N	\N	97015	97015	264822
10765	11214	2	applied	\N	\N	\N	\N	97018	97018	264825
10765	11215	3	applied	\N	\N	\N	\N	97019	97019	264826
10769	11218	0	applied	\N	\N	\N	\N	97030	97030	264837
10769	11219	1	applied	\N	\N	\N	\N	97031	97031	264838
10769	11220	2	applied	\N	\N	\N	\N	97032	97032	264839
10769	11221	3	applied	\N	\N	\N	\N	97033	97033	264840
10770	11218	0	applied	\N	\N	\N	\N	97034	97034	264841
10770	11219	1	applied	\N	\N	\N	\N	97035	97035	264842
10770	11220	2	applied	\N	\N	\N	\N	97036	97036	264843
10770	11221	3	applied	\N	\N	\N	\N	97037	97037	264844
10772	11222	0	applied	\N	\N	\N	\N	97042	97042	264849
10779	11236	0	applied	\N	\N	\N	\N	97068	97068	264875
10779	11238	2	applied	\N	\N	\N	\N	97070	97070	264877
10781	11239	0	applied	\N	\N	\N	\N	97074	97074	264881
10781	11240	1	applied	\N	\N	\N	\N	97075	97075	264882
10781	11241	2	applied	\N	\N	\N	\N	97076	97076	264883
10781	11242	3	applied	\N	\N	\N	\N	97077	97077	264884
10788	11251	0	applied	\N	\N	\N	\N	97221	97221	265028
10788	11252	1	applied	\N	\N	\N	\N	97222	97222	265029
10788	11253	2	applied	\N	\N	\N	\N	97223	97223	265030
10788	11254	3	applied	\N	\N	\N	\N	97224	97224	265031
10792	11262	0	applied	\N	\N	\N	\N	97238	97238	265045
10792	11263	1	applied	\N	\N	\N	\N	97239	97239	265046
10792	11264	2	applied	\N	\N	\N	\N	97240	97240	265047
10792	11265	3	applied	\N	\N	\N	\N	97241	97241	265048
10792	11266	4	applied	\N	\N	\N	\N	97242	97242	265049
10792	11267	5	applied	\N	\N	\N	\N	97243	97243	265050
10795	11268	0	applied	\N	\N	\N	\N	97254	97254	265061
10795	11270	2	applied	\N	\N	\N	\N	97256	97256	265063
10795	11271	3	applied	\N	\N	\N	\N	97257	97257	265064
10795	11272	4	applied	\N	\N	\N	\N	97258	97258	265065
10797	11273	0	applied	\N	\N	\N	\N	97261	97261	265068
10797	11274	1	applied	\N	\N	\N	\N	97262	97262	265069
10807	11290	0	applied	\N	\N	\N	\N	97414	97414	265221
10807	11291	1	applied	\N	\N	\N	\N	97415	97415	265222
10807	11292	2	applied	\N	\N	\N	\N	97416	97416	265223
10811	11293	0	applied	\N	\N	\N	\N	97548	97548	265355
10811	11294	1	applied	\N	\N	\N	\N	97549	97549	265356
10811	11295	2	applied	\N	\N	\N	\N	97550	97550	265357
10813	11296	0	applied	\N	\N	\N	\N	97553	97553	265360
10813	11297	1	applied	\N	\N	\N	\N	97554	97554	265361
10815	11297	0	applied	\N	\N	\N	\N	97557	97557	265364
10821	11311	0	applied	\N	\N	\N	\N	97578	97578	265383
10821	11312	1	applied	\N	\N	\N	\N	97579	97579	265384
10825	11320	1	applied	\N	\N	1000000000	\N	97590	97590	265395
10825	11321	2	applied	\N	\N	\N	\N	97591	97591	265396
10830	11327	0	applied	\N	\N	\N	\N	97603	97603	265408
10830	11328	1	applied	\N	\N	\N	\N	97604	97604	265409
10832	11322	0	applied	\N	\N	\N	\N	97607	97607	265412
10832	11325	1	applied	\N	\N	\N	\N	97608	97608	265413
10832	11326	2	applied	\N	\N	\N	\N	97609	97609	265414
10832	11328	3	applied	\N	\N	\N	\N	97610	97610	265415
10840	11349	0	applied	\N	\N	\N	\N	97651	97651	265456
10840	11350	1	applied	\N	\N	\N	\N	97652	97652	265457
10843	11362	0	applied	\N	\N	\N	\N	97664	97664	265469
10843	11363	1	applied	\N	\N	\N	\N	97665	97665	265470
10843	11358	2	applied	\N	\N	\N	\N	97666	97666	265471
10843	11359	3	applied	\N	\N	\N	\N	97667	97667	265472
10843	11360	4	applied	\N	\N	\N	\N	97668	97668	265473
10843	11361	5	applied	\N	\N	\N	\N	97669	97669	265474
10845	11365	1	applied	\N	\N	\N	\N	97677	97677	265482
10845	11362	2	applied	\N	\N	\N	\N	97678	97678	265483
10845	11366	3	applied	\N	\N	\N	\N	97679	97679	265484
10845	11363	4	applied	\N	\N	\N	\N	97680	97680	265485
10845	11367	5	applied	\N	\N	\N	\N	97681	97681	265486
10845	11368	6	applied	\N	\N	\N	\N	97682	97682	265487
10848	11371	0	applied	\N	\N	\N	\N	97690	97690	265495
10848	11372	1	applied	\N	\N	\N	\N	97691	97691	265496
10848	11373	2	applied	\N	\N	\N	\N	97692	97692	265497
10848	11374	3	applied	\N	\N	\N	\N	97693	97693	265498
10848	11375	4	applied	\N	\N	\N	\N	97694	97694	265499
10850	11382	0	applied	\N	\N	\N	\N	97701	97701	265506
10850	11383	1	applied	\N	\N	\N	\N	97702	97702	265507
10859	11396	0	applied	\N	\N	\N	\N	97838	97838	265642
10859	11397	1	applied	\N	\N	\N	\N	97839	97839	265643
10860	11398	0	applied	\N	\N	\N	\N	97840	97840	265644
10860	11400	2	applied	\N	\N	\N	\N	97842	97842	265646
10860	11401	3	applied	\N	\N	\N	\N	97843	97843	265647
10863	11398	0	applied	\N	\N	\N	\N	97852	97852	265656
10863	11399	1	applied	\N	\N	\N	\N	97853	97853	265657
10863	11400	2	applied	\N	\N	\N	\N	97854	97854	265658
10863	11401	3	applied	\N	\N	\N	\N	97855	97855	265659
10864	11402	0	applied	\N	\N	\N	\N	97856	97856	265660
10864	11403	1	applied	\N	\N	\N	\N	97857	97857	265661
10867	11404	0	applied	\N	\N	\N	\N	97863	97863	265667
10867	11405	1	applied	\N	\N	\N	\N	97864	97864	265668
10867	11406	2	applied	\N	\N	\N	\N	97865	97865	265669
10870	11404	0	applied	\N	\N	\N	\N	97876	97876	265680
10870	11407	1	applied	\N	\N	\N	\N	97877	97877	265681
10870	11371	2	applied	\N	\N	\N	\N	97878	97878	265682
10870	11372	3	applied	\N	\N	\N	\N	97879	97879	265683
10870	11373	4	applied	\N	\N	\N	\N	97880	97880	265684
10870	11377	6	applied	\N	\N	\N	\N	97882	97882	265686
10870	11374	7	applied	\N	\N	\N	\N	97883	97883	265687
10870	11375	8	applied	\N	\N	\N	\N	97884	97884	265688
10870	11378	9	applied	\N	\N	\N	\N	97885	97885	265689
10870	11379	10	applied	\N	\N	\N	\N	97886	97886	265690
10870	11382	11	applied	\N	\N	\N	\N	97887	97887	265691
10870	11386	12	applied	\N	\N	\N	\N	97888	97888	265692
10870	11387	13	applied	\N	\N	\N	\N	97889	97889	265693
10870	11390	14	applied	\N	\N	\N	\N	97890	97890	265694
10870	11383	15	applied	\N	\N	\N	\N	97891	97891	265695
10870	11384	16	applied	\N	\N	\N	\N	97892	97892	265696
10870	11385	17	applied	\N	\N	\N	\N	97893	97893	265697
10870	11388	18	applied	\N	\N	\N	\N	97894	97894	265698
10870	11389	19	applied	\N	\N	\N	\N	97895	97895	265699
10870	11391	20	applied	\N	\N	\N	\N	97896	97896	265700
10870	11395	21	applied	\N	\N	\N	\N	97897	97897	265701
10760	11207	3	applied	\N	\N	\N	\N	97003	97003	264810
10774	11227	1	applied	\N	\N	\N	\N	97051	97051	264858
10774	11228	2	applied	\N	\N	\N	\N	97052	97052	264859
10774	11229	3	applied	\N	\N	\N	\N	97053	97053	264860
10776	11231	1	applied	\N	\N	\N	\N	97060	97060	264867
10776	11232	2	applied	\N	\N	\N	\N	97061	97061	264868
10776	11233	3	applied	\N	\N	\N	\N	97062	97062	264869
10776	11234	4	applied	\N	\N	\N	\N	97063	97063	264870
10777	11235	0	applied	\N	\N	\N	\N	97064	97064	264871
10778	11236	0	applied	\N	\N	\N	\N	97065	97065	264872
10778	11237	1	applied	\N	\N	\N	\N	97066	97066	264873
10778	11238	2	applied	\N	\N	\N	\N	97067	97067	264874
10782	11239	0	applied	\N	\N	\N	\N	97078	97078	264885
10782	11240	1	applied	\N	\N	\N	\N	97079	97079	264886
10782	11241	2	applied	\N	\N	\N	\N	97080	97080	264887
10782	11242	3	applied	\N	\N	\N	\N	97081	97081	264888
10784	11138	0	applied	\N	\N	\N	\N	97086	97086	264893
10784	11147	2	applied	\N	\N	\N	\N	97088	97088	264895
10784	11243	3	applied	\N	\N	\N	\N	97089	97089	264896
10784	10881	4	applied	\N	\N	\N	\N	97090	97090	264897
10784	10883	5	applied	\N	\N	\N	\N	97091	97091	264898
10784	11227	6	applied	\N	\N	\N	\N	97092	97092	264899
10784	11218	7	applied	\N	\N	\N	\N	97093	97093	264900
10784	11220	8	applied	\N	\N	\N	\N	97094	97094	264901
10784	11229	9	applied	\N	\N	\N	\N	97095	97095	264902
10784	11230	10	applied	\N	\N	\N	\N	97096	97096	264903
10784	11236	11	applied	\N	\N	\N	\N	97097	97097	264904
10784	10887	12	applied	\N	\N	\N	\N	97098	97098	264905
10784	10888	13	applied	\N	\N	\N	\N	97099	97099	264906
10784	10892	14	applied	\N	\N	\N	\N	97100	97100	264907
10784	10893	15	applied	\N	\N	\N	\N	97101	97101	264908
10784	10895	16	applied	\N	\N	\N	\N	97102	97102	264909
10784	10897	17	applied	\N	\N	\N	\N	97103	97103	264910
10784	10899	19	applied	\N	\N	\N	\N	97105	97105	264912
10784	10904	20	applied	\N	\N	\N	\N	97106	97106	264913
10784	10906	21	applied	\N	\N	\N	\N	97107	97107	264914
10784	10907	22	applied	\N	\N	\N	\N	97108	97108	264915
10784	10912	23	applied	\N	\N	\N	\N	97109	97109	264916
10784	10915	24	applied	\N	\N	\N	\N	97110	97110	264917
10784	10917	25	applied	\N	\N	\N	\N	97111	97111	264918
10784	10919	26	applied	\N	\N	\N	\N	97112	97112	264919
10784	10920	27	applied	\N	\N	\N	\N	97113	97113	264920
10784	10923	28	applied	\N	\N	\N	\N	97114	97114	264921
10784	10925	29	applied	\N	\N	\N	\N	97115	97115	264922
10784	10927	30	applied	\N	\N	\N	\N	97116	97116	264923
10784	10928	31	applied	\N	\N	\N	\N	97117	97117	264924
10784	10931	32	applied	\N	\N	\N	\N	97118	97118	264925
10784	10932	33	applied	\N	\N	\N	\N	97119	97119	264926
10784	10933	34	applied	\N	\N	\N	\N	97120	97120	264927
10784	10940	36	applied	\N	\N	\N	\N	97122	97122	264929
10784	10941	37	applied	\N	\N	\N	\N	97123	97123	264930
10784	10942	38	applied	\N	\N	\N	\N	97124	97124	264931
10784	10943	39	applied	\N	\N	\N	\N	97125	97125	264932
10784	10946	40	applied	\N	\N	\N	\N	97126	97126	264933
10784	10947	41	applied	\N	\N	\N	\N	97127	97127	264934
10784	10950	42	applied	\N	\N	\N	\N	97128	97128	264935
10784	10952	43	applied	\N	\N	\N	\N	97129	97129	264936
10784	10953	44	applied	\N	\N	\N	\N	97130	97130	264937
10784	10957	45	applied	\N	\N	\N	\N	97131	97131	264938
10784	10958	46	applied	\N	\N	\N	\N	97132	97132	264939
10784	10959	47	applied	\N	\N	\N	\N	97133	97133	264940
10784	10963	48	applied	\N	\N	\N	\N	97134	97134	264941
10784	10964	49	applied	\N	\N	\N	\N	97135	97135	264942
10784	10966	50	applied	\N	\N	\N	\N	97136	97136	264943
10784	10968	51	applied	\N	\N	\N	\N	97137	97137	264944
10784	10972	53	applied	\N	\N	\N	\N	97139	97139	264946
10784	10974	54	applied	\N	\N	\N	\N	97140	97140	264947
10784	10975	55	applied	\N	\N	\N	\N	97141	97141	264948
10784	10978	56	applied	\N	\N	\N	\N	97142	97142	264949
10784	10979	57	applied	\N	\N	\N	\N	97143	97143	264950
10784	10980	58	applied	\N	\N	\N	\N	97144	97144	264951
10784	10984	59	applied	\N	\N	\N	\N	97145	97145	264952
10784	10985	60	applied	\N	\N	\N	\N	97146	97146	264953
10784	10989	61	applied	\N	\N	\N	\N	97147	97147	264954
10784	10990	62	applied	\N	\N	\N	\N	97148	97148	264955
10784	10994	63	applied	\N	\N	\N	\N	97149	97149	264956
10784	10995	64	applied	\N	\N	\N	\N	97150	97150	264957
10784	10999	65	applied	\N	\N	\N	\N	97151	97151	264958
10784	11000	66	applied	\N	\N	\N	\N	97152	97152	264959
10784	11001	67	applied	\N	\N	\N	\N	97153	97153	264960
10784	11002	68	applied	\N	\N	\N	\N	97154	97154	264961
10784	11007	70	applied	\N	\N	\N	\N	97156	97156	264963
10784	11009	71	applied	\N	\N	\N	\N	97157	97157	264964
10784	11014	72	applied	\N	\N	\N	\N	97158	97158	264965
10784	11015	73	applied	\N	\N	\N	\N	97159	97159	264966
10784	11017	74	applied	\N	\N	\N	\N	97160	97160	264967
10784	11021	75	applied	\N	\N	\N	\N	97161	97161	264968
10784	11022	76	applied	\N	\N	\N	\N	97162	97162	264969
10784	11023	77	applied	\N	\N	\N	\N	97163	97163	264970
10784	11026	78	applied	\N	\N	\N	\N	97164	97164	264971
10784	11027	79	applied	\N	\N	\N	\N	97165	97165	264972
10784	11031	80	applied	\N	\N	\N	\N	97166	97166	264973
10784	11032	81	applied	\N	\N	\N	\N	97167	97167	264974
10784	11036	82	applied	\N	\N	\N	\N	97168	97168	264975
10784	11039	83	applied	\N	\N	\N	\N	97169	97169	264976
10784	11041	84	applied	\N	\N	\N	\N	97170	97170	264977
10784	11044	85	applied	\N	\N	\N	\N	97171	97171	264978
10784	11046	87	applied	\N	\N	\N	\N	97173	97173	264980
10784	11047	88	applied	\N	\N	\N	\N	97174	97174	264981
10784	11052	89	applied	\N	\N	\N	\N	97175	97175	264982
10784	11053	90	applied	\N	\N	\N	\N	97176	97176	264983
10784	11054	91	applied	\N	\N	\N	\N	97177	97177	264984
10784	11055	92	applied	\N	\N	\N	\N	97178	97178	264985
10784	11057	93	applied	\N	\N	\N	\N	97179	97179	264986
10784	11060	94	applied	\N	\N	\N	\N	97180	97180	264987
10784	11061	95	applied	\N	\N	\N	\N	97181	97181	264988
10784	11064	96	applied	\N	\N	\N	\N	97182	97182	264989
10784	11065	97	applied	\N	\N	\N	\N	97183	97183	264990
10784	11066	98	applied	\N	\N	\N	\N	97184	97184	264991
10784	11070	99	applied	\N	\N	\N	\N	97185	97185	264992
10784	11073	100	applied	\N	\N	\N	\N	97186	97186	264993
10772	11224	2	applied	\N	\N	\N	\N	97044	97044	264851
10772	11225	3	applied	\N	\N	\N	\N	97045	97045	264852
10784	11075	101	applied	\N	\N	\N	\N	97187	97187	264994
10784	11076	102	applied	\N	\N	\N	\N	97188	97188	264995
10784	11078	103	applied	\N	\N	\N	\N	97189	97189	264996
10784	11081	104	applied	\N	\N	\N	\N	97190	97190	264997
10784	11083	105	applied	\N	\N	\N	\N	97191	97191	264998
10784	11087	107	applied	\N	\N	\N	\N	97193	97193	265000
10784	11089	108	applied	\N	\N	\N	\N	97194	97194	265001
10784	11092	109	applied	\N	\N	\N	\N	97195	97195	265002
10784	11094	110	applied	\N	\N	\N	\N	97196	97196	265003
10784	11096	111	applied	\N	\N	\N	\N	97197	97197	265004
10784	11097	113	applied	\N	\N	\N	\N	97198	97198	265005
10784	11101	114	applied	\N	\N	\N	\N	97199	97199	265006
10784	11102	115	applied	\N	\N	\N	\N	97200	97200	265007
10784	11103	116	applied	\N	\N	\N	\N	97201	97201	265008
10784	11104	117	applied	\N	\N	\N	\N	97202	97202	265009
10784	11105	118	applied	\N	\N	\N	\N	97203	97203	265010
10784	11112	119	applied	\N	\N	\N	\N	97204	97204	265011
10784	11114	120	applied	\N	\N	\N	\N	97205	97205	265012
10784	11117	121	applied	\N	\N	\N	\N	97206	97206	265013
10784	11122	122	applied	\N	\N	\N	\N	97207	97207	265014
10784	11123	123	applied	\N	\N	\N	\N	97208	97208	265015
10784	11125	125	applied	\N	\N	\N	\N	97210	97210	265017
10785	11244	0	applied	\N	\N	\N	\N	97211	97211	265018
10785	11245	1	applied	\N	\N	1000000000	\N	97212	97212	265019
10785	11246	2	applied	\N	\N	\N	\N	97213	97213	265020
10785	11247	3	applied	\N	\N	\N	\N	97214	97214	265021
10786	11248	0	applied	\N	\N	\N	\N	97215	97215	265022
10786	11249	1	applied	\N	\N	\N	\N	97216	97216	265023
10786	11250	2	applied	\N	\N	\N	\N	97217	97217	265024
10789	11255	0	applied	\N	\N	\N	\N	97225	97225	265032
10789	11256	1	applied	\N	\N	\N	\N	97226	97226	265033
10791	11262	0	applied	\N	\N	\N	\N	97232	97232	265039
10791	11263	1	applied	\N	\N	\N	\N	97233	97233	265040
10791	11264	2	applied	\N	\N	\N	\N	97234	97234	265041
10791	11265	3	applied	\N	\N	\N	\N	97235	97235	265042
10791	11266	4	applied	\N	\N	\N	\N	97236	97236	265043
10791	11267	5	applied	\N	\N	\N	\N	97237	97237	265044
10794	11269	1	applied	\N	\N	\N	\N	97250	97250	265057
10794	11270	2	applied	\N	\N	\N	\N	97251	97251	265058
10794	11271	3	applied	\N	\N	\N	\N	97252	97252	265059
10794	11272	4	applied	\N	\N	\N	\N	97253	97253	265060
10796	11273	0	applied	\N	\N	\N	\N	97259	97259	265066
10796	11274	1	applied	\N	\N	\N	\N	97260	97260	265067
10798	11273	0	applied	\N	\N	\N	\N	97263	97263	265070
10798	11274	1	applied	\N	\N	\N	\N	97264	97264	265071
10799	11273	0	applied	\N	\N	\N	\N	97265	97265	265072
10799	11274	1	applied	\N	\N	\N	\N	97266	97266	265073
10801	11280	0	applied	\N	\N	\N	\N	97272	97272	265079
10801	11281	1	applied	\N	\N	\N	\N	97273	97273	265080
10801	11282	2	applied	\N	\N	\N	\N	97274	97274	265081
10801	11283	3	applied	\N	\N	\N	\N	97275	97275	265082
10802	11268	0	applied	\N	\N	\N	\N	97276	97276	265083
10802	11248	1	applied	\N	\N	\N	\N	97277	97277	265084
10804	11285	1	applied	\N	\N	\N	\N	97406	97406	265213
10804	11286	2	applied	\N	\N	\N	\N	97407	97407	265214
10804	11287	3	applied	\N	\N	\N	\N	97408	97408	265215
10806	11290	0	applied	\N	\N	\N	\N	97411	97411	265218
10806	11291	1	applied	\N	\N	\N	\N	97412	97412	265219
10806	11292	2	applied	\N	\N	\N	\N	97413	97413	265220
10810	11293	0	applied	\N	\N	\N	\N	97545	97545	265352
10810	11294	1	applied	\N	\N	\N	\N	97546	97546	265353
10810	11295	2	applied	\N	\N	\N	\N	97547	97547	265354
10812	11293	0	applied	\N	\N	\N	\N	97551	97551	265358
10812	11294	1	applied	\N	\N	\N	\N	97552	97552	265359
10818	11309	1	applied	\N	\N	\N	\N	97572	97572	265377
10818	11310	2	applied	\N	\N	\N	\N	97573	97573	265378
10820	11311	0	applied	\N	\N	\N	\N	97576	97576	265381
10820	11312	1	applied	\N	\N	\N	\N	97577	97577	265382
10822	11313	0	applied	\N	\N	\N	\N	97580	97580	265385
10822	11314	1	applied	\N	\N	\N	\N	97581	97581	265386
10822	11315	2	applied	\N	\N	\N	\N	97582	97582	265387
10827	11319	0	applied	\N	\N	\N	\N	97595	97595	265400
10827	11320	1	applied	\N	\N	1000000000	\N	97596	97596	265401
10827	11321	2	applied	\N	\N	\N	\N	97597	97597	265402
10829	11326	0	applied	\N	\N	\N	\N	97602	97602	265407
10838	11339	0	applied	\N	\N	\N	\N	97640	97640	265445
10838	11340	1	applied	\N	\N	\N	\N	97641	97641	265446
10838	11341	2	applied	\N	\N	\N	\N	97642	97642	265447
10838	11342	3	applied	\N	\N	\N	\N	97643	97643	265448
10838	11343	4	applied	\N	\N	\N	\N	97644	97644	265449
10838	11344	5	applied	\N	\N	\N	\N	97645	97645	265450
10838	11345	6	applied	\N	\N	\N	\N	97646	97646	265451
10838	11347	7	applied	\N	\N	\N	\N	97647	97647	265452
10838	11348	8	applied	\N	\N	\N	\N	97648	97648	265453
10839	11349	0	applied	\N	\N	\N	\N	97649	97649	265454
10839	11350	1	applied	\N	\N	\N	\N	97650	97650	265455
10842	11358	0	applied	\N	\N	\N	\N	97660	97660	265465
10842	11359	1	applied	\N	\N	\N	\N	97661	97661	265466
10842	11360	2	applied	\N	\N	\N	\N	97662	97662	265467
10842	11361	3	applied	\N	\N	\N	\N	97663	97663	265468
10847	11371	0	applied	\N	\N	\N	\N	97685	97685	265490
10847	11372	1	applied	\N	\N	\N	\N	97686	97686	265491
10847	11373	2	applied	\N	\N	\N	\N	97687	97687	265492
10847	11375	4	applied	\N	\N	\N	\N	97689	97689	265494
10852	11384	0	applied	\N	\N	\N	\N	97705	97705	265510
10852	11385	1	applied	\N	\N	\N	\N	97706	97706	265511
10852	11386	2	applied	\N	\N	\N	\N	97707	97707	265512
10852	11387	3	applied	\N	\N	\N	\N	97708	97708	265513
10853	11388	0	applied	\N	\N	\N	\N	97709	97709	265514
10853	11389	1	applied	\N	\N	\N	\N	97710	97710	265515
10853	11390	2	applied	\N	\N	\N	\N	97711	97711	265516
10853	11391	3	applied	\N	\N	\N	\N	97712	97712	265517
10853	11392	4	applied	\N	\N	\N	\N	97713	97713	265518
10853	11393	5	applied	\N	\N	\N	\N	97714	97714	265519
10856	11396	0	applied	\N	\N	\N	\N	97832	97832	265636
10856	11397	1	applied	\N	\N	\N	\N	97833	97833	265637
10861	11398	0	applied	\N	\N	\N	\N	97844	97844	265648
10861	11399	1	applied	\N	\N	\N	\N	97845	97845	265649
10861	11400	2	applied	\N	\N	\N	\N	97846	97846	265650
10780	11237	1	applied	\N	\N	\N	\N	97072	97072	264879
10780	11238	2	applied	\N	\N	\N	\N	97073	97073	264880
10802	11135	6	applied	\N	\N	\N	\N	97282	97282	265089
10802	11278	7	applied	\N	\N	\N	\N	97283	97283	265090
10802	11137	8	applied	\N	\N	\N	\N	97284	97284	265091
10802	11139	9	applied	\N	\N	\N	\N	97285	97285	265092
10802	11142	10	applied	\N	\N	\N	\N	97286	97286	265093
10802	11145	11	applied	\N	\N	\N	\N	97287	97287	265094
10802	11148	12	applied	\N	\N	\N	\N	97288	97288	265095
10802	11154	13	applied	\N	\N	\N	\N	97289	97289	265096
10802	11156	14	applied	\N	\N	\N	\N	97290	97290	265097
10802	11157	15	applied	\N	\N	\N	\N	97291	97291	265098
10802	11160	16	applied	\N	\N	\N	\N	97292	97292	265099
10802	11161	17	applied	\N	\N	\N	\N	97293	97293	265100
10802	11162	18	applied	\N	\N	\N	\N	97294	97294	265101
10802	11165	19	applied	\N	\N	\N	\N	97295	97295	265102
10802	11166	20	applied	\N	\N	\N	\N	97296	97296	265103
10802	11170	21	applied	\N	\N	\N	\N	97297	97297	265104
10802	11174	23	applied	\N	\N	\N	\N	97299	97299	265106
10802	11175	24	applied	\N	\N	\N	\N	97300	97300	265107
10802	11179	25	applied	\N	\N	\N	\N	97301	97301	265108
10802	11181	26	applied	\N	\N	\N	\N	97302	97302	265109
10802	11182	27	applied	\N	\N	\N	\N	97303	97303	265110
10802	11185	28	applied	\N	\N	\N	\N	97304	97304	265111
10802	11190	29	applied	\N	\N	\N	\N	97305	97305	265112
10802	11191	30	applied	\N	\N	\N	\N	97306	97306	265113
10802	11195	31	applied	\N	\N	\N	\N	97307	97307	265114
10802	11196	32	applied	\N	\N	\N	\N	97308	97308	265115
10802	11197	33	applied	\N	\N	\N	\N	97309	97309	265116
10802	11198	34	applied	\N	\N	\N	\N	97310	97310	265117
10802	11200	35	applied	\N	\N	\N	\N	97311	97311	265118
10802	11203	36	applied	\N	\N	\N	\N	97312	97312	265119
10802	11204	37	applied	\N	\N	\N	\N	97313	97313	265120
10802	11205	38	applied	\N	\N	\N	\N	97314	97314	265121
10802	11211	40	applied	\N	\N	\N	\N	97316	97316	265123
10802	11214	41	applied	\N	\N	\N	\N	97317	97317	265124
10802	11215	42	applied	\N	\N	\N	\N	97318	97318	265125
10802	11219	43	applied	\N	\N	\N	\N	97319	97319	265126
10802	11222	44	applied	\N	\N	\N	\N	97320	97320	265127
10802	11225	45	applied	\N	\N	\N	\N	97321	97321	265128
10802	11228	46	applied	\N	\N	\N	\N	97322	97322	265129
10802	11233	47	applied	\N	\N	\N	\N	97323	97323	265130
10802	11234	48	applied	\N	\N	\N	\N	97324	97324	265131
10802	11235	49	applied	\N	\N	\N	\N	97325	97325	265132
10802	11237	50	applied	\N	\N	\N	\N	97326	97326	265133
10802	11239	51	applied	\N	\N	\N	\N	97327	97327	265134
10802	11240	52	applied	\N	\N	\N	\N	97328	97328	265135
10802	11246	53	applied	\N	\N	\N	\N	97329	97329	265136
10802	11249	54	applied	\N	\N	\N	\N	97330	97330	265137
10802	11252	55	applied	\N	\N	\N	\N	97331	97331	265138
10802	11256	57	applied	\N	\N	\N	\N	97333	97333	265140
10802	11258	58	applied	\N	\N	\N	\N	97334	97334	265141
10802	11259	59	applied	\N	\N	\N	\N	97335	97335	265142
10802	11265	60	applied	\N	\N	\N	\N	97336	97336	265143
10802	11266	61	applied	\N	\N	\N	\N	97337	97337	265144
10802	11267	62	applied	\N	\N	\N	\N	97338	97338	265145
10802	11271	63	applied	\N	\N	\N	\N	97339	97339	265146
10802	11272	64	applied	\N	\N	\N	\N	97340	97340	265147
10802	11273	65	applied	\N	\N	\N	\N	97341	97341	265148
10802	11275	66	applied	\N	\N	\N	\N	97342	97342	265149
10802	11277	67	applied	\N	\N	\N	\N	97343	97343	265150
10802	11280	68	applied	\N	\N	\N	\N	97344	97344	265151
10802	11281	69	applied	\N	\N	\N	\N	97345	97345	265152
10802	10882	70	applied	\N	\N	\N	\N	97346	97346	265153
10802	10884	71	applied	\N	\N	\N	\N	97347	97347	265154
10802	10886	72	applied	\N	\N	\N	\N	97348	97348	265155
10802	10890	74	applied	\N	\N	\N	\N	97350	97350	265157
10802	10891	75	applied	\N	\N	\N	\N	97351	97351	265158
10802	10896	76	applied	\N	\N	\N	\N	97352	97352	265159
10802	10900	77	applied	\N	\N	\N	\N	97353	97353	265160
10802	10901	78	applied	\N	\N	\N	\N	97354	97354	265161
10802	10902	79	applied	\N	\N	\N	\N	97355	97355	265162
10802	10903	80	applied	\N	\N	\N	\N	97356	97356	265163
10802	10905	81	applied	\N	\N	\N	\N	97357	97357	265164
10802	10908	82	applied	\N	\N	\N	\N	97358	97358	265165
10802	10909	83	applied	\N	\N	\N	\N	97359	97359	265166
10802	10913	84	applied	\N	\N	\N	\N	97360	97360	265167
10802	10914	85	applied	\N	\N	\N	\N	97361	97361	265168
10802	10916	86	applied	\N	\N	\N	\N	97362	97362	265169
10802	10918	87	applied	\N	\N	\N	\N	97363	97363	265170
10802	10921	88	applied	\N	\N	\N	\N	97364	97364	265171
10802	10922	89	applied	\N	\N	\N	\N	97365	97365	265172
10802	10926	91	applied	\N	\N	\N	\N	97367	97367	265174
10802	10929	92	applied	\N	\N	\N	\N	97368	97368	265175
10802	10930	93	applied	\N	\N	\N	\N	97369	97369	265176
10802	10934	94	applied	\N	\N	\N	\N	97370	97370	265177
10802	10936	95	applied	\N	\N	\N	\N	97371	97371	265178
10802	10937	96	applied	\N	\N	\N	\N	97372	97372	265179
10802	10938	97	applied	\N	\N	\N	\N	97373	97373	265180
10802	10939	98	applied	\N	\N	\N	\N	97374	97374	265181
10802	10944	99	applied	\N	\N	\N	\N	97375	97375	265182
10802	10945	100	applied	\N	\N	\N	\N	97376	97376	265183
10802	10948	101	applied	\N	\N	\N	\N	97377	97377	265184
10802	10949	102	applied	\N	\N	\N	\N	97378	97378	265185
10802	10951	103	applied	\N	\N	\N	\N	97379	97379	265186
10802	10954	104	applied	\N	\N	\N	\N	97380	97380	265187
10802	10955	105	applied	\N	\N	\N	\N	97381	97381	265188
10802	10956	106	applied	\N	\N	\N	\N	97382	97382	265189
10802	10961	108	applied	\N	\N	\N	\N	97384	97384	265191
10802	10962	109	applied	\N	\N	\N	\N	97385	97385	265192
10802	10965	110	applied	\N	\N	\N	\N	97386	97386	265193
10802	10967	111	applied	\N	\N	\N	\N	97387	97387	265194
10802	10969	113	applied	\N	\N	\N	\N	97388	97388	265195
10802	10971	114	applied	\N	\N	\N	\N	97389	97389	265196
10802	10973	115	applied	\N	\N	\N	\N	97390	97390	265197
10802	10976	116	applied	\N	\N	\N	\N	97391	97391	265198
10802	10977	117	applied	\N	\N	\N	\N	97392	97392	265199
10802	10981	118	applied	\N	\N	\N	\N	97393	97393	265200
10802	10982	119	applied	\N	\N	\N	\N	97394	97394	265201
10802	10983	120	applied	\N	\N	\N	\N	97395	97395	265202
10802	10986	121	applied	\N	\N	\N	\N	97396	97396	265203
10802	10988	122	applied	\N	\N	\N	\N	97397	97397	265204
10802	11129	3	applied	\N	\N	\N	\N	97279	97279	265086
10802	11131	4	applied	\N	\N	\N	\N	97280	97280	265087
10805	11289	1	applied	\N	\N	\N	\N	97410	97410	265217
10808	11290	0	applied	\N	\N	\N	\N	97417	97417	265224
10808	11291	1	applied	\N	\N	\N	\N	97418	97418	265225
10808	11292	2	applied	\N	\N	\N	\N	97419	97419	265226
10809	11268	0	applied	\N	\N	\N	\N	97420	97420	265227
10809	11146	1	applied	\N	\N	\N	\N	97421	97421	265228
10809	11147	2	applied	\N	\N	\N	\N	97422	97422	265229
10809	11243	3	applied	\N	\N	\N	\N	97423	97423	265230
10809	11227	4	applied	\N	\N	\N	\N	97424	97424	265231
10809	11218	5	applied	\N	\N	\N	\N	97425	97425	265232
10809	10906	6	applied	\N	\N	\N	\N	97426	97426	265233
10809	10907	7	applied	\N	\N	\N	\N	97427	97427	265234
10809	10912	8	applied	\N	\N	\N	\N	97428	97428	265235
10809	10915	9	applied	\N	\N	\N	\N	97429	97429	265236
10809	10917	10	applied	\N	\N	\N	\N	97430	97430	265237
10809	11220	11	applied	\N	\N	\N	\N	97431	97431	265238
10809	11230	13	applied	\N	\N	\N	\N	97433	97433	265240
10809	11236	14	applied	\N	\N	\N	\N	97434	97434	265241
10809	11248	15	applied	\N	\N	\N	\N	97435	97435	265242
10809	10919	16	applied	\N	\N	\N	\N	97436	97436	265243
10809	10920	17	applied	\N	\N	\N	\N	97437	97437	265244
10809	10923	18	applied	\N	\N	\N	\N	97438	97438	265245
10809	11278	19	applied	\N	\N	\N	\N	97439	97439	265246
10809	10925	20	applied	\N	\N	\N	\N	97440	97440	265247
10809	10927	21	applied	\N	\N	\N	\N	97441	97441	265248
10809	10928	22	applied	\N	\N	\N	\N	97442	97442	265249
10809	10931	24	applied	\N	\N	\N	\N	97443	97443	265250
10809	10932	25	applied	\N	\N	\N	\N	97444	97444	265251
10809	10933	26	applied	\N	\N	\N	\N	97445	97445	265252
10809	10935	27	applied	\N	\N	\N	\N	97446	97446	265253
10809	10940	28	applied	\N	\N	\N	\N	97447	97447	265254
10809	10941	29	applied	\N	\N	\N	\N	97448	97448	265255
10809	10943	31	applied	\N	\N	\N	\N	97450	97450	265257
10809	10946	32	applied	\N	\N	\N	\N	97451	97451	265258
10809	10947	33	applied	\N	\N	\N	\N	97452	97452	265259
10809	10950	34	applied	\N	\N	\N	\N	97453	97453	265260
10809	10952	35	applied	\N	\N	\N	\N	97454	97454	265261
10809	10953	36	applied	\N	\N	\N	\N	97455	97455	265262
10809	10957	37	applied	\N	\N	\N	\N	97456	97456	265263
10809	10958	38	applied	\N	\N	\N	\N	97457	97457	265264
10809	10959	39	applied	\N	\N	\N	\N	97458	97458	265265
10809	10963	40	applied	\N	\N	\N	\N	97459	97459	265266
10809	10964	41	applied	\N	\N	\N	\N	97460	97460	265267
10809	10966	42	applied	\N	\N	\N	\N	97461	97461	265268
10809	11292	43	applied	\N	\N	\N	\N	97462	97462	265269
10809	10968	44	applied	\N	\N	\N	\N	97463	97463	265270
10809	10970	45	applied	\N	\N	\N	\N	97464	97464	265271
10809	10972	46	applied	\N	\N	\N	\N	97465	97465	265272
10809	10975	48	applied	\N	\N	\N	\N	97467	97467	265274
10809	10978	49	applied	\N	\N	\N	\N	97468	97468	265275
10809	10979	50	applied	\N	\N	\N	\N	97469	97469	265276
10809	10980	51	applied	\N	\N	\N	\N	97470	97470	265277
10809	10984	52	applied	\N	\N	\N	\N	97471	97471	265278
10809	10985	53	applied	\N	\N	\N	\N	97472	97472	265279
10809	10989	54	applied	\N	\N	\N	\N	97473	97473	265280
10809	10990	55	applied	\N	\N	\N	\N	97474	97474	265281
10809	10994	56	applied	\N	\N	\N	\N	97475	97475	265282
10809	10995	57	applied	\N	\N	\N	\N	97476	97476	265283
10809	10999	58	applied	\N	\N	\N	\N	97477	97477	265284
10809	11000	59	applied	\N	\N	\N	\N	97478	97478	265285
10809	11001	60	applied	\N	\N	\N	\N	97479	97479	265286
10809	11002	61	applied	\N	\N	\N	\N	97480	97480	265287
10809	11005	62	applied	\N	\N	\N	\N	97481	97481	265288
10809	11007	63	applied	\N	\N	\N	\N	97482	97482	265289
10809	11014	65	applied	\N	\N	\N	\N	97484	97484	265291
10809	11015	66	applied	\N	\N	\N	\N	97485	97485	265292
10809	11017	67	applied	\N	\N	\N	\N	97486	97486	265293
10809	11021	68	applied	\N	\N	\N	\N	97487	97487	265294
10809	11022	69	applied	\N	\N	\N	\N	97488	97488	265295
10809	11023	70	applied	\N	\N	\N	\N	97489	97489	265296
10809	11026	71	applied	\N	\N	\N	\N	97490	97490	265297
10809	11027	72	applied	\N	\N	\N	\N	97491	97491	265298
10809	11031	73	applied	\N	\N	\N	\N	97492	97492	265299
10809	11032	74	applied	\N	\N	\N	\N	97493	97493	265300
10809	11036	75	applied	\N	\N	\N	\N	97494	97494	265301
10809	11039	76	applied	\N	\N	\N	\N	97495	97495	265302
10809	11041	77	applied	\N	\N	\N	\N	97496	97496	265303
10809	11044	78	applied	\N	\N	\N	\N	97497	97497	265304
10809	11045	79	applied	\N	\N	\N	\N	97498	97498	265305
10809	11046	80	applied	\N	\N	\N	\N	97499	97499	265306
10809	11052	82	applied	\N	\N	\N	\N	97501	97501	265308
10809	11053	83	applied	\N	\N	\N	\N	97502	97502	265309
10809	11054	84	applied	\N	\N	\N	\N	97503	97503	265310
10809	11055	85	applied	\N	\N	\N	\N	97504	97504	265311
10809	11057	86	applied	\N	\N	\N	\N	97505	97505	265312
10809	11060	87	applied	\N	\N	\N	\N	97506	97506	265313
10809	11061	88	applied	\N	\N	\N	\N	97507	97507	265314
10809	11064	89	applied	\N	\N	\N	\N	97508	97508	265315
10809	11065	90	applied	\N	\N	\N	\N	97509	97509	265316
10809	11066	91	applied	\N	\N	\N	\N	97510	97510	265317
10809	11070	92	applied	\N	\N	\N	\N	97511	97511	265318
10809	11073	93	applied	\N	\N	\N	\N	97512	97512	265319
10809	11075	94	applied	\N	\N	\N	\N	97513	97513	265320
10809	11076	95	applied	\N	\N	\N	\N	97514	97514	265321
10809	11078	96	applied	\N	\N	\N	\N	97515	97515	265322
10809	11081	97	applied	\N	\N	\N	\N	97516	97516	265323
10809	11085	99	applied	\N	\N	\N	\N	97518	97518	265325
10809	11087	100	applied	\N	\N	\N	\N	97519	97519	265326
10809	11089	101	applied	\N	\N	\N	\N	97520	97520	265327
10809	11092	102	applied	\N	\N	\N	\N	97521	97521	265328
10809	11094	103	applied	\N	\N	\N	\N	97522	97522	265329
10809	11096	104	applied	\N	\N	\N	\N	97523	97523	265330
10809	11097	105	applied	\N	\N	\N	\N	97524	97524	265331
10809	11101	106	applied	\N	\N	\N	\N	97525	97525	265332
10809	11102	107	applied	\N	\N	\N	\N	97526	97526	265333
10809	11103	108	applied	\N	\N	\N	\N	97527	97527	265334
10809	11104	109	applied	\N	\N	\N	\N	97528	97528	265335
10809	11105	110	applied	\N	\N	\N	\N	97529	97529	265336
10809	11112	111	applied	\N	\N	\N	\N	97530	97530	265337
10809	11114	112	applied	\N	\N	\N	\N	97531	97531	265338
10802	10992	124	applied	\N	\N	\N	\N	97399	97399	265206
10802	10993	125	applied	\N	\N	\N	\N	97400	97400	265207
10809	11124	116	applied	\N	\N	\N	\N	97535	97535	265342
10809	11125	117	applied	\N	\N	\N	\N	97536	97536	265343
10809	11127	118	applied	\N	\N	\N	\N	97537	97537	265344
10809	11129	119	applied	\N	\N	\N	\N	97538	97538	265345
10809	11131	120	applied	\N	\N	\N	\N	97539	97539	265346
10809	11132	121	applied	\N	\N	\N	\N	97540	97540	265347
10809	11135	122	applied	\N	\N	\N	\N	97541	97541	265348
10809	11137	123	applied	\N	\N	\N	\N	97542	97542	265349
10809	11139	124	applied	\N	\N	\N	\N	97543	97543	265350
10809	11142	125	applied	\N	\N	\N	\N	97544	97544	265351
10814	11297	1	applied	\N	\N	\N	\N	97556	97556	265363
10816	11298	0	applied	\N	\N	\N	\N	97558	97558	265365
10816	11299	1	applied	\N	\N	\N	\N	97559	97559	265366
10816	11300	2	applied	\N	\N	\N	\N	97560	97560	265367
10816	11301	3	applied	\N	\N	\N	\N	97561	97561	265368
10816	11302	4	applied	\N	\N	\N	\N	97562	97562	265369
10816	11303	5	applied	\N	\N	\N	\N	97563	97563	265370
10816	11304	6	applied	\N	\N	\N	\N	97564	97564	265371
10816	11305	7	applied	\N	\N	\N	\N	97565	97565	265372
10816	11306	8	applied	\N	\N	\N	\N	97566	97566	265373
10816	11307	9	applied	\N	\N	\N	\N	97567	97567	265374
10823	11316	0	applied	\N	\N	1000000000	\N	97583	97583	265388
10823	11317	1	applied	\N	\N	1000000000	\N	97584	97584	265389
10823	11318	2	applied	\N	\N	\N	\N	97585	97585	265390
10826	11319	0	applied	\N	\N	\N	\N	97592	97592	265397
10826	11321	2	applied	\N	\N	\N	\N	97594	97594	265399
10828	11322	0	applied	\N	\N	\N	\N	97598	97598	265403
10828	11323	1	applied	\N	\N	\N	\N	97599	97599	265404
10828	11324	2	applied	\N	\N	\N	\N	97600	97600	265405
10828	11325	3	applied	\N	\N	\N	\N	97601	97601	265406
10831	11327	0	applied	\N	\N	\N	\N	97605	97605	265410
10831	11328	1	applied	\N	\N	\N	\N	97606	97606	265411
10833	11329	0	applied	\N	\N	\N	\N	97611	97611	265416
10833	11330	1	applied	\N	\N	\N	\N	97612	97612	265417
10833	11331	2	applied	\N	\N	\N	\N	97613	97613	265418
10833	11332	3	applied	\N	\N	1000000000	\N	97614	97614	265419
10833	11333	4	applied	\N	\N	\N	\N	97615	97615	265420
10833	11334	5	applied	\N	\N	1000000000	\N	97616	97616	265421
10836	11339	0	applied	\N	\N	\N	\N	97621	97621	265426
10836	11340	1	applied	\N	\N	\N	\N	97622	97622	265427
10836	11341	2	applied	\N	\N	\N	\N	97623	97623	265428
10836	11342	3	applied	\N	\N	\N	\N	97624	97624	265429
10836	11343	4	applied	\N	\N	\N	\N	97625	97625	265430
10836	11344	5	applied	\N	\N	\N	\N	97626	97626	265431
10836	11346	7	applied	\N	\N	\N	\N	97628	97628	265433
10836	11347	8	applied	\N	\N	\N	\N	97629	97629	265434
10836	11348	9	applied	\N	\N	\N	\N	97630	97630	265435
10837	11344	5	applied	\N	\N	\N	\N	97636	97636	265441
10837	11345	6	applied	\N	\N	\N	\N	97637	97637	265442
10837	11347	7	applied	\N	\N	\N	\N	97638	97638	265443
10837	11348	8	applied	\N	\N	\N	\N	97639	97639	265444
10841	11351	0	applied	\N	\N	1000000000	\N	97653	97653	265458
10841	11352	1	applied	\N	\N	\N	\N	97654	97654	265459
10841	11353	2	applied	\N	\N	\N	\N	97655	97655	265460
10841	11354	3	applied	\N	\N	\N	\N	97656	97656	265461
10841	11355	4	applied	\N	\N	\N	\N	97657	97657	265462
10841	11356	5	applied	\N	\N	\N	\N	97658	97658	265463
10841	11357	6	applied	\N	\N	\N	\N	97659	97659	265464
10844	11362	0	applied	\N	\N	\N	\N	97670	97670	265475
10844	11363	1	applied	\N	\N	\N	\N	97671	97671	265476
10844	11359	3	applied	\N	\N	\N	\N	97673	97673	265478
10844	11360	4	applied	\N	\N	\N	\N	97674	97674	265479
10844	11361	5	applied	\N	\N	\N	\N	97675	97675	265480
10846	11369	0	applied	\N	\N	\N	\N	97683	97683	265488
10846	11370	1	applied	\N	\N	\N	\N	97684	97684	265489
10849	11376	0	applied	\N	\N	\N	\N	97695	97695	265500
10849	11377	1	applied	\N	\N	\N	\N	97696	97696	265501
10849	11378	2	applied	\N	\N	\N	\N	97697	97697	265502
10849	11379	3	applied	\N	\N	\N	\N	97698	97698	265503
10849	11380	4	applied	\N	\N	\N	\N	97699	97699	265504
10849	11381	5	applied	\N	\N	\N	\N	97700	97700	265505
10851	11382	0	applied	\N	\N	\N	\N	97703	97703	265508
10851	11383	1	applied	\N	\N	\N	\N	97704	97704	265509
10854	11351	0	applied	\N	\N	1000000000	\N	97715	97715	265520
10854	10996	2	applied	\N	\N	\N	\N	97717	97717	265521
10854	10997	3	applied	\N	\N	\N	\N	97718	97718	265522
10854	10998	4	applied	\N	\N	\N	\N	97719	97719	265523
10854	11003	5	applied	\N	\N	\N	\N	97720	97720	265524
10854	11332	6	applied	\N	\N	1000000000	\N	97721	97721	265525
10854	11339	7	applied	\N	\N	\N	\N	97722	97722	265526
10854	11340	8	applied	\N	\N	\N	\N	97723	97723	265527
10854	11341	9	applied	\N	\N	\N	\N	97724	97724	265528
10854	11342	10	applied	\N	\N	\N	\N	97725	97725	265529
10854	11343	11	applied	\N	\N	\N	\N	97726	97726	265530
10854	11350	12	applied	\N	\N	\N	\N	97727	97727	265531
10854	11354	13	applied	\N	\N	\N	\N	97728	97728	265532
10854	11358	14	applied	\N	\N	\N	\N	97729	97729	265533
10854	11004	15	applied	\N	\N	\N	\N	97730	97730	265534
10854	11008	16	applied	\N	\N	\N	\N	97731	97731	265535
10854	11359	17	applied	\N	\N	\N	\N	97732	97732	265536
10854	11360	18	applied	\N	\N	\N	\N	97733	97733	265537
10854	11361	19	applied	\N	\N	\N	\N	97734	97734	265538
10854	11364	20	applied	\N	\N	\N	\N	97735	97735	265539
10854	11365	21	applied	\N	\N	\N	\N	97736	97736	265540
10855	11394	0	applied	\N	\N	\N	\N	97830	97830	265634
10855	11395	1	applied	\N	\N	\N	\N	97831	97831	265635
10858	11396	0	applied	\N	\N	\N	\N	97836	97836	265640
10858	11397	1	applied	\N	\N	\N	\N	97837	97837	265641
10862	11398	0	applied	\N	\N	\N	\N	97848	97848	265652
10862	11399	1	applied	\N	\N	\N	\N	97849	97849	265653
10862	11401	3	applied	\N	\N	\N	\N	97851	97851	265655
10866	11404	0	applied	\N	\N	\N	\N	97860	97860	265664
10866	11405	1	applied	\N	\N	\N	\N	97861	97861	265665
10866	11406	2	applied	\N	\N	\N	\N	97862	97862	265666
10869	11407	0	applied	\N	\N	\N	\N	97871	97871	265675
10869	11408	1	applied	\N	\N	\N	\N	97872	97872	265676
10869	11409	2	applied	\N	\N	\N	\N	97873	97873	265677
10869	11410	3	applied	\N	\N	\N	\N	97874	97874	265678
10869	11411	4	applied	\N	\N	\N	\N	97875	97875	265679
10809	11122	114	applied	\N	\N	\N	\N	97533	97533	265340
10809	11123	115	applied	\N	\N	\N	\N	97534	97534	265341
10854	11287	26	applied	\N	\N	\N	\N	97741	97741	265545
10854	11288	27	applied	\N	\N	\N	\N	97742	97742	265546
10854	11290	28	applied	\N	\N	\N	\N	97743	97743	265547
10854	11294	29	applied	\N	\N	\N	\N	97744	97744	265548
10854	11297	30	applied	\N	\N	\N	\N	97745	97745	265549
10854	11298	31	applied	\N	\N	\N	\N	97746	97746	265550
10854	11299	32	applied	\N	\N	\N	\N	97747	97747	265551
10854	11303	33	applied	\N	\N	\N	\N	97748	97748	265552
10854	11310	34	applied	\N	\N	\N	\N	97749	97749	265553
10854	11311	35	applied	\N	\N	\N	\N	97750	97750	265554
10854	11314	36	applied	\N	\N	\N	\N	97751	97751	265555
10854	11315	37	applied	\N	\N	\N	\N	97752	97752	265556
10854	11319	38	applied	\N	\N	\N	\N	97753	97753	265557
10854	11322	39	applied	\N	\N	\N	\N	97754	97754	265558
10854	11325	40	applied	\N	\N	\N	\N	97755	97755	265559
10854	11326	41	applied	\N	\N	\N	\N	97756	97756	265560
10854	11329	43	applied	\N	\N	\N	\N	97758	97758	265562
10854	11330	44	applied	\N	\N	\N	\N	97759	97759	265563
10854	11337	45	applied	\N	\N	\N	\N	97760	97760	265564
10854	11338	46	applied	\N	\N	\N	\N	97761	97761	265565
10854	11010	47	applied	\N	\N	\N	\N	97762	97762	265566
10854	11011	48	applied	\N	\N	\N	\N	97763	97763	265567
10854	11013	49	applied	\N	\N	\N	\N	97764	97764	265568
10854	11016	50	applied	\N	\N	\N	\N	97765	97765	265569
10854	11018	51	applied	\N	\N	\N	\N	97766	97766	265570
10854	11019	52	applied	\N	\N	\N	\N	97767	97767	265571
10854	11020	53	applied	\N	\N	\N	\N	97768	97768	265572
10854	11025	54	applied	\N	\N	\N	\N	97769	97769	265573
10854	11028	55	applied	\N	\N	\N	\N	97770	97770	265574
10854	11030	56	applied	\N	\N	\N	\N	97771	97771	265575
10854	11033	57	applied	\N	\N	\N	\N	97772	97772	265576
10854	11037	58	applied	\N	\N	\N	\N	97773	97773	265577
10854	11040	60	applied	\N	\N	\N	\N	97775	97775	265579
10854	11042	61	applied	\N	\N	\N	\N	97776	97776	265580
10854	11043	62	applied	\N	\N	\N	\N	97777	97777	265581
10854	11347	63	applied	\N	\N	\N	\N	97778	97778	265582
10854	11348	64	applied	\N	\N	\N	\N	97779	97779	265583
10854	11349	65	applied	\N	\N	\N	\N	97780	97780	265584
10854	11353	66	applied	\N	\N	\N	\N	97781	97781	265585
10854	11355	67	applied	\N	\N	\N	\N	97782	97782	265586
10854	11363	68	applied	\N	\N	\N	\N	97783	97783	265587
10854	11367	69	applied	\N	\N	\N	\N	97784	97784	265588
10854	11369	70	applied	\N	\N	\N	\N	97785	97785	265589
10854	11373	71	applied	\N	\N	\N	\N	97786	97786	265590
10854	11376	72	applied	\N	\N	\N	\N	97787	97787	265591
10854	11377	73	applied	\N	\N	\N	\N	97788	97788	265592
10854	11383	74	applied	\N	\N	\N	\N	97789	97789	265593
10854	11384	75	applied	\N	\N	\N	\N	97790	97790	265594
10854	11388	77	applied	\N	\N	\N	\N	97792	97792	265596
10854	11389	78	applied	\N	\N	\N	\N	97793	97793	265597
10854	11391	79	applied	\N	\N	\N	\N	97794	97794	265598
10854	11292	80	applied	\N	\N	\N	\N	97795	97795	265599
10854	11304	81	applied	\N	\N	\N	\N	97796	97796	265600
10854	11048	82	applied	\N	\N	\N	\N	97797	97797	265601
10854	11049	83	applied	\N	\N	\N	\N	97798	97798	265602
10854	11050	84	applied	\N	\N	\N	\N	97799	97799	265603
10854	11051	85	applied	\N	\N	\N	\N	97800	97800	265604
10854	11056	86	applied	\N	\N	\N	\N	97801	97801	265605
10854	11058	87	applied	\N	\N	\N	\N	97802	97802	265606
10854	11059	88	applied	\N	\N	\N	\N	97803	97803	265607
10854	11062	89	applied	\N	\N	\N	\N	97804	97804	265608
10854	11063	90	applied	\N	\N	\N	\N	97805	97805	265609
10854	11067	91	applied	\N	\N	\N	\N	97806	97806	265610
10854	11068	92	applied	\N	\N	\N	\N	97807	97807	265611
10854	11071	94	applied	\N	\N	\N	\N	97809	97809	265613
10854	11072	95	applied	\N	\N	\N	\N	97810	97810	265614
10854	11074	96	applied	\N	\N	\N	\N	97811	97811	265615
10854	11077	97	applied	\N	\N	\N	\N	97812	97812	265616
10854	11079	98	applied	\N	\N	\N	\N	97813	97813	265617
10854	11080	99	applied	\N	\N	\N	\N	97814	97814	265618
10854	11082	100	applied	\N	\N	\N	\N	97815	97815	265619
10854	11084	101	applied	\N	\N	\N	\N	97816	97816	265620
10854	11086	102	applied	\N	\N	\N	\N	97817	97817	265621
10854	11090	103	applied	\N	\N	\N	\N	97818	97818	265622
10854	11091	104	applied	\N	\N	\N	\N	97819	97819	265623
10854	11095	105	applied	\N	\N	\N	\N	97820	97820	265624
10854	11098	106	applied	\N	\N	\N	\N	97821	97821	265625
10854	11099	107	applied	\N	\N	\N	\N	97822	97822	265626
10854	11106	108	applied	\N	\N	\N	\N	97823	97823	265627
10854	11107	109	applied	\N	\N	\N	\N	97824	97824	265628
10854	11109	111	applied	\N	\N	\N	\N	97826	97826	265630
10854	11110	113	applied	\N	\N	\N	\N	97827	97827	265631
10854	11113	114	applied	\N	\N	\N	\N	97828	97828	265632
10854	11115	115	applied	\N	\N	\N	\N	97829	97829	265633
10857	11396	0	applied	\N	\N	\N	\N	97834	97834	265638
10857	11397	1	applied	\N	\N	\N	\N	97835	97835	265639
10865	11402	0	applied	\N	\N	\N	\N	97858	97858	265662
10865	11403	1	applied	\N	\N	\N	\N	97859	97859	265663
10868	11407	0	applied	\N	\N	\N	\N	97866	97866	265670
10868	11408	1	applied	\N	\N	\N	\N	97867	97867	265671
10868	11409	2	applied	\N	\N	\N	\N	97868	97868	265672
10868	11410	3	applied	\N	\N	\N	\N	97869	97869	265673
10868	11411	4	applied	\N	\N	\N	\N	97870	97870	265674
10870	11396	22	applied	\N	\N	\N	\N	97898	97898	265702
10870	11399	23	applied	\N	\N	\N	\N	97899	97899	265703
10870	11400	24	applied	\N	\N	\N	\N	97900	97900	265704
10870	11405	26	applied	\N	\N	\N	\N	97902	97902	265706
10870	11408	27	applied	\N	\N	\N	\N	97903	97903	265707
10870	11409	28	applied	\N	\N	\N	\N	97904	97904	265708
10870	11392	29	applied	\N	\N	\N	\N	97905	97905	265709
10870	11393	30	applied	\N	\N	\N	\N	97906	97906	265710
10870	11394	31	applied	\N	\N	\N	\N	97907	97907	265711
10870	11397	32	applied	\N	\N	\N	\N	97908	97908	265712
10870	11398	33	applied	\N	\N	\N	\N	97909	97909	265713
10870	11401	34	applied	\N	\N	\N	\N	97910	97910	265714
10870	11403	35	applied	\N	\N	\N	\N	97911	97911	265715
10870	11406	36	applied	\N	\N	\N	\N	97912	97912	265716
10870	11410	37	applied	\N	\N	\N	\N	97913	97913	265717
10870	11411	38	applied	\N	\N	\N	\N	97914	97914	265718
10870	11380	39	applied	\N	\N	\N	\N	97915	97915	265719
10854	11372	23	applied	\N	\N	\N	\N	97738	97738	265542
10854	11375	24	applied	\N	\N	\N	\N	97739	97739	265543
10873	11412	0	applied	\N	\N	\N	\N	97919	97919	265723
10873	11413	1	applied	\N	\N	\N	\N	97920	97920	265724
10874	11412	0	applied	\N	\N	\N	\N	97921	97921	265725
10874	11413	1	applied	\N	\N	\N	\N	97922	97922	265726
10875	11414	0	applied	\N	\N	\N	\N	97923	97923	265727
10875	11416	2	applied	\N	\N	\N	\N	97925	97925	265729
10875	11417	3	applied	\N	\N	\N	\N	97926	97926	265730
10875	11418	4	applied	\N	\N	\N	\N	97927	97927	265731
10876	11414	0	applied	\N	\N	\N	\N	97928	97928	265732
10876	11415	1	applied	\N	\N	1000000000	\N	97929	97929	265733
10876	11416	2	applied	\N	\N	\N	\N	97930	97930	265734
10876	11417	3	applied	\N	\N	\N	\N	97931	97931	265735
10876	11418	4	applied	\N	\N	\N	\N	97932	97932	265736
10877	11414	0	applied	\N	\N	\N	\N	97933	97933	265737
10877	11415	1	applied	\N	\N	1000000000	\N	97934	97934	265738
10877	11416	2	applied	\N	\N	\N	\N	97935	97935	265739
10877	11417	3	applied	\N	\N	\N	\N	97936	97936	265740
10877	11418	4	applied	\N	\N	\N	\N	97937	97937	265741
10878	11419	0	applied	\N	\N	\N	\N	97938	97938	265742
10878	11420	1	applied	\N	\N	\N	\N	97939	97939	265743
10879	11415	0	applied	\N	\N	1000000000	\N	97940	97940	265744
10879	11421	1	applied	\N	\N	\N	\N	97941	97941	265745
10879	11404	2	applied	\N	\N	\N	\N	97942	97942	265746
10879	11407	3	applied	\N	\N	\N	\N	97943	97943	265747
10879	11422	4	applied	\N	\N	\N	\N	97944	97944	265748
10880	11421	0	applied	\N	\N	\N	\N	97946	97946	265750
10880	11424	1	applied	\N	\N	\N	\N	97947	97947	265751
10880	11422	2	applied	\N	\N	\N	\N	97948	97948	265752
10880	11423	3	applied	\N	\N	\N	\N	97949	97949	265753
10880	11425	4	applied	\N	\N	\N	\N	97950	97950	265754
10881	11421	0	applied	\N	\N	\N	\N	97951	97951	265755
10881	11422	1	applied	\N	\N	\N	\N	97952	97952	265756
10881	11423	2	applied	\N	\N	\N	\N	97953	97953	265757
10881	11425	3	applied	\N	\N	\N	\N	97954	97954	265758
10882	11421	0	applied	\N	\N	\N	\N	97955	97955	265759
10882	11424	1	applied	\N	\N	\N	\N	97956	97956	265760
10882	11422	2	applied	\N	\N	\N	\N	97957	97957	265761
10882	11423	3	applied	\N	\N	\N	\N	97958	97958	265762
10882	11425	4	applied	\N	\N	\N	\N	97959	97959	265763
10883	11421	0	applied	\N	\N	\N	\N	97960	97960	265764
10883	11424	1	applied	\N	\N	\N	\N	97961	97961	265765
10883	11423	3	applied	\N	\N	\N	\N	97963	97963	265767
10883	11425	4	applied	\N	\N	\N	\N	97964	97964	265768
10884	11421	0	applied	\N	\N	\N	\N	97965	97965	265769
10884	11424	1	applied	\N	\N	\N	\N	97966	97966	265770
10884	11422	2	applied	\N	\N	\N	\N	97967	97967	265771
10884	11423	3	applied	\N	\N	\N	\N	97968	97968	265772
10884	11425	4	applied	\N	\N	\N	\N	97969	97969	265773
10885	11421	0	applied	\N	\N	\N	\N	97970	97970	265774
10885	11424	1	applied	\N	\N	\N	\N	97971	97971	265775
10885	11422	2	applied	\N	\N	\N	\N	97972	97972	265776
10885	11423	3	applied	\N	\N	\N	\N	97973	97973	265777
10885	11425	4	applied	\N	\N	\N	\N	97974	97974	265778
10886	11426	0	applied	\N	\N	\N	\N	97975	97975	265779
10886	11427	1	applied	\N	\N	\N	\N	97976	97976	265780
10886	11428	2	applied	\N	\N	\N	\N	97977	97977	265781
10886	11429	3	applied	\N	\N	\N	\N	97978	97978	265782
10887	11427	1	applied	\N	\N	\N	\N	97980	97980	265784
10887	11428	2	applied	\N	\N	\N	\N	97981	97981	265785
10887	11429	3	applied	\N	\N	\N	\N	97982	97982	265786
10888	11426	0	applied	\N	\N	\N	\N	97983	97983	265787
10888	11427	1	applied	\N	\N	\N	\N	97984	97984	265788
10888	11428	2	applied	\N	\N	\N	\N	97985	97985	265789
10888	11429	3	applied	\N	\N	\N	\N	97986	97986	265790
10889	11430	0	applied	\N	\N	\N	\N	97987	97987	265791
10889	11431	1	applied	\N	\N	\N	\N	97988	97988	265792
10890	11432	0	applied	\N	\N	\N	\N	97989	97989	265793
10890	11430	1	applied	\N	\N	\N	\N	97990	97990	265794
10890	11431	2	applied	\N	\N	\N	\N	97991	97991	265795
10891	11433	0	applied	\N	\N	\N	\N	97992	97992	265796
10891	11434	1	applied	\N	\N	\N	\N	97993	97993	265797
10891	11435	2	applied	\N	\N	\N	\N	97994	97994	265798
10891	11436	3	applied	\N	\N	\N	\N	97995	97995	265799
10892	11433	0	applied	\N	\N	\N	\N	97997	97997	265801
10892	11434	1	applied	\N	\N	\N	\N	97998	97998	265802
10892	11435	2	applied	\N	\N	\N	\N	97999	97999	265803
10892	11436	3	applied	\N	\N	\N	\N	98000	98000	265804
10892	11437	4	applied	\N	\N	\N	\N	98001	98001	265805
10893	11438	0	applied	\N	\N	\N	\N	98002	98002	265806
10893	11439	1	applied	\N	\N	\N	\N	98003	98003	265807
10894	11438	0	applied	\N	\N	\N	\N	98004	98004	265808
10894	11439	1	applied	\N	\N	\N	\N	98005	98005	265809
10895	11415	0	applied	\N	\N	1000000000	\N	98006	98006	265810
10895	11421	1	applied	\N	\N	\N	\N	98007	98007	265811
10895	11404	2	applied	\N	\N	\N	\N	98008	98008	265812
10895	11407	3	applied	\N	\N	\N	\N	98009	98009	265813
10895	11422	4	applied	\N	\N	\N	\N	98010	98010	265814
10895	11423	5	applied	\N	\N	\N	\N	98011	98011	265815
10895	11426	6	applied	\N	\N	\N	\N	98012	98012	265816
10895	11394	8	applied	\N	\N	\N	\N	98014	98014	265818
10895	11397	9	applied	\N	\N	\N	\N	98015	98015	265819
10895	11398	10	applied	\N	\N	\N	\N	98016	98016	265820
10895	11401	11	applied	\N	\N	\N	\N	98017	98017	265821
10895	11403	12	applied	\N	\N	\N	\N	98018	98018	265822
10895	11395	13	applied	\N	\N	\N	\N	98019	98019	265823
10895	11396	14	applied	\N	\N	\N	\N	98020	98020	265824
10895	11399	15	applied	\N	\N	\N	\N	98021	98021	265825
10895	11400	16	applied	\N	\N	\N	\N	98022	98022	265826
10895	11402	17	applied	\N	\N	\N	\N	98023	98023	265827
10895	11405	18	applied	\N	\N	\N	\N	98024	98024	265828
10895	11408	19	applied	\N	\N	\N	\N	98025	98025	265829
10895	11409	20	applied	\N	\N	\N	\N	98026	98026	265830
10895	11413	21	applied	\N	\N	\N	\N	98027	98027	265831
10895	11414	22	applied	\N	\N	\N	\N	98028	98028	265832
10895	11418	23	applied	\N	\N	\N	\N	98029	98029	265833
10895	11424	25	applied	\N	\N	\N	\N	98031	98031	265835
10895	11427	26	applied	\N	\N	\N	\N	98032	98032	265836
10895	11431	27	applied	\N	\N	\N	\N	98033	98033	265837
10895	11436	28	applied	\N	\N	\N	\N	98034	98034	265838
10872	11412	0	applied	\N	\N	\N	\N	97917	97917	265721
10872	11413	1	applied	\N	\N	\N	\N	97918	97918	265722
10895	11406	33	applied	\N	\N	\N	\N	98039	98039	265843
10895	11410	34	applied	\N	\N	\N	\N	98040	98040	265844
10895	11411	35	applied	\N	\N	\N	\N	98041	98041	265845
10895	11412	36	applied	\N	\N	\N	\N	98042	98042	265846
10895	11416	37	applied	\N	\N	\N	\N	98043	98043	265847
10895	11417	38	applied	\N	\N	\N	\N	98044	98044	265848
10895	11420	39	applied	\N	\N	\N	\N	98045	98045	265849
10895	11425	40	applied	\N	\N	\N	\N	98046	98046	265850
10895	11428	41	applied	\N	\N	\N	\N	98047	98047	265851
10895	11430	42	applied	\N	\N	\N	\N	98048	98048	265852
10895	11433	43	applied	\N	\N	\N	\N	98049	98049	265853
10895	11435	44	applied	\N	\N	\N	\N	98050	98050	265854
10895	11439	45	applied	\N	\N	\N	\N	98051	98051	265855
10896	11440	0	applied	\N	\N	\N	\N	98052	98052	265856
10896	11441	1	applied	\N	\N	\N	\N	98053	98053	265857
10896	11442	2	applied	\N	\N	\N	\N	98054	98054	265858
10896	11444	4	applied	\N	\N	\N	\N	98056	98056	265860
10896	11445	5	applied	\N	\N	\N	\N	98057	98057	265861
10896	11446	6	applied	\N	\N	\N	\N	98058	98058	265862
10898	11440	0	applied	\N	\N	\N	\N	98066	98066	265870
10898	11441	1	applied	\N	\N	\N	\N	98067	98067	265871
10898	11442	2	applied	\N	\N	\N	\N	98068	98068	265872
10898	11443	3	applied	\N	\N	\N	\N	98069	98069	265873
10898	11444	4	applied	\N	\N	\N	\N	98070	98070	265874
10898	11445	5	applied	\N	\N	\N	\N	98071	98071	265875
10898	11446	6	applied	\N	\N	\N	\N	98072	98072	265876
10900	11448	0	applied	\N	\N	\N	\N	98074	98074	265878
10900	11449	1	applied	\N	\N	\N	\N	98075	98075	265879
10901	11450	0	applied	\N	\N	\N	\N	98076	98076	265880
10901	11451	1	applied	\N	\N	\N	\N	98077	98077	265881
10901	11452	2	applied	\N	\N	\N	\N	98078	98078	265882
10901	11453	3	applied	\N	\N	\N	\N	98079	98079	265883
10904	11468	0	applied	\N	\N	\N	\N	98094	98094	265898
10904	11469	1	applied	\N	\N	\N	\N	98095	98095	265899
10904	11470	2	applied	\N	\N	\N	\N	98096	98096	265900
10904	11471	3	applied	\N	\N	\N	\N	98097	98097	265901
10904	11472	4	applied	\N	\N	\N	\N	98098	98098	265902
10904	11473	5	applied	\N	\N	\N	\N	98099	98099	265903
10904	11474	6	applied	\N	\N	\N	\N	98100	98100	265904
10905	11475	0	applied	\N	\N	\N	\N	98101	98101	265905
10905	11476	1	applied	\N	\N	\N	\N	98102	98102	265906
10905	11477	2	applied	\N	\N	\N	\N	98103	98103	265907
10905	11478	3	applied	\N	\N	\N	\N	98104	98104	265908
10908	11484	0	applied	\N	\N	\N	\N	98114	98114	265918
10913	11468	0	applied	\N	\N	\N	\N	98126	98126	265930
10913	11479	1	applied	\N	\N	\N	\N	98127	98127	265931
10913	11480	3	applied	\N	\N	\N	\N	98128	98128	265932
10913	11481	4	applied	\N	\N	\N	\N	98129	98129	265933
10913	11457	6	applied	\N	\N	\N	\N	98131	98131	265935
10913	11458	7	applied	\N	\N	\N	\N	98132	98132	265936
10913	11459	8	applied	\N	\N	\N	\N	98133	98133	265937
10913	11460	9	applied	\N	\N	\N	\N	98134	98134	265938
10913	11440	10	applied	\N	\N	\N	\N	98135	98135	265939
10913	11441	11	applied	\N	\N	\N	\N	98136	98136	265940
10913	11442	12	applied	\N	\N	\N	\N	98137	98137	265941
10913	11447	13	applied	\N	\N	\N	\N	98138	98138	265942
10913	11449	14	applied	\N	\N	\N	\N	98139	98139	265943
10913	11443	15	applied	\N	\N	\N	\N	98140	98140	265944
10913	11450	16	applied	\N	\N	\N	\N	98141	98141	265945
10913	11453	17	applied	\N	\N	\N	\N	98142	98142	265946
10913	11466	18	applied	\N	\N	\N	\N	98143	98143	265947
10913	11470	19	applied	\N	\N	\N	\N	98144	98144	265948
10913	11444	20	applied	\N	\N	\N	\N	98145	98145	265949
10913	11445	21	applied	\N	\N	\N	\N	98146	98146	265950
10913	11448	23	applied	\N	\N	\N	\N	98148	98148	265952
10913	11451	24	applied	\N	\N	\N	\N	98149	98149	265953
10913	11452	25	applied	\N	\N	\N	\N	98150	98150	265954
10913	11454	26	applied	\N	\N	\N	\N	98151	98151	265955
10913	11455	27	applied	\N	\N	\N	\N	98152	98152	265956
10913	11461	28	applied	\N	\N	\N	\N	98153	98153	265957
10913	11463	29	applied	\N	\N	\N	\N	98154	98154	265958
10913	11465	30	applied	\N	\N	\N	\N	98155	98155	265959
10913	11471	31	applied	\N	\N	\N	\N	98156	98156	265960
10913	11474	32	applied	\N	\N	\N	\N	98157	98157	265961
10913	11475	33	applied	\N	\N	\N	\N	98158	98158	265962
10913	11476	34	applied	\N	\N	\N	\N	98159	98159	265963
10913	11483	35	applied	\N	\N	\N	\N	98160	98160	265964
10913	11486	36	applied	\N	\N	\N	\N	98161	98161	265965
10913	11488	37	applied	\N	\N	\N	\N	98162	98162	265966
10913	11489	38	applied	\N	\N	\N	\N	98163	98163	265967
10913	11456	40	applied	\N	\N	\N	\N	98165	98165	265969
10913	11462	41	applied	\N	\N	\N	\N	98166	98166	265970
10913	11464	42	applied	\N	\N	\N	\N	98167	98167	265971
10913	11467	43	applied	\N	\N	\N	\N	98168	98168	265972
10913	11472	44	applied	\N	\N	\N	\N	98169	98169	265973
10913	11473	45	applied	\N	\N	\N	\N	98170	98170	265974
10913	11477	46	applied	\N	\N	\N	\N	98171	98171	265975
10913	11478	47	applied	\N	\N	\N	\N	98172	98172	265976
10913	11482	48	applied	\N	\N	\N	\N	98173	98173	265977
10913	11485	49	applied	\N	\N	\N	\N	98174	98174	265978
10913	11487	50	applied	\N	\N	\N	\N	98175	98175	265979
10913	11490	51	applied	\N	\N	\N	\N	98176	98176	265980
10913	11492	52	applied	\N	\N	\N	\N	98177	98177	265981
10918	11499	0	applied	\N	\N	\N	\N	98197	98197	266001
10918	11500	1	applied	\N	\N	\N	\N	98198	98198	266002
10921	11508	0	applied	\N	\N	\N	\N	98208	98208	266012
10926	11513	0	applied	\N	\N	\N	\N	98222	98222	266026
10927	11514	0	applied	\N	\N	\N	\N	98223	98223	266027
10927	11510	1	applied	\N	\N	\N	\N	98224	98224	266028
10927	11512	2	applied	\N	\N	\N	\N	98225	98225	266029
10927	11515	3	applied	\N	\N	\N	\N	98226	98226	266030
10927	11516	4	applied	\N	\N	\N	\N	98227	98227	266031
10929	11514	0	applied	\N	\N	\N	\N	98236	98236	266040
10929	11510	1	applied	\N	\N	\N	\N	98237	98237	266041
10929	11511	2	applied	\N	\N	\N	\N	98238	98238	266042
10929	11512	3	applied	\N	\N	\N	\N	98239	98239	266043
10929	11517	4	applied	\N	\N	\N	\N	98240	98240	266044
10929	11518	5	applied	\N	\N	\N	\N	98241	98241	266045
10929	11515	6	applied	\N	\N	\N	\N	98242	98242	266046
10929	11516	7	applied	\N	\N	\N	\N	98243	98243	266047
10895	11438	30	applied	\N	\N	\N	\N	98036	98036	265840
10895	11429	31	applied	\N	\N	\N	\N	98037	98037	265841
10897	11444	4	applied	\N	\N	\N	\N	98063	98063	265867
10897	11445	5	applied	\N	\N	\N	\N	98064	98064	265868
10897	11446	6	applied	\N	\N	\N	\N	98065	98065	265869
10903	11457	0	applied	\N	\N	\N	\N	98083	98083	265887
10903	11458	1	applied	\N	\N	\N	\N	98084	98084	265888
10903	11459	2	applied	\N	\N	\N	\N	98085	98085	265889
10903	11460	3	applied	\N	\N	\N	\N	98086	98086	265890
10903	11461	4	applied	\N	\N	\N	\N	98087	98087	265891
10903	11462	5	applied	\N	\N	\N	\N	98088	98088	265892
10903	11463	6	applied	\N	\N	\N	\N	98089	98089	265893
10903	11464	7	applied	\N	\N	\N	\N	98090	98090	265894
10903	11465	8	applied	\N	\N	\N	\N	98091	98091	265895
10903	11466	9	applied	\N	\N	\N	\N	98092	98092	265896
10903	11467	10	applied	\N	\N	\N	\N	98093	98093	265897
10907	11479	0	applied	\N	\N	\N	\N	98109	98109	265913
10907	11480	1	applied	\N	\N	\N	\N	98110	98110	265914
10907	11482	3	applied	\N	\N	\N	\N	98112	98112	265916
10907	11483	4	applied	\N	\N	\N	\N	98113	98113	265917
10912	11489	0	applied	\N	\N	\N	\N	98124	98124	265928
10912	11490	1	applied	\N	\N	\N	\N	98125	98125	265929
10914	11493	0	applied	\N	\N	\N	\N	98178	98178	265982
10914	11494	1	applied	\N	\N	\N	\N	98179	98179	265983
10914	11495	2	applied	\N	\N	\N	\N	98180	98180	265984
10914	11492	3	applied	\N	\N	\N	\N	98181	98181	265985
10914	11496	4	applied	\N	\N	\N	\N	98182	98182	265986
10914	11497	5	applied	\N	\N	\N	\N	98183	98183	265987
10914	11491	6	applied	\N	\N	\N	\N	98184	98184	265988
10914	11498	7	applied	\N	\N	\N	\N	98185	98185	265989
10919	11501	0	applied	\N	\N	\N	\N	98199	98199	266003
10919	11502	1	applied	\N	\N	\N	\N	98200	98200	266004
10919	11503	2	applied	\N	\N	\N	\N	98201	98201	266005
10919	11504	3	applied	\N	\N	\N	\N	98202	98202	266006
10919	11505	5	applied	\N	\N	\N	\N	98204	98204	266008
10919	11506	6	applied	\N	\N	\N	\N	98205	98205	266009
10919	11507	7	applied	\N	\N	\N	\N	98206	98206	266010
10922	11508	0	applied	\N	\N	\N	\N	98210	98210	266014
10922	11509	1	applied	\N	\N	\N	\N	98211	98211	266015
10925	11511	0	applied	\N	\N	\N	\N	98220	98220	266024
10925	11513	1	applied	\N	\N	\N	\N	98221	98221	266025
10928	11514	0	applied	\N	\N	\N	\N	98228	98228	266032
10928	11510	1	applied	\N	\N	\N	\N	98229	98229	266033
10928	11511	2	applied	\N	\N	\N	\N	98230	98230	266034
10928	11512	3	applied	\N	\N	\N	\N	98231	98231	266035
10928	11517	4	applied	\N	\N	\N	\N	98232	98232	266036
10928	11518	5	applied	\N	\N	\N	\N	98233	98233	266037
10928	11515	6	applied	\N	\N	\N	\N	98234	98234	266038
10928	11516	7	applied	\N	\N	\N	\N	98235	98235	266039
10931	11517	0	applied	\N	\N	\N	\N	98246	98246	266050
10934	11519	0	applied	\N	\N	\N	\N	98251	98251	266055
10934	11520	1	applied	\N	\N	\N	\N	98252	98252	266056
10938	11523	0	applied	\N	\N	\N	\N	98263	98263	266067
10938	11524	1	applied	\N	\N	\N	\N	98264	98264	266068
10945	11527	0	applied	\N	\N	\N	\N	98277	98277	266081
10945	11528	1	applied	\N	\N	\N	\N	98278	98278	266082
10950	11517	0	applied	\N	\N	\N	\N	98294	98294	266098
10950	11520	1	applied	\N	\N	\N	\N	98295	98295	266099
10950	11522	2	applied	\N	\N	\N	\N	98296	98296	266100
10950	11523	3	applied	\N	\N	\N	\N	98297	98297	266101
10950	11525	4	applied	\N	\N	\N	\N	98298	98298	266102
10950	11527	5	applied	\N	\N	\N	\N	98299	98299	266103
10950	11518	6	applied	\N	\N	\N	\N	98300	98300	266104
10950	11519	7	applied	\N	\N	\N	\N	98301	98301	266105
10950	11521	8	applied	\N	\N	\N	\N	98302	98302	266106
10950	11530	9	applied	\N	\N	\N	\N	98303	98303	266107
10950	11532	11	applied	\N	\N	\N	\N	98305	98305	266109
10950	11524	12	applied	\N	\N	\N	\N	98306	98306	266110
10950	11526	13	applied	\N	\N	\N	\N	98307	98307	266111
10950	11528	14	applied	\N	\N	\N	\N	98308	98308	266112
10950	11529	15	applied	\N	\N	\N	\N	98309	98309	266113
10950	11533	16	applied	\N	\N	\N	\N	98310	98310	266114
10950	11534	17	applied	\N	\N	\N	\N	98311	98311	266115
10950	11535	18	applied	\N	\N	\N	\N	98312	98312	266116
10954	11537	0	applied	\N	\N	\N	\N	98321	98321	266125
10954	11538	1	applied	\N	\N	\N	\N	98322	98322	266126
10954	11539	2	applied	\N	\N	\N	\N	98323	98323	266127
10954	11540	3	applied	\N	\N	\N	\N	98324	98324	266128
10954	11541	4	applied	\N	\N	\N	\N	98325	98325	266129
10959	11547	0	applied	\N	\N	\N	\N	98387	98387	266191
10959	11548	1	applied	\N	\N	\N	\N	98388	98388	266192
10959	11549	2	applied	\N	\N	\N	\N	98389	98389	266193
10964	11558	1	applied	\N	\N	\N	\N	98414	98414	266218
10966	11559	0	applied	\N	\N	\N	\N	98417	98417	266221
10966	11560	1	applied	\N	\N	\N	\N	98418	98418	266222
10970	11559	0	applied	\N	\N	\N	\N	98425	98425	266229
10970	11560	1	applied	\N	\N	\N	\N	98426	98426	266230
10975	11566	0	applied	\N	\N	\N	\N	98437	98437	266241
10975	11567	1	applied	\N	\N	\N	\N	98438	98438	266242
10980	11573	0	applied	\N	\N	\N	\N	98450	98450	266254
10980	11574	1	applied	\N	\N	\N	\N	98451	98451	266255
10980	11575	2	applied	\N	\N	\N	\N	98452	98452	266256
10983	11576	0	applied	\N	\N	\N	\N	98457	98457	266261
10983	11577	1	applied	\N	\N	\N	\N	98458	98458	266262
10985	11580	0	applied	\N	\N	\N	\N	98461	98461	266265
10985	11581	1	applied	\N	\N	\N	\N	98462	98462	266266
10985	11582	2	applied	\N	\N	\N	\N	98463	98463	266267
10985	11583	3	applied	\N	\N	\N	\N	98464	98464	266268
10985	11585	5	applied	\N	\N	\N	\N	98466	98466	266270
10992	11590	0	applied	\N	\N	\N	\N	98483	98483	266287
10992	11591	1	applied	\N	\N	\N	\N	98484	98484	266288
10992	11592	2	applied	\N	\N	\N	\N	98485	98485	266289
10992	11593	3	applied	\N	\N	\N	\N	98486	98486	266290
10999	11602	0	applied	\N	\N	\N	\N	98503	98503	266307
11004	11602	0	applied	\N	\N	\N	\N	98506	98506	266310
11008	11603	0	applied	\N	\N	\N	\N	98514	98514	266318
11008	11605	1	applied	\N	\N	\N	\N	98515	98515	266319
11008	11604	2	applied	\N	\N	\N	\N	98516	98516	266320
11008	11606	3	applied	\N	\N	\N	\N	98517	98517	266321
11010	11607	0	applied	\N	\N	\N	\N	98522	98522	98522
11010	11608	1	applied	\N	\N	\N	\N	98523	98523	266326
11010	11609	2	applied	\N	\N	\N	\N	98524	98524	266327
10897	11441	1	applied	\N	\N	\N	\N	98060	98060	265864
10897	11442	2	applied	\N	\N	\N	\N	98061	98061	265865
10906	11476	1	applied	\N	\N	\N	\N	98106	98106	265910
10906	11477	2	applied	\N	\N	\N	\N	98107	98107	265911
10906	11478	3	applied	\N	\N	\N	\N	98108	98108	265912
10909	11484	0	applied	\N	\N	\N	\N	98115	98115	265919
10909	11485	1	applied	\N	\N	\N	\N	98116	98116	265920
10909	11486	2	applied	\N	\N	\N	\N	98117	98117	265921
10910	11485	0	applied	\N	\N	\N	\N	98118	98118	265922
10910	11487	1	applied	\N	\N	\N	\N	98119	98119	265923
10910	11486	2	applied	\N	\N	\N	\N	98120	98120	265924
10910	11488	3	applied	\N	\N	\N	\N	98121	98121	265925
10911	11489	0	applied	\N	\N	\N	\N	98122	98122	265926
10911	11490	1	applied	\N	\N	\N	\N	98123	98123	265927
10915	11493	0	applied	\N	\N	\N	\N	98186	98186	265990
10915	11494	1	applied	\N	\N	\N	\N	98187	98187	265991
10915	11495	2	applied	\N	\N	\N	\N	98188	98188	265992
10915	11492	3	applied	\N	\N	\N	\N	98189	98189	265993
10915	11497	5	applied	\N	\N	\N	\N	98191	98191	265995
10915	11491	6	applied	\N	\N	\N	\N	98192	98192	265996
10916	11499	0	applied	\N	\N	\N	\N	98194	98194	265998
10923	11510	0	applied	\N	\N	\N	\N	98212	98212	266016
10923	11511	1	applied	\N	\N	\N	\N	98213	98213	266017
10923	11512	3	applied	\N	\N	\N	\N	98214	98214	266018
10923	11513	4	applied	\N	\N	\N	\N	98215	98215	266019
10924	11510	0	applied	\N	\N	\N	\N	98216	98216	266020
10924	11511	1	applied	\N	\N	\N	\N	98217	98217	266021
10924	11512	3	applied	\N	\N	\N	\N	98218	98218	266022
10924	11513	4	applied	\N	\N	\N	\N	98219	98219	266023
10930	11517	0	applied	\N	\N	\N	\N	98244	98244	266048
10930	11518	1	applied	\N	\N	\N	\N	98245	98245	266049
10933	11517	0	applied	\N	\N	\N	\N	98249	98249	266053
10933	11518	1	applied	\N	\N	\N	\N	98250	98250	266054
10936	11517	0	applied	\N	\N	\N	\N	98257	98257	266061
10936	11518	2	applied	\N	\N	\N	\N	98259	98259	266063
10936	11519	3	applied	\N	\N	\N	\N	98260	98260	266064
10937	11521	0	applied	\N	\N	\N	\N	98261	98261	266065
10937	11522	1	applied	\N	\N	\N	\N	98262	98262	266066
10940	11523	0	applied	\N	\N	\N	\N	98267	98267	266071
10940	11524	1	applied	\N	\N	\N	\N	98268	98268	266072
10942	11525	0	applied	\N	\N	\N	\N	98271	98271	266075
10942	11526	1	applied	\N	\N	\N	\N	98272	98272	266076
10944	11527	0	applied	\N	\N	\N	\N	98275	98275	266079
10944	11528	1	applied	\N	\N	\N	\N	98276	98276	266080
10956	11542	0	applied	\N	\N	\N	\N	98331	98331	266135
10958	11537	0	applied	\N	\N	\N	\N	98336	98336	266140
10958	11496	1	applied	\N	\N	\N	\N	98337	98337	266141
10958	11502	2	applied	\N	\N	\N	\N	98338	98338	266142
10958	11511	3	applied	\N	\N	\N	\N	98339	98339	266143
10958	11512	4	applied	\N	\N	\N	\N	98340	98340	266144
10958	11501	6	applied	\N	\N	\N	\N	98342	98342	266146
10958	11503	7	applied	\N	\N	\N	\N	98343	98343	266147
10958	11504	8	applied	\N	\N	\N	\N	98344	98344	266148
10958	11509	9	applied	\N	\N	\N	\N	98345	98345	266149
10958	11513	10	applied	\N	\N	\N	\N	98346	98346	266150
10958	11514	11	applied	\N	\N	\N	\N	98347	98347	266151
10958	11517	12	applied	\N	\N	\N	\N	98348	98348	266152
10958	11520	13	applied	\N	\N	\N	\N	98349	98349	266153
10958	11522	14	applied	\N	\N	\N	\N	98350	98350	266154
10958	11523	15	applied	\N	\N	\N	\N	98351	98351	266155
10958	11525	16	applied	\N	\N	\N	\N	98352	98352	266156
10958	11527	17	applied	\N	\N	\N	\N	98353	98353	266157
10958	11493	18	applied	\N	\N	\N	\N	98354	98354	266158
10958	11498	19	applied	\N	\N	\N	\N	98355	98355	266159
10958	11530	20	applied	\N	\N	\N	\N	98356	98356	266160
10958	11531	21	applied	\N	\N	\N	\N	98357	98357	266161
10958	11536	23	applied	\N	\N	\N	\N	98359	98359	266163
10958	11538	24	applied	\N	\N	\N	\N	98360	98360	266164
10958	11539	25	applied	\N	\N	\N	\N	98361	98361	266165
10958	11543	26	applied	\N	\N	\N	\N	98362	98362	266166
10958	11544	27	applied	\N	\N	\N	\N	98363	98363	266167
10958	11515	28	applied	\N	\N	\N	\N	98364	98364	266168
10958	11500	29	applied	\N	\N	\N	\N	98365	98365	266169
10958	11505	30	applied	\N	\N	\N	\N	98366	98366	266170
10958	11506	31	applied	\N	\N	\N	\N	98367	98367	266171
10958	11507	32	applied	\N	\N	\N	\N	98368	98368	266172
10958	11508	33	applied	\N	\N	\N	\N	98369	98369	266173
10958	11510	34	applied	\N	\N	\N	\N	98370	98370	266174
10958	11518	35	applied	\N	\N	\N	\N	98371	98371	266175
10958	11519	36	applied	\N	\N	\N	\N	98372	98372	266176
10958	11521	37	applied	\N	\N	\N	\N	98373	98373	266177
10958	11524	38	applied	\N	\N	\N	\N	98374	98374	266178
10958	11528	40	applied	\N	\N	\N	\N	98376	98376	266180
10958	11529	41	applied	\N	\N	\N	\N	98377	98377	266181
10958	11533	42	applied	\N	\N	\N	\N	98378	98378	266182
10958	11534	43	applied	\N	\N	\N	\N	98379	98379	266183
10958	11535	44	applied	\N	\N	\N	\N	98380	98380	266184
10958	11540	45	applied	\N	\N	\N	\N	98381	98381	266185
10958	11541	46	applied	\N	\N	\N	\N	98382	98382	266186
10958	11542	47	applied	\N	\N	\N	\N	98383	98383	266187
10958	11545	48	applied	\N	\N	\N	\N	98384	98384	266188
10958	11516	49	applied	\N	\N	\N	\N	98385	98385	266189
10958	11546	50	applied	\N	\N	\N	\N	98386	98386	266190
10963	11557	0	applied	\N	\N	\N	\N	98411	98411	266215
10963	11558	1	applied	\N	\N	\N	\N	98412	98412	266216
10969	11559	0	applied	\N	\N	\N	\N	98423	98423	266227
10969	11560	1	applied	\N	\N	\N	\N	98424	98424	266228
10972	11562	0	applied	\N	\N	\N	\N	98428	98428	266232
10972	11564	2	applied	\N	\N	\N	\N	98430	98430	266234
10977	11571	0	applied	\N	\N	\N	\N	98442	98442	266246
10977	11572	1	applied	\N	\N	\N	\N	98443	98443	266247
10982	11576	0	applied	\N	\N	\N	\N	98455	98455	266259
10982	11577	1	applied	\N	\N	\N	\N	98456	98456	266260
10984	11578	0	applied	\N	\N	\N	\N	98459	98459	266263
10984	11579	1	applied	\N	\N	\N	\N	98460	98460	266264
10989	11586	0	applied	\N	\N	\N	\N	98471	98471	266275
10989	11587	1	applied	\N	\N	\N	\N	98472	98472	266276
10989	11588	2	applied	\N	\N	\N	\N	98473	98473	266277
10989	11589	3	applied	\N	\N	\N	\N	98474	98474	266278
10994	11594	0	applied	\N	\N	\N	\N	98491	98491	266295
10994	11595	1	applied	\N	\N	\N	\N	98492	98492	266296
10994	11596	2	applied	\N	\N	\N	\N	98493	98493	266297
10902	11455	0	applied	\N	\N	\N	\N	98081	98081	265885
10902	11456	1	applied	\N	\N	\N	\N	98082	98082	265886
10932	11518	0	applied	\N	\N	\N	\N	98248	98248	266052
10935	11517	0	applied	\N	\N	\N	\N	98253	98253	266057
10935	11520	1	applied	\N	\N	\N	\N	98254	98254	266058
10935	11518	2	applied	\N	\N	\N	\N	98255	98255	266059
10935	11519	3	applied	\N	\N	\N	\N	98256	98256	266060
10939	11523	0	applied	\N	\N	\N	\N	98265	98265	266069
10939	11524	1	applied	\N	\N	\N	\N	98266	98266	266070
10941	11525	0	applied	\N	\N	\N	\N	98269	98269	266073
10941	11526	1	applied	\N	\N	\N	\N	98270	98270	266074
10943	11525	0	applied	\N	\N	\N	\N	98273	98273	266077
10943	11526	1	applied	\N	\N	\N	\N	98274	98274	266078
10946	11527	0	applied	\N	\N	\N	\N	98279	98279	266083
10946	11528	1	applied	\N	\N	\N	\N	98280	98280	266084
10947	11529	0	applied	\N	\N	\N	\N	98281	98281	266085
10948	11531	1	applied	\N	\N	\N	\N	98283	98283	266087
10948	11532	2	applied	\N	\N	\N	\N	98284	98284	266088
10948	11533	3	applied	\N	\N	\N	\N	98285	98285	266089
10948	11534	4	applied	\N	\N	\N	\N	98286	98286	266090
10948	11535	5	applied	\N	\N	\N	\N	98287	98287	266091
10949	11530	0	applied	\N	\N	\N	\N	98288	98288	266092
10949	11531	1	applied	\N	\N	\N	\N	98289	98289	266093
10949	11532	2	applied	\N	\N	\N	\N	98290	98290	266094
10949	11533	3	applied	\N	\N	\N	\N	98291	98291	266095
10949	11534	4	applied	\N	\N	\N	\N	98292	98292	266096
10949	11535	5	applied	\N	\N	\N	\N	98293	98293	266097
10951	11530	0	applied	\N	\N	\N	\N	98313	98313	266117
10951	11531	1	applied	\N	\N	\N	\N	98314	98314	266118
10951	11532	2	applied	\N	\N	\N	\N	98315	98315	266119
10951	11533	3	applied	\N	\N	\N	\N	98316	98316	266120
10951	11534	4	applied	\N	\N	\N	\N	98317	98317	266121
10952	11536	0	applied	\N	\N	\N	\N	98319	98319	266123
10953	11536	0	applied	\N	\N	\N	\N	98320	98320	266124
10955	11537	0	applied	\N	\N	\N	\N	98326	98326	266130
10955	11538	1	applied	\N	\N	\N	\N	98327	98327	266131
10955	11539	2	applied	\N	\N	\N	\N	98328	98328	266132
10955	11540	3	applied	\N	\N	\N	\N	98329	98329	266133
10955	11541	4	applied	\N	\N	\N	\N	98330	98330	266134
10957	11543	0	applied	\N	\N	\N	\N	98332	98332	266136
10957	11544	1	applied	\N	\N	\N	\N	98333	98333	266137
10957	11545	2	applied	\N	\N	\N	\N	98334	98334	266138
10957	11546	3	applied	\N	\N	\N	\N	98335	98335	266139
10960	11550	0	applied	\N	\N	\N	\N	98390	98390	266194
10960	11551	1	applied	\N	\N	\N	\N	98391	98391	266195
10960	11552	2	applied	\N	\N	\N	\N	98392	98392	266196
10960	11553	3	applied	\N	\N	\N	\N	98393	98393	266197
10960	11554	4	applied	\N	\N	\N	\N	98394	98394	266198
10960	11556	6	applied	\N	\N	\N	\N	98396	98396	266200
10961	11550	0	applied	\N	\N	\N	\N	98397	98397	266201
10961	11551	1	applied	\N	\N	\N	\N	98398	98398	266202
10961	11552	2	applied	\N	\N	\N	\N	98399	98399	266203
10961	11553	3	applied	\N	\N	\N	\N	98400	98400	266204
10961	11554	4	applied	\N	\N	\N	\N	98401	98401	266205
10961	11555	5	applied	\N	\N	\N	\N	98402	98402	266206
10962	11550	0	applied	\N	\N	\N	\N	98404	98404	266208
10962	11551	1	applied	\N	\N	\N	\N	98405	98405	266209
10962	11552	2	applied	\N	\N	\N	\N	98406	98406	266210
10962	11553	3	applied	\N	\N	\N	\N	98407	98407	266211
10962	11554	4	applied	\N	\N	\N	\N	98408	98408	266212
10962	11555	5	applied	\N	\N	\N	\N	98409	98409	266213
10962	11556	6	applied	\N	\N	\N	\N	98410	98410	266214
10967	11559	0	applied	\N	\N	\N	\N	98419	98419	266223
10967	11560	1	applied	\N	\N	\N	\N	98420	98420	266224
10973	11562	0	applied	\N	\N	\N	\N	98431	98431	266235
10973	11565	1	applied	\N	\N	\N	\N	98432	98432	266236
10973	11563	2	applied	\N	\N	\N	\N	98433	98433	266237
10973	11564	3	applied	\N	\N	\N	\N	98434	98434	266238
10978	11573	0	applied	\N	\N	\N	\N	98444	98444	266248
10978	11574	1	applied	\N	\N	\N	\N	98445	98445	266249
10978	11575	2	applied	\N	\N	\N	\N	98446	98446	266250
10988	11586	0	applied	\N	\N	\N	\N	98467	98467	266271
10988	11587	1	applied	\N	\N	\N	\N	98468	98468	266272
10988	11588	2	applied	\N	\N	\N	\N	98469	98469	266273
10988	11589	3	applied	\N	\N	\N	\N	98470	98470	266274
10990	11586	0	applied	\N	\N	\N	\N	98475	98475	266279
10990	11587	1	applied	\N	\N	\N	\N	98476	98476	266280
10990	11588	2	applied	\N	\N	\N	\N	98477	98477	266281
10990	11589	3	applied	\N	\N	\N	\N	98478	98478	266282
10993	11590	0	applied	\N	\N	\N	\N	98487	98487	266291
10993	11592	2	applied	\N	\N	\N	\N	98489	98489	266293
10993	11593	3	applied	\N	\N	\N	\N	98490	98490	266294
10995	11598	0	applied	\N	\N	\N	\N	98495	98495	266299
10995	11599	1	applied	\N	\N	\N	\N	98496	98496	266300
10998	11600	0	applied	\N	\N	\N	\N	98501	98501	266305
10998	11601	1	applied	\N	\N	\N	\N	98502	98502	266306
11006	11603	0	applied	\N	\N	\N	\N	98507	98507	266311
11006	11602	1	applied	\N	\N	\N	\N	98508	98508	266312
11006	11604	2	applied	\N	\N	\N	\N	98509	98509	266313
11011	11607	0	applied	\N	\N	\N	\N	98528	98528	98528
11011	11608	1	applied	\N	\N	\N	\N	98529	98529	266331
11011	11609	2	applied	\N	\N	\N	\N	98530	98530	266332
11011	11610	3	applied	\N	\N	\N	\N	98531	98531	266333
11011	11611	4	applied	\N	\N	\N	\N	98532	98532	266334
11013	11613	0	applied	\N	\N	\N	\N	98540	98540	266341
11020	11624	0	applied	\N	\N	\N	\N	98574	98574	266374
11020	11625	1	applied	\N	\N	\N	\N	98575	98575	266375
11022	11626	0	applied	\N	\N	\N	\N	98580	98580	266380
11022	11627	1	applied	\N	\N	\N	\N	98581	98581	266381
11022	11628	2	applied	\N	\N	\N	\N	98582	98582	266382
11025	11629	0	applied	\N	\N	\N	\N	98585	98585	266385
11028	11630	0	applied	\N	\N	\N	\N	98606	98606	266406
11028	11631	1	applied	\N	\N	\N	\N	98607	98607	266407
11028	11632	2	applied	\N	\N	\N	\N	98608	98608	266408
11028	11633	3	applied	\N	\N	\N	\N	98609	98609	266409
11028	11634	4	applied	\N	\N	\N	\N	98610	98610	266410
11028	11635	5	applied	\N	\N	\N	\N	98611	98611	266411
11028	11636	6	applied	\N	\N	\N	\N	98612	98612	266412
11028	11637	7	applied	\N	\N	\N	\N	98613	98613	266413
11028	11638	8	applied	\N	\N	\N	\N	98614	98614	266414
11028	11639	9	applied	\N	\N	\N	\N	98615	98615	266415
11030	11642	0	applied	\N	\N	\N	\N	98618	98618	266418
10917	11500	1	applied	\N	\N	\N	\N	98196	98196	266000
10920	11508	0	applied	\N	\N	\N	\N	98207	98207	266011
10968	11559	0	applied	\N	\N	\N	\N	98421	98421	266225
10968	11560	1	applied	\N	\N	\N	\N	98422	98422	266226
10974	11566	0	applied	\N	\N	\N	\N	98435	98435	266239
10974	11567	1	applied	\N	\N	\N	\N	98436	98436	266240
10976	11568	0	applied	\N	\N	\N	\N	98439	98439	266243
10976	11569	1	applied	\N	\N	\N	\N	98440	98440	266244
10976	11570	2	applied	\N	\N	\N	\N	98441	98441	266245
10979	11573	0	applied	\N	\N	\N	\N	98447	98447	266251
10979	11574	1	applied	\N	\N	\N	\N	98448	98448	266252
10979	11575	2	applied	\N	\N	\N	\N	98449	98449	266253
10981	11576	0	applied	\N	\N	\N	\N	98453	98453	266257
10981	11577	1	applied	\N	\N	\N	\N	98454	98454	266258
10991	11590	0	applied	\N	\N	\N	\N	98479	98479	266283
10991	11592	2	applied	\N	\N	\N	\N	98481	98481	266285
10991	11593	3	applied	\N	\N	\N	\N	98482	98482	266286
10994	11597	3	applied	\N	\N	\N	\N	98494	98494	266298
10996	11600	0	applied	\N	\N	\N	\N	98497	98497	266301
10996	11601	1	applied	\N	\N	\N	\N	98498	98498	266302
10997	11600	0	applied	\N	\N	\N	\N	98499	98499	266303
10997	11601	1	applied	\N	\N	\N	\N	98500	98500	266304
11001	11602	0	applied	\N	\N	\N	\N	98504	98504	266308
11002	11602	0	applied	\N	\N	\N	\N	98505	98505	266309
11007	11603	0	applied	\N	\N	\N	\N	98510	98510	266314
11007	11605	1	applied	\N	\N	\N	\N	98511	98511	266315
11007	11604	2	applied	\N	\N	\N	\N	98512	98512	266316
11007	11606	3	applied	\N	\N	\N	\N	98513	98513	266317
11009	11603	0	applied	\N	\N	\N	\N	98518	98518	266322
11009	11605	1	applied	\N	\N	\N	\N	98519	98519	266323
11009	11604	2	applied	\N	\N	\N	\N	98520	98520	266324
11012	11607	0	applied	\N	\N	\N	\N	98534	98534	98534
11012	11608	1	applied	\N	\N	\N	\N	98535	98535	266336
11012	11609	2	applied	\N	\N	\N	\N	98536	98536	266337
11012	11610	3	applied	\N	\N	\N	\N	98537	98537	266338
11012	11611	4	applied	\N	\N	\N	\N	98538	98538	266339
11012	11612	5	applied	\N	\N	1000000000	\N	98539	98539	266340
11014	11614	0	applied	\N	\N	\N	\N	98541	98541	266342
11014	11615	1	applied	\N	\N	\N	\N	98542	98542	266343
11014	11616	2	applied	\N	\N	\N	\N	98543	98543	266344
11014	11617	3	applied	\N	\N	\N	\N	98544	98544	266345
11018	11620	0	applied	\N	\N	\N	\N	98568	98568	266368
11018	11622	1	applied	\N	\N	\N	\N	98569	98569	266369
11018	11621	2	applied	\N	\N	\N	\N	98570	98570	266370
11018	11623	3	applied	\N	\N	\N	\N	98571	98571	266371
11021	11622	0	applied	\N	\N	\N	\N	98576	98576	266376
11021	11624	1	applied	\N	\N	\N	\N	98577	98577	266377
11021	11625	3	applied	\N	\N	\N	\N	98579	98579	266379
11023	11629	0	applied	\N	\N	\N	\N	98583	98583	266383
11026	11630	0	applied	\N	\N	\N	\N	98586	98586	266386
11026	11631	1	applied	\N	\N	\N	\N	98587	98587	266387
11026	11632	2	applied	\N	\N	\N	\N	98588	98588	266388
11026	11633	3	applied	\N	\N	\N	\N	98589	98589	266389
11026	11634	4	applied	\N	\N	\N	\N	98590	98590	266390
11026	11635	5	applied	\N	\N	\N	\N	98591	98591	266391
11026	11636	6	applied	\N	\N	\N	\N	98592	98592	266392
11026	11637	7	applied	\N	\N	\N	\N	98593	98593	266393
11026	11638	8	applied	\N	\N	\N	\N	98594	98594	266394
11026	11639	9	applied	\N	\N	\N	\N	98595	98595	266395
11033	11550	0	applied	\N	\N	\N	\N	98624	98624	266424
11033	11551	1	applied	\N	\N	\N	\N	98625	98625	266425
11033	11568	2	applied	\N	\N	\N	\N	98626	98626	266426
11033	11547	3	applied	\N	\N	\N	\N	98627	98627	266427
11033	11614	5	applied	\N	\N	\N	\N	98629	98629	266428
11033	11615	6	applied	\N	\N	\N	\N	98630	98630	266429
11033	11616	7	applied	\N	\N	\N	\N	98631	98631	266430
11033	11617	8	applied	\N	\N	\N	\N	98632	98632	266431
11033	11548	9	applied	\N	\N	\N	\N	98633	98633	266432
11033	11554	10	applied	\N	\N	\N	\N	98634	98634	266433
11033	11612	11	applied	\N	\N	1000000000	\N	98635	98635	266434
11033	11631	12	applied	\N	\N	\N	\N	98636	98636	266435
11033	11549	13	applied	\N	\N	\N	\N	98637	98637	266436
11033	11552	14	applied	\N	\N	\N	\N	98638	98638	266437
11033	11553	15	applied	\N	\N	\N	\N	98639	98639	266438
11033	11558	16	applied	\N	\N	\N	\N	98640	98640	266439
11033	11559	17	applied	\N	\N	\N	\N	98641	98641	266440
11033	11561	18	applied	\N	\N	\N	\N	98642	98642	266441
11033	11562	19	applied	\N	\N	\N	\N	98643	98643	266442
11033	11565	20	applied	\N	\N	\N	\N	98644	98644	266443
11033	11569	23	applied	\N	\N	\N	\N	98646	98646	266445
11033	11572	24	applied	\N	\N	\N	\N	98647	98647	266446
11033	11573	25	applied	\N	\N	\N	\N	98648	98648	266447
11033	11576	26	applied	\N	\N	\N	\N	98649	98649	266448
11033	11578	27	applied	\N	\N	\N	\N	98650	98650	266449
11033	11582	28	applied	\N	\N	\N	\N	98651	98651	266450
11033	11583	29	applied	\N	\N	\N	\N	98652	98652	266451
11033	11584	30	applied	\N	\N	\N	\N	98653	98653	266452
11033	11588	31	applied	\N	\N	\N	\N	98654	98654	266453
11033	11589	32	applied	\N	\N	\N	\N	98655	98655	266454
11033	11592	33	applied	\N	\N	\N	\N	98656	98656	266455
11033	11593	34	applied	\N	\N	\N	\N	98657	98657	266456
11033	11596	35	applied	\N	\N	\N	\N	98658	98658	266457
11033	11597	36	applied	\N	\N	\N	\N	98659	98659	266458
11033	11598	37	applied	\N	\N	\N	\N	98660	98660	266459
11033	11601	38	applied	\N	\N	\N	\N	98661	98661	266460
11033	11605	40	applied	\N	\N	\N	\N	98663	98663	266462
11033	11608	41	applied	\N	\N	\N	\N	98664	98664	266463
11033	11611	42	applied	\N	\N	\N	\N	98665	98665	266464
11033	11613	43	applied	\N	\N	\N	\N	98666	98666	266465
11033	11619	44	applied	\N	\N	\N	\N	98667	98667	266466
11033	11621	45	applied	\N	\N	\N	\N	98668	98668	266467
11033	11623	46	applied	\N	\N	\N	\N	98669	98669	266468
11033	11625	47	applied	\N	\N	\N	\N	98670	98670	266469
11033	11626	48	applied	\N	\N	\N	\N	98671	98671	266470
11033	11633	49	applied	\N	\N	\N	\N	98672	98672	266471
11033	11634	50	applied	\N	\N	\N	\N	98673	98673	266472
11033	11635	51	applied	\N	\N	\N	\N	98674	98674	266473
11033	11636	52	applied	\N	\N	\N	\N	98675	98675	266474
11033	11640	53	applied	\N	\N	\N	\N	98676	98676	266475
11033	11643	54	applied	\N	\N	\N	\N	98677	98677	266476
11033	11644	55	applied	\N	\N	\N	\N	98678	98678	266477
10965	11557	0	applied	\N	\N	\N	\N	98415	98415	266219
10965	11558	1	applied	\N	\N	\N	\N	98416	98416	266220
11014	11618	4	applied	\N	\N	\N	\N	98545	98545	266346
11014	11619	5	applied	\N	\N	\N	\N	98546	98546	266347
11015	11614	0	applied	\N	\N	\N	\N	98547	98547	266348
11015	11615	1	applied	\N	\N	\N	\N	98548	98548	266349
11015	11616	2	applied	\N	\N	\N	\N	98549	98549	266350
11015	11617	3	applied	\N	\N	\N	\N	98550	98550	266351
11015	11618	4	applied	\N	\N	\N	\N	98551	98551	266352
11015	11619	5	applied	\N	\N	\N	\N	98552	98552	266353
11016	11607	0	applied	\N	\N	\N	\N	98553	98553	98553
11016	11614	1	applied	\N	\N	\N	\N	98554	98554	266354
11016	11615	2	applied	\N	\N	\N	\N	98555	98555	266355
11016	11616	3	applied	\N	\N	\N	\N	98556	98556	266356
11016	11617	4	applied	\N	\N	\N	\N	98557	98557	266357
11016	11609	6	applied	\N	\N	\N	\N	98559	98559	266359
11016	11610	7	applied	\N	\N	\N	\N	98560	98560	266360
11016	11618	8	applied	\N	\N	\N	\N	98561	98561	266361
11016	11611	9	applied	\N	\N	\N	\N	98562	98562	266362
11016	11612	10	applied	\N	\N	1000000000	\N	98563	98563	266363
11016	11613	11	applied	\N	\N	\N	\N	98564	98564	266364
11016	11619	12	applied	\N	\N	\N	\N	98565	98565	266365
11017	11620	0	applied	\N	\N	\N	\N	98566	98566	266366
11017	11621	1	applied	\N	\N	\N	\N	98567	98567	266367
11019	11624	0	applied	\N	\N	\N	\N	98572	98572	266372
11019	11625	1	applied	\N	\N	\N	\N	98573	98573	266373
11024	11629	0	applied	\N	\N	\N	\N	98584	98584	266384
11027	11630	0	applied	\N	\N	\N	\N	98596	98596	266396
11027	11631	1	applied	\N	\N	\N	\N	98597	98597	266397
11027	11632	2	applied	\N	\N	\N	\N	98598	98598	266398
11027	11633	3	applied	\N	\N	\N	\N	98599	98599	266399
11027	11635	5	applied	\N	\N	\N	\N	98601	98601	266401
11027	11636	6	applied	\N	\N	\N	\N	98602	98602	266402
11027	11637	7	applied	\N	\N	\N	\N	98603	98603	266403
11027	11638	8	applied	\N	\N	\N	\N	98604	98604	266404
11027	11639	9	applied	\N	\N	\N	\N	98605	98605	266405
11029	11640	0	applied	\N	\N	\N	\N	98616	98616	266416
11029	11641	1	applied	\N	\N	\N	\N	98617	98617	266417
11031	11644	0	applied	\N	\N	\N	\N	98620	98620	266420
11031	11645	1	applied	\N	\N	\N	\N	98621	98621	266421
11032	11646	0	applied	\N	\N	\N	\N	98622	98622	266422
11032	11647	1	applied	\N	\N	\N	\N	98623	98623	266423
11034	11648	0	applied	\N	\N	\N	\N	98722	98722	266521
11034	11649	1	applied	\N	\N	\N	\N	98723	98723	266522
11036	11648	0	applied	\N	\N	\N	\N	98725	98725	266524
11036	11649	1	applied	\N	\N	\N	\N	98726	98726	266525
11038	11650	0	applied	\N	\N	\N	\N	98729	98729	266528
11040	11652	0	applied	\N	\N	\N	\N	98733	98733	266532
11040	11653	1	applied	\N	\N	\N	\N	98734	98734	266533
11045	11652	0	applied	\N	\N	\N	\N	98743	98743	266542
11045	11653	1	applied	\N	\N	\N	\N	98744	98744	266543
11047	11654	0	applied	\N	\N	\N	\N	98747	98747	266546
11047	11655	1	applied	\N	\N	\N	\N	98748	98748	266547
11054	11662	0	applied	\N	\N	\N	\N	98765	98765	266564
11054	11663	1	applied	\N	\N	\N	\N	98766	98766	266565
11054	11664	2	applied	\N	\N	\N	\N	98767	98767	266566
11054	11665	3	applied	\N	\N	\N	\N	98768	98768	266567
11056	11662	0	applied	\N	\N	\N	\N	98811	98811	266610
11056	11663	1	applied	\N	\N	\N	\N	98812	98812	266611
11056	11664	2	applied	\N	\N	\N	\N	98813	98813	266612
11056	11665	3	applied	\N	\N	\N	\N	98814	98814	266613
11057	11662	0	applied	\N	\N	\N	\N	98815	98815	266614
11057	11663	1	applied	\N	\N	\N	\N	98816	98816	266615
11057	11665	3	applied	\N	\N	\N	\N	98818	98818	266617
11066	11680	0	applied	\N	\N	\N	\N	98845	98845	266644
11066	11681	1	applied	\N	\N	\N	\N	98846	98846	266645
11071	11685	0	applied	\N	\N	\N	\N	98856	98856	266655
11071	11686	1	applied	\N	\N	\N	\N	98857	98857	266656
11073	11689	0	applied	\N	\N	\N	\N	98860	98860	266659
11073	11690	1	applied	\N	\N	\N	\N	98861	98861	266660
11075	11691	0	applied	\N	\N	\N	\N	98987	98987	266785
11075	11692	1	applied	\N	\N	\N	\N	98988	98988	266786
11080	11696	0	applied	\N	\N	\N	\N	98999	98999	266797
11080	11697	1	applied	\N	\N	\N	\N	99000	99000	266798
11082	11698	0	applied	\N	\N	\N	\N	99003	99003	266801
11082	11699	1	applied	\N	\N	\N	\N	99004	99004	266802
11082	11700	2	applied	\N	\N	\N	\N	99005	99005	266803
11082	11701	3	applied	\N	\N	\N	\N	99006	99006	266804
11084	11702	0	applied	\N	\N	\N	\N	99009	99009	266807
11087	11707	0	applied	\N	\N	\N	\N	99017	99017	266815
11087	11708	1	applied	\N	\N	\N	\N	99018	99018	266816
11087	11709	2	applied	\N	\N	\N	\N	99019	99019	266817
11087	11710	3	applied	\N	\N	\N	\N	99020	99020	266818
11095	11719	0	applied	\N	\N	\N	\N	99036	99036	266834
11095	11720	1	applied	\N	\N	\N	\N	99037	99037	266835
11099	11721	0	applied	\N	\N	\N	\N	99044	99044	266842
11099	11722	1	applied	\N	\N	\N	\N	99045	99045	266843
11104	11648	0	applied	\N	\N	\N	\N	99083	99083	266881
11104	11682	1	applied	\N	\N	\N	\N	99084	99084	266882
11104	11649	2	applied	\N	\N	\N	\N	99085	99085	266883
11104	11723	3	applied	\N	\N	\N	\N	99086	99086	266884
11104	11693	4	applied	\N	\N	\N	\N	99087	99087	266885
11104	11650	5	applied	\N	\N	\N	\N	99088	99088	266886
11104	11651	6	applied	\N	\N	\N	\N	99089	99089	266887
11104	11724	7	applied	\N	\N	\N	\N	99090	99090	266888
11104	11726	9	applied	\N	\N	\N	\N	99092	99092	266890
11104	11727	10	applied	\N	\N	\N	\N	99093	99093	266891
11104	11699	11	applied	\N	\N	\N	\N	99094	99094	266892
11104	11652	12	applied	\N	\N	\N	\N	99095	99095	266893
11104	11653	13	applied	\N	\N	\N	\N	99096	99096	266894
11104	11654	14	applied	\N	\N	\N	\N	99097	99097	266895
11104	11657	15	applied	\N	\N	\N	\N	99098	99098	266896
11104	11655	16	applied	\N	\N	\N	\N	99099	99099	266897
11104	11656	17	applied	\N	\N	\N	\N	99100	99100	266898
11104	11658	18	applied	\N	\N	\N	\N	99101	99101	266899
11104	11659	19	applied	\N	\N	\N	\N	99102	99102	266900
11104	11662	20	applied	\N	\N	\N	\N	99103	99103	266901
11104	11663	21	applied	\N	\N	\N	\N	99104	99104	266902
11104	11666	22	applied	\N	\N	\N	\N	99105	99105	266903
11104	11668	23	applied	\N	\N	\N	\N	99106	99106	266904
11104	11669	24	applied	\N	\N	\N	\N	99107	99107	266905
11010	11611	4	applied	\N	\N	\N	\N	98526	98526	266329
11010	11612	5	applied	\N	\N	1000000000	\N	98527	98527	266330
11037	11649	1	applied	\N	\N	\N	\N	98728	98728	266527
11039	11650	0	applied	\N	\N	\N	\N	98731	98731	266530
11039	11651	1	applied	\N	\N	\N	\N	98732	98732	266531
11041	11652	0	applied	\N	\N	\N	\N	98735	98735	266534
11041	11653	1	applied	\N	\N	\N	\N	98736	98736	266535
11042	11652	0	applied	\N	\N	\N	\N	98737	98737	266536
11042	11653	1	applied	\N	\N	\N	\N	98738	98738	266537
11048	11654	0	applied	\N	\N	\N	\N	98749	98749	266548
11048	11655	1	applied	\N	\N	\N	\N	98750	98750	266549
11049	11656	0	applied	\N	\N	\N	\N	98751	98751	266550
11049	11657	1	applied	\N	\N	\N	\N	98752	98752	266551
11050	11656	0	applied	\N	\N	\N	\N	98753	98753	266552
11050	11657	1	applied	\N	\N	\N	\N	98754	98754	266553
11052	11659	1	applied	\N	\N	\N	\N	98758	98758	266557
11052	11660	2	applied	\N	\N	\N	\N	98759	98759	266558
11052	11661	3	applied	\N	\N	\N	\N	98760	98760	266559
11055	11627	0	applied	\N	\N	\N	\N	98769	98769	266568
11055	11631	1	applied	\N	\N	\N	\N	98770	98770	266569
11055	11632	2	applied	\N	\N	\N	\N	98771	98771	266570
11062	11674	0	applied	\N	\N	\N	\N	98833	98833	266632
11062	11675	1	applied	\N	\N	\N	\N	98834	98834	266633
11062	11676	2	applied	\N	\N	\N	\N	98835	98835	266634
11062	11677	3	applied	\N	\N	\N	\N	98836	98836	266635
11064	11678	0	applied	\N	\N	\N	\N	98841	98841	266640
11064	11679	1	applied	\N	\N	\N	\N	98842	98842	266641
11067	11680	0	applied	\N	\N	\N	\N	98847	98847	266646
11067	11681	1	applied	\N	\N	\N	\N	98848	98848	266647
11078	11693	0	applied	\N	\N	\N	\N	98994	98994	266792
11078	11694	1	applied	\N	\N	\N	\N	98995	98995	266793
11085	11704	0	applied	\N	\N	\N	\N	99011	99011	266809
11085	11705	1	applied	\N	\N	\N	\N	99012	99012	266810
11085	11706	2	applied	\N	\N	\N	\N	99013	99013	266811
11090	11714	0	applied	\N	\N	\N	\N	99024	99024	266822
11090	11715	1	applied	\N	\N	\N	\N	99025	99025	266823
11096	11719	0	applied	\N	\N	\N	\N	99038	99038	266836
11096	11720	1	applied	\N	\N	\N	\N	99039	99039	266837
11102	11728	0	applied	\N	\N	\N	\N	99065	99065	266863
11102	11723	1	applied	\N	\N	\N	\N	99066	99066	266864
11102	11724	2	applied	\N	\N	\N	\N	99067	99067	266865
11102	11725	3	applied	\N	\N	\N	\N	99068	99068	266866
11102	11726	4	applied	\N	\N	\N	\N	99069	99069	266867
11102	11727	5	applied	\N	\N	\N	\N	99070	99070	266868
11102	11729	6	applied	\N	\N	\N	\N	99071	99071	266869
11102	11730	7	applied	\N	\N	\N	\N	99072	99072	266870
11102	11731	8	applied	\N	\N	\N	\N	99073	99073	266871
11106	11733	1	applied	\N	\N	\N	\N	99167	99167	266965
11106	11734	2	applied	\N	\N	\N	\N	99168	99168	266966
11106	11735	3	applied	\N	\N	\N	\N	99169	99169	266967
11106	11736	4	applied	\N	\N	1000000000	\N	99170	99170	266968
11109	11737	0	applied	\N	\N	\N	\N	99175	99175	266973
11109	11738	2	applied	\N	\N	\N	\N	99176	99176	266974
11113	11744	0	applied	\N	\N	\N	\N	99189	99189	266987
11113	11745	1	applied	\N	\N	\N	\N	99190	99190	266988
11113	11746	2	applied	\N	\N	\N	\N	99191	99191	266989
11113	11747	3	applied	\N	\N	\N	\N	99192	99192	266990
11120	11752	0	applied	\N	\N	\N	\N	99213	99213	267011
11120	11753	1	applied	\N	\N	\N	\N	99214	99214	267012
11127	11758	0	applied	\N	\N	\N	\N	99303	99303	267101
11127	11759	1	applied	\N	\N	\N	\N	99304	99304	267102
11129	11760	0	applied	\N	\N	\N	\N	99307	99307	267105
11129	11761	1	applied	\N	\N	\N	\N	99308	99308	267106
11129	11763	3	applied	\N	\N	\N	\N	99310	99310	267108
11134	11766	0	applied	\N	\N	\N	\N	99444	99444	267242
11134	11767	1	applied	\N	\N	\N	\N	99445	99445	267243
11144	11781	0	applied	\N	\N	\N	\N	99473	99473	267271
11144	11782	1	applied	\N	\N	\N	\N	99474	99474	267272
11144	11783	2	applied	\N	\N	\N	\N	99475	99475	267273
11144	11784	3	applied	\N	\N	\N	\N	99476	99476	267274
11147	11781	0	applied	\N	\N	\N	\N	99485	99485	267283
11147	11782	1	applied	\N	\N	\N	\N	99486	99486	267284
11147	11783	2	applied	\N	\N	\N	\N	99487	99487	267285
11147	11784	3	applied	\N	\N	\N	\N	99488	99488	267286
11148	11785	0	applied	\N	\N	\N	\N	99489	99489	267287
11148	11786	1	applied	\N	\N	\N	\N	99490	99490	267288
11153	11793	0	applied	\N	\N	\N	\N	99499	99499	267297
11153	11794	1	applied	\N	\N	\N	\N	99500	99500	267298
11156	11797	0	applied	\N	\N	\N	\N	99505	99505	267303
11156	11799	2	applied	\N	\N	\N	\N	99507	99507	267305
11158	11800	0	applied	\N	\N	\N	\N	99508	99508	267306
11158	11801	1	applied	\N	\N	\N	\N	99509	99509	267307
11163	11802	0	applied	\N	\N	\N	\N	99510	99510	267308
11163	11803	1	applied	\N	\N	\N	\N	99511	99511	267309
11163	11804	2	applied	\N	\N	\N	\N	99512	99512	267310
11163	11805	3	applied	\N	\N	\N	\N	99513	99513	267311
11163	11806	4	applied	\N	\N	\N	\N	99514	99514	267312
11163	11807	5	applied	\N	\N	\N	\N	99515	99515	267313
11166	11810	0	applied	\N	\N	\N	\N	99520	99520	267318
11166	11811	1	applied	\N	\N	\N	\N	99521	99521	267319
11170	11812	0	applied	\N	\N	\N	\N	99522	99522	267320
11170	11813	1	applied	\N	\N	\N	\N	99523	99523	267321
11170	11814	2	applied	\N	\N	\N	\N	99524	99524	267322
11170	11815	3	applied	\N	\N	\N	\N	99525	99525	267323
11176	11812	0	applied	\N	\N	\N	\N	99546	99546	267344
11176	11814	2	applied	\N	\N	\N	\N	99548	99548	267346
11176	11815	3	applied	\N	\N	\N	\N	99549	99549	267347
11189	11826	0	applied	\N	\N	\N	\N	99707	99707	267504
11189	11827	1	applied	\N	\N	\N	\N	99708	99708	267505
11189	11828	2	applied	\N	\N	\N	\N	99709	99709	267506
11192	11829	0	applied	\N	\N	\N	\N	99715	99715	267512
11192	11830	1	applied	\N	\N	\N	\N	99716	99716	267513
11194	11831	0	applied	\N	\N	\N	\N	99719	99719	267516
11194	11832	1	applied	\N	\N	\N	\N	99720	99720	267517
11196	11833	0	applied	\N	\N	\N	\N	99723	99723	267520
11196	11834	1	applied	\N	\N	\N	\N	99724	99724	267521
11199	11841	0	applied	\N	\N	\N	\N	99731	99731	267528
11199	11842	1	applied	\N	\N	\N	\N	99732	99732	267529
11201	11843	0	applied	\N	\N	\N	\N	99735	99735	267532
11201	11844	1	applied	\N	\N	\N	\N	99736	99736	267533
11204	11849	1	applied	\N	\N	\N	\N	99744	99744	267541
11035	11648	0	applied	\N	\N	\N	\N	98724	98724	266523
11037	11648	0	applied	\N	\N	\N	\N	98727	98727	266526
11033	11564	61	applied	\N	\N	\N	\N	98684	98684	266483
11033	11566	62	applied	\N	\N	\N	\N	98685	98685	266484
11033	11570	63	applied	\N	\N	\N	\N	98686	98686	266485
11033	11571	64	applied	\N	\N	\N	\N	98687	98687	266486
11033	11574	65	applied	\N	\N	\N	\N	98688	98688	266487
11033	11577	66	applied	\N	\N	\N	\N	98689	98689	266488
11033	11579	67	applied	\N	\N	\N	\N	98690	98690	266489
11033	11580	68	applied	\N	\N	\N	\N	98691	98691	266490
11033	11581	69	applied	\N	\N	\N	\N	98692	98692	266491
11033	11585	70	applied	\N	\N	\N	\N	98693	98693	266492
11033	11586	71	applied	\N	\N	\N	\N	98694	98694	266493
11033	11587	72	applied	\N	\N	\N	\N	98695	98695	266494
11033	11590	73	applied	\N	\N	\N	\N	98696	98696	266495
11055	11624	3	applied	\N	\N	\N	\N	98772	98772	266571
11055	11629	5	applied	\N	\N	\N	\N	98774	98774	266573
11055	11630	6	applied	\N	\N	\N	\N	98775	98775	266574
11055	11625	7	applied	\N	\N	\N	\N	98776	98776	266575
11055	11626	8	applied	\N	\N	\N	\N	98777	98777	266576
11055	11633	9	applied	\N	\N	\N	\N	98778	98778	266577
11055	11634	10	applied	\N	\N	\N	\N	98779	98779	266578
11055	11635	11	applied	\N	\N	\N	\N	98780	98780	266579
11055	11636	12	applied	\N	\N	\N	\N	98781	98781	266580
11055	11640	13	applied	\N	\N	\N	\N	98782	98782	266581
11055	11643	14	applied	\N	\N	\N	\N	98783	98783	266582
11055	11644	15	applied	\N	\N	\N	\N	98784	98784	266583
11055	11646	16	applied	\N	\N	\N	\N	98785	98785	266584
11055	11648	17	applied	\N	\N	\N	\N	98786	98786	266585
11055	11650	18	applied	\N	\N	\N	\N	98787	98787	266586
11055	11652	19	applied	\N	\N	\N	\N	98788	98788	266587
11055	11655	20	applied	\N	\N	\N	\N	98789	98789	266588
11055	11660	22	applied	\N	\N	\N	\N	98791	98791	266590
11055	11661	23	applied	\N	\N	\N	\N	98792	98792	266591
11055	11664	24	applied	\N	\N	\N	\N	98793	98793	266592
11055	11665	25	applied	\N	\N	\N	\N	98794	98794	266593
11055	11637	26	applied	\N	\N	\N	\N	98795	98795	266594
11055	11638	27	applied	\N	\N	\N	\N	98796	98796	266595
11055	11639	28	applied	\N	\N	\N	\N	98797	98797	266596
11055	11641	29	applied	\N	\N	\N	\N	98798	98798	266597
11055	11642	30	applied	\N	\N	\N	\N	98799	98799	266598
11055	11645	31	applied	\N	\N	\N	\N	98800	98800	266599
11055	11647	32	applied	\N	\N	\N	\N	98801	98801	266600
11055	11649	33	applied	\N	\N	\N	\N	98802	98802	266601
11055	11651	34	applied	\N	\N	\N	\N	98803	98803	266602
11055	11653	35	applied	\N	\N	\N	\N	98804	98804	266603
11055	11654	36	applied	\N	\N	\N	\N	98805	98805	266604
11055	11657	37	applied	\N	\N	\N	\N	98806	98806	266605
11055	11659	39	applied	\N	\N	\N	\N	98808	98808	266607
11055	11662	40	applied	\N	\N	\N	\N	98809	98809	266608
11055	11663	41	applied	\N	\N	\N	\N	98810	98810	266609
11059	11666	0	applied	\N	\N	\N	\N	98819	98819	266618
11059	11667	1	applied	\N	\N	\N	\N	98820	98820	266619
11060	11668	0	applied	\N	\N	\N	\N	98821	98821	266620
11060	11669	1	applied	\N	\N	\N	\N	98822	98822	266621
11060	11670	2	applied	\N	\N	\N	\N	98823	98823	266622
11060	11671	3	applied	\N	\N	\N	\N	98824	98824	266623
11060	11672	4	applied	\N	\N	\N	\N	98825	98825	266624
11060	11673	5	applied	\N	\N	\N	\N	98826	98826	266625
11063	11674	0	applied	\N	\N	\N	\N	98837	98837	266636
11063	11675	1	applied	\N	\N	\N	\N	98838	98838	266637
11063	11676	2	applied	\N	\N	\N	\N	98839	98839	266638
11063	11677	3	applied	\N	\N	\N	\N	98840	98840	266639
11068	11680	0	applied	\N	\N	\N	\N	98849	98849	266648
11069	11682	0	applied	\N	\N	\N	\N	98851	98851	266650
11069	11683	1	applied	\N	\N	\N	\N	98852	98852	266651
11069	11684	2	applied	\N	\N	\N	\N	98853	98853	266652
11074	11568	0	applied	\N	\N	\N	\N	98862	98862	266661
11074	11607	1	applied	\N	\N	\N	\N	98863	98863	98863
11074	11614	2	applied	\N	\N	\N	\N	98864	98864	266662
11074	11615	3	applied	\N	\N	\N	\N	98865	98865	266663
11074	11616	4	applied	\N	\N	\N	\N	98866	98866	266664
11074	11617	5	applied	\N	\N	\N	\N	98867	98867	266665
11074	11682	6	applied	\N	\N	\N	\N	98868	98868	266666
11074	11559	7	applied	\N	\N	\N	\N	98869	98869	266667
11074	11561	8	applied	\N	\N	\N	\N	98870	98870	266668
11074	11562	9	applied	\N	\N	\N	\N	98871	98871	266669
11074	11565	10	applied	\N	\N	\N	\N	98872	98872	266670
11074	11567	11	applied	\N	\N	\N	\N	98873	98873	266671
11074	11569	12	applied	\N	\N	\N	\N	98874	98874	266672
11074	11573	14	applied	\N	\N	\N	\N	98876	98876	266674
11074	11576	15	applied	\N	\N	\N	\N	98877	98877	266675
11074	11578	16	applied	\N	\N	\N	\N	98878	98878	266676
11074	11632	17	applied	\N	\N	1000000000	\N	98879	98879	266677
11074	11612	18	applied	\N	\N	\N	\N	98880	98880	266678
11074	11631	19	applied	\N	\N	\N	\N	98881	98881	266679
11074	11560	20	applied	\N	\N	\N	\N	98882	98882	266680
11074	11563	21	applied	\N	\N	\N	\N	98883	98883	266681
11074	11564	22	applied	\N	\N	\N	\N	98884	98884	266682
11074	11566	23	applied	\N	\N	\N	\N	98885	98885	266683
11074	11570	24	applied	\N	\N	\N	\N	98886	98886	266684
11074	11571	25	applied	\N	\N	\N	\N	98887	98887	266685
11074	11574	26	applied	\N	\N	\N	\N	98888	98888	266686
11074	11577	27	applied	\N	\N	\N	\N	98889	98889	266687
11074	11579	28	applied	\N	\N	\N	\N	98890	98890	266688
11074	11580	29	applied	\N	\N	\N	\N	98891	98891	266689
11074	11582	31	applied	\N	\N	\N	\N	98893	98893	266691
11074	11583	32	applied	\N	\N	\N	\N	98894	98894	266692
11074	11584	33	applied	\N	\N	\N	\N	98895	98895	266693
11074	11588	34	applied	\N	\N	\N	\N	98896	98896	266694
11074	11589	35	applied	\N	\N	\N	\N	98897	98897	266695
11074	11592	36	applied	\N	\N	\N	\N	98898	98898	266696
11074	11593	37	applied	\N	\N	\N	\N	98899	98899	266697
11074	11596	38	applied	\N	\N	\N	\N	98900	98900	266698
11074	11597	39	applied	\N	\N	\N	\N	98901	98901	266699
11074	11598	40	applied	\N	\N	\N	\N	98902	98902	266700
11074	11601	41	applied	\N	\N	\N	\N	98903	98903	266701
11074	11603	42	applied	\N	\N	\N	\N	98904	98904	266702
11074	11605	43	applied	\N	\N	\N	\N	98905	98905	266703
11074	11608	44	applied	\N	\N	\N	\N	98906	98906	266704
11074	11611	45	applied	\N	\N	\N	\N	98907	98907	266705
11074	11613	46	applied	\N	\N	\N	\N	98908	98908	266706
11033	11563	60	applied	\N	\N	\N	\N	98683	98683	266482
11033	11599	77	applied	\N	\N	\N	\N	98700	98700	266499
11033	11600	78	applied	\N	\N	\N	\N	98701	98701	266500
11033	11602	79	applied	\N	\N	\N	\N	98702	98702	266501
11033	11604	80	applied	\N	\N	\N	\N	98703	98703	266502
11033	11606	81	applied	\N	\N	\N	\N	98704	98704	266503
11033	11609	82	applied	\N	\N	\N	\N	98705	98705	266504
11033	11610	83	applied	\N	\N	\N	\N	98706	98706	266505
11033	11618	84	applied	\N	\N	\N	\N	98707	98707	266506
11033	11620	85	applied	\N	\N	\N	\N	98708	98708	266507
11033	11622	86	applied	\N	\N	\N	\N	98709	98709	266508
11033	11624	87	applied	\N	\N	\N	\N	98710	98710	266509
11033	11628	88	applied	\N	\N	\N	\N	98711	98711	266510
11033	11629	89	applied	\N	\N	\N	\N	98712	98712	266511
11033	11637	91	applied	\N	\N	\N	\N	98714	98714	266513
11033	11638	92	applied	\N	\N	\N	\N	98715	98715	266514
11033	11639	93	applied	\N	\N	\N	\N	98716	98716	266515
11033	11641	94	applied	\N	\N	\N	\N	98717	98717	266516
11033	11642	95	applied	\N	\N	\N	\N	98718	98718	266517
11033	11645	96	applied	\N	\N	\N	\N	98719	98719	266518
11033	11647	97	applied	\N	\N	\N	\N	98720	98720	266519
11033	11556	98	applied	\N	\N	\N	\N	98721	98721	266520
11043	11652	0	applied	\N	\N	\N	\N	98739	98739	266538
11043	11653	1	applied	\N	\N	\N	\N	98740	98740	266539
11044	11652	0	applied	\N	\N	\N	\N	98741	98741	266540
11044	11653	1	applied	\N	\N	\N	\N	98742	98742	266541
11046	11654	0	applied	\N	\N	\N	\N	98745	98745	266544
11046	11655	1	applied	\N	\N	\N	\N	98746	98746	266545
11051	11654	0	applied	\N	\N	\N	\N	98755	98755	266554
11051	11655	1	applied	\N	\N	\N	\N	98756	98756	266555
11053	11663	1	applied	\N	\N	\N	\N	98762	98762	266561
11053	11664	2	applied	\N	\N	\N	\N	98763	98763	266562
11053	11665	3	applied	\N	\N	\N	\N	98764	98764	266563
11061	11668	0	applied	\N	\N	\N	\N	98827	98827	266626
11061	11669	1	applied	\N	\N	\N	\N	98828	98828	266627
11061	11670	2	applied	\N	\N	\N	\N	98829	98829	266628
11061	11671	3	applied	\N	\N	\N	\N	98830	98830	266629
11061	11672	4	applied	\N	\N	\N	\N	98831	98831	266630
11061	11673	5	applied	\N	\N	\N	\N	98832	98832	266631
11065	11678	0	applied	\N	\N	\N	\N	98843	98843	266642
11065	11679	1	applied	\N	\N	\N	\N	98844	98844	266643
11070	11685	0	applied	\N	\N	\N	\N	98854	98854	266653
11070	11686	1	applied	\N	\N	\N	\N	98855	98855	266654
11072	11687	0	applied	\N	\N	\N	\N	98858	98858	266657
11072	11688	1	applied	\N	\N	\N	\N	98859	98859	266658
11074	11619	48	applied	\N	\N	\N	\N	98909	98909	266707
11074	11623	50	applied	\N	\N	\N	\N	98911	98911	266709
11074	11625	51	applied	\N	\N	\N	\N	98912	98912	266710
11074	11626	52	applied	\N	\N	\N	\N	98913	98913	266711
11074	11633	53	applied	\N	\N	\N	\N	98914	98914	266712
11074	11634	54	applied	\N	\N	\N	\N	98915	98915	266713
11074	11635	55	applied	\N	\N	\N	\N	98916	98916	266714
11074	11636	56	applied	\N	\N	\N	\N	98917	98917	266715
11074	11640	57	applied	\N	\N	\N	\N	98918	98918	266716
11074	11643	58	applied	\N	\N	\N	\N	98919	98919	266717
11074	11644	59	applied	\N	\N	\N	\N	98920	98920	266718
11074	11646	60	applied	\N	\N	\N	\N	98921	98921	266719
11074	11648	61	applied	\N	\N	\N	\N	98922	98922	266720
11074	11650	62	applied	\N	\N	\N	\N	98923	98923	266721
11074	11652	63	applied	\N	\N	\N	\N	98924	98924	266722
11074	11655	64	applied	\N	\N	\N	\N	98925	98925	266723
11077	11693	0	applied	\N	\N	\N	\N	98991	98991	266789
11077	11695	2	applied	\N	\N	\N	\N	98993	98993	266791
11079	11696	0	applied	\N	\N	\N	\N	98997	98997	266795
11079	11697	1	applied	\N	\N	\N	\N	98998	98998	266796
11089	11713	0	applied	\N	\N	\N	\N	99023	99023	266821
11092	11716	0	applied	\N	\N	\N	\N	99029	99029	266827
11092	11717	1	applied	\N	\N	\N	\N	99030	99030	266828
11092	11718	2	applied	\N	\N	\N	\N	99031	99031	266829
11094	11719	0	applied	\N	\N	\N	\N	99034	99034	266832
11094	11720	1	applied	\N	\N	\N	\N	99035	99035	266833
11098	11721	0	applied	\N	\N	\N	\N	99042	99042	266840
11098	11722	1	applied	\N	\N	\N	\N	99043	99043	266841
11101	11728	0	applied	\N	\N	\N	\N	99056	99056	266854
11101	11723	1	applied	\N	\N	\N	\N	99057	99057	266855
11101	11724	2	applied	\N	\N	\N	\N	99058	99058	266856
11101	11725	3	applied	\N	\N	\N	\N	99059	99059	266857
11101	11726	4	applied	\N	\N	\N	\N	99060	99060	266858
11101	11729	6	applied	\N	\N	\N	\N	99062	99062	266860
11101	11730	7	applied	\N	\N	\N	\N	99063	99063	266861
11101	11731	8	applied	\N	\N	\N	\N	99064	99064	266862
11105	11732	0	applied	\N	\N	\N	\N	99161	99161	266959
11105	11733	1	applied	\N	\N	\N	\N	99162	99162	266960
11105	11734	2	applied	\N	\N	\N	\N	99163	99163	266961
11105	11735	3	applied	\N	\N	\N	\N	99164	99164	266962
11105	11736	4	applied	\N	\N	1000000000	\N	99165	99165	266963
11107	11737	0	applied	\N	\N	\N	\N	99171	99171	266969
11107	11738	2	applied	\N	\N	\N	\N	99172	99172	266970
11112	11739	0	applied	\N	\N	\N	\N	99184	99184	266982
11112	11740	1	applied	\N	\N	1000000000	\N	99185	99185	266983
11112	11741	2	applied	\N	\N	\N	\N	99186	99186	266984
11112	11742	3	applied	\N	\N	\N	\N	99187	99187	266985
11112	11743	4	applied	\N	\N	\N	\N	99188	99188	266986
11115	11744	0	applied	\N	\N	\N	\N	99197	99197	266995
11115	11746	2	applied	\N	\N	\N	\N	99199	99199	266997
11115	11747	3	applied	\N	\N	\N	\N	99200	99200	266998
11121	11754	0	applied	\N	\N	\N	\N	99215	99215	267013
11121	11755	1	applied	\N	\N	\N	\N	99216	99216	267014
11130	11760	0	applied	\N	\N	\N	\N	99311	99311	267109
11130	11761	1	applied	\N	\N	\N	\N	99312	99312	267110
11130	11762	2	applied	\N	\N	\N	\N	99313	99313	267111
11130	11763	3	applied	\N	\N	\N	\N	99314	99314	267112
11135	11766	0	applied	\N	\N	\N	\N	99446	99446	267244
11135	11767	1	applied	\N	\N	\N	\N	99447	99447	267245
11138	11768	0	applied	\N	\N	\N	\N	99456	99456	267254
11138	11769	1	applied	\N	\N	\N	\N	99457	99457	267255
11138	11770	2	applied	\N	\N	\N	\N	99458	99458	267256
11138	11771	3	applied	\N	\N	\N	\N	99459	99459	267257
11138	11772	4	applied	\N	\N	\N	\N	99460	99460	267258
11138	11773	5	applied	\N	\N	\N	\N	99461	99461	267259
11033	11594	75	applied	\N	\N	\N	\N	98698	98698	266497
11033	11595	76	applied	\N	\N	\N	\N	98699	98699	266498
11074	11590	69	applied	\N	\N	\N	\N	98930	98930	266728
11074	11591	70	applied	\N	\N	\N	\N	98931	98931	266729
11074	11594	71	applied	\N	\N	\N	\N	98932	98932	266730
11074	11595	72	applied	\N	\N	\N	\N	98933	98933	266731
11074	11599	73	applied	\N	\N	\N	\N	98934	98934	266732
11074	11600	74	applied	\N	\N	\N	\N	98935	98935	266733
11074	11602	75	applied	\N	\N	\N	\N	98936	98936	266734
11074	11604	76	applied	\N	\N	\N	\N	98937	98937	266735
11074	11606	77	applied	\N	\N	\N	\N	98938	98938	266736
11074	11609	78	applied	\N	\N	\N	\N	98939	98939	266737
11074	11610	79	applied	\N	\N	\N	\N	98940	98940	266738
11074	11618	80	applied	\N	\N	\N	\N	98941	98941	266739
11074	11620	81	applied	\N	\N	\N	\N	98942	98942	266740
11074	11622	82	applied	\N	\N	\N	\N	98943	98943	266741
11074	11628	84	applied	\N	\N	\N	\N	98945	98945	266743
11074	11629	85	applied	\N	\N	\N	\N	98946	98946	266744
11074	11630	86	applied	\N	\N	\N	\N	98947	98947	266745
11074	11660	87	applied	\N	\N	\N	\N	98948	98948	266746
11074	11661	88	applied	\N	\N	\N	\N	98949	98949	266747
11074	11664	89	applied	\N	\N	\N	\N	98950	98950	266748
11074	11665	90	applied	\N	\N	\N	\N	98951	98951	266749
11074	11667	91	applied	\N	\N	\N	\N	98952	98952	266750
11074	11671	92	applied	\N	\N	\N	\N	98953	98953	266751
11074	11672	93	applied	\N	\N	\N	\N	98954	98954	266752
11074	11673	94	applied	\N	\N	\N	\N	98955	98955	266753
11074	11674	95	applied	\N	\N	\N	\N	98956	98956	266754
11074	11677	96	applied	\N	\N	\N	\N	98957	98957	266755
11074	11678	97	applied	\N	\N	\N	\N	98958	98958	266756
11074	11681	98	applied	\N	\N	\N	\N	98959	98959	266757
11074	11684	99	applied	\N	\N	\N	\N	98960	98960	266758
11074	11687	101	applied	\N	\N	\N	\N	98962	98962	266760
11074	11637	102	applied	\N	\N	\N	\N	98963	98963	266761
11074	11638	103	applied	\N	\N	\N	\N	98964	98964	266762
11074	11639	104	applied	\N	\N	\N	\N	98965	98965	266763
11074	11641	105	applied	\N	\N	\N	\N	98966	98966	266764
11074	11642	106	applied	\N	\N	\N	\N	98967	98967	266765
11074	11645	107	applied	\N	\N	\N	\N	98968	98968	266766
11074	11647	108	applied	\N	\N	\N	\N	98969	98969	266767
11074	11649	109	applied	\N	\N	\N	\N	98970	98970	266768
11074	11651	110	applied	\N	\N	\N	\N	98971	98971	266769
11074	11653	111	applied	\N	\N	\N	\N	98972	98972	266770
11074	11654	112	applied	\N	\N	\N	\N	98973	98973	266771
11074	11657	113	applied	\N	\N	\N	\N	98974	98974	266772
11074	11658	114	applied	\N	\N	\N	\N	98975	98975	266773
11074	11659	115	applied	\N	\N	\N	\N	98976	98976	266774
11074	11662	116	applied	\N	\N	\N	\N	98977	98977	266775
11074	11666	118	applied	\N	\N	\N	\N	98979	98979	266777
11074	11668	119	applied	\N	\N	\N	\N	98980	98980	266778
11074	11669	120	applied	\N	\N	\N	\N	98981	98981	266779
11074	11670	121	applied	\N	\N	\N	\N	98982	98982	266780
11074	11675	122	applied	\N	\N	\N	\N	98983	98983	266781
11074	11676	123	applied	\N	\N	\N	\N	98984	98984	266782
11074	11679	124	applied	\N	\N	\N	\N	98985	98985	266783
11074	11680	125	applied	\N	\N	\N	\N	98986	98986	266784
11076	11691	0	applied	\N	\N	\N	\N	98989	98989	266787
11076	11692	1	applied	\N	\N	\N	\N	98990	98990	266788
11081	11696	0	applied	\N	\N	\N	\N	99001	99001	266799
11081	11697	1	applied	\N	\N	\N	\N	99002	99002	266800
11083	11702	0	applied	\N	\N	\N	\N	99007	99007	266805
11083	11703	1	applied	\N	\N	\N	\N	99008	99008	266806
11086	11704	0	applied	\N	\N	\N	\N	99014	99014	266812
11086	11705	1	applied	\N	\N	\N	\N	99015	99015	266813
11088	11711	0	applied	\N	\N	\N	\N	99021	99021	266819
11088	11712	1	applied	\N	\N	\N	\N	99022	99022	266820
11091	11716	0	applied	\N	\N	\N	\N	99026	99026	266824
11091	11717	1	applied	\N	\N	\N	\N	99027	99027	266825
11091	11718	2	applied	\N	\N	\N	\N	99028	99028	266826
11093	11719	0	applied	\N	\N	\N	\N	99032	99032	266830
11093	11720	1	applied	\N	\N	\N	\N	99033	99033	266831
11097	11719	0	applied	\N	\N	\N	\N	99040	99040	266838
11097	11720	1	applied	\N	\N	\N	\N	99041	99041	266839
11100	11723	0	applied	\N	\N	\N	\N	99046	99046	266844
11100	11693	1	applied	\N	\N	\N	\N	99047	99047	266845
11100	11724	2	applied	\N	\N	\N	\N	99048	99048	266846
11100	11725	3	applied	\N	\N	\N	\N	99049	99049	266847
11100	11726	4	applied	\N	\N	\N	\N	99050	99050	266848
11100	11727	5	applied	\N	\N	\N	\N	99051	99051	266849
11100	11699	6	applied	\N	\N	\N	\N	99052	99052	266850
11100	11705	8	applied	\N	\N	\N	\N	99054	99054	266852
11100	11718	9	applied	\N	\N	\N	\N	99055	99055	266853
11103	11728	0	applied	\N	\N	\N	\N	99074	99074	266872
11103	11723	1	applied	\N	\N	\N	\N	99075	99075	266873
11103	11724	2	applied	\N	\N	\N	\N	99076	99076	266874
11103	11725	3	applied	\N	\N	\N	\N	99077	99077	266875
11103	11726	4	applied	\N	\N	\N	\N	99078	99078	266876
11103	11727	5	applied	\N	\N	\N	\N	99079	99079	266877
11103	11729	6	applied	\N	\N	\N	\N	99080	99080	266878
11103	11730	7	applied	\N	\N	\N	\N	99081	99081	266879
11103	11731	8	applied	\N	\N	\N	\N	99082	99082	266880
11104	11675	26	applied	\N	\N	\N	\N	99109	99109	266907
11104	11676	27	applied	\N	\N	\N	\N	99110	99110	266908
11104	11679	28	applied	\N	\N	\N	\N	99111	99111	266909
11104	11680	29	applied	\N	\N	\N	\N	99112	99112	266910
11104	11683	30	applied	\N	\N	\N	\N	99113	99113	266911
11104	11688	32	applied	\N	\N	\N	\N	99115	99115	266913
11104	11689	33	applied	\N	\N	\N	\N	99116	99116	266914
11104	11692	34	applied	\N	\N	\N	\N	99117	99117	266915
11104	11694	35	applied	\N	\N	\N	\N	99118	99118	266916
11104	11697	36	applied	\N	\N	\N	\N	99119	99119	266917
11104	11698	37	applied	\N	\N	\N	\N	99120	99120	266918
11104	11700	38	applied	\N	\N	\N	\N	99121	99121	266919
11104	11705	39	applied	\N	\N	\N	\N	99122	99122	266920
11104	11718	40	applied	\N	\N	\N	\N	99123	99123	266921
11104	11703	41	applied	\N	\N	\N	\N	99124	99124	266922
11104	11706	42	applied	\N	\N	\N	\N	99125	99125	266923
11110	11737	0	applied	\N	\N	\N	\N	99177	99177	266975
11110	11738	2	applied	\N	\N	\N	\N	99178	99178	266976
11111	11739	0	applied	\N	\N	\N	\N	99179	99179	266977
11111	11741	2	applied	\N	\N	\N	\N	99181	99181	266979
11074	11586	67	applied	\N	\N	\N	\N	98928	98928	266726
11074	11587	68	applied	\N	\N	\N	\N	98929	98929	266727
11104	11715	47	applied	\N	\N	\N	\N	99130	99130	266928
11104	11716	48	applied	\N	\N	\N	\N	99131	99131	266929
11104	11719	50	applied	\N	\N	\N	\N	99132	99132	266930
11104	11721	51	applied	\N	\N	\N	\N	99133	99133	266931
11104	11728	52	applied	\N	\N	\N	\N	99134	99134	266932
11104	11731	53	applied	\N	\N	\N	\N	99135	99135	266933
11104	11660	54	applied	\N	\N	\N	\N	99136	99136	266934
11104	11661	55	applied	\N	\N	\N	\N	99137	99137	266935
11104	11664	56	applied	\N	\N	\N	\N	99138	99138	266936
11104	11665	57	applied	\N	\N	\N	\N	99139	99139	266937
11104	11667	58	applied	\N	\N	\N	\N	99140	99140	266938
11104	11671	59	applied	\N	\N	\N	\N	99141	99141	266939
11104	11672	60	applied	\N	\N	\N	\N	99142	99142	266940
11104	11673	61	applied	\N	\N	\N	\N	99143	99143	266941
11104	11674	62	applied	\N	\N	\N	\N	99144	99144	266942
11104	11677	63	applied	\N	\N	\N	\N	99145	99145	266943
11104	11681	65	applied	\N	\N	\N	\N	99147	99147	266945
11104	11684	66	applied	\N	\N	\N	\N	99148	99148	266946
11104	11686	67	applied	\N	\N	\N	\N	99149	99149	266947
11104	11687	68	applied	\N	\N	\N	\N	99150	99150	266948
11104	11690	69	applied	\N	\N	\N	\N	99151	99151	266949
11104	11691	70	applied	\N	\N	\N	\N	99152	99152	266950
11104	11695	71	applied	\N	\N	\N	\N	99153	99153	266951
11104	11696	72	applied	\N	\N	\N	\N	99154	99154	266952
11104	11701	73	applied	\N	\N	\N	\N	99155	99155	266953
11104	11702	74	applied	\N	\N	\N	\N	99156	99156	266954
11104	11704	75	applied	\N	\N	\N	\N	99157	99157	266955
11104	11709	76	applied	\N	\N	\N	\N	99158	99158	266956
11104	11710	77	applied	\N	\N	\N	\N	99159	99159	266957
11104	11712	78	applied	\N	\N	\N	\N	99160	99160	266958
11108	11737	0	applied	\N	\N	\N	\N	99173	99173	266971
11108	11738	2	applied	\N	\N	\N	\N	99174	99174	266972
11111	11743	4	applied	\N	\N	\N	\N	99183	99183	266981
11114	11744	0	applied	\N	\N	\N	\N	99193	99193	266991
11114	11745	1	applied	\N	\N	\N	\N	99194	99194	266992
11114	11746	2	applied	\N	\N	\N	\N	99195	99195	266993
11114	11747	3	applied	\N	\N	\N	\N	99196	99196	266994
11116	11744	0	applied	\N	\N	\N	\N	99201	99201	266999
11116	11745	1	applied	\N	\N	\N	\N	99202	99202	267000
11116	11746	2	applied	\N	\N	\N	\N	99203	99203	267001
11116	11747	3	applied	\N	\N	\N	\N	99204	99204	267002
11118	11748	0	applied	\N	\N	\N	\N	99205	99205	267003
11118	11749	1	applied	\N	\N	\N	\N	99206	99206	267004
11118	11750	2	applied	\N	\N	\N	\N	99207	99207	267005
11118	11751	3	applied	\N	\N	\N	\N	99208	99208	267006
11119	11748	0	applied	\N	\N	\N	\N	99209	99209	267007
11119	11749	1	applied	\N	\N	\N	\N	99210	99210	267008
11119	11750	2	applied	\N	\N	\N	\N	99211	99211	267009
11122	11754	0	applied	\N	\N	\N	\N	99217	99217	267015
11122	11755	1	applied	\N	\N	\N	\N	99218	99218	267016
11123	11754	0	applied	\N	\N	\N	\N	99219	99219	267017
11123	11755	1	applied	\N	\N	\N	\N	99220	99220	267018
11124	11756	0	applied	\N	\N	\N	\N	99221	99221	267019
11124	11757	1	applied	\N	\N	\N	\N	99222	99222	267020
11125	11682	0	applied	\N	\N	\N	\N	99223	99223	267021
11125	11680	1	applied	\N	\N	\N	\N	99224	99224	267022
11125	11681	2	applied	\N	\N	\N	\N	99225	99225	267023
11125	11723	3	applied	\N	\N	\N	\N	99226	99226	267024
11125	11693	4	applied	\N	\N	\N	\N	99227	99227	267025
11126	11758	0	applied	\N	\N	\N	\N	99301	99301	267099
11126	11759	1	applied	\N	\N	\N	\N	99302	99302	267100
11131	11682	0	applied	\N	\N	\N	\N	99315	99315	267113
11131	11627	1	applied	\N	\N	\N	\N	99316	99316	267114
11131	11723	2	applied	\N	\N	\N	\N	99317	99317	267115
11131	11631	4	applied	\N	\N	\N	\N	99319	99319	267117
11131	11724	5	applied	\N	\N	\N	\N	99320	99320	267118
11131	11725	6	applied	\N	\N	\N	\N	99321	99321	267119
11131	11726	7	applied	\N	\N	\N	\N	99322	99322	267120
11131	11727	8	applied	\N	\N	\N	\N	99323	99323	267121
11131	11699	9	applied	\N	\N	\N	\N	99324	99324	267122
11131	11632	10	applied	\N	\N	\N	\N	99325	99325	267123
11131	11624	11	applied	\N	\N	\N	\N	99326	99326	267124
11131	11628	12	applied	\N	\N	\N	\N	99327	99327	267125
11131	11629	13	applied	\N	\N	\N	\N	99328	99328	267126
11131	11630	14	applied	\N	\N	\N	\N	99329	99329	267127
11131	11625	15	applied	\N	\N	\N	\N	99330	99330	267128
11131	11626	16	applied	\N	\N	\N	\N	99331	99331	267129
11131	11633	17	applied	\N	\N	\N	\N	99332	99332	267130
11131	11634	18	applied	\N	\N	\N	\N	99333	99333	267131
11131	11635	19	applied	\N	\N	\N	\N	99334	99334	267132
11131	11640	21	applied	\N	\N	\N	\N	99336	99336	267134
11131	11643	22	applied	\N	\N	\N	\N	99337	99337	267135
11131	11644	23	applied	\N	\N	\N	\N	99338	99338	267136
11131	11646	24	applied	\N	\N	\N	\N	99339	99339	267137
11131	11648	25	applied	\N	\N	\N	\N	99340	99340	267138
11131	11650	26	applied	\N	\N	\N	\N	99341	99341	267139
11131	11652	27	applied	\N	\N	\N	\N	99342	99342	267140
11131	11655	28	applied	\N	\N	\N	\N	99343	99343	267141
11131	11656	29	applied	\N	\N	\N	\N	99344	99344	267142
11131	11700	30	applied	\N	\N	\N	\N	99345	99345	267143
11131	11705	31	applied	\N	\N	\N	\N	99346	99346	267144
11131	11718	32	applied	\N	\N	\N	\N	99347	99347	267145
11131	11660	33	applied	\N	\N	\N	\N	99348	99348	267146
11131	11661	34	applied	\N	\N	\N	\N	99349	99349	267147
11131	11664	35	applied	\N	\N	\N	\N	99350	99350	267148
11131	11665	36	applied	\N	\N	\N	\N	99351	99351	267149
11131	11671	38	applied	\N	\N	\N	\N	99353	99353	267151
11131	11672	39	applied	\N	\N	\N	\N	99354	99354	267152
11131	11673	40	applied	\N	\N	\N	\N	99355	99355	267153
11131	11674	41	applied	\N	\N	\N	\N	99356	99356	267154
11131	11677	42	applied	\N	\N	\N	\N	99357	99357	267155
11131	11678	43	applied	\N	\N	\N	\N	99358	99358	267156
11131	11681	44	applied	\N	\N	\N	\N	99359	99359	267157
11131	11684	45	applied	\N	\N	\N	\N	99360	99360	267158
11131	11686	46	applied	\N	\N	\N	\N	99361	99361	267159
11131	11687	47	applied	\N	\N	\N	\N	99362	99362	267160
11131	11690	48	applied	\N	\N	\N	\N	99363	99363	267161
11131	11691	49	applied	\N	\N	\N	\N	99364	99364	267162
11131	11695	50	applied	\N	\N	\N	\N	99365	99365	267163
11131	11696	51	applied	\N	\N	\N	\N	99366	99366	267164
11104	11708	44	applied	\N	\N	\N	\N	99127	99127	266925
11104	11711	45	applied	\N	\N	\N	\N	99128	99128	266926
11125	11725	8	applied	\N	\N	\N	\N	99231	99231	267029
11125	11726	9	applied	\N	\N	\N	\N	99232	99232	267030
11125	11727	10	applied	\N	\N	\N	\N	99233	99233	267031
11125	11699	11	applied	\N	\N	\N	\N	99234	99234	267032
11125	11688	12	applied	\N	\N	\N	\N	99235	99235	267033
11125	11689	13	applied	\N	\N	\N	\N	99236	99236	267034
11125	11692	14	applied	\N	\N	\N	\N	99237	99237	267035
11125	11694	15	applied	\N	\N	\N	\N	99238	99238	267036
11125	11697	16	applied	\N	\N	\N	\N	99239	99239	267037
11125	11698	17	applied	\N	\N	\N	\N	99240	99240	267038
11125	11684	18	applied	\N	\N	\N	\N	99241	99241	267039
11125	11686	19	applied	\N	\N	\N	\N	99242	99242	267040
11125	11687	20	applied	\N	\N	\N	\N	99243	99243	267041
11125	11691	22	applied	\N	\N	\N	\N	99245	99245	267043
11125	11695	23	applied	\N	\N	\N	\N	99246	99246	267044
11125	11696	24	applied	\N	\N	\N	\N	99247	99247	267045
11125	11700	25	applied	\N	\N	\N	\N	99248	99248	267046
11125	11705	26	applied	\N	\N	\N	\N	99249	99249	267047
11125	11718	27	applied	\N	\N	\N	\N	99250	99250	267048
11125	11703	28	applied	\N	\N	\N	\N	99251	99251	267049
11125	11706	29	applied	\N	\N	\N	\N	99252	99252	267050
11125	11707	30	applied	\N	\N	\N	\N	99253	99253	267051
11125	11708	31	applied	\N	\N	\N	\N	99254	99254	267052
11125	11711	32	applied	\N	\N	\N	\N	99255	99255	267053
11125	11713	33	applied	\N	\N	\N	\N	99256	99256	267054
11125	11715	34	applied	\N	\N	\N	\N	99257	99257	267055
11125	11716	35	applied	\N	\N	\N	\N	99258	99258	267056
11125	11719	36	applied	\N	\N	\N	\N	99259	99259	267057
11125	11721	37	applied	\N	\N	\N	\N	99260	99260	267058
11125	11731	39	applied	\N	\N	\N	\N	99262	99262	267060
11125	11734	40	applied	\N	\N	\N	\N	99263	99263	267061
11125	11735	41	applied	\N	\N	\N	\N	99264	99264	267062
11125	11736	42	applied	\N	\N	1000000000	\N	99265	99265	267063
11125	11737	43	applied	\N	\N	\N	\N	99266	99266	267064
11125	11740	44	applied	\N	\N	1000000000	\N	99267	99267	267065
11125	11741	45	applied	\N	\N	\N	\N	99268	99268	267066
11125	11701	46	applied	\N	\N	\N	\N	99269	99269	267067
11125	11702	47	applied	\N	\N	\N	\N	99270	99270	267068
11125	11704	48	applied	\N	\N	\N	\N	99271	99271	267069
11125	11743	49	applied	\N	\N	\N	\N	99272	99272	267070
11125	11745	50	applied	\N	\N	\N	\N	99273	99273	267071
11125	11746	51	applied	\N	\N	\N	\N	99274	99274	267072
11125	11750	52	applied	\N	\N	\N	\N	99275	99275	267073
11125	11751	53	applied	\N	\N	\N	\N	99276	99276	267074
11125	11753	54	applied	\N	\N	\N	\N	99277	99277	267075
11125	11757	56	applied	\N	\N	\N	\N	99279	99279	267077
11125	11709	57	applied	\N	\N	\N	\N	99280	99280	267078
11125	11710	58	applied	\N	\N	\N	\N	99281	99281	267079
11125	11712	59	applied	\N	\N	\N	\N	99282	99282	267080
11125	11714	60	applied	\N	\N	\N	\N	99283	99283	267081
11125	11717	61	applied	\N	\N	\N	\N	99284	99284	267082
11125	11720	62	applied	\N	\N	\N	\N	99285	99285	267083
11125	11722	63	applied	\N	\N	\N	\N	99286	99286	267084
11125	11729	64	applied	\N	\N	\N	\N	99287	99287	267085
11125	11730	65	applied	\N	\N	\N	\N	99288	99288	267086
11125	11732	66	applied	\N	\N	\N	\N	99289	99289	267087
11125	11733	67	applied	\N	\N	\N	\N	99290	99290	267088
11125	11738	68	applied	\N	\N	\N	\N	99291	99291	267089
11125	11739	69	applied	\N	\N	\N	\N	99292	99292	267090
11125	11742	70	applied	\N	\N	\N	\N	99293	99293	267091
11125	11744	71	applied	\N	\N	\N	\N	99294	99294	267092
11125	11748	73	applied	\N	\N	\N	\N	99296	99296	267094
11125	11749	74	applied	\N	\N	\N	\N	99297	99297	267095
11125	11752	75	applied	\N	\N	\N	\N	99298	99298	267096
11125	11755	76	applied	\N	\N	\N	\N	99299	99299	267097
11125	11756	77	applied	\N	\N	\N	\N	99300	99300	267098
11128	11758	0	applied	\N	\N	\N	\N	99305	99305	267103
11128	11759	1	applied	\N	\N	\N	\N	99306	99306	267104
11131	11701	52	applied	\N	\N	\N	\N	99367	99367	267165
11131	11702	53	applied	\N	\N	\N	\N	99368	99368	267166
11131	11704	54	applied	\N	\N	\N	\N	99369	99369	267167
11131	11637	55	applied	\N	\N	\N	\N	99370	99370	267168
11131	11638	56	applied	\N	\N	\N	\N	99371	99371	267169
11131	11639	57	applied	\N	\N	\N	\N	99372	99372	267170
11131	11641	58	applied	\N	\N	\N	\N	99373	99373	267171
11131	11642	59	applied	\N	\N	\N	\N	99374	99374	267172
11131	11645	60	applied	\N	\N	\N	\N	99375	99375	267173
11131	11649	62	applied	\N	\N	\N	\N	99377	99377	267175
11131	11651	63	applied	\N	\N	\N	\N	99378	99378	267176
11131	11653	64	applied	\N	\N	\N	\N	99379	99379	267177
11131	11654	66	applied	\N	\N	\N	\N	99380	99380	267178
11131	11657	67	applied	\N	\N	\N	\N	99381	99381	267179
11131	11658	68	applied	\N	\N	\N	\N	99382	99382	267180
11131	11659	69	applied	\N	\N	\N	\N	99383	99383	267181
11132	11764	0	applied	\N	\N	\N	\N	99440	99440	267238
11132	11765	1	applied	\N	\N	\N	\N	99441	99441	267239
11137	11768	0	applied	\N	\N	\N	\N	99450	99450	267248
11137	11769	1	applied	\N	\N	\N	\N	99451	99451	267249
11137	11770	2	applied	\N	\N	\N	\N	99452	99452	267250
11137	11771	3	applied	\N	\N	\N	\N	99453	99453	267251
11137	11772	4	applied	\N	\N	\N	\N	99454	99454	267252
11137	11773	5	applied	\N	\N	\N	\N	99455	99455	267253
11139	11774	0	applied	\N	\N	\N	\N	99462	99462	267260
11142	11776	0	applied	\N	\N	\N	\N	99468	99468	267266
11142	11777	1	applied	\N	\N	\N	\N	99469	99469	267267
11145	11781	0	applied	\N	\N	\N	\N	99477	99477	267275
11145	11782	1	applied	\N	\N	\N	\N	99478	99478	267276
11145	11783	2	applied	\N	\N	\N	\N	99479	99479	267277
11145	11784	3	applied	\N	\N	\N	\N	99480	99480	267278
11151	11787	0	applied	\N	\N	\N	\N	99493	99493	267291
11151	11788	1	applied	\N	\N	\N	\N	99494	99494	267292
11151	11789	2	applied	\N	\N	\N	\N	99495	99495	267293
11151	11790	3	applied	\N	\N	\N	\N	99496	99496	267294
11154	11795	0	applied	\N	\N	\N	\N	99501	99501	267299
11154	11796	1	applied	\N	\N	\N	\N	99502	99502	267300
11173	11812	0	applied	\N	\N	\N	\N	99534	99534	267332
11173	11813	1	applied	\N	\N	\N	\N	99535	99535	267333
11173	11814	2	applied	\N	\N	\N	\N	99536	99536	267334
11173	11815	3	applied	\N	\N	\N	\N	99537	99537	267335
11125	11685	6	applied	\N	\N	\N	\N	99229	99229	267027
11125	11724	7	applied	\N	\N	\N	\N	99230	99230	267028
11131	11669	74	applied	\N	\N	\N	\N	99388	99388	267186
11131	11670	75	applied	\N	\N	\N	\N	99389	99389	267187
11131	11675	76	applied	\N	\N	\N	\N	99390	99390	267188
11131	11676	77	applied	\N	\N	\N	\N	99391	99391	267189
11131	11679	78	applied	\N	\N	\N	\N	99392	99392	267190
11131	11680	79	applied	\N	\N	\N	\N	99393	99393	267191
11131	11683	80	applied	\N	\N	\N	\N	99394	99394	267192
11131	11685	81	applied	\N	\N	\N	\N	99395	99395	267193
11131	11688	82	applied	\N	\N	\N	\N	99396	99396	267194
11131	11689	83	applied	\N	\N	\N	\N	99397	99397	267195
11131	11692	84	applied	\N	\N	\N	\N	99398	99398	267196
11131	11694	85	applied	\N	\N	\N	\N	99399	99399	267197
11131	11698	87	applied	\N	\N	\N	\N	99401	99401	267199
11131	11703	88	applied	\N	\N	\N	\N	99402	99402	267200
11131	11706	89	applied	\N	\N	\N	\N	99403	99403	267201
11131	11707	90	applied	\N	\N	\N	\N	99404	99404	267202
11131	11708	91	applied	\N	\N	\N	\N	99405	99405	267203
11131	11711	92	applied	\N	\N	\N	\N	99406	99406	267204
11131	11713	93	applied	\N	\N	\N	\N	99407	99407	267205
11131	11715	94	applied	\N	\N	\N	\N	99408	99408	267206
11131	11716	95	applied	\N	\N	\N	\N	99409	99409	267207
11131	11719	96	applied	\N	\N	\N	\N	99410	99410	267208
11131	11721	97	applied	\N	\N	\N	\N	99411	99411	267209
11131	11728	98	applied	\N	\N	\N	\N	99412	99412	267210
11131	11731	99	applied	\N	\N	\N	\N	99413	99413	267211
11131	11734	100	applied	\N	\N	\N	\N	99414	99414	267212
11131	11735	101	applied	\N	\N	\N	\N	99415	99415	267213
11131	11737	103	applied	\N	\N	\N	\N	99417	99417	267215
11131	11740	104	applied	\N	\N	1000000000	\N	99418	99418	267216
11131	11741	105	applied	\N	\N	\N	\N	99419	99419	267217
11131	11743	106	applied	\N	\N	\N	\N	99420	99420	267218
11131	11745	107	applied	\N	\N	\N	\N	99421	99421	267219
11131	11746	108	applied	\N	\N	\N	\N	99422	99422	267220
11131	11750	109	applied	\N	\N	\N	\N	99423	99423	267221
11131	11751	110	applied	\N	\N	\N	\N	99424	99424	267222
11131	11753	111	applied	\N	\N	\N	\N	99425	99425	267223
11131	11754	112	applied	\N	\N	\N	\N	99426	99426	267224
11131	11757	113	applied	\N	\N	\N	\N	99427	99427	267225
11131	11758	114	applied	\N	\N	\N	\N	99428	99428	267226
11131	11761	115	applied	\N	\N	\N	\N	99429	99429	267227
11131	11762	116	applied	\N	\N	\N	\N	99430	99430	267228
11131	11709	117	applied	\N	\N	\N	\N	99431	99431	267229
11131	11710	118	applied	\N	\N	\N	\N	99432	99432	267230
11131	11712	119	applied	\N	\N	\N	\N	99433	99433	267231
11131	11714	120	applied	\N	\N	\N	\N	99434	99434	267232
11131	11717	121	applied	\N	\N	\N	\N	99435	99435	267233
11131	11722	123	applied	\N	\N	\N	\N	99437	99437	267235
11131	11729	124	applied	\N	\N	\N	\N	99438	99438	267236
11131	11730	125	applied	\N	\N	\N	\N	99439	99439	267237
11133	11766	0	applied	\N	\N	\N	\N	99442	99442	267240
11133	11767	1	applied	\N	\N	\N	\N	99443	99443	267241
11136	11766	0	applied	\N	\N	\N	\N	99448	99448	267246
11136	11767	1	applied	\N	\N	\N	\N	99449	99449	267247
11140	11777	1	applied	\N	\N	\N	\N	99465	99465	267263
11141	11776	0	applied	\N	\N	\N	\N	99466	99466	267264
11141	11777	1	applied	\N	\N	\N	\N	99467	99467	267265
11143	11778	0	applied	\N	\N	\N	\N	99470	99470	267268
11143	11779	1	applied	\N	\N	\N	\N	99471	99471	267269
11143	11780	2	applied	\N	\N	\N	\N	99472	99472	267270
11146	11781	0	applied	\N	\N	\N	\N	99481	99481	267279
11146	11782	1	applied	\N	\N	\N	\N	99482	99482	267280
11146	11783	2	applied	\N	\N	\N	\N	99483	99483	267281
11149	11785	0	applied	\N	\N	\N	\N	99491	99491	267289
11149	11786	1	applied	\N	\N	\N	\N	99492	99492	267290
11152	11791	0	applied	\N	\N	\N	\N	99497	99497	267295
11152	11792	1	applied	\N	\N	\N	\N	99498	99498	267296
11155	11795	0	applied	\N	\N	\N	\N	99503	99503	267301
11155	11796	1	applied	\N	\N	\N	\N	99504	99504	267302
11164	11808	0	applied	\N	\N	\N	\N	99516	99516	267314
11164	11809	1	applied	\N	\N	\N	\N	99517	99517	267315
11165	11810	0	applied	\N	\N	\N	\N	99518	99518	267316
11165	11811	1	applied	\N	\N	\N	\N	99519	99519	267317
11171	11812	0	applied	\N	\N	\N	\N	99526	99526	267324
11171	11813	1	applied	\N	\N	\N	\N	99527	99527	267325
11171	11814	2	applied	\N	\N	\N	\N	99528	99528	267326
11171	11815	3	applied	\N	\N	\N	\N	99529	99529	267327
11172	11812	0	applied	\N	\N	\N	\N	99530	99530	267328
11172	11813	1	applied	\N	\N	\N	\N	99531	99531	267329
11172	11815	3	applied	\N	\N	\N	\N	99533	99533	267331
11174	11812	0	applied	\N	\N	\N	\N	99538	99538	267336
11174	11813	1	applied	\N	\N	\N	\N	99539	99539	267337
11174	11814	2	applied	\N	\N	\N	\N	99540	99540	267338
11174	11815	3	applied	\N	\N	\N	\N	99541	99541	267339
11175	11812	0	applied	\N	\N	\N	\N	99542	99542	267340
11175	11813	1	applied	\N	\N	\N	\N	99543	99543	267341
11175	11814	2	applied	\N	\N	\N	\N	99544	99544	267342
11175	11815	3	applied	\N	\N	\N	\N	99545	99545	267343
11177	11537	0	applied	\N	\N	\N	\N	99550	99550	267348
11177	11550	1	applied	\N	\N	\N	\N	99551	99551	267349
11177	11551	2	applied	\N	\N	\N	\N	99552	99552	267350
11177	11568	3	applied	\N	\N	\N	\N	99553	99553	267351
11177	11468	4	applied	\N	\N	\N	\N	99554	99554	267352
11177	11479	5	applied	\N	\N	\N	\N	99555	99555	267353
11177	11480	6	applied	\N	\N	\N	\N	99556	99556	267354
11177	11547	8	applied	\N	\N	\N	\N	99558	99558	267356
11177	11607	9	applied	\N	\N	\N	\N	99559	99559	99559
11177	11614	10	applied	\N	\N	\N	\N	99560	99560	267357
11177	11615	11	applied	\N	\N	\N	\N	99561	99561	267358
11177	11616	12	applied	\N	\N	\N	\N	99562	99562	267359
11177	11617	13	applied	\N	\N	\N	\N	99563	99563	267360
11177	11469	14	applied	\N	\N	\N	\N	99564	99564	267361
11177	11457	15	applied	\N	\N	\N	\N	99565	99565	267362
11177	11458	16	applied	\N	\N	\N	\N	99566	99566	267363
11177	11459	17	applied	\N	\N	\N	\N	99567	99567	267364
11177	11460	18	applied	\N	\N	\N	\N	99568	99568	267365
11177	11682	19	applied	\N	\N	\N	\N	99569	99569	267366
11177	11723	20	applied	\N	\N	\N	\N	99570	99570	267367
11181	11820	0	applied	\N	\N	\N	\N	99687	99687	267484
11181	11821	1	applied	\N	\N	\N	\N	99688	99688	267485
11131	11663	71	applied	\N	\N	\N	\N	99385	99385	267183
11131	11668	73	applied	\N	\N	\N	\N	99387	99387	267185
11177	11441	24	applied	\N	\N	\N	\N	99574	99574	267371
11177	11724	25	applied	\N	\N	\N	\N	99575	99575	267372
11177	11725	26	applied	\N	\N	\N	\N	99576	99576	267373
11177	11502	27	applied	\N	\N	\N	\N	99577	99577	267374
11177	11511	28	applied	\N	\N	\N	\N	99578	99578	267375
11177	11512	29	applied	\N	\N	\N	\N	99579	99579	267376
11177	11726	30	applied	\N	\N	\N	\N	99580	99580	267377
11177	11727	31	applied	\N	\N	\N	\N	99581	99581	267378
11177	11442	32	applied	\N	\N	\N	\N	99582	99582	267379
11177	11447	33	applied	\N	\N	\N	\N	99583	99583	267380
11177	11699	34	applied	\N	\N	\N	\N	99584	99584	267381
11177	11632	36	applied	\N	\N	1000000000	\N	99586	99586	267383
11177	11493	37	applied	\N	\N	\N	\N	99587	99587	267384
11181	11822	2	applied	\N	\N	\N	\N	99689	99689	267486
11181	11823	3	applied	\N	\N	\N	\N	99690	99690	267487
11185	11824	0	applied	\N	\N	\N	\N	99699	99699	267496
11185	11825	1	applied	\N	\N	\N	\N	99700	99700	267497
11188	11824	0	applied	\N	\N	\N	\N	99705	99705	267502
11188	11825	1	applied	\N	\N	\N	\N	99706	99706	267503
11190	11826	0	applied	\N	\N	\N	\N	99710	99710	267507
11190	11827	1	applied	\N	\N	\N	\N	99711	99711	267508
11190	11828	2	applied	\N	\N	\N	\N	99712	99712	267509
11200	11841	0	applied	\N	\N	\N	\N	99733	99733	267530
11200	11842	1	applied	\N	\N	\N	\N	99734	99734	267531
11202	11845	0	applied	\N	\N	\N	\N	99737	99737	267534
11202	11847	2	applied	\N	\N	\N	\N	99739	99739	267536
11205	11848	0	applied	\N	\N	1000000000	\N	99749	99749	267546
11205	11849	1	applied	\N	\N	\N	\N	99750	99750	267547
11205	11850	2	applied	\N	\N	\N	\N	99751	99751	267548
11205	11851	3	applied	\N	\N	\N	\N	99752	99752	267549
11205	11852	4	applied	\N	\N	\N	\N	99753	99753	267550
11205	11853	5	applied	\N	\N	\N	\N	99754	99754	267551
11209	11858	0	applied	\N	\N	\N	\N	99771	99771	267568
11209	11859	1	applied	\N	\N	\N	\N	99772	99772	267569
11213	11866	0	applied	\N	\N	\N	\N	99782	99782	267579
11213	11867	1	applied	\N	\N	\N	\N	99783	99783	267580
11213	11868	2	applied	\N	\N	\N	\N	99784	99784	267581
11213	11869	3	applied	\N	\N	\N	\N	99785	99785	267582
11213	11870	4	applied	\N	\N	\N	\N	99786	99786	267583
11213	11871	5	applied	\N	\N	\N	\N	99787	99787	267584
11213	11872	6	applied	\N	\N	\N	\N	99788	99788	267585
11213	11873	7	applied	\N	\N	\N	\N	99789	99789	267586
11213	11874	8	applied	\N	\N	\N	\N	99790	99790	267587
11213	11875	9	applied	\N	\N	\N	\N	99791	99791	267588
11221	11889	0	applied	\N	\N	\N	\N	99810	99810	267607
11224	11893	0	applied	\N	\N	\N	\N	99818	99818	267615
11224	11894	1	applied	\N	\N	\N	\N	99819	99819	267616
11224	11895	2	applied	\N	\N	\N	\N	99820	99820	267617
11224	11896	3	applied	\N	\N	\N	\N	99821	99821	267618
11226	11899	0	applied	\N	\N	\N	\N	99824	99824	267621
11226	11900	1	applied	\N	\N	\N	\N	99825	99825	267622
11230	11906	0	applied	\N	\N	\N	\N	99841	99841	267638
11230	11907	1	applied	\N	\N	\N	\N	99842	99842	267639
11230	11908	2	applied	\N	\N	\N	\N	99843	99843	267640
11230	11909	3	applied	\N	\N	\N	\N	99844	99844	267641
11230	11910	4	applied	\N	\N	\N	\N	99845	99845	267642
11235	11911	0	applied	\N	\N	\N	\N	99868	99868	267665
11235	11912	1	applied	\N	\N	\N	\N	99869	99869	267666
11235	11913	2	applied	\N	\N	\N	\N	99870	99870	267667
11235	11914	3	applied	\N	\N	\N	\N	99871	99871	267668
11235	11915	4	applied	\N	\N	\N	\N	99872	99872	267669
11237	11917	0	applied	\N	\N	\N	\N	99876	99876	267673
11237	11918	1	applied	\N	\N	\N	\N	99877	99877	267674
11239	11917	0	applied	\N	\N	\N	\N	99880	99880	267677
11239	11918	1	applied	\N	\N	\N	\N	99881	99881	267678
11245	11934	0	applied	\N	\N	\N	\N	99897	99897	267694
11245	11935	1	applied	\N	\N	\N	\N	99898	99898	267695
11245	11936	2	applied	\N	\N	\N	\N	99899	99899	267696
11245	11937	3	applied	\N	\N	\N	\N	99900	99900	267697
11247	11934	0	applied	\N	\N	\N	\N	99905	99905	267702
11247	11935	1	applied	\N	\N	\N	\N	99906	99906	267703
11247	11936	2	applied	\N	\N	\N	\N	99907	99907	267704
11247	11937	3	applied	\N	\N	\N	\N	99908	99908	267705
11249	11938	0	applied	\N	\N	\N	\N	99914	99914	267711
11249	11939	1	applied	\N	\N	\N	\N	99915	99915	267712
11249	11940	2	applied	\N	\N	\N	\N	99916	99916	267713
11249	11941	3	applied	\N	\N	\N	\N	99917	99917	267714
11252	11958	0	applied	\N	\N	\N	\N	99949	99949	267746
11252	11959	1	applied	\N	\N	\N	\N	99950	99950	267747
11252	11960	2	applied	\N	\N	\N	\N	99951	99951	267748
11252	11961	3	applied	\N	\N	\N	\N	99952	99952	267749
11252	11962	4	applied	\N	\N	\N	\N	99953	99953	267750
11252	11963	5	applied	\N	\N	\N	\N	99954	99954	267751
11252	11964	6	applied	\N	\N	\N	\N	99955	99955	267752
11259	11981	0	applied	\N	\N	\N	\N	99972	99972	267769
11259	11982	1	applied	\N	\N	\N	\N	99973	99973	267770
11259	11983	2	applied	\N	\N	\N	\N	99974	99974	267771
11259	11984	3	applied	\N	\N	\N	\N	99975	99975	267772
11259	11985	4	applied	\N	\N	\N	\N	99976	99976	267773
11259	11986	5	applied	\N	\N	\N	\N	99977	99977	267774
11259	11987	6	applied	\N	\N	\N	\N	99978	99978	267775
11259	11988	7	applied	\N	\N	\N	\N	99979	99979	267776
11259	11989	8	applied	\N	\N	\N	\N	99980	99980	267777
11259	11991	10	applied	\N	\N	\N	\N	99982	99982	267779
11259	11992	11	applied	\N	\N	\N	\N	99983	99983	267780
11259	11993	12	applied	\N	\N	\N	\N	99984	99984	267781
11259	11994	13	applied	\N	\N	\N	\N	99985	99985	267782
11259	11995	14	applied	\N	\N	\N	\N	99986	99986	267783
11259	11996	15	applied	\N	\N	\N	\N	99987	99987	267784
11259	11997	16	applied	\N	\N	\N	\N	99988	99988	267785
11259	11998	17	applied	\N	\N	\N	\N	99989	99989	267786
11259	11999	18	applied	\N	\N	\N	\N	99990	99990	267787
11259	12000	19	applied	\N	\N	\N	\N	99991	99991	267788
11259	12001	20	applied	\N	\N	\N	\N	99992	99992	267789
11259	12002	21	applied	\N	\N	\N	\N	99993	99993	267790
11259	12003	22	applied	\N	\N	\N	\N	99994	99994	267791
11259	12004	23	applied	\N	\N	\N	\N	99995	99995	267792
11265	12012	0	applied	\N	\N	\N	\N	100044	100044	267841
11265	12013	1	applied	\N	\N	\N	\N	100045	100045	267842
11177	11438	22	applied	\N	\N	\N	\N	99572	99572	267369
11177	11440	23	applied	\N	\N	\N	\N	99573	99573	267370
11177	11612	42	applied	\N	\N	\N	\N	99592	99592	267389
11177	11631	43	applied	\N	\N	\N	\N	99593	99593	267390
11177	11453	44	applied	\N	\N	\N	\N	99594	99594	267391
11177	11466	45	applied	\N	\N	\N	\N	99595	99595	267392
11177	11470	46	applied	\N	\N	\N	\N	99596	99596	267393
11177	11497	47	applied	\N	\N	\N	\N	99597	99597	267394
11177	11439	48	applied	\N	\N	\N	\N	99598	99598	267395
11177	11700	49	applied	\N	\N	\N	\N	99599	99599	267396
11177	11705	50	applied	\N	\N	\N	\N	99600	99600	267397
11177	11718	51	applied	\N	\N	\N	\N	99601	99601	267398
11177	11515	52	applied	\N	\N	\N	\N	99602	99602	267399
11177	11444	53	applied	\N	\N	\N	\N	99603	99603	267400
11177	11445	54	applied	\N	\N	\N	\N	99604	99604	267401
11177	11446	55	applied	\N	\N	\N	\N	99605	99605	267402
11177	11451	57	applied	\N	\N	\N	\N	99607	99607	267404
11177	11452	58	applied	\N	\N	\N	\N	99608	99608	267405
11177	11454	59	applied	\N	\N	\N	\N	99609	99609	267406
11177	11455	60	applied	\N	\N	\N	\N	99610	99610	267407
11177	11461	61	applied	\N	\N	\N	\N	99611	99611	267408
11177	11463	62	applied	\N	\N	\N	\N	99612	99612	267409
11177	11465	63	applied	\N	\N	\N	\N	99613	99613	267410
11177	11471	64	applied	\N	\N	\N	\N	99614	99614	267411
11177	11474	65	applied	\N	\N	\N	\N	99615	99615	267412
11177	11475	66	applied	\N	\N	\N	\N	99616	99616	267413
11177	11476	67	applied	\N	\N	\N	\N	99617	99617	267414
11177	11483	68	applied	\N	\N	\N	\N	99618	99618	267415
11177	11486	69	applied	\N	\N	\N	\N	99619	99619	267416
11177	11488	70	applied	\N	\N	\N	\N	99620	99620	267417
11177	11489	71	applied	\N	\N	\N	\N	99621	99621	267418
11177	11491	72	applied	\N	\N	\N	\N	99622	99622	267419
11177	11500	74	applied	\N	\N	\N	\N	99624	99624	267421
11177	11505	75	applied	\N	\N	\N	\N	99625	99625	267422
11177	11506	76	applied	\N	\N	\N	\N	99626	99626	267423
11177	11507	77	applied	\N	\N	\N	\N	99627	99627	267424
11177	11508	78	applied	\N	\N	\N	\N	99628	99628	267425
11177	11510	79	applied	\N	\N	\N	\N	99629	99629	267426
11177	11518	80	applied	\N	\N	\N	\N	99630	99630	267427
11177	11519	81	applied	\N	\N	\N	\N	99631	99631	267428
11177	11521	82	applied	\N	\N	\N	\N	99632	99632	267429
11177	11524	83	applied	\N	\N	\N	\N	99633	99633	267430
11177	11526	84	applied	\N	\N	\N	\N	99634	99634	267431
11177	11528	85	applied	\N	\N	\N	\N	99635	99635	267432
11177	11529	86	applied	\N	\N	\N	\N	99636	99636	267433
11177	11533	87	applied	\N	\N	\N	\N	99637	99637	267434
11177	11534	88	applied	\N	\N	\N	\N	99638	99638	267435
11177	11535	89	applied	\N	\N	\N	\N	99639	99639	267436
11177	11541	91	applied	\N	\N	\N	\N	99641	99641	267438
11177	11542	92	applied	\N	\N	\N	\N	99642	99642	267439
11177	11545	93	applied	\N	\N	\N	\N	99643	99643	267440
11177	11549	94	applied	\N	\N	\N	\N	99644	99644	267441
11177	11552	95	applied	\N	\N	\N	\N	99645	99645	267442
11177	11553	96	applied	\N	\N	\N	\N	99646	99646	267443
11177	11558	97	applied	\N	\N	\N	\N	99647	99647	267444
11177	11559	98	applied	\N	\N	\N	\N	99648	99648	267445
11177	11561	99	applied	\N	\N	\N	\N	99649	99649	267446
11177	11562	100	applied	\N	\N	\N	\N	99650	99650	267447
11177	11565	101	applied	\N	\N	\N	\N	99651	99651	267448
11177	11567	102	applied	\N	\N	\N	\N	99652	99652	267449
11177	11569	103	applied	\N	\N	\N	\N	99653	99653	267450
11177	11572	104	applied	\N	\N	\N	\N	99654	99654	267451
11177	11573	105	applied	\N	\N	\N	\N	99655	99655	267452
11177	11576	106	applied	\N	\N	\N	\N	99656	99656	267453
11177	11582	109	applied	\N	\N	\N	\N	99658	99658	267455
11177	11583	110	applied	\N	\N	\N	\N	99659	99659	267456
11177	11584	111	applied	\N	\N	\N	\N	99660	99660	267457
11177	11588	112	applied	\N	\N	\N	\N	99661	99661	267458
11177	11589	113	applied	\N	\N	\N	\N	99662	99662	267459
11177	11592	114	applied	\N	\N	\N	\N	99663	99663	267460
11177	11593	115	applied	\N	\N	\N	\N	99664	99664	267461
11177	11596	116	applied	\N	\N	\N	\N	99665	99665	267462
11177	11597	117	applied	\N	\N	\N	\N	99666	99666	267463
11177	11598	118	applied	\N	\N	\N	\N	99667	99667	267464
11177	11601	119	applied	\N	\N	\N	\N	99668	99668	267465
11177	11603	120	applied	\N	\N	\N	\N	99669	99669	267466
11177	11605	121	applied	\N	\N	\N	\N	99670	99670	267467
11177	11608	122	applied	\N	\N	\N	\N	99671	99671	267468
11177	11611	123	applied	\N	\N	\N	\N	99672	99672	267469
11177	11613	124	applied	\N	\N	\N	\N	99673	99673	267470
11178	11817	1	applied	\N	\N	\N	\N	99676	99676	267473
11178	11818	2	applied	\N	\N	\N	\N	99677	99677	267474
11178	11819	3	applied	\N	\N	\N	\N	99678	99678	267475
11179	11816	0	applied	\N	\N	\N	\N	99679	99679	267476
11179	11817	1	applied	\N	\N	\N	\N	99680	99680	267477
11179	11818	2	applied	\N	\N	\N	\N	99681	99681	267478
11179	11819	3	applied	\N	\N	\N	\N	99682	99682	267479
11180	11816	0	applied	\N	\N	\N	\N	99683	99683	267480
11180	11817	1	applied	\N	\N	\N	\N	99684	99684	267481
11180	11818	2	applied	\N	\N	\N	\N	99685	99685	267482
11180	11819	3	applied	\N	\N	\N	\N	99686	99686	267483
11182	11820	0	applied	\N	\N	\N	\N	99691	99691	267488
11182	11821	1	applied	\N	\N	\N	\N	99692	99692	267489
11182	11822	2	applied	\N	\N	\N	\N	99693	99693	267490
11182	11823	3	applied	\N	\N	\N	\N	99694	99694	267491
11184	11820	0	applied	\N	\N	\N	\N	99695	99695	267492
11184	11822	2	applied	\N	\N	\N	\N	99697	99697	267494
11184	11823	3	applied	\N	\N	\N	\N	99698	99698	267495
11186	11824	0	applied	\N	\N	\N	\N	99701	99701	267498
11186	11825	1	applied	\N	\N	\N	\N	99702	99702	267499
11187	11824	0	applied	\N	\N	\N	\N	99703	99703	267500
11187	11825	1	applied	\N	\N	\N	\N	99704	99704	267501
11191	11829	0	applied	\N	\N	\N	\N	99713	99713	267510
11191	11830	1	applied	\N	\N	\N	\N	99714	99714	267511
11193	11831	0	applied	\N	\N	\N	\N	99717	99717	267514
11193	11832	1	applied	\N	\N	\N	\N	99718	99718	267515
11195	11831	0	applied	\N	\N	\N	\N	99721	99721	267518
11197	11835	0	applied	\N	\N	\N	\N	99725	99725	267522
11197	11836	1	applied	\N	\N	\N	\N	99726	99726	267523
11203	11845	0	applied	\N	\N	\N	\N	99740	99740	267537
11203	11847	2	applied	\N	\N	\N	\N	99742	99742	267539
11177	11443	40	applied	\N	\N	\N	\N	99590	99590	267387
11177	11450	41	applied	\N	\N	\N	\N	99591	99591	267388
11198	11840	3	applied	\N	\N	\N	\N	99730	99730	267527
11204	11850	2	applied	\N	\N	\N	\N	99745	99745	267542
11204	11851	3	applied	\N	\N	\N	\N	99746	99746	267543
11204	11852	4	applied	\N	\N	\N	\N	99747	99747	267544
11204	11853	5	applied	\N	\N	\N	\N	99748	99748	267545
11207	11848	0	applied	\N	\N	1000000000	\N	99761	99761	267558
11207	11849	1	applied	\N	\N	\N	\N	99762	99762	267559
11207	11850	2	applied	\N	\N	\N	\N	99763	99763	267560
11207	11851	3	applied	\N	\N	\N	\N	99764	99764	267561
11207	11852	4	applied	\N	\N	\N	\N	99765	99765	267562
11207	11853	5	applied	\N	\N	\N	\N	99766	99766	267563
11208	11854	0	applied	\N	\N	\N	\N	99767	99767	267564
11208	11855	1	applied	\N	\N	\N	\N	99768	99768	267565
11208	11856	2	applied	\N	\N	\N	\N	99769	99769	267566
11211	11863	0	applied	\N	\N	\N	\N	99776	99776	267573
11211	11864	1	applied	\N	\N	\N	\N	99777	99777	267574
11211	11865	2	applied	\N	\N	\N	\N	99778	99778	267575
11215	11876	0	applied	\N	\N	\N	\N	99795	99795	267592
11215	11877	1	applied	\N	\N	\N	\N	99796	99796	267593
11215	11878	2	applied	\N	\N	\N	\N	99797	99797	267594
11217	11881	0	applied	\N	\N	\N	\N	99800	99800	267597
11217	11882	1	applied	\N	\N	\N	\N	99801	99801	267598
11217	11883	2	applied	\N	\N	\N	\N	99802	99802	267599
11217	11884	3	applied	\N	\N	\N	\N	99803	99803	267600
11218	11885	0	applied	\N	\N	\N	\N	99804	99804	267601
11218	11886	1	applied	\N	\N	\N	\N	99805	99805	267602
11220	11887	0	applied	\N	\N	\N	\N	99808	99808	267605
11220	11888	1	applied	\N	\N	\N	\N	99809	99809	267606
11222	11891	0	applied	\N	\N	\N	\N	99812	99812	267609
11222	11892	1	applied	\N	\N	\N	\N	99813	99813	267610
11223	11894	1	applied	\N	\N	\N	\N	99815	99815	267612
11223	11895	2	applied	\N	\N	\N	\N	99816	99816	267613
11223	11896	3	applied	\N	\N	\N	\N	99817	99817	267614
11225	11897	0	applied	\N	\N	\N	\N	99822	99822	267619
11225	11898	1	applied	\N	\N	\N	\N	99823	99823	267620
11228	11901	0	applied	\N	\N	\N	\N	99831	99831	267628
11228	11902	1	applied	\N	\N	\N	\N	99832	99832	267629
11228	11903	2	applied	\N	\N	\N	\N	99833	99833	267630
11228	11904	3	applied	\N	\N	\N	\N	99834	99834	267631
11228	11905	4	applied	\N	\N	\N	\N	99835	99835	267632
11229	11906	0	applied	\N	\N	\N	\N	99836	99836	267633
11229	11907	1	applied	\N	\N	\N	\N	99837	99837	267634
11233	11911	0	applied	\N	\N	\N	\N	99856	99856	267653
11233	11912	1	applied	\N	\N	\N	\N	99857	99857	267654
11233	11913	2	applied	\N	\N	\N	\N	99858	99858	267655
11233	11914	3	applied	\N	\N	\N	\N	99859	99859	267656
11233	11916	5	applied	\N	\N	\N	\N	99861	99861	267658
11238	11917	0	applied	\N	\N	\N	\N	99878	99878	267675
11238	11918	1	applied	\N	\N	\N	\N	99879	99879	267676
11240	11919	0	applied	\N	\N	\N	\N	99882	99882	267679
11240	11920	1	applied	\N	\N	\N	\N	99883	99883	267680
11240	11921	2	applied	\N	\N	\N	\N	99884	99884	267681
11243	11928	0	applied	\N	\N	\N	\N	99891	99891	267688
11243	11929	1	applied	\N	\N	\N	\N	99892	99892	267689
11248	11938	0	applied	\N	\N	\N	\N	99909	99909	267706
11248	11939	1	applied	\N	\N	\N	\N	99910	99910	267707
11248	11940	2	applied	\N	\N	\N	\N	99911	99911	267708
11248	11941	3	applied	\N	\N	\N	\N	99912	99912	267709
11248	11942	4	applied	\N	\N	\N	\N	99913	99913	267710
11251	11943	0	applied	\N	\N	\N	\N	99934	99934	267731
11251	11944	1	applied	\N	\N	\N	\N	99935	99935	267732
11251	11945	2	applied	\N	\N	\N	\N	99936	99936	267733
11251	11947	4	applied	\N	\N	\N	\N	99938	99938	267735
11251	11948	5	applied	\N	\N	\N	\N	99939	99939	267736
11251	11949	6	applied	\N	\N	\N	\N	99940	99940	267737
11251	11950	7	applied	\N	\N	\N	\N	99941	99941	267738
11251	11951	8	applied	\N	\N	\N	\N	99942	99942	267739
11251	11952	9	applied	\N	\N	\N	\N	99943	99943	267740
11251	11953	10	applied	\N	\N	\N	\N	99944	99944	267741
11251	11954	11	applied	\N	\N	\N	\N	99945	99945	267742
11251	11955	12	applied	\N	\N	\N	\N	99946	99946	267743
11251	11956	13	applied	\N	\N	\N	\N	99947	99947	267744
11251	11957	14	applied	\N	\N	\N	\N	99948	99948	267745
11253	11965	0	applied	\N	\N	\N	\N	99956	99956	267753
11253	11966	1	applied	\N	\N	\N	\N	99957	99957	267754
11253	11967	2	applied	\N	\N	\N	\N	99958	99958	267755
11253	11968	3	applied	\N	\N	\N	\N	99959	99959	267756
11253	11969	4	applied	\N	\N	\N	\N	99960	99960	267757
11253	11971	6	applied	\N	\N	\N	\N	99962	99962	267759
11253	11972	7	applied	\N	\N	\N	\N	99963	99963	267760
11260	11981	0	applied	\N	\N	\N	\N	99996	99996	267793
11260	11982	1	applied	\N	\N	\N	\N	99997	99997	267794
11260	11983	2	applied	\N	\N	\N	\N	99998	99998	267795
11260	11984	3	applied	\N	\N	\N	\N	99999	99999	267796
11260	11985	4	applied	\N	\N	\N	\N	100000	100000	267797
11260	11986	5	applied	\N	\N	\N	\N	100001	100001	267798
11260	11987	6	applied	\N	\N	\N	\N	100002	100002	267799
11260	11988	7	applied	\N	\N	\N	\N	100003	100003	267800
11260	11989	8	applied	\N	\N	\N	\N	100004	100004	267801
11260	11990	9	applied	\N	\N	\N	\N	100005	100005	267802
11260	11991	10	applied	\N	\N	\N	\N	100006	100006	267803
11260	11992	11	applied	\N	\N	\N	\N	100007	100007	267804
11260	11993	12	applied	\N	\N	\N	\N	100008	100008	267805
11260	11994	13	applied	\N	\N	\N	\N	100009	100009	267806
11260	11996	15	applied	\N	\N	\N	\N	100011	100011	267808
11260	11997	16	applied	\N	\N	\N	\N	100012	100012	267809
11260	11998	17	applied	\N	\N	\N	\N	100013	100013	267810
11260	11999	18	applied	\N	\N	\N	\N	100014	100014	267811
11260	12000	19	applied	\N	\N	\N	\N	100015	100015	267812
11260	12001	20	applied	\N	\N	\N	\N	100016	100016	267813
11260	12002	21	applied	\N	\N	\N	\N	100017	100017	267814
11260	12003	22	applied	\N	\N	\N	\N	100018	100018	267815
11260	12004	23	applied	\N	\N	\N	\N	100019	100019	267816
11269	12066	0	applied	\N	\N	\N	\N	100098	100098	267895
11269	12067	1	applied	\N	\N	\N	\N	100099	100099	267896
11269	12068	2	applied	\N	\N	\N	\N	100100	100100	267897
11269	12069	3	applied	\N	\N	\N	\N	100101	100101	267898
11269	12070	4	applied	\N	\N	\N	\N	100102	100102	267899
11269	12071	5	applied	\N	\N	\N	\N	100103	100103	267900
11269	12072	6	applied	\N	\N	\N	\N	100104	100104	267901
11198	11839	2	applied	\N	\N	\N	\N	99729	99729	267526
11206	11852	4	applied	\N	\N	\N	\N	99759	99759	267556
11206	11853	5	applied	\N	\N	\N	\N	99760	99760	267557
11210	11860	0	applied	\N	\N	\N	\N	99773	99773	267570
11210	11861	1	applied	\N	\N	\N	\N	99774	99774	267571
11210	11862	2	applied	\N	\N	\N	\N	99775	99775	267572
11212	11863	0	applied	\N	\N	\N	\N	99779	99779	267576
11212	11864	1	applied	\N	\N	\N	\N	99780	99780	267577
11212	11865	2	applied	\N	\N	\N	\N	99781	99781	267578
11214	11876	0	applied	\N	\N	\N	\N	99792	99792	267589
11214	11877	1	applied	\N	\N	\N	\N	99793	99793	267590
11214	11878	2	applied	\N	\N	\N	\N	99794	99794	267591
11216	11879	0	applied	\N	\N	\N	\N	99798	99798	267595
11216	11880	1	applied	\N	\N	\N	\N	99799	99799	267596
11219	11887	0	applied	\N	\N	\N	\N	99806	99806	267603
11229	11908	2	applied	\N	\N	\N	\N	99838	99838	267635
11229	11909	3	applied	\N	\N	\N	\N	99839	99839	267636
11231	11906	0	applied	\N	\N	\N	\N	99846	99846	267643
11231	11907	1	applied	\N	\N	\N	\N	99847	99847	267644
11231	11908	2	applied	\N	\N	\N	\N	99848	99848	267645
11231	11909	3	applied	\N	\N	\N	\N	99849	99849	267646
11231	11910	4	applied	\N	\N	\N	\N	99850	99850	267647
11234	11911	0	applied	\N	\N	\N	\N	99862	99862	267659
11234	11912	1	applied	\N	\N	\N	\N	99863	99863	267660
11234	11913	2	applied	\N	\N	\N	\N	99864	99864	267661
11234	11914	3	applied	\N	\N	\N	\N	99865	99865	267662
11234	11915	4	applied	\N	\N	\N	\N	99866	99866	267663
11234	11916	5	applied	\N	\N	\N	\N	99867	99867	267664
11236	11917	0	applied	\N	\N	\N	\N	99874	99874	267671
11236	11918	1	applied	\N	\N	\N	\N	99875	99875	267672
11241	11922	0	applied	\N	\N	\N	\N	99885	99885	267682
11241	11923	1	applied	\N	\N	\N	\N	99886	99886	267683
11241	11924	2	applied	\N	\N	\N	\N	99887	99887	267684
11241	11926	4	applied	\N	\N	\N	\N	99889	99889	267686
11241	11927	5	applied	\N	\N	\N	\N	99890	99890	267687
11244	11930	0	applied	\N	\N	\N	\N	99893	99893	267690
11244	11931	1	applied	\N	\N	\N	\N	99894	99894	267691
11244	11932	2	applied	\N	\N	\N	\N	99895	99895	267692
11244	11933	3	applied	\N	\N	\N	\N	99896	99896	267693
11254	11973	0	applied	\N	\N	\N	\N	99964	99964	267761
11254	11974	1	applied	\N	\N	\N	\N	99965	99965	267762
11254	11975	2	applied	\N	\N	\N	\N	99966	99966	267763
11254	11976	3	applied	\N	\N	\N	\N	99967	99967	267764
11254	11977	4	applied	\N	\N	\N	\N	99968	99968	267765
11254	11978	5	applied	\N	\N	\N	\N	99969	99969	267766
11254	11979	6	applied	\N	\N	\N	\N	99970	99970	267767
11254	11980	7	applied	\N	\N	\N	\N	99971	99971	267768
11261	12005	0	applied	\N	\N	\N	\N	100020	100020	267817
11261	12006	1	applied	\N	\N	\N	\N	100021	100021	267818
11261	12008	3	applied	\N	\N	\N	\N	100023	100023	267820
11261	12009	4	applied	\N	\N	\N	\N	100024	100024	267821
11261	12010	5	applied	\N	\N	\N	\N	100025	100025	267822
11261	12011	6	applied	\N	\N	\N	\N	100026	100026	267823
11263	12012	0	applied	\N	\N	\N	\N	100034	100034	267831
11263	12013	1	applied	\N	\N	\N	\N	100035	100035	267832
11263	12014	2	applied	\N	\N	\N	\N	100036	100036	267833
11263	12015	3	applied	\N	\N	\N	\N	100037	100037	267834
11263	12016	4	applied	\N	\N	\N	\N	100038	100038	267835
11263	12017	5	applied	\N	\N	\N	\N	100039	100039	267836
11263	12018	6	applied	\N	\N	\N	\N	100040	100040	267837
11263	12019	7	applied	\N	\N	\N	\N	100041	100041	267838
11263	12020	8	applied	\N	\N	\N	\N	100042	100042	267839
11263	12021	9	applied	\N	\N	\N	\N	100043	100043	267840
11274	12074	0	applied	\N	\N	\N	\N	100121	100121	267918
11274	12075	1	applied	\N	\N	\N	\N	100122	100122	267919
11281	12088	2	applied	\N	\N	\N	\N	100224	100224	268021
11281	12089	3	applied	\N	\N	\N	\N	100225	100225	268022
11281	12090	4	applied	\N	\N	\N	\N	100226	100226	268023
11285	12091	0	applied	\N	\N	\N	\N	100235	100235	268032
11285	12092	1	applied	\N	\N	\N	\N	100236	100236	268033
11287	12095	0	applied	\N	\N	\N	\N	100239	100239	268036
11287	12096	1	applied	\N	\N	\N	\N	100240	100240	268037
11292	12099	0	applied	\N	\N	\N	\N	100249	100249	268046
11292	12100	1	applied	\N	\N	\N	\N	100250	100250	268047
11295	12109	0	applied	\N	\N	\N	\N	100259	100259	268056
11295	12110	1	applied	\N	\N	\N	\N	100260	100260	268057
11298	12109	0	applied	\N	\N	\N	\N	100265	100265	268062
11298	12110	1	applied	\N	\N	\N	\N	100266	100266	268063
11300	12111	0	applied	\N	\N	\N	\N	100267	100267	268064
11307	12117	0	applied	\N	\N	\N	\N	100277	100277	268074
11307	12116	1	applied	\N	\N	\N	\N	100278	100278	268075
11309	12120	1	applied	\N	\N	\N	\N	100281	100281	268078
11309	12121	2	applied	\N	\N	\N	\N	100282	100282	268079
11311	12122	0	applied	\N	\N	\N	\N	100286	100286	268083
11311	12123	1	applied	\N	\N	\N	\N	100287	100287	268084
11324	12131	0	applied	\N	\N	\N	\N	100307	100307	268104
11324	12132	1	applied	\N	\N	\N	\N	100308	100308	268105
11326	12133	0	applied	\N	\N	\N	\N	100311	100311	268108
11326	12134	1	applied	\N	\N	\N	\N	100312	100312	268109
11334	12150	0	applied	\N	\N	\N	\N	100332	100332	268128
11334	12151	1	applied	\N	\N	\N	\N	100333	100333	268129
11344	12162	0	applied	\N	\N	\N	\N	100362	100362	268158
11344	12163	1	applied	\N	\N	\N	\N	100363	100363	268159
11344	12164	2	applied	\N	\N	\N	\N	100364	100364	268160
11344	12165	3	applied	\N	\N	\N	\N	100365	100365	268161
11344	12166	4	applied	\N	\N	\N	\N	100366	100366	268162
11344	12167	5	applied	\N	\N	\N	\N	100367	100367	268163
11347	12171	1	applied	\N	\N	\N	\N	100377	100377	268173
11347	12172	2	applied	\N	\N	\N	\N	100378	100378	268174
11347	12173	3	applied	\N	\N	\N	\N	100379	100379	268175
11349	12174	0	applied	\N	\N	\N	\N	100384	100384	268180
11349	12175	1	applied	\N	\N	\N	\N	100385	100385	268181
11356	12179	0	applied	\N	\N	\N	\N	100396	100396	268192
11356	12180	1	applied	\N	\N	\N	\N	100397	100397	268193
11358	12181	0	applied	\N	\N	\N	\N	100399	100399	268195
11367	12200	0	applied	\N	\N	\N	\N	100435	100435	268231
11367	12201	1	applied	\N	\N	\N	\N	100436	100436	268232
11372	12210	0	applied	\N	\N	\N	\N	100453	100453	268249
11372	12211	1	applied	\N	\N	\N	\N	100454	100454	268250
11375	12218	0	applied	\N	\N	\N	\N	100461	100461	268257
11375	12219	1	applied	\N	\N	\N	\N	100462	100462	268258
11206	11849	1	applied	\N	\N	\N	\N	99756	99756	267553
11206	11850	2	applied	\N	\N	\N	\N	99757	99757	267554
11227	11904	3	applied	\N	\N	\N	\N	99829	99829	267626
11227	11905	4	applied	\N	\N	\N	\N	99830	99830	267627
11232	11906	0	applied	\N	\N	\N	\N	99851	99851	267648
11232	11907	1	applied	\N	\N	\N	\N	99852	99852	267649
11232	11908	2	applied	\N	\N	\N	\N	99853	99853	267650
11232	11909	3	applied	\N	\N	\N	\N	99854	99854	267651
11232	11910	4	applied	\N	\N	\N	\N	99855	99855	267652
11246	11934	0	applied	\N	\N	\N	\N	99901	99901	267698
11246	11935	1	applied	\N	\N	\N	\N	99902	99902	267699
11246	11936	2	applied	\N	\N	\N	\N	99903	99903	267700
11246	11937	3	applied	\N	\N	\N	\N	99904	99904	267701
11250	11943	0	applied	\N	\N	\N	\N	99919	99919	267716
11250	11944	1	applied	\N	\N	\N	\N	99920	99920	267717
11250	11945	2	applied	\N	\N	\N	\N	99921	99921	267718
11250	11946	3	applied	\N	\N	\N	\N	99922	99922	267719
11250	11947	4	applied	\N	\N	\N	\N	99923	99923	267720
11250	11949	6	applied	\N	\N	\N	\N	99925	99925	267722
11250	11950	7	applied	\N	\N	\N	\N	99926	99926	267723
11250	11951	8	applied	\N	\N	\N	\N	99927	99927	267724
11250	11952	9	applied	\N	\N	\N	\N	99928	99928	267725
11250	11953	10	applied	\N	\N	\N	\N	99929	99929	267726
11250	11954	11	applied	\N	\N	\N	\N	99930	99930	267727
11250	11955	12	applied	\N	\N	\N	\N	99931	99931	267728
11250	11956	13	applied	\N	\N	\N	\N	99932	99932	267729
11250	11957	14	applied	\N	\N	\N	\N	99933	99933	267730
11262	12005	0	applied	\N	\N	\N	\N	100027	100027	267824
11262	12006	1	applied	\N	\N	\N	\N	100028	100028	267825
11262	12007	2	applied	\N	\N	\N	\N	100029	100029	267826
11262	12008	3	applied	\N	\N	\N	\N	100030	100030	267827
11262	12009	4	applied	\N	\N	\N	\N	100031	100031	267828
11262	12010	5	applied	\N	\N	\N	\N	100032	100032	267829
11262	12011	6	applied	\N	\N	\N	\N	100033	100033	267830
11265	12016	4	applied	\N	\N	\N	\N	100048	100048	267845
11265	12017	5	applied	\N	\N	\N	\N	100049	100049	267846
11265	12018	6	applied	\N	\N	\N	\N	100050	100050	267847
11265	12019	7	applied	\N	\N	\N	\N	100051	100051	267848
11265	12022	8	applied	\N	\N	\N	\N	100052	100052	267849
11265	12020	9	applied	\N	\N	\N	\N	100053	100053	267850
11265	12021	10	applied	\N	\N	\N	\N	100054	100054	267851
11266	12023	0	applied	\N	\N	\N	\N	100055	100055	267852
11266	12024	1	applied	\N	\N	\N	\N	100056	100056	267853
11266	12025	2	applied	\N	\N	\N	\N	100057	100057	267854
11266	12026	3	applied	\N	\N	\N	\N	100058	100058	267855
11266	12027	4	applied	\N	\N	\N	\N	100059	100059	267856
11266	12028	5	applied	\N	\N	\N	\N	100060	100060	267857
11266	12029	6	applied	\N	\N	\N	\N	100061	100061	267858
11266	12030	7	applied	\N	\N	\N	\N	100062	100062	267859
11266	12031	8	applied	\N	\N	\N	\N	100063	100063	267860
11266	12033	10	applied	\N	\N	\N	\N	100065	100065	267862
11266	12034	11	applied	\N	\N	\N	\N	100066	100066	267863
11266	12035	12	applied	\N	\N	\N	\N	100067	100067	267864
11266	12036	13	applied	\N	\N	\N	\N	100068	100068	267865
11266	12037	14	applied	\N	\N	\N	\N	100069	100069	267866
11266	12038	15	applied	\N	\N	\N	\N	100070	100070	267867
11266	12039	16	applied	\N	\N	\N	\N	100071	100071	267868
11266	12040	17	applied	\N	\N	\N	\N	100072	100072	267869
11266	12041	18	applied	\N	\N	\N	\N	100073	100073	267870
11266	12042	19	applied	\N	\N	\N	\N	100074	100074	267871
11266	12043	20	applied	\N	\N	\N	\N	100075	100075	267872
11266	12044	21	applied	\N	\N	\N	\N	100076	100076	267873
11266	12045	22	applied	\N	\N	\N	\N	100077	100077	267874
11266	12046	23	applied	\N	\N	\N	\N	100078	100078	267875
11266	12047	24	applied	\N	\N	\N	\N	100079	100079	267876
11266	12048	25	applied	\N	\N	\N	\N	100080	100080	267877
11266	12050	27	applied	\N	\N	\N	\N	100082	100082	267879
11266	12051	28	applied	\N	\N	\N	\N	100083	100083	267880
11266	12052	29	applied	\N	\N	\N	\N	100084	100084	267881
11266	12053	30	applied	\N	\N	\N	\N	100085	100085	267882
11266	12054	31	applied	\N	\N	\N	\N	100086	100086	267883
11266	12055	32	applied	\N	\N	\N	\N	100087	100087	267884
11266	12056	33	applied	\N	\N	\N	\N	100088	100088	267885
11266	12057	34	applied	\N	\N	\N	\N	100089	100089	267886
11266	12058	35	applied	\N	\N	\N	\N	100090	100090	267887
11267	12059	0	applied	\N	\N	\N	\N	100091	100091	267888
11267	12060	1	applied	\N	\N	\N	\N	100092	100092	267889
11267	12061	2	applied	\N	\N	\N	\N	100093	100093	267890
11267	12062	3	applied	\N	\N	\N	\N	100094	100094	267891
11267	12063	4	applied	\N	\N	\N	\N	100095	100095	267892
11267	12064	5	applied	\N	\N	\N	\N	100096	100096	267893
11267	12065	6	applied	\N	\N	\N	\N	100097	100097	267894
11270	12067	1	applied	\N	\N	\N	\N	100107	100107	267904
11270	12068	2	applied	\N	\N	\N	\N	100108	100108	267905
11271	12066	0	applied	\N	\N	\N	\N	100114	100114	267911
11271	12072	1	applied	\N	\N	\N	\N	100115	100115	267912
11271	12073	2	applied	\N	\N	\N	\N	100116	100116	267913
11275	12076	0	applied	\N	\N	\N	\N	100123	100123	267920
11284	12091	0	applied	\N	\N	\N	\N	100233	100233	268030
11284	12092	1	applied	\N	\N	\N	\N	100234	100234	268031
11286	12093	0	applied	\N	\N	\N	\N	100237	100237	268034
11286	12094	1	applied	\N	\N	\N	\N	100238	100238	268035
11293	12101	0	applied	\N	\N	\N	\N	100251	100251	268048
11293	12102	1	applied	\N	\N	\N	\N	100252	100252	268049
11293	12103	2	applied	\N	\N	\N	\N	100253	100253	268050
11293	12104	3	applied	\N	\N	\N	\N	100254	100254	268051
11297	12109	0	applied	\N	\N	\N	\N	100263	100263	268060
11297	12110	1	applied	\N	\N	\N	\N	100264	100264	268061
11303	12113	1	applied	\N	\N	\N	\N	100271	100271	268068
11305	12114	0	applied	\N	\N	\N	\N	100274	100274	268071
11305	12115	1	applied	\N	\N	\N	\N	100275	100275	268072
11313	12122	0	applied	\N	\N	\N	\N	100290	100290	268087
11313	12123	1	applied	\N	\N	\N	\N	100291	100291	268088
11315	12124	0	applied	\N	\N	\N	\N	100294	100294	268091
11315	12125	1	applied	\N	\N	\N	\N	100295	100295	268092
11318	12126	0	applied	\N	\N	\N	\N	100297	100297	268094
11318	12127	1	applied	\N	\N	\N	\N	100298	100298	268095
11321	12128	0	applied	\N	\N	\N	\N	100303	100303	268100
11321	12129	1	applied	\N	\N	\N	\N	100304	100304	268101
11327	12134	0	applied	\N	\N	\N	\N	100313	100313	268110
11330	12139	0	applied	\N	\N	\N	\N	100319	100319	268116
11330	12140	1	applied	\N	\N	\N	\N	100320	100320	268117
11227	11901	0	applied	\N	\N	\N	\N	99826	99826	267623
11227	11902	1	applied	\N	\N	\N	\N	99827	99827	267624
11270	12071	5	applied	\N	\N	\N	\N	100111	100111	267908
11270	12072	6	applied	\N	\N	\N	\N	100112	100112	267909
11270	12073	7	applied	\N	\N	\N	\N	100113	100113	267910
11272	12074	0	applied	\N	\N	\N	\N	100117	100117	267914
11272	12075	1	applied	\N	\N	\N	\N	100118	100118	267915
11273	12074	0	applied	\N	\N	\N	\N	100119	100119	267916
11273	12075	1	applied	\N	\N	\N	\N	100120	100120	267917
11276	12077	0	applied	\N	\N	\N	\N	100124	100124	267921
11276	12078	1	applied	\N	\N	\N	\N	100125	100125	267922
11276	12079	2	applied	\N	\N	\N	\N	100126	100126	267923
11276	12080	3	applied	\N	\N	\N	\N	100127	100127	267924
11276	12082	5	applied	\N	\N	\N	\N	100129	100129	267926
11276	12083	6	applied	\N	\N	\N	\N	100130	100130	267927
11276	12084	7	applied	\N	\N	\N	\N	100131	100131	267928
11277	12085	0	applied	\N	\N	\N	\N	100132	100132	267929
11277	12086	1	applied	\N	\N	\N	\N	100133	100133	267930
11278	12085	0	applied	\N	\N	\N	\N	100134	100134	267931
11278	12086	1	applied	\N	\N	\N	\N	100135	100135	267932
11279	11848	0	applied	\N	\N	1000000000	\N	100136	100136	267933
11279	11723	1	applied	\N	\N	\N	\N	100137	100137	267934
11279	11693	2	applied	\N	\N	\N	\N	100138	100138	267935
11279	11938	3	applied	\N	\N	\N	\N	100139	100139	267936
11279	11683	4	applied	\N	\N	\N	\N	100140	100140	267937
11279	11685	5	applied	\N	\N	\N	\N	100141	100141	267938
11279	11939	6	applied	\N	\N	\N	\N	100142	100142	267939
11279	11690	7	applied	\N	\N	\N	\N	100143	100143	267940
11279	11691	8	applied	\N	\N	\N	\N	100144	100144	267941
11279	11696	10	applied	\N	\N	\N	\N	100146	100146	267943
11279	11724	11	applied	\N	\N	\N	\N	100147	100147	267944
11279	11725	12	applied	\N	\N	\N	\N	100148	100148	267945
11279	12078	13	applied	\N	\N	\N	\N	100149	100149	267946
11279	11726	14	applied	\N	\N	\N	\N	100150	100150	267947
11279	11727	15	applied	\N	\N	\N	\N	100151	100151	267948
11279	11699	16	applied	\N	\N	\N	\N	100152	100152	267949
11279	12080	17	applied	\N	\N	\N	\N	100153	100153	267950
11279	11688	18	applied	\N	\N	\N	\N	100154	100154	267951
11279	11689	19	applied	\N	\N	\N	\N	100155	100155	267952
11279	11692	20	applied	\N	\N	\N	\N	100156	100156	267953
11279	11694	21	applied	\N	\N	\N	\N	100157	100157	267954
11279	11697	22	applied	\N	\N	\N	\N	100158	100158	267955
11279	11698	23	applied	\N	\N	\N	\N	100159	100159	267956
11279	11941	24	applied	\N	\N	\N	\N	100160	100160	267957
11279	11943	25	applied	\N	\N	\N	\N	100161	100161	267958
11279	12081	27	applied	\N	\N	\N	\N	100163	100163	267960
11279	12082	28	applied	\N	\N	\N	\N	100164	100164	267961
11279	11700	29	applied	\N	\N	\N	\N	100165	100165	267962
11279	11705	30	applied	\N	\N	\N	\N	100166	100166	267963
11279	11718	31	applied	\N	\N	\N	\N	100167	100167	267964
11279	11703	32	applied	\N	\N	\N	\N	100168	100168	267965
11279	11706	33	applied	\N	\N	\N	\N	100169	100169	267966
11279	11707	34	applied	\N	\N	\N	\N	100170	100170	267967
11279	11708	35	applied	\N	\N	\N	\N	100171	100171	267968
11279	11711	36	applied	\N	\N	\N	\N	100172	100172	267969
11279	11713	37	applied	\N	\N	\N	\N	100173	100173	267970
11279	11715	38	applied	\N	\N	\N	\N	100174	100174	267971
11279	11716	39	applied	\N	\N	\N	\N	100175	100175	267972
11279	11719	40	applied	\N	\N	\N	\N	100176	100176	267973
11279	11721	41	applied	\N	\N	\N	\N	100177	100177	267974
11279	11728	42	applied	\N	\N	\N	\N	100178	100178	267975
11279	11734	44	applied	\N	\N	\N	\N	100180	100180	267977
11279	11735	45	applied	\N	\N	\N	\N	100181	100181	267978
11279	11736	46	applied	\N	\N	1000000000	\N	100182	100182	267979
11279	11737	48	applied	\N	\N	\N	\N	100183	100183	267980
11279	11740	49	applied	\N	\N	1000000000	\N	100184	100184	267981
11279	11741	50	applied	\N	\N	\N	\N	100185	100185	267982
11279	11701	51	applied	\N	\N	\N	\N	100186	100186	267983
11279	11702	52	applied	\N	\N	\N	\N	100187	100187	267984
11279	11704	53	applied	\N	\N	\N	\N	100188	100188	267985
11279	11743	54	applied	\N	\N	\N	\N	100189	100189	267986
11279	11745	55	applied	\N	\N	\N	\N	100190	100190	267987
11279	11746	56	applied	\N	\N	\N	\N	100191	100191	267988
11279	11750	57	applied	\N	\N	\N	\N	100192	100192	267989
11279	11751	58	applied	\N	\N	\N	\N	100193	100193	267990
11279	11753	59	applied	\N	\N	\N	\N	100194	100194	267991
11279	11754	60	applied	\N	\N	\N	\N	100195	100195	267992
11279	11758	62	applied	\N	\N	\N	\N	100197	100197	267994
11279	11761	63	applied	\N	\N	\N	\N	100198	100198	267995
11279	11762	64	applied	\N	\N	\N	\N	100199	100199	267996
11279	11765	65	applied	\N	\N	\N	\N	100200	100200	267997
11279	11767	66	applied	\N	\N	\N	\N	100201	100201	267998
11279	11768	67	applied	\N	\N	\N	\N	100202	100202	267999
11279	11769	68	applied	\N	\N	\N	\N	100203	100203	268000
11279	11773	69	applied	\N	\N	\N	\N	100204	100204	268001
11279	11775	70	applied	\N	\N	\N	\N	100205	100205	268002
11279	11776	71	applied	\N	\N	\N	\N	100206	100206	268003
11279	11780	72	applied	\N	\N	\N	\N	100207	100207	268004
11279	11781	73	applied	\N	\N	\N	\N	100208	100208	268005
11279	11782	74	applied	\N	\N	\N	\N	100209	100209	268006
11279	11785	75	applied	\N	\N	\N	\N	100210	100210	268007
11279	11788	76	applied	\N	\N	\N	\N	100211	100211	268008
11279	11789	77	applied	\N	\N	\N	\N	100212	100212	268009
11279	11794	79	applied	\N	\N	\N	\N	100214	100214	268011
11279	11796	80	applied	\N	\N	\N	\N	100215	100215	268012
11279	11798	81	applied	\N	\N	\N	\N	100216	100216	268013
11279	11799	82	applied	\N	\N	\N	\N	100217	100217	268014
11279	11800	83	applied	\N	\N	\N	\N	100218	100218	268015
11280	12087	0	applied	\N	\N	\N	\N	100219	100219	268016
11280	12088	2	applied	\N	\N	\N	\N	100220	100220	268017
11280	12089	3	applied	\N	\N	\N	\N	100221	100221	268018
11280	12090	4	applied	\N	\N	\N	\N	100222	100222	268019
11282	12087	0	applied	\N	\N	\N	\N	100227	100227	268024
11283	12091	0	applied	\N	\N	\N	\N	100231	100231	268028
11283	12092	1	applied	\N	\N	\N	\N	100232	100232	268029
11288	12095	0	applied	\N	\N	\N	\N	100241	100241	268038
11288	12096	1	applied	\N	\N	\N	\N	100242	100242	268039
11290	12097	0	applied	\N	\N	\N	\N	100245	100245	268042
11290	12098	1	applied	\N	\N	\N	\N	100246	100246	268043
11296	12110	1	applied	\N	\N	\N	\N	100262	100262	268059
11301	12111	0	applied	\N	\N	\N	\N	100268	100268	268065
11270	12069	3	applied	\N	\N	\N	\N	100109	100109	267906
11270	12070	4	applied	\N	\N	\N	\N	100110	100110	267907
11289	12097	0	applied	\N	\N	\N	\N	100243	100243	268040
11289	12098	1	applied	\N	\N	\N	\N	100244	100244	268041
11291	12099	0	applied	\N	\N	\N	\N	100247	100247	268044
11291	12100	1	applied	\N	\N	\N	\N	100248	100248	268045
11294	12105	0	applied	\N	\N	\N	\N	100255	100255	268052
11294	12106	1	applied	\N	\N	\N	\N	100256	100256	268053
11294	12107	2	applied	\N	\N	\N	\N	100257	100257	268054
11302	12111	0	applied	\N	\N	\N	\N	100269	100269	268066
11304	12112	0	applied	\N	\N	\N	\N	100272	100272	268069
11304	12113	1	applied	\N	\N	\N	\N	100273	100273	268070
11306	12116	0	applied	\N	\N	\N	\N	100276	100276	268073
11308	12118	0	applied	\N	\N	\N	\N	100279	100279	268076
11310	12119	0	applied	\N	\N	\N	\N	100283	100283	268080
11310	12120	1	applied	\N	\N	\N	\N	100284	100284	268081
11310	12121	2	applied	\N	\N	\N	\N	100285	100285	268082
11312	12122	0	applied	\N	\N	\N	\N	100288	100288	268085
11312	12123	1	applied	\N	\N	\N	\N	100289	100289	268086
11314	12124	0	applied	\N	\N	\N	\N	100292	100292	268089
11314	12125	1	applied	\N	\N	\N	\N	100293	100293	268090
11316	12125	0	applied	\N	\N	\N	\N	100296	100296	268093
11319	12126	0	applied	\N	\N	\N	\N	100299	100299	268096
11319	12127	1	applied	\N	\N	\N	\N	100300	100300	268097
11320	12128	0	applied	\N	\N	\N	\N	100301	100301	268098
11322	12130	0	applied	\N	\N	\N	\N	100305	100305	268102
11323	12130	0	applied	\N	\N	\N	\N	100306	100306	268103
11325	12131	0	applied	\N	\N	\N	\N	100309	100309	268106
11325	12132	1	applied	\N	\N	\N	\N	100310	100310	268107
11328	12133	0	applied	\N	\N	\N	\N	100314	100314	268111
11328	12135	1	applied	\N	\N	\N	\N	100315	100315	268112
11328	12136	2	applied	\N	\N	\N	\N	100316	100316	268113
11329	12137	0	applied	\N	\N	\N	\N	100317	100317	268114
11329	12138	1	applied	\N	\N	\N	\N	100318	100318	268115
11331	12139	0	applied	\N	\N	\N	\N	100321	100321	268118
11331	12140	1	applied	\N	\N	\N	\N	100322	100322	268119
11332	12141	0	applied	\N	\N	\N	\N	100323	100323	268120
11332	12142	1	applied	\N	\N	\N	\N	100324	100324	268121
11336	12150	0	applied	\N	\N	\N	\N	100336	100336	268132
11336	12151	1	applied	\N	\N	\N	\N	100337	100337	268133
11339	12152	0	applied	\N	\N	\N	\N	100346	100346	268142
11339	12153	1	applied	\N	\N	\N	\N	100347	100347	268143
11339	12154	2	applied	\N	\N	\N	\N	100348	100348	268144
11339	12155	3	applied	\N	\N	\N	\N	100349	100349	268145
11346	12168	0	applied	\N	\N	\N	\N	100374	100374	268170
11346	12169	1	applied	\N	\N	\N	\N	100375	100375	268171
11359	12181	0	applied	\N	\N	\N	\N	100400	100400	268196
11360	12182	0	applied	\N	\N	\N	\N	100401	100401	268197
11360	12183	1	applied	\N	\N	\N	\N	100402	100402	268198
11360	12184	2	applied	\N	\N	\N	\N	100403	100403	268199
11360	12185	3	applied	\N	\N	\N	\N	100404	100404	268200
11360	12186	4	applied	\N	\N	\N	\N	100405	100405	268201
11360	12187	5	applied	\N	\N	\N	\N	100406	100406	268202
11360	12188	6	applied	\N	\N	\N	\N	100407	100407	268203
11360	12189	7	applied	\N	\N	\N	\N	100408	100408	268204
11360	12190	8	applied	\N	\N	\N	\N	100409	100409	268205
11360	12191	9	applied	\N	\N	\N	\N	100410	100410	268206
11362	12192	0	applied	\N	\N	\N	\N	100421	100421	268217
11362	12193	1	applied	\N	\N	\N	\N	100422	100422	268218
11365	12196	0	applied	\N	\N	\N	\N	100429	100429	268225
11365	12197	1	applied	\N	\N	\N	\N	100430	100430	268226
11365	12198	2	applied	\N	\N	\N	\N	100431	100431	268227
11365	12199	3	applied	\N	\N	\N	\N	100432	100432	268228
11368	12202	0	applied	\N	\N	\N	\N	100437	100437	268233
11368	12203	1	applied	\N	\N	\N	\N	100438	100438	268234
11368	12205	3	applied	\N	\N	\N	\N	100440	100440	268236
11368	12206	4	applied	\N	\N	\N	\N	100441	100441	268237
11368	12207	5	applied	\N	\N	\N	\N	100442	100442	268238
11370	12208	0	applied	\N	\N	\N	\N	100449	100449	268245
11370	12209	1	applied	\N	\N	\N	\N	100450	100450	268246
11373	12212	0	applied	\N	\N	\N	\N	100455	100455	268251
11373	12213	1	applied	\N	\N	\N	\N	100456	100456	268252
11373	12214	2	applied	\N	\N	\N	\N	100457	100457	268253
11373	12215	3	applied	\N	\N	\N	\N	100458	100458	268254
11376	12218	0	applied	\N	\N	\N	\N	100463	100463	268259
11376	12219	1	applied	\N	\N	\N	\N	100464	100464	268260
11379	12220	0	applied	\N	\N	\N	\N	100473	100473	268269
11379	12221	1	applied	\N	\N	\N	\N	100474	100474	268270
11379	12222	2	applied	\N	\N	\N	\N	100475	100475	268271
11379	12223	3	applied	\N	\N	\N	\N	100476	100476	268272
11380	12224	0	applied	\N	\N	\N	\N	100477	100477	268273
11383	12226	0	applied	\N	\N	\N	\N	100483	100483	268279
11383	12227	1	applied	\N	\N	\N	\N	100484	100484	268280
11385	12228	0	applied	\N	\N	\N	\N	100487	100487	268283
11385	12229	1	applied	\N	\N	\N	\N	100488	100488	268284
11387	12230	0	applied	\N	\N	\N	\N	100491	100491	268287
11390	12231	0	applied	\N	\N	\N	\N	100497	100497	268293
11390	12232	2	applied	\N	\N	\N	\N	100498	100498	268294
11390	12233	3	applied	\N	\N	\N	\N	100499	100499	268295
11390	12234	4	applied	\N	\N	\N	\N	100500	100500	268296
11397	12237	0	applied	\N	\N	\N	\N	100515	100515	268311
11397	12238	1	applied	\N	\N	\N	\N	100516	100516	268312
11398	12239	0	applied	\N	\N	\N	\N	100517	100517	268313
11404	12248	0	applied	\N	\N	\N	\N	100532	100532	268328
11404	12249	1	applied	\N	\N	\N	\N	100533	100533	268329
11409	12262	0	applied	\N	\N	\N	\N	100550	100550	268346
11409	12263	1	applied	\N	\N	\N	\N	100551	100551	268347
11414	12267	0	applied	\N	\N	\N	\N	100562	100562	268358
11416	12268	0	applied	\N	\N	\N	\N	100564	100564	268360
11416	12269	1	applied	\N	\N	\N	\N	100565	100565	268361
11418	12270	0	applied	\N	\N	\N	\N	100568	100568	268364
11418	12271	1	applied	\N	\N	\N	\N	100569	100569	268365
11421	12274	0	applied	\N	\N	\N	\N	100574	100574	268370
11421	12275	1	applied	\N	\N	\N	\N	100575	100575	268371
11421	12276	2	applied	\N	\N	\N	\N	100576	100576	268372
11421	12277	3	applied	\N	\N	\N	\N	100577	100577	268373
11423	12278	0	applied	\N	\N	\N	\N	100582	100582	268378
11423	12279	1	applied	\N	\N	\N	\N	100583	100583	268379
11426	12087	0	applied	\N	\N	\N	\N	100588	100588	268384
11426	12088	1	applied	\N	\N	\N	\N	100589	100589	268385
11426	12077	2	applied	\N	\N	\N	\N	100590	100590	268386
11426	12078	3	applied	\N	\N	\N	\N	100591	100591	268387
11282	12089	3	applied	\N	\N	\N	\N	100229	100229	268026
11282	12090	4	applied	\N	\N	\N	\N	100230	100230	268027
11333	12148	2	applied	\N	\N	\N	\N	100330	100330	268126
11333	12149	3	applied	\N	\N	\N	\N	100331	100331	268127
11335	12150	0	applied	\N	\N	\N	\N	100334	100334	268130
11335	12151	1	applied	\N	\N	\N	\N	100335	100335	268131
11337	12152	0	applied	\N	\N	\N	\N	100338	100338	268134
11337	12153	1	applied	\N	\N	\N	\N	100339	100339	268135
11337	12154	2	applied	\N	\N	\N	\N	100340	100340	268136
11337	12155	3	applied	\N	\N	\N	\N	100341	100341	268137
11338	12152	0	applied	\N	\N	\N	\N	100342	100342	268138
11338	12153	1	applied	\N	\N	\N	\N	100343	100343	268139
11338	12154	2	applied	\N	\N	\N	\N	100344	100344	268140
11338	12155	3	applied	\N	\N	\N	\N	100345	100345	268141
11340	12156	0	applied	\N	\N	\N	\N	100350	100350	268146
11340	12157	2	applied	\N	\N	\N	\N	100351	100351	268147
11342	12159	1	applied	\N	\N	\N	\N	100353	100353	268149
11342	12160	2	applied	\N	\N	\N	\N	100354	100354	268150
11342	12161	3	applied	\N	\N	\N	\N	100355	100355	268151
11343	12162	0	applied	\N	\N	\N	\N	100356	100356	268152
11343	12163	1	applied	\N	\N	\N	\N	100357	100357	268153
11343	12164	2	applied	\N	\N	\N	\N	100358	100358	268154
11343	12165	3	applied	\N	\N	\N	\N	100359	100359	268155
11343	12166	4	applied	\N	\N	\N	\N	100360	100360	268156
11343	12167	5	applied	\N	\N	\N	\N	100361	100361	268157
11345	12162	0	applied	\N	\N	\N	\N	100368	100368	268164
11345	12163	1	applied	\N	\N	\N	\N	100369	100369	268165
11345	12164	2	applied	\N	\N	\N	\N	100370	100370	268166
11345	12165	3	applied	\N	\N	\N	\N	100371	100371	268167
11345	12166	4	applied	\N	\N	\N	\N	100372	100372	268168
11345	12167	5	applied	\N	\N	\N	\N	100373	100373	268169
11348	12170	0	applied	\N	\N	\N	\N	100380	100380	268176
11348	12172	2	applied	\N	\N	\N	\N	100382	100382	268178
11348	12173	3	applied	\N	\N	\N	\N	100383	100383	268179
11350	12174	0	applied	\N	\N	\N	\N	100386	100386	268182
11350	12175	1	applied	\N	\N	\N	\N	100387	100387	268183
11351	12174	0	applied	\N	\N	\N	\N	100388	100388	268184
11351	12175	1	applied	\N	\N	\N	\N	100389	100389	268185
11352	12176	0	applied	\N	\N	\N	\N	100390	100390	268186
11354	12177	0	applied	\N	\N	\N	\N	100392	100392	268188
11354	12178	1	applied	\N	\N	\N	\N	100393	100393	268189
11364	12196	0	applied	\N	\N	\N	\N	100425	100425	268221
11364	12197	1	applied	\N	\N	\N	\N	100426	100426	268222
11364	12198	2	applied	\N	\N	\N	\N	100427	100427	268223
11364	12199	3	applied	\N	\N	\N	\N	100428	100428	268224
11366	12200	0	applied	\N	\N	\N	\N	100433	100433	268229
11366	12201	1	applied	\N	\N	\N	\N	100434	100434	268230
11374	12216	0	applied	\N	\N	\N	\N	100459	100459	268255
11377	12220	0	applied	\N	\N	\N	\N	100465	100465	268261
11377	12221	1	applied	\N	\N	\N	\N	100466	100466	268262
11377	12222	2	applied	\N	\N	\N	\N	100467	100467	268263
11377	12223	3	applied	\N	\N	\N	\N	100468	100468	268264
11382	12226	0	applied	\N	\N	\N	\N	100481	100481	268277
11382	12227	1	applied	\N	\N	\N	\N	100482	100482	268278
11386	12228	0	applied	\N	\N	\N	\N	100489	100489	268285
11386	12229	1	applied	\N	\N	\N	\N	100490	100490	268286
11388	12230	0	applied	\N	\N	\N	\N	100492	100492	268288
11393	12235	0	applied	\N	\N	\N	\N	100507	100507	268303
11393	12236	1	applied	\N	\N	\N	\N	100508	100508	268304
11395	12237	0	applied	\N	\N	\N	\N	100511	100511	268307
11395	12238	1	applied	\N	\N	\N	\N	100512	100512	268308
11400	12242	0	applied	\N	\N	\N	\N	100520	100520	268316
11400	12243	1	applied	\N	\N	\N	\N	100521	100521	268317
11400	12244	2	applied	\N	\N	\N	\N	100522	100522	268318
11402	12246	0	applied	\N	\N	\N	\N	100528	100528	268324
11402	12247	1	applied	\N	\N	\N	\N	100529	100529	268325
11405	12250	0	applied	\N	\N	\N	\N	100534	100534	268330
11405	12251	1	applied	\N	\N	\N	\N	100535	100535	268331
11405	12252	2	applied	\N	\N	\N	\N	100536	100536	268332
11405	12253	3	applied	\N	\N	\N	\N	100537	100537	268333
11408	12258	0	applied	\N	\N	\N	\N	100546	100546	268342
11408	12259	1	applied	\N	\N	\N	\N	100547	100547	268343
11408	12260	2	applied	\N	\N	\N	\N	100548	100548	268344
11408	12261	3	applied	\N	\N	\N	\N	100549	100549	268345
11410	12262	0	applied	\N	\N	\N	\N	100553	100553	268349
11410	12263	1	applied	\N	\N	\N	\N	100554	100554	268350
11410	12264	2	applied	\N	\N	1000000000	\N	100555	100555	268351
11415	12267	0	applied	\N	\N	\N	\N	100563	100563	268359
11417	12270	0	applied	\N	\N	\N	\N	100566	100566	268362
11417	12271	1	applied	\N	\N	\N	\N	100567	100567	268363
11422	12275	1	applied	\N	\N	\N	\N	100579	100579	268375
11422	12276	2	applied	\N	\N	\N	\N	100580	100580	268376
11422	12277	3	applied	\N	\N	\N	\N	100581	100581	268377
11425	12280	0	applied	\N	\N	\N	\N	100586	100586	268382
11425	12281	1	applied	\N	\N	\N	\N	100587	100587	268383
11429	12282	0	applied	\N	\N	\N	\N	100718	100718	268513
11429	12283	1	applied	\N	\N	\N	\N	100719	100719	268514
11429	12284	2	applied	\N	\N	\N	\N	100720	100720	268515
11429	12285	3	applied	\N	\N	\N	\N	100721	100721	268516
11429	12286	4	applied	\N	\N	\N	\N	100722	100722	268517
11432	12293	0	applied	\N	\N	\N	\N	100729	100729	268524
11432	12294	1	applied	\N	\N	\N	\N	100730	100730	268525
11435	12293	0	applied	\N	\N	\N	\N	100735	100735	268530
11435	12294	1	applied	\N	\N	\N	\N	100736	100736	268531
11442	12304	0	applied	\N	\N	\N	\N	100873	100873	268668
11442	12305	1	applied	\N	\N	\N	\N	100874	100874	268669
11442	12307	3	applied	\N	\N	\N	\N	100876	100876	268671
11445	12314	0	applied	\N	\N	\N	\N	100887	100887	268682
11453	12324	0	applied	\N	\N	\N	\N	100901	100901	268696
11453	12325	1	applied	\N	\N	\N	\N	100902	100902	268697
11456	11938	0	applied	\N	\N	\N	\N	100908	100908	268703
11456	11939	1	applied	\N	\N	\N	\N	100909	100909	268704
11456	12078	2	applied	\N	\N	\N	\N	100910	100910	268705
11456	12080	3	applied	\N	\N	\N	\N	100911	100911	268706
11456	11941	4	applied	\N	\N	\N	\N	100912	100912	268707
11456	11943	5	applied	\N	\N	\N	\N	100913	100913	268708
11456	11945	6	applied	\N	\N	\N	\N	100914	100914	268709
11456	12081	7	applied	\N	\N	\N	\N	100915	100915	268710
11456	12082	8	applied	\N	\N	\N	\N	100916	100916	268711
11456	11947	9	applied	\N	\N	\N	\N	100917	100917	268712
11456	11948	10	applied	\N	\N	\N	\N	100918	100918	268713
11456	11949	11	applied	\N	\N	\N	\N	100919	100919	268714
11333	12147	1	applied	\N	\N	\N	\N	100329	100329	268125
11357	12181	0	applied	\N	\N	\N	\N	100398	100398	268194
11361	12182	0	applied	\N	\N	\N	\N	100411	100411	268207
11361	12183	1	applied	\N	\N	\N	\N	100412	100412	268208
11361	12184	2	applied	\N	\N	\N	\N	100413	100413	268209
11361	12185	3	applied	\N	\N	\N	\N	100414	100414	268210
11361	12186	4	applied	\N	\N	\N	\N	100415	100415	268211
11361	12187	5	applied	\N	\N	\N	\N	100416	100416	268212
11361	12188	6	applied	\N	\N	\N	\N	100417	100417	268213
11361	12189	7	applied	\N	\N	\N	\N	100418	100418	268214
11361	12191	9	applied	\N	\N	\N	\N	100420	100420	268216
11363	12194	0	applied	\N	\N	\N	\N	100423	100423	268219
11363	12195	1	applied	\N	\N	\N	\N	100424	100424	268220
11369	12202	0	applied	\N	\N	\N	\N	100443	100443	268239
11369	12203	1	applied	\N	\N	\N	\N	100444	100444	268240
11369	12204	2	applied	\N	\N	\N	\N	100445	100445	268241
11369	12205	3	applied	\N	\N	\N	\N	100446	100446	268242
11369	12206	4	applied	\N	\N	\N	\N	100447	100447	268243
11369	12207	5	applied	\N	\N	\N	\N	100448	100448	268244
11371	12208	0	applied	\N	\N	\N	\N	100451	100451	268247
11371	12209	1	applied	\N	\N	\N	\N	100452	100452	268248
11378	12220	0	applied	\N	\N	\N	\N	100469	100469	268265
11378	12221	1	applied	\N	\N	\N	\N	100470	100470	268266
11378	12222	2	applied	\N	\N	\N	\N	100471	100471	268267
11378	12223	3	applied	\N	\N	\N	\N	100472	100472	268268
11381	12226	0	applied	\N	\N	\N	\N	100479	100479	268275
11384	12228	0	applied	\N	\N	\N	\N	100485	100485	268281
11384	12229	1	applied	\N	\N	\N	\N	100486	100486	268282
11389	12231	0	applied	\N	\N	\N	\N	100493	100493	268289
11389	12232	2	applied	\N	\N	\N	\N	100494	100494	268290
11389	12233	3	applied	\N	\N	\N	\N	100495	100495	268291
11389	12234	4	applied	\N	\N	\N	\N	100496	100496	268292
11391	12231	0	applied	\N	\N	\N	\N	100501	100501	268297
11391	12232	2	applied	\N	\N	\N	\N	100502	100502	268298
11391	12233	3	applied	\N	\N	\N	\N	100503	100503	268299
11391	12234	4	applied	\N	\N	\N	\N	100504	100504	268300
11392	12235	0	applied	\N	\N	\N	\N	100505	100505	268301
11392	12236	1	applied	\N	\N	\N	\N	100506	100506	268302
11394	12235	0	applied	\N	\N	\N	\N	100509	100509	268305
11394	12236	1	applied	\N	\N	\N	\N	100510	100510	268306
11396	12237	0	applied	\N	\N	\N	\N	100513	100513	268309
11396	12238	1	applied	\N	\N	\N	\N	100514	100514	268310
11399	12241	1	applied	\N	\N	\N	\N	100519	100519	268315
11401	12242	0	applied	\N	\N	\N	\N	100524	100524	268320
11401	12243	1	applied	\N	\N	\N	\N	100525	100525	268321
11401	12244	2	applied	\N	\N	\N	\N	100526	100526	268322
11401	12245	3	applied	\N	\N	\N	\N	100527	100527	268323
11407	12254	0	applied	\N	\N	\N	\N	100542	100542	268338
11407	12255	1	applied	\N	\N	\N	\N	100543	100543	268339
11407	12256	2	applied	\N	\N	\N	\N	100544	100544	268340
11407	12257	3	applied	\N	\N	\N	\N	100545	100545	268341
11412	12265	0	applied	\N	\N	\N	\N	100559	100559	268355
11412	12266	1	applied	\N	\N	\N	\N	100560	100560	268356
11419	12270	0	applied	\N	\N	\N	\N	100570	100570	268366
11419	12271	1	applied	\N	\N	\N	\N	100571	100571	268367
11424	12280	0	applied	\N	\N	\N	\N	100584	100584	268380
11424	12281	1	applied	\N	\N	\N	\N	100585	100585	268381
11434	12293	0	applied	\N	\N	\N	\N	100733	100733	268528
11436	12295	0	applied	\N	\N	\N	\N	100737	100737	268532
11439	12298	0	applied	\N	\N	\N	\N	100742	100742	268537
11439	12299	1	applied	\N	\N	\N	\N	100743	100743	268538
11444	12308	0	applied	\N	\N	\N	\N	100881	100881	268676
11444	12309	1	applied	\N	\N	\N	\N	100882	100882	268677
11444	12310	2	applied	\N	\N	\N	\N	100883	100883	268678
11444	12311	3	applied	\N	\N	\N	\N	100884	100884	268679
11444	12312	4	applied	\N	\N	\N	\N	100885	100885	268680
11444	12313	5	applied	\N	\N	\N	\N	100886	100886	268681
11448	12314	0	applied	\N	\N	\N	\N	100890	100890	268685
11452	12320	0	applied	\N	\N	\N	\N	100897	100897	268692
11452	12321	1	applied	\N	\N	\N	\N	100898	100898	268693
11452	12322	2	applied	\N	\N	\N	\N	100899	100899	268694
11452	12323	3	applied	\N	\N	\N	\N	100900	100900	268695
11455	12329	0	applied	\N	\N	\N	\N	100906	100906	268701
11455	12330	1	applied	\N	\N	\N	\N	100907	100907	268702
11457	12332	1	applied	\N	\N	\N	\N	100974	100974	268769
11462	12337	0	applied	\N	\N	\N	\N	100983	100983	268778
11462	12338	1	applied	\N	\N	\N	\N	100984	100984	268779
11475	12363	0	applied	\N	\N	\N	\N	101029	101029	268821
11475	12364	1	applied	\N	\N	\N	\N	101030	101030	268822
11477	12365	0	applied	\N	\N	\N	\N	101033	101033	268825
11477	12366	1	applied	\N	\N	\N	\N	101034	101034	268826
11498	12351	1	applied	\N	\N	\N	\N	101090	101090	268877
11498	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	101089	101089	\N
11498	12360	2	applied	\N	\N	\N	\N	101091	101091	101091
11498	12308	3	applied	\N	\N	\N	\N	101092	101092	268878
11498	12309	4	applied	\N	\N	\N	\N	101093	101093	268879
11498	12310	5	applied	\N	\N	\N	\N	101094	101094	268880
11498	12314	6	applied	\N	\N	\N	\N	101095	101095	268881
11498	12316	7	applied	\N	\N	\N	\N	101096	101096	268882
11498	12317	8	applied	\N	\N	\N	\N	101097	101097	268883
11498	12321	10	applied	\N	\N	\N	\N	101099	101099	268885
11498	12324	11	applied	\N	\N	\N	\N	101100	101100	268886
11498	12327	12	applied	\N	\N	\N	\N	101101	101101	268887
11498	12329	13	applied	\N	\N	\N	\N	101102	101102	268888
11498	12331	14	applied	\N	\N	\N	\N	101103	101103	268889
11498	12333	15	applied	\N	\N	\N	\N	101104	101104	268890
11498	12335	16	applied	\N	\N	\N	\N	101105	101105	268891
11498	12337	17	applied	\N	\N	\N	\N	101106	101106	268892
11498	12339	18	applied	\N	\N	\N	\N	101107	101107	268893
11498	12341	19	applied	\N	\N	\N	\N	101108	101108	268894
11498	12343	20	applied	\N	\N	\N	\N	101109	101109	268895
11498	12345	21	applied	\N	\N	\N	\N	101110	101110	268896
11498	12347	22	applied	\N	\N	\N	\N	101111	101111	268897
11498	12352	23	applied	\N	\N	\N	\N	101112	101112	268898
11498	12353	24	applied	\N	\N	\N	\N	101113	101113	268899
11498	12354	25	applied	\N	\N	\N	\N	101114	101114	268900
11498	12361	27	applied	\N	\N	\N	\N	101116	101116	268902
11498	12363	28	applied	\N	\N	\N	\N	101117	101117	268903
11498	12365	29	applied	\N	\N	\N	\N	101118	101118	268904
11498	12367	30	applied	\N	\N	\N	\N	101119	101119	268905
11355	12179	0	applied	\N	\N	\N	\N	100394	100394	268190
11355	12180	1	applied	\N	\N	\N	\N	100395	100395	268191
11406	12251	1	applied	\N	\N	\N	\N	100539	100539	268335
11406	12253	3	applied	\N	\N	\N	\N	100541	100541	268337
11411	12262	0	applied	\N	\N	\N	\N	100556	100556	268352
11411	12263	1	applied	\N	\N	\N	\N	100557	100557	268353
11411	12264	2	applied	\N	\N	1000000000	\N	100558	100558	268354
11413	12267	0	applied	\N	\N	\N	\N	100561	100561	268357
11420	12272	0	applied	\N	\N	\N	\N	100572	100572	268368
11420	12273	1	applied	\N	\N	\N	\N	100573	100573	268369
11426	12079	4	applied	\N	\N	\N	\N	100592	100592	268388
11426	12085	5	applied	\N	\N	\N	\N	100593	100593	268389
11426	12080	6	applied	\N	\N	\N	\N	100594	100594	268390
11426	12089	7	applied	\N	\N	\N	\N	100595	100595	268391
11426	12091	8	applied	\N	\N	\N	\N	100596	100596	268392
11426	12093	9	applied	\N	\N	\N	\N	100597	100597	268393
11426	12095	10	applied	\N	\N	\N	\N	100598	100598	268394
11426	12097	11	applied	\N	\N	\N	\N	100599	100599	268395
11426	12099	12	applied	\N	\N	\N	\N	100600	100600	268396
11426	12102	14	applied	\N	\N	\N	\N	100602	100602	268398
11426	12105	15	applied	\N	\N	\N	\N	100603	100603	268399
11426	12106	16	applied	\N	\N	\N	\N	100604	100604	268400
11426	12081	17	applied	\N	\N	\N	\N	100605	100605	268401
11426	12082	19	applied	\N	\N	\N	\N	100606	100606	268402
11426	12109	20	applied	\N	\N	\N	\N	100607	100607	268403
11426	12111	21	applied	\N	\N	\N	\N	100608	100608	268404
11426	12112	22	applied	\N	\N	\N	\N	100609	100609	268405
11430	12287	0	applied	\N	\N	\N	\N	100723	100723	268518
11430	12288	1	applied	\N	\N	\N	\N	100724	100724	268519
11437	12296	0	applied	\N	\N	\N	\N	100738	100738	268533
11437	12297	1	applied	\N	\N	\N	\N	100739	100739	268534
11440	12300	0	applied	\N	\N	\N	\N	100744	100744	268539
11440	12301	1	applied	\N	\N	\N	\N	100745	100745	268540
11440	12302	2	applied	\N	\N	\N	\N	100746	100746	268541
11440	12303	3	applied	\N	\N	\N	\N	100747	100747	268542
11443	12305	1	applied	\N	\N	\N	\N	100878	100878	268673
11443	12306	2	applied	\N	\N	\N	\N	100879	100879	268674
11443	12307	3	applied	\N	\N	\N	\N	100880	100880	268675
11446	12314	0	applied	\N	\N	\N	\N	100888	100888	268683
11449	12314	0	applied	\N	\N	\N	\N	100891	100891	268686
11450	12315	0	applied	\N	\N	\N	\N	100892	100892	268687
11459	12333	0	applied	\N	\N	\N	\N	100977	100977	268772
11459	12334	1	applied	\N	\N	\N	\N	100978	100978	268773
11463	12339	0	applied	\N	\N	\N	\N	100985	100985	268780
11463	12340	1	applied	\N	\N	\N	\N	100986	100986	268781
11466	12345	0	applied	\N	\N	\N	\N	100991	100991	268786
11466	12346	1	applied	\N	\N	\N	\N	100992	100992	268787
11468	12347	0	applied	\N	\N	\N	\N	100995	100995	268790
11468	12348	1	applied	\N	\N	\N	\N	100996	100996	268791
11468	12349	2	applied	\N	\N	\N	\N	100997	100997	268792
11470	12347	0	applied	\N	\N	\N	\N	101001	101001	268796
11470	12349	2	applied	\N	\N	\N	\N	101003	101003	268798
11471	12351	1	applied	\N	\N	\N	\N	101005	101005	268799
11471	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	101004	101004	\N
11471	12352	2	applied	\N	\N	\N	\N	101006	101006	268800
11471	12353	3	applied	\N	\N	\N	\N	101007	101007	268801
11471	12354	4	applied	\N	\N	\N	\N	101008	101008	268802
11471	12355	5	applied	\N	\N	\N	\N	101009	101009	268803
11471	12356	6	applied	\N	\N	\N	\N	101010	101010	268804
11471	12357	7	applied	\N	\N	\N	\N	101011	101011	268805
11471	12358	8	applied	\N	\N	\N	\N	101012	101012	268806
11471	12359	9	applied	\N	\N	\N	\N	101013	101013	268807
11476	12363	0	applied	\N	\N	\N	\N	101031	101031	268823
11476	12364	1	applied	\N	\N	\N	\N	101032	101032	268824
11479	12367	0	applied	\N	\N	\N	\N	101039	101039	268831
11479	12368	1	applied	\N	\N	\N	\N	101040	101040	268832
11479	12369	2	applied	\N	\N	\N	\N	101041	101041	268833
11481	12371	0	applied	\N	\N	\N	\N	101045	101045	268837
11481	12372	1	applied	\N	\N	\N	\N	101046	101046	268838
11483	12373	0	applied	\N	\N	\N	\N	101049	101049	268841
11483	12374	1	applied	\N	\N	\N	\N	101050	101050	268842
11485	12376	0	applied	\N	\N	\N	\N	101055	101055	268845
11483	12375	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	101051	101051	\N
11490	12376	0	applied	\N	\N	\N	\N	101059	101059	268849
11491	12376	0	applied	\N	\N	\N	\N	101060	101060	268850
11492	12378	1	applied	\N	\N	\N	\N	101062	101062	268851
11492	12379	3	applied	\N	\N	\N	\N	101063	101063	268852
11492	12380	4	applied	\N	\N	\N	\N	101064	101064	268853
11492	12381	5	applied	\N	\N	\N	\N	101065	101065	268854
11492	12382	6	applied	\N	\N	\N	\N	101066	101066	268855
11492	12383	7	applied	\N	\N	\N	\N	101067	101067	268856
11497	12389	0	applied	\N	\N	\N	\N	101087	101087	268875
11497	12390	1	applied	\N	\N	\N	\N	101088	101088	268876
11499	12391	0	applied	\N	\N	\N	\N	101178	101178	268962
11499	12393	2	applied	\N	\N	\N	\N	101180	101180	268963
11499	12392	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	101179	101179	\N
11502	12394	0	applied	\N	\N	\N	\N	101193	101193	268972
11502	12395	1	applied	\N	\N	\N	\N	101194	101194	268973
11502	12397	3	applied	\N	\N	\N	\N	101196	101196	268974
11502	12396	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	101195	101195	\N
11502	12398	4	applied	\N	\N	\N	\N	101197	101197	101197
11502	12399	5	applied	\N	\N	\N	\N	101198	101198	268975
11504	12351	1	applied	\N	\N	\N	\N	101203	101203	268979
11504	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	101202	101202	\N
11504	12360	2	applied	\N	\N	\N	\N	101204	101204	101204
11504	12282	3	applied	\N	\N	\N	\N	101205	101205	268980
11504	12283	4	applied	\N	\N	\N	\N	101206	101206	268981
11504	12284	5	applied	\N	\N	\N	\N	101207	101207	268982
11504	12287	6	applied	\N	\N	\N	\N	101208	101208	268983
11504	12289	7	applied	\N	\N	\N	\N	101209	101209	268984
11504	12290	8	applied	\N	\N	\N	\N	101210	101210	268985
11504	12293	9	applied	\N	\N	\N	\N	101211	101211	268986
11504	12296	10	applied	\N	\N	\N	\N	101212	101212	268987
11504	12298	11	applied	\N	\N	\N	\N	101213	101213	268988
11504	12300	12	applied	\N	\N	\N	\N	101214	101214	268989
11504	12301	13	applied	\N	\N	\N	\N	101215	101215	268990
11504	12304	14	applied	\N	\N	\N	\N	101216	101216	268991
11504	12308	16	applied	\N	\N	\N	\N	101218	101218	268993
11504	12309	17	applied	\N	\N	\N	\N	101219	101219	268994
11403	12249	1	applied	\N	\N	\N	\N	100531	100531	268327
11406	12250	0	applied	\N	\N	\N	\N	100538	100538	268334
11426	12120	26	applied	\N	\N	\N	\N	100613	100613	268409
11426	12122	27	applied	\N	\N	\N	\N	100614	100614	268410
11426	12124	28	applied	\N	\N	\N	\N	100615	100615	268411
11426	12126	29	applied	\N	\N	\N	\N	100616	100616	268412
11426	12128	30	applied	\N	\N	\N	\N	100617	100617	268413
11426	12130	31	applied	\N	\N	\N	\N	100618	100618	268414
11426	12131	32	applied	\N	\N	\N	\N	100619	100619	268415
11426	12133	33	applied	\N	\N	\N	\N	100620	100620	268416
11426	12135	34	applied	\N	\N	\N	\N	100621	100621	268417
11426	12139	36	applied	\N	\N	\N	\N	100623	100623	268419
11426	12141	37	applied	\N	\N	\N	\N	100624	100624	268420
11426	12142	38	applied	\N	\N	\N	\N	100625	100625	268421
11426	12146	39	applied	\N	\N	\N	\N	100626	100626	268422
11426	12147	40	applied	\N	\N	\N	\N	100627	100627	268423
11426	12150	41	applied	\N	\N	\N	\N	100628	100628	268424
11426	12152	42	applied	\N	\N	\N	\N	100629	100629	268425
11426	12153	43	applied	\N	\N	\N	\N	100630	100630	268426
11426	12156	44	applied	\N	\N	\N	\N	100631	100631	268427
11426	12158	45	applied	\N	\N	\N	\N	100632	100632	268428
11426	12159	46	applied	\N	\N	\N	\N	100633	100633	268429
11426	12162	47	applied	\N	\N	\N	\N	100634	100634	268430
11426	12163	48	applied	\N	\N	\N	\N	100635	100635	268431
11426	12164	49	applied	\N	\N	\N	\N	100636	100636	268432
11426	12168	50	applied	\N	\N	\N	\N	100637	100637	268433
11426	12170	51	applied	\N	\N	\N	\N	100638	100638	268434
11426	12174	53	applied	\N	\N	\N	\N	100640	100640	268436
11426	12177	54	applied	\N	\N	\N	\N	100641	100641	268437
11426	12179	55	applied	\N	\N	\N	\N	100642	100642	268438
11426	12181	56	applied	\N	\N	\N	\N	100643	100643	268439
11426	12182	57	applied	\N	\N	\N	\N	100644	100644	268440
11426	12183	58	applied	\N	\N	\N	\N	100645	100645	268441
11426	12184	59	applied	\N	\N	\N	\N	100646	100646	268442
11426	12185	60	applied	\N	\N	\N	\N	100647	100647	268443
11426	12186	61	applied	\N	\N	\N	\N	100648	100648	268444
11426	12192	62	applied	\N	\N	\N	\N	100649	100649	268445
11426	12194	63	applied	\N	\N	\N	\N	100650	100650	268446
11426	12196	64	applied	\N	\N	\N	\N	100651	100651	268447
11426	12197	65	applied	\N	\N	\N	\N	100652	100652	268448
11426	12200	66	applied	\N	\N	\N	\N	100653	100653	268449
11426	12202	67	applied	\N	\N	\N	\N	100654	100654	268450
11426	12203	68	applied	\N	\N	\N	\N	100655	100655	268451
11426	12208	70	applied	\N	\N	\N	\N	100657	100657	268453
11426	12210	71	applied	\N	\N	\N	\N	100658	100658	268454
11426	12212	72	applied	\N	\N	\N	\N	100659	100659	268455
11426	12213	73	applied	\N	\N	\N	\N	100660	100660	268456
11426	12216	74	applied	\N	\N	\N	\N	100661	100661	268457
11426	12218	75	applied	\N	\N	\N	\N	100662	100662	268458
11426	12220	76	applied	\N	\N	\N	\N	100663	100663	268459
11426	12221	77	applied	\N	\N	\N	\N	100664	100664	268460
11426	12224	78	applied	\N	\N	\N	\N	100665	100665	268461
11426	12226	79	applied	\N	\N	\N	\N	100666	100666	268462
11426	12228	80	applied	\N	\N	\N	\N	100667	100667	268463
11426	12231	81	applied	\N	\N	\N	\N	100668	100668	268464
11426	12232	82	applied	\N	\N	\N	\N	100669	100669	268465
11426	12235	83	applied	\N	\N	\N	\N	100670	100670	268466
11426	12237	84	applied	\N	\N	\N	\N	100671	100671	268467
11426	12239	85	applied	\N	\N	\N	\N	100672	100672	268468
11426	12242	87	applied	\N	\N	\N	\N	100674	100674	268470
11426	12243	88	applied	\N	\N	\N	\N	100675	100675	268471
11426	12246	89	applied	\N	\N	\N	\N	100676	100676	268472
11426	12248	90	applied	\N	\N	\N	\N	100677	100677	268473
11426	12250	91	applied	\N	\N	\N	\N	100678	100678	268474
11426	12251	92	applied	\N	\N	\N	\N	100679	100679	268475
11426	12254	93	applied	\N	\N	\N	\N	100680	100680	268476
11426	12255	94	applied	\N	\N	\N	\N	100681	100681	268477
11426	12258	95	applied	\N	\N	\N	\N	100682	100682	268478
11426	12259	96	applied	\N	\N	\N	\N	100683	100683	268479
11426	12262	97	applied	\N	\N	\N	\N	100684	100684	268480
11426	12265	98	applied	\N	\N	\N	\N	100685	100685	268481
11426	12268	99	applied	\N	\N	\N	\N	100686	100686	268482
11426	12270	100	applied	\N	\N	\N	\N	100687	100687	268483
11426	12272	101	applied	\N	\N	\N	\N	100688	100688	268484
11426	12274	102	applied	\N	\N	\N	\N	100689	100689	268485
11426	12278	104	applied	\N	\N	\N	\N	100691	100691	268487
11426	12280	105	applied	\N	\N	\N	\N	100692	100692	268488
11426	12076	106	applied	\N	\N	\N	\N	100693	100693	268489
11426	12083	108	applied	\N	\N	\N	\N	100695	100695	268490
11426	12143	107	failed	Amount_insufficient_to_create_account	\N	\N	\N	100694	100694	\N
11426	12084	109	applied	\N	\N	\N	\N	100696	100696	268491
11426	12086	110	applied	\N	\N	\N	\N	100697	100697	268492
11426	12090	111	applied	\N	\N	\N	\N	100698	100698	268493
11426	12092	112	applied	\N	\N	\N	\N	100699	100699	268494
11426	12094	113	applied	\N	\N	\N	\N	100700	100700	268495
11426	12096	114	applied	\N	\N	\N	\N	100701	100701	268496
11426	12098	115	applied	\N	\N	\N	\N	100702	100702	268497
11426	12100	116	applied	\N	\N	\N	\N	100703	100703	268498
11426	12103	117	applied	\N	\N	\N	\N	100704	100704	268499
11426	12104	118	applied	\N	\N	\N	\N	100705	100705	268500
11426	12107	119	applied	\N	\N	\N	\N	100706	100706	268501
11426	12110	121	applied	\N	\N	\N	\N	100708	100708	268503
11426	12113	122	applied	\N	\N	\N	\N	100709	100709	268504
11426	12115	123	applied	\N	\N	\N	\N	100710	100710	268505
11426	12116	124	applied	\N	\N	\N	\N	100711	100711	268506
11426	12118	125	applied	\N	\N	\N	\N	100712	100712	268507
11428	12282	0	applied	\N	\N	\N	\N	100713	100713	268508
11428	12283	1	applied	\N	\N	\N	\N	100714	100714	268509
11428	12284	2	applied	\N	\N	\N	\N	100715	100715	268510
11428	12285	3	applied	\N	\N	\N	\N	100716	100716	268511
11428	12286	4	applied	\N	\N	\N	\N	100717	100717	268512
11431	12289	0	applied	\N	\N	\N	\N	100725	100725	268520
11431	12290	1	applied	\N	\N	\N	\N	100726	100726	268521
11431	12291	2	applied	\N	\N	\N	\N	100727	100727	268522
11431	12292	3	applied	\N	\N	\N	\N	100728	100728	268523
11433	12293	0	applied	\N	\N	\N	\N	100731	100731	268526
11433	12294	1	applied	\N	\N	\N	\N	100732	100732	268527
11438	12299	1	applied	\N	\N	\N	\N	100741	100741	268536
11441	12177	0	applied	\N	\N	\N	\N	100748	100748	268543
11441	12179	1	applied	\N	\N	\N	\N	100749	100749	268544
11441	12181	2	applied	\N	\N	\N	\N	100750	100750	268545
11426	12117	24	applied	\N	\N	\N	\N	100611	100611	268407
11426	12119	25	applied	\N	\N	\N	\N	100612	100612	268408
11441	12186	7	applied	\N	\N	\N	\N	100755	100755	268550
11441	12192	8	applied	\N	\N	\N	\N	100756	100756	268551
11441	12194	9	applied	\N	\N	\N	\N	100757	100757	268552
11441	12196	10	applied	\N	\N	\N	\N	100758	100758	268553
11441	12197	11	applied	\N	\N	\N	\N	100759	100759	268554
11441	12200	12	applied	\N	\N	\N	\N	100760	100760	268555
11441	12202	13	applied	\N	\N	\N	\N	100761	100761	268556
11441	12203	14	applied	\N	\N	\N	\N	100762	100762	268557
11441	12204	15	applied	\N	\N	\N	\N	100763	100763	268558
11441	12208	16	applied	\N	\N	\N	\N	100764	100764	268559
11441	12210	17	applied	\N	\N	\N	\N	100765	100765	268560
11441	12212	18	applied	\N	\N	\N	\N	100766	100766	268561
11441	12213	19	applied	\N	\N	\N	\N	100767	100767	268562
11441	12216	20	applied	\N	\N	\N	\N	100768	100768	268563
11441	12220	22	applied	\N	\N	\N	\N	100770	100770	268565
11441	12221	23	applied	\N	\N	\N	\N	100771	100771	268566
11441	12224	24	applied	\N	\N	\N	\N	100772	100772	268567
11441	12226	25	applied	\N	\N	\N	\N	100773	100773	268568
11441	12228	26	applied	\N	\N	\N	\N	100774	100774	268569
11441	12231	27	applied	\N	\N	\N	\N	100775	100775	268570
11441	12232	28	applied	\N	\N	\N	\N	100776	100776	268571
11441	12235	29	applied	\N	\N	\N	\N	100777	100777	268572
11441	12237	30	applied	\N	\N	\N	\N	100778	100778	268573
11441	12239	31	applied	\N	\N	\N	\N	100779	100779	268574
11441	12240	32	applied	\N	\N	\N	\N	100780	100780	268575
11441	12242	33	applied	\N	\N	\N	\N	100781	100781	268576
11441	12243	34	applied	\N	\N	\N	\N	100782	100782	268577
11441	12246	35	applied	\N	\N	\N	\N	100783	100783	268578
11441	12248	36	applied	\N	\N	\N	\N	100784	100784	268579
11441	12250	37	applied	\N	\N	\N	\N	100785	100785	268580
11441	12254	39	applied	\N	\N	\N	\N	100787	100787	268582
11441	12255	40	applied	\N	\N	\N	\N	100788	100788	268583
11441	12258	41	applied	\N	\N	\N	\N	100789	100789	268584
11441	12259	42	applied	\N	\N	\N	\N	100790	100790	268585
11441	12262	43	applied	\N	\N	\N	\N	100791	100791	268586
11441	12265	44	applied	\N	\N	\N	\N	100792	100792	268587
11441	12268	45	applied	\N	\N	\N	\N	100793	100793	268588
11441	12270	46	applied	\N	\N	\N	\N	100794	100794	268589
11441	12272	47	applied	\N	\N	\N	\N	100795	100795	268590
11441	12274	48	applied	\N	\N	\N	\N	100796	100796	268591
11441	12275	49	applied	\N	\N	\N	\N	100797	100797	268592
11441	12278	50	applied	\N	\N	\N	\N	100798	100798	268593
11441	12280	51	applied	\N	\N	\N	\N	100799	100799	268594
11441	12282	52	applied	\N	\N	\N	\N	100800	100800	268595
11441	12283	53	applied	\N	\N	\N	\N	100801	100801	268596
11441	12284	54	applied	\N	\N	\N	\N	100802	100802	268597
11441	12289	56	applied	\N	\N	\N	\N	100804	100804	268599
11441	12290	57	applied	\N	\N	\N	\N	100805	100805	268600
11441	12293	58	applied	\N	\N	\N	\N	100806	100806	268601
11441	12296	59	applied	\N	\N	\N	\N	100807	100807	268602
11441	12298	60	applied	\N	\N	\N	\N	100808	100808	268603
11441	12300	61	applied	\N	\N	\N	\N	100809	100809	268604
11441	12301	62	applied	\N	\N	\N	\N	100810	100810	268605
11441	12304	63	applied	\N	\N	\N	\N	100811	100811	268606
11441	12305	64	applied	\N	\N	\N	\N	100812	100812	268607
11441	12178	65	applied	\N	\N	\N	\N	100813	100813	268608
11441	12180	66	applied	\N	\N	\N	\N	100814	100814	268609
11441	12187	67	applied	\N	\N	\N	\N	100815	100815	268610
11441	12188	68	applied	\N	\N	\N	\N	100816	100816	268611
11441	12189	69	applied	\N	\N	\N	\N	100817	100817	268612
11441	12190	70	applied	\N	\N	\N	\N	100818	100818	268613
11441	12191	71	applied	\N	\N	\N	\N	100819	100819	268614
11441	12195	73	applied	\N	\N	\N	\N	100821	100821	268616
11441	12198	74	applied	\N	\N	\N	\N	100822	100822	268617
11441	12199	75	applied	\N	\N	\N	\N	100823	100823	268618
11441	12201	76	applied	\N	\N	\N	\N	100824	100824	268619
11441	12205	77	applied	\N	\N	\N	\N	100825	100825	268620
11441	12206	78	applied	\N	\N	\N	\N	100826	100826	268621
11441	12207	79	applied	\N	\N	\N	\N	100827	100827	268622
11441	12209	80	applied	\N	\N	\N	\N	100828	100828	268623
11441	12211	81	applied	\N	\N	\N	\N	100829	100829	268624
11441	12214	82	applied	\N	\N	\N	\N	100830	100830	268625
11441	12215	83	applied	\N	\N	\N	\N	100831	100831	268626
11441	12217	84	applied	\N	\N	\N	\N	100832	100832	268627
11441	12219	85	applied	\N	\N	\N	\N	100833	100833	268628
11441	12222	86	applied	\N	\N	\N	\N	100834	100834	268629
11441	12223	87	applied	\N	\N	\N	\N	100835	100835	268630
11441	12225	88	applied	\N	\N	\N	\N	100836	100836	268631
11441	12229	90	applied	\N	\N	\N	\N	100838	100838	268633
11441	12230	91	applied	\N	\N	\N	\N	100839	100839	268634
11441	12233	92	applied	\N	\N	\N	\N	100840	100840	268635
11441	12234	94	applied	\N	\N	\N	\N	100841	100841	268636
11441	12236	95	applied	\N	\N	\N	\N	100842	100842	268637
11441	12238	96	applied	\N	\N	\N	\N	100843	100843	268638
11441	12241	97	applied	\N	\N	\N	\N	100844	100844	268639
11441	12244	98	applied	\N	\N	\N	\N	100845	100845	268640
11441	12245	99	applied	\N	\N	\N	\N	100846	100846	268641
11441	12247	100	applied	\N	\N	\N	\N	100847	100847	268642
11441	12249	101	applied	\N	\N	\N	\N	100848	100848	268643
11441	12252	102	applied	\N	\N	\N	\N	100849	100849	268644
11441	12253	103	applied	\N	\N	\N	\N	100850	100850	268645
11441	12256	104	applied	\N	\N	\N	\N	100851	100851	268646
11441	12257	105	applied	\N	\N	\N	\N	100852	100852	268647
11441	12260	106	applied	\N	\N	\N	\N	100853	100853	268648
11441	12263	108	applied	\N	\N	\N	\N	100855	100855	268650
11441	12264	109	applied	\N	\N	1000000000	\N	100856	100856	268651
11441	12266	110	applied	\N	\N	\N	\N	100857	100857	268652
11441	12267	111	applied	\N	\N	\N	\N	100858	100858	268653
11441	12269	112	applied	\N	\N	\N	\N	100859	100859	268654
11441	12271	113	applied	\N	\N	\N	\N	100860	100860	268655
11441	12273	114	applied	\N	\N	\N	\N	100861	100861	268656
11441	12276	115	applied	\N	\N	\N	\N	100862	100862	268657
11441	12277	116	applied	\N	\N	\N	\N	100863	100863	268658
11441	12279	117	applied	\N	\N	\N	\N	100864	100864	268659
11441	12281	118	applied	\N	\N	\N	\N	100865	100865	268660
11441	12285	119	applied	\N	\N	\N	\N	100866	100866	268661
11441	12286	120	applied	\N	\N	\N	\N	100867	100867	268662
11441	12288	121	applied	\N	\N	\N	\N	100868	100868	268663
11441	12291	122	applied	\N	\N	\N	\N	100869	100869	268664
11441	12292	123	applied	\N	\N	\N	\N	100870	100870	268665
11441	12185	6	applied	\N	\N	\N	\N	100754	100754	268549
11451	12317	1	applied	\N	\N	\N	\N	100894	100894	268689
11451	12318	2	applied	\N	\N	\N	\N	100895	100895	268690
11451	12319	3	applied	\N	\N	\N	\N	100896	100896	268691
11454	12327	1	applied	\N	\N	\N	\N	100904	100904	268699
11454	12328	2	applied	\N	\N	\N	\N	100905	100905	268700
11456	11950	12	applied	\N	\N	\N	\N	100920	100920	268715
11456	11951	13	applied	\N	\N	\N	\N	100921	100921	268716
11456	11952	14	applied	\N	\N	\N	\N	100922	100922	268717
11456	11953	15	applied	\N	\N	\N	\N	100923	100923	268718
11456	11954	16	applied	\N	\N	\N	\N	100924	100924	268719
11456	11955	17	applied	\N	\N	\N	\N	100925	100925	268720
11456	11959	18	applied	\N	\N	\N	\N	100926	100926	268721
11456	11960	19	applied	\N	\N	\N	\N	100927	100927	268722
11456	11961	20	applied	\N	\N	\N	\N	100928	100928	268723
11456	11962	21	applied	\N	\N	\N	\N	100929	100929	268724
11456	11963	22	applied	\N	\N	\N	\N	100930	100930	268725
11456	11966	23	applied	\N	\N	\N	\N	100931	100931	268726
11456	11967	24	applied	\N	\N	\N	\N	100932	100932	268727
11456	11968	25	applied	\N	\N	\N	\N	100933	100933	268728
11456	11969	26	applied	\N	\N	\N	\N	100934	100934	268729
11456	11970	27	applied	\N	\N	\N	\N	100935	100935	268730
11456	11974	29	applied	\N	\N	\N	\N	100937	100937	268732
11456	11975	30	applied	\N	\N	\N	\N	100938	100938	268733
11456	11976	31	applied	\N	\N	\N	\N	100939	100939	268734
11456	11977	32	applied	\N	\N	\N	\N	100940	100940	268735
11460	12333	0	applied	\N	\N	\N	\N	100979	100979	268774
11460	12334	1	applied	\N	\N	\N	\N	100980	100980	268775
11461	12335	0	applied	\N	\N	\N	\N	100981	100981	268776
11461	12336	1	applied	\N	\N	\N	\N	100982	100982	268777
11464	12341	0	applied	\N	\N	\N	\N	100987	100987	268782
11464	12342	1	applied	\N	\N	\N	\N	100988	100988	268783
11467	12345	0	applied	\N	\N	\N	\N	100993	100993	268788
11467	12346	1	applied	\N	\N	\N	\N	100994	100994	268789
11469	12347	0	applied	\N	\N	\N	\N	100998	100998	268793
11469	12348	1	applied	\N	\N	\N	\N	100999	100999	268794
11469	12349	2	applied	\N	\N	\N	\N	101000	101000	268795
11472	12351	1	applied	\N	\N	\N	\N	101015	101015	268808
11472	12352	2	applied	\N	\N	\N	\N	101016	101016	268809
11472	12353	3	applied	\N	\N	\N	\N	101017	101017	268810
11472	12354	4	applied	\N	\N	\N	\N	101018	101018	268811
11472	12355	5	applied	\N	\N	\N	\N	101019	101019	268812
11472	12356	6	applied	\N	\N	\N	\N	101020	101020	268813
11472	12357	7	applied	\N	\N	\N	\N	101021	101021	268814
11472	12358	8	applied	\N	\N	\N	\N	101022	101022	268815
11472	12359	9	applied	\N	\N	\N	\N	101023	101023	268816
11474	12363	0	applied	\N	\N	\N	\N	101027	101027	268819
11474	12364	1	applied	\N	\N	\N	\N	101028	101028	268820
11484	12373	0	applied	\N	\N	\N	\N	101052	101052	268843
11484	12374	1	applied	\N	\N	\N	\N	101053	101053	268844
11488	12376	0	applied	\N	\N	\N	\N	101057	101057	268847
11484	12375	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	101054	101054	\N
11493	12378	1	applied	\N	\N	\N	\N	101069	101069	268857
11493	12377	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	101068	101068	\N
11493	12379	3	applied	\N	\N	\N	\N	101070	101070	268858
11493	12380	4	applied	\N	\N	\N	\N	101071	101071	268859
11493	12381	5	applied	\N	\N	\N	\N	101072	101072	268860
11493	12382	6	applied	\N	\N	\N	\N	101073	101073	268861
11493	12383	7	applied	\N	\N	\N	\N	101074	101074	268862
11495	12384	0	applied	\N	\N	\N	\N	101080	101080	268868
11495	12385	1	applied	\N	\N	\N	\N	101081	101081	268869
11495	12386	2	applied	\N	\N	\N	\N	101082	101082	268870
11495	12388	4	applied	\N	\N	\N	\N	101084	101084	268872
11507	12411	0	applied	\N	\N	\N	\N	101248	101248	269023
11507	12412	1	applied	\N	\N	\N	\N	101249	101249	269024
11512	12413	0	applied	\N	\N	\N	\N	101256	101256	269031
11512	12414	1	applied	\N	\N	\N	\N	101257	101257	269032
11514	12415	0	applied	\N	\N	\N	\N	101260	101260	269035
11514	12416	1	applied	\N	\N	\N	\N	101261	101261	269036
11516	12417	0	applied	\N	\N	\N	\N	101264	101264	269039
11516	12418	1	applied	\N	\N	\N	\N	101265	101265	269040
11527	12439	0	applied	\N	\N	\N	\N	101457	101457	269227
11527	12440	1	applied	\N	\N	\N	\N	101458	101458	269228
11527	12441	2	applied	\N	\N	\N	\N	101459	101459	269229
11527	12442	3	applied	\N	\N	\N	\N	101460	101460	269230
11527	12443	4	applied	\N	\N	\N	\N	101461	101461	269231
11532	12450	0	applied	\N	\N	\N	\N	101473	101473	269243
11532	12451	1	applied	\N	\N	\N	\N	101474	101474	269244
11535	12458	1	applied	\N	\N	\N	\N	101485	101485	269255
11535	12459	2	applied	\N	\N	1000000000	\N	101486	101486	269256
11535	12460	3	applied	\N	\N	1000000000	\N	101487	101487	269257
11539	12461	0	applied	\N	\N	\N	\N	101509	101509	269279
11539	12462	1	applied	\N	\N	\N	\N	101510	101510	269280
11539	12463	2	applied	\N	\N	\N	\N	101511	101511	269281
11539	12464	3	applied	\N	\N	\N	\N	101512	101512	269282
11539	12465	4	applied	\N	\N	\N	\N	101513	101513	269283
11539	12466	5	applied	\N	\N	\N	\N	101514	101514	269284
11539	12467	6	applied	\N	\N	\N	\N	101515	101515	269285
11544	12470	0	applied	\N	\N	\N	\N	101534	101534	269304
11544	12471	1	applied	\N	\N	\N	\N	101535	101535	269305
11546	12472	0	applied	\N	\N	\N	\N	101538	101538	269308
11546	12473	1	applied	\N	\N	\N	\N	101539	101539	269309
11551	12476	0	applied	\N	\N	\N	\N	101544	101544	269314
11554	12478	0	applied	\N	\N	\N	\N	101547	101547	269317
11556	12480	0	applied	\N	\N	\N	\N	101551	101551	269321
11560	12486	0	applied	\N	\N	\N	\N	101557	101557	269327
11560	12487	1	applied	\N	\N	\N	\N	101558	101558	269328
11565	12491	0	applied	\N	\N	\N	\N	101564	101564	269334
11567	12492	0	applied	\N	\N	\N	\N	101566	101566	269336
11572	12495	0	applied	\N	\N	\N	\N	101571	101571	269341
11577	12500	0	applied	\N	\N	\N	\N	101577	101577	269347
11577	12501	1	applied	\N	\N	\N	\N	101578	101578	269348
11580	12505	0	applied	\N	\N	\N	\N	101582	101582	269352
11587	12508	0	applied	\N	\N	\N	\N	101587	101587	269357
11592	12511	0	applied	\N	\N	\N	\N	101592	101592	269362
11598	12513	0	applied	\N	\N	\N	\N	101601	101601	269371
11598	12514	1	applied	\N	\N	\N	\N	101602	101602	269372
11599	12515	0	applied	\N	\N	\N	\N	101603	101603	269373
11599	12516	1	applied	\N	\N	\N	\N	101604	101604	269374
11441	12295	125	applied	\N	\N	\N	\N	100872	100872	268667
11451	12316	0	applied	\N	\N	\N	\N	100893	100893	268688
11456	11982	36	applied	\N	\N	\N	\N	100944	100944	268739
11456	11983	37	applied	\N	\N	\N	\N	100945	100945	268740
11456	11984	38	applied	\N	\N	\N	\N	100946	100946	268741
11456	11985	39	applied	\N	\N	\N	\N	100947	100947	268742
11456	11986	40	applied	\N	\N	\N	\N	100948	100948	268743
11456	11987	41	applied	\N	\N	\N	\N	100949	100949	268744
11456	11988	42	applied	\N	\N	\N	\N	100950	100950	268745
11456	11989	43	applied	\N	\N	\N	\N	100951	100951	268746
11456	11990	44	applied	\N	\N	\N	\N	100952	100952	268747
11456	11991	45	applied	\N	\N	\N	\N	100953	100953	268748
11456	11993	47	applied	\N	\N	\N	\N	100955	100955	268750
11456	11994	48	applied	\N	\N	\N	\N	100956	100956	268751
11456	11995	49	applied	\N	\N	\N	\N	100957	100957	268752
11456	11996	50	applied	\N	\N	\N	\N	100958	100958	268753
11456	11997	51	applied	\N	\N	\N	\N	100959	100959	268754
11456	11998	52	applied	\N	\N	\N	\N	100960	100960	268755
11456	12005	53	applied	\N	\N	\N	\N	100961	100961	268756
11456	12006	54	applied	\N	\N	\N	\N	100962	100962	268757
11456	12007	55	applied	\N	\N	\N	\N	100963	100963	268758
11456	12008	56	applied	\N	\N	\N	\N	100964	100964	268759
11456	12009	57	applied	\N	\N	\N	\N	100965	100965	268760
11456	12010	58	applied	\N	\N	\N	\N	100966	100966	268761
11456	12014	59	applied	\N	\N	\N	\N	100967	100967	268762
11456	12015	60	applied	\N	\N	\N	\N	100968	100968	268763
11456	12016	61	applied	\N	\N	\N	\N	100969	100969	268764
11456	12017	62	applied	\N	\N	\N	\N	100970	100970	268765
11456	12019	64	applied	\N	\N	\N	\N	100972	100972	268767
11458	12333	0	applied	\N	\N	\N	\N	100975	100975	268770
11458	12334	1	applied	\N	\N	\N	\N	100976	100976	268771
11465	12343	0	applied	\N	\N	\N	\N	100989	100989	268784
11465	12344	1	applied	\N	\N	\N	\N	100990	100990	268785
11473	12360	0	applied	\N	\N	\N	\N	101024	101024	101024
11473	12361	1	applied	\N	\N	\N	\N	101025	101025	268817
11473	12362	2	applied	\N	\N	\N	\N	101026	101026	268818
11478	12367	0	applied	\N	\N	\N	\N	101035	101035	268827
11478	12368	1	applied	\N	\N	\N	\N	101036	101036	268828
11478	12369	2	applied	\N	\N	\N	\N	101037	101037	268829
11478	12370	3	applied	\N	\N	\N	\N	101038	101038	268830
11480	12371	0	applied	\N	\N	\N	\N	101043	101043	268835
11480	12372	1	applied	\N	\N	\N	\N	101044	101044	268836
11482	12371	0	applied	\N	\N	\N	\N	101047	101047	268839
11482	12372	1	applied	\N	\N	\N	\N	101048	101048	268840
11489	12376	0	applied	\N	\N	\N	\N	101058	101058	268848
11494	12384	0	applied	\N	\N	\N	\N	101075	101075	268863
11494	12385	1	applied	\N	\N	\N	\N	101076	101076	268864
11494	12386	2	applied	\N	\N	\N	\N	101077	101077	268865
11494	12387	3	applied	\N	\N	\N	\N	101078	101078	268866
11494	12388	4	applied	\N	\N	\N	\N	101079	101079	268867
11496	12389	0	applied	\N	\N	\N	\N	101085	101085	268873
11496	12390	1	applied	\N	\N	\N	\N	101086	101086	268874
11498	12368	31	applied	\N	\N	\N	\N	101120	101120	268906
11498	12371	32	applied	\N	\N	\N	\N	101121	101121	268907
11498	12373	33	applied	\N	\N	\N	\N	101122	101122	268908
11498	12376	34	applied	\N	\N	\N	\N	101123	101123	268909
11498	12378	35	applied	\N	\N	\N	\N	101124	101124	268910
11498	12379	36	applied	\N	\N	\N	\N	101125	101125	268911
11498	12380	37	applied	\N	\N	\N	\N	101126	101126	268912
11498	12384	38	applied	\N	\N	\N	\N	101127	101127	268913
11498	12389	40	applied	\N	\N	\N	\N	101129	101129	268915
11498	12386	41	applied	\N	\N	\N	\N	101130	101130	268916
11498	12349	42	applied	\N	\N	\N	\N	101131	101131	268917
11498	12297	43	applied	\N	\N	\N	\N	101132	101132	268918
11498	12299	44	applied	\N	\N	\N	\N	101133	101133	268919
11498	12302	47	applied	\N	\N	\N	\N	101136	101136	268920
11498	12377	46	failed	Amount_insufficient_to_create_account	\N	\N	\N	101135	101135	\N
11498	12303	48	applied	\N	\N	\N	\N	101137	101137	268921
11498	12306	49	applied	\N	\N	\N	\N	101138	101138	268922
11498	12307	50	applied	\N	\N	\N	\N	101139	101139	268923
11501	12394	0	applied	\N	\N	\N	\N	101187	101187	268968
11501	12395	1	applied	\N	\N	\N	\N	101188	101188	268969
11501	12397	3	applied	\N	\N	\N	\N	101190	101190	268970
11501	12398	4	applied	\N	\N	\N	\N	101191	101191	101191
11501	12399	5	applied	\N	\N	\N	\N	101192	101192	268971
11503	12400	0	applied	\N	\N	\N	\N	101199	101199	268976
11503	12401	1	applied	\N	\N	\N	\N	101200	101200	268977
11503	12402	2	applied	\N	\N	\N	\N	101201	101201	268978
11506	12406	0	applied	\N	\N	\N	\N	101243	101243	269018
11506	12407	1	applied	\N	\N	\N	\N	101244	101244	269019
11506	12408	2	applied	\N	\N	\N	\N	101245	101245	269020
11506	12409	3	applied	\N	\N	\N	\N	101246	101246	269021
11506	12410	4	applied	\N	\N	\N	\N	101247	101247	269022
11522	12423	0	applied	\N	\N	\N	\N	101302	101302	269074
11522	12424	1	applied	\N	\N	\N	\N	101303	101303	269075
11523	12425	0	applied	\N	\N	\N	\N	101304	101304	269076
11523	12426	1	applied	\N	\N	\N	\N	101305	101305	269077
11523	12427	2	applied	\N	\N	\N	\N	101306	101306	269078
11523	12428	3	applied	\N	\N	\N	\N	101307	101307	269079
11523	12429	4	applied	\N	\N	\N	\N	101308	101308	269080
11523	12430	5	applied	\N	\N	\N	\N	101309	101309	269081
11523	12431	6	applied	\N	\N	\N	\N	101310	101310	269082
11523	12432	7	applied	\N	\N	\N	\N	101311	101311	269083
11531	12448	0	applied	\N	\N	\N	\N	101471	101471	269241
11531	12449	1	applied	\N	\N	\N	\N	101472	101472	269242
11537	12461	0	applied	\N	\N	\N	\N	101495	101495	269265
11537	12462	1	applied	\N	\N	\N	\N	101496	101496	269266
11537	12463	2	applied	\N	\N	\N	\N	101497	101497	269267
11537	12464	3	applied	\N	\N	\N	\N	101498	101498	269268
11537	12466	5	applied	\N	\N	\N	\N	101500	101500	269270
11537	12467	6	applied	\N	\N	\N	\N	101501	101501	269271
11541	12461	0	applied	\N	\N	\N	\N	101523	101523	269293
11541	12462	1	applied	\N	\N	\N	\N	101524	101524	269294
11541	12463	2	applied	\N	\N	\N	\N	101525	101525	269295
11541	12464	3	applied	\N	\N	\N	\N	101526	101526	269296
11541	12465	4	applied	\N	\N	\N	\N	101527	101527	269297
11541	12466	5	applied	\N	\N	\N	\N	101528	101528	269298
11541	12467	6	applied	\N	\N	\N	\N	101529	101529	269299
11550	12475	0	applied	\N	\N	\N	\N	101543	101543	269313
11558	12482	0	applied	\N	\N	\N	\N	101553	101553	269323
11456	11979	34	applied	\N	\N	\N	\N	100942	100942	268737
11456	11981	35	applied	\N	\N	\N	\N	100943	100943	268738
11498	12315	54	applied	\N	\N	\N	\N	101143	101143	268927
11498	12318	55	applied	\N	\N	\N	\N	101144	101144	268928
11498	12319	56	applied	\N	\N	\N	\N	101145	101145	268929
11498	12323	58	applied	\N	\N	\N	\N	101147	101147	268931
11498	12325	59	applied	\N	\N	\N	\N	101148	101148	268932
11498	12326	60	applied	\N	\N	1000000000	\N	101149	101149	268933
11498	12328	61	applied	\N	\N	\N	\N	101150	101150	268934
11498	12330	62	applied	\N	\N	\N	\N	101151	101151	268935
11498	12332	63	applied	\N	\N	\N	\N	101152	101152	268936
11498	12334	64	applied	\N	\N	\N	\N	101153	101153	268937
11498	12336	65	applied	\N	\N	\N	\N	101154	101154	268938
11498	12338	66	applied	\N	\N	\N	\N	101155	101155	268939
11498	12340	67	applied	\N	\N	\N	\N	101156	101156	268940
11498	12342	68	applied	\N	\N	\N	\N	101157	101157	268941
11498	12344	69	applied	\N	\N	\N	\N	101158	101158	268942
11498	12346	70	applied	\N	\N	\N	\N	101159	101159	268943
11498	12348	71	applied	\N	\N	\N	\N	101160	101160	268944
11498	12356	72	applied	\N	\N	\N	\N	101161	101161	268945
11498	12357	73	applied	\N	\N	\N	\N	101162	101162	268946
11498	12359	75	applied	\N	\N	\N	\N	101164	101164	268948
11498	12362	76	applied	\N	\N	\N	\N	101165	101165	268949
11498	12364	77	applied	\N	\N	\N	\N	101166	101166	268950
11498	12366	78	applied	\N	\N	\N	\N	101167	101167	268951
11498	12369	79	applied	\N	\N	\N	\N	101168	101168	268952
11498	12370	80	applied	\N	\N	\N	\N	101169	101169	268953
11498	12372	81	applied	\N	\N	\N	\N	101170	101170	268954
11498	12374	82	applied	\N	\N	\N	\N	101171	101171	268955
11498	12381	83	applied	\N	\N	\N	\N	101172	101172	268956
11498	12382	84	applied	\N	\N	\N	\N	101173	101173	268957
11498	12383	85	applied	\N	\N	\N	\N	101174	101174	268958
11498	12387	86	applied	\N	\N	\N	\N	101175	101175	268959
11498	12388	87	applied	\N	\N	\N	\N	101176	101176	268960
11498	12390	88	applied	\N	\N	\N	\N	101177	101177	268961
11500	12394	0	applied	\N	\N	\N	\N	101181	101181	268964
11500	12395	1	applied	\N	\N	\N	\N	101182	101182	268965
11500	12397	3	applied	\N	\N	\N	\N	101184	101184	268966
11500	12398	4	applied	\N	\N	\N	\N	101185	101185	101185
11500	12399	5	applied	\N	\N	\N	\N	101186	101186	268967
11504	12310	19	applied	\N	\N	\N	\N	101220	101220	268995
11504	12314	20	applied	\N	\N	\N	\N	101221	101221	268996
11504	12316	21	applied	\N	\N	\N	\N	101222	101222	268997
11504	12317	22	applied	\N	\N	\N	\N	101223	101223	268998
11504	12320	23	applied	\N	\N	\N	\N	101224	101224	268999
11504	12321	24	applied	\N	\N	\N	\N	101225	101225	269000
11504	12324	25	applied	\N	\N	\N	\N	101226	101226	269001
11504	12327	26	applied	\N	\N	\N	\N	101227	101227	269002
11504	12329	27	applied	\N	\N	\N	\N	101228	101228	269003
11504	12331	28	applied	\N	\N	\N	\N	101229	101229	269004
11504	12333	29	applied	\N	\N	\N	\N	101230	101230	269005
11504	12335	30	applied	\N	\N	\N	\N	101231	101231	269006
11504	12337	31	applied	\N	\N	\N	\N	101232	101232	269007
11504	12339	32	applied	\N	\N	\N	\N	101233	101233	269008
11504	12341	33	applied	\N	\N	\N	\N	101234	101234	269009
11504	12343	34	applied	\N	\N	\N	\N	101235	101235	269010
11504	12345	35	applied	\N	\N	\N	\N	101236	101236	269011
11504	12347	36	applied	\N	\N	\N	\N	101237	101237	269012
11504	12352	37	applied	\N	\N	\N	\N	101238	101238	269013
11504	12353	38	applied	\N	\N	\N	\N	101239	101239	269014
11505	12403	0	applied	\N	\N	\N	\N	101240	101240	269015
11505	12405	2	applied	\N	\N	\N	\N	101242	101242	269017
11508	12411	0	applied	\N	\N	\N	\N	101250	101250	269025
11508	12412	1	applied	\N	\N	\N	\N	101251	101251	269026
11509	12411	0	applied	\N	\N	\N	\N	101252	101252	269027
11515	12415	0	applied	\N	\N	\N	\N	101262	101262	269037
11515	12416	1	applied	\N	\N	\N	\N	101263	101263	269038
11517	12417	0	applied	\N	\N	\N	\N	101266	101266	269041
11517	12418	1	applied	\N	\N	\N	\N	101267	101267	269042
11521	12419	0	applied	\N	\N	\N	\N	101298	101298	269070
11521	12420	1	applied	\N	\N	\N	\N	101299	101299	269071
11521	12421	2	applied	\N	\N	\N	\N	101300	101300	269072
11521	12422	3	applied	\N	\N	\N	\N	101301	101301	269073
11525	11537	0	applied	\N	\N	\N	\N	101326	101326	269098
11525	11550	1	applied	\N	\N	\N	\N	101327	101327	269099
11525	11551	2	applied	\N	\N	\N	\N	101328	101328	269100
11525	11568	3	applied	\N	\N	\N	\N	101329	101329	269101
11525	11547	5	applied	\N	\N	\N	\N	101331	101331	269103
11525	11607	6	applied	\N	\N	\N	\N	101332	101332	101332
11525	11614	7	applied	\N	\N	\N	\N	101333	101333	269104
11525	11615	8	applied	\N	\N	\N	\N	101334	101334	269105
11525	11616	9	applied	\N	\N	\N	\N	101335	101335	269106
11525	11617	10	applied	\N	\N	\N	\N	101336	101336	269107
11525	11682	11	applied	\N	\N	\N	\N	101337	101337	269108
11525	12351	12	applied	\N	\N	\N	\N	101338	101338	269109
11525	11723	13	applied	\N	\N	\N	\N	101339	101339	269110
11525	11693	14	applied	\N	\N	\N	\N	101340	101340	269111
11525	12360	15	applied	\N	\N	\N	\N	101341	101341	101341
11525	11938	16	applied	\N	\N	\N	\N	101342	101342	269112
11525	11939	17	applied	\N	\N	\N	\N	101343	101343	269113
11525	11724	18	applied	\N	\N	\N	\N	101344	101344	269114
11525	11725	19	applied	\N	\N	\N	\N	101345	101345	269115
11525	12078	20	applied	\N	\N	\N	\N	101346	101346	269116
11525	11726	21	applied	\N	\N	\N	\N	101347	101347	269117
11525	11727	22	applied	\N	\N	\N	\N	101348	101348	269118
11525	12080	24	applied	\N	\N	\N	\N	101350	101350	269120
11525	11632	25	applied	\N	\N	1000000000	\N	101351	101351	269121
11525	11612	26	applied	\N	\N	\N	\N	101352	101352	269122
11525	11631	27	applied	\N	\N	\N	\N	101353	101353	269123
11525	11941	28	applied	\N	\N	\N	\N	101354	101354	269124
11525	11943	29	applied	\N	\N	\N	\N	101355	101355	269125
11525	11945	30	applied	\N	\N	\N	\N	101356	101356	269126
11525	12081	31	applied	\N	\N	\N	\N	101357	101357	269127
11525	12082	32	applied	\N	\N	\N	\N	101358	101358	269128
11525	11536	33	applied	\N	\N	\N	\N	101359	101359	269129
11525	11538	34	applied	\N	\N	\N	\N	101360	101360	269130
11525	11539	35	applied	\N	\N	\N	\N	101361	101361	269131
11525	11543	36	applied	\N	\N	\N	\N	101362	101362	269132
11525	11544	37	applied	\N	\N	\N	\N	101363	101363	269133
11525	11548	38	applied	\N	\N	\N	\N	101364	101364	269134
11525	11554	39	applied	\N	\N	\N	\N	101365	101365	269135
11498	12312	52	applied	\N	\N	\N	\N	101141	101141	268925
11498	12313	53	applied	\N	\N	\N	\N	101142	101142	268926
11513	12416	1	applied	\N	\N	\N	\N	101259	101259	269034
11518	12417	0	applied	\N	\N	\N	\N	101268	101268	269043
11518	12418	1	applied	\N	\N	\N	\N	101269	101269	269044
11520	12389	0	applied	\N	\N	\N	\N	101270	101270	269045
11520	12391	1	applied	\N	\N	\N	\N	101271	101271	269046
11520	12395	2	applied	\N	\N	\N	\N	101272	101272	269047
11520	12400	3	applied	\N	\N	\N	\N	101273	101273	269048
11520	12403	4	applied	\N	\N	\N	\N	101274	101274	269049
11520	12406	5	applied	\N	\N	\N	\N	101275	101275	269050
11520	12407	6	applied	\N	\N	\N	\N	101276	101276	269051
11520	12411	7	applied	\N	\N	\N	\N	101277	101277	269052
11520	12413	8	applied	\N	\N	\N	\N	101278	101278	269053
11520	12415	9	applied	\N	\N	\N	\N	101279	101279	269054
11520	12397	11	applied	\N	\N	\N	\N	101281	101281	269056
11520	12398	12	applied	\N	\N	\N	\N	101282	101282	101282
11520	12390	13	applied	\N	\N	\N	\N	101283	101283	269057
11520	12393	16	applied	\N	\N	\N	\N	101286	101286	269058
11520	12392	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	101284	101284	\N
11520	12396	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	101285	101285	\N
11520	12394	17	applied	\N	\N	\N	\N	101287	101287	269059
11520	12399	18	applied	\N	\N	\N	\N	101288	101288	269060
11520	12402	19	applied	\N	\N	\N	\N	101289	101289	269061
11520	12404	20	applied	\N	\N	\N	\N	101290	101290	269062
11520	12408	21	applied	\N	\N	\N	\N	101291	101291	269063
11520	12410	22	applied	\N	\N	\N	\N	101292	101292	269064
11520	12412	23	applied	\N	\N	\N	\N	101293	101293	269065
11520	12414	24	applied	\N	\N	\N	\N	101294	101294	269066
11520	12416	25	applied	\N	\N	\N	\N	101295	101295	269067
11520	12405	26	applied	\N	\N	\N	\N	101296	101296	269068
11524	12419	0	applied	\N	\N	\N	\N	101312	101312	269084
11524	12420	1	applied	\N	\N	\N	\N	101313	101313	269085
11524	12423	2	applied	\N	\N	\N	\N	101314	101314	269086
11524	12425	3	applied	\N	\N	\N	\N	101315	101315	269087
11524	12426	4	applied	\N	\N	\N	\N	101316	101316	269088
11524	12427	5	applied	\N	\N	\N	\N	101317	101317	269089
11524	12428	6	applied	\N	\N	\N	\N	101318	101318	269090
11524	12421	7	applied	\N	\N	\N	\N	101319	101319	269091
11524	12422	8	applied	\N	\N	\N	\N	101320	101320	269092
11524	12424	9	applied	\N	\N	\N	\N	101321	101321	269093
11524	12429	10	applied	\N	\N	\N	\N	101322	101322	269094
11524	12430	11	applied	\N	\N	\N	\N	101323	101323	269095
11524	12431	12	applied	\N	\N	\N	\N	101324	101324	269096
11524	12432	13	applied	\N	\N	\N	\N	101325	101325	269097
11525	11705	41	applied	\N	\N	\N	\N	101367	101367	269137
11525	11718	42	applied	\N	\N	\N	\N	101368	101368	269138
11525	11541	44	applied	\N	\N	\N	\N	101370	101370	269140
11525	11542	45	applied	\N	\N	\N	\N	101371	101371	269141
11525	11545	46	applied	\N	\N	\N	\N	101372	101372	269142
11525	11549	47	applied	\N	\N	\N	\N	101373	101373	269143
11525	11552	48	applied	\N	\N	\N	\N	101374	101374	269144
11525	11553	49	applied	\N	\N	\N	\N	101375	101375	269145
11525	11558	50	applied	\N	\N	\N	\N	101376	101376	269146
11525	11559	51	applied	\N	\N	\N	\N	101377	101377	269147
11525	11561	52	applied	\N	\N	\N	\N	101378	101378	269148
11525	11562	53	applied	\N	\N	\N	\N	101379	101379	269149
11525	11565	54	applied	\N	\N	\N	\N	101380	101380	269150
11525	11567	55	applied	\N	\N	\N	\N	101381	101381	269151
11525	11569	56	applied	\N	\N	\N	\N	101382	101382	269152
11525	11572	57	applied	\N	\N	\N	\N	101383	101383	269153
11525	11573	58	applied	\N	\N	\N	\N	101384	101384	269154
11525	11576	59	applied	\N	\N	\N	\N	101385	101385	269155
11525	11582	61	applied	\N	\N	\N	\N	101387	101387	269157
11526	12433	0	applied	\N	\N	\N	\N	101451	101451	269221
11526	12434	1	applied	\N	\N	\N	\N	101452	101452	269222
11526	12435	2	applied	\N	\N	\N	\N	101453	101453	269223
11526	12436	3	applied	\N	\N	\N	\N	101454	101454	269224
11526	12437	4	applied	\N	\N	\N	\N	101455	101455	269225
11526	12438	5	applied	\N	\N	\N	\N	101456	101456	269226
11529	12444	0	applied	\N	\N	\N	\N	101467	101467	269237
11529	12445	1	applied	\N	\N	\N	\N	101468	101468	269238
11534	12457	0	applied	\N	\N	\N	\N	101480	101480	269250
11534	12458	1	applied	\N	\N	\N	\N	101481	101481	269251
11534	12459	2	applied	\N	\N	1000000000	\N	101482	101482	269252
11534	12460	3	applied	\N	\N	1000000000	\N	101483	101483	269253
11538	12461	0	applied	\N	\N	\N	\N	101502	101502	269272
11538	12462	1	applied	\N	\N	\N	\N	101503	101503	269273
11538	12463	2	applied	\N	\N	\N	\N	101504	101504	269274
11538	12465	4	applied	\N	\N	\N	\N	101506	101506	269276
11538	12466	5	applied	\N	\N	\N	\N	101507	101507	269277
11538	12467	6	applied	\N	\N	\N	\N	101508	101508	269278
11543	12468	0	applied	\N	\N	\N	\N	101532	101532	269302
11543	12469	1	applied	\N	\N	\N	\N	101533	101533	269303
11548	12474	0	applied	\N	\N	\N	\N	101542	101542	269312
11553	12477	0	applied	\N	\N	\N	\N	101546	101546	269316
11559	12484	0	applied	\N	\N	\N	\N	101555	101555	269325
11559	12485	1	applied	\N	\N	\N	\N	101556	101556	269326
11562	12488	0	applied	\N	\N	\N	\N	101560	101560	269330
11569	12493	0	applied	\N	\N	\N	\N	101568	101568	269338
11574	12496	0	applied	\N	\N	\N	\N	101573	101573	269343
11584	12506	0	applied	\N	\N	\N	\N	101584	101584	269354
11591	12510	0	applied	\N	\N	\N	\N	101591	101591	269361
11594	12512	0	applied	\N	\N	\N	\N	101594	101594	269364
11597	12513	0	applied	\N	\N	\N	\N	101599	101599	269369
11604	12351	0	applied	\N	\N	\N	\N	101609	101609	269379
11604	12137	1	applied	\N	\N	\N	\N	101610	101610	269380
11604	12360	2	applied	\N	\N	\N	\N	101611	101611	101611
11604	12139	3	applied	\N	\N	\N	\N	101612	101612	269381
11604	12141	4	applied	\N	\N	\N	\N	101613	101613	269382
11604	12142	5	applied	\N	\N	\N	\N	101614	101614	269383
11604	12146	6	applied	\N	\N	\N	\N	101615	101615	269384
11604	12147	7	applied	\N	\N	\N	\N	101616	101616	269385
11604	12150	8	applied	\N	\N	\N	\N	101617	101617	269386
11604	12152	9	applied	\N	\N	\N	\N	101618	101618	269387
11604	12153	10	applied	\N	\N	\N	\N	101619	101619	269388
11604	12156	11	applied	\N	\N	\N	\N	101620	101620	269389
11604	12158	12	applied	\N	\N	\N	\N	101621	101621	269390
11604	12159	13	applied	\N	\N	\N	\N	101622	101622	269391
11604	12162	14	applied	\N	\N	\N	\N	101623	101623	269392
11511	12413	0	applied	\N	\N	\N	\N	101254	101254	269029
11513	12415	0	applied	\N	\N	\N	\N	101258	101258	269033
11525	11592	66	applied	\N	\N	\N	\N	101392	101392	269162
11525	11593	67	applied	\N	\N	\N	\N	101393	101393	269163
11525	11596	68	applied	\N	\N	\N	\N	101394	101394	269164
11525	11597	69	applied	\N	\N	\N	\N	101395	101395	269165
11525	11598	70	applied	\N	\N	\N	\N	101396	101396	269166
11525	11601	71	applied	\N	\N	\N	\N	101397	101397	269167
11525	11603	72	applied	\N	\N	\N	\N	101398	101398	269168
11525	11605	73	applied	\N	\N	\N	\N	101399	101399	269169
11525	11608	74	applied	\N	\N	\N	\N	101400	101400	269170
11525	11611	75	applied	\N	\N	\N	\N	101401	101401	269171
11525	11613	76	applied	\N	\N	\N	\N	101402	101402	269172
11525	11619	77	applied	\N	\N	\N	\N	101403	101403	269173
11525	11621	78	applied	\N	\N	\N	\N	101404	101404	269174
11525	11623	79	applied	\N	\N	\N	\N	101405	101405	269175
11525	11625	80	applied	\N	\N	\N	\N	101406	101406	269176
11525	11626	81	applied	\N	\N	\N	\N	101407	101407	269177
11525	11634	83	applied	\N	\N	\N	\N	101409	101409	269179
11525	11635	84	applied	\N	\N	\N	\N	101410	101410	269180
11525	11636	85	applied	\N	\N	\N	\N	101411	101411	269181
11525	11640	86	applied	\N	\N	\N	\N	101412	101412	269182
11525	11643	87	applied	\N	\N	\N	\N	101413	101413	269183
11525	11644	88	applied	\N	\N	\N	\N	101414	101414	269184
11525	11646	89	applied	\N	\N	\N	\N	101415	101415	269185
11525	11648	90	applied	\N	\N	\N	\N	101416	101416	269186
11525	11650	91	applied	\N	\N	\N	\N	101417	101417	269187
11525	11652	92	applied	\N	\N	\N	\N	101418	101418	269188
11525	11655	93	applied	\N	\N	\N	\N	101419	101419	269189
11525	11656	94	applied	\N	\N	\N	\N	101420	101420	269190
11525	11555	95	applied	\N	\N	\N	\N	101421	101421	269191
11525	11557	96	applied	\N	\N	\N	\N	101422	101422	269192
11525	11560	97	applied	\N	\N	\N	\N	101423	101423	269193
11525	11563	99	applied	\N	\N	\N	\N	101424	101424	269194
11525	11566	101	applied	\N	\N	\N	\N	101426	101426	269196
11525	11570	102	applied	\N	\N	\N	\N	101427	101427	269197
11525	11571	103	applied	\N	\N	\N	\N	101428	101428	269198
11525	11574	104	applied	\N	\N	\N	\N	101429	101429	269199
11525	11577	105	applied	\N	\N	\N	\N	101430	101430	269200
11525	11579	106	applied	\N	\N	\N	\N	101431	101431	269201
11525	11580	107	applied	\N	\N	\N	\N	101432	101432	269202
11525	11581	108	applied	\N	\N	\N	\N	101433	101433	269203
11525	11585	109	applied	\N	\N	\N	\N	101434	101434	269204
11525	11586	110	applied	\N	\N	\N	\N	101435	101435	269205
11525	11587	111	applied	\N	\N	\N	\N	101436	101436	269206
11525	11590	112	applied	\N	\N	\N	\N	101437	101437	269207
11525	11591	113	applied	\N	\N	\N	\N	101438	101438	269208
11525	11594	114	applied	\N	\N	\N	\N	101439	101439	269209
11525	11595	115	applied	\N	\N	\N	\N	101440	101440	269210
11525	11599	116	applied	\N	\N	\N	\N	101441	101441	269211
11525	11602	118	applied	\N	\N	\N	\N	101443	101443	269213
11525	11604	119	applied	\N	\N	\N	\N	101444	101444	269214
11525	11606	120	applied	\N	\N	\N	\N	101445	101445	269215
11525	11609	121	applied	\N	\N	\N	\N	101446	101446	269216
11525	11610	122	applied	\N	\N	\N	\N	101447	101447	269217
11525	11618	123	applied	\N	\N	\N	\N	101448	101448	269218
11525	11620	124	applied	\N	\N	\N	\N	101449	101449	269219
11525	11622	125	applied	\N	\N	\N	\N	101450	101450	269220
11528	12439	0	applied	\N	\N	\N	\N	101462	101462	269232
11528	12440	1	applied	\N	\N	\N	\N	101463	101463	269233
11528	12441	2	applied	\N	\N	\N	\N	101464	101464	269234
11528	12442	3	applied	\N	\N	\N	\N	101465	101465	269235
11528	12443	4	applied	\N	\N	\N	\N	101466	101466	269236
11530	12446	0	applied	\N	\N	\N	\N	101469	101469	269239
11530	12447	1	applied	\N	\N	\N	\N	101470	101470	269240
11533	12452	0	applied	\N	\N	\N	\N	101475	101475	269245
11533	12454	2	applied	\N	\N	\N	\N	101477	101477	269247
11533	12455	3	applied	\N	\N	\N	\N	101478	101478	269248
11533	12456	4	applied	\N	\N	\N	\N	101479	101479	269249
11536	12461	0	applied	\N	\N	\N	\N	101488	101488	269258
11536	12462	1	applied	\N	\N	\N	\N	101489	101489	269259
11536	12463	2	applied	\N	\N	\N	\N	101490	101490	269260
11536	12464	3	applied	\N	\N	\N	\N	101491	101491	269261
11536	12465	4	applied	\N	\N	\N	\N	101492	101492	269262
11536	12466	5	applied	\N	\N	\N	\N	101493	101493	269263
11536	12467	6	applied	\N	\N	\N	\N	101494	101494	269264
11540	12461	0	applied	\N	\N	\N	\N	101516	101516	269286
11540	12462	1	applied	\N	\N	\N	\N	101517	101517	269287
11540	12463	2	applied	\N	\N	\N	\N	101518	101518	269288
11540	12464	3	applied	\N	\N	\N	\N	101519	101519	269289
11540	12465	4	applied	\N	\N	\N	\N	101520	101520	269290
11540	12466	5	applied	\N	\N	\N	\N	101521	101521	269291
11542	12468	0	applied	\N	\N	\N	\N	101530	101530	269300
11542	12469	1	applied	\N	\N	\N	\N	101531	101531	269301
11545	12470	0	applied	\N	\N	\N	\N	101536	101536	269306
11545	12471	1	applied	\N	\N	\N	\N	101537	101537	269307
11547	12472	0	applied	\N	\N	\N	\N	101540	101540	269310
11547	12473	1	applied	\N	\N	\N	\N	101541	101541	269311
11552	12476	0	applied	\N	\N	\N	\N	101545	101545	269315
11555	12478	0	applied	\N	\N	\N	\N	101549	101549	269319
11555	12479	1	applied	\N	\N	\N	\N	101550	101550	269320
11557	12481	0	applied	\N	\N	\N	\N	101552	101552	269322
11558	12483	1	applied	\N	\N	\N	\N	101554	101554	269324
11561	12488	0	applied	\N	\N	\N	\N	101559	101559	269329
11563	12489	0	applied	\N	\N	\N	\N	101561	101561	269331
11563	12490	1	applied	\N	\N	\N	\N	101562	101562	269332
11564	12491	0	applied	\N	\N	\N	\N	101563	101563	269333
11566	12491	0	applied	\N	\N	\N	\N	101565	101565	269335
11570	12494	0	applied	\N	\N	\N	\N	101569	101569	269339
11571	12494	0	applied	\N	\N	\N	\N	101570	101570	269340
11573	12496	0	applied	\N	\N	\N	\N	101572	101572	269342
11575	12497	0	applied	\N	\N	\N	\N	101574	101574	269344
11576	12498	0	applied	\N	\N	\N	\N	101575	101575	269345
11576	12499	1	applied	\N	\N	\N	\N	101576	101576	269346
11579	12504	0	applied	\N	\N	\N	\N	101581	101581	269351
11586	12507	0	applied	\N	\N	\N	\N	101586	101586	269356
11589	12509	0	applied	\N	\N	\N	\N	101589	101589	269359
11593	12512	0	applied	\N	\N	\N	\N	101593	101593	269363
11596	12513	0	applied	\N	\N	\N	\N	101597	101597	269367
11596	12514	1	applied	\N	\N	\N	\N	101598	101598	269368
11601	12517	0	applied	\N	\N	\N	\N	101607	101607	269377
11601	12518	1	applied	\N	\N	\N	\N	101608	101608	269378
11525	11584	63	applied	\N	\N	\N	\N	101389	101389	269159
11525	11588	64	applied	\N	\N	\N	\N	101390	101390	269160
11588	12509	0	applied	\N	\N	\N	\N	101588	101588	269358
11590	12510	0	applied	\N	\N	\N	\N	101590	101590	269360
11595	12513	0	applied	\N	\N	\N	\N	101595	101595	269365
11595	12514	1	applied	\N	\N	\N	\N	101596	101596	269366
11600	12515	0	applied	\N	\N	\N	\N	101605	101605	269375
11600	12516	1	applied	\N	\N	\N	\N	101606	101606	269376
11604	12163	15	applied	\N	\N	\N	\N	101624	101624	269393
11604	12164	16	applied	\N	\N	\N	\N	101625	101625	269394
11604	12168	17	applied	\N	\N	\N	\N	101626	101626	269395
11604	12170	18	applied	\N	\N	\N	\N	101627	101627	269396
11604	12171	19	applied	\N	\N	\N	\N	101628	101628	269397
11604	12174	20	applied	\N	\N	\N	\N	101629	101629	269398
11604	12177	21	applied	\N	\N	\N	\N	101630	101630	269399
11604	12179	22	applied	\N	\N	\N	\N	101631	101631	269400
11604	12181	23	applied	\N	\N	\N	\N	101632	101632	269401
11604	12182	24	applied	\N	\N	\N	\N	101633	101633	269402
11604	12184	26	applied	\N	\N	\N	\N	101635	101635	269404
11604	12185	27	applied	\N	\N	\N	\N	101636	101636	269405
11604	12186	28	applied	\N	\N	\N	\N	101637	101637	269406
11604	12192	29	applied	\N	\N	\N	\N	101638	101638	269407
11604	12194	30	applied	\N	\N	\N	\N	101639	101639	269408
11604	12196	31	applied	\N	\N	\N	\N	101640	101640	269409
11604	12197	33	applied	\N	\N	\N	\N	101641	101641	269410
11604	12200	34	applied	\N	\N	\N	\N	101642	101642	269411
11604	12202	35	applied	\N	\N	\N	\N	101643	101643	269412
11604	12203	36	applied	\N	\N	\N	\N	101644	101644	269413
11604	12204	37	applied	\N	\N	\N	\N	101645	101645	269414
11604	12208	38	applied	\N	\N	\N	\N	101646	101646	269415
11604	12210	39	applied	\N	\N	\N	\N	101647	101647	269416
11604	12212	40	applied	\N	\N	\N	\N	101648	101648	269417
11604	12213	41	applied	\N	\N	\N	\N	101649	101649	269418
11604	12216	42	applied	\N	\N	\N	\N	101650	101650	269419
11604	12220	44	applied	\N	\N	\N	\N	101652	101652	269421
11604	12221	45	applied	\N	\N	\N	\N	101653	101653	269422
11604	12224	46	applied	\N	\N	\N	\N	101654	101654	269423
11604	12226	47	applied	\N	\N	\N	\N	101655	101655	269424
11604	12228	48	applied	\N	\N	\N	\N	101656	101656	269425
11604	12231	49	applied	\N	\N	\N	\N	101657	101657	269426
11604	12232	50	applied	\N	\N	\N	\N	101658	101658	269427
11604	12235	51	applied	\N	\N	\N	\N	101659	101659	269428
11604	12237	52	applied	\N	\N	\N	\N	101660	101660	269429
11604	12239	53	applied	\N	\N	\N	\N	101661	101661	269430
11604	12240	54	applied	\N	\N	\N	\N	101662	101662	269431
11604	12242	55	applied	\N	\N	\N	\N	101663	101663	269432
11604	12243	56	applied	\N	\N	\N	\N	101664	101664	269433
11604	12246	57	applied	\N	\N	\N	\N	101665	101665	269434
11604	12248	58	applied	\N	\N	\N	\N	101666	101666	269435
11604	12250	59	applied	\N	\N	\N	\N	101667	101667	269436
11604	12254	61	applied	\N	\N	\N	\N	101669	101669	269438
11604	12255	62	applied	\N	\N	\N	\N	101670	101670	269439
11604	12258	63	applied	\N	\N	\N	\N	101671	101671	269440
11604	12259	64	applied	\N	\N	\N	\N	101672	101672	269441
11604	12262	65	applied	\N	\N	\N	\N	101673	101673	269442
11604	12265	66	applied	\N	\N	\N	\N	101674	101674	269443
11604	12268	67	applied	\N	\N	\N	\N	101675	101675	269444
11604	12270	68	applied	\N	\N	\N	\N	101676	101676	269445
11604	12272	69	applied	\N	\N	\N	\N	101677	101677	269446
11604	12274	70	applied	\N	\N	\N	\N	101678	101678	269447
11604	12275	71	applied	\N	\N	\N	\N	101679	101679	269448
11604	12278	72	applied	\N	\N	\N	\N	101680	101680	269449
11604	12280	73	applied	\N	\N	\N	\N	101681	101681	269450
11604	12282	74	applied	\N	\N	\N	\N	101682	101682	269451
11604	12283	75	applied	\N	\N	\N	\N	101683	101683	269452
11604	12284	76	applied	\N	\N	\N	\N	101684	101684	269453
11604	12289	78	applied	\N	\N	\N	\N	101686	101686	269455
11604	12290	79	applied	\N	\N	\N	\N	101687	101687	269456
11604	12293	80	applied	\N	\N	\N	\N	101688	101688	269457
11604	12296	81	applied	\N	\N	\N	\N	101689	101689	269458
11604	12298	82	applied	\N	\N	\N	\N	101690	101690	269459
11604	12300	83	applied	\N	\N	\N	\N	101691	101691	269460
11604	12301	84	applied	\N	\N	\N	\N	101692	101692	269461
11604	12304	85	applied	\N	\N	\N	\N	101693	101693	269462
11604	12305	86	applied	\N	\N	\N	\N	101694	101694	269463
11604	12308	87	applied	\N	\N	\N	\N	101695	101695	269464
11604	12309	88	applied	\N	\N	\N	\N	101696	101696	269465
11604	12310	89	applied	\N	\N	\N	\N	101697	101697	269466
11604	12314	90	applied	\N	\N	\N	\N	101698	101698	269467
11604	12316	91	applied	\N	\N	\N	\N	101699	101699	269468
11604	12317	92	applied	\N	\N	\N	\N	101700	101700	269469
11604	12320	93	applied	\N	\N	\N	\N	101701	101701	269470
11604	12324	95	applied	\N	\N	\N	\N	101703	101703	269472
11604	12327	96	applied	\N	\N	\N	\N	101704	101704	269473
11604	12329	97	applied	\N	\N	\N	\N	101705	101705	269474
11604	12331	98	applied	\N	\N	\N	\N	101706	101706	269475
11604	12333	99	applied	\N	\N	\N	\N	101707	101707	269476
11604	12335	100	applied	\N	\N	\N	\N	101708	101708	269477
11604	12337	101	applied	\N	\N	\N	\N	101709	101709	269478
11604	12339	102	applied	\N	\N	\N	\N	101710	101710	269479
11604	12341	103	applied	\N	\N	\N	\N	101711	101711	269480
11604	12343	104	applied	\N	\N	\N	\N	101712	101712	269481
11604	12345	105	applied	\N	\N	\N	\N	101713	101713	269482
11604	12347	106	applied	\N	\N	\N	\N	101714	101714	269483
11604	12352	107	applied	\N	\N	\N	\N	101715	101715	269484
11604	12353	108	applied	\N	\N	\N	\N	101716	101716	269485
11604	12354	109	applied	\N	\N	\N	\N	101717	101717	269486
11604	12355	110	applied	\N	\N	\N	\N	101718	101718	269487
11604	12363	112	applied	\N	\N	\N	\N	101720	101720	269489
11604	12365	113	applied	\N	\N	\N	\N	101721	101721	269490
11604	12367	114	applied	\N	\N	\N	\N	101722	101722	269491
11604	12368	115	applied	\N	\N	\N	\N	101723	101723	269492
11604	12371	116	applied	\N	\N	\N	\N	101724	101724	269493
11604	12373	117	applied	\N	\N	\N	\N	101725	101725	269494
11604	12376	118	applied	\N	\N	\N	\N	101726	101726	269495
11604	12378	119	applied	\N	\N	\N	\N	101727	101727	269496
11604	12379	120	applied	\N	\N	\N	\N	101728	101728	269497
11604	12380	121	applied	\N	\N	\N	\N	101729	101729	269498
11604	12384	122	applied	\N	\N	\N	\N	101730	101730	269499
11604	12385	123	applied	\N	\N	\N	\N	101731	101731	269500
11604	12389	124	applied	\N	\N	\N	\N	101732	101732	269501
11605	12519	0	applied	\N	\N	\N	\N	101733	101733	269502
11578	12503	1	applied	\N	\N	\N	\N	101580	101580	269350
11581	12505	0	applied	\N	\N	\N	\N	101583	101583	269353
11607	12524	0	applied	\N	\N	\N	\N	101738	101738	269507
11607	12525	1	applied	\N	\N	\N	\N	101739	101739	269508
11608	12524	0	applied	\N	\N	\N	\N	101740	101740	269509
11608	12525	1	applied	\N	\N	\N	\N	101741	101741	269510
11609	12526	0	applied	\N	\N	\N	\N	101742	101742	269511
11609	12527	1	applied	\N	\N	\N	\N	101743	101743	269512
11609	12528	2	applied	\N	\N	\N	\N	101744	101744	269513
11613	12461	0	applied	\N	\N	\N	\N	101751	101751	269520
11613	12462	1	applied	\N	\N	\N	\N	101752	101752	269521
11613	12463	2	applied	\N	\N	\N	\N	101753	101753	269522
11613	12464	3	applied	\N	\N	\N	\N	101754	101754	269523
11613	12468	4	applied	\N	\N	\N	\N	101755	101755	269524
11613	12470	5	applied	\N	\N	\N	\N	101756	101756	269525
11613	12472	6	applied	\N	\N	\N	\N	101757	101757	269526
11613	12465	7	applied	\N	\N	\N	\N	101758	101758	269527
11613	12466	8	applied	\N	\N	\N	\N	101759	101759	269528
11613	12469	10	applied	\N	\N	\N	\N	101761	101761	269530
11613	12471	11	applied	\N	\N	\N	\N	101762	101762	269531
11613	12473	12	applied	\N	\N	\N	\N	101763	101763	269532
11613	12474	13	applied	\N	\N	\N	\N	101764	101764	269533
11613	12475	14	applied	\N	\N	\N	\N	101765	101765	269534
11613	12476	15	applied	\N	\N	\N	\N	101766	101766	269535
11613	12477	16	applied	\N	\N	\N	\N	101767	101767	269536
11613	12478	17	applied	\N	\N	\N	\N	101768	101768	269537
11613	12479	18	applied	\N	\N	\N	\N	101769	101769	269538
11613	12480	19	applied	\N	\N	\N	\N	101770	101770	269539
11613	12481	20	applied	\N	\N	\N	\N	101771	101771	269540
11613	12482	21	applied	\N	\N	\N	\N	101772	101772	269541
11613	12483	22	applied	\N	\N	\N	\N	101773	101773	269542
11613	12484	23	applied	\N	\N	\N	\N	101774	101774	269543
11613	12485	24	applied	\N	\N	\N	\N	101775	101775	269544
11613	12486	25	applied	\N	\N	\N	\N	101776	101776	269545
11613	12488	27	applied	\N	\N	\N	\N	101778	101778	269547
11613	12489	28	applied	\N	\N	\N	\N	101779	101779	269548
11613	12490	29	applied	\N	\N	\N	\N	101780	101780	269549
11613	12491	30	applied	\N	\N	\N	\N	101781	101781	269550
11613	12492	31	applied	\N	\N	\N	\N	101782	101782	269551
11613	12493	32	applied	\N	\N	\N	\N	101783	101783	269552
11613	12494	33	applied	\N	\N	\N	\N	101784	101784	269553
11613	12495	34	applied	\N	\N	\N	\N	101785	101785	269554
11613	12496	35	applied	\N	\N	\N	\N	101786	101786	269555
11613	12497	36	applied	\N	\N	\N	\N	101787	101787	269556
11613	12498	37	applied	\N	\N	\N	\N	101788	101788	269557
11613	12499	38	applied	\N	\N	\N	\N	101789	101789	269558
11613	12500	39	applied	\N	\N	\N	\N	101790	101790	269559
11613	12502	40	applied	\N	\N	\N	\N	101791	101791	269560
11613	12503	41	applied	\N	\N	\N	\N	101792	101792	269561
11613	12504	42	applied	\N	\N	\N	\N	101793	101793	269562
11613	12506	44	applied	\N	\N	\N	\N	101795	101795	269564
11613	12507	45	applied	\N	\N	\N	\N	101796	101796	269565
11613	12508	46	applied	\N	\N	\N	\N	101797	101797	269566
11613	12509	47	applied	\N	\N	\N	\N	101798	101798	269567
11613	12510	48	applied	\N	\N	\N	\N	101799	101799	269568
11613	12511	49	applied	\N	\N	\N	\N	101800	101800	269569
11613	12512	50	applied	\N	\N	\N	\N	101801	101801	269570
11613	12513	51	applied	\N	\N	\N	\N	101802	101802	269571
11613	12514	52	applied	\N	\N	\N	\N	101803	101803	269572
11613	12515	53	applied	\N	\N	\N	\N	101804	101804	269573
11613	12516	54	applied	\N	\N	\N	\N	101805	101805	269574
11613	12517	55	applied	\N	\N	\N	\N	101806	101806	269575
11613	12518	56	applied	\N	\N	\N	\N	101807	101807	269576
11613	12519	57	applied	\N	\N	\N	\N	101808	101808	269577
11613	12520	58	applied	\N	\N	\N	\N	101809	101809	269578
11613	12521	59	applied	\N	\N	\N	\N	101810	101810	269579
11613	12523	61	applied	\N	\N	\N	\N	101812	101812	269581
11613	12524	62	applied	\N	\N	\N	\N	101813	101813	269582
11613	12525	63	applied	\N	\N	\N	\N	101814	101814	269583
11613	12526	64	applied	\N	\N	\N	\N	101815	101815	269584
11613	12527	65	applied	\N	\N	\N	\N	101816	101816	269585
11613	12528	66	applied	\N	\N	\N	\N	101817	101817	269586
11613	12529	67	applied	\N	\N	\N	\N	101818	101818	269587
11613	12530	68	applied	\N	\N	\N	\N	101819	101819	269588
11613	12531	69	applied	\N	\N	\N	\N	101820	101820	269589
11613	12532	70	applied	\N	\N	\N	\N	101821	101821	269590
11613	12533	71	applied	\N	\N	\N	\N	101822	101822	269591
11613	12534	72	applied	\N	\N	\N	\N	101823	101823	269592
11617	12537	0	applied	\N	\N	\N	\N	101827	101827	269596
11620	12541	0	applied	\N	\N	\N	\N	101833	101833	269602
11623	12542	0	applied	\N	\N	\N	\N	101835	101835	269604
11623	12543	1	applied	\N	\N	\N	\N	101836	101836	269605
11627	12551	0	applied	\N	\N	\N	\N	101848	101848	269617
11639	12558	0	applied	\N	\N	\N	\N	101975	101975	269744
11645	12561	0	applied	\N	\N	\N	\N	101982	101982	269751
11650	12562	0	applied	\N	\N	\N	\N	101990	101990	269759
11650	12563	1	applied	\N	\N	\N	\N	101991	101991	269760
11655	12564	0	applied	\N	\N	\N	\N	101998	101998	269767
11662	12567	0	applied	\N	\N	\N	\N	102004	102004	269773
11666	12573	0	applied	\N	\N	\N	\N	102012	102012	269781
11669	12573	0	applied	\N	\N	\N	\N	102015	102015	269784
11672	12573	0	applied	\N	\N	\N	\N	102018	102018	269787
11678	12578	0	applied	\N	\N	\N	\N	102024	102024	269793
11680	12579	0	applied	\N	\N	\N	\N	102026	102026	269795
11680	12580	1	applied	\N	\N	\N	\N	102027	102027	269796
11680	12581	2	applied	\N	\N	\N	\N	102028	102028	269797
11685	12584	0	applied	\N	\N	\N	\N	102058	102058	269827
11685	12585	1	applied	\N	\N	\N	\N	102059	102059	269828
11685	12587	3	applied	\N	\N	\N	\N	102061	102061	269830
11685	12588	4	applied	\N	\N	\N	\N	102062	102062	269831
11685	12589	5	applied	\N	\N	\N	\N	102063	102063	269832
11685	12590	6	applied	\N	\N	\N	\N	102064	102064	269833
11685	12591	7	applied	\N	\N	\N	\N	102065	102065	269834
11685	12592	8	applied	\N	\N	\N	\N	102066	102066	269835
11686	12593	0	applied	\N	\N	\N	\N	102067	102067	269836
11686	12594	1	applied	\N	\N	\N	\N	102068	102068	269837
11693	12597	0	applied	\N	\N	\N	\N	102076	102076	269845
11696	12599	0	applied	\N	\N	\N	\N	102080	102080	269849
11696	12600	1	applied	\N	\N	\N	\N	102081	102081	269850
11698	12602	0	applied	\N	\N	\N	\N	102083	102083	269852
11701	12603	0	applied	\N	\N	\N	\N	102086	102086	269855
11703	12605	0	applied	\N	\N	\N	\N	102088	102088	269857
11605	12521	2	applied	\N	\N	\N	\N	101735	101735	269504
11606	12522	0	applied	\N	\N	\N	\N	101736	101736	269505
11611	12532	2	applied	\N	\N	\N	\N	101748	101748	269517
11612	12533	0	applied	\N	\N	\N	\N	101749	101749	269518
11612	12534	1	applied	\N	\N	\N	\N	101750	101750	269519
11614	12535	0	applied	\N	\N	\N	\N	101824	101824	269593
11616	12536	0	applied	\N	\N	\N	\N	101826	101826	269595
11619	12538	0	applied	\N	\N	\N	\N	101830	101830	269599
11619	12539	1	applied	\N	\N	\N	\N	101831	101831	269600
11619	12540	2	applied	\N	\N	\N	\N	101832	101832	269601
11624	12542	0	applied	\N	\N	\N	\N	101838	101838	269607
11624	12543	1	applied	\N	\N	\N	\N	101839	101839	269608
11624	12544	2	applied	\N	\N	\N	\N	101840	101840	269609
11625	11243	0	applied	\N	\N	\N	\N	101841	101841	269610
11625	12545	1	applied	\N	\N	\N	\N	101842	101842	269611
11625	12547	3	applied	\N	\N	\N	\N	101844	101844	269613
11625	12548	4	applied	\N	\N	\N	\N	101845	101845	269614
11626	12549	0	applied	\N	\N	\N	\N	101846	101846	269615
11626	12550	1	applied	\N	\N	\N	\N	101847	101847	269616
11628	12551	0	applied	\N	\N	\N	\N	101849	101849	269618
11629	12551	0	applied	\N	\N	\N	\N	101850	101850	269619
11630	12552	0	applied	\N	\N	\N	\N	101851	101851	269620
11631	12552	0	applied	\N	\N	\N	\N	101852	101852	269621
11634	12461	0	applied	\N	\N	\N	\N	101855	101855	269624
11634	12417	1	applied	\N	\N	\N	\N	101856	101856	269625
11634	12419	2	applied	\N	\N	\N	\N	101857	101857	269626
11634	12420	3	applied	\N	\N	\N	\N	101858	101858	269627
11634	12423	4	applied	\N	\N	\N	\N	101859	101859	269628
11634	12425	5	applied	\N	\N	\N	\N	101860	101860	269629
11634	12426	6	applied	\N	\N	\N	\N	101861	101861	269630
11634	12427	7	applied	\N	\N	\N	\N	101862	101862	269631
11634	12433	9	applied	\N	\N	\N	\N	101864	101864	269633
11634	12434	10	applied	\N	\N	\N	\N	101865	101865	269634
11634	12435	11	applied	\N	\N	\N	\N	101866	101866	269635
11634	12439	12	applied	\N	\N	\N	\N	101867	101867	269636
11634	12440	13	applied	\N	\N	\N	\N	101868	101868	269637
11634	12444	14	applied	\N	\N	\N	\N	101869	101869	269638
11634	12446	15	applied	\N	\N	\N	\N	101870	101870	269639
11634	12448	16	applied	\N	\N	\N	\N	101871	101871	269640
11634	12450	17	applied	\N	\N	\N	\N	101872	101872	269641
11634	12452	18	applied	\N	\N	\N	\N	101873	101873	269642
11634	12457	19	applied	\N	\N	\N	\N	101874	101874	269643
11634	12462	20	applied	\N	\N	\N	\N	101875	101875	269644
11634	12463	21	applied	\N	\N	\N	\N	101876	101876	269645
11634	12464	22	applied	\N	\N	\N	\N	101877	101877	269646
11634	12468	23	applied	\N	\N	\N	\N	101878	101878	269647
11634	12470	24	applied	\N	\N	\N	\N	101879	101879	269648
11634	12418	26	applied	\N	\N	\N	\N	101881	101881	269650
11634	12421	27	applied	\N	\N	\N	\N	101882	101882	269651
11634	12422	28	applied	\N	\N	\N	\N	101883	101883	269652
11634	12424	29	applied	\N	\N	\N	\N	101884	101884	269653
11634	12429	30	applied	\N	\N	\N	\N	101885	101885	269654
11634	12443	31	applied	\N	\N	\N	\N	101886	101886	269655
11634	12454	32	applied	\N	\N	\N	\N	101887	101887	269656
11634	12455	33	applied	\N	\N	\N	\N	101888	101888	269657
11634	12456	34	applied	\N	\N	\N	\N	101889	101889	269658
11634	12430	35	applied	\N	\N	\N	\N	101890	101890	269659
11634	12431	36	applied	\N	\N	\N	\N	101891	101891	269660
11634	12432	37	applied	\N	\N	\N	\N	101892	101892	269661
11634	12436	38	applied	\N	\N	\N	\N	101893	101893	269662
11634	12437	39	applied	\N	\N	\N	\N	101894	101894	269663
11634	12438	40	applied	\N	\N	\N	\N	101895	101895	269664
11634	12441	41	applied	\N	\N	\N	\N	101896	101896	269665
11634	12445	43	applied	\N	\N	\N	\N	101898	101898	269667
11634	12447	44	applied	\N	\N	\N	\N	101899	101899	269668
11634	12449	45	applied	\N	\N	\N	\N	101900	101900	269669
11634	12451	46	applied	\N	\N	\N	\N	101901	101901	269670
11634	12453	47	applied	\N	\N	\N	\N	101902	101902	269671
11634	12458	48	applied	\N	\N	\N	\N	101903	101903	269672
11634	12459	49	applied	\N	\N	1000000000	\N	101904	101904	269673
11634	12460	50	applied	\N	\N	1000000000	\N	101905	101905	269674
11634	12465	51	applied	\N	\N	\N	\N	101906	101906	269675
11634	12466	52	applied	\N	\N	\N	\N	101907	101907	269676
11634	12467	53	applied	\N	\N	\N	\N	101908	101908	269677
11634	12469	54	applied	\N	\N	\N	\N	101909	101909	269678
11634	12471	55	applied	\N	\N	\N	\N	101910	101910	269679
11634	12473	56	applied	\N	\N	\N	\N	101911	101911	269680
11634	12474	57	applied	\N	\N	\N	\N	101912	101912	269681
11634	12475	58	applied	\N	\N	\N	\N	101913	101913	269682
11634	12477	60	applied	\N	\N	\N	\N	101915	101915	269684
11634	12478	61	applied	\N	\N	\N	\N	101916	101916	269685
11634	12479	62	applied	\N	\N	\N	\N	101917	101917	269686
11634	12480	63	applied	\N	\N	\N	\N	101918	101918	269687
11634	12481	64	applied	\N	\N	\N	\N	101919	101919	269688
11634	12482	65	applied	\N	\N	\N	\N	101920	101920	269689
11634	12483	66	applied	\N	\N	\N	\N	101921	101921	269690
11634	12484	67	applied	\N	\N	\N	\N	101922	101922	269691
11634	12485	68	applied	\N	\N	\N	\N	101923	101923	269692
11634	12486	69	applied	\N	\N	\N	\N	101924	101924	269693
11634	12487	70	applied	\N	\N	\N	\N	101925	101925	269694
11634	12488	71	applied	\N	\N	\N	\N	101926	101926	269695
11634	12489	72	applied	\N	\N	\N	\N	101927	101927	269696
11634	12490	73	applied	\N	\N	\N	\N	101928	101928	269697
11634	12491	74	applied	\N	\N	\N	\N	101929	101929	269698
11634	12492	75	applied	\N	\N	\N	\N	101930	101930	269699
11634	12494	77	applied	\N	\N	\N	\N	101932	101932	269701
11634	12495	78	applied	\N	\N	\N	\N	101933	101933	269702
11634	12496	79	applied	\N	\N	\N	\N	101934	101934	269703
11634	12497	80	applied	\N	\N	\N	\N	101935	101935	269704
11634	12498	81	applied	\N	\N	\N	\N	101936	101936	269705
11634	12499	82	applied	\N	\N	\N	\N	101937	101937	269706
11634	12500	84	applied	\N	\N	\N	\N	101938	101938	269707
11706	12607	0	applied	\N	\N	\N	\N	102091	102091	269860
11726	12614	0	applied	\N	\N	\N	\N	102113	102113	269882
11728	12614	0	applied	\N	\N	\N	\N	102116	102116	269885
11728	12615	1	applied	\N	\N	\N	\N	102117	102117	269886
11732	12617	0	applied	\N	\N	\N	\N	102121	102121	269890
11736	12618	0	applied	\N	\N	\N	\N	102134	102134	269903
11736	12619	1	applied	\N	\N	\N	\N	102135	102135	269904
11736	12620	2	applied	\N	\N	\N	\N	102136	102136	269905
11736	12621	3	applied	\N	\N	\N	\N	102137	102137	269906
11611	12530	0	applied	\N	\N	\N	\N	101746	101746	269515
11611	12531	1	applied	\N	\N	\N	\N	101747	101747	269516
11632	12552	0	applied	\N	\N	\N	\N	101853	101853	269622
11633	12553	0	applied	\N	\N	\N	\N	101854	101854	269623
11634	12502	85	applied	\N	\N	\N	\N	101939	101939	269708
11634	12503	86	applied	\N	\N	\N	\N	101940	101940	269709
11634	12504	87	applied	\N	\N	\N	\N	101941	101941	269710
11634	12505	88	applied	\N	\N	\N	\N	101942	101942	269711
11634	12506	89	applied	\N	\N	\N	\N	101943	101943	269712
11634	12507	90	applied	\N	\N	\N	\N	101944	101944	269713
11634	12508	91	applied	\N	\N	\N	\N	101945	101945	269714
11634	12509	92	applied	\N	\N	\N	\N	101946	101946	269715
11634	12510	93	applied	\N	\N	\N	\N	101947	101947	269716
11634	12511	94	applied	\N	\N	\N	\N	101948	101948	269717
11636	12554	0	applied	\N	\N	\N	\N	101971	101971	269740
11636	12555	1	applied	\N	\N	\N	\N	101972	101972	269741
11636	12557	3	applied	\N	\N	\N	\N	101974	101974	269743
11644	12561	0	applied	\N	\N	\N	\N	101981	101981	269750
11646	12561	0	applied	\N	\N	\N	\N	101983	101983	269752
11649	12562	0	applied	\N	\N	\N	\N	101988	101988	269757
11649	12563	1	applied	\N	\N	\N	\N	101989	101989	269758
11652	12562	0	applied	\N	\N	\N	\N	101994	101994	269763
11652	12563	1	applied	\N	\N	\N	\N	101995	101995	269764
11654	12564	0	applied	\N	\N	\N	\N	101997	101997	269766
11657	12565	0	applied	\N	\N	\N	\N	102000	102000	269769
11659	12566	0	applied	\N	\N	\N	\N	102002	102002	269771
11665	12573	0	applied	\N	\N	\N	\N	102011	102011	269780
11668	12573	0	applied	\N	\N	\N	\N	102014	102014	269783
11674	12575	0	applied	\N	\N	\N	\N	102020	102020	269789
11677	12578	0	applied	\N	\N	\N	\N	102023	102023	269792
11679	12578	0	applied	\N	\N	\N	\N	102025	102025	269794
11684	12584	0	applied	\N	\N	\N	\N	102049	102049	269818
11684	12586	2	applied	\N	\N	\N	\N	102051	102051	269820
11684	12587	3	applied	\N	\N	\N	\N	102052	102052	269821
11684	12588	4	applied	\N	\N	\N	\N	102053	102053	269822
11684	12589	5	applied	\N	\N	\N	\N	102054	102054	269823
11684	12590	6	applied	\N	\N	\N	\N	102055	102055	269824
11684	12591	7	applied	\N	\N	\N	\N	102056	102056	269825
11684	12592	8	applied	\N	\N	\N	\N	102057	102057	269826
11688	12595	0	applied	\N	\N	\N	\N	102071	102071	269840
11691	12596	0	applied	\N	\N	\N	\N	102074	102074	269843
11695	12599	0	applied	\N	\N	\N	\N	102078	102078	269847
11695	12600	1	applied	\N	\N	\N	\N	102079	102079	269848
11700	12603	0	applied	\N	\N	\N	\N	102085	102085	269854
11702	12604	0	applied	\N	\N	\N	\N	102087	102087	269856
11705	12607	0	applied	\N	\N	\N	\N	102090	102090	269859
11712	12610	0	applied	\N	\N	\N	\N	102102	102102	269871
11719	12612	0	applied	\N	\N	\N	\N	102106	102106	269875
11721	12585	1	applied	\N	\N	\N	\N	102109	102109	269878
11721	12586	2	applied	\N	\N	\N	\N	102110	102110	269879
11721	12587	3	applied	\N	\N	\N	\N	102111	102111	269880
11721	12588	4	applied	\N	\N	\N	\N	102112	102112	269881
11727	12614	0	applied	\N	\N	\N	\N	102114	102114	269883
11727	12615	1	applied	\N	\N	\N	\N	102115	102115	269884
11730	12616	0	applied	\N	\N	\N	\N	102119	102119	269888
11735	12618	0	applied	\N	\N	\N	\N	102127	102127	269896
11735	12619	1	applied	\N	\N	\N	\N	102128	102128	269897
11735	12620	2	applied	\N	\N	\N	\N	102129	102129	269898
11735	12621	3	applied	\N	\N	\N	\N	102130	102130	269899
11735	12622	4	applied	\N	\N	\N	\N	102131	102131	269900
11735	12623	5	applied	\N	\N	\N	\N	102132	102132	269901
11735	12624	6	applied	\N	\N	\N	\N	102133	102133	269902
11739	12622	0	applied	\N	\N	\N	\N	102148	102148	269917
11739	12623	1	applied	\N	\N	\N	\N	102149	102149	269918
11739	12625	3	applied	\N	\N	\N	\N	102151	102151	269920
11739	12626	4	applied	\N	\N	1000000000	\N	102152	102152	269921
11741	12628	0	applied	\N	\N	\N	\N	102154	102154	269923
11744	12630	0	applied	\N	\N	\N	\N	102157	102157	269926
11744	12631	1	applied	\N	\N	\N	\N	102158	102158	269927
11746	12632	0	applied	\N	\N	\N	\N	102161	102161	269930
11749	12634	0	applied	\N	\N	\N	\N	102164	102164	269933
11749	12635	1	applied	\N	\N	\N	\N	102165	102165	269934
11751	12636	0	applied	\N	\N	\N	\N	102168	102168	269937
11756	12639	0	applied	\N	\N	\N	\N	102171	102171	269940
11761	12642	0	applied	\N	\N	\N	\N	102179	102179	269948
11761	12643	1	applied	\N	\N	\N	\N	102180	102180	269949
11764	12646	0	applied	\N	\N	\N	\N	102185	102185	269954
11764	12647	1	applied	\N	\N	\N	\N	102186	102186	269955
11764	12648	2	applied	\N	\N	\N	\N	102187	102187	269956
11764	12649	3	applied	\N	\N	\N	\N	102188	102188	269957
11767	12653	1	applied	\N	\N	\N	\N	102194	102194	269963
11769	12654	0	applied	\N	\N	\N	\N	102197	102197	269966
11769	12655	1	applied	\N	\N	\N	\N	102198	102198	269967
11769	12656	2	applied	\N	\N	\N	\N	102199	102199	269968
11772	12657	0	applied	\N	\N	\N	\N	102205	102205	269974
11772	12658	1	applied	\N	\N	\N	\N	102206	102206	269975
11774	12657	0	applied	\N	\N	\N	\N	102331	102331	270100
11774	12658	1	applied	\N	\N	\N	\N	102332	102332	270101
11774	12659	2	applied	\N	\N	\N	\N	102333	102333	270102
11779	12664	0	applied	\N	\N	\N	\N	102340	102340	270109
11781	12665	0	applied	\N	\N	\N	\N	102342	102342	270111
11799	12674	0	applied	\N	\N	\N	\N	102611	102611	270373
11802	12677	0	applied	\N	\N	\N	\N	102616	102616	270378
11805	12678	0	applied	\N	\N	\N	\N	102619	102619	270381
11806	12678	0	applied	\N	\N	\N	\N	102620	102620	270382
11814	12681	0	applied	\N	\N	\N	\N	102628	102628	270390
11819	12686	1	applied	\N	\N	\N	\N	102637	102637	270399
11819	12687	2	applied	\N	\N	\N	\N	102638	102638	270400
11821	12689	0	applied	\N	\N	\N	\N	102640	102640	270402
11821	12690	1	applied	\N	\N	\N	\N	102641	102641	270403
11826	12693	0	applied	\N	\N	\N	\N	102645	102645	270407
11826	12694	1	applied	\N	\N	\N	\N	102646	102646	270408
11826	12695	2	applied	\N	\N	\N	\N	102647	102647	270409
11826	12696	3	applied	\N	\N	\N	\N	102648	102648	270410
11826	12697	4	applied	\N	\N	\N	\N	102649	102649	270411
11826	12698	5	applied	\N	\N	\N	\N	102650	102650	270412
11826	12699	6	applied	\N	\N	\N	\N	102651	102651	270413
11826	12700	7	applied	\N	\N	\N	\N	102652	102652	270414
11826	12701	8	applied	\N	\N	\N	\N	102653	102653	270415
11826	12702	9	applied	\N	\N	\N	\N	102654	102654	270416
11826	12703	10	applied	\N	\N	\N	\N	102655	102655	270417
11829	12705	0	applied	\N	\N	\N	\N	102659	102659	270421
11621	12542	0	applied	\N	\N	\N	\N	101834	101834	269603
11634	12515	98	applied	\N	\N	\N	\N	101952	101952	269721
11634	12516	99	applied	\N	\N	\N	\N	101953	101953	269722
11634	12517	100	applied	\N	\N	\N	\N	101954	101954	269723
11634	12518	101	applied	\N	\N	\N	\N	101955	101955	269724
11634	12519	102	applied	\N	\N	\N	\N	101956	101956	269725
11634	12520	103	applied	\N	\N	\N	\N	101957	101957	269726
11634	12521	104	applied	\N	\N	\N	\N	101958	101958	269727
11634	12522	105	applied	\N	\N	\N	\N	101959	101959	269728
11634	12523	106	applied	\N	\N	\N	\N	101960	101960	269729
11634	12524	107	applied	\N	\N	\N	\N	101961	101961	269730
11634	12525	108	applied	\N	\N	\N	\N	101962	101962	269731
11634	12527	110	applied	\N	\N	\N	\N	101964	101964	269733
11634	12528	111	applied	\N	\N	\N	\N	101965	101965	269734
11634	12529	112	applied	\N	\N	\N	\N	101966	101966	269735
11635	12554	0	applied	\N	\N	\N	\N	101967	101967	269736
11635	12555	1	applied	\N	\N	\N	\N	101968	101968	269737
11635	12556	2	applied	\N	\N	\N	\N	101969	101969	269738
11635	12557	3	applied	\N	\N	\N	\N	101970	101970	269739
11640	12559	0	applied	\N	\N	\N	\N	101976	101976	269745
11640	12560	1	applied	\N	\N	\N	\N	101977	101977	269746
11647	12562	0	applied	\N	\N	\N	\N	101984	101984	269753
11647	12563	1	applied	\N	\N	\N	\N	101985	101985	269754
11653	12564	0	applied	\N	\N	\N	\N	101996	101996	269765
11660	12567	0	applied	\N	\N	\N	\N	102003	102003	269772
11663	12568	0	applied	\N	\N	1000000000	\N	102005	102005	269774
11663	12569	1	applied	\N	\N	\N	\N	102006	102006	269775
11663	12570	2	applied	\N	\N	\N	\N	102007	102007	269776
11663	12572	4	applied	\N	\N	\N	\N	102009	102009	269778
11670	12573	0	applied	\N	\N	\N	\N	102016	102016	269785
11673	12574	0	applied	\N	\N	\N	\N	102019	102019	269788
11675	12576	0	applied	\N	\N	\N	\N	102021	102021	269790
11681	12582	0	applied	\N	\N	\N	\N	102029	102029	269798
11681	12583	1	applied	\N	\N	\N	\N	102030	102030	269799
11682	12584	0	applied	\N	\N	\N	\N	102031	102031	269800
11682	12585	1	applied	\N	\N	\N	\N	102032	102032	269801
11682	12586	2	applied	\N	\N	\N	\N	102033	102033	269802
11682	12587	3	applied	\N	\N	\N	\N	102034	102034	269803
11682	12588	4	applied	\N	\N	\N	\N	102035	102035	269804
11682	12589	5	applied	\N	\N	\N	\N	102036	102036	269805
11682	12590	6	applied	\N	\N	\N	\N	102037	102037	269806
11682	12591	7	applied	\N	\N	\N	\N	102038	102038	269807
11682	12592	8	applied	\N	\N	\N	\N	102039	102039	269808
11687	12593	0	applied	\N	\N	\N	\N	102069	102069	269838
11689	12596	0	applied	\N	\N	\N	\N	102072	102072	269841
11707	12607	0	applied	\N	\N	\N	\N	102092	102092	269861
11708	12584	0	applied	\N	\N	\N	\N	102093	102093	269862
11708	11243	1	applied	\N	\N	\N	\N	102094	102094	269863
11708	12568	2	applied	\N	\N	1000000000	\N	102095	102095	269864
11708	12585	3	applied	\N	\N	\N	\N	102096	102096	269865
11708	12586	4	applied	\N	\N	\N	\N	102097	102097	269866
11708	12587	5	applied	\N	\N	\N	\N	102098	102098	269867
11708	12588	6	applied	\N	\N	\N	\N	102099	102099	269868
11715	12611	0	applied	\N	\N	\N	\N	102104	102104	269873
11731	12616	0	applied	\N	\N	\N	\N	102120	102120	269889
11733	12617	0	applied	\N	\N	\N	\N	102122	102122	269891
11737	12618	0	applied	\N	\N	\N	\N	102141	102141	269910
11737	12619	1	applied	\N	\N	\N	\N	102142	102142	269911
11737	12620	2	applied	\N	\N	\N	\N	102143	102143	269912
11737	12621	3	applied	\N	\N	\N	\N	102144	102144	269913
11737	12623	5	applied	\N	\N	\N	\N	102146	102146	269915
11737	12624	6	applied	\N	\N	\N	\N	102147	102147	269916
11740	12627	0	applied	\N	\N	\N	\N	102153	102153	269922
11750	12634	0	applied	\N	\N	\N	\N	102166	102166	269935
11750	12635	1	applied	\N	\N	\N	\N	102167	102167	269936
11755	12638	0	applied	\N	\N	\N	\N	102170	102170	269939
11760	12642	0	applied	\N	\N	\N	\N	102177	102177	269946
11760	12643	1	applied	\N	\N	\N	\N	102178	102178	269947
11763	12644	0	applied	\N	\N	\N	\N	102183	102183	269952
11763	12645	1	applied	\N	\N	\N	\N	102184	102184	269953
11768	12652	0	applied	\N	\N	\N	\N	102195	102195	269964
11768	12653	1	applied	\N	\N	\N	\N	102196	102196	269965
11770	12654	0	applied	\N	\N	\N	\N	102200	102200	269969
11770	12655	1	applied	\N	\N	\N	\N	102201	102201	269970
11770	12656	2	applied	\N	\N	\N	\N	102202	102202	269971
11780	12664	0	applied	\N	\N	\N	\N	102341	102341	270110
11784	12665	0	applied	\N	\N	\N	\N	102345	102345	270114
11788	12666	0	applied	\N	\N	\N	\N	102350	102350	270119
11788	12667	1	applied	\N	\N	\N	\N	102351	102351	270120
11791	12669	0	applied	\N	\N	\N	\N	102478	102478	270247
11791	12670	1	applied	\N	\N	\N	\N	102479	102479	270248
11794	12671	0	applied	\N	\N	\N	\N	102483	102483	270252
11798	12673	0	applied	\N	\N	\N	\N	102610	102610	270372
11803	12678	0	applied	\N	\N	\N	\N	102617	102617	270379
11810	12680	0	applied	\N	\N	\N	\N	102624	102624	270386
11812	12681	0	applied	\N	\N	\N	\N	102626	102626	270388
11816	12682	0	applied	\N	\N	\N	\N	102630	102630	270392
11820	12688	0	applied	\N	\N	\N	\N	102639	102639	270401
11825	12692	0	applied	\N	\N	\N	\N	102644	102644	270406
11828	12705	0	applied	\N	\N	\N	\N	102657	102657	270419
11828	12706	1	applied	\N	\N	\N	\N	102658	102658	270420
11829	12706	1	applied	\N	\N	\N	\N	102660	102660	270422
11833	12710	1	applied	\N	\N	\N	\N	102671	102671	270433
11833	12711	2	applied	\N	\N	\N	\N	102672	102672	270434
11833	12712	3	applied	\N	\N	\N	\N	102673	102673	270435
11833	12713	4	applied	\N	\N	\N	\N	102674	102674	270436
11836	12718	0	applied	\N	\N	\N	\N	102684	102684	270446
11837	12719	0	applied	\N	\N	1000000000	\N	102685	102685	270447
11837	12720	1	applied	\N	\N	\N	\N	102686	102686	270448
11841	12723	0	applied	\N	\N	\N	\N	102690	102690	270452
11841	12724	1	applied	\N	\N	\N	\N	102691	102691	270453
11843	12725	0	applied	\N	\N	\N	\N	102693	102693	270455
11845	12727	0	applied	\N	\N	\N	\N	102695	102695	270457
11846	12727	0	applied	\N	\N	\N	\N	102696	102696	270458
11855	12730	0	applied	\N	\N	\N	\N	102713	102713	270475
11857	12731	0	applied	\N	\N	\N	\N	102716	102716	270478
11857	12732	1	applied	\N	\N	\N	\N	102717	102717	270479
11859	12733	0	applied	\N	\N	\N	\N	102718	102718	270480
11864	12693	1	applied	\N	\N	\N	\N	102728	102728	270490
11864	12433	2	applied	\N	\N	\N	\N	102729	102729	270491
11634	12513	96	applied	\N	\N	\N	\N	101950	101950	269719
11634	12514	97	applied	\N	\N	\N	\N	101951	101951	269720
11648	12563	1	applied	\N	\N	\N	\N	101987	101987	269756
11651	12562	0	applied	\N	\N	\N	\N	101992	101992	269761
11651	12563	1	applied	\N	\N	\N	\N	101993	101993	269762
11656	12565	0	applied	\N	\N	\N	\N	101999	101999	269768
11658	12566	0	applied	\N	\N	\N	\N	102001	102001	269770
11664	12573	0	applied	\N	\N	\N	\N	102010	102010	269779
11667	12573	0	applied	\N	\N	\N	\N	102013	102013	269782
11671	12573	0	applied	\N	\N	\N	\N	102017	102017	269786
11676	12577	0	applied	\N	\N	\N	\N	102022	102022	269791
11683	12584	0	applied	\N	\N	\N	\N	102040	102040	269809
11683	12585	1	applied	\N	\N	\N	\N	102041	102041	269810
11683	12586	2	applied	\N	\N	\N	\N	102042	102042	269811
11683	12588	4	applied	\N	\N	\N	\N	102044	102044	269813
11683	12589	5	applied	\N	\N	\N	\N	102045	102045	269814
11683	12590	6	applied	\N	\N	\N	\N	102046	102046	269815
11683	12591	7	applied	\N	\N	\N	\N	102047	102047	269816
11683	12592	8	applied	\N	\N	\N	\N	102048	102048	269817
11690	12596	0	applied	\N	\N	\N	\N	102073	102073	269842
11692	12597	0	applied	\N	\N	\N	\N	102075	102075	269844
11694	12598	0	applied	\N	\N	\N	\N	102077	102077	269846
11697	12601	0	applied	\N	\N	\N	\N	102082	102082	269851
11699	12602	0	applied	\N	\N	\N	\N	102084	102084	269853
11704	12606	0	applied	\N	\N	\N	\N	102089	102089	269858
11711	12608	0	applied	\N	\N	\N	\N	102100	102100	269869
11711	12609	1	applied	\N	\N	\N	\N	102101	102101	269870
11714	12611	0	applied	\N	\N	\N	\N	102103	102103	269872
11718	12612	0	applied	\N	\N	\N	\N	102105	102105	269874
11720	12613	0	applied	\N	\N	\N	\N	102107	102107	269876
11734	12618	0	applied	\N	\N	\N	\N	102123	102123	269892
11734	12619	1	applied	\N	\N	\N	\N	102124	102124	269893
11734	12620	2	applied	\N	\N	\N	\N	102125	102125	269894
11734	12621	3	applied	\N	\N	\N	\N	102126	102126	269895
11743	12629	0	applied	\N	\N	\N	\N	102156	102156	269925
11748	12633	0	applied	\N	\N	\N	\N	102163	102163	269932
11758	12640	0	applied	\N	\N	\N	\N	102173	102173	269942
11758	12641	1	applied	\N	\N	\N	\N	102174	102174	269943
11766	12652	0	applied	\N	\N	\N	\N	102191	102191	269960
11766	12653	1	applied	\N	\N	\N	\N	102192	102192	269961
11771	12657	0	applied	\N	\N	\N	\N	102203	102203	269972
11771	12658	1	applied	\N	\N	\N	\N	102204	102204	269973
11773	12584	0	applied	\N	\N	\N	\N	102207	102207	269976
11773	12646	1	applied	\N	\N	\N	\N	102208	102208	269977
11773	12647	2	applied	\N	\N	\N	\N	102209	102209	269978
11773	12618	4	applied	\N	\N	\N	\N	102211	102211	269980
11773	12650	5	applied	\N	\N	\N	\N	102212	102212	269981
11773	12652	6	applied	\N	\N	\N	\N	102213	102213	269982
11773	12654	7	applied	\N	\N	\N	\N	102214	102214	269983
11773	12655	8	applied	\N	\N	\N	\N	102215	102215	269984
11773	12657	9	applied	\N	\N	\N	\N	102216	102216	269985
11773	12585	10	applied	\N	\N	\N	\N	102217	102217	269986
11773	12586	11	applied	\N	\N	\N	\N	102218	102218	269987
11773	12587	12	applied	\N	\N	\N	\N	102219	102219	269988
11773	12588	13	applied	\N	\N	\N	\N	102220	102220	269989
11773	12619	14	applied	\N	\N	\N	\N	102221	102221	269990
11773	12620	15	applied	\N	\N	\N	\N	102222	102222	269991
11773	12621	16	applied	\N	\N	\N	\N	102223	102223	269992
11773	12535	17	applied	\N	\N	\N	\N	102224	102224	269993
11773	12536	18	applied	\N	\N	\N	\N	102225	102225	269994
11773	12537	19	applied	\N	\N	\N	\N	102226	102226	269995
11773	12538	20	applied	\N	\N	\N	\N	102227	102227	269996
11773	12539	21	applied	\N	\N	\N	\N	102228	102228	269997
11773	12540	22	applied	\N	\N	\N	\N	102229	102229	269998
11773	12542	24	applied	\N	\N	\N	\N	102231	102231	270000
11773	12543	25	applied	\N	\N	\N	\N	102232	102232	270001
11773	12544	26	applied	\N	\N	\N	\N	102233	102233	270002
11773	12545	27	applied	\N	\N	\N	\N	102234	102234	270003
11773	12546	28	applied	\N	\N	\N	\N	102235	102235	270004
11773	12547	29	applied	\N	\N	\N	\N	102236	102236	270005
11773	12548	30	applied	\N	\N	\N	\N	102237	102237	270006
11773	12549	31	applied	\N	\N	\N	\N	102238	102238	270007
11773	12550	32	applied	\N	\N	\N	\N	102239	102239	270008
11773	12551	33	applied	\N	\N	\N	\N	102240	102240	270009
11773	12552	34	applied	\N	\N	\N	\N	102241	102241	270010
11773	12553	35	applied	\N	\N	\N	\N	102242	102242	270011
11773	12554	36	applied	\N	\N	\N	\N	102243	102243	270012
11773	12555	37	applied	\N	\N	\N	\N	102244	102244	270013
11773	12556	38	applied	\N	\N	\N	\N	102245	102245	270014
11773	12557	39	applied	\N	\N	\N	\N	102246	102246	270015
11773	12559	41	applied	\N	\N	\N	\N	102248	102248	270017
11773	12560	42	applied	\N	\N	\N	\N	102249	102249	270018
11773	12561	43	applied	\N	\N	\N	\N	102250	102250	270019
11773	12562	44	applied	\N	\N	\N	\N	102251	102251	270020
11773	12563	45	applied	\N	\N	\N	\N	102252	102252	270021
11773	12564	46	applied	\N	\N	\N	\N	102253	102253	270022
11773	12565	47	applied	\N	\N	\N	\N	102254	102254	270023
11773	12566	48	applied	\N	\N	\N	\N	102255	102255	270024
11773	12567	49	applied	\N	\N	\N	\N	102256	102256	270025
11773	12569	50	applied	\N	\N	\N	\N	102257	102257	270026
11773	12570	52	applied	\N	\N	\N	\N	102258	102258	270027
11773	12571	53	applied	\N	\N	\N	\N	102259	102259	270028
11773	12572	54	applied	\N	\N	\N	\N	102260	102260	270029
11773	12573	55	applied	\N	\N	\N	\N	102261	102261	270030
11773	12574	56	applied	\N	\N	\N	\N	102262	102262	270031
11773	12575	57	applied	\N	\N	\N	\N	102263	102263	270032
11773	12577	59	applied	\N	\N	\N	\N	102265	102265	270034
11773	12578	60	applied	\N	\N	\N	\N	102266	102266	270035
11773	12579	61	applied	\N	\N	\N	\N	102267	102267	270036
11773	12580	62	applied	\N	\N	\N	\N	102268	102268	270037
11773	12581	63	applied	\N	\N	\N	\N	102269	102269	270038
11864	12461	3	applied	\N	\N	\N	\N	102730	102730	270492
11864	12735	4	applied	\N	\N	\N	\N	102731	102731	270493
11864	12646	5	applied	\N	\N	\N	\N	102732	102732	270494
11864	12647	6	applied	\N	\N	\N	\N	102733	102733	270495
11864	12568	7	applied	\N	\N	1000000000	\N	102734	102734	270496
11864	12694	8	applied	\N	\N	\N	\N	102735	102735	270497
11864	12618	9	applied	\N	\N	\N	\N	102736	102736	270498
11864	12695	10	applied	\N	\N	\N	\N	102737	102737	270499
11864	12650	11	applied	\N	\N	\N	\N	102738	102738	270500
11864	12652	12	applied	\N	\N	\N	\N	102739	102739	270501
11641	12560	1	applied	\N	\N	\N	\N	101979	101979	269748
11648	12562	0	applied	\N	\N	\N	\N	101986	101986	269755
11745	12631	1	applied	\N	\N	\N	\N	102160	102160	269929
11747	12633	0	applied	\N	\N	\N	\N	102162	102162	269931
11752	12637	0	applied	\N	\N	\N	\N	102169	102169	269938
11757	12639	0	applied	\N	\N	\N	\N	102172	102172	269941
11759	12640	0	applied	\N	\N	\N	\N	102175	102175	269944
11759	12641	1	applied	\N	\N	\N	\N	102176	102176	269945
11762	12644	0	applied	\N	\N	\N	\N	102181	102181	269950
11762	12645	1	applied	\N	\N	\N	\N	102182	102182	269951
11765	12650	0	applied	\N	\N	\N	\N	102189	102189	269958
11765	12651	1	applied	\N	\N	\N	\N	102190	102190	269959
11773	12582	64	applied	\N	\N	\N	\N	102270	102270	270039
11773	12583	65	applied	\N	\N	\N	\N	102271	102271	270040
11773	12589	66	applied	\N	\N	\N	\N	102272	102272	270041
11773	12590	67	applied	\N	\N	\N	\N	102273	102273	270042
11773	12592	69	applied	\N	\N	\N	\N	102275	102275	270044
11773	12593	70	applied	\N	\N	\N	\N	102276	102276	270045
11773	12594	71	applied	\N	\N	\N	\N	102277	102277	270046
11773	12595	72	applied	\N	\N	\N	\N	102278	102278	270047
11773	12596	73	applied	\N	\N	\N	\N	102279	102279	270048
11773	12597	74	applied	\N	\N	\N	\N	102280	102280	270049
11777	12663	0	applied	\N	\N	\N	\N	102338	102338	270107
11782	12665	0	applied	\N	\N	\N	\N	102343	102343	270112
11787	12666	0	applied	\N	\N	\N	\N	102348	102348	270117
11787	12667	1	applied	\N	\N	\N	\N	102349	102349	270118
11790	12668	0	applied	\N	\N	\N	\N	102477	102477	270246
11793	12671	0	applied	\N	\N	\N	\N	102482	102482	270251
11795	12671	0	applied	\N	\N	\N	\N	102484	102484	270253
11797	12672	0	applied	\N	\N	\N	\N	102609	102609	270371
11800	12675	0	applied	\N	\N	\N	\N	102612	102612	270374
11800	12676	1	applied	\N	\N	\N	\N	102613	102613	270375
11809	12680	0	applied	\N	\N	\N	\N	102623	102623	270385
11815	12681	0	applied	\N	\N	\N	\N	102629	102629	270391
11822	12691	0	applied	\N	\N	\N	\N	102642	102642	270404
11824	12692	0	applied	\N	\N	\N	\N	102643	102643	270405
11827	12704	0	applied	\N	\N	\N	\N	102656	102656	270418
11830	12705	0	applied	\N	\N	\N	\N	102661	102661	270423
11830	12706	1	applied	\N	\N	\N	\N	102662	102662	270424
11834	12709	0	applied	\N	\N	\N	\N	102675	102675	270437
11834	12710	1	applied	\N	\N	\N	\N	102676	102676	270438
11834	12711	2	applied	\N	\N	\N	\N	102677	102677	270439
11834	12712	3	applied	\N	\N	\N	\N	102678	102678	270440
11834	12713	4	applied	\N	\N	\N	\N	102679	102679	270441
11839	12721	0	applied	\N	\N	\N	\N	102688	102688	270450
11842	12725	0	applied	\N	\N	\N	\N	102692	102692	270454
11844	12726	0	applied	\N	\N	\N	\N	102694	102694	270456
11847	12727	0	applied	\N	\N	\N	\N	102697	102697	270459
11851	12729	1	applied	\N	\N	\N	\N	102702	102702	270464
11854	12693	0	applied	\N	\N	\N	\N	102704	102704	270466
11854	12694	1	applied	\N	\N	\N	\N	102705	102705	270467
11854	12695	2	applied	\N	\N	\N	\N	102706	102706	270468
11854	12696	3	applied	\N	\N	\N	\N	102707	102707	270469
11854	12697	4	applied	\N	\N	\N	\N	102708	102708	270470
11854	12698	5	applied	\N	\N	\N	\N	102709	102709	270471
11854	12699	6	applied	\N	\N	\N	\N	102710	102710	270472
11854	12700	7	applied	\N	\N	\N	\N	102711	102711	270473
11854	12701	8	applied	\N	\N	\N	\N	102712	102712	270474
11856	12731	0	applied	\N	\N	\N	\N	102714	102714	270476
11856	12732	1	applied	\N	\N	\N	\N	102715	102715	270477
11861	12734	0	applied	\N	\N	\N	\N	102720	102720	270482
11863	12735	0	applied	\N	\N	\N	\N	102724	102724	270486
11863	12736	1	applied	\N	\N	\N	\N	102725	102725	270487
11863	12737	2	applied	\N	\N	\N	\N	102726	102726	270488
11866	12738	0	applied	\N	\N	\N	\N	102853	102853	270615
11868	12739	0	applied	\N	\N	\N	\N	102855	102855	270617
11870	12741	1	applied	\N	\N	\N	\N	102858	102858	270620
11873	12745	0	applied	\N	\N	\N	\N	102865	102865	270627
11873	12746	1	applied	\N	\N	\N	\N	102866	102866	270628
11873	12747	2	applied	\N	\N	\N	\N	102867	102867	270629
11876	12748	0	applied	\N	\N	\N	\N	102936	102936	270698
11878	12693	0	applied	\N	\N	\N	\N	102938	102938	270700
11878	12735	1	applied	\N	\N	\N	\N	102939	102939	270701
11878	12740	2	applied	\N	\N	\N	\N	102940	102940	270702
11878	12745	3	applied	\N	\N	\N	\N	102941	102941	270703
11878	12750	4	applied	\N	\N	\N	\N	102942	102942	270704
11878	12646	5	applied	\N	\N	\N	\N	102943	102943	270705
11883	12752	0	applied	\N	\N	\N	\N	102954	102954	270716
11883	12753	1	applied	\N	\N	\N	\N	102955	102955	270717
11883	12754	2	applied	\N	\N	\N	\N	102956	102956	270718
11883	12755	3	applied	\N	\N	\N	\N	102957	102957	270719
11885	12756	0	applied	\N	\N	\N	\N	102962	102962	270724
11893	12762	0	applied	\N	\N	\N	\N	102970	102970	270732
11893	12763	1	applied	\N	\N	\N	\N	102971	102971	270733
11899	12770	0	applied	\N	\N	\N	\N	103102	103102	270864
11899	12771	1	applied	\N	\N	\N	\N	103103	103103	270865
11901	12772	0	applied	\N	\N	\N	\N	103106	103106	270868
11904	12775	0	applied	\N	\N	\N	\N	103111	103111	270873
11912	12782	0	applied	\N	\N	\N	\N	103119	103119	270881
11914	12783	0	applied	\N	\N	\N	\N	103121	103121	270883
11921	12787	0	applied	\N	\N	\N	\N	103152	103152	270914
11921	12788	1	applied	\N	\N	\N	\N	103153	103153	270915
11924	12791	0	applied	\N	\N	\N	\N	103156	103156	270918
11927	12795	0	applied	\N	\N	\N	\N	103160	103160	270922
11930	12797	0	applied	\N	\N	\N	\N	103163	103163	270925
11930	12798	1	applied	\N	\N	\N	\N	103164	103164	270926
11930	12799	2	applied	\N	\N	\N	\N	103165	103165	270927
11932	12800	0	applied	\N	\N	\N	\N	103169	103169	270931
11945	12816	0	applied	\N	\N	\N	\N	103228	103228	270990
11948	12822	0	applied	\N	\N	\N	\N	103236	103236	270998
11948	12823	1	applied	\N	\N	\N	\N	103237	103237	270999
11952	12807	0	applied	\N	\N	\N	\N	103256	103256	271018
11952	12819	1	applied	\N	\N	\N	\N	103257	103257	271019
11952	12820	2	applied	\N	\N	\N	\N	103258	103258	271020
11952	12821	3	applied	\N	\N	\N	\N	103259	103259	271021
11952	12802	4	applied	\N	\N	\N	\N	103260	103260	271022
11952	12803	5	applied	\N	\N	\N	\N	103261	103261	271023
11952	12804	6	applied	\N	\N	\N	\N	103262	103262	271024
11952	12805	7	applied	\N	\N	\N	\N	103263	103263	271025
11952	12818	8	applied	\N	\N	\N	\N	103264	103264	271026
11952	12806	9	applied	\N	\N	\N	\N	103265	103265	271027
11952	12808	10	applied	\N	\N	\N	\N	103266	103266	271028
11742	12628	0	applied	\N	\N	\N	\N	102155	102155	269924
11745	12630	0	applied	\N	\N	\N	\N	102159	102159	269928
11773	12601	78	applied	\N	\N	\N	\N	102284	102284	270053
11773	12602	79	applied	\N	\N	\N	\N	102285	102285	270054
11773	12603	80	applied	\N	\N	\N	\N	102286	102286	270055
11773	12604	81	applied	\N	\N	\N	\N	102287	102287	270056
11773	12605	82	applied	\N	\N	\N	\N	102288	102288	270057
11773	12606	83	applied	\N	\N	\N	\N	102289	102289	270058
11773	12607	84	applied	\N	\N	\N	\N	102290	102290	270059
11773	12608	85	applied	\N	\N	\N	\N	102291	102291	270060
11773	12609	86	applied	\N	\N	\N	\N	102292	102292	270061
11773	12610	87	applied	\N	\N	\N	\N	102293	102293	270062
11773	12611	88	applied	\N	\N	\N	\N	102294	102294	270063
11773	12612	89	applied	\N	\N	\N	\N	102295	102295	270064
11773	12613	90	applied	\N	\N	\N	\N	102296	102296	270065
11773	12615	92	applied	\N	\N	\N	\N	102298	102298	270067
11773	12616	93	applied	\N	\N	\N	\N	102299	102299	270068
11773	12617	94	applied	\N	\N	\N	\N	102300	102300	270069
11773	12622	95	applied	\N	\N	\N	\N	102301	102301	270070
11773	12623	96	applied	\N	\N	\N	\N	102302	102302	270071
11773	12624	97	applied	\N	\N	\N	\N	102303	102303	270072
11773	12625	98	applied	\N	\N	\N	\N	102304	102304	270073
11773	12626	99	applied	\N	\N	1000000000	\N	102305	102305	270074
11773	12627	100	applied	\N	\N	\N	\N	102306	102306	270075
11773	12628	101	applied	\N	\N	\N	\N	102307	102307	270076
11773	12629	102	applied	\N	\N	\N	\N	102308	102308	270077
11773	12630	103	applied	\N	\N	\N	\N	102309	102309	270078
11773	12631	104	applied	\N	\N	\N	\N	102310	102310	270079
11773	12632	105	applied	\N	\N	\N	\N	102311	102311	270080
11773	12633	106	applied	\N	\N	\N	\N	102312	102312	270081
11773	12634	107	applied	\N	\N	\N	\N	102313	102313	270082
11773	12636	109	applied	\N	\N	\N	\N	102315	102315	270084
11773	12637	110	applied	\N	\N	\N	\N	102316	102316	270085
11773	12638	111	applied	\N	\N	\N	\N	102317	102317	270086
11773	12639	112	applied	\N	\N	\N	\N	102318	102318	270087
11773	12640	113	applied	\N	\N	\N	\N	102319	102319	270088
11773	12641	114	applied	\N	\N	\N	\N	102320	102320	270089
11773	12642	115	applied	\N	\N	\N	\N	102321	102321	270090
11773	12643	116	applied	\N	\N	\N	\N	102322	102322	270091
11773	12644	117	applied	\N	\N	\N	\N	102323	102323	270092
11773	12645	118	applied	\N	\N	\N	\N	102324	102324	270093
11773	12648	119	applied	\N	\N	\N	\N	102325	102325	270094
11773	12649	120	applied	\N	\N	\N	\N	102326	102326	270095
11773	12651	121	applied	\N	\N	\N	\N	102327	102327	270096
11773	12653	122	applied	\N	\N	\N	\N	102328	102328	270097
11773	12656	123	applied	\N	\N	\N	\N	102329	102329	270098
11773	12658	124	applied	\N	\N	\N	\N	102330	102330	270099
11775	12660	1	applied	\N	\N	\N	\N	102335	102335	270104
11776	12661	0	applied	\N	\N	\N	\N	102336	102336	270105
11776	12662	1	applied	\N	\N	\N	\N	102337	102337	270106
11778	12664	0	applied	\N	\N	\N	\N	102339	102339	270108
11785	12666	0	applied	\N	\N	\N	\N	102346	102346	270115
11785	12667	1	applied	\N	\N	\N	\N	102347	102347	270116
11789	12584	0	applied	\N	\N	\N	\N	102352	102352	270121
11789	12646	1	applied	\N	\N	\N	\N	102353	102353	270122
11789	12647	2	applied	\N	\N	\N	\N	102354	102354	270123
11789	12568	3	applied	\N	\N	1000000000	\N	102355	102355	270124
11789	12618	4	applied	\N	\N	\N	\N	102356	102356	270125
11789	12650	5	applied	\N	\N	\N	\N	102357	102357	270126
11789	12652	6	applied	\N	\N	\N	\N	102358	102358	270127
11789	12654	7	applied	\N	\N	\N	\N	102359	102359	270128
11789	12655	8	applied	\N	\N	\N	\N	102360	102360	270129
11789	12657	9	applied	\N	\N	\N	\N	102361	102361	270130
11789	12586	11	applied	\N	\N	\N	\N	102363	102363	270132
11789	12587	12	applied	\N	\N	\N	\N	102364	102364	270133
11789	12588	13	applied	\N	\N	\N	\N	102365	102365	270134
11789	12619	14	applied	\N	\N	\N	\N	102366	102366	270135
11789	12620	15	applied	\N	\N	\N	\N	102367	102367	270136
11789	12621	16	applied	\N	\N	\N	\N	102368	102368	270137
11789	12491	17	applied	\N	\N	\N	\N	102369	102369	270138
11789	12492	18	applied	\N	\N	\N	\N	102370	102370	270139
11789	12493	19	applied	\N	\N	\N	\N	102371	102371	270140
11789	12494	20	applied	\N	\N	\N	\N	102372	102372	270141
11789	12495	21	applied	\N	\N	\N	\N	102373	102373	270142
11789	12496	22	applied	\N	\N	\N	\N	102374	102374	270143
11789	12497	23	applied	\N	\N	\N	\N	102375	102375	270144
11789	12501	24	applied	\N	\N	\N	\N	102376	102376	270145
11789	12498	25	applied	\N	\N	\N	\N	102377	102377	270146
11789	12499	26	applied	\N	\N	\N	\N	102378	102378	270147
11789	12502	28	applied	\N	\N	\N	\N	102380	102380	270149
11789	12503	29	applied	\N	\N	\N	\N	102381	102381	270150
11789	12504	30	applied	\N	\N	\N	\N	102382	102382	270151
11789	12505	31	applied	\N	\N	\N	\N	102383	102383	270152
11789	12506	32	applied	\N	\N	\N	\N	102384	102384	270153
11789	12507	33	applied	\N	\N	\N	\N	102385	102385	270154
11789	12508	34	applied	\N	\N	\N	\N	102386	102386	270155
11789	12509	35	applied	\N	\N	\N	\N	102387	102387	270156
11789	12510	36	applied	\N	\N	\N	\N	102388	102388	270157
11789	12511	37	applied	\N	\N	\N	\N	102389	102389	270158
11789	12512	38	applied	\N	\N	\N	\N	102390	102390	270159
11789	12513	39	applied	\N	\N	\N	\N	102391	102391	270160
11789	12514	40	applied	\N	\N	\N	\N	102392	102392	270161
11789	12515	41	applied	\N	\N	\N	\N	102393	102393	270162
11789	12516	42	applied	\N	\N	\N	\N	102394	102394	270163
11789	12517	43	applied	\N	\N	\N	\N	102395	102395	270164
11789	12519	45	applied	\N	\N	\N	\N	102397	102397	270166
11789	12520	46	applied	\N	\N	\N	\N	102398	102398	270167
11789	12660	47	applied	\N	\N	\N	\N	102399	102399	270168
11789	12521	48	applied	\N	\N	\N	\N	102400	102400	270169
11789	12522	49	applied	\N	\N	\N	\N	102401	102401	270170
11789	12523	50	applied	\N	\N	\N	\N	102402	102402	270171
11952	12809	11	applied	\N	\N	\N	\N	103267	103267	271029
11952	12813	12	applied	\N	\N	\N	\N	103268	103268	271030
11952	12814	13	applied	\N	\N	\N	\N	103269	103269	271031
11952	12815	14	applied	\N	\N	\N	\N	103270	103270	271032
11952	12816	15	applied	\N	\N	\N	\N	103271	103271	271033
11952	12817	16	applied	\N	\N	\N	\N	103272	103272	271034
11952	12822	17	applied	\N	\N	\N	\N	103273	103273	271035
11952	12823	18	applied	\N	\N	\N	\N	103274	103274	271036
11952	12824	19	applied	\N	\N	\N	\N	103275	103275	271037
11955	12826	0	applied	\N	\N	\N	\N	103284	103284	271046
11773	12599	76	applied	\N	\N	\N	\N	102282	102282	270051
11773	12600	77	applied	\N	\N	\N	\N	102283	102283	270052
11789	12528	55	applied	\N	\N	\N	\N	102407	102407	270176
11789	12529	56	applied	\N	\N	\N	\N	102408	102408	270177
11789	12530	57	applied	\N	\N	\N	\N	102409	102409	270178
11789	12531	58	applied	\N	\N	\N	\N	102410	102410	270179
11789	12532	59	applied	\N	\N	\N	\N	102411	102411	270180
11789	12533	60	applied	\N	\N	\N	\N	102412	102412	270181
11789	12534	61	applied	\N	\N	\N	\N	102413	102413	270182
11789	12535	62	applied	\N	\N	\N	\N	102414	102414	270183
11789	12536	64	applied	\N	\N	\N	\N	102415	102415	270184
11789	12537	65	applied	\N	\N	\N	\N	102416	102416	270185
11789	12538	66	applied	\N	\N	\N	\N	102417	102417	270186
11789	12539	67	applied	\N	\N	\N	\N	102418	102418	270187
11789	12540	68	applied	\N	\N	\N	\N	102419	102419	270188
11789	12541	69	applied	\N	\N	\N	\N	102420	102420	270189
11789	12543	71	applied	\N	\N	\N	\N	102422	102422	270191
11789	12544	72	applied	\N	\N	\N	\N	102423	102423	270192
11789	12545	73	applied	\N	\N	\N	\N	102424	102424	270193
11789	12546	74	applied	\N	\N	\N	\N	102425	102425	270194
11789	12547	75	applied	\N	\N	\N	\N	102426	102426	270195
11789	12548	76	applied	\N	\N	\N	\N	102427	102427	270196
11789	12549	77	applied	\N	\N	\N	\N	102428	102428	270197
11789	12550	78	applied	\N	\N	\N	\N	102429	102429	270198
11789	12551	79	applied	\N	\N	\N	\N	102430	102430	270199
11789	12552	80	applied	\N	\N	\N	\N	102431	102431	270200
11789	12553	81	applied	\N	\N	\N	\N	102432	102432	270201
11789	12554	82	applied	\N	\N	\N	\N	102433	102433	270202
11789	12555	83	applied	\N	\N	\N	\N	102434	102434	270203
11789	12556	84	applied	\N	\N	\N	\N	102435	102435	270204
11789	12557	85	applied	\N	\N	\N	\N	102436	102436	270205
11789	12558	86	applied	\N	\N	\N	\N	102437	102437	270206
11789	12560	88	applied	\N	\N	\N	\N	102439	102439	270208
11789	12561	89	applied	\N	\N	\N	\N	102440	102440	270209
11789	12562	90	applied	\N	\N	\N	\N	102441	102441	270210
11789	12563	91	applied	\N	\N	\N	\N	102442	102442	270211
11789	12564	92	applied	\N	\N	\N	\N	102443	102443	270212
11789	12565	93	applied	\N	\N	\N	\N	102444	102444	270213
11789	12566	94	applied	\N	\N	\N	\N	102445	102445	270214
11789	12567	95	applied	\N	\N	\N	\N	102446	102446	270215
11789	12569	96	applied	\N	\N	\N	\N	102447	102447	270216
11789	12570	97	applied	\N	\N	\N	\N	102448	102448	270217
11789	12571	98	applied	\N	\N	\N	\N	102449	102449	270218
11789	12572	99	applied	\N	\N	\N	\N	102450	102450	270219
11789	12573	100	applied	\N	\N	\N	\N	102451	102451	270220
11789	12574	101	applied	\N	\N	\N	\N	102452	102452	270221
11789	12575	102	applied	\N	\N	\N	\N	102453	102453	270222
11789	12576	103	applied	\N	\N	\N	\N	102454	102454	270223
11789	12578	105	applied	\N	\N	\N	\N	102456	102456	270225
11789	12579	106	applied	\N	\N	\N	\N	102457	102457	270226
11789	12580	107	applied	\N	\N	\N	\N	102458	102458	270227
11789	12581	108	applied	\N	\N	\N	\N	102459	102459	270228
11789	12582	109	applied	\N	\N	\N	\N	102460	102460	270229
11789	12583	110	applied	\N	\N	\N	\N	102461	102461	270230
11789	12589	111	applied	\N	\N	\N	\N	102462	102462	270231
11789	12590	112	applied	\N	\N	\N	\N	102463	102463	270232
11789	12591	113	applied	\N	\N	\N	\N	102464	102464	270233
11789	12592	114	applied	\N	\N	\N	\N	102465	102465	270234
11789	12593	115	applied	\N	\N	\N	\N	102466	102466	270235
11789	12594	116	applied	\N	\N	\N	\N	102467	102467	270236
11789	12595	117	applied	\N	\N	\N	\N	102468	102468	270237
11789	12596	118	applied	\N	\N	\N	\N	102469	102469	270238
11789	12597	119	applied	\N	\N	\N	\N	102470	102470	270239
11789	12598	120	applied	\N	\N	\N	\N	102471	102471	270240
11789	12600	122	applied	\N	\N	\N	\N	102473	102473	270242
11789	12601	123	applied	\N	\N	\N	\N	102474	102474	270243
11789	12602	124	applied	\N	\N	\N	\N	102475	102475	270244
11789	12603	125	applied	\N	\N	\N	\N	102476	102476	270245
11792	12669	0	applied	\N	\N	\N	\N	102480	102480	270249
11792	12670	1	applied	\N	\N	\N	\N	102481	102481	270250
11796	12584	0	applied	\N	\N	\N	\N	102485	102485	270254
11796	12646	1	applied	\N	\N	\N	\N	102486	102486	270255
11796	12647	2	applied	\N	\N	\N	\N	102487	102487	270256
11796	12568	3	applied	\N	\N	1000000000	\N	102488	102488	270257
11796	12391	4	applied	\N	\N	\N	\N	102489	102489	270258
11796	12395	5	applied	\N	\N	\N	\N	102490	102490	270259
11796	12400	6	applied	\N	\N	\N	\N	102491	102491	270260
11796	12403	7	applied	\N	\N	\N	\N	102492	102492	270261
11796	12406	8	applied	\N	\N	\N	\N	102493	102493	270262
11796	12407	9	applied	\N	\N	\N	\N	102494	102494	270263
11796	12413	11	applied	\N	\N	\N	\N	102496	102496	270265
11796	12415	12	applied	\N	\N	\N	\N	102497	102497	270266
11796	12417	13	applied	\N	\N	\N	\N	102498	102498	270267
11796	12419	14	applied	\N	\N	\N	\N	102499	102499	270268
11796	12420	15	applied	\N	\N	\N	\N	102500	102500	270269
11796	12423	16	applied	\N	\N	\N	\N	102501	102501	270270
11796	12425	17	applied	\N	\N	\N	\N	102502	102502	270271
11796	12426	18	applied	\N	\N	\N	\N	102503	102503	270272
11796	12427	19	applied	\N	\N	\N	\N	102504	102504	270273
11796	12428	20	applied	\N	\N	\N	\N	102505	102505	270274
11796	12433	21	applied	\N	\N	\N	\N	102506	102506	270275
11796	12618	22	applied	\N	\N	\N	\N	102507	102507	270276
11796	12650	23	applied	\N	\N	\N	\N	102508	102508	270277
11796	12652	24	applied	\N	\N	\N	\N	102509	102509	270278
11796	12654	25	applied	\N	\N	\N	\N	102510	102510	270279
11796	12655	26	applied	\N	\N	\N	\N	102511	102511	270280
11796	12585	28	applied	\N	\N	\N	\N	102513	102513	270282
11796	12586	29	applied	\N	\N	\N	\N	102514	102514	270283
11796	12587	30	applied	\N	\N	\N	\N	102515	102515	270284
11796	12588	31	applied	\N	\N	\N	\N	102516	102516	270285
11796	12434	33	applied	\N	\N	\N	\N	102517	102517	270286
11796	12435	34	applied	\N	\N	\N	\N	102518	102518	270287
11796	12439	35	applied	\N	\N	\N	\N	102519	102519	270288
11796	12440	36	applied	\N	\N	\N	\N	102520	102520	270289
11796	12444	37	applied	\N	\N	\N	\N	102521	102521	270290
11796	12446	38	applied	\N	\N	\N	\N	102522	102522	270291
11796	12448	39	applied	\N	\N	\N	\N	102523	102523	270292
11796	12450	40	applied	\N	\N	\N	\N	102524	102524	270293
11796	12452	41	applied	\N	\N	\N	\N	102525	102525	270294
11796	12457	42	applied	\N	\N	\N	\N	102526	102526	270295
11796	12462	43	applied	\N	\N	\N	\N	102527	102527	270296
11796	12463	44	applied	\N	\N	\N	\N	102528	102528	270297
11789	12527	54	applied	\N	\N	\N	\N	102406	102406	270175
11796	12472	48	applied	\N	\N	\N	\N	102532	102532	270301
11796	12620	50	applied	\N	\N	\N	\N	102534	102534	270303
11796	12621	51	applied	\N	\N	\N	\N	102535	102535	270304
11796	12401	52	applied	\N	\N	\N	\N	102536	102536	270305
11796	12386	53	applied	\N	\N	\N	\N	102537	102537	270306
11796	12397	54	applied	\N	\N	\N	\N	102538	102538	270307
11796	12138	55	applied	\N	\N	\N	\N	102539	102539	270308
11796	12140	56	applied	\N	\N	\N	\N	102540	102540	270309
11796	12398	57	applied	\N	\N	\N	\N	102541	102541	102541
11796	12461	58	applied	\N	\N	\N	\N	102542	102542	270310
11796	12349	59	applied	\N	\N	\N	\N	102543	102543	270311
11796	12443	66	applied	\N	\N	\N	\N	102550	102550	270312
11796	12350	61	failed	Amount_insufficient_to_create_account	\N	\N	\N	102545	102545	\N
11796	12375	62	failed	Amount_insufficient_to_create_account	\N	\N	\N	102546	102546	\N
11796	12377	63	failed	Amount_insufficient_to_create_account	\N	\N	\N	102547	102547	\N
11796	12392	64	failed	Amount_insufficient_to_create_account	\N	\N	\N	102548	102548	\N
11796	12396	65	failed	Amount_insufficient_to_create_account	\N	\N	\N	102549	102549	\N
11796	12454	67	applied	\N	\N	\N	\N	102551	102551	270313
11796	12455	68	applied	\N	\N	\N	\N	102552	102552	270314
11796	12456	69	applied	\N	\N	\N	\N	102553	102553	270315
11796	12144	70	applied	\N	\N	\N	\N	102554	102554	270316
11796	12660	71	applied	\N	\N	\N	\N	102555	102555	270317
11796	12405	72	applied	\N	\N	\N	\N	102556	102556	270318
11796	12409	73	applied	\N	\N	\N	\N	102557	102557	270319
11796	12145	74	applied	\N	\N	\N	\N	102558	102558	270320
11796	12148	75	applied	\N	\N	\N	\N	102559	102559	270321
11796	12149	76	applied	\N	\N	\N	\N	102560	102560	270322
11796	12151	77	applied	\N	\N	\N	\N	102561	102561	270323
11796	12154	78	applied	\N	\N	\N	\N	102562	102562	270324
11796	12155	79	applied	\N	\N	\N	\N	102563	102563	270325
11796	12157	80	applied	\N	\N	\N	\N	102564	102564	270326
11796	12160	81	applied	\N	\N	\N	\N	102565	102565	270327
11796	12161	82	applied	\N	\N	\N	\N	102566	102566	270328
11796	12165	83	applied	\N	\N	\N	\N	102567	102567	270329
11796	12166	84	applied	\N	\N	\N	\N	102568	102568	270330
11796	12167	85	applied	\N	\N	\N	\N	102569	102569	270331
11796	12169	86	applied	\N	\N	\N	\N	102570	102570	270332
11796	12172	87	applied	\N	\N	\N	\N	102571	102571	270333
11796	12173	88	applied	\N	\N	\N	\N	102572	102572	270334
11796	12175	89	applied	\N	\N	\N	\N	102573	102573	270335
11796	12176	90	applied	\N	\N	\N	\N	102574	102574	270336
11796	12180	92	applied	\N	\N	\N	\N	102576	102576	270338
11796	12187	93	applied	\N	\N	\N	\N	102577	102577	270339
11796	12188	94	applied	\N	\N	\N	\N	102578	102578	270340
11796	12189	95	applied	\N	\N	\N	\N	102579	102579	270341
11796	12190	96	applied	\N	\N	\N	\N	102580	102580	270342
11796	12191	97	applied	\N	\N	\N	\N	102581	102581	270343
11796	12193	98	applied	\N	\N	\N	\N	102582	102582	270344
11796	12195	99	applied	\N	\N	\N	\N	102583	102583	270345
11796	12198	100	applied	\N	\N	\N	\N	102584	102584	270346
11796	12199	101	applied	\N	\N	\N	\N	102585	102585	270347
11796	12201	102	applied	\N	\N	\N	\N	102586	102586	270348
11796	12205	103	applied	\N	\N	\N	\N	102587	102587	270349
11796	12206	104	applied	\N	\N	\N	\N	102588	102588	270350
11796	12207	105	applied	\N	\N	\N	\N	102589	102589	270351
11796	12209	106	applied	\N	\N	\N	\N	102590	102590	270352
11796	12211	107	applied	\N	\N	\N	\N	102591	102591	270353
11796	12215	109	applied	\N	\N	\N	\N	102593	102593	270355
11796	12217	110	applied	\N	\N	\N	\N	102594	102594	270356
11796	12219	111	applied	\N	\N	\N	\N	102595	102595	270357
11796	12222	112	applied	\N	\N	\N	\N	102596	102596	270358
11796	12223	113	applied	\N	\N	\N	\N	102597	102597	270359
11796	12225	114	applied	\N	\N	\N	\N	102598	102598	270360
11796	12227	115	applied	\N	\N	\N	\N	102599	102599	270361
11796	12229	116	applied	\N	\N	\N	\N	102600	102600	270362
11796	12230	117	applied	\N	\N	\N	\N	102601	102601	270363
11796	12233	118	applied	\N	\N	\N	\N	102602	102602	270364
11796	12234	119	applied	\N	\N	\N	\N	102603	102603	270365
11796	12236	120	applied	\N	\N	\N	\N	102604	102604	270366
11796	12238	121	applied	\N	\N	\N	\N	102605	102605	270367
11796	12241	122	applied	\N	\N	\N	\N	102606	102606	270368
11796	12244	123	applied	\N	\N	\N	\N	102607	102607	270369
11796	12245	124	applied	\N	\N	\N	\N	102608	102608	270370
11801	12676	1	applied	\N	\N	\N	\N	102615	102615	270377
11804	12678	0	applied	\N	\N	\N	\N	102618	102618	270380
11808	12679	0	applied	\N	\N	\N	\N	102622	102622	270384
11811	12680	0	applied	\N	\N	\N	\N	102625	102625	270387
11813	12681	0	applied	\N	\N	\N	\N	102627	102627	270389
11817	12683	0	applied	\N	\N	\N	\N	102631	102631	270393
11817	12684	1	applied	\N	\N	\N	\N	102632	102632	270394
11818	12685	0	applied	\N	\N	\N	\N	102633	102633	270395
11818	12686	1	applied	\N	\N	\N	\N	102634	102634	270396
11818	12687	2	applied	\N	\N	\N	\N	102635	102635	270397
11831	12707	0	applied	\N	\N	\N	\N	102663	102663	270425
11831	12708	1	applied	\N	\N	\N	\N	102664	102664	270426
11832	12709	0	applied	\N	\N	\N	\N	102665	102665	270427
11832	12710	1	applied	\N	\N	\N	\N	102666	102666	270428
11832	12711	2	applied	\N	\N	\N	\N	102667	102667	270429
11832	12712	3	applied	\N	\N	\N	\N	102668	102668	270430
11835	12714	0	applied	\N	\N	\N	\N	102680	102680	270442
11835	12715	1	applied	\N	\N	\N	\N	102681	102681	270443
11835	12716	2	applied	\N	\N	\N	\N	102682	102682	270444
11835	12717	3	applied	\N	\N	\N	\N	102683	102683	270445
11838	12721	0	applied	\N	\N	\N	\N	102687	102687	270449
11840	12722	0	applied	\N	\N	\N	\N	102689	102689	270451
11848	12727	0	applied	\N	\N	\N	\N	102698	102698	270460
11850	12728	0	applied	\N	\N	1000000000	\N	102699	102699	270461
11850	12729	1	applied	\N	\N	\N	\N	102700	102700	270462
11862	12735	0	applied	\N	\N	\N	\N	102721	102721	270483
11862	12736	1	applied	\N	\N	\N	\N	102722	102722	270484
11862	12737	2	applied	\N	\N	\N	\N	102723	102723	270485
11869	12739	0	applied	\N	\N	\N	\N	102856	102856	270618
11872	12742	0	applied	\N	\N	\N	\N	102862	102862	270624
11872	12743	1	applied	\N	\N	\N	\N	102863	102863	270625
11872	12744	2	applied	\N	\N	\N	\N	102864	102864	270626
11875	12735	1	applied	\N	\N	\N	\N	102870	102870	270632
11875	12740	2	applied	\N	\N	\N	\N	102871	102871	270633
11796	12468	46	applied	\N	\N	\N	\N	102530	102530	270299
11796	12470	47	applied	\N	\N	\N	\N	102531	102531	270300
11867	12739	0	applied	\N	\N	\N	\N	102854	102854	270616
11875	12745	3	applied	\N	\N	\N	\N	102872	102872	270634
11875	12694	4	applied	\N	\N	\N	\N	102873	102873	270635
11875	12695	5	applied	\N	\N	\N	\N	102874	102874	270636
11875	12696	6	applied	\N	\N	\N	\N	102875	102875	270637
11875	12697	7	applied	\N	\N	\N	\N	102876	102876	270638
11875	12698	8	applied	\N	\N	\N	\N	102877	102877	270639
11875	12699	9	applied	\N	\N	\N	\N	102878	102878	270640
11875	12700	11	applied	\N	\N	\N	\N	102879	102879	270641
11875	12701	12	applied	\N	\N	\N	\N	102880	102880	270642
11875	12682	13	applied	\N	\N	\N	\N	102881	102881	270643
11877	12749	0	applied	\N	\N	\N	\N	102937	102937	270699
11880	12750	0	applied	\N	\N	\N	\N	102946	102946	270708
11880	12751	1	applied	\N	\N	\N	\N	102947	102947	270709
11892	12761	0	applied	\N	\N	\N	\N	102969	102969	270731
11895	12764	0	applied	\N	\N	\N	\N	103096	103096	270858
11895	12765	1	applied	\N	\N	\N	\N	103097	103097	270859
11898	12769	0	applied	\N	\N	\N	\N	103101	103101	270863
11906	12777	0	applied	\N	\N	\N	\N	103113	103113	270875
11909	12780	0	applied	\N	\N	\N	\N	103116	103116	270878
11911	12782	0	applied	\N	\N	\N	\N	103118	103118	270880
11916	12784	0	applied	\N	\N	\N	\N	103147	103147	270909
11918	12785	0	applied	\N	\N	\N	\N	103149	103149	270911
11923	12790	0	applied	\N	\N	\N	\N	103155	103155	270917
11926	12794	0	applied	\N	\N	\N	\N	103159	103159	270921
11928	12796	0	applied	\N	\N	\N	\N	103161	103161	270923
11931	12797	0	applied	\N	\N	\N	\N	103166	103166	270928
11931	12799	2	applied	\N	\N	\N	\N	103168	103168	270930
11933	12800	0	applied	\N	\N	\N	\N	103170	103170	270932
11936	12801	0	applied	\N	\N	\N	\N	103204	103204	270966
11938	12802	0	applied	\N	\N	\N	\N	103205	103205	270967
11938	12803	1	applied	\N	\N	\N	\N	103206	103206	270968
11938	12804	2	applied	\N	\N	\N	\N	103207	103207	270969
11944	12815	0	applied	\N	\N	\N	\N	103227	103227	270989
11947	12807	0	applied	\N	\N	\N	\N	103231	103231	270993
11947	12819	1	applied	\N	\N	\N	\N	103232	103232	270994
11947	12820	2	applied	\N	\N	\N	\N	103233	103233	270995
11947	12821	3	applied	\N	\N	\N	\N	103234	103234	270996
11947	12818	4	applied	\N	\N	\N	\N	103235	103235	270997
11954	12822	0	applied	\N	\N	\N	\N	103280	103280	271042
11954	12823	1	applied	\N	\N	\N	\N	103281	103281	271043
11954	12824	2	applied	\N	\N	\N	\N	103282	103282	271044
11954	12825	3	applied	\N	\N	\N	\N	103283	103283	271045
11956	12827	1	applied	\N	\N	\N	\N	103287	103287	271049
11971	12835	0	applied	\N	\N	\N	\N	103311	103311	271073
11971	12836	1	applied	\N	\N	\N	\N	103312	103312	271074
11973	12838	0	applied	\N	\N	\N	\N	103314	103314	271076
11975	12839	0	applied	\N	\N	\N	\N	103316	103316	271078
11980	12843	0	applied	\N	\N	\N	\N	103324	103324	271086
11985	12846	0	applied	\N	\N	\N	\N	103329	103329	271091
11987	12847	0	applied	\N	\N	\N	\N	103331	103331	271093
11992	12850	0	applied	\N	\N	\N	\N	103338	103338	271100
11995	12851	0	applied	\N	\N	\N	\N	103341	103341	271103
11997	12852	0	applied	\N	\N	\N	\N	103343	103343	271105
12004	12858	0	applied	\N	\N	\N	\N	103353	103353	271115
12004	12859	1	applied	\N	\N	\N	\N	103354	103354	271116
12004	12860	2	applied	\N	\N	\N	\N	103355	103355	271117
12012	12870	0	applied	\N	\N	\N	\N	103368	103368	271130
12017	12873	0	applied	\N	\N	\N	\N	103570	103570	271332
12022	12874	0	applied	\N	\N	\N	\N	103575	103575	271337
12025	12878	0	applied	\N	\N	\N	\N	103579	103579	271341
12034	12884	0	applied	\N	\N	\N	\N	103591	103591	271353
12034	12885	1	applied	\N	\N	\N	\N	103592	103592	271354
12037	12889	0	applied	\N	\N	\N	\N	103596	103596	271358
12039	12889	0	applied	\N	\N	\N	\N	103598	103598	271360
12045	12892	0	applied	\N	\N	\N	\N	103604	103604	271366
12046	12893	0	applied	\N	\N	\N	\N	103605	103605	271367
12049	12894	0	applied	\N	\N	\N	\N	103608	103608	271370
12053	12896	0	applied	\N	\N	\N	\N	103612	103612	271374
12053	12897	1	applied	\N	\N	\N	\N	103613	103613	271375
12053	12898	2	applied	\N	\N	1000000000	\N	103614	103614	271376
12053	12899	3	applied	\N	\N	\N	\N	103615	103615	103615
12057	12900	0	applied	\N	\N	\N	\N	103619	103619	271380
12060	12902	0	applied	\N	\N	\N	\N	103683	103683	271443
12062	12903	0	applied	\N	\N	\N	\N	103809	103809	271568
12065	12909	0	applied	\N	\N	\N	\N	103819	103819	271573
12069	12914	0	applied	\N	\N	\N	\N	103912	103912	271663
12077	12925	0	applied	\N	\N	\N	\N	103926	103926	271674
12080	12926	0	applied	\N	\N	\N	\N	103929	103929	271677
12086	12930	0	applied	\N	\N	\N	\N	103941	103941	271689
12086	12931	1	applied	\N	\N	\N	\N	103942	103942	271690
12087	12932	0	applied	\N	\N	\N	\N	103943	103943	271691
12092	12935	0	applied	\N	\N	\N	\N	103981	103981	271729
12092	12936	1	applied	\N	\N	\N	\N	103982	103982	271730
12095	12940	0	applied	\N	\N	\N	\N	104029	104029	271774
12095	12941	1	applied	\N	\N	\N	\N	104030	104030	271775
12095	12942	2	applied	\N	\N	\N	\N	104031	104031	271776
12098	12945	0	applied	\N	\N	\N	\N	104034	104034	271779
12098	12946	1	applied	\N	\N	\N	\N	104035	104035	271780
12101	12947	0	applied	\N	\N	\N	\N	104040	104040	271785
12101	12948	1	applied	\N	\N	\N	\N	104041	104041	271786
12103	12950	1	applied	\N	\N	\N	\N	104045	104045	271790
12113	12958	0	applied	\N	\N	\N	\N	104056	104056	271801
12115	12959	0	applied	\N	\N	\N	\N	104058	104058	271803
12122	12963	0	applied	\N	\N	\N	\N	104065	104065	271810
12127	12965	0	applied	\N	\N	\N	\N	104070	104070	271815
12127	12966	1	applied	\N	\N	\N	\N	104071	104071	271816
12130	12968	0	applied	\N	\N	\N	\N	104074	104074	271819
12130	12969	1	applied	\N	\N	\N	\N	104075	104075	271820
12130	12970	2	applied	\N	\N	\N	\N	104076	104076	271821
12133	12968	0	applied	\N	\N	\N	\N	104080	104080	271825
12133	12969	1	applied	\N	\N	\N	\N	104081	104081	271826
12133	12970	2	applied	\N	\N	\N	\N	104082	104082	271827
12146	12982	0	applied	\N	\N	\N	\N	104103	104103	271848
12153	12986	0	applied	\N	\N	\N	\N	104109	104109	271854
12158	12988	1	applied	\N	\N	\N	\N	104116	104116	271861
12159	12987	0	applied	\N	\N	1000000000	\N	104117	104117	271862
12161	12989	0	applied	\N	\N	\N	\N	104123	104123	271868
12161	12990	1	applied	\N	\N	\N	\N	104124	104124	271869
11860	12734	0	applied	\N	\N	\N	\N	102719	102719	270481
11865	12738	0	applied	\N	\N	\N	\N	102852	102852	270614
11864	12586	17	applied	\N	\N	\N	\N	102744	102744	270506
11864	12587	18	applied	\N	\N	\N	\N	102745	102745	270507
11864	12588	19	applied	\N	\N	\N	\N	102746	102746	270508
11864	12696	20	applied	\N	\N	\N	\N	102747	102747	270509
11864	12697	21	applied	\N	\N	\N	\N	102748	102748	270510
11864	12698	22	applied	\N	\N	\N	\N	102749	102749	270511
11864	12699	23	applied	\N	\N	\N	\N	102750	102750	270512
11864	12700	24	applied	\N	\N	\N	\N	102751	102751	270513
11864	12701	25	applied	\N	\N	\N	\N	102752	102752	270514
11864	12434	26	applied	\N	\N	\N	\N	102753	102753	270515
11864	12435	27	applied	\N	\N	\N	\N	102754	102754	270516
11864	12439	28	applied	\N	\N	\N	\N	102755	102755	270517
11864	12444	30	applied	\N	\N	\N	\N	102757	102757	270519
11864	12446	31	applied	\N	\N	\N	\N	102758	102758	270520
11864	12448	32	applied	\N	\N	\N	\N	102759	102759	270521
11864	12450	33	applied	\N	\N	\N	\N	102760	102760	270522
11864	12452	34	applied	\N	\N	\N	\N	102761	102761	270523
11864	12457	35	applied	\N	\N	\N	\N	102762	102762	270524
11864	12462	36	applied	\N	\N	\N	\N	102763	102763	270525
11864	12463	37	applied	\N	\N	\N	\N	102764	102764	270526
11864	12464	38	applied	\N	\N	\N	\N	102765	102765	270527
11864	12468	39	applied	\N	\N	\N	\N	102766	102766	270528
11864	12470	40	applied	\N	\N	\N	\N	102767	102767	270529
11864	12472	41	applied	\N	\N	\N	\N	102768	102768	270530
11864	12619	42	applied	\N	\N	\N	\N	102769	102769	270531
11864	12620	43	applied	\N	\N	\N	\N	102770	102770	270532
11864	12621	44	applied	\N	\N	\N	\N	102771	102771	270533
11864	12436	45	applied	\N	\N	\N	\N	102772	102772	270534
11864	12443	48	applied	\N	\N	\N	\N	102774	102774	270536
11864	12454	49	applied	\N	\N	\N	\N	102775	102775	270537
11864	12455	50	applied	\N	\N	\N	\N	102776	102776	270538
11864	12456	51	applied	\N	\N	\N	\N	102777	102777	270539
11864	12660	52	applied	\N	\N	\N	\N	102778	102778	270540
11864	12438	53	applied	\N	\N	\N	\N	102779	102779	270541
11864	12441	54	applied	\N	\N	\N	\N	102780	102780	270542
11864	12442	55	applied	\N	\N	\N	\N	102781	102781	270543
11864	12445	56	applied	\N	\N	\N	\N	102782	102782	270544
11864	12447	57	applied	\N	\N	\N	\N	102783	102783	270545
11864	12449	58	applied	\N	\N	\N	\N	102784	102784	270546
11864	12451	59	applied	\N	\N	\N	\N	102785	102785	270547
11864	12453	60	applied	\N	\N	\N	\N	102786	102786	270548
11864	12458	61	applied	\N	\N	\N	\N	102787	102787	270549
11864	12460	63	applied	\N	\N	1000000000	\N	102789	102789	270551
11864	12465	64	applied	\N	\N	\N	\N	102790	102790	270552
11864	12466	65	applied	\N	\N	\N	\N	102791	102791	270553
11864	12467	66	applied	\N	\N	\N	\N	102792	102792	270554
11864	12469	67	applied	\N	\N	\N	\N	102793	102793	270555
11864	12471	68	applied	\N	\N	\N	\N	102794	102794	270556
11864	12473	69	applied	\N	\N	\N	\N	102795	102795	270557
11864	12474	70	applied	\N	\N	\N	\N	102796	102796	270558
11864	12475	71	applied	\N	\N	\N	\N	102797	102797	270559
11864	12476	72	applied	\N	\N	\N	\N	102798	102798	270560
11864	12477	73	applied	\N	\N	\N	\N	102799	102799	270561
11864	12478	74	applied	\N	\N	\N	\N	102800	102800	270562
11864	12479	75	applied	\N	\N	\N	\N	102801	102801	270563
11864	12480	76	applied	\N	\N	\N	\N	102802	102802	270564
11864	12481	77	applied	\N	\N	\N	\N	102803	102803	270565
11864	12482	78	applied	\N	\N	\N	\N	102804	102804	270566
11864	12483	79	applied	\N	\N	\N	\N	102805	102805	270567
11864	12484	80	applied	\N	\N	\N	\N	102806	102806	270568
11864	12485	81	applied	\N	\N	\N	\N	102807	102807	270569
11864	12486	82	applied	\N	\N	\N	\N	102808	102808	270570
11864	12488	84	applied	\N	\N	\N	\N	102810	102810	270572
11864	12489	85	applied	\N	\N	\N	\N	102811	102811	270573
11864	12490	86	applied	\N	\N	\N	\N	102812	102812	270574
11864	12491	87	applied	\N	\N	\N	\N	102813	102813	270575
11864	12492	88	applied	\N	\N	\N	\N	102814	102814	270576
11864	12493	89	applied	\N	\N	\N	\N	102815	102815	270577
11864	12494	90	applied	\N	\N	\N	\N	102816	102816	270578
11864	12495	91	applied	\N	\N	\N	\N	102817	102817	270579
11864	12496	92	applied	\N	\N	\N	\N	102818	102818	270580
11864	12497	93	applied	\N	\N	\N	\N	102819	102819	270581
11864	12498	94	applied	\N	\N	\N	\N	102820	102820	270582
11864	12499	95	applied	\N	\N	\N	\N	102821	102821	270583
11864	12500	96	applied	\N	\N	\N	\N	102822	102822	270584
11864	12502	97	applied	\N	\N	\N	\N	102823	102823	270585
11864	12503	98	applied	\N	\N	\N	\N	102824	102824	270586
11864	12504	99	applied	\N	\N	\N	\N	102825	102825	270587
11864	12506	101	applied	\N	\N	\N	\N	102827	102827	270589
11864	12507	102	applied	\N	\N	\N	\N	102828	102828	270590
11864	12508	103	applied	\N	\N	\N	\N	102829	102829	270591
11864	12509	104	applied	\N	\N	\N	\N	102830	102830	270592
11864	12510	105	applied	\N	\N	\N	\N	102831	102831	270593
11864	12511	106	applied	\N	\N	\N	\N	102832	102832	270594
11864	12512	107	applied	\N	\N	\N	\N	102833	102833	270595
11864	12513	108	applied	\N	\N	\N	\N	102834	102834	270596
11864	12514	109	applied	\N	\N	\N	\N	102835	102835	270597
11864	12515	110	applied	\N	\N	\N	\N	102836	102836	270598
11864	12516	111	applied	\N	\N	\N	\N	102837	102837	270599
11864	12517	112	applied	\N	\N	\N	\N	102838	102838	270600
11864	12518	113	applied	\N	\N	\N	\N	102839	102839	270601
11864	12519	114	applied	\N	\N	\N	\N	102840	102840	270602
11864	12520	115	applied	\N	\N	\N	\N	102841	102841	270603
11864	12521	116	applied	\N	\N	\N	\N	102842	102842	270604
11864	12523	118	applied	\N	\N	\N	\N	102844	102844	270606
11864	12524	119	applied	\N	\N	\N	\N	102845	102845	270607
11864	12525	120	applied	\N	\N	\N	\N	102846	102846	270608
11864	12526	121	applied	\N	\N	\N	\N	102847	102847	270609
12161	12991	2	applied	\N	\N	\N	\N	104125	104125	271870
12161	12992	3	applied	\N	\N	\N	\N	104126	104126	271871
12161	12993	4	applied	\N	\N	\N	\N	104127	104127	271872
12163	12989	0	applied	\N	\N	\N	\N	104133	104133	271878
12163	12990	1	applied	\N	\N	\N	\N	104134	104134	271879
12163	12991	2	applied	\N	\N	\N	\N	104135	104135	271880
12163	12992	3	applied	\N	\N	\N	\N	104136	104136	271881
12163	12993	4	applied	\N	\N	\N	\N	104137	104137	271882
12169	12998	0	applied	\N	\N	\N	\N	104143	104143	271888
12170	12999	0	applied	\N	\N	\N	\N	104144	104144	271889
12174	13002	0	applied	\N	\N	\N	\N	104151	104151	271896
11864	12655	14	applied	\N	\N	\N	\N	102741	102741	270503
11864	12585	16	applied	\N	\N	\N	\N	102743	102743	270505
11864	12530	125	applied	\N	\N	\N	\N	102851	102851	270613
11871	12742	0	applied	\N	\N	\N	\N	102859	102859	270621
11871	12743	1	applied	\N	\N	\N	\N	102860	102860	270622
11871	12744	2	applied	\N	\N	\N	\N	102861	102861	270623
11874	12748	0	applied	\N	\N	\N	\N	102868	102868	270630
11875	12684	15	applied	\N	\N	\N	\N	102883	102883	270645
11875	12685	16	applied	\N	\N	\N	\N	102884	102884	270646
11875	12686	17	applied	\N	\N	\N	\N	102885	102885	270647
11875	12687	18	applied	\N	\N	\N	\N	102886	102886	270648
11875	12688	19	applied	\N	\N	\N	\N	102887	102887	270649
11875	12689	20	applied	\N	\N	\N	\N	102888	102888	270650
11875	12691	22	applied	\N	\N	\N	\N	102890	102890	270652
11875	12692	23	applied	\N	\N	\N	\N	102891	102891	270653
11875	12702	24	applied	\N	\N	\N	\N	102892	102892	270654
11875	12703	25	applied	\N	\N	\N	\N	102893	102893	270655
11875	12704	26	applied	\N	\N	\N	\N	102894	102894	270656
11875	12705	27	applied	\N	\N	\N	\N	102895	102895	270657
11875	12706	28	applied	\N	\N	\N	\N	102896	102896	270658
11875	12707	29	applied	\N	\N	\N	\N	102897	102897	270659
11875	12708	30	applied	\N	\N	\N	\N	102898	102898	270660
11875	12709	31	applied	\N	\N	\N	\N	102899	102899	270661
11875	12710	32	applied	\N	\N	\N	\N	102900	102900	270662
11875	12711	33	applied	\N	\N	\N	\N	102901	102901	270663
11875	12712	34	applied	\N	\N	\N	\N	102902	102902	270664
11875	12713	35	applied	\N	\N	\N	\N	102903	102903	270665
11875	12714	36	applied	\N	\N	\N	\N	102904	102904	270666
11875	12715	37	applied	\N	\N	\N	\N	102905	102905	270667
11875	12717	39	applied	\N	\N	\N	\N	102907	102907	270669
11875	12718	40	applied	\N	\N	\N	\N	102908	102908	270670
11875	12719	41	applied	\N	\N	1000000000	\N	102909	102909	270671
11875	12720	42	applied	\N	\N	\N	\N	102910	102910	270672
11875	12721	43	applied	\N	\N	\N	\N	102911	102911	270673
11875	12722	44	applied	\N	\N	\N	\N	102912	102912	270674
11875	12723	45	applied	\N	\N	\N	\N	102913	102913	270675
11875	12724	46	applied	\N	\N	\N	\N	102914	102914	270676
11875	12725	47	applied	\N	\N	\N	\N	102915	102915	270677
11875	12726	48	applied	\N	\N	\N	\N	102916	102916	270678
11875	12727	49	applied	\N	\N	\N	\N	102917	102917	270679
11875	12728	50	applied	\N	\N	1000000000	\N	102918	102918	270680
11875	12729	51	applied	\N	\N	\N	\N	102919	102919	270681
11875	12730	52	applied	\N	\N	\N	\N	102920	102920	270682
11875	12731	53	applied	\N	\N	\N	\N	102921	102921	270683
11875	12732	54	applied	\N	\N	\N	\N	102922	102922	270684
11875	12734	56	applied	\N	\N	\N	\N	102924	102924	270686
11875	12736	57	applied	\N	\N	\N	\N	102925	102925	270687
11875	12737	58	applied	\N	\N	\N	\N	102926	102926	270688
11875	12738	59	applied	\N	\N	\N	\N	102927	102927	270689
11875	12739	60	applied	\N	\N	\N	\N	102928	102928	270690
11875	12741	61	applied	\N	\N	\N	\N	102929	102929	270691
11875	12742	62	applied	\N	\N	\N	\N	102930	102930	270692
11875	12743	63	applied	\N	\N	\N	\N	102931	102931	270693
11875	12744	64	applied	\N	\N	\N	\N	102932	102932	270694
11875	12746	65	applied	\N	\N	\N	\N	102933	102933	270695
11875	12747	66	applied	\N	\N	\N	\N	102934	102934	270696
11875	12748	67	applied	\N	\N	\N	\N	102935	102935	270697
11879	12750	0	applied	\N	\N	\N	\N	102944	102944	270706
11879	12751	1	applied	\N	\N	\N	\N	102945	102945	270707
11881	12750	0	applied	\N	\N	\N	\N	102948	102948	270710
11881	12751	1	applied	\N	\N	\N	\N	102949	102949	270711
11882	12753	1	applied	\N	\N	\N	\N	102951	102951	270713
11882	12754	2	applied	\N	\N	\N	\N	102952	102952	270714
11882	12755	3	applied	\N	\N	\N	\N	102953	102953	270715
11884	12752	0	applied	\N	\N	\N	\N	102958	102958	270720
11884	12753	1	applied	\N	\N	\N	\N	102959	102959	270721
11884	12754	2	applied	\N	\N	\N	\N	102960	102960	270722
11887	12757	0	applied	\N	\N	\N	\N	102964	102964	270726
11889	12758	0	applied	\N	\N	\N	\N	102966	102966	270728
11891	12760	0	applied	\N	\N	\N	\N	102968	102968	270730
11894	12584	0	applied	\N	\N	\N	\N	102972	102972	270734
11894	12693	1	applied	\N	\N	\N	\N	102973	102973	270735
11894	12735	2	applied	\N	\N	\N	\N	102974	102974	270736
11894	12740	3	applied	\N	\N	\N	\N	102975	102975	270737
11894	12745	4	applied	\N	\N	\N	\N	102976	102976	270738
11894	12750	5	applied	\N	\N	\N	\N	102977	102977	270739
11894	12646	6	applied	\N	\N	\N	\N	102978	102978	270740
11894	12568	8	applied	\N	\N	1000000000	\N	102980	102980	270742
11894	12694	9	applied	\N	\N	\N	\N	102981	102981	270743
11894	12618	10	applied	\N	\N	\N	\N	102982	102982	270744
11894	12695	11	applied	\N	\N	\N	\N	102983	102983	270745
11894	12650	12	applied	\N	\N	\N	\N	102984	102984	270746
11894	12652	13	applied	\N	\N	\N	\N	102985	102985	270747
11894	12654	14	applied	\N	\N	\N	\N	102986	102986	270748
11894	12655	15	applied	\N	\N	\N	\N	102987	102987	270749
11894	12657	16	applied	\N	\N	\N	\N	102988	102988	270750
11894	12585	17	applied	\N	\N	\N	\N	102989	102989	270751
11894	12586	18	applied	\N	\N	\N	\N	102990	102990	270752
11894	12587	19	applied	\N	\N	\N	\N	102991	102991	270753
11894	12588	20	applied	\N	\N	\N	\N	102992	102992	270754
11894	12696	21	applied	\N	\N	\N	\N	102993	102993	270755
11894	12697	22	applied	\N	\N	\N	\N	102994	102994	270756
11894	12698	23	applied	\N	\N	\N	\N	102995	102995	270757
11894	12700	25	applied	\N	\N	\N	\N	102997	102997	270759
11894	12701	26	applied	\N	\N	\N	\N	102998	102998	270760
11894	12619	27	applied	\N	\N	\N	\N	102999	102999	270761
11894	12620	28	applied	\N	\N	\N	\N	103000	103000	270762
11894	12621	29	applied	\N	\N	\N	\N	103001	103001	270763
11894	12530	30	applied	\N	\N	\N	\N	103002	103002	270764
11894	12531	31	applied	\N	\N	\N	\N	103003	103003	270765
11894	12532	32	applied	\N	\N	\N	\N	103004	103004	270766
11894	12533	33	applied	\N	\N	\N	\N	103005	103005	270767
11894	12534	34	applied	\N	\N	\N	\N	103006	103006	270768
11894	12535	35	applied	\N	\N	\N	\N	103007	103007	270769
11894	12536	36	applied	\N	\N	\N	\N	103008	103008	270770
11894	12660	37	applied	\N	\N	\N	\N	103009	103009	270771
11894	12537	38	applied	\N	\N	\N	\N	103010	103010	270772
11894	12538	39	applied	\N	\N	\N	\N	103011	103011	270773
11894	12539	40	applied	\N	\N	\N	\N	103012	103012	270774
11894	12541	42	applied	\N	\N	\N	\N	103014	103014	270776
11894	12542	43	applied	\N	\N	\N	\N	103015	103015	270777
11864	12528	123	applied	\N	\N	\N	\N	102849	102849	270611
11864	12529	124	applied	\N	\N	\N	\N	102850	102850	270612
11894	12544	45	applied	\N	\N	\N	\N	103017	103017	270779
11894	12545	46	applied	\N	\N	\N	\N	103018	103018	270780
11894	12546	47	applied	\N	\N	\N	\N	103019	103019	270781
11894	12547	48	applied	\N	\N	\N	\N	103020	103020	270782
11894	12548	49	applied	\N	\N	\N	\N	103021	103021	270783
11894	12549	50	applied	\N	\N	\N	\N	103022	103022	270784
11894	12550	51	applied	\N	\N	\N	\N	103023	103023	270785
11894	12551	52	applied	\N	\N	\N	\N	103024	103024	270786
11894	12552	53	applied	\N	\N	\N	\N	103025	103025	270787
11894	12553	54	applied	\N	\N	\N	\N	103026	103026	270788
11896	12766	0	applied	\N	\N	\N	\N	103098	103098	270860
11900	12770	0	applied	\N	\N	\N	\N	103104	103104	270866
11900	12771	1	applied	\N	\N	\N	\N	103105	103105	270867
11902	12773	0	applied	\N	\N	\N	\N	103107	103107	270869
11905	12776	0	applied	\N	\N	\N	\N	103112	103112	270874
11907	12778	0	applied	\N	\N	\N	\N	103114	103114	270876
11910	12781	0	applied	\N	\N	\N	\N	103117	103117	270879
11919	12786	0	applied	\N	\N	\N	\N	103150	103150	270912
11922	12789	0	applied	\N	\N	\N	\N	103154	103154	270916
11925	12792	0	applied	\N	\N	\N	\N	103157	103157	270919
11925	12793	1	applied	\N	\N	\N	\N	103158	103158	270920
11929	12796	0	applied	\N	\N	\N	\N	103162	103162	270924
11934	12770	0	applied	\N	\N	\N	\N	103171	103171	270933
11934	12771	1	applied	\N	\N	\N	\N	103172	103172	270934
11934	12772	2	applied	\N	\N	\N	\N	103173	103173	270935
11934	12773	3	applied	\N	\N	\N	\N	103174	103174	270936
11934	12774	4	applied	\N	\N	\N	\N	103175	103175	270937
11934	12775	5	applied	\N	\N	\N	\N	103176	103176	270938
11934	12776	6	applied	\N	\N	\N	\N	103177	103177	270939
11934	12777	7	applied	\N	\N	\N	\N	103178	103178	270940
11934	12779	9	applied	\N	\N	\N	\N	103180	103180	270942
11934	12780	10	applied	\N	\N	\N	\N	103181	103181	270943
11934	12781	11	applied	\N	\N	\N	\N	103182	103182	270944
11934	12782	12	applied	\N	\N	\N	\N	103183	103183	270945
11934	12783	13	applied	\N	\N	\N	\N	103184	103184	270946
11934	12784	14	applied	\N	\N	\N	\N	103185	103185	270947
11934	12785	15	applied	\N	\N	\N	\N	103186	103186	270948
11934	12786	16	applied	\N	\N	\N	\N	103187	103187	270949
11934	12787	17	applied	\N	\N	\N	\N	103188	103188	270950
11934	12788	18	applied	\N	\N	\N	\N	103189	103189	270951
11934	12789	19	applied	\N	\N	\N	\N	103190	103190	270952
11934	12790	20	applied	\N	\N	\N	\N	103191	103191	270953
11934	12791	21	applied	\N	\N	\N	\N	103192	103192	270954
11934	12792	22	applied	\N	\N	\N	\N	103193	103193	270955
11934	12793	23	applied	\N	\N	\N	\N	103194	103194	270956
11934	12794	24	applied	\N	\N	\N	\N	103195	103195	270957
11934	12796	26	applied	\N	\N	\N	\N	103197	103197	270959
11934	12797	27	applied	\N	\N	\N	\N	103198	103198	270960
11934	12798	28	applied	\N	\N	\N	\N	103199	103199	270961
11934	12799	29	applied	\N	\N	\N	\N	103200	103200	270962
11934	12800	30	applied	\N	\N	\N	\N	103201	103201	270963
11934	12801	31	applied	\N	\N	\N	\N	103202	103202	270964
11942	12807	0	applied	\N	\N	\N	\N	103218	103218	270980
11942	12808	1	applied	\N	\N	\N	\N	103219	103219	270981
11942	12809	2	applied	\N	\N	\N	\N	103220	103220	270982
11942	12810	3	applied	\N	\N	\N	\N	103221	103221	270983
11942	12811	4	applied	\N	\N	\N	\N	103222	103222	270984
11942	12812	5	applied	\N	\N	\N	\N	103223	103223	270985
11942	12813	6	applied	\N	\N	\N	\N	103224	103224	270986
11942	12814	7	applied	\N	\N	\N	\N	103225	103225	270987
11959	12829	0	applied	\N	\N	\N	\N	103290	103290	271052
11959	12830	1	applied	\N	\N	\N	\N	103291	103291	271053
11962	12819	1	applied	\N	\N	\N	\N	103297	103297	271059
11962	12820	2	applied	\N	\N	\N	\N	103298	103298	271060
11962	12821	3	applied	\N	\N	\N	\N	103299	103299	271061
11962	12818	4	applied	\N	\N	\N	\N	103300	103300	271062
11964	12833	0	applied	\N	\N	\N	\N	103302	103302	271064
11968	12834	0	applied	\N	\N	\N	\N	103306	103306	271068
11974	12838	0	applied	\N	\N	\N	\N	103315	103315	271077
11976	12840	0	applied	\N	\N	\N	\N	103317	103317	271079
11976	12841	1	applied	\N	\N	\N	\N	103318	103318	271080
11977	12840	0	applied	\N	\N	\N	\N	103319	103319	271081
11977	12841	1	applied	\N	\N	\N	\N	103320	103320	271082
11981	12843	0	applied	\N	\N	\N	\N	103325	103325	271087
11983	12845	0	applied	\N	\N	\N	\N	103327	103327	271089
11988	12847	0	applied	\N	\N	\N	\N	103332	103332	271094
11990	12848	0	applied	\N	\N	\N	\N	103334	103334	271096
11990	12849	1	applied	\N	\N	\N	\N	103335	103335	271097
12005	12861	0	applied	\N	\N	\N	\N	103356	103356	271118
12007	12862	0	applied	\N	\N	\N	\N	103358	103358	271120
12008	12862	0	applied	\N	\N	\N	\N	103359	103359	271121
12013	12807	0	applied	\N	\N	\N	\N	103369	103369	271131
12013	12819	1	applied	\N	\N	\N	\N	103370	103370	271132
12013	12820	2	applied	\N	\N	\N	\N	103371	103371	271133
12013	12821	3	applied	\N	\N	\N	\N	103372	103372	271134
12013	12750	4	applied	\N	\N	\N	\N	103373	103373	271135
12013	12854	5	applied	\N	\N	1000000000	\N	103374	103374	271136
12013	12865	6	applied	\N	\N	\N	\N	103375	103375	271137
12013	12818	7	applied	\N	\N	\N	\N	103376	103376	271138
12013	12866	8	applied	\N	\N	\N	\N	103377	103377	271139
12013	12749	9	applied	\N	\N	\N	\N	103378	103378	271140
12013	12751	10	applied	\N	\N	\N	\N	103379	103379	271141
12013	12752	11	applied	\N	\N	\N	\N	103380	103380	271142
12013	12753	12	applied	\N	\N	\N	\N	103381	103381	271143
12013	12755	14	applied	\N	\N	\N	\N	103383	103383	271145
12013	12756	15	applied	\N	\N	\N	\N	103384	103384	271146
12013	12757	16	applied	\N	\N	\N	\N	103385	103385	271147
12013	12758	17	applied	\N	\N	\N	\N	103386	103386	271148
12013	12759	18	applied	\N	\N	\N	\N	103387	103387	271149
12013	12760	19	applied	\N	\N	\N	\N	103388	103388	271150
12013	12761	20	applied	\N	\N	\N	\N	103389	103389	271151
12013	12762	21	applied	\N	\N	\N	\N	103390	103390	271152
12013	12763	22	applied	\N	\N	\N	\N	103391	103391	271153
12013	12764	23	applied	\N	\N	\N	\N	103392	103392	271154
12013	12765	24	applied	\N	\N	\N	\N	103393	103393	271155
12013	12766	25	applied	\N	\N	\N	\N	103394	103394	271156
12013	12767	26	applied	\N	\N	\N	\N	103395	103395	271157
12013	12768	27	applied	\N	\N	\N	\N	103396	103396	271158
12013	12769	28	applied	\N	\N	\N	\N	103397	103397	271159
12013	12770	29	applied	\N	\N	\N	\N	103398	103398	271160
11894	12543	44	applied	\N	\N	\N	\N	103016	103016	270778
11894	12558	59	applied	\N	\N	\N	\N	103031	103031	270793
11894	12559	60	applied	\N	\N	\N	\N	103032	103032	270794
11894	12560	61	applied	\N	\N	\N	\N	103033	103033	270795
11894	12561	62	applied	\N	\N	\N	\N	103034	103034	270796
11894	12562	63	applied	\N	\N	\N	\N	103035	103035	270797
11894	12563	64	applied	\N	\N	\N	\N	103036	103036	270798
11894	12564	65	applied	\N	\N	\N	\N	103037	103037	270799
11894	12565	66	applied	\N	\N	\N	\N	103038	103038	270800
11894	12566	67	applied	\N	\N	\N	\N	103039	103039	270801
11894	12567	68	applied	\N	\N	\N	\N	103040	103040	270802
11894	12569	69	applied	\N	\N	\N	\N	103041	103041	270803
11894	12570	70	applied	\N	\N	\N	\N	103042	103042	270804
11894	12571	71	applied	\N	\N	\N	\N	103043	103043	270805
11894	12572	72	applied	\N	\N	\N	\N	103044	103044	270806
11894	12574	74	applied	\N	\N	\N	\N	103046	103046	270808
11894	12575	75	applied	\N	\N	\N	\N	103047	103047	270809
11894	12576	76	applied	\N	\N	\N	\N	103048	103048	270810
11894	12577	77	applied	\N	\N	\N	\N	103049	103049	270811
11894	12578	78	applied	\N	\N	\N	\N	103050	103050	270812
11894	12579	79	applied	\N	\N	\N	\N	103051	103051	270813
11894	12580	80	applied	\N	\N	\N	\N	103052	103052	270814
11894	12581	81	applied	\N	\N	\N	\N	103053	103053	270815
11894	12582	82	applied	\N	\N	\N	\N	103054	103054	270816
11894	12583	83	applied	\N	\N	\N	\N	103055	103055	270817
11894	12589	84	applied	\N	\N	\N	\N	103056	103056	270818
11894	12590	85	applied	\N	\N	\N	\N	103057	103057	270819
11894	12591	86	applied	\N	\N	\N	\N	103058	103058	270820
11894	12592	87	applied	\N	\N	\N	\N	103059	103059	270821
11894	12593	88	applied	\N	\N	\N	\N	103060	103060	270822
11894	12594	89	applied	\N	\N	\N	\N	103061	103061	270823
11894	12596	91	applied	\N	\N	\N	\N	103063	103063	270825
11894	12597	92	applied	\N	\N	\N	\N	103064	103064	270826
11894	12598	93	applied	\N	\N	\N	\N	103065	103065	270827
11894	12599	96	applied	\N	\N	\N	\N	103066	103066	270828
11894	12600	97	applied	\N	\N	\N	\N	103067	103067	270829
11894	12601	98	applied	\N	\N	\N	\N	103068	103068	270830
11894	12602	99	applied	\N	\N	\N	\N	103069	103069	270831
11894	12603	100	applied	\N	\N	\N	\N	103070	103070	270832
11894	12604	101	applied	\N	\N	\N	\N	103071	103071	270833
11894	12605	102	applied	\N	\N	\N	\N	103072	103072	270834
11894	12606	103	applied	\N	\N	\N	\N	103073	103073	270835
11894	12607	104	applied	\N	\N	\N	\N	103074	103074	270836
11894	12608	105	applied	\N	\N	\N	\N	103075	103075	270837
11894	12609	106	applied	\N	\N	\N	\N	103076	103076	270838
11894	12610	107	applied	\N	\N	\N	\N	103077	103077	270839
11894	12611	108	applied	\N	\N	\N	\N	103078	103078	270840
11894	12613	110	applied	\N	\N	\N	\N	103080	103080	270842
11894	12614	111	applied	\N	\N	\N	\N	103081	103081	270843
11894	12615	112	applied	\N	\N	\N	\N	103082	103082	270844
11894	12616	113	applied	\N	\N	\N	\N	103083	103083	270845
11894	12617	114	applied	\N	\N	\N	\N	103084	103084	270846
11894	12622	115	applied	\N	\N	\N	\N	103085	103085	270847
11894	12623	116	applied	\N	\N	\N	\N	103086	103086	270848
11894	12624	117	applied	\N	\N	\N	\N	103087	103087	270849
11894	12625	118	applied	\N	\N	\N	\N	103088	103088	270850
11894	12626	119	applied	\N	\N	1000000000	\N	103089	103089	270851
11894	12627	120	applied	\N	\N	\N	\N	103090	103090	270852
11894	12628	121	applied	\N	\N	\N	\N	103091	103091	270853
11894	12629	122	applied	\N	\N	\N	\N	103092	103092	270854
11894	12630	123	applied	\N	\N	\N	\N	103093	103093	270855
11894	12631	124	applied	\N	\N	\N	\N	103094	103094	270856
11894	12632	125	applied	\N	\N	\N	\N	103095	103095	270857
11897	12768	1	applied	\N	\N	\N	\N	103100	103100	270862
11903	12773	0	applied	\N	\N	\N	\N	103109	103109	270871
11903	12774	1	applied	\N	\N	\N	\N	103110	103110	270872
11908	12779	0	applied	\N	\N	\N	\N	103115	103115	270877
11913	12782	0	applied	\N	\N	\N	\N	103120	103120	270882
11915	12693	0	applied	\N	\N	\N	\N	103122	103122	270884
11915	12735	1	applied	\N	\N	\N	\N	103123	103123	270885
11915	12740	2	applied	\N	\N	\N	\N	103124	103124	270886
11915	12745	3	applied	\N	\N	\N	\N	103125	103125	270887
11915	12750	4	applied	\N	\N	\N	\N	103126	103126	270888
11915	12646	5	applied	\N	\N	\N	\N	103127	103127	270889
11915	12647	6	applied	\N	\N	\N	\N	103128	103128	270890
11915	12694	7	applied	\N	\N	\N	\N	103129	103129	270891
11915	12618	8	applied	\N	\N	\N	\N	103130	103130	270892
11915	12695	9	applied	\N	\N	\N	\N	103131	103131	270893
11915	12650	10	applied	\N	\N	\N	\N	103132	103132	270894
11915	12654	12	applied	\N	\N	\N	\N	103134	103134	270896
11915	12655	13	applied	\N	\N	\N	\N	103135	103135	270897
11915	12657	14	applied	\N	\N	\N	\N	103136	103136	270898
11915	12696	15	applied	\N	\N	\N	\N	103137	103137	270899
11915	12697	16	applied	\N	\N	\N	\N	103138	103138	270900
11915	12698	17	applied	\N	\N	\N	\N	103139	103139	270901
11915	12699	18	applied	\N	\N	\N	\N	103140	103140	270902
11915	12700	19	applied	\N	\N	\N	\N	103141	103141	270903
11915	12701	20	applied	\N	\N	\N	\N	103142	103142	270904
11915	12619	21	applied	\N	\N	\N	\N	103143	103143	270905
11915	12620	22	applied	\N	\N	\N	\N	103144	103144	270906
11915	12621	23	applied	\N	\N	\N	\N	103145	103145	270907
11915	12660	24	applied	\N	\N	\N	\N	103146	103146	270908
11917	12784	0	applied	\N	\N	\N	\N	103148	103148	270910
11920	12786	0	applied	\N	\N	\N	\N	103151	103151	270913
11935	12801	0	applied	\N	\N	\N	\N	103203	103203	270965
11940	12806	1	applied	\N	\N	\N	\N	103209	103209	270971
11941	12807	0	applied	\N	\N	\N	\N	103210	103210	270972
11941	12808	1	applied	\N	\N	\N	\N	103211	103211	270973
11941	12809	2	applied	\N	\N	\N	\N	103212	103212	270974
11941	12810	3	applied	\N	\N	\N	\N	103213	103213	270975
12013	12771	30	applied	\N	\N	\N	\N	103399	103399	271161
12013	12772	31	applied	\N	\N	\N	\N	103400	103400	271162
12013	12773	32	applied	\N	\N	\N	\N	103401	103401	271163
12013	12774	33	applied	\N	\N	\N	\N	103402	103402	271164
12013	12775	34	applied	\N	\N	\N	\N	103403	103403	271165
12013	12776	35	applied	\N	\N	\N	\N	103404	103404	271166
12013	12777	36	applied	\N	\N	\N	\N	103405	103405	271167
12013	12778	37	applied	\N	\N	\N	\N	103406	103406	271168
12013	12779	38	applied	\N	\N	\N	\N	103407	103407	271169
12013	12780	39	applied	\N	\N	\N	\N	103408	103408	271170
12013	12781	40	applied	\N	\N	\N	\N	103409	103409	271171
11894	12557	58	applied	\N	\N	\N	\N	103030	103030	270792
11946	12817	0	applied	\N	\N	\N	\N	103229	103229	270991
11946	12818	1	applied	\N	\N	\N	\N	103230	103230	270992
11949	12822	0	applied	\N	\N	\N	\N	103238	103238	271000
11949	12823	1	applied	\N	\N	\N	\N	103239	103239	271001
11951	12807	0	applied	\N	\N	\N	\N	103240	103240	271002
11951	12819	1	applied	\N	\N	\N	\N	103241	103241	271003
11951	12820	2	applied	\N	\N	\N	\N	103242	103242	271004
11951	12821	3	applied	\N	\N	\N	\N	103243	103243	271005
11951	12633	4	applied	\N	\N	\N	\N	103244	103244	271006
11951	12818	5	applied	\N	\N	\N	\N	103245	103245	271007
11951	12634	6	applied	\N	\N	\N	\N	103246	103246	271008
11951	12635	7	applied	\N	\N	\N	\N	103247	103247	271009
11951	12636	8	applied	\N	\N	\N	\N	103248	103248	271010
11951	12637	9	applied	\N	\N	\N	\N	103249	103249	271011
11951	12638	10	applied	\N	\N	\N	\N	103250	103250	271012
11951	12640	12	applied	\N	\N	\N	\N	103252	103252	271014
11951	12641	13	applied	\N	\N	\N	\N	103253	103253	271015
11951	12642	14	applied	\N	\N	\N	\N	103254	103254	271016
11951	12643	15	applied	\N	\N	\N	\N	103255	103255	271017
11953	12822	0	applied	\N	\N	\N	\N	103276	103276	271038
11953	12823	1	applied	\N	\N	\N	\N	103277	103277	271039
11953	12824	2	applied	\N	\N	\N	\N	103278	103278	271040
11953	12825	3	applied	\N	\N	\N	\N	103279	103279	271041
11958	12828	0	applied	\N	\N	\N	\N	103289	103289	271051
11961	12831	0	applied	\N	\N	\N	\N	103294	103294	271056
11961	12832	1	applied	\N	\N	\N	\N	103295	103295	271057
11963	12833	0	applied	\N	\N	\N	\N	103301	103301	271063
11966	12833	0	applied	\N	\N	\N	\N	103304	103304	271066
11970	12835	0	applied	\N	\N	\N	\N	103309	103309	271071
11970	12836	1	applied	\N	\N	\N	\N	103310	103310	271072
11972	12837	0	applied	\N	\N	\N	\N	103313	103313	271075
11984	12845	0	applied	\N	\N	\N	\N	103328	103328	271090
11989	12847	0	applied	\N	\N	\N	\N	103333	103333	271095
11991	12848	0	applied	\N	\N	\N	\N	103336	103336	271098
11991	12849	1	applied	\N	\N	\N	\N	103337	103337	271099
11994	12851	0	applied	\N	\N	\N	\N	103340	103340	271102
11996	12852	0	applied	\N	\N	\N	\N	103342	103342	271104
11998	12852	0	applied	\N	\N	\N	\N	103344	103344	271106
12001	12854	0	applied	\N	\N	1000000000	\N	103348	103348	271110
12001	12855	1	applied	\N	\N	\N	\N	103349	103349	271111
12003	12856	0	applied	\N	\N	\N	\N	103352	103352	271114
12006	12862	0	applied	\N	\N	\N	\N	103357	103357	271119
12009	12862	0	applied	\N	\N	\N	\N	103360	103360	271122
12014	12870	0	applied	\N	\N	\N	\N	103488	103488	271250
12016	12871	0	applied	\N	\N	\N	\N	103568	103568	271330
12016	12872	1	applied	\N	\N	\N	\N	103569	103569	271331
12020	12874	0	applied	\N	\N	\N	\N	103573	103573	271335
12041	12890	0	applied	\N	\N	\N	\N	103600	103600	271362
12044	12892	0	applied	\N	\N	\N	\N	103603	103603	271365
12048	12894	0	applied	\N	\N	\N	\N	103607	103607	271369
12051	12894	0	applied	\N	\N	\N	\N	103610	103610	271372
12052	12895	0	applied	\N	\N	\N	\N	103611	103611	271373
12054	12900	0	applied	\N	\N	\N	\N	103616	103616	271377
12058	12901	0	applied	\N	\N	\N	\N	103620	103620	271381
12063	12905	0	applied	\N	\N	\N	\N	103811	103811	271569
12063	12906	1	applied	\N	\N	\N	\N	103812	103812	271570
12063	12908	3	applied	\N	\N	\N	\N	103814	103814	103814
12066	12909	0	applied	\N	\N	\N	\N	103820	103820	271574
12072	12918	0	applied	\N	\N	\N	\N	103916	103916	271666
12075	12921	0	applied	\N	\N	\N	\N	103922	103922	271671
12075	12922	1	applied	\N	\N	\N	\N	103923	103923	271672
12078	12925	0	applied	\N	\N	\N	\N	103927	103927	271675
12075	12923	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	103924	103924	\N
12083	12930	0	applied	\N	\N	\N	\N	103935	103935	271683
12083	12931	1	applied	\N	\N	\N	\N	103936	103936	271684
12096	12943	0	applied	\N	\N	\N	\N	104032	104032	271777
12099	12945	0	applied	\N	\N	\N	\N	104036	104036	271781
12099	12946	1	applied	\N	\N	\N	\N	104037	104037	271782
12106	12952	0	applied	\N	\N	\N	\N	104048	104048	271793
12108	12952	0	applied	\N	\N	\N	\N	104049	104049	271794
12114	12958	0	applied	\N	\N	\N	\N	104057	104057	271802
12116	12959	0	applied	\N	\N	\N	\N	104059	104059	271804
12125	12964	0	applied	\N	\N	\N	\N	104068	104068	271813
12137	12973	0	applied	\N	\N	\N	\N	104088	104088	271833
12142	12975	0	applied	\N	\N	\N	\N	104092	104092	271837
12142	12976	1	applied	\N	\N	\N	\N	104093	104093	271838
12144	12975	0	applied	\N	\N	\N	\N	104096	104096	271841
12144	12976	1	applied	\N	\N	\N	\N	104097	104097	271842
12149	12984	0	applied	\N	\N	\N	\N	104105	104105	271850
12151	12985	0	applied	\N	\N	\N	\N	104107	104107	271852
12154	12986	0	applied	\N	\N	\N	\N	104110	104110	271855
12166	12994	0	applied	\N	\N	\N	\N	104138	104138	271883
12166	12995	1	applied	\N	\N	\N	\N	104139	104139	271884
12166	12996	2	applied	\N	\N	\N	\N	104140	104140	271885
12166	12997	3	applied	\N	\N	\N	\N	104141	104141	271886
12171	12999	0	applied	\N	\N	\N	\N	104145	104145	271890
12177	13008	0	applied	\N	\N	\N	\N	104160	104160	271905
12181	13010	1	applied	\N	\N	\N	\N	104171	104171	271916
12181	13011	2	applied	\N	\N	\N	\N	104172	104172	271917
12181	13012	3	applied	\N	\N	\N	\N	104173	104173	271918
12182	13013	0	applied	\N	\N	\N	\N	104174	104174	271919
12182	13014	1	applied	\N	\N	\N	\N	104175	104175	271920
12187	13018	0	applied	\N	\N	\N	\N	104282	104282	272027
12192	13013	0	applied	\N	\N	\N	\N	104293	104293	272038
12192	12994	1	applied	\N	\N	\N	\N	104294	104294	272039
12192	12995	2	applied	\N	\N	\N	\N	104295	104295	272040
12192	12996	3	applied	\N	\N	\N	\N	104296	104296	272041
12192	12997	4	applied	\N	\N	\N	\N	104297	104297	272042
12192	12998	5	applied	\N	\N	\N	\N	104298	104298	272043
12192	12999	6	applied	\N	\N	\N	\N	104299	104299	272044
12192	13000	7	applied	\N	\N	\N	\N	104300	104300	272045
12192	13001	8	applied	\N	\N	\N	\N	104301	104301	272046
12192	13002	9	applied	\N	\N	\N	\N	104302	104302	272047
12192	13004	11	applied	\N	\N	\N	\N	104304	104304	272049
12192	13005	12	applied	\N	\N	\N	\N	104305	104305	272050
12192	13006	13	applied	\N	\N	\N	\N	104306	104306	272051
12192	13007	14	applied	\N	\N	\N	\N	104307	104307	272052
12192	13008	15	applied	\N	\N	\N	\N	104308	104308	272053
12192	13009	16	applied	\N	\N	\N	\N	104309	104309	272054
11941	12812	5	applied	\N	\N	\N	\N	103215	103215	270977
11941	12814	7	applied	\N	\N	\N	\N	103217	103217	270979
11965	12833	0	applied	\N	\N	\N	\N	103303	103303	271065
11967	12833	0	applied	\N	\N	\N	\N	103305	103305	271067
11969	12835	0	applied	\N	\N	\N	\N	103307	103307	271069
11969	12836	1	applied	\N	\N	\N	\N	103308	103308	271070
11978	12840	0	applied	\N	\N	\N	\N	103321	103321	271083
11979	12842	0	applied	\N	\N	\N	\N	103323	103323	271085
11986	12847	0	applied	\N	\N	\N	\N	103330	103330	271092
11993	12851	0	applied	\N	\N	\N	\N	103339	103339	271101
12000	12854	0	applied	\N	\N	1000000000	\N	103346	103346	271108
12000	12855	1	applied	\N	\N	\N	\N	103347	103347	271109
12002	12856	0	applied	\N	\N	\N	\N	103350	103350	271112
12002	12857	1	applied	\N	\N	\N	\N	103351	103351	271113
12010	12863	0	applied	\N	\N	\N	\N	103361	103361	271123
12011	12864	0	applied	\N	\N	\N	\N	103362	103362	271124
12011	12865	1	applied	\N	\N	\N	\N	103363	103363	271125
12011	12866	2	applied	\N	\N	\N	\N	103364	103364	271126
12011	12867	3	applied	\N	\N	\N	\N	103365	103365	271127
12011	12868	4	applied	\N	\N	\N	\N	103366	103366	271128
12011	12869	5	applied	\N	\N	\N	\N	103367	103367	271129
12019	12874	0	applied	\N	\N	\N	\N	103572	103572	271334
12027	12865	1	applied	\N	\N	\N	\N	103583	103583	271345
12027	12866	2	applied	\N	\N	\N	\N	103584	103584	271346
12029	12881	0	applied	\N	\N	\N	\N	103586	103586	271348
12031	12881	0	applied	\N	\N	\N	\N	103588	103588	271350
12033	12883	0	applied	\N	\N	\N	\N	103590	103590	271352
12036	12887	0	applied	\N	\N	\N	\N	103594	103594	271356
12036	12888	1	applied	\N	\N	\N	\N	103595	103595	271357
12043	12892	0	applied	\N	\N	\N	\N	103602	103602	271364
12055	12900	0	applied	\N	\N	\N	\N	103617	103617	271378
12059	12884	0	applied	\N	\N	\N	\N	103621	103621	271382
12059	12854	1	applied	\N	\N	1000000000	\N	103622	103622	271383
12059	12898	2	applied	\N	\N	1000000000	\N	103623	103623	271384
12059	12840	3	applied	\N	\N	\N	\N	103624	103624	271385
12059	12865	4	applied	\N	\N	\N	\N	103625	103625	271386
12059	12899	5	applied	\N	\N	\N	\N	103626	103626	103626
12059	12866	6	applied	\N	\N	\N	\N	103627	103627	271387
12059	12841	7	applied	\N	\N	\N	\N	103628	103628	271388
12059	12842	8	applied	\N	\N	\N	\N	103629	103629	271389
12059	12843	9	applied	\N	\N	\N	\N	103630	103630	271390
12059	12845	11	applied	\N	\N	\N	\N	103632	103632	271392
12059	12846	12	applied	\N	\N	\N	\N	103633	103633	271393
12059	12847	13	applied	\N	\N	\N	\N	103634	103634	271394
12059	12848	14	applied	\N	\N	\N	\N	103635	103635	271395
12059	12849	15	applied	\N	\N	\N	\N	103636	103636	271396
12059	12850	16	applied	\N	\N	\N	\N	103637	103637	271397
12059	12851	17	applied	\N	\N	\N	\N	103638	103638	271398
12059	12852	18	applied	\N	\N	\N	\N	103639	103639	271399
12059	12853	19	applied	\N	\N	\N	\N	103640	103640	271400
12059	12855	20	applied	\N	\N	\N	\N	103641	103641	271401
12059	12856	21	applied	\N	\N	\N	\N	103642	103642	271402
12059	12857	22	applied	\N	\N	\N	\N	103643	103643	271403
12059	12858	23	applied	\N	\N	\N	\N	103644	103644	271404
12059	12859	24	applied	\N	\N	\N	\N	103645	103645	271405
12059	12860	25	applied	\N	\N	\N	\N	103646	103646	271406
12059	12861	26	applied	\N	\N	\N	\N	103647	103647	271407
12059	12863	28	applied	\N	\N	\N	\N	103649	103649	271409
12059	12864	29	applied	\N	\N	\N	\N	103650	103650	271410
12059	12867	30	applied	\N	\N	\N	\N	103651	103651	271411
12059	12868	31	applied	\N	\N	\N	\N	103652	103652	271412
12059	12869	32	applied	\N	\N	\N	\N	103653	103653	271413
12059	12870	33	applied	\N	\N	\N	\N	103654	103654	271414
12059	12871	34	applied	\N	\N	\N	\N	103655	103655	271415
12059	12872	35	applied	\N	\N	\N	\N	103656	103656	271416
12059	12873	36	applied	\N	\N	\N	\N	103657	103657	271417
12059	12874	37	applied	\N	\N	\N	\N	103658	103658	271418
12059	12875	38	applied	\N	\N	\N	\N	103659	103659	271419
12059	12876	39	applied	\N	\N	\N	\N	103660	103660	271420
12059	12877	40	applied	\N	\N	\N	\N	103661	103661	271421
12059	12878	41	applied	\N	\N	\N	\N	103662	103662	271422
12059	12879	42	applied	\N	\N	\N	\N	103663	103663	271423
12059	12880	43	applied	\N	\N	\N	\N	103664	103664	271424
12059	12882	45	applied	\N	\N	\N	\N	103666	103666	271426
12059	12883	46	applied	\N	\N	\N	\N	103667	103667	271427
12059	12885	47	applied	\N	\N	\N	\N	103668	103668	271428
12059	12886	48	applied	\N	\N	\N	\N	103669	103669	271429
12059	12887	49	applied	\N	\N	\N	\N	103670	103670	271430
12059	12888	50	applied	\N	\N	\N	\N	103671	103671	271431
12059	12889	51	applied	\N	\N	\N	\N	103672	103672	271432
12059	12890	52	applied	\N	\N	\N	\N	103673	103673	271433
12059	12891	53	applied	\N	\N	\N	\N	103674	103674	271434
12059	12892	54	applied	\N	\N	\N	\N	103675	103675	271435
12059	12893	55	applied	\N	\N	\N	\N	103676	103676	271436
12059	12894	57	applied	\N	\N	\N	\N	103677	103677	271437
12059	12895	58	applied	\N	\N	\N	\N	103678	103678	271438
12059	12896	59	applied	\N	\N	\N	\N	103679	103679	271439
12059	12897	60	applied	\N	\N	\N	\N	103680	103680	271440
12059	12900	61	applied	\N	\N	\N	\N	103681	103681	271441
12061	12807	0	applied	\N	\N	\N	\N	103684	103684	271444
12061	12819	1	applied	\N	\N	\N	\N	103685	103685	271445
12061	12820	2	applied	\N	\N	\N	\N	103686	103686	271446
12061	12821	3	applied	\N	\N	\N	\N	103687	103687	271447
12061	12884	4	applied	\N	\N	\N	\N	103688	103688	271448
12061	12758	5	applied	\N	\N	\N	\N	103689	103689	271449
12061	12759	6	applied	\N	\N	\N	\N	103690	103690	271450
12061	12854	7	applied	\N	\N	1000000000	\N	103691	103691	271451
12061	12760	8	applied	\N	\N	\N	\N	103692	103692	271452
12061	12898	9	applied	\N	\N	1000000000	\N	103693	103693	271453
12061	12865	10	applied	\N	\N	\N	\N	103694	103694	271454
12061	12761	11	applied	\N	\N	\N	\N	103695	103695	271455
12192	13010	17	applied	\N	\N	\N	\N	104310	104310	272055
12192	13011	18	applied	\N	\N	\N	\N	104311	104311	272056
12192	13012	19	applied	\N	\N	\N	\N	104312	104312	272057
12192	13014	20	applied	\N	\N	\N	\N	104313	104313	272058
12192	13016	22	applied	\N	\N	\N	\N	104315	104315	272060
12192	13017	23	applied	\N	\N	\N	\N	104316	104316	272061
12192	13018	24	applied	\N	\N	\N	\N	104317	104317	272062
12192	13019	25	applied	\N	\N	\N	\N	104318	104318	272063
12192	13020	26	applied	\N	\N	\N	\N	104319	104319	272064
12192	13021	27	applied	\N	\N	\N	\N	104320	104320	272065
11960	12831	0	applied	\N	\N	\N	\N	103292	103292	271054
11960	12832	1	applied	\N	\N	\N	\N	103293	103293	271055
12013	12786	45	applied	\N	\N	\N	\N	103414	103414	271176
12013	12787	46	applied	\N	\N	\N	\N	103415	103415	271177
12013	12788	47	applied	\N	\N	\N	\N	103416	103416	271178
12013	12789	48	applied	\N	\N	\N	\N	103417	103417	271179
12013	12790	49	applied	\N	\N	\N	\N	103418	103418	271180
12013	12791	50	applied	\N	\N	\N	\N	103419	103419	271181
12013	12792	51	applied	\N	\N	\N	\N	103420	103420	271182
12013	12793	52	applied	\N	\N	\N	\N	103421	103421	271183
12013	12794	53	applied	\N	\N	\N	\N	103422	103422	271184
12013	12795	54	applied	\N	\N	\N	\N	103423	103423	271185
12013	12796	55	applied	\N	\N	\N	\N	103424	103424	271186
12013	12797	56	applied	\N	\N	\N	\N	103425	103425	271187
12013	12798	57	applied	\N	\N	\N	\N	103426	103426	271188
12013	12799	58	applied	\N	\N	\N	\N	103427	103427	271189
12013	12801	60	applied	\N	\N	\N	\N	103429	103429	271191
12013	12802	61	applied	\N	\N	\N	\N	103430	103430	271192
12013	12803	62	applied	\N	\N	\N	\N	103431	103431	271193
12013	12804	63	applied	\N	\N	\N	\N	103432	103432	271194
12013	12805	64	applied	\N	\N	\N	\N	103433	103433	271195
12013	12806	65	applied	\N	\N	\N	\N	103434	103434	271196
12013	12808	66	applied	\N	\N	\N	\N	103435	103435	271197
12013	12809	67	applied	\N	\N	\N	\N	103436	103436	271198
12013	12813	69	applied	\N	\N	\N	\N	103437	103437	271199
12013	12814	70	applied	\N	\N	\N	\N	103438	103438	271200
12013	12815	71	applied	\N	\N	\N	\N	103439	103439	271201
12013	12816	72	applied	\N	\N	\N	\N	103440	103440	271202
12013	12817	73	applied	\N	\N	\N	\N	103441	103441	271203
12013	12822	74	applied	\N	\N	\N	\N	103442	103442	271204
12013	12823	75	applied	\N	\N	\N	\N	103443	103443	271205
12013	12824	76	applied	\N	\N	\N	\N	103444	103444	271206
12013	12826	78	applied	\N	\N	\N	\N	103446	103446	271208
12013	12827	79	applied	\N	\N	\N	\N	103447	103447	271209
12013	12828	80	applied	\N	\N	\N	\N	103448	103448	271210
12013	12829	81	applied	\N	\N	\N	\N	103449	103449	271211
12013	12830	82	applied	\N	\N	\N	\N	103450	103450	271212
12013	12831	83	applied	\N	\N	\N	\N	103451	103451	271213
12013	12832	84	applied	\N	\N	\N	\N	103452	103452	271214
12013	12833	85	applied	\N	\N	\N	\N	103453	103453	271215
12013	12834	86	applied	\N	\N	\N	\N	103454	103454	271216
12013	12835	87	applied	\N	\N	\N	\N	103455	103455	271217
12013	12836	88	applied	\N	\N	\N	\N	103456	103456	271218
12013	12837	89	applied	\N	\N	\N	\N	103457	103457	271219
12013	12838	90	applied	\N	\N	\N	\N	103458	103458	271220
12013	12839	91	applied	\N	\N	\N	\N	103459	103459	271221
12013	12840	92	applied	\N	\N	\N	\N	103460	103460	271222
12013	12841	93	applied	\N	\N	\N	\N	103461	103461	271223
12013	12843	95	applied	\N	\N	\N	\N	103463	103463	271225
12013	12844	96	applied	\N	\N	\N	\N	103464	103464	271226
12013	12845	97	applied	\N	\N	\N	\N	103465	103465	271227
12013	12846	98	applied	\N	\N	\N	\N	103466	103466	271228
12013	12847	99	applied	\N	\N	\N	\N	103467	103467	271229
12013	12848	100	applied	\N	\N	\N	\N	103468	103468	271230
12013	12849	101	applied	\N	\N	\N	\N	103469	103469	271231
12013	12850	102	applied	\N	\N	\N	\N	103470	103470	271232
12013	12851	103	applied	\N	\N	\N	\N	103471	103471	271233
12013	12852	104	applied	\N	\N	\N	\N	103472	103472	271234
12013	12853	105	applied	\N	\N	\N	\N	103473	103473	271235
12013	12855	106	applied	\N	\N	\N	\N	103474	103474	271236
12013	12856	107	applied	\N	\N	\N	\N	103475	103475	271237
12013	12857	108	applied	\N	\N	\N	\N	103476	103476	271238
12013	12858	109	applied	\N	\N	\N	\N	103477	103477	271239
12013	12859	110	applied	\N	\N	\N	\N	103478	103478	271240
12013	12861	112	applied	\N	\N	\N	\N	103480	103480	271242
12013	12862	113	applied	\N	\N	\N	\N	103481	103481	271243
12013	12863	114	applied	\N	\N	\N	\N	103482	103482	271244
12013	12864	115	applied	\N	\N	\N	\N	103483	103483	271245
12013	12867	116	applied	\N	\N	\N	\N	103484	103484	271246
12013	12868	117	applied	\N	\N	\N	\N	103485	103485	271247
12013	12869	118	applied	\N	\N	\N	\N	103486	103486	271248
12013	12870	119	applied	\N	\N	\N	\N	103487	103487	271249
12015	12807	0	applied	\N	\N	\N	\N	103489	103489	271251
12015	12819	1	applied	\N	\N	\N	\N	103490	103490	271252
12015	12820	2	applied	\N	\N	\N	\N	103491	103491	271253
12015	12821	3	applied	\N	\N	\N	\N	103492	103492	271254
12015	12854	4	applied	\N	\N	1000000000	\N	103493	103493	271255
12015	12789	5	applied	\N	\N	\N	\N	103494	103494	271256
12015	12790	6	applied	\N	\N	\N	\N	103495	103495	271257
12015	12791	7	applied	\N	\N	\N	\N	103496	103496	271258
12015	12865	9	applied	\N	\N	\N	\N	103498	103498	271260
12015	12793	10	applied	\N	\N	\N	\N	103499	103499	271261
12015	12794	11	applied	\N	\N	\N	\N	103500	103500	271262
12015	12795	12	applied	\N	\N	\N	\N	103501	103501	271263
12015	12818	13	applied	\N	\N	\N	\N	103502	103502	271264
12015	12866	14	applied	\N	\N	\N	\N	103503	103503	271265
12015	12796	15	applied	\N	\N	\N	\N	103504	103504	271266
12015	12797	16	applied	\N	\N	\N	\N	103505	103505	271267
12015	12798	17	applied	\N	\N	\N	\N	103506	103506	271268
12015	12799	18	applied	\N	\N	\N	\N	103507	103507	271269
12015	12800	19	applied	\N	\N	\N	\N	103508	103508	271270
12015	12801	20	applied	\N	\N	\N	\N	103509	103509	271271
12015	12802	21	applied	\N	\N	\N	\N	103510	103510	271272
12015	12803	22	applied	\N	\N	\N	\N	103511	103511	271273
12015	12804	23	applied	\N	\N	\N	\N	103512	103512	271274
12015	12805	24	applied	\N	\N	\N	\N	103513	103513	271275
12015	12808	26	applied	\N	\N	\N	\N	103515	103515	271277
12015	12809	27	applied	\N	\N	\N	\N	103516	103516	271278
12015	12813	28	applied	\N	\N	\N	\N	103517	103517	271279
12015	12814	29	applied	\N	\N	\N	\N	103518	103518	271280
12015	12815	30	applied	\N	\N	\N	\N	103519	103519	271281
12061	12762	12	applied	\N	\N	\N	\N	103696	103696	271456
12061	12763	13	applied	\N	\N	\N	\N	103697	103697	271457
12061	12764	14	applied	\N	\N	\N	\N	103698	103698	271458
12061	12899	15	applied	\N	\N	\N	\N	103699	103699	103699
12061	12818	16	applied	\N	\N	\N	\N	103700	103700	271459
12061	12866	17	applied	\N	\N	\N	\N	103701	103701	271460
12061	12765	18	applied	\N	\N	\N	\N	103702	103702	271461
12061	12766	19	applied	\N	\N	\N	\N	103703	103703	271462
12061	12767	20	applied	\N	\N	\N	\N	103704	103704	271463
12061	12768	21	applied	\N	\N	\N	\N	103705	103705	271464
12061	12769	22	applied	\N	\N	\N	\N	103706	103706	271465
12013	12785	44	applied	\N	\N	\N	\N	103413	103413	271175
12015	12824	36	applied	\N	\N	\N	\N	103524	103524	271286
12015	12825	37	applied	\N	\N	\N	\N	103525	103525	271287
12015	12826	38	applied	\N	\N	\N	\N	103526	103526	271288
12015	12827	39	applied	\N	\N	\N	\N	103527	103527	271289
12015	12828	40	applied	\N	\N	\N	\N	103528	103528	271290
12015	12829	41	applied	\N	\N	\N	\N	103529	103529	271291
12015	12830	42	applied	\N	\N	\N	\N	103530	103530	271292
12015	12831	43	applied	\N	\N	\N	\N	103531	103531	271293
12015	12832	44	applied	\N	\N	\N	\N	103532	103532	271294
12015	12833	45	applied	\N	\N	\N	\N	103533	103533	271295
12015	12834	46	applied	\N	\N	\N	\N	103534	103534	271296
12015	12835	47	applied	\N	\N	\N	\N	103535	103535	271297
12015	12837	49	applied	\N	\N	\N	\N	103537	103537	271299
12015	12838	50	applied	\N	\N	\N	\N	103538	103538	271300
12015	12839	51	applied	\N	\N	\N	\N	103539	103539	271301
12015	12840	52	applied	\N	\N	\N	\N	103540	103540	271302
12015	12841	53	applied	\N	\N	\N	\N	103541	103541	271303
12015	12842	54	applied	\N	\N	\N	\N	103542	103542	271304
12015	12843	55	applied	\N	\N	\N	\N	103543	103543	271305
12015	12844	56	applied	\N	\N	\N	\N	103544	103544	271306
12015	12845	57	applied	\N	\N	\N	\N	103545	103545	271307
12015	12846	58	applied	\N	\N	\N	\N	103546	103546	271308
12015	12847	59	applied	\N	\N	\N	\N	103547	103547	271309
12015	12848	60	applied	\N	\N	\N	\N	103548	103548	271310
12015	12849	61	applied	\N	\N	\N	\N	103549	103549	271311
12015	12850	62	applied	\N	\N	\N	\N	103550	103550	271312
12015	12851	63	applied	\N	\N	\N	\N	103551	103551	271313
12015	12852	64	applied	\N	\N	\N	\N	103552	103552	271314
12015	12855	66	applied	\N	\N	\N	\N	103554	103554	271316
12015	12856	67	applied	\N	\N	\N	\N	103555	103555	271317
12015	12857	68	applied	\N	\N	\N	\N	103556	103556	271318
12015	12858	69	applied	\N	\N	\N	\N	103557	103557	271319
12015	12859	70	applied	\N	\N	\N	\N	103558	103558	271320
12015	12860	71	applied	\N	\N	\N	\N	103559	103559	271321
12015	12861	72	applied	\N	\N	\N	\N	103560	103560	271322
12015	12862	73	applied	\N	\N	\N	\N	103561	103561	271323
12015	12863	74	applied	\N	\N	\N	\N	103562	103562	271324
12015	12864	75	applied	\N	\N	\N	\N	103563	103563	271325
12015	12867	76	applied	\N	\N	\N	\N	103564	103564	271326
12015	12868	77	applied	\N	\N	\N	\N	103565	103565	271327
12015	12869	78	applied	\N	\N	\N	\N	103566	103566	271328
12015	12870	79	applied	\N	\N	\N	\N	103567	103567	271329
12018	12874	0	applied	\N	\N	\N	\N	103571	103571	271333
12023	12875	0	applied	\N	\N	\N	\N	103576	103576	271338
12024	12877	0	applied	\N	\N	\N	\N	103578	103578	271340
12026	12879	0	applied	\N	\N	\N	\N	103580	103580	271342
12026	12880	1	applied	\N	\N	\N	\N	103581	103581	271343
12028	12881	0	applied	\N	\N	\N	\N	103585	103585	271347
12032	12882	0	applied	\N	\N	\N	\N	103589	103589	271351
12035	12886	0	applied	\N	\N	\N	\N	103593	103593	271355
12038	12889	0	applied	\N	\N	\N	\N	103597	103597	271359
12040	12890	0	applied	\N	\N	\N	\N	103599	103599	271361
12042	12891	0	applied	\N	\N	\N	\N	103601	103601	271363
12047	12893	0	applied	\N	\N	\N	\N	103606	103606	271368
12050	12894	0	applied	\N	\N	\N	\N	103609	103609	271371
12056	12900	0	applied	\N	\N	\N	\N	103618	103618	271379
12067	12884	0	applied	\N	\N	\N	\N	103821	103821	271575
12067	12854	1	applied	\N	\N	1000000000	\N	103822	103822	271576
12067	12825	3	applied	\N	\N	\N	\N	103824	103824	271578
12067	12865	4	applied	\N	\N	\N	\N	103825	103825	271579
12067	12899	5	applied	\N	\N	\N	\N	103826	103826	103826
12067	12866	6	applied	\N	\N	\N	\N	103827	103827	271580
12067	12826	7	applied	\N	\N	\N	\N	103828	103828	271581
12067	12827	8	applied	\N	\N	\N	\N	103829	103829	271582
12067	12828	9	applied	\N	\N	\N	\N	103830	103830	271583
12067	12904	10	applied	\N	\N	\N	\N	103831	103831	103831
12067	12908	11	applied	\N	\N	\N	\N	103832	103832	103832
12067	12829	12	applied	\N	\N	\N	\N	103833	103833	271584
12067	12830	13	applied	\N	\N	\N	\N	103834	103834	271585
12067	12831	14	applied	\N	\N	\N	\N	103835	103835	271586
12067	12832	15	applied	\N	\N	\N	\N	103836	103836	271587
12067	12833	16	applied	\N	\N	\N	\N	103837	103837	271588
12067	12834	17	applied	\N	\N	\N	\N	103838	103838	271589
12067	12835	18	applied	\N	\N	\N	\N	103839	103839	271590
12067	12836	19	applied	\N	\N	\N	\N	103840	103840	271591
12067	12837	20	applied	\N	\N	\N	\N	103841	103841	271592
12067	12838	21	applied	\N	\N	\N	\N	103842	103842	271593
12067	12839	22	applied	\N	\N	\N	\N	103843	103843	271594
12067	12841	24	applied	\N	\N	\N	\N	103845	103845	271596
12067	12842	25	applied	\N	\N	\N	\N	103846	103846	271597
12067	12843	26	applied	\N	\N	\N	\N	103847	103847	271598
12067	12844	27	applied	\N	\N	\N	\N	103848	103848	271599
12067	12845	29	applied	\N	\N	\N	\N	103849	103849	271600
12067	12846	30	applied	\N	\N	\N	\N	103850	103850	271601
12067	12847	31	applied	\N	\N	\N	\N	103851	103851	271602
12067	12848	32	applied	\N	\N	\N	\N	103852	103852	271603
12067	12849	33	applied	\N	\N	\N	\N	103853	103853	271604
12067	12850	34	applied	\N	\N	\N	\N	103854	103854	271605
12067	12851	35	applied	\N	\N	\N	\N	103855	103855	271606
12067	12852	36	applied	\N	\N	\N	\N	103856	103856	271607
12067	12853	37	applied	\N	\N	\N	\N	103857	103857	271608
12067	12855	38	applied	\N	\N	\N	\N	103858	103858	271609
12067	12856	39	applied	\N	\N	\N	\N	103859	103859	271610
12067	12857	40	applied	\N	\N	\N	\N	103860	103860	271611
12067	12859	42	applied	\N	\N	\N	\N	103862	103862	271613
12067	12860	43	applied	\N	\N	\N	\N	103863	103863	271614
12067	12861	44	applied	\N	\N	\N	\N	103864	103864	271615
12067	12862	45	applied	\N	\N	\N	\N	103865	103865	271616
12067	12863	46	applied	\N	\N	\N	\N	103866	103866	271617
12067	12864	47	applied	\N	\N	\N	\N	103867	103867	271618
12067	12867	48	applied	\N	\N	\N	\N	103868	103868	271619
12067	12868	49	applied	\N	\N	\N	\N	103869	103869	271620
12067	12869	50	applied	\N	\N	\N	\N	103870	103870	271621
12067	12870	51	applied	\N	\N	\N	\N	103871	103871	271622
12067	12871	52	applied	\N	\N	\N	\N	103872	103872	271623
12067	12872	53	applied	\N	\N	\N	\N	103873	103873	271624
12067	12873	54	applied	\N	\N	\N	\N	103874	103874	271625
12067	12874	55	applied	\N	\N	\N	\N	103875	103875	271626
12067	12875	56	applied	\N	\N	\N	\N	103876	103876	271627
12015	12817	32	applied	\N	\N	\N	\N	103521	103521	271283
12015	12823	35	applied	\N	\N	\N	\N	103523	103523	271285
12061	12773	26	applied	\N	\N	\N	\N	103710	103710	271469
12061	12775	28	applied	\N	\N	\N	\N	103712	103712	271471
12061	12776	29	applied	\N	\N	\N	\N	103713	103713	271472
12061	12777	30	applied	\N	\N	\N	\N	103714	103714	271473
12061	12778	31	applied	\N	\N	\N	\N	103715	103715	271474
12061	12779	32	applied	\N	\N	\N	\N	103716	103716	271475
12061	12780	33	applied	\N	\N	\N	\N	103717	103717	271476
12061	12781	34	applied	\N	\N	\N	\N	103718	103718	271477
12061	12782	35	applied	\N	\N	\N	\N	103719	103719	271478
12061	12783	36	applied	\N	\N	\N	\N	103720	103720	271479
12061	12784	37	applied	\N	\N	\N	\N	103721	103721	271480
12061	12785	38	applied	\N	\N	\N	\N	103722	103722	271481
12061	12786	39	applied	\N	\N	\N	\N	103723	103723	271482
12061	12787	40	applied	\N	\N	\N	\N	103724	103724	271483
12061	12788	41	applied	\N	\N	\N	\N	103725	103725	271484
12061	12789	42	applied	\N	\N	\N	\N	103726	103726	271485
12061	12790	43	applied	\N	\N	\N	\N	103727	103727	271486
12061	12792	45	applied	\N	\N	\N	\N	103729	103729	271488
12061	12793	46	applied	\N	\N	\N	\N	103730	103730	271489
12061	12794	47	applied	\N	\N	\N	\N	103731	103731	271490
12061	12795	48	applied	\N	\N	\N	\N	103732	103732	271491
12061	12796	49	applied	\N	\N	\N	\N	103733	103733	271492
12061	12797	50	applied	\N	\N	\N	\N	103734	103734	271493
12061	12798	51	applied	\N	\N	\N	\N	103735	103735	271494
12061	12799	52	applied	\N	\N	\N	\N	103736	103736	271495
12061	12800	53	applied	\N	\N	\N	\N	103737	103737	271496
12061	12801	54	applied	\N	\N	\N	\N	103738	103738	271497
12061	12802	55	applied	\N	\N	\N	\N	103739	103739	271498
12061	12803	56	applied	\N	\N	\N	\N	103740	103740	271499
12061	12804	57	applied	\N	\N	\N	\N	103741	103741	271500
12061	12805	58	applied	\N	\N	\N	\N	103742	103742	271501
12061	12806	59	applied	\N	\N	\N	\N	103743	103743	271502
12061	12808	60	applied	\N	\N	\N	\N	103744	103744	271503
12061	12813	62	applied	\N	\N	\N	\N	103746	103746	271505
12061	12814	63	applied	\N	\N	\N	\N	103747	103747	271506
12061	12815	64	applied	\N	\N	\N	\N	103748	103748	271507
12061	12816	65	applied	\N	\N	\N	\N	103749	103749	271508
12061	12817	66	applied	\N	\N	\N	\N	103750	103750	271509
12061	12822	67	applied	\N	\N	\N	\N	103751	103751	271510
12061	12823	68	applied	\N	\N	\N	\N	103752	103752	271511
12061	12824	69	applied	\N	\N	\N	\N	103753	103753	271512
12061	12825	70	applied	\N	\N	\N	\N	103754	103754	271513
12061	12826	71	applied	\N	\N	\N	\N	103755	103755	271514
12061	12827	72	applied	\N	\N	\N	\N	103756	103756	271515
12061	12828	73	applied	\N	\N	\N	\N	103757	103757	271516
12061	12829	74	applied	\N	\N	\N	\N	103758	103758	271517
12061	12830	75	applied	\N	\N	\N	\N	103759	103759	271518
12061	12831	76	applied	\N	\N	\N	\N	103760	103760	271519
12061	12832	77	applied	\N	\N	\N	\N	103761	103761	271520
12061	12834	79	applied	\N	\N	\N	\N	103763	103763	271522
12061	12835	80	applied	\N	\N	\N	\N	103764	103764	271523
12061	12836	81	applied	\N	\N	\N	\N	103765	103765	271524
12061	12837	82	applied	\N	\N	\N	\N	103766	103766	271525
12061	12838	83	applied	\N	\N	\N	\N	103767	103767	271526
12061	12839	84	applied	\N	\N	\N	\N	103768	103768	271527
12061	12840	85	applied	\N	\N	\N	\N	103769	103769	271528
12061	12841	86	applied	\N	\N	\N	\N	103770	103770	271529
12061	12842	87	applied	\N	\N	\N	\N	103771	103771	271530
12061	12843	88	applied	\N	\N	\N	\N	103772	103772	271531
12061	12844	89	applied	\N	\N	\N	\N	103773	103773	271532
12061	12845	90	applied	\N	\N	\N	\N	103774	103774	271533
12061	12846	91	applied	\N	\N	\N	\N	103775	103775	271534
12061	12847	92	applied	\N	\N	\N	\N	103776	103776	271535
12061	12848	93	applied	\N	\N	\N	\N	103777	103777	271536
12061	12849	94	applied	\N	\N	\N	\N	103778	103778	271537
12061	12851	96	applied	\N	\N	\N	\N	103780	103780	271539
12061	12852	97	applied	\N	\N	\N	\N	103781	103781	271540
12061	12853	98	applied	\N	\N	\N	\N	103782	103782	271541
12061	12855	99	applied	\N	\N	\N	\N	103783	103783	271542
12061	12856	100	applied	\N	\N	\N	\N	103784	103784	271543
12061	12857	101	applied	\N	\N	\N	\N	103785	103785	271544
12061	12858	102	applied	\N	\N	\N	\N	103786	103786	271545
12061	12859	103	applied	\N	\N	\N	\N	103787	103787	271546
12061	12860	104	applied	\N	\N	\N	\N	103788	103788	271547
12061	12861	105	applied	\N	\N	\N	\N	103789	103789	271548
12061	12862	106	applied	\N	\N	\N	\N	103790	103790	271549
12061	12863	107	applied	\N	\N	\N	\N	103791	103791	271550
12061	12864	108	applied	\N	\N	\N	\N	103792	103792	271551
12061	12867	109	applied	\N	\N	\N	\N	103793	103793	271552
12061	12868	110	applied	\N	\N	\N	\N	103794	103794	271553
12061	12869	111	applied	\N	\N	\N	\N	103795	103795	271554
12061	12871	113	applied	\N	\N	\N	\N	103797	103797	271556
12061	12872	115	applied	\N	\N	\N	\N	103798	103798	271557
12061	12873	116	applied	\N	\N	\N	\N	103799	103799	271558
12061	12874	117	applied	\N	\N	\N	\N	103800	103800	271559
12061	12875	118	applied	\N	\N	\N	\N	103801	103801	271560
12061	12876	119	applied	\N	\N	\N	\N	103802	103802	271561
12061	12877	120	applied	\N	\N	\N	\N	103803	103803	271562
12061	12878	121	applied	\N	\N	\N	\N	103804	103804	271563
12061	12879	122	applied	\N	\N	\N	\N	103805	103805	271564
12061	12880	123	applied	\N	\N	\N	\N	103806	103806	271565
12061	12881	124	applied	\N	\N	\N	\N	103807	103807	271566
12061	12882	125	applied	\N	\N	\N	\N	103808	103808	271567
12064	12905	0	applied	\N	\N	\N	\N	103815	103815	271571
12064	12906	1	applied	\N	\N	\N	\N	103816	103816	271572
12064	12908	3	applied	\N	\N	\N	\N	103818	103818	103818
12067	12876	57	applied	\N	\N	\N	\N	103877	103877	271628
12067	12877	58	applied	\N	\N	\N	\N	103878	103878	271629
12067	12878	59	applied	\N	\N	\N	\N	103879	103879	271630
12067	12879	60	applied	\N	\N	\N	\N	103880	103880	271631
12067	12880	61	applied	\N	\N	\N	\N	103881	103881	271632
12067	12881	62	applied	\N	\N	\N	\N	103882	103882	271633
12067	12882	63	applied	\N	\N	\N	\N	103883	103883	271634
12067	12883	64	applied	\N	\N	\N	\N	103884	103884	271635
12067	12885	65	applied	\N	\N	\N	\N	103885	103885	271636
12067	12886	66	applied	\N	\N	\N	\N	103886	103886	271637
12067	12887	67	applied	\N	\N	\N	\N	103887	103887	271638
12070	12916	1	applied	\N	\N	\N	\N	103914	103914	271664
12070	12915	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	103913	103913	\N
12061	12771	24	applied	\N	\N	\N	\N	103708	103708	271467
12061	12772	25	applied	\N	\N	\N	\N	103709	103709	271468
12067	12891	71	applied	\N	\N	\N	\N	103891	103891	271642
12067	12892	72	applied	\N	\N	\N	\N	103892	103892	271643
12067	12893	73	applied	\N	\N	\N	\N	103893	103893	271644
12067	12894	74	applied	\N	\N	\N	\N	103894	103894	271645
12067	12895	75	applied	\N	\N	\N	\N	103895	103895	271646
12067	12896	76	applied	\N	\N	\N	\N	103896	103896	271647
12067	12897	77	applied	\N	\N	\N	\N	103897	103897	271648
12067	12900	78	applied	\N	\N	\N	\N	103898	103898	271649
12067	12901	79	applied	\N	\N	\N	\N	103899	103899	271650
12067	12902	80	applied	\N	\N	\N	\N	103900	103900	271651
12067	12903	81	applied	\N	\N	\N	\N	103901	103901	271652
12067	12905	82	applied	\N	\N	\N	\N	103902	103902	271653
12067	12906	83	applied	\N	\N	\N	\N	103903	103903	271654
12067	12909	84	applied	\N	\N	\N	\N	103904	103904	271655
12067	12911	86	applied	\N	\N	1000000000	\N	103906	103906	271657
12067	12912	87	applied	\N	\N	\N	\N	103907	103907	271658
12068	12910	0	applied	\N	\N	\N	\N	103908	103908	271659
12068	12911	1	applied	\N	\N	1000000000	\N	103909	103909	271660
12068	12912	2	applied	\N	\N	\N	\N	103910	103910	271661
12068	12913	3	applied	\N	\N	\N	\N	103911	103911	271662
12071	12917	0	applied	\N	\N	\N	\N	103915	103915	271665
12073	12919	0	applied	\N	\N	\N	\N	103917	103917	271667
12073	12920	2	applied	\N	\N	\N	\N	103918	103918	271668
12074	12921	0	applied	\N	\N	\N	\N	103919	103919	271669
12074	12922	1	applied	\N	\N	\N	\N	103920	103920	271670
12076	12924	0	applied	\N	\N	\N	\N	103925	103925	271673
12079	12926	0	applied	\N	\N	\N	\N	103928	103928	271676
12081	12927	0	applied	\N	\N	\N	\N	103930	103930	271678
12081	12928	1	applied	\N	\N	\N	\N	103931	103931	271679
12081	12929	2	applied	\N	\N	\N	\N	103932	103932	271680
12082	12930	0	applied	\N	\N	\N	\N	103933	103933	271681
12082	12931	1	applied	\N	\N	\N	\N	103934	103934	271682
12084	12930	0	applied	\N	\N	\N	\N	103937	103937	271685
12084	12931	1	applied	\N	\N	\N	\N	103938	103938	271686
12085	12930	0	applied	\N	\N	\N	\N	103939	103939	271687
12085	12931	1	applied	\N	\N	\N	\N	103940	103940	271688
12088	12933	0	applied	\N	\N	\N	\N	103944	103944	271692
12088	12934	1	applied	\N	\N	\N	\N	103945	103945	271693
12089	12933	0	applied	\N	\N	\N	\N	103946	103946	271694
12089	12934	1	applied	\N	\N	\N	\N	103947	103947	271695
12090	12933	0	applied	\N	\N	\N	\N	103948	103948	271696
12091	12807	0	applied	\N	\N	\N	\N	103950	103950	271698
12091	12819	1	applied	\N	\N	\N	\N	103951	103951	271699
12091	12820	2	applied	\N	\N	\N	\N	103952	103952	271700
12091	12821	3	applied	\N	\N	\N	\N	103953	103953	271701
12091	12693	4	applied	\N	\N	\N	\N	103954	103954	271702
12091	12735	5	applied	\N	\N	\N	\N	103955	103955	271703
12091	12740	6	applied	\N	\N	\N	\N	103956	103956	271704
12091	12745	7	applied	\N	\N	\N	\N	103957	103957	271705
12091	12750	8	applied	\N	\N	\N	\N	103958	103958	271706
12091	12646	9	applied	\N	\N	\N	\N	103959	103959	271707
12091	12647	10	applied	\N	\N	\N	\N	103960	103960	271708
12091	12694	11	applied	\N	\N	\N	\N	103961	103961	271709
12091	12884	12	applied	\N	\N	\N	\N	103962	103962	271710
12091	12695	14	applied	\N	\N	\N	\N	103964	103964	271712
12091	12650	15	applied	\N	\N	\N	\N	103965	103965	271713
12091	12652	16	applied	\N	\N	\N	\N	103966	103966	271714
12091	12654	17	applied	\N	\N	\N	\N	103967	103967	271715
12091	12655	18	applied	\N	\N	\N	\N	103968	103968	271716
12091	12657	19	applied	\N	\N	\N	\N	103969	103969	271717
12091	12696	20	applied	\N	\N	\N	\N	103970	103970	271718
12091	12697	21	applied	\N	\N	\N	\N	103971	103971	271719
12091	12698	22	applied	\N	\N	\N	\N	103972	103972	271720
12091	12699	23	applied	\N	\N	\N	\N	103973	103973	271721
12091	12700	24	applied	\N	\N	\N	\N	103974	103974	271722
12091	12701	25	applied	\N	\N	\N	\N	103975	103975	271723
12091	12619	26	applied	\N	\N	\N	\N	103976	103976	271724
12091	12620	27	applied	\N	\N	\N	\N	103977	103977	271725
12091	12621	28	applied	\N	\N	\N	\N	103978	103978	271726
12091	12898	30	applied	\N	\N	1000000000	\N	103980	103980	271728
12094	12937	0	applied	\N	\N	\N	\N	104026	104026	271771
12094	12938	1	applied	\N	\N	\N	\N	104027	104027	271772
12094	12939	2	applied	\N	\N	\N	\N	104028	104028	271773
12097	12944	0	applied	\N	\N	\N	\N	104033	104033	271778
12100	12947	0	applied	\N	\N	\N	\N	104038	104038	271783
12100	12948	1	applied	\N	\N	\N	\N	104039	104039	271784
12105	12951	0	applied	\N	\N	\N	\N	104047	104047	271792
12110	12953	0	applied	\N	\N	\N	\N	104051	104051	271796
12112	12955	0	applied	\N	\N	\N	\N	104053	104053	271798
12112	12956	1	applied	\N	\N	\N	\N	104054	104054	271799
12112	12957	2	applied	\N	\N	1000000000	\N	104055	104055	271800
12117	12960	0	applied	\N	\N	\N	\N	104060	104060	271805
12124	12964	0	applied	\N	\N	\N	\N	104067	104067	271812
12129	12967	0	applied	\N	\N	\N	\N	104073	104073	271818
12134	12968	0	applied	\N	\N	\N	\N	104083	104083	271828
12134	12969	1	applied	\N	\N	\N	\N	104084	104084	271829
12134	12970	2	applied	\N	\N	\N	\N	104085	104085	271830
12136	12972	0	applied	\N	\N	\N	\N	104087	104087	271832
12141	12976	1	applied	\N	\N	\N	\N	104091	104091	271836
12145	12977	0	applied	\N	\N	\N	\N	104098	104098	271843
12145	12978	1	applied	\N	\N	\N	\N	104099	104099	271844
12145	12979	2	applied	\N	\N	\N	\N	104100	104100	271845
12145	12980	3	applied	\N	\N	\N	\N	104101	104101	271846
12145	12981	4	applied	\N	\N	\N	\N	104102	104102	271847
12152	12985	0	applied	\N	\N	\N	\N	104108	104108	271853
12157	12987	0	applied	\N	\N	1000000000	\N	104114	104114	271859
12160	12989	0	applied	\N	\N	\N	\N	104118	104118	271863
12160	12990	1	applied	\N	\N	\N	\N	104119	104119	271864
12160	12991	2	applied	\N	\N	\N	\N	104120	104120	271865
12160	12992	3	applied	\N	\N	\N	\N	104121	104121	271866
12160	12993	4	applied	\N	\N	\N	\N	104122	104122	271867
12168	12998	0	applied	\N	\N	\N	\N	104142	104142	271887
12172	13000	0	applied	\N	\N	\N	\N	104146	104146	271891
12172	13001	1	applied	\N	\N	\N	\N	104147	104147	271892
12173	13003	1	applied	\N	\N	\N	\N	104149	104149	271894
12173	13004	2	applied	\N	\N	\N	\N	104150	104150	271895
12176	13005	0	applied	\N	\N	\N	\N	104157	104157	271902
12176	13006	1	applied	\N	\N	\N	\N	104158	104158	271903
12176	13007	2	applied	\N	\N	\N	\N	104159	104159	271904
12067	12889	69	applied	\N	\N	\N	\N	103889	103889	271640
12067	12890	70	applied	\N	\N	\N	\N	103890	103890	271641
12093	12934	2	applied	\N	\N	\N	\N	103985	103985	271733
12093	12899	3	applied	\N	\N	\N	\N	103986	103986	103986
12093	12892	4	applied	\N	\N	\N	\N	103987	103987	271734
12093	12893	5	applied	\N	\N	\N	\N	103988	103988	271735
12093	12894	6	applied	\N	\N	\N	\N	103989	103989	271736
12093	12895	7	applied	\N	\N	\N	\N	103990	103990	271737
12093	12896	8	applied	\N	\N	\N	\N	103991	103991	271738
12093	12897	9	applied	\N	\N	\N	\N	103992	103992	271739
12093	12900	10	applied	\N	\N	\N	\N	103993	103993	271740
12093	12901	11	applied	\N	\N	\N	\N	103994	103994	271741
12093	12902	12	applied	\N	\N	\N	\N	103995	103995	271742
12093	12905	14	applied	\N	\N	\N	\N	103997	103997	271744
12093	12906	15	applied	\N	\N	\N	\N	103998	103998	271745
12093	12909	16	applied	\N	\N	\N	\N	103999	103999	271746
12093	12910	17	applied	\N	\N	\N	\N	104000	104000	271747
12093	12911	18	applied	\N	\N	1000000000	\N	104001	104001	271748
12093	12912	19	applied	\N	\N	\N	\N	104002	104002	271749
12093	12913	20	applied	\N	\N	\N	\N	104003	104003	271750
12093	12914	21	applied	\N	\N	\N	\N	104004	104004	271751
12093	12916	22	applied	\N	\N	\N	\N	104005	104005	271752
12093	12917	23	applied	\N	\N	\N	\N	104006	104006	271753
12093	12918	24	applied	\N	\N	\N	\N	104007	104007	271754
12093	12919	25	applied	\N	\N	\N	\N	104008	104008	271755
12093	12920	26	applied	\N	\N	\N	\N	104009	104009	271756
12093	12921	27	applied	\N	\N	\N	\N	104010	104010	271757
12093	12922	28	applied	\N	\N	\N	\N	104011	104011	271758
12093	12924	29	applied	\N	\N	\N	\N	104012	104012	271759
12093	12926	31	applied	\N	\N	\N	\N	104014	104014	271761
12093	12927	32	applied	\N	\N	\N	\N	104015	104015	271762
12093	12928	33	applied	\N	\N	\N	\N	104016	104016	271763
12093	12929	34	applied	\N	\N	\N	\N	104017	104017	271764
12093	12930	35	applied	\N	\N	\N	\N	104018	104018	271765
12093	12931	36	applied	\N	\N	\N	\N	104019	104019	271766
12093	12932	37	applied	\N	\N	\N	\N	104020	104020	271767
12093	12933	38	applied	\N	\N	\N	\N	104021	104021	271768
12093	12935	39	applied	\N	\N	\N	\N	104022	104022	271769
12093	12936	40	applied	\N	\N	\N	\N	104023	104023	271770
12093	12904	41	applied	\N	\N	\N	\N	104024	104024	104024
12093	12908	42	applied	\N	\N	\N	\N	104025	104025	104025
12102	12949	0	applied	\N	\N	\N	\N	104042	104042	271787
12102	12950	1	applied	\N	\N	\N	\N	104043	104043	271788
12104	12951	0	applied	\N	\N	\N	\N	104046	104046	271791
12109	12953	0	applied	\N	\N	\N	\N	104050	104050	271795
12119	12961	0	applied	\N	\N	\N	\N	104061	104061	271806
12119	12962	1	applied	\N	\N	\N	\N	104062	104062	271807
12121	12961	0	applied	\N	\N	\N	\N	104063	104063	271808
12121	12962	1	applied	\N	\N	\N	\N	104064	104064	271809
12123	12963	0	applied	\N	\N	\N	\N	104066	104066	271811
12126	12964	0	applied	\N	\N	\N	\N	104069	104069	271814
12128	12967	0	applied	\N	\N	\N	\N	104072	104072	271817
12132	12968	0	applied	\N	\N	\N	\N	104077	104077	271822
12132	12969	1	applied	\N	\N	\N	\N	104078	104078	271823
12132	12970	2	applied	\N	\N	\N	\N	104079	104079	271824
12135	12971	0	applied	\N	\N	\N	\N	104086	104086	271831
12138	12974	0	applied	\N	\N	\N	\N	104089	104089	271834
12143	12975	0	applied	\N	\N	\N	\N	104094	104094	271839
12143	12976	1	applied	\N	\N	\N	\N	104095	104095	271840
12147	12983	0	applied	\N	\N	\N	\N	104104	104104	271849
12150	12984	0	applied	\N	\N	\N	\N	104106	104106	271851
12156	12987	0	applied	\N	\N	1000000000	\N	104112	104112	271857
12156	12988	1	applied	\N	\N	\N	\N	104113	104113	271858
12162	12989	0	applied	\N	\N	\N	\N	104128	104128	271873
12162	12990	1	applied	\N	\N	\N	\N	104129	104129	271874
12162	12991	2	applied	\N	\N	\N	\N	104130	104130	271875
12162	12992	3	applied	\N	\N	\N	\N	104131	104131	271876
12162	12993	4	applied	\N	\N	\N	\N	104132	104132	271877
12175	13005	0	applied	\N	\N	\N	\N	104154	104154	271899
12175	13006	1	applied	\N	\N	\N	\N	104155	104155	271900
12175	13007	2	applied	\N	\N	\N	\N	104156	104156	271901
12178	13008	0	applied	\N	\N	\N	\N	104161	104161	271906
12179	13009	0	applied	\N	\N	\N	\N	104162	104162	271907
12179	13010	1	applied	\N	\N	\N	\N	104163	104163	271908
12179	13011	2	applied	\N	\N	\N	\N	104164	104164	271909
12179	13012	3	applied	\N	\N	\N	\N	104165	104165	271910
12183	13015	0	applied	\N	\N	\N	\N	104176	104176	271921
12185	12913	1	applied	\N	\N	\N	\N	104179	104179	271924
12185	12949	2	applied	\N	\N	\N	\N	104180	104180	271925
12185	12934	3	applied	\N	\N	\N	\N	104181	104181	271926
12185	12914	4	applied	\N	\N	\N	\N	104182	104182	271927
12185	12916	5	applied	\N	\N	\N	\N	104183	104183	271928
12185	12917	6	applied	\N	\N	\N	\N	104184	104184	271929
12185	12918	7	applied	\N	\N	\N	\N	104185	104185	271930
12185	12919	8	applied	\N	\N	\N	\N	104186	104186	271931
12185	12920	9	applied	\N	\N	\N	\N	104187	104187	271932
12185	12921	10	applied	\N	\N	\N	\N	104188	104188	271933
12185	12922	11	applied	\N	\N	\N	\N	104189	104189	271934
12185	12924	12	applied	\N	\N	\N	\N	104190	104190	271935
12185	12978	13	applied	\N	\N	\N	\N	104191	104191	271936
12185	12979	14	applied	\N	\N	\N	\N	104192	104192	271937
12185	12925	15	applied	\N	\N	\N	\N	104193	104193	271938
12185	12926	16	applied	\N	\N	\N	\N	104194	104194	271939
12185	12928	18	applied	\N	\N	\N	\N	104196	104196	271941
12185	12929	19	applied	\N	\N	\N	\N	104197	104197	271942
12185	12930	20	applied	\N	\N	\N	\N	104198	104198	271943
12185	12931	21	applied	\N	\N	\N	\N	104199	104199	271944
12185	12932	22	applied	\N	\N	\N	\N	104200	104200	271945
12185	12933	23	applied	\N	\N	\N	\N	104201	104201	271946
12185	12935	24	applied	\N	\N	\N	\N	104202	104202	271947
12185	12936	25	applied	\N	\N	\N	\N	104203	104203	271948
12185	12937	26	applied	\N	\N	\N	\N	104204	104204	271949
12185	12938	27	applied	\N	\N	\N	\N	104205	104205	271950
12185	12939	28	applied	\N	\N	\N	\N	104206	104206	271951
12185	12940	29	applied	\N	\N	\N	\N	104207	104207	271952
12185	12941	30	applied	\N	\N	\N	\N	104208	104208	271953
12186	13016	0	applied	\N	\N	\N	\N	104280	104280	272025
12186	13017	1	applied	\N	\N	\N	\N	104281	104281	272026
12189	13019	0	applied	\N	\N	\N	\N	104284	104284	272029
12189	13021	2	applied	\N	\N	\N	\N	104286	104286	272031
12193	13022	0	applied	\N	\N	\N	\N	104321	104321	272066
12093	12898	0	applied	\N	\N	1000000000	\N	103983	103983	271731
12093	12891	1	applied	\N	\N	\N	\N	103984	103984	271732
12180	13011	2	applied	\N	\N	\N	\N	104168	104168	271913
12180	13012	3	applied	\N	\N	\N	\N	104169	104169	271914
12184	13015	0	applied	\N	\N	\N	\N	104177	104177	271922
12185	12942	31	applied	\N	\N	\N	\N	104209	104209	271954
12185	12943	32	applied	\N	\N	\N	\N	104210	104210	271955
12185	12944	33	applied	\N	\N	\N	\N	104211	104211	271956
12185	12945	34	applied	\N	\N	\N	\N	104212	104212	271957
12185	12946	35	applied	\N	\N	\N	\N	104213	104213	271958
12185	12980	36	applied	\N	\N	\N	\N	104214	104214	271959
12185	12981	37	applied	\N	\N	\N	\N	104215	104215	271960
12185	12947	38	applied	\N	\N	\N	\N	104216	104216	271961
12185	12948	39	applied	\N	\N	\N	\N	104217	104217	271962
12185	12950	40	applied	\N	\N	\N	\N	104218	104218	271963
12185	12951	41	applied	\N	\N	\N	\N	104219	104219	271964
12190	13020	1	applied	\N	\N	\N	\N	104288	104288	272033
12190	13021	2	applied	\N	\N	\N	\N	104289	104289	272034
12194	13022	0	applied	\N	\N	\N	\N	104322	104322	272067
12205	13041	0	applied	\N	\N	\N	\N	104341	104341	272086
12210	13043	0	applied	\N	\N	\N	\N	104350	104350	272095
12210	13044	1	applied	\N	\N	\N	\N	104351	104351	272096
12210	13045	2	applied	\N	\N	1000000000	\N	104352	104352	272097
12215	13048	0	applied	\N	\N	\N	\N	104357	104357	272102
12215	13049	1	applied	\N	\N	\N	\N	104358	104358	272103
12227	13057	0	applied	\N	\N	\N	\N	104503	104503	272247
12230	13058	0	applied	\N	\N	\N	\N	104507	104507	272251
12230	13059	1	applied	\N	\N	\N	\N	104508	104508	272252
12235	13065	0	applied	\N	\N	\N	\N	104517	104517	272261
12238	13066	0	applied	\N	\N	\N	\N	104519	104519	272263
12248	13078	0	applied	\N	\N	\N	\N	104536	104536	272280
12248	13079	1	applied	\N	\N	\N	\N	104537	104537	272281
12248	13081	3	applied	\N	\N	\N	\N	104539	104539	272283
12250	13069	0	applied	\N	\N	\N	\N	104544	104544	272288
12250	13072	1	applied	\N	\N	\N	\N	104545	104545	272289
12250	13073	2	applied	\N	\N	\N	\N	104546	104546	272290
12250	13074	3	applied	\N	\N	\N	\N	104547	104547	272291
12250	13076	4	applied	\N	\N	\N	\N	104548	104548	272292
12250	13078	5	applied	\N	\N	\N	\N	104549	104549	272293
12250	13079	6	applied	\N	\N	\N	\N	104550	104550	272294
12250	13065	7	applied	\N	\N	\N	\N	104551	104551	272295
12250	13066	8	applied	\N	\N	\N	\N	104552	104552	272296
12250	13067	9	applied	\N	\N	\N	\N	104553	104553	272297
12250	13068	10	applied	\N	\N	\N	\N	104554	104554	272298
12250	13070	11	applied	\N	\N	\N	\N	104555	104555	272299
12250	13071	12	applied	\N	\N	\N	\N	104556	104556	272300
12250	13075	13	applied	\N	\N	\N	\N	104557	104557	272301
12250	13077	14	applied	\N	\N	\N	\N	104558	104558	272302
12250	13081	16	applied	\N	\N	\N	\N	104560	104560	272304
12253	13082	0	applied	\N	\N	\N	\N	104562	104562	272306
12257	13084	0	applied	\N	\N	\N	\N	104565	104565	272309
12262	13089	0	applied	\N	\N	\N	\N	104697	104697	272441
12282	13102	0	applied	\N	\N	\N	\N	104730	104730	272474
12282	13103	1	applied	\N	\N	\N	\N	104731	104731	272475
12285	13107	0	applied	\N	\N	\N	\N	104735	104735	272479
12285	13108	1	applied	\N	\N	\N	\N	104736	104736	272480
12285	13109	2	applied	\N	\N	\N	\N	104737	104737	272481
12285	13110	3	applied	\N	\N	\N	\N	104738	104738	272482
12288	13112	0	applied	\N	\N	\N	\N	104741	104741	272485
12292	13115	0	applied	\N	\N	\N	\N	104765	104765	272509
12292	13116	1	applied	\N	\N	\N	\N	104766	104766	272510
12292	13117	2	applied	\N	\N	\N	\N	104767	104767	272511
12295	13120	0	applied	\N	\N	\N	\N	104780	104780	272524
12295	13121	1	applied	\N	\N	\N	\N	104781	104781	272525
12295	13123	3	applied	\N	\N	\N	\N	104783	104783	272527
12295	13124	4	applied	\N	\N	\N	\N	104784	104784	272528
12295	13125	5	applied	\N	\N	\N	\N	104785	104785	272529
12295	13126	6	applied	\N	\N	\N	\N	104786	104786	272530
12295	13127	7	applied	\N	\N	\N	\N	104787	104787	272531
12295	13128	8	applied	\N	\N	\N	\N	104788	104788	272532
12295	13129	9	applied	\N	\N	\N	\N	104789	104789	272533
12297	13130	0	applied	\N	\N	\N	\N	104794	104794	272538
12300	13133	0	applied	\N	\N	\N	\N	104798	104798	272542
12302	13134	0	applied	\N	\N	\N	\N	104801	104801	272545
12302	13135	1	applied	\N	\N	\N	\N	104802	104802	272546
12304	13136	0	applied	\N	\N	\N	\N	104805	104805	272549
12304	13137	1	applied	\N	\N	\N	\N	104806	104806	272550
12307	13142	0	applied	\N	\N	\N	\N	104815	104815	272559
12312	13148	0	applied	\N	\N	\N	\N	104821	104821	272565
12312	13149	1	applied	\N	\N	\N	\N	104822	104822	272566
12320	13156	0	applied	\N	\N	\N	\N	104832	104832	272576
12323	13159	0	applied	\N	\N	\N	\N	104892	104892	272636
12323	13160	1	applied	\N	\N	\N	\N	104893	104893	272637
12331	13167	0	applied	\N	\N	\N	\N	104912	104912	272656
12338	13170	0	applied	\N	\N	\N	\N	104917	104917	272661
12347	13180	0	applied	\N	\N	\N	\N	104935	104935	272679
12347	13181	1	applied	\N	\N	\N	\N	104936	104936	272680
12347	13182	2	applied	\N	\N	\N	\N	104937	104937	272681
12347	13183	3	applied	\N	\N	\N	\N	104938	104938	272682
12350	13185	0	applied	\N	\N	\N	\N	104942	104942	272686
12350	13186	1	applied	\N	\N	\N	\N	104943	104943	272687
12352	13187	0	applied	\N	\N	\N	\N	104944	104944	272688
12357	13192	0	applied	\N	\N	\N	\N	104951	104951	272695
12364	13195	0	applied	\N	\N	\N	\N	104958	104958	272702
12364	13196	1	applied	\N	\N	\N	\N	104959	104959	272703
12368	13203	0	applied	\N	\N	\N	\N	104966	104966	272710
12381	13210	0	applied	\N	\N	\N	\N	105104	105104	272845
12384	13213	0	applied	\N	\N	\N	\N	105107	105107	272848
12386	13214	0	applied	\N	\N	\N	\N	105109	105109	272850
12391	13216	0	applied	\N	\N	\N	\N	105113	105113	272854
12391	13217	2	applied	\N	\N	\N	\N	105114	105114	272855
12393	13218	0	applied	\N	\N	\N	\N	105116	105116	272857
12399	13224	0	applied	\N	\N	\N	\N	105126	105126	272867
12399	13225	1	applied	\N	\N	\N	\N	105127	105127	272868
12403	13226	0	applied	\N	\N	\N	\N	105132	105132	272873
12403	13227	1	applied	\N	\N	\N	\N	105133	105133	272874
12406	13229	0	applied	\N	\N	\N	\N	105136	105136	272877
12406	13230	1	applied	\N	\N	\N	\N	105137	105137	272878
12409	13231	0	applied	\N	\N	\N	\N	105140	105140	272881
12419	13234	0	applied	\N	\N	\N	\N	105149	105149	272890
12419	13235	1	applied	\N	\N	\N	\N	105150	105150	272891
12419	13236	2	applied	\N	\N	\N	\N	105151	105151	272892
12180	13010	1	applied	\N	\N	\N	\N	104167	104167	271912
12185	12955	45	applied	\N	\N	\N	\N	104223	104223	271968
12185	12956	46	applied	\N	\N	\N	\N	104224	104224	271969
12185	12957	47	applied	\N	\N	1000000000	\N	104225	104225	271970
12185	12958	48	applied	\N	\N	\N	\N	104226	104226	271971
12185	12959	49	applied	\N	\N	\N	\N	104227	104227	271972
12185	12960	50	applied	\N	\N	\N	\N	104228	104228	271973
12185	12961	51	applied	\N	\N	\N	\N	104229	104229	271974
12185	12962	52	applied	\N	\N	\N	\N	104230	104230	271975
12185	12963	53	applied	\N	\N	\N	\N	104231	104231	271976
12185	12965	55	applied	\N	\N	\N	\N	104233	104233	271978
12185	12966	56	applied	\N	\N	\N	\N	104234	104234	271979
12185	12967	57	applied	\N	\N	\N	\N	104235	104235	271980
12185	12968	58	applied	\N	\N	\N	\N	104236	104236	271981
12185	12969	59	applied	\N	\N	\N	\N	104237	104237	271982
12185	12970	60	applied	\N	\N	\N	\N	104238	104238	271983
12185	12971	61	applied	\N	\N	\N	\N	104239	104239	271984
12185	12972	62	applied	\N	\N	\N	\N	104240	104240	271985
12185	12973	63	applied	\N	\N	\N	\N	104241	104241	271986
12185	12974	64	applied	\N	\N	\N	\N	104242	104242	271987
12185	12975	65	applied	\N	\N	\N	\N	104243	104243	271988
12185	12976	67	applied	\N	\N	\N	\N	104244	104244	271989
12185	12977	68	applied	\N	\N	\N	\N	104245	104245	271990
12185	12982	69	applied	\N	\N	\N	\N	104246	104246	271991
12185	12983	70	applied	\N	\N	\N	\N	104247	104247	271992
12185	12984	71	applied	\N	\N	\N	\N	104248	104248	271993
12185	12986	73	applied	\N	\N	\N	\N	104250	104250	271995
12185	12987	74	applied	\N	\N	1000000000	\N	104251	104251	271996
12185	12988	75	applied	\N	\N	\N	\N	104252	104252	271997
12185	12989	76	applied	\N	\N	\N	\N	104253	104253	271998
12185	12990	77	applied	\N	\N	\N	\N	104254	104254	271999
12185	12991	78	applied	\N	\N	\N	\N	104255	104255	272000
12185	12992	79	applied	\N	\N	\N	\N	104256	104256	272001
12185	12993	80	applied	\N	\N	\N	\N	104257	104257	272002
12185	12994	81	applied	\N	\N	\N	\N	104258	104258	272003
12185	12995	82	applied	\N	\N	\N	\N	104259	104259	272004
12185	12996	83	applied	\N	\N	\N	\N	104260	104260	272005
12185	12997	84	applied	\N	\N	\N	\N	104261	104261	272006
12185	12998	85	applied	\N	\N	\N	\N	104262	104262	272007
12185	12999	86	applied	\N	\N	\N	\N	104263	104263	272008
12185	13000	87	applied	\N	\N	\N	\N	104264	104264	272009
12185	13001	88	applied	\N	\N	\N	\N	104265	104265	272010
12185	13003	90	applied	\N	\N	\N	\N	104267	104267	272012
12185	13004	91	applied	\N	\N	\N	\N	104268	104268	272013
12185	13005	92	applied	\N	\N	\N	\N	104269	104269	272014
12185	13006	93	applied	\N	\N	\N	\N	104270	104270	272015
12185	13007	94	applied	\N	\N	\N	\N	104271	104271	272016
12185	13008	95	applied	\N	\N	\N	\N	104272	104272	272017
12185	13009	96	applied	\N	\N	\N	\N	104273	104273	272018
12185	13010	97	applied	\N	\N	\N	\N	104274	104274	272019
12185	13011	98	applied	\N	\N	\N	\N	104275	104275	272020
12185	13012	99	applied	\N	\N	\N	\N	104276	104276	272021
12185	13014	100	applied	\N	\N	\N	\N	104277	104277	272022
12185	13015	101	applied	\N	\N	\N	\N	104278	104278	272023
12185	13016	102	applied	\N	\N	\N	\N	104279	104279	272024
12188	13018	0	applied	\N	\N	\N	\N	104283	104283	272028
12191	13019	0	applied	\N	\N	\N	\N	104290	104290	272035
12191	13020	1	applied	\N	\N	\N	\N	104291	104291	272036
12195	13023	0	applied	\N	\N	\N	\N	104323	104323	272068
12198	13027	0	applied	\N	\N	\N	\N	104327	104327	272072
12198	13028	1	applied	\N	\N	\N	\N	104328	104328	272073
12201	13033	0	applied	\N	\N	\N	\N	104333	104333	272078
12204	13040	0	applied	\N	\N	\N	\N	104340	104340	272085
12209	13027	0	applied	\N	\N	\N	\N	104344	104344	272089
12209	13029	1	applied	\N	\N	\N	\N	104345	104345	272090
12209	13034	2	applied	\N	\N	\N	\N	104346	104346	272091
12209	13035	3	applied	\N	\N	\N	\N	104347	104347	272092
12209	13038	4	applied	\N	\N	\N	\N	104348	104348	272093
12209	13013	5	applied	\N	\N	\N	\N	104349	104349	272094
12211	13046	0	applied	\N	\N	\N	\N	104353	104353	272098
12217	12807	0	applied	\N	\N	\N	\N	104361	104361	272106
12217	12819	1	applied	\N	\N	\N	\N	104362	104362	272107
12217	12820	2	applied	\N	\N	\N	\N	104363	104363	272108
12217	12821	3	applied	\N	\N	\N	\N	104364	104364	272109
12217	13034	5	applied	\N	\N	\N	\N	104366	104366	272111
12217	13035	6	applied	\N	\N	\N	\N	104367	104367	272112
12217	13038	7	applied	\N	\N	\N	\N	104368	104368	272113
12217	12693	8	applied	\N	\N	\N	\N	104369	104369	272114
12217	12735	9	applied	\N	\N	\N	\N	104370	104370	272115
12217	12740	10	applied	\N	\N	\N	\N	104371	104371	272116
12217	12745	11	applied	\N	\N	\N	\N	104372	104372	272117
12217	12750	12	applied	\N	\N	\N	\N	104373	104373	272118
12217	12694	13	applied	\N	\N	\N	\N	104374	104374	272119
12217	12884	14	applied	\N	\N	\N	\N	104375	104375	272120
12217	12695	15	applied	\N	\N	\N	\N	104376	104376	272121
12217	13013	16	applied	\N	\N	\N	\N	104377	104377	272122
12217	12696	17	applied	\N	\N	\N	\N	104378	104378	272123
12217	12697	18	applied	\N	\N	\N	\N	104379	104379	272124
12217	12698	19	applied	\N	\N	\N	\N	104380	104380	272125
12217	12699	20	applied	\N	\N	\N	\N	104381	104381	272126
12217	12701	22	applied	\N	\N	\N	\N	104383	104383	272128
12217	12854	23	applied	\N	\N	1000000000	\N	104384	104384	272129
12217	12949	24	applied	\N	\N	\N	\N	104385	104385	272130
12217	12898	25	applied	\N	\N	1000000000	\N	104386	104386	272131
12217	12702	26	applied	\N	\N	\N	\N	104387	104387	272132
12217	12865	27	applied	\N	\N	\N	\N	104388	104388	272133
12217	12899	28	applied	\N	\N	\N	\N	104389	104389	104389
12217	12818	29	applied	\N	\N	\N	\N	104390	104390	272134
12217	12703	30	applied	\N	\N	\N	\N	104391	104391	272135
12217	12704	31	applied	\N	\N	\N	\N	104392	104392	272136
12459	13174	0	applied	\N	\N	\N	\N	105216	105216	272957
12459	13180	1	applied	\N	\N	\N	\N	105217	105217	272958
12459	13181	2	applied	\N	\N	\N	\N	105218	105218	272959
12459	13182	3	applied	\N	\N	\N	\N	105219	105219	272960
12459	13115	4	applied	\N	\N	\N	\N	105220	105220	272961
12459	13118	5	applied	\N	\N	\N	\N	105221	105221	272962
12459	13134	7	applied	\N	\N	\N	\N	105223	105223	272964
12459	13136	8	applied	\N	\N	\N	\N	105224	105224	272965
12459	13138	9	applied	\N	\N	\N	\N	105225	105225	272966
12472	13239	0	applied	\N	\N	\N	\N	105235	105235	272976
12185	12953	43	applied	\N	\N	\N	\N	104221	104221	271966
12185	12954	44	applied	\N	\N	\N	\N	104222	104222	271967
12199	13030	1	applied	\N	\N	\N	\N	104330	104330	272075
12199	13031	2	applied	\N	\N	\N	\N	104331	104331	272076
12202	13034	0	applied	\N	\N	\N	\N	104334	104334	272079
12202	13035	1	applied	\N	\N	\N	\N	104335	104335	272080
12202	13036	2	applied	\N	\N	\N	\N	104336	104336	272081
12202	13037	3	applied	\N	\N	\N	\N	104337	104337	272082
12208	13042	0	applied	\N	\N	\N	\N	104343	104343	272088
12212	13046	0	applied	\N	\N	\N	\N	104354	104354	272099
12214	13047	0	applied	\N	\N	\N	\N	104356	104356	272101
12217	12934	33	applied	\N	\N	\N	\N	104394	104394	272138
12217	12978	34	applied	\N	\N	\N	\N	104395	104395	272139
12217	12979	35	applied	\N	\N	\N	\N	104396	104396	272140
12217	12980	36	applied	\N	\N	\N	\N	104397	104397	272141
12217	12981	37	applied	\N	\N	\N	\N	104398	104398	272142
12217	12705	38	applied	\N	\N	\N	\N	104399	104399	272143
12217	12706	39	applied	\N	\N	\N	\N	104400	104400	272144
12217	12707	40	applied	\N	\N	\N	\N	104401	104401	272145
12217	12708	41	applied	\N	\N	\N	\N	104402	104402	272146
12217	12709	42	applied	\N	\N	\N	\N	104403	104403	272147
12220	13050	0	applied	\N	\N	\N	\N	104490	104490	272234
12220	13051	1	applied	\N	\N	\N	\N	104491	104491	272235
12224	13053	0	applied	\N	\N	\N	\N	104496	104496	272240
12229	13058	0	applied	\N	\N	\N	\N	104505	104505	272249
12229	13059	1	applied	\N	\N	\N	\N	104506	104506	272250
12234	13065	0	applied	\N	\N	\N	\N	104516	104516	272260
12245	13073	1	applied	\N	\N	\N	\N	104529	104529	272273
12245	13074	2	applied	\N	\N	\N	\N	104530	104530	272274
12245	13075	3	applied	\N	\N	\N	\N	104531	104531	272275
12247	13076	0	applied	\N	\N	\N	\N	104534	104534	272278
12247	13077	1	applied	\N	\N	\N	\N	104535	104535	272279
12254	13083	0	applied	\N	\N	\N	\N	104563	104563	272307
12256	13083	0	applied	\N	\N	\N	\N	104564	104564	272308
12260	13086	0	applied	\N	\N	\N	\N	104570	104570	272314
12260	13087	1	applied	\N	\N	\N	\N	104571	104571	272315
12260	13088	2	applied	\N	\N	\N	\N	104572	104572	272316
12266	13090	0	applied	\N	\N	\N	\N	104713	104713	272457
12268	13091	0	applied	\N	\N	\N	\N	104715	104715	272459
12273	13099	0	applied	\N	\N	\N	\N	104724	104724	272468
12284	13105	0	applied	\N	\N	\N	\N	104733	104733	272477
12284	13106	1	applied	\N	\N	\N	\N	104734	104734	272478
12287	13112	0	applied	\N	\N	\N	\N	104740	104740	272484
12291	13114	0	applied	\N	\N	\N	\N	104764	104764	272508
12294	13120	0	applied	\N	\N	\N	\N	104770	104770	272514
12294	13121	1	applied	\N	\N	\N	\N	104771	104771	272515
12294	13122	2	applied	\N	\N	\N	\N	104772	104772	272516
12294	13123	3	applied	\N	\N	\N	\N	104773	104773	272517
12294	13124	4	applied	\N	\N	\N	\N	104774	104774	272518
12294	13125	5	applied	\N	\N	\N	\N	104775	104775	272519
12294	13126	6	applied	\N	\N	\N	\N	104776	104776	272520
12294	13127	7	applied	\N	\N	\N	\N	104777	104777	272521
12294	13128	8	applied	\N	\N	\N	\N	104778	104778	272522
12294	13129	9	applied	\N	\N	\N	\N	104779	104779	272523
12299	13133	0	applied	\N	\N	\N	\N	104797	104797	272541
12301	13134	0	applied	\N	\N	\N	\N	104799	104799	272543
12301	13135	1	applied	\N	\N	\N	\N	104800	104800	272544
12306	13138	0	applied	\N	\N	\N	\N	104811	104811	272555
12306	13139	1	applied	\N	\N	\N	\N	104812	104812	272556
12306	13141	3	applied	\N	\N	\N	\N	104814	104814	272558
12309	13145	0	applied	\N	\N	\N	\N	104818	104818	272562
12315	13152	0	applied	\N	\N	\N	\N	104826	104826	272570
12317	13153	0	applied	\N	\N	\N	\N	104828	104828	272572
12319	13154	0	applied	\N	\N	\N	\N	104830	104830	272574
12319	13155	1	applied	\N	\N	\N	\N	104831	104831	272575
12322	13157	0	applied	\N	\N	\N	\N	104890	104890	272634
12322	13158	1	applied	\N	\N	\N	\N	104891	104891	272635
12327	13163	0	applied	\N	\N	\N	\N	104904	104904	272648
12327	13164	1	applied	\N	\N	\N	\N	104905	104905	272649
12327	13165	2	applied	\N	\N	\N	\N	104906	104906	272650
12327	13166	3	applied	\N	\N	\N	\N	104907	104907	272651
12333	13168	0	applied	\N	\N	\N	\N	104914	104914	272658
12341	13172	0	applied	\N	\N	\N	\N	104921	104921	272665
12341	13173	1	applied	\N	\N	\N	\N	104922	104922	272666
12344	13174	0	applied	\N	\N	\N	\N	104929	104929	272673
12344	13176	2	applied	\N	\N	\N	\N	104931	104931	272675
12344	13177	3	applied	\N	\N	\N	\N	104932	104932	272676
12346	13179	0	applied	\N	\N	\N	\N	104934	104934	272678
12349	13185	0	applied	\N	\N	\N	\N	104940	104940	272684
12349	13186	1	applied	\N	\N	\N	\N	104941	104941	272685
12359	13193	0	applied	\N	\N	\N	\N	104953	104953	272697
12362	13194	0	applied	\N	\N	\N	\N	104956	104956	272700
12367	13200	0	applied	\N	\N	\N	\N	104963	104963	272707
12367	13201	1	applied	\N	\N	\N	\N	104964	104964	272708
12367	13202	2	applied	\N	\N	\N	\N	104965	104965	272709
12374	13207	0	applied	\N	\N	\N	\N	105097	105097	272838
12379	13208	0	applied	\N	\N	\N	\N	105102	105102	272843
12383	13212	0	applied	\N	\N	\N	\N	105106	105106	272847
12389	13215	0	applied	\N	\N	\N	\N	105112	105112	272853
12396	13221	0	applied	\N	\N	\N	\N	105121	105121	272862
12396	13222	1	applied	\N	\N	\N	\N	105122	105122	272863
12398	13225	1	applied	\N	\N	\N	\N	105125	105125	272866
12408	13231	0	applied	\N	\N	\N	\N	105139	105139	272880
12413	13232	0	applied	\N	\N	\N	\N	105144	105144	272885
12414	13232	0	applied	\N	\N	\N	\N	105145	105145	272886
12417	13233	0	applied	\N	\N	\N	\N	105148	105148	272889
12424	13237	0	applied	\N	\N	\N	\N	105156	105156	272897
12424	13238	1	applied	\N	\N	\N	\N	105157	105157	272898
12461	13239	0	applied	\N	\N	\N	\N	105227	105227	272968
12478	13248	0	applied	\N	\N	\N	\N	105266	105266	273007
12478	13249	1	applied	\N	\N	1000000000	\N	105267	105267	273008
12478	13250	2	applied	\N	\N	1000000000	\N	105268	105268	273009
12480	13251	0	applied	\N	\N	1000000000	\N	105272	105272	273013
12480	13252	1	applied	\N	\N	1000000000	\N	105273	105273	273014
12480	13253	2	applied	\N	\N	\N	\N	105274	105274	273015
12486	13258	0	applied	\N	\N	\N	\N	105283	105283	273024
12486	13259	1	applied	\N	\N	\N	\N	105284	105284	273025
12486	13261	3	applied	\N	\N	\N	\N	105286	105286	273027
12488	13262	0	applied	\N	\N	\N	\N	105291	105291	273032
12501	13268	0	applied	\N	\N	\N	\N	105308	105308	273049
12501	13269	1	applied	\N	\N	\N	\N	105309	105309	273050
12196	13025	1	applied	\N	\N	\N	\N	104325	104325	272070
12199	13029	0	applied	\N	\N	\N	\N	104329	104329	272074
12206	13042	0	applied	\N	\N	\N	\N	104342	104342	272087
12213	13046	0	applied	\N	\N	\N	\N	104355	104355	272100
12216	13048	0	applied	\N	\N	\N	\N	104359	104359	272104
12216	13049	1	applied	\N	\N	\N	\N	104360	104360	272105
12218	13050	0	applied	\N	\N	\N	\N	104486	104486	272230
12218	13051	1	applied	\N	\N	\N	\N	104487	104487	272231
12221	13050	0	applied	\N	\N	\N	\N	104492	104492	272236
12221	13051	1	applied	\N	\N	\N	\N	104493	104493	272237
12222	13052	0	applied	\N	\N	\N	\N	104494	104494	272238
12225	13054	0	applied	\N	\N	\N	\N	104497	104497	272241
12225	13055	1	applied	\N	\N	\N	\N	104498	104498	272242
12225	13056	2	applied	\N	\N	\N	\N	104499	104499	272243
12232	13060	0	applied	\N	\N	\N	\N	104510	104510	272254
12232	13061	1	applied	\N	\N	\N	\N	104511	104511	272255
12232	13062	2	applied	\N	\N	\N	\N	104512	104512	272256
12232	13063	3	applied	\N	\N	\N	\N	104513	104513	272257
12239	13066	0	applied	\N	\N	\N	\N	104520	104520	272264
12241	13067	0	applied	\N	\N	\N	\N	104522	104522	272266
12243	13068	0	applied	\N	\N	\N	\N	104524	104524	272268
12246	13076	0	applied	\N	\N	\N	\N	104532	104532	272276
12246	13077	1	applied	\N	\N	\N	\N	104533	104533	272277
12249	13078	0	applied	\N	\N	\N	\N	104540	104540	272284
12249	13079	1	applied	\N	\N	\N	\N	104541	104541	272285
12249	13080	2	applied	\N	\N	\N	\N	104542	104542	272286
12249	13081	3	applied	\N	\N	\N	\N	104543	104543	272287
12251	13082	0	applied	\N	\N	\N	\N	104561	104561	272305
12264	13089	0	applied	\N	\N	\N	\N	104711	104711	272455
12275	13099	0	applied	\N	\N	\N	\N	104725	104725	272469
12278	13100	0	applied	\N	\N	\N	\N	104726	104726	272470
12280	13101	0	applied	\N	\N	\N	\N	104728	104728	272472
12290	13092	0	applied	\N	\N	\N	\N	104743	104743	272487
12290	13029	1	applied	\N	\N	\N	\N	104744	104744	272488
12290	13035	3	applied	\N	\N	\N	\N	104746	104746	272490
12290	13038	4	applied	\N	\N	\N	\N	104747	104747	272491
12290	13058	5	applied	\N	\N	\N	\N	104748	104748	272492
12290	13060	6	applied	\N	\N	\N	\N	104749	104749	272493
12290	13107	7	applied	\N	\N	\N	\N	104750	104750	272494
12290	13108	8	applied	\N	\N	\N	\N	104751	104751	272495
12290	13061	9	applied	\N	\N	\N	\N	104752	104752	272496
12290	13109	10	applied	\N	\N	\N	\N	104753	104753	272497
12290	13110	11	applied	\N	\N	\N	\N	104754	104754	272498
12290	13062	12	applied	\N	\N	\N	\N	104755	104755	272499
12290	13069	14	applied	\N	\N	\N	\N	104756	104756	272500
12290	13072	15	applied	\N	\N	\N	\N	104757	104757	272501
12290	13073	16	applied	\N	\N	\N	\N	104758	104758	272502
12290	13074	17	applied	\N	\N	\N	\N	104759	104759	272503
12290	13093	18	applied	\N	\N	\N	\N	104760	104760	272504
12290	13094	19	applied	\N	\N	\N	\N	104761	104761	272505
12290	13076	21	applied	\N	\N	\N	\N	104763	104763	272507
12303	13134	0	applied	\N	\N	\N	\N	104803	104803	272547
12303	13135	1	applied	\N	\N	\N	\N	104804	104804	272548
12305	13138	0	applied	\N	\N	\N	\N	104807	104807	272551
12305	13139	1	applied	\N	\N	\N	\N	104808	104808	272552
12305	13140	2	applied	\N	\N	\N	\N	104809	104809	272553
12305	13141	3	applied	\N	\N	\N	\N	104810	104810	272554
12310	13146	0	applied	\N	\N	\N	\N	104819	104819	272563
12310	13147	1	applied	\N	\N	\N	\N	104820	104820	272564
12313	13150	0	applied	\N	\N	\N	\N	104823	104823	272567
12313	13151	1	applied	\N	\N	\N	\N	104824	104824	272568
12324	13161	0	applied	\N	\N	\N	\N	104894	104894	272638
12324	13162	1	applied	\N	\N	\N	\N	104895	104895	272639
12325	13163	0	applied	\N	\N	\N	\N	104896	104896	272640
12325	13164	1	applied	\N	\N	\N	\N	104897	104897	272641
12325	13165	2	applied	\N	\N	\N	\N	104898	104898	272642
12328	13163	0	applied	\N	\N	\N	\N	104908	104908	272652
12328	13164	1	applied	\N	\N	\N	\N	104909	104909	272653
12328	13165	2	applied	\N	\N	\N	\N	104910	104910	272654
12328	13166	3	applied	\N	\N	\N	\N	104911	104911	272655
12334	13169	0	applied	\N	\N	\N	\N	104915	104915	272659
12339	13171	0	applied	\N	\N	\N	\N	104918	104918	272662
12353	13187	0	applied	\N	\N	\N	\N	104945	104945	272689
12355	13188	0	applied	\N	\N	\N	\N	104947	104947	272691
12355	13189	1	applied	\N	\N	\N	\N	104948	104948	272692
12358	13192	0	applied	\N	\N	\N	\N	104952	104952	272696
12360	13194	0	applied	\N	\N	\N	\N	104954	104954	272698
12363	13194	0	applied	\N	\N	\N	\N	104957	104957	272701
12365	13197	0	applied	\N	\N	\N	\N	104960	104960	272704
12365	13198	1	applied	\N	\N	\N	\N	104961	104961	272705
12369	13203	0	applied	\N	\N	\N	\N	104967	104967	272711
12371	13204	0	applied	\N	\N	\N	\N	104969	104969	272713
12377	13208	0	applied	\N	\N	\N	\N	105100	105100	272841
12382	13211	0	applied	\N	\N	\N	\N	105105	105105	272846
12385	13213	0	applied	\N	\N	\N	\N	105108	105108	272849
12387	13215	0	applied	\N	\N	\N	\N	105110	105110	272851
12394	13219	0	applied	\N	\N	\N	\N	105117	105117	272858
12394	13220	1	applied	\N	\N	\N	\N	105118	105118	272859
12404	13228	0	applied	\N	\N	\N	\N	105134	105134	272875
12410	13231	0	applied	\N	\N	\N	\N	105141	105141	272882
12411	13232	0	applied	\N	\N	\N	\N	105142	105142	272883
12415	13233	0	applied	\N	\N	\N	\N	105146	105146	272887
12420	13234	0	applied	\N	\N	\N	\N	105152	105152	272893
12420	13235	1	applied	\N	\N	\N	\N	105153	105153	272894
12420	13236	2	applied	\N	\N	\N	\N	105154	105154	272895
12445	13174	0	applied	\N	\N	\N	\N	105158	105158	272899
12445	13180	1	applied	\N	\N	\N	\N	105159	105159	272900
12445	13181	2	applied	\N	\N	\N	\N	105160	105160	272901
12445	13115	4	applied	\N	\N	\N	\N	105162	105162	272903
12445	13092	5	applied	\N	\N	\N	\N	105163	105163	272904
12445	13118	6	applied	\N	\N	\N	\N	105164	105164	272905
12504	13270	0	applied	\N	\N	\N	\N	105314	105314	273055
12504	13271	1	applied	\N	\N	\N	\N	105315	105315	273056
12509	13285	0	applied	\N	\N	\N	\N	105340	105340	273081
12509	13286	1	applied	\N	\N	\N	\N	105341	105341	273082
12509	13287	2	applied	\N	\N	\N	\N	105342	105342	273083
12509	13288	3	applied	\N	\N	\N	\N	105343	105343	273084
12514	13298	0	applied	\N	\N	\N	\N	105355	105355	273096
12514	13299	1	applied	\N	\N	\N	\N	105356	105356	273097
12518	13304	0	applied	\N	\N	\N	\N	105363	105363	273104
12518	13305	1	applied	\N	\N	\N	\N	105364	105364	273105
12523	13310	0	applied	\N	\N	\N	\N	105377	105377	273118
12200	13032	0	applied	\N	\N	\N	\N	104332	104332	272077
12203	13038	0	applied	\N	\N	\N	\N	104338	104338	272083
12217	12713	46	applied	\N	\N	\N	\N	104407	104407	272151
12217	12714	47	applied	\N	\N	\N	\N	104408	104408	272152
12217	12715	48	applied	\N	\N	\N	\N	104409	104409	272153
12217	12716	49	applied	\N	\N	\N	\N	104410	104410	272154
12217	12717	50	applied	\N	\N	\N	\N	104411	104411	272155
12217	12718	51	applied	\N	\N	\N	\N	104412	104412	272156
12217	12719	52	applied	\N	\N	1000000000	\N	104413	104413	272157
12217	12720	53	applied	\N	\N	\N	\N	104414	104414	272158
12217	12721	54	applied	\N	\N	\N	\N	104415	104415	272159
12217	12722	55	applied	\N	\N	\N	\N	104416	104416	272160
12217	12723	56	applied	\N	\N	\N	\N	104417	104417	272161
12217	12724	57	applied	\N	\N	\N	\N	104418	104418	272162
12217	12725	58	applied	\N	\N	\N	\N	104419	104419	272163
12217	12727	60	applied	\N	\N	\N	\N	104421	104421	272165
12217	12728	61	applied	\N	\N	1000000000	\N	104422	104422	272166
12217	12729	62	applied	\N	\N	\N	\N	104423	104423	272167
12217	12730	63	applied	\N	\N	\N	\N	104424	104424	272168
12217	12731	64	applied	\N	\N	\N	\N	104425	104425	272169
12217	12732	65	applied	\N	\N	\N	\N	104426	104426	272170
12217	12733	66	applied	\N	\N	\N	\N	104427	104427	272171
12217	12734	67	applied	\N	\N	\N	\N	104428	104428	272172
12217	12736	68	applied	\N	\N	\N	\N	104429	104429	272173
12217	12737	69	applied	\N	\N	\N	\N	104430	104430	272174
12217	12738	70	applied	\N	\N	\N	\N	104431	104431	272175
12217	12739	71	applied	\N	\N	\N	\N	104432	104432	272176
12217	12741	72	applied	\N	\N	\N	\N	104433	104433	272177
12217	12742	73	applied	\N	\N	\N	\N	104434	104434	272178
12217	12743	74	applied	\N	\N	\N	\N	104435	104435	272179
12217	12744	75	applied	\N	\N	\N	\N	104436	104436	272180
12217	12747	77	applied	\N	\N	\N	\N	104438	104438	272182
12217	12748	78	applied	\N	\N	\N	\N	104439	104439	272183
12217	12749	79	applied	\N	\N	\N	\N	104440	104440	272184
12217	12751	80	applied	\N	\N	\N	\N	104441	104441	272185
12217	12752	81	applied	\N	\N	\N	\N	104442	104442	272186
12217	12753	82	applied	\N	\N	\N	\N	104443	104443	272187
12217	12754	83	applied	\N	\N	\N	\N	104444	104444	272188
12217	12755	84	applied	\N	\N	\N	\N	104445	104445	272189
12217	12756	85	applied	\N	\N	\N	\N	104446	104446	272190
12217	12757	86	applied	\N	\N	\N	\N	104447	104447	272191
12217	12758	87	applied	\N	\N	\N	\N	104448	104448	272192
12217	12759	88	applied	\N	\N	\N	\N	104449	104449	272193
12217	12760	89	applied	\N	\N	\N	\N	104450	104450	272194
12217	12761	90	applied	\N	\N	\N	\N	104451	104451	272195
12217	12762	91	applied	\N	\N	\N	\N	104452	104452	272196
12217	12763	92	applied	\N	\N	\N	\N	104453	104453	272197
12217	12765	94	applied	\N	\N	\N	\N	104455	104455	272199
12217	12766	95	applied	\N	\N	\N	\N	104456	104456	272200
12217	12767	96	applied	\N	\N	\N	\N	104457	104457	272201
12217	12768	97	applied	\N	\N	\N	\N	104458	104458	272202
12217	12769	98	applied	\N	\N	\N	\N	104459	104459	272203
12217	12770	99	applied	\N	\N	\N	\N	104460	104460	272204
12217	12771	100	applied	\N	\N	\N	\N	104461	104461	272205
12217	12772	101	applied	\N	\N	\N	\N	104462	104462	272206
12217	12773	102	applied	\N	\N	\N	\N	104463	104463	272207
12217	12774	103	applied	\N	\N	\N	\N	104464	104464	272208
12217	12775	104	applied	\N	\N	\N	\N	104465	104465	272209
12217	12776	105	applied	\N	\N	\N	\N	104466	104466	272210
12217	12777	106	applied	\N	\N	\N	\N	104467	104467	272211
12217	12778	107	applied	\N	\N	\N	\N	104468	104468	272212
12217	12779	108	applied	\N	\N	\N	\N	104469	104469	272213
12217	12780	109	applied	\N	\N	\N	\N	104470	104470	272214
12217	12782	111	applied	\N	\N	\N	\N	104472	104472	272216
12217	12783	112	applied	\N	\N	\N	\N	104473	104473	272217
12217	12784	114	applied	\N	\N	\N	\N	104474	104474	272218
12217	12785	115	applied	\N	\N	\N	\N	104475	104475	272219
12217	12786	116	applied	\N	\N	\N	\N	104476	104476	272220
12217	12787	117	applied	\N	\N	\N	\N	104477	104477	272221
12217	12788	118	applied	\N	\N	\N	\N	104478	104478	272222
12217	12789	119	applied	\N	\N	\N	\N	104479	104479	272223
12217	12790	120	applied	\N	\N	\N	\N	104480	104480	272224
12217	12791	121	applied	\N	\N	\N	\N	104481	104481	272225
12217	12792	122	applied	\N	\N	\N	\N	104482	104482	272226
12217	12793	123	applied	\N	\N	\N	\N	104483	104483	272227
12217	12794	124	applied	\N	\N	\N	\N	104484	104484	272228
12217	12795	125	applied	\N	\N	\N	\N	104485	104485	272229
12219	13050	0	applied	\N	\N	\N	\N	104488	104488	272232
12219	13051	1	applied	\N	\N	\N	\N	104489	104489	272233
12226	13054	0	applied	\N	\N	\N	\N	104500	104500	272244
12226	13055	1	applied	\N	\N	\N	\N	104501	104501	272245
12226	13056	2	applied	\N	\N	\N	\N	104502	104502	272246
12228	13058	0	applied	\N	\N	\N	\N	104504	104504	272248
12231	13059	0	applied	\N	\N	\N	\N	104509	104509	272253
12233	13065	0	applied	\N	\N	\N	\N	104515	104515	272259
12237	13065	0	applied	\N	\N	\N	\N	104518	104518	272262
12240	13066	0	applied	\N	\N	\N	\N	104521	104521	272265
12242	13067	0	applied	\N	\N	\N	\N	104523	104523	272267
12244	13069	0	applied	\N	\N	\N	\N	104525	104525	272269
12244	13070	1	applied	\N	\N	\N	\N	104526	104526	272270
12244	13071	2	applied	\N	\N	\N	\N	104527	104527	272271
12258	13085	0	applied	\N	\N	\N	\N	104566	104566	272310
12259	13086	0	applied	\N	\N	\N	\N	104567	104567	272311
12259	13087	1	applied	\N	\N	\N	\N	104568	104568	272312
12259	13088	2	applied	\N	\N	\N	\N	104569	104569	272313
12261	13029	1	applied	\N	\N	\N	\N	104574	104574	272318
12261	13034	2	applied	\N	\N	\N	\N	104575	104575	272319
12261	13035	3	applied	\N	\N	\N	\N	104576	104576	272320
12261	13038	4	applied	\N	\N	\N	\N	104577	104577	272321
12261	13058	5	applied	\N	\N	\N	\N	104578	104578	272322
12261	13060	6	applied	\N	\N	\N	\N	104579	104579	272323
12445	13131	7	applied	\N	\N	\N	\N	105165	105165	272906
12445	13134	8	applied	\N	\N	\N	\N	105166	105166	272907
12445	13136	9	applied	\N	\N	\N	\N	105167	105167	272908
12445	13138	10	applied	\N	\N	\N	\N	105168	105168	272909
12445	13143	11	applied	\N	\N	\N	\N	105169	105169	272910
12445	13146	12	applied	\N	\N	\N	\N	105170	105170	272911
12445	13148	13	applied	\N	\N	\N	\N	105171	105171	272912
12445	13027	14	applied	\N	\N	\N	\N	105172	105172	272913
12445	13029	15	applied	\N	\N	\N	\N	105173	105173	272914
12445	13034	16	applied	\N	\N	\N	\N	105174	105174	272915
12217	12711	44	applied	\N	\N	\N	\N	104405	104405	272149
12217	12712	45	applied	\N	\N	\N	\N	104406	104406	272150
12261	13072	10	applied	\N	\N	\N	\N	104583	104583	272327
12261	13073	11	applied	\N	\N	\N	\N	104584	104584	272328
12261	13074	12	applied	\N	\N	\N	\N	104585	104585	272329
12261	13076	13	applied	\N	\N	\N	\N	104586	104586	272330
12261	13078	14	applied	\N	\N	\N	\N	104587	104587	272331
12261	13013	15	applied	\N	\N	\N	\N	104588	104588	272332
12261	13079	16	applied	\N	\N	\N	\N	104589	104589	272333
12261	12960	17	applied	\N	\N	\N	\N	104590	104590	272334
12261	12978	18	applied	\N	\N	\N	\N	104591	104591	272335
12261	12979	19	applied	\N	\N	\N	\N	104592	104592	272336
12261	12961	20	applied	\N	\N	\N	\N	104593	104593	272337
12261	12980	21	applied	\N	\N	\N	\N	104594	104594	272338
12261	12981	22	applied	\N	\N	\N	\N	104595	104595	272339
12261	12963	24	applied	\N	\N	\N	\N	104597	104597	272341
12261	12964	25	applied	\N	\N	\N	\N	104598	104598	272342
12261	12965	26	applied	\N	\N	\N	\N	104599	104599	272343
12261	12966	27	applied	\N	\N	\N	\N	104600	104600	272344
12261	12967	28	applied	\N	\N	\N	\N	104601	104601	272345
12261	12968	29	applied	\N	\N	\N	\N	104602	104602	272346
12261	12969	30	applied	\N	\N	\N	\N	104603	104603	272347
12261	12970	31	applied	\N	\N	\N	\N	104604	104604	272348
12261	12971	32	applied	\N	\N	\N	\N	104605	104605	272349
12261	12972	33	applied	\N	\N	\N	\N	104606	104606	272350
12261	12973	34	applied	\N	\N	\N	\N	104607	104607	272351
12261	12974	35	applied	\N	\N	\N	\N	104608	104608	272352
12261	12975	36	applied	\N	\N	\N	\N	104609	104609	272353
12261	12976	37	applied	\N	\N	\N	\N	104610	104610	272354
12261	12977	39	applied	\N	\N	\N	\N	104611	104611	272355
12261	12982	40	applied	\N	\N	\N	\N	104612	104612	272356
12261	12984	42	applied	\N	\N	\N	\N	104614	104614	272358
12261	12985	43	applied	\N	\N	\N	\N	104615	104615	272359
12261	12986	44	applied	\N	\N	\N	\N	104616	104616	272360
12261	12987	45	applied	\N	\N	1000000000	\N	104617	104617	272361
12261	12988	46	applied	\N	\N	\N	\N	104618	104618	272362
12261	12989	47	applied	\N	\N	\N	\N	104619	104619	272363
12261	12990	48	applied	\N	\N	\N	\N	104620	104620	272364
12261	12991	49	applied	\N	\N	\N	\N	104621	104621	272365
12261	12992	50	applied	\N	\N	\N	\N	104622	104622	272366
12261	12993	51	applied	\N	\N	\N	\N	104623	104623	272367
12261	12994	52	applied	\N	\N	\N	\N	104624	104624	272368
12261	12995	53	applied	\N	\N	\N	\N	104625	104625	272369
12261	12996	54	applied	\N	\N	\N	\N	104626	104626	272370
12261	12997	55	applied	\N	\N	\N	\N	104627	104627	272371
12261	12998	56	applied	\N	\N	\N	\N	104628	104628	272372
12261	12999	57	applied	\N	\N	\N	\N	104629	104629	272373
12261	13001	59	applied	\N	\N	\N	\N	104631	104631	272375
12261	13002	60	applied	\N	\N	\N	\N	104632	104632	272376
12261	13003	61	applied	\N	\N	\N	\N	104633	104633	272377
12261	13004	62	applied	\N	\N	\N	\N	104634	104634	272378
12261	13005	63	applied	\N	\N	\N	\N	104635	104635	272379
12261	13006	64	applied	\N	\N	\N	\N	104636	104636	272380
12261	13007	65	applied	\N	\N	\N	\N	104637	104637	272381
12261	13008	66	applied	\N	\N	\N	\N	104638	104638	272382
12261	13009	67	applied	\N	\N	\N	\N	104639	104639	272383
12261	13010	68	applied	\N	\N	\N	\N	104640	104640	272384
12261	13011	69	applied	\N	\N	\N	\N	104641	104641	272385
12261	13012	70	applied	\N	\N	\N	\N	104642	104642	272386
12261	13014	71	applied	\N	\N	\N	\N	104643	104643	272387
12261	13015	72	applied	\N	\N	\N	\N	104644	104644	272388
12261	13016	73	applied	\N	\N	\N	\N	104645	104645	272389
12261	13017	74	applied	\N	\N	\N	\N	104646	104646	272390
12261	13019	76	applied	\N	\N	\N	\N	104648	104648	272392
12261	13020	77	applied	\N	\N	\N	\N	104649	104649	272393
12261	13021	78	applied	\N	\N	\N	\N	104650	104650	272394
12261	13022	79	applied	\N	\N	\N	\N	104651	104651	272395
12261	13023	80	applied	\N	\N	\N	\N	104652	104652	272396
12261	13024	81	applied	\N	\N	\N	\N	104653	104653	272397
12261	13025	82	applied	\N	\N	\N	\N	104654	104654	272398
12261	13026	83	applied	\N	\N	\N	\N	104655	104655	272399
12261	13028	84	applied	\N	\N	\N	\N	104656	104656	272400
12261	13030	85	applied	\N	\N	\N	\N	104657	104657	272401
12261	13031	86	applied	\N	\N	\N	\N	104658	104658	272402
12261	13032	87	applied	\N	\N	\N	\N	104659	104659	272403
12261	13033	88	applied	\N	\N	\N	\N	104660	104660	272404
12261	13036	89	applied	\N	\N	\N	\N	104661	104661	272405
12261	13037	90	applied	\N	\N	\N	\N	104662	104662	272406
12261	13039	91	applied	\N	\N	\N	\N	104663	104663	272407
12261	13041	93	applied	\N	\N	\N	\N	104665	104665	272409
12261	13042	94	applied	\N	\N	\N	\N	104666	104666	272410
12261	13043	95	applied	\N	\N	\N	\N	104667	104667	272411
12261	13044	96	applied	\N	\N	\N	\N	104668	104668	272412
12261	13045	97	applied	\N	\N	1000000000	\N	104669	104669	272413
12261	13046	98	applied	\N	\N	\N	\N	104670	104670	272414
12261	13047	99	applied	\N	\N	\N	\N	104671	104671	272415
12261	13048	100	applied	\N	\N	\N	\N	104672	104672	272416
12261	13049	101	applied	\N	\N	\N	\N	104673	104673	272417
12261	13050	102	applied	\N	\N	\N	\N	104674	104674	272418
12261	13051	103	applied	\N	\N	\N	\N	104675	104675	272419
12261	13052	104	applied	\N	\N	\N	\N	104676	104676	272420
12261	13053	105	applied	\N	\N	\N	\N	104677	104677	272421
12261	13054	106	applied	\N	\N	\N	\N	104678	104678	272422
12261	13055	107	applied	\N	\N	\N	\N	104679	104679	272423
12261	13056	108	applied	\N	\N	\N	\N	104680	104680	272424
12261	13059	110	applied	\N	\N	\N	\N	104682	104682	272426
12261	13063	111	applied	\N	\N	\N	\N	104683	104683	272427
12261	13064	112	applied	\N	\N	\N	\N	104684	104684	272428
12261	13065	113	applied	\N	\N	\N	\N	104685	104685	272429
12261	13066	114	applied	\N	\N	\N	\N	104686	104686	272430
12261	13067	115	applied	\N	\N	\N	\N	104687	104687	272431
12261	13068	116	applied	\N	\N	\N	\N	104688	104688	272432
12261	13070	117	applied	\N	\N	\N	\N	104689	104689	272433
12261	13071	118	applied	\N	\N	\N	\N	104690	104690	272434
12261	13075	119	applied	\N	\N	\N	\N	104691	104691	272435
12261	13077	120	applied	\N	\N	\N	\N	104692	104692	272436
12261	13080	121	applied	\N	\N	\N	\N	104693	104693	272437
12261	13081	122	applied	\N	\N	\N	\N	104694	104694	272438
12261	13082	123	applied	\N	\N	\N	\N	104695	104695	272439
12261	13083	124	applied	\N	\N	\N	\N	104696	104696	272440
12263	12807	0	applied	\N	\N	\N	\N	104698	104698	272442
12261	13062	8	applied	\N	\N	\N	\N	104581	104581	272325
12261	13069	9	applied	\N	\N	\N	\N	104582	104582	272326
12263	13035	6	applied	\N	\N	\N	\N	104704	104704	272448
12263	13038	7	applied	\N	\N	\N	\N	104705	104705	272449
12263	13058	8	applied	\N	\N	\N	\N	104706	104706	272450
12263	13060	9	applied	\N	\N	\N	\N	104707	104707	272451
12263	12647	10	applied	\N	\N	\N	\N	104708	104708	272452
12263	13061	11	applied	\N	\N	\N	\N	104709	104709	272453
12263	13062	12	applied	\N	\N	\N	\N	104710	104710	272454
12265	13090	0	applied	\N	\N	\N	\N	104712	104712	272456
12267	13091	0	applied	\N	\N	\N	\N	104714	104714	272458
12270	13092	0	applied	\N	\N	\N	\N	104716	104716	272460
12270	13093	1	applied	\N	\N	\N	\N	104717	104717	272461
12270	13094	2	applied	\N	\N	\N	\N	104718	104718	272462
12270	13095	3	applied	\N	\N	\N	\N	104719	104719	272463
12270	13096	4	applied	\N	\N	\N	\N	104720	104720	272464
12270	13097	5	applied	\N	\N	\N	\N	104721	104721	272465
12270	13098	6	applied	\N	\N	\N	\N	104722	104722	272466
12279	13100	0	applied	\N	\N	\N	\N	104727	104727	272471
12281	13101	0	applied	\N	\N	\N	\N	104729	104729	272473
12283	13104	0	applied	\N	\N	\N	\N	104732	104732	272476
12286	13111	0	applied	\N	\N	\N	\N	104739	104739	272483
12293	13118	0	applied	\N	\N	\N	\N	104768	104768	272512
12293	13119	1	applied	\N	\N	\N	\N	104769	104769	272513
12296	13120	0	applied	\N	\N	\N	\N	104790	104790	272534
12296	13121	1	applied	\N	\N	\N	\N	104791	104791	272535
12296	13128	2	applied	\N	\N	\N	\N	104792	104792	272536
12296	13129	3	applied	\N	\N	\N	\N	104793	104793	272537
12298	13131	0	applied	\N	\N	\N	\N	104795	104795	272539
12298	13132	1	applied	\N	\N	\N	\N	104796	104796	272540
12308	13143	0	applied	\N	\N	\N	\N	104816	104816	272560
12308	13144	1	applied	\N	\N	\N	\N	104817	104817	272561
12314	13152	0	applied	\N	\N	\N	\N	104825	104825	272569
12316	13153	0	applied	\N	\N	\N	\N	104827	104827	272571
12321	13092	1	applied	\N	\N	\N	\N	104834	104834	272578
12321	13118	2	applied	\N	\N	\N	\N	104835	104835	272579
12321	13131	3	applied	\N	\N	\N	\N	104836	104836	272580
12321	13134	4	applied	\N	\N	\N	\N	104837	104837	272581
12321	13136	5	applied	\N	\N	\N	\N	104838	104838	272582
12321	13138	6	applied	\N	\N	\N	\N	104839	104839	272583
12321	13143	7	applied	\N	\N	\N	\N	104840	104840	272584
12321	13146	8	applied	\N	\N	\N	\N	104841	104841	272585
12321	13148	9	applied	\N	\N	\N	\N	104842	104842	272586
12321	13107	10	applied	\N	\N	\N	\N	104843	104843	272587
12321	13108	11	applied	\N	\N	\N	\N	104844	104844	272588
12321	13102	12	applied	\N	\N	\N	\N	104845	104845	272589
12321	13109	13	applied	\N	\N	\N	\N	104846	104846	272590
12321	13110	14	applied	\N	\N	\N	\N	104847	104847	272591
12321	13139	15	applied	\N	\N	\N	\N	104848	104848	272592
12321	13093	16	applied	\N	\N	\N	\N	104849	104849	272593
12321	13095	18	applied	\N	\N	\N	\N	104851	104851	272595
12321	13096	19	applied	\N	\N	\N	\N	104852	104852	272596
12321	13082	20	applied	\N	\N	\N	\N	104853	104853	272597
12321	13083	21	applied	\N	\N	\N	\N	104854	104854	272598
12321	13084	22	applied	\N	\N	\N	\N	104855	104855	272599
12321	13085	23	applied	\N	\N	\N	\N	104856	104856	272600
12321	13086	24	applied	\N	\N	\N	\N	104857	104857	272601
12321	13087	25	applied	\N	\N	\N	\N	104858	104858	272602
12321	13088	26	applied	\N	\N	\N	\N	104859	104859	272603
12321	13089	27	applied	\N	\N	\N	\N	104860	104860	272604
12321	13090	28	applied	\N	\N	\N	\N	104861	104861	272605
12321	13091	29	applied	\N	\N	\N	\N	104862	104862	272606
12321	13097	30	applied	\N	\N	\N	\N	104863	104863	272607
12321	13098	31	applied	\N	\N	\N	\N	104864	104864	272608
12321	13099	32	applied	\N	\N	\N	\N	104865	104865	272609
12321	13100	33	applied	\N	\N	\N	\N	104866	104866	272610
12321	13103	35	applied	\N	\N	\N	\N	104868	104868	272612
12321	13104	36	applied	\N	\N	\N	\N	104869	104869	272613
12321	13105	37	applied	\N	\N	\N	\N	104870	104870	272614
12321	13106	38	applied	\N	\N	\N	\N	104871	104871	272615
12321	13111	39	applied	\N	\N	\N	\N	104872	104872	272616
12321	13112	40	applied	\N	\N	\N	\N	104873	104873	272617
12321	13113	41	applied	\N	\N	\N	\N	104874	104874	272618
12321	13114	42	applied	\N	\N	\N	\N	104875	104875	272619
12321	13116	43	applied	\N	\N	\N	\N	104876	104876	272620
12321	13117	44	applied	\N	\N	\N	\N	104877	104877	272621
12321	13119	45	applied	\N	\N	\N	\N	104878	104878	272622
12321	13128	46	applied	\N	\N	\N	\N	104879	104879	272623
12321	13129	47	applied	\N	\N	\N	\N	104880	104880	272624
12321	13130	48	applied	\N	\N	\N	\N	104881	104881	272625
12321	13132	49	applied	\N	\N	\N	\N	104882	104882	272626
12321	13133	50	applied	\N	\N	\N	\N	104883	104883	272627
12321	13137	53	applied	\N	\N	\N	\N	104885	104885	272629
12321	13140	54	applied	\N	\N	\N	\N	104886	104886	272630
12321	13141	55	applied	\N	\N	\N	\N	104887	104887	272631
12321	13142	56	applied	\N	\N	\N	\N	104888	104888	272632
12321	13144	57	applied	\N	\N	\N	\N	104889	104889	272633
12326	13163	0	applied	\N	\N	\N	\N	104900	104900	272644
12326	13164	1	applied	\N	\N	\N	\N	104901	104901	272645
12326	13165	2	applied	\N	\N	\N	\N	104902	104902	272646
12326	13166	3	applied	\N	\N	\N	\N	104903	104903	272647
12332	13168	0	applied	\N	\N	\N	\N	104913	104913	272657
12337	13170	0	applied	\N	\N	\N	\N	104916	104916	272660
12340	13172	0	applied	\N	\N	\N	\N	104919	104919	272663
12340	13173	1	applied	\N	\N	\N	\N	104920	104920	272664
12342	13172	0	applied	\N	\N	\N	\N	104923	104923	272667
12342	13173	1	applied	\N	\N	\N	\N	104924	104924	272668
12343	13174	0	applied	\N	\N	\N	\N	104925	104925	272669
12343	13176	2	applied	\N	\N	\N	\N	104927	104927	272671
12343	13177	3	applied	\N	\N	\N	\N	104928	104928	272672
12345	13178	0	applied	\N	\N	\N	\N	104933	104933	272677
12348	13184	0	applied	\N	\N	\N	\N	104939	104939	272683
12354	13187	0	applied	\N	\N	\N	\N	104946	104946	272690
12356	13190	0	applied	\N	\N	\N	\N	104949	104949	272693
12356	13191	1	applied	\N	\N	\N	\N	104950	104950	272694
12361	13194	0	applied	\N	\N	\N	\N	104955	104955	272699
12366	13199	0	applied	\N	\N	\N	\N	104962	104962	272706
12370	13203	0	applied	\N	\N	\N	\N	104968	104968	272712
12372	13174	0	applied	\N	\N	\N	\N	104971	104971	272715
12372	13180	1	applied	\N	\N	\N	\N	104972	104972	272716
12372	13181	2	applied	\N	\N	\N	\N	104973	104973	272717
12372	13182	3	applied	\N	\N	\N	\N	104974	104974	272718
12263	12821	3	applied	\N	\N	\N	\N	104701	104701	272445
12263	13029	4	applied	\N	\N	\N	\N	104702	104702	272446
12372	13131	7	applied	\N	\N	\N	\N	104978	104978	272722
12372	13134	8	applied	\N	\N	\N	\N	104979	104979	272723
12372	13136	9	applied	\N	\N	\N	\N	104980	104980	272724
12372	13138	10	applied	\N	\N	\N	\N	104981	104981	272725
12372	13143	11	applied	\N	\N	\N	\N	104982	104982	272726
12372	13146	12	applied	\N	\N	\N	\N	104983	104983	272727
12372	13029	13	applied	\N	\N	\N	\N	104984	104984	272728
12372	13034	14	applied	\N	\N	\N	\N	104985	104985	272729
12372	13035	15	applied	\N	\N	\N	\N	104986	104986	272730
12372	13038	16	applied	\N	\N	\N	\N	104987	104987	272731
12372	13058	17	applied	\N	\N	\N	\N	104988	104988	272732
12372	13060	18	applied	\N	\N	\N	\N	104989	104989	272733
12372	13107	19	applied	\N	\N	\N	\N	104990	104990	272734
12372	13061	21	applied	\N	\N	\N	\N	104992	104992	272736
12372	13109	22	applied	\N	\N	\N	\N	104993	104993	272737
12372	13110	23	applied	\N	\N	\N	\N	104994	104994	272738
12372	13062	24	applied	\N	\N	\N	\N	104995	104995	272739
12372	13069	25	applied	\N	\N	\N	\N	104996	104996	272740
12372	13072	26	applied	\N	\N	\N	\N	104997	104997	272741
12372	13073	27	applied	\N	\N	\N	\N	104998	104998	272742
12372	13074	28	applied	\N	\N	\N	\N	104999	104999	272743
12372	13093	29	applied	\N	\N	\N	\N	105000	105000	272744
12372	13094	30	applied	\N	\N	\N	\N	105001	105001	272745
12372	13095	31	applied	\N	\N	\N	\N	105002	105002	272746
12372	13076	32	applied	\N	\N	\N	\N	105003	105003	272747
12372	13078	33	applied	\N	\N	\N	\N	105004	105004	272748
12372	13096	34	applied	\N	\N	\N	\N	105005	105005	272749
12372	12884	35	applied	\N	\N	\N	\N	105006	105006	272750
12372	13013	36	applied	\N	\N	\N	\N	105007	105007	272751
12372	12871	38	applied	\N	\N	\N	\N	105009	105009	272753
12372	12949	39	applied	\N	\N	\N	\N	105010	105010	272754
12372	12872	40	applied	\N	\N	\N	\N	105011	105011	272755
12372	12898	41	applied	\N	\N	1000000000	\N	105012	105012	272756
12372	12873	42	applied	\N	\N	\N	\N	105013	105013	272757
12372	12874	43	applied	\N	\N	\N	\N	105014	105014	272758
12372	12875	44	applied	\N	\N	\N	\N	105015	105015	272759
12372	12876	45	applied	\N	\N	\N	\N	105016	105016	272760
12372	12934	46	applied	\N	\N	\N	\N	105017	105017	272761
12372	12899	47	applied	\N	\N	\N	\N	105018	105018	105018
12372	12877	48	applied	\N	\N	\N	\N	105019	105019	272762
12372	12878	49	applied	\N	\N	\N	\N	105020	105020	272763
12372	12879	50	applied	\N	\N	\N	\N	105021	105021	272764
12372	12880	51	applied	\N	\N	\N	\N	105022	105022	272765
12372	12881	52	applied	\N	\N	\N	\N	105023	105023	272766
12372	12882	53	applied	\N	\N	\N	\N	105024	105024	272767
12372	12885	55	applied	\N	\N	\N	\N	105026	105026	272769
12372	12886	56	applied	\N	\N	\N	\N	105027	105027	272770
12372	12887	57	applied	\N	\N	\N	\N	105028	105028	272771
12372	12978	58	applied	\N	\N	\N	\N	105029	105029	272772
12372	12979	59	applied	\N	\N	\N	\N	105030	105030	272773
12372	12980	60	applied	\N	\N	\N	\N	105031	105031	272774
12372	12981	61	applied	\N	\N	\N	\N	105032	105032	272775
12372	12888	62	applied	\N	\N	\N	\N	105033	105033	272776
12372	12889	63	applied	\N	\N	\N	\N	105034	105034	272777
12372	12890	64	applied	\N	\N	\N	\N	105035	105035	272778
12372	12891	65	applied	\N	\N	\N	\N	105036	105036	272779
12372	12892	66	applied	\N	\N	\N	\N	105037	105037	272780
12372	12893	67	applied	\N	\N	\N	\N	105038	105038	272781
12372	12894	68	applied	\N	\N	\N	\N	105039	105039	272782
12372	12895	69	applied	\N	\N	\N	\N	105040	105040	272783
12372	12896	70	applied	\N	\N	\N	\N	105041	105041	272784
12372	12900	72	applied	\N	\N	\N	\N	105043	105043	272786
12372	12901	73	applied	\N	\N	\N	\N	105044	105044	272787
12372	12902	74	applied	\N	\N	\N	\N	105045	105045	272788
12372	12903	75	applied	\N	\N	\N	\N	105046	105046	272789
12372	12905	76	applied	\N	\N	\N	\N	105047	105047	272790
12372	12906	77	applied	\N	\N	\N	\N	105048	105048	272791
12372	12909	78	applied	\N	\N	\N	\N	105049	105049	272792
12372	12910	80	applied	\N	\N	\N	\N	105050	105050	272793
12372	12911	81	applied	\N	\N	1000000000	\N	105051	105051	272794
12372	12912	82	applied	\N	\N	\N	\N	105052	105052	272795
12372	12913	83	applied	\N	\N	\N	\N	105053	105053	272796
12372	12914	84	applied	\N	\N	\N	\N	105054	105054	272797
12372	12916	85	applied	\N	\N	\N	\N	105055	105055	272798
12372	12917	86	applied	\N	\N	\N	\N	105056	105056	272799
12372	12918	87	applied	\N	\N	\N	\N	105057	105057	272800
12372	12919	88	applied	\N	\N	\N	\N	105058	105058	272801
12372	12921	90	applied	\N	\N	\N	\N	105060	105060	272803
12372	12922	91	applied	\N	\N	\N	\N	105061	105061	272804
12372	12924	92	applied	\N	\N	\N	\N	105062	105062	272805
12372	12925	93	applied	\N	\N	\N	\N	105063	105063	272806
12372	12926	94	applied	\N	\N	\N	\N	105064	105064	272807
12372	12927	95	applied	\N	\N	\N	\N	105065	105065	272808
12372	12928	96	applied	\N	\N	\N	\N	105066	105066	272809
12372	12929	97	applied	\N	\N	\N	\N	105067	105067	272810
12372	12930	98	applied	\N	\N	\N	\N	105068	105068	272811
12372	12931	99	applied	\N	\N	\N	\N	105069	105069	272812
12372	12932	100	applied	\N	\N	\N	\N	105070	105070	272813
12372	12933	101	applied	\N	\N	\N	\N	105071	105071	272814
12372	12935	102	applied	\N	\N	\N	\N	105072	105072	272815
12372	12936	103	applied	\N	\N	\N	\N	105073	105073	272816
12372	12937	104	applied	\N	\N	\N	\N	105074	105074	272817
12372	12938	105	applied	\N	\N	\N	\N	105075	105075	272818
12372	12940	107	applied	\N	\N	\N	\N	105077	105077	272820
12372	12941	108	applied	\N	\N	\N	\N	105078	105078	272821
12372	12942	109	applied	\N	\N	\N	\N	105079	105079	272822
12372	12943	110	applied	\N	\N	\N	\N	105080	105080	272823
12372	12944	111	applied	\N	\N	\N	\N	105081	105081	272824
12372	12945	112	applied	\N	\N	\N	\N	105082	105082	272825
12372	12946	113	applied	\N	\N	\N	\N	105083	105083	272826
12372	12904	114	applied	\N	\N	\N	\N	105084	105084	105084
12372	12908	115	applied	\N	\N	\N	\N	105085	105085	105085
12372	12947	116	applied	\N	\N	\N	\N	105086	105086	272827
12372	12948	117	applied	\N	\N	\N	\N	105087	105087	272828
12372	12950	118	applied	\N	\N	\N	\N	105088	105088	272829
12372	12951	119	applied	\N	\N	\N	\N	105089	105089	272830
12372	12952	120	applied	\N	\N	\N	\N	105090	105090	272831
12372	12953	121	applied	\N	\N	\N	\N	105091	105091	272832
12372	12954	122	applied	\N	\N	\N	\N	105092	105092	272833
12372	13092	5	applied	\N	\N	\N	\N	104976	104976	272720
12372	13118	6	applied	\N	\N	\N	\N	104977	104977	272721
12376	13207	0	applied	\N	\N	\N	\N	105099	105099	272840
12378	13208	0	applied	\N	\N	\N	\N	105101	105101	272842
12380	13209	0	applied	\N	\N	\N	\N	105103	105103	272844
12388	13215	0	applied	\N	\N	\N	\N	105111	105111	272852
12392	13218	0	applied	\N	\N	\N	\N	105115	105115	272856
12395	13222	1	applied	\N	\N	\N	\N	105120	105120	272861
12397	13223	0	applied	\N	\N	\N	\N	105123	105123	272864
12400	13224	0	applied	\N	\N	\N	\N	105128	105128	272869
12400	13225	1	applied	\N	\N	\N	\N	105129	105129	272870
12402	13226	0	applied	\N	\N	\N	\N	105130	105130	272871
12402	13227	1	applied	\N	\N	\N	\N	105131	105131	272872
12405	13228	0	applied	\N	\N	\N	\N	105135	105135	272876
12407	13231	0	applied	\N	\N	\N	\N	105138	105138	272879
12412	13232	0	applied	\N	\N	\N	\N	105143	105143	272884
12416	13233	0	applied	\N	\N	\N	\N	105147	105147	272888
12421	13228	0	applied	\N	\N	\N	\N	105155	105155	272896
12460	13239	0	applied	\N	\N	\N	\N	105226	105226	272967
12465	13240	0	applied	\N	\N	\N	\N	105228	105228	272969
12465	13241	1	applied	\N	\N	\N	\N	105229	105229	272970
12465	13242	2	applied	\N	\N	\N	\N	105230	105230	272971
12465	13243	3	applied	\N	\N	\N	\N	105231	105231	272972
12465	13245	5	applied	\N	\N	\N	\N	105233	105233	272974
12465	13246	6	applied	\N	\N	\N	\N	105234	105234	272975
12475	13247	0	applied	\N	\N	\N	\N	105262	105262	273003
12477	13248	0	applied	\N	\N	\N	\N	105263	105263	273004
12477	13249	1	applied	\N	\N	1000000000	\N	105264	105264	273005
12477	13250	2	applied	\N	\N	1000000000	\N	105265	105265	273006
12479	13248	0	applied	\N	\N	\N	\N	105269	105269	273010
12479	13249	1	applied	\N	\N	1000000000	\N	105270	105270	273011
12479	13250	2	applied	\N	\N	1000000000	\N	105271	105271	273012
12482	13255	0	applied	\N	\N	\N	\N	105276	105276	273017
12490	13262	0	applied	\N	\N	\N	\N	105293	105293	273034
12493	13263	0	applied	\N	\N	\N	\N	105296	105296	273037
12494	13263	0	applied	\N	\N	\N	\N	105297	105297	273038
12496	13263	0	applied	\N	\N	\N	\N	105299	105299	273040
12499	13266	0	applied	\N	\N	\N	\N	105304	105304	273045
12499	13267	1	applied	\N	\N	\N	\N	105305	105305	273046
12503	13271	1	applied	\N	\N	\N	\N	105313	105313	273054
12505	13264	0	applied	\N	\N	\N	\N	105316	105316	273057
12505	13266	1	applied	\N	\N	\N	\N	105317	105317	273058
12505	13268	2	applied	\N	\N	\N	\N	105318	105318	273059
12505	13270	3	applied	\N	\N	\N	\N	105319	105319	273060
12505	13263	4	applied	\N	\N	\N	\N	105320	105320	273061
12505	13265	5	applied	\N	\N	\N	\N	105321	105321	273062
12505	13267	6	applied	\N	\N	\N	\N	105322	105322	273063
12505	13269	7	applied	\N	\N	\N	\N	105323	105323	273064
12505	13271	8	applied	\N	\N	\N	\N	105324	105324	273065
12507	13272	0	applied	\N	\N	\N	\N	105327	105327	273068
12510	13289	0	applied	\N	\N	\N	\N	105344	105344	273085
12510	13290	1	applied	\N	\N	\N	\N	105345	105345	273086
12513	13298	0	applied	\N	\N	\N	\N	105353	105353	273094
12513	13299	1	applied	\N	\N	\N	\N	105354	105354	273095
12515	13300	0	applied	\N	\N	\N	\N	105357	105357	273098
12525	13310	0	applied	\N	\N	\N	\N	105389	105389	273130
12525	13311	1	applied	\N	\N	\N	\N	105390	105390	273131
12525	13312	2	applied	\N	\N	\N	\N	105391	105391	273132
12525	13313	3	applied	\N	\N	\N	\N	105392	105392	273133
12525	13314	4	applied	\N	\N	\N	\N	105393	105393	273134
12525	13315	5	applied	\N	\N	\N	\N	105394	105394	273135
12527	13318	0	applied	\N	\N	\N	\N	105397	105397	273138
12527	13319	1	applied	\N	\N	\N	\N	105398	105398	273139
12533	13324	0	applied	\N	\N	\N	\N	105411	105411	273152
12537	13331	0	applied	\N	\N	\N	\N	105419	105419	273160
12537	13332	1	applied	\N	\N	\N	\N	105420	105420	273161
12542	13333	0	applied	\N	\N	\N	\N	105433	105433	273174
12542	13334	1	applied	\N	\N	\N	\N	105434	105434	273175
12542	13335	2	applied	\N	\N	\N	\N	105435	105435	273176
12542	13336	3	applied	\N	\N	\N	\N	105436	105436	273177
12544	13337	0	applied	\N	\N	\N	\N	105442	105442	273183
12544	13339	2	applied	\N	\N	1000000000	\N	105444	105444	273185
12544	13340	3	applied	\N	\N	\N	\N	105445	105445	273186
12544	13341	4	applied	\N	\N	\N	\N	105446	105446	273187
12546	13342	0	applied	\N	\N	\N	\N	105449	105449	273190
12546	13343	1	applied	\N	\N	\N	\N	105450	105450	273191
12553	13344	0	applied	\N	\N	\N	\N	105582	105582	273323
12553	13345	1	applied	\N	\N	\N	\N	105583	105583	273324
12553	13348	2	applied	\N	\N	\N	\N	105584	105584	273325
12553	13346	3	applied	\N	\N	\N	\N	105585	105585	273326
12553	13347	4	applied	\N	\N	\N	\N	105586	105586	273327
12553	13349	5	applied	\N	\N	\N	\N	105587	105587	273328
12561	13360	0	applied	\N	\N	\N	\N	105610	105610	273351
12561	13361	1	applied	\N	\N	\N	\N	105611	105611	273352
12561	13362	2	applied	\N	\N	\N	\N	105612	105612	273353
12561	13363	3	applied	\N	\N	\N	\N	105613	105613	273354
12565	13368	0	applied	\N	\N	\N	\N	105626	105626	273367
12568	13372	0	applied	\N	\N	\N	\N	105632	105632	273373
12568	13373	1	applied	\N	\N	\N	\N	105633	105633	273374
12568	13374	2	applied	\N	\N	\N	\N	105634	105634	273375
12568	13375	3	applied	\N	\N	\N	\N	105635	105635	273376
12568	13376	4	applied	\N	\N	\N	\N	105636	105636	273377
12568	13377	5	applied	\N	\N	\N	\N	105637	105637	273378
12568	13378	6	applied	\N	\N	\N	\N	105638	105638	273379
12568	13379	7	applied	\N	\N	\N	\N	105639	105639	273380
12568	13380	8	applied	\N	\N	\N	\N	105640	105640	273381
12573	13385	0	applied	\N	\N	\N	\N	105649	105649	273390
12573	13386	1	applied	\N	\N	\N	\N	105650	105650	273391
12575	13387	0	applied	\N	\N	\N	\N	105653	105653	273394
12575	13388	1	applied	\N	\N	\N	\N	105654	105654	273395
12579	13399	0	applied	\N	\N	\N	\N	105665	105665	273406
12579	13400	1	applied	\N	\N	\N	\N	105666	105666	273407
12579	13401	2	applied	\N	\N	\N	\N	105667	105667	273408
12579	13403	4	applied	\N	\N	\N	\N	105669	105669	273410
12579	13404	5	applied	\N	\N	\N	\N	105670	105670	273411
12582	13405	0	applied	\N	\N	\N	\N	105678	105678	273419
12589	13420	0	applied	\N	\N	\N	\N	105714	105714	273455
12589	13421	1	applied	\N	\N	\N	\N	105715	105715	273456
12590	13422	0	applied	\N	\N	\N	\N	105716	105716	273457
12590	13423	1	applied	\N	\N	\N	\N	105717	105717	273458
12594	13428	0	applied	\N	\N	\N	\N	105726	105726	273467
12372	12957	125	applied	\N	\N	1000000000	\N	105095	105095	272836
12373	13206	0	applied	\N	\N	\N	\N	105096	105096	272837
12445	13108	22	applied	\N	\N	\N	\N	105180	105180	272921
12445	13061	23	applied	\N	\N	\N	\N	105181	105181	272922
12445	13109	24	applied	\N	\N	\N	\N	105182	105182	272923
12445	13110	25	applied	\N	\N	\N	\N	105183	105183	272924
12445	13139	26	applied	\N	\N	\N	\N	105184	105184	272925
12445	13062	27	applied	\N	\N	\N	\N	105185	105185	272926
12445	13069	28	applied	\N	\N	\N	\N	105186	105186	272927
12445	13072	29	applied	\N	\N	\N	\N	105187	105187	272928
12445	13073	30	applied	\N	\N	\N	\N	105188	105188	272929
12445	13074	31	applied	\N	\N	\N	\N	105189	105189	272930
12445	13093	32	applied	\N	\N	\N	\N	105190	105190	272931
12445	13094	33	applied	\N	\N	\N	\N	105191	105191	272932
12445	13095	34	applied	\N	\N	\N	\N	105192	105192	272933
12445	13076	35	applied	\N	\N	\N	\N	105193	105193	272934
12445	13096	37	applied	\N	\N	\N	\N	105195	105195	272936
12445	13079	38	applied	\N	\N	\N	\N	105196	105196	272937
12445	13022	39	applied	\N	\N	\N	\N	105197	105197	272938
12445	13023	40	applied	\N	\N	\N	\N	105198	105198	272939
12445	13024	41	applied	\N	\N	\N	\N	105199	105199	272940
12445	13025	42	applied	\N	\N	\N	\N	105200	105200	272941
12445	13026	43	applied	\N	\N	\N	\N	105201	105201	272942
12445	13028	44	applied	\N	\N	\N	\N	105202	105202	272943
12445	13030	45	applied	\N	\N	\N	\N	105203	105203	272944
12445	13031	46	applied	\N	\N	\N	\N	105204	105204	272945
12445	13032	47	applied	\N	\N	\N	\N	105205	105205	272946
12445	13033	48	applied	\N	\N	\N	\N	105206	105206	272947
12445	13036	49	applied	\N	\N	\N	\N	105207	105207	272948
12445	13037	50	applied	\N	\N	\N	\N	105208	105208	272949
12445	13039	51	applied	\N	\N	\N	\N	105209	105209	272950
12445	13040	52	applied	\N	\N	\N	\N	105210	105210	272951
12445	13042	54	applied	\N	\N	\N	\N	105212	105212	272953
12445	13043	55	applied	\N	\N	\N	\N	105213	105213	272954
12445	13044	56	applied	\N	\N	\N	\N	105214	105214	272955
12445	13045	57	applied	\N	\N	1000000000	\N	105215	105215	272956
12474	13247	0	applied	\N	\N	\N	\N	105261	105261	273002
12481	13254	0	applied	\N	\N	\N	\N	105275	105275	273016
12484	13257	0	applied	\N	\N	\N	\N	105278	105278	273019
12485	13258	0	applied	\N	\N	\N	\N	105279	105279	273020
12485	13259	1	applied	\N	\N	\N	\N	105280	105280	273021
12485	13260	2	applied	\N	\N	\N	\N	105281	105281	273022
12485	13261	3	applied	\N	\N	\N	\N	105282	105282	273023
12492	13263	0	applied	\N	\N	\N	\N	105295	105295	273036
12498	13266	0	applied	\N	\N	\N	\N	105302	105302	273043
12498	13267	1	applied	\N	\N	\N	\N	105303	105303	273044
12500	13266	0	applied	\N	\N	\N	\N	105306	105306	273047
12500	13267	1	applied	\N	\N	\N	\N	105307	105307	273048
12508	13274	1	applied	\N	\N	\N	\N	105329	105329	273070
12508	13275	2	applied	\N	\N	\N	\N	105330	105330	273071
12508	13276	3	applied	\N	\N	\N	\N	105331	105331	273072
12508	13277	4	applied	\N	\N	\N	\N	105332	105332	273073
12508	13278	5	applied	\N	\N	\N	\N	105333	105333	273074
12508	13279	6	applied	\N	\N	\N	\N	105334	105334	273075
12508	13280	7	applied	\N	\N	\N	\N	105335	105335	273076
12508	13281	8	applied	\N	\N	\N	\N	105336	105336	273077
12508	13282	9	applied	\N	\N	\N	\N	105337	105337	273078
12508	13283	10	applied	\N	\N	\N	\N	105338	105338	273079
12508	13284	11	applied	\N	\N	\N	\N	105339	105339	273080
12511	13291	0	applied	\N	\N	\N	\N	105346	105346	273087
12511	13292	1	applied	\N	\N	\N	\N	105347	105347	273088
12511	13293	2	applied	\N	\N	\N	\N	105348	105348	273089
12516	13302	0	applied	\N	\N	\N	\N	105359	105359	273100
12516	13303	1	applied	\N	\N	\N	\N	105360	105360	273101
12519	13305	1	applied	\N	\N	\N	\N	105366	105366	273107
12521	13306	0	applied	\N	\N	\N	\N	105369	105369	273110
12521	13307	1	applied	\N	\N	\N	\N	105370	105370	273111
12521	13308	2	applied	\N	\N	\N	\N	105371	105371	273112
12521	13309	3	applied	\N	\N	\N	\N	105372	105372	273113
12524	13310	0	applied	\N	\N	\N	\N	105383	105383	273124
12524	13311	1	applied	\N	\N	\N	\N	105384	105384	273125
12524	13312	2	applied	\N	\N	\N	\N	105385	105385	273126
12524	13313	3	applied	\N	\N	\N	\N	105386	105386	273127
12524	13314	4	applied	\N	\N	\N	\N	105387	105387	273128
12524	13315	5	applied	\N	\N	\N	\N	105388	105388	273129
12526	13316	0	applied	\N	\N	\N	\N	105395	105395	273136
12526	13317	1	applied	\N	\N	\N	\N	105396	105396	273137
12531	13324	0	applied	\N	\N	\N	\N	105405	105405	273146
12534	13324	0	applied	\N	\N	\N	\N	105412	105412	273153
12535	13325	0	applied	\N	\N	\N	\N	105413	105413	273154
12547	13342	0	applied	\N	\N	\N	\N	105451	105451	273192
12547	13343	1	applied	\N	\N	\N	\N	105452	105452	273193
12556	13358	0	applied	\N	\N	\N	\N	105596	105596	273337
12556	13359	1	applied	\N	\N	\N	\N	105597	105597	273338
12563	13342	0	applied	\N	\N	\N	\N	105616	105616	273357
12563	13344	1	applied	\N	\N	\N	\N	105617	105617	273358
12563	13345	2	applied	\N	\N	\N	\N	105618	105618	273359
12563	13348	3	applied	\N	\N	\N	\N	105619	105619	273360
12563	13350	5	applied	\N	\N	\N	\N	105620	105620	273361
12563	13352	6	applied	\N	\N	\N	\N	105621	105621	273362
12563	13353	7	applied	\N	\N	\N	\N	105622	105622	273363
12563	13354	8	applied	\N	\N	\N	\N	105623	105623	273364
12569	13381	0	applied	\N	\N	\N	\N	105641	105641	273382
12569	13382	1	applied	\N	\N	\N	\N	105642	105642	273383
12576	13389	0	applied	\N	\N	\N	\N	105655	105655	273396
12576	13390	1	applied	\N	\N	\N	\N	105656	105656	273397
12576	13392	3	applied	\N	\N	\N	\N	105658	105658	273399
12580	13399	0	applied	\N	\N	\N	\N	105671	105671	273412
12580	13400	1	applied	\N	\N	\N	\N	105672	105672	273413
12580	13401	2	applied	\N	\N	\N	\N	105673	105673	273414
12580	13402	3	applied	\N	\N	\N	\N	105674	105674	273415
12594	13429	1	applied	\N	\N	\N	\N	105727	105727	273468
12597	13438	0	applied	\N	\N	\N	\N	105738	105738	273479
12597	13439	1	applied	\N	\N	\N	\N	105739	105739	273480
12600	13444	0	applied	\N	\N	\N	\N	105744	105744	273485
12600	13445	1	applied	\N	\N	\N	\N	105745	105745	273486
12603	13448	0	applied	\N	\N	\N	\N	105750	105750	273491
12603	13449	1	applied	\N	\N	\N	\N	105751	105751	273492
12603	13450	2	applied	\N	\N	\N	\N	105752	105752	273493
12603	13451	3	applied	\N	\N	\N	\N	105753	105753	273494
12603	13452	4	applied	\N	\N	\N	\N	105754	105754	273495
12603	13453	5	applied	\N	\N	\N	\N	105755	105755	273496
12445	13107	21	applied	\N	\N	\N	\N	105179	105179	272920
12472	13218	5	applied	\N	\N	\N	\N	105240	105240	272981
12472	13219	6	applied	\N	\N	\N	\N	105241	105241	272982
12472	13220	8	applied	\N	\N	\N	\N	105242	105242	272983
12472	13221	9	applied	\N	\N	\N	\N	105243	105243	272984
12472	13246	10	applied	\N	\N	\N	\N	105244	105244	272985
12472	13222	11	applied	\N	\N	\N	\N	105245	105245	272986
12472	13223	12	applied	\N	\N	\N	\N	105246	105246	272987
12472	13224	13	applied	\N	\N	\N	\N	105247	105247	272988
12472	13225	14	applied	\N	\N	\N	\N	105248	105248	272989
12472	13226	15	applied	\N	\N	\N	\N	105249	105249	272990
12472	13227	16	applied	\N	\N	\N	\N	105250	105250	272991
12472	13228	17	applied	\N	\N	\N	\N	105251	105251	272992
12472	13229	18	applied	\N	\N	\N	\N	105252	105252	272993
12472	13230	19	applied	\N	\N	\N	\N	105253	105253	272994
12472	13232	21	applied	\N	\N	\N	\N	105255	105255	272996
12472	13233	22	applied	\N	\N	\N	\N	105256	105256	272997
12472	13235	23	applied	\N	\N	\N	\N	105257	105257	272998
12472	13236	24	applied	\N	\N	\N	\N	105258	105258	272999
12472	13237	25	applied	\N	\N	\N	\N	105259	105259	273000
12472	13238	26	applied	\N	\N	\N	\N	105260	105260	273001
12483	13256	0	applied	\N	\N	\N	\N	105277	105277	273018
12487	13258	0	applied	\N	\N	\N	\N	105287	105287	273028
12487	13259	1	applied	\N	\N	\N	\N	105288	105288	273029
12487	13260	2	applied	\N	\N	\N	\N	105289	105289	273030
12487	13261	3	applied	\N	\N	\N	\N	105290	105290	273031
12489	13262	0	applied	\N	\N	\N	\N	105292	105292	273033
12491	13263	0	applied	\N	\N	\N	\N	105294	105294	273035
12495	13263	0	applied	\N	\N	\N	\N	105298	105298	273039
12497	13264	0	applied	\N	\N	\N	\N	105300	105300	273041
12497	13265	1	applied	\N	\N	\N	\N	105301	105301	273042
12502	13269	1	applied	\N	\N	\N	\N	105311	105311	273052
12506	13270	0	applied	\N	\N	\N	\N	105325	105325	273066
12506	13271	1	applied	\N	\N	\N	\N	105326	105326	273067
12512	13294	0	applied	\N	\N	\N	\N	105349	105349	273090
12512	13295	1	applied	\N	\N	\N	\N	105350	105350	273091
12512	13296	2	applied	\N	\N	\N	\N	105351	105351	273092
12512	13297	3	applied	\N	\N	\N	\N	105352	105352	273093
12517	13302	0	applied	\N	\N	\N	\N	105361	105361	273102
12517	13303	1	applied	\N	\N	\N	\N	105362	105362	273103
12520	13304	0	applied	\N	\N	\N	\N	105367	105367	273108
12520	13305	1	applied	\N	\N	\N	\N	105368	105368	273109
12522	13306	0	applied	\N	\N	\N	\N	105373	105373	273114
12522	13307	1	applied	\N	\N	\N	\N	105374	105374	273115
12522	13308	2	applied	\N	\N	\N	\N	105375	105375	273116
12522	13309	3	applied	\N	\N	\N	\N	105376	105376	273117
12529	13320	0	applied	\N	\N	\N	\N	105401	105401	273142
12532	13322	1	applied	\N	\N	\N	\N	105407	105407	273148
12532	13320	2	applied	\N	\N	\N	\N	105408	105408	273149
12532	13323	3	applied	\N	\N	\N	\N	105409	105409	273150
12532	13324	4	applied	\N	\N	\N	\N	105410	105410	273151
12536	13327	0	applied	\N	\N	\N	\N	105415	105415	273156
12536	13328	1	applied	\N	\N	\N	\N	105416	105416	273157
12536	13329	2	applied	\N	\N	\N	\N	105417	105417	273158
12536	13330	3	applied	\N	\N	\N	\N	105418	105418	273159
12539	13331	0	applied	\N	\N	\N	\N	105423	105423	273164
12539	13332	1	applied	\N	\N	\N	\N	105424	105424	273165
12541	13333	0	applied	\N	\N	\N	\N	105429	105429	273170
12541	13334	1	applied	\N	\N	\N	\N	105430	105430	273171
12541	13335	2	applied	\N	\N	\N	\N	105431	105431	273172
12541	13336	3	applied	\N	\N	\N	\N	105432	105432	273173
12543	13337	0	applied	\N	\N	\N	\N	105437	105437	273178
12543	13338	1	applied	\N	\N	\N	\N	105438	105438	273179
12543	13340	3	applied	\N	\N	\N	\N	105440	105440	273181
12543	13341	4	applied	\N	\N	\N	\N	105441	105441	273182
12545	13342	0	applied	\N	\N	\N	\N	105447	105447	273188
12545	13343	1	applied	\N	\N	\N	\N	105448	105448	273189
12552	13174	0	applied	\N	\N	\N	\N	105457	105457	273198
12552	13180	1	applied	\N	\N	\N	\N	105458	105458	273199
12552	13181	2	applied	\N	\N	\N	\N	105459	105459	273200
12552	13182	4	applied	\N	\N	\N	\N	105460	105460	273201
12552	13264	5	applied	\N	\N	\N	\N	105461	105461	273202
12552	13266	6	applied	\N	\N	\N	\N	105462	105462	273203
12552	13268	7	applied	\N	\N	\N	\N	105463	105463	273204
12552	13270	8	applied	\N	\N	\N	\N	105464	105464	273205
12552	13273	9	applied	\N	\N	\N	\N	105465	105465	273206
12552	13275	10	applied	\N	\N	\N	\N	105466	105466	273207
12552	13276	11	applied	\N	\N	\N	\N	105467	105467	273208
12552	13277	12	applied	\N	\N	\N	\N	105468	105468	273209
12552	13278	13	applied	\N	\N	\N	\N	105469	105469	273210
12552	13279	14	applied	\N	\N	\N	\N	105470	105470	273211
12552	13286	16	applied	\N	\N	\N	\N	105472	105472	273213
12552	13289	17	applied	\N	\N	\N	\N	105473	105473	273214
12552	13291	18	applied	\N	\N	\N	\N	105474	105474	273215
12552	13294	19	applied	\N	\N	\N	\N	105475	105475	273216
12552	13295	20	applied	\N	\N	\N	\N	105476	105476	273217
12552	13298	21	applied	\N	\N	\N	\N	105477	105477	273218
12552	13300	22	applied	\N	\N	\N	\N	105478	105478	273219
12552	13302	23	applied	\N	\N	\N	\N	105479	105479	273220
12552	13304	24	applied	\N	\N	\N	\N	105480	105480	273221
12552	13306	25	applied	\N	\N	\N	\N	105481	105481	273222
12552	13307	26	applied	\N	\N	\N	\N	105482	105482	273223
12552	13310	27	applied	\N	\N	\N	\N	105483	105483	273224
12552	13311	28	applied	\N	\N	\N	\N	105484	105484	273225
12552	13312	29	applied	\N	\N	\N	\N	105485	105485	273226
12552	13316	30	applied	\N	\N	\N	\N	105486	105486	273227
12552	13318	31	applied	\N	\N	\N	\N	105487	105487	273228
12552	13322	33	applied	\N	\N	\N	\N	105489	105489	273230
12552	13325	34	applied	\N	\N	\N	\N	105490	105490	273231
12552	13327	35	applied	\N	\N	\N	\N	105491	105491	273232
12580	13403	4	applied	\N	\N	\N	\N	105675	105675	273416
12580	13404	5	applied	\N	\N	\N	\N	105676	105676	273417
12584	13406	0	applied	\N	\N	\N	\N	105680	105680	273421
12584	13407	1	applied	\N	\N	\N	\N	105681	105681	273422
12585	13408	0	applied	\N	\N	\N	\N	105682	105682	273423
12585	13409	1	applied	\N	\N	\N	\N	105683	105683	273424
12585	13410	2	applied	\N	\N	\N	\N	105684	105684	273425
12585	13411	3	applied	\N	\N	\N	\N	105685	105685	273426
12585	13412	4	applied	\N	\N	\N	\N	105686	105686	273427
12585	13413	5	applied	\N	\N	\N	\N	105687	105687	273428
12585	13414	6	applied	\N	\N	\N	\N	105688	105688	273429
12472	13216	3	applied	\N	\N	\N	\N	105238	105238	272979
12472	13217	4	applied	\N	\N	\N	\N	105239	105239	272980
12523	13315	5	applied	\N	\N	\N	\N	105382	105382	273123
12528	13318	0	applied	\N	\N	\N	\N	105399	105399	273140
12528	13319	1	applied	\N	\N	\N	\N	105400	105400	273141
12530	13321	0	applied	\N	\N	\N	\N	105402	105402	273143
12530	13322	1	applied	\N	\N	\N	\N	105403	105403	273144
12530	13323	2	applied	\N	\N	\N	\N	105404	105404	273145
12538	13331	0	applied	\N	\N	\N	\N	105421	105421	273162
12538	13332	1	applied	\N	\N	\N	\N	105422	105422	273163
12540	13333	0	applied	\N	\N	\N	\N	105425	105425	273166
12540	13334	1	applied	\N	\N	\N	\N	105426	105426	273167
12540	13335	2	applied	\N	\N	\N	\N	105427	105427	273168
12540	13336	3	applied	\N	\N	\N	\N	105428	105428	273169
12551	13344	0	applied	\N	\N	\N	\N	105453	105453	273194
12551	13345	1	applied	\N	\N	\N	\N	105454	105454	273195
12551	13347	3	applied	\N	\N	\N	\N	105456	105456	273197
12552	13328	36	applied	\N	\N	\N	\N	105492	105492	273233
12552	13331	37	applied	\N	\N	\N	\N	105493	105493	273234
12552	13333	38	applied	\N	\N	\N	\N	105494	105494	273235
12552	13334	39	applied	\N	\N	\N	\N	105495	105495	273236
12552	13337	40	applied	\N	\N	\N	\N	105496	105496	273237
12552	13338	41	applied	\N	\N	\N	\N	105497	105497	273238
12552	13342	42	applied	\N	\N	\N	\N	105498	105498	273239
12552	13344	43	applied	\N	\N	\N	\N	105499	105499	273240
12552	13345	44	applied	\N	\N	\N	\N	105500	105500	273241
12552	13348	45	applied	\N	\N	\N	\N	105501	105501	273242
12552	13239	46	applied	\N	\N	\N	\N	105502	105502	273243
12552	13339	47	applied	\N	\N	1000000000	\N	105503	105503	273244
12552	13161	48	applied	\N	\N	\N	\N	105504	105504	273245
12552	13162	49	applied	\N	\N	\N	\N	105505	105505	273246
12552	13163	50	applied	\N	\N	\N	\N	105506	105506	273247
12552	13165	52	applied	\N	\N	\N	\N	105508	105508	273249
12552	13166	53	applied	\N	\N	\N	\N	105509	105509	273250
12552	13167	54	applied	\N	\N	\N	\N	105510	105510	273251
12552	13168	55	applied	\N	\N	\N	\N	105511	105511	273252
12552	13246	56	applied	\N	\N	\N	\N	105512	105512	273253
12552	13247	57	applied	\N	\N	\N	\N	105513	105513	273254
12552	13169	58	applied	\N	\N	\N	\N	105514	105514	273255
12552	13170	59	applied	\N	\N	\N	\N	105515	105515	273256
12552	13171	60	applied	\N	\N	\N	\N	105516	105516	273257
12552	13172	61	applied	\N	\N	\N	\N	105517	105517	273258
12552	13173	62	applied	\N	\N	\N	\N	105518	105518	273259
12552	13175	63	applied	\N	\N	\N	\N	105519	105519	273260
12552	13176	64	applied	\N	\N	\N	\N	105520	105520	273261
12552	13177	65	applied	\N	\N	\N	\N	105521	105521	273262
12552	13178	66	applied	\N	\N	\N	\N	105522	105522	273263
12552	13179	67	applied	\N	\N	\N	\N	105523	105523	273264
12552	13184	69	applied	\N	\N	\N	\N	105525	105525	273266
12552	13185	70	applied	\N	\N	\N	\N	105526	105526	273267
12552	13186	71	applied	\N	\N	\N	\N	105527	105527	273268
12552	13187	72	applied	\N	\N	\N	\N	105528	105528	273269
12552	13188	73	applied	\N	\N	\N	\N	105529	105529	273270
12552	13189	74	applied	\N	\N	\N	\N	105530	105530	273271
12552	13190	75	applied	\N	\N	\N	\N	105531	105531	273272
12552	13191	76	applied	\N	\N	\N	\N	105532	105532	273273
12552	13192	77	applied	\N	\N	\N	\N	105533	105533	273274
12552	13193	78	applied	\N	\N	\N	\N	105534	105534	273275
12552	13194	79	applied	\N	\N	\N	\N	105535	105535	273276
12552	13195	80	applied	\N	\N	\N	\N	105536	105536	273277
12552	13196	81	applied	\N	\N	\N	\N	105537	105537	273278
12552	13197	82	applied	\N	\N	\N	\N	105538	105538	273279
12552	13198	83	applied	\N	\N	\N	\N	105539	105539	273280
12552	13199	84	applied	\N	\N	\N	\N	105540	105540	273281
12552	13201	86	applied	\N	\N	\N	\N	105542	105542	273283
12552	13202	87	applied	\N	\N	\N	\N	105543	105543	273284
12552	13203	88	applied	\N	\N	\N	\N	105544	105544	273285
12552	13204	89	applied	\N	\N	\N	\N	105545	105545	273286
12552	13205	90	applied	\N	\N	\N	\N	105546	105546	273287
12552	13206	91	applied	\N	\N	\N	\N	105547	105547	273288
12552	13207	92	applied	\N	\N	\N	\N	105548	105548	273289
12552	13208	93	applied	\N	\N	\N	\N	105549	105549	273290
12557	13358	0	applied	\N	\N	\N	\N	105598	105598	273339
12557	13359	1	applied	\N	\N	\N	\N	105599	105599	273340
12559	13360	0	applied	\N	\N	\N	\N	105602	105602	273343
12559	13361	1	applied	\N	\N	\N	\N	105603	105603	273344
12559	13362	2	applied	\N	\N	\N	\N	105604	105604	273345
12559	13363	3	applied	\N	\N	\N	\N	105605	105605	273346
12566	13370	0	applied	\N	\N	\N	\N	105628	105628	273369
12566	13371	1	applied	\N	\N	\N	\N	105629	105629	273370
12570	13382	1	applied	\N	\N	\N	\N	105644	105644	273385
12574	13387	0	applied	\N	\N	\N	\N	105651	105651	273392
12574	13388	1	applied	\N	\N	\N	\N	105652	105652	273393
12577	13393	0	applied	\N	\N	\N	\N	105659	105659	273400
12577	13394	1	applied	\N	\N	\N	\N	105660	105660	273401
12577	13395	2	applied	\N	\N	\N	\N	105661	105661	273402
12577	13396	3	applied	\N	\N	\N	\N	105662	105662	273403
12577	13397	4	applied	\N	\N	\N	\N	105663	105663	273404
12577	13398	5	applied	\N	\N	\N	\N	105664	105664	273405
12586	13416	0	applied	\N	\N	\N	\N	105690	105690	273431
12586	13417	1	applied	\N	\N	\N	\N	105691	105691	273432
12586	13418	2	applied	\N	\N	\N	\N	105692	105692	273433
12586	13419	3	applied	\N	\N	\N	\N	105693	105693	273434
12596	13430	0	applied	\N	\N	\N	\N	105730	105730	273471
12596	13431	1	applied	\N	\N	\N	\N	105731	105731	273472
12596	13432	2	applied	\N	\N	\N	\N	105732	105732	273473
12596	13434	4	applied	\N	\N	\N	\N	105734	105734	273475
12596	13435	5	applied	\N	\N	\N	\N	105735	105735	273476
12596	13436	6	applied	\N	\N	\N	\N	105736	105736	273477
12596	13437	7	applied	\N	\N	\N	\N	105737	105737	273478
12601	13446	0	applied	\N	\N	\N	\N	105746	105746	273487
12601	13447	1	applied	\N	\N	\N	\N	105747	105747	273488
12607	13456	0	applied	\N	\N	\N	\N	105766	105766	273507
12607	13457	1	applied	\N	\N	\N	\N	105767	105767	273508
12609	13460	0	applied	\N	\N	\N	\N	105770	105770	273511
12609	13461	1	applied	\N	\N	\N	\N	105771	105771	273512
12611	13462	0	applied	\N	\N	\N	\N	105774	105774	273515
12611	13463	1	applied	\N	\N	\N	\N	105775	105775	273516
12617	13476	0	applied	\N	\N	\N	\N	105798	105798	273539
12617	13477	1	applied	\N	\N	\N	\N	105799	105799	273540
12620	13486	0	applied	\N	\N	\N	\N	105808	105808	273549
12620	13487	1	applied	\N	\N	\N	\N	105809	105809	273550
12523	13314	4	applied	\N	\N	\N	\N	105381	105381	273122
12552	13213	98	applied	\N	\N	\N	\N	105554	105554	273295
12552	13214	99	applied	\N	\N	\N	\N	105555	105555	273296
12552	13215	100	applied	\N	\N	\N	\N	105556	105556	273297
12552	13216	101	applied	\N	\N	\N	\N	105557	105557	273298
12552	13217	102	applied	\N	\N	\N	\N	105558	105558	273299
12552	13218	103	applied	\N	\N	\N	\N	105559	105559	273300
12552	13219	104	applied	\N	\N	\N	\N	105560	105560	273301
12552	13220	105	applied	\N	\N	\N	\N	105561	105561	273302
12552	13221	106	applied	\N	\N	\N	\N	105562	105562	273303
12552	13222	107	applied	\N	\N	\N	\N	105563	105563	273304
12552	13223	108	applied	\N	\N	\N	\N	105564	105564	273305
12552	13224	109	applied	\N	\N	\N	\N	105565	105565	273306
12552	13226	111	applied	\N	\N	\N	\N	105567	105567	273308
12552	13227	112	applied	\N	\N	\N	\N	105568	105568	273309
12552	13228	113	applied	\N	\N	\N	\N	105569	105569	273310
12552	13229	114	applied	\N	\N	\N	\N	105570	105570	273311
12552	13230	115	applied	\N	\N	\N	\N	105571	105571	273312
12552	13231	116	applied	\N	\N	\N	\N	105572	105572	273313
12552	13232	117	applied	\N	\N	\N	\N	105573	105573	273314
12552	13233	118	applied	\N	\N	\N	\N	105574	105574	273315
12552	13235	119	applied	\N	\N	\N	\N	105575	105575	273316
12552	13236	120	applied	\N	\N	\N	\N	105576	105576	273317
12552	13237	121	applied	\N	\N	\N	\N	105577	105577	273318
12552	13238	122	applied	\N	\N	\N	\N	105578	105578	273319
12552	13248	123	applied	\N	\N	\N	\N	105579	105579	273320
12552	13249	124	applied	\N	\N	1000000000	\N	105580	105580	273321
12554	13350	0	applied	\N	\N	\N	\N	105588	105588	273329
12554	13351	1	applied	\N	\N	\N	\N	105589	105589	273330
12555	13352	0	applied	\N	\N	\N	\N	105590	105590	273331
12555	13353	1	applied	\N	\N	\N	\N	105591	105591	273332
12555	13354	2	applied	\N	\N	\N	\N	105592	105592	273333
12555	13355	3	applied	\N	\N	\N	\N	105593	105593	273334
12555	13356	4	applied	\N	\N	\N	\N	105594	105594	273335
12555	13357	5	applied	\N	\N	\N	\N	105595	105595	273336
12558	13358	0	applied	\N	\N	\N	\N	105600	105600	273341
12558	13359	1	applied	\N	\N	\N	\N	105601	105601	273342
12560	13360	0	applied	\N	\N	\N	\N	105606	105606	273347
12560	13361	1	applied	\N	\N	\N	\N	105607	105607	273348
12560	13362	2	applied	\N	\N	\N	\N	105608	105608	273349
12560	13363	3	applied	\N	\N	\N	\N	105609	105609	273350
12562	13364	0	applied	\N	\N	\N	\N	105614	105614	273355
12562	13365	1	applied	\N	\N	\N	\N	105615	105615	273356
12564	13366	0	applied	\N	\N	\N	\N	105624	105624	273365
12564	13367	1	applied	\N	\N	\N	\N	105625	105625	273366
12567	13370	0	applied	\N	\N	\N	\N	105630	105630	273371
12567	13371	1	applied	\N	\N	\N	\N	105631	105631	273372
12571	13382	1	applied	\N	\N	\N	\N	105646	105646	273387
12572	13383	0	applied	\N	\N	\N	\N	105647	105647	273388
12572	13384	1	applied	\N	\N	\N	\N	105648	105648	273389
12581	13405	0	applied	\N	\N	\N	\N	105677	105677	273418
12583	13405	0	applied	\N	\N	\N	\N	105679	105679	273420
12585	13415	7	applied	\N	\N	\N	\N	105689	105689	273430
12587	13416	0	applied	\N	\N	\N	\N	105694	105694	273435
12587	13417	1	applied	\N	\N	\N	\N	105695	105695	273436
12587	13418	2	applied	\N	\N	\N	\N	105696	105696	273437
12587	13419	3	applied	\N	\N	\N	\N	105697	105697	273438
12588	13406	0	applied	\N	\N	\N	\N	105698	105698	273439
12588	13408	1	applied	\N	\N	\N	\N	105699	105699	273440
12588	13409	2	applied	\N	\N	\N	\N	105700	105700	273441
12588	13410	3	applied	\N	\N	\N	\N	105701	105701	273442
12588	13411	4	applied	\N	\N	\N	\N	105702	105702	273443
12588	13416	5	applied	\N	\N	\N	\N	105703	105703	273444
12588	13420	7	applied	\N	\N	\N	\N	105705	105705	273446
12588	13407	8	applied	\N	\N	\N	\N	105706	105706	273447
12588	13412	9	applied	\N	\N	\N	\N	105707	105707	273448
12588	13413	10	applied	\N	\N	\N	\N	105708	105708	273449
12588	13414	11	applied	\N	\N	\N	\N	105709	105709	273450
12588	13415	12	applied	\N	\N	\N	\N	105710	105710	273451
12588	13418	13	applied	\N	\N	\N	\N	105711	105711	273452
12588	13419	14	applied	\N	\N	\N	\N	105712	105712	273453
12588	13421	15	applied	\N	\N	\N	\N	105713	105713	273454
12592	13424	0	applied	\N	\N	\N	\N	105718	105718	273459
12592	13425	1	applied	\N	\N	\N	\N	105719	105719	273460
12592	13426	2	applied	\N	\N	\N	\N	105720	105720	273461
12592	13427	3	applied	\N	\N	\N	\N	105721	105721	273462
12593	13424	0	applied	\N	\N	\N	\N	105722	105722	273463
12593	13425	1	applied	\N	\N	\N	\N	105723	105723	273464
12593	13426	2	applied	\N	\N	\N	\N	105724	105724	273465
12595	13428	0	applied	\N	\N	\N	\N	105728	105728	273469
12595	13429	1	applied	\N	\N	\N	\N	105729	105729	273470
12598	13440	0	applied	\N	\N	\N	\N	105740	105740	273481
12598	13441	1	applied	\N	\N	\N	\N	105741	105741	273482
12599	13442	0	applied	\N	\N	\N	\N	105742	105742	273483
12599	13443	1	applied	\N	\N	\N	\N	105743	105743	273484
12602	13446	0	applied	\N	\N	\N	\N	105748	105748	273489
12602	13447	1	applied	\N	\N	\N	\N	105749	105749	273490
12604	13448	0	applied	\N	\N	\N	\N	105756	105756	273497
12604	13449	1	applied	\N	\N	\N	\N	105757	105757	273498
12604	13450	2	applied	\N	\N	\N	\N	105758	105758	273499
12604	13451	3	applied	\N	\N	\N	\N	105759	105759	273500
12604	13452	4	applied	\N	\N	\N	\N	105760	105760	273501
12604	13453	5	applied	\N	\N	\N	\N	105761	105761	273502
12606	13456	0	applied	\N	\N	\N	\N	105764	105764	273505
12606	13457	1	applied	\N	\N	\N	\N	105765	105765	273506
12608	13459	1	applied	\N	\N	\N	\N	105769	105769	273510
12614	13466	0	applied	\N	\N	\N	\N	105786	105786	273527
12614	13467	1	applied	\N	\N	\N	\N	105787	105787	273528
12614	13468	2	applied	\N	\N	\N	\N	105788	105788	273529
12614	13469	3	applied	\N	\N	\N	\N	105789	105789	273530
12614	13470	4	applied	\N	\N	\N	\N	105790	105790	273531
12614	13471	5	applied	\N	\N	\N	\N	105791	105791	273532
12614	13472	6	applied	\N	\N	\N	\N	105792	105792	273533
12614	13473	7	applied	\N	\N	\N	\N	105793	105793	273534
12616	13476	0	applied	\N	\N	\N	\N	105796	105796	273537
12616	13477	1	applied	\N	\N	\N	\N	105797	105797	273538
12619	13482	0	applied	\N	\N	\N	\N	105804	105804	273545
12619	13483	1	applied	\N	\N	\N	\N	105805	105805	273546
12619	13484	2	applied	\N	\N	\N	\N	105806	105806	273547
12619	13485	3	applied	\N	\N	\N	\N	105807	105807	273548
12552	13210	95	applied	\N	\N	\N	\N	105551	105551	273292
12552	13212	97	applied	\N	\N	\N	\N	105553	105553	273294
12612	13464	0	applied	\N	\N	\N	\N	105776	105776	273517
12612	13465	1	applied	\N	\N	\N	\N	105777	105777	273518
12613	13466	0	applied	\N	\N	\N	\N	105778	105778	273519
12613	13467	1	applied	\N	\N	\N	\N	105779	105779	273520
12613	13468	2	applied	\N	\N	\N	\N	105780	105780	273521
12613	13469	3	applied	\N	\N	\N	\N	105781	105781	273522
12613	13470	4	applied	\N	\N	\N	\N	105782	105782	273523
12613	13471	5	applied	\N	\N	\N	\N	105783	105783	273524
12613	13472	6	applied	\N	\N	\N	\N	105784	105784	273525
12613	13473	7	applied	\N	\N	\N	\N	105785	105785	273526
12615	13474	0	applied	\N	\N	\N	\N	105794	105794	273535
12615	13475	1	applied	\N	\N	\N	\N	105795	105795	273536
12618	13478	0	applied	\N	\N	\N	\N	105800	105800	273541
12618	13479	1	applied	\N	\N	\N	\N	105801	105801	273542
12618	13480	2	applied	\N	\N	\N	\N	105802	105802	273543
12618	13481	3	applied	\N	\N	\N	\N	105803	105803	273544
12621	13489	1	applied	\N	\N	\N	\N	105811	105811	273552
12621	13490	2	applied	\N	\N	\N	\N	105812	105812	273553
12621	13491	3	applied	\N	\N	\N	\N	105813	105813	273554
12621	13492	4	applied	\N	\N	\N	\N	105814	105814	273555
12621	13493	5	applied	\N	\N	\N	\N	105815	105815	273556
12622	13494	0	applied	\N	\N	\N	\N	105816	105816	273557
12622	13495	1	applied	\N	\N	\N	\N	105817	105817	273558
12622	13496	2	applied	\N	\N	\N	\N	105818	105818	273559
12622	13497	3	applied	\N	\N	\N	\N	105819	105819	273560
12623	13498	0	applied	\N	\N	\N	\N	105820	105820	273561
12623	13499	1	applied	\N	\N	\N	\N	105821	105821	273562
12625	13500	0	applied	\N	\N	\N	\N	105822	105822	273563
12625	13501	1	applied	\N	\N	\N	\N	105823	105823	273564
12626	13500	0	applied	\N	\N	\N	\N	105824	105824	273565
12626	13501	1	applied	\N	\N	\N	\N	105825	105825	273566
12631	13502	0	applied	\N	\N	\N	\N	105826	105826	273567
12632	13502	0	applied	\N	\N	\N	\N	105828	105828	273569
12632	13503	1	applied	\N	\N	\N	\N	105829	105829	273570
12633	13502	0	applied	\N	\N	\N	\N	105830	105830	273571
12633	13503	1	applied	\N	\N	\N	\N	105831	105831	273572
12634	13504	0	applied	\N	\N	\N	\N	105832	105832	273573
12634	13505	1	applied	\N	\N	\N	\N	105833	105833	273574
12635	13504	0	applied	\N	\N	\N	\N	105834	105834	273575
12635	13505	1	applied	\N	\N	\N	\N	105835	105835	273576
12636	13504	0	applied	\N	\N	\N	\N	105836	105836	273577
12636	13505	1	applied	\N	\N	\N	\N	105837	105837	273578
12637	13506	0	applied	\N	\N	\N	\N	105838	105838	273579
12637	13507	1	applied	\N	\N	\N	\N	105839	105839	273580
12637	13508	2	applied	\N	\N	\N	\N	105840	105840	273581
12637	13509	3	applied	\N	\N	\N	\N	105841	105841	273582
12637	13510	4	applied	\N	\N	\N	\N	105842	105842	273583
12637	13511	5	applied	\N	\N	\N	\N	105843	105843	273584
12638	13513	1	applied	\N	\N	\N	\N	105845	105845	273586
12638	13514	2	applied	\N	\N	\N	\N	105846	105846	273587
12638	13515	3	applied	\N	\N	\N	\N	105847	105847	273588
12638	13516	4	applied	\N	\N	\N	\N	105848	105848	273589
12638	13517	5	applied	\N	\N	\N	\N	105849	105849	273590
12639	13512	0	applied	\N	\N	\N	\N	105850	105850	273591
12639	13513	1	applied	\N	\N	\N	\N	105851	105851	273592
12639	13514	2	applied	\N	\N	\N	\N	105852	105852	273593
12639	13515	3	applied	\N	\N	\N	\N	105853	105853	273594
12639	13516	4	applied	\N	\N	\N	\N	105854	105854	273595
12639	13517	5	applied	\N	\N	\N	\N	105855	105855	273596
12640	13174	0	applied	\N	\N	\N	\N	105856	105856	273597
12640	13180	1	applied	\N	\N	\N	\N	105857	105857	273598
12640	13181	2	applied	\N	\N	\N	\N	105858	105858	273599
12640	13182	3	applied	\N	\N	\N	\N	105859	105859	273600
12640	13115	4	applied	\N	\N	\N	\N	105860	105860	273601
12640	13118	6	applied	\N	\N	\N	\N	105862	105862	273603
12640	13131	7	applied	\N	\N	\N	\N	105863	105863	273604
12640	13134	8	applied	\N	\N	\N	\N	105864	105864	273605
12640	13136	9	applied	\N	\N	\N	\N	105865	105865	273606
12640	13138	10	applied	\N	\N	\N	\N	105866	105866	273607
12640	13143	11	applied	\N	\N	\N	\N	105867	105867	273608
12640	13146	12	applied	\N	\N	\N	\N	105868	105868	273609
12640	13148	13	applied	\N	\N	\N	\N	105869	105869	273610
12640	13393	14	applied	\N	\N	\N	\N	105870	105870	273611
12640	13264	15	applied	\N	\N	\N	\N	105871	105871	273612
12640	13107	16	applied	\N	\N	\N	\N	105872	105872	273613
12640	13108	17	applied	\N	\N	\N	\N	105873	105873	273614
12640	13394	18	applied	\N	\N	\N	\N	105874	105874	273615
12640	13109	19	applied	\N	\N	\N	\N	105875	105875	273616
12640	13110	20	applied	\N	\N	\N	\N	105876	105876	273617
12640	13266	21	applied	\N	\N	\N	\N	105877	105877	273618
12640	13139	23	applied	\N	\N	\N	\N	105879	105879	273620
12640	13396	24	applied	\N	\N	\N	\N	105880	105880	273621
12640	13397	25	applied	\N	\N	\N	\N	105881	105881	273622
12640	13093	26	applied	\N	\N	\N	\N	105882	105882	273623
12640	13094	27	applied	\N	\N	\N	\N	105883	105883	273624
12640	13095	28	applied	\N	\N	\N	\N	105884	105884	273625
12640	13096	29	applied	\N	\N	\N	\N	105885	105885	273626
12640	13270	30	applied	\N	\N	\N	\N	105886	105886	273627
12640	13273	31	applied	\N	\N	\N	\N	105887	105887	273628
12640	13275	32	applied	\N	\N	\N	\N	105888	105888	273629
12640	13276	33	applied	\N	\N	\N	\N	105889	105889	273630
12640	13277	34	applied	\N	\N	\N	\N	105890	105890	273631
12640	13278	35	applied	\N	\N	\N	\N	105891	105891	273632
12640	13279	36	applied	\N	\N	\N	\N	105892	105892	273633
12640	13285	37	applied	\N	\N	\N	\N	105893	105893	273634
12640	13286	39	applied	\N	\N	\N	\N	105894	105894	273635
12640	13291	41	applied	\N	\N	\N	\N	105896	105896	273637
12640	13294	42	applied	\N	\N	\N	\N	105897	105897	273638
12640	13295	43	applied	\N	\N	\N	\N	105898	105898	273639
12640	13298	44	applied	\N	\N	\N	\N	105899	105899	273640
12640	13300	45	applied	\N	\N	\N	\N	105900	105900	273641
12640	13302	46	applied	\N	\N	\N	\N	105901	105901	273642
12640	13304	47	applied	\N	\N	\N	\N	105902	105902	273643
12640	13306	48	applied	\N	\N	\N	\N	105903	105903	273644
12640	13307	49	applied	\N	\N	\N	\N	105904	105904	273645
12640	13310	50	applied	\N	\N	\N	\N	105905	105905	273646
12640	13311	51	applied	\N	\N	\N	\N	105906	105906	273647
12640	13312	52	applied	\N	\N	\N	\N	105907	105907	273648
12640	13316	53	applied	\N	\N	\N	\N	105908	105908	273649
12640	13318	54	applied	\N	\N	\N	\N	105909	105909	273650
12605	13455	1	applied	\N	\N	\N	\N	105763	105763	273504
12610	13460	0	applied	\N	\N	\N	\N	105772	105772	273513
12640	13327	58	applied	\N	\N	\N	\N	105913	105913	273654
12640	13328	59	applied	\N	\N	\N	\N	105914	105914	273655
12640	13331	60	applied	\N	\N	\N	\N	105915	105915	273656
12640	13333	61	applied	\N	\N	\N	\N	105916	105916	273657
12640	13334	62	applied	\N	\N	\N	\N	105917	105917	273658
12640	13337	63	applied	\N	\N	\N	\N	105918	105918	273659
12640	13338	64	applied	\N	\N	\N	\N	105919	105919	273660
12640	13342	65	applied	\N	\N	\N	\N	105920	105920	273661
12640	13344	66	applied	\N	\N	\N	\N	105921	105921	273662
12640	13345	67	applied	\N	\N	\N	\N	105922	105922	273663
12640	13348	68	applied	\N	\N	\N	\N	105923	105923	273664
12640	13352	70	applied	\N	\N	\N	\N	105925	105925	273666
12640	13353	71	applied	\N	\N	\N	\N	105926	105926	273667
12640	13354	72	applied	\N	\N	\N	\N	105927	105927	273668
12640	13358	73	applied	\N	\N	\N	\N	105928	105928	273669
12640	13360	74	applied	\N	\N	\N	\N	105929	105929	273670
12640	13361	75	applied	\N	\N	\N	\N	105930	105930	273671
12640	13364	76	applied	\N	\N	\N	\N	105931	105931	273672
12640	13366	77	applied	\N	\N	\N	\N	105932	105932	273673
12640	13368	78	applied	\N	\N	\N	\N	105933	105933	273674
12640	13370	79	applied	\N	\N	\N	\N	105934	105934	273675
12640	13372	80	applied	\N	\N	\N	\N	105935	105935	273676
12640	13373	81	applied	\N	\N	\N	\N	105936	105936	273677
12640	13374	82	applied	\N	\N	\N	\N	105937	105937	273678
12640	13375	83	applied	\N	\N	\N	\N	105938	105938	273679
12640	13381	84	applied	\N	\N	\N	\N	105939	105939	273680
12640	13383	85	applied	\N	\N	\N	\N	105940	105940	273681
12640	13387	87	applied	\N	\N	\N	\N	105942	105942	273683
12640	13389	88	applied	\N	\N	\N	\N	105943	105943	273684
12640	13390	89	applied	\N	\N	\N	\N	105944	105944	273685
12640	13395	90	applied	\N	\N	\N	\N	105945	105945	273686
12640	13399	91	applied	\N	\N	\N	\N	105946	105946	273687
12640	13405	92	applied	\N	\N	\N	\N	105947	105947	273688
12640	13406	93	applied	\N	\N	\N	\N	105948	105948	273689
12640	13408	94	applied	\N	\N	\N	\N	105949	105949	273690
12640	13409	95	applied	\N	\N	\N	\N	105950	105950	273691
12640	13410	96	applied	\N	\N	\N	\N	105951	105951	273692
12640	13411	97	applied	\N	\N	\N	\N	105952	105952	273693
12640	13416	98	applied	\N	\N	\N	\N	105953	105953	273694
12640	13417	99	applied	\N	\N	\N	\N	105954	105954	273695
12640	13420	100	applied	\N	\N	\N	\N	105955	105955	273696
12640	13422	101	applied	\N	\N	\N	\N	105956	105956	273697
12640	13424	102	applied	\N	\N	\N	\N	105957	105957	273698
12640	13428	104	applied	\N	\N	\N	\N	105959	105959	273700
12640	13430	105	applied	\N	\N	\N	\N	105960	105960	273701
12640	13431	106	applied	\N	\N	\N	\N	105961	105961	273702
12640	13432	107	applied	\N	\N	\N	\N	105962	105962	273703
12640	13433	108	applied	\N	\N	\N	\N	105963	105963	273704
12640	13438	109	applied	\N	\N	\N	\N	105964	105964	273705
12640	13440	110	applied	\N	\N	\N	\N	105965	105965	273706
12640	13442	111	applied	\N	\N	\N	\N	105966	105966	273707
12640	13444	112	applied	\N	\N	\N	\N	105967	105967	273708
12640	13446	113	applied	\N	\N	\N	\N	105968	105968	273709
12640	13448	114	applied	\N	\N	\N	\N	105969	105969	273710
12640	13449	115	applied	\N	\N	\N	\N	105970	105970	273711
12640	13450	116	applied	\N	\N	\N	\N	105971	105971	273712
12640	13454	117	applied	\N	\N	\N	\N	105972	105972	273713
12640	13456	118	applied	\N	\N	\N	\N	105973	105973	273714
12640	13458	119	applied	\N	\N	\N	\N	105974	105974	273715
12640	13462	121	applied	\N	\N	\N	\N	105976	105976	273717
12640	13464	122	applied	\N	\N	\N	\N	105977	105977	273718
12640	13466	123	applied	\N	\N	\N	\N	105978	105978	273719
12640	13467	124	applied	\N	\N	\N	\N	105979	105979	273720
12640	13468	125	applied	\N	\N	\N	\N	105980	105980	273721
12642	13518	0	applied	\N	\N	\N	\N	105983	105983	273724
12642	13519	1	applied	\N	\N	\N	\N	105984	105984	273725
12646	13522	0	applied	\N	\N	\N	\N	105992	105992	273733
12646	13523	1	applied	\N	\N	\N	\N	105993	105993	273734
12648	13522	0	applied	\N	\N	\N	\N	105996	105996	273737
12648	13523	1	applied	\N	\N	\N	\N	105997	105997	273738
12651	13526	0	applied	\N	\N	\N	\N	106007	106007	273748
12651	13527	1	applied	\N	\N	\N	\N	106008	106008	273749
12651	13528	2	applied	\N	\N	\N	\N	106009	106009	273750
12651	13529	3	applied	\N	\N	\N	\N	106010	106010	273751
12651	13530	4	applied	\N	\N	\N	\N	106011	106011	273752
12651	13532	6	applied	\N	\N	\N	\N	106013	106013	273754
12654	13537	0	applied	\N	\N	\N	\N	106018	106018	273759
12654	13538	1	applied	\N	\N	\N	\N	106019	106019	273760
12654	13539	2	applied	\N	\N	\N	\N	106020	106020	273761
12654	13540	3	applied	\N	\N	\N	\N	106021	106021	273762
12654	13541	4	applied	\N	\N	\N	\N	106022	106022	273763
12654	13542	5	applied	\N	\N	\N	\N	106023	106023	273764
12654	13543	6	applied	\N	\N	\N	\N	106024	106024	273765
12661	13550	0	applied	\N	\N	\N	\N	106051	106051	273792
12661	13551	1	applied	\N	\N	\N	\N	106052	106052	273793
12661	13552	2	applied	\N	\N	\N	\N	106053	106053	273794
12661	13553	3	applied	\N	\N	1000000000	\N	106054	106054	273795
12661	13554	4	applied	\N	\N	1000000000	\N	106055	106055	273796
12661	13555	5	applied	\N	\N	1000000000	\N	106056	106056	273797
12664	13556	0	applied	\N	\N	\N	\N	106060	106060	273801
12664	13557	1	applied	\N	\N	\N	\N	106061	106061	273802
12666	13564	1	applied	\N	\N	\N	\N	106068	106068	273809
12666	13565	2	applied	\N	\N	\N	\N	106069	106069	273810
12675	13573	0	applied	\N	\N	\N	\N	106095	106095	273836
12675	13574	1	applied	\N	\N	\N	\N	106096	106096	273837
12677	13575	0	applied	\N	\N	\N	\N	106101	106101	273842
12677	13576	1	applied	\N	\N	\N	\N	106102	106102	273843
12677	13577	2	applied	\N	\N	\N	\N	106103	106103	273844
12677	13578	3	applied	\N	\N	\N	\N	106104	106104	273845
12680	13579	0	applied	\N	\N	\N	\N	106109	106109	273850
12680	13580	1	applied	\N	\N	\N	\N	106110	106110	273851
12682	13585	0	applied	\N	\N	\N	\N	106115	106115	273856
12682	13586	1	applied	\N	\N	\N	\N	106116	106116	273857
12684	13587	0	applied	\N	\N	\N	\N	106119	106119	273860
12684	13588	1	applied	\N	\N	\N	\N	106120	106120	273861
12691	13593	0	applied	\N	\N	\N	\N	106132	106132	273873
12691	13594	1	applied	\N	\N	\N	\N	106133	106133	273874
12701	13607	1	applied	\N	\N	\N	\N	106154	106154	273895
12701	13608	2	applied	\N	\N	\N	\N	106155	106155	273896
12640	13322	56	applied	\N	\N	\N	\N	105911	105911	273652
12640	13325	57	applied	\N	\N	\N	\N	105912	105912	273653
12644	13520	1	applied	\N	\N	\N	\N	105988	105988	273729
12644	13519	2	applied	\N	\N	\N	\N	105989	105989	273730
12645	13520	0	applied	\N	\N	\N	\N	105990	105990	273731
12645	13521	1	applied	\N	\N	\N	\N	105991	105991	273732
12653	13535	0	applied	\N	\N	\N	\N	106016	106016	273757
12653	13536	1	applied	\N	\N	\N	\N	106017	106017	273758
12663	13557	0	applied	\N	\N	\N	\N	106059	106059	273800
12665	13558	0	applied	\N	\N	\N	\N	106062	106062	273803
12665	13559	1	applied	\N	\N	\N	\N	106063	106063	273804
12665	13560	2	applied	\N	\N	\N	\N	106064	106064	273805
12665	13561	3	applied	\N	\N	\N	\N	106065	106065	273806
12672	13568	0	applied	\N	\N	\N	\N	106083	106083	273824
12672	13569	1	applied	\N	\N	\N	\N	106084	106084	273825
12672	13570	2	applied	\N	\N	\N	\N	106085	106085	273826
12672	13571	3	applied	\N	\N	\N	\N	106086	106086	273827
12672	13572	4	applied	\N	\N	\N	\N	106087	106087	273828
12674	13573	0	applied	\N	\N	\N	\N	106093	106093	273834
12674	13574	1	applied	\N	\N	\N	\N	106094	106094	273835
12679	13579	0	applied	\N	\N	\N	\N	106107	106107	273848
12679	13580	1	applied	\N	\N	\N	\N	106108	106108	273849
12681	13581	0	applied	\N	\N	\N	\N	106111	106111	273852
12681	13582	1	applied	\N	\N	\N	\N	106112	106112	273853
12681	13583	3	applied	\N	\N	\N	\N	106113	106113	273854
12681	13584	4	applied	\N	\N	\N	\N	106114	106114	273855
12693	13593	0	applied	\N	\N	\N	\N	106136	106136	273877
12695	13595	0	applied	\N	\N	\N	\N	106139	106139	273880
12695	13594	1	applied	\N	\N	\N	\N	106140	106140	273881
12698	13601	1	applied	\N	\N	\N	\N	106148	106148	273889
12700	13604	0	applied	\N	\N	\N	\N	106151	106151	273892
12700	13605	1	applied	\N	\N	\N	\N	106152	106152	273893
12701	13609	3	applied	\N	\N	\N	\N	106156	106156	273897
12703	13610	0	applied	\N	\N	\N	\N	106161	106161	273902
12703	13611	1	applied	\N	\N	\N	\N	106162	106162	273903
12705	13612	0	applied	\N	\N	\N	\N	106165	106165	273906
12705	13613	1	applied	\N	\N	\N	\N	106166	106166	273907
12706	13612	0	applied	\N	\N	\N	\N	106167	106167	273908
12706	13613	1	applied	\N	\N	\N	\N	106168	106168	273909
12708	13612	0	applied	\N	\N	\N	\N	106171	106171	273912
12708	13613	1	applied	\N	\N	\N	\N	106172	106172	273913
12710	13614	0	applied	\N	\N	\N	\N	106177	106177	273918
12710	13615	1	applied	\N	\N	\N	\N	106178	106178	273919
12710	13616	2	applied	\N	\N	\N	\N	106179	106179	273920
12710	13617	3	applied	\N	\N	\N	\N	106180	106180	273921
12711	13615	1	applied	\N	\N	\N	\N	106182	106182	273923
12711	13616	2	applied	\N	\N	\N	\N	106183	106183	273924
12711	13617	3	applied	\N	\N	\N	\N	106184	106184	273925
12712	13618	0	applied	\N	\N	\N	\N	106185	106185	273926
12715	13620	0	applied	\N	\N	\N	\N	106195	106195	273936
12715	13621	1	applied	\N	\N	\N	\N	106196	106196	273937
12715	13622	2	applied	\N	\N	\N	\N	106197	106197	273938
12715	13623	3	applied	\N	\N	\N	\N	106198	106198	273939
12715	13624	4	applied	\N	\N	\N	\N	106199	106199	273940
12715	13625	5	applied	\N	\N	\N	\N	106200	106200	273941
12717	13620	0	applied	\N	\N	\N	\N	106326	106326	274067
12717	13621	1	applied	\N	\N	\N	\N	106327	106327	274068
12717	13622	2	applied	\N	\N	\N	\N	106328	106328	274069
12717	13623	3	applied	\N	\N	\N	\N	106329	106329	274070
12717	13624	4	applied	\N	\N	\N	\N	106330	106330	274071
12717	13625	5	applied	\N	\N	\N	\N	106331	106331	274072
12721	13642	1	applied	\N	\N	\N	\N	106348	106348	274089
12724	13643	0	applied	\N	\N	\N	\N	106357	106357	274098
12724	13644	1	applied	\N	\N	\N	\N	106358	106358	274099
12724	13645	2	applied	\N	\N	\N	\N	106359	106359	274100
12724	13646	3	applied	\N	\N	\N	\N	106360	106360	274101
12729	13628	0	applied	\N	\N	\N	\N	106406	106406	274147
12729	13536	1	applied	\N	\N	\N	\N	106407	106407	274148
12729	13540	2	applied	\N	\N	\N	\N	106408	106408	274149
12729	13541	3	applied	\N	\N	\N	\N	106409	106409	274150
12729	13542	4	applied	\N	\N	\N	\N	106410	106410	274151
12729	13545	5	applied	\N	\N	\N	\N	106411	106411	274152
12729	13548	6	applied	\N	\N	\N	\N	106412	106412	274153
12729	13552	7	applied	\N	\N	\N	\N	106413	106413	274154
12729	13553	8	applied	\N	\N	1000000000	\N	106414	106414	274155
12729	13555	10	applied	\N	\N	1000000000	\N	106416	106416	274157
12729	13557	11	applied	\N	\N	\N	\N	106417	106417	274158
12729	13561	12	applied	\N	\N	\N	\N	106418	106418	274159
12729	13562	13	applied	\N	\N	\N	\N	106419	106419	274160
12729	13564	14	applied	\N	\N	\N	\N	106420	106420	274161
12729	13567	15	applied	\N	\N	\N	\N	106421	106421	274162
12729	13570	16	applied	\N	\N	\N	\N	106422	106422	274163
12729	13571	17	applied	\N	\N	\N	\N	106423	106423	274164
12729	13574	18	applied	\N	\N	\N	\N	106424	106424	274165
12729	13577	19	applied	\N	\N	\N	\N	106425	106425	274166
12729	13578	20	applied	\N	\N	\N	\N	106426	106426	274167
12729	13580	21	applied	\N	\N	\N	\N	106427	106427	274168
12729	13583	22	applied	\N	\N	\N	\N	106428	106428	274169
12729	13584	23	applied	\N	\N	\N	\N	106429	106429	274170
12729	13586	24	applied	\N	\N	\N	\N	106430	106430	274171
12729	13588	25	applied	\N	\N	\N	\N	106431	106431	274172
12729	13590	26	applied	\N	\N	\N	\N	106432	106432	274173
12729	13592	27	applied	\N	\N	\N	\N	106433	106433	274174
12729	13594	28	applied	\N	\N	\N	\N	106434	106434	274175
12729	13598	29	applied	\N	\N	\N	\N	106435	106435	274176
12729	13601	31	applied	\N	\N	\N	\N	106437	106437	274178
12729	13603	32	applied	\N	\N	\N	\N	106438	106438	274179
12729	13605	33	applied	\N	\N	\N	\N	106439	106439	274180
12729	13608	34	applied	\N	\N	\N	\N	106440	106440	274181
12729	13609	35	applied	\N	\N	\N	\N	106441	106441	274182
12729	13611	36	applied	\N	\N	\N	\N	106442	106442	274183
12729	13613	37	applied	\N	\N	\N	\N	106443	106443	274184
12729	13616	38	applied	\N	\N	\N	\N	106444	106444	274185
12729	13617	39	applied	\N	\N	\N	\N	106445	106445	274186
12729	13619	40	applied	\N	\N	\N	\N	106446	106446	274187
12729	13623	41	applied	\N	\N	\N	\N	106447	106447	274188
12729	13624	42	applied	\N	\N	\N	\N	106448	106448	274189
12729	13625	43	applied	\N	\N	\N	\N	106449	106449	274190
12729	13629	44	applied	\N	\N	\N	\N	106450	106450	274191
12729	13630	45	applied	\N	\N	\N	\N	106451	106451	274192
12729	13633	46	applied	\N	\N	\N	\N	106452	106452	274193
12641	13519	1	applied	\N	\N	\N	\N	105982	105982	273723
12644	13518	0	applied	\N	\N	\N	\N	105987	105987	273728
12655	13537	0	applied	\N	\N	\N	\N	106025	106025	273766
12655	13538	1	applied	\N	\N	\N	\N	106026	106026	273767
12655	13539	2	applied	\N	\N	\N	\N	106027	106027	273768
12655	13540	3	applied	\N	\N	\N	\N	106028	106028	273769
12655	13541	4	applied	\N	\N	\N	\N	106029	106029	273770
12655	13542	5	applied	\N	\N	\N	\N	106030	106030	273771
12655	13543	6	applied	\N	\N	\N	\N	106031	106031	273772
12657	13544	0	applied	\N	\N	\N	\N	106039	106039	273780
12657	13545	1	applied	\N	\N	\N	\N	106040	106040	273781
12657	13546	2	applied	\N	\N	\N	\N	106041	106041	273782
12659	13547	0	applied	\N	\N	\N	\N	106045	106045	273786
12659	13548	1	applied	\N	\N	\N	\N	106046	106046	273787
12659	13549	2	applied	\N	\N	\N	\N	106047	106047	273788
12667	13563	0	applied	\N	\N	\N	\N	106070	106070	273811
12667	13565	2	applied	\N	\N	\N	\N	106072	106072	273813
12670	13566	0	applied	\N	\N	\N	\N	106076	106076	273817
12670	13567	1	applied	\N	\N	\N	\N	106077	106077	273818
12683	13585	0	applied	\N	\N	\N	\N	106117	106117	273858
12683	13586	1	applied	\N	\N	\N	\N	106118	106118	273859
12685	13587	0	applied	\N	\N	\N	\N	106121	106121	273862
12685	13588	1	applied	\N	\N	\N	\N	106122	106122	273863
12687	13589	0	applied	\N	\N	\N	\N	106124	106124	273865
12687	13590	1	applied	\N	\N	\N	\N	106125	106125	273866
12689	13591	0	applied	\N	\N	\N	\N	106128	106128	273869
12689	13592	1	applied	\N	\N	\N	\N	106129	106129	273870
12692	13593	0	applied	\N	\N	\N	\N	106134	106134	273875
12692	13594	1	applied	\N	\N	\N	\N	106135	106135	273876
12696	13596	0	applied	\N	\N	\N	\N	106141	106141	273882
12696	13597	1	applied	\N	\N	\N	\N	106142	106142	273883
12696	13598	2	applied	\N	\N	\N	\N	106143	106143	273884
12702	13606	0	applied	\N	\N	\N	\N	106157	106157	273898
12702	13607	1	applied	\N	\N	\N	\N	106158	106158	273899
12702	13608	2	applied	\N	\N	\N	\N	106159	106159	273900
12702	13609	3	applied	\N	\N	\N	\N	106160	106160	273901
12704	13610	0	applied	\N	\N	\N	\N	106163	106163	273904
12704	13611	1	applied	\N	\N	\N	\N	106164	106164	273905
12707	13612	0	applied	\N	\N	\N	\N	106169	106169	273910
12707	13613	1	applied	\N	\N	\N	\N	106170	106170	273911
12713	13618	0	applied	\N	\N	\N	\N	106187	106187	273928
12713	13619	1	applied	\N	\N	\N	\N	106188	106188	273929
12719	13631	0	applied	\N	\N	\N	\N	106337	106337	274078
12719	13632	1	applied	\N	\N	\N	\N	106338	106338	274079
12719	13633	2	applied	\N	\N	\N	\N	106339	106339	274080
12719	13634	3	applied	\N	\N	\N	\N	106340	106340	274081
12720	13635	0	applied	\N	\N	\N	\N	106341	106341	274082
12720	13636	1	applied	\N	\N	\N	\N	106342	106342	274083
12720	13638	3	applied	\N	\N	\N	\N	106344	106344	274085
12720	13639	4	applied	\N	\N	\N	\N	106345	106345	274086
12720	13640	5	applied	\N	\N	\N	\N	106346	106346	274087
12723	13643	0	applied	\N	\N	\N	\N	106353	106353	274094
12723	13644	1	applied	\N	\N	\N	\N	106354	106354	274095
12723	13645	2	applied	\N	\N	\N	\N	106355	106355	274096
12723	13646	3	applied	\N	\N	\N	\N	106356	106356	274097
12729	13638	48	applied	\N	\N	\N	\N	106454	106454	274195
12729	13639	49	applied	\N	\N	\N	\N	106455	106455	274196
12729	13640	50	applied	\N	\N	\N	\N	106456	106456	274197
12729	13642	51	applied	\N	\N	\N	\N	106457	106457	274198
12729	13645	52	applied	\N	\N	\N	\N	106458	106458	274199
12729	13646	53	applied	\N	\N	\N	\N	106459	106459	274200
12729	13648	54	applied	\N	\N	\N	\N	106460	106460	274201
12729	13652	55	applied	\N	\N	\N	\N	106461	106461	274202
12729	13653	56	applied	\N	\N	\N	\N	106462	106462	274203
12729	13656	58	applied	\N	\N	\N	\N	106464	106464	274205
12730	13655	0	applied	\N	\N	\N	\N	106465	106465	274206
12730	13656	1	applied	\N	\N	\N	\N	106466	106466	274207
12731	13657	0	applied	\N	\N	\N	\N	106467	106467	274208
12740	13664	0	applied	\N	\N	\N	\N	106485	106485	274226
12740	13665	1	applied	\N	\N	\N	\N	106486	106486	274227
12741	13666	0	applied	\N	\N	\N	\N	106487	106487	274228
12741	13667	1	applied	\N	\N	\N	\N	106488	106488	274229
12752	13680	0	applied	\N	\N	\N	\N	106521	106521	274259
12752	13681	1	applied	\N	\N	\N	\N	106522	106522	274260
12752	13682	2	applied	\N	\N	\N	\N	106523	106523	274261
12752	13684	3	applied	\N	\N	\N	\N	106524	106524	274262
12752	13685	4	applied	\N	\N	\N	\N	106525	106525	274263
12752	13686	5	applied	\N	\N	\N	\N	106526	106526	274264
12752	13687	6	applied	\N	\N	\N	\N	106527	106527	274265
12752	13688	7	applied	\N	\N	\N	\N	106528	106528	274266
12752	13683	9	applied	\N	\N	\N	\N	106530	106530	274268
12754	13690	0	applied	\N	\N	\N	\N	106541	106541	274279
12754	13691	1	applied	\N	\N	\N	\N	106542	106542	274280
12754	13692	2	applied	\N	\N	\N	\N	106543	106543	274281
12754	13693	3	applied	\N	\N	\N	\N	106544	106544	274282
12754	13694	4	applied	\N	\N	\N	\N	106545	106545	274283
12754	13695	5	applied	\N	\N	\N	\N	106546	106546	274284
12754	13696	6	applied	\N	\N	\N	\N	106547	106547	274285
12754	13697	7	applied	\N	\N	\N	\N	106548	106548	274286
12754	13698	8	applied	\N	\N	\N	\N	106549	106549	274287
12754	13699	9	applied	\N	\N	\N	\N	106550	106550	274288
12754	13700	10	applied	\N	\N	\N	\N	106551	106551	274289
12757	13705	0	applied	\N	\N	\N	\N	106567	106567	274305
12757	13706	1	applied	\N	\N	\N	\N	106568	106568	274306
12757	13707	2	applied	\N	\N	\N	\N	106569	106569	274307
12757	13708	3	applied	\N	\N	\N	\N	106570	106570	274308
12762	13717	1	applied	\N	\N	\N	\N	106587	106587	274325
12762	13718	2	applied	\N	\N	\N	\N	106588	106588	274326
12762	13719	3	applied	\N	\N	\N	\N	106589	106589	274327
12770	13732	0	applied	\N	\N	\N	\N	106604	106604	274342
12770	13733	1	applied	\N	\N	\N	\N	106605	106605	274343
12773	13732	0	applied	\N	\N	\N	\N	106610	106610	274348
12773	13733	1	applied	\N	\N	\N	\N	106611	106611	274349
12773	13735	2	applied	\N	\N	\N	\N	106612	106612	274350
12782	13739	0	applied	\N	\N	\N	\N	106632	106632	274370
12782	13740	1	applied	\N	\N	\N	\N	106633	106633	274371
12782	13741	3	applied	\N	\N	\N	\N	106634	106634	274372
12782	13742	4	applied	\N	\N	\N	\N	106635	106635	274373
12782	13743	5	applied	\N	\N	1000000000	\N	106636	106636	274374
12782	13744	6	applied	\N	\N	\N	\N	106637	106637	274375
12782	13745	7	applied	\N	\N	\N	\N	106638	106638	274376
12799	13778	0	applied	\N	\N	\N	\N	106703	106703	274441
12647	13523	1	applied	\N	\N	\N	\N	105995	105995	273736
12650	13528	2	applied	\N	\N	\N	\N	106002	106002	273743
12650	13529	3	applied	\N	\N	\N	\N	106003	106003	273744
12650	13530	4	applied	\N	\N	\N	\N	106004	106004	273745
12650	13531	5	applied	\N	\N	\N	\N	106005	106005	273746
12650	13532	6	applied	\N	\N	\N	\N	106006	106006	273747
12652	13533	0	applied	\N	\N	\N	\N	106014	106014	273755
12652	13534	1	applied	\N	\N	\N	\N	106015	106015	273756
12656	13537	0	applied	\N	\N	\N	\N	106032	106032	273773
12656	13538	1	applied	\N	\N	\N	\N	106033	106033	273774
12656	13539	2	applied	\N	\N	\N	\N	106034	106034	273775
12656	13540	3	applied	\N	\N	\N	\N	106035	106035	273776
12656	13541	4	applied	\N	\N	\N	\N	106036	106036	273777
12656	13542	5	applied	\N	\N	\N	\N	106037	106037	273778
12656	13543	6	applied	\N	\N	\N	\N	106038	106038	273779
12658	13544	0	applied	\N	\N	\N	\N	106042	106042	273783
12658	13545	1	applied	\N	\N	\N	\N	106043	106043	273784
12660	13547	0	applied	\N	\N	\N	\N	106048	106048	273789
12660	13548	1	applied	\N	\N	\N	\N	106049	106049	273790
12660	13549	2	applied	\N	\N	\N	\N	106050	106050	273791
12662	13556	0	applied	\N	\N	\N	\N	106057	106057	273798
12662	13557	1	applied	\N	\N	\N	\N	106058	106058	273799
12668	13563	0	applied	\N	\N	\N	\N	106073	106073	273814
12668	13564	1	applied	\N	\N	\N	\N	106074	106074	273815
12668	13565	2	applied	\N	\N	\N	\N	106075	106075	273816
12671	13568	0	applied	\N	\N	\N	\N	106078	106078	273819
12671	13569	1	applied	\N	\N	\N	\N	106079	106079	273820
12671	13570	2	applied	\N	\N	\N	\N	106080	106080	273821
12671	13571	3	applied	\N	\N	\N	\N	106081	106081	273822
12671	13572	4	applied	\N	\N	\N	\N	106082	106082	273823
12673	13568	0	applied	\N	\N	\N	\N	106088	106088	273829
12673	13569	1	applied	\N	\N	\N	\N	106089	106089	273830
12673	13570	2	applied	\N	\N	\N	\N	106090	106090	273831
12673	13572	4	applied	\N	\N	\N	\N	106092	106092	273833
12676	13575	0	applied	\N	\N	\N	\N	106097	106097	273838
12676	13576	1	applied	\N	\N	\N	\N	106098	106098	273839
12676	13577	2	applied	\N	\N	\N	\N	106099	106099	273840
12676	13578	3	applied	\N	\N	\N	\N	106100	106100	273841
12678	13579	0	applied	\N	\N	\N	\N	106105	106105	273846
12678	13580	1	applied	\N	\N	\N	\N	106106	106106	273847
12686	13587	0	applied	\N	\N	\N	\N	106123	106123	273864
12688	13589	0	applied	\N	\N	\N	\N	106126	106126	273867
12688	13590	1	applied	\N	\N	\N	\N	106127	106127	273868
12690	13591	0	applied	\N	\N	\N	\N	106130	106130	273871
12690	13592	1	applied	\N	\N	\N	\N	106131	106131	273872
12694	13595	0	applied	\N	\N	\N	\N	106137	106137	273878
12694	13594	1	applied	\N	\N	\N	\N	106138	106138	273879
12697	13600	0	applied	\N	\N	\N	\N	106145	106145	273886
12697	13601	1	applied	\N	\N	\N	\N	106146	106146	273887
12699	13603	1	applied	\N	\N	\N	\N	106150	106150	273891
12709	13614	0	applied	\N	\N	\N	\N	106173	106173	273914
12709	13615	1	applied	\N	\N	\N	\N	106174	106174	273915
12709	13616	2	applied	\N	\N	\N	\N	106175	106175	273916
12709	13617	3	applied	\N	\N	\N	\N	106176	106176	273917
12714	13620	0	applied	\N	\N	\N	\N	106189	106189	273930
12714	13621	1	applied	\N	\N	\N	\N	106190	106190	273931
12714	13622	2	applied	\N	\N	\N	\N	106191	106191	273932
12714	13623	3	applied	\N	\N	\N	\N	106192	106192	273933
12714	13624	4	applied	\N	\N	\N	\N	106193	106193	273934
12714	13625	5	applied	\N	\N	\N	\N	106194	106194	273935
12725	13393	0	applied	\N	\N	\N	\N	106361	106361	274102
12725	13264	1	applied	\N	\N	\N	\N	106362	106362	274103
12725	13394	2	applied	\N	\N	\N	\N	106363	106363	274104
12725	13266	3	applied	\N	\N	\N	\N	106364	106364	274105
12725	13268	4	applied	\N	\N	\N	\N	106365	106365	274106
12725	13397	6	applied	\N	\N	\N	\N	106367	106367	274108
12725	13270	7	applied	\N	\N	\N	\N	106368	106368	274109
12725	13273	8	applied	\N	\N	\N	\N	106369	106369	274110
12725	13275	9	applied	\N	\N	\N	\N	106370	106370	274111
12725	13276	10	applied	\N	\N	\N	\N	106371	106371	274112
12725	13277	11	applied	\N	\N	\N	\N	106372	106372	274113
12725	13278	12	applied	\N	\N	\N	\N	106373	106373	274114
12725	13279	13	applied	\N	\N	\N	\N	106374	106374	274115
12725	13285	14	applied	\N	\N	\N	\N	106375	106375	274116
12725	13286	15	applied	\N	\N	\N	\N	106376	106376	274117
12725	13289	16	applied	\N	\N	\N	\N	106377	106377	274118
12725	13291	17	applied	\N	\N	\N	\N	106378	106378	274119
12725	13294	18	applied	\N	\N	\N	\N	106379	106379	274120
12725	13295	19	applied	\N	\N	\N	\N	106380	106380	274121
12725	13298	20	applied	\N	\N	\N	\N	106381	106381	274122
12725	13300	21	applied	\N	\N	\N	\N	106382	106382	274123
12725	13304	23	applied	\N	\N	\N	\N	106384	106384	274125
12725	13306	24	applied	\N	\N	\N	\N	106385	106385	274126
12725	13307	25	applied	\N	\N	\N	\N	106386	106386	274127
12725	13310	26	applied	\N	\N	\N	\N	106387	106387	274128
12725	13311	27	applied	\N	\N	\N	\N	106388	106388	274129
12725	13312	28	applied	\N	\N	\N	\N	106389	106389	274130
12725	13316	29	applied	\N	\N	\N	\N	106390	106390	274131
12725	13318	30	applied	\N	\N	\N	\N	106391	106391	274132
12725	13321	31	applied	\N	\N	\N	\N	106392	106392	274133
12725	13322	32	applied	\N	\N	\N	\N	106393	106393	274134
12725	13325	33	applied	\N	\N	\N	\N	106394	106394	274135
12725	13327	34	applied	\N	\N	\N	\N	106395	106395	274136
12728	13655	0	applied	\N	\N	\N	\N	106404	106404	274145
12728	13656	1	applied	\N	\N	\N	\N	106405	106405	274146
12737	13664	0	applied	\N	\N	\N	\N	106480	106480	274221
12737	13665	1	applied	\N	\N	\N	\N	106481	106481	274222
12744	13671	1	applied	\N	\N	\N	\N	106494	106494	274235
12746	13670	0	applied	\N	\N	\N	\N	106497	106497	274238
12799	13779	1	applied	\N	\N	\N	\N	106704	106704	274442
12805	13785	0	applied	\N	\N	\N	\N	106715	106715	274453
12805	13786	1	applied	\N	\N	\N	\N	106716	106716	274454
12806	13787	0	applied	\N	\N	\N	\N	106717	106717	274455
12806	13788	1	applied	\N	\N	\N	\N	106718	106718	274456
12811	13791	0	applied	\N	\N	\N	\N	106727	106727	274465
12816	13797	0	applied	\N	\N	\N	\N	106739	106739	274477
12824	13804	0	applied	\N	\N	\N	\N	106747	106747	274485
12827	13806	0	applied	\N	\N	\N	\N	106750	106750	274488
12829	13788	0	applied	\N	\N	\N	\N	106752	106752	274490
12829	13790	1	applied	\N	\N	\N	\N	106753	106753	274491
12831	13808	0	applied	\N	\N	\N	\N	106755	106755	274493
12649	13525	1	applied	\N	\N	\N	\N	105999	105999	273740
12650	13526	0	applied	\N	\N	\N	\N	106000	106000	273741
12716	13389	3	applied	\N	\N	\N	\N	106204	106204	273945
12716	13394	4	applied	\N	\N	\N	\N	106205	106205	273946
12716	13396	5	applied	\N	\N	\N	\N	106206	106206	273947
12716	13397	6	applied	\N	\N	\N	\N	106207	106207	273948
12716	13390	7	applied	\N	\N	\N	\N	106208	106208	273949
12716	13395	8	applied	\N	\N	\N	\N	106209	106209	273950
12716	13399	9	applied	\N	\N	\N	\N	106210	106210	273951
12716	13405	10	applied	\N	\N	\N	\N	106211	106211	273952
12716	13406	11	applied	\N	\N	\N	\N	106212	106212	273953
12716	13408	12	applied	\N	\N	\N	\N	106213	106213	273954
12716	13409	13	applied	\N	\N	\N	\N	106214	106214	273955
12716	13410	14	applied	\N	\N	\N	\N	106215	106215	273956
12716	13411	15	applied	\N	\N	\N	\N	106216	106216	273957
12716	13416	16	applied	\N	\N	\N	\N	106217	106217	273958
12716	13417	17	applied	\N	\N	\N	\N	106218	106218	273959
12716	13420	18	applied	\N	\N	\N	\N	106219	106219	273960
12716	13424	20	applied	\N	\N	\N	\N	106221	106221	273962
12716	13425	21	applied	\N	\N	\N	\N	106222	106222	273963
12716	13428	22	applied	\N	\N	\N	\N	106223	106223	273964
12716	13430	23	applied	\N	\N	\N	\N	106224	106224	273965
12716	13431	24	applied	\N	\N	\N	\N	106225	106225	273966
12716	13432	25	applied	\N	\N	\N	\N	106226	106226	273967
12716	13433	26	applied	\N	\N	\N	\N	106227	106227	273968
12716	13438	27	applied	\N	\N	\N	\N	106228	106228	273969
12716	13440	28	applied	\N	\N	\N	\N	106229	106229	273970
12716	13442	29	applied	\N	\N	\N	\N	106230	106230	273971
12716	13444	30	applied	\N	\N	\N	\N	106231	106231	273972
12716	13446	31	applied	\N	\N	\N	\N	106232	106232	273973
12716	13448	32	applied	\N	\N	\N	\N	106233	106233	273974
12716	13449	33	applied	\N	\N	\N	\N	106234	106234	273975
12716	13450	34	applied	\N	\N	\N	\N	106235	106235	273976
12716	13454	35	applied	\N	\N	\N	\N	106236	106236	273977
12716	13458	37	applied	\N	\N	\N	\N	106238	106238	273979
12716	13460	38	applied	\N	\N	\N	\N	106239	106239	273980
12716	13462	39	applied	\N	\N	\N	\N	106240	106240	273981
12716	13464	40	applied	\N	\N	\N	\N	106241	106241	273982
12716	13466	41	applied	\N	\N	\N	\N	106242	106242	273983
12716	13386	42	applied	\N	\N	\N	\N	106243	106243	273984
12716	13470	43	applied	\N	\N	\N	\N	106244	106244	273985
12716	13388	44	applied	\N	\N	\N	\N	106245	106245	273986
12716	13391	45	applied	\N	\N	\N	\N	106246	106246	273987
12716	13392	46	applied	\N	\N	\N	\N	106247	106247	273988
12716	13398	47	applied	\N	\N	\N	\N	106248	106248	273989
12716	13529	48	applied	\N	\N	\N	\N	106249	106249	273990
12716	13400	49	applied	\N	\N	\N	\N	106250	106250	273991
12716	13401	50	applied	\N	\N	\N	\N	106251	106251	273992
12716	13402	51	applied	\N	\N	\N	\N	106252	106252	273993
12716	13403	52	applied	\N	\N	\N	\N	106253	106253	273994
12716	13404	54	applied	\N	\N	\N	\N	106255	106255	273996
12716	13407	55	applied	\N	\N	\N	\N	106256	106256	273997
12716	13412	56	applied	\N	\N	\N	\N	106257	106257	273998
12716	13413	57	applied	\N	\N	\N	\N	106258	106258	273999
12716	13543	58	applied	\N	\N	\N	\N	106259	106259	274000
12716	13546	59	applied	\N	\N	\N	\N	106260	106260	274001
12716	13549	60	applied	\N	\N	\N	\N	106261	106261	274002
12716	13551	62	applied	\N	\N	\N	\N	106262	106262	274003
12716	13560	63	applied	\N	\N	\N	\N	106263	106263	274004
12716	13565	64	applied	\N	\N	\N	\N	106264	106264	274005
12716	13572	65	applied	\N	\N	\N	\N	106265	106265	274006
12716	13414	66	applied	\N	\N	\N	\N	106266	106266	274007
12716	13415	67	applied	\N	\N	\N	\N	106267	106267	274008
12716	13418	68	applied	\N	\N	\N	\N	106268	106268	274009
12716	13419	69	applied	\N	\N	\N	\N	106269	106269	274010
12716	13421	70	applied	\N	\N	\N	\N	106270	106270	274011
12716	13426	72	applied	\N	\N	\N	\N	106272	106272	274013
12716	13427	73	applied	\N	\N	\N	\N	106273	106273	274014
12716	13429	74	applied	\N	\N	\N	\N	106274	106274	274015
12716	13434	75	applied	\N	\N	\N	\N	106275	106275	274016
12716	13435	76	applied	\N	\N	\N	\N	106276	106276	274017
12716	13436	77	applied	\N	\N	\N	\N	106277	106277	274018
12716	13437	78	applied	\N	\N	\N	\N	106278	106278	274019
12716	13439	79	applied	\N	\N	\N	\N	106279	106279	274020
12716	13441	80	applied	\N	\N	\N	\N	106280	106280	274021
12716	13443	81	applied	\N	\N	\N	\N	106281	106281	274022
12716	13445	82	applied	\N	\N	\N	\N	106282	106282	274023
12716	13447	83	applied	\N	\N	\N	\N	106283	106283	274024
12716	13451	84	applied	\N	\N	\N	\N	106284	106284	274025
12716	13452	85	applied	\N	\N	\N	\N	106285	106285	274026
12716	13453	86	applied	\N	\N	\N	\N	106286	106286	274027
12716	13455	87	applied	\N	\N	\N	\N	106287	106287	274028
12716	13459	89	applied	\N	\N	\N	\N	106289	106289	274030
12716	13461	90	applied	\N	\N	\N	\N	106290	106290	274031
12716	13463	91	applied	\N	\N	\N	\N	106291	106291	274032
12716	13465	92	applied	\N	\N	\N	\N	106292	106292	274033
12716	13469	93	applied	\N	\N	\N	\N	106293	106293	274034
12716	13472	94	applied	\N	\N	\N	\N	106294	106294	274035
12716	13473	95	applied	\N	\N	\N	\N	106295	106295	274036
12716	13475	96	applied	\N	\N	\N	\N	106296	106296	274037
12716	13477	97	applied	\N	\N	\N	\N	106297	106297	274038
12716	13480	98	applied	\N	\N	\N	\N	106298	106298	274039
12716	13481	99	applied	\N	\N	\N	\N	106299	106299	274040
12716	13484	100	applied	\N	\N	\N	\N	106300	106300	274041
12716	13485	101	applied	\N	\N	\N	\N	106301	106301	274042
12716	13487	102	applied	\N	\N	\N	\N	106302	106302	274043
12716	13491	103	applied	\N	\N	\N	\N	106303	106303	274044
12716	13492	104	applied	\N	\N	\N	\N	106304	106304	274045
12716	13496	106	applied	\N	\N	\N	\N	106306	106306	274047
12716	13497	107	applied	\N	\N	\N	\N	106307	106307	274048
12746	13671	1	applied	\N	\N	\N	\N	106498	106498	274239
12753	13680	0	applied	\N	\N	\N	\N	106531	106531	274269
12753	13681	1	applied	\N	\N	\N	\N	106532	106532	274270
12753	13682	2	applied	\N	\N	\N	\N	106533	106533	274271
12753	13684	3	applied	\N	\N	\N	\N	106534	106534	274272
12753	13685	4	applied	\N	\N	\N	\N	106535	106535	274273
12753	13686	5	applied	\N	\N	\N	\N	106536	106536	274274
12753	13687	6	applied	\N	\N	\N	\N	106537	106537	274275
12753	13688	7	applied	\N	\N	\N	\N	106538	106538	274276
12753	13689	8	applied	\N	\N	\N	\N	106539	106539	274277
12753	13683	9	applied	\N	\N	\N	\N	106540	106540	274278
12755	13690	0	applied	\N	\N	\N	\N	106552	106552	274290
12716	13393	0	applied	\N	\N	\N	\N	106201	106201	273942
12716	13385	1	applied	\N	\N	\N	\N	106202	106202	273943
12716	13505	111	applied	\N	\N	\N	\N	106311	106311	274052
12716	13509	112	applied	\N	\N	\N	\N	106312	106312	274053
12716	13510	113	applied	\N	\N	\N	\N	106313	106313	274054
12716	13511	114	applied	\N	\N	\N	\N	106314	106314	274055
12716	13515	115	applied	\N	\N	\N	\N	106315	106315	274056
12716	13516	116	applied	\N	\N	\N	\N	106316	106316	274057
12716	13517	117	applied	\N	\N	\N	\N	106317	106317	274058
12716	13519	118	applied	\N	\N	\N	\N	106318	106318	274059
12716	13521	119	applied	\N	\N	\N	\N	106319	106319	274060
12716	13523	120	applied	\N	\N	\N	\N	106320	106320	274061
12716	13525	121	applied	\N	\N	\N	\N	106321	106321	274062
12716	13530	122	applied	\N	\N	\N	\N	106322	106322	274063
12716	13531	123	applied	\N	\N	\N	\N	106323	106323	274064
12716	13534	125	applied	\N	\N	\N	\N	106325	106325	274066
12718	13626	0	applied	\N	\N	\N	\N	106332	106332	274073
12718	13627	1	applied	\N	\N	\N	\N	106333	106333	274074
12718	13628	2	applied	\N	\N	\N	\N	106334	106334	274075
12718	13629	3	applied	\N	\N	\N	\N	106335	106335	274076
12718	13630	4	applied	\N	\N	\N	\N	106336	106336	274077
12722	13643	0	applied	\N	\N	\N	\N	106349	106349	274090
12722	13644	1	applied	\N	\N	\N	\N	106350	106350	274091
12722	13645	2	applied	\N	\N	\N	\N	106351	106351	274092
12722	13646	3	applied	\N	\N	\N	\N	106352	106352	274093
12726	13647	0	applied	\N	\N	\N	\N	106396	106396	274137
12726	13648	1	applied	\N	\N	\N	\N	106397	106397	274138
12727	13649	0	applied	\N	\N	\N	\N	106398	106398	274139
12727	13650	1	applied	\N	\N	\N	\N	106399	106399	274140
12727	13651	2	applied	\N	\N	\N	\N	106400	106400	274141
12727	13652	3	applied	\N	\N	\N	\N	106401	106401	274142
12727	13654	5	applied	\N	\N	\N	\N	106403	106403	274144
12732	13657	0	applied	\N	\N	\N	\N	106468	106468	274209
12732	13658	1	applied	\N	\N	\N	\N	106469	106469	274210
12734	13657	0	applied	\N	\N	\N	\N	106472	106472	274213
12734	13658	1	applied	\N	\N	\N	\N	106473	106473	274214
12736	13659	0	applied	\N	\N	\N	\N	106474	106474	274215
12736	13660	1	applied	\N	\N	\N	\N	106475	106475	274216
12736	13661	2	applied	\N	\N	1000000000	\N	106476	106476	274217
12736	13658	3	applied	\N	\N	\N	\N	106477	106477	274218
12736	13662	4	applied	\N	\N	\N	\N	106478	106478	274219
12736	13663	5	applied	\N	\N	\N	\N	106479	106479	274220
12739	13664	0	applied	\N	\N	\N	\N	106483	106483	274224
12739	13665	1	applied	\N	\N	\N	\N	106484	106484	274225
12743	13668	0	applied	\N	\N	\N	\N	106491	106491	274232
12743	13669	1	applied	\N	\N	\N	\N	106492	106492	274233
12748	13672	0	applied	\N	\N	\N	\N	106504	106504	274244
12748	13674	2	applied	\N	\N	\N	\N	106506	106506	106506
12748	13675	3	applied	\N	\N	\N	\N	106507	106507	274246
12748	13676	4	applied	\N	\N	\N	\N	106508	106508	274247
12751	13680	0	applied	\N	\N	\N	\N	106517	106517	274255
12751	13681	1	applied	\N	\N	\N	\N	106518	106518	274256
12751	13682	2	applied	\N	\N	\N	\N	106519	106519	274257
12751	13683	3	applied	\N	\N	\N	\N	106520	106520	274258
12756	13701	0	applied	\N	\N	\N	\N	106563	106563	274301
12756	13702	1	applied	\N	\N	\N	\N	106564	106564	274302
12756	13703	2	applied	\N	\N	\N	\N	106565	106565	274303
12756	13704	3	applied	\N	\N	\N	\N	106566	106566	274304
12767	13728	0	applied	\N	\N	\N	\N	106598	106598	274336
12767	13729	1	applied	\N	\N	\N	\N	106599	106599	274337
12772	13734	0	applied	\N	\N	\N	\N	106608	106608	274346
12772	13735	1	applied	\N	\N	\N	\N	106609	106609	274347
12775	13734	0	applied	\N	\N	\N	\N	106615	106615	274353
12780	13738	0	applied	\N	\N	\N	\N	106624	106624	274362
12781	13739	0	applied	\N	\N	\N	\N	106625	106625	274363
12781	13740	1	applied	\N	\N	\N	\N	106626	106626	274364
12781	13741	3	applied	\N	\N	\N	\N	106627	106627	274365
12781	13742	4	applied	\N	\N	\N	\N	106628	106628	274366
12781	13743	5	applied	\N	\N	1000000000	\N	106629	106629	274367
12781	13744	6	applied	\N	\N	\N	\N	106630	106630	274368
12781	13745	7	applied	\N	\N	\N	\N	106631	106631	274369
12784	13746	0	applied	\N	\N	\N	\N	106643	106643	274381
12784	13747	1	applied	\N	\N	\N	\N	106644	106644	274382
12784	13748	2	applied	\N	\N	\N	\N	106645	106645	274383
12784	13749	3	applied	\N	\N	\N	\N	106646	106646	274384
12792	13759	0	applied	\N	\N	\N	\N	106667	106667	274405
12792	13761	1	applied	\N	\N	\N	\N	106668	106668	274406
12792	13762	2	applied	\N	\N	\N	\N	106669	106669	274407
12792	13763	3	applied	\N	\N	\N	\N	106670	106670	274408
12792	13760	5	applied	\N	\N	\N	\N	106672	106672	274410
12792	13765	6	applied	\N	\N	\N	\N	106673	106673	274411
12792	13766	7	applied	\N	\N	\N	\N	106674	106674	274412
12792	13767	8	applied	\N	\N	\N	\N	106675	106675	274413
12794	13768	0	applied	\N	\N	\N	\N	106683	106683	274421
12794	13770	1	applied	\N	\N	\N	\N	106684	106684	274422
12796	13771	0	applied	\N	\N	\N	\N	106692	106692	274430
12796	13760	1	applied	\N	\N	\N	\N	106693	106693	274431
12796	13765	2	applied	\N	\N	\N	\N	106694	106694	274432
12796	13766	3	applied	\N	\N	\N	\N	106695	106695	274433
12796	13767	4	applied	\N	\N	\N	\N	106696	106696	274434
12796	13769	5	applied	\N	\N	\N	\N	106697	106697	274435
12801	13780	0	applied	\N	\N	\N	\N	106707	106707	274445
12801	13781	1	applied	\N	\N	\N	\N	106708	106708	274446
12801	13782	2	applied	\N	\N	\N	\N	106709	106709	274447
12804	13785	0	applied	\N	\N	\N	\N	106713	106713	274451
12808	13787	0	applied	\N	\N	\N	\N	106722	106722	274460
12808	13788	1	applied	\N	\N	\N	\N	106723	106723	274461
12814	13792	0	applied	\N	\N	\N	\N	106734	106734	274472
12814	13793	1	applied	\N	\N	\N	\N	106735	106735	274473
12814	13794	2	applied	\N	\N	\N	\N	106736	106736	274474
12821	13801	0	applied	\N	\N	\N	\N	106743	106743	274481
12821	13802	1	applied	\N	\N	\N	\N	106744	106744	274482
12826	13806	0	applied	\N	\N	\N	\N	106749	106749	274487
12828	13807	0	applied	\N	\N	\N	\N	106751	106751	274489
12830	13807	0	applied	\N	\N	\N	\N	106754	106754	274492
12837	13809	0	applied	\N	\N	\N	\N	106761	106761	274499
12839	13810	0	applied	\N	\N	\N	\N	106763	106763	274501
12846	13817	0	applied	\N	\N	\N	\N	106780	106780	274518
12846	13818	1	applied	\N	\N	\N	\N	106781	106781	274519
12848	13788	0	applied	\N	\N	\N	\N	106784	106784	274522
12848	13732	1	applied	\N	\N	\N	\N	106785	106785	274523
12716	13501	109	applied	\N	\N	\N	\N	106309	106309	274050
12716	13503	110	applied	\N	\N	\N	\N	106310	106310	274051
12742	13668	0	applied	\N	\N	\N	\N	106489	106489	274230
12742	13669	1	applied	\N	\N	\N	\N	106490	106490	274231
12745	13670	0	applied	\N	\N	\N	\N	106495	106495	274236
12745	13671	1	applied	\N	\N	\N	\N	106496	106496	274237
12747	13672	0	applied	\N	\N	\N	\N	106499	106499	274240
12747	13673	1	applied	\N	\N	\N	\N	106500	106500	274241
12747	13674	2	applied	\N	\N	\N	\N	106501	106501	106501
12747	13675	3	applied	\N	\N	\N	\N	106502	106502	274242
12747	13676	4	applied	\N	\N	\N	\N	106503	106503	274243
12749	13672	0	applied	\N	\N	\N	\N	106509	106509	274248
12749	13673	1	applied	\N	\N	\N	\N	106510	106510	274249
12749	13674	2	applied	\N	\N	\N	\N	106511	106511	106511
12750	13677	0	applied	\N	\N	\N	\N	106512	106512	274250
12750	13679	2	applied	\N	\N	\N	\N	106514	106514	274252
12750	13675	3	applied	\N	\N	\N	\N	106515	106515	274253
12750	13676	4	applied	\N	\N	\N	\N	106516	106516	274254
12759	13705	0	applied	\N	\N	\N	\N	106575	106575	274313
12759	13706	1	applied	\N	\N	\N	\N	106576	106576	274314
12759	13707	2	applied	\N	\N	\N	\N	106577	106577	274315
12759	13708	3	applied	\N	\N	\N	\N	106578	106578	274316
12761	13714	0	applied	\N	\N	\N	\N	106584	106584	274322
12761	13715	1	applied	\N	\N	\N	\N	106585	106585	274323
12764	13722	0	applied	\N	\N	\N	\N	106592	106592	274330
12764	13723	1	applied	\N	\N	\N	\N	106593	106593	274331
12764	13724	2	applied	\N	\N	\N	\N	106594	106594	274332
12764	13725	3	applied	\N	\N	\N	\N	106595	106595	274333
12764	13726	4	applied	\N	\N	\N	\N	106596	106596	274334
12764	13727	5	applied	\N	\N	\N	\N	106597	106597	274335
12769	13730	0	applied	\N	\N	\N	\N	106602	106602	274340
12771	13734	0	applied	\N	\N	\N	\N	106606	106606	274344
12771	13735	1	applied	\N	\N	\N	\N	106607	106607	274345
12778	13737	0	applied	\N	\N	\N	\N	106620	106620	274358
12778	13736	1	applied	\N	\N	\N	\N	106621	106621	274359
12783	13746	0	applied	\N	\N	\N	\N	106639	106639	274377
12783	13747	1	applied	\N	\N	\N	\N	106640	106640	274378
12783	13748	2	applied	\N	\N	\N	\N	106641	106641	274379
12783	13749	3	applied	\N	\N	\N	\N	106642	106642	274380
12788	13756	0	applied	\N	\N	\N	\N	106657	106657	274395
12788	13757	1	applied	\N	\N	\N	\N	106658	106658	274396
12788	13758	2	applied	\N	\N	\N	\N	106659	106659	274397
12791	13759	0	applied	\N	\N	\N	\N	106662	106662	274400
12791	13761	1	applied	\N	\N	\N	\N	106663	106663	274401
12791	13762	2	applied	\N	\N	\N	\N	106664	106664	274402
12791	13763	3	applied	\N	\N	\N	\N	106665	106665	274403
12791	13764	4	applied	\N	\N	\N	\N	106666	106666	274404
12793	13760	1	applied	\N	\N	\N	\N	106677	106677	274415
12793	13765	2	applied	\N	\N	\N	\N	106678	106678	274416
12793	13766	3	applied	\N	\N	\N	\N	106679	106679	274417
12793	13767	4	applied	\N	\N	\N	\N	106680	106680	274418
12793	13769	5	applied	\N	\N	\N	\N	106681	106681	274419
12793	13770	6	applied	\N	\N	\N	\N	106682	106682	274420
12798	13776	0	applied	\N	\N	\N	\N	106701	106701	274439
12798	13777	1	applied	\N	\N	\N	\N	106702	106702	274440
12803	13785	0	applied	\N	\N	\N	\N	106712	106712	274450
12813	13792	0	applied	\N	\N	\N	\N	106731	106731	274469
12813	13793	1	applied	\N	\N	\N	\N	106732	106732	274470
12813	13794	2	applied	\N	\N	\N	\N	106733	106733	274471
12815	13795	0	applied	\N	\N	\N	\N	106737	106737	274475
12815	13796	1	applied	\N	\N	\N	\N	106738	106738	274476
12818	13798	0	applied	\N	\N	\N	\N	106740	106740	274478
12820	13800	0	applied	\N	\N	\N	\N	106742	106742	274480
12825	13805	0	applied	\N	\N	\N	\N	106748	106748	274486
12833	13808	0	applied	\N	\N	\N	\N	106757	106757	274495
12835	13808	0	applied	\N	\N	\N	\N	106759	106759	274497
12836	13809	0	applied	\N	\N	\N	\N	106760	106760	274498
12838	13809	0	applied	\N	\N	\N	\N	106762	106762	274500
12841	13811	0	applied	\N	\N	1000000000	\N	106768	106768	274506
12841	13812	1	applied	\N	\N	\N	\N	106769	106769	274507
12841	13813	2	applied	\N	\N	1000000000	\N	106770	106770	274508
12841	13814	3	applied	\N	\N	\N	\N	106771	106771	274509
12844	13815	0	applied	\N	\N	\N	\N	106776	106776	274514
12844	13816	1	applied	\N	\N	\N	\N	106777	106777	274515
12845	13817	0	applied	\N	\N	\N	\N	106778	106778	274516
12845	13818	1	applied	\N	\N	\N	\N	106779	106779	274517
12848	13737	3	applied	\N	\N	\N	\N	106787	106787	274525
12848	13739	4	applied	\N	\N	\N	\N	106788	106788	274526
12848	13740	5	applied	\N	\N	\N	\N	106789	106789	274527
12848	13746	7	applied	\N	\N	\N	\N	106791	106791	274529
12848	13747	8	applied	\N	\N	\N	\N	106792	106792	274530
12848	13750	9	applied	\N	\N	\N	\N	106793	106793	274531
12848	13751	10	applied	\N	\N	\N	\N	106794	106794	274532
12848	13754	11	applied	\N	\N	\N	\N	106795	106795	274533
12848	13756	12	applied	\N	\N	\N	\N	106796	106796	274534
12848	13759	13	applied	\N	\N	\N	\N	106797	106797	274535
12848	13790	14	applied	\N	\N	\N	\N	106798	106798	274536
12862	13833	0	applied	\N	\N	\N	\N	106909	106909	274647
12868	13856	0	applied	\N	\N	\N	\N	106947	106947	274685
12868	13857	1	applied	\N	\N	\N	\N	106948	106948	274686
12868	13858	2	applied	\N	\N	\N	\N	106949	106949	274687
12868	13859	3	applied	\N	\N	\N	\N	106950	106950	274688
12868	13860	4	applied	\N	\N	\N	\N	106951	106951	274689
12868	13861	5	applied	\N	\N	\N	\N	106952	106952	274690
12868	13862	6	applied	\N	\N	\N	\N	106953	106953	274691
12871	13875	0	applied	\N	\N	\N	\N	106966	106966	274704
12871	13876	1	applied	\N	\N	\N	\N	106967	106967	274705
12878	13881	0	applied	\N	\N	\N	\N	106986	106986	274724
12878	13882	1	applied	\N	\N	\N	\N	106987	106987	274725
12889	13889	0	applied	\N	\N	\N	\N	107066	107066	274804
12889	13890	1	applied	\N	\N	\N	\N	107067	107067	274805
12893	13891	0	applied	\N	\N	\N	\N	107072	107072	274810
12893	13892	1	applied	\N	\N	\N	\N	107073	107073	274811
12900	13899	0	applied	\N	\N	\N	\N	107084	107084	274822
12900	13900	1	applied	\N	\N	\N	\N	107085	107085	274823
12903	13901	0	applied	\N	\N	\N	\N	107092	107092	274830
12903	13902	1	applied	\N	\N	\N	\N	107093	107093	274831
12903	13903	2	applied	\N	\N	\N	\N	107094	107094	274832
12903	13904	3	applied	\N	\N	\N	\N	107095	107095	274833
12913	13914	0	applied	\N	\N	\N	\N	107130	107130	274868
12913	13915	1	applied	\N	\N	\N	\N	107131	107131	274869
12733	13658	1	applied	\N	\N	\N	\N	106471	106471	274212
12738	13664	0	applied	\N	\N	\N	\N	106482	106482	274223
12755	13694	4	applied	\N	\N	\N	\N	106556	106556	274294
12755	13695	5	applied	\N	\N	\N	\N	106557	106557	274295
12755	13696	6	applied	\N	\N	\N	\N	106558	106558	274296
12755	13697	7	applied	\N	\N	\N	\N	106559	106559	274297
12755	13698	8	applied	\N	\N	\N	\N	106560	106560	274298
12755	13699	9	applied	\N	\N	\N	\N	106561	106561	274299
12755	13700	10	applied	\N	\N	\N	\N	106562	106562	274300
12758	13705	0	applied	\N	\N	\N	\N	106571	106571	274309
12758	13706	1	applied	\N	\N	\N	\N	106572	106572	274310
12758	13707	2	applied	\N	\N	\N	\N	106573	106573	274311
12758	13708	3	applied	\N	\N	\N	\N	106574	106574	274312
12760	13710	1	applied	\N	\N	\N	\N	106580	106580	274318
12760	13711	2	applied	\N	\N	\N	\N	106581	106581	274319
12760	13712	3	applied	\N	\N	1000000000	\N	106582	106582	274320
12760	13713	4	applied	\N	\N	\N	\N	106583	106583	274321
12763	13720	0	applied	\N	\N	\N	\N	106590	106590	274328
12763	13721	1	applied	\N	\N	\N	\N	106591	106591	274329
12768	13730	0	applied	\N	\N	\N	\N	106600	106600	274338
12768	13731	1	applied	\N	\N	\N	\N	106601	106601	274339
12774	13734	0	applied	\N	\N	\N	\N	106613	106613	274351
12774	13735	1	applied	\N	\N	\N	\N	106614	106614	274352
12776	13734	0	applied	\N	\N	\N	\N	106617	106617	274355
12776	13735	1	applied	\N	\N	\N	\N	106618	106618	274356
12777	13736	0	applied	\N	\N	\N	\N	106619	106619	274357
12779	13737	0	applied	\N	\N	\N	\N	106622	106622	274360
12779	13736	1	applied	\N	\N	\N	\N	106623	106623	274361
12785	13750	0	applied	\N	\N	\N	\N	106647	106647	274385
12785	13752	2	applied	\N	\N	\N	\N	106649	106649	274387
12785	13753	3	applied	\N	\N	\N	\N	106650	106650	274388
12787	13750	0	applied	\N	\N	\N	\N	106651	106651	274389
12787	13751	1	applied	\N	\N	\N	\N	106652	106652	274390
12787	13754	2	applied	\N	\N	\N	\N	106653	106653	274391
12787	13752	3	applied	\N	\N	\N	\N	106654	106654	274392
12787	13753	4	applied	\N	\N	\N	\N	106655	106655	274393
12787	13755	5	applied	\N	\N	\N	\N	106656	106656	274394
12790	13759	0	applied	\N	\N	\N	\N	106660	106660	274398
12790	13760	1	applied	\N	\N	\N	\N	106661	106661	274399
12795	13771	0	applied	\N	\N	\N	\N	106685	106685	274423
12795	13760	1	applied	\N	\N	\N	\N	106686	106686	274424
12795	13765	2	applied	\N	\N	\N	\N	106687	106687	274425
12795	13766	3	applied	\N	\N	\N	\N	106688	106688	274426
12795	13767	4	applied	\N	\N	\N	\N	106689	106689	274427
12795	13769	5	applied	\N	\N	\N	\N	106690	106690	274428
12797	13773	0	applied	\N	\N	\N	\N	106698	106698	274436
12797	13774	1	applied	\N	\N	\N	\N	106699	106699	274437
12797	13775	2	applied	\N	\N	\N	\N	106700	106700	274438
12800	13778	0	applied	\N	\N	\N	\N	106705	106705	274443
12800	13779	1	applied	\N	\N	\N	\N	106706	106706	274444
12802	13783	0	applied	\N	\N	\N	\N	106710	106710	274448
12802	13784	1	applied	\N	\N	\N	\N	106711	106711	274449
12807	13787	0	applied	\N	\N	\N	\N	106719	106719	274457
12807	13788	1	applied	\N	\N	\N	\N	106720	106720	274458
12807	13786	2	applied	\N	\N	\N	\N	106721	106721	274459
12809	13789	0	applied	\N	\N	\N	\N	106724	106724	274462
12809	13790	1	applied	\N	\N	\N	\N	106725	106725	274463
12809	13786	2	applied	\N	\N	\N	\N	106726	106726	274464
12812	13792	0	applied	\N	\N	\N	\N	106728	106728	274466
12812	13793	1	applied	\N	\N	\N	\N	106729	106729	274467
12812	13794	2	applied	\N	\N	\N	\N	106730	106730	274468
12822	13803	0	applied	\N	\N	\N	\N	106745	106745	274483
12832	13808	0	applied	\N	\N	\N	\N	106756	106756	274494
12840	13811	0	applied	\N	\N	1000000000	\N	106764	106764	274502
12840	13812	1	applied	\N	\N	\N	\N	106765	106765	274503
12840	13813	2	applied	\N	\N	1000000000	\N	106766	106766	274504
12840	13814	3	applied	\N	\N	\N	\N	106767	106767	274505
12843	13815	0	applied	\N	\N	\N	\N	106774	106774	274512
12843	13816	1	applied	\N	\N	\N	\N	106775	106775	274513
12847	13819	0	applied	\N	\N	\N	\N	106782	106782	274520
12847	13820	1	applied	\N	\N	\N	\N	106783	106783	274521
12849	13821	0	applied	\N	\N	\N	\N	106873	106873	274611
12849	13822	1	applied	\N	\N	\N	\N	106874	106874	274612
12852	13823	0	applied	\N	\N	\N	\N	106879	106879	274617
12852	13824	1	applied	\N	\N	\N	\N	106880	106880	274618
12854	13825	0	applied	\N	\N	\N	\N	106883	106883	274621
12854	13826	1	applied	\N	\N	\N	\N	106884	106884	274622
12857	13830	1	applied	\N	\N	\N	\N	106892	106892	274630
12857	13831	2	applied	\N	\N	\N	\N	106893	106893	274631
12857	13832	3	applied	\N	\N	\N	\N	106894	106894	274632
12859	13833	0	applied	\N	\N	\N	\N	106897	106897	274635
12859	13834	1	applied	\N	\N	\N	\N	106898	106898	274636
12866	13850	0	applied	\N	\N	\N	\N	106933	106933	274671
12866	13851	1	applied	\N	\N	\N	\N	106934	106934	274672
12866	13852	2	applied	\N	\N	\N	\N	106935	106935	274673
12866	13853	3	applied	\N	\N	\N	\N	106936	106936	274674
12866	13854	4	applied	\N	\N	\N	\N	106937	106937	274675
12866	13855	5	applied	\N	\N	\N	\N	106938	106938	274676
12867	13856	0	applied	\N	\N	\N	\N	106939	106939	274677
12867	13857	1	applied	\N	\N	\N	\N	106940	106940	274678
12867	13858	2	applied	\N	\N	\N	\N	106941	106941	274679
12867	13859	3	applied	\N	\N	\N	\N	106942	106942	274680
12867	13860	4	applied	\N	\N	\N	\N	106943	106943	274681
12867	13862	6	applied	\N	\N	\N	\N	106945	106945	274683
12867	13863	7	applied	\N	\N	\N	\N	106946	106946	274684
12870	13873	0	applied	\N	\N	\N	\N	106964	106964	274702
12870	13874	1	applied	\N	\N	\N	\N	106965	106965	274703
12873	13875	0	applied	\N	\N	\N	\N	106970	106970	274708
12873	13876	1	applied	\N	\N	\N	\N	106971	106971	274709
12876	13877	0	applied	\N	\N	\N	\N	106980	106980	274718
12913	13917	3	applied	\N	\N	\N	\N	107133	107133	274871
12913	13918	4	applied	\N	\N	\N	\N	107134	107134	274872
12913	13919	5	applied	\N	\N	\N	\N	107135	107135	274873
12913	13920	6	applied	\N	\N	\N	\N	107136	107136	274874
12913	13921	7	applied	\N	\N	\N	\N	107137	107137	274875
12915	13922	0	applied	\N	\N	\N	\N	107140	107140	274878
12915	13923	1	applied	\N	\N	\N	\N	107141	107141	274879
12921	13930	0	applied	\N	\N	\N	\N	107197	107197	274935
12921	13931	1	applied	\N	\N	\N	\N	107198	107198	274936
12923	13935	1	applied	\N	\N	\N	\N	107202	107202	274940
12926	13936	0	applied	\N	\N	\N	\N	107209	107209	274947
12755	13692	2	applied	\N	\N	\N	\N	106554	106554	274292
12755	13693	3	applied	\N	\N	\N	\N	106555	106555	274293
12851	13824	1	applied	\N	\N	\N	\N	106878	106878	274616
12853	13825	0	applied	\N	\N	\N	\N	106881	106881	274619
12853	13826	1	applied	\N	\N	\N	\N	106882	106882	274620
12856	13829	0	applied	\N	\N	\N	\N	106887	106887	274625
12856	13830	1	applied	\N	\N	\N	\N	106888	106888	274626
12856	13831	2	applied	\N	\N	\N	\N	106889	106889	274627
12856	13832	3	applied	\N	\N	\N	\N	106890	106890	274628
12858	13833	0	applied	\N	\N	\N	\N	106895	106895	274633
12858	13834	1	applied	\N	\N	\N	\N	106896	106896	274634
12861	13835	0	applied	\N	\N	\N	\N	106901	106901	274639
12861	13836	1	applied	\N	\N	\N	\N	106902	106902	274640
12861	13837	2	applied	\N	\N	\N	\N	106903	106903	274641
12861	13839	4	applied	\N	\N	\N	\N	106905	106905	274643
12861	13840	5	applied	\N	\N	\N	\N	106906	106906	274644
12861	13841	6	applied	\N	\N	\N	\N	106907	106907	274645
12861	13842	7	applied	\N	\N	\N	\N	106908	106908	274646
12865	13843	0	applied	\N	\N	\N	\N	106926	106926	274664
12865	13844	1	applied	\N	\N	\N	\N	106927	106927	274665
12865	13845	2	applied	\N	\N	\N	\N	106928	106928	274666
12865	13846	3	applied	\N	\N	\N	\N	106929	106929	274667
12865	13847	4	applied	\N	\N	1000000000	\N	106930	106930	274668
12865	13848	5	applied	\N	\N	\N	\N	106931	106931	274669
12865	13849	6	applied	\N	\N	\N	\N	106932	106932	274670
12872	13875	0	applied	\N	\N	\N	\N	106968	106968	274706
12872	13876	1	applied	\N	\N	\N	\N	106969	106969	274707
12875	13877	0	applied	\N	\N	\N	\N	106976	106976	274714
12875	13878	1	applied	\N	\N	\N	\N	106977	106977	274715
12875	13879	2	applied	\N	\N	\N	\N	106978	106978	274716
12875	13880	3	applied	\N	\N	\N	\N	106979	106979	274717
12876	13878	1	applied	\N	\N	\N	\N	106981	106981	274719
12876	13880	3	applied	\N	\N	\N	\N	106983	106983	274721
12877	13881	0	applied	\N	\N	\N	\N	106984	106984	274722
12877	13882	1	applied	\N	\N	\N	\N	106985	106985	274723
12879	13883	0	applied	\N	\N	\N	\N	106988	106988	274726
12879	13884	1	applied	\N	\N	\N	\N	106989	106989	274727
12880	13821	0	applied	\N	\N	\N	\N	106990	106990	274728
12880	13823	1	applied	\N	\N	\N	\N	106991	106991	274729
12880	13825	2	applied	\N	\N	\N	\N	106992	106992	274730
12880	13827	3	applied	\N	\N	\N	\N	106993	106993	274731
12880	13829	4	applied	\N	\N	\N	\N	106994	106994	274732
12880	13830	5	applied	\N	\N	\N	\N	106995	106995	274733
12880	13833	6	applied	\N	\N	\N	\N	106996	106996	274734
12881	13885	0	applied	\N	\N	\N	\N	107052	107052	274790
12881	13886	1	applied	\N	\N	\N	\N	107053	107053	274791
12897	13895	0	applied	\N	\N	\N	\N	107078	107078	274816
12897	13896	1	applied	\N	\N	\N	\N	107079	107079	274817
12902	13902	1	applied	\N	\N	\N	\N	107089	107089	274827
12902	13903	2	applied	\N	\N	\N	\N	107090	107090	274828
12902	13904	3	applied	\N	\N	\N	\N	107091	107091	274829
12907	13907	0	applied	\N	\N	\N	\N	107106	107106	274844
12907	13908	1	applied	\N	\N	\N	\N	107107	107107	274845
12907	13909	2	applied	\N	\N	\N	\N	107108	107108	274846
12907	13910	3	applied	\N	\N	\N	\N	107109	107109	274847
12909	13912	0	applied	\N	\N	\N	\N	107112	107112	274850
12912	13914	0	applied	\N	\N	\N	\N	107122	107122	274860
12912	13915	1	applied	\N	\N	\N	\N	107123	107123	274861
12912	13916	2	applied	\N	\N	\N	\N	107124	107124	274862
12912	13917	3	applied	\N	\N	\N	\N	107125	107125	274863
12912	13918	4	applied	\N	\N	\N	\N	107126	107126	274864
12912	13919	5	applied	\N	\N	\N	\N	107127	107127	274865
12912	13920	6	applied	\N	\N	\N	\N	107128	107128	274866
12912	13921	7	applied	\N	\N	\N	\N	107129	107129	274867
12918	13925	1	applied	\N	\N	\N	\N	107190	107190	274928
12918	13926	2	applied	\N	\N	\N	\N	107191	107191	274929
12918	13927	3	applied	\N	\N	\N	\N	107192	107192	274930
12920	13930	0	applied	\N	\N	\N	\N	107195	107195	274933
12920	13931	1	applied	\N	\N	\N	\N	107196	107196	274934
12922	13932	0	applied	\N	\N	\N	\N	107199	107199	274937
12922	13933	1	applied	\N	\N	\N	\N	107200	107200	274938
12925	13936	0	applied	\N	\N	\N	\N	107205	107205	274943
12925	13937	1	applied	\N	\N	\N	\N	107206	107206	274944
12925	13938	2	applied	\N	\N	\N	\N	107207	107207	274945
12925	13939	3	applied	\N	\N	\N	\N	107208	107208	274946
12927	13940	0	applied	\N	\N	\N	\N	107213	107213	274951
12927	13941	1	applied	\N	\N	\N	\N	107214	107214	274952
12934	13946	0	applied	\N	\N	\N	\N	107286	107286	275024
12934	13947	1	applied	\N	\N	\N	\N	107287	107287	275025
12935	13948	0	applied	\N	\N	\N	\N	107288	107288	275026
12935	13950	2	applied	\N	\N	\N	\N	107290	107290	275028
12935	13951	3	applied	\N	\N	\N	\N	107291	107291	275029
12935	13952	4	applied	\N	\N	\N	\N	107292	107292	275030
12935	13953	5	applied	\N	\N	\N	\N	107293	107293	275031
12935	13954	6	applied	\N	\N	\N	\N	107294	107294	275032
12935	13955	7	applied	\N	\N	\N	\N	107295	107295	275033
12937	13948	0	applied	\N	\N	\N	\N	107304	107304	275042
12937	13949	1	applied	\N	\N	\N	\N	107305	107305	275043
12937	13950	2	applied	\N	\N	\N	\N	107306	107306	275044
12937	13951	3	applied	\N	\N	\N	\N	107307	107307	275045
12937	13952	4	applied	\N	\N	\N	\N	107308	107308	275046
12937	13953	5	applied	\N	\N	\N	\N	107309	107309	275047
12937	13954	6	applied	\N	\N	\N	\N	107310	107310	275048
12937	13955	7	applied	\N	\N	\N	\N	107311	107311	275049
12944	13962	0	applied	\N	\N	\N	\N	107324	107324	275062
12944	13961	2	applied	\N	\N	\N	\N	107325	107325	275063
12950	13972	0	applied	\N	\N	\N	\N	107337	107337	275075
12950	13973	1	applied	\N	\N	\N	\N	107338	107338	275076
12950	13974	2	applied	\N	\N	\N	\N	107339	107339	275077
12950	13975	3	applied	\N	\N	\N	\N	107340	107340	275078
12952	13976	0	applied	\N	\N	\N	\N	107345	107345	275083
12952	13977	1	applied	\N	\N	\N	\N	107346	107346	275084
12955	13982	0	applied	\N	\N	\N	\N	107351	107351	275089
12955	13983	1	applied	\N	\N	\N	\N	107352	107352	275090
12963	13996	0	applied	\N	\N	\N	\N	107368	107368	275106
12963	13997	1	applied	\N	\N	\N	\N	107369	107369	275107
12963	13998	2	applied	\N	\N	\N	\N	107370	107370	275108
12963	13999	3	applied	\N	\N	\N	\N	107371	107371	275109
12963	14000	4	applied	\N	\N	\N	\N	107372	107372	275110
12963	14001	5	applied	\N	\N	\N	\N	107373	107373	275111
12970	14008	0	applied	\N	\N	\N	\N	107390	107390	275128
12842	13815	0	applied	\N	\N	\N	\N	106772	106772	274510
12851	13823	0	applied	\N	\N	\N	\N	106877	106877	274615
12848	13768	19	applied	\N	\N	\N	\N	106802	106802	274540
12848	13771	20	applied	\N	\N	\N	\N	106803	106803	274541
12848	13773	21	applied	\N	\N	\N	\N	106804	106804	274542
12848	13776	22	applied	\N	\N	\N	\N	106805	106805	274543
12848	13778	23	applied	\N	\N	\N	\N	106806	106806	274544
12848	13780	24	applied	\N	\N	\N	\N	106807	106807	274545
12848	13783	25	applied	\N	\N	\N	\N	106808	106808	274546
12848	13787	27	applied	\N	\N	\N	\N	106810	106810	274548
12848	13789	28	applied	\N	\N	\N	\N	106811	106811	274549
12848	13791	29	applied	\N	\N	\N	\N	106812	106812	274550
12848	13792	30	applied	\N	\N	\N	\N	106813	106813	274551
12848	13793	31	applied	\N	\N	\N	\N	106814	106814	274552
12848	13794	32	applied	\N	\N	\N	\N	106815	106815	274553
12848	13795	33	applied	\N	\N	\N	\N	106816	106816	274554
12848	13796	34	applied	\N	\N	\N	\N	106817	106817	274555
12848	13797	35	applied	\N	\N	\N	\N	106818	106818	274556
12848	13798	36	applied	\N	\N	\N	\N	106819	106819	274557
12848	13799	37	applied	\N	\N	\N	\N	106820	106820	274558
12848	13800	38	applied	\N	\N	\N	\N	106821	106821	274559
12848	13801	39	applied	\N	\N	\N	\N	106822	106822	274560
12848	13802	40	applied	\N	\N	\N	\N	106823	106823	274561
12848	13803	41	applied	\N	\N	\N	\N	106824	106824	274562
12848	13804	42	applied	\N	\N	\N	\N	106825	106825	274563
12848	13806	44	applied	\N	\N	\N	\N	106827	106827	274565
12848	13807	45	applied	\N	\N	\N	\N	106828	106828	274566
12848	13808	46	applied	\N	\N	\N	\N	106829	106829	274567
12848	13809	47	applied	\N	\N	\N	\N	106830	106830	274568
12848	13810	48	applied	\N	\N	\N	\N	106831	106831	274569
12848	13812	49	applied	\N	\N	\N	\N	106832	106832	274570
12848	13815	50	applied	\N	\N	\N	\N	106833	106833	274571
12848	13817	51	applied	\N	\N	\N	\N	106834	106834	274572
12848	13819	52	applied	\N	\N	\N	\N	106835	106835	274573
12848	13733	53	applied	\N	\N	\N	\N	106836	106836	274574
12848	13735	54	applied	\N	\N	\N	\N	106837	106837	274575
12848	13743	55	applied	\N	\N	1000000000	\N	106838	106838	274576
12848	13757	56	applied	\N	\N	\N	\N	106839	106839	274577
12848	13764	57	applied	\N	\N	\N	\N	106840	106840	274578
12848	13736	58	applied	\N	\N	\N	\N	106841	106841	274579
12848	13738	59	applied	\N	\N	\N	\N	106842	106842	274580
12848	13744	61	applied	\N	\N	\N	\N	106844	106844	274582
12848	13745	62	applied	\N	\N	\N	\N	106845	106845	274583
12848	13748	63	applied	\N	\N	\N	\N	106846	106846	274584
12848	13749	64	applied	\N	\N	\N	\N	106847	106847	274585
12848	13752	65	applied	\N	\N	\N	\N	106848	106848	274586
12848	13753	66	applied	\N	\N	\N	\N	106849	106849	274587
12848	13755	67	applied	\N	\N	\N	\N	106850	106850	274588
12848	13758	68	applied	\N	\N	\N	\N	106851	106851	274589
12848	13760	69	applied	\N	\N	\N	\N	106852	106852	274590
12848	13765	70	applied	\N	\N	\N	\N	106853	106853	274591
12848	13766	71	applied	\N	\N	\N	\N	106854	106854	274592
12848	13767	72	applied	\N	\N	\N	\N	106855	106855	274593
12848	13769	73	applied	\N	\N	\N	\N	106856	106856	274594
12848	13772	74	applied	\N	\N	\N	\N	106857	106857	274595
12848	13775	75	applied	\N	\N	\N	\N	106858	106858	274596
12848	13777	76	applied	\N	\N	\N	\N	106859	106859	274597
12848	13781	78	applied	\N	\N	\N	\N	106861	106861	274599
12848	13784	79	applied	\N	\N	\N	\N	106862	106862	274600
12848	13786	80	applied	\N	\N	\N	\N	106863	106863	274601
12848	13811	81	applied	\N	\N	1000000000	\N	106864	106864	274602
12848	13813	82	applied	\N	\N	1000000000	\N	106865	106865	274603
12848	13814	83	applied	\N	\N	\N	\N	106866	106866	274604
12848	13816	84	applied	\N	\N	\N	\N	106867	106867	274605
12848	13818	85	applied	\N	\N	\N	\N	106868	106868	274606
12848	13820	86	applied	\N	\N	\N	\N	106869	106869	274607
12848	13770	87	applied	\N	\N	\N	\N	106870	106870	274608
12848	13774	88	applied	\N	\N	\N	\N	106871	106871	274609
12848	13782	89	applied	\N	\N	\N	\N	106872	106872	274610
12850	13821	0	applied	\N	\N	\N	\N	106875	106875	274613
12850	13822	1	applied	\N	\N	\N	\N	106876	106876	274614
12855	13827	0	applied	\N	\N	\N	\N	106885	106885	274623
12855	13828	1	applied	\N	\N	\N	\N	106886	106886	274624
12860	13834	1	applied	\N	\N	\N	\N	106900	106900	274638
12863	13835	0	applied	\N	\N	\N	\N	106910	106910	274648
12863	13836	1	applied	\N	\N	\N	\N	106911	106911	274649
12863	13837	2	applied	\N	\N	\N	\N	106912	106912	274650
12863	13834	3	applied	\N	\N	\N	\N	106913	106913	274651
12863	13838	4	applied	\N	\N	1000000000	\N	106914	106914	274652
12863	13839	5	applied	\N	\N	\N	\N	106915	106915	274653
12863	13840	6	applied	\N	\N	\N	\N	106916	106916	274654
12863	13841	7	applied	\N	\N	\N	\N	106917	106917	274655
12863	13842	8	applied	\N	\N	\N	\N	106918	106918	274656
12864	13843	0	applied	\N	\N	\N	\N	106919	106919	274657
12864	13844	1	applied	\N	\N	\N	\N	106920	106920	274658
12864	13845	2	applied	\N	\N	\N	\N	106921	106921	274659
12864	13846	3	applied	\N	\N	\N	\N	106922	106922	274660
12864	13848	5	applied	\N	\N	\N	\N	106924	106924	274662
12864	13849	6	applied	\N	\N	\N	\N	106925	106925	274663
12869	13864	0	applied	\N	\N	\N	\N	106955	106955	274693
12869	13865	1	applied	\N	\N	\N	\N	106956	106956	274694
12869	13866	2	applied	\N	\N	\N	\N	106957	106957	274695
12869	13867	3	applied	\N	\N	\N	\N	106958	106958	274696
12869	13868	4	applied	\N	\N	\N	\N	106959	106959	274697
12869	13869	5	applied	\N	\N	\N	\N	106960	106960	274698
12869	13870	6	applied	\N	\N	\N	\N	106961	106961	274699
12869	13871	7	applied	\N	\N	\N	\N	106962	106962	274700
12869	13872	8	applied	\N	\N	\N	\N	106963	106963	274701
12874	13877	0	applied	\N	\N	\N	\N	106972	106972	274710
12874	13878	1	applied	\N	\N	\N	\N	106973	106973	274711
12970	14009	1	applied	\N	\N	\N	\N	107391	107391	275129
12974	14008	0	applied	\N	\N	\N	\N	107398	107398	275136
12974	14009	1	applied	\N	\N	\N	\N	107399	107399	275137
12977	14012	0	applied	\N	\N	\N	\N	107405	107405	275143
12977	14013	1	applied	\N	\N	\N	\N	107406	107406	275144
12977	14014	2	applied	\N	\N	\N	\N	107407	107407	275145
12979	14015	0	applied	\N	\N	\N	\N	107411	107411	275149
12987	14021	0	applied	\N	\N	\N	\N	107425	107425	275163
12987	14022	1	applied	\N	\N	\N	\N	107426	107426	275164
12989	14023	0	applied	\N	\N	\N	\N	107431	107431	275169
12989	14024	1	applied	\N	\N	\N	\N	107432	107432	275170
12848	13762	16	applied	\N	\N	\N	\N	106800	106800	274538
12848	13763	18	applied	\N	\N	\N	\N	106801	106801	274539
12880	13836	8	applied	\N	\N	\N	\N	106998	106998	274736
12880	13837	9	applied	\N	\N	\N	\N	106999	106999	274737
12880	13843	10	applied	\N	\N	\N	\N	107000	107000	274738
12880	13844	11	applied	\N	\N	\N	\N	107001	107001	274739
12880	13845	12	applied	\N	\N	\N	\N	107002	107002	274740
12880	13850	13	applied	\N	\N	\N	\N	107003	107003	274741
12880	13851	14	applied	\N	\N	\N	\N	107004	107004	274742
12880	13852	15	applied	\N	\N	\N	\N	107005	107005	274743
12880	13856	16	applied	\N	\N	\N	\N	107006	107006	274744
12880	13857	17	applied	\N	\N	\N	\N	107007	107007	274745
12880	13858	18	applied	\N	\N	\N	\N	107008	107008	274746
12880	13859	19	applied	\N	\N	\N	\N	107009	107009	274747
12880	13864	20	applied	\N	\N	\N	\N	107010	107010	274748
12880	13866	22	applied	\N	\N	\N	\N	107012	107012	274750
12880	13867	23	applied	\N	\N	\N	\N	107013	107013	274751
12880	13873	24	applied	\N	\N	\N	\N	107014	107014	274752
12880	13875	25	applied	\N	\N	\N	\N	107015	107015	274753
12880	13877	26	applied	\N	\N	\N	\N	107016	107016	274754
12880	13878	27	applied	\N	\N	\N	\N	107017	107017	274755
12880	13881	28	applied	\N	\N	\N	\N	107018	107018	274756
12880	13869	29	applied	\N	\N	\N	\N	107019	107019	274757
12880	13822	30	applied	\N	\N	\N	\N	107020	107020	274758
12880	13838	31	applied	\N	\N	1000000000	\N	107021	107021	274759
12880	13839	32	applied	\N	\N	\N	\N	107022	107022	274760
12880	13824	33	applied	\N	\N	\N	\N	107023	107023	274761
12880	13826	34	applied	\N	\N	\N	\N	107024	107024	274762
12880	13828	35	applied	\N	\N	\N	\N	107025	107025	274763
12880	13831	36	applied	\N	\N	\N	\N	107026	107026	274764
12880	13832	37	applied	\N	\N	\N	\N	107027	107027	274765
12880	13840	39	applied	\N	\N	\N	\N	107029	107029	274767
12880	13841	40	applied	\N	\N	\N	\N	107030	107030	274768
12880	13842	41	applied	\N	\N	\N	\N	107031	107031	274769
12880	13846	42	applied	\N	\N	\N	\N	107032	107032	274770
12880	13847	43	applied	\N	\N	1000000000	\N	107033	107033	274771
12880	13848	44	applied	\N	\N	\N	\N	107034	107034	274772
12880	13849	45	applied	\N	\N	\N	\N	107035	107035	274773
12880	13853	46	applied	\N	\N	\N	\N	107036	107036	274774
12880	13854	47	applied	\N	\N	\N	\N	107037	107037	274775
12880	13855	48	applied	\N	\N	\N	\N	107038	107038	274776
12880	13860	49	applied	\N	\N	\N	\N	107039	107039	274777
12880	13861	50	applied	\N	\N	\N	\N	107040	107040	274778
12880	13862	51	applied	\N	\N	\N	\N	107041	107041	274779
12880	13863	52	applied	\N	\N	\N	\N	107042	107042	274780
12880	13868	54	applied	\N	\N	\N	\N	107043	107043	274781
12880	13870	55	applied	\N	\N	\N	\N	107044	107044	274782
12880	13872	57	applied	\N	\N	\N	\N	107046	107046	274784
12880	13874	58	applied	\N	\N	\N	\N	107047	107047	274785
12880	13876	59	applied	\N	\N	\N	\N	107048	107048	274786
12880	13879	60	applied	\N	\N	\N	\N	107049	107049	274787
12880	13880	61	applied	\N	\N	\N	\N	107050	107050	274788
12880	13882	62	applied	\N	\N	\N	\N	107051	107051	274789
12882	13885	0	applied	\N	\N	\N	\N	107054	107054	274792
12882	13886	1	applied	\N	\N	\N	\N	107055	107055	274793
12883	13885	0	applied	\N	\N	\N	\N	107056	107056	274794
12883	13886	1	applied	\N	\N	\N	\N	107057	107057	274795
12885	13887	0	applied	\N	\N	\N	\N	107058	107058	274796
12885	13888	1	applied	\N	\N	\N	\N	107059	107059	274797
12886	13887	0	applied	\N	\N	\N	\N	107060	107060	274798
12886	13888	1	applied	\N	\N	\N	\N	107061	107061	274799
12887	13889	0	applied	\N	\N	\N	\N	107062	107062	274800
12887	13890	1	applied	\N	\N	\N	\N	107063	107063	274801
12888	13890	1	applied	\N	\N	\N	\N	107065	107065	274803
12890	13889	0	applied	\N	\N	\N	\N	107068	107068	274806
12890	13890	1	applied	\N	\N	\N	\N	107069	107069	274807
12891	13889	0	applied	\N	\N	\N	\N	107070	107070	274808
12891	13890	1	applied	\N	\N	\N	\N	107071	107071	274809
12894	13893	0	applied	\N	\N	\N	\N	107074	107074	274812
12894	13894	1	applied	\N	\N	\N	\N	107075	107075	274813
12896	13893	0	applied	\N	\N	\N	\N	107076	107076	274814
12896	13894	1	applied	\N	\N	\N	\N	107077	107077	274815
12898	13897	0	applied	\N	\N	\N	\N	107080	107080	274818
12898	13898	1	applied	\N	\N	\N	\N	107081	107081	274819
12899	13897	0	applied	\N	\N	\N	\N	107082	107082	274820
12899	13898	1	applied	\N	\N	\N	\N	107083	107083	274821
12901	13899	0	applied	\N	\N	\N	\N	107086	107086	274824
12901	13900	1	applied	\N	\N	\N	\N	107087	107087	274825
12906	13907	0	applied	\N	\N	\N	\N	107102	107102	274840
12906	13909	2	applied	\N	\N	\N	\N	107104	107104	274842
12906	13910	3	applied	\N	\N	\N	\N	107105	107105	274843
12914	13922	0	applied	\N	\N	\N	\N	107138	107138	274876
12914	13923	1	applied	\N	\N	\N	\N	107139	107139	274877
12916	13881	0	applied	\N	\N	\N	\N	107142	107142	274880
12916	13883	1	applied	\N	\N	\N	\N	107143	107143	274881
12916	13885	2	applied	\N	\N	\N	\N	107144	107144	274882
12916	13887	3	applied	\N	\N	\N	\N	107145	107145	274883
12916	13889	4	applied	\N	\N	\N	\N	107146	107146	274884
12916	13891	5	applied	\N	\N	\N	\N	107147	107147	274885
12916	13893	6	applied	\N	\N	\N	\N	107148	107148	274886
12916	13895	7	applied	\N	\N	\N	\N	107149	107149	274887
12916	13897	8	applied	\N	\N	\N	\N	107150	107150	274888
12916	13899	9	applied	\N	\N	\N	\N	107151	107151	274889
12916	13901	10	applied	\N	\N	\N	\N	107152	107152	274890
12916	13902	11	applied	\N	\N	\N	\N	107153	107153	274891
12916	13907	13	applied	\N	\N	\N	\N	107155	107155	274893
12916	13908	14	applied	\N	\N	\N	\N	107156	107156	274894
12916	13911	16	applied	\N	\N	\N	\N	107157	107157	274895
12916	13914	17	applied	\N	\N	\N	\N	107158	107158	274896
12916	13915	18	applied	\N	\N	\N	\N	107159	107159	274897
12916	13916	19	applied	\N	\N	\N	\N	107160	107160	274898
12916	13917	20	applied	\N	\N	\N	\N	107161	107161	274899
12916	13922	21	applied	\N	\N	\N	\N	107162	107162	274900
12916	13882	22	applied	\N	\N	\N	\N	107163	107163	274901
12916	13884	23	applied	\N	\N	\N	\N	107164	107164	274902
12916	13886	24	applied	\N	\N	\N	\N	107165	107165	274903
12916	13888	25	applied	\N	\N	\N	\N	107166	107166	274904
12916	13890	26	applied	\N	\N	\N	\N	107167	107167	274905
12916	13892	27	applied	\N	\N	\N	\N	107168	107168	274906
12916	13894	28	applied	\N	\N	\N	\N	107169	107169	274907
12916	13896	29	applied	\N	\N	\N	\N	107170	107170	274908
12874	13880	3	applied	\N	\N	\N	\N	106975	106975	274713
12880	13835	7	applied	\N	\N	\N	\N	106997	106997	274735
12904	13904	3	applied	\N	\N	\N	\N	107099	107099	274837
12905	13905	0	applied	\N	\N	\N	\N	107100	107100	274838
12905	13906	1	applied	\N	\N	\N	\N	107101	107101	274839
12908	13911	0	applied	\N	\N	\N	\N	107110	107110	274848
12908	13912	1	applied	\N	\N	\N	\N	107111	107111	274849
12910	13913	0	applied	\N	\N	\N	\N	107113	107113	274851
12911	13914	0	applied	\N	\N	\N	\N	107114	107114	274852
12911	13915	1	applied	\N	\N	\N	\N	107115	107115	274853
12911	13916	2	applied	\N	\N	\N	\N	107116	107116	274854
12911	13918	4	applied	\N	\N	\N	\N	107118	107118	274856
12911	13919	5	applied	\N	\N	\N	\N	107119	107119	274857
12911	13920	6	applied	\N	\N	\N	\N	107120	107120	274858
12911	13921	7	applied	\N	\N	\N	\N	107121	107121	274859
12916	13900	31	applied	\N	\N	\N	\N	107172	107172	274910
12916	13903	32	applied	\N	\N	\N	\N	107173	107173	274911
12916	13904	33	applied	\N	\N	\N	\N	107174	107174	274912
12916	13906	34	applied	\N	\N	\N	\N	107175	107175	274913
12916	13909	35	applied	\N	\N	\N	\N	107176	107176	274914
12916	13910	36	applied	\N	\N	\N	\N	107177	107177	274915
12916	13912	37	applied	\N	\N	\N	\N	107178	107178	274916
12916	13913	38	applied	\N	\N	\N	\N	107179	107179	274917
12916	13918	39	applied	\N	\N	\N	\N	107180	107180	274918
12916	13919	40	applied	\N	\N	\N	\N	107181	107181	274919
12916	13920	41	applied	\N	\N	\N	\N	107182	107182	274920
12916	13921	42	applied	\N	\N	\N	\N	107183	107183	274921
12924	13935	1	applied	\N	\N	\N	\N	107204	107204	274942
12929	13942	0	applied	\N	\N	\N	\N	107217	107217	274955
12929	13943	1	applied	\N	\N	\N	\N	107218	107218	274956
12931	13942	0	applied	\N	\N	\N	\N	107280	107280	275018
12931	13943	1	applied	\N	\N	\N	\N	107281	107281	275019
12933	13944	0	applied	\N	\N	\N	\N	107284	107284	275022
12933	13945	1	applied	\N	\N	\N	\N	107285	107285	275023
12936	13948	0	applied	\N	\N	\N	\N	107296	107296	275034
12936	13949	1	applied	\N	\N	\N	\N	107297	107297	275035
12936	13950	2	applied	\N	\N	\N	\N	107298	107298	275036
12936	13951	3	applied	\N	\N	\N	\N	107299	107299	275037
12936	13952	4	applied	\N	\N	\N	\N	107300	107300	275038
12936	13953	5	applied	\N	\N	\N	\N	107301	107301	275039
12936	13954	6	applied	\N	\N	\N	\N	107302	107302	275040
12936	13955	7	applied	\N	\N	\N	\N	107303	107303	275041
12938	13956	0	applied	\N	\N	\N	\N	107312	107312	275050
12943	13962	0	applied	\N	\N	\N	\N	107321	107321	275059
12943	13961	2	applied	\N	\N	\N	\N	107322	107322	275060
12943	13963	3	applied	\N	\N	\N	\N	107323	107323	275061
12945	13964	0	applied	\N	\N	\N	\N	107327	107327	275065
12945	13965	1	applied	\N	\N	\N	\N	107328	107328	275066
12949	13970	0	applied	\N	\N	\N	\N	107335	107335	275073
12949	13971	1	applied	\N	\N	\N	\N	107336	107336	275074
12954	13980	0	applied	\N	\N	\N	\N	107349	107349	275087
12954	13981	1	applied	\N	\N	\N	\N	107350	107350	275088
12959	13986	0	applied	\N	\N	\N	\N	107358	107358	275096
12959	13987	1	applied	\N	\N	\N	\N	107359	107359	275097
12962	13994	0	applied	\N	\N	\N	\N	107366	107366	275104
12962	13995	1	applied	\N	\N	\N	\N	107367	107367	275105
12965	14002	0	applied	\N	\N	\N	\N	107380	107380	275118
12965	14003	1	applied	\N	\N	\N	\N	107381	107381	275119
12968	14006	0	applied	\N	\N	\N	\N	107386	107386	275124
12973	14008	0	applied	\N	\N	\N	\N	107396	107396	275134
12973	14009	1	applied	\N	\N	\N	\N	107397	107397	275135
12976	14008	0	applied	\N	\N	\N	\N	107402	107402	275140
12976	14010	1	applied	\N	\N	\N	\N	107403	107403	275141
12976	14009	2	applied	\N	\N	\N	\N	107404	107404	275142
12982	14017	0	applied	\N	\N	\N	\N	107417	107417	275155
12982	14018	1	applied	\N	\N	\N	\N	107418	107418	275156
12986	14021	0	applied	\N	\N	\N	\N	107423	107423	275161
12986	14022	1	applied	\N	\N	\N	\N	107424	107424	275162
12988	14023	0	applied	\N	\N	\N	\N	107427	107427	275165
12988	14024	1	applied	\N	\N	\N	\N	107428	107428	275166
12988	14025	2	applied	\N	\N	\N	\N	107429	107429	275167
12988	14026	3	applied	\N	\N	\N	\N	107430	107430	275168
12996	14033	0	applied	\N	\N	\N	\N	107453	107453	275191
12996	14034	1	applied	\N	\N	\N	\N	107454	107454	275192
12996	14035	2	applied	\N	\N	\N	\N	107455	107455	275193
12997	14033	0	applied	\N	\N	\N	\N	107457	107457	275195
12997	14034	1	applied	\N	\N	\N	\N	107458	107458	275196
12997	14035	2	applied	\N	\N	\N	\N	107459	107459	275197
12997	14036	3	applied	\N	\N	\N	\N	107460	107460	275198
13000	14037	0	applied	\N	\N	\N	\N	107467	107467	275205
13000	14038	1	applied	\N	\N	\N	\N	107468	107468	275206
13004	14040	0	applied	\N	\N	\N	\N	107478	107478	275216
13004	14039	1	applied	\N	\N	\N	\N	107479	107479	275217
13007	14046	0	applied	\N	\N	\N	\N	107490	107490	275228
13007	14047	1	applied	\N	\N	\N	\N	107491	107491	275229
13007	14048	2	applied	\N	\N	\N	\N	107492	107492	275230
13007	14049	3	applied	\N	\N	\N	\N	107493	107493	275231
13007	14050	4	applied	\N	\N	\N	\N	107494	107494	275232
13007	14051	5	applied	\N	\N	\N	\N	107495	107495	275233
13010	14054	0	applied	\N	\N	\N	\N	107500	107500	275238
13010	14055	1	applied	\N	\N	\N	\N	107501	107501	275239
13014	14061	1	applied	\N	\N	\N	\N	107509	107509	275247
13017	14063	1	applied	\N	\N	\N	\N	107518	107518	275254
13017	14062	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	107517	107517	\N
13017	14064	2	applied	\N	\N	\N	\N	107519	107519	275255
13017	14065	3	applied	\N	\N	\N	\N	107520	107520	275256
13017	14066	4	applied	\N	\N	\N	\N	107521	107521	275257
13020	14073	0	applied	\N	\N	\N	\N	107531	107531	275266
13020	14074	1	applied	\N	\N	\N	\N	107532	107532	275267
13020	14075	2	applied	\N	\N	\N	\N	107533	107533	275268
13024	14078	0	applied	\N	\N	\N	\N	107541	107541	275276
13024	14079	1	applied	\N	\N	\N	\N	107542	107542	275277
13026	14078	0	applied	\N	\N	\N	\N	107543	107543	275278
13026	14080	1	applied	\N	\N	\N	\N	107544	107544	275279
13026	14079	2	applied	\N	\N	\N	\N	107545	107545	275280
13026	14081	3	applied	\N	\N	\N	\N	107546	107546	275281
13029	14084	0	applied	\N	\N	\N	\N	107553	107553	275288
13029	14086	2	applied	\N	\N	\N	\N	107555	107555	275290
13029	14087	3	applied	\N	\N	\N	\N	107556	107556	275291
13029	14088	4	applied	\N	\N	\N	\N	107557	107557	275292
13032	14096	0	applied	\N	\N	\N	\N	107570	107570	275305
12904	13902	1	applied	\N	\N	\N	\N	107097	107097	274835
12904	13903	2	applied	\N	\N	\N	\N	107098	107098	274836
12917	13927	3	applied	\N	\N	\N	\N	107188	107188	274926
12919	13928	0	applied	\N	\N	\N	\N	107193	107193	274931
12919	13929	1	applied	\N	\N	\N	\N	107194	107194	274932
12930	13883	0	applied	\N	\N	\N	\N	107219	107219	274957
12930	13885	1	applied	\N	\N	\N	\N	107220	107220	274958
12930	13887	2	applied	\N	\N	\N	\N	107221	107221	274959
12930	13889	3	applied	\N	\N	\N	\N	107222	107222	274960
12930	13891	4	applied	\N	\N	\N	\N	107223	107223	274961
12930	13893	5	applied	\N	\N	\N	\N	107224	107224	274962
12930	13895	6	applied	\N	\N	\N	\N	107225	107225	274963
12930	13897	7	applied	\N	\N	\N	\N	107226	107226	274964
12930	13899	8	applied	\N	\N	\N	\N	107227	107227	274965
12930	13901	9	applied	\N	\N	\N	\N	107228	107228	274966
12930	13902	10	applied	\N	\N	\N	\N	107229	107229	274967
12930	13905	11	applied	\N	\N	\N	\N	107230	107230	274968
12930	13907	12	applied	\N	\N	\N	\N	107231	107231	274969
12930	13911	14	applied	\N	\N	\N	\N	107233	107233	274971
12930	13914	15	applied	\N	\N	\N	\N	107234	107234	274972
12930	13915	16	applied	\N	\N	\N	\N	107235	107235	274973
12930	13916	17	applied	\N	\N	\N	\N	107236	107236	274974
12930	13917	18	applied	\N	\N	\N	\N	107237	107237	274975
12930	13922	19	applied	\N	\N	\N	\N	107238	107238	274976
12930	13924	20	applied	\N	\N	\N	\N	107239	107239	274977
12930	13925	21	applied	\N	\N	\N	\N	107240	107240	274978
12930	13928	22	applied	\N	\N	\N	\N	107241	107241	274979
12930	13930	23	applied	\N	\N	\N	\N	107242	107242	274980
12930	13932	24	applied	\N	\N	\N	\N	107243	107243	274981
12930	13934	25	applied	\N	\N	\N	\N	107244	107244	274982
12930	13936	26	applied	\N	\N	\N	\N	107245	107245	274983
12930	13937	27	applied	\N	\N	\N	\N	107246	107246	274984
12930	13940	28	applied	\N	\N	\N	\N	107247	107247	274985
12930	13942	29	applied	\N	\N	\N	\N	107248	107248	274986
12930	13886	31	applied	\N	\N	\N	\N	107250	107250	274988
12930	13888	32	applied	\N	\N	\N	\N	107251	107251	274989
12930	13890	33	applied	\N	\N	\N	\N	107252	107252	274990
12930	13892	34	applied	\N	\N	\N	\N	107253	107253	274991
12930	13894	35	applied	\N	\N	\N	\N	107254	107254	274992
12930	13896	36	applied	\N	\N	\N	\N	107255	107255	274993
12930	13898	37	applied	\N	\N	\N	\N	107256	107256	274994
12930	13900	38	applied	\N	\N	\N	\N	107257	107257	274995
12930	13903	39	applied	\N	\N	\N	\N	107258	107258	274996
12930	13904	40	applied	\N	\N	\N	\N	107259	107259	274997
12930	13906	41	applied	\N	\N	\N	\N	107260	107260	274998
12930	13909	42	applied	\N	\N	\N	\N	107261	107261	274999
12930	13910	43	applied	\N	\N	\N	\N	107262	107262	275000
12930	13912	44	applied	\N	\N	\N	\N	107263	107263	275001
12930	13913	45	applied	\N	\N	\N	\N	107264	107264	275002
12930	13918	46	applied	\N	\N	\N	\N	107265	107265	275003
12930	13920	48	applied	\N	\N	\N	\N	107267	107267	275005
12930	13921	49	applied	\N	\N	\N	\N	107268	107268	275006
12930	13923	50	applied	\N	\N	\N	\N	107269	107269	275007
12930	13926	51	applied	\N	\N	\N	\N	107270	107270	275008
12930	13927	52	applied	\N	\N	\N	\N	107271	107271	275009
12930	13929	53	applied	\N	\N	\N	\N	107272	107272	275010
12930	13931	54	applied	\N	\N	\N	\N	107273	107273	275011
12930	13933	55	applied	\N	\N	\N	\N	107274	107274	275012
12930	13935	56	applied	\N	\N	\N	\N	107275	107275	275013
12930	13938	57	applied	\N	\N	\N	\N	107276	107276	275014
12930	13939	58	applied	\N	\N	\N	\N	107277	107277	275015
12930	13941	59	applied	\N	\N	\N	\N	107278	107278	275016
12930	13943	60	applied	\N	\N	\N	\N	107279	107279	275017
12939	13958	0	applied	\N	\N	\N	\N	107314	107314	275052
12939	13959	1	applied	\N	\N	\N	\N	107315	107315	275053
12941	13960	0	applied	\N	\N	\N	\N	107318	107318	275056
12946	13964	0	applied	\N	\N	\N	\N	107329	107329	275067
12946	13965	1	applied	\N	\N	\N	\N	107330	107330	275068
12948	13968	0	applied	\N	\N	\N	\N	107333	107333	275071
12948	13969	1	applied	\N	\N	\N	\N	107334	107334	275072
12957	13982	0	applied	\N	\N	\N	\N	107354	107354	275092
12957	13983	1	applied	\N	\N	\N	\N	107355	107355	275093
12958	13984	0	applied	\N	\N	\N	\N	107356	107356	275094
12958	13985	1	applied	\N	\N	\N	\N	107357	107357	275095
12961	13988	0	applied	\N	\N	\N	\N	107360	107360	275098
12961	13989	1	applied	\N	\N	\N	\N	107361	107361	275099
12961	13990	2	applied	\N	\N	\N	\N	107362	107362	275100
12961	13991	3	applied	\N	\N	\N	\N	107363	107363	275101
12961	13992	4	applied	\N	\N	\N	\N	107364	107364	275102
12961	13993	5	applied	\N	\N	\N	\N	107365	107365	275103
12967	14006	0	applied	\N	\N	\N	\N	107384	107384	275122
12967	14007	1	applied	\N	\N	\N	\N	107385	107385	275123
12969	14007	1	applied	\N	\N	\N	\N	107389	107389	275127
12972	14008	0	applied	\N	\N	\N	\N	107394	107394	275132
12972	14009	1	applied	\N	\N	\N	\N	107395	107395	275133
12981	14017	0	applied	\N	\N	\N	\N	107415	107415	275153
12981	14018	1	applied	\N	\N	\N	\N	107416	107416	275154
12985	13788	0	applied	\N	\N	\N	\N	107422	107422	275160
12992	14029	0	applied	\N	\N	\N	\N	107441	107441	275179
12992	14030	1	applied	\N	\N	\N	\N	107442	107442	275180
12992	14031	2	applied	\N	\N	\N	\N	107443	107443	275181
12992	14032	3	applied	\N	\N	\N	\N	107444	107444	275182
12995	14033	0	applied	\N	\N	\N	\N	107449	107449	275187
12995	14034	1	applied	\N	\N	\N	\N	107450	107450	275188
12995	14035	2	applied	\N	\N	\N	\N	107451	107451	275189
12995	14036	3	applied	\N	\N	\N	\N	107452	107452	275190
12999	14037	0	applied	\N	\N	\N	\N	107465	107465	275203
12999	14038	1	applied	\N	\N	\N	\N	107466	107466	275204
13003	14041	1	applied	\N	\N	\N	\N	107473	107473	275211
13003	14042	2	applied	\N	\N	\N	\N	107474	107474	275212
13032	14097	1	applied	\N	\N	\N	\N	107571	107571	275306
13035	14098	0	applied	\N	\N	\N	\N	107577	107577	275311
13035	14099	1	applied	\N	\N	\N	\N	107578	107578	275312
13035	14100	2	applied	\N	\N	\N	\N	107579	107579	275313
13035	14101	3	applied	\N	\N	\N	\N	107580	107580	275314
13035	14102	4	applied	\N	\N	\N	\N	107581	107581	275315
13035	14103	5	applied	\N	\N	\N	\N	107582	107582	275316
13035	14104	6	applied	\N	\N	\N	\N	107583	107583	275317
13035	14105	7	applied	\N	\N	\N	\N	107584	107584	275318
13035	14106	8	applied	\N	\N	\N	\N	107585	107585	275319
13035	14107	9	applied	\N	\N	\N	\N	107586	107586	275320
13035	14108	10	applied	\N	\N	\N	\N	107587	107587	275321
12917	13924	0	applied	\N	\N	\N	\N	107185	107185	274923
12917	13925	1	applied	\N	\N	\N	\N	107186	107186	274924
12928	13943	1	applied	\N	\N	\N	\N	107216	107216	274954
12932	13944	0	applied	\N	\N	\N	\N	107282	107282	275020
12932	13945	1	applied	\N	\N	\N	\N	107283	107283	275021
12940	13958	0	applied	\N	\N	\N	\N	107316	107316	275054
12940	13959	1	applied	\N	\N	\N	\N	107317	107317	275055
12942	13960	0	applied	\N	\N	\N	\N	107320	107320	275058
12947	13966	0	applied	\N	\N	\N	\N	107331	107331	275069
12947	13967	1	applied	\N	\N	\N	\N	107332	107332	275070
12951	13972	0	applied	\N	\N	\N	\N	107341	107341	275079
12951	13973	1	applied	\N	\N	\N	\N	107342	107342	275080
12951	13974	2	applied	\N	\N	\N	\N	107343	107343	275081
12951	13975	3	applied	\N	\N	\N	\N	107344	107344	275082
12953	13979	1	applied	\N	\N	\N	\N	107348	107348	275086
12956	13983	0	applied	\N	\N	\N	\N	107353	107353	275091
12964	13996	0	applied	\N	\N	\N	\N	107374	107374	275112
12964	13997	1	applied	\N	\N	\N	\N	107375	107375	275113
12964	13998	2	applied	\N	\N	\N	\N	107376	107376	275114
12964	13999	3	applied	\N	\N	\N	\N	107377	107377	275115
12964	14000	4	applied	\N	\N	\N	\N	107378	107378	275116
12964	14001	5	applied	\N	\N	\N	\N	107379	107379	275117
12966	14004	0	applied	\N	\N	\N	\N	107382	107382	275120
12966	14005	1	applied	\N	\N	\N	\N	107383	107383	275121
12971	14008	0	applied	\N	\N	\N	\N	107392	107392	275130
12971	14009	1	applied	\N	\N	\N	\N	107393	107393	275131
12975	14010	0	applied	\N	\N	\N	\N	107400	107400	275138
12975	14011	1	applied	\N	\N	\N	\N	107401	107401	275139
12978	14012	0	applied	\N	\N	\N	\N	107408	107408	275146
12978	14013	1	applied	\N	\N	\N	\N	107409	107409	275147
12980	14017	0	applied	\N	\N	\N	\N	107413	107413	275151
12980	14018	1	applied	\N	\N	\N	\N	107414	107414	275152
12983	14018	0	applied	\N	\N	\N	\N	107419	107419	275157
12984	14019	0	applied	\N	\N	\N	\N	107420	107420	275158
12984	14020	1	applied	\N	\N	\N	\N	107421	107421	275159
12990	14023	0	applied	\N	\N	\N	\N	107435	107435	275173
12990	14024	1	applied	\N	\N	\N	\N	107436	107436	275174
12990	14025	2	applied	\N	\N	\N	\N	107437	107437	275175
12990	14026	3	applied	\N	\N	\N	\N	107438	107438	275176
12991	14027	0	applied	\N	\N	\N	\N	107439	107439	275177
12991	14028	1	applied	\N	\N	\N	\N	107440	107440	275178
12994	14033	0	applied	\N	\N	\N	\N	107445	107445	275183
12994	14034	1	applied	\N	\N	\N	\N	107446	107446	275184
12994	14035	2	applied	\N	\N	\N	\N	107447	107447	275185
12994	14036	3	applied	\N	\N	\N	\N	107448	107448	275186
13003	14043	3	applied	\N	\N	\N	\N	107475	107475	275213
13003	14045	5	applied	\N	\N	\N	\N	107477	107477	275215
13005	14041	0	applied	\N	\N	\N	\N	107480	107480	275218
13005	14042	1	applied	\N	\N	\N	\N	107481	107481	275219
13005	14043	2	applied	\N	\N	\N	\N	107482	107482	275220
13005	14044	3	applied	\N	\N	\N	\N	107483	107483	275221
13005	14045	4	applied	\N	\N	\N	\N	107484	107484	275222
13006	14041	0	applied	\N	\N	\N	\N	107485	107485	275223
13006	14042	1	applied	\N	\N	\N	\N	107486	107486	275224
13006	14043	2	applied	\N	\N	\N	\N	107487	107487	275225
13006	14044	3	applied	\N	\N	\N	\N	107488	107488	275226
13011	14054	0	applied	\N	\N	\N	\N	107502	107502	275240
13011	14055	1	applied	\N	\N	\N	\N	107503	107503	275241
13012	14056	0	applied	\N	\N	\N	\N	107504	107504	275242
13015	14060	0	applied	\N	\N	\N	\N	107510	107510	275248
13015	14061	1	applied	\N	\N	\N	\N	107511	107511	275249
13022	14076	0	applied	\N	\N	\N	\N	107537	107537	275272
13027	14078	0	applied	\N	\N	\N	\N	107547	107547	275282
13027	14080	1	applied	\N	\N	\N	\N	107548	107548	275283
13027	14079	2	applied	\N	\N	\N	\N	107549	107549	275284
13027	14081	3	applied	\N	\N	\N	\N	107550	107550	275285
13030	14084	0	applied	\N	\N	\N	\N	107558	107558	275293
13030	14085	1	applied	\N	\N	\N	\N	107559	107559	275294
13030	14086	2	applied	\N	\N	\N	\N	107560	107560	275295
13030	14087	3	applied	\N	\N	\N	\N	107561	107561	275296
13030	14088	4	applied	\N	\N	\N	\N	107562	107562	275297
13033	14096	0	applied	\N	\N	\N	\N	107572	107572	275307
13033	14097	1	applied	\N	\N	\N	\N	107573	107573	275308
13036	14116	0	applied	\N	\N	\N	\N	107595	107595	275329
13036	14117	1	applied	\N	\N	\N	\N	107596	107596	275330
13039	14118	0	applied	\N	\N	\N	\N	107603	107603	275337
13039	14119	1	applied	\N	\N	\N	\N	107604	107604	275338
13039	14120	2	applied	\N	\N	\N	\N	107605	107605	275339
13043	14130	1	applied	\N	\N	\N	\N	107631	107631	275365
13043	14131	2	applied	\N	\N	\N	\N	107632	107632	275366
13043	14132	3	applied	\N	\N	\N	\N	107633	107633	275367
13043	14133	4	applied	\N	\N	\N	\N	107634	107634	275368
13043	14134	5	applied	\N	\N	\N	\N	107635	107635	275369
13046	14146	0	applied	\N	\N	\N	\N	107647	107647	275381
13046	14147	1	applied	\N	\N	\N	\N	107648	107648	275382
13046	14148	2	applied	\N	\N	\N	\N	107649	107649	275383
13048	14149	0	applied	\N	\N	\N	\N	107650	107650	275384
13048	14150	1	applied	\N	\N	1000000000	\N	107651	107651	275385
13048	14151	2	applied	\N	\N	\N	\N	107652	107652	275386
13048	14152	3	applied	\N	\N	\N	\N	107653	107653	275387
13048	14153	4	applied	\N	\N	\N	\N	107654	107654	275388
13052	14149	0	applied	\N	\N	\N	\N	107670	107670	275404
13052	14151	2	applied	\N	\N	\N	\N	107672	107672	275406
13052	14152	3	applied	\N	\N	\N	\N	107673	107673	275407
13052	14153	4	applied	\N	\N	\N	\N	107674	107674	275408
13055	14158	0	applied	\N	\N	\N	\N	107679	107679	275413
13055	14159	1	applied	\N	\N	\N	\N	107680	107680	275414
13055	14160	2	applied	\N	\N	\N	\N	107681	107681	275415
13055	14161	3	applied	\N	\N	\N	\N	107682	107682	275416
13055	14162	4	applied	\N	\N	\N	\N	107683	107683	275417
13058	14163	0	applied	\N	\N	\N	\N	107705	107705	275439
13058	14164	1	applied	\N	\N	\N	\N	107706	107706	275440
13058	14165	2	applied	\N	\N	\N	\N	107707	107707	275441
13058	14166	3	applied	\N	\N	\N	\N	107708	107708	275442
13058	14167	4	applied	\N	\N	\N	\N	107709	107709	275443
13058	14168	5	applied	\N	\N	\N	\N	107710	107710	275444
13058	14169	6	applied	\N	\N	\N	\N	107711	107711	275445
13058	14170	7	applied	\N	\N	\N	\N	107712	107712	275446
13058	14171	8	applied	\N	\N	\N	\N	107713	107713	275447
13058	14172	9	applied	\N	\N	\N	\N	107714	107714	275448
13058	14173	10	applied	\N	\N	\N	\N	107715	107715	275449
12926	13938	2	applied	\N	\N	\N	\N	107211	107211	274949
12928	13942	0	applied	\N	\N	\N	\N	107215	107215	274953
12998	14034	1	applied	\N	\N	\N	\N	107462	107462	275200
12998	14035	2	applied	\N	\N	\N	\N	107463	107463	275201
12998	14036	3	applied	\N	\N	\N	\N	107464	107464	275202
13001	14037	0	applied	\N	\N	\N	\N	107469	107469	275207
13001	14038	1	applied	\N	\N	\N	\N	107470	107470	275208
13008	14052	0	applied	\N	\N	\N	\N	107496	107496	275234
13008	14053	1	applied	\N	\N	\N	\N	107497	107497	275235
13013	14057	0	applied	\N	\N	\N	\N	107505	107505	275243
13013	14058	1	applied	\N	\N	\N	\N	107506	107506	275244
13013	14059	2	applied	\N	\N	\N	\N	107507	107507	275245
13018	14067	0	applied	\N	\N	\N	\N	107522	107522	107522
13018	14068	1	applied	\N	\N	\N	\N	107523	107523	275258
13018	14069	2	applied	\N	\N	\N	\N	107524	107524	275259
13018	14070	3	applied	\N	\N	\N	\N	107525	107525	275260
13018	14071	4	applied	\N	\N	\N	\N	107526	107526	275261
13018	14072	5	applied	\N	\N	\N	\N	107527	107527	275262
13021	14073	0	applied	\N	\N	\N	\N	107534	107534	275269
13021	14074	1	applied	\N	\N	\N	\N	107535	107535	275270
13021	14075	2	applied	\N	\N	\N	\N	107536	107536	275271
13023	14076	0	applied	\N	\N	\N	\N	107539	107539	275274
13023	14077	1	applied	\N	\N	\N	\N	107540	107540	275275
13034	14089	1	applied	\N	\N	\N	\N	107575	107575	275309
13034	14073	2	applied	\N	\N	\N	\N	107576	107576	275310
13041	14121	0	applied	\N	\N	\N	\N	107614	107614	275348
13041	14122	1	applied	\N	\N	\N	\N	107615	107615	275349
13041	14123	2	applied	\N	\N	\N	\N	107616	107616	275350
13041	14124	3	applied	\N	\N	\N	\N	107617	107617	275351
13041	14125	4	applied	\N	\N	\N	\N	107618	107618	275352
13041	14126	5	applied	\N	\N	\N	\N	107619	107619	275353
13041	14127	6	applied	\N	\N	\N	\N	107620	107620	275354
13041	14128	7	applied	\N	\N	\N	\N	107621	107621	275355
13044	14135	0	applied	\N	\N	\N	\N	107636	107636	275370
13044	14136	1	applied	\N	\N	\N	\N	107637	107637	275371
13044	14137	2	applied	\N	\N	\N	\N	107638	107638	275372
13049	14149	0	applied	\N	\N	\N	\N	107655	107655	275389
13049	14150	1	applied	\N	\N	1000000000	\N	107656	107656	275390
13049	14151	2	applied	\N	\N	\N	\N	107657	107657	275391
13049	14152	3	applied	\N	\N	\N	\N	107658	107658	275392
13049	14153	4	applied	\N	\N	\N	\N	107659	107659	275393
13053	14154	0	applied	\N	\N	\N	\N	107675	107675	275409
13053	14155	1	applied	\N	\N	\N	\N	107676	107676	275410
13056	14158	0	applied	\N	\N	\N	\N	107684	107684	275418
13056	14159	1	applied	\N	\N	\N	\N	107685	107685	275419
13056	14160	2	applied	\N	\N	\N	\N	107686	107686	275420
13056	14161	3	applied	\N	\N	\N	\N	107687	107687	275421
13058	14174	11	applied	\N	\N	\N	\N	107716	107716	275450
13058	14175	12	applied	\N	\N	\N	\N	107717	107717	275451
13058	14176	13	applied	\N	\N	\N	\N	107718	107718	275452
13058	14177	14	applied	\N	\N	\N	\N	107719	107719	275453
13058	14178	15	applied	\N	\N	\N	\N	107720	107720	275454
13059	14163	0	applied	\N	\N	\N	\N	107721	107721	275455
13059	14164	1	applied	\N	\N	\N	\N	107722	107722	275456
13059	14165	2	applied	\N	\N	\N	\N	107723	107723	275457
13059	14166	3	applied	\N	\N	\N	\N	107724	107724	275458
13059	14167	4	applied	\N	\N	\N	\N	107725	107725	275459
13059	14168	5	applied	\N	\N	\N	\N	107726	107726	275460
13059	14169	6	applied	\N	\N	\N	\N	107727	107727	275461
13059	14170	7	applied	\N	\N	\N	\N	107728	107728	275462
13059	14171	8	applied	\N	\N	\N	\N	107729	107729	275463
13059	14172	9	applied	\N	\N	\N	\N	107730	107730	275464
13059	14173	10	applied	\N	\N	\N	\N	107731	107731	275465
13059	14175	12	applied	\N	\N	\N	\N	107733	107733	275467
13059	14176	13	applied	\N	\N	\N	\N	107734	107734	275468
13059	14177	14	applied	\N	\N	\N	\N	107735	107735	275469
13059	14178	15	applied	\N	\N	\N	\N	107736	107736	275470
13062	14182	0	applied	\N	\N	\N	\N	107756	107756	275490
13062	14183	1	applied	\N	\N	\N	\N	107757	107757	275491
13062	14184	2	applied	\N	\N	\N	\N	107758	107758	275492
13062	14185	3	applied	\N	\N	\N	\N	107759	107759	275493
13062	14186	4	applied	\N	\N	\N	\N	107760	107760	275494
13062	14187	5	applied	\N	\N	\N	\N	107761	107761	275495
13062	14188	6	applied	\N	\N	\N	\N	107762	107762	275496
13063	14182	0	applied	\N	\N	\N	\N	107775	107775	275509
13063	14183	1	applied	\N	\N	\N	\N	107776	107776	275510
13063	14184	2	applied	\N	\N	\N	\N	107777	107777	275511
13063	14185	3	applied	\N	\N	\N	\N	107778	107778	275512
13063	14186	4	applied	\N	\N	\N	\N	107779	107779	275513
13063	14188	6	applied	\N	\N	\N	\N	107781	107781	275515
13063	14189	7	applied	\N	\N	\N	\N	107782	107782	275516
13063	14190	8	applied	\N	\N	\N	\N	107783	107783	275517
13063	14191	9	applied	\N	\N	\N	\N	107784	107784	275518
13063	14192	10	applied	\N	\N	\N	\N	107785	107785	275519
13063	14193	11	applied	\N	\N	\N	\N	107786	107786	275520
13063	14194	12	applied	\N	\N	\N	\N	107787	107787	275521
13063	14195	13	applied	\N	\N	1000000000	\N	107788	107788	275522
13063	14196	14	applied	\N	\N	\N	\N	107789	107789	275523
13063	14197	15	applied	\N	\N	\N	\N	107790	107790	275524
13063	14198	16	applied	\N	\N	\N	\N	107791	107791	275525
13063	14199	17	applied	\N	\N	\N	\N	107792	107792	275526
13063	14200	18	applied	\N	\N	\N	\N	107793	107793	275527
13066	14201	0	applied	\N	\N	\N	\N	107802	107802	275536
13066	14202	1	applied	\N	\N	\N	\N	107803	107803	275537
13066	14203	2	applied	\N	\N	\N	\N	107804	107804	275538
13072	14213	0	applied	\N	\N	\N	\N	107838	107838	275572
13072	14214	2	applied	\N	\N	\N	\N	107839	107839	275573
13072	14215	3	applied	\N	\N	\N	\N	107840	107840	275574
13072	14216	4	applied	\N	\N	\N	\N	107841	107841	275575
13076	14220	0	applied	\N	\N	\N	\N	107850	107850	275584
13076	14221	1	applied	\N	\N	\N	\N	107851	107851	275585
13076	14222	2	applied	\N	\N	\N	\N	107852	107852	275586
13076	14223	3	applied	\N	\N	\N	\N	107853	107853	275587
13079	14224	0	applied	\N	\N	\N	\N	107861	107861	275595
13079	14225	1	applied	\N	\N	\N	\N	107862	107862	275596
13079	14226	2	applied	\N	\N	\N	\N	107863	107863	275597
13083	14227	0	applied	\N	\N	\N	\N	107874	107874	275608
13083	14228	1	applied	\N	\N	\N	\N	107875	107875	275609
13083	14229	2	applied	\N	\N	\N	\N	107876	107876	275610
13083	14230	3	applied	\N	\N	\N	\N	107877	107877	275611
13087	14231	0	applied	\N	\N	\N	\N	107890	107890	275624
12989	14026	3	applied	\N	\N	\N	\N	107434	107434	275172
12998	14033	0	applied	\N	\N	\N	\N	107461	107461	275199
13016	14063	1	applied	\N	\N	\N	\N	107513	107513	275250
13016	14064	2	applied	\N	\N	\N	\N	107514	107514	275251
13016	14065	3	applied	\N	\N	\N	\N	107515	107515	275252
13016	14066	4	applied	\N	\N	\N	\N	107516	107516	275253
13019	14073	0	applied	\N	\N	\N	\N	107528	107528	275263
13019	14074	1	applied	\N	\N	\N	\N	107529	107529	275264
13019	14075	2	applied	\N	\N	\N	\N	107530	107530	275265
13028	14082	0	applied	\N	\N	\N	\N	107551	107551	275286
13028	14083	1	applied	\N	\N	\N	\N	107552	107552	275287
13031	14089	0	applied	\N	\N	\N	\N	107563	107563	275298
13031	14090	1	applied	\N	\N	\N	\N	107564	107564	275299
13031	14091	2	applied	\N	\N	\N	\N	107565	107565	275300
13031	14092	3	applied	\N	\N	\N	\N	107566	107566	275301
13031	14093	4	applied	\N	\N	\N	\N	107567	107567	275302
13031	14094	5	applied	\N	\N	\N	\N	107568	107568	275303
13031	14095	6	applied	\N	\N	\N	\N	107569	107569	275304
13037	14118	0	applied	\N	\N	\N	\N	107597	107597	275331
13037	14119	1	applied	\N	\N	\N	\N	107598	107598	275332
13037	14120	2	applied	\N	\N	\N	\N	107599	107599	275333
13042	14121	0	applied	\N	\N	\N	\N	107622	107622	275356
13042	14122	1	applied	\N	\N	\N	\N	107623	107623	275357
13042	14123	2	applied	\N	\N	\N	\N	107624	107624	275358
13042	14124	3	applied	\N	\N	\N	\N	107625	107625	275359
13042	14125	4	applied	\N	\N	\N	\N	107626	107626	275360
13042	14126	5	applied	\N	\N	\N	\N	107627	107627	275361
13042	14127	6	applied	\N	\N	\N	\N	107628	107628	275362
13042	14128	7	applied	\N	\N	\N	\N	107629	107629	275363
13050	14150	1	applied	\N	\N	1000000000	\N	107661	107661	275395
13050	14151	2	applied	\N	\N	\N	\N	107662	107662	275396
13050	14152	3	applied	\N	\N	\N	\N	107663	107663	275397
13050	14153	4	applied	\N	\N	\N	\N	107664	107664	275398
13067	14201	0	applied	\N	\N	\N	\N	107806	107806	275540
13067	14202	1	applied	\N	\N	\N	\N	107807	107807	275541
13067	14203	2	applied	\N	\N	\N	\N	107808	107808	275542
13067	14204	3	applied	\N	\N	\N	\N	107809	107809	275543
13068	14205	0	applied	\N	\N	1000000000	\N	107810	107810	275544
13068	14206	1	applied	\N	\N	\N	\N	107811	107811	275545
13068	14207	2	applied	\N	\N	\N	\N	107812	107812	275546
13068	14208	3	applied	\N	\N	\N	\N	107813	107813	275547
13068	14209	4	applied	\N	\N	\N	\N	107814	107814	275548
13068	14210	5	applied	\N	\N	\N	\N	107815	107815	275549
13068	14211	6	applied	\N	\N	\N	\N	107816	107816	275550
13068	14212	7	applied	\N	\N	\N	\N	107817	107817	275551
13077	14220	0	applied	\N	\N	\N	\N	107854	107854	275588
13077	14221	1	applied	\N	\N	\N	\N	107855	107855	275589
13077	14222	2	applied	\N	\N	\N	\N	107856	107856	275590
13077	14223	3	applied	\N	\N	\N	\N	107857	107857	275591
13084	14227	0	applied	\N	\N	\N	\N	107878	107878	275612
13084	14228	1	applied	\N	\N	\N	\N	107879	107879	275613
13084	14229	2	applied	\N	\N	\N	\N	107880	107880	275614
13084	14230	3	applied	\N	\N	\N	\N	107881	107881	275615
13087	14233	2	applied	\N	\N	\N	\N	107892	107892	275626
13105	14286	0	applied	\N	\N	\N	\N	107964	107964	275698
13110	14296	0	applied	\N	\N	\N	\N	107979	107979	275713
13110	14297	1	applied	\N	\N	\N	\N	107980	107980	275714
13110	14298	2	applied	\N	\N	\N	\N	107981	107981	275715
13110	14299	3	applied	\N	\N	\N	\N	107982	107982	275716
13110	14300	4	applied	\N	\N	\N	\N	107983	107983	275717
13110	14301	5	applied	\N	\N	\N	\N	107984	107984	275718
13110	14302	7	applied	\N	\N	\N	\N	107985	107985	275719
13112	14296	0	applied	\N	\N	\N	\N	107989	107989	275723
13112	14297	1	applied	\N	\N	\N	\N	107990	107990	275724
13112	14298	2	applied	\N	\N	\N	\N	107991	107991	275725
13112	14299	3	applied	\N	\N	\N	\N	107992	107992	275726
13112	14300	4	applied	\N	\N	\N	\N	107993	107993	275727
13112	14301	5	applied	\N	\N	\N	\N	107994	107994	275728
13112	14302	7	applied	\N	\N	\N	\N	107995	107995	275729
13112	14303	8	applied	\N	\N	\N	\N	107996	107996	275730
13115	14308	0	applied	\N	\N	\N	\N	108004	108004	275738
13115	14309	1	applied	\N	\N	\N	\N	108005	108005	275739
13115	14310	2	applied	\N	\N	\N	\N	108006	108006	275740
13117	14311	0	applied	\N	\N	\N	\N	108010	108010	275744
13117	14312	1	applied	\N	\N	\N	\N	108011	108011	275745
13117	14313	2	applied	\N	\N	\N	\N	108012	108012	275746
13123	14341	0	applied	\N	\N	\N	\N	108048	108048	275782
13123	14342	1	applied	\N	\N	\N	\N	108049	108049	275783
13123	14344	3	applied	\N	\N	\N	\N	108051	108051	275785
13134	14384	0	applied	\N	\N	\N	\N	108120	108120	275854
13009	14054	0	applied	\N	\N	\N	\N	107498	107498	275236
13009	14055	1	applied	\N	\N	\N	\N	107499	107499	275237
13035	14112	14	applied	\N	\N	\N	\N	107591	107591	275325
13035	14113	15	applied	\N	\N	\N	\N	107592	107592	275326
13035	14114	16	applied	\N	\N	\N	\N	107593	107593	275327
13035	14115	17	applied	\N	\N	\N	\N	107594	107594	275328
13038	14118	0	applied	\N	\N	\N	\N	107600	107600	275334
13038	14119	1	applied	\N	\N	\N	\N	107601	107601	275335
13038	14120	2	applied	\N	\N	\N	\N	107602	107602	275336
13040	14121	0	applied	\N	\N	\N	\N	107606	107606	275340
13040	14122	1	applied	\N	\N	\N	\N	107607	107607	275341
13040	14123	2	applied	\N	\N	\N	\N	107608	107608	275342
13040	14124	3	applied	\N	\N	\N	\N	107609	107609	275343
13040	14125	4	applied	\N	\N	\N	\N	107610	107610	275344
13040	14126	5	applied	\N	\N	\N	\N	107611	107611	275345
13040	14128	7	applied	\N	\N	\N	\N	107613	107613	275347
13045	14138	0	applied	\N	\N	\N	\N	107639	107639	275373
13045	14139	1	applied	\N	\N	\N	\N	107640	107640	275374
13045	14140	2	applied	\N	\N	\N	\N	107641	107641	275375
13045	14141	3	applied	\N	\N	\N	\N	107642	107642	275376
13045	14142	4	applied	\N	\N	\N	\N	107643	107643	275377
13045	14143	5	applied	\N	\N	\N	\N	107644	107644	275378
13045	14144	6	applied	\N	\N	\N	\N	107645	107645	275379
13045	14145	7	applied	\N	\N	\N	\N	107646	107646	275380
13051	14149	0	applied	\N	\N	\N	\N	107665	107665	275399
13051	14150	1	applied	\N	\N	1000000000	\N	107666	107666	275400
13051	14151	2	applied	\N	\N	\N	\N	107667	107667	275401
13051	14152	3	applied	\N	\N	\N	\N	107668	107668	275402
13051	14153	4	applied	\N	\N	\N	\N	107669	107669	275403
13054	14156	0	applied	\N	\N	\N	\N	107677	107677	275411
13054	14157	1	applied	\N	\N	\N	\N	107678	107678	275412
13057	14164	1	applied	\N	\N	\N	\N	107690	107690	275424
13057	14165	2	applied	\N	\N	\N	\N	107691	107691	275425
13057	14166	3	applied	\N	\N	\N	\N	107692	107692	275426
13057	14167	4	applied	\N	\N	\N	\N	107693	107693	275427
13057	14168	5	applied	\N	\N	\N	\N	107694	107694	275428
13057	14169	6	applied	\N	\N	\N	\N	107695	107695	275429
13057	14170	7	applied	\N	\N	\N	\N	107696	107696	275430
13057	14171	8	applied	\N	\N	\N	\N	107697	107697	275431
13057	14172	9	applied	\N	\N	\N	\N	107698	107698	275432
13057	14173	10	applied	\N	\N	\N	\N	107699	107699	275433
13057	14174	11	applied	\N	\N	\N	\N	107700	107700	275434
13057	14175	12	applied	\N	\N	\N	\N	107701	107701	275435
13057	14176	13	applied	\N	\N	\N	\N	107702	107702	275436
13057	14177	14	applied	\N	\N	\N	\N	107703	107703	275437
13057	14178	15	applied	\N	\N	\N	\N	107704	107704	275438
13060	14163	0	applied	\N	\N	\N	\N	107737	107737	275471
13060	14165	2	applied	\N	\N	\N	\N	107739	107739	275473
13060	14166	3	applied	\N	\N	\N	\N	107740	107740	275474
13060	14167	4	applied	\N	\N	\N	\N	107741	107741	275475
13060	14168	5	applied	\N	\N	\N	\N	107742	107742	275476
13060	14169	6	applied	\N	\N	\N	\N	107743	107743	275477
13060	14170	7	applied	\N	\N	\N	\N	107744	107744	275478
13060	14171	8	applied	\N	\N	\N	\N	107745	107745	275479
13060	14172	9	applied	\N	\N	\N	\N	107746	107746	275480
13060	14173	10	applied	\N	\N	\N	\N	107747	107747	275481
13060	14174	11	applied	\N	\N	\N	\N	107748	107748	275482
13060	14175	12	applied	\N	\N	\N	\N	107749	107749	275483
13060	14176	13	applied	\N	\N	\N	\N	107750	107750	275484
13060	14177	14	applied	\N	\N	\N	\N	107751	107751	275485
13060	14178	15	applied	\N	\N	\N	\N	107752	107752	275486
13061	14179	0	applied	\N	\N	\N	\N	107753	107753	275487
13061	14180	1	applied	\N	\N	\N	\N	107754	107754	275488
13064	14201	0	applied	\N	\N	\N	\N	107794	107794	275528
13064	14202	1	applied	\N	\N	\N	\N	107795	107795	275529
13064	14203	2	applied	\N	\N	\N	\N	107796	107796	275530
13064	14204	3	applied	\N	\N	\N	\N	107797	107797	275531
13069	14205	0	applied	\N	\N	1000000000	\N	107818	107818	275552
13069	14206	1	applied	\N	\N	\N	\N	107819	107819	275553
13069	14207	2	applied	\N	\N	\N	\N	107820	107820	275554
13069	14208	3	applied	\N	\N	\N	\N	107821	107821	275555
13069	14209	4	applied	\N	\N	\N	\N	107822	107822	275556
13069	14210	5	applied	\N	\N	\N	\N	107823	107823	275557
13069	14211	6	applied	\N	\N	\N	\N	107824	107824	275558
13069	14212	7	applied	\N	\N	\N	\N	107825	107825	275559
13074	14213	0	applied	\N	\N	\N	\N	107843	107843	275577
13075	14217	0	applied	\N	\N	\N	\N	107844	107844	275578
13075	14214	1	applied	\N	\N	\N	\N	107845	107845	275579
13075	14215	2	applied	\N	\N	\N	\N	107846	107846	275580
13075	14218	4	applied	\N	\N	\N	\N	107848	107848	275582
13075	14219	5	applied	\N	\N	\N	\N	107849	107849	275583
13080	14224	0	applied	\N	\N	\N	\N	107864	107864	275598
13080	14225	1	applied	\N	\N	\N	\N	107865	107865	275599
13080	14226	2	applied	\N	\N	\N	\N	107866	107866	275600
13091	14245	0	applied	\N	\N	\N	\N	107907	107907	275641
13103	14279	0	applied	\N	\N	\N	\N	107957	107957	275691
13103	14280	1	applied	\N	\N	\N	\N	107958	107958	275692
13103	14281	2	applied	\N	\N	\N	\N	107959	107959	275693
13111	14296	0	applied	\N	\N	\N	\N	107987	107987	275721
13111	14297	1	applied	\N	\N	\N	\N	107988	107988	275722
13113	14304	0	applied	\N	\N	\N	\N	107997	107997	275731
13113	14306	2	applied	\N	\N	\N	\N	107999	107999	275733
13113	14307	3	applied	\N	\N	\N	\N	108000	108000	275734
13118	14314	0	applied	\N	\N	\N	\N	108013	108013	275747
13118	14315	1	applied	\N	\N	\N	\N	108014	108014	275748
13118	14316	2	applied	\N	\N	\N	\N	108015	108015	275749
13134	14385	1	applied	\N	\N	\N	\N	108121	108121	275855
13134	14386	2	applied	\N	\N	\N	\N	108122	108122	275856
13134	14387	3	applied	\N	\N	\N	\N	108123	108123	275857
13139	14392	0	applied	\N	\N	\N	\N	108139	108139	275873
13139	14393	1	applied	\N	\N	\N	\N	108140	108140	275874
13139	14394	2	applied	\N	\N	\N	\N	108141	108141	275875
13139	14395	3	applied	\N	\N	\N	\N	108142	108142	275876
13141	14396	0	applied	\N	\N	\N	\N	108147	108147	275881
13141	14397	2	applied	\N	\N	\N	\N	108148	108148	275882
13141	14398	3	applied	\N	\N	\N	\N	108149	108149	275883
13141	14399	4	applied	\N	\N	\N	\N	108150	108150	275884
13035	14110	12	applied	\N	\N	\N	\N	107589	107589	275323
13035	14111	13	applied	\N	\N	\N	\N	107590	107590	275324
13062	14193	11	applied	\N	\N	\N	\N	107767	107767	275501
13062	14194	12	applied	\N	\N	\N	\N	107768	107768	275502
13062	14195	13	applied	\N	\N	1000000000	\N	107769	107769	275503
13062	14196	14	applied	\N	\N	\N	\N	107770	107770	275504
13062	14197	15	applied	\N	\N	\N	\N	107771	107771	275505
13062	14198	16	applied	\N	\N	\N	\N	107772	107772	275506
13062	14199	17	applied	\N	\N	\N	\N	107773	107773	275507
13062	14200	18	applied	\N	\N	\N	\N	107774	107774	275508
13065	14201	0	applied	\N	\N	\N	\N	107798	107798	275532
13065	14202	1	applied	\N	\N	\N	\N	107799	107799	275533
13065	14203	2	applied	\N	\N	\N	\N	107800	107800	275534
13065	14204	3	applied	\N	\N	\N	\N	107801	107801	275535
13070	14206	1	applied	\N	\N	\N	\N	107827	107827	275561
13070	14207	2	applied	\N	\N	\N	\N	107828	107828	275562
13070	14208	3	applied	\N	\N	\N	\N	107829	107829	275563
13070	14209	4	applied	\N	\N	\N	\N	107830	107830	275564
13070	14210	5	applied	\N	\N	\N	\N	107831	107831	275565
13070	14211	6	applied	\N	\N	\N	\N	107832	107832	275566
13070	14212	7	applied	\N	\N	\N	\N	107833	107833	275567
13071	14213	0	applied	\N	\N	\N	\N	107834	107834	275568
13071	14214	2	applied	\N	\N	\N	\N	107835	107835	275569
13071	14215	3	applied	\N	\N	\N	\N	107836	107836	275570
13071	14216	4	applied	\N	\N	\N	\N	107837	107837	275571
13078	14224	0	applied	\N	\N	\N	\N	107858	107858	275592
13078	14225	1	applied	\N	\N	\N	\N	107859	107859	275593
13078	14226	2	applied	\N	\N	\N	\N	107860	107860	275594
13081	14224	0	applied	\N	\N	\N	\N	107867	107867	275601
13081	14225	1	applied	\N	\N	\N	\N	107868	107868	275602
13081	14226	2	applied	\N	\N	\N	\N	107869	107869	275603
13082	14227	0	applied	\N	\N	\N	\N	107870	107870	275604
13082	14229	2	applied	\N	\N	\N	\N	107872	107872	275606
13082	14230	3	applied	\N	\N	\N	\N	107873	107873	275607
13085	14227	0	applied	\N	\N	\N	\N	107882	107882	275616
13085	14228	1	applied	\N	\N	\N	\N	107883	107883	275617
13085	14229	2	applied	\N	\N	\N	\N	107884	107884	275618
13085	14230	3	applied	\N	\N	\N	\N	107885	107885	275619
13086	14227	0	applied	\N	\N	\N	\N	107886	107886	275620
13089	14242	0	applied	\N	\N	\N	\N	107901	107901	275635
13089	14243	1	applied	\N	\N	\N	\N	107902	107902	275636
13089	14244	2	applied	\N	\N	\N	\N	107903	107903	275637
13094	14255	0	applied	\N	\N	\N	\N	107917	107917	275651
13102	14278	3	applied	\N	\N	\N	\N	107956	107956	275690
13104	14282	0	applied	\N	\N	\N	\N	107960	107960	275694
13104	14283	1	applied	\N	\N	\N	\N	107961	107961	275695
13104	14284	2	applied	\N	\N	\N	\N	107962	107962	275696
13104	14285	3	applied	\N	\N	\N	\N	107963	107963	275697
13107	14286	0	applied	\N	\N	\N	\N	107965	107965	275699
13107	14287	1	applied	\N	\N	\N	\N	107966	107966	275700
13107	14288	2	applied	\N	\N	\N	\N	107967	107967	275701
13107	14289	3	applied	\N	\N	\N	\N	107968	107968	275702
13118	14317	3	applied	\N	\N	\N	\N	108016	108016	275750
13118	14318	4	applied	\N	\N	\N	\N	108017	108017	275751
13118	14319	5	applied	\N	\N	\N	\N	108018	108018	275752
13118	14320	6	applied	\N	\N	\N	\N	108019	108019	275753
13119	14314	0	applied	\N	\N	\N	\N	108021	108021	275755
13119	14315	1	applied	\N	\N	\N	\N	108022	108022	275756
13119	14316	2	applied	\N	\N	\N	\N	108023	108023	275757
13119	14317	3	applied	\N	\N	\N	\N	108024	108024	275758
13119	14318	4	applied	\N	\N	\N	\N	108025	108025	275759
13119	14319	5	applied	\N	\N	\N	\N	108026	108026	275760
13119	14320	6	applied	\N	\N	\N	\N	108027	108027	275761
13119	14321	7	applied	\N	\N	\N	\N	108028	108028	275762
13120	14322	0	applied	\N	\N	\N	\N	108029	108029	275763
13120	14323	1	applied	\N	\N	\N	\N	108030	108030	275764
13120	14324	2	applied	\N	\N	\N	\N	108031	108031	275765
13120	14325	3	applied	\N	\N	\N	\N	108032	108032	275766
13121	14326	0	applied	\N	\N	\N	\N	108033	108033	275767
13121	14327	1	applied	\N	\N	\N	\N	108034	108034	275768
13121	14328	2	applied	\N	\N	\N	\N	108035	108035	275769
13124	14345	0	applied	\N	\N	\N	\N	108052	108052	275786
13124	14347	2	applied	\N	\N	\N	\N	108054	108054	275788
13128	14348	0	applied	\N	\N	\N	\N	108070	108070	275804
13128	14349	1	applied	\N	\N	\N	\N	108071	108071	275805
13128	14350	2	applied	\N	\N	\N	\N	108072	108072	275806
13128	14351	3	applied	\N	\N	\N	\N	108073	108073	275807
13128	14352	4	applied	\N	\N	\N	\N	108074	108074	275808
13128	14353	5	applied	\N	\N	\N	\N	108075	108075	275809
13128	14354	6	applied	\N	\N	\N	\N	108076	108076	275810
13128	14355	7	applied	\N	\N	\N	\N	108077	108077	275811
13128	14356	8	applied	\N	\N	\N	\N	108078	108078	275812
13128	14357	9	applied	\N	\N	\N	\N	108079	108079	275813
13128	14358	10	applied	\N	\N	\N	\N	108080	108080	275814
13128	14359	11	applied	\N	\N	\N	\N	108081	108081	275815
13133	14384	0	applied	\N	\N	\N	\N	108116	108116	275850
13133	14385	1	applied	\N	\N	\N	\N	108117	108117	275851
13133	14386	2	applied	\N	\N	\N	\N	108118	108118	275852
13135	14388	0	applied	\N	\N	\N	\N	108124	108124	275858
13135	14389	1	applied	\N	\N	\N	\N	108125	108125	275859
13135	14390	2	applied	\N	\N	\N	\N	108126	108126	275860
13135	14391	3	applied	\N	\N	\N	\N	108127	108127	275861
13140	14392	0	applied	\N	\N	\N	\N	108143	108143	275877
13140	14393	1	applied	\N	\N	\N	\N	108144	108144	275878
13140	14394	2	applied	\N	\N	\N	\N	108145	108145	275879
13140	14395	3	applied	\N	\N	\N	\N	108146	108146	275880
13148	14428	0	applied	\N	\N	\N	\N	108200	108200	275934
13148	14429	1	applied	\N	\N	\N	\N	108201	108201	275935
13148	14430	2	applied	\N	\N	\N	\N	108202	108202	275936
13148	14431	3	applied	\N	\N	\N	\N	108203	108203	275937
13148	14432	4	applied	\N	\N	\N	\N	108204	108204	275938
13150	14433	0	applied	\N	\N	\N	\N	108210	108210	275944
13150	14434	1	applied	\N	\N	\N	\N	108211	108211	275945
13062	14190	8	applied	\N	\N	\N	\N	107764	107764	275498
13062	14192	10	applied	\N	\N	\N	\N	107766	107766	275500
13108	14286	0	applied	\N	\N	\N	\N	107969	107969	275703
13108	14287	1	applied	\N	\N	\N	\N	107970	107970	275704
13108	14288	2	applied	\N	\N	\N	\N	107971	107971	275705
13108	14289	3	applied	\N	\N	\N	\N	107972	107972	275706
13109	14290	0	applied	\N	\N	\N	\N	107973	107973	275707
13109	14292	2	applied	\N	\N	\N	\N	107975	107975	275709
13109	14293	3	applied	\N	\N	\N	\N	107976	107976	275710
13109	14294	4	applied	\N	\N	\N	\N	107977	107977	275711
13109	14295	5	applied	\N	\N	\N	\N	107978	107978	275712
13114	14308	0	applied	\N	\N	\N	\N	108001	108001	275735
13114	14309	1	applied	\N	\N	\N	\N	108002	108002	275736
13114	14310	2	applied	\N	\N	\N	\N	108003	108003	275737
13116	14308	0	applied	\N	\N	\N	\N	108007	108007	275741
13116	14309	1	applied	\N	\N	\N	\N	108008	108008	275742
13116	14310	2	applied	\N	\N	\N	\N	108009	108009	275743
13122	14338	0	applied	\N	\N	\N	\N	108045	108045	275779
13122	14339	1	applied	\N	\N	\N	\N	108046	108046	275780
13122	14340	2	applied	\N	\N	\N	\N	108047	108047	275781
13125	14345	0	applied	\N	\N	\N	\N	108055	108055	275789
13125	14346	1	applied	\N	\N	\N	\N	108056	108056	275790
13125	14347	2	applied	\N	\N	\N	\N	108057	108057	275791
13130	14361	1	applied	\N	\N	\N	\N	108093	108093	275827
13130	14362	2	applied	\N	\N	\N	\N	108094	108094	275828
13130	14363	3	applied	\N	\N	\N	\N	108095	108095	275829
13130	14364	4	applied	\N	\N	\N	\N	108096	108096	275830
13130	14365	5	applied	\N	\N	\N	\N	108097	108097	275831
13130	14366	6	applied	\N	\N	\N	\N	108098	108098	275832
13136	14388	0	applied	\N	\N	\N	\N	108128	108128	275862
13136	14389	1	applied	\N	\N	\N	\N	108129	108129	275863
13136	14390	2	applied	\N	\N	\N	\N	108130	108130	275864
13136	14391	3	applied	\N	\N	\N	\N	108131	108131	275865
13138	14392	0	applied	\N	\N	\N	\N	108135	108135	275869
13138	14393	1	applied	\N	\N	\N	\N	108136	108136	275870
13138	14394	2	applied	\N	\N	\N	\N	108137	108137	275871
13138	14395	3	applied	\N	\N	\N	\N	108138	108138	275872
13145	14404	0	applied	\N	\N	\N	\N	108169	108169	275903
13145	14405	1	applied	\N	\N	\N	\N	108170	108170	275904
13146	14407	0	applied	\N	\N	\N	\N	108172	108172	275906
13146	14408	1	applied	\N	\N	\N	\N	108173	108173	275907
13146	14409	2	applied	\N	\N	\N	\N	108174	108174	275908
13146	14410	3	applied	\N	\N	\N	\N	108175	108175	275909
13146	14411	4	applied	\N	\N	\N	\N	108176	108176	275910
13146	14412	5	applied	\N	\N	\N	\N	108177	108177	275911
13146	14413	6	applied	\N	\N	\N	\N	108178	108178	275912
13151	14428	0	applied	\N	\N	\N	\N	108212	108212	275946
13151	14429	1	applied	\N	\N	\N	\N	108213	108213	275947
13151	14433	2	applied	\N	\N	\N	\N	108214	108214	275948
13151	14430	3	applied	\N	\N	\N	\N	108215	108215	275949
13151	14431	4	applied	\N	\N	\N	\N	108216	108216	275950
13151	14432	5	applied	\N	\N	\N	\N	108217	108217	275951
13151	14434	6	applied	\N	\N	\N	\N	108218	108218	275952
13155	14435	0	applied	\N	\N	\N	\N	108232	108232	275966
13155	14436	1	applied	\N	\N	\N	\N	108233	108233	275967
13155	14438	3	applied	\N	\N	\N	\N	108235	108235	275969
13155	14439	4	applied	\N	\N	\N	\N	108236	108236	275970
13158	14444	0	applied	\N	\N	\N	\N	108245	108245	275979
13158	14445	1	applied	\N	\N	\N	\N	108246	108246	275980
13159	14448	0	applied	\N	\N	\N	\N	108247	108247	275981
13159	14449	1	applied	\N	\N	\N	\N	108248	108248	275982
13159	14446	2	applied	\N	\N	\N	\N	108249	108249	275983
13159	14447	3	applied	\N	\N	\N	\N	108250	108250	275984
13159	14450	4	applied	\N	\N	\N	\N	108251	108251	275985
13159	14451	5	applied	\N	\N	\N	\N	108252	108252	275986
13160	14448	0	applied	\N	\N	\N	\N	108253	108253	275987
13160	14449	1	applied	\N	\N	\N	\N	108254	108254	275988
13160	14446	2	applied	\N	\N	\N	\N	108255	108255	275989
13160	14447	3	applied	\N	\N	\N	\N	108256	108256	275990
13160	14450	4	applied	\N	\N	\N	\N	108257	108257	275991
13160	14451	5	applied	\N	\N	\N	\N	108258	108258	275992
13166	14463	0	applied	\N	\N	\N	\N	108284	108284	276018
13166	14464	1	applied	\N	\N	\N	\N	108285	108285	276019
13166	14465	2	applied	\N	\N	\N	\N	108286	108286	276020
13166	14466	3	applied	\N	\N	\N	\N	108287	108287	276021
13166	14467	4	applied	\N	\N	\N	\N	108288	108288	276022
13167	14468	0	applied	\N	\N	\N	\N	108289	108289	276023
13167	14469	1	applied	\N	\N	\N	\N	108290	108290	276024
13172	14475	0	applied	\N	\N	\N	\N	108423	108423	276157
13172	14476	1	applied	\N	\N	\N	\N	108424	108424	276158
13172	14477	2	applied	\N	\N	\N	\N	108425	108425	276159
13172	14478	3	applied	\N	\N	\N	\N	108426	108426	276160
13178	14489	0	applied	\N	\N	\N	\N	108467	108467	276201
13178	14490	1	applied	\N	\N	\N	\N	108468	108468	276202
13178	14491	2	applied	\N	\N	\N	\N	108469	108469	276203
13178	14492	4	applied	\N	\N	\N	\N	108470	108470	276204
13178	14493	5	applied	\N	\N	\N	\N	108471	108471	276205
13178	14495	7	applied	\N	\N	\N	\N	108473	108473	276207
13178	14496	8	applied	\N	\N	\N	\N	108474	108474	276208
13178	14497	9	applied	\N	\N	\N	\N	108475	108475	276209
13178	14498	10	applied	\N	\N	\N	\N	108476	108476	276210
13178	14499	11	applied	\N	\N	\N	\N	108477	108477	276211
13178	14500	12	applied	\N	\N	\N	\N	108478	108478	276212
13180	14501	0	applied	\N	\N	\N	\N	108491	108491	276225
13180	14502	1	applied	\N	\N	\N	\N	108492	108492	276226
13180	14503	2	applied	\N	\N	\N	\N	108493	108493	276227
13180	14504	3	applied	\N	\N	\N	\N	108494	108494	276228
13180	14505	4	applied	\N	\N	\N	\N	108495	108495	276229
13180	14506	5	applied	\N	\N	\N	\N	108496	108496	276230
13180	14507	6	applied	\N	\N	\N	\N	108497	108497	276231
13180	14508	7	applied	\N	\N	\N	\N	108498	108498	276232
13092	14250	4	applied	\N	\N	\N	\N	107912	107912	275646
13121	14333	7	applied	\N	\N	\N	\N	108040	108040	275774
13121	14334	8	applied	\N	\N	\N	\N	108041	108041	275775
13121	14335	9	applied	\N	\N	\N	\N	108042	108042	275776
13121	14336	10	applied	\N	\N	\N	\N	108043	108043	275777
13121	14337	11	applied	\N	\N	\N	\N	108044	108044	275778
13127	14348	0	applied	\N	\N	\N	\N	108058	108058	275792
13127	14349	1	applied	\N	\N	\N	\N	108059	108059	275793
13127	14350	2	applied	\N	\N	\N	\N	108060	108060	275794
13127	14351	3	applied	\N	\N	\N	\N	108061	108061	275795
13127	14352	4	applied	\N	\N	\N	\N	108062	108062	275796
13127	14353	5	applied	\N	\N	\N	\N	108063	108063	275797
13127	14354	6	applied	\N	\N	\N	\N	108064	108064	275798
13127	14355	7	applied	\N	\N	\N	\N	108065	108065	275799
13127	14356	8	applied	\N	\N	\N	\N	108066	108066	275800
13127	14357	9	applied	\N	\N	\N	\N	108067	108067	275801
13127	14358	10	applied	\N	\N	\N	\N	108068	108068	275802
13129	14348	0	applied	\N	\N	\N	\N	108082	108082	275816
13129	14349	1	applied	\N	\N	\N	\N	108083	108083	275817
13129	14351	2	applied	\N	\N	\N	\N	108084	108084	275818
13129	14352	3	applied	\N	\N	\N	\N	108085	108085	275819
13129	14353	4	applied	\N	\N	\N	\N	108086	108086	275820
13129	14354	5	applied	\N	\N	\N	\N	108087	108087	275821
13129	14355	6	applied	\N	\N	\N	\N	108088	108088	275822
13129	14356	7	applied	\N	\N	\N	\N	108089	108089	275823
13129	14357	8	applied	\N	\N	\N	\N	108090	108090	275824
13129	14358	9	applied	\N	\N	\N	\N	108091	108091	275825
13132	14367	0	applied	\N	\N	\N	\N	108099	108099	275833
13132	14368	1	applied	\N	\N	\N	\N	108100	108100	275834
13132	14369	2	applied	\N	\N	\N	\N	108101	108101	275835
13132	14370	3	applied	\N	\N	\N	\N	108102	108102	275836
13132	14371	4	applied	\N	\N	\N	\N	108103	108103	275837
13132	14372	5	applied	\N	\N	\N	\N	108104	108104	275838
13132	14374	7	applied	\N	\N	\N	\N	108106	108106	275840
13132	14375	8	applied	\N	\N	\N	\N	108107	108107	275841
13132	14376	9	applied	\N	\N	\N	\N	108108	108108	275842
13132	14377	10	applied	\N	\N	\N	\N	108109	108109	275843
13132	14378	11	applied	\N	\N	\N	\N	108110	108110	275844
13132	14379	12	applied	\N	\N	\N	\N	108111	108111	275845
13132	14380	13	applied	\N	\N	\N	\N	108112	108112	275846
13132	14381	14	applied	\N	\N	\N	\N	108113	108113	275847
13132	14382	15	applied	\N	\N	\N	\N	108114	108114	275848
13132	14383	16	applied	\N	\N	\N	\N	108115	108115	275849
13137	14388	0	applied	\N	\N	\N	\N	108132	108132	275866
13137	14389	1	applied	\N	\N	\N	\N	108133	108133	275867
13137	14390	2	applied	\N	\N	\N	\N	108134	108134	275868
13142	14396	0	applied	\N	\N	\N	\N	108155	108155	275889
13142	14397	2	applied	\N	\N	\N	\N	108156	108156	275890
13142	14398	3	applied	\N	\N	\N	\N	108157	108157	275891
13142	14400	5	applied	\N	\N	\N	\N	108159	108159	275893
13142	14401	6	applied	\N	\N	\N	\N	108160	108160	275894
13142	14402	7	applied	\N	\N	\N	\N	108161	108161	275895
13142	14403	8	applied	\N	\N	\N	\N	108162	108162	275896
13144	14404	0	applied	\N	\N	\N	\N	108166	108166	275900
13144	14405	1	applied	\N	\N	\N	\N	108167	108167	275901
13144	14406	2	applied	\N	\N	\N	\N	108168	108168	275902
13153	14433	0	applied	\N	\N	\N	\N	108221	108221	275955
13153	14434	1	applied	\N	\N	\N	\N	108222	108222	275956
13154	14435	0	applied	\N	\N	\N	\N	108223	108223	275957
13154	14436	1	applied	\N	\N	\N	\N	108224	108224	275958
13154	14437	2	applied	\N	\N	\N	\N	108225	108225	275959
13154	14438	3	applied	\N	\N	\N	\N	108226	108226	275960
13154	14439	4	applied	\N	\N	\N	\N	108227	108227	275961
13154	14440	5	applied	\N	\N	\N	\N	108228	108228	275962
13154	14441	6	applied	\N	\N	\N	\N	108229	108229	275963
13154	14443	8	applied	\N	\N	\N	\N	108231	108231	275965
13157	14444	0	applied	\N	\N	\N	\N	108241	108241	275975
13157	14445	1	applied	\N	\N	\N	\N	108242	108242	275976
13157	14446	2	applied	\N	\N	\N	\N	108243	108243	275977
13157	14447	3	applied	\N	\N	\N	\N	108244	108244	275978
13164	14463	0	applied	\N	\N	\N	\N	108274	108274	276008
13164	14464	1	applied	\N	\N	\N	\N	108275	108275	276009
13164	14465	2	applied	\N	\N	\N	\N	108276	108276	276010
13164	14466	3	applied	\N	\N	\N	\N	108277	108277	276011
13164	14467	4	applied	\N	\N	\N	\N	108278	108278	276012
13169	14470	0	applied	\N	\N	\N	\N	108293	108293	276027
13169	14471	1	applied	\N	\N	\N	\N	108294	108294	276028
13174	14475	0	applied	\N	\N	\N	\N	108431	108431	276165
13174	14476	1	applied	\N	\N	\N	\N	108432	108432	276166
13174	14477	2	applied	\N	\N	\N	\N	108433	108433	276167
13174	14478	3	applied	\N	\N	\N	\N	108434	108434	276168
13176	14480	1	applied	\N	\N	\N	\N	108446	108446	276180
13176	14481	2	applied	\N	\N	\N	\N	108447	108447	276181
13176	14482	3	applied	\N	\N	\N	\N	108448	108448	276182
13176	14483	4	applied	\N	\N	\N	\N	108449	108449	276183
13176	14484	5	applied	\N	\N	\N	\N	108450	108450	276184
13176	14485	6	applied	\N	\N	\N	\N	108451	108451	276185
13176	14486	7	applied	\N	\N	\N	\N	108452	108452	276186
13176	14487	8	applied	\N	\N	\N	\N	108453	108453	276187
13176	14488	9	applied	\N	\N	\N	\N	108454	108454	276188
13180	14509	8	applied	\N	\N	\N	\N	108499	108499	276233
13184	14515	0	applied	\N	\N	\N	\N	108630	108630	276364
13184	14516	1	applied	\N	\N	\N	\N	108631	108631	276365
13184	14517	2	applied	\N	\N	\N	\N	108632	108632	276366
13184	14518	3	applied	\N	\N	\N	\N	108633	108633	276367
13184	14519	4	applied	\N	\N	\N	\N	108634	108634	276368
13184	14520	5	applied	\N	\N	\N	\N	108635	108635	276369
13187	14524	1	applied	\N	\N	\N	\N	108641	108641	276375
13187	14525	2	applied	\N	\N	\N	\N	108642	108642	276376
13187	14526	3	applied	\N	\N	\N	\N	108643	108643	276377
13189	14536	0	applied	\N	\N	\N	\N	108653	108653	276387
13189	14537	1	applied	\N	\N	\N	\N	108654	108654	276388
13189	14538	2	applied	\N	\N	\N	\N	108655	108655	276389
13189	14539	3	applied	\N	\N	\N	\N	108656	108656	276390
13189	14540	4	applied	\N	\N	\N	\N	108657	108657	276391
13189	14541	5	applied	\N	\N	\N	\N	108658	108658	276392
13189	14542	6	applied	\N	\N	\N	\N	108659	108659	276393
13189	14543	7	applied	\N	\N	\N	\N	108660	108660	276394
13189	14544	8	applied	\N	\N	\N	\N	108661	108661	276395
13192	14545	0	applied	\N	\N	\N	\N	108672	108672	276406
13192	14539	1	applied	\N	\N	\N	\N	108673	108673	276407
13121	14330	4	applied	\N	\N	\N	\N	108037	108037	275771
13121	14331	5	applied	\N	\N	\N	\N	108038	108038	275772
13143	14405	1	applied	\N	\N	\N	\N	108164	108164	275898
13143	14406	2	applied	\N	\N	\N	\N	108165	108165	275899
13147	14407	0	applied	\N	\N	\N	\N	108179	108179	275913
13147	14408	1	applied	\N	\N	\N	\N	108180	108180	275914
13147	14409	2	applied	\N	\N	\N	\N	108181	108181	275915
13147	14410	3	applied	\N	\N	\N	\N	108182	108182	275916
13147	14411	4	applied	\N	\N	\N	\N	108183	108183	275917
13147	14412	5	applied	\N	\N	\N	\N	108184	108184	275918
13147	14413	6	applied	\N	\N	\N	\N	108185	108185	275919
13147	14414	7	applied	\N	\N	\N	\N	108186	108186	275920
13147	14415	8	applied	\N	\N	\N	\N	108187	108187	275921
13147	14416	9	applied	\N	\N	\N	\N	108188	108188	275922
13147	14417	10	applied	\N	\N	\N	\N	108189	108189	275923
13147	14418	11	applied	\N	\N	\N	\N	108190	108190	275924
13147	14419	12	applied	\N	\N	\N	\N	108191	108191	275925
13147	14420	13	applied	\N	\N	\N	\N	108192	108192	275926
13147	14422	15	applied	\N	\N	\N	\N	108194	108194	275928
13147	14423	16	applied	\N	\N	\N	\N	108195	108195	275929
13147	14424	17	applied	\N	\N	\N	\N	108196	108196	275930
13147	14425	18	applied	\N	\N	\N	\N	108197	108197	275931
13147	14426	19	applied	\N	\N	\N	\N	108198	108198	275932
13147	14427	20	applied	\N	\N	\N	\N	108199	108199	275933
13149	14428	0	applied	\N	\N	\N	\N	108205	108205	275939
13149	14429	1	applied	\N	\N	\N	\N	108206	108206	275940
13149	14430	2	applied	\N	\N	\N	\N	108207	108207	275941
13149	14431	3	applied	\N	\N	\N	\N	108208	108208	275942
13149	14432	4	applied	\N	\N	\N	\N	108209	108209	275943
13152	14433	0	applied	\N	\N	\N	\N	108219	108219	275953
13152	14434	1	applied	\N	\N	\N	\N	108220	108220	275954
13156	14444	0	applied	\N	\N	\N	\N	108237	108237	275971
13156	14445	1	applied	\N	\N	\N	\N	108238	108238	275972
13156	14446	2	applied	\N	\N	\N	\N	108239	108239	275973
13163	14462	0	applied	\N	\N	\N	\N	108273	108273	276007
13168	14470	0	applied	\N	\N	\N	\N	108291	108291	276025
13168	14471	1	applied	\N	\N	\N	\N	108292	108292	276026
13173	14475	0	applied	\N	\N	\N	\N	108427	108427	276161
13173	14476	1	applied	\N	\N	\N	\N	108428	108428	276162
13173	14477	2	applied	\N	\N	\N	\N	108429	108429	276163
13173	14478	3	applied	\N	\N	\N	\N	108430	108430	276164
13175	14479	0	applied	\N	\N	\N	\N	108435	108435	276169
13175	14480	1	applied	\N	\N	\N	\N	108436	108436	276170
13175	14481	2	applied	\N	\N	\N	\N	108437	108437	276171
13175	14482	3	applied	\N	\N	\N	\N	108438	108438	276172
13175	14483	4	applied	\N	\N	\N	\N	108439	108439	276173
13175	14484	5	applied	\N	\N	\N	\N	108440	108440	276174
13175	14485	6	applied	\N	\N	\N	\N	108441	108441	276175
13175	14486	7	applied	\N	\N	\N	\N	108442	108442	276176
13175	14487	8	applied	\N	\N	\N	\N	108443	108443	276177
13179	14489	0	applied	\N	\N	\N	\N	108479	108479	276213
13179	14490	1	applied	\N	\N	\N	\N	108480	108480	276214
13179	14491	2	applied	\N	\N	\N	\N	108481	108481	276215
13179	14492	4	applied	\N	\N	\N	\N	108482	108482	276216
13179	14493	5	applied	\N	\N	\N	\N	108483	108483	276217
13179	14494	6	applied	\N	\N	\N	\N	108484	108484	276218
13179	14495	7	applied	\N	\N	\N	\N	108485	108485	276219
13179	14496	8	applied	\N	\N	\N	\N	108486	108486	276220
13179	14497	9	applied	\N	\N	\N	\N	108487	108487	276221
13179	14498	10	applied	\N	\N	\N	\N	108488	108488	276222
13179	14499	11	applied	\N	\N	\N	\N	108489	108489	276223
13179	14500	12	applied	\N	\N	\N	\N	108490	108490	276224
13181	14510	0	applied	\N	\N	\N	\N	108500	108500	276234
13183	14407	0	applied	\N	\N	\N	\N	108505	108505	276239
13183	14428	1	applied	\N	\N	\N	\N	108506	108506	276240
13183	14448	2	applied	\N	\N	\N	\N	108507	108507	276241
13183	14454	4	applied	\N	\N	\N	\N	108509	108509	276243
13183	14436	5	applied	\N	\N	\N	\N	108510	108510	276244
13183	14476	6	applied	\N	\N	\N	\N	108511	108511	276245
13183	14481	7	applied	\N	\N	\N	\N	108512	108512	276246
13183	14439	8	applied	\N	\N	\N	\N	108513	108513	276247
13183	14444	9	applied	\N	\N	\N	\N	108514	108514	276248
13183	14482	10	applied	\N	\N	\N	\N	108515	108515	276249
13183	14489	11	applied	\N	\N	\N	\N	108516	108516	276250
13183	14491	12	applied	\N	\N	\N	\N	108517	108517	276251
13183	14492	13	applied	\N	\N	\N	\N	108518	108518	276252
13183	14304	14	applied	\N	\N	\N	\N	108519	108519	276253
13183	14308	15	applied	\N	\N	\N	\N	108520	108520	276254
13183	14311	16	applied	\N	\N	\N	\N	108521	108521	276255
13183	14314	17	applied	\N	\N	\N	\N	108522	108522	276256
13183	14315	18	applied	\N	\N	\N	\N	108523	108523	276257
13183	14322	19	applied	\N	\N	\N	\N	108524	108524	276258
13183	14327	21	applied	\N	\N	\N	\N	108526	108526	276260
13183	14328	22	applied	\N	\N	\N	\N	108527	108527	276261
13183	14338	23	applied	\N	\N	\N	\N	108528	108528	276262
13183	14341	24	applied	\N	\N	\N	\N	108529	108529	276263
13183	14345	25	applied	\N	\N	\N	\N	108530	108530	276264
13183	14348	26	applied	\N	\N	\N	\N	108531	108531	276265
13183	14349	27	applied	\N	\N	\N	\N	108532	108532	276266
13183	14350	28	applied	\N	\N	\N	\N	108533	108533	276267
13183	14360	29	applied	\N	\N	\N	\N	108534	108534	276268
13183	14367	30	applied	\N	\N	\N	\N	108535	108535	276269
13183	14368	31	applied	\N	\N	\N	\N	108536	108536	276270
13183	14369	32	applied	\N	\N	\N	\N	108537	108537	276271
13183	14370	33	applied	\N	\N	\N	\N	108538	108538	276272
13183	14371	34	applied	\N	\N	\N	\N	108539	108539	276273
13183	14384	35	applied	\N	\N	\N	\N	108540	108540	276274
13183	14388	36	applied	\N	\N	\N	\N	108541	108541	276275
13183	14396	38	applied	\N	\N	\N	\N	108543	108543	276277
13183	14397	39	applied	\N	\N	\N	\N	108544	108544	276278
13187	14527	4	applied	\N	\N	\N	\N	108644	108644	276378
13187	14528	5	applied	\N	\N	\N	\N	108645	108645	276379
13187	14529	6	applied	\N	\N	\N	\N	108646	108646	276380
13190	14536	0	applied	\N	\N	\N	\N	108662	108662	276396
13190	14537	1	applied	\N	\N	\N	\N	108663	108663	276397
13190	14538	2	applied	\N	\N	\N	\N	108664	108664	276398
13194	14539	0	applied	\N	\N	\N	\N	108689	108689	276423
13194	14540	1	applied	\N	\N	\N	\N	108690	108690	276424
13194	14541	2	applied	\N	\N	\N	\N	108691	108691	276425
13194	14542	3	applied	\N	\N	\N	\N	108692	108692	276426
13194	14543	4	applied	\N	\N	\N	\N	108693	108693	276427
13194	14544	5	applied	\N	\N	\N	\N	108694	108694	276428
13141	14402	7	applied	\N	\N	\N	\N	108153	108153	275887
13141	14403	8	applied	\N	\N	\N	\N	108154	108154	275888
13162	14453	1	applied	\N	\N	\N	\N	108264	108264	275998
13162	14454	2	applied	\N	\N	\N	\N	108265	108265	275999
13162	14455	3	applied	\N	\N	\N	\N	108266	108266	276000
13162	14456	4	applied	\N	\N	\N	\N	108267	108267	276001
13162	14457	5	applied	\N	\N	\N	\N	108268	108268	276002
13162	14458	6	applied	\N	\N	\N	\N	108269	108269	276003
13162	14459	7	applied	\N	\N	\N	\N	108270	108270	276004
13162	14460	8	applied	\N	\N	\N	\N	108271	108271	276005
13162	14461	9	applied	\N	\N	\N	\N	108272	108272	276006
13165	14463	0	applied	\N	\N	\N	\N	108279	108279	276013
13165	14464	1	applied	\N	\N	\N	\N	108280	108280	276014
13165	14465	2	applied	\N	\N	\N	\N	108281	108281	276015
13165	14466	3	applied	\N	\N	\N	\N	108282	108282	276016
13165	14467	4	applied	\N	\N	\N	\N	108283	108283	276017
13170	14407	0	applied	\N	\N	\N	\N	108295	108295	276029
13170	14428	1	applied	\N	\N	\N	\N	108296	108296	276030
13170	14435	3	applied	\N	\N	\N	\N	108298	108298	276032
13170	14275	4	applied	\N	\N	\N	\N	108299	108299	276033
13170	14454	5	applied	\N	\N	\N	\N	108300	108300	276034
13170	14436	6	applied	\N	\N	\N	\N	108301	108301	276035
13170	14439	7	applied	\N	\N	\N	\N	108302	108302	276036
13170	14444	8	applied	\N	\N	\N	\N	108303	108303	276037
13170	14279	9	applied	\N	\N	\N	\N	108304	108304	276038
13170	14282	10	applied	\N	\N	\N	\N	108305	108305	276039
13170	14286	11	applied	\N	\N	\N	\N	108306	108306	276040
13170	14290	12	applied	\N	\N	\N	\N	108307	108307	276041
13170	14291	13	applied	\N	\N	\N	\N	108308	108308	276042
13170	14296	14	applied	\N	\N	\N	\N	108309	108309	276043
13170	14297	15	applied	\N	\N	\N	\N	108310	108310	276044
13170	14304	16	applied	\N	\N	\N	\N	108311	108311	276045
13170	14308	17	applied	\N	\N	\N	\N	108312	108312	276046
13170	14311	18	applied	\N	\N	\N	\N	108313	108313	276047
13170	14315	20	applied	\N	\N	\N	\N	108315	108315	276049
13170	14322	21	applied	\N	\N	\N	\N	108316	108316	276050
13170	14326	22	applied	\N	\N	\N	\N	108317	108317	276051
13170	14327	23	applied	\N	\N	\N	\N	108318	108318	276052
13170	14328	24	applied	\N	\N	\N	\N	108319	108319	276053
13170	14338	25	applied	\N	\N	\N	\N	108320	108320	276054
13170	14341	26	applied	\N	\N	\N	\N	108321	108321	276055
13170	14345	27	applied	\N	\N	\N	\N	108322	108322	276056
13170	14348	28	applied	\N	\N	\N	\N	108323	108323	276057
13170	14349	29	applied	\N	\N	\N	\N	108324	108324	276058
13170	14350	30	applied	\N	\N	\N	\N	108325	108325	276059
13170	14360	31	applied	\N	\N	\N	\N	108326	108326	276060
13170	14367	32	applied	\N	\N	\N	\N	108327	108327	276061
13170	14368	33	applied	\N	\N	\N	\N	108328	108328	276062
13170	14369	34	applied	\N	\N	\N	\N	108329	108329	276063
13170	14370	35	applied	\N	\N	\N	\N	108330	108330	276064
13170	14384	38	applied	\N	\N	\N	\N	108332	108332	276066
13170	14388	39	applied	\N	\N	\N	\N	108333	108333	276067
13170	14392	40	applied	\N	\N	\N	\N	108334	108334	276068
13170	14396	41	applied	\N	\N	\N	\N	108335	108335	276069
13170	14397	42	applied	\N	\N	\N	\N	108336	108336	276070
13170	14404	43	applied	\N	\N	\N	\N	108337	108337	276071
13170	14408	44	applied	\N	\N	\N	\N	108338	108338	276072
13170	14409	45	applied	\N	\N	\N	\N	108339	108339	276073
13170	14410	46	applied	\N	\N	\N	\N	108340	108340	276074
13170	14411	47	applied	\N	\N	\N	\N	108341	108341	276075
13170	14412	48	applied	\N	\N	\N	\N	108342	108342	276076
13170	14413	49	applied	\N	\N	\N	\N	108343	108343	276077
13170	14429	50	applied	\N	\N	\N	\N	108344	108344	276078
13170	14433	51	applied	\N	\N	\N	\N	108345	108345	276079
13170	14437	52	applied	\N	\N	\N	\N	108346	108346	276080
13170	14438	53	applied	\N	\N	\N	\N	108347	108347	276081
13170	14449	55	applied	\N	\N	\N	\N	108349	108349	276083
13170	14452	56	applied	\N	\N	\N	\N	108350	108350	276084
13170	14453	57	applied	\N	\N	\N	\N	108351	108351	276085
13170	14455	58	applied	\N	\N	\N	\N	108352	108352	276086
13170	14462	59	applied	\N	\N	\N	\N	108353	108353	276087
13170	14463	60	applied	\N	\N	\N	\N	108354	108354	276088
13170	14468	61	applied	\N	\N	\N	\N	108355	108355	276089
13170	14276	62	applied	\N	\N	\N	\N	108356	108356	276090
13170	14277	63	applied	\N	\N	\N	\N	108357	108357	276091
13170	14278	64	applied	\N	\N	\N	\N	108358	108358	276092
13170	14280	65	applied	\N	\N	\N	\N	108359	108359	276093
13170	14281	66	applied	\N	\N	\N	\N	108360	108360	276094
13170	14283	67	applied	\N	\N	\N	\N	108361	108361	276095
13170	14284	68	applied	\N	\N	\N	\N	108362	108362	276096
13170	14285	69	applied	\N	\N	\N	\N	108363	108363	276097
13170	14287	70	applied	\N	\N	\N	\N	108364	108364	276098
13170	14289	72	applied	\N	\N	\N	\N	108366	108366	276100
13170	14292	73	applied	\N	\N	\N	\N	108367	108367	276101
13170	14293	74	applied	\N	\N	\N	\N	108368	108368	276102
13170	14294	75	applied	\N	\N	\N	\N	108369	108369	276103
13170	14295	76	applied	\N	\N	\N	\N	108370	108370	276104
13170	14298	77	applied	\N	\N	\N	\N	108371	108371	276105
13170	14299	78	applied	\N	\N	\N	\N	108372	108372	276106
13170	14300	79	applied	\N	\N	\N	\N	108373	108373	276107
13170	14301	80	applied	\N	\N	\N	\N	108374	108374	276108
13170	14302	81	applied	\N	\N	\N	\N	108375	108375	276109
13170	14303	82	applied	\N	\N	\N	\N	108376	108376	276110
13170	14305	83	applied	\N	\N	\N	\N	108377	108377	276111
13170	14306	84	applied	\N	\N	\N	\N	108378	108378	276112
13170	14307	85	applied	\N	\N	\N	\N	108379	108379	276113
13170	14309	86	applied	\N	\N	\N	\N	108380	108380	276114
13170	14310	87	applied	\N	\N	\N	\N	108381	108381	276115
13170	14313	89	applied	\N	\N	\N	\N	108383	108383	276117
13170	14316	90	applied	\N	\N	\N	\N	108384	108384	276118
13183	14404	40	applied	\N	\N	\N	\N	108545	108545	276279
13183	14408	41	applied	\N	\N	\N	\N	108546	108546	276280
13183	14409	42	applied	\N	\N	\N	\N	108547	108547	276281
13183	14410	43	applied	\N	\N	\N	\N	108548	108548	276282
13183	14411	44	applied	\N	\N	\N	\N	108549	108549	276283
13183	14412	45	applied	\N	\N	\N	\N	108550	108550	276284
13183	14413	46	applied	\N	\N	\N	\N	108551	108551	276285
13183	14429	47	applied	\N	\N	\N	\N	108552	108552	276286
13183	14433	48	applied	\N	\N	\N	\N	108553	108553	276287
13183	14437	49	applied	\N	\N	\N	\N	108554	108554	276288
13183	14438	50	applied	\N	\N	\N	\N	108555	108555	276289
13183	14445	51	applied	\N	\N	\N	\N	108556	108556	276290
13161	14450	2	applied	\N	\N	\N	\N	108261	108261	275995
13161	14451	3	applied	\N	\N	\N	\N	108262	108262	275996
13170	14321	95	applied	\N	\N	\N	\N	108389	108389	276123
13170	14323	96	applied	\N	\N	\N	\N	108390	108390	276124
13170	14324	97	applied	\N	\N	\N	\N	108391	108391	276125
13170	14325	98	applied	\N	\N	\N	\N	108392	108392	276126
13170	14329	99	applied	\N	\N	\N	\N	108393	108393	276127
13170	14330	100	applied	\N	\N	\N	\N	108394	108394	276128
13170	14331	101	applied	\N	\N	\N	\N	108395	108395	276129
13170	14332	102	applied	\N	\N	\N	\N	108396	108396	276130
13170	14333	103	applied	\N	\N	\N	\N	108397	108397	276131
13170	14334	104	applied	\N	\N	\N	\N	108398	108398	276132
13170	14335	105	applied	\N	\N	\N	\N	108399	108399	276133
13170	14336	106	applied	\N	\N	\N	\N	108400	108400	276134
13170	14337	107	applied	\N	\N	\N	\N	108401	108401	276135
13170	14339	108	applied	\N	\N	\N	\N	108402	108402	276136
13170	14340	109	applied	\N	\N	\N	\N	108403	108403	276137
13170	14342	110	applied	\N	\N	\N	\N	108404	108404	276138
13170	14344	112	applied	\N	\N	\N	\N	108406	108406	276140
13170	14346	113	applied	\N	\N	\N	\N	108407	108407	276141
13170	14347	114	applied	\N	\N	\N	\N	108408	108408	276142
13170	14351	115	applied	\N	\N	\N	\N	108409	108409	276143
13170	14352	116	applied	\N	\N	\N	\N	108410	108410	276144
13170	14353	117	applied	\N	\N	\N	\N	108411	108411	276145
13170	14354	118	applied	\N	\N	\N	\N	108412	108412	276146
13170	14355	119	applied	\N	\N	\N	\N	108413	108413	276147
13170	14356	120	applied	\N	\N	\N	\N	108414	108414	276148
13170	14357	121	applied	\N	\N	\N	\N	108415	108415	276149
13170	14358	122	applied	\N	\N	\N	\N	108416	108416	276150
13170	14359	123	applied	\N	\N	\N	\N	108417	108417	276151
13170	14361	124	applied	\N	\N	\N	\N	108418	108418	276152
13170	14362	125	applied	\N	\N	\N	\N	108419	108419	276153
13171	14472	0	applied	\N	\N	\N	\N	108420	108420	276154
13171	14473	1	applied	\N	\N	\N	\N	108421	108421	276155
13177	14489	0	applied	\N	\N	\N	\N	108455	108455	276189
13177	14490	1	applied	\N	\N	\N	\N	108456	108456	276190
13177	14491	2	applied	\N	\N	\N	\N	108457	108457	276191
13177	14492	4	applied	\N	\N	\N	\N	108458	108458	276192
13177	14493	5	applied	\N	\N	\N	\N	108459	108459	276193
13177	14494	6	applied	\N	\N	\N	\N	108460	108460	276194
13177	14495	7	applied	\N	\N	\N	\N	108461	108461	276195
13177	14496	8	applied	\N	\N	\N	\N	108462	108462	276196
13177	14497	9	applied	\N	\N	\N	\N	108463	108463	276197
13177	14498	10	applied	\N	\N	\N	\N	108464	108464	276198
13177	14499	11	applied	\N	\N	\N	\N	108465	108465	276199
13177	14500	12	applied	\N	\N	\N	\N	108466	108466	276200
13182	14511	0	applied	\N	\N	\N	\N	108501	108501	276235
13182	14512	1	applied	\N	\N	\N	\N	108502	108502	276236
13182	14513	2	applied	\N	\N	\N	\N	108503	108503	276237
13182	14514	3	applied	\N	\N	\N	\N	108504	108504	276238
13185	14516	1	applied	\N	\N	\N	\N	108637	108637	276371
13188	14530	0	applied	\N	\N	\N	\N	108647	108647	276381
13188	14531	1	applied	\N	\N	\N	\N	108648	108648	276382
13188	14532	2	applied	\N	\N	\N	\N	108649	108649	276383
13188	14533	3	applied	\N	\N	\N	\N	108650	108650	276384
13188	14534	4	applied	\N	\N	\N	\N	108651	108651	276385
13188	14535	5	applied	\N	\N	\N	\N	108652	108652	276386
13191	14545	0	applied	\N	\N	\N	\N	108665	108665	276399
13191	14539	1	applied	\N	\N	\N	\N	108666	108666	276400
13191	14540	2	applied	\N	\N	\N	\N	108667	108667	276401
13191	14541	3	applied	\N	\N	\N	\N	108668	108668	276402
13191	14542	4	applied	\N	\N	\N	\N	108669	108669	276403
13191	14543	5	applied	\N	\N	\N	\N	108670	108670	276404
13191	14544	6	applied	\N	\N	\N	\N	108671	108671	276405
13195	14545	0	applied	\N	\N	\N	\N	108695	108695	276429
13195	14548	1	applied	\N	\N	\N	\N	108696	108696	276430
13201	14560	1	applied	\N	\N	\N	\N	108724	108724	276458
13201	14561	2	applied	\N	\N	\N	\N	108725	108725	276459
13201	14562	3	applied	\N	\N	\N	\N	108726	108726	276460
13201	14563	4	applied	\N	\N	\N	\N	108727	108727	276461
13201	14564	5	applied	\N	\N	\N	\N	108728	108728	276462
13206	14568	0	applied	\N	\N	\N	\N	108740	108740	276474
13207	14571	0	applied	\N	\N	\N	\N	108741	108741	276475
13207	14572	1	applied	\N	\N	\N	\N	108742	108742	276476
13207	14573	2	applied	\N	\N	\N	\N	108743	108743	276477
13210	14580	0	applied	\N	\N	\N	\N	108750	108750	276484
13210	14581	2	applied	\N	\N	\N	\N	108751	108751	276485
13210	14582	3	applied	\N	\N	\N	\N	108752	108752	276486
13210	14583	4	applied	\N	\N	\N	\N	108753	108753	276487
13210	14584	5	applied	\N	\N	\N	\N	108754	108754	276488
13210	14585	6	applied	\N	\N	\N	\N	108755	108755	276489
13213	14589	0	applied	\N	\N	\N	\N	108765	108765	276499
13213	14591	2	applied	\N	\N	\N	\N	108767	108767	276501
13213	14592	3	applied	\N	\N	\N	\N	108768	108768	276502
13213	14593	4	applied	\N	\N	\N	\N	108769	108769	276503
13215	14594	0	applied	\N	\N	\N	\N	108775	108775	276509
13215	14595	1	applied	\N	\N	\N	\N	108776	108776	276510
13215	14596	2	applied	\N	\N	\N	\N	108777	108777	276511
13218	14600	0	applied	\N	\N	\N	\N	108906	108906	276640
13218	14601	1	applied	\N	\N	\N	\N	108907	108907	276641
13218	14602	2	applied	\N	\N	\N	\N	108908	108908	276642
13218	14603	3	applied	\N	\N	\N	\N	108909	108909	276643
13218	14604	4	applied	\N	\N	\N	\N	108910	108910	276644
13218	14605	5	applied	\N	\N	\N	\N	108911	108911	276645
13220	14606	0	applied	\N	\N	\N	\N	108914	108914	276648
13220	14602	1	applied	\N	\N	\N	\N	108915	108915	276649
13220	14603	2	applied	\N	\N	\N	\N	108916	108916	276650
13220	14604	3	applied	\N	\N	\N	\N	108917	108917	276651
13220	14607	5	applied	\N	\N	\N	\N	108919	108919	276653
13220	14608	6	applied	\N	\N	\N	\N	108920	108920	276654
13223	14609	0	applied	\N	\N	\N	\N	108931	108931	276665
13232	14618	0	applied	\N	\N	\N	\N	109027	109027	276761
13232	14619	1	applied	\N	\N	\N	\N	109028	109028	276762
13236	14620	0	applied	\N	\N	\N	\N	109088	109088	276822
13236	14621	1	applied	\N	\N	\N	\N	109089	109089	276823
13239	14620	0	applied	\N	\N	\N	\N	109096	109096	276830
13242	14482	0	applied	\N	\N	\N	\N	109104	109104	276838
13242	14489	1	applied	\N	\N	\N	\N	109105	109105	276839
13242	14491	2	applied	\N	\N	\N	\N	109106	109106	276840
13242	14492	3	applied	\N	\N	\N	\N	109107	109107	276841
13244	14625	0	applied	\N	\N	\N	\N	109112	109112	276846
13244	14626	1	applied	\N	\N	\N	\N	109113	109113	276847
13170	14318	92	applied	\N	\N	\N	\N	108386	108386	276120
13170	14319	93	applied	\N	\N	\N	\N	108387	108387	276121
13183	14462	56	applied	\N	\N	\N	\N	108561	108561	276295
13183	14463	57	applied	\N	\N	\N	\N	108562	108562	276296
13183	14468	58	applied	\N	\N	\N	\N	108563	108563	276297
13183	14470	59	applied	\N	\N	\N	\N	108564	108564	276298
13183	14472	60	applied	\N	\N	\N	\N	108565	108565	276299
13183	14475	61	applied	\N	\N	\N	\N	108566	108566	276300
13183	14479	62	applied	\N	\N	\N	\N	108567	108567	276301
13183	14480	63	applied	\N	\N	\N	\N	108568	108568	276302
13183	14483	64	applied	\N	\N	\N	\N	108569	108569	276303
13183	14490	65	applied	\N	\N	\N	\N	108570	108570	276304
13183	14493	66	applied	\N	\N	\N	\N	108571	108571	276305
13183	14494	67	applied	\N	\N	\N	\N	108572	108572	276306
13183	14501	68	applied	\N	\N	\N	\N	108573	108573	276307
13183	14502	69	applied	\N	\N	\N	\N	108574	108574	276308
13183	14503	70	applied	\N	\N	\N	\N	108575	108575	276309
13183	14510	71	applied	\N	\N	\N	\N	108576	108576	276310
13183	14305	73	applied	\N	\N	\N	\N	108578	108578	276312
13183	14306	74	applied	\N	\N	\N	\N	108579	108579	276313
13183	14307	75	applied	\N	\N	\N	\N	108580	108580	276314
13183	14309	76	applied	\N	\N	\N	\N	108581	108581	276315
13183	14310	77	applied	\N	\N	\N	\N	108582	108582	276316
13183	14312	78	applied	\N	\N	\N	\N	108583	108583	276317
13183	14313	79	applied	\N	\N	\N	\N	108584	108584	276318
13183	14316	80	applied	\N	\N	\N	\N	108585	108585	276319
13183	14317	81	applied	\N	\N	\N	\N	108586	108586	276320
13183	14318	82	applied	\N	\N	\N	\N	108587	108587	276321
13183	14319	83	applied	\N	\N	\N	\N	108588	108588	276322
13183	14320	84	applied	\N	\N	\N	\N	108589	108589	276323
13183	14321	85	applied	\N	\N	\N	\N	108590	108590	276324
13183	14323	86	applied	\N	\N	\N	\N	108591	108591	276325
13183	14324	87	applied	\N	\N	\N	\N	108592	108592	276326
13183	14325	88	applied	\N	\N	\N	\N	108593	108593	276327
13183	14330	90	applied	\N	\N	\N	\N	108595	108595	276329
13183	14331	91	applied	\N	\N	\N	\N	108596	108596	276330
13183	14332	92	applied	\N	\N	\N	\N	108597	108597	276331
13183	14333	93	applied	\N	\N	\N	\N	108598	108598	276332
13183	14334	94	applied	\N	\N	\N	\N	108599	108599	276333
13183	14335	95	applied	\N	\N	\N	\N	108600	108600	276334
13183	14336	96	applied	\N	\N	\N	\N	108601	108601	276335
13183	14337	97	applied	\N	\N	\N	\N	108602	108602	276336
13183	14339	98	applied	\N	\N	\N	\N	108603	108603	276337
13183	14340	99	applied	\N	\N	\N	\N	108604	108604	276338
13183	14342	100	applied	\N	\N	\N	\N	108605	108605	276339
13183	14343	101	applied	\N	\N	\N	\N	108606	108606	276340
13183	14344	102	applied	\N	\N	\N	\N	108607	108607	276341
13183	14346	103	applied	\N	\N	\N	\N	108608	108608	276342
13183	14347	104	applied	\N	\N	\N	\N	108609	108609	276343
13183	14351	105	applied	\N	\N	\N	\N	108610	108610	276344
13183	14353	107	applied	\N	\N	\N	\N	108612	108612	276346
13183	14354	108	applied	\N	\N	\N	\N	108613	108613	276347
13183	14355	109	applied	\N	\N	\N	\N	108614	108614	276348
13183	14356	110	applied	\N	\N	\N	\N	108615	108615	276349
13183	14357	111	applied	\N	\N	\N	\N	108616	108616	276350
13183	14358	112	applied	\N	\N	\N	\N	108617	108617	276351
13183	14359	113	applied	\N	\N	\N	\N	108618	108618	276352
13183	14361	114	applied	\N	\N	\N	\N	108619	108619	276353
13183	14362	115	applied	\N	\N	\N	\N	108620	108620	276354
13183	14363	116	applied	\N	\N	\N	\N	108621	108621	276355
13183	14364	117	applied	\N	\N	\N	\N	108622	108622	276356
13183	14365	118	applied	\N	\N	\N	\N	108623	108623	276357
13183	14366	119	applied	\N	\N	\N	\N	108624	108624	276358
13183	14372	120	applied	\N	\N	\N	\N	108625	108625	276359
13183	14373	121	applied	\N	\N	\N	\N	108626	108626	276360
13183	14374	122	applied	\N	\N	\N	\N	108627	108627	276361
13183	14376	125	applied	\N	\N	\N	\N	108629	108629	276363
13186	14521	0	applied	\N	\N	\N	\N	108638	108638	276372
13186	14522	1	applied	\N	\N	\N	\N	108639	108639	276373
13193	14539	0	applied	\N	\N	\N	\N	108681	108681	276415
13193	14540	1	applied	\N	\N	\N	\N	108682	108682	276416
13193	14541	2	applied	\N	\N	\N	\N	108683	108683	276417
13193	14542	3	applied	\N	\N	\N	\N	108684	108684	276418
13193	14543	4	applied	\N	\N	\N	\N	108685	108685	276419
13193	14544	5	applied	\N	\N	\N	\N	108686	108686	276420
13193	14546	6	applied	\N	\N	\N	\N	108687	108687	276421
13193	14547	7	applied	\N	\N	\N	\N	108688	108688	276422
13199	14554	0	applied	\N	\N	\N	\N	108712	108712	276446
13199	14555	1	applied	\N	\N	\N	\N	108713	108713	276447
13199	14556	2	applied	\N	\N	\N	\N	108714	108714	276448
13199	14557	3	applied	\N	\N	\N	\N	108715	108715	276449
13199	14558	4	applied	\N	\N	\N	\N	108716	108716	276450
13204	14569	1	applied	\N	\N	\N	\N	108735	108735	276469
13204	14570	2	applied	\N	\N	\N	\N	108736	108736	276470
13214	14589	0	applied	\N	\N	\N	\N	108770	108770	276504
13214	14590	1	applied	\N	\N	\N	\N	108771	108771	276505
13214	14591	2	applied	\N	\N	\N	\N	108772	108772	276506
13214	14592	3	applied	\N	\N	\N	\N	108773	108773	276507
13214	14593	4	applied	\N	\N	\N	\N	108774	108774	276508
13219	14600	0	applied	\N	\N	\N	\N	108912	108912	276646
13219	14601	1	applied	\N	\N	\N	\N	108913	108913	276647
13221	14606	0	applied	\N	\N	\N	\N	108921	108921	276655
13221	14602	1	applied	\N	\N	\N	\N	108922	108922	276656
13221	14603	2	applied	\N	\N	\N	\N	108923	108923	276657
13221	14604	3	applied	\N	\N	\N	\N	108924	108924	276658
13221	14605	4	applied	\N	\N	\N	\N	108925	108925	276659
13221	14607	5	applied	\N	\N	\N	\N	108926	108926	276660
13221	14608	6	applied	\N	\N	\N	\N	108927	108927	276661
13225	14610	1	applied	\N	\N	\N	\N	108936	108936	276670
13225	14611	2	applied	\N	\N	\N	\N	108937	108937	276671
13244	14627	2	applied	\N	\N	\N	\N	109114	109114	276848
13244	14628	3	applied	\N	\N	\N	\N	109115	109115	276849
13246	14629	0	applied	\N	\N	\N	\N	109118	109118	276852
13251	14636	0	applied	\N	\N	\N	\N	109133	109133	276867
13251	14637	1	applied	\N	\N	\N	\N	109134	109134	276868
13251	14638	2	applied	\N	\N	\N	\N	109135	109135	276869
13256	14648	0	applied	\N	\N	\N	\N	109145	109145	276879
13256	14649	1	applied	\N	\N	\N	\N	109146	109146	276880
13256	14650	2	applied	\N	\N	\N	\N	109147	109147	276881
13256	14651	3	applied	\N	\N	\N	\N	109148	109148	276882
13256	14652	4	applied	\N	\N	\N	\N	109149	109149	276883
13256	14653	5	applied	\N	\N	\N	\N	109150	109150	276884
13183	14452	53	applied	\N	\N	\N	\N	108558	108558	276292
13183	14453	54	applied	\N	\N	\N	\N	108559	108559	276293
13192	14544	6	applied	\N	\N	\N	\N	108678	108678	276412
13192	14546	7	applied	\N	\N	\N	\N	108679	108679	276413
13192	14547	8	applied	\N	\N	\N	\N	108680	108680	276414
13196	14545	0	applied	\N	\N	\N	\N	108697	108697	276431
13196	14546	2	applied	\N	\N	\N	\N	108699	108699	276433
13196	14547	3	applied	\N	\N	\N	\N	108700	108700	276434
13196	14549	4	applied	\N	\N	\N	\N	108701	108701	276435
13196	14550	5	applied	\N	\N	\N	\N	108702	108702	276436
13198	14551	0	applied	\N	\N	\N	\N	108709	108709	276443
13198	14552	1	applied	\N	\N	\N	\N	108710	108710	276444
13198	14553	2	applied	\N	\N	\N	\N	108711	108711	276445
13203	14566	0	applied	\N	\N	\N	\N	108732	108732	276466
13203	14567	1	applied	\N	\N	\N	\N	108733	108733	276467
13208	14574	0	applied	\N	\N	\N	\N	108744	108744	276478
13208	14575	1	applied	\N	\N	\N	\N	108745	108745	276479
13208	14576	2	applied	\N	\N	\N	\N	108746	108746	276480
13211	14580	0	applied	\N	\N	\N	\N	108756	108756	276490
13211	14581	2	applied	\N	\N	\N	\N	108757	108757	276491
13216	14597	0	applied	\N	\N	\N	\N	108778	108778	276512
13216	14598	1	applied	\N	\N	\N	\N	108779	108779	276513
13224	14609	0	applied	\N	\N	\N	\N	108932	108932	276666
13224	14610	1	applied	\N	\N	\N	\N	108933	108933	276667
13224	14611	2	applied	\N	\N	\N	\N	108934	108934	276668
13226	14448	0	applied	\N	\N	\N	\N	108938	108938	276672
13226	14435	1	applied	\N	\N	\N	\N	108939	108939	276673
13226	14454	2	applied	\N	\N	\N	\N	108940	108940	276674
13226	14436	3	applied	\N	\N	\N	\N	108941	108941	276675
13226	14476	4	applied	\N	\N	\N	\N	108942	108942	276676
13226	14481	5	applied	\N	\N	\N	\N	108943	108943	276677
13226	14437	6	applied	\N	\N	\N	\N	108944	108944	276678
13226	14438	7	applied	\N	\N	\N	\N	108945	108945	276679
13226	14445	8	applied	\N	\N	\N	\N	108946	108946	276680
13226	14449	9	applied	\N	\N	\N	\N	108947	108947	276681
13226	14452	10	applied	\N	\N	\N	\N	108948	108948	276682
13226	14453	11	applied	\N	\N	\N	\N	108949	108949	276683
13233	14618	0	applied	\N	\N	\N	\N	109029	109029	276763
13237	14620	0	applied	\N	\N	\N	\N	109090	109090	276824
13237	14621	1	applied	\N	\N	\N	\N	109091	109091	276825
13237	14622	2	applied	\N	\N	\N	\N	109092	109092	276826
13240	14620	0	applied	\N	\N	\N	\N	109097	109097	276831
13240	14621	1	applied	\N	\N	\N	\N	109098	109098	276832
13240	14622	2	applied	\N	\N	\N	\N	109099	109099	276833
13247	14631	0	applied	\N	\N	\N	\N	109119	109119	276853
13247	14630	1	applied	\N	\N	\N	\N	109120	109120	276854
13254	14642	0	applied	\N	\N	\N	\N	109139	109139	276873
13254	14643	1	applied	\N	\N	\N	\N	109140	109140	276874
13254	14644	2	applied	\N	\N	\N	\N	109141	109141	276875
13254	14645	3	applied	\N	\N	\N	\N	109142	109142	276876
13254	14646	4	applied	\N	\N	\N	\N	109143	109143	276877
13254	14647	5	applied	\N	\N	\N	\N	109144	109144	276878
13257	14654	0	applied	\N	\N	\N	\N	109151	109151	276885
13259	14658	0	applied	\N	\N	\N	\N	109157	109157	276889
13265	14664	0	applied	\N	\N	\N	\N	109183	109183	276915
13265	14665	1	applied	\N	\N	\N	\N	109184	109184	276916
13265	14666	2	applied	\N	\N	\N	\N	109185	109185	276917
13265	14667	3	applied	\N	\N	\N	\N	109186	109186	276918
13265	14668	4	applied	\N	\N	\N	\N	109187	109187	276919
13265	14669	5	applied	\N	\N	\N	\N	109188	109188	276920
13265	14670	6	applied	\N	\N	\N	\N	109189	109189	276921
13269	14674	0	applied	\N	\N	\N	\N	109196	109196	276928
13269	14675	1	applied	\N	\N	\N	\N	109197	109197	276929
13269	14676	2	applied	\N	\N	\N	\N	109198	109198	276930
13274	14677	0	applied	\N	\N	\N	\N	109209	109209	276941
13274	14678	1	applied	\N	\N	\N	\N	109210	109210	276942
13275	14677	0	applied	\N	\N	\N	\N	109211	109211	276943
13275	14678	1	applied	\N	\N	\N	\N	109212	109212	276944
13285	14703	0	applied	\N	\N	\N	\N	109241	109241	276973
13285	14704	1	applied	\N	\N	\N	\N	109242	109242	276974
13285	14705	2	applied	\N	\N	\N	\N	109243	109243	276975
13290	14712	0	applied	\N	\N	\N	\N	109256	109256	276988
13290	14713	1	applied	\N	\N	\N	\N	109257	109257	276989
13290	14714	2	applied	\N	\N	\N	\N	109258	109258	276990
13295	14727	0	applied	\N	\N	\N	\N	109283	109283	277015
13295	14728	1	applied	\N	\N	\N	\N	109284	109284	277016
13295	14729	2	applied	\N	\N	\N	\N	109285	109285	277017
13298	14740	0	applied	\N	\N	\N	\N	109296	109296	277028
13298	14742	2	applied	\N	\N	\N	\N	109298	109298	277030
13301	14734	0	applied	\N	\N	1000000000	\N	109305	109305	277037
13301	14658	1	applied	\N	\N	\N	\N	109306	109306	277038
13301	14659	2	applied	\N	\N	\N	\N	109307	109307	277039
13301	14664	3	applied	\N	\N	\N	\N	109308	109308	277040
13301	14665	4	applied	\N	\N	\N	\N	109309	109309	277041
13301	14671	5	applied	\N	\N	\N	\N	109310	109310	277042
13301	14672	6	applied	\N	\N	\N	\N	109311	109311	277043
13301	14674	8	applied	\N	\N	\N	\N	109312	109312	277044
13301	14677	9	applied	\N	\N	\N	\N	109313	109313	277045
13301	14679	10	applied	\N	\N	\N	\N	109314	109314	277046
13301	14682	11	applied	\N	\N	\N	\N	109315	109315	277047
13301	14685	12	applied	\N	\N	\N	\N	109316	109316	277048
13301	14686	13	applied	\N	\N	\N	\N	109317	109317	277049
13301	14687	14	applied	\N	\N	\N	\N	109318	109318	277050
13301	14694	15	applied	\N	\N	\N	\N	109319	109319	277051
13301	14731	17	applied	\N	\N	\N	\N	109321	109321	277053
13301	14697	18	applied	\N	\N	\N	\N	109322	109322	277054
13301	14698	19	applied	\N	\N	\N	\N	109323	109323	277055
13301	14703	20	applied	\N	\N	\N	\N	109324	109324	277056
13301	14706	21	applied	\N	\N	\N	\N	109325	109325	277057
13301	14709	22	applied	\N	\N	\N	\N	109326	109326	277058
13301	14712	23	applied	\N	\N	\N	\N	109327	109327	277059
13301	14715	24	applied	\N	\N	\N	\N	109328	109328	277060
13301	14716	25	applied	\N	\N	\N	\N	109329	109329	277061
13301	14721	26	applied	\N	\N	\N	\N	109330	109330	277062
13301	14722	27	applied	\N	\N	\N	\N	109331	109331	277063
13301	14727	28	applied	\N	\N	\N	\N	109332	109332	277064
13301	14730	29	applied	\N	\N	\N	\N	109333	109333	277065
13301	14735	30	applied	\N	\N	\N	\N	109334	109334	277066
13301	14736	31	applied	\N	\N	\N	\N	109335	109335	277067
13301	14740	32	applied	\N	\N	\N	\N	109336	109336	277068
13301	14743	33	applied	\N	\N	\N	\N	109337	109337	277069
13192	14541	3	applied	\N	\N	\N	\N	108675	108675	276409
13192	14543	5	applied	\N	\N	\N	\N	108677	108677	276411
13197	14549	4	applied	\N	\N	\N	\N	108707	108707	276441
13197	14550	5	applied	\N	\N	\N	\N	108708	108708	276442
13200	14559	0	applied	\N	\N	\N	\N	108717	108717	276451
13200	14560	1	applied	\N	\N	\N	\N	108718	108718	276452
13200	14561	2	applied	\N	\N	\N	\N	108719	108719	276453
13200	14562	3	applied	\N	\N	\N	\N	108720	108720	276454
13200	14563	4	applied	\N	\N	\N	\N	108721	108721	276455
13200	14564	5	applied	\N	\N	\N	\N	108722	108722	276456
13202	14565	0	applied	\N	\N	\N	\N	108729	108729	276463
13202	14566	1	applied	\N	\N	\N	\N	108730	108730	276464
13202	14567	2	applied	\N	\N	\N	\N	108731	108731	276465
13205	14568	0	applied	\N	\N	\N	\N	108737	108737	276471
13205	14569	1	applied	\N	\N	\N	\N	108738	108738	276472
13205	14570	2	applied	\N	\N	\N	\N	108739	108739	276473
13209	14577	0	applied	\N	\N	\N	\N	108747	108747	276481
13209	14578	1	applied	\N	\N	\N	\N	108748	108748	276482
13212	14586	0	applied	\N	\N	\N	\N	108758	108758	276492
13212	14582	1	applied	\N	\N	\N	\N	108759	108759	276493
13212	14583	2	applied	\N	\N	\N	\N	108760	108760	276494
13212	14584	3	applied	\N	\N	\N	\N	108761	108761	276495
13212	14585	4	applied	\N	\N	\N	\N	108762	108762	276496
13212	14587	5	applied	\N	\N	\N	\N	108763	108763	276497
13212	14588	6	applied	\N	\N	\N	\N	108764	108764	276498
13217	14515	0	applied	\N	\N	\N	\N	108781	108781	276515
13217	14516	1	applied	\N	\N	\N	\N	108782	108782	276516
13217	14521	2	applied	\N	\N	\N	\N	108783	108783	276517
13217	14522	3	applied	\N	\N	\N	\N	108784	108784	276518
13217	14523	4	applied	\N	\N	\N	\N	108785	108785	276519
13217	14530	5	applied	\N	\N	\N	\N	108786	108786	276520
13217	14531	6	applied	\N	\N	\N	\N	108787	108787	276521
13217	14536	7	applied	\N	\N	\N	\N	108788	108788	276522
13217	14537	8	applied	\N	\N	\N	\N	108789	108789	276523
13217	14545	10	applied	\N	\N	\N	\N	108791	108791	276525
13217	14548	11	applied	\N	\N	\N	\N	108792	108792	276526
13217	14551	12	applied	\N	\N	\N	\N	108793	108793	276527
13217	14554	13	applied	\N	\N	\N	\N	108794	108794	276528
13217	14555	14	applied	\N	\N	\N	\N	108795	108795	276529
13217	14559	15	applied	\N	\N	\N	\N	108796	108796	276530
13217	14560	16	applied	\N	\N	\N	\N	108797	108797	276531
13217	14565	17	applied	\N	\N	\N	\N	108798	108798	276532
13217	14568	18	applied	\N	\N	\N	\N	108799	108799	276533
13217	14571	19	applied	\N	\N	\N	\N	108800	108800	276534
13217	14574	20	applied	\N	\N	\N	\N	108801	108801	276535
13217	14577	21	applied	\N	\N	\N	\N	108802	108802	276536
13217	14580	22	applied	\N	\N	\N	\N	108803	108803	276537
13217	14581	23	applied	\N	\N	\N	\N	108804	108804	276538
13217	14586	24	applied	\N	\N	\N	\N	108805	108805	276539
13217	14589	25	applied	\N	\N	\N	\N	108806	108806	276540
13217	14594	27	applied	\N	\N	\N	\N	108808	108808	276542
13217	14597	28	applied	\N	\N	\N	\N	108809	108809	276543
13217	14377	29	applied	\N	\N	\N	\N	108810	108810	276544
13217	14378	30	applied	\N	\N	\N	\N	108811	108811	276545
13217	14379	31	applied	\N	\N	\N	\N	108812	108812	276546
13217	14380	32	applied	\N	\N	\N	\N	108813	108813	276547
13217	14381	33	applied	\N	\N	\N	\N	108814	108814	276548
13217	14382	34	applied	\N	\N	\N	\N	108815	108815	276549
13217	14383	35	applied	\N	\N	\N	\N	108816	108816	276550
13217	14385	36	applied	\N	\N	\N	\N	108817	108817	276551
13217	14386	37	applied	\N	\N	\N	\N	108818	108818	276552
13217	14387	38	applied	\N	\N	\N	\N	108819	108819	276553
13217	14389	39	applied	\N	\N	\N	\N	108820	108820	276554
13217	14390	40	applied	\N	\N	\N	\N	108821	108821	276555
13217	14391	41	applied	\N	\N	\N	\N	108822	108822	276556
13217	14393	42	applied	\N	\N	\N	\N	108823	108823	276557
13217	14395	44	applied	\N	\N	\N	\N	108825	108825	276559
13217	14398	45	applied	\N	\N	\N	\N	108826	108826	276560
13217	14399	46	applied	\N	\N	\N	\N	108827	108827	276561
13217	14400	47	applied	\N	\N	\N	\N	108828	108828	276562
13217	14401	48	applied	\N	\N	\N	\N	108829	108829	276563
13217	14402	49	applied	\N	\N	\N	\N	108830	108830	276564
13217	14403	50	applied	\N	\N	\N	\N	108831	108831	276565
13217	14405	51	applied	\N	\N	\N	\N	108832	108832	276566
13217	14406	52	applied	\N	\N	\N	\N	108833	108833	276567
13217	14414	53	applied	\N	\N	\N	\N	108834	108834	276568
13217	14415	54	applied	\N	\N	\N	\N	108835	108835	276569
13217	14416	55	applied	\N	\N	\N	\N	108836	108836	276570
13217	14417	56	applied	\N	\N	\N	\N	108837	108837	276571
13217	14418	57	applied	\N	\N	\N	\N	108838	108838	276572
13217	14419	58	applied	\N	\N	\N	\N	108839	108839	276573
13217	14420	59	applied	\N	\N	\N	\N	108840	108840	276574
13217	14422	61	applied	\N	\N	\N	\N	108842	108842	276576
13217	14423	62	applied	\N	\N	\N	\N	108843	108843	276577
13217	14424	63	applied	\N	\N	\N	\N	108844	108844	276578
13217	14425	64	applied	\N	\N	\N	\N	108845	108845	276579
13217	14426	65	applied	\N	\N	\N	\N	108846	108846	276580
13217	14427	66	applied	\N	\N	\N	\N	108847	108847	276581
13217	14430	67	applied	\N	\N	\N	\N	108848	108848	276582
13217	14431	68	applied	\N	\N	\N	\N	108849	108849	276583
13217	14432	69	applied	\N	\N	\N	\N	108850	108850	276584
13217	14434	70	applied	\N	\N	\N	\N	108851	108851	276585
13217	14440	71	applied	\N	\N	\N	\N	108852	108852	276586
13217	14441	72	applied	\N	\N	\N	\N	108853	108853	276587
13217	14442	73	applied	\N	\N	\N	\N	108854	108854	276588
13217	14443	74	applied	\N	\N	\N	\N	108855	108855	276589
13217	14446	75	applied	\N	\N	\N	\N	108856	108856	276590
13217	14447	76	applied	\N	\N	\N	\N	108857	108857	276591
13217	14451	78	applied	\N	\N	\N	\N	108859	108859	276593
13217	14456	79	applied	\N	\N	\N	\N	108860	108860	276594
13301	14746	34	applied	\N	\N	\N	\N	109338	109338	277070
13301	14747	35	applied	\N	\N	\N	\N	109339	109339	277071
13301	14723	36	applied	\N	\N	\N	\N	109340	109340	277072
13301	14661	37	applied	\N	\N	\N	\N	109341	109341	277073
13301	14662	38	applied	\N	\N	\N	\N	109342	109342	277074
13301	14663	39	applied	\N	\N	\N	\N	109343	109343	277075
13301	14666	40	applied	\N	\N	\N	\N	109344	109344	277076
13301	14667	41	applied	\N	\N	\N	\N	109345	109345	277077
13301	14668	42	applied	\N	\N	\N	\N	109346	109346	277078
13301	14669	43	applied	\N	\N	\N	\N	109347	109347	277079
13301	14670	44	applied	\N	\N	\N	\N	109348	109348	277080
13301	14673	45	applied	\N	\N	\N	\N	109349	109349	277081
13197	14548	1	applied	\N	\N	\N	\N	108704	108704	276438
13197	14546	2	applied	\N	\N	\N	\N	108705	108705	276439
13217	14461	84	applied	\N	\N	\N	\N	108865	108865	276599
13217	14464	85	applied	\N	\N	\N	\N	108866	108866	276600
13217	14465	86	applied	\N	\N	\N	\N	108867	108867	276601
13217	14466	87	applied	\N	\N	\N	\N	108868	108868	276602
13217	14467	88	applied	\N	\N	\N	\N	108869	108869	276603
13217	14469	89	applied	\N	\N	\N	\N	108870	108870	276604
13217	14471	90	applied	\N	\N	\N	\N	108871	108871	276605
13217	14473	91	applied	\N	\N	\N	\N	108872	108872	276606
13217	14474	92	applied	\N	\N	\N	\N	108873	108873	276607
13217	14477	93	applied	\N	\N	\N	\N	108874	108874	276608
13217	14478	94	applied	\N	\N	\N	\N	108875	108875	276609
13217	14484	95	applied	\N	\N	\N	\N	108876	108876	276610
13217	14485	96	applied	\N	\N	\N	\N	108877	108877	276611
13217	14486	97	applied	\N	\N	\N	\N	108878	108878	276612
13217	14487	98	applied	\N	\N	\N	\N	108879	108879	276613
13217	14488	99	applied	\N	\N	\N	\N	108880	108880	276614
13217	14496	101	applied	\N	\N	\N	\N	108882	108882	276616
13217	14497	102	applied	\N	\N	\N	\N	108883	108883	276617
13217	14498	103	applied	\N	\N	\N	\N	108884	108884	276618
13217	14499	104	applied	\N	\N	\N	\N	108885	108885	276619
13217	14500	105	applied	\N	\N	\N	\N	108886	108886	276620
13217	14504	106	applied	\N	\N	\N	\N	108887	108887	276621
13217	14505	107	applied	\N	\N	\N	\N	108888	108888	276622
13217	14506	108	applied	\N	\N	\N	\N	108889	108889	276623
13217	14507	109	applied	\N	\N	\N	\N	108890	108890	276624
13217	14508	110	applied	\N	\N	\N	\N	108891	108891	276625
13217	14509	111	applied	\N	\N	\N	\N	108892	108892	276626
13217	14512	112	applied	\N	\N	\N	\N	108893	108893	276627
13217	14513	113	applied	\N	\N	\N	\N	108894	108894	276628
13217	14514	114	applied	\N	\N	\N	\N	108895	108895	276629
13217	14517	115	applied	\N	\N	\N	\N	108896	108896	276630
13217	14518	116	applied	\N	\N	\N	\N	108897	108897	276631
13217	14520	118	applied	\N	\N	\N	\N	108899	108899	276633
13217	14524	119	applied	\N	\N	\N	\N	108900	108900	276634
13217	14525	120	applied	\N	\N	\N	\N	108901	108901	276635
13217	14526	121	applied	\N	\N	\N	\N	108902	108902	276636
13217	14527	122	applied	\N	\N	\N	\N	108903	108903	276637
13217	14528	124	applied	\N	\N	\N	\N	108904	108904	276638
13217	14529	125	applied	\N	\N	\N	\N	108905	108905	276639
13222	14609	0	applied	\N	\N	\N	\N	108928	108928	276662
13222	14610	1	applied	\N	\N	\N	\N	108929	108929	276663
13222	14611	2	applied	\N	\N	\N	\N	108930	108930	276664
13229	14612	0	applied	\N	\N	\N	\N	109013	109013	276747
13229	14613	1	applied	\N	\N	\N	\N	109014	109014	276748
13229	14614	2	applied	\N	\N	\N	\N	109015	109015	276749
13229	14615	3	applied	\N	\N	\N	\N	109016	109016	276750
13229	14616	4	applied	\N	\N	\N	\N	109017	109017	276751
13229	14617	5	applied	\N	\N	\N	\N	109018	109018	276752
13234	14600	0	applied	\N	\N	\N	\N	109031	109031	276765
13234	14601	1	applied	\N	\N	\N	\N	109032	109032	276766
13234	14606	2	applied	\N	\N	\N	\N	109033	109033	276767
13234	14609	3	applied	\N	\N	\N	\N	109034	109034	276768
13234	14612	4	applied	\N	\N	\N	\N	109035	109035	276769
13234	14613	5	applied	\N	\N	\N	\N	109036	109036	276770
13234	14532	6	applied	\N	\N	\N	\N	109037	109037	276771
13234	14533	7	applied	\N	\N	\N	\N	109038	109038	276772
13234	14534	8	applied	\N	\N	\N	\N	109039	109039	276773
13234	14535	9	applied	\N	\N	\N	\N	109040	109040	276774
13234	14539	10	applied	\N	\N	\N	\N	109041	109041	276775
13234	14540	11	applied	\N	\N	\N	\N	109042	109042	276776
13234	14541	12	applied	\N	\N	\N	\N	109043	109043	276777
13234	14542	13	applied	\N	\N	\N	\N	109044	109044	276778
13234	14543	14	applied	\N	\N	\N	\N	109045	109045	276779
13234	14544	15	applied	\N	\N	\N	\N	109046	109046	276780
13234	14547	17	applied	\N	\N	\N	\N	109048	109048	276782
13234	14549	18	applied	\N	\N	\N	\N	109049	109049	276783
13234	14550	19	applied	\N	\N	\N	\N	109050	109050	276784
13234	14552	20	applied	\N	\N	\N	\N	109051	109051	276785
13234	14553	21	applied	\N	\N	\N	\N	109052	109052	276786
13234	14556	22	applied	\N	\N	\N	\N	109053	109053	276787
13234	14557	23	applied	\N	\N	\N	\N	109054	109054	276788
13234	14558	24	applied	\N	\N	\N	\N	109055	109055	276789
13234	14561	25	applied	\N	\N	\N	\N	109056	109056	276790
13234	14562	26	applied	\N	\N	\N	\N	109057	109057	276791
13234	14563	27	applied	\N	\N	\N	\N	109058	109058	276792
13234	14564	28	applied	\N	\N	\N	\N	109059	109059	276793
13234	14566	29	applied	\N	\N	\N	\N	109060	109060	276794
13234	14567	30	applied	\N	\N	\N	\N	109061	109061	276795
13234	14569	31	applied	\N	\N	\N	\N	109062	109062	276796
13234	14570	32	applied	\N	\N	\N	\N	109063	109063	276797
13234	14573	34	applied	\N	\N	\N	\N	109065	109065	276799
13234	14575	35	applied	\N	\N	\N	\N	109066	109066	276800
13234	14576	36	applied	\N	\N	\N	\N	109067	109067	276801
13234	14578	37	applied	\N	\N	\N	\N	109068	109068	276802
13234	14579	38	applied	\N	\N	\N	\N	109069	109069	276803
13234	14582	39	applied	\N	\N	\N	\N	109070	109070	276804
13234	14583	40	applied	\N	\N	\N	\N	109071	109071	276805
13234	14584	41	applied	\N	\N	\N	\N	109072	109072	276806
13234	14585	42	applied	\N	\N	\N	\N	109073	109073	276807
13234	14587	43	applied	\N	\N	\N	\N	109074	109074	276808
13234	14588	44	applied	\N	\N	\N	\N	109075	109075	276809
13234	14591	45	applied	\N	\N	\N	\N	109076	109076	276810
13234	14592	46	applied	\N	\N	\N	\N	109077	109077	276811
13234	14593	47	applied	\N	\N	\N	\N	109078	109078	276812
13234	14595	48	applied	\N	\N	\N	\N	109079	109079	276813
13234	14596	49	applied	\N	\N	\N	\N	109080	109080	276814
13234	14599	51	applied	\N	\N	\N	\N	109082	109082	276816
13234	14602	52	applied	\N	\N	\N	\N	109083	109083	276817
13234	14603	53	applied	\N	\N	\N	\N	109084	109084	276818
13234	14604	54	applied	\N	\N	\N	\N	109085	109085	276819
13234	14605	55	applied	\N	\N	\N	\N	109086	109086	276820
13235	14620	0	applied	\N	\N	\N	\N	109087	109087	276821
13238	14620	0	applied	\N	\N	\N	\N	109093	109093	276827
13238	14621	1	applied	\N	\N	\N	\N	109094	109094	276828
13238	14622	2	applied	\N	\N	\N	\N	109095	109095	276829
13249	14631	0	applied	\N	\N	\N	\N	109125	109125	276859
13249	14630	1	applied	\N	\N	\N	\N	109126	109126	276860
13249	14632	2	applied	\N	\N	\N	\N	109127	109127	276861
13249	14633	3	applied	\N	\N	\N	\N	109128	109128	276862
13250	14634	0	applied	\N	\N	\N	\N	109129	109129	276863
13217	14458	81	applied	\N	\N	\N	\N	108862	108862	276596
13217	14459	82	applied	\N	\N	\N	\N	108863	108863	276597
13226	14491	16	applied	\N	\N	\N	\N	108954	108954	276688
13226	14492	17	applied	\N	\N	\N	\N	108955	108955	276689
13226	14455	18	applied	\N	\N	\N	\N	108956	108956	276690
13226	14462	19	applied	\N	\N	\N	\N	108957	108957	276691
13226	14463	20	applied	\N	\N	\N	\N	108958	108958	276692
13226	14468	21	applied	\N	\N	\N	\N	108959	108959	276693
13226	14472	23	applied	\N	\N	\N	\N	108961	108961	276695
13226	14475	24	applied	\N	\N	\N	\N	108962	108962	276696
13226	14479	25	applied	\N	\N	\N	\N	108963	108963	276697
13226	14480	26	applied	\N	\N	\N	\N	108964	108964	276698
13226	14483	27	applied	\N	\N	\N	\N	108965	108965	276699
13226	14490	28	applied	\N	\N	\N	\N	108966	108966	276700
13226	14493	29	applied	\N	\N	\N	\N	108967	108967	276701
13226	14494	30	applied	\N	\N	\N	\N	108968	108968	276702
13226	14501	31	applied	\N	\N	\N	\N	108969	108969	276703
13226	14502	32	applied	\N	\N	\N	\N	108970	108970	276704
13226	14503	33	applied	\N	\N	\N	\N	108971	108971	276705
13226	14510	34	applied	\N	\N	\N	\N	108972	108972	276706
13226	14511	35	applied	\N	\N	\N	\N	108973	108973	276707
13226	14515	36	applied	\N	\N	\N	\N	108974	108974	276708
13226	14516	37	applied	\N	\N	\N	\N	108975	108975	276709
13226	14521	38	applied	\N	\N	\N	\N	108976	108976	276710
13226	14523	40	applied	\N	\N	\N	\N	108978	108978	276712
13226	14530	41	applied	\N	\N	\N	\N	108979	108979	276713
13226	14531	42	applied	\N	\N	\N	\N	108980	108980	276714
13226	14536	43	applied	\N	\N	\N	\N	108981	108981	276715
13226	14537	44	applied	\N	\N	\N	\N	108982	108982	276716
13226	14538	45	applied	\N	\N	\N	\N	108983	108983	276717
13226	14545	46	applied	\N	\N	\N	\N	108984	108984	276718
13226	14548	47	applied	\N	\N	\N	\N	108985	108985	276719
13226	14551	48	applied	\N	\N	\N	\N	108986	108986	276720
13226	14554	49	applied	\N	\N	\N	\N	108987	108987	276721
13226	14555	50	applied	\N	\N	\N	\N	108988	108988	276722
13226	14559	51	applied	\N	\N	\N	\N	108989	108989	276723
13226	14560	52	applied	\N	\N	\N	\N	108990	108990	276724
13226	14565	53	applied	\N	\N	\N	\N	108991	108991	276725
13226	14568	54	applied	\N	\N	\N	\N	108992	108992	276726
13226	14571	55	applied	\N	\N	\N	\N	108993	108993	276727
13226	14577	57	applied	\N	\N	\N	\N	108995	108995	276729
13226	14580	58	applied	\N	\N	\N	\N	108996	108996	276730
13226	14581	59	applied	\N	\N	\N	\N	108997	108997	276731
13226	14586	60	applied	\N	\N	\N	\N	108998	108998	276732
13226	14589	61	applied	\N	\N	\N	\N	108999	108999	276733
13226	14590	62	applied	\N	\N	\N	\N	109000	109000	276734
13226	14594	63	applied	\N	\N	\N	\N	109001	109001	276735
13226	14597	64	applied	\N	\N	\N	\N	109002	109002	276736
13226	14600	65	applied	\N	\N	\N	\N	109003	109003	276737
13226	14601	66	applied	\N	\N	\N	\N	109004	109004	276738
13226	14606	67	applied	\N	\N	\N	\N	109005	109005	276739
13226	14609	68	applied	\N	\N	\N	\N	109006	109006	276740
13228	14612	0	applied	\N	\N	\N	\N	109007	109007	276741
13228	14613	1	applied	\N	\N	\N	\N	109008	109008	276742
13228	14614	2	applied	\N	\N	\N	\N	109009	109009	276743
13228	14615	3	applied	\N	\N	\N	\N	109010	109010	276744
13228	14617	5	applied	\N	\N	\N	\N	109012	109012	276746
13230	14612	0	applied	\N	\N	\N	\N	109019	109019	276753
13230	14613	1	applied	\N	\N	\N	\N	109020	109020	276754
13230	14614	2	applied	\N	\N	\N	\N	109021	109021	276755
13230	14615	3	applied	\N	\N	\N	\N	109022	109022	276756
13230	14616	4	applied	\N	\N	\N	\N	109023	109023	276757
13230	14617	5	applied	\N	\N	\N	\N	109024	109024	276758
13230	14618	6	applied	\N	\N	\N	\N	109025	109025	276759
13241	14623	0	applied	\N	\N	\N	\N	109100	109100	276834
13241	14621	1	applied	\N	\N	\N	\N	109101	109101	276835
13241	14622	2	applied	\N	\N	\N	\N	109102	109102	276836
13241	14624	3	applied	\N	\N	\N	\N	109103	109103	276837
13243	14625	0	applied	\N	\N	\N	\N	109108	109108	276842
13243	14626	1	applied	\N	\N	\N	\N	109109	109109	276843
13243	14627	2	applied	\N	\N	\N	\N	109110	109110	276844
13243	14628	3	applied	\N	\N	\N	\N	109111	109111	276845
13245	14630	1	applied	\N	\N	\N	\N	109117	109117	276851
13248	14631	0	applied	\N	\N	\N	\N	109121	109121	276855
13248	14630	1	applied	\N	\N	\N	\N	109122	109122	276856
13248	14632	2	applied	\N	\N	\N	\N	109123	109123	276857
13248	14633	3	applied	\N	\N	\N	\N	109124	109124	276858
13250	14632	1	applied	\N	\N	\N	\N	109130	109130	276864
13250	14633	2	applied	\N	\N	\N	\N	109131	109131	276865
13250	14635	3	applied	\N	\N	\N	\N	109132	109132	276866
13252	14639	0	applied	\N	\N	\N	\N	109136	109136	276870
13252	14640	1	applied	\N	\N	\N	\N	109137	109137	276871
13252	14641	2	applied	\N	\N	\N	\N	109138	109138	276872
13258	14654	0	applied	\N	\N	\N	\N	109153	109153	276886
13258	14656	2	applied	\N	\N	\N	\N	109155	109155	276887
13258	14657	3	applied	\N	\N	\N	\N	109156	109156	276888
13260	14659	0	applied	\N	\N	\N	\N	109158	109158	276890
13260	14660	1	applied	\N	\N	1000000000	\N	109159	109159	276891
13260	14661	2	applied	\N	\N	\N	\N	109160	109160	276892
13260	14662	3	applied	\N	\N	\N	\N	109161	109161	276893
13260	14663	5	applied	\N	\N	\N	\N	109162	109162	276894
13261	14664	0	applied	\N	\N	\N	\N	109163	109163	276895
13261	14665	1	applied	\N	\N	\N	\N	109164	109164	276896
13261	14666	2	applied	\N	\N	\N	\N	109165	109165	276897
13261	14667	3	applied	\N	\N	\N	\N	109166	109166	276898
13261	14668	4	applied	\N	\N	\N	\N	109167	109167	276899
13263	14664	0	applied	\N	\N	\N	\N	109168	109168	276900
13263	14665	1	applied	\N	\N	\N	\N	109169	109169	276901
13263	14666	2	applied	\N	\N	\N	\N	109170	109170	276902
13263	14667	3	applied	\N	\N	\N	\N	109171	109171	276903
13267	14671	0	applied	\N	\N	\N	\N	109190	109190	276922
13267	14672	1	applied	\N	\N	\N	\N	109191	109191	276923
13267	14673	2	applied	\N	\N	\N	\N	109192	109192	276924
13270	14674	0	applied	\N	\N	\N	\N	109199	109199	276931
13270	14675	1	applied	\N	\N	\N	\N	109200	109200	276932
13270	14676	2	applied	\N	\N	\N	\N	109201	109201	276933
13282	14694	0	applied	\N	\N	\N	\N	109229	109229	276961
13282	14695	1	applied	\N	\N	\N	\N	109230	109230	276962
13282	14696	2	applied	\N	\N	\N	\N	109231	109231	276963
13286	14703	0	applied	\N	\N	\N	\N	109244	109244	276976
13286	14704	1	applied	\N	\N	\N	\N	109245	109245	276977
13226	14444	13	applied	\N	\N	\N	\N	108951	108951	276685
13226	14489	15	applied	\N	\N	\N	\N	108953	108953	276687
13271	14674	0	applied	\N	\N	\N	\N	109202	109202	276934
13271	14675	1	applied	\N	\N	\N	\N	109203	109203	276935
13271	14676	2	applied	\N	\N	\N	\N	109204	109204	276936
13272	14677	0	applied	\N	\N	\N	\N	109205	109205	276937
13272	14678	1	applied	\N	\N	\N	\N	109206	109206	276938
13276	14679	0	applied	\N	\N	\N	\N	109213	109213	276945
13276	14680	1	applied	\N	\N	\N	\N	109214	109214	276946
13276	14681	2	applied	\N	\N	\N	\N	109215	109215	276947
13279	14685	0	applied	\N	\N	\N	\N	109219	109219	276951
13279	14687	2	applied	\N	\N	\N	\N	109221	109221	276953
13279	14688	3	applied	\N	\N	\N	\N	109222	109222	276954
13279	14689	4	applied	\N	\N	\N	\N	109223	109223	276955
13279	14690	5	applied	\N	\N	\N	\N	109224	109224	276956
13279	14691	6	applied	\N	\N	\N	\N	109225	109225	276957
13279	14692	7	applied	\N	\N	\N	\N	109226	109226	276958
13279	14693	8	applied	\N	\N	\N	\N	109227	109227	276959
13283	14694	0	applied	\N	\N	\N	\N	109232	109232	276964
13283	14695	1	applied	\N	\N	\N	\N	109233	109233	276965
13283	14696	2	applied	\N	\N	\N	\N	109234	109234	276966
13284	14697	0	applied	\N	\N	\N	\N	109235	109235	276967
13284	14698	1	applied	\N	\N	\N	\N	109236	109236	276968
13284	14699	2	applied	\N	\N	\N	\N	109237	109237	276969
13284	14700	3	applied	\N	\N	\N	\N	109238	109238	276970
13284	14701	4	applied	\N	\N	\N	\N	109239	109239	276971
13284	14702	5	applied	\N	\N	\N	\N	109240	109240	276972
13288	14709	0	applied	\N	\N	\N	\N	109250	109250	276982
13288	14710	1	applied	\N	\N	\N	\N	109251	109251	276983
13288	14711	2	applied	\N	\N	\N	\N	109252	109252	276984
13289	14709	0	applied	\N	\N	\N	\N	109253	109253	276985
13289	14710	1	applied	\N	\N	\N	\N	109254	109254	276986
13289	14711	2	applied	\N	\N	\N	\N	109255	109255	276987
13291	14715	0	applied	\N	\N	\N	\N	109259	109259	276991
13291	14716	1	applied	\N	\N	\N	\N	109260	109260	276992
13291	14717	2	applied	\N	\N	\N	\N	109261	109261	276993
13291	14718	3	applied	\N	\N	\N	\N	109262	109262	276994
13291	14719	4	applied	\N	\N	\N	\N	109263	109263	276995
13291	14720	5	applied	\N	\N	\N	\N	109264	109264	276996
13292	14715	0	applied	\N	\N	\N	\N	109265	109265	276997
13292	14716	1	applied	\N	\N	\N	\N	109266	109266	276998
13292	14717	2	applied	\N	\N	\N	\N	109267	109267	276999
13292	14718	3	applied	\N	\N	\N	\N	109268	109268	277000
13292	14720	5	applied	\N	\N	\N	\N	109270	109270	277002
13294	14721	0	applied	\N	\N	\N	\N	109277	109277	277009
13294	14722	1	applied	\N	\N	\N	\N	109278	109278	277010
13294	14723	2	applied	\N	\N	\N	\N	109279	109279	277011
13294	14724	3	applied	\N	\N	\N	\N	109280	109280	277012
13294	14725	4	applied	\N	\N	\N	\N	109281	109281	277013
13294	14726	5	applied	\N	\N	\N	\N	109282	109282	277014
13296	14730	0	applied	\N	\N	\N	\N	109286	109286	277018
13296	14731	1	applied	\N	\N	\N	\N	109287	109287	277019
13297	14734	0	applied	\N	\N	1000000000	\N	109290	109290	277022
13297	14735	1	applied	\N	\N	\N	\N	109291	109291	277023
13297	14736	2	applied	\N	\N	\N	\N	109292	109292	277024
13297	14737	3	applied	\N	\N	\N	\N	109293	109293	277025
13297	14738	4	applied	\N	\N	\N	\N	109294	109294	277026
13297	14739	5	applied	\N	\N	\N	\N	109295	109295	277027
13309	14761	0	applied	\N	\N	\N	\N	109432	109432	277164
13309	14763	2	applied	\N	\N	\N	\N	109434	109434	277166
13311	14764	0	applied	\N	\N	\N	\N	109437	109437	277169
13311	14765	1	applied	\N	\N	\N	\N	109438	109438	277170
13311	14766	2	applied	\N	\N	\N	\N	109439	109439	277171
13315	14764	0	applied	\N	\N	\N	\N	109449	109449	277181
13315	14765	1	applied	\N	\N	\N	\N	109450	109450	277182
13315	14766	2	applied	\N	\N	\N	\N	109451	109451	277183
13320	14775	0	applied	\N	\N	\N	\N	109463	109463	277195
13320	14776	1	applied	\N	\N	\N	\N	109464	109464	277196
13320	14777	2	applied	\N	\N	\N	\N	109465	109465	277197
13326	14794	0	applied	\N	\N	\N	\N	109526	109526	277258
13326	14795	1	applied	\N	\N	\N	\N	109527	109527	277259
13326	14796	2	applied	\N	\N	\N	\N	109528	109528	277260
13326	14797	3	applied	\N	\N	\N	\N	109529	109529	277261
13326	14798	4	applied	\N	\N	\N	\N	109530	109530	277262
13326	14799	5	applied	\N	\N	\N	\N	109531	109531	277263
13331	14808	0	applied	\N	\N	\N	\N	109653	109653	277384
13331	14809	1	applied	\N	\N	\N	\N	109654	109654	277385
13331	14810	2	applied	\N	\N	\N	\N	109655	109655	277386
13331	14811	3	applied	\N	\N	1000000000	\N	109656	109656	277387
13331	14812	4	applied	\N	\N	1000000000	\N	109657	109657	277388
13335	14813	0	applied	\N	\N	\N	\N	109681	109681	277412
13335	14814	1	applied	\N	\N	\N	\N	109682	109682	277413
13335	14816	2	applied	\N	\N	\N	\N	109683	109683	277414
13335	14817	3	applied	\N	\N	\N	\N	109684	109684	277415
13335	14815	4	applied	\N	\N	\N	\N	109685	109685	277416
13335	14818	5	applied	\N	\N	\N	\N	109686	109686	277417
13335	14819	6	applied	\N	\N	1000000000	\N	109687	109687	277418
13335	14820	7	applied	\N	\N	\N	\N	109688	109688	277419
13335	14821	8	applied	\N	\N	\N	\N	109689	109689	277420
13335	14822	9	applied	\N	\N	\N	\N	109690	109690	277421
13338	14828	0	applied	\N	\N	\N	\N	109713	109713	277444
13338	14830	2	applied	\N	\N	\N	\N	109715	109715	277446
13338	14831	3	applied	\N	\N	\N	\N	109716	109716	277447
13341	14832	0	applied	\N	\N	\N	\N	109729	109729	277460
13341	14833	2	applied	\N	\N	\N	\N	109730	109730	277461
13341	14834	3	applied	\N	\N	\N	\N	109731	109731	277462
13341	14835	4	applied	\N	\N	\N	\N	109732	109732	277463
13341	14836	5	applied	\N	\N	\N	\N	109733	109733	277464
13341	14837	6	applied	\N	\N	\N	\N	109734	109734	277465
13341	14838	7	applied	\N	\N	\N	\N	109735	109735	277466
13341	14839	8	applied	\N	\N	\N	\N	109736	109736	277467
13343	14844	0	applied	\N	\N	\N	\N	109741	109741	277472
13343	14845	1	applied	\N	\N	\N	\N	109742	109742	277473
13343	14846	2	applied	\N	\N	\N	\N	109743	109743	277474
13343	14847	3	applied	\N	\N	\N	\N	109744	109744	277475
13345	14848	0	applied	\N	\N	\N	\N	109749	109749	277480
13345	14849	1	applied	\N	\N	\N	\N	109750	109750	277481
13352	14864	0	applied	\N	\N	\N	\N	109775	109775	277506
13352	14861	1	applied	\N	\N	\N	\N	109776	109776	277507
13352	14862	2	applied	\N	\N	\N	\N	109777	109777	277508
13352	14863	3	applied	\N	\N	\N	\N	109778	109778	277509
13263	14669	5	applied	\N	\N	\N	\N	109173	109173	276905
13263	14670	6	applied	\N	\N	\N	\N	109174	109174	276906
13264	14666	3	applied	\N	\N	\N	\N	109178	109178	276910
13264	14667	4	applied	\N	\N	\N	\N	109179	109179	276911
13264	14668	5	applied	\N	\N	\N	\N	109180	109180	276912
13264	14669	6	applied	\N	\N	\N	\N	109181	109181	276913
13264	14670	7	applied	\N	\N	\N	\N	109182	109182	276914
13268	14674	0	applied	\N	\N	\N	\N	109193	109193	276925
13268	14675	1	applied	\N	\N	\N	\N	109194	109194	276926
13268	14676	2	applied	\N	\N	\N	\N	109195	109195	276927
13273	14677	0	applied	\N	\N	\N	\N	109207	109207	276939
13273	14678	1	applied	\N	\N	\N	\N	109208	109208	276940
13277	14682	0	applied	\N	\N	\N	\N	109216	109216	276948
13277	14683	1	applied	\N	\N	\N	\N	109217	109217	276949
13277	14684	2	applied	\N	\N	\N	\N	109218	109218	276950
13287	14706	0	applied	\N	\N	\N	\N	109247	109247	276979
13287	14707	1	applied	\N	\N	\N	\N	109248	109248	276980
13287	14708	2	applied	\N	\N	\N	\N	109249	109249	276981
13293	14715	0	applied	\N	\N	\N	\N	109271	109271	277003
13293	14716	1	applied	\N	\N	\N	\N	109272	109272	277004
13293	14717	2	applied	\N	\N	\N	\N	109273	109273	277005
13293	14718	3	applied	\N	\N	\N	\N	109274	109274	277006
13293	14719	4	applied	\N	\N	\N	\N	109275	109275	277007
13293	14720	5	applied	\N	\N	\N	\N	109276	109276	277008
13300	14743	0	applied	\N	\N	\N	\N	109302	109302	277034
13300	14744	1	applied	\N	\N	\N	\N	109303	109303	277035
13300	14745	2	applied	\N	\N	\N	\N	109304	109304	277036
13305	14752	0	applied	\N	\N	\N	\N	109417	109417	277149
13305	14755	1	applied	\N	\N	\N	\N	109418	109418	277150
13305	14753	2	applied	\N	\N	\N	\N	109419	109419	277151
13305	14754	3	applied	\N	\N	\N	\N	109420	109420	277152
13305	14757	5	applied	\N	\N	\N	\N	109422	109422	277154
13307	14758	0	applied	\N	\N	\N	\N	109426	109426	277158
13307	14759	1	applied	\N	\N	\N	\N	109427	109427	277159
13307	14760	2	applied	\N	\N	\N	\N	109428	109428	277160
13312	14764	0	applied	\N	\N	\N	\N	109440	109440	277172
13312	14765	1	applied	\N	\N	\N	\N	109441	109441	277173
13312	14766	2	applied	\N	\N	\N	\N	109442	109442	277174
13318	14770	0	applied	\N	\N	\N	\N	109458	109458	277190
13318	14771	1	applied	\N	\N	\N	\N	109459	109459	277191
13321	14778	0	applied	\N	\N	\N	\N	109466	109466	277198
13321	14779	1	applied	\N	\N	\N	\N	109467	109467	277199
13321	14780	2	applied	\N	\N	\N	\N	109468	109468	277200
13324	14790	0	applied	\N	\N	\N	\N	109522	109522	277254
13324	14791	1	applied	\N	\N	\N	\N	109523	109523	277255
13324	14792	2	applied	\N	\N	\N	\N	109524	109524	277256
13329	14801	0	applied	\N	\N	\N	\N	109646	109646	277377
13329	14803	2	applied	\N	\N	\N	\N	109648	109648	277379
13332	14813	0	applied	\N	\N	\N	\N	109658	109658	277389
13332	14814	1	applied	\N	\N	\N	\N	109659	109659	277390
13332	14815	2	applied	\N	\N	\N	\N	109660	109660	277391
13336	14813	0	applied	\N	\N	\N	\N	109691	109691	277422
13336	14814	1	applied	\N	\N	\N	\N	109692	109692	277423
13336	14816	2	applied	\N	\N	\N	\N	109693	109693	277424
13336	14817	3	applied	\N	\N	\N	\N	109694	109694	277425
13336	14815	4	applied	\N	\N	\N	\N	109695	109695	277426
13336	14818	5	applied	\N	\N	\N	\N	109696	109696	277427
13336	14819	6	applied	\N	\N	1000000000	\N	109697	109697	277428
13336	14820	7	applied	\N	\N	\N	\N	109698	109698	277429
13336	14821	8	applied	\N	\N	\N	\N	109699	109699	277430
13336	14822	9	applied	\N	\N	\N	\N	109700	109700	277431
13339	14828	0	applied	\N	\N	\N	\N	109717	109717	277448
13339	14829	1	applied	\N	\N	\N	\N	109718	109718	277449
13339	14831	3	applied	\N	\N	\N	\N	109720	109720	277451
13344	14844	0	applied	\N	\N	\N	\N	109745	109745	277476
13344	14845	1	applied	\N	\N	\N	\N	109746	109746	277477
13344	14846	2	applied	\N	\N	\N	\N	109747	109747	277478
13344	14847	3	applied	\N	\N	\N	\N	109748	109748	277479
13346	14851	0	applied	\N	\N	\N	\N	109752	109752	277483
13346	14852	1	applied	\N	\N	\N	\N	109753	109753	277484
13346	14853	2	applied	\N	\N	\N	\N	109754	109754	277485
13346	14854	3	applied	\N	\N	\N	\N	109755	109755	277486
13352	14865	4	applied	\N	\N	\N	\N	109779	109779	277510
13352	14866	5	applied	\N	\N	\N	\N	109780	109780	277511
13352	14867	6	applied	\N	\N	\N	\N	109781	109781	277512
13353	14864	0	applied	\N	\N	\N	\N	109782	109782	277513
13353	14865	1	applied	\N	\N	\N	\N	109783	109783	277514
13353	14866	2	applied	\N	\N	\N	\N	109784	109784	277515
13355	14868	0	applied	\N	\N	\N	\N	109788	109788	277519
13355	14870	2	applied	\N	\N	\N	\N	109790	109790	277521
13356	14868	0	applied	\N	\N	\N	\N	109791	109791	277522
13356	14869	1	applied	\N	\N	\N	\N	109792	109792	277523
13356	14870	2	applied	\N	\N	\N	\N	109793	109793	277524
13357	14868	0	applied	\N	\N	\N	\N	109794	109794	277525
13357	14867	1	applied	\N	\N	\N	\N	109795	109795	277526
13357	14869	2	applied	\N	\N	\N	\N	109796	109796	277527
13357	14870	3	applied	\N	\N	\N	\N	109797	109797	277528
13358	14868	0	applied	\N	\N	\N	\N	109798	109798	277529
13358	14869	1	applied	\N	\N	\N	\N	109799	109799	277530
13362	14734	0	applied	\N	\N	1000000000	\N	109811	109811	277542
13362	14407	1	applied	\N	\N	\N	\N	109812	109812	277543
13367	14885	0	applied	\N	\N	\N	\N	109959	109959	277688
13367	14886	1	applied	\N	\N	\N	\N	109960	109960	277689
13367	14887	2	applied	\N	\N	\N	\N	109961	109961	277690
13367	14888	3	applied	\N	\N	\N	\N	109962	109962	277691
13367	14890	5	applied	\N	\N	\N	\N	109964	109964	277693
13367	14891	6	applied	\N	\N	\N	\N	109965	109965	277694
13369	14892	0	applied	\N	\N	\N	\N	109973	109973	277702
13369	14893	1	applied	\N	\N	\N	\N	109974	109974	277703
13369	14894	2	applied	\N	\N	\N	\N	109975	109975	277704
13369	14895	3	applied	\N	\N	\N	\N	109976	109976	277705
13369	14896	4	applied	\N	\N	\N	\N	109977	109977	277706
13369	14897	5	applied	\N	\N	\N	\N	109978	109978	277707
13369	14898	6	applied	\N	\N	\N	\N	109979	109979	277708
13369	14899	7	applied	\N	\N	\N	\N	109980	109980	277709
13372	14900	0	applied	\N	\N	\N	\N	109999	109999	277728
13372	14901	1	applied	\N	\N	\N	\N	110000	110000	277729
13372	14902	2	applied	\N	\N	\N	\N	110001	110001	277730
13375	14911	0	applied	\N	\N	\N	\N	110010	110010	277739
13375	14912	1	applied	\N	\N	\N	\N	110011	110011	277740
13375	14913	2	applied	\N	\N	\N	\N	110012	110012	277741
13264	14665	1	applied	\N	\N	\N	\N	109176	109176	276908
13264	14671	2	applied	\N	\N	\N	\N	109177	109177	276909
13299	14741	1	applied	\N	\N	\N	\N	109300	109300	277032
13299	14742	2	applied	\N	\N	\N	\N	109301	109301	277033
13304	14746	0	applied	\N	\N	\N	\N	109408	109408	277140
13304	14747	1	applied	\N	\N	\N	\N	109409	109409	277141
13304	14752	2	applied	\N	\N	\N	\N	109410	109410	277142
13304	14748	3	applied	\N	\N	\N	\N	109411	109411	277143
13304	14749	4	applied	\N	\N	\N	\N	109412	109412	277144
13304	14750	5	applied	\N	\N	\N	\N	109413	109413	277145
13304	14751	6	applied	\N	\N	\N	\N	109414	109414	277146
13304	14753	7	applied	\N	\N	\N	\N	109415	109415	277147
13304	14754	8	applied	\N	\N	\N	\N	109416	109416	277148
13306	14755	0	applied	\N	\N	\N	\N	109423	109423	277155
13306	14756	1	applied	\N	\N	\N	\N	109424	109424	277156
13308	14758	0	applied	\N	\N	\N	\N	109429	109429	277161
13308	14759	1	applied	\N	\N	\N	\N	109430	109430	277162
13308	14760	2	applied	\N	\N	\N	\N	109431	109431	277163
13314	14764	0	applied	\N	\N	\N	\N	109446	109446	277178
13314	14765	1	applied	\N	\N	\N	\N	109447	109447	277179
13314	14766	2	applied	\N	\N	\N	\N	109448	109448	277180
13316	14764	0	applied	\N	\N	\N	\N	109452	109452	277184
13316	14765	1	applied	\N	\N	\N	\N	109453	109453	277185
13316	14766	2	applied	\N	\N	\N	\N	109454	109454	277186
13317	14767	0	applied	\N	\N	\N	\N	109455	109455	277187
13317	14768	1	applied	\N	\N	\N	\N	109456	109456	277188
13317	14769	2	applied	\N	\N	\N	\N	109457	109457	277189
13323	14781	0	applied	\N	\N	\N	\N	109513	109513	277245
13323	14782	1	applied	\N	\N	\N	\N	109514	109514	277246
13323	14783	2	applied	\N	\N	\N	\N	109515	109515	277247
13323	14784	3	applied	\N	\N	\N	\N	109516	109516	277248
13323	14786	5	applied	\N	\N	\N	\N	109518	109518	277250
13323	14787	6	applied	\N	\N	\N	\N	109519	109519	277251
13323	14788	7	applied	\N	\N	\N	\N	109520	109520	277252
13323	14789	8	applied	\N	\N	\N	\N	109521	109521	277253
13325	14793	0	applied	\N	\N	\N	\N	109525	109525	277257
13328	14801	0	applied	\N	\N	\N	\N	109643	109643	277374
13328	14802	1	applied	\N	\N	\N	\N	109644	109644	277375
13328	14803	2	applied	\N	\N	\N	\N	109645	109645	277376
13330	14804	0	applied	\N	\N	\N	\N	109649	109649	277380
13330	14805	1	applied	\N	\N	\N	\N	109650	109650	277381
13330	14806	2	applied	\N	\N	\N	\N	109651	109651	277382
13330	14807	3	applied	\N	\N	\N	\N	109652	109652	277383
13334	14813	0	applied	\N	\N	\N	\N	109671	109671	277402
13334	14814	1	applied	\N	\N	\N	\N	109672	109672	277403
13334	14816	2	applied	\N	\N	\N	\N	109673	109673	277404
13334	14817	3	applied	\N	\N	\N	\N	109674	109674	277405
13334	14818	5	applied	\N	\N	\N	\N	109676	109676	277407
13334	14819	6	applied	\N	\N	1000000000	\N	109677	109677	277408
13334	14820	7	applied	\N	\N	\N	\N	109678	109678	277409
13334	14821	8	applied	\N	\N	\N	\N	109679	109679	277410
13334	14822	9	applied	\N	\N	\N	\N	109680	109680	277411
13337	14823	0	applied	\N	\N	\N	\N	109701	109701	277432
13337	14824	1	applied	\N	\N	\N	\N	109702	109702	277433
13337	14816	2	applied	\N	\N	\N	\N	109703	109703	277434
13337	14817	3	applied	\N	\N	\N	\N	109704	109704	277435
13337	14818	4	applied	\N	\N	\N	\N	109705	109705	277436
13337	14819	5	applied	\N	\N	1000000000	\N	109706	109706	277437
13337	14820	6	applied	\N	\N	\N	\N	109707	109707	277438
13337	14821	7	applied	\N	\N	\N	\N	109708	109708	277439
13337	14822	8	applied	\N	\N	\N	\N	109709	109709	277440
13337	14825	9	applied	\N	\N	\N	\N	109710	109710	277441
13337	14826	10	applied	\N	\N	\N	\N	109711	109711	277442
13340	14832	0	applied	\N	\N	\N	\N	109721	109721	277452
13340	14833	2	applied	\N	\N	\N	\N	109722	109722	277453
13340	14834	3	applied	\N	\N	\N	\N	109723	109723	277454
13340	14835	4	applied	\N	\N	\N	\N	109724	109724	277455
13340	14836	5	applied	\N	\N	\N	\N	109725	109725	277456
13340	14837	6	applied	\N	\N	\N	\N	109726	109726	277457
13340	14838	7	applied	\N	\N	\N	\N	109727	109727	277458
13340	14839	8	applied	\N	\N	\N	\N	109728	109728	277459
13342	14840	0	applied	\N	\N	\N	\N	109737	109737	277468
13342	14841	1	applied	\N	\N	\N	\N	109738	109738	277469
13342	14842	2	applied	\N	\N	\N	\N	109739	109739	277470
13342	14843	3	applied	\N	\N	\N	\N	109740	109740	277471
13347	14855	0	applied	\N	\N	\N	\N	109756	109756	277487
13347	14856	1	applied	\N	\N	\N	\N	109757	109757	277488
13347	14857	2	applied	\N	\N	\N	\N	109758	109758	277489
13347	14858	3	applied	\N	\N	\N	\N	109759	109759	277490
13348	14855	0	applied	\N	\N	\N	\N	109761	109761	277492
13348	14856	1	applied	\N	\N	\N	\N	109762	109762	277493
13348	14857	2	applied	\N	\N	\N	\N	109763	109763	277494
13348	14858	3	applied	\N	\N	\N	\N	109764	109764	277495
13348	14859	4	applied	\N	\N	\N	\N	109765	109765	277496
13350	14860	0	applied	\N	\N	\N	\N	109770	109770	277501
13350	14861	1	applied	\N	\N	\N	\N	109771	109771	277502
13350	14862	2	applied	\N	\N	\N	\N	109772	109772	277503
13350	14863	3	applied	\N	\N	\N	\N	109773	109773	277504
13354	14868	0	applied	\N	\N	\N	\N	109785	109785	277516
13354	14869	1	applied	\N	\N	\N	\N	109786	109786	277517
13354	14870	2	applied	\N	\N	\N	\N	109787	109787	277518
13361	14871	0	applied	\N	\N	\N	\N	109807	109807	277538
13361	14872	1	applied	\N	\N	\N	\N	109808	109808	277539
13361	14873	2	applied	\N	\N	\N	\N	109809	109809	277540
13361	14874	3	applied	\N	\N	\N	\N	109810	109810	277541
13365	14883	1	applied	\N	\N	\N	\N	109944	109944	277674
13365	14884	2	applied	\N	\N	\N	\N	109945	109945	277675
13368	14885	0	applied	\N	\N	\N	\N	109966	109966	277695
13368	14886	1	applied	\N	\N	\N	\N	109967	109967	277696
13376	14915	0	applied	\N	\N	\N	\N	110014	110014	277743
13376	14916	1	applied	\N	\N	\N	\N	110015	110015	277744
13376	14917	2	applied	\N	\N	\N	\N	110016	110016	277745
13376	14918	3	applied	\N	\N	\N	\N	110017	110017	277746
13379	14928	0	applied	\N	\N	\N	\N	110027	110027	277756
13379	14929	1	applied	\N	\N	\N	\N	110028	110028	277757
13379	14930	2	applied	\N	\N	\N	\N	110029	110029	277758
13379	14931	3	applied	\N	\N	\N	\N	110030	110030	277759
13382	14944	0	applied	\N	\N	\N	\N	110047	110047	277776
13382	14945	1	applied	\N	\N	\N	\N	110048	110048	277777
13382	14946	2	applied	\N	\N	\N	\N	110049	110049	277778
13382	14947	3	applied	\N	\N	\N	\N	110050	110050	277779
13296	14733	3	applied	\N	\N	\N	\N	109289	109289	277021
13299	14740	0	applied	\N	\N	\N	\N	109299	109299	277031
13301	14681	50	applied	\N	\N	\N	\N	109354	109354	277086
13301	14683	51	applied	\N	\N	\N	\N	109355	109355	277087
13301	14684	52	applied	\N	\N	\N	\N	109356	109356	277088
13301	14688	53	applied	\N	\N	\N	\N	109357	109357	277089
13301	14689	54	applied	\N	\N	\N	\N	109358	109358	277090
13301	14690	55	applied	\N	\N	\N	\N	109359	109359	277091
13301	14691	56	applied	\N	\N	\N	\N	109360	109360	277092
13301	14692	57	applied	\N	\N	\N	\N	109361	109361	277093
13301	14693	58	applied	\N	\N	\N	\N	109362	109362	277094
13301	14695	59	applied	\N	\N	\N	\N	109363	109363	277095
13301	14696	60	applied	\N	\N	\N	\N	109364	109364	277096
13301	14699	61	applied	\N	\N	\N	\N	109365	109365	277097
13301	14700	62	applied	\N	\N	\N	\N	109366	109366	277098
13301	14701	63	applied	\N	\N	\N	\N	109367	109367	277099
13301	14702	64	applied	\N	\N	\N	\N	109368	109368	277100
13301	14704	65	applied	\N	\N	\N	\N	109369	109369	277101
13301	14707	67	applied	\N	\N	\N	\N	109371	109371	277103
13301	14708	68	applied	\N	\N	\N	\N	109372	109372	277104
13301	14710	69	applied	\N	\N	\N	\N	109373	109373	277105
13301	14711	70	applied	\N	\N	\N	\N	109374	109374	277106
13301	14713	71	applied	\N	\N	\N	\N	109375	109375	277107
13301	14714	72	applied	\N	\N	\N	\N	109376	109376	277108
13301	14717	73	applied	\N	\N	\N	\N	109377	109377	277109
13301	14718	74	applied	\N	\N	\N	\N	109378	109378	277110
13301	14719	75	applied	\N	\N	\N	\N	109379	109379	277111
13301	14720	76	applied	\N	\N	\N	\N	109380	109380	277112
13301	14724	77	applied	\N	\N	\N	\N	109381	109381	277113
13301	14725	78	applied	\N	\N	\N	\N	109382	109382	277114
13301	14726	79	applied	\N	\N	\N	\N	109383	109383	277115
13301	14728	80	applied	\N	\N	\N	\N	109384	109384	277116
13301	14729	81	applied	\N	\N	\N	\N	109385	109385	277117
13301	14732	82	applied	\N	\N	\N	\N	109386	109386	277118
13301	14737	84	applied	\N	\N	\N	\N	109388	109388	277120
13301	14738	85	applied	\N	\N	\N	\N	109389	109389	277121
13301	14739	86	applied	\N	\N	\N	\N	109390	109390	277122
13301	14741	87	applied	\N	\N	\N	\N	109391	109391	277123
13301	14742	88	applied	\N	\N	\N	\N	109392	109392	277124
13301	14744	89	applied	\N	\N	\N	\N	109393	109393	277125
13301	14745	90	applied	\N	\N	\N	\N	109394	109394	277126
13301	14748	91	applied	\N	\N	\N	\N	109395	109395	277127
13301	14749	92	applied	\N	\N	\N	\N	109396	109396	277128
13301	14750	93	applied	\N	\N	\N	\N	109397	109397	277129
13301	14751	94	applied	\N	\N	\N	\N	109398	109398	277130
13303	14746	0	applied	\N	\N	\N	\N	109399	109399	277131
13303	14747	1	applied	\N	\N	\N	\N	109400	109400	277132
13303	14752	2	applied	\N	\N	\N	\N	109401	109401	277133
13303	14748	3	applied	\N	\N	\N	\N	109402	109402	277134
13303	14749	4	applied	\N	\N	\N	\N	109403	109403	277135
13303	14751	6	applied	\N	\N	\N	\N	109405	109405	277137
13303	14753	7	applied	\N	\N	\N	\N	109406	109406	277138
13303	14754	8	applied	\N	\N	\N	\N	109407	109407	277139
13310	14761	0	applied	\N	\N	\N	\N	109435	109435	277167
13310	14762	1	applied	\N	\N	\N	\N	109436	109436	277168
13313	14764	0	applied	\N	\N	\N	\N	109443	109443	277175
13313	14765	1	applied	\N	\N	\N	\N	109444	109444	277176
13313	14766	2	applied	\N	\N	\N	\N	109445	109445	277177
13319	14772	0	applied	\N	\N	\N	\N	109460	109460	277192
13319	14773	1	applied	\N	\N	\N	\N	109461	109461	277193
13319	14774	2	applied	\N	\N	\N	\N	109462	109462	277194
13322	14746	0	applied	\N	\N	\N	\N	109469	109469	277201
13322	14747	1	applied	\N	\N	\N	\N	109470	109470	277202
13322	14752	2	applied	\N	\N	\N	\N	109471	109471	277203
13322	14755	3	applied	\N	\N	\N	\N	109472	109472	277204
13322	14758	4	applied	\N	\N	\N	\N	109473	109473	277205
13322	14764	6	applied	\N	\N	\N	\N	109475	109475	277207
13322	14767	7	applied	\N	\N	\N	\N	109476	109476	277208
13322	14770	8	applied	\N	\N	\N	\N	109477	109477	277209
13322	14772	9	applied	\N	\N	\N	\N	109478	109478	277210
13322	14775	10	applied	\N	\N	\N	\N	109479	109479	277211
13322	14778	11	applied	\N	\N	\N	\N	109480	109480	277212
13322	14781	12	applied	\N	\N	\N	\N	109481	109481	277213
13322	14782	13	applied	\N	\N	\N	\N	109482	109482	277214
13322	14783	14	applied	\N	\N	\N	\N	109483	109483	277215
13322	14748	15	applied	\N	\N	\N	\N	109484	109484	277216
13322	14749	16	applied	\N	\N	\N	\N	109485	109485	277217
13322	14750	17	applied	\N	\N	\N	\N	109486	109486	277218
13322	14751	18	applied	\N	\N	\N	\N	109487	109487	277219
13322	14753	19	applied	\N	\N	\N	\N	109488	109488	277220
13322	14754	20	applied	\N	\N	\N	\N	109489	109489	277221
13322	14756	21	applied	\N	\N	\N	\N	109490	109490	277222
13322	14759	23	applied	\N	\N	\N	\N	109492	109492	277224
13322	14760	24	applied	\N	\N	\N	\N	109493	109493	277225
13322	14762	25	applied	\N	\N	\N	\N	109494	109494	277226
13322	14763	26	applied	\N	\N	\N	\N	109495	109495	277227
13322	14765	27	applied	\N	\N	\N	\N	109496	109496	277228
13322	14766	28	applied	\N	\N	\N	\N	109497	109497	277229
13322	14768	29	applied	\N	\N	\N	\N	109498	109498	277230
13322	14769	30	applied	\N	\N	\N	\N	109499	109499	277231
13322	14771	31	applied	\N	\N	\N	\N	109500	109500	277232
13322	14773	32	applied	\N	\N	\N	\N	109501	109501	277233
13322	14774	33	applied	\N	\N	\N	\N	109502	109502	277234
13322	14776	34	applied	\N	\N	\N	\N	109503	109503	277235
13322	14777	35	applied	\N	\N	\N	\N	109504	109504	277236
13322	14779	36	applied	\N	\N	\N	\N	109505	109505	277237
13322	14780	37	applied	\N	\N	\N	\N	109506	109506	277238
13322	14784	38	applied	\N	\N	\N	\N	109507	109507	277239
13322	14786	40	applied	\N	\N	\N	\N	109509	109509	277241
13368	14887	2	applied	\N	\N	\N	\N	109968	109968	277697
13368	14888	3	applied	\N	\N	\N	\N	109969	109969	277698
13368	14889	4	applied	\N	\N	\N	\N	109970	109970	277699
13368	14890	5	applied	\N	\N	\N	\N	109971	109971	277700
13368	14891	6	applied	\N	\N	\N	\N	109972	109972	277701
13370	14801	0	applied	\N	\N	\N	\N	109981	109981	277710
13370	14804	1	applied	\N	\N	\N	\N	109982	109982	277711
13370	14808	2	applied	\N	\N	\N	\N	109983	109983	277712
13370	14813	4	applied	\N	\N	\N	\N	109984	109984	277713
13370	14814	5	applied	\N	\N	\N	\N	109985	109985	277714
13370	14823	6	applied	\N	\N	\N	\N	109986	109986	277715
13370	14828	7	applied	\N	\N	\N	\N	109987	109987	277716
13373	14911	0	applied	\N	\N	\N	\N	110002	110002	277731
13301	14676	47	applied	\N	\N	\N	\N	109351	109351	277083
13301	14678	48	applied	\N	\N	\N	\N	109352	109352	277084
13327	14734	0	applied	\N	\N	1000000000	\N	109533	109533	277265
13327	14660	2	applied	\N	\N	1000000000	\N	109535	109535	277266
13327	14731	3	applied	\N	\N	\N	\N	109536	109536	277267
13327	14501	4	applied	\N	\N	\N	\N	109537	109537	277268
13327	14502	5	applied	\N	\N	\N	\N	109538	109538	277269
13327	14503	6	applied	\N	\N	\N	\N	109539	109539	277270
13327	14510	7	applied	\N	\N	\N	\N	109540	109540	277271
13327	14511	8	applied	\N	\N	\N	\N	109541	109541	277272
13327	14515	9	applied	\N	\N	\N	\N	109542	109542	277273
13327	14516	10	applied	\N	\N	\N	\N	109543	109543	277274
13327	14521	11	applied	\N	\N	\N	\N	109544	109544	277275
13327	14522	12	applied	\N	\N	\N	\N	109545	109545	277276
13327	14523	13	applied	\N	\N	\N	\N	109546	109546	277277
13327	14530	14	applied	\N	\N	\N	\N	109547	109547	277278
13327	14531	15	applied	\N	\N	\N	\N	109548	109548	277279
13327	14536	16	applied	\N	\N	\N	\N	109549	109549	277280
13327	14537	17	applied	\N	\N	\N	\N	109550	109550	277281
13327	14538	18	applied	\N	\N	\N	\N	109551	109551	277282
13327	14545	19	applied	\N	\N	\N	\N	109552	109552	277283
13327	14548	20	applied	\N	\N	\N	\N	109553	109553	277284
13327	14551	21	applied	\N	\N	\N	\N	109554	109554	277285
13327	14554	22	applied	\N	\N	\N	\N	109555	109555	277286
13327	14555	23	applied	\N	\N	\N	\N	109556	109556	277287
13327	14559	24	applied	\N	\N	\N	\N	109557	109557	277288
13327	14560	25	applied	\N	\N	\N	\N	109558	109558	277289
13327	14565	26	applied	\N	\N	\N	\N	109559	109559	277290
13327	14568	27	applied	\N	\N	\N	\N	109560	109560	277291
13327	14571	28	applied	\N	\N	\N	\N	109561	109561	277292
13327	14574	29	applied	\N	\N	\N	\N	109562	109562	277293
13327	14580	31	applied	\N	\N	\N	\N	109564	109564	277295
13327	14581	32	applied	\N	\N	\N	\N	109565	109565	277296
13327	14586	33	applied	\N	\N	\N	\N	109566	109566	277297
13327	14589	34	applied	\N	\N	\N	\N	109567	109567	277298
13327	14590	35	applied	\N	\N	\N	\N	109568	109568	277299
13327	14594	36	applied	\N	\N	\N	\N	109569	109569	277300
13327	14597	37	applied	\N	\N	\N	\N	109570	109570	277301
13327	14600	38	applied	\N	\N	\N	\N	109571	109571	277302
13327	14601	39	applied	\N	\N	\N	\N	109572	109572	277303
13327	14606	40	applied	\N	\N	\N	\N	109573	109573	277304
13327	14609	41	applied	\N	\N	\N	\N	109574	109574	277305
13327	14612	42	applied	\N	\N	\N	\N	109575	109575	277306
13327	14613	43	applied	\N	\N	\N	\N	109576	109576	277307
13327	14620	44	applied	\N	\N	\N	\N	109577	109577	277308
13327	14623	45	applied	\N	\N	\N	\N	109578	109578	277309
13327	14625	46	applied	\N	\N	\N	\N	109579	109579	277310
13327	14631	48	applied	\N	\N	\N	\N	109581	109581	277312
13327	14634	49	applied	\N	\N	\N	\N	109582	109582	277313
13327	14636	50	applied	\N	\N	\N	\N	109583	109583	277314
13327	14639	51	applied	\N	\N	\N	\N	109584	109584	277315
13327	14642	52	applied	\N	\N	\N	\N	109585	109585	277316
13327	14643	53	applied	\N	\N	\N	\N	109586	109586	277317
13327	14648	54	applied	\N	\N	\N	\N	109587	109587	277318
13327	14649	55	applied	\N	\N	\N	\N	109588	109588	277319
13327	14654	56	applied	\N	\N	\N	\N	109589	109589	277320
13327	14658	57	applied	\N	\N	\N	\N	109590	109590	277321
13327	14659	58	applied	\N	\N	\N	\N	109591	109591	277322
13327	14664	59	applied	\N	\N	\N	\N	109592	109592	277323
13327	14665	60	applied	\N	\N	\N	\N	109593	109593	277324
13327	14671	61	applied	\N	\N	\N	\N	109594	109594	277325
13327	14672	62	applied	\N	\N	\N	\N	109595	109595	277326
13327	14674	63	applied	\N	\N	\N	\N	109596	109596	277327
13327	14679	65	applied	\N	\N	\N	\N	109598	109598	277329
13327	14682	66	applied	\N	\N	\N	\N	109599	109599	277330
13327	14685	67	applied	\N	\N	\N	\N	109600	109600	277331
13327	14686	68	applied	\N	\N	\N	\N	109601	109601	277332
13327	14687	69	applied	\N	\N	\N	\N	109602	109602	277333
13327	14694	70	applied	\N	\N	\N	\N	109603	109603	277334
13327	14697	71	applied	\N	\N	\N	\N	109604	109604	277335
13327	14698	72	applied	\N	\N	\N	\N	109605	109605	277336
13327	14703	73	applied	\N	\N	\N	\N	109606	109606	277337
13327	14706	74	applied	\N	\N	\N	\N	109607	109607	277338
13327	14709	75	applied	\N	\N	\N	\N	109608	109608	277339
13327	14712	76	applied	\N	\N	\N	\N	109609	109609	277340
13327	14715	77	applied	\N	\N	\N	\N	109610	109610	277341
13327	14716	78	applied	\N	\N	\N	\N	109611	109611	277342
13327	14721	79	applied	\N	\N	\N	\N	109612	109612	277343
13327	14722	80	applied	\N	\N	\N	\N	109613	109613	277344
13327	14730	82	applied	\N	\N	\N	\N	109615	109615	277346
13327	14735	83	applied	\N	\N	\N	\N	109616	109616	277347
13327	14736	84	applied	\N	\N	\N	\N	109617	109617	277348
13327	14740	85	applied	\N	\N	\N	\N	109618	109618	277349
13327	14743	86	applied	\N	\N	\N	\N	109619	109619	277350
13327	14746	87	applied	\N	\N	\N	\N	109620	109620	277351
13327	14747	88	applied	\N	\N	\N	\N	109621	109621	277352
13327	14752	89	applied	\N	\N	\N	\N	109622	109622	277353
13327	14755	90	applied	\N	\N	\N	\N	109623	109623	277354
13327	14758	91	applied	\N	\N	\N	\N	109624	109624	277355
13327	14761	92	applied	\N	\N	\N	\N	109625	109625	277356
13327	14764	93	applied	\N	\N	\N	\N	109626	109626	277357
13327	14767	94	applied	\N	\N	\N	\N	109627	109627	277358
13327	14770	95	applied	\N	\N	\N	\N	109628	109628	277359
13327	14772	96	applied	\N	\N	\N	\N	109629	109629	277360
13327	14775	97	applied	\N	\N	\N	\N	109630	109630	277361
13327	14781	99	applied	\N	\N	\N	\N	109632	109632	277363
13327	14782	100	applied	\N	\N	\N	\N	109633	109633	277364
13327	14783	101	applied	\N	\N	\N	\N	109634	109634	277365
13327	14790	102	applied	\N	\N	\N	\N	109635	109635	277366
13327	14793	103	applied	\N	\N	\N	\N	109636	109636	277367
13327	14794	104	applied	\N	\N	\N	\N	109637	109637	277368
13327	14795	105	applied	\N	\N	\N	\N	109638	109638	277369
13327	14723	106	applied	\N	\N	\N	\N	109639	109639	277370
13327	14504	107	applied	\N	\N	\N	\N	109640	109640	277371
13327	14505	108	applied	\N	\N	\N	\N	109641	109641	277372
13327	14506	109	applied	\N	\N	\N	\N	109642	109642	277373
13333	14813	0	applied	\N	\N	\N	\N	109661	109661	277392
13333	14814	1	applied	\N	\N	\N	\N	109662	109662	277393
13333	14816	2	applied	\N	\N	\N	\N	109663	109663	277394
13333	14817	3	applied	\N	\N	\N	\N	109664	109664	277395
13333	14815	4	applied	\N	\N	\N	\N	109665	109665	277396
13322	14788	42	applied	\N	\N	\N	\N	109511	109511	277243
13322	14789	43	applied	\N	\N	\N	\N	109512	109512	277244
13333	14822	9	applied	\N	\N	\N	\N	109670	109670	277401
13349	14860	0	applied	\N	\N	\N	\N	109766	109766	277497
13349	14861	1	applied	\N	\N	\N	\N	109767	109767	277498
13349	14862	2	applied	\N	\N	\N	\N	109768	109768	277499
13349	14863	3	applied	\N	\N	\N	\N	109769	109769	277500
13351	14860	0	applied	\N	\N	\N	\N	109774	109774	277505
13359	14868	0	applied	\N	\N	\N	\N	109800	109800	277531
13359	14869	2	applied	\N	\N	\N	\N	109802	109802	277533
13360	14871	0	applied	\N	\N	\N	\N	109803	109803	277534
13360	14872	1	applied	\N	\N	\N	\N	109804	109804	277535
13360	14873	2	applied	\N	\N	\N	\N	109805	109805	277536
13360	14874	3	applied	\N	\N	\N	\N	109806	109806	277537
13362	14428	2	applied	\N	\N	\N	\N	109813	109813	277544
13362	14448	3	applied	\N	\N	\N	\N	109814	109814	277545
13362	14435	4	applied	\N	\N	\N	\N	109815	109815	277546
13362	14454	5	applied	\N	\N	\N	\N	109816	109816	277547
13362	14436	6	applied	\N	\N	\N	\N	109817	109817	277548
13362	14476	7	applied	\N	\N	\N	\N	109818	109818	277549
13362	14481	8	applied	\N	\N	\N	\N	109819	109819	277550
13362	14439	9	applied	\N	\N	\N	\N	109820	109820	277551
13362	14444	10	applied	\N	\N	\N	\N	109821	109821	277552
13362	14482	11	applied	\N	\N	\N	\N	109822	109822	277553
13362	14489	12	applied	\N	\N	\N	\N	109823	109823	277554
13362	14492	14	applied	\N	\N	\N	\N	109825	109825	277556
13362	14660	16	applied	\N	\N	1000000000	\N	109827	109827	277557
13362	14655	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	109826	109826	\N
13362	14731	17	applied	\N	\N	\N	\N	109828	109828	277558
13362	14239	18	applied	\N	\N	\N	\N	109829	109829	277559
13362	14242	19	applied	\N	\N	\N	\N	109830	109830	277560
13362	14245	20	applied	\N	\N	\N	\N	109831	109831	277561
13362	14246	21	applied	\N	\N	\N	\N	109832	109832	277562
13362	14252	22	applied	\N	\N	\N	\N	109833	109833	277563
13362	14255	23	applied	\N	\N	\N	\N	109834	109834	277564
13362	14259	24	applied	\N	\N	\N	\N	109835	109835	277565
13362	14260	25	applied	\N	\N	\N	\N	109836	109836	277566
13362	14267	26	applied	\N	\N	\N	\N	109837	109837	277567
13362	14271	27	applied	\N	\N	\N	\N	109838	109838	277568
13362	14275	28	applied	\N	\N	\N	\N	109839	109839	277569
13362	14279	29	applied	\N	\N	\N	\N	109840	109840	277570
13364	14876	0	applied	\N	\N	\N	\N	109937	109937	277667
13364	14877	1	applied	\N	\N	\N	\N	109938	109938	277668
13364	14878	2	applied	\N	\N	\N	\N	109939	109939	277669
13364	14879	3	applied	\N	\N	\N	\N	109940	109940	277670
13364	14880	4	applied	\N	\N	\N	\N	109941	109941	277671
13364	14881	5	applied	\N	\N	\N	\N	109942	109942	277672
13377	14919	0	applied	\N	\N	\N	\N	110018	110018	277747
13377	14920	1	applied	\N	\N	\N	\N	110019	110019	277748
13377	14921	2	applied	\N	\N	\N	\N	110020	110020	277749
13377	14922	3	applied	\N	\N	\N	\N	110021	110021	277750
13380	14928	0	applied	\N	\N	\N	\N	110031	110031	277760
13385	14952	0	applied	\N	\N	\N	\N	110071	110071	277800
13385	14953	1	applied	\N	\N	\N	\N	110072	110072	277801
13385	14954	2	applied	\N	\N	\N	\N	110073	110073	277802
13397	14971	0	applied	\N	\N	\N	\N	110120	110120	277849
13397	14972	1	applied	\N	\N	\N	\N	110121	110121	277850
13397	14974	3	applied	\N	\N	\N	\N	110123	110123	277852
13397	14975	4	applied	\N	\N	\N	\N	110124	110124	277853
13397	14976	5	applied	\N	\N	\N	\N	110125	110125	277854
13397	14977	6	applied	\N	\N	\N	\N	110126	110126	277855
13399	14979	0	applied	\N	\N	\N	\N	110135	110135	277864
13399	14980	1	applied	\N	\N	\N	\N	110136	110136	277865
13399	14978	2	applied	\N	\N	\N	\N	110137	110137	277866
13399	14981	3	applied	\N	\N	\N	\N	110138	110138	277867
13399	14982	4	applied	\N	\N	\N	\N	110139	110139	277868
13399	14983	5	applied	\N	\N	\N	\N	110140	110140	277869
13399	14984	6	applied	\N	\N	\N	\N	110141	110141	277870
13402	14985	0	applied	\N	\N	\N	\N	110155	110155	277884
13402	14986	1	applied	\N	\N	\N	\N	110156	110156	277885
13402	14987	2	applied	\N	\N	\N	\N	110157	110157	277886
13402	14988	3	applied	\N	\N	\N	\N	110158	110158	277887
13402	14989	4	applied	\N	\N	\N	\N	110159	110159	277888
13406	14991	0	applied	\N	\N	\N	\N	110172	110172	277901
13419	15033	0	applied	\N	\N	\N	\N	110221	110221	277950
13419	15034	1	applied	\N	\N	\N	\N	110222	110222	277951
13419	15035	2	applied	\N	\N	\N	\N	110223	110223	277952
13423	15042	0	applied	\N	\N	\N	\N	110242	110242	277971
13423	15043	1	applied	\N	\N	\N	\N	110243	110243	277972
13423	15045	2	applied	\N	\N	\N	\N	110244	110244	277973
13423	15046	3	applied	\N	\N	\N	\N	110245	110245	277974
13423	15047	4	applied	\N	\N	\N	\N	110246	110246	277975
13423	15048	5	applied	\N	\N	\N	\N	110247	110247	277976
13423	15049	6	applied	\N	\N	\N	\N	110248	110248	277977
13423	15050	7	applied	\N	\N	\N	\N	110249	110249	277978
13423	15044	8	applied	\N	\N	\N	\N	110250	110250	277979
13429	15059	0	applied	\N	\N	\N	\N	110271	110271	278000
13429	15060	1	applied	\N	\N	\N	\N	110272	110272	278001
13429	15061	2	applied	\N	\N	\N	\N	110273	110273	278002
13431	15063	0	applied	\N	\N	\N	\N	110279	110279	278008
13431	15064	1	applied	\N	\N	\N	\N	110280	110280	278009
13431	15065	2	applied	\N	\N	\N	\N	110281	110281	278010
13432	15066	0	applied	\N	\N	\N	\N	110282	110282	278011
13432	15067	1	applied	\N	\N	\N	\N	110283	110283	278012
13432	15068	2	applied	\N	\N	\N	\N	110284	110284	278013
13432	15069	3	applied	\N	\N	\N	\N	110285	110285	278014
13432	15070	4	applied	\N	\N	\N	\N	110286	110286	278015
13432	15071	5	applied	\N	\N	\N	\N	110287	110287	278016
13432	15072	6	applied	\N	\N	\N	\N	110288	110288	278017
13432	15073	7	applied	\N	\N	\N	\N	110289	110289	278018
13432	15074	8	applied	\N	\N	\N	\N	110290	110290	278019
13432	15075	9	applied	\N	\N	\N	\N	110291	110291	278020
13432	15076	10	applied	\N	\N	\N	\N	110292	110292	278021
13432	15077	11	applied	\N	\N	\N	\N	110293	110293	278022
13435	15082	0	applied	\N	\N	\N	\N	110302	110302	278031
13435	15084	2	applied	\N	\N	\N	\N	110304	110304	278033
13435	15085	3	applied	\N	\N	\N	\N	110305	110305	278034
13437	15086	0	applied	\N	\N	\N	\N	110307	110307	278036
13437	15087	1	applied	\N	\N	\N	\N	110308	110308	278037
13437	15088	2	applied	\N	\N	\N	\N	110309	110309	278038
13437	15089	3	applied	\N	\N	\N	\N	110310	110310	278039
13333	14820	7	applied	\N	\N	\N	\N	109668	109668	277399
13333	14821	8	applied	\N	\N	\N	\N	109669	109669	277400
13362	14296	34	applied	\N	\N	\N	\N	109845	109845	277575
13362	14297	35	applied	\N	\N	\N	\N	109846	109846	277576
13362	14304	36	applied	\N	\N	\N	\N	109847	109847	277577
13362	14308	37	applied	\N	\N	\N	\N	109848	109848	277578
13362	14311	38	applied	\N	\N	\N	\N	109849	109849	277579
13362	14315	40	applied	\N	\N	\N	\N	109851	109851	277581
13362	14322	41	applied	\N	\N	\N	\N	109852	109852	277582
13362	14326	42	applied	\N	\N	\N	\N	109853	109853	277583
13362	14327	43	applied	\N	\N	\N	\N	109854	109854	277584
13362	14328	44	applied	\N	\N	\N	\N	109855	109855	277585
13362	14338	45	applied	\N	\N	\N	\N	109856	109856	277586
13362	14341	46	applied	\N	\N	\N	\N	109857	109857	277587
13362	14345	47	applied	\N	\N	\N	\N	109858	109858	277588
13362	14348	48	applied	\N	\N	\N	\N	109859	109859	277589
13362	14349	49	applied	\N	\N	\N	\N	109860	109860	277590
13362	14350	50	applied	\N	\N	\N	\N	109861	109861	277591
13362	14360	51	applied	\N	\N	\N	\N	109862	109862	277592
13362	14367	52	applied	\N	\N	\N	\N	109863	109863	277593
13362	14368	53	applied	\N	\N	\N	\N	109864	109864	277594
13362	14369	54	applied	\N	\N	\N	\N	109865	109865	277595
13362	14370	55	applied	\N	\N	\N	\N	109866	109866	277596
13362	14384	57	applied	\N	\N	\N	\N	109868	109868	277598
13362	14388	58	applied	\N	\N	\N	\N	109869	109869	277599
13362	14392	59	applied	\N	\N	\N	\N	109870	109870	277600
13362	14396	60	applied	\N	\N	\N	\N	109871	109871	277601
13362	14397	61	applied	\N	\N	\N	\N	109872	109872	277602
13362	14404	62	applied	\N	\N	\N	\N	109873	109873	277603
13362	14408	63	applied	\N	\N	\N	\N	109874	109874	277604
13362	14409	64	applied	\N	\N	\N	\N	109875	109875	277605
13362	14410	65	applied	\N	\N	\N	\N	109876	109876	277606
13362	14411	66	applied	\N	\N	\N	\N	109877	109877	277607
13362	14412	67	applied	\N	\N	\N	\N	109878	109878	277608
13362	14413	68	applied	\N	\N	\N	\N	109879	109879	277609
13362	14429	69	applied	\N	\N	\N	\N	109880	109880	277610
13362	14433	70	applied	\N	\N	\N	\N	109881	109881	277611
13362	14437	71	applied	\N	\N	\N	\N	109882	109882	277612
13362	14438	72	applied	\N	\N	\N	\N	109883	109883	277613
13362	14449	74	applied	\N	\N	\N	\N	109885	109885	277615
13362	14452	75	applied	\N	\N	\N	\N	109886	109886	277616
13362	14453	76	applied	\N	\N	\N	\N	109887	109887	277617
13362	14455	77	applied	\N	\N	\N	\N	109888	109888	277618
13362	14462	78	applied	\N	\N	\N	\N	109889	109889	277619
13362	14463	79	applied	\N	\N	\N	\N	109890	109890	277620
13362	14468	80	applied	\N	\N	\N	\N	109891	109891	277621
13362	14470	81	applied	\N	\N	\N	\N	109892	109892	277622
13362	14472	82	applied	\N	\N	\N	\N	109893	109893	277623
13362	14475	83	applied	\N	\N	\N	\N	109894	109894	277624
13362	14479	84	applied	\N	\N	\N	\N	109895	109895	277625
13362	14480	85	applied	\N	\N	\N	\N	109896	109896	277626
13362	14483	86	applied	\N	\N	\N	\N	109897	109897	277627
13362	14490	87	applied	\N	\N	\N	\N	109898	109898	277628
13362	14493	88	applied	\N	\N	\N	\N	109899	109899	277629
13362	14494	89	applied	\N	\N	\N	\N	109900	109900	277630
13362	14502	92	applied	\N	\N	\N	\N	109902	109902	277632
13362	14503	93	applied	\N	\N	\N	\N	109903	109903	277633
13362	14510	94	applied	\N	\N	\N	\N	109904	109904	277634
13362	14511	95	applied	\N	\N	\N	\N	109905	109905	277635
13362	14515	96	applied	\N	\N	\N	\N	109906	109906	277636
13362	14516	97	applied	\N	\N	\N	\N	109907	109907	277637
13362	14521	98	applied	\N	\N	\N	\N	109908	109908	277638
13362	14522	99	applied	\N	\N	\N	\N	109909	109909	277639
13362	14523	100	applied	\N	\N	\N	\N	109910	109910	277640
13362	14530	101	applied	\N	\N	\N	\N	109911	109911	277641
13362	14531	102	applied	\N	\N	\N	\N	109912	109912	277642
13362	14536	103	applied	\N	\N	\N	\N	109913	109913	277643
13362	14537	104	applied	\N	\N	\N	\N	109914	109914	277644
13362	14538	105	applied	\N	\N	\N	\N	109915	109915	277645
13362	14545	106	applied	\N	\N	\N	\N	109916	109916	277646
13362	14548	107	applied	\N	\N	\N	\N	109917	109917	277647
13362	14554	109	applied	\N	\N	\N	\N	109919	109919	277649
13362	14555	110	applied	\N	\N	\N	\N	109920	109920	277650
13362	14559	111	applied	\N	\N	\N	\N	109921	109921	277651
13362	14560	112	applied	\N	\N	\N	\N	109922	109922	277652
13362	14565	113	applied	\N	\N	\N	\N	109923	109923	277653
13362	14568	114	applied	\N	\N	\N	\N	109924	109924	277654
13362	14571	115	applied	\N	\N	\N	\N	109925	109925	277655
13362	14574	116	applied	\N	\N	\N	\N	109926	109926	277656
13362	14577	117	applied	\N	\N	\N	\N	109927	109927	277657
13362	14580	118	applied	\N	\N	\N	\N	109928	109928	277658
13362	14581	119	applied	\N	\N	\N	\N	109929	109929	277659
13362	14586	120	applied	\N	\N	\N	\N	109930	109930	277660
13362	14589	121	applied	\N	\N	\N	\N	109931	109931	277661
13362	14590	122	applied	\N	\N	\N	\N	109932	109932	277662
13362	14594	123	applied	\N	\N	\N	\N	109933	109933	277663
13362	14597	124	applied	\N	\N	\N	\N	109934	109934	277664
13363	14875	0	applied	\N	\N	\N	\N	109936	109936	277666
13366	14734	0	applied	\N	\N	1000000000	\N	109946	109946	277676
13366	14482	1	applied	\N	\N	\N	\N	109947	109947	277677
13366	14489	2	applied	\N	\N	\N	\N	109948	109948	277678
13366	14491	3	applied	\N	\N	\N	\N	109949	109949	277679
13366	14492	4	applied	\N	\N	\N	\N	109950	109950	277680
13366	14660	6	applied	\N	\N	1000000000	\N	109952	109952	277681
13366	14731	7	applied	\N	\N	\N	\N	109953	109953	277682
13366	14805	8	applied	\N	\N	\N	\N	109954	109954	277683
13366	14723	9	applied	\N	\N	\N	\N	109955	109955	277684
13366	14815	10	applied	\N	\N	\N	\N	109956	109956	277685
13366	14824	11	applied	\N	\N	\N	\N	109957	109957	277686
13366	14874	12	applied	\N	\N	\N	\N	109958	109958	277687
13371	14900	0	applied	\N	\N	\N	\N	109988	109988	277717
13371	14901	1	applied	\N	\N	\N	\N	109989	109989	277718
13371	14903	3	applied	\N	\N	\N	\N	109991	109991	277720
13371	14904	4	applied	\N	\N	\N	\N	109992	109992	277721
13371	14905	5	applied	\N	\N	\N	\N	109993	109993	277722
13371	14906	6	applied	\N	\N	\N	\N	109994	109994	277723
13371	14907	7	applied	\N	\N	\N	\N	109995	109995	277724
13371	14908	8	applied	\N	\N	\N	\N	109996	109996	277725
13371	14909	9	applied	\N	\N	\N	\N	109997	109997	277726
13371	14910	10	applied	\N	\N	\N	\N	109998	109998	277727
13362	14290	32	applied	\N	\N	\N	\N	109843	109843	277573
13362	14291	33	applied	\N	\N	\N	\N	109844	109844	277574
13374	14912	1	applied	\N	\N	\N	\N	110007	110007	277736
13374	14913	2	applied	\N	\N	\N	\N	110008	110008	277737
13374	14914	3	applied	\N	\N	\N	\N	110009	110009	277738
13378	14923	0	applied	\N	\N	\N	\N	110022	110022	277751
13378	14924	1	applied	\N	\N	\N	\N	110023	110023	277752
13378	14925	2	applied	\N	\N	\N	\N	110024	110024	277753
13378	14926	3	applied	\N	\N	\N	\N	110025	110025	277754
13378	14927	4	applied	\N	\N	\N	\N	110026	110026	277755
13381	14932	0	applied	\N	\N	\N	\N	110032	110032	277761
13381	14933	1	applied	\N	\N	\N	\N	110033	110033	277762
13381	14934	2	applied	\N	\N	\N	\N	110034	110034	277763
13381	14929	3	applied	\N	\N	\N	\N	110035	110035	277764
13381	14930	4	applied	\N	\N	\N	\N	110036	110036	277765
13381	14931	5	applied	\N	\N	\N	\N	110037	110037	277766
13381	14936	7	applied	\N	\N	\N	\N	110039	110039	277768
13381	14937	8	applied	\N	\N	\N	\N	110040	110040	277769
13381	14938	9	applied	\N	\N	\N	\N	110041	110041	277770
13381	14939	10	applied	\N	\N	\N	\N	110042	110042	277771
13381	14940	11	applied	\N	\N	1000000000	\N	110043	110043	277772
13381	14941	12	applied	\N	\N	\N	\N	110044	110044	277773
13381	14942	13	applied	\N	\N	\N	\N	110045	110045	277774
13381	14943	14	applied	\N	\N	\N	\N	110046	110046	277775
13383	14944	0	applied	\N	\N	\N	\N	110055	110055	277784
13383	14945	1	applied	\N	\N	\N	\N	110056	110056	277785
13383	14946	2	applied	\N	\N	\N	\N	110057	110057	277786
13383	14947	3	applied	\N	\N	\N	\N	110058	110058	277787
13383	14948	4	applied	\N	\N	\N	\N	110059	110059	277788
13383	14949	5	applied	\N	\N	\N	\N	110060	110060	277789
13383	14950	6	applied	\N	\N	\N	\N	110061	110061	277790
13383	14951	7	applied	\N	\N	\N	\N	110062	110062	277791
13384	14945	1	applied	\N	\N	\N	\N	110064	110064	277793
13384	14946	2	applied	\N	\N	\N	\N	110065	110065	277794
13384	14947	3	applied	\N	\N	\N	\N	110066	110066	277795
13384	14948	4	applied	\N	\N	\N	\N	110067	110067	277796
13384	14949	5	applied	\N	\N	\N	\N	110068	110068	277797
13384	14950	6	applied	\N	\N	\N	\N	110069	110069	277798
13384	14951	7	applied	\N	\N	\N	\N	110070	110070	277799
13386	14955	0	applied	\N	\N	\N	\N	110074	110074	277803
13386	14956	1	applied	\N	\N	\N	\N	110075	110075	277804
13386	14957	2	applied	\N	\N	\N	\N	110076	110076	277805
13388	14958	0	applied	\N	\N	\N	\N	110080	110080	277809
13388	14959	1	applied	\N	\N	\N	\N	110081	110081	277810
13388	14960	2	applied	\N	\N	\N	\N	110082	110082	277811
13390	14961	0	applied	\N	\N	\N	\N	110083	110083	277812
13390	14962	1	applied	\N	\N	\N	\N	110084	110084	277813
13390	14963	2	applied	\N	\N	\N	\N	110085	110085	277814
13391	14962	1	applied	\N	\N	\N	\N	110087	110087	277816
13391	14963	2	applied	\N	\N	\N	\N	110088	110088	277817
13393	14964	0	applied	\N	\N	\N	\N	110092	110092	277821
13393	14965	1	applied	\N	\N	\N	\N	110093	110093	277822
13393	14966	2	applied	\N	\N	\N	\N	110094	110094	277823
13393	14967	3	applied	\N	\N	\N	\N	110095	110095	277824
13393	14968	4	applied	\N	\N	\N	\N	110096	110096	277825
13393	14969	5	applied	\N	\N	\N	\N	110097	110097	277826
13393	14970	6	applied	\N	\N	\N	\N	110098	110098	277827
13395	14964	0	applied	\N	\N	\N	\N	110106	110106	277835
13395	14965	1	applied	\N	\N	\N	\N	110107	110107	277836
13395	14966	2	applied	\N	\N	\N	\N	110108	110108	277837
13395	14967	3	applied	\N	\N	\N	\N	110109	110109	277838
13395	14968	4	applied	\N	\N	\N	\N	110110	110110	277839
13395	14969	5	applied	\N	\N	\N	\N	110111	110111	277840
13395	14970	6	applied	\N	\N	\N	\N	110112	110112	277841
13398	14972	1	applied	\N	\N	\N	\N	110128	110128	277857
13398	14973	2	applied	\N	\N	\N	\N	110129	110129	277858
13398	14974	3	applied	\N	\N	\N	\N	110130	110130	277859
13398	14975	4	applied	\N	\N	\N	\N	110131	110131	277860
13398	14976	5	applied	\N	\N	\N	\N	110132	110132	277861
13398	14977	6	applied	\N	\N	\N	\N	110133	110133	277862
13398	14978	7	applied	\N	\N	\N	\N	110134	110134	277863
13400	14979	0	applied	\N	\N	\N	\N	110142	110142	277871
13400	14980	1	applied	\N	\N	\N	\N	110143	110143	277872
13400	14978	2	applied	\N	\N	\N	\N	110144	110144	277873
13400	14981	3	applied	\N	\N	\N	\N	110145	110145	277874
13400	14982	4	applied	\N	\N	\N	\N	110146	110146	277875
13400	14983	5	applied	\N	\N	\N	\N	110147	110147	277876
13400	14984	6	applied	\N	\N	\N	\N	110148	110148	277877
13403	14985	0	applied	\N	\N	\N	\N	110161	110161	277890
13403	14986	1	applied	\N	\N	\N	\N	110162	110162	277891
13404	14985	0	applied	\N	\N	\N	\N	110164	110164	277893
13404	14986	1	applied	\N	\N	\N	\N	110165	110165	277894
13404	14987	2	applied	\N	\N	\N	\N	110166	110166	277895
13404	14988	3	applied	\N	\N	\N	\N	110167	110167	277896
13404	14989	4	applied	\N	\N	\N	\N	110168	110168	277897
13404	14990	5	applied	\N	\N	\N	\N	110169	110169	277898
13408	14991	0	applied	\N	\N	\N	\N	110177	110177	277906
13408	14992	1	applied	\N	\N	\N	\N	110178	110178	277907
13408	14993	2	applied	\N	\N	\N	\N	110179	110179	277908
13408	14994	3	applied	\N	\N	\N	\N	110180	110180	277909
13412	15007	0	applied	\N	\N	\N	\N	110193	110193	277922
13412	15008	1	applied	\N	\N	\N	\N	110194	110194	277923
13412	15009	2	applied	\N	\N	\N	\N	110195	110195	277924
13412	15010	3	applied	\N	\N	\N	\N	110196	110196	277925
13412	15011	4	applied	\N	\N	\N	\N	110197	110197	277926
13412	15012	5	applied	\N	\N	\N	\N	110198	110198	277927
13415	15019	1	applied	\N	\N	\N	\N	110207	110207	277936
13418	15030	0	applied	\N	\N	\N	\N	110218	110218	277947
13418	15031	1	applied	\N	\N	\N	\N	110219	110219	277948
13418	15032	2	applied	\N	\N	\N	\N	110220	110220	277949
13421	15042	0	applied	\N	\N	\N	\N	110230	110230	277959
13421	15043	1	applied	\N	\N	\N	\N	110231	110231	277960
13421	15044	2	applied	\N	\N	\N	\N	110232	110232	277961
13426	15055	0	applied	\N	\N	\N	\N	110265	110265	277994
13433	15078	0	applied	\N	\N	\N	\N	110294	110294	278023
13433	15079	1	applied	\N	\N	\N	\N	110295	110295	278024
13433	15080	2	applied	\N	\N	\N	\N	110296	110296	278025
13433	15081	3	applied	\N	\N	\N	\N	110297	110297	278026
13439	15086	0	applied	\N	\N	\N	\N	110312	110312	278041
13439	15087	1	applied	\N	\N	\N	\N	110313	110313	278042
13439	15088	2	applied	\N	\N	\N	\N	110314	110314	278043
13439	15089	3	applied	\N	\N	\N	\N	110315	110315	278044
13374	14911	0	applied	\N	\N	\N	\N	110006	110006	277735
13387	14956	1	applied	\N	\N	\N	\N	110078	110078	277807
13387	14957	2	applied	\N	\N	\N	\N	110079	110079	277808
13392	14961	0	applied	\N	\N	\N	\N	110089	110089	277818
13392	14962	1	applied	\N	\N	\N	\N	110090	110090	277819
13392	14963	2	applied	\N	\N	\N	\N	110091	110091	277820
13394	14964	0	applied	\N	\N	\N	\N	110099	110099	277828
13394	14965	1	applied	\N	\N	\N	\N	110100	110100	277829
13394	14966	2	applied	\N	\N	\N	\N	110101	110101	277830
13394	14967	3	applied	\N	\N	\N	\N	110102	110102	277831
13394	14968	4	applied	\N	\N	\N	\N	110103	110103	277832
13394	14969	5	applied	\N	\N	\N	\N	110104	110104	277833
13394	14970	6	applied	\N	\N	\N	\N	110105	110105	277834
13396	14971	0	applied	\N	\N	\N	\N	110113	110113	277842
13396	14972	1	applied	\N	\N	\N	\N	110114	110114	277843
13396	14973	2	applied	\N	\N	\N	\N	110115	110115	277844
13396	14974	3	applied	\N	\N	\N	\N	110116	110116	277845
13396	14976	5	applied	\N	\N	\N	\N	110118	110118	277847
13396	14977	6	applied	\N	\N	\N	\N	110119	110119	277848
13401	14985	0	applied	\N	\N	\N	\N	110149	110149	277878
13401	14986	1	applied	\N	\N	\N	\N	110150	110150	277879
13401	14987	2	applied	\N	\N	\N	\N	110151	110151	277880
13401	14988	3	applied	\N	\N	\N	\N	110152	110152	277881
13401	14989	4	applied	\N	\N	\N	\N	110153	110153	277882
13401	14990	5	applied	\N	\N	\N	\N	110154	110154	277883
13405	14985	0	applied	\N	\N	\N	\N	110170	110170	277899
13405	14986	1	applied	\N	\N	\N	\N	110171	110171	277900
13407	14991	0	applied	\N	\N	\N	\N	110173	110173	277902
13407	14992	1	applied	\N	\N	\N	\N	110174	110174	277903
13407	14993	2	applied	\N	\N	\N	\N	110175	110175	277904
13407	14994	3	applied	\N	\N	\N	\N	110176	110176	277905
13409	14995	0	applied	\N	\N	\N	\N	110181	110181	277910
13409	14996	1	applied	\N	\N	\N	\N	110182	110182	277911
13409	14998	3	applied	\N	\N	\N	\N	110184	110184	277913
13409	14999	4	applied	\N	\N	\N	\N	110185	110185	277914
13409	15000	5	applied	\N	\N	\N	\N	110186	110186	277915
13409	15001	6	applied	\N	\N	\N	\N	110187	110187	277916
13409	15002	7	applied	\N	\N	\N	\N	110188	110188	277917
13411	15003	0	applied	\N	\N	\N	\N	110189	110189	277918
13411	15004	1	applied	\N	\N	\N	\N	110190	110190	277919
13411	15005	2	applied	\N	\N	\N	\N	110191	110191	277920
13411	15006	3	applied	\N	\N	\N	\N	110192	110192	277921
13413	15013	0	applied	\N	\N	\N	\N	110199	110199	277928
13413	15014	1	applied	\N	\N	\N	\N	110200	110200	277929
13414	15013	0	applied	\N	\N	\N	\N	110201	110201	277930
13414	15014	1	applied	\N	\N	\N	\N	110202	110202	277931
13414	15015	2	applied	\N	\N	\N	\N	110203	110203	277932
13414	15016	3	applied	\N	\N	\N	\N	110204	110204	277933
13414	15017	4	applied	\N	\N	\N	\N	110205	110205	277934
13416	15021	1	applied	\N	\N	\N	\N	110209	110209	277938
13416	15022	2	applied	\N	\N	\N	\N	110210	110210	277939
13416	15023	3	applied	\N	\N	\N	\N	110211	110211	277940
13416	15024	4	applied	\N	\N	\N	\N	110212	110212	277941
13416	15025	5	applied	\N	\N	\N	\N	110213	110213	277942
13416	15026	6	applied	\N	\N	\N	\N	110214	110214	277943
13416	15027	7	applied	\N	\N	\N	\N	110215	110215	277944
13416	15028	8	applied	\N	\N	\N	\N	110216	110216	277945
13416	15029	9	applied	\N	\N	\N	\N	110217	110217	277946
13420	15036	0	applied	\N	\N	\N	\N	110224	110224	277953
13420	15037	1	applied	\N	\N	\N	\N	110225	110225	277954
13420	15038	2	applied	\N	\N	\N	\N	110226	110226	277955
13420	15039	3	applied	\N	\N	\N	\N	110227	110227	277956
13420	15040	4	applied	\N	\N	\N	\N	110228	110228	277957
13420	15041	5	applied	\N	\N	\N	\N	110229	110229	277958
13422	15042	0	applied	\N	\N	\N	\N	110233	110233	277962
13422	15045	2	applied	\N	\N	\N	\N	110235	110235	277964
13422	15046	3	applied	\N	\N	\N	\N	110236	110236	277965
13422	15047	4	applied	\N	\N	\N	\N	110237	110237	277966
13422	15048	5	applied	\N	\N	\N	\N	110238	110238	277967
13422	15049	6	applied	\N	\N	\N	\N	110239	110239	277968
13422	15050	7	applied	\N	\N	\N	\N	110240	110240	277969
13422	15044	8	applied	\N	\N	\N	\N	110241	110241	277970
13424	15051	0	applied	\N	\N	\N	\N	110251	110251	277980
13424	15045	1	applied	\N	\N	\N	\N	110252	110252	277981
13424	15046	2	applied	\N	\N	\N	\N	110253	110253	277982
13424	15047	3	applied	\N	\N	\N	\N	110254	110254	277983
13424	15048	4	applied	\N	\N	\N	\N	110255	110255	277984
13424	15049	5	applied	\N	\N	\N	\N	110256	110256	277985
13424	15050	6	applied	\N	\N	\N	\N	110257	110257	277986
13424	15052	7	applied	\N	\N	\N	\N	110258	110258	277987
13424	15053	8	applied	\N	\N	\N	\N	110259	110259	277988
13425	15055	0	applied	\N	\N	\N	\N	110261	110261	277990
13425	15056	1	applied	\N	\N	\N	\N	110262	110262	277991
13425	15057	2	applied	\N	\N	\N	\N	110263	110263	277992
13425	15058	3	applied	\N	\N	\N	\N	110264	110264	277993
13427	15055	0	applied	\N	\N	\N	\N	110266	110266	277995
13427	15056	1	applied	\N	\N	\N	\N	110267	110267	277996
13427	15057	2	applied	\N	\N	\N	\N	110268	110268	277997
13427	15058	3	applied	\N	\N	\N	\N	110269	110269	277998
13428	15055	0	applied	\N	\N	\N	\N	110270	110270	277999
13430	15059	0	applied	\N	\N	\N	\N	110275	110275	278004
13430	15060	1	applied	\N	\N	\N	\N	110276	110276	278005
13430	15061	2	applied	\N	\N	\N	\N	110277	110277	278006
13430	15062	3	applied	\N	\N	\N	\N	110278	110278	278007
13434	15082	0	applied	\N	\N	\N	\N	110298	110298	278027
13434	15083	1	applied	\N	\N	\N	\N	110299	110299	278028
13434	15084	2	applied	\N	\N	\N	\N	110300	110300	278029
13436	15086	0	applied	\N	\N	\N	\N	110306	110306	278035
13438	15086	0	applied	\N	\N	\N	\N	110311	110311	278040
13441	15090	0	applied	\N	\N	\N	\N	110316	110316	278045
13441	15091	1	applied	\N	\N	\N	\N	110317	110317	278046
13441	15092	2	applied	\N	\N	\N	\N	110318	110318	278047
13441	15093	3	applied	\N	\N	\N	\N	110319	110319	278048
13441	15094	4	applied	\N	\N	\N	\N	110320	110320	278049
13441	15095	5	applied	\N	\N	\N	\N	110321	110321	278050
13441	15096	6	applied	\N	\N	\N	\N	110322	110322	278051
13441	15097	7	applied	\N	\N	\N	\N	110323	110323	278052
13441	15098	8	applied	\N	\N	\N	\N	110324	110324	278053
13441	15099	9	applied	\N	\N	\N	\N	110325	110325	278054
13441	15100	10	applied	\N	\N	\N	\N	110326	110326	278055
13441	15101	11	applied	\N	\N	\N	\N	110327	110327	278056
13382	14950	6	applied	\N	\N	\N	\N	110053	110053	277782
13382	14951	7	applied	\N	\N	\N	\N	110054	110054	277783
13443	15106	0	applied	\N	\N	\N	\N	110332	110332	278061
13443	15107	1	applied	\N	\N	\N	\N	110333	110333	278062
13443	15108	2	applied	\N	\N	\N	\N	110334	110334	278063
13443	15109	3	applied	\N	\N	\N	\N	110335	110335	278064
13443	15110	4	applied	\N	\N	\N	\N	110336	110336	278065
13443	15111	5	applied	\N	\N	\N	\N	110337	110337	278066
13444	15106	0	applied	\N	\N	\N	\N	110338	110338	278067
13445	15112	0	applied	\N	\N	\N	\N	110339	110339	278068
13445	15107	1	applied	\N	\N	\N	\N	110340	110340	278069
13445	15108	2	applied	\N	\N	\N	\N	110341	110341	278070
13445	15109	4	applied	\N	\N	\N	\N	110342	110342	278071
13445	15110	5	applied	\N	\N	\N	\N	110343	110343	278072
13445	15113	7	applied	\N	\N	\N	\N	110345	110345	278074
13445	15114	8	applied	\N	\N	\N	\N	110346	110346	278075
13445	15115	9	applied	\N	\N	\N	\N	110347	110347	278076
13446	15112	0	applied	\N	\N	\N	\N	110348	110348	278077
13446	15107	1	applied	\N	\N	\N	\N	110349	110349	278078
13446	15108	2	applied	\N	\N	\N	\N	110350	110350	278079
13446	15109	4	applied	\N	\N	\N	\N	110351	110351	278080
13446	15110	5	applied	\N	\N	\N	\N	110352	110352	278081
13446	15111	6	applied	\N	\N	\N	\N	110353	110353	278082
13446	15113	7	applied	\N	\N	\N	\N	110354	110354	278083
13446	15114	8	applied	\N	\N	\N	\N	110355	110355	278084
13446	15115	9	applied	\N	\N	\N	\N	110356	110356	278085
13447	15112	0	applied	\N	\N	\N	\N	110357	110357	278086
13447	15107	1	applied	\N	\N	\N	\N	110358	110358	278087
13447	15108	2	applied	\N	\N	\N	\N	110359	110359	278088
13447	15109	4	applied	\N	\N	\N	\N	110360	110360	278089
13447	15111	6	applied	\N	\N	\N	\N	110362	110362	278091
13447	15113	7	applied	\N	\N	\N	\N	110363	110363	278092
13447	15114	8	applied	\N	\N	\N	\N	110364	110364	278093
13447	15115	9	applied	\N	\N	\N	\N	110365	110365	278094
13449	15116	0	applied	\N	\N	\N	\N	110374	110374	278103
13449	15117	1	applied	\N	\N	\N	\N	110375	110375	278104
13449	15118	2	applied	\N	\N	\N	\N	110376	110376	278105
13454	15119	0	applied	\N	\N	\N	\N	110391	110391	278120
13454	15121	1	applied	\N	\N	\N	\N	110392	110392	278121
13454	15122	2	applied	\N	\N	\N	\N	110393	110393	278122
13454	15123	3	applied	\N	\N	\N	\N	110394	110394	278123
13455	15124	0	applied	\N	\N	\N	\N	110395	110395	278124
13455	15125	1	applied	\N	\N	\N	\N	110396	110396	278125
13455	15126	2	applied	\N	\N	\N	\N	110397	110397	278126
13461	15135	0	applied	\N	\N	\N	\N	110409	110409	278138
13461	15136	1	applied	\N	\N	\N	\N	110410	110410	278139
13470	15147	0	applied	\N	\N	\N	\N	110505	110505	278233
13470	15148	1	applied	\N	\N	\N	\N	110506	110506	278234
13470	15149	2	applied	\N	\N	\N	\N	110507	110507	278235
13473	15157	0	applied	\N	\N	\N	\N	110519	110519	278247
13473	15158	1	applied	\N	\N	\N	\N	110520	110520	278248
13473	15159	2	applied	\N	\N	\N	\N	110521	110521	278249
13473	15160	3	applied	\N	\N	\N	\N	110522	110522	278250
13477	15161	0	applied	\N	\N	\N	\N	110532	110532	278260
13477	15158	1	applied	\N	\N	\N	\N	110533	110533	278261
13477	15159	2	applied	\N	\N	\N	\N	110534	110534	278262
13477	15160	3	applied	\N	\N	\N	\N	110535	110535	278263
13477	15162	4	applied	\N	\N	\N	\N	110536	110536	278264
13477	15163	5	applied	\N	\N	\N	\N	110537	110537	278265
13477	15164	6	applied	\N	\N	\N	\N	110538	110538	278266
13483	15180	0	applied	\N	\N	\N	\N	110575	110575	278303
13483	15181	1	applied	\N	\N	\N	\N	110576	110576	278304
13483	15183	3	applied	\N	\N	\N	\N	110578	110578	278306
13483	15184	4	applied	\N	\N	\N	\N	110579	110579	278307
13483	15185	5	applied	\N	\N	\N	\N	110580	110580	278308
13483	15186	6	applied	\N	\N	\N	\N	110581	110581	278309
13483	15187	7	applied	\N	\N	\N	\N	110582	110582	278310
13483	15188	8	applied	\N	\N	\N	\N	110583	110583	278311
13486	15198	0	applied	\N	\N	\N	\N	110602	110602	278330
13486	15199	1	applied	\N	\N	\N	\N	110603	110603	278331
13486	15200	2	applied	\N	\N	\N	\N	110604	110604	278332
13486	15201	3	applied	\N	\N	\N	\N	110605	110605	278333
13486	15202	4	applied	\N	\N	\N	\N	110606	110606	278334
13486	15203	5	applied	\N	\N	\N	\N	110607	110607	278335
13486	15204	7	applied	\N	\N	\N	\N	110608	110608	278336
13486	15205	8	applied	\N	\N	\N	\N	110609	110609	278337
13486	15206	9	applied	\N	\N	\N	\N	110610	110610	278338
13486	15208	11	applied	\N	\N	1000000000	\N	110612	110612	278340
13489	15215	0	applied	\N	\N	\N	\N	110623	110623	278351
13489	15216	1	applied	\N	\N	\N	\N	110624	110624	110624
13492	15219	0	applied	\N	\N	\N	\N	110636	110636	278362
13492	15220	1	applied	\N	\N	\N	\N	110637	110637	278363
13492	15221	2	applied	\N	\N	\N	\N	110638	110638	278364
13492	15222	3	applied	\N	\N	\N	\N	110639	110639	278365
13492	15223	4	applied	\N	\N	\N	\N	110640	110640	278366
13492	15224	5	applied	\N	\N	\N	\N	110641	110641	278367
13492	15225	6	applied	\N	\N	\N	\N	110642	110642	278368
13492	15226	7	applied	\N	\N	\N	\N	110643	110643	278369
13492	15227	8	applied	\N	\N	\N	\N	110644	110644	278370
13494	15228	0	applied	\N	\N	\N	\N	110654	110654	278380
13494	15229	1	applied	\N	\N	\N	\N	110655	110655	278381
13494	15230	2	applied	\N	\N	\N	\N	110656	110656	278382
13496	15231	0	applied	\N	\N	\N	\N	110658	110658	278384
13496	15229	1	applied	\N	\N	\N	\N	110659	110659	278385
13496	15230	2	applied	\N	\N	\N	\N	110660	110660	278386
13496	15232	3	applied	\N	\N	\N	\N	110661	110661	278387
13503	15242	1	applied	\N	\N	\N	\N	110680	110680	278406
13503	15243	2	applied	\N	\N	\N	\N	110681	110681	278407
13506	15241	0	applied	\N	\N	\N	\N	110688	110688	278414
13508	15254	0	applied	\N	\N	\N	\N	110699	110699	278425
13508	15255	1	applied	\N	\N	\N	\N	110700	110700	278426
13508	15256	2	applied	\N	\N	\N	\N	110701	110701	278427
13510	15120	0	applied	\N	\N	\N	\N	110718	110718	278444
13510	15124	1	applied	\N	\N	\N	\N	110719	110719	278445
13510	15127	2	applied	\N	\N	\N	\N	110720	110720	278446
13510	15128	3	applied	\N	\N	\N	\N	110721	110721	278447
13510	15135	4	applied	\N	\N	\N	\N	110722	110722	278448
13510	15138	5	applied	\N	\N	\N	\N	110723	110723	278449
13510	15141	6	applied	\N	\N	\N	\N	110724	110724	278450
13510	15144	7	applied	\N	\N	\N	\N	110725	110725	278451
13510	15147	8	applied	\N	\N	\N	\N	110726	110726	278452
13441	15103	13	applied	\N	\N	\N	\N	110329	110329	278058
13442	15105	0	applied	\N	\N	\N	\N	110331	110331	278060
13448	15111	5	applied	\N	\N	\N	\N	110370	110370	278099
13448	15113	6	applied	\N	\N	\N	\N	110371	110371	278100
13448	15114	7	applied	\N	\N	\N	\N	110372	110372	278101
13448	15115	8	applied	\N	\N	\N	\N	110373	110373	278102
13450	15119	0	applied	\N	\N	\N	\N	110377	110377	278106
13462	15138	0	applied	\N	\N	\N	\N	110412	110412	278141
13462	15139	1	applied	\N	\N	\N	\N	110413	110413	278142
13462	15140	2	applied	\N	\N	\N	\N	110414	110414	278143
13464	15141	0	applied	\N	\N	\N	\N	110418	110418	278147
13464	15142	1	applied	\N	\N	\N	\N	110419	110419	278148
13464	15143	2	applied	\N	\N	\N	\N	110420	110420	278149
13474	15157	0	applied	\N	\N	\N	\N	110523	110523	278251
13478	15161	0	applied	\N	\N	\N	\N	110539	110539	278267
13484	15180	0	applied	\N	\N	\N	\N	110584	110584	278312
13484	15181	1	applied	\N	\N	\N	\N	110585	110585	278313
13484	15182	2	applied	\N	\N	\N	\N	110586	110586	278314
13484	15183	3	applied	\N	\N	\N	\N	110587	110587	278315
13484	15184	4	applied	\N	\N	\N	\N	110588	110588	278316
13484	15185	5	applied	\N	\N	\N	\N	110589	110589	278317
13484	15186	6	applied	\N	\N	\N	\N	110590	110590	278318
13484	15187	7	applied	\N	\N	\N	\N	110591	110591	278319
13484	15188	8	applied	\N	\N	\N	\N	110592	110592	278320
13487	15209	0	applied	\N	\N	\N	\N	110613	110613	278341
13487	15210	1	applied	\N	\N	\N	\N	110614	110614	278342
13487	15211	2	applied	\N	\N	\N	\N	110615	110615	278343
13487	15212	3	applied	\N	\N	\N	\N	110616	110616	278344
13487	15213	4	applied	\N	\N	\N	\N	110617	110617	278345
13487	15214	5	applied	\N	\N	\N	\N	110618	110618	278346
13490	15213	1	applied	\N	\N	\N	\N	110626	110626	278353
13490	15214	2	applied	\N	\N	\N	\N	110627	110627	278354
13490	15217	3	applied	\N	\N	\N	\N	110628	110628	278355
13490	15218	4	applied	\N	\N	\N	\N	110629	110629	278356
13490	15216	5	applied	\N	\N	\N	\N	110630	110630	110630
13497	15231	0	applied	\N	\N	\N	\N	110662	110662	278388
13497	15229	1	applied	\N	\N	\N	\N	110663	110663	278389
13497	15230	2	applied	\N	\N	\N	\N	110664	110664	278390
13497	15232	3	applied	\N	\N	\N	\N	110665	110665	278391
13497	15233	4	applied	\N	\N	\N	\N	110666	110666	278392
13497	15234	5	applied	\N	\N	1000000000	\N	110667	110667	278393
13499	15235	0	applied	\N	\N	\N	\N	110669	110669	278395
13499	15236	1	applied	\N	\N	\N	\N	110670	110670	278396
13499	15237	2	applied	\N	\N	\N	\N	110671	110671	278397
13504	15241	0	applied	\N	\N	\N	\N	110682	110682	278408
13504	15242	1	applied	\N	\N	\N	\N	110683	110683	278409
13510	15150	9	applied	\N	\N	\N	\N	110727	110727	278453
13510	15151	10	applied	\N	\N	\N	\N	110728	110728	278454
13510	15157	11	applied	\N	\N	\N	\N	110729	110729	278455
13510	15161	12	applied	\N	\N	\N	\N	110730	110730	278456
13510	15165	13	applied	\N	\N	\N	\N	110731	110731	278457
13510	15166	14	applied	\N	\N	\N	\N	110732	110732	278458
13510	15167	15	applied	\N	\N	\N	\N	110733	110733	278459
13510	15168	16	applied	\N	\N	\N	\N	110734	110734	278460
13510	15169	17	applied	\N	\N	\N	\N	110735	110735	278461
13510	15180	18	applied	\N	\N	\N	\N	110736	110736	278462
13510	15181	19	applied	\N	\N	\N	\N	110737	110737	278463
13510	15182	20	applied	\N	\N	\N	\N	110738	110738	278464
13510	15189	21	applied	\N	\N	\N	\N	110739	110739	278465
13510	15190	22	applied	\N	\N	\N	\N	110740	110740	278466
13510	15191	23	applied	\N	\N	\N	\N	110741	110741	278467
13510	15198	24	applied	\N	\N	\N	\N	110742	110742	278468
13510	15200	26	applied	\N	\N	\N	\N	110744	110744	278470
13510	15209	27	applied	\N	\N	\N	\N	110745	110745	278471
13510	15210	28	applied	\N	\N	\N	\N	110746	110746	278472
13510	15215	29	applied	\N	\N	\N	\N	110747	110747	278473
13510	15219	30	applied	\N	\N	\N	\N	110748	110748	278474
13510	15220	31	applied	\N	\N	\N	\N	110749	110749	278475
13510	15221	32	applied	\N	\N	\N	\N	110750	110750	278476
13510	15228	33	applied	\N	\N	\N	\N	110751	110751	278477
13510	15231	34	applied	\N	\N	\N	\N	110752	110752	278478
13510	15235	35	applied	\N	\N	\N	\N	110753	110753	278479
13510	15238	36	applied	\N	\N	\N	\N	110754	110754	278480
13510	15241	37	applied	\N	\N	\N	\N	110755	110755	278481
13510	15244	38	applied	\N	\N	\N	\N	110756	110756	278482
13510	15245	39	applied	\N	\N	\N	\N	110757	110757	278483
13510	15246	40	applied	\N	\N	\N	\N	110758	110758	278484
13510	15254	41	applied	\N	\N	\N	\N	110759	110759	278485
13510	15170	43	applied	\N	\N	\N	\N	110761	110761	278487
13513	15263	0	applied	\N	\N	\N	\N	110768	110768	278494
13513	15264	1	applied	\N	\N	\N	\N	110769	110769	278495
13518	15272	0	applied	\N	\N	\N	\N	110781	110781	278507
13518	15273	1	applied	\N	\N	\N	\N	110782	110782	278508
13518	15274	2	applied	\N	\N	\N	\N	110783	110783	278509
13518	15275	3	applied	\N	\N	\N	\N	110784	110784	278510
13521	15276	0	applied	\N	\N	\N	\N	110793	110793	278519
13521	15277	1	applied	\N	\N	\N	\N	110794	110794	278520
13521	15278	2	applied	\N	\N	\N	\N	110795	110795	278521
13521	15279	3	applied	\N	\N	\N	\N	110796	110796	278522
13525	15283	0	applied	\N	\N	\N	\N	110808	110808	278534
13525	15284	1	applied	\N	\N	\N	\N	110809	110809	278535
13525	15285	2	applied	\N	\N	\N	\N	110810	110810	278536
13527	15287	0	applied	\N	\N	\N	\N	110812	110812	278538
13527	15288	1	applied	\N	\N	\N	\N	110813	110813	278539
13527	15289	2	applied	\N	\N	\N	\N	110814	110814	278540
13527	15290	3	applied	\N	\N	\N	\N	110815	110815	278541
13527	15291	4	applied	\N	\N	\N	\N	110816	110816	278542
13527	15292	6	applied	\N	\N	\N	\N	110817	110817	278543
13532	15297	0	applied	\N	\N	\N	\N	110834	110834	278560
13532	15298	1	applied	\N	\N	\N	\N	110835	110835	278561
13532	15299	2	applied	\N	\N	\N	\N	110836	110836	278562
13543	15306	0	applied	\N	\N	\N	\N	110864	110864	278590
13543	15307	1	applied	\N	\N	\N	\N	110865	110865	278591
13543	15308	2	applied	\N	\N	\N	\N	110866	110866	278592
13545	15309	0	applied	\N	\N	\N	\N	110870	110870	278596
13545	15310	1	applied	\N	\N	\N	\N	110871	110871	278597
13545	15311	2	applied	\N	\N	\N	\N	110872	110872	278598
13549	15312	0	applied	\N	\N	\N	\N	110878	110878	278604
13549	15310	1	applied	\N	\N	\N	\N	110879	110879	278605
13549	15311	2	applied	\N	\N	\N	\N	110880	110880	278606
13549	15313	3	applied	\N	\N	\N	\N	110881	110881	278607
13448	15108	1	applied	\N	\N	\N	\N	110367	110367	278096
13448	15110	4	applied	\N	\N	\N	\N	110369	110369	278098
13452	15120	1	applied	\N	\N	\N	\N	110382	110382	278111
13452	15121	2	applied	\N	\N	\N	\N	110383	110383	278112
13452	15122	3	applied	\N	\N	\N	\N	110384	110384	278113
13452	15123	4	applied	\N	\N	\N	\N	110385	110385	278114
13457	15127	0	applied	\N	\N	\N	\N	110398	110398	278127
13457	15128	1	applied	\N	\N	\N	\N	110399	110399	278128
13457	15129	2	applied	\N	\N	\N	\N	110400	110400	278129
13457	15130	3	applied	\N	\N	\N	\N	110401	110401	278130
13457	15131	4	applied	\N	\N	\N	\N	110402	110402	278131
13457	15132	5	applied	\N	\N	\N	\N	110403	110403	278132
13457	15133	6	applied	\N	\N	\N	\N	110404	110404	278133
13457	15134	7	applied	\N	\N	\N	\N	110405	110405	278134
13463	15138	0	applied	\N	\N	\N	\N	110415	110415	278144
13463	15139	1	applied	\N	\N	\N	\N	110416	110416	278145
13465	15141	0	applied	\N	\N	\N	\N	110421	110421	278150
13465	15142	1	applied	\N	\N	\N	\N	110422	110422	278151
13465	15143	2	applied	\N	\N	\N	\N	110423	110423	278152
13467	15144	0	applied	\N	\N	\N	\N	110499	110499	278227
13467	15145	1	applied	\N	\N	\N	\N	110500	110500	278228
13467	15146	2	applied	\N	\N	\N	\N	110501	110501	278229
13471	15150	0	applied	\N	\N	\N	\N	110508	110508	278236
13471	15151	1	applied	\N	\N	\N	\N	110509	110509	278237
13471	15152	2	applied	\N	\N	\N	\N	110510	110510	278238
13471	15153	3	applied	\N	\N	\N	\N	110511	110511	278239
13471	15154	4	applied	\N	\N	\N	\N	110512	110512	278240
13471	15155	5	applied	\N	\N	\N	\N	110513	110513	278241
13471	15156	6	applied	\N	\N	\N	\N	110514	110514	278242
13479	15161	0	applied	\N	\N	\N	\N	110540	110540	278268
13479	15158	1	applied	\N	\N	\N	\N	110541	110541	278269
13479	15159	2	applied	\N	\N	\N	\N	110542	110542	278270
13481	15165	0	applied	\N	\N	\N	\N	110548	110548	278276
13481	15166	1	applied	\N	\N	\N	\N	110549	110549	278277
13481	15167	2	applied	\N	\N	\N	\N	110550	110550	278278
13481	15168	3	applied	\N	\N	\N	\N	110551	110551	278279
13481	15169	4	applied	\N	\N	\N	\N	110552	110552	278280
13481	15170	5	applied	\N	\N	\N	\N	110553	110553	278281
13481	15162	6	applied	\N	\N	\N	\N	110554	110554	278282
13481	15163	7	applied	\N	\N	\N	\N	110555	110555	278283
13481	15164	8	applied	\N	\N	\N	\N	110556	110556	278284
13481	15171	9	applied	\N	\N	\N	\N	110557	110557	278285
13481	15172	10	applied	\N	\N	\N	\N	110558	110558	278286
13481	15173	11	applied	\N	\N	\N	\N	110559	110559	278287
13481	15174	12	applied	\N	\N	\N	\N	110560	110560	278288
13481	15175	13	applied	\N	\N	\N	\N	110561	110561	278289
13481	15176	14	applied	\N	\N	\N	\N	110562	110562	278290
13481	15177	15	applied	\N	\N	\N	\N	110563	110563	278291
13481	15179	17	applied	\N	\N	\N	\N	110565	110565	278293
13488	15209	0	applied	\N	\N	\N	\N	110619	110619	278347
13488	15210	1	applied	\N	\N	\N	\N	110620	110620	278348
13488	15211	2	applied	\N	\N	\N	\N	110621	110621	278349
13488	15212	3	applied	\N	\N	\N	\N	110622	110622	278350
13495	15228	0	applied	\N	\N	\N	\N	110657	110657	278383
13498	15231	0	applied	\N	\N	\N	\N	110668	110668	278394
13500	15235	0	applied	\N	\N	\N	\N	110672	110672	278398
13500	15236	1	applied	\N	\N	\N	\N	110673	110673	278399
13500	15237	2	applied	\N	\N	\N	\N	110674	110674	278400
13507	15244	0	applied	\N	\N	\N	\N	110689	110689	278415
13507	15245	1	applied	\N	\N	\N	\N	110690	110690	278416
13507	15246	2	applied	\N	\N	\N	\N	110691	110691	278417
13507	15247	3	applied	\N	\N	\N	\N	110692	110692	278418
13507	15248	4	applied	\N	\N	\N	\N	110693	110693	278419
13507	15249	5	applied	\N	\N	\N	\N	110694	110694	278420
13507	15251	7	applied	\N	\N	\N	\N	110696	110696	278422
13507	15252	8	applied	\N	\N	\N	\N	110697	110697	278423
13507	15253	9	applied	\N	\N	1000000000	\N	110698	110698	278424
13509	15244	0	applied	\N	\N	\N	\N	110702	110702	278428
13509	15245	1	applied	\N	\N	\N	\N	110703	110703	278429
13509	15246	2	applied	\N	\N	\N	\N	110704	110704	278430
13509	15254	3	applied	\N	\N	\N	\N	110705	110705	278431
13509	15257	4	applied	\N	\N	\N	\N	110706	110706	278432
13509	15247	5	applied	\N	\N	\N	\N	110707	110707	278433
13509	15248	6	applied	\N	\N	\N	\N	110708	110708	278434
13509	15249	7	applied	\N	\N	\N	\N	110709	110709	278435
13509	15250	8	applied	\N	\N	\N	\N	110710	110710	278436
13509	15251	9	applied	\N	\N	\N	\N	110711	110711	278437
13549	15314	4	applied	\N	\N	\N	\N	110882	110882	278608
13556	15315	0	applied	\N	\N	\N	\N	110890	110890	278616
13556	15310	1	applied	\N	\N	\N	\N	110891	110891	278617
13556	15313	3	applied	\N	\N	\N	\N	110893	110893	278619
13556	15314	4	applied	\N	\N	\N	\N	110894	110894	278620
13556	15316	5	applied	\N	\N	\N	\N	110895	110895	278621
13556	15317	6	applied	\N	\N	\N	\N	110896	110896	278622
13559	15318	0	applied	\N	\N	\N	\N	110905	110905	278631
13559	15319	1	applied	\N	\N	\N	\N	110906	110906	278632
13559	15320	2	applied	\N	\N	\N	\N	110907	110907	278633
13562	15321	0	applied	\N	\N	\N	\N	110913	110913	278639
13568	15235	0	applied	\N	\N	\N	\N	110951	110951	278677
13568	15238	1	applied	\N	\N	\N	\N	110952	110952	278678
13568	15241	2	applied	\N	\N	\N	\N	110953	110953	278679
13568	15244	3	applied	\N	\N	\N	\N	110954	110954	278680
13568	15245	4	applied	\N	\N	\N	\N	110955	110955	278681
13568	15246	5	applied	\N	\N	\N	\N	110956	110956	278682
13568	15254	6	applied	\N	\N	\N	\N	110957	110957	278683
13568	15257	7	applied	\N	\N	\N	\N	110958	110958	278684
13568	15263	9	applied	\N	\N	\N	\N	110960	110960	278686
13568	15264	10	applied	\N	\N	\N	\N	110961	110961	278687
13568	15269	11	applied	\N	\N	\N	\N	110962	110962	278688
13568	15272	12	applied	\N	\N	\N	\N	110963	110963	278689
13568	15276	13	applied	\N	\N	\N	\N	110964	110964	278690
13568	15280	14	applied	\N	\N	\N	\N	110965	110965	278691
13568	15283	15	applied	\N	\N	\N	\N	110966	110966	278692
13568	15287	16	applied	\N	\N	\N	\N	110967	110967	278693
13568	15288	17	applied	\N	\N	\N	\N	110968	110968	278694
13568	15294	18	applied	\N	\N	\N	\N	110969	110969	278695
13568	15297	19	applied	\N	\N	\N	\N	110970	110970	278696
13568	15300	20	applied	\N	\N	\N	\N	110971	110971	278697
13568	15303	21	applied	\N	\N	\N	\N	110972	110972	278698
13568	15306	22	applied	\N	\N	\N	\N	110973	110973	278699
13568	15309	23	applied	\N	\N	\N	\N	110974	110974	278700
13568	15312	24	applied	\N	\N	\N	\N	110975	110975	278701
13452	15119	0	applied	\N	\N	\N	\N	110381	110381	278110
13453	15122	3	applied	\N	\N	\N	\N	110389	110389	278118
13458	15127	0	applied	\N	\N	\N	\N	110406	110406	278135
13458	15128	1	applied	\N	\N	\N	\N	110407	110407	278136
13458	15129	2	applied	\N	\N	\N	\N	110408	110408	278137
13466	14734	0	applied	\N	\N	1000000000	\N	110424	110424	278153
13466	14470	1	applied	\N	\N	\N	\N	110425	110425	278154
13466	14472	2	applied	\N	\N	\N	\N	110426	110426	278155
13466	14475	3	applied	\N	\N	\N	\N	110427	110427	278156
13466	14479	4	applied	\N	\N	\N	\N	110428	110428	278157
13466	14480	5	applied	\N	\N	\N	\N	110429	110429	278158
13466	14476	6	applied	\N	\N	\N	\N	110430	110430	278159
13466	14481	7	applied	\N	\N	\N	\N	110431	110431	278160
13466	14482	8	applied	\N	\N	\N	\N	110432	110432	278161
13466	14489	9	applied	\N	\N	\N	\N	110433	110433	278162
13466	14491	10	applied	\N	\N	\N	\N	110434	110434	278163
13466	14492	11	applied	\N	\N	\N	\N	110435	110435	278164
13466	14660	13	applied	\N	\N	1000000000	\N	110437	110437	278165
13466	14731	14	applied	\N	\N	\N	\N	110438	110438	278166
13466	14483	15	applied	\N	\N	\N	\N	110439	110439	278167
13466	14490	16	applied	\N	\N	\N	\N	110440	110440	278168
13466	14493	17	applied	\N	\N	\N	\N	110441	110441	278169
13466	14494	18	applied	\N	\N	\N	\N	110442	110442	278170
13466	14501	19	applied	\N	\N	\N	\N	110443	110443	278171
13466	14502	20	applied	\N	\N	\N	\N	110444	110444	278172
13466	14503	21	applied	\N	\N	\N	\N	110445	110445	278173
13466	14510	22	applied	\N	\N	\N	\N	110446	110446	278174
13466	14511	23	applied	\N	\N	\N	\N	110447	110447	278175
13466	14515	24	applied	\N	\N	\N	\N	110448	110448	278176
13466	14516	25	applied	\N	\N	\N	\N	110449	110449	278177
13466	14521	26	applied	\N	\N	\N	\N	110450	110450	278178
13466	14522	27	applied	\N	\N	\N	\N	110451	110451	278179
13466	14523	28	applied	\N	\N	\N	\N	110452	110452	278180
13466	14530	29	applied	\N	\N	\N	\N	110453	110453	278181
13466	14531	30	applied	\N	\N	\N	\N	110454	110454	278182
13466	14536	31	applied	\N	\N	\N	\N	110455	110455	278183
13466	14537	32	applied	\N	\N	\N	\N	110456	110456	278184
13466	14538	33	applied	\N	\N	\N	\N	110457	110457	278185
13466	14545	34	applied	\N	\N	\N	\N	110458	110458	278186
13466	14548	35	applied	\N	\N	\N	\N	110459	110459	278187
13466	14551	36	applied	\N	\N	\N	\N	110460	110460	278188
13466	14554	38	applied	\N	\N	\N	\N	110461	110461	278189
13466	14559	40	applied	\N	\N	\N	\N	110463	110463	278191
13466	14560	41	applied	\N	\N	\N	\N	110464	110464	278192
13466	14565	42	applied	\N	\N	\N	\N	110465	110465	278193
13466	14568	43	applied	\N	\N	\N	\N	110466	110466	278194
13466	14571	44	applied	\N	\N	\N	\N	110467	110467	278195
13466	14574	45	applied	\N	\N	\N	\N	110468	110468	278196
13466	14577	46	applied	\N	\N	\N	\N	110469	110469	278197
13466	14580	47	applied	\N	\N	\N	\N	110470	110470	278198
13466	14581	48	applied	\N	\N	\N	\N	110471	110471	278199
13466	14586	49	applied	\N	\N	\N	\N	110472	110472	278200
13466	14589	50	applied	\N	\N	\N	\N	110473	110473	278201
13466	14590	51	applied	\N	\N	\N	\N	110474	110474	278202
13466	14594	52	applied	\N	\N	\N	\N	110475	110475	278203
13466	14597	53	applied	\N	\N	\N	\N	110476	110476	278204
13466	14600	54	applied	\N	\N	\N	\N	110477	110477	278205
13466	14601	55	applied	\N	\N	\N	\N	110478	110478	278206
13466	14609	57	applied	\N	\N	\N	\N	110480	110480	278208
13466	14612	58	applied	\N	\N	\N	\N	110481	110481	278209
13466	14613	59	applied	\N	\N	\N	\N	110482	110482	278210
13466	14620	60	applied	\N	\N	\N	\N	110483	110483	278211
13466	14623	61	applied	\N	\N	\N	\N	110484	110484	278212
13466	14625	62	applied	\N	\N	\N	\N	110485	110485	278213
13466	14629	63	applied	\N	\N	\N	\N	110486	110486	278214
13466	14631	64	applied	\N	\N	\N	\N	110487	110487	278215
13466	14634	65	applied	\N	\N	\N	\N	110488	110488	278216
13466	14636	66	applied	\N	\N	\N	\N	110489	110489	278217
13466	14639	67	applied	\N	\N	\N	\N	110490	110490	278218
13466	14642	68	applied	\N	\N	\N	\N	110491	110491	278219
13466	14643	69	applied	\N	\N	\N	\N	110492	110492	278220
13466	14648	70	applied	\N	\N	\N	\N	110493	110493	278221
13466	14649	71	applied	\N	\N	\N	\N	110494	110494	278222
13466	14654	72	applied	\N	\N	\N	\N	110495	110495	278223
13466	14659	74	applied	\N	\N	\N	\N	110497	110497	278225
13466	14664	75	applied	\N	\N	\N	\N	110498	110498	278226
13509	15252	10	applied	\N	\N	\N	\N	110712	110712	278438
13509	15253	11	applied	\N	\N	1000000000	\N	110713	110713	278439
13509	15255	12	applied	\N	\N	\N	\N	110714	110714	278440
13509	15256	13	applied	\N	\N	\N	\N	110715	110715	278441
13509	15258	14	applied	\N	\N	\N	\N	110716	110716	278442
13509	15259	15	applied	\N	\N	\N	\N	110717	110717	278443
13511	15257	0	applied	\N	\N	\N	\N	110762	110762	278488
13511	15258	1	applied	\N	\N	\N	\N	110763	110763	278489
13511	15259	2	applied	\N	\N	\N	\N	110764	110764	278490
13516	15269	0	applied	\N	\N	\N	\N	110777	110777	278503
13523	15283	0	applied	\N	\N	\N	\N	110800	110800	278526
13523	15284	1	applied	\N	\N	\N	\N	110801	110801	278527
13523	15285	2	applied	\N	\N	\N	\N	110802	110802	278528
13530	15293	0	applied	\N	\N	\N	\N	110830	110830	278556
13533	15297	0	applied	\N	\N	\N	\N	110837	110837	278563
13533	15298	1	applied	\N	\N	\N	\N	110838	110838	278564
13533	15299	2	applied	\N	\N	\N	\N	110839	110839	278565
13539	15303	0	applied	\N	\N	\N	\N	110852	110852	278578
13539	15304	1	applied	\N	\N	\N	\N	110853	110853	278579
13539	15305	2	applied	\N	\N	\N	\N	110854	110854	278580
13541	15306	0	applied	\N	\N	\N	\N	110858	110858	278584
13541	15307	1	applied	\N	\N	\N	\N	110859	110859	278585
13541	15308	2	applied	\N	\N	\N	\N	110860	110860	278586
13546	15309	0	applied	\N	\N	\N	\N	110873	110873	278599
13550	15312	0	applied	\N	\N	\N	\N	110883	110883	278609
13550	15310	1	applied	\N	\N	\N	\N	110884	110884	278610
13550	15311	2	applied	\N	\N	\N	\N	110885	110885	278611
13550	15313	3	applied	\N	\N	\N	\N	110886	110886	278612
13550	15314	4	applied	\N	\N	\N	\N	110887	110887	278613
13560	15318	0	applied	\N	\N	\N	\N	110908	110908	278634
13560	15319	1	applied	\N	\N	\N	\N	110909	110909	278635
13560	15320	2	applied	\N	\N	\N	\N	110910	110910	278636
13565	15336	1	applied	\N	\N	\N	\N	110928	110928	278654
13565	15337	2	applied	\N	\N	\N	\N	110929	110929	278655
13453	15120	1	applied	\N	\N	\N	\N	110387	110387	278116
13453	15121	2	applied	\N	\N	\N	\N	110388	110388	278117
13472	15158	1	applied	\N	\N	\N	\N	110516	110516	278244
13472	15159	2	applied	\N	\N	\N	\N	110517	110517	278245
13472	15160	3	applied	\N	\N	\N	\N	110518	110518	278246
13476	15161	0	applied	\N	\N	\N	\N	110525	110525	278253
13476	15158	1	applied	\N	\N	\N	\N	110526	110526	278254
13476	15159	2	applied	\N	\N	\N	\N	110527	110527	278255
13476	15160	3	applied	\N	\N	\N	\N	110528	110528	278256
13476	15162	4	applied	\N	\N	\N	\N	110529	110529	278257
13476	15163	5	applied	\N	\N	\N	\N	110530	110530	278258
13476	15164	6	applied	\N	\N	\N	\N	110531	110531	278259
13480	15161	0	applied	\N	\N	\N	\N	110544	110544	278272
13480	15158	1	applied	\N	\N	\N	\N	110545	110545	278273
13480	15159	2	applied	\N	\N	\N	\N	110546	110546	278274
13480	15160	3	applied	\N	\N	\N	\N	110547	110547	278275
13482	15181	1	applied	\N	\N	\N	\N	110567	110567	278295
13482	15182	2	applied	\N	\N	\N	\N	110568	110568	278296
13482	15183	3	applied	\N	\N	\N	\N	110569	110569	278297
13482	15184	4	applied	\N	\N	\N	\N	110570	110570	278298
13482	15185	5	applied	\N	\N	\N	\N	110571	110571	278299
13482	15186	6	applied	\N	\N	\N	\N	110572	110572	278300
13482	15187	7	applied	\N	\N	\N	\N	110573	110573	278301
13482	15188	8	applied	\N	\N	\N	\N	110574	110574	278302
13485	15189	0	applied	\N	\N	\N	\N	110593	110593	278321
13485	15190	1	applied	\N	\N	\N	\N	110594	110594	278322
13485	15191	2	applied	\N	\N	\N	\N	110595	110595	278323
13485	15192	3	applied	\N	\N	\N	\N	110596	110596	278324
13485	15193	4	applied	\N	\N	\N	\N	110597	110597	278325
13485	15194	5	applied	\N	\N	\N	\N	110598	110598	278326
13485	15195	6	applied	\N	\N	\N	\N	110599	110599	278327
13485	15196	7	applied	\N	\N	\N	\N	110600	110600	278328
13491	15219	0	applied	\N	\N	\N	\N	110631	110631	278357
13491	15220	1	applied	\N	\N	\N	\N	110632	110632	278358
13491	15221	2	applied	\N	\N	\N	\N	110633	110633	278359
13491	15222	3	applied	\N	\N	\N	\N	110634	110634	278360
13491	15223	4	applied	\N	\N	\N	\N	110635	110635	278361
13493	15219	0	applied	\N	\N	\N	\N	110645	110645	278371
13493	15220	1	applied	\N	\N	\N	\N	110646	110646	278372
13493	15221	2	applied	\N	\N	\N	\N	110647	110647	278373
13493	15222	3	applied	\N	\N	\N	\N	110648	110648	278374
13493	15223	4	applied	\N	\N	\N	\N	110649	110649	278375
13493	15224	5	applied	\N	\N	\N	\N	110650	110650	278376
13493	15225	6	applied	\N	\N	\N	\N	110651	110651	278377
13493	15226	7	applied	\N	\N	\N	\N	110652	110652	278378
13493	15227	8	applied	\N	\N	\N	\N	110653	110653	278379
13501	15235	0	applied	\N	\N	\N	\N	110675	110675	278401
13502	15238	0	applied	\N	\N	\N	\N	110676	110676	278402
13502	15240	2	applied	\N	\N	\N	\N	110678	110678	278404
13505	15241	0	applied	\N	\N	\N	\N	110685	110685	278411
13505	15242	1	applied	\N	\N	\N	\N	110686	110686	278412
13505	15243	2	applied	\N	\N	\N	\N	110687	110687	278413
13512	15260	0	applied	\N	\N	\N	\N	110765	110765	278491
13512	15261	1	applied	\N	\N	\N	\N	110766	110766	278492
13512	15262	2	applied	\N	\N	\N	\N	110767	110767	278493
13517	15269	0	applied	\N	\N	\N	\N	110778	110778	278504
13517	15270	1	applied	\N	\N	\N	\N	110779	110779	278505
13517	15271	2	applied	\N	\N	\N	\N	110780	110780	278506
13519	15276	0	applied	\N	\N	\N	\N	110785	110785	278511
13519	15277	1	applied	\N	\N	\N	\N	110786	110786	278512
13519	15278	2	applied	\N	\N	\N	\N	110787	110787	278513
13519	15279	3	applied	\N	\N	\N	\N	110788	110788	278514
13524	15283	0	applied	\N	\N	\N	\N	110804	110804	278530
13524	15284	1	applied	\N	\N	\N	\N	110805	110805	278531
13524	15286	3	applied	\N	\N	1000000000	\N	110807	110807	278533
13528	15287	0	applied	\N	\N	\N	\N	110818	110818	278544
13528	15288	1	applied	\N	\N	\N	\N	110819	110819	278545
13528	15289	2	applied	\N	\N	\N	\N	110820	110820	278546
13528	15290	3	applied	\N	\N	\N	\N	110821	110821	278547
13528	15291	4	applied	\N	\N	\N	\N	110822	110822	278548
13528	15292	6	applied	\N	\N	\N	\N	110823	110823	278549
13529	15287	0	applied	\N	\N	\N	\N	110824	110824	278550
13529	15288	1	applied	\N	\N	\N	\N	110825	110825	278551
13529	15289	2	applied	\N	\N	\N	\N	110826	110826	278552
13529	15290	3	applied	\N	\N	\N	\N	110827	110827	278553
13529	15291	4	applied	\N	\N	\N	\N	110828	110828	278554
13529	15292	6	applied	\N	\N	\N	\N	110829	110829	278555
13535	15300	0	applied	\N	\N	\N	\N	110841	110841	278567
13535	15298	1	applied	\N	\N	\N	\N	110842	110842	278568
13535	15299	2	applied	\N	\N	\N	\N	110843	110843	278569
13535	15302	4	applied	\N	\N	\N	\N	110845	110845	278571
13538	15300	0	applied	\N	\N	\N	\N	110849	110849	278575
13538	15301	1	applied	\N	\N	\N	\N	110850	110850	278576
13538	15302	2	applied	\N	\N	\N	\N	110851	110851	278577
13540	15303	0	applied	\N	\N	\N	\N	110855	110855	278581
13540	15304	1	applied	\N	\N	\N	\N	110856	110856	278582
13540	15305	2	applied	\N	\N	\N	\N	110857	110857	278583
13542	15306	0	applied	\N	\N	\N	\N	110861	110861	278587
13542	15307	1	applied	\N	\N	\N	\N	110862	110862	278588
13542	15308	2	applied	\N	\N	\N	\N	110863	110863	278589
13544	15306	0	applied	\N	\N	\N	\N	110867	110867	278593
13544	15307	1	applied	\N	\N	\N	\N	110868	110868	278594
13544	15308	2	applied	\N	\N	\N	\N	110869	110869	278595
13547	15309	0	applied	\N	\N	\N	\N	110874	110874	278600
13551	15312	0	applied	\N	\N	\N	\N	110888	110888	278614
13558	15315	0	applied	\N	\N	\N	\N	110898	110898	278624
13558	15311	2	applied	\N	\N	\N	\N	110900	110900	278626
13558	15313	3	applied	\N	\N	\N	\N	110901	110901	278627
13558	15314	4	applied	\N	\N	\N	\N	110902	110902	278628
13558	15316	5	applied	\N	\N	\N	\N	110903	110903	278629
13558	15317	6	applied	\N	\N	\N	\N	110904	110904	278630
13561	15318	0	applied	\N	\N	\N	\N	110911	110911	278637
13561	15319	1	applied	\N	\N	\N	\N	110912	110912	278638
13563	15322	0	applied	\N	\N	\N	\N	110914	110914	278640
13563	15323	1	applied	\N	\N	\N	\N	110915	110915	278641
13563	15324	2	applied	\N	\N	\N	\N	110916	110916	278642
13563	15325	3	applied	\N	\N	\N	\N	110917	110917	278643
13563	15326	4	applied	\N	\N	\N	\N	110918	110918	278644
13563	15327	5	applied	\N	\N	\N	\N	110919	110919	278645
13563	15328	6	applied	\N	\N	\N	\N	110920	110920	278646
13563	15329	7	applied	\N	\N	\N	\N	110921	110921	278647
13563	15330	8	applied	\N	\N	\N	\N	110922	110922	278648
13472	15157	0	applied	\N	\N	\N	\N	110515	110515	278243
13515	15038	0	applied	\N	\N	\N	\N	110774	110774	278500
13515	15170	1	applied	\N	\N	\N	\N	110775	110775	278501
13515	15044	2	applied	\N	\N	\N	\N	110776	110776	278502
13520	15276	0	applied	\N	\N	\N	\N	110789	110789	278515
13520	15277	1	applied	\N	\N	\N	\N	110790	110790	278516
13520	15278	2	applied	\N	\N	\N	\N	110791	110791	278517
13520	15279	3	applied	\N	\N	\N	\N	110792	110792	278518
13522	15280	0	applied	\N	\N	\N	\N	110797	110797	278523
13522	15281	1	applied	\N	\N	\N	\N	110798	110798	278524
13522	15282	2	applied	\N	\N	\N	\N	110799	110799	278525
13531	15294	0	applied	\N	\N	\N	\N	110831	110831	278557
13531	15295	1	applied	\N	\N	\N	\N	110832	110832	278558
13531	15296	2	applied	\N	\N	\N	\N	110833	110833	278559
13534	15297	0	applied	\N	\N	\N	\N	110840	110840	278566
13536	15301	1	applied	\N	\N	\N	\N	110847	110847	278573
13536	15302	2	applied	\N	\N	\N	\N	110848	110848	278574
13548	15309	0	applied	\N	\N	\N	\N	110875	110875	278601
13548	15310	1	applied	\N	\N	\N	\N	110876	110876	278602
13548	15311	2	applied	\N	\N	\N	\N	110877	110877	278603
13552	15309	0	applied	\N	\N	\N	\N	110889	110889	278615
13557	15315	0	applied	\N	\N	\N	\N	110897	110897	278623
13563	15331	9	applied	\N	\N	\N	\N	110923	110923	278649
13564	15332	0	applied	\N	\N	\N	\N	110924	110924	278650
13564	15333	1	applied	\N	\N	\N	\N	110925	110925	278651
13564	15334	2	applied	\N	\N	\N	\N	110926	110926	278652
13566	15335	0	applied	\N	\N	\N	\N	110935	110935	278661
13566	15336	1	applied	\N	\N	\N	\N	110936	110936	278662
13566	15337	2	applied	\N	\N	\N	\N	110937	110937	278663
13566	15338	3	applied	\N	\N	\N	\N	110938	110938	278664
13566	15339	4	applied	\N	\N	\N	\N	110939	110939	278665
13566	15341	6	applied	\N	\N	\N	\N	110941	110941	278667
13566	15342	7	applied	\N	\N	\N	\N	110942	110942	278668
13567	15335	0	applied	\N	\N	\N	\N	110943	110943	278669
13567	15336	1	applied	\N	\N	\N	\N	110944	110944	278670
13567	15337	2	applied	\N	\N	\N	\N	110945	110945	278671
13567	15338	3	applied	\N	\N	\N	\N	110946	110946	278672
13567	15339	4	applied	\N	\N	\N	\N	110947	110947	278673
13567	15340	5	applied	\N	\N	\N	\N	110948	110948	278674
13567	15341	6	applied	\N	\N	\N	\N	110949	110949	278675
13567	15342	7	applied	\N	\N	\N	\N	110950	110950	278676
13571	15260	0	applied	\N	\N	\N	\N	110997	110997	278723
13571	15263	1	applied	\N	\N	\N	\N	110998	110998	278724
13571	15264	2	applied	\N	\N	\N	\N	110999	110999	278725
13571	15269	3	applied	\N	\N	\N	\N	111000	111000	278726
13571	15272	4	applied	\N	\N	\N	\N	111001	111001	278727
13571	15276	5	applied	\N	\N	\N	\N	111002	111002	278728
13571	15283	7	applied	\N	\N	\N	\N	111004	111004	278730
13571	15287	8	applied	\N	\N	\N	\N	111005	111005	278731
13571	15288	9	applied	\N	\N	\N	\N	111006	111006	278732
13571	15294	10	applied	\N	\N	\N	\N	111007	111007	278733
13571	15297	11	applied	\N	\N	\N	\N	111008	111008	278734
13571	15300	12	applied	\N	\N	\N	\N	111009	111009	278735
13571	15303	13	applied	\N	\N	\N	\N	111010	111010	278736
13571	15306	14	applied	\N	\N	\N	\N	111011	111011	278737
13571	15309	15	applied	\N	\N	\N	\N	111012	111012	278738
13571	15312	16	applied	\N	\N	\N	\N	111013	111013	278739
13571	15315	17	applied	\N	\N	\N	\N	111014	111014	278740
13571	15318	18	applied	\N	\N	\N	\N	111015	111015	278741
13571	15336	19	applied	\N	\N	\N	\N	111016	111016	278742
13571	15337	20	applied	\N	\N	\N	\N	111017	111017	278743
13571	15338	21	applied	\N	\N	\N	\N	111018	111018	278744
13571	15339	22	applied	\N	\N	\N	\N	111019	111019	278745
13571	15321	24	applied	\N	\N	\N	\N	111021	111021	278747
13571	15322	25	applied	\N	\N	\N	\N	111022	111022	278748
13571	15323	26	applied	\N	\N	\N	\N	111023	111023	278749
13572	15343	0	applied	\N	\N	\N	\N	111030	111030	278756
13572	15344	1	applied	\N	\N	\N	\N	111031	111031	278757
13572	15345	2	applied	\N	\N	\N	\N	111032	111032	278758
13575	15349	0	applied	\N	\N	\N	\N	111039	111039	278765
13575	15350	1	applied	\N	\N	\N	\N	111040	111040	278766
13575	15351	2	applied	\N	\N	\N	\N	111041	111041	278767
13578	15361	0	applied	\N	\N	\N	\N	111054	111054	278780
13578	15362	1	applied	\N	\N	\N	\N	111055	111055	278781
13578	15363	2	applied	\N	\N	\N	\N	111056	111056	278782
13578	15364	3	applied	\N	\N	\N	\N	111057	111057	278783
13586	15393	0	applied	\N	\N	\N	\N	111099	111099	278823
13586	15394	1	applied	\N	\N	\N	\N	111100	111100	278824
13586	15395	2	applied	\N	\N	\N	\N	111101	111101	278825
13588	15397	0	applied	\N	\N	1000000000	\N	111107	111107	278831
13588	15398	1	applied	\N	\N	\N	\N	111108	111108	278832
13588	15399	2	applied	\N	\N	\N	\N	111109	111109	278833
13588	15400	3	applied	\N	\N	\N	\N	111110	111110	278834
13588	15401	4	applied	\N	\N	\N	\N	111111	111111	278835
13598	15409	0	applied	\N	\N	\N	\N	111146	111146	278870
13598	15410	1	applied	\N	\N	\N	\N	111147	111147	278871
13598	15411	2	applied	\N	\N	\N	\N	111148	111148	278872
13600	15409	0	applied	\N	\N	\N	\N	111152	111152	278876
13600	15410	1	applied	\N	\N	\N	\N	111153	111153	278877
13600	15411	2	applied	\N	\N	\N	\N	111154	111154	278878
13604	15416	0	applied	\N	\N	\N	\N	111187	111187	278911
13604	15417	1	applied	\N	\N	\N	\N	111188	111188	278912
13604	15418	2	applied	\N	\N	\N	\N	111189	111189	278913
13604	15419	3	applied	\N	\N	\N	\N	111190	111190	278914
13604	15420	4	applied	\N	\N	\N	\N	111191	111191	278915
13604	15422	6	applied	\N	\N	\N	\N	111193	111193	278917
13604	15423	7	applied	\N	\N	\N	\N	111194	111194	278918
13604	15424	8	applied	\N	\N	\N	\N	111195	111195	278919
13604	15425	9	applied	\N	\N	\N	\N	111196	111196	278920
13604	15426	10	applied	\N	\N	\N	\N	111197	111197	278921
13604	15427	11	applied	\N	\N	\N	\N	111198	111198	278922
13604	15428	12	applied	\N	\N	\N	\N	111199	111199	278923
13604	15429	13	applied	\N	\N	\N	\N	111200	111200	278924
13604	15430	14	applied	\N	\N	\N	\N	111201	111201	278925
13604	15431	15	applied	\N	\N	\N	\N	111202	111202	278926
13604	15432	16	applied	\N	\N	\N	\N	111203	111203	278927
13604	15433	17	applied	\N	\N	\N	\N	111204	111204	278928
13604	15434	18	applied	\N	\N	\N	\N	111205	111205	278929
13604	15435	19	applied	\N	\N	\N	\N	111206	111206	278930
13604	15436	20	applied	\N	\N	\N	\N	111207	111207	278931
13604	15437	21	applied	\N	\N	\N	\N	111208	111208	278932
13513	15268	5	applied	\N	\N	\N	\N	110773	110773	278499
13565	15342	7	applied	\N	\N	\N	\N	110934	110934	278660
13570	15343	0	applied	\N	\N	\N	\N	110994	110994	278720
13570	15344	1	applied	\N	\N	\N	\N	110995	110995	278721
13570	15345	2	applied	\N	\N	\N	\N	110996	110996	278722
13574	15346	0	applied	\N	\N	\N	\N	111036	111036	278762
13574	15347	1	applied	\N	\N	\N	\N	111037	111037	278763
13580	15372	0	applied	\N	\N	\N	\N	111065	111065	278791
13580	15373	1	applied	\N	\N	\N	\N	111066	111066	278792
13580	15374	2	applied	\N	\N	\N	\N	111067	111067	278793
13580	15375	3	applied	\N	\N	\N	\N	111068	111068	278794
13580	15376	4	applied	\N	\N	\N	\N	111069	111069	278795
13580	15377	6	applied	\N	\N	\N	\N	111070	111070	278796
13580	15378	7	applied	\N	\N	\N	\N	111071	111071	278797
13580	15379	8	applied	\N	\N	\N	\N	111072	111072	278798
13580	15380	9	applied	\N	\N	\N	\N	111073	111073	278799
13580	15381	10	applied	\N	\N	\N	\N	111074	111074	278800
13580	15382	11	applied	\N	\N	\N	\N	111075	111075	278801
13580	15383	12	applied	\N	\N	\N	\N	111076	111076	278802
13583	15384	0	applied	\N	\N	\N	\N	111085	111085	278811
13583	15385	1	applied	\N	\N	\N	\N	111086	111086	278812
13583	15386	2	applied	\N	\N	\N	\N	111087	111087	278813
13583	15387	3	applied	\N	\N	\N	\N	111088	111088	278814
13585	15389	1	applied	\N	\N	\N	\N	111095	111095	278819
13585	15390	2	applied	\N	\N	\N	\N	111096	111096	278820
13585	15391	3	applied	\N	\N	\N	\N	111097	111097	278821
13585	15392	4	applied	\N	\N	\N	\N	111098	111098	278822
13587	15393	0	applied	\N	\N	\N	\N	111103	111103	278827
13587	15394	1	applied	\N	\N	\N	\N	111104	111104	278828
13587	15395	2	applied	\N	\N	\N	\N	111105	111105	278829
13587	15396	3	applied	\N	\N	\N	\N	111106	111106	278830
13590	15397	0	applied	\N	\N	1000000000	\N	111117	111117	278841
13590	15398	1	applied	\N	\N	\N	\N	111118	111118	278842
13590	15399	2	applied	\N	\N	\N	\N	111119	111119	278843
13590	15400	3	applied	\N	\N	\N	\N	111120	111120	278844
13590	15401	4	applied	\N	\N	\N	\N	111121	111121	278845
13592	15402	0	applied	\N	\N	\N	\N	111125	111125	278849
13592	15403	1	applied	\N	\N	\N	\N	111126	111126	278850
13592	15404	2	applied	\N	\N	\N	\N	111127	111127	278851
13594	15405	0	applied	\N	\N	\N	\N	111132	111132	278856
13594	15406	1	applied	\N	\N	\N	\N	111133	111133	278857
13594	15407	2	applied	\N	\N	\N	\N	111134	111134	278858
13594	15408	3	applied	\N	\N	\N	\N	111135	111135	278859
13596	15409	0	applied	\N	\N	\N	\N	111140	111140	278864
13596	15410	1	applied	\N	\N	\N	\N	111141	111141	278865
13596	15411	2	applied	\N	\N	\N	\N	111142	111142	278866
13599	15409	0	applied	\N	\N	\N	\N	111149	111149	278873
13599	15411	2	applied	\N	\N	\N	\N	111151	111151	278875
13604	15438	22	applied	\N	\N	\N	\N	111209	111209	278933
13604	15439	23	applied	\N	\N	\N	\N	111210	111210	278934
13604	15440	24	applied	\N	\N	\N	\N	111211	111211	278935
13604	15441	25	applied	\N	\N	\N	\N	111212	111212	278936
13604	15442	26	applied	\N	\N	\N	\N	111213	111213	278937
13606	15443	0	applied	\N	\N	\N	\N	111214	111214	278938
13606	15444	1	applied	\N	\N	\N	\N	111215	111215	278939
13606	15445	2	applied	\N	\N	\N	\N	111216	111216	278940
13606	15446	3	applied	\N	\N	\N	\N	111217	111217	278941
13611	15460	0	applied	\N	\N	\N	\N	111243	111243	278966
13611	15461	1	applied	\N	\N	\N	\N	111244	111244	278967
13611	15462	2	applied	\N	\N	\N	\N	111245	111245	278968
13613	15463	0	applied	\N	\N	\N	\N	111249	111249	278972
13613	15464	1	applied	\N	\N	\N	\N	111250	111250	278973
13613	15465	2	applied	\N	\N	\N	\N	111251	111251	278974
13614	15463	0	applied	\N	\N	\N	\N	111253	111253	278976
13614	15464	1	applied	\N	\N	\N	\N	111254	111254	278977
13614	15465	2	applied	\N	\N	\N	\N	111255	111255	278978
13614	15466	3	applied	\N	\N	\N	\N	111256	111256	278979
13615	15467	0	applied	\N	\N	\N	\N	111257	111257	278980
13615	15468	1	applied	\N	\N	\N	\N	111258	111258	278981
13615	15469	2	applied	\N	\N	\N	\N	111259	111259	278982
13615	15470	3	applied	\N	\N	\N	\N	111260	111260	278983
13616	15471	0	applied	\N	\N	\N	\N	111261	111261	278984
13616	15472	1	applied	\N	\N	\N	\N	111262	111262	278985
13616	15473	3	applied	\N	\N	\N	\N	111263	111263	278986
13616	15474	4	applied	\N	\N	\N	\N	111264	111264	278987
13618	15471	0	applied	\N	\N	\N	\N	111269	111269	278992
13618	15472	1	applied	\N	\N	\N	\N	111270	111270	278993
13618	15473	3	applied	\N	\N	\N	\N	111271	111271	278994
13618	15474	4	applied	\N	\N	\N	\N	111272	111272	278995
13620	15480	1	applied	\N	\N	\N	\N	111278	111278	279001
13620	15481	2	applied	\N	\N	\N	\N	111279	111279	279002
13620	15482	3	applied	\N	\N	\N	\N	111280	111280	279003
13621	15479	0	applied	\N	\N	\N	\N	111281	111281	279004
13621	15480	1	applied	\N	\N	\N	\N	111282	111282	279005
13621	15481	2	applied	\N	\N	\N	\N	111283	111283	279006
13621	15482	3	applied	\N	\N	\N	\N	111284	111284	279007
13623	15479	0	applied	\N	\N	\N	\N	111286	111286	279009
13623	15480	1	applied	\N	\N	\N	\N	111287	111287	279010
13623	15481	2	applied	\N	\N	\N	\N	111288	111288	279011
13623	15482	3	applied	\N	\N	\N	\N	111289	111289	279012
13624	15483	0	applied	\N	\N	\N	\N	111290	111290	279013
13624	15484	1	applied	\N	\N	\N	\N	111291	111291	279014
13624	15485	2	applied	\N	\N	\N	\N	111292	111292	279015
13624	15486	3	applied	\N	\N	\N	\N	111293	111293	279016
13625	15483	0	applied	\N	\N	\N	\N	111294	111294	279017
13626	15488	1	applied	\N	\N	\N	\N	111296	111296	279019
13626	15489	2	applied	\N	\N	\N	\N	111297	111297	279020
13626	15490	3	applied	\N	\N	\N	\N	111298	111298	279021
13626	15491	4	applied	\N	\N	\N	\N	111299	111299	279022
13626	15492	5	applied	\N	\N	\N	\N	111300	111300	279023
13626	15493	6	applied	\N	\N	\N	\N	111301	111301	279024
13626	15494	7	applied	\N	\N	\N	\N	111302	111302	279025
13626	15495	8	applied	\N	\N	\N	\N	111303	111303	279026
13632	15507	0	applied	\N	\N	\N	\N	111351	111351	279074
13632	15508	1	applied	\N	\N	\N	\N	111352	111352	279075
13632	15509	2	applied	\N	\N	\N	\N	111353	111353	279076
13633	15510	0	applied	\N	\N	\N	\N	111354	111354	279077
13633	15511	1	applied	\N	\N	\N	\N	111355	111355	279078
13636	15512	0	applied	\N	\N	\N	\N	111384	111384	279107
13636	15513	1	applied	\N	\N	\N	\N	111385	111385	279108
13565	15339	4	applied	\N	\N	\N	\N	110931	110931	278657
13565	15341	6	applied	\N	\N	\N	\N	110933	110933	278659
13568	15337	28	applied	\N	\N	\N	\N	110979	110979	278705
13568	15338	29	applied	\N	\N	\N	\N	110980	110980	278706
13568	15339	30	applied	\N	\N	\N	\N	110981	110981	278707
13568	15340	31	applied	\N	\N	\N	\N	110982	110982	278708
13568	15321	32	applied	\N	\N	\N	\N	110983	110983	278709
13568	15322	33	applied	\N	\N	\N	\N	110984	110984	278710
13568	15323	34	applied	\N	\N	\N	\N	110985	110985	278711
13568	15332	36	applied	\N	\N	\N	\N	110987	110987	278713
13568	15335	37	applied	\N	\N	\N	\N	110988	110988	278714
13568	15275	38	applied	\N	\N	\N	\N	110989	110989	278715
13568	15279	39	applied	\N	\N	\N	\N	110990	110990	278716
13569	15343	0	applied	\N	\N	\N	\N	110991	110991	278717
13569	15344	1	applied	\N	\N	\N	\N	110992	110992	278718
13569	15345	2	applied	\N	\N	\N	\N	110993	110993	278719
13573	15346	0	applied	\N	\N	\N	\N	111033	111033	278759
13573	15347	1	applied	\N	\N	\N	\N	111034	111034	278760
13573	15348	2	applied	\N	\N	\N	\N	111035	111035	278761
13576	15349	0	applied	\N	\N	\N	\N	111042	111042	278768
13576	15350	1	applied	\N	\N	\N	\N	111043	111043	278769
13576	15351	2	applied	\N	\N	\N	\N	111044	111044	278770
13579	15365	0	applied	\N	\N	\N	\N	111058	111058	278784
13579	15366	1	applied	\N	\N	\N	\N	111059	111059	278785
13579	15367	2	applied	\N	\N	\N	\N	111060	111060	278786
13579	15369	4	applied	\N	\N	\N	\N	111062	111062	278788
13579	15370	5	applied	\N	\N	\N	\N	111063	111063	278789
13579	15371	6	applied	\N	\N	\N	\N	111064	111064	278790
13582	15384	0	applied	\N	\N	\N	\N	111081	111081	278807
13582	15385	1	applied	\N	\N	\N	\N	111082	111082	278808
13582	15386	2	applied	\N	\N	\N	\N	111083	111083	278809
13582	15387	3	applied	\N	\N	\N	\N	111084	111084	278810
13584	15389	1	applied	\N	\N	\N	\N	111090	111090	278815
13584	15388	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	111089	111089	\N
13584	15390	2	applied	\N	\N	\N	\N	111091	111091	278816
13584	15391	3	applied	\N	\N	\N	\N	111092	111092	278817
13584	15392	4	applied	\N	\N	\N	\N	111093	111093	278818
13589	15397	0	applied	\N	\N	1000000000	\N	111112	111112	278836
13589	15398	1	applied	\N	\N	\N	\N	111113	111113	278837
13589	15399	2	applied	\N	\N	\N	\N	111114	111114	278838
13589	15400	3	applied	\N	\N	\N	\N	111115	111115	278839
13591	15402	0	applied	\N	\N	\N	\N	111122	111122	278846
13591	15403	1	applied	\N	\N	\N	\N	111123	111123	278847
13591	15404	2	applied	\N	\N	\N	\N	111124	111124	278848
13593	15405	0	applied	\N	\N	\N	\N	111128	111128	278852
13593	15406	1	applied	\N	\N	\N	\N	111129	111129	278853
13593	15407	2	applied	\N	\N	\N	\N	111130	111130	278854
13593	15408	3	applied	\N	\N	\N	\N	111131	111131	278855
13601	15409	0	applied	\N	\N	\N	\N	111155	111155	278879
13602	15412	0	applied	\N	\N	\N	\N	111156	111156	278880
13602	15413	1	applied	\N	\N	\N	\N	111157	111157	278881
13602	15414	2	applied	\N	\N	\N	\N	111158	111158	278882
13602	15415	3	applied	\N	\N	\N	\N	111159	111159	278883
13603	15416	0	applied	\N	\N	\N	\N	111160	111160	278884
13603	15417	1	applied	\N	\N	\N	\N	111161	111161	278885
13603	15418	2	applied	\N	\N	\N	\N	111162	111162	278886
13603	15419	3	applied	\N	\N	\N	\N	111163	111163	278887
13603	15421	5	applied	\N	\N	\N	\N	111165	111165	278889
13603	15422	6	applied	\N	\N	\N	\N	111166	111166	278890
13603	15423	7	applied	\N	\N	\N	\N	111167	111167	278891
13603	15424	8	applied	\N	\N	\N	\N	111168	111168	278892
13603	15425	9	applied	\N	\N	\N	\N	111169	111169	278893
13603	15426	10	applied	\N	\N	\N	\N	111170	111170	278894
13603	15427	11	applied	\N	\N	\N	\N	111171	111171	278895
13603	15428	12	applied	\N	\N	\N	\N	111172	111172	278896
13603	15429	13	applied	\N	\N	\N	\N	111173	111173	278897
13603	15430	14	applied	\N	\N	\N	\N	111174	111174	278898
13603	15431	15	applied	\N	\N	\N	\N	111175	111175	278899
13603	15432	16	applied	\N	\N	\N	\N	111176	111176	278900
13603	15433	17	applied	\N	\N	\N	\N	111177	111177	278901
13603	15434	18	applied	\N	\N	\N	\N	111178	111178	278902
13603	15435	19	applied	\N	\N	\N	\N	111179	111179	278903
13603	15436	20	applied	\N	\N	\N	\N	111180	111180	278904
13603	15438	22	applied	\N	\N	\N	\N	111182	111182	278906
13603	15439	23	applied	\N	\N	\N	\N	111183	111183	278907
13603	15440	24	applied	\N	\N	\N	\N	111184	111184	278908
13603	15441	25	applied	\N	\N	\N	\N	111185	111185	278909
13626	15496	9	applied	\N	\N	\N	\N	111304	111304	279027
13626	15497	10	applied	\N	\N	\N	\N	111305	111305	279028
13626	15498	11	applied	\N	\N	\N	\N	111306	111306	279029
13630	15487	0	applied	\N	\N	\N	\N	111331	111331	279054
13630	15488	1	applied	\N	\N	\N	\N	111332	111332	279055
13630	15489	2	applied	\N	\N	\N	\N	111333	111333	279056
13630	15499	3	applied	\N	\N	\N	\N	111334	111334	279057
13630	15490	4	applied	\N	\N	\N	\N	111335	111335	279058
13630	15491	5	applied	\N	\N	\N	\N	111336	111336	279059
13630	15492	6	applied	\N	\N	\N	\N	111337	111337	279060
13630	15493	7	applied	\N	\N	\N	\N	111338	111338	279061
13630	15494	8	applied	\N	\N	\N	\N	111339	111339	279062
13630	15496	10	applied	\N	\N	\N	\N	111341	111341	279064
13630	15497	11	applied	\N	\N	\N	\N	111342	111342	279065
13630	15498	12	applied	\N	\N	\N	\N	111343	111343	279066
13630	15500	13	applied	\N	\N	\N	\N	111344	111344	279067
13630	15501	14	applied	\N	\N	\N	\N	111345	111345	279068
13630	15502	15	applied	\N	\N	\N	\N	111346	111346	279069
13637	15512	0	applied	\N	\N	\N	\N	111398	111398	279121
13637	15513	1	applied	\N	\N	\N	\N	111399	111399	279122
13637	15514	2	applied	\N	\N	\N	\N	111400	111400	279123
13637	15515	3	applied	\N	\N	\N	\N	111401	111401	279124
13637	15516	4	applied	\N	\N	\N	\N	111402	111402	279125
13637	15517	5	applied	\N	\N	\N	\N	111403	111403	279126
13637	15518	6	applied	\N	\N	\N	\N	111404	111404	279127
13637	15519	7	applied	\N	\N	\N	\N	111405	111405	279128
13637	15520	8	applied	\N	\N	\N	\N	111406	111406	279129
13637	15521	9	applied	\N	\N	\N	\N	111407	111407	279130
13637	15523	11	applied	\N	\N	\N	\N	111409	111409	279132
13637	15524	12	applied	\N	\N	\N	\N	111410	111410	279133
13637	15525	13	applied	\N	\N	\N	\N	111411	111411	279134
13641	15542	0	applied	\N	\N	\N	\N	111446	111446	279169
13641	15543	1	applied	\N	\N	\N	\N	111447	111447	279170
13641	15544	2	applied	\N	\N	\N	\N	111448	111448	279171
13568	15318	26	applied	\N	\N	\N	\N	110977	110977	278703
13568	15336	27	applied	\N	\N	\N	\N	110978	110978	278704
13571	15275	31	applied	\N	\N	\N	\N	111028	111028	278754
13571	15279	32	applied	\N	\N	\N	\N	111029	111029	278755
13577	15352	0	applied	\N	\N	\N	\N	111045	111045	278771
13577	15353	1	applied	\N	\N	\N	\N	111046	111046	278772
13577	15354	2	applied	\N	\N	\N	\N	111047	111047	278773
13577	15355	3	applied	\N	\N	\N	\N	111048	111048	278774
13577	15356	4	applied	\N	\N	\N	\N	111049	111049	278775
13577	15357	5	applied	\N	\N	\N	\N	111050	111050	278776
13577	15358	6	applied	\N	\N	\N	\N	111051	111051	278777
13577	15359	7	applied	\N	\N	\N	\N	111052	111052	278778
13577	15360	8	applied	\N	\N	\N	\N	111053	111053	278779
13581	15384	0	applied	\N	\N	\N	\N	111077	111077	278803
13581	15385	1	applied	\N	\N	\N	\N	111078	111078	278804
13581	15386	2	applied	\N	\N	\N	\N	111079	111079	278805
13581	15387	3	applied	\N	\N	\N	\N	111080	111080	278806
13595	15405	0	applied	\N	\N	\N	\N	111136	111136	278860
13595	15407	2	applied	\N	\N	\N	\N	111138	111138	278862
13595	15408	3	applied	\N	\N	\N	\N	111139	111139	278863
13597	15409	0	applied	\N	\N	\N	\N	111143	111143	278867
13597	15410	1	applied	\N	\N	\N	\N	111144	111144	278868
13597	15411	2	applied	\N	\N	\N	\N	111145	111145	278869
13603	15442	26	applied	\N	\N	\N	\N	111186	111186	278910
13607	15443	0	applied	\N	\N	\N	\N	111218	111218	278942
13607	15447	1	applied	\N	\N	\N	\N	111219	111219	278943
13607	15444	2	applied	\N	\N	\N	\N	111220	111220	278944
13607	15445	3	applied	\N	\N	\N	\N	111221	111221	278945
13607	15446	4	applied	\N	\N	\N	\N	111222	111222	278946
13607	15448	5	applied	\N	\N	\N	\N	111223	111223	278947
13607	15449	6	applied	\N	\N	\N	\N	111224	111224	278948
13607	15450	7	applied	\N	\N	\N	\N	111225	111225	278949
13608	15443	0	applied	\N	\N	\N	\N	111226	111226	278950
13608	15447	1	applied	\N	\N	\N	\N	111227	111227	278951
13608	15445	3	applied	\N	\N	\N	\N	111229	111229	278953
13608	15446	4	applied	\N	\N	\N	\N	111230	111230	278954
13608	15448	5	applied	\N	\N	\N	\N	111231	111231	278955
13608	15449	6	applied	\N	\N	\N	\N	111232	111232	278956
13608	15450	7	applied	\N	\N	\N	\N	111233	111233	278957
13610	15451	0	applied	\N	\N	\N	\N	111234	111234	111234
13610	15452	1	applied	\N	\N	\N	\N	111235	111235	278958
13610	15453	2	applied	\N	\N	\N	\N	111236	111236	278959
13610	15454	3	applied	\N	\N	\N	\N	111237	111237	278960
13610	15455	4	applied	\N	\N	\N	\N	111238	111238	278961
13610	15456	5	applied	\N	\N	\N	\N	111239	111239	278962
13610	15457	6	applied	\N	\N	\N	\N	111240	111240	278963
13610	15458	7	applied	\N	\N	\N	\N	111241	111241	278964
13610	15459	8	applied	\N	\N	\N	\N	111242	111242	278965
13612	15460	0	applied	\N	\N	\N	\N	111246	111246	278969
13612	15461	1	applied	\N	\N	\N	\N	111247	111247	278970
13617	15471	0	applied	\N	\N	\N	\N	111265	111265	278988
13617	15472	1	applied	\N	\N	\N	\N	111266	111266	278989
13617	15473	3	applied	\N	\N	\N	\N	111267	111267	278990
13617	15474	4	applied	\N	\N	\N	\N	111268	111268	278991
13619	15475	0	applied	\N	\N	\N	\N	111273	111273	278996
13619	15476	1	applied	\N	\N	\N	\N	111274	111274	278997
13619	15477	2	applied	\N	\N	\N	\N	111275	111275	278998
13619	15478	3	applied	\N	\N	\N	\N	111276	111276	278999
13622	15479	0	applied	\N	\N	\N	\N	111285	111285	279008
13627	15487	0	applied	\N	\N	\N	\N	111307	111307	279030
13627	15488	1	applied	\N	\N	\N	\N	111308	111308	279031
13627	15489	2	applied	\N	\N	\N	\N	111309	111309	279032
13627	15490	3	applied	\N	\N	\N	\N	111310	111310	279033
13627	15491	4	applied	\N	\N	\N	\N	111311	111311	279034
13627	15492	5	applied	\N	\N	\N	\N	111312	111312	279035
13627	15493	6	applied	\N	\N	\N	\N	111313	111313	279036
13627	15495	8	applied	\N	\N	\N	\N	111315	111315	279038
13627	15496	9	applied	\N	\N	\N	\N	111316	111316	279039
13627	15497	10	applied	\N	\N	\N	\N	111317	111317	279040
13627	15498	11	applied	\N	\N	\N	\N	111318	111318	279041
13628	15487	0	applied	\N	\N	\N	\N	111319	111319	279042
13628	15488	1	applied	\N	\N	\N	\N	111320	111320	279043
13628	15489	2	applied	\N	\N	\N	\N	111321	111321	279044
13628	15490	3	applied	\N	\N	\N	\N	111322	111322	279045
13628	15491	4	applied	\N	\N	\N	\N	111323	111323	279046
13628	15492	5	applied	\N	\N	\N	\N	111324	111324	279047
13628	15493	6	applied	\N	\N	\N	\N	111325	111325	279048
13628	15494	7	applied	\N	\N	\N	\N	111326	111326	279049
13628	15495	8	applied	\N	\N	\N	\N	111327	111327	279050
13628	15496	9	applied	\N	\N	\N	\N	111328	111328	279051
13628	15497	10	applied	\N	\N	\N	\N	111329	111329	279052
13628	15498	11	applied	\N	\N	\N	\N	111330	111330	279053
13631	15504	1	applied	\N	\N	\N	\N	111348	111348	279071
13631	15505	2	applied	\N	\N	\N	\N	111349	111349	279072
13631	15506	3	applied	\N	\N	\N	\N	111350	111350	279073
13634	15512	0	applied	\N	\N	\N	\N	111356	111356	279079
13634	15513	1	applied	\N	\N	\N	\N	111357	111357	279080
13634	15514	2	applied	\N	\N	\N	\N	111358	111358	279081
13634	15515	3	applied	\N	\N	\N	\N	111359	111359	279082
13634	15516	4	applied	\N	\N	\N	\N	111360	111360	279083
13634	15517	5	applied	\N	\N	\N	\N	111361	111361	279084
13634	15518	6	applied	\N	\N	\N	\N	111362	111362	279085
13634	15519	7	applied	\N	\N	\N	\N	111363	111363	279086
13634	15520	8	applied	\N	\N	\N	\N	111364	111364	279087
13634	15521	9	applied	\N	\N	\N	\N	111365	111365	279088
13634	15522	10	applied	\N	\N	\N	\N	111366	111366	279089
13634	15523	11	applied	\N	\N	\N	\N	111367	111367	279090
13634	15524	12	applied	\N	\N	\N	\N	111368	111368	279091
13635	15512	0	applied	\N	\N	\N	\N	111370	111370	279093
13638	15512	0	applied	\N	\N	\N	\N	111412	111412	279135
13638	15513	1	applied	\N	\N	\N	\N	111413	111413	279136
13639	15526	0	applied	\N	\N	\N	\N	111414	111414	279137
13639	15527	1	applied	\N	\N	\N	\N	111415	111415	279138
13639	15528	2	applied	\N	\N	\N	\N	111416	111416	279139
13639	15529	3	applied	\N	\N	\N	\N	111417	111417	279140
13639	15530	4	applied	\N	\N	\N	\N	111418	111418	279141
13639	15531	5	applied	\N	\N	\N	\N	111419	111419	279142
13639	15532	6	applied	\N	\N	\N	\N	111420	111420	279143
13639	15533	7	applied	\N	\N	\N	\N	111421	111421	279144
13639	15534	8	applied	\N	\N	\N	\N	111422	111422	279145
13639	15535	9	applied	\N	\N	\N	\N	111423	111423	279146
13639	15536	10	applied	\N	\N	\N	\N	111424	111424	279147
13571	15332	28	applied	\N	\N	\N	\N	111025	111025	278751
13571	15335	29	applied	\N	\N	\N	\N	111026	111026	278752
13635	15516	4	applied	\N	\N	\N	\N	111374	111374	279097
13635	15517	5	applied	\N	\N	\N	\N	111375	111375	279098
13635	15518	6	applied	\N	\N	\N	\N	111376	111376	279099
13635	15519	7	applied	\N	\N	\N	\N	111377	111377	279100
13635	15520	8	applied	\N	\N	\N	\N	111378	111378	279101
13635	15522	10	applied	\N	\N	\N	\N	111380	111380	279103
13635	15523	11	applied	\N	\N	\N	\N	111381	111381	279104
13635	15524	12	applied	\N	\N	\N	\N	111382	111382	279105
13635	15525	13	applied	\N	\N	\N	\N	111383	111383	279106
13639	15537	11	applied	\N	\N	\N	\N	111425	111425	279148
13639	15538	12	applied	\N	\N	\N	\N	111426	111426	279149
13639	15539	13	applied	\N	\N	\N	\N	111427	111427	279150
13639	15540	14	applied	\N	\N	\N	\N	111428	111428	279151
13639	15541	15	applied	\N	\N	\N	\N	111429	111429	279152
13640	15526	0	applied	\N	\N	\N	\N	111430	111430	279153
13640	15527	1	applied	\N	\N	\N	\N	111431	111431	279154
13640	15528	2	applied	\N	\N	\N	\N	111432	111432	279155
13640	15529	3	applied	\N	\N	\N	\N	111433	111433	279156
13640	15530	4	applied	\N	\N	\N	\N	111434	111434	279157
13640	15531	5	applied	\N	\N	\N	\N	111435	111435	279158
13640	15532	6	applied	\N	\N	\N	\N	111436	111436	279159
13640	15534	8	applied	\N	\N	\N	\N	111438	111438	279161
13640	15535	9	applied	\N	\N	\N	\N	111439	111439	279162
13640	15536	10	applied	\N	\N	\N	\N	111440	111440	279163
13640	15537	11	applied	\N	\N	\N	\N	111441	111441	279164
13640	15538	12	applied	\N	\N	\N	\N	111442	111442	279165
13640	15539	13	applied	\N	\N	\N	\N	111443	111443	279166
13640	15540	14	applied	\N	\N	\N	\N	111444	111444	279167
13640	15541	15	applied	\N	\N	\N	\N	111445	111445	279168
13642	15546	0	applied	\N	\N	\N	\N	111450	111450	279173
13642	15547	1	applied	\N	\N	\N	\N	111451	111451	279174
13642	15548	2	applied	\N	\N	\N	\N	111452	111452	279175
13642	15549	3	applied	\N	\N	\N	\N	111453	111453	279176
13645	15550	0	applied	\N	\N	\N	\N	111460	111460	279183
13645	15551	1	applied	\N	\N	\N	\N	111461	111461	279184
13645	15552	2	applied	\N	\N	\N	\N	111462	111462	279185
13647	15550	0	applied	\N	\N	\N	\N	111466	111466	279189
13647	15552	2	applied	\N	\N	\N	\N	111468	111468	279191
13649	15556	0	applied	\N	\N	\N	\N	111472	111472	279195
13649	15557	1	applied	\N	\N	\N	\N	111473	111473	279196
13650	15556	0	applied	\N	\N	\N	\N	111474	111474	279197
13651	15558	0	applied	\N	\N	\N	\N	111475	111475	279198
13651	15559	1	applied	\N	\N	\N	\N	111476	111476	279199
13651	15560	2	applied	\N	\N	\N	\N	111477	111477	279200
13652	15561	0	applied	\N	\N	\N	\N	111478	111478	279201
13652	15562	1	applied	\N	\N	\N	\N	111479	111479	279202
13652	15563	2	applied	\N	\N	\N	\N	111480	111480	279203
13657	14205	0	applied	\N	\N	1000000000	\N	111487	111487	279210
13657	15361	1	applied	\N	\N	\N	\N	111488	111488	279211
13657	14734	3	applied	\N	\N	1000000000	\N	111490	111490	279212
13657	14407	4	applied	\N	\N	\N	\N	111491	111491	279213
13657	14158	5	applied	\N	\N	\N	\N	111492	111492	279214
13657	14428	6	applied	\N	\N	\N	\N	111493	111493	279215
13657	14448	7	applied	\N	\N	\N	\N	111494	111494	279216
13657	14435	8	applied	\N	\N	\N	\N	111495	111495	279217
13657	14454	9	applied	\N	\N	\N	\N	111496	111496	279218
13657	14436	10	applied	\N	\N	\N	\N	111497	111497	279219
13657	14476	11	applied	\N	\N	\N	\N	111498	111498	279220
13657	14481	12	applied	\N	\N	\N	\N	111499	111499	279221
13657	14159	13	applied	\N	\N	\N	\N	111500	111500	279222
13657	14163	14	applied	\N	\N	\N	\N	111501	111501	279223
13657	14439	15	applied	\N	\N	\N	\N	111502	111502	279224
13657	14444	16	applied	\N	\N	\N	\N	111503	111503	279225
13657	14164	17	applied	\N	\N	\N	\N	111504	111504	279226
13657	14179	18	applied	\N	\N	\N	\N	111505	111505	279227
13657	14182	19	applied	\N	\N	\N	\N	111506	111506	279228
13657	14183	20	applied	\N	\N	\N	\N	111507	111507	279229
13657	14201	21	applied	\N	\N	\N	\N	111508	111508	279230
13659	15564	0	applied	\N	\N	\N	\N	111612	111612	279333
13659	15567	1	applied	\N	\N	\N	\N	111613	111613	279334
13659	15568	2	applied	\N	\N	\N	\N	111614	111614	279335
13659	15569	3	applied	\N	\N	\N	\N	111615	111615	279336
13659	15570	4	applied	\N	\N	\N	\N	111616	111616	279337
13659	15565	5	applied	\N	\N	\N	\N	111617	111617	279338
13659	15566	6	applied	\N	\N	\N	\N	111618	111618	279339
13659	15571	7	applied	\N	\N	\N	\N	111619	111619	279340
13659	15572	8	applied	\N	\N	\N	\N	111620	111620	279341
13659	15574	10	applied	\N	\N	\N	\N	111622	111622	279343
13659	15575	11	applied	\N	\N	\N	\N	111623	111623	279344
13659	15576	12	applied	\N	\N	\N	\N	111624	111624	279345
13659	15577	13	applied	\N	\N	\N	\N	111625	111625	279346
13663	15578	0	applied	\N	\N	\N	\N	111670	111670	279391
13663	15579	1	applied	\N	\N	\N	\N	111671	111671	279392
13663	15580	2	applied	\N	\N	\N	\N	111672	111672	279393
13663	15581	3	applied	\N	\N	\N	\N	111673	111673	279394
13663	15582	4	applied	\N	\N	\N	\N	111674	111674	279395
13663	15583	5	applied	\N	\N	\N	\N	111675	111675	279396
13663	15584	6	applied	\N	\N	\N	\N	111676	111676	279397
13663	15585	7	applied	\N	\N	\N	\N	111677	111677	279398
13663	15577	8	applied	\N	\N	\N	\N	111678	111678	279399
13663	15586	9	applied	\N	\N	\N	\N	111679	111679	279400
13663	15587	10	applied	\N	\N	\N	\N	111680	111680	279401
13663	15588	11	applied	\N	\N	\N	\N	111681	111681	279402
13663	15590	13	applied	\N	\N	\N	\N	111683	111683	279404
13663	15591	14	applied	\N	\N	\N	\N	111684	111684	279405
13663	15592	15	applied	\N	\N	\N	\N	111685	111685	279406
13663	15593	16	applied	\N	\N	\N	\N	111686	111686	279407
13667	15594	0	applied	\N	\N	\N	\N	111706	111706	279427
13667	15595	1	applied	\N	\N	\N	\N	111707	111707	279428
13667	15596	2	applied	\N	\N	\N	\N	111708	111708	279429
13671	15594	0	applied	\N	\N	\N	\N	111716	111716	279437
13671	15596	1	applied	\N	\N	\N	\N	111717	111717	279438
13674	15602	0	applied	\N	\N	\N	\N	111723	111723	279444
13674	15603	1	applied	\N	\N	\N	\N	111724	111724	279445
13674	15604	2	applied	\N	\N	\N	\N	111725	111725	279446
13676	15605	0	applied	\N	\N	\N	\N	111729	111729	279450
13676	15606	1	applied	\N	\N	\N	\N	111730	111730	279451
13676	15607	2	applied	\N	\N	\N	\N	111731	111731	279452
13681	15614	0	applied	\N	\N	\N	\N	111743	111743	279464
13635	15514	2	applied	\N	\N	\N	\N	111372	111372	279095
13635	15515	3	applied	\N	\N	\N	\N	111373	111373	279096
13636	15518	6	applied	\N	\N	\N	\N	111390	111390	279113
13636	15519	7	applied	\N	\N	\N	\N	111391	111391	279114
13636	15520	8	applied	\N	\N	\N	\N	111392	111392	279115
13636	15521	9	applied	\N	\N	\N	\N	111393	111393	279116
13636	15522	10	applied	\N	\N	\N	\N	111394	111394	279117
13636	15523	11	applied	\N	\N	\N	\N	111395	111395	279118
13636	15525	13	applied	\N	\N	\N	\N	111397	111397	279120
13643	15550	0	applied	\N	\N	\N	\N	111454	111454	279177
13643	15551	1	applied	\N	\N	\N	\N	111455	111455	279178
13643	15552	2	applied	\N	\N	\N	\N	111456	111456	279179
13646	15550	0	applied	\N	\N	\N	\N	111463	111463	279186
13646	15551	1	applied	\N	\N	\N	\N	111464	111464	279187
13646	15552	2	applied	\N	\N	\N	\N	111465	111465	279188
13655	15564	0	applied	\N	\N	\N	\N	111484	111484	279207
13655	15565	2	applied	\N	\N	\N	\N	111485	111485	279208
13655	15566	3	applied	\N	\N	\N	\N	111486	111486	279209
13660	15564	0	applied	\N	\N	\N	\N	111626	111626	279347
13660	15567	1	applied	\N	\N	\N	\N	111627	111627	279348
13660	15568	2	applied	\N	\N	\N	\N	111628	111628	279349
13660	15569	3	applied	\N	\N	\N	\N	111629	111629	279350
13660	15570	4	applied	\N	\N	\N	\N	111630	111630	279351
13660	15565	5	applied	\N	\N	\N	\N	111631	111631	279352
13660	15571	7	applied	\N	\N	\N	\N	111633	111633	279354
13660	15572	8	applied	\N	\N	\N	\N	111634	111634	279355
13660	15573	9	applied	\N	\N	\N	\N	111635	111635	279356
13660	15574	10	applied	\N	\N	\N	\N	111636	111636	279357
13660	15575	11	applied	\N	\N	\N	\N	111637	111637	279358
13660	15576	12	applied	\N	\N	\N	\N	111638	111638	279359
13668	15595	0	applied	\N	\N	\N	\N	111709	111709	279430
13669	15597	0	applied	\N	\N	\N	\N	111710	111710	279431
13669	15598	1	applied	\N	\N	\N	\N	111711	111711	279432
13669	15599	2	applied	\N	\N	\N	\N	111712	111712	279433
13672	15600	0	applied	\N	\N	\N	\N	111718	111718	279439
13672	15601	1	applied	\N	\N	\N	\N	111719	111719	279440
13679	15611	0	applied	\N	\N	\N	\N	111738	111738	279459
13679	15612	1	applied	\N	\N	\N	\N	111739	111739	279460
13679	15613	2	applied	\N	\N	\N	\N	111740	111740	279461
13682	15614	0	applied	\N	\N	\N	\N	111745	111745	279466
13684	15623	0	applied	\N	\N	\N	\N	111754	111754	279475
13684	15624	1	applied	\N	\N	\N	\N	111755	111755	279476
13687	15623	0	applied	\N	\N	\N	\N	111760	111760	279481
13687	15624	1	applied	\N	\N	\N	\N	111761	111761	279482
13688	15625	0	applied	\N	\N	\N	\N	111762	111762	279483
13688	15626	1	applied	\N	\N	\N	\N	111763	111763	279484
13690	15627	0	applied	\N	\N	\N	\N	111766	111766	279487
13690	15628	1	applied	\N	\N	\N	\N	111767	111767	279488
13691	15627	0	applied	\N	\N	\N	\N	111768	111768	279489
13691	15628	1	applied	\N	\N	\N	\N	111769	111769	279490
13693	15629	0	applied	\N	\N	\N	\N	111774	111774	279495
13693	15630	1	applied	\N	\N	\N	\N	111775	111775	279496
13693	15631	2	applied	\N	\N	\N	\N	111776	111776	279497
13693	15632	3	applied	\N	\N	\N	\N	111777	111777	279498
13696	15639	0	applied	\N	\N	\N	\N	111872	111872	279591
13696	15640	1	applied	\N	\N	\N	\N	111873	111873	279592
13698	15642	1	applied	\N	\N	\N	\N	111877	111877	279596
13701	15645	0	applied	\N	\N	\N	\N	111882	111882	279601
13701	15646	1	applied	\N	\N	\N	\N	111883	111883	279602
13702	15647	0	applied	\N	\N	\N	\N	111884	111884	279603
13702	15648	1	applied	\N	\N	\N	\N	111885	111885	279604
13702	15649	2	applied	\N	\N	\N	\N	111886	111886	279605
13702	15650	3	applied	\N	\N	\N	\N	111887	111887	279606
13704	15361	0	applied	\N	\N	\N	\N	111892	111892	279611
13704	15578	2	applied	\N	\N	\N	\N	111894	111894	279612
13704	15619	3	applied	\N	\N	\N	\N	111895	111895	279613
13704	15581	4	applied	\N	\N	\N	\N	111896	111896	279614
13704	15582	5	applied	\N	\N	\N	\N	111897	111897	279615
13704	15583	6	applied	\N	\N	\N	\N	111898	111898	279616
13704	15336	7	applied	\N	\N	\N	\N	111899	111899	279617
13704	15337	8	applied	\N	\N	\N	\N	111900	111900	279618
13704	15338	9	applied	\N	\N	\N	\N	111901	111901	279619
13704	15339	10	applied	\N	\N	\N	\N	111902	111902	279620
13704	15340	11	applied	\N	\N	\N	\N	111903	111903	279621
13704	15625	12	applied	\N	\N	\N	\N	111904	111904	279622
13704	15275	13	applied	\N	\N	\N	\N	111905	111905	279623
13704	15279	14	applied	\N	\N	\N	\N	111906	111906	279624
13706	15653	0	applied	\N	\N	\N	\N	111909	111909	279627
13706	15654	1	applied	\N	\N	\N	\N	111910	111910	279628
13706	15655	2	applied	\N	\N	\N	\N	111911	111911	279629
13706	15656	3	applied	\N	\N	\N	\N	111912	111912	279630
13707	15657	0	applied	\N	\N	\N	\N	111913	111913	279631
13707	15658	1	applied	\N	\N	\N	\N	111914	111914	279632
13709	15663	0	applied	\N	\N	\N	\N	111919	111919	279637
13709	15664	1	applied	\N	\N	\N	\N	111920	111920	279638
13709	15665	2	applied	\N	\N	\N	\N	111921	111921	279639
13709	15666	3	applied	\N	\N	\N	\N	111922	111922	279640
13710	15663	0	applied	\N	\N	\N	\N	111923	111923	279641
13710	15664	1	applied	\N	\N	\N	\N	111924	111924	279642
13710	15665	2	applied	\N	\N	\N	\N	111925	111925	279643
13710	15666	3	applied	\N	\N	\N	\N	111926	111926	279644
13714	15667	0	applied	\N	\N	1000000000	\N	111944	111944	279662
13714	15668	1	applied	\N	\N	\N	\N	111945	111945	279663
13714	15669	2	applied	\N	\N	\N	\N	111946	111946	279664
13714	15670	3	applied	\N	\N	\N	\N	111947	111947	279665
13714	15671	4	applied	\N	\N	\N	\N	111948	111948	279666
13714	15673	6	applied	\N	\N	\N	\N	111950	111950	279668
13714	15674	7	applied	\N	\N	\N	\N	111951	111951	279669
13714	15675	8	applied	\N	\N	\N	\N	111952	111952	279670
13717	15694	0	applied	\N	\N	\N	\N	111971	111971	279689
13717	15695	1	applied	\N	\N	\N	\N	111972	111972	279690
13717	15696	2	applied	\N	\N	\N	\N	111973	111973	279691
13717	15697	3	applied	\N	\N	\N	\N	111974	111974	279692
13717	15698	4	applied	\N	\N	\N	\N	111975	111975	279693
13717	15699	5	applied	\N	\N	\N	\N	111976	111976	279694
13717	15700	6	applied	\N	\N	\N	\N	111977	111977	279695
13719	15701	0	applied	\N	\N	\N	\N	111982	111982	279700
13719	15702	1	applied	\N	\N	\N	\N	111983	111983	279701
13720	15701	0	applied	\N	\N	\N	\N	111986	111986	279704
13720	15702	1	applied	\N	\N	\N	\N	111987	111987	279705
13720	15703	2	applied	\N	\N	\N	\N	111988	111988	279706
13636	15515	3	applied	\N	\N	\N	\N	111387	111387	279110
13636	15517	5	applied	\N	\N	\N	\N	111389	111389	279112
13644	15552	2	applied	\N	\N	\N	\N	111459	111459	279182
13648	15553	0	applied	\N	\N	\N	\N	111469	111469	279192
13648	15554	1	applied	\N	\N	\N	\N	111470	111470	279193
13648	15555	2	applied	\N	\N	\N	\N	111471	111471	279194
13653	15564	0	applied	\N	\N	\N	\N	111481	111481	279204
13653	15565	2	applied	\N	\N	\N	\N	111482	111482	279205
13653	15566	3	applied	\N	\N	\N	\N	111483	111483	279206
13664	15578	0	applied	\N	\N	\N	\N	111687	111687	279408
13664	15579	1	applied	\N	\N	\N	\N	111688	111688	279409
13664	15581	3	applied	\N	\N	\N	\N	111690	111690	279411
13664	15582	4	applied	\N	\N	\N	\N	111691	111691	279412
13664	15583	5	applied	\N	\N	\N	\N	111692	111692	279413
13664	15584	6	applied	\N	\N	\N	\N	111693	111693	279414
13664	15585	7	applied	\N	\N	\N	\N	111694	111694	279415
13664	15586	8	applied	\N	\N	\N	\N	111695	111695	279416
13664	15587	9	applied	\N	\N	\N	\N	111696	111696	279417
13664	15588	10	applied	\N	\N	\N	\N	111697	111697	279418
13664	15589	11	applied	\N	\N	\N	\N	111698	111698	279419
13664	15590	12	applied	\N	\N	\N	\N	111699	111699	279420
13664	15591	13	applied	\N	\N	\N	\N	111700	111700	279421
13664	15592	14	applied	\N	\N	\N	\N	111701	111701	279422
13664	15593	15	applied	\N	\N	\N	\N	111702	111702	279423
13670	15597	0	applied	\N	\N	\N	\N	111713	111713	279434
13670	15598	1	applied	\N	\N	\N	\N	111714	111714	279435
13670	15599	2	applied	\N	\N	\N	\N	111715	111715	279436
13675	15606	1	applied	\N	\N	\N	\N	111727	111727	279448
13675	15607	2	applied	\N	\N	\N	\N	111728	111728	279449
13677	15608	0	applied	\N	\N	\N	\N	111732	111732	279453
13677	15609	1	applied	\N	\N	\N	\N	111733	111733	279454
13677	15610	2	applied	\N	\N	\N	\N	111734	111734	279455
13685	15623	0	applied	\N	\N	\N	\N	111756	111756	279477
13685	15624	1	applied	\N	\N	\N	\N	111757	111757	279478
13686	15623	0	applied	\N	\N	\N	\N	111758	111758	279479
13686	15624	1	applied	\N	\N	\N	\N	111759	111759	279480
13689	15625	0	applied	\N	\N	\N	\N	111764	111764	279485
13689	15626	1	applied	\N	\N	\N	\N	111765	111765	279486
13694	15451	0	applied	\N	\N	\N	\N	111778	111778	111778
13694	15361	1	applied	\N	\N	\N	\N	111779	111779	279499
13694	15578	3	applied	\N	\N	\N	\N	111781	111781	279500
13694	15343	4	applied	\N	\N	\N	\N	111782	111782	279501
13694	15619	5	applied	\N	\N	\N	\N	111783	111783	279502
13694	15581	6	applied	\N	\N	\N	\N	111784	111784	279503
13694	15582	7	applied	\N	\N	\N	\N	111785	111785	279504
13694	15583	8	applied	\N	\N	\N	\N	111786	111786	279505
13694	15346	9	applied	\N	\N	\N	\N	111787	111787	279506
13694	15349	10	applied	\N	\N	\N	\N	111788	111788	279507
13694	15352	11	applied	\N	\N	\N	\N	111789	111789	279508
13694	15353	12	applied	\N	\N	\N	\N	111790	111790	279509
13694	15354	13	applied	\N	\N	\N	\N	111791	111791	279510
13694	15362	14	applied	\N	\N	\N	\N	111792	111792	279511
13694	15365	15	applied	\N	\N	\N	\N	111793	111793	279512
13694	15366	16	applied	\N	\N	\N	\N	111794	111794	279513
13694	15372	17	applied	\N	\N	\N	\N	111795	111795	279514
13694	15373	18	applied	\N	\N	\N	\N	111796	111796	279515
13694	15374	19	applied	\N	\N	\N	\N	111797	111797	279516
13694	15384	20	applied	\N	\N	\N	\N	111798	111798	279517
13694	15389	21	applied	\N	\N	\N	\N	111799	111799	279518
13694	15393	22	applied	\N	\N	\N	\N	111800	111800	279519
13694	15398	23	applied	\N	\N	\N	\N	111801	111801	279520
13694	15402	24	applied	\N	\N	\N	\N	111802	111802	279521
13694	15405	25	applied	\N	\N	\N	\N	111803	111803	279522
13694	15409	26	applied	\N	\N	\N	\N	111804	111804	279523
13694	15412	27	applied	\N	\N	\N	\N	111805	111805	279524
13694	15416	28	applied	\N	\N	\N	\N	111806	111806	279525
13694	15417	29	applied	\N	\N	\N	\N	111807	111807	279526
13694	15419	31	applied	\N	\N	\N	\N	111809	111809	279528
13694	15420	32	applied	\N	\N	\N	\N	111810	111810	279529
13694	15421	33	applied	\N	\N	\N	\N	111811	111811	279530
13694	15422	34	applied	\N	\N	\N	\N	111812	111812	279531
13694	15443	35	applied	\N	\N	\N	\N	111813	111813	279532
13694	15447	36	applied	\N	\N	\N	\N	111814	111814	279533
13694	15452	37	applied	\N	\N	\N	\N	111815	111815	279534
13694	15453	38	applied	\N	\N	\N	\N	111816	111816	279535
13694	15460	39	applied	\N	\N	\N	\N	111817	111817	279536
13694	15625	40	applied	\N	\N	\N	\N	111818	111818	279537
13694	15463	42	applied	\N	\N	\N	\N	111819	111819	279538
13720	15704	3	applied	\N	\N	\N	\N	111989	111989	279707
13734	15734	0	applied	\N	\N	\N	\N	112047	112047	279765
13734	15735	1	applied	\N	\N	\N	\N	112048	112048	279766
13734	15736	2	applied	\N	\N	\N	\N	112049	112049	279767
13734	15737	3	applied	\N	\N	\N	\N	112050	112050	279768
13739	15742	1	applied	\N	\N	\N	\N	112065	112065	279783
13739	15743	2	applied	\N	\N	\N	\N	112066	112066	279784
13739	15744	3	applied	\N	\N	\N	\N	112067	112067	279785
13741	15745	0	applied	\N	\N	\N	\N	112072	112072	279790
13741	15746	1	applied	\N	\N	\N	\N	112073	112073	279791
13741	15747	2	applied	\N	\N	\N	\N	112074	112074	279792
13741	15748	3	applied	\N	\N	\N	\N	112075	112075	279793
13741	15749	4	applied	\N	\N	\N	\N	112076	112076	279794
13741	15750	5	applied	\N	\N	\N	\N	112077	112077	279795
13741	15751	6	applied	\N	\N	\N	\N	112078	112078	279796
13741	15752	7	applied	\N	\N	\N	\N	112079	112079	279797
13741	15753	8	applied	\N	\N	\N	\N	112080	112080	279798
13741	15754	9	applied	\N	\N	\N	\N	112081	112081	279799
13741	15755	10	applied	\N	\N	\N	\N	112082	112082	279800
13741	15756	11	applied	\N	\N	\N	\N	112083	112083	279801
13741	15757	12	applied	\N	\N	\N	\N	112084	112084	279802
13741	15759	14	applied	\N	\N	\N	\N	112086	112086	279804
13741	15760	15	applied	\N	\N	\N	\N	112087	112087	279805
13741	15761	16	applied	\N	\N	\N	\N	112088	112088	279806
13741	15762	17	applied	\N	\N	\N	\N	112089	112089	279807
13741	15763	18	applied	\N	\N	\N	\N	112090	112090	279808
13741	15764	19	applied	\N	\N	\N	\N	112091	112091	279809
13747	15765	0	applied	\N	\N	\N	\N	112161	112161	279879
13748	15769	0	applied	\N	\N	\N	\N	112162	112162	279880
13748	15770	1	applied	\N	\N	\N	\N	112163	112163	279881
13748	15771	2	applied	\N	\N	\N	\N	112164	112164	279882
13748	15772	3	applied	\N	\N	\N	\N	112165	112165	279883
13748	15773	4	applied	\N	\N	\N	\N	112166	112166	279884
13748	15774	5	applied	\N	\N	\N	\N	112167	112167	279885
13644	15550	0	applied	\N	\N	\N	\N	111457	111457	279180
13644	15551	1	applied	\N	\N	\N	\N	111458	111458	279181
13657	14491	25	applied	\N	\N	\N	\N	111512	111512	279234
13657	14492	26	applied	\N	\N	\N	\N	111513	111513	279235
13657	14207	27	applied	\N	\N	\N	\N	111514	111514	279236
13657	14213	28	applied	\N	\N	\N	\N	111515	111515	279237
13657	14217	29	applied	\N	\N	\N	\N	111516	111516	279238
13657	14220	30	applied	\N	\N	\N	\N	111517	111517	279239
13657	14224	31	applied	\N	\N	\N	\N	111518	111518	279240
13657	14231	33	applied	\N	\N	\N	\N	111520	111520	279242
13657	14660	35	applied	\N	\N	1000000000	\N	111522	111522	279243
13657	14655	34	failed	Amount_insufficient_to_create_account	\N	\N	\N	111521	111521	\N
13657	14731	36	applied	\N	\N	\N	\N	111523	111523	279244
13657	15336	37	applied	\N	\N	\N	\N	111524	111524	279245
13657	15337	38	applied	\N	\N	\N	\N	111525	111525	279246
13657	15338	39	applied	\N	\N	\N	\N	111526	111526	279247
13657	15339	40	applied	\N	\N	\N	\N	111527	111527	279248
13657	15340	41	applied	\N	\N	\N	\N	111528	111528	279249
13657	14165	42	applied	\N	\N	\N	\N	111529	111529	279250
13657	14166	43	applied	\N	\N	\N	\N	111530	111530	279251
13657	14167	44	applied	\N	\N	\N	\N	111531	111531	279252
13657	14168	45	applied	\N	\N	\N	\N	111532	111532	279253
13657	14169	46	applied	\N	\N	\N	\N	111533	111533	279254
13657	14170	47	applied	\N	\N	\N	\N	111534	111534	279255
13657	14171	48	applied	\N	\N	\N	\N	111535	111535	279256
13657	14173	50	applied	\N	\N	\N	\N	111537	111537	279258
13657	14174	51	applied	\N	\N	\N	\N	111538	111538	279259
13657	14184	52	applied	\N	\N	\N	\N	111539	111539	279260
13657	14185	53	applied	\N	\N	\N	\N	111540	111540	279261
13657	14186	54	applied	\N	\N	\N	\N	111541	111541	279262
13657	14187	55	applied	\N	\N	\N	\N	111542	111542	279263
13657	14188	56	applied	\N	\N	\N	\N	111543	111543	279264
13657	14189	57	applied	\N	\N	\N	\N	111544	111544	279265
13657	14190	58	applied	\N	\N	\N	\N	111545	111545	279266
13657	14191	59	applied	\N	\N	\N	\N	111546	111546	279267
13657	14192	60	applied	\N	\N	\N	\N	111547	111547	279268
13657	14232	61	applied	\N	\N	\N	\N	111548	111548	279269
13657	14239	62	applied	\N	\N	\N	\N	111549	111549	279270
13657	14242	63	applied	\N	\N	\N	\N	111550	111550	279271
13657	14245	64	applied	\N	\N	\N	\N	111551	111551	279272
13657	14246	65	applied	\N	\N	\N	\N	111552	111552	279273
13657	14255	67	applied	\N	\N	\N	\N	111554	111554	279275
13657	14259	69	applied	\N	\N	\N	\N	111555	111555	279276
13657	14260	70	applied	\N	\N	\N	\N	111556	111556	279277
13657	14267	71	applied	\N	\N	\N	\N	111557	111557	279278
13657	14271	72	applied	\N	\N	\N	\N	111558	111558	279279
13657	14275	73	applied	\N	\N	\N	\N	111559	111559	279280
13657	14279	74	applied	\N	\N	\N	\N	111560	111560	279281
13657	14282	75	applied	\N	\N	\N	\N	111561	111561	279282
13657	14286	76	applied	\N	\N	\N	\N	111562	111562	279283
13657	14290	77	applied	\N	\N	\N	\N	111563	111563	279284
13657	14291	78	applied	\N	\N	\N	\N	111564	111564	279285
13657	14296	79	applied	\N	\N	\N	\N	111565	111565	279286
13657	14297	80	applied	\N	\N	\N	\N	111566	111566	279287
13657	14304	81	applied	\N	\N	\N	\N	111567	111567	279288
13657	14308	82	applied	\N	\N	\N	\N	111568	111568	279289
13657	14311	83	applied	\N	\N	\N	\N	111569	111569	279290
13657	14315	85	applied	\N	\N	\N	\N	111571	111571	279292
13657	14322	86	applied	\N	\N	\N	\N	111572	111572	279293
13657	14326	87	applied	\N	\N	\N	\N	111573	111573	279294
13657	14327	88	applied	\N	\N	\N	\N	111574	111574	279295
13657	14328	89	applied	\N	\N	\N	\N	111575	111575	279296
13657	14338	90	applied	\N	\N	\N	\N	111576	111576	279297
13657	14341	91	applied	\N	\N	\N	\N	111577	111577	279298
13657	14345	92	applied	\N	\N	\N	\N	111578	111578	279299
13657	14348	93	applied	\N	\N	\N	\N	111579	111579	279300
13657	14349	94	applied	\N	\N	\N	\N	111580	111580	279301
13657	14350	95	applied	\N	\N	\N	\N	111581	111581	279302
13657	14360	96	applied	\N	\N	\N	\N	111582	111582	279303
13657	14367	97	applied	\N	\N	\N	\N	111583	111583	279304
13657	14368	98	applied	\N	\N	\N	\N	111584	111584	279305
13657	14369	99	applied	\N	\N	\N	\N	111585	111585	279306
13657	14370	100	applied	\N	\N	\N	\N	111586	111586	279307
13657	14384	102	applied	\N	\N	\N	\N	111588	111588	279309
13657	14388	103	applied	\N	\N	\N	\N	111589	111589	279310
13657	14392	104	applied	\N	\N	\N	\N	111590	111590	279311
13657	14396	105	applied	\N	\N	\N	\N	111591	111591	279312
13694	15467	43	applied	\N	\N	\N	\N	111820	111820	279539
13694	15471	44	applied	\N	\N	\N	\N	111821	111821	279540
13694	15475	45	applied	\N	\N	\N	\N	111822	111822	279541
13694	15479	46	applied	\N	\N	\N	\N	111823	111823	279542
13694	15483	47	applied	\N	\N	\N	\N	111824	111824	279543
13694	15487	48	applied	\N	\N	\N	\N	111825	111825	279544
13694	15488	49	applied	\N	\N	\N	\N	111826	111826	279545
13694	15489	50	applied	\N	\N	\N	\N	111827	111827	279546
13694	15499	51	applied	\N	\N	\N	\N	111828	111828	279547
13694	15503	52	applied	\N	\N	\N	\N	111829	111829	279548
13694	15507	53	applied	\N	\N	\N	\N	111830	111830	279549
13694	15510	54	applied	\N	\N	\N	\N	111831	111831	279550
13694	15512	56	applied	\N	\N	\N	\N	111833	111833	279552
13694	15513	57	applied	\N	\N	\N	\N	111834	111834	279553
13694	15526	58	applied	\N	\N	\N	\N	111835	111835	279554
13694	15527	59	applied	\N	\N	\N	\N	111836	111836	279555
13694	15528	60	applied	\N	\N	\N	\N	111837	111837	279556
13694	15529	61	applied	\N	\N	\N	\N	111838	111838	279557
13694	15542	62	applied	\N	\N	\N	\N	111839	111839	279558
13694	15546	63	applied	\N	\N	\N	\N	111840	111840	279559
13694	15550	64	applied	\N	\N	\N	\N	111841	111841	279560
13694	15553	65	applied	\N	\N	\N	\N	111842	111842	279561
13694	15556	66	applied	\N	\N	\N	\N	111843	111843	279562
13694	15558	67	applied	\N	\N	\N	\N	111844	111844	279563
13694	15561	68	applied	\N	\N	\N	\N	111845	111845	279564
13694	15564	69	applied	\N	\N	\N	\N	111846	111846	279565
13694	15567	70	applied	\N	\N	\N	\N	111847	111847	279566
13694	15568	71	applied	\N	\N	\N	\N	111848	111848	279567
13694	15570	73	applied	\N	\N	\N	\N	111850	111850	279569
13694	15579	74	applied	\N	\N	\N	\N	111851	111851	279570
13694	15580	75	applied	\N	\N	\N	\N	111852	111852	279571
13694	15584	76	applied	\N	\N	\N	\N	111853	111853	279572
13694	15585	77	applied	\N	\N	\N	\N	111854	111854	279573
13694	15594	78	applied	\N	\N	\N	\N	111855	111855	279574
13657	14482	23	applied	\N	\N	\N	\N	111510	111510	279232
13657	14489	24	applied	\N	\N	\N	\N	111511	111511	279233
13657	14410	110	applied	\N	\N	\N	\N	111596	111596	279317
13657	14411	111	applied	\N	\N	\N	\N	111597	111597	279318
13657	14412	112	applied	\N	\N	\N	\N	111598	111598	279319
13657	14413	113	applied	\N	\N	\N	\N	111599	111599	279320
13657	14429	114	applied	\N	\N	\N	\N	111600	111600	279321
13657	14433	115	applied	\N	\N	\N	\N	111601	111601	279322
13657	14437	116	applied	\N	\N	\N	\N	111602	111602	279323
13657	14438	117	applied	\N	\N	\N	\N	111603	111603	279324
13657	14445	118	applied	\N	\N	\N	\N	111604	111604	279325
13657	14449	119	applied	\N	\N	\N	\N	111605	111605	279326
13657	14452	120	applied	\N	\N	\N	\N	111606	111606	279327
13657	14453	121	applied	\N	\N	\N	\N	111607	111607	279328
13657	14455	122	applied	\N	\N	\N	\N	111608	111608	279329
13657	14462	123	applied	\N	\N	\N	\N	111609	111609	279330
13657	14468	125	applied	\N	\N	\N	\N	111611	111611	279332
13661	15564	0	applied	\N	\N	\N	\N	111639	111639	279360
13661	15567	1	applied	\N	\N	\N	\N	111640	111640	279361
13661	15568	2	applied	\N	\N	\N	\N	111641	111641	279362
13661	15569	3	applied	\N	\N	\N	\N	111642	111642	279363
13661	15570	4	applied	\N	\N	\N	\N	111643	111643	279364
13661	15565	5	applied	\N	\N	\N	\N	111644	111644	279365
13661	15566	6	applied	\N	\N	\N	\N	111645	111645	279366
13661	15571	7	applied	\N	\N	\N	\N	111646	111646	279367
13661	15572	8	applied	\N	\N	\N	\N	111647	111647	279368
13661	15573	9	applied	\N	\N	\N	\N	111648	111648	279369
13661	15574	10	applied	\N	\N	\N	\N	111649	111649	279370
13661	15575	11	applied	\N	\N	\N	\N	111650	111650	279371
13661	15576	12	applied	\N	\N	\N	\N	111651	111651	279372
13661	15577	13	applied	\N	\N	\N	\N	111652	111652	279373
13662	15578	0	applied	\N	\N	\N	\N	111653	111653	279374
13662	15580	2	applied	\N	\N	\N	\N	111655	111655	279376
13662	15581	3	applied	\N	\N	\N	\N	111656	111656	279377
13662	15582	4	applied	\N	\N	\N	\N	111657	111657	279378
13662	15583	5	applied	\N	\N	\N	\N	111658	111658	279379
13662	15584	6	applied	\N	\N	\N	\N	111659	111659	279380
13662	15585	7	applied	\N	\N	\N	\N	111660	111660	279381
13662	15577	8	applied	\N	\N	\N	\N	111661	111661	279382
13662	15586	9	applied	\N	\N	\N	\N	111662	111662	279383
13662	15587	10	applied	\N	\N	\N	\N	111663	111663	279384
13662	15588	11	applied	\N	\N	\N	\N	111664	111664	279385
13662	15589	12	applied	\N	\N	\N	\N	111665	111665	279386
13662	15590	13	applied	\N	\N	\N	\N	111666	111666	279387
13662	15591	14	applied	\N	\N	\N	\N	111667	111667	279388
13662	15592	15	applied	\N	\N	\N	\N	111668	111668	279389
13662	15593	16	applied	\N	\N	\N	\N	111669	111669	279390
13666	15594	0	applied	\N	\N	\N	\N	111703	111703	279424
13666	15596	2	applied	\N	\N	\N	\N	111705	111705	279426
13673	15602	0	applied	\N	\N	\N	\N	111720	111720	279441
13673	15603	1	applied	\N	\N	\N	\N	111721	111721	279442
13673	15604	2	applied	\N	\N	\N	\N	111722	111722	279443
13678	15611	0	applied	\N	\N	\N	\N	111735	111735	279456
13678	15612	1	applied	\N	\N	\N	\N	111736	111736	279457
13678	15613	2	applied	\N	\N	\N	\N	111737	111737	279458
13680	15614	0	applied	\N	\N	\N	\N	111741	111741	279462
13680	15615	1	applied	\N	\N	\N	\N	111742	111742	279463
13683	15616	0	applied	\N	\N	\N	\N	111747	111747	279468
13683	15617	1	applied	\N	\N	\N	\N	111748	111748	279469
13683	15618	2	applied	\N	\N	\N	\N	111749	111749	279470
13683	15619	3	applied	\N	\N	\N	\N	111750	111750	279471
13683	15620	4	applied	\N	\N	\N	\N	111751	111751	279472
13683	15621	5	applied	\N	\N	\N	\N	111752	111752	279473
13683	15622	6	applied	\N	\N	\N	\N	111753	111753	279474
13692	15630	1	applied	\N	\N	\N	\N	111771	111771	279492
13692	15631	2	applied	\N	\N	\N	\N	111772	111772	279493
13692	15632	3	applied	\N	\N	\N	\N	111773	111773	279494
13695	15633	0	applied	\N	\N	\N	\N	111866	111866	279585
13695	15634	1	applied	\N	\N	\N	\N	111867	111867	279586
13695	15635	2	applied	\N	\N	\N	\N	111868	111868	279587
13695	15636	3	applied	\N	\N	\N	\N	111869	111869	279588
13695	15637	4	applied	\N	\N	\N	\N	111870	111870	279589
13695	15638	5	applied	\N	\N	\N	\N	111871	111871	279590
13700	15645	0	applied	\N	\N	\N	\N	111880	111880	279599
13700	15646	1	applied	\N	\N	\N	\N	111881	111881	279600
13705	15651	0	applied	\N	\N	\N	\N	111907	111907	279625
13705	15652	1	applied	\N	\N	\N	\N	111908	111908	279626
13708	15659	0	applied	\N	\N	\N	\N	111915	111915	279633
13708	15660	1	applied	\N	\N	\N	\N	111916	111916	279634
13708	15661	2	applied	\N	\N	\N	\N	111917	111917	279635
13712	15663	0	applied	\N	\N	\N	\N	111931	111931	279649
13712	15664	1	applied	\N	\N	\N	\N	111932	111932	279650
13712	15665	2	applied	\N	\N	\N	\N	111933	111933	279651
13712	15666	3	applied	\N	\N	\N	\N	111934	111934	279652
13713	15667	0	applied	\N	\N	1000000000	\N	111935	111935	279653
13713	15668	1	applied	\N	\N	\N	\N	111936	111936	279654
13713	15669	2	applied	\N	\N	\N	\N	111937	111937	279655
13713	15670	3	applied	\N	\N	\N	\N	111938	111938	279656
13713	15671	4	applied	\N	\N	\N	\N	111939	111939	279657
13713	15672	5	applied	\N	\N	\N	\N	111940	111940	279658
13713	15673	6	applied	\N	\N	\N	\N	111941	111941	279659
13713	15674	7	applied	\N	\N	\N	\N	111942	111942	279660
13713	15675	8	applied	\N	\N	\N	\N	111943	111943	279661
13716	15685	0	applied	\N	\N	\N	\N	111962	111962	279680
13716	15686	1	applied	\N	\N	\N	\N	111963	111963	279681
13716	15687	2	applied	\N	\N	\N	\N	111964	111964	279682
13716	15689	4	applied	\N	\N	\N	\N	111966	111966	279684
13716	15690	5	applied	\N	\N	\N	\N	111967	111967	279685
13716	15691	6	applied	\N	\N	\N	\N	111968	111968	279686
13716	15692	7	applied	\N	\N	\N	\N	111969	111969	279687
13716	15693	8	applied	\N	\N	\N	\N	111970	111970	279688
13724	15713	0	applied	\N	\N	\N	\N	112002	112002	279720
13724	15714	1	applied	\N	\N	\N	\N	112003	112003	279721
13724	15715	2	applied	\N	\N	\N	\N	112004	112004	279722
13724	15716	3	applied	\N	\N	\N	\N	112005	112005	279723
13724	15717	4	applied	\N	\N	\N	\N	112006	112006	279724
13726	15718	0	applied	\N	\N	\N	\N	112012	112012	279730
13726	15719	1	applied	\N	\N	\N	\N	112013	112013	279731
13726	15720	2	applied	\N	\N	\N	\N	112014	112014	279732
13726	15721	3	applied	\N	\N	\N	\N	112015	112015	279733
13729	15722	0	applied	\N	\N	\N	\N	112024	112024	279742
13729	15719	1	applied	\N	\N	\N	\N	112025	112025	279743
13657	14409	109	applied	\N	\N	\N	\N	111595	111595	279316
13694	15608	83	applied	\N	\N	\N	\N	111860	111860	279579
13694	15611	84	applied	\N	\N	\N	\N	111861	111861	279580
13694	15614	85	applied	\N	\N	\N	\N	111862	111862	279581
13694	15616	86	applied	\N	\N	\N	\N	111863	111863	279582
13694	15617	87	applied	\N	\N	\N	\N	111864	111864	279583
13694	15618	88	applied	\N	\N	\N	\N	111865	111865	279584
13697	15639	0	applied	\N	\N	\N	\N	111874	111874	279593
13697	15640	1	applied	\N	\N	\N	\N	111875	111875	279594
13699	15643	0	applied	\N	\N	\N	\N	111878	111878	279597
13699	15644	1	applied	\N	\N	\N	\N	111879	111879	279598
13703	15647	0	applied	\N	\N	\N	\N	111888	111888	279607
13703	15648	1	applied	\N	\N	\N	\N	111889	111889	279608
13703	15649	2	applied	\N	\N	\N	\N	111890	111890	279609
13703	15650	3	applied	\N	\N	\N	\N	111891	111891	279610
13711	15663	0	applied	\N	\N	\N	\N	111927	111927	279645
13711	15664	1	applied	\N	\N	\N	\N	111928	111928	279646
13711	15666	3	applied	\N	\N	\N	\N	111930	111930	279648
13715	15676	0	applied	\N	\N	\N	\N	111953	111953	279671
13715	15677	1	applied	\N	\N	\N	\N	111954	111954	279672
13715	15678	2	applied	\N	\N	\N	\N	111955	111955	279673
13715	15679	3	applied	\N	\N	\N	\N	111956	111956	279674
13715	15680	4	applied	\N	\N	\N	\N	111957	111957	279675
13715	15681	5	applied	\N	\N	\N	\N	111958	111958	279676
13715	15682	6	applied	\N	\N	\N	\N	111959	111959	279677
13715	15683	7	applied	\N	\N	\N	\N	111960	111960	279678
13715	15684	8	applied	\N	\N	\N	\N	111961	111961	279679
13718	15701	0	applied	\N	\N	\N	\N	111978	111978	279696
13718	15702	1	applied	\N	\N	\N	\N	111979	111979	279697
13718	15703	2	applied	\N	\N	\N	\N	111980	111980	279698
13718	15704	3	applied	\N	\N	\N	\N	111981	111981	279699
13721	15705	0	applied	\N	\N	\N	\N	111990	111990	279708
13721	15706	1	applied	\N	\N	\N	\N	111991	111991	279709
13721	15708	3	applied	\N	\N	\N	\N	111993	111993	279711
13723	15709	0	applied	\N	\N	\N	\N	111998	111998	279716
13723	15710	1	applied	\N	\N	\N	\N	111999	111999	279717
13723	15711	2	applied	\N	\N	\N	\N	112000	112000	279718
13723	15712	3	applied	\N	\N	\N	\N	112001	112001	279719
13728	15722	0	applied	\N	\N	\N	\N	112017	112017	279735
13728	15719	1	applied	\N	\N	\N	\N	112018	112018	279736
13728	15720	2	applied	\N	\N	\N	\N	112019	112019	279737
13728	15721	3	applied	\N	\N	\N	\N	112020	112020	279738
13728	15723	4	applied	\N	\N	\N	\N	112021	112021	279739
13728	15724	5	applied	\N	\N	\N	\N	112022	112022	279740
13728	15725	6	applied	\N	\N	\N	\N	112023	112023	279741
13729	15720	2	applied	\N	\N	\N	\N	112026	112026	279744
13729	15721	3	applied	\N	\N	\N	\N	112027	112027	279745
13729	15723	4	applied	\N	\N	\N	\N	112028	112028	279746
13729	15724	5	applied	\N	\N	\N	\N	112029	112029	279747
13730	15726	0	applied	\N	\N	\N	\N	112031	112031	279749
13730	15727	1	applied	\N	\N	\N	\N	112032	112032	279750
13730	15728	2	applied	\N	\N	\N	\N	112033	112033	279751
13730	15729	3	applied	\N	\N	\N	\N	112034	112034	279752
13731	15730	0	applied	\N	\N	\N	\N	112035	112035	279753
13731	15731	1	applied	\N	\N	\N	\N	112036	112036	279754
13731	15732	2	applied	\N	\N	\N	\N	112037	112037	279755
13731	15733	3	applied	\N	\N	\N	\N	112038	112038	279756
13732	15734	0	applied	\N	\N	\N	\N	112039	112039	279757
13732	15735	1	applied	\N	\N	\N	\N	112040	112040	279758
13732	15736	2	applied	\N	\N	\N	\N	112041	112041	279759
13732	15737	3	applied	\N	\N	\N	\N	112042	112042	279760
13735	15734	0	applied	\N	\N	\N	\N	112051	112051	279769
13735	15735	1	applied	\N	\N	\N	\N	112052	112052	279770
13735	15736	2	applied	\N	\N	\N	\N	112053	112053	279771
13736	15738	0	applied	\N	\N	\N	\N	112054	112054	279772
13736	15740	2	applied	\N	\N	\N	\N	112056	112056	279774
13737	15738	0	applied	\N	\N	\N	\N	112057	112057	279775
13737	15739	1	applied	\N	\N	\N	\N	112058	112058	279776
13737	15740	2	applied	\N	\N	\N	\N	112059	112059	279777
13740	15741	0	applied	\N	\N	\N	\N	112068	112068	279786
13740	15742	1	applied	\N	\N	\N	\N	112069	112069	279787
13740	15743	2	applied	\N	\N	\N	\N	112070	112070	279788
13740	15744	3	applied	\N	\N	\N	\N	112071	112071	279789
13744	15745	0	applied	\N	\N	\N	\N	112132	112132	279850
13744	15746	1	applied	\N	\N	\N	\N	112133	112133	279851
13744	15747	2	applied	\N	\N	\N	\N	112134	112134	279852
13744	15748	3	applied	\N	\N	\N	\N	112135	112135	279853
13744	15749	4	applied	\N	\N	\N	\N	112136	112136	279854
13744	15750	5	applied	\N	\N	\N	\N	112137	112137	279855
13744	15751	6	applied	\N	\N	\N	\N	112138	112138	279856
13744	15752	7	applied	\N	\N	\N	\N	112139	112139	279857
13744	15754	9	applied	\N	\N	\N	\N	112141	112141	279859
13744	15755	10	applied	\N	\N	\N	\N	112142	112142	279860
13744	15756	11	applied	\N	\N	\N	\N	112143	112143	279861
13744	15757	12	applied	\N	\N	\N	\N	112144	112144	279862
13744	15758	13	applied	\N	\N	\N	\N	112145	112145	279863
13744	15759	14	applied	\N	\N	\N	\N	112146	112146	279864
13744	15760	15	applied	\N	\N	\N	\N	112147	112147	279865
13744	15761	16	applied	\N	\N	\N	\N	112148	112148	279866
13744	15762	17	applied	\N	\N	\N	\N	112149	112149	279867
13744	15763	18	applied	\N	\N	\N	\N	112150	112150	279868
13744	15764	19	applied	\N	\N	\N	\N	112151	112151	279869
13745	15745	0	applied	\N	\N	\N	\N	112152	112152	279870
13745	15746	1	applied	\N	\N	\N	\N	112153	112153	279871
13745	15747	2	applied	\N	\N	\N	\N	112154	112154	279872
13745	15748	3	applied	\N	\N	\N	\N	112155	112155	279873
13749	15769	0	applied	\N	\N	\N	\N	112169	112169	279887
13749	15771	2	applied	\N	\N	\N	\N	112171	112171	279889
13749	15772	3	applied	\N	\N	\N	\N	112172	112172	279890
13749	15773	4	applied	\N	\N	\N	\N	112173	112173	279891
13749	15774	5	applied	\N	\N	\N	\N	112174	112174	279892
13749	15775	6	applied	\N	\N	\N	\N	112175	112175	279893
13750	15776	0	applied	\N	\N	\N	\N	112176	112176	279894
13750	15777	1	applied	\N	\N	\N	\N	112177	112177	279895
13750	15778	2	applied	\N	\N	\N	\N	112178	112178	279896
13750	15779	3	applied	\N	\N	\N	\N	112179	112179	279897
13750	15780	4	applied	\N	\N	\N	\N	112180	112180	279898
13750	15781	5	applied	\N	\N	\N	\N	112181	112181	279899
13750	15782	6	applied	\N	\N	\N	\N	112182	112182	279900
13757	15795	0	applied	\N	\N	\N	\N	112214	112214	279932
13757	15796	1	applied	\N	\N	\N	\N	112215	112215	279933
13694	15600	80	applied	\N	\N	\N	\N	111857	111857	279576
13694	15602	81	applied	\N	\N	\N	\N	111858	111858	279577
13722	15707	2	applied	\N	\N	\N	\N	111996	111996	279714
13722	15708	3	applied	\N	\N	\N	\N	111997	111997	279715
13725	15713	0	applied	\N	\N	\N	\N	112007	112007	279725
13725	15714	1	applied	\N	\N	\N	\N	112008	112008	279726
13725	15715	2	applied	\N	\N	\N	\N	112009	112009	279727
13725	15716	3	applied	\N	\N	\N	\N	112010	112010	279728
13725	15717	4	applied	\N	\N	\N	\N	112011	112011	279729
13727	15718	0	applied	\N	\N	\N	\N	112016	112016	279734
13733	15734	0	applied	\N	\N	\N	\N	112043	112043	279761
13733	15735	1	applied	\N	\N	\N	\N	112044	112044	279762
13733	15736	2	applied	\N	\N	\N	\N	112045	112045	279763
13733	15737	3	applied	\N	\N	\N	\N	112046	112046	279764
13738	15741	0	applied	\N	\N	\N	\N	112060	112060	279778
13738	15742	1	applied	\N	\N	\N	\N	112061	112061	279779
13738	15743	2	applied	\N	\N	\N	\N	112062	112062	279780
13738	15744	3	applied	\N	\N	\N	\N	112063	112063	279781
13742	15746	1	applied	\N	\N	\N	\N	112093	112093	279811
13742	15747	2	applied	\N	\N	\N	\N	112094	112094	279812
13742	15748	3	applied	\N	\N	\N	\N	112095	112095	279813
13742	15749	4	applied	\N	\N	\N	\N	112096	112096	279814
13742	15750	5	applied	\N	\N	\N	\N	112097	112097	279815
13742	15751	6	applied	\N	\N	\N	\N	112098	112098	279816
13742	15752	7	applied	\N	\N	\N	\N	112099	112099	279817
13742	15753	8	applied	\N	\N	\N	\N	112100	112100	279818
13742	15754	9	applied	\N	\N	\N	\N	112101	112101	279819
13742	15755	10	applied	\N	\N	\N	\N	112102	112102	279820
13742	15756	11	applied	\N	\N	\N	\N	112103	112103	279821
13742	15757	12	applied	\N	\N	\N	\N	112104	112104	279822
13742	15758	13	applied	\N	\N	\N	\N	112105	112105	279823
13742	15759	14	applied	\N	\N	\N	\N	112106	112106	279824
13742	15760	15	applied	\N	\N	\N	\N	112107	112107	279825
13742	15761	16	applied	\N	\N	\N	\N	112108	112108	279826
13742	15763	18	applied	\N	\N	\N	\N	112110	112110	279828
13742	15764	19	applied	\N	\N	\N	\N	112111	112111	279829
13743	15745	0	applied	\N	\N	\N	\N	112112	112112	279830
13743	15746	1	applied	\N	\N	\N	\N	112113	112113	279831
13743	15747	2	applied	\N	\N	\N	\N	112114	112114	279832
13743	15748	3	applied	\N	\N	\N	\N	112115	112115	279833
13743	15749	4	applied	\N	\N	\N	\N	112116	112116	279834
13743	15750	5	applied	\N	\N	\N	\N	112117	112117	279835
13743	15751	6	applied	\N	\N	\N	\N	112118	112118	279836
13743	15752	7	applied	\N	\N	\N	\N	112119	112119	279837
13743	15753	8	applied	\N	\N	\N	\N	112120	112120	279838
13743	15754	9	applied	\N	\N	\N	\N	112121	112121	279839
13743	15755	10	applied	\N	\N	\N	\N	112122	112122	279840
13743	15756	11	applied	\N	\N	\N	\N	112123	112123	279841
13743	15757	12	applied	\N	\N	\N	\N	112124	112124	279842
13743	15758	13	applied	\N	\N	\N	\N	112125	112125	279843
13743	15760	15	applied	\N	\N	\N	\N	112127	112127	279845
13743	15761	16	applied	\N	\N	\N	\N	112128	112128	279846
13743	15762	17	applied	\N	\N	\N	\N	112129	112129	279847
13743	15763	18	applied	\N	\N	\N	\N	112130	112130	279848
13743	15764	19	applied	\N	\N	\N	\N	112131	112131	279849
13746	15765	0	applied	\N	\N	\N	\N	112157	112157	279875
13746	15766	1	applied	\N	\N	\N	\N	112158	112158	279876
13746	15767	2	applied	\N	\N	\N	\N	112159	112159	279877
13746	15768	3	applied	\N	\N	\N	\N	112160	112160	279878
13753	15787	0	applied	\N	\N	\N	\N	112194	112194	279912
13753	15788	1	applied	\N	\N	\N	\N	112195	112195	279913
13753	15789	2	applied	\N	\N	\N	\N	112196	112196	279914
13753	15790	3	applied	\N	\N	\N	\N	112197	112197	279915
13757	15797	2	applied	\N	\N	\N	\N	112216	112216	279934
13757	15798	3	applied	\N	\N	\N	\N	112217	112217	279935
13757	15799	4	applied	\N	\N	\N	\N	112218	112218	279936
13757	15801	6	applied	\N	\N	\N	\N	112220	112220	279938
13757	15802	7	applied	\N	\N	\N	\N	112221	112221	279939
13759	15795	0	applied	\N	\N	\N	\N	112230	112230	279948
13759	15796	1	applied	\N	\N	\N	\N	112231	112231	279949
13759	15797	2	applied	\N	\N	\N	\N	112232	112232	279950
13759	15798	3	applied	\N	\N	\N	\N	112233	112233	279951
13759	15799	4	applied	\N	\N	\N	\N	112234	112234	279952
13759	15800	5	applied	\N	\N	\N	\N	112235	112235	279953
13759	15801	6	applied	\N	\N	\N	\N	112236	112236	279954
13759	15802	7	applied	\N	\N	\N	\N	112237	112237	279955
13761	15803	0	applied	\N	\N	\N	\N	112241	112241	279959
13766	15811	0	applied	\N	\N	\N	\N	112258	112258	279976
13766	15812	1	applied	\N	\N	\N	\N	112259	112259	279977
13766	15813	2	applied	\N	\N	\N	\N	112260	112260	279978
13766	15814	3	applied	\N	\N	\N	\N	112261	112261	279979
13767	15815	0	applied	\N	\N	\N	\N	112262	112262	279980
13767	15817	2	applied	\N	\N	\N	\N	112264	112264	279982
13767	15818	3	applied	\N	\N	\N	\N	112265	112265	279983
13769	15819	0	applied	\N	\N	\N	\N	112274	112274	279992
13769	15820	1	applied	\N	\N	\N	\N	112275	112275	279993
13769	15821	2	applied	\N	\N	\N	\N	112276	112276	279994
13769	15822	3	applied	\N	\N	\N	\N	112277	112277	279995
13769	15823	4	applied	\N	\N	\N	\N	112278	112278	279996
13769	15824	5	applied	\N	\N	\N	\N	112279	112279	279997
13769	15825	6	applied	\N	\N	\N	\N	112280	112280	279998
13769	15826	7	applied	\N	\N	\N	\N	112281	112281	279999
13771	15827	0	applied	\N	\N	\N	\N	112283	112283	280001
13771	15828	1	applied	\N	\N	\N	\N	112284	112284	280002
13771	15829	2	applied	\N	\N	\N	\N	112285	112285	280003
13771	15830	3	applied	\N	\N	\N	\N	112286	112286	280004
13772	15831	0	applied	\N	\N	\N	\N	112287	112287	280005
13772	15832	1	applied	\N	\N	\N	\N	112288	112288	280006
13772	15834	3	applied	\N	\N	\N	\N	112290	112290	280008
13776	15835	0	applied	\N	\N	\N	\N	112295	112295	280013
13776	15836	1	applied	\N	\N	\N	\N	112296	112296	280014
13776	15837	2	applied	\N	\N	\N	\N	112297	112297	280015
13776	15838	3	applied	\N	\N	\N	\N	112298	112298	280016
13776	15839	4	applied	\N	\N	\N	\N	112299	112299	280017
13776	15840	5	applied	\N	\N	\N	\N	112300	112300	280018
13776	15841	6	applied	\N	\N	\N	\N	112301	112301	280019
13776	15842	7	applied	\N	\N	\N	\N	112302	112302	280020
13776	15843	8	applied	\N	\N	\N	\N	112303	112303	280021
13776	15844	9	applied	\N	\N	\N	\N	112304	112304	280022
13776	15845	10	applied	\N	\N	\N	\N	112305	112305	280023
13776	15846	11	applied	\N	\N	\N	\N	112306	112306	280024
13776	15847	12	applied	\N	\N	\N	\N	112307	112307	280025
13719	15704	3	applied	\N	\N	\N	\N	111985	111985	279703
13722	15705	0	applied	\N	\N	\N	\N	111994	111994	279712
13751	15779	3	applied	\N	\N	\N	\N	112186	112186	279904
13751	15780	4	applied	\N	\N	\N	\N	112187	112187	279905
13751	15781	5	applied	\N	\N	\N	\N	112188	112188	279906
13751	15782	6	applied	\N	\N	\N	\N	112189	112189	279907
13752	15783	0	applied	\N	\N	\N	\N	112190	112190	279908
13752	15784	1	applied	\N	\N	\N	\N	112191	112191	279909
13752	15785	2	applied	\N	\N	\N	\N	112192	112192	279910
13752	15786	3	applied	\N	\N	\N	\N	112193	112193	279911
13756	15795	0	applied	\N	\N	\N	\N	112206	112206	279924
13756	15796	1	applied	\N	\N	\N	\N	112207	112207	279925
13756	15797	2	applied	\N	\N	\N	\N	112208	112208	279926
13756	15798	3	applied	\N	\N	\N	\N	112209	112209	279927
13756	15799	4	applied	\N	\N	\N	\N	112210	112210	279928
13756	15800	5	applied	\N	\N	\N	\N	112211	112211	279929
13756	15802	7	applied	\N	\N	\N	\N	112213	112213	279931
13758	15795	0	applied	\N	\N	\N	\N	112222	112222	279940
13758	15796	1	applied	\N	\N	\N	\N	112223	112223	279941
13758	15797	2	applied	\N	\N	\N	\N	112224	112224	279942
13758	15798	3	applied	\N	\N	\N	\N	112225	112225	279943
13758	15799	4	applied	\N	\N	\N	\N	112226	112226	279944
13758	15800	5	applied	\N	\N	\N	\N	112227	112227	279945
13758	15801	6	applied	\N	\N	\N	\N	112228	112228	279946
13758	15802	7	applied	\N	\N	\N	\N	112229	112229	279947
13762	15803	0	applied	\N	\N	\N	\N	112242	112242	279960
13762	15804	1	applied	\N	\N	\N	\N	112243	112243	279961
13762	15805	2	applied	\N	\N	\N	\N	112244	112244	279962
13762	15806	3	applied	\N	\N	\N	\N	112245	112245	279963
13764	15807	0	applied	\N	\N	\N	\N	112250	112250	279968
13764	15808	1	applied	\N	\N	\N	\N	112251	112251	279969
13764	15809	2	applied	\N	\N	\N	\N	112252	112252	279970
13778	15835	0	applied	\N	\N	\N	\N	112311	112311	280029
13778	15836	1	applied	\N	\N	\N	\N	112312	112312	280030
13778	15837	2	applied	\N	\N	\N	\N	112313	112313	280031
13778	15838	3	applied	\N	\N	\N	\N	112314	112314	280032
13778	15839	4	applied	\N	\N	\N	\N	112315	112315	280033
13778	15840	5	applied	\N	\N	\N	\N	112316	112316	280034
13778	15841	6	applied	\N	\N	\N	\N	112317	112317	280035
13778	15842	7	applied	\N	\N	\N	\N	112318	112318	280036
13778	15843	8	applied	\N	\N	\N	\N	112319	112319	280037
13778	15844	9	applied	\N	\N	\N	\N	112320	112320	280038
13778	15845	10	applied	\N	\N	\N	\N	112321	112321	280039
13778	15846	11	applied	\N	\N	\N	\N	112322	112322	280040
13778	15847	12	applied	\N	\N	\N	\N	112323	112323	280041
13778	15848	13	applied	\N	\N	\N	\N	112324	112324	280042
13778	15849	14	applied	\N	\N	\N	\N	112325	112325	280043
13778	15850	15	applied	\N	\N	\N	\N	112326	112326	280044
13781	15676	1	applied	\N	\N	\N	\N	112328	112328	280046
13781	15614	2	applied	\N	\N	\N	\N	112329	112329	280047
13781	15616	3	applied	\N	\N	\N	\N	112330	112330	280048
13781	15617	4	applied	\N	\N	\N	\N	112331	112331	280049
13781	15618	5	applied	\N	\N	\N	\N	112332	112332	280050
13781	15619	6	applied	\N	\N	\N	\N	112333	112333	280051
13781	15623	7	applied	\N	\N	\N	\N	112334	112334	280052
13781	15627	8	applied	\N	\N	\N	\N	112335	112335	280053
13781	15629	9	applied	\N	\N	\N	\N	112336	112336	280054
13781	15630	10	applied	\N	\N	\N	\N	112337	112337	280055
13781	15625	11	applied	\N	\N	\N	\N	112338	112338	280056
13781	15633	12	applied	\N	\N	\N	\N	112339	112339	280057
13781	15634	13	applied	\N	\N	\N	\N	112340	112340	280058
13781	15635	14	applied	\N	\N	\N	\N	112341	112341	280059
13781	15639	15	applied	\N	\N	\N	\N	112342	112342	280060
13781	15641	16	applied	\N	\N	\N	\N	112343	112343	280061
13781	15643	17	applied	\N	\N	\N	\N	112344	112344	280062
13781	15645	18	applied	\N	\N	\N	\N	112345	112345	280063
13781	15648	20	applied	\N	\N	\N	\N	112347	112347	280065
13781	15651	21	applied	\N	\N	\N	\N	112348	112348	280066
13781	15653	22	applied	\N	\N	\N	\N	112349	112349	280067
13781	15654	23	applied	\N	\N	\N	\N	112350	112350	280068
13781	15657	24	applied	\N	\N	\N	\N	112351	112351	280069
13781	15659	25	applied	\N	\N	\N	\N	112352	112352	280070
13781	15663	26	applied	\N	\N	\N	\N	112353	112353	280071
13781	15668	27	applied	\N	\N	\N	\N	112354	112354	280072
13781	15669	28	applied	\N	\N	\N	\N	112355	112355	280073
13781	15677	29	applied	\N	\N	\N	\N	112356	112356	280074
13781	15678	30	applied	\N	\N	\N	\N	112357	112357	280075
13781	15685	31	applied	\N	\N	\N	\N	112358	112358	280076
13781	15686	32	applied	\N	\N	\N	\N	112359	112359	280077
13781	15694	33	applied	\N	\N	\N	\N	112360	112360	280078
13781	15695	34	applied	\N	\N	\N	\N	112361	112361	280079
13781	15701	35	applied	\N	\N	\N	\N	112362	112362	280080
13781	15709	37	applied	\N	\N	\N	\N	112364	112364	280082
13781	15713	38	applied	\N	\N	\N	\N	112365	112365	280083
13781	15718	39	applied	\N	\N	\N	\N	112366	112366	280084
13781	15722	40	applied	\N	\N	\N	\N	112367	112367	280085
13781	15726	41	applied	\N	\N	\N	\N	112368	112368	280086
13781	15730	42	applied	\N	\N	\N	\N	112369	112369	280087
13781	15734	43	applied	\N	\N	\N	\N	112370	112370	280088
13781	15738	44	applied	\N	\N	\N	\N	112371	112371	280089
13781	15741	45	applied	\N	\N	\N	\N	112372	112372	280090
13781	15745	46	applied	\N	\N	\N	\N	112373	112373	280091
13781	15746	47	applied	\N	\N	\N	\N	112374	112374	280092
13782	15851	0	applied	\N	\N	\N	\N	112452	112452	280170
13782	15852	1	applied	\N	\N	\N	\N	112453	112453	280171
13782	15853	2	applied	\N	\N	\N	\N	112454	112454	280172
13782	15854	3	applied	\N	\N	\N	\N	112455	112455	280173
13788	15866	0	applied	\N	\N	\N	\N	112489	112489	280207
13788	15868	2	applied	\N	\N	\N	\N	112491	112491	280209
13788	15869	3	applied	\N	\N	\N	\N	112492	112492	280210
13788	15870	4	applied	\N	\N	\N	\N	112493	112493	280211
13788	15871	5	applied	\N	\N	\N	\N	112494	112494	280212
13788	15872	6	applied	\N	\N	\N	\N	112495	112495	280213
13788	15873	7	applied	\N	\N	\N	\N	112496	112496	280214
13789	15866	0	applied	\N	\N	\N	\N	112497	112497	280215
13789	15867	1	applied	\N	\N	\N	\N	112498	112498	280216
13789	15868	2	applied	\N	\N	\N	\N	112499	112499	280217
13789	15869	3	applied	\N	\N	\N	\N	112500	112500	280218
13789	15870	4	applied	\N	\N	\N	\N	112501	112501	280219
13789	15871	5	applied	\N	\N	\N	\N	112502	112502	280220
13789	15872	6	applied	\N	\N	\N	\N	112503	112503	280221
13789	15873	7	applied	\N	\N	\N	\N	112504	112504	280222
13751	15777	1	applied	\N	\N	\N	\N	112184	112184	279902
13751	15778	2	applied	\N	\N	\N	\N	112185	112185	279903
13754	15789	2	applied	\N	\N	\N	\N	112200	112200	279918
13754	15790	3	applied	\N	\N	\N	\N	112201	112201	279919
13755	15791	0	applied	\N	\N	\N	\N	112202	112202	279920
13755	15792	1	applied	\N	\N	\N	\N	112203	112203	279921
13755	15793	2	applied	\N	\N	\N	\N	112204	112204	279922
13755	15794	3	applied	\N	\N	\N	\N	112205	112205	279923
13760	15795	0	applied	\N	\N	\N	\N	112238	112238	279956
13760	15796	1	applied	\N	\N	\N	\N	112239	112239	279957
13760	15797	2	applied	\N	\N	\N	\N	112240	112240	279958
13763	15807	0	applied	\N	\N	\N	\N	112246	112246	279964
13763	15808	1	applied	\N	\N	\N	\N	112247	112247	279965
13763	15810	3	applied	\N	\N	\N	\N	112249	112249	279967
13765	15811	0	applied	\N	\N	\N	\N	112254	112254	279972
13765	15812	1	applied	\N	\N	\N	\N	112255	112255	279973
13765	15813	2	applied	\N	\N	\N	\N	112256	112256	279974
13765	15814	3	applied	\N	\N	\N	\N	112257	112257	279975
13768	15819	0	applied	\N	\N	\N	\N	112266	112266	279984
13768	15820	1	applied	\N	\N	\N	\N	112267	112267	279985
13768	15821	2	applied	\N	\N	\N	\N	112268	112268	279986
13768	15822	3	applied	\N	\N	\N	\N	112269	112269	279987
13768	15823	4	applied	\N	\N	\N	\N	112270	112270	279988
13768	15824	5	applied	\N	\N	\N	\N	112271	112271	279989
13768	15825	6	applied	\N	\N	\N	\N	112272	112272	279990
13768	15826	7	applied	\N	\N	\N	\N	112273	112273	279991
13770	15827	0	applied	\N	\N	\N	\N	112282	112282	280000
13773	15831	0	applied	\N	\N	\N	\N	112291	112291	280009
13773	15832	1	applied	\N	\N	\N	\N	112292	112292	280010
13773	15834	3	applied	\N	\N	\N	\N	112294	112294	280012
13781	15747	48	applied	\N	\N	\N	\N	112375	112375	280093
13781	15748	49	applied	\N	\N	\N	\N	112376	112376	280094
13781	15749	50	applied	\N	\N	\N	\N	112377	112377	280095
13781	15765	51	applied	\N	\N	\N	\N	112378	112378	280096
13781	15769	52	applied	\N	\N	\N	\N	112379	112379	280097
13781	15770	53	applied	\N	\N	\N	\N	112380	112380	280098
13781	15776	54	applied	\N	\N	\N	\N	112381	112381	280099
13781	15783	55	applied	\N	\N	\N	\N	112382	112382	280100
13781	15787	56	applied	\N	\N	\N	\N	112383	112383	280101
13781	15791	57	applied	\N	\N	\N	\N	112384	112384	280102
13781	15795	58	applied	\N	\N	\N	\N	112385	112385	280103
13781	15796	60	applied	\N	\N	\N	\N	112386	112386	280104
13781	15803	61	applied	\N	\N	\N	\N	112387	112387	280105
13781	15807	62	applied	\N	\N	\N	\N	112388	112388	280106
13781	15811	63	applied	\N	\N	\N	\N	112389	112389	280107
13781	15819	65	applied	\N	\N	\N	\N	112391	112391	280109
13781	15820	66	applied	\N	\N	\N	\N	112392	112392	280110
13781	15827	67	applied	\N	\N	\N	\N	112393	112393	280111
13781	15831	68	applied	\N	\N	\N	\N	112394	112394	280112
13781	15835	69	applied	\N	\N	\N	\N	112395	112395	280113
13781	15836	70	applied	\N	\N	\N	\N	112396	112396	280114
13781	15837	71	applied	\N	\N	\N	\N	112397	112397	280115
13781	15838	72	applied	\N	\N	\N	\N	112398	112398	280116
13781	15851	73	applied	\N	\N	\N	\N	112399	112399	280117
13781	15615	74	applied	\N	\N	\N	\N	112400	112400	280118
13781	15620	75	applied	\N	\N	\N	\N	112401	112401	280119
13781	15621	76	applied	\N	\N	\N	\N	112402	112402	280120
13781	15622	77	applied	\N	\N	\N	\N	112403	112403	280121
13781	15624	78	applied	\N	\N	\N	\N	112404	112404	280122
13781	15626	79	applied	\N	\N	\N	\N	112405	112405	280123
13781	15628	80	applied	\N	\N	\N	\N	112406	112406	280124
13781	15632	82	applied	\N	\N	\N	\N	112408	112408	280126
13781	15636	83	applied	\N	\N	\N	\N	112409	112409	280127
13781	15637	84	applied	\N	\N	\N	\N	112410	112410	280128
13785	15861	0	applied	\N	\N	\N	\N	112468	112468	280186
13785	15862	1	applied	\N	\N	1000000000	\N	112469	112469	280187
13785	15863	2	applied	\N	\N	\N	\N	112470	112470	280188
13785	15864	3	applied	\N	\N	\N	\N	112471	112471	280189
13785	15865	4	applied	\N	\N	\N	\N	112472	112472	280190
13794	15879	0	applied	\N	\N	\N	\N	112523	112523	280241
13796	15883	0	applied	\N	\N	\N	\N	112528	112528	280246
13796	15884	1	applied	\N	\N	\N	\N	112529	112529	280247
13796	15885	2	applied	\N	\N	\N	\N	112530	112530	280248
13796	15886	3	applied	\N	\N	\N	\N	112531	112531	280249
13796	15887	4	applied	\N	\N	\N	\N	112532	112532	280250
13801	15892	0	applied	\N	\N	\N	\N	112550	112550	280268
13801	15893	1	applied	\N	\N	\N	\N	112551	112551	280269
13801	15895	3	applied	\N	\N	\N	\N	112553	112553	280271
13801	15896	4	applied	\N	\N	\N	\N	112554	112554	280272
13801	15897	5	applied	\N	\N	1000000000	\N	112555	112555	280273
13801	15898	6	applied	\N	\N	1000000000	\N	112556	112556	280274
13801	15899	7	applied	\N	\N	\N	\N	112557	112557	280275
13801	15900	8	applied	\N	\N	\N	\N	112558	112558	280276
13801	15901	9	applied	\N	\N	\N	\N	112559	112559	280277
13803	15902	0	applied	\N	\N	\N	\N	112564	112564	280282
13803	15903	1	applied	\N	\N	\N	\N	112565	112565	280283
13803	15904	2	applied	\N	\N	\N	\N	112566	112566	280284
13803	15905	3	applied	\N	\N	\N	\N	112567	112567	280285
13806	15912	0	applied	\N	\N	\N	\N	112579	112579	280297
13810	15918	0	applied	\N	\N	\N	\N	112595	112595	280313
13810	15919	1	applied	\N	\N	\N	\N	112596	112596	280314
13810	15920	2	applied	\N	\N	\N	\N	112597	112597	280315
13810	15921	3	applied	\N	\N	\N	\N	112598	112598	280316
13813	15923	0	applied	\N	\N	\N	\N	112613	112613	280331
13813	15924	1	applied	\N	\N	\N	\N	112614	112614	280332
13813	15925	2	applied	\N	\N	\N	\N	112615	112615	280333
13813	15926	3	applied	\N	\N	\N	\N	112616	112616	280334
13813	15927	4	applied	\N	\N	\N	\N	112617	112617	280335
13813	15928	5	applied	\N	\N	\N	\N	112618	112618	280336
13813	15929	6	applied	\N	\N	\N	\N	112619	112619	280337
13813	15930	7	applied	\N	\N	\N	\N	112620	112620	280338
13815	15931	0	applied	\N	\N	\N	\N	112623	112623	280341
13815	15932	2	applied	\N	\N	\N	\N	112624	112624	280342
13815	15933	3	applied	\N	\N	\N	\N	112625	112625	280343
13815	15934	4	applied	\N	\N	\N	\N	112626	112626	280344
13821	15952	0	applied	\N	\N	\N	\N	112671	112671	280389
13821	15953	1	applied	\N	\N	\N	\N	112672	112672	280390
13821	15954	2	applied	\N	\N	\N	\N	112673	112673	280391
13821	15955	3	applied	\N	\N	\N	\N	112674	112674	280392
13821	15957	5	applied	\N	\N	\N	\N	112676	112676	280394
13821	15958	6	applied	\N	\N	\N	\N	112677	112677	280395
13754	15787	0	applied	\N	\N	\N	\N	112198	112198	279916
13754	15788	1	applied	\N	\N	\N	\N	112199	112199	279917
13783	15856	1	applied	\N	\N	\N	\N	112457	112457	280175
13783	15857	2	applied	\N	\N	\N	\N	112458	112458	280176
13783	15858	3	applied	\N	\N	\N	\N	112459	112459	280177
13783	15859	4	applied	\N	\N	\N	\N	112460	112460	280178
13783	15860	5	applied	\N	\N	\N	\N	112461	112461	280179
13786	15866	0	applied	\N	\N	\N	\N	112473	112473	280191
13786	15867	1	applied	\N	\N	\N	\N	112474	112474	280192
13786	15868	2	applied	\N	\N	\N	\N	112475	112475	280193
13786	15869	3	applied	\N	\N	\N	\N	112476	112476	280194
13786	15870	4	applied	\N	\N	\N	\N	112477	112477	280195
13786	15871	5	applied	\N	\N	\N	\N	112478	112478	280196
13786	15872	6	applied	\N	\N	\N	\N	112479	112479	280197
13786	15873	7	applied	\N	\N	\N	\N	112480	112480	280198
13790	15874	0	applied	\N	\N	\N	\N	112505	112505	280223
13790	15875	1	applied	\N	\N	\N	\N	112506	112506	280224
13790	15876	2	applied	\N	\N	\N	\N	112507	112507	280225
13790	15878	4	applied	\N	\N	\N	\N	112509	112509	280227
13795	15879	0	applied	\N	\N	\N	\N	112524	112524	280242
13795	15880	1	applied	\N	\N	\N	\N	112525	112525	280243
13795	15881	2	applied	\N	\N	\N	\N	112526	112526	280244
13795	15882	3	applied	\N	\N	\N	\N	112527	112527	280245
13797	15883	0	applied	\N	\N	\N	\N	112533	112533	280251
13797	15884	1	applied	\N	\N	\N	\N	112534	112534	280252
13797	15886	2	applied	\N	\N	\N	\N	112535	112535	280253
13797	15887	3	applied	\N	\N	\N	\N	112536	112536	280254
13799	15888	0	applied	\N	\N	\N	\N	112541	112541	280259
13799	15889	1	applied	\N	\N	\N	\N	112542	112542	280260
13799	15890	2	applied	\N	\N	\N	\N	112543	112543	280261
13799	15891	3	applied	\N	\N	\N	\N	112544	112544	280262
13804	15906	0	applied	\N	\N	\N	\N	112568	112568	280286
13804	15907	1	applied	\N	\N	\N	\N	112569	112569	280287
13804	15908	2	applied	\N	\N	\N	\N	112570	112570	280288
13804	15910	4	applied	\N	\N	\N	\N	112572	112572	280290
13807	15912	0	applied	\N	\N	\N	\N	112580	112580	280298
13807	15911	1	applied	\N	\N	\N	\N	112581	112581	280299
13807	15913	2	applied	\N	\N	\N	\N	112582	112582	280300
13807	15914	3	applied	\N	\N	\N	\N	112583	112583	280301
13807	15915	4	applied	\N	\N	\N	\N	112584	112584	280302
13807	15916	5	applied	\N	\N	\N	\N	112585	112585	280303
13807	15917	6	applied	\N	\N	\N	\N	112586	112586	280304
13811	15918	0	applied	\N	\N	\N	\N	112600	112600	280318
13811	15919	1	applied	\N	\N	\N	\N	112601	112601	280319
13811	15920	2	applied	\N	\N	\N	\N	112602	112602	280320
13811	15921	3	applied	\N	\N	\N	\N	112603	112603	280321
13811	15922	4	applied	\N	\N	\N	\N	112604	112604	280322
13816	15931	0	applied	\N	\N	\N	\N	112627	112627	280345
13816	15935	2	applied	\N	\N	\N	\N	112628	112628	280346
13816	15936	3	applied	\N	\N	\N	\N	112629	112629	280347
13823	15959	0	applied	\N	\N	\N	\N	112685	112685	280403
13823	15960	1	applied	\N	\N	\N	\N	112686	112686	280404
13823	15961	2	applied	\N	\N	\N	\N	112687	112687	280405
13823	15962	3	applied	\N	\N	\N	\N	112688	112688	280406
13823	15963	4	applied	\N	\N	\N	\N	112689	112689	280407
13823	15964	5	applied	\N	\N	\N	\N	112690	112690	280408
13823	15965	6	applied	\N	\N	\N	\N	112691	112691	280409
13824	15966	0	applied	\N	\N	\N	\N	112692	112692	280410
13824	15967	1	applied	\N	\N	\N	\N	112693	112693	280411
13824	15968	2	applied	\N	\N	\N	\N	112694	112694	280412
13826	15966	0	applied	\N	\N	\N	\N	112695	112695	280413
13826	15967	1	applied	\N	\N	\N	\N	112696	112696	280414
13826	15968	2	applied	\N	\N	\N	\N	112697	112697	280415
13826	15969	3	applied	\N	\N	\N	\N	112698	112698	280416
13826	15970	4	applied	\N	\N	\N	\N	112699	112699	280417
13826	15971	5	applied	\N	\N	\N	\N	112700	112700	280418
13826	15973	7	applied	\N	\N	\N	\N	112702	112702	280420
13826	15974	8	applied	\N	\N	\N	\N	112703	112703	280421
13826	15975	9	applied	\N	\N	\N	\N	112704	112704	280422
13826	15976	10	applied	\N	\N	\N	\N	112705	112705	280423
13826	15977	11	applied	\N	\N	\N	\N	112706	112706	280424
13827	15978	0	applied	\N	\N	\N	\N	112707	112707	280425
13827	15979	1	applied	\N	\N	\N	\N	112708	112708	280426
13827	15980	2	applied	\N	\N	\N	\N	112709	112709	280427
13827	15981	3	applied	\N	\N	\N	\N	112710	112710	280428
13827	15982	4	applied	\N	\N	\N	\N	112711	112711	280429
13827	15983	5	applied	\N	\N	\N	\N	112712	112712	280430
13827	15984	6	applied	\N	\N	\N	\N	112713	112713	280431
13827	15985	7	applied	\N	\N	\N	\N	112714	112714	280432
13827	15986	8	applied	\N	\N	\N	\N	112715	112715	280433
13827	15987	9	applied	\N	\N	\N	\N	112716	112716	280434
13827	15988	10	applied	\N	\N	\N	\N	112717	112717	280435
13827	15990	12	applied	\N	\N	\N	\N	112719	112719	280437
13827	15991	13	applied	\N	\N	\N	\N	112720	112720	280438
13834	16022	0	applied	\N	\N	\N	\N	112775	112775	280493
13834	16023	1	applied	\N	\N	\N	\N	112776	112776	280494
13834	16024	2	applied	\N	\N	\N	\N	112777	112777	280495
13841	16033	0	applied	\N	\N	\N	\N	112946	112946	280664
13841	16034	1	applied	\N	\N	\N	\N	112947	112947	280665
13841	16035	3	applied	\N	\N	\N	\N	112948	112948	280666
13841	16036	4	applied	\N	\N	\N	\N	112949	112949	280667
13841	16037	5	applied	\N	\N	\N	\N	112950	112950	280668
13841	16038	6	applied	\N	\N	\N	\N	112951	112951	280669
13841	16039	7	applied	\N	\N	\N	\N	112952	112952	280670
13841	16040	8	applied	\N	\N	\N	\N	112953	112953	280671
13845	16041	0	applied	\N	\N	\N	\N	112982	112982	280700
13845	16042	1	applied	\N	\N	\N	\N	112983	112983	280701
13845	16043	2	applied	\N	\N	\N	\N	112984	112984	280702
13845	16045	4	applied	\N	\N	\N	\N	112986	112986	280704
13850	16061	0	applied	\N	\N	\N	\N	113033	113033	280751
13857	16077	0	applied	\N	\N	\N	\N	113077	113077	280795
13857	16078	1	applied	\N	\N	\N	\N	113078	113078	280796
13857	16079	2	applied	\N	\N	\N	\N	113079	113079	280797
13857	16080	3	applied	\N	\N	\N	\N	113080	113080	280798
13860	16085	0	applied	\N	\N	\N	\N	113089	113089	280807
13860	16086	1	applied	\N	\N	\N	\N	113090	113090	280808
13860	16087	2	applied	\N	\N	\N	\N	113091	113091	280809
13860	16088	3	applied	\N	\N	\N	\N	113092	113092	280810
13862	16089	0	applied	\N	\N	\N	\N	113094	113094	280812
13862	16086	1	applied	\N	\N	\N	\N	113095	113095	280813
13862	16087	2	applied	\N	\N	\N	\N	113096	113096	280814
13862	16088	3	applied	\N	\N	\N	\N	113097	113097	280815
13776	15849	14	applied	\N	\N	\N	\N	112309	112309	280027
13776	15850	15	applied	\N	\N	\N	\N	112310	112310	280028
13781	15646	89	applied	\N	\N	\N	\N	112415	112415	280133
13781	15649	90	applied	\N	\N	\N	\N	112416	112416	280134
13781	15650	91	applied	\N	\N	\N	\N	112417	112417	280135
13781	15652	92	applied	\N	\N	\N	\N	112418	112418	280136
13781	15655	93	applied	\N	\N	\N	\N	112419	112419	280137
13781	15656	94	applied	\N	\N	\N	\N	112420	112420	280138
13781	15658	95	applied	\N	\N	\N	\N	112421	112421	280139
13781	15660	96	applied	\N	\N	\N	\N	112422	112422	280140
13781	15661	97	applied	\N	\N	\N	\N	112423	112423	280141
13781	15662	98	applied	\N	\N	\N	\N	112424	112424	280142
13781	15664	99	applied	\N	\N	\N	\N	112425	112425	280143
13781	15665	100	applied	\N	\N	\N	\N	112426	112426	280144
13781	15666	101	applied	\N	\N	\N	\N	112427	112427	280145
13781	15670	102	applied	\N	\N	\N	\N	112428	112428	280146
13781	15671	103	applied	\N	\N	\N	\N	112429	112429	280147
13781	15672	104	applied	\N	\N	\N	\N	112430	112430	280148
13781	15674	106	applied	\N	\N	\N	\N	112432	112432	280150
13781	15675	107	applied	\N	\N	\N	\N	112433	112433	280151
13781	15679	108	applied	\N	\N	\N	\N	112434	112434	280152
13781	15680	109	applied	\N	\N	\N	\N	112435	112435	280153
13781	15681	110	applied	\N	\N	\N	\N	112436	112436	280154
13781	15682	111	applied	\N	\N	\N	\N	112437	112437	280155
13781	15683	112	applied	\N	\N	\N	\N	112438	112438	280156
13781	15684	113	applied	\N	\N	\N	\N	112439	112439	280157
13781	15687	114	applied	\N	\N	\N	\N	112440	112440	280158
13781	15688	115	applied	\N	\N	\N	\N	112441	112441	280159
13781	15689	116	applied	\N	\N	\N	\N	112442	112442	280160
13781	15690	117	applied	\N	\N	\N	\N	112443	112443	280161
13781	15691	118	applied	\N	\N	\N	\N	112444	112444	280162
13781	15692	119	applied	\N	\N	\N	\N	112445	112445	280163
13781	15696	120	applied	\N	\N	\N	\N	112446	112446	280164
13781	15697	121	applied	\N	\N	\N	\N	112447	112447	280165
13781	15699	123	applied	\N	\N	\N	\N	112449	112449	280167
13781	15700	124	applied	\N	\N	\N	\N	112450	112450	280168
13781	15702	125	applied	\N	\N	\N	\N	112451	112451	280169
13784	15855	0	applied	\N	\N	\N	\N	112462	112462	280180
13784	15856	1	applied	\N	\N	\N	\N	112463	112463	280181
13784	15857	2	applied	\N	\N	\N	\N	112464	112464	280182
13784	15858	3	applied	\N	\N	\N	\N	112465	112465	280183
13784	15859	4	applied	\N	\N	\N	\N	112466	112466	280184
13784	15860	5	applied	\N	\N	\N	\N	112467	112467	280185
13787	15866	0	applied	\N	\N	\N	\N	112481	112481	280199
13787	15867	1	applied	\N	\N	\N	\N	112482	112482	280200
13787	15868	2	applied	\N	\N	\N	\N	112483	112483	280201
13787	15869	3	applied	\N	\N	\N	\N	112484	112484	280202
13787	15870	4	applied	\N	\N	\N	\N	112485	112485	280203
13787	15871	5	applied	\N	\N	\N	\N	112486	112486	280204
13787	15872	6	applied	\N	\N	\N	\N	112487	112487	280205
13791	15874	0	applied	\N	\N	\N	\N	112510	112510	280228
13791	15876	1	applied	\N	\N	\N	\N	112511	112511	280229
13791	15877	2	applied	\N	\N	\N	\N	112512	112512	280230
13791	15878	3	applied	\N	\N	\N	\N	112513	112513	280231
13793	15879	0	applied	\N	\N	\N	\N	112519	112519	280237
13793	15880	1	applied	\N	\N	\N	\N	112520	112520	280238
13793	15881	2	applied	\N	\N	\N	\N	112521	112521	280239
13793	15882	3	applied	\N	\N	\N	\N	112522	112522	280240
13798	15883	0	applied	\N	\N	\N	\N	112537	112537	280255
13798	15884	1	applied	\N	\N	\N	\N	112538	112538	280256
13798	15886	2	applied	\N	\N	\N	\N	112539	112539	280257
13798	15887	3	applied	\N	\N	\N	\N	112540	112540	280258
13802	15902	0	applied	\N	\N	\N	\N	112560	112560	280278
13802	15903	1	applied	\N	\N	\N	\N	112561	112561	280279
13802	15904	2	applied	\N	\N	\N	\N	112562	112562	280280
13802	15905	3	applied	\N	\N	\N	\N	112563	112563	280281
13805	15907	1	applied	\N	\N	\N	\N	112574	112574	280292
13805	15908	2	applied	\N	\N	\N	\N	112575	112575	280293
13805	15909	3	applied	\N	\N	\N	\N	112576	112576	280294
13805	15910	4	applied	\N	\N	\N	\N	112577	112577	280295
13805	15911	5	applied	\N	\N	\N	\N	112578	112578	280296
13808	15912	0	applied	\N	\N	\N	\N	112587	112587	280305
13808	15911	1	applied	\N	\N	\N	\N	112588	112588	280306
13808	15913	2	applied	\N	\N	\N	\N	112589	112589	280307
13808	15914	3	applied	\N	\N	\N	\N	112590	112590	280308
13808	15915	4	applied	\N	\N	\N	\N	112591	112591	280309
13808	15916	5	applied	\N	\N	\N	\N	112592	112592	280310
13808	15917	6	applied	\N	\N	\N	\N	112593	112593	280311
13827	15992	14	applied	\N	\N	\N	\N	112721	112721	280439
13827	15993	15	applied	\N	\N	\N	\N	112722	112722	280440
13832	16018	0	applied	\N	\N	\N	\N	112753	112753	280471
13832	16001	1	applied	\N	\N	\N	\N	112754	112754	280472
13832	16003	3	applied	\N	\N	\N	\N	112756	112756	280474
13832	16004	4	applied	\N	\N	\N	\N	112757	112757	280475
13832	16005	5	applied	\N	\N	\N	\N	112758	112758	280476
13832	16006	6	applied	\N	\N	\N	\N	112759	112759	280477
13832	16007	7	applied	\N	\N	\N	\N	112760	112760	280478
13832	16008	8	applied	\N	\N	\N	\N	112761	112761	280479
13832	16009	9	applied	\N	\N	\N	\N	112762	112762	280480
13832	16010	10	applied	\N	\N	\N	\N	112763	112763	280481
13832	16011	11	applied	\N	\N	\N	\N	112764	112764	280482
13832	16012	12	applied	\N	\N	\N	\N	112765	112765	280483
13832	16013	13	applied	\N	\N	\N	\N	112766	112766	280484
13832	16014	14	applied	\N	\N	\N	\N	112767	112767	280485
13832	16015	15	applied	\N	\N	\N	\N	112768	112768	280486
13832	16016	16	applied	\N	\N	\N	\N	112769	112769	280487
13832	16017	17	applied	\N	\N	\N	\N	112770	112770	280488
13832	16019	18	applied	\N	\N	\N	\N	112771	112771	280489
13832	16021	20	applied	\N	\N	\N	\N	112773	112773	280491
13836	16022	0	applied	\N	\N	\N	\N	112781	112781	280499
13836	16023	1	applied	\N	\N	\N	\N	112782	112782	280500
13836	16024	2	applied	\N	\N	\N	\N	112783	112783	280501
13846	16041	0	applied	\N	\N	\N	\N	112987	112987	280705
13846	16042	1	applied	\N	\N	\N	\N	112988	112988	280706
13846	16043	2	applied	\N	\N	\N	\N	112989	112989	280707
13846	16044	3	applied	\N	\N	\N	\N	112990	112990	280708
13846	16045	4	applied	\N	\N	\N	\N	112991	112991	280709
13846	16046	5	applied	\N	\N	\N	\N	112992	112992	280710
13846	16047	6	applied	\N	\N	\N	\N	112993	112993	280711
13846	16048	7	applied	\N	\N	\N	\N	112994	112994	280712
13846	16049	8	applied	\N	\N	\N	\N	112995	112995	280713
13846	16050	9	applied	\N	\N	\N	\N	112996	112996	280714
13781	15640	86	applied	\N	\N	\N	\N	112412	112412	280130
13781	15642	87	applied	\N	\N	\N	\N	112413	112413	280131
13792	15878	4	applied	\N	\N	\N	\N	112518	112518	280236
13800	15874	0	applied	\N	\N	\N	\N	112545	112545	280263
13800	15879	1	applied	\N	\N	\N	\N	112546	112546	280264
13800	15883	2	applied	\N	\N	\N	\N	112547	112547	280265
13800	15888	3	applied	\N	\N	\N	\N	112548	112548	280266
13800	15885	4	applied	\N	\N	\N	\N	112549	112549	280267
13809	15912	0	applied	\N	\N	\N	\N	112594	112594	280312
13812	15923	0	applied	\N	\N	\N	\N	112605	112605	280323
13812	15924	1	applied	\N	\N	\N	\N	112606	112606	280324
13812	15925	2	applied	\N	\N	\N	\N	112607	112607	280325
13812	15926	3	applied	\N	\N	\N	\N	112608	112608	280326
13812	15927	4	applied	\N	\N	\N	\N	112609	112609	280327
13812	15928	5	applied	\N	\N	\N	\N	112610	112610	280328
13812	15929	6	applied	\N	\N	\N	\N	112611	112611	280329
13812	15930	7	applied	\N	\N	\N	\N	112612	112612	280330
13814	15923	0	applied	\N	\N	\N	\N	112621	112621	280339
13817	15935	0	applied	\N	\N	\N	\N	112631	112631	280349
13817	15936	1	applied	\N	\N	\N	\N	112632	112632	280350
13817	15937	2	applied	\N	\N	\N	\N	112633	112633	280351
13817	15938	3	applied	\N	\N	\N	\N	112634	112634	280352
13817	15939	4	applied	\N	\N	\N	\N	112635	112635	280353
13817	15940	5	applied	\N	\N	\N	\N	112636	112636	280354
13817	15941	6	applied	\N	\N	\N	\N	112637	112637	280355
13817	15942	7	applied	\N	\N	\N	\N	112638	112638	280356
13817	15943	8	applied	\N	\N	\N	\N	112639	112639	280357
13817	15944	9	applied	\N	\N	\N	\N	112640	112640	280358
13817	15945	10	applied	\N	\N	\N	\N	112641	112641	280359
13817	15946	11	applied	\N	\N	\N	\N	112642	112642	280360
13817	15947	12	applied	\N	\N	\N	\N	112643	112643	280361
13817	15948	13	applied	\N	\N	\N	\N	112644	112644	280362
13817	15949	14	applied	\N	\N	\N	\N	112645	112645	280363
13817	15950	15	applied	\N	\N	\N	\N	112646	112646	280364
13818	15936	1	applied	\N	\N	\N	\N	112648	112648	280366
13818	15937	2	applied	\N	\N	\N	\N	112649	112649	280367
13818	15938	3	applied	\N	\N	\N	\N	112650	112650	280368
13818	15939	4	applied	\N	\N	\N	\N	112651	112651	280369
13818	15940	5	applied	\N	\N	\N	\N	112652	112652	280370
13818	15941	6	applied	\N	\N	\N	\N	112653	112653	280371
13818	15942	7	applied	\N	\N	\N	\N	112654	112654	280372
13818	15943	8	applied	\N	\N	\N	\N	112655	112655	280373
13818	15944	9	applied	\N	\N	\N	\N	112656	112656	280374
13818	15945	10	applied	\N	\N	\N	\N	112657	112657	280375
13818	15946	11	applied	\N	\N	\N	\N	112658	112658	280376
13818	15947	12	applied	\N	\N	\N	\N	112659	112659	280377
13818	15948	13	applied	\N	\N	\N	\N	112660	112660	280378
13818	15949	14	applied	\N	\N	\N	\N	112661	112661	280379
13818	15950	15	applied	\N	\N	\N	\N	112662	112662	280380
13819	15951	0	applied	\N	\N	\N	\N	112663	112663	280381
13820	15953	1	applied	\N	\N	\N	\N	112665	112665	280383
13820	15954	2	applied	\N	\N	\N	\N	112666	112666	280384
13820	15955	3	applied	\N	\N	\N	\N	112667	112667	280385
13820	15956	4	applied	\N	\N	\N	\N	112668	112668	280386
13820	15957	5	applied	\N	\N	\N	\N	112669	112669	280387
13820	15958	6	applied	\N	\N	\N	\N	112670	112670	280388
13822	15952	0	applied	\N	\N	\N	\N	112678	112678	280396
13822	15953	1	applied	\N	\N	\N	\N	112679	112679	280397
13822	15954	2	applied	\N	\N	\N	\N	112680	112680	280398
13822	15955	3	applied	\N	\N	\N	\N	112681	112681	280399
13822	15956	4	applied	\N	\N	\N	\N	112682	112682	280400
13822	15957	5	applied	\N	\N	\N	\N	112683	112683	280401
13822	15958	6	applied	\N	\N	\N	\N	112684	112684	280402
13828	15994	0	applied	\N	\N	\N	\N	112723	112723	280441
13830	15995	0	applied	\N	\N	\N	\N	112724	112724	280442
13830	15996	1	applied	\N	\N	\N	\N	112725	112725	280443
13830	15998	3	applied	\N	\N	\N	\N	112727	112727	280445
13830	15999	4	applied	\N	\N	\N	\N	112728	112728	280446
13830	16000	5	applied	\N	\N	\N	\N	112729	112729	280447
13830	16001	6	applied	\N	\N	\N	\N	112730	112730	280448
13830	16002	7	applied	\N	\N	\N	\N	112731	112731	280449
13830	16003	8	applied	\N	\N	\N	\N	112732	112732	280450
13830	16004	9	applied	\N	\N	\N	\N	112733	112733	280451
13830	16005	10	applied	\N	\N	\N	\N	112734	112734	280452
13830	16006	11	applied	\N	\N	\N	\N	112735	112735	280453
13830	16007	12	applied	\N	\N	\N	\N	112736	112736	280454
13830	16008	13	applied	\N	\N	\N	\N	112737	112737	280455
13830	16009	14	applied	\N	\N	\N	\N	112738	112738	280456
13830	16010	15	applied	\N	\N	\N	\N	112739	112739	280457
13830	16011	16	applied	\N	\N	\N	\N	112740	112740	280458
13831	15995	0	applied	\N	\N	\N	\N	112747	112747	280465
13831	15996	1	applied	\N	\N	\N	\N	112748	112748	280466
13831	15998	3	applied	\N	\N	\N	\N	112750	112750	280468
13831	15999	4	applied	\N	\N	\N	\N	112751	112751	280469
13831	16000	5	applied	\N	\N	\N	\N	112752	112752	280470
13833	16022	0	applied	\N	\N	\N	\N	112774	112774	280492
13835	16022	0	applied	\N	\N	\N	\N	112778	112778	280496
13835	16023	1	applied	\N	\N	\N	\N	112779	112779	280497
13835	16024	2	applied	\N	\N	\N	\N	112780	112780	280498
13838	16018	0	applied	\N	\N	\N	\N	112910	112910	280628
13838	16022	1	applied	\N	\N	\N	\N	112911	112911	280629
13838	16001	2	applied	\N	\N	\N	\N	112912	112912	280630
13838	16002	3	applied	\N	\N	\N	\N	112913	112913	280631
13838	16003	4	applied	\N	\N	\N	\N	112914	112914	280632
13838	16004	5	applied	\N	\N	\N	\N	112915	112915	280633
13838	16005	6	applied	\N	\N	\N	\N	112916	112916	280634
13838	16006	7	applied	\N	\N	\N	\N	112917	112917	280635
13838	16007	8	applied	\N	\N	\N	\N	112918	112918	280636
13838	16009	10	applied	\N	\N	\N	\N	112920	112920	280638
13838	16010	11	applied	\N	\N	\N	\N	112921	112921	280639
13838	16011	12	applied	\N	\N	\N	\N	112922	112922	280640
13838	16012	13	applied	\N	\N	\N	\N	112923	112923	280641
13838	16013	14	applied	\N	\N	\N	\N	112924	112924	280642
13838	16014	15	applied	\N	\N	\N	\N	112925	112925	280643
13838	16015	16	applied	\N	\N	\N	\N	112926	112926	280644
13838	16016	17	applied	\N	\N	\N	\N	112927	112927	280645
13838	16017	18	applied	\N	\N	\N	\N	112928	112928	280646
13838	16019	19	applied	\N	\N	\N	\N	112929	112929	280647
13840	16033	0	applied	\N	\N	\N	\N	112938	112938	280656
13840	16034	1	applied	\N	\N	\N	\N	112939	112939	280657
13840	16035	3	applied	\N	\N	\N	\N	112940	112940	280658
13840	16036	4	applied	\N	\N	\N	\N	112941	112941	280659
13792	15875	1	applied	\N	\N	\N	\N	112515	112515	280233
13792	15876	2	applied	\N	\N	\N	\N	112516	112516	280234
13830	16016	21	applied	\N	\N	\N	\N	112745	112745	280463
13830	16017	22	applied	\N	\N	\N	\N	112746	112746	280464
13837	15835	0	applied	\N	\N	\N	\N	112784	112784	280502
13837	15836	1	applied	\N	\N	\N	\N	112785	112785	280503
13837	15837	2	applied	\N	\N	\N	\N	112786	112786	280504
13837	15838	3	applied	\N	\N	\N	\N	112787	112787	280505
13837	15851	4	applied	\N	\N	\N	\N	112788	112788	280506
13837	15855	5	applied	\N	\N	\N	\N	112789	112789	280507
13837	15856	6	applied	\N	\N	\N	\N	112790	112790	280508
13837	15861	7	applied	\N	\N	\N	\N	112791	112791	280509
13837	15866	8	applied	\N	\N	\N	\N	112792	112792	280510
13837	15867	9	applied	\N	\N	\N	\N	112793	112793	280511
13837	15874	10	applied	\N	\N	\N	\N	112794	112794	280512
13837	15879	11	applied	\N	\N	\N	\N	112795	112795	280513
13837	15888	13	applied	\N	\N	\N	\N	112797	112797	280515
13837	15892	14	applied	\N	\N	\N	\N	112798	112798	280516
13837	15893	15	applied	\N	\N	\N	\N	112799	112799	280517
13837	15902	16	applied	\N	\N	\N	\N	112800	112800	280518
13837	15906	17	applied	\N	\N	\N	\N	112801	112801	280519
13837	15907	18	applied	\N	\N	\N	\N	112802	112802	280520
13837	15912	19	applied	\N	\N	\N	\N	112803	112803	280521
13837	15918	20	applied	\N	\N	\N	\N	112804	112804	280522
13837	15923	21	applied	\N	\N	\N	\N	112805	112805	280523
13837	15924	22	applied	\N	\N	\N	\N	112806	112806	280524
13837	15931	23	applied	\N	\N	\N	\N	112807	112807	280525
13837	15935	24	applied	\N	\N	\N	\N	112808	112808	280526
13837	15936	25	applied	\N	\N	\N	\N	112809	112809	280527
13837	15937	26	applied	\N	\N	\N	\N	112810	112810	280528
13837	15938	27	applied	\N	\N	\N	\N	112811	112811	280529
13837	15951	28	applied	\N	\N	\N	\N	112812	112812	280530
13837	15959	30	applied	\N	\N	\N	\N	112814	112814	280532
13837	15960	31	applied	\N	\N	\N	\N	112815	112815	280533
13837	15966	32	applied	\N	\N	\N	\N	112816	112816	280534
13837	15967	33	applied	\N	\N	\N	\N	112817	112817	280535
13837	15968	34	applied	\N	\N	\N	\N	112818	112818	280536
13837	15978	35	applied	\N	\N	\N	\N	112819	112819	280537
13837	15979	36	applied	\N	\N	\N	\N	112820	112820	280538
13837	15980	37	applied	\N	\N	\N	\N	112821	112821	280539
13837	15981	38	applied	\N	\N	\N	\N	112822	112822	280540
13837	15994	39	applied	\N	\N	\N	\N	112823	112823	280541
13837	15995	40	applied	\N	\N	\N	\N	112824	112824	280542
13837	15996	41	applied	\N	\N	\N	\N	112825	112825	280543
13837	15997	42	applied	\N	\N	\N	\N	112826	112826	280544
13837	15998	43	applied	\N	\N	\N	\N	112827	112827	280545
13837	15999	44	applied	\N	\N	\N	\N	112828	112828	280546
13837	16018	45	applied	\N	\N	\N	\N	112829	112829	280547
13837	15839	47	applied	\N	\N	\N	\N	112831	112831	280549
13837	15840	48	applied	\N	\N	\N	\N	112832	112832	280550
13837	15841	49	applied	\N	\N	\N	\N	112833	112833	280551
13837	15842	50	applied	\N	\N	\N	\N	112834	112834	280552
13837	15843	51	applied	\N	\N	\N	\N	112835	112835	280553
13837	15844	52	applied	\N	\N	\N	\N	112836	112836	280554
13837	15845	53	applied	\N	\N	\N	\N	112837	112837	280555
13837	15846	54	applied	\N	\N	\N	\N	112838	112838	280556
13837	15847	55	applied	\N	\N	\N	\N	112839	112839	280557
13837	15848	56	applied	\N	\N	\N	\N	112840	112840	280558
13837	15849	57	applied	\N	\N	\N	\N	112841	112841	280559
13837	15850	58	applied	\N	\N	\N	\N	112842	112842	280560
13837	15852	59	applied	\N	\N	\N	\N	112843	112843	280561
13837	15853	60	applied	\N	\N	\N	\N	112844	112844	280562
13837	15854	61	applied	\N	\N	\N	\N	112845	112845	280563
13837	15857	62	applied	\N	\N	\N	\N	112846	112846	280564
13837	15859	64	applied	\N	\N	\N	\N	112848	112848	280566
13837	15860	65	applied	\N	\N	\N	\N	112849	112849	280567
13837	15862	66	applied	\N	\N	1000000000	\N	112850	112850	280568
13837	15885	67	applied	\N	\N	\N	\N	112851	112851	280569
13837	15863	68	applied	\N	\N	\N	\N	112852	112852	280570
13837	15864	69	applied	\N	\N	\N	\N	112853	112853	280571
13837	15865	70	applied	\N	\N	\N	\N	112854	112854	280572
13837	15868	71	applied	\N	\N	\N	\N	112855	112855	280573
13837	15869	72	applied	\N	\N	\N	\N	112856	112856	280574
13837	15870	73	applied	\N	\N	\N	\N	112857	112857	280575
13837	15871	74	applied	\N	\N	\N	\N	112858	112858	280576
13837	15872	75	applied	\N	\N	\N	\N	112859	112859	280577
13837	15873	76	applied	\N	\N	\N	\N	112860	112860	280578
13837	15876	77	applied	\N	\N	\N	\N	112861	112861	280579
13840	16037	5	applied	\N	\N	\N	\N	112942	112942	280660
13840	16038	6	applied	\N	\N	\N	\N	112943	112943	280661
13840	16040	8	applied	\N	\N	\N	\N	112945	112945	280663
13844	16041	0	applied	\N	\N	\N	\N	112978	112978	280696
13844	16042	1	applied	\N	\N	\N	\N	112979	112979	280697
13844	16043	2	applied	\N	\N	\N	\N	112980	112980	280698
13844	16044	3	applied	\N	\N	\N	\N	112981	112981	280699
13848	16057	0	applied	\N	\N	\N	\N	113016	113016	280734
13848	16045	1	applied	\N	\N	\N	\N	113017	113017	280735
13848	16046	2	applied	\N	\N	\N	\N	113018	113018	280736
13848	16047	3	applied	\N	\N	\N	\N	113019	113019	280737
13848	16048	4	applied	\N	\N	\N	\N	113020	113020	280738
13848	16049	5	applied	\N	\N	\N	\N	113021	113021	280739
13848	16050	6	applied	\N	\N	\N	\N	113022	113022	280740
13848	16051	7	applied	\N	\N	\N	\N	113023	113023	280741
13848	16052	8	applied	\N	\N	\N	\N	113024	113024	280742
13848	16053	9	applied	\N	\N	\N	\N	113025	113025	280743
13848	16054	10	applied	\N	\N	\N	\N	113026	113026	280744
13848	16056	12	applied	\N	\N	\N	\N	113028	113028	280746
13848	16058	13	applied	\N	\N	\N	\N	113029	113029	280747
13848	16059	14	applied	\N	\N	\N	\N	113030	113030	280748
13848	16060	15	applied	\N	\N	\N	\N	113031	113031	280749
13853	16061	0	applied	\N	\N	\N	\N	113048	113048	280766
13854	16065	0	applied	\N	\N	\N	\N	113049	113049	280767
13854	16058	1	applied	\N	\N	\N	\N	113050	113050	280768
13854	16059	2	applied	\N	\N	\N	\N	113051	113051	280769
13854	16060	3	applied	\N	\N	\N	\N	113052	113052	280770
13854	16062	4	applied	\N	\N	\N	\N	113053	113053	280771
13854	16063	5	applied	\N	\N	\N	\N	113054	113054	280772
13854	16064	6	applied	\N	\N	\N	\N	113055	113055	280773
13854	16066	7	applied	\N	\N	\N	\N	113056	113056	280774
13854	16067	8	applied	\N	\N	\N	\N	113057	113057	280775
13854	16068	9	applied	\N	\N	\N	\N	113058	113058	280776
13859	16085	0	applied	\N	\N	\N	\N	113085	113085	280803
13830	16015	20	applied	\N	\N	\N	\N	112744	112744	280462
13837	15882	82	applied	\N	\N	\N	\N	112866	112866	280584
13837	15884	83	applied	\N	\N	\N	\N	112867	112867	280585
13837	15886	84	applied	\N	\N	\N	\N	112868	112868	280586
13837	15887	85	applied	\N	\N	\N	\N	112869	112869	280587
13837	15889	86	applied	\N	\N	\N	\N	112870	112870	280588
13837	15890	87	applied	\N	\N	\N	\N	112871	112871	280589
13837	15891	88	applied	\N	\N	\N	\N	112872	112872	280590
13837	15894	89	applied	\N	\N	\N	\N	112873	112873	280591
13837	15895	90	applied	\N	\N	\N	\N	112874	112874	280592
13837	15896	91	applied	\N	\N	\N	\N	112875	112875	280593
13837	15898	93	applied	\N	\N	1000000000	\N	112877	112877	280595
13837	15899	94	applied	\N	\N	\N	\N	112878	112878	280596
13837	15900	95	applied	\N	\N	\N	\N	112879	112879	280597
13837	15901	96	applied	\N	\N	\N	\N	112880	112880	280598
13837	15903	97	applied	\N	\N	\N	\N	112881	112881	280599
13837	15904	98	applied	\N	\N	\N	\N	112882	112882	280600
13837	15905	99	applied	\N	\N	\N	\N	112883	112883	280601
13837	15908	100	applied	\N	\N	\N	\N	112884	112884	280602
13837	15909	101	applied	\N	\N	\N	\N	112885	112885	280603
13837	15910	102	applied	\N	\N	\N	\N	112886	112886	280604
13837	15911	103	applied	\N	\N	\N	\N	112887	112887	280605
13837	15913	104	applied	\N	\N	\N	\N	112888	112888	280606
13837	15914	105	applied	\N	\N	\N	\N	112889	112889	280607
13837	15915	106	applied	\N	\N	\N	\N	112890	112890	280608
13837	15916	107	applied	\N	\N	\N	\N	112891	112891	280609
13837	15917	108	applied	\N	\N	\N	\N	112892	112892	280610
13837	15920	109	applied	\N	\N	\N	\N	112893	112893	280611
13837	15921	110	applied	\N	\N	\N	\N	112894	112894	280612
13837	15922	111	applied	\N	\N	\N	\N	112895	112895	280613
13837	15925	112	applied	\N	\N	\N	\N	112896	112896	280614
13837	15927	114	applied	\N	\N	\N	\N	112898	112898	280616
13837	15928	115	applied	\N	\N	\N	\N	112899	112899	280617
13837	15929	116	applied	\N	\N	\N	\N	112900	112900	280618
13837	15930	117	applied	\N	\N	\N	\N	112901	112901	280619
13837	15932	118	applied	\N	\N	\N	\N	112902	112902	280620
13837	15933	119	applied	\N	\N	\N	\N	112903	112903	280621
13837	15934	120	applied	\N	\N	\N	\N	112904	112904	280622
13837	15939	121	applied	\N	\N	\N	\N	112905	112905	280623
13837	15940	122	applied	\N	\N	\N	\N	112906	112906	280624
13837	15941	123	applied	\N	\N	\N	\N	112907	112907	280625
13837	15942	124	applied	\N	\N	\N	\N	112908	112908	280626
13837	15943	125	applied	\N	\N	\N	\N	112909	112909	280627
13839	16025	0	applied	\N	\N	\N	\N	112930	112930	280648
13839	16026	1	applied	\N	\N	\N	\N	112931	112931	280649
13839	16027	2	applied	\N	\N	\N	\N	112932	112932	280650
13839	16028	3	applied	\N	\N	\N	\N	112933	112933	280651
13839	16030	5	applied	\N	\N	\N	\N	112935	112935	280653
13839	16031	6	applied	\N	\N	\N	\N	112936	112936	280654
13839	16032	7	applied	\N	\N	\N	\N	112937	112937	280655
13842	16033	0	applied	\N	\N	\N	\N	112954	112954	280672
13842	16034	1	applied	\N	\N	\N	\N	112955	112955	280673
13842	16035	3	applied	\N	\N	\N	\N	112956	112956	280674
13842	16036	4	applied	\N	\N	\N	\N	112957	112957	280675
13842	16037	5	applied	\N	\N	\N	\N	112958	112958	280676
13842	16038	6	applied	\N	\N	\N	\N	112959	112959	280677
13842	16039	7	applied	\N	\N	\N	\N	112960	112960	280678
13842	16040	8	applied	\N	\N	\N	\N	112961	112961	280679
13843	16041	0	applied	\N	\N	\N	\N	112962	112962	280680
13843	16042	1	applied	\N	\N	\N	\N	112963	112963	280681
13843	16043	2	applied	\N	\N	\N	\N	112964	112964	280682
13843	16044	3	applied	\N	\N	\N	\N	112965	112965	280683
13843	16045	4	applied	\N	\N	\N	\N	112966	112966	280684
13843	16047	6	applied	\N	\N	\N	\N	112968	112968	280686
13843	16048	7	applied	\N	\N	\N	\N	112969	112969	280687
13843	16049	8	applied	\N	\N	\N	\N	112970	112970	280688
13843	16050	9	applied	\N	\N	\N	\N	112971	112971	280689
13843	16051	10	applied	\N	\N	\N	\N	112972	112972	280690
13843	16052	11	applied	\N	\N	\N	\N	112973	112973	280691
13843	16053	12	applied	\N	\N	\N	\N	112974	112974	280692
13843	16054	13	applied	\N	\N	\N	\N	112975	112975	280693
13843	16055	14	applied	\N	\N	\N	\N	112976	112976	280694
13843	16056	15	applied	\N	\N	\N	\N	112977	112977	280695
13851	16061	0	applied	\N	\N	\N	\N	113034	113034	280752
13851	16058	1	applied	\N	\N	\N	\N	113035	113035	280753
13851	16059	2	applied	\N	\N	\N	\N	113036	113036	280754
13851	16060	3	applied	\N	\N	\N	\N	113037	113037	280755
13851	16062	4	applied	\N	\N	\N	\N	113038	113038	280756
13851	16063	5	applied	\N	\N	\N	\N	113039	113039	280757
13855	16065	0	applied	\N	\N	\N	\N	113059	113059	280777
13855	16058	1	applied	\N	\N	\N	\N	113060	113060	280778
13855	16059	2	applied	\N	\N	\N	\N	113061	113061	280779
13855	16060	3	applied	\N	\N	\N	\N	113062	113062	280780
13855	16062	4	applied	\N	\N	\N	\N	113063	113063	280781
13855	16063	5	applied	\N	\N	\N	\N	113064	113064	280782
13855	16064	6	applied	\N	\N	\N	\N	113065	113065	280783
13855	16066	7	applied	\N	\N	\N	\N	113066	113066	280784
13855	16067	8	applied	\N	\N	\N	\N	113067	113067	280785
13855	16068	9	applied	\N	\N	\N	\N	113068	113068	280786
13858	16081	0	applied	\N	\N	\N	\N	113081	113081	280799
13858	16082	1	applied	\N	\N	\N	\N	113082	113082	280800
13858	16083	2	applied	\N	\N	\N	\N	113083	113083	280801
13858	16084	3	applied	\N	\N	\N	\N	113084	113084	280802
13863	16089	0	applied	\N	\N	\N	\N	113101	113101	280819
13865	16097	0	applied	\N	\N	\N	\N	113112	113112	280830
13865	16099	2	applied	\N	\N	\N	\N	113114	113114	280832
13865	16100	3	applied	\N	\N	\N	\N	113115	113115	280833
13869	16108	0	applied	\N	\N	\N	\N	113133	113133	280851
13869	16109	1	applied	\N	\N	\N	\N	113134	113134	280852
13869	16110	2	applied	\N	\N	\N	\N	113135	113135	280853
13869	16111	3	applied	\N	\N	\N	\N	113136	113136	280854
13869	16112	4	applied	\N	\N	\N	\N	113137	113137	280855
13869	16113	5	applied	\N	\N	\N	\N	113138	113138	280856
13869	16114	6	applied	\N	\N	\N	\N	113139	113139	280857
13869	16115	7	applied	\N	\N	\N	\N	113140	113140	280858
13871	16108	0	applied	\N	\N	\N	\N	113149	113149	280867
13871	16109	1	applied	\N	\N	\N	\N	113150	113150	280868
13873	16120	0	applied	\N	\N	\N	\N	113155	113155	280873
13873	16121	1	applied	\N	\N	\N	\N	113156	113156	280874
13873	16122	2	applied	\N	\N	\N	\N	113157	113157	280875
13837	15878	79	applied	\N	\N	\N	\N	112863	112863	280581
13837	15881	81	applied	\N	\N	\N	\N	112865	112865	280583
13846	16055	14	applied	\N	\N	\N	\N	113001	113001	280719
13846	16056	15	applied	\N	\N	\N	\N	113002	113002	280720
13847	16057	0	applied	\N	\N	\N	\N	113003	113003	280721
13847	16045	1	applied	\N	\N	\N	\N	113004	113004	280722
13847	16046	2	applied	\N	\N	\N	\N	113005	113005	280723
13847	16047	3	applied	\N	\N	\N	\N	113006	113006	280724
13847	16048	4	applied	\N	\N	\N	\N	113007	113007	280725
13847	16049	5	applied	\N	\N	\N	\N	113008	113008	280726
13847	16050	6	applied	\N	\N	\N	\N	113009	113009	280727
13847	16051	7	applied	\N	\N	\N	\N	113010	113010	280728
13847	16052	8	applied	\N	\N	\N	\N	113011	113011	280729
13847	16053	9	applied	\N	\N	\N	\N	113012	113012	280730
13847	16054	10	applied	\N	\N	\N	\N	113013	113013	280731
13847	16055	11	applied	\N	\N	\N	\N	113014	113014	280732
13847	16056	12	applied	\N	\N	\N	\N	113015	113015	280733
13849	16057	0	applied	\N	\N	\N	\N	113032	113032	280750
13852	16058	1	applied	\N	\N	\N	\N	113042	113042	280760
13852	16059	2	applied	\N	\N	\N	\N	113043	113043	280761
13852	16060	3	applied	\N	\N	\N	\N	113044	113044	280762
13852	16062	4	applied	\N	\N	\N	\N	113045	113045	280763
13852	16063	5	applied	\N	\N	\N	\N	113046	113046	280764
13852	16064	6	applied	\N	\N	\N	\N	113047	113047	280765
13856	16069	0	applied	\N	\N	\N	\N	113069	113069	280787
13856	16070	1	applied	\N	\N	\N	\N	113070	113070	280788
13856	16071	2	applied	\N	\N	\N	\N	113071	113071	280789
13856	16072	3	applied	\N	\N	\N	\N	113072	113072	280790
13856	16073	4	applied	\N	\N	\N	\N	113073	113073	280791
13856	16074	5	applied	\N	\N	\N	\N	113074	113074	280792
13856	16075	6	applied	\N	\N	\N	\N	113075	113075	280793
13856	16076	7	applied	\N	\N	\N	\N	113076	113076	280794
13861	16085	0	applied	\N	\N	\N	\N	113093	113093	280811
13866	16101	0	applied	\N	\N	\N	\N	113116	113116	280834
13866	16103	2	applied	\N	\N	\N	\N	113118	113118	280836
13866	16104	3	applied	\N	\N	\N	\N	113119	113119	280837
13866	16105	4	applied	\N	\N	\N	\N	113120	113120	280838
13866	16106	5	applied	\N	\N	\N	\N	113121	113121	280839
13866	16107	6	applied	\N	\N	\N	\N	113122	113122	280840
13873	16123	3	applied	\N	\N	\N	\N	113158	113158	280876
13873	16124	4	applied	\N	\N	\N	\N	113159	113159	280877
13873	16125	5	applied	\N	\N	\N	\N	113160	113160	280878
13873	16126	6	applied	\N	\N	\N	\N	113161	113161	280879
13874	16127	0	applied	\N	\N	\N	\N	113162	113162	280880
13874	16128	1	applied	\N	\N	\N	\N	113163	113163	280881
13874	16129	2	applied	\N	\N	\N	\N	113164	113164	280882
13874	16130	4	applied	\N	\N	\N	\N	113165	113165	280883
13875	16127	0	applied	\N	\N	\N	\N	113166	113166	280884
13875	16128	1	applied	\N	\N	\N	\N	113167	113167	280885
13875	16129	2	applied	\N	\N	\N	\N	113168	113168	280886
13875	16132	5	applied	\N	\N	\N	\N	113170	113170	280888
13875	16133	6	applied	\N	\N	\N	\N	113171	113171	280889
13875	16130	7	applied	\N	\N	\N	\N	113172	113172	280890
13875	16134	8	applied	\N	\N	\N	\N	113173	113173	280891
13875	16135	9	applied	\N	\N	\N	\N	113174	113174	280892
13875	16136	10	applied	\N	\N	\N	\N	113175	113175	280893
13875	16137	11	applied	\N	\N	\N	\N	113176	113176	280894
13875	16138	12	applied	\N	\N	\N	\N	113177	113177	280895
13875	16139	13	applied	\N	\N	\N	\N	113178	113178	280896
13878	16140	0	applied	\N	\N	\N	\N	113187	113187	280905
13878	16141	1	applied	\N	\N	\N	\N	113188	113188	280906
13878	16142	2	applied	\N	\N	\N	\N	113189	113189	280907
13878	16143	3	applied	\N	\N	\N	\N	113190	113190	280908
13878	16144	4	applied	\N	\N	\N	\N	113191	113191	280909
13878	16145	5	applied	\N	\N	\N	\N	113192	113192	280910
13878	16146	6	applied	\N	\N	\N	\N	113193	113193	280911
13879	16140	0	applied	\N	\N	\N	\N	113195	113195	280913
13879	16141	1	applied	\N	\N	\N	\N	113196	113196	280914
13879	16142	2	applied	\N	\N	\N	\N	113197	113197	280915
13879	16143	3	applied	\N	\N	\N	\N	113198	113198	280916
13879	16144	4	applied	\N	\N	\N	\N	113199	113199	280917
13879	16145	5	applied	\N	\N	\N	\N	113200	113200	280918
13879	16146	6	applied	\N	\N	\N	\N	113201	113201	280919
13879	16147	7	applied	\N	\N	\N	\N	113202	113202	280920
13880	16140	0	applied	\N	\N	\N	\N	113203	113203	280921
13880	16141	1	applied	\N	\N	\N	\N	113204	113204	280922
13884	16156	0	applied	\N	\N	\N	\N	113231	113231	280949
13884	16157	1	applied	\N	\N	\N	\N	113232	113232	280950
13884	16151	2	applied	\N	\N	\N	\N	113233	113233	280951
13884	16152	3	applied	\N	\N	\N	\N	113234	113234	280952
13884	16153	4	applied	\N	\N	\N	\N	113235	113235	280953
13884	16154	5	applied	\N	\N	\N	\N	113236	113236	280954
13884	16158	7	applied	\N	\N	\N	\N	113238	113238	280956
13884	16159	8	applied	\N	\N	\N	\N	113239	113239	280957
13884	16160	9	applied	\N	\N	\N	\N	113240	113240	280958
13884	16161	10	applied	\N	\N	\N	\N	113241	113241	280959
13884	16162	11	applied	\N	\N	\N	\N	113242	113242	280960
13884	16163	12	applied	\N	\N	\N	\N	113243	113243	280961
13886	16167	0	applied	\N	\N	\N	\N	113247	113247	280965
13886	16168	1	applied	\N	\N	\N	\N	113248	113248	280966
13886	16169	2	applied	\N	\N	\N	\N	113249	113249	280967
13886	16170	3	applied	\N	\N	\N	\N	113250	113250	280968
13887	16167	0	applied	\N	\N	\N	\N	113251	113251	280969
13887	16168	1	applied	\N	\N	\N	\N	113252	113252	280970
13887	16169	2	applied	\N	\N	\N	\N	113253	113253	280971
13887	16170	3	applied	\N	\N	\N	\N	113254	113254	280972
13888	16167	0	applied	\N	\N	\N	\N	113255	113255	280973
13888	16168	1	applied	\N	\N	\N	\N	113256	113256	280974
13888	16170	3	applied	\N	\N	\N	\N	113258	113258	280976
13890	16171	0	applied	\N	\N	\N	\N	113260	113260	280978
13890	16168	1	applied	\N	\N	\N	\N	113261	113261	280979
13890	16169	2	applied	\N	\N	\N	\N	113262	113262	280980
13890	16170	3	applied	\N	\N	\N	\N	113263	113263	280981
13890	16172	4	applied	\N	\N	\N	\N	113264	113264	280982
13890	16173	5	applied	\N	\N	\N	\N	113265	113265	280983
13890	16174	6	applied	\N	\N	\N	\N	113266	113266	280984
13891	16171	0	applied	\N	\N	\N	\N	113267	113267	280985
13893	16176	0	applied	\N	\N	\N	\N	113269	113269	280987
13893	16177	1	applied	\N	\N	\N	\N	113270	113270	280988
13893	16172	2	applied	\N	\N	\N	\N	113271	113271	280989
13893	16173	3	applied	\N	\N	\N	\N	113272	113272	280990
13893	16174	4	applied	\N	\N	\N	\N	113273	113273	280991
13846	16052	11	applied	\N	\N	\N	\N	112998	112998	280716
13846	16053	12	applied	\N	\N	\N	\N	112999	112999	280717
13867	16109	1	applied	\N	\N	\N	\N	113124	113124	280842
13867	16110	2	applied	\N	\N	\N	\N	113125	113125	280843
13867	16111	3	applied	\N	\N	\N	\N	113126	113126	280844
13867	16112	4	applied	\N	\N	\N	\N	113127	113127	280845
13867	16113	5	applied	\N	\N	\N	\N	113128	113128	280846
13867	16114	6	applied	\N	\N	\N	\N	113129	113129	280847
13867	16115	7	applied	\N	\N	\N	\N	113130	113130	280848
13870	16108	0	applied	\N	\N	\N	\N	113141	113141	280859
13870	16109	1	applied	\N	\N	\N	\N	113142	113142	280860
13870	16110	2	applied	\N	\N	\N	\N	113143	113143	280861
13870	16111	3	applied	\N	\N	\N	\N	113144	113144	280862
13870	16112	4	applied	\N	\N	\N	\N	113145	113145	280863
13870	16113	5	applied	\N	\N	\N	\N	113146	113146	280864
13870	16114	6	applied	\N	\N	\N	\N	113147	113147	280865
13870	16115	7	applied	\N	\N	\N	\N	113148	113148	280866
13882	16148	0	applied	\N	\N	\N	\N	113205	113205	280923
13882	16131	2	applied	\N	\N	\N	\N	113207	113207	280925
13882	16132	3	applied	\N	\N	\N	\N	113208	113208	280926
13882	16133	4	applied	\N	\N	\N	\N	113209	113209	280927
13882	16134	5	applied	\N	\N	\N	\N	113210	113210	280928
13882	16135	6	applied	\N	\N	\N	\N	113211	113211	280929
13882	16136	7	applied	\N	\N	\N	\N	113212	113212	280930
13882	16137	8	applied	\N	\N	\N	\N	113213	113213	280931
13882	16138	9	applied	\N	\N	\N	\N	113214	113214	280932
13882	16139	10	applied	\N	\N	\N	\N	113215	113215	280933
13882	16142	11	applied	\N	\N	\N	\N	113216	113216	280934
13882	16143	12	applied	\N	\N	\N	\N	113217	113217	280935
13882	16144	13	applied	\N	\N	\N	\N	113218	113218	280936
13882	16145	14	applied	\N	\N	\N	\N	113219	113219	280937
13882	16146	15	applied	\N	\N	\N	\N	113220	113220	280938
13882	16147	16	applied	\N	\N	\N	\N	113221	113221	280939
13882	16150	17	applied	\N	\N	\N	\N	113222	113222	280940
13882	16152	19	applied	\N	\N	\N	\N	113224	113224	280942
13882	16153	20	applied	\N	\N	\N	\N	113225	113225	280943
13882	16154	21	applied	\N	\N	\N	\N	113226	113226	280944
13882	16155	22	applied	\N	\N	\N	\N	113227	113227	280945
13889	16167	0	applied	\N	\N	\N	\N	113259	113259	280977
13894	16176	0	applied	\N	\N	\N	\N	113283	113283	281001
13894	16177	1	applied	\N	\N	\N	\N	113284	113284	281002
13894	16172	2	applied	\N	\N	\N	\N	113285	113285	281003
13894	16173	3	applied	\N	\N	\N	\N	113286	113286	281004
13894	16174	4	applied	\N	\N	\N	\N	113287	113287	281005
13894	16178	5	applied	\N	\N	\N	\N	113288	113288	281006
13894	16179	6	applied	\N	\N	\N	\N	113289	113289	281007
13894	16180	7	applied	\N	\N	\N	\N	113290	113290	281008
13894	16181	8	applied	\N	\N	\N	\N	113291	113291	281009
13894	16182	9	applied	\N	\N	\N	\N	113292	113292	281010
13894	16183	10	applied	\N	\N	\N	\N	113293	113293	281011
13894	16185	12	applied	\N	\N	\N	\N	113295	113295	281013
13894	16186	13	applied	\N	\N	\N	\N	113296	113296	281014
13895	16176	0	applied	\N	\N	\N	\N	113297	113297	281015
13895	16177	1	applied	\N	\N	\N	\N	113298	113298	281016
13895	16172	2	applied	\N	\N	\N	\N	113299	113299	281017
13895	16173	3	applied	\N	\N	\N	\N	113300	113300	281018
13895	16174	4	applied	\N	\N	\N	\N	113301	113301	281019
13895	16178	5	applied	\N	\N	\N	\N	113302	113302	281020
13895	16179	6	applied	\N	\N	\N	\N	113303	113303	281021
13895	16180	7	applied	\N	\N	\N	\N	113304	113304	281022
13895	16181	8	applied	\N	\N	\N	\N	113305	113305	281023
13895	16182	9	applied	\N	\N	\N	\N	113306	113306	281024
13895	16183	10	applied	\N	\N	\N	\N	113307	113307	281025
13895	16184	11	applied	\N	\N	\N	\N	113308	113308	281026
13895	16185	12	applied	\N	\N	\N	\N	113309	113309	281027
13895	16186	13	applied	\N	\N	\N	\N	113310	113310	281028
13897	16177	1	applied	\N	\N	\N	\N	113326	113326	281044
13899	16187	0	applied	\N	\N	\N	\N	113358	113358	281076
13899	16188	1	applied	\N	\N	\N	\N	113359	113359	281077
13899	16189	2	applied	\N	\N	\N	\N	113360	113360	281078
13899	16190	3	applied	\N	\N	\N	\N	113361	113361	281079
13899	16191	4	applied	\N	\N	\N	\N	113362	113362	281080
13899	16172	5	applied	\N	\N	\N	\N	113363	113363	281081
13899	16173	6	applied	\N	\N	\N	\N	113364	113364	281082
13899	16174	7	applied	\N	\N	\N	\N	113365	113365	281083
13899	16178	8	applied	\N	\N	\N	\N	113366	113366	281084
13899	16179	9	applied	\N	\N	\N	\N	113367	113367	281085
13899	16180	10	applied	\N	\N	\N	\N	113368	113368	281086
13899	16181	11	applied	\N	\N	\N	\N	113369	113369	281087
13899	16182	12	applied	\N	\N	\N	\N	113370	113370	281088
13899	16183	13	applied	\N	\N	\N	\N	113371	113371	281089
13899	16184	14	applied	\N	\N	\N	\N	113372	113372	281090
13899	16186	16	applied	\N	\N	\N	\N	113374	113374	281092
13899	16192	17	applied	\N	\N	\N	\N	113375	113375	281093
13899	16193	18	applied	\N	\N	\N	\N	113376	113376	281094
13899	16194	19	applied	\N	\N	\N	\N	113377	113377	281095
13900	16187	0	applied	\N	\N	\N	\N	113389	113389	281107
13900	16188	1	applied	\N	\N	\N	\N	113390	113390	281108
13900	16189	2	applied	\N	\N	\N	\N	113391	113391	281109
13900	16190	3	applied	\N	\N	\N	\N	113392	113392	281110
13900	16191	4	applied	\N	\N	\N	\N	113393	113393	281111
13900	16172	5	applied	\N	\N	\N	\N	113394	113394	281112
13900	16173	6	applied	\N	\N	\N	\N	113395	113395	281113
13900	16174	7	applied	\N	\N	\N	\N	113396	113396	281114
13900	16178	8	applied	\N	\N	\N	\N	113397	113397	281115
13900	16179	9	applied	\N	\N	\N	\N	113398	113398	281116
13900	16180	10	applied	\N	\N	\N	\N	113399	113399	281117
13900	16181	11	applied	\N	\N	\N	\N	113400	113400	281118
13900	16183	13	applied	\N	\N	\N	\N	113402	113402	281120
13900	16184	14	applied	\N	\N	\N	\N	113403	113403	281121
13900	16185	15	applied	\N	\N	\N	\N	113404	113404	281122
13900	16186	16	applied	\N	\N	\N	\N	113405	113405	281123
13903	16187	0	applied	\N	\N	\N	\N	113468	113468	281186
13903	16188	1	applied	\N	\N	\N	\N	113469	113469	281187
13903	16189	2	applied	\N	\N	\N	\N	113470	113470	281188
13903	16190	3	applied	\N	\N	\N	\N	113471	113471	281189
13903	16191	4	applied	\N	\N	\N	\N	113472	113472	281190
13903	16172	5	applied	\N	\N	\N	\N	113473	113473	281191
13903	16173	6	applied	\N	\N	\N	\N	113474	113474	281192
13903	16174	7	applied	\N	\N	\N	\N	113475	113475	281193
13903	16178	8	applied	\N	\N	\N	\N	113476	113476	281194
13903	16179	9	applied	\N	\N	\N	\N	113477	113477	281195
13859	16087	2	applied	\N	\N	\N	\N	113087	113087	280805
13859	16088	3	applied	\N	\N	\N	\N	113088	113088	280806
13864	16086	1	applied	\N	\N	\N	\N	113103	113103	280821
13864	16087	2	applied	\N	\N	\N	\N	113104	113104	280822
13864	16088	3	applied	\N	\N	\N	\N	113105	113105	280823
13864	16090	4	applied	\N	\N	\N	\N	113106	113106	280824
13864	16091	5	applied	\N	\N	\N	\N	113107	113107	280825
13864	16092	6	applied	\N	\N	\N	\N	113108	113108	280826
13864	16094	7	applied	\N	\N	\N	\N	113109	113109	280827
13864	16095	8	applied	\N	\N	\N	\N	113110	113110	280828
13864	16096	9	applied	\N	\N	\N	\N	113111	113111	280829
13868	16108	0	applied	\N	\N	\N	\N	113131	113131	280849
13868	16109	1	applied	\N	\N	\N	\N	113132	113132	280850
13872	16116	0	applied	\N	\N	\N	\N	113151	113151	280869
13872	16117	1	applied	\N	\N	\N	\N	113152	113152	280870
13872	16118	2	applied	\N	\N	\N	\N	113153	113153	280871
13872	16119	3	applied	\N	\N	\N	\N	113154	113154	280872
13876	16140	0	applied	\N	\N	\N	\N	113179	113179	280897
13876	16142	2	applied	\N	\N	\N	\N	113181	113181	280899
13876	16143	3	applied	\N	\N	\N	\N	113182	113182	280900
13876	16144	4	applied	\N	\N	\N	\N	113183	113183	280901
13876	16145	5	applied	\N	\N	\N	\N	113184	113184	280902
13876	16146	6	applied	\N	\N	\N	\N	113185	113185	280903
13876	16147	7	applied	\N	\N	\N	\N	113186	113186	280904
13883	16148	0	applied	\N	\N	\N	\N	113228	113228	280946
13883	16149	1	applied	\N	\N	\N	\N	113229	113229	280947
13883	16150	2	applied	\N	\N	\N	\N	113230	113230	280948
13885	16164	0	applied	\N	\N	\N	\N	113244	113244	280962
13885	16165	1	applied	\N	\N	\N	\N	113245	113245	280963
13885	16166	2	applied	\N	\N	\N	\N	113246	113246	280964
13892	16175	0	applied	\N	\N	\N	\N	113268	113268	280986
13902	16187	0	applied	\N	\N	\N	\N	113437	113437	281155
13902	16188	1	applied	\N	\N	\N	\N	113438	113438	281156
13902	16189	2	applied	\N	\N	\N	\N	113439	113439	281157
13902	16191	4	applied	\N	\N	\N	\N	113441	113441	281159
13902	16172	5	applied	\N	\N	\N	\N	113442	113442	281160
13902	16173	6	applied	\N	\N	\N	\N	113443	113443	281161
13902	16174	7	applied	\N	\N	\N	\N	113444	113444	281162
13902	16178	8	applied	\N	\N	\N	\N	113445	113445	281163
13902	16179	9	applied	\N	\N	\N	\N	113446	113446	281164
13902	16180	10	applied	\N	\N	\N	\N	113447	113447	281165
13902	16181	11	applied	\N	\N	\N	\N	113448	113448	281166
13902	16182	12	applied	\N	\N	\N	\N	113449	113449	281167
13902	16183	13	applied	\N	\N	\N	\N	113450	113450	281168
13902	16184	14	applied	\N	\N	\N	\N	113451	113451	281169
13902	16185	15	applied	\N	\N	\N	\N	113452	113452	281170
13902	16186	16	applied	\N	\N	\N	\N	113453	113453	281171
13902	16192	17	applied	\N	\N	\N	\N	113454	113454	281172
13902	16193	18	applied	\N	\N	\N	\N	113455	113455	281173
13902	16194	19	applied	\N	\N	\N	\N	113456	113456	281174
13902	16196	21	applied	\N	\N	\N	\N	113458	113458	281176
13902	16197	22	applied	\N	\N	\N	\N	113459	113459	281177
13902	16198	23	applied	\N	\N	\N	\N	113460	113460	281178
13902	16199	24	applied	\N	\N	\N	\N	113461	113461	281179
13902	16200	25	applied	\N	\N	\N	\N	113462	113462	281180
13902	16201	26	applied	\N	\N	\N	\N	113463	113463	281181
13902	16202	27	applied	\N	\N	\N	\N	113464	113464	281182
13902	16203	28	applied	\N	\N	\N	\N	113465	113465	281183
13902	16204	29	applied	\N	\N	\N	\N	113466	113466	281184
13902	16205	30	applied	\N	\N	\N	\N	113467	113467	281185
13903	16180	10	applied	\N	\N	\N	\N	113478	113478	281196
13903	16181	11	applied	\N	\N	\N	\N	113479	113479	281197
13903	16182	12	applied	\N	\N	\N	\N	113480	113480	281198
13903	16183	13	applied	\N	\N	\N	\N	113481	113481	281199
13903	16184	14	applied	\N	\N	\N	\N	113482	113482	281200
13903	16185	15	applied	\N	\N	\N	\N	113483	113483	281201
13904	16206	0	applied	\N	\N	\N	\N	113485	113485	281203
13904	16207	1	applied	\N	\N	\N	\N	113486	113486	281204
13904	16208	2	applied	\N	\N	\N	\N	113487	113487	281205
13904	16209	3	applied	\N	\N	\N	\N	113488	113488	281206
13906	16210	0	applied	\N	\N	\N	\N	113493	113493	281211
13906	16211	1	applied	\N	\N	\N	\N	113494	113494	281212
13906	16212	2	applied	\N	\N	\N	\N	113495	113495	281213
13906	16213	3	applied	\N	\N	\N	\N	113496	113496	281214
13911	16222	0	applied	\N	\N	\N	\N	113519	113519	281237
13911	16223	1	applied	\N	\N	\N	\N	113520	113520	281238
13911	16224	2	applied	\N	\N	\N	\N	113521	113521	281239
13911	16225	3	applied	\N	\N	\N	\N	113522	113522	281240
13913	16226	0	applied	\N	\N	\N	\N	113526	113526	281244
13916	16226	0	applied	\N	\N	\N	\N	113531	113531	281249
13916	16227	1	applied	\N	\N	\N	\N	113532	113532	281250
13916	16228	2	applied	\N	\N	\N	\N	113533	113533	281251
13917	16226	0	applied	\N	\N	\N	\N	113535	113535	281253
13917	16227	1	applied	\N	\N	\N	\N	113536	113536	281254
13917	16228	2	applied	\N	\N	\N	\N	113537	113537	281255
13917	16229	4	applied	\N	\N	\N	\N	113538	113538	281256
13922	16238	0	applied	\N	\N	\N	\N	113554	113554	281272
13922	16239	1	applied	\N	\N	\N	\N	113555	113555	281273
13922	16240	2	applied	\N	\N	\N	\N	113556	113556	281274
13922	16241	3	applied	\N	\N	\N	\N	113557	113557	281275
13923	16238	0	applied	\N	\N	\N	\N	113558	113558	281276
13923	16239	1	applied	\N	\N	\N	\N	113559	113559	281277
13923	16240	2	applied	\N	\N	\N	\N	113560	113560	281278
13923	16241	3	applied	\N	\N	\N	\N	113561	113561	281279
13926	16238	0	applied	\N	\N	\N	\N	113570	113570	281288
13928	16242	0	applied	\N	\N	\N	\N	113572	113572	281290
13928	16243	1	applied	\N	\N	\N	\N	113573	113573	281291
13928	16244	2	applied	\N	\N	\N	\N	113574	113574	281292
13930	16245	0	applied	\N	\N	\N	\N	113578	113578	281296
13930	16243	1	applied	\N	\N	\N	\N	113579	113579	281297
13930	16244	2	applied	\N	\N	\N	\N	113580	113580	281298
13930	16246	3	applied	\N	\N	\N	\N	113581	113581	281299
13930	16247	4	applied	\N	\N	\N	\N	113582	113582	281300
13930	16248	5	applied	\N	\N	\N	\N	113583	113583	281301
13935	16260	0	applied	\N	\N	\N	\N	113599	113599	281317
13935	16261	1	applied	\N	\N	\N	\N	113600	113600	281318
13935	16262	2	applied	\N	\N	\N	\N	113601	113601	281319
13935	16263	3	applied	\N	\N	\N	\N	113602	113602	281320
13948	16280	0	applied	\N	\N	\N	\N	113641	113641	281359
13948	16281	1	applied	\N	\N	\N	\N	113642	113642	281360
13948	16282	2	applied	\N	\N	\N	\N	113643	113643	281361
13948	16283	3	applied	\N	\N	\N	\N	113644	113644	281362
13862	16091	5	applied	\N	\N	\N	\N	113099	113099	280817
13862	16092	6	applied	\N	\N	\N	\N	113100	113100	280818
13893	16182	9	applied	\N	\N	\N	\N	113278	113278	280996
13893	16183	10	applied	\N	\N	\N	\N	113279	113279	280997
13893	16184	11	applied	\N	\N	\N	\N	113280	113280	280998
13893	16185	12	applied	\N	\N	\N	\N	113281	113281	280999
13893	16186	13	applied	\N	\N	\N	\N	113282	113282	281000
13896	16176	0	applied	\N	\N	\N	\N	113311	113311	281029
13896	16177	1	applied	\N	\N	\N	\N	113312	113312	281030
13896	16172	2	applied	\N	\N	\N	\N	113313	113313	281031
13896	16173	3	applied	\N	\N	\N	\N	113314	113314	281032
13896	16174	4	applied	\N	\N	\N	\N	113315	113315	281033
13896	16178	5	applied	\N	\N	\N	\N	113316	113316	281034
13896	16179	6	applied	\N	\N	\N	\N	113317	113317	281035
13896	16180	7	applied	\N	\N	\N	\N	113318	113318	281036
13896	16181	8	applied	\N	\N	\N	\N	113319	113319	281037
13896	16182	9	applied	\N	\N	\N	\N	113320	113320	281038
13896	16183	10	applied	\N	\N	\N	\N	113321	113321	281039
13896	16185	12	applied	\N	\N	\N	\N	113323	113323	281041
13896	16186	13	applied	\N	\N	\N	\N	113324	113324	281042
13898	16187	0	applied	\N	\N	\N	\N	113327	113327	281045
13898	16188	1	applied	\N	\N	\N	\N	113328	113328	281046
13898	16189	2	applied	\N	\N	\N	\N	113329	113329	281047
13898	16190	3	applied	\N	\N	\N	\N	113330	113330	281048
13898	16191	4	applied	\N	\N	\N	\N	113331	113331	281049
13898	16172	5	applied	\N	\N	\N	\N	113332	113332	281050
13898	16173	6	applied	\N	\N	\N	\N	113333	113333	281051
13898	16174	7	applied	\N	\N	\N	\N	113334	113334	281052
13898	16178	8	applied	\N	\N	\N	\N	113335	113335	281053
13898	16179	9	applied	\N	\N	\N	\N	113336	113336	281054
13898	16180	10	applied	\N	\N	\N	\N	113337	113337	281055
13898	16181	11	applied	\N	\N	\N	\N	113338	113338	281056
13898	16182	12	applied	\N	\N	\N	\N	113339	113339	281057
13898	16183	13	applied	\N	\N	\N	\N	113340	113340	281058
13898	16185	15	applied	\N	\N	\N	\N	113342	113342	281060
13898	16186	16	applied	\N	\N	\N	\N	113343	113343	281061
13898	16192	17	applied	\N	\N	\N	\N	113344	113344	281062
13898	16193	18	applied	\N	\N	\N	\N	113345	113345	281063
13898	16194	19	applied	\N	\N	\N	\N	113346	113346	281064
13898	16195	20	applied	\N	\N	\N	\N	113347	113347	281065
13898	16196	21	applied	\N	\N	\N	\N	113348	113348	281066
13898	16197	22	applied	\N	\N	\N	\N	113349	113349	281067
13898	16198	23	applied	\N	\N	\N	\N	113350	113350	281068
13898	16199	24	applied	\N	\N	\N	\N	113351	113351	281069
13898	16200	25	applied	\N	\N	\N	\N	113352	113352	281070
13898	16201	26	applied	\N	\N	\N	\N	113353	113353	281071
13898	16202	27	applied	\N	\N	\N	\N	113354	113354	281072
13898	16203	28	applied	\N	\N	\N	\N	113355	113355	281073
13898	16204	29	applied	\N	\N	\N	\N	113356	113356	281074
13898	16205	30	applied	\N	\N	\N	\N	113357	113357	281075
13901	16188	1	applied	\N	\N	\N	\N	113407	113407	281125
13901	16189	2	applied	\N	\N	\N	\N	113408	113408	281126
13901	16190	3	applied	\N	\N	\N	\N	113409	113409	281127
13901	16191	4	applied	\N	\N	\N	\N	113410	113410	281128
13901	16172	5	applied	\N	\N	\N	\N	113411	113411	281129
13901	16173	6	applied	\N	\N	\N	\N	113412	113412	281130
13901	16174	7	applied	\N	\N	\N	\N	113413	113413	281131
13901	16178	8	applied	\N	\N	\N	\N	113414	113414	281132
13901	16179	9	applied	\N	\N	\N	\N	113415	113415	281133
13901	16180	10	applied	\N	\N	\N	\N	113416	113416	281134
13901	16181	11	applied	\N	\N	\N	\N	113417	113417	281135
13901	16182	12	applied	\N	\N	\N	\N	113418	113418	281136
13901	16183	13	applied	\N	\N	\N	\N	113419	113419	281137
13901	16184	14	applied	\N	\N	\N	\N	113420	113420	281138
13901	16185	15	applied	\N	\N	\N	\N	113421	113421	281139
13901	16186	16	applied	\N	\N	\N	\N	113422	113422	281140
13901	16193	18	applied	\N	\N	\N	\N	113424	113424	281142
13901	16194	19	applied	\N	\N	\N	\N	113425	113425	281143
13901	16195	20	applied	\N	\N	\N	\N	113426	113426	281144
13901	16196	21	applied	\N	\N	\N	\N	113427	113427	281145
13901	16197	22	applied	\N	\N	\N	\N	113428	113428	281146
13901	16198	23	applied	\N	\N	\N	\N	113429	113429	281147
13901	16199	24	applied	\N	\N	\N	\N	113430	113430	281148
13901	16200	25	applied	\N	\N	\N	\N	113431	113431	281149
13901	16201	26	applied	\N	\N	\N	\N	113432	113432	281150
13901	16202	27	applied	\N	\N	\N	\N	113433	113433	281151
13901	16203	28	applied	\N	\N	\N	\N	113434	113434	281152
13901	16204	29	applied	\N	\N	\N	\N	113435	113435	281153
13929	16243	1	applied	\N	\N	\N	\N	113576	113576	281294
13929	16244	2	applied	\N	\N	\N	\N	113577	113577	281295
13934	16260	0	applied	\N	\N	\N	\N	113595	113595	281313
13934	16261	1	applied	\N	\N	\N	\N	113596	113596	281314
13934	16263	3	applied	\N	\N	\N	\N	113598	113598	281316
13936	16260	0	applied	\N	\N	\N	\N	113603	113603	281321
13940	16264	0	applied	\N	\N	\N	\N	113609	113609	281327
13940	16265	1	applied	\N	\N	\N	\N	113610	113610	281328
13940	16266	2	applied	\N	\N	\N	\N	113611	113611	281329
13940	16267	3	applied	\N	\N	\N	\N	113612	113612	281330
13942	16268	0	applied	\N	\N	\N	\N	113620	113620	281338
13942	16269	1	applied	\N	\N	\N	\N	113621	113621	281339
13942	16270	2	applied	\N	\N	\N	\N	113622	113622	281340
13942	16271	3	applied	\N	\N	\N	\N	113623	113623	281341
13944	16272	0	applied	\N	\N	\N	\N	113628	113628	281346
13944	16273	1	applied	\N	\N	\N	\N	113629	113629	281347
13944	16274	2	applied	\N	\N	\N	\N	113630	113630	281348
13944	16275	3	applied	\N	\N	\N	\N	113631	113631	281349
13949	16284	0	applied	\N	\N	\N	\N	113645	113645	281363
13949	16285	1	applied	\N	\N	\N	\N	113646	113646	281364
13949	16287	3	applied	\N	\N	\N	\N	113648	113648	281366
13952	16288	0	applied	\N	\N	\N	\N	113654	113654	281372
13959	16310	0	applied	\N	\N	\N	\N	113678	113678	281396
13959	16311	1	applied	\N	\N	\N	\N	113679	113679	281397
13959	16307	2	applied	\N	\N	\N	\N	113680	113680	281398
13959	16308	3	applied	\N	\N	\N	\N	113681	113681	281399
13959	16309	4	applied	\N	\N	\N	\N	113682	113682	281400
13959	16312	5	applied	\N	\N	\N	\N	113683	113683	281401
13959	16313	6	applied	\N	\N	\N	\N	113684	113684	281402
13959	16314	7	applied	\N	\N	\N	\N	113685	113685	281403
13959	16315	8	applied	\N	\N	\N	\N	113686	113686	281404
13959	16316	9	applied	\N	\N	\N	\N	113687	113687	281405
13959	16317	10	applied	\N	\N	\N	\N	113688	113688	281406
13965	16347	0	applied	\N	\N	\N	\N	113755	113755	281473
13893	16179	6	applied	\N	\N	\N	\N	113275	113275	280993
13893	16180	7	applied	\N	\N	\N	\N	113276	113276	280994
13899	16199	24	applied	\N	\N	\N	\N	113382	113382	281100
13899	16200	25	applied	\N	\N	\N	\N	113383	113383	281101
13899	16201	26	applied	\N	\N	\N	\N	113384	113384	281102
13899	16202	27	applied	\N	\N	\N	\N	113385	113385	281103
13899	16203	28	applied	\N	\N	\N	\N	113386	113386	281104
13899	16204	29	applied	\N	\N	\N	\N	113387	113387	281105
13899	16205	30	applied	\N	\N	\N	\N	113388	113388	281106
13901	16205	30	applied	\N	\N	\N	\N	113436	113436	281154
13905	16206	0	applied	\N	\N	\N	\N	113489	113489	281207
13905	16207	1	applied	\N	\N	\N	\N	113490	113490	281208
13905	16208	2	applied	\N	\N	\N	\N	113491	113491	281209
13905	16209	3	applied	\N	\N	\N	\N	113492	113492	281210
13907	16214	0	applied	\N	\N	\N	\N	113497	113497	281215
13907	16215	1	applied	\N	\N	\N	\N	113498	113498	281216
13907	16216	2	applied	\N	\N	\N	\N	113499	113499	281217
13907	16217	3	applied	\N	\N	\N	\N	113500	113500	281218
13907	16219	5	applied	\N	\N	\N	\N	113502	113502	281220
13907	16220	6	applied	\N	\N	\N	\N	113503	113503	281221
13907	16221	7	applied	\N	\N	\N	\N	113504	113504	281222
13908	16214	0	applied	\N	\N	\N	\N	113505	113505	281223
13908	16215	1	applied	\N	\N	\N	\N	113506	113506	281224
13908	16216	2	applied	\N	\N	\N	\N	113507	113507	281225
13908	16217	3	applied	\N	\N	\N	\N	113508	113508	281226
13908	16218	4	applied	\N	\N	\N	\N	113509	113509	281227
13908	16219	5	applied	\N	\N	\N	\N	113510	113510	281228
13908	16220	6	applied	\N	\N	\N	\N	113511	113511	281229
13908	16221	7	applied	\N	\N	\N	\N	113512	113512	281230
13909	16214	0	applied	\N	\N	\N	\N	113513	113513	281231
13909	16215	1	applied	\N	\N	\N	\N	113514	113514	281232
13910	16222	0	applied	\N	\N	\N	\N	113515	113515	281233
13910	16223	1	applied	\N	\N	\N	\N	113516	113516	281234
13910	16224	2	applied	\N	\N	\N	\N	113517	113517	281235
13912	16222	0	applied	\N	\N	\N	\N	113523	113523	281241
13912	16223	1	applied	\N	\N	\N	\N	113524	113524	281242
13912	16224	2	applied	\N	\N	\N	\N	113525	113525	281243
13914	16226	0	applied	\N	\N	\N	\N	113527	113527	281245
13915	16168	0	applied	\N	\N	\N	\N	113528	113528	281246
13915	16169	1	applied	\N	\N	\N	\N	113529	113529	281247
13915	16170	2	applied	\N	\N	\N	\N	113530	113530	281248
13920	16230	0	applied	\N	\N	\N	\N	113539	113539	281257
13920	16231	1	applied	\N	\N	\N	\N	113540	113540	281258
13920	16227	2	applied	\N	\N	\N	\N	113541	113541	281259
13920	16228	3	applied	\N	\N	\N	\N	113542	113542	281260
13920	16229	4	applied	\N	\N	\N	\N	113543	113543	281261
13920	16232	5	applied	\N	\N	\N	\N	113544	113544	281262
13920	16233	6	applied	\N	\N	\N	\N	113545	113545	281263
13920	16234	7	applied	\N	\N	\N	\N	113546	113546	281264
13920	16235	8	applied	\N	\N	\N	\N	113547	113547	281265
13920	16237	10	applied	\N	\N	\N	\N	113549	113549	281267
13921	16238	0	applied	\N	\N	\N	\N	113550	113550	281268
13921	16239	1	applied	\N	\N	\N	\N	113551	113551	281269
13921	16240	2	applied	\N	\N	\N	\N	113552	113552	281270
13921	16241	3	applied	\N	\N	\N	\N	113553	113553	281271
13924	16238	0	applied	\N	\N	\N	\N	113562	113562	281280
13924	16239	1	applied	\N	\N	\N	\N	113563	113563	281281
13924	16240	2	applied	\N	\N	\N	\N	113564	113564	281282
13924	16241	3	applied	\N	\N	\N	\N	113565	113565	281283
13925	16238	0	applied	\N	\N	\N	\N	113566	113566	281284
13925	16239	1	applied	\N	\N	\N	\N	113567	113567	281285
13925	16240	2	applied	\N	\N	\N	\N	113568	113568	281286
13925	16241	3	applied	\N	\N	\N	\N	113569	113569	281287
13927	16242	0	applied	\N	\N	\N	\N	113571	113571	281289
13932	16249	0	applied	\N	\N	\N	\N	113584	113584	281302
13932	16250	1	applied	\N	\N	\N	\N	113585	113585	281303
13932	16252	3	applied	\N	\N	\N	\N	113587	113587	281305
13932	16253	4	applied	\N	\N	\N	\N	113588	113588	281306
13932	16254	5	applied	\N	\N	\N	\N	113589	113589	281307
13932	16255	6	applied	\N	\N	\N	\N	113590	113590	281308
13932	16256	7	applied	\N	\N	\N	\N	113591	113591	281309
13932	16257	8	applied	\N	\N	\N	\N	113592	113592	281310
13932	16258	9	applied	\N	\N	\N	\N	113593	113593	281311
13932	16259	10	applied	\N	\N	\N	\N	113594	113594	281312
13937	16260	0	applied	\N	\N	\N	\N	113604	113604	281322
13937	16261	1	applied	\N	\N	\N	\N	113605	113605	281323
13937	16262	2	applied	\N	\N	\N	\N	113606	113606	281324
13937	16263	3	applied	\N	\N	\N	\N	113607	113607	281325
13938	16260	0	applied	\N	\N	\N	\N	113608	113608	281326
13941	16264	0	applied	\N	\N	\N	\N	113613	113613	281331
13941	16261	1	applied	\N	\N	\N	\N	113614	113614	281332
13941	16262	2	applied	\N	\N	\N	\N	113615	113615	281333
13941	16265	4	applied	\N	\N	\N	\N	113617	113617	281335
13941	16266	5	applied	\N	\N	\N	\N	113618	113618	281336
13941	16267	6	applied	\N	\N	\N	\N	113619	113619	281337
13943	16268	0	applied	\N	\N	\N	\N	113624	113624	281342
13943	16269	1	applied	\N	\N	\N	\N	113625	113625	281343
13946	16276	0	applied	\N	\N	\N	\N	113636	113636	281354
13946	16277	1	applied	\N	\N	\N	\N	113637	113637	281355
13946	16278	2	applied	\N	\N	\N	\N	113638	113638	281356
13946	16279	3	applied	\N	\N	\N	\N	113639	113639	281357
13950	16288	0	applied	\N	\N	\N	\N	113649	113649	281367
13950	16289	1	applied	\N	\N	\N	\N	113650	113650	281368
13950	16290	2	applied	\N	\N	\N	\N	113651	113651	281369
13950	16291	3	applied	\N	\N	\N	\N	113652	113652	281370
13955	16299	0	applied	\N	\N	\N	\N	113665	113665	281383
13955	16300	1	applied	\N	\N	\N	\N	113666	113666	281384
13955	16301	2	applied	\N	\N	\N	\N	113667	113667	281385
13955	16303	4	applied	\N	\N	\N	\N	113669	113669	281387
13955	16304	5	applied	\N	\N	\N	\N	113670	113670	281388
13955	16305	6	applied	\N	\N	\N	\N	113671	113671	281389
13964	16318	0	applied	\N	\N	\N	\N	113742	113742	281460
13964	16319	1	applied	\N	\N	\N	\N	113743	113743	281461
13964	16320	2	applied	\N	\N	\N	\N	113744	113744	281462
13964	16321	3	applied	\N	\N	\N	\N	113745	113745	281463
13964	16322	4	applied	\N	\N	\N	\N	113746	113746	281464
13964	16323	5	applied	\N	\N	\N	\N	113747	113747	281465
13964	16324	6	applied	\N	\N	\N	\N	113748	113748	281466
13964	16325	7	applied	\N	\N	\N	\N	113749	113749	281467
13964	16326	8	applied	\N	\N	\N	\N	113750	113750	281468
13964	16327	9	applied	\N	\N	\N	\N	113751	113751	281469
13964	16328	10	applied	\N	\N	\N	\N	113752	113752	281470
13899	16196	21	applied	\N	\N	\N	\N	113379	113379	281097
13899	16197	22	applied	\N	\N	\N	\N	113380	113380	281098
13945	16278	2	applied	\N	\N	\N	\N	113634	113634	281352
13945	16279	3	applied	\N	\N	\N	\N	113635	113635	281353
13947	16280	0	applied	\N	\N	\N	\N	113640	113640	281358
13954	16292	0	applied	\N	\N	\N	\N	113658	113658	281376
13954	16293	1	applied	\N	\N	\N	\N	113659	113659	281377
13954	16294	2	applied	\N	\N	\N	\N	113660	113660	281378
13954	16295	3	applied	\N	\N	\N	\N	113661	113661	281379
13954	16296	4	applied	\N	\N	\N	\N	113662	113662	281380
13954	16297	5	applied	\N	\N	\N	\N	113663	113663	281381
13954	16298	6	applied	\N	\N	\N	\N	113664	113664	281382
13957	16306	0	applied	\N	\N	\N	\N	113676	113676	281394
13960	16310	0	applied	\N	\N	\N	\N	113689	113689	281407
13960	16311	1	applied	\N	\N	\N	\N	113690	113690	281408
13960	16307	2	applied	\N	\N	\N	\N	113691	113691	281409
13960	16308	3	applied	\N	\N	\N	\N	113692	113692	281410
13960	16309	4	applied	\N	\N	\N	\N	113693	113693	281411
13960	16313	6	applied	\N	\N	\N	\N	113695	113695	281413
13960	16314	7	applied	\N	\N	\N	\N	113696	113696	281414
13960	16315	8	applied	\N	\N	\N	\N	113697	113697	281415
13960	16316	9	applied	\N	\N	\N	\N	113698	113698	281416
13960	16317	10	applied	\N	\N	\N	\N	113699	113699	281417
13963	16318	0	applied	\N	\N	\N	\N	113729	113729	281447
13963	16319	1	applied	\N	\N	\N	\N	113730	113730	281448
13963	16320	2	applied	\N	\N	\N	\N	113731	113731	281449
13963	16321	3	applied	\N	\N	\N	\N	113732	113732	281450
13963	16322	4	applied	\N	\N	\N	\N	113733	113733	281451
13963	16323	5	applied	\N	\N	\N	\N	113734	113734	281452
13963	16324	6	applied	\N	\N	\N	\N	113735	113735	281453
13963	16325	7	applied	\N	\N	\N	\N	113736	113736	281454
13963	16326	8	applied	\N	\N	\N	\N	113737	113737	281455
13963	16327	9	applied	\N	\N	\N	\N	113738	113738	281456
13963	16328	10	applied	\N	\N	\N	\N	113739	113739	281457
13963	16330	12	applied	\N	\N	\N	\N	113741	113741	281459
13964	16329	11	applied	\N	\N	\N	\N	113753	113753	281471
13964	16330	12	applied	\N	\N	\N	\N	113754	113754	281472
13966	16347	0	applied	\N	\N	\N	\N	113759	113759	281477
13968	16351	0	applied	\N	\N	\N	\N	113764	113764	281482
13971	16355	0	applied	\N	\N	\N	\N	113789	113789	281507
13971	16356	1	applied	\N	\N	\N	\N	113790	113790	281508
13971	16357	2	applied	\N	\N	\N	\N	113791	113791	281509
13973	16364	0	applied	\N	\N	\N	\N	113800	113800	281518
13973	16365	1	applied	\N	\N	\N	\N	113801	113801	281519
13975	16372	0	applied	\N	\N	\N	\N	113810	113810	281528
13975	16373	1	applied	\N	\N	\N	\N	113811	113811	281529
13975	16374	2	applied	\N	\N	\N	\N	113812	113812	281530
13975	16375	3	applied	\N	\N	\N	\N	113813	113813	281531
13976	16372	0	applied	\N	\N	\N	\N	113814	113814	281532
13976	16373	1	applied	\N	\N	\N	\N	113815	113815	281533
13976	16375	3	applied	\N	\N	\N	\N	113817	113817	281535
13978	16376	0	applied	\N	\N	\N	\N	113822	113822	281540
13978	16377	1	applied	\N	\N	\N	\N	113823	113823	281541
13978	16378	2	applied	\N	\N	\N	\N	113824	113824	281542
13978	16379	3	applied	\N	\N	\N	\N	113825	113825	281543
13978	16380	4	applied	\N	\N	\N	\N	113826	113826	281544
13978	16381	5	applied	\N	\N	\N	\N	113827	113827	281545
13978	16382	6	applied	\N	\N	\N	\N	113828	113828	281546
13978	16383	7	applied	\N	\N	\N	\N	113829	113829	281547
13978	16384	8	applied	\N	\N	\N	\N	113830	113830	281548
13978	16385	9	applied	\N	\N	\N	\N	113831	113831	281549
13978	16386	10	applied	\N	\N	\N	\N	113832	113832	281550
13978	16387	11	applied	\N	\N	\N	\N	113833	113833	281551
13980	16388	0	applied	\N	\N	\N	\N	113838	113838	281556
13980	16389	1	applied	\N	\N	\N	\N	113839	113839	281557
13980	16380	2	applied	\N	\N	\N	\N	113840	113840	281558
13980	16382	4	applied	\N	\N	\N	\N	113842	113842	281560
13980	16383	5	applied	\N	\N	\N	\N	113843	113843	281561
13980	16384	6	applied	\N	\N	\N	\N	113844	113844	281562
13980	16385	7	applied	\N	\N	\N	\N	113845	113845	281563
13980	16386	8	applied	\N	\N	\N	\N	113846	113846	281564
13980	16387	9	applied	\N	\N	\N	\N	113847	113847	281565
13980	16390	10	applied	\N	\N	\N	\N	113848	113848	281566
13980	16391	11	applied	\N	\N	\N	\N	113849	113849	281567
13980	16392	12	applied	\N	\N	\N	\N	113850	113850	281568
13980	16393	13	applied	\N	\N	\N	\N	113851	113851	281569
13980	16394	14	applied	\N	\N	\N	\N	113852	113852	281570
13980	16395	15	applied	\N	\N	\N	\N	113853	113853	281571
13981	16388	0	applied	\N	\N	\N	\N	113854	113854	281572
13981	16389	1	applied	\N	\N	\N	\N	113855	113855	281573
13981	16380	2	applied	\N	\N	\N	\N	113856	113856	281574
13981	16381	3	applied	\N	\N	\N	\N	113857	113857	281575
13981	16383	5	applied	\N	\N	\N	\N	113859	113859	281577
13981	16384	6	applied	\N	\N	\N	\N	113860	113860	281578
13981	16385	7	applied	\N	\N	\N	\N	113861	113861	281579
13981	16386	8	applied	\N	\N	\N	\N	113862	113862	281580
13981	16387	9	applied	\N	\N	\N	\N	113863	113863	281581
13981	16390	10	applied	\N	\N	\N	\N	113864	113864	281582
13981	16391	11	applied	\N	\N	\N	\N	113865	113865	281583
13985	16400	0	applied	\N	\N	\N	\N	113888	113888	281606
13985	16401	1	applied	\N	\N	\N	\N	113889	113889	281607
13985	16402	2	applied	\N	\N	\N	\N	113890	113890	281608
13985	16403	3	applied	\N	\N	\N	\N	113891	113891	281609
13985	16404	4	applied	\N	\N	\N	\N	113892	113892	281610
13985	16405	5	applied	\N	\N	\N	\N	113893	113893	281611
13988	16410	0	applied	\N	\N	\N	\N	113902	113902	281620
13988	16411	1	applied	\N	\N	\N	\N	113903	113903	281621
13988	16412	2	applied	\N	\N	\N	\N	113904	113904	281622
13990	16422	0	applied	\N	\N	\N	\N	113914	113914	281632
13990	16423	1	applied	\N	\N	\N	\N	113915	113915	281633
13990	16424	2	applied	\N	\N	\N	\N	113916	113916	281634
13990	16425	3	applied	\N	\N	\N	\N	113917	113917	281635
13992	16422	0	applied	\N	\N	\N	\N	113922	113922	281640
13992	16423	1	applied	\N	\N	\N	\N	113923	113923	281641
13992	16424	2	applied	\N	\N	\N	\N	113924	113924	281642
13992	16425	3	applied	\N	\N	\N	\N	113925	113925	281643
13997	16431	0	applied	\N	\N	\N	\N	113949	113949	281667
13997	16432	1	applied	\N	\N	\N	\N	113950	113950	281668
13997	16433	2	applied	\N	\N	\N	\N	113951	113951	281669
13997	16434	3	applied	\N	\N	\N	\N	113952	113952	281670
13997	16435	4	applied	\N	\N	\N	\N	113953	113953	281671
13997	16436	5	applied	\N	\N	\N	\N	113954	113954	281672
13943	16271	3	applied	\N	\N	\N	\N	113627	113627	281345
13945	16276	0	applied	\N	\N	\N	\N	113632	113632	281350
13956	16306	0	applied	\N	\N	\N	\N	113672	113672	281390
13956	16307	1	applied	\N	\N	\N	\N	113673	113673	281391
13956	16308	2	applied	\N	\N	\N	\N	113674	113674	281392
13956	16309	3	applied	\N	\N	\N	\N	113675	113675	281393
13958	16306	0	applied	\N	\N	\N	\N	113677	113677	281395
13962	16318	0	applied	\N	\N	\N	\N	113700	113700	281418
13962	16319	1	applied	\N	\N	\N	\N	113701	113701	281419
13962	16320	2	applied	\N	\N	\N	\N	113702	113702	281420
13962	16321	3	applied	\N	\N	\N	\N	113703	113703	281421
13962	16322	4	applied	\N	\N	\N	\N	113704	113704	281422
13962	16323	5	applied	\N	\N	\N	\N	113705	113705	281423
13962	16324	6	applied	\N	\N	\N	\N	113706	113706	281424
13962	16325	7	applied	\N	\N	\N	\N	113707	113707	281425
13962	16326	8	applied	\N	\N	\N	\N	113708	113708	281426
13962	16327	9	applied	\N	\N	\N	\N	113709	113709	281427
13962	16328	10	applied	\N	\N	\N	\N	113710	113710	281428
13962	16330	12	applied	\N	\N	\N	\N	113712	113712	281430
13962	16331	13	applied	\N	\N	\N	\N	113713	113713	281431
13962	16332	14	applied	\N	\N	\N	\N	113714	113714	281432
13962	16333	15	applied	\N	\N	\N	\N	113715	113715	281433
13962	16334	16	applied	\N	\N	\N	\N	113716	113716	281434
13962	16335	17	applied	\N	\N	\N	\N	113717	113717	281435
13962	16336	18	applied	\N	\N	\N	\N	113718	113718	281436
13962	16337	19	applied	\N	\N	\N	\N	113719	113719	281437
13962	16338	20	applied	\N	\N	\N	\N	113720	113720	281438
13962	16339	21	applied	\N	\N	\N	\N	113721	113721	281439
13962	16340	22	applied	\N	\N	\N	\N	113722	113722	281440
13962	16341	23	applied	\N	\N	\N	\N	113723	113723	281441
13962	16342	24	applied	\N	\N	\N	\N	113724	113724	281442
13962	16343	25	applied	\N	\N	\N	\N	113725	113725	281443
13962	16344	26	applied	\N	\N	\N	\N	113726	113726	281444
13962	16345	27	applied	\N	\N	\N	\N	113727	113727	281445
13969	16355	0	applied	\N	\N	\N	\N	113765	113765	281483
13969	16356	1	applied	\N	\N	\N	\N	113766	113766	281484
13969	16357	2	applied	\N	\N	\N	\N	113767	113767	281485
13969	16352	3	applied	\N	\N	\N	\N	113768	113768	281486
13969	16353	4	applied	\N	\N	\N	\N	113769	113769	281487
13969	16354	5	applied	\N	\N	\N	\N	113770	113770	281488
13969	16358	6	applied	\N	\N	\N	\N	113771	113771	281489
13969	16359	7	applied	\N	\N	\N	\N	113772	113772	281490
13969	16360	8	applied	\N	\N	\N	\N	113773	113773	281491
13969	16361	9	applied	\N	\N	\N	\N	113774	113774	281492
13969	16362	10	applied	\N	\N	\N	\N	113775	113775	281493
13969	16363	11	applied	\N	\N	\N	\N	113776	113776	281494
13974	16364	0	applied	\N	\N	\N	\N	113802	113802	281520
13974	16365	1	applied	\N	\N	\N	\N	113803	113803	281521
13974	16366	2	applied	\N	\N	\N	\N	113804	113804	281522
13974	16367	3	applied	\N	\N	\N	\N	113805	113805	281523
13974	16369	5	applied	\N	\N	\N	\N	113807	113807	281525
13974	16370	6	applied	\N	\N	\N	\N	113808	113808	281526
13974	16371	7	applied	\N	\N	\N	\N	113809	113809	281527
13977	16372	0	applied	\N	\N	\N	\N	113818	113818	281536
13977	16373	1	applied	\N	\N	\N	\N	113819	113819	281537
13977	16374	2	applied	\N	\N	\N	\N	113820	113820	281538
13977	16375	3	applied	\N	\N	\N	\N	113821	113821	281539
13984	16319	0	applied	\N	\N	\N	\N	113885	113885	281603
13984	16355	1	applied	\N	\N	\N	\N	113886	113886	281604
13984	16270	2	applied	\N	\N	\N	\N	113887	113887	281605
13986	16406	0	applied	\N	\N	\N	\N	113894	113894	281612
13986	16407	1	applied	\N	\N	\N	\N	113895	113895	281613
13986	16408	2	applied	\N	\N	\N	\N	113896	113896	281614
13986	16409	3	applied	\N	\N	\N	\N	113897	113897	281615
13989	16414	0	applied	\N	\N	\N	\N	113906	113906	281624
13989	16415	1	applied	\N	\N	\N	\N	113907	113907	281625
13989	16417	3	applied	\N	\N	\N	\N	113909	113909	281627
13989	16418	4	applied	\N	\N	\N	\N	113910	113910	281628
13989	16419	5	applied	\N	\N	\N	\N	113911	113911	281629
13989	16420	6	applied	\N	\N	\N	\N	113912	113912	281630
13989	16421	8	applied	\N	\N	\N	\N	113913	113913	281631
13991	16422	0	applied	\N	\N	\N	\N	113918	113918	281636
13991	16423	1	applied	\N	\N	\N	\N	113919	113919	281637
13991	16424	2	applied	\N	\N	\N	\N	113920	113920	281638
13991	16425	3	applied	\N	\N	\N	\N	113921	113921	281639
13996	16431	0	applied	\N	\N	\N	\N	113940	113940	281658
13996	16432	1	applied	\N	\N	\N	\N	113941	113941	281659
13996	16433	2	applied	\N	\N	\N	\N	113942	113942	281660
13997	16437	6	applied	\N	\N	\N	\N	113955	113955	281673
13997	16438	7	applied	\N	\N	\N	\N	113956	113956	281674
13997	16439	8	applied	\N	\N	\N	\N	113957	113957	281675
13999	16440	0	applied	\N	\N	\N	\N	113962	113962	281680
14000	16433	1	applied	\N	\N	\N	\N	113964	113964	281682
14000	16444	2	applied	\N	\N	\N	\N	113965	113965	281683
14000	16427	3	applied	\N	\N	\N	\N	113966	113966	281684
14000	16434	4	applied	\N	\N	\N	\N	113967	113967	281685
14002	16457	0	applied	\N	\N	\N	\N	113984	113984	281702
14002	16458	1	applied	\N	\N	\N	\N	113985	113985	113985
14008	16491	0	applied	\N	\N	\N	\N	114031	114031	281748
14008	16492	1	applied	\N	\N	\N	\N	114032	114032	281749
14008	16493	2	applied	\N	\N	\N	\N	114033	114033	281750
14008	16494	3	applied	\N	\N	\N	\N	114034	114034	281751
14008	16495	4	applied	\N	\N	\N	\N	114035	114035	281752
14013	16504	0	applied	\N	\N	\N	\N	114054	114054	281771
14013	16505	1	applied	\N	\N	\N	\N	114055	114055	281772
14016	16509	0	applied	\N	\N	\N	\N	114066	114066	281783
14016	16510	1	applied	\N	\N	\N	\N	114067	114067	281784
14016	16511	2	applied	\N	\N	\N	\N	114068	114068	281785
14016	16513	4	applied	\N	\N	\N	\N	114070	114070	281787
14018	16460	0	applied	\N	\N	\N	\N	114072	114072	281789
14018	16474	1	applied	\N	\N	\N	\N	114073	114073	281790
14018	16319	2	applied	\N	\N	\N	\N	114074	114074	281791
14018	16355	3	applied	\N	\N	\N	\N	114075	114075	281792
14018	16416	4	applied	\N	\N	\N	\N	114076	114076	281793
14018	16433	5	applied	\N	\N	\N	\N	114077	114077	281794
14018	16492	6	applied	\N	\N	\N	\N	114078	114078	281795
14018	16444	7	applied	\N	\N	\N	\N	114079	114079	281796
14018	16500	8	applied	\N	\N	\N	\N	114080	114080	281797
14018	16515	9	applied	\N	\N	\N	\N	114081	114081	281798
14018	16505	10	applied	\N	\N	\N	\N	114082	114082	281799
14018	16427	11	applied	\N	\N	\N	\N	114083	114083	281800
14018	16434	12	applied	\N	\N	\N	\N	114084	114084	281801
13953	16289	0	applied	\N	\N	\N	\N	113655	113655	281373
13953	16290	1	applied	\N	\N	\N	\N	113656	113656	281374
13967	16352	1	applied	\N	\N	\N	\N	113761	113761	281479
13967	16353	2	applied	\N	\N	\N	\N	113762	113762	281480
13967	16354	3	applied	\N	\N	\N	\N	113763	113763	281481
13970	16355	0	applied	\N	\N	\N	\N	113777	113777	281495
13970	16356	1	applied	\N	\N	\N	\N	113778	113778	281496
13970	16357	2	applied	\N	\N	\N	\N	113779	113779	281497
13970	16352	3	applied	\N	\N	\N	\N	113780	113780	281498
13970	16353	4	applied	\N	\N	\N	\N	113781	113781	281499
13970	16354	5	applied	\N	\N	\N	\N	113782	113782	281500
13970	16358	6	applied	\N	\N	\N	\N	113783	113783	281501
13970	16359	7	applied	\N	\N	\N	\N	113784	113784	281502
13970	16360	8	applied	\N	\N	\N	\N	113785	113785	281503
13970	16361	9	applied	\N	\N	\N	\N	113786	113786	281504
13970	16362	10	applied	\N	\N	\N	\N	113787	113787	281505
13970	16363	11	applied	\N	\N	\N	\N	113788	113788	281506
13972	16364	0	applied	\N	\N	\N	\N	113792	113792	281510
13972	16366	2	applied	\N	\N	\N	\N	113794	113794	281512
13972	16367	3	applied	\N	\N	\N	\N	113795	113795	281513
13972	16368	4	applied	\N	\N	\N	\N	113796	113796	281514
13972	16369	5	applied	\N	\N	\N	\N	113797	113797	281515
13972	16370	6	applied	\N	\N	\N	\N	113798	113798	281516
13972	16371	7	applied	\N	\N	\N	\N	113799	113799	281517
13979	16376	0	applied	\N	\N	\N	\N	113834	113834	281552
13979	16377	1	applied	\N	\N	\N	\N	113835	113835	281553
13979	16378	2	applied	\N	\N	\N	\N	113836	113836	281554
13979	16379	3	applied	\N	\N	\N	\N	113837	113837	281555
13982	16388	0	applied	\N	\N	\N	\N	113870	113870	281588
13982	16389	1	applied	\N	\N	\N	\N	113871	113871	281589
13982	16396	2	applied	\N	\N	\N	\N	113872	113872	281590
13982	16380	3	applied	\N	\N	\N	\N	113873	113873	281591
13982	16381	4	applied	\N	\N	\N	\N	113874	113874	281592
13982	16382	5	applied	\N	\N	\N	\N	113875	113875	281593
13982	16384	7	applied	\N	\N	\N	\N	113877	113877	281595
13982	16385	8	applied	\N	\N	\N	\N	113878	113878	281596
13982	16386	9	applied	\N	\N	\N	\N	113879	113879	281597
13982	16387	10	applied	\N	\N	\N	\N	113880	113880	281598
13987	16410	0	applied	\N	\N	\N	\N	113898	113898	281616
13987	16411	1	applied	\N	\N	\N	\N	113899	113899	281617
13987	16412	2	applied	\N	\N	\N	\N	113900	113900	281618
13987	16413	3	applied	\N	\N	\N	\N	113901	113901	281619
13994	16426	0	applied	\N	\N	\N	\N	113927	113927	281645
13994	16423	1	applied	\N	\N	\N	\N	113928	113928	281646
13994	16427	2	applied	\N	\N	\N	\N	113929	113929	281647
13994	16424	3	applied	\N	\N	\N	\N	113930	113930	281648
13994	16425	4	applied	\N	\N	\N	\N	113931	113931	281649
13994	16428	5	applied	\N	\N	\N	\N	113932	113932	281650
13994	16429	6	applied	\N	\N	\N	\N	113933	113933	281651
13994	16430	7	applied	\N	\N	\N	\N	113934	113934	281652
13996	16435	4	applied	\N	\N	\N	\N	113944	113944	281662
13996	16436	5	applied	\N	\N	\N	\N	113945	113945	281663
13996	16437	6	applied	\N	\N	\N	\N	113946	113946	281664
13996	16438	7	applied	\N	\N	\N	\N	113947	113947	281665
13996	16439	8	applied	\N	\N	\N	\N	113948	113948	281666
13998	16440	0	applied	\N	\N	\N	\N	113958	113958	281676
13998	16441	1	applied	\N	\N	\N	\N	113959	113959	281677
13998	16442	2	applied	\N	\N	\N	\N	113960	113960	281678
13998	16443	3	applied	\N	\N	\N	\N	113961	113961	281679
14001	16445	0	applied	\N	\N	\N	\N	113968	113968	281686
14001	16446	1	applied	\N	\N	\N	\N	113969	113969	281687
14001	16447	2	applied	\N	\N	\N	\N	113970	113970	281688
14001	16441	3	applied	\N	\N	\N	\N	113971	113971	281689
14001	16444	4	applied	\N	\N	\N	\N	113972	113972	281690
14001	16442	5	applied	\N	\N	\N	\N	113973	113973	281691
14001	16443	6	applied	\N	\N	\N	\N	113974	113974	281692
14001	16449	8	applied	\N	\N	\N	\N	113976	113976	281694
14001	16450	9	applied	\N	\N	\N	\N	113977	113977	281695
14001	16451	10	applied	\N	\N	\N	\N	113978	113978	281696
14001	16452	11	applied	\N	\N	\N	\N	113979	113979	281697
14001	16453	12	applied	\N	\N	\N	\N	113980	113980	281698
14001	16454	13	applied	\N	\N	\N	\N	113981	113981	281699
14001	16455	14	applied	\N	\N	\N	\N	113982	113982	281700
14001	16456	15	applied	\N	\N	\N	\N	113983	113983	281701
14004	16460	0	applied	\N	\N	\N	\N	113987	113987	281704
14004	16461	1	applied	\N	\N	\N	\N	113988	113988	281705
14004	16462	2	applied	\N	\N	\N	\N	113989	113989	281706
14004	16463	3	applied	\N	\N	\N	\N	113990	113990	281707
14004	16464	4	applied	\N	\N	\N	\N	113991	113991	281708
14004	16465	5	applied	\N	\N	\N	\N	113992	113992	281709
14004	16466	6	applied	\N	\N	\N	\N	113993	113993	281710
14004	16467	7	applied	\N	\N	\N	\N	113994	113994	281711
14004	16469	9	applied	\N	\N	\N	\N	113996	113996	281713
14005	16474	0	applied	\N	\N	\N	\N	114001	114001	281718
14005	16475	1	applied	\N	\N	\N	\N	114002	114002	281719
14005	16476	2	applied	\N	\N	\N	\N	114003	114003	281720
14005	16477	3	applied	\N	\N	\N	\N	114004	114004	281721
14005	16478	4	applied	\N	\N	\N	\N	114005	114005	281722
14005	16479	5	applied	\N	\N	\N	\N	114006	114006	281723
14005	16480	6	applied	\N	\N	\N	\N	114007	114007	281724
14005	16481	7	applied	\N	\N	\N	\N	114008	114008	281725
14005	16482	8	applied	\N	\N	\N	\N	114009	114009	281726
14005	16483	9	applied	\N	\N	\N	\N	114010	114010	281727
14005	16484	10	applied	\N	\N	\N	\N	114011	114011	281728
14005	16485	11	applied	\N	\N	\N	\N	114012	114012	281729
14005	16486	12	applied	\N	\N	\N	\N	114013	114013	281730
14010	16496	0	applied	\N	\N	\N	\N	114038	114038	281755
14010	16493	1	applied	\N	\N	\N	\N	114039	114039	281756
14010	16495	3	applied	\N	\N	\N	\N	114041	114041	281758
14010	16497	4	applied	\N	\N	\N	\N	114042	114042	281759
14010	16498	5	applied	\N	\N	\N	\N	114043	114043	281760
14021	16516	0	applied	\N	\N	\N	\N	114099	114099	281815
14021	16517	1	applied	\N	\N	\N	\N	114100	114100	281816
14021	16515	2	applied	\N	\N	\N	\N	114101	114101	281817
14021	16518	3	applied	\N	\N	\N	\N	114102	114102	281818
14021	16519	4	applied	\N	\N	\N	\N	114103	114103	281819
14021	16520	5	applied	\N	\N	\N	\N	114104	114104	281820
14021	16521	6	applied	\N	\N	\N	\N	114105	114105	281821
14021	16522	7	applied	\N	\N	\N	\N	114106	114106	281822
14021	16523	8	applied	\N	\N	\N	\N	114107	114107	281823
14021	16524	9	applied	\N	\N	\N	\N	114108	114108	281824
14025	16516	0	applied	\N	\N	\N	\N	114132	114132	281848
13965	16349	2	applied	\N	\N	\N	\N	113757	113757	281475
13965	16350	3	applied	\N	\N	\N	\N	113758	113758	281476
13981	16395	15	applied	\N	\N	\N	\N	113869	113869	281587
13983	16396	0	applied	\N	\N	\N	\N	113881	113881	281599
13983	16397	1	applied	\N	\N	\N	\N	113882	113882	281600
13983	16398	2	applied	\N	\N	\N	\N	113883	113883	281601
13983	16399	3	applied	\N	\N	\N	\N	113884	113884	281602
13993	16422	0	applied	\N	\N	\N	\N	113926	113926	281644
13995	16426	0	applied	\N	\N	\N	\N	113935	113935	281653
13995	16423	1	applied	\N	\N	\N	\N	113936	113936	281654
13995	16427	2	applied	\N	\N	\N	\N	113937	113937	281655
13995	16424	3	applied	\N	\N	\N	\N	113938	113938	281656
14003	16459	0	applied	\N	\N	\N	\N	113986	113986	281703
14006	16474	0	applied	\N	\N	\N	\N	114014	114014	281731
14006	16475	1	applied	\N	\N	\N	\N	114015	114015	281732
14006	16476	2	applied	\N	\N	\N	\N	114016	114016	281733
14006	16477	3	applied	\N	\N	\N	\N	114017	114017	281734
14011	16499	0	applied	\N	\N	\N	\N	114044	114044	281761
14011	16500	1	applied	\N	\N	\N	\N	114045	114045	281762
14011	16501	2	applied	\N	\N	\N	\N	114046	114046	281763
14011	16502	3	applied	\N	\N	\N	\N	114047	114047	281764
14011	16503	4	applied	\N	\N	\N	\N	114048	114048	281765
14014	16509	0	applied	\N	\N	\N	\N	114056	114056	281773
14014	16510	1	applied	\N	\N	\N	\N	114057	114057	281774
14014	16511	2	applied	\N	\N	\N	\N	114058	114058	281775
14014	16512	3	applied	\N	\N	\N	\N	114059	114059	281776
14014	16513	4	applied	\N	\N	\N	\N	114060	114060	281777
14023	16516	0	applied	\N	\N	\N	\N	114119	114119	281835
14023	16515	2	applied	\N	\N	\N	\N	114121	114121	281837
14025	16517	1	applied	\N	\N	\N	\N	114133	114133	281849
14025	16515	2	applied	\N	\N	\N	\N	114134	114134	281850
14025	16518	3	applied	\N	\N	\N	\N	114135	114135	281851
14025	16519	4	applied	\N	\N	\N	\N	114136	114136	281852
14025	16520	5	applied	\N	\N	\N	\N	114137	114137	281853
14025	16521	6	applied	\N	\N	\N	\N	114138	114138	281854
14025	16522	7	applied	\N	\N	\N	\N	114139	114139	281855
14025	16523	8	applied	\N	\N	\N	\N	114140	114140	281856
14025	16524	9	applied	\N	\N	\N	\N	114141	114141	281857
14027	16525	0	applied	\N	\N	\N	\N	114152	114152	281868
14027	16526	1	applied	\N	\N	\N	\N	114153	114153	281869
14027	16527	2	applied	\N	\N	\N	\N	114154	114154	281870
14027	16528	3	applied	\N	\N	\N	\N	114155	114155	281871
14027	16529	4	applied	\N	\N	\N	\N	114156	114156	281872
14028	16530	0	applied	\N	\N	\N	\N	114157	114157	281873
14031	16531	1	applied	\N	\N	\N	\N	114166	114166	281882
14033	16531	0	applied	\N	\N	\N	\N	114173	114173	281889
14037	16537	0	applied	\N	\N	\N	\N	114181	114181	281897
14038	16540	0	applied	\N	\N	\N	\N	114182	114182	281898
14038	16541	1	applied	\N	\N	\N	\N	114183	114183	281899
14039	16540	0	applied	\N	\N	\N	\N	114184	114184	281900
14039	16541	1	applied	\N	\N	\N	\N	114185	114185	281901
14039	16538	2	applied	\N	\N	\N	\N	114186	114186	281902
14039	16539	3	applied	\N	\N	\N	\N	114187	114187	281903
14039	16542	4	applied	\N	\N	\N	\N	114188	114188	281904
14039	16543	5	applied	\N	\N	\N	\N	114189	114189	281905
14039	16544	6	applied	\N	\N	\N	\N	114190	114190	281906
14039	16545	7	applied	\N	\N	\N	\N	114191	114191	281907
14040	16546	0	applied	\N	\N	\N	\N	114192	114192	281908
14040	16547	1	applied	\N	\N	\N	\N	114193	114193	281909
14040	16548	2	applied	\N	\N	\N	\N	114194	114194	281910
14040	16550	4	applied	\N	\N	\N	\N	114196	114196	281912
14040	16551	5	applied	\N	\N	\N	\N	114197	114197	281913
14040	16552	6	applied	\N	\N	\N	\N	114198	114198	281914
14040	16553	7	applied	\N	\N	\N	\N	114199	114199	281915
14043	16554	0	applied	\N	\N	\N	\N	114216	114216	281932
14043	16555	1	applied	\N	\N	\N	\N	114217	114217	281933
14045	16563	1	applied	\N	\N	\N	\N	114227	114227	281941
14045	16556	2	applied	\N	\N	\N	\N	114228	114228	281942
14045	16557	3	applied	\N	\N	\N	\N	114229	114229	281943
14045	16558	4	applied	\N	\N	\N	\N	114230	114230	281944
14045	16559	5	applied	\N	\N	\N	\N	114231	114231	281945
14045	16560	6	applied	\N	\N	\N	\N	114232	114232	281946
14045	16561	7	applied	\N	\N	\N	\N	114233	114233	281947
14045	16564	8	applied	\N	\N	\N	\N	114234	114234	281948
14045	16565	9	applied	\N	\N	\N	\N	114235	114235	281949
14048	16563	1	applied	\N	\N	\N	\N	114259	114259	281970
14048	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114258	114258	\N
14048	16556	2	applied	\N	\N	\N	\N	114260	114260	281971
14048	16557	3	applied	\N	\N	\N	\N	114261	114261	281972
14048	16558	4	applied	\N	\N	\N	\N	114262	114262	281973
14048	16559	5	applied	\N	\N	\N	\N	114263	114263	281974
14048	16560	6	applied	\N	\N	\N	\N	114264	114264	281975
14048	16561	7	applied	\N	\N	\N	\N	114265	114265	281976
14048	16564	8	applied	\N	\N	\N	\N	114266	114266	281977
14048	16565	9	applied	\N	\N	\N	\N	114267	114267	281978
14048	16566	10	applied	\N	\N	\N	\N	114268	114268	281979
14050	16563	1	applied	\N	\N	\N	\N	114272	114272	281981
14050	16556	2	applied	\N	\N	\N	\N	114273	114273	281982
14050	16557	3	applied	\N	\N	\N	\N	114274	114274	281983
14050	16558	4	applied	\N	\N	\N	\N	114275	114275	281984
14050	16559	5	applied	\N	\N	\N	\N	114276	114276	281985
14050	16560	6	applied	\N	\N	\N	\N	114277	114277	281986
14050	16561	7	applied	\N	\N	\N	\N	114278	114278	281987
14050	16564	8	applied	\N	\N	\N	\N	114279	114279	281988
14050	16565	9	applied	\N	\N	\N	\N	114280	114280	281989
14050	16566	10	applied	\N	\N	\N	\N	114281	114281	281990
14051	16567	0	applied	\N	\N	\N	\N	114282	114282	281991
14051	16568	1	applied	\N	\N	\N	\N	114283	114283	281992
14051	16569	2	applied	\N	\N	\N	\N	114284	114284	281993
14051	16570	3	applied	\N	\N	\N	\N	114285	114285	281994
14051	16571	4	applied	\N	\N	\N	\N	114286	114286	281995
14052	16567	0	applied	\N	\N	\N	\N	114287	114287	281996
14052	16568	1	applied	\N	\N	\N	\N	114288	114288	281997
14052	16569	2	applied	\N	\N	\N	\N	114289	114289	281998
14056	16580	0	applied	\N	\N	\N	\N	114306	114306	282015
14056	16581	1	applied	\N	\N	\N	\N	114307	114307	282016
14056	16582	2	applied	\N	\N	\N	\N	114308	114308	282017
14056	16583	3	applied	\N	\N	\N	\N	114309	114309	282018
14068	16600	0	applied	\N	\N	\N	\N	114346	114346	282055
14068	16601	1	applied	\N	\N	\N	\N	114347	114347	282056
13981	16393	13	applied	\N	\N	\N	\N	113867	113867	281585
13981	16394	14	applied	\N	\N	\N	\N	113868	113868	281586
14007	16487	0	applied	\N	\N	\N	\N	114018	114018	281735
14007	16478	1	applied	\N	\N	\N	\N	114019	114019	281736
14007	16479	2	applied	\N	\N	\N	\N	114020	114020	281737
14007	16480	3	applied	\N	\N	\N	\N	114021	114021	281738
14007	16481	4	applied	\N	\N	\N	\N	114022	114022	281739
14007	16482	5	applied	\N	\N	\N	\N	114023	114023	281740
14007	16483	6	applied	\N	\N	\N	\N	114024	114024	281741
14007	16484	7	applied	\N	\N	\N	\N	114025	114025	281742
14007	16485	8	applied	\N	\N	\N	\N	114026	114026	281743
14007	16486	9	applied	\N	\N	\N	\N	114027	114027	281744
14007	16488	10	applied	\N	\N	\N	\N	114028	114028	281745
14007	16489	11	applied	\N	\N	\N	\N	114029	114029	281746
14007	16490	12	applied	\N	\N	\N	\N	114030	114030	281747
14009	16492	1	applied	\N	\N	\N	\N	114037	114037	281754
14012	16504	0	applied	\N	\N	\N	\N	114049	114049	281766
14012	16505	1	applied	\N	\N	\N	\N	114050	114050	281767
14012	16506	2	applied	\N	\N	\N	\N	114051	114051	281768
14012	16507	3	applied	\N	\N	\N	\N	114052	114052	281769
14012	16508	4	applied	\N	\N	\N	\N	114053	114053	281770
14015	16509	0	applied	\N	\N	\N	\N	114061	114061	281778
14015	16510	1	applied	\N	\N	\N	\N	114062	114062	281779
14015	16511	2	applied	\N	\N	\N	\N	114063	114063	281780
14015	16512	3	applied	\N	\N	\N	\N	114064	114064	281781
14015	16513	4	applied	\N	\N	\N	\N	114065	114065	281782
14017	16514	0	applied	\N	\N	\N	\N	114071	114071	281788
14020	16516	0	applied	\N	\N	\N	\N	114089	114089	281805
14020	16517	1	applied	\N	\N	\N	\N	114090	114090	281806
14020	16515	2	applied	\N	\N	\N	\N	114091	114091	281807
14020	16518	3	applied	\N	\N	\N	\N	114092	114092	281808
14020	16520	5	applied	\N	\N	\N	\N	114094	114094	281810
14020	16521	6	applied	\N	\N	\N	\N	114095	114095	281811
14020	16522	7	applied	\N	\N	\N	\N	114096	114096	281812
14020	16523	8	applied	\N	\N	\N	\N	114097	114097	281813
14020	16524	9	applied	\N	\N	\N	\N	114098	114098	281814
14024	16516	0	applied	\N	\N	\N	\N	114122	114122	281838
14024	16517	1	applied	\N	\N	\N	\N	114123	114123	281839
14024	16515	2	applied	\N	\N	\N	\N	114124	114124	281840
14024	16518	3	applied	\N	\N	\N	\N	114125	114125	281841
14024	16519	4	applied	\N	\N	\N	\N	114126	114126	281842
14024	16520	5	applied	\N	\N	\N	\N	114127	114127	281843
14024	16521	6	applied	\N	\N	\N	\N	114128	114128	281844
14024	16522	7	applied	\N	\N	\N	\N	114129	114129	281845
14024	16523	8	applied	\N	\N	\N	\N	114130	114130	281846
14024	16524	9	applied	\N	\N	\N	\N	114131	114131	281847
14030	16531	0	applied	\N	\N	\N	\N	114159	114159	281875
14030	16533	2	applied	\N	\N	\N	\N	114161	114161	281877
14030	16534	3	applied	\N	\N	\N	\N	114162	114162	281878
14030	16535	4	applied	\N	\N	\N	\N	114163	114163	281879
14030	16536	5	applied	\N	\N	\N	\N	114164	114164	281880
14032	16531	0	applied	\N	\N	\N	\N	114167	114167	281883
14032	16532	1	applied	\N	\N	\N	\N	114168	114168	281884
14032	16533	2	applied	\N	\N	\N	\N	114169	114169	281885
14032	16534	3	applied	\N	\N	\N	\N	114170	114170	281886
14032	16535	4	applied	\N	\N	\N	\N	114171	114171	281887
14032	16536	5	applied	\N	\N	\N	\N	114172	114172	281888
14036	16537	0	applied	\N	\N	\N	\N	114178	114178	281894
14036	16538	1	applied	\N	\N	\N	\N	114179	114179	281895
14036	16539	2	applied	\N	\N	\N	\N	114180	114180	281896
14041	16546	0	applied	\N	\N	\N	\N	114200	114200	281916
14041	16547	1	applied	\N	\N	\N	\N	114201	114201	281917
14041	16548	2	applied	\N	\N	\N	\N	114202	114202	281918
14041	16550	4	applied	\N	\N	\N	\N	114204	114204	281920
14041	16551	5	applied	\N	\N	\N	\N	114205	114205	281921
14041	16552	6	applied	\N	\N	\N	\N	114206	114206	281922
14041	16553	7	applied	\N	\N	\N	\N	114207	114207	281923
14046	16563	1	applied	\N	\N	\N	\N	114238	114238	281951
14046	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114237	114237	\N
14046	16556	2	applied	\N	\N	\N	\N	114239	114239	281952
14046	16557	3	applied	\N	\N	\N	\N	114240	114240	281953
14046	16558	4	applied	\N	\N	\N	\N	114241	114241	281954
14046	16559	5	applied	\N	\N	\N	\N	114242	114242	281955
14046	16560	6	applied	\N	\N	\N	\N	114243	114243	281956
14046	16561	7	applied	\N	\N	\N	\N	114244	114244	281957
14046	16564	8	applied	\N	\N	\N	\N	114245	114245	281958
14046	16565	9	applied	\N	\N	\N	\N	114246	114246	281959
14068	16602	2	applied	\N	\N	\N	\N	114348	114348	282057
14068	16603	3	applied	\N	\N	\N	\N	114349	114349	282058
14071	16474	1	applied	\N	\N	\N	\N	114359	114359	282068
14071	16492	3	applied	\N	\N	\N	\N	114361	114361	282069
14071	16562	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	114360	114360	\N
14071	16500	4	applied	\N	\N	\N	\N	114362	114362	282070
14071	16515	5	applied	\N	\N	\N	\N	114363	114363	282071
14071	16505	6	applied	\N	\N	\N	\N	114364	114364	282072
14071	16503	7	applied	\N	\N	\N	\N	114365	114365	282073
14071	16510	8	applied	\N	\N	\N	\N	114366	114366	282074
14071	16529	9	applied	\N	\N	\N	\N	114367	114367	282075
14071	16568	10	applied	\N	\N	\N	\N	114368	114368	282076
14071	16458	11	applied	\N	\N	\N	\N	114369	114369	114369
14071	16586	12	applied	\N	\N	\N	\N	114370	114370	282077
14072	16604	0	applied	\N	\N	\N	\N	114371	114371	282078
14072	16605	1	applied	\N	\N	\N	\N	114372	114372	282079
14072	16606	2	applied	\N	\N	\N	\N	114373	114373	282080
14072	16607	3	applied	\N	\N	\N	\N	114374	114374	282081
14083	16617	1	applied	\N	\N	\N	\N	114388	114388	282095
14083	16618	2	applied	\N	\N	1000000000	\N	114389	114389	282096
14083	16619	3	applied	\N	\N	1000000000	\N	114390	114390	282097
14083	16620	4	applied	\N	\N	\N	\N	114391	114391	282098
14083	16621	5	applied	\N	\N	\N	\N	114392	114392	282099
14086	16622	0	applied	\N	\N	\N	\N	114408	114408	282115
14086	16623	1	applied	\N	\N	\N	\N	114409	114409	282116
14086	16624	2	applied	\N	\N	\N	\N	114410	114410	282117
14086	16625	3	applied	\N	\N	\N	\N	114411	114411	282118
14086	16626	4	applied	\N	\N	\N	\N	114412	114412	282119
14086	16627	5	applied	\N	\N	\N	\N	114413	114413	282120
14086	16628	6	applied	\N	\N	\N	\N	114414	114414	282121
14086	16629	7	applied	\N	\N	\N	\N	114415	114415	282122
14086	16630	8	applied	\N	\N	\N	\N	114416	114416	282123
14088	16622	0	applied	\N	\N	\N	\N	114426	114426	282133
14004	16471	11	applied	\N	\N	\N	\N	113998	113998	281715
14004	16473	13	applied	\N	\N	\N	\N	114000	114000	281717
14018	16458	16	applied	\N	\N	\N	\N	114088	114088	114088
14022	16516	0	applied	\N	\N	\N	\N	114109	114109	281825
14022	16517	1	applied	\N	\N	\N	\N	114110	114110	281826
14022	16515	2	applied	\N	\N	\N	\N	114111	114111	281827
14022	16518	3	applied	\N	\N	\N	\N	114112	114112	281828
14022	16519	4	applied	\N	\N	\N	\N	114113	114113	281829
14022	16520	5	applied	\N	\N	\N	\N	114114	114114	281830
14022	16521	6	applied	\N	\N	\N	\N	114115	114115	281831
14022	16522	7	applied	\N	\N	\N	\N	114116	114116	281832
14022	16523	8	applied	\N	\N	\N	\N	114117	114117	281833
14026	16516	0	applied	\N	\N	\N	\N	114142	114142	281858
14026	16517	1	applied	\N	\N	\N	\N	114143	114143	281859
14026	16515	2	applied	\N	\N	\N	\N	114144	114144	281860
14026	16518	3	applied	\N	\N	\N	\N	114145	114145	281861
14026	16519	4	applied	\N	\N	\N	\N	114146	114146	281862
14026	16520	5	applied	\N	\N	\N	\N	114147	114147	281863
14026	16521	6	applied	\N	\N	\N	\N	114148	114148	281864
14026	16522	7	applied	\N	\N	\N	\N	114149	114149	281865
14026	16523	8	applied	\N	\N	\N	\N	114150	114150	281866
14026	16524	9	applied	\N	\N	\N	\N	114151	114151	281867
14029	16531	0	applied	\N	\N	\N	\N	114158	114158	281874
14034	16537	0	applied	\N	\N	\N	\N	114174	114174	281890
14034	16538	1	applied	\N	\N	\N	\N	114175	114175	281891
14034	16539	2	applied	\N	\N	\N	\N	114176	114176	281892
14035	16537	0	applied	\N	\N	\N	\N	114177	114177	281893
14042	16554	0	applied	\N	\N	\N	\N	114208	114208	281924
14042	16556	2	applied	\N	\N	\N	\N	114210	114210	281926
14042	16557	3	applied	\N	\N	\N	\N	114211	114211	281927
14042	16558	4	applied	\N	\N	\N	\N	114212	114212	281928
14042	16559	5	applied	\N	\N	\N	\N	114213	114213	281929
14042	16560	6	applied	\N	\N	\N	\N	114214	114214	281930
14042	16561	7	applied	\N	\N	\N	\N	114215	114215	281931
14044	16563	1	applied	\N	\N	\N	\N	114219	114219	281934
14044	16556	2	applied	\N	\N	\N	\N	114220	114220	281935
14044	16557	3	applied	\N	\N	\N	\N	114221	114221	281936
14044	16558	4	applied	\N	\N	\N	\N	114222	114222	281937
14044	16559	5	applied	\N	\N	\N	\N	114223	114223	281938
14044	16560	6	applied	\N	\N	\N	\N	114224	114224	281939
14044	16561	7	applied	\N	\N	\N	\N	114225	114225	281940
14046	16566	10	applied	\N	\N	\N	\N	114247	114247	281960
14047	16556	1	applied	\N	\N	\N	\N	114249	114249	281961
14047	16557	2	applied	\N	\N	\N	\N	114250	114250	281962
14047	16558	3	applied	\N	\N	\N	\N	114251	114251	281963
14047	16559	4	applied	\N	\N	\N	\N	114252	114252	281964
14047	16560	5	applied	\N	\N	\N	\N	114253	114253	281965
14047	16561	6	applied	\N	\N	\N	\N	114254	114254	281966
14047	16564	7	applied	\N	\N	\N	\N	114255	114255	281967
14047	16565	8	applied	\N	\N	\N	\N	114256	114256	281968
14047	16566	9	applied	\N	\N	\N	\N	114257	114257	281969
14049	16563	1	applied	\N	\N	\N	\N	114270	114270	281980
14049	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114269	114269	\N
14053	16572	0	applied	\N	\N	\N	\N	114292	114292	282001
14053	16573	1	applied	\N	\N	\N	\N	114293	114293	282002
14054	16572	0	applied	\N	\N	\N	\N	114294	114294	282003
14054	16573	1	applied	\N	\N	\N	\N	114295	114295	282004
14054	16574	2	applied	\N	\N	\N	\N	114296	114296	282005
14054	16575	3	applied	\N	\N	\N	\N	114297	114297	282006
14054	16576	4	applied	\N	\N	\N	\N	114298	114298	282007
14054	16577	5	applied	\N	\N	\N	\N	114299	114299	282008
14054	16578	6	applied	\N	\N	\N	\N	114300	114300	282009
14054	16579	7	applied	\N	\N	\N	\N	114301	114301	282010
14055	16580	0	applied	\N	\N	\N	\N	114302	114302	282011
14055	16581	1	applied	\N	\N	\N	\N	114303	114303	282012
14055	16582	2	applied	\N	\N	\N	\N	114304	114304	282013
14055	16583	3	applied	\N	\N	\N	\N	114305	114305	282014
14057	16582	1	applied	\N	\N	\N	\N	114311	114311	282020
14057	16583	2	applied	\N	\N	\N	\N	114312	114312	282021
14058	16581	0	applied	\N	\N	\N	\N	114313	114313	282022
14058	16582	1	applied	\N	\N	\N	\N	114314	114314	282023
14058	16583	2	applied	\N	\N	\N	\N	114315	114315	282024
14060	16584	0	applied	\N	\N	\N	\N	114324	114324	282033
14060	16585	1	applied	\N	\N	\N	\N	114325	114325	282034
14060	16586	2	applied	\N	\N	\N	\N	114326	114326	282035
14060	16587	3	applied	\N	\N	\N	\N	114327	114327	282036
14060	16588	4	applied	\N	\N	\N	\N	114328	114328	282037
14060	16589	5	applied	\N	\N	\N	\N	114329	114329	282038
14060	16590	6	applied	\N	\N	\N	\N	114330	114330	282039
14060	16591	7	applied	\N	\N	\N	\N	114331	114331	282040
14061	16592	0	applied	\N	\N	\N	\N	114332	114332	282041
14061	16593	1	applied	\N	\N	\N	\N	114333	114333	282042
14061	16594	2	applied	\N	\N	\N	\N	114334	114334	282043
14067	16600	0	applied	\N	\N	\N	\N	114345	114345	282054
14069	16600	0	applied	\N	\N	\N	\N	114350	114350	282059
14069	16601	1	applied	\N	\N	\N	\N	114351	114351	282060
14069	16602	2	applied	\N	\N	\N	\N	114352	114352	282061
14069	16603	3	applied	\N	\N	\N	\N	114353	114353	282062
14070	16600	0	applied	\N	\N	\N	\N	114354	114354	282063
14070	16601	1	applied	\N	\N	\N	\N	114355	114355	282064
14070	16602	2	applied	\N	\N	\N	\N	114356	114356	282065
14070	16603	3	applied	\N	\N	\N	\N	114357	114357	282066
14073	16604	0	applied	\N	\N	\N	\N	114375	114375	282082
14073	16605	1	applied	\N	\N	\N	\N	114376	114376	282083
14073	16606	2	applied	\N	\N	\N	\N	114377	114377	282084
14073	16607	3	applied	\N	\N	\N	\N	114378	114378	282085
14077	16608	0	applied	\N	\N	\N	\N	114379	114379	282086
14077	16609	1	applied	\N	\N	\N	\N	114380	114380	282087
14077	16610	2	applied	\N	\N	\N	\N	114381	114381	282088
14077	16612	4	applied	\N	\N	\N	\N	114383	114383	282090
14077	16613	5	applied	\N	\N	\N	\N	114384	114384	282091
14077	16614	6	applied	\N	\N	\N	\N	114385	114385	282092
14085	16622	0	applied	\N	\N	\N	\N	114399	114399	282106
14085	16623	1	applied	\N	\N	\N	\N	114400	114400	282107
14085	16624	2	applied	\N	\N	\N	\N	114401	114401	282108
14085	16625	3	applied	\N	\N	\N	\N	114402	114402	282109
14085	16626	4	applied	\N	\N	\N	\N	114403	114403	282110
14085	16627	5	applied	\N	\N	\N	\N	114404	114404	282111
14085	16628	6	applied	\N	\N	\N	\N	114405	114405	282112
14085	16629	7	applied	\N	\N	\N	\N	114406	114406	282113
14018	16503	14	applied	\N	\N	\N	\N	114086	114086	281803
14018	16510	15	applied	\N	\N	\N	\N	114087	114087	281804
14059	16585	1	applied	\N	\N	\N	\N	114317	114317	282026
14059	16586	2	applied	\N	\N	\N	\N	114318	114318	282027
14059	16587	3	applied	\N	\N	\N	\N	114319	114319	282028
14059	16588	4	applied	\N	\N	\N	\N	114320	114320	282029
14059	16589	5	applied	\N	\N	\N	\N	114321	114321	282030
14059	16590	6	applied	\N	\N	\N	\N	114322	114322	282031
14059	16591	7	applied	\N	\N	\N	\N	114323	114323	282032
14062	16592	0	applied	\N	\N	\N	\N	114336	114336	282045
14064	16592	0	applied	\N	\N	\N	\N	114337	114337	282046
14064	16594	2	applied	\N	\N	\N	\N	114339	114339	282048
14064	16595	3	applied	\N	\N	\N	\N	114340	114340	282049
14066	16596	0	applied	\N	\N	\N	\N	114341	114341	282050
14066	16597	1	applied	\N	\N	\N	\N	114342	114342	282051
14066	16598	2	applied	\N	\N	\N	\N	114343	114343	282052
14066	16599	3	applied	\N	\N	\N	\N	114344	114344	282053
14085	16630	8	applied	\N	\N	\N	\N	114407	114407	282114
14087	16622	0	applied	\N	\N	\N	\N	114417	114417	282124
14087	16623	1	applied	\N	\N	\N	\N	114418	114418	282125
14087	16624	2	applied	\N	\N	\N	\N	114419	114419	282126
14087	16625	3	applied	\N	\N	\N	\N	114420	114420	282127
14087	16626	4	applied	\N	\N	\N	\N	114421	114421	282128
14087	16627	5	applied	\N	\N	\N	\N	114422	114422	282129
14087	16628	6	applied	\N	\N	\N	\N	114423	114423	282130
14087	16629	7	applied	\N	\N	\N	\N	114424	114424	282131
14087	16630	8	applied	\N	\N	\N	\N	114425	114425	282132
14092	16631	0	applied	\N	\N	\N	\N	114444	114444	282151
14092	16632	1	applied	\N	\N	\N	\N	114445	114445	282152
14092	16633	2	applied	\N	\N	\N	\N	114446	114446	282153
14092	16634	3	applied	\N	\N	\N	\N	114447	114447	282154
14097	16639	0	applied	\N	\N	\N	\N	114465	114465	282172
14097	16632	1	applied	\N	\N	\N	\N	114466	114466	282173
14097	16633	2	applied	\N	\N	\N	\N	114467	114467	282174
14097	16634	3	applied	\N	\N	\N	\N	114468	114468	282175
14097	16637	4	applied	\N	\N	\N	\N	114469	114469	282176
14097	16638	5	applied	\N	\N	\N	\N	114470	114470	282177
14097	16640	6	applied	\N	\N	\N	\N	114471	114471	282178
14097	16641	7	applied	\N	\N	\N	\N	114472	114472	282179
14097	16642	8	applied	\N	\N	\N	\N	114473	114473	282180
14098	16639	0	applied	\N	\N	\N	\N	114474	114474	282181
14098	16632	1	applied	\N	\N	\N	\N	114475	114475	282182
14098	16633	2	applied	\N	\N	\N	\N	114476	114476	282183
14098	16637	4	applied	\N	\N	\N	\N	114478	114478	282185
14098	16638	5	applied	\N	\N	\N	\N	114479	114479	282186
14098	16640	6	applied	\N	\N	\N	\N	114480	114480	282187
14098	16641	7	applied	\N	\N	\N	\N	114481	114481	282188
14098	16642	8	applied	\N	\N	\N	\N	114482	114482	282189
14100	16643	0	applied	\N	\N	\N	\N	114484	114484	282191
14100	16644	1	applied	\N	\N	\N	\N	114485	114485	282192
14100	16645	2	applied	\N	\N	\N	\N	114486	114486	282193
14100	16646	3	applied	\N	\N	\N	\N	114487	114487	282194
14103	16636	1	applied	\N	\N	\N	\N	114495	114495	282201
14103	16586	2	applied	\N	\N	\N	\N	114496	114496	282202
14103	16529	3	applied	\N	\N	\N	\N	114497	114497	282203
14103	16568	4	applied	\N	\N	\N	\N	114498	114498	282204
14104	16650	0	applied	\N	\N	\N	\N	114499	114499	282205
14104	16651	1	applied	\N	\N	\N	\N	114500	114500	282206
14104	16652	2	applied	\N	\N	\N	\N	114501	114501	282207
14104	16653	3	applied	\N	\N	\N	\N	114502	114502	282208
14105	16650	0	applied	\N	\N	\N	\N	114503	114503	282209
14109	16654	0	applied	\N	\N	\N	\N	114516	114516	282222
14109	16658	1	applied	\N	\N	\N	\N	114517	114517	282223
14109	16655	2	applied	\N	\N	\N	\N	114518	114518	282224
14109	16656	3	applied	\N	\N	\N	\N	114519	114519	282225
14109	16657	4	applied	\N	\N	\N	\N	114520	114520	282226
14111	16658	0	applied	\N	\N	\N	\N	114527	114527	282233
14111	16659	1	applied	\N	\N	\N	\N	114528	114528	282234
14111	16660	2	applied	\N	\N	\N	\N	114529	114529	282235
14111	16661	3	applied	\N	\N	\N	\N	114530	114530	282236
14113	16658	0	applied	\N	\N	\N	\N	114535	114535	282241
14115	16662	0	applied	\N	\N	\N	\N	114536	114536	282242
14115	16663	1	applied	\N	\N	\N	\N	114537	114537	282243
14115	16664	2	applied	\N	\N	\N	\N	114538	114538	282244
14115	16659	3	applied	\N	\N	\N	\N	114539	114539	282245
14115	16660	4	applied	\N	\N	\N	\N	114540	114540	282246
14115	16661	5	applied	\N	\N	\N	\N	114541	114541	282247
14115	16665	6	applied	\N	\N	\N	\N	114542	114542	282248
14115	16666	7	applied	\N	\N	\N	\N	114543	114543	282249
14115	16667	8	applied	\N	\N	\N	\N	114544	114544	282250
14115	16668	9	applied	\N	\N	\N	\N	114545	114545	282251
14115	16669	10	applied	\N	\N	\N	\N	114546	114546	282252
14115	16670	11	applied	\N	\N	\N	\N	114547	114547	282253
14115	16672	13	applied	\N	\N	\N	\N	114549	114549	282255
14115	16673	14	applied	\N	\N	\N	\N	114550	114550	282256
14116	16674	0	applied	\N	\N	\N	\N	114551	114551	282257
14116	16675	1	applied	\N	\N	\N	\N	114552	114552	282258
14116	16676	2	applied	\N	\N	\N	\N	114553	114553	282259
14116	16677	3	applied	\N	\N	\N	\N	114554	114554	282260
14118	16682	0	applied	\N	\N	\N	\N	114559	114559	282265
14118	16683	1	applied	\N	\N	\N	\N	114560	114560	282266
14118	16684	2	applied	\N	\N	\N	\N	114561	114561	282267
14118	16685	3	applied	\N	\N	\N	\N	114562	114562	282268
14123	16686	0	applied	\N	\N	\N	\N	114576	114576	282282
14123	16687	1	applied	\N	\N	\N	\N	114577	114577	282283
14123	16688	2	applied	\N	\N	\N	\N	114578	114578	282284
14123	16689	3	applied	\N	\N	\N	\N	114579	114579	282285
14125	16690	0	applied	\N	\N	\N	\N	114580	114580	282286
14125	16691	1	applied	\N	\N	\N	\N	114581	114581	282287
14125	16693	3	applied	\N	\N	\N	\N	114583	114583	282289
14129	16662	0	applied	\N	\N	\N	\N	114594	114594	282300
14129	16663	1	applied	\N	\N	\N	\N	114595	114595	282301
14129	16664	2	applied	\N	\N	\N	\N	114596	114596	282302
14129	16674	3	applied	\N	\N	\N	\N	114597	114597	282303
14129	16678	4	applied	\N	\N	\N	\N	114598	114598	282304
14129	16682	5	applied	\N	\N	\N	\N	114599	114599	282305
14129	16686	6	applied	\N	\N	\N	\N	114600	114600	282306
14129	16690	7	applied	\N	\N	\N	\N	114601	114601	282307
14129	16659	8	applied	\N	\N	\N	\N	114602	114602	282308
14129	16660	9	applied	\N	\N	\N	\N	114603	114603	282309
14129	16661	10	applied	\N	\N	\N	\N	114604	114604	282310
14129	16665	11	applied	\N	\N	\N	\N	114605	114605	282311
14052	16571	4	applied	\N	\N	\N	\N	114291	114291	282000
14059	16584	0	applied	\N	\N	\N	\N	114316	114316	282025
14084	16618	2	applied	\N	\N	1000000000	\N	114395	114395	282102
14084	16619	3	applied	\N	\N	1000000000	\N	114396	114396	282103
14084	16620	4	applied	\N	\N	\N	\N	114397	114397	282104
14084	16621	5	applied	\N	\N	\N	\N	114398	114398	282105
14091	16631	0	applied	\N	\N	\N	\N	114440	114440	282147
14091	16633	2	applied	\N	\N	\N	\N	114442	114442	282149
14091	16634	3	applied	\N	\N	\N	\N	114443	114443	282150
14095	16635	0	applied	\N	\N	\N	\N	114451	114451	282158
14095	16636	1	applied	\N	\N	\N	\N	114452	114452	282159
14095	16632	2	applied	\N	\N	\N	\N	114453	114453	282160
14095	16633	3	applied	\N	\N	\N	\N	114454	114454	282161
14095	16634	4	applied	\N	\N	\N	\N	114455	114455	282162
14095	16637	5	applied	\N	\N	\N	\N	114456	114456	282163
14095	16638	6	applied	\N	\N	\N	\N	114457	114457	282164
14099	16643	0	applied	\N	\N	\N	\N	114483	114483	282190
14108	16654	0	applied	\N	\N	\N	\N	114512	114512	282218
14108	16655	1	applied	\N	\N	\N	\N	114513	114513	282219
14108	16656	2	applied	\N	\N	\N	\N	114514	114514	282220
14108	16657	3	applied	\N	\N	\N	\N	114515	114515	282221
14117	16678	0	applied	\N	\N	\N	\N	114555	114555	282261
14117	16679	1	applied	\N	\N	\N	\N	114556	114556	282262
14117	16681	3	applied	\N	\N	\N	\N	114558	114558	282264
14120	16682	0	applied	\N	\N	\N	\N	114567	114567	282273
14122	16686	0	applied	\N	\N	\N	\N	114572	114572	282278
14122	16687	1	applied	\N	\N	\N	\N	114573	114573	282279
14122	16688	2	applied	\N	\N	\N	\N	114574	114574	282280
14122	16689	3	applied	\N	\N	\N	\N	114575	114575	282281
14127	16691	0	applied	\N	\N	\N	\N	114588	114588	282294
14127	16692	1	applied	\N	\N	\N	\N	114589	114589	282295
14127	16693	2	applied	\N	\N	\N	\N	114590	114590	282296
14131	16694	0	applied	\N	\N	\N	\N	114635	114635	282341
14131	16695	1	applied	\N	\N	\N	\N	114636	114636	282342
14131	16696	2	applied	\N	\N	\N	\N	114637	114637	282343
14131	16697	3	applied	\N	\N	\N	\N	114638	114638	282344
14131	16698	4	applied	\N	\N	\N	\N	114639	114639	282345
14131	16699	5	applied	\N	\N	\N	\N	114640	114640	282346
14131	16700	6	applied	\N	\N	\N	\N	114641	114641	282347
14131	16702	9	applied	\N	\N	\N	\N	114643	114643	282349
14131	16703	10	applied	\N	\N	\N	\N	114644	114644	282350
14131	16704	11	applied	\N	\N	\N	\N	114645	114645	282351
14134	16694	0	applied	\N	\N	\N	\N	114668	114668	282374
14134	16695	1	applied	\N	\N	\N	\N	114669	114669	282375
14134	16696	2	applied	\N	\N	\N	\N	114670	114670	282376
14134	16697	3	applied	\N	\N	\N	\N	114671	114671	282377
14134	16698	4	applied	\N	\N	\N	\N	114672	114672	282378
14134	16699	5	applied	\N	\N	\N	\N	114673	114673	282379
14134	16700	6	applied	\N	\N	\N	\N	114674	114674	282380
14134	16701	8	applied	\N	\N	\N	\N	114675	114675	282381
14134	16702	9	applied	\N	\N	\N	\N	114676	114676	282382
14134	16703	10	applied	\N	\N	\N	\N	114677	114677	282383
14134	16704	11	applied	\N	\N	\N	\N	114678	114678	282384
14137	16694	0	applied	\N	\N	\N	\N	114693	114693	282399
14137	16695	1	applied	\N	\N	\N	\N	114694	114694	282400
14137	16705	3	applied	\N	\N	\N	\N	114696	114696	282402
14137	16693	4	applied	\N	\N	\N	\N	114697	114697	282403
14137	16697	5	applied	\N	\N	\N	\N	114698	114698	282404
14137	16698	6	applied	\N	\N	\N	\N	114699	114699	282405
14137	16699	7	applied	\N	\N	\N	\N	114700	114700	282406
14137	16700	8	applied	\N	\N	\N	\N	114701	114701	282407
14137	16701	9	applied	\N	\N	\N	\N	114702	114702	282408
14137	16702	10	applied	\N	\N	\N	\N	114703	114703	282409
14137	16703	11	applied	\N	\N	\N	\N	114704	114704	282410
14137	16704	12	applied	\N	\N	\N	\N	114705	114705	282411
14137	16706	13	applied	\N	\N	\N	\N	114706	114706	282412
14137	16707	14	applied	\N	\N	\N	\N	114707	114707	282413
14140	16460	0	applied	\N	\N	\N	\N	114717	114717	282423
14140	16474	1	applied	\N	\N	\N	\N	114718	114718	282424
14140	16069	3	applied	\N	\N	\N	\N	114720	114720	282425
14140	16319	4	applied	\N	\N	\N	\N	114721	114721	282426
14140	16355	5	applied	\N	\N	\N	\N	114722	114722	282427
14140	16070	6	applied	\N	\N	\N	\N	114723	114723	282428
14140	16077	7	applied	\N	\N	\N	\N	114724	114724	282429
14140	16081	8	applied	\N	\N	\N	\N	114725	114725	282430
14140	16085	9	applied	\N	\N	\N	\N	114726	114726	282431
14141	16708	0	applied	\N	\N	\N	\N	114842	114842	282547
14141	16709	1	applied	\N	\N	\N	\N	114843	114843	282548
14141	16710	2	applied	\N	\N	\N	\N	114844	114844	282549
14141	16711	3	applied	\N	\N	\N	\N	114845	114845	282550
14141	16712	4	applied	\N	\N	\N	\N	114846	114846	282551
14141	16713	5	applied	\N	\N	\N	\N	114847	114847	282552
14145	16705	0	applied	\N	\N	\N	\N	114866	114866	282571
14145	16708	1	applied	\N	\N	\N	\N	114867	114867	282572
14145	16709	2	applied	\N	\N	\N	\N	114868	114868	282573
14145	16706	3	applied	\N	\N	\N	\N	114869	114869	282574
14145	16707	4	applied	\N	\N	\N	\N	114870	114870	282575
14145	16710	5	applied	\N	\N	\N	\N	114871	114871	282576
14145	16711	6	applied	\N	\N	\N	\N	114872	114872	282577
14145	16712	7	applied	\N	\N	\N	\N	114873	114873	282578
14145	16713	8	applied	\N	\N	\N	\N	114874	114874	282579
14146	16714	0	applied	\N	\N	\N	\N	114875	114875	282580
14146	16715	1	applied	\N	\N	\N	\N	114876	114876	282581
14146	16716	2	applied	\N	\N	\N	\N	114877	114877	282582
14149	16714	0	applied	\N	\N	\N	\N	114882	114882	282587
14149	16716	2	applied	\N	\N	\N	\N	114884	114884	282589
14153	16720	0	applied	\N	\N	\N	\N	114892	114892	282597
14153	16721	1	applied	\N	\N	\N	\N	114893	114893	282598
14153	16718	2	applied	\N	\N	\N	\N	114894	114894	282599
14153	16719	3	applied	\N	\N	\N	\N	114895	114895	282600
14153	16722	4	applied	\N	\N	\N	\N	114896	114896	282601
14153	16723	5	applied	\N	\N	\N	\N	114897	114897	282602
14153	16724	6	applied	\N	\N	\N	\N	114898	114898	282603
14153	16725	7	applied	\N	\N	\N	\N	114899	114899	282604
14162	16733	0	applied	\N	\N	\N	\N	114915	114915	282620
14165	16740	0	applied	\N	\N	\N	\N	114926	114926	282631
14165	16741	1	applied	\N	\N	\N	\N	114927	114927	282632
14165	16742	2	applied	\N	\N	\N	\N	114928	114928	282633
14170	16753	0	applied	\N	\N	\N	\N	114942	114942	282647
14170	16754	1	applied	\N	\N	\N	\N	114943	114943	282648
14170	16755	2	applied	\N	\N	\N	\N	114944	114944	282649
14084	16616	0	applied	\N	\N	\N	\N	114393	114393	282100
14084	16617	1	applied	\N	\N	\N	\N	114394	114394	282101
14088	16627	5	applied	\N	\N	\N	\N	114431	114431	282138
14088	16628	6	applied	\N	\N	\N	\N	114432	114432	282139
14088	16629	7	applied	\N	\N	\N	\N	114433	114433	282140
14088	16630	8	applied	\N	\N	\N	\N	114434	114434	282141
14090	16631	0	applied	\N	\N	\N	\N	114436	114436	282143
14090	16632	1	applied	\N	\N	\N	\N	114437	114437	282144
14090	16633	2	applied	\N	\N	\N	\N	114438	114438	282145
14090	16634	3	applied	\N	\N	\N	\N	114439	114439	282146
14093	16631	0	applied	\N	\N	\N	\N	114448	114448	282155
14094	16635	0	applied	\N	\N	\N	\N	114449	114449	282156
14094	16636	1	applied	\N	\N	\N	\N	114450	114450	282157
14096	16635	0	applied	\N	\N	\N	\N	114458	114458	282165
14096	16636	1	applied	\N	\N	\N	\N	114459	114459	282166
14096	16632	2	applied	\N	\N	\N	\N	114460	114460	282167
14096	16633	3	applied	\N	\N	\N	\N	114461	114461	282168
14096	16634	4	applied	\N	\N	\N	\N	114462	114462	282169
14096	16638	6	applied	\N	\N	\N	\N	114464	114464	282171
14102	16647	0	applied	\N	\N	\N	\N	114488	114488	282195
14102	16644	1	applied	\N	\N	\N	\N	114489	114489	282196
14102	16645	2	applied	\N	\N	\N	\N	114490	114490	282197
14102	16646	3	applied	\N	\N	\N	\N	114491	114491	282198
14102	16648	4	applied	\N	\N	\N	\N	114492	114492	282199
14102	16649	5	applied	\N	\N	\N	\N	114493	114493	282200
14106	16650	0	applied	\N	\N	\N	\N	114504	114504	282210
14106	16651	1	applied	\N	\N	\N	\N	114505	114505	282211
14106	16652	2	applied	\N	\N	\N	\N	114506	114506	282212
14106	16653	3	applied	\N	\N	\N	\N	114507	114507	282213
14107	16654	0	applied	\N	\N	\N	\N	114508	114508	282214
14107	16655	1	applied	\N	\N	\N	\N	114509	114509	282215
14107	16656	2	applied	\N	\N	\N	\N	114510	114510	282216
14107	16657	3	applied	\N	\N	\N	\N	114511	114511	282217
14110	16654	0	applied	\N	\N	\N	\N	114521	114521	282227
14110	16655	2	applied	\N	\N	\N	\N	114523	114523	282229
14110	16656	3	applied	\N	\N	\N	\N	114524	114524	282230
14110	16657	4	applied	\N	\N	\N	\N	114525	114525	282231
14110	16659	5	applied	\N	\N	\N	\N	114526	114526	282232
14112	16658	0	applied	\N	\N	\N	\N	114531	114531	282237
14112	16659	1	applied	\N	\N	\N	\N	114532	114532	282238
14112	16660	2	applied	\N	\N	\N	\N	114533	114533	282239
14112	16661	3	applied	\N	\N	\N	\N	114534	114534	282240
14119	16682	0	applied	\N	\N	\N	\N	114563	114563	282269
14119	16683	1	applied	\N	\N	\N	\N	114564	114564	282270
14119	16684	2	applied	\N	\N	\N	\N	114565	114565	282271
14119	16685	3	applied	\N	\N	\N	\N	114566	114566	282272
14121	16686	0	applied	\N	\N	\N	\N	114568	114568	282274
14121	16687	1	applied	\N	\N	\N	\N	114569	114569	282275
14121	16688	2	applied	\N	\N	\N	\N	114570	114570	282276
14121	16689	3	applied	\N	\N	\N	\N	114571	114571	282277
14126	16691	1	applied	\N	\N	\N	\N	114585	114585	282291
14126	16692	2	applied	\N	\N	\N	\N	114586	114586	282292
14126	16693	3	applied	\N	\N	\N	\N	114587	114587	282293
14128	16690	0	applied	\N	\N	\N	\N	114591	114591	282297
14128	16691	1	applied	\N	\N	\N	\N	114592	114592	282298
14128	16692	2	applied	\N	\N	\N	\N	114593	114593	282299
14130	16694	0	applied	\N	\N	\N	\N	114628	114628	282334
14130	16695	1	applied	\N	\N	\N	\N	114629	114629	282335
14130	16696	2	applied	\N	\N	\N	\N	114630	114630	282336
14130	16697	3	applied	\N	\N	\N	\N	114631	114631	282337
14130	16698	4	applied	\N	\N	\N	\N	114632	114632	282338
14130	16699	5	applied	\N	\N	\N	\N	114633	114633	282339
14130	16700	6	applied	\N	\N	\N	\N	114634	114634	282340
14133	16694	0	applied	\N	\N	\N	\N	114657	114657	282363
14133	16695	1	applied	\N	\N	\N	\N	114658	114658	282364
14133	16696	2	applied	\N	\N	\N	\N	114659	114659	282365
14133	16698	4	applied	\N	\N	\N	\N	114661	114661	282367
14133	16699	5	applied	\N	\N	\N	\N	114662	114662	282368
14133	16700	6	applied	\N	\N	\N	\N	114663	114663	282369
14133	16701	8	applied	\N	\N	\N	\N	114664	114664	282370
14133	16702	9	applied	\N	\N	\N	\N	114665	114665	282371
14133	16703	10	applied	\N	\N	\N	\N	114666	114666	282372
14133	16704	11	applied	\N	\N	\N	\N	114667	114667	282373
14136	16705	0	applied	\N	\N	\N	\N	114690	114690	282396
14136	16706	1	applied	\N	\N	\N	\N	114691	114691	282397
14136	16707	2	applied	\N	\N	\N	\N	114692	114692	282398
14139	16708	0	applied	\N	\N	\N	\N	114711	114711	282417
14140	16089	10	applied	\N	\N	\N	\N	114727	114727	282432
14140	16093	11	applied	\N	\N	\N	\N	114728	114728	282433
14140	16097	12	applied	\N	\N	\N	\N	114729	114729	282434
14140	16101	13	applied	\N	\N	\N	\N	114730	114730	282435
14140	16108	14	applied	\N	\N	\N	\N	114731	114731	282436
14140	16116	16	applied	\N	\N	\N	\N	114733	114733	282438
14140	16120	17	applied	\N	\N	\N	\N	114734	114734	282439
14140	16121	18	applied	\N	\N	\N	\N	114735	114735	282440
14140	16127	19	applied	\N	\N	\N	\N	114736	114736	282441
14140	16128	20	applied	\N	\N	\N	\N	114737	114737	282442
14140	16129	21	applied	\N	\N	\N	\N	114738	114738	282443
14140	16140	22	applied	\N	\N	\N	\N	114739	114739	282444
14140	16141	23	applied	\N	\N	\N	\N	114740	114740	282445
14140	16148	24	applied	\N	\N	\N	\N	114741	114741	282446
14140	16149	25	applied	\N	\N	\N	\N	114742	114742	282447
14140	16156	26	applied	\N	\N	\N	\N	114743	114743	282448
14140	16157	27	applied	\N	\N	\N	\N	114744	114744	282449
14140	16164	28	applied	\N	\N	\N	\N	114745	114745	282450
14140	16167	29	applied	\N	\N	\N	\N	114746	114746	282451
14140	16171	30	applied	\N	\N	\N	\N	114747	114747	282452
14140	16175	31	applied	\N	\N	\N	\N	114748	114748	282453
14140	16177	33	applied	\N	\N	\N	\N	114750	114750	282455
14140	16187	34	applied	\N	\N	\N	\N	114751	114751	282456
14140	16188	35	applied	\N	\N	\N	\N	114752	114752	282457
14140	16189	36	applied	\N	\N	\N	\N	114753	114753	282458
14140	16190	37	applied	\N	\N	\N	\N	114754	114754	282459
14140	16191	38	applied	\N	\N	\N	\N	114755	114755	282460
14140	16206	39	applied	\N	\N	\N	\N	114756	114756	282461
14140	16210	40	applied	\N	\N	\N	\N	114757	114757	282462
14140	16214	41	applied	\N	\N	\N	\N	114758	114758	282463
14140	16215	42	applied	\N	\N	\N	\N	114759	114759	282464
14140	16222	43	applied	\N	\N	\N	\N	114760	114760	282465
14140	16226	44	applied	\N	\N	\N	\N	114761	114761	282466
14140	16230	45	applied	\N	\N	\N	\N	114762	114762	282467
14140	16231	46	applied	\N	\N	\N	\N	114763	114763	282468
14088	16624	2	applied	\N	\N	\N	\N	114428	114428	282135
14088	16625	3	applied	\N	\N	\N	\N	114429	114429	282136
14129	16670	16	applied	\N	\N	\N	\N	114610	114610	282316
14129	16671	17	applied	\N	\N	\N	\N	114611	114611	282317
14129	16672	18	applied	\N	\N	\N	\N	114612	114612	282318
14129	16673	19	applied	\N	\N	\N	\N	114613	114613	282319
14129	16675	20	applied	\N	\N	\N	\N	114614	114614	282320
14129	16676	21	applied	\N	\N	\N	\N	114615	114615	282321
14129	16677	22	applied	\N	\N	\N	\N	114616	114616	282322
14129	16679	23	applied	\N	\N	\N	\N	114617	114617	282323
14129	16680	24	applied	\N	\N	\N	\N	114618	114618	282324
14129	16681	25	applied	\N	\N	\N	\N	114619	114619	282325
14129	16683	26	applied	\N	\N	\N	\N	114620	114620	282326
14129	16684	27	applied	\N	\N	\N	\N	114621	114621	282327
14129	16685	28	applied	\N	\N	\N	\N	114622	114622	282328
14129	16687	29	applied	\N	\N	\N	\N	114623	114623	282329
14129	16689	31	applied	\N	\N	\N	\N	114625	114625	282331
14129	16691	32	applied	\N	\N	\N	\N	114626	114626	282332
14129	16692	33	applied	\N	\N	\N	\N	114627	114627	282333
14132	16694	0	applied	\N	\N	\N	\N	114646	114646	282352
14132	16695	1	applied	\N	\N	\N	\N	114647	114647	282353
14132	16696	2	applied	\N	\N	\N	\N	114648	114648	282354
14132	16697	3	applied	\N	\N	\N	\N	114649	114649	282355
14132	16698	4	applied	\N	\N	\N	\N	114650	114650	282356
14132	16699	5	applied	\N	\N	\N	\N	114651	114651	282357
14132	16700	6	applied	\N	\N	\N	\N	114652	114652	282358
14132	16701	8	applied	\N	\N	\N	\N	114653	114653	282359
14132	16702	9	applied	\N	\N	\N	\N	114654	114654	282360
14132	16703	10	applied	\N	\N	\N	\N	114655	114655	282361
14132	16704	11	applied	\N	\N	\N	\N	114656	114656	282362
14135	16694	0	applied	\N	\N	\N	\N	114679	114679	282385
14135	16695	1	applied	\N	\N	\N	\N	114680	114680	282386
14135	16697	3	applied	\N	\N	\N	\N	114682	114682	282388
14135	16698	4	applied	\N	\N	\N	\N	114683	114683	282389
14135	16699	5	applied	\N	\N	\N	\N	114684	114684	282390
14135	16700	6	applied	\N	\N	\N	\N	114685	114685	282391
14135	16701	8	applied	\N	\N	\N	\N	114686	114686	282392
14135	16702	9	applied	\N	\N	\N	\N	114687	114687	282393
14135	16703	10	applied	\N	\N	\N	\N	114688	114688	282394
14135	16704	11	applied	\N	\N	\N	\N	114689	114689	282395
14138	16705	0	applied	\N	\N	\N	\N	114708	114708	282414
14138	16706	1	applied	\N	\N	\N	\N	114709	114709	282415
14138	16707	2	applied	\N	\N	\N	\N	114710	114710	282416
14139	16709	1	applied	\N	\N	\N	\N	114712	114712	282418
14139	16710	2	applied	\N	\N	\N	\N	114713	114713	282419
14139	16711	3	applied	\N	\N	\N	\N	114714	114714	282420
14139	16712	4	applied	\N	\N	\N	\N	114715	114715	282421
14139	16713	5	applied	\N	\N	\N	\N	114716	114716	282422
14142	16709	1	applied	\N	\N	\N	\N	114849	114849	282554
14142	16710	2	applied	\N	\N	\N	\N	114850	114850	282555
14142	16711	3	applied	\N	\N	\N	\N	114851	114851	282556
14142	16712	4	applied	\N	\N	\N	\N	114852	114852	282557
14142	16713	5	applied	\N	\N	\N	\N	114853	114853	282558
14143	16708	0	applied	\N	\N	\N	\N	114854	114854	282559
14143	16709	1	applied	\N	\N	\N	\N	114855	114855	282560
14143	16710	2	applied	\N	\N	\N	\N	114856	114856	282561
14143	16711	3	applied	\N	\N	\N	\N	114857	114857	282562
14143	16712	4	applied	\N	\N	\N	\N	114858	114858	282563
14143	16713	5	applied	\N	\N	\N	\N	114859	114859	282564
14144	16708	0	applied	\N	\N	\N	\N	114860	114860	282565
14144	16709	1	applied	\N	\N	\N	\N	114861	114861	282566
14144	16710	2	applied	\N	\N	\N	\N	114862	114862	282567
14144	16711	3	applied	\N	\N	\N	\N	114863	114863	282568
14144	16712	4	applied	\N	\N	\N	\N	114864	114864	282569
14147	16714	0	applied	\N	\N	\N	\N	114878	114878	282583
14147	16715	1	applied	\N	\N	\N	\N	114879	114879	282584
14147	16716	2	applied	\N	\N	\N	\N	114880	114880	282585
14150	16714	0	applied	\N	\N	\N	\N	114885	114885	282590
14150	16715	1	applied	\N	\N	\N	\N	114886	114886	282591
14150	16716	2	applied	\N	\N	\N	\N	114887	114887	282592
14151	16717	0	applied	\N	\N	\N	\N	114888	114888	282593
14151	16718	1	applied	\N	\N	\N	\N	114889	114889	282594
14151	16719	2	applied	\N	\N	\N	\N	114890	114890	282595
14154	16726	0	applied	\N	\N	\N	\N	114900	114900	282605
14154	16727	1	applied	\N	\N	\N	\N	114901	114901	282606
14154	16728	2	applied	\N	\N	\N	\N	114902	114902	282607
14157	16726	0	applied	\N	\N	\N	\N	114903	114903	282608
14157	16727	1	applied	\N	\N	\N	\N	114904	114904	282609
14157	16728	2	applied	\N	\N	\N	\N	114905	114905	282610
14160	16729	0	applied	\N	\N	\N	\N	114909	114909	282614
14160	16731	2	applied	\N	\N	\N	\N	114911	114911	282616
14163	16732	0	applied	\N	\N	\N	\N	114916	114916	282621
14163	16735	1	applied	\N	\N	\N	\N	114917	114917	282622
14163	16734	2	applied	\N	\N	\N	\N	114918	114918	282623
14163	16736	3	applied	\N	\N	\N	\N	114919	114919	282624
14163	16737	4	applied	\N	\N	\N	\N	114920	114920	282625
14163	16738	5	applied	\N	\N	\N	\N	114921	114921	282626
14163	16739	6	applied	\N	\N	\N	\N	114922	114922	282627
14166	16740	0	applied	\N	\N	\N	\N	114929	114929	282634
14166	16741	1	applied	\N	\N	\N	\N	114930	114930	282635
14166	16742	2	applied	\N	\N	\N	\N	114931	114931	282636
14167	16743	0	applied	\N	\N	\N	\N	114932	114932	282637
14167	16744	1	applied	\N	\N	\N	\N	114933	114933	282638
14167	16745	2	applied	\N	\N	\N	\N	114934	114934	282639
14168	16746	0	applied	\N	\N	\N	\N	114935	114935	282640
14168	16747	1	applied	\N	\N	\N	\N	114936	114936	282641
14168	16749	3	applied	\N	\N	\N	\N	114938	114938	282643
14168	16750	4	applied	\N	\N	\N	\N	114939	114939	282644
14168	16751	5	applied	\N	\N	\N	\N	114940	114940	282645
14171	16763	0	applied	\N	\N	\N	\N	114952	114952	282657
14173	16767	0	applied	\N	\N	\N	\N	114960	114960	282665
14173	16768	1	applied	\N	\N	\N	\N	114961	114961	282666
14173	16769	2	applied	\N	\N	1000000000	\N	114962	114962	282667
14173	16770	3	applied	\N	\N	\N	\N	114963	114963	282668
14173	16771	4	applied	\N	\N	\N	\N	114964	114964	282669
14176	16772	0	applied	\N	\N	\N	\N	114975	114975	282680
14176	16773	1	applied	\N	\N	\N	\N	114976	114976	282681
14176	16774	2	applied	\N	\N	\N	\N	114977	114977	282682
14176	16775	3	applied	\N	\N	\N	\N	114978	114978	282683
14176	16776	4	applied	\N	\N	\N	\N	114979	114979	282684
14176	16777	5	applied	\N	\N	\N	\N	114980	114980	282685
14176	16778	6	applied	\N	\N	\N	\N	114981	114981	282686
14129	16669	15	applied	\N	\N	\N	\N	114609	114609	282315
14140	16250	51	applied	\N	\N	\N	\N	114768	114768	282473
14140	16251	52	applied	\N	\N	\N	\N	114769	114769	282474
14140	16260	53	applied	\N	\N	\N	\N	114770	114770	282475
14140	16264	54	applied	\N	\N	\N	\N	114771	114771	282476
14140	16268	55	applied	\N	\N	\N	\N	114772	114772	282477
14140	16272	56	applied	\N	\N	\N	\N	114773	114773	282478
14140	16276	57	applied	\N	\N	\N	\N	114774	114774	282479
14140	16280	58	applied	\N	\N	\N	\N	114775	114775	282480
14140	16284	59	applied	\N	\N	\N	\N	114776	114776	282481
14140	16288	60	applied	\N	\N	\N	\N	114777	114777	282482
14140	16292	61	applied	\N	\N	\N	\N	114778	114778	282483
14140	16299	62	applied	\N	\N	\N	\N	114779	114779	282484
14140	16300	63	applied	\N	\N	\N	\N	114780	114780	282485
14140	16306	64	applied	\N	\N	\N	\N	114781	114781	282486
14140	16310	65	applied	\N	\N	\N	\N	114782	114782	282487
14140	16311	66	applied	\N	\N	\N	\N	114783	114783	282488
14140	16320	68	applied	\N	\N	\N	\N	114785	114785	282490
14140	16321	69	applied	\N	\N	\N	\N	114786	114786	282491
14140	16322	70	applied	\N	\N	\N	\N	114787	114787	282492
14140	16323	71	applied	\N	\N	\N	\N	114788	114788	282493
14140	16324	72	applied	\N	\N	\N	\N	114789	114789	282494
14140	16325	73	applied	\N	\N	\N	\N	114790	114790	282495
14140	16347	74	applied	\N	\N	\N	\N	114791	114791	282496
14140	16351	75	applied	\N	\N	\N	\N	114792	114792	282497
14140	16356	76	applied	\N	\N	\N	\N	114793	114793	282498
14140	16357	77	applied	\N	\N	\N	\N	114794	114794	282499
14140	16364	78	applied	\N	\N	\N	\N	114795	114795	282500
14140	16365	79	applied	\N	\N	\N	\N	114796	114796	282501
14140	16372	80	applied	\N	\N	\N	\N	114797	114797	282502
14140	16376	81	applied	\N	\N	\N	\N	114798	114798	282503
14140	16377	82	applied	\N	\N	\N	\N	114799	114799	282504
14140	16378	84	applied	\N	\N	\N	\N	114800	114800	282505
14140	16389	86	applied	\N	\N	\N	\N	114802	114802	282507
14140	16396	87	applied	\N	\N	\N	\N	114803	114803	282508
14140	16400	88	applied	\N	\N	\N	\N	114804	114804	282509
14140	16406	89	applied	\N	\N	\N	\N	114805	114805	282510
14140	16410	90	applied	\N	\N	\N	\N	114806	114806	282511
14140	16414	91	applied	\N	\N	\N	\N	114807	114807	282512
14140	16415	92	applied	\N	\N	\N	\N	114808	114808	282513
14140	16422	93	applied	\N	\N	\N	\N	114809	114809	282514
14140	16426	94	applied	\N	\N	\N	\N	114810	114810	282515
14140	16431	95	applied	\N	\N	\N	\N	114811	114811	282516
14140	16432	96	applied	\N	\N	\N	\N	114812	114812	282517
14140	16440	97	applied	\N	\N	\N	\N	114813	114813	282518
14140	16445	98	applied	\N	\N	\N	\N	114814	114814	282519
14140	16446	99	applied	\N	\N	\N	\N	114815	114815	282520
14140	16447	100	applied	\N	\N	\N	\N	114816	114816	282521
14140	16457	101	applied	\N	\N	\N	\N	114817	114817	282522
14140	16461	103	applied	\N	\N	\N	\N	114819	114819	282524
14140	16462	104	applied	\N	\N	\N	\N	114820	114820	282525
14140	16475	105	applied	\N	\N	\N	\N	114821	114821	282526
14140	16476	106	applied	\N	\N	\N	\N	114822	114822	282527
14140	16477	107	applied	\N	\N	\N	\N	114823	114823	282528
14140	16487	108	applied	\N	\N	\N	\N	114824	114824	282529
14140	16491	109	applied	\N	\N	\N	\N	114825	114825	282530
14140	16496	110	applied	\N	\N	\N	\N	114826	114826	282531
14140	16499	111	applied	\N	\N	\N	\N	114827	114827	282532
14140	16504	112	applied	\N	\N	\N	\N	114828	114828	282533
14140	16509	113	applied	\N	\N	\N	\N	114829	114829	282534
14140	16514	114	applied	\N	\N	\N	\N	114830	114830	282535
14140	16516	115	applied	\N	\N	\N	\N	114831	114831	282536
14140	16517	116	applied	\N	\N	\N	\N	114832	114832	282537
14140	16525	117	applied	\N	\N	\N	\N	114833	114833	282538
14140	16530	118	applied	\N	\N	\N	\N	114834	114834	282539
14140	16537	120	applied	\N	\N	\N	\N	114836	114836	282541
14140	16540	121	applied	\N	\N	\N	\N	114837	114837	282542
14140	16541	122	applied	\N	\N	\N	\N	114838	114838	282543
14140	16546	123	applied	\N	\N	\N	\N	114839	114839	282544
14140	16547	124	applied	\N	\N	\N	\N	114840	114840	282545
14140	16554	125	applied	\N	\N	\N	\N	114841	114841	282546
14148	16715	0	applied	\N	\N	\N	\N	114881	114881	282586
14152	16717	0	applied	\N	\N	\N	\N	114891	114891	282596
14159	16729	0	applied	\N	\N	\N	\N	114906	114906	282611
14159	16730	1	applied	\N	\N	\N	\N	114907	114907	282612
14159	16731	2	applied	\N	\N	\N	\N	114908	114908	282613
14176	16779	7	applied	\N	\N	\N	\N	114982	114982	282687
14179	16780	0	applied	\N	\N	\N	\N	114985	114985	282690
14179	16781	1	applied	\N	\N	\N	\N	114986	114986	282691
14179	16782	2	applied	\N	\N	\N	\N	114987	114987	282692
14179	16783	3	applied	\N	\N	\N	\N	114988	114988	282693
14179	16785	5	applied	\N	\N	\N	\N	114990	114990	282695
14183	16780	0	applied	\N	\N	\N	\N	115005	115005	282710
14183	16781	1	applied	\N	\N	\N	\N	115006	115006	282711
14183	16782	2	applied	\N	\N	\N	\N	115007	115007	282712
14183	16783	3	applied	\N	\N	\N	\N	115008	115008	282713
14183	16784	4	applied	\N	\N	\N	\N	115009	115009	282714
14183	16785	5	applied	\N	\N	\N	\N	115010	115010	282715
14187	16790	0	applied	\N	\N	\N	\N	115023	115023	282728
14189	16792	0	applied	\N	\N	\N	\N	115030	115030	282735
14189	16791	1	applied	\N	\N	\N	\N	115031	115031	282736
14189	16793	2	applied	\N	\N	\N	\N	115032	115032	282737
14189	16794	3	applied	\N	\N	\N	\N	115033	115033	282738
14193	16795	0	applied	\N	\N	\N	\N	115043	115043	282748
14193	16796	1	applied	\N	\N	\N	\N	115044	115044	282749
14193	16797	2	applied	\N	\N	\N	\N	115045	115045	282750
14193	16798	3	applied	\N	\N	\N	\N	115046	115046	282751
14199	16810	1	applied	\N	\N	\N	\N	115064	115064	282769
14199	16811	2	applied	\N	\N	\N	\N	115065	115065	282770
14202	16821	0	applied	\N	\N	\N	\N	115075	115075	282780
14202	16822	1	applied	\N	\N	\N	\N	115076	115076	282781
14202	16823	2	applied	\N	\N	\N	\N	115077	115077	282782
14202	16824	3	applied	\N	\N	\N	\N	115078	115078	282783
14202	16825	4	applied	\N	\N	\N	\N	115079	115079	282784
14202	16826	5	applied	\N	\N	\N	\N	115080	115080	282785
14207	16838	0	applied	\N	\N	\N	\N	115108	115108	282813
14207	16839	1	applied	\N	\N	\N	\N	115109	115109	282814
14207	16840	2	applied	\N	\N	\N	\N	115110	115110	282815
14207	16841	3	applied	\N	\N	\N	\N	115111	115111	282816
14210	16846	0	applied	\N	\N	\N	\N	115120	115120	282825
14210	16847	1	applied	\N	\N	\N	\N	115121	115121	282826
14140	16242	48	applied	\N	\N	\N	\N	114765	114765	282470
14140	16245	49	applied	\N	\N	\N	\N	114766	114766	282471
14164	16741	1	applied	\N	\N	\N	\N	114924	114924	282629
14164	16742	2	applied	\N	\N	\N	\N	114925	114925	282630
14169	16752	0	applied	\N	\N	\N	\N	114941	114941	282646
14170	16757	4	applied	\N	\N	\N	\N	114946	114946	282651
14170	16758	5	applied	\N	\N	\N	\N	114947	114947	282652
14170	16759	6	applied	\N	\N	\N	\N	114948	114948	282653
14170	16760	7	applied	\N	\N	\N	\N	114949	114949	282654
14170	16761	8	applied	\N	\N	\N	\N	114950	114950	282655
14170	16762	9	applied	\N	\N	\N	\N	114951	114951	282656
14172	16763	0	applied	\N	\N	\N	\N	114956	114956	282661
14172	16764	1	applied	\N	\N	\N	\N	114957	114957	282662
14172	16765	2	applied	\N	\N	\N	\N	114958	114958	282663
14172	16766	3	applied	\N	\N	\N	\N	114959	114959	282664
14175	16772	0	applied	\N	\N	\N	\N	114973	114973	282678
14175	16773	1	applied	\N	\N	\N	\N	114974	114974	282679
14178	16780	0	applied	\N	\N	\N	\N	114983	114983	282688
14181	16780	0	applied	\N	\N	\N	\N	114997	114997	282702
14181	16781	1	applied	\N	\N	\N	\N	114998	114998	282703
14182	16780	0	applied	\N	\N	\N	\N	114999	114999	282704
14182	16781	1	applied	\N	\N	\N	\N	115000	115000	282705
14182	16782	2	applied	\N	\N	\N	\N	115001	115001	282706
14182	16783	3	applied	\N	\N	\N	\N	115002	115002	282707
14182	16784	4	applied	\N	\N	\N	\N	115003	115003	282708
14182	16785	5	applied	\N	\N	\N	\N	115004	115004	282709
14184	16780	0	applied	\N	\N	\N	\N	115011	115011	282716
14184	16781	1	applied	\N	\N	\N	\N	115012	115012	282717
14185	16780	0	applied	\N	\N	\N	\N	115013	115013	282718
14185	16781	1	applied	\N	\N	\N	\N	115014	115014	282719
14186	16786	0	applied	\N	\N	\N	\N	115015	115015	282720
14186	16782	1	applied	\N	\N	\N	\N	115016	115016	282721
14186	16783	2	applied	\N	\N	\N	\N	115017	115017	282722
14186	16784	3	applied	\N	\N	\N	\N	115018	115018	282723
14186	16787	5	applied	\N	\N	\N	\N	115020	115020	282725
14186	16788	6	applied	\N	\N	\N	\N	115021	115021	282726
14186	16789	7	applied	\N	\N	\N	\N	115022	115022	282727
14191	16795	0	applied	\N	\N	\N	\N	115038	115038	282743
14191	16796	1	applied	\N	\N	\N	\N	115039	115039	282744
14191	16797	2	applied	\N	\N	\N	\N	115040	115040	282745
14191	16798	3	applied	\N	\N	\N	\N	115041	115041	282746
14192	16795	0	applied	\N	\N	\N	\N	115042	115042	282747
14194	16795	0	applied	\N	\N	\N	\N	115047	115047	282752
14194	16796	1	applied	\N	\N	\N	\N	115048	115048	282753
14194	16797	2	applied	\N	\N	\N	\N	115049	115049	282754
14194	16798	3	applied	\N	\N	\N	\N	115050	115050	282755
14195	16795	0	applied	\N	\N	\N	\N	115051	115051	282756
14196	16799	0	applied	\N	\N	\N	\N	115052	115052	282757
14196	16800	1	applied	\N	\N	\N	\N	115053	115053	282758
14196	16801	2	applied	\N	\N	\N	\N	115054	115054	282759
14196	16803	4	applied	\N	\N	\N	\N	115056	115056	282761
14196	16804	5	applied	\N	\N	\N	\N	115057	115057	282762
14198	16805	0	applied	\N	\N	\N	\N	115059	115059	282764
14198	16806	1	applied	\N	\N	\N	\N	115060	115060	282765
14198	16807	2	applied	\N	\N	\N	\N	115061	115061	282766
14198	16808	3	applied	\N	\N	\N	\N	115062	115062	282767
14201	16820	0	applied	\N	\N	\N	\N	115074	115074	282779
14204	16827	0	applied	\N	\N	\N	\N	115083	115083	282788
14204	16828	1	applied	\N	\N	\N	\N	115084	115084	282789
14204	16829	2	applied	\N	\N	\N	\N	115085	115085	282790
14204	16830	3	applied	\N	\N	\N	\N	115086	115086	282791
14204	16831	4	applied	\N	\N	\N	\N	115087	115087	282792
14204	16832	5	applied	\N	\N	\N	\N	115088	115088	282793
14204	16833	6	applied	\N	\N	\N	\N	115089	115089	282794
14204	16834	7	applied	\N	\N	\N	\N	115090	115090	282795
14205	16827	0	applied	\N	\N	\N	\N	115091	115091	282796
14205	16829	2	applied	\N	\N	\N	\N	115093	115093	282798
14205	16830	3	applied	\N	\N	\N	\N	115094	115094	282799
14205	16831	4	applied	\N	\N	\N	\N	115095	115095	282800
14205	16832	5	applied	\N	\N	\N	\N	115096	115096	282801
14205	16833	6	applied	\N	\N	\N	\N	115097	115097	282802
14205	16834	7	applied	\N	\N	\N	\N	115098	115098	282803
14206	16835	0	applied	\N	\N	\N	\N	115099	115099	282804
14206	16829	1	applied	\N	\N	\N	\N	115100	115100	282805
14206	16830	2	applied	\N	\N	\N	\N	115101	115101	282806
14206	16831	3	applied	\N	\N	\N	\N	115102	115102	282807
14206	16832	4	applied	\N	\N	\N	\N	115103	115103	282808
14206	16833	5	applied	\N	\N	\N	\N	115104	115104	282809
14206	16834	6	applied	\N	\N	\N	\N	115105	115105	282810
14206	16836	7	applied	\N	\N	\N	\N	115106	115106	282811
14206	16837	8	applied	\N	\N	\N	\N	115107	115107	282812
14208	16842	0	applied	\N	\N	\N	\N	115112	115112	282817
14209	16846	0	applied	\N	\N	\N	\N	115116	115116	282821
14209	16847	1	applied	\N	\N	\N	\N	115117	115117	282822
14209	16848	2	applied	\N	\N	\N	\N	115118	115118	282823
14209	16849	3	applied	\N	\N	\N	\N	115119	115119	282824
14211	16850	0	applied	\N	\N	\N	\N	115124	115124	282829
14211	16851	1	applied	\N	\N	\N	\N	115125	115125	282830
14211	16852	2	applied	\N	\N	\N	\N	115126	115126	282831
14211	16853	3	applied	\N	\N	\N	\N	115127	115127	282832
14216	16862	0	applied	\N	\N	\N	\N	115154	115154	282859
14216	16863	1	applied	\N	\N	\N	\N	115155	115155	282860
14216	16864	2	applied	\N	\N	\N	\N	115156	115156	282861
14216	16865	3	applied	\N	\N	\N	\N	115157	115157	282862
14219	16877	0	applied	\N	\N	\N	\N	115173	115173	282878
14219	16878	2	applied	\N	\N	\N	\N	115174	115174	282879
14219	16879	3	applied	\N	\N	\N	\N	115175	115175	282880
14219	16880	4	applied	\N	\N	\N	\N	115176	115176	282881
14224	16890	1	applied	\N	\N	\N	\N	115190	115190	282895
14224	16891	2	applied	\N	\N	\N	\N	115191	115191	282896
14224	16892	3	applied	\N	\N	\N	\N	115192	115192	282897
14226	16893	0	applied	\N	\N	\N	\N	115203	115203	282908
14226	16894	1	applied	\N	\N	\N	\N	115204	115204	282909
14226	16895	2	applied	\N	\N	\N	\N	115205	115205	282910
14226	16896	3	applied	\N	\N	\N	\N	115206	115206	282911
14229	16901	0	applied	\N	\N	\N	\N	115215	115215	282920
14229	16902	1	applied	\N	\N	\N	\N	115216	115216	282921
14229	16903	2	applied	\N	\N	\N	\N	115217	115217	282922
14229	16904	3	applied	\N	\N	\N	\N	115218	115218	282923
14231	16905	0	applied	\N	\N	\N	\N	115223	115223	282928
14231	16906	1	applied	\N	\N	\N	\N	115224	115224	282929
14231	16907	2	applied	\N	\N	\N	\N	115225	115225	282930
14161	16733	1	applied	\N	\N	\N	\N	114913	114913	282618
14161	16734	2	applied	\N	\N	\N	\N	114914	114914	282619
14174	16773	1	applied	\N	\N	\N	\N	114966	114966	282671
14174	16774	2	applied	\N	\N	\N	\N	114967	114967	282672
14174	16775	3	applied	\N	\N	\N	\N	114968	114968	282673
14174	16776	4	applied	\N	\N	\N	\N	114969	114969	282674
14174	16777	5	applied	\N	\N	\N	\N	114970	114970	282675
14174	16778	6	applied	\N	\N	\N	\N	114971	114971	282676
14174	16779	7	applied	\N	\N	\N	\N	114972	114972	282677
14180	16780	0	applied	\N	\N	\N	\N	114991	114991	282696
14180	16781	1	applied	\N	\N	\N	\N	114992	114992	282697
14180	16782	2	applied	\N	\N	\N	\N	114993	114993	282698
14180	16783	3	applied	\N	\N	\N	\N	114994	114994	282699
14180	16784	4	applied	\N	\N	\N	\N	114995	114995	282700
14180	16785	5	applied	\N	\N	\N	\N	114996	114996	282701
14188	16786	0	applied	\N	\N	\N	\N	115024	115024	282729
14188	16790	1	applied	\N	\N	\N	\N	115025	115025	282730
14188	16787	2	applied	\N	\N	\N	\N	115026	115026	282731
14188	16789	5	applied	\N	\N	\N	\N	115028	115028	282733
14188	16791	6	applied	\N	\N	\N	\N	115029	115029	282734
14190	16795	0	applied	\N	\N	\N	\N	115034	115034	282739
14190	16796	1	applied	\N	\N	\N	\N	115035	115035	282740
14190	16797	2	applied	\N	\N	\N	\N	115036	115036	282741
14190	16798	3	applied	\N	\N	\N	\N	115037	115037	282742
14197	16805	0	applied	\N	\N	\N	\N	115058	115058	282763
14200	16812	0	applied	\N	\N	\N	\N	115066	115066	282771
14200	16813	1	applied	\N	\N	\N	\N	115067	115067	282772
14200	16814	2	applied	\N	\N	\N	\N	115068	115068	282773
14200	16815	3	applied	\N	\N	\N	\N	115069	115069	282774
14200	16816	4	applied	\N	\N	\N	\N	115070	115070	282775
14200	16817	5	applied	\N	\N	\N	\N	115071	115071	282776
14200	16818	6	applied	\N	\N	\N	\N	115072	115072	282777
14200	16819	7	applied	\N	\N	\N	\N	115073	115073	282778
14203	16827	0	applied	\N	\N	\N	\N	115081	115081	282786
14208	16844	2	applied	\N	\N	\N	\N	115114	115114	282819
14208	16845	3	applied	\N	\N	\N	\N	115115	115115	282820
14213	16786	0	applied	\N	\N	\N	\N	115132	115132	282837
14213	16790	1	applied	\N	\N	\N	\N	115133	115133	282838
14213	16792	2	applied	\N	\N	\N	\N	115134	115134	282839
14213	16795	3	applied	\N	\N	\N	\N	115135	115135	282840
14213	16799	5	applied	\N	\N	\N	\N	115136	115136	282841
14213	16800	6	applied	\N	\N	\N	\N	115137	115137	282842
14213	16805	7	applied	\N	\N	\N	\N	115138	115138	282843
14213	16809	8	applied	\N	\N	\N	\N	115139	115139	282844
14213	16812	9	applied	\N	\N	\N	\N	115140	115140	282845
14213	16813	10	applied	\N	\N	\N	\N	115141	115141	282846
14213	16820	11	applied	\N	\N	\N	\N	115142	115142	282847
14213	16821	12	applied	\N	\N	\N	\N	115143	115143	282848
14213	16827	13	applied	\N	\N	\N	\N	115144	115144	282849
14213	16828	14	applied	\N	\N	\N	\N	115145	115145	282850
14215	16859	1	applied	\N	\N	\N	\N	115151	115151	282856
14215	16860	2	applied	\N	\N	\N	\N	115152	115152	282857
14215	16861	3	applied	\N	\N	\N	\N	115153	115153	282858
14218	16866	0	applied	\N	\N	\N	\N	115162	115162	282867
14218	16867	1	applied	\N	\N	\N	\N	115163	115163	282868
14218	16868	2	applied	\N	\N	\N	\N	115164	115164	282869
14218	16869	3	applied	\N	\N	\N	\N	115165	115165	282870
14218	16870	4	applied	\N	\N	\N	\N	115166	115166	282871
14218	16871	5	applied	\N	\N	\N	\N	115167	115167	282872
14218	16872	6	applied	\N	\N	\N	\N	115168	115168	282873
14218	16873	7	applied	\N	\N	\N	\N	115169	115169	282874
14218	16874	8	applied	\N	\N	\N	\N	115170	115170	282875
14218	16875	9	applied	\N	\N	\N	\N	115171	115171	282876
14218	16876	10	applied	\N	\N	\N	\N	115172	115172	282877
14221	16877	0	applied	\N	\N	\N	\N	115177	115177	282882
14221	16878	2	applied	\N	\N	\N	\N	115178	115178	282883
14221	16880	4	applied	\N	\N	\N	\N	115180	115180	282885
14222	16881	0	applied	\N	\N	\N	\N	115181	115181	282886
14222	16882	1	applied	\N	\N	\N	\N	115182	115182	282887
14223	16883	0	applied	\N	\N	\N	\N	115183	115183	282888
14223	16884	1	applied	\N	\N	\N	\N	115184	115184	282889
14223	16885	2	applied	\N	\N	\N	\N	115185	115185	282890
14223	16886	3	applied	\N	\N	\N	\N	115186	115186	282891
14223	16887	4	applied	\N	\N	\N	\N	115187	115187	282892
14223	16888	5	applied	\N	\N	\N	\N	115188	115188	282893
14225	16883	0	applied	\N	\N	\N	\N	115193	115193	282898
14225	16884	1	applied	\N	\N	\N	\N	115194	115194	282899
14225	16889	2	applied	\N	\N	\N	\N	115195	115195	282900
14225	16885	3	applied	\N	\N	\N	\N	115196	115196	282901
14225	16886	4	applied	\N	\N	\N	\N	115197	115197	282902
14225	16887	5	applied	\N	\N	\N	\N	115198	115198	282903
14225	16888	6	applied	\N	\N	\N	\N	115199	115199	282904
14225	16891	8	applied	\N	\N	\N	\N	115201	115201	282906
14225	16892	9	applied	\N	\N	\N	\N	115202	115202	282907
14228	16901	0	applied	\N	\N	\N	\N	115211	115211	282916
14228	16902	1	applied	\N	\N	\N	\N	115212	115212	282917
14228	16903	2	applied	\N	\N	\N	\N	115213	115213	282918
14228	16904	3	applied	\N	\N	\N	\N	115214	115214	282919
14231	16908	3	applied	\N	\N	\N	\N	115226	115226	282931
14233	16909	0	applied	\N	\N	\N	\N	115231	115231	282936
14233	16910	1	applied	\N	\N	\N	\N	115232	115232	282937
14233	16911	2	applied	\N	\N	\N	\N	115233	115233	282938
14233	16912	3	applied	\N	\N	\N	\N	115234	115234	282939
14235	16909	0	applied	\N	\N	\N	\N	115239	115239	282944
14235	16910	1	applied	\N	\N	\N	\N	115240	115240	282945
14235	16911	2	applied	\N	\N	\N	\N	115241	115241	282946
14235	16912	3	applied	\N	\N	\N	\N	115242	115242	282947
14236	16909	0	applied	\N	\N	\N	\N	115243	115243	282948
14236	16911	2	applied	\N	\N	\N	\N	115245	115245	282950
14236	16912	3	applied	\N	\N	\N	\N	115246	115246	282951
14237	16913	0	applied	\N	\N	\N	\N	115247	115247	282952
14237	16914	1	applied	\N	\N	\N	\N	115248	115248	282953
14237	16915	2	applied	\N	\N	\N	\N	115249	115249	282954
14237	16916	3	applied	\N	\N	\N	\N	115250	115250	282955
14237	16917	4	applied	\N	\N	\N	\N	115251	115251	282956
14239	16913	0	applied	\N	\N	\N	\N	115255	115255	282960
14239	16914	1	applied	\N	\N	\N	\N	115256	115256	282961
14239	16915	2	applied	\N	\N	\N	\N	115257	115257	282962
14239	16916	3	applied	\N	\N	\N	\N	115258	115258	282963
14239	16917	4	applied	\N	\N	\N	\N	115259	115259	282964
14239	16918	5	applied	\N	\N	\N	\N	115260	115260	282965
14239	16919	6	applied	\N	\N	\N	\N	115261	115261	282966
14171	16765	2	applied	\N	\N	\N	\N	114954	114954	282659
14171	16766	3	applied	\N	\N	\N	\N	114955	114955	282660
14212	16856	2	applied	\N	\N	\N	\N	115130	115130	282835
14212	16857	3	applied	\N	\N	\N	\N	115131	115131	282836
14214	16858	0	applied	\N	\N	\N	\N	115146	115146	282851
14214	16859	1	applied	\N	\N	\N	\N	115147	115147	282852
14214	16860	2	applied	\N	\N	\N	\N	115148	115148	282853
14214	16861	3	applied	\N	\N	\N	\N	115149	115149	282854
14217	16862	0	applied	\N	\N	\N	\N	115158	115158	282863
14217	16863	1	applied	\N	\N	\N	\N	115159	115159	282864
14217	16864	2	applied	\N	\N	\N	\N	115160	115160	282865
14217	16865	3	applied	\N	\N	\N	\N	115161	115161	282866
14227	16897	0	applied	\N	\N	\N	\N	115207	115207	282912
14227	16898	1	applied	\N	\N	\N	\N	115208	115208	282913
14227	16899	2	applied	\N	\N	\N	\N	115209	115209	282914
14227	16900	3	applied	\N	\N	\N	\N	115210	115210	282915
14230	16901	0	applied	\N	\N	\N	\N	115219	115219	282924
14230	16902	1	applied	\N	\N	\N	\N	115220	115220	282925
14230	16904	3	applied	\N	\N	\N	\N	115222	115222	282927
14232	16905	0	applied	\N	\N	\N	\N	115227	115227	282932
14232	16906	1	applied	\N	\N	\N	\N	115228	115228	282933
14232	16907	2	applied	\N	\N	\N	\N	115229	115229	282934
14232	16908	3	applied	\N	\N	\N	\N	115230	115230	282935
14234	16909	0	applied	\N	\N	\N	\N	115235	115235	282940
14234	16910	1	applied	\N	\N	\N	\N	115236	115236	282941
14234	16911	2	applied	\N	\N	\N	\N	115237	115237	282942
14234	16912	3	applied	\N	\N	\N	\N	115238	115238	282943
14237	16918	5	applied	\N	\N	\N	\N	115252	115252	282957
14237	16919	6	applied	\N	\N	\N	\N	115253	115253	282958
14238	16913	0	applied	\N	\N	\N	\N	115254	115254	282959
14240	16914	0	applied	\N	\N	\N	\N	115262	115262	282967
14240	16915	1	applied	\N	\N	\N	\N	115263	115263	282968
14240	16916	2	applied	\N	\N	\N	\N	115264	115264	282969
14240	16917	3	applied	\N	\N	\N	\N	115265	115265	282970
14240	16919	5	applied	\N	\N	\N	\N	115267	115267	282972
14241	16913	0	applied	\N	\N	\N	\N	115268	115268	282973
14241	16920	1	applied	\N	\N	\N	\N	115269	115269	282974
14241	16921	2	applied	\N	\N	\N	\N	115270	115270	282975
14241	16922	3	applied	\N	\N	\N	\N	115271	115271	282976
14241	16923	4	applied	\N	\N	\N	\N	115272	115272	282977
14241	16924	5	applied	\N	\N	\N	\N	115273	115273	282978
14241	16925	6	applied	\N	\N	\N	\N	115274	115274	282979
14241	16926	7	applied	\N	\N	\N	\N	115275	115275	282980
14241	16927	8	applied	\N	\N	\N	\N	115276	115276	282981
14242	16928	0	applied	\N	\N	\N	\N	115277	115277	282982
14242	16929	1	applied	\N	\N	\N	\N	115278	115278	282983
14242	16930	2	applied	\N	\N	\N	\N	115279	115279	282984
14242	16931	3	applied	\N	\N	\N	\N	115280	115280	282985
14243	16929	0	applied	\N	\N	\N	\N	115281	115281	282986
14243	16930	1	applied	\N	\N	\N	\N	115282	115282	282987
14244	16933	1	applied	\N	\N	\N	\N	115284	115284	282989
14244	16934	2	applied	\N	\N	\N	\N	115285	115285	282990
14244	16935	3	applied	\N	\N	\N	\N	115286	115286	282991
14245	16936	0	applied	\N	\N	\N	\N	115287	115287	282992
14245	16937	1	applied	\N	\N	\N	\N	115288	115288	282993
14245	16938	2	applied	\N	\N	\N	\N	115289	115289	282994
14246	16936	0	applied	\N	\N	\N	\N	115290	115290	282995
14246	16937	1	applied	\N	\N	\N	\N	115291	115291	282996
14246	16938	2	applied	\N	\N	\N	\N	115292	115292	282997
14247	16939	0	applied	\N	\N	\N	\N	115293	115293	282998
14247	16940	1	applied	\N	\N	\N	\N	115294	115294	282999
14247	16941	2	applied	\N	\N	\N	\N	115295	115295	283000
14247	16942	3	applied	\N	\N	\N	\N	115296	115296	283001
14247	16943	4	applied	\N	\N	\N	\N	115297	115297	283002
14247	16944	5	applied	\N	\N	\N	\N	115298	115298	283003
14247	16945	6	applied	\N	\N	\N	\N	115299	115299	283004
14248	16947	0	applied	\N	\N	\N	\N	115301	115301	283006
14248	16948	1	applied	\N	\N	\N	\N	115302	115302	283007
14248	16949	2	applied	\N	\N	\N	\N	115303	115303	283008
14248	16950	3	applied	\N	\N	\N	\N	115304	115304	283009
14249	16951	0	applied	\N	\N	\N	\N	115305	115305	283010
14249	16952	1	applied	\N	\N	\N	\N	115306	115306	283011
14249	16953	2	applied	\N	\N	\N	\N	115307	115307	283012
14249	16954	3	applied	\N	\N	\N	\N	115308	115308	283013
14250	16955	0	applied	\N	\N	\N	\N	115309	115309	283014
14250	16956	1	applied	\N	\N	\N	\N	115310	115310	283015
14250	16957	2	applied	\N	\N	\N	\N	115311	115311	283016
14251	16958	0	applied	\N	\N	\N	\N	115312	115312	283017
14251	16959	1	applied	\N	\N	\N	\N	115313	115313	283018
14251	16960	2	applied	\N	\N	\N	\N	115314	115314	283019
14251	16961	3	applied	\N	\N	\N	\N	115315	115315	283020
14251	16962	4	applied	\N	\N	\N	\N	115316	115316	283021
14251	16964	6	applied	\N	\N	\N	\N	115318	115318	283023
14251	16965	7	applied	\N	\N	\N	\N	115319	115319	283024
14252	16958	0	applied	\N	\N	\N	\N	115320	115320	283025
14252	16959	1	applied	\N	\N	\N	\N	115321	115321	283026
14252	16960	2	applied	\N	\N	\N	\N	115322	115322	283027
14252	16961	3	applied	\N	\N	\N	\N	115323	115323	283028
14252	16962	4	applied	\N	\N	\N	\N	115324	115324	283029
14252	16963	5	applied	\N	\N	\N	\N	115325	115325	283030
14252	16964	6	applied	\N	\N	\N	\N	115326	115326	283031
14252	16965	7	applied	\N	\N	\N	\N	115327	115327	283032
14253	16958	0	applied	\N	\N	\N	\N	115328	115328	283033
14253	16959	1	applied	\N	\N	\N	\N	115329	115329	283034
14253	16960	2	applied	\N	\N	\N	\N	115330	115330	283035
14253	16961	3	applied	\N	\N	\N	\N	115331	115331	283036
14253	16962	4	applied	\N	\N	\N	\N	115332	115332	283037
14253	16963	5	applied	\N	\N	\N	\N	115333	115333	283038
14253	16965	7	applied	\N	\N	\N	\N	115335	115335	283040
14254	16958	0	applied	\N	\N	\N	\N	115336	115336	283041
14254	16959	1	applied	\N	\N	\N	\N	115337	115337	283042
14254	16960	2	applied	\N	\N	\N	\N	115338	115338	283043
14254	16961	3	applied	\N	\N	\N	\N	115339	115339	283044
14254	16962	4	applied	\N	\N	\N	\N	115340	115340	283045
14254	16963	5	applied	\N	\N	\N	\N	115341	115341	283046
14254	16964	6	applied	\N	\N	\N	\N	115342	115342	283047
14254	16965	7	applied	\N	\N	\N	\N	115343	115343	283048
14255	16958	0	applied	\N	\N	\N	\N	115344	115344	283049
14255	16959	1	applied	\N	\N	\N	\N	115345	115345	283050
14256	16966	0	applied	\N	\N	\N	\N	115346	115346	283051
14256	16960	1	applied	\N	\N	\N	\N	115347	115347	283052
14256	16961	2	applied	\N	\N	\N	\N	115348	115348	283053
14210	16849	3	applied	\N	\N	\N	\N	115123	115123	282828
14212	16854	0	applied	\N	\N	\N	\N	115128	115128	282833
14256	16967	8	applied	\N	\N	\N	\N	115353	115353	283058
14256	16968	9	applied	\N	\N	\N	\N	115354	115354	283059
14256	16969	10	applied	\N	\N	\N	\N	115355	115355	283060
14259	16974	0	applied	\N	\N	\N	\N	115364	115364	283069
14259	16975	1	applied	\N	\N	\N	\N	115365	115365	283070
14259	16976	2	applied	\N	\N	\N	\N	115366	115366	283071
14259	16977	3	applied	\N	\N	\N	\N	115367	115367	283072
14263	16622	0	applied	\N	\N	\N	\N	115380	115380	283085
14263	16623	1	applied	\N	\N	\N	\N	115381	115381	283086
14263	16624	2	applied	\N	\N	\N	\N	115382	115382	283087
14263	16631	3	applied	\N	\N	\N	\N	115383	115383	283088
14263	16635	4	applied	\N	\N	\N	\N	115384	115384	283089
14263	16639	5	applied	\N	\N	\N	\N	115385	115385	283090
14263	16643	6	applied	\N	\N	\N	\N	115386	115386	283091
14263	16647	7	applied	\N	\N	\N	\N	115387	115387	283092
14263	16650	8	applied	\N	\N	\N	\N	115388	115388	283093
14263	16658	10	applied	\N	\N	\N	\N	115390	115390	283095
14263	16662	11	applied	\N	\N	\N	\N	115391	115391	283096
14263	16663	12	applied	\N	\N	\N	\N	115392	115392	283097
14263	16664	13	applied	\N	\N	\N	\N	115393	115393	283098
14263	16674	14	applied	\N	\N	\N	\N	115394	115394	283099
14263	16678	15	applied	\N	\N	\N	\N	115395	115395	283100
14263	16682	16	applied	\N	\N	\N	\N	115396	115396	283101
14263	16686	17	applied	\N	\N	\N	\N	115397	115397	283102
14263	16690	18	applied	\N	\N	\N	\N	115398	115398	283103
14263	16694	19	applied	\N	\N	\N	\N	115399	115399	283104
14263	16695	20	applied	\N	\N	\N	\N	115400	115400	283105
14263	16696	21	applied	\N	\N	\N	\N	115401	115401	283106
14263	16705	22	applied	\N	\N	\N	\N	115402	115402	283107
14263	16708	23	applied	\N	\N	\N	\N	115403	115403	283108
14263	16709	24	applied	\N	\N	\N	\N	115404	115404	283109
14263	16714	25	applied	\N	\N	\N	\N	115405	115405	283110
14263	16720	27	applied	\N	\N	\N	\N	115407	115407	283112
14263	16721	28	applied	\N	\N	\N	\N	115408	115408	283113
14263	16726	29	applied	\N	\N	\N	\N	115409	115409	283114
14263	16729	30	applied	\N	\N	\N	\N	115410	115410	283115
14263	16732	31	applied	\N	\N	\N	\N	115411	115411	283116
14263	16735	32	applied	\N	\N	\N	\N	115412	115412	283117
14263	16740	33	applied	\N	\N	\N	\N	115413	115413	283118
14263	16743	34	applied	\N	\N	\N	\N	115414	115414	283119
14263	16746	35	applied	\N	\N	\N	\N	115415	115415	283120
14263	16747	36	applied	\N	\N	\N	\N	115416	115416	283121
14263	16752	37	applied	\N	\N	\N	\N	115417	115417	283122
14263	16753	38	applied	\N	\N	\N	\N	115418	115418	283123
14263	16754	39	applied	\N	\N	\N	\N	115419	115419	283124
14263	16763	40	applied	\N	\N	\N	\N	115420	115420	283125
14263	16767	41	applied	\N	\N	\N	\N	115421	115421	283126
14263	16772	42	applied	\N	\N	\N	\N	115422	115422	283127
14263	16780	44	applied	\N	\N	\N	\N	115424	115424	283129
14263	16781	45	applied	\N	\N	\N	\N	115425	115425	283130
14263	16786	46	applied	\N	\N	\N	\N	115426	115426	283131
14263	16790	47	applied	\N	\N	\N	\N	115427	115427	283132
14263	16792	48	applied	\N	\N	\N	\N	115428	115428	283133
14263	16795	49	applied	\N	\N	\N	\N	115429	115429	283134
14263	16799	50	applied	\N	\N	\N	\N	115430	115430	283135
14263	16800	51	applied	\N	\N	\N	\N	115431	115431	283136
14263	16805	52	applied	\N	\N	\N	\N	115432	115432	283137
14263	16809	53	applied	\N	\N	\N	\N	115433	115433	283138
14263	16812	54	applied	\N	\N	\N	\N	115434	115434	283139
14263	16813	55	applied	\N	\N	\N	\N	115435	115435	283140
14263	16820	56	applied	\N	\N	\N	\N	115436	115436	283141
14263	16821	57	applied	\N	\N	\N	\N	115437	115437	283142
14263	16827	58	applied	\N	\N	\N	\N	115438	115438	283143
14263	16828	59	applied	\N	\N	\N	\N	115439	115439	283144
14263	16838	61	applied	\N	\N	\N	\N	115441	115441	283146
14263	16842	62	applied	\N	\N	\N	\N	115442	115442	283147
14263	16846	63	applied	\N	\N	\N	\N	115443	115443	283148
14263	16850	64	applied	\N	\N	\N	\N	115444	115444	283149
14263	16854	65	applied	\N	\N	\N	\N	115445	115445	283150
14263	16858	66	applied	\N	\N	\N	\N	115446	115446	283151
14263	16862	67	applied	\N	\N	\N	\N	115447	115447	283152
14263	16866	68	applied	\N	\N	\N	\N	115448	115448	283153
14263	16867	69	applied	\N	\N	\N	\N	115449	115449	283154
14263	16868	70	applied	\N	\N	\N	\N	115450	115450	283155
14263	16877	71	applied	\N	\N	\N	\N	115451	115451	283156
14263	16883	72	applied	\N	\N	\N	\N	115452	115452	283157
14263	16884	73	applied	\N	\N	\N	\N	115453	115453	283158
14263	16889	74	applied	\N	\N	\N	\N	115454	115454	283159
14263	16893	75	applied	\N	\N	\N	\N	115455	115455	283160
14263	16897	76	applied	\N	\N	\N	\N	115456	115456	283161
14263	16905	78	applied	\N	\N	\N	\N	115458	115458	283163
14263	16909	79	applied	\N	\N	\N	\N	115459	115459	283164
14263	16913	80	applied	\N	\N	\N	\N	115460	115460	283165
14263	16920	81	applied	\N	\N	\N	\N	115461	115461	283166
14263	16921	82	applied	\N	\N	\N	\N	115462	115462	283167
14263	16928	83	applied	\N	\N	\N	\N	115463	115463	283168
14263	16932	84	applied	\N	\N	\N	\N	115464	115464	283169
14263	16936	85	applied	\N	\N	\N	\N	115465	115465	283170
14263	16939	86	applied	\N	\N	\N	\N	115466	115466	283171
14263	16940	87	applied	\N	\N	\N	\N	115467	115467	283172
14263	16947	88	applied	\N	\N	\N	\N	115468	115468	283173
14263	16951	89	applied	\N	\N	\N	\N	115469	115469	283174
14263	16955	90	applied	\N	\N	\N	\N	115470	115470	283175
14263	16958	91	applied	\N	\N	\N	\N	115471	115471	283176
14263	16959	92	applied	\N	\N	\N	\N	115472	115472	283177
14263	16966	93	applied	\N	\N	\N	\N	115473	115473	283178
14263	16974	95	applied	\N	\N	\N	\N	115475	115475	283180
14263	16978	96	applied	\N	\N	\N	\N	115476	115476	283181
14263	16636	97	applied	\N	\N	\N	\N	115477	115477	283182
14263	16625	98	applied	\N	\N	\N	\N	115478	115478	283183
14263	16626	99	applied	\N	\N	\N	\N	115479	115479	283184
14263	16627	100	applied	\N	\N	\N	\N	115480	115480	283185
14263	16628	101	applied	\N	\N	\N	\N	115481	115481	283186
14263	16629	102	applied	\N	\N	\N	\N	115482	115482	283187
14263	16630	103	applied	\N	\N	\N	\N	115483	115483	283188
14263	16632	104	applied	\N	\N	\N	\N	115484	115484	283189
14263	16633	105	applied	\N	\N	\N	\N	115485	115485	283190
14263	16634	106	applied	\N	\N	\N	\N	115486	115486	283191
14263	16637	107	applied	\N	\N	\N	\N	115487	115487	283192
14263	16986	108	applied	\N	\N	\N	\N	115488	115488	283193
14256	16963	4	applied	\N	\N	\N	\N	115350	115350	283055
14256	16964	5	applied	\N	\N	\N	\N	115351	115351	283056
14263	16640	110	applied	\N	\N	\N	\N	115489	115489	283194
14263	16641	111	applied	\N	\N	\N	\N	115490	115490	283195
14264	16987	0	applied	\N	\N	\N	\N	115505	115505	283210
14264	16988	1	applied	\N	\N	\N	\N	115506	115506	283211
14264	16989	2	applied	\N	\N	\N	\N	115507	115507	283212
14264	16990	3	applied	\N	\N	\N	\N	115508	115508	283213
14267	16991	0	applied	\N	\N	\N	\N	115525	115525	283230
14267	16992	1	applied	\N	\N	\N	\N	115526	115526	283231
14267	16993	2	applied	\N	\N	\N	\N	115527	115527	283232
14267	16994	3	applied	\N	\N	\N	\N	115528	115528	283233
14267	16995	4	applied	\N	\N	\N	\N	115529	115529	283234
14267	16996	5	applied	\N	\N	\N	\N	115530	115530	283235
14267	16997	6	applied	\N	\N	\N	\N	115531	115531	283236
14267	16998	7	applied	\N	\N	\N	\N	115532	115532	283237
14267	16999	8	applied	\N	\N	\N	\N	115533	115533	283238
14267	17000	9	applied	\N	\N	\N	\N	115534	115534	283239
14267	17002	11	applied	\N	\N	\N	\N	115536	115536	283241
14269	17003	0	applied	\N	\N	\N	\N	115549	115549	283254
14271	17003	0	applied	\N	\N	\N	\N	115554	115554	283259
14271	17004	1	applied	\N	\N	\N	\N	115555	115555	283260
14271	17005	2	applied	\N	\N	\N	\N	115556	115556	283261
14271	17006	3	applied	\N	\N	\N	\N	115557	115557	283262
14276	17018	0	applied	\N	\N	\N	\N	115579	115579	283284
14276	17019	1	applied	\N	\N	\N	\N	115580	115580	283285
14276	17020	2	applied	\N	\N	\N	\N	115581	115581	283286
14276	17021	3	applied	\N	\N	\N	\N	115582	115582	283287
14276	17022	4	applied	\N	\N	\N	\N	115583	115583	283288
14276	17023	5	applied	\N	\N	\N	\N	115584	115584	283289
14279	17034	0	applied	\N	\N	\N	\N	115607	115607	283312
14279	17035	1	applied	\N	\N	\N	\N	115608	115608	283313
14282	17018	0	applied	\N	\N	\N	\N	115625	115625	283330
14282	17019	1	applied	\N	\N	\N	\N	115626	115626	283331
14282	17021	3	applied	\N	\N	\N	\N	115628	115628	283333
14282	16635	4	applied	\N	\N	\N	\N	115629	115629	283334
14282	16639	5	applied	\N	\N	\N	\N	115630	115630	283335
14282	16643	6	applied	\N	\N	\N	\N	115631	115631	283336
14282	16647	7	applied	\N	\N	\N	\N	115632	115632	283337
14282	16650	8	applied	\N	\N	\N	\N	115633	115633	283338
14282	16654	9	applied	\N	\N	\N	\N	115634	115634	283339
14282	16658	10	applied	\N	\N	\N	\N	115635	115635	283340
14282	16662	11	applied	\N	\N	\N	\N	115636	115636	283341
14282	16663	12	applied	\N	\N	\N	\N	115637	115637	283342
14282	16664	13	applied	\N	\N	\N	\N	115638	115638	283343
14282	16674	14	applied	\N	\N	\N	\N	115639	115639	283344
14282	16678	15	applied	\N	\N	\N	\N	115640	115640	283345
14282	16682	16	applied	\N	\N	\N	\N	115641	115641	283346
14282	16686	17	applied	\N	\N	\N	\N	115642	115642	283347
14282	16690	18	applied	\N	\N	\N	\N	115643	115643	283348
14282	16695	20	applied	\N	\N	\N	\N	115645	115645	283350
14282	16696	21	applied	\N	\N	\N	\N	115646	115646	283351
14282	16705	22	applied	\N	\N	\N	\N	115647	115647	283352
14282	16708	23	applied	\N	\N	\N	\N	115648	115648	283353
14282	16709	24	applied	\N	\N	\N	\N	115649	115649	283354
14282	16714	25	applied	\N	\N	\N	\N	115650	115650	283355
14282	16717	26	applied	\N	\N	\N	\N	115651	115651	283356
14282	16720	27	applied	\N	\N	\N	\N	115652	115652	283357
14282	16721	28	applied	\N	\N	\N	\N	115653	115653	283358
14282	16726	29	applied	\N	\N	\N	\N	115654	115654	283359
14282	16729	30	applied	\N	\N	\N	\N	115655	115655	283360
14282	16732	31	applied	\N	\N	\N	\N	115656	115656	283361
14282	16735	32	applied	\N	\N	\N	\N	115657	115657	283362
14282	16740	33	applied	\N	\N	\N	\N	115658	115658	283363
14282	16743	34	applied	\N	\N	\N	\N	115659	115659	283364
14282	16746	35	applied	\N	\N	\N	\N	115660	115660	283365
14282	16752	37	applied	\N	\N	\N	\N	115662	115662	283367
14282	16753	38	applied	\N	\N	\N	\N	115663	115663	283368
14282	16754	39	applied	\N	\N	\N	\N	115664	115664	283369
14282	16763	40	applied	\N	\N	\N	\N	115665	115665	283370
14282	16767	41	applied	\N	\N	\N	\N	115666	115666	283371
14282	16772	42	applied	\N	\N	\N	\N	115667	115667	283372
14282	16773	43	applied	\N	\N	\N	\N	115668	115668	283373
14282	16780	44	applied	\N	\N	\N	\N	115669	115669	283374
14282	16781	45	applied	\N	\N	\N	\N	115670	115670	283375
14282	16786	46	applied	\N	\N	\N	\N	115671	115671	283376
14282	16790	47	applied	\N	\N	\N	\N	115672	115672	283377
14282	16792	48	applied	\N	\N	\N	\N	115673	115673	283378
14282	16795	49	applied	\N	\N	\N	\N	115674	115674	283379
14282	16799	50	applied	\N	\N	\N	\N	115675	115675	283380
14282	16800	51	applied	\N	\N	\N	\N	115676	115676	283381
14282	16805	52	applied	\N	\N	\N	\N	115677	115677	283382
14282	16812	54	applied	\N	\N	\N	\N	115679	115679	283384
14282	16813	55	applied	\N	\N	\N	\N	115680	115680	283385
14282	16820	56	applied	\N	\N	\N	\N	115681	115681	283386
14282	16821	57	applied	\N	\N	\N	\N	115682	115682	283387
14282	16827	58	applied	\N	\N	\N	\N	115683	115683	283388
14282	16828	59	applied	\N	\N	\N	\N	115684	115684	283389
14282	16835	60	applied	\N	\N	\N	\N	115685	115685	283390
14282	16838	61	applied	\N	\N	\N	\N	115686	115686	283391
14282	16842	62	applied	\N	\N	\N	\N	115687	115687	283392
14282	16846	63	applied	\N	\N	\N	\N	115688	115688	283393
14282	16850	64	applied	\N	\N	\N	\N	115689	115689	283394
14282	16854	65	applied	\N	\N	\N	\N	115690	115690	283395
14282	16858	66	applied	\N	\N	\N	\N	115691	115691	283396
14282	16862	67	applied	\N	\N	\N	\N	115692	115692	283397
14282	16866	68	applied	\N	\N	\N	\N	115693	115693	283398
14282	16867	69	applied	\N	\N	\N	\N	115694	115694	283399
14282	16877	71	applied	\N	\N	\N	\N	115696	115696	283401
14282	16883	72	applied	\N	\N	\N	\N	115697	115697	283402
14282	16884	73	applied	\N	\N	\N	\N	115698	115698	283403
14282	16889	74	applied	\N	\N	\N	\N	115699	115699	283404
14282	16893	75	applied	\N	\N	\N	\N	115700	115700	283405
14282	16897	76	applied	\N	\N	\N	\N	115701	115701	283406
14282	16901	77	applied	\N	\N	\N	\N	115702	115702	283407
14282	16905	78	applied	\N	\N	\N	\N	115703	115703	283408
14282	16909	79	applied	\N	\N	\N	\N	115704	115704	283409
14282	16913	80	applied	\N	\N	\N	\N	115705	115705	283410
14282	16920	81	applied	\N	\N	\N	\N	115706	115706	283411
14282	16921	82	applied	\N	\N	\N	\N	115707	115707	283412
14282	16928	83	applied	\N	\N	\N	\N	115708	115708	283413
14282	16932	84	applied	\N	\N	\N	\N	115709	115709	283414
14257	16971	1	applied	\N	\N	\N	\N	115357	115357	283062
14257	16972	2	applied	\N	\N	\N	\N	115358	115358	283063
14258	16977	3	applied	\N	\N	\N	\N	115363	115363	283068
14261	16978	0	applied	\N	\N	\N	\N	115372	115372	283077
14261	16979	1	applied	\N	\N	\N	\N	115373	115373	283078
14261	16980	2	applied	\N	\N	\N	\N	115374	115374	283079
14261	16981	3	applied	\N	\N	\N	\N	115375	115375	283080
14265	16987	0	applied	\N	\N	\N	\N	115509	115509	283214
14265	16988	1	applied	\N	\N	\N	\N	115510	115510	283215
14265	16989	2	applied	\N	\N	\N	\N	115511	115511	283216
14265	16990	3	applied	\N	\N	\N	\N	115512	115512	283217
14274	17007	0	applied	\N	\N	\N	\N	115574	115574	283279
14274	17008	1	applied	\N	\N	\N	\N	115575	115575	283280
14275	17015	0	applied	\N	\N	\N	\N	115576	115576	283281
14275	17016	1	applied	\N	\N	\N	\N	115577	115577	283282
14278	17030	0	applied	\N	\N	\N	\N	115597	115597	283302
14278	17024	1	applied	\N	\N	\N	\N	115598	115598	283303
14278	17025	2	applied	\N	\N	\N	\N	115599	115599	283304
14278	17026	3	applied	\N	\N	\N	\N	115600	115600	283305
14278	17027	4	applied	\N	\N	\N	\N	115601	115601	283306
14278	17028	5	applied	\N	\N	\N	\N	115602	115602	283307
14278	17029	6	applied	\N	\N	\N	\N	115603	115603	283308
14278	17031	7	applied	\N	\N	\N	\N	115604	115604	283309
14278	17032	8	applied	\N	\N	\N	\N	115605	115605	283310
14278	17033	9	applied	\N	\N	\N	\N	115606	115606	283311
14282	16936	85	applied	\N	\N	\N	\N	115710	115710	283415
14282	16939	86	applied	\N	\N	\N	\N	115711	115711	283416
14287	17050	0	applied	\N	\N	\N	\N	115764	115764	283469
14287	17051	1	applied	\N	\N	\N	\N	115765	115765	283470
14287	17052	2	applied	\N	\N	\N	\N	115766	115766	283471
14287	17053	3	applied	\N	\N	\N	\N	115767	115767	283472
14288	17051	1	applied	\N	\N	\N	\N	115769	115769	283474
14288	17052	2	applied	\N	\N	\N	\N	115770	115770	283475
14288	17053	3	applied	\N	\N	\N	\N	115771	115771	283476
14288	17054	4	applied	\N	\N	\N	\N	115772	115772	283477
14288	17055	5	applied	\N	\N	\N	\N	115773	115773	283478
14291	17056	0	applied	\N	\N	\N	\N	115788	115788	283493
14291	17057	1	applied	\N	\N	\N	\N	115789	115789	283494
14291	17054	2	applied	\N	\N	\N	\N	115790	115790	283495
14291	17055	3	applied	\N	\N	\N	\N	115791	115791	283496
14291	17058	4	applied	\N	\N	\N	\N	115792	115792	283497
14291	17059	5	applied	\N	\N	\N	\N	115793	115793	283498
14291	17060	6	applied	\N	\N	\N	\N	115794	115794	283499
14297	17067	0	applied	\N	\N	\N	\N	115808	115808	283513
14297	17068	1	applied	\N	\N	\N	\N	115809	115809	283514
14297	17069	2	applied	\N	\N	\N	\N	115810	115810	283515
14297	17070	3	applied	\N	\N	\N	\N	115811	115811	283516
14297	17072	5	applied	\N	\N	1000000000	\N	115813	115813	283518
14297	17073	6	applied	\N	\N	\N	\N	115814	115814	283519
14297	17074	7	applied	\N	\N	\N	\N	115815	115815	283520
14297	17075	8	applied	\N	\N	\N	\N	115816	115816	283521
14300	17018	0	applied	\N	\N	\N	\N	115829	115829	283534
14300	17019	1	applied	\N	\N	\N	\N	115830	115830	283535
14300	17020	2	applied	\N	\N	\N	\N	115831	115831	283536
14303	17088	0	applied	\N	\N	\N	\N	115849	115849	283554
14303	17089	1	applied	\N	\N	\N	\N	115850	115850	283555
14303	17090	2	applied	\N	\N	\N	\N	115851	115851	283556
14306	17100	0	applied	\N	\N	\N	\N	115993	115993	283698
14306	17101	1	applied	\N	\N	\N	\N	115994	115994	283699
14306	17102	2	applied	\N	\N	\N	\N	115995	115995	283700
14306	17103	3	applied	\N	\N	\N	\N	115996	115996	283701
14306	17104	4	applied	\N	\N	\N	\N	115997	115997	283702
14306	17105	5	applied	\N	\N	\N	\N	115998	115998	283703
14306	17106	6	applied	\N	\N	\N	\N	115999	115999	283704
14311	17117	0	applied	\N	\N	\N	\N	116021	116021	283726
14311	17118	1	applied	\N	\N	\N	\N	116022	116022	283727
14311	17119	2	applied	\N	\N	\N	\N	116023	116023	283728
14311	17120	3	applied	\N	\N	\N	\N	116024	116024	283729
14314	17121	0	applied	\N	\N	\N	\N	116031	116031	283736
14314	17122	1	applied	\N	\N	\N	\N	116032	116032	283737
14314	17123	2	applied	\N	\N	\N	\N	116033	116033	283738
14315	17124	0	applied	\N	\N	\N	\N	116034	116034	283739
14315	17125	1	applied	\N	\N	\N	\N	116035	116035	283740
14315	17126	2	applied	\N	\N	\N	\N	116036	116036	283741
14320	17127	0	applied	\N	\N	\N	\N	116050	116050	283755
14320	17128	1	applied	\N	\N	\N	\N	116051	116051	283756
14320	17129	2	applied	\N	\N	\N	\N	116052	116052	283757
14320	17130	3	applied	\N	\N	\N	\N	116053	116053	283758
14322	17131	0	applied	\N	\N	\N	\N	116058	116058	283763
14322	17132	1	applied	\N	\N	\N	\N	116059	116059	283764
14322	17133	2	applied	\N	\N	\N	\N	116060	116060	283765
14322	17134	3	applied	\N	\N	\N	\N	116061	116061	283766
14322	17135	4	applied	\N	\N	\N	\N	116062	116062	283767
14322	17136	5	applied	\N	\N	\N	\N	116063	116063	283768
14322	17137	6	applied	\N	\N	\N	\N	116064	116064	283769
14327	17146	0	applied	\N	\N	\N	\N	116080	116080	283785
14327	17147	1	applied	\N	\N	\N	\N	116081	116081	283786
14327	17148	2	applied	\N	\N	\N	\N	116082	116082	283787
14327	17149	3	applied	\N	\N	\N	\N	116083	116083	283788
14330	17154	0	applied	\N	\N	\N	\N	116091	116091	283796
14330	17155	1	applied	\N	\N	\N	\N	116092	116092	283797
14332	17157	0	applied	\N	\N	\N	\N	116097	116097	283802
14332	17158	1	applied	\N	\N	\N	\N	116098	116098	283803
14332	17159	2	applied	\N	\N	\N	\N	116099	116099	283804
14332	17160	3	applied	\N	\N	\N	\N	116100	116100	283805
14335	17173	0	applied	\N	\N	\N	\N	116113	116113	283818
14335	17174	1	applied	\N	\N	\N	\N	116114	116114	283819
14335	17175	2	applied	\N	\N	\N	\N	116115	116115	283820
14335	17176	3	applied	\N	\N	\N	\N	116116	116116	283821
14335	17177	4	applied	\N	\N	\N	\N	116117	116117	283822
14335	17178	5	applied	\N	\N	\N	\N	116118	116118	283823
14335	17179	6	applied	\N	\N	\N	\N	116119	116119	283824
14335	17180	7	applied	\N	\N	\N	\N	116120	116120	283825
14338	17185	0	applied	\N	\N	\N	\N	116129	116129	283834
14258	16975	1	applied	\N	\N	\N	\N	115361	115361	283066
14258	16976	2	applied	\N	\N	\N	\N	115362	115362	283067
14262	16982	0	applied	\N	\N	\N	\N	115376	115376	283081
14262	16983	1	applied	\N	\N	\N	\N	115377	115377	283082
14262	16984	2	applied	\N	\N	\N	\N	115378	115378	283083
14262	16985	3	applied	\N	\N	\N	\N	115379	115379	283084
14268	16991	0	applied	\N	\N	\N	\N	115537	115537	283242
14268	16992	1	applied	\N	\N	\N	\N	115538	115538	283243
14268	16993	2	applied	\N	\N	\N	\N	115539	115539	283244
14268	16994	3	applied	\N	\N	\N	\N	115540	115540	283245
14268	16995	4	applied	\N	\N	\N	\N	115541	115541	283246
14268	16996	5	applied	\N	\N	\N	\N	115542	115542	283247
14268	16997	6	applied	\N	\N	\N	\N	115543	115543	283248
14268	16998	7	applied	\N	\N	\N	\N	115544	115544	283249
14268	16999	8	applied	\N	\N	\N	\N	115545	115545	283250
14268	17000	9	applied	\N	\N	\N	\N	115546	115546	283251
14268	17001	10	applied	\N	\N	\N	\N	115547	115547	283252
14268	17002	11	applied	\N	\N	\N	\N	115548	115548	283253
14270	17004	1	applied	\N	\N	\N	\N	115551	115551	283256
14270	17005	2	applied	\N	\N	\N	\N	115552	115552	283257
14270	17006	3	applied	\N	\N	\N	\N	115553	115553	283258
14272	17007	0	applied	\N	\N	\N	\N	115558	115558	283263
14272	17008	1	applied	\N	\N	\N	\N	115559	115559	283264
14272	17009	2	applied	\N	\N	\N	\N	115560	115560	283265
14272	17010	3	applied	\N	\N	\N	\N	115561	115561	283266
14272	17011	4	applied	\N	\N	\N	\N	115562	115562	283267
14272	17012	5	applied	\N	\N	\N	\N	115563	115563	283268
14272	17013	6	applied	\N	\N	\N	\N	115564	115564	283269
14272	17014	7	applied	\N	\N	\N	\N	115565	115565	283270
14277	17018	0	applied	\N	\N	\N	\N	115585	115585	283290
14277	17019	1	applied	\N	\N	\N	\N	115586	115586	283291
14277	17020	2	applied	\N	\N	\N	\N	115587	115587	283292
14277	17021	3	applied	\N	\N	\N	\N	115588	115588	283293
14277	17022	4	applied	\N	\N	\N	\N	115589	115589	283294
14277	17024	6	applied	\N	\N	\N	\N	115591	115591	283296
14277	17025	7	applied	\N	\N	\N	\N	115592	115592	283297
14277	17026	8	applied	\N	\N	\N	\N	115593	115593	283298
14277	17027	9	applied	\N	\N	\N	\N	115594	115594	283299
14277	17028	10	applied	\N	\N	\N	\N	115595	115595	283300
14277	17029	11	applied	\N	\N	\N	\N	115596	115596	283301
14280	17034	0	applied	\N	\N	\N	\N	115609	115609	283314
14280	17035	1	applied	\N	\N	\N	\N	115610	115610	283315
14280	17036	2	applied	\N	\N	\N	\N	115611	115611	283316
14280	17037	3	applied	\N	\N	\N	\N	115612	115612	283317
14280	17038	4	applied	\N	\N	\N	\N	115613	115613	283318
14280	17039	5	applied	\N	\N	\N	\N	115614	115614	283319
14280	17040	6	applied	\N	\N	\N	\N	115615	115615	283320
14280	17041	7	applied	\N	\N	\N	\N	115616	115616	283321
14285	17050	0	applied	\N	\N	\N	\N	115756	115756	283461
14285	17051	1	applied	\N	\N	\N	\N	115757	115757	283462
14285	17053	3	applied	\N	\N	\N	\N	115759	115759	283464
14289	17056	0	applied	\N	\N	\N	\N	115774	115774	283479
14289	17057	1	applied	\N	\N	\N	\N	115775	115775	283480
14289	17054	2	applied	\N	\N	\N	\N	115776	115776	283481
14289	17055	3	applied	\N	\N	\N	\N	115777	115777	283482
14289	17058	4	applied	\N	\N	\N	\N	115778	115778	283483
14289	17059	5	applied	\N	\N	\N	\N	115779	115779	283484
14289	17060	6	applied	\N	\N	\N	\N	115780	115780	283485
14294	17061	0	applied	\N	\N	\N	\N	115799	115799	283504
14294	17062	2	applied	\N	\N	\N	\N	115800	115800	283505
14294	17063	3	applied	\N	\N	\N	\N	115801	115801	283506
14294	17064	4	applied	\N	\N	\N	\N	115802	115802	283507
14299	17080	0	applied	\N	\N	\N	\N	115821	115821	283526
14299	17081	1	applied	\N	\N	\N	\N	115822	115822	283527
14299	17082	2	applied	\N	\N	\N	\N	115823	115823	283528
14299	17083	3	applied	\N	\N	\N	\N	115824	115824	283529
14299	17085	5	applied	\N	\N	\N	\N	115826	115826	283531
14299	17086	6	applied	\N	\N	\N	\N	115827	115827	283532
14299	17087	7	applied	\N	\N	\N	\N	115828	115828	283533
14302	17088	0	applied	\N	\N	\N	\N	115837	115837	283542
14302	17089	1	applied	\N	\N	\N	\N	115838	115838	283543
14307	17107	0	applied	\N	\N	\N	\N	116000	116000	283705
14307	17108	1	applied	\N	\N	\N	\N	116001	116001	283706
14307	17109	2	applied	\N	\N	\N	\N	116002	116002	283707
14307	17110	3	applied	\N	\N	\N	\N	116003	116003	283708
14307	17111	4	applied	\N	\N	\N	\N	116004	116004	283709
14307	17112	5	applied	\N	\N	\N	\N	116005	116005	283710
14307	17113	6	applied	\N	\N	\N	\N	116006	116006	283711
14312	17121	0	applied	\N	\N	\N	\N	116025	116025	283730
14312	17122	1	applied	\N	\N	\N	\N	116026	116026	283731
14312	17123	2	applied	\N	\N	\N	\N	116027	116027	283732
14317	17124	0	applied	\N	\N	\N	\N	116040	116040	283745
14317	17125	1	applied	\N	\N	\N	\N	116041	116041	283746
14317	17126	2	applied	\N	\N	\N	\N	116042	116042	283747
14323	17138	0	applied	\N	\N	\N	\N	116065	116065	283770
14323	17139	1	applied	\N	\N	\N	\N	116066	116066	283771
14323	17140	2	applied	\N	\N	\N	\N	116067	116067	283772
14323	17141	3	applied	\N	\N	\N	\N	116068	116068	283773
14331	17157	0	applied	\N	\N	\N	\N	116093	116093	283798
14331	17158	1	applied	\N	\N	\N	\N	116094	116094	283799
14331	17159	2	applied	\N	\N	\N	\N	116095	116095	283800
14331	17160	3	applied	\N	\N	\N	\N	116096	116096	283801
14338	17186	1	applied	\N	\N	\N	\N	116130	116130	283835
14338	17187	2	applied	\N	\N	\N	\N	116131	116131	283836
14339	17189	0	applied	\N	\N	\N	\N	116133	116133	283838
14339	17190	1	applied	\N	\N	\N	\N	116134	116134	283839
14339	17191	2	applied	\N	\N	\N	\N	116135	116135	283840
14339	17192	3	applied	\N	\N	\N	\N	116136	116136	283841
14339	17193	4	applied	\N	\N	\N	\N	116137	116137	283842
14339	17194	5	applied	\N	\N	\N	\N	116138	116138	283843
14339	17195	6	applied	\N	\N	\N	\N	116139	116139	283844
14339	17196	7	applied	\N	\N	\N	\N	116140	116140	283845
14342	17201	0	applied	\N	\N	\N	\N	116149	116149	283854
14342	17202	1	applied	\N	\N	\N	\N	116150	116150	283855
14260	16979	1	applied	\N	\N	\N	\N	115369	115369	283074
14260	16980	2	applied	\N	\N	\N	\N	115370	115370	283075
14263	16648	116	applied	\N	\N	\N	\N	115495	115495	283200
14263	16649	117	applied	\N	\N	\N	\N	115496	115496	283201
14263	16651	118	applied	\N	\N	\N	\N	115497	115497	283202
14263	16652	119	applied	\N	\N	\N	\N	115498	115498	283203
14263	16653	120	applied	\N	\N	\N	\N	115499	115499	283204
14263	16655	121	applied	\N	\N	\N	\N	115500	115500	283205
14263	16656	122	applied	\N	\N	\N	\N	115501	115501	283206
14263	16657	123	applied	\N	\N	\N	\N	115502	115502	283207
14263	16659	124	applied	\N	\N	\N	\N	115503	115503	283208
14263	16660	125	applied	\N	\N	\N	\N	115504	115504	283209
14266	16991	0	applied	\N	\N	\N	\N	115513	115513	283218
14266	16992	1	applied	\N	\N	\N	\N	115514	115514	283219
14266	16993	2	applied	\N	\N	\N	\N	115515	115515	283220
14266	16994	3	applied	\N	\N	\N	\N	115516	115516	283221
14266	16995	4	applied	\N	\N	\N	\N	115517	115517	283222
14266	16996	5	applied	\N	\N	\N	\N	115518	115518	283223
14266	16998	7	applied	\N	\N	\N	\N	115520	115520	283225
14266	16999	8	applied	\N	\N	\N	\N	115521	115521	283226
14266	17000	9	applied	\N	\N	\N	\N	115522	115522	283227
14266	17001	10	applied	\N	\N	\N	\N	115523	115523	283228
14266	17002	11	applied	\N	\N	\N	\N	115524	115524	283229
14273	17007	0	applied	\N	\N	\N	\N	115566	115566	283271
14273	17008	1	applied	\N	\N	\N	\N	115567	115567	283272
14273	17009	2	applied	\N	\N	\N	\N	115568	115568	283273
14273	17010	3	applied	\N	\N	\N	\N	115569	115569	283274
14273	17011	4	applied	\N	\N	\N	\N	115570	115570	283275
14273	17012	5	applied	\N	\N	\N	\N	115571	115571	283276
14273	17013	6	applied	\N	\N	\N	\N	115572	115572	283277
14273	17014	7	applied	\N	\N	\N	\N	115573	115573	283278
14281	17034	0	applied	\N	\N	\N	\N	115617	115617	283322
14281	17035	1	applied	\N	\N	\N	\N	115618	115618	283323
14281	17036	2	applied	\N	\N	\N	\N	115619	115619	283324
14281	17038	4	applied	\N	\N	\N	\N	115621	115621	283326
14281	17039	5	applied	\N	\N	\N	\N	115622	115622	283327
14281	17040	6	applied	\N	\N	\N	\N	115623	115623	283328
14281	17041	7	applied	\N	\N	\N	\N	115624	115624	283329
14283	17042	0	applied	\N	\N	\N	\N	115738	115738	283443
14283	17043	1	applied	\N	\N	\N	\N	115739	115739	283444
14283	17036	2	applied	\N	\N	\N	\N	115740	115740	283445
14283	17037	3	applied	\N	\N	\N	\N	115741	115741	283446
14283	17038	4	applied	\N	\N	\N	\N	115742	115742	283447
14283	17039	5	applied	\N	\N	\N	\N	115743	115743	283448
14283	17040	6	applied	\N	\N	\N	\N	115744	115744	283449
14283	17041	7	applied	\N	\N	\N	\N	115745	115745	283450
14283	17044	8	applied	\N	\N	\N	\N	115746	115746	283451
14283	17045	9	applied	\N	\N	\N	\N	115747	115747	283452
14283	17046	10	applied	\N	\N	\N	\N	115748	115748	283453
14283	17047	11	applied	\N	\N	\N	\N	115749	115749	283454
14283	17049	13	applied	\N	\N	\N	\N	115751	115751	283456
14286	17050	0	applied	\N	\N	\N	\N	115760	115760	283465
14286	17051	1	applied	\N	\N	\N	\N	115761	115761	283466
14286	17052	2	applied	\N	\N	\N	\N	115762	115762	283467
14286	17053	3	applied	\N	\N	\N	\N	115763	115763	283468
14290	17056	0	applied	\N	\N	\N	\N	115781	115781	283486
14290	17057	1	applied	\N	\N	\N	\N	115782	115782	283487
14290	17054	2	applied	\N	\N	\N	\N	115783	115783	283488
14290	17055	3	applied	\N	\N	\N	\N	115784	115784	283489
14290	17058	4	applied	\N	\N	\N	\N	115785	115785	283490
14290	17059	5	applied	\N	\N	\N	\N	115786	115786	283491
14290	17060	6	applied	\N	\N	\N	\N	115787	115787	283492
14295	17062	0	applied	\N	\N	\N	\N	115803	115803	283508
14295	17063	2	applied	\N	\N	\N	\N	115804	115804	283509
14295	17064	3	applied	\N	\N	\N	\N	115805	115805	283510
14296	17065	0	applied	\N	\N	\N	\N	115806	115806	283511
14305	17100	0	applied	\N	\N	\N	\N	115986	115986	283691
14305	17101	1	applied	\N	\N	\N	\N	115987	115987	283692
14305	17102	2	applied	\N	\N	\N	\N	115988	115988	283693
14305	17103	3	applied	\N	\N	\N	\N	115989	115989	283694
14305	17104	4	applied	\N	\N	\N	\N	115990	115990	283695
14305	17105	5	applied	\N	\N	\N	\N	115991	115991	283696
14305	17106	6	applied	\N	\N	\N	\N	115992	115992	283697
14308	17107	0	applied	\N	\N	\N	\N	116007	116007	283712
14308	17108	1	applied	\N	\N	\N	\N	116008	116008	283713
14308	17109	2	applied	\N	\N	\N	\N	116009	116009	283714
14308	17110	3	applied	\N	\N	\N	\N	116010	116010	283715
14308	17111	4	applied	\N	\N	\N	\N	116011	116011	283716
14308	17112	5	applied	\N	\N	\N	\N	116012	116012	283717
14308	17113	6	applied	\N	\N	\N	\N	116013	116013	283718
14310	17117	0	applied	\N	\N	\N	\N	116017	116017	283722
14310	17118	1	applied	\N	\N	\N	\N	116018	116018	283723
14310	17120	3	applied	\N	\N	\N	\N	116020	116020	283725
14313	17121	0	applied	\N	\N	\N	\N	116028	116028	283733
14313	17122	1	applied	\N	\N	\N	\N	116029	116029	283734
14313	17123	2	applied	\N	\N	\N	\N	116030	116030	283735
14318	17124	0	applied	\N	\N	\N	\N	116043	116043	283748
14318	17125	1	applied	\N	\N	\N	\N	116044	116044	283749
14318	17126	2	applied	\N	\N	\N	\N	116045	116045	283750
14319	17127	0	applied	\N	\N	\N	\N	116046	116046	283751
14319	17128	1	applied	\N	\N	\N	\N	116047	116047	283752
14319	17129	2	applied	\N	\N	\N	\N	116048	116048	283753
14319	17130	3	applied	\N	\N	\N	\N	116049	116049	283754
14324	17138	0	applied	\N	\N	\N	\N	116069	116069	283774
14324	17139	1	applied	\N	\N	\N	\N	116070	116070	283775
14324	17140	2	applied	\N	\N	\N	\N	116071	116071	283776
14324	17141	3	applied	\N	\N	\N	\N	116072	116072	283777
14326	17142	0	applied	\N	\N	\N	\N	116077	116077	283782
14326	17144	2	applied	\N	\N	\N	\N	116079	116079	283784
14329	17154	0	applied	\N	\N	\N	\N	116088	116088	283793
14329	17155	1	applied	\N	\N	\N	\N	116089	116089	283794
14329	17156	2	applied	\N	\N	\N	\N	116090	116090	283795
14334	17169	0	applied	\N	\N	\N	\N	116109	116109	283814
14334	17170	1	applied	\N	\N	\N	\N	116110	116110	283815
14334	17171	2	applied	\N	\N	\N	\N	116111	116111	283816
14334	17172	3	applied	\N	\N	\N	\N	116112	116112	283817
14337	17185	0	applied	\N	\N	\N	\N	116125	116125	283830
14337	17186	1	applied	\N	\N	\N	\N	116126	116126	283831
14337	17187	2	applied	\N	\N	\N	\N	116127	116127	283832
14337	17188	3	applied	\N	\N	\N	\N	116128	116128	283833
14342	17203	2	applied	\N	\N	\N	\N	116151	116151	283856
14342	17204	3	applied	\N	\N	\N	\N	116152	116152	283857
14263	16644	113	applied	\N	\N	\N	\N	115492	115492	283197
14263	16645	114	applied	\N	\N	\N	\N	115493	115493	283198
14282	16958	91	applied	\N	\N	\N	\N	115716	115716	283421
14282	16959	92	applied	\N	\N	\N	\N	115717	115717	283422
14282	16966	93	applied	\N	\N	\N	\N	115718	115718	283423
14282	16970	94	applied	\N	\N	\N	\N	115719	115719	283424
14282	16974	96	applied	\N	\N	\N	\N	115720	115720	283425
14282	16978	97	applied	\N	\N	\N	\N	115721	115721	283426
14282	16982	98	applied	\N	\N	\N	\N	115722	115722	283427
14282	16987	99	applied	\N	\N	\N	\N	115723	115723	283428
14282	16991	100	applied	\N	\N	\N	\N	115724	115724	283429
14282	16992	101	applied	\N	\N	\N	\N	115725	115725	283430
14282	16993	102	applied	\N	\N	\N	\N	115726	115726	283431
14282	17003	103	applied	\N	\N	\N	\N	115727	115727	283432
14282	17007	104	applied	\N	\N	\N	\N	115728	115728	283433
14282	17008	105	applied	\N	\N	\N	\N	115729	115729	283434
14282	17022	107	applied	\N	\N	\N	\N	115731	115731	283436
14282	17023	108	applied	\N	\N	\N	\N	115732	115732	283437
14282	17030	109	applied	\N	\N	\N	\N	115733	115733	283438
14282	17034	110	applied	\N	\N	\N	\N	115734	115734	283439
14282	17035	111	applied	\N	\N	\N	\N	115735	115735	283440
14282	16636	112	applied	\N	\N	\N	\N	115736	115736	283441
14282	16632	113	applied	\N	\N	\N	\N	115737	115737	283442
14284	17050	0	applied	\N	\N	\N	\N	115752	115752	283457
14284	17051	1	applied	\N	\N	\N	\N	115753	115753	283458
14284	17052	2	applied	\N	\N	\N	\N	115754	115754	283459
14284	17053	3	applied	\N	\N	\N	\N	115755	115755	283460
14293	17061	0	applied	\N	\N	\N	\N	115795	115795	283500
14293	17062	2	applied	\N	\N	\N	\N	115796	115796	283501
14293	17063	3	applied	\N	\N	\N	\N	115797	115797	283502
14293	17064	4	applied	\N	\N	\N	\N	115798	115798	283503
14298	17076	0	applied	\N	\N	\N	\N	115817	115817	283522
14298	17078	2	applied	\N	\N	\N	\N	115819	115819	283524
14298	17079	3	applied	\N	\N	\N	\N	115820	115820	283525
14301	17088	0	applied	\N	\N	\N	\N	115834	115834	283539
14304	16982	0	applied	\N	\N	\N	\N	115861	115861	283566
14304	17018	1	applied	\N	\N	\N	\N	115862	115862	283567
14304	17019	2	applied	\N	\N	\N	\N	115863	115863	283568
14304	17003	9	applied	\N	\N	\N	\N	115870	115870	283575
14304	17007	10	applied	\N	\N	\N	\N	115871	115871	283576
14304	17008	11	applied	\N	\N	\N	\N	115872	115872	283577
14304	17015	12	applied	\N	\N	\N	\N	115873	115873	283578
14304	17022	13	applied	\N	\N	\N	\N	115874	115874	283579
14304	17023	14	applied	\N	\N	\N	\N	115875	115875	283580
14304	17030	15	applied	\N	\N	\N	\N	115876	115876	283581
14304	17034	16	applied	\N	\N	\N	\N	115877	115877	283582
14304	17035	17	applied	\N	\N	\N	\N	115878	115878	283583
14304	17042	18	applied	\N	\N	\N	\N	115879	115879	283584
14304	17043	19	applied	\N	\N	\N	\N	115880	115880	283585
14304	17050	20	applied	\N	\N	\N	\N	115881	115881	283586
14304	17056	21	applied	\N	\N	\N	\N	115882	115882	283587
14304	17057	22	applied	\N	\N	\N	\N	115883	115883	283588
14304	17061	23	applied	\N	\N	\N	\N	115884	115884	283589
14304	17067	24	applied	\N	\N	\N	\N	115885	115885	283590
14304	17068	25	applied	\N	\N	\N	\N	115886	115886	283591
14304	17076	26	applied	\N	\N	\N	\N	115887	115887	283592
14304	17080	27	applied	\N	\N	\N	\N	115888	115888	283593
14304	17081	28	applied	\N	\N	\N	\N	115889	115889	283594
14304	17088	29	applied	\N	\N	\N	\N	115890	115890	283595
14304	17089	30	applied	\N	\N	\N	\N	115891	115891	283596
14304	17090	31	applied	\N	\N	\N	\N	115892	115892	283597
14304	16661	32	applied	\N	\N	\N	\N	115893	115893	283598
14304	16665	33	applied	\N	\N	\N	\N	115894	115894	283599
14304	16666	34	applied	\N	\N	\N	\N	115895	115895	283600
14304	16667	35	applied	\N	\N	\N	\N	115896	115896	283601
14304	16668	36	applied	\N	\N	\N	\N	115897	115897	283602
14304	17072	37	applied	\N	\N	1000000000	\N	115898	115898	283603
14304	16669	38	applied	\N	\N	\N	\N	115899	115899	283604
14304	16670	39	applied	\N	\N	\N	\N	115900	115900	283605
14304	16671	40	applied	\N	\N	\N	\N	115901	115901	283606
14304	16672	41	applied	\N	\N	\N	\N	115902	115902	283607
14304	16673	42	applied	\N	\N	\N	\N	115903	115903	283608
14304	16675	43	applied	\N	\N	\N	\N	115904	115904	283609
14304	16676	44	applied	\N	\N	\N	\N	115905	115905	283610
14304	16677	45	applied	\N	\N	\N	\N	115906	115906	283611
14304	16679	46	applied	\N	\N	\N	\N	115907	115907	283612
14304	16680	47	applied	\N	\N	\N	\N	115908	115908	283613
14304	16681	48	applied	\N	\N	\N	\N	115909	115909	283614
14304	16683	49	applied	\N	\N	\N	\N	115910	115910	283615
14304	16684	50	applied	\N	\N	\N	\N	115911	115911	283616
14304	16685	51	applied	\N	\N	\N	\N	115912	115912	283617
14304	16687	52	applied	\N	\N	\N	\N	115913	115913	283618
14304	16688	53	applied	\N	\N	\N	\N	115914	115914	283619
14304	16689	54	applied	\N	\N	\N	\N	115915	115915	283620
14304	16691	55	applied	\N	\N	\N	\N	115916	115916	283621
14304	16692	56	applied	\N	\N	\N	\N	115917	115917	283622
14304	16693	57	applied	\N	\N	\N	\N	115918	115918	283623
14304	16697	58	applied	\N	\N	\N	\N	115919	115919	283624
14304	16698	59	applied	\N	\N	\N	\N	115920	115920	283625
14304	16699	60	applied	\N	\N	\N	\N	115921	115921	283626
14304	16700	61	applied	\N	\N	\N	\N	115922	115922	283627
14304	16701	62	applied	\N	\N	\N	\N	115923	115923	283628
14304	16702	63	applied	\N	\N	\N	\N	115924	115924	283629
14304	16703	64	applied	\N	\N	\N	\N	115925	115925	283630
14304	16704	65	applied	\N	\N	\N	\N	115926	115926	283631
14304	16706	66	applied	\N	\N	\N	\N	115927	115927	283632
14304	16707	67	applied	\N	\N	\N	\N	115928	115928	283633
14304	16710	68	applied	\N	\N	\N	\N	115929	115929	283634
14304	16711	69	applied	\N	\N	\N	\N	115930	115930	283635
14304	16712	70	applied	\N	\N	\N	\N	115931	115931	283636
14304	16713	71	applied	\N	\N	\N	\N	115932	115932	283637
14304	16715	72	applied	\N	\N	\N	\N	115933	115933	283638
14304	16716	73	applied	\N	\N	\N	\N	115934	115934	283639
14304	16718	74	applied	\N	\N	\N	\N	115935	115935	283640
14304	16719	75	applied	\N	\N	\N	\N	115936	115936	283641
14304	16722	76	applied	\N	\N	\N	\N	115937	115937	283642
14340	17197	0	applied	\N	\N	\N	\N	116141	116141	283846
14340	17198	1	applied	\N	\N	\N	\N	116142	116142	283847
14282	16951	89	applied	\N	\N	\N	\N	115714	115714	283419
14282	16955	90	applied	\N	\N	\N	\N	115715	115715	283420
14304	16727	80	applied	\N	\N	\N	\N	115941	115941	283646
14304	16728	81	applied	\N	\N	\N	\N	115942	115942	283647
14304	16730	82	applied	\N	\N	\N	\N	115943	115943	283648
14304	16731	83	applied	\N	\N	\N	\N	115944	115944	283649
14304	16733	84	applied	\N	\N	\N	\N	115945	115945	283650
14304	16734	85	applied	\N	\N	\N	\N	115946	115946	283651
14304	16736	86	applied	\N	\N	\N	\N	115947	115947	283652
14304	16737	87	applied	\N	\N	\N	\N	115948	115948	283653
14304	16738	88	applied	\N	\N	\N	\N	115949	115949	283654
14304	16739	89	applied	\N	\N	\N	\N	115950	115950	283655
14304	16741	90	applied	\N	\N	\N	\N	115951	115951	283656
14304	16742	91	applied	\N	\N	\N	\N	115952	115952	283657
14304	16744	92	applied	\N	\N	\N	\N	115953	115953	283658
14304	16748	94	applied	\N	\N	\N	\N	115955	115955	283660
14304	16749	95	applied	\N	\N	\N	\N	115956	115956	283661
14304	16750	96	applied	\N	\N	\N	\N	115957	115957	283662
14304	16751	97	applied	\N	\N	\N	\N	115958	115958	283663
14304	16755	98	applied	\N	\N	\N	\N	115959	115959	283664
14304	16756	99	applied	\N	\N	\N	\N	115960	115960	283665
14304	16757	100	applied	\N	\N	\N	\N	115961	115961	283666
14304	16758	101	applied	\N	\N	\N	\N	115962	115962	283667
14304	16759	102	applied	\N	\N	\N	\N	115963	115963	283668
14304	16760	103	applied	\N	\N	\N	\N	115964	115964	283669
14304	16761	104	applied	\N	\N	\N	\N	115965	115965	283670
14304	16762	105	applied	\N	\N	\N	\N	115966	115966	283671
14304	16764	106	applied	\N	\N	\N	\N	115967	115967	283672
14304	16765	107	applied	\N	\N	\N	\N	115968	115968	283673
14304	16766	108	applied	\N	\N	\N	\N	115969	115969	283674
14304	16768	110	applied	\N	\N	\N	\N	115970	115970	283675
14304	16770	112	applied	\N	\N	\N	\N	115972	115972	283677
14304	16771	113	applied	\N	\N	\N	\N	115973	115973	283678
14304	16774	114	applied	\N	\N	\N	\N	115974	115974	283679
14304	16775	115	applied	\N	\N	\N	\N	115975	115975	283680
14304	16776	116	applied	\N	\N	\N	\N	115976	115976	283681
14304	16777	117	applied	\N	\N	\N	\N	115977	115977	283682
14304	16778	118	applied	\N	\N	\N	\N	115978	115978	283683
14304	16779	119	applied	\N	\N	\N	\N	115979	115979	283684
14304	16782	120	applied	\N	\N	\N	\N	115980	115980	283685
14304	16783	121	applied	\N	\N	\N	\N	115981	115981	283686
14304	16784	122	applied	\N	\N	\N	\N	115982	115982	283687
14304	16785	123	applied	\N	\N	\N	\N	115983	115983	283688
14304	16787	124	applied	\N	\N	\N	\N	115984	115984	283689
14304	16788	125	applied	\N	\N	\N	\N	115985	115985	283690
14309	17114	0	applied	\N	\N	\N	\N	116014	116014	283719
14309	17115	1	applied	\N	\N	\N	\N	116015	116015	283720
14309	17116	2	applied	\N	\N	\N	\N	116016	116016	283721
14316	17124	0	applied	\N	\N	\N	\N	116037	116037	283742
14316	17126	2	applied	\N	\N	\N	\N	116039	116039	283744
14321	17127	0	applied	\N	\N	\N	\N	116054	116054	283759
14321	17128	1	applied	\N	\N	\N	\N	116055	116055	283760
14321	17129	2	applied	\N	\N	\N	\N	116056	116056	283761
14321	17130	3	applied	\N	\N	\N	\N	116057	116057	283762
14325	17142	0	applied	\N	\N	\N	\N	116073	116073	283778
14325	17143	1	applied	\N	\N	\N	\N	116074	116074	283779
14325	17144	2	applied	\N	\N	\N	\N	116075	116075	283780
14325	17145	3	applied	\N	\N	\N	\N	116076	116076	283781
14328	17150	0	applied	\N	\N	\N	\N	116084	116084	283789
14328	17151	1	applied	\N	\N	\N	\N	116085	116085	283790
14328	17152	2	applied	\N	\N	\N	\N	116086	116086	283791
14328	17153	3	applied	\N	\N	\N	\N	116087	116087	283792
14333	17161	0	applied	\N	\N	\N	\N	116101	116101	283806
14333	17162	1	applied	\N	\N	\N	\N	116102	116102	283807
14333	17163	2	applied	\N	\N	\N	\N	116103	116103	283808
14333	17165	4	applied	\N	\N	\N	\N	116105	116105	283810
14333	17166	5	applied	\N	\N	\N	\N	116106	116106	283811
14333	17167	6	applied	\N	\N	\N	\N	116107	116107	283812
14333	17168	7	applied	\N	\N	\N	\N	116108	116108	283813
14336	17181	0	applied	\N	\N	\N	\N	116121	116121	283826
14336	17182	1	applied	\N	\N	\N	\N	116122	116122	283827
14336	17183	2	applied	\N	\N	\N	\N	116123	116123	283828
14336	17184	3	applied	\N	\N	\N	\N	116124	116124	283829
14354	17234	0	applied	\N	\N	\N	\N	116340	116340	284044
14354	17235	1	applied	\N	\N	\N	\N	116341	116341	284045
14354	17236	2	applied	\N	\N	\N	\N	116342	116342	284046
14354	17237	3	applied	\N	\N	\N	\N	116343	116343	284047
14356	17239	0	applied	\N	\N	\N	\N	116345	116345	284049
14356	17240	1	applied	\N	\N	\N	\N	116346	116346	284050
14356	17241	2	applied	\N	\N	\N	\N	116347	116347	284051
14356	17242	3	applied	\N	\N	\N	\N	116348	116348	284052
14356	17243	4	applied	\N	\N	\N	\N	116349	116349	284053
14356	17244	5	applied	\N	\N	\N	\N	116350	116350	284054
14356	17246	7	applied	\N	\N	\N	\N	116352	116352	284056
14358	17247	0	applied	\N	\N	\N	\N	116359	116359	284063
14358	17248	1	applied	\N	\N	\N	\N	116360	116360	284064
14358	17249	2	applied	\N	\N	\N	\N	116361	116361	284065
14358	17250	3	applied	\N	\N	\N	\N	116362	116362	284066
14362	17240	0	applied	\N	\N	\N	\N	116375	116375	284079
14362	17018	1	applied	\N	\N	\N	\N	116376	116376	284080
14362	17019	2	applied	\N	\N	\N	\N	116377	116377	284081
14362	17020	3	applied	\N	\N	\N	\N	116378	116378	284082
14362	17021	4	applied	\N	\N	\N	\N	116379	116379	284083
14362	16780	5	applied	\N	\N	\N	\N	116380	116380	284084
14362	16781	6	applied	\N	\N	\N	\N	116381	116381	284085
14362	16786	7	applied	\N	\N	\N	\N	116382	116382	284086
14362	16790	8	applied	\N	\N	\N	\N	116383	116383	284087
14362	16792	9	applied	\N	\N	\N	\N	116384	116384	284088
14362	16795	10	applied	\N	\N	\N	\N	116385	116385	284089
14362	16800	13	applied	\N	\N	\N	\N	116387	116387	284091
14362	16805	14	applied	\N	\N	\N	\N	116388	116388	284092
14362	16809	15	applied	\N	\N	\N	\N	116389	116389	284093
14362	16812	16	applied	\N	\N	\N	\N	116390	116390	284094
14362	16813	17	applied	\N	\N	\N	\N	116391	116391	284095
14362	16820	18	applied	\N	\N	\N	\N	116392	116392	284096
14362	16821	19	applied	\N	\N	\N	\N	116393	116393	284097
14362	16827	20	applied	\N	\N	\N	\N	116394	116394	284098
14362	16828	21	applied	\N	\N	\N	\N	116395	116395	284099
14362	16835	22	applied	\N	\N	\N	\N	116396	116396	284100
14362	16838	23	applied	\N	\N	\N	\N	116397	116397	284101
14362	16842	24	applied	\N	\N	\N	\N	116398	116398	284102
14362	16846	25	applied	\N	\N	\N	\N	116399	116399	284103
14304	16724	78	applied	\N	\N	\N	\N	115939	115939	283644
14304	16725	79	applied	\N	\N	\N	\N	115940	115940	283645
14341	17199	2	applied	\N	\N	\N	\N	116147	116147	283852
14341	17200	3	applied	\N	\N	\N	\N	116148	116148	283853
14344	17201	0	applied	\N	\N	\N	\N	116163	116163	283868
14344	17202	1	applied	\N	\N	\N	\N	116164	116164	283869
14344	17203	2	applied	\N	\N	\N	\N	116165	116165	283870
14344	17204	3	applied	\N	\N	\N	\N	116166	116166	283871
14344	17205	4	applied	\N	\N	\N	\N	116167	116167	283872
14344	17206	5	applied	\N	\N	\N	\N	116168	116168	283873
14344	17207	6	applied	\N	\N	\N	\N	116169	116169	283874
14346	17209	1	applied	\N	\N	\N	\N	116179	116179	283884
14346	17210	2	applied	\N	\N	\N	\N	116180	116180	283885
14346	17211	3	applied	\N	\N	\N	\N	116181	116181	283886
14346	17212	4	applied	\N	\N	\N	\N	116182	116182	283887
14346	17213	5	applied	\N	\N	\N	\N	116183	116183	283888
14346	17214	6	applied	\N	\N	\N	\N	116184	116184	283889
14346	17215	7	applied	\N	\N	\N	\N	116185	116185	283890
14348	16554	1	applied	\N	\N	\N	\N	116191	116191	283895
14348	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	116190	116190	\N
14348	16555	2	applied	\N	\N	\N	\N	116192	116192	283896
14348	16563	3	applied	\N	\N	\N	\N	116193	116193	283897
14348	16567	4	applied	\N	\N	\N	\N	116194	116194	283898
14348	16572	5	applied	\N	\N	\N	\N	116195	116195	283899
14348	16573	6	applied	\N	\N	\N	\N	116196	116196	283900
14348	17018	7	applied	\N	\N	\N	\N	116197	116197	283901
14348	17019	8	applied	\N	\N	\N	\N	116198	116198	283902
14348	17021	10	applied	\N	\N	\N	\N	116200	116200	283904
14348	16580	11	applied	\N	\N	\N	\N	116201	116201	283905
14348	16584	12	applied	\N	\N	\N	\N	116202	116202	283906
14348	16592	13	applied	\N	\N	\N	\N	116203	116203	283907
14348	16596	14	applied	\N	\N	\N	\N	116204	116204	283908
14348	16600	15	applied	\N	\N	\N	\N	116205	116205	283909
14348	16604	16	applied	\N	\N	\N	\N	116206	116206	283910
14348	16608	17	applied	\N	\N	\N	\N	116207	116207	283911
14348	16609	18	applied	\N	\N	\N	\N	116208	116208	283912
14348	16616	19	applied	\N	\N	\N	\N	116209	116209	283913
14348	16623	20	applied	\N	\N	\N	\N	116210	116210	283914
14348	16624	21	applied	\N	\N	\N	\N	116211	116211	283915
14348	16631	22	applied	\N	\N	\N	\N	116212	116212	283916
14348	16635	23	applied	\N	\N	\N	\N	116213	116213	283917
14348	16639	24	applied	\N	\N	\N	\N	116214	116214	283918
14348	16643	25	applied	\N	\N	\N	\N	116215	116215	283919
14348	16650	27	applied	\N	\N	\N	\N	116217	116217	283921
14348	16654	28	applied	\N	\N	\N	\N	116218	116218	283922
14348	16658	29	applied	\N	\N	\N	\N	116219	116219	283923
14348	16662	30	applied	\N	\N	\N	\N	116220	116220	283924
14348	16663	31	applied	\N	\N	\N	\N	116221	116221	283925
14348	16664	32	applied	\N	\N	\N	\N	116222	116222	283926
14348	16674	33	applied	\N	\N	\N	\N	116223	116223	283927
14348	16678	34	applied	\N	\N	\N	\N	116224	116224	283928
14348	16682	35	applied	\N	\N	\N	\N	116225	116225	283929
14348	16686	36	applied	\N	\N	\N	\N	116226	116226	283930
14348	16690	37	applied	\N	\N	\N	\N	116227	116227	283931
14348	16694	38	applied	\N	\N	\N	\N	116228	116228	283932
14348	16695	39	applied	\N	\N	\N	\N	116229	116229	283933
14348	16696	40	applied	\N	\N	\N	\N	116230	116230	283934
14348	16705	41	applied	\N	\N	\N	\N	116231	116231	283935
14348	16708	42	applied	\N	\N	\N	\N	116232	116232	283936
14348	16714	44	applied	\N	\N	\N	\N	116234	116234	283938
14348	16717	45	applied	\N	\N	\N	\N	116235	116235	283939
14348	16720	46	applied	\N	\N	\N	\N	116236	116236	283940
14348	16721	47	applied	\N	\N	\N	\N	116237	116237	283941
14348	16726	48	applied	\N	\N	\N	\N	116238	116238	283942
14348	16729	49	applied	\N	\N	\N	\N	116239	116239	283943
14348	16732	50	applied	\N	\N	\N	\N	116240	116240	283944
14348	16735	51	applied	\N	\N	\N	\N	116241	116241	283945
14348	16740	52	applied	\N	\N	\N	\N	116242	116242	283946
14348	16743	53	applied	\N	\N	\N	\N	116243	116243	283947
14348	16746	54	applied	\N	\N	\N	\N	116244	116244	283948
14348	16747	55	applied	\N	\N	\N	\N	116245	116245	283949
14348	16752	56	applied	\N	\N	\N	\N	116246	116246	283950
14348	16753	57	applied	\N	\N	\N	\N	116247	116247	283951
14348	16754	58	applied	\N	\N	\N	\N	116248	116248	283952
14348	16763	59	applied	\N	\N	\N	\N	116249	116249	283953
14348	16772	61	applied	\N	\N	\N	\N	116251	116251	283955
14348	16773	62	applied	\N	\N	\N	\N	116252	116252	283956
14348	16780	63	applied	\N	\N	\N	\N	116253	116253	283957
14348	16781	64	applied	\N	\N	\N	\N	116254	116254	283958
14348	16786	65	applied	\N	\N	\N	\N	116255	116255	283959
14348	16790	66	applied	\N	\N	\N	\N	116256	116256	283960
14348	16792	67	applied	\N	\N	\N	\N	116257	116257	283961
14348	16795	68	applied	\N	\N	\N	\N	116258	116258	283962
14348	16799	69	applied	\N	\N	\N	\N	116259	116259	283963
14348	16800	70	applied	\N	\N	\N	\N	116260	116260	283964
14348	16805	71	applied	\N	\N	\N	\N	116261	116261	283965
14348	16809	72	applied	\N	\N	\N	\N	116262	116262	283966
14348	16812	73	applied	\N	\N	\N	\N	116263	116263	283967
14348	16813	75	applied	\N	\N	\N	\N	116264	116264	283968
14348	16820	76	applied	\N	\N	\N	\N	116265	116265	283969
14348	16821	77	applied	\N	\N	\N	\N	116266	116266	283970
14348	16828	79	applied	\N	\N	\N	\N	116268	116268	283972
14348	16835	80	applied	\N	\N	\N	\N	116269	116269	283973
14348	16838	81	applied	\N	\N	\N	\N	116270	116270	283974
14348	16842	82	applied	\N	\N	\N	\N	116271	116271	283975
14348	16846	83	applied	\N	\N	\N	\N	116272	116272	283976
14348	16850	84	applied	\N	\N	\N	\N	116273	116273	283977
14348	16854	85	applied	\N	\N	\N	\N	116274	116274	283978
14348	16858	86	applied	\N	\N	\N	\N	116275	116275	283979
14348	16862	87	applied	\N	\N	\N	\N	116276	116276	283980
14348	16866	88	applied	\N	\N	\N	\N	116277	116277	283981
14348	16867	89	applied	\N	\N	\N	\N	116278	116278	283982
14348	16868	90	applied	\N	\N	\N	\N	116279	116279	283983
14348	16877	91	applied	\N	\N	\N	\N	116280	116280	283984
14348	16883	92	applied	\N	\N	\N	\N	116281	116281	283985
14348	16884	93	applied	\N	\N	\N	\N	116282	116282	283986
14348	16889	94	applied	\N	\N	\N	\N	116283	116283	283987
14348	16897	96	applied	\N	\N	\N	\N	116285	116285	283989
14348	16901	97	applied	\N	\N	\N	\N	116286	116286	283990
14362	16850	26	applied	\N	\N	\N	\N	116400	116400	284104
14362	16854	27	applied	\N	\N	\N	\N	116401	116401	284105
14341	17197	0	applied	\N	\N	\N	\N	116145	116145	283850
14341	17198	1	applied	\N	\N	\N	\N	116146	116146	283851
14343	17202	1	applied	\N	\N	\N	\N	116157	116157	283862
14343	17203	2	applied	\N	\N	\N	\N	116158	116158	283863
14343	17204	3	applied	\N	\N	\N	\N	116159	116159	283864
14343	17205	4	applied	\N	\N	\N	\N	116160	116160	283865
14343	17206	5	applied	\N	\N	\N	\N	116161	116161	283866
14343	17207	6	applied	\N	\N	\N	\N	116162	116162	283867
14345	17208	0	applied	\N	\N	\N	\N	116170	116170	283875
14345	17209	1	applied	\N	\N	\N	\N	116171	116171	283876
14345	17210	2	applied	\N	\N	\N	\N	116172	116172	283877
14345	17211	3	applied	\N	\N	\N	\N	116173	116173	283878
14345	17212	4	applied	\N	\N	\N	\N	116174	116174	283879
14345	17213	5	applied	\N	\N	\N	\N	116175	116175	283880
14345	17214	6	applied	\N	\N	\N	\N	116176	116176	283881
14347	17216	0	applied	\N	\N	\N	\N	116186	116186	283891
14347	17217	1	applied	\N	\N	\N	\N	116187	116187	283892
14347	17218	2	applied	\N	\N	\N	\N	116188	116188	283893
14347	17219	3	applied	\N	\N	\N	\N	116189	116189	283894
14348	16905	98	applied	\N	\N	\N	\N	116287	116287	283991
14348	16909	99	applied	\N	\N	\N	\N	116288	116288	283992
14350	17223	0	applied	\N	\N	\N	\N	116318	116318	284022
14350	17224	1	applied	\N	\N	\N	\N	116319	116319	284023
14350	17225	2	applied	\N	\N	\N	\N	116320	116320	284024
14350	17226	3	applied	\N	\N	\N	\N	116321	116321	284025
14350	17227	4	applied	\N	\N	\N	\N	116322	116322	284026
14350	17228	5	applied	\N	\N	\N	\N	116323	116323	284027
14350	17229	6	applied	\N	\N	\N	\N	116324	116324	284028
14352	17230	0	applied	\N	\N	\N	\N	116332	116332	284036
14352	17231	1	applied	\N	\N	\N	\N	116333	116333	284037
14352	17232	2	applied	\N	\N	\N	\N	116334	116334	284038
14357	17240	0	applied	\N	\N	\N	\N	116353	116353	284057
14357	17018	1	applied	\N	\N	\N	\N	116354	116354	284058
14357	17019	2	applied	\N	\N	\N	\N	116355	116355	284059
14357	17020	3	applied	\N	\N	\N	\N	116356	116356	284060
14357	17021	4	applied	\N	\N	\N	\N	116357	116357	284061
14357	17072	5	applied	\N	\N	1000000000	\N	116358	116358	284062
14360	17247	0	applied	\N	\N	\N	\N	116367	116367	284071
14360	17248	1	applied	\N	\N	\N	\N	116368	116368	284072
14360	17249	2	applied	\N	\N	\N	\N	116369	116369	284073
14360	17250	3	applied	\N	\N	\N	\N	116370	116370	284074
14370	17258	0	applied	\N	\N	\N	\N	116645	116645	284349
14370	17259	1	applied	\N	\N	\N	\N	116646	116646	284350
14370	17260	2	applied	\N	\N	\N	\N	116647	116647	284351
14384	17285	0	applied	\N	\N	\N	\N	116881	116881	284584
14384	17286	1	applied	\N	\N	\N	\N	116882	116882	284585
14384	17287	2	applied	\N	\N	\N	\N	116883	116883	284586
14384	17289	4	applied	\N	\N	\N	\N	116885	116885	284588
14384	17290	5	applied	\N	\N	\N	\N	116886	116886	284589
14386	17291	0	applied	\N	\N	\N	\N	116893	116893	284596
14386	17292	1	applied	\N	\N	\N	\N	116894	116894	284597
14386	17293	2	applied	\N	\N	\N	\N	116895	116895	284598
14394	17314	0	applied	\N	\N	\N	\N	116926	116926	284629
14394	17315	1	applied	\N	\N	\N	\N	116927	116927	284630
14394	17316	2	applied	\N	\N	\N	\N	116928	116928	284631
14400	17320	0	applied	\N	\N	\N	\N	116940	116940	284643
14400	17321	1	applied	\N	\N	\N	\N	116941	116941	284644
14400	17322	2	applied	\N	\N	\N	\N	116942	116942	284645
14401	17323	0	applied	\N	\N	\N	\N	116943	116943	284646
14401	17324	1	applied	\N	\N	\N	\N	116944	116944	284647
14401	17325	2	applied	\N	\N	\N	\N	116945	116945	284648
14404	17240	0	applied	\N	\N	\N	\N	116954	116954	284657
14404	17018	1	applied	\N	\N	\N	\N	116955	116955	284658
14404	17020	3	applied	\N	\N	\N	\N	116957	116957	284660
14404	17021	4	applied	\N	\N	\N	\N	116958	116958	284661
14404	17072	5	applied	\N	\N	1000000000	\N	116959	116959	284662
14406	17330	0	applied	\N	\N	\N	\N	116962	116962	284665
14406	17331	1	applied	\N	\N	\N	\N	116963	116963	284666
14409	17330	0	applied	\N	\N	\N	\N	116968	116968	284671
14409	17331	1	applied	\N	\N	\N	\N	116969	116969	284672
14414	17344	0	applied	\N	\N	\N	\N	116989	116989	284691
14414	17345	1	applied	\N	\N	\N	\N	116990	116990	284692
14414	17346	2	applied	\N	\N	\N	\N	116991	116991	116991
14414	17350	3	applied	\N	\N	\N	\N	116992	116992	284693
14414	17348	4	applied	\N	\N	\N	\N	116993	116993	284694
14414	17351	5	applied	\N	\N	\N	\N	116994	116994	284695
14414	17352	6	applied	\N	\N	\N	\N	116995	116995	284696
14414	17353	7	applied	\N	\N	\N	\N	116996	116996	284697
14414	17354	8	applied	\N	\N	\N	\N	116997	116997	284698
14414	17356	10	applied	\N	\N	\N	\N	116999	116999	284700
14414	17357	11	applied	\N	\N	\N	\N	117000	117000	284701
14414	17358	12	applied	\N	\N	\N	\N	117001	117001	284702
14416	17362	0	applied	\N	\N	\N	\N	117012	117012	284713
14416	17363	1	applied	\N	\N	\N	\N	117013	117013	284714
14416	17364	2	applied	\N	\N	\N	\N	117014	117014	284715
14420	17365	0	applied	\N	\N	\N	\N	117020	117020	284721
14425	17327	0	applied	\N	\N	\N	\N	117036	117036	284737
14425	17346	1	applied	\N	\N	\N	\N	117037	117037	117037
14430	16647	0	applied	\N	\N	\N	\N	117054	117054	284754
14430	16650	1	applied	\N	\N	\N	\N	117055	117055	284755
14430	16654	2	applied	\N	\N	\N	\N	117056	117056	284756
14430	16658	3	applied	\N	\N	\N	\N	117057	117057	284757
14430	16662	4	applied	\N	\N	\N	\N	117058	117058	284758
14430	16663	5	applied	\N	\N	\N	\N	117059	117059	284759
14430	16664	6	applied	\N	\N	\N	\N	117060	117060	284760
14430	16678	8	applied	\N	\N	\N	\N	117062	117062	284762
14430	16682	9	applied	\N	\N	\N	\N	117063	117063	284763
14430	16686	10	applied	\N	\N	\N	\N	117064	117064	284764
14430	16690	11	applied	\N	\N	\N	\N	117065	117065	284765
14430	16694	12	applied	\N	\N	\N	\N	117066	117066	284766
14430	16695	13	applied	\N	\N	\N	\N	117067	117067	284767
14430	16696	14	applied	\N	\N	\N	\N	117068	117068	284768
14430	16705	15	applied	\N	\N	\N	\N	117069	117069	284769
14430	16708	16	applied	\N	\N	\N	\N	117070	117070	284770
14430	16709	17	applied	\N	\N	\N	\N	117071	117071	284771
14430	16714	18	applied	\N	\N	\N	\N	117072	117072	284772
14430	16717	19	applied	\N	\N	\N	\N	117073	117073	284773
14430	16720	20	applied	\N	\N	\N	\N	117074	117074	284774
14430	16721	21	applied	\N	\N	\N	\N	117075	117075	284775
14430	16726	22	applied	\N	\N	\N	\N	117076	117076	284776
14430	16729	23	applied	\N	\N	\N	\N	117077	117077	284777
14340	17200	3	applied	\N	\N	\N	\N	116144	116144	283849
14343	17201	0	applied	\N	\N	\N	\N	116156	116156	283861
14349	17221	1	applied	\N	\N	\N	\N	116316	116316	284020
14349	17222	2	applied	\N	\N	\N	\N	116317	116317	284021
14359	17247	0	applied	\N	\N	\N	\N	116363	116363	284067
14359	17248	1	applied	\N	\N	\N	\N	116364	116364	284068
14359	17249	2	applied	\N	\N	\N	\N	116365	116365	284069
14359	17250	3	applied	\N	\N	\N	\N	116366	116366	284070
14363	17247	0	applied	\N	\N	\N	\N	116500	116500	284204
14363	17248	1	applied	\N	\N	\N	\N	116501	116501	284205
14363	17249	2	applied	\N	\N	\N	\N	116502	116502	284206
14363	17250	3	applied	\N	\N	\N	\N	116503	116503	284207
14368	17255	0	applied	\N	\N	\N	\N	116639	116639	284343
14368	17256	1	applied	\N	\N	\N	\N	116640	116640	284344
14368	17257	2	applied	\N	\N	\N	\N	116641	116641	284345
14376	16708	0	applied	\N	\N	\N	\N	116654	116654	284358
14376	17240	1	applied	\N	\N	\N	\N	116655	116655	284359
14376	17018	2	applied	\N	\N	\N	\N	116656	116656	284360
14376	17020	4	applied	\N	\N	\N	\N	116658	116658	284362
14376	17021	5	applied	\N	\N	\N	\N	116659	116659	284363
14376	16709	6	applied	\N	\N	\N	\N	116660	116660	284364
14376	16714	7	applied	\N	\N	\N	\N	116661	116661	284365
14376	16717	8	applied	\N	\N	\N	\N	116662	116662	284366
14376	16720	9	applied	\N	\N	\N	\N	116663	116663	284367
14376	16721	10	applied	\N	\N	\N	\N	116664	116664	284368
14376	16726	11	applied	\N	\N	\N	\N	116665	116665	284369
14376	16729	12	applied	\N	\N	\N	\N	116666	116666	284370
14376	16732	13	applied	\N	\N	\N	\N	116667	116667	284371
14376	16735	14	applied	\N	\N	\N	\N	116668	116668	284372
14376	16740	15	applied	\N	\N	\N	\N	116669	116669	284373
14376	16743	16	applied	\N	\N	\N	\N	116670	116670	284374
14376	16746	17	applied	\N	\N	\N	\N	116671	116671	284375
14376	16747	18	applied	\N	\N	\N	\N	116672	116672	284376
14376	16752	19	applied	\N	\N	\N	\N	116673	116673	284377
14376	16754	21	applied	\N	\N	\N	\N	116675	116675	284379
14376	16763	22	applied	\N	\N	\N	\N	116676	116676	284380
14376	16767	23	applied	\N	\N	\N	\N	116677	116677	284381
14376	16772	24	applied	\N	\N	\N	\N	116678	116678	284382
14376	16773	25	applied	\N	\N	\N	\N	116679	116679	284383
14376	16780	26	applied	\N	\N	\N	\N	116680	116680	284384
14376	16781	27	applied	\N	\N	\N	\N	116681	116681	284385
14376	16786	28	applied	\N	\N	\N	\N	116682	116682	284386
14376	16790	29	applied	\N	\N	\N	\N	116683	116683	284387
14376	16792	30	applied	\N	\N	\N	\N	116684	116684	284388
14376	16795	31	applied	\N	\N	\N	\N	116685	116685	284389
14376	16799	32	applied	\N	\N	\N	\N	116686	116686	284390
14376	16800	33	applied	\N	\N	\N	\N	116687	116687	284391
14376	16805	34	applied	\N	\N	\N	\N	116688	116688	284392
14376	16809	35	applied	\N	\N	\N	\N	116689	116689	284393
14376	16812	36	applied	\N	\N	\N	\N	116690	116690	284394
14376	16820	38	applied	\N	\N	\N	\N	116692	116692	284396
14376	16821	39	applied	\N	\N	\N	\N	116693	116693	284397
14376	16827	40	applied	\N	\N	\N	\N	116694	116694	284398
14376	16828	41	applied	\N	\N	\N	\N	116695	116695	284399
14376	16835	42	applied	\N	\N	\N	\N	116696	116696	284400
14376	16838	43	applied	\N	\N	\N	\N	116697	116697	284401
14376	16842	44	applied	\N	\N	\N	\N	116698	116698	284402
14376	16846	45	applied	\N	\N	\N	\N	116699	116699	284403
14376	16850	46	applied	\N	\N	\N	\N	116700	116700	284404
14376	16854	47	applied	\N	\N	\N	\N	116701	116701	284405
14376	16858	48	applied	\N	\N	\N	\N	116702	116702	284406
14376	16862	49	applied	\N	\N	\N	\N	116703	116703	284407
14376	16866	50	applied	\N	\N	\N	\N	116704	116704	284408
14376	16867	51	applied	\N	\N	\N	\N	116705	116705	284409
14376	16868	52	applied	\N	\N	\N	\N	116706	116706	284410
14376	16877	53	applied	\N	\N	\N	\N	116707	116707	284411
14376	16884	55	applied	\N	\N	\N	\N	116709	116709	284413
14376	16889	56	applied	\N	\N	\N	\N	116710	116710	284414
14376	16893	57	applied	\N	\N	\N	\N	116711	116711	284415
14376	16897	58	applied	\N	\N	\N	\N	116712	116712	284416
14376	16901	59	applied	\N	\N	\N	\N	116713	116713	284417
14376	16905	60	applied	\N	\N	\N	\N	116714	116714	284418
14376	16909	61	applied	\N	\N	\N	\N	116715	116715	284419
14376	16913	62	applied	\N	\N	\N	\N	116716	116716	284420
14376	16920	63	applied	\N	\N	\N	\N	116717	116717	284421
14376	16921	64	applied	\N	\N	\N	\N	116718	116718	284422
14376	16928	65	applied	\N	\N	\N	\N	116719	116719	284423
14376	16932	66	applied	\N	\N	\N	\N	116720	116720	284424
14376	16936	67	applied	\N	\N	\N	\N	116721	116721	284425
14376	16939	68	applied	\N	\N	\N	\N	116722	116722	284426
14376	16940	69	applied	\N	\N	\N	\N	116723	116723	284427
14376	16947	70	applied	\N	\N	\N	\N	116724	116724	284428
14376	16955	72	applied	\N	\N	\N	\N	116726	116726	284430
14376	16958	73	applied	\N	\N	\N	\N	116727	116727	284431
14376	16959	74	applied	\N	\N	\N	\N	116728	116728	284432
14376	16966	75	applied	\N	\N	\N	\N	116729	116729	284433
14376	16970	76	applied	\N	\N	\N	\N	116730	116730	284434
14376	16974	77	applied	\N	\N	\N	\N	116731	116731	284435
14376	16978	78	applied	\N	\N	\N	\N	116732	116732	284436
14376	16982	79	applied	\N	\N	\N	\N	116733	116733	284437
14376	16987	80	applied	\N	\N	\N	\N	116734	116734	284438
14376	16991	81	applied	\N	\N	\N	\N	116735	116735	284439
14376	16992	82	applied	\N	\N	\N	\N	116736	116736	284440
14376	16993	83	applied	\N	\N	\N	\N	116737	116737	284441
14376	17003	84	applied	\N	\N	\N	\N	116738	116738	284442
14376	17007	85	applied	\N	\N	\N	\N	116739	116739	284443
14376	17008	86	applied	\N	\N	\N	\N	116740	116740	284444
14376	17015	87	applied	\N	\N	\N	\N	116741	116741	284445
14376	17023	89	applied	\N	\N	\N	\N	116743	116743	284447
14376	17030	90	applied	\N	\N	\N	\N	116744	116744	284448
14376	17034	91	applied	\N	\N	\N	\N	116745	116745	284449
14376	17035	92	applied	\N	\N	\N	\N	116746	116746	284450
14376	17042	93	applied	\N	\N	\N	\N	116747	116747	284451
14376	17043	94	applied	\N	\N	\N	\N	116748	116748	284452
14376	17050	95	applied	\N	\N	\N	\N	116749	116749	284453
14376	17056	96	applied	\N	\N	\N	\N	116750	116750	284454
14376	17057	97	applied	\N	\N	\N	\N	116751	116751	284455
14376	17061	98	applied	\N	\N	\N	\N	116752	116752	284456
14376	17067	99	applied	\N	\N	\N	\N	116753	116753	284457
14376	17068	100	applied	\N	\N	\N	\N	116754	116754	284458
14430	16735	25	applied	\N	\N	\N	\N	117079	117079	284779
14430	16740	26	applied	\N	\N	\N	\N	117080	117080	284780
14342	17206	5	applied	\N	\N	\N	\N	116154	116154	283859
14342	17207	6	applied	\N	\N	\N	\N	116155	116155	283860
14348	16932	104	applied	\N	\N	\N	\N	116293	116293	283997
14348	16936	105	applied	\N	\N	\N	\N	116294	116294	283998
14348	16939	106	applied	\N	\N	\N	\N	116295	116295	283999
14348	16940	107	applied	\N	\N	\N	\N	116296	116296	284000
14348	16947	108	applied	\N	\N	\N	\N	116297	116297	284001
14348	16951	109	applied	\N	\N	\N	\N	116298	116298	284002
14348	16955	110	applied	\N	\N	\N	\N	116299	116299	284003
14348	16958	111	applied	\N	\N	\N	\N	116300	116300	284004
14348	16959	112	applied	\N	\N	\N	\N	116301	116301	284005
14348	16966	113	applied	\N	\N	\N	\N	116302	116302	284006
14348	16970	114	applied	\N	\N	\N	\N	116303	116303	284007
14348	16974	115	applied	\N	\N	\N	\N	116304	116304	284008
14348	16978	116	applied	\N	\N	\N	\N	116305	116305	284009
14348	16982	117	applied	\N	\N	\N	\N	116306	116306	284010
14348	16991	119	applied	\N	\N	\N	\N	116308	116308	284012
14348	16992	120	applied	\N	\N	\N	\N	116309	116309	284013
14348	16993	121	applied	\N	\N	\N	\N	116310	116310	284014
14348	17003	122	applied	\N	\N	\N	\N	116311	116311	284015
14348	17007	123	applied	\N	\N	\N	\N	116312	116312	284016
14348	17008	124	applied	\N	\N	\N	\N	116313	116313	284017
14348	17015	125	applied	\N	\N	\N	\N	116314	116314	284018
14351	17223	0	applied	\N	\N	\N	\N	116325	116325	284029
14351	17224	1	applied	\N	\N	\N	\N	116326	116326	284030
14351	17225	2	applied	\N	\N	\N	\N	116327	116327	284031
14351	17226	3	applied	\N	\N	\N	\N	116328	116328	284032
14351	17227	4	applied	\N	\N	\N	\N	116329	116329	284033
14351	17228	5	applied	\N	\N	\N	\N	116330	116330	284034
14351	17229	6	applied	\N	\N	\N	\N	116331	116331	284035
14353	17234	0	applied	\N	\N	\N	\N	116336	116336	284040
14353	17235	1	applied	\N	\N	\N	\N	116337	116337	284041
14353	17237	3	applied	\N	\N	\N	\N	116339	116339	284043
14355	17238	0	applied	\N	\N	\N	\N	116344	116344	284048
14361	17247	0	applied	\N	\N	\N	\N	116371	116371	284075
14361	17248	1	applied	\N	\N	\N	\N	116372	116372	284076
14361	17249	2	applied	\N	\N	\N	\N	116373	116373	284077
14361	17250	3	applied	\N	\N	\N	\N	116374	116374	284078
14364	17240	0	applied	\N	\N	\N	\N	116504	116504	284208
14364	17022	1	applied	\N	\N	\N	\N	116505	116505	284209
14364	17023	2	applied	\N	\N	\N	\N	116506	116506	284210
14364	17030	3	applied	\N	\N	\N	\N	116507	116507	284211
14364	17034	4	applied	\N	\N	\N	\N	116508	116508	284212
14364	17035	5	applied	\N	\N	\N	\N	116509	116509	284213
14364	17042	6	applied	\N	\N	\N	\N	116510	116510	284214
14364	17043	7	applied	\N	\N	\N	\N	116511	116511	284215
14364	17050	8	applied	\N	\N	\N	\N	116512	116512	284216
14364	17056	9	applied	\N	\N	\N	\N	116513	116513	284217
14364	17061	11	applied	\N	\N	\N	\N	116515	116515	284219
14364	17067	12	applied	\N	\N	\N	\N	116516	116516	284220
14364	17068	13	applied	\N	\N	\N	\N	116517	116517	284221
14364	17076	14	applied	\N	\N	\N	\N	116518	116518	284222
14364	17080	15	applied	\N	\N	\N	\N	116519	116519	284223
14364	17081	16	applied	\N	\N	\N	\N	116520	116520	284224
14364	17088	17	applied	\N	\N	\N	\N	116521	116521	284225
14364	17089	18	applied	\N	\N	\N	\N	116522	116522	284226
14364	17090	19	applied	\N	\N	\N	\N	116523	116523	284227
14364	17100	20	applied	\N	\N	\N	\N	116524	116524	284228
14364	17101	21	applied	\N	\N	\N	\N	116525	116525	284229
14364	17107	22	applied	\N	\N	\N	\N	116526	116526	284230
14364	17108	23	applied	\N	\N	\N	\N	116527	116527	284231
14364	17114	24	applied	\N	\N	\N	\N	116528	116528	284232
14364	17117	25	applied	\N	\N	\N	\N	116529	116529	284233
14364	17121	26	applied	\N	\N	\N	\N	116530	116530	284234
14364	17127	28	applied	\N	\N	\N	\N	116532	116532	284236
14364	17131	29	applied	\N	\N	\N	\N	116533	116533	284237
14364	17132	30	applied	\N	\N	\N	\N	116534	116534	284238
14364	17138	31	applied	\N	\N	\N	\N	116535	116535	284239
14364	17142	32	applied	\N	\N	\N	\N	116536	116536	284240
14364	17146	33	applied	\N	\N	\N	\N	116537	116537	284241
14364	17150	34	applied	\N	\N	\N	\N	116538	116538	284242
14364	17154	35	applied	\N	\N	\N	\N	116539	116539	284243
14364	17157	36	applied	\N	\N	\N	\N	116540	116540	284244
14364	17161	37	applied	\N	\N	\N	\N	116541	116541	284245
14364	17162	38	applied	\N	\N	\N	\N	116542	116542	284246
14364	17169	39	applied	\N	\N	\N	\N	116543	116543	284247
14364	17173	40	applied	\N	\N	\N	\N	116544	116544	284248
14364	17174	41	applied	\N	\N	\N	\N	116545	116545	284249
14364	17181	42	applied	\N	\N	\N	\N	116546	116546	284250
14364	17185	43	applied	\N	\N	\N	\N	116547	116547	284251
14364	17190	45	applied	\N	\N	\N	\N	116549	116549	284253
14364	17197	46	applied	\N	\N	\N	\N	116550	116550	284254
14364	17201	47	applied	\N	\N	\N	\N	116551	116551	284255
14364	17208	48	applied	\N	\N	\N	\N	116552	116552	284256
14364	17209	49	applied	\N	\N	\N	\N	116553	116553	284257
14364	17216	50	applied	\N	\N	\N	\N	116554	116554	284258
14364	17220	51	applied	\N	\N	\N	\N	116555	116555	284259
14364	17223	52	applied	\N	\N	\N	\N	116556	116556	284260
14364	17224	53	applied	\N	\N	\N	\N	116557	116557	284261
14364	17230	54	applied	\N	\N	\N	\N	116558	116558	284262
14364	17234	55	applied	\N	\N	\N	\N	116559	116559	284263
14364	17238	56	applied	\N	\N	\N	\N	116560	116560	284264
14364	17239	57	applied	\N	\N	\N	\N	116561	116561	284265
14364	17247	58	applied	\N	\N	\N	\N	116562	116562	284266
14364	17251	59	applied	\N	\N	\N	\N	116563	116563	284267
14364	16556	60	applied	\N	\N	\N	\N	116564	116564	284268
14364	16586	62	applied	\N	\N	\N	\N	116566	116566	284270
14364	16568	63	applied	\N	\N	\N	\N	116567	116567	284271
14364	17072	64	applied	\N	\N	1000000000	\N	116568	116568	284272
14364	16557	65	applied	\N	\N	\N	\N	116569	116569	284273
14364	16558	66	applied	\N	\N	\N	\N	116570	116570	284274
14364	16559	67	applied	\N	\N	\N	\N	116571	116571	284275
14364	16560	68	applied	\N	\N	\N	\N	116572	116572	284276
14364	16561	69	applied	\N	\N	\N	\N	116573	116573	284277
14364	16564	70	applied	\N	\N	\N	\N	116574	116574	284278
14364	16565	71	applied	\N	\N	\N	\N	116575	116575	284279
14364	16566	72	applied	\N	\N	\N	\N	116576	116576	284280
14364	16569	73	applied	\N	\N	\N	\N	116577	116577	284281
14364	16570	75	applied	\N	\N	\N	\N	116578	116578	284282
14364	16571	76	applied	\N	\N	\N	\N	116579	116579	284283
14376	17076	101	applied	\N	\N	\N	\N	116755	116755	284459
14376	17080	102	applied	\N	\N	\N	\N	116756	116756	284460
14348	16928	103	applied	\N	\N	\N	\N	116292	116292	283996
14362	16868	32	applied	\N	\N	\N	\N	116406	116406	284110
14362	16877	33	applied	\N	\N	\N	\N	116407	116407	284111
14362	16883	34	applied	\N	\N	\N	\N	116408	116408	284112
14362	16884	35	applied	\N	\N	\N	\N	116409	116409	284113
14362	16889	36	applied	\N	\N	\N	\N	116410	116410	284114
14362	16893	37	applied	\N	\N	\N	\N	116411	116411	284115
14362	16897	38	applied	\N	\N	\N	\N	116412	116412	284116
14362	16901	39	applied	\N	\N	\N	\N	116413	116413	284117
14362	16905	40	applied	\N	\N	\N	\N	116414	116414	284118
14362	16909	41	applied	\N	\N	\N	\N	116415	116415	284119
14362	16913	42	applied	\N	\N	\N	\N	116416	116416	284120
14362	16920	43	applied	\N	\N	\N	\N	116417	116417	284121
14362	16921	44	applied	\N	\N	\N	\N	116418	116418	284122
14362	16928	45	applied	\N	\N	\N	\N	116419	116419	284123
14362	16936	47	applied	\N	\N	\N	\N	116421	116421	284125
14362	16939	48	applied	\N	\N	\N	\N	116422	116422	284126
14362	16940	49	applied	\N	\N	\N	\N	116423	116423	284127
14362	16947	50	applied	\N	\N	\N	\N	116424	116424	284128
14362	16951	51	applied	\N	\N	\N	\N	116425	116425	284129
14362	16955	52	applied	\N	\N	\N	\N	116426	116426	284130
14362	16958	53	applied	\N	\N	\N	\N	116427	116427	284131
14362	16959	54	applied	\N	\N	\N	\N	116428	116428	284132
14362	16966	55	applied	\N	\N	\N	\N	116429	116429	284133
14362	16970	56	applied	\N	\N	\N	\N	116430	116430	284134
14362	16974	57	applied	\N	\N	\N	\N	116431	116431	284135
14362	16978	58	applied	\N	\N	\N	\N	116432	116432	284136
14362	16982	59	applied	\N	\N	\N	\N	116433	116433	284137
14362	16987	60	applied	\N	\N	\N	\N	116434	116434	284138
14362	16991	61	applied	\N	\N	\N	\N	116435	116435	284139
14362	16992	62	applied	\N	\N	\N	\N	116436	116436	284140
14362	17003	64	applied	\N	\N	\N	\N	116438	116438	284142
14362	17007	65	applied	\N	\N	\N	\N	116439	116439	284143
14362	17008	66	applied	\N	\N	\N	\N	116440	116440	284144
14362	17015	67	applied	\N	\N	\N	\N	116441	116441	284145
14362	17022	68	applied	\N	\N	\N	\N	116442	116442	284146
14362	17023	69	applied	\N	\N	\N	\N	116443	116443	284147
14362	17030	70	applied	\N	\N	\N	\N	116444	116444	284148
14362	17034	71	applied	\N	\N	\N	\N	116445	116445	284149
14362	17035	72	applied	\N	\N	\N	\N	116446	116446	284150
14362	17042	73	applied	\N	\N	\N	\N	116447	116447	284151
14362	17043	74	applied	\N	\N	\N	\N	116448	116448	284152
14362	17050	75	applied	\N	\N	\N	\N	116449	116449	284153
14362	17056	76	applied	\N	\N	\N	\N	116450	116450	284154
14362	17057	77	applied	\N	\N	\N	\N	116451	116451	284155
14362	17061	78	applied	\N	\N	\N	\N	116452	116452	284156
14362	17067	79	applied	\N	\N	\N	\N	116453	116453	284157
14362	17076	81	applied	\N	\N	\N	\N	116455	116455	284159
14362	17080	82	applied	\N	\N	\N	\N	116456	116456	284160
14362	17081	83	applied	\N	\N	\N	\N	116457	116457	284161
14362	17088	84	applied	\N	\N	\N	\N	116458	116458	284162
14362	17089	85	applied	\N	\N	\N	\N	116459	116459	284163
14362	17090	86	applied	\N	\N	\N	\N	116460	116460	284164
14362	17100	87	applied	\N	\N	\N	\N	116461	116461	284165
14362	17101	88	applied	\N	\N	\N	\N	116462	116462	284166
14362	17107	89	applied	\N	\N	\N	\N	116463	116463	284167
14362	17108	90	applied	\N	\N	\N	\N	116464	116464	284168
14362	17114	91	applied	\N	\N	\N	\N	116465	116465	284169
14362	17117	92	applied	\N	\N	\N	\N	116466	116466	284170
14362	17121	93	applied	\N	\N	\N	\N	116467	116467	284171
14362	17124	94	applied	\N	\N	\N	\N	116468	116468	284172
14362	17127	95	applied	\N	\N	\N	\N	116469	116469	284173
14362	17131	96	applied	\N	\N	\N	\N	116470	116470	284174
14362	17138	98	applied	\N	\N	\N	\N	116472	116472	284176
14362	17142	99	applied	\N	\N	\N	\N	116473	116473	284177
14362	17146	100	applied	\N	\N	\N	\N	116474	116474	284178
14362	17150	101	applied	\N	\N	\N	\N	116475	116475	284179
14362	17154	102	applied	\N	\N	\N	\N	116476	116476	284180
14362	17157	103	applied	\N	\N	\N	\N	116477	116477	284181
14362	17161	104	applied	\N	\N	\N	\N	116478	116478	284182
14362	17162	105	applied	\N	\N	\N	\N	116479	116479	284183
14362	17169	106	applied	\N	\N	\N	\N	116480	116480	284184
14362	17173	107	applied	\N	\N	\N	\N	116481	116481	284185
14362	17174	108	applied	\N	\N	\N	\N	116482	116482	284186
14362	17181	109	applied	\N	\N	\N	\N	116483	116483	284187
14362	17185	110	applied	\N	\N	\N	\N	116484	116484	284188
14362	17189	111	applied	\N	\N	\N	\N	116485	116485	284189
14362	17190	112	applied	\N	\N	\N	\N	116486	116486	284190
14362	17197	113	applied	\N	\N	\N	\N	116487	116487	284191
14362	17208	115	applied	\N	\N	\N	\N	116489	116489	284193
14362	17209	116	applied	\N	\N	\N	\N	116490	116490	284194
14362	17216	117	applied	\N	\N	\N	\N	116491	116491	284195
14362	17220	118	applied	\N	\N	\N	\N	116492	116492	284196
14362	17223	119	applied	\N	\N	\N	\N	116493	116493	284197
14362	17224	120	applied	\N	\N	\N	\N	116494	116494	284198
14362	17230	121	applied	\N	\N	\N	\N	116495	116495	284199
14362	17234	122	applied	\N	\N	\N	\N	116496	116496	284200
14362	17238	123	applied	\N	\N	\N	\N	116497	116497	284201
14362	17239	124	applied	\N	\N	\N	\N	116498	116498	284202
14362	17247	125	applied	\N	\N	\N	\N	116499	116499	284203
14364	16574	77	applied	\N	\N	\N	\N	116580	116580	284284
14364	16575	78	applied	\N	\N	\N	\N	116581	116581	284285
14365	17251	0	applied	\N	\N	\N	\N	116629	116629	284333
14365	17252	1	applied	\N	\N	\N	\N	116630	116630	284334
14365	17253	2	applied	\N	\N	\N	\N	116631	116631	284335
14367	17255	0	applied	\N	\N	\N	\N	116636	116636	284340
14367	17256	1	applied	\N	\N	\N	\N	116637	116637	284341
14367	17257	2	applied	\N	\N	\N	\N	116638	116638	284342
14371	17258	0	applied	\N	\N	\N	\N	116648	116648	284352
14371	17259	1	applied	\N	\N	\N	\N	116649	116649	284353
14371	17260	2	applied	\N	\N	\N	\N	116650	116650	284354
14374	17261	0	applied	\N	\N	\N	\N	116651	116651	284355
14374	17262	1	applied	\N	\N	\N	\N	116652	116652	284356
14374	17263	2	applied	\N	\N	\N	\N	116653	116653	284357
14380	17267	0	applied	\N	\N	\N	\N	116860	116860	284563
14382	17276	0	applied	\N	\N	\N	\N	116872	116872	284575
14382	17277	1	applied	\N	\N	\N	\N	116873	116873	284576
14382	17278	2	applied	\N	\N	\N	\N	116874	116874	284577
14382	17279	3	applied	\N	\N	\N	\N	116875	116875	284578
14382	17280	4	applied	\N	\N	\N	\N	116876	116876	284579
14382	17281	5	applied	\N	\N	\N	\N	116877	116877	284580
14362	16866	30	applied	\N	\N	\N	\N	116404	116404	284108
14362	16867	31	applied	\N	\N	\N	\N	116405	116405	284109
14364	16579	82	applied	\N	\N	\N	\N	116585	116585	284289
14364	16581	83	applied	\N	\N	\N	\N	116586	116586	284290
14364	16582	84	applied	\N	\N	\N	\N	116587	116587	284291
14364	16583	85	applied	\N	\N	\N	\N	116588	116588	284292
14364	16585	86	applied	\N	\N	\N	\N	116589	116589	284293
14364	16588	88	applied	\N	\N	\N	\N	116591	116591	284295
14364	16589	89	applied	\N	\N	\N	\N	116592	116592	284296
14364	16590	90	applied	\N	\N	\N	\N	116593	116593	284297
14364	16591	91	applied	\N	\N	\N	\N	116594	116594	284298
14364	16593	92	applied	\N	\N	\N	\N	116595	116595	284299
14364	16594	93	applied	\N	\N	\N	\N	116596	116596	284300
14364	16595	94	applied	\N	\N	\N	\N	116597	116597	284301
14364	16597	95	applied	\N	\N	\N	\N	116598	116598	284302
14364	16598	96	applied	\N	\N	\N	\N	116599	116599	284303
14364	16599	97	applied	\N	\N	\N	\N	116600	116600	284304
14364	16601	98	applied	\N	\N	\N	\N	116601	116601	284305
14364	16602	99	applied	\N	\N	\N	\N	116602	116602	284306
14364	16603	100	applied	\N	\N	\N	\N	116603	116603	284307
14364	16605	101	applied	\N	\N	\N	\N	116604	116604	284308
14364	16606	102	applied	\N	\N	\N	\N	116605	116605	284309
14364	16607	103	applied	\N	\N	\N	\N	116606	116606	284310
14364	16611	105	applied	\N	\N	\N	\N	116608	116608	284312
14364	16612	106	applied	\N	\N	\N	\N	116609	116609	284313
14364	16613	107	applied	\N	\N	\N	\N	116610	116610	284314
14364	16614	108	applied	\N	\N	\N	\N	116611	116611	284315
14364	16615	109	applied	\N	\N	\N	\N	116612	116612	284316
14364	16617	110	applied	\N	\N	\N	\N	116613	116613	284317
14364	16618	111	applied	\N	\N	1000000000	\N	116614	116614	284318
14364	16619	112	applied	\N	\N	1000000000	\N	116615	116615	284319
14364	16620	113	applied	\N	\N	\N	\N	116616	116616	284320
14364	16621	114	applied	\N	\N	\N	\N	116617	116617	284321
14364	16622	115	applied	\N	\N	\N	\N	116618	116618	284322
14364	16625	116	applied	\N	\N	\N	\N	116619	116619	284323
14364	16626	117	applied	\N	\N	\N	\N	116620	116620	284324
14364	16627	118	applied	\N	\N	\N	\N	116621	116621	284325
14364	16628	119	applied	\N	\N	\N	\N	116622	116622	284326
14364	16629	120	applied	\N	\N	\N	\N	116623	116623	284327
14364	16632	122	applied	\N	\N	\N	\N	116625	116625	284329
14364	16633	123	applied	\N	\N	\N	\N	116626	116626	284330
14364	16634	124	applied	\N	\N	\N	\N	116627	116627	284331
14364	16637	125	applied	\N	\N	\N	\N	116628	116628	284332
14366	17255	0	applied	\N	\N	\N	\N	116633	116633	284337
14366	17256	1	applied	\N	\N	\N	\N	116634	116634	284338
14366	17257	2	applied	\N	\N	\N	\N	116635	116635	284339
14369	17255	0	applied	\N	\N	\N	\N	116642	116642	284346
14369	17256	1	applied	\N	\N	\N	\N	116643	116643	284347
14369	17257	2	applied	\N	\N	\N	\N	116644	116644	284348
14377	16460	0	applied	\N	\N	\N	\N	116779	116779	284483
14377	16474	1	applied	\N	\N	\N	\N	116780	116780	284484
14377	16400	3	applied	\N	\N	\N	\N	116782	116782	284485
14377	17240	4	applied	\N	\N	\N	\N	116783	116783	284486
14377	16406	5	applied	\N	\N	\N	\N	116784	116784	284487
14377	16410	6	applied	\N	\N	\N	\N	116785	116785	284488
14377	16414	7	applied	\N	\N	\N	\N	116786	116786	284489
14377	16415	8	applied	\N	\N	\N	\N	116787	116787	284490
14377	17018	9	applied	\N	\N	\N	\N	116788	116788	284491
14377	17019	10	applied	\N	\N	\N	\N	116789	116789	284492
14377	17020	11	applied	\N	\N	\N	\N	116790	116790	284493
14377	17021	12	applied	\N	\N	\N	\N	116791	116791	284494
14377	16422	13	applied	\N	\N	\N	\N	116792	116792	284495
14377	16426	14	applied	\N	\N	\N	\N	116793	116793	284496
14377	16431	15	applied	\N	\N	\N	\N	116794	116794	284497
14377	16432	16	applied	\N	\N	\N	\N	116795	116795	284498
14377	16440	17	applied	\N	\N	\N	\N	116796	116796	284499
14377	16445	18	applied	\N	\N	\N	\N	116797	116797	284500
14377	16446	19	applied	\N	\N	\N	\N	116798	116798	284501
14377	16447	20	applied	\N	\N	\N	\N	116799	116799	284502
14377	16457	21	applied	\N	\N	\N	\N	116800	116800	284503
14377	16459	22	applied	\N	\N	\N	\N	116801	116801	284504
14377	16461	23	applied	\N	\N	\N	\N	116802	116802	284505
14377	16462	24	applied	\N	\N	\N	\N	116803	116803	284506
14377	16475	25	applied	\N	\N	\N	\N	116804	116804	284507
14377	16476	26	applied	\N	\N	\N	\N	116805	116805	284508
14377	16477	27	applied	\N	\N	\N	\N	116806	116806	284509
14377	16487	28	applied	\N	\N	\N	\N	116807	116807	284510
14377	16491	29	applied	\N	\N	\N	\N	116808	116808	284511
14377	16496	30	applied	\N	\N	\N	\N	116809	116809	284512
14377	16504	32	applied	\N	\N	\N	\N	116811	116811	284514
14377	16509	33	applied	\N	\N	\N	\N	116812	116812	284515
14377	16514	34	applied	\N	\N	\N	\N	116813	116813	284516
14377	16516	35	applied	\N	\N	\N	\N	116814	116814	284517
14377	16517	36	applied	\N	\N	\N	\N	116815	116815	284518
14377	16525	37	applied	\N	\N	\N	\N	116816	116816	284519
14377	16530	39	applied	\N	\N	\N	\N	116817	116817	284520
14377	16531	40	applied	\N	\N	\N	\N	116818	116818	284521
14377	16537	41	applied	\N	\N	\N	\N	116819	116819	284522
14377	16540	42	applied	\N	\N	\N	\N	116820	116820	284523
14377	16541	43	applied	\N	\N	\N	\N	116821	116821	284524
14377	16546	44	applied	\N	\N	\N	\N	116822	116822	284525
14377	16547	45	applied	\N	\N	\N	\N	116823	116823	284526
14377	16554	46	applied	\N	\N	\N	\N	116824	116824	284527
14377	16555	47	applied	\N	\N	\N	\N	116825	116825	284528
14377	16563	48	applied	\N	\N	\N	\N	116826	116826	284529
14377	16572	50	applied	\N	\N	\N	\N	116828	116828	284531
14377	16573	51	applied	\N	\N	\N	\N	116829	116829	284532
14377	16580	52	applied	\N	\N	\N	\N	116830	116830	284533
14377	16584	53	applied	\N	\N	\N	\N	116831	116831	284534
14377	16592	54	applied	\N	\N	\N	\N	116832	116832	284535
14377	16596	55	applied	\N	\N	\N	\N	116833	116833	284536
14377	16600	56	applied	\N	\N	\N	\N	116834	116834	284537
14377	16604	57	applied	\N	\N	\N	\N	116835	116835	284538
14377	16608	58	applied	\N	\N	\N	\N	116836	116836	284539
14377	16609	59	applied	\N	\N	\N	\N	116837	116837	284540
14377	16616	60	applied	\N	\N	\N	\N	116838	116838	284541
14377	16623	61	applied	\N	\N	\N	\N	116839	116839	284542
14377	16624	62	applied	\N	\N	\N	\N	116840	116840	284543
14377	16631	63	applied	\N	\N	\N	\N	116841	116841	284544
14377	16635	64	applied	\N	\N	\N	\N	116842	116842	284545
14385	17285	0	applied	\N	\N	\N	\N	116887	116887	284590
14364	16577	80	applied	\N	\N	\N	\N	116583	116583	284287
14364	16578	81	applied	\N	\N	\N	\N	116584	116584	284288
14376	17100	107	applied	\N	\N	\N	\N	116761	116761	284465
14376	17101	108	applied	\N	\N	\N	\N	116762	116762	284466
14376	17107	109	applied	\N	\N	\N	\N	116763	116763	284467
14376	17108	110	applied	\N	\N	\N	\N	116764	116764	284468
14376	17114	111	applied	\N	\N	\N	\N	116765	116765	284469
14376	17117	112	applied	\N	\N	\N	\N	116766	116766	284470
14376	17121	113	applied	\N	\N	\N	\N	116767	116767	284471
14376	17124	114	applied	\N	\N	\N	\N	116768	116768	284472
14376	17127	115	applied	\N	\N	\N	\N	116769	116769	284473
14376	17131	117	applied	\N	\N	\N	\N	116770	116770	284474
14376	17132	118	applied	\N	\N	\N	\N	116771	116771	284475
14376	17138	119	applied	\N	\N	\N	\N	116772	116772	284476
14376	17142	120	applied	\N	\N	\N	\N	116773	116773	284477
14376	17146	121	applied	\N	\N	\N	\N	116774	116774	284478
14376	17150	122	applied	\N	\N	\N	\N	116775	116775	284479
14376	17154	123	applied	\N	\N	\N	\N	116776	116776	284480
14376	17161	125	applied	\N	\N	\N	\N	116778	116778	284482
14377	16639	65	applied	\N	\N	\N	\N	116843	116843	284546
14377	16643	66	applied	\N	\N	\N	\N	116844	116844	284547
14378	17261	0	applied	\N	\N	\N	\N	116845	116845	284548
14378	17264	1	applied	\N	\N	\N	\N	116846	116846	284549
14378	17265	2	applied	\N	\N	\N	\N	116847	116847	284550
14378	17266	3	applied	\N	\N	\N	\N	116848	116848	284551
14383	17282	0	applied	\N	\N	\N	\N	116878	116878	284581
14383	17283	1	applied	\N	\N	\N	\N	116879	116879	284582
14383	17284	2	applied	\N	\N	\N	\N	116880	116880	284583
14389	17294	0	applied	\N	\N	\N	\N	116902	116902	284605
14389	17295	1	applied	\N	\N	\N	\N	116903	116903	284606
14389	17296	2	applied	\N	\N	\N	\N	116904	116904	284607
14389	17297	3	applied	\N	\N	\N	\N	116905	116905	284608
14389	17298	4	applied	\N	\N	\N	\N	116906	116906	284609
14389	17299	5	applied	\N	\N	\N	\N	116907	116907	284610
14389	17301	7	applied	\N	\N	\N	\N	116909	116909	284612
14389	17302	8	applied	\N	\N	\N	\N	116910	116910	284613
14389	17303	9	applied	\N	\N	\N	\N	116911	116911	284614
14389	17304	10	applied	\N	\N	\N	\N	116912	116912	284615
14389	17305	11	applied	\N	\N	\N	\N	116913	116913	284616
14389	17306	12	applied	\N	\N	\N	\N	116914	116914	284617
14389	17307	13	applied	\N	\N	\N	\N	116915	116915	284618
14399	17320	0	applied	\N	\N	\N	\N	116937	116937	284640
14399	17321	1	applied	\N	\N	\N	\N	116938	116938	284641
14399	17322	2	applied	\N	\N	\N	\N	116939	116939	284642
14403	17326	0	applied	\N	\N	\N	\N	116950	116950	284653
14403	17327	1	applied	\N	\N	\N	\N	116951	116951	284654
14403	17328	2	applied	\N	\N	\N	\N	116952	116952	284655
14403	17329	3	applied	\N	\N	\N	\N	116953	116953	284656
14405	17330	0	applied	\N	\N	\N	\N	116960	116960	284663
14405	17331	1	applied	\N	\N	\N	\N	116961	116961	284664
14408	17331	1	applied	\N	\N	\N	\N	116967	116967	284670
14413	17344	0	applied	\N	\N	\N	\N	116983	116983	284686
14413	17345	1	applied	\N	\N	\N	\N	116984	116984	284687
14413	17346	2	applied	\N	\N	\N	\N	116985	116985	116985
14413	17347	3	applied	\N	\N	\N	\N	116986	116986	284688
14413	17348	4	applied	\N	\N	\N	\N	116987	116987	284689
14413	17349	5	applied	\N	\N	\N	\N	116988	116988	284690
14415	17359	0	applied	\N	\N	\N	\N	117002	117002	284703
14415	17352	1	applied	\N	\N	\N	\N	117003	117003	284704
14415	17353	2	applied	\N	\N	\N	\N	117004	117004	284705
14415	17354	3	applied	\N	\N	\N	\N	117005	117005	284706
14415	17355	4	applied	\N	\N	\N	\N	117006	117006	284707
14415	17356	5	applied	\N	\N	\N	\N	117007	117007	284708
14415	17357	6	applied	\N	\N	\N	\N	117008	117008	284709
14415	17358	7	applied	\N	\N	\N	\N	117009	117009	284710
14415	17360	8	applied	\N	\N	\N	\N	117010	117010	284711
14422	17366	0	applied	\N	\N	\N	\N	117026	117026	284727
14422	17367	1	applied	\N	\N	\N	\N	117027	117027	284728
14422	17368	2	applied	\N	\N	\N	\N	117028	117028	284729
14422	17369	3	applied	\N	\N	\N	\N	117029	117029	284730
14422	17370	4	applied	\N	\N	\N	\N	117030	117030	284731
14427	17376	0	applied	\N	\N	\N	\N	117042	117042	284742
14427	17377	1	applied	\N	\N	\N	\N	117043	117043	284743
14427	17378	2	applied	\N	\N	\N	\N	117044	117044	284744
14427	17379	3	applied	\N	\N	\N	\N	117045	117045	284745
14432	17389	0	applied	\N	\N	\N	\N	117100	117100	284800
14432	17390	1	applied	\N	\N	\N	\N	117101	117101	284801
14432	17391	2	applied	\N	\N	\N	\N	117102	117102	284802
14432	17392	3	applied	\N	\N	\N	\N	117103	117103	284803
14432	17393	4	applied	\N	\N	\N	\N	117104	117104	284804
14432	17394	5	applied	\N	\N	\N	\N	117105	117105	284805
14432	17395	6	applied	\N	\N	\N	\N	117106	117106	284806
14432	17397	8	applied	\N	\N	\N	\N	117108	117108	284808
14432	17398	9	applied	\N	\N	\N	\N	117109	117109	284809
14432	17399	10	applied	\N	\N	\N	\N	117110	117110	284810
14440	17425	0	applied	\N	\N	\N	\N	117144	117144	284844
14440	17426	1	applied	\N	\N	\N	\N	117145	117145	284845
14440	17427	3	applied	\N	\N	\N	\N	117146	117146	284846
14440	17428	4	applied	\N	\N	\N	\N	117147	117147	284847
14450	17448	0	applied	\N	\N	\N	\N	117186	117186	284885
14450	17449	1	applied	\N	\N	\N	\N	117187	117187	284886
14452	17453	0	applied	\N	\N	\N	\N	117191	117191	284890
14452	17454	1	applied	\N	\N	\N	\N	117192	117192	284891
14452	17455	2	applied	\N	\N	\N	\N	117193	117193	284892
14455	17456	0	applied	\N	\N	\N	\N	117201	117201	284900
14455	17457	1	applied	\N	\N	\N	\N	117202	117202	284901
14455	17458	2	applied	\N	\N	\N	\N	117203	117203	284902
14455	17459	3	applied	\N	\N	\N	\N	117204	117204	284903
14457	17469	1	applied	\N	\N	\N	\N	117214	117214	284913
14457	17470	2	applied	\N	\N	\N	\N	117215	117215	284914
14457	17471	3	applied	\N	\N	\N	\N	117216	117216	284915
14463	17483	0	applied	\N	\N	\N	\N	117240	117240	284939
14463	17484	1	applied	\N	\N	\N	\N	117241	117241	284940
14463	17485	2	applied	\N	\N	\N	\N	117242	117242	284941
14463	17486	3	applied	\N	\N	\N	\N	117243	117243	284942
14465	17483	0	applied	\N	\N	\N	\N	117248	117248	284947
14467	17495	0	applied	\N	\N	\N	\N	117257	117257	284956
14467	17496	1	applied	\N	\N	\N	\N	117258	117258	284957
14467	17497	2	applied	\N	\N	\N	\N	117259	117259	284958
14467	17498	3	applied	\N	\N	\N	\N	117260	117260	284959
14469	17495	0	applied	\N	\N	\N	\N	117265	117265	284964
14469	17496	1	applied	\N	\N	\N	\N	117266	117266	284965
14376	17088	104	applied	\N	\N	\N	\N	116758	116758	284462
14376	17089	105	applied	\N	\N	\N	\N	116759	116759	284463
14379	17269	4	applied	\N	\N	\N	\N	116853	116853	284556
14379	17270	5	applied	\N	\N	\N	\N	116854	116854	284557
14379	17271	6	applied	\N	\N	\N	\N	116855	116855	284558
14379	17272	7	applied	\N	\N	\N	\N	116856	116856	284559
14379	17273	8	applied	\N	\N	\N	\N	116857	116857	284560
14379	17274	9	applied	\N	\N	\N	\N	116858	116858	284561
14379	17275	10	applied	\N	\N	\N	\N	116859	116859	284562
14381	17267	0	applied	\N	\N	\N	\N	116861	116861	284564
14381	17262	1	applied	\N	\N	\N	\N	116862	116862	284565
14381	17263	2	applied	\N	\N	\N	\N	116863	116863	284566
14381	17268	3	applied	\N	\N	\N	\N	116864	116864	284567
14381	17269	4	applied	\N	\N	\N	\N	116865	116865	284568
14381	17270	5	applied	\N	\N	\N	\N	116866	116866	284569
14381	17271	6	applied	\N	\N	\N	\N	116867	116867	284570
14381	17272	7	applied	\N	\N	\N	\N	116868	116868	284571
14381	17273	8	applied	\N	\N	\N	\N	116869	116869	284572
14381	17275	10	applied	\N	\N	\N	\N	116871	116871	284574
14390	17308	0	applied	\N	\N	\N	\N	116916	116916	284619
14390	17309	1	applied	\N	\N	\N	\N	116917	116917	284620
14390	17310	2	applied	\N	\N	\N	\N	116918	116918	284621
14392	17308	0	applied	\N	\N	\N	\N	116922	116922	284625
14395	17317	0	applied	\N	\N	\N	\N	116929	116929	284632
14395	17318	1	applied	\N	\N	\N	\N	116930	116930	284633
14395	17319	2	applied	\N	\N	\N	\N	116931	116931	284634
14397	17320	0	applied	\N	\N	\N	\N	116932	116932	284635
14397	17321	1	applied	\N	\N	\N	\N	116933	116933	284636
14407	17330	0	applied	\N	\N	\N	\N	116964	116964	284667
14407	17331	1	applied	\N	\N	\N	\N	116965	116965	284668
14410	17327	0	applied	\N	\N	\N	\N	116970	116970	284673
14411	17332	0	applied	\N	\N	\N	\N	116971	116971	284674
14417	17362	0	applied	\N	\N	\N	\N	117015	117015	284716
14417	17363	1	applied	\N	\N	\N	\N	117016	117016	284717
14421	17366	0	applied	\N	\N	\N	\N	117021	117021	284722
14421	17367	1	applied	\N	\N	\N	\N	117022	117022	284723
14421	17368	2	applied	\N	\N	\N	\N	117023	117023	284724
14421	17369	3	applied	\N	\N	\N	\N	117024	117024	284725
14421	17370	4	applied	\N	\N	\N	\N	117025	117025	284726
14423	17371	0	applied	\N	\N	\N	\N	117031	117031	284732
14423	17372	1	applied	\N	\N	\N	\N	117032	117032	284733
14428	17380	0	applied	\N	\N	\N	\N	117046	117046	284746
14428	17381	1	applied	\N	\N	\N	\N	117047	117047	284747
14428	17382	2	applied	\N	\N	\N	\N	117048	117048	284748
14428	17383	3	applied	\N	\N	\N	\N	117049	117049	284749
14428	17384	4	applied	\N	\N	\N	\N	117050	117050	284750
14428	17385	5	applied	\N	\N	\N	\N	117051	117051	284751
14428	17386	6	applied	\N	\N	\N	\N	117052	117052	284752
14428	17387	7	applied	\N	\N	\N	\N	117053	117053	284753
14433	17400	0	applied	\N	\N	\N	\N	117111	117111	284811
14433	17402	2	applied	\N	\N	\N	\N	117113	117113	284813
14433	17403	3	applied	\N	\N	\N	\N	117114	117114	284814
14433	17404	4	applied	\N	\N	\N	\N	117115	117115	284815
14434	17400	0	applied	\N	\N	\N	\N	117116	117116	284816
14434	17401	1	applied	\N	\N	\N	\N	117117	117117	284817
14434	17402	2	applied	\N	\N	\N	\N	117118	117118	284818
14434	17403	3	applied	\N	\N	\N	\N	117119	117119	284819
14436	17412	0	applied	\N	\N	\N	\N	117128	117128	284828
14436	17413	1	applied	\N	\N	\N	\N	117129	117129	284829
14436	17414	2	applied	\N	\N	\N	\N	117130	117130	284830
14438	17415	0	applied	\N	\N	\N	\N	117134	117134	284834
14438	17416	1	applied	\N	\N	\N	\N	117135	117135	284835
14438	17417	2	applied	\N	\N	\N	\N	117136	117136	284836
14438	17418	3	applied	\N	\N	\N	\N	117137	117137	284837
14441	17429	0	applied	\N	\N	\N	\N	117148	117148	284848
14441	17430	1	applied	\N	\N	\N	\N	117149	117149	284849
14441	17432	3	applied	\N	\N	\N	\N	117151	117151	284851
14446	17439	0	applied	\N	\N	\N	\N	117172	117172	284871
14446	17440	1	applied	\N	\N	\N	\N	117173	117173	284872
14446	17441	2	applied	\N	\N	\N	\N	117174	117174	284873
14451	17450	0	applied	\N	\N	\N	\N	117188	117188	284887
14451	17451	1	applied	\N	\N	\N	\N	117189	117189	284888
14451	17452	2	applied	\N	\N	\N	\N	117190	117190	284889
14456	17460	0	applied	\N	\N	\N	\N	117205	117205	284904
14456	17461	1	applied	\N	\N	\N	\N	117206	117206	284905
14456	17462	2	applied	\N	\N	\N	\N	117207	117207	284906
14456	17463	3	applied	\N	\N	\N	\N	117208	117208	284907
14456	17464	4	applied	\N	\N	\N	\N	117209	117209	284908
14456	17465	5	applied	\N	\N	\N	\N	117210	117210	284909
14456	17466	6	applied	\N	\N	\N	\N	117211	117211	284910
14456	17467	7	applied	\N	\N	\N	\N	117212	117212	284911
14459	17479	0	applied	\N	\N	\N	\N	117224	117224	284923
14459	17481	2	applied	\N	\N	\N	\N	117226	117226	284925
14459	17482	3	applied	\N	\N	\N	\N	117227	117227	284926
14461	17483	0	applied	\N	\N	\N	\N	117232	117232	284931
14461	17484	1	applied	\N	\N	\N	\N	117233	117233	284932
14461	17485	2	applied	\N	\N	\N	\N	117234	117234	284933
14461	17486	3	applied	\N	\N	\N	\N	117235	117235	284934
14464	17483	0	applied	\N	\N	\N	\N	117244	117244	284943
14464	17484	1	applied	\N	\N	\N	\N	117245	117245	284944
14464	17485	2	applied	\N	\N	\N	\N	117246	117246	284945
14464	17486	3	applied	\N	\N	\N	\N	117247	117247	284946
14469	17497	2	applied	\N	\N	\N	\N	117267	117267	284966
14469	17498	3	applied	\N	\N	\N	\N	117268	117268	284967
14473	17502	0	applied	\N	\N	\N	\N	117289	117289	284988
14473	17503	1	applied	\N	\N	\N	\N	117290	117290	284989
14473	17504	2	applied	\N	\N	\N	\N	117291	117291	284990
14473	17505	3	applied	\N	\N	\N	\N	117292	117292	284991
14478	17522	1	applied	\N	\N	\N	\N	117315	117315	285014
14478	17523	2	applied	\N	\N	\N	\N	117316	117316	285015
14478	17524	3	applied	\N	\N	\N	\N	117317	117317	285016
14478	17525	4	applied	\N	\N	\N	\N	117318	117318	285017
14478	17526	5	applied	\N	\N	\N	\N	117319	117319	285018
14478	17527	6	applied	\N	\N	\N	\N	117320	117320	285019
14478	17528	7	applied	\N	\N	\N	\N	117321	117321	285020
14481	17541	0	applied	\N	\N	\N	\N	117342	117342	285041
14481	17542	1	applied	\N	\N	\N	\N	117343	117343	285042
14481	17543	2	applied	\N	\N	\N	\N	117344	117344	285043
14481	17544	3	applied	\N	\N	\N	\N	117345	117345	285044
14485	17545	0	applied	\N	\N	\N	\N	117351	117351	285050
14488	17240	0	applied	\N	\N	\N	\N	117360	117360	285059
14488	17018	1	applied	\N	\N	\N	\N	117361	117361	285060
14379	17262	1	applied	\N	\N	\N	\N	116850	116850	284553
14379	17263	2	applied	\N	\N	\N	\N	116851	116851	284554
14385	17290	5	applied	\N	\N	\N	\N	116892	116892	284595
14388	17240	0	applied	\N	\N	\N	\N	116896	116896	284599
14388	17018	1	applied	\N	\N	\N	\N	116897	116897	284600
14388	17019	2	applied	\N	\N	\N	\N	116898	116898	284601
14388	17020	3	applied	\N	\N	\N	\N	116899	116899	284602
14388	17021	4	applied	\N	\N	\N	\N	116900	116900	284603
14388	17072	5	applied	\N	\N	1000000000	\N	116901	116901	284604
14391	17308	0	applied	\N	\N	\N	\N	116919	116919	284622
14391	17309	1	applied	\N	\N	\N	\N	116920	116920	284623
14391	17310	2	applied	\N	\N	\N	\N	116921	116921	284624
14393	17311	0	applied	\N	\N	\N	\N	116923	116923	284626
14393	17312	1	applied	\N	\N	\N	\N	116924	116924	284627
14393	17313	2	applied	\N	\N	\N	\N	116925	116925	284628
14398	17321	1	applied	\N	\N	\N	\N	116935	116935	284638
14398	17322	2	applied	\N	\N	\N	\N	116936	116936	284639
14402	17326	0	applied	\N	\N	\N	\N	116946	116946	284649
14402	17327	1	applied	\N	\N	\N	\N	116947	116947	284650
14402	17328	2	applied	\N	\N	\N	\N	116948	116948	284651
14402	17329	3	applied	\N	\N	\N	\N	116949	116949	284652
14412	17333	0	applied	\N	\N	\N	\N	116972	116972	284675
14412	17334	1	applied	\N	\N	\N	\N	116973	116973	284676
14412	17335	2	applied	\N	\N	\N	\N	116974	116974	284677
14412	17336	3	applied	\N	\N	\N	\N	116975	116975	284678
14412	17337	4	applied	\N	\N	\N	\N	116976	116976	284679
14412	17338	5	applied	\N	\N	\N	\N	116977	116977	284680
14412	17339	6	applied	\N	\N	\N	\N	116978	116978	284681
14412	17340	7	applied	\N	\N	\N	\N	116979	116979	284682
14412	17341	8	applied	\N	\N	\N	\N	116980	116980	284683
14412	17342	9	applied	\N	\N	\N	\N	116981	116981	284684
14418	17362	0	applied	\N	\N	\N	\N	117018	117018	284719
14419	17365	0	applied	\N	\N	\N	\N	117019	117019	284720
14424	17373	0	applied	\N	\N	\N	\N	117033	117033	284734
14424	17374	1	applied	\N	\N	\N	\N	117034	117034	284735
14424	17375	2	applied	\N	\N	\N	\N	117035	117035	284736
14426	17376	0	applied	\N	\N	\N	\N	117038	117038	284738
14426	17377	1	applied	\N	\N	\N	\N	117039	117039	284739
14426	17378	2	applied	\N	\N	\N	\N	117040	117040	284740
14426	17379	3	applied	\N	\N	\N	\N	117041	117041	284741
14431	17388	0	applied	\N	\N	\N	\N	117099	117099	284799
14437	17412	0	applied	\N	\N	\N	\N	117131	117131	284831
14437	17413	1	applied	\N	\N	\N	\N	117132	117132	284832
14437	17414	2	applied	\N	\N	\N	\N	117133	117133	284833
14439	17419	0	applied	\N	\N	\N	\N	117138	117138	284838
14439	17420	1	applied	\N	\N	\N	\N	117139	117139	284839
14439	17421	2	applied	\N	\N	\N	\N	117140	117140	284840
14439	17423	4	applied	\N	\N	\N	\N	117142	117142	284842
14439	17424	5	applied	\N	\N	\N	\N	117143	117143	284843
14442	17429	0	applied	\N	\N	\N	\N	117152	117152	284852
14442	17430	1	applied	\N	\N	\N	\N	117153	117153	284853
14442	17431	2	applied	\N	\N	\N	\N	117154	117154	284854
14442	17432	3	applied	\N	\N	\N	\N	117155	117155	284855
14444	17240	0	applied	\N	\N	\N	\N	117159	117159	284859
14444	17327	1	applied	\N	\N	\N	\N	117160	117160	284860
14444	17346	2	applied	\N	\N	\N	\N	117161	117161	117161
14444	17024	3	applied	\N	\N	\N	\N	117162	117162	284861
14444	17025	4	applied	\N	\N	\N	\N	117163	117163	284862
14444	17072	5	applied	\N	\N	1000000000	\N	117164	117164	284863
14444	17026	6	applied	\N	\N	\N	\N	117165	117165	284864
14444	17027	7	applied	\N	\N	\N	\N	117166	117166	284865
14444	17028	8	applied	\N	\N	\N	\N	117167	117167	284866
14444	17029	9	applied	\N	\N	\N	\N	117168	117168	284867
14447	17440	1	applied	\N	\N	\N	\N	117176	117176	284875
14447	17441	2	applied	\N	\N	\N	\N	117177	117177	284876
14449	17448	0	applied	\N	\N	\N	\N	117184	117184	284883
14449	17449	1	applied	\N	\N	\N	\N	117185	117185	284884
14454	17456	0	applied	\N	\N	\N	\N	117197	117197	284896
14454	17457	1	applied	\N	\N	\N	\N	117198	117198	284897
14454	17458	2	applied	\N	\N	\N	\N	117199	117199	284898
14454	17459	3	applied	\N	\N	\N	\N	117200	117200	284899
14460	17479	0	applied	\N	\N	\N	\N	117228	117228	284927
14460	17480	1	applied	\N	\N	\N	\N	117229	117229	284928
14460	17481	2	applied	\N	\N	\N	\N	117230	117230	284929
14460	17482	3	applied	\N	\N	\N	\N	117231	117231	284930
14462	17483	0	applied	\N	\N	\N	\N	117236	117236	284935
14462	17484	1	applied	\N	\N	\N	\N	117237	117237	284936
14462	17485	2	applied	\N	\N	\N	\N	117238	117238	284937
14462	17486	3	applied	\N	\N	\N	\N	117239	117239	284938
14466	17488	1	applied	\N	\N	\N	\N	117250	117250	284949
14466	17489	2	applied	\N	\N	\N	\N	117251	117251	284950
14466	17490	3	applied	\N	\N	\N	\N	117252	117252	284951
14466	17491	4	applied	\N	\N	\N	\N	117253	117253	284952
14466	17492	5	applied	\N	\N	\N	\N	117254	117254	284953
14466	17493	6	applied	\N	\N	\N	\N	117255	117255	284954
14466	17494	7	applied	\N	\N	\N	\N	117256	117256	284955
14474	17506	0	applied	\N	\N	\N	\N	117293	117293	284992
14474	17507	1	applied	\N	\N	\N	\N	117294	117294	284993
14474	17508	2	applied	\N	\N	\N	\N	117295	117295	284994
14474	17509	3	applied	\N	\N	\N	\N	117296	117296	284995
14474	17510	4	applied	\N	\N	\N	\N	117297	117297	284996
14474	17511	5	applied	\N	\N	\N	\N	117298	117298	284997
14474	17512	6	applied	\N	\N	\N	\N	117299	117299	284998
14474	17513	7	applied	\N	\N	\N	\N	117300	117300	284999
14474	17514	8	applied	\N	\N	\N	\N	117301	117301	285000
14474	17516	11	applied	\N	\N	\N	\N	117303	117303	285002
14474	17517	12	applied	\N	\N	\N	\N	117304	117304	285003
14474	17518	13	applied	\N	\N	\N	\N	117305	117305	285004
14474	17519	14	applied	\N	\N	\N	\N	117306	117306	285005
14474	17520	15	applied	\N	\N	\N	\N	117307	117307	285006
14479	17521	0	applied	\N	\N	\N	\N	117322	117322	285021
14479	17522	1	applied	\N	\N	\N	\N	117323	117323	285022
14479	17523	2	applied	\N	\N	\N	\N	117324	117324	285023
14479	17524	3	applied	\N	\N	\N	\N	117325	117325	285024
14479	17525	4	applied	\N	\N	\N	\N	117326	117326	285025
14479	17526	5	applied	\N	\N	\N	\N	117327	117327	285026
14479	17527	6	applied	\N	\N	\N	\N	117328	117328	285027
14479	17528	7	applied	\N	\N	\N	\N	117329	117329	285028
14484	17541	0	applied	\N	\N	\N	\N	117347	117347	285046
14484	17542	1	applied	\N	\N	\N	\N	117348	117348	285047
14488	17019	2	applied	\N	\N	\N	\N	117362	117362	285061
14385	17288	3	applied	\N	\N	\N	\N	116890	116890	284593
14385	17289	4	applied	\N	\N	\N	\N	116891	116891	284594
14430	16753	31	applied	\N	\N	\N	\N	117085	117085	284785
14430	16754	32	applied	\N	\N	\N	\N	117086	117086	284786
14430	16763	33	applied	\N	\N	\N	\N	117087	117087	284787
14430	16767	34	applied	\N	\N	\N	\N	117088	117088	284788
14430	16772	35	applied	\N	\N	\N	\N	117089	117089	284789
14430	16773	36	applied	\N	\N	\N	\N	117090	117090	284790
14430	16780	37	applied	\N	\N	\N	\N	117091	117091	284791
14430	16781	38	applied	\N	\N	\N	\N	117092	117092	284792
14430	16786	39	applied	\N	\N	\N	\N	117093	117093	284793
14430	16790	40	applied	\N	\N	\N	\N	117094	117094	284794
14430	16792	41	applied	\N	\N	\N	\N	117095	117095	284795
14430	16795	42	applied	\N	\N	\N	\N	117096	117096	284796
14430	16799	43	applied	\N	\N	\N	\N	117097	117097	284797
14430	16800	44	applied	\N	\N	\N	\N	117098	117098	284798
14435	17405	0	applied	\N	\N	\N	\N	117120	117120	284820
14435	17406	1	applied	\N	\N	\N	\N	117121	117121	284821
14435	17407	3	applied	\N	\N	\N	\N	117123	117123	284823
14435	17408	4	applied	\N	\N	\N	\N	117124	117124	284824
14435	17409	5	applied	\N	\N	\N	\N	117125	117125	284825
14435	17410	6	applied	\N	\N	\N	\N	117126	117126	284826
14435	17411	7	applied	\N	\N	\N	\N	117127	117127	284827
14443	17433	0	applied	\N	\N	\N	\N	117156	117156	284856
14443	17434	1	applied	\N	\N	\N	\N	117157	117157	284857
14443	17435	2	applied	\N	\N	\N	\N	117158	117158	284858
14445	17436	0	applied	\N	\N	\N	\N	117169	117169	284868
14445	17437	1	applied	\N	\N	\N	\N	117170	117170	284869
14445	17438	2	applied	\N	\N	\N	\N	117171	117171	284870
14448	17442	0	applied	\N	\N	\N	\N	117178	117178	284877
14448	17443	1	applied	\N	\N	\N	\N	117179	117179	284878
14448	17444	2	applied	\N	\N	\N	\N	117180	117180	284879
14448	17445	3	applied	\N	\N	\N	\N	117181	117181	284880
14448	17446	4	applied	\N	\N	\N	\N	117182	117182	284881
14453	17453	0	applied	\N	\N	\N	\N	117194	117194	284893
14453	17454	1	applied	\N	\N	\N	\N	117195	117195	284894
14453	17455	2	applied	\N	\N	\N	\N	117196	117196	284895
14458	17472	0	applied	\N	\N	\N	\N	117217	117217	284916
14458	17473	1	applied	\N	\N	\N	\N	117218	117218	284917
14458	17474	2	applied	\N	\N	\N	\N	117219	117219	284918
14458	17475	3	applied	\N	\N	\N	\N	117220	117220	284919
14458	17476	4	applied	\N	\N	\N	\N	117221	117221	284920
14458	17477	5	applied	\N	\N	\N	\N	117222	117222	284921
14458	17478	6	applied	\N	\N	\N	\N	117223	117223	284922
14468	17495	0	applied	\N	\N	\N	\N	117261	117261	284960
14468	17496	1	applied	\N	\N	\N	\N	117262	117262	284961
14468	17497	2	applied	\N	\N	\N	\N	117263	117263	284962
14468	17498	3	applied	\N	\N	\N	\N	117264	117264	284963
14470	17483	0	applied	\N	\N	\N	\N	117269	117269	284968
14470	17487	1	applied	\N	\N	\N	\N	117270	117270	284969
14470	17495	3	applied	\N	\N	\N	\N	117272	117272	284971
14470	17484	4	applied	\N	\N	\N	\N	117273	117273	284972
14470	17485	5	applied	\N	\N	\N	\N	117274	117274	284973
14470	17486	6	applied	\N	\N	\N	\N	117275	117275	284974
14470	17489	7	applied	\N	\N	\N	\N	117276	117276	284975
14470	17490	8	applied	\N	\N	\N	\N	117277	117277	284976
14470	17491	9	applied	\N	\N	\N	\N	117278	117278	284977
14470	17492	10	applied	\N	\N	\N	\N	117279	117279	284978
14470	17493	11	applied	\N	\N	\N	\N	117280	117280	284979
14470	17494	12	applied	\N	\N	\N	\N	117281	117281	284980
14470	17496	13	applied	\N	\N	\N	\N	117282	117282	284981
14470	17497	14	applied	\N	\N	\N	\N	117283	117283	284982
14470	17498	15	applied	\N	\N	\N	\N	117284	117284	284983
14472	17502	0	applied	\N	\N	\N	\N	117288	117288	284987
14477	17506	0	applied	\N	\N	\N	\N	117309	117309	285008
14477	17507	1	applied	\N	\N	\N	\N	117310	117310	285009
14477	17509	3	applied	\N	\N	\N	\N	117312	117312	285011
14477	17510	4	applied	\N	\N	\N	\N	117313	117313	285012
14480	17529	0	applied	\N	\N	\N	\N	117330	117330	285029
14480	17530	1	applied	\N	\N	\N	\N	117331	117331	285030
14480	17531	2	applied	\N	\N	\N	\N	117332	117332	285031
14480	17532	3	applied	\N	\N	\N	\N	117333	117333	285032
14480	17533	4	applied	\N	\N	\N	\N	117334	117334	285033
14480	17534	5	applied	\N	\N	\N	\N	117335	117335	285034
14480	17535	6	applied	\N	\N	\N	\N	117336	117336	285035
14480	17536	7	applied	\N	\N	\N	\N	117337	117337	285036
14480	17537	8	applied	\N	\N	\N	\N	117338	117338	285037
14480	17538	9	applied	\N	\N	\N	\N	117339	117339	285038
14480	17539	10	applied	\N	\N	\N	\N	117340	117340	285039
14480	17540	11	applied	\N	\N	\N	\N	117341	117341	285040
14484	17543	2	applied	\N	\N	\N	\N	117349	117349	285048
14484	17544	3	applied	\N	\N	\N	\N	117350	117350	285049
14491	17548	1	applied	\N	\N	\N	\N	117393	117393	285091
14491	17555	2	applied	\N	\N	\N	\N	117394	117394	285092
14491	17556	3	applied	\N	\N	\N	\N	117395	117395	285093
14491	17557	4	applied	\N	\N	\N	\N	117396	117396	285094
14491	17558	5	applied	\N	\N	\N	\N	117397	117397	285095
14491	17559	6	applied	\N	\N	\N	\N	117398	117398	285096
14491	17560	7	applied	\N	\N	\N	\N	117399	117399	285097
14491	17561	8	applied	\N	\N	\N	\N	117400	117400	285098
14491	17562	9	applied	\N	\N	\N	\N	117401	117401	285099
14491	17563	10	applied	\N	\N	\N	\N	117402	117402	285100
14491	17564	11	applied	\N	\N	\N	\N	117403	117403	285101
14491	17565	12	applied	\N	\N	\N	\N	117404	117404	285102
14491	17566	13	applied	\N	\N	\N	\N	117405	117405	285103
14491	17567	14	applied	\N	\N	\N	\N	117406	117406	285104
14491	17568	15	applied	\N	\N	\N	\N	117407	117407	285105
14491	17569	16	applied	\N	\N	\N	\N	117408	117408	285106
14497	17575	1	applied	\N	\N	\N	\N	117470	117470	285167
14497	17576	2	applied	\N	\N	\N	\N	117471	117471	285168
14499	17575	0	applied	\N	\N	\N	\N	117473	117473	285170
14499	17576	1	applied	\N	\N	\N	\N	117474	117474	285171
14502	17574	0	applied	\N	\N	\N	\N	117486	117486	285183
14502	17577	1	applied	\N	\N	\N	\N	117487	117487	285184
14502	17578	2	applied	\N	\N	\N	\N	117488	117488	285185
14502	17579	3	applied	\N	\N	\N	\N	117489	117489	285186
14502	17580	4	applied	\N	\N	\N	\N	117490	117490	285187
14502	17581	5	applied	\N	\N	\N	\N	117491	117491	285188
14502	17582	6	applied	\N	\N	\N	\N	117492	117492	285189
14502	17583	7	applied	\N	\N	\N	\N	117493	117493	285190
14504	17584	0	applied	\N	\N	\N	\N	117495	117495	285192
14504	17585	1	applied	\N	\N	\N	\N	117496	117496	285193
14430	16746	28	applied	\N	\N	\N	\N	117082	117082	284782
14430	16747	29	applied	\N	\N	\N	\N	117083	117083	284783
14483	17541	0	applied	\N	\N	\N	\N	117346	117346	285045
14487	17545	0	applied	\N	\N	\N	\N	117356	117356	285055
14487	17546	1	applied	\N	\N	\N	\N	117357	117357	285056
14487	17547	2	applied	\N	\N	\N	\N	117358	117358	285057
14487	17548	3	applied	\N	\N	\N	\N	117359	117359	285058
14490	17554	0	applied	\N	\N	\N	\N	117375	117375	285073
14490	17548	1	applied	\N	\N	\N	\N	117376	117376	285074
14490	17555	2	applied	\N	\N	\N	\N	117377	117377	285075
14490	17556	3	applied	\N	\N	\N	\N	117378	117378	285076
14490	17557	4	applied	\N	\N	\N	\N	117379	117379	285077
14490	17558	5	applied	\N	\N	\N	\N	117380	117380	285078
14490	17559	6	applied	\N	\N	\N	\N	117381	117381	285079
14490	17560	7	applied	\N	\N	\N	\N	117382	117382	285080
14490	17561	8	applied	\N	\N	\N	\N	117383	117383	285081
14490	17562	9	applied	\N	\N	\N	\N	117384	117384	285082
14490	17563	10	applied	\N	\N	\N	\N	117385	117385	285083
14490	17565	12	applied	\N	\N	\N	\N	117387	117387	285085
14490	17566	13	applied	\N	\N	\N	\N	117388	117388	285086
14490	17567	14	applied	\N	\N	\N	\N	117389	117389	285087
14490	17568	15	applied	\N	\N	\N	\N	117390	117390	285088
14490	17569	16	applied	\N	\N	\N	\N	117391	117391	285089
14492	17400	0	applied	\N	\N	\N	\N	117409	117409	285107
14492	17251	1	applied	\N	\N	\N	\N	117410	117410	285108
14492	17255	2	applied	\N	\N	\N	\N	117411	117411	285109
14492	17258	3	applied	\N	\N	\N	\N	117412	117412	285110
14492	17261	4	applied	\N	\N	\N	\N	117413	117413	285111
14492	17264	5	applied	\N	\N	\N	\N	117414	117414	285112
14492	17265	6	applied	\N	\N	\N	\N	117415	117415	285113
14492	17266	7	applied	\N	\N	\N	\N	117416	117416	285114
14492	17267	8	applied	\N	\N	\N	\N	117417	117417	285115
14492	17276	9	applied	\N	\N	\N	\N	117418	117418	285116
14492	17277	10	applied	\N	\N	\N	\N	117419	117419	285117
14492	17285	13	applied	\N	\N	\N	\N	117421	117421	285119
14492	17286	14	applied	\N	\N	\N	\N	117422	117422	285120
14492	17291	15	applied	\N	\N	\N	\N	117423	117423	285121
14492	17294	16	applied	\N	\N	\N	\N	117424	117424	285122
14492	17295	17	applied	\N	\N	\N	\N	117425	117425	285123
14492	17296	18	applied	\N	\N	\N	\N	117426	117426	285124
14492	17297	19	applied	\N	\N	\N	\N	117427	117427	285125
14492	17298	20	applied	\N	\N	\N	\N	117428	117428	285126
14492	17308	21	applied	\N	\N	\N	\N	117429	117429	285127
14492	17311	22	applied	\N	\N	\N	\N	117430	117430	285128
14492	17314	23	applied	\N	\N	\N	\N	117431	117431	285129
14492	17317	24	applied	\N	\N	\N	\N	117432	117432	285130
14492	17320	25	applied	\N	\N	\N	\N	117433	117433	285131
14492	17323	26	applied	\N	\N	\N	\N	117434	117434	285132
14492	17326	27	applied	\N	\N	\N	\N	117435	117435	285133
14492	17332	28	applied	\N	\N	\N	\N	117436	117436	285134
14492	17334	30	applied	\N	\N	\N	\N	117438	117438	285136
14492	17335	31	applied	\N	\N	\N	\N	117439	117439	285137
14492	17336	32	applied	\N	\N	\N	\N	117440	117440	285138
14492	17337	33	applied	\N	\N	\N	\N	117441	117441	285139
14492	17344	34	applied	\N	\N	\N	\N	117442	117442	285140
14492	17345	35	applied	\N	\N	\N	\N	117443	117443	285141
14492	17359	36	applied	\N	\N	\N	\N	117444	117444	285142
14492	17362	37	applied	\N	\N	\N	\N	117445	117445	285143
14492	17365	38	applied	\N	\N	\N	\N	117446	117446	285144
14492	17366	39	applied	\N	\N	\N	\N	117447	117447	285145
14492	17371	40	applied	\N	\N	\N	\N	117448	117448	285146
14492	17373	41	applied	\N	\N	\N	\N	117449	117449	285147
14492	17376	42	applied	\N	\N	\N	\N	117450	117450	285148
14492	17380	43	applied	\N	\N	\N	\N	117451	117451	285149
14492	17381	44	applied	\N	\N	\N	\N	117452	117452	285150
14492	17388	45	applied	\N	\N	\N	\N	117453	117453	285151
14495	17571	1	applied	\N	\N	\N	\N	117463	117463	285161
14495	17572	2	applied	\N	\N	\N	\N	117464	117464	285162
14495	17573	3	applied	\N	\N	\N	\N	117465	117465	285163
14496	17400	0	applied	\N	\N	\N	\N	117466	117466	285164
14496	17327	1	applied	\N	\N	\N	\N	117467	117467	285165
14496	17346	2	applied	\N	\N	\N	\N	117468	117468	117468
14501	17574	0	applied	\N	\N	\N	\N	117478	117478	285175
14501	17577	1	applied	\N	\N	\N	\N	117479	117479	285176
14501	17578	2	applied	\N	\N	\N	\N	117480	117480	285177
14501	17579	3	applied	\N	\N	\N	\N	117481	117481	285178
14501	17580	4	applied	\N	\N	\N	\N	117482	117482	285179
14501	17581	5	applied	\N	\N	\N	\N	117483	117483	285180
14501	17582	6	applied	\N	\N	\N	\N	117484	117484	285181
14501	17583	7	applied	\N	\N	\N	\N	117485	117485	285182
14503	17584	0	applied	\N	\N	\N	\N	117494	117494	285191
14504	17586	2	applied	\N	\N	\N	\N	117497	117497	285194
14507	17612	0	applied	\N	\N	\N	\N	117526	117526	285223
14507	17613	1	applied	\N	\N	\N	\N	117527	117527	285224
14507	17614	2	applied	\N	\N	\N	\N	117528	117528	285225
14507	17615	3	applied	\N	\N	\N	\N	117529	117529	285226
14507	17616	4	applied	\N	\N	\N	\N	117530	117530	285227
14515	17624	0	applied	\N	\N	\N	\N	117564	117564	285261
14515	17625	1	applied	\N	\N	\N	\N	117565	117565	285262
14515	17630	2	applied	\N	\N	\N	\N	117566	117566	285263
14515	17627	3	applied	\N	\N	\N	\N	117567	117567	285264
14515	17628	4	applied	\N	\N	\N	\N	117568	117568	285265
14515	17629	5	applied	\N	\N	\N	\N	117569	117569	285266
14516	17631	0	applied	\N	\N	\N	\N	117570	117570	285267
14516	17632	1	applied	\N	\N	\N	\N	117571	117571	285268
14521	17633	0	applied	\N	\N	\N	\N	117578	117578	285275
14521	17634	1	applied	\N	\N	\N	\N	117579	117579	285276
14521	17635	2	applied	\N	\N	\N	\N	117580	117580	285277
14521	17637	4	applied	\N	\N	\N	\N	117582	117582	285279
14521	17638	5	applied	\N	\N	\N	\N	117583	117583	285280
14523	17642	0	applied	\N	\N	\N	\N	117587	117587	285284
14523	17643	1	applied	\N	\N	\N	\N	117588	117588	285285
14526	17656	0	applied	\N	\N	\N	\N	117601	117601	285298
14526	17657	1	applied	\N	\N	\N	\N	117602	117602	285299
14529	17656	0	applied	\N	\N	\N	\N	117607	117607	285304
14529	17657	1	applied	\N	\N	\N	\N	117608	117608	285305
14534	17660	0	applied	\N	\N	\N	\N	117615	117615	285312
14534	17661	1	applied	\N	\N	\N	\N	117616	117616	285313
14539	17672	0	applied	\N	\N	\N	\N	117629	117629	285326
14539	17673	1	applied	\N	\N	\N	\N	117630	117630	285327
14539	17674	2	applied	\N	\N	\N	\N	117631	117631	285328
14539	17675	3	applied	\N	\N	\N	\N	117632	117632	285329
14471	17500	1	applied	\N	\N	\N	\N	117286	117286	284985
14471	17501	2	applied	\N	\N	\N	\N	117287	117287	284986
14494	17570	0	applied	\N	\N	\N	\N	117458	117458	285156
14494	17571	1	applied	\N	\N	\N	\N	117459	117459	285157
14494	17572	2	applied	\N	\N	\N	\N	117460	117460	285158
14494	17573	3	applied	\N	\N	\N	\N	117461	117461	285159
14498	17574	0	applied	\N	\N	\N	\N	117472	117472	285169
14500	17574	0	applied	\N	\N	\N	\N	117475	117475	285172
14500	17577	1	applied	\N	\N	\N	\N	117476	117476	285173
14500	17578	2	applied	\N	\N	\N	\N	117477	117477	285174
14506	17604	0	applied	\N	\N	\N	\N	117518	117518	285215
14506	17605	1	applied	\N	\N	\N	\N	117519	117519	285216
14506	17606	2	applied	\N	\N	\N	\N	117520	117520	285217
14506	17607	3	applied	\N	\N	\N	\N	117521	117521	285218
14506	17608	4	applied	\N	\N	\N	\N	117522	117522	285219
14506	17609	5	applied	\N	\N	\N	\N	117523	117523	285220
14506	17611	7	applied	\N	\N	\N	\N	117525	117525	285222
14509	17617	0	applied	\N	\N	\N	\N	117531	117531	285228
14514	17624	0	applied	\N	\N	\N	\N	117558	117558	285255
14514	17625	1	applied	\N	\N	\N	\N	117559	117559	285256
14514	17630	2	applied	\N	\N	\N	\N	117560	117560	285257
14514	17627	3	applied	\N	\N	\N	\N	117561	117561	285258
14514	17628	4	applied	\N	\N	\N	\N	117562	117562	285259
14514	17629	5	applied	\N	\N	\N	\N	117563	117563	285260
14522	17639	0	applied	\N	\N	\N	\N	117584	117584	285281
14522	17640	1	applied	\N	\N	\N	\N	117585	117585	285282
14522	17641	2	applied	\N	\N	\N	\N	117586	117586	285283
14531	17658	0	applied	\N	\N	\N	\N	117611	117611	285308
14531	17659	1	applied	\N	\N	\N	\N	117612	117612	285309
14533	17660	0	applied	\N	\N	\N	\N	117613	117613	285310
14533	17661	1	applied	\N	\N	\N	\N	117614	117614	285311
14538	17668	0	applied	\N	\N	\N	\N	117625	117625	285322
14538	17670	2	applied	\N	\N	\N	\N	117627	117627	285324
14538	17671	3	applied	\N	\N	\N	\N	117628	117628	285325
14539	17676	4	applied	\N	\N	\N	\N	117633	117633	285330
14539	17677	5	applied	\N	\N	\N	\N	117634	117634	285331
14541	17681	0	applied	\N	\N	\N	\N	117638	117638	285335
14541	17682	1	applied	\N	\N	\N	\N	117639	117639	285336
14541	17683	2	applied	\N	\N	\N	\N	117640	117640	285337
14541	17684	3	applied	\N	\N	\N	\N	117641	117641	285338
14541	17685	4	applied	\N	\N	\N	\N	117642	117642	285339
14541	17686	5	applied	\N	\N	\N	\N	117643	117643	285340
14547	17693	0	applied	\N	\N	\N	\N	117666	117666	285363
14547	17694	1	applied	\N	\N	\N	\N	117667	117667	285364
14547	17695	2	applied	\N	\N	\N	\N	117668	117668	285365
14547	17696	3	applied	\N	\N	\N	\N	117669	117669	285366
14547	17697	4	applied	\N	\N	\N	\N	117670	117670	285367
14547	17698	5	applied	\N	\N	\N	\N	117671	117671	285368
14547	17700	7	applied	\N	\N	\N	\N	117673	117673	285370
14547	17701	8	applied	\N	\N	\N	\N	117674	117674	285371
14547	17702	9	applied	\N	\N	\N	\N	117675	117675	285372
14547	17703	10	applied	\N	\N	\N	\N	117676	117676	285373
14547	17704	11	applied	\N	\N	\N	\N	117677	117677	285374
14552	17705	0	applied	\N	\N	1000000000	\N	117710	117710	285407
14552	17706	1	applied	\N	\N	\N	\N	117711	117711	285408
14552	17707	2	applied	\N	\N	\N	\N	117712	117712	285409
14552	17708	3	applied	\N	\N	\N	\N	117713	117713	285410
14552	17709	4	applied	\N	\N	\N	\N	117714	117714	285411
14552	17710	5	applied	\N	\N	\N	\N	117715	117715	285412
14552	17711	6	applied	\N	\N	\N	\N	117716	117716	285413
14552	17712	7	applied	\N	\N	\N	\N	117717	117717	285414
14552	17713	8	applied	\N	\N	\N	\N	117718	117718	285415
14552	17714	9	applied	\N	\N	\N	\N	117719	117719	285416
14555	17715	0	applied	\N	\N	\N	\N	117726	117726	285423
14555	17717	2	applied	\N	\N	\N	\N	117728	117728	285425
14558	17718	0	applied	\N	\N	\N	\N	117735	117735	285432
14558	17719	1	applied	\N	\N	\N	\N	117736	117736	285433
14558	17720	2	applied	\N	\N	\N	\N	117737	117737	285434
14563	17726	0	applied	\N	\N	\N	\N	117868	117868	285565
14563	17727	1	applied	\N	\N	\N	\N	117869	117869	285566
14566	17726	0	applied	\N	\N	\N	\N	117873	117873	285570
14566	17727	1	applied	\N	\N	\N	\N	117874	117874	285571
14568	17733	0	applied	\N	\N	\N	\N	117881	117881	285578
14568	17734	1	applied	\N	\N	\N	\N	117882	117882	285579
14568	17735	2	applied	\N	\N	\N	\N	117883	117883	285580
14568	17736	3	applied	\N	\N	\N	\N	117884	117884	285581
14568	17737	4	applied	\N	\N	\N	\N	117885	117885	285582
14568	17738	5	applied	\N	\N	\N	\N	117886	117886	285583
14573	17739	0	applied	\N	\N	\N	\N	117907	117907	285604
14573	17740	1	applied	\N	\N	\N	\N	117908	117908	285605
14577	17744	1	applied	\N	\N	\N	\N	117916	117916	285613
14579	17745	0	applied	\N	\N	\N	\N	117919	117919	285616
14582	17747	0	applied	\N	\N	\N	\N	117922	117922	285619
14589	17754	0	applied	\N	\N	\N	\N	117936	117936	285633
14589	17755	1	applied	\N	\N	\N	\N	117937	117937	285634
14589	17756	2	applied	\N	\N	\N	\N	117938	117938	285635
14591	17757	0	applied	\N	\N	\N	\N	117942	117942	285639
14591	17758	1	applied	\N	\N	\N	\N	117943	117943	285640
14591	17759	2	applied	\N	\N	\N	\N	117944	117944	285641
14594	17763	0	applied	\N	\N	\N	\N	117951	117951	285648
14594	17764	1	applied	\N	\N	\N	\N	117952	117952	285649
14594	17765	2	applied	\N	\N	\N	\N	117953	117953	285650
14598	17766	0	applied	\N	\N	\N	\N	117963	117963	285660
14598	17767	1	applied	\N	\N	\N	\N	117964	117964	285661
14598	17768	2	applied	\N	\N	\N	\N	117965	117965	285662
14604	17772	0	applied	\N	\N	\N	\N	117978	117978	285675
14604	17774	2	applied	\N	\N	\N	\N	117980	117980	285677
14607	17778	0	applied	\N	\N	\N	\N	117986	117986	285683
14607	17779	1	applied	\N	\N	\N	\N	117987	117987	285684
14607	17780	2	applied	\N	\N	\N	\N	117988	117988	285685
14610	17781	0	applied	\N	\N	\N	\N	118003	118003	285700
14610	17782	1	applied	\N	\N	\N	\N	118004	118004	285701
14610	17783	2	applied	\N	\N	\N	\N	118005	118005	285702
14610	17784	3	applied	\N	\N	\N	\N	118006	118006	285703
14610	17785	4	applied	\N	\N	\N	\N	118007	118007	285704
14610	17786	5	applied	\N	\N	\N	\N	118008	118008	285705
14610	17787	6	applied	\N	\N	\N	\N	118009	118009	285706
14610	17788	7	applied	\N	\N	\N	\N	118010	118010	285707
14610	17789	8	applied	\N	\N	\N	\N	118011	118011	285708
14610	17790	9	applied	\N	\N	\N	\N	118012	118012	285709
14610	17791	10	applied	\N	\N	\N	\N	118013	118013	285710
14612	17794	0	applied	\N	\N	\N	\N	118016	118016	285713
14486	17548	3	applied	\N	\N	\N	\N	117355	117355	285054
14488	17072	7	applied	\N	\N	1000000000	\N	117367	117367	285065
14489	17549	0	applied	\N	\N	\N	\N	117368	117368	285066
14489	17550	1	applied	\N	\N	\N	\N	117369	117369	285067
14489	17551	2	applied	\N	\N	\N	\N	117370	117370	285068
14489	17552	3	applied	\N	\N	\N	\N	117371	117371	285069
14489	17553	4	applied	\N	\N	\N	\N	117372	117372	285070
14489	17546	5	applied	\N	\N	\N	\N	117373	117373	285071
14489	17547	6	applied	\N	\N	\N	\N	117374	117374	285072
14493	17570	0	applied	\N	\N	\N	\N	117454	117454	285152
14493	17571	1	applied	\N	\N	\N	\N	117455	117455	285153
14493	17572	2	applied	\N	\N	\N	\N	117456	117456	285154
14493	17573	3	applied	\N	\N	\N	\N	117457	117457	285155
14505	17588	0	applied	\N	\N	\N	\N	117499	117499	285196
14505	17590	2	applied	\N	\N	\N	\N	117501	117501	285198
14505	17591	3	applied	\N	\N	\N	\N	117502	117502	285199
14505	17585	4	applied	\N	\N	\N	\N	117503	117503	285200
14505	17586	5	applied	\N	\N	\N	\N	117504	117504	285201
14505	17587	6	applied	\N	\N	\N	\N	117505	117505	285202
14505	17592	7	applied	\N	\N	\N	\N	117506	117506	285203
14505	17593	8	applied	\N	\N	\N	\N	117507	117507	285204
14505	17594	9	applied	\N	\N	\N	\N	117508	117508	285205
14505	17595	10	applied	\N	\N	\N	\N	117509	117509	285206
14505	17596	11	applied	\N	\N	\N	\N	117510	117510	285207
14505	17597	12	applied	\N	\N	\N	\N	117511	117511	285208
14505	17598	13	applied	\N	\N	\N	\N	117512	117512	285209
14505	17599	14	applied	\N	\N	\N	\N	117513	117513	285210
14505	17600	15	applied	\N	\N	\N	\N	117514	117514	285211
14505	17601	16	applied	\N	\N	\N	\N	117515	117515	285212
14505	17602	17	applied	\N	\N	\N	\N	117516	117516	285213
14511	17617	0	applied	\N	\N	\N	\N	117539	117539	285236
14511	17618	1	applied	\N	\N	\N	\N	117540	117540	285237
14511	17619	2	applied	\N	\N	\N	\N	117541	117541	285238
14511	17620	3	applied	\N	\N	\N	\N	117542	117542	285239
14511	17621	4	applied	\N	\N	\N	\N	117543	117543	285240
14511	17622	5	applied	\N	\N	\N	\N	117544	117544	285241
14511	17623	6	applied	\N	\N	\N	\N	117545	117545	285242
14513	17624	0	applied	\N	\N	\N	\N	117552	117552	285249
14513	17625	1	applied	\N	\N	\N	\N	117553	117553	285250
14513	17630	2	applied	\N	\N	\N	\N	117554	117554	285251
14513	17627	3	applied	\N	\N	\N	\N	117555	117555	285252
14513	17628	4	applied	\N	\N	\N	\N	117556	117556	285253
14513	17629	5	applied	\N	\N	\N	\N	117557	117557	285254
14518	17631	0	applied	\N	\N	\N	\N	117574	117574	285271
14518	17632	1	applied	\N	\N	\N	\N	117575	117575	285272
14520	17631	0	applied	\N	\N	\N	\N	117576	117576	285273
14525	17650	0	applied	\N	\N	\N	\N	117595	117595	285292
14525	17651	1	applied	\N	\N	\N	\N	117596	117596	285293
14525	17652	2	applied	\N	\N	\N	\N	117597	117597	285294
14525	17653	3	applied	\N	\N	\N	\N	117598	117598	285295
14525	17654	4	applied	\N	\N	\N	\N	117599	117599	285296
14525	17655	5	applied	\N	\N	\N	\N	117600	117600	285297
14528	17656	0	applied	\N	\N	\N	\N	117605	117605	285302
14528	17657	1	applied	\N	\N	\N	\N	117606	117606	285303
14530	17658	0	applied	\N	\N	\N	\N	117609	117609	285306
14530	17659	1	applied	\N	\N	\N	\N	117610	117610	285307
14537	17664	0	applied	\N	\N	\N	\N	117621	117621	285318
14537	17665	1	applied	\N	\N	\N	\N	117622	117622	285319
14537	17666	2	applied	\N	\N	\N	\N	117623	117623	285320
14537	17667	3	applied	\N	\N	\N	\N	117624	117624	285321
14540	17678	0	applied	\N	\N	\N	\N	117635	117635	285332
14540	17679	1	applied	\N	\N	\N	\N	117636	117636	285333
14546	17689	0	applied	\N	\N	\N	\N	117662	117662	285359
14546	17690	1	applied	\N	\N	\N	\N	117663	117663	285360
14546	17691	2	applied	\N	\N	\N	\N	117664	117664	285361
14546	17692	3	applied	\N	\N	\N	\N	117665	117665	285362
14554	17715	0	applied	\N	\N	\N	\N	117723	117723	285420
14554	17716	1	applied	\N	\N	\N	\N	117724	117724	285421
14554	17717	2	applied	\N	\N	\N	\N	117725	117725	285422
14557	17715	0	applied	\N	\N	\N	\N	117732	117732	285429
14557	17716	1	applied	\N	\N	\N	\N	117733	117733	285430
14557	17717	2	applied	\N	\N	\N	\N	117734	117734	285431
14567	17726	0	applied	\N	\N	\N	\N	117875	117875	285572
14567	17728	1	applied	\N	\N	\N	\N	117876	117876	285573
14567	17729	2	applied	\N	\N	\N	\N	117877	117877	285574
14567	17730	3	applied	\N	\N	\N	\N	117878	117878	285575
14567	17731	4	applied	\N	\N	\N	\N	117879	117879	285576
14567	17732	5	applied	\N	\N	\N	\N	117880	117880	285577
14571	17734	1	applied	\N	\N	\N	\N	117900	117900	285597
14571	17735	2	applied	\N	\N	\N	\N	117901	117901	285598
14571	17736	3	applied	\N	\N	\N	\N	117902	117902	285599
14571	17737	4	applied	\N	\N	\N	\N	117903	117903	285600
14571	17738	5	applied	\N	\N	\N	\N	117904	117904	285601
14572	17739	0	applied	\N	\N	\N	\N	117905	117905	285602
14572	17740	1	applied	\N	\N	\N	\N	117906	117906	285603
14574	17739	0	applied	\N	\N	\N	\N	117909	117909	285606
14574	17740	1	applied	\N	\N	\N	\N	117910	117910	285607
14581	17747	0	applied	\N	\N	\N	\N	117921	117921	285618
14584	17748	0	applied	\N	\N	\N	\N	117924	117924	285621
14586	17751	0	applied	\N	\N	\N	\N	117927	117927	285624
14586	17752	1	applied	\N	\N	\N	\N	117928	117928	285625
14586	17753	2	applied	\N	\N	\N	\N	117929	117929	285626
14588	17754	0	applied	\N	\N	\N	\N	117933	117933	285630
14588	17755	1	applied	\N	\N	\N	\N	117934	117934	285631
14593	17763	0	applied	\N	\N	\N	\N	117948	117948	285645
14593	17764	1	applied	\N	\N	\N	\N	117949	117949	285646
14593	17765	2	applied	\N	\N	\N	\N	117950	117950	285647
14597	17766	0	applied	\N	\N	\N	\N	117960	117960	285657
14597	17767	1	applied	\N	\N	\N	\N	117961	117961	285658
14597	17768	2	applied	\N	\N	\N	\N	117962	117962	285659
14602	17769	0	applied	\N	\N	\N	\N	117972	117972	285669
14602	17770	1	applied	\N	\N	\N	\N	117973	117973	285670
14602	17771	2	applied	\N	\N	\N	\N	117974	117974	285671
14606	17705	0	applied	\N	\N	1000000000	\N	117984	117984	285681
14606	17719	1	applied	\N	\N	\N	\N	117985	117985	285682
14609	17781	0	applied	\N	\N	\N	\N	117992	117992	285689
14609	17782	1	applied	\N	\N	\N	\N	117993	117993	285690
14609	17783	2	applied	\N	\N	\N	\N	117994	117994	285691
14609	17784	3	applied	\N	\N	\N	\N	117995	117995	285692
14612	17795	1	applied	\N	\N	\N	\N	118017	118017	285714
14488	17327	5	applied	\N	\N	\N	\N	117365	117365	285064
14488	17346	6	applied	\N	\N	\N	\N	117366	117366	117366
14510	17621	4	applied	\N	\N	\N	\N	117536	117536	285233
14510	17622	5	applied	\N	\N	\N	\N	117537	117537	285234
14510	17623	6	applied	\N	\N	\N	\N	117538	117538	285235
14512	17624	0	applied	\N	\N	\N	\N	117546	117546	285243
14512	17625	1	applied	\N	\N	\N	\N	117547	117547	285244
14512	17626	2	applied	\N	\N	\N	\N	117548	117548	285245
14512	17627	3	applied	\N	\N	\N	\N	117549	117549	285246
14512	17628	4	applied	\N	\N	\N	\N	117550	117550	285247
14512	17629	5	applied	\N	\N	\N	\N	117551	117551	285248
14517	17631	0	applied	\N	\N	\N	\N	117572	117572	285269
14517	17632	1	applied	\N	\N	\N	\N	117573	117573	285270
14524	17644	0	applied	\N	\N	\N	\N	117589	117589	285286
14524	17645	1	applied	\N	\N	\N	\N	117590	117590	285287
14524	17646	2	applied	\N	\N	\N	\N	117591	117591	285288
14524	17648	4	applied	\N	\N	\N	\N	117593	117593	285290
14524	17649	5	applied	\N	\N	\N	\N	117594	117594	285291
14527	17656	0	applied	\N	\N	\N	\N	117603	117603	285300
14527	17657	1	applied	\N	\N	\N	\N	117604	117604	285301
14535	17660	0	applied	\N	\N	\N	\N	117617	117617	285314
14535	17661	1	applied	\N	\N	\N	\N	117618	117618	285315
14536	17662	0	applied	\N	\N	\N	\N	117619	117619	285316
14536	17663	1	applied	\N	\N	\N	\N	117620	117620	285317
14543	17681	0	applied	\N	\N	\N	\N	117650	117650	285347
14543	17682	1	applied	\N	\N	\N	\N	117651	117651	285348
14543	17683	2	applied	\N	\N	\N	\N	117652	117652	285349
14543	17684	3	applied	\N	\N	\N	\N	117653	117653	285350
14543	17685	4	applied	\N	\N	\N	\N	117654	117654	285351
14543	17686	5	applied	\N	\N	\N	\N	117655	117655	285352
14545	17689	0	applied	\N	\N	\N	\N	117658	117658	285355
14545	17690	1	applied	\N	\N	\N	\N	117659	117659	285356
14545	17692	3	applied	\N	\N	\N	\N	117661	117661	285358
14551	17705	0	applied	\N	\N	1000000000	\N	117700	117700	285397
14551	17706	1	applied	\N	\N	\N	\N	117701	117701	285398
14551	17707	2	applied	\N	\N	\N	\N	117702	117702	285399
14551	17708	3	applied	\N	\N	\N	\N	117703	117703	285400
14551	17709	4	applied	\N	\N	\N	\N	117704	117704	285401
14551	17710	5	applied	\N	\N	\N	\N	117705	117705	285402
14551	17711	6	applied	\N	\N	\N	\N	117706	117706	285403
14551	17712	7	applied	\N	\N	\N	\N	117707	117707	285404
14551	17713	8	applied	\N	\N	\N	\N	117708	117708	285405
14551	17714	9	applied	\N	\N	\N	\N	117709	117709	285406
14553	17715	0	applied	\N	\N	\N	\N	117720	117720	285417
14553	17716	1	applied	\N	\N	\N	\N	117721	117721	285418
14553	17717	2	applied	\N	\N	\N	\N	117722	117722	285419
14556	17715	0	applied	\N	\N	\N	\N	117729	117729	285426
14556	17716	1	applied	\N	\N	\N	\N	117730	117730	285427
14565	17727	0	applied	\N	\N	\N	\N	117872	117872	285569
14570	17733	0	applied	\N	\N	\N	\N	117893	117893	285590
14570	17734	1	applied	\N	\N	\N	\N	117894	117894	285591
14570	17735	2	applied	\N	\N	\N	\N	117895	117895	285592
14570	17736	3	applied	\N	\N	\N	\N	117896	117896	285593
14570	17737	4	applied	\N	\N	\N	\N	117897	117897	285594
14570	17738	5	applied	\N	\N	\N	\N	117898	117898	285595
14576	17741	0	applied	\N	\N	\N	\N	117913	117913	285610
14576	17742	1	applied	\N	\N	\N	\N	117914	117914	285611
14583	17748	0	applied	\N	\N	\N	\N	117923	117923	285620
14585	17749	0	applied	\N	\N	\N	\N	117925	117925	285622
14585	17750	1	applied	\N	\N	\N	\N	117926	117926	285623
14592	17760	0	applied	\N	\N	\N	\N	117945	117945	285642
14592	17761	1	applied	\N	\N	\N	\N	117946	117946	285643
14592	17762	2	applied	\N	\N	\N	\N	117947	117947	285644
14596	17763	0	applied	\N	\N	\N	\N	117957	117957	285654
14596	17765	2	applied	\N	\N	\N	\N	117959	117959	285656
14601	17769	0	applied	\N	\N	\N	\N	117969	117969	285666
14601	17770	1	applied	\N	\N	\N	\N	117970	117970	285667
14601	17771	2	applied	\N	\N	\N	\N	117971	117971	285668
14608	17778	0	applied	\N	\N	\N	\N	117989	117989	285686
14608	17779	1	applied	\N	\N	\N	\N	117990	117990	285687
14608	17780	2	applied	\N	\N	\N	\N	117991	117991	285688
14609	17785	4	applied	\N	\N	\N	\N	117996	117996	285693
14609	17786	5	applied	\N	\N	\N	\N	117997	117997	285694
14611	17792	0	applied	\N	\N	\N	\N	118014	118014	285711
14611	17793	1	applied	\N	\N	\N	\N	118015	118015	285712
14626	17815	0	applied	\N	\N	\N	\N	118061	118061	285758
14626	17816	1	applied	\N	\N	\N	\N	118062	118062	285759
14626	17817	2	applied	\N	\N	\N	\N	118063	118063	285760
14633	17830	0	applied	\N	\N	\N	\N	118091	118091	285788
14633	17831	1	applied	\N	\N	\N	\N	118092	118092	285789
14633	17833	3	applied	\N	\N	\N	\N	118094	118094	285791
14633	17834	4	applied	\N	\N	\N	\N	118095	118095	285792
14633	17835	5	applied	\N	\N	\N	\N	118096	118096	285793
14633	17836	6	applied	\N	\N	\N	\N	118097	118097	285794
14633	17837	7	applied	\N	\N	\N	\N	118098	118098	285795
14633	17838	8	applied	\N	\N	\N	\N	118099	118099	285796
14641	17845	0	applied	\N	\N	\N	\N	118122	118122	285819
14641	17846	1	applied	\N	\N	\N	\N	118123	118123	285820
14646	17864	0	applied	\N	\N	\N	\N	118266	118266	285963
14646	17865	1	applied	\N	\N	\N	\N	118267	118267	285964
14646	17866	2	applied	\N	\N	\N	\N	118268	118268	285965
14651	17873	0	applied	\N	\N	\N	\N	118406	118406	286103
14651	17874	1	applied	\N	\N	\N	\N	118407	118407	286104
14651	17875	2	applied	\N	\N	\N	\N	118408	118408	286105
14654	17873	0	applied	\N	\N	\N	\N	118415	118415	286112
14654	17874	1	applied	\N	\N	\N	\N	118416	118416	286113
14661	17879	0	applied	\N	\N	\N	\N	118435	118435	286132
14661	17880	1	applied	\N	\N	\N	\N	118436	118436	286133
14661	17881	2	applied	\N	\N	\N	\N	118437	118437	286134
14661	17882	3	applied	\N	\N	\N	\N	118438	118438	286135
14661	17883	4	applied	\N	\N	\N	\N	118439	118439	286136
14665	17887	0	applied	\N	\N	\N	\N	118451	118451	286148
14665	17888	1	applied	\N	\N	\N	\N	118452	118452	286149
14665	17889	2	applied	\N	\N	\N	\N	118453	118453	286150
14665	17890	3	applied	\N	\N	\N	\N	118454	118454	286151
14665	17891	4	applied	\N	\N	\N	\N	118455	118455	286152
14665	17892	5	applied	\N	\N	\N	\N	118456	118456	286153
14668	17925	0	applied	\N	\N	\N	\N	118489	118489	286186
14668	17926	1	applied	\N	\N	\N	\N	118490	118490	286187
14668	17927	2	applied	\N	\N	\N	\N	118491	118491	286188
14668	17928	3	applied	\N	\N	\N	\N	118492	118492	286189
14668	17929	4	applied	\N	\N	\N	\N	118493	118493	286190
14510	17620	3	applied	\N	\N	\N	\N	117535	117535	285232
14542	17684	3	applied	\N	\N	\N	\N	117647	117647	285344
14542	17685	4	applied	\N	\N	\N	\N	117648	117648	285345
14542	17686	5	applied	\N	\N	\N	\N	117649	117649	285346
14544	17687	0	applied	\N	\N	\N	\N	117656	117656	285353
14544	17688	1	applied	\N	\N	\N	\N	117657	117657	285354
14548	17693	0	applied	\N	\N	\N	\N	117678	117678	285375
14548	17694	1	applied	\N	\N	\N	\N	117679	117679	285376
14548	17695	2	applied	\N	\N	\N	\N	117680	117680	285377
14548	17696	3	applied	\N	\N	\N	\N	117681	117681	285378
14548	17697	4	applied	\N	\N	\N	\N	117682	117682	285379
14548	17698	5	applied	\N	\N	\N	\N	117683	117683	285380
14548	17699	6	applied	\N	\N	\N	\N	117684	117684	285381
14548	17700	7	applied	\N	\N	\N	\N	117685	117685	285382
14548	17702	9	applied	\N	\N	\N	\N	117687	117687	285384
14548	17703	10	applied	\N	\N	\N	\N	117688	117688	285385
14548	17704	11	applied	\N	\N	\N	\N	117689	117689	285386
14550	17705	0	applied	\N	\N	1000000000	\N	117690	117690	285387
14550	17706	1	applied	\N	\N	\N	\N	117691	117691	285388
14550	17707	2	applied	\N	\N	\N	\N	117692	117692	285389
14550	17708	3	applied	\N	\N	\N	\N	117693	117693	285390
14550	17709	4	applied	\N	\N	\N	\N	117694	117694	285391
14550	17710	5	applied	\N	\N	\N	\N	117695	117695	285392
14550	17711	6	applied	\N	\N	\N	\N	117696	117696	285393
14550	17712	7	applied	\N	\N	\N	\N	117697	117697	285394
14550	17713	8	applied	\N	\N	\N	\N	117698	117698	285395
14550	17714	9	applied	\N	\N	\N	\N	117699	117699	285396
14559	17721	0	applied	\N	\N	\N	\N	117738	117738	285435
14559	17722	1	applied	\N	\N	\N	\N	117739	117739	285436
14559	17723	2	applied	\N	\N	\N	\N	117740	117740	285437
14561	17725	1	applied	\N	\N	\N	\N	117742	117742	285439
14562	17705	0	applied	\N	\N	1000000000	\N	117743	117743	285440
14562	17499	1	applied	\N	\N	\N	\N	117744	117744	285441
14562	17502	2	applied	\N	\N	\N	\N	117745	117745	285442
14562	17506	3	applied	\N	\N	\N	\N	117746	117746	285443
14562	17507	4	applied	\N	\N	\N	\N	117747	117747	285444
14562	17508	5	applied	\N	\N	\N	\N	117748	117748	285445
14562	17509	6	applied	\N	\N	\N	\N	117749	117749	285446
14562	17521	7	applied	\N	\N	\N	\N	117750	117750	285447
14562	17522	8	applied	\N	\N	\N	\N	117751	117751	285448
14562	17529	9	applied	\N	\N	\N	\N	117752	117752	285449
14562	17530	10	applied	\N	\N	\N	\N	117753	117753	285450
14562	17531	11	applied	\N	\N	\N	\N	117754	117754	285451
14562	17541	12	applied	\N	\N	\N	\N	117755	117755	285452
14562	17545	13	applied	\N	\N	\N	\N	117756	117756	285453
14562	17549	14	applied	\N	\N	\N	\N	117757	117757	285454
14562	17551	16	applied	\N	\N	\N	\N	117759	117759	285456
14562	17552	17	applied	\N	\N	\N	\N	117760	117760	285457
14562	17553	18	applied	\N	\N	\N	\N	117761	117761	285458
14562	17554	19	applied	\N	\N	\N	\N	117762	117762	285459
14562	17570	20	applied	\N	\N	\N	\N	117763	117763	285460
14562	17574	21	applied	\N	\N	\N	\N	117764	117764	285461
14562	17577	22	applied	\N	\N	\N	\N	117765	117765	285462
14562	17578	23	applied	\N	\N	\N	\N	117766	117766	285463
14562	17584	24	applied	\N	\N	\N	\N	117767	117767	285464
14562	17588	26	applied	\N	\N	\N	\N	117768	117768	285465
14562	17589	27	applied	\N	\N	\N	\N	117769	117769	285466
14562	17590	28	applied	\N	\N	\N	\N	117770	117770	285467
14562	17591	29	applied	\N	\N	\N	\N	117771	117771	285468
14562	17604	30	applied	\N	\N	\N	\N	117772	117772	285469
14562	17605	31	applied	\N	\N	\N	\N	117773	117773	285470
14562	17612	32	applied	\N	\N	\N	\N	117774	117774	285471
14562	17617	34	applied	\N	\N	\N	\N	117776	117776	285473
14562	17624	35	applied	\N	\N	\N	\N	117777	117777	285474
14562	17625	36	applied	\N	\N	\N	\N	117778	117778	285475
14562	17631	37	applied	\N	\N	\N	\N	117779	117779	285476
14562	17633	38	applied	\N	\N	\N	\N	117780	117780	285477
14562	17634	39	applied	\N	\N	\N	\N	117781	117781	285478
14562	17639	40	applied	\N	\N	\N	\N	117782	117782	285479
14562	17642	41	applied	\N	\N	\N	\N	117783	117783	285480
14562	17644	42	applied	\N	\N	\N	\N	117784	117784	285481
14562	17645	43	applied	\N	\N	\N	\N	117785	117785	285482
14562	17650	44	applied	\N	\N	\N	\N	117786	117786	285483
14562	17651	45	applied	\N	\N	\N	\N	117787	117787	285484
14562	17656	46	applied	\N	\N	\N	\N	117788	117788	285485
14562	17658	47	applied	\N	\N	\N	\N	117789	117789	285486
14562	17660	48	applied	\N	\N	\N	\N	117790	117790	285487
14562	17662	49	applied	\N	\N	\N	\N	117791	117791	285488
14562	17665	51	applied	\N	\N	\N	\N	117793	117793	285490
14562	17668	52	applied	\N	\N	\N	\N	117794	117794	285491
14562	17669	53	applied	\N	\N	\N	\N	117795	117795	285492
14562	17672	54	applied	\N	\N	\N	\N	117796	117796	285493
14562	17673	55	applied	\N	\N	\N	\N	117797	117797	285494
14562	17678	56	applied	\N	\N	\N	\N	117798	117798	285495
14562	17681	57	applied	\N	\N	\N	\N	117799	117799	285496
14562	17682	58	applied	\N	\N	\N	\N	117800	117800	285497
14562	17687	59	applied	\N	\N	\N	\N	117801	117801	285498
14562	17689	60	applied	\N	\N	\N	\N	117802	117802	285499
14562	17690	61	applied	\N	\N	\N	\N	117803	117803	285500
14562	17693	62	applied	\N	\N	\N	\N	117804	117804	285501
14562	17694	63	applied	\N	\N	\N	\N	117805	117805	285502
14562	17695	64	applied	\N	\N	\N	\N	117806	117806	285503
14562	17696	65	applied	\N	\N	\N	\N	117807	117807	285504
14562	17706	66	applied	\N	\N	\N	\N	117808	117808	285505
14562	17708	68	applied	\N	\N	\N	\N	117810	117810	285507
14562	17715	69	applied	\N	\N	\N	\N	117811	117811	285508
14562	17718	70	applied	\N	\N	\N	\N	117812	117812	285509
14562	17721	71	applied	\N	\N	\N	\N	117813	117813	285510
14562	17724	72	applied	\N	\N	\N	\N	117814	117814	285511
14562	17719	73	applied	\N	\N	\N	\N	117815	117815	285512
14562	17500	74	applied	\N	\N	\N	\N	117816	117816	285513
14562	17501	75	applied	\N	\N	\N	\N	117817	117817	285514
14562	17503	76	applied	\N	\N	\N	\N	117818	117818	285515
14562	17504	77	applied	\N	\N	\N	\N	117819	117819	285516
14562	17505	78	applied	\N	\N	\N	\N	117820	117820	285517
14562	17510	79	applied	\N	\N	\N	\N	117821	117821	285518
14562	17511	80	applied	\N	\N	\N	\N	117822	117822	285519
14562	17512	81	applied	\N	\N	\N	\N	117823	117823	285520
14562	17513	82	applied	\N	\N	\N	\N	117824	117824	285521
14668	17930	5	applied	\N	\N	\N	\N	118494	118494	286191
14542	17682	1	applied	\N	\N	\N	\N	117645	117645	285342
14542	17683	2	applied	\N	\N	\N	\N	117646	117646	285343
14562	17518	87	applied	\N	\N	\N	\N	117829	117829	285526
14562	17519	88	applied	\N	\N	\N	\N	117830	117830	285527
14562	17520	89	applied	\N	\N	\N	\N	117831	117831	285528
14562	17523	90	applied	\N	\N	\N	\N	117832	117832	285529
14562	17524	91	applied	\N	\N	\N	\N	117833	117833	285530
14562	17525	92	applied	\N	\N	\N	\N	117834	117834	285531
14562	17526	93	applied	\N	\N	\N	\N	117835	117835	285532
14562	17527	94	applied	\N	\N	\N	\N	117836	117836	285533
14562	17528	95	applied	\N	\N	\N	\N	117837	117837	285534
14562	17532	96	applied	\N	\N	\N	\N	117838	117838	285535
14562	17533	97	applied	\N	\N	\N	\N	117839	117839	285536
14562	17534	98	applied	\N	\N	\N	\N	117840	117840	285537
14562	17535	99	applied	\N	\N	\N	\N	117841	117841	285538
14562	17536	100	applied	\N	\N	\N	\N	117842	117842	285539
14562	17538	102	applied	\N	\N	\N	\N	117844	117844	285541
14562	17539	103	applied	\N	\N	\N	\N	117845	117845	285542
14562	17540	104	applied	\N	\N	\N	\N	117846	117846	285543
14562	17542	105	applied	\N	\N	\N	\N	117847	117847	285544
14562	17543	106	applied	\N	\N	\N	\N	117848	117848	285545
14562	17544	107	applied	\N	\N	\N	\N	117849	117849	285546
14562	17546	108	applied	\N	\N	\N	\N	117850	117850	285547
14562	17547	109	applied	\N	\N	\N	\N	117851	117851	285548
14562	17548	110	applied	\N	\N	\N	\N	117852	117852	285549
14562	17555	111	applied	\N	\N	\N	\N	117853	117853	285550
14562	17556	112	applied	\N	\N	\N	\N	117854	117854	285551
14562	17557	113	applied	\N	\N	\N	\N	117855	117855	285552
14562	17558	114	applied	\N	\N	\N	\N	117856	117856	285553
14562	17559	115	applied	\N	\N	\N	\N	117857	117857	285554
14562	17560	116	applied	\N	\N	\N	\N	117858	117858	285555
14562	17561	117	applied	\N	\N	\N	\N	117859	117859	285556
14562	17563	119	applied	\N	\N	\N	\N	117861	117861	285558
14562	17564	120	applied	\N	\N	\N	\N	117862	117862	285559
14562	17565	121	applied	\N	\N	\N	\N	117863	117863	285560
14562	17566	122	applied	\N	\N	\N	\N	117864	117864	285561
14562	17567	123	applied	\N	\N	\N	\N	117865	117865	285562
14562	17568	124	applied	\N	\N	\N	\N	117866	117866	285563
14562	17569	125	applied	\N	\N	\N	\N	117867	117867	285564
14564	17726	0	applied	\N	\N	\N	\N	117870	117870	285567
14564	17727	1	applied	\N	\N	\N	\N	117871	117871	285568
14569	17733	0	applied	\N	\N	\N	\N	117887	117887	285584
14569	17734	1	applied	\N	\N	\N	\N	117888	117888	285585
14569	17735	2	applied	\N	\N	\N	\N	117889	117889	285586
14569	17736	3	applied	\N	\N	\N	\N	117890	117890	285587
14569	17737	4	applied	\N	\N	\N	\N	117891	117891	285588
14569	17738	5	applied	\N	\N	\N	\N	117892	117892	285589
14575	17741	0	applied	\N	\N	\N	\N	117911	117911	285608
14578	17743	0	applied	\N	\N	\N	\N	117917	117917	285614
14578	17744	1	applied	\N	\N	\N	\N	117918	117918	285615
14580	17746	0	applied	\N	\N	\N	\N	117920	117920	285617
14587	17751	0	applied	\N	\N	\N	\N	117930	117930	285627
14587	17752	1	applied	\N	\N	\N	\N	117931	117931	285628
14587	17753	2	applied	\N	\N	\N	\N	117932	117932	285629
14590	17754	0	applied	\N	\N	\N	\N	117939	117939	285636
14590	17755	1	applied	\N	\N	\N	\N	117940	117940	285637
14590	17756	2	applied	\N	\N	\N	\N	117941	117941	285638
14595	17763	0	applied	\N	\N	\N	\N	117954	117954	285651
14595	17764	1	applied	\N	\N	\N	\N	117955	117955	285652
14595	17765	2	applied	\N	\N	\N	\N	117956	117956	285653
14600	17766	0	applied	\N	\N	\N	\N	117966	117966	285663
14600	17767	1	applied	\N	\N	\N	\N	117967	117967	285664
14600	17768	2	applied	\N	\N	\N	\N	117968	117968	285665
14603	17769	0	applied	\N	\N	\N	\N	117975	117975	285672
14603	17771	2	applied	\N	\N	\N	\N	117977	117977	285674
14605	17775	0	applied	\N	\N	\N	\N	117981	117981	285678
14605	17776	1	applied	\N	\N	\N	\N	117982	117982	285679
14605	17777	2	applied	\N	\N	\N	\N	117983	117983	285680
14613	17794	0	applied	\N	\N	\N	\N	118019	118019	285716
14613	17795	1	applied	\N	\N	\N	\N	118020	118020	285717
14613	17796	2	applied	\N	\N	\N	\N	118021	118021	285718
14618	17809	0	applied	\N	\N	\N	\N	118040	118040	285737
14618	17810	1	applied	\N	\N	\N	\N	118041	118041	285738
14618	17811	2	applied	\N	\N	\N	\N	118042	118042	285739
14625	17815	0	applied	\N	\N	\N	\N	118058	118058	285755
14625	17816	1	applied	\N	\N	\N	\N	118059	118059	285756
14625	17817	2	applied	\N	\N	\N	\N	118060	118060	285757
14627	17818	0	applied	\N	\N	\N	\N	118064	118064	285761
14627	17819	1	applied	\N	\N	\N	\N	118065	118065	285762
14627	17820	2	applied	\N	\N	\N	\N	118066	118066	285763
14627	17822	4	applied	\N	\N	\N	\N	118068	118068	285765
14627	17823	5	applied	\N	\N	\N	\N	118069	118069	285766
14630	17827	0	applied	\N	\N	\N	\N	118076	118076	285773
14630	17828	1	applied	\N	\N	\N	\N	118077	118077	285774
14630	17829	2	applied	\N	\N	\N	\N	118078	118078	285775
14632	17830	0	applied	\N	\N	\N	\N	118082	118082	285779
14632	17831	1	applied	\N	\N	\N	\N	118083	118083	285780
14632	17832	2	applied	\N	\N	\N	\N	118084	118084	285781
14632	17833	3	applied	\N	\N	\N	\N	118085	118085	285782
14632	17834	4	applied	\N	\N	\N	\N	118086	118086	285783
14632	17835	5	applied	\N	\N	\N	\N	118087	118087	285784
14632	17836	6	applied	\N	\N	\N	\N	118088	118088	285785
14632	17837	7	applied	\N	\N	\N	\N	118089	118089	285786
14632	17838	8	applied	\N	\N	\N	\N	118090	118090	285787
14638	17839	0	applied	\N	\N	\N	\N	118112	118112	285809
14638	17840	1	applied	\N	\N	\N	\N	118113	118113	285810
14638	17842	3	applied	\N	\N	\N	\N	118115	118115	285812
14638	17843	4	applied	\N	\N	\N	\N	118116	118116	285813
14638	17844	5	applied	\N	\N	\N	\N	118117	118117	285814
14640	17845	0	applied	\N	\N	\N	\N	118120	118120	285817
14640	17846	1	applied	\N	\N	\N	\N	118121	118121	285818
14642	17400	0	applied	\N	\N	\N	\N	118124	118124	285821
14642	17705	1	applied	\N	\N	1000000000	\N	118125	118125	285822
14642	17380	2	applied	\N	\N	\N	\N	118126	118126	285823
14642	17381	3	applied	\N	\N	\N	\N	118127	118127	285824
14642	17388	4	applied	\N	\N	\N	\N	118128	118128	285825
14642	17389	5	applied	\N	\N	\N	\N	118129	118129	285826
14642	17390	6	applied	\N	\N	\N	\N	118130	118130	285827
14642	17401	7	applied	\N	\N	\N	\N	118131	118131	285828
14642	17405	8	applied	\N	\N	\N	\N	118132	118132	285829
14642	17406	9	applied	\N	\N	\N	\N	118133	118133	285830
14642	17412	10	applied	\N	\N	\N	\N	118134	118134	285831
14562	17517	86	applied	\N	\N	\N	\N	117828	117828	285525
14609	17791	10	applied	\N	\N	\N	\N	118002	118002	285699
14614	17794	0	applied	\N	\N	\N	\N	118022	118022	285719
14614	17795	1	applied	\N	\N	\N	\N	118023	118023	285720
14614	17796	2	applied	\N	\N	\N	\N	118024	118024	285721
14616	17797	0	applied	\N	\N	\N	\N	118028	118028	285725
14616	17798	1	applied	\N	\N	\N	\N	118029	118029	285726
14616	17799	2	applied	\N	\N	\N	\N	118030	118030	285727
14620	17809	0	applied	\N	\N	\N	\N	118043	118043	285740
14620	17810	1	applied	\N	\N	\N	\N	118044	118044	285741
14620	17811	2	applied	\N	\N	\N	\N	118045	118045	285742
14622	17809	0	applied	\N	\N	\N	\N	118049	118049	285746
14622	17810	1	applied	\N	\N	\N	\N	118050	118050	285747
14622	17811	2	applied	\N	\N	\N	\N	118051	118051	285748
14623	17812	0	applied	\N	\N	\N	\N	118052	118052	285749
14623	17813	1	applied	\N	\N	\N	\N	118053	118053	285750
14623	17814	2	applied	\N	\N	\N	\N	118054	118054	285751
14628	17825	1	applied	\N	\N	\N	\N	118071	118071	285768
14628	17826	2	applied	\N	\N	\N	\N	118072	118072	285769
14631	17827	0	applied	\N	\N	\N	\N	118079	118079	285776
14631	17828	1	applied	\N	\N	\N	\N	118080	118080	285777
14631	17829	2	applied	\N	\N	\N	\N	118081	118081	285778
14636	17839	0	applied	\N	\N	\N	\N	118100	118100	285797
14636	17840	1	applied	\N	\N	\N	\N	118101	118101	285798
14636	17841	2	applied	\N	\N	\N	\N	118102	118102	285799
14636	17842	3	applied	\N	\N	\N	\N	118103	118103	285800
14636	17843	4	applied	\N	\N	\N	\N	118104	118104	285801
14636	17844	5	applied	\N	\N	\N	\N	118105	118105	285802
14642	17415	11	applied	\N	\N	\N	\N	118135	118135	285832
14642	17419	12	applied	\N	\N	\N	\N	118136	118136	285833
14644	17849	0	applied	\N	\N	\N	\N	118251	118251	285948
14644	17850	1	applied	\N	\N	\N	\N	118252	118252	285949
14644	17851	2	applied	\N	\N	\N	\N	118253	118253	285950
14644	17853	4	applied	\N	\N	\N	\N	118255	118255	285952
14644	17854	5	applied	\N	\N	\N	\N	118256	118256	285953
14644	17855	6	applied	\N	\N	\N	\N	118257	118257	285954
14644	17856	7	applied	\N	\N	\N	\N	118258	118258	285955
14644	17857	8	applied	\N	\N	\N	\N	118259	118259	285956
14644	17858	9	applied	\N	\N	\N	\N	118260	118260	285957
14644	17859	10	applied	\N	\N	\N	\N	118261	118261	285958
14644	17860	11	applied	\N	\N	\N	\N	118262	118262	285959
14647	17864	0	applied	\N	\N	\N	\N	118269	118269	285966
14647	17865	1	applied	\N	\N	\N	\N	118270	118270	285967
14647	17866	2	applied	\N	\N	\N	\N	118271	118271	285968
14649	17867	0	applied	\N	\N	\N	\N	118397	118397	286094
14649	17868	1	applied	\N	\N	\N	\N	118398	118398	286095
14649	17869	2	applied	\N	\N	\N	\N	118399	118399	286096
14649	17870	3	applied	\N	\N	\N	\N	118400	118400	286097
14649	17871	4	applied	\N	\N	\N	\N	118401	118401	286098
14652	17873	0	applied	\N	\N	\N	\N	118409	118409	286106
14652	17874	1	applied	\N	\N	\N	\N	118410	118410	286107
14652	17875	2	applied	\N	\N	\N	\N	118411	118411	286108
14659	17876	0	applied	\N	\N	\N	\N	118427	118427	286124
14659	17877	1	applied	\N	\N	\N	\N	118428	118428	286125
14659	17878	2	applied	\N	\N	\N	\N	118429	118429	286126
14663	17884	0	applied	\N	\N	\N	\N	118445	118445	286142
14663	17885	1	applied	\N	\N	\N	\N	118446	118446	286143
14663	17886	2	applied	\N	\N	\N	\N	118447	118447	286144
14675	17941	0	applied	\N	\N	\N	\N	118573	118573	286270
14675	17942	1	applied	\N	\N	\N	\N	118574	118574	286271
14675	17943	2	applied	\N	\N	\N	\N	118575	118575	286272
14675	17944	3	applied	\N	\N	\N	\N	118576	118576	286273
14675	17945	4	applied	\N	\N	\N	\N	118577	118577	286274
14675	17946	5	applied	\N	\N	\N	\N	118578	118578	286275
14675	17947	6	applied	\N	\N	\N	\N	118579	118579	286276
14675	17949	8	applied	\N	\N	\N	\N	118581	118581	286278
14675	17950	9	applied	\N	\N	\N	\N	118582	118582	286279
14675	17951	10	applied	\N	\N	\N	\N	118583	118583	286280
14675	17952	11	applied	\N	\N	\N	\N	118584	118584	286281
14675	17953	12	applied	\N	\N	\N	\N	118585	118585	286282
14675	17954	13	applied	\N	\N	\N	\N	118586	118586	286283
14675	17955	14	applied	\N	\N	\N	\N	118587	118587	286284
14675	17956	15	applied	\N	\N	\N	\N	118588	118588	286285
14675	17957	16	applied	\N	\N	\N	\N	118589	118589	286286
14675	17958	17	applied	\N	\N	\N	\N	118590	118590	286287
14675	17959	18	applied	\N	\N	\N	\N	118591	118591	286288
14675	17960	19	applied	\N	\N	\N	\N	118592	118592	286289
14675	17961	20	applied	\N	\N	\N	\N	118593	118593	286290
14675	17962	21	applied	\N	\N	\N	\N	118594	118594	286291
14675	17963	22	applied	\N	\N	\N	\N	118595	118595	286292
14675	17964	23	applied	\N	\N	\N	\N	118596	118596	286293
14678	17966	1	applied	\N	\N	\N	\N	118646	118646	286343
14678	17967	2	applied	\N	\N	\N	\N	118647	118647	286344
14678	17968	3	applied	\N	\N	\N	\N	118648	118648	286345
14678	17969	4	applied	\N	\N	\N	\N	118649	118649	286346
14678	17970	5	applied	\N	\N	\N	\N	118650	118650	286347
14678	17971	6	applied	\N	\N	\N	\N	118651	118651	286348
14678	17972	7	applied	\N	\N	\N	\N	118652	118652	286349
14678	17973	8	applied	\N	\N	\N	\N	118653	118653	286350
14678	17974	9	applied	\N	\N	\N	\N	118654	118654	286351
14678	17975	10	applied	\N	\N	\N	\N	118655	118655	286352
14678	17976	11	applied	\N	\N	\N	\N	118656	118656	286353
14678	17977	13	applied	\N	\N	\N	\N	118657	118657	286354
14678	17978	14	applied	\N	\N	\N	\N	118658	118658	286355
14678	17979	15	applied	\N	\N	\N	\N	118659	118659	286356
14678	17980	16	applied	\N	\N	\N	\N	118660	118660	286357
14679	17981	0	applied	\N	\N	\N	\N	118661	118661	286358
14679	17983	2	applied	\N	\N	\N	\N	118663	118663	286360
14679	17984	3	applied	\N	\N	\N	\N	118664	118664	286361
14679	17985	4	applied	\N	\N	\N	\N	118665	118665	286362
14679	17986	5	applied	\N	\N	\N	\N	118666	118666	286363
14679	17987	6	applied	\N	\N	\N	\N	118667	118667	286364
14679	17988	7	applied	\N	\N	\N	\N	118668	118668	286365
14679	17989	8	applied	\N	\N	\N	\N	118669	118669	286366
14679	17990	9	applied	\N	\N	\N	\N	118670	118670	286367
14679	17991	10	applied	\N	\N	\N	\N	118671	118671	286368
14679	17992	11	applied	\N	\N	\N	\N	118672	118672	286369
14679	17993	12	applied	\N	\N	\N	\N	118673	118673	286370
14679	17994	13	applied	\N	\N	\N	\N	118674	118674	286371
14679	17995	14	applied	\N	\N	\N	\N	118675	118675	286372
14679	17996	15	applied	\N	\N	\N	\N	118676	118676	286373
14609	17788	7	applied	\N	\N	\N	\N	117999	117999	285696
14609	17789	8	applied	\N	\N	\N	\N	118000	118000	285697
14617	17801	1	applied	\N	\N	\N	\N	118032	118032	285729
14617	17802	2	applied	\N	\N	\N	\N	118033	118033	285730
14617	17803	3	applied	\N	\N	\N	\N	118034	118034	285731
14617	17804	4	applied	\N	\N	\N	\N	118035	118035	285732
14617	17805	5	applied	\N	\N	\N	\N	118036	118036	285733
14617	17806	6	applied	\N	\N	\N	\N	118037	118037	285734
14617	17807	7	applied	\N	\N	\N	\N	118038	118038	285735
14617	17808	8	applied	\N	\N	\N	\N	118039	118039	285736
14621	17809	0	applied	\N	\N	\N	\N	118046	118046	285743
14621	17810	1	applied	\N	\N	\N	\N	118047	118047	285744
14621	17811	2	applied	\N	\N	\N	\N	118048	118048	285745
14624	17815	0	applied	\N	\N	\N	\N	118055	118055	285752
14624	17816	1	applied	\N	\N	\N	\N	118056	118056	285753
14624	17817	2	applied	\N	\N	\N	\N	118057	118057	285754
14629	17827	0	applied	\N	\N	\N	\N	118073	118073	285770
14629	17828	1	applied	\N	\N	\N	\N	118074	118074	285771
14637	17839	0	applied	\N	\N	\N	\N	118106	118106	285803
14637	17840	1	applied	\N	\N	\N	\N	118107	118107	285804
14637	17841	2	applied	\N	\N	\N	\N	118108	118108	285805
14637	17842	3	applied	\N	\N	\N	\N	118109	118109	285806
14637	17843	4	applied	\N	\N	\N	\N	118110	118110	285807
14637	17844	5	applied	\N	\N	\N	\N	118111	118111	285808
14639	17845	0	applied	\N	\N	\N	\N	118118	118118	285815
14639	17846	1	applied	\N	\N	\N	\N	118119	118119	285816
14643	17847	0	applied	\N	\N	\N	\N	118249	118249	285946
14643	17848	1	applied	\N	\N	\N	\N	118250	118250	285947
14653	17873	0	applied	\N	\N	\N	\N	118412	118412	286109
14653	17874	1	applied	\N	\N	\N	\N	118413	118413	286110
14653	17875	2	applied	\N	\N	\N	\N	118414	118414	286111
14656	17873	0	applied	\N	\N	\N	\N	118418	118418	286115
14656	17874	1	applied	\N	\N	\N	\N	118419	118419	286116
14656	17875	2	applied	\N	\N	\N	\N	118420	118420	286117
14657	17877	1	applied	\N	\N	\N	\N	118422	118422	286119
14657	17878	2	applied	\N	\N	\N	\N	118423	118423	286120
14662	17879	0	applied	\N	\N	\N	\N	118440	118440	286137
14662	17880	1	applied	\N	\N	\N	\N	118441	118441	286138
14662	17881	2	applied	\N	\N	\N	\N	118442	118442	286139
14662	17882	3	applied	\N	\N	\N	\N	118443	118443	286140
14662	17883	4	applied	\N	\N	\N	\N	118444	118444	286141
14664	17884	0	applied	\N	\N	\N	\N	118448	118448	286145
14664	17885	1	applied	\N	\N	\N	\N	118449	118449	286146
14664	17886	2	applied	\N	\N	\N	\N	118450	118450	286147
14666	17893	0	applied	\N	\N	\N	\N	118457	118457	286154
14666	17894	1	applied	\N	\N	\N	\N	118458	118458	286155
14666	17895	2	applied	\N	\N	\N	\N	118459	118459	286156
14666	17896	3	applied	\N	\N	\N	\N	118460	118460	286157
14666	17897	4	applied	\N	\N	\N	\N	118461	118461	286158
14666	17898	5	applied	\N	\N	\N	\N	118462	118462	286159
14666	17900	7	applied	\N	\N	\N	\N	118464	118464	286161
14667	17901	0	applied	\N	\N	\N	\N	118465	118465	286162
14667	17902	1	applied	\N	\N	\N	\N	118466	118466	286163
14667	17903	2	applied	\N	\N	\N	\N	118467	118467	286164
14667	17904	3	applied	\N	\N	\N	\N	118468	118468	286165
14667	17905	4	applied	\N	\N	\N	\N	118469	118469	286166
14667	17906	5	applied	\N	\N	\N	\N	118470	118470	286167
14667	17907	6	applied	\N	\N	\N	\N	118471	118471	286168
14667	17908	7	applied	\N	\N	\N	\N	118472	118472	286169
14667	17909	8	applied	\N	\N	\N	\N	118473	118473	286170
14667	17910	9	applied	\N	\N	\N	\N	118474	118474	286171
14667	17911	10	applied	\N	\N	\N	\N	118475	118475	286172
14667	17912	11	applied	\N	\N	\N	\N	118476	118476	286173
14667	17913	12	applied	\N	\N	\N	\N	118477	118477	286174
14667	17914	13	applied	\N	\N	\N	\N	118478	118478	286175
14667	17915	14	applied	\N	\N	\N	\N	118479	118479	286176
14667	17917	16	applied	\N	\N	\N	\N	118481	118481	286178
14667	17918	17	applied	\N	\N	\N	\N	118482	118482	286179
14667	17919	18	applied	\N	\N	\N	\N	118483	118483	286180
14667	17920	19	applied	\N	\N	\N	\N	118484	118484	286181
14667	17921	20	applied	\N	\N	\N	\N	118485	118485	286182
14667	17922	21	applied	\N	\N	\N	\N	118486	118486	286183
14667	17923	22	applied	\N	\N	\N	\N	118487	118487	286184
14667	17924	23	applied	\N	\N	\N	\N	118488	118488	286185
14669	17925	0	applied	\N	\N	\N	\N	118497	118497	286194
14669	17926	1	applied	\N	\N	\N	\N	118498	118498	286195
14669	17927	2	applied	\N	\N	\N	\N	118499	118499	286196
14669	17928	3	applied	\N	\N	\N	\N	118500	118500	286197
14669	17929	4	applied	\N	\N	\N	\N	118501	118501	286198
14669	17930	5	applied	\N	\N	\N	\N	118502	118502	286199
14669	17931	6	applied	\N	\N	\N	\N	118503	118503	286200
14672	17941	0	applied	\N	\N	\N	\N	118522	118522	286219
14672	17943	2	applied	\N	\N	\N	\N	118524	118524	286221
14679	17997	16	applied	\N	\N	\N	\N	118677	118677	286374
14679	17998	17	applied	\N	\N	\N	\N	118678	118678	286375
14680	17887	0	applied	\N	\N	\N	\N	118685	118685	286382
14680	17889	1	applied	\N	\N	\N	\N	118686	118686	286383
14680	17890	2	applied	\N	\N	\N	\N	118687	118687	286384
14680	17891	3	applied	\N	\N	\N	\N	118688	118688	286385
14680	17893	4	applied	\N	\N	\N	\N	118689	118689	286386
14680	17895	5	applied	\N	\N	\N	\N	118690	118690	286387
14680	17896	6	applied	\N	\N	\N	\N	118691	118691	286388
14680	17897	7	applied	\N	\N	\N	\N	118692	118692	286389
14680	17898	8	applied	\N	\N	\N	\N	118693	118693	286390
14680	17899	9	applied	\N	\N	\N	\N	118694	118694	286391
14680	17901	10	applied	\N	\N	\N	\N	118695	118695	286392
14680	17905	11	applied	\N	\N	\N	\N	118696	118696	286393
14680	17906	12	applied	\N	\N	\N	\N	118697	118697	286394
14680	17908	14	applied	\N	\N	\N	\N	118699	118699	286396
14680	17909	15	applied	\N	\N	\N	\N	118700	118700	286397
14680	17910	16	applied	\N	\N	\N	\N	118701	118701	286398
14680	17911	17	applied	\N	\N	\N	\N	118702	118702	286399
14680	17912	18	applied	\N	\N	\N	\N	118703	118703	286400
14680	17913	19	applied	\N	\N	\N	\N	118704	118704	286401
14680	17914	20	applied	\N	\N	\N	\N	118705	118705	286402
14680	17915	21	applied	\N	\N	\N	\N	118706	118706	286403
14680	17916	22	applied	\N	\N	\N	\N	118707	118707	286404
14680	17917	23	applied	\N	\N	\N	\N	118708	118708	286405
14680	17918	24	applied	\N	\N	\N	\N	118709	118709	286406
14680	17919	25	applied	\N	\N	\N	\N	118710	118710	286407
14680	17920	26	applied	\N	\N	\N	\N	118711	118711	286408
14680	17921	27	applied	\N	\N	\N	\N	118712	118712	286409
14615	17795	1	applied	\N	\N	\N	\N	118026	118026	285723
14615	17796	2	applied	\N	\N	\N	\N	118027	118027	285724
14642	17436	17	applied	\N	\N	\N	\N	118141	118141	285838
14642	17450	18	applied	\N	\N	\N	\N	118142	118142	285839
14642	17453	19	applied	\N	\N	\N	\N	118143	118143	285840
14642	17456	20	applied	\N	\N	\N	\N	118144	118144	285841
14642	17460	21	applied	\N	\N	\N	\N	118145	118145	285842
14642	17461	22	applied	\N	\N	\N	\N	118146	118146	285843
14642	17468	23	applied	\N	\N	\N	\N	118147	118147	285844
14642	17472	24	applied	\N	\N	\N	\N	118148	118148	285845
14642	17473	25	applied	\N	\N	\N	\N	118149	118149	285846
14642	17479	26	applied	\N	\N	\N	\N	118150	118150	285847
14642	17483	27	applied	\N	\N	\N	\N	118151	118151	285848
14642	17487	28	applied	\N	\N	\N	\N	118152	118152	285849
14642	17488	29	applied	\N	\N	\N	\N	118153	118153	285850
14642	17495	30	applied	\N	\N	\N	\N	118154	118154	285851
14642	17499	31	applied	\N	\N	\N	\N	118155	118155	285852
14642	17502	32	applied	\N	\N	\N	\N	118156	118156	285853
14642	17507	34	applied	\N	\N	\N	\N	118158	118158	285855
14642	17508	35	applied	\N	\N	\N	\N	118159	118159	285856
14642	17509	36	applied	\N	\N	\N	\N	118160	118160	285857
14642	17521	37	applied	\N	\N	\N	\N	118161	118161	285858
14642	17522	38	applied	\N	\N	\N	\N	118162	118162	285859
14642	17529	39	applied	\N	\N	\N	\N	118163	118163	285860
14642	17530	40	applied	\N	\N	\N	\N	118164	118164	285861
14642	17531	41	applied	\N	\N	\N	\N	118165	118165	285862
14642	17541	42	applied	\N	\N	\N	\N	118166	118166	285863
14642	17545	43	applied	\N	\N	\N	\N	118167	118167	285864
14642	17549	44	applied	\N	\N	\N	\N	118168	118168	285865
14642	17550	45	applied	\N	\N	\N	\N	118169	118169	285866
14642	17551	46	applied	\N	\N	\N	\N	118170	118170	285867
14642	17552	47	applied	\N	\N	\N	\N	118171	118171	285868
14642	17553	48	applied	\N	\N	\N	\N	118172	118172	285869
14642	17554	49	applied	\N	\N	\N	\N	118173	118173	285870
14642	17574	51	applied	\N	\N	\N	\N	118175	118175	285872
14642	17577	52	applied	\N	\N	\N	\N	118176	118176	285873
14642	17578	53	applied	\N	\N	\N	\N	118177	118177	285874
14642	17584	54	applied	\N	\N	\N	\N	118178	118178	285875
14642	17588	55	applied	\N	\N	\N	\N	118179	118179	285876
14642	17589	56	applied	\N	\N	\N	\N	118180	118180	285877
14642	17590	57	applied	\N	\N	\N	\N	118181	118181	285878
14642	17591	58	applied	\N	\N	\N	\N	118182	118182	285879
14642	17604	59	applied	\N	\N	\N	\N	118183	118183	285880
14642	17605	60	applied	\N	\N	\N	\N	118184	118184	285881
14642	17612	61	applied	\N	\N	\N	\N	118185	118185	285882
14642	17613	62	applied	\N	\N	\N	\N	118186	118186	285883
14642	17617	64	applied	\N	\N	\N	\N	118187	118187	285884
14642	17624	65	applied	\N	\N	\N	\N	118188	118188	285885
14642	17625	66	applied	\N	\N	\N	\N	118189	118189	285886
14642	17631	67	applied	\N	\N	\N	\N	118190	118190	285887
14642	17634	69	applied	\N	\N	\N	\N	118192	118192	285889
14642	17639	70	applied	\N	\N	\N	\N	118193	118193	285890
14642	17642	71	applied	\N	\N	\N	\N	118194	118194	285891
14642	17644	72	applied	\N	\N	\N	\N	118195	118195	285892
14642	17645	73	applied	\N	\N	\N	\N	118196	118196	285893
14642	17650	74	applied	\N	\N	\N	\N	118197	118197	285894
14642	17651	75	applied	\N	\N	\N	\N	118198	118198	285895
14642	17656	76	applied	\N	\N	\N	\N	118199	118199	285896
14642	17658	77	applied	\N	\N	\N	\N	118200	118200	285897
14642	17660	78	applied	\N	\N	\N	\N	118201	118201	285898
14642	17662	79	applied	\N	\N	\N	\N	118202	118202	285899
14642	17664	80	applied	\N	\N	\N	\N	118203	118203	285900
14642	17665	81	applied	\N	\N	\N	\N	118204	118204	285901
14642	17668	82	applied	\N	\N	\N	\N	118205	118205	285902
14642	17669	83	applied	\N	\N	\N	\N	118206	118206	285903
14642	17672	84	applied	\N	\N	\N	\N	118207	118207	285904
14642	17678	86	applied	\N	\N	\N	\N	118209	118209	285906
14642	17681	87	applied	\N	\N	\N	\N	118210	118210	285907
14642	17682	88	applied	\N	\N	\N	\N	118211	118211	285908
14642	17687	89	applied	\N	\N	\N	\N	118212	118212	285909
14642	17689	90	applied	\N	\N	\N	\N	118213	118213	285910
14642	17690	91	applied	\N	\N	\N	\N	118214	118214	285911
14642	17693	92	applied	\N	\N	\N	\N	118215	118215	285912
14642	17694	93	applied	\N	\N	\N	\N	118216	118216	285913
14642	17695	94	applied	\N	\N	\N	\N	118217	118217	285914
14642	17696	95	applied	\N	\N	\N	\N	118218	118218	285915
14642	17706	96	applied	\N	\N	\N	\N	118219	118219	285916
14642	17707	97	applied	\N	\N	\N	\N	118220	118220	285917
14642	17708	98	applied	\N	\N	\N	\N	118221	118221	285918
14642	17715	99	applied	\N	\N	\N	\N	118222	118222	285919
14642	17718	100	applied	\N	\N	\N	\N	118223	118223	285920
14642	17721	101	applied	\N	\N	\N	\N	118224	118224	285921
14642	17726	103	applied	\N	\N	\N	\N	118226	118226	285923
14642	17728	104	applied	\N	\N	\N	\N	118227	118227	285924
14642	17729	105	applied	\N	\N	\N	\N	118228	118228	285925
14642	17733	106	applied	\N	\N	\N	\N	118229	118229	285926
14642	17734	107	applied	\N	\N	\N	\N	118230	118230	285927
14642	17735	108	applied	\N	\N	\N	\N	118231	118231	285928
14642	17739	109	applied	\N	\N	\N	\N	118232	118232	285929
14642	17741	110	applied	\N	\N	\N	\N	118233	118233	285930
14642	17743	111	applied	\N	\N	\N	\N	118234	118234	285931
14642	17751	112	applied	\N	\N	\N	\N	118235	118235	285932
14642	17754	113	applied	\N	\N	\N	\N	118236	118236	285933
14642	17757	114	applied	\N	\N	\N	\N	118237	118237	285934
14642	17760	115	applied	\N	\N	\N	\N	118238	118238	285935
14642	17763	116	applied	\N	\N	\N	\N	118239	118239	285936
14642	17766	117	applied	\N	\N	\N	\N	118240	118240	285937
14642	17769	118	applied	\N	\N	\N	\N	118241	118241	285938
14642	17775	120	applied	\N	\N	\N	\N	118243	118243	285940
14642	17778	121	applied	\N	\N	\N	\N	118244	118244	285941
14642	17781	122	applied	\N	\N	\N	\N	118245	118245	285942
14642	17782	123	applied	\N	\N	\N	\N	118246	118246	285943
14642	17783	124	applied	\N	\N	\N	\N	118247	118247	285944
14642	17784	125	applied	\N	\N	\N	\N	118248	118248	285945
14645	17861	0	applied	\N	\N	\N	\N	118263	118263	285960
14645	17862	1	applied	\N	\N	\N	\N	118264	118264	285961
14645	17863	2	applied	\N	\N	\N	\N	118265	118265	285962
14648	17792	0	applied	\N	\N	\N	\N	118272	118272	285969
14648	17794	1	applied	\N	\N	\N	\N	118273	118273	285970
14648	17797	2	applied	\N	\N	\N	\N	118274	118274	285971
14680	17925	28	applied	\N	\N	\N	\N	118713	118713	286410
14680	17926	29	applied	\N	\N	\N	\N	118714	118714	286411
14642	17425	14	applied	\N	\N	\N	\N	118138	118138	285835
14642	17429	15	applied	\N	\N	\N	\N	118139	118139	285836
14648	17812	7	applied	\N	\N	\N	\N	118279	118279	285976
14648	17815	8	applied	\N	\N	\N	\N	118280	118280	285977
14648	17818	9	applied	\N	\N	\N	\N	118281	118281	285978
14648	17819	10	applied	\N	\N	\N	\N	118282	118282	285979
14648	17824	11	applied	\N	\N	\N	\N	118283	118283	285980
14648	17827	12	applied	\N	\N	\N	\N	118284	118284	285981
14648	17830	13	applied	\N	\N	\N	\N	118285	118285	285982
14648	17831	14	applied	\N	\N	\N	\N	118286	118286	285983
14648	17832	15	applied	\N	\N	\N	\N	118287	118287	285984
14648	17839	16	applied	\N	\N	\N	\N	118288	118288	285985
14648	17840	17	applied	\N	\N	\N	\N	118289	118289	285986
14648	17849	18	applied	\N	\N	\N	\N	118290	118290	285987
14648	17850	19	applied	\N	\N	\N	\N	118291	118291	285988
14648	17861	20	applied	\N	\N	\N	\N	118292	118292	285989
14648	17864	21	applied	\N	\N	\N	\N	118293	118293	285990
14648	17719	22	applied	\N	\N	\N	\N	118294	118294	285991
14648	17383	24	applied	\N	\N	\N	\N	118296	118296	285993
14648	17384	25	applied	\N	\N	\N	\N	118297	118297	285994
14648	17385	26	applied	\N	\N	\N	\N	118298	118298	285995
14648	17386	27	applied	\N	\N	\N	\N	118299	118299	285996
14648	17387	28	applied	\N	\N	\N	\N	118300	118300	285997
14648	17391	29	applied	\N	\N	\N	\N	118301	118301	285998
14648	17392	30	applied	\N	\N	\N	\N	118302	118302	285999
14648	17393	31	applied	\N	\N	\N	\N	118303	118303	286000
14648	17394	32	applied	\N	\N	\N	\N	118304	118304	286001
14648	17395	33	applied	\N	\N	\N	\N	118305	118305	286002
14648	17396	34	applied	\N	\N	\N	\N	118306	118306	286003
14648	17397	35	applied	\N	\N	\N	\N	118307	118307	286004
14648	17398	36	applied	\N	\N	\N	\N	118308	118308	286005
14648	17399	37	applied	\N	\N	\N	\N	118309	118309	286006
14648	17402	38	applied	\N	\N	\N	\N	118310	118310	286007
14648	17403	39	applied	\N	\N	\N	\N	118311	118311	286008
14648	17407	41	applied	\N	\N	\N	\N	118313	118313	286010
14648	17408	42	applied	\N	\N	\N	\N	118314	118314	286011
14648	17409	43	applied	\N	\N	\N	\N	118315	118315	286012
14648	17410	44	applied	\N	\N	\N	\N	118316	118316	286013
14648	17411	45	applied	\N	\N	\N	\N	118317	118317	286014
14648	17413	46	applied	\N	\N	\N	\N	118318	118318	286015
14648	17414	47	applied	\N	\N	\N	\N	118319	118319	286016
14648	17416	48	applied	\N	\N	\N	\N	118320	118320	286017
14648	17417	49	applied	\N	\N	\N	\N	118321	118321	286018
14648	17418	50	applied	\N	\N	\N	\N	118322	118322	286019
14648	17421	51	applied	\N	\N	\N	\N	118323	118323	286020
14648	17422	52	applied	\N	\N	\N	\N	118324	118324	286021
14648	17423	53	applied	\N	\N	\N	\N	118325	118325	286022
14648	17424	54	applied	\N	\N	\N	\N	118326	118326	286023
14648	17426	55	applied	\N	\N	\N	\N	118327	118327	286024
14648	17427	56	applied	\N	\N	\N	\N	118328	118328	286025
14648	17430	58	applied	\N	\N	\N	\N	118330	118330	286027
14648	17431	59	applied	\N	\N	\N	\N	118331	118331	286028
14648	17432	60	applied	\N	\N	\N	\N	118332	118332	286029
14648	17434	61	applied	\N	\N	\N	\N	118333	118333	286030
14648	17435	62	applied	\N	\N	\N	\N	118334	118334	286031
14648	17437	64	applied	\N	\N	\N	\N	118335	118335	286032
14648	17438	65	applied	\N	\N	\N	\N	118336	118336	286033
14648	17439	66	applied	\N	\N	\N	\N	118337	118337	286034
14648	17440	67	applied	\N	\N	\N	\N	118338	118338	286035
14648	17441	68	applied	\N	\N	\N	\N	118339	118339	286036
14648	17442	69	applied	\N	\N	\N	\N	118340	118340	286037
14648	17443	70	applied	\N	\N	\N	\N	118341	118341	286038
14648	17444	71	applied	\N	\N	\N	\N	118342	118342	286039
14648	17445	72	applied	\N	\N	\N	\N	118343	118343	286040
14648	17446	73	applied	\N	\N	\N	\N	118344	118344	286041
14648	17447	74	applied	\N	\N	\N	\N	118345	118345	286042
14648	17449	76	applied	\N	\N	\N	\N	118347	118347	286044
14648	17451	77	applied	\N	\N	\N	\N	118348	118348	286045
14648	17452	78	applied	\N	\N	\N	\N	118349	118349	286046
14648	17454	79	applied	\N	\N	\N	\N	118350	118350	286047
14648	17455	80	applied	\N	\N	\N	\N	118351	118351	286048
14648	17457	81	applied	\N	\N	\N	\N	118352	118352	286049
14648	17458	82	applied	\N	\N	\N	\N	118353	118353	286050
14648	17459	83	applied	\N	\N	\N	\N	118354	118354	286051
14648	17462	84	applied	\N	\N	\N	\N	118355	118355	286052
14648	17463	85	applied	\N	\N	\N	\N	118356	118356	286053
14648	17464	86	applied	\N	\N	\N	\N	118357	118357	286054
14648	17465	87	applied	\N	\N	\N	\N	118358	118358	286055
14648	17466	88	applied	\N	\N	\N	\N	118359	118359	286056
14648	17467	89	applied	\N	\N	\N	\N	118360	118360	286057
14648	17469	90	applied	\N	\N	\N	\N	118361	118361	286058
14648	17470	91	applied	\N	\N	\N	\N	118362	118362	286059
14648	17474	93	applied	\N	\N	\N	\N	118364	118364	286061
14648	17475	94	applied	\N	\N	\N	\N	118365	118365	286062
14648	17476	95	applied	\N	\N	\N	\N	118366	118366	286063
14648	17477	96	applied	\N	\N	\N	\N	118367	118367	286064
14648	17478	97	applied	\N	\N	\N	\N	118368	118368	286065
14648	17480	98	applied	\N	\N	\N	\N	118369	118369	286066
14648	17481	99	applied	\N	\N	\N	\N	118370	118370	286067
14648	17482	100	applied	\N	\N	\N	\N	118371	118371	286068
14648	17484	101	applied	\N	\N	\N	\N	118372	118372	286069
14648	17485	102	applied	\N	\N	\N	\N	118373	118373	286070
14648	17486	103	applied	\N	\N	\N	\N	118374	118374	286071
14648	17489	104	applied	\N	\N	\N	\N	118375	118375	286072
14648	17490	105	applied	\N	\N	\N	\N	118376	118376	286073
14648	17491	106	applied	\N	\N	\N	\N	118377	118377	286074
14648	17492	107	applied	\N	\N	\N	\N	118378	118378	286075
14648	17493	108	applied	\N	\N	\N	\N	118379	118379	286076
14648	17496	110	applied	\N	\N	\N	\N	118381	118381	286078
14648	17497	111	applied	\N	\N	\N	\N	118382	118382	286079
14648	17498	112	applied	\N	\N	\N	\N	118383	118383	286080
14648	17500	113	applied	\N	\N	\N	\N	118384	118384	286081
14648	17501	114	applied	\N	\N	\N	\N	118385	118385	286082
14648	17503	115	applied	\N	\N	\N	\N	118386	118386	286083
14648	17504	116	applied	\N	\N	\N	\N	118387	118387	286084
14648	17505	117	applied	\N	\N	\N	\N	118388	118388	286085
14648	17510	118	applied	\N	\N	\N	\N	118389	118389	286086
14648	17511	119	applied	\N	\N	\N	\N	118390	118390	286087
14648	17512	120	applied	\N	\N	\N	\N	118391	118391	286088
14648	17513	121	applied	\N	\N	\N	\N	118392	118392	286089
14648	17514	122	applied	\N	\N	\N	\N	118393	118393	286090
14648	17515	123	applied	\N	\N	\N	\N	118394	118394	286091
14648	17801	4	applied	\N	\N	\N	\N	118276	118276	285973
14648	17802	5	applied	\N	\N	\N	\N	118277	118277	285974
14650	17875	2	applied	\N	\N	\N	\N	118405	118405	286102
14658	17876	0	applied	\N	\N	\N	\N	118424	118424	286121
14658	17877	1	applied	\N	\N	\N	\N	118425	118425	286122
14658	17878	2	applied	\N	\N	\N	\N	118426	118426	286123
14660	17879	0	applied	\N	\N	\N	\N	118430	118430	286127
14660	17880	1	applied	\N	\N	\N	\N	118431	118431	286128
14660	17881	2	applied	\N	\N	\N	\N	118432	118432	286129
14660	17882	3	applied	\N	\N	\N	\N	118433	118433	286130
14660	17883	4	applied	\N	\N	\N	\N	118434	118434	286131
14670	17933	0	applied	\N	\N	\N	\N	118504	118504	286201
14670	17934	1	applied	\N	\N	\N	\N	118505	118505	286202
14670	17935	2	applied	\N	\N	\N	\N	118506	118506	286203
14670	17936	3	applied	\N	\N	\N	\N	118507	118507	286204
14670	17937	4	applied	\N	\N	\N	\N	118508	118508	286205
14670	17938	5	applied	\N	\N	\N	\N	118509	118509	286206
14670	17939	6	applied	\N	\N	\N	\N	118510	118510	286207
14670	17940	8	applied	\N	\N	\N	\N	118512	118512	286209
14673	17941	0	applied	\N	\N	\N	\N	118525	118525	286222
14673	17942	1	applied	\N	\N	\N	\N	118526	118526	286223
14673	17943	2	applied	\N	\N	\N	\N	118527	118527	286224
14673	17944	3	applied	\N	\N	\N	\N	118528	118528	286225
14673	17945	4	applied	\N	\N	\N	\N	118529	118529	286226
14673	17946	5	applied	\N	\N	\N	\N	118530	118530	286227
14673	17947	6	applied	\N	\N	\N	\N	118531	118531	286228
14673	17948	7	applied	\N	\N	\N	\N	118532	118532	286229
14673	17949	8	applied	\N	\N	\N	\N	118533	118533	286230
14673	17950	9	applied	\N	\N	\N	\N	118534	118534	286231
14673	17951	10	applied	\N	\N	\N	\N	118535	118535	286232
14673	17952	11	applied	\N	\N	\N	\N	118536	118536	286233
14673	17953	12	applied	\N	\N	\N	\N	118537	118537	286234
14673	17954	13	applied	\N	\N	\N	\N	118538	118538	286235
14673	17955	14	applied	\N	\N	\N	\N	118539	118539	286236
14673	17957	16	applied	\N	\N	\N	\N	118541	118541	286238
14673	17958	17	applied	\N	\N	\N	\N	118542	118542	286239
14673	17959	18	applied	\N	\N	\N	\N	118543	118543	286240
14673	17960	19	applied	\N	\N	\N	\N	118544	118544	286241
14673	17961	20	applied	\N	\N	\N	\N	118545	118545	286242
14673	17962	21	applied	\N	\N	\N	\N	118546	118546	286243
14673	17963	22	applied	\N	\N	\N	\N	118547	118547	286244
14673	17964	23	applied	\N	\N	\N	\N	118548	118548	286245
14676	17941	0	applied	\N	\N	\N	\N	118597	118597	286294
14676	17942	1	applied	\N	\N	\N	\N	118598	118598	286295
14676	17943	2	applied	\N	\N	\N	\N	118599	118599	286296
14676	17944	3	applied	\N	\N	\N	\N	118600	118600	286297
14676	17945	4	applied	\N	\N	\N	\N	118601	118601	286298
14676	17946	5	applied	\N	\N	\N	\N	118602	118602	286299
14676	17947	6	applied	\N	\N	\N	\N	118603	118603	286300
14676	17948	7	applied	\N	\N	\N	\N	118604	118604	286301
14676	17950	9	applied	\N	\N	\N	\N	118606	118606	286303
14676	17951	10	applied	\N	\N	\N	\N	118607	118607	286304
14676	17952	11	applied	\N	\N	\N	\N	118608	118608	286305
14676	17953	12	applied	\N	\N	\N	\N	118609	118609	286306
14676	17954	13	applied	\N	\N	\N	\N	118610	118610	286307
14676	17955	14	applied	\N	\N	\N	\N	118611	118611	286308
14676	17956	15	applied	\N	\N	\N	\N	118612	118612	286309
14676	17957	16	applied	\N	\N	\N	\N	118613	118613	286310
14676	17958	17	applied	\N	\N	\N	\N	118614	118614	286311
14676	17959	18	applied	\N	\N	\N	\N	118615	118615	286312
14676	17960	19	applied	\N	\N	\N	\N	118616	118616	286313
14676	17961	20	applied	\N	\N	\N	\N	118617	118617	286314
14676	17962	21	applied	\N	\N	\N	\N	118618	118618	286315
14676	17963	22	applied	\N	\N	\N	\N	118619	118619	286316
14676	17964	23	applied	\N	\N	\N	\N	118620	118620	286317
14677	17941	0	applied	\N	\N	\N	\N	118621	118621	286318
14677	17943	2	applied	\N	\N	\N	\N	118623	118623	286320
14677	17944	3	applied	\N	\N	\N	\N	118624	118624	286321
14677	17945	4	applied	\N	\N	\N	\N	118625	118625	286322
14677	17946	5	applied	\N	\N	\N	\N	118626	118626	286323
14677	17947	6	applied	\N	\N	\N	\N	118627	118627	286324
14677	17948	7	applied	\N	\N	\N	\N	118628	118628	286325
14677	17949	8	applied	\N	\N	\N	\N	118629	118629	286326
14677	17950	9	applied	\N	\N	\N	\N	118630	118630	286327
14677	17951	10	applied	\N	\N	\N	\N	118631	118631	286328
14677	17952	11	applied	\N	\N	\N	\N	118632	118632	286329
14677	17953	12	applied	\N	\N	\N	\N	118633	118633	286330
14677	17954	13	applied	\N	\N	\N	\N	118634	118634	286331
14677	17955	14	applied	\N	\N	\N	\N	118635	118635	286332
14677	17956	15	applied	\N	\N	\N	\N	118636	118636	286333
14677	17957	16	applied	\N	\N	\N	\N	118637	118637	286334
14677	17958	17	applied	\N	\N	\N	\N	118638	118638	286335
14677	17960	19	applied	\N	\N	\N	\N	118640	118640	286337
14677	17961	20	applied	\N	\N	\N	\N	118641	118641	286338
14677	17962	21	applied	\N	\N	\N	\N	118642	118642	286339
14677	17963	22	applied	\N	\N	\N	\N	118643	118643	286340
14677	17964	23	applied	\N	\N	\N	\N	118644	118644	286341
14681	17981	0	applied	\N	\N	\N	\N	118718	118718	286415
14681	17982	1	applied	\N	\N	\N	\N	118719	118719	286416
14681	17983	2	applied	\N	\N	\N	\N	118720	118720	286417
14681	17984	3	applied	\N	\N	\N	\N	118721	118721	286418
14681	17985	4	applied	\N	\N	\N	\N	118722	118722	286419
14681	17986	5	applied	\N	\N	\N	\N	118723	118723	286420
14681	17987	6	applied	\N	\N	\N	\N	118724	118724	286421
14681	17988	7	applied	\N	\N	\N	\N	118725	118725	286422
14681	17989	8	applied	\N	\N	\N	\N	118726	118726	286423
14681	17990	9	applied	\N	\N	\N	\N	118727	118727	286424
14681	17991	10	applied	\N	\N	\N	\N	118728	118728	286425
14681	17993	12	applied	\N	\N	\N	\N	118730	118730	286427
14681	17994	13	applied	\N	\N	\N	\N	118731	118731	286428
14681	17995	14	applied	\N	\N	\N	\N	118732	118732	286429
14681	17996	15	applied	\N	\N	\N	\N	118733	118733	286430
14681	17997	16	applied	\N	\N	\N	\N	118734	118734	286431
14681	17998	17	applied	\N	\N	\N	\N	118735	118735	286432
14681	17999	18	applied	\N	\N	\N	\N	118736	118736	286433
14681	18000	19	applied	\N	\N	\N	\N	118737	118737	286434
14681	18001	20	applied	\N	\N	\N	\N	118738	118738	286435
14681	18002	21	applied	\N	\N	\N	\N	118739	118739	286436
14681	18003	22	applied	\N	\N	\N	\N	118740	118740	286437
14681	18004	23	applied	\N	\N	\N	\N	118741	118741	286438
14698	18035	0	applied	\N	\N	\N	\N	118865	118865	286562
14698	18036	1	applied	\N	\N	\N	\N	118866	118866	286563
14648	17517	125	applied	\N	\N	\N	\N	118396	118396	286093
14650	17873	0	applied	\N	\N	\N	\N	118403	118403	286100
14671	17936	3	applied	\N	\N	\N	\N	118516	118516	286213
14671	17937	4	applied	\N	\N	\N	\N	118517	118517	286214
14671	17938	5	applied	\N	\N	\N	\N	118518	118518	286215
14671	17939	6	applied	\N	\N	\N	\N	118519	118519	286216
14671	17932	7	applied	\N	\N	\N	\N	118520	118520	286217
14671	17940	8	applied	\N	\N	\N	\N	118521	118521	286218
14674	17941	0	applied	\N	\N	\N	\N	118549	118549	286246
14674	17942	1	applied	\N	\N	\N	\N	118550	118550	286247
14674	17943	2	applied	\N	\N	\N	\N	118551	118551	286248
14674	17944	3	applied	\N	\N	\N	\N	118552	118552	286249
14674	17945	4	applied	\N	\N	\N	\N	118553	118553	286250
14674	17946	5	applied	\N	\N	\N	\N	118554	118554	286251
14674	17947	6	applied	\N	\N	\N	\N	118555	118555	286252
14674	17948	7	applied	\N	\N	\N	\N	118556	118556	286253
14674	17950	9	applied	\N	\N	\N	\N	118558	118558	286255
14674	17951	10	applied	\N	\N	\N	\N	118559	118559	286256
14674	17952	11	applied	\N	\N	\N	\N	118560	118560	286257
14674	17953	12	applied	\N	\N	\N	\N	118561	118561	286258
14674	17954	13	applied	\N	\N	\N	\N	118562	118562	286259
14674	17955	14	applied	\N	\N	\N	\N	118563	118563	286260
14674	17956	15	applied	\N	\N	\N	\N	118564	118564	286261
14674	17957	16	applied	\N	\N	\N	\N	118565	118565	286262
14674	17958	17	applied	\N	\N	\N	\N	118566	118566	286263
14674	17959	18	applied	\N	\N	\N	\N	118567	118567	286264
14674	17960	19	applied	\N	\N	\N	\N	118568	118568	286265
14674	17961	20	applied	\N	\N	\N	\N	118569	118569	286266
14674	17962	21	applied	\N	\N	\N	\N	118570	118570	286267
14674	17963	22	applied	\N	\N	\N	\N	118571	118571	286268
14674	17964	23	applied	\N	\N	\N	\N	118572	118572	286269
14682	17981	0	applied	\N	\N	\N	\N	118742	118742	286439
14682	17983	2	applied	\N	\N	\N	\N	118744	118744	286441
14682	17984	3	applied	\N	\N	\N	\N	118745	118745	286442
14682	17985	4	applied	\N	\N	\N	\N	118746	118746	286443
14682	17986	5	applied	\N	\N	\N	\N	118747	118747	286444
14682	17987	6	applied	\N	\N	\N	\N	118748	118748	286445
14682	17988	7	applied	\N	\N	\N	\N	118749	118749	286446
14682	17989	8	applied	\N	\N	\N	\N	118750	118750	286447
14682	17990	9	applied	\N	\N	\N	\N	118751	118751	286448
14682	17991	10	applied	\N	\N	\N	\N	118752	118752	286449
14682	17992	11	applied	\N	\N	\N	\N	118753	118753	286450
14682	17993	12	applied	\N	\N	\N	\N	118754	118754	286451
14682	17994	13	applied	\N	\N	\N	\N	118755	118755	286452
14682	17995	14	applied	\N	\N	\N	\N	118756	118756	286453
14682	17996	15	applied	\N	\N	\N	\N	118757	118757	286454
14682	17997	16	applied	\N	\N	\N	\N	118758	118758	286455
14682	17998	17	applied	\N	\N	\N	\N	118759	118759	286456
14682	18000	19	applied	\N	\N	\N	\N	118761	118761	286458
14682	18001	20	applied	\N	\N	\N	\N	118762	118762	286459
14682	18002	21	applied	\N	\N	\N	\N	118763	118763	286460
14682	18003	22	applied	\N	\N	\N	\N	118764	118764	286461
14682	18004	23	applied	\N	\N	\N	\N	118765	118765	286462
14685	18005	0	applied	\N	\N	\N	\N	118805	118805	286502
14685	18006	1	applied	\N	\N	\N	\N	118806	118806	286503
14685	18007	2	applied	\N	\N	\N	\N	118807	118807	286504
14685	18008	3	applied	\N	\N	\N	\N	118808	118808	286505
14685	18009	4	applied	\N	\N	\N	\N	118809	118809	286506
14685	18010	5	applied	\N	\N	\N	\N	118810	118810	286507
14685	18011	6	applied	\N	\N	\N	\N	118811	118811	286508
14685	18012	7	applied	\N	\N	\N	\N	118812	118812	286509
14685	18013	8	applied	\N	\N	\N	\N	118813	118813	286510
14687	18014	0	applied	\N	\N	\N	\N	118817	118817	286514
14687	18015	1	applied	\N	\N	\N	\N	118818	118818	286515
14687	18017	3	applied	\N	\N	\N	\N	118820	118820	286517
14687	18018	4	applied	\N	\N	\N	\N	118821	118821	286518
14687	18019	5	applied	\N	\N	\N	\N	118822	118822	286519
14687	18020	6	applied	\N	\N	\N	\N	118823	118823	286520
14689	18021	0	applied	\N	\N	\N	\N	118831	118831	286528
14689	18022	1	applied	\N	\N	\N	\N	118832	118832	286529
14689	18023	2	applied	\N	\N	\N	\N	118833	118833	286530
14689	18024	3	applied	\N	\N	\N	\N	118834	118834	286531
14689	18025	4	applied	\N	\N	\N	\N	118835	118835	286532
14689	18026	5	applied	\N	\N	\N	\N	118836	118836	286533
14694	18029	0	applied	\N	\N	\N	\N	118853	118853	286550
14694	18030	1	applied	\N	\N	\N	\N	118854	118854	286551
14694	18031	2	applied	\N	\N	\N	\N	118855	118855	286552
14694	18032	3	applied	\N	\N	\N	\N	118856	118856	286553
14696	18033	0	applied	\N	\N	\N	\N	118861	118861	286558
14696	18034	1	applied	\N	\N	\N	\N	118862	118862	286559
14699	18036	1	applied	\N	\N	\N	\N	118868	118868	286565
14701	18037	0	applied	\N	\N	\N	\N	118937	118937	286634
14701	18038	1	applied	\N	\N	\N	\N	118938	118938	286635
14701	18039	2	applied	\N	\N	\N	\N	118939	118939	286636
14701	18040	3	applied	\N	\N	\N	\N	118940	118940	286637
14705	18043	0	applied	\N	\N	\N	\N	118951	118951	286648
14705	18044	1	applied	\N	\N	\N	\N	118952	118952	286649
14706	18043	0	applied	\N	\N	\N	\N	118953	118953	286650
14706	18044	1	applied	\N	\N	\N	\N	118954	118954	286651
14708	18045	0	applied	\N	\N	\N	\N	118957	118957	286654
14708	18046	1	applied	\N	\N	\N	\N	118958	118958	286655
14708	18047	2	applied	\N	\N	\N	\N	118959	118959	286656
14708	18048	3	applied	\N	\N	\N	\N	118960	118960	286657
14708	18049	4	applied	\N	\N	\N	\N	118961	118961	286658
14711	17687	1	applied	\N	\N	\N	\N	118975	118975	286672
14711	17887	2	applied	\N	\N	\N	\N	118976	118976	286673
14711	17689	3	applied	\N	\N	\N	\N	118977	118977	286674
14711	17690	4	applied	\N	\N	\N	\N	118978	118978	286675
14711	17693	5	applied	\N	\N	\N	\N	118979	118979	286676
14711	17694	6	applied	\N	\N	\N	\N	118980	118980	286677
14711	17695	7	applied	\N	\N	\N	\N	118981	118981	286678
14711	17696	8	applied	\N	\N	\N	\N	118982	118982	286679
14711	17706	9	applied	\N	\N	\N	\N	118983	118983	286680
14711	17707	10	applied	\N	\N	\N	\N	118984	118984	286681
14711	17708	11	applied	\N	\N	\N	\N	118985	118985	286682
14711	17889	12	applied	\N	\N	\N	\N	118986	118986	286683
14711	17890	13	applied	\N	\N	\N	\N	118987	118987	286684
14711	17891	14	applied	\N	\N	\N	\N	118988	118988	286685
14711	17893	15	applied	\N	\N	\N	\N	118989	118989	286686
14711	17715	16	applied	\N	\N	\N	\N	118990	118990	286687
14711	17718	17	applied	\N	\N	\N	\N	118991	118991	286688
14711	17721	18	applied	\N	\N	\N	\N	118992	118992	286689
14671	17934	1	applied	\N	\N	\N	\N	118514	118514	286211
14671	17935	2	applied	\N	\N	\N	\N	118515	118515	286212
14679	18003	22	applied	\N	\N	\N	\N	118683	118683	286380
14679	18004	23	applied	\N	\N	\N	\N	118684	118684	286381
14683	17887	0	applied	\N	\N	\N	\N	118766	118766	286463
14683	17889	1	applied	\N	\N	\N	\N	118767	118767	286464
14683	17890	2	applied	\N	\N	\N	\N	118768	118768	286465
14683	17891	3	applied	\N	\N	\N	\N	118769	118769	286466
14683	17893	4	applied	\N	\N	\N	\N	118770	118770	286467
14683	17895	5	applied	\N	\N	\N	\N	118771	118771	286468
14683	17896	6	applied	\N	\N	\N	\N	118772	118772	286469
14683	17897	7	applied	\N	\N	\N	\N	118773	118773	286470
14683	17898	8	applied	\N	\N	\N	\N	118774	118774	286471
14683	17899	9	applied	\N	\N	\N	\N	118775	118775	286472
14683	17901	10	applied	\N	\N	\N	\N	118776	118776	286473
14683	17905	11	applied	\N	\N	\N	\N	118777	118777	286474
14683	17906	12	applied	\N	\N	\N	\N	118778	118778	286475
14683	17907	13	applied	\N	\N	\N	\N	118779	118779	286476
14683	17909	15	applied	\N	\N	\N	\N	118781	118781	286478
14683	17910	16	applied	\N	\N	\N	\N	118782	118782	286479
14683	17911	17	applied	\N	\N	\N	\N	118783	118783	286480
14683	17912	18	applied	\N	\N	\N	\N	118784	118784	286481
14683	17913	19	applied	\N	\N	\N	\N	118785	118785	286482
14683	17914	20	applied	\N	\N	\N	\N	118786	118786	286483
14683	17915	21	applied	\N	\N	\N	\N	118787	118787	286484
14683	17916	22	applied	\N	\N	\N	\N	118788	118788	286485
14683	17917	23	applied	\N	\N	\N	\N	118789	118789	286486
14683	17918	24	applied	\N	\N	\N	\N	118790	118790	286487
14683	17919	25	applied	\N	\N	\N	\N	118791	118791	286488
14683	17920	26	applied	\N	\N	\N	\N	118792	118792	286489
14683	17921	27	applied	\N	\N	\N	\N	118793	118793	286490
14683	17925	28	applied	\N	\N	\N	\N	118794	118794	286491
14683	17926	29	applied	\N	\N	\N	\N	118795	118795	286492
14686	18006	0	applied	\N	\N	\N	\N	118814	118814	286511
14686	18013	2	applied	\N	\N	\N	\N	118816	118816	286513
14688	18014	0	applied	\N	\N	\N	\N	118824	118824	286521
14688	18015	1	applied	\N	\N	\N	\N	118825	118825	286522
14688	18016	2	applied	\N	\N	\N	\N	118826	118826	286523
14688	18017	3	applied	\N	\N	\N	\N	118827	118827	286524
14688	18018	4	applied	\N	\N	\N	\N	118828	118828	286525
14688	18019	5	applied	\N	\N	\N	\N	118829	118829	286526
14688	18020	6	applied	\N	\N	\N	\N	118830	118830	286527
14690	18021	0	applied	\N	\N	\N	\N	118837	118837	286534
14690	18022	1	applied	\N	\N	\N	\N	118838	118838	286535
14690	18023	2	applied	\N	\N	\N	\N	118839	118839	286536
14690	18024	3	applied	\N	\N	\N	\N	118840	118840	286537
14690	18025	4	applied	\N	\N	\N	\N	118841	118841	286538
14690	18026	5	applied	\N	\N	\N	\N	118842	118842	286539
14692	18027	0	applied	\N	\N	\N	\N	118849	118849	286546
14692	18028	1	applied	\N	\N	\N	\N	118850	118850	286547
14695	18030	1	applied	\N	\N	\N	\N	118858	118858	286555
14695	18031	2	applied	\N	\N	\N	\N	118859	118859	286556
14695	18032	3	applied	\N	\N	\N	\N	118860	118860	286557
14700	17887	0	applied	\N	\N	\N	\N	118869	118869	286566
14700	17889	1	applied	\N	\N	\N	\N	118870	118870	286567
14700	17890	2	applied	\N	\N	\N	\N	118871	118871	286568
14700	17891	3	applied	\N	\N	\N	\N	118872	118872	286569
14700	17893	4	applied	\N	\N	\N	\N	118873	118873	286570
14700	17895	5	applied	\N	\N	\N	\N	118874	118874	286571
14700	17896	6	applied	\N	\N	\N	\N	118875	118875	286572
14700	17897	7	applied	\N	\N	\N	\N	118876	118876	286573
14700	17898	8	applied	\N	\N	\N	\N	118877	118877	286574
14700	17899	9	applied	\N	\N	\N	\N	118878	118878	286575
14700	17901	10	applied	\N	\N	\N	\N	118879	118879	286576
14700	17905	11	applied	\N	\N	\N	\N	118880	118880	286577
14700	17906	12	applied	\N	\N	\N	\N	118881	118881	286578
14700	17908	14	applied	\N	\N	\N	\N	118883	118883	286580
14700	17909	15	applied	\N	\N	\N	\N	118884	118884	286581
14700	17910	16	applied	\N	\N	\N	\N	118885	118885	286582
14700	17911	17	applied	\N	\N	\N	\N	118886	118886	286583
14700	17912	18	applied	\N	\N	\N	\N	118887	118887	286584
14700	17913	19	applied	\N	\N	\N	\N	118888	118888	286585
14700	17914	20	applied	\N	\N	\N	\N	118889	118889	286586
14700	17915	21	applied	\N	\N	\N	\N	118890	118890	286587
14700	17916	22	applied	\N	\N	\N	\N	118891	118891	286588
14700	17917	23	applied	\N	\N	\N	\N	118892	118892	286589
14700	17918	24	applied	\N	\N	\N	\N	118893	118893	286590
14700	17919	25	applied	\N	\N	\N	\N	118894	118894	286591
14700	17920	26	applied	\N	\N	\N	\N	118895	118895	286592
14700	17921	27	applied	\N	\N	\N	\N	118896	118896	286593
14700	17925	28	applied	\N	\N	\N	\N	118897	118897	286594
14700	17926	29	applied	\N	\N	\N	\N	118898	118898	286595
14700	17929	31	applied	\N	\N	\N	\N	118900	118900	286597
14700	17930	32	applied	\N	\N	\N	\N	118901	118901	286598
14700	17931	33	applied	\N	\N	\N	\N	118902	118902	286599
14700	17934	34	applied	\N	\N	\N	\N	118903	118903	286600
14700	17935	35	applied	\N	\N	\N	\N	118904	118904	286601
14700	17936	36	applied	\N	\N	\N	\N	118905	118905	286602
14700	17937	37	applied	\N	\N	\N	\N	118906	118906	286603
14700	17938	38	applied	\N	\N	\N	\N	118907	118907	286604
14700	17939	39	applied	\N	\N	\N	\N	118908	118908	286605
14700	17944	40	applied	\N	\N	\N	\N	118909	118909	286606
14700	17945	41	applied	\N	\N	\N	\N	118910	118910	286607
14700	17946	42	applied	\N	\N	\N	\N	118911	118911	286608
14700	17947	43	applied	\N	\N	\N	\N	118912	118912	286609
14700	17948	44	applied	\N	\N	\N	\N	118913	118913	286610
14700	17949	45	applied	\N	\N	\N	\N	118914	118914	286611
14700	17950	46	applied	\N	\N	\N	\N	118915	118915	286612
14700	17952	48	applied	\N	\N	\N	\N	118917	118917	286614
14700	17953	49	applied	\N	\N	\N	\N	118918	118918	286615
14700	17954	50	applied	\N	\N	\N	\N	118919	118919	286616
14700	17955	51	applied	\N	\N	\N	\N	118920	118920	286617
14700	17956	52	applied	\N	\N	\N	\N	118921	118921	286618
14700	17957	53	applied	\N	\N	\N	\N	118922	118922	286619
14700	17958	54	applied	\N	\N	\N	\N	118923	118923	286620
14700	17959	55	applied	\N	\N	\N	\N	118924	118924	286621
14700	17960	56	applied	\N	\N	\N	\N	118925	118925	286622
14700	17961	57	applied	\N	\N	\N	\N	118926	118926	286623
14700	17965	58	applied	\N	\N	\N	\N	118927	118927	286624
14700	17967	59	applied	\N	\N	\N	\N	118928	118928	286625
14711	17724	19	applied	\N	\N	\N	\N	118993	118993	286690
14711	17726	20	applied	\N	\N	\N	\N	118994	118994	286691
14679	18000	19	applied	\N	\N	\N	\N	118680	118680	286377
14679	18001	20	applied	\N	\N	\N	\N	118681	118681	286378
14684	18006	1	applied	\N	\N	\N	\N	118797	118797	286494
14684	18007	2	applied	\N	\N	\N	\N	118798	118798	286495
14684	18008	3	applied	\N	\N	\N	\N	118799	118799	286496
14684	18009	4	applied	\N	\N	\N	\N	118800	118800	286497
14684	18010	5	applied	\N	\N	\N	\N	118801	118801	286498
14684	18011	6	applied	\N	\N	\N	\N	118802	118802	286499
14684	18012	7	applied	\N	\N	\N	\N	118803	118803	286500
14684	18013	8	applied	\N	\N	\N	\N	118804	118804	286501
14691	18021	0	applied	\N	\N	\N	\N	118843	118843	286540
14691	18022	1	applied	\N	\N	\N	\N	118844	118844	286541
14691	18023	2	applied	\N	\N	\N	\N	118845	118845	286542
14691	18024	3	applied	\N	\N	\N	\N	118846	118846	286543
14691	18025	4	applied	\N	\N	\N	\N	118847	118847	286544
14691	18026	5	applied	\N	\N	\N	\N	118848	118848	286545
14693	18028	1	applied	\N	\N	\N	\N	118852	118852	286549
14697	18033	0	applied	\N	\N	\N	\N	118863	118863	286560
14697	18034	1	applied	\N	\N	\N	\N	118864	118864	286561
14700	17968	60	applied	\N	\N	\N	\N	118929	118929	286626
14700	17969	61	applied	\N	\N	\N	\N	118930	118930	286627
14703	18037	0	applied	\N	\N	\N	\N	118945	118945	286642
14703	18038	1	applied	\N	\N	\N	\N	118946	118946	286643
14703	18039	2	applied	\N	\N	\N	\N	118947	118947	286644
14703	18040	3	applied	\N	\N	\N	\N	118948	118948	286645
14704	18041	0	applied	\N	\N	\N	\N	118949	118949	286646
14704	18042	1	applied	\N	\N	\N	\N	118950	118950	286647
14707	18043	0	applied	\N	\N	\N	\N	118955	118955	286652
14707	18044	1	applied	\N	\N	\N	\N	118956	118956	286653
14710	18050	0	applied	\N	\N	\N	\N	118968	118968	286665
14710	18051	1	applied	\N	\N	\N	\N	118969	118969	286666
14710	18052	2	applied	\N	\N	\N	\N	118970	118970	286667
14710	18054	4	applied	\N	\N	\N	\N	118972	118972	286669
14710	18055	5	applied	\N	\N	\N	\N	118973	118973	286670
14712	17705	0	applied	\N	\N	1000000000	\N	119099	119099	286796
14712	17887	1	applied	\N	\N	\N	\N	119100	119100	286797
14712	17889	2	applied	\N	\N	\N	\N	119101	119101	286798
14712	17890	3	applied	\N	\N	\N	\N	119102	119102	286799
14712	17891	4	applied	\N	\N	\N	\N	119103	119103	286800
14712	17893	5	applied	\N	\N	\N	\N	119104	119104	286801
14712	17895	6	applied	\N	\N	\N	\N	119105	119105	286802
14712	17896	7	applied	\N	\N	\N	\N	119106	119106	286803
14712	17897	8	applied	\N	\N	\N	\N	119107	119107	286804
14712	17898	9	applied	\N	\N	\N	\N	119108	119108	286805
14712	17899	10	applied	\N	\N	\N	\N	119109	119109	286806
14712	17901	11	applied	\N	\N	\N	\N	119110	119110	286807
14712	17905	12	applied	\N	\N	\N	\N	119111	119111	286808
14712	17906	13	applied	\N	\N	\N	\N	119112	119112	286809
14712	17908	15	applied	\N	\N	\N	\N	119114	119114	286811
14712	17909	16	applied	\N	\N	\N	\N	119115	119115	286812
14712	17910	17	applied	\N	\N	\N	\N	119116	119116	286813
14712	17911	18	applied	\N	\N	\N	\N	119117	119117	286814
14712	17912	19	applied	\N	\N	\N	\N	119118	119118	286815
14712	17913	20	applied	\N	\N	\N	\N	119119	119119	286816
14712	17914	21	applied	\N	\N	\N	\N	119120	119120	286817
14712	17915	22	applied	\N	\N	\N	\N	119121	119121	286818
14712	17916	23	applied	\N	\N	\N	\N	119122	119122	286819
14712	17917	24	applied	\N	\N	\N	\N	119123	119123	286820
14712	17918	25	applied	\N	\N	\N	\N	119124	119124	286821
14712	17919	26	applied	\N	\N	\N	\N	119125	119125	286822
14712	17920	27	applied	\N	\N	\N	\N	119126	119126	286823
14712	17921	28	applied	\N	\N	\N	\N	119127	119127	286824
14712	17925	29	applied	\N	\N	\N	\N	119128	119128	286825
14712	17926	30	applied	\N	\N	\N	\N	119129	119129	286826
14712	17929	32	applied	\N	\N	\N	\N	119131	119131	286828
14712	17930	33	applied	\N	\N	\N	\N	119132	119132	286829
14712	17931	34	applied	\N	\N	\N	\N	119133	119133	286830
14712	17934	35	applied	\N	\N	\N	\N	119134	119134	286831
14718	18068	0	applied	\N	\N	\N	\N	119159	119159	286856
14718	18069	1	applied	\N	\N	\N	\N	119160	119160	286857
14720	18072	0	applied	\N	\N	\N	\N	119163	119163	286860
14720	18073	1	applied	\N	\N	\N	\N	119164	119164	286861
14720	18074	2	applied	\N	\N	\N	\N	119165	119165	286862
14720	18075	3	applied	\N	\N	\N	\N	119166	119166	286863
14723	18077	0	applied	\N	\N	\N	\N	119170	119170	286867
14723	18078	1	applied	\N	\N	\N	\N	119171	119171	286868
14730	18083	0	applied	\N	\N	\N	\N	119190	119190	286887
14730	18084	1	applied	\N	\N	\N	\N	119191	119191	286888
14740	18103	0	applied	\N	\N	\N	\N	119230	119230	286927
14740	18104	1	applied	\N	\N	\N	\N	119231	119231	286928
14746	18112	1	applied	\N	\N	\N	\N	119347	119347	287044
14749	18119	0	applied	\N	\N	\N	\N	119354	119354	287051
14749	18120	1	applied	\N	\N	\N	\N	119355	119355	287052
14754	18127	0	applied	\N	\N	\N	\N	119364	119364	287061
14754	18128	1	applied	\N	\N	\N	\N	119365	119365	287062
14756	18129	0	applied	\N	\N	\N	\N	119368	119368	287065
14756	18130	1	applied	\N	\N	\N	\N	119369	119369	287066
14761	18136	0	applied	\N	\N	\N	\N	119376	119376	287073
14761	18137	1	applied	\N	\N	\N	\N	119377	119377	287074
14769	18148	0	applied	\N	\N	\N	\N	119404	119404	287101
14769	18149	1	applied	\N	\N	\N	\N	119405	119405	287102
14781	18164	0	applied	\N	\N	\N	\N	119428	119428	287125
14781	18165	1	applied	\N	\N	\N	\N	119429	119429	287126
14783	18168	0	applied	\N	\N	\N	\N	119432	119432	287129
14783	18169	1	applied	\N	\N	\N	\N	119433	119433	287130
14786	18174	0	applied	\N	\N	\N	\N	119442	119442	287139
14788	18176	0	applied	\N	\N	\N	\N	119446	119446	287143
14788	18177	1	applied	\N	\N	\N	\N	119447	119447	287144
14791	18184	0	applied	\N	\N	\N	\N	119454	119454	287151
14791	18185	1	applied	\N	\N	\N	\N	119455	119455	287152
14797	18196	0	applied	\N	\N	\N	\N	119469	119469	287166
14797	18197	1	applied	\N	\N	\N	\N	119470	119470	287167
14797	18198	2	applied	\N	\N	\N	\N	119471	119471	287168
14799	18201	0	applied	\N	\N	\N	\N	119474	119474	287171
14799	18202	1	applied	\N	\N	\N	\N	119475	119475	287172
14802	18207	0	applied	\N	\N	\N	\N	119482	119482	287179
14802	18208	1	applied	\N	\N	\N	\N	119483	119483	287180
14802	18209	2	applied	\N	\N	\N	\N	119484	119484	287181
14802	18210	3	applied	\N	\N	\N	\N	119485	119485	287182
14802	18211	4	applied	\N	\N	\N	\N	119486	119486	287183
14807	18214	0	applied	\N	\N	\N	\N	119496	119496	287193
14807	18215	1	applied	\N	\N	\N	\N	119497	119497	287194
14684	18005	0	applied	\N	\N	\N	\N	118796	118796	286493
14700	17973	65	applied	\N	\N	\N	\N	118934	118934	286631
14700	17975	66	applied	\N	\N	\N	\N	118935	118935	286632
14700	17976	67	applied	\N	\N	\N	\N	118936	118936	286633
14702	18037	0	applied	\N	\N	\N	\N	118941	118941	286638
14702	18038	1	applied	\N	\N	\N	\N	118942	118942	286639
14702	18039	2	applied	\N	\N	\N	\N	118943	118943	286640
14702	18040	3	applied	\N	\N	\N	\N	118944	118944	286641
14709	18050	0	applied	\N	\N	\N	\N	118962	118962	286659
14709	18051	1	applied	\N	\N	\N	\N	118963	118963	286660
14709	18053	3	applied	\N	\N	\N	\N	118965	118965	286662
14709	18054	4	applied	\N	\N	\N	\N	118966	118966	286663
14709	18055	5	applied	\N	\N	\N	\N	118967	118967	286664
14715	18056	0	applied	\N	\N	\N	\N	119145	119145	286842
14715	18057	1	applied	\N	\N	\N	\N	119146	119146	286843
14715	18058	2	applied	\N	\N	\N	\N	119147	119147	286844
14715	18059	3	applied	\N	\N	\N	\N	119148	119148	286845
14715	18060	4	applied	\N	\N	\N	\N	119149	119149	286846
14715	18061	5	applied	\N	\N	\N	\N	119150	119150	286847
14715	18062	6	applied	\N	\N	\N	\N	119151	119151	286848
14715	18063	7	applied	\N	\N	\N	\N	119152	119152	286849
14715	18064	8	applied	\N	\N	\N	\N	119153	119153	286850
14715	18065	9	applied	\N	\N	\N	\N	119154	119154	286851
14717	18068	0	applied	\N	\N	\N	\N	119157	119157	286854
14717	18069	1	applied	\N	\N	\N	\N	119158	119158	286855
14719	18070	0	applied	\N	\N	\N	\N	119161	119161	286858
14722	18077	0	applied	\N	\N	\N	\N	119168	119168	286865
14722	18078	1	applied	\N	\N	\N	\N	119169	119169	286866
14727	18079	0	applied	\N	\N	\N	\N	119180	119180	286877
14727	18080	1	applied	\N	\N	\N	\N	119181	119181	286878
14727	18081	2	applied	\N	\N	\N	\N	119182	119182	286879
14727	18082	3	applied	\N	\N	\N	\N	119183	119183	286880
14729	18083	0	applied	\N	\N	\N	\N	119188	119188	286885
14729	18084	1	applied	\N	\N	\N	\N	119189	119189	286886
14733	18085	0	applied	\N	\N	\N	\N	119208	119208	286905
14733	18086	1	applied	\N	\N	\N	\N	119209	119209	286906
14733	18087	2	applied	\N	\N	\N	\N	119210	119210	286907
14733	18088	3	applied	\N	\N	\N	\N	119211	119211	286908
14733	18089	4	applied	\N	\N	\N	\N	119212	119212	286909
14733	18090	5	applied	\N	\N	\N	\N	119213	119213	286910
14733	18091	6	applied	\N	\N	\N	\N	119214	119214	286911
14733	18092	7	applied	\N	\N	\N	\N	119215	119215	286912
14737	18102	1	applied	\N	\N	\N	\N	119225	119225	286922
14743	18105	0	applied	\N	\N	\N	\N	119240	119240	286937
14743	18106	1	applied	\N	\N	\N	\N	119241	119241	286938
14743	18107	2	applied	\N	\N	\N	\N	119242	119242	286939
14743	18108	3	applied	\N	\N	\N	\N	119243	119243	286940
14744	18109	0	applied	\N	\N	\N	\N	119244	119244	286941
14744	18110	1	applied	\N	\N	\N	\N	119245	119245	286942
14748	18117	0	applied	\N	\N	\N	\N	119352	119352	287049
14748	18118	1	applied	\N	\N	\N	\N	119353	119353	287050
14751	18121	0	applied	\N	\N	\N	\N	119358	119358	287055
14751	18122	1	applied	\N	\N	\N	\N	119359	119359	287056
14753	18125	0	applied	\N	\N	\N	\N	119362	119362	287059
14753	18126	1	applied	\N	\N	\N	\N	119363	119363	287060
14764	18138	0	applied	\N	\N	\N	\N	119386	119386	287083
14764	18139	1	applied	\N	\N	\N	\N	119387	119387	287084
14764	18140	2	applied	\N	\N	\N	\N	119388	119388	287085
14764	18142	4	applied	\N	\N	\N	\N	119390	119390	287087
14764	18143	5	applied	\N	\N	\N	\N	119391	119391	287088
14766	18144	0	applied	\N	\N	\N	\N	119396	119396	287093
14766	18145	2	applied	\N	\N	\N	\N	119397	119397	287094
14766	18146	3	applied	\N	\N	\N	\N	119398	119398	287095
14766	18147	4	applied	\N	\N	\N	\N	119399	119399	287096
14771	18154	0	applied	\N	\N	\N	\N	119410	119410	287107
14771	18155	1	applied	\N	\N	\N	\N	119411	119411	287108
14778	18158	0	applied	\N	\N	\N	\N	119420	119420	287117
14778	18159	1	applied	\N	\N	\N	\N	119421	119421	287118
14778	18160	2	applied	\N	\N	\N	\N	119422	119422	287119
14778	18161	3	applied	\N	\N	\N	\N	119423	119423	287120
14778	18162	4	applied	\N	\N	\N	\N	119424	119424	287121
14778	18163	5	applied	\N	\N	\N	\N	119425	119425	287122
14785	18170	0	applied	\N	\N	\N	\N	119438	119438	287135
14785	18171	1	applied	\N	\N	\N	\N	119439	119439	287136
14785	18173	3	applied	\N	\N	\N	\N	119441	119441	287138
14796	18196	0	applied	\N	\N	\N	\N	119466	119466	287163
14796	18197	1	applied	\N	\N	\N	\N	119467	119467	287164
14796	18198	2	applied	\N	\N	\N	\N	119468	119468	287165
14801	18203	0	applied	\N	\N	\N	\N	119478	119478	287175
14801	18204	1	applied	\N	\N	\N	\N	119479	119479	287176
14801	18205	2	applied	\N	\N	\N	\N	119480	119480	287177
14801	18206	3	applied	\N	\N	\N	\N	119481	119481	287178
14804	18212	0	applied	\N	\N	\N	\N	119489	119489	287186
14804	18213	1	applied	\N	\N	\N	\N	119490	119490	287187
14807	18216	2	applied	\N	\N	\N	\N	119498	119498	287195
14809	18217	0	applied	\N	\N	\N	\N	119500	119500	287197
14830	18259	0	applied	\N	\N	\N	\N	119568	119568	287265
14830	18260	1	applied	\N	\N	\N	\N	119569	119569	287266
14830	18261	2	applied	\N	\N	\N	\N	119570	119570	287267
14830	18262	3	applied	\N	\N	\N	\N	119571	119571	287268
14832	18263	1	applied	\N	\N	\N	\N	119631	119631	287328
14835	18264	0	applied	\N	\N	\N	\N	119634	119634	287331
14835	18263	1	applied	\N	\N	\N	\N	119635	119635	287332
14840	18269	0	applied	\N	\N	\N	\N	119656	119656	287353
14840	18270	1	applied	\N	\N	\N	\N	119657	119657	287354
14840	18271	2	applied	\N	\N	\N	\N	119658	119658	287355
14840	18272	3	applied	\N	\N	\N	\N	119659	119659	287356
14840	18273	4	applied	\N	\N	\N	\N	119660	119660	287357
14840	18274	5	applied	\N	\N	\N	\N	119661	119661	287358
14840	18275	6	applied	\N	\N	\N	\N	119662	119662	287359
14840	18276	7	applied	\N	\N	\N	\N	119663	119663	287360
14841	18277	0	applied	\N	\N	\N	\N	119664	119664	287361
14841	18278	1	applied	\N	\N	\N	\N	119665	119665	287362
14844	18280	0	applied	\N	\N	\N	\N	119671	119671	287367
14844	18281	1	applied	\N	\N	\N	\N	119672	119672	287368
14846	17887	0	applied	\N	\N	\N	\N	119675	119675	287371
14846	18209	1	applied	\N	\N	\N	\N	119676	119676	287372
14846	18220	2	applied	\N	\N	\N	\N	119677	119677	287373
14846	18215	3	applied	\N	\N	\N	\N	119678	119678	287374
14846	18197	4	applied	\N	\N	\N	\N	119679	119679	287375
14700	17971	63	applied	\N	\N	\N	\N	118932	118932	286629
14700	17972	64	applied	\N	\N	\N	\N	118933	118933	286630
14711	17895	26	applied	\N	\N	\N	\N	118999	118999	286696
14711	17896	27	applied	\N	\N	\N	\N	119000	119000	286697
14711	17897	28	applied	\N	\N	\N	\N	119001	119001	286698
14711	17898	29	applied	\N	\N	\N	\N	119002	119002	286699
14711	17899	30	applied	\N	\N	\N	\N	119003	119003	286700
14711	17901	31	applied	\N	\N	\N	\N	119004	119004	286701
14711	17905	32	applied	\N	\N	\N	\N	119005	119005	286702
14711	17906	33	applied	\N	\N	\N	\N	119006	119006	286703
14711	17907	34	applied	\N	\N	\N	\N	119007	119007	286704
14711	17908	35	applied	\N	\N	\N	\N	119008	119008	286705
14711	17909	36	applied	\N	\N	\N	\N	119009	119009	286706
14711	17910	37	applied	\N	\N	\N	\N	119010	119010	286707
14711	17911	38	applied	\N	\N	\N	\N	119011	119011	286708
14711	17912	39	applied	\N	\N	\N	\N	119012	119012	286709
14711	17913	40	applied	\N	\N	\N	\N	119013	119013	286710
14711	17914	41	applied	\N	\N	\N	\N	119014	119014	286711
14711	17916	43	applied	\N	\N	\N	\N	119016	119016	286713
14711	17917	44	applied	\N	\N	\N	\N	119017	119017	286714
14711	17918	45	applied	\N	\N	\N	\N	119018	119018	286715
14711	17919	46	applied	\N	\N	\N	\N	119019	119019	286716
14711	17920	47	applied	\N	\N	\N	\N	119020	119020	286717
14711	17921	48	applied	\N	\N	\N	\N	119021	119021	286718
14711	17925	49	applied	\N	\N	\N	\N	119022	119022	286719
14711	17926	50	applied	\N	\N	\N	\N	119023	119023	286720
14711	17927	51	applied	\N	\N	\N	\N	119024	119024	286721
14711	17929	52	applied	\N	\N	\N	\N	119025	119025	286722
14711	17930	53	applied	\N	\N	\N	\N	119026	119026	286723
14711	17931	54	applied	\N	\N	\N	\N	119027	119027	286724
14711	17934	55	applied	\N	\N	\N	\N	119028	119028	286725
14711	17935	56	applied	\N	\N	\N	\N	119029	119029	286726
14711	17936	57	applied	\N	\N	\N	\N	119030	119030	286727
14711	17937	58	applied	\N	\N	\N	\N	119031	119031	286728
14711	17939	60	applied	\N	\N	\N	\N	119033	119033	286730
14711	17944	61	applied	\N	\N	\N	\N	119034	119034	286731
14711	17945	62	applied	\N	\N	\N	\N	119035	119035	286732
14711	17946	63	applied	\N	\N	\N	\N	119036	119036	286733
14711	17947	64	applied	\N	\N	\N	\N	119037	119037	286734
14711	17948	65	applied	\N	\N	\N	\N	119038	119038	286735
14711	17949	66	applied	\N	\N	\N	\N	119039	119039	286736
14711	17950	67	applied	\N	\N	\N	\N	119040	119040	286737
14711	17951	68	applied	\N	\N	\N	\N	119041	119041	286738
14711	17952	69	applied	\N	\N	\N	\N	119042	119042	286739
14711	17953	70	applied	\N	\N	\N	\N	119043	119043	286740
14711	17954	71	applied	\N	\N	\N	\N	119044	119044	286741
14711	17955	72	applied	\N	\N	\N	\N	119045	119045	286742
14711	17956	73	applied	\N	\N	\N	\N	119046	119046	286743
14711	17957	74	applied	\N	\N	\N	\N	119047	119047	286744
14711	17958	75	applied	\N	\N	\N	\N	119048	119048	286745
14711	17960	77	applied	\N	\N	\N	\N	119050	119050	286747
14711	17961	78	applied	\N	\N	\N	\N	119051	119051	286748
14711	17965	79	applied	\N	\N	\N	\N	119052	119052	286749
14711	17967	80	applied	\N	\N	\N	\N	119053	119053	286750
14711	17968	81	applied	\N	\N	\N	\N	119054	119054	286751
14711	17969	82	applied	\N	\N	\N	\N	119055	119055	286752
14711	17970	83	applied	\N	\N	\N	\N	119056	119056	286753
14711	17971	84	applied	\N	\N	\N	\N	119057	119057	286754
14711	17972	85	applied	\N	\N	\N	\N	119058	119058	286755
14711	17973	86	applied	\N	\N	\N	\N	119059	119059	286756
14711	17975	87	applied	\N	\N	\N	\N	119060	119060	286757
14711	17976	88	applied	\N	\N	\N	\N	119061	119061	286758
14711	17977	89	applied	\N	\N	\N	\N	119062	119062	286759
14711	17978	90	applied	\N	\N	\N	\N	119063	119063	286760
14711	17984	91	applied	\N	\N	\N	\N	119064	119064	286761
14711	17985	92	applied	\N	\N	\N	\N	119065	119065	286762
14711	17987	94	applied	\N	\N	\N	\N	119067	119067	286764
14711	17988	95	applied	\N	\N	\N	\N	119068	119068	286765
14711	17989	96	applied	\N	\N	\N	\N	119069	119069	286766
14711	17990	97	applied	\N	\N	\N	\N	119070	119070	286767
14711	17991	98	applied	\N	\N	\N	\N	119071	119071	286768
14711	17992	99	applied	\N	\N	\N	\N	119072	119072	286769
14711	17993	100	applied	\N	\N	\N	\N	119073	119073	286770
14711	17994	101	applied	\N	\N	\N	\N	119074	119074	286771
14711	17995	102	applied	\N	\N	\N	\N	119075	119075	286772
14711	17996	103	applied	\N	\N	\N	\N	119076	119076	286773
14711	17997	104	applied	\N	\N	\N	\N	119077	119077	286774
14711	17998	105	applied	\N	\N	\N	\N	119078	119078	286775
14711	17999	106	applied	\N	\N	\N	\N	119079	119079	286776
14711	18000	107	applied	\N	\N	\N	\N	119080	119080	286777
14711	18001	108	applied	\N	\N	\N	\N	119081	119081	286778
14711	18005	109	applied	\N	\N	\N	\N	119082	119082	286779
14711	18008	111	applied	\N	\N	\N	\N	119084	119084	286781
14711	18009	112	applied	\N	\N	\N	\N	119085	119085	286782
14711	18010	113	applied	\N	\N	\N	\N	119086	119086	286783
14711	18011	114	applied	\N	\N	\N	\N	119087	119087	286784
14711	18015	115	applied	\N	\N	\N	\N	119088	119088	286785
14711	18016	116	applied	\N	\N	\N	\N	119089	119089	286786
14711	18017	117	applied	\N	\N	\N	\N	119090	119090	286787
14711	18018	118	applied	\N	\N	\N	\N	119091	119091	286788
14711	18019	119	applied	\N	\N	\N	\N	119092	119092	286789
14711	18022	120	applied	\N	\N	\N	\N	119093	119093	286790
14711	18023	121	applied	\N	\N	\N	\N	119094	119094	286791
14711	18024	122	applied	\N	\N	\N	\N	119095	119095	286792
14711	18025	123	applied	\N	\N	\N	\N	119096	119096	286793
14711	17735	124	applied	\N	\N	\N	\N	119097	119097	286794
14711	17739	125	applied	\N	\N	\N	\N	119098	119098	286795
14714	18056	0	applied	\N	\N	\N	\N	119135	119135	286832
14714	18058	2	applied	\N	\N	\N	\N	119137	119137	286834
14714	18059	3	applied	\N	\N	\N	\N	119138	119138	286835
14714	18060	4	applied	\N	\N	\N	\N	119139	119139	286836
14714	18061	5	applied	\N	\N	\N	\N	119140	119140	286837
14714	18062	6	applied	\N	\N	\N	\N	119141	119141	286838
14714	18063	7	applied	\N	\N	\N	\N	119142	119142	286839
14714	18064	8	applied	\N	\N	\N	\N	119143	119143	286840
14714	18065	9	applied	\N	\N	\N	\N	119144	119144	286841
14716	18066	0	applied	\N	\N	\N	\N	119155	119155	286852
14716	18067	1	applied	\N	\N	\N	\N	119156	119156	286853
14725	18077	0	applied	\N	\N	\N	\N	119174	119174	286871
14725	18078	1	applied	\N	\N	\N	\N	119175	119175	286872
14846	17889	5	applied	\N	\N	\N	\N	119680	119680	287376
14846	17890	6	applied	\N	\N	\N	\N	119681	119681	287377
14711	17729	22	applied	\N	\N	\N	\N	118996	118996	286693
14711	17733	24	applied	\N	\N	\N	\N	118997	118997	286694
14726	18080	1	applied	\N	\N	\N	\N	119177	119177	286874
14728	18079	0	applied	\N	\N	\N	\N	119184	119184	286881
14728	18080	1	applied	\N	\N	\N	\N	119185	119185	286882
14728	18081	2	applied	\N	\N	\N	\N	119186	119186	286883
14728	18082	3	applied	\N	\N	\N	\N	119187	119187	286884
14731	18085	0	applied	\N	\N	\N	\N	119192	119192	286889
14731	18086	1	applied	\N	\N	\N	\N	119193	119193	286890
14731	18087	2	applied	\N	\N	\N	\N	119194	119194	286891
14731	18088	3	applied	\N	\N	\N	\N	119195	119195	286892
14731	18089	4	applied	\N	\N	\N	\N	119196	119196	286893
14731	18090	5	applied	\N	\N	\N	\N	119197	119197	286894
14731	18091	6	applied	\N	\N	\N	\N	119198	119198	286895
14731	18092	7	applied	\N	\N	\N	\N	119199	119199	286896
14736	18093	0	applied	\N	\N	\N	\N	119216	119216	286913
14736	18094	1	applied	\N	\N	\N	\N	119217	119217	286914
14736	18095	2	applied	\N	\N	\N	\N	119218	119218	286915
14736	18097	4	applied	\N	\N	\N	\N	119220	119220	286917
14736	18098	5	applied	\N	\N	\N	\N	119221	119221	286918
14736	18099	6	applied	\N	\N	\N	\N	119222	119222	286919
14736	18100	7	applied	\N	\N	\N	\N	119223	119223	286920
14738	18101	0	applied	\N	\N	\N	\N	119226	119226	286923
14738	18102	1	applied	\N	\N	\N	\N	119227	119227	286924
14741	18105	0	applied	\N	\N	\N	\N	119232	119232	286929
14741	18106	1	applied	\N	\N	\N	\N	119233	119233	286930
14741	18107	2	applied	\N	\N	\N	\N	119234	119234	286931
14741	18108	3	applied	\N	\N	\N	\N	119235	119235	286932
14747	18113	0	applied	\N	\N	\N	\N	119348	119348	287045
14747	18114	1	applied	\N	\N	\N	\N	119349	119349	287046
14747	18115	2	applied	\N	\N	\N	\N	119350	119350	287047
14747	18116	3	applied	\N	\N	\N	\N	119351	119351	287048
14752	18123	0	applied	\N	\N	\N	\N	119360	119360	287057
14752	18124	1	applied	\N	\N	\N	\N	119361	119361	287058
14759	18132	0	applied	\N	\N	\N	\N	119372	119372	287069
14759	18133	1	applied	\N	\N	\N	\N	119373	119373	287070
14762	18136	0	applied	\N	\N	\N	\N	119378	119378	287075
14762	18137	1	applied	\N	\N	\N	\N	119379	119379	287076
14765	18144	0	applied	\N	\N	\N	\N	119392	119392	287089
14765	18145	2	applied	\N	\N	\N	\N	119393	119393	287090
14765	18146	3	applied	\N	\N	\N	\N	119394	119394	287091
14765	18147	4	applied	\N	\N	\N	\N	119395	119395	287092
14767	18148	0	applied	\N	\N	\N	\N	119400	119400	287097
14767	18149	1	applied	\N	\N	\N	\N	119401	119401	287098
14772	18156	0	applied	\N	\N	\N	\N	119412	119412	287109
14772	18157	1	applied	\N	\N	\N	\N	119413	119413	287110
14777	18158	0	applied	\N	\N	\N	\N	119414	119414	287111
14777	18159	1	applied	\N	\N	\N	\N	119415	119415	287112
14777	18160	2	applied	\N	\N	\N	\N	119416	119416	287113
14777	18161	3	applied	\N	\N	\N	\N	119417	119417	287114
14777	18163	5	applied	\N	\N	\N	\N	119419	119419	287116
14779	18164	0	applied	\N	\N	\N	\N	119426	119426	287123
14779	18165	1	applied	\N	\N	\N	\N	119427	119427	287124
14784	18170	0	applied	\N	\N	\N	\N	119434	119434	287131
14784	18171	1	applied	\N	\N	\N	\N	119435	119435	287132
14784	18172	2	applied	\N	\N	\N	\N	119436	119436	287133
14784	18173	3	applied	\N	\N	\N	\N	119437	119437	287134
14787	18174	0	applied	\N	\N	\N	\N	119444	119444	287141
14787	18175	1	applied	\N	\N	\N	\N	119445	119445	287142
14789	18178	0	applied	\N	\N	\N	\N	119448	119448	287145
14789	18179	1	applied	\N	\N	\N	\N	119449	119449	287146
14789	18180	2	applied	\N	\N	\N	\N	119450	119450	287147
14789	18181	3	applied	\N	\N	\N	\N	119451	119451	287148
14792	18186	0	applied	\N	\N	\N	\N	119456	119456	287153
14792	18187	1	applied	\N	\N	\N	\N	119457	119457	287154
14795	18194	0	applied	\N	\N	\N	\N	119464	119464	287161
14803	18212	0	applied	\N	\N	\N	\N	119487	119487	287184
14803	18213	1	applied	\N	\N	\N	\N	119488	119488	287185
14805	18214	0	applied	\N	\N	\N	\N	119491	119491	287188
14805	18215	1	applied	\N	\N	\N	\N	119492	119492	287189
14805	18216	2	applied	\N	\N	\N	\N	119493	119493	287190
14808	18215	0	applied	\N	\N	\N	\N	119499	119499	287196
14813	18220	0	applied	\N	\N	\N	\N	119514	119514	287211
14813	18221	1	applied	\N	\N	\N	\N	119515	119515	287212
14813	18222	2	applied	\N	\N	\N	\N	119516	119516	287213
14813	18223	3	applied	\N	\N	\N	\N	119517	119517	287214
14813	18224	4	applied	\N	\N	\N	\N	119518	119518	287215
14813	18225	5	applied	\N	\N	\N	\N	119519	119519	287216
14813	18226	6	applied	\N	\N	\N	\N	119520	119520	287217
14813	18227	7	applied	\N	\N	\N	\N	119521	119521	287218
14813	18228	8	applied	\N	\N	\N	\N	119522	119522	287219
14815	18231	0	applied	\N	\N	\N	\N	119525	119525	287222
14818	18237	0	applied	\N	\N	\N	\N	119531	119531	287228
14818	18238	1	applied	\N	\N	\N	\N	119532	119532	287229
14818	18239	2	applied	\N	\N	\N	\N	119533	119533	287230
14818	18240	3	applied	\N	\N	\N	\N	119534	119534	287231
14821	18243	0	applied	\N	\N	\N	\N	119539	119539	287236
14821	18244	1	applied	\N	\N	\N	\N	119540	119540	287237
14823	18246	0	applied	\N	\N	\N	\N	119543	119543	287240
14826	18251	0	applied	\N	\N	\N	\N	119552	119552	287249
14826	18252	1	applied	\N	\N	\N	\N	119553	119553	287250
14826	18253	2	applied	\N	\N	\N	\N	119554	119554	287251
14826	18254	3	applied	\N	\N	\N	\N	119555	119555	287252
14826	18255	4	applied	\N	\N	\N	\N	119556	119556	287253
14826	18256	5	applied	\N	\N	\N	\N	119557	119557	287254
14829	18259	0	applied	\N	\N	\N	\N	119564	119564	287261
14829	18260	1	applied	\N	\N	\N	\N	119565	119565	287262
14829	18261	2	applied	\N	\N	\N	\N	119566	119566	287263
14831	18209	0	applied	\N	\N	\N	\N	119572	119572	287269
14831	18220	1	applied	\N	\N	\N	\N	119573	119573	287270
14831	18215	2	applied	\N	\N	\N	\N	119574	119574	287271
14831	18197	3	applied	\N	\N	\N	\N	119575	119575	287272
14831	18155	4	applied	\N	\N	\N	\N	119576	119576	287273
14831	18157	5	applied	\N	\N	\N	\N	119577	119577	287274
14831	18161	6	applied	\N	\N	\N	\N	119578	119578	287275
14831	18162	7	applied	\N	\N	\N	\N	119579	119579	287276
14831	18218	8	applied	\N	\N	\N	\N	119580	119580	287277
14831	18163	9	applied	\N	\N	\N	\N	119581	119581	287278
14831	18165	10	applied	\N	\N	\N	\N	119582	119582	287279
14831	18167	11	applied	\N	\N	\N	\N	119583	119583	287280
14831	18169	12	applied	\N	\N	\N	\N	119584	119584	287281
14831	18172	13	applied	\N	\N	\N	\N	119585	119585	287282
14724	18077	0	applied	\N	\N	\N	\N	119172	119172	286869
14724	18078	1	applied	\N	\N	\N	\N	119173	119173	286870
14732	18087	2	applied	\N	\N	\N	\N	119202	119202	286899
14732	18088	3	applied	\N	\N	\N	\N	119203	119203	286900
14732	18089	4	applied	\N	\N	\N	\N	119204	119204	286901
14732	18090	5	applied	\N	\N	\N	\N	119205	119205	286902
14732	18091	6	applied	\N	\N	\N	\N	119206	119206	286903
14732	18092	7	applied	\N	\N	\N	\N	119207	119207	286904
14739	18103	0	applied	\N	\N	\N	\N	119228	119228	286925
14739	18104	1	applied	\N	\N	\N	\N	119229	119229	286926
14742	18105	0	applied	\N	\N	\N	\N	119236	119236	286933
14742	18106	1	applied	\N	\N	\N	\N	119237	119237	286934
14742	18107	2	applied	\N	\N	\N	\N	119238	119238	286935
14742	18108	3	applied	\N	\N	\N	\N	119239	119239	286936
14745	17887	1	applied	\N	\N	\N	\N	119247	119247	286944
14745	17889	2	applied	\N	\N	\N	\N	119248	119248	286945
14745	17890	3	applied	\N	\N	\N	\N	119249	119249	286946
14745	17891	4	applied	\N	\N	\N	\N	119250	119250	286947
14745	17893	5	applied	\N	\N	\N	\N	119251	119251	286948
14745	17895	6	applied	\N	\N	\N	\N	119252	119252	286949
14745	17896	7	applied	\N	\N	\N	\N	119253	119253	286950
14745	17897	8	applied	\N	\N	\N	\N	119254	119254	286951
14745	17898	9	applied	\N	\N	\N	\N	119255	119255	286952
14745	17899	10	applied	\N	\N	\N	\N	119256	119256	286953
14745	17901	11	applied	\N	\N	\N	\N	119257	119257	286954
14745	17905	12	applied	\N	\N	\N	\N	119258	119258	286955
14745	17906	13	applied	\N	\N	\N	\N	119259	119259	286956
14745	17907	14	applied	\N	\N	\N	\N	119260	119260	286957
14745	17908	15	applied	\N	\N	\N	\N	119261	119261	286958
14745	17909	16	applied	\N	\N	\N	\N	119262	119262	286959
14745	17910	17	applied	\N	\N	\N	\N	119263	119263	286960
14745	17911	18	applied	\N	\N	\N	\N	119264	119264	286961
14745	17912	19	applied	\N	\N	\N	\N	119265	119265	286962
14745	17913	20	applied	\N	\N	\N	\N	119266	119266	286963
14745	17915	22	applied	\N	\N	\N	\N	119268	119268	286965
14745	17916	23	applied	\N	\N	\N	\N	119269	119269	286966
14745	17917	24	applied	\N	\N	\N	\N	119270	119270	286967
14745	17918	25	applied	\N	\N	\N	\N	119271	119271	286968
14745	17919	26	applied	\N	\N	\N	\N	119272	119272	286969
14745	17920	27	applied	\N	\N	\N	\N	119273	119273	286970
14745	17921	28	applied	\N	\N	\N	\N	119274	119274	286971
14745	17925	29	applied	\N	\N	\N	\N	119275	119275	286972
14745	17926	30	applied	\N	\N	\N	\N	119276	119276	286973
14745	17927	31	applied	\N	\N	\N	\N	119277	119277	286974
14745	17929	32	applied	\N	\N	\N	\N	119278	119278	286975
14745	17930	33	applied	\N	\N	\N	\N	119279	119279	286976
14745	17931	34	applied	\N	\N	\N	\N	119280	119280	286977
14745	17934	35	applied	\N	\N	\N	\N	119281	119281	286978
14745	17935	36	applied	\N	\N	\N	\N	119282	119282	286979
14745	17936	37	applied	\N	\N	\N	\N	119283	119283	286980
14745	17938	39	applied	\N	\N	\N	\N	119285	119285	286982
14745	17939	40	applied	\N	\N	\N	\N	119286	119286	286983
14745	17944	41	applied	\N	\N	\N	\N	119287	119287	286984
14745	17945	42	applied	\N	\N	\N	\N	119288	119288	286985
14745	17946	43	applied	\N	\N	\N	\N	119289	119289	286986
14745	17947	44	applied	\N	\N	\N	\N	119290	119290	286987
14745	17948	46	applied	\N	\N	\N	\N	119291	119291	286988
14745	17949	47	applied	\N	\N	\N	\N	119292	119292	286989
14745	17950	48	applied	\N	\N	\N	\N	119293	119293	286990
14745	17951	49	applied	\N	\N	\N	\N	119294	119294	286991
14745	17952	50	applied	\N	\N	\N	\N	119295	119295	286992
14745	17953	51	applied	\N	\N	\N	\N	119296	119296	286993
14745	17954	52	applied	\N	\N	\N	\N	119297	119297	286994
14745	17955	53	applied	\N	\N	\N	\N	119298	119298	286995
14745	17956	54	applied	\N	\N	\N	\N	119299	119299	286996
14745	17957	55	applied	\N	\N	\N	\N	119300	119300	286997
14745	17959	57	applied	\N	\N	\N	\N	119302	119302	286999
14745	17960	58	applied	\N	\N	\N	\N	119303	119303	287000
14745	17961	59	applied	\N	\N	\N	\N	119304	119304	287001
14745	17965	60	applied	\N	\N	\N	\N	119305	119305	287002
14745	17967	61	applied	\N	\N	\N	\N	119306	119306	287003
14745	17968	62	applied	\N	\N	\N	\N	119307	119307	287004
14745	17969	63	applied	\N	\N	\N	\N	119308	119308	287005
14745	17970	64	applied	\N	\N	\N	\N	119309	119309	287006
14745	17971	65	applied	\N	\N	\N	\N	119310	119310	287007
14745	17972	66	applied	\N	\N	\N	\N	119311	119311	287008
14745	17973	67	applied	\N	\N	\N	\N	119312	119312	287009
14745	17975	68	applied	\N	\N	\N	\N	119313	119313	287010
14745	17976	69	applied	\N	\N	\N	\N	119314	119314	287011
14745	17977	70	applied	\N	\N	\N	\N	119315	119315	287012
14745	17978	71	applied	\N	\N	\N	\N	119316	119316	287013
14745	17984	72	applied	\N	\N	\N	\N	119317	119317	287014
14745	17986	74	applied	\N	\N	\N	\N	119319	119319	287016
14745	17987	75	applied	\N	\N	\N	\N	119320	119320	287017
14745	17988	76	applied	\N	\N	\N	\N	119321	119321	287018
14745	17989	77	applied	\N	\N	\N	\N	119322	119322	287019
14745	17990	78	applied	\N	\N	\N	\N	119323	119323	287020
14745	17991	79	applied	\N	\N	\N	\N	119324	119324	287021
14745	17992	80	applied	\N	\N	\N	\N	119325	119325	287022
14745	17993	81	applied	\N	\N	\N	\N	119326	119326	287023
14745	17994	82	applied	\N	\N	\N	\N	119327	119327	287024
14745	17995	83	applied	\N	\N	\N	\N	119328	119328	287025
14745	17996	84	applied	\N	\N	\N	\N	119329	119329	287026
14745	17997	85	applied	\N	\N	\N	\N	119330	119330	287027
14745	17998	86	applied	\N	\N	\N	\N	119331	119331	287028
14745	17999	87	applied	\N	\N	\N	\N	119332	119332	287029
14745	18000	88	applied	\N	\N	\N	\N	119333	119333	287030
14745	18001	89	applied	\N	\N	\N	\N	119334	119334	287031
14745	18007	91	applied	\N	\N	\N	\N	119336	119336	287033
14745	18008	92	applied	\N	\N	\N	\N	119337	119337	287034
14745	18009	93	applied	\N	\N	\N	\N	119338	119338	287035
14745	18010	94	applied	\N	\N	\N	\N	119339	119339	287036
14745	18011	95	applied	\N	\N	\N	\N	119340	119340	287037
14745	18015	96	applied	\N	\N	\N	\N	119341	119341	287038
14745	18016	97	applied	\N	\N	\N	\N	119342	119342	287039
14745	18017	98	applied	\N	\N	\N	\N	119343	119343	287040
14745	18018	99	applied	\N	\N	\N	\N	119344	119344	287041
14745	18019	100	applied	\N	\N	\N	\N	119345	119345	287042
14750	18121	0	applied	\N	\N	\N	\N	119356	119356	287053
14750	18122	1	applied	\N	\N	\N	\N	119357	119357	287054
14831	18173	14	applied	\N	\N	\N	\N	119586	119586	287283
14831	18175	15	applied	\N	\N	\N	\N	119587	119587	287284
14732	18085	0	applied	\N	\N	\N	\N	119200	119200	286897
14732	18086	1	applied	\N	\N	\N	\N	119201	119201	286898
14760	18134	0	applied	\N	\N	\N	\N	119374	119374	287071
14760	18135	1	applied	\N	\N	\N	\N	119375	119375	287072
14763	18138	0	applied	\N	\N	\N	\N	119380	119380	287077
14763	18139	1	applied	\N	\N	\N	\N	119381	119381	287078
14763	18140	2	applied	\N	\N	\N	\N	119382	119382	287079
14763	18141	3	applied	\N	\N	\N	\N	119383	119383	287080
14763	18142	4	applied	\N	\N	\N	\N	119384	119384	287081
14763	18143	5	applied	\N	\N	\N	\N	119385	119385	287082
14768	18148	0	applied	\N	\N	\N	\N	119402	119402	287099
14768	18149	1	applied	\N	\N	\N	\N	119403	119403	287100
14770	18150	0	applied	\N	\N	\N	\N	119406	119406	287103
14770	18152	2	applied	\N	\N	\N	\N	119408	119408	287105
14770	18153	3	applied	\N	\N	\N	\N	119409	119409	287106
14782	18166	0	applied	\N	\N	\N	\N	119430	119430	287127
14782	18167	1	applied	\N	\N	\N	\N	119431	119431	287128
14790	18182	0	applied	\N	\N	\N	\N	119452	119452	287149
14790	18183	1	applied	\N	\N	\N	\N	119453	119453	287150
14793	18188	0	applied	\N	\N	\N	\N	119458	119458	287155
14793	18189	1	applied	\N	\N	\N	\N	119459	119459	287156
14793	18190	2	applied	\N	\N	\N	\N	119460	119460	287157
14793	18191	3	applied	\N	\N	\N	\N	119461	119461	287158
14793	18192	4	applied	\N	\N	\N	\N	119462	119462	287159
14793	18193	5	applied	\N	\N	\N	\N	119463	119463	287160
14798	18199	0	applied	\N	\N	\N	\N	119472	119472	287169
14798	18200	1	applied	\N	\N	\N	\N	119473	119473	287170
14800	18201	0	applied	\N	\N	\N	\N	119476	119476	287173
14800	18202	1	applied	\N	\N	\N	\N	119477	119477	287174
14806	18215	1	applied	\N	\N	\N	\N	119495	119495	287192
14811	18220	0	applied	\N	\N	\N	\N	119503	119503	287200
14811	18221	1	applied	\N	\N	\N	\N	119504	119504	287201
14817	18235	0	applied	\N	\N	\N	\N	119529	119529	287226
14817	18236	1	applied	\N	\N	\N	\N	119530	119530	287227
14820	18243	0	applied	\N	\N	\N	\N	119537	119537	287234
14820	18244	1	applied	\N	\N	\N	\N	119538	119538	287235
14822	18245	0	applied	\N	\N	\N	\N	119541	119541	287238
14822	18246	1	applied	\N	\N	\N	\N	119542	119542	287239
14825	18247	0	applied	\N	\N	\N	\N	119548	119548	287245
14825	18248	1	applied	\N	\N	\N	\N	119549	119549	287246
14825	18249	2	applied	\N	\N	\N	\N	119550	119550	287247
14825	18250	3	applied	\N	\N	\N	\N	119551	119551	287248
14828	18259	0	applied	\N	\N	\N	\N	119560	119560	287257
14828	18260	1	applied	\N	\N	\N	\N	119561	119561	287258
14828	18261	2	applied	\N	\N	\N	\N	119562	119562	287259
14833	18264	0	applied	\N	\N	\N	\N	119632	119632	287329
14833	18263	1	applied	\N	\N	\N	\N	119633	119633	287330
14837	18267	0	applied	\N	\N	\N	\N	119638	119638	287335
14837	18268	1	applied	\N	\N	\N	\N	119639	119639	287336
14838	18269	0	applied	\N	\N	\N	\N	119640	119640	287337
14838	18270	1	applied	\N	\N	\N	\N	119641	119641	287338
14838	18271	2	applied	\N	\N	\N	\N	119642	119642	287339
14838	18272	3	applied	\N	\N	\N	\N	119643	119643	287340
14838	18273	4	applied	\N	\N	\N	\N	119644	119644	287341
14838	18274	5	applied	\N	\N	\N	\N	119645	119645	287342
14838	18275	6	applied	\N	\N	\N	\N	119646	119646	287343
14838	18276	7	applied	\N	\N	\N	\N	119647	119647	287344
14843	18280	0	applied	\N	\N	\N	\N	119669	119669	287365
14843	18281	1	applied	\N	\N	\N	\N	119670	119670	287366
14856	18296	0	applied	\N	\N	\N	\N	119789	119789	287485
14856	18297	1	applied	\N	\N	\N	\N	119790	119790	287486
14863	18304	0	applied	\N	\N	\N	\N	119816	119816	287512
14863	18301	1	applied	\N	\N	\N	\N	119817	119817	287513
14863	18302	2	applied	\N	\N	\N	\N	119818	119818	287514
14863	18303	3	applied	\N	\N	\N	\N	119819	119819	287515
14863	18305	4	applied	\N	\N	\N	\N	119820	119820	287516
14867	18310	0	applied	\N	\N	\N	\N	119827	119827	287523
14867	18311	1	applied	\N	\N	\N	\N	119828	119828	287524
14872	18312	0	applied	\N	\N	1000000000	\N	119847	119847	287543
14872	18313	1	applied	\N	\N	\N	\N	119848	119848	287544
14872	18314	2	applied	\N	\N	\N	\N	119849	119849	287545
14872	18315	3	applied	\N	\N	\N	\N	119850	119850	287546
14872	18316	4	applied	\N	\N	\N	\N	119851	119851	287547
14872	18317	5	applied	\N	\N	\N	\N	119852	119852	287548
14872	18318	6	applied	\N	\N	\N	\N	119853	119853	287549
14875	18319	0	applied	\N	\N	\N	\N	119858	119858	287554
14875	18320	1	applied	\N	\N	\N	\N	119859	119859	287555
14879	18333	1	applied	\N	\N	\N	\N	119874	119874	287570
14879	18334	2	applied	\N	\N	\N	\N	119875	119875	287571
14882	18335	0	applied	\N	\N	1000000000	\N	119894	119894	287590
14882	18336	1	applied	\N	\N	1000000000	\N	119895	119895	287591
14882	18337	2	applied	\N	\N	\N	\N	119896	119896	287592
14882	18338	3	applied	\N	\N	\N	\N	119897	119897	287593
14882	18339	4	applied	\N	\N	\N	\N	119898	119898	287594
14882	18340	5	applied	\N	\N	\N	\N	119899	119899	287595
14882	18341	6	applied	\N	\N	\N	\N	119900	119900	287596
14882	18342	7	applied	\N	\N	\N	\N	119901	119901	287597
14882	18343	8	applied	\N	\N	\N	\N	119902	119902	287598
14884	18349	0	applied	\N	\N	\N	\N	119908	119908	287604
14884	18350	1	applied	\N	\N	\N	\N	119909	119909	287605
14884	18351	2	applied	\N	\N	\N	\N	119910	119910	287606
14888	18376	0	applied	\N	\N	\N	\N	119938	119938	287634
14888	18377	1	applied	\N	\N	\N	\N	119939	119939	287635
14888	18379	3	applied	\N	\N	\N	\N	119941	119941	287637
14893	18388	0	applied	\N	\N	\N	\N	119962	119962	287658
14893	18395	8	applied	\N	\N	\N	\N	119969	119969	287665
14899	18396	0	applied	\N	\N	\N	\N	119994	119994	287690
14899	18397	1	applied	\N	\N	\N	\N	119995	119995	287691
14899	18398	2	applied	\N	\N	\N	\N	119996	119996	287692
14899	18399	3	applied	\N	\N	\N	\N	119997	119997	287693
14910	18418	0	applied	\N	\N	\N	\N	120032	120032	287728
14910	18419	1	applied	\N	\N	\N	\N	120033	120033	287729
14919	18442	0	applied	\N	\N	\N	\N	120072	120072	287768
14919	18443	1	applied	\N	\N	\N	\N	120073	120073	287769
14755	18128	1	applied	\N	\N	\N	\N	119367	119367	287064
14758	18131	0	applied	\N	\N	\N	\N	119371	119371	287068
14812	18221	1	applied	\N	\N	\N	\N	119506	119506	287203
14812	18222	2	applied	\N	\N	\N	\N	119507	119507	287204
14812	18223	3	applied	\N	\N	\N	\N	119508	119508	287205
14812	18224	4	applied	\N	\N	\N	\N	119509	119509	287206
14812	18225	5	applied	\N	\N	\N	\N	119510	119510	287207
14812	18226	6	applied	\N	\N	\N	\N	119511	119511	287208
14812	18227	7	applied	\N	\N	\N	\N	119512	119512	287209
14812	18228	8	applied	\N	\N	\N	\N	119513	119513	287210
14814	18229	0	applied	\N	\N	\N	\N	119523	119523	287220
14814	18230	1	applied	\N	\N	\N	\N	119524	119524	287221
14816	18233	0	applied	\N	\N	\N	\N	119527	119527	287224
14816	18234	1	applied	\N	\N	\N	\N	119528	119528	287225
14819	18241	0	applied	\N	\N	\N	\N	119535	119535	287232
14824	18247	0	applied	\N	\N	\N	\N	119544	119544	287241
14824	18248	1	applied	\N	\N	\N	\N	119545	119545	287242
14824	18249	2	applied	\N	\N	\N	\N	119546	119546	287243
14824	18250	3	applied	\N	\N	\N	\N	119547	119547	287244
14827	18257	0	applied	\N	\N	\N	\N	119558	119558	287255
14827	18258	1	applied	\N	\N	\N	\N	119559	119559	287256
14836	18265	0	applied	\N	\N	\N	\N	119636	119636	287333
14836	18266	1	applied	\N	\N	\N	\N	119637	119637	287334
14842	18280	0	applied	\N	\N	\N	\N	119667	119667	287363
14842	18281	1	applied	\N	\N	\N	\N	119668	119668	287364
14847	18282	0	applied	\N	\N	\N	\N	119751	119751	287447
14847	18283	1	applied	\N	\N	\N	\N	119752	119752	287448
14852	18292	0	applied	\N	\N	\N	\N	119769	119769	287465
14852	18293	1	applied	\N	\N	\N	\N	119770	119770	287466
14855	18296	0	applied	\N	\N	\N	\N	119781	119781	287477
14855	18297	1	applied	\N	\N	\N	\N	119782	119782	287478
14855	18299	4	applied	\N	\N	\N	\N	119784	119784	287480
14855	18300	5	applied	\N	\N	\N	\N	119785	119785	287481
14855	18301	6	applied	\N	\N	\N	\N	119786	119786	287482
14855	18302	7	applied	\N	\N	\N	\N	119787	119787	287483
14855	18303	8	applied	\N	\N	\N	\N	119788	119788	287484
14857	18296	0	applied	\N	\N	\N	\N	119792	119792	287488
14857	18297	1	applied	\N	\N	\N	\N	119793	119793	287489
14857	18298	2	applied	\N	\N	\N	\N	119794	119794	287490
14857	18299	4	applied	\N	\N	\N	\N	119795	119795	287491
14857	18300	5	applied	\N	\N	\N	\N	119796	119796	287492
14857	18301	6	applied	\N	\N	\N	\N	119797	119797	287493
14857	18302	7	applied	\N	\N	\N	\N	119798	119798	287494
14857	18303	8	applied	\N	\N	\N	\N	119799	119799	287495
14860	18304	0	applied	\N	\N	\N	\N	119804	119804	287500
14860	18305	1	applied	\N	\N	\N	\N	119805	119805	287501
14862	18304	0	applied	\N	\N	\N	\N	119811	119811	287507
14862	18302	2	applied	\N	\N	\N	\N	119813	119813	287509
14862	18303	3	applied	\N	\N	\N	\N	119814	119814	287510
14862	18305	4	applied	\N	\N	\N	\N	119815	119815	287511
14866	18310	0	applied	\N	\N	\N	\N	119825	119825	287521
14866	18311	1	applied	\N	\N	\N	\N	119826	119826	287522
14874	18319	0	applied	\N	\N	\N	\N	119856	119856	287552
14874	18320	1	applied	\N	\N	\N	\N	119857	119857	287553
14881	18335	0	applied	\N	\N	1000000000	\N	119885	119885	287581
14881	18336	1	applied	\N	\N	1000000000	\N	119886	119886	287582
14881	18337	2	applied	\N	\N	\N	\N	119887	119887	287583
14881	18338	3	applied	\N	\N	\N	\N	119888	119888	287584
14881	18339	4	applied	\N	\N	\N	\N	119889	119889	287585
14881	18340	5	applied	\N	\N	\N	\N	119890	119890	287586
14881	18341	6	applied	\N	\N	\N	\N	119891	119891	287587
14881	18342	7	applied	\N	\N	\N	\N	119892	119892	287588
14881	18343	8	applied	\N	\N	\N	\N	119893	119893	287589
14887	18365	1	applied	\N	\N	\N	\N	119927	119927	287623
14887	18366	2	applied	\N	\N	\N	\N	119928	119928	287624
14887	18367	3	applied	\N	\N	\N	\N	119929	119929	287625
14887	18368	4	applied	\N	\N	\N	\N	119930	119930	287626
14887	18369	5	applied	\N	\N	\N	\N	119931	119931	287627
14887	18370	6	applied	\N	\N	\N	\N	119932	119932	287628
14887	18371	7	applied	\N	\N	\N	\N	119933	119933	287629
14887	18372	8	applied	\N	\N	\N	\N	119934	119934	287630
14887	18373	9	applied	\N	\N	\N	\N	119935	119935	287631
14887	18374	10	applied	\N	\N	\N	\N	119936	119936	287632
14887	18375	11	applied	\N	\N	\N	\N	119937	119937	287633
14890	18380	0	applied	\N	\N	\N	\N	119946	119946	287642
14890	18383	3	applied	\N	\N	\N	\N	119949	119949	287645
14900	18400	0	applied	\N	\N	\N	\N	119998	119998	287694
14900	18402	2	applied	\N	\N	\N	\N	120000	120000	287696
14903	18405	0	applied	\N	\N	\N	\N	120007	120007	287703
14912	18421	3	applied	\N	\N	\N	\N	120043	120043	287739
14916	18440	0	applied	\N	\N	\N	\N	120064	120064	287760
14916	18441	1	applied	\N	\N	\N	\N	120065	120065	287761
14918	18442	0	applied	\N	\N	\N	\N	120069	120069	287765
14918	18443	1	applied	\N	\N	\N	\N	120070	120070	287766
14918	18444	2	applied	\N	\N	\N	\N	120071	120071	287767
14920	18445	0	applied	\N	\N	\N	\N	120075	120075	287771
14920	18446	1	applied	\N	\N	\N	\N	120076	120076	287772
14920	18447	2	applied	\N	\N	\N	\N	120077	120077	287773
14921	18445	0	applied	\N	\N	\N	\N	120078	120078	287774
14922	18448	0	applied	\N	\N	\N	\N	120081	120081	287777
14927	18454	0	applied	\N	\N	\N	\N	120089	120089	287785
14927	18455	1	applied	\N	\N	\N	\N	120090	120090	287786
14932	18460	0	applied	\N	\N	\N	\N	120097	120097	287793
14932	18461	1	applied	\N	\N	\N	\N	120098	120098	287794
14932	18462	2	applied	\N	\N	\N	\N	120099	120099	287795
14932	18463	3	applied	\N	\N	\N	\N	120100	120100	287796
14932	18464	4	applied	\N	\N	\N	\N	120101	120101	287797
14941	18465	0	applied	\N	\N	\N	\N	120131	120131	287827
14941	18466	1	applied	\N	\N	\N	\N	120132	120132	287828
14943	18467	0	applied	\N	\N	\N	\N	120135	120135	287831
14943	18468	1	applied	\N	\N	\N	\N	120136	120136	287832
14809	18219	2	applied	\N	\N	\N	\N	119502	119502	287199
14812	18220	0	applied	\N	\N	\N	\N	119505	119505	287202
14831	18192	23	applied	\N	\N	\N	\N	119595	119595	287292
14831	18193	24	applied	\N	\N	\N	\N	119596	119596	287293
14831	18195	25	applied	\N	\N	\N	\N	119597	119597	287294
14831	18198	26	applied	\N	\N	\N	\N	119598	119598	287295
14831	18200	27	applied	\N	\N	\N	\N	119599	119599	287296
14831	18210	31	applied	\N	\N	\N	\N	119603	119603	287300
14831	18211	32	applied	\N	\N	\N	\N	119604	119604	287301
14831	18213	33	applied	\N	\N	\N	\N	119605	119605	287302
14831	18216	34	applied	\N	\N	\N	\N	119606	119606	287303
14831	18219	35	applied	\N	\N	\N	\N	119607	119607	287304
14831	18225	36	applied	\N	\N	\N	\N	119608	119608	287305
14831	18226	37	applied	\N	\N	\N	\N	119609	119609	287306
14831	18227	38	applied	\N	\N	\N	\N	119610	119610	287307
14831	18228	39	applied	\N	\N	\N	\N	119611	119611	287308
14831	18230	40	applied	\N	\N	\N	\N	119612	119612	287309
14831	18232	41	applied	\N	\N	\N	\N	119613	119613	287310
14831	18234	42	applied	\N	\N	\N	\N	119614	119614	287311
14831	18236	43	applied	\N	\N	\N	\N	119615	119615	287312
14831	18239	44	applied	\N	\N	\N	\N	119616	119616	287313
14831	18240	45	applied	\N	\N	\N	\N	119617	119617	287314
14831	18242	46	applied	\N	\N	\N	\N	119618	119618	287315
14831	18246	48	applied	\N	\N	\N	\N	119620	119620	287317
14831	18249	49	applied	\N	\N	\N	\N	119621	119621	287318
14831	18250	50	applied	\N	\N	\N	\N	119622	119622	287319
14831	18254	51	applied	\N	\N	\N	\N	119623	119623	287320
14831	18255	52	applied	\N	\N	\N	\N	119624	119624	287321
14831	18256	53	applied	\N	\N	\N	\N	119625	119625	287322
14831	18258	54	applied	\N	\N	\N	\N	119626	119626	287323
14831	18261	55	applied	\N	\N	\N	\N	119627	119627	287324
14831	18262	56	applied	\N	\N	\N	\N	119628	119628	287325
14831	18263	57	applied	\N	\N	\N	\N	119629	119629	287326
14839	18269	0	applied	\N	\N	\N	\N	119648	119648	287345
14839	18270	1	applied	\N	\N	\N	\N	119649	119649	287346
14839	18271	2	applied	\N	\N	\N	\N	119650	119650	287347
14839	18272	3	applied	\N	\N	\N	\N	119651	119651	287348
14839	18273	4	applied	\N	\N	\N	\N	119652	119652	287349
14839	18274	5	applied	\N	\N	\N	\N	119653	119653	287350
14839	18276	7	applied	\N	\N	\N	\N	119655	119655	287352
14845	18282	0	applied	\N	\N	\N	\N	119673	119673	287369
14845	18283	1	applied	\N	\N	\N	\N	119674	119674	287370
14848	18284	0	applied	\N	\N	\N	\N	119753	119753	287449
14848	18285	1	applied	\N	\N	\N	\N	119754	119754	287450
14848	18286	2	applied	\N	\N	\N	\N	119755	119755	287451
14848	18287	3	applied	\N	\N	\N	\N	119756	119756	287452
14848	18288	4	applied	\N	\N	\N	\N	119757	119757	287453
14848	18289	5	applied	\N	\N	\N	\N	119758	119758	287454
14850	18290	0	applied	\N	\N	\N	\N	119765	119765	287461
14850	18291	1	applied	\N	\N	\N	\N	119766	119766	287462
14858	18304	0	applied	\N	\N	\N	\N	119800	119800	287496
14858	18305	1	applied	\N	\N	\N	\N	119801	119801	287497
14865	18308	0	applied	\N	\N	\N	\N	119823	119823	287519
14865	18309	1	applied	\N	\N	\N	\N	119824	119824	287520
14868	18310	0	applied	\N	\N	\N	\N	119829	119829	287525
14870	18312	0	applied	\N	\N	1000000000	\N	119833	119833	287529
14870	18313	1	applied	\N	\N	\N	\N	119834	119834	287530
14870	18314	2	applied	\N	\N	\N	\N	119835	119835	287531
14870	18315	3	applied	\N	\N	\N	\N	119836	119836	287532
14870	18316	4	applied	\N	\N	\N	\N	119837	119837	287533
14870	18317	5	applied	\N	\N	\N	\N	119838	119838	287534
14870	18318	6	applied	\N	\N	\N	\N	119839	119839	287535
14876	18319	0	applied	\N	\N	\N	\N	119860	119860	287556
14876	18320	1	applied	\N	\N	\N	\N	119861	119861	287557
14877	18321	0	applied	\N	\N	\N	\N	119862	119862	287558
14877	18322	1	applied	\N	\N	\N	\N	119863	119863	287559
14877	18323	2	applied	\N	\N	\N	\N	119864	119864	287560
14877	18324	3	applied	\N	\N	\N	\N	119865	119865	287561
14877	18325	4	applied	\N	\N	\N	\N	119866	119866	287562
14877	18326	5	applied	\N	\N	\N	\N	119867	119867	287563
14877	18327	6	applied	\N	\N	\N	\N	119868	119868	287564
14880	18336	1	applied	\N	\N	1000000000	\N	119877	119877	287573
14880	18337	2	applied	\N	\N	\N	\N	119878	119878	287574
14880	18338	3	applied	\N	\N	\N	\N	119879	119879	287575
14880	18339	4	applied	\N	\N	\N	\N	119880	119880	287576
14880	18340	5	applied	\N	\N	\N	\N	119881	119881	287577
14880	18341	6	applied	\N	\N	\N	\N	119882	119882	287578
14880	18342	7	applied	\N	\N	\N	\N	119883	119883	287579
14880	18343	8	applied	\N	\N	\N	\N	119884	119884	287580
14885	18349	0	applied	\N	\N	\N	\N	119911	119911	287607
14885	18350	1	applied	\N	\N	\N	\N	119912	119912	287608
14885	18351	2	applied	\N	\N	\N	\N	119913	119913	287609
14891	18384	0	applied	\N	\N	\N	\N	119950	119950	287646
14891	18385	1	applied	\N	\N	\N	\N	119951	119951	287647
14891	18386	2	applied	\N	\N	\N	\N	119952	119952	287648
14891	18387	3	applied	\N	\N	\N	\N	119953	119953	287649
14894	18388	0	applied	\N	\N	\N	\N	119970	119970	287666
14946	18484	1	applied	\N	\N	\N	\N	120152	120152	287848
14831	18180	17	applied	\N	\N	\N	\N	119589	119589	287286
14831	18181	18	applied	\N	\N	\N	\N	119590	119590	287287
14831	18183	19	applied	\N	\N	\N	\N	119591	119591	287288
14831	18185	20	applied	\N	\N	\N	\N	119592	119592	287289
14831	18187	21	applied	\N	\N	\N	\N	119593	119593	287290
14831	18191	22	applied	\N	\N	\N	\N	119594	119594	287291
14831	18202	28	applied	\N	\N	\N	\N	119600	119600	287297
14831	18205	29	applied	\N	\N	\N	\N	119601	119601	287298
14846	17897	11	applied	\N	\N	\N	\N	119686	119686	287382
14846	17898	12	applied	\N	\N	\N	\N	119687	119687	287383
14846	17899	13	applied	\N	\N	\N	\N	119688	119688	287384
14846	17901	14	applied	\N	\N	\N	\N	119689	119689	287385
14846	17905	15	applied	\N	\N	\N	\N	119690	119690	287386
14846	17906	16	applied	\N	\N	\N	\N	119691	119691	287387
14846	17907	17	applied	\N	\N	\N	\N	119692	119692	287388
14846	17908	18	applied	\N	\N	\N	\N	119693	119693	287389
14846	17909	19	applied	\N	\N	\N	\N	119694	119694	287390
14846	17910	20	applied	\N	\N	\N	\N	119695	119695	287391
14846	17911	21	applied	\N	\N	\N	\N	119696	119696	287392
14846	17912	22	applied	\N	\N	\N	\N	119697	119697	287393
14846	17913	23	applied	\N	\N	\N	\N	119698	119698	287394
14846	17914	24	applied	\N	\N	\N	\N	119699	119699	287395
14846	17916	26	applied	\N	\N	\N	\N	119701	119701	287397
14846	17917	27	applied	\N	\N	\N	\N	119702	119702	287398
14846	17918	28	applied	\N	\N	\N	\N	119703	119703	287399
14846	17919	29	applied	\N	\N	\N	\N	119704	119704	287400
14846	17920	30	applied	\N	\N	\N	\N	119705	119705	287401
14846	17921	31	applied	\N	\N	\N	\N	119706	119706	287402
14846	17925	32	applied	\N	\N	\N	\N	119707	119707	287403
14846	17926	33	applied	\N	\N	\N	\N	119708	119708	287404
14846	17927	34	applied	\N	\N	\N	\N	119709	119709	287405
14846	17929	35	applied	\N	\N	\N	\N	119710	119710	287406
14846	17930	36	applied	\N	\N	\N	\N	119711	119711	287407
14846	17931	37	applied	\N	\N	\N	\N	119712	119712	287408
14846	17934	38	applied	\N	\N	\N	\N	119713	119713	287409
14846	17935	39	applied	\N	\N	\N	\N	119714	119714	287410
14846	17936	40	applied	\N	\N	\N	\N	119715	119715	287411
14846	17937	41	applied	\N	\N	\N	\N	119716	119716	287412
14846	17939	43	applied	\N	\N	\N	\N	119718	119718	287414
14846	17944	44	applied	\N	\N	\N	\N	119719	119719	287415
14846	17945	45	applied	\N	\N	\N	\N	119720	119720	287416
14846	17946	46	applied	\N	\N	\N	\N	119721	119721	287417
14846	17947	47	applied	\N	\N	\N	\N	119722	119722	287418
14846	17948	48	applied	\N	\N	\N	\N	119723	119723	287419
14846	17949	49	applied	\N	\N	\N	\N	119724	119724	287420
14846	17950	50	applied	\N	\N	\N	\N	119725	119725	287421
14846	17951	51	applied	\N	\N	\N	\N	119726	119726	287422
14846	17952	52	applied	\N	\N	\N	\N	119727	119727	287423
14846	17953	53	applied	\N	\N	\N	\N	119728	119728	287424
14846	17954	54	applied	\N	\N	\N	\N	119729	119729	287425
14846	17955	55	applied	\N	\N	\N	\N	119730	119730	287426
14846	17956	56	applied	\N	\N	\N	\N	119731	119731	287427
14846	17957	57	applied	\N	\N	\N	\N	119732	119732	287428
14846	17958	58	applied	\N	\N	\N	\N	119733	119733	287429
14846	17960	60	applied	\N	\N	\N	\N	119735	119735	287431
14846	17961	61	applied	\N	\N	\N	\N	119736	119736	287432
14846	17965	62	applied	\N	\N	\N	\N	119737	119737	287433
14846	17967	63	applied	\N	\N	\N	\N	119738	119738	287434
14846	17968	64	applied	\N	\N	\N	\N	119739	119739	287435
14846	17969	65	applied	\N	\N	\N	\N	119740	119740	287436
14846	17970	66	applied	\N	\N	\N	\N	119741	119741	287437
14846	17971	67	applied	\N	\N	\N	\N	119742	119742	287438
14846	17972	68	applied	\N	\N	\N	\N	119743	119743	287439
14846	17973	69	applied	\N	\N	\N	\N	119744	119744	287440
14846	17975	70	applied	\N	\N	\N	\N	119745	119745	287441
14846	17976	71	applied	\N	\N	\N	\N	119746	119746	287442
14846	17977	72	applied	\N	\N	\N	\N	119747	119747	287443
14846	17978	73	applied	\N	\N	\N	\N	119748	119748	287444
14846	17984	74	applied	\N	\N	\N	\N	119749	119749	287445
14846	17985	75	applied	\N	\N	\N	\N	119750	119750	287446
14849	18285	1	applied	\N	\N	\N	\N	119760	119760	287456
14849	18286	2	applied	\N	\N	\N	\N	119761	119761	287457
14849	18287	3	applied	\N	\N	\N	\N	119762	119762	287458
14849	18288	4	applied	\N	\N	\N	\N	119763	119763	287459
14849	18289	5	applied	\N	\N	\N	\N	119764	119764	287460
14851	18292	0	applied	\N	\N	\N	\N	119767	119767	287463
14851	18293	1	applied	\N	\N	\N	\N	119768	119768	287464
14853	18294	0	applied	\N	\N	\N	\N	119771	119771	287467
14853	18295	1	applied	\N	\N	\N	\N	119772	119772	287468
14854	18296	0	applied	\N	\N	\N	\N	119773	119773	287469
14854	18297	1	applied	\N	\N	\N	\N	119774	119774	287470
14854	18298	2	applied	\N	\N	\N	\N	119775	119775	287471
14854	18299	4	applied	\N	\N	\N	\N	119776	119776	287472
14854	18300	5	applied	\N	\N	\N	\N	119777	119777	287473
14854	18301	6	applied	\N	\N	\N	\N	119778	119778	287474
14854	18302	7	applied	\N	\N	\N	\N	119779	119779	287475
14859	18304	0	applied	\N	\N	\N	\N	119802	119802	287498
14859	18305	1	applied	\N	\N	\N	\N	119803	119803	287499
14861	18296	0	applied	\N	\N	\N	\N	119806	119806	287502
14861	18297	1	applied	\N	\N	\N	\N	119807	119807	287503
14861	18298	2	applied	\N	\N	\N	\N	119808	119808	287504
14861	18299	4	applied	\N	\N	\N	\N	119809	119809	287505
14861	18300	5	applied	\N	\N	\N	\N	119810	119810	287506
14864	18306	0	applied	\N	\N	\N	\N	119821	119821	287517
14864	18307	1	applied	\N	\N	\N	\N	119822	119822	287518
14869	18310	0	applied	\N	\N	\N	\N	119831	119831	287527
14869	18311	1	applied	\N	\N	\N	\N	119832	119832	287528
14871	18312	0	applied	\N	\N	1000000000	\N	119840	119840	287536
14871	18313	1	applied	\N	\N	\N	\N	119841	119841	287537
14871	18314	2	applied	\N	\N	\N	\N	119842	119842	287538
14871	18315	3	applied	\N	\N	\N	\N	119843	119843	287539
14871	18316	4	applied	\N	\N	\N	\N	119844	119844	287540
14871	18318	6	applied	\N	\N	\N	\N	119846	119846	287542
14873	18319	0	applied	\N	\N	\N	\N	119854	119854	287550
14873	18320	1	applied	\N	\N	\N	\N	119855	119855	287551
14878	18328	0	applied	\N	\N	\N	\N	119869	119869	287565
14878	18329	1	applied	\N	\N	\N	\N	119870	119870	287566
14878	18330	2	applied	\N	\N	\N	\N	119871	119871	287567
14878	18331	3	applied	\N	\N	\N	\N	119872	119872	287568
14883	18344	0	applied	\N	\N	\N	\N	119903	119903	287599
14883	18345	1	applied	\N	\N	\N	\N	119904	119904	287600
14883	18346	2	applied	\N	\N	\N	\N	119905	119905	287601
14883	18347	3	applied	\N	\N	\N	\N	119906	119906	287602
14883	18348	4	applied	\N	\N	\N	\N	119907	119907	287603
14886	18352	0	applied	\N	\N	\N	\N	119914	119914	287610
14886	18353	1	applied	\N	\N	\N	\N	119915	119915	287611
14908	18415	1	applied	\N	\N	\N	\N	120025	120025	287721
14846	17896	10	applied	\N	\N	\N	\N	119685	119685	287381
14889	18381	1	applied	\N	\N	\N	\N	119943	119943	287639
14889	18382	2	applied	\N	\N	\N	\N	119944	119944	287640
14889	18383	3	applied	\N	\N	\N	\N	119945	119945	287641
14892	18388	0	applied	\N	\N	\N	\N	119954	119954	287650
14892	18389	1	applied	\N	\N	\N	\N	119955	119955	287651
14892	18390	3	applied	\N	\N	\N	\N	119956	119956	287652
14892	18391	4	applied	\N	\N	\N	\N	119957	119957	287653
14892	18393	6	applied	\N	\N	\N	\N	119959	119959	287655
14917	18443	1	applied	\N	\N	\N	\N	120067	120067	287763
14917	18444	2	applied	\N	\N	\N	\N	120068	120068	287764
14926	18452	0	applied	\N	\N	\N	\N	120087	120087	287783
14926	18453	1	applied	\N	\N	\N	\N	120088	120088	287784
14929	18459	0	applied	\N	\N	\N	\N	120094	120094	287790
14935	18460	0	applied	\N	\N	\N	\N	120112	120112	287808
14935	18461	1	applied	\N	\N	\N	\N	120113	120113	287809
14935	18462	2	applied	\N	\N	\N	\N	120114	120114	287810
14935	18463	3	applied	\N	\N	\N	\N	120115	120115	287811
14940	18465	0	applied	\N	\N	\N	\N	120129	120129	287825
14940	18466	1	applied	\N	\N	\N	\N	120130	120130	287826
14942	18467	0	applied	\N	\N	\N	\N	120133	120133	287829
14942	18468	1	applied	\N	\N	\N	\N	120134	120134	287830
14944	18469	0	applied	\N	\N	\N	\N	120137	120137	287833
14948	18485	0	applied	\N	\N	\N	\N	120155	120155	287851
14948	18486	1	applied	\N	\N	\N	\N	120156	120156	287852
14948	18487	2	applied	\N	\N	\N	\N	120157	120157	287853
14948	18488	3	applied	\N	\N	\N	\N	120158	120158	287854
14948	18489	4	applied	\N	\N	\N	\N	120159	120159	287855
14954	18490	0	applied	\N	\N	\N	\N	120173	120173	287869
14954	18491	1	applied	\N	\N	\N	\N	120174	120174	287870
14954	18492	2	applied	\N	\N	\N	\N	120175	120175	287871
14956	18494	0	applied	\N	\N	\N	\N	120177	120177	287873
14956	18495	1	applied	\N	\N	\N	\N	120178	120178	287874
14956	18496	2	applied	\N	\N	\N	\N	120179	120179	287875
14959	18495	1	applied	\N	\N	\N	\N	120187	120187	287883
14959	18496	2	applied	\N	\N	\N	\N	120188	120188	287884
14963	18504	0	applied	\N	\N	\N	\N	120198	120198	287894
14963	18505	1	applied	\N	\N	\N	\N	120199	120199	287895
14976	18533	0	applied	\N	\N	\N	\N	120231	120231	287927
14976	18534	1	applied	\N	\N	\N	\N	120232	120232	287928
14976	18535	2	applied	\N	\N	\N	\N	120233	120233	287929
14978	18536	0	applied	\N	\N	\N	\N	120237	120237	287933
14978	18537	1	applied	\N	\N	\N	\N	120238	120238	287934
14981	18536	0	applied	\N	\N	\N	\N	120243	120243	287939
14981	18537	1	applied	\N	\N	\N	\N	120244	120244	287940
14990	18545	0	applied	\N	\N	\N	\N	120261	120261	287957
14990	18546	1	applied	\N	\N	\N	\N	120262	120262	287958
14990	18547	2	applied	\N	\N	\N	\N	120263	120263	287959
15001	18561	0	applied	\N	\N	\N	\N	120293	120293	287989
15001	18562	1	applied	\N	\N	\N	\N	120294	120294	287990
15001	18564	3	applied	\N	\N	\N	\N	120296	120296	287992
15003	18565	0	applied	\N	\N	\N	\N	120423	120423	288119
15003	18566	1	applied	\N	\N	\N	\N	120424	120424	288120
15006	18567	0	applied	\N	\N	\N	\N	120432	120432	288128
15006	18568	1	applied	\N	\N	\N	\N	120433	120433	288129
15006	18569	2	applied	\N	\N	\N	\N	120434	120434	288130
15006	18570	3	applied	\N	\N	\N	\N	120435	120435	288131
15006	18571	4	applied	\N	\N	\N	\N	120436	120436	288132
15013	18580	0	applied	\N	\N	\N	\N	120449	120449	288145
15013	18581	1	applied	\N	\N	\N	\N	120450	120450	288146
15013	18582	2	applied	\N	\N	\N	\N	120451	120451	288147
15018	18592	0	applied	\N	\N	\N	\N	120464	120464	288160
15018	18593	1	applied	\N	\N	\N	\N	120465	120465	288161
15018	18594	2	applied	\N	\N	\N	\N	120466	120466	288162
15024	18597	0	applied	\N	\N	\N	\N	120487	120487	288183
15024	18598	1	applied	\N	\N	\N	\N	120488	120488	288184
14886	18357	5	applied	\N	\N	\N	\N	119919	119919	287615
14886	18358	6	applied	\N	\N	\N	\N	119920	119920	287616
14886	18359	7	applied	\N	\N	\N	\N	119921	119921	287617
14886	18360	8	applied	\N	\N	\N	\N	119922	119922	287618
14886	18361	9	applied	\N	\N	\N	\N	119923	119923	287619
14886	18362	10	applied	\N	\N	\N	\N	119924	119924	287620
14886	18363	11	applied	\N	\N	\N	\N	119925	119925	287621
14889	18380	0	applied	\N	\N	\N	\N	119942	119942	287638
14895	18388	0	applied	\N	\N	\N	\N	119978	119978	287674
14895	18389	1	applied	\N	\N	\N	\N	119979	119979	287675
14895	18390	3	applied	\N	\N	\N	\N	119980	119980	287676
14913	18422	0	applied	\N	\N	\N	\N	120044	120044	287740
14913	18423	1	applied	\N	\N	\N	\N	120045	120045	287741
14913	18424	2	applied	\N	\N	1000000000	\N	120046	120046	287742
14913	18425	3	applied	\N	\N	\N	\N	120047	120047	287743
14915	18440	0	applied	\N	\N	\N	\N	120062	120062	287758
14915	18441	1	applied	\N	\N	\N	\N	120063	120063	287759
14917	18442	0	applied	\N	\N	\N	\N	120066	120066	287762
14914	18429	3	applied	\N	\N	\N	\N	120051	120051	287747
14914	18430	4	applied	\N	\N	\N	\N	120052	120052	287748
14914	18431	5	applied	\N	\N	\N	\N	120053	120053	287749
14914	18432	6	applied	\N	\N	\N	\N	120054	120054	287750
14914	18433	7	applied	\N	\N	\N	\N	120055	120055	287751
14914	18434	8	applied	\N	\N	\N	\N	120056	120056	287752
14914	18435	9	applied	\N	\N	\N	\N	120057	120057	287753
14914	18436	10	applied	\N	\N	\N	\N	120058	120058	287754
14914	18437	11	applied	\N	\N	\N	\N	120059	120059	287755
14914	18438	12	applied	\N	\N	\N	\N	120060	120060	287756
14914	18439	13	applied	\N	\N	\N	\N	120061	120061	287757
14924	18448	0	applied	\N	\N	\N	\N	120083	120083	287779
14928	18457	1	applied	\N	\N	\N	\N	120092	120092	287788
14928	18458	2	applied	\N	\N	\N	\N	120093	120093	287789
14931	18459	0	applied	\N	\N	\N	\N	120096	120096	287792
14934	18460	0	applied	\N	\N	\N	\N	120107	120107	287803
14934	18461	1	applied	\N	\N	\N	\N	120108	120108	287804
14934	18462	2	applied	\N	\N	\N	\N	120109	120109	287805
14934	18463	3	applied	\N	\N	\N	\N	120110	120110	287806
14934	18464	4	applied	\N	\N	\N	\N	120111	120111	287807
14938	18460	0	applied	\N	\N	\N	\N	120122	120122	287818
14938	18461	1	applied	\N	\N	\N	\N	120123	120123	287819
14938	18462	2	applied	\N	\N	\N	\N	120124	120124	287820
14938	18463	3	applied	\N	\N	\N	\N	120125	120125	287821
14938	18464	4	applied	\N	\N	\N	\N	120126	120126	287822
14939	18465	0	applied	\N	\N	\N	\N	120127	120127	287823
14939	18466	1	applied	\N	\N	\N	\N	120128	120128	287824
14945	18470	0	applied	\N	\N	\N	\N	120138	120138	287834
14945	18472	2	applied	\N	\N	\N	\N	120140	120140	287836
14945	18473	3	applied	\N	\N	\N	\N	120141	120141	287837
14945	18474	4	applied	\N	\N	\N	\N	120142	120142	287838
14945	18475	5	applied	\N	\N	\N	\N	120143	120143	287839
14945	18476	6	applied	\N	\N	\N	\N	120144	120144	287840
14945	18477	7	applied	\N	\N	\N	\N	120145	120145	287841
14945	18478	8	applied	\N	\N	\N	\N	120146	120146	287842
14945	18479	9	applied	\N	\N	\N	\N	120147	120147	287843
14945	18480	10	applied	\N	\N	\N	\N	120148	120148	287844
14945	18481	11	applied	\N	\N	\N	\N	120149	120149	287845
14945	18482	12	applied	\N	\N	\N	\N	120150	120150	287846
14947	18483	0	applied	\N	\N	\N	\N	120153	120153	287849
14947	18484	1	applied	\N	\N	\N	\N	120154	120154	287850
14953	18490	0	applied	\N	\N	\N	\N	120170	120170	287866
14953	18491	1	applied	\N	\N	\N	\N	120171	120171	287867
14953	18492	2	applied	\N	\N	\N	\N	120172	120172	287868
14958	18494	0	applied	\N	\N	\N	\N	120183	120183	287879
14958	18495	1	applied	\N	\N	\N	\N	120184	120184	287880
14958	18496	2	applied	\N	\N	\N	\N	120185	120185	287881
14960	18497	0	applied	\N	\N	\N	\N	120189	120189	287885
14960	18498	1	applied	\N	\N	\N	\N	120190	120190	287886
14960	18499	2	applied	\N	\N	\N	\N	120191	120191	287887
14960	18500	3	applied	\N	\N	\N	\N	120192	120192	287888
14960	18501	4	applied	\N	\N	\N	\N	120193	120193	287889
14965	18509	0	applied	\N	\N	\N	\N	120203	120203	287899
14965	18510	1	applied	\N	\N	\N	\N	120204	120204	287900
14965	18511	2	applied	\N	\N	\N	\N	120205	120205	287901
14968	18512	0	applied	\N	\N	\N	\N	120208	120208	287904
14970	18516	0	applied	\N	\N	\N	\N	120212	120212	287908
14970	18517	1	applied	\N	\N	\N	\N	120213	120213	287909
14970	18518	2	applied	\N	\N	\N	\N	120214	120214	287910
14970	18519	3	applied	\N	\N	\N	\N	120215	120215	287911
14970	18521	5	applied	\N	\N	\N	\N	120217	120217	287913
14973	18524	0	applied	\N	\N	\N	\N	120222	120222	287918
14973	18525	1	applied	\N	\N	\N	\N	120223	120223	287919
14975	18529	0	applied	\N	\N	\N	\N	120227	120227	287923
14975	18530	1	applied	\N	\N	\N	\N	120228	120228	287924
14975	18531	2	applied	\N	\N	\N	\N	120229	120229	287925
14975	18532	3	applied	\N	\N	\N	\N	120230	120230	287926
14980	18536	0	applied	\N	\N	\N	\N	120241	120241	287937
14980	18537	1	applied	\N	\N	\N	\N	120242	120242	287938
14982	18538	0	applied	\N	\N	\N	\N	120245	120245	287941
14982	18539	1	applied	\N	\N	\N	\N	120246	120246	287942
14982	18540	2	applied	\N	\N	\N	\N	120247	120247	287943
14985	18541	0	applied	\N	\N	\N	\N	120250	120250	287946
14987	18542	0	applied	\N	\N	\N	\N	120252	120252	287948
14987	18543	1	applied	\N	\N	\N	\N	120253	120253	287949
14987	18544	2	applied	\N	\N	\N	\N	120254	120254	287950
14989	18545	0	applied	\N	\N	\N	\N	120258	120258	287954
14989	18546	1	applied	\N	\N	\N	\N	120259	120259	287955
14994	18550	0	applied	\N	\N	\N	\N	120274	120274	287970
14994	18551	1	applied	\N	\N	\N	\N	120275	120275	287971
14994	18552	2	applied	\N	\N	\N	\N	120276	120276	287972
14994	18553	3	applied	\N	\N	\N	\N	120277	120277	287973
14994	18554	4	applied	\N	\N	1000000000	\N	120278	120278	287974
14996	18555	0	applied	\N	\N	\N	\N	120282	120282	287978
14996	18556	1	applied	\N	\N	\N	\N	120283	120283	287979
14996	18557	2	applied	\N	\N	\N	\N	120284	120284	287980
14998	18561	0	applied	\N	\N	\N	\N	120288	120288	287984
15005	18567	0	applied	\N	\N	\N	\N	120427	120427	288123
15005	18568	1	applied	\N	\N	\N	\N	120428	120428	288124
15005	18569	2	applied	\N	\N	\N	\N	120429	120429	288125
15005	18570	3	applied	\N	\N	\N	\N	120430	120430	288126
15005	18571	4	applied	\N	\N	\N	\N	120431	120431	288127
15008	18572	0	applied	\N	\N	\N	\N	120439	120439	288135
15008	18573	1	applied	\N	\N	\N	\N	120440	120440	288136
15010	18575	1	applied	\N	\N	\N	\N	120444	120444	288140
15012	18578	0	applied	\N	\N	\N	\N	120447	120447	288143
15012	18579	1	applied	\N	\N	\N	\N	120448	120448	288144
15015	18583	0	applied	\N	\N	\N	\N	120455	120455	288151
15015	18584	1	applied	\N	\N	\N	\N	120456	120456	288152
15015	18585	2	applied	\N	\N	\N	\N	120457	120457	288153
15015	18586	3	applied	\N	\N	\N	\N	120458	120458	288154
15015	18587	4	applied	\N	\N	\N	\N	120459	120459	288155
15023	18597	0	applied	\N	\N	\N	\N	120477	120477	288173
15023	18598	1	applied	\N	\N	\N	\N	120478	120478	288174
15023	18599	2	applied	\N	\N	\N	\N	120479	120479	288175
15023	18600	3	applied	\N	\N	\N	\N	120480	120480	288176
15023	18601	4	applied	\N	\N	\N	\N	120481	120481	288177
15024	18599	2	applied	\N	\N	\N	\N	120489	120489	288185
15024	18600	3	applied	\N	\N	\N	\N	120490	120490	288186
14914	18426	0	applied	\N	\N	\N	\N	120048	120048	287744
14914	18428	2	applied	\N	\N	\N	\N	120050	120050	287746
14925	18450	1	applied	\N	\N	\N	\N	120085	120085	287781
14925	18451	2	applied	\N	\N	\N	\N	120086	120086	287782
14930	18459	0	applied	\N	\N	\N	\N	120095	120095	287791
14933	18460	0	applied	\N	\N	\N	\N	120102	120102	287798
14933	18461	1	applied	\N	\N	\N	\N	120103	120103	287799
14933	18462	2	applied	\N	\N	\N	\N	120104	120104	287800
14933	18463	3	applied	\N	\N	\N	\N	120105	120105	287801
14933	18464	4	applied	\N	\N	\N	\N	120106	120106	287802
14937	18460	0	applied	\N	\N	\N	\N	120117	120117	287813
14937	18461	1	applied	\N	\N	\N	\N	120118	120118	287814
14937	18462	2	applied	\N	\N	\N	\N	120119	120119	287815
14937	18463	3	applied	\N	\N	\N	\N	120120	120120	287816
14937	18464	4	applied	\N	\N	\N	\N	120121	120121	287817
14962	18502	0	applied	\N	\N	\N	\N	120196	120196	287892
14964	18506	0	applied	\N	\N	\N	\N	120200	120200	287896
14964	18507	1	applied	\N	\N	\N	\N	120201	120201	287897
14964	18508	2	applied	\N	\N	\N	\N	120202	120202	287898
14967	18512	0	applied	\N	\N	\N	\N	120207	120207	287903
14969	18513	0	applied	\N	\N	\N	\N	120209	120209	287905
14969	18514	1	applied	\N	\N	\N	\N	120210	120210	287906
14969	18515	2	applied	\N	\N	\N	\N	120211	120211	287907
14972	18524	0	applied	\N	\N	\N	\N	120220	120220	287916
14972	18525	1	applied	\N	\N	\N	\N	120221	120221	287917
14974	18526	0	applied	\N	\N	\N	\N	120224	120224	287920
14974	18527	1	applied	\N	\N	\N	\N	120225	120225	287921
14974	18528	2	applied	\N	\N	\N	\N	120226	120226	287922
14984	18541	0	applied	\N	\N	\N	\N	120249	120249	287945
14986	18541	0	applied	\N	\N	\N	\N	120251	120251	287947
14988	18545	0	applied	\N	\N	\N	\N	120255	120255	287951
14988	18546	1	applied	\N	\N	\N	\N	120256	120256	287952
14993	18550	0	applied	\N	\N	\N	\N	120269	120269	287965
14993	18551	1	applied	\N	\N	\N	\N	120270	120270	287966
14993	18552	2	applied	\N	\N	\N	\N	120271	120271	287967
14993	18553	3	applied	\N	\N	\N	\N	120272	120272	287968
14993	18554	4	applied	\N	\N	1000000000	\N	120273	120273	287969
14995	18555	0	applied	\N	\N	\N	\N	120279	120279	287975
14995	18556	1	applied	\N	\N	\N	\N	120280	120280	287976
14995	18557	2	applied	\N	\N	\N	\N	120281	120281	287977
15000	18561	0	applied	\N	\N	\N	\N	120289	120289	287985
15000	18562	1	applied	\N	\N	\N	\N	120290	120290	287986
15000	18563	2	applied	\N	\N	\N	\N	120291	120291	287987
15000	18564	3	applied	\N	\N	\N	\N	120292	120292	287988
15007	18572	0	applied	\N	\N	\N	\N	120437	120437	288133
15007	18573	1	applied	\N	\N	\N	\N	120438	120438	288134
15009	18574	0	applied	\N	\N	\N	\N	120441	120441	288137
15009	18575	1	applied	\N	\N	\N	\N	120442	120442	288138
15017	18590	1	applied	\N	\N	\N	\N	120462	120462	288158
15017	18591	2	applied	\N	\N	\N	\N	120463	120463	288159
15020	18592	0	applied	\N	\N	\N	\N	120470	120470	288166
15020	18593	1	applied	\N	\N	\N	\N	120471	120471	288167
15020	18594	2	applied	\N	\N	\N	\N	120472	120472	288168
15022	18595	0	applied	\N	\N	\N	\N	120475	120475	288171
15022	18596	1	applied	\N	\N	\N	\N	120476	120476	288172
15023	18602	5	applied	\N	\N	\N	\N	120482	120482	288178
15023	18603	6	applied	\N	\N	\N	\N	120483	120483	288179
15027	18608	0	applied	\N	\N	\N	\N	120501	120501	288197
15027	18609	1	applied	\N	\N	\N	\N	120502	120502	288198
15027	18610	2	applied	\N	\N	\N	\N	120503	120503	288199
15029	18611	0	applied	\N	\N	\N	\N	120507	120507	288203
15029	18612	1	applied	\N	\N	\N	\N	120508	120508	288204
15034	18618	0	applied	\N	\N	\N	\N	120562	120562	288257
15034	18619	1	applied	\N	\N	\N	\N	120563	120563	288258
15034	18621	3	applied	\N	\N	\N	\N	120565	120565	288260
15034	18622	4	applied	\N	\N	\N	\N	120566	120566	288261
15037	18623	0	applied	\N	\N	\N	\N	120573	120573	288268
15041	18624	0	applied	\N	\N	\N	\N	120579	120579	288274
15041	18625	2	applied	\N	\N	\N	\N	120580	120580	288275
15041	18626	3	applied	\N	\N	\N	\N	120581	120581	288276
15045	18627	0	applied	\N	\N	\N	\N	120590	120590	288285
15045	18628	1	applied	\N	\N	\N	\N	120591	120591	288286
15048	18631	0	applied	\N	\N	\N	\N	120596	120596	288291
15048	18632	1	applied	\N	\N	\N	\N	120597	120597	288292
15054	18558	0	applied	\N	\N	\N	\N	120602	120602	288297
15054	18561	1	applied	\N	\N	\N	\N	120603	120603	288298
15054	18562	2	applied	\N	\N	\N	\N	120604	120604	288299
15054	18565	3	applied	\N	\N	\N	\N	120605	120605	288300
15054	18567	4	applied	\N	\N	\N	\N	120606	120606	288301
15054	18568	5	applied	\N	\N	\N	\N	120607	120607	288302
15054	18574	7	applied	\N	\N	\N	\N	120609	120609	288304
15054	18576	8	applied	\N	\N	\N	\N	120610	120610	288305
15054	18578	9	applied	\N	\N	\N	\N	120611	120611	288306
15054	18580	10	applied	\N	\N	\N	\N	120612	120612	288307
15054	18583	11	applied	\N	\N	\N	\N	120613	120613	288308
15054	18584	12	applied	\N	\N	\N	\N	120614	120614	288309
15054	18588	13	applied	\N	\N	\N	\N	120615	120615	288310
15054	18589	14	applied	\N	\N	\N	\N	120616	120616	288311
15054	18592	15	applied	\N	\N	\N	\N	120617	120617	288312
15054	18595	16	applied	\N	\N	\N	\N	120618	120618	288313
15054	18597	17	applied	\N	\N	\N	\N	120619	120619	288314
15054	18598	18	applied	\N	\N	\N	\N	120620	120620	288315
15054	18599	19	applied	\N	\N	\N	\N	120621	120621	288316
15054	18600	20	applied	\N	\N	\N	\N	120622	120622	288317
15054	18607	21	applied	\N	\N	\N	\N	120623	120623	288318
15054	18608	22	applied	\N	\N	\N	\N	120624	120624	288319
15054	18613	24	applied	\N	\N	\N	\N	120626	120626	288321
15054	18616	25	applied	\N	\N	\N	\N	120627	120627	288322
15054	18618	26	applied	\N	\N	\N	\N	120628	120628	288323
15054	18619	27	applied	\N	\N	\N	\N	120629	120629	288324
15054	18623	28	applied	\N	\N	\N	\N	120630	120630	288325
15054	18624	29	applied	\N	\N	\N	\N	120631	120631	288326
15054	18627	30	applied	\N	\N	\N	\N	120632	120632	288327
15054	18629	31	applied	\N	\N	\N	\N	120633	120633	288328
15054	18631	32	applied	\N	\N	\N	\N	120634	120634	288329
15054	18633	33	applied	\N	\N	\N	\N	120635	120635	288330
15054	18559	34	applied	\N	\N	\N	\N	120636	120636	288331
15054	18560	35	applied	\N	\N	\N	\N	120637	120637	288332
15054	18563	36	applied	\N	\N	\N	\N	120638	120638	288333
15054	18564	37	applied	\N	\N	\N	\N	120639	120639	288334
15054	18566	38	applied	\N	\N	\N	\N	120640	120640	288335
15054	18569	39	applied	\N	\N	\N	\N	120641	120641	288336
14925	18449	0	applied	\N	\N	\N	\N	120084	120084	287780
14951	18485	0	applied	\N	\N	\N	\N	120165	120165	287861
14951	18486	1	applied	\N	\N	\N	\N	120166	120166	287862
14951	18487	2	applied	\N	\N	\N	\N	120167	120167	287863
14951	18488	3	applied	\N	\N	\N	\N	120168	120168	287864
14951	18489	4	applied	\N	\N	\N	\N	120169	120169	287865
14957	18494	0	applied	\N	\N	\N	\N	120180	120180	287876
14957	18495	1	applied	\N	\N	\N	\N	120181	120181	287877
14957	18496	2	applied	\N	\N	\N	\N	120182	120182	287878
14961	18502	0	applied	\N	\N	\N	\N	120194	120194	287890
14961	18503	1	applied	\N	\N	\N	\N	120195	120195	287891
14966	18512	0	applied	\N	\N	\N	\N	120206	120206	287902
14971	18522	0	applied	\N	\N	\N	\N	120218	120218	287914
14971	18523	1	applied	\N	\N	\N	\N	120219	120219	287915
14977	18533	0	applied	\N	\N	\N	\N	120234	120234	287930
14977	18535	2	applied	\N	\N	\N	\N	120236	120236	287932
14979	18536	0	applied	\N	\N	\N	\N	120239	120239	287935
14979	18537	1	applied	\N	\N	\N	\N	120240	120240	287936
14983	18541	0	applied	\N	\N	\N	\N	120248	120248	287944
14991	18545	0	applied	\N	\N	\N	\N	120264	120264	287960
14991	18546	1	applied	\N	\N	\N	\N	120265	120265	287961
14991	18547	2	applied	\N	\N	\N	\N	120266	120266	287962
14992	18548	0	applied	\N	\N	\N	\N	120267	120267	287963
14992	18549	2	applied	\N	\N	\N	\N	120268	120268	287964
14997	18558	0	applied	\N	\N	\N	\N	120285	120285	287981
14997	18559	1	applied	\N	\N	\N	\N	120286	120286	287982
14997	18560	2	applied	\N	\N	\N	\N	120287	120287	287983
15002	18312	0	applied	\N	\N	1000000000	\N	120297	120297	287993
15002	18220	1	applied	\N	\N	\N	\N	120298	120298	287994
15002	18221	2	applied	\N	\N	\N	\N	120299	120299	287995
15002	18222	3	applied	\N	\N	\N	\N	120300	120300	287996
15002	18224	5	applied	\N	\N	\N	\N	120302	120302	287998
15002	18229	6	applied	\N	\N	\N	\N	120303	120303	287999
15002	18231	7	applied	\N	\N	\N	\N	120304	120304	288000
15002	18233	8	applied	\N	\N	\N	\N	120305	120305	288001
15002	18235	9	applied	\N	\N	\N	\N	120306	120306	288002
15002	18237	10	applied	\N	\N	\N	\N	120307	120307	288003
15002	18238	11	applied	\N	\N	\N	\N	120308	120308	288004
15002	18241	12	applied	\N	\N	\N	\N	120309	120309	288005
15002	18243	13	applied	\N	\N	\N	\N	120310	120310	288006
15002	18245	14	applied	\N	\N	\N	\N	120311	120311	288007
15002	18247	15	applied	\N	\N	\N	\N	120312	120312	288008
15002	18248	16	applied	\N	\N	\N	\N	120313	120313	288009
15002	18251	17	applied	\N	\N	\N	\N	120314	120314	288010
15002	18252	18	applied	\N	\N	\N	\N	120315	120315	288011
15002	18253	19	applied	\N	\N	\N	\N	120316	120316	288012
15002	18257	20	applied	\N	\N	\N	\N	120317	120317	288013
15002	18260	22	applied	\N	\N	\N	\N	120319	120319	288015
15002	18264	23	applied	\N	\N	\N	\N	120320	120320	288016
15002	18265	24	applied	\N	\N	\N	\N	120321	120321	288017
15002	18267	25	applied	\N	\N	\N	\N	120322	120322	288018
15002	18269	26	applied	\N	\N	\N	\N	120323	120323	288019
15002	18270	27	applied	\N	\N	\N	\N	120324	120324	288020
15002	18271	28	applied	\N	\N	\N	\N	120325	120325	288021
15002	18272	29	applied	\N	\N	\N	\N	120326	120326	288022
15002	18277	30	applied	\N	\N	\N	\N	120327	120327	288023
15002	18280	31	applied	\N	\N	\N	\N	120328	120328	288024
15002	18282	32	applied	\N	\N	\N	\N	120329	120329	288025
15002	18284	33	applied	\N	\N	\N	\N	120330	120330	288026
15002	18285	34	applied	\N	\N	\N	\N	120331	120331	288027
15002	18286	35	applied	\N	\N	\N	\N	120332	120332	288028
15002	18290	36	applied	\N	\N	\N	\N	120333	120333	288029
15002	18292	37	applied	\N	\N	\N	\N	120334	120334	288030
15002	18296	39	applied	\N	\N	\N	\N	120336	120336	288032
15002	18297	40	applied	\N	\N	\N	\N	120337	120337	288033
15002	18298	41	applied	\N	\N	\N	\N	120338	120338	288034
15002	18299	42	applied	\N	\N	\N	\N	120339	120339	288035
15002	18304	43	applied	\N	\N	\N	\N	120340	120340	288036
15002	18306	44	applied	\N	\N	\N	\N	120341	120341	288037
15002	18308	45	applied	\N	\N	\N	\N	120342	120342	288038
15002	18310	46	applied	\N	\N	\N	\N	120343	120343	288039
15002	18313	47	applied	\N	\N	\N	\N	120344	120344	288040
15002	18314	48	applied	\N	\N	\N	\N	120345	120345	288041
15002	18315	49	applied	\N	\N	\N	\N	120346	120346	288042
15002	18319	50	applied	\N	\N	\N	\N	120347	120347	288043
15002	18321	51	applied	\N	\N	\N	\N	120348	120348	288044
15002	18322	52	applied	\N	\N	\N	\N	120349	120349	288045
15002	18328	53	applied	\N	\N	\N	\N	120350	120350	288046
15002	18332	54	applied	\N	\N	\N	\N	120351	120351	288047
15002	18338	56	applied	\N	\N	\N	\N	120353	120353	288049
15002	18344	57	applied	\N	\N	\N	\N	120354	120354	288050
15002	18349	58	applied	\N	\N	\N	\N	120355	120355	288051
15002	18364	59	applied	\N	\N	\N	\N	120356	120356	288052
15002	18365	60	applied	\N	\N	\N	\N	120357	120357	288053
15002	18366	61	applied	\N	\N	\N	\N	120358	120358	288054
15002	18367	62	applied	\N	\N	\N	\N	120359	120359	288055
15002	18368	63	applied	\N	\N	\N	\N	120360	120360	288056
15002	18369	64	applied	\N	\N	\N	\N	120361	120361	288057
15002	18376	65	applied	\N	\N	\N	\N	120362	120362	288058
15002	18380	66	applied	\N	\N	\N	\N	120363	120363	288059
15002	18384	67	applied	\N	\N	\N	\N	120364	120364	288060
15002	18388	68	applied	\N	\N	\N	\N	120365	120365	288061
15002	18389	69	applied	\N	\N	\N	\N	120366	120366	288062
15002	18396	70	applied	\N	\N	\N	\N	120367	120367	288063
15002	18400	71	applied	\N	\N	\N	\N	120368	120368	288064
15002	18405	73	applied	\N	\N	\N	\N	120370	120370	288066
15002	18409	74	applied	\N	\N	\N	\N	120371	120371	288067
15002	18412	75	applied	\N	\N	\N	\N	120372	120372	288068
15002	18414	76	applied	\N	\N	\N	\N	120373	120373	288069
15002	18418	77	applied	\N	\N	\N	\N	120374	120374	288070
15002	18422	78	applied	\N	\N	\N	\N	120375	120375	288071
15002	18426	79	applied	\N	\N	\N	\N	120376	120376	288072
15002	18427	80	applied	\N	\N	\N	\N	120377	120377	288073
15002	18428	81	applied	\N	\N	\N	\N	120378	120378	288074
15002	18429	82	applied	\N	\N	\N	\N	120379	120379	288075
15002	18430	83	applied	\N	\N	\N	\N	120380	120380	288076
15002	18431	84	applied	\N	\N	\N	\N	120381	120381	288077
15002	18440	85	applied	\N	\N	\N	\N	120382	120382	288078
15002	18442	86	applied	\N	\N	\N	\N	120383	120383	288079
15054	18570	40	applied	\N	\N	\N	\N	120642	120642	288337
15054	18571	41	applied	\N	\N	\N	\N	120643	120643	288338
14949	18489	4	applied	\N	\N	\N	\N	120164	120164	287860
15002	18454	91	applied	\N	\N	\N	\N	120388	120388	288084
15002	18456	92	applied	\N	\N	\N	\N	120389	120389	288085
15002	18459	93	applied	\N	\N	\N	\N	120390	120390	288086
15002	18460	94	applied	\N	\N	\N	\N	120391	120391	288087
15002	18461	95	applied	\N	\N	\N	\N	120392	120392	288088
15002	18465	96	applied	\N	\N	\N	\N	120393	120393	288089
15002	18469	98	applied	\N	\N	\N	\N	120395	120395	288091
15002	18470	99	applied	\N	\N	\N	\N	120396	120396	288092
15002	18471	100	applied	\N	\N	\N	\N	120397	120397	288093
15002	18472	101	applied	\N	\N	\N	\N	120398	120398	288094
15002	18473	102	applied	\N	\N	\N	\N	120399	120399	288095
15002	18474	103	applied	\N	\N	\N	\N	120400	120400	288096
15002	18483	104	applied	\N	\N	\N	\N	120401	120401	288097
15002	18485	105	applied	\N	\N	\N	\N	120402	120402	288098
15002	18486	106	applied	\N	\N	\N	\N	120403	120403	288099
15002	18490	107	applied	\N	\N	\N	\N	120404	120404	288100
15002	18493	108	applied	\N	\N	\N	\N	120405	120405	288101
15002	18494	109	applied	\N	\N	\N	\N	120406	120406	288102
15002	18497	110	applied	\N	\N	\N	\N	120407	120407	288103
15002	18498	111	applied	\N	\N	\N	\N	120408	120408	288104
15002	18502	112	applied	\N	\N	\N	\N	120409	120409	288105
15002	18504	113	applied	\N	\N	\N	\N	120410	120410	288106
15002	18509	115	applied	\N	\N	\N	\N	120412	120412	288108
15002	18512	116	applied	\N	\N	\N	\N	120413	120413	288109
15002	18513	117	applied	\N	\N	\N	\N	120414	120414	288110
15002	18516	118	applied	\N	\N	\N	\N	120415	120415	288111
15002	18517	119	applied	\N	\N	\N	\N	120416	120416	288112
15002	18522	120	applied	\N	\N	\N	\N	120417	120417	288113
15002	18524	121	applied	\N	\N	\N	\N	120418	120418	288114
15002	18526	122	applied	\N	\N	\N	\N	120419	120419	288115
15002	18529	123	applied	\N	\N	\N	\N	120420	120420	288116
15002	18530	124	applied	\N	\N	\N	\N	120421	120421	288117
15002	18533	125	applied	\N	\N	\N	\N	120422	120422	288118
15004	18565	0	applied	\N	\N	\N	\N	120425	120425	288121
15004	18566	1	applied	\N	\N	\N	\N	120426	120426	288122
15011	18576	0	applied	\N	\N	\N	\N	120445	120445	288141
15011	18577	1	applied	\N	\N	\N	\N	120446	120446	288142
15014	18580	0	applied	\N	\N	\N	\N	120452	120452	288148
15014	18582	2	applied	\N	\N	\N	\N	120454	120454	288150
15016	18588	0	applied	\N	\N	\N	\N	120460	120460	288156
15019	18592	0	applied	\N	\N	\N	\N	120467	120467	288163
15019	18593	1	applied	\N	\N	\N	\N	120468	120468	288164
15019	18594	2	applied	\N	\N	\N	\N	120469	120469	288165
15021	18595	0	applied	\N	\N	\N	\N	120473	120473	288169
15021	18596	1	applied	\N	\N	\N	\N	120474	120474	288170
15023	18604	7	applied	\N	\N	\N	\N	120484	120484	288180
15023	18605	8	applied	\N	\N	\N	\N	120485	120485	288181
15023	18606	9	applied	\N	\N	\N	\N	120486	120486	288182
15024	18601	4	applied	\N	\N	\N	\N	120491	120491	288187
15024	18602	5	applied	\N	\N	\N	\N	120492	120492	288188
15024	18603	6	applied	\N	\N	\N	\N	120493	120493	288189
15024	18604	7	applied	\N	\N	\N	\N	120494	120494	288190
15024	18605	8	applied	\N	\N	\N	\N	120495	120495	288191
15024	18606	9	applied	\N	\N	\N	\N	120496	120496	288192
15026	18608	0	applied	\N	\N	\N	\N	120498	120498	288194
15026	18609	1	applied	\N	\N	\N	\N	120499	120499	288195
15026	18610	2	applied	\N	\N	\N	\N	120500	120500	288196
15028	18608	0	applied	\N	\N	\N	\N	120504	120504	288200
15028	18609	1	applied	\N	\N	\N	\N	120505	120505	288201
15028	18610	2	applied	\N	\N	\N	\N	120506	120506	288202
15030	18613	0	applied	\N	\N	\N	\N	120509	120509	288205
15030	18614	1	applied	\N	\N	\N	\N	120510	120510	288206
15030	18615	2	applied	\N	\N	\N	\N	120511	120511	288207
15031	18312	0	applied	\N	\N	1000000000	\N	120512	120512	288208
15031	18346	1	applied	\N	\N	\N	\N	120513	120513	288209
15031	18326	3	applied	\N	\N	\N	\N	120515	120515	288210
15032	18616	0	applied	\N	\N	\N	\N	120516	120516	288211
15032	18617	1	applied	\N	\N	\N	\N	120517	120517	288212
15033	18574	0	applied	\N	\N	\N	\N	120518	120518	288213
15033	18576	1	applied	\N	\N	\N	\N	120519	120519	288214
15033	18578	2	applied	\N	\N	\N	\N	120520	120520	288215
15033	18580	3	applied	\N	\N	\N	\N	120521	120521	288216
15033	18583	4	applied	\N	\N	\N	\N	120522	120522	288217
15033	18584	5	applied	\N	\N	\N	\N	120523	120523	288218
15033	18588	6	applied	\N	\N	\N	\N	120524	120524	288219
15033	18589	7	applied	\N	\N	\N	\N	120525	120525	288220
15033	18592	8	applied	\N	\N	\N	\N	120526	120526	288221
15033	18595	9	applied	\N	\N	\N	\N	120527	120527	288222
15033	18597	10	applied	\N	\N	\N	\N	120528	120528	288223
15033	18598	11	applied	\N	\N	\N	\N	120529	120529	288224
15033	18599	12	applied	\N	\N	\N	\N	120530	120530	288225
15033	18600	13	applied	\N	\N	\N	\N	120531	120531	288226
15033	18607	14	applied	\N	\N	\N	\N	120532	120532	288227
15036	18623	0	applied	\N	\N	\N	\N	120572	120572	288267
15038	18623	0	applied	\N	\N	\N	\N	120574	120574	288269
15039	18623	0	applied	\N	\N	\N	\N	120575	120575	288270
15040	18624	0	applied	\N	\N	\N	\N	120576	120576	288271
15040	18625	2	applied	\N	\N	\N	\N	120577	120577	288272
15040	18626	3	applied	\N	\N	\N	\N	120578	120578	288273
15042	18624	0	applied	\N	\N	\N	\N	120582	120582	288277
15042	18625	2	applied	\N	\N	\N	\N	120583	120583	288278
15042	18626	3	applied	\N	\N	\N	\N	120584	120584	288279
15047	18631	0	applied	\N	\N	\N	\N	120594	120594	288289
15047	18632	1	applied	\N	\N	\N	\N	120595	120595	288290
15055	18634	0	applied	\N	\N	\N	\N	120678	120678	288373
15055	18635	1	applied	\N	\N	\N	\N	120679	120679	288374
15056	18636	0	applied	\N	\N	\N	\N	120680	120680	288375
15056	18637	1	applied	\N	\N	\N	\N	120681	120681	288376
15056	18638	2	applied	\N	\N	\N	\N	120682	120682	288377
15058	18639	0	applied	\N	\N	\N	\N	120686	120686	288381
15058	18640	1	applied	\N	\N	\N	\N	120687	120687	288382
15060	18641	0	applied	\N	\N	\N	\N	120690	120690	288385
15060	18642	1	applied	\N	\N	\N	\N	120691	120691	288386
15060	18643	2	applied	\N	\N	\N	\N	120692	120692	288387
15060	18644	3	applied	\N	\N	\N	\N	120693	120693	288388
15063	18641	0	applied	\N	\N	\N	\N	120702	120702	288397
15063	18642	1	applied	\N	\N	\N	\N	120703	120703	288398
15063	18643	2	applied	\N	\N	\N	\N	120704	120704	288399
15063	18644	3	applied	\N	\N	\N	\N	120705	120705	288400
15002	18448	88	applied	\N	\N	\N	\N	120385	120385	288081
15002	18452	90	applied	\N	\N	\N	\N	120387	120387	288083
15033	18575	19	applied	\N	\N	\N	\N	120537	120537	288232
15033	18577	20	applied	\N	\N	\N	\N	120538	120538	288233
15033	18579	21	applied	\N	\N	\N	\N	120539	120539	288234
15033	18581	22	applied	\N	\N	\N	\N	120540	120540	288235
15033	18582	23	applied	\N	\N	\N	\N	120541	120541	288236
15033	18585	24	applied	\N	\N	\N	\N	120542	120542	288237
15033	18586	25	applied	\N	\N	\N	\N	120543	120543	288238
15033	18587	26	applied	\N	\N	\N	\N	120544	120544	288239
15033	18590	27	applied	\N	\N	\N	\N	120545	120545	288240
15033	18591	28	applied	\N	\N	\N	\N	120546	120546	288241
15033	18593	29	applied	\N	\N	\N	\N	120547	120547	288242
15033	18594	30	applied	\N	\N	\N	\N	120548	120548	288243
15033	18596	31	applied	\N	\N	\N	\N	120549	120549	288244
15033	18601	32	applied	\N	\N	\N	\N	120550	120550	288245
15033	18602	33	applied	\N	\N	\N	\N	120551	120551	288246
15033	18603	34	applied	\N	\N	\N	\N	120552	120552	288247
15033	18605	36	applied	\N	\N	\N	\N	120554	120554	288249
15033	18606	37	applied	\N	\N	\N	\N	120555	120555	288250
15033	18609	38	applied	\N	\N	\N	\N	120556	120556	288251
15033	18610	39	applied	\N	\N	\N	\N	120557	120557	288252
15033	18612	40	applied	\N	\N	\N	\N	120558	120558	288253
15033	18614	41	applied	\N	\N	\N	\N	120559	120559	288254
15033	18615	42	applied	\N	\N	\N	\N	120560	120560	288255
15033	18617	43	applied	\N	\N	\N	\N	120561	120561	288256
15035	18618	0	applied	\N	\N	\N	\N	120567	120567	288262
15035	18619	1	applied	\N	\N	\N	\N	120568	120568	288263
15035	18620	2	applied	\N	\N	\N	\N	120569	120569	288264
15035	18621	3	applied	\N	\N	\N	\N	120570	120570	288265
15035	18622	4	applied	\N	\N	\N	\N	120571	120571	288266
15043	18624	0	applied	\N	\N	\N	\N	120585	120585	288280
15043	18625	2	applied	\N	\N	\N	\N	120586	120586	288281
15043	18626	3	applied	\N	\N	\N	\N	120587	120587	288282
15044	18628	1	applied	\N	\N	\N	\N	120589	120589	288284
15046	18629	0	applied	\N	\N	\N	\N	120592	120592	288287
15046	18630	1	applied	\N	\N	\N	\N	120593	120593	288288
15049	18631	0	applied	\N	\N	\N	\N	120598	120598	288293
15049	18632	1	applied	\N	\N	\N	\N	120599	120599	288294
15051	18633	0	applied	\N	\N	\N	\N	120601	120601	288296
15054	18573	42	applied	\N	\N	\N	\N	120644	120644	288339
15054	18575	43	applied	\N	\N	\N	\N	120645	120645	288340
15054	18577	44	applied	\N	\N	\N	\N	120646	120646	288341
15054	18579	45	applied	\N	\N	\N	\N	120647	120647	288342
15054	18581	46	applied	\N	\N	\N	\N	120648	120648	288343
15054	18582	47	applied	\N	\N	\N	\N	120649	120649	288344
15054	18585	48	applied	\N	\N	\N	\N	120650	120650	288345
15054	18586	49	applied	\N	\N	\N	\N	120651	120651	288346
15054	18587	50	applied	\N	\N	\N	\N	120652	120652	288347
15054	18590	51	applied	\N	\N	\N	\N	120653	120653	288348
15054	18593	53	applied	\N	\N	\N	\N	120655	120655	288350
15054	18594	54	applied	\N	\N	\N	\N	120656	120656	288351
15054	18596	55	applied	\N	\N	\N	\N	120657	120657	288352
15054	18601	56	applied	\N	\N	\N	\N	120658	120658	288353
15054	18602	57	applied	\N	\N	\N	\N	120659	120659	288354
15054	18603	58	applied	\N	\N	\N	\N	120660	120660	288355
15054	18604	59	applied	\N	\N	\N	\N	120661	120661	288356
15054	18605	60	applied	\N	\N	\N	\N	120662	120662	288357
15054	18606	61	applied	\N	\N	\N	\N	120663	120663	288358
15054	18609	62	applied	\N	\N	\N	\N	120664	120664	288359
15054	18610	63	applied	\N	\N	\N	\N	120665	120665	288360
15054	18612	64	applied	\N	\N	\N	\N	120666	120666	288361
15054	18614	65	applied	\N	\N	\N	\N	120667	120667	288362
15054	18615	66	applied	\N	\N	\N	\N	120668	120668	288363
15054	18617	67	applied	\N	\N	\N	\N	120669	120669	288364
15054	18620	68	applied	\N	\N	\N	\N	120670	120670	288365
15054	18622	70	applied	\N	\N	\N	\N	120672	120672	288367
15054	18625	71	applied	\N	\N	\N	\N	120673	120673	288368
15054	18626	72	applied	\N	\N	\N	\N	120674	120674	288369
15054	18628	73	applied	\N	\N	\N	\N	120675	120675	288370
15054	18630	74	applied	\N	\N	\N	\N	120676	120676	288371
15054	18632	75	applied	\N	\N	\N	\N	120677	120677	288372
15057	18636	0	applied	\N	\N	\N	\N	120683	120683	288378
15057	18637	1	applied	\N	\N	\N	\N	120684	120684	288379
15057	18638	2	applied	\N	\N	\N	\N	120685	120685	288380
15059	18639	0	applied	\N	\N	\N	\N	120688	120688	288383
15059	18640	1	applied	\N	\N	\N	\N	120689	120689	288384
15061	18641	0	applied	\N	\N	\N	\N	120694	120694	288389
15061	18642	1	applied	\N	\N	\N	\N	120695	120695	288390
15061	18643	2	applied	\N	\N	\N	\N	120696	120696	288391
15061	18644	3	applied	\N	\N	\N	\N	120697	120697	288392
15062	18641	0	applied	\N	\N	\N	\N	120698	120698	288393
15062	18643	2	applied	\N	\N	\N	\N	120700	120700	288395
15062	18644	3	applied	\N	\N	\N	\N	120701	120701	288396
15064	18641	0	applied	\N	\N	\N	\N	120706	120706	288401
15064	18642	1	applied	\N	\N	\N	\N	120707	120707	288402
15064	18643	2	applied	\N	\N	\N	\N	120708	120708	288403
15064	18644	3	applied	\N	\N	\N	\N	120709	120709	288404
15065	18645	0	applied	\N	\N	\N	\N	120710	120710	288405
15065	18646	1	applied	\N	\N	\N	\N	120711	120711	288406
15066	18645	0	applied	\N	\N	\N	\N	120712	120712	288407
15066	18646	1	applied	\N	\N	\N	\N	120713	120713	288408
15067	18647	0	applied	\N	\N	\N	\N	120714	120714	288409
15067	18648	1	applied	\N	\N	\N	\N	120715	120715	288410
15068	18647	0	applied	\N	\N	\N	\N	120716	120716	288411
15068	18648	1	applied	\N	\N	\N	\N	120717	120717	288412
15069	18649	0	applied	\N	\N	\N	\N	120718	120718	288413
15070	18649	0	applied	\N	\N	\N	\N	120719	120719	288414
15072	18650	0	applied	\N	\N	\N	\N	120721	120721	288416
15073	18651	0	applied	\N	\N	\N	\N	120722	120722	288417
15074	18652	0	applied	\N	\N	\N	\N	120723	120723	288418
15074	18653	1	applied	\N	\N	\N	\N	120724	120724	288419
15075	18654	0	applied	\N	\N	\N	\N	120725	120725	288420
15075	18655	1	applied	\N	\N	\N	\N	120726	120726	288421
15076	18656	0	applied	\N	\N	\N	\N	120727	120727	288422
15077	18657	0	applied	\N	\N	\N	\N	120728	120728	288423
15077	18658	1	applied	\N	\N	\N	\N	120729	120729	288424
15077	18659	2	applied	\N	\N	\N	\N	120730	120730	288425
15077	18660	3	applied	\N	\N	\N	\N	120731	120731	288426
15077	18661	4	applied	\N	\N	\N	\N	120732	120732	288427
15078	18657	0	applied	\N	\N	\N	\N	120733	120733	288428
15078	18658	1	applied	\N	\N	\N	\N	120734	120734	288429
15033	18611	16	applied	\N	\N	\N	\N	120534	120534	288229
15033	18613	17	applied	\N	\N	\N	\N	120535	120535	288230
15079	18657	0	applied	\N	\N	\N	\N	120738	120738	288433
15079	18658	1	applied	\N	\N	\N	\N	120739	120739	288434
15079	18659	2	applied	\N	\N	\N	\N	120740	120740	288435
15079	18660	3	applied	\N	\N	\N	\N	120741	120741	288436
15079	18661	4	applied	\N	\N	\N	\N	120742	120742	288437
15080	18663	1	applied	\N	\N	\N	\N	120744	120744	288439
15080	18664	2	applied	\N	\N	\N	\N	120745	120745	288440
15081	18665	0	applied	\N	\N	\N	\N	120746	120746	288441
15081	18666	1	applied	\N	\N	\N	\N	120747	120747	288442
15081	18667	2	applied	\N	\N	\N	\N	120748	120748	288443
15082	18665	0	applied	\N	\N	\N	\N	120749	120749	288444
15082	18666	1	applied	\N	\N	\N	\N	120750	120750	288445
15082	18667	2	applied	\N	\N	\N	\N	120751	120751	288446
15083	18668	0	applied	\N	\N	\N	\N	120752	120752	288447
15083	18669	1	applied	\N	\N	\N	\N	120753	120753	288448
15084	18670	0	applied	\N	\N	\N	\N	120754	120754	288449
15084	18671	1	applied	\N	\N	\N	\N	120755	120755	288450
15085	18672	0	applied	\N	\N	\N	\N	120756	120756	288451
15086	18673	0	applied	\N	\N	\N	\N	120757	120757	288452
15086	18674	1	applied	\N	\N	\N	\N	120758	120758	288453
15087	18673	0	applied	\N	\N	\N	\N	120759	120759	288454
15088	18675	0	applied	\N	\N	\N	\N	120761	120761	288456
15089	18675	0	applied	\N	\N	\N	\N	120762	120762	288457
15090	18676	0	applied	\N	\N	\N	\N	120763	120763	288458
15090	18677	1	applied	\N	\N	\N	\N	120764	120764	288459
15091	18678	0	applied	\N	\N	\N	\N	120765	120765	288460
15091	18679	1	applied	\N	\N	\N	\N	120766	120766	288461
15094	18680	0	applied	\N	\N	\N	\N	120767	120767	288462
15095	18680	0	applied	\N	\N	\N	\N	120768	120768	288463
15096	18680	0	applied	\N	\N	\N	\N	120769	120769	288464
15098	18681	0	applied	\N	\N	\N	\N	120770	120770	288465
15099	18682	0	applied	\N	\N	\N	\N	120771	120771	288466
15099	18683	1	applied	\N	\N	\N	\N	120772	120772	288467
15100	18682	0	applied	\N	\N	\N	\N	120773	120773	288468
15100	18683	1	applied	\N	\N	\N	\N	120774	120774	288469
15103	18684	0	applied	\N	\N	\N	\N	120775	120775	288470
15103	18685	1	applied	\N	\N	\N	\N	120776	120776	288471
15104	18687	0	applied	\N	\N	\N	\N	120778	120778	288473
15105	18688	0	applied	\N	\N	\N	\N	120779	120779	288474
15105	18689	1	applied	\N	\N	\N	\N	120780	120780	288475
15106	18688	0	applied	\N	\N	\N	\N	120781	120781	288476
15106	18690	1	applied	\N	\N	\N	\N	120782	120782	288477
15106	18689	2	applied	\N	\N	\N	\N	120783	120783	288478
15106	18691	3	applied	\N	\N	\N	\N	120784	120784	288479
15106	18692	4	applied	\N	\N	1000000000	\N	120785	120785	288480
15106	18693	5	applied	\N	\N	1000000000	\N	120786	120786	288481
15106	18694	6	applied	\N	\N	1000000000	\N	120787	120787	288482
15106	18695	7	applied	\N	\N	\N	\N	120788	120788	288483
15109	18690	0	applied	\N	\N	\N	\N	120801	120801	288496
15109	18691	1	applied	\N	\N	\N	\N	120802	120802	288497
15109	18692	2	applied	\N	\N	1000000000	\N	120803	120803	288498
15109	18694	4	applied	\N	\N	1000000000	\N	120805	120805	288500
15109	18695	5	applied	\N	\N	\N	\N	120806	120806	288501
15111	18698	0	applied	\N	\N	\N	\N	120809	120809	288504
15111	18699	1	applied	\N	\N	\N	\N	120810	120810	288505
15111	18700	2	applied	\N	\N	\N	\N	120811	120811	288506
15111	18701	3	applied	\N	\N	\N	\N	120812	120812	288507
15114	18705	0	applied	\N	\N	\N	\N	120816	120816	288511
15114	18706	1	applied	\N	\N	\N	\N	120817	120817	288512
15114	18707	2	applied	\N	\N	\N	\N	120818	120818	288513
15117	18712	0	applied	\N	\N	\N	\N	120823	120823	288518
15125	18717	0	applied	\N	\N	\N	\N	120835	120835	288530
15129	18723	0	applied	\N	\N	\N	\N	120844	120844	288539
15129	18724	1	applied	\N	\N	\N	\N	120845	120845	288540
15129	18725	2	applied	\N	\N	\N	\N	120846	120846	288541
15129	18726	3	applied	\N	\N	\N	\N	120847	120847	288542
15129	18727	4	applied	\N	\N	\N	\N	120848	120848	288543
15138	18737	0	applied	\N	\N	\N	\N	120866	120866	288561
15138	18738	1	applied	\N	\N	\N	\N	120867	120867	288562
15140	18739	0	applied	\N	\N	\N	\N	120870	120870	288565
15140	18740	1	applied	\N	\N	\N	\N	120871	120871	288566
15148	18752	1	applied	\N	\N	\N	\N	120913	120913	288608
15148	18753	2	applied	\N	\N	\N	\N	120914	120914	288609
15148	18754	3	applied	\N	\N	\N	\N	120915	120915	288610
15148	18755	4	applied	\N	\N	\N	\N	120916	120916	288611
15148	18756	5	applied	\N	\N	\N	\N	120917	120917	288612
15153	18763	0	applied	\N	\N	\N	\N	120936	120936	288631
15153	18764	1	applied	\N	\N	\N	\N	120937	120937	288632
15155	18765	0	applied	\N	\N	\N	\N	120939	120939	288634
15155	18766	1	applied	\N	\N	\N	\N	120940	120940	288635
15158	18769	0	applied	\N	\N	\N	\N	120945	120945	288640
15158	18770	1	applied	\N	\N	\N	\N	120946	120946	288641
15158	18771	2	applied	\N	\N	\N	\N	120947	120947	288642
15165	18777	0	applied	\N	\N	\N	\N	120959	120959	288654
15165	18778	1	applied	\N	\N	\N	\N	120960	120960	288655
15165	18779	2	applied	\N	\N	\N	\N	120961	120961	288656
15168	18780	0	applied	\N	\N	\N	\N	120969	120969	288664
15168	18782	2	applied	\N	\N	\N	\N	120971	120971	288666
15168	18783	3	applied	\N	\N	\N	\N	120972	120972	288667
15176	18785	0	applied	\N	\N	\N	\N	120995	120995	288690
15176	18786	1	applied	\N	\N	\N	\N	120996	120996	288691
15176	18787	2	applied	\N	\N	\N	\N	120997	120997	288692
15178	18788	0	applied	\N	\N	\N	\N	121001	121001	288696
15178	18789	1	applied	\N	\N	\N	\N	121002	121002	288697
15178	18790	2	applied	\N	\N	\N	\N	121003	121003	288698
15183	18797	0	applied	\N	\N	\N	\N	121022	121022	288717
15183	18798	1	applied	\N	\N	\N	\N	121023	121023	288718
15183	18799	2	applied	\N	\N	\N	\N	121024	121024	288719
15193	18818	0	applied	\N	\N	\N	\N	121061	121061	288754
15193	18819	1	applied	\N	\N	\N	\N	121062	121062	288755
15193	18820	2	applied	\N	\N	\N	\N	121063	121063	288756
15200	18825	0	applied	\N	\N	\N	\N	121152	121152	288845
15200	18826	1	applied	\N	\N	\N	\N	121153	121153	288846
15202	18828	0	applied	\N	\N	\N	\N	121157	121157	288850
15202	18829	1	applied	\N	\N	\N	\N	121158	121158	288851
15209	18833	0	applied	\N	\N	\N	\N	121177	121177	288870
15209	18834	1	applied	\N	\N	\N	\N	121178	121178	288871
15209	18835	2	applied	\N	\N	\N	\N	121179	121179	288872
15209	18836	3	applied	\N	\N	\N	\N	121180	121180	288873
15078	18660	3	applied	\N	\N	\N	\N	120736	120736	288431
15078	18661	4	applied	\N	\N	\N	\N	120737	120737	288432
15107	18694	4	applied	\N	\N	1000000000	\N	120793	120793	288488
15107	18695	5	applied	\N	\N	\N	\N	120794	120794	288489
15110	18696	0	applied	\N	\N	\N	\N	120807	120807	288502
15110	18697	1	applied	\N	\N	\N	\N	120808	120808	288503
15115	18708	0	applied	\N	\N	\N	\N	120819	120819	288514
15119	18713	0	applied	\N	\N	\N	\N	120826	120826	288521
15119	18714	1	applied	\N	\N	\N	\N	120827	120827	288522
15122	18717	0	applied	\N	\N	\N	\N	120832	120832	288527
15124	18717	0	applied	\N	\N	\N	\N	120834	120834	288529
15130	18723	0	applied	\N	\N	\N	\N	120849	120849	288544
15130	18724	1	applied	\N	\N	\N	\N	120850	120850	288545
15130	18726	3	applied	\N	\N	\N	\N	120852	120852	288547
15130	18727	4	applied	\N	\N	\N	\N	120853	120853	288548
15133	18731	0	applied	\N	\N	\N	\N	120857	120857	288552
15133	18732	1	applied	\N	\N	\N	\N	120858	120858	288553
15139	18737	0	applied	\N	\N	\N	\N	120868	120868	288563
15139	18738	1	applied	\N	\N	\N	\N	120869	120869	288564
15142	18741	0	applied	\N	\N	\N	\N	120873	120873	288568
15150	18757	0	applied	\N	\N	\N	\N	120924	120924	288619
15150	18758	1	applied	\N	\N	\N	\N	120925	120925	288620
15150	18759	2	applied	\N	\N	\N	\N	120926	120926	288621
15150	18760	3	applied	\N	\N	\N	\N	120927	120927	288622
15150	18761	4	applied	\N	\N	\N	\N	120928	120928	288623
15150	18762	6	applied	\N	\N	\N	\N	120929	120929	288624
15154	18764	0	applied	\N	\N	\N	\N	120938	120938	288633
15156	18765	0	applied	\N	\N	\N	\N	120941	120941	288636
15156	18766	1	applied	\N	\N	\N	\N	120942	120942	288637
15159	18770	1	applied	\N	\N	\N	\N	120949	120949	288644
15159	18771	2	applied	\N	\N	\N	\N	120950	120950	288645
15161	18772	0	applied	\N	\N	1000000000	\N	120955	120955	288650
15163	18776	0	applied	\N	\N	\N	\N	120957	120957	288652
15169	18780	0	applied	\N	\N	\N	\N	120973	120973	288668
15169	18781	1	applied	\N	\N	\N	\N	120974	120974	288669
15169	18782	2	applied	\N	\N	\N	\N	120975	120975	288670
15169	18783	3	applied	\N	\N	\N	\N	120976	120976	288671
15172	18780	0	applied	\N	\N	\N	\N	120985	120985	288680
15172	18781	1	applied	\N	\N	\N	\N	120986	120986	288681
15172	18782	2	applied	\N	\N	\N	\N	120987	120987	288682
15172	18783	3	applied	\N	\N	\N	\N	120988	120988	288683
15174	18784	0	applied	\N	\N	\N	\N	120993	120993	288688
15181	18791	0	applied	\N	\N	1000000000	\N	121013	121013	288708
15181	18792	1	applied	\N	\N	\N	\N	121014	121014	288709
15181	18793	2	applied	\N	\N	\N	\N	121015	121015	288710
15181	18795	4	applied	\N	\N	\N	\N	121017	121017	288712
15181	18796	5	applied	\N	\N	\N	\N	121018	121018	288713
15186	18800	0	applied	\N	\N	\N	\N	121030	121030	288725
15186	18801	1	applied	\N	\N	\N	\N	121031	121031	288726
15188	18802	0	applied	\N	\N	\N	\N	121034	121034	288729
15189	18803	0	applied	\N	\N	\N	\N	121035	121035	288730
15189	18804	1	applied	\N	\N	\N	\N	121036	121036	288731
15189	18805	2	applied	\N	\N	\N	\N	121037	121037	288732
15189	18807	4	applied	\N	\N	\N	\N	121039	121039	288733
15189	18806	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	121038	121038	\N
15189	18808	5	applied	\N	\N	\N	\N	121040	121040	288734
15189	18809	6	applied	\N	\N	\N	\N	121041	121041	288735
15189	18810	7	applied	\N	\N	\N	\N	121042	121042	288736
15189	18811	8	applied	\N	\N	\N	\N	121043	121043	288737
15189	18812	9	applied	\N	\N	\N	\N	121044	121044	288738
15189	18813	10	applied	\N	\N	\N	\N	121045	121045	288739
15191	18814	0	applied	\N	\N	\N	\N	121057	121057	288750
15191	18815	1	applied	\N	\N	\N	\N	121058	121058	288751
15196	18744	1	applied	\N	\N	\N	\N	121070	121070	288763
15216	18844	0	applied	\N	\N	\N	\N	121194	121194	288887
15216	18845	1	applied	\N	\N	\N	\N	121195	121195	288888
15225	18858	0	applied	\N	\N	\N	\N	121227	121227	288920
15225	18859	1	applied	\N	\N	\N	\N	121228	121228	288921
15225	18860	2	applied	\N	\N	\N	\N	121229	121229	288922
15227	18858	0	applied	\N	\N	\N	\N	121233	121233	288926
15227	18859	1	applied	\N	\N	\N	\N	121234	121234	288927
15227	18860	2	applied	\N	\N	\N	\N	121235	121235	288928
15229	18861	0	applied	\N	\N	\N	\N	121237	121237	288930
15236	18868	0	applied	\N	\N	\N	\N	121253	121253	288946
15236	18869	1	applied	\N	\N	\N	\N	121254	121254	288947
15238	18868	0	applied	\N	\N	\N	\N	121257	121257	288950
15238	18869	1	applied	\N	\N	\N	\N	121258	121258	288951
15241	18874	0	applied	\N	\N	\N	\N	121263	121263	288956
15241	18875	1	applied	\N	\N	\N	\N	121264	121264	288957
15241	18876	2	applied	\N	\N	\N	\N	121265	121265	288958
15241	18877	3	applied	\N	\N	\N	\N	121266	121266	288959
15241	18879	5	applied	\N	\N	\N	\N	121268	121268	288961
15241	18880	6	applied	\N	\N	\N	\N	121269	121269	288962
15247	18893	0	applied	\N	\N	\N	\N	121284	121284	288977
15247	18894	1	applied	\N	\N	\N	\N	121285	121285	288978
15247	18895	2	applied	\N	\N	\N	\N	121286	121286	288979
15247	18896	3	applied	\N	\N	\N	\N	121287	121287	288980
15247	18897	4	applied	\N	\N	\N	\N	121288	121288	288981
15247	18898	5	applied	\N	\N	\N	\N	121289	121289	288982
15247	18899	6	applied	\N	\N	\N	\N	121290	121290	288983
15252	18905	0	applied	\N	\N	\N	\N	121306	121306	288999
15252	18906	1	applied	\N	\N	\N	\N	121307	121307	289000
15252	18907	2	applied	\N	\N	\N	\N	121308	121308	289001
15252	18908	3	applied	\N	\N	\N	\N	121309	121309	289002
15254	18905	0	applied	\N	\N	\N	\N	121314	121314	289007
15254	18906	1	applied	\N	\N	\N	\N	121315	121315	289008
15254	18907	2	applied	\N	\N	\N	\N	121316	121316	289009
15257	18909	0	applied	\N	\N	\N	\N	121332	121332	289025
15257	18910	1	applied	\N	\N	\N	\N	121333	121333	289026
15257	18911	2	applied	\N	\N	\N	\N	121334	121334	289027
15257	18912	3	applied	\N	\N	\N	\N	121335	121335	289028
15257	18913	4	applied	\N	\N	\N	\N	121336	121336	289029
15257	18914	5	applied	\N	\N	\N	\N	121337	121337	289030
15257	18915	6	applied	\N	\N	\N	\N	121338	121338	289031
15257	18916	7	applied	\N	\N	\N	\N	121339	121339	289032
15257	18917	8	applied	\N	\N	\N	\N	121340	121340	289033
15257	18918	10	applied	\N	\N	\N	\N	121341	121341	289034
15264	18927	0	applied	\N	\N	\N	\N	121365	121365	289058
15269	18928	0	applied	\N	\N	\N	\N	121378	121378	289071
15269	18929	1	applied	\N	\N	\N	\N	121379	121379	289072
15107	18691	1	applied	\N	\N	\N	\N	120790	120790	288485
15107	18693	3	applied	\N	\N	1000000000	\N	120792	120792	288487
15108	18693	3	applied	\N	\N	1000000000	\N	120798	120798	288493
15108	18694	4	applied	\N	\N	1000000000	\N	120799	120799	288494
15108	18695	5	applied	\N	\N	\N	\N	120800	120800	288495
15116	18709	0	applied	\N	\N	\N	\N	120820	120820	288515
15116	18710	1	applied	\N	\N	\N	\N	120821	120821	288516
15116	18711	2	applied	\N	\N	\N	\N	120822	120822	288517
15120	18713	0	applied	\N	\N	\N	\N	120828	120828	288523
15121	18715	0	applied	\N	\N	\N	\N	120830	120830	288525
15121	18716	1	applied	\N	\N	\N	\N	120831	120831	288526
15126	18718	0	applied	\N	\N	\N	\N	120836	120836	288531
15126	18719	1	applied	\N	\N	\N	\N	120837	120837	288532
15126	18720	2	applied	\N	\N	\N	\N	120838	120838	288533
15127	18709	0	applied	\N	\N	\N	\N	120839	120839	288534
15127	18710	1	applied	\N	\N	\N	\N	120840	120840	288535
15127	18711	2	applied	\N	\N	\N	\N	120841	120841	288536
15131	18728	0	applied	\N	\N	\N	\N	120854	120854	288549
15134	18733	0	applied	\N	\N	\N	\N	120859	120859	288554
15134	18734	1	applied	\N	\N	\N	\N	120860	120860	288555
15134	18735	2	applied	\N	\N	\N	\N	120861	120861	288556
15137	18736	0	applied	\N	\N	\N	\N	120865	120865	288560
15144	18742	0	applied	\N	\N	\N	\N	120875	120875	288570
15144	18743	1	applied	\N	\N	\N	\N	120876	120876	288571
15146	18718	0	applied	\N	\N	\N	\N	120879	120879	288574
15146	18721	2	applied	\N	\N	\N	\N	120881	120881	288576
15146	18723	3	applied	\N	\N	\N	\N	120882	120882	288577
15146	18724	4	applied	\N	\N	\N	\N	120883	120883	288578
15146	18725	5	applied	\N	\N	\N	\N	120884	120884	288579
15146	18728	6	applied	\N	\N	\N	\N	120885	120885	288580
15146	18729	7	applied	\N	\N	\N	\N	120886	120886	288581
15146	18731	8	applied	\N	\N	\N	\N	120887	120887	288582
15146	18733	9	applied	\N	\N	\N	\N	120888	120888	288583
15146	18734	10	applied	\N	\N	\N	\N	120889	120889	288584
15146	18736	11	applied	\N	\N	\N	\N	120890	120890	288585
15146	18737	12	applied	\N	\N	\N	\N	120891	120891	288586
15146	18739	13	applied	\N	\N	\N	\N	120892	120892	288587
15146	18741	14	applied	\N	\N	\N	\N	120893	120893	288588
15146	18742	15	applied	\N	\N	\N	\N	120894	120894	288589
15146	18720	16	applied	\N	\N	\N	\N	120895	120895	288590
15146	18722	17	applied	\N	\N	\N	\N	120896	120896	288591
15146	18727	19	applied	\N	\N	\N	\N	120898	120898	288593
15146	18730	20	applied	\N	\N	\N	\N	120899	120899	288594
15146	18732	21	applied	\N	\N	\N	\N	120900	120900	288595
15146	18735	22	applied	\N	\N	\N	\N	120901	120901	288596
15146	18738	23	applied	\N	\N	\N	\N	120902	120902	288597
15146	18740	24	applied	\N	\N	\N	\N	120903	120903	288598
15146	18743	25	applied	\N	\N	\N	\N	120904	120904	288599
15147	18744	0	applied	\N	\N	\N	\N	120905	120905	288600
15147	18745	1	applied	\N	\N	\N	\N	120906	120906	288601
15147	18746	2	applied	\N	\N	\N	\N	120907	120907	288602
15147	18747	3	applied	\N	\N	\N	\N	120908	120908	288603
15147	18748	4	applied	\N	\N	\N	\N	120909	120909	288604
15147	18749	5	applied	\N	\N	1000000000	\N	120910	120910	288605
15147	18750	6	applied	\N	\N	\N	\N	120911	120911	288606
15157	18767	0	applied	\N	\N	\N	\N	120943	120943	288638
15157	18768	1	applied	\N	\N	\N	\N	120944	120944	288639
15166	18778	1	applied	\N	\N	\N	\N	120963	120963	288658
15166	18779	2	applied	\N	\N	\N	\N	120964	120964	288659
15177	18785	0	applied	\N	\N	\N	\N	120998	120998	288693
15177	18786	1	applied	\N	\N	\N	\N	120999	120999	288694
15177	18787	2	applied	\N	\N	\N	\N	121000	121000	288695
15179	18788	0	applied	\N	\N	\N	\N	121004	121004	288699
15179	18789	1	applied	\N	\N	\N	\N	121005	121005	288700
15179	18790	2	applied	\N	\N	\N	\N	121006	121006	288701
15182	18797	0	applied	\N	\N	\N	\N	121019	121019	288714
15196	18745	2	applied	\N	\N	\N	\N	121071	121071	288764
15196	18746	3	applied	\N	\N	\N	\N	121072	121072	288765
15196	18751	4	applied	\N	\N	\N	\N	121073	121073	288766
15196	18752	5	applied	\N	\N	\N	\N	121074	121074	288767
15196	18753	6	applied	\N	\N	\N	\N	121075	121075	288768
15196	18757	7	applied	\N	\N	\N	\N	121076	121076	288769
15196	18758	8	applied	\N	\N	\N	\N	121077	121077	288770
15196	18765	10	applied	\N	\N	\N	\N	121079	121079	288772
15196	18767	11	applied	\N	\N	\N	\N	121080	121080	288773
15196	18769	12	applied	\N	\N	\N	\N	121081	121081	288774
15196	18773	13	applied	\N	\N	\N	\N	121082	121082	288775
15196	18776	14	applied	\N	\N	\N	\N	121083	121083	288776
15196	18777	15	applied	\N	\N	\N	\N	121084	121084	288777
15196	18780	16	applied	\N	\N	\N	\N	121085	121085	288778
15196	18784	17	applied	\N	\N	\N	\N	121086	121086	288779
15196	18785	18	applied	\N	\N	\N	\N	121087	121087	288780
15196	18788	19	applied	\N	\N	\N	\N	121088	121088	288781
15196	18792	20	applied	\N	\N	\N	\N	121089	121089	288782
15196	18793	21	applied	\N	\N	\N	\N	121090	121090	288783
15196	18797	22	applied	\N	\N	\N	\N	121091	121091	288784
15196	18798	23	applied	\N	\N	\N	\N	121092	121092	288785
15196	18800	24	applied	\N	\N	\N	\N	121093	121093	288786
15196	18802	25	applied	\N	\N	\N	\N	121094	121094	288787
15196	18804	27	applied	\N	\N	\N	\N	121096	121096	288789
15196	18805	28	applied	\N	\N	\N	\N	121097	121097	288790
15196	18814	29	applied	\N	\N	\N	\N	121098	121098	288791
15196	18816	30	applied	\N	\N	\N	\N	121099	121099	288792
15196	18818	31	applied	\N	\N	\N	\N	121100	121100	288793
15196	18821	32	applied	\N	\N	\N	\N	121101	121101	288794
15196	18747	33	applied	\N	\N	\N	\N	121102	121102	288795
15196	18748	34	applied	\N	\N	\N	\N	121103	121103	288796
15196	18749	35	applied	\N	\N	1000000000	\N	121104	121104	288797
15196	18750	36	applied	\N	\N	\N	\N	121105	121105	288798
15196	18754	37	applied	\N	\N	\N	\N	121106	121106	288799
15196	18755	38	applied	\N	\N	\N	\N	121107	121107	288800
15196	18756	39	applied	\N	\N	\N	\N	121108	121108	288801
15196	18759	40	applied	\N	\N	\N	\N	121109	121109	288802
15196	18760	41	applied	\N	\N	\N	\N	121110	121110	288803
15196	18761	42	applied	\N	\N	\N	\N	121111	121111	288804
15196	18764	45	applied	\N	\N	\N	\N	121113	121113	288806
15196	18766	46	applied	\N	\N	\N	\N	121114	121114	288807
15196	18768	47	applied	\N	\N	\N	\N	121115	121115	288808
15196	18770	48	applied	\N	\N	\N	\N	121116	121116	288809
15196	18771	49	applied	\N	\N	\N	\N	121117	121117	288810
15196	18774	50	applied	\N	\N	\N	\N	121118	121118	288811
15108	18691	1	applied	\N	\N	\N	\N	120796	120796	288491
15108	18692	2	applied	\N	\N	1000000000	\N	120797	120797	288492
15118	18713	0	applied	\N	\N	\N	\N	120824	120824	288519
15118	18714	1	applied	\N	\N	\N	\N	120825	120825	288520
15123	18717	0	applied	\N	\N	\N	\N	120833	120833	288528
15128	18722	1	applied	\N	\N	\N	\N	120843	120843	288538
15132	18729	0	applied	\N	\N	\N	\N	120855	120855	288550
15132	18730	1	applied	\N	\N	\N	\N	120856	120856	288551
15135	18733	0	applied	\N	\N	\N	\N	120862	120862	288557
15135	18734	1	applied	\N	\N	\N	\N	120863	120863	288558
15135	18735	2	applied	\N	\N	\N	\N	120864	120864	288559
15141	18741	0	applied	\N	\N	\N	\N	120872	120872	288567
15143	18741	0	applied	\N	\N	\N	\N	120874	120874	288569
15145	18742	0	applied	\N	\N	\N	\N	120877	120877	288572
15145	18743	1	applied	\N	\N	\N	\N	120878	120878	288573
15149	18757	0	applied	\N	\N	\N	\N	120918	120918	288613
15149	18758	1	applied	\N	\N	\N	\N	120919	120919	288614
15149	18759	2	applied	\N	\N	\N	\N	120920	120920	288615
15149	18760	3	applied	\N	\N	\N	\N	120921	120921	288616
15149	18761	4	applied	\N	\N	\N	\N	120922	120922	288617
15149	18762	6	applied	\N	\N	\N	\N	120923	120923	288618
15151	18758	1	applied	\N	\N	\N	\N	120931	120931	288626
15151	18759	2	applied	\N	\N	\N	\N	120932	120932	288627
15151	18760	3	applied	\N	\N	\N	\N	120933	120933	288628
15151	18761	4	applied	\N	\N	\N	\N	120934	120934	288629
15151	18762	6	applied	\N	\N	\N	\N	120935	120935	288630
15160	18772	0	applied	\N	\N	1000000000	\N	120951	120951	288646
15160	18773	1	applied	\N	\N	\N	\N	120952	120952	288647
15160	18774	2	applied	\N	\N	\N	\N	120953	120953	288648
15160	18775	3	applied	\N	\N	\N	\N	120954	120954	288649
15162	18776	0	applied	\N	\N	\N	\N	120956	120956	288651
15164	18776	0	applied	\N	\N	\N	\N	120958	120958	288653
15167	18780	0	applied	\N	\N	\N	\N	120965	120965	288660
15167	18781	1	applied	\N	\N	\N	\N	120966	120966	288661
15167	18782	2	applied	\N	\N	\N	\N	120967	120967	288662
15167	18783	3	applied	\N	\N	\N	\N	120968	120968	288663
15170	18780	0	applied	\N	\N	\N	\N	120977	120977	288672
15170	18782	2	applied	\N	\N	\N	\N	120979	120979	288674
15170	18783	3	applied	\N	\N	\N	\N	120980	120980	288675
15171	18780	0	applied	\N	\N	\N	\N	120981	120981	288676
15171	18781	1	applied	\N	\N	\N	\N	120982	120982	288677
15171	18782	2	applied	\N	\N	\N	\N	120983	120983	288678
15171	18783	3	applied	\N	\N	\N	\N	120984	120984	288679
15173	18780	0	applied	\N	\N	\N	\N	120989	120989	288684
15173	18781	1	applied	\N	\N	\N	\N	120990	120990	288685
15173	18782	2	applied	\N	\N	\N	\N	120991	120991	288686
15173	18783	3	applied	\N	\N	\N	\N	120992	120992	288687
15175	18784	0	applied	\N	\N	\N	\N	120994	120994	288689
15180	18791	0	applied	\N	\N	1000000000	\N	121007	121007	288702
15180	18792	1	applied	\N	\N	\N	\N	121008	121008	288703
15180	18793	2	applied	\N	\N	\N	\N	121009	121009	288704
15180	18795	4	applied	\N	\N	\N	\N	121011	121011	288706
15180	18796	5	applied	\N	\N	\N	\N	121012	121012	288707
15182	18798	1	applied	\N	\N	\N	\N	121020	121020	288715
15182	18799	2	applied	\N	\N	\N	\N	121021	121021	288716
15184	18797	0	applied	\N	\N	\N	\N	121025	121025	288720
15184	18798	1	applied	\N	\N	\N	\N	121026	121026	288721
15184	18799	2	applied	\N	\N	\N	\N	121027	121027	288722
15185	18800	0	applied	\N	\N	\N	\N	121028	121028	288723
15185	18801	1	applied	\N	\N	\N	\N	121029	121029	288724
15187	18800	0	applied	\N	\N	\N	\N	121032	121032	288727
15187	18801	1	applied	\N	\N	\N	\N	121033	121033	288728
15190	18803	0	applied	\N	\N	\N	\N	121046	121046	288740
15190	18804	1	applied	\N	\N	\N	\N	121047	121047	288741
15190	18805	2	applied	\N	\N	\N	\N	121048	121048	288742
15190	18807	4	applied	\N	\N	\N	\N	121050	121050	288743
15190	18808	5	applied	\N	\N	\N	\N	121051	121051	288744
15190	18809	6	applied	\N	\N	\N	\N	121052	121052	288745
15190	18810	7	applied	\N	\N	\N	\N	121053	121053	288746
15190	18811	8	applied	\N	\N	\N	\N	121054	121054	288747
15192	18816	0	applied	\N	\N	\N	\N	121059	121059	288752
15192	18817	1	applied	\N	\N	\N	\N	121060	121060	288753
15194	18818	0	applied	\N	\N	\N	\N	121064	121064	288757
15194	18819	1	applied	\N	\N	\N	\N	121065	121065	288758
15194	18820	2	applied	\N	\N	\N	\N	121066	121066	288759
15199	18825	0	applied	\N	\N	\N	\N	121149	121149	288842
15199	18826	1	applied	\N	\N	\N	\N	121150	121150	288843
15199	18827	2	applied	\N	\N	\N	\N	121151	121151	288844
15201	18828	0	applied	\N	\N	\N	\N	121155	121155	288848
15201	18829	1	applied	\N	\N	\N	\N	121156	121156	288849
15204	18830	0	applied	\N	\N	\N	\N	121162	121162	288855
15204	18831	1	applied	\N	\N	\N	\N	121163	121163	288856
15204	18832	2	applied	\N	\N	\N	\N	121164	121164	288857
15208	18833	0	applied	\N	\N	\N	\N	121173	121173	288866
15208	18834	1	applied	\N	\N	\N	\N	121174	121174	288867
15208	18835	2	applied	\N	\N	\N	\N	121175	121175	288868
15208	18836	3	applied	\N	\N	\N	\N	121176	121176	288869
15210	18837	0	applied	\N	\N	\N	\N	121181	121181	288874
15210	18838	1	applied	\N	\N	\N	\N	121182	121182	288875
15210	18839	2	applied	\N	\N	\N	\N	121183	121183	288876
15215	18844	0	applied	\N	\N	\N	\N	121192	121192	288885
15215	18845	1	applied	\N	\N	\N	\N	121193	121193	288886
15218	18851	0	applied	\N	\N	\N	\N	121201	121201	288894
15218	18852	1	applied	\N	\N	\N	\N	121202	121202	288895
15218	18853	2	applied	\N	\N	\N	\N	121203	121203	288896
15218	18855	4	applied	\N	\N	\N	\N	121205	121205	288898
15220	18851	0	applied	\N	\N	\N	\N	121211	121211	288904
15220	18852	1	applied	\N	\N	\N	\N	121212	121212	288905
15220	18853	2	applied	\N	\N	\N	\N	121213	121213	288906
15220	18854	3	applied	\N	\N	\N	\N	121214	121214	288907
15220	18855	4	applied	\N	\N	\N	\N	121215	121215	288908
15222	18856	0	applied	\N	\N	\N	\N	121221	121221	288914
15222	18857	1	applied	\N	\N	\N	\N	121222	121222	288915
15224	18856	0	applied	\N	\N	\N	\N	121225	121225	288918
15224	18857	1	applied	\N	\N	\N	\N	121226	121226	288919
15231	18862	0	applied	\N	\N	\N	\N	121239	121239	288932
15231	18863	1	applied	\N	\N	\N	\N	121240	121240	288933
15231	18864	2	applied	\N	\N	\N	\N	121241	121241	288934
15233	18865	0	applied	\N	\N	\N	\N	121245	121245	288938
15233	18866	1	applied	\N	\N	\N	\N	121246	121246	288939
15233	18867	2	applied	\N	\N	\N	\N	121247	121247	288940
15113	18703	1	applied	\N	\N	\N	\N	120814	120814	288509
15113	18704	2	applied	\N	\N	\N	\N	120815	120815	288510
15196	18775	51	applied	\N	\N	\N	\N	121119	121119	288812
15196	18778	52	applied	\N	\N	\N	\N	121120	121120	288813
15196	18779	53	applied	\N	\N	\N	\N	121121	121121	288814
15196	18781	54	applied	\N	\N	\N	\N	121122	121122	288815
15196	18782	55	applied	\N	\N	\N	\N	121123	121123	288816
15196	18783	56	applied	\N	\N	\N	\N	121124	121124	288817
15196	18786	57	applied	\N	\N	\N	\N	121125	121125	288818
15196	18787	58	applied	\N	\N	\N	\N	121126	121126	288819
15196	18789	59	applied	\N	\N	\N	\N	121127	121127	288820
15196	18790	60	applied	\N	\N	\N	\N	121128	121128	288821
15196	18794	62	applied	\N	\N	1000000000	\N	121130	121130	288823
15196	18795	63	applied	\N	\N	\N	\N	121131	121131	288824
15196	18796	64	applied	\N	\N	\N	\N	121132	121132	288825
15196	18799	65	applied	\N	\N	\N	\N	121133	121133	288826
15196	18801	66	applied	\N	\N	\N	\N	121134	121134	288827
15196	18809	67	applied	\N	\N	\N	\N	121135	121135	288828
15196	18810	68	applied	\N	\N	\N	\N	121136	121136	288829
15196	18811	69	applied	\N	\N	\N	\N	121137	121137	288830
15196	18812	70	applied	\N	\N	\N	\N	121138	121138	288831
15196	18813	71	applied	\N	\N	\N	\N	121139	121139	288832
15196	18815	72	applied	\N	\N	\N	\N	121140	121140	288833
15196	18817	73	applied	\N	\N	\N	\N	121141	121141	288834
15196	18819	74	applied	\N	\N	\N	\N	121142	121142	288835
15196	18820	75	applied	\N	\N	\N	\N	121143	121143	288836
15196	18822	76	applied	\N	\N	\N	\N	121144	121144	288837
15197	18823	0	applied	\N	\N	\N	\N	121145	121145	288838
15197	18824	1	applied	\N	\N	\N	\N	121146	121146	288839
15198	18823	0	applied	\N	\N	\N	\N	121147	121147	288840
15198	18824	1	applied	\N	\N	\N	\N	121148	121148	288841
15203	18830	0	applied	\N	\N	\N	\N	121159	121159	288852
15203	18832	2	applied	\N	\N	\N	\N	121161	121161	288854
15205	18831	0	applied	\N	\N	\N	\N	121165	121165	288858
15205	18832	1	applied	\N	\N	\N	\N	121166	121166	288859
15206	18830	0	applied	\N	\N	\N	\N	121167	121167	288860
15206	18831	1	applied	\N	\N	\N	\N	121168	121168	288861
15206	18832	2	applied	\N	\N	\N	\N	121169	121169	288862
15207	18830	0	applied	\N	\N	\N	\N	121170	121170	288863
15207	18831	1	applied	\N	\N	\N	\N	121171	121171	288864
15207	18832	2	applied	\N	\N	\N	\N	121172	121172	288865
15211	18840	0	applied	\N	\N	\N	\N	121184	121184	288877
15211	18841	1	applied	\N	\N	\N	\N	121185	121185	288878
15212	18842	0	applied	\N	\N	\N	\N	121186	121186	288879
15212	18843	1	applied	\N	\N	\N	\N	121187	121187	288880
15213	18842	0	applied	\N	\N	\N	\N	121188	121188	288881
15213	18843	1	applied	\N	\N	\N	\N	121189	121189	288882
15214	18842	0	applied	\N	\N	\N	\N	121190	121190	288883
15217	18846	0	applied	\N	\N	\N	\N	121196	121196	288889
15217	18847	1	applied	\N	\N	\N	\N	121197	121197	288890
15217	18848	2	applied	\N	\N	\N	\N	121198	121198	288891
15217	18849	3	applied	\N	\N	\N	\N	121199	121199	288892
15217	18850	4	applied	\N	\N	\N	\N	121200	121200	288893
15219	18851	0	applied	\N	\N	\N	\N	121206	121206	288899
15219	18852	1	applied	\N	\N	\N	\N	121207	121207	288900
15219	18853	2	applied	\N	\N	\N	\N	121208	121208	288901
15219	18854	3	applied	\N	\N	\N	\N	121209	121209	288902
15219	18855	4	applied	\N	\N	\N	\N	121210	121210	288903
15221	18851	0	applied	\N	\N	\N	\N	121216	121216	288909
15221	18852	1	applied	\N	\N	\N	\N	121217	121217	288910
15221	18853	2	applied	\N	\N	\N	\N	121218	121218	288911
15221	18854	3	applied	\N	\N	\N	\N	121219	121219	288912
15221	18855	4	applied	\N	\N	\N	\N	121220	121220	288913
15223	18856	0	applied	\N	\N	\N	\N	121223	121223	288916
15226	18858	0	applied	\N	\N	\N	\N	121230	121230	288923
15226	18859	1	applied	\N	\N	\N	\N	121231	121231	288924
15226	18860	2	applied	\N	\N	\N	\N	121232	121232	288925
15228	18861	0	applied	\N	\N	\N	\N	121236	121236	288929
15230	18861	0	applied	\N	\N	\N	\N	121238	121238	288931
15232	18865	0	applied	\N	\N	\N	\N	121242	121242	288935
15232	18866	1	applied	\N	\N	\N	\N	121243	121243	288936
15232	18867	2	applied	\N	\N	\N	\N	121244	121244	288937
15234	18865	0	applied	\N	\N	\N	\N	121248	121248	288941
15234	18866	1	applied	\N	\N	\N	\N	121249	121249	288942
15234	18867	2	applied	\N	\N	\N	\N	121250	121250	288943
15235	18868	0	applied	\N	\N	\N	\N	121251	121251	288944
15235	18869	1	applied	\N	\N	\N	\N	121252	121252	288945
15237	18868	0	applied	\N	\N	\N	\N	121255	121255	288948
15237	18869	1	applied	\N	\N	\N	\N	121256	121256	288949
15239	18870	0	applied	\N	\N	\N	\N	121259	121259	288952
15242	18881	0	applied	\N	\N	\N	\N	121270	121270	288963
15242	18882	1	applied	\N	\N	\N	\N	121271	121271	288964
15242	18883	2	applied	\N	\N	\N	\N	121272	121272	288965
15244	18884	0	applied	\N	\N	\N	\N	121275	121275	288968
15244	18885	1	applied	\N	\N	\N	\N	121276	121276	288969
15245	18886	0	applied	\N	\N	\N	\N	121277	121277	288970
15245	18887	1	applied	\N	\N	\N	\N	121278	121278	288971
15245	18888	2	applied	\N	\N	\N	\N	121279	121279	288972
15245	18889	3	applied	\N	\N	\N	\N	121280	121280	288973
15245	18890	4	applied	\N	\N	\N	\N	121281	121281	288974
15248	18893	0	applied	\N	\N	\N	\N	121291	121291	288984
15248	18894	1	applied	\N	\N	\N	\N	121292	121292	288985
15248	18895	2	applied	\N	\N	\N	\N	121293	121293	288986
15248	18896	3	applied	\N	\N	\N	\N	121294	121294	288987
15248	18897	4	applied	\N	\N	\N	\N	121295	121295	288988
15248	18898	5	applied	\N	\N	\N	\N	121296	121296	288989
15250	18900	0	applied	\N	\N	\N	\N	121301	121301	288994
15250	18901	1	applied	\N	\N	\N	\N	121302	121302	288995
15250	18902	2	applied	\N	\N	\N	\N	121303	121303	288996
15253	18905	0	applied	\N	\N	\N	\N	121310	121310	289003
15253	18906	1	applied	\N	\N	\N	\N	121311	121311	289004
15253	18907	2	applied	\N	\N	\N	\N	121312	121312	289005
15253	18908	3	applied	\N	\N	\N	\N	121313	121313	289006
15255	18905	0	applied	\N	\N	\N	\N	121318	121318	289011
15255	18906	1	applied	\N	\N	\N	\N	121319	121319	289012
15255	18907	2	applied	\N	\N	\N	\N	121320	121320	289013
15255	18908	3	applied	\N	\N	\N	\N	121321	121321	289014
15260	18919	0	applied	\N	\N	\N	\N	121354	121354	289047
15260	18920	1	applied	\N	\N	\N	\N	121355	121355	289048
15262	18921	0	applied	\N	\N	\N	\N	121359	121359	289052
15262	18922	1	applied	\N	\N	\N	\N	121360	121360	289053
15190	18813	10	applied	\N	\N	\N	\N	121056	121056	288749
15195	18822	1	applied	\N	\N	\N	\N	121068	121068	288761
15246	18892	1	applied	\N	\N	\N	\N	121283	121283	288976
15249	18900	0	applied	\N	\N	\N	\N	121298	121298	288991
15249	18901	1	applied	\N	\N	\N	\N	121299	121299	288992
15249	18902	2	applied	\N	\N	\N	\N	121300	121300	288993
15251	18903	0	applied	\N	\N	\N	\N	121304	121304	288997
15251	18904	1	applied	\N	\N	\N	\N	121305	121305	288998
15256	18909	0	applied	\N	\N	\N	\N	121322	121322	289015
15256	18910	1	applied	\N	\N	\N	\N	121323	121323	289016
15256	18911	2	applied	\N	\N	\N	\N	121324	121324	289017
15256	18912	3	applied	\N	\N	\N	\N	121325	121325	289018
15256	18913	4	applied	\N	\N	\N	\N	121326	121326	289019
15256	18914	5	applied	\N	\N	\N	\N	121327	121327	289020
15256	18915	6	applied	\N	\N	\N	\N	121328	121328	289021
15256	18916	7	applied	\N	\N	\N	\N	121329	121329	289022
15256	18918	10	applied	\N	\N	\N	\N	121331	121331	289024
15258	18909	0	applied	\N	\N	\N	\N	121342	121342	289035
15258	18910	1	applied	\N	\N	\N	\N	121343	121343	289036
15258	18911	2	applied	\N	\N	\N	\N	121344	121344	289037
15258	18912	3	applied	\N	\N	\N	\N	121345	121345	289038
15258	18913	4	applied	\N	\N	\N	\N	121346	121346	289039
15258	18914	5	applied	\N	\N	\N	\N	121347	121347	289040
15258	18915	6	applied	\N	\N	\N	\N	121348	121348	289041
15258	18916	7	applied	\N	\N	\N	\N	121349	121349	289042
15258	18917	8	applied	\N	\N	\N	\N	121350	121350	289043
15258	18918	10	applied	\N	\N	\N	\N	121351	121351	289044
15259	18919	0	applied	\N	\N	\N	\N	121352	121352	289045
15259	18920	1	applied	\N	\N	\N	\N	121353	121353	289046
15261	18921	0	applied	\N	\N	\N	\N	121356	121356	289049
15261	18922	1	applied	\N	\N	\N	\N	121357	121357	289050
15261	18923	2	applied	\N	\N	\N	\N	121358	121358	289051
15263	18925	1	applied	\N	\N	\N	\N	121363	121363	289056
15263	18926	2	applied	\N	\N	\N	\N	121364	121364	289057
15266	18927	0	applied	\N	\N	\N	\N	121367	121367	289060
15268	18928	0	applied	\N	\N	\N	\N	121373	121373	289066
15268	18929	1	applied	\N	\N	\N	\N	121374	121374	289067
15268	18930	2	applied	\N	\N	\N	\N	121375	121375	289068
15268	18931	3	applied	\N	\N	\N	\N	121376	121376	289069
15268	18932	4	applied	\N	\N	\N	\N	121377	121377	289070
15270	18933	0	applied	\N	\N	\N	\N	121383	121383	289076
15270	18934	1	applied	\N	\N	1000000000	\N	121384	121384	289077
15270	18935	2	applied	\N	\N	\N	\N	121385	121385	289078
15270	18936	3	applied	\N	\N	\N	\N	121386	121386	289079
15272	18937	0	applied	\N	\N	\N	\N	121391	121391	289084
15272	18938	1	applied	\N	\N	\N	\N	121392	121392	289085
15273	18939	0	applied	\N	\N	\N	\N	121393	121393	289086
15273	18940	1	applied	\N	\N	\N	\N	121394	121394	289087
15273	18942	3	applied	\N	\N	\N	\N	121396	121396	289089
15273	18943	4	applied	\N	\N	\N	\N	121397	121397	289090
15273	18944	5	applied	\N	\N	\N	\N	121398	121398	289091
15273	18945	6	applied	\N	\N	\N	\N	121399	121399	289092
15273	18946	7	applied	\N	\N	\N	\N	121400	121400	289093
15276	18947	0	applied	\N	\N	\N	\N	121413	121413	289106
15276	18948	1	applied	\N	\N	\N	\N	121414	121414	289107
15276	18949	2	applied	\N	\N	\N	\N	121415	121415	289108
15276	18950	3	applied	\N	\N	\N	\N	121416	121416	289109
15278	18951	0	applied	\N	\N	\N	\N	121418	121418	289111
15278	18952	1	applied	\N	\N	\N	\N	121419	121419	289112
15278	18953	2	applied	\N	\N	\N	\N	121420	121420	289113
15280	18951	0	applied	\N	\N	\N	\N	121424	121424	289117
15280	18952	1	applied	\N	\N	\N	\N	121425	121425	289118
15280	18953	2	applied	\N	\N	\N	\N	121426	121426	289119
15282	18956	0	applied	\N	\N	\N	\N	121429	121429	289122
15283	18958	1	applied	\N	\N	\N	\N	121431	121431	289124
15283	18959	2	applied	\N	\N	\N	\N	121432	121432	289125
15286	18962	0	applied	\N	\N	\N	\N	121445	121445	289138
15286	18963	1	applied	\N	\N	\N	\N	121446	121446	289139
15286	18964	2	applied	\N	\N	\N	\N	121447	121447	289140
15286	18965	3	applied	\N	\N	\N	\N	121448	121448	289141
15286	18966	4	applied	\N	\N	\N	\N	121449	121449	289142
15286	18967	5	applied	\N	\N	\N	\N	121450	121450	289143
15286	18968	6	applied	\N	\N	\N	\N	121451	121451	289144
15286	18969	7	applied	\N	\N	\N	\N	121452	121452	289145
15286	18970	8	applied	\N	\N	\N	\N	121453	121453	289146
15286	18971	9	applied	\N	\N	\N	\N	121454	121454	289147
15287	18972	0	applied	\N	\N	\N	\N	121455	121455	289148
15287	18973	1	applied	\N	\N	\N	\N	121456	121456	289149
15289	18979	0	applied	\N	\N	\N	\N	121462	121462	289155
15289	18980	1	applied	\N	\N	\N	\N	121463	121463	289156
15292	18986	1	applied	\N	\N	\N	\N	121469	121469	289162
15292	18987	2	applied	\N	\N	\N	\N	121470	121470	289163
15294	18988	0	applied	\N	\N	\N	\N	121474	121474	289167
15294	18989	1	applied	\N	\N	\N	\N	121475	121475	289168
15294	18990	2	applied	\N	\N	\N	\N	121476	121476	289169
15297	18993	0	applied	\N	\N	\N	\N	121489	121489	289181
15297	18994	1	applied	\N	\N	\N	\N	121490	121490	289182
15303	18995	0	applied	\N	\N	\N	\N	121499	121499	289191
15303	18996	1	applied	\N	\N	\N	\N	121500	121500	289192
15303	18997	2	applied	\N	\N	\N	\N	121501	121501	289193
15303	18998	3	applied	\N	\N	\N	\N	121502	121502	289194
15303	18999	4	applied	\N	\N	\N	\N	121503	121503	289195
15303	19000	5	applied	\N	\N	\N	\N	121504	121504	289196
15303	19001	6	applied	\N	\N	\N	\N	121505	121505	289197
15303	19002	7	applied	\N	\N	\N	\N	121506	121506	289198
15306	18995	0	applied	\N	\N	\N	\N	121562	121562	289254
15306	18997	2	applied	\N	\N	\N	\N	121564	121564	289256
15306	18998	3	applied	\N	\N	\N	\N	121565	121565	289257
15306	18999	4	applied	\N	\N	\N	\N	121566	121566	289258
15306	19000	5	applied	\N	\N	\N	\N	121567	121567	289259
15306	19001	6	applied	\N	\N	\N	\N	121568	121568	289260
15306	19002	7	applied	\N	\N	\N	\N	121569	121569	289261
15307	19003	0	applied	\N	\N	\N	\N	121570	121570	289262
15317	19019	0	applied	\N	\N	\N	\N	121595	121595	289287
15317	19020	1	applied	\N	\N	\N	\N	121596	121596	289288
15319	19021	0	applied	\N	\N	\N	\N	121599	121599	289291
15319	19022	1	applied	\N	\N	\N	\N	121600	121600	289292
15322	19031	0	applied	\N	\N	\N	\N	121609	121609	289301
15327	19038	0	applied	\N	\N	\N	\N	121620	121620	289312
15327	19039	1	applied	\N	\N	\N	\N	121621	121621	289313
15330	19047	0	applied	\N	\N	\N	\N	121631	121631	289323
15330	19048	1	applied	\N	\N	\N	\N	121632	121632	289324
15246	18891	0	applied	\N	\N	\N	\N	121282	121282	288975
15267	18930	2	applied	\N	\N	\N	\N	121370	121370	289063
15267	18931	3	applied	\N	\N	\N	\N	121371	121371	289064
15267	18932	4	applied	\N	\N	\N	\N	121372	121372	289065
15275	18947	0	applied	\N	\N	\N	\N	121409	121409	289102
15275	18948	1	applied	\N	\N	\N	\N	121410	121410	289103
15275	18949	2	applied	\N	\N	\N	\N	121411	121411	289104
15275	18950	3	applied	\N	\N	\N	\N	121412	121412	289105
15277	18943	0	applied	\N	\N	\N	\N	121417	121417	289110
15279	18951	0	applied	\N	\N	\N	\N	121421	121421	289114
15279	18952	1	applied	\N	\N	\N	\N	121422	121422	289115
15279	18953	2	applied	\N	\N	\N	\N	121423	121423	289116
15284	18960	0	applied	\N	\N	\N	\N	121433	121433	289126
15284	18961	1	applied	\N	\N	\N	\N	121434	121434	289127
15285	18962	0	applied	\N	\N	\N	\N	121435	121435	289128
15285	18963	1	applied	\N	\N	\N	\N	121436	121436	289129
15285	18964	2	applied	\N	\N	\N	\N	121437	121437	289130
15285	18966	4	applied	\N	\N	\N	\N	121439	121439	289132
15285	18967	5	applied	\N	\N	\N	\N	121440	121440	289133
15285	18968	6	applied	\N	\N	\N	\N	121441	121441	289134
15285	18969	7	applied	\N	\N	\N	\N	121442	121442	289135
15285	18970	8	applied	\N	\N	\N	\N	121443	121443	289136
15285	18971	9	applied	\N	\N	\N	\N	121444	121444	289137
15288	18974	0	applied	\N	\N	\N	\N	121457	121457	289150
15288	18975	1	applied	\N	\N	\N	\N	121458	121458	289151
15288	18976	2	applied	\N	\N	\N	\N	121459	121459	289152
15288	18977	3	applied	\N	\N	\N	\N	121460	121460	289153
15288	18978	4	applied	\N	\N	\N	\N	121461	121461	289154
15293	18988	0	applied	\N	\N	\N	\N	121471	121471	289164
15293	18989	1	applied	\N	\N	\N	\N	121472	121472	289165
15293	18990	2	applied	\N	\N	\N	\N	121473	121473	289166
15305	18995	0	applied	\N	\N	\N	\N	121554	121554	289246
15305	18996	1	applied	\N	\N	\N	\N	121555	121555	289247
15305	18998	3	applied	\N	\N	\N	\N	121557	121557	289249
15305	18999	4	applied	\N	\N	\N	\N	121558	121558	289250
15305	19000	5	applied	\N	\N	\N	\N	121559	121559	289251
15305	19001	6	applied	\N	\N	\N	\N	121560	121560	289252
15305	19002	7	applied	\N	\N	\N	\N	121561	121561	289253
15309	19004	0	applied	\N	\N	\N	\N	121572	121572	289264
15309	19005	1	applied	\N	\N	\N	\N	121573	121573	289265
15309	19006	2	applied	\N	\N	\N	\N	121574	121574	289266
15311	19007	0	applied	\N	\N	\N	\N	121578	121578	289270
15311	19008	1	applied	\N	\N	\N	\N	121579	121579	289271
15314	19009	0	applied	\N	\N	\N	\N	121585	121585	289277
15314	19010	1	applied	\N	\N	\N	\N	121586	121586	289278
15314	19011	2	applied	\N	\N	\N	\N	121587	121587	289279
15316	19016	0	applied	\N	\N	\N	\N	121592	121592	289284
15316	19017	1	applied	\N	\N	\N	\N	121593	121593	289285
15316	19018	2	applied	\N	\N	\N	\N	121594	121594	289286
15324	19033	1	applied	\N	\N	\N	\N	121612	121612	289304
15324	19034	2	applied	\N	\N	\N	\N	121613	121613	289305
15326	19035	0	applied	\N	\N	\N	\N	121617	121617	289309
15326	19036	1	applied	\N	\N	\N	\N	121618	121618	289310
15326	19037	2	applied	\N	\N	\N	\N	121619	121619	289311
15329	19040	0	applied	\N	\N	\N	\N	121624	121624	289316
15329	19041	1	applied	\N	\N	\N	\N	121625	121625	289317
15329	19042	2	applied	\N	\N	\N	\N	121626	121626	289318
15329	19043	3	applied	\N	\N	\N	\N	121627	121627	289319
15329	19044	4	applied	\N	\N	\N	\N	121628	121628	289320
15329	19045	5	applied	\N	\N	\N	\N	121629	121629	289321
15329	19046	6	applied	\N	\N	\N	\N	121630	121630	289322
15330	19049	2	applied	\N	\N	\N	\N	121633	121633	289325
15332	19047	0	applied	\N	\N	\N	\N	121637	121637	289329
15332	19048	1	applied	\N	\N	\N	\N	121638	121638	289330
15332	19049	2	applied	\N	\N	\N	\N	121639	121639	289331
15334	19055	1	applied	\N	\N	\N	\N	121645	121645	289337
15337	19056	0	applied	\N	\N	\N	\N	121655	121655	289347
15337	19057	1	applied	\N	\N	\N	\N	121656	121656	289348
15337	19058	2	applied	\N	\N	\N	\N	121657	121657	289349
15340	19063	0	applied	\N	\N	\N	\N	121676	121676	289368
15340	19064	1	applied	\N	\N	\N	\N	121677	121677	289369
15340	19065	2	applied	\N	\N	\N	\N	121678	121678	289370
15340	19066	3	applied	\N	\N	\N	\N	121679	121679	289371
15340	19067	4	applied	\N	\N	\N	\N	121680	121680	289372
15340	19068	5	applied	\N	\N	\N	\N	121681	121681	289373
15340	19069	6	applied	\N	\N	\N	\N	121682	121682	289374
15345	19073	0	applied	\N	\N	\N	\N	121693	121693	289385
15345	19074	1	applied	\N	\N	\N	\N	121694	121694	289386
15347	19075	0	applied	\N	\N	\N	\N	121698	121698	289390
15347	19076	2	applied	\N	\N	\N	\N	121699	121699	289391
15347	19077	3	applied	\N	\N	\N	\N	121700	121700	289392
15356	19084	0	applied	\N	\N	\N	\N	121713	121713	289405
15356	19085	1	applied	\N	\N	\N	\N	121714	121714	289406
15356	19086	2	applied	\N	\N	\N	\N	121715	121715	289407
15358	19087	0	applied	\N	\N	\N	\N	121719	121719	289411
15358	19088	1	applied	\N	\N	\N	\N	121720	121720	289412
15367	19091	0	applied	\N	\N	\N	\N	121740	121740	289432
15367	19092	1	applied	\N	\N	\N	\N	121741	121741	289433
15367	19093	2	applied	\N	\N	\N	\N	121742	121742	289434
15367	19094	3	applied	\N	\N	\N	\N	121743	121743	289435
15367	19095	4	applied	\N	\N	\N	\N	121744	121744	289436
15372	19103	0	applied	\N	\N	\N	\N	121760	121760	289452
15372	19104	1	applied	\N	\N	\N	\N	121761	121761	289453
15372	19105	2	applied	\N	\N	\N	\N	121762	121762	289454
15374	19106	0	applied	\N	\N	\N	\N	121764	121764	289456
15391	19133	0	applied	\N	\N	\N	\N	121827	121827	289517
15391	19134	1	applied	\N	\N	\N	\N	121828	121828	289518
15393	19136	0	applied	\N	\N	\N	\N	121832	121832	289522
15393	19137	1	applied	\N	\N	\N	\N	121833	121833	289523
15395	19127	0	applied	\N	\N	\N	\N	121836	121836	289526
15399	19143	0	applied	\N	\N	\N	\N	121844	121844	289534
15399	19144	1	applied	\N	\N	\N	\N	121845	121845	289535
15402	19152	0	applied	\N	\N	\N	\N	121853	121853	289543
15402	19153	2	applied	\N	\N	\N	\N	121854	121854	289544
15402	19154	3	applied	\N	\N	\N	\N	121855	121855	289545
15404	19152	0	applied	\N	\N	\N	\N	121859	121859	289549
15404	19153	2	applied	\N	\N	\N	\N	121860	121860	289550
15404	19154	3	applied	\N	\N	\N	\N	121861	121861	289551
15407	19162	0	applied	\N	\N	\N	\N	121869	121869	289559
15407	19163	1	applied	\N	\N	\N	\N	121870	121870	289560
15407	19164	2	applied	\N	\N	\N	\N	121871	121871	289561
15265	18927	0	applied	\N	\N	\N	\N	121366	121366	289059
15267	18928	0	applied	\N	\N	\N	\N	121368	121368	289061
15271	18933	0	applied	\N	\N	\N	\N	121387	121387	289080
15271	18934	1	applied	\N	\N	1000000000	\N	121388	121388	289081
15271	18935	2	applied	\N	\N	\N	\N	121389	121389	289082
15271	18936	3	applied	\N	\N	\N	\N	121390	121390	289083
15274	18939	0	applied	\N	\N	\N	\N	121401	121401	289094
15274	18940	1	applied	\N	\N	\N	\N	121402	121402	289095
15274	18941	2	applied	\N	\N	\N	\N	121403	121403	289096
15274	18942	3	applied	\N	\N	\N	\N	121404	121404	289097
15274	18943	4	applied	\N	\N	\N	\N	121405	121405	289098
15274	18944	5	applied	\N	\N	\N	\N	121406	121406	289099
15274	18945	6	applied	\N	\N	\N	\N	121407	121407	289100
15274	18946	7	applied	\N	\N	\N	\N	121408	121408	289101
15281	18955	1	applied	\N	\N	\N	\N	121428	121428	289121
15291	18984	0	applied	\N	\N	\N	\N	121467	121467	289160
15296	18772	0	applied	\N	\N	1000000000	\N	121479	121479	289172
15296	18312	1	applied	\N	\N	1000000000	\N	121480	121480	289173
15296	18209	2	applied	\N	\N	\N	\N	121481	121481	289174
15296	18220	3	applied	\N	\N	\N	\N	121482	121482	289175
15296	18215	4	applied	\N	\N	\N	\N	121483	121483	289176
15296	18197	5	applied	\N	\N	\N	\N	121484	121484	289177
15296	18346	6	applied	\N	\N	\N	\N	121485	121485	289178
15296	18218	8	applied	\N	\N	\N	\N	121487	121487	289179
15296	18326	9	applied	\N	\N	\N	\N	121488	121488	289180
15298	18993	0	applied	\N	\N	\N	\N	121491	121491	289183
15298	18994	1	applied	\N	\N	\N	\N	121492	121492	289184
15304	18956	0	applied	\N	\N	\N	\N	121507	121507	289199
15304	18957	1	applied	\N	\N	\N	\N	121508	121508	289200
15304	18960	2	applied	\N	\N	\N	\N	121509	121509	289201
15304	18962	3	applied	\N	\N	\N	\N	121510	121510	289202
15304	18963	4	applied	\N	\N	\N	\N	121511	121511	289203
15304	18964	5	applied	\N	\N	\N	\N	121512	121512	289204
15304	18965	6	applied	\N	\N	\N	\N	121513	121513	289205
15304	18972	7	applied	\N	\N	\N	\N	121514	121514	289206
15304	18974	8	applied	\N	\N	\N	\N	121515	121515	289207
15304	18975	9	applied	\N	\N	\N	\N	121516	121516	289208
15304	18979	10	applied	\N	\N	\N	\N	121517	121517	289209
15304	18981	11	applied	\N	\N	\N	\N	121518	121518	289210
15304	18984	12	applied	\N	\N	\N	\N	121519	121519	289211
15304	18985	13	applied	\N	\N	\N	\N	121520	121520	289212
15304	18988	14	applied	\N	\N	\N	\N	121521	121521	289213
15304	18991	15	applied	\N	\N	\N	\N	121522	121522	289214
15304	18993	16	applied	\N	\N	\N	\N	121523	121523	289215
15304	18995	17	applied	\N	\N	\N	\N	121524	121524	289216
15304	18996	18	applied	\N	\N	\N	\N	121525	121525	289217
15304	18997	19	applied	\N	\N	\N	\N	121526	121526	289218
15304	18958	20	applied	\N	\N	\N	\N	121527	121527	289219
15304	18959	21	applied	\N	\N	\N	\N	121528	121528	289220
15304	18961	22	applied	\N	\N	\N	\N	121529	121529	289221
15304	18966	23	applied	\N	\N	\N	\N	121530	121530	289222
15304	18967	24	applied	\N	\N	\N	\N	121531	121531	289223
15304	18968	25	applied	\N	\N	\N	\N	121532	121532	289224
15304	18969	26	applied	\N	\N	\N	\N	121533	121533	289225
15304	18971	28	applied	\N	\N	\N	\N	121535	121535	289227
15304	18973	29	applied	\N	\N	\N	\N	121536	121536	289228
15304	18976	30	applied	\N	\N	\N	\N	121537	121537	289229
15304	18977	31	applied	\N	\N	\N	\N	121538	121538	289230
15304	18978	32	applied	\N	\N	\N	\N	121539	121539	289231
15304	18980	33	applied	\N	\N	\N	\N	121540	121540	289232
15304	18982	34	applied	\N	\N	\N	\N	121541	121541	289233
15304	18983	35	applied	\N	\N	\N	\N	121542	121542	289234
15304	18986	36	applied	\N	\N	\N	\N	121543	121543	289235
15304	18987	37	applied	\N	\N	\N	\N	121544	121544	289236
15304	18989	38	applied	\N	\N	\N	\N	121545	121545	289237
15304	18990	39	applied	\N	\N	\N	\N	121546	121546	289238
15304	18992	40	applied	\N	\N	\N	\N	121547	121547	289239
15337	19059	3	applied	\N	\N	\N	\N	121658	121658	289350
15337	19060	4	applied	\N	\N	\N	\N	121659	121659	289351
15337	19061	5	applied	\N	\N	\N	\N	121660	121660	289352
15342	19070	0	applied	\N	\N	\N	\N	121686	121686	289378
15342	19071	1	applied	\N	\N	\N	\N	121687	121687	289379
15342	19072	2	applied	\N	\N	\N	\N	121688	121688	289380
15351	19079	0	applied	\N	\N	\N	\N	121706	121706	289398
15351	19080	1	applied	\N	\N	\N	\N	121707	121707	289399
15351	19081	2	applied	\N	\N	\N	\N	121708	121708	289400
15353	19082	0	applied	\N	\N	\N	\N	121711	121711	289403
15353	19083	1	applied	\N	\N	\N	\N	121712	121712	289404
15360	19089	0	applied	\N	\N	\N	\N	121721	121721	289413
15360	19090	1	applied	\N	\N	\N	\N	121722	121722	289414
15365	19091	0	applied	\N	\N	\N	\N	121730	121730	289422
15365	19092	1	applied	\N	\N	\N	\N	121731	121731	289423
15365	19093	2	applied	\N	\N	\N	\N	121732	121732	289424
15365	19094	3	applied	\N	\N	\N	\N	121733	121733	289425
15365	19095	4	applied	\N	\N	\N	\N	121734	121734	289426
15369	19096	0	applied	\N	\N	\N	\N	121750	121750	289442
15369	19098	2	applied	\N	\N	\N	\N	121752	121752	289444
15369	19099	3	applied	\N	\N	\N	\N	121753	121753	289445
15369	19100	4	applied	\N	\N	\N	\N	121754	121754	289446
15378	19107	0	applied	\N	\N	\N	\N	121797	121797	289489
15378	19108	1	applied	\N	\N	\N	\N	121798	121798	289490
15378	19109	2	applied	\N	\N	\N	\N	121799	121799	289491
15378	19110	3	applied	\N	\N	\N	\N	121800	121800	289492
15378	19111	4	applied	\N	\N	\N	\N	121801	121801	289493
15378	19112	5	applied	\N	\N	\N	\N	121802	121802	289494
15379	19113	0	applied	\N	\N	\N	\N	121803	121803	289495
15379	19114	1	applied	\N	\N	\N	\N	121804	121804	289496
15379	19115	2	applied	\N	\N	\N	\N	121805	121805	289497
15379	19117	4	applied	\N	\N	\N	\N	121807	121807	289498
15379	19118	5	applied	\N	\N	\N	\N	121808	121808	289499
15379	19119	6	applied	\N	\N	\N	\N	121809	121809	289500
15388	19131	0	applied	\N	\N	\N	\N	121825	121825	289515
15388	19132	1	applied	\N	\N	\N	\N	121826	121826	289516
15397	19138	0	applied	\N	\N	\N	\N	121839	121839	289529
15397	19139	1	applied	\N	\N	\N	\N	121840	121840	289530
15403	19152	0	applied	\N	\N	\N	\N	121856	121856	289546
15403	19153	2	applied	\N	\N	\N	\N	121857	121857	289547
15403	19154	3	applied	\N	\N	\N	\N	121858	121858	289548
15408	19162	0	applied	\N	\N	\N	\N	121873	121873	289563
15408	19163	1	applied	\N	\N	\N	\N	121874	121874	289564
15408	19164	2	applied	\N	\N	\N	\N	121875	121875	289565
15269	18931	3	applied	\N	\N	\N	\N	121381	121381	289074
15269	18932	4	applied	\N	\N	\N	\N	121382	121382	289075
15295	18992	1	applied	\N	\N	\N	\N	121478	121478	289171
15299	18993	0	applied	\N	\N	\N	\N	121493	121493	289185
15299	18994	1	applied	\N	\N	\N	\N	121494	121494	289186
15302	18995	0	applied	\N	\N	\N	\N	121495	121495	289187
15302	18996	1	applied	\N	\N	\N	\N	121496	121496	289188
15302	18997	2	applied	\N	\N	\N	\N	121497	121497	289189
15302	18998	3	applied	\N	\N	\N	\N	121498	121498	289190
15304	18994	41	applied	\N	\N	\N	\N	121548	121548	289240
15304	18998	42	applied	\N	\N	\N	\N	121549	121549	289241
15304	18999	43	applied	\N	\N	\N	\N	121550	121550	289242
15304	19000	44	applied	\N	\N	\N	\N	121551	121551	289243
15304	19001	45	applied	\N	\N	\N	\N	121552	121552	289244
15304	19002	46	applied	\N	\N	\N	\N	121553	121553	289245
15308	19003	0	applied	\N	\N	\N	\N	121571	121571	289263
15310	19004	0	applied	\N	\N	\N	\N	121575	121575	289267
15310	19005	1	applied	\N	\N	\N	\N	121576	121576	289268
15312	19007	0	applied	\N	\N	\N	\N	121580	121580	289272
15312	19008	1	applied	\N	\N	\N	\N	121581	121581	289273
15313	19009	0	applied	\N	\N	\N	\N	121582	121582	289274
15313	19010	1	applied	\N	\N	\N	\N	121583	121583	289275
15313	19011	2	applied	\N	\N	\N	\N	121584	121584	289276
15315	19012	0	applied	\N	\N	\N	\N	121588	121588	289280
15315	19013	1	applied	\N	\N	\N	\N	121589	121589	289281
15315	19014	2	applied	\N	\N	\N	\N	121590	121590	289282
15315	19015	3	applied	\N	\N	\N	\N	121591	121591	289283
15318	19019	0	applied	\N	\N	\N	\N	121597	121597	289289
15318	19020	1	applied	\N	\N	\N	\N	121598	121598	289290
15320	19023	0	applied	\N	\N	\N	\N	121601	121601	289293
15320	19024	1	applied	\N	\N	\N	\N	121602	121602	289294
15320	19025	2	applied	\N	\N	\N	\N	121603	121603	289295
15320	19026	3	applied	\N	\N	\N	\N	121604	121604	289296
15320	19027	4	applied	\N	\N	\N	\N	121605	121605	289297
15321	19029	1	applied	\N	\N	\N	\N	121607	121607	289299
15321	19030	2	applied	\N	\N	\N	\N	121608	121608	289300
15323	19031	0	applied	\N	\N	\N	\N	121610	121610	289302
15325	19032	0	applied	\N	\N	\N	\N	121614	121614	289306
15325	19033	1	applied	\N	\N	\N	\N	121615	121615	289307
15325	19034	2	applied	\N	\N	\N	\N	121616	121616	289308
15328	19038	0	applied	\N	\N	\N	\N	121622	121622	289314
15328	19039	1	applied	\N	\N	\N	\N	121623	121623	289315
15331	19047	0	applied	\N	\N	\N	\N	121634	121634	289326
15331	19048	1	applied	\N	\N	\N	\N	121635	121635	289327
15331	19049	2	applied	\N	\N	\N	\N	121636	121636	289328
15333	19050	0	applied	\N	\N	\N	\N	121640	121640	289332
15333	19051	1	applied	\N	\N	\N	\N	121641	121641	289333
15333	19052	2	applied	\N	\N	\N	\N	121642	121642	289334
15333	19053	3	applied	\N	\N	\N	\N	121643	121643	289335
15335	19054	0	applied	\N	\N	\N	\N	121646	121646	289338
15336	19056	0	applied	\N	\N	\N	\N	121648	121648	289340
15336	19057	1	applied	\N	\N	\N	\N	121649	121649	289341
15336	19058	2	applied	\N	\N	\N	\N	121650	121650	289342
15336	19059	3	applied	\N	\N	\N	\N	121651	121651	289343
15336	19060	4	applied	\N	\N	\N	\N	121652	121652	289344
15336	19061	5	applied	\N	\N	\N	\N	121653	121653	289345
15336	19062	6	applied	\N	\N	\N	\N	121654	121654	289346
15338	19056	0	applied	\N	\N	\N	\N	121662	121662	289354
15338	19057	1	applied	\N	\N	\N	\N	121663	121663	289355
15338	19058	2	applied	\N	\N	\N	\N	121664	121664	289356
15338	19059	3	applied	\N	\N	\N	\N	121665	121665	289357
15338	19060	4	applied	\N	\N	\N	\N	121666	121666	289358
15338	19061	5	applied	\N	\N	\N	\N	121667	121667	289359
15338	19062	6	applied	\N	\N	\N	\N	121668	121668	289360
15339	19056	0	applied	\N	\N	\N	\N	121669	121669	289361
15339	19057	1	applied	\N	\N	\N	\N	121670	121670	289362
15339	19059	3	applied	\N	\N	\N	\N	121672	121672	289364
15339	19060	4	applied	\N	\N	\N	\N	121673	121673	289365
15339	19061	5	applied	\N	\N	\N	\N	121674	121674	289366
15339	19062	6	applied	\N	\N	\N	\N	121675	121675	289367
15341	19070	0	applied	\N	\N	\N	\N	121683	121683	289375
15341	19071	1	applied	\N	\N	\N	\N	121684	121684	289376
15341	19072	2	applied	\N	\N	\N	\N	121685	121685	289377
15343	19073	0	applied	\N	\N	\N	\N	121689	121689	289381
15343	19074	1	applied	\N	\N	\N	\N	121690	121690	289382
15344	19073	0	applied	\N	\N	\N	\N	121691	121691	289383
15344	19074	1	applied	\N	\N	\N	\N	121692	121692	289384
15346	19075	0	applied	\N	\N	\N	\N	121695	121695	289387
15346	19076	2	applied	\N	\N	\N	\N	121696	121696	289388
15346	19077	3	applied	\N	\N	\N	\N	121697	121697	289389
15348	19078	0	applied	\N	\N	\N	\N	121701	121701	289393
15364	19091	0	applied	\N	\N	\N	\N	121725	121725	289417
15364	19093	2	applied	\N	\N	\N	\N	121727	121727	289419
15364	19094	3	applied	\N	\N	\N	\N	121728	121728	289420
15364	19095	4	applied	\N	\N	\N	\N	121729	121729	289421
15366	19091	0	applied	\N	\N	\N	\N	121735	121735	289427
15366	19092	1	applied	\N	\N	\N	\N	121736	121736	289428
15366	19093	2	applied	\N	\N	\N	\N	121737	121737	289429
15366	19094	3	applied	\N	\N	\N	\N	121738	121738	289430
15366	19095	4	applied	\N	\N	\N	\N	121739	121739	289431
15371	19103	0	applied	\N	\N	\N	\N	121757	121757	289449
15371	19104	1	applied	\N	\N	\N	\N	121758	121758	289450
15371	19105	2	applied	\N	\N	\N	\N	121759	121759	289451
15373	19106	0	applied	\N	\N	\N	\N	121763	121763	289455
15375	19106	0	applied	\N	\N	\N	\N	121765	121765	289457
15381	19120	0	applied	\N	\N	\N	\N	121812	121812	289502
15381	19121	1	applied	\N	\N	\N	\N	121813	121813	289503
15381	19122	2	applied	\N	\N	\N	\N	121814	121814	289504
15381	19124	4	applied	\N	\N	\N	\N	121816	121816	289506
15381	19125	5	applied	\N	\N	\N	\N	121817	121817	289507
15383	19126	0	applied	\N	\N	\N	\N	121818	121818	289508
15383	19127	1	applied	\N	\N	\N	\N	121819	121819	289509
15392	19136	0	applied	\N	\N	\N	\N	121830	121830	289520
15392	19137	1	applied	\N	\N	\N	\N	121831	121831	289521
15394	19136	0	applied	\N	\N	\N	\N	121834	121834	289524
15394	19137	1	applied	\N	\N	\N	\N	121835	121835	289525
15400	19145	0	applied	\N	\N	\N	\N	121846	121846	289536
15400	19146	1	applied	\N	\N	\N	\N	121847	121847	289537
15405	19155	0	applied	\N	\N	\N	\N	121862	121862	289552
15417	19175	0	applied	\N	\N	\N	\N	121903	121903	289593
15417	19176	1	applied	\N	\N	\N	\N	121904	121904	289594
15417	19177	2	applied	\N	\N	\N	\N	121905	121905	289595
15290	18982	1	applied	\N	\N	\N	\N	121465	121465	289158
15290	18983	2	applied	\N	\N	\N	\N	121466	121466	289159
15352	19082	0	applied	\N	\N	\N	\N	121709	121709	289401
15352	19083	1	applied	\N	\N	\N	\N	121710	121710	289402
15357	19084	0	applied	\N	\N	\N	\N	121716	121716	289408
15357	19085	1	applied	\N	\N	\N	\N	121717	121717	289409
15357	19086	2	applied	\N	\N	\N	\N	121718	121718	289410
15361	19089	0	applied	\N	\N	\N	\N	121723	121723	289415
15361	19090	1	applied	\N	\N	\N	\N	121724	121724	289416
15368	19097	1	applied	\N	\N	\N	\N	121746	121746	289438
15368	19098	2	applied	\N	\N	\N	\N	121747	121747	289439
15368	19099	3	applied	\N	\N	\N	\N	121748	121748	289440
15368	19100	4	applied	\N	\N	\N	\N	121749	121749	289441
15370	19101	0	applied	\N	\N	\N	\N	121755	121755	289447
15370	19102	1	applied	\N	\N	\N	\N	121756	121756	289448
15377	19082	0	applied	\N	\N	\N	\N	121766	121766	289458
15377	19084	1	applied	\N	\N	\N	\N	121767	121767	289459
15377	19087	2	applied	\N	\N	\N	\N	121768	121768	289460
15377	19089	3	applied	\N	\N	\N	\N	121769	121769	289461
15377	19091	4	applied	\N	\N	\N	\N	121770	121770	289462
15377	19092	5	applied	\N	\N	\N	\N	121771	121771	289463
15377	19096	6	applied	\N	\N	\N	\N	121772	121772	289464
15377	19097	7	applied	\N	\N	\N	\N	121773	121773	289465
15377	19101	8	applied	\N	\N	\N	\N	121774	121774	289466
15377	19103	9	applied	\N	\N	\N	\N	121775	121775	289467
15377	19107	11	applied	\N	\N	\N	\N	121777	121777	289469
15377	19108	12	applied	\N	\N	\N	\N	121778	121778	289470
15377	19083	13	applied	\N	\N	\N	\N	121779	121779	289471
15377	19085	14	applied	\N	\N	\N	\N	121780	121780	289472
15377	19086	15	applied	\N	\N	\N	\N	121781	121781	289473
15377	19088	16	applied	\N	\N	\N	\N	121782	121782	289474
15377	19090	17	applied	\N	\N	\N	\N	121783	121783	289475
15377	19093	18	applied	\N	\N	\N	\N	121784	121784	289476
15377	19094	19	applied	\N	\N	\N	\N	121785	121785	289477
15377	19095	20	applied	\N	\N	\N	\N	121786	121786	289478
15377	19098	21	applied	\N	\N	\N	\N	121787	121787	289479
15377	19099	22	applied	\N	\N	\N	\N	121788	121788	289480
15377	19100	23	applied	\N	\N	\N	\N	121789	121789	289481
15377	19102	24	applied	\N	\N	\N	\N	121790	121790	289482
15377	19104	25	applied	\N	\N	\N	\N	121791	121791	289483
15377	19105	26	applied	\N	\N	\N	\N	121792	121792	289484
15377	19110	28	applied	\N	\N	\N	\N	121794	121794	289486
15377	19111	29	applied	\N	\N	\N	\N	121795	121795	289487
15377	19112	30	applied	\N	\N	\N	\N	121796	121796	289488
15380	18772	0	applied	\N	\N	1000000000	\N	121810	121810	289501
15385	19128	0	applied	\N	\N	\N	\N	121820	121820	289510
15380	19116	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	121811	121811	\N
15385	19129	1	applied	\N	\N	\N	\N	121821	121821	289511
15385	19130	2	applied	\N	\N	\N	\N	121822	121822	289512
15387	19131	0	applied	\N	\N	\N	\N	121823	121823	289513
15387	19132	1	applied	\N	\N	\N	\N	121824	121824	289514
15396	19138	0	applied	\N	\N	\N	\N	121837	121837	289527
15396	19139	1	applied	\N	\N	\N	\N	121838	121838	289528
15398	19140	0	applied	\N	\N	\N	\N	121841	121841	289531
15398	19141	1	applied	\N	\N	\N	\N	121842	121842	289532
15398	19142	2	applied	\N	\N	\N	\N	121843	121843	289533
15401	19147	0	applied	\N	\N	\N	\N	121848	121848	289538
15401	19149	2	applied	\N	\N	\N	\N	121850	121850	289540
15401	19150	3	applied	\N	\N	\N	\N	121851	121851	289541
15401	19151	4	applied	\N	\N	\N	\N	121852	121852	289542
15406	19156	0	applied	\N	\N	\N	\N	121863	121863	289553
15406	19157	1	applied	\N	\N	\N	\N	121864	121864	289554
15406	19158	2	applied	\N	\N	\N	\N	121865	121865	289555
15406	19159	3	applied	\N	\N	\N	\N	121866	121866	289556
15406	19160	4	applied	\N	\N	\N	\N	121867	121867	289557
15406	19161	5	applied	\N	\N	\N	\N	121868	121868	289558
15422	19182	0	applied	\N	\N	\N	\N	121917	121917	289607
15422	19183	1	applied	\N	\N	\N	\N	121918	121918	289608
15424	19184	0	applied	\N	\N	\N	\N	121922	121922	289612
15424	19185	1	applied	\N	\N	\N	\N	121923	121923	289613
15424	19186	2	applied	\N	\N	\N	\N	121924	121924	289614
15434	19201	0	applied	\N	\N	\N	\N	121955	121955	289645
15434	19202	1	applied	\N	\N	\N	\N	121956	121956	289646
15434	19204	3	applied	\N	\N	\N	\N	121958	121958	289648
15434	19205	4	applied	\N	\N	\N	\N	121959	121959	289649
15437	19210	0	applied	\N	\N	\N	\N	121968	121968	289658
15437	19211	1	applied	\N	\N	\N	\N	121969	121969	289659
15437	19212	2	applied	\N	\N	\N	\N	121970	121970	289660
15437	19213	3	applied	\N	\N	\N	\N	121971	121971	289661
15437	19214	4	applied	\N	\N	\N	\N	121972	121972	289662
15439	19210	0	applied	\N	\N	\N	\N	121978	121978	289668
15439	19211	1	applied	\N	\N	\N	\N	121979	121979	289669
15439	19212	2	applied	\N	\N	\N	\N	121980	121980	289670
15439	19213	3	applied	\N	\N	\N	\N	121981	121981	289671
15439	19214	4	applied	\N	\N	\N	\N	121982	121982	289672
15441	19215	0	applied	\N	\N	\N	\N	122011	122011	289701
15441	19216	1	applied	\N	\N	\N	\N	122012	122012	289702
15443	19215	0	applied	\N	\N	\N	\N	122015	122015	289705
15443	19216	1	applied	\N	\N	\N	\N	122016	122016	289706
15446	19223	1	applied	\N	\N	\N	\N	122025	122025	289715
15449	19231	0	applied	\N	\N	\N	\N	122036	122036	289726
15449	19232	1	applied	\N	\N	\N	\N	122037	122037	289727
15449	19233	2	applied	\N	\N	\N	\N	122038	122038	289728
15456	19241	0	applied	\N	\N	\N	\N	122067	122067	289757
15456	19242	1	applied	\N	\N	\N	\N	122068	122068	289758
15458	19243	0	applied	\N	\N	\N	\N	122071	122071	289761
15458	19244	1	applied	\N	\N	\N	\N	122072	122072	289762
15467	19250	0	applied	\N	\N	\N	\N	122208	122208	289897
15467	19251	1	applied	\N	\N	\N	\N	122209	122209	289898
15467	19252	2	applied	\N	\N	\N	\N	122210	122210	289899
15467	19253	3	applied	\N	\N	\N	\N	122211	122211	289900
15472	19262	0	applied	\N	\N	\N	\N	122221	122221	289910
15472	19263	1	applied	\N	\N	\N	\N	122222	122222	289911
15476	19262	0	applied	\N	\N	\N	\N	122229	122229	289918
15476	19263	1	applied	\N	\N	\N	\N	122230	122230	289919
15479	19270	1	applied	\N	\N	\N	\N	122242	122242	289931
15479	19271	2	applied	\N	\N	\N	\N	122243	122243	289932
15479	19272	3	applied	\N	\N	\N	\N	122244	122244	289933
15481	19269	0	applied	\N	\N	\N	\N	122249	122249	289938
15481	19270	1	applied	\N	\N	\N	\N	122250	122250	289939
15481	19271	2	applied	\N	\N	\N	\N	122251	122251	289940
15350	19080	1	applied	\N	\N	\N	\N	121704	121704	289396
15350	19081	2	applied	\N	\N	\N	\N	121705	121705	289397
15409	19165	3	applied	\N	\N	\N	\N	121880	121880	289570
15411	19166	0	applied	\N	\N	\N	\N	121885	121885	289575
15411	19167	1	applied	\N	\N	\N	\N	121886	121886	289576
15413	19168	0	applied	\N	\N	\N	\N	121891	121891	289581
15413	19169	1	applied	\N	\N	\N	\N	121892	121892	289582
15413	19170	2	applied	\N	\N	\N	\N	121893	121893	289583
15413	19171	3	applied	\N	\N	\N	\N	121894	121894	289584
15415	19172	0	applied	\N	\N	\N	\N	121897	121897	289587
15415	19173	1	applied	\N	\N	\N	\N	121898	121898	289588
15415	19174	2	applied	\N	\N	\N	\N	121899	121899	289589
15416	19175	0	applied	\N	\N	\N	\N	121900	121900	289590
15416	19176	1	applied	\N	\N	\N	\N	121901	121901	289591
15416	19177	2	applied	\N	\N	\N	\N	121902	121902	289592
15418	19175	0	applied	\N	\N	\N	\N	121906	121906	289596
15418	19176	1	applied	\N	\N	\N	\N	121907	121907	289597
15418	19177	2	applied	\N	\N	\N	\N	121908	121908	289598
15420	19183	1	applied	\N	\N	\N	\N	121914	121914	289604
15423	19184	0	applied	\N	\N	\N	\N	121919	121919	289609
15423	19185	1	applied	\N	\N	\N	\N	121920	121920	289610
15423	19186	2	applied	\N	\N	\N	\N	121921	121921	289611
15425	19187	0	applied	\N	\N	\N	\N	121925	121925	289615
15425	19188	1	applied	\N	\N	\N	\N	121926	121926	289616
15427	19189	0	applied	\N	\N	\N	\N	121929	121929	289619
15427	19190	1	applied	\N	\N	\N	\N	121930	121930	289620
15429	19189	0	applied	\N	\N	\N	\N	121933	121933	289623
15429	19190	1	applied	\N	\N	\N	\N	121934	121934	289624
15431	19191	0	applied	\N	\N	\N	\N	121938	121938	289628
15431	19192	1	applied	\N	\N	\N	\N	121939	121939	289629
15431	19193	2	applied	\N	\N	\N	\N	121940	121940	289630
15432	19194	0	applied	\N	\N	\N	\N	121941	121941	289631
15432	19195	1	applied	\N	\N	\N	\N	121942	121942	289632
15432	19196	2	applied	\N	\N	\N	\N	121943	121943	289633
15432	19198	4	applied	\N	\N	\N	\N	121945	121945	289635
15432	19199	5	applied	\N	\N	\N	\N	121946	121946	289636
15432	19200	6	applied	\N	\N	\N	\N	121947	121947	289637
15433	19194	0	applied	\N	\N	\N	\N	121948	121948	289638
15433	19195	1	applied	\N	\N	\N	\N	121949	121949	289639
15433	19196	2	applied	\N	\N	\N	\N	121950	121950	289640
15433	19197	3	applied	\N	\N	\N	\N	121951	121951	289641
15433	19198	4	applied	\N	\N	\N	\N	121952	121952	289642
15433	19199	5	applied	\N	\N	\N	\N	121953	121953	289643
15433	19200	6	applied	\N	\N	\N	\N	121954	121954	289644
15435	19206	0	applied	\N	\N	\N	\N	121960	121960	289650
15435	19207	1	applied	\N	\N	\N	\N	121961	121961	289651
15435	19208	2	applied	\N	\N	\N	\N	121962	121962	289652
15435	19209	3	applied	\N	\N	\N	\N	121963	121963	289653
15438	19210	0	applied	\N	\N	\N	\N	121973	121973	289663
15438	19211	1	applied	\N	\N	\N	\N	121974	121974	289664
15438	19213	3	applied	\N	\N	\N	\N	121976	121976	289666
15438	19214	4	applied	\N	\N	\N	\N	121977	121977	289667
15440	19187	0	applied	\N	\N	\N	\N	121983	121983	289673
15440	19189	1	applied	\N	\N	\N	\N	121984	121984	289674
15440	19191	2	applied	\N	\N	\N	\N	121985	121985	289675
15440	19194	3	applied	\N	\N	\N	\N	121986	121986	289676
15440	19195	4	applied	\N	\N	\N	\N	121987	121987	289677
15440	19196	5	applied	\N	\N	\N	\N	121988	121988	289678
15440	19201	6	applied	\N	\N	\N	\N	121989	121989	289679
15440	19202	7	applied	\N	\N	\N	\N	121990	121990	289680
15440	19206	8	applied	\N	\N	\N	\N	121991	121991	289681
15440	19207	9	applied	\N	\N	\N	\N	121992	121992	289682
15440	19210	10	applied	\N	\N	\N	\N	121993	121993	289683
15440	19211	11	applied	\N	\N	\N	\N	121994	121994	289684
15440	19188	12	applied	\N	\N	\N	\N	121995	121995	289685
15440	19190	13	applied	\N	\N	\N	\N	121996	121996	289686
15440	19193	15	applied	\N	\N	\N	\N	121998	121998	289688
15440	19197	16	applied	\N	\N	\N	\N	121999	121999	289689
15440	19198	17	applied	\N	\N	\N	\N	122000	122000	289690
15440	19199	18	applied	\N	\N	\N	\N	122001	122001	289691
15440	19200	19	applied	\N	\N	\N	\N	122002	122002	289692
15440	19203	20	applied	\N	\N	\N	\N	122003	122003	289693
15440	19204	21	applied	\N	\N	\N	\N	122004	122004	289694
15440	19205	22	applied	\N	\N	\N	\N	122005	122005	289695
15440	19208	23	applied	\N	\N	\N	\N	122006	122006	289696
15440	19209	24	applied	\N	\N	\N	\N	122007	122007	289697
15440	19212	25	applied	\N	\N	\N	\N	122008	122008	289698
15440	19213	26	applied	\N	\N	\N	\N	122009	122009	289699
15440	19214	27	applied	\N	\N	\N	\N	122010	122010	289700
15442	19215	0	applied	\N	\N	\N	\N	122013	122013	289703
15442	19216	1	applied	\N	\N	\N	\N	122014	122014	289704
15444	19215	0	applied	\N	\N	\N	\N	122017	122017	289707
15447	19224	0	applied	\N	\N	\N	\N	122026	122026	289716
15447	19225	1	applied	\N	\N	\N	\N	122027	122027	289717
15447	19226	2	applied	\N	\N	\N	\N	122028	122028	289718
15447	19227	3	applied	\N	\N	\N	\N	122029	122029	289719
15447	19228	4	applied	\N	\N	\N	\N	122030	122030	289720
15447	19229	5	applied	\N	\N	\N	\N	122031	122031	289721
15447	19230	6	applied	\N	\N	\N	\N	122032	122032	289722
15448	19231	0	applied	\N	\N	\N	\N	122033	122033	289723
15448	19232	1	applied	\N	\N	\N	\N	122034	122034	289724
15448	19233	2	applied	\N	\N	\N	\N	122035	122035	289725
15452	19234	0	applied	\N	\N	\N	\N	122039	122039	289729
15452	19235	1	applied	\N	\N	\N	\N	122040	122040	289730
15452	19236	2	applied	\N	\N	\N	\N	122041	122041	289731
15452	19237	3	applied	\N	\N	\N	\N	122042	122042	289732
15452	19238	4	applied	\N	\N	\N	\N	122043	122043	289733
15457	19241	0	applied	\N	\N	\N	\N	122069	122069	289759
15460	19245	0	applied	\N	\N	\N	\N	122075	122075	289765
15460	19246	1	applied	\N	\N	\N	\N	122076	122076	289766
15471	19259	0	applied	\N	\N	\N	\N	122218	122218	289907
15471	19260	1	applied	\N	\N	\N	\N	122219	122219	289908
15471	19261	2	applied	\N	\N	\N	\N	122220	122220	289909
15473	19262	0	applied	\N	\N	\N	\N	122223	122223	289912
15473	19263	1	applied	\N	\N	\N	\N	122224	122224	289913
15475	19262	0	applied	\N	\N	\N	\N	122227	122227	289916
15475	19263	1	applied	\N	\N	\N	\N	122228	122228	289917
15478	19264	0	applied	\N	\N	\N	\N	122236	122236	289925
15478	19265	1	applied	\N	\N	\N	\N	122237	122237	289926
15478	19266	2	applied	\N	\N	\N	\N	122238	122238	289927
15478	19267	3	applied	\N	\N	\N	\N	122239	122239	289928
15478	19268	4	applied	\N	\N	\N	\N	122240	122240	289929
15409	19162	0	applied	\N	\N	\N	\N	121877	121877	289567
15409	19163	1	applied	\N	\N	\N	\N	121878	121878	289568
15410	19165	3	applied	\N	\N	\N	\N	121884	121884	289574
15412	19168	0	applied	\N	\N	\N	\N	121887	121887	289577
15412	19169	1	applied	\N	\N	\N	\N	121888	121888	289578
15412	19170	2	applied	\N	\N	\N	\N	121889	121889	289579
15412	19171	3	applied	\N	\N	\N	\N	121890	121890	289580
15414	19162	0	applied	\N	\N	\N	\N	121895	121895	289585
15414	19163	1	applied	\N	\N	\N	\N	121896	121896	289586
15419	19178	0	applied	\N	\N	\N	\N	121909	121909	289599
15419	19179	1	applied	\N	\N	\N	\N	121910	121910	289600
15419	19180	2	applied	\N	\N	\N	\N	121911	121911	289601
15419	19181	3	applied	\N	\N	\N	\N	121912	121912	289602
15421	19182	0	applied	\N	\N	\N	\N	121915	121915	289605
15421	19183	1	applied	\N	\N	\N	\N	121916	121916	289606
15426	19189	0	applied	\N	\N	\N	\N	121927	121927	289617
15428	19189	0	applied	\N	\N	\N	\N	121931	121931	289621
15428	19190	1	applied	\N	\N	\N	\N	121932	121932	289622
15430	19191	0	applied	\N	\N	\N	\N	121935	121935	289625
15430	19192	1	applied	\N	\N	\N	\N	121936	121936	289626
15430	19193	2	applied	\N	\N	\N	\N	121937	121937	289627
15436	19206	0	applied	\N	\N	\N	\N	121964	121964	289654
15436	19207	1	applied	\N	\N	\N	\N	121965	121965	289655
15436	19208	2	applied	\N	\N	\N	\N	121966	121966	289656
15436	19209	3	applied	\N	\N	\N	\N	121967	121967	289657
15445	19217	0	applied	\N	\N	\N	\N	122019	122019	289709
15445	19218	1	applied	\N	\N	\N	\N	122020	122020	289710
15445	19219	2	applied	\N	\N	\N	\N	122021	122021	289711
15445	19220	3	applied	\N	\N	\N	\N	122022	122022	289712
15445	19221	4	applied	\N	\N	\N	\N	122023	122023	289713
15453	19234	0	applied	\N	\N	\N	\N	122046	122046	289736
15453	19235	1	applied	\N	\N	\N	\N	122047	122047	289737
15453	19237	3	applied	\N	\N	\N	\N	122049	122049	289739
15453	19238	4	applied	\N	\N	\N	\N	122050	122050	289740
15453	19239	5	applied	\N	\N	\N	\N	122051	122051	289741
15453	19240	6	applied	\N	\N	\N	\N	122052	122052	289742
15455	19234	0	applied	\N	\N	\N	\N	122060	122060	289750
15455	19235	1	applied	\N	\N	\N	\N	122061	122061	289751
15455	19236	2	applied	\N	\N	\N	\N	122062	122062	289752
15455	19237	3	applied	\N	\N	\N	\N	122063	122063	289753
15455	19238	4	applied	\N	\N	\N	\N	122064	122064	289754
15455	19239	5	applied	\N	\N	\N	\N	122065	122065	289755
15455	19240	6	applied	\N	\N	\N	\N	122066	122066	289756
15462	19247	0	applied	\N	\N	\N	\N	122202	122202	289891
15462	19248	1	applied	\N	\N	\N	\N	122203	122203	289892
15462	19249	2	applied	\N	\N	\N	\N	122204	122204	289893
15469	19254	0	applied	\N	\N	\N	\N	122213	122213	289902
15469	19255	1	applied	\N	\N	\N	\N	122214	122214	289903
15474	19262	0	applied	\N	\N	\N	\N	122225	122225	289914
15474	19263	1	applied	\N	\N	\N	\N	122226	122226	289915
15480	19269	0	applied	\N	\N	\N	\N	122245	122245	289934
15480	19270	1	applied	\N	\N	\N	\N	122246	122246	289935
15480	19271	2	applied	\N	\N	\N	\N	122247	122247	289936
15480	19272	3	applied	\N	\N	\N	\N	122248	122248	289937
15483	19276	0	applied	\N	\N	\N	\N	122256	122256	289945
15483	19277	1	applied	\N	\N	\N	\N	122257	122257	289946
15485	19278	0	applied	\N	\N	\N	\N	122261	122261	289950
15485	19279	1	applied	\N	\N	\N	\N	122262	122262	289951
15485	19280	2	applied	\N	\N	\N	\N	122263	122263	289952
15487	19278	0	applied	\N	\N	\N	\N	122264	122264	289953
15487	19279	1	applied	\N	\N	\N	\N	122265	122265	289954
15487	19280	2	applied	\N	\N	\N	\N	122266	122266	289955
15489	19281	0	applied	\N	\N	\N	\N	122267	122267	289956
15494	19282	0	applied	\N	\N	\N	\N	122272	122272	289961
15494	19284	2	applied	\N	\N	\N	\N	122274	122274	289963
15494	19285	3	applied	\N	\N	\N	\N	122275	122275	289964
15494	19286	4	applied	\N	\N	\N	\N	122276	122276	289965
15494	19287	5	applied	\N	\N	\N	\N	122277	122277	289966
15495	19288	0	applied	\N	\N	\N	\N	122278	122278	289967
15495	19289	1	applied	\N	\N	\N	\N	122279	122279	289968
15495	19290	2	applied	\N	\N	\N	\N	122280	122280	289969
15495	19291	3	applied	\N	\N	\N	\N	122281	122281	289970
15495	19292	4	applied	\N	\N	\N	\N	122282	122282	289971
15495	19293	5	applied	\N	\N	\N	\N	122283	122283	289972
15499	19294	0	applied	\N	\N	\N	\N	122296	122296	289985
15499	19295	1	applied	\N	\N	\N	\N	122297	122297	289986
15499	19296	2	applied	\N	\N	\N	\N	122298	122298	289987
15501	19297	0	applied	\N	\N	\N	\N	122302	122302	289991
15501	19298	1	applied	\N	\N	\N	\N	122303	122303	289992
15501	19299	2	applied	\N	\N	\N	\N	122304	122304	289993
15504	19301	0	applied	\N	\N	\N	\N	122309	122309	289998
15504	19302	1	applied	\N	\N	\N	\N	122310	122310	289999
15504	19303	2	applied	\N	\N	\N	\N	122311	122311	290000
15504	19304	3	applied	\N	\N	\N	\N	122312	122312	290001
15504	19305	4	applied	\N	\N	\N	\N	122313	122313	290002
15504	19306	5	applied	\N	\N	\N	\N	122314	122314	290003
15504	19307	6	applied	\N	\N	\N	\N	122315	122315	290004
15504	19308	7	applied	\N	\N	\N	\N	122316	122316	290005
15507	19309	0	applied	\N	\N	\N	\N	122317	122317	290006
15507	19310	1	applied	\N	\N	\N	\N	122318	122318	290007
15508	19309	0	applied	\N	\N	\N	\N	122319	122319	290008
15508	19310	1	applied	\N	\N	\N	\N	122320	122320	290009
15511	19312	0	applied	\N	\N	\N	\N	122325	122325	290014
15515	19313	0	applied	\N	\N	1000000000	\N	122341	122341	290030
15515	19311	2	applied	\N	\N	\N	\N	122342	122342	290031
15515	19315	3	applied	\N	\N	\N	\N	122343	122343	290032
15521	19328	0	applied	\N	\N	\N	\N	122357	122357	290046
15521	19329	1	applied	\N	\N	\N	\N	122358	122358	290047
15521	19330	2	applied	\N	\N	\N	\N	122359	122359	290048
15521	19331	3	applied	\N	\N	\N	\N	122360	122360	290049
15523	19332	0	applied	\N	\N	\N	\N	122367	122367	290056
15523	19333	1	applied	\N	\N	\N	\N	122368	122368	290057
15523	19334	2	applied	\N	\N	\N	\N	122369	122369	290058
15523	19335	3	applied	\N	\N	\N	\N	122370	122370	290059
15523	19336	4	applied	\N	\N	\N	\N	122371	122371	290060
15523	19337	5	applied	\N	\N	\N	\N	122372	122372	290061
15525	19338	0	applied	\N	\N	\N	\N	122379	122379	290068
15525	19339	1	applied	\N	\N	\N	\N	122380	122380	290069
15527	19338	0	applied	\N	\N	\N	\N	122383	122383	290072
15527	19339	1	applied	\N	\N	\N	\N	122384	122384	290073
15530	19342	0	applied	\N	\N	\N	\N	122394	122394	290083
15530	19343	1	applied	\N	\N	\N	\N	122395	122395	290084
15410	19164	2	applied	\N	\N	\N	\N	121883	121883	289573
15454	19235	1	applied	\N	\N	\N	\N	122054	122054	289744
15454	19236	2	applied	\N	\N	\N	\N	122055	122055	289745
15454	19237	3	applied	\N	\N	\N	\N	122056	122056	289746
15454	19238	4	applied	\N	\N	\N	\N	122057	122057	289747
15454	19239	5	applied	\N	\N	\N	\N	122058	122058	289748
15454	19240	6	applied	\N	\N	\N	\N	122059	122059	289749
15459	19245	0	applied	\N	\N	\N	\N	122073	122073	289763
15459	19246	1	applied	\N	\N	\N	\N	122074	122074	289764
15461	19003	0	applied	\N	\N	\N	\N	122077	122077	289767
15461	19162	1	applied	\N	\N	\N	\N	122078	122078	289768
15461	19163	2	applied	\N	\N	\N	\N	122079	122079	289769
15461	19169	3	applied	\N	\N	\N	\N	122080	122080	289770
15461	19170	4	applied	\N	\N	\N	\N	122081	122081	289771
15461	19007	6	applied	\N	\N	\N	\N	122083	122083	289773
15461	19009	7	applied	\N	\N	\N	\N	122084	122084	289774
15461	19012	8	applied	\N	\N	\N	\N	122085	122085	289775
15461	19013	9	applied	\N	\N	\N	\N	122086	122086	289776
15461	19016	10	applied	\N	\N	\N	\N	122087	122087	289777
15461	19019	11	applied	\N	\N	\N	\N	122088	122088	289778
15461	19021	12	applied	\N	\N	\N	\N	122089	122089	289779
15461	19023	13	applied	\N	\N	\N	\N	122090	122090	289780
15461	19024	14	applied	\N	\N	\N	\N	122091	122091	289781
15461	19028	15	applied	\N	\N	\N	\N	122092	122092	289782
15461	19031	17	applied	\N	\N	\N	\N	122093	122093	289783
15461	19032	18	applied	\N	\N	\N	\N	122094	122094	289784
15461	19035	19	applied	\N	\N	\N	\N	122095	122095	289785
15461	19038	20	applied	\N	\N	\N	\N	122096	122096	289786
15461	19040	21	applied	\N	\N	\N	\N	122097	122097	289787
15461	19041	22	applied	\N	\N	\N	\N	122098	122098	289788
15461	19047	24	applied	\N	\N	\N	\N	122100	122100	289790
15461	19050	25	applied	\N	\N	\N	\N	122101	122101	289791
15461	19051	26	applied	\N	\N	\N	\N	122102	122102	289792
15461	19054	27	applied	\N	\N	\N	\N	122103	122103	289793
15461	19056	28	applied	\N	\N	\N	\N	122104	122104	289794
15461	19057	29	applied	\N	\N	\N	\N	122105	122105	289795
15461	19058	30	applied	\N	\N	\N	\N	122106	122106	289796
15461	19063	31	applied	\N	\N	\N	\N	122107	122107	289797
15461	19064	32	applied	\N	\N	\N	\N	122108	122108	289798
15461	19065	33	applied	\N	\N	\N	\N	122109	122109	289799
15461	19070	34	applied	\N	\N	\N	\N	122110	122110	289800
15461	19073	35	applied	\N	\N	\N	\N	122111	122111	289801
15461	19075	36	applied	\N	\N	\N	\N	122112	122112	289802
15461	19078	37	applied	\N	\N	\N	\N	122113	122113	289803
15461	19079	38	applied	\N	\N	\N	\N	122114	122114	289804
15461	19082	39	applied	\N	\N	\N	\N	122115	122115	289805
15461	19087	41	applied	\N	\N	\N	\N	122117	122117	289807
15461	19089	42	applied	\N	\N	\N	\N	122118	122118	289808
15461	19091	43	applied	\N	\N	\N	\N	122119	122119	289809
15461	19092	44	applied	\N	\N	\N	\N	122120	122120	289810
15461	19096	45	applied	\N	\N	\N	\N	122121	122121	289811
15461	19097	46	applied	\N	\N	\N	\N	122122	122122	289812
15461	19101	47	applied	\N	\N	\N	\N	122123	122123	289813
15461	19103	48	applied	\N	\N	\N	\N	122124	122124	289814
15461	19106	49	applied	\N	\N	\N	\N	122125	122125	289815
15461	19107	50	applied	\N	\N	\N	\N	122126	122126	289816
15461	19108	51	applied	\N	\N	\N	\N	122127	122127	289817
15461	19113	52	applied	\N	\N	\N	\N	122128	122128	289818
15461	19114	53	applied	\N	\N	\N	\N	122129	122129	289819
15461	19115	54	applied	\N	\N	\N	\N	122130	122130	289820
15461	19120	55	applied	\N	\N	\N	\N	122131	122131	289821
15461	19121	56	applied	\N	\N	\N	\N	122132	122132	289822
15461	19128	58	applied	\N	\N	\N	\N	122134	122134	289824
15461	19131	59	applied	\N	\N	\N	\N	122135	122135	289825
15461	19133	60	applied	\N	\N	\N	\N	122136	122136	289826
15461	19136	61	applied	\N	\N	\N	\N	122137	122137	289827
15513	19313	0	applied	\N	\N	1000000000	\N	122331	122331	290020
15513	19311	2	applied	\N	\N	\N	\N	122332	122332	290021
15513	19314	3	applied	\N	\N	\N	\N	122333	122333	290022
15513	19315	4	applied	\N	\N	\N	\N	122334	122334	290023
15513	19316	5	applied	\N	\N	\N	\N	122335	122335	290024
15518	19323	0	applied	\N	\N	\N	\N	122352	122352	290041
15518	19324	1	applied	\N	\N	\N	\N	122353	122353	290042
15528	19340	0	applied	\N	\N	\N	\N	122385	122385	290074
15528	19341	1	applied	\N	\N	\N	\N	122386	122386	290075
15531	19349	0	applied	\N	\N	\N	\N	122401	122401	290090
15531	19350	1	applied	\N	\N	\N	\N	122402	122402	290091
15531	19351	2	applied	\N	\N	\N	\N	122403	122403	290092
15539	19367	1	applied	\N	\N	\N	\N	122427	122427	290116
15539	19368	2	applied	\N	\N	\N	\N	122428	122428	290117
15539	19369	3	applied	\N	\N	\N	\N	122429	122429	290118
15550	19394	0	applied	\N	\N	\N	\N	122473	122473	290162
15550	19395	1	applied	\N	\N	\N	\N	122474	122474	290163
15563	19422	0	applied	\N	\N	\N	\N	122650	122650	290339
15565	19422	0	applied	\N	\N	\N	\N	122652	122652	290341
15571	19431	0	applied	\N	\N	\N	\N	122664	122664	290353
15571	19432	1	applied	\N	\N	\N	\N	122665	122665	290354
15573	19435	0	applied	\N	\N	\N	\N	122668	122668	290356
15575	19435	0	applied	\N	\N	\N	\N	122670	122670	290358
15578	19437	0	applied	\N	\N	\N	\N	122673	122673	290361
15578	19438	1	applied	\N	\N	\N	\N	122674	122674	290362
15578	19439	2	applied	\N	\N	1000000000	\N	122675	122675	290363
15582	19447	0	applied	\N	\N	\N	\N	122687	122687	290375
15586	19450	0	applied	\N	\N	\N	\N	122693	122693	290381
15586	19452	2	applied	\N	\N	\N	\N	122695	122695	290383
15586	19453	3	applied	\N	\N	\N	\N	122696	122696	290384
15589	19456	0	applied	\N	\N	\N	\N	122703	122703	290391
15589	19457	1	applied	\N	\N	\N	\N	122704	122704	290392
15589	19458	2	applied	\N	\N	\N	\N	122705	122705	290393
15589	19459	3	applied	\N	\N	\N	\N	122706	122706	290394
15589	19460	4	applied	\N	\N	\N	\N	122707	122707	290395
15589	19461	5	applied	\N	\N	\N	\N	122708	122708	290396
15591	19456	0	applied	\N	\N	\N	\N	122715	122715	290403
15591	19457	1	applied	\N	\N	\N	\N	122716	122716	290404
15591	19458	2	applied	\N	\N	\N	\N	122717	122717	290405
15591	19459	3	applied	\N	\N	\N	\N	122718	122718	290406
15591	19460	4	applied	\N	\N	\N	\N	122719	122719	290407
15591	19461	5	applied	\N	\N	\N	\N	122720	122720	290408
15597	19468	0	applied	\N	\N	\N	\N	122733	122733	290421
15597	19469	1	applied	\N	\N	\N	\N	122734	122734	290422
15452	19240	6	applied	\N	\N	\N	\N	122045	122045	289735
15454	19234	0	applied	\N	\N	\N	\N	122053	122053	289743
15461	19145	65	applied	\N	\N	\N	\N	122141	122141	289831
15461	19147	66	applied	\N	\N	\N	\N	122142	122142	289832
15461	19148	67	applied	\N	\N	\N	\N	122143	122143	289833
15461	19152	68	applied	\N	\N	\N	\N	122144	122144	289834
15461	19155	69	applied	\N	\N	\N	\N	122145	122145	289835
15461	19157	71	applied	\N	\N	\N	\N	122147	122147	289837
15461	19164	72	applied	\N	\N	\N	\N	122148	122148	289838
15461	19166	73	applied	\N	\N	\N	\N	122149	122149	289839
15461	19168	74	applied	\N	\N	\N	\N	122150	122150	289840
15461	19172	75	applied	\N	\N	\N	\N	122151	122151	289841
15461	19175	76	applied	\N	\N	\N	\N	122152	122152	289842
15461	19178	77	applied	\N	\N	\N	\N	122153	122153	289843
15461	19179	78	applied	\N	\N	\N	\N	122154	122154	289844
15461	19182	79	applied	\N	\N	\N	\N	122155	122155	289845
15461	19184	80	applied	\N	\N	\N	\N	122156	122156	289846
15461	19187	81	applied	\N	\N	\N	\N	122157	122157	289847
15461	19189	82	applied	\N	\N	\N	\N	122158	122158	289848
15461	19191	83	applied	\N	\N	\N	\N	122159	122159	289849
15461	19194	84	applied	\N	\N	\N	\N	122160	122160	289850
15461	19195	85	applied	\N	\N	\N	\N	122161	122161	289851
15461	19196	86	applied	\N	\N	\N	\N	122162	122162	289852
15461	19202	88	applied	\N	\N	\N	\N	122164	122164	289854
15461	19206	89	applied	\N	\N	\N	\N	122165	122165	289855
15461	19207	90	applied	\N	\N	\N	\N	122166	122166	289856
15461	19210	91	applied	\N	\N	\N	\N	122167	122167	289857
15461	19211	92	applied	\N	\N	\N	\N	122168	122168	289858
15461	19215	93	applied	\N	\N	\N	\N	122169	122169	289859
15461	19217	94	applied	\N	\N	\N	\N	122170	122170	289860
15461	19218	95	applied	\N	\N	\N	\N	122171	122171	289861
15461	19222	96	applied	\N	\N	\N	\N	122172	122172	289862
15461	19224	97	applied	\N	\N	\N	\N	122173	122173	289863
15461	19225	98	applied	\N	\N	\N	\N	122174	122174	289864
15461	19226	99	applied	\N	\N	\N	\N	122175	122175	289865
15461	19231	100	applied	\N	\N	\N	\N	122176	122176	289866
15461	19234	101	applied	\N	\N	\N	\N	122177	122177	289867
15461	19235	102	applied	\N	\N	\N	\N	122178	122178	289868
15461	19236	103	applied	\N	\N	\N	\N	122179	122179	289869
15461	19243	105	applied	\N	\N	\N	\N	122181	122181	289871
15461	19245	106	applied	\N	\N	\N	\N	122182	122182	289872
15461	19005	108	applied	\N	\N	\N	\N	122184	122184	289873
15461	19116	107	failed	Amount_insufficient_to_create_account	\N	\N	\N	122183	122183	\N
15461	19127	109	applied	\N	\N	\N	\N	122185	122185	289874
15461	19006	110	applied	\N	\N	\N	\N	122186	122186	289875
15461	19008	111	applied	\N	\N	\N	\N	122187	122187	289876
15461	19010	112	applied	\N	\N	\N	\N	122188	122188	289877
15461	19011	113	applied	\N	\N	\N	\N	122189	122189	289878
15461	19014	114	applied	\N	\N	\N	\N	122190	122190	289879
15461	19015	115	applied	\N	\N	\N	\N	122191	122191	289880
15461	19017	116	applied	\N	\N	\N	\N	122192	122192	289881
15461	19018	117	applied	\N	\N	\N	\N	122193	122193	289882
15461	19020	118	applied	\N	\N	\N	\N	122194	122194	289883
15461	19022	119	applied	\N	\N	\N	\N	122195	122195	289884
15461	19025	120	applied	\N	\N	\N	\N	122196	122196	289885
15461	19027	122	applied	\N	\N	\N	\N	122198	122198	289887
15461	19029	123	applied	\N	\N	\N	\N	122199	122199	289888
15461	19030	124	applied	\N	\N	\N	\N	122200	122200	289889
15461	19033	125	applied	\N	\N	\N	\N	122201	122201	289890
15463	19247	0	applied	\N	\N	\N	\N	122205	122205	289894
15463	19248	1	applied	\N	\N	\N	\N	122206	122206	289895
15463	19249	2	applied	\N	\N	\N	\N	122207	122207	289896
15468	19254	0	applied	\N	\N	\N	\N	122212	122212	289901
15470	19257	0	applied	\N	\N	\N	\N	122216	122216	289905
15470	19258	1	applied	\N	\N	\N	\N	122217	122217	289906
15477	19264	0	applied	\N	\N	\N	\N	122231	122231	289920
15477	19265	1	applied	\N	\N	\N	\N	122232	122232	289921
15477	19266	2	applied	\N	\N	\N	\N	122233	122233	289922
15477	19267	3	applied	\N	\N	\N	\N	122234	122234	289923
15477	19268	4	applied	\N	\N	\N	\N	122235	122235	289924
15482	19273	0	applied	\N	\N	\N	\N	122253	122253	289942
15482	19275	2	applied	\N	\N	\N	\N	122255	122255	289944
15493	19162	0	applied	\N	\N	\N	\N	122268	122268	289957
15493	19163	1	applied	\N	\N	\N	\N	122269	122269	289958
15493	19169	2	applied	\N	\N	\N	\N	122270	122270	289959
15493	19170	3	applied	\N	\N	\N	\N	122271	122271	289960
15497	19288	0	applied	\N	\N	\N	\N	122290	122290	289979
15497	19289	1	applied	\N	\N	\N	\N	122291	122291	289980
15497	19290	2	applied	\N	\N	\N	\N	122292	122292	289981
15497	19291	3	applied	\N	\N	\N	\N	122293	122293	289982
15497	19292	4	applied	\N	\N	\N	\N	122294	122294	289983
15497	19293	5	applied	\N	\N	\N	\N	122295	122295	289984
15500	19294	0	applied	\N	\N	\N	\N	122299	122299	289988
15500	19295	1	applied	\N	\N	\N	\N	122300	122300	289989
15500	19296	2	applied	\N	\N	\N	\N	122301	122301	289990
15510	19311	0	applied	\N	\N	\N	\N	122323	122323	290012
15510	19312	1	applied	\N	\N	\N	\N	122324	122324	290013
15512	19311	2	applied	\N	\N	\N	\N	122327	122327	290016
15512	19314	3	applied	\N	\N	\N	\N	122328	122328	290017
15512	19315	4	applied	\N	\N	\N	\N	122329	122329	290018
15512	19316	5	applied	\N	\N	\N	\N	122330	122330	290019
15514	19313	0	applied	\N	\N	1000000000	\N	122336	122336	290025
15514	19311	2	applied	\N	\N	\N	\N	122337	122337	290026
15514	19314	3	applied	\N	\N	\N	\N	122338	122338	290027
15514	19315	4	applied	\N	\N	\N	\N	122339	122339	290028
15514	19316	5	applied	\N	\N	\N	\N	122340	122340	290029
15517	19319	0	applied	\N	\N	\N	\N	122348	122348	290037
15517	19320	1	applied	\N	\N	\N	\N	122349	122349	290038
15517	19321	2	applied	\N	\N	\N	\N	122350	122350	290039
15517	19322	3	applied	\N	\N	\N	\N	122351	122351	290040
15532	19349	0	applied	\N	\N	\N	\N	122404	122404	290093
15532	19350	1	applied	\N	\N	\N	\N	122405	122405	290094
15532	19351	2	applied	\N	\N	\N	\N	122406	122406	290095
15537	19358	0	applied	\N	\N	\N	\N	122418	122418	290107
15537	19359	1	applied	\N	\N	\N	\N	122419	122419	290108
15537	19361	3	applied	\N	\N	\N	\N	122421	122421	290110
15537	19362	4	applied	\N	\N	\N	\N	122422	122422	290111
15537	19363	5	applied	\N	\N	\N	\N	122423	122423	290112
15540	19370	0	applied	\N	\N	\N	\N	122430	122430	290119
15540	19371	1	applied	\N	\N	\N	\N	122431	122431	290120
15540	19372	2	applied	\N	\N	\N	\N	122432	122432	290121
15461	19140	63	applied	\N	\N	\N	\N	122139	122139	289829
15461	19143	64	applied	\N	\N	\N	\N	122140	122140	289830
15496	19288	0	applied	\N	\N	\N	\N	122284	122284	289973
15496	19289	1	applied	\N	\N	\N	\N	122285	122285	289974
15496	19290	2	applied	\N	\N	\N	\N	122286	122286	289975
15496	19291	3	applied	\N	\N	\N	\N	122287	122287	289976
15496	19292	4	applied	\N	\N	\N	\N	122288	122288	289977
15496	19293	5	applied	\N	\N	\N	\N	122289	122289	289978
15502	19297	0	applied	\N	\N	\N	\N	122305	122305	289994
15502	19298	1	applied	\N	\N	\N	\N	122306	122306	289995
15502	19299	2	applied	\N	\N	\N	\N	122307	122307	289996
15509	19309	0	applied	\N	\N	\N	\N	122321	122321	290010
15509	19310	1	applied	\N	\N	\N	\N	122322	122322	290011
15516	19314	0	applied	\N	\N	\N	\N	122345	122345	290034
15516	19317	1	applied	\N	\N	\N	\N	122346	122346	290035
15516	19318	2	applied	\N	\N	\N	\N	122347	122347	290036
15519	19326	1	applied	\N	\N	\N	\N	122355	122355	290044
15519	19327	2	applied	\N	\N	\N	\N	122356	122356	290045
15522	19332	0	applied	\N	\N	\N	\N	122361	122361	290050
15522	19333	1	applied	\N	\N	\N	\N	122362	122362	290051
15522	19334	2	applied	\N	\N	\N	\N	122363	122363	290052
15522	19335	3	applied	\N	\N	\N	\N	122364	122364	290053
15522	19336	4	applied	\N	\N	\N	\N	122365	122365	290054
15522	19337	5	applied	\N	\N	\N	\N	122366	122366	290055
15524	19332	0	applied	\N	\N	\N	\N	122373	122373	290062
15524	19333	1	applied	\N	\N	\N	\N	122374	122374	290063
15524	19334	2	applied	\N	\N	\N	\N	122375	122375	290064
15524	19335	3	applied	\N	\N	\N	\N	122376	122376	290065
15524	19336	4	applied	\N	\N	\N	\N	122377	122377	290066
15524	19337	5	applied	\N	\N	\N	\N	122378	122378	290067
15526	19338	0	applied	\N	\N	\N	\N	122381	122381	290070
15526	19339	1	applied	\N	\N	\N	\N	122382	122382	290071
15529	19343	1	applied	\N	\N	\N	\N	122388	122388	290077
15529	19344	2	applied	\N	\N	\N	\N	122389	122389	290078
15529	19345	3	applied	\N	\N	\N	\N	122390	122390	290079
15529	19346	4	applied	\N	\N	\N	\N	122391	122391	290080
15529	19347	5	applied	\N	\N	\N	\N	122392	122392	290081
15529	19348	6	applied	\N	\N	\N	\N	122393	122393	290082
15534	19352	0	applied	\N	\N	\N	\N	122407	122407	290096
15534	19353	1	applied	\N	\N	\N	\N	122408	122408	290097
15534	19354	2	applied	\N	\N	\N	\N	122409	122409	290098
15534	19355	3	applied	\N	\N	\N	\N	122410	122410	290099
15534	19356	4	applied	\N	\N	\N	\N	122411	122411	290100
15536	19352	0	applied	\N	\N	\N	\N	122412	122412	290101
15536	19353	1	applied	\N	\N	\N	\N	122413	122413	290102
15536	19357	2	applied	\N	\N	\N	\N	122414	122414	290103
15536	19354	3	applied	\N	\N	\N	\N	122415	122415	290104
15536	19355	4	applied	\N	\N	\N	\N	122416	122416	290105
15542	19373	0	applied	\N	\N	\N	\N	122437	122437	290126
15542	19374	1	applied	\N	\N	\N	\N	122438	122438	290127
15542	19375	2	applied	\N	\N	\N	\N	122439	122439	290128
15542	19376	3	applied	\N	\N	\N	\N	122440	122440	290129
15544	19373	0	applied	\N	\N	\N	\N	122445	122445	290134
15544	19374	1	applied	\N	\N	\N	\N	122446	122446	290135
15544	19375	2	applied	\N	\N	\N	\N	122447	122447	290136
15544	19376	3	applied	\N	\N	\N	\N	122448	122448	290137
15545	19377	0	applied	\N	\N	\N	\N	122449	122449	290138
15545	19378	1	applied	\N	\N	\N	\N	122450	122450	290139
15545	19379	2	applied	\N	\N	\N	\N	122451	122451	290140
15546	19380	0	applied	\N	\N	\N	\N	122452	122452	290141
15546	19381	1	applied	\N	\N	\N	\N	122453	122453	290142
15546	19382	2	applied	\N	\N	\N	\N	122454	122454	290143
15546	19383	3	applied	\N	\N	\N	\N	122455	122455	290144
15546	19384	4	applied	\N	\N	\N	\N	122456	122456	290145
15546	19386	6	applied	\N	\N	\N	\N	122458	122458	290147
15546	19387	7	applied	\N	\N	\N	\N	122459	122459	290148
15546	19388	8	applied	\N	\N	\N	\N	122460	122460	290149
15548	19389	0	applied	\N	\N	\N	\N	122466	122466	290155
15548	19390	1	applied	\N	\N	\N	\N	122467	122467	290156
15548	19391	2	applied	\N	\N	\N	\N	122468	122468	290157
15548	19392	3	applied	\N	\N	\N	\N	122469	122469	290158
15548	19393	4	applied	\N	\N	\N	\N	122470	122470	290159
15551	19396	0	applied	\N	\N	\N	\N	122475	122475	290164
15551	19397	2	applied	\N	\N	\N	\N	122476	122476	290165
15551	19398	3	applied	\N	\N	\N	\N	122477	122477	290166
15551	19399	4	applied	\N	\N	\N	\N	122478	122478	290167
15551	19400	5	applied	\N	\N	\N	\N	122479	122479	290168
15551	19401	6	applied	\N	\N	\N	\N	122480	122480	290169
15551	19402	7	applied	\N	\N	\N	\N	122481	122481	290170
15554	19405	0	applied	\N	\N	\N	\N	122485	122485	290174
15554	19407	2	applied	\N	\N	\N	\N	122487	122487	290176
15554	19408	3	applied	\N	\N	\N	\N	122488	122488	290177
15554	19409	4	applied	\N	\N	\N	\N	122489	122489	290178
15567	19425	0	applied	\N	\N	\N	\N	122655	122655	290344
15567	19426	1	applied	\N	\N	\N	\N	122656	122656	290345
15570	19430	0	applied	\N	\N	\N	\N	122663	122663	290352
15579	19437	0	applied	\N	\N	\N	\N	122676	122676	290364
15579	19438	1	applied	\N	\N	\N	\N	122677	122677	290365
15579	19439	2	applied	\N	\N	1000000000	\N	122678	122678	290366
15584	19448	0	applied	\N	\N	\N	\N	122689	122689	290377
15584	19449	1	applied	\N	\N	\N	\N	122690	122690	290378
15587	19450	0	applied	\N	\N	\N	\N	122697	122697	290385
15587	19451	1	applied	\N	\N	\N	\N	122698	122698	290386
15587	19452	2	applied	\N	\N	\N	\N	122699	122699	290387
15587	19453	3	applied	\N	\N	\N	\N	122700	122700	290388
15592	19462	0	applied	\N	\N	\N	\N	122721	122721	290409
15592	19464	2	applied	\N	\N	\N	\N	122723	122723	290411
15592	19465	3	applied	\N	\N	\N	\N	122724	122724	290412
15593	19466	0	applied	\N	\N	\N	\N	122725	122725	290413
15593	19467	1	applied	\N	\N	\N	\N	122726	122726	290414
15595	19466	0	applied	\N	\N	\N	\N	122729	122729	290417
15595	19467	1	applied	\N	\N	\N	\N	122730	122730	290418
15600	19472	0	applied	\N	\N	\N	\N	122739	122739	290427
15600	19473	2	applied	\N	\N	\N	\N	122740	122740	290428
15602	19474	0	applied	\N	\N	\N	\N	122743	122743	290431
15602	19475	1	applied	\N	\N	\N	\N	122744	122744	290432
15610	19487	0	applied	\N	\N	\N	\N	122765	122765	290453
15610	19488	1	applied	\N	\N	\N	\N	122766	122766	290454
15610	19489	2	applied	\N	\N	\N	\N	122767	122767	290455
15612	19487	0	applied	\N	\N	\N	\N	122771	122771	290459
15612	19488	1	applied	\N	\N	\N	\N	122772	122772	290460
15612	19489	2	applied	\N	\N	\N	\N	122773	122773	290461
15484	19280	2	applied	\N	\N	\N	\N	122260	122260	289949
15530	19347	5	applied	\N	\N	\N	\N	122399	122399	290088
15530	19348	6	applied	\N	\N	\N	\N	122400	122400	290089
15538	19364	0	applied	\N	\N	\N	\N	122424	122424	290113
15538	19365	1	applied	\N	\N	\N	\N	122425	122425	290114
15541	19373	0	applied	\N	\N	\N	\N	122433	122433	290122
15541	19374	1	applied	\N	\N	\N	\N	122434	122434	290123
15541	19375	2	applied	\N	\N	\N	\N	122435	122435	290124
15543	19373	0	applied	\N	\N	\N	\N	122441	122441	290130
15543	19374	1	applied	\N	\N	\N	\N	122442	122442	290131
15543	19375	2	applied	\N	\N	\N	\N	122443	122443	290132
15543	19376	3	applied	\N	\N	\N	\N	122444	122444	290133
15547	19389	0	applied	\N	\N	\N	\N	122461	122461	290150
15547	19390	1	applied	\N	\N	\N	\N	122462	122462	290151
15547	19391	2	applied	\N	\N	\N	\N	122463	122463	290152
15547	19392	3	applied	\N	\N	\N	\N	122464	122464	290153
15547	19393	4	applied	\N	\N	\N	\N	122465	122465	290154
15549	19394	0	applied	\N	\N	\N	\N	122471	122471	290160
15549	19395	1	applied	\N	\N	\N	\N	122472	122472	290161
15551	19403	8	applied	\N	\N	\N	\N	122482	122482	290171
15552	19404	0	applied	\N	\N	\N	\N	122483	122483	290172
15553	19404	0	applied	\N	\N	\N	\N	122484	122484	290173
15555	19405	0	applied	\N	\N	\N	\N	122490	122490	290179
15555	19406	1	applied	\N	\N	\N	\N	122491	122491	290180
15555	19408	3	applied	\N	\N	\N	\N	122493	122493	290182
15555	19409	4	applied	\N	\N	\N	\N	122494	122494	290183
15556	19410	0	applied	\N	\N	\N	\N	122495	122495	290184
15556	19411	1	applied	\N	\N	\N	\N	122496	122496	290185
15556	19412	2	applied	\N	\N	\N	\N	122497	122497	290186
15556	19413	3	applied	\N	\N	\N	\N	122498	122498	290187
15556	19414	4	applied	\N	\N	1000000000	\N	122499	122499	290188
15556	19415	5	applied	\N	\N	\N	\N	122500	122500	290189
15557	19410	0	applied	\N	\N	\N	\N	122501	122501	290190
15557	19411	1	applied	\N	\N	\N	\N	122502	122502	290191
15557	19412	2	applied	\N	\N	\N	\N	122503	122503	290192
15557	19413	3	applied	\N	\N	\N	\N	122504	122504	290193
15557	19414	4	applied	\N	\N	1000000000	\N	122505	122505	290194
15557	19415	5	applied	\N	\N	\N	\N	122506	122506	290195
15558	19410	0	applied	\N	\N	\N	\N	122507	122507	290196
15558	19411	1	applied	\N	\N	\N	\N	122508	122508	290197
15558	19413	3	applied	\N	\N	\N	\N	122510	122510	290199
15558	19414	4	applied	\N	\N	1000000000	\N	122511	122511	290200
15558	19415	5	applied	\N	\N	\N	\N	122512	122512	290201
15559	19313	0	applied	\N	\N	1000000000	\N	122513	122513	290202
15559	19143	1	applied	\N	\N	\N	\N	122514	122514	290203
15559	19145	2	applied	\N	\N	\N	\N	122515	122515	290204
15559	19147	3	applied	\N	\N	\N	\N	122516	122516	290205
15559	19148	4	applied	\N	\N	\N	\N	122517	122517	290206
15559	19152	5	applied	\N	\N	\N	\N	122518	122518	290207
15559	19155	6	applied	\N	\N	\N	\N	122519	122519	290208
15559	19156	7	applied	\N	\N	\N	\N	122520	122520	290209
15559	19157	8	applied	\N	\N	\N	\N	122521	122521	290210
15559	19162	9	applied	\N	\N	\N	\N	122522	122522	290211
15559	19163	10	applied	\N	\N	\N	\N	122523	122523	290212
15559	19169	11	applied	\N	\N	\N	\N	122524	122524	290213
15559	19170	12	applied	\N	\N	\N	\N	122525	122525	290214
15559	19166	14	applied	\N	\N	\N	\N	122527	122527	290216
15559	19168	15	applied	\N	\N	\N	\N	122528	122528	290217
15559	19172	17	applied	\N	\N	\N	\N	122529	122529	290218
15559	19175	18	applied	\N	\N	\N	\N	122530	122530	290219
15559	19178	19	applied	\N	\N	\N	\N	122531	122531	290220
15559	19179	20	applied	\N	\N	\N	\N	122532	122532	290221
15559	19182	21	applied	\N	\N	\N	\N	122533	122533	290222
15559	19184	22	applied	\N	\N	\N	\N	122534	122534	290223
15559	19187	23	applied	\N	\N	\N	\N	122535	122535	290224
15559	19189	24	applied	\N	\N	\N	\N	122536	122536	290225
15559	19191	25	applied	\N	\N	\N	\N	122537	122537	290226
15559	19194	26	applied	\N	\N	\N	\N	122538	122538	290227
15559	19195	27	applied	\N	\N	\N	\N	122539	122539	290228
15559	19196	28	applied	\N	\N	\N	\N	122540	122540	290229
15559	19201	29	applied	\N	\N	\N	\N	122541	122541	290230
15559	19202	30	applied	\N	\N	\N	\N	122542	122542	290231
15559	19207	32	applied	\N	\N	\N	\N	122544	122544	290233
15560	19416	0	applied	\N	\N	\N	\N	122638	122638	290327
15560	19417	1	applied	\N	\N	\N	\N	122639	122639	290328
15560	19418	2	applied	\N	\N	\N	\N	122640	122640	290329
15560	19419	3	applied	\N	\N	\N	\N	122641	122641	290330
15560	19420	4	applied	\N	\N	1000000000	\N	122642	122642	290331
15560	19421	5	applied	\N	\N	\N	\N	122643	122643	290332
15568	19427	0	applied	\N	\N	\N	\N	122657	122657	290346
15568	19428	1	applied	\N	\N	\N	\N	122658	122658	290347
15568	19429	2	applied	\N	\N	\N	\N	122659	122659	290348
15577	19436	0	applied	\N	\N	\N	\N	122672	122672	290360
15581	19447	0	applied	\N	\N	\N	\N	122686	122686	290374
15588	19454	0	applied	\N	\N	\N	\N	122701	122701	290389
15588	19455	1	applied	\N	\N	\N	\N	122702	122702	290390
15594	19466	0	applied	\N	\N	\N	\N	122727	122727	290415
15594	19467	1	applied	\N	\N	\N	\N	122728	122728	290416
15596	19467	1	applied	\N	\N	\N	\N	122732	122732	290420
15599	19472	0	applied	\N	\N	\N	\N	122737	122737	290425
15599	19473	2	applied	\N	\N	\N	\N	122738	122738	290426
15601	19474	0	applied	\N	\N	\N	\N	122741	122741	290429
15601	19475	1	applied	\N	\N	\N	\N	122742	122742	290430
15613	19490	0	applied	\N	\N	\N	\N	122774	122774	290462
15613	19491	1	applied	\N	\N	\N	\N	122775	122775	290463
15615	19492	0	applied	\N	\N	\N	\N	122778	122778	290466
15615	19493	1	applied	\N	\N	\N	\N	122779	122779	290467
15618	19496	0	applied	\N	\N	\N	\N	122787	122787	290475
15618	19497	1	applied	\N	\N	\N	\N	122788	122788	290476
15618	19498	2	applied	\N	\N	\N	\N	122789	122789	290477
15618	19499	3	applied	\N	\N	\N	\N	122790	122790	290478
15618	19500	4	applied	\N	\N	\N	\N	122791	122791	290479
15623	19507	0	applied	\N	\N	\N	\N	122804	122804	290492
15623	19508	1	applied	\N	\N	\N	\N	122805	122805	290493
15623	19510	3	applied	\N	\N	\N	\N	122807	122807	290495
15623	19511	4	applied	\N	\N	\N	\N	122808	122808	290496
15623	19512	5	applied	\N	\N	\N	\N	122809	122809	290497
15625	19513	0	applied	\N	\N	\N	\N	122814	122814	290502
15625	19514	1	applied	\N	\N	\N	\N	122815	122815	290503
15625	19515	2	applied	\N	\N	\N	\N	122816	122816	290504
15530	19345	3	applied	\N	\N	\N	\N	122397	122397	290086
15530	19346	4	applied	\N	\N	\N	\N	122398	122398	290087
15559	19218	37	applied	\N	\N	\N	\N	122549	122549	290238
15559	19222	38	applied	\N	\N	\N	\N	122550	122550	290239
15559	19224	39	applied	\N	\N	\N	\N	122551	122551	290240
15559	19225	40	applied	\N	\N	\N	\N	122552	122552	290241
15559	19226	41	applied	\N	\N	\N	\N	122553	122553	290242
15559	19231	42	applied	\N	\N	\N	\N	122554	122554	290243
15559	19234	43	applied	\N	\N	\N	\N	122555	122555	290244
15559	19235	44	applied	\N	\N	\N	\N	122556	122556	290245
15559	19236	45	applied	\N	\N	\N	\N	122557	122557	290246
15559	19241	46	applied	\N	\N	\N	\N	122558	122558	290247
15559	19243	47	applied	\N	\N	\N	\N	122559	122559	290248
15559	19245	48	applied	\N	\N	\N	\N	122560	122560	290249
15559	19247	49	applied	\N	\N	\N	\N	122561	122561	290250
15559	19250	50	applied	\N	\N	\N	\N	122562	122562	290251
15559	19251	51	applied	\N	\N	\N	\N	122563	122563	290252
15559	19254	52	applied	\N	\N	\N	\N	122564	122564	290253
15559	19259	54	applied	\N	\N	\N	\N	122566	122566	290255
15559	19262	55	applied	\N	\N	\N	\N	122567	122567	290256
15559	19264	56	applied	\N	\N	\N	\N	122568	122568	290257
15559	19265	57	applied	\N	\N	\N	\N	122569	122569	290258
15559	19269	58	applied	\N	\N	\N	\N	122570	122570	290259
15559	19270	59	applied	\N	\N	\N	\N	122571	122571	290260
15559	19273	60	applied	\N	\N	\N	\N	122572	122572	290261
15559	19276	61	applied	\N	\N	\N	\N	122573	122573	290262
15559	19278	62	applied	\N	\N	\N	\N	122574	122574	290263
15559	19281	63	applied	\N	\N	\N	\N	122575	122575	290264
15559	19282	64	applied	\N	\N	\N	\N	122576	122576	290265
15559	19283	65	applied	\N	\N	\N	\N	122577	122577	290266
15559	19288	66	applied	\N	\N	\N	\N	122578	122578	290267
15559	19289	67	applied	\N	\N	\N	\N	122579	122579	290268
15559	19290	68	applied	\N	\N	\N	\N	122580	122580	290269
15559	19294	69	applied	\N	\N	\N	\N	122581	122581	290270
15559	19300	71	applied	\N	\N	\N	\N	122583	122583	290272
15559	19301	72	applied	\N	\N	\N	\N	122584	122584	290273
15559	19302	73	applied	\N	\N	\N	\N	122585	122585	290274
15559	19303	74	applied	\N	\N	\N	\N	122586	122586	290275
15559	19309	75	applied	\N	\N	\N	\N	122587	122587	290276
15559	19311	76	applied	\N	\N	\N	\N	122588	122588	290277
15559	19314	77	applied	\N	\N	\N	\N	122589	122589	290278
15559	19317	78	applied	\N	\N	\N	\N	122590	122590	290279
15559	19319	79	applied	\N	\N	\N	\N	122591	122591	290280
15559	19323	80	applied	\N	\N	\N	\N	122592	122592	290281
15559	19325	81	applied	\N	\N	\N	\N	122593	122593	290282
15559	19328	82	applied	\N	\N	\N	\N	122594	122594	290283
15559	19329	83	applied	\N	\N	\N	\N	122595	122595	290284
15559	19333	84	applied	\N	\N	\N	\N	122596	122596	290285
15559	19334	85	applied	\N	\N	\N	\N	122597	122597	290286
15559	19338	86	applied	\N	\N	\N	\N	122598	122598	290287
15559	19342	88	applied	\N	\N	\N	\N	122600	122600	290289
15559	19343	89	applied	\N	\N	\N	\N	122601	122601	290290
15559	19344	90	applied	\N	\N	\N	\N	122602	122602	290291
15559	19349	91	applied	\N	\N	\N	\N	122603	122603	290292
15559	19352	92	applied	\N	\N	\N	\N	122604	122604	290293
15559	19353	93	applied	\N	\N	\N	\N	122605	122605	290294
15559	19357	94	applied	\N	\N	\N	\N	122606	122606	290295
15559	19358	95	applied	\N	\N	\N	\N	122607	122607	290296
15559	19359	96	applied	\N	\N	\N	\N	122608	122608	290297
15559	19364	97	applied	\N	\N	\N	\N	122609	122609	290298
15559	19366	98	applied	\N	\N	\N	\N	122610	122610	290299
15559	19367	99	applied	\N	\N	\N	\N	122611	122611	290300
15559	19370	100	applied	\N	\N	\N	\N	122612	122612	290301
15559	19373	101	applied	\N	\N	\N	\N	122613	122613	290302
15559	19374	102	applied	\N	\N	\N	\N	122614	122614	290303
15559	19377	103	applied	\N	\N	\N	\N	122615	122615	290304
15559	19381	105	applied	\N	\N	\N	\N	122617	122617	290306
15559	19382	106	applied	\N	\N	\N	\N	122618	122618	290307
15625	19516	3	applied	\N	\N	\N	\N	122817	122817	290505
15630	19523	0	applied	\N	\N	\N	\N	122827	122827	290515
15630	19524	1	applied	\N	\N	\N	\N	122828	122828	290516
15630	19525	2	applied	\N	\N	\N	\N	122829	122829	290517
15632	19523	0	applied	\N	\N	\N	\N	122833	122833	290521
15632	19524	1	applied	\N	\N	\N	\N	122834	122834	290522
15632	19525	2	applied	\N	\N	\N	\N	122835	122835	290523
15634	19526	0	applied	\N	\N	\N	\N	122839	122839	290527
15634	19527	1	applied	\N	\N	\N	\N	122840	122840	290528
15634	19528	2	applied	\N	\N	\N	\N	122841	122841	290529
15634	19529	3	applied	\N	\N	\N	\N	122842	122842	290530
15636	19526	0	applied	\N	\N	\N	\N	122847	122847	290535
15636	19527	1	applied	\N	\N	\N	\N	122848	122848	290536
15636	19528	2	applied	\N	\N	\N	\N	122849	122849	290537
15638	19526	0	applied	\N	\N	\N	\N	122855	122855	290543
15638	19527	1	applied	\N	\N	\N	\N	122856	122856	290544
15638	19528	2	applied	\N	\N	\N	\N	122857	122857	290545
15638	19529	3	applied	\N	\N	\N	\N	122858	122858	290546
15643	19533	0	applied	\N	\N	\N	\N	122884	122884	290572
15643	19534	1	applied	\N	\N	\N	\N	122885	122885	290573
15645	19535	0	applied	\N	\N	\N	\N	122890	122890	290578
15645	19536	1	applied	\N	\N	\N	\N	122891	122891	290579
15645	19537	2	applied	\N	\N	\N	\N	122892	122892	290580
15645	19538	3	applied	\N	\N	\N	\N	122893	122893	290581
15650	19549	0	applied	\N	\N	\N	\N	122912	122912	290600
15650	19550	1	applied	\N	\N	\N	\N	122913	122913	290601
15650	19551	2	applied	\N	\N	\N	\N	122914	122914	290602
15650	19552	3	applied	\N	\N	\N	\N	122915	122915	290603
15650	19553	4	applied	\N	\N	\N	\N	122916	122916	290604
15650	19554	6	applied	\N	\N	\N	\N	122917	122917	290605
15653	19556	1	applied	\N	\N	\N	\N	122925	122925	290613
15653	19557	2	applied	\N	\N	\N	\N	122926	122926	290614
15655	19562	0	applied	\N	\N	\N	\N	122931	122931	290619
15655	19563	1	applied	\N	\N	\N	\N	122932	122932	290620
15655	19564	2	applied	\N	\N	\N	\N	122933	122933	290621
15658	19565	0	applied	\N	\N	\N	\N	122944	122944	290632
15658	19566	1	applied	\N	\N	\N	\N	122945	122945	290633
15658	19567	2	applied	\N	\N	\N	\N	122946	122946	290634
15658	19568	3	applied	\N	\N	\N	\N	122947	122947	290635
15658	19569	4	applied	\N	\N	\N	\N	122948	122948	290636
15658	19570	5	applied	\N	\N	\N	\N	122949	122949	290637
15658	19571	6	applied	\N	\N	\N	\N	122950	122950	290638
15660	19575	0	applied	\N	\N	\N	\N	122954	122954	290642
15660	19576	1	applied	\N	\N	\N	\N	122955	122955	290643
15559	19211	34	applied	\N	\N	\N	\N	122546	122546	290235
15559	19215	35	applied	\N	\N	\N	\N	122547	122547	290236
15559	19394	110	applied	\N	\N	\N	\N	122622	122622	290311
15559	19396	111	applied	\N	\N	\N	\N	122623	122623	290312
15559	19397	112	applied	\N	\N	\N	\N	122624	122624	290313
15559	19404	114	applied	\N	\N	\N	\N	122626	122626	290315
15559	19405	115	applied	\N	\N	\N	\N	122627	122627	290316
15559	19406	116	applied	\N	\N	\N	\N	122628	122628	290317
15559	19410	117	applied	\N	\N	\N	\N	122629	122629	290318
15559	19411	118	applied	\N	\N	\N	\N	122630	122630	290319
15559	19416	119	applied	\N	\N	\N	\N	122631	122631	290320
15559	19417	120	applied	\N	\N	\N	\N	122632	122632	290321
15559	19418	121	applied	\N	\N	\N	\N	122633	122633	290322
15559	19144	122	applied	\N	\N	\N	\N	122634	122634	290323
15559	19146	123	applied	\N	\N	\N	\N	122635	122635	290324
15559	19149	124	applied	\N	\N	\N	\N	122636	122636	290325
15559	19150	125	applied	\N	\N	\N	\N	122637	122637	290326
15561	19416	0	applied	\N	\N	\N	\N	122644	122644	290333
15561	19417	1	applied	\N	\N	\N	\N	122645	122645	290334
15561	19418	2	applied	\N	\N	\N	\N	122646	122646	290335
15561	19419	3	applied	\N	\N	\N	\N	122647	122647	290336
15561	19421	5	applied	\N	\N	\N	\N	122649	122649	290338
15564	19422	0	applied	\N	\N	\N	\N	122651	122651	290340
15566	19423	0	applied	\N	\N	\N	\N	122653	122653	290342
15566	19424	1	applied	\N	\N	\N	\N	122654	122654	290343
15569	19427	0	applied	\N	\N	\N	\N	122660	122660	290349
15569	19428	1	applied	\N	\N	\N	\N	122661	122661	290350
15569	19429	2	applied	\N	\N	\N	\N	122662	122662	290351
15572	19434	1	applied	\N	\N	\N	\N	122667	122667	290355
15572	19433	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	122666	122666	\N
15574	19435	0	applied	\N	\N	\N	\N	122669	122669	290357
15576	19435	0	applied	\N	\N	\N	\N	122671	122671	290359
15580	19440	0	applied	\N	\N	\N	\N	122679	122679	290367
15580	19441	1	applied	\N	\N	\N	\N	122680	122680	290368
15580	19442	2	applied	\N	\N	\N	\N	122681	122681	290369
15580	19443	3	applied	\N	\N	\N	\N	122682	122682	290370
15580	19444	4	applied	\N	\N	\N	\N	122683	122683	290371
15580	19446	6	applied	\N	\N	1000000000	\N	122685	122685	290373
15583	19447	0	applied	\N	\N	\N	\N	122688	122688	290376
15585	19448	0	applied	\N	\N	\N	\N	122691	122691	290379
15585	19449	1	applied	\N	\N	\N	\N	122692	122692	290380
15590	19456	0	applied	\N	\N	\N	\N	122709	122709	290397
15590	19457	1	applied	\N	\N	\N	\N	122710	122710	290398
15590	19458	2	applied	\N	\N	\N	\N	122711	122711	290399
15590	19459	3	applied	\N	\N	\N	\N	122712	122712	290400
15590	19460	4	applied	\N	\N	\N	\N	122713	122713	290401
15590	19461	5	applied	\N	\N	\N	\N	122714	122714	290402
15598	19470	0	applied	\N	\N	\N	\N	122735	122735	290423
15598	19471	1	applied	\N	\N	\N	\N	122736	122736	290424
15603	19476	0	applied	\N	\N	\N	\N	122745	122745	290433
15603	19477	1	applied	\N	\N	\N	\N	122746	122746	290434
15605	19478	0	applied	\N	\N	\N	\N	122749	122749	290437
15605	19479	1	applied	\N	\N	\N	\N	122750	122750	290438
15607	19478	0	applied	\N	\N	\N	\N	122753	122753	290441
15607	19479	1	applied	\N	\N	\N	\N	122754	122754	290442
15608	19480	0	applied	\N	\N	\N	\N	122755	122755	290443
15608	19481	1	applied	\N	\N	\N	\N	122756	122756	290444
15608	19483	3	applied	\N	\N	\N	\N	122758	122758	290446
15608	19484	4	applied	\N	\N	\N	\N	122759	122759	290447
15608	19485	5	applied	\N	\N	\N	\N	122760	122760	290448
15608	19486	6	applied	\N	\N	\N	\N	122761	122761	290449
15620	19501	0	applied	\N	\N	\N	\N	122794	122794	290482
15620	19502	1	applied	\N	\N	\N	\N	122795	122795	290483
15622	19503	0	applied	\N	\N	\N	\N	122800	122800	290488
15622	19504	1	applied	\N	\N	\N	\N	122801	122801	290489
15622	19505	2	applied	\N	\N	\N	\N	122802	122802	290490
15622	19506	3	applied	\N	\N	\N	\N	122803	122803	290491
15629	19520	0	applied	\N	\N	\N	\N	122824	122824	290512
15629	19521	1	applied	\N	\N	\N	\N	122825	122825	290513
15629	19522	2	applied	\N	\N	\N	\N	122826	122826	290514
15640	19530	0	applied	\N	\N	\N	\N	122876	122876	290564
15640	19531	1	applied	\N	\N	\N	\N	122877	122877	290565
15640	19532	2	applied	\N	\N	\N	\N	122878	122878	290566
15642	19534	1	applied	\N	\N	\N	\N	122883	122883	290571
15647	19539	0	applied	\N	\N	\N	\N	122898	122898	290586
15647	19540	1	applied	\N	\N	\N	\N	122899	122899	290587
15647	19541	2	applied	\N	\N	\N	\N	122900	122900	290588
15647	19542	3	applied	\N	\N	\N	\N	122901	122901	290589
15647	19543	4	applied	\N	\N	\N	\N	122902	122902	290590
15647	19544	5	applied	\N	\N	\N	\N	122903	122903	290591
15649	19545	0	applied	\N	\N	\N	\N	122908	122908	290596
15649	19546	1	applied	\N	\N	\N	\N	122909	122909	290597
15649	19547	2	applied	\N	\N	\N	\N	122910	122910	290598
15649	19548	3	applied	\N	\N	\N	\N	122911	122911	290599
15652	19555	0	applied	\N	\N	\N	\N	122921	122921	290609
15652	19556	1	applied	\N	\N	\N	\N	122922	122922	290610
15652	19557	2	applied	\N	\N	\N	\N	122923	122923	290611
15654	19558	0	applied	\N	\N	\N	\N	122927	122927	290615
15654	19559	1	applied	\N	\N	\N	\N	122928	122928	290616
15654	19561	3	applied	\N	\N	\N	\N	122930	122930	290618
15657	19565	0	applied	\N	\N	\N	\N	122937	122937	290625
15657	19566	1	applied	\N	\N	\N	\N	122938	122938	290626
15657	19567	2	applied	\N	\N	\N	\N	122939	122939	290627
15657	19568	3	applied	\N	\N	\N	\N	122940	122940	290628
15657	19569	4	applied	\N	\N	\N	\N	122941	122941	290629
15657	19570	5	applied	\N	\N	\N	\N	122942	122942	290630
15657	19571	6	applied	\N	\N	\N	\N	122943	122943	290631
15659	19572	0	applied	\N	\N	\N	\N	122951	122951	290639
15659	19573	1	applied	\N	\N	\N	\N	122952	122952	290640
15659	19574	2	applied	\N	\N	\N	\N	122953	122953	290641
15662	19582	0	applied	\N	\N	\N	\N	122961	122961	290649
15662	19583	1	applied	\N	\N	\N	\N	122962	122962	290650
15662	19584	2	applied	\N	\N	\N	\N	122963	122963	290651
15662	19585	3	applied	\N	\N	\N	\N	122964	122964	290652
15662	19586	4	applied	\N	\N	\N	\N	122965	122965	290653
15665	19595	0	applied	\N	\N	\N	\N	122974	122974	290662
15665	19596	1	applied	\N	\N	\N	\N	122975	122975	290663
15665	19597	2	applied	\N	\N	\N	\N	122976	122976	290664
15665	19598	3	applied	\N	\N	\N	\N	122977	122977	290665
15665	19599	4	applied	\N	\N	\N	\N	122978	122978	290666
15665	19600	5	applied	\N	\N	\N	\N	122979	122979	290667
15559	19389	108	applied	\N	\N	\N	\N	122620	122620	290309
15559	19390	109	applied	\N	\N	\N	\N	122621	122621	290310
15609	19488	1	applied	\N	\N	\N	\N	122763	122763	290451
15609	19489	2	applied	\N	\N	\N	\N	122764	122764	290452
15611	19487	0	applied	\N	\N	\N	\N	122768	122768	290456
15611	19488	1	applied	\N	\N	\N	\N	122769	122769	290457
15611	19489	2	applied	\N	\N	\N	\N	122770	122770	290458
15616	19494	0	applied	\N	\N	\N	\N	122780	122780	290468
15616	19495	1	applied	\N	\N	\N	\N	122781	122781	290469
15621	19503	0	applied	\N	\N	\N	\N	122796	122796	290484
15621	19504	1	applied	\N	\N	\N	\N	122797	122797	290485
15621	19505	2	applied	\N	\N	\N	\N	122798	122798	290486
15621	19506	3	applied	\N	\N	\N	\N	122799	122799	290487
15626	19517	0	applied	\N	\N	\N	\N	122818	122818	290506
15626	19518	1	applied	\N	\N	\N	\N	122819	122819	290507
15626	19519	2	applied	\N	\N	\N	\N	122820	122820	290508
15628	19520	0	applied	\N	\N	\N	\N	122821	122821	290509
15628	19521	1	applied	\N	\N	\N	\N	122822	122822	290510
15631	19523	0	applied	\N	\N	\N	\N	122830	122830	290518
15631	19524	1	applied	\N	\N	\N	\N	122831	122831	290519
15631	19525	2	applied	\N	\N	\N	\N	122832	122832	290520
15641	19530	0	applied	\N	\N	\N	\N	122879	122879	290567
15641	19531	1	applied	\N	\N	\N	\N	122880	122880	290568
15641	19532	2	applied	\N	\N	\N	\N	122881	122881	290569
15648	19545	0	applied	\N	\N	\N	\N	122904	122904	290592
15648	19546	1	applied	\N	\N	\N	\N	122905	122905	290593
15648	19547	2	applied	\N	\N	\N	\N	122906	122906	290594
15648	19548	3	applied	\N	\N	\N	\N	122907	122907	290595
15651	19555	0	applied	\N	\N	\N	\N	122918	122918	290606
15651	19556	1	applied	\N	\N	\N	\N	122919	122919	290607
15651	19557	2	applied	\N	\N	\N	\N	122920	122920	290608
15656	19562	0	applied	\N	\N	\N	\N	122934	122934	290622
15656	19563	1	applied	\N	\N	\N	\N	122935	122935	290623
15656	19564	2	applied	\N	\N	\N	\N	122936	122936	290624
15667	19596	1	applied	\N	\N	\N	\N	122987	122987	290675
15667	19597	2	applied	\N	\N	\N	\N	122988	122988	290676
15667	19598	3	applied	\N	\N	\N	\N	122989	122989	290677
15667	19599	4	applied	\N	\N	\N	\N	122990	122990	290678
15667	19600	5	applied	\N	\N	\N	\N	122991	122991	290679
15669	19591	0	applied	\N	\N	\N	\N	122998	122998	290686
15669	19592	1	applied	\N	\N	\N	\N	122999	122999	290687
15669	19593	2	applied	\N	\N	\N	\N	123000	123000	290688
15669	19594	3	applied	\N	\N	\N	\N	123001	123001	290689
15672	19601	0	applied	\N	\N	\N	\N	123015	123015	290703
15672	19602	1	applied	\N	\N	\N	\N	123016	123016	290704
15672	19603	2	applied	\N	\N	\N	\N	123017	123017	290705
15672	19604	3	applied	\N	\N	\N	\N	123018	123018	290706
15672	19605	4	applied	\N	\N	\N	\N	123019	123019	290707
15672	19606	5	applied	\N	\N	\N	\N	123020	123020	290708
15672	19607	6	applied	\N	\N	\N	\N	123021	123021	290709
15674	19609	1	applied	\N	\N	\N	\N	123030	123030	290718
15674	19610	2	applied	\N	\N	\N	\N	123031	123031	290719
15675	19608	0	applied	\N	\N	\N	\N	123032	123032	290720
15675	19609	1	applied	\N	\N	\N	\N	123033	123033	290721
15675	19610	2	applied	\N	\N	\N	\N	123034	123034	290722
15676	19611	0	applied	\N	\N	\N	\N	123035	123035	290723
15676	19612	1	applied	\N	\N	\N	\N	123036	123036	290724
15676	19613	2	applied	\N	\N	\N	\N	123037	123037	290725
15676	19614	3	applied	\N	\N	\N	\N	123038	123038	290726
15677	19611	0	applied	\N	\N	\N	\N	123039	123039	290727
15677	19612	1	applied	\N	\N	\N	\N	123040	123040	290728
15677	19613	2	applied	\N	\N	\N	\N	123041	123041	290729
15677	19614	3	applied	\N	\N	\N	\N	123042	123042	290730
15680	19611	0	applied	\N	\N	\N	\N	123051	123051	290739
15680	19612	1	applied	\N	\N	\N	\N	123052	123052	290740
15680	19613	2	applied	\N	\N	\N	\N	123053	123053	290741
15686	19618	0	applied	\N	\N	\N	\N	123069	123069	290757
15686	19619	1	applied	\N	\N	\N	\N	123070	123070	290758
15686	19620	2	applied	\N	\N	\N	\N	123071	123071	290759
15688	19618	0	applied	\N	\N	\N	\N	123075	123075	290763
15688	19619	1	applied	\N	\N	\N	\N	123076	123076	290764
15688	19620	2	applied	\N	\N	\N	\N	123077	123077	290765
15689	19621	0	applied	\N	\N	\N	\N	123078	123078	290766
15689	19622	1	applied	\N	\N	\N	\N	123079	123079	290767
15689	19623	2	applied	\N	\N	\N	\N	123080	123080	290768
15689	19624	3	applied	\N	\N	\N	\N	123081	123081	290769
15689	19625	4	applied	\N	\N	\N	\N	123082	123082	290770
15691	19621	0	applied	\N	\N	\N	\N	123090	123090	290778
15691	19622	1	applied	\N	\N	\N	\N	123091	123091	290779
15691	19623	2	applied	\N	\N	\N	\N	123092	123092	290780
15691	19624	3	applied	\N	\N	\N	\N	123093	123093	290781
15691	19625	4	applied	\N	\N	\N	\N	123094	123094	290782
15691	19627	6	applied	\N	\N	\N	\N	123096	123096	290784
15695	19631	0	applied	\N	\N	\N	\N	123103	123103	290791
15695	19632	1	applied	\N	\N	\N	\N	123104	123104	290792
15695	19633	2	applied	\N	\N	\N	\N	123105	123105	290793
15696	19634	0	applied	\N	\N	\N	\N	123106	123106	290794
15696	19635	1	applied	\N	\N	\N	\N	123107	123107	290795
15696	19636	2	applied	\N	\N	\N	\N	123108	123108	290796
15696	19637	3	applied	\N	\N	\N	\N	123109	123109	290797
15697	19634	0	applied	\N	\N	\N	\N	123110	123110	290798
15697	19635	1	applied	\N	\N	\N	\N	123111	123111	290799
15697	19636	2	applied	\N	\N	\N	\N	123112	123112	290800
15697	19637	3	applied	\N	\N	\N	\N	123113	123113	290801
15699	19634	0	applied	\N	\N	\N	\N	123118	123118	290806
15699	19635	1	applied	\N	\N	\N	\N	123119	123119	290807
15699	19636	2	applied	\N	\N	\N	\N	123120	123120	290808
15699	19637	3	applied	\N	\N	\N	\N	123121	123121	290809
15707	19650	1	applied	\N	\N	\N	\N	123165	123165	290853
15707	19651	2	applied	\N	\N	\N	\N	123166	123166	290854
15708	19652	0	applied	\N	\N	\N	\N	123167	123167	290855
15708	19653	1	applied	\N	\N	\N	\N	123168	123168	290856
15708	19654	2	applied	\N	\N	\N	\N	123169	123169	290857
15710	19655	0	applied	\N	\N	\N	\N	123170	123170	290858
15710	19656	1	applied	\N	\N	\N	\N	123171	123171	290859
15710	19657	2	applied	\N	\N	\N	\N	123172	123172	290860
15711	19432	0	applied	\N	\N	\N	\N	123180	123180	290868
15718	19672	0	applied	\N	\N	\N	\N	123323	123323	291011
15718	19673	1	applied	\N	\N	\N	\N	123324	123324	291012
15718	19674	2	applied	\N	\N	\N	\N	123325	123325	291013
15718	19675	3	applied	\N	\N	\N	\N	123326	123326	291014
15718	19676	4	applied	\N	\N	\N	\N	123327	123327	291015
15606	19478	0	applied	\N	\N	\N	\N	122751	122751	290439
15606	19479	1	applied	\N	\N	\N	\N	122752	122752	290440
15617	19498	2	applied	\N	\N	\N	\N	122784	122784	290472
15617	19499	3	applied	\N	\N	\N	\N	122785	122785	290473
15617	19500	4	applied	\N	\N	\N	\N	122786	122786	290474
15619	19501	0	applied	\N	\N	\N	\N	122792	122792	290480
15619	19502	1	applied	\N	\N	\N	\N	122793	122793	290481
15624	19513	0	applied	\N	\N	\N	\N	122810	122810	290498
15624	19514	1	applied	\N	\N	\N	\N	122811	122811	290499
15624	19515	2	applied	\N	\N	\N	\N	122812	122812	290500
15624	19516	3	applied	\N	\N	\N	\N	122813	122813	290501
15633	19523	0	applied	\N	\N	\N	\N	122836	122836	290524
15633	19524	1	applied	\N	\N	\N	\N	122837	122837	290525
15633	19525	2	applied	\N	\N	\N	\N	122838	122838	290526
15635	19526	0	applied	\N	\N	\N	\N	122843	122843	290531
15635	19527	1	applied	\N	\N	\N	\N	122844	122844	290532
15635	19529	3	applied	\N	\N	\N	\N	122846	122846	290534
15637	19526	0	applied	\N	\N	\N	\N	122851	122851	290539
15637	19527	1	applied	\N	\N	\N	\N	122852	122852	290540
15637	19528	2	applied	\N	\N	\N	\N	122853	122853	290541
15637	19529	3	applied	\N	\N	\N	\N	122854	122854	290542
15639	19507	0	applied	\N	\N	\N	\N	122859	122859	290547
15639	19508	1	applied	\N	\N	\N	\N	122860	122860	290548
15639	19513	2	applied	\N	\N	\N	\N	122861	122861	290549
15639	19517	3	applied	\N	\N	\N	\N	122862	122862	290550
15639	19520	4	applied	\N	\N	\N	\N	122863	122863	290551
15639	19509	5	applied	\N	\N	\N	\N	122864	122864	290552
15639	19514	6	applied	\N	\N	\N	\N	122865	122865	290553
15639	19510	7	applied	\N	\N	\N	\N	122866	122866	290554
15639	19511	8	applied	\N	\N	\N	\N	122867	122867	290555
15639	19515	9	applied	\N	\N	\N	\N	122868	122868	290556
15639	19518	10	applied	\N	\N	\N	\N	122869	122869	290557
15639	19525	12	applied	\N	\N	\N	\N	122871	122871	290559
15639	19512	13	applied	\N	\N	\N	\N	122872	122872	290560
15639	19516	14	applied	\N	\N	\N	\N	122873	122873	290561
15639	19519	15	applied	\N	\N	\N	\N	122874	122874	290562
15639	19521	16	applied	\N	\N	\N	\N	122875	122875	290563
15644	19535	0	applied	\N	\N	\N	\N	122886	122886	290574
15644	19536	1	applied	\N	\N	\N	\N	122887	122887	290575
15644	19537	2	applied	\N	\N	\N	\N	122888	122888	290576
15644	19538	3	applied	\N	\N	\N	\N	122889	122889	290577
15646	19535	0	applied	\N	\N	\N	\N	122894	122894	290582
15646	19536	1	applied	\N	\N	\N	\N	122895	122895	290583
15646	19537	2	applied	\N	\N	\N	\N	122896	122896	290584
15646	19538	3	applied	\N	\N	\N	\N	122897	122897	290585
15661	19578	0	applied	\N	\N	\N	\N	122957	122957	290645
15661	19579	1	applied	\N	\N	\N	\N	122958	122958	290646
15661	19580	2	applied	\N	\N	\N	\N	122959	122959	290647
15664	19591	0	applied	\N	\N	\N	\N	122970	122970	290658
15664	19592	1	applied	\N	\N	\N	\N	122971	122971	290659
15664	19593	2	applied	\N	\N	\N	\N	122972	122972	290660
15664	19594	3	applied	\N	\N	\N	\N	122973	122973	290661
15671	19601	0	applied	\N	\N	\N	\N	123008	123008	290696
15671	19602	1	applied	\N	\N	\N	\N	123009	123009	290697
15671	19603	2	applied	\N	\N	\N	\N	123010	123010	290698
15671	19604	3	applied	\N	\N	\N	\N	123011	123011	290699
15671	19605	4	applied	\N	\N	\N	\N	123012	123012	290700
15671	19606	5	applied	\N	\N	\N	\N	123013	123013	290701
15671	19607	6	applied	\N	\N	\N	\N	123014	123014	290702
15673	19601	0	applied	\N	\N	\N	\N	123022	123022	290710
15673	19602	1	applied	\N	\N	\N	\N	123023	123023	290711
15673	19603	2	applied	\N	\N	\N	\N	123024	123024	290712
15673	19604	3	applied	\N	\N	\N	\N	123025	123025	290713
15673	19605	4	applied	\N	\N	\N	\N	123026	123026	290714
15673	19607	6	applied	\N	\N	\N	\N	123028	123028	290716
15678	19611	0	applied	\N	\N	\N	\N	123043	123043	290731
15678	19612	1	applied	\N	\N	\N	\N	123044	123044	290732
15678	19613	2	applied	\N	\N	\N	\N	123045	123045	290733
15718	19677	5	applied	\N	\N	\N	\N	123328	123328	291016
15718	19678	6	applied	\N	\N	\N	\N	123329	123329	291017
15718	19679	7	applied	\N	\N	\N	\N	123330	123330	291018
15718	19680	8	applied	\N	\N	\N	\N	123331	123331	291019
15718	19681	9	applied	\N	\N	\N	\N	123332	123332	291020
15723	19688	0	applied	\N	\N	\N	\N	123352	123352	291040
15723	19689	1	applied	\N	\N	\N	\N	123353	123353	291041
15723	19690	2	applied	\N	\N	\N	\N	123354	123354	291042
15730	19698	0	applied	\N	\N	\N	\N	123375	123375	291063
15730	19699	1	applied	\N	\N	\N	\N	123376	123376	291064
15730	19700	2	applied	\N	\N	\N	\N	123377	123377	291065
15733	19716	0	applied	\N	\N	\N	\N	123393	123393	291081
15733	19718	2	applied	\N	\N	\N	\N	123395	123395	291083
15735	19719	0	applied	\N	\N	\N	\N	123399	123399	291087
15735	19720	1	applied	\N	\N	\N	\N	123400	123400	291088
15735	19721	2	applied	\N	\N	\N	\N	123401	123401	291089
15736	19722	0	applied	\N	\N	\N	\N	123402	123402	291090
15736	19723	1	applied	\N	\N	\N	\N	123403	123403	291091
15736	19724	2	applied	\N	\N	\N	\N	123404	123404	291092
15736	19725	3	applied	\N	\N	\N	\N	123405	123405	291093
15736	19726	4	applied	\N	\N	\N	\N	123406	123406	291094
15736	19727	5	applied	\N	\N	\N	\N	123407	123407	291095
15736	19728	6	applied	\N	\N	\N	\N	123408	123408	291096
15736	19729	7	applied	\N	\N	\N	\N	123409	123409	291097
15736	19730	9	applied	\N	\N	\N	\N	123410	123410	291098
15736	19731	10	applied	\N	\N	\N	\N	123411	123411	291099
15736	19732	11	applied	\N	\N	\N	\N	123412	123412	291100
15738	19734	1	applied	\N	\N	\N	\N	123425	123425	291113
15738	19735	2	applied	\N	\N	\N	\N	123426	123426	291114
15743	19743	0	applied	\N	\N	\N	\N	123446	123446	291134
15743	19744	1	applied	\N	\N	\N	\N	123447	123447	291135
15743	19745	2	applied	\N	\N	\N	\N	123448	123448	291136
15749	19757	0	applied	\N	\N	\N	\N	123485	123485	291173
15749	19758	1	applied	\N	\N	\N	\N	123486	123486	291174
15749	19759	2	applied	\N	\N	\N	\N	123487	123487	291175
15749	19760	3	applied	\N	\N	\N	\N	123488	123488	291176
15749	19761	4	applied	\N	\N	\N	\N	123489	123489	291177
15749	19762	5	applied	\N	\N	\N	\N	123490	123490	291178
15749	19763	6	applied	\N	\N	\N	\N	123491	123491	291179
15749	19764	7	applied	\N	\N	\N	\N	123492	123492	291180
15749	19765	8	applied	\N	\N	\N	\N	123493	123493	291181
15749	19766	9	applied	\N	\N	\N	\N	123494	123494	291182
15749	19767	10	applied	\N	\N	\N	\N	123495	123495	291183
15749	19768	11	applied	\N	\N	\N	\N	123496	123496	291184
15617	19496	0	applied	\N	\N	\N	\N	122782	122782	290470
15617	19497	1	applied	\N	\N	\N	\N	122783	122783	290471
15666	19595	0	applied	\N	\N	\N	\N	122980	122980	290668
15666	19596	1	applied	\N	\N	\N	\N	122981	122981	290669
15666	19597	2	applied	\N	\N	\N	\N	122982	122982	290670
15666	19598	3	applied	\N	\N	\N	\N	122983	122983	290671
15666	19599	4	applied	\N	\N	\N	\N	122984	122984	290672
15666	19600	5	applied	\N	\N	\N	\N	122985	122985	290673
15668	19595	0	applied	\N	\N	\N	\N	122992	122992	290680
15668	19596	1	applied	\N	\N	\N	\N	122993	122993	290681
15668	19597	2	applied	\N	\N	\N	\N	122994	122994	290682
15668	19598	3	applied	\N	\N	\N	\N	122995	122995	290683
15668	19599	4	applied	\N	\N	\N	\N	122996	122996	290684
15668	19600	5	applied	\N	\N	\N	\N	122997	122997	290685
15670	19595	0	applied	\N	\N	\N	\N	123002	123002	290690
15670	19596	1	applied	\N	\N	\N	\N	123003	123003	290691
15670	19597	2	applied	\N	\N	\N	\N	123004	123004	290692
15670	19598	3	applied	\N	\N	\N	\N	123005	123005	290693
15670	19600	5	applied	\N	\N	\N	\N	123007	123007	290695
15678	19614	3	applied	\N	\N	\N	\N	123046	123046	290734
15679	19611	0	applied	\N	\N	\N	\N	123047	123047	290735
15679	19612	1	applied	\N	\N	\N	\N	123048	123048	290736
15679	19613	2	applied	\N	\N	\N	\N	123049	123049	290737
15679	19614	3	applied	\N	\N	\N	\N	123050	123050	290738
15681	19615	0	applied	\N	\N	\N	\N	123055	123055	290743
15681	19616	1	applied	\N	\N	\N	\N	123056	123056	290744
15681	19617	2	applied	\N	\N	\N	\N	123057	123057	290745
15682	19615	0	applied	\N	\N	\N	\N	123058	123058	290746
15682	19616	1	applied	\N	\N	\N	\N	123059	123059	290747
15682	19617	2	applied	\N	\N	\N	\N	123060	123060	290748
15683	19618	0	applied	\N	\N	\N	\N	123061	123061	290749
15683	19619	1	applied	\N	\N	\N	\N	123062	123062	290750
15683	19620	2	applied	\N	\N	\N	\N	123063	123063	290751
15684	19618	0	applied	\N	\N	\N	\N	123064	123064	290752
15685	19618	0	applied	\N	\N	\N	\N	123066	123066	290754
15685	19619	1	applied	\N	\N	\N	\N	123067	123067	290755
15685	19620	2	applied	\N	\N	\N	\N	123068	123068	290756
15687	19618	0	applied	\N	\N	\N	\N	123072	123072	290760
15687	19619	1	applied	\N	\N	\N	\N	123073	123073	290761
15687	19620	2	applied	\N	\N	\N	\N	123074	123074	290762
15690	19621	0	applied	\N	\N	\N	\N	123083	123083	290771
15690	19622	1	applied	\N	\N	\N	\N	123084	123084	290772
15690	19623	2	applied	\N	\N	\N	\N	123085	123085	290773
15690	19624	3	applied	\N	\N	\N	\N	123086	123086	290774
15690	19625	4	applied	\N	\N	\N	\N	123087	123087	290775
15690	19626	5	applied	\N	\N	\N	\N	123088	123088	290776
15690	19627	6	applied	\N	\N	\N	\N	123089	123089	290777
15693	19628	0	applied	\N	\N	\N	\N	123097	123097	290785
15693	19629	1	applied	\N	\N	\N	\N	123098	123098	290786
15693	19630	2	applied	\N	\N	\N	\N	123099	123099	290787
15694	19632	1	applied	\N	\N	\N	\N	123101	123101	290789
15694	19633	2	applied	\N	\N	\N	\N	123102	123102	290790
15698	19634	0	applied	\N	\N	\N	\N	123114	123114	290802
15698	19635	1	applied	\N	\N	\N	\N	123115	123115	290803
15698	19636	2	applied	\N	\N	\N	\N	123116	123116	290804
15698	19637	3	applied	\N	\N	\N	\N	123117	123117	290805
15700	19638	0	applied	\N	\N	\N	\N	123122	123122	290810
15700	19639	2	applied	\N	\N	\N	\N	123123	123123	290811
15701	19638	0	applied	\N	\N	\N	\N	123124	123124	290812
15701	19639	2	applied	\N	\N	\N	\N	123125	123125	290813
15701	19640	3	applied	\N	\N	\N	\N	123126	123126	290814
15701	19641	4	applied	\N	\N	\N	\N	123127	123127	290815
15701	19642	5	applied	\N	\N	\N	\N	123128	123128	290816
15702	19638	0	applied	\N	\N	\N	\N	123129	123129	290817
15702	19639	2	applied	\N	\N	\N	\N	123130	123130	290818
15702	19643	3	applied	\N	\N	\N	\N	123131	123131	290819
15702	19640	5	applied	\N	\N	\N	\N	123133	123133	290821
15702	19641	6	applied	\N	\N	\N	\N	123134	123134	290822
15702	19642	7	applied	\N	\N	\N	\N	123135	123135	290823
15703	19638	0	applied	\N	\N	\N	\N	123136	123136	290824
15703	19639	2	applied	\N	\N	\N	\N	123137	123137	290825
15703	19643	3	applied	\N	\N	\N	\N	123138	123138	290826
15703	19644	4	applied	\N	\N	\N	\N	123139	123139	290827
15703	19640	5	applied	\N	\N	\N	\N	123140	123140	290828
15703	19641	6	applied	\N	\N	\N	\N	123141	123141	290829
15703	19642	7	applied	\N	\N	\N	\N	123142	123142	290830
15704	19645	0	applied	\N	\N	\N	\N	123143	123143	290831
15704	19646	1	applied	\N	\N	\N	\N	123144	123144	290832
15704	19643	2	applied	\N	\N	\N	\N	123145	123145	290833
15704	19647	3	applied	\N	\N	\N	\N	123146	123146	290834
15704	19644	4	applied	\N	\N	\N	\N	123147	123147	290835
15704	19648	5	applied	\N	\N	\N	\N	123148	123148	290836
15705	19646	1	applied	\N	\N	\N	\N	123150	123150	290838
15705	19643	2	applied	\N	\N	\N	\N	123151	123151	290839
15705	19647	3	applied	\N	\N	\N	\N	123152	123152	290840
15705	19644	4	applied	\N	\N	\N	\N	123153	123153	290841
15705	19648	5	applied	\N	\N	\N	\N	123154	123154	290842
15706	19645	0	applied	\N	\N	\N	\N	123155	123155	290843
15706	19646	1	applied	\N	\N	\N	\N	123156	123156	290844
15706	19643	2	applied	\N	\N	\N	\N	123157	123157	290845
15706	19644	3	applied	\N	\N	\N	\N	123158	123158	290846
15706	19648	4	applied	\N	\N	\N	\N	123159	123159	290847
15706	19640	5	applied	\N	\N	\N	\N	123160	123160	290848
15706	19641	6	applied	\N	\N	\N	\N	123161	123161	290849
15706	19642	7	applied	\N	\N	\N	\N	123162	123162	290850
15706	19647	8	applied	\N	\N	\N	\N	123163	123163	290851
15713	19665	0	applied	\N	\N	\N	\N	123184	123184	290872
15713	19666	1	applied	\N	\N	\N	\N	123185	123185	290873
15715	19668	0	applied	\N	\N	\N	\N	123190	123190	290878
15715	19669	1	applied	\N	\N	\N	\N	123191	123191	290879
15715	19670	2	applied	\N	\N	\N	\N	123192	123192	290880
15715	19671	3	applied	\N	\N	\N	\N	123193	123193	290881
15716	19668	0	applied	\N	\N	\N	\N	123194	123194	290882
15716	19669	1	applied	\N	\N	\N	\N	123195	123195	290883
15716	19670	2	applied	\N	\N	\N	\N	123196	123196	290884
15716	19671	3	applied	\N	\N	\N	\N	123197	123197	290885
15717	19419	0	applied	\N	\N	\N	\N	123198	123198	290886
15717	19422	1	applied	\N	\N	\N	\N	123199	123199	290887
15717	19423	2	applied	\N	\N	\N	\N	123200	123200	290888
15717	19424	3	applied	\N	\N	\N	\N	123201	123201	290889
15721	19685	0	applied	\N	\N	\N	\N	123346	123346	291034
15721	19686	1	applied	\N	\N	\N	\N	123347	123347	291035
15663	19588	0	applied	\N	\N	\N	\N	122967	122967	290655
15663	19589	1	applied	\N	\N	\N	\N	122968	122968	290656
15710	19662	7	applied	\N	\N	\N	\N	123177	123177	290865
15710	19663	8	applied	\N	\N	\N	\N	123178	123178	290866
15710	19664	9	applied	\N	\N	\N	\N	123179	123179	290867
15712	19665	0	applied	\N	\N	\N	\N	123181	123181	290869
15712	19666	1	applied	\N	\N	\N	\N	123182	123182	290870
15712	19667	2	applied	\N	\N	\N	\N	123183	123183	290871
15714	19665	0	applied	\N	\N	\N	\N	123187	123187	290875
15714	19666	1	applied	\N	\N	\N	\N	123188	123188	290876
15714	19667	2	applied	\N	\N	\N	\N	123189	123189	290877
15717	19425	4	applied	\N	\N	\N	\N	123202	123202	290890
15717	19426	5	applied	\N	\N	\N	\N	123203	123203	290891
15717	19427	6	applied	\N	\N	\N	\N	123204	123204	290892
15717	19428	7	applied	\N	\N	\N	\N	123205	123205	290893
15717	19429	8	applied	\N	\N	\N	\N	123206	123206	290894
15717	19431	10	applied	\N	\N	\N	\N	123208	123208	290896
15717	19434	11	applied	\N	\N	\N	\N	123209	123209	290897
15717	19435	12	applied	\N	\N	\N	\N	123210	123210	290898
15717	19436	13	applied	\N	\N	\N	\N	123211	123211	290899
15717	19437	14	applied	\N	\N	\N	\N	123212	123212	290900
15717	19438	15	applied	\N	\N	\N	\N	123213	123213	290901
15717	19440	17	applied	\N	\N	\N	\N	123214	123214	290902
15717	19441	18	applied	\N	\N	\N	\N	123215	123215	290903
15717	19442	19	applied	\N	\N	\N	\N	123216	123216	290904
15717	19443	20	applied	\N	\N	\N	\N	123217	123217	290905
15717	19444	21	applied	\N	\N	\N	\N	123218	123218	290906
15717	19447	22	applied	\N	\N	\N	\N	123219	123219	290907
15717	19448	23	applied	\N	\N	\N	\N	123220	123220	290908
15717	19450	24	applied	\N	\N	\N	\N	123221	123221	290909
15717	19451	25	applied	\N	\N	\N	\N	123222	123222	290910
15717	19454	26	applied	\N	\N	\N	\N	123223	123223	290911
15717	19457	28	applied	\N	\N	\N	\N	123225	123225	290913
15717	19458	29	applied	\N	\N	\N	\N	123226	123226	290914
15717	19462	30	applied	\N	\N	\N	\N	123227	123227	290915
15717	19463	31	applied	\N	\N	\N	\N	123228	123228	290916
15717	19470	32	applied	\N	\N	\N	\N	123229	123229	290917
15717	19472	33	applied	\N	\N	\N	\N	123230	123230	290918
15717	19474	34	applied	\N	\N	\N	\N	123231	123231	290919
15717	19476	35	applied	\N	\N	\N	\N	123232	123232	290920
15717	19478	36	applied	\N	\N	\N	\N	123233	123233	290921
15717	19480	37	applied	\N	\N	\N	\N	123234	123234	290922
15717	19481	38	applied	\N	\N	\N	\N	123235	123235	290923
15717	19482	39	applied	\N	\N	\N	\N	123236	123236	290924
15717	19487	40	applied	\N	\N	\N	\N	123237	123237	290925
15717	19490	41	applied	\N	\N	\N	\N	123238	123238	290926
15717	19492	42	applied	\N	\N	\N	\N	123239	123239	290927
15717	19494	43	applied	\N	\N	\N	\N	123240	123240	290928
15717	19497	45	applied	\N	\N	\N	\N	123242	123242	290930
15717	19501	46	applied	\N	\N	\N	\N	123243	123243	290931
15717	19503	47	applied	\N	\N	\N	\N	123244	123244	290932
15717	19507	48	applied	\N	\N	\N	\N	123245	123245	290933
15717	19508	49	applied	\N	\N	\N	\N	123246	123246	290934
15717	19513	50	applied	\N	\N	\N	\N	123247	123247	290935
15719	19672	0	applied	\N	\N	\N	\N	123333	123333	291021
15719	19673	1	applied	\N	\N	\N	\N	123334	123334	291022
15719	19674	2	applied	\N	\N	\N	\N	123335	123335	291023
15719	19675	3	applied	\N	\N	\N	\N	123336	123336	291024
15719	19676	4	applied	\N	\N	\N	\N	123337	123337	291025
15719	19677	5	applied	\N	\N	\N	\N	123338	123338	291026
15719	19678	6	applied	\N	\N	\N	\N	123339	123339	291027
15719	19679	7	applied	\N	\N	\N	\N	123340	123340	291028
15719	19680	8	applied	\N	\N	\N	\N	123341	123341	291029
15719	19681	9	applied	\N	\N	\N	\N	123342	123342	291030
15726	19692	1	applied	\N	\N	\N	\N	123362	123362	291050
15726	19693	2	applied	\N	\N	\N	\N	123363	123363	291051
15726	19694	3	applied	\N	\N	\N	\N	123364	123364	291052
15731	19701	0	applied	\N	\N	\N	\N	123378	123378	291066
15731	19702	1	applied	\N	\N	\N	\N	123379	123379	291067
15731	19703	2	applied	\N	\N	\N	\N	123380	123380	291068
15731	19704	3	applied	\N	\N	\N	\N	123381	123381	291069
15731	19705	4	applied	\N	\N	\N	\N	123382	123382	291070
15731	19706	5	applied	\N	\N	\N	\N	123383	123383	291071
15731	19707	6	applied	\N	\N	\N	\N	123384	123384	291072
15734	19719	0	applied	\N	\N	\N	\N	123396	123396	291084
15734	19720	1	applied	\N	\N	\N	\N	123397	123397	291085
15734	19721	2	applied	\N	\N	\N	\N	123398	123398	291086
15739	19733	0	applied	\N	\N	1000000000	\N	123427	123427	291115
15739	19734	1	applied	\N	\N	\N	\N	123428	123428	291116
15742	19743	0	applied	\N	\N	\N	\N	123443	123443	291131
15742	19745	2	applied	\N	\N	\N	\N	123445	123445	291133
15744	19746	0	applied	\N	\N	\N	\N	123449	123449	291137
15744	19747	1	applied	\N	\N	\N	\N	123450	123450	291138
15744	19748	2	applied	\N	\N	\N	\N	123451	123451	291139
15744	19749	3	applied	\N	\N	\N	\N	123452	123452	291140
15758	19791	0	applied	\N	\N	\N	\N	123558	123558	291246
15758	19792	1	applied	\N	\N	\N	\N	123559	123559	291247
15758	19793	2	applied	\N	\N	\N	\N	123560	123560	291248
15760	19794	0	applied	\N	\N	\N	\N	123565	123565	291253
15760	19795	1	applied	\N	\N	\N	\N	123566	123566	291254
15760	19796	2	applied	\N	\N	\N	\N	123567	123567	291255
15760	19797	3	applied	\N	\N	\N	\N	123568	123568	291256
15763	19807	0	applied	\N	\N	\N	\N	123581	123581	291269
15763	19808	1	applied	\N	\N	\N	\N	123582	123582	291270
15763	19809	2	applied	\N	\N	\N	\N	123583	123583	291271
15765	19813	0	applied	\N	\N	\N	\N	123587	123587	291275
15765	19815	2	applied	\N	\N	\N	\N	123589	123589	291277
15765	19816	3	applied	\N	\N	\N	\N	123590	123590	291278
15770	19827	0	applied	\N	\N	\N	\N	123615	123615	291303
15770	19828	1	applied	\N	\N	\N	\N	123616	123616	291304
15770	19829	2	applied	\N	\N	\N	\N	123617	123617	291305
15770	19830	3	applied	\N	\N	\N	\N	123618	123618	291306
15770	19831	4	applied	\N	\N	\N	\N	123619	123619	291307
15776	19853	0	applied	\N	\N	\N	\N	123654	123654	291342
15776	19854	1	applied	\N	\N	\N	\N	123655	123655	291343
15776	19848	2	applied	\N	\N	\N	\N	123656	123656	291344
15776	19849	3	applied	\N	\N	\N	\N	123657	123657	291345
15776	19850	4	applied	\N	\N	\N	\N	123658	123658	291346
15776	19851	5	applied	\N	\N	\N	\N	123659	123659	291347
15776	19852	6	applied	\N	\N	\N	\N	123660	123660	291348
15776	19855	7	applied	\N	\N	\N	\N	123661	123661	291349
15778	19856	0	applied	\N	\N	\N	\N	123670	123670	291358
15710	19661	6	applied	\N	\N	\N	\N	123176	123176	290864
15717	19530	55	applied	\N	\N	\N	\N	123252	123252	290940
15717	19533	56	applied	\N	\N	\N	\N	123253	123253	290941
15717	19535	57	applied	\N	\N	\N	\N	123254	123254	290942
15717	19539	58	applied	\N	\N	\N	\N	123255	123255	290943
15717	19540	59	applied	\N	\N	\N	\N	123256	123256	290944
15717	19545	60	applied	\N	\N	\N	\N	123257	123257	290945
15717	19549	61	applied	\N	\N	\N	\N	123258	123258	290946
15717	19550	62	applied	\N	\N	\N	\N	123259	123259	290947
15717	19555	63	applied	\N	\N	\N	\N	123260	123260	290948
15717	19558	64	applied	\N	\N	\N	\N	123261	123261	290949
15717	19562	65	applied	\N	\N	\N	\N	123262	123262	290950
15717	19565	66	applied	\N	\N	\N	\N	123263	123263	290951
15717	19566	67	applied	\N	\N	\N	\N	123264	123264	290952
15717	19572	68	applied	\N	\N	\N	\N	123265	123265	290953
15717	19575	69	applied	\N	\N	\N	\N	123266	123266	290954
15717	19578	70	applied	\N	\N	\N	\N	123267	123267	290955
15717	19583	72	applied	\N	\N	\N	\N	123269	123269	290957
15717	19588	73	applied	\N	\N	\N	\N	123270	123270	290958
15717	19591	74	applied	\N	\N	\N	\N	123271	123271	290959
15717	19595	75	applied	\N	\N	\N	\N	123272	123272	290960
15717	19596	76	applied	\N	\N	\N	\N	123273	123273	290961
15717	19601	77	applied	\N	\N	\N	\N	123274	123274	290962
15717	19602	78	applied	\N	\N	\N	\N	123275	123275	290963
15717	19608	79	applied	\N	\N	\N	\N	123276	123276	290964
15717	19611	80	applied	\N	\N	\N	\N	123277	123277	290965
15717	19615	81	applied	\N	\N	\N	\N	123278	123278	290966
15717	19618	82	applied	\N	\N	\N	\N	123279	123279	290967
15717	19621	83	applied	\N	\N	\N	\N	123280	123280	290968
15717	19622	84	applied	\N	\N	\N	\N	123281	123281	290969
15717	19628	85	applied	\N	\N	\N	\N	123282	123282	290970
15717	19631	86	applied	\N	\N	\N	\N	123283	123283	290971
15717	19634	87	applied	\N	\N	\N	\N	123284	123284	290972
15717	19639	89	applied	\N	\N	\N	\N	123286	123286	290974
15717	19645	90	applied	\N	\N	\N	\N	123287	123287	290975
15717	19649	91	applied	\N	\N	\N	\N	123288	123288	290976
15717	19652	92	applied	\N	\N	\N	\N	123289	123289	290977
15717	19655	93	applied	\N	\N	\N	\N	123290	123290	290978
15717	19656	94	applied	\N	\N	\N	\N	123291	123291	290979
15717	19657	95	applied	\N	\N	\N	\N	123292	123292	290980
15717	19665	96	applied	\N	\N	\N	\N	123293	123293	290981
15717	19668	97	applied	\N	\N	\N	\N	123294	123294	290982
15717	19432	98	applied	\N	\N	\N	\N	123295	123295	290983
15717	19151	99	applied	\N	\N	\N	\N	123296	123296	290984
15717	19153	100	applied	\N	\N	\N	\N	123297	123297	290985
15717	19154	101	applied	\N	\N	\N	\N	123298	123298	290986
15717	19158	102	applied	\N	\N	\N	\N	123299	123299	290987
15717	19159	103	applied	\N	\N	\N	\N	123300	123300	290988
15717	19160	104	applied	\N	\N	\N	\N	123301	123301	290989
15717	19165	106	applied	\N	\N	\N	\N	123303	123303	290991
15717	19167	107	applied	\N	\N	\N	\N	123304	123304	290992
15717	19171	108	applied	\N	\N	\N	\N	123305	123305	290993
15717	19173	109	applied	\N	\N	\N	\N	123306	123306	290994
15717	19174	110	applied	\N	\N	\N	\N	123307	123307	290995
15717	19176	111	applied	\N	\N	\N	\N	123308	123308	290996
15717	19177	112	applied	\N	\N	\N	\N	123309	123309	290997
15717	19180	113	applied	\N	\N	\N	\N	123310	123310	290998
15717	19181	114	applied	\N	\N	\N	\N	123311	123311	290999
15717	19183	115	applied	\N	\N	\N	\N	123312	123312	291000
15717	19185	116	applied	\N	\N	\N	\N	123313	123313	291001
15717	19186	117	applied	\N	\N	\N	\N	123314	123314	291002
15717	19188	118	applied	\N	\N	\N	\N	123315	123315	291003
15717	19190	119	applied	\N	\N	\N	\N	123316	123316	291004
15717	19192	120	applied	\N	\N	\N	\N	123317	123317	291005
15717	19193	121	applied	\N	\N	\N	\N	123318	123318	291006
15717	19198	123	applied	\N	\N	\N	\N	123320	123320	291008
15717	19199	124	applied	\N	\N	\N	\N	123321	123321	291009
15785	19866	0	applied	\N	\N	\N	\N	123691	123691	291379
15785	19867	1	applied	\N	\N	\N	\N	123692	123692	291380
15785	19868	2	applied	\N	\N	\N	\N	123693	123693	291381
15785	19869	3	applied	\N	\N	\N	\N	123694	123694	291382
15785	19870	4	applied	\N	\N	\N	\N	123695	123695	291383
15785	19871	5	applied	\N	\N	\N	\N	123696	123696	291384
15791	19892	0	applied	\N	\N	\N	\N	123720	123720	291408
15791	19893	1	applied	\N	\N	\N	\N	123721	123721	291409
15791	19894	2	applied	\N	\N	\N	\N	123722	123722	291410
15793	19895	0	applied	\N	\N	\N	\N	123727	123727	291415
15793	19896	1	applied	\N	\N	\N	\N	123728	123728	291416
15793	19897	2	applied	\N	\N	\N	\N	123729	123729	291417
15793	19898	3	applied	\N	\N	\N	\N	123730	123730	291418
15796	19909	0	applied	\N	\N	\N	\N	123741	123741	291429
15796	19911	2	applied	\N	\N	\N	\N	123743	123743	291431
15796	19912	3	applied	\N	\N	\N	\N	123744	123744	291432
15796	19913	4	applied	\N	\N	\N	\N	123745	123745	291433
15796	19914	5	applied	\N	\N	\N	\N	123746	123746	291434
15796	19915	7	applied	\N	\N	\N	\N	123747	123747	291435
15796	19916	8	applied	\N	\N	\N	\N	123748	123748	291436
15796	19917	9	applied	\N	\N	\N	\N	123749	123749	291437
15796	19918	10	applied	\N	\N	\N	\N	123750	123750	291438
15796	19919	11	applied	\N	\N	\N	\N	123751	123751	291439
15796	19920	12	applied	\N	\N	\N	\N	123752	123752	291440
15796	19921	13	applied	\N	\N	\N	\N	123753	123753	291441
15796	19922	14	applied	\N	\N	\N	\N	123754	123754	291442
15796	19923	15	applied	\N	\N	\N	\N	123755	123755	291443
15796	19924	16	applied	\N	\N	\N	\N	123756	123756	291444
15801	19934	0	applied	\N	\N	\N	\N	123769	123769	291457
15801	19935	1	applied	\N	\N	\N	\N	123770	123770	291458
15804	19942	0	applied	\N	\N	\N	\N	123779	123779	291467
15804	19944	1	applied	\N	\N	\N	\N	123780	123780	291468
15804	19943	2	applied	\N	\N	\N	\N	123781	123781	291469
15806	19949	0	applied	\N	\N	\N	\N	123787	123787	291475
15806	19950	1	applied	\N	\N	\N	\N	123788	123788	291476
15806	19951	2	applied	\N	\N	\N	\N	123789	123789	291477
15811	19956	0	applied	\N	\N	\N	\N	123807	123807	291495
15811	19957	1	applied	\N	\N	\N	\N	123808	123808	291496
15811	19958	2	applied	\N	\N	\N	\N	123809	123809	291497
15811	19959	3	applied	\N	\N	\N	\N	123810	123810	291498
15811	19960	4	applied	\N	\N	\N	\N	123811	123811	291499
15811	19961	5	applied	\N	\N	\N	\N	123812	123812	291500
15811	19962	6	applied	\N	\N	\N	\N	123813	123813	291501
15811	19963	7	applied	\N	\N	\N	\N	123814	123814	291502
15717	19520	52	applied	\N	\N	\N	\N	123249	123249	290937
15717	19523	53	applied	\N	\N	\N	\N	123250	123250	290938
15720	19684	2	applied	\N	\N	\N	\N	123345	123345	291033
15721	19687	2	applied	\N	\N	\N	\N	123348	123348	291036
15722	19685	0	applied	\N	\N	\N	\N	123349	123349	291037
15722	19686	1	applied	\N	\N	\N	\N	123350	123350	291038
15722	19687	2	applied	\N	\N	\N	\N	123351	123351	291039
15724	19688	0	applied	\N	\N	\N	\N	123355	123355	291043
15724	19689	1	applied	\N	\N	\N	\N	123356	123356	291044
15724	19690	2	applied	\N	\N	\N	\N	123357	123357	291045
15725	19688	0	applied	\N	\N	\N	\N	123358	123358	291046
15725	19689	1	applied	\N	\N	\N	\N	123359	123359	291047
15725	19690	2	applied	\N	\N	\N	\N	123360	123360	291048
15727	19692	1	applied	\N	\N	\N	\N	123366	123366	291054
15727	19693	2	applied	\N	\N	\N	\N	123367	123367	291055
15727	19694	3	applied	\N	\N	\N	\N	123368	123368	291056
15728	19695	0	applied	\N	\N	\N	\N	123369	123369	291057
15728	19696	1	applied	\N	\N	\N	\N	123370	123370	291058
15728	19697	2	applied	\N	\N	\N	\N	123371	123371	291059
15729	19698	0	applied	\N	\N	\N	\N	123372	123372	291060
15729	19699	1	applied	\N	\N	\N	\N	123373	123373	291061
15729	19700	2	applied	\N	\N	\N	\N	123374	123374	291062
15732	19708	0	applied	\N	\N	\N	\N	123385	123385	291073
15732	19709	1	applied	\N	\N	\N	\N	123386	123386	291074
15732	19710	2	applied	\N	\N	\N	\N	123387	123387	291075
15732	19711	3	applied	\N	\N	\N	\N	123388	123388	291076
15732	19712	4	applied	\N	\N	\N	\N	123389	123389	291077
15732	19714	6	applied	\N	\N	\N	\N	123391	123391	291079
15732	19715	7	applied	\N	\N	\N	\N	123392	123392	291080
15737	19722	0	applied	\N	\N	\N	\N	123413	123413	291101
15737	19723	1	applied	\N	\N	\N	\N	123414	123414	291102
15737	19724	2	applied	\N	\N	\N	\N	123415	123415	291103
15737	19725	3	applied	\N	\N	\N	\N	123416	123416	291104
15737	19726	4	applied	\N	\N	\N	\N	123417	123417	291105
15737	19727	5	applied	\N	\N	\N	\N	123418	123418	291106
15737	19728	6	applied	\N	\N	\N	\N	123419	123419	291107
15737	19729	7	applied	\N	\N	\N	\N	123420	123420	291108
15737	19730	9	applied	\N	\N	\N	\N	123421	123421	291109
15737	19731	10	applied	\N	\N	\N	\N	123422	123422	291110
15737	19732	11	applied	\N	\N	\N	\N	123423	123423	291111
15740	19736	0	applied	\N	\N	\N	\N	123429	123429	291117
15740	19737	1	applied	\N	\N	\N	\N	123430	123430	291118
15740	19738	2	applied	\N	\N	\N	\N	123431	123431	291119
15740	19739	3	applied	\N	\N	\N	\N	123432	123432	291120
15740	19740	4	applied	\N	\N	\N	\N	123433	123433	291121
15740	19741	5	applied	\N	\N	\N	\N	123434	123434	291122
15740	19742	6	applied	\N	\N	\N	\N	123435	123435	291123
15741	19737	1	applied	\N	\N	\N	\N	123437	123437	291125
15741	19738	2	applied	\N	\N	\N	\N	123438	123438	291126
15741	19739	3	applied	\N	\N	\N	\N	123439	123439	291127
15741	19740	4	applied	\N	\N	\N	\N	123440	123440	291128
15741	19741	5	applied	\N	\N	\N	\N	123441	123441	291129
15741	19742	6	applied	\N	\N	\N	\N	123442	123442	291130
15745	19733	0	applied	\N	\N	1000000000	\N	123453	123453	291141
15745	19750	1	applied	\N	\N	\N	\N	123454	123454	291142
15745	19713	2	applied	\N	\N	1000000000	\N	123455	123455	291143
15745	19726	3	applied	\N	\N	\N	\N	123456	123456	291144
15746	19750	0	applied	\N	\N	\N	\N	123457	123457	291145
15746	19751	1	applied	\N	\N	\N	\N	123458	123458	291146
15746	19752	2	applied	\N	\N	\N	\N	123459	123459	291147
15746	19753	3	applied	\N	\N	\N	\N	123460	123460	291148
15746	19754	4	applied	\N	\N	\N	\N	123461	123461	291149
15746	19755	5	applied	\N	\N	\N	\N	123462	123462	291150
15747	19750	0	applied	\N	\N	\N	\N	123464	123464	291152
15747	19751	1	applied	\N	\N	\N	\N	123465	123465	291153
15747	19752	2	applied	\N	\N	\N	\N	123466	123466	291154
15747	19753	3	applied	\N	\N	\N	\N	123467	123467	291155
15747	19754	4	applied	\N	\N	\N	\N	123468	123468	291156
15747	19755	5	applied	\N	\N	\N	\N	123469	123469	291157
15747	19756	6	applied	\N	\N	\N	\N	123470	123470	291158
15748	19757	0	applied	\N	\N	\N	\N	123471	123471	291159
15748	19758	1	applied	\N	\N	\N	\N	123472	123472	291160
15752	19778	0	applied	\N	\N	\N	\N	123520	123520	291208
15752	19779	1	applied	\N	\N	\N	\N	123521	123521	291209
15752	19780	2	applied	\N	\N	\N	\N	123522	123522	291210
15752	19781	3	applied	\N	\N	\N	\N	123523	123523	291211
15752	19782	4	applied	\N	\N	\N	\N	123524	123524	291212
15752	19783	5	applied	\N	\N	\N	\N	123525	123525	291213
15752	19784	6	applied	\N	\N	\N	\N	123526	123526	291214
15754	19779	1	applied	\N	\N	\N	\N	123535	123535	291223
15754	19780	2	applied	\N	\N	\N	\N	123536	123536	291224
15754	19781	3	applied	\N	\N	\N	\N	123537	123537	291225
15754	19782	4	applied	\N	\N	\N	\N	123538	123538	291226
15754	19783	5	applied	\N	\N	\N	\N	123539	123539	291227
15754	19784	6	applied	\N	\N	\N	\N	123540	123540	291228
15757	19791	0	applied	\N	\N	\N	\N	123555	123555	291243
15757	19792	1	applied	\N	\N	\N	\N	123556	123556	291244
15757	19793	2	applied	\N	\N	\N	\N	123557	123557	291245
15759	19794	0	applied	\N	\N	\N	\N	123561	123561	291249
15759	19795	1	applied	\N	\N	\N	\N	123562	123562	291250
15759	19796	2	applied	\N	\N	\N	\N	123563	123563	291251
15759	19797	3	applied	\N	\N	\N	\N	123564	123564	291252
15762	19807	0	applied	\N	\N	\N	\N	123578	123578	291266
15762	19808	1	applied	\N	\N	\N	\N	123579	123579	291267
15762	19809	2	applied	\N	\N	\N	\N	123580	123580	291268
15767	19818	1	applied	\N	\N	\N	\N	123599	123599	291287
15767	19819	2	applied	\N	\N	\N	\N	123600	123600	291288
15767	19820	3	applied	\N	\N	\N	\N	123601	123601	291289
15767	19821	4	applied	\N	\N	\N	\N	123602	123602	291290
15767	19822	5	applied	\N	\N	\N	\N	123603	123603	291291
15767	19823	6	applied	\N	\N	\N	\N	123604	123604	291292
15775	19845	0	applied	\N	\N	\N	\N	123646	123646	291334
15775	19846	1	applied	\N	\N	\N	\N	123647	123647	291335
15775	19847	2	applied	\N	\N	\N	\N	123648	123648	291336
15775	19848	3	applied	\N	\N	\N	\N	123649	123649	291337
15775	19849	4	applied	\N	\N	\N	\N	123650	123650	291338
15775	19850	5	applied	\N	\N	\N	\N	123651	123651	291339
15775	19851	6	applied	\N	\N	\N	\N	123652	123652	291340
15775	19852	7	applied	\N	\N	\N	\N	123653	123653	291341
15780	19859	0	applied	\N	\N	\N	\N	123674	123674	291362
15780	19860	1	applied	\N	\N	\N	\N	123675	123675	291363
15720	19682	0	applied	\N	\N	\N	\N	123343	123343	291031
15720	19683	1	applied	\N	\N	\N	\N	123344	123344	291032
15748	19762	5	applied	\N	\N	\N	\N	123476	123476	291164
15748	19763	6	applied	\N	\N	\N	\N	123477	123477	291165
15748	19764	7	applied	\N	\N	\N	\N	123478	123478	291166
15748	19765	8	applied	\N	\N	\N	\N	123479	123479	291167
15748	19766	9	applied	\N	\N	\N	\N	123480	123480	291168
15748	19767	10	applied	\N	\N	\N	\N	123481	123481	291169
15748	19768	11	applied	\N	\N	\N	\N	123482	123482	291170
15748	19769	12	applied	\N	\N	\N	\N	123483	123483	291171
15748	19770	13	applied	\N	\N	\N	\N	123484	123484	291172
15750	19757	0	applied	\N	\N	\N	\N	123499	123499	291187
15750	19758	1	applied	\N	\N	\N	\N	123500	123500	291188
15750	19759	2	applied	\N	\N	\N	\N	123501	123501	291189
15750	19760	3	applied	\N	\N	\N	\N	123502	123502	291190
15750	19762	5	applied	\N	\N	\N	\N	123504	123504	291192
15750	19763	6	applied	\N	\N	\N	\N	123505	123505	291193
15750	19764	7	applied	\N	\N	\N	\N	123506	123506	291194
15750	19765	8	applied	\N	\N	\N	\N	123507	123507	291195
15750	19766	9	applied	\N	\N	\N	\N	123508	123508	291196
15750	19767	10	applied	\N	\N	\N	\N	123509	123509	291197
15750	19768	11	applied	\N	\N	\N	\N	123510	123510	291198
15750	19769	12	applied	\N	\N	\N	\N	123511	123511	291199
15750	19770	13	applied	\N	\N	\N	\N	123512	123512	291200
15753	19778	0	applied	\N	\N	\N	\N	123527	123527	291215
15753	19779	1	applied	\N	\N	\N	\N	123528	123528	291216
15753	19780	2	applied	\N	\N	\N	\N	123529	123529	291217
15753	19781	3	applied	\N	\N	\N	\N	123530	123530	291218
15753	19782	4	applied	\N	\N	\N	\N	123531	123531	291219
15753	19783	5	applied	\N	\N	\N	\N	123532	123532	291220
15753	19784	6	applied	\N	\N	\N	\N	123533	123533	291221
15755	19779	1	applied	\N	\N	\N	\N	123542	123542	291230
15755	19780	2	applied	\N	\N	\N	\N	123543	123543	291231
15755	19781	3	applied	\N	\N	\N	\N	123544	123544	291232
15755	19782	4	applied	\N	\N	\N	\N	123545	123545	291233
15755	19783	5	applied	\N	\N	\N	\N	123546	123546	291234
15755	19784	6	applied	\N	\N	\N	\N	123547	123547	291235
15755	19785	7	applied	\N	\N	\N	\N	123548	123548	291236
15761	19798	0	applied	\N	\N	\N	\N	123569	123569	291257
15761	19799	1	applied	\N	\N	\N	\N	123570	123570	291258
15761	19800	2	applied	\N	\N	\N	\N	123571	123571	291259
15761	19801	3	applied	\N	\N	\N	\N	123572	123572	291260
15761	19802	4	applied	\N	\N	\N	\N	123573	123573	291261
15761	19803	5	applied	\N	\N	\N	\N	123574	123574	291262
15761	19804	6	applied	\N	\N	\N	\N	123575	123575	291263
15761	19805	7	applied	\N	\N	\N	\N	123576	123576	291264
15761	19806	8	applied	\N	\N	\N	\N	123577	123577	291265
15766	19818	1	applied	\N	\N	\N	\N	123592	123592	291280
15766	19819	2	applied	\N	\N	\N	\N	123593	123593	291281
15766	19820	3	applied	\N	\N	\N	\N	123594	123594	291282
15766	19821	4	applied	\N	\N	\N	\N	123595	123595	291283
15766	19822	5	applied	\N	\N	\N	\N	123596	123596	291284
15766	19823	6	applied	\N	\N	\N	\N	123597	123597	291285
15768	19817	0	applied	\N	\N	\N	\N	123605	123605	291293
15768	19818	1	applied	\N	\N	\N	\N	123606	123606	291294
15768	19819	2	applied	\N	\N	\N	\N	123607	123607	291295
15768	19820	3	applied	\N	\N	\N	\N	123608	123608	291296
15768	19821	4	applied	\N	\N	\N	\N	123609	123609	291297
15768	19822	5	applied	\N	\N	\N	\N	123610	123610	291298
15768	19823	6	applied	\N	\N	\N	\N	123611	123611	291299
15771	19832	0	applied	\N	\N	\N	\N	123620	123620	291308
15771	19833	1	applied	\N	\N	\N	\N	123621	123621	291309
15771	19834	2	applied	\N	\N	\N	\N	123622	123622	291310
15772	19836	1	applied	\N	\N	\N	\N	123624	123624	291312
15772	19837	2	applied	\N	\N	\N	\N	123625	123625	291313
15772	19838	3	applied	\N	\N	\N	\N	123626	123626	291314
15772	19839	4	applied	\N	\N	\N	\N	123627	123627	291315
15772	19840	5	applied	\N	\N	\N	\N	123628	123628	291316
15772	19841	6	applied	\N	\N	\N	\N	123629	123629	291317
15782	19862	0	applied	\N	\N	\N	\N	123680	123680	291368
15782	19863	1	applied	\N	\N	\N	\N	123681	123681	291369
15782	19864	2	applied	\N	\N	\N	\N	123682	123682	291370
15782	19865	3	applied	\N	\N	\N	\N	123683	123683	291371
15784	19862	0	applied	\N	\N	\N	\N	123688	123688	291376
15784	19863	1	applied	\N	\N	\N	\N	123689	123689	291377
15784	19864	2	applied	\N	\N	\N	\N	123690	123690	291378
15788	19882	0	applied	\N	\N	\N	\N	123707	123707	291395
15788	19883	1	applied	\N	\N	\N	\N	123708	123708	291396
15788	19884	2	applied	\N	\N	\N	\N	123709	123709	291397
15788	19886	4	applied	\N	\N	\N	\N	123711	123711	291399
15790	19887	0	applied	\N	\N	\N	\N	123715	123715	291403
15790	19888	1	applied	\N	\N	\N	\N	123716	123716	291404
15790	19889	2	applied	\N	\N	\N	\N	123717	123717	291405
15790	19890	3	applied	\N	\N	\N	\N	123718	123718	291406
15790	19891	4	applied	\N	\N	\N	\N	123719	123719	291407
15795	19905	0	applied	\N	\N	\N	\N	123737	123737	291425
15795	19906	1	applied	\N	\N	\N	\N	123738	123738	291426
15795	19907	2	applied	\N	\N	\N	\N	123739	123739	291427
15795	19908	3	applied	\N	\N	\N	\N	123740	123740	291428
15803	19942	0	applied	\N	\N	\N	\N	123777	123777	291465
15803	19943	1	applied	\N	\N	\N	\N	123778	123778	291466
15808	19733	0	applied	\N	\N	1000000000	\N	123794	123794	291482
15808	19817	1	applied	\N	\N	\N	\N	123795	123795	291483
15808	19934	2	applied	\N	\N	\N	\N	123796	123796	291484
15808	19750	3	applied	\N	\N	\N	\N	123797	123797	291485
15808	19828	5	applied	\N	\N	\N	\N	123799	123799	291487
15808	19840	6	applied	\N	\N	\N	\N	123800	123800	291488
15808	19713	7	applied	\N	\N	1000000000	\N	123801	123801	291489
15808	19726	8	applied	\N	\N	\N	\N	123802	123802	291490
15817	19970	0	applied	\N	\N	\N	\N	123885	123885	291573
15817	19971	1	applied	\N	\N	\N	\N	123886	123886	291574
15817	19972	2	applied	\N	\N	\N	\N	123887	123887	291575
15817	19973	3	applied	\N	\N	\N	\N	123888	123888	291576
15817	19974	4	applied	\N	\N	\N	\N	123889	123889	291577
15817	19975	5	applied	\N	\N	\N	\N	123890	123890	291578
15817	19976	6	applied	\N	\N	\N	\N	123891	123891	291579
15817	19977	7	applied	\N	\N	\N	\N	123892	123892	291580
15817	19978	8	applied	\N	\N	\N	\N	123893	123893	291581
15817	19979	9	applied	\N	\N	\N	\N	123894	123894	291582
15817	19980	10	applied	\N	\N	\N	\N	123895	123895	291583
15817	19981	11	applied	\N	\N	\N	\N	123896	123896	291584
15748	19760	3	applied	\N	\N	\N	\N	123474	123474	291162
15748	19761	4	applied	\N	\N	\N	\N	123475	123475	291163
15751	19773	2	applied	\N	\N	\N	\N	123515	123515	291203
15751	19774	3	applied	\N	\N	\N	\N	123516	123516	291204
15751	19775	4	applied	\N	\N	\N	\N	123517	123517	291205
15751	19776	5	applied	\N	\N	\N	\N	123518	123518	291206
15751	19777	6	applied	\N	\N	\N	\N	123519	123519	291207
15756	19786	0	applied	\N	\N	\N	\N	123549	123549	291237
15756	19787	1	applied	\N	\N	\N	\N	123550	123550	291238
15756	19788	2	applied	\N	\N	\N	\N	123551	123551	291239
15756	19789	3	applied	\N	\N	\N	\N	123552	123552	291240
15756	19785	4	applied	\N	\N	\N	\N	123553	123553	291241
15756	19790	5	applied	\N	\N	\N	\N	123554	123554	291242
15764	19810	0	applied	\N	\N	\N	\N	123584	123584	291272
15764	19811	1	applied	\N	\N	\N	\N	123585	123585	291273
15764	19812	2	applied	\N	\N	\N	\N	123586	123586	291274
15769	19824	0	applied	\N	\N	\N	\N	123612	123612	291300
15769	19825	1	applied	\N	\N	\N	\N	123613	123613	291301
15772	19842	7	applied	\N	\N	\N	\N	123630	123630	291318
15772	19843	8	applied	\N	\N	\N	\N	123631	123631	291319
15772	19844	9	applied	\N	\N	\N	\N	123632	123632	291320
15773	19835	0	applied	\N	\N	\N	\N	123633	123633	291321
15773	19836	1	applied	\N	\N	\N	\N	123634	123634	291322
15773	19837	2	applied	\N	\N	\N	\N	123635	123635	291323
15773	19838	3	applied	\N	\N	\N	\N	123636	123636	291324
15773	19839	4	applied	\N	\N	\N	\N	123637	123637	291325
15773	19840	5	applied	\N	\N	\N	\N	123638	123638	291326
15773	19841	6	applied	\N	\N	\N	\N	123639	123639	291327
15773	19842	7	applied	\N	\N	\N	\N	123640	123640	291328
15773	19843	8	applied	\N	\N	\N	\N	123641	123641	291329
15773	19844	9	applied	\N	\N	\N	\N	123642	123642	291330
15774	19845	0	applied	\N	\N	\N	\N	123643	123643	291331
15774	19846	1	applied	\N	\N	\N	\N	123644	123644	291332
15774	19847	2	applied	\N	\N	\N	\N	123645	123645	291333
15777	19854	1	applied	\N	\N	\N	\N	123663	123663	291351
15777	19848	2	applied	\N	\N	\N	\N	123664	123664	291352
15777	19849	3	applied	\N	\N	\N	\N	123665	123665	291353
15777	19850	4	applied	\N	\N	\N	\N	123666	123666	291354
15777	19851	5	applied	\N	\N	\N	\N	123667	123667	291355
15777	19852	6	applied	\N	\N	\N	\N	123668	123668	291356
15777	19855	7	applied	\N	\N	\N	\N	123669	123669	291357
15779	19856	0	applied	\N	\N	\N	\N	123671	123671	291359
15779	19857	1	applied	\N	\N	\N	\N	123672	123672	291360
15779	19858	2	applied	\N	\N	\N	\N	123673	123673	291361
15781	19859	0	applied	\N	\N	\N	\N	123677	123677	291365
15781	19860	1	applied	\N	\N	\N	\N	123678	123678	291366
15781	19861	2	applied	\N	\N	\N	\N	123679	123679	291367
15783	19862	0	applied	\N	\N	\N	\N	123684	123684	291372
15783	19863	1	applied	\N	\N	\N	\N	123685	123685	291373
15783	19864	2	applied	\N	\N	\N	\N	123686	123686	291374
15786	19872	0	applied	\N	\N	\N	\N	123697	123697	291385
15786	19873	1	applied	\N	\N	\N	\N	123698	123698	291386
15786	19874	2	applied	\N	\N	\N	\N	123699	123699	291387
15786	19875	3	applied	\N	\N	\N	\N	123700	123700	291388
15787	19876	0	applied	\N	\N	\N	\N	123701	123701	291389
15787	19877	1	applied	\N	\N	\N	\N	123702	123702	291390
15787	19878	2	applied	\N	\N	\N	\N	123703	123703	291391
15787	19879	3	applied	\N	\N	\N	\N	123704	123704	291392
15787	19880	4	applied	\N	\N	\N	\N	123705	123705	291393
15787	19881	5	applied	\N	\N	\N	\N	123706	123706	291394
15789	19882	0	applied	\N	\N	\N	\N	123712	123712	291400
15789	19883	1	applied	\N	\N	\N	\N	123713	123713	291401
15789	19884	2	applied	\N	\N	\N	\N	123714	123714	291402
15792	19895	0	applied	\N	\N	\N	\N	123723	123723	291411
15792	19896	1	applied	\N	\N	\N	\N	123724	123724	291412
15792	19897	2	applied	\N	\N	\N	\N	123725	123725	291413
15794	19899	0	applied	\N	\N	\N	\N	123731	123731	291419
15794	19900	1	applied	\N	\N	\N	\N	123732	123732	291420
15794	19901	2	applied	\N	\N	\N	\N	123733	123733	291421
15794	19902	3	applied	\N	\N	\N	\N	123734	123734	291422
15794	19903	4	applied	\N	\N	\N	\N	123735	123735	291423
15794	19904	5	applied	\N	\N	\N	\N	123736	123736	291424
15797	19925	0	applied	\N	\N	\N	\N	123757	123757	291445
15797	19926	1	applied	\N	\N	\N	\N	123758	123758	291446
15797	19927	2	applied	\N	\N	\N	\N	123759	123759	291447
15798	19925	0	applied	\N	\N	\N	\N	123760	123760	291448
15798	19926	1	applied	\N	\N	\N	\N	123761	123761	291449
15798	19927	2	applied	\N	\N	\N	\N	123762	123762	291450
15799	19928	0	applied	\N	\N	\N	\N	123763	123763	291451
15799	19929	1	applied	\N	\N	\N	\N	123764	123764	291452
15799	19930	2	applied	\N	\N	\N	\N	123765	123765	291453
15800	19931	0	applied	\N	\N	\N	\N	123766	123766	291454
15800	19933	2	applied	\N	\N	\N	\N	123768	123768	291456
15802	19937	0	applied	\N	\N	\N	\N	123772	123772	291460
15802	19938	1	applied	\N	\N	\N	\N	123773	123773	291461
15802	19939	2	applied	\N	\N	\N	\N	123774	123774	291462
15802	19940	3	applied	\N	\N	\N	\N	123775	123775	291463
15802	19941	4	applied	\N	\N	\N	\N	123776	123776	291464
15805	19945	0	applied	\N	\N	\N	\N	123782	123782	291470
15805	19946	1	applied	\N	\N	\N	\N	123783	123783	291471
15805	19947	2	applied	\N	\N	\N	\N	123784	123784	291472
15805	19944	3	applied	\N	\N	\N	\N	123785	123785	291473
15805	19948	4	applied	\N	\N	\N	\N	123786	123786	291474
15807	19949	0	applied	\N	\N	\N	\N	123790	123790	291478
15807	19952	1	applied	\N	\N	\N	\N	123791	123791	291479
15807	19950	2	applied	\N	\N	\N	\N	123792	123792	291480
15807	19951	3	applied	\N	\N	\N	\N	123793	123793	291481
15809	19953	0	applied	\N	\N	\N	\N	123803	123803	291491
15809	19954	2	applied	\N	\N	\N	\N	123805	123805	291493
15809	19955	3	applied	\N	\N	\N	\N	123806	123806	291494
15812	19956	0	applied	\N	\N	\N	\N	123818	123818	291506
15812	19957	1	applied	\N	\N	\N	\N	123819	123819	291507
15812	19958	2	applied	\N	\N	\N	\N	123820	123820	291508
15812	19959	3	applied	\N	\N	\N	\N	123821	123821	291509
15812	19960	4	applied	\N	\N	\N	\N	123822	123822	291510
15812	19961	5	applied	\N	\N	\N	\N	123823	123823	291511
15812	19962	6	applied	\N	\N	\N	\N	123824	123824	291512
15812	19967	7	applied	\N	\N	\N	\N	123825	123825	291513
15812	19968	8	applied	\N	\N	\N	\N	123826	123826	291514
15812	19963	9	applied	\N	\N	\N	\N	123827	123827	291515
15812	19964	10	applied	\N	\N	\N	\N	123828	123828	291516
15813	19956	0	applied	\N	\N	\N	\N	123832	123832	291520
15749	19770	13	applied	\N	\N	\N	\N	123498	123498	291186
15751	19771	0	applied	\N	\N	\N	\N	123513	123513	291201
15813	19958	2	applied	\N	\N	\N	\N	123834	123834	291522
15813	19959	3	applied	\N	\N	\N	\N	123835	123835	291523
15813	19960	4	applied	\N	\N	\N	\N	123836	123836	291524
15813	19961	5	applied	\N	\N	\N	\N	123837	123837	291525
15813	19962	6	applied	\N	\N	\N	\N	123838	123838	291526
15813	19967	7	applied	\N	\N	\N	\N	123839	123839	291527
15813	19968	8	applied	\N	\N	\N	\N	123840	123840	291528
15813	19963	9	applied	\N	\N	\N	\N	123841	123841	291529
15813	19964	10	applied	\N	\N	\N	\N	123842	123842	291530
15813	19965	11	applied	\N	\N	\N	\N	123843	123843	291531
15813	19966	12	applied	\N	\N	\N	\N	123844	123844	291532
15813	19969	13	applied	\N	\N	\N	\N	123845	123845	291533
15814	19956	0	applied	\N	\N	\N	\N	123846	123846	291534
15814	19957	1	applied	\N	\N	\N	\N	123847	123847	291535
15814	19958	2	applied	\N	\N	\N	\N	123848	123848	291536
15814	19959	3	applied	\N	\N	\N	\N	123849	123849	291537
15814	19961	5	applied	\N	\N	\N	\N	123851	123851	291539
15814	19962	6	applied	\N	\N	\N	\N	123852	123852	291540
15814	19967	7	applied	\N	\N	\N	\N	123853	123853	291541
15814	19968	8	applied	\N	\N	\N	\N	123854	123854	291542
15814	19963	9	applied	\N	\N	\N	\N	123855	123855	291543
15814	19964	10	applied	\N	\N	\N	\N	123856	123856	291544
15814	19965	11	applied	\N	\N	\N	\N	123857	123857	291545
15814	19966	12	applied	\N	\N	\N	\N	123858	123858	291546
15814	19969	13	applied	\N	\N	\N	\N	123859	123859	291547
15815	19956	0	applied	\N	\N	\N	\N	123860	123860	291548
15815	19957	1	applied	\N	\N	\N	\N	123861	123861	291549
15815	19958	2	applied	\N	\N	\N	\N	123862	123862	291550
15815	19959	3	applied	\N	\N	\N	\N	123863	123863	291551
15815	19960	4	applied	\N	\N	\N	\N	123864	123864	291552
15815	19961	5	applied	\N	\N	\N	\N	123865	123865	291553
15815	19962	6	applied	\N	\N	\N	\N	123866	123866	291554
15815	19968	8	applied	\N	\N	\N	\N	123868	123868	291556
15815	19963	9	applied	\N	\N	\N	\N	123869	123869	291557
15815	19964	10	applied	\N	\N	\N	\N	123870	123870	291558
15815	19965	11	applied	\N	\N	\N	\N	123871	123871	291559
15815	19966	12	applied	\N	\N	\N	\N	123872	123872	291560
15815	19969	13	applied	\N	\N	\N	\N	123873	123873	291561
15821	20007	0	applied	\N	\N	\N	\N	123927	123927	291615
15821	20008	1	applied	\N	\N	\N	\N	123928	123928	291616
15821	20009	2	applied	\N	\N	\N	\N	123929	123929	291617
15821	20010	3	applied	\N	\N	\N	\N	123930	123930	291618
15821	20011	4	applied	\N	\N	\N	\N	123931	123931	291619
15821	20012	5	applied	\N	\N	\N	\N	123932	123932	291620
15821	20013	6	applied	\N	\N	\N	\N	123933	123933	291621
15821	20014	8	applied	\N	\N	\N	\N	123934	123934	291622
15821	20015	9	applied	\N	\N	\N	\N	123935	123935	291623
15821	20016	10	applied	\N	\N	\N	\N	123936	123936	291624
15821	20018	12	applied	\N	\N	\N	\N	123938	123938	291626
15821	20019	13	applied	\N	\N	\N	\N	123939	123939	291627
15821	20020	14	applied	\N	\N	\N	\N	123940	123940	291628
15821	20021	15	applied	\N	\N	\N	\N	123941	123941	291629
15821	20022	16	applied	\N	\N	\N	\N	123942	123942	291630
15821	20023	17	applied	\N	\N	\N	\N	123943	123943	291631
15821	20024	18	applied	\N	\N	\N	\N	123944	123944	291632
15821	20025	19	applied	\N	\N	\N	\N	123945	123945	291633
15825	20007	0	applied	\N	\N	\N	\N	124003	124003	291691
15825	20008	1	applied	\N	\N	\N	\N	124004	124004	291692
15825	20009	2	applied	\N	\N	\N	\N	124005	124005	291693
15825	20010	3	applied	\N	\N	\N	\N	124006	124006	291694
15825	20011	4	applied	\N	\N	\N	\N	124007	124007	291695
15825	20012	5	applied	\N	\N	\N	\N	124008	124008	291696
15825	20013	6	applied	\N	\N	\N	\N	124009	124009	291697
15825	20014	8	applied	\N	\N	\N	\N	124010	124010	291698
15825	20016	10	applied	\N	\N	\N	\N	124012	124012	291700
15825	20017	11	applied	\N	\N	\N	\N	124013	124013	291701
15825	20018	12	applied	\N	\N	\N	\N	124014	124014	291702
15825	20019	13	applied	\N	\N	\N	\N	124015	124015	291703
15825	20020	14	applied	\N	\N	\N	\N	124016	124016	291704
15825	20021	15	applied	\N	\N	\N	\N	124017	124017	291705
15825	20022	16	applied	\N	\N	\N	\N	124018	124018	291706
15825	20023	17	applied	\N	\N	\N	\N	124019	124019	291707
15825	20024	18	applied	\N	\N	\N	\N	124020	124020	291708
15825	20025	19	applied	\N	\N	\N	\N	124021	124021	291709
15826	20007	0	applied	\N	\N	\N	\N	124022	124022	291710
15826	20008	1	applied	\N	\N	\N	\N	124023	124023	291711
15826	20009	2	applied	\N	\N	\N	\N	124024	124024	291712
15826	20010	3	applied	\N	\N	\N	\N	124025	124025	291713
15826	20011	4	applied	\N	\N	\N	\N	124026	124026	291714
15826	20012	5	applied	\N	\N	\N	\N	124027	124027	291715
15826	20014	8	applied	\N	\N	\N	\N	124029	124029	291717
15826	20015	9	applied	\N	\N	\N	\N	124030	124030	291718
15826	20016	10	applied	\N	\N	\N	\N	124031	124031	291719
15826	20017	11	applied	\N	\N	\N	\N	124032	124032	291720
15826	20018	12	applied	\N	\N	\N	\N	124033	124033	291721
15826	20019	13	applied	\N	\N	\N	\N	124034	124034	291722
15826	20020	14	applied	\N	\N	\N	\N	124035	124035	291723
15826	20021	15	applied	\N	\N	\N	\N	124036	124036	291724
15826	20022	16	applied	\N	\N	\N	\N	124037	124037	291725
15826	20023	17	applied	\N	\N	\N	\N	124038	124038	291726
15826	20024	18	applied	\N	\N	\N	\N	124039	124039	291727
15826	20025	19	applied	\N	\N	\N	\N	124040	124040	291728
15828	20007	0	applied	\N	\N	\N	\N	124060	124060	291748
15828	20008	1	applied	\N	\N	\N	\N	124061	124061	291749
15828	20009	2	applied	\N	\N	\N	\N	124062	124062	291750
15828	20010	3	applied	\N	\N	\N	\N	124063	124063	291751
15828	20012	5	applied	\N	\N	\N	\N	124065	124065	291753
15828	20013	6	applied	\N	\N	\N	\N	124066	124066	291754
15828	20014	8	applied	\N	\N	\N	\N	124067	124067	291755
15828	20015	9	applied	\N	\N	\N	\N	124068	124068	291756
15828	20016	10	applied	\N	\N	\N	\N	124069	124069	291757
15828	20017	11	applied	\N	\N	\N	\N	124070	124070	291758
15828	20018	12	applied	\N	\N	\N	\N	124071	124071	291759
15828	20019	13	applied	\N	\N	\N	\N	124072	124072	291760
15828	20020	14	applied	\N	\N	\N	\N	124073	124073	291761
15828	20021	15	applied	\N	\N	\N	\N	124074	124074	291762
15828	20022	16	applied	\N	\N	\N	\N	124075	124075	291763
15828	20023	17	applied	\N	\N	\N	\N	124076	124076	291764
15828	20024	18	applied	\N	\N	\N	\N	124077	124077	291765
15828	20025	19	applied	\N	\N	\N	\N	124078	124078	291766
15811	19965	9	applied	\N	\N	\N	\N	123816	123816	291504
15811	19966	10	applied	\N	\N	\N	\N	123817	123817	291505
15816	19957	1	applied	\N	\N	\N	\N	123875	123875	291563
15816	19958	2	applied	\N	\N	\N	\N	123876	123876	291564
15816	19959	3	applied	\N	\N	\N	\N	123877	123877	291565
15816	19960	4	applied	\N	\N	\N	\N	123878	123878	291566
15816	19961	5	applied	\N	\N	\N	\N	123879	123879	291567
15816	19962	6	applied	\N	\N	\N	\N	123880	123880	291568
15816	19963	7	applied	\N	\N	\N	\N	123881	123881	291569
15816	19964	8	applied	\N	\N	\N	\N	123882	123882	291570
15816	19965	9	applied	\N	\N	\N	\N	123883	123883	291571
15816	19966	10	applied	\N	\N	\N	\N	123884	123884	291572
15818	19989	0	applied	\N	\N	\N	\N	123904	123904	291592
15818	19990	1	applied	\N	\N	\N	\N	123905	123905	291593
15818	19991	2	applied	\N	\N	\N	\N	123906	123906	291594
15818	19992	3	applied	\N	\N	\N	\N	123907	123907	291595
15822	20007	0	applied	\N	\N	\N	\N	123946	123946	291634
15822	20008	1	applied	\N	\N	\N	\N	123947	123947	291635
15822	20009	2	applied	\N	\N	\N	\N	123948	123948	291636
15822	20010	3	applied	\N	\N	\N	\N	123949	123949	291637
15822	20011	4	applied	\N	\N	\N	\N	123950	123950	291638
15822	20012	5	applied	\N	\N	\N	\N	123951	123951	291639
15822	20013	6	applied	\N	\N	\N	\N	123952	123952	291640
15822	20014	8	applied	\N	\N	\N	\N	123953	123953	291641
15822	20015	9	applied	\N	\N	\N	\N	123954	123954	291642
15822	20016	10	applied	\N	\N	\N	\N	123955	123955	291643
15822	20017	11	applied	\N	\N	\N	\N	123956	123956	291644
15822	20018	12	applied	\N	\N	\N	\N	123957	123957	291645
15822	20019	13	applied	\N	\N	\N	\N	123958	123958	291646
15822	20020	14	applied	\N	\N	\N	\N	123959	123959	291647
15822	20021	15	applied	\N	\N	\N	\N	123960	123960	291648
15822	20022	16	applied	\N	\N	\N	\N	123961	123961	291649
15822	20024	18	applied	\N	\N	\N	\N	123963	123963	291651
15822	20025	19	applied	\N	\N	\N	\N	123964	123964	291652
15824	20007	0	applied	\N	\N	\N	\N	123984	123984	291672
15824	20008	1	applied	\N	\N	\N	\N	123985	123985	291673
15824	20009	2	applied	\N	\N	\N	\N	123986	123986	291674
15824	20010	3	applied	\N	\N	\N	\N	123987	123987	291675
15824	20011	4	applied	\N	\N	\N	\N	123988	123988	291676
15824	20012	5	applied	\N	\N	\N	\N	123989	123989	291677
15824	20013	6	applied	\N	\N	\N	\N	123990	123990	291678
15824	20014	8	applied	\N	\N	\N	\N	123991	123991	291679
15824	20015	9	applied	\N	\N	\N	\N	123992	123992	291680
15824	20016	10	applied	\N	\N	\N	\N	123993	123993	291681
15824	20017	11	applied	\N	\N	\N	\N	123994	123994	291682
15824	20018	12	applied	\N	\N	\N	\N	123995	123995	291683
15824	20019	13	applied	\N	\N	\N	\N	123996	123996	291684
15824	20020	14	applied	\N	\N	\N	\N	123997	123997	291685
15824	20022	16	applied	\N	\N	\N	\N	123999	123999	291687
15824	20023	17	applied	\N	\N	\N	\N	124000	124000	291688
15824	20024	18	applied	\N	\N	\N	\N	124001	124001	291689
15824	20025	19	applied	\N	\N	\N	\N	124002	124002	291690
15827	20007	0	applied	\N	\N	\N	\N	124041	124041	291729
15827	20008	1	applied	\N	\N	\N	\N	124042	124042	291730
15827	20009	2	applied	\N	\N	\N	\N	124043	124043	291731
15827	20010	3	applied	\N	\N	\N	\N	124044	124044	291732
15827	20011	4	applied	\N	\N	\N	\N	124045	124045	291733
15827	20012	5	applied	\N	\N	\N	\N	124046	124046	291734
15827	20013	6	applied	\N	\N	\N	\N	124047	124047	291735
15827	20014	8	applied	\N	\N	\N	\N	124048	124048	291736
15827	20015	9	applied	\N	\N	\N	\N	124049	124049	291737
15827	20016	10	applied	\N	\N	\N	\N	124050	124050	291738
15827	20017	11	applied	\N	\N	\N	\N	124051	124051	291739
15827	20018	12	applied	\N	\N	\N	\N	124052	124052	291740
15827	20020	14	applied	\N	\N	\N	\N	124054	124054	291742
15827	20021	15	applied	\N	\N	\N	\N	124055	124055	291743
15827	20022	16	applied	\N	\N	\N	\N	124056	124056	291744
15827	20023	17	applied	\N	\N	\N	\N	124057	124057	291745
15830	20026	0	applied	\N	\N	\N	\N	124084	124084	291772
15830	20027	1	applied	\N	\N	\N	\N	124085	124085	291773
15830	20028	2	applied	\N	\N	\N	\N	124086	124086	291774
15830	20029	3	applied	\N	\N	\N	\N	124087	124087	291775
15830	20030	4	applied	\N	\N	\N	\N	124088	124088	291776
15832	20031	0	applied	\N	\N	\N	\N	124094	124094	291782
15832	20032	1	applied	\N	\N	\N	\N	124095	124095	291783
15832	20033	2	applied	\N	\N	\N	\N	124096	124096	291784
15832	20034	3	applied	\N	\N	\N	\N	124097	124097	291785
15832	20035	4	applied	\N	\N	\N	\N	124098	124098	291786
15834	20036	0	applied	\N	\N	\N	\N	124106	124106	291794
15834	20037	1	applied	\N	\N	\N	\N	124107	124107	291795
15834	20039	3	applied	\N	\N	\N	\N	124109	124109	291797
15834	20040	4	applied	\N	\N	\N	\N	124110	124110	291798
15834	20041	5	applied	\N	\N	\N	\N	124111	124111	291799
15834	20042	6	applied	\N	\N	\N	\N	124112	124112	291800
15838	20066	0	applied	\N	\N	\N	\N	124139	124139	291827
15838	20067	1	applied	\N	\N	\N	\N	124140	124140	291828
15844	20069	0	applied	\N	\N	\N	\N	124159	124159	291847
15844	20070	1	applied	\N	\N	\N	\N	124160	124160	291848
15844	20071	2	applied	\N	\N	\N	\N	124161	124161	291849
15844	20072	3	applied	\N	\N	\N	\N	124162	124162	291850
15849	20076	0	applied	\N	\N	\N	\N	124189	124189	291877
15849	20077	1	applied	\N	\N	\N	\N	124190	124190	291878
15849	20078	2	applied	\N	\N	\N	\N	124191	124191	291879
15849	20079	3	applied	\N	\N	\N	\N	124192	124192	291880
15849	20080	4	applied	\N	\N	\N	\N	124193	124193	291881
15849	20081	5	applied	\N	\N	\N	\N	124194	124194	291882
15849	20083	7	applied	\N	\N	\N	\N	124196	124196	291884
15849	20084	8	applied	\N	\N	\N	\N	124197	124197	291885
15849	20085	9	applied	\N	\N	\N	\N	124198	124198	291886
15851	20086	0	applied	\N	\N	1000000000	\N	124209	124209	291897
15851	20087	1	applied	\N	\N	\N	\N	124210	124210	291898
15851	20088	2	applied	\N	\N	\N	\N	124211	124211	291899
15851	20089	3	applied	\N	\N	\N	\N	124212	124212	291900
15858	20099	0	applied	\N	\N	\N	\N	124239	124239	291927
15858	20100	1	applied	\N	\N	\N	\N	124240	124240	291928
15858	20101	2	applied	\N	\N	\N	\N	124241	124241	291929
15861	20102	0	applied	\N	\N	\N	\N	124252	124252	291940
15861	20103	1	applied	\N	\N	\N	\N	124253	124253	291941
15861	20104	2	applied	\N	\N	\N	\N	124254	124254	291942
15861	20105	3	applied	\N	\N	\N	\N	124255	124255	291943
15861	20106	4	applied	\N	\N	\N	\N	124256	124256	291944
15861	20107	5	applied	\N	\N	\N	\N	124257	124257	291945
15816	19956	0	applied	\N	\N	\N	\N	123874	123874	291562
15817	19987	17	applied	\N	\N	\N	\N	123902	123902	291590
15817	19988	18	applied	\N	\N	\N	\N	123903	123903	291591
15819	19989	0	applied	\N	\N	\N	\N	123909	123909	291597
15819	19990	1	applied	\N	\N	\N	\N	123910	123910	291598
15819	19991	2	applied	\N	\N	\N	\N	123911	123911	291599
15819	19992	3	applied	\N	\N	\N	\N	123912	123912	291600
15819	19993	4	applied	\N	\N	\N	\N	123913	123913	291601
15820	19994	0	applied	\N	\N	\N	\N	123914	123914	291602
15820	19995	1	applied	\N	\N	\N	\N	123915	123915	291603
15820	19996	2	applied	\N	\N	\N	\N	123916	123916	291604
15820	19997	3	applied	\N	\N	\N	\N	123917	123917	291605
15820	19998	4	applied	\N	\N	\N	\N	123918	123918	291606
15820	19999	5	applied	\N	\N	\N	\N	123919	123919	291607
15820	20000	6	applied	\N	\N	\N	\N	123920	123920	291608
15820	20002	8	applied	\N	\N	\N	\N	123922	123922	291610
15820	20003	9	applied	\N	\N	\N	\N	123923	123923	291611
15820	20004	10	applied	\N	\N	\N	\N	123924	123924	291612
15820	20005	11	applied	\N	\N	\N	\N	123925	123925	291613
15820	20006	12	applied	\N	\N	\N	\N	123926	123926	291614
15823	20007	0	applied	\N	\N	\N	\N	123965	123965	291653
15823	20008	1	applied	\N	\N	\N	\N	123966	123966	291654
15823	20009	2	applied	\N	\N	\N	\N	123967	123967	291655
15823	20010	3	applied	\N	\N	\N	\N	123968	123968	291656
15823	20011	4	applied	\N	\N	\N	\N	123969	123969	291657
15823	20012	5	applied	\N	\N	\N	\N	123970	123970	291658
15823	20013	6	applied	\N	\N	\N	\N	123971	123971	291659
15823	20014	8	applied	\N	\N	\N	\N	123972	123972	291660
15823	20015	9	applied	\N	\N	\N	\N	123973	123973	291661
15823	20016	10	applied	\N	\N	\N	\N	123974	123974	291662
15823	20017	11	applied	\N	\N	\N	\N	123975	123975	291663
15823	20019	13	applied	\N	\N	\N	\N	123977	123977	291665
15823	20020	14	applied	\N	\N	\N	\N	123978	123978	291666
15823	20021	15	applied	\N	\N	\N	\N	123979	123979	291667
15823	20022	16	applied	\N	\N	\N	\N	123980	123980	291668
15823	20023	17	applied	\N	\N	\N	\N	123981	123981	291669
15823	20024	18	applied	\N	\N	\N	\N	123982	123982	291670
15823	20025	19	applied	\N	\N	\N	\N	123983	123983	291671
15827	20024	18	applied	\N	\N	\N	\N	124058	124058	291746
15827	20025	19	applied	\N	\N	\N	\N	124059	124059	291747
15829	20026	0	applied	\N	\N	\N	\N	124079	124079	291767
15829	20027	1	applied	\N	\N	\N	\N	124080	124080	291768
15829	20028	2	applied	\N	\N	\N	\N	124081	124081	291769
15829	20029	3	applied	\N	\N	\N	\N	124082	124082	291770
15829	20030	4	applied	\N	\N	\N	\N	124083	124083	291771
15831	20031	0	applied	\N	\N	\N	\N	124089	124089	291777
15831	20032	1	applied	\N	\N	\N	\N	124090	124090	291778
15831	20034	3	applied	\N	\N	\N	\N	124092	124092	291780
15831	20035	4	applied	\N	\N	\N	\N	124093	124093	291781
15837	20066	0	applied	\N	\N	\N	\N	124136	124136	291824
15837	20067	1	applied	\N	\N	\N	\N	124137	124137	291825
15837	20068	2	applied	\N	\N	\N	\N	124138	124138	291826
15839	20066	0	applied	\N	\N	\N	\N	124141	124141	291829
15839	20067	1	applied	\N	\N	\N	\N	124142	124142	291830
15839	20068	2	applied	\N	\N	\N	\N	124143	124143	291831
15840	20066	0	applied	\N	\N	\N	\N	124144	124144	291832
15840	20067	1	applied	\N	\N	\N	\N	124145	124145	291833
15840	20068	2	applied	\N	\N	\N	\N	124146	124146	291834
15841	20069	0	applied	\N	\N	\N	\N	124147	124147	291835
15841	20070	1	applied	\N	\N	\N	\N	124148	124148	291836
15841	20071	2	applied	\N	\N	\N	\N	124149	124149	291837
15841	20072	3	applied	\N	\N	\N	\N	124150	124150	291838
15842	20069	0	applied	\N	\N	\N	\N	124151	124151	291839
15842	20071	2	applied	\N	\N	\N	\N	124153	124153	291841
15842	20072	3	applied	\N	\N	\N	\N	124154	124154	291842
15843	20069	0	applied	\N	\N	\N	\N	124155	124155	291843
15843	20070	1	applied	\N	\N	\N	\N	124156	124156	291844
15843	20071	2	applied	\N	\N	\N	\N	124157	124157	291845
15843	20072	3	applied	\N	\N	\N	\N	124158	124158	291846
15846	20073	0	applied	\N	\N	\N	\N	124166	124166	291854
15846	20074	1	applied	\N	\N	\N	\N	124167	124167	291855
15846	20075	2	applied	\N	\N	\N	\N	124168	124168	291856
15847	20076	0	applied	\N	\N	\N	\N	124169	124169	291857
15847	20077	1	applied	\N	\N	\N	\N	124170	124170	291858
15847	20078	2	applied	\N	\N	\N	\N	124171	124171	291859
15847	20079	3	applied	\N	\N	\N	\N	124172	124172	291860
15847	20080	4	applied	\N	\N	\N	\N	124173	124173	291861
15847	20081	5	applied	\N	\N	\N	\N	124174	124174	291862
15847	20082	6	applied	\N	\N	\N	\N	124175	124175	291863
15847	20084	8	applied	\N	\N	\N	\N	124177	124177	291865
15847	20085	9	applied	\N	\N	\N	\N	124178	124178	291866
15848	20076	0	applied	\N	\N	\N	\N	124179	124179	291867
15848	20077	1	applied	\N	\N	\N	\N	124180	124180	291868
15848	20078	2	applied	\N	\N	\N	\N	124181	124181	291869
15848	20079	3	applied	\N	\N	\N	\N	124182	124182	291870
15852	20086	0	applied	\N	\N	1000000000	\N	124213	124213	291901
15852	20087	1	applied	\N	\N	\N	\N	124214	124214	291902
15852	20088	2	applied	\N	\N	\N	\N	124215	124215	291903
15852	20089	3	applied	\N	\N	\N	\N	124216	124216	291904
15854	20090	0	applied	\N	\N	\N	\N	124221	124221	291909
15854	20091	1	applied	\N	\N	\N	\N	124222	124222	291910
15854	20092	2	applied	\N	\N	\N	\N	124223	124223	291911
15854	20093	3	applied	\N	\N	\N	\N	124224	124224	291912
15854	20094	4	applied	\N	\N	\N	\N	124225	124225	291913
15854	20095	5	applied	\N	\N	\N	\N	124226	124226	291914
15856	20097	1	applied	\N	\N	\N	\N	124234	124234	291922
15856	20098	2	applied	\N	\N	\N	\N	124235	124235	291923
15863	20109	0	applied	\N	\N	\N	\N	124301	124301	291989
15863	20110	1	applied	\N	\N	\N	\N	124302	124302	291990
15863	20111	3	applied	\N	\N	\N	\N	124303	124303	291991
15866	20112	0	applied	\N	\N	\N	\N	124312	124312	292000
15866	20113	1	applied	\N	\N	\N	\N	124313	124313	292001
15866	20114	2	applied	\N	\N	\N	\N	124314	124314	292002
15866	20115	3	applied	\N	\N	\N	\N	124315	124315	292003
15868	20119	0	applied	\N	\N	\N	\N	124319	124319	292007
15868	20120	1	applied	\N	\N	\N	\N	124320	124320	292008
15868	20121	2	applied	\N	\N	\N	\N	124321	124321	292009
15873	20132	0	applied	\N	\N	\N	\N	124336	124336	292024
15873	20133	1	applied	\N	\N	\N	\N	124337	124337	292025
15873	20134	2	applied	\N	\N	\N	\N	124338	124338	292026
15873	20135	3	applied	\N	\N	\N	\N	124339	124339	292027
15817	19986	16	applied	\N	\N	\N	\N	123901	123901	291589
15833	20039	3	applied	\N	\N	\N	\N	124102	124102	291790
15833	20040	4	applied	\N	\N	\N	\N	124103	124103	291791
15833	20041	5	applied	\N	\N	\N	\N	124104	124104	291792
15833	20042	6	applied	\N	\N	\N	\N	124105	124105	291793
15835	20043	0	applied	\N	\N	\N	\N	124113	124113	291801
15835	20044	1	applied	\N	\N	\N	\N	124114	124114	291802
15835	20045	2	applied	\N	\N	\N	\N	124115	124115	291803
15835	20046	3	applied	\N	\N	\N	\N	124116	124116	291804
15835	20047	4	applied	\N	\N	\N	\N	124117	124117	291805
15835	20048	5	applied	\N	\N	\N	\N	124118	124118	291806
15836	20049	0	applied	\N	\N	\N	\N	124119	124119	291807
15836	20051	2	applied	\N	\N	\N	\N	124121	124121	291809
15836	20052	3	applied	\N	\N	\N	\N	124122	124122	291810
15836	20053	4	applied	\N	\N	\N	\N	124123	124123	291811
15836	20054	5	applied	\N	\N	\N	\N	124124	124124	291812
15836	20055	6	applied	\N	\N	\N	\N	124125	124125	291813
15836	20056	7	applied	\N	\N	\N	\N	124126	124126	291814
15836	20057	8	applied	\N	\N	\N	\N	124127	124127	291815
15836	20058	9	applied	\N	\N	\N	\N	124128	124128	291816
15836	20059	10	applied	\N	\N	\N	\N	124129	124129	291817
15836	20060	11	applied	\N	\N	\N	\N	124130	124130	291818
15836	20061	12	applied	\N	\N	\N	\N	124131	124131	291819
15836	20062	13	applied	\N	\N	\N	\N	124132	124132	291820
15836	20063	14	applied	\N	\N	\N	\N	124133	124133	291821
15836	20064	15	applied	\N	\N	\N	\N	124134	124134	291822
15836	20065	16	applied	\N	\N	\N	\N	124135	124135	291823
15845	20073	0	applied	\N	\N	\N	\N	124163	124163	291851
15845	20075	2	applied	\N	\N	\N	\N	124165	124165	291853
15848	20080	4	applied	\N	\N	\N	\N	124183	124183	291871
15848	20081	5	applied	\N	\N	\N	\N	124184	124184	291872
15848	20082	6	applied	\N	\N	\N	\N	124185	124185	291873
15848	20083	7	applied	\N	\N	\N	\N	124186	124186	291874
15848	20084	8	applied	\N	\N	\N	\N	124187	124187	291875
15848	20085	9	applied	\N	\N	\N	\N	124188	124188	291876
15850	20076	0	applied	\N	\N	\N	\N	124199	124199	291887
15850	20077	1	applied	\N	\N	\N	\N	124200	124200	291888
15850	20078	2	applied	\N	\N	\N	\N	124201	124201	291889
15850	20079	3	applied	\N	\N	\N	\N	124202	124202	291890
15850	20080	4	applied	\N	\N	\N	\N	124203	124203	291891
15850	20081	5	applied	\N	\N	\N	\N	124204	124204	291892
15850	20082	6	applied	\N	\N	\N	\N	124205	124205	291893
15850	20083	7	applied	\N	\N	\N	\N	124206	124206	291894
15850	20084	8	applied	\N	\N	\N	\N	124207	124207	291895
15853	20086	0	applied	\N	\N	1000000000	\N	124217	124217	291905
15853	20087	1	applied	\N	\N	\N	\N	124218	124218	291906
15853	20088	2	applied	\N	\N	\N	\N	124219	124219	291907
15853	20089	3	applied	\N	\N	\N	\N	124220	124220	291908
15855	20090	0	applied	\N	\N	\N	\N	124227	124227	291915
15855	20091	1	applied	\N	\N	\N	\N	124228	124228	291916
15855	20092	2	applied	\N	\N	\N	\N	124229	124229	291917
15855	20093	3	applied	\N	\N	\N	\N	124230	124230	291918
15855	20094	4	applied	\N	\N	\N	\N	124231	124231	291919
15855	20095	5	applied	\N	\N	\N	\N	124232	124232	291920
15857	20099	0	applied	\N	\N	\N	\N	124236	124236	291924
15857	20100	1	applied	\N	\N	\N	\N	124237	124237	291925
15857	20101	2	applied	\N	\N	\N	\N	124238	124238	291926
15859	20099	0	applied	\N	\N	\N	\N	124242	124242	291930
15859	20100	1	applied	\N	\N	\N	\N	124243	124243	291931
15859	20101	2	applied	\N	\N	\N	\N	124244	124244	291932
15860	20103	1	applied	\N	\N	\N	\N	124246	124246	291934
15860	20104	2	applied	\N	\N	\N	\N	124247	124247	291935
15860	20105	3	applied	\N	\N	\N	\N	124248	124248	291936
15860	20106	4	applied	\N	\N	\N	\N	124249	124249	291937
15860	20107	5	applied	\N	\N	\N	\N	124250	124250	291938
15860	20108	6	applied	\N	\N	\N	\N	124251	124251	291939
15862	19733	0	applied	\N	\N	1000000000	\N	124259	124259	291947
15862	20086	1	applied	\N	\N	1000000000	\N	124260	124260	291948
15862	19817	2	applied	\N	\N	\N	\N	124261	124261	291949
15862	19934	3	applied	\N	\N	\N	\N	124262	124262	291950
15862	19750	4	applied	\N	\N	\N	\N	124263	124263	291951
15862	19946	5	applied	\N	\N	\N	\N	124264	124264	291952
15862	19956	6	applied	\N	\N	\N	\N	124265	124265	291953
15862	20007	7	applied	\N	\N	\N	\N	124266	124266	291954
15862	20008	8	applied	\N	\N	\N	\N	124267	124267	291955
15862	19957	9	applied	\N	\N	\N	\N	124268	124268	291956
15862	20010	11	applied	\N	\N	\N	\N	124270	124270	291958
15862	20011	12	applied	\N	\N	\N	\N	124271	124271	291959
15862	20012	13	applied	\N	\N	\N	\N	124272	124272	291960
15862	19962	14	applied	\N	\N	\N	\N	124273	124273	291961
15862	19973	15	applied	\N	\N	\N	\N	124274	124274	291962
15862	19974	16	applied	\N	\N	\N	\N	124275	124275	291963
15862	19975	17	applied	\N	\N	\N	\N	124276	124276	291964
15862	19976	18	applied	\N	\N	\N	\N	124277	124277	291965
15862	19977	19	applied	\N	\N	\N	\N	124278	124278	291966
15862	19978	20	applied	\N	\N	\N	\N	124279	124279	291967
15862	19979	21	applied	\N	\N	\N	\N	124280	124280	291968
15862	19980	22	applied	\N	\N	\N	\N	124281	124281	291969
15862	19981	23	applied	\N	\N	\N	\N	124282	124282	291970
15862	19989	24	applied	\N	\N	\N	\N	124283	124283	291971
15862	19990	25	applied	\N	\N	\N	\N	124284	124284	291972
15862	19997	26	applied	\N	\N	\N	\N	124285	124285	291973
15862	19999	28	applied	\N	\N	\N	\N	124287	124287	291975
15862	20015	29	applied	\N	\N	\N	\N	124288	124288	291976
15862	20016	30	applied	\N	\N	\N	\N	124289	124289	291977
15862	20017	31	applied	\N	\N	\N	\N	124290	124290	291978
15864	20112	0	applied	\N	\N	\N	\N	124304	124304	291992
15864	20113	1	applied	\N	\N	\N	\N	124305	124305	291993
15864	20114	2	applied	\N	\N	\N	\N	124306	124306	291994
15864	20115	3	applied	\N	\N	\N	\N	124307	124307	291995
15871	20125	0	applied	\N	\N	\N	\N	124329	124329	292017
15871	20126	1	applied	\N	\N	\N	\N	124330	124330	292018
15871	20127	2	applied	\N	\N	\N	\N	124331	124331	292019
15871	20128	3	applied	\N	\N	\N	\N	124332	124332	292020
15878	20134	0	applied	\N	\N	\N	\N	124352	124352	292040
15880	20140	0	applied	\N	\N	\N	\N	124354	124354	292042
15886	20134	0	applied	\N	\N	\N	\N	124365	124365	292053
15889	20149	0	applied	\N	\N	\N	\N	124378	124378	292066
15889	20151	2	applied	\N	\N	\N	\N	124380	124380	292068
15889	20152	3	applied	\N	\N	\N	\N	124381	124381	292069
15833	20037	1	applied	\N	\N	\N	\N	124100	124100	291788
15833	20038	2	applied	\N	\N	\N	\N	124101	124101	291789
15865	20115	3	applied	\N	\N	\N	\N	124311	124311	291999
15867	20116	0	applied	\N	\N	\N	\N	124316	124316	292004
15867	20117	1	applied	\N	\N	\N	\N	124317	124317	292005
15867	20118	2	applied	\N	\N	\N	\N	124318	124318	292006
15870	20125	0	applied	\N	\N	\N	\N	124325	124325	292013
15870	20126	1	applied	\N	\N	\N	\N	124326	124326	292014
15870	20127	2	applied	\N	\N	\N	\N	124327	124327	292015
15870	20128	3	applied	\N	\N	\N	\N	124328	124328	292016
15872	20129	0	applied	\N	\N	\N	\N	124333	124333	292021
15872	20130	1	applied	\N	\N	\N	\N	124334	124334	292022
15872	20131	2	applied	\N	\N	\N	\N	124335	124335	292023
15879	20134	0	applied	\N	\N	\N	\N	124353	124353	292041
15885	20140	0	applied	\N	\N	\N	\N	124361	124361	292049
15885	20143	1	applied	\N	\N	\N	\N	124362	124362	292050
15885	20141	2	applied	\N	\N	\N	\N	124363	124363	292051
15885	20142	3	applied	\N	\N	\N	\N	124364	124364	292052
15888	20144	1	applied	\N	\N	\N	\N	124373	124373	292061
15888	20145	2	applied	\N	\N	\N	\N	124374	124374	292062
15888	20146	3	applied	\N	\N	\N	\N	124375	124375	292063
15888	20147	4	applied	\N	\N	\N	\N	124376	124376	292064
15888	20148	5	applied	\N	\N	\N	\N	124377	124377	292065
15889	20153	4	applied	\N	\N	\N	\N	124382	124382	292070
15889	20154	5	applied	\N	\N	\N	\N	124383	124383	292071
15889	20155	6	applied	\N	\N	\N	\N	124384	124384	292072
15889	20156	7	applied	\N	\N	\N	\N	124385	124385	292073
15889	20157	8	applied	\N	\N	\N	\N	124386	124386	292074
15891	20158	0	applied	\N	\N	\N	\N	124391	124391	292079
15891	20159	1	applied	\N	\N	\N	\N	124392	124392	292080
15891	20160	2	applied	\N	\N	\N	\N	124393	124393	292081
15891	20161	3	applied	\N	\N	\N	\N	124394	124394	292082
15894	20165	0	applied	\N	\N	\N	\N	124402	124402	292090
15894	20166	1	applied	\N	\N	\N	\N	124403	124403	292091
15896	20177	0	applied	\N	\N	\N	\N	124414	124414	292102
15896	20178	1	applied	\N	\N	\N	\N	124415	124415	292103
15896	20179	2	applied	\N	\N	\N	\N	124416	124416	292104
15898	20177	0	applied	\N	\N	\N	\N	124420	124420	292108
15898	20178	1	applied	\N	\N	\N	\N	124421	124421	292109
15898	20179	2	applied	\N	\N	\N	\N	124422	124422	292110
15899	20180	0	applied	\N	\N	\N	\N	124423	124423	292111
15899	20181	1	applied	\N	\N	\N	\N	124424	124424	292112
15899	20182	2	applied	\N	\N	\N	\N	124425	124425	292113
15901	20186	0	applied	\N	\N	\N	\N	124429	124429	292117
15901	20187	1	applied	\N	\N	\N	\N	124430	124430	292118
15901	20188	2	applied	\N	\N	\N	\N	124431	124431	292119
15901	20189	3	applied	\N	\N	\N	\N	124432	124432	292120
15901	20190	4	applied	\N	\N	\N	\N	124433	124433	292121
15901	20191	5	applied	\N	\N	\N	\N	124434	124434	292122
15902	20186	0	applied	\N	\N	\N	\N	124435	124435	292123
15902	20188	2	applied	\N	\N	\N	\N	124437	124437	292125
15902	20189	3	applied	\N	\N	\N	\N	124438	124438	292126
15902	20190	4	applied	\N	\N	\N	\N	124439	124439	292127
15902	20191	5	applied	\N	\N	\N	\N	124440	124440	292128
15903	20186	0	applied	\N	\N	\N	\N	124441	124441	292129
15903	20187	1	applied	\N	\N	\N	\N	124442	124442	292130
15903	20188	2	applied	\N	\N	\N	\N	124443	124443	292131
15903	20189	3	applied	\N	\N	\N	\N	124444	124444	292132
15903	20190	4	applied	\N	\N	\N	\N	124445	124445	292133
15903	20191	5	applied	\N	\N	\N	\N	124446	124446	292134
15905	20192	0	applied	\N	\N	\N	\N	124453	124453	292141
15905	20193	1	applied	\N	\N	\N	\N	124454	124454	292142
15905	20194	2	applied	\N	\N	\N	\N	124455	124455	292143
15905	20195	3	applied	\N	\N	\N	\N	124456	124456	292144
15905	20196	4	applied	\N	\N	\N	\N	124457	124457	292145
15905	20197	5	applied	\N	\N	\N	\N	124458	124458	292146
15909	20199	1	applied	\N	\N	\N	\N	124474	124474	292162
15910	20200	0	applied	\N	\N	\N	\N	124475	124475	292163
15910	20201	1	applied	\N	\N	\N	\N	124476	124476	292164
15910	20202	2	applied	\N	\N	\N	\N	124477	124477	292165
15912	20203	0	applied	\N	\N	\N	\N	124481	124481	292169
15912	20204	1	applied	\N	\N	\N	\N	124482	124482	292170
15912	20205	2	applied	\N	\N	\N	\N	124483	124483	292171
15914	20209	0	applied	\N	\N	\N	\N	124487	124487	292175
15914	20210	1	applied	\N	\N	\N	\N	124488	124488	292176
15914	20211	2	applied	\N	\N	\N	\N	124489	124489	292177
15914	20212	3	applied	\N	\N	\N	\N	124490	124490	292178
15914	20213	4	applied	\N	\N	\N	\N	124491	124491	292179
15914	20214	5	applied	\N	\N	\N	\N	124492	124492	292180
15917	20215	0	applied	\N	\N	\N	\N	124504	124504	292192
15917	20216	1	applied	\N	\N	\N	\N	124505	124505	292193
15917	20217	2	applied	\N	\N	\N	\N	124506	124506	292194
15917	20218	4	applied	\N	\N	\N	\N	124508	124508	292196
15917	20219	5	applied	\N	\N	\N	\N	124509	124509	292197
15921	20224	0	applied	\N	\N	\N	\N	124525	124525	292213
15921	20225	1	applied	\N	\N	\N	\N	124526	124526	292214
15921	20226	2	applied	\N	\N	\N	\N	124527	124527	292215
15926	20233	0	applied	\N	\N	\N	\N	124546	124546	292234
15926	20234	1	applied	\N	\N	\N	\N	124547	124547	292235
15926	20235	2	applied	\N	\N	\N	\N	124548	124548	292236
15929	20236	0	applied	\N	\N	\N	\N	124554	124554	292242
15929	20237	1	applied	\N	\N	\N	\N	124555	124555	292243
15932	20247	0	applied	\N	\N	\N	\N	124574	124574	292262
15932	20248	1	applied	\N	\N	\N	\N	124575	124575	292263
15932	20249	2	applied	\N	\N	\N	\N	124576	124576	292264
15936	20250	0	applied	\N	\N	\N	\N	124586	124586	292274
15936	20251	1	applied	\N	\N	\N	\N	124587	124587	292275
15936	20252	2	applied	\N	\N	\N	\N	124588	124588	292276
15941	20257	1	applied	\N	\N	\N	\N	124602	124602	292290
15941	20258	2	applied	\N	\N	\N	\N	124603	124603	292291
15944	20271	0	applied	\N	\N	\N	\N	124616	124616	292304
15944	20272	1	applied	\N	\N	\N	\N	124617	124617	292305
15944	20273	2	applied	\N	\N	\N	\N	124618	124618	292306
15946	20274	0	applied	\N	\N	\N	\N	124622	124622	292310
15946	20275	1	applied	\N	\N	\N	\N	124623	124623	292311
15946	20276	2	applied	\N	\N	\N	\N	124624	124624	292312
15951	20283	0	applied	\N	\N	\N	\N	124640	124640	292328
15951	20284	1	applied	\N	\N	\N	\N	124641	124641	292329
15951	20285	2	applied	\N	\N	\N	\N	124642	124642	292330
15959	20295	0	applied	\N	\N	\N	\N	124664	124664	292352
15959	20296	1	applied	\N	\N	\N	\N	124665	124665	292353
15959	20297	2	applied	\N	\N	\N	\N	124666	124666	292354
15865	20112	0	applied	\N	\N	\N	\N	124308	124308	291996
15865	20113	1	applied	\N	\N	\N	\N	124309	124309	291997
15862	20031	36	applied	\N	\N	\N	\N	124295	124295	291983
15862	20033	37	applied	\N	\N	\N	\N	124296	124296	291984
15862	20037	38	applied	\N	\N	\N	\N	124297	124297	291985
15862	20038	39	applied	\N	\N	\N	\N	124298	124298	291986
15862	20039	40	applied	\N	\N	\N	\N	124299	124299	291987
15862	20044	41	applied	\N	\N	\N	\N	124300	124300	291988
15869	20122	0	applied	\N	\N	\N	\N	124322	124322	292010
15869	20123	1	applied	\N	\N	\N	\N	124323	124323	292011
15869	20124	2	applied	\N	\N	\N	\N	124324	124324	292012
15874	20132	0	applied	\N	\N	\N	\N	124340	124340	292028
15874	20133	1	applied	\N	\N	\N	\N	124341	124341	292029
15874	20134	2	applied	\N	\N	\N	\N	124342	124342	292030
15874	20135	3	applied	\N	\N	\N	\N	124343	124343	292031
15876	20136	0	applied	\N	\N	\N	\N	124348	124348	292036
15876	20137	1	applied	\N	\N	\N	\N	124349	124349	292037
15876	20138	2	applied	\N	\N	\N	\N	124350	124350	292038
15881	20140	0	applied	\N	\N	\N	\N	124355	124355	292043
15881	20141	1	applied	\N	\N	\N	\N	124356	124356	292044
15881	20142	2	applied	\N	\N	\N	\N	124357	124357	292045
15887	20143	0	applied	\N	\N	\N	\N	124366	124366	292054
15887	20144	1	applied	\N	\N	\N	\N	124367	124367	292055
15887	20145	2	applied	\N	\N	\N	\N	124368	124368	292056
15887	20146	3	applied	\N	\N	\N	\N	124369	124369	292057
15887	20147	4	applied	\N	\N	\N	\N	124370	124370	292058
15887	20148	5	applied	\N	\N	\N	\N	124371	124371	292059
15890	20158	0	applied	\N	\N	\N	\N	124387	124387	292075
15890	20159	1	applied	\N	\N	\N	\N	124388	124388	292076
15890	20160	2	applied	\N	\N	\N	\N	124389	124389	292077
15890	20161	3	applied	\N	\N	\N	\N	124390	124390	292078
15895	20168	0	applied	\N	\N	\N	\N	124405	124405	292093
15895	20169	1	applied	\N	\N	\N	\N	124406	124406	292094
15895	20170	2	applied	\N	\N	\N	\N	124407	124407	292095
15895	20172	4	applied	\N	\N	\N	\N	124409	124409	292097
15895	20173	5	applied	\N	\N	\N	\N	124410	124410	292098
15895	20174	6	applied	\N	\N	\N	\N	124411	124411	292099
15895	20175	7	applied	\N	\N	\N	\N	124412	124412	292100
15895	20176	8	applied	\N	\N	\N	\N	124413	124413	292101
15900	20183	0	applied	\N	\N	\N	\N	124426	124426	292114
15900	20184	1	applied	\N	\N	\N	\N	124427	124427	292115
15900	20185	2	applied	\N	\N	\N	\N	124428	124428	292116
15906	20192	0	applied	\N	\N	\N	\N	124459	124459	292147
15906	20193	1	applied	\N	\N	\N	\N	124460	124460	292148
15906	20194	2	applied	\N	\N	\N	\N	124461	124461	292149
15906	20195	3	applied	\N	\N	\N	\N	124462	124462	292150
15906	20196	4	applied	\N	\N	\N	\N	124463	124463	292151
15906	20197	5	applied	\N	\N	\N	\N	124464	124464	292152
15915	20209	0	applied	\N	\N	\N	\N	124493	124493	292181
15915	20210	1	applied	\N	\N	\N	\N	124494	124494	292182
15915	20212	3	applied	\N	\N	\N	\N	124496	124496	292184
15915	20213	4	applied	\N	\N	\N	\N	124497	124497	292185
15915	20214	5	applied	\N	\N	\N	\N	124498	124498	292186
15918	20215	0	applied	\N	\N	\N	\N	124510	124510	292198
15918	20216	1	applied	\N	\N	\N	\N	124511	124511	292199
15918	20217	2	applied	\N	\N	\N	\N	124512	124512	292200
15918	20220	3	applied	\N	\N	\N	\N	124513	124513	292201
15918	20218	4	applied	\N	\N	\N	\N	124514	124514	292202
15918	20219	5	applied	\N	\N	\N	\N	124515	124515	292203
15922	20224	0	applied	\N	\N	\N	\N	124528	124528	292216
15922	20225	1	applied	\N	\N	\N	\N	124529	124529	292217
15922	20226	2	applied	\N	\N	\N	\N	124530	124530	292218
15924	20227	0	applied	\N	\N	\N	\N	124537	124537	292225
15924	20228	1	applied	\N	\N	\N	\N	124538	124538	292226
15924	20229	2	applied	\N	\N	\N	\N	124539	124539	292227
15924	20230	3	applied	\N	\N	\N	\N	124540	124540	292228
15924	20232	5	applied	\N	\N	\N	\N	124542	124542	292230
15927	20233	0	applied	\N	\N	\N	\N	124549	124549	292237
15961	20295	0	applied	\N	\N	\N	\N	124670	124670	292358
15961	20296	1	applied	\N	\N	\N	\N	124671	124671	292359
15961	20297	2	applied	\N	\N	\N	\N	124672	124672	292360
15963	20298	0	applied	\N	\N	\N	\N	124679	124679	292367
15963	20299	1	applied	\N	\N	\N	\N	124680	124680	292368
15963	20300	2	applied	\N	\N	\N	\N	124681	124681	292369
15963	20301	3	applied	\N	\N	\N	\N	124682	124682	292370
15963	20302	4	applied	\N	\N	\N	\N	124683	124683	292371
15963	20303	5	applied	\N	\N	\N	\N	124684	124684	292372
15967	20307	0	applied	\N	\N	\N	\N	124694	124694	292382
15967	20308	1	applied	\N	\N	\N	\N	124695	124695	292383
15967	20309	2	applied	\N	\N	\N	\N	124696	124696	292384
15967	20310	3	applied	\N	\N	\N	\N	124697	124697	292385
15967	20311	4	applied	\N	\N	\N	\N	124698	124698	292386
15974	20319	0	applied	\N	\N	\N	\N	124730	124730	292418
15974	20320	1	applied	\N	\N	\N	\N	124731	124731	292419
15974	20321	2	applied	\N	\N	\N	\N	124732	124732	292420
15977	20322	0	applied	\N	\N	\N	\N	124738	124738	292426
15977	20323	1	applied	\N	\N	\N	\N	124739	124739	292427
15977	20324	2	applied	\N	\N	\N	\N	124740	124740	292428
15977	20325	3	applied	\N	\N	\N	\N	124741	124741	292429
15977	20326	4	applied	\N	\N	\N	\N	124742	124742	292430
15977	20327	5	applied	\N	\N	\N	\N	124743	124743	292431
15977	20328	6	applied	\N	\N	\N	\N	124744	124744	292432
15977	20329	7	applied	\N	\N	\N	\N	124745	124745	292433
15977	20330	8	applied	\N	\N	\N	\N	124746	124746	292434
15977	20331	9	applied	\N	\N	\N	\N	124747	124747	292435
15977	20332	10	applied	\N	\N	\N	\N	124748	124748	292436
15977	20333	11	applied	\N	\N	\N	\N	124749	124749	292437
15977	20334	12	applied	\N	\N	\N	\N	124750	124750	292438
15977	20336	14	applied	\N	\N	\N	\N	124752	124752	292440
15977	20337	15	applied	\N	\N	\N	\N	124753	124753	292441
15982	20344	0	applied	\N	\N	\N	\N	124766	124766	292454
15982	20345	1	applied	\N	\N	\N	\N	124767	124767	292455
15982	20346	2	applied	\N	\N	\N	\N	124768	124768	292456
15982	20347	3	applied	\N	\N	\N	\N	124769	124769	292457
15982	20348	4	applied	\N	\N	\N	\N	124770	124770	292458
15982	20349	5	applied	\N	\N	\N	\N	124771	124771	292459
15985	20353	0	applied	\N	\N	\N	\N	124778	124778	292466
15985	20354	1	applied	\N	\N	\N	\N	124779	124779	292467
15985	20355	2	applied	\N	\N	\N	\N	124780	124780	292468
15987	20356	0	applied	\N	\N	\N	\N	124784	124784	292472
15987	20357	1	applied	\N	\N	\N	\N	124785	124785	292473
15987	20358	2	applied	\N	\N	\N	\N	124786	124786	292474
15862	20026	33	applied	\N	\N	\N	\N	124292	124292	291980
15862	20027	34	applied	\N	\N	\N	\N	124293	124293	291981
15883	20140	0	applied	\N	\N	\N	\N	124358	124358	292046
15883	20141	1	applied	\N	\N	\N	\N	124359	124359	292047
15883	20142	2	applied	\N	\N	\N	\N	124360	124360	292048
15892	20158	0	applied	\N	\N	\N	\N	124395	124395	292083
15892	20159	1	applied	\N	\N	\N	\N	124396	124396	292084
15892	20160	2	applied	\N	\N	\N	\N	124397	124397	292085
15892	20161	3	applied	\N	\N	\N	\N	124398	124398	292086
15893	20162	0	applied	\N	\N	\N	\N	124399	124399	292087
15893	20163	1	applied	\N	\N	\N	\N	124400	124400	292088
15893	20164	2	applied	\N	\N	\N	\N	124401	124401	292089
15897	20177	0	applied	\N	\N	\N	\N	124417	124417	292105
15897	20178	1	applied	\N	\N	\N	\N	124418	124418	292106
15897	20179	2	applied	\N	\N	\N	\N	124419	124419	292107
15904	20192	0	applied	\N	\N	\N	\N	124447	124447	292135
15904	20194	2	applied	\N	\N	\N	\N	124449	124449	292137
15904	20195	3	applied	\N	\N	\N	\N	124450	124450	292138
15904	20196	4	applied	\N	\N	\N	\N	124451	124451	292139
15904	20197	5	applied	\N	\N	\N	\N	124452	124452	292140
15907	20192	0	applied	\N	\N	\N	\N	124465	124465	292153
15907	20193	1	applied	\N	\N	\N	\N	124466	124466	292154
15907	20194	2	applied	\N	\N	\N	\N	124467	124467	292155
15907	20195	3	applied	\N	\N	\N	\N	124468	124468	292156
15907	20196	4	applied	\N	\N	\N	\N	124469	124469	292157
15907	20197	5	applied	\N	\N	\N	\N	124470	124470	292158
15908	20198	0	applied	\N	\N	\N	\N	124471	124471	292159
15908	20199	1	applied	\N	\N	\N	\N	124472	124472	292160
15911	20200	0	applied	\N	\N	\N	\N	124478	124478	292166
15911	20201	1	applied	\N	\N	\N	\N	124479	124479	292167
15911	20202	2	applied	\N	\N	\N	\N	124480	124480	292168
15913	20206	0	applied	\N	\N	\N	\N	124484	124484	292172
15913	20208	2	applied	\N	\N	\N	\N	124486	124486	292174
15916	20215	0	applied	\N	\N	\N	\N	124499	124499	292187
15916	20216	1	applied	\N	\N	\N	\N	124500	124500	292188
15916	20217	2	applied	\N	\N	\N	\N	124501	124501	292189
15916	20218	3	applied	\N	\N	\N	\N	124502	124502	292190
15916	20219	4	applied	\N	\N	\N	\N	124503	124503	292191
15919	20215	0	applied	\N	\N	\N	\N	124516	124516	292204
15919	20216	1	applied	\N	\N	\N	\N	124517	124517	292205
15919	20217	2	applied	\N	\N	\N	\N	124518	124518	292206
15919	20220	3	applied	\N	\N	\N	\N	124519	124519	292207
15919	20218	4	applied	\N	\N	\N	\N	124520	124520	292208
15919	20219	5	applied	\N	\N	\N	\N	124521	124521	292209
15920	20221	0	applied	\N	\N	\N	\N	124522	124522	292210
15920	20222	1	applied	\N	\N	\N	\N	124523	124523	292211
15920	20223	2	applied	\N	\N	\N	\N	124524	124524	292212
15923	20227	0	applied	\N	\N	\N	\N	124531	124531	292219
15923	20229	2	applied	\N	\N	\N	\N	124533	124533	292221
15923	20230	3	applied	\N	\N	\N	\N	124534	124534	292222
15923	20231	4	applied	\N	\N	\N	\N	124535	124535	292223
15923	20232	5	applied	\N	\N	\N	\N	124536	124536	292224
15925	20233	0	applied	\N	\N	\N	\N	124543	124543	292231
15925	20234	1	applied	\N	\N	\N	\N	124544	124544	292232
15925	20235	2	applied	\N	\N	\N	\N	124545	124545	292233
15927	20234	1	applied	\N	\N	\N	\N	124550	124550	292238
15927	20235	2	applied	\N	\N	\N	\N	124551	124551	292239
15930	20238	0	applied	\N	\N	\N	\N	124556	124556	292244
15930	20239	1	applied	\N	\N	\N	\N	124557	124557	292245
15930	20240	2	applied	\N	\N	\N	\N	124558	124558	292246
15930	20241	3	applied	\N	\N	\N	\N	124559	124559	292247
15930	20242	4	applied	\N	\N	\N	\N	124560	124560	292248
15930	20243	5	applied	\N	\N	\N	\N	124561	124561	292249
15930	20244	6	applied	\N	\N	\N	\N	124562	124562	292250
15930	20246	8	applied	\N	\N	\N	\N	124564	124564	292252
15933	20247	0	applied	\N	\N	\N	\N	124577	124577	292265
15933	20248	1	applied	\N	\N	\N	\N	124578	124578	292266
15933	20249	2	applied	\N	\N	\N	\N	124579	124579	292267
15937	20253	0	applied	\N	\N	\N	\N	124589	124589	292277
15937	20254	1	applied	\N	\N	\N	\N	124590	124590	292278
15940	20256	0	applied	\N	\N	\N	\N	124598	124598	292286
15940	20257	1	applied	\N	\N	\N	\N	124599	124599	292287
15940	20258	2	applied	\N	\N	\N	\N	124600	124600	292288
15943	20265	0	applied	\N	\N	\N	\N	124610	124610	292298
15943	20266	1	applied	\N	\N	\N	\N	124611	124611	292299
15943	20267	2	applied	\N	\N	\N	\N	124612	124612	292300
15943	20268	3	applied	\N	\N	\N	\N	124613	124613	292301
15943	20269	4	applied	\N	\N	\N	\N	124614	124614	292302
15943	20270	5	applied	\N	\N	\N	\N	124615	124615	292303
15953	20289	0	applied	\N	\N	\N	\N	124646	124646	292334
15953	20291	2	applied	\N	\N	\N	\N	124648	124648	292336
15955	20292	0	applied	\N	\N	\N	\N	124652	124652	292340
15955	20293	1	applied	\N	\N	\N	\N	124653	124653	292341
15955	20294	2	applied	\N	\N	\N	\N	124654	124654	292342
15958	20295	0	applied	\N	\N	\N	\N	124661	124661	292349
15958	20296	1	applied	\N	\N	\N	\N	124662	124662	292350
15958	20297	2	applied	\N	\N	\N	\N	124663	124663	292351
15962	20298	0	applied	\N	\N	\N	\N	124673	124673	292361
15962	20299	1	applied	\N	\N	\N	\N	124674	124674	292362
15962	20300	2	applied	\N	\N	\N	\N	124675	124675	292363
15962	20301	3	applied	\N	\N	\N	\N	124676	124676	292364
15962	20302	4	applied	\N	\N	\N	\N	124677	124677	292365
15962	20303	5	applied	\N	\N	\N	\N	124678	124678	292366
15964	20298	0	applied	\N	\N	\N	\N	124685	124685	292373
15964	20299	1	applied	\N	\N	\N	\N	124686	124686	292374
15964	20300	2	applied	\N	\N	\N	\N	124687	124687	292375
15964	20302	4	applied	\N	\N	\N	\N	124689	124689	292377
15964	20303	5	applied	\N	\N	\N	\N	124690	124690	292378
15970	20307	0	applied	\N	\N	\N	\N	124712	124712	292400
15970	20308	1	applied	\N	\N	\N	\N	124713	124713	292401
15970	20309	2	applied	\N	\N	\N	\N	124714	124714	292402
15970	20310	3	applied	\N	\N	\N	\N	124715	124715	292403
15970	20311	4	applied	\N	\N	\N	\N	124716	124716	292404
15970	20312	5	applied	\N	\N	\N	\N	124717	124717	292405
15973	20316	0	applied	\N	\N	\N	\N	124727	124727	292415
15973	20317	1	applied	\N	\N	\N	\N	124728	124728	292416
15973	20318	2	applied	\N	\N	\N	\N	124729	124729	292417
15976	20086	0	applied	\N	\N	1000000000	\N	124736	124736	292424
15976	20134	1	applied	\N	\N	\N	\N	124737	124737	292425
15980	20338	0	applied	\N	\N	\N	\N	124760	124760	292448
15980	20339	1	applied	\N	\N	\N	\N	124761	124761	292449
15980	20340	2	applied	\N	\N	\N	\N	124762	124762	292450
15875	20139	3	applied	\N	\N	\N	\N	124347	124347	292035
15931	20240	2	applied	\N	\N	\N	\N	124567	124567	292255
15931	20241	3	applied	\N	\N	\N	\N	124568	124568	292256
15931	20242	4	applied	\N	\N	\N	\N	124569	124569	292257
15931	20243	5	applied	\N	\N	\N	\N	124570	124570	292258
15931	20244	6	applied	\N	\N	\N	\N	124571	124571	292259
15931	20245	7	applied	\N	\N	\N	\N	124572	124572	292260
15931	20246	8	applied	\N	\N	\N	\N	124573	124573	292261
15934	20247	0	applied	\N	\N	\N	\N	124580	124580	292268
15934	20248	1	applied	\N	\N	\N	\N	124581	124581	292269
15934	20249	2	applied	\N	\N	\N	\N	124582	124582	292270
15935	20250	0	applied	\N	\N	\N	\N	124583	124583	292271
15935	20251	1	applied	\N	\N	\N	\N	124584	124584	292272
15935	20252	2	applied	\N	\N	\N	\N	124585	124585	292273
15937	20255	2	applied	\N	\N	\N	\N	124591	124591	292279
15938	20254	1	applied	\N	\N	\N	\N	124593	124593	292281
15938	20255	2	applied	\N	\N	\N	\N	124594	124594	292282
15939	20256	0	applied	\N	\N	\N	\N	124595	124595	292283
15939	20257	1	applied	\N	\N	\N	\N	124596	124596	292284
15939	20258	2	applied	\N	\N	\N	\N	124597	124597	292285
15942	20259	0	applied	\N	\N	\N	\N	124604	124604	292292
15942	20260	1	applied	\N	\N	\N	\N	124605	124605	292293
15942	20261	2	applied	\N	\N	\N	\N	124606	124606	292294
15942	20262	3	applied	\N	\N	\N	\N	124607	124607	292295
15942	20263	4	applied	\N	\N	\N	\N	124608	124608	292296
15942	20264	5	applied	\N	\N	\N	\N	124609	124609	292297
15945	20271	0	applied	\N	\N	\N	\N	124619	124619	292307
15945	20272	1	applied	\N	\N	\N	\N	124620	124620	292308
15945	20273	2	applied	\N	\N	\N	\N	124621	124621	292309
15947	20274	0	applied	\N	\N	\N	\N	124625	124625	292313
15947	20275	1	applied	\N	\N	\N	\N	124626	124626	292314
15949	20277	0	applied	\N	\N	\N	\N	124628	124628	292316
15949	20278	1	applied	\N	\N	\N	\N	124629	124629	292317
15949	20279	2	applied	\N	\N	\N	\N	124630	124630	292318
15949	20280	3	applied	\N	\N	\N	\N	124631	124631	292319
15949	20281	4	applied	\N	\N	\N	\N	124632	124632	292320
15949	20282	5	applied	\N	\N	\N	\N	124633	124633	292321
15950	20277	0	applied	\N	\N	\N	\N	124634	124634	292322
15950	20278	1	applied	\N	\N	\N	\N	124635	124635	292323
15950	20279	2	applied	\N	\N	\N	\N	124636	124636	292324
15950	20280	3	applied	\N	\N	\N	\N	124637	124637	292325
15950	20281	4	applied	\N	\N	\N	\N	124638	124638	292326
15950	20282	5	applied	\N	\N	\N	\N	124639	124639	292327
15952	20286	0	applied	\N	\N	\N	\N	124643	124643	292331
15952	20287	1	applied	\N	\N	\N	\N	124644	124644	292332
15952	20288	2	applied	\N	\N	\N	\N	124645	124645	292333
15954	20292	0	applied	\N	\N	\N	\N	124649	124649	292337
15954	20294	2	applied	\N	\N	\N	\N	124651	124651	292339
15956	20292	0	applied	\N	\N	\N	\N	124655	124655	292343
15956	20293	1	applied	\N	\N	\N	\N	124656	124656	292344
15956	20294	2	applied	\N	\N	\N	\N	124657	124657	292345
15957	20295	0	applied	\N	\N	\N	\N	124658	124658	292346
15957	20296	1	applied	\N	\N	\N	\N	124659	124659	292347
15957	20297	2	applied	\N	\N	\N	\N	124660	124660	292348
15960	20295	0	applied	\N	\N	\N	\N	124667	124667	292355
15960	20296	1	applied	\N	\N	\N	\N	124668	124668	292356
15960	20297	2	applied	\N	\N	\N	\N	124669	124669	292357
15965	20304	0	applied	\N	\N	\N	\N	124691	124691	292379
15965	20305	1	applied	\N	\N	\N	\N	124692	124692	292380
15965	20306	2	applied	\N	\N	\N	\N	124693	124693	292381
15968	20307	0	applied	\N	\N	\N	\N	124700	124700	292388
15968	20308	1	applied	\N	\N	\N	\N	124701	124701	292389
15968	20309	2	applied	\N	\N	\N	\N	124702	124702	292390
15968	20311	4	applied	\N	\N	\N	\N	124704	124704	292392
15968	20312	5	applied	\N	\N	\N	\N	124705	124705	292393
15969	20307	0	applied	\N	\N	\N	\N	124706	124706	292394
15969	20308	1	applied	\N	\N	\N	\N	124707	124707	292395
15969	20309	2	applied	\N	\N	\N	\N	124708	124708	292396
15969	20310	3	applied	\N	\N	\N	\N	124709	124709	292397
15969	20311	4	applied	\N	\N	\N	\N	124710	124710	292398
15969	20312	5	applied	\N	\N	\N	\N	124711	124711	292399
15971	20307	0	applied	\N	\N	\N	\N	124718	124718	292406
15971	20308	1	applied	\N	\N	\N	\N	124719	124719	292407
15971	20309	2	applied	\N	\N	\N	\N	124720	124720	292408
15971	20310	3	applied	\N	\N	\N	\N	124721	124721	292409
15971	20311	4	applied	\N	\N	\N	\N	124722	124722	292410
15971	20312	5	applied	\N	\N	\N	\N	124723	124723	292411
15972	20313	0	applied	\N	\N	\N	\N	124724	124724	292412
15972	20314	1	applied	\N	\N	\N	\N	124725	124725	292413
15975	20319	0	applied	\N	\N	\N	\N	124733	124733	292421
15975	20320	1	applied	\N	\N	\N	\N	124734	124734	292422
15975	20321	2	applied	\N	\N	\N	\N	124735	124735	292423
15978	20338	0	applied	\N	\N	\N	\N	124754	124754	292442
15978	20339	1	applied	\N	\N	\N	\N	124755	124755	292443
15978	20340	2	applied	\N	\N	\N	\N	124756	124756	292444
15979	20338	0	applied	\N	\N	\N	\N	124757	124757	292445
15979	20339	1	applied	\N	\N	\N	\N	124758	124758	292446
15979	20340	2	applied	\N	\N	\N	\N	124759	124759	292447
15983	20350	0	applied	\N	\N	\N	\N	124772	124772	292460
15983	20351	1	applied	\N	\N	\N	\N	124773	124773	292461
15983	20352	2	applied	\N	\N	\N	\N	124774	124774	292462
15986	20353	0	applied	\N	\N	\N	\N	124781	124781	292469
15986	20354	1	applied	\N	\N	\N	\N	124782	124782	292470
15986	20355	2	applied	\N	\N	\N	\N	124783	124783	292471
15988	20362	0	applied	\N	\N	\N	\N	124790	124790	292478
15988	20364	2	applied	\N	\N	\N	\N	124792	124792	292480
15989	20362	0	applied	\N	\N	\N	\N	124793	124793	292481
15989	20363	1	applied	\N	\N	\N	\N	124794	124794	292482
15989	20364	2	applied	\N	\N	\N	\N	124795	124795	292483
15993	20371	0	applied	\N	\N	\N	\N	124805	124805	292493
15993	20372	1	applied	\N	\N	\N	\N	124806	124806	292494
15993	20373	2	applied	\N	\N	\N	\N	124807	124807	292495
15999	20383	0	applied	\N	\N	\N	\N	124830	124830	292518
15999	20384	1	applied	\N	\N	\N	\N	124831	124831	292519
15999	20385	2	applied	\N	\N	\N	\N	124832	124832	292520
15999	20386	3	applied	\N	\N	1000000000	\N	124833	124833	292521
15999	20387	4	applied	\N	\N	\N	\N	124834	124834	292522
15999	20388	5	applied	\N	\N	\N	\N	124835	124835	292523
15999	20389	6	applied	\N	\N	\N	\N	124836	124836	292524
15999	20390	7	applied	\N	\N	\N	\N	124837	124837	292525
15999	20391	8	applied	\N	\N	\N	\N	124838	124838	292526
15931	20239	1	applied	\N	\N	\N	\N	124566	124566	292254
15984	20354	1	applied	\N	\N	\N	\N	124776	124776	292464
15984	20355	2	applied	\N	\N	\N	\N	124777	124777	292465
15991	20365	0	applied	\N	\N	\N	\N	124799	124799	292487
15991	20366	1	applied	\N	\N	\N	\N	124800	124800	292488
15991	20367	2	applied	\N	\N	\N	\N	124801	124801	292489
15994	20371	0	applied	\N	\N	\N	\N	124808	124808	292496
15994	20372	1	applied	\N	\N	\N	\N	124809	124809	292497
15994	20373	2	applied	\N	\N	\N	\N	124810	124810	292498
15996	20377	0	applied	\N	\N	\N	\N	124814	124814	292502
15996	20378	1	applied	\N	\N	\N	\N	124815	124815	292503
15996	20379	2	applied	\N	\N	\N	\N	124816	124816	292504
15999	20392	9	applied	\N	\N	\N	\N	124839	124839	292527
16000	20393	0	applied	\N	\N	\N	\N	124840	124840	292528
16000	20394	1	applied	\N	\N	\N	\N	124841	124841	292529
16000	20396	3	applied	\N	\N	\N	\N	124843	124843	292531
16000	20397	4	applied	\N	\N	\N	\N	124844	124844	292532
16000	20398	5	applied	\N	\N	\N	\N	124845	124845	292533
16000	20399	6	applied	\N	\N	\N	\N	124846	124846	292534
16000	20400	7	applied	\N	\N	\N	\N	124847	124847	292535
16000	20401	8	applied	\N	\N	\N	\N	124848	124848	292536
16002	20402	0	applied	\N	\N	\N	\N	124852	124852	292540
16002	20403	1	applied	\N	\N	\N	\N	124853	124853	292541
16002	20404	2	applied	\N	\N	\N	\N	124854	124854	292542
16005	20409	0	applied	\N	\N	\N	\N	124869	124869	292557
16005	20410	1	applied	\N	\N	\N	\N	124870	124870	292558
16005	20411	2	applied	\N	\N	\N	\N	124871	124871	292559
16005	20412	3	applied	\N	\N	\N	\N	124872	124872	292560
16005	20413	4	applied	\N	\N	\N	\N	124873	124873	292561
16005	20414	5	applied	\N	\N	\N	\N	124874	124874	292562
16005	20415	6	applied	\N	\N	\N	\N	124875	124875	292563
16005	20417	8	applied	\N	\N	\N	\N	124877	124877	292565
16005	20418	9	applied	\N	\N	\N	\N	124878	124878	292566
16009	20422	0	applied	\N	\N	\N	\N	124914	124914	292602
16009	20423	1	applied	\N	\N	\N	\N	124915	124915	292603
16009	20424	2	applied	\N	\N	\N	\N	124916	124916	292604
16009	20425	3	applied	\N	\N	\N	\N	124917	124917	292605
16009	20426	4	applied	\N	\N	\N	\N	124918	124918	292606
16009	20427	5	applied	\N	\N	\N	\N	124919	124919	292607
16009	20428	6	applied	\N	\N	\N	\N	124920	124920	292608
16009	20429	7	applied	\N	\N	\N	\N	124921	124921	292609
16009	20430	8	applied	\N	\N	\N	\N	124922	124922	292610
16009	20431	9	applied	\N	\N	\N	\N	124923	124923	292611
16009	20432	10	applied	\N	\N	\N	\N	124924	124924	292612
16009	20433	11	applied	\N	\N	\N	\N	124925	124925	292613
16009	20434	12	applied	\N	\N	\N	\N	124926	124926	292614
16009	20435	13	applied	\N	\N	\N	\N	124927	124927	292615
16009	20437	15	applied	\N	\N	\N	\N	124929	124929	292617
16011	20438	0	applied	\N	\N	\N	\N	124934	124934	292622
16011	20439	1	applied	\N	\N	\N	\N	124935	124935	292623
16011	20440	2	applied	\N	\N	\N	\N	124936	124936	292624
16011	20441	3	applied	\N	\N	\N	\N	124937	124937	292625
16012	20438	0	applied	\N	\N	\N	\N	124938	124938	292626
16012	20439	1	applied	\N	\N	\N	\N	124939	124939	292627
16012	20440	2	applied	\N	\N	\N	\N	124940	124940	292628
16012	20441	3	applied	\N	\N	\N	\N	124941	124941	292629
16015	20442	0	applied	\N	\N	\N	\N	124949	124949	292637
16015	20443	1	applied	\N	\N	\N	\N	124950	124950	292638
16015	20444	2	applied	\N	\N	\N	\N	124951	124951	292639
16017	20445	0	applied	\N	\N	\N	\N	124955	124955	292643
16017	20446	1	applied	\N	\N	\N	\N	124956	124956	292644
16017	20447	2	applied	\N	\N	\N	\N	124957	124957	292645
16018	20445	0	applied	\N	\N	\N	\N	124958	124958	292646
16018	20447	2	applied	\N	\N	\N	\N	124960	124960	292648
16022	20455	0	applied	\N	\N	\N	\N	124971	124971	292659
16022	20456	1	applied	\N	\N	\N	\N	124972	124972	292660
16022	20457	2	applied	\N	\N	\N	\N	124973	124973	292661
16027	20462	0	applied	\N	\N	\N	\N	124995	124995	292683
16027	20463	1	applied	\N	\N	\N	\N	124996	124996	292684
16027	20464	2	applied	\N	\N	\N	\N	124997	124997	292685
16027	20465	3	applied	\N	\N	\N	\N	124998	124998	292686
16027	20466	4	applied	\N	\N	\N	\N	124999	124999	292687
16027	20467	5	applied	\N	\N	\N	\N	125000	125000	292688
16027	20468	6	applied	\N	\N	\N	\N	125001	125001	292689
16027	20469	7	applied	\N	\N	\N	\N	125002	125002	292690
16027	20470	8	applied	\N	\N	\N	\N	125003	125003	292691
16047	20518	0	applied	\N	\N	\N	\N	125081	125081	292769
16047	20519	1	applied	\N	\N	\N	\N	125082	125082	292770
16047	20520	2	applied	\N	\N	\N	\N	125083	125083	292771
16052	20532	1	applied	\N	\N	\N	\N	125098	125098	292786
16052	20533	2	applied	\N	\N	\N	\N	125099	125099	292787
16052	20534	3	applied	\N	\N	\N	\N	125100	125100	292788
16052	20535	4	applied	\N	\N	\N	\N	125101	125101	292789
16052	20536	5	applied	\N	\N	\N	\N	125102	125102	292790
16054	20200	0	applied	\N	\N	\N	\N	125109	125109	292797
16054	20203	1	applied	\N	\N	\N	\N	125110	125110	292798
16054	20206	2	applied	\N	\N	\N	\N	125111	125111	292799
16054	20209	3	applied	\N	\N	\N	\N	125112	125112	292800
16054	20210	4	applied	\N	\N	\N	\N	125113	125113	292801
16054	20215	5	applied	\N	\N	\N	\N	125114	125114	292802
16054	20216	6	applied	\N	\N	\N	\N	125115	125115	292803
16054	20221	7	applied	\N	\N	\N	\N	125116	125116	292804
16054	20386	8	applied	\N	\N	1000000000	\N	125117	125117	292805
16054	20224	9	applied	\N	\N	\N	\N	125118	125118	292806
16054	20227	10	applied	\N	\N	\N	\N	125119	125119	292807
16054	20233	12	applied	\N	\N	\N	\N	125121	125121	292809
16054	20236	13	applied	\N	\N	\N	\N	125122	125122	292810
16054	20238	14	applied	\N	\N	\N	\N	125123	125123	292811
16054	20239	15	applied	\N	\N	\N	\N	125124	125124	292812
16054	20240	16	applied	\N	\N	\N	\N	125125	125125	292813
16054	20247	17	applied	\N	\N	\N	\N	125126	125126	292814
16054	20250	18	applied	\N	\N	\N	\N	125127	125127	292815
16054	20253	19	applied	\N	\N	\N	\N	125128	125128	292816
16054	20256	20	applied	\N	\N	\N	\N	125129	125129	292817
16054	20259	21	applied	\N	\N	\N	\N	125130	125130	292818
16054	20260	22	applied	\N	\N	\N	\N	125131	125131	292819
16054	20265	23	applied	\N	\N	\N	\N	125132	125132	292820
16054	20266	24	applied	\N	\N	\N	\N	125133	125133	292821
16054	20271	25	applied	\N	\N	\N	\N	125134	125134	292822
16054	20274	26	applied	\N	\N	\N	\N	125135	125135	292823
16054	20277	27	applied	\N	\N	\N	\N	125136	125136	292824
15984	20353	0	applied	\N	\N	\N	\N	124775	124775	292463
15992	20369	2	applied	\N	\N	\N	\N	124803	124803	292491
15992	20370	3	applied	\N	\N	\N	\N	124804	124804	292492
15997	20380	0	applied	\N	\N	\N	\N	124817	124817	292505
15997	20381	1	applied	\N	\N	\N	\N	124818	124818	292506
15997	20382	2	applied	\N	\N	\N	\N	124819	124819	292507
16003	20405	0	applied	\N	\N	\N	\N	124855	124855	292543
16003	20406	1	applied	\N	\N	\N	\N	124856	124856	292544
16003	20407	2	applied	\N	\N	\N	\N	124857	124857	292545
16003	20408	3	applied	\N	\N	\N	\N	124858	124858	292546
16006	20419	0	applied	\N	\N	\N	\N	124879	124879	292567
16006	20420	1	applied	\N	\N	\N	\N	124880	124880	292568
16006	20421	2	applied	\N	\N	\N	\N	124881	124881	292569
16007	20422	0	applied	\N	\N	\N	\N	124882	124882	292570
16007	20423	1	applied	\N	\N	\N	\N	124883	124883	292571
16007	20424	2	applied	\N	\N	\N	\N	124884	124884	292572
16007	20425	3	applied	\N	\N	\N	\N	124885	124885	292573
16007	20427	5	applied	\N	\N	\N	\N	124887	124887	292575
16007	20428	6	applied	\N	\N	\N	\N	124888	124888	292576
16007	20429	7	applied	\N	\N	\N	\N	124889	124889	292577
16007	20430	8	applied	\N	\N	\N	\N	124890	124890	292578
16007	20431	9	applied	\N	\N	\N	\N	124891	124891	292579
16007	20432	10	applied	\N	\N	\N	\N	124892	124892	292580
16007	20433	11	applied	\N	\N	\N	\N	124893	124893	292581
16007	20434	12	applied	\N	\N	\N	\N	124894	124894	292582
16007	20435	13	applied	\N	\N	\N	\N	124895	124895	292583
16007	20436	14	applied	\N	\N	\N	\N	124896	124896	292584
16007	20437	15	applied	\N	\N	\N	\N	124897	124897	292585
16020	20448	0	applied	\N	\N	\N	\N	124964	124964	292652
16020	20449	1	applied	\N	\N	\N	\N	124965	124965	292653
16020	20450	2	applied	\N	\N	\N	\N	124966	124966	292654
16020	20451	3	applied	\N	\N	\N	\N	124967	124967	292655
16023	20458	0	applied	\N	\N	\N	\N	124974	124974	292662
16023	20460	3	applied	\N	\N	\N	\N	124976	124976	292664
16023	20461	4	applied	\N	\N	\N	\N	124977	124977	292665
16025	20458	0	applied	\N	\N	\N	\N	124982	124982	292670
16025	20459	1	applied	\N	\N	\N	\N	124983	124983	292671
16025	20460	3	applied	\N	\N	\N	\N	124984	124984	292672
16025	20461	4	applied	\N	\N	\N	\N	124985	124985	292673
16028	20471	0	applied	\N	\N	\N	\N	125004	125004	292692
16028	20472	1	applied	\N	\N	\N	\N	125005	125005	292693
16028	20473	2	applied	\N	\N	\N	\N	125006	125006	292694
16028	20474	3	applied	\N	\N	\N	\N	125007	125007	292695
16030	20475	0	applied	\N	\N	\N	\N	125011	125011	292699
16030	20476	1	applied	\N	\N	\N	\N	125012	125012	292700
16030	20477	2	applied	\N	\N	\N	\N	125013	125013	292701
16033	20485	0	applied	\N	\N	\N	\N	125021	125021	292709
16033	20486	1	applied	\N	\N	\N	\N	125022	125022	292710
16033	20487	2	applied	\N	\N	\N	\N	125023	125023	292711
16036	20496	1	applied	\N	\N	\N	\N	125039	125039	292727
16036	20497	2	applied	\N	\N	\N	\N	125040	125040	292728
16036	20498	3	applied	\N	\N	\N	\N	125041	125041	292729
16038	20501	0	applied	\N	\N	\N	\N	125048	125048	292736
16038	20502	1	applied	\N	\N	\N	\N	125049	125049	292737
16038	20503	2	applied	\N	\N	\N	\N	125050	125050	292738
16041	20504	0	applied	\N	\N	\N	\N	125059	125059	292747
16041	20505	1	applied	\N	\N	\N	\N	125060	125060	292748
16041	20506	2	applied	\N	\N	\N	\N	125061	125061	292749
16041	20507	3	applied	\N	\N	\N	\N	125062	125062	292750
16045	20514	0	applied	\N	\N	\N	\N	125073	125073	292761
16045	20515	1	applied	\N	\N	\N	\N	125074	125074	292762
16045	20516	2	applied	\N	\N	\N	\N	125075	125075	292763
16045	20517	3	applied	\N	\N	\N	\N	125076	125076	292764
16050	20524	0	applied	\N	\N	\N	\N	125090	125090	292778
16050	20525	1	applied	\N	\N	\N	\N	125091	125091	292779
16050	20527	3	applied	\N	\N	\N	\N	125093	125093	292781
16053	20531	0	applied	\N	\N	\N	\N	125103	125103	292791
16054	20278	28	applied	\N	\N	\N	\N	125137	125137	292825
16054	20283	29	applied	\N	\N	\N	\N	125138	125138	292826
16054	20286	30	applied	\N	\N	\N	\N	125139	125139	292827
16054	20289	31	applied	\N	\N	\N	\N	125140	125140	292828
16054	20292	32	applied	\N	\N	\N	\N	125141	125141	292829
16054	20295	33	applied	\N	\N	\N	\N	125142	125142	292830
16054	20298	34	applied	\N	\N	\N	\N	125143	125143	292831
16054	20299	35	applied	\N	\N	\N	\N	125144	125144	292832
16054	20304	36	applied	\N	\N	\N	\N	125145	125145	292833
16054	20307	37	applied	\N	\N	\N	\N	125146	125146	292834
16054	20308	38	applied	\N	\N	\N	\N	125147	125147	292835
16054	20313	39	applied	\N	\N	\N	\N	125148	125148	292836
16054	20316	40	applied	\N	\N	\N	\N	125149	125149	292837
16054	20319	41	applied	\N	\N	\N	\N	125150	125150	292838
16054	20323	43	applied	\N	\N	\N	\N	125152	125152	292840
16054	20324	44	applied	\N	\N	\N	\N	125153	125153	292841
16054	20325	45	applied	\N	\N	\N	\N	125154	125154	292842
16054	20326	46	applied	\N	\N	\N	\N	125155	125155	292843
16054	20338	47	applied	\N	\N	\N	\N	125156	125156	292844
16054	20341	48	applied	\N	\N	\N	\N	125157	125157	292845
16054	20344	49	applied	\N	\N	\N	\N	125158	125158	292846
16054	20345	50	applied	\N	\N	\N	\N	125159	125159	292847
16054	20350	51	applied	\N	\N	\N	\N	125160	125160	292848
16054	20353	52	applied	\N	\N	\N	\N	125161	125161	292849
16054	20356	53	applied	\N	\N	\N	\N	125162	125162	292850
16054	20357	54	applied	\N	\N	\N	\N	125163	125163	292851
16054	20362	55	applied	\N	\N	\N	\N	125164	125164	292852
16054	20365	56	applied	\N	\N	\N	\N	125165	125165	292853
16054	20368	57	applied	\N	\N	\N	\N	125166	125166	292854
16054	20371	58	applied	\N	\N	\N	\N	125167	125167	292855
16054	20377	60	applied	\N	\N	\N	\N	125169	125169	292857
16054	20380	61	applied	\N	\N	\N	\N	125170	125170	292858
16054	20383	62	applied	\N	\N	\N	\N	125171	125171	292859
16054	20384	63	applied	\N	\N	\N	\N	125172	125172	292860
16054	20385	64	applied	\N	\N	\N	\N	125173	125173	292861
16054	20393	65	applied	\N	\N	\N	\N	125174	125174	292862
16054	20394	66	applied	\N	\N	\N	\N	125175	125175	292863
16054	20395	67	applied	\N	\N	\N	\N	125176	125176	292864
16054	20402	68	applied	\N	\N	\N	\N	125177	125177	292865
16054	20405	69	applied	\N	\N	\N	\N	125178	125178	292866
16054	20409	70	applied	\N	\N	\N	\N	125179	125179	292867
16054	20410	71	applied	\N	\N	\N	\N	125180	125180	292868
16054	20411	72	applied	\N	\N	\N	\N	125181	125181	292869
16054	20419	73	applied	\N	\N	\N	\N	125182	125182	292870
15987	20360	4	applied	\N	\N	\N	\N	124788	124788	292476
15987	20361	5	applied	\N	\N	\N	\N	124789	124789	292477
15995	20375	1	applied	\N	\N	\N	\N	124812	124812	292500
15995	20376	2	applied	\N	\N	\N	\N	124813	124813	292501
15998	20383	0	applied	\N	\N	\N	\N	124820	124820	292508
15998	20384	1	applied	\N	\N	\N	\N	124821	124821	292509
15998	20385	2	applied	\N	\N	\N	\N	124822	124822	292510
15998	20386	3	applied	\N	\N	1000000000	\N	124823	124823	292511
15998	20387	4	applied	\N	\N	\N	\N	124824	124824	292512
15998	20388	5	applied	\N	\N	\N	\N	124825	124825	292513
15998	20389	6	applied	\N	\N	\N	\N	124826	124826	292514
15998	20390	7	applied	\N	\N	\N	\N	124827	124827	292515
15998	20391	8	applied	\N	\N	\N	\N	124828	124828	292516
15998	20392	9	applied	\N	\N	\N	\N	124829	124829	292517
16001	20402	0	applied	\N	\N	\N	\N	124849	124849	292537
16001	20403	1	applied	\N	\N	\N	\N	124850	124850	292538
16004	20409	0	applied	\N	\N	\N	\N	124859	124859	292547
16004	20410	1	applied	\N	\N	\N	\N	124860	124860	292548
16004	20411	2	applied	\N	\N	\N	\N	124861	124861	292549
16004	20412	3	applied	\N	\N	\N	\N	124862	124862	292550
16004	20413	4	applied	\N	\N	\N	\N	124863	124863	292551
16004	20414	5	applied	\N	\N	\N	\N	124864	124864	292552
16004	20415	6	applied	\N	\N	\N	\N	124865	124865	292553
16004	20416	7	applied	\N	\N	\N	\N	124866	124866	292554
16004	20417	8	applied	\N	\N	\N	\N	124867	124867	292555
16004	20418	9	applied	\N	\N	\N	\N	124868	124868	292556
16008	20422	0	applied	\N	\N	\N	\N	124898	124898	292586
16008	20423	1	applied	\N	\N	\N	\N	124899	124899	292587
16008	20424	2	applied	\N	\N	\N	\N	124900	124900	292588
16008	20425	3	applied	\N	\N	\N	\N	124901	124901	292589
16008	20426	4	applied	\N	\N	\N	\N	124902	124902	292590
16008	20427	5	applied	\N	\N	\N	\N	124903	124903	292591
16008	20429	7	applied	\N	\N	\N	\N	124905	124905	292593
16008	20430	8	applied	\N	\N	\N	\N	124906	124906	292594
16008	20431	9	applied	\N	\N	\N	\N	124907	124907	292595
16008	20432	10	applied	\N	\N	\N	\N	124908	124908	292596
16008	20433	11	applied	\N	\N	\N	\N	124909	124909	292597
16008	20434	12	applied	\N	\N	\N	\N	124910	124910	292598
16008	20435	13	applied	\N	\N	\N	\N	124911	124911	292599
16008	20436	14	applied	\N	\N	\N	\N	124912	124912	292600
16008	20437	15	applied	\N	\N	\N	\N	124913	124913	292601
16010	20438	0	applied	\N	\N	\N	\N	124930	124930	292618
16010	20439	1	applied	\N	\N	\N	\N	124931	124931	292619
16010	20440	2	applied	\N	\N	\N	\N	124932	124932	292620
16010	20441	3	applied	\N	\N	\N	\N	124933	124933	292621
16013	20438	0	applied	\N	\N	\N	\N	124942	124942	292630
16013	20439	1	applied	\N	\N	\N	\N	124943	124943	292631
16013	20440	2	applied	\N	\N	\N	\N	124944	124944	292632
16014	20442	0	applied	\N	\N	\N	\N	124946	124946	292634
16014	20443	1	applied	\N	\N	\N	\N	124947	124947	292635
16014	20444	2	applied	\N	\N	\N	\N	124948	124948	292636
16016	20442	0	applied	\N	\N	\N	\N	124952	124952	292640
16016	20443	1	applied	\N	\N	\N	\N	124953	124953	292641
16016	20444	2	applied	\N	\N	\N	\N	124954	124954	292642
16019	20445	0	applied	\N	\N	\N	\N	124961	124961	292649
16019	20446	1	applied	\N	\N	\N	\N	124962	124962	292650
16019	20447	2	applied	\N	\N	\N	\N	124963	124963	292651
16021	20452	0	applied	\N	\N	\N	\N	124968	124968	292656
16021	20453	1	applied	\N	\N	\N	\N	124969	124969	292657
16021	20454	2	applied	\N	\N	\N	\N	124970	124970	292658
16024	20458	0	applied	\N	\N	\N	\N	124978	124978	292666
16024	20459	1	applied	\N	\N	\N	\N	124979	124979	292667
16024	20460	3	applied	\N	\N	\N	\N	124980	124980	292668
16024	20461	4	applied	\N	\N	\N	\N	124981	124981	292669
16026	20463	1	applied	\N	\N	\N	\N	124987	124987	292675
16026	20464	2	applied	\N	\N	\N	\N	124988	124988	292676
16026	20465	3	applied	\N	\N	\N	\N	124989	124989	292677
16026	20466	4	applied	\N	\N	\N	\N	124990	124990	292678
16053	20532	1	applied	\N	\N	\N	\N	125104	125104	292792
16053	20533	2	applied	\N	\N	\N	\N	125105	125105	292793
16053	20534	3	applied	\N	\N	\N	\N	125106	125106	292794
16053	20535	4	applied	\N	\N	\N	\N	125107	125107	292795
16053	20536	5	applied	\N	\N	\N	\N	125108	125108	292796
16055	20537	0	applied	\N	\N	\N	\N	125226	125226	292914
16055	20538	1	applied	\N	\N	\N	\N	125227	125227	292915
16055	20539	2	applied	\N	\N	\N	\N	125228	125228	292916
16055	20540	3	applied	\N	\N	\N	\N	125229	125229	292917
16058	20541	0	applied	\N	\N	\N	\N	125241	125241	292929
16058	20542	1	applied	\N	\N	\N	\N	125242	125242	292930
16058	20543	2	applied	\N	\N	\N	\N	125243	125243	292931
16058	20545	4	applied	\N	\N	\N	\N	125245	125245	292933
16058	20546	5	applied	\N	\N	\N	\N	125246	125246	292934
16058	20547	6	applied	\N	\N	\N	\N	125247	125247	292935
16060	20548	0	applied	\N	\N	\N	\N	125252	125252	292940
16060	20549	1	applied	\N	\N	\N	\N	125253	125253	292941
16060	20550	2	applied	\N	\N	\N	\N	125254	125254	292942
16060	20551	3	applied	\N	\N	\N	\N	125255	125255	292943
16064	20552	0	applied	\N	\N	\N	\N	125268	125268	292956
16064	20553	1	applied	\N	\N	\N	\N	125269	125269	292957
16064	20554	2	applied	\N	\N	\N	\N	125270	125270	292958
16064	20555	3	applied	\N	\N	\N	\N	125271	125271	292959
16069	20562	0	applied	\N	\N	\N	\N	125292	125292	292980
16069	20563	1	applied	\N	\N	\N	\N	125293	125293	292981
16069	20564	2	applied	\N	\N	\N	\N	125294	125294	292982
16069	20565	3	applied	\N	\N	\N	\N	125295	125295	292983
16069	20566	4	applied	\N	\N	\N	\N	125296	125296	292984
16069	20568	6	applied	\N	\N	\N	\N	125298	125298	292986
16072	20569	0	applied	\N	\N	\N	\N	125313	125313	293001
16072	20570	1	applied	\N	\N	\N	\N	125314	125314	293002
16072	20571	2	applied	\N	\N	\N	\N	125315	125315	293003
16072	20572	3	applied	\N	\N	\N	\N	125316	125316	293004
16072	20573	4	applied	\N	\N	\N	\N	125317	125317	293005
16072	20574	5	applied	\N	\N	\N	\N	125318	125318	293006
16072	20575	6	applied	\N	\N	\N	\N	125319	125319	293007
16075	20569	0	applied	\N	\N	\N	\N	125334	125334	293022
16075	20570	1	applied	\N	\N	\N	\N	125335	125335	293023
16075	20571	2	applied	\N	\N	\N	\N	125336	125336	293024
16075	20572	3	applied	\N	\N	\N	\N	125337	125337	293025
16075	20573	4	applied	\N	\N	\N	\N	125338	125338	293026
16075	20574	5	applied	\N	\N	\N	\N	125339	125339	293027
16075	20575	6	applied	\N	\N	\N	\N	125340	125340	293028
16082	20581	0	applied	\N	\N	\N	\N	125353	125353	293041
15995	20374	0	applied	\N	\N	\N	\N	124811	124811	292499
16029	20475	0	applied	\N	\N	\N	\N	125008	125008	292696
16029	20476	1	applied	\N	\N	\N	\N	125009	125009	292697
16029	20477	2	applied	\N	\N	\N	\N	125010	125010	292698
16031	20478	0	applied	\N	\N	\N	\N	125014	125014	292702
16031	20479	1	applied	\N	\N	\N	\N	125015	125015	292703
16031	20480	2	applied	\N	\N	\N	\N	125016	125016	292704
16031	20481	3	applied	\N	\N	\N	\N	125017	125017	292705
16031	20482	4	applied	\N	\N	\N	\N	125018	125018	292706
16031	20483	5	applied	\N	\N	\N	\N	125019	125019	292707
16031	20484	6	applied	\N	\N	\N	\N	125020	125020	292708
16034	20488	0	applied	\N	\N	\N	\N	125024	125024	292712
16034	20489	1	applied	\N	\N	\N	\N	125025	125025	292713
16034	20490	2	applied	\N	\N	\N	\N	125026	125026	292714
16034	20491	3	applied	\N	\N	\N	\N	125027	125027	292715
16034	20492	4	applied	\N	\N	\N	\N	125028	125028	292716
16034	20493	5	applied	\N	\N	\N	\N	125029	125029	292717
16035	20488	0	applied	\N	\N	\N	\N	125031	125031	292719
16035	20489	1	applied	\N	\N	\N	\N	125032	125032	292720
16035	20490	2	applied	\N	\N	\N	\N	125033	125033	292721
16035	20491	3	applied	\N	\N	\N	\N	125034	125034	292722
16035	20492	4	applied	\N	\N	\N	\N	125035	125035	292723
16035	20493	5	applied	\N	\N	\N	\N	125036	125036	292724
16035	20494	6	applied	\N	\N	\N	\N	125037	125037	292725
16037	20495	0	applied	\N	\N	\N	\N	125042	125042	292730
16037	20496	1	applied	\N	\N	\N	\N	125043	125043	292731
16037	20499	2	applied	\N	\N	\N	\N	125044	125044	292732
16037	20497	3	applied	\N	\N	\N	\N	125045	125045	292733
16037	20500	4	applied	\N	\N	\N	\N	125046	125046	292734
16037	20498	5	applied	\N	\N	\N	\N	125047	125047	292735
16039	20504	0	applied	\N	\N	\N	\N	125051	125051	292739
16039	20505	1	applied	\N	\N	\N	\N	125052	125052	292740
16039	20506	2	applied	\N	\N	\N	\N	125053	125053	292741
16040	20504	0	applied	\N	\N	\N	\N	125055	125055	292743
16040	20505	1	applied	\N	\N	\N	\N	125056	125056	292744
16040	20506	2	applied	\N	\N	\N	\N	125057	125057	292745
16040	20507	3	applied	\N	\N	\N	\N	125058	125058	292746
16042	20504	0	applied	\N	\N	\N	\N	125063	125063	292751
16042	20505	1	applied	\N	\N	\N	\N	125064	125064	292752
16042	20506	2	applied	\N	\N	\N	\N	125065	125065	292753
16042	20507	3	applied	\N	\N	\N	\N	125066	125066	292754
16043	20508	0	applied	\N	\N	\N	\N	125067	125067	292755
16043	20509	1	applied	\N	\N	\N	\N	125068	125068	292756
16043	20510	2	applied	\N	\N	\N	\N	125069	125069	292757
16044	20511	0	applied	\N	\N	\N	\N	125070	125070	292758
16044	20512	1	applied	\N	\N	\N	\N	125071	125071	292759
16044	20513	2	applied	\N	\N	\N	\N	125072	125072	292760
16046	20514	0	applied	\N	\N	\N	\N	125077	125077	292765
16046	20515	1	applied	\N	\N	\N	\N	125078	125078	292766
16046	20517	3	applied	\N	\N	\N	\N	125080	125080	292768
16048	20521	0	applied	\N	\N	\N	\N	125084	125084	292772
16048	20522	1	applied	\N	\N	\N	\N	125085	125085	292773
16048	20523	2	applied	\N	\N	\N	\N	125086	125086	292774
16049	20521	0	applied	\N	\N	\N	\N	125087	125087	292775
16049	20522	1	applied	\N	\N	\N	\N	125088	125088	292776
16049	20523	2	applied	\N	\N	\N	\N	125089	125089	292777
16051	20528	0	applied	\N	\N	\N	\N	125094	125094	292782
16051	20529	1	applied	\N	\N	\N	\N	125095	125095	292783
16051	20530	2	applied	\N	\N	\N	\N	125096	125096	292784
16056	20537	0	applied	\N	\N	\N	\N	125230	125230	292918
16056	20538	1	applied	\N	\N	\N	\N	125231	125231	292919
16056	20539	2	applied	\N	\N	\N	\N	125232	125232	292920
16056	20540	3	applied	\N	\N	\N	\N	125233	125233	292921
16061	20548	0	applied	\N	\N	\N	\N	125256	125256	292944
16061	20549	1	applied	\N	\N	\N	\N	125257	125257	292945
16061	20551	3	applied	\N	\N	\N	\N	125259	125259	292947
16063	20548	0	applied	\N	\N	\N	\N	125264	125264	292952
16063	20549	1	applied	\N	\N	\N	\N	125265	125265	292953
16063	20550	2	applied	\N	\N	\N	\N	125266	125266	292954
16063	20551	3	applied	\N	\N	\N	\N	125267	125267	292955
16065	20552	0	applied	\N	\N	\N	\N	125272	125272	292960
16065	20553	1	applied	\N	\N	\N	\N	125273	125273	292961
16065	20556	2	applied	\N	\N	\N	\N	125274	125274	292962
16065	20554	3	applied	\N	\N	\N	\N	125275	125275	292963
16065	20555	4	applied	\N	\N	\N	\N	125276	125276	292964
16065	20557	5	applied	\N	\N	\N	\N	125277	125277	292965
16067	20558	0	applied	\N	\N	\N	\N	125282	125282	292970
16067	20559	1	applied	\N	\N	\N	\N	125283	125283	292971
16067	20560	2	applied	\N	\N	\N	\N	125284	125284	292972
16067	20561	3	applied	\N	\N	\N	\N	125285	125285	292973
16068	20558	0	applied	\N	\N	\N	\N	125286	125286	292974
16068	20556	2	applied	\N	\N	\N	\N	125288	125288	292976
16068	20557	3	applied	\N	\N	\N	\N	125289	125289	292977
16068	20560	4	applied	\N	\N	\N	\N	125290	125290	292978
16068	20561	5	applied	\N	\N	\N	\N	125291	125291	292979
16070	20569	0	applied	\N	\N	\N	\N	125299	125299	292987
16070	20570	1	applied	\N	\N	\N	\N	125300	125300	292988
16071	20569	0	applied	\N	\N	\N	\N	125306	125306	292994
16071	20570	1	applied	\N	\N	\N	\N	125307	125307	292995
16071	20571	2	applied	\N	\N	\N	\N	125308	125308	292996
16071	20572	3	applied	\N	\N	\N	\N	125309	125309	292997
16071	20573	4	applied	\N	\N	\N	\N	125310	125310	292998
16071	20574	5	applied	\N	\N	\N	\N	125311	125311	292999
16071	20575	6	applied	\N	\N	\N	\N	125312	125312	293000
16074	20569	0	applied	\N	\N	\N	\N	125327	125327	293015
16074	20570	1	applied	\N	\N	\N	\N	125328	125328	293016
16074	20571	2	applied	\N	\N	\N	\N	125329	125329	293017
16074	20573	4	applied	\N	\N	\N	\N	125331	125331	293019
16074	20574	5	applied	\N	\N	\N	\N	125332	125332	293020
16074	20575	6	applied	\N	\N	\N	\N	125333	125333	293021
16079	20578	0	applied	\N	\N	\N	\N	125344	125344	293032
16079	20579	1	applied	\N	\N	\N	\N	125345	125345	293033
16079	20580	2	applied	\N	\N	\N	\N	125346	125346	293034
16081	20578	0	applied	\N	\N	\N	\N	125350	125350	293038
16081	20579	1	applied	\N	\N	\N	\N	125351	125351	293039
16081	20580	2	applied	\N	\N	\N	\N	125352	125352	293040
16086	20584	0	applied	\N	\N	\N	\N	125364	125364	293052
16086	20585	1	applied	\N	\N	\N	\N	125365	125365	293053
16086	20586	2	applied	\N	\N	\N	\N	125366	125366	293054
16092	20612	0	applied	\N	\N	\N	\N	125421	125421	293109
16092	20613	1	applied	\N	\N	\N	\N	125422	125422	293110
16026	20468	6	applied	\N	\N	\N	\N	124992	124992	292680
16026	20469	7	applied	\N	\N	\N	\N	124993	124993	292681
16054	20426	78	applied	\N	\N	\N	\N	125187	125187	292875
16054	20438	79	applied	\N	\N	\N	\N	125188	125188	292876
16054	20442	80	applied	\N	\N	\N	\N	125189	125189	292877
16054	20445	81	applied	\N	\N	\N	\N	125190	125190	292878
16054	20448	82	applied	\N	\N	\N	\N	125191	125191	292879
16054	20452	83	applied	\N	\N	\N	\N	125192	125192	292880
16054	20455	84	applied	\N	\N	\N	\N	125193	125193	292881
16054	20458	85	applied	\N	\N	\N	\N	125194	125194	292882
16054	20462	86	applied	\N	\N	\N	\N	125195	125195	292883
16054	20463	87	applied	\N	\N	\N	\N	125196	125196	292884
16054	20464	88	applied	\N	\N	\N	\N	125197	125197	292885
16054	20471	89	applied	\N	\N	\N	\N	125198	125198	292886
16054	20475	90	applied	\N	\N	\N	\N	125199	125199	292887
16054	20478	91	applied	\N	\N	\N	\N	125200	125200	292888
16054	20479	92	applied	\N	\N	\N	\N	125201	125201	292889
16054	20485	93	applied	\N	\N	\N	\N	125202	125202	292890
16054	20489	95	applied	\N	\N	\N	\N	125204	125204	292892
16054	20495	96	applied	\N	\N	\N	\N	125205	125205	292893
16054	20496	97	applied	\N	\N	\N	\N	125206	125206	292894
16054	20501	98	applied	\N	\N	\N	\N	125207	125207	292895
16054	20504	99	applied	\N	\N	\N	\N	125208	125208	292896
16054	20508	100	applied	\N	\N	\N	\N	125209	125209	292897
16054	20511	101	applied	\N	\N	\N	\N	125210	125210	292898
16054	20514	102	applied	\N	\N	\N	\N	125211	125211	292899
16054	20518	103	applied	\N	\N	\N	\N	125212	125212	292900
16054	20521	104	applied	\N	\N	\N	\N	125213	125213	292901
16054	20524	105	applied	\N	\N	\N	\N	125214	125214	292902
16054	20528	106	applied	\N	\N	\N	\N	125215	125215	292903
16054	20531	107	applied	\N	\N	\N	\N	125216	125216	292904
16054	20532	108	applied	\N	\N	\N	\N	125217	125217	292905
16054	20201	109	applied	\N	\N	\N	\N	125218	125218	292906
16054	20202	110	applied	\N	\N	\N	\N	125219	125219	292907
16054	20204	112	applied	\N	\N	\N	\N	125221	125221	292909
16054	20208	113	applied	\N	\N	\N	\N	125222	125222	292910
16054	20391	114	applied	\N	\N	\N	\N	125223	125223	292911
16054	20205	115	applied	\N	\N	\N	\N	125224	125224	292912
16054	20207	116	applied	\N	\N	\N	\N	125225	125225	292913
16057	20541	0	applied	\N	\N	\N	\N	125234	125234	292922
16057	20542	1	applied	\N	\N	\N	\N	125235	125235	292923
16057	20543	2	applied	\N	\N	\N	\N	125236	125236	292924
16057	20544	3	applied	\N	\N	\N	\N	125237	125237	292925
16057	20545	4	applied	\N	\N	\N	\N	125238	125238	292926
16057	20546	5	applied	\N	\N	\N	\N	125239	125239	292927
16057	20547	6	applied	\N	\N	\N	\N	125240	125240	292928
16059	20548	0	applied	\N	\N	\N	\N	125248	125248	292936
16059	20549	1	applied	\N	\N	\N	\N	125249	125249	292937
16059	20550	2	applied	\N	\N	\N	\N	125250	125250	292938
16059	20551	3	applied	\N	\N	\N	\N	125251	125251	292939
16062	20549	1	applied	\N	\N	\N	\N	125261	125261	292949
16062	20550	2	applied	\N	\N	\N	\N	125262	125262	292950
16062	20551	3	applied	\N	\N	\N	\N	125263	125263	292951
16066	20558	0	applied	\N	\N	\N	\N	125278	125278	292966
16066	20559	1	applied	\N	\N	\N	\N	125279	125279	292967
16066	20560	2	applied	\N	\N	\N	\N	125280	125280	292968
16066	20561	3	applied	\N	\N	\N	\N	125281	125281	292969
16078	20576	0	applied	\N	\N	\N	\N	125343	125343	293031
16080	20578	0	applied	\N	\N	\N	\N	125347	125347	293035
16080	20579	1	applied	\N	\N	\N	\N	125348	125348	293036
16080	20580	2	applied	\N	\N	\N	\N	125349	125349	293037
16084	20582	0	applied	\N	\N	\N	\N	125359	125359	293047
16084	20583	1	applied	\N	\N	\N	\N	125360	125360	293048
16087	20584	0	applied	\N	\N	\N	\N	125367	125367	293055
16087	20585	1	applied	\N	\N	\N	\N	125368	125368	293056
16087	20586	2	applied	\N	\N	\N	\N	125369	125369	293057
16088	20585	1	applied	\N	\N	\N	\N	125371	125371	293059
16088	20582	2	applied	\N	\N	\N	\N	125372	125372	293060
16092	20614	2	applied	\N	\N	\N	\N	125423	125423	293111
16092	20615	3	applied	\N	\N	\N	\N	125424	125424	293112
16092	20616	4	applied	\N	\N	\N	\N	125425	125425	293113
16092	20617	5	applied	\N	\N	\N	\N	125426	125426	293114
16092	20618	6	applied	\N	\N	\N	\N	125427	125427	293115
16095	20619	0	applied	\N	\N	\N	\N	125434	125434	293122
16095	20620	1	applied	\N	\N	\N	\N	125435	125435	293123
16095	20621	2	applied	\N	\N	\N	\N	125436	125436	293124
16097	20626	0	applied	\N	\N	\N	\N	125441	125441	293129
16097	20627	1	applied	\N	\N	\N	\N	125442	125442	293130
16097	20628	2	applied	\N	\N	\N	\N	125443	125443	293131
16097	20629	3	applied	\N	\N	\N	\N	125444	125444	293132
16097	20630	4	applied	\N	\N	\N	\N	125445	125445	293133
16097	20631	5	applied	\N	\N	\N	\N	125446	125446	293134
16104	20640	1	applied	\N	\N	\N	\N	125589	125589	293277
16104	20641	3	applied	\N	\N	\N	\N	125590	125590	293278
16111	20655	0	applied	\N	\N	\N	\N	125617	125617	293305
16111	20656	1	applied	\N	\N	\N	\N	125618	125618	293306
16111	20657	2	applied	\N	\N	\N	\N	125619	125619	293307
16111	20658	3	applied	\N	\N	\N	\N	125620	125620	293308
16112	20659	0	applied	\N	\N	\N	\N	125621	125621	293309
16112	20660	1	applied	\N	\N	\N	\N	125622	125622	293310
16112	20661	2	applied	\N	\N	\N	\N	125623	125623	293311
16112	20662	3	applied	\N	\N	\N	\N	125624	125624	293312
16112	20663	4	applied	\N	\N	\N	\N	125625	125625	293313
16112	20664	5	applied	\N	\N	\N	\N	125626	125626	293314
16112	20665	6	applied	\N	\N	\N	\N	125627	125627	293315
16112	20666	7	applied	\N	\N	\N	\N	125628	125628	293316
16112	20667	8	applied	\N	\N	\N	\N	125629	125629	293317
16112	20668	9	applied	\N	\N	\N	\N	125630	125630	293318
16112	20670	11	applied	\N	\N	\N	\N	125632	125632	293320
16112	20671	12	applied	\N	\N	\N	\N	125633	125633	293321
16117	20678	0	applied	\N	\N	\N	\N	125647	125647	293335
16117	20679	1	applied	\N	\N	\N	\N	125648	125648	293336
16117	20680	2	applied	\N	\N	\N	\N	125649	125649	293337
16117	20681	3	applied	\N	\N	\N	\N	125650	125650	293338
16119	20682	0	applied	\N	\N	\N	\N	125657	125657	293345
16119	20683	1	applied	\N	\N	\N	\N	125658	125658	293346
16119	20684	2	applied	\N	\N	\N	\N	125659	125659	293347
16119	20685	3	applied	\N	\N	\N	\N	125660	125660	293348
16119	20686	4	applied	\N	\N	\N	\N	125661	125661	293349
16119	20687	5	applied	\N	\N	\N	\N	125662	125662	293350
16127	20708	0	applied	\N	\N	\N	\N	125693	125693	293381
16127	20709	1	applied	\N	\N	\N	\N	125694	125694	293382
16054	20423	75	applied	\N	\N	\N	\N	125184	125184	292872
16054	20424	76	applied	\N	\N	\N	\N	125185	125185	292873
16070	20575	6	applied	\N	\N	\N	\N	125305	125305	292993
16073	20569	0	applied	\N	\N	\N	\N	125320	125320	293008
16073	20570	1	applied	\N	\N	\N	\N	125321	125321	293009
16073	20571	2	applied	\N	\N	\N	\N	125322	125322	293010
16073	20572	3	applied	\N	\N	\N	\N	125323	125323	293011
16073	20573	4	applied	\N	\N	\N	\N	125324	125324	293012
16073	20574	5	applied	\N	\N	\N	\N	125325	125325	293013
16073	20575	6	applied	\N	\N	\N	\N	125326	125326	293014
16076	20576	0	applied	\N	\N	\N	\N	125341	125341	293029
16076	20577	1	applied	\N	\N	\N	\N	125342	125342	293030
16083	20581	0	applied	\N	\N	\N	\N	125356	125356	293044
16083	20582	1	applied	\N	\N	\N	\N	125357	125357	293045
16083	20583	2	applied	\N	\N	\N	\N	125358	125358	293046
16085	20584	0	applied	\N	\N	\N	\N	125361	125361	293049
16085	20585	1	applied	\N	\N	\N	\N	125362	125362	293050
16085	20586	2	applied	\N	\N	\N	\N	125363	125363	293051
16089	20587	0	applied	\N	\N	\N	\N	125374	125374	293062
16089	20588	1	applied	\N	\N	\N	\N	125375	125375	293063
16089	20589	2	applied	\N	\N	\N	\N	125376	125376	293064
16090	20590	0	applied	\N	\N	\N	\N	125377	125377	293065
16090	20591	1	applied	\N	\N	\N	\N	125378	125378	293066
16090	20592	2	applied	\N	\N	\N	\N	125379	125379	293067
16090	20593	3	applied	\N	\N	\N	\N	125380	125380	293068
16090	20594	4	applied	\N	\N	\N	\N	125381	125381	293069
16090	20595	5	applied	\N	\N	\N	\N	125382	125382	293070
16090	20596	6	applied	\N	\N	\N	\N	125383	125383	293071
16090	20597	7	applied	\N	\N	\N	\N	125384	125384	293072
16090	20598	8	applied	\N	\N	\N	\N	125385	125385	293073
16090	20599	9	applied	\N	\N	\N	\N	125386	125386	293074
16090	20600	10	applied	\N	\N	\N	\N	125387	125387	293075
16090	20601	11	applied	\N	\N	\N	\N	125388	125388	293076
16090	20602	12	applied	\N	\N	\N	\N	125389	125389	293077
16090	20604	14	applied	\N	\N	\N	\N	125391	125391	293079
16090	20605	15	applied	\N	\N	\N	\N	125392	125392	293080
16090	20606	16	applied	\N	\N	\N	\N	125393	125393	293081
16090	20607	17	applied	\N	\N	\N	\N	125394	125394	293082
16090	20608	18	applied	\N	\N	\N	\N	125395	125395	293083
16090	20609	19	applied	\N	\N	\N	\N	125396	125396	293084
16090	20610	20	applied	\N	\N	\N	\N	125397	125397	293085
16090	20611	21	applied	\N	\N	\N	\N	125398	125398	293086
16094	20619	0	applied	\N	\N	\N	\N	125431	125431	293119
16094	20620	1	applied	\N	\N	\N	\N	125432	125432	293120
16094	20621	2	applied	\N	\N	\N	\N	125433	125433	293121
16096	20622	0	applied	\N	\N	\N	\N	125437	125437	293125
16096	20623	1	applied	\N	\N	\N	\N	125438	125438	293126
16096	20624	2	applied	\N	\N	\N	\N	125439	125439	293127
16096	20625	3	applied	\N	\N	\N	\N	125440	125440	293128
16099	20632	0	applied	\N	\N	\N	\N	125450	125450	293138
16099	20634	2	applied	\N	\N	\N	\N	125452	125452	293140
16101	20635	0	applied	\N	\N	\N	\N	125578	125578	293266
16101	20636	1	applied	\N	\N	\N	\N	125579	125579	293267
16101	20637	2	applied	\N	\N	\N	\N	125580	125580	293268
16101	20638	3	applied	\N	\N	\N	\N	125581	125581	293269
16102	20639	0	applied	\N	\N	\N	\N	125582	125582	293270
16102	20640	1	applied	\N	\N	\N	\N	125583	125583	293271
16102	20641	3	applied	\N	\N	\N	\N	125584	125584	293272
16106	20642	0	applied	\N	\N	\N	\N	125598	125598	293286
16106	20643	1	applied	\N	\N	\N	\N	125599	125599	293287
16106	20644	2	applied	\N	\N	\N	\N	125600	125600	293288
16106	20645	3	applied	\N	\N	\N	\N	125601	125601	293289
16106	20646	4	applied	\N	\N	\N	\N	125602	125602	293290
16106	20647	5	applied	\N	\N	\N	\N	125603	125603	293291
16106	20648	6	applied	\N	\N	\N	\N	125604	125604	293292
16107	20649	0	applied	\N	\N	\N	\N	125605	125605	293293
16107	20651	2	applied	\N	\N	\N	\N	125607	125607	293295
16109	20649	0	applied	\N	\N	\N	\N	125611	125611	293299
16109	20650	1	applied	\N	\N	\N	\N	125612	125612	293300
16109	20651	2	applied	\N	\N	\N	\N	125613	125613	293301
16110	20652	0	applied	\N	\N	\N	\N	125614	125614	293302
16110	20653	1	applied	\N	\N	\N	\N	125615	125615	293303
16110	20654	2	applied	\N	\N	\N	\N	125616	125616	293304
16114	20672	0	applied	\N	\N	\N	\N	125637	125637	293325
16114	20673	1	applied	\N	\N	\N	\N	125638	125638	293326
16114	20674	2	applied	\N	\N	\N	\N	125639	125639	293327
16115	20675	0	applied	\N	\N	\N	\N	125640	125640	293328
16115	20676	1	applied	\N	\N	\N	\N	125641	125641	293329
16115	20677	2	applied	\N	\N	\N	\N	125642	125642	293330
16116	20678	0	applied	\N	\N	\N	\N	125643	125643	293331
16116	20679	1	applied	\N	\N	\N	\N	125644	125644	293332
16116	20680	2	applied	\N	\N	\N	\N	125645	125645	293333
16120	20688	0	applied	\N	\N	\N	\N	125663	125663	293351
16120	20689	1	applied	\N	\N	\N	\N	125664	125664	293352
16120	20690	2	applied	\N	\N	\N	\N	125665	125665	293353
16120	20691	3	applied	\N	\N	\N	\N	125666	125666	293354
16121	20692	0	applied	\N	\N	\N	\N	125667	125667	293355
16121	20693	1	applied	\N	\N	\N	\N	125668	125668	293356
16121	20694	2	applied	\N	\N	\N	\N	125669	125669	293357
16122	20692	0	applied	\N	\N	\N	\N	125670	125670	293358
16122	20693	1	applied	\N	\N	\N	\N	125671	125671	293359
16122	20694	2	applied	\N	\N	\N	\N	125672	125672	293360
16124	20698	0	applied	\N	\N	\N	\N	125676	125676	293364
16124	20699	1	applied	\N	\N	\N	\N	125677	125677	293365
16124	20700	2	applied	\N	\N	\N	\N	125678	125678	293366
16124	20701	3	applied	\N	\N	\N	\N	125679	125679	293367
16124	20702	4	applied	\N	\N	\N	\N	125680	125680	293368
16124	20703	5	applied	\N	\N	\N	\N	125681	125681	293369
16125	20698	0	applied	\N	\N	\N	\N	125683	125683	293371
16125	20699	1	applied	\N	\N	\N	\N	125684	125684	293372
16125	20700	2	applied	\N	\N	\N	\N	125685	125685	293373
16125	20701	3	applied	\N	\N	\N	\N	125686	125686	293374
16126	20705	0	applied	\N	\N	\N	\N	125690	125690	293378
16126	20706	1	applied	\N	\N	\N	\N	125691	125691	293379
16126	20707	2	applied	\N	\N	\N	\N	125692	125692	293380
16131	20712	0	applied	\N	\N	\N	\N	125738	125738	293426
16131	20713	1	applied	\N	\N	\N	\N	125739	125739	293427
16131	20714	2	applied	\N	\N	\N	\N	125740	125740	293428
16131	20711	3	applied	\N	\N	\N	\N	125741	125741	293429
16138	20724	0	applied	\N	\N	\N	\N	125767	125767	293455
16138	20725	1	applied	\N	\N	\N	\N	125768	125768	293456
16138	20726	2	applied	\N	\N	\N	\N	125769	125769	293457
16070	20572	3	applied	\N	\N	\N	\N	125302	125302	292990
16070	20573	4	applied	\N	\N	\N	\N	125303	125303	292991
16091	20592	2	applied	\N	\N	\N	\N	125401	125401	293089
16091	20593	3	applied	\N	\N	\N	\N	125402	125402	293090
16091	20594	4	applied	\N	\N	\N	\N	125403	125403	293091
16091	20595	5	applied	\N	\N	\N	\N	125404	125404	293092
16091	20596	6	applied	\N	\N	\N	\N	125405	125405	293093
16091	20597	7	applied	\N	\N	\N	\N	125406	125406	293094
16091	20598	8	applied	\N	\N	\N	\N	125407	125407	293095
16091	20599	9	applied	\N	\N	\N	\N	125408	125408	293096
16091	20600	10	applied	\N	\N	\N	\N	125409	125409	293097
16091	20601	11	applied	\N	\N	\N	\N	125410	125410	293098
16091	20602	12	applied	\N	\N	\N	\N	125411	125411	293099
16091	20603	13	applied	\N	\N	\N	\N	125412	125412	293100
16091	20604	14	applied	\N	\N	\N	\N	125413	125413	293101
16091	20605	15	applied	\N	\N	\N	\N	125414	125414	293102
16091	20606	16	applied	\N	\N	\N	\N	125415	125415	293103
16091	20607	17	applied	\N	\N	\N	\N	125416	125416	293104
16091	20609	19	applied	\N	\N	\N	\N	125418	125418	293106
16091	20610	20	applied	\N	\N	\N	\N	125419	125419	293107
16091	20611	21	applied	\N	\N	\N	\N	125420	125420	293108
16093	20619	0	applied	\N	\N	\N	\N	125428	125428	293116
16093	20620	1	applied	\N	\N	\N	\N	125429	125429	293117
16093	20621	2	applied	\N	\N	\N	\N	125430	125430	293118
16098	20632	0	applied	\N	\N	\N	\N	125447	125447	293135
16098	20633	1	applied	\N	\N	\N	\N	125448	125448	293136
16098	20634	2	applied	\N	\N	\N	\N	125449	125449	293137
16100	20419	0	applied	\N	\N	\N	\N	125453	125453	293141
16100	20422	1	applied	\N	\N	\N	\N	125454	125454	293142
16100	20423	2	applied	\N	\N	\N	\N	125455	125455	293143
16100	20424	3	applied	\N	\N	\N	\N	125456	125456	293144
16100	20425	4	applied	\N	\N	\N	\N	125457	125457	293145
16100	20426	5	applied	\N	\N	\N	\N	125458	125458	293146
16100	20438	6	applied	\N	\N	\N	\N	125459	125459	293147
16100	20445	8	applied	\N	\N	\N	\N	125461	125461	293149
16100	20448	9	applied	\N	\N	\N	\N	125462	125462	293150
16100	20452	10	applied	\N	\N	\N	\N	125463	125463	293151
16100	20455	11	applied	\N	\N	\N	\N	125464	125464	293152
16100	20458	12	applied	\N	\N	\N	\N	125465	125465	293153
16100	20462	13	applied	\N	\N	\N	\N	125466	125466	293154
16100	20463	14	applied	\N	\N	\N	\N	125467	125467	293155
16100	20464	15	applied	\N	\N	\N	\N	125468	125468	293156
16100	20471	16	applied	\N	\N	\N	\N	125469	125469	293157
16100	20475	17	applied	\N	\N	\N	\N	125470	125470	293158
16100	20478	18	applied	\N	\N	\N	\N	125471	125471	293159
16100	20479	19	applied	\N	\N	\N	\N	125472	125472	293160
16100	20485	20	applied	\N	\N	\N	\N	125473	125473	293161
16100	20488	21	applied	\N	\N	\N	\N	125474	125474	293162
16100	20489	22	applied	\N	\N	\N	\N	125475	125475	293163
16100	20495	23	applied	\N	\N	\N	\N	125476	125476	293164
16100	20501	25	applied	\N	\N	\N	\N	125478	125478	293166
16100	20504	26	applied	\N	\N	\N	\N	125479	125479	293167
16100	20508	27	applied	\N	\N	\N	\N	125480	125480	293168
16100	20511	28	applied	\N	\N	\N	\N	125481	125481	293169
16100	20514	29	applied	\N	\N	\N	\N	125482	125482	293170
16100	20518	30	applied	\N	\N	\N	\N	125483	125483	293171
16100	20521	31	applied	\N	\N	\N	\N	125484	125484	293172
16100	20524	32	applied	\N	\N	\N	\N	125485	125485	293173
16100	20528	33	applied	\N	\N	\N	\N	125486	125486	293174
16100	20531	34	applied	\N	\N	\N	\N	125487	125487	293175
16100	20532	35	applied	\N	\N	\N	\N	125488	125488	293176
16100	20537	36	applied	\N	\N	\N	\N	125489	125489	293177
16100	20541	37	applied	\N	\N	\N	\N	125490	125490	293178
16100	20542	38	applied	\N	\N	\N	\N	125491	125491	293179
16100	20548	39	applied	\N	\N	\N	\N	125492	125492	293180
16100	20552	40	applied	\N	\N	\N	\N	125493	125493	293181
16100	20558	42	applied	\N	\N	\N	\N	125495	125495	293183
16100	20562	43	applied	\N	\N	\N	\N	125496	125496	293184
16138	20727	3	applied	\N	\N	\N	\N	125770	125770	293458
16138	20728	4	applied	\N	\N	\N	\N	125771	125771	293459
16138	20729	5	applied	\N	\N	\N	\N	125772	125772	293460
16140	20724	0	applied	\N	\N	\N	\N	125779	125779	293467
16140	20725	1	applied	\N	\N	\N	\N	125780	125780	293468
16140	20726	2	applied	\N	\N	\N	\N	125781	125781	293469
16140	20727	3	applied	\N	\N	\N	\N	125782	125782	293470
16140	20728	4	applied	\N	\N	\N	\N	125783	125783	293471
16140	20729	5	applied	\N	\N	\N	\N	125784	125784	293472
16143	20736	0	applied	\N	\N	\N	\N	125794	125794	293482
16143	20737	1	applied	\N	\N	\N	\N	125795	125795	293483
16143	20738	2	applied	\N	\N	\N	\N	125796	125796	293484
16150	20751	0	applied	\N	\N	\N	\N	125821	125821	293509
16150	20752	1	applied	\N	\N	\N	\N	125822	125822	293510
16150	20754	3	applied	\N	\N	\N	\N	125824	125824	293512
16152	20755	0	applied	\N	\N	\N	\N	125829	125829	293517
16152	20756	1	applied	\N	\N	\N	\N	125830	125830	293518
16152	20757	2	applied	\N	\N	\N	\N	125831	125831	293519
16154	20730	0	applied	\N	\N	\N	\N	125835	125835	293523
16154	20731	1	applied	\N	\N	\N	\N	125836	125836	293524
16154	20736	2	applied	\N	\N	\N	\N	125837	125837	293525
16154	20739	3	applied	\N	\N	\N	\N	125838	125838	293526
16154	20742	4	applied	\N	\N	\N	\N	125839	125839	293527
16154	20743	5	applied	\N	\N	\N	\N	125840	125840	293528
16154	20748	6	applied	\N	\N	\N	\N	125841	125841	293529
16154	20751	7	applied	\N	\N	\N	\N	125842	125842	293530
16154	20755	8	applied	\N	\N	\N	\N	125843	125843	293531
16154	20732	9	applied	\N	\N	\N	\N	125844	125844	293532
16154	20733	10	applied	\N	\N	\N	\N	125845	125845	293533
16154	20738	11	applied	\N	\N	\N	\N	125846	125846	293534
16154	20744	13	applied	\N	\N	\N	\N	125848	125848	293536
16154	20750	14	applied	\N	\N	\N	\N	125849	125849	293537
16154	20753	15	applied	\N	\N	\N	\N	125850	125850	293538
16154	20757	16	applied	\N	\N	\N	\N	125851	125851	293539
16154	20734	17	applied	\N	\N	\N	\N	125852	125852	293540
16154	20745	18	applied	\N	\N	\N	\N	125853	125853	293541
16154	20752	19	applied	\N	\N	\N	\N	125854	125854	293542
16154	20735	20	applied	\N	\N	\N	\N	125855	125855	293543
16154	20737	21	applied	\N	\N	\N	\N	125856	125856	293544
16154	20741	22	applied	\N	\N	\N	\N	125857	125857	293545
16154	20746	23	applied	\N	\N	\N	\N	125858	125858	293546
16154	20747	24	applied	\N	\N	\N	\N	125859	125859	293547
16154	20749	25	applied	\N	\N	\N	\N	125860	125860	293548
16154	20754	26	applied	\N	\N	\N	\N	125861	125861	293549
16082	20583	2	applied	\N	\N	\N	\N	125355	125355	293043
16091	20590	0	applied	\N	\N	\N	\N	125399	125399	293087
16100	20578	48	applied	\N	\N	\N	\N	125501	125501	293189
16100	20581	49	applied	\N	\N	\N	\N	125502	125502	293190
16100	20584	50	applied	\N	\N	\N	\N	125503	125503	293191
16100	20587	51	applied	\N	\N	\N	\N	125504	125504	293192
16100	20590	52	applied	\N	\N	\N	\N	125505	125505	293193
16100	20591	53	applied	\N	\N	\N	\N	125506	125506	293194
16100	20592	54	applied	\N	\N	\N	\N	125507	125507	293195
16100	20593	55	applied	\N	\N	\N	\N	125508	125508	293196
16100	20594	56	applied	\N	\N	\N	\N	125509	125509	293197
16100	20595	58	applied	\N	\N	\N	\N	125510	125510	293198
16100	20612	59	applied	\N	\N	\N	\N	125511	125511	293199
16100	20613	60	applied	\N	\N	\N	\N	125512	125512	293200
16100	20619	61	applied	\N	\N	\N	\N	125513	125513	293201
16100	20622	62	applied	\N	\N	\N	\N	125514	125514	293202
16100	20626	63	applied	\N	\N	\N	\N	125515	125515	293203
16100	20627	64	applied	\N	\N	\N	\N	125516	125516	293204
16100	20420	66	applied	\N	\N	\N	\N	125518	125518	293206
16100	20543	67	applied	\N	\N	\N	\N	125519	125519	293207
16100	20564	68	applied	\N	\N	\N	\N	125520	125520	293208
16100	20430	69	applied	\N	\N	\N	\N	125521	125521	293209
16100	20431	70	applied	\N	\N	\N	\N	125522	125522	293210
16100	20432	71	applied	\N	\N	\N	\N	125523	125523	293211
16100	20433	72	applied	\N	\N	\N	\N	125524	125524	293212
16100	20434	73	applied	\N	\N	\N	\N	125525	125525	293213
16100	20440	74	applied	\N	\N	\N	\N	125526	125526	293214
16100	20444	75	applied	\N	\N	\N	\N	125527	125527	293215
16100	20435	76	applied	\N	\N	\N	\N	125528	125528	293216
16100	20441	77	applied	\N	\N	\N	\N	125529	125529	293217
16100	20449	78	applied	\N	\N	\N	\N	125530	125530	293218
16100	20460	79	applied	\N	\N	\N	\N	125531	125531	293219
16100	20474	80	applied	\N	\N	\N	\N	125532	125532	293220
16100	20480	81	applied	\N	\N	\N	\N	125533	125533	293221
16100	20506	83	applied	\N	\N	\N	\N	125535	125535	293223
16100	20517	84	applied	\N	\N	\N	\N	125536	125536	293224
16100	20447	85	applied	\N	\N	\N	\N	125537	125537	293225
16100	20451	86	applied	\N	\N	\N	\N	125538	125538	293226
16100	20453	87	applied	\N	\N	\N	\N	125539	125539	293227
16100	20456	88	applied	\N	\N	\N	\N	125540	125540	293228
16100	20459	89	applied	\N	\N	\N	\N	125541	125541	293229
16100	20465	90	applied	\N	\N	\N	\N	125542	125542	293230
16100	20467	91	applied	\N	\N	\N	\N	125543	125543	293231
16100	20468	92	applied	\N	\N	\N	\N	125544	125544	293232
16100	20472	93	applied	\N	\N	\N	\N	125545	125545	293233
16100	20476	94	applied	\N	\N	\N	\N	125546	125546	293234
16100	20481	95	applied	\N	\N	\N	\N	125547	125547	293235
16100	20482	96	applied	\N	\N	\N	\N	125548	125548	293236
16100	20486	97	applied	\N	\N	\N	\N	125549	125549	293237
16100	20490	98	applied	\N	\N	\N	\N	125550	125550	293238
16100	20499	100	applied	\N	\N	\N	\N	125552	125552	293240
16100	20500	101	applied	\N	\N	\N	\N	125553	125553	293241
16100	20502	102	applied	\N	\N	\N	\N	125554	125554	293242
16100	20507	103	applied	\N	\N	\N	\N	125555	125555	293243
16100	20509	104	applied	\N	\N	\N	\N	125556	125556	293244
16100	20512	105	applied	\N	\N	\N	\N	125557	125557	293245
16100	20516	106	applied	\N	\N	\N	\N	125558	125558	293246
16100	20520	107	applied	\N	\N	\N	\N	125559	125559	293247
16100	20522	108	applied	\N	\N	\N	\N	125560	125560	293248
16100	20525	109	applied	\N	\N	\N	\N	125561	125561	293249
16100	20529	110	applied	\N	\N	\N	\N	125562	125562	293250
16100	20421	111	applied	\N	\N	\N	\N	125563	125563	293251
16100	20427	112	applied	\N	\N	\N	\N	125564	125564	293252
16100	20428	113	applied	\N	\N	\N	\N	125565	125565	293253
16100	20429	114	applied	\N	\N	\N	\N	125566	125566	293254
16100	20436	115	applied	\N	\N	\N	\N	125567	125567	293255
16100	20439	117	applied	\N	\N	\N	\N	125569	125569	293257
16100	20443	118	applied	\N	\N	\N	\N	125570	125570	293258
16100	20446	119	applied	\N	\N	\N	\N	125571	125571	293259
16100	20450	120	applied	\N	\N	\N	\N	125572	125572	293260
16100	20454	121	applied	\N	\N	\N	\N	125573	125573	293261
16100	20457	122	applied	\N	\N	\N	\N	125574	125574	293262
16100	20461	123	applied	\N	\N	\N	\N	125575	125575	293263
16100	20466	124	applied	\N	\N	\N	\N	125576	125576	293264
16100	20527	125	applied	\N	\N	\N	\N	125577	125577	293265
16103	20639	0	applied	\N	\N	\N	\N	125585	125585	293273
16103	20640	1	applied	\N	\N	\N	\N	125586	125586	293274
16103	20641	3	applied	\N	\N	\N	\N	125587	125587	293275
16105	20642	0	applied	\N	\N	\N	\N	125591	125591	293279
16105	20643	1	applied	\N	\N	\N	\N	125592	125592	293280
16105	20644	2	applied	\N	\N	\N	\N	125593	125593	293281
16105	20645	3	applied	\N	\N	\N	\N	125594	125594	293282
16105	20647	5	applied	\N	\N	\N	\N	125596	125596	293284
16105	20648	6	applied	\N	\N	\N	\N	125597	125597	293285
16108	20649	0	applied	\N	\N	\N	\N	125608	125608	293296
16108	20650	1	applied	\N	\N	\N	\N	125609	125609	293297
16108	20651	2	applied	\N	\N	\N	\N	125610	125610	293298
16113	20672	0	applied	\N	\N	\N	\N	125634	125634	293322
16113	20673	1	applied	\N	\N	\N	\N	125635	125635	293323
16113	20674	2	applied	\N	\N	\N	\N	125636	125636	293324
16118	20682	0	applied	\N	\N	\N	\N	125651	125651	293339
16118	20683	1	applied	\N	\N	\N	\N	125652	125652	293340
16118	20684	2	applied	\N	\N	\N	\N	125653	125653	293341
16118	20685	3	applied	\N	\N	\N	\N	125654	125654	293342
16118	20686	4	applied	\N	\N	\N	\N	125655	125655	293343
16118	20687	5	applied	\N	\N	\N	\N	125656	125656	293344
16123	20695	0	applied	\N	\N	\N	\N	125673	125673	293361
16123	20696	1	applied	\N	\N	\N	\N	125674	125674	293362
16130	20712	0	applied	\N	\N	\N	\N	125734	125734	293422
16130	20713	1	applied	\N	\N	\N	\N	125735	125735	293423
16130	20714	2	applied	\N	\N	\N	\N	125736	125736	293424
16130	20711	3	applied	\N	\N	\N	\N	125737	125737	293425
16133	20715	0	applied	\N	\N	\N	\N	125744	125744	293432
16133	20716	1	applied	\N	\N	\N	\N	125745	125745	293433
16135	20717	0	applied	\N	\N	\N	\N	125753	125753	293441
16135	20718	1	applied	\N	\N	\N	\N	125754	125754	293442
16135	20719	2	applied	\N	\N	\N	\N	125755	125755	293443
16135	20720	3	applied	\N	\N	\N	\N	125756	125756	293444
16135	20721	4	applied	\N	\N	\N	\N	125757	125757	293445
16135	20722	5	applied	\N	\N	\N	\N	125758	125758	293446
16135	20723	6	applied	\N	\N	\N	\N	125759	125759	293447
16142	20736	0	applied	\N	\N	\N	\N	125791	125791	293479
16100	20569	45	applied	\N	\N	\N	\N	125498	125498	293186
16100	20570	46	applied	\N	\N	\N	\N	125499	125499	293187
16128	20709	1	applied	\N	\N	\N	\N	125697	125697	293385
16128	20710	2	applied	\N	\N	\N	\N	125698	125698	293386
16132	20715	0	applied	\N	\N	\N	\N	125742	125742	293430
16132	20716	1	applied	\N	\N	\N	\N	125743	125743	293431
16142	20737	1	applied	\N	\N	\N	\N	125792	125792	293480
16144	20739	0	applied	\N	\N	\N	\N	125797	125797	293485
16144	20740	1	applied	\N	\N	\N	\N	125798	125798	293486
16144	20741	2	applied	\N	\N	\N	\N	125799	125799	293487
16145	20739	0	applied	\N	\N	\N	\N	125800	125800	293488
16145	20740	1	applied	\N	\N	\N	\N	125801	125801	293489
16145	20741	2	applied	\N	\N	\N	\N	125802	125802	293490
16147	20742	0	applied	\N	\N	\N	\N	125809	125809	293497
16147	20743	1	applied	\N	\N	\N	\N	125810	125810	293498
16147	20744	2	applied	\N	\N	\N	\N	125811	125811	293499
16147	20745	3	applied	\N	\N	\N	\N	125812	125812	293500
16147	20746	4	applied	\N	\N	\N	\N	125813	125813	293501
16147	20747	5	applied	\N	\N	\N	\N	125814	125814	293502
16149	20748	0	applied	\N	\N	\N	\N	125818	125818	293506
16149	20749	1	applied	\N	\N	\N	\N	125819	125819	293507
16149	20750	2	applied	\N	\N	\N	\N	125820	125820	293508
16156	20758	0	applied	\N	\N	\N	\N	125866	125866	293554
16156	20760	2	applied	\N	\N	\N	\N	125868	125868	293556
16158	20761	0	applied	\N	\N	\N	\N	125872	125872	293560
16158	20762	1	applied	\N	\N	\N	\N	125873	125873	293561
16158	20763	2	applied	\N	\N	\N	\N	125874	125874	293562
16159	20761	0	applied	\N	\N	\N	\N	125875	125875	293563
16159	20762	1	applied	\N	\N	\N	\N	125876	125876	293564
16159	20763	2	applied	\N	\N	\N	\N	125877	125877	293565
16160	20761	0	applied	\N	\N	\N	\N	125878	125878	293566
16160	20762	1	applied	\N	\N	\N	\N	125879	125879	293567
16160	20763	2	applied	\N	\N	\N	\N	125880	125880	293568
16162	20764	0	applied	\N	\N	\N	\N	125884	125884	293572
16162	20765	1	applied	\N	\N	\N	\N	125885	125885	293573
16162	20766	2	applied	\N	\N	\N	\N	125886	125886	293574
16162	20767	3	applied	\N	\N	\N	\N	125887	125887	293575
16165	20774	0	applied	\N	\N	\N	\N	125894	125894	293582
16165	20775	1	applied	\N	\N	\N	\N	125895	125895	293583
16165	20777	3	applied	\N	\N	\N	\N	125897	125897	293585
16167	20781	0	applied	\N	\N	\N	\N	125901	125901	293589
16167	20782	1	applied	\N	\N	\N	\N	125902	125902	293590
16167	20783	2	applied	\N	\N	\N	\N	125903	125903	293591
16168	20781	0	applied	\N	\N	\N	\N	125904	125904	293592
16168	20782	1	applied	\N	\N	\N	\N	125905	125905	293593
16168	20783	2	applied	\N	\N	\N	\N	125906	125906	293594
16170	20784	0	applied	\N	\N	\N	\N	125910	125910	293598
16170	20785	1	applied	\N	\N	\N	\N	125911	125911	293599
16170	20786	2	applied	\N	\N	\N	\N	125912	125912	293600
16170	20787	3	applied	\N	\N	\N	\N	125913	125913	293601
16172	20784	0	applied	\N	\N	\N	\N	125918	125918	293606
16172	20785	1	applied	\N	\N	\N	\N	125919	125919	293607
16172	20786	2	applied	\N	\N	\N	\N	125920	125920	293608
16172	20787	3	applied	\N	\N	\N	\N	125921	125921	293609
16173	20784	0	applied	\N	\N	\N	\N	125922	125922	293610
16173	20786	2	applied	\N	\N	\N	\N	125924	125924	293612
16173	20787	3	applied	\N	\N	\N	\N	125925	125925	293613
16174	20788	0	applied	\N	\N	\N	\N	125926	125926	293614
16174	20789	1	applied	\N	\N	\N	\N	125927	125927	293615
16176	20790	0	applied	\N	\N	\N	\N	126053	126053	293741
16176	20791	1	applied	\N	\N	\N	\N	126054	126054	293742
16176	20792	2	applied	\N	\N	\N	\N	126055	126055	293743
16179	20796	0	applied	\N	\N	\N	\N	126062	126062	293750
16179	20797	1	applied	\N	\N	\N	\N	126063	126063	293751
16179	20798	2	applied	\N	\N	\N	\N	126064	126064	293752
16179	20799	3	applied	\N	\N	\N	\N	126065	126065	293753
16181	20800	0	applied	\N	\N	\N	\N	126070	126070	293758
16181	20801	1	applied	\N	\N	\N	\N	126071	126071	293759
16182	20802	0	applied	\N	\N	\N	\N	126072	126072	293760
16182	20803	1	applied	\N	\N	\N	\N	126073	126073	293761
16182	20804	2	applied	\N	\N	\N	\N	126074	126074	293762
16186	20802	0	applied	\N	\N	\N	\N	126116	126116	293800
16182	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	126076	126076	\N
16186	20803	1	applied	\N	\N	\N	\N	126117	126117	293801
16186	20804	2	applied	\N	\N	\N	\N	126118	126118	293802
16186	20805	3	applied	\N	\N	\N	\N	126119	126119	293803
16186	20807	5	applied	\N	\N	\N	\N	126121	126121	293804
16186	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	126120	126120	\N
16186	20808	6	applied	\N	\N	\N	\N	126122	126122	293805
16186	20809	7	applied	\N	\N	\N	\N	126123	126123	293806
16186	20810	8	applied	\N	\N	\N	\N	126124	126124	293807
16186	20811	9	applied	\N	\N	\N	\N	126125	126125	293808
16186	20812	10	applied	\N	\N	\N	\N	126126	126126	293809
16188	20813	0	applied	\N	\N	\N	\N	126131	126131	293814
16188	20814	1	applied	\N	\N	1000000000	\N	126132	126132	293815
16188	20815	2	applied	\N	\N	\N	\N	126133	126133	293816
16188	20816	3	applied	\N	\N	\N	\N	126134	126134	293817
16190	20814	1	applied	\N	\N	1000000000	\N	126140	126140	293822
16193	20831	0	applied	\N	\N	\N	\N	126155	126155	293837
16193	20832	1	applied	\N	\N	\N	\N	126156	126156	293838
16193	20833	2	applied	\N	\N	\N	\N	126157	126157	293839
16193	20834	3	applied	\N	\N	\N	\N	126158	126158	293840
16200	20845	0	applied	\N	\N	\N	\N	126182	126182	293864
16200	20846	1	applied	\N	\N	\N	\N	126183	126183	293865
16200	20847	2	applied	\N	\N	\N	\N	126184	126184	293866
16202	20849	0	applied	\N	\N	\N	\N	126188	126188	293870
16202	20850	1	applied	\N	\N	\N	\N	126189	126189	293871
16205	20851	0	applied	\N	\N	\N	\N	126199	126199	293881
16205	20848	1	applied	\N	\N	\N	\N	126200	126200	293882
16205	20852	2	applied	\N	\N	\N	\N	126201	126201	293883
16205	20853	3	applied	\N	\N	\N	\N	126202	126202	293884
16205	20854	4	applied	\N	\N	\N	\N	126203	126203	293885
16205	20855	5	applied	\N	\N	\N	\N	126204	126204	293886
16209	20867	0	applied	\N	\N	\N	\N	126225	126225	293907
16209	20868	1	applied	\N	\N	\N	\N	126226	126226	293908
16209	20869	2	applied	\N	\N	\N	\N	126227	126227	293909
16212	20877	0	applied	\N	\N	\N	\N	126245	126245	293927
16212	20878	1	applied	\N	\N	\N	\N	126246	126246	293928
16212	20879	2	applied	\N	\N	\N	\N	126247	126247	293929
16212	20880	3	applied	\N	\N	\N	\N	126248	126248	293930
16125	20703	5	applied	\N	\N	\N	\N	125688	125688	293376
16128	20708	0	applied	\N	\N	\N	\N	125696	125696	293384
16129	20543	2	applied	\N	\N	\N	\N	125701	125701	293389
16129	20564	3	applied	\N	\N	\N	\N	125702	125702	293390
16129	20391	4	applied	\N	\N	\N	\N	125703	125703	293391
16129	20396	5	applied	\N	\N	\N	\N	125704	125704	293392
16129	20407	6	applied	\N	\N	\N	\N	125705	125705	293393
16129	20435	8	applied	\N	\N	\N	\N	125707	125707	293395
16129	20441	9	applied	\N	\N	\N	\N	125708	125708	293396
16129	20449	10	applied	\N	\N	\N	\N	125709	125709	293397
16129	20460	11	applied	\N	\N	\N	\N	125710	125710	293398
16129	20474	12	applied	\N	\N	\N	\N	125711	125711	293399
16129	20480	13	applied	\N	\N	\N	\N	125712	125712	293400
16129	20492	14	applied	\N	\N	\N	\N	125713	125713	293401
16129	20506	15	applied	\N	\N	\N	\N	125714	125714	293402
16129	20517	16	applied	\N	\N	\N	\N	125715	125715	293403
16129	20527	17	applied	\N	\N	\N	\N	125716	125716	293404
16129	20539	18	applied	\N	\N	\N	\N	125717	125717	293405
16129	20551	19	applied	\N	\N	\N	\N	125718	125718	293406
16129	20561	20	applied	\N	\N	\N	\N	125719	125719	293407
16129	20572	21	applied	\N	\N	\N	\N	125720	125720	293408
16129	20583	22	applied	\N	\N	\N	\N	125721	125721	293409
16129	20610	23	applied	\N	\N	\N	\N	125722	125722	293410
16129	20615	25	applied	\N	\N	\N	\N	125724	125724	293412
16129	20623	26	applied	\N	\N	\N	\N	125725	125725	293413
16129	20637	27	applied	\N	\N	\N	\N	125726	125726	293414
16129	20646	28	applied	\N	\N	\N	\N	125727	125727	293415
16129	20656	29	applied	\N	\N	\N	\N	125728	125728	293416
16129	20663	30	applied	\N	\N	\N	\N	125729	125729	293417
16129	20679	31	applied	\N	\N	\N	\N	125730	125730	293418
16129	20691	32	applied	\N	\N	\N	\N	125731	125731	293419
16129	20700	33	applied	\N	\N	\N	\N	125732	125732	293420
16129	20711	34	applied	\N	\N	\N	\N	125733	125733	293421
16134	20717	0	applied	\N	\N	\N	\N	125746	125746	293434
16134	20718	1	applied	\N	\N	\N	\N	125747	125747	293435
16134	20719	2	applied	\N	\N	\N	\N	125748	125748	293436
16134	20720	3	applied	\N	\N	\N	\N	125749	125749	293437
16134	20721	4	applied	\N	\N	\N	\N	125750	125750	293438
16134	20722	5	applied	\N	\N	\N	\N	125751	125751	293439
16136	20717	0	applied	\N	\N	\N	\N	125760	125760	293448
16136	20718	1	applied	\N	\N	\N	\N	125761	125761	293449
16136	20719	2	applied	\N	\N	\N	\N	125762	125762	293450
16136	20720	3	applied	\N	\N	\N	\N	125763	125763	293451
16136	20721	4	applied	\N	\N	\N	\N	125764	125764	293452
16136	20722	5	applied	\N	\N	\N	\N	125765	125765	293453
16136	20723	6	applied	\N	\N	\N	\N	125766	125766	293454
16139	20724	0	applied	\N	\N	\N	\N	125773	125773	293461
16139	20725	1	applied	\N	\N	\N	\N	125774	125774	293462
16139	20726	2	applied	\N	\N	\N	\N	125775	125775	293463
16139	20727	3	applied	\N	\N	\N	\N	125776	125776	293464
16139	20728	4	applied	\N	\N	\N	\N	125777	125777	293465
16139	20729	5	applied	\N	\N	\N	\N	125778	125778	293466
16141	20730	0	applied	\N	\N	\N	\N	125785	125785	293473
16141	20731	1	applied	\N	\N	\N	\N	125786	125786	293474
16141	20732	2	applied	\N	\N	\N	\N	125787	125787	293475
16141	20734	4	applied	\N	\N	\N	\N	125789	125789	293477
16141	20735	5	applied	\N	\N	\N	\N	125790	125790	293478
16146	20742	0	applied	\N	\N	\N	\N	125803	125803	293491
16146	20743	1	applied	\N	\N	\N	\N	125804	125804	293492
16146	20744	2	applied	\N	\N	\N	\N	125805	125805	293493
16146	20745	3	applied	\N	\N	\N	\N	125806	125806	293494
16146	20746	4	applied	\N	\N	\N	\N	125807	125807	293495
16146	20747	5	applied	\N	\N	\N	\N	125808	125808	293496
16148	20748	0	applied	\N	\N	\N	\N	125815	125815	293503
16148	20749	1	applied	\N	\N	\N	\N	125816	125816	293504
16148	20750	2	applied	\N	\N	\N	\N	125817	125817	293505
16151	20751	0	applied	\N	\N	\N	\N	125825	125825	293513
16151	20752	1	applied	\N	\N	\N	\N	125826	125826	293514
16151	20753	2	applied	\N	\N	\N	\N	125827	125827	293515
16212	20881	4	applied	\N	\N	\N	\N	126249	126249	293931
16214	20877	0	applied	\N	\N	\N	\N	126256	126256	293938
16214	20883	2	applied	\N	\N	\N	\N	126258	126258	293940
16214	20879	3	applied	\N	\N	\N	\N	126259	126259	293941
16214	20882	4	applied	\N	\N	\N	\N	126260	126260	293942
16214	20880	5	applied	\N	\N	\N	\N	126261	126261	293943
16214	20881	6	applied	\N	\N	\N	\N	126262	126262	293944
16217	20889	0	applied	\N	\N	\N	\N	126272	126272	293954
16217	20890	1	applied	\N	\N	\N	\N	126273	126273	293955
16217	20891	2	applied	\N	\N	\N	\N	126274	126274	293956
16219	20892	0	applied	\N	\N	\N	\N	126279	126279	293961
16219	20893	1	applied	\N	\N	\N	\N	126280	126280	293962
16219	20894	2	applied	\N	\N	\N	\N	126281	126281	293963
16219	20895	3	applied	\N	\N	\N	\N	126282	126282	293964
16224	20904	0	applied	\N	\N	\N	\N	126298	126298	293980
16224	20908	1	applied	\N	\N	\N	\N	126299	126299	293981
16224	20905	2	applied	\N	\N	\N	\N	126300	126300	293982
16224	20907	3	applied	\N	\N	\N	\N	126301	126301	293983
16224	20910	5	applied	\N	\N	1000000000	\N	126303	126303	293985
16224	20906	6	applied	\N	\N	\N	\N	126304	126304	293986
16224	20911	7	applied	\N	\N	\N	\N	126305	126305	293987
16229	20922	0	applied	\N	\N	\N	\N	126333	126333	294015
16229	20923	1	applied	\N	\N	\N	\N	126334	126334	294016
16229	20924	2	applied	\N	\N	\N	\N	126335	126335	294017
16232	20931	0	applied	\N	\N	\N	\N	126342	126342	294024
16232	20932	1	applied	\N	\N	\N	\N	126343	126343	294025
16232	20933	2	applied	\N	\N	\N	\N	126344	126344	294026
16236	20935	0	applied	\N	\N	\N	\N	126365	126365	294046
16236	20934	1	applied	\N	\N	\N	\N	126366	126366	294047
16236	20936	2	applied	\N	\N	\N	\N	126367	126367	294048
16236	20937	3	applied	\N	\N	\N	\N	126368	126368	294049
16239	20817	0	applied	\N	\N	\N	\N	126379	126379	294060
16239	20858	2	applied	\N	\N	1000000000	\N	126381	126381	294062
16239	20818	3	applied	\N	\N	\N	\N	126382	126382	294063
16239	20824	4	applied	\N	\N	\N	\N	126383	126383	294064
16239	20825	5	applied	\N	\N	\N	\N	126384	126384	294065
16239	20831	6	applied	\N	\N	\N	\N	126385	126385	294066
16239	20859	7	applied	\N	\N	1000000000	\N	126386	126386	294067
16239	20860	8	applied	\N	\N	1000000000	\N	126387	126387	294068
16239	20835	9	applied	\N	\N	\N	\N	126388	126388	294069
16239	20836	10	applied	\N	\N	\N	\N	126389	126389	294070
16239	20841	11	applied	\N	\N	\N	\N	126390	126390	294071
16129	20386	0	applied	\N	\N	1000000000	\N	125699	125699	293387
16129	20328	1	applied	\N	\N	\N	\N	125700	125700	293388
16153	20757	2	applied	\N	\N	\N	\N	125834	125834	293522
16154	20756	27	applied	\N	\N	\N	\N	125862	125862	293550
16155	20758	0	applied	\N	\N	\N	\N	125863	125863	293551
16155	20759	1	applied	\N	\N	\N	\N	125864	125864	293552
16155	20760	2	applied	\N	\N	\N	\N	125865	125865	293553
16157	20761	0	applied	\N	\N	\N	\N	125869	125869	293557
16157	20763	2	applied	\N	\N	\N	\N	125871	125871	293559
16161	20761	0	applied	\N	\N	\N	\N	125881	125881	293569
16161	20762	1	applied	\N	\N	\N	\N	125882	125882	293570
16161	20763	2	applied	\N	\N	\N	\N	125883	125883	293571
16163	20768	0	applied	\N	\N	\N	\N	125888	125888	293576
16163	20769	1	applied	\N	\N	\N	\N	125889	125889	293577
16163	20770	2	applied	\N	\N	\N	\N	125890	125890	293578
16164	20771	0	applied	\N	\N	\N	\N	125891	125891	293579
16164	20772	1	applied	\N	\N	\N	\N	125892	125892	293580
16164	20773	2	applied	\N	\N	\N	\N	125893	125893	293581
16166	20778	0	applied	\N	\N	\N	\N	125898	125898	293586
16166	20779	1	applied	\N	\N	\N	\N	125899	125899	293587
16166	20780	2	applied	\N	\N	\N	\N	125900	125900	293588
16169	20781	0	applied	\N	\N	\N	\N	125907	125907	293595
16169	20782	1	applied	\N	\N	\N	\N	125908	125908	293596
16169	20783	2	applied	\N	\N	\N	\N	125909	125909	293597
16171	20785	1	applied	\N	\N	\N	\N	125915	125915	293603
16171	20786	2	applied	\N	\N	\N	\N	125916	125916	293604
16171	20787	3	applied	\N	\N	\N	\N	125917	125917	293605
16175	20635	0	applied	\N	\N	\N	\N	125928	125928	293616
16175	20639	1	applied	\N	\N	\N	\N	125929	125929	293617
16175	20642	2	applied	\N	\N	\N	\N	125930	125930	293618
16175	20643	3	applied	\N	\N	\N	\N	125931	125931	293619
16175	20649	4	applied	\N	\N	\N	\N	125932	125932	293620
16175	20652	5	applied	\N	\N	\N	\N	125933	125933	293621
16175	20655	6	applied	\N	\N	\N	\N	125934	125934	293622
16175	20659	7	applied	\N	\N	\N	\N	125935	125935	293623
16175	20660	8	applied	\N	\N	\N	\N	125936	125936	293624
16175	20661	9	applied	\N	\N	\N	\N	125937	125937	293625
16175	20662	10	applied	\N	\N	\N	\N	125938	125938	293626
16175	20672	11	applied	\N	\N	\N	\N	125939	125939	293627
16175	20675	12	applied	\N	\N	\N	\N	125940	125940	293628
16175	20682	14	applied	\N	\N	\N	\N	125942	125942	293630
16175	20683	15	applied	\N	\N	\N	\N	125943	125943	293631
16175	20688	16	applied	\N	\N	\N	\N	125944	125944	293632
16175	20692	17	applied	\N	\N	\N	\N	125945	125945	293633
16175	20695	18	applied	\N	\N	\N	\N	125946	125946	293634
16175	20698	19	applied	\N	\N	\N	\N	125947	125947	293635
16175	20699	20	applied	\N	\N	\N	\N	125948	125948	293636
16175	20705	21	applied	\N	\N	\N	\N	125949	125949	293637
16175	20708	22	applied	\N	\N	\N	\N	125950	125950	293638
16175	20712	23	applied	\N	\N	\N	\N	125951	125951	293639
16175	20715	24	applied	\N	\N	\N	\N	125952	125952	293640
16175	20717	25	applied	\N	\N	\N	\N	125953	125953	293641
16177	20793	0	applied	\N	\N	\N	\N	126056	126056	293744
16177	20794	1	applied	\N	\N	\N	\N	126057	126057	293745
16177	20795	2	applied	\N	\N	\N	\N	126058	126058	293746
16183	20802	0	applied	\N	\N	\N	\N	126083	126083	293770
16183	20804	2	applied	\N	\N	\N	\N	126085	126085	293772
16183	20805	3	applied	\N	\N	\N	\N	126086	126086	293773
16183	20807	5	applied	\N	\N	\N	\N	126088	126088	293774
16183	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	126087	126087	\N
16183	20808	6	applied	\N	\N	\N	\N	126089	126089	293775
16183	20809	7	applied	\N	\N	\N	\N	126090	126090	293776
16183	20810	8	applied	\N	\N	\N	\N	126091	126091	293777
16183	20811	9	applied	\N	\N	\N	\N	126092	126092	293778
16183	20812	10	applied	\N	\N	\N	\N	126093	126093	293779
16189	20813	0	applied	\N	\N	\N	\N	126135	126135	293818
16189	20814	1	applied	\N	\N	1000000000	\N	126136	126136	293819
16189	20815	2	applied	\N	\N	\N	\N	126137	126137	293820
16189	20816	3	applied	\N	\N	\N	\N	126138	126138	293821
16191	20817	0	applied	\N	\N	\N	\N	126141	126141	293823
16191	20818	1	applied	\N	\N	\N	\N	126142	126142	293824
16191	20819	2	applied	\N	\N	\N	\N	126143	126143	293825
16191	20821	4	applied	\N	\N	\N	\N	126145	126145	293827
16191	20822	5	applied	\N	\N	\N	\N	126146	126146	293828
16191	20823	6	applied	\N	\N	\N	\N	126147	126147	293829
16197	20845	0	applied	\N	\N	\N	\N	126173	126173	293855
16197	20846	1	applied	\N	\N	\N	\N	126174	126174	293856
16197	20847	2	applied	\N	\N	\N	\N	126175	126175	293857
16201	20848	0	applied	\N	\N	\N	\N	126185	126185	293867
16201	20849	1	applied	\N	\N	\N	\N	126186	126186	293868
16201	20850	2	applied	\N	\N	\N	\N	126187	126187	293869
16218	20892	0	applied	\N	\N	\N	\N	126275	126275	293957
16218	20893	1	applied	\N	\N	\N	\N	126276	126276	293958
16218	20894	2	applied	\N	\N	\N	\N	126277	126277	293959
16218	20895	3	applied	\N	\N	\N	\N	126278	126278	293960
16220	20896	0	applied	\N	\N	\N	\N	126283	126283	293965
16220	20897	1	applied	\N	\N	\N	\N	126284	126284	293966
16220	20898	2	applied	\N	\N	\N	\N	126285	126285	293967
16223	20904	1	applied	\N	\N	\N	\N	126292	126292	293974
16223	20905	2	applied	\N	\N	\N	\N	126293	126293	293975
16223	20902	4	applied	\N	\N	\N	\N	126294	126294	293976
16223	20906	5	applied	\N	\N	\N	\N	126295	126295	293977
16223	20903	6	applied	\N	\N	\N	\N	126296	126296	293978
16223	20907	7	applied	\N	\N	\N	\N	126297	126297	293979
16227	20915	0	applied	\N	\N	\N	\N	126316	126316	293998
16227	20916	1	applied	\N	\N	\N	\N	126317	126317	293999
16227	20917	2	applied	\N	\N	\N	\N	126318	126318	294000
16227	20918	3	applied	\N	\N	\N	\N	126319	126319	294001
16227	20919	4	applied	\N	\N	\N	\N	126320	126320	294002
16227	20920	5	applied	\N	\N	\N	\N	126321	126321	294003
16227	20921	6	applied	\N	\N	\N	\N	126322	126322	294004
16233	20931	0	applied	\N	\N	\N	\N	126345	126345	294027
16233	20932	1	applied	\N	\N	\N	\N	126346	126346	294028
16233	20933	2	applied	\N	\N	\N	\N	126347	126347	294029
16235	20858	1	applied	\N	\N	1000000000	\N	126352	126352	294034
16235	20859	2	applied	\N	\N	1000000000	\N	126353	126353	294035
16235	20860	3	applied	\N	\N	1000000000	\N	126354	126354	294036
16235	20934	4	applied	\N	\N	\N	\N	126355	126355	294037
16235	20814	6	applied	\N	\N	1000000000	\N	126357	126357	294038
16235	20806	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	126356	126356	\N
16153	20755	0	applied	\N	\N	\N	\N	125832	125832	293520
16153	20756	1	applied	\N	\N	\N	\N	125833	125833	293521
16175	20730	29	applied	\N	\N	\N	\N	125957	125957	293645
16175	20731	30	applied	\N	\N	\N	\N	125958	125958	293646
16175	20736	31	applied	\N	\N	\N	\N	125959	125959	293647
16175	20739	32	applied	\N	\N	\N	\N	125960	125960	293648
16175	20742	33	applied	\N	\N	\N	\N	125961	125961	293649
16175	20743	34	applied	\N	\N	\N	\N	125962	125962	293650
16175	20748	35	applied	\N	\N	\N	\N	125963	125963	293651
16175	20751	36	applied	\N	\N	\N	\N	125964	125964	293652
16175	20755	37	applied	\N	\N	\N	\N	125965	125965	293653
16175	20758	38	applied	\N	\N	\N	\N	125966	125966	293654
16175	20761	39	applied	\N	\N	\N	\N	125967	125967	293655
16175	20764	40	applied	\N	\N	\N	\N	125968	125968	293656
16175	20768	41	applied	\N	\N	\N	\N	125969	125969	293657
16175	20774	43	applied	\N	\N	\N	\N	125971	125971	293659
16175	20778	44	applied	\N	\N	\N	\N	125972	125972	293660
16175	20781	45	applied	\N	\N	\N	\N	125973	125973	293661
16175	20784	46	applied	\N	\N	\N	\N	125974	125974	293662
16175	20539	47	applied	\N	\N	\N	\N	125975	125975	293663
16175	20551	48	applied	\N	\N	\N	\N	125976	125976	293664
16175	20561	49	applied	\N	\N	\N	\N	125977	125977	293665
16175	20572	50	applied	\N	\N	\N	\N	125978	125978	293666
16175	20583	51	applied	\N	\N	\N	\N	125979	125979	293667
16175	20469	52	applied	\N	\N	\N	\N	125980	125980	293668
16175	20470	53	applied	\N	\N	\N	\N	125981	125981	293669
16175	20473	54	applied	\N	\N	\N	\N	125982	125982	293670
16175	20477	55	applied	\N	\N	\N	\N	125983	125983	293671
16175	20610	56	applied	\N	\N	\N	\N	125984	125984	293672
16175	20535	58	applied	\N	\N	\N	\N	125985	125985	293673
16175	20536	59	applied	\N	\N	\N	\N	125986	125986	293674
16175	20544	61	applied	\N	\N	\N	\N	125988	125988	293676
16175	20545	62	applied	\N	\N	\N	\N	125989	125989	293677
16175	20550	63	applied	\N	\N	\N	\N	125990	125990	293678
16175	20556	64	applied	\N	\N	\N	\N	125991	125991	293679
16175	20557	65	applied	\N	\N	\N	\N	125992	125992	293680
16175	20560	66	applied	\N	\N	\N	\N	125993	125993	293681
16175	20565	67	applied	\N	\N	\N	\N	125994	125994	293682
16175	20566	68	applied	\N	\N	\N	\N	125995	125995	293683
16175	20571	69	applied	\N	\N	\N	\N	125996	125996	293684
16175	20575	70	applied	\N	\N	\N	\N	125997	125997	293685
16175	20580	71	applied	\N	\N	\N	\N	125998	125998	293686
16175	20582	72	applied	\N	\N	\N	\N	125999	125999	293687
16175	20586	73	applied	\N	\N	\N	\N	126000	126000	293688
16175	20588	74	applied	\N	\N	\N	\N	126001	126001	293689
16175	20596	75	applied	\N	\N	\N	\N	126002	126002	293690
16175	20597	76	applied	\N	\N	\N	\N	126003	126003	293691
16175	20599	78	applied	\N	\N	\N	\N	126005	126005	293693
16175	20600	79	applied	\N	\N	\N	\N	126006	126006	293694
16175	20608	80	applied	\N	\N	\N	\N	126007	126007	293695
16175	20609	81	applied	\N	\N	\N	\N	126008	126008	293696
16175	20614	82	applied	\N	\N	\N	\N	126009	126009	293697
16175	20616	83	applied	\N	\N	\N	\N	126010	126010	293698
16175	20620	84	applied	\N	\N	\N	\N	126011	126011	293699
16175	20624	85	applied	\N	\N	\N	\N	126012	126012	293700
16175	20630	86	applied	\N	\N	\N	\N	126013	126013	293701
16175	20631	87	applied	\N	\N	\N	\N	126014	126014	293702
16175	20633	88	applied	\N	\N	\N	\N	126015	126015	293703
16175	20636	89	applied	\N	\N	\N	\N	126016	126016	293704
16175	20641	90	applied	\N	\N	\N	\N	126017	126017	293705
16175	20644	91	applied	\N	\N	\N	\N	126018	126018	293706
16175	20645	92	applied	\N	\N	\N	\N	126019	126019	293707
16175	20651	93	applied	\N	\N	\N	\N	126020	126020	293708
16175	20483	95	applied	\N	\N	\N	\N	126022	126022	293710
16175	20484	96	applied	\N	\N	\N	\N	126023	126023	293711
16175	20487	97	applied	\N	\N	\N	\N	126024	126024	293712
16175	20491	98	applied	\N	\N	\N	\N	126025	126025	293713
16175	20494	99	applied	\N	\N	\N	\N	126026	126026	293714
16235	20826	7	applied	\N	\N	\N	\N	126358	126358	294039
16235	20851	8	applied	\N	\N	\N	\N	126359	126359	294040
16235	20863	9	applied	\N	\N	\N	\N	126360	126360	294041
16235	20864	10	applied	\N	\N	\N	\N	126361	126361	294042
16235	20865	11	applied	\N	\N	\N	\N	126362	126362	294043
16235	20866	12	applied	\N	\N	\N	\N	126363	126363	294044
16235	20910	13	applied	\N	\N	1000000000	\N	126364	126364	294045
16238	20938	0	applied	\N	\N	\N	\N	126374	126374	294055
16238	20939	1	applied	\N	\N	\N	\N	126375	126375	294056
16238	20940	2	applied	\N	\N	\N	\N	126376	126376	294057
16238	20941	3	applied	\N	\N	\N	\N	126377	126377	294058
16240	20899	0	applied	\N	\N	\N	\N	126440	126440	294121
16240	20901	1	applied	\N	\N	\N	\N	126441	126441	294122
16240	20904	2	applied	\N	\N	\N	\N	126442	126442	294123
16240	20908	3	applied	\N	\N	\N	\N	126443	126443	294124
16240	20912	4	applied	\N	\N	\N	\N	126444	126444	294125
16240	20915	5	applied	\N	\N	\N	\N	126445	126445	294126
16240	20916	6	applied	\N	\N	\N	\N	126446	126446	294127
16240	20922	8	applied	\N	\N	\N	\N	126447	126447	294128
16240	20925	9	applied	\N	\N	\N	\N	126448	126448	294129
16240	20929	10	applied	\N	\N	\N	\N	126449	126449	294130
16240	20931	11	applied	\N	\N	\N	\N	126450	126450	294131
16240	20935	12	applied	\N	\N	\N	\N	126451	126451	294132
16240	20938	13	applied	\N	\N	\N	\N	126452	126452	294133
16240	20934	14	applied	\N	\N	\N	\N	126453	126453	294134
16240	20939	15	applied	\N	\N	\N	\N	126454	126454	294135
16240	20900	16	applied	\N	\N	\N	\N	126455	126455	294136
16240	20910	18	applied	\N	\N	1000000000	\N	126457	126457	294138
16240	20902	19	applied	\N	\N	\N	\N	126458	126458	294139
16240	20906	20	applied	\N	\N	\N	\N	126459	126459	294140
16240	20911	21	applied	\N	\N	\N	\N	126460	126460	294141
16240	20913	22	applied	\N	\N	\N	\N	126461	126461	294142
16240	20918	23	applied	\N	\N	\N	\N	126462	126462	294143
16240	20919	24	applied	\N	\N	\N	\N	126463	126463	294144
16240	20924	25	applied	\N	\N	\N	\N	126464	126464	294145
16240	20921	26	applied	\N	\N	\N	\N	126465	126465	294146
16240	20927	27	applied	\N	\N	\N	\N	126466	126466	294147
16240	20903	28	applied	\N	\N	\N	\N	126467	126467	294148
16242	20943	0	applied	\N	\N	\N	\N	126471	126471	294152
16242	20944	1	applied	\N	\N	\N	\N	126472	126472	294153
16242	20945	2	applied	\N	\N	\N	\N	126473	126473	294154
16244	20949	0	applied	\N	\N	\N	\N	126477	126477	294158
16244	20950	1	applied	\N	\N	\N	\N	126478	126478	294159
16175	20724	27	applied	\N	\N	\N	\N	125955	125955	293643
16175	20725	28	applied	\N	\N	\N	\N	125956	125956	293644
16175	20505	103	applied	\N	\N	\N	\N	126030	126030	293718
16175	20510	104	applied	\N	\N	\N	\N	126031	126031	293719
16175	20513	105	applied	\N	\N	\N	\N	126032	126032	293720
16175	20515	106	applied	\N	\N	\N	\N	126033	126033	293721
16175	20519	107	applied	\N	\N	\N	\N	126034	126034	293722
16175	20523	108	applied	\N	\N	\N	\N	126035	126035	293723
16175	20526	109	applied	\N	\N	\N	\N	126036	126036	293724
16175	20530	110	applied	\N	\N	\N	\N	126037	126037	293725
16175	20534	112	applied	\N	\N	\N	\N	126039	126039	293727
16175	20540	113	applied	\N	\N	\N	\N	126040	126040	293728
16175	20546	114	applied	\N	\N	\N	\N	126041	126041	293729
16175	20547	115	applied	\N	\N	\N	\N	126042	126042	293730
16175	20549	116	applied	\N	\N	\N	\N	126043	126043	293731
16175	20554	117	applied	\N	\N	\N	\N	126044	126044	293732
16175	20555	118	applied	\N	\N	\N	\N	126045	126045	293733
16175	20559	119	applied	\N	\N	\N	\N	126046	126046	293734
16175	20567	120	applied	\N	\N	\N	\N	126047	126047	293735
16175	20568	121	applied	\N	\N	\N	\N	126048	126048	293736
16175	20573	122	applied	\N	\N	\N	\N	126049	126049	293737
16175	20574	123	applied	\N	\N	\N	\N	126050	126050	293738
16175	20577	124	applied	\N	\N	\N	\N	126051	126051	293739
16175	20579	125	applied	\N	\N	\N	\N	126052	126052	293740
16178	20793	0	applied	\N	\N	\N	\N	126059	126059	293747
16178	20794	1	applied	\N	\N	\N	\N	126060	126060	293748
16180	20796	0	applied	\N	\N	\N	\N	126066	126066	293754
16180	20797	1	applied	\N	\N	\N	\N	126067	126067	293755
16180	20798	2	applied	\N	\N	\N	\N	126068	126068	293756
16180	20799	3	applied	\N	\N	\N	\N	126069	126069	293757
16182	20807	5	applied	\N	\N	\N	\N	126077	126077	293764
16182	20808	6	applied	\N	\N	\N	\N	126078	126078	293765
16182	20809	7	applied	\N	\N	\N	\N	126079	126079	293766
16182	20810	8	applied	\N	\N	\N	\N	126080	126080	293767
16182	20811	9	applied	\N	\N	\N	\N	126081	126081	293768
16182	20812	10	applied	\N	\N	\N	\N	126082	126082	293769
16184	20802	0	applied	\N	\N	\N	\N	126094	126094	293780
16184	20803	1	applied	\N	\N	\N	\N	126095	126095	293781
16184	20804	2	applied	\N	\N	\N	\N	126096	126096	293782
16184	20805	3	applied	\N	\N	\N	\N	126097	126097	293783
16184	20807	5	applied	\N	\N	\N	\N	126099	126099	293784
16184	20808	6	applied	\N	\N	\N	\N	126100	126100	293785
16184	20809	7	applied	\N	\N	\N	\N	126101	126101	293786
16184	20810	8	applied	\N	\N	\N	\N	126102	126102	293787
16184	20811	9	applied	\N	\N	\N	\N	126103	126103	293788
16184	20812	10	applied	\N	\N	\N	\N	126104	126104	293789
16185	20802	0	applied	\N	\N	\N	\N	126105	126105	293790
16185	20803	1	applied	\N	\N	\N	\N	126106	126106	293791
16185	20804	2	applied	\N	\N	\N	\N	126107	126107	293792
16185	20805	3	applied	\N	\N	\N	\N	126108	126108	293793
16185	20807	5	applied	\N	\N	\N	\N	126110	126110	293794
16185	20808	6	applied	\N	\N	\N	\N	126111	126111	293795
16185	20809	7	applied	\N	\N	\N	\N	126112	126112	293796
16185	20810	8	applied	\N	\N	\N	\N	126113	126113	293797
16185	20811	9	applied	\N	\N	\N	\N	126114	126114	293798
16185	20812	10	applied	\N	\N	\N	\N	126115	126115	293799
16187	20813	0	applied	\N	\N	\N	\N	126127	126127	293810
16187	20814	1	applied	\N	\N	1000000000	\N	126128	126128	293811
16194	20835	0	applied	\N	\N	\N	\N	126159	126159	293841
16194	20836	1	applied	\N	\N	\N	\N	126160	126160	293842
16194	20837	2	applied	\N	\N	\N	\N	126161	126161	293843
16194	20838	3	applied	\N	\N	\N	\N	126162	126162	293844
16194	20839	4	applied	\N	\N	\N	\N	126163	126163	293845
16194	20840	5	applied	\N	\N	\N	\N	126164	126164	293846
16196	20841	0	applied	\N	\N	\N	\N	126169	126169	293851
16196	20843	2	applied	\N	\N	\N	\N	126171	126171	293853
16196	20844	3	applied	\N	\N	\N	\N	126172	126172	293854
16199	20845	0	applied	\N	\N	\N	\N	126179	126179	293861
16199	20846	1	applied	\N	\N	\N	\N	126180	126180	293862
16199	20847	2	applied	\N	\N	\N	\N	126181	126181	293863
16203	20848	0	applied	\N	\N	\N	\N	126190	126190	293872
16203	20849	1	applied	\N	\N	\N	\N	126191	126191	293873
16203	20850	2	applied	\N	\N	\N	\N	126192	126192	293874
16206	20851	0	applied	\N	\N	\N	\N	126205	126205	293887
16206	20848	1	applied	\N	\N	\N	\N	126206	126206	293888
16206	20852	2	applied	\N	\N	\N	\N	126207	126207	293889
16206	20853	3	applied	\N	\N	\N	\N	126208	126208	293890
16206	20854	4	applied	\N	\N	\N	\N	126209	126209	293891
16206	20855	5	applied	\N	\N	\N	\N	126210	126210	293892
16210	20858	1	applied	\N	\N	1000000000	\N	126229	126229	293911
16210	20859	2	applied	\N	\N	1000000000	\N	126230	126230	293912
16210	20860	3	applied	\N	\N	1000000000	\N	126231	126231	293913
16210	20826	4	applied	\N	\N	\N	\N	126232	126232	293914
16210	20851	5	applied	\N	\N	\N	\N	126233	126233	293915
16210	20863	6	applied	\N	\N	\N	\N	126234	126234	293916
16210	20864	7	applied	\N	\N	\N	\N	126235	126235	293917
16210	20865	8	applied	\N	\N	\N	\N	126236	126236	293918
16210	20866	9	applied	\N	\N	\N	\N	126237	126237	293919
16213	20877	0	applied	\N	\N	\N	\N	126250	126250	293932
16213	20878	1	applied	\N	\N	\N	\N	126251	126251	293933
16213	20879	2	applied	\N	\N	\N	\N	126252	126252	293934
16213	20882	3	applied	\N	\N	\N	\N	126253	126253	293935
16213	20880	4	applied	\N	\N	\N	\N	126254	126254	293936
16213	20881	5	applied	\N	\N	\N	\N	126255	126255	293937
16215	20883	0	applied	\N	\N	\N	\N	126263	126263	293945
16215	20884	1	applied	\N	\N	\N	\N	126264	126264	293946
16215	20885	2	applied	\N	\N	\N	\N	126265	126265	293947
16215	20886	3	applied	\N	\N	\N	\N	126266	126266	293948
16215	20887	4	applied	\N	\N	\N	\N	126267	126267	293949
16222	20901	0	applied	\N	\N	\N	\N	126288	126288	293970
16222	20902	1	applied	\N	\N	\N	\N	126289	126289	293971
16222	20903	2	applied	\N	\N	\N	\N	126290	126290	293972
16225	20912	0	applied	\N	\N	\N	\N	126306	126306	293988
16225	20913	1	applied	\N	\N	\N	\N	126307	126307	293989
16225	20914	2	applied	\N	\N	\N	\N	126308	126308	293990
16226	20915	0	applied	\N	\N	\N	\N	126309	126309	293991
16226	20916	1	applied	\N	\N	\N	\N	126310	126310	293992
16226	20917	2	applied	\N	\N	\N	\N	126311	126311	293993
16226	20918	3	applied	\N	\N	\N	\N	126312	126312	293994
16226	20919	4	applied	\N	\N	\N	\N	126313	126313	293995
16175	20498	101	applied	\N	\N	\N	\N	126028	126028	293716
16175	20503	102	applied	\N	\N	\N	\N	126029	126029	293717
16192	20825	1	applied	\N	\N	\N	\N	126149	126149	293831
16192	20826	2	applied	\N	\N	\N	\N	126150	126150	293832
16192	20827	3	applied	\N	\N	\N	\N	126151	126151	293833
16192	20828	4	applied	\N	\N	\N	\N	126152	126152	293834
16192	20829	5	applied	\N	\N	\N	\N	126153	126153	293835
16192	20830	6	applied	\N	\N	\N	\N	126154	126154	293836
16195	20841	0	applied	\N	\N	\N	\N	126165	126165	293847
16195	20842	1	applied	\N	\N	\N	\N	126166	126166	293848
16195	20843	2	applied	\N	\N	\N	\N	126167	126167	293849
16198	20845	0	applied	\N	\N	\N	\N	126176	126176	293858
16198	20846	1	applied	\N	\N	\N	\N	126177	126177	293859
16198	20847	2	applied	\N	\N	\N	\N	126178	126178	293860
16204	20851	0	applied	\N	\N	\N	\N	126193	126193	293875
16204	20848	1	applied	\N	\N	\N	\N	126194	126194	293876
16204	20852	2	applied	\N	\N	\N	\N	126195	126195	293877
16204	20853	3	applied	\N	\N	\N	\N	126196	126196	293878
16204	20854	4	applied	\N	\N	\N	\N	126197	126197	293879
16204	20855	5	applied	\N	\N	\N	\N	126198	126198	293880
16207	20848	0	applied	\N	\N	\N	\N	126211	126211	293893
16207	20852	1	applied	\N	\N	\N	\N	126212	126212	293894
16207	20855	2	applied	\N	\N	\N	\N	126213	126213	293895
16208	20856	0	applied	\N	\N	\N	\N	126214	126214	293896
16208	20857	1	applied	\N	\N	1000000000	\N	126215	126215	293897
16208	20859	3	applied	\N	\N	1000000000	\N	126217	126217	293899
16208	20860	4	applied	\N	\N	1000000000	\N	126218	126218	293900
16208	20861	5	applied	\N	\N	\N	\N	126219	126219	293901
16208	20862	6	applied	\N	\N	\N	\N	126220	126220	293902
16208	20863	7	applied	\N	\N	\N	\N	126221	126221	293903
16208	20864	8	applied	\N	\N	\N	\N	126222	126222	293904
16208	20865	9	applied	\N	\N	\N	\N	126223	126223	293905
16208	20866	10	applied	\N	\N	\N	\N	126224	126224	293906
16211	20870	0	applied	\N	\N	\N	\N	126238	126238	293920
16211	20871	1	applied	\N	\N	\N	\N	126239	126239	293921
16211	20872	2	applied	\N	\N	\N	\N	126240	126240	293922
16211	20873	3	applied	\N	\N	\N	\N	126241	126241	293923
16211	20874	4	applied	\N	\N	\N	\N	126242	126242	293924
16211	20875	5	applied	\N	\N	\N	\N	126243	126243	293925
16211	20876	6	applied	\N	\N	\N	\N	126244	126244	293926
16216	20889	0	applied	\N	\N	\N	\N	126269	126269	293951
16216	20890	1	applied	\N	\N	\N	\N	126270	126270	293952
16216	20891	2	applied	\N	\N	\N	\N	126271	126271	293953
16221	20899	0	applied	\N	\N	\N	\N	126286	126286	293968
16221	20900	1	applied	\N	\N	\N	\N	126287	126287	293969
16226	20921	6	applied	\N	\N	\N	\N	126315	126315	293997
16228	20912	0	applied	\N	\N	\N	\N	126323	126323	294005
16228	20915	1	applied	\N	\N	\N	\N	126324	126324	294006
16228	20916	2	applied	\N	\N	\N	\N	126325	126325	294007
16228	20913	3	applied	\N	\N	\N	\N	126326	126326	294008
16228	20918	4	applied	\N	\N	\N	\N	126327	126327	294009
16228	20919	5	applied	\N	\N	\N	\N	126328	126328	294010
16228	20921	6	applied	\N	\N	\N	\N	126329	126329	294011
16228	20914	7	applied	\N	\N	\N	\N	126330	126330	294012
16228	20917	8	applied	\N	\N	\N	\N	126331	126331	294013
16228	20920	9	applied	\N	\N	\N	\N	126332	126332	294014
16230	20925	0	applied	\N	\N	\N	\N	126336	126336	294018
16230	20926	1	applied	\N	\N	\N	\N	126337	126337	294019
16230	20927	2	applied	\N	\N	\N	\N	126338	126338	294020
16230	20928	3	applied	\N	\N	\N	\N	126339	126339	294021
16231	20929	0	applied	\N	\N	\N	\N	126340	126340	294022
16234	20931	0	applied	\N	\N	\N	\N	126348	126348	294030
16234	20932	1	applied	\N	\N	\N	\N	126349	126349	294031
16234	20933	2	applied	\N	\N	\N	\N	126350	126350	294032
16237	20938	0	applied	\N	\N	\N	\N	126369	126369	294050
16237	20939	1	applied	\N	\N	\N	\N	126370	126370	294051
16237	20940	2	applied	\N	\N	\N	\N	126371	126371	294052
16237	20941	3	applied	\N	\N	\N	\N	126372	126372	294053
16237	20942	4	applied	\N	\N	\N	\N	126373	126373	294054
16241	20943	0	applied	\N	\N	\N	\N	126468	126468	294149
16241	20944	1	applied	\N	\N	\N	\N	126469	126469	294150
16241	20945	2	applied	\N	\N	\N	\N	126470	126470	294151
16246	20953	0	applied	\N	\N	\N	\N	126485	126485	294166
16246	20954	1	applied	\N	\N	\N	\N	126486	126486	294167
16247	20953	0	applied	\N	\N	\N	\N	126487	126487	294168
16247	20954	1	applied	\N	\N	\N	\N	126488	126488	294169
16250	20953	0	applied	\N	\N	\N	\N	126493	126493	294174
16252	20955	0	applied	\N	\N	\N	\N	126497	126497	294178
16252	20956	1	applied	\N	\N	\N	\N	126498	126498	294179
16252	20957	2	applied	\N	\N	\N	\N	126499	126499	294180
16255	20965	0	applied	\N	\N	\N	\N	126507	126507	294188
16255	20966	1	applied	\N	\N	\N	\N	126508	126508	294189
16255	20967	2	applied	\N	\N	\N	\N	126509	126509	294190
16259	20968	0	applied	\N	\N	\N	\N	126641	126641	294322
16259	20969	1	applied	\N	\N	\N	\N	126642	126642	294323
16259	20970	2	applied	\N	\N	\N	\N	126643	126643	294324
16260	20968	0	applied	\N	\N	\N	\N	126644	126644	294325
16260	20969	1	applied	\N	\N	\N	\N	126645	126645	294326
16260	20970	2	applied	\N	\N	\N	\N	126646	126646	294327
16263	20978	0	applied	\N	\N	\N	\N	126659	126659	294340
16263	20979	1	applied	\N	\N	\N	\N	126660	126660	294341
16263	20980	2	applied	\N	\N	\N	\N	126661	126661	294342
16263	20981	3	applied	\N	\N	\N	\N	126662	126662	294343
16263	20983	5	applied	\N	\N	\N	\N	126664	126664	294345
16263	20984	6	applied	\N	\N	\N	\N	126665	126665	294346
16268	20988	0	applied	\N	\N	\N	\N	126672	126672	294353
16269	20995	0	applied	\N	\N	\N	\N	126679	126679	294360
16269	20996	1	applied	\N	\N	\N	\N	126680	126680	294361
16269	20997	2	applied	\N	\N	\N	\N	126681	126681	294362
16270	20998	0	applied	\N	\N	\N	\N	126682	126682	294363
16270	20999	1	applied	\N	\N	\N	\N	126683	126683	294364
16270	21000	2	applied	\N	\N	\N	\N	126684	126684	294365
16270	21001	3	applied	\N	\N	\N	\N	126685	126685	294366
16270	21002	4	applied	\N	\N	\N	\N	126686	126686	294367
16270	21003	5	applied	\N	\N	\N	\N	126687	126687	294368
16270	21004	6	applied	\N	\N	\N	\N	126688	126688	294369
16270	21005	7	applied	\N	\N	\N	\N	126689	126689	294370
16270	21006	8	applied	\N	\N	\N	\N	126690	126690	126690
16270	21007	9	applied	\N	\N	\N	\N	126691	126691	294371
16270	21009	11	applied	\N	\N	\N	\N	126693	126693	294373
16270	21010	12	applied	\N	\N	\N	\N	126694	126694	294374
16187	20816	3	applied	\N	\N	\N	\N	126130	126130	293813
16192	20824	0	applied	\N	\N	\N	\N	126148	126148	293830
16239	20856	15	applied	\N	\N	\N	\N	126394	126394	294075
16239	20867	16	applied	\N	\N	\N	\N	126395	126395	294076
16239	20870	17	applied	\N	\N	\N	\N	126396	126396	294077
16239	20871	18	applied	\N	\N	\N	\N	126397	126397	294078
16239	20877	19	applied	\N	\N	\N	\N	126398	126398	294079
16239	20878	20	applied	\N	\N	\N	\N	126399	126399	294080
16239	20883	21	applied	\N	\N	\N	\N	126400	126400	294081
16239	20889	23	applied	\N	\N	\N	\N	126402	126402	294083
16239	20892	24	applied	\N	\N	\N	\N	126403	126403	294084
16239	20896	25	applied	\N	\N	\N	\N	126404	126404	294085
16239	20899	26	applied	\N	\N	\N	\N	126405	126405	294086
16239	20901	27	applied	\N	\N	\N	\N	126406	126406	294087
16239	20904	28	applied	\N	\N	\N	\N	126407	126407	294088
16239	20908	29	applied	\N	\N	\N	\N	126408	126408	294089
16239	20912	30	applied	\N	\N	\N	\N	126409	126409	294090
16239	20915	31	applied	\N	\N	\N	\N	126410	126410	294091
16239	20916	32	applied	\N	\N	\N	\N	126411	126411	294092
16239	20922	33	applied	\N	\N	\N	\N	126412	126412	294093
16239	20925	34	applied	\N	\N	\N	\N	126413	126413	294094
16239	20929	35	applied	\N	\N	\N	\N	126414	126414	294095
16239	20931	36	applied	\N	\N	\N	\N	126415	126415	294096
16239	20935	37	applied	\N	\N	\N	\N	126416	126416	294097
16239	20938	38	applied	\N	\N	\N	\N	126417	126417	294098
16239	20939	40	applied	\N	\N	\N	\N	126419	126419	294100
16239	20826	41	applied	\N	\N	\N	\N	126420	126420	294101
16239	20851	42	applied	\N	\N	\N	\N	126421	126421	294102
16239	20819	43	applied	\N	\N	\N	\N	126422	126422	294103
16239	20833	44	applied	\N	\N	\N	\N	126423	126423	294104
16239	20843	45	applied	\N	\N	\N	\N	126424	126424	294105
16239	20853	46	applied	\N	\N	\N	\N	126425	126425	294106
16239	20872	47	applied	\N	\N	\N	\N	126426	126426	294107
16239	20885	48	applied	\N	\N	\N	\N	126427	126427	294108
16239	20893	49	applied	\N	\N	\N	\N	126428	126428	294109
16239	20905	50	applied	\N	\N	\N	\N	126429	126429	294110
16239	20863	51	applied	\N	\N	\N	\N	126430	126430	294111
16239	20864	52	applied	\N	\N	\N	\N	126431	126431	294112
16239	20865	53	applied	\N	\N	\N	\N	126432	126432	294113
16239	20866	54	applied	\N	\N	\N	\N	126433	126433	294114
16239	20921	56	applied	\N	\N	\N	\N	126435	126435	294116
16239	20927	57	applied	\N	\N	\N	\N	126436	126436	294117
16239	20820	58	applied	\N	\N	\N	\N	126437	126437	294118
16239	20822	59	applied	\N	\N	\N	\N	126438	126438	294119
16239	20942	60	applied	\N	\N	\N	\N	126439	126439	294120
16243	20946	0	applied	\N	\N	\N	\N	126474	126474	294155
16243	20947	1	applied	\N	\N	\N	\N	126475	126475	294156
16243	20948	2	applied	\N	\N	\N	\N	126476	126476	294157
16244	20952	3	applied	\N	\N	\N	\N	126480	126480	294161
16245	20949	0	applied	\N	\N	\N	\N	126481	126481	294162
16245	20950	1	applied	\N	\N	\N	\N	126482	126482	294163
16245	20951	2	applied	\N	\N	\N	\N	126483	126483	294164
16245	20952	3	applied	\N	\N	\N	\N	126484	126484	294165
16248	20953	0	applied	\N	\N	\N	\N	126489	126489	294170
16248	20954	1	applied	\N	\N	\N	\N	126490	126490	294171
16249	20953	0	applied	\N	\N	\N	\N	126491	126491	294172
16249	20954	1	applied	\N	\N	\N	\N	126492	126492	294173
16251	20953	0	applied	\N	\N	\N	\N	126495	126495	294176
16251	20954	1	applied	\N	\N	\N	\N	126496	126496	294177
16253	20959	1	applied	\N	\N	\N	\N	126501	126501	294182
16253	20960	2	applied	\N	\N	\N	\N	126502	126502	294183
16253	20961	3	applied	\N	\N	\N	\N	126503	126503	294184
16254	20962	0	applied	\N	\N	\N	\N	126504	126504	294185
16254	20963	1	applied	\N	\N	\N	\N	126505	126505	294186
16254	20964	2	applied	\N	\N	\N	\N	126506	126506	294187
16256	20965	0	applied	\N	\N	\N	\N	126510	126510	294191
16256	20966	1	applied	\N	\N	\N	\N	126511	126511	294192
16256	20967	2	applied	\N	\N	\N	\N	126512	126512	294193
16257	20965	0	applied	\N	\N	\N	\N	126513	126513	294194
16257	20966	1	applied	\N	\N	\N	\N	126514	126514	294195
16257	20967	2	applied	\N	\N	\N	\N	126515	126515	294196
16258	20857	0	applied	\N	\N	1000000000	\N	126516	126516	294197
16258	20511	1	applied	\N	\N	\N	\N	126517	126517	294198
16258	20514	3	applied	\N	\N	\N	\N	126519	126519	294200
16258	20518	4	applied	\N	\N	\N	\N	126520	126520	294201
16258	20521	5	applied	\N	\N	\N	\N	126521	126521	294202
16258	20524	6	applied	\N	\N	\N	\N	126522	126522	294203
16258	20859	7	applied	\N	\N	1000000000	\N	126523	126523	294204
16258	20860	8	applied	\N	\N	1000000000	\N	126524	126524	294205
16258	20528	9	applied	\N	\N	\N	\N	126525	126525	294206
16258	20531	10	applied	\N	\N	\N	\N	126526	126526	294207
16258	20532	11	applied	\N	\N	\N	\N	126527	126527	294208
16258	20537	12	applied	\N	\N	\N	\N	126528	126528	294209
16258	20541	13	applied	\N	\N	\N	\N	126529	126529	294210
16258	20542	14	applied	\N	\N	\N	\N	126530	126530	294211
16258	20548	15	applied	\N	\N	\N	\N	126531	126531	294212
16258	20552	16	applied	\N	\N	\N	\N	126532	126532	294213
16258	20553	17	applied	\N	\N	\N	\N	126533	126533	294214
16258	20558	18	applied	\N	\N	\N	\N	126534	126534	294215
16258	20562	19	applied	\N	\N	\N	\N	126535	126535	294216
16258	20563	20	applied	\N	\N	\N	\N	126536	126536	294217
16258	20569	21	applied	\N	\N	\N	\N	126537	126537	294218
16258	20570	22	applied	\N	\N	\N	\N	126538	126538	294219
16258	20578	24	applied	\N	\N	\N	\N	126540	126540	294221
16258	20581	25	applied	\N	\N	\N	\N	126541	126541	294222
16258	20584	26	applied	\N	\N	\N	\N	126542	126542	294223
16258	20587	27	applied	\N	\N	\N	\N	126543	126543	294224
16258	20590	28	applied	\N	\N	\N	\N	126544	126544	294225
16261	20971	0	applied	\N	\N	\N	\N	126647	126647	294328
16261	20972	1	applied	\N	\N	\N	\N	126648	126648	294329
16261	20973	2	applied	\N	\N	\N	\N	126649	126649	294330
16261	20974	3	applied	\N	\N	\N	\N	126650	126650	294331
16261	20975	4	applied	\N	\N	\N	\N	126651	126651	294332
16264	20985	0	applied	\N	\N	\N	\N	126666	126666	294347
16264	20986	1	applied	\N	\N	\N	\N	126667	126667	294348
16264	20987	2	applied	\N	\N	\N	\N	126668	126668	294349
16268	20989	1	applied	\N	\N	\N	\N	126673	126673	294354
16268	20990	2	applied	\N	\N	\N	\N	126674	126674	294355
16268	20991	3	applied	\N	\N	\N	\N	126675	126675	294356
16268	20993	5	applied	\N	\N	\N	\N	126677	126677	294358
16268	20994	6	applied	\N	\N	\N	\N	126678	126678	294359
16239	20848	13	applied	\N	\N	\N	\N	126392	126392	294073
16239	20852	14	applied	\N	\N	\N	\N	126393	126393	294074
16258	20595	33	applied	\N	\N	\N	\N	126549	126549	294230
16258	20612	34	applied	\N	\N	\N	\N	126550	126550	294231
16258	20613	35	applied	\N	\N	\N	\N	126551	126551	294232
16258	20619	36	applied	\N	\N	\N	\N	126552	126552	294233
16258	20622	37	applied	\N	\N	\N	\N	126553	126553	294234
16258	20626	38	applied	\N	\N	\N	\N	126554	126554	294235
16258	20627	39	applied	\N	\N	\N	\N	126555	126555	294236
16258	20632	40	applied	\N	\N	\N	\N	126556	126556	294237
16258	20635	41	applied	\N	\N	\N	\N	126557	126557	294238
16258	20639	42	applied	\N	\N	\N	\N	126558	126558	294239
16258	20642	43	applied	\N	\N	\N	\N	126559	126559	294240
16258	20643	44	applied	\N	\N	\N	\N	126560	126560	294241
16258	20649	45	applied	\N	\N	\N	\N	126561	126561	294242
16258	20652	46	applied	\N	\N	\N	\N	126562	126562	294243
16258	20655	47	applied	\N	\N	\N	\N	126563	126563	294244
16258	20659	48	applied	\N	\N	\N	\N	126564	126564	294245
16258	20661	50	applied	\N	\N	\N	\N	126566	126566	294247
16258	20662	51	applied	\N	\N	\N	\N	126567	126567	294248
16258	20672	52	applied	\N	\N	\N	\N	126568	126568	294249
16258	20675	53	applied	\N	\N	\N	\N	126569	126569	294250
16258	20678	55	applied	\N	\N	\N	\N	126570	126570	294251
16258	20682	56	applied	\N	\N	\N	\N	126571	126571	294252
16258	20683	57	applied	\N	\N	\N	\N	126572	126572	294253
16258	20688	58	applied	\N	\N	\N	\N	126573	126573	294254
16258	20692	59	applied	\N	\N	\N	\N	126574	126574	294255
16258	20695	60	applied	\N	\N	\N	\N	126575	126575	294256
16258	20698	61	applied	\N	\N	\N	\N	126576	126576	294257
16258	20699	62	applied	\N	\N	\N	\N	126577	126577	294258
16258	20705	63	applied	\N	\N	\N	\N	126578	126578	294259
16258	20708	64	applied	\N	\N	\N	\N	126579	126579	294260
16258	20712	65	applied	\N	\N	\N	\N	126580	126580	294261
16258	20715	66	applied	\N	\N	\N	\N	126581	126581	294262
16258	20718	68	applied	\N	\N	\N	\N	126583	126583	294264
16258	20724	69	applied	\N	\N	\N	\N	126584	126584	294265
16258	20725	70	applied	\N	\N	\N	\N	126585	126585	294266
16258	20730	71	applied	\N	\N	\N	\N	126586	126586	294267
16258	20731	72	applied	\N	\N	\N	\N	126587	126587	294268
16258	20736	73	applied	\N	\N	\N	\N	126588	126588	294269
16258	20739	74	applied	\N	\N	\N	\N	126589	126589	294270
16258	20742	75	applied	\N	\N	\N	\N	126590	126590	294271
16258	20743	76	applied	\N	\N	\N	\N	126591	126591	294272
16258	20748	77	applied	\N	\N	\N	\N	126592	126592	294273
16258	20751	78	applied	\N	\N	\N	\N	126593	126593	294274
16258	20755	79	applied	\N	\N	\N	\N	126594	126594	294275
16258	20758	80	applied	\N	\N	\N	\N	126595	126595	294276
16258	20761	81	applied	\N	\N	\N	\N	126596	126596	294277
16258	20764	82	applied	\N	\N	\N	\N	126597	126597	294278
16258	20768	83	applied	\N	\N	\N	\N	126598	126598	294279
16258	20774	85	applied	\N	\N	\N	\N	126600	126600	294281
16258	20778	86	applied	\N	\N	\N	\N	126601	126601	294282
16258	20781	87	applied	\N	\N	\N	\N	126602	126602	294283
16258	20784	88	applied	\N	\N	\N	\N	126603	126603	294284
16258	20788	89	applied	\N	\N	\N	\N	126604	126604	294285
16258	20790	90	applied	\N	\N	\N	\N	126605	126605	294286
16258	20793	91	applied	\N	\N	\N	\N	126606	126606	294287
16258	20796	92	applied	\N	\N	\N	\N	126607	126607	294288
16258	20802	93	applied	\N	\N	\N	\N	126608	126608	294289
16258	20803	94	applied	\N	\N	\N	\N	126609	126609	294290
16258	20804	95	applied	\N	\N	\N	\N	126610	126610	294291
16258	20813	96	applied	\N	\N	\N	\N	126611	126611	294292
16258	20817	97	applied	\N	\N	\N	\N	126612	126612	294293
16258	20818	98	applied	\N	\N	\N	\N	126613	126613	294294
16258	20824	99	applied	\N	\N	\N	\N	126614	126614	294295
16258	20825	100	applied	\N	\N	\N	\N	126615	126615	294296
16258	20835	102	applied	\N	\N	\N	\N	126617	126617	294298
16258	20836	103	applied	\N	\N	\N	\N	126618	126618	294299
16258	20841	104	applied	\N	\N	\N	\N	126619	126619	294300
16258	20845	105	applied	\N	\N	\N	\N	126620	126620	294301
16258	20848	106	applied	\N	\N	\N	\N	126621	126621	294302
16258	20852	107	applied	\N	\N	\N	\N	126622	126622	294303
16258	20856	108	applied	\N	\N	\N	\N	126623	126623	294304
16258	20867	109	applied	\N	\N	\N	\N	126624	126624	294305
16258	20870	110	applied	\N	\N	\N	\N	126625	126625	294306
16258	20871	111	applied	\N	\N	\N	\N	126626	126626	294307
16258	20877	112	applied	\N	\N	\N	\N	126627	126627	294308
16258	20878	113	applied	\N	\N	\N	\N	126628	126628	294309
16258	20883	114	applied	\N	\N	\N	\N	126629	126629	294310
16258	20884	115	applied	\N	\N	\N	\N	126630	126630	294311
16258	20889	116	applied	\N	\N	\N	\N	126631	126631	294312
16258	20892	117	applied	\N	\N	\N	\N	126632	126632	294313
16258	20899	119	applied	\N	\N	\N	\N	126634	126634	294315
16258	20901	120	applied	\N	\N	\N	\N	126635	126635	294316
16258	20904	121	applied	\N	\N	\N	\N	126636	126636	294317
16258	20908	122	applied	\N	\N	\N	\N	126637	126637	294318
16258	20912	123	applied	\N	\N	\N	\N	126638	126638	294319
16258	20915	124	applied	\N	\N	\N	\N	126639	126639	294320
16258	20916	125	applied	\N	\N	\N	\N	126640	126640	294321
16262	20971	0	applied	\N	\N	\N	\N	126652	126652	294333
16262	20972	1	applied	\N	\N	\N	\N	126653	126653	294334
16262	20973	2	applied	\N	\N	\N	\N	126654	126654	294335
16262	20974	3	applied	\N	\N	\N	\N	126655	126655	294336
16262	20976	4	applied	\N	\N	\N	\N	126656	126656	294337
16262	20975	5	applied	\N	\N	\N	\N	126657	126657	294338
16262	20977	6	applied	\N	\N	\N	\N	126658	126658	294339
16265	20985	0	applied	\N	\N	\N	\N	126669	126669	294350
16265	20986	1	applied	\N	\N	\N	\N	126670	126670	294351
16271	21011	0	applied	\N	\N	\N	\N	126695	126695	294375
16271	21012	1	applied	\N	\N	\N	\N	126696	126696	294376
16271	21013	2	applied	\N	\N	\N	\N	126697	126697	294377
16271	21014	3	applied	\N	\N	\N	\N	126698	126698	126698
16271	21015	4	applied	\N	\N	\N	\N	126699	126699	294378
16271	21016	5	applied	\N	\N	\N	\N	126700	126700	294379
16271	21017	6	applied	\N	\N	\N	\N	126701	126701	294380
16271	21018	7	applied	\N	\N	\N	\N	126702	126702	294381
16272	21011	0	applied	\N	\N	\N	\N	126703	126703	294382
16272	21012	1	applied	\N	\N	\N	\N	126704	126704	294383
16272	21013	2	applied	\N	\N	\N	\N	126705	126705	294384
16272	21014	3	applied	\N	\N	\N	\N	126706	126706	126706
16272	21015	4	applied	\N	\N	\N	\N	126707	126707	294385
16272	21016	5	applied	\N	\N	\N	\N	126708	126708	294386
16258	20592	30	applied	\N	\N	\N	\N	126546	126546	294227
16258	20593	31	applied	\N	\N	\N	\N	126547	126547	294228
16273	21012	1	applied	\N	\N	\N	\N	126712	126712	294390
16273	21013	2	applied	\N	\N	\N	\N	126713	126713	294391
16273	21014	3	applied	\N	\N	\N	\N	126714	126714	126714
16273	21015	4	applied	\N	\N	\N	\N	126715	126715	294392
16273	21016	5	applied	\N	\N	\N	\N	126716	126716	294393
16273	21017	6	applied	\N	\N	\N	\N	126717	126717	294394
16273	21018	7	applied	\N	\N	\N	\N	126718	126718	294395
16274	21020	1	applied	\N	\N	\N	\N	126720	126720	294397
16274	21021	2	applied	\N	\N	\N	\N	126721	126721	294398
16275	21022	0	applied	\N	\N	\N	\N	126722	126722	294399
16275	21023	1	applied	\N	\N	\N	\N	126723	126723	294400
16275	21024	2	applied	\N	\N	\N	\N	126724	126724	294401
16276	21025	0	applied	\N	\N	\N	\N	126725	126725	294402
16276	21026	1	applied	\N	\N	\N	\N	126726	126726	294403
16276	21027	2	applied	\N	\N	\N	\N	126727	126727	294404
16276	21028	3	applied	\N	\N	\N	\N	126728	126728	294405
16277	21025	0	applied	\N	\N	\N	\N	126729	126729	294406
16277	21026	1	applied	\N	\N	\N	\N	126730	126730	294407
16277	21027	2	applied	\N	\N	\N	\N	126731	126731	294408
16277	21028	3	applied	\N	\N	\N	\N	126732	126732	294409
16278	21025	0	applied	\N	\N	\N	\N	126733	126733	294410
16278	21026	1	applied	\N	\N	\N	\N	126734	126734	294411
16278	21027	2	applied	\N	\N	\N	\N	126735	126735	294412
16279	21025	0	applied	\N	\N	\N	\N	126737	126737	294414
16279	21026	1	applied	\N	\N	\N	\N	126738	126738	294415
16279	21027	2	applied	\N	\N	\N	\N	126739	126739	294416
16279	21028	3	applied	\N	\N	\N	\N	126740	126740	294417
16280	21025	0	applied	\N	\N	\N	\N	126741	126741	294418
16280	21026	1	applied	\N	\N	\N	\N	126742	126742	294419
16280	21027	2	applied	\N	\N	\N	\N	126743	126743	294420
16280	21028	3	applied	\N	\N	\N	\N	126744	126744	294421
16281	21029	0	applied	\N	\N	\N	\N	126745	126745	294422
16281	21030	1	applied	\N	\N	\N	\N	126746	126746	294423
16282	21029	0	applied	\N	\N	\N	\N	126747	126747	294424
16282	21030	1	applied	\N	\N	\N	\N	126748	126748	294425
16282	21031	2	applied	\N	\N	\N	\N	126749	126749	294426
16283	21029	0	applied	\N	\N	\N	\N	126750	126750	294427
16283	21030	1	applied	\N	\N	\N	\N	126751	126751	294428
16283	21031	2	applied	\N	\N	\N	\N	126752	126752	294429
16284	21030	1	applied	\N	\N	\N	\N	126754	126754	294431
16284	21031	2	applied	\N	\N	\N	\N	126755	126755	294432
16285	21029	0	applied	\N	\N	\N	\N	126756	126756	294433
16285	21030	1	applied	\N	\N	\N	\N	126757	126757	294434
16285	21031	2	applied	\N	\N	\N	\N	126758	126758	294435
16287	21032	0	applied	\N	\N	\N	\N	126759	126759	294436
16287	21033	1	applied	\N	\N	\N	\N	126760	126760	294437
16288	21032	0	applied	\N	\N	\N	\N	126761	126761	294438
16288	21034	1	applied	\N	\N	\N	\N	126762	126762	294439
16288	21033	2	applied	\N	\N	\N	\N	126763	126763	294440
16289	21032	0	applied	\N	\N	\N	\N	126764	126764	294441
16289	21034	1	applied	\N	\N	\N	\N	126765	126765	294442
16290	21032	0	applied	\N	\N	\N	\N	126766	126766	294443
16290	21034	1	applied	\N	\N	\N	\N	126767	126767	294444
16290	21033	2	applied	\N	\N	\N	\N	126768	126768	294445
16291	21035	0	applied	\N	\N	\N	\N	126769	126769	294446
16292	21037	0	applied	\N	\N	\N	\N	126771	126771	294448
16292	21038	1	applied	\N	\N	\N	\N	126772	126772	294449
16292	21039	2	applied	\N	\N	\N	\N	126773	126773	294450
16292	21040	3	applied	\N	\N	\N	\N	126774	126774	294451
16293	20922	0	applied	\N	\N	\N	\N	126775	126775	294452
16293	20925	1	applied	\N	\N	\N	\N	126776	126776	294453
16293	20929	2	applied	\N	\N	\N	\N	126777	126777	294454
16293	20931	3	applied	\N	\N	\N	\N	126778	126778	294455
16293	20935	4	applied	\N	\N	\N	\N	126779	126779	294456
16293	20938	5	applied	\N	\N	\N	\N	126780	126780	294457
16293	20943	6	applied	\N	\N	\N	\N	126781	126781	294458
16293	20946	7	applied	\N	\N	\N	\N	126782	126782	294459
16293	20949	8	applied	\N	\N	\N	\N	126783	126783	294460
16293	20953	9	applied	\N	\N	\N	\N	126784	126784	294461
16293	20955	10	applied	\N	\N	\N	\N	126785	126785	294462
16293	20958	11	applied	\N	\N	\N	\N	126786	126786	294463
16293	20965	13	applied	\N	\N	\N	\N	126788	126788	294465
16293	20968	14	applied	\N	\N	\N	\N	126789	126789	294466
16293	20971	15	applied	\N	\N	\N	\N	126790	126790	294467
16293	20972	16	applied	\N	\N	\N	\N	126791	126791	294468
16293	20978	17	applied	\N	\N	\N	\N	126792	126792	294469
16293	20979	18	applied	\N	\N	\N	\N	126793	126793	294470
16293	20985	19	applied	\N	\N	\N	\N	126794	126794	294471
16293	20988	20	applied	\N	\N	\N	\N	126795	126795	294472
16293	20989	21	applied	\N	\N	\N	\N	126796	126796	294473
16293	20995	22	applied	\N	\N	\N	\N	126797	126797	294474
16293	20998	23	applied	\N	\N	\N	\N	126798	126798	294475
16293	20999	24	applied	\N	\N	\N	\N	126799	126799	294476
16293	21000	25	applied	\N	\N	\N	\N	126800	126800	294477
16293	21001	26	applied	\N	\N	\N	\N	126801	126801	294478
16293	21011	27	applied	\N	\N	\N	\N	126802	126802	294479
16293	21012	28	applied	\N	\N	\N	\N	126803	126803	294480
16293	21022	30	applied	\N	\N	\N	\N	126805	126805	294482
16293	21025	31	applied	\N	\N	\N	\N	126806	126806	294483
16293	21029	32	applied	\N	\N	\N	\N	126807	126807	294484
16293	21032	33	applied	\N	\N	\N	\N	126808	126808	294485
16293	21035	34	applied	\N	\N	\N	\N	126809	126809	294486
16293	20934	35	applied	\N	\N	\N	\N	126810	126810	294487
16293	20939	36	applied	\N	\N	\N	\N	126811	126811	294488
16293	20814	38	applied	\N	\N	1000000000	\N	126813	126813	294489
16293	20806	37	failed	Amount_insufficient_to_create_account	\N	\N	\N	126812	126812	\N
16293	20826	39	applied	\N	\N	\N	\N	126814	126814	294490
16293	20851	40	applied	\N	\N	\N	\N	126815	126815	294491
16293	20512	41	applied	\N	\N	\N	\N	126816	126816	294492
16293	20513	42	applied	\N	\N	\N	\N	126817	126817	294493
16293	20515	43	applied	\N	\N	\N	\N	126818	126818	294494
16293	20519	44	applied	\N	\N	\N	\N	126819	126819	294495
16293	20516	45	applied	\N	\N	\N	\N	126820	126820	294496
16293	20522	47	applied	\N	\N	\N	\N	126822	126822	294498
16293	20525	48	applied	\N	\N	\N	\N	126823	126823	294499
16293	20529	49	applied	\N	\N	\N	\N	126824	126824	294500
16293	20543	50	applied	\N	\N	\N	\N	126825	126825	294501
16293	20564	51	applied	\N	\N	\N	\N	126826	126826	294502
16293	20517	52	applied	\N	\N	\N	\N	126827	126827	294503
16272	21018	7	applied	\N	\N	\N	\N	126710	126710	294388
16273	21011	0	applied	\N	\N	\N	\N	126711	126711	294389
16293	20910	58	applied	\N	\N	1000000000	\N	126832	126832	294508
16293	20527	59	applied	\N	\N	\N	\N	126833	126833	294509
16293	20539	60	applied	\N	\N	\N	\N	126834	126834	294510
16293	20551	61	applied	\N	\N	\N	\N	126835	126835	294511
16293	20561	62	applied	\N	\N	\N	\N	126836	126836	294512
16293	20572	63	applied	\N	\N	\N	\N	126837	126837	294513
16293	20583	64	applied	\N	\N	\N	\N	126838	126838	294514
16293	20610	65	applied	\N	\N	\N	\N	126839	126839	294515
16293	20535	66	applied	\N	\N	\N	\N	126840	126840	294516
16293	20536	67	applied	\N	\N	\N	\N	126841	126841	294517
16293	20538	68	applied	\N	\N	\N	\N	126842	126842	294518
16293	20544	69	applied	\N	\N	\N	\N	126843	126843	294519
16293	20545	70	applied	\N	\N	\N	\N	126844	126844	294520
16293	20550	71	applied	\N	\N	\N	\N	126845	126845	294521
16293	20557	73	applied	\N	\N	\N	\N	126847	126847	294523
16293	20560	74	applied	\N	\N	\N	\N	126848	126848	294524
16293	20565	75	applied	\N	\N	\N	\N	126849	126849	294525
16293	20566	76	applied	\N	\N	\N	\N	126850	126850	294526
16293	20571	77	applied	\N	\N	\N	\N	126851	126851	294527
16293	20575	78	applied	\N	\N	\N	\N	126852	126852	294528
16293	20580	79	applied	\N	\N	\N	\N	126853	126853	294529
16293	20582	80	applied	\N	\N	\N	\N	126854	126854	294530
16293	20586	81	applied	\N	\N	\N	\N	126855	126855	294531
16293	20588	82	applied	\N	\N	\N	\N	126856	126856	294532
16293	20596	83	applied	\N	\N	\N	\N	126857	126857	294533
16293	20597	84	applied	\N	\N	\N	\N	126858	126858	294534
16293	20598	85	applied	\N	\N	\N	\N	126859	126859	294535
16293	20599	86	applied	\N	\N	\N	\N	126860	126860	294536
16293	20600	87	applied	\N	\N	\N	\N	126861	126861	294537
16293	20608	88	applied	\N	\N	\N	\N	126862	126862	294538
16293	20614	90	applied	\N	\N	\N	\N	126864	126864	294540
16293	20616	91	applied	\N	\N	\N	\N	126865	126865	294541
16293	20620	92	applied	\N	\N	\N	\N	126866	126866	294542
16293	20624	93	applied	\N	\N	\N	\N	126867	126867	294543
16293	20630	94	applied	\N	\N	\N	\N	126868	126868	294544
16293	20631	95	applied	\N	\N	\N	\N	126869	126869	294545
16293	20633	96	applied	\N	\N	\N	\N	126870	126870	294546
16293	20636	97	applied	\N	\N	\N	\N	126871	126871	294547
16293	20641	98	applied	\N	\N	\N	\N	126872	126872	294548
16293	20644	99	applied	\N	\N	\N	\N	126873	126873	294549
16293	20645	100	applied	\N	\N	\N	\N	126874	126874	294550
16293	20651	101	applied	\N	\N	\N	\N	126875	126875	294551
16293	20654	102	applied	\N	\N	\N	\N	126876	126876	294552
16293	21006	103	applied	\N	\N	\N	\N	126877	126877	126877
16293	21014	104	applied	\N	\N	\N	\N	126878	126878	126878
16293	20523	105	applied	\N	\N	\N	\N	126879	126879	294553
16293	20530	107	applied	\N	\N	\N	\N	126881	126881	294555
16293	20533	108	applied	\N	\N	\N	\N	126882	126882	294556
16293	20534	109	applied	\N	\N	\N	\N	126883	126883	294557
16293	20540	110	applied	\N	\N	\N	\N	126884	126884	294558
16293	20546	111	applied	\N	\N	\N	\N	126885	126885	294559
16293	20547	112	applied	\N	\N	\N	\N	126886	126886	294560
16293	20549	113	applied	\N	\N	\N	\N	126887	126887	294561
16293	20554	114	applied	\N	\N	\N	\N	126888	126888	294562
16293	20555	115	applied	\N	\N	\N	\N	126889	126889	294563
16293	20559	116	applied	\N	\N	\N	\N	126890	126890	294564
16293	20567	117	applied	\N	\N	\N	\N	126891	126891	294565
16293	20568	118	applied	\N	\N	\N	\N	126892	126892	294566
16293	20573	119	applied	\N	\N	\N	\N	126893	126893	294567
16293	20574	120	applied	\N	\N	\N	\N	126894	126894	294568
16293	20577	121	applied	\N	\N	\N	\N	126895	126895	294569
16293	20579	122	applied	\N	\N	\N	\N	126896	126896	294570
16293	20589	124	applied	\N	\N	\N	\N	126898	126898	294572
16293	20601	125	applied	\N	\N	\N	\N	126899	126899	294573
16294	21041	0	applied	\N	\N	\N	\N	126900	126900	294574
16294	21042	1	applied	\N	\N	\N	\N	126901	126901	294575
16294	21043	2	applied	\N	\N	\N	\N	126902	126902	294576
16294	21044	3	applied	\N	\N	\N	\N	126903	126903	294577
16294	21045	4	applied	\N	\N	\N	\N	126904	126904	294578
16294	21046	5	applied	\N	\N	\N	\N	126905	126905	294579
16296	21047	0	applied	\N	\N	\N	\N	126910	126910	294584
16296	21048	1	applied	\N	\N	\N	\N	126911	126911	294585
16296	21049	2	applied	\N	\N	\N	\N	126912	126912	294586
16296	21050	3	applied	\N	\N	\N	\N	126913	126913	294587
16298	21054	0	applied	\N	\N	\N	\N	126917	126917	294591
16298	21055	1	applied	\N	\N	\N	\N	126918	126918	294592
16298	21056	2	applied	\N	\N	\N	\N	126919	126919	294593
16300	21054	0	applied	\N	\N	\N	\N	126923	126923	294597
16300	21056	2	applied	\N	\N	\N	\N	126925	126925	294599
16301	21057	0	applied	\N	\N	\N	\N	126926	126926	294600
16301	21058	1	applied	\N	\N	\N	\N	126927	126927	294601
16301	21059	2	applied	\N	\N	\N	\N	126928	126928	294602
16303	21060	0	applied	\N	\N	\N	\N	126932	126932	294606
16303	21061	1	applied	\N	\N	\N	\N	126933	126933	294607
16306	20971	0	applied	\N	\N	\N	\N	126941	126941	294615
16306	20972	1	applied	\N	\N	\N	\N	126942	126942	294616
16306	20978	2	applied	\N	\N	\N	\N	126943	126943	294617
16306	20979	3	applied	\N	\N	\N	\N	126944	126944	294618
16306	20985	4	applied	\N	\N	\N	\N	126945	126945	294619
16306	20988	5	applied	\N	\N	\N	\N	126946	126946	294620
16306	20989	6	applied	\N	\N	\N	\N	126947	126947	294621
16306	20995	7	applied	\N	\N	\N	\N	126948	126948	294622
16306	20998	8	applied	\N	\N	\N	\N	126949	126949	294623
16306	20999	9	applied	\N	\N	\N	\N	126950	126950	294624
16306	21001	11	applied	\N	\N	\N	\N	126952	126952	294626
16306	21011	12	applied	\N	\N	\N	\N	126953	126953	294627
16306	21012	13	applied	\N	\N	\N	\N	126954	126954	294628
16306	21019	14	applied	\N	\N	\N	\N	126955	126955	294629
16306	21022	15	applied	\N	\N	\N	\N	126956	126956	294630
16306	21025	16	applied	\N	\N	\N	\N	126957	126957	294631
16306	21029	17	applied	\N	\N	\N	\N	126958	126958	294632
16306	21032	18	applied	\N	\N	\N	\N	126959	126959	294633
16306	21035	19	applied	\N	\N	\N	\N	126960	126960	294634
16306	21037	20	applied	\N	\N	\N	\N	126961	126961	294635
16306	21041	21	applied	\N	\N	\N	\N	126962	126962	294636
16306	21042	22	applied	\N	\N	\N	\N	126963	126963	294637
16306	21047	24	applied	\N	\N	\N	\N	126964	126964	294638
16306	21051	25	applied	\N	\N	\N	\N	126965	126965	294639
16306	21054	26	applied	\N	\N	\N	\N	126966	126966	294640
16306	21057	27	applied	\N	\N	\N	\N	126967	126967	294641
16293	20866	57	applied	\N	\N	\N	\N	126831	126831	294507
16302	21060	0	applied	\N	\N	\N	\N	126929	126929	294603
16302	21061	1	applied	\N	\N	\N	\N	126930	126930	294604
16302	21062	2	applied	\N	\N	\N	\N	126931	126931	294605
16306	21060	28	applied	\N	\N	\N	\N	126968	126968	294642
16306	21063	29	applied	\N	\N	\N	\N	126969	126969	294643
16306	20973	30	applied	\N	\N	\N	\N	126970	126970	294644
16306	20974	31	applied	\N	\N	\N	\N	126971	126971	294645
16306	20980	32	applied	\N	\N	\N	\N	126972	126972	294646
16306	20976	33	applied	\N	\N	\N	\N	126973	126973	294647
16306	20975	34	applied	\N	\N	\N	\N	126974	126974	294648
16306	20977	35	applied	\N	\N	\N	\N	126975	126975	294649
16306	20981	36	applied	\N	\N	\N	\N	126976	126976	294650
16306	20982	37	applied	\N	\N	\N	\N	126977	126977	294651
16306	20986	38	applied	\N	\N	\N	\N	126978	126978	294652
16306	20992	40	applied	\N	\N	\N	\N	126980	126980	294654
16306	20996	41	applied	\N	\N	\N	\N	126981	126981	294655
16306	21003	42	applied	\N	\N	\N	\N	126982	126982	294656
16306	21004	43	applied	\N	\N	\N	\N	126983	126983	294657
16306	21005	44	applied	\N	\N	\N	\N	126984	126984	294658
16306	21006	45	applied	\N	\N	\N	\N	126985	126985	126985
16306	21014	46	applied	\N	\N	\N	\N	126986	126986	126986
16306	20983	47	applied	\N	\N	\N	\N	126987	126987	294659
16306	20993	48	applied	\N	\N	\N	\N	126988	126988	294660
16306	21002	49	applied	\N	\N	\N	\N	126989	126989	294661
16306	21013	50	applied	\N	\N	\N	\N	126990	126990	294662
16306	21026	51	applied	\N	\N	\N	\N	126991	126991	294663
16306	21038	52	applied	\N	\N	\N	\N	126992	126992	294664
16306	21049	53	applied	\N	\N	\N	\N	126993	126993	294665
16306	21059	54	applied	\N	\N	\N	\N	126994	126994	294666
16306	20984	55	applied	\N	\N	\N	\N	126995	126995	294667
16306	20990	57	applied	\N	\N	\N	\N	126997	126997	294669
16306	20994	58	applied	\N	\N	\N	\N	126998	126998	294670
16306	20997	59	applied	\N	\N	\N	\N	126999	126999	294671
16306	21017	60	applied	\N	\N	\N	\N	127000	127000	294672
16306	21018	61	applied	\N	\N	\N	\N	127001	127001	294673
16306	21021	62	applied	\N	\N	\N	\N	127002	127002	294674
16306	21023	63	applied	\N	\N	\N	\N	127003	127003	294675
16306	21007	64	applied	\N	\N	\N	\N	127004	127004	294676
16306	21008	65	applied	\N	\N	\N	\N	127005	127005	294677
16306	21009	66	applied	\N	\N	\N	\N	127006	127006	294678
16306	21010	67	applied	\N	\N	\N	\N	127007	127007	294679
16306	21015	68	applied	\N	\N	\N	\N	127008	127008	294680
16306	21016	69	applied	\N	\N	\N	\N	127009	127009	294681
16306	21020	70	applied	\N	\N	\N	\N	127010	127010	294682
16306	21024	71	applied	\N	\N	\N	\N	127011	127011	294683
16306	21027	72	applied	\N	\N	\N	\N	127012	127012	294684
16306	21033	74	applied	\N	\N	\N	\N	127014	127014	294686
16306	21039	75	applied	\N	\N	\N	\N	127015	127015	294687
16306	21043	76	applied	\N	\N	\N	\N	127016	127016	294688
16306	21046	77	applied	\N	\N	\N	\N	127017	127017	294689
16306	21050	78	applied	\N	\N	\N	\N	127018	127018	294690
16306	21053	79	applied	\N	\N	\N	\N	127019	127019	294691
16306	21056	80	applied	\N	\N	\N	\N	127020	127020	294692
16306	21058	81	applied	\N	\N	\N	\N	127021	127021	294693
16306	21062	82	applied	\N	\N	\N	\N	127022	127022	294694
16306	21064	83	applied	\N	\N	\N	\N	127023	127023	294695
16306	21028	84	applied	\N	\N	\N	\N	127024	127024	294696
16306	21031	85	applied	\N	\N	\N	\N	127025	127025	294697
16306	21034	86	applied	\N	\N	\N	\N	127026	127026	294698
16306	21036	87	applied	\N	\N	\N	\N	127027	127027	294699
16306	21040	88	applied	\N	\N	\N	\N	127028	127028	294700
16306	21044	89	applied	\N	\N	\N	\N	127029	127029	294701
16306	21048	91	applied	\N	\N	\N	\N	127031	127031	294703
16306	21052	92	applied	\N	\N	\N	\N	127032	127032	294704
16306	21055	93	applied	\N	\N	\N	\N	127033	127033	294705
16306	21061	94	applied	\N	\N	\N	\N	127034	127034	294706
16306	21065	95	applied	\N	\N	\N	\N	127035	127035	294707
16308	21069	0	applied	\N	\N	\N	\N	127039	127039	294711
16308	21070	1	applied	\N	\N	\N	\N	127040	127040	294712
16308	21071	2	applied	\N	\N	\N	\N	127041	127041	294713
16308	21072	3	applied	\N	\N	\N	\N	127042	127042	294714
16308	21073	4	applied	\N	\N	\N	\N	127043	127043	294715
16308	21074	5	applied	\N	\N	\N	\N	127044	127044	294716
16308	21075	6	applied	\N	\N	\N	\N	127045	127045	294717
16311	21069	0	applied	\N	\N	\N	\N	127060	127060	294732
16311	21070	1	applied	\N	\N	\N	\N	127061	127061	294733
16311	21071	2	applied	\N	\N	\N	\N	127062	127062	294734
16311	21072	3	applied	\N	\N	\N	\N	127063	127063	294735
16312	21069	0	applied	\N	\N	\N	\N	127067	127067	294739
16312	21070	1	applied	\N	\N	\N	\N	127068	127068	294740
16312	21071	2	applied	\N	\N	\N	\N	127069	127069	294741
16312	21072	3	applied	\N	\N	\N	\N	127070	127070	294742
16312	21073	4	applied	\N	\N	\N	\N	127071	127071	294743
16312	21074	5	applied	\N	\N	\N	\N	127072	127072	294744
16312	21075	6	applied	\N	\N	\N	\N	127073	127073	294745
16321	21097	0	applied	\N	\N	\N	\N	127110	127110	294778
16321	21098	1	applied	\N	\N	\N	\N	127111	127111	294779
16326	21112	0	applied	\N	\N	\N	\N	127125	127125	294793
16326	21113	1	applied	\N	\N	\N	\N	127126	127126	294794
16326	21114	2	applied	\N	\N	\N	\N	127127	127127	294795
16326	21115	3	applied	\N	\N	\N	\N	127128	127128	294796
16333	21146	0	applied	\N	\N	\N	\N	127188	127188	294854
16333	21147	1	applied	\N	\N	\N	\N	127189	127189	294855
16333	21148	2	applied	\N	\N	\N	\N	127190	127190	294856
16335	21150	0	applied	\N	\N	1000000000	\N	127196	127196	294862
16335	21151	1	applied	\N	\N	\N	\N	127197	127197	294863
16335	21152	2	applied	\N	\N	\N	\N	127198	127198	294864
16335	21153	3	applied	\N	\N	\N	\N	127199	127199	294865
16335	21154	4	applied	\N	\N	\N	\N	127200	127200	294866
16335	21155	5	applied	\N	\N	\N	\N	127201	127201	294867
16338	21163	0	applied	\N	\N	\N	\N	127209	127209	294875
16338	21164	1	applied	\N	\N	\N	\N	127210	127210	294876
16338	21165	2	applied	\N	\N	\N	\N	127211	127211	294877
16346	21184	0	applied	\N	\N	\N	\N	127236	127236	294902
16346	21185	1	applied	\N	\N	\N	\N	127237	127237	294903
16346	21186	2	applied	\N	\N	\N	\N	127238	127238	294904
16348	21187	0	applied	\N	\N	\N	\N	127242	127242	294908
16348	21188	1	applied	\N	\N	\N	\N	127243	127243	294909
16348	21189	2	applied	\N	\N	\N	\N	127244	127244	294910
16350	21190	0	applied	\N	\N	\N	\N	127248	127248	294914
16295	21050	3	applied	\N	\N	\N	\N	126909	126909	294583
16299	21054	0	applied	\N	\N	\N	\N	126920	126920	294594
16299	21055	1	applied	\N	\N	\N	\N	126921	126921	294595
16299	21056	2	applied	\N	\N	\N	\N	126922	126922	294596
16304	21063	0	applied	\N	\N	\N	\N	126935	126935	294609
16304	21064	1	applied	\N	\N	\N	\N	126936	126936	294610
16304	21065	2	applied	\N	\N	\N	\N	126937	126937	294611
16309	21069	0	applied	\N	\N	\N	\N	127046	127046	294718
16309	21070	1	applied	\N	\N	\N	\N	127047	127047	294719
16309	21071	2	applied	\N	\N	\N	\N	127048	127048	294720
16309	21073	4	applied	\N	\N	\N	\N	127050	127050	294722
16309	21074	5	applied	\N	\N	\N	\N	127051	127051	294723
16309	21075	6	applied	\N	\N	\N	\N	127052	127052	294724
16313	21076	0	applied	\N	\N	\N	\N	127074	127074	294746
16313	21077	1	applied	\N	\N	\N	\N	127075	127075	294747
16313	21078	2	applied	\N	\N	\N	\N	127076	127076	294748
16316	21089	0	applied	\N	\N	\N	\N	127087	127087	127087
16316	21090	1	applied	\N	\N	\N	\N	127088	127088	294759
16316	21091	2	applied	\N	\N	\N	\N	127089	127089	294760
16316	21092	3	applied	\N	\N	\N	\N	127090	127090	294761
16316	21093	4	applied	\N	\N	\N	\N	127091	127091	294762
16319	21089	0	applied	\N	\N	\N	\N	127102	127102	127102
16319	21090	1	applied	\N	\N	\N	\N	127103	127103	294771
16319	21091	2	applied	\N	\N	\N	\N	127104	127104	294772
16319	21092	3	applied	\N	\N	\N	\N	127105	127105	294773
16319	21093	4	applied	\N	\N	\N	\N	127106	127106	294774
16320	21095	1	applied	\N	\N	\N	\N	127108	127108	294776
16320	21096	2	applied	\N	\N	\N	\N	127109	127109	294777
16323	21102	0	applied	\N	\N	\N	\N	127115	127115	294783
16323	21103	1	applied	\N	\N	\N	\N	127116	127116	294784
16323	21104	2	applied	\N	\N	\N	\N	127117	127117	294785
16323	21105	3	applied	\N	\N	\N	\N	127118	127118	294786
16328	21116	0	applied	\N	\N	\N	\N	127133	127133	294801
16328	21117	1	applied	\N	\N	\N	\N	127134	127134	294802
16328	21118	2	applied	\N	\N	\N	\N	127135	127135	294803
16328	21119	3	applied	\N	\N	\N	\N	127136	127136	294804
16350	21191	1	applied	\N	\N	\N	\N	127249	127249	294915
16350	21192	2	applied	\N	\N	\N	\N	127250	127250	294916
16354	21217	0	applied	\N	\N	\N	\N	127278	127278	294944
16354	21218	1	applied	\N	\N	\N	\N	127279	127279	294945
16354	21219	2	applied	\N	\N	\N	\N	127280	127280	294946
16354	21220	3	applied	\N	\N	\N	\N	127281	127281	294947
16354	21222	5	applied	\N	\N	\N	\N	127283	127283	294949
16359	21230	0	applied	\N	\N	\N	\N	127299	127299	294965
16359	21231	1	applied	\N	\N	\N	\N	127300	127300	294966
16359	21232	2	applied	\N	\N	\N	\N	127301	127301	294967
16359	21233	3	applied	\N	\N	\N	\N	127302	127302	294968
16359	21234	4	applied	\N	\N	\N	\N	127303	127303	294969
16359	21235	5	applied	\N	\N	\N	\N	127304	127304	294970
16364	21243	0	applied	\N	\N	\N	\N	127318	127318	294984
16364	21244	1	applied	\N	\N	\N	\N	127319	127319	294985
16364	21245	2	applied	\N	\N	\N	\N	127320	127320	294986
16364	21246	3	applied	\N	\N	\N	\N	127321	127321	294987
16369	21258	0	applied	\N	\N	\N	\N	127348	127348	295014
16369	21259	1	applied	\N	\N	\N	\N	127349	127349	295015
16374	21243	1	applied	\N	\N	\N	\N	127365	127365	295030
16374	21247	2	applied	\N	\N	\N	\N	127366	127366	295031
16374	21248	3	applied	\N	\N	\N	\N	127367	127367	295032
16374	21254	4	applied	\N	\N	\N	\N	127368	127368	295033
16374	21150	5	applied	\N	\N	1000000000	\N	127369	127369	295034
16374	21166	6	applied	\N	\N	\N	\N	127370	127370	295035
16374	20934	7	applied	\N	\N	\N	\N	127371	127371	295036
16374	20939	8	applied	\N	\N	\N	\N	127372	127372	295037
16374	21250	9	applied	\N	\N	\N	\N	127373	127373	295038
16374	20863	10	applied	\N	\N	\N	\N	127374	127374	295039
16374	20864	11	applied	\N	\N	\N	\N	127375	127375	295040
16374	20865	12	applied	\N	\N	\N	\N	127376	127376	295041
16374	20866	13	applied	\N	\N	\N	\N	127377	127377	295042
16374	20910	14	applied	\N	\N	1000000000	\N	127378	127378	295043
16374	21006	15	applied	\N	\N	\N	\N	127379	127379	127379
16374	21014	16	applied	\N	\N	\N	\N	127380	127380	127380
16377	21279	0	applied	\N	\N	\N	\N	127391	127391	295054
16377	21280	1	applied	\N	\N	\N	\N	127392	127392	295055
16377	21281	2	applied	\N	\N	\N	\N	127393	127393	295056
16381	21288	0	applied	\N	\N	\N	\N	127406	127406	295069
16381	21289	1	applied	\N	\N	\N	\N	127407	127407	295070
16381	21290	2	applied	\N	\N	\N	\N	127408	127408	295071
16384	21291	0	applied	\N	\N	\N	\N	127415	127415	295078
16384	21293	2	applied	\N	\N	\N	\N	127417	127417	295080
16386	21298	0	applied	\N	\N	\N	\N	127422	127422	295085
16386	21299	1	applied	\N	\N	\N	\N	127423	127423	295086
16386	21300	2	applied	\N	\N	\N	\N	127424	127424	295087
16389	21308	0	applied	\N	\N	\N	\N	127435	127435	295098
16389	21309	1	applied	\N	\N	\N	\N	127436	127436	295099
16389	21310	2	applied	\N	\N	\N	\N	127437	127437	295100
16389	21311	3	applied	\N	\N	\N	\N	127438	127438	295101
16389	21312	4	applied	\N	\N	\N	\N	127439	127439	295102
16389	21313	5	applied	\N	\N	\N	\N	127440	127440	295103
16389	21314	6	applied	\N	\N	\N	\N	127441	127441	127441
16389	21315	7	applied	\N	\N	\N	\N	127442	127442	295104
16389	21316	8	applied	\N	\N	\N	\N	127443	127443	295105
16389	21317	9	applied	\N	\N	\N	\N	127444	127444	295106
16389	21318	10	applied	\N	\N	\N	\N	127445	127445	295107
16394	21323	0	applied	\N	\N	\N	\N	127463	127463	295120
16394	21327	2	applied	\N	\N	\N	\N	127465	127465	295122
16394	21324	3	applied	\N	\N	\N	\N	127466	127466	295123
16394	21328	4	applied	\N	\N	\N	\N	127467	127467	295124
16394	21329	5	applied	\N	\N	\N	\N	127468	127468	295125
16394	21330	6	applied	\N	\N	\N	\N	127469	127469	295126
16394	21325	7	applied	\N	\N	\N	\N	127470	127470	295127
16394	21331	8	applied	\N	\N	\N	\N	127471	127471	295128
16394	21332	9	applied	\N	\N	\N	\N	127472	127472	295129
16399	21344	0	applied	\N	\N	\N	\N	127497	127497	295154
16399	21345	1	applied	\N	\N	\N	\N	127498	127498	295155
16399	21346	2	applied	\N	\N	\N	\N	127499	127499	295156
16409	21363	0	applied	\N	\N	\N	\N	127534	127534	295191
16409	21365	1	applied	\N	\N	\N	\N	127535	127535	295192
16409	21364	2	applied	\N	\N	\N	\N	127536	127536	295193
16411	21366	0	applied	\N	\N	\N	\N	127540	127540	295197
16411	21367	1	applied	\N	\N	\N	\N	127541	127541	295198
16297	21052	1	applied	\N	\N	\N	\N	126915	126915	294589
16297	21053	2	applied	\N	\N	\N	\N	126916	126916	294590
16305	21065	2	applied	\N	\N	\N	\N	126940	126940	294614
16307	21066	0	applied	\N	\N	\N	\N	127036	127036	294708
16307	21067	1	applied	\N	\N	\N	\N	127037	127037	294709
16307	21068	2	applied	\N	\N	\N	\N	127038	127038	294710
16310	21069	0	applied	\N	\N	\N	\N	127053	127053	294725
16310	21070	1	applied	\N	\N	\N	\N	127054	127054	294726
16310	21071	2	applied	\N	\N	\N	\N	127055	127055	294727
16310	21072	3	applied	\N	\N	\N	\N	127056	127056	294728
16310	21073	4	applied	\N	\N	\N	\N	127057	127057	294729
16310	21074	5	applied	\N	\N	\N	\N	127058	127058	294730
16310	21075	6	applied	\N	\N	\N	\N	127059	127059	294731
16314	21079	0	applied	\N	\N	\N	\N	127077	127077	294749
16314	21080	1	applied	\N	\N	\N	\N	127078	127078	294750
16314	21082	3	applied	\N	\N	\N	\N	127080	127080	294752
16317	21089	0	applied	\N	\N	\N	\N	127092	127092	127092
16317	21090	1	applied	\N	\N	\N	\N	127093	127093	294763
16317	21091	2	applied	\N	\N	\N	\N	127094	127094	294764
16317	21092	3	applied	\N	\N	\N	\N	127095	127095	294765
16317	21093	4	applied	\N	\N	\N	\N	127096	127096	294766
16324	21106	0	applied	\N	\N	\N	\N	127119	127119	294787
16324	21107	1	applied	\N	\N	\N	\N	127120	127120	294788
16324	21108	2	applied	\N	\N	\N	\N	127121	127121	294789
16327	21112	0	applied	\N	\N	\N	\N	127129	127129	294797
16327	21113	1	applied	\N	\N	\N	\N	127130	127130	294798
16327	21114	2	applied	\N	\N	\N	\N	127131	127131	294799
16327	21115	3	applied	\N	\N	\N	\N	127132	127132	294800
16328	21120	4	applied	\N	\N	\N	\N	127137	127137	294805
16328	21121	5	applied	\N	\N	\N	\N	127138	127138	294806
16330	21123	1	applied	\N	\N	\N	\N	127161	127161	294827
16330	21124	2	applied	\N	\N	\N	\N	127162	127162	294828
16330	21125	3	applied	\N	\N	\N	\N	127163	127163	294829
16330	21126	4	applied	\N	\N	\N	\N	127164	127164	294830
16330	21127	5	applied	\N	\N	\N	\N	127165	127165	294831
16330	21128	6	applied	\N	\N	\N	\N	127166	127166	294832
16330	21129	7	applied	\N	\N	\N	\N	127167	127167	294833
16330	21130	8	applied	\N	\N	\N	\N	127168	127168	294834
16330	21131	9	applied	\N	\N	\N	\N	127169	127169	294835
16330	21132	10	applied	\N	\N	\N	\N	127170	127170	294836
16330	21133	11	applied	\N	\N	\N	\N	127171	127171	294837
16330	21134	12	applied	\N	\N	\N	\N	127172	127172	294838
16330	21135	13	applied	\N	\N	\N	\N	127173	127173	294839
16330	21136	14	applied	\N	\N	\N	\N	127174	127174	294840
16330	21137	15	applied	\N	\N	\N	\N	127175	127175	294841
16330	21138	16	applied	\N	\N	\N	\N	127176	127176	294842
16330	21139	17	applied	\N	\N	\N	\N	127177	127177	294843
16330	21140	18	applied	\N	\N	\N	\N	127178	127178	294844
16330	21141	19	applied	\N	\N	\N	\N	127179	127179	294845
16330	21142	20	applied	\N	\N	\N	\N	127180	127180	294846
16331	21143	0	applied	\N	\N	\N	\N	127181	127181	294847
16331	21145	2	applied	\N	\N	\N	\N	127183	127183	294849
16332	21146	0	applied	\N	\N	\N	\N	127184	127184	294850
16332	21147	1	applied	\N	\N	\N	\N	127185	127185	294851
16332	21148	2	applied	\N	\N	\N	\N	127186	127186	294852
16332	21149	3	applied	\N	\N	\N	\N	127187	127187	294853
16336	21156	0	applied	\N	\N	\N	\N	127202	127202	294868
16336	21157	1	applied	\N	\N	\N	\N	127203	127203	294869
16336	21158	2	applied	\N	\N	\N	\N	127204	127204	294870
16336	21159	3	applied	\N	\N	\N	\N	127205	127205	294871
16337	21160	0	applied	\N	\N	\N	\N	127206	127206	294872
16337	21161	1	applied	\N	\N	\N	\N	127207	127207	294873
16337	21162	2	applied	\N	\N	\N	\N	127208	127208	294874
16340	21170	0	applied	\N	\N	\N	\N	127216	127216	294882
16340	21171	1	applied	\N	\N	\N	\N	127217	127217	294883
16340	21172	2	applied	\N	\N	\N	\N	127218	127218	294884
16340	21173	3	applied	\N	\N	\N	\N	127219	127219	294885
16341	21175	1	applied	\N	\N	\N	\N	127221	127221	294887
16341	21176	2	applied	\N	\N	\N	\N	127222	127222	294888
16343	21177	0	applied	\N	\N	\N	\N	127226	127226	294892
16343	21178	1	applied	\N	\N	\N	\N	127227	127227	294893
16343	21179	2	applied	\N	\N	\N	\N	127228	127228	294894
16345	21184	0	applied	\N	\N	\N	\N	127233	127233	294899
16345	21185	1	applied	\N	\N	\N	\N	127234	127234	294900
16345	21186	2	applied	\N	\N	\N	\N	127235	127235	294901
16347	21187	0	applied	\N	\N	\N	\N	127239	127239	294905
16347	21188	1	applied	\N	\N	\N	\N	127240	127240	294906
16347	21189	2	applied	\N	\N	\N	\N	127241	127241	294907
16349	21187	0	applied	\N	\N	\N	\N	127245	127245	294911
16349	21188	1	applied	\N	\N	\N	\N	127246	127246	294912
16349	21189	2	applied	\N	\N	\N	\N	127247	127247	294913
16353	21207	0	applied	\N	\N	\N	\N	127268	127268	294934
16353	21208	1	applied	\N	\N	\N	\N	127269	127269	294935
16353	21210	3	applied	\N	\N	\N	\N	127271	127271	294937
16353	21211	4	applied	\N	\N	\N	\N	127272	127272	294938
16353	21212	5	applied	\N	\N	\N	\N	127273	127273	294939
16353	21213	6	applied	\N	\N	\N	\N	127274	127274	294940
16353	21214	7	applied	\N	\N	\N	\N	127275	127275	294941
16353	21215	8	applied	\N	\N	\N	\N	127276	127276	294942
16353	21216	9	applied	\N	\N	\N	\N	127277	127277	294943
16356	21226	0	applied	\N	\N	\N	\N	127287	127287	294953
16356	21227	1	applied	\N	\N	\N	\N	127288	127288	294954
16356	21228	2	applied	\N	\N	\N	\N	127289	127289	294955
16356	21229	3	applied	\N	\N	\N	\N	127290	127290	294956
16358	21226	0	applied	\N	\N	\N	\N	127295	127295	294961
16358	21227	1	applied	\N	\N	\N	\N	127296	127296	294962
16358	21228	2	applied	\N	\N	\N	\N	127297	127297	294963
16358	21229	3	applied	\N	\N	\N	\N	127298	127298	294964
16361	21236	0	applied	\N	\N	\N	\N	127309	127309	294975
16361	21238	2	applied	\N	\N	\N	\N	127311	127311	294977
16361	21239	3	applied	\N	\N	\N	\N	127312	127312	294978
16366	21247	0	applied	\N	\N	\N	\N	127333	127333	294999
16366	21248	1	applied	\N	\N	\N	\N	127334	127334	295000
16366	21254	2	applied	\N	\N	\N	\N	127335	127335	295001
16366	21249	3	applied	\N	\N	\N	\N	127336	127336	295002
16366	21255	4	applied	\N	\N	\N	\N	127337	127337	295003
16366	21250	5	applied	\N	\N	\N	\N	127338	127338	295004
16366	21251	6	applied	\N	\N	\N	\N	127339	127339	295005
16366	21253	7	applied	\N	\N	\N	\N	127340	127340	295006
16366	21256	8	applied	\N	\N	\N	\N	127341	127341	295007
16366	21252	9	applied	\N	\N	\N	\N	127342	127342	295008
16366	21257	10	applied	\N	\N	\N	\N	127343	127343	295009
16305	21063	0	applied	\N	\N	\N	\N	126938	126938	294612
16305	21064	1	applied	\N	\N	\N	\N	126939	126939	294613
16315	21084	1	applied	\N	\N	\N	\N	127082	127082	294754
16315	21085	2	applied	\N	\N	\N	\N	127083	127083	294755
16315	21086	3	applied	\N	\N	\N	\N	127084	127084	294756
16315	21087	4	applied	\N	\N	\N	\N	127085	127085	294757
16315	21088	5	applied	\N	\N	\N	\N	127086	127086	294758
16318	21089	0	applied	\N	\N	\N	\N	127097	127097	127097
16318	21090	1	applied	\N	\N	\N	\N	127098	127098	294767
16318	21091	2	applied	\N	\N	\N	\N	127099	127099	294768
16318	21092	3	applied	\N	\N	\N	\N	127100	127100	294769
16318	21093	4	applied	\N	\N	\N	\N	127101	127101	294770
16322	21099	0	applied	\N	\N	\N	\N	127112	127112	294780
16322	21100	1	applied	\N	\N	\N	\N	127113	127113	294781
16322	21101	2	applied	\N	\N	\N	\N	127114	127114	294782
16325	21110	1	applied	\N	\N	\N	\N	127123	127123	294791
16325	21111	2	applied	\N	\N	\N	\N	127124	127124	294792
16329	21123	1	applied	\N	\N	\N	\N	127140	127140	294807
16329	21122	0	failed	Receiver_not_present	\N	\N	\N	127139	127139	\N
16329	21124	2	applied	\N	\N	\N	\N	127141	127141	294808
16329	21125	3	applied	\N	\N	\N	\N	127142	127142	294809
16329	21126	4	applied	\N	\N	\N	\N	127143	127143	294810
16329	21127	5	applied	\N	\N	\N	\N	127144	127144	294811
16329	21128	6	applied	\N	\N	\N	\N	127145	127145	294812
16329	21129	7	applied	\N	\N	\N	\N	127146	127146	294813
16329	21130	8	applied	\N	\N	\N	\N	127147	127147	294814
16329	21131	9	applied	\N	\N	\N	\N	127148	127148	294815
16329	21132	10	applied	\N	\N	\N	\N	127149	127149	294816
16329	21133	11	applied	\N	\N	\N	\N	127150	127150	294817
16329	21134	12	applied	\N	\N	\N	\N	127151	127151	294818
16329	21135	13	applied	\N	\N	\N	\N	127152	127152	294819
16329	21137	15	applied	\N	\N	\N	\N	127154	127154	294821
16329	21138	16	applied	\N	\N	\N	\N	127155	127155	294822
16329	21139	17	applied	\N	\N	\N	\N	127156	127156	294823
16329	21140	18	applied	\N	\N	\N	\N	127157	127157	294824
16329	21141	19	applied	\N	\N	\N	\N	127158	127158	294825
16351	21190	0	applied	\N	\N	\N	\N	127251	127251	294917
16351	21191	1	applied	\N	\N	\N	\N	127252	127252	294918
16351	21192	2	applied	\N	\N	\N	\N	127253	127253	294919
16355	21223	0	applied	\N	\N	\N	\N	127284	127284	294950
16355	21224	1	applied	\N	\N	\N	\N	127285	127285	294951
16355	21225	2	applied	\N	\N	\N	\N	127286	127286	294952
16357	21226	0	applied	\N	\N	\N	\N	127291	127291	294957
16357	21227	1	applied	\N	\N	\N	\N	127292	127292	294958
16357	21228	2	applied	\N	\N	\N	\N	127293	127293	294959
16357	21229	3	applied	\N	\N	\N	\N	127294	127294	294960
16360	21236	0	applied	\N	\N	\N	\N	127305	127305	294971
16360	21238	2	applied	\N	\N	\N	\N	127307	127307	294973
16360	21239	3	applied	\N	\N	\N	\N	127308	127308	294974
16362	21240	0	applied	\N	\N	\N	\N	127313	127313	294979
16362	21241	1	applied	\N	\N	\N	\N	127314	127314	294980
16362	21242	2	applied	\N	\N	\N	\N	127315	127315	294981
16367	21258	0	applied	\N	\N	\N	\N	127344	127344	295010
16367	21259	1	applied	\N	\N	\N	\N	127345	127345	295011
16379	21279	0	applied	\N	\N	\N	\N	127397	127397	295060
16379	21280	1	applied	\N	\N	\N	\N	127398	127398	295061
16379	21281	2	applied	\N	\N	\N	\N	127399	127399	295062
16382	21291	0	applied	\N	\N	\N	\N	127409	127409	295072
16382	21292	1	applied	\N	\N	\N	\N	127410	127410	295073
16382	21293	2	applied	\N	\N	\N	\N	127411	127411	295074
16387	21298	0	applied	\N	\N	\N	\N	127425	127425	295088
16387	21299	1	applied	\N	\N	\N	\N	127426	127426	295089
16387	21300	2	applied	\N	\N	\N	\N	127427	127427	295090
16390	21320	1	applied	\N	\N	\N	\N	127447	127447	295109
16390	21321	2	applied	\N	\N	\N	\N	127448	127448	295110
16390	21322	3	applied	\N	\N	\N	\N	127449	127449	127449
16392	21319	0	applied	\N	\N	\N	\N	127454	127454	295114
16392	21323	1	applied	\N	\N	\N	\N	127455	127455	295115
16392	21320	2	applied	\N	\N	\N	\N	127456	127456	295116
16392	21321	3	applied	\N	\N	\N	\N	127457	127457	295117
16392	21324	4	applied	\N	\N	\N	\N	127458	127458	295118
16392	21322	5	applied	\N	\N	\N	\N	127459	127459	127459
16392	21325	6	applied	\N	\N	\N	\N	127460	127460	295119
16395	21323	0	applied	\N	\N	\N	\N	127473	127473	295130
16395	21326	1	applied	\N	\N	\N	\N	127474	127474	295131
16395	21327	2	applied	\N	\N	\N	\N	127475	127475	295132
16395	21324	3	applied	\N	\N	\N	\N	127476	127476	295133
16395	21328	4	applied	\N	\N	\N	\N	127477	127477	295134
16395	21329	5	applied	\N	\N	\N	\N	127478	127478	295135
16395	21325	7	applied	\N	\N	\N	\N	127480	127480	295137
16395	21331	8	applied	\N	\N	\N	\N	127481	127481	295138
16395	21332	9	applied	\N	\N	\N	\N	127482	127482	295139
16397	21333	0	applied	\N	\N	\N	\N	127486	127486	295143
16397	21334	1	applied	\N	\N	\N	\N	127487	127487	295144
16397	21335	2	applied	\N	\N	\N	\N	127488	127488	295145
16402	21347	0	applied	\N	\N	\N	\N	127510	127510	295167
16402	21348	1	applied	\N	\N	\N	\N	127511	127511	295168
16402	21349	3	applied	\N	\N	\N	\N	127512	127512	295169
16402	21350	4	applied	\N	\N	\N	\N	127513	127513	295170
16402	21351	5	applied	\N	\N	\N	\N	127514	127514	295171
16402	21352	6	applied	\N	\N	\N	\N	127515	127515	295172
16402	21353	7	applied	\N	\N	\N	\N	127516	127516	295173
16407	21363	0	applied	\N	\N	\N	\N	127529	127529	295186
16407	21364	1	applied	\N	\N	\N	\N	127530	127530	295187
16410	21363	0	applied	\N	\N	\N	\N	127537	127537	295194
16410	21364	2	applied	\N	\N	\N	\N	127539	127539	295196
16412	21372	0	applied	\N	\N	\N	\N	127546	127546	295203
16412	21373	1	applied	\N	\N	\N	\N	127547	127547	295204
16412	21374	2	applied	\N	\N	\N	\N	127548	127548	295205
16412	21375	3	applied	\N	\N	\N	\N	127549	127549	295206
16414	21372	0	applied	\N	\N	\N	\N	127554	127554	295211
16414	21373	1	applied	\N	\N	\N	\N	127555	127555	295212
16414	21374	2	applied	\N	\N	\N	\N	127556	127556	295213
16414	21375	3	applied	\N	\N	\N	\N	127557	127557	295214
16416	21376	0	applied	\N	\N	\N	\N	127562	127562	295219
16416	21377	1	applied	\N	\N	\N	\N	127563	127563	295220
16416	21378	2	applied	\N	\N	\N	\N	127564	127564	295221
16418	21376	0	applied	\N	\N	\N	\N	127567	127567	295224
16418	21377	1	applied	\N	\N	\N	\N	127568	127568	295225
16418	21378	2	applied	\N	\N	\N	\N	127569	127569	295226
16423	21386	0	applied	\N	\N	\N	\N	127586	127586	295243
16311	21075	6	applied	\N	\N	\N	\N	127066	127066	294738
16315	21083	0	applied	\N	\N	\N	\N	127081	127081	294753
16334	21149	3	applied	\N	\N	\N	\N	127195	127195	294861
16339	21166	0	applied	\N	\N	\N	\N	127212	127212	294878
16339	21167	1	applied	\N	\N	\N	\N	127213	127213	294879
16339	21168	2	applied	\N	\N	\N	\N	127214	127214	294880
16339	21169	3	applied	\N	\N	\N	\N	127215	127215	294881
16342	21177	0	applied	\N	\N	\N	\N	127223	127223	294889
16342	21178	1	applied	\N	\N	\N	\N	127224	127224	294890
16342	21179	2	applied	\N	\N	\N	\N	127225	127225	294891
16344	21180	0	applied	\N	\N	\N	\N	127229	127229	294895
16344	21181	1	applied	\N	\N	\N	\N	127230	127230	294896
16344	21182	2	applied	\N	\N	\N	\N	127231	127231	294897
16344	21183	3	applied	\N	\N	\N	\N	127232	127232	294898
16352	21193	0	applied	\N	\N	\N	\N	127254	127254	294920
16352	21194	1	applied	\N	\N	\N	\N	127255	127255	294921
16352	21196	3	applied	\N	\N	\N	\N	127257	127257	294923
16352	21197	4	applied	\N	\N	\N	\N	127258	127258	294924
16352	21198	5	applied	\N	\N	\N	\N	127259	127259	294925
16352	21199	6	applied	\N	\N	\N	\N	127260	127260	294926
16352	21200	7	applied	\N	\N	\N	\N	127261	127261	294927
16352	21201	8	applied	\N	\N	\N	\N	127262	127262	294928
16352	21202	9	applied	\N	\N	\N	\N	127263	127263	294929
16352	21203	10	applied	\N	\N	\N	\N	127264	127264	294930
16352	21204	11	applied	\N	\N	\N	\N	127265	127265	294931
16352	21205	12	applied	\N	\N	\N	\N	127266	127266	294932
16352	21206	13	applied	\N	\N	\N	\N	127267	127267	294933
16363	21240	0	applied	\N	\N	\N	\N	127316	127316	294982
16363	21241	1	applied	\N	\N	\N	\N	127317	127317	294983
16365	21243	0	applied	\N	\N	\N	\N	127322	127322	294988
16365	21247	1	applied	\N	\N	\N	\N	127323	127323	294989
16365	21248	2	applied	\N	\N	\N	\N	127324	127324	294990
16365	21249	4	applied	\N	\N	\N	\N	127326	127326	294992
16365	21250	5	applied	\N	\N	\N	\N	127327	127327	294993
16365	21245	6	applied	\N	\N	\N	\N	127328	127328	294994
16365	21251	7	applied	\N	\N	\N	\N	127329	127329	294995
16365	21252	8	applied	\N	\N	\N	\N	127330	127330	294996
16365	21246	9	applied	\N	\N	\N	\N	127331	127331	294997
16365	21253	10	applied	\N	\N	\N	\N	127332	127332	294998
16368	21258	0	applied	\N	\N	\N	\N	127346	127346	295012
16368	21259	1	applied	\N	\N	\N	\N	127347	127347	295013
16370	21260	0	applied	\N	\N	\N	\N	127350	127350	295016
16370	21261	1	applied	\N	\N	\N	\N	127351	127351	295017
16370	21262	2	applied	\N	\N	\N	\N	127352	127352	295018
16371	21260	0	applied	\N	\N	\N	\N	127353	127353	295019
16371	21262	1	applied	\N	\N	\N	\N	127354	127354	295020
16372	21263	0	applied	\N	\N	\N	\N	127355	127355	295021
16372	21264	1	applied	\N	\N	\N	\N	127356	127356	295022
16372	21266	3	applied	\N	\N	\N	\N	127358	127358	295024
16373	21267	0	applied	\N	\N	\N	\N	127359	127359	295025
16373	21268	1	applied	\N	\N	\N	\N	127360	127360	295026
16373	21269	2	applied	\N	\N	\N	\N	127361	127361	295027
16373	21270	3	applied	\N	\N	\N	\N	127362	127362	295028
16373	21271	4	applied	\N	\N	\N	\N	127363	127363	295029
16375	21272	0	applied	\N	\N	\N	\N	127381	127381	295044
16375	21273	1	applied	\N	\N	\N	\N	127382	127382	295045
16375	21274	2	applied	\N	\N	\N	\N	127383	127383	295046
16375	21275	3	applied	\N	\N	\N	\N	127384	127384	295047
16375	21276	4	applied	\N	\N	\N	\N	127385	127385	295048
16375	21277	5	applied	\N	\N	\N	\N	127386	127386	295049
16375	21278	6	applied	\N	\N	\N	\N	127387	127387	295050
16376	21279	0	applied	\N	\N	\N	\N	127388	127388	295051
16376	21280	1	applied	\N	\N	\N	\N	127389	127389	295052
16376	21281	2	applied	\N	\N	\N	\N	127390	127390	295053
16378	21280	1	applied	\N	\N	\N	\N	127395	127395	295058
16378	21281	2	applied	\N	\N	\N	\N	127396	127396	295059
16380	21282	0	applied	\N	\N	\N	\N	127400	127400	295063
16380	21283	1	applied	\N	\N	\N	\N	127401	127401	295064
16380	21284	2	applied	\N	\N	\N	\N	127402	127402	295065
16380	21285	3	applied	\N	\N	\N	\N	127403	127403	295066
16380	21286	4	applied	\N	\N	\N	\N	127404	127404	295067
16380	21287	5	applied	\N	\N	\N	\N	127405	127405	295068
16383	21291	0	applied	\N	\N	\N	\N	127412	127412	295075
16383	21292	1	applied	\N	\N	\N	\N	127413	127413	295076
16383	21293	2	applied	\N	\N	\N	\N	127414	127414	295077
16385	21294	0	applied	\N	\N	\N	\N	127418	127418	295081
16385	21295	1	applied	\N	\N	\N	\N	127419	127419	295082
16385	21296	2	applied	\N	\N	\N	\N	127420	127420	295083
16385	21297	3	applied	\N	\N	\N	\N	127421	127421	295084
16388	21301	0	applied	\N	\N	\N	\N	127428	127428	295091
16388	21303	2	applied	\N	\N	\N	\N	127430	127430	295093
16388	21304	3	applied	\N	\N	\N	\N	127431	127431	295094
16388	21305	4	applied	\N	\N	\N	\N	127432	127432	295095
16388	21306	5	applied	\N	\N	\N	\N	127433	127433	295096
16388	21307	6	applied	\N	\N	\N	\N	127434	127434	295097
16391	21319	0	applied	\N	\N	\N	\N	127450	127450	295111
16391	21320	1	applied	\N	\N	\N	\N	127451	127451	295112
16391	21321	2	applied	\N	\N	\N	\N	127452	127452	295113
16391	21322	3	applied	\N	\N	\N	\N	127453	127453	127453
16393	21314	0	applied	\N	\N	\N	\N	127461	127461	127461
16393	21322	1	applied	\N	\N	\N	\N	127462	127462	127462
16396	21333	0	applied	\N	\N	\N	\N	127483	127483	295140
16396	21334	1	applied	\N	\N	\N	\N	127484	127484	295141
16396	21335	2	applied	\N	\N	\N	\N	127485	127485	295142
16398	21336	0	applied	\N	\N	\N	\N	127489	127489	295146
16398	21338	2	applied	\N	\N	\N	\N	127491	127491	295148
16398	21339	3	applied	\N	\N	\N	\N	127492	127492	295149
16398	21340	4	applied	\N	\N	\N	\N	127493	127493	295150
16401	21347	0	applied	\N	\N	\N	\N	127503	127503	295160
16401	21348	1	applied	\N	\N	\N	\N	127504	127504	295161
16401	21349	3	applied	\N	\N	\N	\N	127505	127505	295162
16401	21350	4	applied	\N	\N	\N	\N	127506	127506	295163
16401	21351	5	applied	\N	\N	\N	\N	127507	127507	295164
16401	21352	6	applied	\N	\N	\N	\N	127508	127508	295165
16401	21353	7	applied	\N	\N	\N	\N	127509	127509	295166
16404	21354	0	applied	\N	\N	\N	\N	127520	127520	295177
16404	21355	1	applied	\N	\N	\N	\N	127521	127521	295178
16404	21356	2	applied	\N	\N	\N	\N	127522	127522	295179
16406	21360	0	applied	\N	\N	\N	\N	127526	127526	295183
16406	21361	1	applied	\N	\N	\N	\N	127527	127527	295184
16406	21362	2	applied	\N	\N	\N	\N	127528	127528	295185
16415	21372	0	applied	\N	\N	\N	\N	127558	127558	295215
16334	21147	1	applied	\N	\N	\N	\N	127193	127193	294859
16334	21148	2	applied	\N	\N	\N	\N	127194	127194	294860
16400	21344	0	applied	\N	\N	\N	\N	127500	127500	295157
16400	21345	1	applied	\N	\N	\N	\N	127501	127501	295158
16400	21346	2	applied	\N	\N	\N	\N	127502	127502	295159
16403	21354	0	applied	\N	\N	\N	\N	127517	127517	295174
16403	21355	1	applied	\N	\N	\N	\N	127518	127518	295175
16403	21356	2	applied	\N	\N	\N	\N	127519	127519	295176
16405	21357	0	applied	\N	\N	\N	\N	127523	127523	295180
16405	21358	1	applied	\N	\N	\N	\N	127524	127524	295181
16405	21359	2	applied	\N	\N	\N	\N	127525	127525	295182
16408	21363	0	applied	\N	\N	\N	\N	127531	127531	295188
16408	21365	1	applied	\N	\N	\N	\N	127532	127532	295189
16413	21372	0	applied	\N	\N	\N	\N	127550	127550	295207
16413	21373	1	applied	\N	\N	\N	\N	127551	127551	295208
16413	21374	2	applied	\N	\N	\N	\N	127552	127552	295209
16413	21375	3	applied	\N	\N	\N	\N	127553	127553	295210
16415	21373	1	applied	\N	\N	\N	\N	127559	127559	295216
16415	21374	2	applied	\N	\N	\N	\N	127560	127560	295217
16415	21375	3	applied	\N	\N	\N	\N	127561	127561	295218
16417	21377	0	applied	\N	\N	\N	\N	127565	127565	295222
16417	21378	1	applied	\N	\N	\N	\N	127566	127566	295223
16419	21376	0	applied	\N	\N	\N	\N	127570	127570	295227
16419	21379	1	applied	\N	\N	\N	\N	127571	127571	295228
16419	21380	2	applied	\N	\N	\N	\N	127572	127572	295229
16419	21381	3	applied	\N	\N	\N	\N	127573	127573	295230
16421	21382	0	applied	\N	\N	\N	\N	127578	127578	295235
16421	21383	1	applied	\N	\N	\N	\N	127579	127579	295236
16421	21384	2	applied	\N	\N	\N	\N	127580	127580	295237
16422	21382	0	applied	\N	\N	\N	\N	127582	127582	295239
16422	21383	1	applied	\N	\N	\N	\N	127583	127583	295240
16422	21384	2	applied	\N	\N	\N	\N	127584	127584	295241
16422	21385	3	applied	\N	\N	\N	\N	127585	127585	295242
16424	21386	0	applied	\N	\N	\N	\N	127592	127592	295249
16424	21387	1	applied	\N	\N	\N	\N	127593	127593	295250
16424	21388	2	applied	\N	\N	\N	\N	127594	127594	295251
16424	21389	3	applied	\N	\N	\N	\N	127595	127595	295252
16424	21390	4	applied	\N	\N	\N	\N	127596	127596	295253
16424	21391	5	applied	\N	\N	\N	\N	127597	127597	295254
16426	21392	0	applied	\N	\N	\N	\N	127604	127604	295261
16426	21393	1	applied	\N	\N	\N	\N	127605	127605	127605
16426	21394	2	applied	\N	\N	\N	\N	127606	127606	295262
16426	21395	3	applied	\N	\N	\N	\N	127607	127607	295263
16427	21392	0	applied	\N	\N	\N	\N	127608	127608	295264
16427	21393	1	applied	\N	\N	\N	\N	127609	127609	127609
16427	21395	3	applied	\N	\N	\N	\N	127611	127611	295266
16428	21396	0	applied	\N	\N	\N	\N	127612	127612	295267
16428	21397	1	applied	\N	\N	\N	\N	127613	127613	295268
16428	21398	2	applied	\N	\N	\N	\N	127614	127614	295269
16428	21399	3	applied	\N	\N	\N	\N	127615	127615	295270
16431	21400	0	applied	\N	\N	\N	\N	127624	127624	295279
16431	21401	1	applied	\N	\N	\N	\N	127625	127625	295280
16431	21402	2	applied	\N	\N	\N	\N	127626	127626	295281
16431	21403	3	applied	\N	\N	\N	\N	127627	127627	127627
16431	21404	4	applied	\N	\N	\N	\N	127628	127628	295282
16431	21405	5	applied	\N	\N	\N	\N	127629	127629	127629
16431	21406	6	applied	\N	\N	\N	\N	127630	127630	295283
16433	21400	0	applied	\N	\N	\N	\N	127638	127638	295289
16433	21401	1	applied	\N	\N	\N	\N	127639	127639	295290
16433	21402	2	applied	\N	\N	\N	\N	127640	127640	295291
16434	21407	0	applied	\N	\N	\N	\N	127645	127645	295294
16434	21409	2	applied	\N	\N	\N	\N	127647	127647	295296
16434	21410	3	applied	\N	\N	\N	\N	127648	127648	295297
16434	21411	4	applied	\N	\N	\N	\N	127649	127649	295298
16434	21412	5	applied	\N	\N	\N	\N	127650	127650	295299
16434	21413	6	applied	\N	\N	\N	\N	127651	127651	127651
16434	21414	7	applied	\N	\N	\N	\N	127652	127652	295300
16434	21415	8	applied	\N	\N	\N	\N	127653	127653	295301
16434	21416	9	applied	\N	\N	\N	\N	127654	127654	295302
16434	21417	10	applied	\N	\N	\N	\N	127655	127655	295303
16434	21418	11	applied	\N	\N	\N	\N	127656	127656	295304
16436	21419	0	applied	\N	\N	\N	\N	127661	127661	295308
16436	21420	1	applied	\N	\N	\N	\N	127662	127662	295309
16436	21421	2	applied	\N	\N	\N	\N	127663	127663	127663
16436	21422	3	applied	\N	\N	\N	\N	127664	127664	295310
16443	21431	0	applied	\N	\N	\N	\N	127681	127681	295327
16443	21432	1	applied	\N	\N	\N	\N	127682	127682	295328
16443	21434	3	applied	\N	\N	\N	\N	127684	127684	295330
16452	21460	0	applied	\N	\N	\N	\N	127735	127735	295381
16452	21461	1	applied	\N	\N	\N	\N	127736	127736	295382
16452	21462	2	applied	\N	\N	1000000000	\N	127737	127737	295383
16452	21463	3	applied	\N	\N	\N	\N	127738	127738	295384
16452	21464	4	applied	\N	\N	\N	\N	127739	127739	295385
16452	21465	5	applied	\N	\N	\N	\N	127740	127740	295386
16452	21466	6	applied	\N	\N	\N	\N	127741	127741	295387
16452	21467	7	applied	\N	\N	\N	\N	127742	127742	295388
16454	21326	0	applied	\N	\N	\N	\N	127751	127751	295397
16454	21327	1	applied	\N	\N	\N	\N	127752	127752	295398
16454	21333	2	applied	\N	\N	\N	\N	127753	127753	295399
16454	21336	3	applied	\N	\N	\N	\N	127754	127754	295400
16454	21337	4	applied	\N	\N	1000000000	\N	127755	127755	295401
16454	21409	6	applied	\N	\N	\N	\N	127757	127757	295403
16454	21338	7	applied	\N	\N	\N	\N	127758	127758	295404
16454	21344	8	applied	\N	\N	\N	\N	127759	127759	295405
16454	21347	9	applied	\N	\N	\N	\N	127760	127760	295406
16454	21348	10	applied	\N	\N	\N	\N	127761	127761	295407
16454	21354	11	applied	\N	\N	\N	\N	127762	127762	295408
16454	21357	12	applied	\N	\N	\N	\N	127763	127763	295409
16454	21360	13	applied	\N	\N	\N	\N	127764	127764	295410
16454	21363	14	applied	\N	\N	\N	\N	127765	127765	295411
16454	21366	15	applied	\N	\N	\N	\N	127766	127766	295412
16454	21367	16	applied	\N	\N	\N	\N	127767	127767	295413
16454	21372	17	applied	\N	\N	\N	\N	127768	127768	295414
16454	21376	18	applied	\N	\N	\N	\N	127769	127769	295415
16454	21379	19	applied	\N	\N	\N	\N	127770	127770	295416
16454	21382	20	applied	\N	\N	\N	\N	127771	127771	295417
16454	21386	21	applied	\N	\N	\N	\N	127772	127772	295418
16454	21387	22	applied	\N	\N	\N	\N	127773	127773	295419
16454	21392	23	applied	\N	\N	\N	\N	127774	127774	295420
16454	21396	24	applied	\N	\N	\N	\N	127775	127775	295421
16454	21400	25	applied	\N	\N	\N	\N	127776	127776	295422
16398	21342	6	applied	\N	\N	\N	\N	127495	127495	295152
16398	21343	7	applied	\N	\N	\N	\N	127496	127496	295153
16420	21383	1	applied	\N	\N	\N	\N	127575	127575	295232
16420	21384	2	applied	\N	\N	\N	\N	127576	127576	295233
16420	21385	3	applied	\N	\N	\N	\N	127577	127577	295234
16425	21386	0	applied	\N	\N	\N	\N	127598	127598	295255
16425	21387	1	applied	\N	\N	\N	\N	127599	127599	295256
16425	21388	2	applied	\N	\N	\N	\N	127600	127600	295257
16425	21389	3	applied	\N	\N	\N	\N	127601	127601	295258
16425	21390	4	applied	\N	\N	\N	\N	127602	127602	295259
16425	21391	5	applied	\N	\N	\N	\N	127603	127603	295260
16429	21396	0	applied	\N	\N	\N	\N	127616	127616	295271
16429	21398	2	applied	\N	\N	\N	\N	127618	127618	295273
16429	21399	3	applied	\N	\N	\N	\N	127619	127619	295274
16432	21400	0	applied	\N	\N	\N	\N	127631	127631	295284
16432	21401	1	applied	\N	\N	\N	\N	127632	127632	295285
16432	21402	2	applied	\N	\N	\N	\N	127633	127633	295286
16432	21403	3	applied	\N	\N	\N	\N	127634	127634	127634
16432	21404	4	applied	\N	\N	\N	\N	127635	127635	295287
16432	21405	5	applied	\N	\N	\N	\N	127636	127636	127636
16432	21406	6	applied	\N	\N	\N	\N	127637	127637	295288
16433	21403	3	applied	\N	\N	\N	\N	127641	127641	127641
16433	21404	4	applied	\N	\N	\N	\N	127642	127642	295292
16433	21405	5	applied	\N	\N	\N	\N	127643	127643	127643
16433	21406	6	applied	\N	\N	\N	\N	127644	127644	295293
16437	21423	0	applied	\N	\N	\N	\N	127665	127665	295311
16437	21424	1	applied	\N	\N	\N	\N	127666	127666	295312
16437	21425	2	applied	\N	\N	\N	\N	127667	127667	295313
16438	21425	1	applied	\N	\N	\N	\N	127669	127669	295315
16439	21423	0	applied	\N	\N	\N	\N	127670	127670	295316
16439	21426	1	applied	\N	\N	\N	\N	127671	127671	295317
16439	21427	2	applied	\N	\N	\N	\N	127672	127672	295318
16440	21423	0	applied	\N	\N	\N	\N	127673	127673	295319
16440	21426	1	applied	\N	\N	\N	\N	127674	127674	295320
16440	21427	2	applied	\N	\N	\N	\N	127675	127675	295321
16441	21426	0	applied	\N	\N	\N	\N	127676	127676	295322
16441	21427	1	applied	\N	\N	\N	\N	127677	127677	295323
16444	21435	0	applied	\N	\N	\N	\N	127685	127685	295331
16444	21436	2	applied	\N	\N	\N	\N	127686	127686	295332
16444	21437	3	applied	\N	\N	\N	\N	127687	127687	295333
16446	21438	0	applied	\N	\N	\N	\N	127698	127698	295344
16446	21439	1	applied	\N	\N	\N	\N	127699	127699	295345
16446	21440	2	applied	\N	\N	\N	\N	127700	127700	295346
16446	21441	3	applied	\N	\N	\N	\N	127701	127701	295347
16446	21443	5	applied	\N	\N	\N	\N	127703	127703	295349
16446	21444	6	applied	\N	\N	\N	\N	127704	127704	295350
16446	21445	7	applied	\N	\N	\N	\N	127705	127705	295351
16446	21446	8	applied	\N	\N	\N	\N	127706	127706	295352
16446	21447	9	applied	\N	\N	\N	\N	127707	127707	295353
16447	21448	0	applied	\N	\N	\N	\N	127708	127708	295354
16447	21449	1	applied	\N	\N	\N	\N	127709	127709	295355
16449	21450	0	applied	\N	\N	\N	\N	127717	127717	295363
16449	21451	1	applied	\N	\N	\N	\N	127718	127718	295364
16449	21452	2	applied	\N	\N	\N	\N	127719	127719	295365
16449	21453	3	applied	\N	\N	\N	\N	127720	127720	295366
16449	21454	4	applied	\N	\N	\N	\N	127721	127721	295367
16449	21455	5	applied	\N	\N	\N	\N	127722	127722	295368
16449	21456	6	applied	\N	\N	\N	\N	127723	127723	295369
16451	21460	0	applied	\N	\N	\N	\N	127727	127727	295373
16451	21461	1	applied	\N	\N	\N	\N	127728	127728	295374
16451	21463	3	applied	\N	\N	\N	\N	127730	127730	295376
16451	21464	4	applied	\N	\N	\N	\N	127731	127731	295377
16451	21465	5	applied	\N	\N	\N	\N	127732	127732	295378
16451	21466	6	applied	\N	\N	\N	\N	127733	127733	295379
16451	21467	7	applied	\N	\N	\N	\N	127734	127734	295380
16457	21471	0	applied	\N	\N	\N	\N	127882	127882	295523
16457	21472	1	applied	\N	\N	\N	\N	127883	127883	295524
16457	21473	2	applied	\N	\N	\N	\N	127884	127884	295525
16461	21488	0	applied	\N	\N	\N	\N	127903	127903	295544
16461	21489	1	applied	\N	\N	\N	\N	127904	127904	295545
16461	21490	2	applied	\N	\N	\N	\N	127905	127905	295546
16463	21491	0	applied	\N	\N	\N	\N	127909	127909	295550
16463	21492	1	applied	\N	\N	\N	\N	127910	127910	295551
16470	21500	0	applied	\N	\N	\N	\N	127932	127932	295573
16470	21501	1	applied	\N	\N	\N	\N	127933	127933	295574
16470	21502	2	applied	\N	\N	\N	\N	127934	127934	295575
16472	21462	1	applied	\N	\N	1000000000	\N	127939	127939	295580
16472	21409	2	applied	\N	\N	\N	\N	127940	127940	295581
16472	21314	3	applied	\N	\N	\N	\N	127941	127941	127941
16472	21322	4	applied	\N	\N	\N	\N	127942	127942	127942
16472	21393	5	applied	\N	\N	\N	\N	127943	127943	127943
16472	21403	6	applied	\N	\N	\N	\N	127944	127944	127944
16472	21405	7	applied	\N	\N	\N	\N	127945	127945	127945
16472	21413	8	applied	\N	\N	\N	\N	127946	127946	127946
16472	21421	9	applied	\N	\N	\N	\N	127947	127947	127947
16479	21513	0	applied	\N	\N	\N	\N	127967	127967	295601
16479	21514	1	applied	\N	\N	\N	\N	127968	127968	295602
16479	21515	2	applied	\N	\N	\N	\N	127969	127969	295603
16485	21534	0	applied	\N	\N	\N	\N	127997	127997	295631
16485	21535	1	applied	\N	\N	\N	\N	127998	127998	295632
16485	21536	2	applied	\N	\N	\N	\N	127999	127999	295633
16491	21544	0	applied	\N	\N	\N	\N	128016	128016	295650
16491	21545	1	applied	\N	\N	\N	\N	128017	128017	295651
16491	21546	2	applied	\N	\N	\N	\N	128018	128018	295652
16491	21547	3	applied	\N	\N	\N	\N	128019	128019	295653
16494	21554	0	applied	\N	\N	\N	\N	128030	128030	295664
16494	21556	2	applied	\N	\N	\N	\N	128032	128032	295666
16494	21557	3	applied	\N	\N	\N	\N	128033	128033	295667
16497	21571	0	applied	\N	\N	\N	\N	128051	128051	295685
16497	21572	1	applied	\N	\N	\N	\N	128052	128052	295686
16497	21573	2	applied	\N	\N	\N	\N	128053	128053	295687
16500	21582	0	applied	\N	\N	\N	\N	128062	128062	295696
16500	21583	1	applied	\N	\N	\N	\N	128063	128063	295697
16500	21584	2	applied	\N	\N	\N	\N	128064	128064	295698
16505	21593	0	applied	\N	\N	\N	\N	128092	128092	295726
16505	21594	1	applied	\N	\N	\N	\N	128093	128093	295727
16505	21595	2	applied	\N	\N	\N	\N	128094	128094	295728
16508	21607	0	applied	\N	\N	\N	\N	128109	128109	295743
16508	21608	1	applied	\N	\N	\N	\N	128110	128110	295744
16508	21609	2	applied	\N	\N	\N	\N	128111	128111	295745
16508	21610	3	applied	\N	\N	\N	\N	128112	128112	295746
16411	21370	4	applied	\N	\N	\N	\N	127544	127544	295201
16420	21382	0	applied	\N	\N	\N	\N	127574	127574	295231
16430	21396	0	applied	\N	\N	\N	\N	127620	127620	295275
16430	21397	1	applied	\N	\N	\N	\N	127621	127621	295276
16430	21398	2	applied	\N	\N	\N	\N	127622	127622	295277
16430	21399	3	applied	\N	\N	\N	\N	127623	127623	295278
16435	21419	0	applied	\N	\N	\N	\N	127657	127657	295305
16435	21420	1	applied	\N	\N	\N	\N	127658	127658	295306
16435	21421	2	applied	\N	\N	\N	\N	127659	127659	127659
16435	21422	3	applied	\N	\N	\N	\N	127660	127660	295307
16442	21428	0	applied	\N	\N	\N	\N	127678	127678	295324
16442	21429	1	applied	\N	\N	\N	\N	127679	127679	295325
16442	21430	2	applied	\N	\N	\N	\N	127680	127680	295326
16445	21438	0	applied	\N	\N	\N	\N	127688	127688	295334
16445	21440	2	applied	\N	\N	\N	\N	127690	127690	295336
16445	21441	3	applied	\N	\N	\N	\N	127691	127691	295337
16445	21442	4	applied	\N	\N	\N	\N	127692	127692	295338
16445	21443	5	applied	\N	\N	\N	\N	127693	127693	295339
16445	21444	6	applied	\N	\N	\N	\N	127694	127694	295340
16445	21445	7	applied	\N	\N	\N	\N	127695	127695	295341
16445	21446	8	applied	\N	\N	\N	\N	127696	127696	295342
16445	21447	9	applied	\N	\N	\N	\N	127697	127697	295343
16448	21450	0	applied	\N	\N	\N	\N	127710	127710	295356
16448	21451	1	applied	\N	\N	\N	\N	127711	127711	295357
16448	21452	2	applied	\N	\N	\N	\N	127712	127712	295358
16448	21453	3	applied	\N	\N	\N	\N	127713	127713	295359
16448	21454	4	applied	\N	\N	\N	\N	127714	127714	295360
16448	21455	5	applied	\N	\N	\N	\N	127715	127715	295361
16448	21456	6	applied	\N	\N	\N	\N	127716	127716	295362
16450	21457	0	applied	\N	\N	\N	\N	127724	127724	295370
16450	21459	2	applied	\N	\N	\N	\N	127726	127726	295372
16453	21460	0	applied	\N	\N	\N	\N	127743	127743	295389
16453	21461	1	applied	\N	\N	\N	\N	127744	127744	295390
16453	21462	2	applied	\N	\N	1000000000	\N	127745	127745	295391
16453	21463	3	applied	\N	\N	\N	\N	127746	127746	295392
16460	21484	0	applied	\N	\N	\N	\N	127899	127899	295540
16460	21485	1	applied	\N	\N	\N	\N	127900	127900	295541
16460	21486	2	applied	\N	\N	\N	\N	127901	127901	295542
16460	21487	3	applied	\N	\N	\N	\N	127902	127902	295543
16462	21488	0	applied	\N	\N	\N	\N	127906	127906	295547
16462	21489	1	applied	\N	\N	\N	\N	127907	127907	295548
16462	21490	2	applied	\N	\N	\N	\N	127908	127908	295549
16469	21496	0	applied	\N	\N	\N	\N	127928	127928	295569
16469	21497	1	applied	\N	\N	\N	\N	127929	127929	295570
16469	21498	2	applied	\N	\N	\N	\N	127930	127930	295571
16469	21499	3	applied	\N	\N	\N	\N	127931	127931	295572
16473	21504	1	applied	\N	\N	\N	\N	127949	127949	295583
16473	21505	2	applied	\N	\N	\N	\N	127950	127950	295584
16475	21503	0	applied	\N	\N	\N	\N	127954	127954	295588
16475	21504	1	applied	\N	\N	\N	\N	127955	127955	295589
16475	21505	2	applied	\N	\N	\N	\N	127956	127956	295590
16478	21513	0	applied	\N	\N	\N	\N	127964	127964	295598
16478	21514	1	applied	\N	\N	\N	\N	127965	127965	295599
16478	21515	2	applied	\N	\N	\N	\N	127966	127966	295600
16481	21513	0	applied	\N	\N	\N	\N	127973	127973	295607
16481	21514	1	applied	\N	\N	\N	\N	127974	127974	295608
16481	21515	2	applied	\N	\N	\N	\N	127975	127975	295609
16482	21516	0	applied	\N	\N	\N	\N	127976	127976	295610
16482	21517	1	applied	\N	\N	\N	\N	127977	127977	295611
16482	21518	2	applied	\N	\N	\N	\N	127978	127978	295612
16482	21519	3	applied	\N	\N	\N	\N	127979	127979	295613
16483	21520	0	applied	\N	\N	\N	\N	127980	127980	295614
16483	21522	2	applied	\N	\N	\N	\N	127982	127982	295616
16483	21523	4	applied	\N	\N	\N	\N	127983	127983	295617
16483	21524	5	applied	\N	\N	\N	\N	127984	127984	295618
16483	21525	6	applied	\N	\N	\N	\N	127985	127985	295619
16483	21526	7	applied	\N	\N	\N	\N	127986	127986	295620
16483	21527	8	applied	\N	\N	\N	\N	127987	127987	295621
16483	21528	9	applied	\N	\N	\N	\N	127988	127988	295622
16483	21529	10	applied	\N	\N	\N	\N	127989	127989	295623
16483	21530	11	applied	\N	\N	\N	\N	127990	127990	295624
16483	21531	12	applied	\N	\N	\N	\N	127991	127991	295625
16483	21532	13	applied	\N	\N	\N	\N	127992	127992	295626
16483	21533	14	applied	\N	\N	\N	\N	127993	127993	295627
16490	21540	0	applied	\N	\N	\N	\N	128012	128012	295646
16490	21541	1	applied	\N	\N	\N	\N	128013	128013	295647
16490	21542	2	applied	\N	\N	\N	\N	128014	128014	295648
16490	21543	3	applied	\N	\N	\N	\N	128015	128015	295649
16496	21558	0	applied	\N	\N	\N	\N	128038	128038	295672
16496	21559	1	applied	\N	\N	\N	\N	128039	128039	295673
16496	21561	3	applied	\N	\N	\N	\N	128041	128041	295675
16496	21562	4	applied	\N	\N	\N	\N	128042	128042	295676
16496	21563	5	applied	\N	\N	\N	\N	128043	128043	295677
16496	21564	6	applied	\N	\N	\N	\N	128044	128044	295678
16496	21565	7	applied	\N	\N	\N	\N	128045	128045	295679
16496	21566	8	applied	\N	\N	\N	\N	128046	128046	295680
16496	21567	9	applied	\N	\N	\N	\N	128047	128047	295681
16496	21568	10	applied	\N	\N	\N	\N	128048	128048	295682
16496	21569	11	applied	\N	\N	\N	\N	128049	128049	295683
16496	21570	12	applied	\N	\N	\N	\N	128050	128050	295684
16501	21582	0	applied	\N	\N	\N	\N	128065	128065	295699
16501	21583	1	applied	\N	\N	\N	\N	128066	128066	295700
16501	21584	2	applied	\N	\N	\N	\N	128067	128067	295701
16504	21585	0	applied	\N	\N	\N	\N	128084	128084	295718
16504	21586	1	applied	\N	\N	\N	\N	128085	128085	295719
16504	21587	2	applied	\N	\N	\N	\N	128086	128086	295720
16504	21589	4	applied	\N	\N	\N	\N	128088	128088	295722
16504	21590	5	applied	\N	\N	\N	\N	128089	128089	295723
16504	21591	6	applied	\N	\N	\N	\N	128090	128090	295724
16504	21592	7	applied	\N	\N	\N	\N	128091	128091	295725
16506	21593	0	applied	\N	\N	\N	\N	128095	128095	295729
16506	21594	1	applied	\N	\N	\N	\N	128096	128096	295730
16506	21595	2	applied	\N	\N	\N	\N	128097	128097	295731
16513	21630	0	applied	\N	\N	\N	\N	128147	128147	295781
16513	21631	1	applied	\N	\N	\N	\N	128148	128148	295782
16513	21632	2	applied	\N	\N	\N	\N	128149	128149	295783
16513	21633	3	applied	\N	\N	\N	\N	128150	128150	295784
16519	21637	0	applied	\N	\N	\N	\N	128167	128167	295801
16519	21638	1	applied	\N	\N	\N	\N	128168	128168	295802
16519	21635	2	applied	\N	\N	\N	\N	128169	128169	295803
16519	21639	3	applied	\N	\N	\N	\N	128170	128170	295804
16423	21389	3	applied	\N	\N	\N	\N	127589	127589	295246
16423	21391	5	applied	\N	\N	\N	\N	127591	127591	295248
16453	21467	7	applied	\N	\N	\N	\N	127750	127750	295396
16454	21407	27	applied	\N	\N	\N	\N	127778	127778	295424
16454	21408	28	applied	\N	\N	\N	\N	127779	127779	295425
16454	21410	29	applied	\N	\N	\N	\N	127780	127780	295426
16454	21419	30	applied	\N	\N	\N	\N	127781	127781	295427
16454	21423	32	applied	\N	\N	\N	\N	127782	127782	295428
16454	21428	33	applied	\N	\N	\N	\N	127783	127783	295429
16454	21431	34	applied	\N	\N	\N	\N	127784	127784	295430
16454	21435	35	applied	\N	\N	\N	\N	127785	127785	295431
16454	21438	36	applied	\N	\N	\N	\N	127786	127786	295432
16454	21439	37	applied	\N	\N	\N	\N	127787	127787	295433
16454	21448	39	applied	\N	\N	\N	\N	127789	127789	295435
16454	21450	40	applied	\N	\N	\N	\N	127790	127790	295436
16454	21451	41	applied	\N	\N	\N	\N	127791	127791	295437
16454	21457	42	applied	\N	\N	\N	\N	127792	127792	295438
16454	21460	43	applied	\N	\N	\N	\N	127793	127793	295439
16454	21461	44	applied	\N	\N	\N	\N	127794	127794	295440
16454	21328	45	applied	\N	\N	\N	\N	127795	127795	295441
16454	21393	46	applied	\N	\N	\N	\N	127796	127796	127796
16454	21403	47	applied	\N	\N	\N	\N	127797	127797	127797
16454	21331	48	applied	\N	\N	\N	\N	127798	127798	295442
16454	21329	49	applied	\N	\N	\N	\N	127799	127799	295443
16454	21342	50	applied	\N	\N	\N	\N	127800	127800	295444
16454	21332	51	applied	\N	\N	\N	\N	127801	127801	295445
16454	21334	52	applied	\N	\N	\N	\N	127802	127802	295446
16454	21340	53	applied	\N	\N	\N	\N	127803	127803	295447
16454	21341	54	applied	\N	\N	\N	\N	127804	127804	295448
16454	21349	56	applied	\N	\N	\N	\N	127806	127806	295450
16454	21350	57	applied	\N	\N	\N	\N	127807	127807	295451
16454	21330	58	applied	\N	\N	\N	\N	127808	127808	295452
16454	21335	59	applied	\N	\N	\N	\N	127809	127809	295453
16454	21339	60	applied	\N	\N	\N	\N	127810	127810	295454
16454	21405	61	applied	\N	\N	\N	\N	127811	127811	127811
16454	21413	62	applied	\N	\N	\N	\N	127812	127812	127812
16454	21421	63	applied	\N	\N	\N	\N	127813	127813	127813
16454	21356	64	applied	\N	\N	\N	\N	127814	127814	295455
16454	21359	65	applied	\N	\N	\N	\N	127815	127815	295456
16454	21352	66	applied	\N	\N	\N	\N	127816	127816	295457
16455	21468	0	applied	\N	\N	\N	\N	127876	127876	295517
16455	21469	1	applied	\N	\N	\N	\N	127877	127877	295518
16455	21470	2	applied	\N	\N	\N	\N	127878	127878	295519
16458	21474	0	applied	\N	\N	\N	\N	127885	127885	295526
16458	21475	1	applied	\N	\N	\N	\N	127886	127886	295527
16458	21477	3	applied	\N	\N	\N	\N	127888	127888	295529
16458	21478	4	applied	\N	\N	\N	\N	127889	127889	295530
16458	21479	5	applied	\N	\N	\N	\N	127890	127890	295531
16458	21480	6	applied	\N	\N	\N	\N	127891	127891	295532
16458	21481	7	applied	\N	\N	\N	\N	127892	127892	295533
16458	21482	8	applied	\N	\N	\N	\N	127893	127893	295534
16458	21483	9	applied	\N	\N	\N	\N	127894	127894	295535
16465	21493	0	applied	\N	\N	\N	\N	127913	127913	295554
16465	21494	1	applied	\N	\N	\N	\N	127914	127914	295555
16465	21495	2	applied	\N	\N	\N	\N	127915	127915	295556
16467	21496	0	applied	\N	\N	\N	\N	127920	127920	295561
16467	21497	1	applied	\N	\N	\N	\N	127921	127921	295562
16467	21498	2	applied	\N	\N	\N	\N	127922	127922	295563
16467	21499	3	applied	\N	\N	\N	\N	127923	127923	295564
16474	21503	0	applied	\N	\N	\N	\N	127951	127951	295585
16474	21504	1	applied	\N	\N	\N	\N	127952	127952	295586
16476	21506	0	applied	\N	\N	\N	\N	127957	127957	295591
16476	21507	1	applied	\N	\N	\N	\N	127958	127958	295592
16476	21508	2	applied	\N	\N	\N	\N	127959	127959	295593
16476	21509	3	applied	\N	\N	\N	\N	127960	127960	295594
16484	21534	0	applied	\N	\N	\N	\N	127994	127994	295628
16484	21535	1	applied	\N	\N	\N	\N	127995	127995	295629
16484	21536	2	applied	\N	\N	\N	\N	127996	127996	295630
16487	21534	0	applied	\N	\N	\N	\N	128003	128003	295637
16487	21535	1	applied	\N	\N	\N	\N	128004	128004	295638
16487	21536	2	applied	\N	\N	\N	\N	128005	128005	295639
16493	21548	0	applied	\N	\N	\N	\N	128024	128024	295658
16493	21549	1	applied	\N	\N	\N	\N	128025	128025	295659
16493	21550	2	applied	\N	\N	\N	\N	128026	128026	295660
16493	21551	3	applied	\N	\N	\N	\N	128027	128027	295661
16493	21552	4	applied	\N	\N	\N	\N	128028	128028	295662
16493	21553	5	applied	\N	\N	\N	\N	128029	128029	295663
16499	21579	1	applied	\N	\N	\N	\N	128059	128059	295693
16499	21580	2	applied	\N	\N	\N	\N	128060	128060	295694
16499	21581	3	applied	\N	\N	\N	\N	128061	128061	295695
16502	21585	0	applied	\N	\N	\N	\N	128068	128068	295702
16502	21586	1	applied	\N	\N	\N	\N	128069	128069	295703
16502	21587	2	applied	\N	\N	\N	\N	128070	128070	295704
16502	21588	3	applied	\N	\N	\N	\N	128071	128071	295705
16502	21589	4	applied	\N	\N	\N	\N	128072	128072	295706
16502	21590	5	applied	\N	\N	\N	\N	128073	128073	295707
16502	21591	6	applied	\N	\N	\N	\N	128074	128074	295708
16502	21592	7	applied	\N	\N	\N	\N	128075	128075	295709
16507	21596	0	applied	\N	\N	\N	\N	128098	128098	295732
16507	21597	1	applied	\N	\N	\N	\N	128099	128099	295733
16507	21598	2	applied	\N	\N	\N	\N	128100	128100	295734
16507	21599	3	applied	\N	\N	1000000000	\N	128101	128101	295735
16507	21600	4	applied	\N	\N	\N	\N	128102	128102	295736
16507	21601	5	applied	\N	\N	\N	\N	128103	128103	295737
16507	21602	6	applied	\N	\N	\N	\N	128104	128104	295738
16507	21604	8	applied	\N	\N	\N	\N	128106	128106	295740
16507	21605	9	applied	\N	\N	\N	\N	128107	128107	295741
16507	21606	10	applied	\N	\N	\N	\N	128108	128108	295742
16511	21630	0	applied	\N	\N	\N	\N	128139	128139	295773
16511	21631	1	applied	\N	\N	\N	\N	128140	128140	295774
16511	21632	2	applied	\N	\N	\N	\N	128141	128141	295775
16511	21633	3	applied	\N	\N	\N	\N	128142	128142	295776
16514	21630	0	applied	\N	\N	\N	\N	128151	128151	295785
16514	21631	1	applied	\N	\N	\N	\N	128152	128152	295786
16514	21632	2	applied	\N	\N	\N	\N	128153	128153	295787
16514	21633	3	applied	\N	\N	\N	\N	128154	128154	295788
16523	21521	0	applied	\N	\N	1000000000	\N	128183	128183	295817
16523	21409	1	applied	\N	\N	\N	\N	128184	128184	295818
16523	21314	2	applied	\N	\N	\N	\N	128185	128185	128185
16523	21322	3	applied	\N	\N	\N	\N	128186	128186	128186
16523	21393	4	applied	\N	\N	\N	\N	128187	128187	128187
16453	21465	5	applied	\N	\N	\N	\N	127748	127748	295394
16453	21466	6	applied	\N	\N	\N	\N	127749	127749	295395
16454	21417	71	applied	\N	\N	\N	\N	127821	127821	295462
16454	21420	72	applied	\N	\N	\N	\N	127822	127822	295463
16454	21433	73	applied	\N	\N	\N	\N	127823	127823	295464
16454	21443	74	applied	\N	\N	\N	\N	127824	127824	295465
16454	21456	75	applied	\N	\N	\N	\N	127825	127825	295466
16454	21466	76	applied	\N	\N	\N	\N	127826	127826	295467
16454	21362	77	applied	\N	\N	\N	\N	127827	127827	295468
16454	21365	78	applied	\N	\N	\N	\N	127828	127828	295469
16454	21369	79	applied	\N	\N	\N	\N	127829	127829	295470
16454	21370	80	applied	\N	\N	\N	\N	127830	127830	295471
16454	21375	81	applied	\N	\N	\N	\N	127831	127831	295472
16454	21377	82	applied	\N	\N	\N	\N	127832	127832	295473
16454	21380	83	applied	\N	\N	\N	\N	127833	127833	295474
16454	21383	84	applied	\N	\N	\N	\N	127834	127834	295475
16454	21390	85	applied	\N	\N	\N	\N	127835	127835	295476
16454	21391	86	applied	\N	\N	\N	\N	127836	127836	295477
16454	21398	88	applied	\N	\N	\N	\N	127838	127838	295479
16454	21402	89	applied	\N	\N	\N	\N	127839	127839	295480
16454	21411	90	applied	\N	\N	\N	\N	127840	127840	295481
16454	21414	91	applied	\N	\N	\N	\N	127841	127841	295482
16454	21418	92	applied	\N	\N	\N	\N	127842	127842	295483
16454	21422	93	applied	\N	\N	\N	\N	127843	127843	295484
16454	21425	94	applied	\N	\N	\N	\N	127844	127844	295485
16454	21426	95	applied	\N	\N	\N	\N	127845	127845	295486
16454	21429	96	applied	\N	\N	\N	\N	127846	127846	295487
16454	21434	97	applied	\N	\N	\N	\N	127847	127847	295488
16454	21436	98	applied	\N	\N	\N	\N	127848	127848	295489
16454	21442	99	applied	\N	\N	\N	\N	127849	127849	295490
16454	21446	100	applied	\N	\N	\N	\N	127850	127850	295491
16454	21447	101	applied	\N	\N	\N	\N	127851	127851	295492
16454	21449	102	applied	\N	\N	\N	\N	127852	127852	295493
16454	21452	103	applied	\N	\N	\N	\N	127853	127853	295494
16454	21459	105	applied	\N	\N	\N	\N	127855	127855	295496
16454	21464	106	applied	\N	\N	\N	\N	127856	127856	295497
16454	21465	107	applied	\N	\N	\N	\N	127857	127857	295498
16454	21343	108	applied	\N	\N	\N	\N	127858	127858	295499
16454	21346	109	applied	\N	\N	\N	\N	127859	127859	295500
16454	21351	110	applied	\N	\N	\N	\N	127860	127860	295501
16454	21353	111	applied	\N	\N	\N	\N	127861	127861	295502
16454	21355	112	applied	\N	\N	\N	\N	127862	127862	295503
16454	21358	113	applied	\N	\N	\N	\N	127863	127863	295504
16454	21361	114	applied	\N	\N	\N	\N	127864	127864	295505
16454	21368	115	applied	\N	\N	\N	\N	127865	127865	295506
16454	21371	116	applied	\N	\N	\N	\N	127866	127866	295507
16454	21374	117	applied	\N	\N	\N	\N	127867	127867	295508
16454	21378	118	applied	\N	\N	\N	\N	127868	127868	295509
16454	21381	119	applied	\N	\N	\N	\N	127869	127869	295510
16454	21385	120	applied	\N	\N	\N	\N	127870	127870	295511
16454	21389	122	applied	\N	\N	\N	\N	127872	127872	295513
16454	21394	123	applied	\N	\N	\N	\N	127873	127873	295514
16454	21399	124	applied	\N	\N	\N	\N	127874	127874	295515
16454	21404	125	applied	\N	\N	\N	\N	127875	127875	295516
16456	21471	0	applied	\N	\N	\N	\N	127879	127879	295520
16456	21472	1	applied	\N	\N	\N	\N	127880	127880	295521
16456	21473	2	applied	\N	\N	\N	\N	127881	127881	295522
16459	21484	0	applied	\N	\N	\N	\N	127895	127895	295536
16459	21485	1	applied	\N	\N	\N	\N	127896	127896	295537
16459	21486	2	applied	\N	\N	\N	\N	127897	127897	295538
16459	21487	3	applied	\N	\N	\N	\N	127898	127898	295539
16464	21491	0	applied	\N	\N	\N	\N	127911	127911	295552
16464	21492	1	applied	\N	\N	\N	\N	127912	127912	295553
16466	21496	0	applied	\N	\N	\N	\N	127916	127916	295557
16466	21497	1	applied	\N	\N	\N	\N	127917	127917	295558
16466	21498	2	applied	\N	\N	\N	\N	127918	127918	295559
16468	21496	0	applied	\N	\N	\N	\N	127924	127924	295565
16468	21497	1	applied	\N	\N	\N	\N	127925	127925	295566
16468	21498	2	applied	\N	\N	\N	\N	127926	127926	295567
16468	21499	3	applied	\N	\N	\N	\N	127927	127927	295568
16471	21500	0	applied	\N	\N	\N	\N	127935	127935	295576
16471	21501	1	applied	\N	\N	\N	\N	127936	127936	295577
16471	21502	2	applied	\N	\N	\N	\N	127937	127937	295578
16477	21510	0	applied	\N	\N	\N	\N	127961	127961	295595
16477	21511	1	applied	\N	\N	\N	\N	127962	127962	295596
16477	21512	2	applied	\N	\N	\N	\N	127963	127963	295597
16480	21513	0	applied	\N	\N	\N	\N	127970	127970	295604
16480	21514	1	applied	\N	\N	\N	\N	127971	127971	295605
16480	21515	2	applied	\N	\N	\N	\N	127972	127972	295606
16486	21534	0	applied	\N	\N	\N	\N	128000	128000	295634
16486	21535	1	applied	\N	\N	\N	\N	128001	128001	295635
16486	21536	2	applied	\N	\N	\N	\N	128002	128002	295636
16488	21535	1	applied	\N	\N	\N	\N	128007	128007	295641
16488	21536	2	applied	\N	\N	\N	\N	128008	128008	295642
16489	21537	0	applied	\N	\N	\N	\N	128009	128009	295643
16489	21538	1	applied	\N	\N	\N	\N	128010	128010	295644
16489	21539	2	applied	\N	\N	\N	\N	128011	128011	295645
16492	21544	0	applied	\N	\N	\N	\N	128020	128020	295654
16492	21545	1	applied	\N	\N	\N	\N	128021	128021	295655
16492	21546	2	applied	\N	\N	\N	\N	128022	128022	295656
16492	21547	3	applied	\N	\N	\N	\N	128023	128023	295657
16495	21554	0	applied	\N	\N	\N	\N	128034	128034	295668
16495	21555	1	applied	\N	\N	\N	\N	128035	128035	295669
16495	21556	2	applied	\N	\N	\N	\N	128036	128036	295670
16495	21557	3	applied	\N	\N	\N	\N	128037	128037	295671
16498	21574	0	applied	\N	\N	\N	\N	128054	128054	295688
16498	21575	1	applied	\N	\N	\N	\N	128055	128055	295689
16498	21576	2	applied	\N	\N	\N	\N	128056	128056	295690
16503	21585	0	applied	\N	\N	\N	\N	128076	128076	295710
16503	21586	1	applied	\N	\N	\N	\N	128077	128077	295711
16503	21587	2	applied	\N	\N	\N	\N	128078	128078	295712
16503	21588	3	applied	\N	\N	\N	\N	128079	128079	295713
16503	21589	4	applied	\N	\N	\N	\N	128080	128080	295714
16503	21590	5	applied	\N	\N	\N	\N	128081	128081	295715
16503	21591	6	applied	\N	\N	\N	\N	128082	128082	295716
16503	21592	7	applied	\N	\N	\N	\N	128083	128083	295717
16509	21607	0	applied	\N	\N	\N	\N	128116	128116	295750
16509	21608	1	applied	\N	\N	\N	\N	128117	128117	295751
16509	21609	2	applied	\N	\N	\N	\N	128118	128118	295752
16509	21610	3	applied	\N	\N	\N	\N	128119	128119	295753
16509	21611	4	applied	\N	\N	\N	\N	128120	128120	295754
16509	21612	5	applied	\N	\N	\N	\N	128121	128121	295755
16454	21373	68	applied	\N	\N	\N	\N	127818	127818	295459
16454	21384	69	applied	\N	\N	\N	\N	127819	127819	295460
16510	21614	0	applied	\N	\N	\N	\N	128123	128123	295757
16510	21615	1	applied	\N	\N	\N	\N	128124	128124	295758
16510	21616	2	applied	\N	\N	\N	\N	128125	128125	295759
16510	21617	3	applied	\N	\N	\N	\N	128126	128126	295760
16510	21618	5	applied	\N	\N	\N	\N	128127	128127	295761
16510	21619	6	applied	\N	\N	\N	\N	128128	128128	295762
16510	21620	7	applied	\N	\N	\N	\N	128129	128129	295763
16510	21621	8	applied	\N	\N	\N	\N	128130	128130	295764
16510	21622	9	applied	\N	\N	\N	\N	128131	128131	295765
16510	21623	10	applied	\N	\N	\N	\N	128132	128132	295766
16510	21624	11	applied	\N	\N	\N	\N	128133	128133	295767
16510	21625	12	applied	\N	\N	\N	\N	128134	128134	295768
16510	21626	13	applied	\N	\N	\N	\N	128135	128135	295769
16510	21627	14	applied	\N	\N	\N	\N	128136	128136	295770
16510	21628	15	applied	\N	\N	\N	\N	128137	128137	295771
16510	21629	16	applied	\N	\N	\N	\N	128138	128138	295772
16512	21631	1	applied	\N	\N	\N	\N	128144	128144	295778
16512	21632	2	applied	\N	\N	\N	\N	128145	128145	295779
16512	21633	3	applied	\N	\N	\N	\N	128146	128146	295780
16515	21630	0	applied	\N	\N	\N	\N	128155	128155	295789
16515	21631	1	applied	\N	\N	\N	\N	128156	128156	295790
16515	21632	2	applied	\N	\N	\N	\N	128157	128157	295791
16515	21633	3	applied	\N	\N	\N	\N	128158	128158	295792
16516	21634	0	applied	\N	\N	\N	\N	128159	128159	295793
16516	21635	1	applied	\N	\N	\N	\N	128160	128160	295794
16516	21636	2	applied	\N	\N	\N	\N	128161	128161	295795
16517	21634	0	applied	\N	\N	\N	\N	128162	128162	295796
16517	21635	1	applied	\N	\N	\N	\N	128163	128163	295797
16517	21636	2	applied	\N	\N	\N	\N	128164	128164	295798
16518	21634	0	applied	\N	\N	\N	\N	128165	128165	295799
16518	21636	1	applied	\N	\N	\N	\N	128166	128166	295800
16520	21637	0	applied	\N	\N	\N	\N	128171	128171	295805
16520	21635	2	applied	\N	\N	\N	\N	128173	128173	295807
16520	21639	3	applied	\N	\N	\N	\N	128174	128174	295808
16521	21640	0	applied	\N	\N	\N	\N	128175	128175	295809
16521	21641	1	applied	\N	\N	\N	\N	128176	128176	295810
16521	21642	2	applied	\N	\N	\N	\N	128177	128177	295811
16521	21643	3	applied	\N	\N	\N	\N	128178	128178	295812
16525	21644	0	applied	\N	\N	\N	\N	128196	128196	295823
16525	21645	1	applied	\N	\N	\N	\N	128197	128197	295824
16525	21646	2	applied	\N	\N	\N	\N	128198	128198	295825
16528	21659	0	applied	\N	\N	\N	\N	128211	128211	295838
16528	21660	1	applied	\N	\N	\N	\N	128212	128212	295839
16528	21661	2	applied	\N	\N	\N	\N	128213	128213	295840
16529	21659	0	applied	\N	\N	\N	\N	128214	128214	295841
16529	21660	1	applied	\N	\N	\N	\N	128215	128215	295842
16529	21661	2	applied	\N	\N	\N	\N	128216	128216	295843
16531	21662	0	applied	\N	\N	\N	\N	128220	128220	295847
16531	21664	2	applied	\N	\N	\N	\N	128222	128222	295849
16531	21665	3	applied	\N	\N	\N	\N	128223	128223	295850
16531	21666	4	applied	\N	\N	\N	\N	128224	128224	295851
16531	21667	5	applied	\N	\N	\N	\N	128225	128225	295852
16531	21668	6	applied	\N	\N	\N	\N	128226	128226	295853
16533	21669	0	applied	\N	\N	\N	\N	128234	128234	295861
16533	21670	1	applied	\N	\N	\N	\N	128235	128235	295862
16533	21671	2	applied	\N	\N	\N	\N	128236	128236	295863
16536	21669	0	applied	\N	\N	\N	\N	128243	128243	295870
16536	21670	1	applied	\N	\N	\N	\N	128244	128244	295871
16536	21671	2	applied	\N	\N	\N	\N	128245	128245	295872
16542	21672	0	applied	\N	\N	\N	\N	128251	128251	295878
16542	21673	1	applied	\N	\N	\N	\N	128252	128252	295879
16542	21674	2	applied	\N	\N	\N	\N	128253	128253	295880
16542	21675	3	applied	\N	\N	\N	\N	128254	128254	295881
16542	21676	4	applied	\N	\N	\N	\N	128255	128255	295882
16542	21678	6	applied	\N	\N	\N	\N	128257	128257	295884
16542	21679	7	applied	\N	\N	\N	\N	128258	128258	295885
16542	21680	8	applied	\N	\N	\N	\N	128259	128259	295886
16542	21681	9	applied	\N	\N	\N	\N	128260	128260	295887
16542	21682	10	applied	\N	\N	\N	\N	128261	128261	295888
16542	21683	11	applied	\N	\N	\N	\N	128262	128262	295889
16542	21684	12	applied	\N	\N	\N	\N	128263	128263	295890
16542	21685	13	applied	\N	\N	\N	\N	128264	128264	295891
16545	21672	0	applied	\N	\N	\N	\N	128279	128279	295906
16545	21673	1	applied	\N	\N	\N	\N	128280	128280	295907
16545	21674	2	applied	\N	\N	\N	\N	128281	128281	295908
16545	21675	3	applied	\N	\N	\N	\N	128282	128282	295909
16545	21676	4	applied	\N	\N	\N	\N	128283	128283	295910
16545	21677	5	applied	\N	\N	\N	\N	128284	128284	295911
16545	21678	6	applied	\N	\N	\N	\N	128285	128285	295912
16545	21679	7	applied	\N	\N	\N	\N	128286	128286	295913
16545	21681	9	applied	\N	\N	\N	\N	128288	128288	295915
16545	21682	10	applied	\N	\N	\N	\N	128289	128289	295916
16545	21683	11	applied	\N	\N	\N	\N	128290	128290	295917
16545	21684	12	applied	\N	\N	\N	\N	128291	128291	295918
16545	21685	13	applied	\N	\N	\N	\N	128292	128292	295919
16551	21686	0	applied	\N	\N	\N	\N	128317	128317	295944
16551	21687	1	applied	\N	\N	\N	\N	128318	128318	295945
16551	21688	2	applied	\N	\N	\N	\N	128319	128319	295946
16551	21689	3	applied	\N	\N	\N	\N	128320	128320	295947
16552	21686	0	applied	\N	\N	\N	\N	128321	128321	295948
16552	21687	1	applied	\N	\N	\N	\N	128322	128322	295949
16552	21688	2	applied	\N	\N	\N	\N	128323	128323	295950
16552	21689	3	applied	\N	\N	\N	\N	128324	128324	295951
16553	21690	0	applied	\N	\N	\N	\N	128325	128325	295952
16554	21691	0	applied	\N	\N	\N	\N	128326	128326	295953
16554	21692	1	applied	\N	\N	\N	\N	128327	128327	295954
16554	21694	3	applied	\N	\N	\N	\N	128329	128329	295956
16554	21695	4	applied	\N	\N	\N	\N	128330	128330	295957
16555	21696	0	applied	\N	\N	\N	\N	128331	128331	295958
16555	21697	1	applied	\N	\N	\N	\N	128332	128332	295959
16555	21698	2	applied	\N	\N	\N	\N	128333	128333	295960
16555	21699	3	applied	\N	\N	\N	\N	128334	128334	295961
16555	21700	4	applied	\N	\N	\N	\N	128335	128335	295962
16555	21701	5	applied	\N	\N	\N	\N	128336	128336	295963
16555	21702	6	applied	\N	\N	\N	\N	128337	128337	295964
16555	21703	7	applied	\N	\N	\N	\N	128338	128338	295965
16555	21704	8	applied	\N	\N	\N	\N	128339	128339	295966
16555	21705	9	applied	\N	\N	\N	\N	128340	128340	295967
16555	21706	10	applied	\N	\N	\N	\N	128341	128341	295968
16557	21709	0	applied	\N	\N	\N	\N	128347	128347	295974
16508	21612	5	applied	\N	\N	\N	\N	128114	128114	295748
16508	21613	6	applied	\N	\N	\N	\N	128115	128115	295749
16522	21643	3	applied	\N	\N	\N	\N	128182	128182	295816
16526	21647	0	applied	\N	\N	\N	\N	128199	128199	295826
16526	21648	1	applied	\N	\N	\N	\N	128200	128200	295827
16526	21649	2	applied	\N	\N	\N	\N	128201	128201	295828
16526	21650	3	applied	\N	\N	\N	\N	128202	128202	295829
16526	21651	4	applied	\N	\N	\N	\N	128203	128203	295830
16530	21659	0	applied	\N	\N	\N	\N	128217	128217	295844
16530	21660	1	applied	\N	\N	\N	\N	128218	128218	295845
16530	21661	2	applied	\N	\N	\N	\N	128219	128219	295846
16534	21669	0	applied	\N	\N	\N	\N	128237	128237	295864
16534	21670	1	applied	\N	\N	\N	\N	128238	128238	295865
16537	21669	0	applied	\N	\N	\N	\N	128246	128246	295873
16537	21670	1	applied	\N	\N	\N	\N	128247	128247	295874
16537	21671	2	applied	\N	\N	\N	\N	128248	128248	295875
16546	21672	0	applied	\N	\N	\N	\N	128293	128293	295920
16546	21673	1	applied	\N	\N	\N	\N	128294	128294	295921
16546	21674	2	applied	\N	\N	\N	\N	128295	128295	295922
16546	21675	3	applied	\N	\N	\N	\N	128296	128296	295923
16546	21676	4	applied	\N	\N	\N	\N	128297	128297	295924
16546	21677	5	applied	\N	\N	\N	\N	128298	128298	295925
16546	21678	6	applied	\N	\N	\N	\N	128299	128299	295926
16546	21679	7	applied	\N	\N	\N	\N	128300	128300	295927
16546	21680	8	applied	\N	\N	\N	\N	128301	128301	295928
16546	21681	9	applied	\N	\N	\N	\N	128302	128302	295929
16546	21682	10	applied	\N	\N	\N	\N	128303	128303	295930
16546	21683	11	applied	\N	\N	\N	\N	128304	128304	295931
16546	21684	12	applied	\N	\N	\N	\N	128305	128305	295932
16550	21686	0	applied	\N	\N	\N	\N	128313	128313	295940
16550	21687	1	applied	\N	\N	\N	\N	128314	128314	295941
16550	21688	2	applied	\N	\N	\N	\N	128315	128315	295942
16550	21689	3	applied	\N	\N	\N	\N	128316	128316	295943
16557	21710	1	applied	\N	\N	\N	\N	128348	128348	295975
16557	21711	2	applied	\N	\N	\N	\N	128349	128349	295976
16558	21709	0	applied	\N	\N	\N	\N	128350	128350	295977
16558	21710	1	applied	\N	\N	\N	\N	128351	128351	295978
16558	21711	2	applied	\N	\N	\N	\N	128352	128352	295979
16559	21712	0	applied	\N	\N	\N	\N	128353	128353	295980
16559	21713	1	applied	\N	\N	\N	\N	128354	128354	295981
16559	21714	2	applied	\N	\N	\N	\N	128355	128355	295982
16561	21715	0	applied	\N	\N	\N	\N	128359	128359	295986
16561	21716	1	applied	\N	\N	\N	\N	128360	128360	295987
16561	21717	2	applied	\N	\N	\N	\N	128361	128361	295988
16564	21673	0	applied	\N	\N	\N	\N	128371	128371	295997
16564	21663	3	applied	\N	\N	\N	\N	128374	128374	295999
16564	21719	2	failed	Receiver_not_present	\N	\N	\N	128373	128373	\N
16564	21669	4	applied	\N	\N	\N	\N	128375	128375	296000
16564	21672	5	applied	\N	\N	\N	\N	128376	128376	296001
16564	21674	6	applied	\N	\N	\N	\N	128377	128377	296002
16564	21675	7	applied	\N	\N	\N	\N	128378	128378	296003
16564	21676	8	applied	\N	\N	\N	\N	128379	128379	296004
16564	21686	9	applied	\N	\N	\N	\N	128380	128380	296005
16564	21691	10	applied	\N	\N	\N	\N	128381	128381	296006
16564	21692	11	applied	\N	\N	\N	\N	128382	128382	296007
16564	21696	12	applied	\N	\N	\N	\N	128383	128383	296008
16564	21697	13	applied	\N	\N	\N	\N	128384	128384	296009
16564	21698	14	applied	\N	\N	\N	\N	128385	128385	296010
16564	21699	15	applied	\N	\N	\N	\N	128386	128386	296011
16564	21709	16	applied	\N	\N	\N	\N	128387	128387	296012
16564	21712	17	applied	\N	\N	\N	\N	128388	128388	296013
16564	21718	19	applied	\N	\N	\N	\N	128390	128390	296015
16564	21724	20	applied	\N	\N	\N	\N	128391	128391	296016
16564	21727	21	applied	\N	\N	\N	\N	128392	128392	296017
16564	21664	22	applied	\N	\N	\N	\N	128393	128393	296018
16564	21665	23	applied	\N	\N	\N	\N	128394	128394	296019
16564	21666	24	applied	\N	\N	\N	\N	128395	128395	296020
16564	21667	25	applied	\N	\N	\N	\N	128396	128396	296021
16564	21677	26	applied	\N	\N	\N	\N	128397	128397	296022
16564	21688	27	applied	\N	\N	\N	\N	128398	128398	296023
16564	21702	28	applied	\N	\N	\N	\N	128399	128399	296024
16564	21668	29	applied	\N	\N	\N	\N	128400	128400	296025
16564	21670	30	applied	\N	\N	\N	\N	128401	128401	296026
16564	21678	31	applied	\N	\N	\N	\N	128402	128402	296027
16564	21679	32	applied	\N	\N	\N	\N	128403	128403	296028
16564	21680	33	applied	\N	\N	\N	\N	128404	128404	296029
16564	21681	34	applied	\N	\N	\N	\N	128405	128405	296030
16564	21693	36	applied	\N	\N	\N	\N	128407	128407	296032
16564	21694	37	applied	\N	\N	\N	\N	128408	128408	296033
16564	21700	38	applied	\N	\N	\N	\N	128409	128409	296034
16564	21701	39	applied	\N	\N	\N	\N	128410	128410	296035
16564	21671	40	applied	\N	\N	\N	\N	128411	128411	296036
16564	21682	41	applied	\N	\N	\N	\N	128412	128412	296037
16564	21683	42	applied	\N	\N	\N	\N	128413	128413	296038
16564	21684	43	applied	\N	\N	\N	\N	128414	128414	296039
16564	21685	44	applied	\N	\N	\N	\N	128415	128415	296040
16564	21689	45	applied	\N	\N	\N	\N	128416	128416	296041
16564	21690	46	applied	\N	\N	\N	\N	128417	128417	296042
16564	21707	47	applied	\N	\N	\N	\N	128418	128418	296043
16564	21708	48	applied	\N	\N	\N	\N	128419	128419	296044
16564	21713	49	applied	\N	\N	\N	\N	128420	128420	296045
16564	21717	50	applied	\N	\N	\N	\N	128421	128421	296046
16564	21721	51	applied	\N	\N	\N	\N	128422	128422	296047
16564	21725	53	applied	\N	\N	\N	\N	128424	128424	296049
16564	21728	54	applied	\N	\N	\N	\N	128425	128425	296050
16564	21695	55	applied	\N	\N	\N	\N	128426	128426	296051
16564	21703	56	applied	\N	\N	\N	\N	128427	128427	296052
16564	21704	57	applied	\N	\N	\N	\N	128428	128428	296053
16564	21705	58	applied	\N	\N	\N	\N	128429	128429	296054
16564	21706	59	applied	\N	\N	\N	\N	128430	128430	296055
16564	21710	60	applied	\N	\N	\N	\N	128431	128431	296056
16564	21714	61	applied	\N	\N	\N	\N	128432	128432	296057
16564	21716	62	applied	\N	\N	\N	\N	128433	128433	296058
16564	21720	63	applied	\N	\N	\N	\N	128434	128434	296059
16564	21726	64	applied	\N	\N	\N	\N	128435	128435	296060
16564	21729	66	applied	\N	\N	\N	\N	128436	128436	296061
16564	21711	67	applied	\N	\N	\N	\N	128437	128437	296062
16564	21722	68	applied	\N	\N	\N	\N	128438	128438	296063
16564	21730	69	applied	\N	\N	\N	\N	128439	128439	296064
16567	21738	1	applied	\N	\N	1000000000	\N	128451	128451	296076
16567	21739	2	applied	\N	\N	\N	\N	128452	128452	296077
16522	21641	1	applied	\N	\N	\N	\N	128180	128180	295814
16522	21642	2	applied	\N	\N	\N	\N	128181	128181	295815
16524	21641	1	applied	\N	\N	\N	\N	128193	128193	295820
16524	21642	2	applied	\N	\N	\N	\N	128194	128194	295821
16524	21643	3	applied	\N	\N	\N	\N	128195	128195	295822
16527	21652	0	applied	\N	\N	\N	\N	128204	128204	295831
16527	21653	1	applied	\N	\N	\N	\N	128205	128205	295832
16527	21654	2	applied	\N	\N	\N	\N	128206	128206	295833
16527	21655	3	applied	\N	\N	\N	\N	128207	128207	295834
16527	21656	4	applied	\N	\N	\N	\N	128208	128208	295835
16527	21657	5	applied	\N	\N	\N	\N	128209	128209	295836
16527	21658	6	applied	\N	\N	\N	\N	128210	128210	295837
16532	21662	0	applied	\N	\N	\N	\N	128227	128227	295854
16532	21663	1	applied	\N	\N	\N	\N	128228	128228	295855
16532	21664	2	applied	\N	\N	\N	\N	128229	128229	295856
16532	21665	3	applied	\N	\N	\N	\N	128230	128230	295857
16532	21667	5	applied	\N	\N	\N	\N	128232	128232	295859
16532	21668	6	applied	\N	\N	\N	\N	128233	128233	295860
16535	21669	0	applied	\N	\N	\N	\N	128240	128240	295867
16535	21670	1	applied	\N	\N	\N	\N	128241	128241	295868
16535	21671	2	applied	\N	\N	\N	\N	128242	128242	295869
16538	21670	0	applied	\N	\N	\N	\N	128249	128249	295876
16538	21671	1	applied	\N	\N	\N	\N	128250	128250	295877
16544	21672	0	applied	\N	\N	\N	\N	128265	128265	295892
16544	21673	1	applied	\N	\N	\N	\N	128266	128266	295893
16544	21674	2	applied	\N	\N	\N	\N	128267	128267	295894
16544	21675	3	applied	\N	\N	\N	\N	128268	128268	295895
16544	21676	4	applied	\N	\N	\N	\N	128269	128269	295896
16544	21677	5	applied	\N	\N	\N	\N	128270	128270	295897
16544	21678	6	applied	\N	\N	\N	\N	128271	128271	295898
16544	21679	7	applied	\N	\N	\N	\N	128272	128272	295899
16544	21680	8	applied	\N	\N	\N	\N	128273	128273	295900
16544	21682	10	applied	\N	\N	\N	\N	128275	128275	295902
16544	21683	11	applied	\N	\N	\N	\N	128276	128276	295903
16544	21684	12	applied	\N	\N	\N	\N	128277	128277	295904
16563	21724	0	applied	\N	\N	\N	\N	128368	128368	295994
16563	21725	1	applied	\N	\N	\N	\N	128369	128369	295995
16563	21726	2	applied	\N	\N	\N	\N	128370	128370	295996
16565	21727	0	applied	\N	\N	\N	\N	128440	128440	296065
16565	21729	1	applied	\N	\N	\N	\N	128441	128441	296066
16565	21730	2	applied	\N	\N	\N	\N	128442	128442	296067
16565	21728	3	applied	\N	\N	\N	\N	128443	128443	296068
16566	21731	0	applied	\N	\N	\N	\N	128444	128444	296069
16566	21732	1	applied	\N	\N	\N	\N	128445	128445	296070
16566	21733	2	applied	\N	\N	\N	\N	128446	128446	296071
16566	21734	3	applied	\N	\N	\N	\N	128447	128447	296072
16566	21735	4	applied	\N	\N	\N	\N	128448	128448	296073
16566	21736	5	applied	\N	\N	\N	\N	128449	128449	296074
16570	21732	1	applied	\N	\N	\N	\N	128463	128463	296088
16570	21737	2	applied	\N	\N	\N	\N	128464	128464	296089
16570	21741	3	applied	\N	\N	\N	\N	128465	128465	296090
16570	21738	4	applied	\N	\N	1000000000	\N	128466	128466	296091
16570	21733	5	applied	\N	\N	\N	\N	128467	128467	296092
16570	21734	6	applied	\N	\N	\N	\N	128468	128468	296093
16570	21735	7	applied	\N	\N	\N	\N	128469	128469	296094
16570	21739	8	applied	\N	\N	\N	\N	128470	128470	296095
16570	21742	9	applied	\N	\N	\N	\N	128471	128471	296096
16570	21743	10	applied	\N	\N	\N	\N	128472	128472	296097
16570	21736	11	applied	\N	\N	\N	\N	128473	128473	296098
16570	21740	12	applied	\N	\N	\N	\N	128474	128474	296099
16570	21744	13	applied	\N	\N	\N	\N	128475	128475	296100
16573	21741	0	applied	\N	\N	\N	\N	128492	128492	296117
16573	21745	1	applied	\N	\N	\N	\N	128493	128493	296118
16573	21742	2	applied	\N	\N	\N	\N	128494	128494	296119
16573	21743	4	applied	\N	\N	\N	\N	128496	128496	296121
16573	21744	5	applied	\N	\N	\N	\N	128497	128497	296122
16575	21752	0	applied	\N	\N	\N	\N	128503	128503	296128
16575	21753	1	applied	\N	\N	\N	\N	128504	128504	296129
16575	21754	2	applied	\N	\N	\N	\N	128505	128505	296130
16575	21755	3	applied	\N	\N	\N	\N	128506	128506	296131
16578	21756	0	applied	\N	\N	\N	\N	128545	128545	296158
16578	21757	1	applied	\N	\N	\N	\N	128546	128546	296159
16578	21758	2	applied	\N	\N	\N	\N	128547	128547	296160
16578	21759	3	applied	\N	\N	\N	\N	128548	128548	296161
16578	21760	4	applied	\N	\N	\N	\N	128549	128549	296162
16578	21761	5	applied	\N	\N	\N	\N	128550	128550	296163
16578	21762	6	applied	\N	\N	\N	\N	128551	128551	296164
16578	21763	7	applied	\N	\N	\N	\N	128552	128552	296165
16578	21764	8	applied	\N	\N	\N	\N	128553	128553	296166
16578	21765	9	applied	\N	\N	\N	\N	128554	128554	296167
16580	21767	1	applied	\N	\N	\N	\N	128566	128566	296179
16580	21768	2	applied	\N	\N	\N	\N	128567	128567	296180
16580	21769	3	applied	\N	\N	\N	\N	128568	128568	296181
16583	21766	0	applied	\N	\N	\N	\N	128581	128581	296194
16583	21767	1	applied	\N	\N	\N	\N	128582	128582	296195
16583	21770	2	applied	\N	\N	\N	\N	128583	128583	296196
16583	21768	3	applied	\N	\N	\N	\N	128584	128584	296197
16583	21769	4	applied	\N	\N	\N	\N	128585	128585	296198
16583	21771	5	applied	\N	\N	\N	\N	128586	128586	296199
16587	21778	0	applied	\N	\N	\N	\N	128732	128732	296342
16587	21779	1	applied	\N	\N	\N	\N	128733	128733	296343
16587	21780	2	applied	\N	\N	\N	\N	128734	128734	296344
16587	21781	3	applied	\N	\N	\N	\N	128735	128735	296345
16587	21782	4	applied	\N	\N	\N	\N	128736	128736	296346
16587	21783	5	applied	\N	\N	\N	\N	128737	128737	296347
16592	21794	0	applied	\N	\N	\N	\N	128756	128756	296366
16592	21796	2	applied	\N	\N	\N	\N	128758	128758	296368
16596	21798	0	applied	\N	\N	\N	\N	128769	128769	128769
16596	21799	1	applied	\N	\N	\N	\N	128770	128770	296379
16596	21800	2	applied	\N	\N	\N	\N	128771	128771	296380
16596	21801	3	applied	\N	\N	\N	\N	128772	128772	296381
16596	21802	4	applied	\N	\N	\N	\N	128773	128773	296382
16599	21803	0	applied	\N	\N	\N	\N	128782	128782	296390
16599	21804	2	applied	\N	\N	\N	\N	128783	128783	296391
16599	21805	3	applied	\N	\N	\N	\N	128784	128784	296392
16604	21810	0	applied	\N	\N	\N	\N	128795	128795	296403
16604	21811	1	applied	\N	\N	\N	\N	128796	128796	296404
16604	21809	2	applied	\N	\N	\N	\N	128797	128797	296405
16607	21810	0	applied	\N	\N	\N	\N	128804	128804	296412
16607	21811	1	applied	\N	\N	\N	\N	128805	128805	296413
16607	21809	2	applied	\N	\N	\N	\N	128806	128806	296414
16611	21810	0	applied	\N	\N	\N	\N	128841	128841	296449
16524	21640	0	applied	\N	\N	\N	\N	128192	128192	295819
16547	21674	2	applied	\N	\N	\N	\N	128309	128309	295936
16547	21675	3	applied	\N	\N	\N	\N	128310	128310	295937
16547	21676	4	applied	\N	\N	\N	\N	128311	128311	295938
16547	21677	5	applied	\N	\N	\N	\N	128312	128312	295939
16555	21707	11	applied	\N	\N	\N	\N	128342	128342	295969
16555	21708	12	applied	\N	\N	\N	\N	128343	128343	295970
16556	21709	0	applied	\N	\N	\N	\N	128344	128344	295971
16556	21710	1	applied	\N	\N	\N	\N	128345	128345	295972
16556	21711	2	applied	\N	\N	\N	\N	128346	128346	295973
16560	21713	1	applied	\N	\N	\N	\N	128357	128357	295984
16560	21714	2	applied	\N	\N	\N	\N	128358	128358	295985
16562	21718	0	applied	\N	\N	\N	\N	128362	128362	295989
16562	21720	2	applied	\N	\N	\N	\N	128364	128364	295990
16562	21719	1	failed	Receiver_not_present	\N	\N	\N	128363	128363	\N
16562	21721	3	applied	\N	\N	\N	\N	128365	128365	295991
16562	21722	4	applied	\N	\N	\N	\N	128366	128366	295992
16562	21723	5	applied	\N	\N	\N	\N	128367	128367	295993
16568	21737	0	applied	\N	\N	\N	\N	128454	128454	296079
16568	21738	1	applied	\N	\N	1000000000	\N	128455	128455	296080
16568	21739	2	applied	\N	\N	\N	\N	128456	128456	296081
16568	21740	3	applied	\N	\N	\N	\N	128457	128457	296082
16569	21737	0	applied	\N	\N	\N	\N	128458	128458	296083
16569	21738	1	applied	\N	\N	1000000000	\N	128459	128459	296084
16569	21739	2	applied	\N	\N	\N	\N	128460	128460	296085
16569	21740	3	applied	\N	\N	\N	\N	128461	128461	296086
16571	21745	1	applied	\N	\N	\N	\N	128477	128477	296102
16571	21746	2	applied	\N	\N	\N	\N	128478	128478	296103
16571	21742	3	applied	\N	\N	\N	\N	128479	128479	296104
16571	21747	4	applied	\N	\N	\N	\N	128480	128480	296105
16571	21743	5	applied	\N	\N	\N	\N	128481	128481	296106
16571	21744	6	applied	\N	\N	\N	\N	128482	128482	296107
16571	21748	7	applied	\N	\N	\N	\N	128483	128483	296108
16572	21741	0	applied	\N	\N	\N	\N	128484	128484	296109
16572	21745	1	applied	\N	\N	\N	\N	128485	128485	296110
16572	21746	2	applied	\N	\N	\N	\N	128486	128486	296111
16572	21742	3	applied	\N	\N	\N	\N	128487	128487	296112
16572	21747	4	applied	\N	\N	\N	\N	128488	128488	296113
16572	21743	5	applied	\N	\N	\N	\N	128489	128489	296114
16572	21744	6	applied	\N	\N	\N	\N	128490	128490	296115
16572	21748	7	applied	\N	\N	\N	\N	128491	128491	296116
16574	21749	0	applied	\N	\N	\N	\N	128498	128498	296123
16574	21750	2	applied	\N	\N	\N	\N	128500	128500	296125
16574	21748	3	applied	\N	\N	\N	\N	128501	128501	296126
16574	21751	4	applied	\N	\N	\N	\N	128502	128502	296127
16577	21756	0	applied	\N	\N	\N	\N	128535	128535	296148
16577	21757	1	applied	\N	\N	\N	\N	128536	128536	296149
16577	21758	2	applied	\N	\N	\N	\N	128537	128537	296150
16577	21759	3	applied	\N	\N	\N	\N	128538	128538	296151
16577	21760	4	applied	\N	\N	\N	\N	128539	128539	296152
16577	21761	5	applied	\N	\N	\N	\N	128540	128540	296153
16577	21762	6	applied	\N	\N	\N	\N	128541	128541	296154
16577	21763	7	applied	\N	\N	\N	\N	128542	128542	296155
16577	21764	8	applied	\N	\N	\N	\N	128543	128543	296156
16577	21765	9	applied	\N	\N	\N	\N	128544	128544	296157
16579	21756	0	applied	\N	\N	\N	\N	128555	128555	296168
16579	21757	1	applied	\N	\N	\N	\N	128556	128556	296169
16579	21758	2	applied	\N	\N	\N	\N	128557	128557	296170
16579	21760	4	applied	\N	\N	\N	\N	128559	128559	296172
16579	21761	5	applied	\N	\N	\N	\N	128560	128560	296173
16579	21762	6	applied	\N	\N	\N	\N	128561	128561	296174
16579	21763	7	applied	\N	\N	\N	\N	128562	128562	296175
16579	21764	8	applied	\N	\N	\N	\N	128563	128563	296176
16579	21765	9	applied	\N	\N	\N	\N	128564	128564	296177
16581	21766	0	applied	\N	\N	\N	\N	128569	128569	296182
16581	21767	1	applied	\N	\N	\N	\N	128570	128570	296183
16581	21770	2	applied	\N	\N	\N	\N	128571	128571	296184
16581	21768	3	applied	\N	\N	\N	\N	128572	128572	296185
16581	21769	4	applied	\N	\N	\N	\N	128573	128573	296186
16581	21771	5	applied	\N	\N	\N	\N	128574	128574	296187
16584	21756	0	applied	\N	\N	\N	\N	128587	128587	296200
16584	21757	1	applied	\N	\N	\N	\N	128588	128588	296201
16584	21758	2	applied	\N	\N	\N	\N	128589	128589	296202
16584	21766	3	applied	\N	\N	\N	\N	128590	128590	296203
16584	21759	5	applied	\N	\N	\N	\N	128592	128592	296205
16584	21760	6	applied	\N	\N	\N	\N	128593	128593	296206
16584	21761	7	applied	\N	\N	\N	\N	128594	128594	296207
16584	21762	8	applied	\N	\N	\N	\N	128595	128595	296208
16584	21763	9	applied	\N	\N	\N	\N	128596	128596	296209
16584	21768	10	applied	\N	\N	\N	\N	128597	128597	296210
16584	21769	11	applied	\N	\N	\N	\N	128598	128598	296211
16585	21772	0	applied	\N	\N	\N	\N	128599	128599	296212
16585	21773	1	applied	\N	\N	\N	\N	128600	128600	296213
16585	21770	2	applied	\N	\N	\N	\N	128601	128601	296214
16585	21774	3	applied	\N	\N	\N	\N	128602	128602	296215
16585	21775	4	applied	\N	\N	\N	\N	128603	128603	296216
16585	21771	5	applied	\N	\N	\N	\N	128604	128604	296217
16585	21776	6	applied	\N	\N	\N	\N	128605	128605	296218
16585	21777	7	applied	\N	\N	\N	\N	128606	128606	296219
16589	21784	0	applied	\N	\N	\N	\N	128744	128744	296354
16589	21786	2	applied	\N	\N	\N	\N	128746	128746	296356
16589	21787	3	applied	\N	\N	\N	\N	128747	128747	296357
16589	21788	4	applied	\N	\N	\N	\N	128748	128748	296358
16590	21789	0	applied	\N	\N	\N	\N	128749	128749	296359
16590	21790	1	applied	\N	\N	\N	\N	128750	128750	296360
16590	21791	2	applied	\N	\N	\N	\N	128751	128751	296361
16590	21792	3	applied	\N	\N	\N	\N	128752	128752	296362
16590	21793	4	applied	\N	\N	\N	\N	128753	128753	296363
16593	21794	0	applied	\N	\N	\N	\N	128759	128759	296369
16593	21795	1	applied	\N	\N	\N	\N	128760	128760	296370
16593	21796	2	applied	\N	\N	\N	\N	128761	128761	296371
16597	21798	0	applied	\N	\N	\N	\N	128774	128774	128774
16597	21799	1	applied	\N	\N	\N	\N	128775	128775	296383
16597	21800	2	applied	\N	\N	\N	\N	128776	128776	296384
16597	21801	3	applied	\N	\N	\N	\N	128777	128777	296385
16597	21802	4	applied	\N	\N	\N	\N	128778	128778	296386
16601	21807	1	applied	\N	\N	\N	\N	128789	128789	296397
16601	21808	2	applied	\N	\N	\N	\N	128790	128790	296398
16605	21810	0	applied	\N	\N	\N	\N	128798	128798	296406
16605	21811	1	applied	\N	\N	\N	\N	128799	128799	296407
16547	21672	0	applied	\N	\N	\N	\N	128307	128307	295934
16547	21673	1	applied	\N	\N	\N	\N	128308	128308	295935
16576	21247	3	applied	\N	\N	\N	\N	128510	128510	296133
16576	21248	4	applied	\N	\N	\N	\N	128511	128511	296134
16576	21254	5	applied	\N	\N	\N	\N	128512	128512	296135
16576	21150	6	applied	\N	\N	1000000000	\N	128513	128513	296136
16576	21166	7	applied	\N	\N	\N	\N	128514	128514	296137
16576	21337	8	applied	\N	\N	1000000000	\N	128515	128515	296138
16576	21521	9	applied	\N	\N	1000000000	\N	128516	128516	296139
16576	21462	10	applied	\N	\N	1000000000	\N	128517	128517	296140
16576	21578	11	applied	\N	\N	1000000000	\N	128518	128518	296141
16576	21599	12	applied	\N	\N	1000000000	\N	128519	128519	296142
16576	21409	13	applied	\N	\N	\N	\N	128520	128520	296143
16576	21738	15	applied	\N	\N	1000000000	\N	128522	128522	296144
16576	21746	16	applied	\N	\N	\N	\N	128523	128523	296145
16576	20939	17	applied	\N	\N	\N	\N	128524	128524	296146
16576	21250	18	applied	\N	\N	\N	\N	128525	128525	296147
16576	21006	19	applied	\N	\N	\N	\N	128526	128526	128526
16576	21014	20	applied	\N	\N	\N	\N	128527	128527	128527
16576	21314	21	applied	\N	\N	\N	\N	128528	128528	128528
16576	21322	22	applied	\N	\N	\N	\N	128529	128529	128529
16576	21393	23	applied	\N	\N	\N	\N	128530	128530	128530
16576	21403	24	applied	\N	\N	\N	\N	128531	128531	128531
16576	21405	25	applied	\N	\N	\N	\N	128532	128532	128532
16576	21413	26	applied	\N	\N	\N	\N	128533	128533	128533
16576	21421	27	applied	\N	\N	\N	\N	128534	128534	128534
16582	21766	0	applied	\N	\N	\N	\N	128575	128575	296188
16582	21767	1	applied	\N	\N	\N	\N	128576	128576	296189
16582	21770	2	applied	\N	\N	\N	\N	128577	128577	296190
16582	21768	3	applied	\N	\N	\N	\N	128578	128578	296191
16582	21769	4	applied	\N	\N	\N	\N	128579	128579	296192
16582	21771	5	applied	\N	\N	\N	\N	128580	128580	296193
16586	21089	0	applied	\N	\N	\N	\N	128607	128607	128607
16598	21803	0	applied	\N	\N	\N	\N	128779	128779	296387
16598	21804	2	applied	\N	\N	\N	\N	128780	128780	296388
16598	21805	3	applied	\N	\N	\N	\N	128781	128781	296389
16600	21803	0	applied	\N	\N	\N	\N	128785	128785	296393
16600	21804	2	applied	\N	\N	\N	\N	128786	128786	296394
16600	21805	3	applied	\N	\N	\N	\N	128787	128787	296395
16603	21810	0	applied	\N	\N	\N	\N	128792	128792	296400
16603	21811	1	applied	\N	\N	\N	\N	128793	128793	296401
16603	21809	2	applied	\N	\N	\N	\N	128794	128794	296402
16606	21810	0	applied	\N	\N	\N	\N	128801	128801	296409
16606	21811	1	applied	\N	\N	\N	\N	128802	128802	296410
16606	21809	2	applied	\N	\N	\N	\N	128803	128803	296411
16609	21810	0	applied	\N	\N	\N	\N	128810	128810	296418
16609	21811	1	applied	\N	\N	\N	\N	128811	128811	296419
16609	21809	2	applied	\N	\N	\N	\N	128812	128812	296420
16613	21819	0	applied	\N	\N	\N	\N	128850	128850	296458
16613	21820	1	applied	\N	\N	\N	\N	128851	128851	296459
16613	21821	2	applied	\N	\N	\N	\N	128852	128852	296460
16616	21826	0	applied	\N	\N	\N	\N	128857	128857	296465
16616	21827	1	applied	\N	\N	\N	\N	128858	128858	296466
16616	21828	2	applied	\N	\N	\N	\N	128859	128859	296467
16620	21833	0	applied	\N	\N	\N	\N	128864	128864	296472
16620	21834	1	applied	\N	\N	\N	\N	128865	128865	296473
16623	21784	0	applied	\N	\N	\N	\N	128873	128873	296481
16623	21789	1	applied	\N	\N	\N	\N	128874	128874	296482
16623	21790	2	applied	\N	\N	\N	\N	128875	128875	296483
16623	21797	3	applied	\N	\N	\N	\N	128876	128876	296484
16623	21558	4	applied	\N	\N	\N	\N	128877	128877	296485
16623	21578	5	applied	\N	\N	1000000000	\N	128878	128878	296486
16623	21599	6	applied	\N	\N	1000000000	\N	128879	128879	296487
16623	21554	7	applied	\N	\N	\N	\N	128880	128880	296488
16623	21559	8	applied	\N	\N	\N	\N	128881	128881	296489
16623	21560	9	applied	\N	\N	\N	\N	128882	128882	296490
16623	21561	10	applied	\N	\N	\N	\N	128883	128883	296491
16623	21571	11	applied	\N	\N	\N	\N	128884	128884	296492
16623	21574	12	applied	\N	\N	\N	\N	128885	128885	296493
16623	21579	13	applied	\N	\N	\N	\N	128886	128886	296494
16623	21582	14	applied	\N	\N	\N	\N	128887	128887	296495
16623	21585	15	applied	\N	\N	\N	\N	128888	128888	296496
16623	21587	17	applied	\N	\N	\N	\N	128890	128890	296498
16623	21593	18	applied	\N	\N	\N	\N	128891	128891	296499
16623	21596	19	applied	\N	\N	\N	\N	128892	128892	296500
16623	21597	20	applied	\N	\N	\N	\N	128893	128893	296501
16623	21598	21	applied	\N	\N	\N	\N	128894	128894	296502
16623	21607	22	applied	\N	\N	\N	\N	128895	128895	296503
16623	21608	23	applied	\N	\N	\N	\N	128896	128896	296504
16623	21614	25	applied	\N	\N	\N	\N	128898	128898	296505
16623	21719	24	failed	Receiver_not_present	\N	\N	\N	128897	128897	\N
16623	21615	26	applied	\N	\N	\N	\N	128899	128899	296506
16623	21616	27	applied	\N	\N	\N	\N	128900	128900	296507
16623	21617	28	applied	\N	\N	\N	\N	128901	128901	296508
16623	21618	29	applied	\N	\N	\N	\N	128902	128902	296509
16623	21630	30	applied	\N	\N	\N	\N	128903	128903	296510
16623	21634	31	applied	\N	\N	\N	\N	128904	128904	296511
16623	21637	32	applied	\N	\N	\N	\N	128905	128905	296512
16623	21644	34	applied	\N	\N	\N	\N	128907	128907	296514
16623	21647	35	applied	\N	\N	\N	\N	128908	128908	296515
16623	21648	36	applied	\N	\N	\N	\N	128909	128909	296516
16623	21652	37	applied	\N	\N	\N	\N	128910	128910	296517
16623	21653	38	applied	\N	\N	\N	\N	128911	128911	296518
16623	21659	39	applied	\N	\N	\N	\N	128912	128912	296519
16623	21662	40	applied	\N	\N	\N	\N	128913	128913	296520
16623	21663	41	applied	\N	\N	\N	\N	128914	128914	296521
16623	21738	42	applied	\N	\N	1000000000	\N	128915	128915	296522
16623	21746	43	applied	\N	\N	\N	\N	128916	128916	296523
16623	21669	44	applied	\N	\N	\N	\N	128917	128917	296524
16623	21672	45	applied	\N	\N	\N	\N	128918	128918	296525
16623	21674	46	applied	\N	\N	\N	\N	128919	128919	296526
16623	21675	47	applied	\N	\N	\N	\N	128920	128920	296527
16623	21676	48	applied	\N	\N	\N	\N	128921	128921	296528
16623	21686	49	applied	\N	\N	\N	\N	128922	128922	296529
16623	21692	51	applied	\N	\N	\N	\N	128924	128924	296531
16623	21696	52	applied	\N	\N	\N	\N	128925	128925	296532
16623	21697	53	applied	\N	\N	\N	\N	128926	128926	296533
16623	21698	54	applied	\N	\N	\N	\N	128927	128927	296534
16623	21699	55	applied	\N	\N	\N	\N	128928	128928	296535
16623	21709	56	applied	\N	\N	\N	\N	128929	128929	296536
16576	21243	2	applied	\N	\N	\N	\N	128509	128509	296132
16576	21122	1	failed	Receiver_not_present	\N	\N	\N	128508	128508	\N
16586	21166	7	applied	\N	\N	\N	\N	128614	128614	296225
16586	21337	8	applied	\N	\N	1000000000	\N	128615	128615	296226
16586	21521	9	applied	\N	\N	1000000000	\N	128616	128616	296227
16586	21035	10	applied	\N	\N	\N	\N	128617	128617	296228
16586	21037	11	applied	\N	\N	\N	\N	128618	128618	296229
16586	21041	12	applied	\N	\N	\N	\N	128619	128619	296230
16586	21042	13	applied	\N	\N	\N	\N	128620	128620	296231
16586	21047	14	applied	\N	\N	\N	\N	128621	128621	296232
16586	21051	15	applied	\N	\N	\N	\N	128622	128622	296233
16586	21054	16	applied	\N	\N	\N	\N	128623	128623	296234
16586	21057	17	applied	\N	\N	\N	\N	128624	128624	296235
16586	21060	18	applied	\N	\N	\N	\N	128625	128625	296236
16586	21063	19	applied	\N	\N	\N	\N	128626	128626	296237
16586	21066	20	applied	\N	\N	\N	\N	128627	128627	296238
16586	21070	22	applied	\N	\N	\N	\N	128629	128629	296240
16586	21462	23	applied	\N	\N	1000000000	\N	128630	128630	296241
16586	21578	24	applied	\N	\N	1000000000	\N	128631	128631	296242
16586	21599	25	applied	\N	\N	1000000000	\N	128632	128632	296243
16586	21409	26	applied	\N	\N	\N	\N	128633	128633	296244
16586	21076	28	applied	\N	\N	\N	\N	128635	128635	296245
16586	21719	27	failed	Receiver_not_present	\N	\N	\N	128634	128634	\N
16586	21079	29	applied	\N	\N	\N	\N	128636	128636	296246
16586	21083	30	applied	\N	\N	\N	\N	128637	128637	296247
16586	21738	31	applied	\N	\N	1000000000	\N	128638	128638	296248
16586	21746	32	applied	\N	\N	\N	\N	128639	128639	296249
16586	21084	33	applied	\N	\N	\N	\N	128640	128640	296250
16586	21090	34	applied	\N	\N	\N	\N	128641	128641	296251
16586	21094	35	applied	\N	\N	\N	\N	128642	128642	296252
16586	21097	36	applied	\N	\N	\N	\N	128643	128643	296253
16586	21099	37	applied	\N	\N	\N	\N	128644	128644	296254
16586	21106	39	applied	\N	\N	\N	\N	128646	128646	296256
16586	21109	40	applied	\N	\N	\N	\N	128647	128647	296257
16586	21112	41	applied	\N	\N	\N	\N	128648	128648	296258
16586	21116	42	applied	\N	\N	\N	\N	128649	128649	296259
16586	21117	43	applied	\N	\N	\N	\N	128650	128650	296260
16586	21123	44	applied	\N	\N	\N	\N	128651	128651	296261
16586	21124	45	applied	\N	\N	\N	\N	128652	128652	296262
16586	21125	46	applied	\N	\N	\N	\N	128653	128653	296263
16586	21126	47	applied	\N	\N	\N	\N	128654	128654	296264
16586	21127	48	applied	\N	\N	\N	\N	128655	128655	296265
16586	21128	49	applied	\N	\N	\N	\N	128656	128656	296266
16586	21143	50	applied	\N	\N	\N	\N	128657	128657	296267
16586	21146	51	applied	\N	\N	\N	\N	128658	128658	296268
16586	21151	52	applied	\N	\N	\N	\N	128659	128659	296269
16586	21152	53	applied	\N	\N	\N	\N	128660	128660	296270
16586	21156	54	applied	\N	\N	\N	\N	128661	128661	296271
16586	21163	56	applied	\N	\N	\N	\N	128663	128663	296273
16586	21167	57	applied	\N	\N	\N	\N	128664	128664	296274
16586	21170	58	applied	\N	\N	\N	\N	128665	128665	296275
16586	21174	59	applied	\N	\N	\N	\N	128666	128666	296276
16586	21177	60	applied	\N	\N	\N	\N	128667	128667	296277
16586	21180	61	applied	\N	\N	\N	\N	128668	128668	296278
16586	21184	62	applied	\N	\N	\N	\N	128669	128669	296279
16586	21187	64	applied	\N	\N	\N	\N	128670	128670	296280
16586	21190	65	applied	\N	\N	\N	\N	128671	128671	296281
16586	21193	66	applied	\N	\N	\N	\N	128672	128672	296282
16586	21194	67	applied	\N	\N	\N	\N	128673	128673	296283
16586	21195	68	applied	\N	\N	\N	\N	128674	128674	296284
16586	21196	69	applied	\N	\N	\N	\N	128675	128675	296285
16586	21207	70	applied	\N	\N	\N	\N	128676	128676	296286
16586	21208	71	applied	\N	\N	\N	\N	128677	128677	296287
16586	21209	72	applied	\N	\N	\N	\N	128678	128678	296288
16586	21218	74	applied	\N	\N	\N	\N	128680	128680	296290
16586	21223	75	applied	\N	\N	\N	\N	128681	128681	296291
16586	21226	76	applied	\N	\N	\N	\N	128682	128682	296292
16586	21230	77	applied	\N	\N	\N	\N	128683	128683	296293
16586	21231	78	applied	\N	\N	\N	\N	128684	128684	296294
16586	21236	79	applied	\N	\N	\N	\N	128685	128685	296295
16586	21240	80	applied	\N	\N	\N	\N	128686	128686	296296
16586	21244	81	applied	\N	\N	\N	\N	128687	128687	296297
16586	21249	82	applied	\N	\N	\N	\N	128688	128688	296298
16586	21255	83	applied	\N	\N	\N	\N	128689	128689	296299
16586	21260	84	applied	\N	\N	\N	\N	128690	128690	296300
16586	21263	85	applied	\N	\N	\N	\N	128691	128691	296301
16586	21267	86	applied	\N	\N	\N	\N	128692	128692	296302
16586	21268	87	applied	\N	\N	\N	\N	128693	128693	296303
16586	21272	88	applied	\N	\N	\N	\N	128694	128694	296304
16586	21273	89	applied	\N	\N	\N	\N	128695	128695	296305
16586	21282	91	applied	\N	\N	\N	\N	128697	128697	296307
16586	21283	92	applied	\N	\N	\N	\N	128698	128698	296308
16586	21288	93	applied	\N	\N	\N	\N	128699	128699	296309
16586	21291	94	applied	\N	\N	\N	\N	128700	128700	296310
16586	21294	95	applied	\N	\N	\N	\N	128701	128701	296311
16586	21298	96	applied	\N	\N	\N	\N	128702	128702	296312
16586	21301	97	applied	\N	\N	\N	\N	128703	128703	296313
16586	21302	98	applied	\N	\N	\N	\N	128704	128704	296314
16586	21308	99	applied	\N	\N	\N	\N	128705	128705	296315
16586	21309	100	applied	\N	\N	\N	\N	128706	128706	296316
16586	21310	101	applied	\N	\N	\N	\N	128707	128707	296317
16586	21319	102	applied	\N	\N	\N	\N	128708	128708	296318
16586	21323	103	applied	\N	\N	\N	\N	128709	128709	296319
16586	21326	104	applied	\N	\N	\N	\N	128710	128710	296320
16586	21327	105	applied	\N	\N	\N	\N	128711	128711	296321
16586	21333	106	applied	\N	\N	\N	\N	128712	128712	296322
16586	21338	108	applied	\N	\N	\N	\N	128714	128714	296324
16586	21344	109	applied	\N	\N	\N	\N	128715	128715	296325
16586	21347	110	applied	\N	\N	\N	\N	128716	128716	296326
16586	21348	111	applied	\N	\N	\N	\N	128717	128717	296327
16586	21354	112	applied	\N	\N	\N	\N	128718	128718	296328
16586	21357	113	applied	\N	\N	\N	\N	128719	128719	296329
16586	21360	114	applied	\N	\N	\N	\N	128720	128720	296330
16586	21363	115	applied	\N	\N	\N	\N	128721	128721	296331
16586	21366	116	applied	\N	\N	\N	\N	128722	128722	296332
16586	21367	117	applied	\N	\N	\N	\N	128723	128723	296333
16586	21372	118	applied	\N	\N	\N	\N	128724	128724	296334
16586	21376	119	applied	\N	\N	\N	\N	128725	128725	296335
16586	21379	120	applied	\N	\N	\N	\N	128726	128726	296336
16586	21382	121	applied	\N	\N	\N	\N	128727	128727	296337
16586	21247	3	applied	\N	\N	\N	\N	128610	128610	296221
16586	21254	5	applied	\N	\N	\N	\N	128612	128612	296223
16588	21778	0	applied	\N	\N	\N	\N	128738	128738	296348
16588	21779	1	applied	\N	\N	\N	\N	128739	128739	296349
16588	21780	2	applied	\N	\N	\N	\N	128740	128740	296350
16588	21781	3	applied	\N	\N	\N	\N	128741	128741	296351
16588	21782	4	applied	\N	\N	\N	\N	128742	128742	296352
16588	21783	5	applied	\N	\N	\N	\N	128743	128743	296353
16591	21789	0	applied	\N	\N	\N	\N	128754	128754	296364
16591	21790	1	applied	\N	\N	\N	\N	128755	128755	296365
16594	21794	0	applied	\N	\N	\N	\N	128762	128762	296372
16594	21795	1	applied	\N	\N	\N	\N	128763	128763	296373
16594	21796	2	applied	\N	\N	\N	\N	128764	128764	296374
16595	21784	0	applied	\N	\N	\N	\N	128765	128765	296375
16595	21789	1	applied	\N	\N	\N	\N	128766	128766	296376
16595	21790	2	applied	\N	\N	\N	\N	128767	128767	296377
16602	21809	0	applied	\N	\N	\N	\N	128791	128791	296399
16605	21809	2	applied	\N	\N	\N	\N	128800	128800	296408
16608	21810	0	applied	\N	\N	\N	\N	128807	128807	296415
16608	21811	1	applied	\N	\N	\N	\N	128808	128808	296416
16608	21809	2	applied	\N	\N	\N	\N	128809	128809	296417
16610	21784	0	applied	\N	\N	\N	\N	128813	128813	296421
16610	21789	1	applied	\N	\N	\N	\N	128814	128814	296422
16610	21790	2	applied	\N	\N	\N	\N	128815	128815	296423
16610	21797	3	applied	\N	\N	\N	\N	128816	128816	296424
16610	21772	4	applied	\N	\N	\N	\N	128817	128817	296425
16610	21773	5	applied	\N	\N	\N	\N	128818	128818	296426
16610	21778	6	applied	\N	\N	\N	\N	128819	128819	296427
16610	21779	7	applied	\N	\N	\N	\N	128820	128820	296428
16610	21785	8	applied	\N	\N	\N	\N	128821	128821	296429
16610	21791	9	applied	\N	\N	\N	\N	128822	128822	296430
16610	21794	10	applied	\N	\N	\N	\N	128823	128823	296431
16610	21803	12	applied	\N	\N	\N	\N	128825	128825	296433
16610	21806	13	applied	\N	\N	\N	\N	128826	128826	296434
16610	21810	14	applied	\N	\N	\N	\N	128827	128827	296435
16610	21774	15	applied	\N	\N	\N	\N	128828	128828	296436
16610	21786	16	applied	\N	\N	\N	\N	128829	128829	296437
16610	21800	17	applied	\N	\N	\N	\N	128830	128830	296438
16610	21775	18	applied	\N	\N	\N	\N	128831	128831	296439
16610	21780	19	applied	\N	\N	\N	\N	128832	128832	296440
16610	21783	20	applied	\N	\N	\N	\N	128833	128833	296441
16610	21787	21	applied	\N	\N	\N	\N	128834	128834	296442
16610	21792	22	applied	\N	\N	\N	\N	128835	128835	296443
16610	21796	23	applied	\N	\N	\N	\N	128836	128836	296444
16610	21801	24	applied	\N	\N	\N	\N	128837	128837	296445
16610	21804	25	applied	\N	\N	\N	\N	128838	128838	296446
16610	21808	26	applied	\N	\N	\N	\N	128839	128839	296447
16610	21811	27	applied	\N	\N	\N	\N	128840	128840	296448
16612	21817	1	applied	\N	\N	\N	\N	128848	128848	296456
16612	21818	2	applied	\N	\N	\N	\N	128849	128849	296457
16619	21829	0	applied	\N	\N	\N	\N	128860	128860	296468
16619	21830	1	applied	\N	\N	\N	\N	128861	128861	296469
16619	21831	2	applied	\N	\N	\N	\N	128862	128862	296470
16619	21832	3	applied	\N	\N	\N	\N	128863	128863	296471
16621	21833	0	applied	\N	\N	\N	\N	128867	128867	296475
16621	21834	1	applied	\N	\N	\N	\N	128868	128868	296476
16621	21835	2	applied	\N	\N	\N	\N	128869	128869	296477
16622	21833	0	applied	\N	\N	\N	\N	128870	128870	296478
16622	21834	1	applied	\N	\N	\N	\N	128871	128871	296479
16622	21835	2	applied	\N	\N	\N	\N	128872	128872	296480
16624	21836	0	applied	\N	\N	\N	\N	128974	128974	296581
16624	21837	1	applied	\N	\N	\N	\N	128975	128975	296582
16626	21838	0	applied	\N	\N	\N	\N	128979	128979	296586
16626	21839	1	applied	\N	\N	\N	\N	128980	128980	296587
16629	21784	0	applied	\N	\N	\N	\N	128992	128992	296599
16629	21789	1	applied	\N	\N	\N	\N	128993	128993	296600
16629	21790	2	applied	\N	\N	\N	\N	128994	128994	296601
16629	21797	3	applied	\N	\N	\N	\N	128995	128995	296602
16629	21731	4	applied	\N	\N	\N	\N	128996	128996	296603
16629	21732	5	applied	\N	\N	\N	\N	128997	128997	296604
16629	21737	6	applied	\N	\N	\N	\N	128998	128998	296605
16629	21741	7	applied	\N	\N	\N	\N	128999	128999	296606
16629	21745	8	applied	\N	\N	\N	\N	129000	129000	296607
16629	21749	9	applied	\N	\N	\N	\N	129001	129001	296608
16629	21752	10	applied	\N	\N	\N	\N	129002	129002	296609
16629	21756	11	applied	\N	\N	\N	\N	129003	129003	296610
16629	21738	12	applied	\N	\N	1000000000	\N	129004	129004	296611
16629	21746	13	applied	\N	\N	\N	\N	129005	129005	296612
16629	21757	14	applied	\N	\N	\N	\N	129006	129006	296613
16629	21758	15	applied	\N	\N	\N	\N	129007	129007	296614
16629	21767	17	applied	\N	\N	\N	\N	129009	129009	296616
16629	21772	18	applied	\N	\N	\N	\N	129010	129010	296617
16629	21773	19	applied	\N	\N	\N	\N	129011	129011	296618
16629	21778	20	applied	\N	\N	\N	\N	129012	129012	296619
16629	21779	21	applied	\N	\N	\N	\N	129013	129013	296620
16629	21785	22	applied	\N	\N	\N	\N	129014	129014	296621
16629	21791	23	applied	\N	\N	\N	\N	129015	129015	296622
16629	21794	24	applied	\N	\N	\N	\N	129016	129016	296623
16631	21854	0	applied	\N	\N	\N	\N	129116	129116	296723
16631	21855	1	applied	\N	\N	\N	\N	129117	129117	296724
16631	21856	2	applied	\N	\N	\N	\N	129118	129118	296725
16631	21857	3	applied	\N	\N	\N	\N	129119	129119	296726
16631	21858	4	applied	\N	\N	\N	\N	129120	129120	296727
16631	21859	5	applied	\N	\N	\N	\N	129121	129121	296728
16633	21860	0	applied	\N	\N	\N	\N	129127	129127	296734
16633	21861	1	applied	\N	\N	\N	\N	129128	129128	296735
16633	21863	3	applied	\N	\N	\N	\N	129130	129130	296737
16635	21860	0	applied	\N	\N	\N	\N	129135	129135	296742
16635	21861	1	applied	\N	\N	\N	\N	129136	129136	296743
16635	21862	2	applied	\N	\N	\N	\N	129137	129137	296744
16635	21863	3	applied	\N	\N	\N	\N	129138	129138	296745
16638	21873	0	applied	\N	\N	\N	\N	129148	129148	296755
16638	21874	1	applied	\N	\N	\N	\N	129149	129149	296756
16638	21875	2	applied	\N	\N	\N	\N	129150	129150	296757
16638	21876	3	applied	\N	\N	\N	\N	129151	129151	296758
16638	21877	4	applied	\N	\N	\N	\N	129152	129152	296759
16638	21878	5	applied	\N	\N	\N	\N	129153	129153	296760
16638	21879	6	applied	\N	\N	\N	\N	129154	129154	296761
16644	21887	0	applied	\N	\N	\N	\N	129169	129169	296776
16644	21888	1	applied	\N	\N	\N	\N	129170	129170	296777
16644	21889	2	applied	\N	\N	\N	\N	129171	129171	296778
16644	21890	3	applied	\N	\N	\N	\N	129172	129172	296779
16586	21396	125	applied	\N	\N	\N	\N	128731	128731	296341
16611	21815	5	applied	\N	\N	\N	\N	128846	128846	296454
16614	21822	0	applied	\N	\N	\N	\N	128853	128853	296461
16614	21823	1	applied	\N	\N	\N	\N	128854	128854	296462
16614	21824	2	applied	\N	\N	\N	\N	128855	128855	296463
16614	21825	3	applied	\N	\N	\N	\N	128856	128856	296464
16625	21838	0	applied	\N	\N	\N	\N	128976	128976	296583
16625	21839	1	applied	\N	\N	\N	\N	128977	128977	296584
16625	21840	2	applied	\N	\N	\N	\N	128978	128978	296585
16628	21848	0	applied	\N	\N	\N	\N	128989	128989	296596
16628	21849	1	applied	\N	\N	\N	\N	128990	128990	296597
16628	21850	2	applied	\N	\N	\N	\N	128991	128991	296598
16630	21851	0	applied	\N	\N	\N	\N	129113	129113	296720
16630	21853	1	applied	\N	\N	\N	\N	129114	129114	296721
16630	21852	2	applied	\N	\N	\N	\N	129115	129115	296722
16637	21870	0	applied	\N	\N	\N	\N	129145	129145	296752
16637	21871	1	applied	\N	\N	\N	\N	129146	129146	296753
16640	21880	0	applied	\N	\N	\N	\N	129162	129162	296769
16640	21881	1	applied	\N	\N	\N	\N	129163	129163	296770
16640	21882	2	applied	\N	\N	\N	\N	129164	129164	296771
16644	21891	4	applied	\N	\N	\N	\N	129173	129173	296780
16644	21892	5	applied	\N	\N	\N	\N	129174	129174	296781
16644	21893	6	applied	\N	\N	\N	\N	129175	129175	296782
16644	21894	7	applied	\N	\N	\N	\N	129176	129176	296783
16644	21895	8	applied	\N	\N	\N	\N	129177	129177	296784
16644	21896	9	applied	\N	\N	\N	\N	129178	129178	296785
16644	21897	10	applied	\N	\N	\N	\N	129179	129179	296786
16644	21898	11	applied	\N	\N	\N	\N	129180	129180	296787
16646	21899	0	applied	\N	\N	\N	\N	129196	129196	296803
16646	21900	1	applied	\N	\N	\N	\N	129197	129197	296804
16646	21901	2	applied	\N	\N	\N	\N	129198	129198	296805
16648	21902	0	applied	\N	\N	\N	\N	129202	129202	296809
16648	21903	1	applied	\N	\N	\N	\N	129203	129203	296810
16650	21905	0	applied	\N	\N	\N	\N	129208	129208	296815
16650	21906	1	applied	\N	\N	\N	\N	129209	129209	296816
16650	21907	2	applied	\N	\N	\N	\N	129210	129210	296817
16650	21908	3	applied	\N	\N	\N	\N	129211	129211	296818
16650	21909	4	applied	\N	\N	\N	\N	129212	129212	296819
16650	21910	5	applied	\N	\N	\N	\N	129213	129213	296820
16651	21905	0	applied	\N	\N	\N	\N	129214	129214	296821
16651	21906	1	applied	\N	\N	\N	\N	129215	129215	296822
16651	21907	2	applied	\N	\N	\N	\N	129216	129216	296823
16651	21908	3	applied	\N	\N	\N	\N	129217	129217	296824
16651	21909	4	applied	\N	\N	\N	\N	129218	129218	296825
16651	21910	5	applied	\N	\N	\N	\N	129219	129219	296826
16653	21911	0	applied	\N	\N	\N	\N	129227	129227	296834
16653	21912	1	applied	\N	\N	\N	\N	129228	129228	296835
16653	21913	2	applied	\N	\N	\N	\N	129229	129229	296836
16653	21914	3	applied	\N	\N	\N	\N	129230	129230	296837
16653	21916	5	applied	\N	\N	\N	\N	129232	129232	296839
16653	21917	6	applied	\N	\N	\N	\N	129233	129233	296840
16657	21918	0	applied	\N	\N	\N	\N	129255	129255	296862
16657	21919	1	applied	\N	\N	\N	\N	129256	129256	296863
16657	21920	2	applied	\N	\N	\N	\N	129257	129257	296864
16662	21784	0	applied	\N	\N	\N	\N	129288	129288	296895
16662	21854	1	applied	\N	\N	\N	\N	129289	129289	296896
16662	21864	2	applied	\N	\N	\N	\N	129290	129290	296897
16662	21865	3	applied	\N	\N	\N	\N	129291	129291	296898
16662	21866	4	applied	\N	\N	\N	\N	129292	129292	296899
16662	21789	5	applied	\N	\N	\N	\N	129293	129293	296900
16665	21933	0	applied	\N	\N	\N	\N	129318	129318	296919
16665	21934	1	applied	\N	\N	\N	\N	129319	129319	296920
16665	21935	2	applied	\N	\N	\N	\N	129320	129320	296921
16667	21940	0	applied	\N	\N	\N	\N	129325	129325	296926
16667	21941	1	applied	\N	\N	\N	\N	129326	129326	296927
16672	21946	0	applied	\N	\N	\N	\N	129344	129344	296945
16672	21947	1	applied	\N	\N	\N	\N	129345	129345	296946
16672	21948	2	applied	\N	\N	\N	\N	129346	129346	296947
16672	21949	3	applied	\N	\N	\N	\N	129347	129347	296948
16672	21950	4	applied	\N	\N	\N	\N	129348	129348	296949
16672	21951	5	applied	\N	\N	\N	\N	129349	129349	296950
16675	21952	0	applied	\N	\N	\N	\N	129363	129363	296964
16675	21953	1	applied	\N	\N	\N	\N	129364	129364	296965
16675	21954	2	applied	\N	\N	\N	\N	129365	129365	296966
16675	21955	3	applied	\N	\N	\N	\N	129366	129366	296967
16675	21956	4	applied	\N	\N	\N	\N	129367	129367	296968
16675	21957	5	applied	\N	\N	\N	\N	129368	129368	296969
16675	21958	6	applied	\N	\N	\N	\N	129369	129369	296970
16677	21952	0	applied	\N	\N	\N	\N	129377	129377	296978
16677	21953	1	applied	\N	\N	\N	\N	129378	129378	296979
16677	21954	2	applied	\N	\N	\N	\N	129379	129379	296980
16677	21956	4	applied	\N	\N	\N	\N	129381	129381	296982
16677	21957	5	applied	\N	\N	\N	\N	129382	129382	296983
16677	21958	6	applied	\N	\N	\N	\N	129383	129383	296984
16682	21975	0	applied	\N	\N	\N	\N	129403	129403	297004
16682	21976	1	applied	\N	\N	\N	\N	129404	129404	297005
16682	21977	2	applied	\N	\N	\N	\N	129405	129405	297006
16682	21978	3	applied	\N	\N	\N	\N	129406	129406	297007
16682	21979	4	applied	\N	\N	\N	\N	129407	129407	297008
16682	21980	6	applied	\N	\N	\N	\N	129408	129408	297009
16682	21981	7	applied	\N	\N	\N	\N	129409	129409	297010
16688	21984	0	applied	\N	\N	\N	\N	129546	129546	297146
16688	21985	1	applied	\N	\N	\N	\N	129547	129547	297147
16688	21986	2	applied	\N	\N	\N	\N	129548	129548	297148
16688	21987	3	applied	\N	\N	\N	\N	129549	129549	297149
16688	21988	4	applied	\N	\N	\N	\N	129550	129550	297150
16688	21989	5	applied	\N	\N	\N	\N	129551	129551	297151
16688	21991	7	applied	\N	\N	\N	\N	129553	129553	297153
16688	21992	8	applied	\N	\N	\N	\N	129554	129554	297154
16688	21993	9	applied	\N	\N	\N	\N	129555	129555	297155
16688	21994	10	applied	\N	\N	\N	\N	129556	129556	297156
16688	21995	11	applied	\N	\N	\N	\N	129557	129557	297157
16688	21996	12	applied	\N	\N	\N	\N	129558	129558	297158
16688	21997	13	applied	\N	\N	\N	\N	129559	129559	297159
16688	21998	14	applied	\N	\N	\N	\N	129560	129560	297160
16688	21999	15	applied	\N	\N	\N	\N	129561	129561	297161
16691	22007	0	applied	\N	\N	\N	\N	129576	129576	297176
16691	22008	1	applied	\N	\N	\N	\N	129577	129577	297177
16691	22009	2	applied	\N	\N	\N	\N	129578	129578	297178
16691	22010	3	applied	\N	\N	\N	\N	129579	129579	297179
16691	22011	4	applied	\N	\N	\N	\N	129580	129580	297180
16611	21813	2	applied	\N	\N	\N	\N	128843	128843	296451
16611	21811	3	applied	\N	\N	\N	\N	128844	128844	296452
16623	21724	60	applied	\N	\N	\N	\N	128933	128933	296540
16623	21731	62	applied	\N	\N	\N	\N	128935	128935	296542
16623	21732	63	applied	\N	\N	\N	\N	128936	128936	296543
16623	21737	64	applied	\N	\N	\N	\N	128937	128937	296544
16623	21741	65	applied	\N	\N	\N	\N	128938	128938	296545
16623	21745	66	applied	\N	\N	\N	\N	128939	128939	296546
16623	21749	67	applied	\N	\N	\N	\N	128940	128940	296547
16623	21752	68	applied	\N	\N	\N	\N	128941	128941	296548
16623	21756	69	applied	\N	\N	\N	\N	128942	128942	296549
16623	21757	70	applied	\N	\N	\N	\N	128943	128943	296550
16623	21758	71	applied	\N	\N	\N	\N	128944	128944	296551
16623	21766	72	applied	\N	\N	\N	\N	128945	128945	296552
16623	21767	73	applied	\N	\N	\N	\N	128946	128946	296553
16623	21772	74	applied	\N	\N	\N	\N	128947	128947	296554
16623	21773	75	applied	\N	\N	\N	\N	128948	128948	296555
16623	21778	76	applied	\N	\N	\N	\N	128949	128949	296556
16623	21779	77	applied	\N	\N	\N	\N	128950	128950	296557
16623	21791	79	applied	\N	\N	\N	\N	128952	128952	296559
16623	21794	80	applied	\N	\N	\N	\N	128953	128953	296560
16623	21799	81	applied	\N	\N	\N	\N	128954	128954	296561
16623	21803	82	applied	\N	\N	\N	\N	128955	128955	296562
16623	21806	83	applied	\N	\N	\N	\N	128956	128956	296563
16623	21810	85	applied	\N	\N	\N	\N	128957	128957	296564
16623	21812	86	applied	\N	\N	\N	\N	128958	128958	296565
16623	21816	87	applied	\N	\N	\N	\N	128959	128959	296566
16623	21819	88	applied	\N	\N	\N	\N	128960	128960	296567
16623	21822	89	applied	\N	\N	\N	\N	128961	128961	296568
16623	21826	90	applied	\N	\N	\N	\N	128962	128962	296569
16623	21830	91	applied	\N	\N	\N	\N	128963	128963	296570
16623	21555	92	applied	\N	\N	\N	\N	128964	128964	296571
16623	21556	93	applied	\N	\N	\N	\N	128965	128965	296572
16623	21562	94	applied	\N	\N	\N	\N	128966	128966	296573
16623	21557	95	applied	\N	\N	\N	\N	128967	128967	296574
16662	21790	6	applied	\N	\N	\N	\N	129294	129294	296901
16662	21797	7	applied	\N	\N	\N	\N	129295	129295	296902
16662	21337	8	applied	\N	\N	1000000000	\N	129296	129296	296903
16662	21521	9	applied	\N	\N	1000000000	\N	129297	129297	296904
16662	21462	10	applied	\N	\N	1000000000	\N	129298	129298	296905
16662	21578	11	applied	\N	\N	1000000000	\N	129299	129299	296906
16662	21599	12	applied	\N	\N	1000000000	\N	129300	129300	296907
16662	21409	13	applied	\N	\N	\N	\N	129301	129301	296908
16662	21738	15	applied	\N	\N	1000000000	\N	129303	129303	296909
16662	21746	16	applied	\N	\N	\N	\N	129304	129304	296910
16662	21856	17	applied	\N	\N	\N	\N	129305	129305	296911
16662	21393	18	applied	\N	\N	\N	\N	129306	129306	129306
16662	21403	19	applied	\N	\N	\N	\N	129307	129307	129307
16662	21405	20	applied	\N	\N	\N	\N	129308	129308	129308
16662	21413	21	applied	\N	\N	\N	\N	129309	129309	129309
16662	21863	23	applied	\N	\N	\N	\N	129311	129311	296912
16664	21933	0	applied	\N	\N	\N	\N	129315	129315	296916
16664	21934	1	applied	\N	\N	\N	\N	129316	129316	296917
16664	21935	2	applied	\N	\N	\N	\N	129317	129317	296918
16669	21943	0	applied	\N	\N	\N	\N	129335	129335	296936
16669	21944	1	applied	\N	\N	\N	\N	129336	129336	296937
16669	21945	2	applied	\N	\N	\N	\N	129337	129337	296938
16674	21952	0	applied	\N	\N	\N	\N	129356	129356	296957
16674	21953	1	applied	\N	\N	\N	\N	129357	129357	296958
16674	21954	2	applied	\N	\N	\N	\N	129358	129358	296959
16674	21955	3	applied	\N	\N	\N	\N	129359	129359	296960
16674	21956	4	applied	\N	\N	\N	\N	129360	129360	296961
16674	21957	5	applied	\N	\N	\N	\N	129361	129361	296962
16674	21958	6	applied	\N	\N	\N	\N	129362	129362	296963
16676	21952	0	applied	\N	\N	\N	\N	129370	129370	296971
16676	21953	1	applied	\N	\N	\N	\N	129371	129371	296972
16676	21955	3	applied	\N	\N	\N	\N	129373	129373	296974
16676	21956	4	applied	\N	\N	\N	\N	129374	129374	296975
16676	21957	5	applied	\N	\N	\N	\N	129375	129375	296976
16676	21958	6	applied	\N	\N	\N	\N	129376	129376	296977
16678	21959	0	applied	\N	\N	\N	\N	129384	129384	296985
16678	21960	1	applied	\N	\N	\N	\N	129385	129385	296986
16678	21961	2	applied	\N	\N	\N	\N	129386	129386	296987
16681	21965	0	applied	\N	\N	\N	\N	129393	129393	296994
16681	21966	1	applied	\N	\N	\N	\N	129394	129394	296995
16681	21967	2	applied	\N	\N	\N	\N	129395	129395	296996
16681	21968	3	applied	\N	\N	\N	\N	129396	129396	296997
16681	21969	4	applied	\N	\N	\N	\N	129397	129397	296998
16681	21970	5	applied	\N	\N	\N	\N	129398	129398	296999
16681	21971	6	applied	\N	\N	\N	\N	129399	129399	297000
16681	21972	7	applied	\N	\N	\N	\N	129400	129400	297001
16681	21973	8	applied	\N	\N	\N	\N	129401	129401	297002
16684	21982	0	applied	\N	\N	\N	\N	129417	129417	297018
16684	21983	1	applied	\N	\N	\N	\N	129418	129418	297019
16690	22007	0	applied	\N	\N	\N	\N	129569	129569	297169
16690	22008	1	applied	\N	\N	\N	\N	129570	129570	297170
16690	22009	2	applied	\N	\N	\N	\N	129571	129571	297171
16690	22010	3	applied	\N	\N	\N	\N	129572	129572	297172
16690	22011	4	applied	\N	\N	\N	\N	129573	129573	297173
16690	22012	5	applied	\N	\N	\N	\N	129574	129574	297174
16690	22013	6	applied	\N	\N	\N	\N	129575	129575	297175
16692	22007	0	applied	\N	\N	\N	\N	129583	129583	297183
16692	22008	1	applied	\N	\N	\N	\N	129584	129584	297184
16692	22009	2	applied	\N	\N	\N	\N	129585	129585	297185
16692	22010	3	applied	\N	\N	\N	\N	129586	129586	297186
16692	22011	4	applied	\N	\N	\N	\N	129587	129587	297187
16692	22012	5	applied	\N	\N	\N	\N	129588	129588	297188
16692	22013	6	applied	\N	\N	\N	\N	129589	129589	297189
16698	22032	1	applied	\N	\N	\N	\N	129610	129610	297210
16698	22033	2	applied	\N	\N	\N	\N	129611	129611	297211
16698	22034	3	applied	\N	\N	\N	\N	129612	129612	297212
16703	22044	0	applied	\N	\N	\N	\N	129626	129626	297226
16703	22045	1	applied	\N	\N	\N	\N	129627	129627	297227
16703	22046	2	applied	\N	\N	\N	\N	129628	129628	297228
16705	22047	0	applied	\N	\N	\N	\N	129632	129632	297232
16705	22048	1	applied	\N	\N	\N	\N	129633	129633	297233
16705	22049	2	applied	\N	\N	\N	\N	129634	129634	297234
16705	22050	3	applied	\N	\N	\N	\N	129635	129635	297235
16705	22051	4	applied	\N	\N	\N	\N	129636	129636	297236
16705	22052	5	applied	\N	\N	\N	\N	129637	129637	297237
16623	21715	58	applied	\N	\N	\N	\N	128931	128931	296538
16623	21718	59	applied	\N	\N	\N	\N	128932	128932	296539
16623	21619	101	applied	\N	\N	\N	\N	128973	128973	296580
16627	21841	0	applied	\N	\N	\N	\N	128982	128982	296589
16627	21842	1	applied	\N	\N	\N	\N	128983	128983	296590
16627	21843	2	applied	\N	\N	\N	\N	128984	128984	296591
16627	21844	3	applied	\N	\N	\N	\N	128985	128985	296592
16627	21845	4	applied	\N	\N	\N	\N	128986	128986	296593
16627	21846	5	applied	\N	\N	\N	\N	128987	128987	296594
16627	21847	6	applied	\N	\N	\N	\N	128988	128988	296595
16629	21799	25	applied	\N	\N	\N	\N	129017	129017	296624
16629	21803	26	applied	\N	\N	\N	\N	129018	129018	296625
16629	21806	27	applied	\N	\N	\N	\N	129019	129019	296626
16629	21810	28	applied	\N	\N	\N	\N	129020	129020	296627
16629	21812	29	applied	\N	\N	\N	\N	129021	129021	296628
16629	21816	30	applied	\N	\N	\N	\N	129022	129022	296629
16629	21819	31	applied	\N	\N	\N	\N	129023	129023	296630
16629	21822	32	applied	\N	\N	\N	\N	129024	129024	296631
16629	21830	34	applied	\N	\N	\N	\N	129026	129026	296633
16629	21833	35	applied	\N	\N	\N	\N	129027	129027	296634
16629	21836	36	applied	\N	\N	\N	\N	129028	129028	296635
16629	21838	37	applied	\N	\N	\N	\N	129029	129029	296636
16629	21841	38	applied	\N	\N	\N	\N	129030	129030	296637
16629	21842	39	applied	\N	\N	\N	\N	129031	129031	296638
16629	21848	40	applied	\N	\N	\N	\N	129032	129032	296639
16629	21851	41	applied	\N	\N	\N	\N	129033	129033	296640
16629	21733	42	applied	\N	\N	\N	\N	129034	129034	296641
16629	21734	43	applied	\N	\N	\N	\N	129035	129035	296642
16629	21735	44	applied	\N	\N	\N	\N	129036	129036	296643
16629	21739	45	applied	\N	\N	\N	\N	129037	129037	296644
16629	21742	46	applied	\N	\N	\N	\N	129038	129038	296645
16629	21747	47	applied	\N	\N	\N	\N	129039	129039	296646
16629	21743	48	applied	\N	\N	\N	\N	129040	129040	296647
16629	21755	49	applied	\N	\N	\N	\N	129041	129041	296648
16629	21774	51	applied	\N	\N	\N	\N	129043	129043	296650
16629	21786	52	applied	\N	\N	\N	\N	129044	129044	296651
16629	21800	53	applied	\N	\N	\N	\N	129045	129045	296652
16629	21813	54	applied	\N	\N	\N	\N	129046	129046	296653
16629	21736	55	applied	\N	\N	\N	\N	129047	129047	296654
16629	21740	56	applied	\N	\N	\N	\N	129048	129048	296655
16629	21750	57	applied	\N	\N	\N	\N	129049	129049	296656
16629	21753	58	applied	\N	\N	\N	\N	129050	129050	296657
16629	21761	59	applied	\N	\N	\N	\N	129051	129051	296658
16629	21825	60	applied	\N	\N	\N	\N	129052	129052	296659
16629	21837	61	applied	\N	\N	\N	\N	129053	129053	296660
16629	21844	62	applied	\N	\N	\N	\N	129054	129054	296661
16629	21744	63	applied	\N	\N	\N	\N	129055	129055	296662
16632	21854	0	applied	\N	\N	\N	\N	129122	129122	296729
16632	21855	1	applied	\N	\N	\N	\N	129123	129123	296730
16632	21857	2	applied	\N	\N	\N	\N	129124	129124	296731
16632	21859	4	applied	\N	\N	\N	\N	129126	129126	296733
16634	21860	0	applied	\N	\N	\N	\N	129131	129131	296738
16634	21861	1	applied	\N	\N	\N	\N	129132	129132	296739
16634	21862	2	applied	\N	\N	\N	\N	129133	129133	296740
16634	21863	3	applied	\N	\N	\N	\N	129134	129134	296741
16645	21887	0	applied	\N	\N	\N	\N	129181	129181	296788
16645	21888	1	applied	\N	\N	\N	\N	129182	129182	296789
16645	21889	2	applied	\N	\N	\N	\N	129183	129183	296790
16645	21890	3	applied	\N	\N	\N	\N	129184	129184	296791
16645	21899	4	applied	\N	\N	\N	\N	129185	129185	296792
16645	21891	5	applied	\N	\N	\N	\N	129186	129186	296793
16645	21892	6	applied	\N	\N	\N	\N	129187	129187	296794
16645	21893	7	applied	\N	\N	\N	\N	129188	129188	296795
16645	21894	8	applied	\N	\N	\N	\N	129189	129189	296796
16645	21895	9	applied	\N	\N	\N	\N	129190	129190	296797
16645	21896	10	applied	\N	\N	\N	\N	129191	129191	296798
16645	21897	12	applied	\N	\N	\N	\N	129193	129193	296800
16645	21898	13	applied	\N	\N	\N	\N	129194	129194	296801
16645	21901	14	applied	\N	\N	\N	\N	129195	129195	296802
16647	21902	0	applied	\N	\N	\N	\N	129199	129199	296806
16647	21903	1	applied	\N	\N	\N	\N	129200	129200	296807
16647	21904	2	applied	\N	\N	\N	\N	129201	129201	296808
16652	21911	0	applied	\N	\N	\N	\N	129220	129220	296827
16652	21912	1	applied	\N	\N	\N	\N	129221	129221	296828
16652	21913	2	applied	\N	\N	\N	\N	129222	129222	296829
16652	21914	3	applied	\N	\N	\N	\N	129223	129223	296830
16652	21915	4	applied	\N	\N	\N	\N	129224	129224	296831
16652	21916	5	applied	\N	\N	\N	\N	129225	129225	296832
16652	21917	6	applied	\N	\N	\N	\N	129226	129226	296833
16655	21911	0	applied	\N	\N	\N	\N	129241	129241	296848
16655	21912	1	applied	\N	\N	\N	\N	129242	129242	296849
16655	21913	2	applied	\N	\N	\N	\N	129243	129243	296850
16655	21915	4	applied	\N	\N	\N	\N	129245	129245	296852
16655	21916	5	applied	\N	\N	\N	\N	129246	129246	296853
16655	21917	6	applied	\N	\N	\N	\N	129247	129247	296854
16656	21911	0	applied	\N	\N	\N	\N	129248	129248	296855
16656	21912	1	applied	\N	\N	\N	\N	129249	129249	296856
16656	21913	2	applied	\N	\N	\N	\N	129250	129250	296857
16656	21914	3	applied	\N	\N	\N	\N	129251	129251	296858
16656	21915	4	applied	\N	\N	\N	\N	129252	129252	296859
16656	21916	5	applied	\N	\N	\N	\N	129253	129253	296860
16656	21917	6	applied	\N	\N	\N	\N	129254	129254	296861
16660	21924	0	applied	\N	\N	\N	\N	129270	129270	296877
16660	21925	1	applied	\N	\N	\N	\N	129271	129271	296878
16660	21926	2	applied	\N	\N	\N	\N	129272	129272	296879
16660	21927	3	applied	\N	\N	\N	\N	129273	129273	296880
16660	21928	4	applied	\N	\N	\N	\N	129274	129274	296881
16660	21929	5	applied	\N	\N	\N	\N	129275	129275	296882
16660	21931	7	applied	\N	\N	\N	\N	129277	129277	296884
16660	21932	8	applied	\N	\N	\N	\N	129278	129278	296885
16666	21936	0	applied	\N	\N	\N	\N	129321	129321	296922
16666	21937	1	applied	\N	\N	\N	\N	129322	129322	296923
16666	21938	2	applied	\N	\N	\N	\N	129323	129323	296924
16666	21939	3	applied	\N	\N	\N	\N	129324	129324	296925
16668	21936	0	applied	\N	\N	\N	\N	129328	129328	296929
16668	21940	1	applied	\N	\N	\N	\N	129329	129329	296930
16668	21937	2	applied	\N	\N	\N	\N	129330	129330	296931
16668	21941	3	applied	\N	\N	\N	\N	129331	129331	296932
16668	21938	4	applied	\N	\N	\N	\N	129332	129332	296933
16668	21939	5	applied	\N	\N	\N	\N	129333	129333	296934
16668	21942	6	applied	\N	\N	\N	\N	129334	129334	296935
16671	21943	0	applied	\N	\N	\N	\N	129341	129341	296942
16623	21592	98	applied	\N	\N	\N	\N	128970	128970	296577
16623	21606	99	applied	\N	\N	\N	\N	128971	128971	296578
16629	21762	68	applied	\N	\N	\N	\N	129060	129060	296667
16629	21763	69	applied	\N	\N	\N	\N	129061	129061	296668
16629	21768	70	applied	\N	\N	\N	\N	129062	129062	296669
16629	21769	71	applied	\N	\N	\N	\N	129063	129063	296670
16629	21775	72	applied	\N	\N	\N	\N	129064	129064	296671
16629	21780	73	applied	\N	\N	\N	\N	129065	129065	296672
16629	21783	74	applied	\N	\N	\N	\N	129066	129066	296673
16629	21787	75	applied	\N	\N	\N	\N	129067	129067	296674
16629	21792	76	applied	\N	\N	\N	\N	129068	129068	296675
16629	21796	77	applied	\N	\N	\N	\N	129069	129069	296676
16629	21801	78	applied	\N	\N	\N	\N	129070	129070	296677
16629	21804	79	applied	\N	\N	\N	\N	129071	129071	296678
16629	21808	80	applied	\N	\N	\N	\N	129072	129072	296679
16629	21811	81	applied	\N	\N	\N	\N	129073	129073	296680
16629	21814	82	applied	\N	\N	\N	\N	129074	129074	296681
16629	21817	83	applied	\N	\N	\N	\N	129075	129075	296682
16629	21824	85	applied	\N	\N	\N	\N	129077	129077	296684
16629	21827	86	applied	\N	\N	\N	\N	129078	129078	296685
16629	21832	87	applied	\N	\N	\N	\N	129079	129079	296686
16629	21835	88	applied	\N	\N	\N	\N	129080	129080	296687
16629	21840	89	applied	\N	\N	\N	\N	129081	129081	296688
16629	21843	90	applied	\N	\N	\N	\N	129082	129082	296689
16629	21847	91	applied	\N	\N	\N	\N	129083	129083	296690
16629	21764	92	applied	\N	\N	\N	\N	129084	129084	296691
16629	21765	93	applied	\N	\N	\N	\N	129085	129085	296692
16629	21770	94	applied	\N	\N	\N	\N	129086	129086	296693
16629	21771	95	applied	\N	\N	\N	\N	129087	129087	296694
16629	21776	96	applied	\N	\N	\N	\N	129088	129088	296695
16629	21777	97	applied	\N	\N	\N	\N	129089	129089	296696
16629	21781	98	applied	\N	\N	\N	\N	129090	129090	296697
16629	21782	99	applied	\N	\N	\N	\N	129091	129091	296698
16629	21788	100	applied	\N	\N	\N	\N	129092	129092	296699
16629	21795	102	applied	\N	\N	\N	\N	129094	129094	296701
16629	21802	103	applied	\N	\N	\N	\N	129095	129095	296702
16629	21805	104	applied	\N	\N	\N	\N	129096	129096	296703
16629	21807	105	applied	\N	\N	\N	\N	129097	129097	296704
16629	21809	106	applied	\N	\N	\N	\N	129098	129098	296705
16629	21815	107	applied	\N	\N	\N	\N	129099	129099	296706
16629	21818	108	applied	\N	\N	\N	\N	129100	129100	296707
16629	21821	109	applied	\N	\N	\N	\N	129101	129101	296708
16629	21823	110	applied	\N	\N	\N	\N	129102	129102	296709
16629	21828	111	applied	\N	\N	\N	\N	129103	129103	296710
16629	21831	112	applied	\N	\N	\N	\N	129104	129104	296711
16629	21834	113	applied	\N	\N	\N	\N	129105	129105	296712
16629	21839	114	applied	\N	\N	\N	\N	129106	129106	296713
16629	21845	115	applied	\N	\N	\N	\N	129107	129107	296714
16629	21846	116	applied	\N	\N	\N	\N	129108	129108	296715
16629	21849	117	applied	\N	\N	\N	\N	129109	129109	296716
16629	21850	119	applied	\N	\N	\N	\N	129111	129111	296718
16629	21853	120	applied	\N	\N	\N	\N	129112	129112	296719
16636	21864	0	applied	\N	\N	\N	\N	129139	129139	296746
16636	21865	1	applied	\N	\N	\N	\N	129140	129140	296747
16636	21866	2	applied	\N	\N	\N	\N	129141	129141	296748
16636	21867	3	applied	\N	\N	\N	\N	129142	129142	296749
16636	21868	4	applied	\N	\N	\N	\N	129143	129143	296750
16636	21869	5	applied	\N	\N	\N	\N	129144	129144	296751
16639	21873	0	applied	\N	\N	\N	\N	129155	129155	296762
16639	21874	1	applied	\N	\N	\N	\N	129156	129156	296763
16639	21875	2	applied	\N	\N	\N	\N	129157	129157	296764
16639	21876	3	applied	\N	\N	\N	\N	129158	129158	296765
16639	21877	4	applied	\N	\N	\N	\N	129159	129159	296766
16639	21878	5	applied	\N	\N	\N	\N	129160	129160	296767
16639	21879	6	applied	\N	\N	\N	\N	129161	129161	296768
16641	21883	0	applied	\N	\N	\N	\N	129165	129165	296772
16641	21885	2	applied	\N	\N	\N	\N	129167	129167	296774
16641	21886	3	applied	\N	\N	\N	\N	129168	129168	296775
16649	21902	0	applied	\N	\N	\N	\N	129205	129205	296812
16649	21903	1	applied	\N	\N	\N	\N	129206	129206	296813
16649	21904	2	applied	\N	\N	\N	\N	129207	129207	296814
16654	21911	0	applied	\N	\N	\N	\N	129234	129234	296841
16654	21912	1	applied	\N	\N	\N	\N	129235	129235	296842
16654	21913	2	applied	\N	\N	\N	\N	129236	129236	296843
16654	21914	3	applied	\N	\N	\N	\N	129237	129237	296844
16654	21915	4	applied	\N	\N	\N	\N	129238	129238	296845
16654	21916	5	applied	\N	\N	\N	\N	129239	129239	296846
16654	21917	6	applied	\N	\N	\N	\N	129240	129240	296847
16658	21921	0	applied	\N	\N	\N	\N	129258	129258	296865
16658	21922	1	applied	\N	\N	\N	\N	129259	129259	296866
16658	21923	2	applied	\N	\N	\N	\N	129260	129260	296867
16659	21924	0	applied	\N	\N	\N	\N	129261	129261	296868
16659	21926	2	applied	\N	\N	\N	\N	129263	129263	296870
16659	21927	3	applied	\N	\N	\N	\N	129264	129264	296871
16659	21928	4	applied	\N	\N	\N	\N	129265	129265	296872
16659	21929	5	applied	\N	\N	\N	\N	129266	129266	296873
16659	21930	6	applied	\N	\N	\N	\N	129267	129267	296874
16659	21931	7	applied	\N	\N	\N	\N	129268	129268	296875
16659	21932	8	applied	\N	\N	\N	\N	129269	129269	296876
16661	21924	0	applied	\N	\N	\N	\N	129279	129279	296886
16661	21925	1	applied	\N	\N	\N	\N	129280	129280	296887
16661	21926	2	applied	\N	\N	\N	\N	129281	129281	296888
16661	21927	3	applied	\N	\N	\N	\N	129282	129282	296889
16661	21928	4	applied	\N	\N	\N	\N	129283	129283	296890
16661	21929	5	applied	\N	\N	\N	\N	129284	129284	296891
16661	21930	6	applied	\N	\N	\N	\N	129285	129285	296892
16661	21931	7	applied	\N	\N	\N	\N	129286	129286	296893
16661	21932	8	applied	\N	\N	\N	\N	129287	129287	296894
16663	21934	1	applied	\N	\N	\N	\N	129313	129313	296914
16663	21935	2	applied	\N	\N	\N	\N	129314	129314	296915
16670	21943	0	applied	\N	\N	\N	\N	129338	129338	296939
16670	21944	1	applied	\N	\N	\N	\N	129339	129339	296940
16670	21945	2	applied	\N	\N	\N	\N	129340	129340	296941
16679	21959	0	applied	\N	\N	\N	\N	129387	129387	296988
16679	21960	1	applied	\N	\N	\N	\N	129388	129388	296989
16679	21961	2	applied	\N	\N	\N	\N	129389	129389	296990
16683	21975	0	applied	\N	\N	\N	\N	129410	129410	297011
16683	21976	1	applied	\N	\N	\N	\N	129411	129411	297012
16683	21977	2	applied	\N	\N	\N	\N	129412	129412	297013
16683	21978	3	applied	\N	\N	\N	\N	129413	129413	297014
16683	21979	4	applied	\N	\N	\N	\N	129414	129414	297015
16683	21980	6	applied	\N	\N	\N	\N	129415	129415	297016
16629	21751	65	applied	\N	\N	\N	\N	129057	129057	296664
16629	21754	66	applied	\N	\N	\N	\N	129058	129058	296665
16673	21947	1	applied	\N	\N	\N	\N	129351	129351	296952
16673	21948	2	applied	\N	\N	\N	\N	129352	129352	296953
16673	21949	3	applied	\N	\N	\N	\N	129353	129353	296954
16673	21950	4	applied	\N	\N	\N	\N	129354	129354	296955
16673	21951	5	applied	\N	\N	\N	\N	129355	129355	296956
16680	21962	0	applied	\N	\N	\N	\N	129390	129390	296991
16680	21963	1	applied	\N	\N	\N	\N	129391	129391	296992
16680	21964	2	applied	\N	\N	\N	\N	129392	129392	296993
16683	21981	7	applied	\N	\N	\N	\N	129416	129416	297017
16685	21982	0	applied	\N	\N	\N	\N	129419	129419	297020
16685	21983	1	applied	\N	\N	\N	\N	129420	129420	297021
16687	21854	1	applied	\N	\N	\N	\N	129422	129422	297023
16687	21864	2	applied	\N	\N	\N	\N	129423	129423	297024
16687	21865	4	applied	\N	\N	\N	\N	129424	129424	297025
16687	21866	5	applied	\N	\N	\N	\N	129425	129425	297026
16687	21789	6	applied	\N	\N	\N	\N	129426	129426	297027
16687	21790	7	applied	\N	\N	\N	\N	129427	129427	297028
16687	21797	8	applied	\N	\N	\N	\N	129428	129428	297029
16687	21578	9	applied	\N	\N	1000000000	\N	129429	129429	297030
16687	21599	10	applied	\N	\N	1000000000	\N	129430	129430	297031
16687	21520	11	applied	\N	\N	\N	\N	129431	129431	297032
16687	21521	12	applied	\N	\N	1000000000	\N	129432	129432	297033
16687	21558	13	applied	\N	\N	\N	\N	129433	129433	297034
16687	21522	14	applied	\N	\N	\N	\N	129434	129434	297035
16687	21523	15	applied	\N	\N	\N	\N	129435	129435	297036
16687	21524	16	applied	\N	\N	\N	\N	129436	129436	297037
16687	21534	17	applied	\N	\N	\N	\N	129437	129437	297038
16687	21540	19	applied	\N	\N	\N	\N	129439	129439	297040
16687	21545	20	applied	\N	\N	\N	\N	129440	129440	297041
16687	21548	21	applied	\N	\N	\N	\N	129441	129441	297042
16687	21549	22	applied	\N	\N	\N	\N	129442	129442	297043
16687	21554	23	applied	\N	\N	\N	\N	129443	129443	297044
16687	21559	24	applied	\N	\N	\N	\N	129444	129444	297045
16687	21560	25	applied	\N	\N	\N	\N	129445	129445	297046
16687	21561	26	applied	\N	\N	\N	\N	129446	129446	297047
16687	21571	27	applied	\N	\N	\N	\N	129447	129447	297048
16699	22035	0	applied	\N	\N	\N	\N	129613	129613	297213
16699	22036	1	applied	\N	\N	\N	\N	129614	129614	297214
16699	22037	2	applied	\N	\N	\N	\N	129615	129615	297215
16702	22040	0	applied	\N	\N	\N	\N	129622	129622	297222
16702	22041	1	applied	\N	\N	\N	\N	129623	129623	297223
16702	22042	2	applied	\N	\N	\N	\N	129624	129624	297224
16702	22043	3	applied	\N	\N	\N	\N	129625	129625	297225
16708	22055	1	applied	\N	\N	\N	\N	129769	129769	297369
16708	22056	2	applied	\N	\N	\N	\N	129770	129770	297370
16709	21784	0	applied	\N	\N	\N	\N	129771	129771	297371
16709	21854	1	applied	\N	\N	\N	\N	129772	129772	297372
16709	21864	2	applied	\N	\N	\N	\N	129773	129773	297373
16709	21865	3	applied	\N	\N	\N	\N	129774	129774	297374
16709	21866	4	applied	\N	\N	\N	\N	129775	129775	297375
16709	21789	5	applied	\N	\N	\N	\N	129776	129776	297376
16709	21790	6	applied	\N	\N	\N	\N	129777	129777	297377
16709	21797	7	applied	\N	\N	\N	\N	129778	129778	297378
16709	21756	8	applied	\N	\N	\N	\N	129779	129779	297379
16709	21757	9	applied	\N	\N	\N	\N	129780	129780	297380
16709	21758	10	applied	\N	\N	\N	\N	129781	129781	297381
16709	21766	11	applied	\N	\N	\N	\N	129782	129782	297382
16709	21767	12	applied	\N	\N	\N	\N	129783	129783	297383
16709	21772	13	applied	\N	\N	\N	\N	129784	129784	297384
16709	21778	15	applied	\N	\N	\N	\N	129786	129786	297386
16709	21779	16	applied	\N	\N	\N	\N	129787	129787	297387
16709	21785	17	applied	\N	\N	\N	\N	129788	129788	297388
16709	21791	18	applied	\N	\N	\N	\N	129789	129789	297389
16709	21794	19	applied	\N	\N	\N	\N	129790	129790	297390
16709	21799	20	applied	\N	\N	\N	\N	129791	129791	297391
16709	21803	21	applied	\N	\N	\N	\N	129792	129792	297392
16709	21806	22	applied	\N	\N	\N	\N	129793	129793	297393
16709	21810	23	applied	\N	\N	\N	\N	129794	129794	297394
16709	21812	24	applied	\N	\N	\N	\N	129795	129795	297395
16709	21816	25	applied	\N	\N	\N	\N	129796	129796	297396
16709	21819	26	applied	\N	\N	\N	\N	129797	129797	297397
16709	21822	27	applied	\N	\N	\N	\N	129798	129798	297398
16709	21826	28	applied	\N	\N	\N	\N	129799	129799	297399
16709	21830	29	applied	\N	\N	\N	\N	129800	129800	297400
16709	21833	30	applied	\N	\N	\N	\N	129801	129801	297401
16709	21838	32	applied	\N	\N	\N	\N	129803	129803	297403
16709	21841	33	applied	\N	\N	\N	\N	129804	129804	297404
16709	21842	34	applied	\N	\N	\N	\N	129805	129805	297405
16709	21848	35	applied	\N	\N	\N	\N	129806	129806	297406
16709	21851	36	applied	\N	\N	\N	\N	129807	129807	297407
16709	21855	37	applied	\N	\N	\N	\N	129808	129808	297408
16709	21860	38	applied	\N	\N	\N	\N	129809	129809	297409
16709	21867	39	applied	\N	\N	\N	\N	129810	129810	297410
16709	21870	40	applied	\N	\N	\N	\N	129811	129811	297411
16709	21873	41	applied	\N	\N	\N	\N	129812	129812	297412
16709	21874	42	applied	\N	\N	\N	\N	129813	129813	297413
16709	21880	43	applied	\N	\N	\N	\N	129814	129814	297414
16709	21883	44	applied	\N	\N	\N	\N	129815	129815	297415
16709	21887	45	applied	\N	\N	\N	\N	129816	129816	297416
16709	21888	46	applied	\N	\N	\N	\N	129817	129817	297417
16709	21889	47	applied	\N	\N	\N	\N	129818	129818	297418
16709	21899	49	applied	\N	\N	\N	\N	129820	129820	297420
16709	21902	50	applied	\N	\N	\N	\N	129821	129821	297421
16709	21905	51	applied	\N	\N	\N	\N	129822	129822	297422
16709	21906	52	applied	\N	\N	\N	\N	129823	129823	297423
16709	21911	53	applied	\N	\N	\N	\N	129824	129824	297424
16709	21912	54	applied	\N	\N	\N	\N	129825	129825	297425
16709	21918	55	applied	\N	\N	\N	\N	129826	129826	297426
16709	21921	56	applied	\N	\N	\N	\N	129827	129827	297427
16709	21924	57	applied	\N	\N	\N	\N	129828	129828	297428
16709	21925	58	applied	\N	\N	\N	\N	129829	129829	297429
16709	21926	59	applied	\N	\N	\N	\N	129830	129830	297430
16709	21933	60	applied	\N	\N	\N	\N	129831	129831	297431
16709	21936	61	applied	\N	\N	\N	\N	129832	129832	297432
16709	21940	62	applied	\N	\N	\N	\N	129833	129833	297433
16709	21943	64	applied	\N	\N	\N	\N	129834	129834	297434
16709	21946	65	applied	\N	\N	\N	\N	129835	129835	297435
16709	21952	67	applied	\N	\N	\N	\N	129837	129837	297437
16709	21953	68	applied	\N	\N	\N	\N	129838	129838	297438
16671	21945	2	applied	\N	\N	\N	\N	129343	129343	296944
16673	21946	0	applied	\N	\N	\N	\N	129350	129350	296951
16687	21586	32	applied	\N	\N	\N	\N	129452	129452	297053
16687	21587	33	applied	\N	\N	\N	\N	129453	129453	297054
16687	21593	34	applied	\N	\N	\N	\N	129454	129454	297055
16687	21596	35	applied	\N	\N	\N	\N	129455	129455	297056
16687	21597	36	applied	\N	\N	\N	\N	129456	129456	297057
16687	21598	37	applied	\N	\N	\N	\N	129457	129457	297058
16687	21607	38	applied	\N	\N	\N	\N	129458	129458	297059
16687	21608	39	applied	\N	\N	\N	\N	129459	129459	297060
16687	21614	41	applied	\N	\N	\N	\N	129461	129461	297061
16687	21615	42	applied	\N	\N	\N	\N	129462	129462	297062
16687	21616	43	applied	\N	\N	\N	\N	129463	129463	297063
16687	21617	44	applied	\N	\N	\N	\N	129464	129464	297064
16687	21618	45	applied	\N	\N	\N	\N	129465	129465	297065
16687	21630	46	applied	\N	\N	\N	\N	129466	129466	297066
16687	21634	47	applied	\N	\N	\N	\N	129467	129467	297067
16687	21637	48	applied	\N	\N	\N	\N	129468	129468	297068
16687	21640	49	applied	\N	\N	\N	\N	129469	129469	297069
16687	21644	50	applied	\N	\N	\N	\N	129470	129470	297070
16687	21647	51	applied	\N	\N	\N	\N	129471	129471	297071
16687	21648	52	applied	\N	\N	\N	\N	129472	129472	297072
16687	21652	53	applied	\N	\N	\N	\N	129473	129473	297073
16687	21653	54	applied	\N	\N	\N	\N	129474	129474	297074
16687	21659	55	applied	\N	\N	\N	\N	129475	129475	297075
16687	21662	56	applied	\N	\N	\N	\N	129476	129476	297076
16687	21663	57	applied	\N	\N	\N	\N	129477	129477	297077
16687	21738	58	applied	\N	\N	1000000000	\N	129478	129478	297078
16687	21746	59	applied	\N	\N	\N	\N	129479	129479	297079
16687	21669	60	applied	\N	\N	\N	\N	129480	129480	297080
16687	21672	61	applied	\N	\N	\N	\N	129481	129481	297081
16687	21674	62	applied	\N	\N	\N	\N	129482	129482	297082
16687	21676	64	applied	\N	\N	\N	\N	129484	129484	297084
16687	21686	65	applied	\N	\N	\N	\N	129485	129485	297085
16687	21691	66	applied	\N	\N	\N	\N	129486	129486	297086
16687	21692	67	applied	\N	\N	\N	\N	129487	129487	297087
16687	21696	68	applied	\N	\N	\N	\N	129488	129488	297088
16687	21697	69	applied	\N	\N	\N	\N	129489	129489	297089
16687	21698	70	applied	\N	\N	\N	\N	129490	129490	297090
16687	21699	71	applied	\N	\N	\N	\N	129491	129491	297091
16687	21709	72	applied	\N	\N	\N	\N	129492	129492	297092
16687	21712	73	applied	\N	\N	\N	\N	129493	129493	297093
16687	21715	74	applied	\N	\N	\N	\N	129494	129494	297094
16687	21718	75	applied	\N	\N	\N	\N	129495	129495	297095
16687	21724	76	applied	\N	\N	\N	\N	129496	129496	297096
16687	21727	77	applied	\N	\N	\N	\N	129497	129497	297097
16687	21731	78	applied	\N	\N	\N	\N	129498	129498	297098
16687	21732	79	applied	\N	\N	\N	\N	129499	129499	297099
16687	21741	81	applied	\N	\N	\N	\N	129501	129501	297101
16687	21745	82	applied	\N	\N	\N	\N	129502	129502	297102
16687	21749	83	applied	\N	\N	\N	\N	129503	129503	297103
16687	21752	84	applied	\N	\N	\N	\N	129504	129504	297104
16687	21756	85	applied	\N	\N	\N	\N	129505	129505	297105
16687	21757	86	applied	\N	\N	\N	\N	129506	129506	297106
16687	21758	87	applied	\N	\N	\N	\N	129507	129507	297107
16687	21766	88	applied	\N	\N	\N	\N	129508	129508	297108
16687	21767	89	applied	\N	\N	\N	\N	129509	129509	297109
16687	21772	90	applied	\N	\N	\N	\N	129510	129510	297110
16687	21773	91	applied	\N	\N	\N	\N	129511	129511	297111
16687	21778	92	applied	\N	\N	\N	\N	129512	129512	297112
16687	21779	93	applied	\N	\N	\N	\N	129513	129513	297113
16687	21785	94	applied	\N	\N	\N	\N	129514	129514	297114
16687	21791	95	applied	\N	\N	\N	\N	129515	129515	297115
16687	21794	96	applied	\N	\N	\N	\N	129516	129516	297116
16687	21803	98	applied	\N	\N	\N	\N	129518	129518	297118
16687	21806	99	applied	\N	\N	\N	\N	129519	129519	297119
16687	21810	100	applied	\N	\N	\N	\N	129520	129520	297120
16687	21812	101	applied	\N	\N	\N	\N	129521	129521	297121
16687	21816	102	applied	\N	\N	\N	\N	129522	129522	297122
16687	21819	103	applied	\N	\N	\N	\N	129523	129523	297123
16687	21822	104	applied	\N	\N	\N	\N	129524	129524	297124
16687	21826	105	applied	\N	\N	\N	\N	129525	129525	297125
16687	21830	106	applied	\N	\N	\N	\N	129526	129526	297126
16687	21833	107	applied	\N	\N	\N	\N	129527	129527	297127
16687	21836	108	applied	\N	\N	\N	\N	129528	129528	297128
16687	21838	109	applied	\N	\N	\N	\N	129529	129529	297129
16687	21841	110	applied	\N	\N	\N	\N	129530	129530	297130
16687	21842	111	applied	\N	\N	\N	\N	129531	129531	297131
16687	21848	112	applied	\N	\N	\N	\N	129532	129532	297132
16687	21851	113	applied	\N	\N	\N	\N	129533	129533	297133
16687	21860	115	applied	\N	\N	\N	\N	129535	129535	297135
16687	21867	116	applied	\N	\N	\N	\N	129536	129536	297136
16687	21870	117	applied	\N	\N	\N	\N	129537	129537	297137
16687	21873	118	applied	\N	\N	\N	\N	129538	129538	297138
16687	21874	119	applied	\N	\N	\N	\N	129539	129539	297139
16687	21880	120	applied	\N	\N	\N	\N	129540	129540	297140
16687	21883	121	applied	\N	\N	\N	\N	129541	129541	297141
16687	21887	122	applied	\N	\N	\N	\N	129542	129542	297142
16687	21888	123	applied	\N	\N	\N	\N	129543	129543	297143
16687	21889	124	applied	\N	\N	\N	\N	129544	129544	297144
16687	21890	125	applied	\N	\N	\N	\N	129545	129545	297145
16689	22000	0	applied	\N	\N	\N	\N	129562	129562	297162
16689	22001	1	applied	\N	\N	\N	\N	129563	129563	297163
16689	22002	2	applied	\N	\N	\N	\N	129564	129564	297164
16689	22003	3	applied	\N	\N	\N	\N	129565	129565	297165
16689	22004	4	applied	\N	\N	\N	\N	129566	129566	297166
16689	22006	6	applied	\N	\N	\N	\N	129568	129568	297168
16694	22017	0	applied	\N	\N	\N	\N	129593	129593	297193
16694	22018	1	applied	\N	\N	\N	\N	129594	129594	297194
16697	22028	0	applied	\N	\N	\N	\N	129606	129606	297206
16697	22029	1	applied	\N	\N	\N	\N	129607	129607	297207
16697	22030	2	applied	\N	\N	\N	\N	129608	129608	297208
16700	22038	0	applied	\N	\N	\N	\N	129616	129616	297216
16700	22039	1	applied	\N	\N	\N	\N	129617	129617	297217
16707	21854	0	applied	\N	\N	\N	\N	129646	129646	297246
16707	21864	1	applied	\N	\N	\N	\N	129647	129647	297247
16707	21865	2	applied	\N	\N	\N	\N	129648	129648	297248
16707	21866	3	applied	\N	\N	\N	\N	129649	129649	297249
16707	21812	4	applied	\N	\N	\N	\N	129650	129650	297250
16707	21816	5	applied	\N	\N	\N	\N	129651	129651	297251
16707	21819	6	applied	\N	\N	\N	\N	129652	129652	297252
16687	21579	29	applied	\N	\N	\N	\N	129449	129449	297050
16687	21585	31	applied	\N	\N	\N	\N	129451	129451	297052
16693	22016	2	applied	\N	\N	\N	\N	129592	129592	297192
16695	22017	0	applied	\N	\N	\N	\N	129595	129595	297195
16695	22018	1	applied	\N	\N	\N	\N	129596	129596	297196
16696	22019	0	applied	\N	\N	\N	\N	129597	129597	297197
16696	22020	1	applied	\N	\N	\N	\N	129598	129598	297198
16696	22021	2	applied	\N	\N	\N	\N	129599	129599	297199
16696	22022	3	applied	\N	\N	\N	\N	129600	129600	297200
16696	22023	4	applied	\N	\N	\N	\N	129601	129601	297201
16696	22024	5	applied	\N	\N	\N	\N	129602	129602	297202
16696	22025	6	applied	\N	\N	\N	\N	129603	129603	297203
16696	22026	7	applied	\N	\N	\N	\N	129604	129604	297204
16696	22027	8	applied	\N	\N	\N	\N	129605	129605	297205
16701	22040	0	applied	\N	\N	\N	\N	129618	129618	297218
16701	22041	1	applied	\N	\N	\N	\N	129619	129619	297219
16701	22042	2	applied	\N	\N	\N	\N	129620	129620	297220
16701	22043	3	applied	\N	\N	\N	\N	129621	129621	297221
16704	22045	1	applied	\N	\N	\N	\N	129630	129630	297230
16704	22046	2	applied	\N	\N	\N	\N	129631	129631	297231
16707	21822	7	applied	\N	\N	\N	\N	129653	129653	297253
16707	21826	8	applied	\N	\N	\N	\N	129654	129654	297254
16707	21830	9	applied	\N	\N	\N	\N	129655	129655	297255
16707	21833	10	applied	\N	\N	\N	\N	129656	129656	297256
16707	21836	11	applied	\N	\N	\N	\N	129657	129657	297257
16707	21838	12	applied	\N	\N	\N	\N	129658	129658	297258
16707	21841	13	applied	\N	\N	\N	\N	129659	129659	297259
16707	21842	14	applied	\N	\N	\N	\N	129660	129660	297260
16707	21848	15	applied	\N	\N	\N	\N	129661	129661	297261
16707	21851	16	applied	\N	\N	\N	\N	129662	129662	297262
16707	21855	17	applied	\N	\N	\N	\N	129663	129663	297263
16707	21860	18	applied	\N	\N	\N	\N	129664	129664	297264
16707	21867	20	applied	\N	\N	\N	\N	129665	129665	297265
16707	21870	21	applied	\N	\N	\N	\N	129666	129666	297266
16707	21874	23	applied	\N	\N	\N	\N	129668	129668	297268
16707	21880	24	applied	\N	\N	\N	\N	129669	129669	297269
16707	21883	25	applied	\N	\N	\N	\N	129670	129670	297270
16707	21887	26	applied	\N	\N	\N	\N	129671	129671	297271
16707	21888	27	applied	\N	\N	\N	\N	129672	129672	297272
16707	21889	28	applied	\N	\N	\N	\N	129673	129673	297273
16707	21890	29	applied	\N	\N	\N	\N	129674	129674	297274
16707	21899	30	applied	\N	\N	\N	\N	129675	129675	297275
16707	21902	31	applied	\N	\N	\N	\N	129676	129676	297276
16707	21905	32	applied	\N	\N	\N	\N	129677	129677	297277
16707	21906	33	applied	\N	\N	\N	\N	129678	129678	297278
16707	21911	34	applied	\N	\N	\N	\N	129679	129679	297279
16707	21912	35	applied	\N	\N	\N	\N	129680	129680	297280
16707	21918	36	applied	\N	\N	\N	\N	129681	129681	297281
16707	21921	37	applied	\N	\N	\N	\N	129682	129682	297282
16707	21924	38	applied	\N	\N	\N	\N	129683	129683	297283
16707	21926	40	applied	\N	\N	\N	\N	129685	129685	297285
16707	21933	41	applied	\N	\N	\N	\N	129686	129686	297286
16707	21936	42	applied	\N	\N	\N	\N	129687	129687	297287
16707	21940	43	applied	\N	\N	\N	\N	129688	129688	297288
16707	21943	44	applied	\N	\N	\N	\N	129689	129689	297289
16707	21946	45	applied	\N	\N	\N	\N	129690	129690	297290
16707	21947	46	applied	\N	\N	\N	\N	129691	129691	297291
16707	21952	47	applied	\N	\N	\N	\N	129692	129692	297292
16707	21953	48	applied	\N	\N	\N	\N	129693	129693	297293
16707	21959	49	applied	\N	\N	\N	\N	129694	129694	297294
16707	21962	50	applied	\N	\N	\N	\N	129695	129695	297295
16707	21965	51	applied	\N	\N	\N	\N	129696	129696	297296
16707	21966	52	applied	\N	\N	\N	\N	129697	129697	297297
16707	21967	53	applied	\N	\N	\N	\N	129698	129698	297298
16707	21975	54	applied	\N	\N	\N	\N	129699	129699	297299
16707	21976	55	applied	\N	\N	\N	\N	129700	129700	297300
16707	21984	57	applied	\N	\N	\N	\N	129702	129702	297302
16707	21985	58	applied	\N	\N	\N	\N	129703	129703	297303
16707	21986	59	applied	\N	\N	\N	\N	129704	129704	297304
16707	21987	60	applied	\N	\N	\N	\N	129705	129705	297305
16707	21988	61	applied	\N	\N	\N	\N	129706	129706	297306
16707	22000	62	applied	\N	\N	\N	\N	129707	129707	297307
16707	22001	63	applied	\N	\N	\N	\N	129708	129708	297308
16707	22007	64	applied	\N	\N	\N	\N	129709	129709	297309
16707	22008	65	applied	\N	\N	\N	\N	129710	129710	297310
16707	22014	66	applied	\N	\N	\N	\N	129711	129711	297311
16707	22017	67	applied	\N	\N	\N	\N	129712	129712	297312
16707	22019	68	applied	\N	\N	\N	\N	129713	129713	297313
16707	22020	69	applied	\N	\N	\N	\N	129714	129714	297314
16707	22028	70	applied	\N	\N	\N	\N	129715	129715	297315
16707	22031	71	applied	\N	\N	\N	\N	129716	129716	297316
16707	22035	72	applied	\N	\N	\N	\N	129717	129717	297317
16707	22040	74	applied	\N	\N	\N	\N	129719	129719	297319
16707	22044	75	applied	\N	\N	\N	\N	129720	129720	297320
16707	22047	76	applied	\N	\N	\N	\N	129721	129721	297321
16707	22048	77	applied	\N	\N	\N	\N	129722	129722	297322
16707	21856	78	applied	\N	\N	\N	\N	129723	129723	297323
16707	21814	79	applied	\N	\N	\N	\N	129724	129724	297324
16707	21813	80	applied	\N	\N	\N	\N	129725	129725	297325
16707	21817	81	applied	\N	\N	\N	\N	129726	129726	297326
16707	21820	82	applied	\N	\N	\N	\N	129727	129727	297327
16707	21824	83	applied	\N	\N	\N	\N	129728	129728	297328
16707	21827	84	applied	\N	\N	\N	\N	129729	129729	297329
16707	21832	85	applied	\N	\N	\N	\N	129730	129730	297330
16707	21863	86	applied	\N	\N	\N	\N	129731	129731	297331
16707	21825	87	applied	\N	\N	\N	\N	129732	129732	297332
16707	21837	88	applied	\N	\N	\N	\N	129733	129733	297333
16707	21844	89	applied	\N	\N	\N	\N	129734	129734	297334
16712	22071	2	applied	\N	\N	\N	\N	129910	129910	297510
16712	22072	3	applied	\N	\N	\N	\N	129911	129911	297511
16717	22070	0	applied	\N	\N	\N	\N	129922	129922	297522
16717	22071	2	applied	\N	\N	\N	\N	129923	129923	297523
16717	22072	3	applied	\N	\N	\N	\N	129924	129924	297524
16721	21784	0	applied	\N	\N	\N	\N	129938	129938	297538
16721	21854	1	applied	\N	\N	\N	\N	129939	129939	297539
16721	21864	2	applied	\N	\N	\N	\N	129940	129940	297540
16721	21865	3	applied	\N	\N	\N	\N	129941	129941	297541
16721	21866	4	applied	\N	\N	\N	\N	129942	129942	297542
16721	21789	5	applied	\N	\N	\N	\N	129943	129943	297543
16721	21790	6	applied	\N	\N	\N	\N	129944	129944	297544
16721	21797	7	applied	\N	\N	\N	\N	129945	129945	297545
16721	21396	8	applied	\N	\N	\N	\N	129946	129946	297546
16691	22013	6	applied	\N	\N	\N	\N	129582	129582	297182
16693	22014	0	applied	\N	\N	\N	\N	129590	129590	297190
16706	22049	2	applied	\N	\N	\N	\N	129641	129641	297241
16706	22050	3	applied	\N	\N	\N	\N	129642	129642	297242
16706	22051	4	applied	\N	\N	\N	\N	129643	129643	297243
16706	22052	5	applied	\N	\N	\N	\N	129644	129644	297244
16706	22053	6	applied	\N	\N	\N	\N	129645	129645	297245
16711	22068	1	applied	\N	\N	\N	\N	129907	129907	297507
16711	22069	2	applied	\N	\N	\N	\N	129908	129908	297508
16714	22070	0	applied	\N	\N	\N	\N	129913	129913	297513
16714	22071	2	applied	\N	\N	\N	\N	129914	129914	297514
16714	22072	3	applied	\N	\N	\N	\N	129915	129915	297515
16716	22070	0	applied	\N	\N	\N	\N	129919	129919	297519
16716	22071	2	applied	\N	\N	\N	\N	129920	129920	297520
16716	22072	3	applied	\N	\N	\N	\N	129921	129921	297521
16720	22073	0	applied	\N	\N	\N	\N	129931	129931	297531
16720	22074	1	applied	\N	\N	\N	\N	129932	129932	297532
16720	22075	2	applied	\N	\N	\N	\N	129933	129933	297533
16720	22076	3	applied	\N	\N	\N	\N	129934	129934	297534
16720	22077	4	applied	\N	\N	\N	\N	129935	129935	297535
16720	22078	5	applied	\N	\N	\N	\N	129936	129936	297536
16720	22079	6	applied	\N	\N	\N	\N	129937	129937	297537
16721	21400	9	applied	\N	\N	\N	\N	129947	129947	297547
16721	21462	11	applied	\N	\N	1000000000	\N	129949	129949	297549
16721	21578	12	applied	\N	\N	1000000000	\N	129950	129950	297550
16721	21599	13	applied	\N	\N	1000000000	\N	129951	129951	297551
16721	21409	14	applied	\N	\N	\N	\N	129952	129952	297552
16721	21401	16	applied	\N	\N	\N	\N	129954	129954	297553
16721	21719	15	failed	Receiver_not_present	\N	\N	\N	129953	129953	\N
16721	21407	17	applied	\N	\N	\N	\N	129955	129955	297554
16721	21408	18	applied	\N	\N	\N	\N	129956	129956	297555
16721	21410	19	applied	\N	\N	\N	\N	129957	129957	297556
16721	21419	20	applied	\N	\N	\N	\N	129958	129958	297557
16721	21423	21	applied	\N	\N	\N	\N	129959	129959	297558
16721	21428	22	applied	\N	\N	\N	\N	129960	129960	297559
16721	21431	23	applied	\N	\N	\N	\N	129961	129961	297560
16721	21435	24	applied	\N	\N	\N	\N	129962	129962	297561
16721	21438	25	applied	\N	\N	\N	\N	129963	129963	297562
16721	21439	26	applied	\N	\N	\N	\N	129964	129964	297563
16721	21440	27	applied	\N	\N	\N	\N	129965	129965	297564
16721	21448	28	applied	\N	\N	\N	\N	129966	129966	297565
16721	21451	30	applied	\N	\N	\N	\N	129968	129968	297567
16721	21457	31	applied	\N	\N	\N	\N	129969	129969	297568
16721	21460	32	applied	\N	\N	\N	\N	129970	129970	297569
16721	21461	33	applied	\N	\N	\N	\N	129971	129971	297570
16721	21468	34	applied	\N	\N	\N	\N	129972	129972	297571
16721	21471	35	applied	\N	\N	\N	\N	129973	129973	297572
16721	21474	36	applied	\N	\N	\N	\N	129974	129974	297573
16721	21475	37	applied	\N	\N	\N	\N	129975	129975	297574
16721	21476	38	applied	\N	\N	\N	\N	129976	129976	297575
16721	21484	39	applied	\N	\N	\N	\N	129977	129977	297576
16721	21488	40	applied	\N	\N	\N	\N	129978	129978	297577
16721	21491	41	applied	\N	\N	\N	\N	129979	129979	297578
16721	21493	42	applied	\N	\N	\N	\N	129980	129980	297579
16721	21496	43	applied	\N	\N	\N	\N	129981	129981	297580
16721	21500	44	applied	\N	\N	\N	\N	129982	129982	297581
16721	21503	45	applied	\N	\N	\N	\N	129983	129983	297582
16721	21510	47	applied	\N	\N	\N	\N	129985	129985	297584
16721	21513	48	applied	\N	\N	\N	\N	129986	129986	297585
16721	21516	49	applied	\N	\N	\N	\N	129987	129987	297586
16721	21520	50	applied	\N	\N	\N	\N	129988	129988	297587
16721	21522	51	applied	\N	\N	\N	\N	129989	129989	297588
16721	21523	52	applied	\N	\N	\N	\N	129990	129990	297589
16721	21524	53	applied	\N	\N	\N	\N	129991	129991	297590
16721	21534	54	applied	\N	\N	\N	\N	129992	129992	297591
16721	21537	55	applied	\N	\N	\N	\N	129993	129993	297592
16721	21540	57	applied	\N	\N	\N	\N	129994	129994	297593
16721	21545	58	applied	\N	\N	\N	\N	129995	129995	297594
16721	21548	59	applied	\N	\N	\N	\N	129996	129996	297595
16721	21549	60	applied	\N	\N	\N	\N	129997	129997	297596
16721	21554	61	applied	\N	\N	\N	\N	129998	129998	297597
16721	21559	62	applied	\N	\N	\N	\N	129999	129999	297598
16721	21560	63	applied	\N	\N	\N	\N	130000	130000	297599
16721	21571	65	applied	\N	\N	\N	\N	130002	130002	297601
16721	21574	66	applied	\N	\N	\N	\N	130003	130003	297602
16721	21579	67	applied	\N	\N	\N	\N	130004	130004	297603
16721	21582	68	applied	\N	\N	\N	\N	130005	130005	297604
16721	21585	69	applied	\N	\N	\N	\N	130006	130006	297605
16721	21586	70	applied	\N	\N	\N	\N	130007	130007	297606
16721	21587	71	applied	\N	\N	\N	\N	130008	130008	297607
16721	21593	72	applied	\N	\N	\N	\N	130009	130009	297608
16721	21596	73	applied	\N	\N	\N	\N	130010	130010	297609
16721	21597	74	applied	\N	\N	\N	\N	130011	130011	297610
16721	21598	75	applied	\N	\N	\N	\N	130012	130012	297611
16721	21607	76	applied	\N	\N	\N	\N	130013	130013	297612
16721	21608	77	applied	\N	\N	\N	\N	130014	130014	297613
16721	21614	78	applied	\N	\N	\N	\N	130015	130015	297614
16721	21615	79	applied	\N	\N	\N	\N	130016	130016	297615
16721	21616	80	applied	\N	\N	\N	\N	130017	130017	297616
16721	21618	82	applied	\N	\N	\N	\N	130019	130019	297618
16721	21630	83	applied	\N	\N	\N	\N	130020	130020	297619
16721	21634	84	applied	\N	\N	\N	\N	130021	130021	297620
16721	21637	85	applied	\N	\N	\N	\N	130022	130022	297621
16721	21640	86	applied	\N	\N	\N	\N	130023	130023	297622
16721	21644	87	applied	\N	\N	\N	\N	130024	130024	297623
16721	21647	88	applied	\N	\N	\N	\N	130025	130025	297624
16721	21648	89	applied	\N	\N	\N	\N	130026	130026	297625
16721	21652	90	applied	\N	\N	\N	\N	130027	130027	297626
16722	22040	0	applied	\N	\N	\N	\N	130063	130063	297662
16722	22044	1	applied	\N	\N	\N	\N	130064	130064	297663
16722	22047	2	applied	\N	\N	\N	\N	130065	130065	297664
16722	22048	3	applied	\N	\N	\N	\N	130066	130066	297665
16722	22054	4	applied	\N	\N	\N	\N	130067	130067	297666
16722	22057	5	applied	\N	\N	\N	\N	130068	130068	297667
16722	22058	6	applied	\N	\N	\N	\N	130069	130069	297668
16722	22067	8	applied	\N	\N	\N	\N	130071	130071	297670
16722	22070	9	applied	\N	\N	\N	\N	130072	130072	297671
16722	22073	10	applied	\N	\N	\N	\N	130073	130073	297672
16722	22074	11	applied	\N	\N	\N	\N	130074	130074	297673
16722	22080	12	applied	\N	\N	\N	\N	130075	130075	297674
16722	22041	13	applied	\N	\N	\N	\N	130076	130076	297675
16706	22047	0	applied	\N	\N	\N	\N	129639	129639	297239
16706	22048	1	applied	\N	\N	\N	\N	129640	129640	297240
16707	21908	94	applied	\N	\N	\N	\N	129739	129739	297339
16707	21913	95	applied	\N	\N	\N	\N	129740	129740	297340
16707	21927	96	applied	\N	\N	\N	\N	129741	129741	297341
16707	21938	97	applied	\N	\N	\N	\N	129742	129742	297342
16707	21950	98	applied	\N	\N	\N	\N	129743	129743	297343
16707	21954	99	applied	\N	\N	\N	\N	129744	129744	297344
16707	21968	100	applied	\N	\N	\N	\N	129745	129745	297345
16707	21977	101	applied	\N	\N	\N	\N	129746	129746	297346
16707	21989	102	applied	\N	\N	\N	\N	129747	129747	297347
16707	22004	103	applied	\N	\N	\N	\N	129748	129748	297348
16707	22011	104	applied	\N	\N	\N	\N	129749	129749	297349
16707	22023	105	applied	\N	\N	\N	\N	129750	129750	297350
16707	22034	106	applied	\N	\N	\N	\N	129751	129751	297351
16707	22043	107	applied	\N	\N	\N	\N	129752	129752	297352
16707	22053	108	applied	\N	\N	\N	\N	129753	129753	297353
16707	21835	109	applied	\N	\N	\N	\N	129754	129754	297354
16707	21843	111	applied	\N	\N	\N	\N	129756	129756	297356
16707	21847	112	applied	\N	\N	\N	\N	129757	129757	297357
16707	21850	113	applied	\N	\N	\N	\N	129758	129758	297358
16707	21853	114	applied	\N	\N	\N	\N	129759	129759	297359
16707	21858	115	applied	\N	\N	\N	\N	129760	129760	297360
16707	21861	116	applied	\N	\N	\N	\N	129761	129761	297361
16707	21868	117	applied	\N	\N	\N	\N	129762	129762	297362
16707	21871	118	applied	\N	\N	\N	\N	129763	129763	297363
16707	21877	119	applied	\N	\N	\N	\N	129764	129764	297364
16707	21878	120	applied	\N	\N	\N	\N	129765	129765	297365
16707	21881	121	applied	\N	\N	\N	\N	129766	129766	297366
16707	21884	122	applied	\N	\N	\N	\N	129767	129767	297367
16710	22057	0	applied	\N	\N	\N	\N	129896	129896	297496
16710	22058	1	applied	\N	\N	\N	\N	129897	129897	297497
16710	22059	2	applied	\N	\N	\N	\N	129898	129898	297498
16710	22060	3	applied	\N	\N	\N	\N	129899	129899	297499
16722	22042	14	applied	\N	\N	\N	\N	130077	130077	297676
16722	22045	15	applied	\N	\N	\N	\N	130078	130078	297677
16722	22046	16	applied	\N	\N	\N	\N	130079	130079	297678
16722	22049	17	applied	\N	\N	\N	\N	130080	130080	297679
16722	22050	18	applied	\N	\N	\N	\N	130081	130081	297680
16722	22051	19	applied	\N	\N	\N	\N	130082	130082	297681
16722	22052	20	applied	\N	\N	\N	\N	130083	130083	297682
16722	22055	21	applied	\N	\N	\N	\N	130084	130084	297683
16722	22043	22	applied	\N	\N	\N	\N	130085	130085	297684
16722	22053	23	applied	\N	\N	\N	\N	130086	130086	297685
16722	22062	24	applied	\N	\N	\N	\N	130087	130087	297686
16722	22079	25	applied	\N	\N	\N	\N	130088	130088	297687
16722	22064	26	applied	\N	\N	\N	\N	130089	130089	297688
16722	22065	27	applied	\N	\N	\N	\N	130090	130090	297689
16722	22066	28	applied	\N	\N	\N	\N	130091	130091	297690
16722	22068	29	applied	\N	\N	\N	\N	130092	130092	297691
16722	22075	31	applied	\N	\N	\N	\N	130094	130094	297693
16722	22076	32	applied	\N	\N	\N	\N	130095	130095	297694
16722	22081	33	applied	\N	\N	\N	\N	130096	130096	297695
16722	22056	34	applied	\N	\N	\N	\N	130097	130097	297696
16722	22060	35	applied	\N	\N	\N	\N	130098	130098	297697
16722	22061	36	applied	\N	\N	\N	\N	130099	130099	297698
16722	22063	37	applied	\N	\N	\N	\N	130100	130100	297699
16722	22069	38	applied	\N	\N	\N	\N	130101	130101	297700
16722	22071	39	applied	\N	\N	\N	\N	130102	130102	297701
16722	22077	40	applied	\N	\N	\N	\N	130103	130103	297702
16722	22078	41	applied	\N	\N	\N	\N	130104	130104	297703
16722	22082	42	applied	\N	\N	\N	\N	130105	130105	297704
16725	22087	0	applied	\N	\N	\N	\N	130120	130120	297719
16725	22088	1	applied	\N	\N	\N	\N	130121	130121	297720
16725	22089	2	applied	\N	\N	\N	\N	130122	130122	297721
16725	22090	3	applied	\N	\N	\N	\N	130123	130123	297722
16731	22095	0	applied	\N	\N	\N	\N	130140	130140	297739
16731	22096	1	applied	\N	\N	\N	\N	130141	130141	297740
16733	22097	0	applied	\N	\N	\N	\N	130145	130145	297744
16733	22098	1	applied	\N	\N	\N	\N	130146	130146	297745
16733	22099	2	applied	\N	\N	\N	\N	130147	130147	297746
16738	22104	0	applied	\N	\N	\N	\N	130166	130166	297763
16738	22105	1	applied	\N	\N	\N	\N	130167	130167	297764
16738	22106	2	applied	\N	\N	\N	\N	130168	130168	297765
16738	22107	3	applied	\N	\N	\N	\N	130169	130169	297766
16738	22108	4	applied	\N	\N	\N	\N	130170	130170	297767
16748	22117	0	applied	\N	\N	\N	\N	130356	130356	297948
16748	22118	1	applied	\N	\N	\N	\N	130357	130357	297949
16748	22119	2	applied	\N	\N	\N	\N	130358	130358	297950
16748	22120	3	applied	\N	\N	\N	\N	130359	130359	297951
16748	22121	4	applied	\N	\N	\N	\N	130360	130360	297952
16748	22122	5	applied	\N	\N	\N	\N	130361	130361	297953
16748	22124	7	applied	\N	\N	\N	\N	130363	130363	297955
16748	22125	8	applied	\N	\N	\N	\N	130364	130364	297956
16748	22126	9	applied	\N	\N	\N	\N	130365	130365	297957
16753	22134	0	applied	\N	\N	\N	\N	130381	130381	297973
16753	22135	1	applied	\N	\N	\N	\N	130382	130382	297974
16753	22136	2	applied	\N	\N	\N	\N	130383	130383	297975
16757	22140	0	applied	\N	\N	\N	\N	130515	130515	298105
16757	22141	1	applied	\N	\N	\N	\N	130516	130516	298106
16757	22142	2	applied	\N	\N	\N	\N	130517	130517	298107
16762	22143	0	applied	\N	\N	\N	\N	130530	130530	298120
16762	22144	1	applied	\N	\N	\N	\N	130531	130531	298121
16762	22145	2	applied	\N	\N	\N	\N	130532	130532	298122
16768	22151	0	applied	\N	\N	\N	\N	130606	130606	298196
16768	22152	1	applied	\N	\N	\N	\N	130607	130607	298197
16768	22153	2	applied	\N	\N	\N	\N	130608	130608	298198
16768	22154	3	applied	\N	\N	\N	\N	130609	130609	298199
16777	22182	1	applied	\N	\N	\N	\N	130786	130786	298376
16777	22183	2	applied	\N	\N	\N	\N	130787	130787	298377
16777	22184	3	applied	\N	\N	\N	\N	130788	130788	298378
16777	22185	4	applied	\N	\N	\N	\N	130789	130789	298379
16777	22186	5	applied	\N	\N	\N	\N	130790	130790	298380
16777	22187	6	applied	\N	\N	\N	\N	130791	130791	298381
16783	22194	0	applied	\N	\N	\N	\N	130815	130815	298405
16783	22195	1	applied	\N	\N	\N	\N	130816	130816	298406
16783	22196	2	applied	\N	\N	\N	\N	130817	130817	298407
16783	22197	3	applied	\N	\N	\N	\N	130818	130818	298408
16783	22198	4	applied	\N	\N	\N	\N	130819	130819	298409
16783	22199	5	applied	\N	\N	\N	\N	130820	130820	298410
16783	22200	6	applied	\N	\N	\N	\N	130821	130821	298411
16785	22201	0	applied	\N	\N	\N	\N	130886	130886	298474
16707	21875	91	applied	\N	\N	\N	\N	129736	129736	297336
16707	21885	92	applied	\N	\N	\N	\N	129737	129737	297337
16709	21967	73	applied	\N	\N	\N	\N	129843	129843	297443
16709	21975	74	applied	\N	\N	\N	\N	129844	129844	297444
16709	21976	75	applied	\N	\N	\N	\N	129845	129845	297445
16709	21982	76	applied	\N	\N	\N	\N	129846	129846	297446
16709	21984	77	applied	\N	\N	\N	\N	129847	129847	297447
16709	21985	78	applied	\N	\N	\N	\N	129848	129848	297448
16709	21986	79	applied	\N	\N	\N	\N	129849	129849	297449
16709	21987	80	applied	\N	\N	\N	\N	129850	129850	297450
16709	21988	81	applied	\N	\N	\N	\N	129851	129851	297451
16709	22000	82	applied	\N	\N	\N	\N	129852	129852	297452
16709	22001	83	applied	\N	\N	\N	\N	129853	129853	297453
16709	22007	84	applied	\N	\N	\N	\N	129854	129854	297454
16709	22008	85	applied	\N	\N	\N	\N	129855	129855	297455
16709	22014	86	applied	\N	\N	\N	\N	129856	129856	297456
16709	22017	87	applied	\N	\N	\N	\N	129857	129857	297457
16709	22019	88	applied	\N	\N	\N	\N	129858	129858	297458
16709	22028	90	applied	\N	\N	\N	\N	129860	129860	297460
16709	22031	91	applied	\N	\N	\N	\N	129861	129861	297461
16709	22035	92	applied	\N	\N	\N	\N	129862	129862	297462
16709	22038	93	applied	\N	\N	\N	\N	129863	129863	297463
16709	22040	94	applied	\N	\N	\N	\N	129864	129864	297464
16709	22044	95	applied	\N	\N	\N	\N	129865	129865	297465
16709	22047	96	applied	\N	\N	\N	\N	129866	129866	297466
16709	22048	97	applied	\N	\N	\N	\N	129867	129867	297467
16709	22054	98	applied	\N	\N	\N	\N	129868	129868	297468
16709	21856	99	applied	\N	\N	\N	\N	129869	129869	297469
16709	21759	100	applied	\N	\N	\N	\N	129870	129870	297470
16709	21774	101	applied	\N	\N	\N	\N	129871	129871	297471
16709	21786	102	applied	\N	\N	\N	\N	129872	129872	297472
16709	21800	103	applied	\N	\N	\N	\N	129873	129873	297473
16709	21813	104	applied	\N	\N	\N	\N	129874	129874	297474
16709	21760	105	applied	\N	\N	\N	\N	129875	129875	297475
16710	22062	5	applied	\N	\N	\N	\N	129901	129901	297501
16710	22063	6	applied	\N	\N	\N	\N	129902	129902	297502
16710	22064	7	applied	\N	\N	\N	\N	129903	129903	297503
16710	22065	8	applied	\N	\N	\N	\N	129904	129904	297504
16710	22066	9	applied	\N	\N	\N	\N	129905	129905	297505
16719	22070	0	applied	\N	\N	\N	\N	129928	129928	297528
16719	22071	2	applied	\N	\N	\N	\N	129929	129929	297529
16719	22072	3	applied	\N	\N	\N	\N	129930	129930	297530
16724	22080	0	applied	\N	\N	\N	\N	130113	130113	297712
16724	22083	1	applied	\N	\N	\N	\N	130114	130114	297713
16724	22082	2	applied	\N	\N	\N	\N	130115	130115	297714
16724	22084	3	applied	\N	\N	\N	\N	130116	130116	297715
16724	22085	4	applied	\N	\N	\N	\N	130117	130117	297716
16724	22081	5	applied	\N	\N	\N	\N	130118	130118	297717
16724	22086	6	applied	\N	\N	\N	\N	130119	130119	297718
16730	22095	0	applied	\N	\N	\N	\N	130138	130138	297737
16732	22097	0	applied	\N	\N	\N	\N	130142	130142	297741
16732	22098	1	applied	\N	\N	\N	\N	130143	130143	297742
16732	22099	2	applied	\N	\N	\N	\N	130144	130144	297743
16735	22100	0	applied	\N	\N	\N	\N	130152	130152	297750
16735	22101	1	applied	\N	\N	\N	\N	130153	130153	297751
16735	22102	2	applied	\N	\N	\N	\N	130154	130154	297752
16735	22103	3	applied	\N	\N	\N	\N	130155	130155	130155
16737	22104	0	applied	\N	\N	\N	\N	130161	130161	297758
16737	22105	1	applied	\N	\N	\N	\N	130162	130162	297759
16737	22106	2	applied	\N	\N	\N	\N	130163	130163	297760
16737	22107	3	applied	\N	\N	\N	\N	130164	130164	297761
16737	22108	4	applied	\N	\N	\N	\N	130165	130165	297762
16742	22109	0	applied	\N	\N	\N	\N	130192	130192	297787
16742	22110	1	applied	\N	\N	\N	\N	130193	130193	297788
16742	22111	2	applied	\N	\N	\N	\N	130194	130194	297789
16742	22112	3	applied	\N	\N	\N	\N	130195	130195	130195
16742	22114	5	applied	\N	\N	\N	\N	130197	130197	297791
16742	22115	6	applied	\N	\N	\N	\N	130198	130198	297792
16742	22116	7	applied	\N	\N	\N	\N	130199	130199	297793
16747	22117	0	applied	\N	\N	\N	\N	130346	130346	297938
16747	22118	1	applied	\N	\N	\N	\N	130347	130347	297939
16747	22119	2	applied	\N	\N	\N	\N	130348	130348	297940
16747	22120	3	applied	\N	\N	\N	\N	130349	130349	297941
16747	22121	4	applied	\N	\N	\N	\N	130350	130350	297942
16747	22122	5	applied	\N	\N	\N	\N	130351	130351	297943
16747	22123	6	applied	\N	\N	\N	\N	130352	130352	297944
16747	22124	7	applied	\N	\N	\N	\N	130353	130353	297945
16747	22125	8	applied	\N	\N	\N	\N	130354	130354	297946
16747	22126	9	applied	\N	\N	\N	\N	130355	130355	297947
16751	22127	0	applied	\N	\N	\N	\N	130374	130374	297966
16751	22128	1	applied	\N	\N	\N	\N	130375	130375	297967
16751	22129	2	applied	\N	\N	\N	\N	130376	130376	297968
16755	22137	0	applied	\N	\N	\N	\N	130387	130387	297979
16755	22138	1	applied	\N	\N	\N	\N	130388	130388	297980
16755	22139	2	applied	\N	\N	\N	\N	130389	130389	297981
16760	22140	0	applied	\N	\N	\N	\N	130524	130524	298114
16760	22141	1	applied	\N	\N	\N	\N	130525	130525	298115
16760	22142	2	applied	\N	\N	\N	\N	130526	130526	298116
16761	22143	0	applied	\N	\N	\N	\N	130527	130527	298117
16761	22144	1	applied	\N	\N	\N	\N	130528	130528	298118
16761	22145	2	applied	\N	\N	\N	\N	130529	130529	298119
16766	22149	0	applied	\N	\N	\N	\N	130541	130541	298131
16766	22150	1	applied	\N	\N	\N	\N	130542	130542	298132
16771	22158	0	applied	\N	\N	\N	\N	130620	130620	298210
16771	22159	1	applied	\N	\N	\N	\N	130621	130621	298211
16771	22160	2	applied	\N	\N	\N	\N	130622	130622	298212
16771	22161	3	applied	\N	\N	\N	\N	130623	130623	298213
16771	22162	4	applied	\N	\N	\N	\N	130624	130624	298214
16771	22164	6	applied	\N	\N	\N	\N	130626	130626	298216
16772	21854	0	applied	\N	\N	\N	\N	130627	130627	298217
16772	21864	1	applied	\N	\N	\N	\N	130628	130628	298218
16772	21865	2	applied	\N	\N	\N	\N	130629	130629	298219
16772	21866	3	applied	\N	\N	\N	\N	130630	130630	298220
16772	21855	4	applied	\N	\N	\N	\N	130631	130631	298221
16772	21860	5	applied	\N	\N	\N	\N	130632	130632	298222
16772	21867	6	applied	\N	\N	\N	\N	130633	130633	298223
16772	21870	7	applied	\N	\N	\N	\N	130634	130634	298224
16772	21873	8	applied	\N	\N	\N	\N	130635	130635	298225
16772	21874	9	applied	\N	\N	\N	\N	130636	130636	298226
16772	21880	10	applied	\N	\N	\N	\N	130637	130637	298227
16772	21883	11	applied	\N	\N	\N	\N	130638	130638	298228
16772	22105	12	applied	\N	\N	\N	\N	130639	130639	298229
16709	21962	70	applied	\N	\N	\N	\N	129840	129840	297440
16709	21965	71	applied	\N	\N	\N	\N	129841	129841	297441
16709	21775	111	applied	\N	\N	\N	\N	129881	129881	297481
16709	21780	112	applied	\N	\N	\N	\N	129882	129882	297482
16709	21783	113	applied	\N	\N	\N	\N	129883	129883	297483
16709	21787	114	applied	\N	\N	\N	\N	129884	129884	297484
16709	21792	115	applied	\N	\N	\N	\N	129885	129885	297485
16709	21796	116	applied	\N	\N	\N	\N	129886	129886	297486
16709	21801	117	applied	\N	\N	\N	\N	129887	129887	297487
16709	21804	118	applied	\N	\N	\N	\N	129888	129888	297488
16709	21863	119	applied	\N	\N	\N	\N	129889	129889	297489
16709	21825	120	applied	\N	\N	\N	\N	129890	129890	297490
16709	21837	121	applied	\N	\N	\N	\N	129891	129891	297491
16709	21844	122	applied	\N	\N	\N	\N	129892	129892	297492
16709	21857	123	applied	\N	\N	\N	\N	129893	129893	297493
16709	21875	124	applied	\N	\N	\N	\N	129894	129894	297494
16713	22070	0	applied	\N	\N	\N	\N	129912	129912	297512
16715	22070	0	applied	\N	\N	\N	\N	129916	129916	297516
16715	22071	2	applied	\N	\N	\N	\N	129917	129917	297517
16715	22072	3	applied	\N	\N	\N	\N	129918	129918	297518
16718	22070	0	applied	\N	\N	\N	\N	129925	129925	297525
16718	22071	2	applied	\N	\N	\N	\N	129926	129926	297526
16718	22072	3	applied	\N	\N	\N	\N	129927	129927	297527
16721	21653	91	applied	\N	\N	\N	\N	130028	130028	297627
16721	21659	92	applied	\N	\N	\N	\N	130029	130029	297628
16721	21662	93	applied	\N	\N	\N	\N	130030	130030	297629
16721	21663	94	applied	\N	\N	\N	\N	130031	130031	297630
16721	21738	95	applied	\N	\N	1000000000	\N	130032	130032	297631
16721	21746	96	applied	\N	\N	\N	\N	130033	130033	297632
16721	21669	97	applied	\N	\N	\N	\N	130034	130034	297633
16721	21672	98	applied	\N	\N	\N	\N	130035	130035	297634
16721	21674	99	applied	\N	\N	\N	\N	130036	130036	297635
16721	21676	101	applied	\N	\N	\N	\N	130038	130038	297637
16721	21686	102	applied	\N	\N	\N	\N	130039	130039	297638
16721	21691	103	applied	\N	\N	\N	\N	130040	130040	297639
16721	21692	104	applied	\N	\N	\N	\N	130041	130041	297640
16721	21696	105	applied	\N	\N	\N	\N	130042	130042	297641
16721	21697	106	applied	\N	\N	\N	\N	130043	130043	297642
16721	21698	107	applied	\N	\N	\N	\N	130044	130044	297643
16721	21699	108	applied	\N	\N	\N	\N	130045	130045	297644
16721	21709	109	applied	\N	\N	\N	\N	130046	130046	297645
16721	21712	110	applied	\N	\N	\N	\N	130047	130047	297646
16721	21715	111	applied	\N	\N	\N	\N	130048	130048	297647
16721	21718	112	applied	\N	\N	\N	\N	130049	130049	297648
16721	21724	113	applied	\N	\N	\N	\N	130050	130050	297649
16721	21727	114	applied	\N	\N	\N	\N	130051	130051	297650
16721	21731	115	applied	\N	\N	\N	\N	130052	130052	297651
16721	21732	116	applied	\N	\N	\N	\N	130053	130053	297652
16721	21741	118	applied	\N	\N	\N	\N	130055	130055	297654
16721	21745	119	applied	\N	\N	\N	\N	130056	130056	297655
16721	21749	120	applied	\N	\N	\N	\N	130057	130057	297656
16721	21752	121	applied	\N	\N	\N	\N	130058	130058	297657
16721	21756	122	applied	\N	\N	\N	\N	130059	130059	297658
16721	21757	123	applied	\N	\N	\N	\N	130060	130060	297659
16721	21758	124	applied	\N	\N	\N	\N	130061	130061	297660
16721	21766	125	applied	\N	\N	\N	\N	130062	130062	297661
16723	22080	0	applied	\N	\N	\N	\N	130106	130106	297705
16723	22083	1	applied	\N	\N	\N	\N	130107	130107	297706
16723	22082	2	applied	\N	\N	\N	\N	130108	130108	297707
16727	22087	0	applied	\N	\N	\N	\N	130130	130130	297729
16727	22088	1	applied	\N	\N	\N	\N	130131	130131	297730
16727	22089	2	applied	\N	\N	\N	\N	130132	130132	297731
16727	22090	3	applied	\N	\N	\N	\N	130133	130133	297732
16727	22091	4	applied	\N	\N	\N	\N	130134	130134	297733
16728	22093	1	applied	\N	\N	\N	\N	130136	130136	297735
16728	22094	2	applied	\N	\N	\N	\N	130137	130137	297736
16734	22100	0	applied	\N	\N	\N	\N	130148	130148	297747
16734	22101	1	applied	\N	\N	\N	\N	130149	130149	297748
16734	22102	2	applied	\N	\N	\N	\N	130150	130150	297749
16734	22103	3	applied	\N	\N	\N	\N	130151	130151	130151
16736	22104	0	applied	\N	\N	\N	\N	130156	130156	297753
16736	22105	1	applied	\N	\N	\N	\N	130157	130157	297754
16736	22106	2	applied	\N	\N	\N	\N	130158	130158	297755
16736	22107	3	applied	\N	\N	\N	\N	130159	130159	297756
16736	22108	4	applied	\N	\N	\N	\N	130160	130160	297757
16741	22109	0	applied	\N	\N	\N	\N	130184	130184	297780
16741	22110	1	applied	\N	\N	\N	\N	130185	130185	297781
16741	22111	2	applied	\N	\N	\N	\N	130186	130186	297782
16741	22112	3	applied	\N	\N	\N	\N	130187	130187	130187
16741	22113	4	applied	\N	\N	\N	\N	130188	130188	297783
16741	22115	6	applied	\N	\N	\N	\N	130190	130190	297785
16741	22116	7	applied	\N	\N	\N	\N	130191	130191	297786
16744	22105	0	applied	\N	\N	\N	\N	130325	130325	297917
16746	22117	0	applied	\N	\N	\N	\N	130336	130336	297928
16746	22118	1	applied	\N	\N	\N	\N	130337	130337	297929
16746	22119	2	applied	\N	\N	\N	\N	130338	130338	297930
16746	22120	3	applied	\N	\N	\N	\N	130339	130339	297931
16746	22121	4	applied	\N	\N	\N	\N	130340	130340	297932
16746	22122	5	applied	\N	\N	\N	\N	130341	130341	297933
16746	22123	6	applied	\N	\N	\N	\N	130342	130342	297934
16746	22124	7	applied	\N	\N	\N	\N	130343	130343	297935
16746	22125	8	applied	\N	\N	\N	\N	130344	130344	297936
16746	22126	9	applied	\N	\N	\N	\N	130345	130345	297937
16750	22127	0	applied	\N	\N	\N	\N	130370	130370	297962
16750	22128	1	applied	\N	\N	\N	\N	130371	130371	297963
16750	22129	2	applied	\N	\N	\N	\N	130372	130372	297964
16752	22131	0	applied	\N	\N	\N	\N	130378	130378	297970
16752	22132	1	applied	\N	\N	\N	\N	130379	130379	297971
16752	22133	2	applied	\N	\N	\N	\N	130380	130380	297972
16756	21899	0	applied	\N	\N	\N	\N	130390	130390	297982
16756	21902	1	applied	\N	\N	\N	\N	130391	130391	297983
16756	21905	2	applied	\N	\N	\N	\N	130392	130392	297984
16756	21906	4	applied	\N	\N	\N	\N	130393	130393	297985
16756	21911	5	applied	\N	\N	\N	\N	130394	130394	297986
16756	21912	6	applied	\N	\N	\N	\N	130395	130395	297987
16756	21918	7	applied	\N	\N	\N	\N	130396	130396	297988
16756	21921	8	applied	\N	\N	\N	\N	130397	130397	297989
16756	21924	9	applied	\N	\N	\N	\N	130398	130398	297990
16756	21925	10	applied	\N	\N	\N	\N	130399	130399	297991
16756	21926	11	applied	\N	\N	\N	\N	130400	130400	297992
16756	21933	12	applied	\N	\N	\N	\N	130401	130401	297993
16756	21936	13	applied	\N	\N	\N	\N	130402	130402	297994
16709	21769	110	applied	\N	\N	\N	\N	129880	129880	297480
16723	22086	6	applied	\N	\N	\N	\N	130112	130112	297711
16726	22087	0	applied	\N	\N	\N	\N	130125	130125	297724
16726	22088	1	applied	\N	\N	\N	\N	130126	130126	297725
16726	22089	2	applied	\N	\N	\N	\N	130127	130127	297726
16726	22090	3	applied	\N	\N	\N	\N	130128	130128	297727
16726	22091	4	applied	\N	\N	\N	\N	130129	130129	297728
16739	22105	1	applied	\N	\N	\N	\N	130172	130172	297769
16739	22106	2	applied	\N	\N	\N	\N	130173	130173	297770
16739	22107	3	applied	\N	\N	\N	\N	130174	130174	297771
16739	22108	4	applied	\N	\N	\N	\N	130175	130175	297772
16740	22109	0	applied	\N	\N	\N	\N	130176	130176	297773
16740	22110	1	applied	\N	\N	\N	\N	130177	130177	297774
16740	22111	2	applied	\N	\N	\N	\N	130178	130178	297775
16740	22112	3	applied	\N	\N	\N	\N	130179	130179	130179
16740	22113	4	applied	\N	\N	\N	\N	130180	130180	297776
16740	22114	5	applied	\N	\N	\N	\N	130181	130181	297777
16740	22115	6	applied	\N	\N	\N	\N	130182	130182	297778
16740	22116	7	applied	\N	\N	\N	\N	130183	130183	297779
16743	21243	1	applied	\N	\N	\N	\N	130201	130201	297794
16743	21247	2	applied	\N	\N	\N	\N	130202	130202	297795
16743	21248	3	applied	\N	\N	\N	\N	130203	130203	297796
16743	21254	4	applied	\N	\N	\N	\N	130204	130204	297797
16743	21150	5	applied	\N	\N	1000000000	\N	130205	130205	297798
16743	21166	6	applied	\N	\N	\N	\N	130206	130206	297799
16743	21784	7	applied	\N	\N	\N	\N	130207	130207	297800
16743	21854	8	applied	\N	\N	\N	\N	130208	130208	297801
16743	21864	9	applied	\N	\N	\N	\N	130209	130209	297802
16743	21865	10	applied	\N	\N	\N	\N	130210	130210	297803
16743	21866	11	applied	\N	\N	\N	\N	130211	130211	297804
16743	21789	12	applied	\N	\N	\N	\N	130212	130212	297805
16743	21790	13	applied	\N	\N	\N	\N	130213	130213	297806
16743	21797	14	applied	\N	\N	\N	\N	130214	130214	297807
16743	20857	15	applied	\N	\N	1000000000	\N	130215	130215	297808
16743	20858	16	applied	\N	\N	1000000000	\N	130216	130216	297809
16743	20768	17	applied	\N	\N	\N	\N	130217	130217	297810
16743	20771	18	applied	\N	\N	\N	\N	130218	130218	297811
16743	20774	19	applied	\N	\N	\N	\N	130219	130219	297812
16743	21521	20	applied	\N	\N	1000000000	\N	130220	130220	297813
16743	22105	21	applied	\N	\N	\N	\N	130221	130221	297814
16743	22109	22	applied	\N	\N	\N	\N	130222	130222	297815
16743	20778	23	applied	\N	\N	\N	\N	130223	130223	297816
16743	20781	24	applied	\N	\N	\N	\N	130224	130224	297817
16743	20788	26	applied	\N	\N	\N	\N	130226	130226	297819
16743	20790	27	applied	\N	\N	\N	\N	130227	130227	297820
16743	20793	28	applied	\N	\N	\N	\N	130228	130228	297821
16743	20796	29	applied	\N	\N	\N	\N	130229	130229	297822
16743	21409	30	applied	\N	\N	\N	\N	130230	130230	297823
16743	20859	31	applied	\N	\N	1000000000	\N	130231	130231	297824
16743	20860	32	applied	\N	\N	1000000000	\N	130232	130232	297825
16743	21337	33	applied	\N	\N	1000000000	\N	130233	130233	297826
16743	21462	34	applied	\N	\N	1000000000	\N	130234	130234	297827
16743	21578	35	applied	\N	\N	1000000000	\N	130235	130235	297828
16743	21599	36	applied	\N	\N	1000000000	\N	130236	130236	297829
16743	20802	38	applied	\N	\N	\N	\N	130238	130238	297830
16743	21719	37	failed	Receiver_not_present	\N	\N	\N	130237	130237	\N
16743	20803	39	applied	\N	\N	\N	\N	130239	130239	297831
16743	20804	40	applied	\N	\N	\N	\N	130240	130240	297832
16743	20813	41	applied	\N	\N	\N	\N	130241	130241	297833
16743	20818	43	applied	\N	\N	\N	\N	130243	130243	297835
16743	20824	44	applied	\N	\N	\N	\N	130244	130244	297836
16743	20825	45	applied	\N	\N	\N	\N	130245	130245	297837
16743	20831	46	applied	\N	\N	\N	\N	130246	130246	297838
16743	20835	47	applied	\N	\N	\N	\N	130247	130247	297839
16743	20836	48	applied	\N	\N	\N	\N	130248	130248	297840
16743	20841	49	applied	\N	\N	\N	\N	130249	130249	297841
16743	20845	50	applied	\N	\N	\N	\N	130250	130250	297842
16743	20848	51	applied	\N	\N	\N	\N	130251	130251	297843
16743	20852	52	applied	\N	\N	\N	\N	130252	130252	297844
16743	20856	53	applied	\N	\N	\N	\N	130253	130253	297845
16743	20867	54	applied	\N	\N	\N	\N	130254	130254	297846
16743	20870	55	applied	\N	\N	\N	\N	130255	130255	297847
16743	20871	56	applied	\N	\N	\N	\N	130256	130256	297848
16743	20877	57	applied	\N	\N	\N	\N	130257	130257	297849
16743	20878	58	applied	\N	\N	\N	\N	130258	130258	297850
16743	20884	60	applied	\N	\N	\N	\N	130260	130260	297852
16743	20889	61	applied	\N	\N	\N	\N	130261	130261	297853
16743	20892	62	applied	\N	\N	\N	\N	130262	130262	297854
16743	20896	63	applied	\N	\N	\N	\N	130263	130263	297855
16743	20899	64	applied	\N	\N	\N	\N	130264	130264	297856
16743	20901	65	applied	\N	\N	\N	\N	130265	130265	297857
16743	20904	66	applied	\N	\N	\N	\N	130266	130266	297858
16743	20908	67	applied	\N	\N	\N	\N	130267	130267	297859
16743	20912	69	applied	\N	\N	\N	\N	130268	130268	297860
16743	20915	70	applied	\N	\N	\N	\N	130269	130269	297861
16743	20916	71	applied	\N	\N	\N	\N	130270	130270	297862
16743	20922	72	applied	\N	\N	\N	\N	130271	130271	297863
16743	20925	73	applied	\N	\N	\N	\N	130272	130272	297864
16743	20929	74	applied	\N	\N	\N	\N	130273	130273	297865
16743	20931	75	applied	\N	\N	\N	\N	130274	130274	297866
16743	20935	76	applied	\N	\N	\N	\N	130275	130275	297867
16743	20943	78	applied	\N	\N	\N	\N	130277	130277	297869
16743	20946	79	applied	\N	\N	\N	\N	130278	130278	297870
16743	20949	80	applied	\N	\N	\N	\N	130279	130279	297871
16743	20953	81	applied	\N	\N	\N	\N	130280	130280	297872
16743	20955	82	applied	\N	\N	\N	\N	130281	130281	297873
16743	20958	83	applied	\N	\N	\N	\N	130282	130282	297874
16743	20962	84	applied	\N	\N	\N	\N	130283	130283	297875
16743	20965	85	applied	\N	\N	\N	\N	130284	130284	297876
16743	20968	86	applied	\N	\N	\N	\N	130285	130285	297877
16743	20971	87	applied	\N	\N	\N	\N	130286	130286	297878
16743	20972	88	applied	\N	\N	\N	\N	130287	130287	297879
16743	20978	89	applied	\N	\N	\N	\N	130288	130288	297880
16743	20979	90	applied	\N	\N	\N	\N	130289	130289	297881
16743	20985	91	applied	\N	\N	\N	\N	130290	130290	297882
16743	20988	92	applied	\N	\N	\N	\N	130291	130291	297883
16743	20989	93	applied	\N	\N	\N	\N	130292	130292	297884
16743	20998	95	applied	\N	\N	\N	\N	130294	130294	297886
16743	20999	96	applied	\N	\N	\N	\N	130295	130295	297887
16723	22085	4	applied	\N	\N	\N	\N	130110	130110	297709
16723	22081	5	applied	\N	\N	\N	\N	130111	130111	297710
16743	21019	101	applied	\N	\N	\N	\N	130300	130300	297892
16743	21022	102	applied	\N	\N	\N	\N	130301	130301	297893
16743	21025	103	applied	\N	\N	\N	\N	130302	130302	297894
16743	21029	104	applied	\N	\N	\N	\N	130303	130303	297895
16743	21032	105	applied	\N	\N	\N	\N	130304	130304	297896
16743	21035	106	applied	\N	\N	\N	\N	130305	130305	297897
16743	21037	107	applied	\N	\N	\N	\N	130306	130306	297898
16743	21041	108	applied	\N	\N	\N	\N	130307	130307	297899
16743	21042	109	applied	\N	\N	\N	\N	130308	130308	297900
16743	21047	110	applied	\N	\N	\N	\N	130309	130309	297901
16743	21051	111	applied	\N	\N	\N	\N	130310	130310	297902
16743	21054	112	applied	\N	\N	\N	\N	130311	130311	297903
16743	21057	113	applied	\N	\N	\N	\N	130312	130312	297904
16743	21060	114	applied	\N	\N	\N	\N	130313	130313	297905
16743	21066	116	applied	\N	\N	\N	\N	130315	130315	297907
16743	21069	117	applied	\N	\N	\N	\N	130316	130316	297908
16743	21070	118	applied	\N	\N	\N	\N	130317	130317	297909
16743	21076	119	applied	\N	\N	\N	\N	130318	130318	297910
16743	21079	120	applied	\N	\N	\N	\N	130319	130319	297911
16743	21083	121	applied	\N	\N	\N	\N	130320	130320	297912
16743	21738	122	applied	\N	\N	1000000000	\N	130321	130321	297913
16743	21746	123	applied	\N	\N	\N	\N	130322	130322	297914
16743	21084	124	applied	\N	\N	\N	\N	130323	130323	297915
16743	21090	125	applied	\N	\N	\N	\N	130324	130324	297916
16745	22117	0	applied	\N	\N	\N	\N	130326	130326	297918
16745	22118	1	applied	\N	\N	\N	\N	130327	130327	297919
16745	22119	2	applied	\N	\N	\N	\N	130328	130328	297920
16745	22120	3	applied	\N	\N	\N	\N	130329	130329	297921
16745	22121	4	applied	\N	\N	\N	\N	130330	130330	297922
16745	22122	5	applied	\N	\N	\N	\N	130331	130331	297923
16745	22124	7	applied	\N	\N	\N	\N	130333	130333	297925
16745	22125	8	applied	\N	\N	\N	\N	130334	130334	297926
16745	22126	9	applied	\N	\N	\N	\N	130335	130335	297927
16749	22127	0	applied	\N	\N	\N	\N	130366	130366	297958
16749	22128	1	applied	\N	\N	\N	\N	130367	130367	297959
16749	22129	2	applied	\N	\N	\N	\N	130368	130368	297960
16749	22130	3	applied	\N	\N	\N	\N	130369	130369	297961
16754	22134	0	applied	\N	\N	\N	\N	130384	130384	297976
16754	22135	1	applied	\N	\N	\N	\N	130385	130385	297977
16754	22136	2	applied	\N	\N	\N	\N	130386	130386	297978
16756	21940	14	applied	\N	\N	\N	\N	130403	130403	297995
16756	21943	15	applied	\N	\N	\N	\N	130404	130404	297996
16756	21946	16	applied	\N	\N	\N	\N	130405	130405	297997
16756	21947	17	applied	\N	\N	\N	\N	130406	130406	297998
16756	21952	18	applied	\N	\N	\N	\N	130407	130407	297999
16756	21953	19	applied	\N	\N	\N	\N	130408	130408	298000
16756	21962	21	applied	\N	\N	\N	\N	130410	130410	298002
16756	21965	22	applied	\N	\N	\N	\N	130411	130411	298003
16756	21966	23	applied	\N	\N	\N	\N	130412	130412	298004
16756	22105	24	applied	\N	\N	\N	\N	130413	130413	298005
16756	22109	25	applied	\N	\N	\N	\N	130414	130414	298006
16756	22128	26	applied	\N	\N	\N	\N	130415	130415	298007
16756	21967	27	applied	\N	\N	\N	\N	130416	130416	298008
16756	21975	28	applied	\N	\N	\N	\N	130417	130417	298009
16756	21976	29	applied	\N	\N	\N	\N	130418	130418	298010
16756	21982	30	applied	\N	\N	\N	\N	130419	130419	298011
16756	21984	31	applied	\N	\N	\N	\N	130420	130420	298012
16756	21985	32	applied	\N	\N	\N	\N	130421	130421	298013
16756	21986	33	applied	\N	\N	\N	\N	130422	130422	298014
16756	21987	34	applied	\N	\N	\N	\N	130423	130423	298015
16756	21988	35	applied	\N	\N	\N	\N	130424	130424	298016
16756	22000	36	applied	\N	\N	\N	\N	130425	130425	298017
16756	22007	38	applied	\N	\N	\N	\N	130427	130427	298019
16756	22008	39	applied	\N	\N	\N	\N	130428	130428	298020
16756	22014	40	applied	\N	\N	\N	\N	130429	130429	298021
16756	22017	41	applied	\N	\N	\N	\N	130430	130430	298022
16756	22019	42	applied	\N	\N	\N	\N	130431	130431	298023
16756	22020	43	applied	\N	\N	\N	\N	130432	130432	298024
16756	22028	44	applied	\N	\N	\N	\N	130433	130433	298025
16756	22031	45	applied	\N	\N	\N	\N	130434	130434	298026
16756	22035	46	applied	\N	\N	\N	\N	130435	130435	298027
16756	22038	47	applied	\N	\N	\N	\N	130436	130436	298028
16756	22040	48	applied	\N	\N	\N	\N	130437	130437	298029
16756	22044	49	applied	\N	\N	\N	\N	130438	130438	298030
16756	22047	50	applied	\N	\N	\N	\N	130439	130439	298031
16756	22048	51	applied	\N	\N	\N	\N	130440	130440	298032
16758	22140	0	applied	\N	\N	\N	\N	130518	130518	298108
16758	22141	1	applied	\N	\N	\N	\N	130519	130519	298109
16763	22143	0	applied	\N	\N	\N	\N	130533	130533	298123
16763	22144	1	applied	\N	\N	\N	\N	130534	130534	298124
16763	22145	2	applied	\N	\N	\N	\N	130535	130535	298125
16764	22146	0	applied	\N	\N	\N	\N	130536	130536	298126
16764	22147	1	applied	\N	\N	\N	\N	130537	130537	298127
16764	22148	2	applied	\N	\N	\N	\N	130538	130538	298128
16767	22137	0	applied	\N	\N	\N	\N	130543	130543	298133
16767	22143	1	applied	\N	\N	\N	\N	130544	130544	298134
16767	22146	2	applied	\N	\N	\N	\N	130545	130545	298135
16767	22149	4	applied	\N	\N	\N	\N	130546	130546	298136
16767	21611	5	applied	\N	\N	\N	\N	130547	130547	298137
16767	21620	6	applied	\N	\N	\N	\N	130548	130548	298138
16767	21622	7	applied	\N	\N	\N	\N	130549	130549	298139
16767	21623	8	applied	\N	\N	\N	\N	130550	130550	298140
16767	21628	9	applied	\N	\N	\N	\N	130551	130551	298141
16767	21643	10	applied	\N	\N	\N	\N	130552	130552	298142
16767	21667	12	applied	\N	\N	\N	\N	130554	130554	298144
16767	21677	13	applied	\N	\N	\N	\N	130555	130555	298145
16767	21688	14	applied	\N	\N	\N	\N	130556	130556	298146
16767	21702	15	applied	\N	\N	\N	\N	130557	130557	298147
16767	21629	16	applied	\N	\N	\N	\N	130558	130558	298148
16767	21633	17	applied	\N	\N	\N	\N	130559	130559	298149
16767	21635	18	applied	\N	\N	\N	\N	130560	130560	298150
16767	21639	19	applied	\N	\N	\N	\N	130561	130561	298151
16767	21641	20	applied	\N	\N	\N	\N	130562	130562	298152
16767	21645	21	applied	\N	\N	\N	\N	130563	130563	298153
16767	21650	22	applied	\N	\N	\N	\N	130564	130564	298154
16767	21655	23	applied	\N	\N	\N	\N	130565	130565	298155
16767	21656	24	applied	\N	\N	\N	\N	130566	130566	298156
16767	21660	25	applied	\N	\N	\N	\N	130567	130567	298157
16767	21666	26	applied	\N	\N	\N	\N	130568	130568	298158
16767	21668	27	applied	\N	\N	\N	\N	130569	130569	298159
16743	21012	100	applied	\N	\N	\N	\N	130299	130299	297891
16756	22067	56	applied	\N	\N	\N	\N	130445	130445	298037
16756	22070	57	applied	\N	\N	\N	\N	130446	130446	298038
16756	22073	58	applied	\N	\N	\N	\N	130447	130447	298039
16756	22074	59	applied	\N	\N	\N	\N	130448	130448	298040
16756	22080	60	applied	\N	\N	\N	\N	130449	130449	298041
16756	22083	61	applied	\N	\N	\N	\N	130450	130450	298042
16756	22087	62	applied	\N	\N	\N	\N	130451	130451	298043
16756	22088	63	applied	\N	\N	\N	\N	130452	130452	298044
16756	22092	64	applied	\N	\N	\N	\N	130453	130453	298045
16756	22095	65	applied	\N	\N	\N	\N	130454	130454	298046
16756	22097	66	applied	\N	\N	\N	\N	130455	130455	298047
16756	22100	67	applied	\N	\N	\N	\N	130456	130456	298048
16756	22104	68	applied	\N	\N	\N	\N	130457	130457	298049
16756	22110	69	applied	\N	\N	\N	\N	130458	130458	298050
16756	22111	70	applied	\N	\N	\N	\N	130459	130459	298051
16756	22117	71	applied	\N	\N	\N	\N	130460	130460	298052
16756	22119	73	applied	\N	\N	\N	\N	130462	130462	298054
16756	22127	74	applied	\N	\N	\N	\N	130463	130463	298055
16756	22131	75	applied	\N	\N	\N	\N	130464	130464	298056
16756	22134	76	applied	\N	\N	\N	\N	130465	130465	298057
16756	21856	77	applied	\N	\N	\N	\N	130466	130466	298058
16756	21525	78	applied	\N	\N	\N	\N	130467	130467	298059
16756	21526	79	applied	\N	\N	\N	\N	130468	130468	298060
16756	21527	80	applied	\N	\N	\N	\N	130469	130469	298061
16756	21542	81	applied	\N	\N	\N	\N	130470	130470	298062
16756	21557	82	applied	\N	\N	\N	\N	130471	130471	298063
16756	21563	83	applied	\N	\N	\N	\N	130472	130472	298064
16756	21576	84	applied	\N	\N	\N	\N	130473	130473	298065
16756	21592	85	applied	\N	\N	\N	\N	130474	130474	298066
16756	21528	86	applied	\N	\N	\N	\N	130475	130475	298067
16756	21529	87	applied	\N	\N	\N	\N	130476	130476	298068
16756	21530	88	applied	\N	\N	\N	\N	130477	130477	298069
16756	21606	90	applied	\N	\N	\N	\N	130479	130479	298071
16756	21609	91	applied	\N	\N	\N	\N	130480	130480	298072
16756	21619	92	applied	\N	\N	\N	\N	130481	130481	298073
16756	21631	93	applied	\N	\N	\N	\N	130482	130482	298074
16756	22103	94	applied	\N	\N	\N	\N	130483	130483	130483
16756	22112	95	applied	\N	\N	\N	\N	130484	130484	130484
16756	21531	96	applied	\N	\N	\N	\N	130485	130485	298075
16756	21535	97	applied	\N	\N	\N	\N	130486	130486	298076
16756	21539	98	applied	\N	\N	\N	\N	130487	130487	298077
16756	21541	99	applied	\N	\N	\N	\N	130488	130488	298078
16756	21546	100	applied	\N	\N	\N	\N	130489	130489	298079
16756	21551	101	applied	\N	\N	\N	\N	130490	130490	298080
16756	21532	102	applied	\N	\N	\N	\N	130491	130491	298081
16756	21533	103	applied	\N	\N	\N	\N	130492	130492	298082
16756	21536	104	applied	\N	\N	\N	\N	130493	130493	298083
16756	21538	105	applied	\N	\N	\N	\N	130494	130494	298084
16756	21547	107	applied	\N	\N	\N	\N	130496	130496	298086
16756	21550	108	applied	\N	\N	\N	\N	130497	130497	298087
16756	21552	109	applied	\N	\N	\N	\N	130498	130498	298088
16756	21555	110	applied	\N	\N	\N	\N	130499	130499	298089
16756	21562	111	applied	\N	\N	\N	\N	130500	130500	298090
16756	21564	112	applied	\N	\N	\N	\N	130501	130501	298091
16756	21565	113	applied	\N	\N	\N	\N	130502	130502	298092
16756	21566	114	applied	\N	\N	\N	\N	130503	130503	298093
16756	21573	115	applied	\N	\N	\N	\N	130504	130504	298094
16756	21577	116	applied	\N	\N	\N	\N	130505	130505	298095
16756	21580	117	applied	\N	\N	\N	\N	130506	130506	298096
16756	21584	118	applied	\N	\N	\N	\N	130507	130507	298097
16756	21588	119	applied	\N	\N	\N	\N	130508	130508	298098
16756	21590	120	applied	\N	\N	\N	\N	130509	130509	298099
16756	21595	121	applied	\N	\N	\N	\N	130510	130510	298100
16756	21603	122	applied	\N	\N	\N	\N	130511	130511	298101
16756	21605	124	applied	\N	\N	\N	\N	130513	130513	298103
16756	21610	125	applied	\N	\N	\N	\N	130514	130514	298104
16759	22140	0	applied	\N	\N	\N	\N	130521	130521	298111
16759	22141	1	applied	\N	\N	\N	\N	130522	130522	298112
16759	22142	2	applied	\N	\N	\N	\N	130523	130523	298113
16765	22149	0	applied	\N	\N	\N	\N	130539	130539	298129
16765	22150	1	applied	\N	\N	\N	\N	130540	130540	298130
16767	21670	28	applied	\N	\N	\N	\N	130570	130570	298160
16767	21678	29	applied	\N	\N	\N	\N	130571	130571	298161
16767	21679	30	applied	\N	\N	\N	\N	130572	130572	298162
16767	21680	31	applied	\N	\N	\N	\N	130573	130573	298163
16767	21681	32	applied	\N	\N	\N	\N	130574	130574	298164
16767	21687	33	applied	\N	\N	\N	\N	130575	130575	298165
16767	21693	34	applied	\N	\N	\N	\N	130576	130576	298166
16767	21694	35	applied	\N	\N	\N	\N	130577	130577	298167
16767	21700	36	applied	\N	\N	\N	\N	130578	130578	298168
16767	21707	38	applied	\N	\N	\N	\N	130580	130580	298170
16767	21708	39	applied	\N	\N	\N	\N	130581	130581	298171
16767	21713	40	applied	\N	\N	\N	\N	130582	130582	298172
16767	21717	41	applied	\N	\N	\N	\N	130583	130583	298173
16767	21721	42	applied	\N	\N	\N	\N	130584	130584	298174
16767	21723	43	applied	\N	\N	\N	\N	130585	130585	298175
16767	21725	44	applied	\N	\N	\N	\N	130586	130586	298176
16767	21728	45	applied	\N	\N	\N	\N	130587	130587	298177
16767	21733	46	applied	\N	\N	\N	\N	130588	130588	298178
16767	21736	47	applied	\N	\N	\N	\N	130589	130589	298179
16767	21740	48	applied	\N	\N	\N	\N	130590	130590	298180
16767	21744	49	applied	\N	\N	\N	\N	130591	130591	298181
16767	21748	50	applied	\N	\N	\N	\N	130592	130592	298182
16767	21751	51	applied	\N	\N	\N	\N	130593	130593	298183
16767	21754	52	applied	\N	\N	\N	\N	130594	130594	298184
16767	21760	53	applied	\N	\N	\N	\N	130595	130595	298185
16767	21763	55	applied	\N	\N	\N	\N	130597	130597	298187
16767	21768	56	applied	\N	\N	\N	\N	130598	130598	298188
16767	21769	57	applied	\N	\N	\N	\N	130599	130599	298189
16767	21775	58	applied	\N	\N	\N	\N	130600	130600	298190
16767	21780	59	applied	\N	\N	\N	\N	130601	130601	298191
16767	21783	60	applied	\N	\N	\N	\N	130602	130602	298192
16767	21787	61	applied	\N	\N	\N	\N	130603	130603	298193
16767	21792	62	applied	\N	\N	\N	\N	130604	130604	298194
16767	21796	63	applied	\N	\N	\N	\N	130605	130605	298195
16769	22155	0	applied	\N	\N	\N	\N	130610	130610	298200
16769	22156	1	applied	\N	\N	\N	\N	130611	130611	298201
16770	22158	0	applied	\N	\N	\N	\N	130613	130613	298203
16770	22159	1	applied	\N	\N	\N	\N	130614	130614	298204
16770	22160	2	applied	\N	\N	\N	\N	130615	130615	298205
16756	22057	53	applied	\N	\N	\N	\N	130442	130442	298034
16756	22058	54	applied	\N	\N	\N	\N	130443	130443	298035
16770	22164	6	applied	\N	\N	\N	\N	130619	130619	298209
16773	22165	0	applied	\N	\N	\N	\N	130753	130753	298343
16773	22166	1	applied	\N	\N	\N	\N	130754	130754	298344
16773	22167	2	applied	\N	\N	\N	\N	130755	130755	298345
16773	22168	3	applied	\N	\N	\N	\N	130756	130756	298346
16773	22169	4	applied	\N	\N	\N	\N	130757	130757	298347
16773	22170	5	applied	\N	\N	\N	\N	130758	130758	298348
16773	22171	6	applied	\N	\N	\N	\N	130759	130759	298349
16773	22172	7	applied	\N	\N	\N	\N	130760	130760	298350
16773	22173	8	applied	\N	\N	\N	\N	130761	130761	298351
16773	22174	9	applied	\N	\N	\N	\N	130762	130762	298352
16773	22175	10	applied	\N	\N	\N	\N	130763	130763	298353
16773	22176	11	applied	\N	\N	\N	\N	130764	130764	298354
16773	22177	12	applied	\N	\N	\N	\N	130765	130765	298355
16774	22166	1	applied	\N	\N	\N	\N	130767	130767	298357
16774	22167	2	applied	\N	\N	\N	\N	130768	130768	298358
16774	22168	3	applied	\N	\N	\N	\N	130769	130769	298359
16774	22169	4	applied	\N	\N	\N	\N	130770	130770	298360
16774	22170	5	applied	\N	\N	\N	\N	130771	130771	298361
16774	22171	6	applied	\N	\N	\N	\N	130772	130772	298362
16774	22172	7	applied	\N	\N	\N	\N	130773	130773	298363
16774	22173	8	applied	\N	\N	\N	\N	130774	130774	298364
16774	22174	9	applied	\N	\N	\N	\N	130775	130775	298365
16774	22175	10	applied	\N	\N	\N	\N	130776	130776	298366
16774	22176	11	applied	\N	\N	\N	\N	130777	130777	298367
16774	22177	12	applied	\N	\N	\N	\N	130778	130778	298368
16775	22178	0	applied	\N	\N	\N	\N	130779	130779	298369
16775	22179	1	applied	\N	\N	\N	\N	130780	130780	298370
16775	22180	2	applied	\N	\N	\N	\N	130781	130781	298371
16776	22178	0	applied	\N	\N	\N	\N	130782	130782	298372
16776	22180	2	applied	\N	\N	\N	\N	130784	130784	298374
16778	22188	0	applied	\N	\N	\N	\N	130792	130792	298382
16778	22189	1	applied	\N	\N	\N	\N	130793	130793	298383
16778	22190	2	applied	\N	\N	\N	\N	130794	130794	298384
16779	22188	0	applied	\N	\N	\N	\N	130795	130795	298385
16779	22189	1	applied	\N	\N	\N	\N	130796	130796	298386
16779	22190	2	applied	\N	\N	\N	\N	130797	130797	298387
16780	22191	0	applied	\N	\N	\N	\N	130798	130798	298388
16780	22192	1	applied	\N	\N	\N	\N	130799	130799	298389
16780	22193	2	applied	\N	\N	\N	\N	130800	130800	298390
16781	22194	0	applied	\N	\N	\N	\N	130801	130801	298391
16781	22195	1	applied	\N	\N	\N	\N	130802	130802	298392
16781	22196	2	applied	\N	\N	\N	\N	130803	130803	298393
16781	22197	3	applied	\N	\N	\N	\N	130804	130804	298394
16781	22198	4	applied	\N	\N	\N	\N	130805	130805	298395
16781	22199	5	applied	\N	\N	\N	\N	130806	130806	298396
16787	22201	0	applied	\N	\N	\N	\N	130907	130907	298492
16787	22202	1	applied	\N	\N	\N	\N	130908	130908	298493
16787	22203	2	applied	\N	\N	\N	\N	130909	130909	298494
16789	22201	0	applied	\N	\N	\N	\N	130913	130913	298498
16789	22202	1	applied	\N	\N	\N	\N	130914	130914	298499
16789	22203	2	applied	\N	\N	\N	\N	130915	130915	298500
16791	22207	0	applied	\N	\N	\N	\N	130919	130919	298504
16791	22208	1	applied	\N	\N	\N	\N	130920	130920	298505
16791	22209	2	applied	\N	\N	\N	\N	130921	130921	298506
16792	22207	0	applied	\N	\N	\N	\N	130922	130922	298507
16792	22208	1	applied	\N	\N	\N	\N	130923	130923	298508
16792	22209	2	applied	\N	\N	\N	\N	130924	130924	298509
16793	22210	0	applied	\N	\N	\N	\N	130925	130925	298510
16793	22211	1	applied	\N	\N	\N	\N	130926	130926	298511
16793	22212	2	applied	\N	\N	\N	\N	130927	130927	298512
16794	22210	0	applied	\N	\N	\N	\N	130928	130928	298513
16796	22217	0	applied	\N	\N	\N	\N	130935	130935	298520
16796	22218	1	applied	\N	\N	\N	\N	130936	130936	298521
16796	22219	2	applied	\N	\N	\N	\N	130937	130937	298522
16796	22220	3	applied	\N	\N	\N	\N	130938	130938	298523
16796	22221	4	applied	\N	\N	\N	\N	130939	130939	298524
16796	22222	5	applied	\N	\N	\N	\N	130940	130940	298525
16796	22223	6	applied	\N	\N	\N	\N	130941	130941	298526
16796	22224	7	applied	\N	\N	\N	\N	130942	130942	298527
16796	22225	8	applied	\N	\N	\N	\N	130943	130943	298528
16796	22226	9	applied	\N	\N	\N	\N	130944	130944	298529
16796	22227	10	applied	\N	\N	\N	\N	130945	130945	298530
16801	22231	0	applied	\N	\N	\N	\N	130975	130975	298560
16801	22232	1	applied	\N	\N	\N	\N	130976	130976	298561
16801	22233	2	applied	\N	\N	\N	\N	130977	130977	298562
16801	22234	3	applied	\N	\N	\N	\N	130978	130978	298563
16803	22235	0	applied	\N	\N	\N	\N	130982	130982	298567
16803	22237	2	applied	\N	\N	\N	\N	130984	130984	298569
16810	22213	0	applied	\N	\N	1000000000	\N	130998	130998	298583
16810	22105	1	applied	\N	\N	\N	\N	130999	130999	298584
16810	22109	2	applied	\N	\N	\N	\N	131000	131000	298585
16810	22128	3	applied	\N	\N	\N	\N	131001	131001	298586
16810	22220	4	applied	\N	\N	\N	\N	131002	131002	298587
16810	22221	5	applied	\N	\N	\N	\N	131003	131003	298588
16810	22103	6	applied	\N	\N	\N	\N	131004	131004	131004
16810	22112	7	applied	\N	\N	\N	\N	131005	131005	131005
16812	22246	0	applied	\N	\N	\N	\N	131006	131006	298589
16812	22247	1	applied	\N	\N	\N	\N	131007	131007	298590
16812	22248	2	applied	\N	\N	\N	\N	131008	131008	298591
16812	22249	3	applied	\N	\N	\N	\N	131009	131009	298592
16812	22250	4	applied	\N	\N	\N	\N	131010	131010	298593
16812	22251	5	applied	\N	\N	\N	\N	131011	131011	298594
16812	22252	6	applied	\N	\N	\N	\N	131012	131012	298595
16812	22254	8	applied	\N	\N	\N	\N	131014	131014	298597
16812	22255	9	applied	\N	\N	\N	\N	131015	131015	298598
16812	22256	10	applied	\N	\N	\N	\N	131016	131016	298599
16815	22257	0	applied	\N	\N	\N	\N	131039	131039	298622
16815	22258	1	applied	\N	\N	\N	\N	131040	131040	298623
16817	22259	0	applied	\N	\N	\N	\N	131043	131043	298626
16817	22260	1	applied	\N	\N	\N	\N	131044	131044	298627
16820	22266	0	applied	\N	\N	\N	\N	131052	131052	298635
16820	22267	1	applied	\N	\N	\N	\N	131053	131053	298636
16822	22268	0	applied	\N	\N	\N	\N	131057	131057	298640
16822	22269	1	applied	\N	\N	\N	\N	131058	131058	298641
16822	22270	2	applied	\N	\N	\N	\N	131059	131059	298642
16825	22271	0	applied	\N	\N	\N	\N	131064	131064	298647
16825	22272	1	applied	\N	\N	\N	\N	131065	131065	298648
16829	22277	0	applied	\N	\N	\N	\N	131076	131076	298659
16829	22278	1	applied	\N	\N	\N	\N	131077	131077	298660
16770	22163	5	applied	\N	\N	\N	\N	130618	130618	298208
16772	21889	17	applied	\N	\N	\N	\N	130644	130644	298234
16772	21890	18	applied	\N	\N	\N	\N	130645	130645	298235
16772	21899	19	applied	\N	\N	\N	\N	130646	130646	298236
16772	21902	20	applied	\N	\N	\N	\N	130647	130647	298237
16772	21905	21	applied	\N	\N	\N	\N	130648	130648	298238
16772	21906	22	applied	\N	\N	\N	\N	130649	130649	298239
16772	21911	23	applied	\N	\N	\N	\N	130650	130650	298240
16772	21912	24	applied	\N	\N	\N	\N	130651	130651	298241
16772	21918	25	applied	\N	\N	\N	\N	130652	130652	298242
16772	21921	26	applied	\N	\N	\N	\N	130653	130653	298243
16772	21924	27	applied	\N	\N	\N	\N	130654	130654	298244
16772	21925	28	applied	\N	\N	\N	\N	130655	130655	298245
16772	21926	29	applied	\N	\N	\N	\N	130656	130656	298246
16772	21933	30	applied	\N	\N	\N	\N	130657	130657	298247
16772	21936	31	applied	\N	\N	\N	\N	130658	130658	298248
16772	21940	32	applied	\N	\N	\N	\N	130659	130659	298249
16772	21946	34	applied	\N	\N	\N	\N	130661	130661	298251
16772	21947	35	applied	\N	\N	\N	\N	130662	130662	298252
16772	21952	36	applied	\N	\N	\N	\N	130663	130663	298253
16772	21953	37	applied	\N	\N	\N	\N	130664	130664	298254
16772	21959	38	applied	\N	\N	\N	\N	130665	130665	298255
16772	21962	39	applied	\N	\N	\N	\N	130666	130666	298256
16772	21965	40	applied	\N	\N	\N	\N	130667	130667	298257
16772	21966	41	applied	\N	\N	\N	\N	130668	130668	298258
16772	21967	42	applied	\N	\N	\N	\N	130669	130669	298259
16772	21975	43	applied	\N	\N	\N	\N	130670	130670	298260
16772	21976	44	applied	\N	\N	\N	\N	130671	130671	298261
16772	21982	45	applied	\N	\N	\N	\N	130672	130672	298262
16772	21984	46	applied	\N	\N	\N	\N	130673	130673	298263
16772	21985	47	applied	\N	\N	\N	\N	130674	130674	298264
16772	21986	48	applied	\N	\N	\N	\N	130675	130675	298265
16772	21987	49	applied	\N	\N	\N	\N	130676	130676	298266
16794	22212	2	applied	\N	\N	\N	\N	130930	130930	298515
16808	22243	0	applied	\N	\N	\N	\N	130995	130995	298580
16808	22244	1	applied	\N	\N	\N	\N	130996	130996	298581
16808	22245	2	applied	\N	\N	\N	\N	130997	130997	298582
16813	22246	0	applied	\N	\N	\N	\N	131017	131017	298600
16813	22247	1	applied	\N	\N	\N	\N	131018	131018	298601
16813	22248	2	applied	\N	\N	\N	\N	131019	131019	298602
16813	22249	3	applied	\N	\N	\N	\N	131020	131020	298603
16813	22250	4	applied	\N	\N	\N	\N	131021	131021	298604
16813	22251	5	applied	\N	\N	\N	\N	131022	131022	298605
16813	22252	6	applied	\N	\N	\N	\N	131023	131023	298606
16813	22253	7	applied	\N	\N	\N	\N	131024	131024	298607
16813	22254	8	applied	\N	\N	\N	\N	131025	131025	298608
16813	22255	9	applied	\N	\N	\N	\N	131026	131026	298609
16813	22256	10	applied	\N	\N	\N	\N	131027	131027	298610
16818	22261	0	applied	\N	\N	\N	\N	131045	131045	298628
16818	22263	2	applied	\N	\N	\N	\N	131047	131047	298630
16818	22264	3	applied	\N	\N	\N	\N	131048	131048	298631
16818	22265	4	applied	\N	\N	\N	\N	131049	131049	298632
16827	22277	0	applied	\N	\N	\N	\N	131070	131070	298653
16827	22278	1	applied	\N	\N	\N	\N	131071	131071	298654
16827	22279	2	applied	\N	\N	\N	\N	131072	131072	298655
16839	22287	0	applied	\N	\N	\N	\N	131214	131214	298782
16839	22288	1	applied	\N	\N	\N	\N	131215	131215	298783
16840	22289	0	applied	\N	\N	\N	\N	131216	131216	298784
16840	22290	1	applied	\N	\N	\N	\N	131217	131217	298785
16840	22291	2	applied	\N	\N	\N	\N	131218	131218	298786
16850	22312	0	applied	\N	\N	\N	\N	131251	131251	298819
16850	22313	1	applied	\N	\N	\N	\N	131252	131252	298820
16850	22314	2	applied	\N	\N	\N	\N	131253	131253	298821
16854	22312	0	applied	\N	\N	\N	\N	131263	131263	298831
16854	22313	1	applied	\N	\N	\N	\N	131264	131264	298832
16857	22315	0	applied	\N	\N	\N	\N	131346	131346	298914
16857	22316	1	applied	\N	\N	\N	\N	131347	131347	298915
16857	22317	2	applied	\N	\N	\N	\N	131348	131348	298916
16857	22318	3	applied	\N	\N	\N	\N	131349	131349	298917
16857	22319	4	applied	\N	\N	\N	\N	131350	131350	298918
16857	22320	5	applied	\N	\N	\N	\N	131351	131351	298919
16857	22321	6	applied	\N	\N	\N	\N	131352	131352	298920
16863	22322	0	applied	\N	\N	\N	\N	131353	131353	298921
16863	22323	1	applied	\N	\N	\N	\N	131354	131354	298922
16863	22324	2	applied	\N	\N	\N	\N	131355	131355	298923
16869	22329	0	applied	\N	\N	\N	\N	131491	131491	299057
16869	22330	1	applied	\N	\N	\N	\N	131492	131492	299058
16869	22331	2	applied	\N	\N	\N	\N	131493	131493	299059
16869	22332	3	applied	\N	\N	\N	\N	131494	131494	299060
16869	22333	4	applied	\N	\N	\N	\N	131495	131495	299061
16869	22334	5	applied	\N	\N	\N	\N	131496	131496	299062
16869	22336	7	applied	\N	\N	\N	\N	131498	131498	299064
16869	22337	8	applied	\N	\N	\N	\N	131499	131499	299065
16869	22338	9	applied	\N	\N	\N	\N	131500	131500	299066
16869	22339	10	applied	\N	\N	\N	\N	131501	131501	299067
16869	22340	11	applied	\N	\N	\N	\N	131502	131502	299068
16869	22341	12	applied	\N	\N	\N	\N	131503	131503	299069
16873	22344	0	applied	\N	\N	\N	\N	131532	131532	299098
16873	22345	1	applied	\N	\N	\N	\N	131533	131533	299099
16873	22346	2	applied	\N	\N	\N	\N	131534	131534	299100
16873	22347	3	applied	\N	\N	\N	\N	131535	131535	299101
16879	22361	0	applied	\N	\N	\N	\N	131557	131557	299123
16879	22362	1	applied	\N	\N	\N	\N	131558	131558	299124
16879	22363	2	applied	\N	\N	\N	\N	131559	131559	299125
16879	22364	3	applied	\N	\N	\N	\N	131560	131560	299126
16879	22365	4	applied	\N	\N	\N	\N	131561	131561	299127
16879	22366	5	applied	\N	\N	\N	\N	131562	131562	299128
16879	22368	7	applied	\N	\N	\N	\N	131564	131564	299130
16879	22369	8	applied	\N	\N	\N	\N	131565	131565	299131
16879	22370	9	applied	\N	\N	\N	\N	131566	131566	299132
16879	22371	10	applied	\N	\N	\N	\N	131567	131567	299133
16882	22372	0	applied	\N	\N	\N	\N	131574	131574	299140
16882	22373	1	applied	\N	\N	\N	\N	131575	131575	299141
16882	22374	2	applied	\N	\N	\N	\N	131576	131576	299142
16886	22382	0	applied	\N	\N	\N	\N	131710	131710	299274
16886	22383	1	applied	\N	\N	\N	\N	131711	131711	299275
16886	22384	2	applied	\N	\N	\N	\N	131712	131712	299276
16888	22385	0	applied	\N	\N	\N	\N	131716	131716	299280
16888	22386	1	applied	\N	\N	\N	\N	131717	131717	299281
16888	22387	2	applied	\N	\N	\N	\N	131718	131718	299282
16891	22385	0	applied	\N	\N	\N	\N	131847	131847	299411
16772	22128	14	applied	\N	\N	\N	\N	130641	130641	298231
16772	21887	15	applied	\N	\N	\N	\N	130642	130642	298232
16772	22014	55	applied	\N	\N	\N	\N	130682	130682	298272
16772	22017	56	applied	\N	\N	\N	\N	130683	130683	298273
16772	22019	57	applied	\N	\N	\N	\N	130684	130684	298274
16772	22020	58	applied	\N	\N	\N	\N	130685	130685	298275
16772	22028	59	applied	\N	\N	\N	\N	130686	130686	298276
16772	22031	60	applied	\N	\N	\N	\N	130687	130687	298277
16772	22035	61	applied	\N	\N	\N	\N	130688	130688	298278
16772	22038	62	applied	\N	\N	\N	\N	130689	130689	298279
16772	22040	63	applied	\N	\N	\N	\N	130690	130690	298280
16772	22044	64	applied	\N	\N	\N	\N	130691	130691	298281
16772	22047	65	applied	\N	\N	\N	\N	130692	130692	298282
16772	22048	66	applied	\N	\N	\N	\N	130693	130693	298283
16772	22054	67	applied	\N	\N	\N	\N	130694	130694	298284
16772	22057	68	applied	\N	\N	\N	\N	130695	130695	298285
16772	22058	69	applied	\N	\N	\N	\N	130696	130696	298286
16772	22059	70	applied	\N	\N	\N	\N	130697	130697	298287
16772	22070	72	applied	\N	\N	\N	\N	130699	130699	298289
16772	22073	73	applied	\N	\N	\N	\N	130700	130700	298290
16772	22074	74	applied	\N	\N	\N	\N	130701	130701	298291
16772	22080	75	applied	\N	\N	\N	\N	130702	130702	298292
16772	22083	76	applied	\N	\N	\N	\N	130703	130703	298293
16772	22087	77	applied	\N	\N	\N	\N	130704	130704	298294
16772	22088	78	applied	\N	\N	\N	\N	130705	130705	298295
16772	22092	79	applied	\N	\N	\N	\N	130706	130706	298296
16772	22095	80	applied	\N	\N	\N	\N	130707	130707	298297
16772	22097	81	applied	\N	\N	\N	\N	130708	130708	298298
16772	22100	82	applied	\N	\N	\N	\N	130709	130709	298299
16772	22104	83	applied	\N	\N	\N	\N	130710	130710	298300
16772	22110	84	applied	\N	\N	\N	\N	130711	130711	298301
16772	22111	85	applied	\N	\N	\N	\N	130712	130712	298302
16772	22117	86	applied	\N	\N	\N	\N	130713	130713	298303
16772	22118	87	applied	\N	\N	\N	\N	130714	130714	298304
16772	22127	89	applied	\N	\N	\N	\N	130716	130716	298306
16772	22131	90	applied	\N	\N	\N	\N	130717	130717	298307
16772	22134	91	applied	\N	\N	\N	\N	130718	130718	298308
16772	22137	92	applied	\N	\N	\N	\N	130719	130719	298309
16772	22143	93	applied	\N	\N	\N	\N	130720	130720	298310
16772	22146	94	applied	\N	\N	\N	\N	130721	130721	298311
16772	22149	95	applied	\N	\N	\N	\N	130722	130722	298312
16772	22151	96	applied	\N	\N	\N	\N	130723	130723	298313
16772	22155	97	applied	\N	\N	\N	\N	130724	130724	298314
16772	22158	98	applied	\N	\N	\N	\N	130725	130725	298315
16772	22159	99	applied	\N	\N	\N	\N	130726	130726	298316
16772	21856	100	applied	\N	\N	\N	\N	130727	130727	298317
16772	21857	101	applied	\N	\N	\N	\N	130728	130728	298318
16772	21875	102	applied	\N	\N	\N	\N	130729	130729	298319
16772	21858	103	applied	\N	\N	\N	\N	130730	130730	298320
16772	21861	104	applied	\N	\N	\N	\N	130731	130731	298321
16772	21859	106	applied	\N	\N	\N	\N	130733	130733	298323
16772	21885	107	applied	\N	\N	\N	\N	130734	130734	298324
16772	21891	108	applied	\N	\N	\N	\N	130735	130735	298325
16772	21908	109	applied	\N	\N	\N	\N	130736	130736	298326
16772	21913	110	applied	\N	\N	\N	\N	130737	130737	298327
16772	21927	111	applied	\N	\N	\N	\N	130738	130738	298328
16772	21938	112	applied	\N	\N	\N	\N	130739	130739	298329
16772	21950	113	applied	\N	\N	\N	\N	130740	130740	298330
16772	21954	114	applied	\N	\N	\N	\N	130741	130741	298331
16772	21968	115	applied	\N	\N	\N	\N	130742	130742	298332
16772	21977	116	applied	\N	\N	\N	\N	130743	130743	298333
16772	21989	117	applied	\N	\N	\N	\N	130744	130744	298334
16772	21871	118	applied	\N	\N	\N	\N	130745	130745	298335
16772	21877	119	applied	\N	\N	\N	\N	130746	130746	298336
16772	21878	120	applied	\N	\N	\N	\N	130747	130747	298337
16772	21881	121	applied	\N	\N	\N	\N	130748	130748	298338
16772	21892	123	applied	\N	\N	\N	\N	130750	130750	298340
16772	21862	124	applied	\N	\N	\N	\N	130751	130751	298341
16772	21869	125	applied	\N	\N	\N	\N	130752	130752	298342
16782	22194	0	applied	\N	\N	\N	\N	130808	130808	298398
16782	22195	1	applied	\N	\N	\N	\N	130809	130809	298399
16782	22196	2	applied	\N	\N	\N	\N	130810	130810	298400
16782	22197	3	applied	\N	\N	\N	\N	130811	130811	298401
16782	22198	4	applied	\N	\N	\N	\N	130812	130812	298402
16782	22199	5	applied	\N	\N	\N	\N	130813	130813	298403
16782	22200	6	applied	\N	\N	\N	\N	130814	130814	298404
16784	22054	0	applied	\N	\N	\N	\N	130822	130822	298412
16784	22057	1	applied	\N	\N	\N	\N	130823	130823	298413
16784	22058	2	applied	\N	\N	\N	\N	130824	130824	298414
16784	22059	3	applied	\N	\N	\N	\N	130825	130825	298415
16784	22067	4	applied	\N	\N	\N	\N	130826	130826	298416
16784	22070	5	applied	\N	\N	\N	\N	130827	130827	298417
16784	22109	7	applied	\N	\N	\N	\N	130829	130829	298419
16784	22128	8	applied	\N	\N	\N	\N	130830	130830	298420
16784	22073	9	applied	\N	\N	\N	\N	130831	130831	298421
16784	22074	10	applied	\N	\N	\N	\N	130832	130832	298422
16784	22080	11	applied	\N	\N	\N	\N	130833	130833	298423
16784	22083	12	applied	\N	\N	\N	\N	130834	130834	298424
16784	22087	13	applied	\N	\N	\N	\N	130835	130835	298425
16784	22088	14	applied	\N	\N	\N	\N	130836	130836	298426
16784	22092	15	applied	\N	\N	\N	\N	130837	130837	298427
16784	22095	16	applied	\N	\N	\N	\N	130838	130838	298428
16784	22097	17	applied	\N	\N	\N	\N	130839	130839	298429
16784	22100	20	applied	\N	\N	\N	\N	130840	130840	298430
16784	22104	21	applied	\N	\N	\N	\N	130841	130841	298431
16784	22110	22	applied	\N	\N	\N	\N	130842	130842	298432
16784	22111	23	applied	\N	\N	\N	\N	130843	130843	298433
16784	22117	24	applied	\N	\N	\N	\N	130844	130844	298434
16784	22119	26	applied	\N	\N	\N	\N	130846	130846	298436
16784	22127	27	applied	\N	\N	\N	\N	130847	130847	298437
16784	22131	28	applied	\N	\N	\N	\N	130848	130848	298438
16784	22134	29	applied	\N	\N	\N	\N	130849	130849	298439
16784	22137	30	applied	\N	\N	\N	\N	130850	130850	298440
16784	22143	31	applied	\N	\N	\N	\N	130851	130851	298441
16784	22146	32	applied	\N	\N	\N	\N	130852	130852	298442
16784	22149	33	applied	\N	\N	\N	\N	130853	130853	298443
16784	22151	34	applied	\N	\N	\N	\N	130854	130854	298444
16784	22155	35	applied	\N	\N	\N	\N	130855	130855	298445
16784	22158	36	applied	\N	\N	\N	\N	130856	130856	298446
16784	22159	37	applied	\N	\N	\N	\N	130857	130857	298447
16784	22165	38	applied	\N	\N	\N	\N	130858	130858	298448
16784	22166	39	applied	\N	\N	\N	\N	130859	130859	298449
16772	22001	52	applied	\N	\N	\N	\N	130679	130679	298269
16772	22007	53	applied	\N	\N	\N	\N	130680	130680	298270
16784	22181	43	applied	\N	\N	\N	\N	130863	130863	298453
16784	22182	44	applied	\N	\N	\N	\N	130864	130864	298454
16784	22188	45	applied	\N	\N	\N	\N	130865	130865	298455
16784	22194	47	applied	\N	\N	\N	\N	130867	130867	298457
16784	22195	48	applied	\N	\N	\N	\N	130868	130868	298458
16784	22062	49	applied	\N	\N	\N	\N	130869	130869	298459
16784	21892	50	applied	\N	\N	\N	\N	130870	130870	298460
16784	22079	51	applied	\N	\N	\N	\N	130871	130871	298461
16784	22085	52	applied	\N	\N	\N	\N	130872	130872	298462
16784	22096	53	applied	\N	\N	\N	\N	130873	130873	298463
16784	22103	54	applied	\N	\N	\N	\N	130874	130874	130874
16784	22112	55	applied	\N	\N	\N	\N	130875	130875	130875
16784	21897	56	applied	\N	\N	\N	\N	130876	130876	298464
16784	21898	57	applied	\N	\N	\N	\N	130877	130877	298465
16784	22108	58	applied	\N	\N	\N	\N	130878	130878	298466
16784	22122	59	applied	\N	\N	\N	\N	130879	130879	298467
16784	22133	60	applied	\N	\N	\N	\N	130880	130880	298468
16784	22140	61	applied	\N	\N	\N	\N	130881	130881	298469
16784	22153	62	applied	\N	\N	\N	\N	130882	130882	298470
16784	22175	64	applied	\N	\N	\N	\N	130884	130884	298472
16784	22183	65	applied	\N	\N	\N	\N	130885	130885	298473
16785	22202	1	applied	\N	\N	\N	\N	130887	130887	298475
16785	22203	2	applied	\N	\N	\N	\N	130888	130888	298476
16786	21784	0	applied	\N	\N	\N	\N	130889	130889	298477
16786	21854	1	applied	\N	\N	\N	\N	130890	130890	298478
16786	21864	2	applied	\N	\N	\N	\N	130891	130891	298479
16786	21865	3	applied	\N	\N	\N	\N	130892	130892	298480
16786	21866	4	applied	\N	\N	\N	\N	130893	130893	298481
16786	21789	5	applied	\N	\N	\N	\N	130894	130894	298482
16786	21790	6	applied	\N	\N	\N	\N	130895	130895	298483
16786	21797	7	applied	\N	\N	\N	\N	130896	130896	298484
16786	22105	8	applied	\N	\N	\N	\N	130897	130897	298485
16786	22109	9	applied	\N	\N	\N	\N	130898	130898	298486
16786	22128	10	applied	\N	\N	\N	\N	130899	130899	298487
16786	21738	12	applied	\N	\N	1000000000	\N	130901	130901	298488
16786	21746	13	applied	\N	\N	\N	\N	130902	130902	298489
16786	21856	14	applied	\N	\N	\N	\N	130903	130903	298490
16786	21863	15	applied	\N	\N	\N	\N	130904	130904	298491
16786	22103	16	applied	\N	\N	\N	\N	130905	130905	130905
16786	22112	17	applied	\N	\N	\N	\N	130906	130906	130906
16788	22201	0	applied	\N	\N	\N	\N	130910	130910	298495
16788	22202	1	applied	\N	\N	\N	\N	130911	130911	298496
16788	22203	2	applied	\N	\N	\N	\N	130912	130912	298497
16790	22204	0	applied	\N	\N	\N	\N	130916	130916	298501
16790	22205	1	applied	\N	\N	\N	\N	130917	130917	298502
16790	22206	2	applied	\N	\N	\N	\N	130918	130918	298503
16795	22213	0	applied	\N	\N	1000000000	\N	130931	130931	298516
16795	22214	1	applied	\N	\N	\N	\N	130932	130932	298517
16795	22215	2	applied	\N	\N	\N	\N	130933	130933	298518
16795	22216	3	applied	\N	\N	\N	\N	130934	130934	298519
16797	22217	0	applied	\N	\N	\N	\N	130946	130946	298531
16797	22218	1	applied	\N	\N	\N	\N	130947	130947	298532
16797	22219	2	applied	\N	\N	\N	\N	130948	130948	298533
16797	22220	3	applied	\N	\N	\N	\N	130949	130949	298534
16797	22221	4	applied	\N	\N	\N	\N	130950	130950	298535
16797	22223	6	applied	\N	\N	\N	\N	130952	130952	298537
16797	22224	7	applied	\N	\N	\N	\N	130953	130953	298538
16797	22225	8	applied	\N	\N	\N	\N	130954	130954	298539
16797	22226	9	applied	\N	\N	\N	\N	130955	130955	298540
16797	22227	10	applied	\N	\N	\N	\N	130956	130956	298541
16798	22217	0	applied	\N	\N	\N	\N	130957	130957	298542
16798	22218	1	applied	\N	\N	\N	\N	130958	130958	298543
16798	22219	2	applied	\N	\N	\N	\N	130959	130959	298544
16798	22220	3	applied	\N	\N	\N	\N	130960	130960	298545
16798	22221	4	applied	\N	\N	\N	\N	130961	130961	298546
16798	22222	5	applied	\N	\N	\N	\N	130962	130962	298547
16798	22223	6	applied	\N	\N	\N	\N	130963	130963	298548
16798	22224	7	applied	\N	\N	\N	\N	130964	130964	298549
16799	22228	0	applied	\N	\N	\N	\N	130968	130968	298553
16799	22229	1	applied	\N	\N	\N	\N	130969	130969	298554
16799	22230	2	applied	\N	\N	\N	\N	130970	130970	298555
16804	22239	1	applied	\N	\N	\N	\N	130986	130986	298571
16804	22240	2	applied	\N	\N	\N	\N	130987	130987	298572
16806	22241	0	applied	\N	\N	\N	\N	130991	130991	298576
16806	22242	1	applied	\N	\N	\N	\N	130992	130992	298577
16816	22257	0	applied	\N	\N	\N	\N	131041	131041	298624
16816	22258	1	applied	\N	\N	\N	\N	131042	131042	298625
16821	22268	0	applied	\N	\N	\N	\N	131054	131054	298637
16821	22269	1	applied	\N	\N	\N	\N	131055	131055	298638
16821	22270	2	applied	\N	\N	\N	\N	131056	131056	298639
16823	22271	0	applied	\N	\N	\N	\N	131060	131060	298643
16823	22272	1	applied	\N	\N	\N	\N	131061	131061	298644
16828	22277	0	applied	\N	\N	\N	\N	131073	131073	298656
16828	22278	1	applied	\N	\N	\N	\N	131074	131074	298657
16828	22279	2	applied	\N	\N	\N	\N	131075	131075	298658
16830	22280	0	applied	\N	\N	\N	\N	131079	131079	298662
16830	22281	1	applied	\N	\N	\N	\N	131080	131080	298663
16834	22283	0	applied	\N	\N	\N	\N	131133	131133	298702
16834	22284	1	applied	\N	\N	\N	\N	131134	131134	298703
16834	22285	2	applied	\N	\N	\N	\N	131135	131135	298704
16834	22286	3	applied	\N	\N	\N	\N	131136	131136	298705
16836	22213	0	applied	\N	\N	1000000000	\N	131141	131141	298710
16836	21784	1	applied	\N	\N	\N	\N	131142	131142	298711
16836	21854	2	applied	\N	\N	\N	\N	131143	131143	298712
16836	21864	3	applied	\N	\N	\N	\N	131144	131144	298713
16836	21865	4	applied	\N	\N	\N	\N	131145	131145	298714
16836	21866	5	applied	\N	\N	\N	\N	131146	131146	298715
16836	21789	6	applied	\N	\N	\N	\N	131147	131147	298716
16836	21790	7	applied	\N	\N	\N	\N	131148	131148	298717
16836	21797	8	applied	\N	\N	\N	\N	131149	131149	298718
16836	22105	9	applied	\N	\N	\N	\N	131150	131150	298719
16836	22109	10	applied	\N	\N	\N	\N	131151	131151	298720
16836	22128	11	applied	\N	\N	\N	\N	131152	131152	298721
16836	21691	13	applied	\N	\N	\N	\N	131154	131154	298722
16836	21692	14	applied	\N	\N	\N	\N	131155	131155	298723
16836	21696	15	applied	\N	\N	\N	\N	131156	131156	298724
16836	21697	16	applied	\N	\N	\N	\N	131157	131157	298725
16836	21698	17	applied	\N	\N	\N	\N	131158	131158	298726
16836	21699	18	applied	\N	\N	\N	\N	131159	131159	298727
16784	22168	41	applied	\N	\N	\N	\N	130861	130861	298451
16784	22178	42	applied	\N	\N	\N	\N	130862	130862	298452
16800	22231	0	applied	\N	\N	\N	\N	130971	130971	298556
16800	22232	1	applied	\N	\N	\N	\N	130972	130972	298557
16800	22233	2	applied	\N	\N	\N	\N	130973	130973	298558
16800	22234	3	applied	\N	\N	\N	\N	130974	130974	298559
16802	22235	0	applied	\N	\N	\N	\N	130979	130979	298564
16802	22236	1	applied	\N	\N	\N	\N	130980	130980	298565
16802	22237	2	applied	\N	\N	\N	\N	130981	130981	298566
16805	22238	0	applied	\N	\N	\N	\N	130988	130988	298573
16805	22239	1	applied	\N	\N	\N	\N	130989	130989	298574
16805	22240	2	applied	\N	\N	\N	\N	130990	130990	298575
16807	22242	1	applied	\N	\N	\N	\N	130994	130994	298579
16814	22246	0	applied	\N	\N	\N	\N	131028	131028	298611
16814	22247	1	applied	\N	\N	\N	\N	131029	131029	298612
16814	22248	2	applied	\N	\N	\N	\N	131030	131030	298613
16814	22249	3	applied	\N	\N	\N	\N	131031	131031	298614
16814	22250	4	applied	\N	\N	\N	\N	131032	131032	298615
16814	22251	5	applied	\N	\N	\N	\N	131033	131033	298616
16814	22252	6	applied	\N	\N	\N	\N	131034	131034	298617
16814	22253	7	applied	\N	\N	\N	\N	131035	131035	298618
16814	22254	8	applied	\N	\N	\N	\N	131036	131036	298619
16814	22255	9	applied	\N	\N	\N	\N	131037	131037	298620
16814	22256	10	applied	\N	\N	\N	\N	131038	131038	298621
16819	22266	0	applied	\N	\N	\N	\N	131050	131050	298633
16819	22267	1	applied	\N	\N	\N	\N	131051	131051	298634
16824	22271	0	applied	\N	\N	\N	\N	131062	131062	298645
16824	22272	1	applied	\N	\N	\N	\N	131063	131063	298646
16826	22274	1	applied	\N	\N	\N	\N	131067	131067	298650
16826	22275	2	applied	\N	\N	\N	\N	131068	131068	298651
16826	22276	3	applied	\N	\N	\N	\N	131069	131069	298652
16829	22279	2	applied	\N	\N	\N	\N	131078	131078	298661
16831	22280	0	applied	\N	\N	\N	\N	131082	131082	298665
16831	22281	1	applied	\N	\N	\N	\N	131083	131083	298666
16831	22282	2	applied	\N	\N	\N	\N	131084	131084	298667
16832	22280	0	applied	\N	\N	\N	\N	131085	131085	298668
16832	22281	1	applied	\N	\N	\N	\N	131086	131086	298669
16832	22282	2	applied	\N	\N	\N	\N	131087	131087	298670
16833	21089	0	applied	\N	\N	\N	\N	131088	131088	131088
16833	21243	2	applied	\N	\N	\N	\N	131090	131090	298671
16833	21122	1	failed	Receiver_not_present	\N	\N	\N	131089	131089	\N
16833	22213	3	applied	\N	\N	1000000000	\N	131091	131091	298672
16833	21247	4	applied	\N	\N	\N	\N	131092	131092	298673
16833	21248	5	applied	\N	\N	\N	\N	131093	131093	298674
16833	21150	7	applied	\N	\N	1000000000	\N	131095	131095	298676
16833	21166	8	applied	\N	\N	\N	\N	131096	131096	298677
16833	21784	9	applied	\N	\N	\N	\N	131097	131097	298678
16833	21854	10	applied	\N	\N	\N	\N	131098	131098	298679
16833	21864	11	applied	\N	\N	\N	\N	131099	131099	298680
16833	21865	12	applied	\N	\N	\N	\N	131100	131100	298681
16833	21866	13	applied	\N	\N	\N	\N	131101	131101	298682
16833	21789	14	applied	\N	\N	\N	\N	131102	131102	298683
16833	21790	15	applied	\N	\N	\N	\N	131103	131103	298684
16833	21797	16	applied	\N	\N	\N	\N	131104	131104	298685
16833	21337	17	applied	\N	\N	1000000000	\N	131105	131105	298686
16833	21521	18	applied	\N	\N	1000000000	\N	131106	131106	298687
16833	22105	19	applied	\N	\N	\N	\N	131107	131107	298688
16833	22109	20	applied	\N	\N	\N	\N	131108	131108	298689
16833	22128	21	applied	\N	\N	\N	\N	131109	131109	298690
16833	21578	23	applied	\N	\N	1000000000	\N	131111	131111	298692
16833	21599	24	applied	\N	\N	1000000000	\N	131112	131112	298693
16833	21409	25	applied	\N	\N	\N	\N	131113	131113	298694
16833	21738	27	applied	\N	\N	1000000000	\N	131115	131115	298695
16833	21719	26	failed	Receiver_not_present	\N	\N	\N	131114	131114	\N
16833	21746	28	applied	\N	\N	\N	\N	131116	131116	298696
16833	22220	29	applied	\N	\N	\N	\N	131117	131117	298697
16833	22221	30	applied	\N	\N	\N	\N	131118	131118	298698
16833	21856	31	applied	\N	\N	\N	\N	131119	131119	298699
16833	21250	32	applied	\N	\N	\N	\N	131120	131120	298700
16835	22283	0	applied	\N	\N	\N	\N	131137	131137	298706
16835	22284	1	applied	\N	\N	\N	\N	131138	131138	298707
16835	22285	2	applied	\N	\N	\N	\N	131139	131139	298708
16835	22286	3	applied	\N	\N	\N	\N	131140	131140	298709
16837	22287	0	applied	\N	\N	\N	\N	131210	131210	298778
16837	22288	1	applied	\N	\N	\N	\N	131211	131211	298779
16842	22289	0	applied	\N	\N	\N	\N	131222	131222	298790
16842	22290	1	applied	\N	\N	\N	\N	131223	131223	298791
16842	22291	2	applied	\N	\N	\N	\N	131224	131224	298792
16844	22300	1	applied	\N	\N	\N	\N	131233	131233	298801
16844	22301	2	applied	\N	\N	\N	\N	131234	131234	298802
16846	22302	0	applied	\N	\N	\N	\N	131238	131238	298806
16846	22303	1	applied	\N	\N	\N	\N	131239	131239	298807
16846	22304	2	applied	\N	\N	\N	\N	131240	131240	298808
16852	22312	0	applied	\N	\N	\N	\N	131257	131257	298825
16852	22313	1	applied	\N	\N	\N	\N	131258	131258	298826
16852	22314	2	applied	\N	\N	\N	\N	131259	131259	298827
16855	22235	0	applied	\N	\N	\N	\N	131266	131266	298834
16855	22238	1	applied	\N	\N	\N	\N	131267	131267	298835
16855	22241	2	applied	\N	\N	\N	\N	131268	131268	298836
16855	22243	3	applied	\N	\N	\N	\N	131269	131269	298837
16855	22246	4	applied	\N	\N	\N	\N	131270	131270	298838
16855	22247	5	applied	\N	\N	\N	\N	131271	131271	298839
16855	22248	6	applied	\N	\N	\N	\N	131272	131272	298840
16855	22257	7	applied	\N	\N	\N	\N	131273	131273	298841
16855	22261	9	applied	\N	\N	\N	\N	131275	131275	298843
16855	22266	10	applied	\N	\N	\N	\N	131276	131276	298844
16855	22268	11	applied	\N	\N	\N	\N	131277	131277	298845
16855	22271	12	applied	\N	\N	\N	\N	131278	131278	298846
16855	22273	13	applied	\N	\N	\N	\N	131279	131279	298847
16855	22277	14	applied	\N	\N	\N	\N	131280	131280	298848
16855	22280	15	applied	\N	\N	\N	\N	131281	131281	298849
16855	22283	16	applied	\N	\N	\N	\N	131282	131282	298850
16855	22287	17	applied	\N	\N	\N	\N	131283	131283	298851
16855	22289	18	applied	\N	\N	\N	\N	131284	131284	298852
16855	22292	20	applied	\N	\N	\N	\N	131285	131285	298853
16855	22293	21	applied	\N	\N	\N	\N	131286	131286	298854
16855	22299	22	applied	\N	\N	\N	\N	131287	131287	298855
16855	22302	23	applied	\N	\N	\N	\N	131288	131288	298856
16855	22305	24	applied	\N	\N	\N	\N	131289	131289	298857
16855	22309	25	applied	\N	\N	\N	\N	131290	131290	298858
16798	22226	9	applied	\N	\N	\N	\N	130966	130966	298551
16798	22227	10	applied	\N	\N	\N	\N	130967	130967	298552
16833	21322	37	applied	\N	\N	\N	\N	131125	131125	131125
16833	21393	38	applied	\N	\N	\N	\N	131126	131126	131126
16833	21403	39	applied	\N	\N	\N	\N	131127	131127	131127
16833	21405	40	applied	\N	\N	\N	\N	131128	131128	131128
16833	21413	41	applied	\N	\N	\N	\N	131129	131129	131129
16833	21421	42	applied	\N	\N	\N	\N	131130	131130	131130
16833	22103	43	applied	\N	\N	\N	\N	131131	131131	131131
16833	22112	44	applied	\N	\N	\N	\N	131132	131132	131132
16836	21709	19	applied	\N	\N	\N	\N	131160	131160	298728
16836	21712	20	applied	\N	\N	\N	\N	131161	131161	298729
16836	21715	21	applied	\N	\N	\N	\N	131162	131162	298730
16836	21718	22	applied	\N	\N	\N	\N	131163	131163	298731
16836	21727	24	applied	\N	\N	\N	\N	131165	131165	298733
16836	21731	25	applied	\N	\N	\N	\N	131166	131166	298734
16836	21732	27	applied	\N	\N	\N	\N	131167	131167	298735
16836	21737	28	applied	\N	\N	\N	\N	131168	131168	298736
16836	21741	29	applied	\N	\N	\N	\N	131169	131169	298737
16836	21745	30	applied	\N	\N	\N	\N	131170	131170	298738
16836	21749	31	applied	\N	\N	\N	\N	131171	131171	298739
16836	21752	32	applied	\N	\N	\N	\N	131172	131172	298740
16836	21756	33	applied	\N	\N	\N	\N	131173	131173	298741
16836	21738	34	applied	\N	\N	1000000000	\N	131174	131174	298742
16836	21746	35	applied	\N	\N	\N	\N	131175	131175	298743
16836	21757	36	applied	\N	\N	\N	\N	131176	131176	298744
16836	21758	37	applied	\N	\N	\N	\N	131177	131177	298745
16836	21766	38	applied	\N	\N	\N	\N	131178	131178	298746
16836	21767	39	applied	\N	\N	\N	\N	131179	131179	298747
16836	21772	40	applied	\N	\N	\N	\N	131180	131180	298748
16836	21778	42	applied	\N	\N	\N	\N	131182	131182	298750
16836	21779	43	applied	\N	\N	\N	\N	131183	131183	298751
16836	21785	44	applied	\N	\N	\N	\N	131184	131184	298752
16836	21791	45	applied	\N	\N	\N	\N	131185	131185	298753
16836	21794	46	applied	\N	\N	\N	\N	131186	131186	298754
16836	21799	47	applied	\N	\N	\N	\N	131187	131187	298755
16836	21803	48	applied	\N	\N	\N	\N	131188	131188	298756
16836	21806	49	applied	\N	\N	\N	\N	131189	131189	298757
16836	21810	50	applied	\N	\N	\N	\N	131190	131190	298758
16836	21812	51	applied	\N	\N	\N	\N	131191	131191	298759
16836	21816	52	applied	\N	\N	\N	\N	131192	131192	298760
16836	21819	53	applied	\N	\N	\N	\N	131193	131193	298761
16836	21822	54	applied	\N	\N	\N	\N	131194	131194	298762
16836	21826	55	applied	\N	\N	\N	\N	131195	131195	298763
16836	21830	56	applied	\N	\N	\N	\N	131196	131196	298764
16836	21833	57	applied	\N	\N	\N	\N	131197	131197	298765
16838	22288	1	applied	\N	\N	\N	\N	131213	131213	298781
16845	22299	0	applied	\N	\N	\N	\N	131235	131235	298803
16845	22300	1	applied	\N	\N	\N	\N	131236	131236	298804
16845	22301	2	applied	\N	\N	\N	\N	131237	131237	298805
16847	22302	0	applied	\N	\N	\N	\N	131241	131241	298809
16847	22303	1	applied	\N	\N	\N	\N	131242	131242	298810
16847	22304	2	applied	\N	\N	\N	\N	131243	131243	298811
16849	22309	0	applied	\N	\N	\N	\N	131248	131248	298816
16849	22310	1	applied	\N	\N	\N	\N	131249	131249	298817
16849	22311	2	applied	\N	\N	\N	\N	131250	131250	298818
16853	22312	0	applied	\N	\N	\N	\N	131260	131260	298828
16853	22313	1	applied	\N	\N	\N	\N	131261	131261	298829
16853	22314	2	applied	\N	\N	\N	\N	131262	131262	298830
16865	22322	0	applied	\N	\N	\N	\N	131359	131359	298927
16865	22323	1	applied	\N	\N	\N	\N	131360	131360	298928
16865	22324	2	applied	\N	\N	\N	\N	131361	131361	298929
16868	22057	1	applied	\N	\N	\N	\N	131367	131367	298935
16868	22058	2	applied	\N	\N	\N	\N	131368	131368	298936
16868	22059	3	applied	\N	\N	\N	\N	131369	131369	298937
16868	22067	4	applied	\N	\N	\N	\N	131370	131370	298938
16868	22070	5	applied	\N	\N	\N	\N	131371	131371	298939
16868	22105	6	applied	\N	\N	\N	\N	131372	131372	298940
16868	22109	7	applied	\N	\N	\N	\N	131373	131373	298941
16868	22128	8	applied	\N	\N	\N	\N	131374	131374	298942
16868	22073	9	applied	\N	\N	\N	\N	131375	131375	298943
16868	22074	10	applied	\N	\N	\N	\N	131376	131376	298944
16868	22080	11	applied	\N	\N	\N	\N	131377	131377	298945
16868	22083	12	applied	\N	\N	\N	\N	131378	131378	298946
16868	22087	13	applied	\N	\N	\N	\N	131379	131379	298947
16868	22088	14	applied	\N	\N	\N	\N	131380	131380	298948
16868	22092	15	applied	\N	\N	\N	\N	131381	131381	298949
16868	22095	16	applied	\N	\N	\N	\N	131382	131382	298950
16868	22097	17	applied	\N	\N	\N	\N	131383	131383	298951
16868	22100	18	applied	\N	\N	\N	\N	131384	131384	298952
16868	22110	20	applied	\N	\N	\N	\N	131386	131386	298954
16868	22111	21	applied	\N	\N	\N	\N	131387	131387	298955
16868	22117	22	applied	\N	\N	\N	\N	131388	131388	298956
16868	22118	23	applied	\N	\N	\N	\N	131389	131389	298957
16868	22119	24	applied	\N	\N	\N	\N	131390	131390	298958
16868	22127	25	applied	\N	\N	\N	\N	131391	131391	298959
16868	22131	26	applied	\N	\N	\N	\N	131392	131392	298960
16868	22134	27	applied	\N	\N	\N	\N	131393	131393	298961
16868	22137	28	applied	\N	\N	\N	\N	131394	131394	298962
16868	22143	29	applied	\N	\N	\N	\N	131395	131395	298963
16868	22146	30	applied	\N	\N	\N	\N	131396	131396	298964
16868	22149	31	applied	\N	\N	\N	\N	131397	131397	298965
16868	22151	32	applied	\N	\N	\N	\N	131398	131398	298966
16868	22155	33	applied	\N	\N	\N	\N	131399	131399	298967
16868	22158	34	applied	\N	\N	\N	\N	131400	131400	298968
16868	22159	35	applied	\N	\N	\N	\N	131401	131401	298969
16868	22166	37	applied	\N	\N	\N	\N	131403	131403	298971
16868	22167	38	applied	\N	\N	\N	\N	131404	131404	298972
16868	22168	39	applied	\N	\N	\N	\N	131405	131405	298973
16868	22178	40	applied	\N	\N	\N	\N	131406	131406	298974
16868	22181	41	applied	\N	\N	\N	\N	131407	131407	298975
16868	22182	42	applied	\N	\N	\N	\N	131408	131408	298976
16868	22188	43	applied	\N	\N	\N	\N	131409	131409	298977
16868	22191	44	applied	\N	\N	\N	\N	131410	131410	298978
16868	22194	45	applied	\N	\N	\N	\N	131411	131411	298979
16868	22195	46	applied	\N	\N	\N	\N	131412	131412	298980
16868	22201	47	applied	\N	\N	\N	\N	131413	131413	298981
16868	22204	48	applied	\N	\N	\N	\N	131414	131414	298982
16868	22207	49	applied	\N	\N	\N	\N	131415	131415	298983
16868	22210	50	applied	\N	\N	\N	\N	131416	131416	298984
16868	22214	51	applied	\N	\N	\N	\N	131417	131417	298985
16833	21006	34	applied	\N	\N	\N	\N	131122	131122	131122
16833	21314	36	applied	\N	\N	\N	\N	131124	131124	131124
16836	21848	62	applied	\N	\N	\N	\N	131202	131202	298770
16836	21851	63	applied	\N	\N	\N	\N	131203	131203	298771
16836	21855	64	applied	\N	\N	\N	\N	131204	131204	298772
16836	21860	65	applied	\N	\N	\N	\N	131205	131205	298773
16836	21867	66	applied	\N	\N	\N	\N	131206	131206	298774
16836	21870	67	applied	\N	\N	\N	\N	131207	131207	298775
16836	21873	68	applied	\N	\N	\N	\N	131208	131208	298776
16836	21874	69	applied	\N	\N	\N	\N	131209	131209	298777
16841	22289	0	applied	\N	\N	\N	\N	131219	131219	298787
16841	22290	1	applied	\N	\N	\N	\N	131220	131220	298788
16841	22291	2	applied	\N	\N	\N	\N	131221	131221	298789
16843	22292	0	applied	\N	\N	\N	\N	131225	131225	298793
16843	22293	1	applied	\N	\N	\N	\N	131226	131226	298794
16843	22294	2	applied	\N	\N	\N	\N	131227	131227	298795
16843	22296	4	applied	\N	\N	\N	\N	131229	131229	298797
16843	22297	5	applied	\N	\N	\N	\N	131230	131230	298798
16843	22298	6	applied	\N	\N	\N	\N	131231	131231	298799
16848	22305	0	applied	\N	\N	\N	\N	131244	131244	298812
16848	22306	1	applied	\N	\N	\N	\N	131245	131245	298813
16848	22307	2	applied	\N	\N	\N	\N	131246	131246	298814
16848	22308	3	applied	\N	\N	\N	\N	131247	131247	298815
16851	22312	0	applied	\N	\N	\N	\N	131254	131254	298822
16851	22313	1	applied	\N	\N	\N	\N	131255	131255	298823
16851	22314	2	applied	\N	\N	\N	\N	131256	131256	298824
16855	22245	27	applied	\N	\N	\N	\N	131292	131292	298860
16855	22249	28	applied	\N	\N	\N	\N	131293	131293	298861
16855	22262	29	applied	\N	\N	\N	\N	131294	131294	298862
16855	22275	30	applied	\N	\N	\N	\N	131295	131295	298863
16855	22236	31	applied	\N	\N	\N	\N	131296	131296	298864
16855	22286	32	applied	\N	\N	\N	\N	131297	131297	298865
16855	22307	34	applied	\N	\N	\N	\N	131299	131299	298867
16855	22240	35	applied	\N	\N	\N	\N	131300	131300	298868
16855	22242	36	applied	\N	\N	\N	\N	131301	131301	298869
16855	22253	37	applied	\N	\N	\N	\N	131302	131302	298870
16855	22254	38	applied	\N	\N	\N	\N	131303	131303	298871
16855	22255	39	applied	\N	\N	\N	\N	131304	131304	298872
16855	22256	40	applied	\N	\N	\N	\N	131305	131305	298873
16855	22258	41	applied	\N	\N	\N	\N	131306	131306	298874
16855	22264	42	applied	\N	\N	\N	\N	131307	131307	298875
16855	22265	43	applied	\N	\N	\N	\N	131308	131308	298876
16855	22267	44	applied	\N	\N	\N	\N	131309	131309	298877
16855	22269	45	applied	\N	\N	\N	\N	131310	131310	298878
16855	22274	46	applied	\N	\N	\N	\N	131311	131311	298879
16855	22276	47	applied	\N	\N	\N	\N	131312	131312	298880
16855	22278	48	applied	\N	\N	\N	\N	131313	131313	298881
16855	22282	49	applied	\N	\N	\N	\N	131314	131314	298882
16855	22288	51	applied	\N	\N	\N	\N	131316	131316	298884
16855	22291	52	applied	\N	\N	\N	\N	131317	131317	298885
16855	22294	53	applied	\N	\N	\N	\N	131318	131318	298886
16855	22297	54	applied	\N	\N	\N	\N	131319	131319	298887
16855	22300	55	applied	\N	\N	\N	\N	131320	131320	298888
16855	22304	56	applied	\N	\N	\N	\N	131321	131321	298889
16855	22306	57	applied	\N	\N	\N	\N	131322	131322	298890
16855	22311	58	applied	\N	\N	\N	\N	131323	131323	298891
16855	22313	59	applied	\N	\N	\N	\N	131324	131324	298892
16855	22237	60	applied	\N	\N	\N	\N	131325	131325	298893
16855	22239	61	applied	\N	\N	\N	\N	131326	131326	298894
16855	22244	62	applied	\N	\N	\N	\N	131327	131327	298895
16855	22250	63	applied	\N	\N	\N	\N	131328	131328	298896
16855	22251	64	applied	\N	\N	\N	\N	131329	131329	298897
16855	22252	65	applied	\N	\N	\N	\N	131330	131330	298898
16864	22322	0	applied	\N	\N	\N	\N	131356	131356	298924
16864	22324	2	applied	\N	\N	\N	\N	131358	131358	298926
16866	22325	0	applied	\N	\N	\N	\N	131362	131362	298930
16866	22326	1	applied	\N	\N	\N	\N	131363	131363	298931
16866	22327	2	applied	\N	\N	\N	\N	131364	131364	298932
16866	22328	3	applied	\N	\N	\N	\N	131365	131365	298933
16870	22329	0	applied	\N	\N	\N	\N	131504	131504	299070
16870	22330	1	applied	\N	\N	\N	\N	131505	131505	299071
16870	22331	2	applied	\N	\N	\N	\N	131506	131506	299072
16870	22332	3	applied	\N	\N	\N	\N	131507	131507	299073
16870	22333	4	applied	\N	\N	\N	\N	131508	131508	299074
16870	22334	5	applied	\N	\N	\N	\N	131509	131509	299075
16870	22335	6	applied	\N	\N	\N	\N	131510	131510	299076
16870	22336	7	applied	\N	\N	\N	\N	131511	131511	299077
16870	22337	8	applied	\N	\N	\N	\N	131512	131512	299078
16870	22338	9	applied	\N	\N	\N	\N	131513	131513	299079
16870	22339	10	applied	\N	\N	\N	\N	131514	131514	299080
16870	22341	12	applied	\N	\N	\N	\N	131516	131516	299082
16874	22344	0	applied	\N	\N	\N	\N	131536	131536	299102
16874	22345	1	applied	\N	\N	\N	\N	131537	131537	299103
16874	22346	2	applied	\N	\N	\N	\N	131538	131538	299104
16874	22347	3	applied	\N	\N	\N	\N	131539	131539	299105
16876	22348	0	applied	\N	\N	\N	\N	131544	131544	299110
16876	22349	1	applied	\N	\N	\N	\N	131545	131545	299111
16876	22350	2	applied	\N	\N	\N	\N	131546	131546	299112
16876	22351	3	applied	\N	\N	\N	\N	131547	131547	299113
16876	22352	4	applied	\N	\N	\N	\N	131548	131548	299114
16876	22353	5	applied	\N	\N	\N	\N	131549	131549	299115
16876	22354	6	applied	\N	\N	\N	\N	131550	131550	299116
16876	22355	7	applied	\N	\N	\N	\N	131551	131551	299117
16876	22356	8	applied	\N	\N	\N	\N	131552	131552	299118
16884	22378	0	applied	\N	\N	\N	\N	131580	131580	299146
16884	22379	1	applied	\N	\N	\N	\N	131581	131581	299147
16884	22381	3	applied	\N	\N	\N	\N	131583	131583	299149
16887	22382	0	applied	\N	\N	\N	\N	131713	131713	299277
16887	22383	1	applied	\N	\N	\N	\N	131714	131714	299278
16887	22384	2	applied	\N	\N	\N	\N	131715	131715	299279
16889	22213	0	applied	\N	\N	1000000000	\N	131719	131719	299283
16889	21905	1	applied	\N	\N	\N	\N	131720	131720	299284
16889	21906	2	applied	\N	\N	\N	\N	131721	131721	299285
16889	21911	3	applied	\N	\N	\N	\N	131722	131722	299286
16889	21912	4	applied	\N	\N	\N	\N	131723	131723	299287
16889	21918	5	applied	\N	\N	\N	\N	131724	131724	299288
16889	21921	6	applied	\N	\N	\N	\N	131725	131725	299289
16889	21924	7	applied	\N	\N	\N	\N	131726	131726	299290
16889	21925	8	applied	\N	\N	\N	\N	131727	131727	299291
16889	21926	9	applied	\N	\N	\N	\N	131728	131728	299292
16889	21933	10	applied	\N	\N	\N	\N	131729	131729	299293
16889	21936	11	applied	\N	\N	\N	\N	131730	131730	299294
16836	21842	61	applied	\N	\N	\N	\N	131201	131201	298769
16855	22279	70	applied	\N	\N	\N	\N	131335	131335	298903
16855	22281	71	applied	\N	\N	\N	\N	131336	131336	298904
16855	22284	72	applied	\N	\N	\N	\N	131337	131337	298905
16855	22290	73	applied	\N	\N	\N	\N	131338	131338	298906
16855	22295	74	applied	\N	\N	\N	\N	131339	131339	298907
16855	22298	75	applied	\N	\N	\N	\N	131340	131340	298908
16855	22301	76	applied	\N	\N	\N	\N	131341	131341	298909
16855	22303	77	applied	\N	\N	\N	\N	131342	131342	298910
16855	22308	78	applied	\N	\N	\N	\N	131343	131343	298911
16855	22310	79	applied	\N	\N	\N	\N	131344	131344	298912
16855	22314	80	applied	\N	\N	\N	\N	131345	131345	298913
16868	22218	52	applied	\N	\N	\N	\N	131418	131418	298986
16868	22219	53	applied	\N	\N	\N	\N	131419	131419	298987
16868	22228	54	applied	\N	\N	\N	\N	131420	131420	298988
16868	22235	56	applied	\N	\N	\N	\N	131422	131422	298990
16868	22238	57	applied	\N	\N	\N	\N	131423	131423	298991
16868	22241	58	applied	\N	\N	\N	\N	131424	131424	298992
16868	22243	59	applied	\N	\N	\N	\N	131425	131425	298993
16868	22246	60	applied	\N	\N	\N	\N	131426	131426	298994
16868	22247	61	applied	\N	\N	\N	\N	131427	131427	298995
16868	22248	62	applied	\N	\N	\N	\N	131428	131428	298996
16868	22257	64	applied	\N	\N	\N	\N	131429	131429	298997
16868	22259	65	applied	\N	\N	\N	\N	131430	131430	298998
16868	22261	66	applied	\N	\N	\N	\N	131431	131431	298999
16868	22266	67	applied	\N	\N	\N	\N	131432	131432	299000
16868	22268	68	applied	\N	\N	\N	\N	131433	131433	299001
16868	22271	69	applied	\N	\N	\N	\N	131434	131434	299002
16868	22273	70	applied	\N	\N	\N	\N	131435	131435	299003
16868	22277	71	applied	\N	\N	\N	\N	131436	131436	299004
16868	22280	72	applied	\N	\N	\N	\N	131437	131437	299005
16868	22287	74	applied	\N	\N	\N	\N	131439	131439	299007
16868	22289	75	applied	\N	\N	\N	\N	131440	131440	299008
16868	22292	76	applied	\N	\N	\N	\N	131441	131441	299009
16868	22293	77	applied	\N	\N	\N	\N	131442	131442	299010
16868	22299	78	applied	\N	\N	\N	\N	131443	131443	299011
16868	22302	79	applied	\N	\N	\N	\N	131444	131444	299012
16868	22305	80	applied	\N	\N	\N	\N	131445	131445	299013
16868	22309	81	applied	\N	\N	\N	\N	131446	131446	299014
16868	22312	82	applied	\N	\N	\N	\N	131447	131447	299015
16868	22315	83	applied	\N	\N	\N	\N	131448	131448	299016
16868	22316	84	applied	\N	\N	\N	\N	131449	131449	299017
16868	22322	85	applied	\N	\N	\N	\N	131450	131450	299018
16868	22325	86	applied	\N	\N	\N	\N	131451	131451	299019
16868	22329	87	applied	\N	\N	\N	\N	131452	131452	299020
16868	22330	88	applied	\N	\N	\N	\N	131453	131453	299021
16868	22331	89	applied	\N	\N	\N	\N	131454	131454	299022
16868	22220	91	applied	\N	\N	\N	\N	131456	131456	299024
16875	22344	0	applied	\N	\N	\N	\N	131540	131540	299106
16875	22345	1	applied	\N	\N	\N	\N	131541	131541	299107
16875	22346	2	applied	\N	\N	\N	\N	131542	131542	299108
16875	22347	3	applied	\N	\N	\N	\N	131543	131543	299109
16877	22357	0	applied	\N	\N	\N	\N	131553	131553	299119
16877	22358	1	applied	\N	\N	\N	\N	131554	131554	299120
16877	22359	2	applied	\N	\N	\N	\N	131555	131555	299121
16877	22360	3	applied	\N	\N	\N	\N	131556	131556	299122
16880	22372	0	applied	\N	\N	\N	\N	131568	131568	299134
16880	22373	1	applied	\N	\N	\N	\N	131569	131569	299135
16880	22374	2	applied	\N	\N	\N	\N	131570	131570	299136
16885	22213	0	applied	\N	\N	1000000000	\N	131584	131584	299150
16885	22083	1	applied	\N	\N	\N	\N	131585	131585	299151
16885	22105	2	applied	\N	\N	\N	\N	131586	131586	299152
16885	22109	3	applied	\N	\N	\N	\N	131587	131587	299153
16885	22087	5	applied	\N	\N	\N	\N	131589	131589	299155
16885	22088	6	applied	\N	\N	\N	\N	131590	131590	299156
16885	22092	7	applied	\N	\N	\N	\N	131591	131591	299157
16885	22095	8	applied	\N	\N	\N	\N	131592	131592	299158
16885	22097	9	applied	\N	\N	\N	\N	131593	131593	299159
16885	22100	10	applied	\N	\N	\N	\N	131594	131594	299160
16885	22104	11	applied	\N	\N	\N	\N	131595	131595	299161
16885	22110	12	applied	\N	\N	\N	\N	131596	131596	299162
16885	22111	13	applied	\N	\N	\N	\N	131597	131597	299163
16885	22117	14	applied	\N	\N	\N	\N	131598	131598	299164
16885	22118	15	applied	\N	\N	\N	\N	131599	131599	299165
16885	22119	16	applied	\N	\N	\N	\N	131600	131600	299166
16885	22127	17	applied	\N	\N	\N	\N	131601	131601	299167
16885	22131	18	applied	\N	\N	\N	\N	131602	131602	299168
16885	22134	19	applied	\N	\N	\N	\N	131603	131603	299169
16885	22137	20	applied	\N	\N	\N	\N	131604	131604	299170
16885	22146	22	applied	\N	\N	\N	\N	131606	131606	299172
16885	22149	23	applied	\N	\N	\N	\N	131607	131607	299173
16885	22151	24	applied	\N	\N	\N	\N	131608	131608	299174
16885	22155	25	applied	\N	\N	\N	\N	131609	131609	299175
16885	22158	26	applied	\N	\N	\N	\N	131610	131610	299176
16885	22159	27	applied	\N	\N	\N	\N	131611	131611	299177
16885	22165	28	applied	\N	\N	\N	\N	131612	131612	299178
16885	22166	29	applied	\N	\N	\N	\N	131613	131613	299179
16885	22167	30	applied	\N	\N	\N	\N	131614	131614	299180
16885	22168	31	applied	\N	\N	\N	\N	131615	131615	299181
16885	22178	32	applied	\N	\N	\N	\N	131616	131616	299182
16885	22181	33	applied	\N	\N	\N	\N	131617	131617	299183
16885	22182	34	applied	\N	\N	\N	\N	131618	131618	299184
16885	22188	35	applied	\N	\N	\N	\N	131619	131619	299185
16885	22191	36	applied	\N	\N	\N	\N	131620	131620	299186
16885	22194	37	applied	\N	\N	\N	\N	131621	131621	299187
16885	22201	39	applied	\N	\N	\N	\N	131623	131623	299189
16885	22204	40	applied	\N	\N	\N	\N	131624	131624	299190
16885	22207	41	applied	\N	\N	\N	\N	131625	131625	299191
16885	22210	42	applied	\N	\N	\N	\N	131626	131626	299192
16885	22214	43	applied	\N	\N	\N	\N	131627	131627	299193
16885	22218	44	applied	\N	\N	\N	\N	131628	131628	299194
16885	22219	45	applied	\N	\N	\N	\N	131629	131629	299195
16885	22228	46	applied	\N	\N	\N	\N	131630	131630	299196
16885	22231	47	applied	\N	\N	\N	\N	131631	131631	299197
16885	22235	48	applied	\N	\N	\N	\N	131632	131632	299198
16885	22238	49	applied	\N	\N	\N	\N	131633	131633	299199
16885	22241	50	applied	\N	\N	\N	\N	131634	131634	299200
16885	22243	51	applied	\N	\N	\N	\N	131635	131635	299201
16885	22246	52	applied	\N	\N	\N	\N	131636	131636	299202
16885	22247	53	applied	\N	\N	\N	\N	131637	131637	299203
16885	22248	54	applied	\N	\N	\N	\N	131638	131638	299204
16855	22272	69	applied	\N	\N	\N	\N	131334	131334	298902
16868	21908	96	applied	\N	\N	\N	\N	131461	131461	299029
16868	21913	97	applied	\N	\N	\N	\N	131462	131462	299030
16868	21927	98	applied	\N	\N	\N	\N	131463	131463	299031
16868	21938	99	applied	\N	\N	\N	\N	131464	131464	299032
16868	21950	100	applied	\N	\N	\N	\N	131465	131465	299033
16868	21954	101	applied	\N	\N	\N	\N	131466	131466	299034
16868	21968	102	applied	\N	\N	\N	\N	131467	131467	299035
16868	21977	103	applied	\N	\N	\N	\N	131468	131468	299036
16868	21989	104	applied	\N	\N	\N	\N	131469	131469	299037
16868	22004	105	applied	\N	\N	\N	\N	131470	131470	299038
16868	22011	106	applied	\N	\N	\N	\N	131471	131471	299039
16868	22023	107	applied	\N	\N	\N	\N	131472	131472	299040
16868	22034	108	applied	\N	\N	\N	\N	131473	131473	299041
16868	22043	109	applied	\N	\N	\N	\N	131474	131474	299042
16868	22053	110	applied	\N	\N	\N	\N	131475	131475	299043
16868	22062	111	applied	\N	\N	\N	\N	131476	131476	299044
16868	22085	113	applied	\N	\N	\N	\N	131478	131478	299046
16868	22096	114	applied	\N	\N	\N	\N	131479	131479	299047
16868	22103	115	applied	\N	\N	\N	\N	131480	131480	131480
16868	22112	116	applied	\N	\N	\N	\N	131481	131481	131481
16868	22108	117	applied	\N	\N	\N	\N	131482	131482	299048
16868	22122	118	applied	\N	\N	\N	\N	131483	131483	299049
16868	22133	119	applied	\N	\N	\N	\N	131484	131484	299050
16868	22140	120	applied	\N	\N	\N	\N	131485	131485	299051
16868	22153	121	applied	\N	\N	\N	\N	131486	131486	299052
16868	22164	122	applied	\N	\N	\N	\N	131487	131487	299053
16868	22175	123	applied	\N	\N	\N	\N	131488	131488	299054
16868	22183	124	applied	\N	\N	\N	\N	131489	131489	299055
16868	22197	125	applied	\N	\N	\N	\N	131490	131490	299056
16871	22329	0	applied	\N	\N	\N	\N	131517	131517	299083
16871	22330	1	applied	\N	\N	\N	\N	131518	131518	299084
16871	22331	2	applied	\N	\N	\N	\N	131519	131519	299085
16871	22333	4	applied	\N	\N	\N	\N	131521	131521	299087
16871	22334	5	applied	\N	\N	\N	\N	131522	131522	299088
16871	22335	6	applied	\N	\N	\N	\N	131523	131523	299089
16871	22336	7	applied	\N	\N	\N	\N	131524	131524	299090
16871	22337	8	applied	\N	\N	\N	\N	131525	131525	299091
16871	22338	9	applied	\N	\N	\N	\N	131526	131526	299092
16871	22339	10	applied	\N	\N	\N	\N	131527	131527	299093
16871	22340	11	applied	\N	\N	\N	\N	131528	131528	299094
16871	22341	12	applied	\N	\N	\N	\N	131529	131529	299095
16872	22342	0	applied	\N	\N	\N	\N	131530	131530	299096
16872	22343	1	applied	\N	\N	\N	\N	131531	131531	299097
16881	22372	0	applied	\N	\N	\N	\N	131571	131571	299137
16881	22373	1	applied	\N	\N	\N	\N	131572	131572	299138
16881	22374	2	applied	\N	\N	\N	\N	131573	131573	299139
16883	22375	0	applied	\N	\N	\N	\N	131577	131577	299143
16883	22376	1	applied	\N	\N	\N	\N	131578	131578	299144
16885	22257	55	applied	\N	\N	\N	\N	131639	131639	299205
16885	22259	56	applied	\N	\N	\N	\N	131640	131640	299206
16885	22261	57	applied	\N	\N	\N	\N	131641	131641	299207
16885	22266	58	applied	\N	\N	\N	\N	131642	131642	299208
16885	22268	59	applied	\N	\N	\N	\N	131643	131643	299209
16885	22271	60	applied	\N	\N	\N	\N	131644	131644	299210
16885	22273	61	applied	\N	\N	\N	\N	131645	131645	299211
16885	22277	62	applied	\N	\N	\N	\N	131646	131646	299212
16885	22280	63	applied	\N	\N	\N	\N	131647	131647	299213
16885	22283	64	applied	\N	\N	\N	\N	131648	131648	299214
16885	22287	65	applied	\N	\N	\N	\N	131649	131649	299215
16885	22289	66	applied	\N	\N	\N	\N	131650	131650	299216
16885	22292	67	applied	\N	\N	\N	\N	131651	131651	299217
16885	22293	68	applied	\N	\N	\N	\N	131652	131652	299218
16885	22299	69	applied	\N	\N	\N	\N	131653	131653	299219
16885	22302	70	applied	\N	\N	\N	\N	131654	131654	299220
16885	22309	72	applied	\N	\N	\N	\N	131656	131656	299222
16885	22312	73	applied	\N	\N	\N	\N	131657	131657	299223
16885	22315	74	applied	\N	\N	\N	\N	131658	131658	299224
16885	22316	75	applied	\N	\N	\N	\N	131659	131659	299225
16885	22322	76	applied	\N	\N	\N	\N	131660	131660	299226
16885	22325	77	applied	\N	\N	\N	\N	131661	131661	299227
16885	22329	78	applied	\N	\N	\N	\N	131662	131662	299228
16885	22330	79	applied	\N	\N	\N	\N	131663	131663	299229
16885	22331	80	applied	\N	\N	\N	\N	131664	131664	299230
16885	22332	81	applied	\N	\N	\N	\N	131665	131665	299231
16885	22342	82	applied	\N	\N	\N	\N	131666	131666	299232
16885	22344	83	applied	\N	\N	\N	\N	131667	131667	299233
16885	22348	84	applied	\N	\N	\N	\N	131668	131668	299234
16885	22349	85	applied	\N	\N	\N	\N	131669	131669	299235
16885	22350	86	applied	\N	\N	\N	\N	131670	131670	299236
16885	22357	87	applied	\N	\N	\N	\N	131671	131671	299237
16885	22362	89	applied	\N	\N	\N	\N	131673	131673	299239
16885	22363	90	applied	\N	\N	\N	\N	131674	131674	299240
16885	22372	91	applied	\N	\N	\N	\N	131675	131675	299241
16885	22375	92	applied	\N	\N	\N	\N	131676	131676	299242
16885	22378	93	applied	\N	\N	\N	\N	131677	131677	299243
16890	22385	0	applied	\N	\N	\N	\N	131844	131844	299408
16890	22386	1	applied	\N	\N	\N	\N	131845	131845	299409
16890	22387	2	applied	\N	\N	\N	\N	131846	131846	299410
16892	22388	0	applied	\N	\N	\N	\N	131850	131850	299414
16892	22389	1	applied	\N	\N	\N	\N	131851	131851	299415
16892	22390	2	applied	\N	\N	\N	\N	131852	131852	299416
16895	22391	0	applied	\N	\N	\N	\N	131861	131861	299425
16895	22392	1	applied	\N	\N	\N	\N	131862	131862	299426
16895	22393	2	applied	\N	\N	\N	\N	131863	131863	299427
16895	22394	3	applied	\N	\N	\N	\N	131864	131864	299428
16897	22397	0	applied	\N	\N	\N	\N	131872	131872	299436
16897	22401	2	applied	\N	\N	\N	\N	131874	131874	299438
16903	22405	0	applied	\N	\N	\N	\N	131892	131892	299456
16903	22406	1	applied	\N	\N	\N	\N	131893	131893	299457
16903	22407	2	applied	\N	\N	\N	\N	131894	131894	299458
16909	22421	0	applied	\N	\N	\N	\N	131921	131921	299485
16909	22422	1	applied	\N	\N	\N	\N	131922	131922	299486
16909	22423	2	applied	\N	\N	\N	\N	131923	131923	299487
16909	22424	3	applied	\N	\N	\N	\N	131924	131924	299488
16909	22425	4	applied	\N	\N	\N	\N	131925	131925	299489
16909	22426	5	applied	\N	\N	\N	\N	131926	131926	299490
16909	22427	6	applied	\N	\N	\N	\N	131927	131927	299491
16912	22421	0	applied	\N	\N	\N	\N	131942	131942	299506
16912	22422	1	applied	\N	\N	\N	\N	131943	131943	299507
16912	22423	2	applied	\N	\N	\N	\N	131944	131944	299508
16868	22222	93	applied	\N	\N	\N	\N	131458	131458	299026
16868	22223	94	applied	\N	\N	\N	\N	131459	131459	299027
16885	22084	98	applied	\N	\N	\N	\N	131682	131682	299248
16885	22089	99	applied	\N	\N	\N	\N	131683	131683	299249
16885	22086	100	applied	\N	\N	\N	\N	131684	131684	299250
16885	22090	101	applied	\N	\N	\N	\N	131685	131685	299251
16885	22091	102	applied	\N	\N	\N	\N	131686	131686	299252
16885	22093	103	applied	\N	\N	\N	\N	131687	131687	299253
16885	22094	104	applied	\N	\N	\N	\N	131688	131688	299254
16885	22098	105	applied	\N	\N	\N	\N	131689	131689	299255
16885	22101	106	applied	\N	\N	\N	\N	131690	131690	299256
16885	22106	107	applied	\N	\N	\N	\N	131691	131691	299257
16885	22099	108	applied	\N	\N	\N	\N	131692	131692	299258
16885	22102	109	applied	\N	\N	\N	\N	131693	131693	299259
16885	22107	110	applied	\N	\N	\N	\N	131694	131694	299260
16885	22085	111	applied	\N	\N	\N	\N	131695	131695	299261
16885	22096	112	applied	\N	\N	\N	\N	131696	131696	299262
16885	22103	113	applied	\N	\N	\N	\N	131697	131697	131697
16885	22108	115	applied	\N	\N	\N	\N	131699	131699	299263
16885	22122	116	applied	\N	\N	\N	\N	131700	131700	299264
16885	22133	117	applied	\N	\N	\N	\N	131701	131701	299265
16885	22140	118	applied	\N	\N	\N	\N	131702	131702	299266
16885	22153	119	applied	\N	\N	\N	\N	131703	131703	299267
16885	22164	120	applied	\N	\N	\N	\N	131704	131704	299268
16885	22175	121	applied	\N	\N	\N	\N	131705	131705	299269
16885	22183	122	applied	\N	\N	\N	\N	131706	131706	299270
16885	22197	123	applied	\N	\N	\N	\N	131707	131707	299271
16885	22209	124	applied	\N	\N	\N	\N	131708	131708	299272
16885	22225	125	applied	\N	\N	\N	\N	131709	131709	299273
16889	21940	12	applied	\N	\N	\N	\N	131731	131731	299295
16889	21943	13	applied	\N	\N	\N	\N	131732	131732	299296
16889	21946	14	applied	\N	\N	\N	\N	131733	131733	299297
16889	21947	15	applied	\N	\N	\N	\N	131734	131734	299298
16889	21952	16	applied	\N	\N	\N	\N	131735	131735	299299
16889	21959	18	applied	\N	\N	\N	\N	131737	131737	299301
16889	21962	19	applied	\N	\N	\N	\N	131738	131738	299302
16889	21965	20	applied	\N	\N	\N	\N	131739	131739	299303
16889	21966	21	applied	\N	\N	\N	\N	131740	131740	299304
16889	22105	22	applied	\N	\N	\N	\N	131741	131741	299305
16889	22109	23	applied	\N	\N	\N	\N	131742	131742	299306
16889	22128	24	applied	\N	\N	\N	\N	131743	131743	299307
16889	21967	25	applied	\N	\N	\N	\N	131744	131744	299308
16889	21975	26	applied	\N	\N	\N	\N	131745	131745	299309
16889	21976	27	applied	\N	\N	\N	\N	131746	131746	299310
16889	21982	28	applied	\N	\N	\N	\N	131747	131747	299311
16889	21984	29	applied	\N	\N	\N	\N	131748	131748	299312
16889	21985	30	applied	\N	\N	\N	\N	131749	131749	299313
16889	21986	31	applied	\N	\N	\N	\N	131750	131750	299314
16889	21987	32	applied	\N	\N	\N	\N	131751	131751	299315
16889	21988	33	applied	\N	\N	\N	\N	131752	131752	299316
16889	22001	35	applied	\N	\N	\N	\N	131754	131754	299318
16889	22007	36	applied	\N	\N	\N	\N	131755	131755	299319
16889	22008	37	applied	\N	\N	\N	\N	131756	131756	299320
16889	22014	38	applied	\N	\N	\N	\N	131757	131757	299321
16889	22017	39	applied	\N	\N	\N	\N	131758	131758	299322
16889	22019	40	applied	\N	\N	\N	\N	131759	131759	299323
16889	22020	41	applied	\N	\N	\N	\N	131760	131760	299324
16889	22028	42	applied	\N	\N	\N	\N	131761	131761	299325
16889	22031	43	applied	\N	\N	\N	\N	131762	131762	299326
16889	22035	44	applied	\N	\N	\N	\N	131763	131763	299327
16889	22038	45	applied	\N	\N	\N	\N	131764	131764	299328
16889	22040	46	applied	\N	\N	\N	\N	131765	131765	299329
16889	22044	47	applied	\N	\N	\N	\N	131766	131766	299330
16889	22047	48	applied	\N	\N	\N	\N	131767	131767	299331
16889	22048	49	applied	\N	\N	\N	\N	131768	131768	299332
16889	22054	50	applied	\N	\N	\N	\N	131769	131769	299333
16894	22392	1	applied	\N	\N	\N	\N	131858	131858	299422
16894	22393	2	applied	\N	\N	\N	\N	131859	131859	299423
16894	22394	3	applied	\N	\N	\N	\N	131860	131860	299424
16896	22395	0	applied	\N	\N	\N	\N	131865	131865	299429
16896	22396	1	applied	\N	\N	\N	\N	131866	131866	299430
16896	22397	2	applied	\N	\N	\N	\N	131867	131867	299431
16896	22398	3	applied	\N	\N	\N	\N	131868	131868	299432
16896	22399	4	applied	\N	\N	\N	\N	131869	131869	299433
16896	22400	5	applied	\N	\N	\N	\N	131870	131870	299434
16896	22401	6	applied	\N	\N	\N	\N	131871	131871	299435
16900	22395	0	applied	\N	\N	\N	\N	131877	131877	299441
16900	22396	1	applied	\N	\N	\N	\N	131878	131878	299442
16900	22397	2	applied	\N	\N	\N	\N	131879	131879	299443
16900	22398	3	applied	\N	\N	\N	\N	131880	131880	299444
16900	22399	4	applied	\N	\N	\N	\N	131881	131881	299445
16900	22400	5	applied	\N	\N	\N	\N	131882	131882	299446
16905	22408	0	applied	\N	\N	\N	\N	131898	131898	299462
16905	22409	1	applied	\N	\N	\N	\N	131899	131899	299463
16905	22410	2	applied	\N	\N	\N	\N	131900	131900	299464
16908	22421	0	applied	\N	\N	\N	\N	131914	131914	299478
16908	22422	1	applied	\N	\N	\N	\N	131915	131915	299479
16908	22423	2	applied	\N	\N	\N	\N	131916	131916	299480
16908	22424	3	applied	\N	\N	\N	\N	131917	131917	299481
16908	22425	4	applied	\N	\N	\N	\N	131918	131918	299482
16908	22426	5	applied	\N	\N	\N	\N	131919	131919	299483
16908	22427	6	applied	\N	\N	\N	\N	131920	131920	299484
16919	22434	0	applied	\N	\N	\N	\N	131967	131967	299531
16919	22435	1	applied	\N	\N	\N	\N	131968	131968	299532
16919	22436	2	applied	\N	\N	\N	\N	131969	131969	299533
16919	22437	3	applied	\N	\N	\N	\N	131970	131970	299534
16922	22434	0	applied	\N	\N	\N	\N	131979	131979	299543
16922	22435	1	applied	\N	\N	\N	\N	131980	131980	299544
16922	22437	3	applied	\N	\N	\N	\N	131982	131982	299546
16932	22460	0	applied	\N	\N	\N	\N	132048	132048	299612
16932	22461	1	applied	\N	\N	\N	\N	132049	132049	299613
16932	22462	2	applied	\N	\N	\N	\N	132050	132050	299614
16938	22468	0	applied	\N	\N	\N	\N	132073	132073	299637
16938	22469	1	applied	\N	\N	\N	\N	132074	132074	299638
16938	22470	2	applied	\N	\N	\N	\N	132075	132075	299639
16938	22471	3	applied	\N	\N	\N	\N	132076	132076	299640
16938	22472	4	applied	\N	\N	\N	\N	132077	132077	299641
16938	22473	5	applied	\N	\N	\N	\N	132078	132078	299642
16938	22474	6	applied	\N	\N	\N	\N	132079	132079	299643
16939	22475	0	applied	\N	\N	\N	\N	132080	132080	299644
16939	22476	1	applied	\N	\N	\N	\N	132081	132081	299645
16939	22477	2	applied	\N	\N	\N	\N	132082	132082	299646
16885	22221	95	applied	\N	\N	\N	\N	131679	131679	299245
16885	22222	96	applied	\N	\N	\N	\N	131680	131680	299246
16889	22070	55	applied	\N	\N	\N	\N	131774	131774	299338
16889	22073	56	applied	\N	\N	\N	\N	131775	131775	299339
16889	22074	57	applied	\N	\N	\N	\N	131776	131776	299340
16889	22080	58	applied	\N	\N	\N	\N	131777	131777	299341
16889	22083	59	applied	\N	\N	\N	\N	131778	131778	299342
16889	22087	60	applied	\N	\N	\N	\N	131779	131779	299343
16889	22088	61	applied	\N	\N	\N	\N	131780	131780	299344
16889	22092	62	applied	\N	\N	\N	\N	131781	131781	299345
16889	22095	63	applied	\N	\N	\N	\N	131782	131782	299346
16889	22097	64	applied	\N	\N	\N	\N	131783	131783	299347
16889	22100	65	applied	\N	\N	\N	\N	131784	131784	299348
16889	22104	66	applied	\N	\N	\N	\N	131785	131785	299349
16889	22110	67	applied	\N	\N	\N	\N	131786	131786	299350
16889	22111	68	applied	\N	\N	\N	\N	131787	131787	299351
16889	22118	70	applied	\N	\N	\N	\N	131789	131789	299353
16889	22119	71	applied	\N	\N	\N	\N	131790	131790	299354
16889	22127	72	applied	\N	\N	\N	\N	131791	131791	299355
16889	22131	73	applied	\N	\N	\N	\N	131792	131792	299356
16889	22134	74	applied	\N	\N	\N	\N	131793	131793	299357
16889	22137	75	applied	\N	\N	\N	\N	131794	131794	299358
16889	22143	76	applied	\N	\N	\N	\N	131795	131795	299359
16889	22146	77	applied	\N	\N	\N	\N	131796	131796	299360
16889	22149	78	applied	\N	\N	\N	\N	131797	131797	299361
16889	22151	79	applied	\N	\N	\N	\N	131798	131798	299362
16889	22155	80	applied	\N	\N	\N	\N	131799	131799	299363
16889	22158	81	applied	\N	\N	\N	\N	131800	131800	299364
16889	22159	82	applied	\N	\N	\N	\N	131801	131801	299365
16889	22165	83	applied	\N	\N	\N	\N	131802	131802	299366
16889	22166	84	applied	\N	\N	\N	\N	131803	131803	299367
16889	22167	85	applied	\N	\N	\N	\N	131804	131804	299368
16889	22178	87	applied	\N	\N	\N	\N	131806	131806	299370
16889	22181	88	applied	\N	\N	\N	\N	131807	131807	299371
16889	22182	89	applied	\N	\N	\N	\N	131808	131808	299372
16889	22188	90	applied	\N	\N	\N	\N	131809	131809	299373
16889	22191	91	applied	\N	\N	\N	\N	131810	131810	299374
16889	22194	92	applied	\N	\N	\N	\N	131811	131811	299375
16889	22195	93	applied	\N	\N	\N	\N	131812	131812	299376
16889	22201	94	applied	\N	\N	\N	\N	131813	131813	299377
16889	22204	95	applied	\N	\N	\N	\N	131814	131814	299378
16889	22207	96	applied	\N	\N	\N	\N	131815	131815	299379
16889	22210	97	applied	\N	\N	\N	\N	131816	131816	299380
16889	22214	98	applied	\N	\N	\N	\N	131817	131817	299381
16889	22218	99	applied	\N	\N	\N	\N	131818	131818	299382
16889	22219	100	applied	\N	\N	\N	\N	131819	131819	299383
16889	22228	101	applied	\N	\N	\N	\N	131820	131820	299384
16889	22231	102	applied	\N	\N	\N	\N	131821	131821	299385
16889	22238	105	applied	\N	\N	\N	\N	131823	131823	299387
16889	22241	106	applied	\N	\N	\N	\N	131824	131824	299388
16889	22243	107	applied	\N	\N	\N	\N	131825	131825	299389
16889	22246	108	applied	\N	\N	\N	\N	131826	131826	299390
16889	22247	109	applied	\N	\N	\N	\N	131827	131827	299391
16889	22248	110	applied	\N	\N	\N	\N	131828	131828	299392
16889	22257	111	applied	\N	\N	\N	\N	131829	131829	299393
16889	22259	112	applied	\N	\N	\N	\N	131830	131830	299394
16889	22261	113	applied	\N	\N	\N	\N	131831	131831	299395
16889	22266	114	applied	\N	\N	\N	\N	131832	131832	299396
16889	22268	115	applied	\N	\N	\N	\N	131833	131833	299397
16889	22271	116	applied	\N	\N	\N	\N	131834	131834	299398
16889	22273	117	applied	\N	\N	\N	\N	131835	131835	299399
16889	22277	118	applied	\N	\N	\N	\N	131836	131836	299400
16889	22280	119	applied	\N	\N	\N	\N	131837	131837	299401
16889	22283	120	applied	\N	\N	\N	\N	131838	131838	299402
16889	22289	122	applied	\N	\N	\N	\N	131840	131840	299404
16889	22292	123	applied	\N	\N	\N	\N	131841	131841	299405
16889	22293	124	applied	\N	\N	\N	\N	131842	131842	299406
16889	22299	125	applied	\N	\N	\N	\N	131843	131843	299407
16891	22386	1	applied	\N	\N	\N	\N	131848	131848	299412
16891	22387	2	applied	\N	\N	\N	\N	131849	131849	299413
16893	22391	0	applied	\N	\N	\N	\N	131853	131853	299417
16893	22392	1	applied	\N	\N	\N	\N	131854	131854	299418
16893	22393	2	applied	\N	\N	\N	\N	131855	131855	299419
16893	22394	3	applied	\N	\N	\N	\N	131856	131856	299420
16898	22397	0	applied	\N	\N	\N	\N	131875	131875	299439
16899	22397	0	applied	\N	\N	\N	\N	131876	131876	299440
16901	22397	0	applied	\N	\N	\N	\N	131884	131884	299448
16902	22395	0	applied	\N	\N	\N	\N	131885	131885	299449
16902	22396	1	applied	\N	\N	\N	\N	131886	131886	299450
16904	22405	0	applied	\N	\N	\N	\N	131895	131895	299459
16904	22407	2	applied	\N	\N	\N	\N	131897	131897	299461
16906	22408	0	applied	\N	\N	\N	\N	131901	131901	299465
16906	22409	1	applied	\N	\N	\N	\N	131902	131902	299466
16906	22410	2	applied	\N	\N	\N	\N	131903	131903	299467
16910	22421	0	applied	\N	\N	\N	\N	131928	131928	299492
16910	22422	1	applied	\N	\N	\N	\N	131929	131929	299493
16910	22423	2	applied	\N	\N	\N	\N	131930	131930	299494
16910	22424	3	applied	\N	\N	\N	\N	131931	131931	299495
16910	22425	4	applied	\N	\N	\N	\N	131932	131932	299496
16910	22426	5	applied	\N	\N	\N	\N	131933	131933	299497
16910	22427	6	applied	\N	\N	\N	\N	131934	131934	299498
16916	22428	0	applied	\N	\N	\N	\N	131958	131958	299522
16916	22429	1	applied	\N	\N	\N	\N	131959	131959	299523
16916	22430	2	applied	\N	\N	\N	\N	131960	131960	299524
16918	22431	0	applied	\N	\N	\N	\N	131964	131964	299528
16918	22432	1	applied	\N	\N	\N	\N	131965	131965	299529
16924	22438	0	applied	\N	\N	\N	\N	131987	131987	299551
16924	22439	1	applied	\N	\N	\N	\N	131988	131988	299552
16924	22440	2	applied	\N	\N	\N	\N	131989	131989	299553
16924	22441	3	applied	\N	\N	\N	\N	131990	131990	299554
16924	22442	4	applied	\N	\N	\N	\N	131991	131991	299555
16924	22443	5	applied	\N	\N	\N	\N	131992	131992	299556
16924	22444	6	applied	\N	\N	\N	\N	131993	131993	299557
16924	22445	7	applied	\N	\N	\N	\N	131994	131994	299558
16924	22446	8	applied	\N	\N	\N	\N	131995	131995	299559
16924	22447	9	applied	\N	\N	\N	\N	131996	131996	299560
16924	22448	10	applied	\N	\N	\N	\N	131997	131997	299561
16924	22449	11	applied	\N	\N	\N	\N	131998	131998	299562
16926	22450	0	applied	\N	\N	\N	\N	132011	132011	299575
16926	22451	1	applied	\N	\N	1000000000	\N	132012	132012	299576
16926	22452	2	applied	\N	\N	\N	\N	132013	132013	299577
16926	22453	3	applied	\N	\N	\N	\N	132014	132014	299578
16889	22067	54	applied	\N	\N	\N	\N	131773	131773	299337
16902	22404	6	applied	\N	\N	\N	\N	131891	131891	299455
16907	22411	0	applied	\N	\N	\N	\N	131904	131904	299468
16907	22412	1	applied	\N	\N	\N	\N	131905	131905	299469
16907	22413	2	applied	\N	\N	\N	\N	131906	131906	299470
16907	22414	3	applied	\N	\N	\N	\N	131907	131907	299471
16907	22415	4	applied	\N	\N	\N	\N	131908	131908	299472
16907	22416	5	applied	\N	\N	\N	\N	131909	131909	299473
16907	22417	6	applied	\N	\N	\N	\N	131910	131910	299474
16907	22418	7	applied	\N	\N	\N	\N	131911	131911	299475
16907	22419	8	applied	\N	\N	\N	\N	131912	131912	299476
16907	22420	9	applied	\N	\N	\N	\N	131913	131913	299477
16911	22421	0	applied	\N	\N	\N	\N	131935	131935	299499
16911	22422	1	applied	\N	\N	\N	\N	131936	131936	299500
16911	22423	2	applied	\N	\N	\N	\N	131937	131937	299501
16911	22425	4	applied	\N	\N	\N	\N	131939	131939	299503
16911	22426	5	applied	\N	\N	\N	\N	131940	131940	299504
16911	22427	6	applied	\N	\N	\N	\N	131941	131941	299505
16913	22428	0	applied	\N	\N	\N	\N	131949	131949	299513
16913	22429	1	applied	\N	\N	\N	\N	131950	131950	299514
16913	22430	2	applied	\N	\N	\N	\N	131951	131951	299515
16915	22428	0	applied	\N	\N	\N	\N	131955	131955	299519
16915	22429	1	applied	\N	\N	\N	\N	131956	131956	299520
16915	22430	2	applied	\N	\N	\N	\N	131957	131957	299521
16921	22434	0	applied	\N	\N	\N	\N	131975	131975	299539
16921	22435	1	applied	\N	\N	\N	\N	131976	131976	299540
16921	22436	2	applied	\N	\N	\N	\N	131977	131977	299541
16921	22437	3	applied	\N	\N	\N	\N	131978	131978	299542
16925	22438	0	applied	\N	\N	\N	\N	131999	131999	299563
16925	22439	1	applied	\N	\N	\N	\N	132000	132000	299564
16925	22440	2	applied	\N	\N	\N	\N	132001	132001	299565
16925	22442	4	applied	\N	\N	\N	\N	132003	132003	299567
16925	22443	5	applied	\N	\N	\N	\N	132004	132004	299568
16925	22444	6	applied	\N	\N	\N	\N	132005	132005	299569
16925	22445	7	applied	\N	\N	\N	\N	132006	132006	299570
16931	22460	0	applied	\N	\N	\N	\N	132045	132045	299609
16931	22461	1	applied	\N	\N	\N	\N	132046	132046	299610
16931	22462	2	applied	\N	\N	\N	\N	132047	132047	299611
16933	22463	0	applied	\N	\N	\N	\N	132051	132051	299615
16933	22464	1	applied	\N	\N	\N	\N	132052	132052	299616
16933	22465	2	applied	\N	\N	\N	\N	132053	132053	299617
16936	22468	0	applied	\N	\N	\N	\N	132059	132059	299623
16936	22469	1	applied	\N	\N	\N	\N	132060	132060	299624
16936	22470	2	applied	\N	\N	\N	\N	132061	132061	299625
16936	22471	3	applied	\N	\N	\N	\N	132062	132062	299626
16936	22472	4	applied	\N	\N	\N	\N	132063	132063	299627
16936	22473	5	applied	\N	\N	\N	\N	132064	132064	299628
16941	22478	0	applied	\N	\N	\N	\N	132086	132086	299650
16941	22479	1	applied	\N	\N	\N	\N	132087	132087	299651
16941	22480	2	applied	\N	\N	\N	\N	132088	132088	299652
16943	22481	0	applied	\N	\N	\N	\N	132090	132090	299654
16946	22482	0	applied	\N	\N	\N	\N	132095	132095	299659
16946	22483	1	applied	\N	\N	\N	\N	132096	132096	299660
16947	22302	0	applied	\N	\N	\N	\N	132097	132097	299661
16947	22305	1	applied	\N	\N	\N	\N	132098	132098	299662
16947	22309	2	applied	\N	\N	\N	\N	132099	132099	299663
16947	22312	3	applied	\N	\N	\N	\N	132100	132100	299664
16947	22315	4	applied	\N	\N	\N	\N	132101	132101	299665
16947	22451	5	applied	\N	\N	1000000000	\N	132102	132102	299666
16947	22316	6	applied	\N	\N	\N	\N	132103	132103	299667
16947	22322	7	applied	\N	\N	\N	\N	132104	132104	299668
16947	22325	8	applied	\N	\N	\N	\N	132105	132105	299669
16947	22329	9	applied	\N	\N	\N	\N	132106	132106	299670
16947	22331	11	applied	\N	\N	\N	\N	132108	132108	299672
16947	22332	12	applied	\N	\N	\N	\N	132109	132109	299673
16947	22342	13	applied	\N	\N	\N	\N	132110	132110	299674
16947	22344	14	applied	\N	\N	\N	\N	132111	132111	299675
16947	22348	15	applied	\N	\N	\N	\N	132112	132112	299676
16947	22349	16	applied	\N	\N	\N	\N	132113	132113	299677
16947	22350	17	applied	\N	\N	\N	\N	132114	132114	299678
16947	22357	18	applied	\N	\N	\N	\N	132115	132115	299679
16947	22361	19	applied	\N	\N	\N	\N	132116	132116	299680
16947	22362	20	applied	\N	\N	\N	\N	132117	132117	299681
16947	22363	21	applied	\N	\N	\N	\N	132118	132118	299682
16947	22372	22	applied	\N	\N	\N	\N	132119	132119	299683
16947	22375	23	applied	\N	\N	\N	\N	132120	132120	299684
16947	22378	24	applied	\N	\N	\N	\N	132121	132121	299685
16947	22382	25	applied	\N	\N	\N	\N	132122	132122	299686
16947	22385	26	applied	\N	\N	\N	\N	132123	132123	299687
16947	22391	28	applied	\N	\N	\N	\N	132125	132125	299689
16947	22395	29	applied	\N	\N	\N	\N	132126	132126	299690
16947	22396	30	applied	\N	\N	\N	\N	132127	132127	299691
16947	22402	31	applied	\N	\N	\N	\N	132128	132128	299692
16947	22405	32	applied	\N	\N	\N	\N	132129	132129	299693
16947	22408	33	applied	\N	\N	\N	\N	132130	132130	299694
16947	22411	34	applied	\N	\N	\N	\N	132131	132131	299695
16947	22397	35	applied	\N	\N	\N	\N	132132	132132	299696
16947	22412	36	applied	\N	\N	\N	\N	132133	132133	299697
16947	22413	37	applied	\N	\N	\N	\N	132134	132134	299698
16947	22421	38	applied	\N	\N	\N	\N	132135	132135	299699
16947	22422	39	applied	\N	\N	\N	\N	132136	132136	299700
16947	22428	40	applied	\N	\N	\N	\N	132137	132137	299701
16947	22431	41	applied	\N	\N	\N	\N	132138	132138	299702
16947	22434	42	applied	\N	\N	\N	\N	132139	132139	299703
16947	22438	43	applied	\N	\N	\N	\N	132140	132140	299704
16947	22440	45	applied	\N	\N	\N	\N	132142	132142	299706
16947	22441	46	applied	\N	\N	\N	\N	132143	132143	299707
16947	22450	47	applied	\N	\N	\N	\N	132144	132144	299708
16947	22454	48	applied	\N	\N	\N	\N	132145	132145	299709
16947	22460	49	applied	\N	\N	\N	\N	132146	132146	299710
16947	22463	50	applied	\N	\N	\N	\N	132147	132147	299711
16947	22466	51	applied	\N	\N	\N	\N	132148	132148	299712
16947	22468	52	applied	\N	\N	\N	\N	132149	132149	299713
16947	22469	53	applied	\N	\N	\N	\N	132150	132150	299714
16947	22475	54	applied	\N	\N	\N	\N	132151	132151	299715
16947	22478	55	applied	\N	\N	\N	\N	132152	132152	299716
16947	22481	56	applied	\N	\N	\N	\N	132153	132153	299717
16947	22482	57	applied	\N	\N	\N	\N	132154	132154	299718
16947	22220	58	applied	\N	\N	\N	\N	132155	132155	299719
16947	22221	59	applied	\N	\N	\N	\N	132156	132156	299720
16947	22222	60	applied	\N	\N	\N	\N	132157	132157	299721
16902	22399	5	applied	\N	\N	\N	\N	131890	131890	299454
16912	22427	6	applied	\N	\N	\N	\N	131948	131948	299512
16914	22428	0	applied	\N	\N	\N	\N	131952	131952	299516
16914	22429	1	applied	\N	\N	\N	\N	131953	131953	299517
16914	22430	2	applied	\N	\N	\N	\N	131954	131954	299518
16917	22431	0	applied	\N	\N	\N	\N	131961	131961	299525
16917	22432	1	applied	\N	\N	\N	\N	131962	131962	299526
16917	22433	2	applied	\N	\N	\N	\N	131963	131963	299527
16920	22435	1	applied	\N	\N	\N	\N	131972	131972	299536
16920	22436	2	applied	\N	\N	\N	\N	131973	131973	299537
16920	22437	3	applied	\N	\N	\N	\N	131974	131974	299538
16923	22434	0	applied	\N	\N	\N	\N	131983	131983	299547
16923	22435	1	applied	\N	\N	\N	\N	131984	131984	299548
16923	22436	2	applied	\N	\N	\N	\N	131985	131985	299549
16923	22437	3	applied	\N	\N	\N	\N	131986	131986	299550
16925	22446	8	applied	\N	\N	\N	\N	132007	132007	299571
16925	22447	9	applied	\N	\N	\N	\N	132008	132008	299572
16925	22448	10	applied	\N	\N	\N	\N	132009	132009	299573
16925	22449	11	applied	\N	\N	\N	\N	132010	132010	299574
16927	22454	0	applied	\N	\N	\N	\N	132015	132015	299579
16927	22455	1	applied	\N	\N	\N	\N	132016	132016	299580
16927	22456	2	applied	\N	\N	\N	\N	132017	132017	299581
16928	22454	0	applied	\N	\N	\N	\N	132018	132018	299582
16928	22455	1	applied	\N	\N	\N	\N	132019	132019	299583
16929	22451	0	applied	\N	\N	1000000000	\N	132021	132021	299585
16929	22438	1	applied	\N	\N	\N	\N	132022	132022	299586
16929	22439	2	applied	\N	\N	\N	\N	132023	132023	299587
16929	22440	3	applied	\N	\N	\N	\N	132024	132024	299588
16929	22441	4	applied	\N	\N	\N	\N	132025	132025	299589
16929	22450	5	applied	\N	\N	\N	\N	132026	132026	299590
16929	22454	6	applied	\N	\N	\N	\N	132027	132027	299591
16929	22442	7	applied	\N	\N	\N	\N	132028	132028	299592
16929	22443	8	applied	\N	\N	\N	\N	132029	132029	299593
16929	22444	9	applied	\N	\N	\N	\N	132030	132030	299594
16929	22445	10	applied	\N	\N	\N	\N	132031	132031	299595
16929	22446	11	applied	\N	\N	\N	\N	132032	132032	299596
16929	22457	12	applied	\N	\N	\N	\N	132033	132033	299597
16929	22447	13	applied	\N	\N	\N	\N	132034	132034	299598
16929	22448	14	applied	\N	\N	\N	\N	132035	132035	299599
16929	22452	15	applied	\N	\N	\N	\N	132036	132036	299600
16929	22449	17	applied	\N	\N	\N	\N	132038	132038	299602
16929	22453	18	applied	\N	\N	\N	\N	132039	132039	299603
16929	22456	19	applied	\N	\N	\N	\N	132040	132040	299604
16929	22458	20	applied	\N	\N	\N	\N	132041	132041	299605
16930	22457	0	applied	\N	\N	\N	\N	132042	132042	299606
16930	22459	1	applied	\N	\N	\N	\N	132043	132043	299607
16930	22458	2	applied	\N	\N	\N	\N	132044	132044	299608
16934	22463	0	applied	\N	\N	\N	\N	132054	132054	299618
16934	22464	1	applied	\N	\N	\N	\N	132055	132055	299619
16934	22465	2	applied	\N	\N	\N	\N	132056	132056	299620
16935	22466	0	applied	\N	\N	\N	\N	132057	132057	299621
16935	22467	1	applied	\N	\N	\N	\N	132058	132058	299622
16937	22468	0	applied	\N	\N	\N	\N	132066	132066	299630
16937	22469	1	applied	\N	\N	\N	\N	132067	132067	299631
16937	22470	2	applied	\N	\N	\N	\N	132068	132068	299632
16937	22471	3	applied	\N	\N	\N	\N	132069	132069	299633
16937	22473	5	applied	\N	\N	\N	\N	132071	132071	299635
16937	22474	6	applied	\N	\N	\N	\N	132072	132072	299636
16940	22478	0	applied	\N	\N	\N	\N	132083	132083	299647
16940	22479	1	applied	\N	\N	\N	\N	132084	132084	299648
16940	22480	2	applied	\N	\N	\N	\N	132085	132085	299649
16942	22481	0	applied	\N	\N	\N	\N	132089	132089	299653
16945	22482	0	applied	\N	\N	\N	\N	132093	132093	299657
16945	22483	1	applied	\N	\N	\N	\N	132094	132094	299658
16949	22487	0	applied	\N	\N	\N	\N	132225	132225	299787
16949	22488	1	applied	\N	\N	\N	\N	132226	132226	299788
16951	22489	0	applied	\N	\N	\N	\N	132227	132227	299789
16951	22490	1	applied	\N	\N	\N	\N	132228	132228	299790
16951	22491	2	applied	\N	\N	\N	\N	132229	132229	299791
16951	22492	3	applied	\N	\N	\N	\N	132230	132230	299792
16951	22493	4	applied	\N	\N	\N	\N	132231	132231	299793
16953	22494	0	applied	\N	\N	\N	\N	132232	132232	299794
16953	22496	2	applied	\N	\N	\N	\N	132234	132234	299796
16953	22497	3	applied	\N	\N	\N	\N	132235	132235	299797
16956	22498	0	applied	\N	\N	\N	\N	132246	132246	299808
16956	22499	1	applied	\N	\N	\N	\N	132247	132247	299809
16956	22500	2	applied	\N	\N	1000000000	\N	132248	132248	299810
16956	22501	3	applied	\N	\N	\N	\N	132249	132249	299811
16956	22502	4	applied	\N	\N	\N	\N	132250	132250	299812
16956	22503	5	applied	\N	\N	\N	\N	132251	132251	299813
16958	22498	0	applied	\N	\N	\N	\N	132258	132258	299820
16958	22499	1	applied	\N	\N	\N	\N	132259	132259	299821
16958	22500	2	applied	\N	\N	1000000000	\N	132260	132260	299822
16958	22501	3	applied	\N	\N	\N	\N	132261	132261	299823
16958	22502	4	applied	\N	\N	\N	\N	132262	132262	299824
16958	22503	5	applied	\N	\N	\N	\N	132263	132263	299825
16960	22506	0	applied	\N	\N	\N	\N	132266	132266	299828
16963	22510	0	applied	\N	\N	\N	\N	132273	132273	299835
16963	22512	2	applied	\N	\N	\N	\N	132275	132275	299837
16963	22513	3	applied	\N	\N	\N	\N	132276	132276	299838
16963	22514	4	applied	\N	\N	\N	\N	132277	132277	299839
16963	22515	5	applied	\N	\N	\N	\N	132278	132278	299840
16966	22510	0	applied	\N	\N	\N	\N	132293	132293	299855
16966	22511	1	applied	\N	\N	\N	\N	132294	132294	299856
16966	22512	2	applied	\N	\N	\N	\N	132295	132295	299857
16966	22513	3	applied	\N	\N	\N	\N	132296	132296	299858
16966	22514	4	applied	\N	\N	\N	\N	132297	132297	299859
16966	22515	5	applied	\N	\N	\N	\N	132298	132298	299860
16969	22451	0	applied	\N	\N	1000000000	\N	132311	132311	299873
16969	22500	1	applied	\N	\N	1000000000	\N	132312	132312	299874
16969	22397	2	applied	\N	\N	\N	\N	132313	132313	299875
16975	22519	0	applied	\N	\N	\N	\N	132326	132326	299888
16975	22520	1	applied	\N	\N	\N	\N	132327	132327	299889
16985	22527	0	applied	\N	\N	\N	\N	132346	132346	299908
16985	22529	2	applied	\N	\N	\N	\N	132348	132348	299910
16985	22530	3	applied	\N	\N	\N	\N	132349	132349	299911
16985	22531	4	applied	\N	\N	\N	\N	132350	132350	299912
16991	22536	0	applied	\N	\N	\N	\N	132364	132364	299926
16991	22537	1	applied	\N	\N	\N	\N	132365	132365	299927
16991	22538	2	applied	\N	\N	\N	\N	132366	132366	299928
16912	22425	4	applied	\N	\N	\N	\N	131946	131946	299510
16912	22426	5	applied	\N	\N	\N	\N	131947	131947	299511
16948	22485	1	applied	\N	\N	\N	\N	132223	132223	299785
16948	22486	2	applied	\N	\N	\N	\N	132224	132224	299786
16954	22494	0	applied	\N	\N	\N	\N	132236	132236	299798
16954	22496	2	applied	\N	\N	\N	\N	132238	132238	299800
16954	22497	3	applied	\N	\N	\N	\N	132239	132239	299801
16957	22498	0	applied	\N	\N	\N	\N	132252	132252	299814
16957	22499	1	applied	\N	\N	\N	\N	132253	132253	299815
16957	22500	2	applied	\N	\N	1000000000	\N	132254	132254	299816
16957	22501	3	applied	\N	\N	\N	\N	132255	132255	299817
16957	22502	4	applied	\N	\N	\N	\N	132256	132256	299818
16957	22503	5	applied	\N	\N	\N	\N	132257	132257	299819
16961	22507	0	applied	\N	\N	\N	\N	132267	132267	299829
16961	22508	1	applied	\N	\N	\N	\N	132268	132268	299830
16961	22509	2	applied	\N	\N	\N	\N	132269	132269	299831
16964	22213	0	applied	\N	\N	1000000000	\N	132279	132279	299841
16964	22451	1	applied	\N	\N	1000000000	\N	132280	132280	299842
16964	22500	2	applied	\N	\N	1000000000	\N	132281	132281	299843
16964	22397	3	applied	\N	\N	\N	\N	132282	132282	299844
16964	22220	4	applied	\N	\N	\N	\N	132283	132283	299845
16964	22222	6	applied	\N	\N	\N	\N	132285	132285	299847
16964	22223	7	applied	\N	\N	\N	\N	132286	132286	299848
16967	22510	0	applied	\N	\N	\N	\N	132299	132299	299861
16967	22511	1	applied	\N	\N	\N	\N	132300	132300	299862
16967	22512	2	applied	\N	\N	\N	\N	132301	132301	299863
16967	22513	3	applied	\N	\N	\N	\N	132302	132302	299864
16967	22514	4	applied	\N	\N	\N	\N	132303	132303	299865
16967	22515	5	applied	\N	\N	\N	\N	132304	132304	299866
16970	22516	0	applied	\N	\N	\N	\N	132314	132314	299876
16970	22517	1	applied	\N	\N	\N	\N	132315	132315	299877
16970	22518	2	applied	\N	\N	\N	\N	132316	132316	299878
16972	22519	0	applied	\N	\N	\N	\N	132320	132320	299882
16972	22520	1	applied	\N	\N	\N	\N	132321	132321	299883
16973	22519	0	applied	\N	\N	\N	\N	132322	132322	299884
16973	22520	1	applied	\N	\N	\N	\N	132323	132323	299885
16976	22519	0	applied	\N	\N	\N	\N	132328	132328	299890
16978	22521	0	applied	\N	\N	\N	\N	132330	132330	299892
16980	22522	0	applied	\N	\N	\N	\N	132332	132332	299894
16980	22523	1	applied	\N	\N	\N	\N	132333	132333	299895
16980	22524	2	applied	\N	\N	\N	\N	132334	132334	299896
16981	22525	0	applied	\N	\N	\N	\N	132335	132335	299897
16981	22526	1	applied	\N	\N	\N	\N	132336	132336	299898
16983	22525	0	applied	\N	\N	\N	\N	132339	132339	299901
16983	22526	1	applied	\N	\N	\N	\N	132340	132340	299902
16986	22527	0	applied	\N	\N	\N	\N	132351	132351	299913
16986	22528	1	applied	\N	\N	\N	\N	132352	132352	299914
16988	22532	0	applied	\N	\N	\N	\N	132358	132358	299920
16988	22533	1	applied	\N	\N	\N	\N	132359	132359	299921
16990	22534	0	applied	\N	\N	\N	\N	132362	132362	299924
16990	22535	1	applied	\N	\N	\N	\N	132363	132363	299925
16999	22546	0	applied	\N	\N	\N	\N	132374	132374	299936
16999	22547	1	applied	\N	\N	\N	\N	132375	132375	299937
17001	22547	1	applied	\N	\N	\N	\N	132379	132379	299941
17004	22553	0	applied	\N	\N	\N	\N	132385	132385	299947
17004	22554	1	applied	\N	\N	\N	\N	132386	132386	299948
17004	22555	2	applied	\N	\N	\N	\N	132387	132387	299949
17004	22556	3	applied	\N	\N	\N	\N	132388	132388	299950
17012	22573	0	applied	\N	\N	\N	\N	132418	132418	299980
17012	22574	1	applied	\N	\N	\N	\N	132419	132419	299981
17017	22585	0	applied	\N	\N	\N	\N	132435	132435	299997
17017	22586	1	applied	\N	\N	\N	\N	132436	132436	299998
17017	22587	2	applied	\N	\N	\N	\N	132437	132437	299999
17029	22598	0	applied	\N	\N	\N	\N	132591	132591	300153
17029	22599	1	applied	\N	\N	\N	\N	132592	132592	300154
17033	22600	0	applied	\N	\N	\N	\N	132601	132601	300163
17033	22598	1	applied	\N	\N	\N	\N	132602	132602	300164
17033	22601	2	applied	\N	\N	\N	\N	132603	132603	300165
17033	22602	3	applied	\N	\N	\N	\N	132604	132604	300166
17036	22604	1	applied	\N	\N	\N	\N	132611	132611	300173
17036	22602	2	applied	\N	\N	\N	\N	132612	132612	300174
17038	22605	0	applied	\N	\N	\N	\N	132616	132616	300178
17038	22606	1	applied	\N	\N	\N	\N	132617	132617	300179
17038	22607	2	applied	\N	\N	\N	\N	132618	132618	300180
17040	22612	0	applied	\N	\N	\N	\N	132623	132623	300185
17040	22613	1	applied	\N	\N	\N	\N	132624	132624	300186
17040	22614	2	applied	\N	\N	\N	\N	132625	132625	300187
17043	22621	0	applied	\N	\N	\N	\N	132632	132632	300194
17043	22622	1	applied	\N	\N	\N	\N	132633	132633	300195
17043	22623	2	applied	\N	\N	\N	\N	132634	132634	300196
17043	22624	3	applied	\N	\N	\N	\N	132635	132635	300197
17043	22625	4	applied	\N	\N	\N	\N	132636	132636	300198
17043	22626	5	applied	\N	\N	\N	\N	132637	132637	300199
17050	22634	0	applied	\N	\N	\N	\N	132657	132657	300219
17050	22635	1	applied	\N	\N	\N	\N	132658	132658	300220
17052	22388	0	applied	\N	\N	\N	\N	132663	132663	300225
17052	22391	1	applied	\N	\N	\N	\N	132664	132664	300226
17052	22451	2	applied	\N	\N	1000000000	\N	132665	132665	300227
17052	22500	3	applied	\N	\N	1000000000	\N	132666	132666	300228
17052	22570	4	applied	\N	\N	1000000000	\N	132667	132667	300229
17052	22395	5	applied	\N	\N	\N	\N	132668	132668	300230
17052	22396	6	applied	\N	\N	\N	\N	132669	132669	300231
17052	22402	7	applied	\N	\N	\N	\N	132670	132670	300232
17052	22405	8	applied	\N	\N	\N	\N	132671	132671	300233
17052	22408	9	applied	\N	\N	\N	\N	132672	132672	300234
17052	22411	10	applied	\N	\N	\N	\N	132673	132673	300235
17052	22397	11	applied	\N	\N	\N	\N	132674	132674	300236
17052	22412	12	applied	\N	\N	\N	\N	132675	132675	300237
17052	22413	13	applied	\N	\N	\N	\N	132676	132676	300238
17052	22421	14	applied	\N	\N	\N	\N	132677	132677	300239
17052	22422	15	applied	\N	\N	\N	\N	132678	132678	300240
17052	22431	17	applied	\N	\N	\N	\N	132680	132680	300242
17052	22434	18	applied	\N	\N	\N	\N	132681	132681	300243
17052	22438	19	applied	\N	\N	\N	\N	132682	132682	300244
17052	22439	20	applied	\N	\N	\N	\N	132683	132683	300245
17052	22440	21	applied	\N	\N	\N	\N	132684	132684	300246
17052	22441	22	applied	\N	\N	\N	\N	132685	132685	300247
17052	22450	23	applied	\N	\N	\N	\N	132686	132686	300248
17052	22454	24	applied	\N	\N	\N	\N	132687	132687	300249
17052	22460	25	applied	\N	\N	\N	\N	132688	132688	300250
17052	22463	26	applied	\N	\N	\N	\N	132689	132689	300251
16944	22483	1	applied	\N	\N	\N	\N	132092	132092	299656
16948	22484	0	applied	\N	\N	\N	\N	132222	132222	299784
16947	21913	64	applied	\N	\N	\N	\N	132161	132161	299725
16947	21927	65	applied	\N	\N	\N	\N	132162	132162	299726
16947	21938	66	applied	\N	\N	\N	\N	132163	132163	299727
16947	21950	67	applied	\N	\N	\N	\N	132164	132164	299728
16947	21954	68	applied	\N	\N	\N	\N	132165	132165	299729
16947	21968	69	applied	\N	\N	\N	\N	132166	132166	299730
16947	21977	70	applied	\N	\N	\N	\N	132167	132167	299731
16947	21989	71	applied	\N	\N	\N	\N	132168	132168	299732
16947	21915	72	applied	\N	\N	\N	\N	132169	132169	299733
16947	22004	73	applied	\N	\N	\N	\N	132170	132170	299734
16947	21909	74	applied	\N	\N	\N	\N	132171	132171	299735
16947	21910	75	applied	\N	\N	\N	\N	132172	132172	299736
16947	21914	76	applied	\N	\N	\N	\N	132173	132173	299737
16947	22023	78	applied	\N	\N	\N	\N	132175	132175	299739
16947	22034	79	applied	\N	\N	\N	\N	132176	132176	299740
16947	22043	80	applied	\N	\N	\N	\N	132177	132177	299741
16947	22053	81	applied	\N	\N	\N	\N	132178	132178	299742
16947	22062	82	applied	\N	\N	\N	\N	132179	132179	299743
16947	22079	83	applied	\N	\N	\N	\N	132180	132180	299744
16947	22085	84	applied	\N	\N	\N	\N	132181	132181	299745
16947	22096	85	applied	\N	\N	\N	\N	132182	132182	299746
16947	22103	86	applied	\N	\N	\N	\N	132183	132183	132183
16947	22112	87	applied	\N	\N	\N	\N	132184	132184	132184
16947	22108	88	applied	\N	\N	\N	\N	132185	132185	299747
16947	22122	89	applied	\N	\N	\N	\N	132186	132186	299748
16947	22133	90	applied	\N	\N	\N	\N	132187	132187	299749
16947	22140	91	applied	\N	\N	\N	\N	132188	132188	299750
16947	22153	92	applied	\N	\N	\N	\N	132189	132189	299751
16947	21916	93	applied	\N	\N	\N	\N	132190	132190	299752
16947	21923	95	applied	\N	\N	\N	\N	132192	132192	299754
16947	21929	96	applied	\N	\N	\N	\N	132193	132193	299755
16947	21930	97	applied	\N	\N	\N	\N	132194	132194	299756
16947	21934	98	applied	\N	\N	\N	\N	132195	132195	299757
16947	21939	99	applied	\N	\N	\N	\N	132196	132196	299758
16947	21942	100	applied	\N	\N	\N	\N	132197	132197	299759
16986	22529	2	applied	\N	\N	\N	\N	132353	132353	299915
16986	22530	3	applied	\N	\N	\N	\N	132354	132354	299916
16986	22531	4	applied	\N	\N	\N	\N	132355	132355	299917
16987	22532	0	applied	\N	\N	\N	\N	132356	132356	299918
16987	22533	1	applied	\N	\N	\N	\N	132357	132357	299919
16994	22539	0	applied	\N	\N	\N	\N	132367	132367	299929
16994	22540	1	applied	\N	\N	\N	\N	132368	132368	299930
17003	22550	0	applied	\N	\N	\N	\N	132382	132382	299944
17003	22551	1	applied	\N	\N	\N	\N	132383	132383	299945
17003	22552	2	applied	\N	\N	\N	\N	132384	132384	299946
17009	22565	1	applied	\N	\N	\N	\N	132405	132405	299967
17009	22566	2	applied	\N	\N	\N	\N	132406	132406	299968
17009	22567	3	applied	\N	\N	\N	\N	132407	132407	299969
17009	22568	4	applied	\N	\N	\N	\N	132408	132408	299970
17011	22569	0	applied	\N	\N	\N	\N	132414	132414	299976
17011	22570	1	applied	\N	\N	1000000000	\N	132415	132415	299977
17011	22571	2	applied	\N	\N	\N	\N	132416	132416	299978
17011	22572	3	applied	\N	\N	\N	\N	132417	132417	299979
17014	22575	0	applied	\N	\N	\N	\N	132422	132422	299984
17014	22576	1	applied	\N	\N	\N	\N	132423	132423	299985
17014	22577	2	applied	\N	\N	\N	\N	132424	132424	299986
17014	22578	3	applied	\N	\N	\N	\N	132425	132425	299987
17014	22579	4	applied	\N	\N	\N	\N	132426	132426	299988
17014	22580	5	applied	\N	\N	\N	\N	132427	132427	299989
17014	22581	6	applied	\N	\N	\N	\N	132428	132428	299990
17022	22588	0	applied	\N	\N	\N	\N	132458	132458	300020
17022	22590	2	applied	\N	\N	\N	\N	132460	132460	300022
17022	22591	3	applied	\N	\N	\N	\N	132461	132461	300023
17022	22592	4	applied	\N	\N	\N	\N	132462	132462	300024
17022	22593	5	applied	\N	\N	\N	\N	132463	132463	300025
17022	22594	6	applied	\N	\N	\N	\N	132464	132464	300026
17023	22588	0	applied	\N	\N	\N	\N	132465	132465	300027
17023	22589	1	applied	\N	\N	\N	\N	132466	132466	300028
17023	22590	2	applied	\N	\N	\N	\N	132467	132467	300029
17023	22591	3	applied	\N	\N	\N	\N	132468	132468	300030
17023	22592	4	applied	\N	\N	\N	\N	132469	132469	300031
17023	22593	5	applied	\N	\N	\N	\N	132470	132470	300032
17023	22594	6	applied	\N	\N	\N	\N	132471	132471	300033
17026	22595	0	applied	\N	\N	\N	\N	132477	132477	300039
17026	22596	1	applied	\N	\N	\N	\N	132478	132478	300040
17026	22597	2	applied	\N	\N	\N	\N	132479	132479	300041
17028	22598	0	applied	\N	\N	\N	\N	132589	132589	300151
17032	22599	0	applied	\N	\N	\N	\N	132600	132600	300162
17035	22603	0	applied	\N	\N	\N	\N	132607	132607	300169
17035	22604	1	applied	\N	\N	\N	\N	132608	132608	300170
17035	22602	2	applied	\N	\N	\N	\N	132609	132609	300171
17037	22605	0	applied	\N	\N	\N	\N	132613	132613	300175
17037	22606	1	applied	\N	\N	\N	\N	132614	132614	300176
17037	22607	2	applied	\N	\N	\N	\N	132615	132615	300177
17042	22618	0	applied	\N	\N	\N	\N	132629	132629	300191
17042	22619	1	applied	\N	\N	\N	\N	132630	132630	300192
17042	22620	2	applied	\N	\N	\N	\N	132631	132631	300193
17054	22641	0	applied	\N	\N	\N	\N	132790	132790	300352
17054	22640	1	applied	\N	\N	1000000000	\N	132791	132791	300353
17054	22642	2	applied	\N	\N	\N	\N	132792	132792	300354
17054	22643	3	applied	\N	\N	\N	\N	132793	132793	300355
17059	22655	0	applied	\N	\N	\N	\N	132814	132814	300376
17059	22656	1	applied	\N	\N	\N	\N	132815	132815	300377
17062	22661	0	applied	\N	\N	\N	\N	132824	132824	300386
17062	22662	1	applied	\N	\N	\N	\N	132825	132825	300387
17062	22663	2	applied	\N	\N	\N	\N	132826	132826	300388
17062	22664	3	applied	\N	\N	\N	\N	132827	132827	300389
17069	22681	0	applied	\N	\N	\N	\N	132875	132875	300437
17069	22682	1	applied	\N	\N	\N	\N	132876	132876	300438
17069	22683	2	applied	\N	\N	\N	\N	132877	132877	300439
17072	22684	0	applied	\N	\N	\N	\N	132886	132886	300448
17072	22685	1	applied	\N	\N	\N	\N	132887	132887	300449
17072	22687	2	applied	\N	\N	\N	\N	132888	132888	300450
17074	22688	0	applied	\N	\N	\N	\N	132891	132891	300453
17074	22689	1	applied	\N	\N	\N	\N	132892	132892	300454
17078	22693	0	applied	\N	\N	\N	\N	132902	132902	300464
17078	22694	1	applied	\N	\N	\N	\N	132903	132903	300465
17078	22695	2	applied	\N	\N	\N	\N	132904	132904	300466
17082	22715	0	applied	\N	\N	\N	\N	132928	132928	300490
16947	21907	62	applied	\N	\N	\N	\N	132159	132159	299723
16947	21908	63	applied	\N	\N	\N	\N	132160	132160	299724
16947	21958	106	applied	\N	\N	\N	\N	132202	132202	299764
16947	21960	107	applied	\N	\N	\N	\N	132203	132203	299765
16947	21963	108	applied	\N	\N	\N	\N	132204	132204	299766
16947	21972	109	applied	\N	\N	\N	\N	132205	132205	299767
16947	21973	110	applied	\N	\N	\N	\N	132206	132206	299768
16947	21974	111	applied	\N	\N	\N	\N	132207	132207	299769
16947	21978	112	applied	\N	\N	\N	\N	132208	132208	299770
16947	21979	113	applied	\N	\N	\N	\N	132209	132209	299771
16947	21993	114	applied	\N	\N	\N	\N	132210	132210	299772
16947	21994	115	applied	\N	\N	\N	\N	132211	132211	299773
16947	21995	116	applied	\N	\N	\N	\N	132212	132212	299774
16947	21996	117	applied	\N	\N	\N	\N	132213	132213	299775
16947	22164	118	applied	\N	\N	\N	\N	132214	132214	299776
16947	22175	119	applied	\N	\N	\N	\N	132215	132215	299777
16947	22197	121	applied	\N	\N	\N	\N	132217	132217	299779
16947	22209	122	applied	\N	\N	\N	\N	132218	132218	299780
16947	22225	123	applied	\N	\N	\N	\N	132219	132219	299781
16947	22234	124	applied	\N	\N	\N	\N	132220	132220	299782
16947	22245	125	applied	\N	\N	\N	\N	132221	132221	299783
16955	22498	0	applied	\N	\N	\N	\N	132240	132240	299802
16955	22499	1	applied	\N	\N	\N	\N	132241	132241	299803
16955	22500	2	applied	\N	\N	1000000000	\N	132242	132242	299804
16955	22501	3	applied	\N	\N	\N	\N	132243	132243	299805
16955	22502	4	applied	\N	\N	\N	\N	132244	132244	299806
16955	22503	5	applied	\N	\N	\N	\N	132245	132245	299807
16959	22504	0	applied	\N	\N	\N	\N	132264	132264	299826
16959	22505	1	applied	\N	\N	\N	\N	132265	132265	299827
16962	22507	0	applied	\N	\N	\N	\N	132270	132270	299832
16962	22508	1	applied	\N	\N	\N	\N	132271	132271	299833
16962	22509	2	applied	\N	\N	\N	\N	132272	132272	299834
16965	22511	1	applied	\N	\N	\N	\N	132288	132288	299850
16965	22512	2	applied	\N	\N	\N	\N	132289	132289	299851
16965	22513	3	applied	\N	\N	\N	\N	132290	132290	299852
16965	22514	4	applied	\N	\N	\N	\N	132291	132291	299853
16965	22515	5	applied	\N	\N	\N	\N	132292	132292	299854
16968	22510	0	applied	\N	\N	\N	\N	132305	132305	299867
16968	22511	1	applied	\N	\N	\N	\N	132306	132306	299868
16968	22512	2	applied	\N	\N	\N	\N	132307	132307	299869
16968	22513	3	applied	\N	\N	\N	\N	132308	132308	299870
16968	22514	4	applied	\N	\N	\N	\N	132309	132309	299871
16968	22515	5	applied	\N	\N	\N	\N	132310	132310	299872
16971	22516	0	applied	\N	\N	\N	\N	132317	132317	299879
16971	22517	1	applied	\N	\N	\N	\N	132318	132318	299880
16971	22518	2	applied	\N	\N	\N	\N	132319	132319	299881
16974	22519	0	applied	\N	\N	\N	\N	132324	132324	299886
16974	22520	1	applied	\N	\N	\N	\N	132325	132325	299887
16982	22525	0	applied	\N	\N	\N	\N	132337	132337	299899
16982	22526	1	applied	\N	\N	\N	\N	132338	132338	299900
16984	22527	0	applied	\N	\N	\N	\N	132341	132341	299903
16984	22528	1	applied	\N	\N	\N	\N	132342	132342	299904
16984	22529	2	applied	\N	\N	\N	\N	132343	132343	299905
16984	22530	3	applied	\N	\N	\N	\N	132344	132344	299906
16984	22531	4	applied	\N	\N	\N	\N	132345	132345	299907
16989	22532	0	applied	\N	\N	\N	\N	132360	132360	299922
16989	22533	1	applied	\N	\N	\N	\N	132361	132361	299923
16998	22541	0	applied	\N	\N	\N	\N	132369	132369	299931
16998	22542	1	applied	\N	\N	\N	\N	132370	132370	299932
16998	22543	2	applied	\N	\N	\N	\N	132371	132371	299933
16998	22544	3	applied	\N	\N	\N	\N	132372	132372	299934
16998	22545	4	applied	\N	\N	\N	\N	132373	132373	299935
17000	22546	0	applied	\N	\N	\N	\N	132376	132376	299938
17000	22547	1	applied	\N	\N	\N	\N	132377	132377	299939
17002	22549	1	applied	\N	\N	\N	\N	132381	132381	299943
17005	22553	0	applied	\N	\N	\N	\N	132389	132389	299951
17005	22554	1	applied	\N	\N	\N	\N	132390	132390	299952
17005	22555	2	applied	\N	\N	\N	\N	132391	132391	299953
17005	22556	3	applied	\N	\N	\N	\N	132392	132392	299954
17006	22553	0	applied	\N	\N	\N	\N	132393	132393	299955
17006	22554	1	applied	\N	\N	\N	\N	132394	132394	299956
17006	22555	2	applied	\N	\N	\N	\N	132395	132395	299957
17006	22556	3	applied	\N	\N	\N	\N	132396	132396	299958
17007	22557	0	applied	\N	\N	\N	\N	132397	132397	299959
17007	22558	1	applied	\N	\N	\N	\N	132398	132398	299960
17007	22559	2	applied	\N	\N	\N	\N	132399	132399	299961
17007	22560	3	applied	\N	\N	\N	\N	132400	132400	299962
17007	22561	4	applied	\N	\N	\N	\N	132401	132401	299963
17008	22562	0	applied	\N	\N	\N	\N	132402	132402	299964
17008	22563	1	applied	\N	\N	\N	\N	132403	132403	299965
17010	22565	1	applied	\N	\N	\N	\N	132410	132410	299972
17010	22566	2	applied	\N	\N	\N	\N	132411	132411	299973
17010	22567	3	applied	\N	\N	\N	\N	132412	132412	299974
17010	22568	4	applied	\N	\N	\N	\N	132413	132413	299975
17016	22582	0	applied	\N	\N	\N	\N	132432	132432	299994
17016	22583	1	applied	\N	\N	\N	\N	132433	132433	299995
17016	22584	3	applied	\N	\N	\N	\N	132434	132434	299996
17019	22585	0	applied	\N	\N	\N	\N	132441	132441	300003
17019	22586	1	applied	\N	\N	\N	\N	132442	132442	300004
17019	22587	2	applied	\N	\N	\N	\N	132443	132443	300005
17021	22588	0	applied	\N	\N	\N	\N	132451	132451	300013
17021	22589	1	applied	\N	\N	\N	\N	132452	132452	300014
17021	22590	2	applied	\N	\N	\N	\N	132453	132453	300015
17021	22591	3	applied	\N	\N	\N	\N	132454	132454	300016
17021	22592	4	applied	\N	\N	\N	\N	132455	132455	300017
17021	22593	5	applied	\N	\N	\N	\N	132456	132456	300018
17025	22596	0	applied	\N	\N	\N	\N	132475	132475	300037
17025	22597	1	applied	\N	\N	\N	\N	132476	132476	300038
17031	22598	0	applied	\N	\N	\N	\N	132598	132598	300160
17031	22599	1	applied	\N	\N	\N	\N	132599	132599	300161
17039	22608	0	applied	\N	\N	\N	\N	132619	132619	300181
17039	22609	1	applied	\N	\N	\N	\N	132620	132620	300182
17039	22610	2	applied	\N	\N	\N	\N	132621	132621	300183
17039	22611	3	applied	\N	\N	\N	\N	132622	132622	300184
17047	22627	0	applied	\N	\N	\N	\N	132648	132648	300210
17047	22628	1	applied	\N	\N	\N	\N	132649	132649	300211
17047	22629	2	applied	\N	\N	\N	\N	132650	132650	300212
17047	22630	3	applied	\N	\N	\N	\N	132651	132651	300213
17049	22632	0	applied	\N	\N	\N	\N	132655	132655	300217
17049	22633	1	applied	\N	\N	\N	\N	132656	132656	300218
17051	22637	0	applied	\N	\N	\N	\N	132660	132660	300222
17051	22638	1	applied	\N	\N	\N	\N	132661	132661	300223
16947	21957	105	applied	\N	\N	\N	\N	132201	132201	299763
17015	22583	1	applied	\N	\N	\N	\N	132430	132430	299992
17015	22584	3	applied	\N	\N	\N	\N	132431	132431	299993
17018	22585	0	applied	\N	\N	\N	\N	132438	132438	300000
17018	22586	1	applied	\N	\N	\N	\N	132439	132439	300001
17018	22587	2	applied	\N	\N	\N	\N	132440	132440	300002
17020	22588	0	applied	\N	\N	\N	\N	132444	132444	300006
17020	22589	1	applied	\N	\N	\N	\N	132445	132445	300007
17020	22590	2	applied	\N	\N	\N	\N	132446	132446	300008
17020	22591	3	applied	\N	\N	\N	\N	132447	132447	300009
17020	22592	4	applied	\N	\N	\N	\N	132448	132448	300010
17020	22593	5	applied	\N	\N	\N	\N	132449	132449	300011
17024	22595	0	applied	\N	\N	\N	\N	132472	132472	300034
17024	22596	1	applied	\N	\N	\N	\N	132473	132473	300035
17024	22597	2	applied	\N	\N	\N	\N	132474	132474	300036
17027	22489	0	applied	\N	\N	\N	\N	132480	132480	300042
17027	22490	1	applied	\N	\N	\N	\N	132481	132481	300043
17027	22494	2	applied	\N	\N	\N	\N	132482	132482	300044
17027	22495	3	applied	\N	\N	\N	\N	132483	132483	300045
17027	22498	4	applied	\N	\N	\N	\N	132484	132484	300046
17027	22499	5	applied	\N	\N	\N	\N	132485	132485	300047
17027	22500	6	applied	\N	\N	1000000000	\N	132486	132486	300048
17027	22570	7	applied	\N	\N	1000000000	\N	132487	132487	300049
17027	22504	8	applied	\N	\N	\N	\N	132488	132488	300050
17027	22506	9	applied	\N	\N	\N	\N	132489	132489	300051
17027	22507	10	applied	\N	\N	\N	\N	132490	132490	300052
17027	22510	11	applied	\N	\N	\N	\N	132491	132491	300053
17027	22511	12	applied	\N	\N	\N	\N	132492	132492	300054
17027	22516	14	applied	\N	\N	\N	\N	132494	132494	300056
17027	22519	15	applied	\N	\N	\N	\N	132495	132495	300057
17027	22521	16	applied	\N	\N	\N	\N	132496	132496	300058
17027	22522	17	applied	\N	\N	\N	\N	132497	132497	300059
17027	22525	18	applied	\N	\N	\N	\N	132498	132498	300060
17027	22527	19	applied	\N	\N	\N	\N	132499	132499	300061
17027	22528	20	applied	\N	\N	\N	\N	132500	132500	300062
17051	22639	2	applied	\N	\N	\N	\N	132662	132662	300224
17058	22648	0	applied	\N	\N	\N	\N	132807	132807	300369
17058	22649	1	applied	\N	\N	\N	\N	132808	132808	300370
17058	22650	2	applied	\N	\N	\N	\N	132809	132809	300371
17058	22651	3	applied	\N	\N	\N	\N	132810	132810	300372
17058	22652	4	applied	\N	\N	\N	\N	132811	132811	300373
17058	22653	5	applied	\N	\N	\N	\N	132812	132812	300374
17058	22654	6	applied	\N	\N	\N	\N	132813	132813	300375
17061	22661	0	applied	\N	\N	\N	\N	132820	132820	300382
17061	22663	2	applied	\N	\N	\N	\N	132822	132822	300384
17061	22664	3	applied	\N	\N	\N	\N	132823	132823	300385
17066	22666	0	applied	\N	\N	\N	\N	132854	132854	300416
17066	22667	1	applied	\N	\N	\N	\N	132855	132855	300417
17066	22668	2	applied	\N	\N	\N	\N	132856	132856	300418
17066	22669	3	applied	\N	\N	\N	\N	132857	132857	300419
17066	22665	4	applied	\N	\N	\N	\N	132858	132858	300420
17066	22670	5	applied	\N	\N	\N	\N	132859	132859	300421
17066	22671	6	applied	\N	\N	\N	\N	132860	132860	300422
17066	22672	7	applied	\N	\N	\N	\N	132861	132861	300423
17066	22673	8	applied	\N	\N	\N	\N	132862	132862	300424
17066	22674	9	applied	\N	\N	\N	\N	132863	132863	300425
17066	22675	10	applied	\N	\N	\N	\N	132864	132864	300426
17066	22676	11	applied	\N	\N	\N	\N	132865	132865	300427
17066	22677	12	applied	\N	\N	\N	\N	132866	132866	300428
17068	22678	0	applied	\N	\N	\N	\N	132872	132872	300434
17068	22680	2	applied	\N	\N	\N	\N	132874	132874	300436
17071	22684	0	applied	\N	\N	\N	\N	132882	132882	300444
17071	22685	1	applied	\N	\N	\N	\N	132883	132883	300445
17071	22686	2	applied	\N	\N	\N	\N	132884	132884	300446
17071	22687	3	applied	\N	\N	\N	\N	132885	132885	300447
17073	22688	0	applied	\N	\N	\N	\N	132889	132889	300451
17073	22689	1	applied	\N	\N	\N	\N	132890	132890	300452
17081	22715	0	applied	\N	\N	\N	\N	132924	132924	300486
17081	22716	1	applied	\N	\N	\N	\N	132925	132925	300487
17081	22717	2	applied	\N	\N	\N	\N	132926	132926	300488
17081	22718	3	applied	\N	\N	\N	\N	132927	132927	300489
17083	22719	0	applied	\N	\N	\N	\N	132932	132932	300494
17083	22720	1	applied	\N	\N	\N	\N	132933	132933	300495
17083	22721	2	applied	\N	\N	\N	\N	132934	132934	300496
17083	22722	3	applied	\N	\N	\N	\N	132935	132935	300497
17086	22715	0	applied	\N	\N	\N	\N	132945	132945	300507
17086	22603	2	applied	\N	\N	\N	\N	132947	132947	300509
17086	22640	3	applied	\N	\N	1000000000	\N	132948	132948	300510
17086	22605	4	applied	\N	\N	\N	\N	132949	132949	300511
17086	22608	5	applied	\N	\N	\N	\N	132950	132950	300512
17086	22612	6	applied	\N	\N	\N	\N	132951	132951	300513
17086	22615	7	applied	\N	\N	\N	\N	132952	132952	300514
17086	22618	8	applied	\N	\N	\N	\N	132953	132953	300515
17086	22621	9	applied	\N	\N	\N	\N	132954	132954	300516
17086	22622	10	applied	\N	\N	\N	\N	132955	132955	300517
17086	22627	11	applied	\N	\N	\N	\N	132956	132956	300518
17086	22631	12	applied	\N	\N	\N	\N	132957	132957	300519
17086	22634	13	applied	\N	\N	\N	\N	132958	132958	300520
17086	22698	14	applied	\N	\N	\N	\N	132959	132959	300521
17086	22637	15	applied	\N	\N	\N	\N	132960	132960	300522
17086	22641	16	applied	\N	\N	\N	\N	132961	132961	300523
17086	22645	17	applied	\N	\N	\N	\N	132962	132962	300524
17086	22649	19	applied	\N	\N	\N	\N	132964	132964	300526
17086	22655	20	applied	\N	\N	\N	\N	132965	132965	300527
17086	22658	21	applied	\N	\N	\N	\N	132966	132966	300528
17086	22661	22	applied	\N	\N	\N	\N	132967	132967	300529
17086	22666	23	applied	\N	\N	\N	\N	132968	132968	300530
17086	22667	24	applied	\N	\N	\N	\N	132969	132969	300531
17086	22668	25	applied	\N	\N	\N	\N	132970	132970	300532
17086	22669	26	applied	\N	\N	\N	\N	132971	132971	300533
17086	22678	27	applied	\N	\N	\N	\N	132972	132972	300534
17086	22681	28	applied	\N	\N	\N	\N	132973	132973	300535
17086	22684	29	applied	\N	\N	\N	\N	132974	132974	300536
17086	22688	30	applied	\N	\N	\N	\N	132975	132975	300537
17086	22690	31	applied	\N	\N	\N	\N	132976	132976	300538
17086	22693	32	applied	\N	\N	\N	\N	132977	132977	300539
17086	22696	33	applied	\N	\N	\N	\N	132978	132978	300540
17086	22697	34	applied	\N	\N	\N	\N	132979	132979	300541
17086	22705	36	applied	\N	\N	\N	\N	132981	132981	300543
17086	22706	37	applied	\N	\N	\N	\N	132982	132982	300544
17013	22574	1	applied	\N	\N	\N	\N	132421	132421	299983
17015	22582	0	applied	\N	\N	\N	\N	132429	132429	299991
17027	22539	25	applied	\N	\N	\N	\N	132504	132504	300066
17027	22541	26	applied	\N	\N	\N	\N	132505	132505	300067
17027	22542	27	applied	\N	\N	\N	\N	132506	132506	300068
17027	22546	28	applied	\N	\N	\N	\N	132507	132507	300069
17027	22548	29	applied	\N	\N	\N	\N	132508	132508	300070
17027	22550	30	applied	\N	\N	\N	\N	132509	132509	300071
17027	22553	31	applied	\N	\N	\N	\N	132510	132510	300072
17027	22554	32	applied	\N	\N	\N	\N	132511	132511	300073
17027	22557	33	applied	\N	\N	\N	\N	132512	132512	300074
17027	22558	34	applied	\N	\N	\N	\N	132513	132513	300075
17027	22562	35	applied	\N	\N	\N	\N	132514	132514	300076
17027	22565	37	applied	\N	\N	\N	\N	132516	132516	300078
17027	22569	38	applied	\N	\N	\N	\N	132517	132517	300079
17027	22573	39	applied	\N	\N	\N	\N	132518	132518	300080
17027	22575	40	applied	\N	\N	\N	\N	132519	132519	300081
17027	22576	41	applied	\N	\N	\N	\N	132520	132520	300082
17027	22582	42	applied	\N	\N	\N	\N	132521	132521	300083
17027	22585	43	applied	\N	\N	\N	\N	132522	132522	300084
17027	22588	44	applied	\N	\N	\N	\N	132523	132523	300085
17027	22589	45	applied	\N	\N	\N	\N	132524	132524	300086
17027	22595	46	applied	\N	\N	\N	\N	132525	132525	300087
17027	22491	47	applied	\N	\N	\N	\N	132526	132526	300088
17027	22492	48	applied	\N	\N	\N	\N	132527	132527	300089
17027	22496	49	applied	\N	\N	\N	\N	132528	132528	300090
17027	22497	50	applied	\N	\N	\N	\N	132529	132529	300091
17027	22501	51	applied	\N	\N	\N	\N	132530	132530	300092
17027	22502	52	applied	\N	\N	\N	\N	132531	132531	300093
17027	22509	54	applied	\N	\N	\N	\N	132533	132533	300095
17027	22513	55	applied	\N	\N	\N	\N	132534	132534	300096
17027	22572	56	applied	\N	\N	\N	\N	132535	132535	300097
17027	22574	57	applied	\N	\N	\N	\N	132536	132536	300098
17027	22578	58	applied	\N	\N	\N	\N	132537	132537	300099
17027	22579	59	applied	\N	\N	\N	\N	132538	132538	300100
17027	22583	60	applied	\N	\N	\N	\N	132539	132539	300101
17027	22586	61	applied	\N	\N	\N	\N	132540	132540	300102
17027	22590	62	applied	\N	\N	\N	\N	132541	132541	300103
17027	22591	63	applied	\N	\N	\N	\N	132542	132542	300104
17027	22597	64	applied	\N	\N	\N	\N	132543	132543	300105
17027	22514	65	applied	\N	\N	\N	\N	132544	132544	300106
17027	22515	66	applied	\N	\N	\N	\N	132545	132545	300107
17027	22518	67	applied	\N	\N	\N	\N	132546	132546	300108
17027	22520	68	applied	\N	\N	\N	\N	132547	132547	300109
17027	22524	69	applied	\N	\N	\N	\N	132548	132548	300110
17027	22530	71	applied	\N	\N	\N	\N	132550	132550	300112
17027	22531	72	applied	\N	\N	\N	\N	132551	132551	300113
17027	22493	73	applied	\N	\N	\N	\N	132552	132552	300114
17027	22503	74	applied	\N	\N	\N	\N	132553	132553	300115
17027	22508	75	applied	\N	\N	\N	\N	132554	132554	300116
17027	22517	76	applied	\N	\N	\N	\N	132555	132555	300117
17027	22523	77	applied	\N	\N	\N	\N	132556	132556	300118
17027	22529	78	applied	\N	\N	\N	\N	132557	132557	300119
17027	22537	79	applied	\N	\N	\N	\N	132558	132558	300120
17027	22543	80	applied	\N	\N	\N	\N	132559	132559	300121
17027	22551	81	applied	\N	\N	\N	\N	132560	132560	300122
17027	22561	82	applied	\N	\N	\N	\N	132561	132561	300123
17027	22566	83	applied	\N	\N	\N	\N	132562	132562	300124
17027	22577	84	applied	\N	\N	\N	\N	132563	132563	300125
17027	22592	85	applied	\N	\N	\N	\N	132564	132564	300126
17027	22533	86	applied	\N	\N	\N	\N	132565	132565	300127
17027	22538	88	applied	\N	\N	\N	\N	132567	132567	300129
17027	22540	89	applied	\N	\N	\N	\N	132568	132568	300130
17027	22544	90	applied	\N	\N	\N	\N	132569	132569	300131
17027	22545	91	applied	\N	\N	\N	\N	132570	132570	300132
17027	22547	92	applied	\N	\N	\N	\N	132571	132571	300133
17027	22549	93	applied	\N	\N	\N	\N	132572	132572	300134
17027	22552	94	applied	\N	\N	\N	\N	132573	132573	300135
17027	22555	95	applied	\N	\N	\N	\N	132574	132574	300136
17027	22556	96	applied	\N	\N	\N	\N	132575	132575	300137
17027	22559	97	applied	\N	\N	\N	\N	132576	132576	300138
17027	22560	98	applied	\N	\N	\N	\N	132577	132577	300139
17027	22563	99	applied	\N	\N	\N	\N	132578	132578	300140
17027	22567	100	applied	\N	\N	\N	\N	132579	132579	300141
17027	22568	101	applied	\N	\N	\N	\N	132580	132580	300142
17027	22571	102	applied	\N	\N	\N	\N	132581	132581	300143
17027	22580	103	applied	\N	\N	\N	\N	132582	132582	300144
17027	22584	105	applied	\N	\N	\N	\N	132584	132584	300146
17027	22587	106	applied	\N	\N	\N	\N	132585	132585	300147
17027	22593	107	applied	\N	\N	\N	\N	132586	132586	300148
17027	22594	108	applied	\N	\N	\N	\N	132587	132587	300149
17027	22596	109	applied	\N	\N	\N	\N	132588	132588	300150
17030	22595	0	applied	\N	\N	\N	\N	132593	132593	300155
17030	22596	1	applied	\N	\N	\N	\N	132594	132594	300156
17030	22598	2	applied	\N	\N	\N	\N	132595	132595	300157
17030	22597	3	applied	\N	\N	\N	\N	132596	132596	300158
17030	22599	4	applied	\N	\N	\N	\N	132597	132597	300159
17034	22600	0	applied	\N	\N	\N	\N	132605	132605	300167
17034	22601	1	applied	\N	\N	\N	\N	132606	132606	300168
17041	22615	0	applied	\N	\N	\N	\N	132626	132626	300188
17041	22616	1	applied	\N	\N	\N	\N	132627	132627	300189
17041	22617	2	applied	\N	\N	\N	\N	132628	132628	300190
17044	22621	0	applied	\N	\N	\N	\N	132638	132638	300200
17044	22623	2	applied	\N	\N	\N	\N	132640	132640	300202
17044	22624	3	applied	\N	\N	\N	\N	132641	132641	300203
17044	22625	4	applied	\N	\N	\N	\N	132642	132642	300204
17044	22626	5	applied	\N	\N	\N	\N	132643	132643	300205
17046	22627	0	applied	\N	\N	\N	\N	132644	132644	300206
17046	22628	1	applied	\N	\N	\N	\N	132645	132645	300207
17046	22629	2	applied	\N	\N	\N	\N	132646	132646	300208
17046	22630	3	applied	\N	\N	\N	\N	132647	132647	300209
17048	22631	0	applied	\N	\N	\N	\N	132652	132652	300214
17048	22632	1	applied	\N	\N	\N	\N	132653	132653	300215
17048	22633	2	applied	\N	\N	\N	\N	132654	132654	300216
17053	22570	0	applied	\N	\N	1000000000	\N	132788	132788	300350
17053	22640	1	applied	\N	\N	1000000000	\N	132789	132789	300351
17056	22641	0	applied	\N	\N	\N	\N	132799	132799	300361
17056	22644	2	applied	\N	\N	\N	\N	132801	132801	300363
17056	22642	3	applied	\N	\N	\N	\N	132802	132802	300364
17056	22643	4	applied	\N	\N	\N	\N	132803	132803	300365
17057	22645	0	applied	\N	\N	\N	\N	132804	132804	300366
17027	22534	22	applied	\N	\N	\N	\N	132502	132502	300064
17027	22536	24	applied	\N	\N	\N	\N	132503	132503	300065
17052	22475	30	applied	\N	\N	\N	\N	132693	132693	300255
17052	22478	31	applied	\N	\N	\N	\N	132694	132694	300256
17052	22481	32	applied	\N	\N	\N	\N	132695	132695	300257
17052	22482	33	applied	\N	\N	\N	\N	132696	132696	300258
17052	22484	34	applied	\N	\N	\N	\N	132697	132697	300259
17052	22487	35	applied	\N	\N	\N	\N	132698	132698	300260
17052	22489	36	applied	\N	\N	\N	\N	132699	132699	300261
17052	22494	38	applied	\N	\N	\N	\N	132701	132701	300263
17052	22495	39	applied	\N	\N	\N	\N	132702	132702	300264
17052	22498	40	applied	\N	\N	\N	\N	132703	132703	300265
17052	22499	41	applied	\N	\N	\N	\N	132704	132704	300266
17052	22504	42	applied	\N	\N	\N	\N	132705	132705	300267
17052	22506	43	applied	\N	\N	\N	\N	132706	132706	300268
17052	22507	44	applied	\N	\N	\N	\N	132707	132707	300269
17052	22510	45	applied	\N	\N	\N	\N	132708	132708	300270
17052	22511	47	applied	\N	\N	\N	\N	132709	132709	300271
17052	22512	48	applied	\N	\N	\N	\N	132710	132710	300272
17052	22516	49	applied	\N	\N	\N	\N	132711	132711	300273
17052	22519	50	applied	\N	\N	\N	\N	132712	132712	300274
17052	22521	51	applied	\N	\N	\N	\N	132713	132713	300275
17052	22522	52	applied	\N	\N	\N	\N	132714	132714	300276
17052	22525	53	applied	\N	\N	\N	\N	132715	132715	300277
17052	22527	54	applied	\N	\N	\N	\N	132716	132716	300278
17052	22532	56	applied	\N	\N	\N	\N	132718	132718	300280
17052	22534	57	applied	\N	\N	\N	\N	132719	132719	300281
17052	22536	58	applied	\N	\N	\N	\N	132720	132720	300282
17052	22539	59	applied	\N	\N	\N	\N	132721	132721	300283
17052	22541	60	applied	\N	\N	\N	\N	132722	132722	300284
17052	22542	61	applied	\N	\N	\N	\N	132723	132723	300285
17052	22546	62	applied	\N	\N	\N	\N	132724	132724	300286
17052	22548	63	applied	\N	\N	\N	\N	132725	132725	300287
17052	22550	64	applied	\N	\N	\N	\N	132726	132726	300288
17052	22553	65	applied	\N	\N	\N	\N	132727	132727	300289
17052	22554	66	applied	\N	\N	\N	\N	132728	132728	300290
17057	22646	1	applied	\N	\N	\N	\N	132805	132805	300367
17057	22647	2	applied	\N	\N	\N	\N	132806	132806	300368
17060	22658	0	applied	\N	\N	\N	\N	132817	132817	300379
17060	22659	1	applied	\N	\N	\N	\N	132818	132818	300380
17060	22660	2	applied	\N	\N	\N	\N	132819	132819	300381
17063	22165	1	applied	\N	\N	\N	\N	132829	132829	300391
17063	22451	2	applied	\N	\N	1000000000	\N	132830	132830	300392
17063	22166	3	applied	\N	\N	\N	\N	132831	132831	300393
17063	22500	4	applied	\N	\N	1000000000	\N	132832	132832	300394
17063	22570	5	applied	\N	\N	1000000000	\N	132833	132833	300395
17063	22640	6	applied	\N	\N	1000000000	\N	132834	132834	300396
17063	22167	7	applied	\N	\N	\N	\N	132835	132835	300397
17063	22168	8	applied	\N	\N	\N	\N	132836	132836	300398
17063	22178	9	applied	\N	\N	\N	\N	132837	132837	300399
17063	22181	10	applied	\N	\N	\N	\N	132838	132838	300400
17063	22182	11	applied	\N	\N	\N	\N	132839	132839	300401
17063	22188	12	applied	\N	\N	\N	\N	132840	132840	300402
17063	22191	13	applied	\N	\N	\N	\N	132841	132841	300403
17063	22194	14	applied	\N	\N	\N	\N	132842	132842	300404
17063	22195	15	applied	\N	\N	\N	\N	132843	132843	300405
17063	22201	16	applied	\N	\N	\N	\N	132844	132844	300406
17063	22204	17	applied	\N	\N	\N	\N	132845	132845	300407
17063	22207	18	applied	\N	\N	\N	\N	132846	132846	300408
17063	22214	20	applied	\N	\N	\N	\N	132848	132848	300410
17063	22218	21	applied	\N	\N	\N	\N	132849	132849	300411
17063	22219	22	applied	\N	\N	\N	\N	132850	132850	300412
17063	22228	23	applied	\N	\N	\N	\N	132851	132851	300413
17063	22231	24	applied	\N	\N	\N	\N	132852	132852	300414
17070	22684	0	applied	\N	\N	\N	\N	132878	132878	300440
17070	22685	1	applied	\N	\N	\N	\N	132879	132879	300441
17070	22686	2	applied	\N	\N	\N	\N	132880	132880	300442
17070	22687	3	applied	\N	\N	\N	\N	132881	132881	300443
17077	22690	0	applied	\N	\N	\N	\N	132898	132898	300460
17077	22689	1	applied	\N	\N	\N	\N	132899	132899	300461
17077	22691	2	applied	\N	\N	\N	\N	132900	132900	300462
17077	22692	3	applied	\N	\N	\N	\N	132901	132901	300463
17080	22704	0	applied	\N	\N	\N	\N	132913	132913	300475
17080	22705	1	applied	\N	\N	\N	\N	132914	132914	300476
17080	22706	2	applied	\N	\N	\N	\N	132915	132915	300477
17080	22708	4	applied	\N	\N	\N	\N	132917	132917	300479
17080	22709	5	applied	\N	\N	\N	\N	132918	132918	300480
17080	22710	6	applied	\N	\N	\N	\N	132919	132919	300481
17080	22711	7	applied	\N	\N	\N	\N	132920	132920	300482
17080	22712	8	applied	\N	\N	\N	\N	132921	132921	300483
17080	22713	9	applied	\N	\N	\N	\N	132922	132922	300484
17080	22714	10	applied	\N	\N	\N	\N	132923	132923	300485
17087	22732	0	applied	\N	\N	\N	\N	133070	133070	300632
17087	22733	1	applied	\N	\N	\N	\N	133071	133071	300633
17087	22734	2	applied	\N	\N	\N	\N	133072	133072	300634
17090	22738	0	applied	\N	\N	\N	\N	133079	133079	300641
17090	22739	1	applied	\N	\N	\N	\N	133080	133080	300642
17090	22740	2	applied	\N	\N	\N	\N	133081	133081	300643
17095	22748	0	applied	\N	\N	\N	\N	133089	133089	300651
17095	22749	1	applied	\N	\N	\N	\N	133090	133090	300652
17095	22750	2	applied	\N	\N	\N	\N	133091	133091	300653
17095	22752	4	applied	\N	\N	\N	\N	133093	133093	300655
17098	22732	0	applied	\N	\N	\N	\N	133104	133104	300666
17098	22735	1	applied	\N	\N	\N	\N	133105	133105	300667
17098	22738	2	applied	\N	\N	\N	\N	133106	133106	300668
17098	22741	3	applied	\N	\N	\N	\N	133107	133107	300669
17098	22744	4	applied	\N	\N	\N	\N	133108	133108	300670
17098	22746	5	applied	\N	\N	\N	\N	133109	133109	300671
17098	22748	6	applied	\N	\N	\N	\N	133110	133110	300672
17098	22749	7	applied	\N	\N	\N	\N	133111	133111	300673
17098	22736	8	applied	\N	\N	\N	\N	133112	133112	300674
17098	22701	9	applied	\N	\N	\N	\N	133113	133113	300675
17098	22740	10	applied	\N	\N	\N	\N	133114	133114	300676
17098	22712	11	applied	\N	\N	\N	\N	133115	133115	300677
17098	22713	12	applied	\N	\N	\N	\N	133116	133116	300678
17098	22714	13	applied	\N	\N	\N	\N	133117	133117	300679
17098	22718	14	applied	\N	\N	\N	\N	133118	133118	300680
17098	22722	16	applied	\N	\N	\N	\N	133120	133120	300682
17098	22724	17	applied	\N	\N	\N	\N	133121	133121	300683
17098	22728	18	applied	\N	\N	\N	\N	133122	133122	300684
17098	22734	19	applied	\N	\N	\N	\N	133123	133123	300685
17052	22468	28	applied	\N	\N	\N	\N	132691	132691	300253
17052	22469	29	applied	\N	\N	\N	\N	132692	132692	300254
17052	22564	70	applied	\N	\N	\N	\N	132732	132732	300294
17052	22565	71	applied	\N	\N	\N	\N	132733	132733	300295
17052	22569	72	applied	\N	\N	\N	\N	132734	132734	300296
17052	22573	73	applied	\N	\N	\N	\N	132735	132735	300297
17052	22575	74	applied	\N	\N	\N	\N	132736	132736	300298
17052	22582	76	applied	\N	\N	\N	\N	132738	132738	300300
17052	22585	77	applied	\N	\N	\N	\N	132739	132739	300301
17052	22588	78	applied	\N	\N	\N	\N	132740	132740	300302
17052	22589	79	applied	\N	\N	\N	\N	132741	132741	300303
17052	22595	80	applied	\N	\N	\N	\N	132742	132742	300304
17052	22600	81	applied	\N	\N	\N	\N	132743	132743	300305
17052	22603	82	applied	\N	\N	\N	\N	132744	132744	300306
17052	22605	83	applied	\N	\N	\N	\N	132745	132745	300307
17052	22608	84	applied	\N	\N	\N	\N	132746	132746	300308
17052	22612	85	applied	\N	\N	\N	\N	132747	132747	300309
17052	22615	86	applied	\N	\N	\N	\N	132748	132748	300310
17052	22618	87	applied	\N	\N	\N	\N	132749	132749	300311
17052	22621	88	applied	\N	\N	\N	\N	132750	132750	300312
17052	22622	89	applied	\N	\N	\N	\N	132751	132751	300313
17052	22627	90	applied	\N	\N	\N	\N	132752	132752	300314
17052	22631	91	applied	\N	\N	\N	\N	132753	132753	300315
17052	22637	93	applied	\N	\N	\N	\N	132755	132755	300317
17052	22392	94	applied	\N	\N	\N	\N	132756	132756	300318
17052	22389	95	applied	\N	\N	\N	\N	132757	132757	300319
17052	22390	96	applied	\N	\N	\N	\N	132758	132758	300320
17052	22403	97	applied	\N	\N	\N	\N	132759	132759	300321
17052	22415	98	applied	\N	\N	\N	\N	132760	132760	300322
17052	22423	99	applied	\N	\N	\N	\N	132761	132761	300323
17052	22393	100	applied	\N	\N	\N	\N	132762	132762	300324
17052	22394	101	applied	\N	\N	\N	\N	132763	132763	300325
17052	22398	102	applied	\N	\N	\N	\N	132764	132764	300326
17052	22399	103	applied	\N	\N	\N	\N	132765	132765	300327
17052	22404	104	applied	\N	\N	\N	\N	132766	132766	300328
17052	22400	105	applied	\N	\N	\N	\N	132767	132767	300329
17052	22401	106	applied	\N	\N	\N	\N	132768	132768	300330
17052	22406	107	applied	\N	\N	\N	\N	132769	132769	300331
17052	22409	108	applied	\N	\N	\N	\N	132770	132770	300332
17052	22417	110	applied	\N	\N	\N	\N	132772	132772	300334
17052	22418	111	applied	\N	\N	\N	\N	132773	132773	300335
17052	22425	112	applied	\N	\N	\N	\N	132774	132774	300336
17052	22426	113	applied	\N	\N	\N	\N	132775	132775	300337
17052	22407	114	applied	\N	\N	\N	\N	132776	132776	300338
17052	22410	115	applied	\N	\N	\N	\N	132777	132777	300339
17052	22414	116	applied	\N	\N	\N	\N	132778	132778	300340
17052	22419	117	applied	\N	\N	\N	\N	132779	132779	300341
17052	22420	118	applied	\N	\N	\N	\N	132780	132780	300342
17052	22424	119	applied	\N	\N	\N	\N	132781	132781	300343
17052	22427	120	applied	\N	\N	\N	\N	132782	132782	300344
17052	22429	121	applied	\N	\N	\N	\N	132783	132783	300345
17052	22433	122	applied	\N	\N	\N	\N	132784	132784	300346
17052	22436	123	applied	\N	\N	\N	\N	132785	132785	300347
17052	22442	124	applied	\N	\N	\N	\N	132786	132786	300348
17052	22443	125	applied	\N	\N	\N	\N	132787	132787	300349
17055	22640	1	applied	\N	\N	1000000000	\N	132795	132795	300357
17055	22644	2	applied	\N	\N	\N	\N	132796	132796	300358
17055	22642	3	applied	\N	\N	\N	\N	132797	132797	300359
17055	22643	4	applied	\N	\N	\N	\N	132798	132798	300360
17065	22665	0	applied	\N	\N	\N	\N	132853	132853	300415
17067	22451	0	applied	\N	\N	1000000000	\N	132867	132867	300429
17067	22500	1	applied	\N	\N	1000000000	\N	132868	132868	300430
17067	22570	2	applied	\N	\N	1000000000	\N	132869	132869	300431
17067	22640	3	applied	\N	\N	1000000000	\N	132870	132870	300432
17067	22397	4	applied	\N	\N	\N	\N	132871	132871	300433
17075	22688	0	applied	\N	\N	\N	\N	132893	132893	300455
17076	22690	0	applied	\N	\N	\N	\N	132894	132894	300456
17076	22689	1	applied	\N	\N	\N	\N	132895	132895	300457
17076	22691	2	applied	\N	\N	\N	\N	132896	132896	300458
17076	22692	3	applied	\N	\N	\N	\N	132897	132897	300459
17079	22696	0	applied	\N	\N	\N	\N	132905	132905	300467
17079	22698	2	applied	\N	\N	\N	\N	132907	132907	300469
17079	22699	3	applied	\N	\N	\N	\N	132908	132908	300470
17079	22700	4	applied	\N	\N	\N	\N	132909	132909	300471
17079	22701	5	applied	\N	\N	\N	\N	132910	132910	300472
17079	22702	6	applied	\N	\N	\N	\N	132911	132911	300473
17079	22703	7	applied	\N	\N	\N	\N	132912	132912	300474
17082	22717	2	applied	\N	\N	\N	\N	132930	132930	300492
17082	22718	3	applied	\N	\N	\N	\N	132931	132931	300493
17084	22723	0	applied	\N	\N	\N	\N	132936	132936	300498
17084	22724	1	applied	\N	\N	\N	\N	132937	132937	300499
17084	22725	2	applied	\N	\N	\N	\N	132938	132938	300500
17085	22726	0	applied	\N	\N	\N	\N	132939	132939	300501
17085	22727	1	applied	\N	\N	\N	\N	132940	132940	300502
17085	22728	2	applied	\N	\N	\N	\N	132941	132941	300503
17085	22729	3	applied	\N	\N	\N	\N	132942	132942	300504
17085	22730	4	applied	\N	\N	\N	\N	132943	132943	300505
17089	22738	0	applied	\N	\N	\N	\N	133076	133076	300638
17089	22739	1	applied	\N	\N	\N	\N	133077	133077	300639
17089	22740	2	applied	\N	\N	\N	\N	133078	133078	300640
17091	22741	0	applied	\N	\N	\N	\N	133082	133082	300644
17091	22742	1	applied	\N	\N	\N	\N	133083	133083	300645
17091	22743	2	applied	\N	\N	\N	\N	133084	133084	300646
17093	22744	0	applied	\N	\N	\N	\N	133085	133085	300647
17093	22745	1	applied	\N	\N	\N	\N	133086	133086	300648
17094	22746	0	applied	\N	\N	\N	\N	133087	133087	300649
17094	22747	1	applied	\N	\N	\N	\N	133088	133088	300650
17097	22748	0	applied	\N	\N	\N	\N	133099	133099	300661
17097	22749	1	applied	\N	\N	\N	\N	133100	133100	300662
17101	22715	0	applied	\N	\N	\N	\N	133136	133136	300698
17101	22640	1	applied	\N	\N	1000000000	\N	133137	133137	300699
17101	22698	2	applied	\N	\N	\N	\N	133138	133138	300700
17101	22707	3	applied	\N	\N	\N	\N	133139	133139	300701
17108	22763	1	applied	\N	\N	\N	\N	133159	133159	300721
17113	22770	0	applied	\N	\N	\N	\N	133171	133171	300733
17113	22771	1	applied	\N	\N	\N	\N	133172	133172	300734
17117	22772	0	applied	\N	\N	\N	\N	133259	133259	300821
17117	22773	1	applied	\N	\N	\N	\N	133260	133260	300822
17117	22774	2	applied	\N	\N	\N	\N	133261	133261	300823
17122	22782	0	applied	\N	\N	\N	\N	133271	133271	300833
17122	22783	1	applied	\N	\N	\N	\N	133272	133272	300834
17052	22558	68	applied	\N	\N	\N	\N	132730	132730	300292
17052	22562	69	applied	\N	\N	\N	\N	132731	132731	300293
17086	22727	43	applied	\N	\N	\N	\N	132987	132987	300549
17086	22598	44	applied	\N	\N	\N	\N	132988	132988	300550
17086	22707	45	applied	\N	\N	\N	\N	132989	132989	300551
17086	22601	46	applied	\N	\N	\N	\N	132990	132990	300552
17086	22604	47	applied	\N	\N	\N	\N	132991	132991	300553
17086	22602	48	applied	\N	\N	\N	\N	132992	132992	300554
17086	22606	49	applied	\N	\N	\N	\N	132993	132993	300555
17086	22610	50	applied	\N	\N	\N	\N	132994	132994	300556
17086	22614	51	applied	\N	\N	\N	\N	132995	132995	300557
17086	22599	52	applied	\N	\N	\N	\N	132996	132996	300558
17086	22609	53	applied	\N	\N	\N	\N	132997	132997	300559
17086	22619	54	applied	\N	\N	\N	\N	132998	132998	300560
17086	22617	55	applied	\N	\N	\N	\N	132999	132999	300561
17086	22625	56	applied	\N	\N	\N	\N	133000	133000	300562
17086	22626	57	applied	\N	\N	\N	\N	133001	133001	300563
17086	22629	58	applied	\N	\N	\N	\N	133002	133002	300564
17086	22636	60	applied	\N	\N	\N	\N	133004	133004	300566
17086	22639	61	applied	\N	\N	\N	\N	133005	133005	300567
17086	22642	62	applied	\N	\N	\N	\N	133006	133006	300568
17086	22646	63	applied	\N	\N	\N	\N	133007	133007	300569
17086	22651	64	applied	\N	\N	\N	\N	133008	133008	300570
17086	22652	65	applied	\N	\N	\N	\N	133009	133009	300571
17086	22656	66	applied	\N	\N	\N	\N	133010	133010	300572
17086	22660	67	applied	\N	\N	\N	\N	133011	133011	300573
17086	22662	68	applied	\N	\N	\N	\N	133012	133012	300574
17086	22670	69	applied	\N	\N	\N	\N	133013	133013	300575
17086	22671	70	applied	\N	\N	\N	\N	133014	133014	300576
17086	22672	71	applied	\N	\N	\N	\N	133015	133015	300577
17086	22673	72	applied	\N	\N	\N	\N	133016	133016	300578
17086	22680	73	applied	\N	\N	\N	\N	133017	133017	300579
17086	22682	74	applied	\N	\N	\N	\N	133018	133018	300580
17086	22685	75	applied	\N	\N	\N	\N	133019	133019	300581
17086	22694	77	applied	\N	\N	\N	\N	133021	133021	300583
17086	22699	78	applied	\N	\N	\N	\N	133022	133022	300584
17086	22702	79	applied	\N	\N	\N	\N	133023	133023	300585
17086	22708	80	applied	\N	\N	\N	\N	133024	133024	300586
17086	22710	81	applied	\N	\N	\N	\N	133025	133025	300587
17086	22711	82	applied	\N	\N	\N	\N	133026	133026	300588
17086	22717	83	applied	\N	\N	\N	\N	133027	133027	300589
17086	22720	84	applied	\N	\N	\N	\N	133028	133028	300590
17086	22725	85	applied	\N	\N	\N	\N	133029	133029	300591
17086	22729	86	applied	\N	\N	\N	\N	133030	133030	300592
17086	22730	87	applied	\N	\N	\N	\N	133031	133031	300593
17086	22607	88	applied	\N	\N	\N	\N	133032	133032	300594
17086	22611	89	applied	\N	\N	\N	\N	133033	133033	300595
17086	22613	90	applied	\N	\N	\N	\N	133034	133034	300596
17086	22616	91	applied	\N	\N	\N	\N	133035	133035	300597
17086	22620	92	applied	\N	\N	\N	\N	133036	133036	300598
17086	22624	94	applied	\N	\N	\N	\N	133038	133038	300600
17086	22628	95	applied	\N	\N	\N	\N	133039	133039	300601
17086	22632	96	applied	\N	\N	\N	\N	133040	133040	300602
17086	22635	97	applied	\N	\N	\N	\N	133041	133041	300603
17086	22638	98	applied	\N	\N	\N	\N	133042	133042	300604
17086	22644	99	applied	\N	\N	\N	\N	133043	133043	300605
17086	22647	100	applied	\N	\N	\N	\N	133044	133044	300606
17086	22630	101	applied	\N	\N	\N	\N	133045	133045	300607
17086	22643	102	applied	\N	\N	\N	\N	133046	133046	300608
17086	22650	103	applied	\N	\N	\N	\N	133047	133047	300609
17086	22664	104	applied	\N	\N	\N	\N	133048	133048	300610
17086	22665	105	applied	\N	\N	\N	\N	133049	133049	300611
17086	22687	106	applied	\N	\N	\N	\N	133050	133050	300612
17086	22703	107	applied	\N	\N	\N	\N	133051	133051	300613
17086	22709	108	applied	\N	\N	\N	\N	133052	133052	300614
17086	22721	109	applied	\N	\N	\N	\N	133053	133053	300615
17086	22654	111	applied	\N	\N	\N	\N	133055	133055	300617
17086	22657	112	applied	\N	\N	\N	\N	133056	133056	300618
17086	22659	113	applied	\N	\N	\N	\N	133057	133057	300619
17086	22663	114	applied	\N	\N	\N	\N	133058	133058	300620
17086	22674	115	applied	\N	\N	\N	\N	133059	133059	300621
17086	22675	116	applied	\N	\N	\N	\N	133060	133060	300622
17086	22676	117	applied	\N	\N	\N	\N	133061	133061	300623
17086	22677	118	applied	\N	\N	\N	\N	133062	133062	300624
17086	22679	119	applied	\N	\N	\N	\N	133063	133063	300625
17086	22683	120	applied	\N	\N	\N	\N	133064	133064	300626
17086	22686	121	applied	\N	\N	\N	\N	133065	133065	300627
17086	22689	122	applied	\N	\N	\N	\N	133066	133066	300628
17086	22691	123	applied	\N	\N	\N	\N	133067	133067	300629
17086	22695	124	applied	\N	\N	\N	\N	133068	133068	300630
17086	22700	125	applied	\N	\N	\N	\N	133069	133069	300631
17088	22735	0	applied	\N	\N	\N	\N	133073	133073	300635
17088	22737	2	applied	\N	\N	\N	\N	133075	133075	300637
17096	22748	0	applied	\N	\N	\N	\N	133094	133094	300656
17096	22749	1	applied	\N	\N	\N	\N	133095	133095	300657
17096	22750	2	applied	\N	\N	\N	\N	133096	133096	300658
17096	22751	3	applied	\N	\N	\N	\N	133097	133097	300659
17096	22752	4	applied	\N	\N	\N	\N	133098	133098	300660
17097	22750	2	applied	\N	\N	\N	\N	133101	133101	300663
17097	22751	3	applied	\N	\N	\N	\N	133102	133102	300664
17097	22752	4	applied	\N	\N	\N	\N	133103	133103	300665
17100	22753	0	applied	\N	\N	\N	\N	133134	133134	300696
17100	22754	1	applied	\N	\N	\N	\N	133135	133135	300697
17103	22753	0	applied	\N	\N	\N	\N	133144	133144	300706
17103	22755	1	applied	\N	\N	\N	\N	133145	133145	300707
17103	22754	2	applied	\N	\N	\N	\N	133146	133146	300708
17103	22756	3	applied	\N	\N	\N	\N	133147	133147	300709
17105	22757	0	applied	\N	\N	\N	\N	133151	133151	300713
17105	22759	2	applied	\N	\N	\N	\N	133153	133153	300715
17106	22760	0	applied	\N	\N	\N	\N	133154	133154	300716
17107	22762	0	applied	\N	\N	\N	\N	133156	133156	300718
17107	22763	1	applied	\N	\N	\N	\N	133157	133157	300719
17110	22765	0	applied	\N	\N	\N	\N	133164	133164	300726
17110	22766	1	applied	\N	\N	\N	\N	133165	133165	300727
17110	22767	2	applied	\N	\N	\N	\N	133166	133166	300728
17112	22770	0	applied	\N	\N	\N	\N	133169	133169	300731
17112	22771	1	applied	\N	\N	\N	\N	133170	133170	300732
17119	22775	0	applied	\N	\N	\N	\N	133264	133264	300826
17119	22776	1	applied	\N	\N	\N	\N	133265	133265	300827
17121	22779	0	applied	\N	\N	\N	\N	133268	133268	300830
17121	22780	1	applied	\N	\N	\N	\N	133269	133269	300831
17121	22781	2	applied	\N	\N	\N	\N	133270	133270	300832
17086	22719	40	applied	\N	\N	\N	\N	132984	132984	300546
17086	22723	41	applied	\N	\N	\N	\N	132985	132985	300547
17098	22751	24	applied	\N	\N	\N	\N	133128	133128	300690
17098	22752	25	applied	\N	\N	\N	\N	133129	133129	300691
17098	22731	26	applied	\N	\N	\N	\N	133130	133130	300692
17098	22733	27	applied	\N	\N	\N	\N	133131	133131	300693
17098	22737	28	applied	\N	\N	\N	\N	133132	133132	300694
17098	22739	29	applied	\N	\N	\N	\N	133133	133133	300695
17102	22753	0	applied	\N	\N	\N	\N	133140	133140	300702
17102	22755	1	applied	\N	\N	\N	\N	133141	133141	300703
17102	22754	2	applied	\N	\N	\N	\N	133142	133142	300704
17102	22756	3	applied	\N	\N	\N	\N	133143	133143	300705
17104	22757	0	applied	\N	\N	\N	\N	133148	133148	300710
17104	22758	1	applied	\N	\N	\N	\N	133149	133149	300711
17104	22759	2	applied	\N	\N	\N	\N	133150	133150	300712
17106	22761	1	applied	\N	\N	\N	\N	133155	133155	300717
17109	22764	0	applied	\N	\N	\N	\N	133160	133160	300722
17109	22765	1	applied	\N	\N	\N	\N	133161	133161	300723
17109	22767	3	applied	\N	\N	\N	\N	133163	133163	300725
17111	22768	0	applied	\N	\N	\N	\N	133167	133167	300729
17111	22769	1	applied	\N	\N	\N	\N	133168	133168	300730
17114	22770	0	applied	\N	\N	\N	\N	133173	133173	300735
17114	22771	1	applied	\N	\N	\N	\N	133174	133174	300736
17115	22715	0	applied	\N	\N	\N	\N	133175	133175	300737
17115	22688	1	applied	\N	\N	\N	\N	133176	133176	300738
17115	22690	2	applied	\N	\N	\N	\N	133177	133177	300739
17115	22693	3	applied	\N	\N	\N	\N	133178	133178	300740
17115	22696	4	applied	\N	\N	\N	\N	133179	133179	300741
17115	22697	5	applied	\N	\N	\N	\N	133180	133180	300742
17115	22704	6	applied	\N	\N	\N	\N	133181	133181	300743
17115	22705	7	applied	\N	\N	\N	\N	133182	133182	300744
17115	22706	8	applied	\N	\N	\N	\N	133183	133183	300745
17115	22716	9	applied	\N	\N	\N	\N	133184	133184	300746
17115	22698	10	applied	\N	\N	\N	\N	133185	133185	300747
17115	22723	12	applied	\N	\N	\N	\N	133187	133187	300749
17115	22726	13	applied	\N	\N	\N	\N	133188	133188	300750
17115	22727	14	applied	\N	\N	\N	\N	133189	133189	300751
17115	22732	15	applied	\N	\N	\N	\N	133190	133190	300752
17115	22735	16	applied	\N	\N	\N	\N	133191	133191	300753
17115	22738	17	applied	\N	\N	\N	\N	133192	133192	300754
17115	22741	18	applied	\N	\N	\N	\N	133193	133193	300755
17115	22744	19	applied	\N	\N	\N	\N	133194	133194	300756
17115	22746	20	applied	\N	\N	\N	\N	133195	133195	300757
17115	22748	21	applied	\N	\N	\N	\N	133196	133196	300758
17115	22749	22	applied	\N	\N	\N	\N	133197	133197	300759
17115	22753	23	applied	\N	\N	\N	\N	133198	133198	300760
17115	22755	24	applied	\N	\N	\N	\N	133199	133199	300761
17115	22757	25	applied	\N	\N	\N	\N	133200	133200	300762
17115	22760	26	applied	\N	\N	\N	\N	133201	133201	300763
17115	22762	27	applied	\N	\N	\N	\N	133202	133202	300764
17115	22768	29	applied	\N	\N	\N	\N	133204	133204	300766
17115	22770	30	applied	\N	\N	\N	\N	133205	133205	300767
17115	22707	31	applied	\N	\N	\N	\N	133206	133206	300768
17115	22689	32	applied	\N	\N	\N	\N	133207	133207	300769
17115	22691	33	applied	\N	\N	\N	\N	133208	133208	300770
17115	22695	34	applied	\N	\N	\N	\N	133209	133209	300771
17115	22700	35	applied	\N	\N	\N	\N	133210	133210	300772
17115	22701	36	applied	\N	\N	\N	\N	133211	133211	300773
17115	22767	37	applied	\N	\N	\N	\N	133212	133212	300774
17115	22692	38	applied	\N	\N	\N	\N	133213	133213	300775
17115	22694	39	applied	\N	\N	\N	\N	133214	133214	300776
17115	22699	40	applied	\N	\N	\N	\N	133215	133215	300777
17115	22702	41	applied	\N	\N	\N	\N	133216	133216	300778
17115	22708	42	applied	\N	\N	\N	\N	133217	133217	300779
17115	22710	43	applied	\N	\N	\N	\N	133218	133218	300780
17115	22711	44	applied	\N	\N	\N	\N	133219	133219	300781
17115	22720	46	applied	\N	\N	\N	\N	133221	133221	300783
17115	22725	47	applied	\N	\N	\N	\N	133222	133222	300784
17115	22729	48	applied	\N	\N	\N	\N	133223	133223	300785
17115	22730	49	applied	\N	\N	\N	\N	133224	133224	300786
17115	22736	50	applied	\N	\N	\N	\N	133225	133225	300787
17115	22740	51	applied	\N	\N	\N	\N	133226	133226	300788
17115	22712	52	applied	\N	\N	\N	\N	133227	133227	300789
17115	22713	53	applied	\N	\N	\N	\N	133228	133228	300790
17115	22714	54	applied	\N	\N	\N	\N	133229	133229	300791
17115	22718	55	applied	\N	\N	\N	\N	133230	133230	300792
17115	22703	56	applied	\N	\N	\N	\N	133231	133231	300793
17115	22709	57	applied	\N	\N	\N	\N	133232	133232	300794
17115	22721	58	applied	\N	\N	\N	\N	133233	133233	300795
17115	22743	59	applied	\N	\N	\N	\N	133234	133234	300796
17115	22722	60	applied	\N	\N	\N	\N	133235	133235	300797
17115	22724	61	applied	\N	\N	\N	\N	133236	133236	300798
17115	22734	63	applied	\N	\N	\N	\N	133238	133238	300800
17115	22742	64	applied	\N	\N	\N	\N	133239	133239	300801
17115	22745	65	applied	\N	\N	\N	\N	133240	133240	300802
17115	22747	66	applied	\N	\N	\N	\N	133241	133241	300803
17115	22750	67	applied	\N	\N	\N	\N	133242	133242	300804
17115	22751	68	applied	\N	\N	\N	\N	133243	133243	300805
17115	22754	69	applied	\N	\N	\N	\N	133244	133244	300806
17115	22756	70	applied	\N	\N	\N	\N	133245	133245	300807
17115	22752	71	applied	\N	\N	\N	\N	133246	133246	300808
17115	22758	72	applied	\N	\N	\N	\N	133247	133247	300809
17115	22766	73	applied	\N	\N	\N	\N	133248	133248	300810
17115	22759	74	applied	\N	\N	\N	\N	133249	133249	300811
17115	22761	75	applied	\N	\N	\N	\N	133250	133250	300812
17115	22763	76	applied	\N	\N	\N	\N	133251	133251	300813
17115	22765	77	applied	\N	\N	\N	\N	133252	133252	300814
17115	22769	78	applied	\N	\N	\N	\N	133253	133253	300815
17115	22731	80	applied	\N	\N	\N	\N	133255	133255	300817
17115	22733	81	applied	\N	\N	\N	\N	133256	133256	300818
17115	22737	82	applied	\N	\N	\N	\N	133257	133257	300819
17115	22739	83	applied	\N	\N	\N	\N	133258	133258	300820
17118	22775	0	applied	\N	\N	\N	\N	133262	133262	300824
17118	22776	1	applied	\N	\N	\N	\N	133263	133263	300825
17120	22777	0	applied	\N	\N	\N	\N	133266	133266	300828
17120	22778	1	applied	\N	\N	\N	\N	133267	133267	300829
17123	22782	0	applied	\N	\N	\N	\N	133273	133273	300835
17123	22783	1	applied	\N	\N	\N	\N	133274	133274	300836
17124	22784	0	applied	\N	\N	\N	\N	133275	133275	300837
17124	22785	1	applied	\N	\N	\N	\N	133276	133276	300838
17125	22784	0	applied	\N	\N	\N	\N	133277	133277	300839
17125	22785	1	applied	\N	\N	\N	\N	133278	133278	300840
17098	22745	21	applied	\N	\N	\N	\N	133125	133125	300687
17098	22747	22	applied	\N	\N	\N	\N	133126	133126	300688
17127	22753	0	applied	\N	\N	\N	\N	133282	133282	300844
17127	22755	1	applied	\N	\N	\N	\N	133283	133283	300845
17127	22757	2	applied	\N	\N	\N	\N	133284	133284	300846
17127	22760	3	applied	\N	\N	\N	\N	133285	133285	300847
17127	22762	4	applied	\N	\N	\N	\N	133286	133286	300848
17127	22764	5	applied	\N	\N	\N	\N	133287	133287	300849
17127	22768	6	applied	\N	\N	\N	\N	133288	133288	300850
17127	22772	9	applied	\N	\N	\N	\N	133290	133290	300852
17127	22775	10	applied	\N	\N	\N	\N	133291	133291	300853
17127	22777	11	applied	\N	\N	\N	\N	133292	133292	300854
17127	22779	12	applied	\N	\N	\N	\N	133293	133293	300855
17127	22782	13	applied	\N	\N	\N	\N	133294	133294	300856
17127	22784	14	applied	\N	\N	\N	\N	133295	133295	300857
17127	22786	15	applied	\N	\N	\N	\N	133296	133296	300858
17127	22754	16	applied	\N	\N	\N	\N	133297	133297	300859
17127	22756	17	applied	\N	\N	\N	\N	133298	133298	300860
17127	22767	18	applied	\N	\N	\N	\N	133299	133299	300861
17127	22758	19	applied	\N	\N	\N	\N	133300	133300	300862
17127	22766	20	applied	\N	\N	\N	\N	133301	133301	300863
17127	22774	21	applied	\N	\N	\N	\N	133302	133302	300864
17127	22781	22	applied	\N	\N	\N	\N	133303	133303	300865
17127	22788	23	applied	\N	\N	\N	\N	133304	133304	300866
17127	22759	24	applied	\N	\N	\N	\N	133305	133305	300867
17127	22763	26	applied	\N	\N	\N	\N	133307	133307	300869
17127	22765	27	applied	\N	\N	\N	\N	133308	133308	300870
17127	22769	28	applied	\N	\N	\N	\N	133309	133309	300871
17127	22771	29	applied	\N	\N	\N	\N	133310	133310	300872
17127	22773	30	applied	\N	\N	\N	\N	133311	133311	300873
17127	22776	31	applied	\N	\N	\N	\N	133312	133312	300874
17127	22778	32	applied	\N	\N	\N	\N	133313	133313	300875
17127	22780	33	applied	\N	\N	\N	\N	133314	133314	300876
17127	22783	34	applied	\N	\N	\N	\N	133315	133315	300877
17127	22785	35	applied	\N	\N	\N	\N	133316	133316	300878
17129	22790	0	applied	\N	\N	\N	\N	133318	133318	300880
17129	22791	1	applied	\N	\N	\N	\N	133319	133319	300881
17129	22792	2	applied	\N	\N	\N	\N	133320	133320	300882
17132	22793	0	applied	\N	\N	\N	\N	133327	133327	300889
17132	22794	1	applied	\N	\N	\N	\N	133328	133328	300890
17132	22795	2	applied	\N	\N	\N	\N	133329	133329	300891
17134	22797	1	applied	\N	\N	\N	\N	133335	133335	300897
17134	22798	2	applied	\N	\N	\N	\N	133336	133336	300898
17134	22799	3	applied	\N	\N	\N	\N	133337	133337	300899
17139	22804	0	applied	\N	\N	\N	\N	133346	133346	300908
17139	22805	1	applied	\N	\N	\N	\N	133347	133347	300909
17141	22809	0	applied	\N	\N	\N	\N	133351	133351	300913
17141	22810	1	applied	\N	\N	\N	\N	133352	133352	300914
17141	22811	2	applied	\N	\N	\N	\N	133353	133353	300915
17141	22812	3	applied	\N	\N	\N	\N	133354	133354	300916
17149	22841	0	applied	\N	\N	\N	\N	133386	133386	300948
17149	22842	1	applied	\N	\N	\N	\N	133387	133387	300949
17149	22843	2	applied	\N	\N	\N	\N	133388	133388	300950
17149	22844	3	applied	\N	\N	\N	\N	133389	133389	300951
17155	22848	0	applied	\N	\N	\N	\N	133542	133542	301104
17155	22849	1	applied	\N	\N	\N	\N	133543	133543	301105
17155	22850	2	applied	\N	\N	\N	\N	133544	133544	301106
17155	22852	4	applied	\N	\N	\N	\N	133546	133546	301108
17155	22853	5	applied	\N	\N	\N	\N	133547	133547	301109
17155	22854	6	applied	\N	\N	\N	\N	133548	133548	301110
17155	22855	7	applied	\N	\N	\N	\N	133549	133549	301111
17155	22856	8	applied	\N	\N	\N	\N	133550	133550	301112
17155	22857	9	applied	\N	\N	\N	\N	133551	133551	301113
17159	22858	0	applied	\N	\N	\N	\N	133578	133578	301140
17159	22859	1	applied	\N	\N	\N	\N	133579	133579	301141
17159	22860	2	applied	\N	\N	\N	\N	133580	133580	301142
17159	22861	3	applied	\N	\N	\N	\N	133581	133581	301143
17159	22862	4	applied	\N	\N	\N	\N	133582	133582	301144
17159	22863	5	applied	\N	\N	\N	\N	133583	133583	301145
17159	22864	6	applied	\N	\N	\N	\N	133584	133584	301146
17169	22715	0	applied	\N	\N	\N	\N	133765	133765	301327
17169	22570	2	applied	\N	\N	1000000000	\N	133767	133767	301329
17169	22640	3	applied	\N	\N	1000000000	\N	133768	133768	301330
17169	22698	4	applied	\N	\N	\N	\N	133769	133769	301331
17169	22790	5	applied	\N	\N	\N	\N	133770	133770	301332
17169	22806	6	applied	\N	\N	1000000000	\N	133771	133771	301333
17169	22830	7	applied	\N	\N	1000000000	\N	133772	133772	301334
17169	22850	8	applied	\N	\N	\N	\N	133773	133773	301335
17169	22707	9	applied	\N	\N	\N	\N	133774	133774	301336
17169	22767	10	applied	\N	\N	\N	\N	133775	133775	301337
17172	22902	0	applied	\N	\N	\N	\N	133786	133786	301348
17172	22903	1	applied	\N	\N	\N	\N	133787	133787	301349
17172	22904	2	applied	\N	\N	\N	\N	133788	133788	301350
17174	22908	0	applied	\N	\N	\N	\N	133792	133792	301354
17174	22909	1	applied	\N	\N	\N	\N	133793	133793	301355
17174	22910	2	applied	\N	\N	\N	\N	133794	133794	301356
17174	22911	3	applied	\N	\N	\N	\N	133795	133795	301357
17178	22912	0	applied	\N	\N	\N	\N	133808	133808	301370
17178	22913	1	applied	\N	\N	\N	\N	133809	133809	301371
17178	22914	2	applied	\N	\N	\N	\N	133810	133810	301372
17181	22915	0	applied	\N	\N	\N	\N	133820	133820	301382
17181	22917	2	applied	\N	\N	\N	\N	133822	133822	301384
17181	22918	3	applied	\N	\N	\N	\N	133823	133823	301385
17181	22919	4	applied	\N	\N	\N	\N	133824	133824	301386
17181	22920	5	applied	\N	\N	\N	\N	133825	133825	301387
17192	22937	0	applied	\N	\N	\N	\N	133860	133860	301422
17192	22938	1	applied	\N	\N	\N	\N	133861	133861	301423
17192	22939	2	applied	\N	\N	\N	\N	133862	133862	301424
17195	22940	0	applied	\N	\N	\N	\N	133868	133868	301430
17195	22941	1	applied	\N	\N	\N	\N	133869	133869	301431
17195	22942	2	applied	\N	\N	\N	\N	133870	133870	301432
17195	22943	3	applied	\N	\N	\N	\N	133871	133871	301433
17199	22947	0	applied	\N	\N	\N	\N	133882	133882	301444
17199	22948	1	applied	\N	\N	\N	\N	133883	133883	301445
17199	22949	2	applied	\N	\N	\N	\N	133884	133884	301446
17199	22950	3	applied	\N	\N	\N	\N	133885	133885	301447
17199	22951	4	applied	\N	\N	\N	\N	133886	133886	301448
17204	22956	0	applied	\N	\N	\N	\N	133900	133900	301462
17204	22957	1	applied	\N	\N	\N	\N	133901	133901	301463
17204	22958	2	applied	\N	\N	\N	\N	133902	133902	301464
17216	22970	0	applied	\N	\N	\N	\N	133944	133944	301506
17126	22787	1	applied	\N	\N	\N	\N	133280	133280	300842
17126	22788	2	applied	\N	\N	\N	\N	133281	133281	300843
17130	22795	2	applied	\N	\N	\N	\N	133323	133323	300885
17131	22793	0	applied	\N	\N	\N	\N	133324	133324	300886
17131	22794	1	applied	\N	\N	\N	\N	133325	133325	300887
17131	22795	2	applied	\N	\N	\N	\N	133326	133326	300888
17133	22796	0	applied	\N	\N	\N	\N	133330	133330	300892
17133	22798	2	applied	\N	\N	\N	\N	133332	133332	300894
17133	22799	3	applied	\N	\N	\N	\N	133333	133333	300895
17135	22800	0	applied	\N	\N	\N	\N	133338	133338	300900
17135	22801	1	applied	\N	\N	\N	\N	133339	133339	300901
17136	22800	0	applied	\N	\N	\N	\N	133340	133340	300902
17136	22801	1	applied	\N	\N	\N	\N	133341	133341	300903
17137	22802	0	applied	\N	\N	\N	\N	133342	133342	300904
17137	22803	1	applied	\N	\N	\N	\N	133343	133343	300905
17138	22804	0	applied	\N	\N	\N	\N	133344	133344	300906
17138	22805	1	applied	\N	\N	\N	\N	133345	133345	300907
17140	22806	0	applied	\N	\N	1000000000	\N	133348	133348	300910
17140	22807	1	applied	\N	\N	\N	\N	133349	133349	300911
17140	22808	2	applied	\N	\N	\N	\N	133350	133350	300912
17143	22822	0	applied	\N	\N	\N	\N	133364	133364	300926
17143	22823	1	applied	\N	\N	\N	\N	133365	133365	300927
17143	22824	2	applied	\N	\N	\N	\N	133366	133366	300928
17145	22826	1	applied	\N	\N	\N	\N	133371	133371	300933
17145	22827	2	applied	\N	\N	\N	\N	133372	133372	300934
17147	22828	0	applied	\N	\N	\N	\N	133373	133373	300935
17147	22829	1	applied	\N	\N	\N	\N	133374	133374	300936
17147	22830	2	applied	\N	\N	1000000000	\N	133375	133375	300937
17147	22831	3	applied	\N	\N	\N	\N	133376	133376	300938
17147	22832	4	applied	\N	\N	\N	\N	133377	133377	300939
17147	22833	5	applied	\N	\N	\N	\N	133378	133378	300940
17147	22834	6	applied	\N	\N	\N	\N	133379	133379	300941
17147	22835	7	applied	\N	\N	\N	\N	133380	133380	300942
17148	22836	0	applied	\N	\N	\N	\N	133381	133381	300943
17148	22837	1	applied	\N	\N	\N	\N	133382	133382	300944
17148	22838	2	applied	\N	\N	\N	\N	133383	133383	300945
17148	22839	3	applied	\N	\N	\N	\N	133384	133384	300946
17148	22840	4	applied	\N	\N	\N	\N	133385	133385	300947
17151	22715	0	applied	\N	\N	\N	\N	133394	133394	300956
17151	22521	2	applied	\N	\N	\N	\N	133396	133396	300958
17151	22522	3	applied	\N	\N	\N	\N	133397	133397	300959
17151	22640	4	applied	\N	\N	1000000000	\N	133398	133398	300960
17151	22698	5	applied	\N	\N	\N	\N	133399	133399	300961
17151	22790	6	applied	\N	\N	\N	\N	133400	133400	300962
17151	22806	7	applied	\N	\N	1000000000	\N	133401	133401	300963
17151	22830	8	applied	\N	\N	1000000000	\N	133402	133402	300964
17151	22525	9	applied	\N	\N	\N	\N	133403	133403	300965
17151	22527	10	applied	\N	\N	\N	\N	133404	133404	300966
17151	22528	11	applied	\N	\N	\N	\N	133405	133405	300967
17151	22532	12	applied	\N	\N	\N	\N	133406	133406	300968
17151	22534	13	applied	\N	\N	\N	\N	133407	133407	300969
17151	22536	14	applied	\N	\N	\N	\N	133408	133408	300970
17151	22539	15	applied	\N	\N	\N	\N	133409	133409	300971
17151	22541	16	applied	\N	\N	\N	\N	133410	133410	300972
17151	22542	17	applied	\N	\N	\N	\N	133411	133411	300973
17151	22546	18	applied	\N	\N	\N	\N	133412	133412	300974
17151	22548	19	applied	\N	\N	\N	\N	133413	133413	300975
17151	22553	21	applied	\N	\N	\N	\N	133415	133415	300977
17151	22554	22	applied	\N	\N	\N	\N	133416	133416	300978
17151	22557	23	applied	\N	\N	\N	\N	133417	133417	300979
17151	22558	24	applied	\N	\N	\N	\N	133418	133418	300980
17151	22562	25	applied	\N	\N	\N	\N	133419	133419	300981
17151	22564	26	applied	\N	\N	\N	\N	133420	133420	300982
17151	22565	27	applied	\N	\N	\N	\N	133421	133421	300983
17151	22569	28	applied	\N	\N	\N	\N	133422	133422	300984
17151	22573	29	applied	\N	\N	\N	\N	133423	133423	300985
17151	22575	30	applied	\N	\N	\N	\N	133424	133424	300986
17151	22576	31	applied	\N	\N	\N	\N	133425	133425	300987
17151	22582	32	applied	\N	\N	\N	\N	133426	133426	300988
17151	22585	33	applied	\N	\N	\N	\N	133427	133427	300989
17151	22588	34	applied	\N	\N	\N	\N	133428	133428	300990
17151	22589	35	applied	\N	\N	\N	\N	133429	133429	300991
17151	22595	36	applied	\N	\N	\N	\N	133430	133430	300992
17151	22603	38	applied	\N	\N	\N	\N	133432	133432	300994
17151	22605	39	applied	\N	\N	\N	\N	133433	133433	300995
17151	22608	40	applied	\N	\N	\N	\N	133434	133434	300996
17151	22612	41	applied	\N	\N	\N	\N	133435	133435	300997
17151	22615	42	applied	\N	\N	\N	\N	133436	133436	300998
17151	22618	43	applied	\N	\N	\N	\N	133437	133437	300999
17151	22621	44	applied	\N	\N	\N	\N	133438	133438	301000
17151	22622	45	applied	\N	\N	\N	\N	133439	133439	301001
17151	22627	46	applied	\N	\N	\N	\N	133440	133440	301002
17151	22631	47	applied	\N	\N	\N	\N	133441	133441	301003
17151	22634	48	applied	\N	\N	\N	\N	133442	133442	301004
17151	22637	49	applied	\N	\N	\N	\N	133443	133443	301005
17151	22641	50	applied	\N	\N	\N	\N	133444	133444	301006
17151	22645	51	applied	\N	\N	\N	\N	133445	133445	301007
17151	22648	52	applied	\N	\N	\N	\N	133446	133446	301008
17151	22649	53	applied	\N	\N	\N	\N	133447	133447	301009
17151	22658	55	applied	\N	\N	\N	\N	133449	133449	301011
17151	22661	56	applied	\N	\N	\N	\N	133450	133450	301012
17151	22666	57	applied	\N	\N	\N	\N	133451	133451	301013
17151	22667	58	applied	\N	\N	\N	\N	133452	133452	301014
17151	22668	59	applied	\N	\N	\N	\N	133453	133453	301015
17151	22669	60	applied	\N	\N	\N	\N	133454	133454	301016
17151	22678	61	applied	\N	\N	\N	\N	133455	133455	301017
17151	22681	62	applied	\N	\N	\N	\N	133456	133456	301018
17151	22684	63	applied	\N	\N	\N	\N	133457	133457	301019
17151	22688	64	applied	\N	\N	\N	\N	133458	133458	301020
17151	22690	65	applied	\N	\N	\N	\N	133459	133459	301021
17151	22693	66	applied	\N	\N	\N	\N	133460	133460	301022
17151	22696	67	applied	\N	\N	\N	\N	133461	133461	301023
17151	22697	68	applied	\N	\N	\N	\N	133462	133462	301024
17151	22704	69	applied	\N	\N	\N	\N	133463	133463	301025
17151	22705	70	applied	\N	\N	\N	\N	133464	133464	301026
17217	22973	1	applied	\N	\N	\N	\N	133946	133946	301508
17217	22974	2	applied	\N	\N	\N	\N	133947	133947	301509
17217	22975	3	applied	\N	\N	\N	\N	133948	133948	301510
17217	22976	4	applied	\N	\N	\N	\N	133949	133949	301511
17217	22977	5	applied	\N	\N	\N	\N	133950	133950	301512
17217	22978	6	applied	\N	\N	\N	\N	133951	133951	301513
17130	22793	0	applied	\N	\N	\N	\N	133321	133321	300883
17130	22794	1	applied	\N	\N	\N	\N	133322	133322	300884
17142	22816	3	applied	\N	\N	\N	\N	133358	133358	300920
17142	22817	4	applied	\N	\N	\N	\N	133359	133359	300921
17142	22818	5	applied	\N	\N	\N	\N	133360	133360	300922
17142	22820	7	applied	\N	\N	\N	\N	133362	133362	300924
17142	22821	8	applied	\N	\N	\N	\N	133363	133363	300925
17144	22822	0	applied	\N	\N	\N	\N	133367	133367	300929
17144	22823	1	applied	\N	\N	\N	\N	133368	133368	300930
17144	22824	2	applied	\N	\N	\N	\N	133369	133369	300931
17150	22841	0	applied	\N	\N	\N	\N	133390	133390	300952
17150	22842	1	applied	\N	\N	\N	\N	133391	133391	300953
17150	22843	2	applied	\N	\N	\N	\N	133392	133392	300954
17150	22844	3	applied	\N	\N	\N	\N	133393	133393	300955
17151	22706	71	applied	\N	\N	\N	\N	133465	133465	301027
17151	22716	72	applied	\N	\N	\N	\N	133466	133466	301028
17151	22719	73	applied	\N	\N	\N	\N	133467	133467	301029
17151	22723	74	applied	\N	\N	\N	\N	133468	133468	301030
17151	22726	75	applied	\N	\N	\N	\N	133469	133469	301031
17151	22727	76	applied	\N	\N	\N	\N	133470	133470	301032
17151	22732	77	applied	\N	\N	\N	\N	133471	133471	301033
17156	22849	1	applied	\N	\N	\N	\N	133553	133553	301115
17156	22850	2	applied	\N	\N	\N	\N	133554	133554	301116
17156	22851	3	applied	\N	\N	\N	\N	133555	133555	301117
17156	22852	4	applied	\N	\N	\N	\N	133556	133556	301118
17156	22853	5	applied	\N	\N	\N	\N	133557	133557	301119
17156	22854	6	applied	\N	\N	\N	\N	133558	133558	301120
17156	22855	7	applied	\N	\N	\N	\N	133559	133559	301121
17156	22856	8	applied	\N	\N	\N	\N	133560	133560	301122
17156	22857	9	applied	\N	\N	\N	\N	133561	133561	301123
17157	22715	0	applied	\N	\N	\N	\N	133562	133562	301124
17157	22640	1	applied	\N	\N	1000000000	\N	133563	133563	301125
17157	22698	2	applied	\N	\N	\N	\N	133564	133564	301126
17157	22790	3	applied	\N	\N	\N	\N	133565	133565	301127
17157	22806	4	applied	\N	\N	1000000000	\N	133566	133566	301128
17157	22850	6	applied	\N	\N	\N	\N	133568	133568	301130
17157	22707	7	applied	\N	\N	\N	\N	133569	133569	301131
17157	22767	8	applied	\N	\N	\N	\N	133570	133570	301132
17160	22858	0	applied	\N	\N	\N	\N	133585	133585	301147
17160	22859	1	applied	\N	\N	\N	\N	133586	133586	301148
17160	22860	2	applied	\N	\N	\N	\N	133587	133587	301149
17160	22861	3	applied	\N	\N	\N	\N	133588	133588	301150
17160	22862	4	applied	\N	\N	\N	\N	133589	133589	301151
17160	22863	5	applied	\N	\N	\N	\N	133590	133590	301152
17160	22864	6	applied	\N	\N	\N	\N	133591	133591	301153
17164	22879	0	applied	\N	\N	\N	\N	133613	133613	301175
17164	22880	1	applied	\N	\N	\N	\N	133614	133614	301176
17164	22881	2	applied	\N	\N	\N	\N	133615	133615	301177
17167	22885	0	applied	\N	\N	\N	\N	133745	133745	301307
17167	22886	1	applied	\N	\N	\N	\N	133746	133746	301308
17167	22887	2	applied	\N	\N	\N	\N	133747	133747	301309
17167	22888	3	applied	\N	\N	\N	\N	133748	133748	301310
17167	22889	4	applied	\N	\N	\N	\N	133749	133749	301311
17167	22890	5	applied	\N	\N	\N	\N	133750	133750	301312
17167	22891	6	applied	\N	\N	\N	\N	133751	133751	301313
17167	22893	8	applied	\N	\N	\N	\N	133753	133753	301315
17167	22894	9	applied	\N	\N	\N	\N	133754	133754	301316
17175	22908	0	applied	\N	\N	\N	\N	133796	133796	301358
17175	22909	1	applied	\N	\N	\N	\N	133797	133797	301359
17175	22910	2	applied	\N	\N	\N	\N	133798	133798	301360
17175	22911	3	applied	\N	\N	\N	\N	133799	133799	301361
17179	22912	0	applied	\N	\N	\N	\N	133811	133811	301373
17179	22913	1	applied	\N	\N	\N	\N	133812	133812	301374
17179	22914	2	applied	\N	\N	\N	\N	133813	133813	301375
17182	22915	0	applied	\N	\N	\N	\N	133826	133826	301388
17182	22916	1	applied	\N	\N	\N	\N	133827	133827	301389
17182	22917	2	applied	\N	\N	\N	\N	133828	133828	301390
17182	22918	3	applied	\N	\N	\N	\N	133829	133829	301391
17182	22919	4	applied	\N	\N	\N	\N	133830	133830	301392
17182	22920	5	applied	\N	\N	\N	\N	133831	133831	301393
17184	22916	0	applied	\N	\N	\N	\N	133833	133833	301395
17188	22921	0	applied	\N	\N	\N	\N	133835	133835	301397
17188	22922	1	applied	\N	\N	\N	\N	133836	133836	301398
17188	22923	2	applied	\N	\N	\N	\N	133837	133837	301399
17188	22924	3	applied	\N	\N	\N	\N	133838	133838	301400
17188	22925	4	applied	\N	\N	\N	\N	133839	133839	301401
17188	22926	5	applied	\N	\N	\N	\N	133840	133840	301402
17188	22927	6	applied	\N	\N	\N	\N	133841	133841	301403
17188	22928	7	applied	\N	\N	\N	\N	133842	133842	301404
17188	22929	8	applied	\N	\N	\N	\N	133843	133843	301405
17190	22930	0	applied	\N	\N	\N	\N	133853	133853	301415
17190	22931	1	applied	\N	\N	\N	\N	133854	133854	301416
17190	22932	2	applied	\N	\N	\N	\N	133855	133855	301417
17190	22933	3	applied	\N	\N	\N	\N	133856	133856	301418
17193	22916	0	applied	\N	\N	\N	\N	133863	133863	301425
17196	22940	0	applied	\N	\N	\N	\N	133872	133872	301434
17196	22942	1	applied	\N	\N	\N	\N	133873	133873	301435
17200	22953	0	applied	\N	\N	\N	\N	133888	133888	301450
17200	22954	1	applied	\N	\N	\N	\N	133889	133889	301451
17200	22955	2	applied	\N	\N	\N	\N	133890	133890	301452
17205	22715	0	applied	\N	\N	\N	\N	133903	133903	301465
17205	22570	1	applied	\N	\N	1000000000	\N	133904	133904	301466
17205	22640	2	applied	\N	\N	1000000000	\N	133905	133905	301467
17205	22698	3	applied	\N	\N	\N	\N	133906	133906	301468
17205	22790	4	applied	\N	\N	\N	\N	133907	133907	301469
17205	22806	5	applied	\N	\N	1000000000	\N	133908	133908	301470
17205	22830	6	applied	\N	\N	1000000000	\N	133909	133909	301471
17205	22850	7	applied	\N	\N	\N	\N	133910	133910	301472
17205	22707	8	applied	\N	\N	\N	\N	133911	133911	301473
17205	22916	9	applied	\N	\N	\N	\N	133912	133912	301474
17205	22767	10	applied	\N	\N	\N	\N	133913	133913	301475
17206	22956	0	applied	\N	\N	\N	\N	133914	133914	301476
17206	22957	1	applied	\N	\N	\N	\N	133915	133915	301477
17209	22959	0	applied	\N	\N	\N	\N	133922	133922	301484
17209	22960	1	applied	\N	\N	\N	\N	133923	133923	301485
17209	22961	2	applied	\N	\N	\N	\N	133924	133924	301486
17213	22969	0	applied	\N	\N	\N	\N	133935	133935	301497
17213	22970	1	applied	\N	\N	\N	\N	133936	133936	301498
17213	22971	2	applied	\N	\N	\N	\N	133937	133937	301499
17218	22972	0	applied	\N	\N	\N	\N	133952	133952	301514
17218	22973	1	applied	\N	\N	\N	\N	133953	133953	301515
17142	22814	1	applied	\N	\N	\N	\N	133356	133356	300918
17142	22815	2	applied	\N	\N	\N	\N	133357	133357	300919
17151	22746	82	applied	\N	\N	\N	\N	133476	133476	301038
17151	22748	83	applied	\N	\N	\N	\N	133477	133477	301039
17151	22749	84	applied	\N	\N	\N	\N	133478	133478	301040
17151	22753	85	applied	\N	\N	\N	\N	133479	133479	301041
17151	22755	86	applied	\N	\N	\N	\N	133480	133480	301042
17151	22757	87	applied	\N	\N	\N	\N	133481	133481	301043
17151	22760	88	applied	\N	\N	\N	\N	133482	133482	301044
17151	22762	89	applied	\N	\N	\N	\N	133483	133483	301045
17151	22764	90	applied	\N	\N	\N	\N	133484	133484	301046
17151	22768	91	applied	\N	\N	\N	\N	133485	133485	301047
17151	22770	92	applied	\N	\N	\N	\N	133486	133486	301048
17151	22772	93	applied	\N	\N	\N	\N	133487	133487	301049
17151	22777	95	applied	\N	\N	\N	\N	133489	133489	301051
17151	22779	96	applied	\N	\N	\N	\N	133490	133490	301052
17151	22782	97	applied	\N	\N	\N	\N	133491	133491	301053
17151	22784	98	applied	\N	\N	\N	\N	133492	133492	301054
17151	22786	99	applied	\N	\N	\N	\N	133493	133493	301055
17151	22789	100	applied	\N	\N	\N	\N	133494	133494	301056
17151	22791	102	applied	\N	\N	\N	\N	133495	133495	301057
17151	22793	103	applied	\N	\N	\N	\N	133496	133496	301058
17151	22796	104	applied	\N	\N	\N	\N	133497	133497	301059
17151	22797	105	applied	\N	\N	\N	\N	133498	133498	301060
17151	22800	106	applied	\N	\N	\N	\N	133499	133499	301061
17151	22802	107	applied	\N	\N	\N	\N	133500	133500	301062
17151	22804	108	applied	\N	\N	\N	\N	133501	133501	301063
17151	22807	109	applied	\N	\N	\N	\N	133502	133502	301064
17151	22809	110	applied	\N	\N	\N	\N	133503	133503	301065
17151	22813	111	applied	\N	\N	\N	\N	133504	133504	301066
17151	22815	113	applied	\N	\N	\N	\N	133506	133506	301068
17151	22822	114	applied	\N	\N	\N	\N	133507	133507	301069
17151	22825	115	applied	\N	\N	\N	\N	133508	133508	301070
17151	22828	116	applied	\N	\N	\N	\N	133509	133509	301071
17151	22829	117	applied	\N	\N	\N	\N	133510	133510	301072
17151	22836	118	applied	\N	\N	\N	\N	133511	133511	301073
17151	22837	119	applied	\N	\N	\N	\N	133512	133512	301074
17151	22841	120	applied	\N	\N	\N	\N	133513	133513	301075
17151	22707	121	applied	\N	\N	\N	\N	133514	133514	301076
17151	22767	122	applied	\N	\N	\N	\N	133515	133515	301077
17151	22523	123	applied	\N	\N	\N	\N	133516	133516	301078
17151	22529	124	applied	\N	\N	\N	\N	133517	133517	301079
17151	22537	125	applied	\N	\N	\N	\N	133518	133518	301080
17154	22848	0	applied	\N	\N	\N	\N	133532	133532	301094
17154	22849	1	applied	\N	\N	\N	\N	133533	133533	301095
17154	22850	2	applied	\N	\N	\N	\N	133534	133534	301096
17154	22852	4	applied	\N	\N	\N	\N	133536	133536	301098
17154	22853	5	applied	\N	\N	\N	\N	133537	133537	301099
17154	22854	6	applied	\N	\N	\N	\N	133538	133538	301100
17154	22855	7	applied	\N	\N	\N	\N	133539	133539	301101
17154	22856	8	applied	\N	\N	\N	\N	133540	133540	301102
17154	22857	9	applied	\N	\N	\N	\N	133541	133541	301103
17158	22858	0	applied	\N	\N	\N	\N	133571	133571	301133
17158	22859	1	applied	\N	\N	\N	\N	133572	133572	301134
17158	22860	2	applied	\N	\N	\N	\N	133573	133573	301135
17158	22861	3	applied	\N	\N	\N	\N	133574	133574	301136
17158	22862	4	applied	\N	\N	\N	\N	133575	133575	301137
17158	22863	5	applied	\N	\N	\N	\N	133576	133576	301138
17158	22864	6	applied	\N	\N	\N	\N	133577	133577	301139
17162	22865	0	applied	\N	\N	\N	\N	133599	133599	301161
17162	22866	1	applied	\N	\N	\N	\N	133600	133600	301162
17162	22867	2	applied	\N	\N	\N	\N	133601	133601	301163
17163	22869	0	applied	\N	\N	\N	\N	133603	133603	301165
17163	22870	1	applied	\N	\N	\N	\N	133604	133604	301166
17163	22871	2	applied	\N	\N	\N	\N	133605	133605	301167
17163	22872	3	applied	\N	\N	\N	\N	133606	133606	301168
17163	22873	4	applied	\N	\N	\N	\N	133607	133607	301169
17163	22874	5	applied	\N	\N	\N	\N	133608	133608	301170
17163	22875	6	applied	\N	\N	\N	\N	133609	133609	301171
17163	22876	7	applied	\N	\N	\N	\N	133610	133610	301172
17163	22877	8	applied	\N	\N	\N	\N	133611	133611	301173
17163	22878	9	applied	\N	\N	\N	\N	133612	133612	301174
17166	22715	0	applied	\N	\N	\N	\N	133619	133619	301181
17166	22698	1	applied	\N	\N	\N	\N	133620	133620	301182
17166	22790	2	applied	\N	\N	\N	\N	133621	133621	301183
17166	22806	3	applied	\N	\N	1000000000	\N	133622	133622	301184
17166	22850	5	applied	\N	\N	\N	\N	133624	133624	301186
17166	22666	6	applied	\N	\N	\N	\N	133625	133625	301187
17166	22667	7	applied	\N	\N	\N	\N	133626	133626	301188
17166	22668	8	applied	\N	\N	\N	\N	133627	133627	301189
17166	22669	9	applied	\N	\N	\N	\N	133628	133628	301190
17166	22678	10	applied	\N	\N	\N	\N	133629	133629	301191
17166	22681	11	applied	\N	\N	\N	\N	133630	133630	301192
17166	22684	12	applied	\N	\N	\N	\N	133631	133631	301193
17166	22688	13	applied	\N	\N	\N	\N	133632	133632	301194
17166	22690	14	applied	\N	\N	\N	\N	133633	133633	301195
17166	22693	15	applied	\N	\N	\N	\N	133634	133634	301196
17166	22696	16	applied	\N	\N	\N	\N	133635	133635	301197
17166	22697	17	applied	\N	\N	\N	\N	133636	133636	301198
17166	22704	18	applied	\N	\N	\N	\N	133637	133637	301199
17166	22705	19	applied	\N	\N	\N	\N	133638	133638	301200
17166	22706	20	applied	\N	\N	\N	\N	133639	133639	301201
17166	22716	21	applied	\N	\N	\N	\N	133640	133640	301202
17166	22719	22	applied	\N	\N	\N	\N	133641	133641	301203
17166	22723	23	applied	\N	\N	\N	\N	133642	133642	301204
17166	22726	24	applied	\N	\N	\N	\N	133643	133643	301205
17166	22732	26	applied	\N	\N	\N	\N	133645	133645	301207
17166	22735	27	applied	\N	\N	\N	\N	133646	133646	301208
17166	22738	28	applied	\N	\N	\N	\N	133647	133647	301209
17166	22741	29	applied	\N	\N	\N	\N	133648	133648	301210
17166	22744	30	applied	\N	\N	\N	\N	133649	133649	301211
17166	22746	31	applied	\N	\N	\N	\N	133650	133650	301212
17166	22748	32	applied	\N	\N	\N	\N	133651	133651	301213
17166	22749	33	applied	\N	\N	\N	\N	133652	133652	301214
17218	22974	2	applied	\N	\N	\N	\N	133954	133954	301516
17218	22975	3	applied	\N	\N	\N	\N	133955	133955	301517
17218	22976	4	applied	\N	\N	\N	\N	133956	133956	301518
17218	22977	5	applied	\N	\N	\N	\N	133957	133957	301519
17218	22978	6	applied	\N	\N	\N	\N	133958	133958	301520
17224	22985	0	applied	\N	\N	\N	\N	133978	133978	301540
17224	22986	1	applied	\N	\N	\N	\N	133979	133979	301541
17151	22738	79	applied	\N	\N	\N	\N	133473	133473	301035
17151	22744	81	applied	\N	\N	\N	\N	133475	133475	301037
17153	22849	1	applied	\N	\N	\N	\N	133523	133523	301085
17153	22850	2	applied	\N	\N	\N	\N	133524	133524	301086
17153	22851	3	applied	\N	\N	\N	\N	133525	133525	301087
17153	22852	4	applied	\N	\N	\N	\N	133526	133526	301088
17153	22853	5	applied	\N	\N	\N	\N	133527	133527	301089
17153	22854	6	applied	\N	\N	\N	\N	133528	133528	301090
17153	22855	7	applied	\N	\N	\N	\N	133529	133529	301091
17153	22856	8	applied	\N	\N	\N	\N	133530	133530	301092
17153	22857	9	applied	\N	\N	\N	\N	133531	133531	301093
17161	22858	0	applied	\N	\N	\N	\N	133592	133592	301154
17161	22859	1	applied	\N	\N	\N	\N	133593	133593	301155
17161	22860	2	applied	\N	\N	\N	\N	133594	133594	301156
17161	22861	3	applied	\N	\N	\N	\N	133595	133595	301157
17161	22862	4	applied	\N	\N	\N	\N	133596	133596	301158
17161	22863	5	applied	\N	\N	\N	\N	133597	133597	301159
17161	22864	6	applied	\N	\N	\N	\N	133598	133598	301160
17165	22883	1	applied	\N	\N	\N	\N	133617	133617	301179
17165	22884	2	applied	\N	\N	\N	\N	133618	133618	301180
17166	22753	34	applied	\N	\N	\N	\N	133653	133653	301215
17166	22755	35	applied	\N	\N	\N	\N	133654	133654	301216
17166	22757	36	applied	\N	\N	\N	\N	133655	133655	301217
17166	22760	37	applied	\N	\N	\N	\N	133656	133656	301218
17166	22762	38	applied	\N	\N	\N	\N	133657	133657	301219
17166	22764	39	applied	\N	\N	\N	\N	133658	133658	301220
17166	22768	40	applied	\N	\N	\N	\N	133659	133659	301221
17168	22885	0	applied	\N	\N	\N	\N	133755	133755	301317
17168	22886	1	applied	\N	\N	\N	\N	133756	133756	301318
17168	22887	2	applied	\N	\N	\N	\N	133757	133757	301319
17168	22888	3	applied	\N	\N	\N	\N	133758	133758	301320
17168	22889	4	applied	\N	\N	\N	\N	133759	133759	301321
17168	22890	5	applied	\N	\N	\N	\N	133760	133760	301322
17168	22891	6	applied	\N	\N	\N	\N	133761	133761	301323
17168	22893	8	applied	\N	\N	\N	\N	133763	133763	301325
17168	22894	9	applied	\N	\N	\N	\N	133764	133764	301326
17170	22895	0	applied	\N	\N	\N	\N	133776	133776	301338
17170	22896	1	applied	\N	\N	\N	\N	133777	133777	301339
17170	22897	2	applied	\N	\N	\N	\N	133778	133778	301340
17170	22898	3	applied	\N	\N	\N	\N	133779	133779	301341
17170	22899	4	applied	\N	\N	\N	\N	133780	133780	301342
17170	22900	5	applied	\N	\N	\N	\N	133781	133781	301343
17170	22901	6	applied	\N	\N	\N	\N	133782	133782	301344
17176	22908	0	applied	\N	\N	\N	\N	133800	133800	301362
17176	22909	1	applied	\N	\N	\N	\N	133801	133801	301363
17176	22910	2	applied	\N	\N	\N	\N	133802	133802	301364
17176	22911	3	applied	\N	\N	\N	\N	133803	133803	301365
17189	22921	0	applied	\N	\N	\N	\N	133844	133844	301406
17189	22922	1	applied	\N	\N	\N	\N	133845	133845	301407
17189	22923	2	applied	\N	\N	\N	\N	133846	133846	301408
17189	22925	4	applied	\N	\N	\N	\N	133848	133848	301410
17189	22926	5	applied	\N	\N	\N	\N	133849	133849	301411
17189	22927	6	applied	\N	\N	\N	\N	133850	133850	301412
17189	22928	7	applied	\N	\N	\N	\N	133851	133851	301413
17189	22929	8	applied	\N	\N	\N	\N	133852	133852	301414
17191	22934	0	applied	\N	\N	\N	\N	133857	133857	301419
17191	22935	1	applied	\N	\N	\N	\N	133858	133858	301420
17191	22936	2	applied	\N	\N	\N	\N	133859	133859	301421
17197	22940	0	applied	\N	\N	\N	\N	133875	133875	301437
17197	22941	1	applied	\N	\N	\N	\N	133876	133876	301438
17197	22942	2	applied	\N	\N	\N	\N	133877	133877	301439
17197	22943	3	applied	\N	\N	\N	\N	133878	133878	301440
17201	22953	0	applied	\N	\N	\N	\N	133891	133891	301453
17201	22954	1	applied	\N	\N	\N	\N	133892	133892	301454
17201	22955	2	applied	\N	\N	\N	\N	133893	133893	301455
17207	22959	0	applied	\N	\N	\N	\N	133917	133917	301479
17211	22962	0	applied	\N	\N	\N	\N	133928	133928	301490
17211	22963	1	applied	\N	\N	\N	\N	133929	133929	301491
17211	22964	2	applied	\N	\N	\N	\N	133930	133930	301492
17211	22965	3	applied	\N	\N	\N	\N	133931	133931	301493
17214	22969	0	applied	\N	\N	\N	\N	133938	133938	301500
17214	22970	1	applied	\N	\N	\N	\N	133939	133939	301501
17214	22971	2	applied	\N	\N	\N	\N	133940	133940	301502
17219	22972	0	applied	\N	\N	\N	\N	133959	133959	301521
17219	22973	1	applied	\N	\N	\N	\N	133960	133960	301522
17219	22974	2	applied	\N	\N	\N	\N	133961	133961	301523
17219	22975	3	applied	\N	\N	\N	\N	133962	133962	301524
17219	22976	4	applied	\N	\N	\N	\N	133963	133963	301525
17219	22977	5	applied	\N	\N	\N	\N	133964	133964	301526
17219	22978	6	applied	\N	\N	\N	\N	133965	133965	301527
17226	22991	0	applied	\N	\N	\N	\N	133984	133984	301546
17226	22992	1	applied	\N	\N	\N	\N	133985	133985	301547
17229	22998	0	applied	\N	\N	\N	\N	133997	133997	301559
17229	22999	1	applied	\N	\N	\N	\N	133998	133998	301560
17229	23000	2	applied	\N	\N	\N	\N	133999	133999	301561
17229	23001	3	applied	\N	\N	\N	\N	134000	134000	301562
17229	23002	4	applied	\N	\N	\N	\N	134001	134001	301563
17229	23003	5	applied	\N	\N	\N	\N	134002	134002	301564
17241	23023	0	applied	\N	\N	\N	\N	134055	134055	301617
17241	23024	1	applied	\N	\N	\N	\N	134056	134056	301618
17241	23025	2	applied	\N	\N	\N	\N	134057	134057	301619
17241	23026	3	applied	\N	\N	\N	\N	134058	134058	301620
17241	23027	4	applied	\N	\N	\N	\N	134059	134059	301621
17241	23028	5	applied	\N	\N	\N	\N	134060	134060	301622
17241	23029	6	applied	\N	\N	\N	\N	134061	134061	301623
17243	23030	0	applied	\N	\N	\N	\N	134069	134069	301631
17243	23031	1	applied	\N	\N	\N	\N	134070	134070	301632
17243	23032	2	applied	\N	\N	\N	\N	134071	134071	301633
17249	23036	1	applied	\N	\N	\N	\N	134207	134207	301769
17249	23037	2	applied	\N	\N	\N	\N	134208	134208	301770
17249	23038	3	applied	\N	\N	\N	\N	134209	134209	301771
17249	23039	4	applied	\N	\N	\N	\N	134210	134210	301772
17249	23040	5	applied	\N	\N	\N	\N	134211	134211	301773
17252	23044	0	applied	\N	\N	\N	\N	134218	134218	301780
17252	23045	1	applied	\N	\N	\N	\N	134219	134219	301781
17252	23046	2	applied	\N	\N	\N	\N	134220	134220	301782
17252	23047	3	applied	\N	\N	\N	\N	134221	134221	301783
17252	23048	4	applied	\N	\N	\N	\N	134222	134222	301784
17252	23049	5	applied	\N	\N	\N	\N	134223	134223	301785
17266	23068	0	applied	\N	\N	\N	\N	134268	134268	301830
17266	23069	1	applied	\N	\N	\N	\N	134269	134269	301831
17266	23070	2	applied	\N	\N	\N	\N	134270	134270	301832
17152	22846	1	applied	\N	\N	\N	\N	133520	133520	301082
17152	22847	2	applied	\N	\N	\N	\N	133521	133521	301083
17166	22779	45	applied	\N	\N	\N	\N	133664	133664	301226
17166	22782	46	applied	\N	\N	\N	\N	133665	133665	301227
17166	22784	47	applied	\N	\N	\N	\N	133666	133666	301228
17166	22786	48	applied	\N	\N	\N	\N	133667	133667	301229
17166	22789	49	applied	\N	\N	\N	\N	133668	133668	301230
17166	22791	50	applied	\N	\N	\N	\N	133669	133669	301231
17166	22793	51	applied	\N	\N	\N	\N	133670	133670	301232
17166	22796	52	applied	\N	\N	\N	\N	133671	133671	301233
17166	22797	53	applied	\N	\N	\N	\N	133672	133672	301234
17166	22800	54	applied	\N	\N	\N	\N	133673	133673	301235
17166	22802	55	applied	\N	\N	\N	\N	133674	133674	301236
17166	22804	56	applied	\N	\N	\N	\N	133675	133675	301237
17166	22807	57	applied	\N	\N	\N	\N	133676	133676	301238
17166	22809	58	applied	\N	\N	\N	\N	133677	133677	301239
17166	22813	59	applied	\N	\N	\N	\N	133678	133678	301240
17166	22814	60	applied	\N	\N	\N	\N	133679	133679	301241
17166	22822	62	applied	\N	\N	\N	\N	133681	133681	301243
17166	22825	63	applied	\N	\N	\N	\N	133682	133682	301244
17166	22828	64	applied	\N	\N	\N	\N	133683	133683	301245
17166	22829	65	applied	\N	\N	\N	\N	133684	133684	301246
17166	22836	66	applied	\N	\N	\N	\N	133685	133685	301247
17166	22837	67	applied	\N	\N	\N	\N	133686	133686	301248
17166	22841	68	applied	\N	\N	\N	\N	133687	133687	301249
17166	22845	69	applied	\N	\N	\N	\N	133688	133688	301250
17166	22848	70	applied	\N	\N	\N	\N	133689	133689	301251
17166	22849	71	applied	\N	\N	\N	\N	133690	133690	301252
17166	22859	72	applied	\N	\N	\N	\N	133691	133691	301253
17166	22860	73	applied	\N	\N	\N	\N	133692	133692	301254
17166	22865	74	applied	\N	\N	\N	\N	133693	133693	301255
17166	22869	75	applied	\N	\N	\N	\N	133694	133694	301256
17166	22870	76	applied	\N	\N	\N	\N	133695	133695	301257
17166	22871	77	applied	\N	\N	\N	\N	133696	133696	301258
17166	22882	79	applied	\N	\N	\N	\N	133698	133698	301260
17166	22885	80	applied	\N	\N	\N	\N	133699	133699	301261
17166	22886	81	applied	\N	\N	\N	\N	133700	133700	301262
17166	22707	82	applied	\N	\N	\N	\N	133701	133701	301263
17166	22665	83	applied	\N	\N	\N	\N	133702	133702	301264
17166	22670	84	applied	\N	\N	\N	\N	133703	133703	301265
17166	22767	85	applied	\N	\N	\N	\N	133704	133704	301266
17166	22671	86	applied	\N	\N	\N	\N	133705	133705	301267
17166	22672	87	applied	\N	\N	\N	\N	133706	133706	301268
17166	22673	88	applied	\N	\N	\N	\N	133707	133707	301269
17166	22680	89	applied	\N	\N	\N	\N	133708	133708	301270
17166	22682	90	applied	\N	\N	\N	\N	133709	133709	301271
17166	22685	91	applied	\N	\N	\N	\N	133710	133710	301272
17166	22692	92	applied	\N	\N	\N	\N	133711	133711	301273
17166	22694	93	applied	\N	\N	\N	\N	133712	133712	301274
17166	22699	94	applied	\N	\N	\N	\N	133713	133713	301275
17166	22708	96	applied	\N	\N	\N	\N	133715	133715	301277
17166	22710	97	applied	\N	\N	\N	\N	133716	133716	301278
17166	22711	98	applied	\N	\N	\N	\N	133717	133717	301279
17166	22717	99	applied	\N	\N	\N	\N	133718	133718	301280
17166	22720	100	applied	\N	\N	\N	\N	133719	133719	301281
17166	22725	101	applied	\N	\N	\N	\N	133720	133720	301282
17166	22729	102	applied	\N	\N	\N	\N	133721	133721	301283
17166	22730	103	applied	\N	\N	\N	\N	133722	133722	301284
17166	22736	104	applied	\N	\N	\N	\N	133723	133723	301285
17166	22740	105	applied	\N	\N	\N	\N	133724	133724	301286
17166	22674	106	applied	\N	\N	\N	\N	133725	133725	301287
17166	22675	107	applied	\N	\N	\N	\N	133726	133726	301288
17166	22676	108	applied	\N	\N	\N	\N	133727	133727	301289
17166	22677	109	applied	\N	\N	\N	\N	133728	133728	301290
17166	22679	110	applied	\N	\N	\N	\N	133729	133729	301291
17166	22683	111	applied	\N	\N	\N	\N	133730	133730	301292
17166	22689	113	applied	\N	\N	\N	\N	133732	133732	301294
17166	22691	114	applied	\N	\N	\N	\N	133733	133733	301295
17166	22695	115	applied	\N	\N	\N	\N	133734	133734	301296
17166	22700	116	applied	\N	\N	\N	\N	133735	133735	301297
17166	22701	117	applied	\N	\N	\N	\N	133736	133736	301298
17166	22712	118	applied	\N	\N	\N	\N	133737	133737	301299
17166	22713	119	applied	\N	\N	\N	\N	133738	133738	301300
17166	22714	120	applied	\N	\N	\N	\N	133739	133739	301301
17166	22718	121	applied	\N	\N	\N	\N	133740	133740	301302
17166	22743	122	applied	\N	\N	\N	\N	133741	133741	301303
17166	22722	123	applied	\N	\N	\N	\N	133742	133742	301304
17166	22724	124	applied	\N	\N	\N	\N	133743	133743	301305
17166	22728	125	applied	\N	\N	\N	\N	133744	133744	301306
17171	22902	0	applied	\N	\N	\N	\N	133783	133783	301345
17171	22903	1	applied	\N	\N	\N	\N	133784	133784	301346
17171	22904	2	applied	\N	\N	\N	\N	133785	133785	301347
17173	22906	1	applied	\N	\N	\N	\N	133790	133790	301352
17173	22907	2	applied	\N	\N	\N	\N	133791	133791	301353
17177	22908	0	applied	\N	\N	\N	\N	133804	133804	301366
17177	22909	1	applied	\N	\N	\N	\N	133805	133805	301367
17177	22910	2	applied	\N	\N	\N	\N	133806	133806	301368
17177	22911	3	applied	\N	\N	\N	\N	133807	133807	301369
17180	22915	0	applied	\N	\N	\N	\N	133814	133814	301376
17180	22916	1	applied	\N	\N	\N	\N	133815	133815	301377
17180	22917	2	applied	\N	\N	\N	\N	133816	133816	301378
17180	22918	3	applied	\N	\N	\N	\N	133817	133817	301379
17180	22919	4	applied	\N	\N	\N	\N	133818	133818	301380
17180	22920	5	applied	\N	\N	\N	\N	133819	133819	301381
17183	22916	0	applied	\N	\N	\N	\N	133832	133832	301394
17194	22940	0	applied	\N	\N	\N	\N	133864	133864	301426
17194	22941	1	applied	\N	\N	\N	\N	133865	133865	301427
17194	22942	2	applied	\N	\N	\N	\N	133866	133866	301428
17198	22944	0	applied	\N	\N	\N	\N	133879	133879	301441
17198	22945	1	applied	\N	\N	\N	\N	133880	133880	301442
17198	22946	2	applied	\N	\N	\N	\N	133881	133881	301443
17202	22953	0	applied	\N	\N	\N	\N	133894	133894	301456
17202	22954	1	applied	\N	\N	\N	\N	133895	133895	301457
17202	22955	2	applied	\N	\N	\N	\N	133896	133896	301458
17203	22956	0	applied	\N	\N	\N	\N	133897	133897	301459
17268	23072	0	applied	\N	\N	\N	\N	134272	134272	301834
17268	23073	1	applied	\N	\N	\N	\N	134273	134273	301835
17268	23074	2	applied	\N	\N	\N	\N	134274	134274	301836
17268	23075	3	applied	\N	\N	\N	\N	134275	134275	301837
17278	23087	0	applied	\N	\N	\N	\N	134290	134290	301852
17278	23088	1	applied	\N	\N	\N	\N	134291	134291	301853
17278	23089	3	applied	\N	\N	\N	\N	134292	134292	301854
17166	22772	42	applied	\N	\N	\N	\N	133661	133661	301223
17166	22775	43	applied	\N	\N	\N	\N	133662	133662	301224
17208	22960	1	applied	\N	\N	\N	\N	133920	133920	301482
17208	22961	2	applied	\N	\N	\N	\N	133921	133921	301483
17210	22959	0	applied	\N	\N	\N	\N	133925	133925	301487
17210	22960	1	applied	\N	\N	\N	\N	133926	133926	301488
17210	22961	2	applied	\N	\N	\N	\N	133927	133927	301489
17212	22966	0	applied	\N	\N	\N	\N	133932	133932	301494
17212	22967	1	applied	\N	\N	\N	\N	133933	133933	301495
17212	22968	2	applied	\N	\N	\N	\N	133934	133934	301496
17215	22969	0	applied	\N	\N	\N	\N	133941	133941	301503
17215	22970	1	applied	\N	\N	\N	\N	133942	133942	301504
17215	22971	2	applied	\N	\N	\N	\N	133943	133943	301505
17222	22986	1	applied	\N	\N	\N	\N	133973	133973	301535
17222	22987	2	applied	\N	\N	\N	\N	133974	133974	301536
17232	23004	0	applied	\N	\N	\N	\N	134017	134017	301579
17232	23005	1	applied	\N	\N	\N	\N	134018	134018	301580
17232	23006	3	applied	\N	\N	\N	\N	134019	134019	301581
17232	23007	4	applied	\N	\N	\N	\N	134020	134020	301582
17232	23008	5	applied	\N	\N	\N	\N	134021	134021	301583
17232	23009	6	applied	\N	\N	\N	\N	134022	134022	301584
17232	23010	7	applied	\N	\N	\N	\N	134023	134023	301585
17234	23011	0	applied	\N	\N	\N	\N	134031	134031	301593
17234	23012	1	applied	\N	\N	\N	\N	134032	134032	301594
17234	23013	2	applied	\N	\N	\N	\N	134033	134033	301595
17234	23014	3	applied	\N	\N	\N	\N	134034	134034	301596
17234	23015	4	applied	\N	\N	\N	\N	134035	134035	301597
17234	23016	5	applied	\N	\N	\N	\N	134036	134036	301598
17234	23017	6	applied	\N	\N	\N	\N	134037	134037	301599
17242	23024	1	applied	\N	\N	\N	\N	134063	134063	301625
17242	23025	2	applied	\N	\N	\N	\N	134064	134064	301626
17242	23026	3	applied	\N	\N	\N	\N	134065	134065	301627
17242	23027	4	applied	\N	\N	\N	\N	134066	134066	301628
17242	23028	5	applied	\N	\N	\N	\N	134067	134067	301629
17242	23029	6	applied	\N	\N	\N	\N	134068	134068	301630
17244	23030	0	applied	\N	\N	\N	\N	134072	134072	301634
17244	23031	1	applied	\N	\N	\N	\N	134073	134073	301635
17244	23032	2	applied	\N	\N	\N	\N	134074	134074	301636
17248	22715	0	applied	\N	\N	\N	\N	134081	134081	301643
17248	22595	1	applied	\N	\N	\N	\N	134082	134082	301644
17248	22600	2	applied	\N	\N	\N	\N	134083	134083	301645
17248	22603	3	applied	\N	\N	\N	\N	134084	134084	301646
17248	22640	4	applied	\N	\N	1000000000	\N	134085	134085	301647
17248	22605	5	applied	\N	\N	\N	\N	134086	134086	301648
17248	22608	6	applied	\N	\N	\N	\N	134087	134087	301649
17248	22615	8	applied	\N	\N	\N	\N	134089	134089	301651
17248	22618	9	applied	\N	\N	\N	\N	134090	134090	301652
17248	22621	10	applied	\N	\N	\N	\N	134091	134091	301653
17248	22622	11	applied	\N	\N	\N	\N	134092	134092	301654
17248	22627	12	applied	\N	\N	\N	\N	134093	134093	301655
17248	22631	13	applied	\N	\N	\N	\N	134094	134094	301656
17248	22634	14	applied	\N	\N	\N	\N	134095	134095	301657
17248	22698	15	applied	\N	\N	\N	\N	134096	134096	301658
17248	22790	16	applied	\N	\N	\N	\N	134097	134097	301659
17248	22806	17	applied	\N	\N	1000000000	\N	134098	134098	301660
17248	22830	18	applied	\N	\N	1000000000	\N	134099	134099	301661
17248	22850	19	applied	\N	\N	\N	\N	134100	134100	301662
17248	22637	20	applied	\N	\N	\N	\N	134101	134101	301663
17248	22641	21	applied	\N	\N	\N	\N	134102	134102	301664
17248	22645	22	applied	\N	\N	\N	\N	134103	134103	301665
17248	22648	23	applied	\N	\N	\N	\N	134104	134104	301666
17248	22655	25	applied	\N	\N	\N	\N	134106	134106	301668
17248	22658	26	applied	\N	\N	\N	\N	134107	134107	301669
17248	22661	27	applied	\N	\N	\N	\N	134108	134108	301670
17248	22666	28	applied	\N	\N	\N	\N	134109	134109	301671
17248	22667	29	applied	\N	\N	\N	\N	134110	134110	301672
17248	22668	30	applied	\N	\N	\N	\N	134111	134111	301673
17248	22669	31	applied	\N	\N	\N	\N	134112	134112	301674
17248	22678	32	applied	\N	\N	\N	\N	134113	134113	301675
17248	22681	33	applied	\N	\N	\N	\N	134114	134114	301676
17248	22684	34	applied	\N	\N	\N	\N	134115	134115	301677
17248	22688	35	applied	\N	\N	\N	\N	134116	134116	301678
17248	22690	36	applied	\N	\N	\N	\N	134117	134117	301679
17248	22693	37	applied	\N	\N	\N	\N	134118	134118	301680
17248	22696	38	applied	\N	\N	\N	\N	134119	134119	301681
17248	22697	39	applied	\N	\N	\N	\N	134120	134120	301682
17248	22704	40	applied	\N	\N	\N	\N	134121	134121	301683
17248	22706	42	applied	\N	\N	\N	\N	134123	134123	301685
17248	22716	43	applied	\N	\N	\N	\N	134124	134124	301686
17248	22719	44	applied	\N	\N	\N	\N	134125	134125	301687
17248	22723	45	applied	\N	\N	\N	\N	134126	134126	301688
17248	22726	46	applied	\N	\N	\N	\N	134127	134127	301689
17248	22727	47	applied	\N	\N	\N	\N	134128	134128	301690
17248	22732	48	applied	\N	\N	\N	\N	134129	134129	301691
17248	22735	49	applied	\N	\N	\N	\N	134130	134130	301692
17248	22738	50	applied	\N	\N	\N	\N	134131	134131	301693
17248	22741	51	applied	\N	\N	\N	\N	134132	134132	301694
17248	22744	52	applied	\N	\N	\N	\N	134133	134133	301695
17248	22746	53	applied	\N	\N	\N	\N	134134	134134	301696
17248	22748	54	applied	\N	\N	\N	\N	134135	134135	301697
17248	22749	55	applied	\N	\N	\N	\N	134136	134136	301698
17248	22753	56	applied	\N	\N	\N	\N	134137	134137	301699
17248	22755	57	applied	\N	\N	\N	\N	134138	134138	301700
17248	22760	59	applied	\N	\N	\N	\N	134140	134140	301702
17248	22762	60	applied	\N	\N	\N	\N	134141	134141	301703
17248	22764	61	applied	\N	\N	\N	\N	134142	134142	301704
17248	22768	62	applied	\N	\N	\N	\N	134143	134143	301705
17248	22770	63	applied	\N	\N	\N	\N	134144	134144	301706
17248	22772	64	applied	\N	\N	\N	\N	134145	134145	301707
17248	22775	65	applied	\N	\N	\N	\N	134146	134146	301708
17248	22777	66	applied	\N	\N	\N	\N	134147	134147	301709
17248	22779	67	applied	\N	\N	\N	\N	134148	134148	301710
17248	22782	68	applied	\N	\N	\N	\N	134149	134149	301711
17248	22784	69	applied	\N	\N	\N	\N	134150	134150	301712
17248	22786	70	applied	\N	\N	\N	\N	134151	134151	301713
17248	22789	71	applied	\N	\N	\N	\N	134152	134152	301714
17248	22791	72	applied	\N	\N	\N	\N	134153	134153	301715
17248	22793	73	applied	\N	\N	\N	\N	134154	134154	301716
17248	22796	74	applied	\N	\N	\N	\N	134155	134155	301717
17248	22800	76	applied	\N	\N	\N	\N	134157	134157	301719
17248	22802	77	applied	\N	\N	\N	\N	134158	134158	301720
17203	22958	2	applied	\N	\N	\N	\N	133899	133899	301461
17208	22959	0	applied	\N	\N	\N	\N	133919	133919	301481
17220	22982	3	applied	\N	\N	\N	\N	133969	133969	301531
17220	22983	4	applied	\N	\N	\N	\N	133970	133970	301532
17220	22984	5	applied	\N	\N	\N	\N	133971	133971	301533
17223	22985	0	applied	\N	\N	\N	\N	133975	133975	301537
17223	22986	1	applied	\N	\N	\N	\N	133976	133976	301538
17223	22987	2	applied	\N	\N	\N	\N	133977	133977	301539
17227	22994	0	applied	\N	\N	\N	\N	133987	133987	301549
17227	22995	1	applied	\N	\N	\N	\N	133988	133988	301550
17227	22996	2	applied	\N	\N	\N	\N	133989	133989	301551
17227	22997	3	applied	\N	\N	\N	\N	133990	133990	301552
17230	23004	0	applied	\N	\N	\N	\N	134003	134003	301565
17230	23005	1	applied	\N	\N	\N	\N	134004	134004	301566
17230	23006	3	applied	\N	\N	\N	\N	134005	134005	301567
17230	23008	5	applied	\N	\N	\N	\N	134007	134007	301569
17230	23009	6	applied	\N	\N	\N	\N	134008	134008	301570
17230	23010	7	applied	\N	\N	\N	\N	134009	134009	301571
17233	23004	0	applied	\N	\N	\N	\N	134024	134024	301586
17233	23005	1	applied	\N	\N	\N	\N	134025	134025	301587
17233	23006	3	applied	\N	\N	\N	\N	134026	134026	301588
17233	23007	4	applied	\N	\N	\N	\N	134027	134027	301589
17233	23008	5	applied	\N	\N	\N	\N	134028	134028	301590
17233	23009	6	applied	\N	\N	\N	\N	134029	134029	301591
17233	23010	7	applied	\N	\N	\N	\N	134030	134030	301592
17235	23018	0	applied	\N	\N	\N	\N	134038	134038	301600
17235	23019	1	applied	\N	\N	\N	\N	134039	134039	301601
17235	23020	2	applied	\N	\N	\N	\N	134040	134040	301602
17237	23021	0	applied	\N	\N	\N	\N	134044	134044	301606
17237	23022	1	applied	\N	\N	\N	\N	134045	134045	301607
17245	23030	0	applied	\N	\N	\N	\N	134075	134075	301637
17245	23032	2	applied	\N	\N	\N	\N	134077	134077	301639
17246	23033	0	applied	\N	\N	\N	\N	134078	134078	301640
17246	23034	1	applied	\N	\N	\N	\N	134079	134079	301641
17248	22804	78	applied	\N	\N	\N	\N	134159	134159	301721
17248	22807	79	applied	\N	\N	\N	\N	134160	134160	301722
17248	22809	80	applied	\N	\N	\N	\N	134161	134161	301723
17248	22813	81	applied	\N	\N	\N	\N	134162	134162	301724
17248	22814	82	applied	\N	\N	\N	\N	134163	134163	301725
17248	22815	83	applied	\N	\N	\N	\N	134164	134164	301726
17248	22822	84	applied	\N	\N	\N	\N	134165	134165	301727
17251	23041	0	applied	\N	\N	\N	\N	134215	134215	301777
17251	23042	1	applied	\N	\N	\N	\N	134216	134216	301778
17251	23043	2	applied	\N	\N	\N	\N	134217	134217	301779
17254	23044	0	applied	\N	\N	\N	\N	134230	134230	301792
17254	23045	1	applied	\N	\N	\N	\N	134231	134231	301793
17254	23046	2	applied	\N	\N	\N	\N	134232	134232	301794
17254	23048	4	applied	\N	\N	\N	\N	134234	134234	301796
17254	23049	5	applied	\N	\N	\N	\N	134235	134235	301797
17255	23050	0	applied	\N	\N	\N	\N	134236	134236	301798
17255	23051	1	applied	\N	\N	\N	\N	134237	134237	301799
17255	23052	2	applied	\N	\N	\N	\N	134238	134238	301800
17257	23052	0	applied	\N	\N	\N	\N	134242	134242	301804
17260	23056	0	applied	\N	\N	\N	\N	134252	134252	301814
17260	23057	1	applied	\N	\N	\N	\N	134253	134253	301815
17260	23054	2	applied	\N	\N	\N	\N	134254	134254	301816
17260	23058	3	applied	\N	\N	\N	\N	134255	134255	301817
17260	23059	4	applied	\N	\N	\N	\N	134256	134256	301818
17260	23060	5	applied	\N	\N	\N	\N	134257	134257	301819
17260	23061	6	applied	\N	\N	\N	\N	134258	134258	301820
17262	23062	0	applied	\N	\N	\N	\N	134259	134259	301821
17262	23063	1	applied	\N	\N	\N	\N	134260	134260	301822
17262	23064	2	applied	\N	\N	\N	\N	134261	134261	301823
17275	23081	0	applied	\N	\N	\N	\N	134284	134284	301846
17275	23082	1	applied	\N	\N	\N	\N	134285	134285	301847
17275	23083	2	applied	\N	\N	\N	\N	134286	134286	301848
17280	23087	0	applied	\N	\N	\N	\N	134296	134296	301858
17280	23088	1	applied	\N	\N	\N	\N	134297	134297	301859
17280	23089	3	applied	\N	\N	\N	\N	134298	134298	301860
17281	23087	0	applied	\N	\N	\N	\N	134299	134299	301861
17281	23088	1	applied	\N	\N	\N	\N	134300	134300	301862
17281	23089	3	applied	\N	\N	\N	\N	134301	134301	301863
17283	23090	0	applied	\N	\N	\N	\N	134305	134305	301867
17283	23091	1	applied	\N	\N	\N	\N	134306	134306	301868
17283	23092	2	applied	\N	\N	\N	\N	134307	134307	301869
17289	23114	0	applied	\N	\N	\N	\N	134341	134341	301903
17289	23115	1	applied	\N	\N	\N	\N	134342	134342	301904
17289	23116	2	applied	\N	\N	\N	\N	134343	134343	301905
17301	22715	0	applied	\N	\N	\N	\N	134395	134395	301957
17301	22790	2	applied	\N	\N	\N	\N	134397	134397	301959
17301	22806	3	applied	\N	\N	1000000000	\N	134398	134398	301960
17301	22830	4	applied	\N	\N	1000000000	\N	134399	134399	301961
17301	22850	5	applied	\N	\N	\N	\N	134400	134400	301962
17301	22707	6	applied	\N	\N	\N	\N	134401	134401	301963
17301	22916	7	applied	\N	\N	\N	\N	134402	134402	301964
17301	22767	8	applied	\N	\N	\N	\N	134403	134403	301965
17305	23159	0	applied	\N	\N	\N	\N	134420	134420	301982
17305	23160	1	applied	\N	\N	\N	\N	134421	134421	301983
17305	23161	2	applied	\N	\N	\N	\N	134422	134422	301984
17305	23162	3	applied	\N	\N	\N	\N	134423	134423	301985
17305	23163	4	applied	\N	\N	\N	\N	134424	134424	301986
17305	23164	5	applied	\N	\N	\N	\N	134425	134425	301987
17317	23181	0	applied	\N	\N	\N	\N	134458	134458	302020
17317	23182	1	applied	\N	\N	\N	\N	134459	134459	302021
17317	23183	2	applied	\N	\N	\N	\N	134460	134460	302022
17325	23193	1	applied	\N	\N	\N	\N	134490	134490	302052
17325	23194	2	applied	\N	\N	\N	\N	134491	134491	302053
17325	23195	3	applied	\N	\N	\N	\N	134492	134492	302054
17325	23196	4	applied	\N	\N	\N	\N	134493	134493	302055
17325	23197	5	applied	\N	\N	\N	\N	134494	134494	302056
17325	23198	6	applied	\N	\N	\N	\N	134495	134495	302057
17336	23219	0	applied	\N	\N	\N	\N	134615	134615	302177
17336	23220	1	applied	\N	\N	\N	\N	134616	134616	302178
17336	23221	2	applied	\N	\N	\N	\N	134617	134617	302179
17336	23216	3	applied	\N	\N	\N	\N	134618	134618	302180
17336	23222	4	applied	\N	\N	\N	\N	134619	134619	302181
17336	23217	5	applied	\N	\N	\N	\N	134620	134620	302182
17336	23223	6	applied	\N	\N	\N	\N	134621	134621	302183
17336	23224	7	applied	\N	\N	\N	\N	134622	134622	302184
17336	23225	8	applied	\N	\N	\N	\N	134623	134623	302185
17341	23235	0	applied	\N	\N	\N	\N	134636	134636	302198
17220	22980	1	applied	\N	\N	\N	\N	133967	133967	301529
17220	22981	2	applied	\N	\N	\N	\N	133968	133968	301530
17228	22998	0	applied	\N	\N	\N	\N	133991	133991	301553
17228	22999	1	applied	\N	\N	\N	\N	133992	133992	301554
17228	23000	2	applied	\N	\N	\N	\N	133993	133993	301555
17228	23001	3	applied	\N	\N	\N	\N	133994	133994	301556
17228	23002	4	applied	\N	\N	\N	\N	133995	133995	301557
17228	23003	5	applied	\N	\N	\N	\N	133996	133996	301558
17231	23004	0	applied	\N	\N	\N	\N	134010	134010	301572
17231	23005	1	applied	\N	\N	\N	\N	134011	134011	301573
17231	23006	3	applied	\N	\N	\N	\N	134012	134012	301574
17231	23007	4	applied	\N	\N	\N	\N	134013	134013	301575
17231	23008	5	applied	\N	\N	\N	\N	134014	134014	301576
17231	23009	6	applied	\N	\N	\N	\N	134015	134015	301577
17231	23010	7	applied	\N	\N	\N	\N	134016	134016	301578
17236	23018	0	applied	\N	\N	\N	\N	134041	134041	301603
17236	23019	1	applied	\N	\N	\N	\N	134042	134042	301604
17236	23020	2	applied	\N	\N	\N	\N	134043	134043	301605
17238	23022	1	applied	\N	\N	\N	\N	134047	134047	301609
17240	23023	0	applied	\N	\N	\N	\N	134048	134048	301610
17240	23024	1	applied	\N	\N	\N	\N	134049	134049	301611
17240	23025	2	applied	\N	\N	\N	\N	134050	134050	301612
17240	23026	3	applied	\N	\N	\N	\N	134051	134051	301613
17240	23027	4	applied	\N	\N	\N	\N	134052	134052	301614
17240	23028	5	applied	\N	\N	\N	\N	134053	134053	301615
17240	23029	6	applied	\N	\N	\N	\N	134054	134054	301616
17247	22916	0	applied	\N	\N	\N	\N	134080	134080	301642
17256	23050	0	applied	\N	\N	\N	\N	134239	134239	301801
17256	23051	1	applied	\N	\N	\N	\N	134240	134240	301802
17256	23052	2	applied	\N	\N	\N	\N	134241	134241	301803
17258	23050	0	applied	\N	\N	\N	\N	134243	134243	301805
17258	23053	1	applied	\N	\N	\N	\N	134244	134244	301806
17258	23054	2	applied	\N	\N	\N	\N	134245	134245	301807
17258	23051	3	applied	\N	\N	\N	\N	134246	134246	301808
17263	23065	0	applied	\N	\N	\N	\N	134262	134262	301824
17263	23066	1	applied	\N	\N	\N	\N	134263	134263	301825
17263	23067	2	applied	\N	\N	\N	\N	134264	134264	301826
17265	23068	0	applied	\N	\N	\N	\N	134265	134265	301827
17265	23069	1	applied	\N	\N	\N	\N	134266	134266	301828
17265	23070	2	applied	\N	\N	\N	\N	134267	134267	301829
17270	23076	0	applied	\N	\N	\N	\N	134276	134276	301838
17270	23077	1	applied	\N	\N	\N	\N	134277	134277	301839
17272	23078	0	applied	\N	\N	\N	\N	134278	134278	301840
17272	23079	1	applied	\N	\N	\N	\N	134279	134279	301841
17272	23080	2	applied	\N	\N	\N	\N	134280	134280	301842
17277	23084	0	applied	\N	\N	\N	\N	134287	134287	301849
17277	23085	1	applied	\N	\N	\N	\N	134288	134288	301850
17277	23086	2	applied	\N	\N	\N	\N	134289	134289	301851
17282	23087	0	applied	\N	\N	\N	\N	134302	134302	301864
17282	23088	1	applied	\N	\N	\N	\N	134303	134303	301865
17284	23093	0	applied	\N	\N	\N	\N	134308	134308	301870
17284	23094	1	applied	\N	\N	\N	\N	134309	134309	301871
17284	23095	2	applied	\N	\N	\N	\N	134310	134310	301872
17284	23096	3	applied	\N	\N	\N	\N	134311	134311	301873
17284	23097	4	applied	\N	\N	\N	\N	134312	134312	301874
17284	23098	5	applied	\N	\N	\N	\N	134313	134313	301875
17287	23099	0	applied	\N	\N	\N	\N	134326	134326	301888
17287	23100	1	applied	\N	\N	\N	\N	134327	134327	301889
17287	23101	2	applied	\N	\N	\N	\N	134328	134328	301890
17287	23102	3	applied	\N	\N	\N	\N	134329	134329	301891
17287	23103	4	applied	\N	\N	\N	\N	134330	134330	301892
17287	23104	5	applied	\N	\N	\N	\N	134331	134331	301893
17287	23105	6	applied	\N	\N	\N	\N	134332	134332	301894
17287	23106	7	applied	\N	\N	\N	\N	134333	134333	301895
17287	23107	8	applied	\N	\N	\N	\N	134334	134334	301896
17290	23117	0	applied	\N	\N	\N	\N	134344	134344	301906
17294	23120	1	applied	\N	\N	\N	\N	134350	134350	301912
17294	23118	2	applied	\N	\N	\N	\N	134351	134351	301913
17294	23121	3	applied	\N	\N	\N	\N	134352	134352	301914
17295	23122	0	applied	\N	\N	\N	\N	134353	134353	301915
17295	23123	1	applied	\N	\N	\N	\N	134354	134354	301916
17295	23124	2	applied	\N	\N	\N	\N	134355	134355	301917
17295	23125	3	applied	\N	\N	\N	\N	134356	134356	301918
17295	23126	4	applied	\N	\N	\N	\N	134357	134357	301919
17295	23127	5	applied	\N	\N	\N	\N	134358	134358	301920
17295	23128	6	applied	\N	\N	\N	\N	134359	134359	301921
17295	23129	7	applied	\N	\N	\N	\N	134360	134360	301922
17295	23130	8	applied	\N	\N	\N	\N	134361	134361	301923
17297	23131	0	applied	\N	\N	\N	\N	134371	134371	301933
17297	23132	1	applied	\N	\N	\N	\N	134372	134372	301934
17297	23133	2	applied	\N	\N	\N	\N	134373	134373	301935
17298	23134	0	applied	\N	\N	\N	\N	134374	134374	301936
17298	23136	2	applied	\N	\N	\N	\N	134376	134376	301938
17298	23137	3	applied	\N	\N	\N	\N	134377	134377	301939
17298	23138	4	applied	\N	\N	\N	\N	134378	134378	301940
17298	23139	5	applied	\N	\N	\N	\N	134379	134379	301941
17298	23140	6	applied	\N	\N	\N	\N	134380	134380	301942
17298	23141	7	applied	\N	\N	\N	\N	134381	134381	301943
17298	23142	8	applied	\N	\N	\N	\N	134382	134382	301944
17298	23143	9	applied	\N	\N	\N	\N	134383	134383	301945
17298	23144	10	applied	\N	\N	\N	\N	134384	134384	301946
17298	23145	11	applied	\N	\N	\N	\N	134385	134385	301947
17302	23149	0	applied	\N	\N	\N	\N	134404	134404	301966
17302	23150	1	applied	\N	\N	\N	\N	134405	134405	301967
17302	23151	2	applied	\N	\N	\N	\N	134406	134406	301968
17302	23152	3	applied	\N	\N	\N	\N	134407	134407	301969
17302	23153	4	applied	\N	\N	\N	\N	134408	134408	301970
17302	23154	5	applied	\N	\N	\N	\N	134409	134409	301971
17306	23166	1	applied	\N	\N	\N	\N	134427	134427	301989
17306	23167	2	applied	\N	\N	\N	\N	134428	134428	301990
17308	23168	0	applied	\N	\N	\N	\N	134432	134432	301994
17308	23169	1	applied	\N	\N	\N	\N	134433	134433	301995
17313	23174	0	applied	\N	\N	\N	\N	134444	134444	302006
17313	23176	1	applied	\N	\N	\N	\N	134445	134445	302007
17313	23177	2	applied	\N	\N	\N	\N	134446	134446	302008
17341	23237	2	applied	\N	\N	\N	\N	134638	134638	302200
17348	23244	0	applied	\N	\N	\N	\N	134654	134654	302216
17348	23245	1	applied	\N	\N	\N	\N	134655	134655	302217
17348	23246	2	applied	\N	\N	\N	\N	134656	134656	302218
17352	23249	0	applied	\N	\N	\N	\N	134667	134667	302229
17352	23250	1	applied	\N	\N	\N	\N	134668	134668	302230
17352	23251	2	applied	\N	\N	\N	\N	134669	134669	302231
17225	22988	0	applied	\N	\N	\N	\N	133981	133981	301543
17225	22989	1	applied	\N	\N	\N	\N	133982	133982	301544
17248	22837	89	applied	\N	\N	\N	\N	134170	134170	301732
17248	22841	90	applied	\N	\N	\N	\N	134171	134171	301733
17248	22845	91	applied	\N	\N	\N	\N	134172	134172	301734
17248	22848	92	applied	\N	\N	\N	\N	134173	134173	301735
17248	22849	93	applied	\N	\N	\N	\N	134174	134174	301736
17248	22859	94	applied	\N	\N	\N	\N	134175	134175	301737
17248	22860	95	applied	\N	\N	\N	\N	134176	134176	301738
17248	22865	96	applied	\N	\N	\N	\N	134177	134177	301739
17248	22869	97	applied	\N	\N	\N	\N	134178	134178	301740
17248	22870	98	applied	\N	\N	\N	\N	134179	134179	301741
17248	22871	99	applied	\N	\N	\N	\N	134180	134180	301742
17248	22879	100	applied	\N	\N	\N	\N	134181	134181	301743
17248	22882	101	applied	\N	\N	\N	\N	134182	134182	301744
17248	22885	102	applied	\N	\N	\N	\N	134183	134183	301745
17248	22886	103	applied	\N	\N	\N	\N	134184	134184	301746
17248	22887	104	applied	\N	\N	\N	\N	134185	134185	301747
17248	22896	107	applied	\N	\N	\N	\N	134187	134187	301749
17248	22902	108	applied	\N	\N	\N	\N	134188	134188	301750
17248	22905	109	applied	\N	\N	\N	\N	134189	134189	301751
17248	22908	110	applied	\N	\N	\N	\N	134190	134190	301752
17248	22912	111	applied	\N	\N	\N	\N	134191	134191	301753
17248	22915	112	applied	\N	\N	\N	\N	134192	134192	301754
17248	22921	113	applied	\N	\N	\N	\N	134193	134193	301755
17248	22922	114	applied	\N	\N	\N	\N	134194	134194	301756
17248	22923	115	applied	\N	\N	\N	\N	134195	134195	301757
17248	22930	116	applied	\N	\N	\N	\N	134196	134196	301758
17248	22934	117	applied	\N	\N	\N	\N	134197	134197	301759
17248	22937	118	applied	\N	\N	\N	\N	134198	134198	301760
17248	22940	119	applied	\N	\N	\N	\N	134199	134199	301761
17248	22944	120	applied	\N	\N	\N	\N	134200	134200	301762
17248	22947	121	applied	\N	\N	\N	\N	134201	134201	301763
17248	22948	122	applied	\N	\N	\N	\N	134202	134202	301764
17248	22956	124	applied	\N	\N	\N	\N	134204	134204	301766
17248	22959	125	applied	\N	\N	\N	\N	134205	134205	301767
17250	23041	0	applied	\N	\N	\N	\N	134212	134212	301774
17250	23042	1	applied	\N	\N	\N	\N	134213	134213	301775
17250	23043	2	applied	\N	\N	\N	\N	134214	134214	301776
17253	23044	0	applied	\N	\N	\N	\N	134224	134224	301786
17253	23045	1	applied	\N	\N	\N	\N	134225	134225	301787
17253	23046	2	applied	\N	\N	\N	\N	134226	134226	301788
17253	23047	3	applied	\N	\N	\N	\N	134227	134227	301789
17253	23048	4	applied	\N	\N	\N	\N	134228	134228	301790
17253	23049	5	applied	\N	\N	\N	\N	134229	134229	301791
17259	23050	0	applied	\N	\N	\N	\N	134248	134248	301810
17259	23053	1	applied	\N	\N	\N	\N	134249	134249	301811
17259	23051	2	applied	\N	\N	\N	\N	134250	134250	301812
17259	23055	3	applied	\N	\N	\N	\N	134251	134251	301813
17274	23081	0	applied	\N	\N	\N	\N	134281	134281	301843
17274	23083	2	applied	\N	\N	\N	\N	134283	134283	301845
17279	23087	0	applied	\N	\N	\N	\N	134293	134293	301855
17279	23088	1	applied	\N	\N	\N	\N	134294	134294	301856
17279	23089	3	applied	\N	\N	\N	\N	134295	134295	301857
17286	23093	0	applied	\N	\N	\N	\N	134320	134320	301882
17286	23094	1	applied	\N	\N	\N	\N	134321	134321	301883
17286	23095	2	applied	\N	\N	\N	\N	134322	134322	301884
17286	23096	3	applied	\N	\N	\N	\N	134323	134323	301885
17286	23097	4	applied	\N	\N	\N	\N	134324	134324	301886
17286	23098	5	applied	\N	\N	\N	\N	134325	134325	301887
17292	23117	0	applied	\N	\N	\N	\N	134347	134347	301909
17292	23118	1	applied	\N	\N	\N	\N	134348	134348	301910
17296	23122	0	applied	\N	\N	\N	\N	134362	134362	301924
17296	23123	1	applied	\N	\N	\N	\N	134363	134363	301925
17296	23124	2	applied	\N	\N	\N	\N	134364	134364	301926
17296	23125	3	applied	\N	\N	\N	\N	134365	134365	301927
17296	23127	5	applied	\N	\N	\N	\N	134367	134367	301929
17296	23128	6	applied	\N	\N	\N	\N	134368	134368	301930
17296	23129	7	applied	\N	\N	\N	\N	134369	134369	301931
17296	23130	8	applied	\N	\N	\N	\N	134370	134370	301932
17300	23149	0	applied	\N	\N	\N	\N	134389	134389	301951
17300	23150	1	applied	\N	\N	\N	\N	134390	134390	301952
17300	23151	2	applied	\N	\N	\N	\N	134391	134391	301953
17300	23152	3	applied	\N	\N	\N	\N	134392	134392	301954
17300	23153	4	applied	\N	\N	\N	\N	134393	134393	301955
17300	23154	5	applied	\N	\N	\N	\N	134394	134394	301956
17303	23149	0	applied	\N	\N	\N	\N	134410	134410	301972
17303	23150	1	applied	\N	\N	\N	\N	134411	134411	301973
17303	23151	2	applied	\N	\N	\N	\N	134412	134412	301974
17303	23152	3	applied	\N	\N	\N	\N	134413	134413	301975
17303	23153	4	applied	\N	\N	\N	\N	134414	134414	301976
17303	23154	5	applied	\N	\N	\N	\N	134415	134415	301977
17304	23156	1	applied	\N	\N	\N	\N	134417	134417	301979
17304	23157	2	applied	\N	\N	\N	\N	134418	134418	301980
17304	23158	3	applied	\N	\N	\N	\N	134419	134419	301981
17310	23170	0	applied	\N	\N	\N	\N	134437	134437	301999
17310	23171	1	applied	\N	\N	\N	\N	134438	134438	302000
17310	23172	2	applied	\N	\N	\N	\N	134439	134439	302001
17312	23174	0	applied	\N	\N	\N	\N	134441	134441	302003
17312	23173	1	applied	\N	\N	\N	\N	134442	134442	302004
17312	23175	2	applied	\N	\N	\N	\N	134443	134443	302005
17313	23175	3	applied	\N	\N	\N	\N	134447	134447	302009
17313	23178	5	applied	\N	\N	\N	\N	134448	134448	302010
17314	23174	0	applied	\N	\N	\N	\N	134449	134449	302011
17314	23176	1	applied	\N	\N	\N	\N	134450	134450	302012
17314	23177	2	applied	\N	\N	\N	\N	134451	134451	302013
17314	23175	3	applied	\N	\N	\N	\N	134452	134452	302014
17314	23178	5	applied	\N	\N	\N	\N	134453	134453	302015
17315	23180	1	applied	\N	\N	\N	\N	134455	134455	302017
17319	23187	0	applied	\N	\N	\N	\N	134464	134464	302026
17319	23188	1	applied	\N	\N	\N	\N	134465	134465	302027
17320	23189	0	applied	\N	\N	\N	\N	134466	134466	302028
17320	23190	1	applied	\N	\N	\N	\N	134467	134467	302029
17320	23191	2	applied	\N	\N	\N	\N	134468	134468	302030
17322	23189	0	applied	\N	\N	\N	\N	134472	134472	302034
17322	23190	1	applied	\N	\N	\N	\N	134473	134473	302035
17322	23191	2	applied	\N	\N	\N	\N	134474	134474	302036
17324	23192	0	applied	\N	\N	\N	\N	134482	134482	302044
17324	23193	1	applied	\N	\N	\N	\N	134483	134483	302045
17324	23194	2	applied	\N	\N	\N	\N	134484	134484	302046
17324	23195	3	applied	\N	\N	\N	\N	134485	134485	302047
17324	23196	4	applied	\N	\N	\N	\N	134486	134486	302048
17248	22828	86	applied	\N	\N	\N	\N	134167	134167	301729
17248	22829	87	applied	\N	\N	\N	\N	134168	134168	301730
17285	23097	4	applied	\N	\N	\N	\N	134318	134318	301880
17285	23098	5	applied	\N	\N	\N	\N	134319	134319	301881
17288	23108	0	applied	\N	\N	\N	\N	134335	134335	301897
17288	23109	1	applied	\N	\N	\N	\N	134336	134336	301898
17288	23110	2	applied	\N	\N	\N	\N	134337	134337	301899
17288	23111	3	applied	\N	\N	\N	\N	134338	134338	301900
17288	23112	4	applied	\N	\N	\N	\N	134339	134339	301901
17288	23113	5	applied	\N	\N	\N	\N	134340	134340	301902
17291	23117	0	applied	\N	\N	\N	\N	134345	134345	301907
17291	23118	1	applied	\N	\N	\N	\N	134346	134346	301908
17299	23146	0	applied	\N	\N	\N	\N	134386	134386	301948
17299	23147	1	applied	\N	\N	\N	\N	134387	134387	301949
17299	23148	2	applied	\N	\N	\N	\N	134388	134388	301950
17307	23165	0	applied	\N	\N	\N	\N	134429	134429	301991
17307	23166	1	applied	\N	\N	\N	\N	134430	134430	301992
17307	23167	2	applied	\N	\N	\N	\N	134431	134431	301993
17309	23171	1	applied	\N	\N	\N	\N	134435	134435	301997
17309	23172	2	applied	\N	\N	\N	\N	134436	134436	301998
17311	23173	0	applied	\N	\N	\N	\N	134440	134440	302002
17316	23179	0	applied	\N	\N	\N	\N	134456	134456	302018
17316	23180	1	applied	\N	\N	\N	\N	134457	134457	302019
17318	23184	0	applied	\N	\N	\N	\N	134461	134461	302023
17318	23185	1	applied	\N	\N	\N	\N	134462	134462	302024
17318	23186	2	applied	\N	\N	\N	\N	134463	134463	302025
17321	23189	0	applied	\N	\N	\N	\N	134469	134469	302031
17321	23190	1	applied	\N	\N	\N	\N	134470	134470	302032
17321	23191	2	applied	\N	\N	\N	\N	134471	134471	302033
17323	23192	0	applied	\N	\N	\N	\N	134475	134475	302037
17323	23193	1	applied	\N	\N	\N	\N	134476	134476	302038
17323	23194	2	applied	\N	\N	\N	\N	134477	134477	302039
17323	23195	3	applied	\N	\N	\N	\N	134478	134478	302040
17323	23196	4	applied	\N	\N	\N	\N	134479	134479	302041
17323	23198	6	applied	\N	\N	\N	\N	134481	134481	302043
17324	23197	5	applied	\N	\N	\N	\N	134487	134487	302049
17324	23198	6	applied	\N	\N	\N	\N	134488	134488	302050
17328	23192	0	applied	\N	\N	\N	\N	134505	134505	302067
17328	23134	1	applied	\N	\N	\N	\N	134506	134506	302068
17328	23156	2	applied	\N	\N	\N	\N	134507	134507	302069
17328	23135	3	applied	\N	\N	\N	\N	134508	134508	302070
17328	23136	4	applied	\N	\N	\N	\N	134509	134509	302071
17328	23137	5	applied	\N	\N	\N	\N	134510	134510	302072
17328	23146	6	applied	\N	\N	\N	\N	134511	134511	302073
17328	23149	7	applied	\N	\N	\N	\N	134512	134512	302074
17328	23150	8	applied	\N	\N	\N	\N	134513	134513	302075
17328	23155	9	applied	\N	\N	\N	\N	134514	134514	302076
17328	23159	10	applied	\N	\N	\N	\N	134515	134515	302077
17328	23160	11	applied	\N	\N	\N	\N	134516	134516	302078
17328	23165	12	applied	\N	\N	\N	\N	134517	134517	302079
17328	23170	14	applied	\N	\N	\N	\N	134519	134519	302081
17328	23174	15	applied	\N	\N	\N	\N	134520	134520	302082
17328	23176	16	applied	\N	\N	\N	\N	134521	134521	302083
17328	23179	17	applied	\N	\N	\N	\N	134522	134522	302084
17328	23181	18	applied	\N	\N	\N	\N	134523	134523	302085
17328	23184	19	applied	\N	\N	\N	\N	134524	134524	302086
17328	23187	20	applied	\N	\N	\N	\N	134525	134525	302087
17328	23189	21	applied	\N	\N	\N	\N	134526	134526	302088
17328	23193	22	applied	\N	\N	\N	\N	134527	134527	302089
17328	23194	23	applied	\N	\N	\N	\N	134528	134528	302090
17328	23199	24	applied	\N	\N	\N	\N	134529	134529	302091
17328	23138	25	applied	\N	\N	\N	\N	134530	134530	302092
17328	23139	26	applied	\N	\N	\N	\N	134531	134531	302093
17328	23140	27	applied	\N	\N	\N	\N	134532	134532	302094
17328	23141	28	applied	\N	\N	\N	\N	134533	134533	302095
17328	23142	29	applied	\N	\N	\N	\N	134534	134534	302096
17328	23151	31	applied	\N	\N	\N	\N	134536	134536	302098
17328	23154	32	applied	\N	\N	\N	\N	134537	134537	302099
17328	23158	33	applied	\N	\N	\N	\N	134538	134538	302100
17328	23161	34	applied	\N	\N	\N	\N	134539	134539	302101
17328	23164	35	applied	\N	\N	\N	\N	134540	134540	302102
17328	23166	36	applied	\N	\N	\N	\N	134541	134541	302103
17328	23169	37	applied	\N	\N	\N	\N	134542	134542	302104
17328	23172	38	applied	\N	\N	\N	\N	134543	134543	302105
17328	23175	39	applied	\N	\N	\N	\N	134544	134544	302106
17328	23143	40	applied	\N	\N	\N	\N	134545	134545	302107
17328	23144	41	applied	\N	\N	\N	\N	134546	134546	302108
17328	23145	42	applied	\N	\N	\N	\N	134547	134547	302109
17328	23148	43	applied	\N	\N	\N	\N	134548	134548	302110
17328	23152	44	applied	\N	\N	\N	\N	134549	134549	302111
17328	23153	45	applied	\N	\N	\N	\N	134550	134550	302112
17328	23157	46	applied	\N	\N	\N	\N	134551	134551	302113
17328	23163	48	applied	\N	\N	\N	\N	134553	134553	302115
17328	23167	49	applied	\N	\N	\N	\N	134554	134554	302116
17328	23171	50	applied	\N	\N	\N	\N	134555	134555	302117
17328	23173	51	applied	\N	\N	\N	\N	134556	134556	302118
17328	23177	52	applied	\N	\N	\N	\N	134557	134557	302119
17328	23183	53	applied	\N	\N	\N	\N	134558	134558	302120
17328	23186	54	applied	\N	\N	\N	\N	134559	134559	302121
17328	23191	55	applied	\N	\N	\N	\N	134560	134560	302122
17328	23195	56	applied	\N	\N	\N	\N	134561	134561	302123
17328	23196	57	applied	\N	\N	\N	\N	134562	134562	302124
17328	23178	58	applied	\N	\N	\N	\N	134563	134563	302125
17328	23180	59	applied	\N	\N	\N	\N	134564	134564	302126
17328	23182	60	applied	\N	\N	\N	\N	134565	134565	302127
17328	23185	61	applied	\N	\N	\N	\N	134566	134566	302128
17328	23188	63	applied	\N	\N	\N	\N	134567	134567	302129
17328	23190	64	applied	\N	\N	\N	\N	134568	134568	302130
17328	23198	66	applied	\N	\N	\N	\N	134570	134570	302132
17328	23200	67	applied	\N	\N	\N	\N	134571	134571	302133
17330	23201	0	applied	\N	\N	\N	\N	134583	134583	302145
17330	23202	1	applied	\N	\N	\N	\N	134584	134584	302146
17330	23203	2	applied	\N	\N	\N	\N	134585	134585	302147
17330	23204	3	applied	\N	\N	\N	\N	134586	134586	302148
17330	23205	4	applied	\N	\N	\N	\N	134587	134587	302149
17330	23206	5	applied	\N	\N	\N	\N	134588	134588	302150
17330	23207	6	applied	\N	\N	\N	\N	134589	134589	302151
17331	23201	0	applied	\N	\N	\N	\N	134594	134594	302156
17331	23202	1	applied	\N	\N	\N	\N	134595	134595	302157
17331	23203	2	applied	\N	\N	\N	\N	134596	134596	302158
17331	23204	3	applied	\N	\N	\N	\N	134597	134597	302159
17331	23205	4	applied	\N	\N	\N	\N	134598	134598	302160
17285	23094	1	applied	\N	\N	\N	\N	134315	134315	301877
17285	23095	2	applied	\N	\N	\N	\N	134316	134316	301878
17326	23196	4	applied	\N	\N	\N	\N	134500	134500	302062
17326	23197	5	applied	\N	\N	\N	\N	134501	134501	302063
17326	23198	6	applied	\N	\N	\N	\N	134502	134502	302064
17327	23199	0	applied	\N	\N	\N	\N	134503	134503	302065
17327	23200	1	applied	\N	\N	\N	\N	134504	134504	302066
17329	23201	0	applied	\N	\N	\N	\N	134572	134572	302134
17329	23202	1	applied	\N	\N	\N	\N	134573	134573	302135
17329	23203	2	applied	\N	\N	\N	\N	134574	134574	302136
17329	23204	3	applied	\N	\N	\N	\N	134575	134575	302137
17329	23205	4	applied	\N	\N	\N	\N	134576	134576	302138
17329	23206	5	applied	\N	\N	\N	\N	134577	134577	302139
17329	23207	6	applied	\N	\N	\N	\N	134578	134578	302140
17329	23208	7	applied	\N	\N	\N	\N	134579	134579	302141
17329	23209	8	applied	\N	\N	\N	\N	134580	134580	302142
17329	23211	10	applied	\N	\N	\N	\N	134582	134582	302144
17330	23208	7	applied	\N	\N	\N	\N	134590	134590	302152
17330	23209	8	applied	\N	\N	\N	\N	134591	134591	302153
17330	23210	9	applied	\N	\N	\N	\N	134592	134592	302154
17330	23211	10	applied	\N	\N	\N	\N	134593	134593	302155
17332	23212	0	applied	\N	\N	\N	\N	134603	134603	302165
17332	23213	1	applied	\N	\N	\N	\N	134604	134604	302166
17332	23214	2	applied	\N	\N	\N	\N	134605	134605	302167
17334	23218	0	applied	\N	\N	\N	\N	134613	134613	302175
17339	23232	0	applied	\N	\N	\N	\N	134630	134630	302192
17339	23233	1	applied	\N	\N	\N	\N	134631	134631	302193
17339	23234	2	applied	\N	\N	\N	\N	134632	134632	302194
17344	23241	0	applied	\N	\N	\N	\N	134645	134645	302207
17344	23242	1	applied	\N	\N	\N	\N	134646	134646	302208
17344	23243	2	applied	\N	\N	\N	\N	134647	134647	302209
17346	23241	0	applied	\N	\N	\N	\N	134651	134651	302213
17346	23243	2	applied	\N	\N	\N	\N	134653	134653	302215
17349	23244	0	applied	\N	\N	\N	\N	134657	134657	302219
17349	23246	1	applied	\N	\N	\N	\N	134658	134658	302220
17353	23252	0	applied	\N	\N	\N	\N	134670	134670	302232
17353	23253	1	applied	\N	\N	\N	\N	134671	134671	302233
17356	23254	0	applied	\N	\N	\N	\N	134690	134690	302252
17356	23255	1	applied	\N	\N	\N	\N	134691	134691	302253
17356	23256	2	applied	\N	\N	\N	\N	134692	134692	302254
17356	23257	3	applied	\N	\N	\N	\N	134693	134693	302255
17356	23258	4	applied	\N	\N	\N	\N	134694	134694	302256
17356	23259	5	applied	\N	\N	\N	\N	134695	134695	302257
17356	23260	6	applied	\N	\N	\N	\N	134696	134696	302258
17356	23261	7	applied	\N	\N	\N	\N	134697	134697	302259
17356	23262	9	applied	\N	\N	\N	\N	134698	134698	302260
17358	23263	0	applied	\N	\N	\N	\N	134702	134702	302264
17358	23264	1	applied	\N	\N	\N	\N	134703	134703	302265
17361	23263	0	applied	\N	\N	\N	\N	134711	134711	302273
17361	23264	1	applied	\N	\N	\N	\N	134712	134712	302274
17361	23265	2	applied	\N	\N	\N	\N	134713	134713	302275
17366	23269	0	applied	\N	\N	\N	\N	134730	134730	302292
17366	23270	1	applied	\N	\N	\N	\N	134731	134731	302293
17366	23271	2	applied	\N	\N	\N	\N	134732	134732	302294
17366	23272	3	applied	\N	\N	\N	\N	134733	134733	302295
17366	23273	4	applied	\N	\N	\N	\N	134734	134734	302296
17370	23280	0	applied	\N	\N	\N	\N	134748	134748	302310
17370	23281	1	applied	\N	\N	\N	\N	134749	134749	302311
17372	23282	0	applied	\N	\N	\N	\N	134753	134753	302315
17372	23283	1	applied	\N	\N	\N	\N	134754	134754	302316
17372	23284	2	applied	\N	\N	\N	\N	134755	134755	302317
17376	23285	0	applied	\N	\N	\N	\N	134764	134764	302326
17376	23286	1	applied	\N	\N	\N	\N	134765	134765	302327
17376	23287	2	applied	\N	\N	\N	\N	134766	134766	302328
17379	23292	1	applied	\N	\N	\N	\N	134777	134777	302339
17379	23293	2	applied	\N	\N	\N	\N	134778	134778	302340
17379	23294	3	applied	\N	\N	\N	\N	134779	134779	302341
17379	23295	4	applied	\N	\N	\N	\N	134780	134780	302342
17379	23296	5	applied	\N	\N	\N	\N	134781	134781	302343
17385	23315	0	applied	\N	\N	\N	\N	134806	134806	302368
17385	23314	1	applied	\N	\N	\N	\N	134807	134807	302369
17385	23316	2	applied	\N	\N	\N	\N	134808	134808	302370
17390	23320	0	applied	\N	\N	\N	\N	134954	134954	302516
17390	23321	1	applied	\N	\N	\N	\N	134955	134955	302517
17390	23322	2	applied	\N	\N	\N	\N	134956	134956	302518
17390	23323	3	applied	\N	\N	\N	\N	134957	134957	302519
17390	23324	4	applied	\N	\N	1000000000	\N	134958	134958	302520
17390	23329	5	applied	\N	\N	\N	\N	134959	134959	302521
17390	23330	6	applied	\N	\N	\N	\N	134960	134960	302522
17390	23325	7	applied	\N	\N	\N	\N	134961	134961	302523
17390	23326	9	applied	\N	\N	\N	\N	134963	134963	302525
17390	23327	10	applied	\N	\N	\N	\N	134964	134964	302526
17390	23328	11	applied	\N	\N	\N	\N	134965	134965	302527
17392	23332	0	applied	\N	\N	\N	\N	134975	134975	302537
17392	23333	1	applied	\N	\N	\N	\N	134976	134976	302538
17392	23334	2	applied	\N	\N	\N	\N	134977	134977	302539
17392	23335	3	applied	\N	\N	\N	\N	134978	134978	302540
17392	23336	4	applied	\N	\N	\N	\N	134979	134979	302541
17392	23337	5	applied	\N	\N	\N	\N	134980	134980	302542
17392	23338	6	applied	\N	\N	\N	\N	134981	134981	302543
17395	23340	0	applied	\N	\N	\N	\N	134995	134995	302557
17395	23341	1	applied	\N	\N	\N	\N	134996	134996	302558
17395	23342	2	applied	\N	\N	\N	\N	134997	134997	302559
17395	23343	3	applied	\N	\N	\N	\N	134998	134998	302560
17395	23344	4	applied	\N	\N	\N	\N	134999	134999	302561
17399	23356	0	applied	\N	\N	\N	\N	135020	135020	302582
17399	23358	2	applied	\N	\N	\N	\N	135022	135022	302584
17399	23359	3	applied	\N	\N	\N	\N	135023	135023	302585
17399	23360	4	applied	\N	\N	\N	\N	135024	135024	302586
17399	23361	5	applied	\N	\N	\N	\N	135025	135025	302587
17399	23362	6	applied	\N	\N	\N	\N	135026	135026	302588
17399	23363	7	applied	\N	\N	\N	\N	135027	135027	302589
17399	23364	8	applied	\N	\N	\N	\N	135028	135028	302590
17403	23367	0	applied	\N	\N	\N	\N	135042	135042	302604
17403	23368	1	applied	\N	\N	\N	\N	135043	135043	302605
17403	23369	2	applied	\N	\N	\N	\N	135044	135044	302606
17406	23373	0	applied	\N	\N	\N	\N	135051	135051	302613
17406	23374	1	applied	\N	\N	\N	\N	135052	135052	302614
17406	23375	2	applied	\N	\N	\N	\N	135053	135053	302615
17411	23387	0	applied	\N	\N	\N	\N	135074	135074	302636
17411	23388	1	applied	\N	\N	\N	\N	135075	135075	302637
17411	23389	2	applied	\N	\N	\N	\N	135076	135076	302638
17326	23195	3	applied	\N	\N	\N	\N	134499	134499	302061
17333	23212	0	applied	\N	\N	\N	\N	134607	134607	302169
17333	23213	1	applied	\N	\N	\N	\N	134608	134608	302170
17333	23216	2	applied	\N	\N	\N	\N	134609	134609	302171
17333	23217	3	applied	\N	\N	\N	\N	134610	134610	302172
17333	23214	4	applied	\N	\N	\N	\N	134611	134611	302173
17333	23215	5	applied	\N	\N	\N	\N	134612	134612	302174
17338	23229	0	applied	\N	\N	\N	\N	134627	134627	302189
17338	23230	1	applied	\N	\N	\N	\N	134628	134628	302190
17338	23231	2	applied	\N	\N	\N	\N	134629	134629	302191
17343	23238	0	applied	\N	\N	\N	\N	134642	134642	302204
17343	23239	1	applied	\N	\N	\N	\N	134643	134643	302205
17343	23240	2	applied	\N	\N	\N	\N	134644	134644	302206
17355	23254	0	applied	\N	\N	\N	\N	134681	134681	302243
17355	23255	1	applied	\N	\N	\N	\N	134682	134682	302244
17355	23257	3	applied	\N	\N	\N	\N	134684	134684	302246
17355	23258	4	applied	\N	\N	\N	\N	134685	134685	302247
17355	23259	5	applied	\N	\N	\N	\N	134686	134686	302248
17355	23260	6	applied	\N	\N	\N	\N	134687	134687	302249
17355	23261	7	applied	\N	\N	\N	\N	134688	134688	302250
17355	23262	9	applied	\N	\N	\N	\N	134689	134689	302251
17357	23192	0	applied	\N	\N	\N	\N	134699	134699	302261
17357	23156	1	applied	\N	\N	\N	\N	134700	134700	302262
17357	22916	2	applied	\N	\N	\N	\N	134701	134701	302263
17364	23269	0	applied	\N	\N	\N	\N	134720	134720	302282
17364	23270	1	applied	\N	\N	\N	\N	134721	134721	302283
17364	23271	2	applied	\N	\N	\N	\N	134722	134722	302284
17364	23272	3	applied	\N	\N	\N	\N	134723	134723	302285
17364	23273	4	applied	\N	\N	\N	\N	134724	134724	302286
17368	23270	0	applied	\N	\N	\N	\N	134739	134739	302301
17368	23274	1	applied	\N	\N	\N	\N	134740	134740	302302
17368	23276	3	applied	\N	\N	\N	\N	134742	134742	302304
17368	23277	4	applied	\N	\N	\N	\N	134743	134743	302305
17368	23278	5	applied	\N	\N	\N	\N	134744	134744	302306
17368	23279	6	applied	\N	\N	\N	\N	134745	134745	302307
17374	23282	0	applied	\N	\N	\N	\N	134759	134759	302321
17374	23283	1	applied	\N	\N	\N	\N	134760	134760	302322
17374	23284	2	applied	\N	\N	\N	\N	134761	134761	302323
17380	23297	0	applied	\N	\N	\N	\N	134782	134782	302344
17380	23298	1	applied	\N	\N	\N	\N	134783	134783	302345
17380	23299	2	applied	\N	\N	\N	\N	134784	134784	302346
17380	23300	3	applied	\N	\N	\N	\N	134785	134785	302347
17380	23301	4	applied	\N	\N	\N	\N	134786	134786	302348
17380	23302	5	applied	\N	\N	\N	\N	134787	134787	302349
17380	23303	6	applied	\N	\N	\N	\N	134788	134788	302350
17380	23304	7	applied	\N	\N	\N	\N	134789	134789	302351
17386	23315	0	applied	\N	\N	\N	\N	134809	134809	302371
17386	23316	2	applied	\N	\N	\N	\N	134811	134811	302373
17387	23315	0	applied	\N	\N	\N	\N	134812	134812	302374
17387	23317	1	applied	\N	\N	\N	\N	134813	134813	302375
17387	23316	2	applied	\N	\N	\N	\N	134814	134814	302376
17387	23318	3	applied	\N	\N	\N	\N	134815	134815	302377
17387	23319	4	applied	\N	\N	\N	\N	134816	134816	302378
17388	23192	0	applied	\N	\N	\N	\N	134817	134817	302379
17388	23179	1	applied	\N	\N	\N	\N	134818	134818	302380
17388	23181	2	applied	\N	\N	\N	\N	134819	134819	302381
17388	23184	3	applied	\N	\N	\N	\N	134820	134820	302382
17388	23187	4	applied	\N	\N	\N	\N	134821	134821	302383
17388	23189	5	applied	\N	\N	\N	\N	134822	134822	302384
17388	23193	6	applied	\N	\N	\N	\N	134823	134823	302385
17388	23194	7	applied	\N	\N	\N	\N	134824	134824	302386
17388	23199	8	applied	\N	\N	\N	\N	134825	134825	302387
17388	23209	9	applied	\N	\N	\N	\N	134826	134826	302388
17388	23213	11	applied	\N	\N	\N	\N	134828	134828	302390
17388	23219	12	applied	\N	\N	\N	\N	134829	134829	302391
17388	23220	13	applied	\N	\N	\N	\N	134830	134830	302392
17388	23226	14	applied	\N	\N	\N	\N	134831	134831	302393
17388	23229	15	applied	\N	\N	\N	\N	134832	134832	302394
17388	23232	16	applied	\N	\N	\N	\N	134833	134833	302395
17388	23235	17	applied	\N	\N	\N	\N	134834	134834	302396
17388	23238	18	applied	\N	\N	\N	\N	134835	134835	302397
17388	23241	19	applied	\N	\N	\N	\N	134836	134836	302398
17388	23244	20	applied	\N	\N	\N	\N	134837	134837	302399
17388	23247	21	applied	\N	\N	\N	\N	134838	134838	302400
17388	23249	22	applied	\N	\N	\N	\N	134839	134839	302401
17388	23252	23	applied	\N	\N	\N	\N	134840	134840	302402
17388	23254	24	applied	\N	\N	\N	\N	134841	134841	302403
17388	23255	25	applied	\N	\N	\N	\N	134842	134842	302404
17388	23256	26	applied	\N	\N	\N	\N	134843	134843	302405
17388	23266	28	applied	\N	\N	\N	\N	134845	134845	302407
17388	23269	29	applied	\N	\N	\N	\N	134846	134846	302408
17388	23270	30	applied	\N	\N	\N	\N	134847	134847	302409
17388	23274	31	applied	\N	\N	\N	\N	134848	134848	302410
17388	23275	32	applied	\N	\N	\N	\N	134849	134849	302411
17388	23280	33	applied	\N	\N	\N	\N	134850	134850	302412
17388	23282	34	applied	\N	\N	\N	\N	134851	134851	302413
17388	23285	35	applied	\N	\N	\N	\N	134852	134852	302414
17388	23288	36	applied	\N	\N	\N	\N	134853	134853	302415
17388	23291	37	applied	\N	\N	\N	\N	134854	134854	302416
17388	23292	38	applied	\N	\N	\N	\N	134855	134855	302417
17388	23297	39	applied	\N	\N	\N	\N	134856	134856	302418
17388	23298	40	applied	\N	\N	\N	\N	134857	134857	302419
17388	23299	41	applied	\N	\N	\N	\N	134858	134858	302420
17388	23305	42	applied	\N	\N	\N	\N	134859	134859	302421
17388	23306	43	applied	\N	\N	\N	\N	134860	134860	302422
17388	23315	45	applied	\N	\N	\N	\N	134862	134862	302424
17388	23317	46	applied	\N	\N	\N	\N	134863	134863	302425
17388	23320	47	applied	\N	\N	\N	\N	134864	134864	302426
17388	23321	48	applied	\N	\N	\N	\N	134865	134865	302427
17388	23322	49	applied	\N	\N	\N	\N	134866	134866	302428
17388	23323	50	applied	\N	\N	\N	\N	134867	134867	302429
17388	23324	51	applied	\N	\N	1000000000	\N	134868	134868	302430
17388	23183	52	applied	\N	\N	\N	\N	134869	134869	302431
17388	23186	53	applied	\N	\N	\N	\N	134870	134870	302432
17416	23390	0	applied	\N	\N	\N	\N	135087	135087	302649
17416	23391	1	applied	\N	\N	\N	\N	135088	135088	302650
17417	23392	0	applied	\N	\N	\N	\N	135089	135089	302651
17417	23393	1	applied	\N	\N	\N	\N	135090	135090	302652
17420	23397	0	applied	\N	\N	\N	\N	135096	135096	302658
17420	23398	1	applied	\N	\N	\N	\N	135097	135097	302659
17422	23399	0	applied	\N	\N	\N	\N	135104	135104	302666
17331	23211	8	applied	\N	\N	\N	\N	134602	134602	302164
17337	23228	2	applied	\N	\N	\N	\N	134626	134626	302188
17340	23232	0	applied	\N	\N	\N	\N	134633	134633	302195
17340	23233	1	applied	\N	\N	\N	\N	134634	134634	302196
17340	23234	2	applied	\N	\N	\N	\N	134635	134635	302197
17342	23238	0	applied	\N	\N	\N	\N	134639	134639	302201
17342	23239	1	applied	\N	\N	\N	\N	134640	134640	302202
17342	23240	2	applied	\N	\N	\N	\N	134641	134641	302203
17345	23241	0	applied	\N	\N	\N	\N	134648	134648	302210
17345	23242	1	applied	\N	\N	\N	\N	134649	134649	302211
17345	23243	2	applied	\N	\N	\N	\N	134650	134650	302212
17350	23244	0	applied	\N	\N	\N	\N	134659	134659	302221
17350	23245	1	applied	\N	\N	\N	\N	134660	134660	302222
17351	23244	0	applied	\N	\N	\N	\N	134662	134662	302224
17351	23247	1	applied	\N	\N	\N	\N	134663	134663	302225
17351	23245	2	applied	\N	\N	\N	\N	134664	134664	302226
17351	23248	3	applied	\N	\N	\N	\N	134665	134665	302227
17351	23246	4	applied	\N	\N	\N	\N	134666	134666	302228
17354	23254	0	applied	\N	\N	\N	\N	134672	134672	302234
17354	23255	1	applied	\N	\N	\N	\N	134673	134673	302235
17354	23256	2	applied	\N	\N	\N	\N	134674	134674	302236
17354	23257	3	applied	\N	\N	\N	\N	134675	134675	302237
17354	23258	4	applied	\N	\N	\N	\N	134676	134676	302238
17354	23259	5	applied	\N	\N	\N	\N	134677	134677	302239
17354	23260	6	applied	\N	\N	\N	\N	134678	134678	302240
17354	23261	7	applied	\N	\N	\N	\N	134679	134679	302241
17354	23262	9	applied	\N	\N	\N	\N	134680	134680	302242
17359	23263	0	applied	\N	\N	\N	\N	134705	134705	302267
17359	23264	1	applied	\N	\N	\N	\N	134706	134706	302268
17362	23263	0	applied	\N	\N	\N	\N	134714	134714	302276
17362	23264	1	applied	\N	\N	\N	\N	134715	134715	302277
17362	23265	2	applied	\N	\N	\N	\N	134716	134716	302278
17367	23269	0	applied	\N	\N	\N	\N	134735	134735	302297
17367	23271	1	applied	\N	\N	\N	\N	134736	134736	302298
17367	23272	2	applied	\N	\N	\N	\N	134737	134737	302299
17367	23273	3	applied	\N	\N	\N	\N	134738	134738	302300
17373	23282	0	applied	\N	\N	\N	\N	134756	134756	302318
17373	23283	1	applied	\N	\N	\N	\N	134757	134757	302319
17373	23284	2	applied	\N	\N	\N	\N	134758	134758	302320
17377	23288	0	applied	\N	\N	\N	\N	134767	134767	302329
17377	23289	1	applied	\N	\N	\N	\N	134768	134768	302330
17377	23290	2	applied	\N	\N	\N	\N	134769	134769	302331
17381	23305	0	applied	\N	\N	\N	\N	134790	134790	302352
17381	23306	1	applied	\N	\N	\N	\N	134791	134791	302353
17381	23307	2	applied	\N	\N	\N	\N	134792	134792	302354
17381	23309	4	applied	\N	\N	\N	\N	134794	134794	302356
17381	23310	5	applied	\N	\N	\N	\N	134795	134795	302357
17383	23311	0	applied	\N	\N	\N	\N	134802	134802	302364
17383	23312	1	applied	\N	\N	\N	\N	134803	134803	302365
17383	23313	2	applied	\N	\N	\N	\N	134804	134804	302366
17388	23191	54	applied	\N	\N	\N	\N	134871	134871	302433
17388	23195	55	applied	\N	\N	\N	\N	134872	134872	302434
17388	23196	56	applied	\N	\N	\N	\N	134873	134873	302435
17388	23210	57	applied	\N	\N	\N	\N	134874	134874	302436
17388	23214	58	applied	\N	\N	\N	\N	134875	134875	302437
17388	23215	59	applied	\N	\N	\N	\N	134876	134876	302438
17388	23218	60	applied	\N	\N	\N	\N	134877	134877	302439
17391	23192	0	applied	\N	\N	\N	\N	134966	134966	302528
17391	22715	1	applied	\N	\N	\N	\N	134967	134967	302529
17391	22698	2	applied	\N	\N	\N	\N	134968	134968	302530
17391	22790	3	applied	\N	\N	\N	\N	134969	134969	302531
17391	22830	5	applied	\N	\N	1000000000	\N	134971	134971	302533
17391	22850	6	applied	\N	\N	\N	\N	134972	134972	302534
17391	22666	7	applied	\N	\N	\N	\N	134973	134973	302535
17391	22667	8	applied	\N	\N	\N	\N	134974	134974	302536
17393	23332	0	applied	\N	\N	\N	\N	134982	134982	302544
17393	23333	1	applied	\N	\N	\N	\N	134983	134983	302545
17393	23334	2	applied	\N	\N	\N	\N	134984	134984	302546
17393	23335	3	applied	\N	\N	\N	\N	134985	134985	302547
17393	23336	4	applied	\N	\N	\N	\N	134986	134986	302548
17393	23337	5	applied	\N	\N	\N	\N	134987	134987	302549
17393	23338	6	applied	\N	\N	\N	\N	134988	134988	302550
17393	23339	7	applied	\N	\N	\N	\N	134989	134989	302551
17396	23345	0	applied	\N	\N	\N	\N	135000	135000	302562
17396	23346	1	applied	\N	\N	\N	\N	135001	135001	302563
17402	23365	0	applied	\N	\N	\N	\N	135040	135040	302602
17402	23366	1	applied	\N	\N	\N	\N	135041	135041	302603
17404	23370	0	applied	\N	\N	\N	\N	135045	135045	302607
17404	23371	1	applied	\N	\N	\N	\N	135046	135046	302608
17407	23376	0	applied	\N	\N	\N	\N	135054	135054	302616
17407	23377	1	applied	\N	\N	\N	\N	135055	135055	302617
17407	23378	2	applied	\N	\N	\N	\N	135056	135056	302618
17407	23379	3	applied	\N	\N	\N	\N	135057	135057	302619
17407	23380	4	applied	\N	\N	\N	\N	135058	135058	302620
17407	23381	5	applied	\N	\N	\N	\N	135059	135059	302621
17413	23387	0	applied	\N	\N	\N	\N	135080	135080	302642
17413	23388	1	applied	\N	\N	\N	\N	135081	135081	302643
17413	23389	2	applied	\N	\N	\N	\N	135082	135082	302644
17414	23390	0	applied	\N	\N	\N	\N	135083	135083	302645
17414	23391	1	applied	\N	\N	\N	\N	135084	135084	302646
17421	23399	0	applied	\N	\N	\N	\N	135098	135098	302660
17421	23400	1	applied	\N	\N	\N	\N	135099	135099	302661
17421	23401	2	applied	\N	\N	\N	\N	135100	135100	302662
17421	23402	3	applied	\N	\N	\N	\N	135101	135101	302663
17421	23403	4	applied	\N	\N	\N	\N	135102	135102	302664
17426	23409	0	applied	\N	\N	\N	\N	135124	135124	302686
17426	23410	1	applied	\N	\N	\N	\N	135125	135125	302687
17426	23411	2	applied	\N	\N	\N	\N	135126	135126	302688
17426	23412	3	applied	\N	\N	\N	\N	135127	135127	302689
17426	23413	4	applied	\N	\N	\N	\N	135128	135128	302690
17426	23414	5	applied	\N	\N	\N	\N	135129	135129	302691
17426	23415	6	applied	\N	\N	\N	\N	135130	135130	302692
17426	23416	7	applied	\N	\N	\N	\N	135131	135131	302693
17431	23422	0	applied	\N	\N	\N	\N	135143	135143	302705
17431	23423	1	applied	\N	\N	\N	\N	135144	135144	302706
17431	23424	2	applied	\N	\N	\N	\N	135145	135145	302707
17431	23425	3	applied	\N	\N	\N	\N	135146	135146	302708
17437	23429	0	applied	\N	\N	\N	\N	135284	135284	302846
17437	23430	1	applied	\N	\N	\N	\N	135285	135285	302847
17437	23431	2	applied	\N	\N	\N	\N	135286	135286	302848
17335	23192	0	applied	\N	\N	\N	\N	134614	134614	302176
17337	23227	1	applied	\N	\N	\N	\N	134625	134625	302187
17363	23266	0	applied	\N	\N	\N	\N	134717	134717	302279
17363	23267	1	applied	\N	\N	\N	\N	134718	134718	302280
17363	23268	2	applied	\N	\N	\N	\N	134719	134719	302281
17365	23269	0	applied	\N	\N	\N	\N	134725	134725	302287
17365	23270	1	applied	\N	\N	\N	\N	134726	134726	302288
17365	23271	2	applied	\N	\N	\N	\N	134727	134727	302289
17365	23272	3	applied	\N	\N	\N	\N	134728	134728	302290
17365	23273	4	applied	\N	\N	\N	\N	134729	134729	302291
17369	23280	0	applied	\N	\N	\N	\N	134746	134746	302308
17369	23281	1	applied	\N	\N	\N	\N	134747	134747	302309
17371	23282	0	applied	\N	\N	\N	\N	134750	134750	302312
17371	23283	1	applied	\N	\N	\N	\N	134751	134751	302313
17371	23284	2	applied	\N	\N	\N	\N	134752	134752	302314
17375	23284	1	applied	\N	\N	\N	\N	134763	134763	302325
17378	23291	0	applied	\N	\N	\N	\N	134770	134770	302332
17378	23292	1	applied	\N	\N	\N	\N	134771	134771	302333
17378	23293	2	applied	\N	\N	\N	\N	134772	134772	302334
17378	23294	3	applied	\N	\N	\N	\N	134773	134773	302335
17378	23295	4	applied	\N	\N	\N	\N	134774	134774	302336
17378	23296	5	applied	\N	\N	\N	\N	134775	134775	302337
17382	23305	0	applied	\N	\N	\N	\N	134796	134796	302358
17382	23306	1	applied	\N	\N	\N	\N	134797	134797	302359
17382	23307	2	applied	\N	\N	\N	\N	134798	134798	302360
17382	23308	3	applied	\N	\N	\N	\N	134799	134799	302361
17382	23309	4	applied	\N	\N	\N	\N	134800	134800	302362
17382	23310	5	applied	\N	\N	\N	\N	134801	134801	302363
17384	23314	0	applied	\N	\N	\N	\N	134805	134805	302367
17389	23320	0	applied	\N	\N	\N	\N	134942	134942	302504
17389	23321	1	applied	\N	\N	\N	\N	134943	134943	302505
17389	23323	3	applied	\N	\N	\N	\N	134945	134945	302507
17389	23324	4	applied	\N	\N	1000000000	\N	134946	134946	302508
17389	23329	5	applied	\N	\N	\N	\N	134947	134947	302509
17389	23330	6	applied	\N	\N	\N	\N	134948	134948	302510
17389	23325	7	applied	\N	\N	\N	\N	134949	134949	302511
17389	23331	8	applied	\N	\N	\N	\N	134950	134950	302512
17389	23326	9	applied	\N	\N	\N	\N	134951	134951	302513
17389	23327	10	applied	\N	\N	\N	\N	134952	134952	302514
17389	23328	11	applied	\N	\N	\N	\N	134953	134953	302515
17394	23340	0	applied	\N	\N	\N	\N	134990	134990	302552
17394	23341	1	applied	\N	\N	\N	\N	134991	134991	302553
17394	23342	2	applied	\N	\N	\N	\N	134992	134992	302554
17394	23343	3	applied	\N	\N	\N	\N	134993	134993	302555
17394	23344	4	applied	\N	\N	\N	\N	134994	134994	302556
17397	23347	0	applied	\N	\N	\N	\N	135002	135002	302564
17397	23348	1	applied	\N	\N	\N	\N	135003	135003	302565
17397	23350	3	applied	\N	\N	\N	\N	135005	135005	302567
17397	23351	5	applied	\N	\N	\N	\N	135006	135006	302568
17397	23352	6	applied	\N	\N	\N	\N	135007	135007	302569
17397	23353	7	applied	\N	\N	\N	\N	135008	135008	302570
17397	23354	8	applied	\N	\N	\N	\N	135009	135009	302571
17397	23355	9	applied	\N	\N	\N	\N	135010	135010	302572
17398	23356	0	applied	\N	\N	\N	\N	135011	135011	302573
17398	23357	1	applied	\N	\N	\N	\N	135012	135012	302574
17398	23358	2	applied	\N	\N	\N	\N	135013	135013	302575
17398	23359	3	applied	\N	\N	\N	\N	135014	135014	302576
17398	23360	4	applied	\N	\N	\N	\N	135015	135015	302577
17398	23361	5	applied	\N	\N	\N	\N	135016	135016	302578
17398	23362	6	applied	\N	\N	\N	\N	135017	135017	302579
17398	23363	7	applied	\N	\N	\N	\N	135018	135018	302580
17398	23364	8	applied	\N	\N	\N	\N	135019	135019	302581
17405	23373	0	applied	\N	\N	\N	\N	135048	135048	302610
17405	23375	2	applied	\N	\N	\N	\N	135050	135050	302612
17408	23376	0	applied	\N	\N	\N	\N	135060	135060	302622
17408	23377	1	applied	\N	\N	\N	\N	135061	135061	302623
17408	23378	2	applied	\N	\N	\N	\N	135062	135062	302624
17408	23379	3	applied	\N	\N	\N	\N	135063	135063	302625
17408	23380	4	applied	\N	\N	\N	\N	135064	135064	302626
17408	23381	5	applied	\N	\N	\N	\N	135065	135065	302627
17410	23387	0	applied	\N	\N	\N	\N	135071	135071	302633
17410	23388	1	applied	\N	\N	\N	\N	135072	135072	302634
17410	23389	2	applied	\N	\N	\N	\N	135073	135073	302635
17415	23390	0	applied	\N	\N	\N	\N	135085	135085	302647
17415	23391	1	applied	\N	\N	\N	\N	135086	135086	302648
17419	23397	0	applied	\N	\N	\N	\N	135094	135094	302656
17419	23398	1	applied	\N	\N	\N	\N	135095	135095	302657
17424	23405	0	applied	\N	\N	\N	\N	135116	135116	302678
17424	23406	1	applied	\N	\N	\N	\N	135117	135117	302679
17424	23408	3	applied	\N	\N	\N	\N	135119	135119	302681
17429	23419	0	applied	\N	\N	\N	\N	135136	135136	302698
17429	23420	1	applied	\N	\N	\N	\N	135137	135137	302699
17429	23421	2	applied	\N	\N	\N	\N	135138	135138	302700
17434	23426	0	applied	\N	\N	\N	\N	135275	135275	302837
17434	23427	1	applied	\N	\N	\N	\N	135276	135276	302838
17434	23428	2	applied	\N	\N	\N	\N	135277	135277	302839
17438	23432	0	applied	\N	\N	\N	\N	135287	135287	302849
17438	23433	1	applied	\N	\N	\N	\N	135288	135288	302850
17438	23434	2	applied	\N	\N	\N	\N	135289	135289	302851
17438	23435	3	applied	\N	\N	\N	\N	135290	135290	302852
17438	23436	5	applied	\N	\N	\N	\N	135291	135291	302853
17438	23437	6	applied	\N	\N	\N	\N	135292	135292	302854
17440	23432	0	applied	\N	\N	\N	\N	135299	135299	302861
17440	23433	1	applied	\N	\N	\N	\N	135300	135300	302862
17440	23434	2	applied	\N	\N	\N	\N	135301	135301	302863
17440	23436	5	applied	\N	\N	\N	\N	135303	135303	302865
17440	23437	6	applied	\N	\N	\N	\N	135304	135304	302866
17441	23432	0	applied	\N	\N	\N	\N	135305	135305	302867
17441	23433	1	applied	\N	\N	\N	\N	135306	135306	302868
17441	23434	2	applied	\N	\N	\N	\N	135307	135307	302869
17441	23435	3	applied	\N	\N	\N	\N	135308	135308	302870
17441	23436	5	applied	\N	\N	\N	\N	135309	135309	302871
17441	23437	6	applied	\N	\N	\N	\N	135310	135310	302872
17443	23432	0	applied	\N	\N	\N	\N	135317	135317	302879
17449	23446	0	applied	\N	\N	\N	\N	135345	135345	302907
17449	23447	1	applied	\N	\N	\N	\N	135346	135346	302908
17451	23192	0	applied	\N	\N	\N	\N	135365	135365	302927
17451	23448	1	applied	\N	\N	1000000000	\N	135366	135366	302928
17451	22715	2	applied	\N	\N	\N	\N	135367	135367	302929
17451	22641	3	applied	\N	\N	\N	\N	135368	135368	302930
17451	22645	4	applied	\N	\N	\N	\N	135369	135369	302931
17360	23264	1	applied	\N	\N	\N	\N	134709	134709	302271
17360	23265	2	applied	\N	\N	\N	\N	134710	134710	302272
17388	23234	65	applied	\N	\N	\N	\N	134882	134882	302444
17388	23236	66	applied	\N	\N	\N	\N	134883	134883	302445
17388	23240	67	applied	\N	\N	\N	\N	134884	134884	302446
17388	23243	68	applied	\N	\N	\N	\N	134885	134885	302447
17388	23246	69	applied	\N	\N	\N	\N	134886	134886	302448
17388	23251	70	applied	\N	\N	\N	\N	134887	134887	302449
17388	23260	71	applied	\N	\N	\N	\N	134888	134888	302450
17388	23261	72	applied	\N	\N	\N	\N	134889	134889	302451
17388	23262	73	applied	\N	\N	\N	\N	134890	134890	302452
17388	23265	74	applied	\N	\N	\N	\N	134891	134891	302453
17388	23268	75	applied	\N	\N	\N	\N	134892	134892	302454
17388	23271	76	applied	\N	\N	\N	\N	134893	134893	302455
17388	23276	77	applied	\N	\N	\N	\N	134894	134894	302456
17388	23277	78	applied	\N	\N	\N	\N	134895	134895	302457
17388	23284	79	applied	\N	\N	\N	\N	134896	134896	302458
17388	23286	80	applied	\N	\N	\N	\N	134897	134897	302459
17388	23295	82	applied	\N	\N	\N	\N	134899	134899	302461
17388	23296	83	applied	\N	\N	\N	\N	134900	134900	302462
17388	23301	84	applied	\N	\N	\N	\N	134901	134901	302463
17388	23302	85	applied	\N	\N	\N	\N	134902	134902	302464
17388	23309	86	applied	\N	\N	\N	\N	134903	134903	302465
17388	23310	87	applied	\N	\N	\N	\N	134904	134904	302466
17388	23313	88	applied	\N	\N	\N	\N	134905	134905	302467
17388	23316	89	applied	\N	\N	\N	\N	134906	134906	302468
17388	23318	90	applied	\N	\N	\N	\N	134907	134907	302469
17388	23325	91	applied	\N	\N	\N	\N	134908	134908	302470
17388	23326	92	applied	\N	\N	\N	\N	134909	134909	302471
17388	23327	93	applied	\N	\N	\N	\N	134910	134910	302472
17388	23328	94	applied	\N	\N	\N	\N	134911	134911	302473
17388	23180	95	applied	\N	\N	\N	\N	134912	134912	302474
17388	23182	96	applied	\N	\N	\N	\N	134913	134913	302475
17388	23185	97	applied	\N	\N	\N	\N	134914	134914	302476
17388	23190	99	applied	\N	\N	\N	\N	134916	134916	302478
17388	23197	100	applied	\N	\N	\N	\N	134917	134917	302479
17388	23198	101	applied	\N	\N	\N	\N	134918	134918	302480
17388	23200	102	applied	\N	\N	\N	\N	134919	134919	302481
17388	23211	103	applied	\N	\N	\N	\N	134920	134920	302482
17388	23216	104	applied	\N	\N	\N	\N	134921	134921	302483
17388	23217	105	applied	\N	\N	\N	\N	134922	134922	302484
17388	23223	106	applied	\N	\N	\N	\N	134923	134923	302485
17388	23224	107	applied	\N	\N	\N	\N	134924	134924	302486
17388	23225	108	applied	\N	\N	\N	\N	134925	134925	302487
17388	23227	109	applied	\N	\N	\N	\N	134926	134926	302488
17388	23230	110	applied	\N	\N	\N	\N	134927	134927	302489
17388	23233	111	applied	\N	\N	\N	\N	134928	134928	302490
17388	23237	112	applied	\N	\N	\N	\N	134929	134929	302491
17388	23239	113	applied	\N	\N	\N	\N	134930	134930	302492
17388	23242	114	applied	\N	\N	\N	\N	134931	134931	302493
17388	23248	116	applied	\N	\N	\N	\N	134933	134933	302495
17388	23250	117	applied	\N	\N	\N	\N	134934	134934	302496
17388	23253	118	applied	\N	\N	\N	\N	134935	134935	302497
17388	23257	119	applied	\N	\N	\N	\N	134936	134936	302498
17388	23258	120	applied	\N	\N	\N	\N	134937	134937	302499
17388	23259	121	applied	\N	\N	\N	\N	134938	134938	302500
17388	23264	122	applied	\N	\N	\N	\N	134939	134939	302501
17388	23267	123	applied	\N	\N	\N	\N	134940	134940	302502
17388	23272	125	applied	\N	\N	\N	\N	134941	134941	302503
17400	23356	0	applied	\N	\N	\N	\N	135029	135029	302591
17400	23357	1	applied	\N	\N	\N	\N	135030	135030	302592
17400	23358	2	applied	\N	\N	\N	\N	135031	135031	302593
17400	23359	3	applied	\N	\N	\N	\N	135032	135032	302594
17400	23360	4	applied	\N	\N	\N	\N	135033	135033	302595
17400	23361	5	applied	\N	\N	\N	\N	135034	135034	302596
17400	23362	6	applied	\N	\N	\N	\N	135035	135035	302597
17400	23364	8	applied	\N	\N	\N	\N	135037	135037	302599
17401	23365	0	applied	\N	\N	\N	\N	135038	135038	302600
17401	23366	1	applied	\N	\N	\N	\N	135039	135039	302601
17409	23382	0	applied	\N	\N	\N	\N	135066	135066	302628
17409	23383	1	applied	\N	\N	\N	\N	135067	135067	302629
17409	23384	2	applied	\N	\N	\N	\N	135068	135068	302630
17409	23385	3	applied	\N	\N	\N	\N	135069	135069	302631
17409	23386	4	applied	\N	\N	\N	\N	135070	135070	302632
17412	23387	0	applied	\N	\N	\N	\N	135077	135077	302639
17412	23388	1	applied	\N	\N	\N	\N	135078	135078	302640
17412	23389	2	applied	\N	\N	\N	\N	135079	135079	302641
17418	23394	0	applied	\N	\N	\N	\N	135091	135091	302653
17418	23395	1	applied	\N	\N	\N	\N	135092	135092	302654
17418	23396	2	applied	\N	\N	\N	\N	135093	135093	302655
17423	23399	0	applied	\N	\N	\N	\N	135110	135110	302672
17423	23400	1	applied	\N	\N	\N	\N	135111	135111	302673
17423	23402	3	applied	\N	\N	\N	\N	135113	135113	302675
17423	23403	4	applied	\N	\N	\N	\N	135114	135114	302676
17423	23404	5	applied	\N	\N	\N	\N	135115	135115	302677
17428	23417	0	applied	\N	\N	\N	\N	135134	135134	302696
17428	23418	1	applied	\N	\N	\N	\N	135135	135135	302697
17430	23422	0	applied	\N	\N	\N	\N	135139	135139	302701
17430	23423	1	applied	\N	\N	\N	\N	135140	135140	302702
17430	23424	2	applied	\N	\N	\N	\N	135141	135141	302703
17430	23425	3	applied	\N	\N	\N	\N	135142	135142	302704
17433	23426	0	applied	\N	\N	\N	\N	135272	135272	302834
17433	23427	1	applied	\N	\N	\N	\N	135273	135273	302835
17433	23428	2	applied	\N	\N	\N	\N	135274	135274	302836
17447	23440	0	applied	\N	\N	\N	\N	135337	135337	302899
17447	23441	1	applied	\N	\N	\N	\N	135338	135338	302900
17447	23442	2	applied	\N	\N	\N	\N	135339	135339	302901
17447	23443	3	applied	\N	\N	\N	\N	135340	135340	302902
17447	23445	5	applied	\N	\N	\N	\N	135342	135342	302904
17448	23446	0	applied	\N	\N	\N	\N	135343	135343	302905
17448	23447	1	applied	\N	\N	\N	\N	135344	135344	302906
17451	23450	6	applied	\N	\N	\N	\N	135371	135371	302933
17451	23451	7	applied	\N	\N	\N	\N	135372	135372	302934
17451	23452	8	applied	\N	\N	\N	\N	135373	135373	302935
17451	23453	9	applied	\N	\N	\N	\N	135374	135374	302936
17451	23454	10	applied	\N	\N	\N	\N	135375	135375	302937
17451	23455	11	applied	\N	\N	\N	\N	135376	135376	302938
17451	23394	12	applied	\N	\N	\N	\N	135377	135377	302939
17453	23472	0	applied	\N	\N	\N	\N	135496	135496	303058
17453	23473	1	applied	\N	\N	\N	\N	135497	135497	303059
17453	23474	2	applied	\N	\N	\N	\N	135498	135498	303060
17453	23475	3	applied	\N	\N	\N	\N	135499	135499	303061
17388	23222	62	applied	\N	\N	\N	\N	134879	134879	302441
17388	23228	63	applied	\N	\N	\N	\N	134880	134880	302442
17422	23404	5	applied	\N	\N	\N	\N	135109	135109	302671
17425	23405	0	applied	\N	\N	\N	\N	135120	135120	302682
17425	23406	1	applied	\N	\N	\N	\N	135121	135121	302683
17425	23407	2	applied	\N	\N	\N	\N	135122	135122	302684
17425	23408	3	applied	\N	\N	\N	\N	135123	135123	302685
17427	23417	0	applied	\N	\N	\N	\N	135132	135132	302694
17427	23418	1	applied	\N	\N	\N	\N	135133	135133	302695
17432	23192	0	applied	\N	\N	\N	\N	135147	135147	302709
17432	23159	1	applied	\N	\N	\N	\N	135148	135148	302710
17432	23394	2	applied	\N	\N	\N	\N	135149	135149	302711
17432	23160	3	applied	\N	\N	\N	\N	135150	135150	302712
17432	23165	4	applied	\N	\N	\N	\N	135151	135151	302713
17432	23168	5	applied	\N	\N	\N	\N	135152	135152	302714
17432	23170	6	applied	\N	\N	\N	\N	135153	135153	302715
17432	23176	8	applied	\N	\N	\N	\N	135155	135155	302717
17432	23423	9	applied	\N	\N	\N	\N	135156	135156	302718
17432	23179	10	applied	\N	\N	\N	\N	135157	135157	302719
17432	23181	11	applied	\N	\N	\N	\N	135158	135158	302720
17432	23184	12	applied	\N	\N	\N	\N	135159	135159	302721
17432	23187	13	applied	\N	\N	\N	\N	135160	135160	302722
17432	23189	14	applied	\N	\N	\N	\N	135161	135161	302723
17432	23193	15	applied	\N	\N	\N	\N	135162	135162	302724
17432	23194	16	applied	\N	\N	\N	\N	135163	135163	302725
17432	23199	17	applied	\N	\N	\N	\N	135164	135164	302726
17432	23209	18	applied	\N	\N	\N	\N	135165	135165	302727
17432	23212	19	applied	\N	\N	\N	\N	135166	135166	302728
17432	23213	20	applied	\N	\N	\N	\N	135167	135167	302729
17432	23219	21	applied	\N	\N	\N	\N	135168	135168	302730
17432	23220	22	applied	\N	\N	\N	\N	135169	135169	302731
17432	23226	23	applied	\N	\N	\N	\N	135170	135170	302732
17432	23232	25	applied	\N	\N	\N	\N	135172	135172	302734
17432	23235	26	applied	\N	\N	\N	\N	135173	135173	302735
17432	23238	27	applied	\N	\N	\N	\N	135174	135174	302736
17432	23241	28	applied	\N	\N	\N	\N	135175	135175	302737
17432	23244	30	applied	\N	\N	\N	\N	135176	135176	302738
17432	23247	31	applied	\N	\N	\N	\N	135177	135177	302739
17432	23249	32	applied	\N	\N	\N	\N	135178	135178	302740
17432	23252	33	applied	\N	\N	\N	\N	135179	135179	302741
17432	23254	34	applied	\N	\N	\N	\N	135180	135180	302742
17432	23255	35	applied	\N	\N	\N	\N	135181	135181	302743
17432	23256	36	applied	\N	\N	\N	\N	135182	135182	302744
17432	23263	37	applied	\N	\N	\N	\N	135183	135183	302745
17432	23266	38	applied	\N	\N	\N	\N	135184	135184	302746
17432	23269	39	applied	\N	\N	\N	\N	135185	135185	302747
17432	23270	40	applied	\N	\N	\N	\N	135186	135186	302748
17432	23274	41	applied	\N	\N	\N	\N	135187	135187	302749
17432	23280	43	applied	\N	\N	\N	\N	135189	135189	302751
17432	23282	44	applied	\N	\N	\N	\N	135190	135190	302752
17432	23285	45	applied	\N	\N	\N	\N	135191	135191	302753
17432	23288	46	applied	\N	\N	\N	\N	135192	135192	302754
17432	23291	47	applied	\N	\N	\N	\N	135193	135193	302755
17432	23292	48	applied	\N	\N	\N	\N	135194	135194	302756
17432	23297	49	applied	\N	\N	\N	\N	135195	135195	302757
17432	23298	50	applied	\N	\N	\N	\N	135196	135196	302758
17432	23299	51	applied	\N	\N	\N	\N	135197	135197	302759
17432	23305	52	applied	\N	\N	\N	\N	135198	135198	302760
17432	23306	53	applied	\N	\N	\N	\N	135199	135199	302761
17432	23311	54	applied	\N	\N	\N	\N	135200	135200	302762
17432	23315	55	applied	\N	\N	\N	\N	135201	135201	302763
17432	23317	56	applied	\N	\N	\N	\N	135202	135202	302764
17432	23320	57	applied	\N	\N	\N	\N	135203	135203	302765
17432	23321	58	applied	\N	\N	\N	\N	135204	135204	302766
17432	23323	60	applied	\N	\N	\N	\N	135206	135206	302768
17432	23332	61	applied	\N	\N	\N	\N	135207	135207	302769
17432	23333	62	applied	\N	\N	\N	\N	135208	135208	302770
17432	23340	63	applied	\N	\N	\N	\N	135209	135209	302771
17432	23341	64	applied	\N	\N	\N	\N	135210	135210	302772
17432	23345	65	applied	\N	\N	\N	\N	135211	135211	302773
17432	23347	66	applied	\N	\N	\N	\N	135212	135212	302774
17432	23348	67	applied	\N	\N	\N	\N	135213	135213	302775
17432	23349	68	applied	\N	\N	\N	\N	135214	135214	302776
17432	23356	69	applied	\N	\N	\N	\N	135215	135215	302777
17432	23357	70	applied	\N	\N	\N	\N	135216	135216	302778
17432	23358	71	applied	\N	\N	\N	\N	135217	135217	302779
17432	23367	72	applied	\N	\N	\N	\N	135218	135218	302780
17432	23370	73	applied	\N	\N	\N	\N	135219	135219	302781
17432	23373	74	applied	\N	\N	\N	\N	135220	135220	302782
17432	23376	75	applied	\N	\N	\N	\N	135221	135221	302783
17432	23382	77	applied	\N	\N	\N	\N	135223	135223	302785
17432	23383	78	applied	\N	\N	\N	\N	135224	135224	302786
17432	23387	79	applied	\N	\N	\N	\N	135225	135225	302787
17432	23399	80	applied	\N	\N	\N	\N	135226	135226	302788
17432	23400	81	applied	\N	\N	\N	\N	135227	135227	302789
17432	23407	82	applied	\N	\N	\N	\N	135228	135228	302790
17432	23411	83	applied	\N	\N	\N	\N	135229	135229	302791
17432	23412	84	applied	\N	\N	\N	\N	135230	135230	302792
17432	23417	85	applied	\N	\N	\N	\N	135231	135231	302793
17432	23419	86	applied	\N	\N	\N	\N	135232	135232	302794
17432	23422	87	applied	\N	\N	\N	\N	135233	135233	302795
17432	23324	88	applied	\N	\N	1000000000	\N	135234	135234	302796
17432	23161	89	applied	\N	\N	\N	\N	135235	135235	302797
17432	23162	90	applied	\N	\N	\N	\N	135236	135236	302798
17432	23163	91	applied	\N	\N	\N	\N	135237	135237	302799
17432	23167	92	applied	\N	\N	\N	\N	135238	135238	302800
17432	23173	94	applied	\N	\N	\N	\N	135240	135240	302802
17432	23177	95	applied	\N	\N	\N	\N	135241	135241	302803
17432	23183	96	applied	\N	\N	\N	\N	135242	135242	302804
17432	23186	97	applied	\N	\N	\N	\N	135243	135243	302805
17432	23191	98	applied	\N	\N	\N	\N	135244	135244	302806
17432	23195	99	applied	\N	\N	\N	\N	135245	135245	302807
17432	23196	100	applied	\N	\N	\N	\N	135246	135246	302808
17432	23210	101	applied	\N	\N	\N	\N	135247	135247	302809
17432	23334	102	applied	\N	\N	\N	\N	135248	135248	302810
17453	23476	4	applied	\N	\N	\N	\N	135500	135500	303062
17453	23477	5	applied	\N	\N	\N	\N	135501	135501	303063
17453	23478	6	applied	\N	\N	\N	\N	135502	135502	303064
17456	23487	0	applied	\N	\N	\N	\N	135518	135518	303080
17456	23488	1	applied	\N	\N	\N	\N	135519	135519	303081
17456	23489	2	applied	\N	\N	\N	\N	135520	135520	303082
17456	23490	3	applied	\N	\N	\N	\N	135521	135521	303083
17422	23403	4	applied	\N	\N	\N	\N	135108	135108	302670
17432	23175	107	applied	\N	\N	\N	\N	135253	135253	302815
17432	23214	108	applied	\N	\N	\N	\N	135254	135254	302816
17432	23215	109	applied	\N	\N	\N	\N	135255	135255	302817
17432	23218	110	applied	\N	\N	\N	\N	135256	135256	302818
17432	23221	111	applied	\N	\N	\N	\N	135257	135257	302819
17432	23222	112	applied	\N	\N	\N	\N	135258	135258	302820
17432	23228	113	applied	\N	\N	\N	\N	135259	135259	302821
17432	23231	114	applied	\N	\N	\N	\N	135260	135260	302822
17432	23234	115	applied	\N	\N	\N	\N	135261	135261	302823
17432	23236	116	applied	\N	\N	\N	\N	135262	135262	302824
17432	23240	117	applied	\N	\N	\N	\N	135263	135263	302825
17432	23243	118	applied	\N	\N	\N	\N	135264	135264	302826
17432	23246	119	applied	\N	\N	\N	\N	135265	135265	302827
17432	23251	120	applied	\N	\N	\N	\N	135266	135266	302828
17432	23260	121	applied	\N	\N	\N	\N	135267	135267	302829
17432	23261	122	applied	\N	\N	\N	\N	135268	135268	302830
17432	23265	124	applied	\N	\N	\N	\N	135270	135270	302832
17432	23268	125	applied	\N	\N	\N	\N	135271	135271	302833
17435	23426	0	applied	\N	\N	\N	\N	135278	135278	302840
17435	23427	1	applied	\N	\N	\N	\N	135279	135279	302841
17435	23428	2	applied	\N	\N	\N	\N	135280	135280	302842
17436	23429	0	applied	\N	\N	\N	\N	135281	135281	302843
17436	23430	1	applied	\N	\N	\N	\N	135282	135282	302844
17436	23431	2	applied	\N	\N	\N	\N	135283	135283	302845
17439	23432	0	applied	\N	\N	\N	\N	135293	135293	302855
17439	23433	1	applied	\N	\N	\N	\N	135294	135294	302856
17439	23434	2	applied	\N	\N	\N	\N	135295	135295	302857
17439	23435	3	applied	\N	\N	\N	\N	135296	135296	302858
17439	23436	5	applied	\N	\N	\N	\N	135297	135297	302859
17439	23437	6	applied	\N	\N	\N	\N	135298	135298	302860
17442	23432	0	applied	\N	\N	\N	\N	135311	135311	302873
17442	23433	1	applied	\N	\N	\N	\N	135312	135312	302874
17442	23435	3	applied	\N	\N	\N	\N	135314	135314	302876
17442	23436	5	applied	\N	\N	\N	\N	135315	135315	302877
17442	23437	6	applied	\N	\N	\N	\N	135316	135316	302878
17444	23438	0	applied	\N	\N	\N	\N	135323	135323	302885
17444	23439	1	applied	\N	\N	\N	\N	135324	135324	302886
17445	23440	0	applied	\N	\N	\N	\N	135325	135325	302887
17445	23441	1	applied	\N	\N	\N	\N	135326	135326	302888
17445	23442	2	applied	\N	\N	\N	\N	135327	135327	302889
17445	23443	3	applied	\N	\N	\N	\N	135328	135328	302890
17445	23444	4	applied	\N	\N	\N	\N	135329	135329	302891
17445	23445	5	applied	\N	\N	\N	\N	135330	135330	302892
17452	23466	0	applied	\N	\N	\N	\N	135490	135490	303052
17452	23467	1	applied	\N	\N	\N	\N	135491	135491	303053
17452	23468	2	applied	\N	\N	\N	\N	135492	135492	303054
17452	23469	3	applied	\N	\N	\N	\N	135493	135493	303055
17452	23470	4	applied	\N	\N	\N	\N	135494	135494	303056
17458	23487	0	applied	\N	\N	\N	\N	135573	135573	303135
17458	23488	1	applied	\N	\N	\N	\N	135574	135574	303136
17458	23489	2	applied	\N	\N	\N	\N	135575	135575	303137
17458	23490	3	applied	\N	\N	\N	\N	135576	135576	303138
17458	23491	4	applied	\N	\N	\N	\N	135577	135577	303139
17458	23506	5	applied	\N	\N	\N	\N	135578	135578	303140
17458	23507	6	applied	\N	\N	\N	\N	135579	135579	303141
17458	23492	7	applied	\N	\N	\N	\N	135580	135580	303142
17458	23493	8	applied	\N	\N	\N	\N	135581	135581	303143
17458	23494	9	applied	\N	\N	\N	\N	135582	135582	303144
17458	23495	10	applied	\N	\N	\N	\N	135583	135583	303145
17458	23496	11	applied	\N	\N	\N	\N	135584	135584	303146
17458	23497	12	applied	\N	\N	\N	\N	135585	135585	303147
17458	23498	13	applied	\N	\N	\N	\N	135586	135586	303148
17458	23499	14	applied	\N	\N	\N	\N	135587	135587	303149
17458	23500	15	applied	\N	\N	\N	\N	135588	135588	303150
17458	23508	17	applied	\N	\N	\N	\N	135590	135590	303152
17458	23509	18	applied	\N	\N	\N	\N	135591	135591	303153
17458	23510	19	applied	\N	\N	\N	\N	135592	135592	303154
17458	23511	20	applied	\N	\N	\N	\N	135593	135593	303155
17458	23512	21	applied	\N	\N	\N	\N	135594	135594	303156
17458	23513	22	applied	\N	\N	\N	\N	135595	135595	303157
17458	23514	23	applied	\N	\N	\N	\N	135596	135596	303158
17458	23515	24	applied	\N	\N	\N	\N	135597	135597	303159
17458	23516	25	applied	\N	\N	\N	\N	135598	135598	303160
17458	23517	26	applied	\N	\N	\N	\N	135599	135599	303161
17458	23518	27	applied	\N	\N	\N	\N	135600	135600	303162
17458	23502	28	applied	\N	\N	\N	\N	135601	135601	303163
17458	23503	29	applied	\N	\N	\N	\N	135602	135602	303164
17458	23519	30	applied	\N	\N	\N	\N	135603	135603	303165
17458	23504	31	applied	\N	\N	\N	\N	135604	135604	303166
17458	23505	32	applied	\N	\N	\N	\N	135605	135605	303167
17458	23521	34	applied	\N	\N	\N	\N	135607	135607	303169
17458	23522	35	applied	\N	\N	\N	\N	135608	135608	303170
17463	23506	0	applied	\N	\N	\N	\N	135668	135668	303230
17463	23507	1	applied	\N	\N	\N	\N	135669	135669	303231
17463	23529	2	applied	\N	\N	\N	\N	135670	135670	303232
17463	23508	3	applied	\N	\N	\N	\N	135671	135671	303233
17463	23509	4	applied	\N	\N	\N	\N	135672	135672	303234
17463	23510	5	applied	\N	\N	\N	\N	135673	135673	303235
17463	23511	6	applied	\N	\N	\N	\N	135674	135674	303236
17463	23512	7	applied	\N	\N	\N	\N	135675	135675	303237
17463	23513	8	applied	\N	\N	\N	\N	135676	135676	303238
17463	23514	9	applied	\N	\N	\N	\N	135677	135677	303239
17463	23515	10	applied	\N	\N	\N	\N	135678	135678	303240
17463	23516	11	applied	\N	\N	\N	\N	135679	135679	303241
17463	23517	12	applied	\N	\N	\N	\N	135680	135680	303242
17463	23518	13	applied	\N	\N	\N	\N	135681	135681	303243
17463	23524	15	applied	\N	\N	\N	\N	135683	135683	303245
17463	23525	16	applied	\N	\N	\N	\N	135684	135684	303246
17463	23526	17	applied	\N	\N	\N	\N	135685	135685	303247
17463	23527	18	applied	\N	\N	\N	\N	135686	135686	303248
17463	23519	19	applied	\N	\N	\N	\N	135687	135687	303249
17463	23520	20	applied	\N	\N	\N	\N	135688	135688	303250
17463	23530	21	applied	\N	\N	\N	\N	135689	135689	303251
17463	23521	22	applied	\N	\N	\N	\N	135690	135690	303252
17463	23522	23	applied	\N	\N	\N	\N	135691	135691	303253
17463	23531	24	applied	\N	\N	\N	\N	135692	135692	303254
17464	23532	0	applied	\N	\N	\N	\N	135693	135693	303255
17464	23533	1	applied	\N	\N	\N	\N	135694	135694	303256
17464	23534	2	applied	\N	\N	\N	\N	135695	135695	303257
17464	23535	3	applied	\N	\N	\N	\N	135696	135696	303258
17432	23166	104	applied	\N	\N	\N	\N	135250	135250	302812
17432	23169	105	applied	\N	\N	\N	\N	135251	135251	302813
17443	23437	6	applied	\N	\N	\N	\N	135322	135322	302884
17446	23440	0	applied	\N	\N	\N	\N	135331	135331	302893
17446	23441	1	applied	\N	\N	\N	\N	135332	135332	302894
17446	23442	2	applied	\N	\N	\N	\N	135333	135333	302895
17446	23443	3	applied	\N	\N	\N	\N	135334	135334	302896
17446	23444	4	applied	\N	\N	\N	\N	135335	135335	302897
17446	23445	5	applied	\N	\N	\N	\N	135336	135336	302898
17450	23448	0	applied	\N	\N	1000000000	\N	135347	135347	302909
17450	23449	1	applied	\N	\N	\N	\N	135348	135348	302910
17450	23450	2	applied	\N	\N	\N	\N	135349	135349	302911
17450	23451	3	applied	\N	\N	\N	\N	135350	135350	302912
17450	23452	4	applied	\N	\N	\N	\N	135351	135351	302913
17450	23453	5	applied	\N	\N	\N	\N	135352	135352	302914
17450	23454	6	applied	\N	\N	\N	\N	135353	135353	302915
17450	23456	8	applied	\N	\N	\N	\N	135355	135355	302917
17450	23457	9	applied	\N	\N	\N	\N	135356	135356	302918
17450	23458	10	applied	\N	\N	\N	\N	135357	135357	302919
17450	23459	11	applied	\N	\N	\N	\N	135358	135358	302920
17450	23460	12	applied	\N	\N	\N	\N	135359	135359	302921
17450	23461	13	applied	\N	\N	\N	\N	135360	135360	302922
17450	23462	14	applied	\N	\N	\N	\N	135361	135361	302923
17450	23463	15	applied	\N	\N	\N	\N	135362	135362	302924
17450	23464	16	applied	\N	\N	\N	\N	135363	135363	302925
17450	23465	17	applied	\N	\N	\N	\N	135364	135364	302926
17455	23479	0	applied	\N	\N	\N	\N	135510	135510	303072
17455	23480	1	applied	\N	\N	\N	\N	135511	135511	303073
17455	23481	2	applied	\N	\N	\N	\N	135512	135512	303074
17455	23482	3	applied	\N	\N	\N	\N	135513	135513	303075
17455	23483	4	applied	\N	\N	\N	\N	135514	135514	303076
17455	23484	5	applied	\N	\N	\N	\N	135515	135515	303077
17455	23486	7	applied	\N	\N	\N	\N	135517	135517	303079
17460	23523	0	applied	\N	\N	\N	\N	135626	135626	303188
17460	23524	1	applied	\N	\N	\N	\N	135627	135627	303189
17460	23525	2	applied	\N	\N	\N	\N	135628	135628	303190
17460	23526	3	applied	\N	\N	\N	\N	135629	135629	303191
17460	23527	4	applied	\N	\N	\N	\N	135630	135630	303192
17460	23528	5	applied	\N	\N	\N	\N	135631	135631	303193
17460	23529	6	applied	\N	\N	\N	\N	135632	135632	303194
17460	23530	7	applied	\N	\N	\N	\N	135633	135633	303195
17460	23531	8	applied	\N	\N	\N	\N	135634	135634	303196
17464	23536	4	applied	\N	\N	\N	\N	135697	135697	303259
17464	23537	5	applied	\N	\N	\N	\N	135698	135698	303260
17464	23538	6	applied	\N	\N	\N	\N	135699	135699	303261
17464	23539	7	applied	\N	\N	\N	\N	135700	135700	303262
17464	23540	8	applied	\N	\N	\N	\N	135701	135701	303263
17464	23541	10	applied	\N	\N	\N	\N	135702	135702	303264
17465	23538	0	applied	\N	\N	\N	\N	135706	135706	303268
17465	23539	1	applied	\N	\N	\N	\N	135707	135707	303269
17465	23542	2	applied	\N	\N	\N	\N	135708	135708	303270
17465	23543	3	applied	\N	\N	\N	\N	135709	135709	303271
17465	23544	4	applied	\N	\N	\N	\N	135710	135710	303272
17467	23532	0	applied	\N	\N	\N	\N	135836	135836	303398
17467	23533	1	applied	\N	\N	\N	\N	135837	135837	303399
17467	23534	3	applied	\N	\N	\N	\N	135838	135838	303400
17467	23535	4	applied	\N	\N	\N	\N	135839	135839	303401
17467	23536	5	applied	\N	\N	\N	\N	135840	135840	303402
17467	23537	6	applied	\N	\N	\N	\N	135841	135841	303403
17467	23545	7	applied	\N	\N	\N	\N	135842	135842	303404
17467	23546	8	applied	\N	\N	\N	\N	135843	135843	303405
17467	23540	9	applied	\N	\N	\N	\N	135844	135844	303406
17467	23541	10	applied	\N	\N	\N	\N	135845	135845	303407
17467	23547	11	applied	\N	\N	\N	\N	135846	135846	303408
17472	23536	0	applied	\N	\N	\N	\N	135878	135878	303440
17472	23537	1	applied	\N	\N	\N	\N	135879	135879	303441
17472	23545	2	applied	\N	\N	\N	\N	135880	135880	303442
17472	23546	3	applied	\N	\N	\N	\N	135881	135881	303443
17472	23563	4	applied	\N	\N	\N	\N	135882	135882	303444
17472	23540	5	applied	\N	\N	\N	\N	135883	135883	303445
17472	23541	6	applied	\N	\N	\N	\N	135884	135884	303446
17472	23549	7	applied	\N	\N	\N	\N	135885	135885	303447
17472	23550	8	applied	\N	\N	\N	\N	135886	135886	303448
17472	23551	9	applied	\N	\N	\N	\N	135887	135887	303449
17472	23552	10	applied	\N	\N	\N	\N	135888	135888	303450
17472	23553	11	applied	\N	\N	\N	\N	135889	135889	303451
17472	23554	12	applied	\N	\N	\N	\N	135890	135890	303452
17472	23555	13	applied	\N	\N	\N	\N	135891	135891	303453
17472	23556	14	applied	\N	\N	\N	\N	135892	135892	303454
17472	23557	15	applied	\N	\N	\N	\N	135893	135893	303455
17472	23559	17	applied	\N	\N	\N	\N	135895	135895	303457
17472	23560	18	applied	\N	\N	\N	\N	135896	135896	303458
17472	23564	19	applied	\N	\N	\N	\N	135897	135897	303459
17472	23565	20	applied	\N	\N	\N	\N	135898	135898	303460
17472	23566	21	applied	\N	\N	\N	\N	135899	135899	303461
17472	23567	22	applied	\N	\N	\N	\N	135900	135900	303462
17472	23561	23	applied	\N	\N	\N	\N	135901	135901	303463
17472	23547	24	applied	\N	\N	\N	\N	135902	135902	303464
17472	23562	25	applied	\N	\N	\N	\N	135903	135903	303465
17472	23548	26	applied	\N	\N	\N	\N	135904	135904	303466
17472	23568	27	applied	\N	\N	\N	\N	135905	135905	303467
17472	23569	28	applied	\N	\N	\N	\N	135906	135906	303468
17474	23536	0	applied	\N	\N	\N	\N	135907	135907	303469
17474	23537	1	applied	\N	\N	\N	\N	135908	135908	303470
17474	23545	2	applied	\N	\N	\N	\N	135909	135909	303471
17474	23546	3	applied	\N	\N	\N	\N	135910	135910	303472
17474	23540	5	applied	\N	\N	\N	\N	135912	135912	303474
17474	23541	6	applied	\N	\N	\N	\N	135913	135913	303475
17474	23549	7	applied	\N	\N	\N	\N	135914	135914	303476
17474	23550	8	applied	\N	\N	\N	\N	135915	135915	303477
17474	23551	9	applied	\N	\N	\N	\N	135916	135916	303478
17474	23552	10	applied	\N	\N	\N	\N	135917	135917	303479
17474	23553	11	applied	\N	\N	\N	\N	135918	135918	303480
17474	23554	12	applied	\N	\N	\N	\N	135919	135919	303481
17474	23555	13	applied	\N	\N	\N	\N	135920	135920	303482
17474	23556	14	applied	\N	\N	\N	\N	135921	135921	303483
17474	23557	15	applied	\N	\N	\N	\N	135922	135922	303484
17474	23558	16	applied	\N	\N	\N	\N	135923	135923	303485
17474	23559	17	applied	\N	\N	\N	\N	135924	135924	303486
17474	23560	18	applied	\N	\N	\N	\N	135925	135925	303487
17474	23564	19	applied	\N	\N	\N	\N	135926	135926	303488
17474	23565	20	applied	\N	\N	\N	\N	135927	135927	303489
17443	23436	5	applied	\N	\N	\N	\N	135321	135321	302883
17451	23458	16	applied	\N	\N	\N	\N	135381	135381	302943
17451	23459	17	applied	\N	\N	\N	\N	135382	135382	302944
17451	22648	18	applied	\N	\N	\N	\N	135383	135383	302945
17451	22698	19	applied	\N	\N	\N	\N	135384	135384	302946
17451	22790	20	applied	\N	\N	\N	\N	135385	135385	302947
17451	22806	21	applied	\N	\N	1000000000	\N	135386	135386	302948
17451	22830	22	applied	\N	\N	1000000000	\N	135387	135387	302949
17451	22649	23	applied	\N	\N	\N	\N	135388	135388	302950
17451	22655	24	applied	\N	\N	\N	\N	135389	135389	302951
17451	22658	25	applied	\N	\N	\N	\N	135390	135390	302952
17451	22661	26	applied	\N	\N	\N	\N	135391	135391	302953
17451	22850	27	applied	\N	\N	\N	\N	135392	135392	302954
17451	22666	28	applied	\N	\N	\N	\N	135393	135393	302955
17451	22668	30	applied	\N	\N	\N	\N	135395	135395	302957
17451	22669	31	applied	\N	\N	\N	\N	135396	135396	302958
17451	22678	32	applied	\N	\N	\N	\N	135397	135397	302959
17451	22681	33	applied	\N	\N	\N	\N	135398	135398	302960
17451	22684	34	applied	\N	\N	\N	\N	135399	135399	302961
17451	22688	35	applied	\N	\N	\N	\N	135400	135400	302962
17451	22690	36	applied	\N	\N	\N	\N	135401	135401	302963
17451	22693	37	applied	\N	\N	\N	\N	135402	135402	302964
17451	22696	38	applied	\N	\N	\N	\N	135403	135403	302965
17451	22697	39	applied	\N	\N	\N	\N	135404	135404	302966
17451	22704	40	applied	\N	\N	\N	\N	135405	135405	302967
17451	22705	41	applied	\N	\N	\N	\N	135406	135406	302968
17451	22706	42	applied	\N	\N	\N	\N	135407	135407	302969
17451	22716	43	applied	\N	\N	\N	\N	135408	135408	302970
17451	22719	44	applied	\N	\N	\N	\N	135409	135409	302971
17451	23423	45	applied	\N	\N	\N	\N	135410	135410	302972
17451	22726	48	applied	\N	\N	\N	\N	135412	135412	302974
17451	22727	49	applied	\N	\N	\N	\N	135413	135413	302975
17451	22732	50	applied	\N	\N	\N	\N	135414	135414	302976
17451	22735	51	applied	\N	\N	\N	\N	135415	135415	302977
17451	22738	52	applied	\N	\N	\N	\N	135416	135416	302978
17451	22741	53	applied	\N	\N	\N	\N	135417	135417	302979
17451	22744	54	applied	\N	\N	\N	\N	135418	135418	302980
17451	22746	55	applied	\N	\N	\N	\N	135419	135419	302981
17451	22748	56	applied	\N	\N	\N	\N	135420	135420	302982
17451	22749	57	applied	\N	\N	\N	\N	135421	135421	302983
17451	22753	58	applied	\N	\N	\N	\N	135422	135422	302984
17451	22755	59	applied	\N	\N	\N	\N	135423	135423	302985
17451	22757	60	applied	\N	\N	\N	\N	135424	135424	302986
17451	23156	61	applied	\N	\N	\N	\N	135425	135425	302987
17451	22760	62	applied	\N	\N	\N	\N	135426	135426	302988
17451	22762	63	applied	\N	\N	\N	\N	135427	135427	302989
17451	22768	65	applied	\N	\N	\N	\N	135429	135429	302991
17451	22770	66	applied	\N	\N	\N	\N	135430	135430	302992
17451	22772	67	applied	\N	\N	\N	\N	135431	135431	302993
17451	22775	68	applied	\N	\N	\N	\N	135432	135432	302994
17451	22777	69	applied	\N	\N	\N	\N	135433	135433	302995
17451	22779	70	applied	\N	\N	\N	\N	135434	135434	302996
17451	22782	71	applied	\N	\N	\N	\N	135435	135435	302997
17451	22784	72	applied	\N	\N	\N	\N	135436	135436	302998
17451	22786	73	applied	\N	\N	\N	\N	135437	135437	302999
17451	22789	74	applied	\N	\N	\N	\N	135438	135438	303000
17451	22791	75	applied	\N	\N	\N	\N	135439	135439	303001
17451	22793	76	applied	\N	\N	\N	\N	135440	135440	303002
17451	22796	77	applied	\N	\N	\N	\N	135441	135441	303003
17451	22797	78	applied	\N	\N	\N	\N	135442	135442	303004
17451	22800	79	applied	\N	\N	\N	\N	135443	135443	303005
17451	22802	80	applied	\N	\N	\N	\N	135444	135444	303006
17451	22807	82	applied	\N	\N	\N	\N	135446	135446	303008
17451	22809	83	applied	\N	\N	\N	\N	135447	135447	303009
17451	22813	84	applied	\N	\N	\N	\N	135448	135448	303010
17451	22814	85	applied	\N	\N	\N	\N	135449	135449	303011
17451	22815	86	applied	\N	\N	\N	\N	135450	135450	303012
17451	22822	87	applied	\N	\N	\N	\N	135451	135451	303013
17451	22825	88	applied	\N	\N	\N	\N	135452	135452	303014
17451	22828	89	applied	\N	\N	\N	\N	135453	135453	303015
17451	22829	90	applied	\N	\N	\N	\N	135454	135454	303016
17451	22836	91	applied	\N	\N	\N	\N	135455	135455	303017
17451	22837	92	applied	\N	\N	\N	\N	135456	135456	303018
17451	22841	93	applied	\N	\N	\N	\N	135457	135457	303019
17451	22845	94	applied	\N	\N	\N	\N	135458	135458	303020
17451	22848	95	applied	\N	\N	\N	\N	135459	135459	303021
17451	22849	96	applied	\N	\N	\N	\N	135460	135460	303022
17451	22859	97	applied	\N	\N	\N	\N	135461	135461	303023
17451	22865	99	applied	\N	\N	\N	\N	135463	135463	303025
17451	22869	100	applied	\N	\N	\N	\N	135464	135464	303026
17451	22870	101	applied	\N	\N	\N	\N	135465	135465	303027
17451	22871	102	applied	\N	\N	\N	\N	135466	135466	303028
17451	22879	103	applied	\N	\N	\N	\N	135467	135467	303029
17451	22882	104	applied	\N	\N	\N	\N	135468	135468	303030
17451	22885	105	applied	\N	\N	\N	\N	135469	135469	303031
17451	22886	106	applied	\N	\N	\N	\N	135470	135470	303032
17451	22887	107	applied	\N	\N	\N	\N	135471	135471	303033
17451	22895	108	applied	\N	\N	\N	\N	135472	135472	303034
17451	22896	109	applied	\N	\N	\N	\N	135473	135473	303035
17451	22902	110	applied	\N	\N	\N	\N	135474	135474	303036
17451	22905	111	applied	\N	\N	\N	\N	135475	135475	303037
17451	22908	112	applied	\N	\N	\N	\N	135476	135476	303038
17451	22912	113	applied	\N	\N	\N	\N	135477	135477	303039
17451	22915	114	applied	\N	\N	\N	\N	135478	135478	303040
17451	22922	116	applied	\N	\N	\N	\N	135480	135480	303042
17451	22923	117	applied	\N	\N	\N	\N	135481	135481	303043
17451	22930	118	applied	\N	\N	\N	\N	135482	135482	303044
17451	22934	119	applied	\N	\N	\N	\N	135483	135483	303045
17451	22937	120	applied	\N	\N	\N	\N	135484	135484	303046
17451	22940	121	applied	\N	\N	\N	\N	135485	135485	303047
17451	22944	122	applied	\N	\N	\N	\N	135486	135486	303048
17451	22947	123	applied	\N	\N	\N	\N	135487	135487	303049
17451	22948	124	applied	\N	\N	\N	\N	135488	135488	303050
17451	22953	125	applied	\N	\N	\N	\N	135489	135489	303051
17474	23566	21	applied	\N	\N	\N	\N	135928	135928	303490
17474	23567	22	applied	\N	\N	\N	\N	135929	135929	303491
17474	23561	23	applied	\N	\N	\N	\N	135930	135930	303492
17474	23547	24	applied	\N	\N	\N	\N	135931	135931	303493
17474	23562	25	applied	\N	\N	\N	\N	135932	135932	303494
17474	23548	26	applied	\N	\N	\N	\N	135933	135933	303495
17451	23456	14	applied	\N	\N	\N	\N	135379	135379	302941
17451	23457	15	applied	\N	\N	\N	\N	135380	135380	302942
17454	23476	4	applied	\N	\N	\N	\N	135507	135507	303069
17454	23477	5	applied	\N	\N	\N	\N	135508	135508	303070
17454	23478	6	applied	\N	\N	\N	\N	135509	135509	303071
17456	23491	4	applied	\N	\N	\N	\N	135522	135522	303084
17456	23492	5	applied	\N	\N	\N	\N	135523	135523	303085
17456	23493	6	applied	\N	\N	\N	\N	135524	135524	303086
17456	23494	7	applied	\N	\N	\N	\N	135525	135525	303087
17456	23495	8	applied	\N	\N	\N	\N	135526	135526	303088
17456	23496	9	applied	\N	\N	\N	\N	135527	135527	303089
17456	23497	10	applied	\N	\N	\N	\N	135528	135528	303090
17456	23498	11	applied	\N	\N	\N	\N	135529	135529	303091
17456	23499	12	applied	\N	\N	\N	\N	135530	135530	303092
17456	23500	13	applied	\N	\N	\N	\N	135531	135531	303093
17456	23501	14	applied	\N	\N	\N	\N	135532	135532	303094
17456	23503	16	applied	\N	\N	\N	\N	135534	135534	303096
17456	23504	17	applied	\N	\N	\N	\N	135535	135535	303097
17456	23505	18	applied	\N	\N	\N	\N	135536	135536	303098
17461	23523	0	applied	\N	\N	\N	\N	135635	135635	303197
17461	23524	1	applied	\N	\N	\N	\N	135636	135636	303198
17461	23525	2	applied	\N	\N	\N	\N	135637	135637	303199
17461	23526	3	applied	\N	\N	\N	\N	135638	135638	303200
17461	23527	4	applied	\N	\N	\N	\N	135639	135639	303201
17461	23528	5	applied	\N	\N	\N	\N	135640	135640	303202
17461	23529	6	applied	\N	\N	\N	\N	135641	135641	303203
17461	23530	7	applied	\N	\N	\N	\N	135642	135642	303204
17461	23531	8	applied	\N	\N	\N	\N	135643	135643	303205
17466	23192	0	applied	\N	\N	\N	\N	135711	135711	303273
17466	23448	1	applied	\N	\N	1000000000	\N	135712	135712	303274
17466	23449	2	applied	\N	\N	\N	\N	135713	135713	303275
17466	23450	3	applied	\N	\N	\N	\N	135714	135714	303276
17466	23452	5	applied	\N	\N	\N	\N	135716	135716	303278
17466	23453	6	applied	\N	\N	\N	\N	135717	135717	303279
17466	23454	7	applied	\N	\N	\N	\N	135718	135718	303280
17466	23455	8	applied	\N	\N	\N	\N	135719	135719	303281
17466	23394	9	applied	\N	\N	\N	\N	135720	135720	303282
17466	23068	10	applied	\N	\N	\N	\N	135721	135721	303283
17466	23072	11	applied	\N	\N	\N	\N	135722	135722	303284
17466	23073	12	applied	\N	\N	\N	\N	135723	135723	303285
17466	23076	13	applied	\N	\N	\N	\N	135724	135724	303286
17466	23078	14	applied	\N	\N	\N	\N	135725	135725	303287
17466	23081	15	applied	\N	\N	\N	\N	135726	135726	303288
17466	23456	16	applied	\N	\N	\N	\N	135727	135727	303289
17466	23457	17	applied	\N	\N	\N	\N	135728	135728	303290
17466	23458	18	applied	\N	\N	\N	\N	135729	135729	303291
17466	23459	19	applied	\N	\N	\N	\N	135730	135730	303292
17466	23467	20	applied	\N	\N	\N	\N	135731	135731	303293
17466	23469	22	applied	\N	\N	\N	\N	135733	135733	303295
17466	23492	23	applied	\N	\N	\N	\N	135734	135734	303296
17466	23470	24	applied	\N	\N	\N	\N	135735	135735	303297
17466	23473	25	applied	\N	\N	\N	\N	135736	135736	303298
17466	23474	26	applied	\N	\N	\N	\N	135737	135737	303299
17466	23475	27	applied	\N	\N	\N	\N	135738	135738	303300
17466	23476	28	applied	\N	\N	\N	\N	135739	135739	303301
17466	23477	29	applied	\N	\N	\N	\N	135740	135740	303302
17466	23480	30	applied	\N	\N	\N	\N	135741	135741	303303
17466	23481	31	applied	\N	\N	\N	\N	135742	135742	303304
17466	23482	32	applied	\N	\N	\N	\N	135743	135743	303305
17466	23483	33	applied	\N	\N	\N	\N	135744	135744	303306
17466	23484	34	applied	\N	\N	\N	\N	135745	135745	303307
17466	23487	36	applied	\N	\N	\N	\N	135746	135746	303308
17466	23488	37	applied	\N	\N	\N	\N	135747	135747	303309
17466	23491	38	applied	\N	\N	\N	\N	135748	135748	303310
17466	23084	40	applied	\N	\N	\N	\N	135750	135750	303312
17466	23087	41	applied	\N	\N	\N	\N	135751	135751	303313
17466	23090	42	applied	\N	\N	\N	\N	135752	135752	303314
17466	23093	43	applied	\N	\N	\N	\N	135753	135753	303315
17466	23094	44	applied	\N	\N	\N	\N	135754	135754	303316
17466	23099	45	applied	\N	\N	\N	\N	135755	135755	303317
17466	23100	46	applied	\N	\N	\N	\N	135756	135756	303318
17466	23101	47	applied	\N	\N	\N	\N	135757	135757	303319
17466	23108	48	applied	\N	\N	\N	\N	135758	135758	303320
17466	23109	49	applied	\N	\N	\N	\N	135759	135759	303321
17466	23114	50	applied	\N	\N	\N	\N	135760	135760	303322
17466	23117	51	applied	\N	\N	\N	\N	135761	135761	303323
17466	23119	52	applied	\N	\N	\N	\N	135762	135762	303324
17466	23122	53	applied	\N	\N	\N	\N	135763	135763	303325
17466	23123	54	applied	\N	\N	\N	\N	135764	135764	303326
17466	23124	55	applied	\N	\N	\N	\N	135765	135765	303327
17466	23134	57	applied	\N	\N	\N	\N	135767	135767	303329
17466	23156	58	applied	\N	\N	\N	\N	135768	135768	303330
17466	23493	59	applied	\N	\N	\N	\N	135769	135769	303331
17466	23494	60	applied	\N	\N	\N	\N	135770	135770	303332
17466	23495	61	applied	\N	\N	\N	\N	135771	135771	303333
17466	23496	62	applied	\N	\N	\N	\N	135772	135772	303334
17466	23497	63	applied	\N	\N	\N	\N	135773	135773	303335
17466	23498	64	applied	\N	\N	\N	\N	135774	135774	303336
17466	23499	65	applied	\N	\N	\N	\N	135775	135775	303337
17466	23500	66	applied	\N	\N	\N	\N	135776	135776	303338
17466	23501	67	applied	\N	\N	\N	\N	135777	135777	303339
17466	23508	68	applied	\N	\N	\N	\N	135778	135778	303340
17466	23509	69	applied	\N	\N	\N	\N	135779	135779	303341
17466	23510	70	applied	\N	\N	\N	\N	135780	135780	303342
17466	23511	71	applied	\N	\N	\N	\N	135781	135781	303343
17466	23512	72	applied	\N	\N	\N	\N	135782	135782	303344
17466	23514	74	applied	\N	\N	\N	\N	135784	135784	303346
17466	23515	75	applied	\N	\N	\N	\N	135785	135785	303347
17466	23516	76	applied	\N	\N	\N	\N	135786	135786	303348
17466	23517	77	applied	\N	\N	\N	\N	135787	135787	303349
17466	23518	78	applied	\N	\N	\N	\N	135788	135788	303350
17466	23523	79	applied	\N	\N	\N	\N	135789	135789	303351
17466	23524	80	applied	\N	\N	\N	\N	135790	135790	303352
17466	23525	81	applied	\N	\N	\N	\N	135791	135791	303353
17466	23526	82	applied	\N	\N	\N	\N	135792	135792	303354
17466	23527	83	applied	\N	\N	\N	\N	135793	135793	303355
17466	23528	84	applied	\N	\N	\N	\N	135794	135794	303356
17466	23532	85	applied	\N	\N	\N	\N	135795	135795	303357
17466	23533	86	applied	\N	\N	\N	\N	135796	135796	303358
17466	23534	87	applied	\N	\N	\N	\N	135797	135797	303359
17466	23535	88	applied	\N	\N	\N	\N	135798	135798	303360
17466	23536	89	applied	\N	\N	\N	\N	135799	135799	303361
17454	23475	3	applied	\N	\N	\N	\N	135506	135506	303068
17457	23491	4	applied	\N	\N	\N	\N	135541	135541	303103
17457	23506	5	applied	\N	\N	\N	\N	135542	135542	303104
17457	23507	6	applied	\N	\N	\N	\N	135543	135543	303105
17457	23492	7	applied	\N	\N	\N	\N	135544	135544	303106
17457	23493	8	applied	\N	\N	\N	\N	135545	135545	303107
17457	23494	9	applied	\N	\N	\N	\N	135546	135546	303108
17457	23495	10	applied	\N	\N	\N	\N	135547	135547	303109
17457	23496	11	applied	\N	\N	\N	\N	135548	135548	303110
17457	23497	12	applied	\N	\N	\N	\N	135549	135549	303111
17457	23498	13	applied	\N	\N	\N	\N	135550	135550	303112
17457	23499	14	applied	\N	\N	\N	\N	135551	135551	303113
17457	23500	15	applied	\N	\N	\N	\N	135552	135552	303114
17457	23501	16	applied	\N	\N	\N	\N	135553	135553	303115
17457	23508	17	applied	\N	\N	\N	\N	135554	135554	303116
17457	23509	18	applied	\N	\N	\N	\N	135555	135555	303117
17457	23510	19	applied	\N	\N	\N	\N	135556	135556	303118
17457	23512	21	applied	\N	\N	\N	\N	135558	135558	303120
17457	23513	22	applied	\N	\N	\N	\N	135559	135559	303121
17457	23514	23	applied	\N	\N	\N	\N	135560	135560	303122
17457	23515	24	applied	\N	\N	\N	\N	135561	135561	303123
17457	23516	25	applied	\N	\N	\N	\N	135562	135562	303124
17457	23517	26	applied	\N	\N	\N	\N	135563	135563	303125
17457	23518	27	applied	\N	\N	\N	\N	135564	135564	303126
17457	23502	28	applied	\N	\N	\N	\N	135565	135565	303127
17457	23503	29	applied	\N	\N	\N	\N	135566	135566	303128
17457	23519	30	applied	\N	\N	\N	\N	135567	135567	303129
17457	23504	31	applied	\N	\N	\N	\N	135568	135568	303130
17457	23505	32	applied	\N	\N	\N	\N	135569	135569	303131
17457	23520	33	applied	\N	\N	\N	\N	135570	135570	303132
17457	23521	34	applied	\N	\N	\N	\N	135571	135571	303133
17457	23522	35	applied	\N	\N	\N	\N	135572	135572	303134
17459	23506	0	applied	\N	\N	\N	\N	135609	135609	303171
17459	23508	2	applied	\N	\N	\N	\N	135611	135611	303173
17459	23509	3	applied	\N	\N	\N	\N	135612	135612	303174
17459	23510	4	applied	\N	\N	\N	\N	135613	135613	303175
17459	23511	5	applied	\N	\N	\N	\N	135614	135614	303176
17459	23512	6	applied	\N	\N	\N	\N	135615	135615	303177
17459	23513	7	applied	\N	\N	\N	\N	135616	135616	303178
17459	23514	8	applied	\N	\N	\N	\N	135617	135617	303179
17459	23515	9	applied	\N	\N	\N	\N	135618	135618	303180
17459	23516	10	applied	\N	\N	\N	\N	135619	135619	303181
17459	23517	11	applied	\N	\N	\N	\N	135620	135620	303182
17459	23518	12	applied	\N	\N	\N	\N	135621	135621	303183
17459	23519	13	applied	\N	\N	\N	\N	135622	135622	303184
17459	23520	14	applied	\N	\N	\N	\N	135623	135623	303185
17459	23521	15	applied	\N	\N	\N	\N	135624	135624	303186
17459	23522	16	applied	\N	\N	\N	\N	135625	135625	303187
17462	23506	0	applied	\N	\N	\N	\N	135644	135644	303206
17462	23508	2	applied	\N	\N	\N	\N	135646	135646	303208
17462	23509	3	applied	\N	\N	\N	\N	135647	135647	303209
17462	23510	4	applied	\N	\N	\N	\N	135648	135648	303210
17462	23511	5	applied	\N	\N	\N	\N	135649	135649	303211
17462	23512	6	applied	\N	\N	\N	\N	135650	135650	303212
17462	23513	7	applied	\N	\N	\N	\N	135651	135651	303213
17462	23514	8	applied	\N	\N	\N	\N	135652	135652	303214
17462	23515	9	applied	\N	\N	\N	\N	135653	135653	303215
17462	23516	10	applied	\N	\N	\N	\N	135654	135654	303216
17462	23517	11	applied	\N	\N	\N	\N	135655	135655	303217
17462	23518	12	applied	\N	\N	\N	\N	135656	135656	303218
17462	23523	13	applied	\N	\N	\N	\N	135657	135657	303219
17462	23524	14	applied	\N	\N	\N	\N	135658	135658	303220
17462	23525	15	applied	\N	\N	\N	\N	135659	135659	303221
17462	23526	16	applied	\N	\N	\N	\N	135660	135660	303222
17462	23527	17	applied	\N	\N	\N	\N	135661	135661	303223
17462	23520	19	applied	\N	\N	\N	\N	135663	135663	303225
17462	23530	20	applied	\N	\N	\N	\N	135664	135664	303226
17462	23521	21	applied	\N	\N	\N	\N	135665	135665	303227
17462	23522	22	applied	\N	\N	\N	\N	135666	135666	303228
17462	23531	23	applied	\N	\N	\N	\N	135667	135667	303229
17466	23537	90	applied	\N	\N	\N	\N	135800	135800	303362
17466	23540	91	applied	\N	\N	\N	\N	135801	135801	303363
17466	23541	92	applied	\N	\N	\N	\N	135802	135802	303364
17466	23135	93	applied	\N	\N	\N	\N	135803	135803	303365
17466	23136	94	applied	\N	\N	\N	\N	135804	135804	303366
17466	23137	95	applied	\N	\N	\N	\N	135805	135805	303367
17466	23146	96	applied	\N	\N	\N	\N	135806	135806	303368
17469	23532	0	applied	\N	\N	\N	\N	135874	135874	303436
17469	23533	1	applied	\N	\N	\N	\N	135875	135875	303437
17469	23534	3	applied	\N	\N	\N	\N	135876	135876	303438
17469	23535	4	applied	\N	\N	\N	\N	135877	135877	303439
17476	23574	1	applied	\N	\N	\N	\N	135940	135940	303502
17476	23575	2	applied	\N	\N	\N	\N	135941	135941	303503
17479	23585	0	applied	\N	\N	\N	\N	135959	135959	303521
17479	23586	1	applied	\N	\N	\N	\N	135960	135960	303522
17479	23587	2	applied	\N	\N	\N	\N	135961	135961	303523
17479	23588	3	applied	\N	\N	\N	\N	135962	135962	303524
17479	23589	4	applied	\N	\N	\N	\N	135963	135963	303525
17479	23590	5	applied	\N	\N	\N	\N	135964	135964	303526
17479	23591	6	applied	\N	\N	\N	\N	135965	135965	303527
17479	23592	7	applied	\N	\N	\N	\N	135966	135966	303528
17481	23593	0	applied	\N	\N	\N	\N	135975	135975	303537
17481	23594	1	applied	\N	\N	\N	\N	135976	135976	303538
17481	23595	2	applied	\N	\N	\N	\N	135977	135977	303539
17481	23596	3	applied	\N	\N	\N	\N	135978	135978	303540
17481	23597	4	applied	\N	\N	\N	\N	135979	135979	303541
17481	23598	5	applied	\N	\N	\N	\N	135980	135980	303542
17481	23600	7	applied	\N	\N	\N	\N	135982	135982	303544
17487	23601	0	applied	\N	\N	\N	\N	136020	136020	303582
17487	23602	1	applied	\N	\N	\N	\N	136021	136021	303583
17487	23603	2	applied	\N	\N	\N	\N	136022	136022	303584
17487	23604	3	applied	\N	\N	\N	\N	136023	136023	303585
17487	23605	4	applied	\N	\N	\N	\N	136024	136024	303586
17487	23599	5	applied	\N	\N	\N	\N	136025	136025	303587
17487	23606	6	applied	\N	\N	\N	\N	136026	136026	303588
17487	23607	7	applied	\N	\N	\N	\N	136027	136027	303589
17490	23617	0	applied	\N	\N	\N	\N	136045	136045	303607
17490	23618	1	applied	\N	\N	\N	\N	136046	136046	303608
17490	23619	2	applied	\N	\N	\N	\N	136047	136047	303609
17490	23620	3	applied	\N	\N	\N	\N	136048	136048	303610
17490	23621	4	applied	\N	\N	\N	\N	136049	136049	303611
17457	23488	1	applied	\N	\N	\N	\N	135538	135538	303100
17457	23489	2	applied	\N	\N	\N	\N	135539	135539	303101
17477	23578	2	applied	\N	\N	\N	\N	135944	135944	303506
17477	23579	3	applied	\N	\N	\N	\N	135945	135945	303507
17477	23580	4	applied	\N	\N	\N	\N	135946	135946	303508
17477	23581	5	applied	\N	\N	\N	\N	135947	135947	303509
17477	23582	6	applied	\N	\N	\N	\N	135948	135948	303510
17477	23583	7	applied	\N	\N	\N	\N	135949	135949	303511
17477	23584	8	applied	\N	\N	\N	\N	135950	135950	303512
17482	23593	0	applied	\N	\N	\N	\N	135983	135983	303545
17482	23594	1	applied	\N	\N	\N	\N	135984	135984	303546
17482	23595	2	applied	\N	\N	\N	\N	135985	135985	303547
17482	23596	3	applied	\N	\N	\N	\N	135986	135986	303548
17482	23597	4	applied	\N	\N	\N	\N	135987	135987	303549
17482	23598	5	applied	\N	\N	\N	\N	135988	135988	303550
17482	23600	6	applied	\N	\N	\N	\N	135989	135989	303551
17484	23601	0	applied	\N	\N	\N	\N	135998	135998	303560
17484	23602	1	applied	\N	\N	\N	\N	135999	135999	303561
17484	23604	3	applied	\N	\N	\N	\N	136001	136001	303563
17484	23605	4	applied	\N	\N	\N	\N	136002	136002	303564
17484	23599	5	applied	\N	\N	\N	\N	136003	136003	303565
17484	23606	6	applied	\N	\N	\N	\N	136004	136004	303566
17484	23607	7	applied	\N	\N	\N	\N	136005	136005	303567
17490	23622	5	applied	\N	\N	\N	\N	136050	136050	303612
17490	23623	6	applied	\N	\N	\N	\N	136051	136051	303613
17490	23624	7	applied	\N	\N	\N	\N	136052	136052	303614
17491	23617	0	applied	\N	\N	\N	\N	136053	136053	303615
17491	23618	1	applied	\N	\N	\N	\N	136054	136054	303616
17491	23619	2	applied	\N	\N	\N	\N	136055	136055	303617
17491	23620	3	applied	\N	\N	\N	\N	136056	136056	303618
17491	23621	4	applied	\N	\N	\N	\N	136057	136057	303619
17491	23622	5	applied	\N	\N	\N	\N	136058	136058	303620
17491	23623	6	applied	\N	\N	\N	\N	136059	136059	303621
17491	23624	7	applied	\N	\N	\N	\N	136060	136060	303622
17493	23626	1	applied	\N	\N	\N	\N	136070	136070	303632
17495	23627	0	applied	\N	\N	\N	\N	136073	136073	303635
17495	23628	1	applied	\N	\N	\N	\N	136074	136074	303636
17497	23631	0	applied	\N	\N	\N	\N	136077	136077	303639
17497	23632	1	applied	\N	\N	\N	\N	136078	136078	303640
17498	23633	0	applied	\N	\N	\N	\N	136079	136079	303641
17498	23634	1	applied	\N	\N	\N	\N	136080	136080	303642
17502	23641	0	applied	\N	\N	\N	\N	136091	136091	303653
17502	23642	1	applied	\N	\N	\N	\N	136092	136092	303654
17506	23647	0	applied	\N	\N	\N	\N	136109	136109	303671
17506	23648	1	applied	\N	\N	\N	\N	136110	136110	303672
17506	23649	2	applied	\N	\N	\N	\N	136111	136111	303673
17506	23650	3	applied	\N	\N	\N	\N	136112	136112	303674
17506	23651	4	applied	\N	\N	\N	\N	136113	136113	303675
17506	23652	5	applied	\N	\N	\N	\N	136114	136114	303676
17508	23655	0	applied	\N	\N	\N	\N	136118	136118	303680
17511	23656	1	applied	\N	\N	\N	\N	136134	136134	303696
17511	23659	2	applied	\N	\N	\N	\N	136135	136135	303697
17511	23660	3	applied	\N	\N	\N	\N	136136	136136	303698
17511	23661	4	applied	\N	\N	\N	\N	136137	136137	303699
17511	23654	5	applied	\N	\N	\N	\N	136138	136138	303700
17511	23657	6	applied	\N	\N	\N	\N	136139	136139	303701
17511	23664	7	applied	\N	\N	\N	\N	136140	136140	303702
17511	23665	8	applied	\N	\N	\N	\N	136141	136141	303703
17511	23658	9	applied	\N	\N	\N	\N	136142	136142	303704
17511	23662	10	applied	\N	\N	\N	\N	136143	136143	303705
17511	23663	11	applied	\N	\N	\N	\N	136144	136144	303706
17511	23666	12	applied	\N	\N	\N	\N	136145	136145	303707
17511	23667	13	applied	\N	\N	\N	\N	136146	136146	303708
17518	23675	0	applied	\N	\N	\N	\N	136169	136169	303731
17518	23676	1	applied	\N	\N	\N	\N	136170	136170	303732
17518	23677	2	applied	\N	\N	\N	\N	136171	136171	303733
17525	23683	1	applied	\N	\N	\N	\N	136186	136186	303748
17525	23684	2	applied	\N	\N	\N	\N	136187	136187	303749
17525	23685	3	applied	\N	\N	\N	\N	136188	136188	303750
17525	23686	4	applied	\N	\N	\N	\N	136189	136189	303751
17525	23687	5	applied	\N	\N	\N	\N	136190	136190	303752
17525	23688	6	applied	\N	\N	\N	\N	136191	136191	303753
17525	23689	7	applied	\N	\N	\N	\N	136192	136192	303754
17529	23702	0	applied	\N	\N	\N	\N	136210	136210	303772
17529	23703	1	applied	\N	\N	\N	\N	136211	136211	303773
17529	23704	2	applied	\N	\N	\N	\N	136212	136212	303774
17529	23705	3	applied	\N	\N	\N	\N	136213	136213	303775
17529	23706	4	applied	\N	\N	\N	\N	136214	136214	303776
17533	23713	0	applied	\N	\N	\N	\N	136226	136226	303788
17533	23714	1	applied	\N	\N	\N	\N	136227	136227	303789
17533	23715	2	applied	\N	\N	\N	\N	136228	136228	303790
17534	23716	0	applied	\N	\N	\N	\N	136229	136229	303791
17534	23718	2	applied	\N	\N	\N	\N	136231	136231	303793
17534	23719	3	applied	\N	\N	\N	\N	136232	136232	303794
17534	23720	4	applied	\N	\N	\N	\N	136233	136233	303795
17534	23721	5	applied	\N	\N	\N	\N	136234	136234	303796
17534	23722	6	applied	\N	\N	\N	\N	136235	136235	303797
17534	23723	8	applied	\N	\N	\N	\N	136236	136236	303798
17534	23724	9	applied	\N	\N	\N	\N	136237	136237	303799
17534	23725	10	applied	\N	\N	\N	\N	136238	136238	303800
17534	23726	11	applied	\N	\N	\N	\N	136239	136239	303801
17534	23727	12	applied	\N	\N	\N	\N	136240	136240	303802
17537	23728	0	applied	\N	\N	\N	\N	136256	136256	303818
17537	23729	1	applied	\N	\N	\N	\N	136257	136257	303819
17537	23730	2	applied	\N	\N	\N	\N	136258	136258	303820
17541	23734	0	applied	\N	\N	\N	\N	136268	136268	303830
17541	23735	1	applied	\N	\N	\N	\N	136269	136269	303831
17541	23736	2	applied	\N	\N	\N	\N	136270	136270	303832
17541	23738	4	applied	\N	\N	\N	\N	136272	136272	303834
17544	23734	0	applied	\N	\N	\N	\N	136284	136284	303846
17544	23735	1	applied	\N	\N	\N	\N	136285	136285	303847
17544	23736	2	applied	\N	\N	\N	\N	136286	136286	303848
17544	23737	3	applied	\N	\N	\N	\N	136287	136287	303849
17544	23738	4	applied	\N	\N	\N	\N	136288	136288	303850
17553	23748	0	applied	\N	\N	\N	\N	136312	136312	303874
17553	23749	1	applied	\N	\N	\N	\N	136313	136313	303875
17553	23750	2	applied	\N	\N	\N	\N	136314	136314	303876
17555	23751	0	applied	\N	\N	\N	\N	136318	136318	303880
17555	23752	1	applied	\N	\N	\N	\N	136319	136319	303881
17555	23753	2	applied	\N	\N	\N	\N	136320	136320	303882
17563	23757	0	applied	\N	\N	\N	\N	136342	136342	303904
17563	23758	1	applied	\N	\N	\N	\N	136343	136343	303905
17464	23544	13	applied	\N	\N	\N	\N	135705	135705	303267
17477	23576	0	applied	\N	\N	\N	\N	135942	135942	303504
17466	23160	101	applied	\N	\N	\N	\N	135811	135811	303373
17466	23165	102	applied	\N	\N	\N	\N	135812	135812	303374
17466	23168	103	applied	\N	\N	\N	\N	135813	135813	303375
17466	23170	104	applied	\N	\N	\N	\N	135814	135814	303376
17466	23174	105	applied	\N	\N	\N	\N	135815	135815	303377
17466	23176	106	applied	\N	\N	\N	\N	135816	135816	303378
17466	23179	107	applied	\N	\N	\N	\N	135817	135817	303379
17466	23181	108	applied	\N	\N	\N	\N	135818	135818	303380
17466	23184	109	applied	\N	\N	\N	\N	135819	135819	303381
17466	23187	110	applied	\N	\N	\N	\N	135820	135820	303382
17466	23189	111	applied	\N	\N	\N	\N	135821	135821	303383
17466	23193	112	applied	\N	\N	\N	\N	135822	135822	303384
17466	23194	113	applied	\N	\N	\N	\N	135823	135823	303385
17466	23199	114	applied	\N	\N	\N	\N	135824	135824	303386
17466	23209	115	applied	\N	\N	\N	\N	135825	135825	303387
17466	23212	116	applied	\N	\N	\N	\N	135826	135826	303388
17466	23219	118	applied	\N	\N	\N	\N	135828	135828	303390
17466	23220	119	applied	\N	\N	\N	\N	135829	135829	303391
17466	23226	120	applied	\N	\N	\N	\N	135830	135830	303392
17466	23229	121	applied	\N	\N	\N	\N	135831	135831	303393
17466	23232	122	applied	\N	\N	\N	\N	135832	135832	303394
17466	23235	123	applied	\N	\N	\N	\N	135833	135833	303395
17466	23238	124	applied	\N	\N	\N	\N	135834	135834	303396
17466	23241	125	applied	\N	\N	\N	\N	135835	135835	303397
17468	23532	0	applied	\N	\N	\N	\N	135848	135848	303410
17468	23533	1	applied	\N	\N	\N	\N	135849	135849	303411
17468	23534	3	applied	\N	\N	\N	\N	135850	135850	303412
17468	23535	4	applied	\N	\N	\N	\N	135851	135851	303413
17468	23536	5	applied	\N	\N	\N	\N	135852	135852	303414
17468	23537	6	applied	\N	\N	\N	\N	135853	135853	303415
17468	23545	7	applied	\N	\N	\N	\N	135854	135854	303416
17468	23546	8	applied	\N	\N	\N	\N	135855	135855	303417
17468	23541	10	applied	\N	\N	\N	\N	135857	135857	303419
17468	23549	11	applied	\N	\N	\N	\N	135858	135858	303420
17468	23550	12	applied	\N	\N	\N	\N	135859	135859	303421
17468	23551	13	applied	\N	\N	\N	\N	135860	135860	303422
17468	23552	14	applied	\N	\N	\N	\N	135861	135861	303423
17468	23553	15	applied	\N	\N	\N	\N	135862	135862	303424
17468	23554	16	applied	\N	\N	\N	\N	135863	135863	303425
17468	23555	17	applied	\N	\N	\N	\N	135864	135864	303426
17468	23556	18	applied	\N	\N	\N	\N	135865	135865	303427
17468	23557	19	applied	\N	\N	\N	\N	135866	135866	303428
17468	23558	20	applied	\N	\N	\N	\N	135867	135867	303429
17468	23559	21	applied	\N	\N	\N	\N	135868	135868	303430
17468	23560	22	applied	\N	\N	\N	\N	135869	135869	303431
17468	23561	23	applied	\N	\N	\N	\N	135870	135870	303432
17468	23547	24	applied	\N	\N	\N	\N	135871	135871	303433
17468	23562	25	applied	\N	\N	\N	\N	135872	135872	303434
17475	23570	0	applied	\N	\N	\N	\N	135936	135936	303498
17475	23571	1	applied	\N	\N	\N	\N	135937	135937	303499
17475	23572	2	applied	\N	\N	\N	\N	135938	135938	303500
17478	23585	0	applied	\N	\N	\N	\N	135951	135951	303513
17478	23586	1	applied	\N	\N	\N	\N	135952	135952	303514
17478	23587	2	applied	\N	\N	\N	\N	135953	135953	303515
17478	23588	3	applied	\N	\N	\N	\N	135954	135954	303516
17478	23589	4	applied	\N	\N	\N	\N	135955	135955	303517
17478	23590	5	applied	\N	\N	\N	\N	135956	135956	303518
17478	23591	6	applied	\N	\N	\N	\N	135957	135957	303519
17478	23592	7	applied	\N	\N	\N	\N	135958	135958	303520
17486	23601	0	applied	\N	\N	\N	\N	136012	136012	303574
17486	23602	1	applied	\N	\N	\N	\N	136013	136013	303575
17486	23603	2	applied	\N	\N	\N	\N	136014	136014	303576
17486	23604	3	applied	\N	\N	\N	\N	136015	136015	303577
17486	23605	4	applied	\N	\N	\N	\N	136016	136016	303578
17486	23606	6	applied	\N	\N	\N	\N	136018	136018	303580
17486	23607	7	applied	\N	\N	\N	\N	136019	136019	303581
17488	23601	0	applied	\N	\N	\N	\N	136028	136028	303590
17488	23602	1	applied	\N	\N	\N	\N	136029	136029	303591
17488	23603	2	applied	\N	\N	\N	\N	136030	136030	303592
17488	23604	3	applied	\N	\N	\N	\N	136031	136031	303593
17488	23605	4	applied	\N	\N	\N	\N	136032	136032	303594
17488	23599	5	applied	\N	\N	\N	\N	136033	136033	303595
17488	23606	6	applied	\N	\N	\N	\N	136034	136034	303596
17488	23607	7	applied	\N	\N	\N	\N	136035	136035	303597
17492	23617	0	applied	\N	\N	\N	\N	136061	136061	303623
17492	23618	1	applied	\N	\N	\N	\N	136062	136062	303624
17492	23619	2	applied	\N	\N	\N	\N	136063	136063	303625
17492	23620	3	applied	\N	\N	\N	\N	136064	136064	303626
17492	23621	4	applied	\N	\N	\N	\N	136065	136065	303627
17492	23622	5	applied	\N	\N	\N	\N	136066	136066	303628
17492	23624	7	applied	\N	\N	\N	\N	136068	136068	303630
17494	23627	0	applied	\N	\N	\N	\N	136071	136071	303633
17494	23628	1	applied	\N	\N	\N	\N	136072	136072	303634
17500	23633	0	applied	\N	\N	\N	\N	136083	136083	303645
17500	23634	1	applied	\N	\N	\N	\N	136084	136084	303646
17501	23635	0	applied	\N	\N	\N	\N	136085	136085	303647
17501	23636	2	applied	\N	\N	\N	\N	136086	136086	303648
17501	23637	3	applied	\N	\N	\N	\N	136087	136087	303649
17501	23638	4	applied	\N	\N	\N	\N	136088	136088	303650
17501	23639	5	applied	\N	\N	\N	\N	136089	136089	303651
17501	23640	6	applied	\N	\N	\N	\N	136090	136090	303652
17504	23647	0	applied	\N	\N	\N	\N	136097	136097	303659
17504	23648	1	applied	\N	\N	\N	\N	136098	136098	303660
17504	23649	2	applied	\N	\N	\N	\N	136099	136099	303661
17504	23650	3	applied	\N	\N	\N	\N	136100	136100	303662
17504	23651	4	applied	\N	\N	\N	\N	136101	136101	303663
17514	23670	0	applied	\N	\N	\N	\N	136158	136158	303720
17514	23671	1	applied	\N	\N	\N	\N	136159	136159	303721
17514	23672	2	applied	\N	\N	\N	\N	136160	136160	303722
17516	23673	0	applied	\N	\N	\N	\N	136164	136164	303726
17516	23674	1	applied	\N	\N	\N	\N	136165	136165	303727
17521	23678	0	applied	\N	\N	\N	\N	136177	136177	303739
17521	23679	1	applied	\N	\N	\N	\N	136178	136178	303740
17563	23759	2	applied	\N	\N	\N	\N	136344	136344	303906
17569	23766	0	applied	\N	\N	\N	\N	136363	136363	303925
17569	23767	1	applied	\N	\N	\N	\N	136364	136364	303926
17569	23768	2	applied	\N	\N	\N	\N	136365	136365	303927
17573	23734	0	applied	\N	\N	\N	\N	136381	136381	303943
17573	23735	1	applied	\N	\N	\N	\N	136382	136382	303944
17573	23740	2	applied	\N	\N	\N	\N	136383	136383	303945
17466	23150	98	applied	\N	\N	\N	\N	135808	135808	303370
17466	23155	99	applied	\N	\N	\N	\N	135809	135809	303371
17480	23588	3	applied	\N	\N	\N	\N	135970	135970	303532
17480	23589	4	applied	\N	\N	\N	\N	135971	135971	303533
17480	23590	5	applied	\N	\N	\N	\N	135972	135972	303534
17480	23591	6	applied	\N	\N	\N	\N	135973	135973	303535
17480	23592	7	applied	\N	\N	\N	\N	135974	135974	303536
17483	23593	0	applied	\N	\N	\N	\N	135990	135990	303552
17483	23594	1	applied	\N	\N	\N	\N	135991	135991	303553
17483	23595	2	applied	\N	\N	\N	\N	135992	135992	303554
17483	23596	3	applied	\N	\N	\N	\N	135993	135993	303555
17483	23597	4	applied	\N	\N	\N	\N	135994	135994	303556
17483	23598	5	applied	\N	\N	\N	\N	135995	135995	303557
17483	23599	6	applied	\N	\N	\N	\N	135996	135996	303558
17483	23600	7	applied	\N	\N	\N	\N	135997	135997	303559
17485	23601	0	applied	\N	\N	\N	\N	136006	136006	303568
17485	23602	1	applied	\N	\N	\N	\N	136007	136007	303569
17485	23603	2	applied	\N	\N	\N	\N	136008	136008	303570
17485	23605	4	applied	\N	\N	\N	\N	136010	136010	303572
17485	23607	5	applied	\N	\N	\N	\N	136011	136011	303573
17489	23608	0	applied	\N	\N	\N	\N	136036	136036	303598
17489	23609	1	applied	\N	\N	\N	\N	136037	136037	303599
17489	23610	2	applied	\N	\N	\N	\N	136038	136038	303600
17489	23611	3	applied	\N	\N	\N	\N	136039	136039	303601
17489	23612	4	applied	\N	\N	\N	\N	136040	136040	303602
17489	23613	5	applied	\N	\N	\N	\N	136041	136041	303603
17489	23614	6	applied	\N	\N	\N	\N	136042	136042	303604
17489	23615	7	applied	\N	\N	\N	\N	136043	136043	303605
17489	23616	8	applied	\N	\N	\N	\N	136044	136044	303606
17496	23629	0	applied	\N	\N	\N	\N	136075	136075	303637
17496	23630	1	applied	\N	\N	\N	\N	136076	136076	303638
17499	23633	0	applied	\N	\N	\N	\N	136081	136081	303643
17499	23634	1	applied	\N	\N	\N	\N	136082	136082	303644
17503	23644	0	applied	\N	\N	\N	\N	136094	136094	303656
17503	23646	2	applied	\N	\N	\N	\N	136096	136096	303658
17512	23659	0	applied	\N	\N	\N	\N	136147	136147	303709
17512	23660	1	applied	\N	\N	\N	\N	136148	136148	303710
17512	23661	2	applied	\N	\N	\N	\N	136149	136149	303711
17512	23662	3	applied	\N	\N	\N	\N	136150	136150	303712
17512	23663	4	applied	\N	\N	\N	\N	136151	136151	303713
17512	23664	5	applied	\N	\N	\N	\N	136152	136152	303714
17512	23665	6	applied	\N	\N	\N	\N	136153	136153	303715
17512	23666	7	applied	\N	\N	\N	\N	136154	136154	303716
17512	23667	8	applied	\N	\N	\N	\N	136155	136155	303717
17513	23668	0	applied	\N	\N	\N	\N	136156	136156	303718
17513	23669	1	applied	\N	\N	\N	\N	136157	136157	303719
17519	23675	0	applied	\N	\N	\N	\N	136172	136172	303734
17519	23676	1	applied	\N	\N	\N	\N	136173	136173	303735
17519	23677	2	applied	\N	\N	\N	\N	136174	136174	303736
17520	23678	0	applied	\N	\N	\N	\N	136175	136175	303737
17523	23680	0	applied	\N	\N	\N	\N	136181	136181	303743
17523	23681	1	applied	\N	\N	\N	\N	136182	136182	303744
17524	23680	0	applied	\N	\N	\N	\N	136183	136183	303745
17524	23681	1	applied	\N	\N	\N	\N	136184	136184	303746
17526	23690	0	applied	\N	\N	\N	\N	136193	136193	303755
17526	23691	1	applied	\N	\N	\N	\N	136194	136194	303756
17526	23692	2	applied	\N	\N	\N	\N	136195	136195	303757
17526	23693	3	applied	\N	\N	\N	\N	136196	136196	303758
17526	23694	4	applied	\N	\N	\N	\N	136197	136197	303759
17526	23695	5	applied	\N	\N	\N	\N	136198	136198	303760
17526	23696	6	applied	\N	\N	\N	\N	136199	136199	303761
17526	23697	7	applied	\N	\N	\N	\N	136200	136200	303762
17526	23698	8	applied	\N	\N	\N	\N	136201	136201	303763
17527	23699	0	applied	\N	\N	\N	\N	136202	136202	303764
17527	23700	1	applied	\N	\N	\N	\N	136203	136203	303765
17527	23701	2	applied	\N	\N	\N	\N	136204	136204	303766
17530	23703	1	applied	\N	\N	\N	\N	136216	136216	303778
17530	23704	2	applied	\N	\N	\N	\N	136217	136217	303779
17530	23705	3	applied	\N	\N	\N	\N	136218	136218	303780
17530	23706	4	applied	\N	\N	\N	\N	136219	136219	303781
17531	23707	0	applied	\N	\N	\N	\N	136220	136220	303782
17531	23708	1	applied	\N	\N	\N	\N	136221	136221	303783
17531	23709	2	applied	\N	\N	\N	\N	136222	136222	303784
17532	23710	0	applied	\N	\N	\N	\N	136223	136223	303785
17532	23711	1	applied	\N	\N	\N	\N	136224	136224	303786
17535	23716	0	applied	\N	\N	\N	\N	136241	136241	303803
17535	23717	1	applied	\N	\N	\N	\N	136242	136242	303804
17535	23718	2	applied	\N	\N	\N	\N	136243	136243	303805
17535	23719	3	applied	\N	\N	\N	\N	136244	136244	303806
17535	23720	4	applied	\N	\N	\N	\N	136245	136245	303807
17535	23721	5	applied	\N	\N	\N	\N	136246	136246	303808
17535	23722	6	applied	\N	\N	\N	\N	136247	136247	303809
17535	23724	9	applied	\N	\N	\N	\N	136249	136249	303811
17535	23725	10	applied	\N	\N	\N	\N	136250	136250	303812
17535	23726	11	applied	\N	\N	\N	\N	136251	136251	303813
17535	23727	12	applied	\N	\N	\N	\N	136252	136252	303814
17539	23731	0	applied	\N	\N	\N	\N	136262	136262	303824
17539	23732	1	applied	\N	\N	\N	\N	136263	136263	303825
17539	23733	2	applied	\N	\N	\N	\N	136264	136264	303826
17542	23734	0	applied	\N	\N	\N	\N	136273	136273	303835
17542	23735	1	applied	\N	\N	\N	\N	136274	136274	303836
17542	23736	2	applied	\N	\N	\N	\N	136275	136275	303837
17542	23737	3	applied	\N	\N	\N	\N	136276	136276	303838
17542	23738	4	applied	\N	\N	\N	\N	136277	136277	303839
17542	23739	5	applied	\N	\N	\N	\N	136278	136278	303840
17546	23742	0	applied	\N	\N	\N	\N	136291	136291	303853
17546	23743	1	applied	\N	\N	\N	\N	136292	136292	303854
17546	23744	2	applied	\N	\N	\N	\N	136293	136293	303855
17556	23752	1	applied	\N	\N	\N	\N	136322	136322	303884
17556	23753	2	applied	\N	\N	\N	\N	136323	136323	303885
17558	23751	0	applied	\N	\N	\N	\N	136327	136327	303889
17558	23752	1	applied	\N	\N	\N	\N	136328	136328	303890
17558	23753	2	applied	\N	\N	\N	\N	136329	136329	303891
17559	23754	0	applied	\N	\N	\N	\N	136330	136330	303892
17559	23755	1	applied	\N	\N	\N	\N	136331	136331	303893
17559	23756	2	applied	\N	\N	\N	\N	136332	136332	303894
17564	23760	0	applied	\N	\N	\N	\N	136345	136345	303907
17564	23761	1	applied	\N	\N	\N	\N	136346	136346	303908
17564	23762	2	applied	\N	\N	\N	\N	136347	136347	303909
17564	23763	3	applied	\N	\N	\N	\N	136348	136348	303910
17564	23764	4	applied	\N	\N	\N	\N	136349	136349	303911
17564	23765	5	applied	\N	\N	\N	\N	136350	136350	303912
17480	23585	0	applied	\N	\N	\N	\N	135967	135967	303529
17480	23586	1	applied	\N	\N	\N	\N	135968	135968	303530
17505	23650	3	applied	\N	\N	\N	\N	136106	136106	303668
17505	23651	4	applied	\N	\N	\N	\N	136107	136107	303669
17505	23652	5	applied	\N	\N	\N	\N	136108	136108	303670
17507	23653	0	applied	\N	\N	\N	\N	136115	136115	303677
17507	23654	1	applied	\N	\N	\N	\N	136116	136116	303678
17507	23655	2	applied	\N	\N	\N	\N	136117	136117	303679
17509	23653	0	applied	\N	\N	\N	\N	136119	136119	303681
17509	23656	1	applied	\N	\N	\N	\N	136120	136120	303682
17509	23654	2	applied	\N	\N	\N	\N	136121	136121	303683
17509	23657	3	applied	\N	\N	\N	\N	136122	136122	303684
17509	23658	4	applied	\N	\N	\N	\N	136123	136123	303685
17510	23659	0	applied	\N	\N	\N	\N	136124	136124	303686
17510	23660	1	applied	\N	\N	\N	\N	136125	136125	303687
17510	23661	2	applied	\N	\N	\N	\N	136126	136126	303688
17510	23662	3	applied	\N	\N	\N	\N	136127	136127	303689
17510	23663	4	applied	\N	\N	\N	\N	136128	136128	303690
17510	23665	6	applied	\N	\N	\N	\N	136130	136130	303692
17510	23666	7	applied	\N	\N	\N	\N	136131	136131	303693
17510	23667	8	applied	\N	\N	\N	\N	136132	136132	303694
17515	23670	0	applied	\N	\N	\N	\N	136161	136161	303723
17515	23671	1	applied	\N	\N	\N	\N	136162	136162	303724
17515	23672	2	applied	\N	\N	\N	\N	136163	136163	303725
17517	23675	0	applied	\N	\N	\N	\N	136166	136166	303728
17517	23676	1	applied	\N	\N	\N	\N	136167	136167	303729
17517	23677	2	applied	\N	\N	\N	\N	136168	136168	303730
17522	23678	0	applied	\N	\N	\N	\N	136179	136179	303741
17522	23679	1	applied	\N	\N	\N	\N	136180	136180	303742
17528	23702	0	applied	\N	\N	\N	\N	136205	136205	303767
17528	23703	1	applied	\N	\N	\N	\N	136206	136206	303768
17528	23704	2	applied	\N	\N	\N	\N	136207	136207	303769
17528	23705	3	applied	\N	\N	\N	\N	136208	136208	303770
17528	23706	4	applied	\N	\N	\N	\N	136209	136209	303771
17536	23729	1	applied	\N	\N	\N	\N	136254	136254	303816
17536	23730	2	applied	\N	\N	\N	\N	136255	136255	303817
17538	23676	0	applied	\N	\N	\N	\N	136259	136259	303821
17538	23599	1	applied	\N	\N	\N	\N	136260	136260	303822
17538	23616	2	applied	\N	\N	\N	\N	136261	136261	303823
17545	23740	0	applied	\N	\N	\N	\N	136289	136289	303851
17545	23741	1	applied	\N	\N	\N	\N	136290	136290	303852
17548	23742	0	applied	\N	\N	\N	\N	136297	136297	303859
17548	23743	1	applied	\N	\N	\N	\N	136298	136298	303860
17548	23744	2	applied	\N	\N	\N	\N	136299	136299	303861
17550	23745	0	applied	\N	\N	\N	\N	136303	136303	303865
17550	23746	1	applied	\N	\N	\N	\N	136304	136304	303866
17550	23747	2	applied	\N	\N	\N	\N	136305	136305	303867
17552	23748	0	applied	\N	\N	\N	\N	136309	136309	303871
17552	23749	1	applied	\N	\N	\N	\N	136310	136310	303872
17552	23750	2	applied	\N	\N	\N	\N	136311	136311	303873
17554	23752	1	applied	\N	\N	\N	\N	136316	136316	303878
17554	23753	2	applied	\N	\N	\N	\N	136317	136317	303879
17561	23754	0	applied	\N	\N	\N	\N	136336	136336	303898
17561	23755	1	applied	\N	\N	\N	\N	136337	136337	303899
17561	23756	2	applied	\N	\N	\N	\N	136338	136338	303900
17566	23766	0	applied	\N	\N	\N	\N	136357	136357	303919
17566	23767	1	applied	\N	\N	\N	\N	136358	136358	303920
17566	23768	2	applied	\N	\N	\N	\N	136359	136359	303921
17570	23766	0	applied	\N	\N	\N	\N	136366	136366	303928
17570	23767	1	applied	\N	\N	\N	\N	136367	136367	303929
17570	23768	2	applied	\N	\N	\N	\N	136368	136368	303930
17572	23769	0	applied	\N	\N	\N	\N	136375	136375	303937
17572	23770	1	applied	\N	\N	\N	\N	136376	136376	303938
17572	23771	2	applied	\N	\N	\N	\N	136377	136377	303939
17572	23772	3	applied	\N	\N	\N	\N	136378	136378	303940
17572	23773	4	applied	\N	\N	\N	\N	136379	136379	303941
17574	23775	0	applied	\N	\N	\N	\N	136418	136418	303980
17574	23776	1	applied	\N	\N	\N	\N	136419	136419	303981
17574	23777	2	applied	\N	\N	\N	\N	136420	136420	303982
17580	23775	0	applied	\N	\N	\N	\N	136430	136430	303992
17584	23784	0	applied	\N	\N	\N	\N	136451	136451	304013
17584	23785	1	applied	\N	\N	\N	\N	136452	136452	304014
17584	23786	2	applied	\N	\N	\N	\N	136453	136453	304015
17584	23787	3	applied	\N	\N	\N	\N	136454	136454	304016
17584	23788	4	applied	\N	\N	\N	\N	136455	136455	304017
17584	23789	5	applied	\N	\N	\N	\N	136456	136456	304018
17584	23790	6	applied	\N	\N	\N	\N	136457	136457	304019
17584	23791	7	applied	\N	\N	\N	\N	136458	136458	304020
17584	23792	8	applied	\N	\N	\N	\N	136459	136459	304021
17586	23784	0	applied	\N	\N	\N	\N	136469	136469	304031
17586	23785	1	applied	\N	\N	\N	\N	136470	136470	304032
17586	23786	2	applied	\N	\N	\N	\N	136471	136471	304033
17586	23788	4	applied	\N	\N	\N	\N	136473	136473	304035
17586	23789	5	applied	\N	\N	\N	\N	136474	136474	304036
17586	23790	6	applied	\N	\N	\N	\N	136475	136475	304037
17586	23791	7	applied	\N	\N	\N	\N	136476	136476	304038
17586	23792	8	applied	\N	\N	\N	\N	136477	136477	304039
17589	23799	0	applied	\N	\N	\N	\N	136488	136488	304050
17589	23800	1	applied	\N	\N	\N	\N	136489	136489	304051
17589	23801	2	applied	\N	\N	\N	\N	136490	136490	304052
17589	23802	3	applied	\N	\N	\N	\N	136491	136491	304053
17591	23799	0	applied	\N	\N	\N	\N	136494	136494	304056
17591	23800	1	applied	\N	\N	\N	\N	136495	136495	304057
17591	23801	2	applied	\N	\N	\N	\N	136496	136496	304058
17591	23802	3	applied	\N	\N	\N	\N	136497	136497	304059
17595	23806	0	applied	\N	\N	\N	\N	136541	136541	304103
17595	23807	1	applied	\N	\N	\N	\N	136542	136542	304104
17595	23808	3	applied	\N	\N	\N	\N	136543	136543	304105
17597	23810	1	applied	\N	\N	\N	\N	136670	136670	304232
17597	23811	2	applied	\N	\N	\N	\N	136671	136671	304233
17605	23817	0	applied	\N	\N	\N	\N	136859	136859	304421
17605	23818	1	applied	\N	\N	\N	\N	136860	136860	304422
17605	23819	2	applied	\N	\N	\N	\N	136861	136861	304423
17605	23815	3	applied	\N	\N	\N	\N	136862	136862	304424
17605	23816	4	applied	\N	\N	\N	\N	136863	136863	304425
17605	23812	5	applied	\N	\N	\N	\N	136864	136864	304426
17605	23820	6	applied	\N	\N	\N	\N	136865	136865	304427
17605	23821	7	applied	\N	\N	\N	\N	136866	136866	304428
17605	23822	8	applied	\N	\N	\N	\N	136867	136867	304429
17607	23817	0	applied	\N	\N	\N	\N	136873	136873	304435
17607	23818	1	applied	\N	\N	\N	\N	136874	136874	304436
17607	23819	2	applied	\N	\N	\N	\N	136875	136875	304437
17505	23647	0	applied	\N	\N	\N	\N	136103	136103	303665
17505	23648	1	applied	\N	\N	\N	\N	136104	136104	303666
17540	23733	2	applied	\N	\N	\N	\N	136267	136267	303829
17543	23734	0	applied	\N	\N	\N	\N	136279	136279	303841
17543	23735	1	applied	\N	\N	\N	\N	136280	136280	303842
17543	23736	2	applied	\N	\N	\N	\N	136281	136281	303843
17543	23737	3	applied	\N	\N	\N	\N	136282	136282	303844
17543	23738	4	applied	\N	\N	\N	\N	136283	136283	303845
17547	23742	0	applied	\N	\N	\N	\N	136294	136294	303856
17547	23743	1	applied	\N	\N	\N	\N	136295	136295	303857
17547	23744	2	applied	\N	\N	\N	\N	136296	136296	303858
17549	23745	0	applied	\N	\N	\N	\N	136300	136300	303862
17549	23746	1	applied	\N	\N	\N	\N	136301	136301	303863
17551	23748	0	applied	\N	\N	\N	\N	136306	136306	303868
17551	23749	1	applied	\N	\N	\N	\N	136307	136307	303869
17551	23750	2	applied	\N	\N	\N	\N	136308	136308	303870
17557	23751	0	applied	\N	\N	\N	\N	136324	136324	303886
17557	23752	1	applied	\N	\N	\N	\N	136325	136325	303887
17557	23753	2	applied	\N	\N	\N	\N	136326	136326	303888
17560	23754	0	applied	\N	\N	\N	\N	136333	136333	303895
17560	23755	1	applied	\N	\N	\N	\N	136334	136334	303896
17560	23756	2	applied	\N	\N	\N	\N	136335	136335	303897
17562	23757	0	applied	\N	\N	\N	\N	136339	136339	303901
17562	23758	1	applied	\N	\N	\N	\N	136340	136340	303902
17562	23759	2	applied	\N	\N	\N	\N	136341	136341	303903
17565	23760	0	applied	\N	\N	\N	\N	136351	136351	303913
17565	23761	1	applied	\N	\N	\N	\N	136352	136352	303914
17565	23762	2	applied	\N	\N	\N	\N	136353	136353	303915
17565	23763	3	applied	\N	\N	\N	\N	136354	136354	303916
17565	23765	5	applied	\N	\N	\N	\N	136356	136356	303918
17567	23766	0	applied	\N	\N	\N	\N	136360	136360	303922
17567	23767	1	applied	\N	\N	\N	\N	136361	136361	303923
17567	23768	2	applied	\N	\N	\N	\N	136362	136362	303924
17571	23769	0	applied	\N	\N	\N	\N	136369	136369	303931
17571	23770	1	applied	\N	\N	\N	\N	136370	136370	303932
17571	23771	2	applied	\N	\N	\N	\N	136371	136371	303933
17571	23772	3	applied	\N	\N	\N	\N	136372	136372	303934
17571	23773	4	applied	\N	\N	\N	\N	136373	136373	303935
17571	23774	5	applied	\N	\N	\N	\N	136374	136374	303936
17576	23775	0	applied	\N	\N	\N	\N	136424	136424	303986
17576	23776	1	applied	\N	\N	\N	\N	136425	136425	303987
17576	23777	2	applied	\N	\N	\N	\N	136426	136426	303988
17581	23781	0	applied	\N	\N	\N	\N	136439	136439	304001
17581	23783	1	applied	\N	\N	\N	\N	136440	136440	304002
17581	23782	2	applied	\N	\N	\N	\N	136441	136441	304003
17583	23785	1	applied	\N	\N	\N	\N	136443	136443	304005
17583	23786	2	applied	\N	\N	\N	\N	136444	136444	304006
17583	23787	3	applied	\N	\N	\N	\N	136445	136445	304007
17583	23788	4	applied	\N	\N	\N	\N	136446	136446	304008
17583	23789	5	applied	\N	\N	\N	\N	136447	136447	304009
17583	23790	6	applied	\N	\N	\N	\N	136448	136448	304010
17583	23791	7	applied	\N	\N	\N	\N	136449	136449	304011
17583	23792	8	applied	\N	\N	\N	\N	136450	136450	304012
17588	23799	0	applied	\N	\N	\N	\N	136484	136484	304046
17588	23800	1	applied	\N	\N	\N	\N	136485	136485	304047
17588	23801	2	applied	\N	\N	\N	\N	136486	136486	304048
17588	23802	3	applied	\N	\N	\N	\N	136487	136487	304049
17593	23803	0	applied	\N	\N	\N	\N	136533	136533	304095
17593	23804	1	applied	\N	\N	\N	\N	136534	136534	304096
17593	23805	2	applied	\N	\N	\N	\N	136535	136535	304097
17599	23192	0	applied	\N	\N	\N	\N	136692	136692	304254
17599	22790	2	applied	\N	\N	\N	\N	136694	136694	304256
17599	22806	3	applied	\N	\N	1000000000	\N	136695	136695	304257
17599	23449	4	applied	\N	\N	\N	\N	136696	136696	304258
17599	23450	5	applied	\N	\N	\N	\N	136697	136697	304259
17599	23451	6	applied	\N	\N	\N	\N	136698	136698	304260
17599	23452	7	applied	\N	\N	\N	\N	136699	136699	304261
17599	23453	8	applied	\N	\N	\N	\N	136700	136700	304262
17599	23454	10	applied	\N	\N	\N	\N	136701	136701	304263
17599	23455	11	applied	\N	\N	\N	\N	136702	136702	304264
17599	23394	12	applied	\N	\N	\N	\N	136703	136703	304265
17604	23817	0	applied	\N	\N	\N	\N	136854	136854	304416
17604	23818	1	applied	\N	\N	\N	\N	136855	136855	304417
17604	23819	2	applied	\N	\N	\N	\N	136856	136856	304418
17604	23815	3	applied	\N	\N	\N	\N	136857	136857	304419
17604	23816	4	applied	\N	\N	\N	\N	136858	136858	304420
17606	23817	0	applied	\N	\N	\N	\N	136868	136868	304430
17606	23818	1	applied	\N	\N	\N	\N	136869	136869	304431
17606	23819	2	applied	\N	\N	\N	\N	136870	136870	304432
17606	23824	4	applied	\N	\N	\N	\N	136872	136872	304434
17607	23823	3	applied	\N	\N	\N	\N	136876	136876	304438
17607	23824	4	applied	\N	\N	\N	\N	136877	136877	304439
17607	23812	5	applied	\N	\N	\N	\N	136878	136878	304440
17607	23820	6	applied	\N	\N	\N	\N	136879	136879	304441
17607	23821	7	applied	\N	\N	\N	\N	136880	136880	304442
17607	23822	8	applied	\N	\N	\N	\N	136881	136881	304443
17607	23825	9	applied	\N	\N	\N	\N	136882	136882	304444
17608	23826	0	applied	\N	\N	\N	\N	136883	136883	304445
17608	23827	1	applied	\N	\N	\N	\N	136884	136884	304446
17620	23838	0	applied	\N	\N	\N	\N	136922	136922	304484
17620	23839	1	applied	\N	\N	\N	\N	136923	136923	304485
17620	23840	2	applied	\N	\N	\N	\N	136924	136924	304486
17621	23839	0	applied	\N	\N	\N	\N	136925	136925	304487
17624	23844	0	applied	\N	\N	\N	\N	136932	136932	304494
17624	23845	1	applied	\N	\N	\N	\N	136933	136933	304495
17626	23847	0	applied	\N	\N	\N	\N	136938	136938	304500
17626	23848	1	applied	\N	\N	\N	\N	136939	136939	304501
17626	23849	2	applied	\N	\N	\N	\N	136940	136940	304502
17626	23850	3	applied	\N	\N	\N	\N	136941	136941	304503
17626	23851	4	applied	\N	\N	\N	\N	136942	136942	304504
17626	23852	5	applied	\N	\N	\N	\N	136943	136943	304505
17638	23862	0	applied	\N	\N	\N	\N	137105	137105	304667
17638	23863	1	applied	\N	\N	\N	\N	137106	137106	304668
17638	23864	2	applied	\N	\N	\N	\N	137107	137107	304669
17640	23865	0	applied	\N	\N	\N	\N	137233	137233	304795
17640	23866	1	applied	\N	\N	\N	\N	137234	137234	304796
17640	23867	2	applied	\N	\N	\N	\N	137235	137235	304797
17642	23868	0	applied	\N	\N	\N	\N	137239	137239	304801
17642	23869	1	applied	\N	\N	\N	\N	137240	137240	304802
17642	23870	2	applied	\N	\N	\N	\N	137241	137241	304803
17645	23877	1	applied	\N	\N	\N	\N	137255	137255	304817
17540	23731	0	applied	\N	\N	\N	\N	136265	136265	303827
17540	23732	1	applied	\N	\N	\N	\N	136266	136266	303828
17573	23751	6	applied	\N	\N	\N	\N	136387	136387	303949
17573	23754	7	applied	\N	\N	\N	\N	136388	136388	303950
17573	23757	8	applied	\N	\N	\N	\N	136389	136389	303951
17573	23760	9	applied	\N	\N	\N	\N	136390	136390	303952
17573	23761	10	applied	\N	\N	\N	\N	136391	136391	303953
17573	23766	11	applied	\N	\N	\N	\N	136392	136392	303954
17573	23769	12	applied	\N	\N	\N	\N	136393	136393	303955
17573	23736	13	applied	\N	\N	\N	\N	136394	136394	303956
17573	23737	14	applied	\N	\N	\N	\N	136395	136395	303957
17573	23739	16	applied	\N	\N	\N	\N	136397	136397	303959
17573	23744	17	applied	\N	\N	\N	\N	136398	136398	303960
17573	23746	18	applied	\N	\N	\N	\N	136399	136399	303961
17573	23750	19	applied	\N	\N	\N	\N	136400	136400	303962
17573	23752	20	applied	\N	\N	\N	\N	136401	136401	303963
17573	23755	21	applied	\N	\N	\N	\N	136402	136402	303964
17573	23758	22	applied	\N	\N	\N	\N	136403	136403	303965
17573	23763	23	applied	\N	\N	\N	\N	136404	136404	303966
17573	23764	24	applied	\N	\N	\N	\N	136405	136405	303967
17573	23741	25	applied	\N	\N	\N	\N	136406	136406	303968
17573	23743	26	applied	\N	\N	\N	\N	136407	136407	303969
17573	23747	27	applied	\N	\N	\N	\N	136408	136408	303970
17573	23749	28	applied	\N	\N	\N	\N	136409	136409	303971
17573	23753	29	applied	\N	\N	\N	\N	136410	136410	303972
17573	23756	30	applied	\N	\N	\N	\N	136411	136411	303973
17573	23759	31	applied	\N	\N	\N	\N	136412	136412	303974
17573	23768	33	applied	\N	\N	\N	\N	136414	136414	303976
17573	23771	34	applied	\N	\N	\N	\N	136415	136415	303977
17573	23765	35	applied	\N	\N	\N	\N	136416	136416	303978
17573	23767	36	applied	\N	\N	\N	\N	136417	136417	303979
17575	23775	0	applied	\N	\N	\N	\N	136421	136421	303983
17575	23776	1	applied	\N	\N	\N	\N	136422	136422	303984
17575	23777	2	applied	\N	\N	\N	\N	136423	136423	303985
17579	23778	0	applied	\N	\N	\N	\N	136427	136427	303989
17579	23779	1	applied	\N	\N	\N	\N	136428	136428	303990
17579	23780	2	applied	\N	\N	\N	\N	136429	136429	303991
17585	23784	0	applied	\N	\N	\N	\N	136460	136460	304022
17585	23785	1	applied	\N	\N	\N	\N	136461	136461	304023
17585	23786	2	applied	\N	\N	\N	\N	136462	136462	304024
17585	23787	3	applied	\N	\N	\N	\N	136463	136463	304025
17585	23788	4	applied	\N	\N	\N	\N	136464	136464	304026
17585	23789	5	applied	\N	\N	\N	\N	136465	136465	304027
17585	23791	7	applied	\N	\N	\N	\N	136467	136467	304029
17585	23792	8	applied	\N	\N	\N	\N	136468	136468	304030
17587	23793	0	applied	\N	\N	\N	\N	136478	136478	304040
17587	23794	1	applied	\N	\N	\N	\N	136479	136479	304041
17587	23795	2	applied	\N	\N	\N	\N	136480	136480	304042
17587	23796	3	applied	\N	\N	\N	\N	136481	136481	304043
17587	23797	4	applied	\N	\N	\N	\N	136482	136482	304044
17587	23798	5	applied	\N	\N	\N	\N	136483	136483	304045
17590	23799	0	applied	\N	\N	\N	\N	136492	136492	304054
17590	23802	1	applied	\N	\N	\N	\N	136493	136493	304055
17594	23800	0	applied	\N	\N	\N	\N	136536	136536	304098
17594	23803	1	applied	\N	\N	\N	\N	136537	136537	304099
17594	23801	2	applied	\N	\N	\N	\N	136538	136538	304100
17594	23804	3	applied	\N	\N	\N	\N	136539	136539	304101
17594	23805	4	applied	\N	\N	\N	\N	136540	136540	304102
17598	23799	0	applied	\N	\N	\N	\N	136672	136672	304234
17598	23763	2	applied	\N	\N	\N	\N	136674	136674	304236
17598	23764	3	applied	\N	\N	\N	\N	136675	136675	304237
17598	23768	4	applied	\N	\N	\N	\N	136676	136676	304238
17598	23771	5	applied	\N	\N	\N	\N	136677	136677	304239
17598	23772	6	applied	\N	\N	\N	\N	136678	136678	304240
17598	23777	7	applied	\N	\N	\N	\N	136679	136679	304241
17598	23779	8	applied	\N	\N	\N	\N	136680	136680	304242
17598	23783	9	applied	\N	\N	\N	\N	136681	136681	304243
17598	23787	10	applied	\N	\N	\N	\N	136682	136682	304244
17598	23790	11	applied	\N	\N	\N	\N	136683	136683	304245
17598	23792	12	applied	\N	\N	\N	\N	136684	136684	304246
17598	23795	13	applied	\N	\N	\N	\N	136685	136685	304247
17598	23796	14	applied	\N	\N	\N	\N	136686	136686	304248
17598	23801	15	applied	\N	\N	\N	\N	136687	136687	304249
17598	23804	16	applied	\N	\N	\N	\N	136688	136688	304250
17598	23808	17	applied	\N	\N	\N	\N	136689	136689	304251
17598	23812	19	applied	\N	\N	\N	\N	136691	136691	304253
17600	23799	0	applied	\N	\N	\N	\N	136704	136704	304266
17600	23784	1	applied	\N	\N	\N	\N	136705	136705	304267
17600	23785	2	applied	\N	\N	\N	\N	136706	136706	304268
17600	23786	3	applied	\N	\N	\N	\N	136707	136707	304269
17600	23793	4	applied	\N	\N	\N	\N	136708	136708	304270
17600	23794	5	applied	\N	\N	\N	\N	136709	136709	304271
17600	23800	6	applied	\N	\N	\N	\N	136710	136710	304272
17600	23803	7	applied	\N	\N	\N	\N	136711	136711	304273
17600	23806	8	applied	\N	\N	\N	\N	136712	136712	304274
17600	23809	9	applied	\N	\N	\N	\N	136713	136713	304275
17600	23813	10	applied	\N	\N	\N	\N	136714	136714	304276
17600	23788	11	applied	\N	\N	\N	\N	136715	136715	304277
17600	23789	12	applied	\N	\N	\N	\N	136716	136716	304278
17600	23791	13	applied	\N	\N	\N	\N	136717	136717	304279
17600	23797	14	applied	\N	\N	\N	\N	136718	136718	304280
17600	23802	16	applied	\N	\N	\N	\N	136720	136720	304282
17600	23805	17	applied	\N	\N	\N	\N	136721	136721	304283
17600	23807	18	applied	\N	\N	\N	\N	136722	136722	304284
17600	23810	19	applied	\N	\N	\N	\N	136723	136723	304285
17600	23814	20	applied	\N	\N	\N	\N	136724	136724	304286
17602	23813	0	applied	\N	\N	\N	\N	136850	136850	304412
17602	23814	1	applied	\N	\N	\N	\N	136851	136851	304413
17610	23828	0	applied	\N	\N	\N	\N	136889	136889	304451
17610	23829	1	applied	\N	\N	\N	\N	136890	136890	304452
17610	23830	2	applied	\N	\N	\N	\N	136891	136891	304453
17610	23831	3	applied	\N	\N	\N	\N	136892	136892	304454
17614	23832	0	applied	\N	\N	\N	\N	136904	136904	304466
17614	23833	1	applied	\N	\N	\N	\N	136905	136905	304467
17614	23834	2	applied	\N	\N	\N	\N	136906	136906	304468
17645	23879	3	applied	\N	\N	1000000000	\N	137257	137257	304819
17645	23880	4	applied	\N	\N	1000000000	\N	137258	137258	304820
17645	23881	5	applied	\N	\N	\N	\N	137259	137259	304821
17645	23882	6	applied	\N	\N	\N	\N	137260	137260	304822
17647	23876	0	applied	\N	\N	1000000000	\N	137268	137268	304830
17647	23877	1	applied	\N	\N	\N	\N	137269	137269	304831
17573	23745	4	applied	\N	\N	\N	\N	136385	136385	303947
17573	23748	5	applied	\N	\N	\N	\N	136386	136386	303948
17580	23780	4	applied	\N	\N	\N	\N	136434	136434	303996
17580	23782	5	applied	\N	\N	\N	\N	136435	136435	303997
17580	23777	6	applied	\N	\N	\N	\N	136436	136436	303998
17580	23779	7	applied	\N	\N	\N	\N	136437	136437	303999
17580	23783	8	applied	\N	\N	\N	\N	136438	136438	304000
17592	23192	0	applied	\N	\N	\N	\N	136498	136498	304060
17592	23448	1	applied	\N	\N	1000000000	\N	136499	136499	304061
17592	23449	2	applied	\N	\N	\N	\N	136500	136500	304062
17592	23450	3	applied	\N	\N	\N	\N	136501	136501	304063
17592	23451	4	applied	\N	\N	\N	\N	136502	136502	304064
17592	23452	5	applied	\N	\N	\N	\N	136503	136503	304065
17592	23453	6	applied	\N	\N	\N	\N	136504	136504	304066
17592	23454	7	applied	\N	\N	\N	\N	136505	136505	304067
17592	23394	9	applied	\N	\N	\N	\N	136507	136507	304069
17592	23577	10	applied	\N	\N	\N	\N	136508	136508	304070
17592	23608	11	applied	\N	\N	\N	\N	136509	136509	304071
17592	23456	12	applied	\N	\N	\N	\N	136510	136510	304072
17592	23457	13	applied	\N	\N	\N	\N	136511	136511	304073
17592	23458	14	applied	\N	\N	\N	\N	136512	136512	304074
17592	23459	15	applied	\N	\N	\N	\N	136513	136513	304075
17592	23467	16	applied	\N	\N	\N	\N	136514	136514	304076
17592	23468	17	applied	\N	\N	\N	\N	136515	136515	304077
17592	23469	18	applied	\N	\N	\N	\N	136516	136516	304078
17592	23492	19	applied	\N	\N	\N	\N	136517	136517	304079
17592	23470	20	applied	\N	\N	\N	\N	136518	136518	304080
17592	23473	21	applied	\N	\N	\N	\N	136519	136519	304081
17592	23474	22	applied	\N	\N	\N	\N	136520	136520	304082
17592	23475	23	applied	\N	\N	\N	\N	136521	136521	304083
17592	23476	24	applied	\N	\N	\N	\N	136522	136522	304084
17592	23480	26	applied	\N	\N	\N	\N	136524	136524	304086
17592	23481	27	applied	\N	\N	\N	\N	136525	136525	304087
17592	23482	28	applied	\N	\N	\N	\N	136526	136526	304088
17592	23483	29	applied	\N	\N	\N	\N	136527	136527	304089
17592	23484	30	applied	\N	\N	\N	\N	136528	136528	304090
17592	23487	31	applied	\N	\N	\N	\N	136529	136529	304091
17592	23488	32	applied	\N	\N	\N	\N	136530	136530	304092
17592	23491	33	applied	\N	\N	\N	\N	136531	136531	304093
17592	23423	34	applied	\N	\N	\N	\N	136532	136532	304094
17596	23448	0	applied	\N	\N	1000000000	\N	136544	136544	304106
17596	23449	1	applied	\N	\N	\N	\N	136545	136545	304107
17596	23450	2	applied	\N	\N	\N	\N	136546	136546	304108
17596	23451	3	applied	\N	\N	\N	\N	136547	136547	304109
17596	23452	4	applied	\N	\N	\N	\N	136548	136548	304110
17596	23453	5	applied	\N	\N	\N	\N	136549	136549	304111
17596	23454	6	applied	\N	\N	\N	\N	136550	136550	304112
17596	23394	8	applied	\N	\N	\N	\N	136552	136552	304114
17596	23577	9	applied	\N	\N	\N	\N	136553	136553	304115
17596	23608	10	applied	\N	\N	\N	\N	136554	136554	304116
17596	23456	11	applied	\N	\N	\N	\N	136555	136555	304117
17596	23457	12	applied	\N	\N	\N	\N	136556	136556	304118
17596	23458	13	applied	\N	\N	\N	\N	136557	136557	304119
17596	23459	14	applied	\N	\N	\N	\N	136558	136558	304120
17596	23467	15	applied	\N	\N	\N	\N	136559	136559	304121
17596	23468	16	applied	\N	\N	\N	\N	136560	136560	304122
17596	23469	17	applied	\N	\N	\N	\N	136561	136561	304123
17596	23382	18	applied	\N	\N	\N	\N	136562	136562	304124
17596	23383	19	applied	\N	\N	\N	\N	136563	136563	304125
17596	23387	20	applied	\N	\N	\N	\N	136564	136564	304126
17596	23399	21	applied	\N	\N	\N	\N	136565	136565	304127
17596	23492	22	applied	\N	\N	\N	\N	136566	136566	304128
17596	23470	23	applied	\N	\N	\N	\N	136567	136567	304129
17596	23474	25	applied	\N	\N	\N	\N	136569	136569	304131
17596	23475	26	applied	\N	\N	\N	\N	136570	136570	304132
17596	23476	27	applied	\N	\N	\N	\N	136571	136571	304133
17596	23477	28	applied	\N	\N	\N	\N	136572	136572	304134
17596	23480	29	applied	\N	\N	\N	\N	136573	136573	304135
17596	23481	30	applied	\N	\N	\N	\N	136574	136574	304136
17596	23482	31	applied	\N	\N	\N	\N	136575	136575	304137
17596	23483	32	applied	\N	\N	\N	\N	136576	136576	304138
17596	23484	33	applied	\N	\N	\N	\N	136577	136577	304139
17596	23487	34	applied	\N	\N	\N	\N	136578	136578	304140
17596	23488	35	applied	\N	\N	\N	\N	136579	136579	304141
17596	23491	36	applied	\N	\N	\N	\N	136580	136580	304142
17596	23423	37	applied	\N	\N	\N	\N	136581	136581	304143
17596	23400	38	applied	\N	\N	\N	\N	136582	136582	304144
17596	23407	39	applied	\N	\N	\N	\N	136583	136583	304145
17596	23411	40	applied	\N	\N	\N	\N	136584	136584	304146
17596	23417	42	applied	\N	\N	\N	\N	136586	136586	304148
17596	23419	43	applied	\N	\N	\N	\N	136587	136587	304149
17596	23422	44	applied	\N	\N	\N	\N	136588	136588	304150
17596	23426	45	applied	\N	\N	\N	\N	136589	136589	304151
17596	23430	46	applied	\N	\N	\N	\N	136590	136590	304152
17596	23432	47	applied	\N	\N	\N	\N	136591	136591	304153
17596	23433	48	applied	\N	\N	\N	\N	136592	136592	304154
17596	23438	49	applied	\N	\N	\N	\N	136593	136593	304155
17596	23440	50	applied	\N	\N	\N	\N	136594	136594	304156
17596	23441	51	applied	\N	\N	\N	\N	136595	136595	304157
17596	23446	52	applied	\N	\N	\N	\N	136596	136596	304158
17596	23460	53	applied	\N	\N	\N	\N	136597	136597	304159
17596	23461	54	applied	\N	\N	\N	\N	136598	136598	304160
17596	23466	55	applied	\N	\N	\N	\N	136599	136599	304161
17596	23472	56	applied	\N	\N	\N	\N	136600	136600	304162
17596	23479	57	applied	\N	\N	\N	\N	136601	136601	304163
17596	23490	59	applied	\N	\N	\N	\N	136603	136603	304165
17596	23506	60	applied	\N	\N	\N	\N	136604	136604	304166
17596	23507	61	applied	\N	\N	\N	\N	136605	136605	304167
17596	23529	62	applied	\N	\N	\N	\N	136606	136606	304168
17596	23538	63	applied	\N	\N	\N	\N	136607	136607	304169
17596	23539	64	applied	\N	\N	\N	\N	136608	136608	304170
17596	23545	65	applied	\N	\N	\N	\N	136609	136609	304171
17596	23546	66	applied	\N	\N	\N	\N	136610	136610	304172
17596	23563	67	applied	\N	\N	\N	\N	136611	136611	304173
17616	23835	0	applied	\N	\N	\N	\N	136910	136910	304472
17616	23836	1	applied	\N	\N	\N	\N	136911	136911	304473
17616	23837	2	applied	\N	\N	\N	\N	136912	136912	304474
17618	23838	0	applied	\N	\N	\N	\N	136916	136916	304478
17618	23839	1	applied	\N	\N	\N	\N	136917	136917	304479
17618	23840	2	applied	\N	\N	\N	\N	136918	136918	304480
17628	23847	0	applied	\N	\N	\N	\N	136950	136950	304512
17580	23781	2	applied	\N	\N	\N	\N	136432	136432	303994
17580	23776	3	applied	\N	\N	\N	\N	136433	136433	303995
17596	23585	72	applied	\N	\N	\N	\N	136616	136616	304178
17596	23594	73	applied	\N	\N	\N	\N	136617	136617	304179
17596	23603	74	applied	\N	\N	\N	\N	136618	136618	304180
17596	23610	75	applied	\N	\N	\N	\N	136619	136619	304181
17596	23617	76	applied	\N	\N	\N	\N	136620	136620	304182
17596	23625	77	applied	\N	\N	\N	\N	136621	136621	304183
17596	23627	78	applied	\N	\N	\N	\N	136622	136622	304184
17596	23629	79	applied	\N	\N	\N	\N	136623	136623	304185
17596	23631	80	applied	\N	\N	\N	\N	136624	136624	304186
17596	23633	81	applied	\N	\N	\N	\N	136625	136625	304187
17596	23635	83	applied	\N	\N	\N	\N	136626	136626	304188
17596	23641	84	applied	\N	\N	\N	\N	136627	136627	304189
17596	23644	85	applied	\N	\N	\N	\N	136628	136628	304190
17596	23647	86	applied	\N	\N	\N	\N	136629	136629	304191
17596	23653	88	applied	\N	\N	\N	\N	136631	136631	304193
17596	23656	89	applied	\N	\N	\N	\N	136632	136632	304194
17596	23659	90	applied	\N	\N	\N	\N	136633	136633	304195
17596	23660	91	applied	\N	\N	\N	\N	136634	136634	304196
17596	23661	92	applied	\N	\N	\N	\N	136635	136635	304197
17596	23668	93	applied	\N	\N	\N	\N	136636	136636	304198
17596	23670	94	applied	\N	\N	\N	\N	136637	136637	304199
17596	23673	95	applied	\N	\N	\N	\N	136638	136638	304200
17596	23675	96	applied	\N	\N	\N	\N	136639	136639	304201
17596	23678	97	applied	\N	\N	\N	\N	136640	136640	304202
17596	23680	98	applied	\N	\N	\N	\N	136641	136641	304203
17596	23682	99	applied	\N	\N	\N	\N	136642	136642	304204
17596	23683	100	applied	\N	\N	\N	\N	136643	136643	304205
17596	23690	101	applied	\N	\N	\N	\N	136644	136644	304206
17596	23691	102	applied	\N	\N	\N	\N	136645	136645	304207
17596	23692	103	applied	\N	\N	\N	\N	136646	136646	304208
17596	23702	105	applied	\N	\N	\N	\N	136648	136648	304210
17596	23493	106	applied	\N	\N	\N	\N	136649	136649	304211
17596	23494	107	applied	\N	\N	\N	\N	136650	136650	304212
17596	23495	108	applied	\N	\N	\N	\N	136651	136651	304213
17596	23496	109	applied	\N	\N	\N	\N	136652	136652	304214
17596	23497	110	applied	\N	\N	\N	\N	136653	136653	304215
17596	23498	111	applied	\N	\N	\N	\N	136654	136654	304216
17596	23499	112	applied	\N	\N	\N	\N	136655	136655	304217
17596	23500	113	applied	\N	\N	\N	\N	136656	136656	304218
17596	23501	114	applied	\N	\N	\N	\N	136657	136657	304219
17596	23508	115	applied	\N	\N	\N	\N	136658	136658	304220
17596	23509	116	applied	\N	\N	\N	\N	136659	136659	304221
17596	23510	117	applied	\N	\N	\N	\N	136660	136660	304222
17596	23511	118	applied	\N	\N	\N	\N	136661	136661	304223
17596	23512	119	applied	\N	\N	\N	\N	136662	136662	304224
17596	23513	120	applied	\N	\N	\N	\N	136663	136663	304225
17596	23515	122	applied	\N	\N	\N	\N	136665	136665	304227
17596	23516	123	applied	\N	\N	\N	\N	136666	136666	304228
17596	23517	124	applied	\N	\N	\N	\N	136667	136667	304229
17596	23518	125	applied	\N	\N	\N	\N	136668	136668	304230
17601	23192	0	applied	\N	\N	\N	\N	136725	136725	304287
17601	23448	1	applied	\N	\N	1000000000	\N	136726	136726	304288
17601	23449	2	applied	\N	\N	\N	\N	136727	136727	304289
17601	23450	3	applied	\N	\N	\N	\N	136728	136728	304290
17601	23451	4	applied	\N	\N	\N	\N	136729	136729	304291
17601	23452	5	applied	\N	\N	\N	\N	136730	136730	304292
17601	23453	6	applied	\N	\N	\N	\N	136731	136731	304293
17601	23454	7	applied	\N	\N	\N	\N	136732	136732	304294
17601	23455	8	applied	\N	\N	\N	\N	136733	136733	304295
17601	23394	9	applied	\N	\N	\N	\N	136734	136734	304296
17601	23577	10	applied	\N	\N	\N	\N	136735	136735	304297
17601	23608	11	applied	\N	\N	\N	\N	136736	136736	304298
17601	23072	13	applied	\N	\N	\N	\N	136738	136738	304300
17601	23073	14	applied	\N	\N	\N	\N	136739	136739	304301
17601	23076	15	applied	\N	\N	\N	\N	136740	136740	304302
17601	23078	16	applied	\N	\N	\N	\N	136741	136741	304303
17601	23081	17	applied	\N	\N	\N	\N	136742	136742	304304
17601	23456	18	applied	\N	\N	\N	\N	136743	136743	304305
17601	23457	19	applied	\N	\N	\N	\N	136744	136744	304306
17601	23458	20	applied	\N	\N	\N	\N	136745	136745	304307
17601	23459	21	applied	\N	\N	\N	\N	136746	136746	304308
17601	23467	22	applied	\N	\N	\N	\N	136747	136747	304309
17601	23468	23	applied	\N	\N	\N	\N	136748	136748	304310
17601	23469	24	applied	\N	\N	\N	\N	136749	136749	304311
17601	23492	25	applied	\N	\N	\N	\N	136750	136750	304312
17601	23470	26	applied	\N	\N	\N	\N	136751	136751	304313
17601	23473	27	applied	\N	\N	\N	\N	136752	136752	304314
17601	23474	28	applied	\N	\N	\N	\N	136753	136753	304315
17601	23476	30	applied	\N	\N	\N	\N	136755	136755	304317
17601	23477	31	applied	\N	\N	\N	\N	136756	136756	304318
17601	23480	32	applied	\N	\N	\N	\N	136757	136757	304319
17601	23481	33	applied	\N	\N	\N	\N	136758	136758	304320
17601	23482	34	applied	\N	\N	\N	\N	136759	136759	304321
17601	23483	36	applied	\N	\N	\N	\N	136760	136760	304322
17601	23484	37	applied	\N	\N	\N	\N	136761	136761	304323
17601	23487	38	applied	\N	\N	\N	\N	136762	136762	304324
17601	23488	39	applied	\N	\N	\N	\N	136763	136763	304325
17601	23491	40	applied	\N	\N	\N	\N	136764	136764	304326
17601	23423	41	applied	\N	\N	\N	\N	136765	136765	304327
17601	23084	42	applied	\N	\N	\N	\N	136766	136766	304328
17601	23087	43	applied	\N	\N	\N	\N	136767	136767	304329
17601	23090	44	applied	\N	\N	\N	\N	136768	136768	304330
17601	23093	45	applied	\N	\N	\N	\N	136769	136769	304331
17601	23094	46	applied	\N	\N	\N	\N	136770	136770	304332
17601	23100	48	applied	\N	\N	\N	\N	136772	136772	304334
17601	23101	49	applied	\N	\N	\N	\N	136773	136773	304335
17601	23108	50	applied	\N	\N	\N	\N	136774	136774	304336
17601	23109	51	applied	\N	\N	\N	\N	136775	136775	304337
17601	23114	52	applied	\N	\N	\N	\N	136776	136776	304338
17601	23117	53	applied	\N	\N	\N	\N	136777	136777	304339
17601	23119	54	applied	\N	\N	\N	\N	136778	136778	304340
17601	23122	55	applied	\N	\N	\N	\N	136779	136779	304341
17601	23123	56	applied	\N	\N	\N	\N	136780	136780	304342
17601	23124	57	applied	\N	\N	\N	\N	136781	136781	304343
17601	23131	58	applied	\N	\N	\N	\N	136782	136782	304344
17601	23134	59	applied	\N	\N	\N	\N	136783	136783	304345
17601	23156	60	applied	\N	\N	\N	\N	136784	136784	304346
17601	23493	61	applied	\N	\N	\N	\N	136785	136785	304347
17601	23494	62	applied	\N	\N	\N	\N	136786	136786	304348
17601	23495	63	applied	\N	\N	\N	\N	136787	136787	304349
17596	23579	71	applied	\N	\N	\N	\N	136615	136615	304177
17601	23500	68	applied	\N	\N	\N	\N	136792	136792	304354
17601	23501	69	applied	\N	\N	\N	\N	136793	136793	304355
17601	23508	70	applied	\N	\N	\N	\N	136794	136794	304356
17601	23509	71	applied	\N	\N	\N	\N	136795	136795	304357
17601	23510	72	applied	\N	\N	\N	\N	136796	136796	304358
17601	23511	73	applied	\N	\N	\N	\N	136797	136797	304359
17601	23512	74	applied	\N	\N	\N	\N	136798	136798	304360
17601	23513	75	applied	\N	\N	\N	\N	136799	136799	304361
17601	23514	76	applied	\N	\N	\N	\N	136800	136800	304362
17601	23515	77	applied	\N	\N	\N	\N	136801	136801	304363
17601	23516	78	applied	\N	\N	\N	\N	136802	136802	304364
17601	23517	79	applied	\N	\N	\N	\N	136803	136803	304365
17601	23518	80	applied	\N	\N	\N	\N	136804	136804	304366
17601	23523	81	applied	\N	\N	\N	\N	136805	136805	304367
17601	23524	82	applied	\N	\N	\N	\N	136806	136806	304368
17601	23526	84	applied	\N	\N	\N	\N	136808	136808	304370
17601	23527	85	applied	\N	\N	\N	\N	136809	136809	304371
17601	23528	86	applied	\N	\N	\N	\N	136810	136810	304372
17601	23532	87	applied	\N	\N	\N	\N	136811	136811	304373
17601	23533	88	applied	\N	\N	\N	\N	136812	136812	304374
17601	23534	89	applied	\N	\N	\N	\N	136813	136813	304375
17601	23535	90	applied	\N	\N	\N	\N	136814	136814	304376
17601	23536	91	applied	\N	\N	\N	\N	136815	136815	304377
17601	23537	92	applied	\N	\N	\N	\N	136816	136816	304378
17601	23540	93	applied	\N	\N	\N	\N	136817	136817	304379
17601	23541	94	applied	\N	\N	\N	\N	136818	136818	304380
17601	23549	95	applied	\N	\N	\N	\N	136819	136819	304381
17601	23550	96	applied	\N	\N	\N	\N	136820	136820	304382
17601	23551	97	applied	\N	\N	\N	\N	136821	136821	304383
17601	23552	98	applied	\N	\N	\N	\N	136822	136822	304384
17601	23553	99	applied	\N	\N	\N	\N	136823	136823	304385
17601	23555	101	applied	\N	\N	\N	\N	136825	136825	304387
17601	23556	102	applied	\N	\N	\N	\N	136826	136826	304388
17601	23557	103	applied	\N	\N	\N	\N	136827	136827	304389
17601	23558	104	applied	\N	\N	\N	\N	136828	136828	304390
17601	23135	105	applied	\N	\N	\N	\N	136829	136829	304391
17601	23136	106	applied	\N	\N	\N	\N	136830	136830	304392
17601	23137	107	applied	\N	\N	\N	\N	136831	136831	304393
17601	23146	108	applied	\N	\N	\N	\N	136832	136832	304394
17601	23149	109	applied	\N	\N	\N	\N	136833	136833	304395
17601	23150	110	applied	\N	\N	\N	\N	136834	136834	304396
17601	23155	111	applied	\N	\N	\N	\N	136835	136835	304397
17601	23159	112	applied	\N	\N	\N	\N	136836	136836	304398
17601	23160	113	applied	\N	\N	\N	\N	136837	136837	304399
17601	23165	114	applied	\N	\N	\N	\N	136838	136838	304400
17601	23168	115	applied	\N	\N	\N	\N	136839	136839	304401
17601	23170	116	applied	\N	\N	\N	\N	136840	136840	304402
17601	23176	118	applied	\N	\N	\N	\N	136842	136842	304404
17601	23559	119	applied	\N	\N	\N	\N	136843	136843	304405
17601	23560	120	applied	\N	\N	\N	\N	136844	136844	304406
17601	23564	121	applied	\N	\N	\N	\N	136845	136845	304407
17601	23565	122	applied	\N	\N	\N	\N	136846	136846	304408
17601	23566	123	applied	\N	\N	\N	\N	136847	136847	304409
17601	23567	124	applied	\N	\N	\N	\N	136848	136848	304410
17601	23576	125	applied	\N	\N	\N	\N	136849	136849	304411
17603	23815	0	applied	\N	\N	\N	\N	136852	136852	304414
17603	23816	1	applied	\N	\N	\N	\N	136853	136853	304415
17611	23828	0	applied	\N	\N	\N	\N	136893	136893	304455
17611	23829	1	applied	\N	\N	\N	\N	136894	136894	304456
17611	23830	2	applied	\N	\N	\N	\N	136895	136895	304457
17611	23831	3	applied	\N	\N	\N	\N	136896	136896	304458
17612	23828	0	applied	\N	\N	\N	\N	136897	136897	304459
17612	23829	1	applied	\N	\N	\N	\N	136898	136898	304460
17612	23831	3	applied	\N	\N	\N	\N	136900	136900	304462
17615	23832	0	applied	\N	\N	\N	\N	136907	136907	304469
17615	23833	1	applied	\N	\N	\N	\N	136908	136908	304470
17615	23834	2	applied	\N	\N	\N	\N	136909	136909	304471
17617	23835	0	applied	\N	\N	\N	\N	136913	136913	304475
17617	23836	1	applied	\N	\N	\N	\N	136914	136914	304476
17617	23837	2	applied	\N	\N	\N	\N	136915	136915	304477
17619	23838	0	applied	\N	\N	\N	\N	136919	136919	304481
17619	23839	1	applied	\N	\N	\N	\N	136920	136920	304482
17619	23840	2	applied	\N	\N	\N	\N	136921	136921	304483
17623	23844	0	applied	\N	\N	\N	\N	136929	136929	304491
17623	23845	1	applied	\N	\N	\N	\N	136930	136930	304492
17623	23846	2	applied	\N	\N	\N	\N	136931	136931	304493
17631	23853	0	applied	\N	\N	\N	\N	136962	136962	304524
17631	23854	1	applied	\N	\N	\N	\N	136963	136963	304525
17631	23855	2	applied	\N	\N	\N	\N	136964	136964	304526
17635	23860	1	applied	\N	\N	\N	\N	137097	137097	304659
17635	23861	2	applied	\N	\N	\N	\N	137098	137098	304660
17644	23877	1	applied	\N	\N	\N	\N	137248	137248	304810
17644	23878	2	applied	\N	\N	1000000000	\N	137249	137249	304811
17644	23879	3	applied	\N	\N	1000000000	\N	137250	137250	304812
17644	23880	4	applied	\N	\N	1000000000	\N	137251	137251	304813
17644	23881	5	applied	\N	\N	\N	\N	137252	137252	304814
17644	23882	6	applied	\N	\N	\N	\N	137253	137253	304815
17649	23890	0	applied	\N	\N	\N	\N	137282	137282	304844
17649	23891	2	applied	\N	\N	\N	\N	137283	137283	304845
17652	23892	0	applied	\N	\N	\N	\N	137411	137411	304973
17652	23893	1	applied	\N	\N	\N	\N	137412	137412	304974
17656	23896	0	applied	\N	\N	\N	\N	137425	137425	304987
17656	23897	1	applied	\N	\N	\N	\N	137426	137426	304988
17660	23898	0	applied	\N	\N	\N	\N	137433	137433	304995
17667	23908	0	applied	\N	\N	\N	\N	137453	137453	305015
17667	23909	1	applied	\N	\N	\N	\N	137454	137454	305016
17670	23871	0	applied	\N	\N	1000000000	\N	137459	137459	305021
17670	23876	1	applied	\N	\N	1000000000	\N	137460	137460	305022
17670	23878	2	applied	\N	\N	1000000000	\N	137461	137461	305023
17670	23879	3	applied	\N	\N	1000000000	\N	137462	137462	305024
17670	23880	4	applied	\N	\N	1000000000	\N	137463	137463	305025
17670	23179	5	applied	\N	\N	\N	\N	137464	137464	305026
17670	23181	6	applied	\N	\N	\N	\N	137465	137465	305027
17670	23184	7	applied	\N	\N	\N	\N	137466	137466	305028
17670	23187	8	applied	\N	\N	\N	\N	137467	137467	305029
17670	23189	9	applied	\N	\N	\N	\N	137468	137468	305030
17670	23193	10	applied	\N	\N	\N	\N	137469	137469	305031
17670	23194	11	applied	\N	\N	\N	\N	137470	137470	305032
17601	23497	65	applied	\N	\N	\N	\N	136789	136789	304351
17601	23499	67	applied	\N	\N	\N	\N	136791	136791	304353
17613	23832	0	applied	\N	\N	\N	\N	136901	136901	304463
17613	23833	1	applied	\N	\N	\N	\N	136902	136902	304464
17613	23834	2	applied	\N	\N	\N	\N	136903	136903	304465
17622	23841	0	applied	\N	\N	\N	\N	136926	136926	304488
17622	23842	1	applied	\N	\N	\N	\N	136927	136927	304489
17622	23843	2	applied	\N	\N	\N	\N	136928	136928	304490
17625	23844	0	applied	\N	\N	\N	\N	136935	136935	304497
17625	23845	1	applied	\N	\N	\N	\N	136936	136936	304498
17625	23846	2	applied	\N	\N	\N	\N	136937	136937	304499
17627	23847	0	applied	\N	\N	\N	\N	136944	136944	304506
17627	23848	1	applied	\N	\N	\N	\N	136945	136945	304507
17627	23849	2	applied	\N	\N	\N	\N	136946	136946	304508
17627	23850	3	applied	\N	\N	\N	\N	136947	136947	304509
17627	23851	4	applied	\N	\N	\N	\N	136948	136948	304510
17629	23853	0	applied	\N	\N	\N	\N	136956	136956	304518
17629	23854	1	applied	\N	\N	\N	\N	136957	136957	304519
17629	23855	2	applied	\N	\N	\N	\N	136958	136958	304520
17632	23192	0	applied	\N	\N	\N	\N	136965	136965	304527
17632	23448	1	applied	\N	\N	1000000000	\N	136966	136966	304528
17632	22885	2	applied	\N	\N	\N	\N	136967	136967	304529
17632	22886	3	applied	\N	\N	\N	\N	136968	136968	304530
17632	22887	4	applied	\N	\N	\N	\N	136969	136969	304531
17632	23449	5	applied	\N	\N	\N	\N	136970	136970	304532
17632	23450	6	applied	\N	\N	\N	\N	136971	136971	304533
17632	23451	7	applied	\N	\N	\N	\N	136972	136972	304534
17632	23452	8	applied	\N	\N	\N	\N	136973	136973	304535
17632	23453	9	applied	\N	\N	\N	\N	136974	136974	304536
17632	23454	10	applied	\N	\N	\N	\N	136975	136975	304537
17632	23455	11	applied	\N	\N	\N	\N	136976	136976	304538
17632	22895	12	applied	\N	\N	\N	\N	136977	136977	304539
17632	22902	14	applied	\N	\N	\N	\N	136979	136979	304541
17632	23394	15	applied	\N	\N	\N	\N	136980	136980	304542
17632	23577	16	applied	\N	\N	\N	\N	136981	136981	304543
17632	23608	17	applied	\N	\N	\N	\N	136982	136982	304544
17632	23456	18	applied	\N	\N	\N	\N	136983	136983	304545
17632	23457	19	applied	\N	\N	\N	\N	136984	136984	304546
17632	23458	20	applied	\N	\N	\N	\N	136985	136985	304547
17632	23459	21	applied	\N	\N	\N	\N	136986	136986	304548
17632	23467	22	applied	\N	\N	\N	\N	136987	136987	304549
17632	23468	23	applied	\N	\N	\N	\N	136988	136988	304550
17632	23469	24	applied	\N	\N	\N	\N	136989	136989	304551
17632	22905	25	applied	\N	\N	\N	\N	136990	136990	304552
17632	22908	26	applied	\N	\N	\N	\N	136991	136991	304553
17632	23492	27	applied	\N	\N	\N	\N	136992	136992	304554
17632	23470	28	applied	\N	\N	\N	\N	136993	136993	304555
17632	23473	29	applied	\N	\N	\N	\N	136994	136994	304556
17632	23475	31	applied	\N	\N	\N	\N	136996	136996	304558
17632	23476	32	applied	\N	\N	\N	\N	136997	136997	304559
17632	23477	33	applied	\N	\N	\N	\N	136998	136998	304560
17632	23480	34	applied	\N	\N	\N	\N	136999	136999	304561
17632	23481	35	applied	\N	\N	\N	\N	137000	137000	304562
17632	23482	36	applied	\N	\N	\N	\N	137001	137001	304563
17632	23483	37	applied	\N	\N	\N	\N	137002	137002	304564
17632	23484	38	applied	\N	\N	\N	\N	137003	137003	304565
17632	23487	39	applied	\N	\N	\N	\N	137004	137004	304566
17632	23488	40	applied	\N	\N	\N	\N	137005	137005	304567
17632	23491	41	applied	\N	\N	\N	\N	137006	137006	304568
17632	22912	42	applied	\N	\N	\N	\N	137007	137007	304569
17632	22915	43	applied	\N	\N	\N	\N	137008	137008	304570
17632	22921	44	applied	\N	\N	\N	\N	137009	137009	304571
17632	22922	45	applied	\N	\N	\N	\N	137010	137010	304572
17632	22923	46	applied	\N	\N	\N	\N	137011	137011	304573
17632	22934	48	applied	\N	\N	\N	\N	137013	137013	304575
17632	22937	49	applied	\N	\N	\N	\N	137014	137014	304576
17632	22940	51	applied	\N	\N	\N	\N	137015	137015	304577
17632	22944	52	applied	\N	\N	\N	\N	137016	137016	304578
17632	22947	53	applied	\N	\N	\N	\N	137017	137017	304579
17632	22948	54	applied	\N	\N	\N	\N	137018	137018	304580
17632	22953	55	applied	\N	\N	\N	\N	137019	137019	304581
17632	22956	56	applied	\N	\N	\N	\N	137020	137020	304582
17632	22959	57	applied	\N	\N	\N	\N	137021	137021	304583
17632	22962	58	applied	\N	\N	\N	\N	137022	137022	304584
17632	22966	59	applied	\N	\N	\N	\N	137023	137023	304585
17632	22969	60	applied	\N	\N	\N	\N	137024	137024	304586
17632	22972	61	applied	\N	\N	\N	\N	137025	137025	304587
17632	23423	62	applied	\N	\N	\N	\N	137026	137026	304588
17632	23156	63	applied	\N	\N	\N	\N	137027	137027	304589
17632	23493	64	applied	\N	\N	\N	\N	137028	137028	304590
17632	23495	66	applied	\N	\N	\N	\N	137030	137030	304592
17632	23496	67	applied	\N	\N	\N	\N	137031	137031	304593
17632	23497	68	applied	\N	\N	\N	\N	137032	137032	304594
17632	23498	69	applied	\N	\N	\N	\N	137033	137033	304595
17632	23499	70	applied	\N	\N	\N	\N	137034	137034	304596
17632	23500	71	applied	\N	\N	\N	\N	137035	137035	304597
17632	23501	72	applied	\N	\N	\N	\N	137036	137036	304598
17632	23508	73	applied	\N	\N	\N	\N	137037	137037	304599
17632	23509	74	applied	\N	\N	\N	\N	137038	137038	304600
17632	23510	75	applied	\N	\N	\N	\N	137039	137039	304601
17632	23511	76	applied	\N	\N	\N	\N	137040	137040	304602
17632	23512	77	applied	\N	\N	\N	\N	137041	137041	304603
17632	23513	78	applied	\N	\N	\N	\N	137042	137042	304604
17632	23514	79	applied	\N	\N	\N	\N	137043	137043	304605
17632	23515	80	applied	\N	\N	\N	\N	137044	137044	304606
17632	23516	81	applied	\N	\N	\N	\N	137045	137045	304607
17632	23518	83	applied	\N	\N	\N	\N	137047	137047	304609
17632	23523	84	applied	\N	\N	\N	\N	137048	137048	304610
17632	23524	85	applied	\N	\N	\N	\N	137049	137049	304611
17632	23525	86	applied	\N	\N	\N	\N	137050	137050	304612
17632	23526	87	applied	\N	\N	\N	\N	137051	137051	304613
17632	23527	88	applied	\N	\N	\N	\N	137052	137052	304614
17632	23528	89	applied	\N	\N	\N	\N	137053	137053	304615
17632	23532	90	applied	\N	\N	\N	\N	137054	137054	304616
17670	23199	12	applied	\N	\N	\N	\N	137471	137471	305033
17670	23209	13	applied	\N	\N	\N	\N	137472	137472	305034
17670	23212	14	applied	\N	\N	\N	\N	137473	137473	305035
17670	23213	15	applied	\N	\N	\N	\N	137474	137474	305036
17670	23219	16	applied	\N	\N	\N	\N	137475	137475	305037
17670	23220	17	applied	\N	\N	\N	\N	137476	137476	305038
17670	23226	18	applied	\N	\N	\N	\N	137477	137477	305039
17670	23229	19	applied	\N	\N	\N	\N	137478	137478	305040
17609	23831	3	applied	\N	\N	\N	\N	136888	136888	304450
17628	23852	5	applied	\N	\N	\N	\N	136955	136955	304517
17630	23853	0	applied	\N	\N	\N	\N	136959	136959	304521
17630	23854	1	applied	\N	\N	\N	\N	136960	136960	304522
17630	23855	2	applied	\N	\N	\N	\N	136961	136961	304523
17632	23533	91	applied	\N	\N	\N	\N	137055	137055	304617
17632	23534	92	applied	\N	\N	\N	\N	137056	137056	304618
17632	23535	93	applied	\N	\N	\N	\N	137057	137057	304619
17632	23537	95	applied	\N	\N	\N	\N	137059	137059	304621
17632	23540	96	applied	\N	\N	\N	\N	137060	137060	304622
17632	23541	97	applied	\N	\N	\N	\N	137061	137061	304623
17632	23549	98	applied	\N	\N	\N	\N	137062	137062	304624
17634	23859	0	applied	\N	\N	\N	\N	137093	137093	304655
17634	23860	1	applied	\N	\N	\N	\N	137094	137094	304656
17634	23861	2	applied	\N	\N	\N	\N	137095	137095	304657
17637	23862	0	applied	\N	\N	\N	\N	137102	137102	304664
17637	23863	1	applied	\N	\N	\N	\N	137103	137103	304665
17637	23864	2	applied	\N	\N	\N	\N	137104	137104	304666
17646	23876	0	applied	\N	\N	1000000000	\N	137261	137261	304823
17646	23877	1	applied	\N	\N	\N	\N	137262	137262	304824
17646	23878	2	applied	\N	\N	1000000000	\N	137263	137263	304825
17646	23879	3	applied	\N	\N	1000000000	\N	137264	137264	304826
17646	23881	5	applied	\N	\N	\N	\N	137266	137266	304828
17646	23882	6	applied	\N	\N	\N	\N	137267	137267	304829
17655	23892	0	applied	\N	\N	\N	\N	137421	137421	304983
17655	23894	1	applied	\N	\N	\N	\N	137422	137422	304984
17655	23893	2	applied	\N	\N	\N	\N	137423	137423	304985
17655	23895	3	applied	\N	\N	\N	\N	137424	137424	304986
17663	23904	0	applied	\N	\N	\N	\N	137443	137443	305005
17663	23905	1	applied	\N	\N	\N	\N	137444	137444	305006
17663	23906	2	applied	\N	\N	\N	\N	137445	137445	305007
17663	23907	3	applied	\N	\N	\N	\N	137446	137446	305008
17666	23908	0	applied	\N	\N	\N	\N	137451	137451	305013
17666	23909	1	applied	\N	\N	\N	\N	137452	137452	305014
17672	23914	0	applied	\N	\N	\N	\N	137586	137586	305148
17672	23915	1	applied	\N	\N	\N	\N	137587	137587	305149
17673	23916	0	applied	\N	\N	\N	\N	137588	137588	305150
17673	23917	1	applied	\N	\N	\N	\N	137589	137589	305151
17673	23918	2	applied	\N	\N	\N	\N	137590	137590	305152
17673	23919	3	applied	\N	\N	\N	\N	137591	137591	305153
17673	23920	4	applied	\N	\N	\N	\N	137592	137592	305154
17673	23921	5	applied	\N	\N	\N	\N	137593	137593	305155
17673	23923	7	applied	\N	\N	\N	\N	137595	137595	305157
17673	23924	8	applied	\N	\N	\N	\N	137596	137596	305158
17673	23925	9	applied	\N	\N	\N	\N	137597	137597	305159
17675	23926	0	applied	\N	\N	\N	\N	137608	137608	305170
17675	23927	1	applied	\N	\N	\N	\N	137609	137609	305171
17684	23934	0	applied	\N	\N	1000000000	\N	137631	137631	305193
17684	23935	1	applied	\N	\N	\N	\N	137632	137632	305194
17684	23936	2	applied	\N	\N	\N	\N	137633	137633	305195
17687	23937	0	applied	\N	\N	\N	\N	137645	137645	305207
17687	23938	1	applied	\N	\N	\N	\N	137646	137646	305208
17693	23957	0	applied	\N	\N	\N	\N	137691	137691	305253
17693	23958	1	applied	\N	\N	\N	\N	137692	137692	305254
17693	23959	2	applied	\N	\N	\N	\N	137693	137693	305255
17693	23960	3	applied	\N	\N	\N	\N	137694	137694	305256
17699	23972	0	applied	\N	\N	\N	\N	137711	137711	305273
17704	23971	0	applied	\N	\N	\N	\N	137720	137720	305282
17707	23975	0	applied	\N	\N	\N	\N	137727	137727	305289
17707	23976	1	applied	\N	\N	\N	\N	137728	137728	305290
17710	23979	0	applied	\N	\N	\N	\N	137733	137733	305295
17710	23980	1	applied	\N	\N	\N	\N	137734	137734	305296
17713	23981	0	applied	\N	\N	\N	\N	137740	137740	305302
17713	23982	1	applied	\N	\N	\N	\N	137741	137741	305303
17713	23983	2	applied	\N	\N	\N	\N	137742	137742	305304
17713	23984	3	applied	\N	\N	\N	\N	137743	137743	305305
17715	23985	0	applied	\N	\N	\N	\N	137748	137748	305310
17715	23986	1	applied	\N	\N	\N	\N	137749	137749	305311
17715	23987	2	applied	\N	\N	\N	\N	137750	137750	305312
17715	23988	3	applied	\N	\N	\N	\N	137751	137751	305313
17717	23989	0	applied	\N	\N	\N	\N	137756	137756	305318
17717	23990	1	applied	\N	\N	\N	\N	137757	137757	305319
17717	23991	2	applied	\N	\N	\N	\N	137758	137758	305320
17717	23992	3	applied	\N	\N	\N	\N	137759	137759	305321
17722	24001	1	applied	\N	\N	\N	\N	137789	137789	305351
17727	24008	0	applied	\N	\N	\N	\N	137802	137802	305364
17727	24009	1	applied	\N	\N	\N	\N	137803	137803	305365
17727	24010	2	applied	\N	\N	\N	\N	137804	137804	305366
17727	24011	3	applied	\N	\N	\N	\N	137805	137805	305367
17727	24012	4	applied	\N	\N	\N	\N	137806	137806	305368
17727	24013	5	applied	\N	\N	\N	\N	137807	137807	305369
17727	24014	6	applied	\N	\N	\N	\N	137808	137808	305370
17732	24022	0	applied	\N	\N	\N	\N	137831	137831	305393
17732	24023	1	applied	\N	\N	\N	\N	137832	137832	305394
17732	24024	2	applied	\N	\N	\N	\N	137833	137833	305395
17732	24025	3	applied	\N	\N	\N	\N	137834	137834	305396
17732	24026	4	applied	\N	\N	\N	\N	137835	137835	305397
17732	24027	5	applied	\N	\N	\N	\N	137836	137836	305398
17739	24058	0	applied	\N	\N	\N	\N	137882	137882	305441
17739	24060	1	applied	\N	\N	\N	\N	137883	137883	305442
17749	24068	1	applied	\N	\N	\N	\N	137943	137943	305502
17749	24069	2	applied	\N	\N	\N	\N	137944	137944	305503
17749	24070	3	applied	\N	\N	\N	\N	137945	137945	305504
17757	24081	0	applied	\N	\N	\N	\N	138044	138044	305601
17757	24082	1	applied	\N	\N	\N	\N	138045	138045	305602
17757	24083	2	applied	\N	\N	\N	\N	138046	138046	305603
17757	24084	3	applied	\N	\N	\N	\N	138047	138047	305604
17757	24085	4	applied	\N	\N	\N	\N	138048	138048	305605
17757	24086	5	applied	\N	\N	\N	\N	138049	138049	305606
17757	24087	6	applied	\N	\N	\N	\N	138050	138050	305607
17757	24088	7	applied	\N	\N	\N	\N	138051	138051	305608
17757	24089	8	applied	\N	\N	\N	\N	138052	138052	305609
17757	24090	9	applied	\N	\N	\N	\N	138053	138053	305610
17757	24091	10	applied	\N	\N	\N	\N	138054	138054	305611
17757	24092	11	applied	\N	\N	\N	\N	138055	138055	305612
17759	24093	0	applied	\N	\N	\N	\N	138068	138068	305625
17759	24095	2	applied	\N	\N	\N	\N	138070	138070	305627
17761	24096	0	applied	\N	\N	\N	\N	138074	138074	305631
17761	24097	1	applied	\N	\N	\N	\N	138075	138075	305632
17761	24098	2	applied	\N	\N	\N	\N	138076	138076	305633
17628	23850	3	applied	\N	\N	\N	\N	136953	136953	304515
17628	23851	4	applied	\N	\N	\N	\N	136954	136954	304516
17632	23554	103	applied	\N	\N	\N	\N	137067	137067	304629
17632	23555	104	applied	\N	\N	\N	\N	137068	137068	304630
17632	23556	105	applied	\N	\N	\N	\N	137069	137069	304631
17632	23557	106	applied	\N	\N	\N	\N	137070	137070	304632
17632	23558	107	applied	\N	\N	\N	\N	137071	137071	304633
17632	22973	108	applied	\N	\N	\N	\N	137072	137072	304634
17632	22979	109	applied	\N	\N	\N	\N	137073	137073	304635
17632	22980	110	applied	\N	\N	\N	\N	137074	137074	304636
17632	22985	111	applied	\N	\N	\N	\N	137075	137075	304637
17632	22988	112	applied	\N	\N	\N	\N	137076	137076	304638
17632	22991	113	applied	\N	\N	\N	\N	137077	137077	304639
17632	22994	114	applied	\N	\N	\N	\N	137078	137078	304640
17632	22998	115	applied	\N	\N	\N	\N	137079	137079	304641
17632	22999	116	applied	\N	\N	\N	\N	137080	137080	304642
17632	23004	117	applied	\N	\N	\N	\N	137081	137081	304643
17632	23005	118	applied	\N	\N	\N	\N	137082	137082	304644
17632	23012	120	applied	\N	\N	\N	\N	137084	137084	304646
17632	23018	121	applied	\N	\N	\N	\N	137085	137085	304647
17632	23021	122	applied	\N	\N	\N	\N	137086	137086	304648
17632	23023	123	applied	\N	\N	\N	\N	137087	137087	304649
17632	23024	124	applied	\N	\N	\N	\N	137088	137088	304650
17632	23030	125	applied	\N	\N	\N	\N	137089	137089	304651
17633	23856	0	applied	\N	\N	\N	\N	137090	137090	304652
17633	23857	1	applied	\N	\N	\N	\N	137091	137091	304653
17633	23858	2	applied	\N	\N	\N	\N	137092	137092	304654
17636	23862	0	applied	\N	\N	\N	\N	137099	137099	304661
17636	23863	1	applied	\N	\N	\N	\N	137100	137100	304662
17636	23864	2	applied	\N	\N	\N	\N	137101	137101	304663
17639	23799	0	applied	\N	\N	\N	\N	137108	137108	304670
17639	23523	1	applied	\N	\N	\N	\N	137109	137109	304671
17639	23524	2	applied	\N	\N	\N	\N	137110	137110	304672
17639	23525	3	applied	\N	\N	\N	\N	137111	137111	304673
17639	23608	5	applied	\N	\N	\N	\N	137113	137113	304675
17639	23526	6	applied	\N	\N	\N	\N	137114	137114	304676
17639	23527	7	applied	\N	\N	\N	\N	137115	137115	304677
17639	23528	8	applied	\N	\N	\N	\N	137116	137116	304678
17639	23532	9	applied	\N	\N	\N	\N	137117	137117	304679
17639	23533	10	applied	\N	\N	\N	\N	137118	137118	304680
17639	23534	11	applied	\N	\N	\N	\N	137119	137119	304681
17639	23535	12	applied	\N	\N	\N	\N	137120	137120	304682
17639	23536	13	applied	\N	\N	\N	\N	137121	137121	304683
17639	23537	14	applied	\N	\N	\N	\N	137122	137122	304684
17639	23529	15	applied	\N	\N	\N	\N	137123	137123	304685
17639	23538	16	applied	\N	\N	\N	\N	137124	137124	304686
17639	23539	17	applied	\N	\N	\N	\N	137125	137125	304687
17639	23545	18	applied	\N	\N	\N	\N	137126	137126	304688
17639	23546	19	applied	\N	\N	\N	\N	137127	137127	304689
17639	23563	21	applied	\N	\N	\N	\N	137128	137128	304690
17639	23573	23	applied	\N	\N	\N	\N	137130	137130	304692
17639	23578	24	applied	\N	\N	\N	\N	137131	137131	304693
17639	23579	25	applied	\N	\N	\N	\N	137132	137132	304694
17639	23585	26	applied	\N	\N	\N	\N	137133	137133	304695
17639	23594	27	applied	\N	\N	\N	\N	137134	137134	304696
17639	23603	28	applied	\N	\N	\N	\N	137135	137135	304697
17639	23610	29	applied	\N	\N	\N	\N	137136	137136	304698
17639	23617	30	applied	\N	\N	\N	\N	137137	137137	304699
17639	23625	31	applied	\N	\N	\N	\N	137138	137138	304700
17639	23627	32	applied	\N	\N	\N	\N	137139	137139	304701
17639	23629	33	applied	\N	\N	\N	\N	137140	137140	304702
17639	23631	34	applied	\N	\N	\N	\N	137141	137141	304703
17639	23633	35	applied	\N	\N	\N	\N	137142	137142	304704
17639	23635	36	applied	\N	\N	\N	\N	137143	137143	304705
17639	23641	37	applied	\N	\N	\N	\N	137144	137144	304706
17639	23644	38	applied	\N	\N	\N	\N	137145	137145	304707
17639	23648	40	applied	\N	\N	\N	\N	137147	137147	304709
17639	23653	41	applied	\N	\N	\N	\N	137148	137148	304710
17639	23656	42	applied	\N	\N	\N	\N	137149	137149	304711
17639	23659	43	applied	\N	\N	\N	\N	137150	137150	304712
17639	23660	44	applied	\N	\N	\N	\N	137151	137151	304713
17639	23661	45	applied	\N	\N	\N	\N	137152	137152	304714
17639	23668	46	applied	\N	\N	\N	\N	137153	137153	304715
17639	23670	47	applied	\N	\N	\N	\N	137154	137154	304716
17639	23673	48	applied	\N	\N	\N	\N	137155	137155	304717
17639	23675	49	applied	\N	\N	\N	\N	137156	137156	304718
17639	23678	50	applied	\N	\N	\N	\N	137157	137157	304719
17639	23680	51	applied	\N	\N	\N	\N	137158	137158	304720
17639	23682	52	applied	\N	\N	\N	\N	137159	137159	304721
17639	23683	53	applied	\N	\N	\N	\N	137160	137160	304722
17639	23690	54	applied	\N	\N	\N	\N	137161	137161	304723
17639	23691	55	applied	\N	\N	\N	\N	137162	137162	304724
17639	23699	57	applied	\N	\N	\N	\N	137164	137164	304726
17639	23702	58	applied	\N	\N	\N	\N	137165	137165	304727
17639	23540	59	applied	\N	\N	\N	\N	137166	137166	304728
17639	23541	60	applied	\N	\N	\N	\N	137167	137167	304729
17639	23549	61	applied	\N	\N	\N	\N	137168	137168	304730
17639	23550	62	applied	\N	\N	\N	\N	137169	137169	304731
17639	23551	63	applied	\N	\N	\N	\N	137170	137170	304732
17639	23552	64	applied	\N	\N	\N	\N	137171	137171	304733
17639	23553	65	applied	\N	\N	\N	\N	137172	137172	304734
17639	23554	66	applied	\N	\N	\N	\N	137173	137173	304735
17639	23555	67	applied	\N	\N	\N	\N	137174	137174	304736
17639	23556	68	applied	\N	\N	\N	\N	137175	137175	304737
17639	23557	69	applied	\N	\N	\N	\N	137176	137176	304738
17639	23558	70	applied	\N	\N	\N	\N	137177	137177	304739
17639	23707	71	applied	\N	\N	\N	\N	137178	137178	304740
17639	23710	72	applied	\N	\N	\N	\N	137179	137179	304741
17639	23716	74	applied	\N	\N	\N	\N	137181	137181	304743
17639	23717	75	applied	\N	\N	\N	\N	137182	137182	304744
17639	23718	76	applied	\N	\N	\N	\N	137183	137183	304745
17639	23719	77	applied	\N	\N	\N	\N	137184	137184	304746
17639	23728	78	applied	\N	\N	\N	\N	137185	137185	304747
17639	23731	79	applied	\N	\N	\N	\N	137186	137186	304748
17775	24135	0	applied	\N	\N	\N	\N	138161	138161	305714
17775	24136	1	applied	\N	\N	\N	\N	138162	138162	305715
17775	24137	2	applied	\N	\N	\N	\N	138163	138163	305716
17775	24138	3	applied	\N	\N	\N	\N	138164	138164	305717
17775	24139	4	applied	\N	\N	\N	\N	138165	138165	305718
17775	24140	5	applied	\N	\N	\N	\N	138166	138166	305719
17775	24141	6	applied	\N	\N	\N	\N	138167	138167	305720
17775	24142	7	applied	\N	\N	\N	\N	138168	138168	305721
17632	23551	100	applied	\N	\N	\N	\N	137064	137064	304626
17632	23552	101	applied	\N	\N	\N	\N	137065	137065	304627
17639	23742	83	applied	\N	\N	\N	\N	137190	137190	304752
17639	23745	84	applied	\N	\N	\N	\N	137191	137191	304753
17639	23748	85	applied	\N	\N	\N	\N	137192	137192	304754
17639	23751	86	applied	\N	\N	\N	\N	137193	137193	304755
17639	23754	87	applied	\N	\N	\N	\N	137194	137194	304756
17639	23760	89	applied	\N	\N	\N	\N	137196	137196	304758
17639	23761	90	applied	\N	\N	\N	\N	137197	137197	304759
17639	23766	91	applied	\N	\N	\N	\N	137198	137198	304760
17639	23769	92	applied	\N	\N	\N	\N	137199	137199	304761
17639	23770	93	applied	\N	\N	\N	\N	137200	137200	304762
17639	23775	94	applied	\N	\N	\N	\N	137201	137201	304763
17639	23778	95	applied	\N	\N	\N	\N	137202	137202	304764
17639	23781	96	applied	\N	\N	\N	\N	137203	137203	304765
17639	23559	97	applied	\N	\N	\N	\N	137204	137204	304766
17639	23560	98	applied	\N	\N	\N	\N	137205	137205	304767
17639	23564	99	applied	\N	\N	\N	\N	137206	137206	304768
17639	23565	100	applied	\N	\N	\N	\N	137207	137207	304769
17639	23566	101	applied	\N	\N	\N	\N	137208	137208	304770
17639	23567	102	applied	\N	\N	\N	\N	137209	137209	304771
17639	23576	103	applied	\N	\N	\N	\N	137210	137210	304772
17639	23580	104	applied	\N	\N	\N	\N	137211	137211	304773
17639	23587	106	applied	\N	\N	\N	\N	137213	137213	304775
17639	23588	107	applied	\N	\N	\N	\N	137214	137214	304776
17639	23589	108	applied	\N	\N	\N	\N	137215	137215	304777
17639	23590	109	applied	\N	\N	\N	\N	137216	137216	304778
17639	23593	110	applied	\N	\N	\N	\N	137217	137217	304779
17639	23595	111	applied	\N	\N	\N	\N	137218	137218	304780
17639	23596	112	applied	\N	\N	\N	\N	137219	137219	304781
17639	23597	113	applied	\N	\N	\N	\N	137220	137220	304782
17639	23598	114	applied	\N	\N	\N	\N	137221	137221	304783
17639	23601	115	applied	\N	\N	\N	\N	137222	137222	304784
17639	23602	116	applied	\N	\N	\N	\N	137223	137223	304785
17639	23604	117	applied	\N	\N	\N	\N	137224	137224	304786
17639	23605	118	applied	\N	\N	\N	\N	137225	137225	304787
17639	23609	119	applied	\N	\N	\N	\N	137226	137226	304788
17639	23611	120	applied	\N	\N	\N	\N	137227	137227	304789
17639	23612	121	applied	\N	\N	\N	\N	137228	137228	304790
17639	23618	123	applied	\N	\N	\N	\N	137230	137230	304792
17639	23619	124	applied	\N	\N	\N	\N	137231	137231	304793
17639	23620	125	applied	\N	\N	\N	\N	137232	137232	304794
17641	23865	0	applied	\N	\N	\N	\N	137236	137236	304798
17641	23866	1	applied	\N	\N	\N	\N	137237	137237	304799
17641	23867	2	applied	\N	\N	\N	\N	137238	137238	304800
17643	23871	0	applied	\N	\N	1000000000	\N	137242	137242	304804
17643	23872	1	applied	\N	\N	\N	\N	137243	137243	304805
17643	23873	2	applied	\N	\N	\N	\N	137244	137244	304806
17643	23874	3	applied	\N	\N	\N	\N	137245	137245	304807
17643	23875	4	applied	\N	\N	\N	\N	137246	137246	304808
17648	23883	0	applied	\N	\N	\N	\N	137275	137275	304837
17648	23884	1	applied	\N	\N	\N	\N	137276	137276	304838
17648	23885	2	applied	\N	\N	\N	\N	137277	137277	304839
17648	23886	3	applied	\N	\N	\N	\N	137278	137278	304840
17648	23887	4	applied	\N	\N	\N	\N	137279	137279	304841
17648	23889	6	applied	\N	\N	\N	\N	137281	137281	304843
17651	23035	0	applied	\N	\N	\N	\N	137286	137286	304848
17651	23036	1	applied	\N	\N	\N	\N	137287	137287	304849
17651	23041	2	applied	\N	\N	\N	\N	137288	137288	304850
17651	23871	3	applied	\N	\N	1000000000	\N	137289	137289	304851
17651	23876	4	applied	\N	\N	1000000000	\N	137290	137290	304852
17651	23044	5	applied	\N	\N	\N	\N	137291	137291	304853
17651	23045	6	applied	\N	\N	\N	\N	137292	137292	304854
17651	23050	7	applied	\N	\N	\N	\N	137293	137293	304855
17651	23053	8	applied	\N	\N	\N	\N	137294	137294	304856
17651	23056	9	applied	\N	\N	\N	\N	137295	137295	304857
17651	23057	10	applied	\N	\N	\N	\N	137296	137296	304858
17651	23062	11	applied	\N	\N	\N	\N	137297	137297	304859
17651	23065	12	applied	\N	\N	\N	\N	137298	137298	304860
17651	23068	13	applied	\N	\N	\N	\N	137299	137299	304861
17651	23072	14	applied	\N	\N	\N	\N	137300	137300	304862
17651	23076	16	applied	\N	\N	\N	\N	137302	137302	304864
17651	23078	17	applied	\N	\N	\N	\N	137303	137303	304865
17651	23081	18	applied	\N	\N	\N	\N	137304	137304	304866
17651	23084	19	applied	\N	\N	\N	\N	137305	137305	304867
17651	23087	20	applied	\N	\N	\N	\N	137306	137306	304868
17651	23090	21	applied	\N	\N	\N	\N	137307	137307	304869
17651	23093	22	applied	\N	\N	\N	\N	137308	137308	304870
17651	23094	23	applied	\N	\N	\N	\N	137309	137309	304871
17651	23099	24	applied	\N	\N	\N	\N	137310	137310	304872
17651	23100	25	applied	\N	\N	\N	\N	137311	137311	304873
17651	23101	26	applied	\N	\N	\N	\N	137312	137312	304874
17651	23108	27	applied	\N	\N	\N	\N	137313	137313	304875
17651	23109	28	applied	\N	\N	\N	\N	137314	137314	304876
17651	23114	29	applied	\N	\N	\N	\N	137315	137315	304877
17651	23117	30	applied	\N	\N	\N	\N	137316	137316	304878
17651	23119	31	applied	\N	\N	\N	\N	137317	137317	304879
17651	23123	33	applied	\N	\N	\N	\N	137319	137319	304881
17651	23124	34	applied	\N	\N	\N	\N	137320	137320	304882
17651	23131	35	applied	\N	\N	\N	\N	137321	137321	304883
17651	23134	36	applied	\N	\N	\N	\N	137322	137322	304884
17651	23878	37	applied	\N	\N	1000000000	\N	137323	137323	304885
17651	23879	38	applied	\N	\N	1000000000	\N	137324	137324	304886
17651	23880	39	applied	\N	\N	1000000000	\N	137325	137325	304887
17651	23135	40	applied	\N	\N	\N	\N	137326	137326	304888
17651	23136	41	applied	\N	\N	\N	\N	137327	137327	304889
17651	23137	42	applied	\N	\N	\N	\N	137328	137328	304890
17651	23146	43	applied	\N	\N	\N	\N	137329	137329	304891
17651	23149	44	applied	\N	\N	\N	\N	137330	137330	304892
17651	23150	45	applied	\N	\N	\N	\N	137331	137331	304893
17651	23155	46	applied	\N	\N	\N	\N	137332	137332	304894
17651	23159	47	applied	\N	\N	\N	\N	137333	137333	304895
17651	23160	48	applied	\N	\N	\N	\N	137334	137334	304896
17651	23168	51	applied	\N	\N	\N	\N	137336	137336	304898
17651	23170	52	applied	\N	\N	\N	\N	137337	137337	304899
17651	23174	53	applied	\N	\N	\N	\N	137338	137338	304900
17651	23176	54	applied	\N	\N	\N	\N	137339	137339	304901
17651	23179	55	applied	\N	\N	\N	\N	137340	137340	304902
17651	23181	56	applied	\N	\N	\N	\N	137341	137341	304903
17651	23184	57	applied	\N	\N	\N	\N	137342	137342	304904
17651	23187	58	applied	\N	\N	\N	\N	137343	137343	304905
17639	23735	81	applied	\N	\N	\N	\N	137188	137188	304750
17639	23740	82	applied	\N	\N	\N	\N	137189	137189	304751
17647	23882	6	applied	\N	\N	\N	\N	137274	137274	304836
17650	23890	0	applied	\N	\N	\N	\N	137284	137284	304846
17650	23891	2	applied	\N	\N	\N	\N	137285	137285	304847
17651	23189	59	applied	\N	\N	\N	\N	137344	137344	304906
17651	23193	60	applied	\N	\N	\N	\N	137345	137345	304907
17651	23194	61	applied	\N	\N	\N	\N	137346	137346	304908
17651	23199	62	applied	\N	\N	\N	\N	137347	137347	304909
17651	23209	63	applied	\N	\N	\N	\N	137348	137348	304910
17651	23212	64	applied	\N	\N	\N	\N	137349	137349	304911
17651	23213	65	applied	\N	\N	\N	\N	137350	137350	304912
17651	23219	66	applied	\N	\N	\N	\N	137351	137351	304913
17654	23894	0	applied	\N	\N	\N	\N	137419	137419	304981
17654	23895	1	applied	\N	\N	\N	\N	137420	137420	304982
17657	23896	0	applied	\N	\N	\N	\N	137427	137427	304989
17657	23897	1	applied	\N	\N	\N	\N	137428	137428	304990
17661	23900	0	applied	\N	\N	\N	\N	137435	137435	304997
17661	23901	1	applied	\N	\N	\N	\N	137436	137436	304998
17661	23902	2	applied	\N	\N	\N	\N	137437	137437	304999
17664	23908	0	applied	\N	\N	\N	\N	137447	137447	305009
17664	23909	1	applied	\N	\N	\N	\N	137448	137448	305010
17668	23910	0	applied	\N	\N	\N	\N	137455	137455	305017
17668	23911	1	applied	\N	\N	\N	\N	137456	137456	305018
17677	23926	0	applied	\N	\N	\N	\N	137612	137612	305174
17677	23927	1	applied	\N	\N	\N	\N	137613	137613	305175
17681	23932	0	applied	\N	\N	\N	\N	137624	137624	305186
17681	23933	1	applied	\N	\N	\N	\N	137625	137625	305187
17683	23934	0	applied	\N	\N	1000000000	\N	137628	137628	305190
17683	23935	1	applied	\N	\N	\N	\N	137629	137629	305191
17683	23936	2	applied	\N	\N	\N	\N	137630	137630	305192
17686	23799	0	applied	\N	\N	\N	\N	137636	137636	305198
17686	23871	1	applied	\N	\N	1000000000	\N	137637	137637	305199
17686	23876	2	applied	\N	\N	1000000000	\N	137638	137638	305200
17686	23879	4	applied	\N	\N	1000000000	\N	137640	137640	305202
17686	23880	5	applied	\N	\N	1000000000	\N	137641	137641	305203
17686	23934	6	applied	\N	\N	1000000000	\N	137642	137642	305204
17686	23676	7	applied	\N	\N	\N	\N	137643	137643	305205
17686	23873	8	applied	\N	\N	\N	\N	137644	137644	305206
17688	23799	0	applied	\N	\N	\N	\N	137647	137647	305209
17688	23871	1	applied	\N	\N	1000000000	\N	137648	137648	305210
17688	23876	2	applied	\N	\N	1000000000	\N	137649	137649	305211
17688	23878	3	applied	\N	\N	1000000000	\N	137650	137650	305212
17688	23879	4	applied	\N	\N	1000000000	\N	137651	137651	305213
17688	23880	5	applied	\N	\N	1000000000	\N	137652	137652	305214
17688	23934	6	applied	\N	\N	1000000000	\N	137653	137653	305215
17688	23873	7	applied	\N	\N	\N	\N	137654	137654	305216
17690	23939	0	applied	\N	\N	\N	\N	137671	137671	305233
17690	23940	1	applied	\N	\N	\N	\N	137672	137672	305234
17690	23941	2	applied	\N	\N	\N	\N	137673	137673	305235
17690	23942	3	applied	\N	\N	\N	\N	137674	137674	305236
17690	23943	4	applied	\N	\N	\N	\N	137675	137675	305237
17690	23944	5	applied	\N	\N	\N	\N	137676	137676	305238
17690	23945	6	applied	\N	\N	\N	\N	137677	137677	305239
17690	23947	8	applied	\N	\N	\N	\N	137679	137679	305241
17690	23948	9	applied	\N	\N	\N	\N	137680	137680	305242
17690	23949	10	applied	\N	\N	\N	\N	137681	137681	305243
17690	23950	11	applied	\N	\N	\N	\N	137682	137682	305244
17690	23951	12	applied	\N	\N	\N	\N	137683	137683	305245
17690	23952	13	applied	\N	\N	\N	\N	137684	137684	305246
17690	23953	14	applied	\N	\N	\N	\N	137685	137685	305247
17690	23954	15	applied	\N	\N	\N	\N	137686	137686	305248
17692	23955	0	applied	\N	\N	\N	\N	137689	137689	305251
17692	23956	1	applied	\N	\N	\N	\N	137690	137690	305252
17700	23971	0	applied	\N	\N	\N	\N	137712	137712	305274
17700	23972	1	applied	\N	\N	\N	\N	137713	137713	305275
17702	23971	0	applied	\N	\N	\N	\N	137716	137716	305278
17702	23973	1	applied	\N	\N	\N	\N	137717	137717	305279
17702	23974	2	applied	\N	\N	\N	\N	137718	137718	305280
17706	23973	0	applied	\N	\N	\N	\N	137725	137725	305287
17711	23981	0	applied	\N	\N	\N	\N	137735	137735	305297
17711	23982	1	applied	\N	\N	\N	\N	137736	137736	305298
17711	23983	2	applied	\N	\N	\N	\N	137737	137737	305299
17711	23984	3	applied	\N	\N	\N	\N	137738	137738	305300
17719	23993	0	applied	\N	\N	1000000000	\N	137767	137767	305329
17719	23994	1	applied	\N	\N	\N	\N	137768	137768	305330
17719	23995	2	applied	\N	\N	\N	\N	137769	137769	305331
17719	23996	3	applied	\N	\N	\N	\N	137770	137770	305332
17719	23997	4	applied	\N	\N	\N	\N	137771	137771	305333
17719	23998	5	applied	\N	\N	\N	\N	137772	137772	305334
17719	23999	6	applied	\N	\N	\N	\N	137773	137773	305335
17721	23993	0	applied	\N	\N	1000000000	\N	137781	137781	305343
17721	23994	1	applied	\N	\N	\N	\N	137782	137782	305344
17721	23995	2	applied	\N	\N	\N	\N	137783	137783	305345
17721	23996	3	applied	\N	\N	\N	\N	137784	137784	305346
17721	23997	4	applied	\N	\N	\N	\N	137785	137785	305347
17721	23999	6	applied	\N	\N	\N	\N	137787	137787	305349
17723	24002	0	applied	\N	\N	\N	\N	137790	137790	305352
17723	24003	1	applied	\N	\N	\N	\N	137791	137791	305353
17723	24004	2	applied	\N	\N	\N	\N	137792	137792	305354
17726	24005	0	applied	\N	\N	\N	\N	137799	137799	305361
17726	24006	1	applied	\N	\N	\N	\N	137800	137800	305362
17726	24007	2	applied	\N	\N	\N	\N	137801	137801	305363
17728	24015	0	applied	\N	\N	\N	\N	137809	137809	305371
17728	24016	1	applied	\N	\N	\N	\N	137810	137810	305372
17728	24017	2	applied	\N	\N	\N	\N	137811	137811	305373
17731	24020	0	applied	\N	\N	\N	\N	137827	137827	305389
17731	24021	1	applied	\N	\N	\N	\N	137828	137828	305390
17731	24019	2	applied	\N	\N	\N	\N	137829	137829	305391
17731	24018	3	applied	\N	\N	\N	\N	137830	137830	305392
17734	24036	0	applied	\N	\N	\N	\N	137845	137845	305406
17734	24037	1	applied	\N	\N	\N	\N	137846	137846	137846
17734	24039	3	applied	\N	\N	\N	\N	137848	137848	305408
17734	24040	4	applied	\N	\N	\N	\N	137849	137849	305409
17734	24041	5	applied	\N	\N	\N	\N	137850	137850	305410
17734	24042	6	applied	\N	\N	\N	\N	137851	137851	305411
17737	24054	0	applied	\N	\N	\N	\N	137870	137870	305429
17737	24055	1	applied	\N	\N	\N	\N	137871	137871	305430
17737	24056	2	applied	\N	\N	\N	\N	137872	137872	305431
17737	24057	3	applied	\N	\N	\N	\N	137873	137873	305432
17647	23880	4	applied	\N	\N	1000000000	\N	137272	137272	304834
17647	23881	5	applied	\N	\N	\N	\N	137273	137273	304835
17651	23235	71	applied	\N	\N	\N	\N	137356	137356	304918
17651	23238	72	applied	\N	\N	\N	\N	137357	137357	304919
17651	23241	73	applied	\N	\N	\N	\N	137358	137358	304920
17651	23244	74	applied	\N	\N	\N	\N	137359	137359	304921
17651	23247	75	applied	\N	\N	\N	\N	137360	137360	304922
17651	23249	76	applied	\N	\N	\N	\N	137361	137361	304923
17651	23252	77	applied	\N	\N	\N	\N	137362	137362	304924
17651	23254	78	applied	\N	\N	\N	\N	137363	137363	304925
17651	23255	79	applied	\N	\N	\N	\N	137364	137364	304926
17651	23263	81	applied	\N	\N	\N	\N	137366	137366	304928
17651	23266	82	applied	\N	\N	\N	\N	137367	137367	304929
17651	23269	83	applied	\N	\N	\N	\N	137368	137368	304930
17651	23270	84	applied	\N	\N	\N	\N	137369	137369	304931
17651	23274	85	applied	\N	\N	\N	\N	137370	137370	304932
17651	23275	86	applied	\N	\N	\N	\N	137371	137371	304933
17651	23280	87	applied	\N	\N	\N	\N	137372	137372	304934
17651	23282	88	applied	\N	\N	\N	\N	137373	137373	304935
17651	23285	89	applied	\N	\N	\N	\N	137374	137374	304936
17651	23288	90	applied	\N	\N	\N	\N	137375	137375	304937
17651	23291	91	applied	\N	\N	\N	\N	137376	137376	304938
17651	23292	92	applied	\N	\N	\N	\N	137377	137377	304939
17651	23297	93	applied	\N	\N	\N	\N	137378	137378	304940
17651	23298	94	applied	\N	\N	\N	\N	137379	137379	304941
17651	23299	95	applied	\N	\N	\N	\N	137380	137380	304942
17651	23305	96	applied	\N	\N	\N	\N	137381	137381	304943
17651	23311	98	applied	\N	\N	\N	\N	137383	137383	304945
17651	23315	99	applied	\N	\N	\N	\N	137384	137384	304946
17651	23317	100	applied	\N	\N	\N	\N	137385	137385	304947
17651	23320	101	applied	\N	\N	\N	\N	137386	137386	304948
17651	23321	102	applied	\N	\N	\N	\N	137387	137387	304949
17651	23322	103	applied	\N	\N	\N	\N	137388	137388	304950
17651	23323	104	applied	\N	\N	\N	\N	137389	137389	304951
17651	23332	105	applied	\N	\N	\N	\N	137390	137390	304952
17651	23333	106	applied	\N	\N	\N	\N	137391	137391	304953
17651	23340	107	applied	\N	\N	\N	\N	137392	137392	304954
17651	23341	108	applied	\N	\N	\N	\N	137393	137393	304955
17651	23345	109	applied	\N	\N	\N	\N	137394	137394	304956
17651	23347	110	applied	\N	\N	\N	\N	137395	137395	304957
17651	23348	111	applied	\N	\N	\N	\N	137396	137396	304958
17651	23349	112	applied	\N	\N	\N	\N	137397	137397	304959
17651	23356	113	applied	\N	\N	\N	\N	137398	137398	304960
17651	23358	115	applied	\N	\N	\N	\N	137400	137400	304962
17651	23367	116	applied	\N	\N	\N	\N	137401	137401	304963
17651	23370	117	applied	\N	\N	\N	\N	137402	137402	304964
17651	23373	118	applied	\N	\N	\N	\N	137403	137403	304965
17651	23376	119	applied	\N	\N	\N	\N	137404	137404	304966
17651	23377	120	applied	\N	\N	\N	\N	137405	137405	304967
17651	23382	121	applied	\N	\N	\N	\N	137406	137406	304968
17651	23383	122	applied	\N	\N	\N	\N	137407	137407	304969
17651	23387	123	applied	\N	\N	\N	\N	137408	137408	304970
17651	23399	124	applied	\N	\N	\N	\N	137409	137409	304971
17651	23400	125	applied	\N	\N	\N	\N	137410	137410	304972
17653	23871	0	applied	\N	\N	1000000000	\N	137413	137413	304975
17653	23876	1	applied	\N	\N	1000000000	\N	137414	137414	304976
17653	23878	2	applied	\N	\N	1000000000	\N	137415	137415	304977
17653	23880	4	applied	\N	\N	1000000000	\N	137417	137417	304979
17653	23873	5	applied	\N	\N	\N	\N	137418	137418	304980
17658	23896	0	applied	\N	\N	\N	\N	137429	137429	304991
17658	23897	1	applied	\N	\N	\N	\N	137430	137430	304992
17659	23898	0	applied	\N	\N	\N	\N	137431	137431	304993
17659	23899	1	applied	\N	\N	\N	\N	137432	137432	304994
17662	23904	0	applied	\N	\N	\N	\N	137439	137439	305001
17662	23905	1	applied	\N	\N	\N	\N	137440	137440	305002
17662	23906	2	applied	\N	\N	\N	\N	137441	137441	305003
17662	23907	3	applied	\N	\N	\N	\N	137442	137442	305004
17665	23908	0	applied	\N	\N	\N	\N	137449	137449	305011
17665	23909	1	applied	\N	\N	\N	\N	137450	137450	305012
17669	23912	0	applied	\N	\N	\N	\N	137457	137457	305019
17669	23913	1	applied	\N	\N	\N	\N	137458	137458	305020
17671	23914	0	applied	\N	\N	\N	\N	137584	137584	305146
17671	23915	1	applied	\N	\N	\N	\N	137585	137585	305147
17678	23871	0	applied	\N	\N	1000000000	\N	137614	137614	305176
17678	23876	1	applied	\N	\N	1000000000	\N	137615	137615	305177
17678	23879	3	applied	\N	\N	1000000000	\N	137617	137617	305179
17678	23880	4	applied	\N	\N	1000000000	\N	137618	137618	305180
17678	23873	5	applied	\N	\N	\N	\N	137619	137619	305181
17679	23928	0	applied	\N	\N	\N	\N	137620	137620	305182
17679	23929	1	applied	\N	\N	\N	\N	137621	137621	305183
17682	23932	0	applied	\N	\N	\N	\N	137626	137626	305188
17682	23933	1	applied	\N	\N	\N	\N	137627	137627	305189
17695	23961	0	applied	\N	\N	\N	\N	137699	137699	305261
17695	23962	1	applied	\N	\N	\N	\N	137700	137700	305262
17698	23971	0	applied	\N	\N	\N	\N	137709	137709	305271
17698	23972	1	applied	\N	\N	\N	\N	137710	137710	305272
17701	23971	0	applied	\N	\N	\N	\N	137714	137714	305276
17701	23972	1	applied	\N	\N	\N	\N	137715	137715	305277
17703	23934	0	applied	\N	\N	1000000000	\N	137719	137719	305281
17709	23979	0	applied	\N	\N	\N	\N	137731	137731	305293
17709	23980	1	applied	\N	\N	\N	\N	137732	137732	305294
17712	23934	0	applied	\N	\N	1000000000	\N	137739	137739	305301
17714	23985	0	applied	\N	\N	\N	\N	137744	137744	305306
17714	23986	1	applied	\N	\N	\N	\N	137745	137745	305307
17714	23987	2	applied	\N	\N	\N	\N	137746	137746	305308
17724	24002	0	applied	\N	\N	\N	\N	137793	137793	305355
17724	24003	1	applied	\N	\N	\N	\N	137794	137794	305356
17724	24004	2	applied	\N	\N	\N	\N	137795	137795	305357
17729	23996	0	applied	\N	\N	\N	\N	137812	137812	305374
17729	23998	1	applied	\N	\N	\N	\N	137813	137813	305375
17729	24001	2	applied	\N	\N	\N	\N	137814	137814	305376
17729	24003	3	applied	\N	\N	\N	\N	137815	137815	305377
17737	24058	4	applied	\N	\N	\N	\N	137874	137874	305433
17737	24059	6	applied	\N	\N	\N	\N	137875	137875	305434
17737	24060	7	applied	\N	\N	\N	\N	137876	137876	305435
17745	24054	0	applied	\N	\N	\N	\N	137919	137919	305478
17745	24055	1	applied	\N	\N	\N	\N	137920	137920	305479
17745	24058	2	applied	\N	\N	\N	\N	137921	137921	305480
17745	24059	3	applied	\N	\N	\N	\N	137922	137922	305481
17745	24060	4	applied	\N	\N	\N	\N	137923	137923	305482
17651	23226	68	applied	\N	\N	\N	\N	137353	137353	304915
17651	23232	70	applied	\N	\N	\N	\N	137355	137355	304917
17670	23244	24	applied	\N	\N	\N	\N	137483	137483	305045
17670	23247	25	applied	\N	\N	\N	\N	137484	137484	305046
17670	23249	26	applied	\N	\N	\N	\N	137485	137485	305047
17670	23252	27	applied	\N	\N	\N	\N	137486	137486	305048
17670	23254	28	applied	\N	\N	\N	\N	137487	137487	305049
17670	23255	29	applied	\N	\N	\N	\N	137488	137488	305050
17670	23256	30	applied	\N	\N	\N	\N	137489	137489	305051
17670	23263	31	applied	\N	\N	\N	\N	137490	137490	305052
17670	23266	32	applied	\N	\N	\N	\N	137491	137491	305053
17670	23269	33	applied	\N	\N	\N	\N	137492	137492	305054
17670	23270	34	applied	\N	\N	\N	\N	137493	137493	305055
17670	23274	36	applied	\N	\N	\N	\N	137494	137494	305056
17670	23275	37	applied	\N	\N	\N	\N	137495	137495	305057
17670	23280	38	applied	\N	\N	\N	\N	137496	137496	305058
17670	23282	39	applied	\N	\N	\N	\N	137497	137497	305059
17670	23285	40	applied	\N	\N	\N	\N	137498	137498	305060
17670	23291	42	applied	\N	\N	\N	\N	137500	137500	305062
17670	23292	43	applied	\N	\N	\N	\N	137501	137501	305063
17670	23297	44	applied	\N	\N	\N	\N	137502	137502	305064
17670	23298	45	applied	\N	\N	\N	\N	137503	137503	305065
17670	23299	46	applied	\N	\N	\N	\N	137504	137504	305066
17670	23305	47	applied	\N	\N	\N	\N	137505	137505	305067
17670	23306	48	applied	\N	\N	\N	\N	137506	137506	305068
17670	23311	49	applied	\N	\N	\N	\N	137507	137507	305069
17670	23315	50	applied	\N	\N	\N	\N	137508	137508	305070
17670	23317	51	applied	\N	\N	\N	\N	137509	137509	305071
17670	23320	52	applied	\N	\N	\N	\N	137510	137510	305072
17670	23321	53	applied	\N	\N	\N	\N	137511	137511	305073
17670	23322	54	applied	\N	\N	\N	\N	137512	137512	305074
17670	23323	55	applied	\N	\N	\N	\N	137513	137513	305075
17670	23332	56	applied	\N	\N	\N	\N	137514	137514	305076
17670	23333	57	applied	\N	\N	\N	\N	137515	137515	305077
17670	23341	59	applied	\N	\N	\N	\N	137517	137517	305079
17670	23345	60	applied	\N	\N	\N	\N	137518	137518	305080
17670	23347	61	applied	\N	\N	\N	\N	137519	137519	305081
17670	23348	62	applied	\N	\N	\N	\N	137520	137520	305082
17670	23349	63	applied	\N	\N	\N	\N	137521	137521	305083
17670	23356	64	applied	\N	\N	\N	\N	137522	137522	305084
17670	23357	65	applied	\N	\N	\N	\N	137523	137523	305085
17670	23358	66	applied	\N	\N	\N	\N	137524	137524	305086
17670	23367	67	applied	\N	\N	\N	\N	137525	137525	305087
17670	23370	68	applied	\N	\N	\N	\N	137526	137526	305088
17670	23373	69	applied	\N	\N	\N	\N	137527	137527	305089
17670	23376	70	applied	\N	\N	\N	\N	137528	137528	305090
17670	23377	71	applied	\N	\N	\N	\N	137529	137529	305091
17670	23382	72	applied	\N	\N	\N	\N	137530	137530	305092
17670	23383	73	applied	\N	\N	\N	\N	137531	137531	305093
17670	23387	74	applied	\N	\N	\N	\N	137532	137532	305094
17670	23400	76	applied	\N	\N	\N	\N	137534	137534	305096
17670	23407	77	applied	\N	\N	\N	\N	137535	137535	305097
17670	23411	78	applied	\N	\N	\N	\N	137536	137536	305098
17670	23412	79	applied	\N	\N	\N	\N	137537	137537	305099
17670	23417	80	applied	\N	\N	\N	\N	137538	137538	305100
17670	23419	81	applied	\N	\N	\N	\N	137539	137539	305101
17670	23422	82	applied	\N	\N	\N	\N	137540	137540	305102
17670	23426	83	applied	\N	\N	\N	\N	137541	137541	305103
17670	23430	84	applied	\N	\N	\N	\N	137542	137542	305104
17670	23432	85	applied	\N	\N	\N	\N	137543	137543	305105
17670	23433	86	applied	\N	\N	\N	\N	137544	137544	305106
17670	23438	87	applied	\N	\N	\N	\N	137545	137545	305107
17670	23440	88	applied	\N	\N	\N	\N	137546	137546	305108
17670	23441	89	applied	\N	\N	\N	\N	137547	137547	305109
17670	23446	90	applied	\N	\N	\N	\N	137548	137548	305110
17670	23460	91	applied	\N	\N	\N	\N	137549	137549	305111
17670	23466	93	applied	\N	\N	\N	\N	137551	137551	305113
17670	23472	94	applied	\N	\N	\N	\N	137552	137552	305114
17670	23479	95	applied	\N	\N	\N	\N	137553	137553	305115
17670	23489	96	applied	\N	\N	\N	\N	137554	137554	305116
17670	23490	97	applied	\N	\N	\N	\N	137555	137555	305117
17670	23506	98	applied	\N	\N	\N	\N	137556	137556	305118
17670	23507	99	applied	\N	\N	\N	\N	137557	137557	305119
17670	23529	100	applied	\N	\N	\N	\N	137558	137558	305120
17670	23538	101	applied	\N	\N	\N	\N	137559	137559	305121
17670	23539	102	applied	\N	\N	\N	\N	137560	137560	305122
17670	23545	103	applied	\N	\N	\N	\N	137561	137561	305123
17670	23546	104	applied	\N	\N	\N	\N	137562	137562	305124
17670	23563	105	applied	\N	\N	\N	\N	137563	137563	305125
17670	23570	106	applied	\N	\N	\N	\N	137564	137564	305126
17670	23573	107	applied	\N	\N	\N	\N	137565	137565	305127
17670	23578	108	applied	\N	\N	\N	\N	137566	137566	305128
17670	23585	110	applied	\N	\N	\N	\N	137568	137568	305130
17670	23594	111	applied	\N	\N	\N	\N	137569	137569	305131
17670	23603	112	applied	\N	\N	\N	\N	137570	137570	305132
17670	23610	113	applied	\N	\N	\N	\N	137571	137571	305133
17670	23617	114	applied	\N	\N	\N	\N	137572	137572	305134
17670	23625	115	applied	\N	\N	\N	\N	137573	137573	305135
17670	23627	116	applied	\N	\N	\N	\N	137574	137574	305136
17670	23629	117	applied	\N	\N	\N	\N	137575	137575	305137
17670	23631	118	applied	\N	\N	\N	\N	137576	137576	305138
17670	23633	119	applied	\N	\N	\N	\N	137577	137577	305139
17670	23635	120	applied	\N	\N	\N	\N	137578	137578	305140
17670	23641	121	applied	\N	\N	\N	\N	137579	137579	305141
17670	23644	122	applied	\N	\N	\N	\N	137580	137580	305142
17670	23647	123	applied	\N	\N	\N	\N	137581	137581	305143
17670	23648	124	applied	\N	\N	\N	\N	137582	137582	305144
17670	23653	125	applied	\N	\N	\N	\N	137583	137583	305145
17674	23917	1	applied	\N	\N	\N	\N	137599	137599	305161
17674	23918	2	applied	\N	\N	\N	\N	137600	137600	305162
17674	23919	3	applied	\N	\N	\N	\N	137601	137601	305163
17674	23920	4	applied	\N	\N	\N	\N	137602	137602	305164
17674	23921	5	applied	\N	\N	\N	\N	137603	137603	305165
17674	23922	6	applied	\N	\N	\N	\N	137604	137604	305166
17729	24006	4	applied	\N	\N	\N	\N	137816	137816	305378
17729	24011	5	applied	\N	\N	\N	\N	137817	137817	305379
17729	24012	6	applied	\N	\N	\N	\N	137818	137818	305380
17729	24014	7	applied	\N	\N	\N	\N	137819	137819	305381
17729	24018	8	applied	\N	\N	\N	\N	137820	137820	305382
17729	24017	9	applied	\N	\N	\N	\N	137821	137821	305383
17729	24019	10	applied	\N	\N	\N	\N	137822	137822	305384
17735	24036	0	applied	\N	\N	\N	\N	137852	137852	305412
17670	23235	21	applied	\N	\N	\N	\N	137480	137480	305042
17670	23238	22	applied	\N	\N	\N	\N	137481	137481	305043
17676	23927	1	applied	\N	\N	\N	\N	137611	137611	305173
17680	23930	0	applied	\N	\N	\N	\N	137622	137622	305184
17680	23931	1	applied	\N	\N	\N	\N	137623	137623	305185
17685	23937	0	applied	\N	\N	\N	\N	137634	137634	305196
17685	23938	1	applied	\N	\N	\N	\N	137635	137635	305197
17689	23939	0	applied	\N	\N	\N	\N	137655	137655	305217
17689	23940	1	applied	\N	\N	\N	\N	137656	137656	305218
17689	23941	2	applied	\N	\N	\N	\N	137657	137657	305219
17689	23942	3	applied	\N	\N	\N	\N	137658	137658	305220
17689	23943	4	applied	\N	\N	\N	\N	137659	137659	305221
17689	23944	5	applied	\N	\N	\N	\N	137660	137660	305222
17689	23945	6	applied	\N	\N	\N	\N	137661	137661	305223
17689	23947	8	applied	\N	\N	\N	\N	137663	137663	305225
17689	23948	9	applied	\N	\N	\N	\N	137664	137664	305226
17689	23949	10	applied	\N	\N	\N	\N	137665	137665	305227
17689	23950	11	applied	\N	\N	\N	\N	137666	137666	305228
17689	23951	12	applied	\N	\N	\N	\N	137667	137667	305229
17689	23952	13	applied	\N	\N	\N	\N	137668	137668	305230
17689	23953	14	applied	\N	\N	\N	\N	137669	137669	305231
17689	23954	15	applied	\N	\N	\N	\N	137670	137670	305232
17691	23955	0	applied	\N	\N	\N	\N	137687	137687	305249
17691	23956	1	applied	\N	\N	\N	\N	137688	137688	305250
17694	23957	0	applied	\N	\N	\N	\N	137695	137695	305257
17694	23958	1	applied	\N	\N	\N	\N	137696	137696	305258
17694	23959	2	applied	\N	\N	\N	\N	137697	137697	305259
17694	23960	3	applied	\N	\N	\N	\N	137698	137698	305260
17696	23963	0	applied	\N	\N	\N	\N	137701	137701	305263
17696	23964	1	applied	\N	\N	\N	\N	137702	137702	305264
17697	23966	1	applied	\N	\N	\N	\N	137704	137704	305266
17697	23967	2	applied	\N	\N	\N	\N	137705	137705	305267
17697	23968	3	applied	\N	\N	\N	\N	137706	137706	305268
17697	23969	4	applied	\N	\N	\N	\N	137707	137707	305269
17697	23970	5	applied	\N	\N	\N	\N	137708	137708	305270
17705	23971	0	applied	\N	\N	\N	\N	137722	137722	305284
17705	23973	1	applied	\N	\N	\N	\N	137723	137723	305285
17705	23974	2	applied	\N	\N	\N	\N	137724	137724	305286
17708	23977	0	applied	\N	\N	\N	\N	137729	137729	305291
17708	23978	1	applied	\N	\N	\N	\N	137730	137730	305292
17716	23985	0	applied	\N	\N	\N	\N	137752	137752	305314
17716	23986	1	applied	\N	\N	\N	\N	137753	137753	305315
17716	23987	2	applied	\N	\N	\N	\N	137754	137754	305316
17716	23988	3	applied	\N	\N	\N	\N	137755	137755	305317
17718	23994	1	applied	\N	\N	\N	\N	137761	137761	305323
17718	23995	2	applied	\N	\N	\N	\N	137762	137762	305324
17718	23996	3	applied	\N	\N	\N	\N	137763	137763	305325
17718	23997	4	applied	\N	\N	\N	\N	137764	137764	305326
17718	23998	5	applied	\N	\N	\N	\N	137765	137765	305327
17718	23999	6	applied	\N	\N	\N	\N	137766	137766	305328
17720	23993	0	applied	\N	\N	1000000000	\N	137774	137774	305336
17720	23994	1	applied	\N	\N	\N	\N	137775	137775	305337
17720	23995	2	applied	\N	\N	\N	\N	137776	137776	305338
17720	23996	3	applied	\N	\N	\N	\N	137777	137777	305339
17720	23997	4	applied	\N	\N	\N	\N	137778	137778	305340
17720	23998	5	applied	\N	\N	\N	\N	137779	137779	305341
17720	23999	6	applied	\N	\N	\N	\N	137780	137780	305342
17725	24005	0	applied	\N	\N	\N	\N	137796	137796	305358
17725	24006	1	applied	\N	\N	\N	\N	137797	137797	305359
17725	24007	2	applied	\N	\N	\N	\N	137798	137798	305360
17730	24020	0	applied	\N	\N	\N	\N	137823	137823	305385
17730	24021	1	applied	\N	\N	\N	\N	137824	137824	305386
17730	24019	2	applied	\N	\N	\N	\N	137825	137825	305387
17730	24018	3	applied	\N	\N	\N	\N	137826	137826	305388
17733	24029	1	applied	\N	\N	\N	\N	137838	137838	305399
17733	24030	2	applied	\N	\N	\N	\N	137839	137839	305400
17733	24031	3	applied	\N	\N	\N	\N	137840	137840	305401
17733	24032	4	applied	\N	\N	\N	\N	137841	137841	305402
17733	24033	5	applied	\N	\N	\N	\N	137842	137842	305403
17733	24034	6	applied	\N	\N	\N	\N	137843	137843	305404
17733	24035	7	applied	\N	\N	\N	\N	137844	137844	305405
17736	24043	0	applied	\N	\N	\N	\N	137859	137859	305418
17736	24044	1	applied	\N	\N	\N	\N	137860	137860	305419
17736	24045	2	applied	\N	\N	\N	\N	137861	137861	305420
17736	24046	3	applied	\N	\N	\N	\N	137862	137862	305421
17736	24047	4	applied	\N	\N	\N	\N	137863	137863	305422
17736	24048	5	applied	\N	\N	\N	\N	137864	137864	305423
17736	24049	6	applied	\N	\N	\N	\N	137865	137865	305424
17736	24050	7	applied	\N	\N	\N	\N	137866	137866	305425
17736	24051	8	applied	\N	\N	\N	\N	137867	137867	305426
17736	24053	10	applied	\N	\N	\N	\N	137869	137869	305428
17740	24054	0	applied	\N	\N	\N	\N	137884	137884	305443
17740	24055	1	applied	\N	\N	\N	\N	137885	137885	305444
17740	24056	2	applied	\N	\N	\N	\N	137886	137886	305445
17740	24057	3	applied	\N	\N	\N	\N	137887	137887	305446
17740	24058	4	applied	\N	\N	\N	\N	137888	137888	305447
17740	24059	6	applied	\N	\N	\N	\N	137889	137889	305448
17740	24060	7	applied	\N	\N	\N	\N	137890	137890	305449
17742	24054	0	applied	\N	\N	\N	\N	137898	137898	305457
17742	24055	1	applied	\N	\N	\N	\N	137899	137899	305458
17742	24056	2	applied	\N	\N	\N	\N	137900	137900	305459
17742	24057	3	applied	\N	\N	\N	\N	137901	137901	305460
17742	24058	4	applied	\N	\N	\N	\N	137902	137902	305461
17742	24059	6	applied	\N	\N	\N	\N	137903	137903	305462
17742	24060	7	applied	\N	\N	\N	\N	137904	137904	305463
17744	24054	0	applied	\N	\N	\N	\N	137912	137912	305471
17744	24056	2	applied	\N	\N	\N	\N	137914	137914	305473
17744	24057	3	applied	\N	\N	\N	\N	137915	137915	305474
17744	24058	4	applied	\N	\N	\N	\N	137916	137916	305475
17744	24059	6	applied	\N	\N	\N	\N	137917	137917	305476
17744	24060	7	applied	\N	\N	\N	\N	137918	137918	305477
17747	24061	0	applied	\N	\N	\N	\N	137930	137930	305489
17747	24062	1	applied	\N	\N	\N	\N	137931	137931	305490
17747	24063	2	applied	\N	\N	\N	\N	137932	137932	305491
17747	24064	3	applied	\N	\N	\N	\N	137933	137933	305492
17747	24065	4	applied	\N	\N	\N	\N	137934	137934	305493
17747	24066	5	applied	\N	\N	\N	\N	137935	137935	305494
17750	24067	0	applied	\N	\N	\N	\N	137946	137946	305505
17750	24068	1	applied	\N	\N	\N	\N	137947	137947	305506
17750	24069	2	applied	\N	\N	\N	\N	137948	137948	305507
17750	24070	3	applied	\N	\N	\N	\N	137949	137949	305508
17674	23924	8	applied	\N	\N	\N	\N	137606	137606	305168
17676	23926	0	applied	\N	\N	\N	\N	137610	137610	305172
17735	24040	4	applied	\N	\N	\N	\N	137856	137856	305415
17735	24041	5	applied	\N	\N	\N	\N	137857	137857	305416
17735	24042	6	applied	\N	\N	\N	\N	137858	137858	305417
17738	24055	1	applied	\N	\N	\N	\N	137878	137878	305437
17738	24058	2	applied	\N	\N	\N	\N	137879	137879	305438
17738	24059	3	applied	\N	\N	\N	\N	137880	137880	305439
17738	24060	4	applied	\N	\N	\N	\N	137881	137881	305440
17741	24054	0	applied	\N	\N	\N	\N	137891	137891	305450
17741	24055	1	applied	\N	\N	\N	\N	137892	137892	305451
17741	24056	2	applied	\N	\N	\N	\N	137893	137893	305452
17741	24057	3	applied	\N	\N	\N	\N	137894	137894	305453
17741	24058	4	applied	\N	\N	\N	\N	137895	137895	305454
17741	24059	6	applied	\N	\N	\N	\N	137896	137896	305455
17741	24060	7	applied	\N	\N	\N	\N	137897	137897	305456
17743	24054	0	applied	\N	\N	\N	\N	137905	137905	305464
17743	24055	1	applied	\N	\N	\N	\N	137906	137906	305465
17743	24056	2	applied	\N	\N	\N	\N	137907	137907	305466
17743	24057	3	applied	\N	\N	\N	\N	137908	137908	305467
17743	24058	4	applied	\N	\N	\N	\N	137909	137909	305468
17743	24060	7	applied	\N	\N	\N	\N	137911	137911	305470
17746	24061	0	applied	\N	\N	\N	\N	137924	137924	305483
17746	24062	1	applied	\N	\N	\N	\N	137925	137925	305484
17746	24063	2	applied	\N	\N	\N	\N	137926	137926	305485
17746	24064	3	applied	\N	\N	\N	\N	137927	137927	305486
17746	24065	4	applied	\N	\N	\N	\N	137928	137928	305487
17746	24066	5	applied	\N	\N	\N	\N	137929	137929	305488
17751	23817	0	applied	\N	\N	\N	\N	137950	137950	305509
17751	23818	1	applied	\N	\N	\N	\N	137951	137951	305510
17751	24043	2	applied	\N	\N	\N	\N	137952	137952	305511
17751	24037	3	applied	\N	\N	\N	\N	137953	137953	137953
17751	24028	4	applied	\N	\N	\N	\N	137954	137954	137954
17751	23871	5	applied	\N	\N	1000000000	\N	137955	137955	305512
17751	23876	6	applied	\N	\N	1000000000	\N	137956	137956	305513
17751	23819	7	applied	\N	\N	\N	\N	137957	137957	305514
17751	23879	10	applied	\N	\N	1000000000	\N	137959	137959	305516
17751	23880	11	applied	\N	\N	1000000000	\N	137960	137960	305517
17751	23934	12	applied	\N	\N	1000000000	\N	137961	137961	305518
17751	23993	13	applied	\N	\N	1000000000	\N	137962	137962	305519
17751	23823	14	applied	\N	\N	\N	\N	137963	137963	305520
17751	23826	15	applied	\N	\N	\N	\N	137964	137964	305521
17751	23828	16	applied	\N	\N	\N	\N	137965	137965	305522
17751	23832	17	applied	\N	\N	\N	\N	137966	137966	305523
17751	23835	18	applied	\N	\N	\N	\N	137967	137967	305524
17751	23838	19	applied	\N	\N	\N	\N	137968	137968	305525
17751	23841	20	applied	\N	\N	\N	\N	137969	137969	305526
17751	23844	21	applied	\N	\N	\N	\N	137970	137970	305527
17751	23847	22	applied	\N	\N	\N	\N	137971	137971	305528
17751	23848	23	applied	\N	\N	\N	\N	137972	137972	305529
17751	23853	24	applied	\N	\N	\N	\N	137973	137973	305530
17751	23856	25	applied	\N	\N	\N	\N	137974	137974	305531
17751	23859	26	applied	\N	\N	\N	\N	137975	137975	305532
17751	23862	27	applied	\N	\N	\N	\N	137976	137976	305533
17751	23865	28	applied	\N	\N	\N	\N	137977	137977	305534
17751	23872	30	applied	\N	\N	\N	\N	137979	137979	305536
17751	23877	31	applied	\N	\N	\N	\N	137980	137980	305537
17751	23883	32	applied	\N	\N	\N	\N	137981	137981	305538
17751	23884	33	applied	\N	\N	\N	\N	137982	137982	305539
17751	23885	34	applied	\N	\N	\N	\N	137983	137983	305540
17751	23890	35	applied	\N	\N	\N	\N	137984	137984	305541
17751	23892	36	applied	\N	\N	\N	\N	137985	137985	305542
17751	23894	37	applied	\N	\N	\N	\N	137986	137986	305543
17751	23896	38	applied	\N	\N	\N	\N	137987	137987	305544
17751	23898	39	applied	\N	\N	\N	\N	137988	137988	305545
17751	23900	40	applied	\N	\N	\N	\N	137989	137989	305546
17751	23901	41	applied	\N	\N	\N	\N	137990	137990	305547
17751	23904	42	applied	\N	\N	\N	\N	137991	137991	305548
17751	23905	43	applied	\N	\N	\N	\N	137992	137992	305549
17751	23908	44	applied	\N	\N	\N	\N	137993	137993	305550
17751	23910	45	applied	\N	\N	\N	\N	137994	137994	305551
17751	23914	47	applied	\N	\N	\N	\N	137996	137996	305553
17751	23916	48	applied	\N	\N	\N	\N	137997	137997	305554
17751	23917	49	applied	\N	\N	\N	\N	137998	137998	305555
17751	23918	50	applied	\N	\N	\N	\N	137999	137999	305556
17751	23919	51	applied	\N	\N	\N	\N	138000	138000	305557
17751	23920	52	applied	\N	\N	\N	\N	138001	138001	305558
17751	23926	53	applied	\N	\N	\N	\N	138002	138002	305559
17751	23928	54	applied	\N	\N	\N	\N	138003	138003	305560
17751	23930	55	applied	\N	\N	\N	\N	138004	138004	305561
17751	23932	56	applied	\N	\N	\N	\N	138005	138005	305562
17751	23935	57	applied	\N	\N	\N	\N	138006	138006	305563
17751	23937	58	applied	\N	\N	\N	\N	138007	138007	305564
17751	23939	59	applied	\N	\N	\N	\N	138008	138008	305565
17751	23940	60	applied	\N	\N	\N	\N	138009	138009	305566
17751	23941	61	applied	\N	\N	\N	\N	138010	138010	305567
17751	23942	62	applied	\N	\N	\N	\N	138011	138011	305568
17751	23944	64	applied	\N	\N	\N	\N	138013	138013	305570
17751	23945	65	applied	\N	\N	\N	\N	138014	138014	305571
17751	23946	66	applied	\N	\N	\N	\N	138015	138015	305572
17751	23955	67	applied	\N	\N	\N	\N	138016	138016	305573
17751	23957	68	applied	\N	\N	\N	\N	138017	138017	305574
17751	23958	69	applied	\N	\N	\N	\N	138018	138018	305575
17753	24071	0	applied	\N	\N	\N	\N	138022	138022	305579
17753	24072	1	applied	\N	\N	\N	\N	138023	138023	305580
17753	24073	2	applied	\N	\N	\N	\N	138024	138024	305581
17754	24074	0	applied	\N	\N	\N	\N	138025	138025	305582
17754	24075	1	applied	\N	\N	\N	\N	138026	138026	305583
17754	24076	2	applied	\N	\N	\N	\N	138027	138027	305584
17755	24077	0	applied	\N	\N	\N	\N	138028	138028	305585
17755	24078	1	applied	\N	\N	\N	\N	138029	138029	305586
17755	24079	2	applied	\N	\N	\N	\N	138030	138030	305587
17755	24080	3	applied	\N	\N	\N	\N	138031	138031	305588
17756	24082	1	applied	\N	\N	\N	\N	138033	138033	305590
17756	24083	2	applied	\N	\N	\N	\N	138034	138034	305591
17756	24084	3	applied	\N	\N	\N	\N	138035	138035	305592
17758	24081	0	applied	\N	\N	\N	\N	138056	138056	305613
17758	24082	1	applied	\N	\N	\N	\N	138057	138057	305614
17758	24083	2	applied	\N	\N	\N	\N	138058	138058	305615
17758	24084	3	applied	\N	\N	\N	\N	138059	138059	305616
17758	24085	4	applied	\N	\N	\N	\N	138060	138060	305617
17735	24038	2	applied	\N	\N	\N	\N	137854	137854	305413
17735	24039	3	applied	\N	\N	\N	\N	137855	137855	305414
17748	24064	3	applied	\N	\N	\N	\N	137939	137939	305498
17748	24066	5	applied	\N	\N	\N	\N	137941	137941	305500
17752	24071	0	applied	\N	\N	\N	\N	138019	138019	305576
17752	24072	1	applied	\N	\N	\N	\N	138020	138020	305577
17752	24073	2	applied	\N	\N	\N	\N	138021	138021	305578
17756	24085	4	applied	\N	\N	\N	\N	138036	138036	305593
17756	24086	5	applied	\N	\N	\N	\N	138037	138037	305594
17756	24087	6	applied	\N	\N	\N	\N	138038	138038	305595
17756	24088	7	applied	\N	\N	\N	\N	138039	138039	305596
17756	24089	8	applied	\N	\N	\N	\N	138040	138040	305597
17756	24090	9	applied	\N	\N	\N	\N	138041	138041	305598
17756	24091	10	applied	\N	\N	\N	\N	138042	138042	305599
17756	24092	11	applied	\N	\N	\N	\N	138043	138043	305600
17763	24096	0	applied	\N	\N	\N	\N	138080	138080	305637
17763	24097	1	applied	\N	\N	\N	\N	138081	138081	305638
17763	24098	2	applied	\N	\N	\N	\N	138082	138082	305639
17765	24096	0	applied	\N	\N	\N	\N	138086	138086	305643
17765	24098	2	applied	\N	\N	\N	\N	138088	138088	305645
17767	24106	0	applied	\N	\N	\N	\N	138096	138096	305653
17767	24107	1	applied	\N	\N	\N	\N	138097	138097	305654
17767	24108	2	applied	\N	\N	\N	\N	138098	138098	305655
17767	24109	3	applied	\N	\N	\N	\N	138099	138099	305656
17767	24110	4	applied	\N	\N	\N	\N	138100	138100	305657
17767	24111	5	applied	\N	\N	\N	\N	138101	138101	305658
17767	24112	6	applied	\N	\N	\N	\N	138102	138102	305659
17773	24131	0	applied	\N	\N	\N	\N	138147	138147	305700
17773	24132	1	applied	\N	\N	\N	\N	138148	138148	305701
17773	24133	2	applied	\N	\N	\N	\N	138149	138149	305702
17773	24134	3	applied	\N	\N	\N	\N	138150	138150	305703
17786	24164	0	applied	\N	\N	\N	\N	138196	138196	305749
17786	24165	1	applied	\N	\N	\N	\N	138197	138197	305750
17786	24166	2	applied	\N	\N	\N	\N	138198	138198	305751
17799	24184	0	applied	\N	\N	\N	\N	138236	138236	305789
17799	24186	2	applied	\N	\N	\N	\N	138238	138238	305791
17802	24184	0	applied	\N	\N	\N	\N	138245	138245	305798
17802	24185	1	applied	\N	\N	\N	\N	138246	138246	305799
17802	24186	2	applied	\N	\N	\N	\N	138247	138247	305800
17806	24189	0	applied	\N	\N	\N	\N	138259	138259	305811
17806	24187	2	applied	\N	\N	\N	\N	138261	138261	305812
17806	24191	3	applied	\N	\N	\N	\N	138262	138262	305813
17806	24188	4	applied	\N	\N	\N	\N	138263	138263	305814
17811	24206	0	applied	\N	\N	\N	\N	138284	138284	305834
17811	24207	1	applied	\N	\N	\N	\N	138285	138285	305835
17813	24208	0	applied	\N	\N	\N	\N	138288	138288	305838
17813	24209	1	applied	\N	\N	\N	\N	138289	138289	305839
17813	24210	2	applied	\N	\N	\N	\N	138290	138290	305840
17821	24217	0	applied	\N	\N	\N	\N	138309	138309	305859
17821	24218	1	applied	\N	\N	\N	\N	138310	138310	305860
17821	24220	3	applied	\N	\N	\N	\N	138312	138312	305862
17823	24221	0	applied	\N	\N	\N	\N	138317	138317	305867
17823	24222	1	applied	\N	\N	\N	\N	138318	138318	305868
17823	24223	2	applied	\N	\N	\N	\N	138319	138319	305869
17828	24234	0	applied	\N	\N	\N	\N	138340	138340	305890
17828	24235	1	applied	\N	\N	\N	\N	138341	138341	305891
17828	24236	2	applied	\N	\N	\N	\N	138342	138342	305892
17833	24237	0	applied	\N	\N	\N	\N	138352	138352	305902
17833	24238	1	applied	\N	\N	\N	\N	138353	138353	305903
17833	24239	2	applied	\N	\N	\N	\N	138354	138354	305904
17833	24240	3	applied	\N	\N	\N	\N	138355	138355	305905
17833	24241	4	applied	\N	\N	\N	\N	138356	138356	305906
17833	24242	5	applied	\N	\N	\N	\N	138357	138357	305907
17833	24243	6	applied	\N	\N	\N	\N	138358	138358	305908
17838	24244	0	applied	\N	\N	\N	\N	138383	138383	305933
17838	24245	1	applied	\N	\N	\N	\N	138384	138384	305934
17838	24249	3	applied	\N	\N	\N	\N	138386	138386	305936
17838	24246	4	applied	\N	\N	\N	\N	138387	138387	305937
17838	24247	5	applied	\N	\N	\N	\N	138388	138388	305938
17842	24244	0	applied	\N	\N	\N	\N	138402	138402	305952
17842	24245	1	applied	\N	\N	\N	\N	138403	138403	305953
17842	24248	2	applied	\N	\N	\N	\N	138404	138404	305954
17842	24249	3	applied	\N	\N	\N	\N	138405	138405	305955
17842	24246	4	applied	\N	\N	\N	\N	138406	138406	305956
17842	24247	5	applied	\N	\N	\N	\N	138407	138407	305957
17843	24251	0	applied	\N	\N	\N	\N	138408	138408	305958
17843	24250	1	applied	\N	\N	\N	\N	138409	138409	305959
17843	24252	2	applied	\N	\N	\N	\N	138410	138410	305960
17843	24253	3	applied	\N	\N	\N	\N	138411	138411	305961
17847	24251	0	applied	\N	\N	\N	\N	138428	138428	305978
17847	24250	1	applied	\N	\N	\N	\N	138429	138429	305979
17847	24252	2	applied	\N	\N	\N	\N	138430	138430	305980
17852	24260	0	applied	\N	\N	\N	\N	138443	138443	305993
17852	24262	2	applied	\N	\N	\N	\N	138445	138445	305994
17852	24261	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	138444	138444	\N
17852	24263	3	applied	\N	\N	\N	\N	138446	138446	305995
17857	24264	0	applied	\N	\N	\N	\N	138582	138582	306128
17857	24265	1	applied	\N	\N	\N	\N	138583	138583	306129
17857	24266	2	applied	\N	\N	\N	\N	138584	138584	306130
17862	24273	0	applied	\N	\N	\N	\N	138597	138597	306143
17862	24274	1	applied	\N	\N	\N	\N	138598	138598	306144
17862	24275	2	applied	\N	\N	\N	\N	138599	138599	306145
17862	24276	3	applied	\N	\N	\N	\N	138600	138600	306146
17871	24297	0	applied	\N	\N	\N	\N	138670	138670	306211
17871	24298	1	applied	\N	\N	\N	\N	138671	138671	306212
17871	24299	2	applied	\N	\N	\N	\N	138672	138672	306213
17871	24300	3	applied	\N	\N	\N	\N	138673	138673	306214
17876	24307	0	applied	\N	\N	\N	\N	138688	138688	306229
17876	24309	2	applied	\N	\N	\N	\N	138690	138690	306231
17876	24310	3	applied	\N	\N	\N	\N	138691	138691	306232
17877	24311	0	applied	\N	\N	\N	\N	138692	138692	306233
17877	24312	1	applied	\N	\N	\N	\N	138693	138693	306234
17877	24313	2	applied	\N	\N	\N	\N	138694	138694	306235
17883	24324	0	applied	\N	\N	\N	\N	138717	138717	306258
17883	24325	1	applied	\N	\N	\N	\N	138718	138718	306259
17883	24326	3	applied	\N	\N	\N	\N	138719	138719	306260
17884	24327	0	applied	\N	\N	\N	\N	138720	138720	306261
17884	24328	1	applied	\N	\N	\N	\N	138721	138721	306262
17884	24329	2	applied	\N	\N	\N	\N	138722	138722	306263
17884	24330	3	applied	\N	\N	\N	\N	138723	138723	306264
17748	24062	1	applied	\N	\N	\N	\N	137937	137937	305496
17748	24063	2	applied	\N	\N	\N	\N	137938	137938	305497
17758	24089	8	applied	\N	\N	\N	\N	138064	138064	305621
17758	24090	9	applied	\N	\N	\N	\N	138065	138065	305622
17758	24092	11	applied	\N	\N	\N	\N	138067	138067	305624
17760	24093	0	applied	\N	\N	\N	\N	138071	138071	305628
17760	24094	1	applied	\N	\N	\N	\N	138072	138072	305629
17760	24095	2	applied	\N	\N	\N	\N	138073	138073	305630
17762	24096	0	applied	\N	\N	\N	\N	138077	138077	305634
17762	24097	1	applied	\N	\N	\N	\N	138078	138078	305635
17762	24098	2	applied	\N	\N	\N	\N	138079	138079	305636
17766	24099	0	applied	\N	\N	\N	\N	138089	138089	305646
17766	24100	1	applied	\N	\N	\N	\N	138090	138090	305647
17766	24101	2	applied	\N	\N	\N	\N	138091	138091	305648
17766	24102	3	applied	\N	\N	\N	\N	138092	138092	305649
17766	24103	4	applied	\N	\N	\N	\N	138093	138093	305650
17766	24104	5	applied	\N	\N	\N	\N	138094	138094	305651
17766	24105	6	applied	\N	\N	\N	\N	138095	138095	305652
17769	24113	0	applied	\N	\N	\N	\N	138110	138110	305667
17769	24114	1	applied	\N	\N	\N	\N	138111	138111	305668
17770	24116	0	applied	\N	\N	\N	\N	138113	138113	305670
17770	24117	1	applied	\N	\N	\N	\N	138114	138114	305671
17770	24118	2	applied	\N	\N	\N	\N	138115	138115	305672
17770	24119	3	applied	\N	\N	\N	\N	138116	138116	305673
17770	24122	6	applied	\N	\N	\N	\N	138119	138119	305674
17770	24120	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	138117	138117	\N
17770	24121	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	138118	138118	\N
17770	24123	7	applied	\N	\N	\N	\N	138120	138120	305675
17770	24124	8	applied	\N	\N	\N	\N	138121	138121	305676
17770	24125	9	applied	\N	\N	\N	\N	138122	138122	305677
17770	24126	10	applied	\N	\N	\N	\N	138123	138123	305678
17770	24127	11	applied	\N	\N	\N	\N	138124	138124	305679
17770	24128	12	applied	\N	\N	\N	\N	138125	138125	305680
17770	24129	13	applied	\N	\N	\N	\N	138126	138126	305681
17770	24130	14	applied	\N	\N	\N	\N	138127	138127	305682
17772	24131	0	applied	\N	\N	\N	\N	138143	138143	305696
17772	24133	2	applied	\N	\N	\N	\N	138145	138145	305698
17772	24134	3	applied	\N	\N	\N	\N	138146	138146	305699
17780	24152	0	applied	\N	\N	\N	\N	138178	138178	305731
17780	24153	1	applied	\N	\N	\N	\N	138179	138179	305732
17780	24154	2	applied	\N	\N	\N	\N	138180	138180	305733
17780	24155	3	applied	\N	\N	\N	\N	138181	138181	305734
17780	24156	4	applied	\N	\N	\N	\N	138182	138182	305735
17780	24157	5	applied	\N	\N	\N	\N	138183	138183	305736
17783	24161	0	applied	\N	\N	\N	\N	138190	138190	305743
17783	24162	1	applied	\N	\N	\N	\N	138191	138191	305744
17783	24163	2	applied	\N	\N	\N	\N	138192	138192	305745
17785	24164	0	applied	\N	\N	\N	\N	138193	138193	305746
17785	24165	1	applied	\N	\N	\N	\N	138194	138194	305747
17785	24166	2	applied	\N	\N	\N	\N	138195	138195	305748
17789	24164	0	applied	\N	\N	\N	\N	138202	138202	305755
17789	24165	1	applied	\N	\N	\N	\N	138203	138203	305756
17793	24167	0	applied	\N	\N	\N	\N	138205	138205	305758
17793	24168	1	applied	\N	\N	\N	\N	138206	138206	305759
17793	24169	2	applied	\N	\N	\N	\N	138207	138207	305760
17793	24170	3	applied	\N	\N	\N	\N	138208	138208	305761
17793	24171	4	applied	\N	\N	\N	\N	138209	138209	305762
17793	24172	5	applied	\N	\N	\N	\N	138210	138210	305763
17793	24173	6	applied	\N	\N	\N	\N	138211	138211	305764
17795	24167	0	applied	\N	\N	\N	\N	138219	138219	305772
17795	24168	1	applied	\N	\N	\N	\N	138220	138220	305773
17795	24169	2	applied	\N	\N	\N	\N	138221	138221	305774
17795	24170	3	applied	\N	\N	\N	\N	138222	138222	305775
17795	24171	4	applied	\N	\N	\N	\N	138223	138223	305776
17795	24172	5	applied	\N	\N	\N	\N	138224	138224	305777
17795	24173	6	applied	\N	\N	\N	\N	138225	138225	305778
17797	24176	0	applied	\N	\N	\N	\N	138228	138228	305781
17797	24177	1	applied	\N	\N	\N	\N	138229	138229	305782
17797	24179	3	applied	\N	\N	\N	\N	138231	138231	305784
17797	24180	4	applied	\N	\N	\N	\N	138232	138232	305785
17801	24184	0	applied	\N	\N	\N	\N	138242	138242	305795
17801	24185	1	applied	\N	\N	\N	\N	138243	138243	305796
17801	24186	2	applied	\N	\N	\N	\N	138244	138244	305797
17805	24189	0	applied	\N	\N	\N	\N	138254	138254	305807
17805	24187	2	applied	\N	\N	\N	\N	138256	138256	305808
17805	24190	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	138255	138255	\N
17805	24191	3	applied	\N	\N	\N	\N	138257	138257	305809
17805	24188	4	applied	\N	\N	\N	\N	138258	138258	305810
17807	24189	0	applied	\N	\N	\N	\N	138264	138264	305815
17807	24187	2	applied	\N	\N	\N	\N	138266	138266	305816
17807	24192	3	applied	\N	\N	\N	\N	138267	138267	305817
17807	24191	4	applied	\N	\N	\N	\N	138268	138268	305818
17807	24188	5	applied	\N	\N	\N	\N	138269	138269	305819
17807	24193	6	applied	\N	\N	\N	\N	138270	138270	305820
17810	24204	0	applied	\N	\N	\N	\N	138282	138282	305832
17810	24205	1	applied	\N	\N	\N	\N	138283	138283	305833
17816	24208	0	applied	\N	\N	\N	\N	138297	138297	305847
17816	24209	1	applied	\N	\N	\N	\N	138298	138298	305848
17816	24210	2	applied	\N	\N	\N	\N	138299	138299	305849
17818	24211	0	applied	\N	\N	\N	\N	138300	138300	305850
17818	24212	1	applied	\N	\N	\N	\N	138301	138301	305851
17818	24213	2	applied	\N	\N	\N	\N	138302	138302	305852
17820	24214	0	applied	\N	\N	\N	\N	138306	138306	305856
17820	24215	1	applied	\N	\N	\N	\N	138307	138307	305857
17820	24216	2	applied	\N	\N	\N	\N	138308	138308	305858
17827	24230	0	applied	\N	\N	\N	\N	138336	138336	305886
17827	24231	1	applied	\N	\N	\N	\N	138337	138337	305887
17827	24232	2	applied	\N	\N	\N	\N	138338	138338	305888
17827	24233	3	applied	\N	\N	\N	\N	138339	138339	305889
17831	24234	0	applied	\N	\N	\N	\N	138349	138349	305899
17831	24235	1	applied	\N	\N	\N	\N	138350	138350	305900
17831	24236	2	applied	\N	\N	\N	\N	138351	138351	305901
17837	24244	0	applied	\N	\N	\N	\N	138377	138377	305927
17884	24331	4	applied	\N	\N	\N	\N	138724	138724	306265
17884	24332	5	applied	\N	\N	\N	\N	138725	138725	306266
17884	24333	6	applied	\N	\N	\N	\N	138726	138726	306267
17889	24340	0	applied	\N	\N	\N	\N	138744	138744	306285
17889	24341	1	applied	\N	\N	\N	\N	138745	138745	306286
17889	24336	3	applied	\N	\N	\N	\N	138747	138747	306288
17889	24337	4	applied	\N	\N	\N	\N	138748	138748	306289
17758	24087	6	applied	\N	\N	\N	\N	138062	138062	305619
17758	24088	7	applied	\N	\N	\N	\N	138063	138063	305620
17768	24106	0	applied	\N	\N	\N	\N	138103	138103	305660
17768	24107	1	applied	\N	\N	\N	\N	138104	138104	305661
17768	24108	2	applied	\N	\N	\N	\N	138105	138105	305662
17768	24109	3	applied	\N	\N	\N	\N	138106	138106	305663
17768	24110	4	applied	\N	\N	\N	\N	138107	138107	305664
17768	24111	5	applied	\N	\N	\N	\N	138108	138108	305665
17768	24112	6	applied	\N	\N	\N	\N	138109	138109	305666
17771	24116	0	applied	\N	\N	\N	\N	138128	138128	305683
17771	24118	2	applied	\N	\N	\N	\N	138130	138130	305685
17771	24119	3	applied	\N	\N	\N	\N	138131	138131	305686
17771	24122	6	applied	\N	\N	\N	\N	138134	138134	305687
17771	24120	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	138132	138132	\N
17771	24121	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	138133	138133	\N
17771	24123	7	applied	\N	\N	\N	\N	138135	138135	305688
17771	24124	8	applied	\N	\N	\N	\N	138136	138136	305689
17771	24125	9	applied	\N	\N	\N	\N	138137	138137	305690
17771	24126	10	applied	\N	\N	\N	\N	138138	138138	305691
17771	24127	11	applied	\N	\N	\N	\N	138139	138139	305692
17771	24128	12	applied	\N	\N	\N	\N	138140	138140	305693
17771	24129	13	applied	\N	\N	\N	\N	138141	138141	305694
17771	24130	14	applied	\N	\N	\N	\N	138142	138142	305695
17774	24135	0	applied	\N	\N	\N	\N	138151	138151	305704
17774	24136	1	applied	\N	\N	\N	\N	138152	138152	305705
17774	24137	2	applied	\N	\N	\N	\N	138153	138153	305706
17774	24139	4	applied	\N	\N	\N	\N	138155	138155	305708
17774	24140	5	applied	\N	\N	\N	\N	138156	138156	305709
17774	24141	6	applied	\N	\N	\N	\N	138157	138157	305710
17774	24142	7	applied	\N	\N	\N	\N	138158	138158	305711
17774	24143	8	applied	\N	\N	\N	\N	138159	138159	305712
17774	24144	9	applied	\N	\N	\N	\N	138160	138160	305713
17776	24145	0	applied	\N	\N	\N	\N	138171	138171	305724
17776	24146	1	applied	\N	\N	\N	\N	138172	138172	305725
17776	24147	2	applied	\N	\N	\N	\N	138173	138173	305726
17776	24148	3	applied	\N	\N	\N	\N	138174	138174	305727
17781	24158	0	applied	\N	\N	\N	\N	138184	138184	305737
17781	24159	1	applied	\N	\N	\N	\N	138185	138185	305738
17781	24160	2	applied	\N	\N	\N	\N	138186	138186	305739
17798	24181	0	applied	\N	\N	\N	\N	138233	138233	305786
17798	24182	1	applied	\N	\N	\N	\N	138234	138234	305787
17798	24183	2	applied	\N	\N	\N	\N	138235	138235	305788
17800	24185	1	applied	\N	\N	\N	\N	138240	138240	305793
17800	24186	2	applied	\N	\N	\N	\N	138241	138241	305794
17803	24184	0	applied	\N	\N	\N	\N	138248	138248	305801
17808	24194	0	applied	\N	\N	\N	\N	138271	138271	305821
17809	24195	0	applied	\N	\N	1000000000	\N	138272	138272	305822
17809	24194	1	applied	\N	\N	\N	\N	138273	138273	305823
17809	24196	2	applied	\N	\N	\N	\N	138274	138274	305824
17809	24197	3	applied	\N	\N	\N	\N	138275	138275	305825
17809	24198	4	applied	\N	\N	\N	\N	138276	138276	305826
17809	24199	5	applied	\N	\N	\N	\N	138277	138277	305827
17809	24200	6	applied	\N	\N	\N	\N	138278	138278	305828
17809	24201	7	applied	\N	\N	\N	\N	138279	138279	305829
17809	24202	8	applied	\N	\N	\N	\N	138280	138280	305830
17809	24203	9	applied	\N	\N	\N	\N	138281	138281	305831
17812	24206	0	applied	\N	\N	\N	\N	138286	138286	305836
17812	24207	1	applied	\N	\N	\N	\N	138287	138287	305837
17814	24209	1	applied	\N	\N	\N	\N	138292	138292	305842
17814	24210	2	applied	\N	\N	\N	\N	138293	138293	305843
17819	24211	0	applied	\N	\N	\N	\N	138303	138303	305853
17819	24212	1	applied	\N	\N	\N	\N	138304	138304	305854
17819	24213	2	applied	\N	\N	\N	\N	138305	138305	305855
17824	24224	0	applied	\N	\N	\N	\N	138320	138320	305870
17824	24225	1	applied	\N	\N	\N	\N	138321	138321	305871
17824	24226	2	applied	\N	\N	\N	\N	138322	138322	305872
17824	24227	3	applied	\N	\N	\N	\N	138323	138323	305873
17824	24228	4	applied	\N	\N	\N	\N	138324	138324	305874
17824	24229	5	applied	\N	\N	\N	\N	138325	138325	305875
17829	24234	0	applied	\N	\N	\N	\N	138343	138343	305893
17829	24235	1	applied	\N	\N	\N	\N	138344	138344	305894
17829	24236	2	applied	\N	\N	\N	\N	138345	138345	305895
17834	24237	0	applied	\N	\N	\N	\N	138359	138359	305909
17834	24238	1	applied	\N	\N	\N	\N	138360	138360	305910
17834	24240	3	applied	\N	\N	\N	\N	138362	138362	305912
17834	24241	4	applied	\N	\N	\N	\N	138363	138363	305913
17834	24242	5	applied	\N	\N	\N	\N	138364	138364	305914
17834	24243	6	applied	\N	\N	\N	\N	138365	138365	305915
17837	24245	1	applied	\N	\N	\N	\N	138378	138378	305928
17837	24248	2	applied	\N	\N	\N	\N	138379	138379	305929
17837	24249	3	applied	\N	\N	\N	\N	138380	138380	305930
17837	24246	4	applied	\N	\N	\N	\N	138381	138381	305931
17837	24247	5	applied	\N	\N	\N	\N	138382	138382	305932
17839	24244	0	applied	\N	\N	\N	\N	138389	138389	305939
17839	24245	1	applied	\N	\N	\N	\N	138390	138390	305940
17839	24248	2	applied	\N	\N	\N	\N	138391	138391	305941
17839	24249	3	applied	\N	\N	\N	\N	138392	138392	305942
17839	24246	4	applied	\N	\N	\N	\N	138393	138393	305943
17839	24247	5	applied	\N	\N	\N	\N	138394	138394	305944
17841	24244	0	applied	\N	\N	\N	\N	138395	138395	305945
17841	24248	2	applied	\N	\N	\N	\N	138397	138397	305947
17844	24251	0	applied	\N	\N	\N	\N	138412	138412	305962
17844	24250	1	applied	\N	\N	\N	\N	138413	138413	305963
17844	24252	2	applied	\N	\N	\N	\N	138414	138414	305964
17844	24253	3	applied	\N	\N	\N	\N	138415	138415	305965
17848	24254	0	applied	\N	\N	\N	\N	138432	138432	305982
17848	24255	1	applied	\N	\N	\N	\N	138433	138433	305983
17848	24256	2	applied	\N	\N	\N	\N	138434	138434	305984
17853	24260	0	applied	\N	\N	\N	\N	138447	138447	305996
17853	24262	2	applied	\N	\N	\N	\N	138449	138449	305997
17853	24263	3	applied	\N	\N	\N	\N	138450	138450	305998
17854	24264	0	applied	\N	\N	\N	\N	138451	138451	305999
17854	24265	1	applied	\N	\N	\N	\N	138452	138452	306000
17854	24266	2	applied	\N	\N	\N	\N	138453	138453	306001
17858	24267	0	applied	\N	\N	\N	\N	138585	138585	306131
17858	24268	1	applied	\N	\N	\N	\N	138586	138586	306132
17858	24269	2	applied	\N	\N	\N	\N	138587	138587	306133
17859	24270	0	applied	\N	\N	\N	\N	138588	138588	306134
17859	24271	1	applied	\N	\N	\N	\N	138589	138589	306135
17859	24272	2	applied	\N	\N	\N	\N	138590	138590	306136
17764	24097	1	applied	\N	\N	\N	\N	138084	138084	305641
17764	24098	2	applied	\N	\N	\N	\N	138085	138085	305642
17777	24151	2	applied	\N	\N	\N	\N	138177	138177	305730
17782	24161	0	applied	\N	\N	\N	\N	138187	138187	305740
17782	24162	1	applied	\N	\N	\N	\N	138188	138188	305741
17782	24163	2	applied	\N	\N	\N	\N	138189	138189	305742
17788	24164	0	applied	\N	\N	\N	\N	138199	138199	305752
17788	24165	1	applied	\N	\N	\N	\N	138200	138200	305753
17788	24166	2	applied	\N	\N	\N	\N	138201	138201	305754
17794	24167	0	applied	\N	\N	\N	\N	138212	138212	305765
17794	24168	1	applied	\N	\N	\N	\N	138213	138213	305766
17794	24169	2	applied	\N	\N	\N	\N	138214	138214	305767
17794	24170	3	applied	\N	\N	\N	\N	138215	138215	305768
17794	24171	4	applied	\N	\N	\N	\N	138216	138216	305769
17794	24172	5	applied	\N	\N	\N	\N	138217	138217	305770
17794	24173	6	applied	\N	\N	\N	\N	138218	138218	305771
17796	24174	0	applied	\N	\N	\N	\N	138226	138226	305779
17804	24184	0	applied	\N	\N	\N	\N	138249	138249	305802
17804	24185	1	applied	\N	\N	\N	\N	138250	138250	305803
17804	24186	2	applied	\N	\N	\N	\N	138251	138251	305804
17804	24187	3	applied	\N	\N	\N	\N	138252	138252	305805
17804	24188	4	applied	\N	\N	\N	\N	138253	138253	305806
17815	24208	0	applied	\N	\N	\N	\N	138294	138294	305844
17815	24209	1	applied	\N	\N	\N	\N	138295	138295	305845
17815	24210	2	applied	\N	\N	\N	\N	138296	138296	305846
17822	24217	0	applied	\N	\N	\N	\N	138313	138313	305863
17822	24218	1	applied	\N	\N	\N	\N	138314	138314	305864
17822	24219	2	applied	\N	\N	\N	\N	138315	138315	305865
17822	24220	3	applied	\N	\N	\N	\N	138316	138316	305866
17825	24224	0	applied	\N	\N	\N	\N	138326	138326	305876
17825	24225	1	applied	\N	\N	\N	\N	138327	138327	305877
17825	24226	2	applied	\N	\N	\N	\N	138328	138328	305878
17825	24227	3	applied	\N	\N	\N	\N	138329	138329	305879
17825	24229	5	applied	\N	\N	\N	\N	138331	138331	305881
17826	24230	0	applied	\N	\N	\N	\N	138332	138332	305882
17826	24231	1	applied	\N	\N	\N	\N	138333	138333	305883
17826	24232	2	applied	\N	\N	\N	\N	138334	138334	305884
17826	24233	3	applied	\N	\N	\N	\N	138335	138335	305885
17830	24234	0	applied	\N	\N	\N	\N	138346	138346	305896
17830	24235	1	applied	\N	\N	\N	\N	138347	138347	305897
17830	24236	2	applied	\N	\N	\N	\N	138348	138348	305898
17835	24237	0	applied	\N	\N	\N	\N	138366	138366	305916
17835	24238	1	applied	\N	\N	\N	\N	138367	138367	305917
17835	24239	2	applied	\N	\N	\N	\N	138368	138368	305918
17835	24240	3	applied	\N	\N	\N	\N	138369	138369	305919
17835	24241	4	applied	\N	\N	\N	\N	138370	138370	305920
17835	24242	5	applied	\N	\N	\N	\N	138371	138371	305921
17835	24243	6	applied	\N	\N	\N	\N	138372	138372	305922
17836	24244	0	applied	\N	\N	\N	\N	138373	138373	305923
17836	24246	2	applied	\N	\N	\N	\N	138375	138375	305925
17836	24247	3	applied	\N	\N	\N	\N	138376	138376	305926
17845	24251	0	applied	\N	\N	\N	\N	138416	138416	305966
17845	24250	1	applied	\N	\N	\N	\N	138417	138417	305967
17845	24253	2	applied	\N	\N	\N	\N	138418	138418	305968
17849	24254	0	applied	\N	\N	\N	\N	138435	138435	305985
17849	24255	1	applied	\N	\N	\N	\N	138436	138436	305986
17849	24256	2	applied	\N	\N	\N	\N	138437	138437	305987
17855	24043	0	applied	\N	\N	\N	\N	138454	138454	306002
17855	23876	1	applied	\N	\N	1000000000	\N	138455	138455	306003
17855	23877	2	applied	\N	\N	\N	\N	138456	138456	306004
17855	24037	3	applied	\N	\N	\N	\N	138457	138457	138457
17855	23883	4	applied	\N	\N	\N	\N	138458	138458	306005
17855	23884	5	applied	\N	\N	\N	\N	138459	138459	306006
17855	23885	6	applied	\N	\N	\N	\N	138460	138460	306007
17855	23890	7	applied	\N	\N	\N	\N	138461	138461	306008
17855	23892	9	applied	\N	\N	\N	\N	138463	138463	306009
17855	23894	10	applied	\N	\N	\N	\N	138464	138464	306010
17855	23896	11	applied	\N	\N	\N	\N	138465	138465	306011
17855	23898	12	applied	\N	\N	\N	\N	138466	138466	306012
17855	23900	13	applied	\N	\N	\N	\N	138467	138467	306013
17855	23901	14	applied	\N	\N	\N	\N	138468	138468	306014
17855	23904	15	applied	\N	\N	\N	\N	138469	138469	306015
17855	23905	16	applied	\N	\N	\N	\N	138470	138470	306016
17855	23908	17	applied	\N	\N	\N	\N	138471	138471	306017
17855	23910	18	applied	\N	\N	\N	\N	138472	138472	306018
17855	23912	20	applied	\N	\N	\N	\N	138473	138473	306019
17855	23878	21	applied	\N	\N	1000000000	\N	138474	138474	306020
17855	23879	22	applied	\N	\N	1000000000	\N	138475	138475	306021
17855	23880	23	applied	\N	\N	1000000000	\N	138476	138476	306022
17855	23993	25	applied	\N	\N	1000000000	\N	138478	138478	306024
17855	24195	26	applied	\N	\N	1000000000	\N	138479	138479	306025
17855	23914	27	applied	\N	\N	\N	\N	138480	138480	306026
17855	23916	28	applied	\N	\N	\N	\N	138481	138481	306027
17855	23917	29	applied	\N	\N	\N	\N	138482	138482	306028
17855	23918	30	applied	\N	\N	\N	\N	138483	138483	306029
17855	23919	31	applied	\N	\N	\N	\N	138484	138484	306030
17855	23920	32	applied	\N	\N	\N	\N	138485	138485	306031
17855	23926	33	applied	\N	\N	\N	\N	138486	138486	306032
17855	23928	34	applied	\N	\N	\N	\N	138487	138487	306033
17855	23930	35	applied	\N	\N	\N	\N	138488	138488	306034
17855	23932	36	applied	\N	\N	\N	\N	138489	138489	306035
17855	23935	37	applied	\N	\N	\N	\N	138490	138490	306036
17855	23937	38	applied	\N	\N	\N	\N	138491	138491	306037
17855	23939	39	applied	\N	\N	\N	\N	138492	138492	306038
17855	23940	40	applied	\N	\N	\N	\N	138493	138493	306039
17855	23941	41	applied	\N	\N	\N	\N	138494	138494	306040
17855	23942	42	applied	\N	\N	\N	\N	138495	138495	306041
17855	23943	43	applied	\N	\N	\N	\N	138496	138496	306042
17855	23944	44	applied	\N	\N	\N	\N	138497	138497	306043
17855	23946	46	applied	\N	\N	\N	\N	138499	138499	306045
17855	23955	47	applied	\N	\N	\N	\N	138500	138500	306046
17855	23957	48	applied	\N	\N	\N	\N	138501	138501	306047
17855	23958	49	applied	\N	\N	\N	\N	138502	138502	306048
17863	24273	0	applied	\N	\N	\N	\N	138601	138601	306147
17863	24274	1	applied	\N	\N	\N	\N	138602	138602	306148
17863	24275	2	applied	\N	\N	\N	\N	138603	138603	306149
17863	24276	3	applied	\N	\N	\N	\N	138604	138604	306150
17866	24043	0	applied	\N	\N	\N	\N	138612	138612	306158
17866	24037	1	applied	\N	\N	\N	\N	138613	138613	138613
17866	23993	2	applied	\N	\N	1000000000	\N	138614	138614	306159
17866	24195	3	applied	\N	\N	1000000000	\N	138615	138615	306160
17775	24144	9	applied	\N	\N	\N	\N	138170	138170	305723
17777	24150	1	applied	\N	\N	\N	\N	138176	138176	305729
17846	24244	0	applied	\N	\N	\N	\N	138419	138419	305969
17846	24245	1	applied	\N	\N	\N	\N	138420	138420	305970
17846	24251	2	applied	\N	\N	\N	\N	138421	138421	305971
17846	24248	3	applied	\N	\N	\N	\N	138422	138422	305972
17846	24249	4	applied	\N	\N	\N	\N	138423	138423	305973
17846	24253	5	applied	\N	\N	\N	\N	138424	138424	305974
17846	24246	6	applied	\N	\N	\N	\N	138425	138425	305975
17846	24247	7	applied	\N	\N	\N	\N	138426	138426	305976
17846	24250	8	applied	\N	\N	\N	\N	138427	138427	305977
17850	24254	0	applied	\N	\N	\N	\N	138438	138438	305988
17850	24255	1	applied	\N	\N	\N	\N	138439	138439	305989
17851	24257	0	applied	\N	\N	\N	\N	138440	138440	305990
17851	24258	1	applied	\N	\N	\N	\N	138441	138441	305991
17851	24259	2	applied	\N	\N	\N	\N	138442	138442	305992
17855	23961	50	applied	\N	\N	\N	\N	138503	138503	306049
17855	23963	51	applied	\N	\N	\N	\N	138504	138504	306050
17855	23966	53	applied	\N	\N	\N	\N	138506	138506	306052
17855	23967	54	applied	\N	\N	\N	\N	138507	138507	306053
17855	23971	55	applied	\N	\N	\N	\N	138508	138508	306054
17855	23973	56	applied	\N	\N	\N	\N	138509	138509	306055
17855	23975	57	applied	\N	\N	\N	\N	138510	138510	306056
17856	24264	0	applied	\N	\N	\N	\N	138579	138579	306125
17856	24265	1	applied	\N	\N	\N	\N	138580	138580	306126
17856	24266	2	applied	\N	\N	\N	\N	138581	138581	306127
17861	24270	0	applied	\N	\N	\N	\N	138594	138594	306140
17861	24271	1	applied	\N	\N	\N	\N	138595	138595	306141
17861	24272	2	applied	\N	\N	\N	\N	138596	138596	306142
17870	24297	0	applied	\N	\N	\N	\N	138666	138666	306207
17870	24298	1	applied	\N	\N	\N	\N	138667	138667	306208
17870	24299	2	applied	\N	\N	\N	\N	138668	138668	306209
17870	24300	3	applied	\N	\N	\N	\N	138669	138669	306210
17875	24307	0	applied	\N	\N	\N	\N	138684	138684	306225
17875	24309	2	applied	\N	\N	\N	\N	138686	138686	306227
17875	24310	3	applied	\N	\N	\N	\N	138687	138687	306228
17882	24324	0	applied	\N	\N	\N	\N	138714	138714	306255
17882	24325	1	applied	\N	\N	\N	\N	138715	138715	306256
17882	24326	3	applied	\N	\N	\N	\N	138716	138716	306257
17888	24334	0	applied	\N	\N	\N	\N	138740	138740	306281
17888	24335	1	applied	\N	\N	\N	\N	138741	138741	306282
17888	24338	2	applied	\N	\N	\N	\N	138742	138742	306283
17888	24339	3	applied	\N	\N	\N	\N	138743	138743	306284
17892	24340	0	applied	\N	\N	\N	\N	138762	138762	306303
17892	24341	1	applied	\N	\N	\N	\N	138763	138763	306304
17892	24342	2	applied	\N	\N	\N	\N	138764	138764	306305
17892	24343	3	applied	\N	\N	\N	\N	138765	138765	306306
17893	24344	0	applied	\N	\N	\N	\N	138766	138766	306307
17893	24345	1	applied	\N	\N	\N	\N	138767	138767	306308
17893	24346	2	applied	\N	\N	\N	\N	138768	138768	306309
17900	24365	1	applied	\N	\N	\N	\N	138942	138942	306481
17900	24366	2	applied	\N	\N	\N	\N	138943	138943	306482
17900	24367	3	applied	\N	\N	\N	\N	138944	138944	306483
17900	24368	4	applied	\N	\N	\N	\N	138945	138945	306484
17900	24369	5	applied	\N	\N	\N	\N	138946	138946	306485
17900	24370	6	applied	\N	\N	\N	\N	138947	138947	306486
17901	24371	0	applied	\N	\N	\N	\N	138948	138948	306487
17901	24372	1	applied	\N	\N	\N	\N	138949	138949	306488
17901	24373	2	applied	\N	\N	\N	\N	138950	138950	306489
17901	24374	3	applied	\N	\N	\N	\N	138951	138951	306490
17901	24375	4	applied	\N	\N	\N	\N	138952	138952	306491
17901	24376	5	applied	\N	\N	\N	\N	138953	138953	306492
17901	24377	6	applied	\N	\N	\N	\N	138954	138954	306493
17905	24364	0	applied	\N	\N	\N	\N	138976	138976	306515
17905	24365	1	applied	\N	\N	\N	\N	138977	138977	306516
17905	24371	2	applied	\N	\N	\N	\N	138978	138978	306517
17905	24366	4	applied	\N	\N	\N	\N	138980	138980	306519
17905	24367	5	applied	\N	\N	\N	\N	138981	138981	306520
17905	24375	6	applied	\N	\N	\N	\N	138982	138982	306521
17905	24368	7	applied	\N	\N	\N	\N	138983	138983	306522
17905	24376	8	applied	\N	\N	\N	\N	138984	138984	306523
17905	24377	9	applied	\N	\N	\N	\N	138985	138985	306524
17906	24378	0	applied	\N	\N	\N	\N	138986	138986	306525
17906	24379	1	applied	\N	\N	\N	\N	138987	138987	306526
17910	24380	0	applied	\N	\N	\N	\N	138994	138994	306533
17910	24381	1	applied	\N	\N	\N	\N	138995	138995	306534
17911	24382	0	applied	\N	\N	\N	\N	138996	138996	306535
17911	24383	1	applied	\N	\N	\N	\N	138997	138997	306536
17911	24384	2	applied	\N	\N	\N	\N	138998	138998	306537
17911	24385	3	applied	\N	\N	\N	\N	138999	138999	306538
17911	24386	4	applied	\N	\N	\N	\N	139000	139000	306539
17911	24387	5	applied	\N	\N	\N	\N	139001	139001	306540
17917	24399	1	applied	\N	\N	\N	\N	139031	139031	306570
17917	24400	2	applied	\N	\N	\N	\N	139032	139032	306571
17924	24410	0	applied	\N	\N	\N	\N	139048	139048	306587
17924	24411	1	applied	\N	\N	\N	\N	139049	139049	306588
17924	24412	2	applied	\N	\N	\N	\N	139050	139050	306589
17929	24417	0	applied	\N	\N	\N	\N	139066	139066	306603
17929	24418	1	applied	\N	\N	\N	\N	139067	139067	306604
17929	24419	2	applied	\N	\N	\N	\N	139068	139068	306605
17929	24420	3	applied	\N	\N	\N	\N	139069	139069	306606
17935	24432	0	applied	\N	\N	\N	\N	139091	139091	306627
17935	24434	1	applied	\N	\N	\N	\N	139092	139092	306628
17935	24433	2	applied	\N	\N	\N	\N	139093	139093	306629
17940	24439	0	applied	\N	\N	\N	\N	139107	139107	306642
17940	24440	1	applied	\N	\N	\N	\N	139108	139108	306643
17940	24441	2	applied	\N	\N	\N	\N	139109	139109	306644
17946	24449	0	applied	\N	\N	\N	\N	139130	139130	306665
17946	24451	2	applied	\N	\N	\N	\N	139132	139132	306667
17946	24452	3	applied	\N	\N	\N	\N	139133	139133	306668
17946	24453	4	applied	\N	\N	\N	\N	139134	139134	306669
17946	24454	5	applied	\N	\N	\N	\N	139135	139135	306670
17946	24455	6	applied	\N	\N	\N	\N	139136	139136	306671
17952	24466	0	applied	\N	\N	\N	\N	139161	139161	306696
17952	24467	1	applied	\N	\N	\N	\N	139162	139162	306697
17952	24468	2	applied	\N	\N	\N	\N	139163	139163	306698
17957	24472	0	applied	\N	\N	\N	\N	139298	139298	306829
17957	24473	1	applied	\N	\N	\N	\N	139299	139299	306830
17957	24474	2	applied	\N	\N	\N	\N	139300	139300	306831
17957	24475	3	applied	\N	\N	\N	\N	139301	139301	306832
17960	24476	0	applied	\N	\N	\N	\N	139365	139365	306887
17960	24477	1	applied	\N	\N	\N	\N	139366	139366	306888
17841	24246	4	applied	\N	\N	\N	\N	138399	138399	305949
17841	24247	5	applied	\N	\N	\N	\N	138400	138400	305950
17855	23985	62	applied	\N	\N	\N	\N	138515	138515	306061
17855	23986	63	applied	\N	\N	\N	\N	138516	138516	306062
17855	23989	64	applied	\N	\N	\N	\N	138517	138517	306063
17855	23990	65	applied	\N	\N	\N	\N	138518	138518	306064
17855	23994	66	applied	\N	\N	\N	\N	138519	138519	306065
17855	23995	67	applied	\N	\N	\N	\N	138520	138520	306066
17855	24000	68	applied	\N	\N	\N	\N	138521	138521	306067
17855	24002	69	applied	\N	\N	\N	\N	138522	138522	306068
17855	24005	70	applied	\N	\N	\N	\N	138523	138523	306069
17855	24008	71	applied	\N	\N	\N	\N	138524	138524	306070
17855	24009	72	applied	\N	\N	\N	\N	138525	138525	306071
17855	24015	73	applied	\N	\N	\N	\N	138526	138526	306072
17855	24020	74	applied	\N	\N	\N	\N	138527	138527	306073
17855	24022	75	applied	\N	\N	\N	\N	138528	138528	306074
17855	24023	76	applied	\N	\N	\N	\N	138529	138529	306075
17855	24029	77	applied	\N	\N	\N	\N	138530	138530	306076
17855	24036	79	applied	\N	\N	\N	\N	138532	138532	306078
17855	24038	80	applied	\N	\N	\N	\N	138533	138533	306079
17855	24044	81	applied	\N	\N	\N	\N	138534	138534	306080
17855	24045	82	applied	\N	\N	\N	\N	138535	138535	306081
17855	24046	83	applied	\N	\N	\N	\N	138536	138536	306082
17855	24054	84	applied	\N	\N	\N	\N	138537	138537	306083
17855	24055	85	applied	\N	\N	\N	\N	138538	138538	306084
17855	24061	86	applied	\N	\N	\N	\N	138539	138539	306085
17855	24062	87	applied	\N	\N	\N	\N	138540	138540	306086
17855	24067	88	applied	\N	\N	\N	\N	138541	138541	306087
17855	24071	89	applied	\N	\N	\N	\N	138542	138542	306088
17855	24074	90	applied	\N	\N	\N	\N	138543	138543	306089
17855	24077	91	applied	\N	\N	\N	\N	138544	138544	306090
17855	24081	92	applied	\N	\N	\N	\N	138545	138545	306091
17855	24082	93	applied	\N	\N	\N	\N	138546	138546	306092
17855	24083	94	applied	\N	\N	\N	\N	138547	138547	306093
17855	24093	96	applied	\N	\N	\N	\N	138549	138549	306095
17855	24096	97	applied	\N	\N	\N	\N	138550	138550	306096
17855	24099	98	applied	\N	\N	\N	\N	138551	138551	306097
17855	24100	99	applied	\N	\N	\N	\N	138552	138552	306098
17855	24106	100	applied	\N	\N	\N	\N	138553	138553	306099
17855	24107	101	applied	\N	\N	\N	\N	138554	138554	306100
17855	24113	102	applied	\N	\N	\N	\N	138555	138555	306101
17855	24116	103	applied	\N	\N	\N	\N	138556	138556	306102
17855	24117	104	applied	\N	\N	\N	\N	138557	138557	306103
17855	24118	105	applied	\N	\N	\N	\N	138558	138558	306104
17855	24119	106	applied	\N	\N	\N	\N	138559	138559	306105
17855	24131	107	applied	\N	\N	\N	\N	138560	138560	306106
17855	24135	108	applied	\N	\N	\N	\N	138561	138561	306107
17855	24136	109	applied	\N	\N	\N	\N	138562	138562	306108
17855	24137	110	applied	\N	\N	\N	\N	138563	138563	306109
17855	24145	111	applied	\N	\N	\N	\N	138564	138564	306110
17855	24152	113	applied	\N	\N	\N	\N	138566	138566	306112
17855	24153	114	applied	\N	\N	\N	\N	138567	138567	306113
17855	24158	115	applied	\N	\N	\N	\N	138568	138568	306114
17855	24161	116	applied	\N	\N	\N	\N	138569	138569	306115
17855	24164	117	applied	\N	\N	\N	\N	138570	138570	306116
17855	24167	118	applied	\N	\N	\N	\N	138571	138571	306117
17855	24168	119	applied	\N	\N	\N	\N	138572	138572	306118
17855	24176	120	applied	\N	\N	\N	\N	138573	138573	306119
17855	24177	121	applied	\N	\N	\N	\N	138574	138574	306120
17855	24181	122	applied	\N	\N	\N	\N	138575	138575	306121
17855	24184	123	applied	\N	\N	\N	\N	138576	138576	306122
17855	24189	124	applied	\N	\N	\N	\N	138577	138577	306123
17855	24194	125	applied	\N	\N	\N	\N	138578	138578	306124
17860	24270	0	applied	\N	\N	\N	\N	138591	138591	306137
17860	24271	1	applied	\N	\N	\N	\N	138592	138592	306138
17860	24272	2	applied	\N	\N	\N	\N	138593	138593	306139
17864	24274	1	applied	\N	\N	\N	\N	138606	138606	306152
17864	24275	2	applied	\N	\N	\N	\N	138607	138607	306153
17864	24276	3	applied	\N	\N	\N	\N	138608	138608	306154
17865	24277	0	applied	\N	\N	\N	\N	138609	138609	306155
17865	24278	1	applied	\N	\N	\N	\N	138610	138610	306156
17865	24279	2	applied	\N	\N	\N	\N	138611	138611	306157
17867	24281	0	applied	\N	\N	\N	\N	138648	138648	306189
17867	24282	1	applied	\N	\N	\N	\N	138649	138649	306190
17867	24283	2	applied	\N	\N	\N	\N	138650	138650	306191
17867	24284	3	applied	\N	\N	\N	\N	138651	138651	306192
17867	24280	4	applied	\N	\N	\N	\N	138652	138652	306193
17867	24285	5	applied	\N	\N	\N	\N	138653	138653	306194
17867	24286	6	applied	\N	\N	\N	\N	138654	138654	306195
17867	24287	7	applied	\N	\N	\N	\N	138655	138655	306196
17868	24288	0	applied	\N	\N	\N	\N	138656	138656	306197
17868	24289	1	applied	\N	\N	\N	\N	138657	138657	306198
17868	24291	3	applied	\N	\N	\N	\N	138659	138659	306200
17868	24292	4	applied	\N	\N	\N	\N	138660	138660	306201
17868	24293	5	applied	\N	\N	\N	\N	138661	138661	306202
17868	24294	6	applied	\N	\N	\N	\N	138662	138662	306203
17868	24295	7	applied	\N	\N	\N	\N	138663	138663	306204
17868	24296	8	applied	\N	\N	\N	\N	138664	138664	306205
17869	24280	0	applied	\N	\N	\N	\N	138665	138665	306206
17874	24307	0	applied	\N	\N	\N	\N	138680	138680	306221
17874	24308	1	applied	\N	\N	\N	\N	138681	138681	306222
17874	24309	2	applied	\N	\N	\N	\N	138682	138682	306223
17874	24310	3	applied	\N	\N	\N	\N	138683	138683	306224
17881	24324	0	applied	\N	\N	\N	\N	138711	138711	306252
17881	24325	1	applied	\N	\N	\N	\N	138712	138712	306253
17881	24326	3	applied	\N	\N	\N	\N	138713	138713	306254
17887	24334	0	applied	\N	\N	\N	\N	138734	138734	306275
17887	24335	1	applied	\N	\N	\N	\N	138735	138735	306276
17887	24337	3	applied	\N	\N	\N	\N	138737	138737	306278
17887	24338	4	applied	\N	\N	\N	\N	138738	138738	306279
17887	24339	5	applied	\N	\N	\N	\N	138739	138739	306280
17891	24340	0	applied	\N	\N	\N	\N	138756	138756	306297
17891	24341	1	applied	\N	\N	\N	\N	138757	138757	306298
17891	24342	2	applied	\N	\N	\N	\N	138758	138758	306299
17960	24478	2	applied	\N	\N	\N	\N	139367	139367	306889
17960	24479	3	applied	\N	\N	\N	\N	139368	139368	306890
17960	24480	4	applied	\N	\N	\N	\N	139369	139369	306891
17960	24481	5	applied	\N	\N	\N	\N	139370	139370	306892
17966	24492	0	applied	\N	\N	\N	\N	139495	139495	307008
17966	24493	1	applied	\N	\N	\N	\N	139496	139496	307009
17966	24494	2	applied	\N	\N	\N	\N	139497	139497	307010
17966	24495	3	applied	\N	\N	\N	\N	139498	139498	307011
17855	23979	59	applied	\N	\N	\N	\N	138512	138512	306058
17855	23981	60	applied	\N	\N	\N	\N	138513	138513	306059
17866	24121	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	138619	138619	\N
17866	23996	9	applied	\N	\N	\N	\N	138621	138621	306162
17866	24280	10	applied	\N	\N	\N	\N	138622	138622	306163
17866	24014	11	applied	\N	\N	\N	\N	138623	138623	306164
17866	24018	12	applied	\N	\N	\N	\N	138624	138624	306165
17866	24035	13	applied	\N	\N	\N	\N	138625	138625	306166
17866	24049	14	applied	\N	\N	\N	\N	138626	138626	306167
17866	24059	15	applied	\N	\N	\N	\N	138627	138627	306168
17866	24069	16	applied	\N	\N	\N	\N	138628	138628	306169
17866	24080	17	applied	\N	\N	\N	\N	138629	138629	306170
17866	24092	18	applied	\N	\N	\N	\N	138630	138630	306171
17866	24102	19	applied	\N	\N	\N	\N	138631	138631	306172
17866	24111	20	applied	\N	\N	\N	\N	138632	138632	306173
17866	24128	21	applied	\N	\N	\N	\N	138633	138633	306174
17866	24139	22	applied	\N	\N	\N	\N	138634	138634	306175
17866	24146	23	applied	\N	\N	\N	\N	138635	138635	306176
17866	24156	24	applied	\N	\N	\N	\N	138636	138636	306177
17866	24171	25	applied	\N	\N	\N	\N	138637	138637	306178
17866	24178	26	applied	\N	\N	\N	\N	138638	138638	306179
17866	24191	27	applied	\N	\N	\N	\N	138639	138639	306180
17866	24198	28	applied	\N	\N	\N	\N	138640	138640	306181
17866	24209	29	applied	\N	\N	\N	\N	138641	138641	306182
17866	24218	30	applied	\N	\N	\N	\N	138642	138642	306183
17866	24233	31	applied	\N	\N	\N	\N	138643	138643	306184
17866	24239	32	applied	\N	\N	\N	\N	138644	138644	306185
17866	24252	33	applied	\N	\N	\N	\N	138645	138645	306186
17866	24266	34	applied	\N	\N	\N	\N	138646	138646	306187
17866	24274	35	applied	\N	\N	\N	\N	138647	138647	306188
17872	24301	0	applied	\N	\N	\N	\N	138674	138674	306215
17872	24302	1	applied	\N	\N	\N	\N	138675	138675	306216
17873	24304	0	applied	\N	\N	\N	\N	138677	138677	306218
17873	24305	1	applied	\N	\N	\N	\N	138678	138678	306219
17873	24306	2	applied	\N	\N	\N	\N	138679	138679	306220
17878	24311	0	applied	\N	\N	\N	\N	138695	138695	306236
17878	24312	1	applied	\N	\N	\N	\N	138696	138696	306237
17878	24313	2	applied	\N	\N	\N	\N	138697	138697	306238
17879	24314	0	applied	\N	\N	\N	\N	138698	138698	306239
17879	24315	1	applied	\N	\N	\N	\N	138699	138699	306240
17879	24316	2	applied	\N	\N	\N	\N	138700	138700	306241
17879	24317	3	applied	\N	\N	\N	\N	138701	138701	306242
17879	24318	4	applied	\N	\N	\N	\N	138702	138702	306243
17879	24319	5	applied	\N	\N	\N	\N	138703	138703	306244
17879	24320	6	applied	\N	\N	\N	\N	138704	138704	306245
17879	24321	7	applied	\N	\N	\N	\N	138705	138705	306246
17879	24322	8	applied	\N	\N	\N	\N	138706	138706	306247
17879	24323	9	applied	\N	\N	\N	\N	138707	138707	306248
17880	24325	1	applied	\N	\N	\N	\N	138709	138709	306250
17880	24326	3	applied	\N	\N	\N	\N	138710	138710	306251
17885	24327	0	applied	\N	\N	\N	\N	138727	138727	306268
17885	24328	1	applied	\N	\N	\N	\N	138728	138728	306269
17885	24329	2	applied	\N	\N	\N	\N	138729	138729	306270
17885	24330	3	applied	\N	\N	\N	\N	138730	138730	306271
17885	24331	4	applied	\N	\N	\N	\N	138731	138731	306272
17885	24332	5	applied	\N	\N	\N	\N	138732	138732	306273
17885	24333	6	applied	\N	\N	\N	\N	138733	138733	306274
17890	24340	0	applied	\N	\N	\N	\N	138750	138750	306291
17890	24341	1	applied	\N	\N	\N	\N	138751	138751	306292
17890	24342	2	applied	\N	\N	\N	\N	138752	138752	306293
17890	24336	3	applied	\N	\N	\N	\N	138753	138753	306294
17890	24337	4	applied	\N	\N	\N	\N	138754	138754	306295
17890	24343	5	applied	\N	\N	\N	\N	138755	138755	306296
17891	24336	3	applied	\N	\N	\N	\N	138759	138759	306300
17891	24343	5	applied	\N	\N	\N	\N	138761	138761	306302
17895	24344	0	applied	\N	\N	\N	\N	138772	138772	306313
17895	24345	1	applied	\N	\N	\N	\N	138773	138773	306314
17895	24346	2	applied	\N	\N	\N	\N	138774	138774	306315
17896	24195	0	applied	\N	\N	1000000000	\N	138775	138775	306316
17896	24167	1	applied	\N	\N	\N	\N	138776	138776	306317
17896	24168	2	applied	\N	\N	\N	\N	138777	138777	306318
17896	24176	3	applied	\N	\N	\N	\N	138778	138778	306319
17896	24177	4	applied	\N	\N	\N	\N	138779	138779	306320
17897	24347	0	applied	\N	\N	1000000000	\N	138900	138900	306439
17897	24348	1	applied	\N	\N	\N	\N	138901	138901	306440
17897	24349	2	applied	\N	\N	\N	\N	138902	138902	306441
17897	24350	3	applied	\N	\N	\N	\N	138903	138903	306442
17897	24351	4	applied	\N	\N	\N	\N	138904	138904	306443
17897	24352	5	applied	\N	\N	\N	\N	138905	138905	306444
17897	24353	6	applied	\N	\N	\N	\N	138906	138906	306445
17897	24355	8	applied	\N	\N	\N	\N	138908	138908	306447
17897	24356	9	applied	\N	\N	\N	\N	138909	138909	306448
17897	24357	10	applied	\N	\N	\N	\N	138910	138910	306449
17897	24358	11	applied	\N	\N	\N	\N	138911	138911	306450
17897	24359	12	applied	\N	\N	\N	\N	138912	138912	306451
17897	24360	13	applied	\N	\N	\N	\N	138913	138913	306452
17897	24361	14	applied	\N	\N	\N	\N	138914	138914	306453
17897	24362	15	applied	\N	\N	\N	\N	138915	138915	306454
17897	24363	16	applied	\N	\N	\N	\N	138916	138916	306455
17903	24371	0	applied	\N	\N	\N	\N	138962	138962	306501
17903	24372	1	applied	\N	\N	\N	\N	138963	138963	306502
17903	24373	2	applied	\N	\N	\N	\N	138964	138964	306503
17903	24374	3	applied	\N	\N	\N	\N	138965	138965	306504
17903	24375	4	applied	\N	\N	\N	\N	138966	138966	306505
17903	24376	5	applied	\N	\N	\N	\N	138967	138967	306506
17903	24377	6	applied	\N	\N	\N	\N	138968	138968	306507
17908	24379	1	applied	\N	\N	\N	\N	138991	138991	306530
17913	24382	0	applied	\N	\N	\N	\N	139008	139008	306547
17913	24383	1	applied	\N	\N	\N	\N	139009	139009	306548
17913	24384	2	applied	\N	\N	\N	\N	139010	139010	306549
17913	24385	3	applied	\N	\N	\N	\N	139011	139011	306550
17913	24386	4	applied	\N	\N	\N	\N	139012	139012	306551
17913	24387	5	applied	\N	\N	\N	\N	139013	139013	306552
17921	24403	0	applied	\N	\N	\N	\N	139038	139038	306577
17921	24404	1	applied	\N	\N	\N	\N	139039	139039	306578
17921	24405	2	applied	\N	\N	\N	\N	139040	139040	306579
17921	24406	3	applied	\N	\N	\N	\N	139041	139041	306580
17922	24407	0	applied	\N	\N	\N	\N	139042	139042	306581
17922	24408	1	applied	\N	\N	\N	\N	139043	139043	306582
17922	24409	2	applied	\N	\N	\N	\N	139044	139044	306583
17927	24413	0	applied	\N	\N	\N	\N	139058	139058	306596
17866	24133	8	applied	\N	\N	\N	\N	138620	138620	306161
17894	24346	2	applied	\N	\N	\N	\N	138771	138771	306312
17902	24371	0	applied	\N	\N	\N	\N	138955	138955	306494
17902	24372	1	applied	\N	\N	\N	\N	138956	138956	306495
17902	24373	2	applied	\N	\N	\N	\N	138957	138957	306496
17902	24374	3	applied	\N	\N	\N	\N	138958	138958	306497
17902	24375	4	applied	\N	\N	\N	\N	138959	138959	306498
17902	24376	5	applied	\N	\N	\N	\N	138960	138960	306499
17902	24377	6	applied	\N	\N	\N	\N	138961	138961	306500
17907	24378	0	applied	\N	\N	\N	\N	138988	138988	306527
17907	24379	1	applied	\N	\N	\N	\N	138989	138989	306528
17912	24382	0	applied	\N	\N	\N	\N	139002	139002	306541
17912	24383	1	applied	\N	\N	\N	\N	139003	139003	306542
17912	24384	2	applied	\N	\N	\N	\N	139004	139004	306543
17912	24386	4	applied	\N	\N	\N	\N	139006	139006	306545
17912	24387	5	applied	\N	\N	\N	\N	139007	139007	306546
17918	24398	0	applied	\N	\N	\N	\N	139033	139033	306572
17918	24399	1	applied	\N	\N	\N	\N	139034	139034	306573
17918	24400	2	applied	\N	\N	\N	\N	139035	139035	306574
17923	24410	0	applied	\N	\N	\N	\N	139045	139045	306584
17923	24411	1	applied	\N	\N	\N	\N	139046	139046	306585
17923	24412	2	applied	\N	\N	\N	\N	139047	139047	306586
17927	24414	1	applied	\N	\N	\N	\N	139059	139059	139059
17927	24415	2	applied	\N	\N	\N	\N	139060	139060	306597
17927	24416	3	applied	\N	\N	\N	\N	139061	139061	306598
17928	24417	0	applied	\N	\N	\N	\N	139062	139062	306599
17928	24418	1	applied	\N	\N	\N	\N	139063	139063	306600
17928	24419	2	applied	\N	\N	\N	\N	139064	139064	306601
17928	24420	3	applied	\N	\N	\N	\N	139065	139065	306602
17931	24417	0	applied	\N	\N	\N	\N	139074	139074	306611
17931	24419	2	applied	\N	\N	\N	\N	139076	139076	306613
17931	24420	3	applied	\N	\N	\N	\N	139077	139077	306614
17932	24421	0	applied	\N	\N	\N	\N	139078	139078	306615
17934	24432	0	applied	\N	\N	\N	\N	139089	139089	306625
17934	24433	1	applied	\N	\N	\N	\N	139090	139090	306626
17939	24435	0	applied	\N	\N	\N	\N	139103	139103	306639
17939	24436	1	applied	\N	\N	\N	\N	139104	139104	306640
17939	24438	2	applied	\N	\N	\N	\N	139105	139105	139105
17939	24437	3	applied	\N	\N	\N	\N	139106	139106	306641
17944	24446	0	applied	\N	\N	\N	\N	139120	139120	306655
17944	24447	1	applied	\N	\N	\N	\N	139121	139121	306656
17944	24448	2	applied	\N	\N	\N	\N	139122	139122	306657
17945	24449	0	applied	\N	\N	\N	\N	139123	139123	306658
17945	24450	1	applied	\N	\N	\N	\N	139124	139124	306659
17945	24451	2	applied	\N	\N	\N	\N	139125	139125	306660
17945	24452	3	applied	\N	\N	\N	\N	139126	139126	306661
17945	24454	5	applied	\N	\N	\N	\N	139128	139128	306663
17945	24455	6	applied	\N	\N	\N	\N	139129	139129	306664
17950	24459	0	applied	\N	\N	\N	\N	139154	139154	306689
17950	24460	1	applied	\N	\N	\N	\N	139155	139155	306690
17950	24461	2	applied	\N	\N	\N	\N	139156	139156	306691
17951	24462	0	applied	\N	\N	\N	\N	139157	139157	306692
17951	24463	1	applied	\N	\N	\N	\N	139158	139158	306693
17951	24464	2	applied	\N	\N	\N	\N	139159	139159	306694
17951	24465	3	applied	\N	\N	\N	\N	139160	139160	306695
17956	24469	0	applied	\N	\N	\N	\N	139295	139295	306826
17956	24470	1	applied	\N	\N	\N	\N	139296	139296	306827
17956	24471	2	applied	\N	\N	\N	\N	139297	139297	306828
17959	24043	0	applied	\N	\N	\N	\N	139306	139306	306837
17959	24037	1	applied	\N	\N	\N	\N	139307	139307	139307
17959	24028	2	applied	\N	\N	\N	\N	139308	139308	139308
17959	24347	5	applied	\N	\N	1000000000	\N	139311	139311	306840
17959	24414	7	applied	\N	\N	\N	\N	139313	139313	139313
17959	24120	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	139312	139312	\N
17959	24133	11	applied	\N	\N	\N	\N	139317	139317	306841
17959	24190	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	139314	139314	\N
17959	24261	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	139315	139315	\N
17959	24121	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	139316	139316	\N
17959	23996	12	applied	\N	\N	\N	\N	139318	139318	306842
17959	24423	13	applied	\N	\N	\N	\N	139319	139319	139319
17959	24438	14	applied	\N	\N	\N	\N	139320	139320	139320
17959	24280	15	applied	\N	\N	\N	\N	139321	139321	306843
17959	24014	16	applied	\N	\N	\N	\N	139322	139322	306844
17959	24018	17	applied	\N	\N	\N	\N	139323	139323	306845
17959	24035	18	applied	\N	\N	\N	\N	139324	139324	306846
17959	24049	19	applied	\N	\N	\N	\N	139325	139325	306847
17959	24059	20	applied	\N	\N	\N	\N	139326	139326	306848
17959	24069	21	applied	\N	\N	\N	\N	139327	139327	306849
17959	24080	22	applied	\N	\N	\N	\N	139328	139328	306850
17959	24102	24	applied	\N	\N	\N	\N	139330	139330	306852
17959	24111	25	applied	\N	\N	\N	\N	139331	139331	306853
17959	24128	26	applied	\N	\N	\N	\N	139332	139332	306854
17959	24139	27	applied	\N	\N	\N	\N	139333	139333	306855
17959	24146	28	applied	\N	\N	\N	\N	139334	139334	306856
17959	24156	29	applied	\N	\N	\N	\N	139335	139335	306857
17959	24171	30	applied	\N	\N	\N	\N	139336	139336	306858
17959	24178	31	applied	\N	\N	\N	\N	139337	139337	306859
17959	24191	32	applied	\N	\N	\N	\N	139338	139338	306860
17959	24198	33	applied	\N	\N	\N	\N	139339	139339	306861
17959	24209	34	applied	\N	\N	\N	\N	139340	139340	306862
17959	24218	35	applied	\N	\N	\N	\N	139341	139341	306863
17959	24233	36	applied	\N	\N	\N	\N	139342	139342	306864
17959	24239	37	applied	\N	\N	\N	\N	139343	139343	306865
17959	24252	38	applied	\N	\N	\N	\N	139344	139344	306866
17959	24266	39	applied	\N	\N	\N	\N	139345	139345	306867
17959	24284	41	applied	\N	\N	\N	\N	139347	139347	306869
17959	24298	42	applied	\N	\N	\N	\N	139348	139348	306870
17959	24309	43	applied	\N	\N	\N	\N	139349	139349	306871
17959	24318	44	applied	\N	\N	\N	\N	139350	139350	306872
17959	24331	45	applied	\N	\N	\N	\N	139351	139351	306873
17959	24341	46	applied	\N	\N	\N	\N	139352	139352	306874
17959	24353	47	applied	\N	\N	\N	\N	139353	139353	306875
17959	24367	48	applied	\N	\N	\N	\N	139354	139354	306876
17959	24375	49	applied	\N	\N	\N	\N	139355	139355	306877
17959	24384	50	applied	\N	\N	\N	\N	139356	139356	306878
17959	24394	51	applied	\N	\N	\N	\N	139357	139357	306879
17959	24404	52	applied	\N	\N	\N	\N	139358	139358	306880
17959	24420	53	applied	\N	\N	\N	\N	139359	139359	306881
17894	24344	0	applied	\N	\N	\N	\N	138769	138769	306310
17894	24345	1	applied	\N	\N	\N	\N	138770	138770	306311
17896	24194	8	applied	\N	\N	\N	\N	138783	138783	306324
17896	24211	10	applied	\N	\N	\N	\N	138785	138785	306326
17896	24214	11	applied	\N	\N	\N	\N	138786	138786	306327
17896	24217	12	applied	\N	\N	\N	\N	138787	138787	306328
17896	24221	13	applied	\N	\N	\N	\N	138788	138788	306329
17896	24224	14	applied	\N	\N	\N	\N	138789	138789	306330
17896	24225	15	applied	\N	\N	\N	\N	138790	138790	306331
17896	24230	16	applied	\N	\N	\N	\N	138791	138791	306332
17896	24234	17	applied	\N	\N	\N	\N	138792	138792	306333
17896	24237	18	applied	\N	\N	\N	\N	138793	138793	306334
17896	24238	19	applied	\N	\N	\N	\N	138794	138794	306335
17896	24244	20	applied	\N	\N	\N	\N	138795	138795	306336
17896	24245	21	applied	\N	\N	\N	\N	138796	138796	306337
17896	24251	22	applied	\N	\N	\N	\N	138797	138797	306338
17896	24254	23	applied	\N	\N	\N	\N	138798	138798	306339
17896	24257	24	applied	\N	\N	\N	\N	138799	138799	306340
17896	24260	25	applied	\N	\N	\N	\N	138800	138800	306341
17896	24267	27	applied	\N	\N	\N	\N	138802	138802	306343
17896	24270	28	applied	\N	\N	\N	\N	138803	138803	306344
17896	24273	29	applied	\N	\N	\N	\N	138804	138804	306345
17896	24277	30	applied	\N	\N	\N	\N	138805	138805	306346
17896	24281	31	applied	\N	\N	\N	\N	138806	138806	306347
17896	24282	32	applied	\N	\N	\N	\N	138807	138807	306348
17896	24288	33	applied	\N	\N	\N	\N	138808	138808	306349
17896	24289	34	applied	\N	\N	\N	\N	138809	138809	306350
17896	24290	35	applied	\N	\N	\N	\N	138810	138810	306351
17896	24297	36	applied	\N	\N	\N	\N	138811	138811	306352
17896	24301	37	applied	\N	\N	\N	\N	138812	138812	306353
17896	24304	38	applied	\N	\N	\N	\N	138813	138813	306354
17896	24307	39	applied	\N	\N	\N	\N	138814	138814	306355
17896	24311	40	applied	\N	\N	\N	\N	138815	138815	306356
17896	24314	41	applied	\N	\N	\N	\N	138816	138816	306357
17896	24315	42	applied	\N	\N	\N	\N	138817	138817	306358
17896	24324	44	applied	\N	\N	\N	\N	138819	138819	306360
17896	24327	45	applied	\N	\N	\N	\N	138820	138820	306361
17896	24328	46	applied	\N	\N	\N	\N	138821	138821	306362
17896	24334	47	applied	\N	\N	\N	\N	138822	138822	306363
17896	24335	48	applied	\N	\N	\N	\N	138823	138823	306364
17896	24340	49	applied	\N	\N	\N	\N	138824	138824	306365
17896	24344	50	applied	\N	\N	\N	\N	138825	138825	306366
17896	24280	53	applied	\N	\N	\N	\N	138828	138828	306367
17896	24190	51	failed	Amount_insufficient_to_create_account	\N	\N	\N	138826	138826	\N
17896	24169	54	applied	\N	\N	\N	\N	138829	138829	306368
17896	24170	55	applied	\N	\N	\N	\N	138830	138830	306369
17896	24175	56	applied	\N	\N	\N	\N	138831	138831	306370
17896	24179	57	applied	\N	\N	\N	\N	138832	138832	306371
17896	24182	58	applied	\N	\N	\N	\N	138833	138833	306372
17896	24171	59	applied	\N	\N	\N	\N	138834	138834	306373
17896	24178	60	applied	\N	\N	\N	\N	138835	138835	306374
17896	24191	61	applied	\N	\N	\N	\N	138836	138836	306375
17896	24198	62	applied	\N	\N	\N	\N	138837	138837	306376
17896	24209	63	applied	\N	\N	\N	\N	138838	138838	306377
17896	24218	64	applied	\N	\N	\N	\N	138839	138839	306378
17896	24172	65	applied	\N	\N	\N	\N	138840	138840	306379
17896	24173	66	applied	\N	\N	\N	\N	138841	138841	306380
17896	24174	67	applied	\N	\N	\N	\N	138842	138842	306381
17896	24180	68	applied	\N	\N	\N	\N	138843	138843	306382
17896	24183	69	applied	\N	\N	\N	\N	138844	138844	306383
17896	24185	70	applied	\N	\N	\N	\N	138845	138845	306384
17896	24186	71	applied	\N	\N	\N	\N	138846	138846	306385
17896	24187	72	applied	\N	\N	\N	\N	138847	138847	306386
17896	24192	73	applied	\N	\N	\N	\N	138848	138848	306387
17896	24201	74	applied	\N	\N	\N	\N	138849	138849	306388
17896	24202	75	applied	\N	\N	\N	\N	138850	138850	306389
17896	24188	76	applied	\N	\N	\N	\N	138851	138851	306390
17896	24193	77	applied	\N	\N	\N	\N	138852	138852	306391
17896	24197	78	applied	\N	\N	\N	\N	138853	138853	306392
17896	24199	79	applied	\N	\N	\N	\N	138854	138854	306393
17896	24200	80	applied	\N	\N	\N	\N	138855	138855	306394
17896	24204	81	applied	\N	\N	\N	\N	138856	138856	306395
17896	24206	82	applied	\N	\N	\N	\N	138857	138857	306396
17896	24208	83	applied	\N	\N	\N	\N	138858	138858	306397
17896	24212	84	applied	\N	\N	\N	\N	138859	138859	306398
17896	24220	86	applied	\N	\N	\N	\N	138861	138861	306400
17896	24203	87	applied	\N	\N	\N	\N	138862	138862	306401
17896	24205	88	applied	\N	\N	\N	\N	138863	138863	306402
17896	24207	89	applied	\N	\N	\N	\N	138864	138864	306403
17896	24210	90	applied	\N	\N	\N	\N	138865	138865	306404
17896	24213	91	applied	\N	\N	\N	\N	138866	138866	306405
17896	24215	92	applied	\N	\N	\N	\N	138867	138867	306406
17896	24219	93	applied	\N	\N	\N	\N	138868	138868	306407
17896	24222	94	applied	\N	\N	\N	\N	138869	138869	306408
17896	24226	95	applied	\N	\N	\N	\N	138870	138870	306409
17896	24227	96	applied	\N	\N	\N	\N	138871	138871	306410
17896	24231	97	applied	\N	\N	\N	\N	138872	138872	306411
17896	24235	98	applied	\N	\N	\N	\N	138873	138873	306412
17896	24223	99	applied	\N	\N	\N	\N	138874	138874	306413
17896	24233	100	applied	\N	\N	\N	\N	138875	138875	306414
17896	24239	101	applied	\N	\N	\N	\N	138876	138876	306415
17896	24266	103	applied	\N	\N	\N	\N	138878	138878	306417
17896	24274	105	applied	\N	\N	\N	\N	138879	138879	306418
17896	24284	106	applied	\N	\N	\N	\N	138880	138880	306419
17896	24298	107	applied	\N	\N	\N	\N	138881	138881	306420
17896	24309	108	applied	\N	\N	\N	\N	138882	138882	306421
17896	24318	109	applied	\N	\N	\N	\N	138883	138883	306422
17896	24331	110	applied	\N	\N	\N	\N	138884	138884	306423
17896	24341	111	applied	\N	\N	\N	\N	138885	138885	306424
17896	24228	112	applied	\N	\N	\N	\N	138886	138886	306425
17896	24229	113	applied	\N	\N	\N	\N	138887	138887	306426
17896	24232	114	applied	\N	\N	\N	\N	138888	138888	306427
17896	24236	115	applied	\N	\N	\N	\N	138889	138889	306428
17896	24240	116	applied	\N	\N	\N	\N	138890	138890	306429
17959	24429	54	applied	\N	\N	\N	\N	139360	139360	306882
17959	24440	55	applied	\N	\N	\N	\N	139361	139361	306883
17959	24454	56	applied	\N	\N	\N	\N	139362	139362	306884
17959	24474	58	applied	\N	\N	\N	\N	139364	139364	306886
17965	24492	0	applied	\N	\N	\N	\N	139485	139485	306998
17965	24493	1	applied	\N	\N	\N	\N	139486	139486	306999
17965	24494	2	applied	\N	\N	\N	\N	139487	139487	307000
17896	24184	6	applied	\N	\N	\N	\N	138781	138781	306322
17896	24189	7	applied	\N	\N	\N	\N	138782	138782	306323
17896	24250	120	applied	\N	\N	\N	\N	138894	138894	306433
17896	24255	121	applied	\N	\N	\N	\N	138895	138895	306434
17896	24259	122	applied	\N	\N	\N	\N	138896	138896	306435
17896	24262	123	applied	\N	\N	\N	\N	138897	138897	306436
17896	24265	124	applied	\N	\N	\N	\N	138898	138898	306437
17896	24269	125	applied	\N	\N	\N	\N	138899	138899	306438
17898	24347	0	applied	\N	\N	1000000000	\N	138917	138917	306456
17898	24348	1	applied	\N	\N	\N	\N	138918	138918	306457
17898	24349	2	applied	\N	\N	\N	\N	138919	138919	306458
17898	24350	3	applied	\N	\N	\N	\N	138920	138920	306459
17898	24351	4	applied	\N	\N	\N	\N	138921	138921	306460
17898	24353	6	applied	\N	\N	\N	\N	138923	138923	306462
17898	24354	7	applied	\N	\N	\N	\N	138924	138924	306463
17898	24355	8	applied	\N	\N	\N	\N	138925	138925	306464
17898	24356	9	applied	\N	\N	\N	\N	138926	138926	306465
17898	24357	10	applied	\N	\N	\N	\N	138927	138927	306466
17898	24358	11	applied	\N	\N	\N	\N	138928	138928	306467
17898	24359	12	applied	\N	\N	\N	\N	138929	138929	306468
17898	24360	13	applied	\N	\N	\N	\N	138930	138930	306469
17898	24361	14	applied	\N	\N	\N	\N	138931	138931	306470
17898	24362	15	applied	\N	\N	\N	\N	138932	138932	306471
17898	24363	16	applied	\N	\N	\N	\N	138933	138933	306472
17899	24364	0	applied	\N	\N	\N	\N	138934	138934	306473
17899	24365	1	applied	\N	\N	\N	\N	138935	138935	306474
17899	24366	2	applied	\N	\N	\N	\N	138936	138936	306475
17899	24367	3	applied	\N	\N	\N	\N	138937	138937	306476
17899	24368	4	applied	\N	\N	\N	\N	138938	138938	306477
17899	24370	6	applied	\N	\N	\N	\N	138940	138940	306479
17904	24371	0	applied	\N	\N	\N	\N	138969	138969	306508
17904	24372	1	applied	\N	\N	\N	\N	138970	138970	306509
17904	24373	2	applied	\N	\N	\N	\N	138971	138971	306510
17904	24374	3	applied	\N	\N	\N	\N	138972	138972	306511
17904	24375	4	applied	\N	\N	\N	\N	138973	138973	306512
17904	24376	5	applied	\N	\N	\N	\N	138974	138974	306513
17904	24377	6	applied	\N	\N	\N	\N	138975	138975	306514
17909	24380	0	applied	\N	\N	\N	\N	138992	138992	306531
17909	24381	1	applied	\N	\N	\N	\N	138993	138993	306532
17914	24382	0	applied	\N	\N	\N	\N	139014	139014	306553
17914	24383	1	applied	\N	\N	\N	\N	139015	139015	306554
17914	24384	2	applied	\N	\N	\N	\N	139016	139016	306555
17914	24385	3	applied	\N	\N	\N	\N	139017	139017	306556
17914	24386	4	applied	\N	\N	\N	\N	139018	139018	306557
17914	24387	5	applied	\N	\N	\N	\N	139019	139019	306558
17915	24389	1	applied	\N	\N	\N	\N	139021	139021	306560
17915	24390	2	applied	\N	\N	\N	\N	139022	139022	306561
17916	24391	0	applied	\N	\N	\N	\N	139023	139023	306562
17916	24392	1	applied	\N	\N	\N	\N	139024	139024	306563
17916	24393	2	applied	\N	\N	\N	\N	139025	139025	306564
17916	24394	3	applied	\N	\N	\N	\N	139026	139026	306565
17916	24395	4	applied	\N	\N	\N	\N	139027	139027	306566
17916	24396	5	applied	\N	\N	\N	\N	139028	139028	306567
17916	24397	6	applied	\N	\N	\N	\N	139029	139029	306568
17920	24401	0	applied	\N	\N	\N	\N	139036	139036	306575
17920	24402	1	applied	\N	\N	\N	\N	139037	139037	306576
17925	24410	0	applied	\N	\N	\N	\N	139051	139051	306590
17925	24411	1	applied	\N	\N	\N	\N	139052	139052	306591
17925	24412	2	applied	\N	\N	\N	\N	139053	139053	306592
17926	24413	0	applied	\N	\N	\N	\N	139054	139054	306593
17926	24414	1	applied	\N	\N	\N	\N	139055	139055	139055
17926	24416	3	applied	\N	\N	\N	\N	139057	139057	306595
17930	24417	0	applied	\N	\N	\N	\N	139070	139070	306607
17930	24418	1	applied	\N	\N	\N	\N	139071	139071	306608
17930	24419	2	applied	\N	\N	\N	\N	139072	139072	306609
17930	24420	3	applied	\N	\N	\N	\N	139073	139073	306610
17936	24432	0	applied	\N	\N	\N	\N	139094	139094	306630
17936	24434	1	applied	\N	\N	\N	\N	139095	139095	306631
17936	24433	2	applied	\N	\N	\N	\N	139096	139096	306632
17941	24439	0	applied	\N	\N	\N	\N	139110	139110	306645
17941	24440	1	applied	\N	\N	\N	\N	139111	139111	306646
17941	24442	2	applied	\N	\N	\N	\N	139112	139112	306647
17941	24441	3	applied	\N	\N	\N	\N	139113	139113	306648
17942	24443	0	applied	\N	\N	\N	\N	139114	139114	306649
17942	24444	1	applied	\N	\N	\N	\N	139115	139115	306650
17942	24445	2	applied	\N	\N	\N	\N	139116	139116	306651
17947	24449	0	applied	\N	\N	\N	\N	139137	139137	306672
17947	24451	2	applied	\N	\N	\N	\N	139139	139139	306674
17947	24452	3	applied	\N	\N	\N	\N	139140	139140	306675
17947	24453	4	applied	\N	\N	\N	\N	139141	139141	306676
17947	24454	5	applied	\N	\N	\N	\N	139142	139142	306677
17947	24455	6	applied	\N	\N	\N	\N	139143	139143	306678
17953	24196	0	applied	\N	\N	\N	\N	139164	139164	306699
17953	24211	1	applied	\N	\N	\N	\N	139165	139165	306700
17953	24214	2	applied	\N	\N	\N	\N	139166	139166	306701
17953	24195	3	applied	\N	\N	1000000000	\N	139167	139167	306702
17953	24347	4	applied	\N	\N	1000000000	\N	139168	139168	306703
17953	24217	5	applied	\N	\N	\N	\N	139169	139169	306704
17953	24221	6	applied	\N	\N	\N	\N	139170	139170	306705
17953	24224	7	applied	\N	\N	\N	\N	139171	139171	306706
17953	24225	8	applied	\N	\N	\N	\N	139172	139172	306707
17953	24230	9	applied	\N	\N	\N	\N	139173	139173	306708
17953	24234	10	applied	\N	\N	\N	\N	139174	139174	306709
17953	24238	12	applied	\N	\N	\N	\N	139176	139176	306711
17953	24244	13	applied	\N	\N	\N	\N	139177	139177	306712
17953	24245	14	applied	\N	\N	\N	\N	139178	139178	306713
17953	24251	15	applied	\N	\N	\N	\N	139179	139179	306714
17953	24254	16	applied	\N	\N	\N	\N	139180	139180	306715
17953	24257	17	applied	\N	\N	\N	\N	139181	139181	306716
17953	24260	18	applied	\N	\N	\N	\N	139182	139182	306717
17953	24264	19	applied	\N	\N	\N	\N	139183	139183	306718
17953	24267	20	applied	\N	\N	\N	\N	139184	139184	306719
17953	24270	21	applied	\N	\N	\N	\N	139185	139185	306720
17953	24273	22	applied	\N	\N	\N	\N	139186	139186	306721
17953	24277	23	applied	\N	\N	\N	\N	139187	139187	306722
17953	24281	24	applied	\N	\N	\N	\N	139188	139188	306723
17953	24282	25	applied	\N	\N	\N	\N	139189	139189	306724
17953	24288	26	applied	\N	\N	\N	\N	139190	139190	306725
17953	24289	27	applied	\N	\N	\N	\N	139191	139191	306726
17953	24297	29	applied	\N	\N	\N	\N	139193	139193	306728
17953	24301	30	applied	\N	\N	\N	\N	139194	139194	306729
17896	24246	118	applied	\N	\N	\N	\N	138892	138892	306431
17896	24247	119	applied	\N	\N	\N	\N	138893	138893	306432
17932	24425	4	applied	\N	\N	\N	\N	139082	139082	306618
17932	24426	5	applied	\N	\N	\N	\N	139083	139083	306619
17932	24427	6	applied	\N	\N	\N	\N	139084	139084	306620
17933	24428	0	applied	\N	\N	\N	\N	139085	139085	306621
17933	24429	1	applied	\N	\N	\N	\N	139086	139086	306622
17933	24430	2	applied	\N	\N	\N	\N	139087	139087	306623
17933	24431	3	applied	\N	\N	\N	\N	139088	139088	306624
17937	24432	0	applied	\N	\N	\N	\N	139097	139097	306633
17937	24434	1	applied	\N	\N	\N	\N	139098	139098	306634
17937	24433	2	applied	\N	\N	\N	\N	139099	139099	306635
17938	24435	0	applied	\N	\N	\N	\N	139100	139100	306636
17938	24436	1	applied	\N	\N	\N	\N	139101	139101	306637
17938	24437	2	applied	\N	\N	\N	\N	139102	139102	306638
17943	24444	1	applied	\N	\N	\N	\N	139118	139118	306653
17943	24445	2	applied	\N	\N	\N	\N	139119	139119	306654
17948	24449	0	applied	\N	\N	\N	\N	139144	139144	306679
17948	24450	1	applied	\N	\N	\N	\N	139145	139145	306680
17948	24451	2	applied	\N	\N	\N	\N	139146	139146	306681
17948	24452	3	applied	\N	\N	\N	\N	139147	139147	306682
17948	24453	4	applied	\N	\N	\N	\N	139148	139148	306683
17948	24454	5	applied	\N	\N	\N	\N	139149	139149	306684
17948	24455	6	applied	\N	\N	\N	\N	139150	139150	306685
17949	24456	0	applied	\N	\N	\N	\N	139151	139151	306686
17949	24457	1	applied	\N	\N	\N	\N	139152	139152	306687
17949	24458	2	applied	\N	\N	\N	\N	139153	139153	306688
17953	24304	31	applied	\N	\N	\N	\N	139195	139195	306730
17953	24307	32	applied	\N	\N	\N	\N	139196	139196	306731
17953	24311	33	applied	\N	\N	\N	\N	139197	139197	306732
17953	24314	34	applied	\N	\N	\N	\N	139198	139198	306733
17953	24316	36	applied	\N	\N	\N	\N	139200	139200	306735
17953	24324	37	applied	\N	\N	\N	\N	139201	139201	306736
17953	24327	38	applied	\N	\N	\N	\N	139202	139202	306737
17955	24469	0	applied	\N	\N	\N	\N	139292	139292	306823
17955	24470	1	applied	\N	\N	\N	\N	139293	139293	306824
17955	24471	2	applied	\N	\N	\N	\N	139294	139294	306825
17961	24043	0	applied	\N	\N	\N	\N	139371	139371	306893
17961	24037	1	applied	\N	\N	\N	\N	139372	139372	139372
17961	24028	2	applied	\N	\N	\N	\N	139373	139373	139373
17961	23993	3	applied	\N	\N	1000000000	\N	139374	139374	306894
17961	24195	4	applied	\N	\N	1000000000	\N	139375	139375	306895
17961	24347	5	applied	\N	\N	1000000000	\N	139376	139376	306896
17961	24414	7	applied	\N	\N	\N	\N	139378	139378	139378
17961	24133	11	applied	\N	\N	\N	\N	139382	139382	306897
17961	24261	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	139380	139380	\N
17961	24121	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	139381	139381	\N
17961	23996	12	applied	\N	\N	\N	\N	139383	139383	306898
17961	24423	13	applied	\N	\N	\N	\N	139384	139384	139384
17961	24438	14	applied	\N	\N	\N	\N	139385	139385	139385
17961	24280	15	applied	\N	\N	\N	\N	139386	139386	306899
17961	23998	16	applied	\N	\N	\N	\N	139387	139387	306900
17961	24001	17	applied	\N	\N	\N	\N	139388	139388	306901
17961	24003	18	applied	\N	\N	\N	\N	139389	139389	306902
17961	24006	19	applied	\N	\N	\N	\N	139390	139390	306903
17961	24011	20	applied	\N	\N	\N	\N	139391	139391	306904
17961	24012	21	applied	\N	\N	\N	\N	139392	139392	306905
17961	24014	22	applied	\N	\N	\N	\N	139393	139393	306906
17961	24018	23	applied	\N	\N	\N	\N	139394	139394	306907
17961	24035	24	applied	\N	\N	\N	\N	139395	139395	306908
17961	24049	25	applied	\N	\N	\N	\N	139396	139396	306909
17961	24059	26	applied	\N	\N	\N	\N	139397	139397	306910
17961	24069	27	applied	\N	\N	\N	\N	139398	139398	306911
17961	24080	28	applied	\N	\N	\N	\N	139399	139399	306912
17961	24017	29	applied	\N	\N	\N	\N	139400	139400	306913
17961	24019	30	applied	\N	\N	\N	\N	139401	139401	306914
17961	24024	31	applied	\N	\N	\N	\N	139402	139402	306915
17961	24025	32	applied	\N	\N	\N	\N	139403	139403	306916
17961	24031	33	applied	\N	\N	\N	\N	139404	139404	306917
17961	24034	34	applied	\N	\N	\N	\N	139405	139405	306918
17961	24042	36	applied	\N	\N	\N	\N	139407	139407	306920
17961	24050	37	applied	\N	\N	\N	\N	139408	139408	306921
17961	24051	38	applied	\N	\N	\N	\N	139409	139409	306922
17961	24052	39	applied	\N	\N	\N	\N	139410	139410	306923
17961	24058	40	applied	\N	\N	\N	\N	139411	139411	306924
17961	24060	41	applied	\N	\N	\N	\N	139412	139412	306925
17961	24063	42	applied	\N	\N	\N	\N	139413	139413	306926
17961	24064	43	applied	\N	\N	\N	\N	139414	139414	306927
17961	24070	44	applied	\N	\N	\N	\N	139415	139415	306928
17961	24073	45	applied	\N	\N	\N	\N	139416	139416	306929
17961	24076	46	applied	\N	\N	\N	\N	139417	139417	306930
17961	24079	47	applied	\N	\N	\N	\N	139418	139418	306931
17961	24085	48	applied	\N	\N	\N	\N	139419	139419	306932
17961	24086	49	applied	\N	\N	\N	\N	139420	139420	306933
17961	24087	50	applied	\N	\N	\N	\N	139421	139421	306934
17961	24095	51	applied	\N	\N	\N	\N	139422	139422	306935
17961	24101	53	applied	\N	\N	\N	\N	139424	139424	306937
17961	24103	54	applied	\N	\N	\N	\N	139425	139425	306938
17961	24109	55	applied	\N	\N	\N	\N	139426	139426	306939
17961	24110	56	applied	\N	\N	\N	\N	139427	139427	306940
17961	24115	57	applied	\N	\N	\N	\N	139428	139428	306941
17961	24123	58	applied	\N	\N	\N	\N	139429	139429	306942
17961	24124	59	applied	\N	\N	\N	\N	139430	139430	306943
17961	24129	60	applied	\N	\N	\N	\N	139431	139431	306944
17961	24130	61	applied	\N	\N	\N	\N	139432	139432	306945
17961	24132	62	applied	\N	\N	\N	\N	139433	139433	306946
17961	24138	63	applied	\N	\N	\N	\N	139434	139434	306947
17961	24140	64	applied	\N	\N	\N	\N	139435	139435	306948
17961	24141	65	applied	\N	\N	\N	\N	139436	139436	306949
17961	24148	66	applied	\N	\N	\N	\N	139437	139437	306950
17961	24150	67	applied	\N	\N	\N	\N	139438	139438	306951
17961	24155	68	applied	\N	\N	\N	\N	139439	139439	306952
17961	24160	70	applied	\N	\N	\N	\N	139441	139441	306954
17961	24092	71	applied	\N	\N	\N	\N	139442	139442	306955
17961	24102	72	applied	\N	\N	\N	\N	139443	139443	306956
17961	24111	73	applied	\N	\N	\N	\N	139444	139444	306957
17961	24128	74	applied	\N	\N	\N	\N	139445	139445	306958
17961	24139	75	applied	\N	\N	\N	\N	139446	139446	306959
17961	24146	76	applied	\N	\N	\N	\N	139447	139447	306960
17932	24423	2	applied	\N	\N	\N	\N	139080	139080	139080
17932	24424	3	applied	\N	\N	\N	\N	139081	139081	306617
17953	24340	42	applied	\N	\N	\N	\N	139206	139206	306741
17953	24344	43	applied	\N	\N	\N	\N	139207	139207	306742
17953	24348	44	applied	\N	\N	\N	\N	139208	139208	306743
17953	24349	45	applied	\N	\N	\N	\N	139209	139209	306744
17953	24350	46	applied	\N	\N	\N	\N	139210	139210	306745
17953	24351	47	applied	\N	\N	\N	\N	139211	139211	306746
17953	24352	48	applied	\N	\N	\N	\N	139212	139212	306747
17953	24364	49	applied	\N	\N	\N	\N	139213	139213	306748
17953	24365	50	applied	\N	\N	\N	\N	139214	139214	306749
17953	24372	52	applied	\N	\N	\N	\N	139216	139216	306751
17953	24382	53	applied	\N	\N	\N	\N	139217	139217	306752
17953	24388	54	applied	\N	\N	\N	\N	139218	139218	306753
17953	24391	55	applied	\N	\N	\N	\N	139219	139219	306754
17953	24392	56	applied	\N	\N	\N	\N	139220	139220	306755
17953	24398	57	applied	\N	\N	\N	\N	139221	139221	306756
17953	24401	58	applied	\N	\N	\N	\N	139222	139222	306757
17953	24403	59	applied	\N	\N	\N	\N	139223	139223	306758
17953	24407	60	applied	\N	\N	\N	\N	139224	139224	306759
17953	24410	61	applied	\N	\N	\N	\N	139225	139225	306760
17953	24413	63	applied	\N	\N	\N	\N	139226	139226	306761
17953	24417	64	applied	\N	\N	\N	\N	139227	139227	306762
17953	24421	65	applied	\N	\N	\N	\N	139228	139228	306763
17953	24422	66	applied	\N	\N	\N	\N	139229	139229	306764
17953	24428	67	applied	\N	\N	\N	\N	139230	139230	306765
17953	24432	68	applied	\N	\N	\N	\N	139231	139231	306766
17953	24439	70	applied	\N	\N	\N	\N	139233	139233	306768
17953	24443	71	applied	\N	\N	\N	\N	139234	139234	306769
17953	24446	72	applied	\N	\N	\N	\N	139235	139235	306770
17953	24449	73	applied	\N	\N	\N	\N	139236	139236	306771
17953	24450	74	applied	\N	\N	\N	\N	139237	139237	306772
17953	24456	75	applied	\N	\N	\N	\N	139238	139238	306773
17953	24459	76	applied	\N	\N	\N	\N	139239	139239	306774
17953	24462	77	applied	\N	\N	\N	\N	139240	139240	306775
17953	24466	78	applied	\N	\N	\N	\N	139241	139241	306776
17953	24197	80	applied	\N	\N	\N	\N	139243	139243	306777
17953	24414	81	applied	\N	\N	\N	\N	139244	139244	139244
17953	24423	82	applied	\N	\N	\N	\N	139245	139245	139245
17953	24438	83	applied	\N	\N	\N	\N	139246	139246	139246
17953	24198	84	applied	\N	\N	\N	\N	139247	139247	306778
17953	24209	85	applied	\N	\N	\N	\N	139248	139248	306779
17953	24218	86	applied	\N	\N	\N	\N	139249	139249	306780
17953	24280	87	applied	\N	\N	\N	\N	139250	139250	306781
17953	24199	88	applied	\N	\N	\N	\N	139251	139251	306782
17953	24200	89	applied	\N	\N	\N	\N	139252	139252	306783
17953	24204	90	applied	\N	\N	\N	\N	139253	139253	306784
17953	24206	91	applied	\N	\N	\N	\N	139254	139254	306785
17953	24208	92	applied	\N	\N	\N	\N	139255	139255	306786
17953	24212	93	applied	\N	\N	\N	\N	139256	139256	306787
17953	24216	94	applied	\N	\N	\N	\N	139257	139257	306788
17953	24220	95	applied	\N	\N	\N	\N	139258	139258	306789
17953	24201	96	applied	\N	\N	\N	\N	139259	139259	306790
17953	24202	97	applied	\N	\N	\N	\N	139260	139260	306791
17953	24203	98	applied	\N	\N	\N	\N	139261	139261	306792
17953	24205	99	applied	\N	\N	\N	\N	139262	139262	306793
17953	24207	100	applied	\N	\N	\N	\N	139263	139263	306794
17953	24210	101	applied	\N	\N	\N	\N	139264	139264	306795
17953	24213	102	applied	\N	\N	\N	\N	139265	139265	306796
17953	24215	103	applied	\N	\N	\N	\N	139266	139266	306797
17953	24219	104	applied	\N	\N	\N	\N	139267	139267	306798
17953	24222	105	applied	\N	\N	\N	\N	139268	139268	306799
17953	24226	106	applied	\N	\N	\N	\N	139269	139269	306800
17953	24227	107	applied	\N	\N	\N	\N	139270	139270	306801
17953	24231	108	applied	\N	\N	\N	\N	139271	139271	306802
17953	24235	109	applied	\N	\N	\N	\N	139272	139272	306803
17953	24223	110	applied	\N	\N	\N	\N	139273	139273	306804
17953	24239	112	applied	\N	\N	\N	\N	139275	139275	306806
17953	24252	113	applied	\N	\N	\N	\N	139276	139276	306807
17953	24266	114	applied	\N	\N	\N	\N	139277	139277	306808
17953	24274	115	applied	\N	\N	\N	\N	139278	139278	306809
17953	24284	116	applied	\N	\N	\N	\N	139279	139279	306810
17953	24298	117	applied	\N	\N	\N	\N	139280	139280	306811
17953	24309	118	applied	\N	\N	\N	\N	139281	139281	306812
17953	24318	119	applied	\N	\N	\N	\N	139282	139282	306813
17953	24331	120	applied	\N	\N	\N	\N	139283	139283	306814
17953	24341	121	applied	\N	\N	\N	\N	139284	139284	306815
17953	24353	122	applied	\N	\N	\N	\N	139285	139285	306816
17953	24367	123	applied	\N	\N	\N	\N	139286	139286	306817
17953	24375	124	applied	\N	\N	\N	\N	139287	139287	306818
17953	24384	125	applied	\N	\N	\N	\N	139288	139288	306819
17954	24469	0	applied	\N	\N	\N	\N	139289	139289	306820
17954	24470	1	applied	\N	\N	\N	\N	139290	139290	306821
17958	24472	0	applied	\N	\N	\N	\N	139302	139302	306833
17958	24473	1	applied	\N	\N	\N	\N	139303	139303	306834
17958	24474	2	applied	\N	\N	\N	\N	139304	139304	306835
17958	24475	3	applied	\N	\N	\N	\N	139305	139305	306836
17961	24156	77	applied	\N	\N	\N	\N	139448	139448	306961
17961	24171	78	applied	\N	\N	\N	\N	139449	139449	306962
17961	24178	79	applied	\N	\N	\N	\N	139450	139450	306963
17961	24191	80	applied	\N	\N	\N	\N	139451	139451	306964
17961	24198	81	applied	\N	\N	\N	\N	139452	139452	306965
17961	24209	82	applied	\N	\N	\N	\N	139453	139453	306966
17961	24218	83	applied	\N	\N	\N	\N	139454	139454	306967
17961	24233	84	applied	\N	\N	\N	\N	139455	139455	306968
17968	24502	0	applied	\N	\N	\N	\N	139507	139507	307020
17968	24503	1	applied	\N	\N	\N	\N	139508	139508	307021
17973	24511	0	applied	\N	\N	\N	\N	139522	139522	307035
17973	24506	1	applied	\N	\N	\N	\N	139523	139523	307036
17973	24508	3	applied	\N	\N	\N	\N	139525	139525	307038
17973	24509	4	applied	\N	\N	\N	\N	139526	139526	307039
17973	24512	5	applied	\N	\N	\N	\N	139527	139527	307040
17973	24510	6	applied	\N	\N	\N	\N	139528	139528	307041
17973	24513	7	applied	\N	\N	\N	\N	139529	139529	307042
17978	24518	0	applied	\N	\N	\N	\N	139554	139554	307067
17978	24519	1	applied	\N	\N	\N	\N	139555	139555	307068
17978	24520	2	applied	\N	\N	\N	\N	139556	139556	307069
17978	24521	3	applied	\N	\N	\N	\N	139557	139557	307070
17998	24589	0	applied	\N	\N	\N	\N	139745	139745	307256
17998	24590	1	applied	\N	\N	\N	\N	139746	139746	307257
18000	24591	0	applied	\N	\N	\N	\N	139752	139752	307263
18000	24592	1	applied	\N	\N	\N	\N	139753	139753	307264
17953	24334	40	applied	\N	\N	\N	\N	139204	139204	306739
17953	24335	41	applied	\N	\N	\N	\N	139205	139205	306740
17961	24274	88	applied	\N	\N	\N	\N	139459	139459	306972
17961	24284	89	applied	\N	\N	\N	\N	139460	139460	306973
17961	24298	90	applied	\N	\N	\N	\N	139461	139461	306974
17961	24318	92	applied	\N	\N	\N	\N	139463	139463	306976
17961	24331	93	applied	\N	\N	\N	\N	139464	139464	306977
17962	24482	0	applied	\N	\N	\N	\N	139465	139465	306978
17962	24483	1	applied	\N	\N	\N	\N	139466	139466	306979
17962	24484	2	applied	\N	\N	\N	\N	139467	139467	306980
17962	24485	3	applied	\N	\N	\N	\N	139468	139468	306981
17962	24486	4	applied	\N	\N	\N	\N	139469	139469	306982
17962	24487	5	applied	\N	\N	\N	\N	139470	139470	306983
17962	24488	6	applied	\N	\N	\N	\N	139471	139471	306984
17963	24489	0	applied	\N	\N	\N	\N	139472	139472	306985
17963	24490	1	applied	\N	\N	\N	\N	139473	139473	306986
17963	24491	2	applied	\N	\N	\N	\N	139474	139474	306987
17964	24492	0	applied	\N	\N	\N	\N	139475	139475	306988
17964	24493	1	applied	\N	\N	\N	\N	139476	139476	306989
17964	24494	2	applied	\N	\N	\N	\N	139477	139477	306990
17964	24495	3	applied	\N	\N	\N	\N	139478	139478	306991
17964	24497	5	applied	\N	\N	\N	\N	139480	139480	306993
17964	24498	6	applied	\N	\N	\N	\N	139481	139481	306994
17964	24499	7	applied	\N	\N	\N	\N	139482	139482	306995
17964	24500	8	applied	\N	\N	\N	\N	139483	139483	306996
17964	24501	9	applied	\N	\N	\N	\N	139484	139484	306997
17969	24502	0	applied	\N	\N	\N	\N	139509	139509	307022
17969	24503	1	applied	\N	\N	\N	\N	139510	139510	307023
17974	24511	0	applied	\N	\N	\N	\N	139530	139530	307043
17974	24506	1	applied	\N	\N	\N	\N	139531	139531	307044
17974	24507	2	applied	\N	\N	\N	\N	139532	139532	307045
17974	24508	3	applied	\N	\N	\N	\N	139533	139533	307046
17974	24509	4	applied	\N	\N	\N	\N	139534	139534	307047
17974	24512	5	applied	\N	\N	\N	\N	139535	139535	307048
17974	24510	6	applied	\N	\N	\N	\N	139536	139536	307049
17974	24513	7	applied	\N	\N	\N	\N	139537	139537	307050
17979	24518	0	applied	\N	\N	\N	\N	139558	139558	307071
17979	24520	2	applied	\N	\N	\N	\N	139560	139560	307073
17980	24522	0	applied	\N	\N	\N	\N	139561	139561	307074
17980	24523	1	applied	\N	\N	\N	\N	139562	139562	307075
17980	24524	2	applied	\N	\N	\N	\N	139563	139563	307076
17980	24525	3	applied	\N	\N	\N	\N	139564	139564	307077
17980	24526	4	applied	\N	\N	\N	\N	139565	139565	307078
17980	24527	5	applied	\N	\N	\N	\N	139566	139566	307079
17990	24566	0	applied	\N	\N	\N	\N	139614	139614	307126
17990	24567	1	applied	\N	\N	1000000000	\N	139615	139615	307127
17990	24568	2	applied	\N	\N	\N	\N	139616	139616	307128
17990	24569	3	applied	\N	\N	\N	\N	139617	139617	307129
17990	24570	4	applied	\N	\N	\N	\N	139618	139618	307130
17992	24571	0	applied	\N	\N	1000000000	\N	139624	139624	307136
17992	24572	1	applied	\N	\N	\N	\N	139625	139625	307137
17992	24573	2	applied	\N	\N	\N	\N	139626	139626	307138
17992	24574	3	applied	\N	\N	\N	\N	139627	139627	307139
17992	24576	5	applied	\N	\N	\N	\N	139629	139629	307141
17992	24577	6	applied	\N	\N	\N	\N	139630	139630	307142
17992	24578	7	applied	\N	\N	\N	\N	139631	139631	307143
17992	24579	8	applied	\N	\N	\N	\N	139632	139632	307144
17992	24580	9	applied	\N	\N	\N	\N	139633	139633	307145
17992	24581	10	applied	\N	\N	\N	\N	139634	139634	307146
17992	24582	11	applied	\N	\N	\N	\N	139635	139635	307147
17993	24583	0	applied	\N	\N	\N	\N	139636	139636	307148
17993	24584	1	applied	\N	\N	\N	\N	139637	139637	307149
17993	24585	2	applied	\N	\N	\N	\N	139638	139638	307150
17994	24489	0	applied	\N	\N	\N	\N	139639	139639	307151
17994	24560	1	applied	\N	\N	1000000000	\N	139640	139640	307152
17994	24567	2	applied	\N	\N	1000000000	\N	139641	139641	307153
17994	24571	3	applied	\N	\N	1000000000	\N	139642	139642	307154
17994	24556	4	applied	\N	\N	\N	\N	139643	139643	307155
17994	24575	5	applied	\N	\N	1000000000	\N	139644	139644	307156
17994	24514	6	applied	\N	\N	\N	\N	139645	139645	307157
17994	24529	7	applied	\N	\N	\N	\N	139646	139646	307158
17994	24493	9	applied	\N	\N	\N	\N	139648	139648	307160
17994	24494	10	applied	\N	\N	\N	\N	139649	139649	307161
17994	24502	11	applied	\N	\N	\N	\N	139650	139650	307162
17994	24504	12	applied	\N	\N	\N	\N	139651	139651	307163
17994	24505	13	applied	\N	\N	\N	\N	139652	139652	307164
17994	24511	14	applied	\N	\N	\N	\N	139653	139653	307165
17994	24538	15	applied	\N	\N	\N	\N	139654	139654	307166
17994	24544	16	applied	\N	\N	\N	\N	139655	139655	307167
17994	24515	17	applied	\N	\N	\N	\N	139656	139656	307168
17994	24518	18	applied	\N	\N	\N	\N	139657	139657	307169
17994	24522	19	applied	\N	\N	\N	\N	139658	139658	307170
17994	24523	21	applied	\N	\N	\N	\N	139659	139659	307171
17994	24528	22	applied	\N	\N	\N	\N	139660	139660	307172
17994	24530	23	applied	\N	\N	\N	\N	139661	139661	307173
17994	24536	24	applied	\N	\N	\N	\N	139662	139662	307174
17994	24537	25	applied	\N	\N	\N	\N	139663	139663	307175
17994	24546	27	applied	\N	\N	\N	\N	139665	139665	307177
17994	24552	28	applied	\N	\N	\N	\N	139666	139666	307178
17994	24555	29	applied	\N	\N	\N	\N	139667	139667	307179
17994	24559	30	applied	\N	\N	\N	\N	139668	139668	307180
17994	24563	31	applied	\N	\N	\N	\N	139669	139669	307181
17994	24566	32	applied	\N	\N	\N	\N	139670	139670	307182
17994	24572	33	applied	\N	\N	\N	\N	139671	139671	307183
17994	24573	34	applied	\N	\N	\N	\N	139672	139672	307184
17994	24574	35	applied	\N	\N	\N	\N	139673	139673	307185
17994	24583	36	applied	\N	\N	\N	\N	139674	139674	307186
17994	24490	37	applied	\N	\N	\N	\N	139675	139675	307187
17994	24496	38	applied	\N	\N	\N	\N	139676	139676	307188
17994	24497	39	applied	\N	\N	\N	\N	139677	139677	307189
17994	24547	40	applied	\N	\N	\N	\N	139678	139678	139678
17994	24491	41	applied	\N	\N	\N	\N	139679	139679	307190
17994	24495	42	applied	\N	\N	\N	\N	139680	139680	307191
18000	24593	2	applied	\N	\N	\N	\N	139754	139754	307265
18000	24594	3	applied	\N	\N	\N	\N	139755	139755	307266
18000	24595	4	applied	\N	\N	\N	\N	139756	139756	307267
18007	24596	0	applied	\N	\N	\N	\N	139780	139780	307291
18007	24599	1	applied	\N	\N	\N	\N	139781	139781	307292
18007	24602	2	applied	\N	\N	\N	\N	139782	139782	307293
18007	24603	3	applied	\N	\N	\N	\N	139783	139783	307294
18007	24597	4	applied	\N	\N	\N	\N	139784	139784	307295
17961	24252	86	applied	\N	\N	\N	\N	139457	139457	306970
17961	24266	87	applied	\N	\N	\N	\N	139458	139458	306971
17965	24498	6	applied	\N	\N	\N	\N	139491	139491	307004
17965	24499	7	applied	\N	\N	\N	\N	139492	139492	307005
17965	24500	8	applied	\N	\N	\N	\N	139493	139493	307006
17965	24501	9	applied	\N	\N	\N	\N	139494	139494	307007
17970	24502	0	applied	\N	\N	\N	\N	139511	139511	307024
17970	24503	1	applied	\N	\N	\N	\N	139512	139512	307025
17971	24504	0	applied	\N	\N	\N	\N	139513	139513	307026
17975	24511	0	applied	\N	\N	\N	\N	139538	139538	307051
17975	24506	1	applied	\N	\N	\N	\N	139539	139539	307052
17975	24507	2	applied	\N	\N	\N	\N	139540	139540	307053
17975	24508	3	applied	\N	\N	\N	\N	139541	139541	307054
17975	24509	4	applied	\N	\N	\N	\N	139542	139542	307055
17975	24512	5	applied	\N	\N	\N	\N	139543	139543	307056
17975	24510	6	applied	\N	\N	\N	\N	139544	139544	307057
17975	24513	7	applied	\N	\N	\N	\N	139545	139545	307058
17976	24514	0	applied	\N	\N	1000000000	\N	139546	139546	307059
17976	24515	1	applied	\N	\N	\N	\N	139547	139547	307060
17976	24516	2	applied	\N	\N	\N	\N	139548	139548	307061
17976	24517	3	applied	\N	\N	\N	\N	139549	139549	307062
17981	24522	0	applied	\N	\N	\N	\N	139567	139567	307080
17981	24523	1	applied	\N	\N	\N	\N	139568	139568	307081
17981	24524	2	applied	\N	\N	\N	\N	139569	139569	307082
17981	24525	3	applied	\N	\N	\N	\N	139570	139570	307083
17981	24527	5	applied	\N	\N	\N	\N	139572	139572	307085
17982	24528	0	applied	\N	\N	\N	\N	139573	139573	307086
17982	24529	1	applied	\N	\N	\N	\N	139574	139574	307087
17982	24530	2	applied	\N	\N	\N	\N	139575	139575	307088
17982	24531	3	applied	\N	\N	\N	\N	139576	139576	307089
17982	24532	4	applied	\N	\N	\N	\N	139577	139577	307090
17982	24533	5	applied	\N	\N	\N	\N	139578	139578	307091
17982	24534	6	applied	\N	\N	\N	\N	139579	139579	307092
17982	24535	7	applied	\N	\N	\N	\N	139580	139580	307093
17983	24536	0	applied	\N	\N	\N	\N	139581	139581	307094
17983	24537	1	applied	\N	\N	\N	\N	139582	139582	307095
17983	24538	2	applied	\N	\N	\N	\N	139583	139583	307096
17983	24539	3	applied	\N	\N	\N	\N	139584	139584	307097
17983	24540	4	applied	\N	\N	\N	\N	139585	139585	307098
17983	24541	5	applied	\N	\N	\N	\N	139586	139586	307099
17983	24542	6	applied	\N	\N	\N	\N	139587	139587	307100
17984	24544	0	applied	\N	\N	\N	\N	139589	139589	307102
17984	24545	1	applied	\N	\N	\N	\N	139590	139590	307103
17984	24546	2	applied	\N	\N	\N	\N	139591	139591	307104
17984	24547	3	applied	\N	\N	\N	\N	139592	139592	139592
17984	24548	4	applied	\N	\N	\N	\N	139593	139593	307105
17984	24549	5	applied	\N	\N	\N	\N	139594	139594	307106
17984	24550	6	applied	\N	\N	\N	\N	139595	139595	307107
17984	24551	7	applied	\N	\N	\N	\N	139596	139596	307108
17985	24552	0	applied	\N	\N	\N	\N	139597	139597	307109
17985	24553	1	applied	\N	\N	\N	\N	139598	139598	307110
17985	24554	2	applied	\N	\N	\N	\N	139599	139599	307111
17988	24563	0	applied	\N	\N	\N	\N	139608	139608	307120
17988	24564	1	applied	\N	\N	\N	\N	139609	139609	307121
17988	24565	2	applied	\N	\N	\N	\N	139610	139610	307122
17989	24563	0	applied	\N	\N	\N	\N	139611	139611	307123
17989	24564	1	applied	\N	\N	\N	\N	139612	139612	307124
17994	24499	44	applied	\N	\N	\N	\N	139682	139682	307193
17994	24500	45	applied	\N	\N	\N	\N	139683	139683	307194
17994	24507	46	applied	\N	\N	\N	\N	139684	139684	307195
17994	24501	47	applied	\N	\N	\N	\N	139685	139685	307196
17994	24503	48	applied	\N	\N	\N	\N	139686	139686	307197
17994	24506	49	applied	\N	\N	\N	\N	139687	139687	307198
17994	24508	50	applied	\N	\N	\N	\N	139688	139688	307199
17994	24520	51	applied	\N	\N	\N	\N	139689	139689	307200
17999	24591	0	applied	\N	\N	\N	\N	139747	139747	307258
17999	24592	1	applied	\N	\N	\N	\N	139748	139748	307259
17999	24593	2	applied	\N	\N	\N	\N	139749	139749	307260
17999	24594	3	applied	\N	\N	\N	\N	139750	139750	307261
17999	24595	4	applied	\N	\N	\N	\N	139751	139751	307262
18001	24591	0	applied	\N	\N	\N	\N	139757	139757	307268
18001	24592	1	applied	\N	\N	\N	\N	139758	139758	307269
18001	24593	2	applied	\N	\N	\N	\N	139759	139759	307270
18001	24595	4	applied	\N	\N	\N	\N	139761	139761	307272
18006	24596	0	applied	\N	\N	\N	\N	139774	139774	307285
18006	24599	1	applied	\N	\N	\N	\N	139775	139775	307286
18006	24597	2	applied	\N	\N	\N	\N	139776	139776	307287
18006	24598	3	applied	\N	\N	\N	\N	139777	139777	307288
18006	24600	4	applied	\N	\N	\N	\N	139778	139778	307289
18006	24601	5	applied	\N	\N	\N	\N	139779	139779	307290
18009	24602	0	applied	\N	\N	\N	\N	139794	139794	307305
18009	24603	1	applied	\N	\N	\N	\N	139795	139795	307306
18009	24604	2	applied	\N	\N	\N	\N	139796	139796	307307
18009	24605	3	applied	\N	\N	\N	\N	139797	139797	307308
18010	24606	0	applied	\N	\N	\N	\N	139798	139798	307309
18010	24607	1	applied	\N	\N	\N	\N	139799	139799	307310
18010	24608	2	applied	\N	\N	\N	\N	139800	139800	307311
18010	24609	3	applied	\N	\N	\N	\N	139801	139801	307312
18017	24620	0	applied	\N	\N	\N	\N	139830	139830	307341
18017	24622	2	applied	\N	\N	\N	\N	139832	139832	307343
18022	24627	0	applied	\N	\N	\N	\N	139846	139846	307357
18022	24628	1	applied	\N	\N	\N	\N	139847	139847	307358
18022	24629	2	applied	\N	\N	\N	\N	139848	139848	307359
18022	24630	3	applied	\N	\N	\N	\N	139849	139849	307360
18022	24631	4	applied	\N	\N	\N	\N	139850	139850	307361
18022	24632	5	applied	\N	\N	\N	\N	139851	139851	307362
18027	24642	0	applied	\N	\N	\N	\N	139863	139863	307374
18027	24643	1	applied	\N	\N	\N	\N	139864	139864	307375
18031	24644	0	applied	\N	\N	\N	\N	139874	139874	307385
18031	24645	1	applied	\N	\N	\N	\N	139875	139875	307386
18031	24646	2	applied	\N	\N	\N	\N	139876	139876	307387
18034	24560	0	applied	\N	\N	1000000000	\N	139883	139883	307394
18034	24567	1	applied	\N	\N	1000000000	\N	139884	139884	307395
18034	24592	3	applied	\N	\N	\N	\N	139886	139886	307397
18034	24556	4	applied	\N	\N	\N	\N	139887	139887	307398
18034	24575	5	applied	\N	\N	1000000000	\N	139888	139888	307399
18034	24514	6	applied	\N	\N	\N	\N	139889	139889	307400
18034	24529	7	applied	\N	\N	\N	\N	139890	139890	307401
18034	24538	8	applied	\N	\N	\N	\N	139891	139891	307402
18034	24544	9	applied	\N	\N	\N	\N	139892	139892	307403
18034	24547	10	applied	\N	\N	\N	\N	139893	139893	139893
17965	24496	4	applied	\N	\N	\N	\N	139489	139489	307002
17965	24497	5	applied	\N	\N	\N	\N	139490	139490	307003
17966	24500	8	applied	\N	\N	\N	\N	139503	139503	307016
17966	24501	9	applied	\N	\N	\N	\N	139504	139504	307017
17967	24502	0	applied	\N	\N	\N	\N	139505	139505	307018
17967	24503	1	applied	\N	\N	\N	\N	139506	139506	307019
17972	24504	0	applied	\N	\N	\N	\N	139515	139515	307028
17972	24505	1	applied	\N	\N	\N	\N	139516	139516	307029
17972	24506	2	applied	\N	\N	\N	\N	139517	139517	307030
17972	24507	3	applied	\N	\N	\N	\N	139518	139518	307031
17972	24508	4	applied	\N	\N	\N	\N	139519	139519	307032
17972	24509	5	applied	\N	\N	\N	\N	139520	139520	307033
17972	24510	6	applied	\N	\N	\N	\N	139521	139521	307034
17977	24515	1	applied	\N	\N	\N	\N	139551	139551	307064
17977	24516	2	applied	\N	\N	\N	\N	139552	139552	307065
17977	24517	3	applied	\N	\N	\N	\N	139553	139553	307066
17986	24555	0	applied	\N	\N	\N	\N	139600	139600	307112
17986	24556	1	applied	\N	\N	\N	\N	139601	139601	307113
17986	24557	2	applied	\N	\N	\N	\N	139602	139602	307114
17986	24558	3	applied	\N	\N	\N	\N	139603	139603	307115
17987	24559	0	applied	\N	\N	\N	\N	139604	139604	307116
17987	24560	1	applied	\N	\N	\N	\N	139605	139605	307117
17987	24561	2	applied	\N	\N	\N	\N	139606	139606	307118
17987	24562	3	applied	\N	\N	\N	\N	139607	139607	307119
17991	24566	0	applied	\N	\N	\N	\N	139619	139619	307131
17991	24567	1	applied	\N	\N	1000000000	\N	139620	139620	307132
17991	24568	2	applied	\N	\N	\N	\N	139621	139621	307133
17991	24569	3	applied	\N	\N	\N	\N	139622	139622	307134
17991	24570	4	applied	\N	\N	\N	\N	139623	139623	307135
17995	24586	0	applied	\N	\N	\N	\N	139736	139736	307247
17995	24587	1	applied	\N	\N	\N	\N	139737	139737	307248
17995	24588	2	applied	\N	\N	\N	\N	139738	139738	307249
17997	24587	1	applied	\N	\N	\N	\N	139743	139743	307254
17997	24588	2	applied	\N	\N	\N	\N	139744	139744	307255
18002	24596	0	applied	\N	\N	\N	\N	139762	139762	307273
18002	24597	1	applied	\N	\N	\N	\N	139763	139763	307274
18002	24598	2	applied	\N	\N	\N	\N	139764	139764	307275
18004	24596	0	applied	\N	\N	\N	\N	139765	139765	307276
18004	24597	1	applied	\N	\N	\N	\N	139766	139766	307277
18004	24598	2	applied	\N	\N	\N	\N	139767	139767	307278
18013	24606	0	applied	\N	\N	\N	\N	139809	139809	307320
18013	24611	1	applied	\N	\N	\N	\N	139810	139810	307321
18013	24607	2	applied	\N	\N	\N	\N	139811	139811	307322
18013	24610	3	applied	\N	\N	\N	\N	139812	139812	307323
18013	24608	4	applied	\N	\N	\N	\N	139813	139813	307324
18013	24612	5	applied	\N	\N	\N	\N	139814	139814	307325
18013	24609	6	applied	\N	\N	\N	\N	139815	139815	307326
18015	24613	0	applied	\N	\N	\N	\N	139823	139823	307334
18015	24615	2	applied	\N	\N	\N	\N	139825	139825	307336
18015	24616	3	applied	\N	\N	\N	\N	139826	139826	307337
18018	24620	0	applied	\N	\N	\N	\N	139833	139833	307344
18018	24621	1	applied	\N	\N	\N	\N	139834	139834	307345
18018	24622	2	applied	\N	\N	\N	\N	139835	139835	307346
18020	24623	0	applied	\N	\N	\N	\N	139838	139838	307349
18020	24624	1	applied	\N	\N	\N	\N	139839	139839	307350
18020	24625	2	applied	\N	\N	\N	\N	139840	139840	307351
18020	24626	3	applied	\N	\N	\N	\N	139841	139841	307352
18025	24640	0	applied	\N	\N	\N	\N	139859	139859	307370
18025	24641	1	applied	\N	\N	\N	\N	139860	139860	307371
18028	24644	0	applied	\N	\N	\N	\N	139865	139865	307376
18028	24645	1	applied	\N	\N	\N	\N	139866	139866	307377
18028	24646	2	applied	\N	\N	\N	\N	139867	139867	307378
18034	24423	11	applied	\N	\N	\N	\N	139894	139894	139894
18034	24438	12	applied	\N	\N	\N	\N	139895	139895	139895
18034	24626	14	applied	\N	\N	\N	\N	139897	139897	307405
18035	24649	0	applied	\N	\N	\N	\N	139898	139898	307406
18035	24650	1	applied	\N	\N	\N	\N	139899	139899	307407
18035	24651	2	applied	\N	\N	\N	\N	139900	139900	307408
18035	24652	3	applied	\N	\N	\N	\N	139901	139901	307409
18041	24658	0	applied	\N	\N	\N	\N	139914	139914	307422
18041	24659	1	applied	\N	\N	\N	\N	139915	139915	307423
18043	24660	0	applied	\N	\N	\N	\N	139935	139935	307438
18043	24661	1	applied	\N	\N	\N	\N	139936	139936	307439
18043	24662	2	applied	\N	\N	\N	\N	139937	139937	307440
18045	24660	0	applied	\N	\N	\N	\N	139941	139941	307444
18045	24661	1	applied	\N	\N	\N	\N	139942	139942	307445
18045	24662	2	applied	\N	\N	\N	\N	139943	139943	307446
18052	24671	0	applied	\N	\N	\N	\N	139959	139959	307462
18052	24672	1	applied	\N	\N	\N	\N	139960	139960	307463
18052	24673	2	applied	\N	\N	\N	\N	139961	139961	307464
18067	24694	0	applied	\N	\N	\N	\N	140011	140011	307514
18067	24695	1	applied	\N	\N	\N	\N	140012	140012	307515
18067	24696	2	applied	\N	\N	\N	\N	140013	140013	307516
18074	24699	0	applied	\N	\N	\N	\N	140028	140028	307531
18074	24700	1	applied	\N	\N	\N	\N	140029	140029	307532
18074	24701	2	applied	\N	\N	\N	\N	140030	140030	307533
18074	24702	3	applied	\N	\N	\N	\N	140031	140031	307534
18080	24717	0	applied	\N	\N	\N	\N	140051	140051	307554
18080	24718	1	applied	\N	\N	\N	\N	140052	140052	307555
18080	24719	2	applied	\N	\N	\N	\N	140053	140053	307556
18082	24720	0	applied	\N	\N	\N	\N	140057	140057	307560
18082	24721	1	applied	\N	\N	\N	\N	140058	140058	307561
18092	24732	0	applied	\N	\N	\N	\N	140225	140225	307727
18092	24733	1	applied	\N	\N	\N	\N	140226	140226	307728
18092	24734	2	applied	\N	\N	\N	\N	140227	140227	307729
18094	24735	0	applied	\N	\N	\N	\N	140231	140231	307733
18099	24744	0	applied	\N	\N	\N	\N	140242	140242	307744
18099	24745	1	applied	\N	\N	\N	\N	140243	140243	307745
18102	24752	0	applied	\N	\N	\N	\N	140250	140250	307752
18102	24753	1	applied	\N	\N	\N	\N	140251	140251	307753
18109	24744	0	applied	\N	\N	\N	\N	140269	140269	307771
18109	24746	1	applied	\N	\N	\N	\N	140270	140270	307772
18109	24748	2	applied	\N	\N	\N	\N	140271	140271	307773
18109	24749	3	applied	\N	\N	\N	\N	140272	140272	307774
18109	24752	4	applied	\N	\N	\N	\N	140273	140273	307775
18109	24754	5	applied	\N	\N	\N	\N	140274	140274	307776
18109	24758	6	applied	\N	\N	\N	\N	140275	140275	307777
18109	24745	7	applied	\N	\N	\N	\N	140276	140276	307778
18109	24747	8	applied	\N	\N	\N	\N	140277	140277	307779
18109	24753	9	applied	\N	\N	\N	\N	140278	140278	307780
18109	24755	10	applied	\N	\N	\N	\N	140279	140279	307781
17966	24497	5	applied	\N	\N	\N	\N	139500	139500	307013
17966	24499	7	applied	\N	\N	\N	\N	139502	139502	307015
17994	24516	56	applied	\N	\N	\N	\N	139694	139694	307205
17994	24521	57	applied	\N	\N	\N	\N	139695	139695	307206
17994	24524	58	applied	\N	\N	\N	\N	139696	139696	307207
17994	24525	59	applied	\N	\N	\N	\N	139697	139697	307208
17994	24532	60	applied	\N	\N	\N	\N	139698	139698	307209
17994	24535	61	applied	\N	\N	\N	\N	139699	139699	307210
17994	24539	62	applied	\N	\N	\N	\N	139700	139700	307211
17994	24543	63	applied	\N	\N	\N	\N	139701	139701	307212
17994	24550	64	applied	\N	\N	\N	\N	139702	139702	307213
17994	24551	65	applied	\N	\N	\N	\N	139703	139703	307214
17994	24553	66	applied	\N	\N	\N	\N	139704	139704	307215
17994	24557	67	applied	\N	\N	\N	\N	139705	139705	307216
17994	24558	68	applied	\N	\N	\N	\N	139706	139706	307217
17994	24569	70	applied	\N	\N	\N	\N	139708	139708	307219
17994	24576	71	applied	\N	\N	\N	\N	139709	139709	307220
17994	24510	72	applied	\N	\N	\N	\N	139710	139710	307221
17994	24513	73	applied	\N	\N	\N	\N	139711	139711	307222
17994	24517	74	applied	\N	\N	\N	\N	139712	139712	307223
17994	24519	75	applied	\N	\N	\N	\N	139713	139713	307224
17994	24526	76	applied	\N	\N	\N	\N	139714	139714	307225
17994	24527	77	applied	\N	\N	\N	\N	139715	139715	307226
17994	24533	78	applied	\N	\N	\N	\N	139716	139716	307227
17994	24534	79	applied	\N	\N	\N	\N	139717	139717	307228
17994	24540	80	applied	\N	\N	\N	\N	139718	139718	307229
17994	24542	81	applied	\N	\N	\N	\N	139719	139719	307230
17994	24548	82	applied	\N	\N	\N	\N	139720	139720	307231
17994	24549	83	applied	\N	\N	\N	\N	139721	139721	307232
17994	24554	84	applied	\N	\N	\N	\N	139722	139722	307233
17994	24561	85	applied	\N	\N	\N	\N	139723	139723	307234
17994	24564	87	applied	\N	\N	\N	\N	139725	139725	307236
17994	24568	88	applied	\N	\N	\N	\N	139726	139726	307237
17994	24577	89	applied	\N	\N	\N	\N	139727	139727	307238
17994	24578	90	applied	\N	\N	\N	\N	139728	139728	307239
17994	24579	91	applied	\N	\N	\N	\N	139729	139729	307240
17994	24584	92	applied	\N	\N	\N	\N	139730	139730	307241
17994	24570	93	applied	\N	\N	\N	\N	139731	139731	307242
17994	24580	94	applied	\N	\N	\N	\N	139732	139732	307243
17994	24581	95	applied	\N	\N	\N	\N	139733	139733	307244
17994	24582	96	applied	\N	\N	\N	\N	139734	139734	307245
17994	24585	97	applied	\N	\N	\N	\N	139735	139735	307246
17996	24586	0	applied	\N	\N	\N	\N	139739	139739	307250
17996	24587	1	applied	\N	\N	\N	\N	139740	139740	307251
17996	24588	2	applied	\N	\N	\N	\N	139741	139741	307252
18005	24596	0	applied	\N	\N	\N	\N	139768	139768	307279
18005	24599	1	applied	\N	\N	\N	\N	139769	139769	307280
18005	24598	3	applied	\N	\N	\N	\N	139771	139771	307282
18005	24600	4	applied	\N	\N	\N	\N	139772	139772	307283
18005	24601	5	applied	\N	\N	\N	\N	139773	139773	307284
18008	24602	0	applied	\N	\N	\N	\N	139790	139790	307301
18008	24603	1	applied	\N	\N	\N	\N	139791	139791	307302
18008	24604	2	applied	\N	\N	\N	\N	139792	139792	307303
18008	24605	3	applied	\N	\N	\N	\N	139793	139793	307304
18012	24611	0	applied	\N	\N	\N	\N	139807	139807	307318
18012	24612	1	applied	\N	\N	\N	\N	139808	139808	307319
18021	24623	0	applied	\N	\N	\N	\N	139842	139842	307353
18021	24624	1	applied	\N	\N	\N	\N	139843	139843	307354
18021	24625	2	applied	\N	\N	\N	\N	139844	139844	307355
18021	24626	3	applied	\N	\N	\N	\N	139845	139845	307356
18024	24636	0	applied	\N	\N	\N	\N	139855	139855	307366
18024	24637	1	applied	\N	\N	\N	\N	139856	139856	307367
18024	24638	2	applied	\N	\N	\N	\N	139857	139857	307368
18026	24640	0	applied	\N	\N	\N	\N	139861	139861	307372
18026	24641	1	applied	\N	\N	\N	\N	139862	139862	307373
18030	24644	0	applied	\N	\N	\N	\N	139871	139871	307382
18030	24645	1	applied	\N	\N	\N	\N	139872	139872	307383
18030	24646	2	applied	\N	\N	\N	\N	139873	139873	307384
18040	24658	0	applied	\N	\N	\N	\N	139912	139912	307420
18040	24659	1	applied	\N	\N	\N	\N	139913	139913	307421
18042	24347	0	applied	\N	\N	1000000000	\N	139916	139916	307424
18042	24560	1	applied	\N	\N	1000000000	\N	139917	139917	307425
18042	24567	2	applied	\N	\N	1000000000	\N	139918	139918	307426
18042	24571	3	applied	\N	\N	1000000000	\N	139919	139919	307427
18042	24592	4	applied	\N	\N	\N	\N	139920	139920	307428
18042	24556	5	applied	\N	\N	\N	\N	139921	139921	307429
18042	24575	6	applied	\N	\N	1000000000	\N	139922	139922	307430
18042	24514	7	applied	\N	\N	\N	\N	139923	139923	307431
18042	24529	8	applied	\N	\N	\N	\N	139924	139924	307432
18042	24544	10	applied	\N	\N	\N	\N	139926	139926	307434
18042	24414	12	applied	\N	\N	\N	\N	139928	139928	139928
18042	24261	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	139927	139927	\N
18042	24547	13	applied	\N	\N	\N	\N	139929	139929	139929
18042	24423	14	applied	\N	\N	\N	\N	139930	139930	139930
18042	24438	15	applied	\N	\N	\N	\N	139931	139931	139931
18042	24280	16	applied	\N	\N	\N	\N	139932	139932	307435
18042	24609	17	applied	\N	\N	\N	\N	139933	139933	307436
18042	24626	18	applied	\N	\N	\N	\N	139934	139934	307437
18046	24663	0	applied	\N	\N	1000000000	\N	139944	139944	307447
18046	24664	1	applied	\N	\N	\N	\N	139945	139945	307448
18046	24665	2	applied	\N	\N	\N	\N	139946	139946	307449
18056	24675	0	applied	\N	\N	\N	\N	139969	139969	307472
18056	24676	1	applied	\N	\N	\N	\N	139970	139970	307473
18056	24677	2	applied	\N	\N	\N	\N	139971	139971	307474
18058	24678	0	applied	\N	\N	\N	\N	139975	139975	307478
18058	24680	2	applied	\N	\N	\N	\N	139977	139977	307480
18058	24681	3	applied	\N	\N	\N	\N	139978	139978	307481
18058	24682	4	applied	\N	\N	\N	\N	139979	139979	307482
18058	24683	5	applied	\N	\N	\N	\N	139980	139980	307483
18059	24678	0	applied	\N	\N	\N	\N	139981	139981	307484
18059	24679	1	applied	\N	\N	\N	\N	139982	139982	307485
18059	24680	2	applied	\N	\N	\N	\N	139983	139983	307486
18109	24750	11	applied	\N	\N	\N	\N	140280	140280	307782
18109	24751	12	applied	\N	\N	\N	\N	140281	140281	307783
18109	24756	13	applied	\N	\N	\N	\N	140282	140282	307784
18109	24757	14	applied	\N	\N	\N	\N	140283	140283	307785
18109	24759	15	applied	\N	\N	\N	\N	140284	140284	307786
18112	24764	0	applied	\N	\N	\N	\N	140290	140290	307792
18112	24765	1	applied	\N	\N	\N	\N	140291	140291	307793
18119	24777	0	applied	\N	\N	\N	\N	140353	140353	307855
17994	24541	53	applied	\N	\N	\N	\N	139691	139691	307202
17994	24512	55	applied	\N	\N	\N	\N	139693	139693	307204
18007	24605	9	applied	\N	\N	\N	\N	139789	139789	307300
18011	24606	0	applied	\N	\N	\N	\N	139802	139802	307313
18011	24607	1	applied	\N	\N	\N	\N	139803	139803	307314
18011	24610	2	applied	\N	\N	\N	\N	139804	139804	307315
18011	24608	3	applied	\N	\N	\N	\N	139805	139805	307316
18011	24609	4	applied	\N	\N	\N	\N	139806	139806	307317
18014	24606	0	applied	\N	\N	\N	\N	139816	139816	307327
18014	24611	1	applied	\N	\N	\N	\N	139817	139817	307328
18014	24607	2	applied	\N	\N	\N	\N	139818	139818	307329
18014	24610	3	applied	\N	\N	\N	\N	139819	139819	307330
18014	24608	4	applied	\N	\N	\N	\N	139820	139820	307331
18014	24612	5	applied	\N	\N	\N	\N	139821	139821	307332
18014	24609	6	applied	\N	\N	\N	\N	139822	139822	307333
18016	24617	0	applied	\N	\N	\N	\N	139827	139827	307338
18016	24618	1	applied	\N	\N	\N	\N	139828	139828	307339
18016	24619	2	applied	\N	\N	\N	\N	139829	139829	307340
18019	24622	1	applied	\N	\N	\N	\N	139837	139837	307348
18023	24633	0	applied	\N	\N	\N	\N	139852	139852	307363
18023	24634	1	applied	\N	\N	\N	\N	139853	139853	307364
18023	24635	2	applied	\N	\N	\N	\N	139854	139854	307365
18029	24644	0	applied	\N	\N	\N	\N	139868	139868	307379
18029	24645	1	applied	\N	\N	\N	\N	139869	139869	307380
18029	24646	2	applied	\N	\N	\N	\N	139870	139870	307381
18032	24647	0	applied	\N	\N	\N	\N	139877	139877	307388
18032	24648	1	applied	\N	\N	\N	\N	139878	139878	307389
18033	24649	0	applied	\N	\N	\N	\N	139879	139879	307390
18033	24650	1	applied	\N	\N	\N	\N	139880	139880	307391
18033	24651	2	applied	\N	\N	\N	\N	139881	139881	307392
18033	24652	3	applied	\N	\N	\N	\N	139882	139882	307393
18038	24656	0	applied	\N	\N	\N	\N	139908	139908	307416
18038	24657	1	applied	\N	\N	\N	\N	139909	139909	307417
18039	24656	0	applied	\N	\N	\N	\N	139910	139910	307418
18044	24660	0	applied	\N	\N	\N	\N	139938	139938	307441
18044	24661	1	applied	\N	\N	\N	\N	139939	139939	307442
18044	24662	2	applied	\N	\N	\N	\N	139940	139940	307443
18048	24666	0	applied	\N	\N	\N	\N	139949	139949	307452
18048	24667	1	applied	\N	\N	\N	\N	139950	139950	307453
18050	24668	0	applied	\N	\N	\N	\N	139953	139953	307456
18050	24669	1	applied	\N	\N	\N	\N	139954	139954	307457
18050	24670	2	applied	\N	\N	\N	\N	139955	139955	307458
18055	24675	0	applied	\N	\N	\N	\N	139966	139966	307469
18055	24676	1	applied	\N	\N	\N	\N	139967	139967	307470
18055	24677	2	applied	\N	\N	\N	\N	139968	139968	307471
18059	24681	3	applied	\N	\N	\N	\N	139984	139984	307487
18059	24682	4	applied	\N	\N	\N	\N	139985	139985	307488
18059	24683	5	applied	\N	\N	\N	\N	139986	139986	307489
18061	24684	0	applied	\N	\N	\N	\N	139993	139993	307496
18061	24685	1	applied	\N	\N	\N	\N	139994	139994	307497
18061	24687	3	applied	\N	\N	\N	\N	139996	139996	307499
18061	24688	4	applied	\N	\N	\N	\N	139997	139997	307500
18061	24689	5	applied	\N	\N	\N	\N	139998	139998	307501
18063	24690	0	applied	\N	\N	\N	\N	140005	140005	307508
18065	24691	0	applied	\N	\N	\N	\N	140007	140007	307510
18065	24690	1	applied	\N	\N	\N	\N	140008	140008	307511
18065	24692	2	applied	\N	\N	\N	\N	140009	140009	307512
18066	24693	0	applied	\N	\N	\N	\N	140010	140010	307513
18068	24697	0	applied	\N	\N	\N	\N	140014	140014	307517
18068	24698	1	applied	\N	\N	\N	\N	140015	140015	307518
18070	24697	0	applied	\N	\N	\N	\N	140018	140018	307521
18070	24698	1	applied	\N	\N	\N	\N	140019	140019	307522
18072	24697	0	applied	\N	\N	\N	\N	140022	140022	307525
18072	24698	1	applied	\N	\N	\N	\N	140023	140023	307526
18073	24699	0	applied	\N	\N	\N	\N	140024	140024	307527
18073	24700	1	applied	\N	\N	\N	\N	140025	140025	307528
18073	24702	3	applied	\N	\N	\N	\N	140027	140027	307530
18075	24703	0	applied	\N	\N	\N	\N	140032	140032	307535
18075	24704	1	applied	\N	\N	\N	\N	140033	140033	307536
18075	24705	2	applied	\N	\N	\N	\N	140034	140034	307537
18075	24706	3	applied	\N	\N	\N	\N	140035	140035	307538
18075	24707	4	applied	\N	\N	\N	\N	140036	140036	307539
18075	24708	5	applied	\N	\N	\N	\N	140037	140037	307540
18075	24709	6	applied	\N	\N	\N	\N	140038	140038	307541
18078	24715	0	applied	\N	\N	\N	\N	140046	140046	307549
18078	24716	1	applied	\N	\N	\N	\N	140047	140047	307550
18084	24722	0	applied	\N	\N	\N	\N	140059	140059	307562
18084	24723	1	applied	\N	\N	\N	\N	140060	140060	307563
18084	24724	2	applied	\N	\N	\N	\N	140061	140061	307564
18084	24725	3	applied	\N	\N	\N	\N	140062	140062	307565
18084	24726	4	applied	\N	\N	\N	\N	140063	140063	307566
18084	24727	5	applied	\N	\N	\N	\N	140064	140064	307567
18088	24729	0	applied	\N	\N	\N	\N	140094	140094	307597
18088	24730	1	applied	\N	\N	\N	\N	140095	140095	307598
18090	24731	0	applied	\N	\N	\N	\N	140221	140221	307723
18095	24737	0	applied	\N	\N	\N	\N	140233	140233	307735
18095	24738	1	applied	\N	\N	\N	\N	140234	140234	307736
18097	24739	0	applied	\N	\N	\N	\N	140237	140237	307739
18097	24740	1	applied	\N	\N	\N	\N	140238	140238	307740
18097	24741	2	applied	\N	\N	\N	\N	140239	140239	307741
18100	24746	0	applied	\N	\N	\N	\N	140244	140244	307746
18100	24747	1	applied	\N	\N	\N	\N	140245	140245	307747
18103	24754	0	applied	\N	\N	\N	\N	140252	140252	307754
18103	24755	1	applied	\N	\N	\N	\N	140253	140253	307755
18103	24756	2	applied	\N	\N	\N	\N	140254	140254	307756
18103	24757	3	applied	\N	\N	\N	\N	140255	140255	307757
18105	24754	0	applied	\N	\N	\N	\N	140260	140260	307762
18105	24755	1	applied	\N	\N	\N	\N	140261	140261	307763
18105	24757	3	applied	\N	\N	\N	\N	140263	140263	307765
18114	24764	0	applied	\N	\N	\N	\N	140294	140294	307796
18114	24765	1	applied	\N	\N	\N	\N	140295	140295	307797
18117	24766	0	applied	\N	\N	\N	\N	140331	140331	307833
18117	24767	1	applied	\N	\N	\N	\N	140332	140332	307834
18117	24768	2	applied	\N	\N	\N	\N	140333	140333	307835
18117	24769	3	applied	\N	\N	\N	\N	140334	140334	307836
18117	24770	4	applied	\N	\N	\N	\N	140335	140335	307837
18117	24771	5	applied	\N	\N	\N	\N	140336	140336	307838
18117	24772	6	applied	\N	\N	\N	\N	140337	140337	307839
18117	24773	7	applied	\N	\N	\N	\N	140338	140338	307840
18117	24774	8	applied	\N	\N	\N	\N	140339	140339	307841
18117	24775	9	applied	\N	\N	\N	\N	140340	140340	307842
18117	24776	10	applied	\N	\N	\N	\N	140341	140341	307843
18007	24600	6	applied	\N	\N	\N	\N	139786	139786	307297
18007	24601	7	applied	\N	\N	\N	\N	139787	139787	307298
18037	24653	0	applied	\N	\N	\N	\N	139905	139905	307413
18037	24654	1	applied	\N	\N	\N	\N	139906	139906	307414
18037	24655	2	applied	\N	\N	\N	\N	139907	139907	307415
18047	24666	0	applied	\N	\N	\N	\N	139947	139947	307450
18047	24667	1	applied	\N	\N	\N	\N	139948	139948	307451
18049	24666	0	applied	\N	\N	\N	\N	139951	139951	307454
18049	24667	1	applied	\N	\N	\N	\N	139952	139952	307455
18051	24668	0	applied	\N	\N	\N	\N	139956	139956	307459
18051	24669	1	applied	\N	\N	\N	\N	139957	139957	307460
18051	24670	2	applied	\N	\N	\N	\N	139958	139958	307461
18054	24675	0	applied	\N	\N	\N	\N	139963	139963	307466
18054	24677	2	applied	\N	\N	\N	\N	139965	139965	307468
18057	24663	0	applied	\N	\N	1000000000	\N	139972	139972	307475
18057	24675	1	applied	\N	\N	\N	\N	139973	139973	307476
18057	24560	3	applied	\N	\N	1000000000	\N	139974	139974	307477
18060	24684	0	applied	\N	\N	\N	\N	139987	139987	307490
18060	24685	1	applied	\N	\N	\N	\N	139988	139988	307491
18060	24686	2	applied	\N	\N	\N	\N	139989	139989	307492
18060	24687	3	applied	\N	\N	\N	\N	139990	139990	307493
18060	24688	4	applied	\N	\N	\N	\N	139991	139991	307494
18060	24689	5	applied	\N	\N	\N	\N	139992	139992	307495
18062	24684	0	applied	\N	\N	\N	\N	139999	139999	307502
18062	24685	1	applied	\N	\N	\N	\N	140000	140000	307503
18062	24686	2	applied	\N	\N	\N	\N	140001	140001	307504
18062	24687	3	applied	\N	\N	\N	\N	140002	140002	307505
18062	24688	4	applied	\N	\N	\N	\N	140003	140003	307506
18062	24689	5	applied	\N	\N	\N	\N	140004	140004	307507
18069	24697	0	applied	\N	\N	\N	\N	140016	140016	307519
18069	24698	1	applied	\N	\N	\N	\N	140017	140017	307520
18071	24697	0	applied	\N	\N	\N	\N	140020	140020	307523
18071	24698	1	applied	\N	\N	\N	\N	140021	140021	307524
18077	24715	0	applied	\N	\N	\N	\N	140044	140044	307547
18077	24716	1	applied	\N	\N	\N	\N	140045	140045	307548
18079	24717	0	applied	\N	\N	\N	\N	140048	140048	307551
18079	24718	1	applied	\N	\N	\N	\N	140049	140049	307552
18079	24719	2	applied	\N	\N	\N	\N	140050	140050	307553
18081	24717	0	applied	\N	\N	\N	\N	140054	140054	307557
18081	24718	1	applied	\N	\N	\N	\N	140055	140055	307558
18081	24719	2	applied	\N	\N	\N	\N	140056	140056	307559
18085	24663	0	applied	\N	\N	1000000000	\N	140066	140066	307569
18085	24675	1	applied	\N	\N	\N	\N	140067	140067	307570
18085	24691	2	applied	\N	\N	\N	\N	140068	140068	307571
18085	24686	3	applied	\N	\N	\N	\N	140069	140069	307572
18085	24630	5	applied	\N	\N	\N	\N	140071	140071	307574
18085	24637	6	applied	\N	\N	\N	\N	140072	140072	307575
18085	24645	7	applied	\N	\N	\N	\N	140073	140073	307576
18085	24654	8	applied	\N	\N	\N	\N	140074	140074	307577
18085	24662	9	applied	\N	\N	\N	\N	140075	140075	307578
18085	24670	10	applied	\N	\N	\N	\N	140076	140076	307579
18085	24681	11	applied	\N	\N	\N	\N	140077	140077	307580
18085	24689	12	applied	\N	\N	\N	\N	140078	140078	307581
18085	24696	13	applied	\N	\N	\N	\N	140079	140079	307582
18085	24709	14	applied	\N	\N	\N	\N	140080	140080	307583
18085	24712	15	applied	\N	\N	\N	\N	140081	140081	307584
18085	24719	16	applied	\N	\N	\N	\N	140082	140082	307585
18085	24725	17	applied	\N	\N	\N	\N	140083	140083	307586
18085	24626	18	applied	\N	\N	\N	\N	140084	140084	307587
18087	24729	0	applied	\N	\N	\N	\N	140092	140092	307595
18087	24730	1	applied	\N	\N	\N	\N	140093	140093	307596
18104	24755	1	applied	\N	\N	\N	\N	140257	140257	307759
18104	24756	2	applied	\N	\N	\N	\N	140258	140258	307760
18104	24757	3	applied	\N	\N	\N	\N	140259	140259	307761
18106	24758	0	applied	\N	\N	\N	\N	140264	140264	307766
18106	24759	1	applied	\N	\N	\N	\N	140265	140265	307767
18111	24764	0	applied	\N	\N	\N	\N	140288	140288	307790
18111	24765	1	applied	\N	\N	\N	\N	140289	140289	307791
18115	24731	0	applied	\N	\N	\N	\N	140296	140296	307798
18115	24732	1	applied	\N	\N	\N	\N	140297	140297	307799
18115	24735	2	applied	\N	\N	\N	\N	140298	140298	307800
18115	24737	3	applied	\N	\N	\N	\N	140299	140299	307801
18115	24739	4	applied	\N	\N	\N	\N	140300	140300	307802
18115	24742	5	applied	\N	\N	\N	\N	140301	140301	307803
18115	24744	6	applied	\N	\N	\N	\N	140302	140302	307804
18115	24746	7	applied	\N	\N	\N	\N	140303	140303	307805
18115	24748	8	applied	\N	\N	\N	\N	140304	140304	307806
18115	24752	10	applied	\N	\N	\N	\N	140306	140306	307808
18115	24754	11	applied	\N	\N	\N	\N	140307	140307	307809
18115	24758	12	applied	\N	\N	\N	\N	140308	140308	307810
18115	24760	13	applied	\N	\N	\N	\N	140309	140309	307811
18115	24761	14	applied	\N	\N	\N	\N	140310	140310	307812
18115	24764	15	applied	\N	\N	\N	\N	140311	140311	307813
18115	24733	16	applied	\N	\N	\N	\N	140312	140312	307814
18115	24736	17	applied	\N	\N	\N	\N	140313	140313	307815
18115	24738	18	applied	\N	\N	\N	\N	140314	140314	307816
18115	24734	19	applied	\N	\N	\N	\N	140315	140315	307817
18115	24740	20	applied	\N	\N	\N	\N	140316	140316	307818
18115	24743	21	applied	\N	\N	\N	\N	140317	140317	307819
18115	24745	22	applied	\N	\N	\N	\N	140318	140318	307820
18115	24747	23	applied	\N	\N	\N	\N	140319	140319	307821
18115	24750	24	applied	\N	\N	\N	\N	140320	140320	307822
18115	24741	25	applied	\N	\N	\N	\N	140321	140321	307823
18115	24755	27	applied	\N	\N	\N	\N	140323	140323	307825
18115	24762	28	applied	\N	\N	\N	\N	140324	140324	307826
18115	24751	29	applied	\N	\N	\N	\N	140325	140325	307827
18115	24756	30	applied	\N	\N	\N	\N	140326	140326	307828
18115	24757	31	applied	\N	\N	\N	\N	140327	140327	307829
18115	24759	32	applied	\N	\N	\N	\N	140328	140328	307830
18115	24763	33	applied	\N	\N	\N	\N	140329	140329	307831
18115	24765	34	applied	\N	\N	\N	\N	140330	140330	307832
18118	24766	0	applied	\N	\N	\N	\N	140342	140342	307844
18118	24767	1	applied	\N	\N	\N	\N	140343	140343	307845
18118	24768	2	applied	\N	\N	\N	\N	140344	140344	307846
18122	24780	0	applied	\N	\N	\N	\N	140362	140362	307864
18122	24781	1	applied	\N	\N	\N	\N	140363	140363	307865
18122	24782	2	applied	\N	\N	\N	\N	140364	140364	307866
18122	24783	3	applied	\N	\N	\N	\N	140365	140365	307867
18127	24789	0	applied	\N	\N	\N	\N	140434	140434	307936
18127	24791	2	applied	\N	\N	\N	\N	140436	140436	307938
18127	24792	3	applied	\N	\N	\N	\N	140437	140437	307939
18036	24654	1	applied	\N	\N	\N	\N	139903	139903	307411
18036	24655	2	applied	\N	\N	\N	\N	139904	139904	307412
18076	24713	3	applied	\N	\N	\N	\N	140042	140042	307545
18076	24714	4	applied	\N	\N	\N	\N	140043	140043	307546
18086	24722	0	applied	\N	\N	\N	\N	140085	140085	307588
18086	24723	1	applied	\N	\N	\N	\N	140086	140086	307589
18086	24724	2	applied	\N	\N	\N	\N	140087	140087	307590
18086	24725	3	applied	\N	\N	\N	\N	140088	140088	307591
18086	24726	4	applied	\N	\N	\N	\N	140089	140089	307592
18086	24728	6	applied	\N	\N	\N	\N	140091	140091	307594
18089	24663	0	applied	\N	\N	1000000000	\N	140096	140096	307599
18089	24675	1	applied	\N	\N	\N	\N	140097	140097	307600
18089	24691	2	applied	\N	\N	\N	\N	140098	140098	307601
18089	24686	3	applied	\N	\N	\N	\N	140099	140099	307602
18089	24560	4	applied	\N	\N	1000000000	\N	140100	140100	307603
18089	24469	5	applied	\N	\N	\N	\N	140101	140101	307604
18089	24472	6	applied	\N	\N	\N	\N	140102	140102	307605
18089	24567	7	applied	\N	\N	1000000000	\N	140103	140103	307606
18089	24571	8	applied	\N	\N	1000000000	\N	140104	140104	307607
18089	24476	9	applied	\N	\N	\N	\N	140105	140105	307608
18089	24477	10	applied	\N	\N	\N	\N	140106	140106	307609
18089	24482	11	applied	\N	\N	\N	\N	140107	140107	307610
18089	24483	12	applied	\N	\N	\N	\N	140108	140108	307611
18089	24489	13	applied	\N	\N	\N	\N	140109	140109	307612
18089	24592	14	applied	\N	\N	\N	\N	140110	140110	307613
18089	24575	16	applied	\N	\N	1000000000	\N	140112	140112	307615
18089	24514	17	applied	\N	\N	\N	\N	140113	140113	307616
18089	24529	18	applied	\N	\N	\N	\N	140114	140114	307617
18089	24492	19	applied	\N	\N	\N	\N	140115	140115	307618
18089	24493	20	applied	\N	\N	\N	\N	140116	140116	307619
18089	24494	21	applied	\N	\N	\N	\N	140117	140117	307620
18089	24502	22	applied	\N	\N	\N	\N	140118	140118	307621
18089	24504	23	applied	\N	\N	\N	\N	140119	140119	307622
18089	24505	24	applied	\N	\N	\N	\N	140120	140120	307623
18089	24511	25	applied	\N	\N	\N	\N	140121	140121	307624
18089	24538	26	applied	\N	\N	\N	\N	140122	140122	307625
18089	24544	27	applied	\N	\N	\N	\N	140123	140123	307626
18089	24515	28	applied	\N	\N	\N	\N	140124	140124	307627
18089	24518	29	applied	\N	\N	\N	\N	140125	140125	307628
18089	24522	30	applied	\N	\N	\N	\N	140126	140126	307629
18089	24523	31	applied	\N	\N	\N	\N	140127	140127	307630
18089	24530	33	applied	\N	\N	\N	\N	140129	140129	307632
18089	24536	34	applied	\N	\N	\N	\N	140130	140130	307633
18089	24537	35	applied	\N	\N	\N	\N	140131	140131	307634
18089	24545	36	applied	\N	\N	\N	\N	140132	140132	307635
18089	24546	37	applied	\N	\N	\N	\N	140133	140133	307636
18089	24552	38	applied	\N	\N	\N	\N	140134	140134	307637
18089	24555	39	applied	\N	\N	\N	\N	140135	140135	307638
18089	24559	40	applied	\N	\N	\N	\N	140136	140136	307639
18089	24563	41	applied	\N	\N	\N	\N	140137	140137	307640
18089	24566	42	applied	\N	\N	\N	\N	140138	140138	307641
18089	24572	43	applied	\N	\N	\N	\N	140139	140139	307642
18089	24573	44	applied	\N	\N	\N	\N	140140	140140	307643
18089	24574	45	applied	\N	\N	\N	\N	140141	140141	307644
18089	24583	46	applied	\N	\N	\N	\N	140142	140142	307645
18089	24586	47	applied	\N	\N	\N	\N	140143	140143	307646
18089	24589	48	applied	\N	\N	\N	\N	140144	140144	307647
18089	24596	50	applied	\N	\N	\N	\N	140146	140146	307649
18089	24599	51	applied	\N	\N	\N	\N	140147	140147	307650
18089	24602	52	applied	\N	\N	\N	\N	140148	140148	307651
18089	24606	53	applied	\N	\N	\N	\N	140149	140149	307652
18089	24611	54	applied	\N	\N	\N	\N	140150	140150	307653
18089	24613	55	applied	\N	\N	\N	\N	140151	140151	307654
18089	24617	56	applied	\N	\N	\N	\N	140152	140152	307655
18089	24620	57	applied	\N	\N	\N	\N	140153	140153	307656
18089	24623	58	applied	\N	\N	\N	\N	140154	140154	307657
18089	24627	59	applied	\N	\N	\N	\N	140155	140155	307658
18089	24628	60	applied	\N	\N	\N	\N	140156	140156	307659
18089	24633	61	applied	\N	\N	\N	\N	140157	140157	307660
18089	24636	63	applied	\N	\N	\N	\N	140158	140158	307661
18089	24640	64	applied	\N	\N	\N	\N	140159	140159	307662
18089	24642	65	applied	\N	\N	\N	\N	140160	140160	307663
18089	24644	66	applied	\N	\N	\N	\N	140161	140161	307664
18089	24649	68	applied	\N	\N	\N	\N	140163	140163	307666
18089	24650	69	applied	\N	\N	\N	\N	140164	140164	307667
18089	24653	70	applied	\N	\N	\N	\N	140165	140165	307668
18089	24656	71	applied	\N	\N	\N	\N	140166	140166	307669
18089	24658	72	applied	\N	\N	\N	\N	140167	140167	307670
18089	24660	73	applied	\N	\N	\N	\N	140168	140168	307671
18089	24664	74	applied	\N	\N	\N	\N	140169	140169	307672
18089	24666	75	applied	\N	\N	\N	\N	140170	140170	307673
18089	24668	76	applied	\N	\N	\N	\N	140171	140171	307674
18089	24671	77	applied	\N	\N	\N	\N	140172	140172	307675
18089	24672	78	applied	\N	\N	\N	\N	140173	140173	307676
18089	24676	79	applied	\N	\N	\N	\N	140174	140174	307677
18089	24678	80	applied	\N	\N	\N	\N	140175	140175	307678
18089	24680	81	applied	\N	\N	\N	\N	140176	140176	307679
18089	24684	82	applied	\N	\N	\N	\N	140177	140177	307680
18089	24685	83	applied	\N	\N	\N	\N	140178	140178	307681
18089	24693	85	applied	\N	\N	\N	\N	140180	140180	307683
18089	24694	86	applied	\N	\N	\N	\N	140181	140181	307684
18089	24697	87	applied	\N	\N	\N	\N	140182	140182	307685
18089	24699	88	applied	\N	\N	\N	\N	140183	140183	307686
18089	24700	89	applied	\N	\N	\N	\N	140184	140184	307687
18089	24703	90	applied	\N	\N	\N	\N	140185	140185	307688
18089	24704	91	applied	\N	\N	\N	\N	140186	140186	307689
18089	24705	92	applied	\N	\N	\N	\N	140187	140187	307690
18089	24710	93	applied	\N	\N	\N	\N	140188	140188	307691
18089	24711	94	applied	\N	\N	\N	\N	140189	140189	307692
18089	24715	95	applied	\N	\N	\N	\N	140190	140190	307693
18089	24717	96	applied	\N	\N	\N	\N	140191	140191	307694
18089	24720	97	applied	\N	\N	\N	\N	140192	140192	307695
18089	24722	98	applied	\N	\N	\N	\N	140193	140193	307696
18089	24723	99	applied	\N	\N	\N	\N	140194	140194	307697
18118	24769	3	applied	\N	\N	\N	\N	140345	140345	307847
18118	24771	5	applied	\N	\N	\N	\N	140347	140347	307849
18118	24772	6	applied	\N	\N	\N	\N	140348	140348	307850
18118	24773	7	applied	\N	\N	\N	\N	140349	140349	307851
18118	24774	8	applied	\N	\N	\N	\N	140350	140350	307852
18118	24775	9	applied	\N	\N	\N	\N	140351	140351	307853
18118	24776	10	applied	\N	\N	\N	\N	140352	140352	307854
18076	24711	1	applied	\N	\N	\N	\N	140040	140040	307543
18076	24712	2	applied	\N	\N	\N	\N	140041	140041	307544
18089	24547	104	applied	\N	\N	\N	\N	140199	140199	140199
18089	24609	105	applied	\N	\N	\N	\N	140200	140200	307702
18089	24626	106	applied	\N	\N	\N	\N	140201	140201	307703
18089	24420	107	applied	\N	\N	\N	\N	140202	140202	307704
18089	24429	108	applied	\N	\N	\N	\N	140203	140203	307705
18089	24440	109	applied	\N	\N	\N	\N	140204	140204	307706
18089	24454	110	applied	\N	\N	\N	\N	140205	140205	307707
18089	24465	111	applied	\N	\N	\N	\N	140206	140206	307708
18089	24474	112	applied	\N	\N	\N	\N	140207	140207	307709
18089	24488	113	applied	\N	\N	\N	\N	140208	140208	307710
18089	24497	114	applied	\N	\N	\N	\N	140209	140209	307711
18089	24508	115	applied	\N	\N	\N	\N	140210	140210	307712
18089	24520	116	applied	\N	\N	\N	\N	140211	140211	307713
18089	24531	117	applied	\N	\N	\N	\N	140212	140212	307714
18089	24541	118	applied	\N	\N	\N	\N	140213	140213	307715
18089	24558	119	applied	\N	\N	\N	\N	140214	140214	307716
18089	24576	121	applied	\N	\N	\N	\N	140216	140216	307718
18089	24595	122	applied	\N	\N	\N	\N	140217	140217	307719
18089	24603	123	applied	\N	\N	\N	\N	140218	140218	307720
18089	24615	124	applied	\N	\N	\N	\N	140219	140219	307721
18089	24630	125	applied	\N	\N	\N	\N	140220	140220	307722
18091	24732	0	applied	\N	\N	\N	\N	140222	140222	307724
18091	24733	1	applied	\N	\N	\N	\N	140223	140223	307725
18091	24734	2	applied	\N	\N	\N	\N	140224	140224	307726
18093	24732	0	applied	\N	\N	\N	\N	140228	140228	307730
18093	24733	1	applied	\N	\N	\N	\N	140229	140229	307731
18093	24734	2	applied	\N	\N	\N	\N	140230	140230	307732
18096	24737	0	applied	\N	\N	\N	\N	140235	140235	307737
18096	24738	1	applied	\N	\N	\N	\N	140236	140236	307738
18098	24742	0	applied	\N	\N	\N	\N	140240	140240	307742
18098	24743	1	applied	\N	\N	\N	\N	140241	140241	307743
18101	24748	0	applied	\N	\N	\N	\N	140246	140246	307748
18101	24750	2	applied	\N	\N	\N	\N	140248	140248	307750
18101	24751	3	applied	\N	\N	\N	\N	140249	140249	307751
18108	24758	0	applied	\N	\N	\N	\N	140266	140266	307768
18108	24760	1	applied	\N	\N	\N	\N	140267	140267	307769
18108	24759	2	applied	\N	\N	\N	\N	140268	140268	307770
18110	24761	0	applied	\N	\N	\N	\N	140285	140285	307787
18110	24762	1	applied	\N	\N	\N	\N	140286	140286	307788
18110	24763	2	applied	\N	\N	\N	\N	140287	140287	307789
18113	24764	0	applied	\N	\N	\N	\N	140292	140292	307794
18113	24765	1	applied	\N	\N	\N	\N	140293	140293	307795
18119	24778	1	applied	\N	\N	\N	\N	140354	140354	307856
18119	24779	2	applied	\N	\N	\N	\N	140355	140355	307857
18120	24777	0	applied	\N	\N	\N	\N	140356	140356	307858
18120	24778	1	applied	\N	\N	\N	\N	140357	140357	307859
18120	24779	2	applied	\N	\N	\N	\N	140358	140358	307860
18121	24777	0	applied	\N	\N	\N	\N	140359	140359	307861
18121	24779	2	applied	\N	\N	\N	\N	140361	140361	307863
18124	24784	0	applied	\N	\N	\N	\N	140366	140366	307868
18124	24785	1	applied	\N	\N	\N	\N	140367	140367	307869
18124	24786	2	applied	\N	\N	\N	\N	140368	140368	307870
18124	24787	3	applied	\N	\N	\N	\N	140369	140369	307871
18124	24788	4	applied	\N	\N	\N	\N	140370	140370	307872
18125	24784	0	applied	\N	\N	\N	\N	140371	140371	307873
18125	24785	1	applied	\N	\N	\N	\N	140372	140372	307874
18125	24786	2	applied	\N	\N	\N	\N	140373	140373	307875
18125	24787	3	applied	\N	\N	\N	\N	140374	140374	307876
18125	24788	4	applied	\N	\N	\N	\N	140375	140375	307877
18126	24691	0	applied	\N	\N	\N	\N	140376	140376	307878
18126	24693	1	applied	\N	\N	\N	\N	140377	140377	307879
18126	24694	2	applied	\N	\N	\N	\N	140378	140378	307880
18126	24697	3	applied	\N	\N	\N	\N	140379	140379	307881
18126	24699	4	applied	\N	\N	\N	\N	140380	140380	307882
18126	24703	6	applied	\N	\N	\N	\N	140382	140382	307884
18126	24704	7	applied	\N	\N	\N	\N	140383	140383	307885
18126	24705	8	applied	\N	\N	\N	\N	140384	140384	307886
18126	24710	9	applied	\N	\N	\N	\N	140385	140385	307887
18126	24711	10	applied	\N	\N	\N	\N	140386	140386	307888
18126	24715	11	applied	\N	\N	\N	\N	140387	140387	307889
18126	24717	12	applied	\N	\N	\N	\N	140388	140388	307890
18126	24720	13	applied	\N	\N	\N	\N	140389	140389	307891
18126	24722	14	applied	\N	\N	\N	\N	140390	140390	307892
18126	24723	15	applied	\N	\N	\N	\N	140391	140391	307893
18126	24724	16	applied	\N	\N	\N	\N	140392	140392	307894
18126	24729	17	applied	\N	\N	\N	\N	140393	140393	307895
18126	24731	18	applied	\N	\N	\N	\N	140394	140394	307896
18126	24732	19	applied	\N	\N	\N	\N	140395	140395	307897
18126	24735	20	applied	\N	\N	\N	\N	140396	140396	307898
18126	24737	21	applied	\N	\N	\N	\N	140397	140397	307899
18126	24742	23	applied	\N	\N	\N	\N	140399	140399	307901
18126	24744	24	applied	\N	\N	\N	\N	140400	140400	307902
18126	24746	25	applied	\N	\N	\N	\N	140401	140401	307903
18126	24748	26	applied	\N	\N	\N	\N	140402	140402	307904
18126	24749	27	applied	\N	\N	\N	\N	140403	140403	307905
18126	24752	28	applied	\N	\N	\N	\N	140404	140404	307906
18126	24754	29	applied	\N	\N	\N	\N	140405	140405	307907
18126	24758	30	applied	\N	\N	\N	\N	140406	140406	307908
18126	24760	31	applied	\N	\N	\N	\N	140407	140407	307909
18126	24761	32	applied	\N	\N	\N	\N	140408	140408	307910
18126	24764	33	applied	\N	\N	\N	\N	140409	140409	307911
18126	24766	34	applied	\N	\N	\N	\N	140410	140410	307912
18126	24767	35	applied	\N	\N	\N	\N	140411	140411	307913
18126	24768	36	applied	\N	\N	\N	\N	140412	140412	307914
18126	24769	37	applied	\N	\N	\N	\N	140413	140413	307915
18126	24770	38	applied	\N	\N	\N	\N	140414	140414	307916
18126	24780	40	applied	\N	\N	\N	\N	140416	140416	307918
18126	24781	41	applied	\N	\N	\N	\N	140417	140417	307919
18126	24784	42	applied	\N	\N	\N	\N	140418	140418	307920
18126	24785	43	applied	\N	\N	\N	\N	140419	140419	307921
18128	24789	0	applied	\N	\N	\N	\N	140441	140441	307943
18128	24790	1	applied	\N	\N	\N	\N	140442	140442	307944
18128	24791	2	applied	\N	\N	\N	\N	140443	140443	307945
18128	24792	3	applied	\N	\N	\N	\N	140444	140444	307946
18128	24793	4	applied	\N	\N	\N	\N	140445	140445	307947
18128	24794	5	applied	\N	\N	\N	\N	140446	140446	307948
18128	24795	6	applied	\N	\N	\N	\N	140447	140447	307949
18131	24800	0	applied	\N	\N	\N	\N	140455	140455	307957
18131	24801	1	applied	\N	\N	\N	\N	140456	140456	307958
18131	24802	2	applied	\N	\N	\N	\N	140457	140457	307959
18089	24729	101	applied	\N	\N	\N	\N	140196	140196	307699
18089	24394	102	applied	\N	\N	\N	\N	140197	140197	307700
18126	24719	48	applied	\N	\N	\N	\N	140424	140424	307926
18126	24725	49	applied	\N	\N	\N	\N	140425	140425	307927
18126	24741	51	applied	\N	\N	\N	\N	140427	140427	307929
18126	24753	52	applied	\N	\N	\N	\N	140428	140428	307930
18126	24755	53	applied	\N	\N	\N	\N	140429	140429	307931
18126	24762	54	applied	\N	\N	\N	\N	140430	140430	307932
18126	24773	55	applied	\N	\N	\N	\N	140431	140431	307933
18126	24778	56	applied	\N	\N	\N	\N	140432	140432	307934
18126	24786	57	applied	\N	\N	\N	\N	140433	140433	307935
18127	24793	4	applied	\N	\N	\N	\N	140438	140438	307940
18127	24794	5	applied	\N	\N	\N	\N	140439	140439	307941
18127	24795	6	applied	\N	\N	\N	\N	140440	140440	307942
18129	24796	0	applied	\N	\N	\N	\N	140448	140448	307950
18129	24797	1	applied	\N	\N	\N	\N	140449	140449	307951
18129	24798	2	applied	\N	\N	\N	\N	140450	140450	307952
18129	24799	3	applied	\N	\N	\N	\N	140451	140451	307953
18130	24800	0	applied	\N	\N	\N	\N	140452	140452	307954
18130	24801	1	applied	\N	\N	\N	\N	140453	140453	307955
18132	24800	0	applied	\N	\N	\N	\N	140458	140458	307960
18132	24801	1	applied	\N	\N	\N	\N	140459	140459	307961
18132	24802	2	applied	\N	\N	\N	\N	140460	140460	307962
18134	24803	0	applied	\N	\N	\N	\N	140463	140463	307965
18134	24804	1	applied	\N	\N	\N	\N	140464	140464	307966
18135	24663	0	applied	\N	\N	1000000000	\N	140465	140465	307967
18135	24043	1	applied	\N	\N	\N	\N	140466	140466	307968
18135	24675	2	applied	\N	\N	\N	\N	140467	140467	307969
18135	24691	3	applied	\N	\N	\N	\N	140468	140468	307970
18135	24037	4	applied	\N	\N	\N	\N	140469	140469	140469
18135	24686	5	applied	\N	\N	\N	\N	140470	140470	307971
18135	24028	6	applied	\N	\N	\N	\N	140471	140471	140471
18135	24560	7	applied	\N	\N	1000000000	\N	140472	140472	307972
18135	24592	8	applied	\N	\N	\N	\N	140473	140473	307973
18135	24195	10	applied	\N	\N	1000000000	\N	140475	140475	307975
18135	24347	11	applied	\N	\N	1000000000	\N	140476	140476	307976
18135	24567	12	applied	\N	\N	1000000000	\N	140477	140477	307977
18135	24571	13	applied	\N	\N	1000000000	\N	140478	140478	307978
18135	24556	14	applied	\N	\N	\N	\N	140479	140479	307979
18135	24575	15	applied	\N	\N	1000000000	\N	140480	140480	307980
18135	24514	16	applied	\N	\N	\N	\N	140481	140481	307981
18135	24529	17	applied	\N	\N	\N	\N	140482	140482	307982
18135	24538	18	applied	\N	\N	\N	\N	140483	140483	307983
18135	24544	19	applied	\N	\N	\N	\N	140484	140484	307984
18135	24414	21	applied	\N	\N	\N	\N	140486	140486	140486
18135	24120	20	failed	Amount_insufficient_to_create_account	\N	\N	\N	140485	140485	\N
18135	24547	24	applied	\N	\N	\N	\N	140489	140489	140489
18135	24261	23	failed	Amount_insufficient_to_create_account	\N	\N	\N	140488	140488	\N
18135	24133	26	applied	\N	\N	\N	\N	140491	140491	307985
18135	24121	25	failed	Amount_insufficient_to_create_account	\N	\N	\N	140490	140490	\N
18135	23996	27	applied	\N	\N	\N	\N	140492	140492	307986
18135	24423	28	applied	\N	\N	\N	\N	140493	140493	140493
18135	24438	29	applied	\N	\N	\N	\N	140494	140494	140494
18135	24280	30	applied	\N	\N	\N	\N	140495	140495	307987
18135	24609	31	applied	\N	\N	\N	\N	140496	140496	307988
18135	24626	32	applied	\N	\N	\N	\N	140497	140497	307989
18135	24014	33	applied	\N	\N	\N	\N	140498	140498	307990
18135	24018	34	applied	\N	\N	\N	\N	140499	140499	307991
18135	24035	35	applied	\N	\N	\N	\N	140500	140500	307992
18135	24049	36	applied	\N	\N	\N	\N	140501	140501	307993
18135	24059	37	applied	\N	\N	\N	\N	140502	140502	307994
18135	24069	38	applied	\N	\N	\N	\N	140503	140503	307995
18135	24080	39	applied	\N	\N	\N	\N	140504	140504	307996
18135	24092	41	applied	\N	\N	\N	\N	140505	140505	307997
18135	24102	42	applied	\N	\N	\N	\N	140506	140506	307998
18135	24111	43	applied	\N	\N	\N	\N	140507	140507	307999
18135	24128	44	applied	\N	\N	\N	\N	140508	140508	308000
18135	24139	45	applied	\N	\N	\N	\N	140509	140509	308001
18135	24146	46	applied	\N	\N	\N	\N	140510	140510	308002
18135	24156	47	applied	\N	\N	\N	\N	140511	140511	308003
18135	24171	48	applied	\N	\N	\N	\N	140512	140512	308004
18135	24178	49	applied	\N	\N	\N	\N	140513	140513	308005
18135	24191	50	applied	\N	\N	\N	\N	140514	140514	308006
18135	24198	51	applied	\N	\N	\N	\N	140515	140515	308007
18135	24209	52	applied	\N	\N	\N	\N	140516	140516	308008
18135	24218	53	applied	\N	\N	\N	\N	140517	140517	308009
18135	24233	54	applied	\N	\N	\N	\N	140518	140518	308010
18135	24239	55	applied	\N	\N	\N	\N	140519	140519	308011
18135	24266	57	applied	\N	\N	\N	\N	140521	140521	308013
18135	24274	58	applied	\N	\N	\N	\N	140522	140522	308014
18135	24284	59	applied	\N	\N	\N	\N	140523	140523	308015
18135	24298	60	applied	\N	\N	\N	\N	140524	140524	308016
18135	24309	61	applied	\N	\N	\N	\N	140525	140525	308017
18135	24318	62	applied	\N	\N	\N	\N	140526	140526	308018
18135	24331	63	applied	\N	\N	\N	\N	140527	140527	308019
18135	24341	64	applied	\N	\N	\N	\N	140528	140528	308020
18135	24353	65	applied	\N	\N	\N	\N	140529	140529	308021
18135	24367	66	applied	\N	\N	\N	\N	140530	140530	308022
18135	24375	67	applied	\N	\N	\N	\N	140531	140531	308023
18135	24384	68	applied	\N	\N	\N	\N	140532	140532	308024
18135	24394	69	applied	\N	\N	\N	\N	140533	140533	308025
18135	24404	70	applied	\N	\N	\N	\N	140534	140534	308026
18135	24420	71	applied	\N	\N	\N	\N	140535	140535	308027
18135	24429	72	applied	\N	\N	\N	\N	140536	140536	308028
18135	24454	74	applied	\N	\N	\N	\N	140538	140538	308030
18135	24465	75	applied	\N	\N	\N	\N	140539	140539	308031
18135	24474	76	applied	\N	\N	\N	\N	140540	140540	308032
18135	24488	77	applied	\N	\N	\N	\N	140541	140541	308033
18135	24497	78	applied	\N	\N	\N	\N	140542	140542	308034
18135	24508	79	applied	\N	\N	\N	\N	140543	140543	308035
18135	24520	80	applied	\N	\N	\N	\N	140544	140544	308036
18135	24531	81	applied	\N	\N	\N	\N	140545	140545	308037
18135	24541	82	applied	\N	\N	\N	\N	140546	140546	308038
18135	24558	83	applied	\N	\N	\N	\N	140547	140547	308039
18135	24569	84	applied	\N	\N	\N	\N	140548	140548	308040
18135	24576	85	applied	\N	\N	\N	\N	140549	140549	308041
18135	24595	86	applied	\N	\N	\N	\N	140550	140550	308042
18135	24603	87	applied	\N	\N	\N	\N	140551	140551	308043
18135	24615	88	applied	\N	\N	\N	\N	140552	140552	308044
18126	24696	45	applied	\N	\N	\N	\N	140421	140421	307923
18126	24712	47	applied	\N	\N	\N	\N	140423	140423	307925
18135	24637	90	applied	\N	\N	\N	\N	140554	140554	308046
18135	24645	91	applied	\N	\N	\N	\N	140555	140555	308047
18135	24654	92	applied	\N	\N	\N	\N	140556	140556	308048
18135	24662	93	applied	\N	\N	\N	\N	140557	140557	308049
18135	24670	94	applied	\N	\N	\N	\N	140558	140558	308050
18135	24681	95	applied	\N	\N	\N	\N	140559	140559	308051
18135	24689	96	applied	\N	\N	\N	\N	140560	140560	308052
18135	24696	97	applied	\N	\N	\N	\N	140561	140561	308053
18135	24709	98	applied	\N	\N	\N	\N	140562	140562	308054
18135	24712	99	applied	\N	\N	\N	\N	140563	140563	308055
18135	24719	100	applied	\N	\N	\N	\N	140564	140564	308056
18135	24734	102	applied	\N	\N	\N	\N	140566	140566	308058
18135	24741	103	applied	\N	\N	\N	\N	140567	140567	308059
18135	24753	104	applied	\N	\N	\N	\N	140568	140568	308060
18135	24755	105	applied	\N	\N	\N	\N	140569	140569	308061
18135	24762	106	applied	\N	\N	\N	\N	140570	140570	308062
18135	24773	107	applied	\N	\N	\N	\N	140571	140571	308063
18135	24778	108	applied	\N	\N	\N	\N	140572	140572	308064
18135	24786	109	applied	\N	\N	\N	\N	140573	140573	308065
18135	24792	110	applied	\N	\N	\N	\N	140574	140574	308066
18135	24802	111	applied	\N	\N	\N	\N	140575	140575	308067
18136	24805	0	applied	\N	\N	\N	\N	140576	140576	308068
18136	24806	1	applied	\N	\N	\N	\N	140577	140577	308069
18136	24807	2	applied	\N	\N	\N	\N	140578	140578	308070
18136	24808	3	applied	\N	\N	\N	\N	140579	140579	308071
18136	24809	4	applied	\N	\N	\N	\N	140580	140580	308072
18136	24810	5	applied	\N	\N	\N	\N	140581	140581	308073
18137	24805	0	applied	\N	\N	\N	\N	140583	140583	308075
18137	24806	1	applied	\N	\N	\N	\N	140584	140584	308076
18137	24807	2	applied	\N	\N	\N	\N	140585	140585	308077
18137	24808	3	applied	\N	\N	\N	\N	140586	140586	308078
18137	24809	4	applied	\N	\N	\N	\N	140587	140587	308079
18137	24810	5	applied	\N	\N	\N	\N	140588	140588	308080
18137	24811	6	applied	\N	\N	\N	\N	140589	140589	308081
18138	24805	0	applied	\N	\N	\N	\N	140590	140590	308082
18138	24806	1	applied	\N	\N	\N	\N	140591	140591	308083
18138	24807	2	applied	\N	\N	\N	\N	140592	140592	308084
18138	24808	3	applied	\N	\N	\N	\N	140593	140593	308085
18138	24809	4	applied	\N	\N	\N	\N	140594	140594	308086
18138	24810	5	applied	\N	\N	\N	\N	140595	140595	308087
18138	24811	6	applied	\N	\N	\N	\N	140596	140596	308088
18139	24812	0	applied	\N	\N	\N	\N	140597	140597	308089
18139	24813	1	applied	\N	\N	\N	\N	140598	140598	308090
18140	24813	1	applied	\N	\N	\N	\N	140600	140600	308092
18141	24814	0	applied	\N	\N	\N	\N	140601	140601	308093
18141	24815	1	applied	\N	\N	\N	\N	140602	140602	308094
18142	24816	0	applied	\N	\N	\N	\N	140603	140603	308095
18142	24817	1	applied	\N	\N	\N	\N	140604	140604	308096
18142	24818	2	applied	\N	\N	\N	\N	140605	140605	308097
18142	24819	3	applied	\N	\N	\N	\N	140606	140606	308098
18142	24820	4	applied	\N	\N	\N	\N	140607	140607	308099
18143	24816	0	applied	\N	\N	\N	\N	140608	140608	308100
18143	24817	1	applied	\N	\N	\N	\N	140609	140609	308101
18143	24818	2	applied	\N	\N	\N	\N	140610	140610	308102
18143	24819	3	applied	\N	\N	\N	\N	140611	140611	308103
18143	24820	4	applied	\N	\N	\N	\N	140612	140612	308104
18144	24821	0	applied	\N	\N	\N	\N	140613	140613	308105
18144	24822	1	applied	\N	\N	\N	\N	140614	140614	308106
18145	24823	0	applied	\N	\N	\N	\N	140615	140615	308107
18146	24823	0	applied	\N	\N	\N	\N	140617	140617	308109
18146	24824	1	applied	\N	\N	\N	\N	140618	140618	308110
18147	24823	0	applied	\N	\N	\N	\N	140619	140619	308111
18147	24824	1	applied	\N	\N	\N	\N	140620	140620	308112
18148	24825	0	applied	\N	\N	\N	\N	140621	140621	308113
18148	24826	1	applied	\N	\N	\N	\N	140622	140622	308114
18148	24827	2	applied	\N	\N	\N	\N	140623	140623	308115
18150	24828	0	applied	\N	\N	\N	\N	140624	140624	140624
18150	24829	1	applied	\N	\N	\N	\N	140625	140625	308116
18150	24830	2	applied	\N	\N	\N	\N	140626	140626	308117
18150	24831	3	applied	\N	\N	\N	\N	140627	140627	308118
18150	24832	4	applied	\N	\N	\N	\N	140628	140628	308119
18150	24833	5	applied	\N	\N	1000000000	\N	140629	140629	308120
18150	24834	6	applied	\N	\N	\N	\N	140630	140630	308121
18150	24835	7	applied	\N	\N	\N	\N	140631	140631	308122
18150	24836	8	applied	\N	\N	\N	\N	140632	140632	308123
18150	24838	10	applied	\N	\N	\N	\N	140634	140634	308125
18150	24839	11	applied	\N	\N	\N	\N	140635	140635	308126
18150	24840	12	applied	\N	\N	\N	\N	140636	140636	308127
18150	24841	14	applied	\N	\N	\N	\N	140637	140637	308128
18150	24842	15	applied	\N	\N	\N	\N	140638	140638	308129
18151	24828	0	applied	\N	\N	\N	\N	140639	140639	140639
18151	24829	1	applied	\N	\N	\N	\N	140640	140640	308130
18151	24830	2	applied	\N	\N	\N	\N	140641	140641	308131
18151	24831	3	applied	\N	\N	\N	\N	140642	140642	308132
18151	24832	4	applied	\N	\N	\N	\N	140643	140643	308133
18151	24833	5	applied	\N	\N	1000000000	\N	140644	140644	308134
18151	24834	6	applied	\N	\N	\N	\N	140645	140645	308135
18151	24835	7	applied	\N	\N	\N	\N	140646	140646	308136
18151	24836	8	applied	\N	\N	\N	\N	140647	140647	308137
18151	24837	9	applied	\N	\N	\N	\N	140648	140648	308138
18151	24838	10	applied	\N	\N	\N	\N	140649	140649	308139
18151	24840	12	applied	\N	\N	\N	\N	140651	140651	308141
18151	24841	14	applied	\N	\N	\N	\N	140652	140652	308142
18151	24842	15	applied	\N	\N	\N	\N	140653	140653	308143
18152	24828	0	applied	\N	\N	\N	\N	140654	140654	140654
18152	24829	1	applied	\N	\N	\N	\N	140655	140655	308144
18152	24830	2	applied	\N	\N	\N	\N	140656	140656	308145
18152	24831	3	applied	\N	\N	\N	\N	140657	140657	308146
18152	24832	4	applied	\N	\N	\N	\N	140658	140658	308147
18152	24833	5	applied	\N	\N	1000000000	\N	140659	140659	308148
18152	24834	6	applied	\N	\N	\N	\N	140660	140660	308149
18152	24835	7	applied	\N	\N	\N	\N	140661	140661	308150
18152	24836	8	applied	\N	\N	\N	\N	140662	140662	308151
18152	24837	9	applied	\N	\N	\N	\N	140663	140663	308152
18152	24838	10	applied	\N	\N	\N	\N	140664	140664	308153
18152	24839	11	applied	\N	\N	\N	\N	140665	140665	308154
18152	24840	12	applied	\N	\N	\N	\N	140666	140666	308155
18152	24842	15	applied	\N	\N	\N	\N	140668	140668	308157
18153	24717	0	applied	\N	\N	\N	\N	140669	140669	308158
18133	24804	1	applied	\N	\N	\N	\N	140462	140462	307964
18135	24630	89	applied	\N	\N	\N	\N	140553	140553	308045
18153	24723	5	applied	\N	\N	\N	\N	140674	140674	308162
18153	24724	6	applied	\N	\N	\N	\N	140675	140675	308163
18153	24729	7	applied	\N	\N	\N	\N	140676	140676	308164
18153	24731	8	applied	\N	\N	\N	\N	140677	140677	308165
18153	24732	9	applied	\N	\N	\N	\N	140678	140678	308166
18153	24735	10	applied	\N	\N	\N	\N	140679	140679	308167
18153	24737	11	applied	\N	\N	\N	\N	140680	140680	308168
18153	24739	12	applied	\N	\N	\N	\N	140681	140681	308169
18153	24742	13	applied	\N	\N	\N	\N	140682	140682	308170
18153	24744	14	applied	\N	\N	\N	\N	140683	140683	308171
18153	24746	15	applied	\N	\N	\N	\N	140684	140684	308172
18153	24748	16	applied	\N	\N	\N	\N	140685	140685	308173
18153	24749	17	applied	\N	\N	\N	\N	140686	140686	308174
18153	24752	18	applied	\N	\N	\N	\N	140687	140687	308175
18153	24754	19	applied	\N	\N	\N	\N	140688	140688	308176
18153	24758	20	applied	\N	\N	\N	\N	140689	140689	308177
18153	24761	22	applied	\N	\N	\N	\N	140691	140691	308179
18153	24764	23	applied	\N	\N	\N	\N	140692	140692	308180
18153	24766	24	applied	\N	\N	\N	\N	140693	140693	308181
18153	24767	25	applied	\N	\N	\N	\N	140694	140694	308182
18153	24768	26	applied	\N	\N	\N	\N	140695	140695	308183
18153	24769	27	applied	\N	\N	\N	\N	140696	140696	308184
18153	24770	28	applied	\N	\N	\N	\N	140697	140697	308185
18153	24777	29	applied	\N	\N	\N	\N	140698	140698	308186
18153	24780	30	applied	\N	\N	\N	\N	140699	140699	308187
18153	24781	31	applied	\N	\N	\N	\N	140700	140700	308188
18153	24784	32	applied	\N	\N	\N	\N	140701	140701	308189
18153	24785	33	applied	\N	\N	\N	\N	140702	140702	308190
18153	24789	34	applied	\N	\N	\N	\N	140703	140703	308191
18153	24790	35	applied	\N	\N	\N	\N	140704	140704	308192
18153	24791	36	applied	\N	\N	\N	\N	140705	140705	308193
18153	24796	37	applied	\N	\N	\N	\N	140706	140706	308194
18153	24800	39	applied	\N	\N	\N	\N	140708	140708	308196
18153	24803	40	applied	\N	\N	\N	\N	140709	140709	308197
18153	24805	41	applied	\N	\N	\N	\N	140710	140710	308198
18153	24806	42	applied	\N	\N	\N	\N	140711	140711	308199
18153	24807	43	applied	\N	\N	\N	\N	140712	140712	308200
18153	24812	44	applied	\N	\N	\N	\N	140713	140713	308201
18153	24814	45	applied	\N	\N	\N	\N	140714	140714	308202
18153	24816	46	applied	\N	\N	\N	\N	140715	140715	308203
18153	24817	47	applied	\N	\N	\N	\N	140716	140716	308204
18153	24821	48	applied	\N	\N	\N	\N	140717	140717	308205
18153	24823	49	applied	\N	\N	\N	\N	140718	140718	308206
18153	24825	50	applied	\N	\N	\N	\N	140719	140719	308207
18153	24829	51	applied	\N	\N	\N	\N	140720	140720	308208
18153	24830	52	applied	\N	\N	\N	\N	140721	140721	308209
18153	24831	53	applied	\N	\N	\N	\N	140722	140722	308210
18153	24832	54	applied	\N	\N	\N	\N	140723	140723	308211
18153	24827	56	applied	\N	\N	\N	\N	140725	140725	308213
18153	24835	57	applied	\N	\N	\N	\N	140726	140726	308214
18153	24836	58	applied	\N	\N	\N	\N	140727	140727	308215
18153	24839	59	applied	\N	\N	\N	\N	140728	140728	308216
18153	24840	60	applied	\N	\N	\N	\N	140729	140729	308217
18153	24719	61	applied	\N	\N	\N	\N	140730	140730	308218
18153	24725	62	applied	\N	\N	\N	\N	140731	140731	308219
18153	24734	64	applied	\N	\N	\N	\N	140732	140732	308220
18153	24721	65	applied	\N	\N	\N	\N	140733	140733	308221
18153	24726	66	applied	\N	\N	\N	\N	140734	140734	308222
18153	24727	67	applied	\N	\N	\N	\N	140735	140735	308223
18153	24728	68	applied	\N	\N	\N	\N	140736	140736	308224
18153	24730	69	applied	\N	\N	\N	\N	140737	140737	308225
18153	24733	70	applied	\N	\N	\N	\N	140738	140738	308226
18153	24736	71	applied	\N	\N	\N	\N	140739	140739	308227
18153	24738	72	applied	\N	\N	\N	\N	140740	140740	308228
18153	24743	74	applied	\N	\N	\N	\N	140742	140742	308230
18153	24745	75	applied	\N	\N	\N	\N	140743	140743	308231
18153	24747	76	applied	\N	\N	\N	\N	140744	140744	308232
18153	24750	77	applied	\N	\N	\N	\N	140745	140745	308233
18153	24741	78	applied	\N	\N	\N	\N	140746	140746	308234
18153	24753	79	applied	\N	\N	\N	\N	140747	140747	308235
18153	24755	80	applied	\N	\N	\N	\N	140748	140748	308236
18153	24762	81	applied	\N	\N	\N	\N	140749	140749	308237
18153	24773	82	applied	\N	\N	\N	\N	140750	140750	308238
18153	24778	83	applied	\N	\N	\N	\N	140751	140751	308239
18153	24786	84	applied	\N	\N	\N	\N	140752	140752	308240
18153	24792	85	applied	\N	\N	\N	\N	140753	140753	308241
18153	24802	86	applied	\N	\N	\N	\N	140754	140754	308242
18153	24809	87	applied	\N	\N	\N	\N	140755	140755	308243
18153	24820	88	applied	\N	\N	\N	\N	140756	140756	308244
18153	24824	89	applied	\N	\N	\N	\N	140757	140757	308245
18153	24751	91	applied	\N	\N	\N	\N	140759	140759	308247
18153	24756	92	applied	\N	\N	\N	\N	140760	140760	308248
18153	24757	93	applied	\N	\N	\N	\N	140761	140761	308249
18153	24759	94	applied	\N	\N	\N	\N	140762	140762	308250
18153	24763	95	applied	\N	\N	\N	\N	140763	140763	308251
18153	24765	96	applied	\N	\N	\N	\N	140764	140764	308252
18153	24771	97	applied	\N	\N	\N	\N	140765	140765	308253
18153	24772	98	applied	\N	\N	\N	\N	140766	140766	308254
18153	24774	99	applied	\N	\N	\N	\N	140767	140767	308255
18153	24775	100	applied	\N	\N	\N	\N	140768	140768	308256
18153	24776	101	applied	\N	\N	\N	\N	140769	140769	308257
18153	24779	102	applied	\N	\N	\N	\N	140770	140770	308258
18153	24782	103	applied	\N	\N	\N	\N	140771	140771	308259
18153	24783	104	applied	\N	\N	\N	\N	140772	140772	308260
18153	24787	105	applied	\N	\N	\N	\N	140773	140773	308261
18153	24788	106	applied	\N	\N	\N	\N	140774	140774	308262
18153	24794	108	applied	\N	\N	\N	\N	140776	140776	308264
18153	24795	109	applied	\N	\N	\N	\N	140777	140777	308265
18153	24798	110	applied	\N	\N	\N	\N	140778	140778	308266
18153	24799	111	applied	\N	\N	\N	\N	140779	140779	308267
18153	24801	112	applied	\N	\N	\N	\N	140780	140780	308268
18153	24804	113	applied	\N	\N	\N	\N	140781	140781	308269
18153	24808	114	applied	\N	\N	\N	\N	140782	140782	308270
18153	24810	115	applied	\N	\N	\N	\N	140783	140783	308271
18153	24811	116	applied	\N	\N	\N	\N	140784	140784	308272
18153	24813	117	applied	\N	\N	\N	\N	140785	140785	308273
18153	24815	118	applied	\N	\N	\N	\N	140786	140786	308274
18153	24818	119	applied	\N	\N	\N	\N	140787	140787	308275
18153	24819	120	applied	\N	\N	\N	\N	140788	140788	308276
18153	24822	121	applied	\N	\N	\N	\N	140789	140789	308277
18153	24720	3	applied	\N	\N	\N	\N	140672	140672	308160
18153	24722	4	applied	\N	\N	\N	\N	140673	140673	308161
18154	24828	0	applied	\N	\N	\N	\N	140794	140794	140794
18154	24829	1	applied	\N	\N	\N	\N	140795	140795	308282
18154	24830	2	applied	\N	\N	\N	\N	140796	140796	308283
18154	24831	3	applied	\N	\N	\N	\N	140797	140797	308284
18154	24832	4	applied	\N	\N	\N	\N	140798	140798	308285
18154	24833	5	applied	\N	\N	1000000000	\N	140799	140799	308286
18154	24834	6	applied	\N	\N	\N	\N	140800	140800	308287
18154	24835	7	applied	\N	\N	\N	\N	140801	140801	308288
18154	24836	8	applied	\N	\N	\N	\N	140802	140802	308289
18154	24837	9	applied	\N	\N	\N	\N	140803	140803	308290
18154	24838	10	applied	\N	\N	\N	\N	140804	140804	308291
18154	24839	11	applied	\N	\N	\N	\N	140805	140805	308292
18154	24840	12	applied	\N	\N	\N	\N	140806	140806	308293
18154	24841	14	applied	\N	\N	\N	\N	140807	140807	308294
18154	24842	15	applied	\N	\N	\N	\N	140808	140808	308295
18155	24844	1	applied	\N	\N	\N	\N	140810	140810	308296
18155	24845	2	applied	\N	\N	\N	\N	140811	140811	308297
18155	24846	3	applied	\N	\N	\N	\N	140812	140812	308298
18155	24847	4	applied	\N	\N	\N	\N	140813	140813	308299
18155	24848	5	applied	\N	\N	\N	\N	140814	140814	308300
18155	24849	6	applied	\N	\N	\N	\N	140815	140815	308301
18155	24850	7	applied	\N	\N	\N	\N	140816	140816	308302
18155	24851	8	applied	\N	\N	\N	\N	140817	140817	308303
18155	24852	9	applied	\N	\N	\N	\N	140818	140818	308304
18155	24853	10	applied	\N	\N	\N	\N	140819	140819	308305
18155	24854	11	applied	\N	\N	\N	\N	140820	140820	308306
18155	24855	12	applied	\N	\N	\N	\N	140821	140821	308307
18155	24856	13	applied	\N	\N	\N	\N	140822	140822	308308
18156	24844	1	applied	\N	\N	\N	\N	140824	140824	308309
18156	24843	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	140823	140823	\N
18156	24845	2	applied	\N	\N	\N	\N	140825	140825	308310
18156	24846	3	applied	\N	\N	\N	\N	140826	140826	308311
18156	24847	4	applied	\N	\N	\N	\N	140827	140827	308312
18156	24848	5	applied	\N	\N	\N	\N	140828	140828	308313
18156	24849	6	applied	\N	\N	\N	\N	140829	140829	308314
18156	24850	7	applied	\N	\N	\N	\N	140830	140830	308315
18156	24851	8	applied	\N	\N	\N	\N	140831	140831	308316
18156	24852	9	applied	\N	\N	\N	\N	140832	140832	308317
18156	24853	10	applied	\N	\N	\N	\N	140833	140833	308318
18156	24855	12	applied	\N	\N	\N	\N	140835	140835	308320
18156	24856	13	applied	\N	\N	\N	\N	140836	140836	308321
18160	24864	0	applied	\N	\N	\N	\N	140858	140858	308343
18160	24865	1	applied	\N	\N	\N	\N	140859	140859	308344
18160	24866	2	applied	\N	\N	\N	\N	140860	140860	308345
18160	24867	3	applied	\N	\N	\N	\N	140861	140861	308346
18160	24868	4	applied	\N	\N	\N	\N	140862	140862	308347
18160	24869	5	applied	\N	\N	\N	\N	140863	140863	308348
18165	24880	0	applied	\N	\N	\N	\N	140882	140882	308363
18165	24881	1	applied	\N	\N	\N	\N	140883	140883	308364
18165	24882	2	applied	\N	\N	\N	\N	140884	140884	308365
18166	24883	0	applied	\N	\N	\N	\N	140885	140885	308366
18166	24884	1	applied	\N	\N	\N	\N	140886	140886	308367
18166	24885	2	applied	\N	\N	\N	\N	140887	140887	308368
18168	24890	0	applied	\N	\N	\N	\N	140892	140892	308373
18168	24891	1	applied	\N	\N	\N	\N	140893	140893	308374
18168	24893	3	applied	\N	\N	\N	\N	140895	140895	308376
18168	24894	4	applied	\N	\N	\N	\N	140896	140896	308377
18168	24895	5	applied	\N	\N	\N	\N	140897	140897	308378
18168	24896	6	applied	\N	\N	\N	\N	140898	140898	308379
18168	24897	7	applied	\N	\N	\N	\N	140899	140899	308380
18168	24898	8	applied	\N	\N	\N	\N	140900	140900	308381
18168	24899	9	applied	\N	\N	\N	\N	140901	140901	308382
18171	24903	0	applied	\N	\N	\N	\N	140908	140908	308389
18171	24904	1	applied	\N	\N	\N	\N	140909	140909	308390
18171	24905	2	applied	\N	\N	\N	\N	140910	140910	308391
18171	24906	3	applied	\N	\N	\N	\N	140911	140911	308392
18171	24907	4	applied	\N	\N	\N	\N	140912	140912	308393
18171	24908	5	applied	\N	\N	\N	\N	140913	140913	308394
18174	24913	0	applied	\N	\N	\N	\N	140924	140924	308405
18174	24914	1	applied	\N	\N	\N	\N	140925	140925	308406
18174	24915	2	applied	\N	\N	\N	\N	140926	140926	308407
18174	24917	4	applied	\N	\N	\N	\N	140928	140928	308409
18179	24929	0	applied	\N	\N	\N	\N	140947	140947	308426
18179	24930	1	applied	\N	\N	\N	\N	140948	140948	308427
18186	24934	0	applied	\N	\N	\N	\N	140963	140963	308442
18186	24935	1	applied	\N	\N	\N	\N	140964	140964	308443
18186	24936	2	applied	\N	\N	\N	\N	140965	140965	308444
18186	24937	3	applied	\N	\N	\N	\N	140966	140966	308445
18186	24938	4	applied	\N	\N	\N	\N	140967	140967	308446
18197	24939	0	applied	\N	\N	\N	\N	141013	141013	308492
18197	24940	1	applied	\N	\N	\N	\N	141014	141014	308493
18199	24939	0	applied	\N	\N	\N	\N	141017	141017	308496
18199	24941	1	applied	\N	\N	\N	\N	141018	141018	308497
18199	24940	2	applied	\N	\N	\N	\N	141019	141019	308498
18199	24942	3	applied	\N	\N	\N	\N	141020	141020	308499
18208	24951	0	applied	\N	\N	\N	\N	141057	141057	308532
18210	24952	0	applied	\N	\N	\N	\N	141061	141061	308536
18210	24951	2	applied	\N	\N	\N	\N	141063	141063	308538
18211	24952	0	applied	\N	\N	\N	\N	141064	141064	308539
18211	24953	1	applied	\N	\N	\N	\N	141065	141065	308540
18211	24954	2	applied	\N	\N	\N	\N	141066	141066	308541
18211	24955	3	applied	\N	\N	\N	\N	141067	141067	308542
18211	24956	4	applied	\N	\N	\N	\N	141068	141068	308543
18211	24957	5	applied	\N	\N	\N	\N	141069	141069	308544
18211	24958	6	applied	\N	\N	\N	\N	141070	141070	308545
18211	24959	7	applied	\N	\N	\N	\N	141071	141071	308546
18211	24960	8	applied	\N	\N	\N	\N	141072	141072	308547
18211	24961	9	applied	\N	\N	\N	\N	141073	141073	141073
18213	24952	0	applied	\N	\N	\N	\N	141077	141077	308550
18213	24953	1	applied	\N	\N	\N	\N	141078	141078	308551
18213	24954	2	applied	\N	\N	\N	\N	141079	141079	308552
18213	24955	3	applied	\N	\N	\N	\N	141080	141080	308553
18213	24956	4	applied	\N	\N	\N	\N	141081	141081	308554
18213	24958	6	applied	\N	\N	\N	\N	141083	141083	308556
18213	24959	7	applied	\N	\N	\N	\N	141084	141084	308557
18213	24960	8	applied	\N	\N	\N	\N	141085	141085	308558
18213	24961	9	applied	\N	\N	\N	\N	141086	141086	141086
18215	24962	0	applied	\N	\N	\N	\N	141091	141091	308562
18215	24963	1	applied	\N	\N	\N	\N	141092	141092	308563
18153	24834	123	applied	\N	\N	\N	\N	140791	140791	308279
18153	24841	125	applied	\N	\N	\N	\N	140793	140793	308281
18157	24861	4	applied	\N	\N	\N	\N	140841	140841	308326
18157	24862	5	applied	\N	\N	\N	\N	140842	140842	308327
18157	24863	6	applied	\N	\N	\N	\N	140843	140843	308328
18159	24857	0	applied	\N	\N	\N	\N	140851	140851	308336
18159	24858	1	applied	\N	\N	\N	\N	140852	140852	308337
18159	24859	2	applied	\N	\N	\N	\N	140853	140853	308338
18159	24860	3	applied	\N	\N	\N	\N	140854	140854	308339
18159	24861	4	applied	\N	\N	\N	\N	140855	140855	308340
18159	24862	5	applied	\N	\N	\N	\N	140856	140856	308341
18159	24863	6	applied	\N	\N	\N	\N	140857	140857	308342
18162	24870	0	applied	\N	\N	\N	\N	140868	140868	308353
18162	24871	1	applied	\N	\N	\N	\N	140869	140869	308354
18162	24872	2	applied	\N	\N	\N	\N	140870	140870	308355
18162	24873	3	applied	\N	\N	\N	\N	140871	140871	308356
18164	24874	0	applied	\N	\N	\N	\N	140876	140876	308361
18164	24879	5	applied	\N	\N	\N	\N	140881	140881	308362
18164	24876	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	140878	140878	\N
18164	24877	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	140879	140879	\N
18164	24878	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	140880	140880	\N
18167	24887	0	applied	\N	\N	\N	\N	140889	140889	308370
18167	24888	1	applied	\N	\N	\N	\N	140890	140890	308371
18167	24889	2	applied	\N	\N	\N	\N	140891	140891	308372
18170	24900	0	applied	\N	\N	\N	\N	140905	140905	308386
18170	24901	1	applied	\N	\N	\N	\N	140906	140906	308387
18170	24902	2	applied	\N	\N	\N	\N	140907	140907	308388
18173	24909	0	applied	\N	\N	\N	\N	140920	140920	308401
18173	24910	1	applied	\N	\N	\N	\N	140921	140921	308402
18173	24911	2	applied	\N	\N	\N	\N	140922	140922	308403
18173	24912	3	applied	\N	\N	\N	\N	140923	140923	308404
18181	24931	0	applied	\N	\N	\N	\N	140952	140952	308431
18181	24932	1	applied	\N	\N	\N	\N	140953	140953	308432
18181	24933	2	applied	\N	\N	\N	\N	140954	140954	308433
18195	24934	0	applied	\N	\N	\N	\N	141003	141003	308482
18195	24935	1	applied	\N	\N	\N	\N	141004	141004	308483
18195	24936	2	applied	\N	\N	\N	\N	141005	141005	308484
18195	24937	3	applied	\N	\N	\N	\N	141006	141006	308485
18195	24938	4	applied	\N	\N	\N	\N	141007	141007	308486
18201	24943	0	applied	\N	\N	\N	\N	141025	141025	308504
18201	24944	1	applied	\N	\N	\N	\N	141026	141026	308505
18203	24945	0	applied	\N	\N	\N	\N	141033	141033	308512
18203	24947	2	applied	\N	\N	\N	\N	141035	141035	141035
18203	24948	3	applied	\N	\N	\N	\N	141036	141036	308514
18203	24949	4	applied	\N	\N	\N	\N	141037	141037	308515
18203	24950	5	applied	\N	\N	\N	\N	141038	141038	308516
18215	24964	2	applied	\N	\N	\N	\N	141093	141093	141093
18215	24965	3	applied	\N	\N	\N	\N	141094	141094	308564
18223	24760	0	applied	\N	\N	\N	\N	141127	141127	308583
18223	24828	1	applied	\N	\N	\N	\N	141128	141128	141128
18223	24833	2	applied	\N	\N	1000000000	\N	141129	141129	308584
18223	24761	3	applied	\N	\N	\N	\N	141130	141130	308585
18223	24764	4	applied	\N	\N	\N	\N	141131	141131	308586
18223	24766	5	applied	\N	\N	\N	\N	141132	141132	308587
18223	24767	6	applied	\N	\N	\N	\N	141133	141133	308588
18223	24768	7	applied	\N	\N	\N	\N	141134	141134	308589
18223	24769	8	applied	\N	\N	\N	\N	141135	141135	308590
18223	24770	9	applied	\N	\N	\N	\N	141136	141136	308591
18223	24780	11	applied	\N	\N	\N	\N	141138	141138	308593
18223	24781	12	applied	\N	\N	\N	\N	141139	141139	308594
18223	24784	13	applied	\N	\N	\N	\N	141140	141140	308595
18223	24785	14	applied	\N	\N	\N	\N	141141	141141	308596
18223	24789	15	applied	\N	\N	\N	\N	141142	141142	308597
18223	24790	16	applied	\N	\N	\N	\N	141143	141143	308598
18223	24791	17	applied	\N	\N	\N	\N	141144	141144	308599
18223	24796	18	applied	\N	\N	\N	\N	141145	141145	308600
18223	24797	19	applied	\N	\N	\N	\N	141146	141146	308601
18223	24800	20	applied	\N	\N	\N	\N	141147	141147	308602
18223	24803	21	applied	\N	\N	\N	\N	141148	141148	308603
18223	24805	22	applied	\N	\N	\N	\N	141149	141149	308604
18223	24806	23	applied	\N	\N	\N	\N	141150	141150	308605
18223	24807	24	applied	\N	\N	\N	\N	141151	141151	308606
18223	24812	25	applied	\N	\N	\N	\N	141152	141152	308607
18223	24814	26	applied	\N	\N	\N	\N	141153	141153	308608
18223	24817	28	applied	\N	\N	\N	\N	141155	141155	308610
18223	24821	29	applied	\N	\N	\N	\N	141156	141156	308611
18223	24823	30	applied	\N	\N	\N	\N	141157	141157	308612
18223	24825	31	applied	\N	\N	\N	\N	141158	141158	308613
18223	24829	32	applied	\N	\N	\N	\N	141159	141159	308614
18223	24830	33	applied	\N	\N	\N	\N	141160	141160	308615
18223	24831	34	applied	\N	\N	\N	\N	141161	141161	308616
18223	24832	35	applied	\N	\N	\N	\N	141162	141162	308617
18223	24844	36	applied	\N	\N	\N	\N	141163	141163	308618
18223	24845	37	applied	\N	\N	\N	\N	141164	141164	308619
18223	24846	38	applied	\N	\N	\N	\N	141165	141165	308620
18223	24847	39	applied	\N	\N	\N	\N	141166	141166	308621
18223	24857	40	applied	\N	\N	\N	\N	141167	141167	308622
18223	24858	41	applied	\N	\N	\N	\N	141168	141168	308623
18223	24864	42	applied	\N	\N	\N	\N	141169	141169	308624
18223	24865	43	applied	\N	\N	\N	\N	141170	141170	308625
18223	24874	45	applied	\N	\N	\N	\N	141172	141172	308627
18223	24880	46	applied	\N	\N	\N	\N	141173	141173	308628
18224	24973	0	applied	\N	\N	\N	\N	141187	141187	308642
18224	24974	1	applied	\N	\N	\N	\N	141188	141188	308643
18224	24975	2	applied	\N	\N	\N	\N	141189	141189	308644
18224	24976	3	applied	\N	\N	\N	\N	141190	141190	308645
18224	24977	4	applied	\N	\N	\N	\N	141191	141191	308646
18229	24985	0	applied	\N	\N	\N	\N	141327	141327	308775
18229	24986	1	applied	\N	\N	\N	\N	141328	141328	308776
18229	24987	2	applied	\N	\N	\N	\N	141329	141329	308777
18238	24996	0	applied	\N	\N	\N	\N	141427	141427	308865
18238	24997	1	applied	\N	\N	\N	\N	141428	141428	308866
18240	24996	0	applied	\N	\N	\N	\N	141431	141431	308869
18240	24997	1	applied	\N	\N	\N	\N	141432	141432	308870
18245	25003	0	applied	\N	\N	\N	\N	141450	141450	308888
18245	25004	1	applied	\N	\N	\N	\N	141451	141451	308889
18248	25015	1	applied	\N	\N	\N	\N	141462	141462	308900
18248	25016	2	applied	\N	\N	\N	\N	141463	141463	308901
18251	25017	0	applied	\N	\N	\N	\N	141493	141493	308931
18251	25018	1	applied	\N	\N	\N	\N	141494	141494	308932
18157	24858	1	applied	\N	\N	\N	\N	140838	140838	308323
18157	24859	2	applied	\N	\N	\N	\N	140839	140839	308324
18158	24861	4	applied	\N	\N	\N	\N	140848	140848	308333
18158	24862	5	applied	\N	\N	\N	\N	140849	140849	308334
18158	24863	6	applied	\N	\N	\N	\N	140850	140850	308335
18161	24870	0	applied	\N	\N	\N	\N	140864	140864	308349
18161	24871	1	applied	\N	\N	\N	\N	140865	140865	308350
18161	24872	2	applied	\N	\N	\N	\N	140866	140866	308351
18161	24873	3	applied	\N	\N	\N	\N	140867	140867	308352
18163	24870	0	applied	\N	\N	\N	\N	140872	140872	308357
18163	24871	1	applied	\N	\N	\N	\N	140873	140873	308358
18163	24872	2	applied	\N	\N	\N	\N	140874	140874	308359
18163	24873	3	applied	\N	\N	\N	\N	140875	140875	308360
18169	24900	0	applied	\N	\N	\N	\N	140902	140902	308383
18169	24902	2	applied	\N	\N	\N	\N	140904	140904	308385
18178	24929	0	applied	\N	\N	\N	\N	140945	140945	308424
18178	24930	1	applied	\N	\N	\N	\N	140946	140946	308425
18180	24931	0	applied	\N	\N	\N	\N	140949	140949	308428
18180	24932	1	applied	\N	\N	\N	\N	140950	140950	308429
18180	24933	2	applied	\N	\N	\N	\N	140951	140951	308430
18182	24931	0	applied	\N	\N	\N	\N	140955	140955	308434
18182	24932	1	applied	\N	\N	\N	\N	140956	140956	308435
18182	24933	2	applied	\N	\N	\N	\N	140957	140957	308436
18187	24934	0	applied	\N	\N	\N	\N	140968	140968	308447
18187	24935	1	applied	\N	\N	\N	\N	140969	140969	308448
18187	24936	2	applied	\N	\N	\N	\N	140970	140970	308449
18187	24937	3	applied	\N	\N	\N	\N	140971	140971	308450
18187	24938	4	applied	\N	\N	\N	\N	140972	140972	308451
18189	24934	0	applied	\N	\N	\N	\N	140978	140978	308457
18189	24935	1	applied	\N	\N	\N	\N	140979	140979	308458
18189	24937	3	applied	\N	\N	\N	\N	140981	140981	308460
18189	24938	4	applied	\N	\N	\N	\N	140982	140982	308461
18192	24934	0	applied	\N	\N	\N	\N	140988	140988	308467
18192	24935	1	applied	\N	\N	\N	\N	140989	140989	308468
18192	24936	2	applied	\N	\N	\N	\N	140990	140990	308469
18192	24937	3	applied	\N	\N	\N	\N	140991	140991	308470
18192	24938	4	applied	\N	\N	\N	\N	140992	140992	308471
18193	24934	0	applied	\N	\N	\N	\N	140993	140993	308472
18193	24935	1	applied	\N	\N	\N	\N	140994	140994	308473
18193	24936	2	applied	\N	\N	\N	\N	140995	140995	308474
18193	24937	3	applied	\N	\N	\N	\N	140996	140996	308475
18193	24938	4	applied	\N	\N	\N	\N	140997	140997	308476
18196	24934	0	applied	\N	\N	\N	\N	141008	141008	308487
18196	24935	1	applied	\N	\N	\N	\N	141009	141009	308488
18196	24936	2	applied	\N	\N	\N	\N	141010	141010	308489
18196	24937	3	applied	\N	\N	\N	\N	141011	141011	308490
18198	24939	0	applied	\N	\N	\N	\N	141015	141015	308494
18198	24940	1	applied	\N	\N	\N	\N	141016	141016	308495
18202	24939	0	applied	\N	\N	\N	\N	141027	141027	308506
18202	24941	1	applied	\N	\N	\N	\N	141028	141028	308507
18202	24943	2	applied	\N	\N	\N	\N	141029	141029	308508
18202	24940	3	applied	\N	\N	\N	\N	141030	141030	308509
18202	24942	4	applied	\N	\N	\N	\N	141031	141031	308510
18202	24944	5	applied	\N	\N	\N	\N	141032	141032	308511
18204	24945	0	applied	\N	\N	\N	\N	141039	141039	308517
18204	24946	1	applied	\N	\N	\N	\N	141040	141040	308518
18204	24947	2	applied	\N	\N	\N	\N	141041	141041	141041
18204	24948	3	applied	\N	\N	\N	\N	141042	141042	308519
18204	24949	4	applied	\N	\N	\N	\N	141043	141043	308520
18204	24950	5	applied	\N	\N	\N	\N	141044	141044	308521
18206	24945	0	applied	\N	\N	\N	\N	141051	141051	308527
18206	24946	1	applied	\N	\N	\N	\N	141052	141052	308528
18206	24948	3	applied	\N	\N	\N	\N	141054	141054	308529
18206	24949	4	applied	\N	\N	\N	\N	141055	141055	308530
18206	24950	5	applied	\N	\N	\N	\N	141056	141056	308531
18216	24962	0	applied	\N	\N	\N	\N	141095	141095	308565
18216	24963	1	applied	\N	\N	\N	\N	141096	141096	308566
18216	24964	2	applied	\N	\N	\N	\N	141097	141097	141097
18216	24965	3	applied	\N	\N	\N	\N	141098	141098	308567
18218	24966	0	applied	\N	\N	\N	\N	141099	141099	308568
18218	24967	1	applied	\N	\N	\N	\N	141100	141100	308569
18218	24968	2	applied	\N	\N	\N	\N	141101	141101	141101
18218	24969	3	applied	\N	\N	\N	\N	141102	141102	141102
18218	24970	4	applied	\N	\N	\N	\N	141103	141103	141103
18220	24971	0	applied	\N	\N	\N	\N	141109	141109	308572
18220	24972	1	applied	\N	\N	\N	\N	141110	141110	308573
18222	24675	1	applied	\N	\N	\N	\N	141114	141114	308577
18222	24691	2	applied	\N	\N	\N	\N	141115	141115	308578
18222	24686	3	applied	\N	\N	\N	\N	141116	141116	308579
18222	24828	4	applied	\N	\N	\N	\N	141117	141117	141117
18222	24833	5	applied	\N	\N	1000000000	\N	141118	141118	308580
18222	24946	6	applied	\N	\N	\N	\N	141119	141119	308581
18222	24947	7	applied	\N	\N	\N	\N	141120	141120	141120
18222	24948	8	applied	\N	\N	\N	\N	141121	141121	308582
18222	24961	9	applied	\N	\N	\N	\N	141122	141122	141122
18222	24964	10	applied	\N	\N	\N	\N	141123	141123	141123
18222	24968	11	applied	\N	\N	\N	\N	141124	141124	141124
18222	24969	12	applied	\N	\N	\N	\N	141125	141125	141125
18222	24970	13	applied	\N	\N	\N	\N	141126	141126	141126
18223	24883	47	applied	\N	\N	\N	\N	141174	141174	308629
18223	24887	48	applied	\N	\N	\N	\N	141175	141175	308630
18223	24890	49	applied	\N	\N	\N	\N	141176	141176	308631
18223	24891	50	applied	\N	\N	\N	\N	141177	141177	308632
18223	24892	51	applied	\N	\N	\N	\N	141178	141178	308633
18223	24900	52	applied	\N	\N	\N	\N	141179	141179	308634
18223	24903	53	applied	\N	\N	\N	\N	141180	141180	308635
18223	24909	55	applied	\N	\N	\N	\N	141182	141182	308637
18223	24910	56	applied	\N	\N	\N	\N	141183	141183	308638
18223	24913	57	applied	\N	\N	\N	\N	141184	141184	308639
18223	24914	58	applied	\N	\N	\N	\N	141185	141185	308640
18223	24920	59	applied	\N	\N	\N	\N	141186	141186	308641
18225	24978	0	applied	\N	\N	\N	\N	141192	141192	308647
18225	24979	1	applied	\N	\N	\N	\N	141193	141193	308648
18226	24978	0	applied	\N	\N	\N	\N	141195	141195	308650
18226	24979	1	applied	\N	\N	\N	\N	141196	141196	308651
18226	24980	2	applied	\N	\N	\N	\N	141197	141197	308652
18228	24981	0	applied	\N	\N	\N	\N	141323	141323	308771
18228	24982	1	applied	\N	\N	\N	\N	141324	141324	308772
18228	24983	2	applied	\N	\N	\N	\N	141325	141325	308773
18228	24984	3	applied	\N	\N	\N	\N	141326	141326	308774
18231	24990	0	applied	\N	\N	\N	\N	141332	141332	308780
18158	24858	1	applied	\N	\N	\N	\N	140845	140845	308330
18158	24860	3	applied	\N	\N	\N	\N	140847	140847	308332
18172	24906	3	applied	\N	\N	\N	\N	140917	140917	308398
18172	24907	4	applied	\N	\N	\N	\N	140918	140918	308399
18172	24908	5	applied	\N	\N	\N	\N	140919	140919	308400
18175	24913	0	applied	\N	\N	\N	\N	140929	140929	308410
18175	24914	1	applied	\N	\N	\N	\N	140930	140930	308411
18175	24915	2	applied	\N	\N	\N	\N	140931	140931	308412
18175	24916	3	applied	\N	\N	\N	\N	140932	140932	308413
18175	24917	4	applied	\N	\N	\N	\N	140933	140933	308414
18176	24918	0	applied	\N	\N	\N	\N	140934	140934	140934
18176	24919	1	applied	\N	\N	\N	\N	140935	140935	140935
18176	24920	2	applied	\N	\N	\N	\N	140936	140936	308415
18176	24921	3	applied	\N	\N	\N	\N	140937	140937	308416
18176	24922	4	applied	\N	\N	\N	\N	140938	140938	308417
18176	24923	5	applied	\N	\N	\N	\N	140939	140939	308418
18176	24925	7	applied	\N	\N	\N	\N	140941	140941	308420
18176	24926	8	applied	\N	\N	\N	\N	140942	140942	308421
18176	24927	9	applied	\N	\N	\N	\N	140943	140943	308422
18176	24928	10	applied	\N	\N	\N	\N	140944	140944	308423
18185	24934	0	applied	\N	\N	\N	\N	140958	140958	308437
18185	24935	1	applied	\N	\N	\N	\N	140959	140959	308438
18185	24936	2	applied	\N	\N	\N	\N	140960	140960	308439
18185	24937	3	applied	\N	\N	\N	\N	140961	140961	308440
18185	24938	4	applied	\N	\N	\N	\N	140962	140962	308441
18188	24934	0	applied	\N	\N	\N	\N	140973	140973	308452
18188	24935	1	applied	\N	\N	\N	\N	140974	140974	308453
18188	24936	2	applied	\N	\N	\N	\N	140975	140975	308454
18188	24937	3	applied	\N	\N	\N	\N	140976	140976	308455
18188	24938	4	applied	\N	\N	\N	\N	140977	140977	308456
18190	24934	0	applied	\N	\N	\N	\N	140983	140983	308462
18190	24935	1	applied	\N	\N	\N	\N	140984	140984	308463
18190	24937	3	applied	\N	\N	\N	\N	140986	140986	308465
18190	24938	4	applied	\N	\N	\N	\N	140987	140987	308466
18194	24934	0	applied	\N	\N	\N	\N	140998	140998	308477
18194	24935	1	applied	\N	\N	\N	\N	140999	140999	308478
18194	24936	2	applied	\N	\N	\N	\N	141000	141000	308479
18194	24937	3	applied	\N	\N	\N	\N	141001	141001	308480
18194	24938	4	applied	\N	\N	\N	\N	141002	141002	308481
18200	24939	0	applied	\N	\N	\N	\N	141021	141021	308500
18200	24941	1	applied	\N	\N	\N	\N	141022	141022	308501
18200	24940	2	applied	\N	\N	\N	\N	141023	141023	308502
18200	24942	3	applied	\N	\N	\N	\N	141024	141024	308503
18205	24945	0	applied	\N	\N	\N	\N	141045	141045	308522
18205	24946	1	applied	\N	\N	\N	\N	141046	141046	308523
18205	24947	2	applied	\N	\N	\N	\N	141047	141047	141047
18205	24948	3	applied	\N	\N	\N	\N	141048	141048	308524
18205	24949	4	applied	\N	\N	\N	\N	141049	141049	308525
18209	24952	0	applied	\N	\N	\N	\N	141058	141058	308533
18209	24953	1	applied	\N	\N	\N	\N	141059	141059	308534
18209	24951	2	applied	\N	\N	\N	\N	141060	141060	308535
18212	24952	0	applied	\N	\N	\N	\N	141074	141074	308548
18212	24953	1	applied	\N	\N	\N	\N	141075	141075	308549
18212	24961	2	applied	\N	\N	\N	\N	141076	141076	141076
18214	24962	0	applied	\N	\N	\N	\N	141087	141087	308559
18214	24963	1	applied	\N	\N	\N	\N	141088	141088	308560
18214	24964	2	applied	\N	\N	\N	\N	141089	141089	141089
18214	24965	3	applied	\N	\N	\N	\N	141090	141090	308561
18219	24966	0	applied	\N	\N	\N	\N	141104	141104	308570
18219	24967	1	applied	\N	\N	\N	\N	141105	141105	308571
18219	24968	2	applied	\N	\N	\N	\N	141106	141106	141106
18219	24969	3	applied	\N	\N	\N	\N	141107	141107	141107
18219	24970	4	applied	\N	\N	\N	\N	141108	141108	141108
18221	24971	0	applied	\N	\N	\N	\N	141111	141111	308574
18225	24980	2	applied	\N	\N	\N	\N	141194	141194	308649
18227	24828	0	applied	\N	\N	\N	\N	141198	141198	141198
18227	24829	1	applied	\N	\N	\N	\N	141199	141199	308653
18227	24830	2	applied	\N	\N	\N	\N	141200	141200	308654
18227	24831	3	applied	\N	\N	\N	\N	141201	141201	308655
18227	24832	4	applied	\N	\N	\N	\N	141202	141202	308656
18227	24833	5	applied	\N	\N	1000000000	\N	141203	141203	308657
18227	24844	6	applied	\N	\N	\N	\N	141204	141204	308658
18227	24845	7	applied	\N	\N	\N	\N	141205	141205	308659
18227	24846	8	applied	\N	\N	\N	\N	141206	141206	308660
18227	24847	9	applied	\N	\N	\N	\N	141207	141207	308661
18227	24857	10	applied	\N	\N	\N	\N	141208	141208	308662
18227	24858	11	applied	\N	\N	\N	\N	141209	141209	308663
18227	24864	12	applied	\N	\N	\N	\N	141210	141210	308664
18227	24865	14	applied	\N	\N	\N	\N	141211	141211	308665
18227	24870	15	applied	\N	\N	\N	\N	141212	141212	308666
18227	24880	17	applied	\N	\N	\N	\N	141214	141214	308668
18227	24883	18	applied	\N	\N	\N	\N	141215	141215	308669
18227	24887	19	applied	\N	\N	\N	\N	141216	141216	308670
18227	24890	20	applied	\N	\N	\N	\N	141217	141217	308671
18230	24988	0	applied	\N	\N	\N	\N	141330	141330	308778
18230	24989	1	applied	\N	\N	\N	\N	141331	141331	308779
18235	24994	0	applied	\N	\N	\N	\N	141422	141422	308860
18237	24995	0	applied	\N	\N	\N	\N	141425	141425	308863
18237	24994	1	applied	\N	\N	\N	\N	141426	141426	308864
18239	24996	0	applied	\N	\N	\N	\N	141429	141429	308867
18239	24997	1	applied	\N	\N	\N	\N	141430	141430	308868
18244	25003	0	applied	\N	\N	\N	\N	141448	141448	308886
18244	25004	1	applied	\N	\N	\N	\N	141449	141449	308887
18246	25005	0	applied	\N	\N	\N	\N	141452	141452	308890
18246	25006	1	applied	\N	\N	\N	\N	141453	141453	308891
18247	25007	0	applied	\N	\N	\N	\N	141454	141454	308892
18247	25009	2	applied	\N	\N	\N	\N	141456	141456	308894
18247	25010	3	applied	\N	\N	\N	\N	141457	141457	308895
18247	25011	4	applied	\N	\N	\N	\N	141458	141458	308896
18247	25012	5	applied	\N	\N	\N	\N	141459	141459	308897
18247	25013	6	applied	\N	\N	\N	\N	141460	141460	308898
18250	24992	0	applied	\N	\N	\N	\N	141466	141466	308904
18250	24995	1	applied	\N	\N	\N	\N	141467	141467	308905
18250	24996	2	applied	\N	\N	\N	\N	141468	141468	308906
18250	24998	3	applied	\N	\N	\N	\N	141469	141469	308907
18250	24999	4	applied	\N	\N	\N	\N	141470	141470	308908
18250	25003	5	applied	\N	\N	\N	\N	141471	141471	308909
18250	25005	6	applied	\N	\N	\N	\N	141472	141472	308910
18250	25007	7	applied	\N	\N	\N	\N	141473	141473	308911
18250	25008	8	applied	\N	\N	\N	\N	141474	141474	308912
18250	25009	9	applied	\N	\N	\N	\N	141475	141475	308913
18250	25014	10	applied	\N	\N	\N	\N	141476	141476	308914
18172	24905	2	applied	\N	\N	\N	\N	140916	140916	308397
18227	24904	25	applied	\N	\N	\N	\N	141222	141222	308676
18227	24909	26	applied	\N	\N	\N	\N	141223	141223	308677
18227	24910	27	applied	\N	\N	\N	\N	141224	141224	308678
18227	24913	28	applied	\N	\N	\N	\N	141225	141225	308679
18227	24914	29	applied	\N	\N	\N	\N	141226	141226	308680
18227	24920	30	applied	\N	\N	\N	\N	141227	141227	308681
18227	24921	31	applied	\N	\N	\N	\N	141228	141228	308682
18227	24922	32	applied	\N	\N	\N	\N	141229	141229	308683
18227	24923	33	applied	\N	\N	\N	\N	141230	141230	308684
18227	24929	34	applied	\N	\N	\N	\N	141231	141231	308685
18227	24931	35	applied	\N	\N	\N	\N	141232	141232	308686
18227	24934	36	applied	\N	\N	\N	\N	141233	141233	308687
18227	24935	37	applied	\N	\N	\N	\N	141234	141234	308688
18227	24939	38	applied	\N	\N	\N	\N	141235	141235	308689
18227	24941	39	applied	\N	\N	\N	\N	141236	141236	308690
18227	24943	40	applied	\N	\N	\N	\N	141237	141237	308691
18227	24952	42	applied	\N	\N	\N	\N	141239	141239	308693
18227	24953	43	applied	\N	\N	\N	\N	141240	141240	308694
18227	24954	44	applied	\N	\N	\N	\N	141241	141241	308695
18227	24955	45	applied	\N	\N	\N	\N	141242	141242	308696
18227	24956	46	applied	\N	\N	\N	\N	141243	141243	308697
18227	24962	47	applied	\N	\N	\N	\N	141244	141244	308698
18227	24966	48	applied	\N	\N	\N	\N	141245	141245	308699
18227	24971	49	applied	\N	\N	\N	\N	141246	141246	308700
18227	24973	50	applied	\N	\N	\N	\N	141247	141247	308701
18227	24974	51	applied	\N	\N	\N	\N	141248	141248	308702
18227	24978	52	applied	\N	\N	\N	\N	141249	141249	308703
18227	24946	53	applied	\N	\N	\N	\N	141250	141250	308704
18227	24947	54	applied	\N	\N	\N	\N	141251	141251	141251
18227	24948	55	applied	\N	\N	\N	\N	141252	141252	308705
18227	24834	56	applied	\N	\N	\N	\N	141253	141253	308706
18227	24835	57	applied	\N	\N	\N	\N	141254	141254	308707
18227	24837	59	applied	\N	\N	\N	\N	141256	141256	308709
18227	24848	60	applied	\N	\N	\N	\N	141257	141257	308710
18227	24838	61	applied	\N	\N	\N	\N	141258	141258	308711
18227	24839	62	applied	\N	\N	\N	\N	141259	141259	308712
18227	24840	63	applied	\N	\N	\N	\N	141260	141260	308713
18227	24853	64	applied	\N	\N	\N	\N	141261	141261	308714
18227	24854	65	applied	\N	\N	\N	\N	141262	141262	308715
18227	24841	66	applied	\N	\N	\N	\N	141263	141263	308716
18227	24842	67	applied	\N	\N	\N	\N	141264	141264	308717
18227	24849	68	applied	\N	\N	\N	\N	141265	141265	308718
18227	24850	69	applied	\N	\N	\N	\N	141266	141266	308719
18227	24851	70	applied	\N	\N	\N	\N	141267	141267	308720
18227	24852	71	applied	\N	\N	\N	\N	141268	141268	308721
18227	24859	72	applied	\N	\N	\N	\N	141269	141269	308722
18227	24860	73	applied	\N	\N	\N	\N	141270	141270	308723
18227	24868	74	applied	\N	\N	\N	\N	141271	141271	308724
18227	24872	76	applied	\N	\N	\N	\N	141273	141273	308726
18227	24881	77	applied	\N	\N	\N	\N	141274	141274	308727
18227	24885	78	applied	\N	\N	\N	\N	141275	141275	308728
18227	24855	79	applied	\N	\N	\N	\N	141276	141276	308729
18227	24856	80	applied	\N	\N	\N	\N	141277	141277	308730
18227	24861	81	applied	\N	\N	\N	\N	141278	141278	308731
18227	24862	82	applied	\N	\N	\N	\N	141279	141279	308732
18227	24866	83	applied	\N	\N	\N	\N	141280	141280	308733
18227	24867	84	applied	\N	\N	\N	\N	141281	141281	308734
18227	24871	85	applied	\N	\N	\N	\N	141282	141282	308735
18227	24879	86	applied	\N	\N	\N	\N	141283	141283	308736
18227	24882	87	applied	\N	\N	\N	\N	141284	141284	308737
18227	24863	88	applied	\N	\N	\N	\N	141285	141285	308738
18227	24873	89	applied	\N	\N	\N	\N	141286	141286	308739
18227	24884	90	applied	\N	\N	\N	\N	141287	141287	308740
18227	24893	91	applied	\N	\N	\N	\N	141288	141288	308741
18227	24915	93	applied	\N	\N	\N	\N	141290	141290	308743
18227	24924	94	applied	\N	\N	\N	\N	141291	141291	308744
18227	24932	95	applied	\N	\N	\N	\N	141292	141292	308745
18227	24937	96	applied	\N	\N	\N	\N	141293	141293	308746
18227	24950	97	applied	\N	\N	\N	\N	141294	141294	308747
18227	24957	98	applied	\N	\N	\N	\N	141295	141295	308748
18227	24963	99	applied	\N	\N	\N	\N	141296	141296	308749
18227	24975	100	applied	\N	\N	\N	\N	141297	141297	308750
18227	24886	101	applied	\N	\N	\N	\N	141298	141298	308751
18227	24888	102	applied	\N	\N	\N	\N	141299	141299	308752
18227	24895	103	applied	\N	\N	\N	\N	141300	141300	308753
18227	24896	104	applied	\N	\N	\N	\N	141301	141301	308754
18227	24897	105	applied	\N	\N	\N	\N	141302	141302	308755
18227	24902	106	applied	\N	\N	\N	\N	141303	141303	308756
18227	24905	107	applied	\N	\N	\N	\N	141304	141304	308757
18227	24889	108	applied	\N	\N	\N	\N	141305	141305	308758
18227	24898	110	applied	\N	\N	\N	\N	141307	141307	308760
18227	24899	111	applied	\N	\N	\N	\N	141308	141308	308761
18227	24901	112	applied	\N	\N	\N	\N	141309	141309	308762
18227	24907	113	applied	\N	\N	\N	\N	141310	141310	308763
18227	24908	114	applied	\N	\N	\N	\N	141311	141311	308764
18227	24911	115	applied	\N	\N	\N	\N	141312	141312	308765
18227	24912	116	applied	\N	\N	\N	\N	141313	141313	308766
18227	24961	117	applied	\N	\N	\N	\N	141314	141314	141314
18227	24964	118	applied	\N	\N	\N	\N	141315	141315	141315
18227	24968	119	applied	\N	\N	\N	\N	141316	141316	141316
18250	25017	11	applied	\N	\N	\N	\N	141477	141477	308915
18250	24994	12	applied	\N	\N	\N	\N	141478	141478	308916
18250	24993	13	applied	\N	\N	\N	\N	141479	141479	308917
18250	25000	14	applied	\N	\N	\N	\N	141480	141480	308918
18250	25010	15	applied	\N	\N	\N	\N	141481	141481	308919
18250	25015	16	applied	\N	\N	\N	\N	141482	141482	308920
18250	25001	18	applied	\N	\N	\N	\N	141484	141484	308922
18250	25002	19	applied	\N	\N	\N	\N	141485	141485	308923
18250	25004	20	applied	\N	\N	\N	\N	141486	141486	308924
18250	25006	21	applied	\N	\N	\N	\N	141487	141487	308925
18250	25011	22	applied	\N	\N	\N	\N	141488	141488	308926
18250	25012	23	applied	\N	\N	\N	\N	141489	141489	308927
18250	25013	24	applied	\N	\N	\N	\N	141490	141490	308928
18250	25016	25	applied	\N	\N	\N	\N	141491	141491	308929
18250	25018	26	applied	\N	\N	\N	\N	141492	141492	308930
18256	25019	0	applied	\N	\N	\N	\N	141503	141503	308941
18256	25021	1	applied	\N	\N	\N	\N	141504	141504	308942
18256	25020	2	applied	\N	\N	\N	\N	141505	141505	308943
18256	25022	3	applied	\N	\N	\N	\N	141506	141506	308944
18260	25024	0	applied	\N	\N	\N	\N	141514	141514	308952
18227	24892	22	applied	\N	\N	\N	\N	141219	141219	308673
18227	24900	23	applied	\N	\N	\N	\N	141220	141220	308674
18227	24916	123	applied	\N	\N	\N	\N	141320	141320	308768
18227	24917	124	applied	\N	\N	\N	\N	141321	141321	308769
18231	24991	1	applied	\N	\N	\N	\N	141333	141333	308781
18232	24990	0	applied	\N	\N	\N	\N	141334	141334	308782
18232	24991	1	applied	\N	\N	\N	\N	141335	141335	308783
18233	24864	0	applied	\N	\N	\N	\N	141336	141336	308784
18233	24865	5	applied	\N	\N	\N	\N	141341	141341	308785
18233	24876	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	141338	141338	\N
18233	24877	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	141339	141339	\N
18233	24878	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	141340	141340	\N
18233	24870	6	applied	\N	\N	\N	\N	141342	141342	308786
18233	24874	7	applied	\N	\N	\N	\N	141343	141343	308787
18233	24880	8	applied	\N	\N	\N	\N	141344	141344	308788
18233	24883	9	applied	\N	\N	\N	\N	141345	141345	308789
18233	24887	10	applied	\N	\N	\N	\N	141346	141346	308790
18233	24890	11	applied	\N	\N	\N	\N	141347	141347	308791
18233	24891	12	applied	\N	\N	\N	\N	141348	141348	308792
18233	24900	14	applied	\N	\N	\N	\N	141350	141350	308794
18233	24903	15	applied	\N	\N	\N	\N	141351	141351	308795
18233	24904	16	applied	\N	\N	\N	\N	141352	141352	308796
18233	24909	17	applied	\N	\N	\N	\N	141353	141353	308797
18233	24910	18	applied	\N	\N	\N	\N	141354	141354	308798
18233	24913	19	applied	\N	\N	\N	\N	141355	141355	308799
18233	24914	20	applied	\N	\N	\N	\N	141356	141356	308800
18233	24920	21	applied	\N	\N	\N	\N	141357	141357	308801
18233	24921	22	applied	\N	\N	\N	\N	141358	141358	308802
18233	24922	23	applied	\N	\N	\N	\N	141359	141359	308803
18233	24923	24	applied	\N	\N	\N	\N	141360	141360	308804
18233	24929	25	applied	\N	\N	\N	\N	141361	141361	308805
18233	24931	26	applied	\N	\N	\N	\N	141362	141362	308806
18233	24934	27	applied	\N	\N	\N	\N	141363	141363	308807
18233	24935	28	applied	\N	\N	\N	\N	141364	141364	308808
18233	24939	29	applied	\N	\N	\N	\N	141365	141365	308809
18233	24943	31	applied	\N	\N	\N	\N	141367	141367	308811
18233	24945	32	applied	\N	\N	\N	\N	141368	141368	308812
18233	24952	33	applied	\N	\N	\N	\N	141369	141369	308813
18233	24953	34	applied	\N	\N	\N	\N	141370	141370	308814
18233	24954	35	applied	\N	\N	\N	\N	141371	141371	308815
18233	24955	36	applied	\N	\N	\N	\N	141372	141372	308816
18233	24956	37	applied	\N	\N	\N	\N	141373	141373	308817
18233	24962	38	applied	\N	\N	\N	\N	141374	141374	308818
18233	24966	39	applied	\N	\N	\N	\N	141375	141375	308819
18233	24971	40	applied	\N	\N	\N	\N	141376	141376	308820
18233	24973	41	applied	\N	\N	\N	\N	141377	141377	308821
18233	24974	42	applied	\N	\N	\N	\N	141378	141378	308822
18233	24978	43	applied	\N	\N	\N	\N	141379	141379	308823
18233	24981	44	applied	\N	\N	\N	\N	141380	141380	308824
18233	24985	45	applied	\N	\N	\N	\N	141381	141381	308825
18233	24988	46	applied	\N	\N	\N	\N	141382	141382	308826
18233	24946	48	applied	\N	\N	\N	\N	141384	141384	308828
18233	24947	49	applied	\N	\N	\N	\N	141385	141385	141385
18233	24948	50	applied	\N	\N	\N	\N	141386	141386	308829
18233	24866	51	applied	\N	\N	\N	\N	141387	141387	308830
18233	24867	52	applied	\N	\N	\N	\N	141388	141388	308831
18233	24871	53	applied	\N	\N	\N	\N	141389	141389	308832
18233	24879	54	applied	\N	\N	\N	\N	141390	141390	308833
18233	24882	55	applied	\N	\N	\N	\N	141391	141391	308834
18233	24873	56	applied	\N	\N	\N	\N	141392	141392	308835
18233	24884	57	applied	\N	\N	\N	\N	141393	141393	308836
18233	24893	58	applied	\N	\N	\N	\N	141394	141394	308837
18233	24906	59	applied	\N	\N	\N	\N	141395	141395	308838
18233	24915	60	applied	\N	\N	\N	\N	141396	141396	308839
18233	24924	61	applied	\N	\N	\N	\N	141397	141397	308840
18233	24932	62	applied	\N	\N	\N	\N	141398	141398	308841
18233	24937	63	applied	\N	\N	\N	\N	141399	141399	308842
18233	24957	65	applied	\N	\N	\N	\N	141401	141401	308844
18233	24963	66	applied	\N	\N	\N	\N	141402	141402	308845
18233	24975	67	applied	\N	\N	\N	\N	141403	141403	308846
18233	24886	68	applied	\N	\N	\N	\N	141404	141404	308847
18233	24888	69	applied	\N	\N	\N	\N	141405	141405	308848
18233	24895	70	applied	\N	\N	\N	\N	141406	141406	308849
18233	24896	71	applied	\N	\N	\N	\N	141407	141407	308850
18233	24897	72	applied	\N	\N	\N	\N	141408	141408	308851
18233	24902	73	applied	\N	\N	\N	\N	141409	141409	308852
18233	24905	74	applied	\N	\N	\N	\N	141410	141410	308853
18233	24987	75	applied	\N	\N	\N	\N	141411	141411	308854
18233	24961	76	applied	\N	\N	\N	\N	141412	141412	141412
18233	24964	77	applied	\N	\N	\N	\N	141413	141413	141413
18233	24968	78	applied	\N	\N	\N	\N	141414	141414	141414
18233	24969	79	applied	\N	\N	\N	\N	141415	141415	141415
18233	24970	80	applied	\N	\N	\N	\N	141416	141416	141416
18233	24982	82	applied	\N	\N	\N	\N	141418	141418	308856
18233	24983	83	applied	\N	\N	\N	\N	141419	141419	308857
18234	24992	0	applied	\N	\N	\N	\N	141420	141420	308858
18234	24993	1	applied	\N	\N	\N	\N	141421	141421	308859
18236	24995	0	applied	\N	\N	\N	\N	141423	141423	308861
18236	24994	1	applied	\N	\N	\N	\N	141424	141424	308862
18241	24998	0	applied	\N	\N	\N	\N	141433	141433	308871
18241	24999	1	applied	\N	\N	\N	\N	141434	141434	308872
18241	25000	2	applied	\N	\N	\N	\N	141435	141435	308873
18241	25001	3	applied	\N	\N	\N	\N	141436	141436	308874
18241	25002	4	applied	\N	\N	\N	\N	141437	141437	308875
18242	24998	0	applied	\N	\N	\N	\N	141438	141438	308876
18242	24999	1	applied	\N	\N	\N	\N	141439	141439	308877
18242	25000	2	applied	\N	\N	\N	\N	141440	141440	308878
18242	25001	3	applied	\N	\N	\N	\N	141441	141441	308879
18242	25002	4	applied	\N	\N	\N	\N	141442	141442	308880
18243	24999	1	applied	\N	\N	\N	\N	141444	141444	308882
18243	25000	2	applied	\N	\N	\N	\N	141445	141445	308883
18243	25001	3	applied	\N	\N	\N	\N	141446	141446	308884
18243	25002	4	applied	\N	\N	\N	\N	141447	141447	308885
18249	25017	0	applied	\N	\N	\N	\N	141464	141464	308902
18252	25017	0	applied	\N	\N	\N	\N	141495	141495	308933
18252	25018	1	applied	\N	\N	\N	\N	141496	141496	308934
18254	25019	0	applied	\N	\N	\N	\N	141499	141499	308937
18254	25020	1	applied	\N	\N	\N	\N	141500	141500	308938
18259	25024	0	applied	\N	\N	\N	\N	141511	141511	308949
18227	24970	121	applied	\N	\N	\N	\N	141318	141318	141318
18227	24980	122	applied	\N	\N	\N	\N	141319	141319	308767
18258	25023	1	applied	\N	\N	\N	\N	141509	141509	308947
18258	25025	2	applied	\N	\N	\N	\N	141510	141510	308948
18259	25023	1	applied	\N	\N	\N	\N	141512	141512	308950
18259	25025	2	applied	\N	\N	\N	\N	141513	141513	308951
18261	25026	0	applied	\N	\N	\N	\N	141517	141517	308955
18261	25027	1	applied	\N	\N	\N	\N	141518	141518	308956
18262	25028	0	applied	\N	\N	\N	\N	141519	141519	308957
18262	25029	1	applied	\N	\N	\N	\N	141520	141520	308958
18264	25035	0	applied	\N	\N	\N	\N	141526	141526	308964
18264	25036	1	applied	\N	\N	\N	\N	141527	141527	308965
18265	25035	0	applied	\N	\N	\N	\N	141528	141528	308966
18265	25036	1	applied	\N	\N	\N	\N	141529	141529	308967
18266	25037	0	applied	\N	\N	\N	\N	141530	141530	308968
18266	25038	1	applied	\N	\N	\N	\N	141531	141531	308969
18266	25039	2	applied	\N	\N	\N	\N	141532	141532	308970
18270	25043	0	applied	\N	\N	\N	\N	141538	141538	308976
18272	25050	0	applied	\N	\N	\N	\N	141545	141545	308983
18272	25051	1	applied	\N	\N	\N	\N	141546	141546	308984
18272	25052	2	applied	\N	\N	\N	\N	141547	141547	308985
18272	25053	3	applied	\N	\N	\N	\N	141548	141548	308986
18272	25054	4	applied	\N	\N	\N	\N	141549	141549	308987
18274	25050	0	applied	\N	\N	\N	\N	141555	141555	308993
18274	25051	1	applied	\N	\N	\N	\N	141556	141556	308994
18274	25052	2	applied	\N	\N	\N	\N	141557	141557	308995
18274	25053	3	applied	\N	\N	\N	\N	141558	141558	308996
18274	25054	4	applied	\N	\N	\N	\N	141559	141559	308997
18278	25062	0	applied	\N	\N	\N	\N	141569	141569	309007
18278	25063	1	applied	\N	\N	\N	\N	141570	141570	309008
18280	25064	0	applied	\N	\N	\N	\N	141573	141573	309011
18280	25065	1	applied	\N	\N	\N	\N	141574	141574	309012
18281	25066	0	applied	\N	\N	\N	\N	141575	141575	309013
18281	25067	1	applied	\N	\N	\N	\N	141576	141576	309014
18282	25069	1	applied	\N	\N	\N	\N	141578	141578	309016
18282	25070	2	applied	\N	\N	\N	\N	141579	141579	309017
18282	25071	3	applied	\N	\N	\N	\N	141580	141580	309018
18282	25072	4	applied	\N	\N	\N	\N	141581	141581	309019
18286	25075	0	applied	\N	\N	\N	\N	141666	141666	309104
18286	25076	1	applied	\N	\N	\N	\N	141667	141667	309105
18286	25077	2	applied	\N	\N	\N	\N	141668	141668	309106
18289	25085	0	applied	\N	\N	\N	\N	141680	141680	309118
18289	25086	1	applied	\N	\N	\N	\N	141681	141681	309119
18289	25087	2	applied	\N	\N	\N	\N	141682	141682	309120
18289	25088	3	applied	\N	\N	\N	\N	141683	141683	309121
18289	25089	4	applied	\N	\N	\N	\N	141684	141684	309122
18289	25090	5	applied	\N	\N	\N	\N	141685	141685	309123
18291	25091	0	applied	\N	\N	\N	\N	141689	141689	309127
18291	25092	1	applied	\N	\N	\N	\N	141690	141690	309128
18291	25093	2	applied	\N	\N	\N	\N	141691	141691	309129
18298	25098	1	applied	\N	\N	\N	\N	141709	141709	309147
18299	25097	0	applied	\N	\N	\N	\N	141710	141710	309148
18299	25098	1	applied	\N	\N	\N	\N	141711	141711	309149
18301	25099	0	applied	\N	\N	\N	\N	141713	141713	309151
18301	25100	1	applied	\N	\N	\N	\N	141714	141714	309152
18301	25101	2	applied	\N	\N	\N	\N	141715	141715	309153
18303	25099	0	applied	\N	\N	\N	\N	141719	141719	309157
18303	25100	1	applied	\N	\N	\N	\N	141720	141720	309158
18303	25101	2	applied	\N	\N	\N	\N	141721	141721	309159
18309	25107	0	applied	\N	\N	\N	\N	141750	141750	309188
18309	25108	1	applied	\N	\N	\N	\N	141751	141751	309189
18309	25109	2	applied	\N	\N	\N	\N	141752	141752	309190
18309	25110	3	applied	\N	\N	\N	\N	141753	141753	309191
18309	25111	4	applied	\N	\N	\N	\N	141754	141754	309192
18309	25112	5	applied	\N	\N	\N	\N	141755	141755	309193
18309	25113	6	applied	\N	\N	\N	\N	141756	141756	309194
18309	25115	8	applied	\N	\N	\N	\N	141758	141758	309196
18309	25116	9	applied	\N	\N	\N	\N	141759	141759	309197
18309	25117	10	applied	\N	\N	\N	\N	141760	141760	309198
18309	25118	11	applied	\N	\N	\N	\N	141761	141761	309199
18309	25119	12	applied	\N	\N	\N	\N	141762	141762	309200
18309	25120	13	applied	\N	\N	\N	\N	141763	141763	309201
18309	25121	14	applied	\N	\N	\N	\N	141764	141764	309202
18309	25122	15	applied	\N	\N	\N	\N	141765	141765	309203
18309	25123	16	applied	\N	\N	\N	\N	141766	141766	309204
18309	25124	17	applied	\N	\N	\N	\N	141767	141767	309205
18309	25125	18	applied	\N	\N	\N	\N	141768	141768	309206
18311	25126	0	applied	\N	\N	\N	\N	141788	141788	309226
18311	25127	1	applied	\N	\N	\N	\N	141789	141789	309227
18314	25128	0	applied	\N	\N	\N	\N	141796	141796	309234
18314	25129	1	applied	\N	\N	\N	\N	141797	141797	309235
18314	25130	2	applied	\N	\N	\N	\N	141798	141798	309236
18319	25141	1	applied	\N	\N	\N	\N	141870	141870	309308
18326	25150	0	applied	\N	\N	\N	\N	141883	141883	309321
18326	25148	1	applied	\N	\N	\N	\N	141884	141884	309322
18326	25149	2	applied	\N	\N	\N	\N	141885	141885	309323
18327	25150	0	applied	\N	\N	\N	\N	141886	141886	309324
18327	25148	1	applied	\N	\N	\N	\N	141887	141887	309325
18327	25149	2	applied	\N	\N	\N	\N	141888	141888	309326
18334	25167	0	applied	\N	\N	\N	\N	141916	141916	309354
18334	25168	1	applied	\N	\N	\N	\N	141917	141917	309355
18337	25170	0	applied	\N	\N	\N	\N	141924	141924	309362
18337	25171	1	applied	\N	\N	\N	\N	141925	141925	309363
18337	25172	2	applied	\N	\N	\N	\N	141926	141926	309364
18337	25173	3	applied	\N	\N	\N	\N	141927	141927	309365
18337	25174	4	applied	\N	\N	\N	\N	141928	141928	309366
18342	25177	0	applied	\N	\N	\N	\N	141931	141931	309369
18342	25178	1	applied	\N	\N	\N	\N	141932	141932	309370
18342	25180	3	applied	\N	\N	\N	\N	141934	141934	309372
18342	25181	4	applied	\N	\N	\N	\N	141935	141935	309373
18342	25182	5	applied	\N	\N	\N	\N	141936	141936	141936
18342	25183	6	applied	\N	\N	\N	\N	141937	141937	141937
18342	25184	7	applied	\N	\N	\N	\N	141938	141938	309374
18342	25185	8	applied	\N	\N	\N	\N	141939	141939	309375
18344	25186	0	applied	\N	\N	\N	\N	141942	141942	309378
18344	25187	1	applied	\N	\N	\N	\N	141943	141943	309379
18352	25209	0	applied	\N	\N	\N	\N	141983	141983	309409
18352	25210	1	applied	\N	\N	\N	\N	141984	141984	309410
18352	25211	2	applied	\N	\N	\N	\N	141985	141985	309411
18352	25212	3	applied	\N	\N	\N	\N	141986	141986	309412
18352	25213	4	applied	\N	\N	\N	\N	141987	141987	309413
18355	25218	0	applied	\N	\N	\N	\N	141992	141992	309418
18253	25017	0	applied	\N	\N	\N	\N	141497	141497	308935
18253	25018	1	applied	\N	\N	\N	\N	141498	141498	308936
18267	25041	1	applied	\N	\N	\N	\N	141534	141534	308972
18269	25042	0	applied	\N	\N	\N	\N	141537	141537	308975
18273	25050	0	applied	\N	\N	\N	\N	141550	141550	308988
18273	25051	1	applied	\N	\N	\N	\N	141551	141551	308989
18273	25052	2	applied	\N	\N	\N	\N	141552	141552	308990
18273	25053	3	applied	\N	\N	\N	\N	141553	141553	308991
18273	25054	4	applied	\N	\N	\N	\N	141554	141554	308992
18275	25055	0	applied	\N	\N	\N	\N	141560	141560	308998
18275	25056	1	applied	\N	\N	\N	\N	141561	141561	308999
18275	25057	2	applied	\N	\N	\N	\N	141562	141562	309000
18275	25058	3	applied	\N	\N	\N	\N	141563	141563	309001
18279	25062	0	applied	\N	\N	\N	\N	141571	141571	309009
18279	25063	1	applied	\N	\N	\N	\N	141572	141572	309010
18285	25075	0	applied	\N	\N	\N	\N	141663	141663	309101
18285	25077	2	applied	\N	\N	\N	\N	141665	141665	309103
18287	25075	0	applied	\N	\N	\N	\N	141669	141669	309107
18287	25078	1	applied	\N	\N	\N	\N	141670	141670	309108
18287	25076	2	applied	\N	\N	\N	\N	141671	141671	309109
18287	25077	3	applied	\N	\N	\N	\N	141672	141672	309110
18292	25091	0	applied	\N	\N	\N	\N	141692	141692	309130
18292	25092	1	applied	\N	\N	\N	\N	141693	141693	309131
18292	25093	2	applied	\N	\N	\N	\N	141694	141694	309132
18297	25097	0	applied	\N	\N	\N	\N	141706	141706	309144
18297	25098	1	applied	\N	\N	\N	\N	141707	141707	309145
18305	25102	0	applied	\N	\N	\N	\N	141724	141724	309162
18305	25103	1	applied	\N	\N	\N	\N	141725	141725	309163
18307	25104	0	applied	\N	\N	\N	\N	141728	141728	309166
18307	25105	1	applied	\N	\N	\N	\N	141729	141729	309167
18307	25106	2	applied	\N	\N	\N	\N	141730	141730	309168
18318	25140	0	applied	\N	\N	\N	\N	141867	141867	309305
18322	25142	0	applied	\N	\N	\N	\N	141875	141875	309313
18322	25143	1	applied	\N	\N	\N	\N	141876	141876	309314
18328	25150	0	applied	\N	\N	\N	\N	141889	141889	309327
18328	25151	1	applied	\N	\N	\N	\N	141890	141890	309328
18328	25152	2	applied	\N	\N	\N	\N	141891	141891	309329
18328	25153	3	applied	\N	\N	\N	\N	141892	141892	309330
18328	25154	4	applied	\N	\N	\N	\N	141893	141893	309331
18332	25160	0	applied	\N	\N	\N	\N	141909	141909	309347
18332	25161	1	applied	\N	\N	\N	\N	141910	141910	309348
18335	25169	0	applied	\N	\N	\N	\N	141918	141918	309356
18345	25188	0	applied	\N	\N	\N	\N	141944	141944	309380
18345	25189	1	applied	\N	\N	\N	\N	141945	141945	309381
18345	25190	2	applied	\N	\N	\N	\N	141946	141946	309382
18345	25191	3	applied	\N	\N	\N	\N	141947	141947	141947
18345	25192	4	applied	\N	\N	\N	\N	141948	141948	141948
18350	25200	0	applied	\N	\N	\N	\N	141974	141974	309404
18350	25202	2	applied	\N	\N	\N	\N	141976	141976	141976
18350	25203	3	applied	\N	\N	\N	\N	141977	141977	141977
18350	25204	4	applied	\N	\N	\N	\N	141978	141978	141978
18350	25205	5	applied	\N	\N	\N	\N	141979	141979	141979
18350	25206	6	applied	\N	\N	\N	\N	141980	141980	309406
18353	25214	0	applied	\N	\N	\N	\N	141988	141988	309414
18353	25215	1	applied	\N	\N	\N	\N	141989	141989	309415
18355	25219	1	applied	\N	\N	\N	\N	141993	141993	309419
18355	25220	2	applied	\N	\N	\N	\N	141994	141994	309420
18358	25225	0	applied	\N	\N	\N	\N	142002	142002	309428
18358	25226	1	applied	\N	\N	\N	\N	142003	142003	309429
18360	25227	0	applied	\N	\N	\N	\N	142006	142006	309432
18360	25228	1	applied	\N	\N	\N	\N	142007	142007	309433
18362	25227	0	applied	\N	\N	\N	\N	142010	142010	309436
18362	25228	1	applied	\N	\N	\N	\N	142011	142011	309437
18364	25229	0	applied	\N	\N	\N	\N	142014	142014	309440
18365	25231	0	applied	\N	\N	\N	\N	142016	142016	309442
18365	25232	1	applied	\N	\N	\N	\N	142017	142017	309443
18365	25233	2	applied	\N	\N	\N	\N	142018	142018	309444
18365	25234	3	applied	\N	\N	\N	\N	142019	142019	309445
18365	25235	4	applied	\N	\N	\N	\N	142020	142020	309446
18367	25107	0	applied	\N	\N	\N	\N	142023	142023	309449
18367	25108	1	applied	\N	\N	\N	\N	142024	142024	309450
18367	25109	2	applied	\N	\N	\N	\N	142025	142025	309451
18367	25110	3	applied	\N	\N	\N	\N	142026	142026	309452
18367	25131	4	applied	\N	\N	\N	\N	142027	142027	309453
18367	25132	5	applied	\N	\N	\N	\N	142028	142028	309454
18367	25133	6	applied	\N	\N	\N	\N	142029	142029	309455
18367	25134	7	applied	\N	\N	\N	\N	142030	142030	309456
18367	24828	8	applied	\N	\N	\N	\N	142031	142031	142031
18367	24789	10	applied	\N	\N	\N	\N	142033	142033	309458
18367	24790	11	applied	\N	\N	\N	\N	142034	142034	309459
18367	24791	12	applied	\N	\N	\N	\N	142035	142035	309460
18367	24796	13	applied	\N	\N	\N	\N	142036	142036	309461
18367	24797	14	applied	\N	\N	\N	\N	142037	142037	309462
18367	24800	15	applied	\N	\N	\N	\N	142038	142038	309463
18367	24803	16	applied	\N	\N	\N	\N	142039	142039	309464
18367	24805	17	applied	\N	\N	\N	\N	142040	142040	309465
18367	25079	18	applied	\N	\N	\N	\N	142041	142041	309466
18367	25080	19	applied	\N	\N	\N	\N	142042	142042	309467
18367	25086	20	applied	\N	\N	\N	\N	142043	142043	309468
18367	24806	21	applied	\N	\N	\N	\N	142044	142044	309469
18367	25087	22	applied	\N	\N	\N	\N	142045	142045	309470
18367	24807	23	applied	\N	\N	\N	\N	142046	142046	309471
18367	24812	24	applied	\N	\N	\N	\N	142047	142047	309472
18367	24814	25	applied	\N	\N	\N	\N	142048	142048	309473
18367	24816	26	applied	\N	\N	\N	\N	142049	142049	309474
18367	24817	27	applied	\N	\N	\N	\N	142050	142050	309475
18367	24821	28	applied	\N	\N	\N	\N	142051	142051	309476
18367	24823	29	applied	\N	\N	\N	\N	142052	142052	309477
18367	24829	31	applied	\N	\N	\N	\N	142054	142054	309479
18369	25238	0	applied	\N	\N	\N	\N	142152	142152	309577
18369	25239	1	applied	\N	\N	\N	\N	142153	142153	309578
18369	25240	2	applied	\N	\N	\N	\N	142154	142154	309579
18369	25241	3	applied	\N	\N	\N	\N	142155	142155	309580
18369	25242	4	applied	\N	\N	\N	\N	142156	142156	309581
18374	25247	0	applied	\N	\N	\N	\N	142288	142288	309708
18374	25248	1	applied	\N	\N	\N	\N	142289	142289	309709
18382	25256	0	applied	\N	\N	\N	\N	142422	142422	309838
18382	25257	2	applied	\N	\N	\N	\N	142423	142423	309839
18382	25258	3	applied	\N	\N	\N	\N	142424	142424	309840
18382	25259	4	applied	\N	\N	\N	\N	142425	142425	309841
18382	25260	5	applied	\N	\N	\N	\N	142426	142426	309842
18392	25275	0	applied	\N	\N	\N	\N	142451	142451	309867
18257	25023	0	applied	\N	\N	\N	\N	141507	141507	308945
18267	25040	0	applied	\N	\N	\N	\N	141533	141533	308971
18263	25032	2	applied	\N	\N	\N	\N	141523	141523	308961
18263	25033	3	applied	\N	\N	\N	\N	141524	141524	308962
18263	25034	4	applied	\N	\N	\N	\N	141525	141525	308963
18268	25040	0	applied	\N	\N	\N	\N	141535	141535	308973
18268	25041	1	applied	\N	\N	\N	\N	141536	141536	308974
18271	25045	0	applied	\N	\N	\N	\N	141540	141540	308978
18271	25046	1	applied	\N	\N	\N	\N	141541	141541	308979
18271	25047	2	applied	\N	\N	\N	\N	141542	141542	308980
18271	25048	3	applied	\N	\N	\N	\N	141543	141543	308981
18271	25049	4	applied	\N	\N	\N	\N	141544	141544	308982
18276	25059	0	applied	\N	\N	\N	\N	141564	141564	309002
18276	25060	1	applied	\N	\N	\N	\N	141565	141565	309003
18276	25061	2	applied	\N	\N	\N	\N	141566	141566	309004
18277	25062	0	applied	\N	\N	\N	\N	141567	141567	309005
18277	25063	1	applied	\N	\N	\N	\N	141568	141568	309006
18283	25073	0	applied	\N	\N	\N	\N	141582	141582	309020
18288	25079	0	applied	\N	\N	\N	\N	141673	141673	309111
18288	25080	1	applied	\N	\N	\N	\N	141674	141674	309112
18288	25078	2	applied	\N	\N	\N	\N	141675	141675	309113
18288	25081	3	applied	\N	\N	\N	\N	141676	141676	309114
18288	25082	4	applied	\N	\N	\N	\N	141677	141677	309115
18288	25083	5	applied	\N	\N	\N	\N	141678	141678	309116
18288	25084	6	applied	\N	\N	\N	\N	141679	141679	309117
18293	25094	0	applied	\N	\N	\N	\N	141695	141695	309133
18293	25095	1	applied	\N	\N	\N	\N	141696	141696	309134
18293	25096	2	applied	\N	\N	\N	\N	141697	141697	309135
18295	25094	0	applied	\N	\N	\N	\N	141701	141701	309139
18295	25095	1	applied	\N	\N	\N	\N	141702	141702	309140
18295	25096	2	applied	\N	\N	\N	\N	141703	141703	309141
18304	25102	0	applied	\N	\N	\N	\N	141722	141722	309160
18304	25103	1	applied	\N	\N	\N	\N	141723	141723	309161
18306	25102	0	applied	\N	\N	\N	\N	141726	141726	309164
18312	25128	0	applied	\N	\N	\N	\N	141790	141790	309228
18312	25129	1	applied	\N	\N	\N	\N	141791	141791	309229
18312	25130	2	applied	\N	\N	\N	\N	141792	141792	309230
18316	25128	0	applied	\N	\N	\N	\N	141855	141855	309293
18316	25129	1	applied	\N	\N	\N	\N	141856	141856	309294
18316	25130	2	applied	\N	\N	\N	\N	141857	141857	309295
18320	25140	0	applied	\N	\N	\N	\N	141871	141871	309309
18320	25141	1	applied	\N	\N	\N	\N	141872	141872	309310
18324	25146	0	applied	\N	\N	\N	\N	141879	141879	309317
18324	25147	1	applied	\N	\N	\N	\N	141880	141880	309318
18329	25150	0	applied	\N	\N	\N	\N	141894	141894	309332
18329	25151	1	applied	\N	\N	\N	\N	141895	141895	309333
18329	25152	2	applied	\N	\N	\N	\N	141896	141896	309334
18329	25153	3	applied	\N	\N	\N	\N	141897	141897	309335
18329	25154	4	applied	\N	\N	\N	\N	141898	141898	309336
18331	25155	0	applied	\N	\N	\N	\N	141904	141904	309342
18331	25157	2	applied	\N	\N	\N	\N	141906	141906	309344
18331	25158	3	applied	\N	\N	\N	\N	141907	141907	309345
18331	25159	4	applied	\N	\N	\N	\N	141908	141908	309346
18347	25193	0	applied	\N	\N	\N	\N	141956	141956	309389
18347	25194	1	applied	\N	\N	\N	\N	141957	141957	309390
18347	25195	2	applied	\N	\N	\N	\N	141958	141958	309391
18347	25197	3	applied	\N	\N	\N	\N	141959	141959	141959
18349	25193	0	applied	\N	\N	\N	\N	141967	141967	309398
18349	25194	1	applied	\N	\N	\N	\N	141968	141968	309399
18349	25195	2	applied	\N	\N	\N	\N	141969	141969	309400
18349	25196	3	applied	\N	\N	\N	\N	141970	141970	309401
18349	25197	4	applied	\N	\N	\N	\N	141971	141971	141971
18349	25198	5	applied	\N	\N	\N	\N	141972	141972	309402
18349	25199	6	applied	\N	\N	\N	\N	141973	141973	309403
18351	25207	0	applied	\N	\N	\N	\N	141981	141981	309407
18351	25208	1	applied	\N	\N	\N	\N	141982	141982	309408
18354	25217	1	applied	\N	\N	\N	\N	141991	141991	309417
18357	25221	0	applied	\N	\N	\N	\N	141998	141998	309424
18357	25222	1	applied	\N	\N	\N	\N	141999	141999	309425
18357	25223	2	applied	\N	\N	\N	\N	142000	142000	309426
18357	25224	3	applied	\N	\N	\N	\N	142001	142001	309427
18367	24830	32	applied	\N	\N	\N	\N	142055	142055	309480
18367	24831	33	applied	\N	\N	\N	\N	142056	142056	309481
18367	24832	34	applied	\N	\N	\N	\N	142057	142057	309482
18367	24844	35	applied	\N	\N	\N	\N	142058	142058	309483
18367	24845	36	applied	\N	\N	\N	\N	142059	142059	309484
18367	24846	37	applied	\N	\N	\N	\N	142060	142060	309485
18367	24847	38	applied	\N	\N	\N	\N	142061	142061	309486
18367	24857	39	applied	\N	\N	\N	\N	142062	142062	309487
18367	24858	40	applied	\N	\N	\N	\N	142063	142063	309488
18367	24864	41	applied	\N	\N	\N	\N	142064	142064	309489
18367	24865	42	applied	\N	\N	\N	\N	142065	142065	309490
18367	24874	45	applied	\N	\N	\N	\N	142067	142067	309492
18367	24880	46	applied	\N	\N	\N	\N	142068	142068	309493
18367	24883	47	applied	\N	\N	\N	\N	142069	142069	309494
18367	24887	48	applied	\N	\N	\N	\N	142070	142070	309495
18367	24890	49	applied	\N	\N	\N	\N	142071	142071	309496
18367	24891	50	applied	\N	\N	\N	\N	142072	142072	309497
18367	24892	51	applied	\N	\N	\N	\N	142073	142073	309498
18367	24900	52	applied	\N	\N	\N	\N	142074	142074	309499
18367	24903	53	applied	\N	\N	\N	\N	142075	142075	309500
18368	25238	0	applied	\N	\N	\N	\N	142147	142147	309572
18368	25239	1	applied	\N	\N	\N	\N	142148	142148	309573
18368	25240	2	applied	\N	\N	\N	\N	142149	142149	309574
18368	25241	3	applied	\N	\N	\N	\N	142150	142150	309575
18368	25242	4	applied	\N	\N	\N	\N	142151	142151	309576
18371	25243	0	applied	\N	\N	\N	\N	142282	142282	309702
18371	25244	1	applied	\N	\N	\N	\N	142283	142283	309703
18376	25250	1	applied	\N	\N	\N	\N	142294	142294	309714
18376	25251	2	applied	\N	\N	\N	\N	142295	142295	309715
18387	25272	0	applied	\N	\N	\N	\N	142438	142438	309854
18387	25273	1	applied	\N	\N	\N	\N	142439	142439	309855
18387	25274	2	applied	\N	\N	\N	\N	142440	142440	309856
18394	25277	0	applied	\N	\N	\N	\N	142455	142455	309871
18394	25278	1	applied	\N	\N	\N	\N	142456	142456	309872
18396	25282	0	applied	\N	\N	\N	\N	142460	142460	309876
18396	25283	1	applied	\N	\N	\N	\N	142461	142461	309877
18399	25289	0	applied	\N	\N	\N	\N	142467	142467	309883
18399	25290	1	applied	\N	\N	\N	\N	142468	142468	309884
18399	25291	2	applied	\N	\N	\N	\N	142469	142469	309885
18399	25292	3	applied	\N	\N	\N	\N	142470	142470	309886
18401	25293	0	applied	\N	\N	\N	\N	142475	142475	309891
18260	25025	2	applied	\N	\N	\N	\N	141516	141516	308954
18263	25030	0	applied	\N	\N	\N	\N	141521	141521	308959
18284	25005	4	applied	\N	\N	\N	\N	141588	141588	309026
18284	25007	5	applied	\N	\N	\N	\N	141589	141589	309027
18284	25008	6	applied	\N	\N	\N	\N	141590	141590	309028
18284	25009	7	applied	\N	\N	\N	\N	141591	141591	309029
18284	25014	8	applied	\N	\N	\N	\N	141592	141592	309030
18284	25017	9	applied	\N	\N	\N	\N	141593	141593	309031
18284	25019	10	applied	\N	\N	\N	\N	141594	141594	309032
18284	25021	11	applied	\N	\N	\N	\N	141595	141595	309033
18284	25024	12	applied	\N	\N	\N	\N	141596	141596	309034
18284	25026	13	applied	\N	\N	\N	\N	141597	141597	309035
18284	25028	14	applied	\N	\N	\N	\N	141598	141598	309036
18284	25030	15	applied	\N	\N	\N	\N	141599	141599	309037
18284	25031	16	applied	\N	\N	\N	\N	141600	141600	309038
18284	25035	17	applied	\N	\N	\N	\N	141601	141601	309039
18284	25037	18	applied	\N	\N	\N	\N	141602	141602	309040
18284	25040	19	applied	\N	\N	\N	\N	141603	141603	309041
18284	25043	21	applied	\N	\N	\N	\N	141605	141605	309043
18284	25045	22	applied	\N	\N	\N	\N	141606	141606	309044
18284	25046	23	applied	\N	\N	\N	\N	141607	141607	309045
18284	25050	24	applied	\N	\N	\N	\N	141608	141608	309046
18284	25051	25	applied	\N	\N	\N	\N	141609	141609	309047
18284	25055	26	applied	\N	\N	\N	\N	141610	141610	309048
18284	25056	27	applied	\N	\N	\N	\N	141611	141611	309049
18284	25059	28	applied	\N	\N	\N	\N	141612	141612	309050
18284	25062	29	applied	\N	\N	\N	\N	141613	141613	309051
18284	25064	30	applied	\N	\N	\N	\N	141614	141614	309052
18284	25066	32	applied	\N	\N	\N	\N	141615	141615	309053
18284	25068	33	applied	\N	\N	\N	\N	141616	141616	309054
18284	25069	34	applied	\N	\N	\N	\N	141617	141617	309055
18284	25073	35	applied	\N	\N	\N	\N	141618	141618	309056
18284	25000	36	applied	\N	\N	\N	\N	141619	141619	309057
18284	25010	37	applied	\N	\N	\N	\N	141620	141620	309058
18284	25023	39	applied	\N	\N	\N	\N	141622	141622	309060
18284	25032	40	applied	\N	\N	\N	\N	141623	141623	309061
18284	25039	41	applied	\N	\N	\N	\N	141624	141624	309062
18284	25047	42	applied	\N	\N	\N	\N	141625	141625	309063
18284	25054	43	applied	\N	\N	\N	\N	141626	141626	309064
18284	25061	44	applied	\N	\N	\N	\N	141627	141627	309065
18284	25070	45	applied	\N	\N	\N	\N	141628	141628	309066
18284	24997	46	applied	\N	\N	\N	\N	141629	141629	309067
18284	25001	47	applied	\N	\N	\N	\N	141630	141630	309068
18284	25002	48	applied	\N	\N	\N	\N	141631	141631	309069
18284	25004	49	applied	\N	\N	\N	\N	141632	141632	309070
18284	25006	50	applied	\N	\N	\N	\N	141633	141633	309071
18284	25011	51	applied	\N	\N	\N	\N	141634	141634	309072
18284	25012	52	applied	\N	\N	\N	\N	141635	141635	309073
18284	25013	53	applied	\N	\N	\N	\N	141636	141636	309074
18284	25016	54	applied	\N	\N	\N	\N	141637	141637	309075
18284	25020	56	applied	\N	\N	\N	\N	141639	141639	309077
18284	25022	57	applied	\N	\N	\N	\N	141640	141640	309078
18284	25025	58	applied	\N	\N	\N	\N	141641	141641	309079
18284	25027	59	applied	\N	\N	\N	\N	141642	141642	309080
18284	25029	60	applied	\N	\N	\N	\N	141643	141643	309081
18284	25033	61	applied	\N	\N	\N	\N	141644	141644	309082
18284	25034	62	applied	\N	\N	\N	\N	141645	141645	309083
18284	25036	63	applied	\N	\N	\N	\N	141646	141646	309084
18284	25038	64	applied	\N	\N	\N	\N	141647	141647	309085
18284	25041	65	applied	\N	\N	\N	\N	141648	141648	309086
18284	25044	66	applied	\N	\N	\N	\N	141649	141649	309087
18284	25048	67	applied	\N	\N	\N	\N	141650	141650	309088
18284	25049	68	applied	\N	\N	\N	\N	141651	141651	309089
18284	25052	69	applied	\N	\N	\N	\N	141652	141652	309090
18284	25053	70	applied	\N	\N	\N	\N	141653	141653	309091
18284	25057	71	applied	\N	\N	\N	\N	141654	141654	309092
18284	25060	73	applied	\N	\N	\N	\N	141656	141656	309094
18284	25063	74	applied	\N	\N	\N	\N	141657	141657	309095
18284	25065	75	applied	\N	\N	\N	\N	141658	141658	309096
18284	25067	76	applied	\N	\N	\N	\N	141659	141659	309097
18284	25071	77	applied	\N	\N	\N	\N	141660	141660	309098
18284	25072	78	applied	\N	\N	\N	\N	141661	141661	309099
18284	25074	79	applied	\N	\N	\N	\N	141662	141662	309100
18290	25091	0	applied	\N	\N	\N	\N	141686	141686	309124
18290	25092	1	applied	\N	\N	\N	\N	141687	141687	309125
18290	25093	2	applied	\N	\N	\N	\N	141688	141688	309126
18294	25094	0	applied	\N	\N	\N	\N	141698	141698	309136
18294	25095	1	applied	\N	\N	\N	\N	141699	141699	309137
18294	25096	2	applied	\N	\N	\N	\N	141700	141700	309138
18296	25097	0	applied	\N	\N	\N	\N	141704	141704	309142
18296	25098	1	applied	\N	\N	\N	\N	141705	141705	309143
18300	25097	0	applied	\N	\N	\N	\N	141712	141712	309150
18302	25100	1	applied	\N	\N	\N	\N	141717	141717	309155
18302	25101	2	applied	\N	\N	\N	\N	141718	141718	309156
18308	25107	0	applied	\N	\N	\N	\N	141731	141731	309169
18308	25108	1	applied	\N	\N	\N	\N	141732	141732	309170
18308	25109	2	applied	\N	\N	\N	\N	141733	141733	309171
18308	25110	3	applied	\N	\N	\N	\N	141734	141734	309172
18308	25111	4	applied	\N	\N	\N	\N	141735	141735	309173
18308	25112	5	applied	\N	\N	\N	\N	141736	141736	309174
18308	25113	6	applied	\N	\N	\N	\N	141737	141737	309175
18308	25114	7	applied	\N	\N	\N	\N	141738	141738	309176
18401	25294	1	applied	\N	\N	\N	\N	142476	142476	309892
18404	25295	0	applied	\N	\N	\N	\N	142483	142483	309899
18404	25296	1	applied	\N	\N	\N	\N	142484	142484	309900
18404	25297	2	applied	\N	\N	\N	\N	142485	142485	309901
18411	25312	0	applied	\N	\N	\N	\N	142503	142503	309919
18411	25313	1	applied	\N	\N	\N	\N	142504	142504	309920
18413	25312	0	applied	\N	\N	\N	\N	142509	142509	309925
18413	25313	1	applied	\N	\N	\N	\N	142510	142510	309926
18413	25314	2	applied	\N	\N	\N	\N	142511	142511	309927
18414	25315	0	applied	\N	\N	\N	\N	142512	142512	309928
18414	25316	1	applied	\N	\N	\N	\N	142513	142513	309929
18414	25317	2	applied	\N	\N	\N	\N	142514	142514	309930
18414	25318	3	applied	\N	\N	\N	\N	142515	142515	309931
18414	25319	4	applied	\N	\N	\N	\N	142516	142516	309932
18414	25320	5	applied	\N	\N	\N	\N	142517	142517	309933
18414	25321	6	applied	\N	\N	\N	\N	142518	142518	309934
18414	25322	7	applied	\N	\N	\N	\N	142519	142519	309935
18414	25323	8	applied	\N	\N	\N	\N	142520	142520	309936
18414	25324	9	applied	\N	\N	\N	\N	142521	142521	309937
18416	25315	0	applied	\N	\N	\N	\N	142532	142532	309948
18284	24998	1	applied	\N	\N	\N	\N	141585	141585	309023
18284	24999	2	applied	\N	\N	\N	\N	141586	141586	309024
18308	25119	12	applied	\N	\N	\N	\N	141743	141743	309181
18308	25120	13	applied	\N	\N	\N	\N	141744	141744	309182
18308	25121	14	applied	\N	\N	\N	\N	141745	141745	309183
18308	25122	15	applied	\N	\N	\N	\N	141746	141746	309184
18308	25123	16	applied	\N	\N	\N	\N	141747	141747	309185
18308	25124	17	applied	\N	\N	\N	\N	141748	141748	309186
18308	25125	18	applied	\N	\N	\N	\N	141749	141749	309187
18310	25107	0	applied	\N	\N	\N	\N	141769	141769	309207
18310	25108	1	applied	\N	\N	\N	\N	141770	141770	309208
18310	25109	2	applied	\N	\N	\N	\N	141771	141771	309209
18310	25110	3	applied	\N	\N	\N	\N	141772	141772	309210
18310	25111	4	applied	\N	\N	\N	\N	141773	141773	309211
18310	25112	5	applied	\N	\N	\N	\N	141774	141774	309212
18310	25113	6	applied	\N	\N	\N	\N	141775	141775	309213
18310	25114	7	applied	\N	\N	\N	\N	141776	141776	309214
18310	25115	8	applied	\N	\N	\N	\N	141777	141777	309215
18310	25117	10	applied	\N	\N	\N	\N	141779	141779	309217
18310	25118	11	applied	\N	\N	\N	\N	141780	141780	309218
18310	25119	12	applied	\N	\N	\N	\N	141781	141781	309219
18310	25120	13	applied	\N	\N	\N	\N	141782	141782	309220
18310	25121	14	applied	\N	\N	\N	\N	141783	141783	309221
18310	25122	15	applied	\N	\N	\N	\N	141784	141784	309222
18310	25123	16	applied	\N	\N	\N	\N	141785	141785	309223
18310	25124	17	applied	\N	\N	\N	\N	141786	141786	309224
18310	25125	18	applied	\N	\N	\N	\N	141787	141787	309225
18313	25128	0	applied	\N	\N	\N	\N	141793	141793	309231
18313	25129	1	applied	\N	\N	\N	\N	141794	141794	309232
18313	25130	2	applied	\N	\N	\N	\N	141795	141795	309233
18315	25107	0	applied	\N	\N	\N	\N	141799	141799	309237
18315	25108	1	applied	\N	\N	\N	\N	141800	141800	309238
18315	25109	2	applied	\N	\N	\N	\N	141801	141801	309239
18315	25110	3	applied	\N	\N	\N	\N	141802	141802	309240
18315	25079	5	applied	\N	\N	\N	\N	141804	141804	309242
18315	25080	6	applied	\N	\N	\N	\N	141805	141805	309243
18315	25078	7	applied	\N	\N	\N	\N	141806	141806	309244
18315	25081	8	applied	\N	\N	\N	\N	141807	141807	309245
18315	25085	9	applied	\N	\N	\N	\N	141808	141808	309246
18315	25091	10	applied	\N	\N	\N	\N	141809	141809	309247
18315	25094	11	applied	\N	\N	\N	\N	141810	141810	309248
18315	25086	12	applied	\N	\N	\N	\N	141811	141811	309249
18315	25087	13	applied	\N	\N	\N	\N	141812	141812	309250
18315	25097	14	applied	\N	\N	\N	\N	141813	141813	309251
18315	25099	15	applied	\N	\N	\N	\N	141814	141814	309252
18315	25102	16	applied	\N	\N	\N	\N	141815	141815	309253
18315	25104	17	applied	\N	\N	\N	\N	141816	141816	309254
18315	25111	18	applied	\N	\N	\N	\N	141817	141817	309255
18315	25112	19	applied	\N	\N	\N	\N	141818	141818	309256
18315	25113	20	applied	\N	\N	\N	\N	141819	141819	309257
18315	25115	22	applied	\N	\N	\N	\N	141821	141821	309259
18315	25126	23	applied	\N	\N	\N	\N	141822	141822	309260
18315	25128	24	applied	\N	\N	\N	\N	141823	141823	309261
18315	25129	25	applied	\N	\N	\N	\N	141824	141824	309262
18315	25076	26	applied	\N	\N	\N	\N	141825	141825	309263
18315	25088	27	applied	\N	\N	\N	\N	141826	141826	309264
18315	25077	28	applied	\N	\N	\N	\N	141827	141827	309265
18315	25096	29	applied	\N	\N	\N	\N	141828	141828	309266
18315	25082	30	applied	\N	\N	\N	\N	141829	141829	309267
18315	25089	31	applied	\N	\N	\N	\N	141830	141830	309268
18315	25093	32	applied	\N	\N	\N	\N	141831	141831	309269
18315	25100	33	applied	\N	\N	\N	\N	141832	141832	309270
18315	25121	34	applied	\N	\N	\N	\N	141833	141833	309271
18315	25083	35	applied	\N	\N	\N	\N	141834	141834	309272
18315	25084	36	applied	\N	\N	\N	\N	141835	141835	309273
18315	25090	37	applied	\N	\N	\N	\N	141836	141836	309274
18315	25095	39	applied	\N	\N	\N	\N	141838	141838	309276
18315	25098	40	applied	\N	\N	\N	\N	141839	141839	309277
18315	25103	41	applied	\N	\N	\N	\N	141840	141840	309278
18315	25105	42	applied	\N	\N	\N	\N	141841	141841	309279
18315	25116	43	applied	\N	\N	\N	\N	141842	141842	309280
18315	25117	44	applied	\N	\N	\N	\N	141843	141843	309281
18315	25118	45	applied	\N	\N	\N	\N	141844	141844	309282
18315	25119	46	applied	\N	\N	\N	\N	141845	141845	309283
18315	25120	47	applied	\N	\N	\N	\N	141846	141846	309284
18315	25127	48	applied	\N	\N	\N	\N	141847	141847	309285
18315	25130	49	applied	\N	\N	\N	\N	141848	141848	309286
18315	25122	50	applied	\N	\N	\N	\N	141849	141849	309287
18315	25123	51	applied	\N	\N	\N	\N	141850	141850	309288
18315	25101	52	applied	\N	\N	\N	\N	141851	141851	309289
18315	25106	53	applied	\N	\N	\N	\N	141852	141852	309290
18315	25124	54	applied	\N	\N	\N	\N	141853	141853	309291
18317	25131	0	applied	\N	\N	\N	\N	141858	141858	309296
18317	25132	1	applied	\N	\N	\N	\N	141859	141859	309297
18317	25133	2	applied	\N	\N	\N	\N	141860	141860	309298
18317	25134	3	applied	\N	\N	\N	\N	141861	141861	309299
18317	25135	4	applied	\N	\N	\N	\N	141862	141862	309300
18317	25136	5	applied	\N	\N	\N	\N	141863	141863	309301
18317	25137	6	applied	\N	\N	\N	\N	141864	141864	309302
18317	25138	7	applied	\N	\N	\N	\N	141865	141865	309303
18317	25139	8	applied	\N	\N	\N	\N	141866	141866	309304
18321	25142	0	applied	\N	\N	\N	\N	141873	141873	309311
18321	25143	1	applied	\N	\N	\N	\N	141874	141874	309312
18323	25144	0	applied	\N	\N	\N	\N	141877	141877	309315
18323	25145	1	applied	\N	\N	\N	\N	141878	141878	309316
18325	25148	0	applied	\N	\N	\N	\N	141881	141881	309319
18325	25149	1	applied	\N	\N	\N	\N	141882	141882	309320
18330	25155	0	applied	\N	\N	\N	\N	141899	141899	309337
18330	25157	2	applied	\N	\N	\N	\N	141901	141901	309339
18330	25158	3	applied	\N	\N	\N	\N	141902	141902	309340
18330	25159	4	applied	\N	\N	\N	\N	141903	141903	309341
18333	25162	0	applied	\N	\N	\N	\N	141911	141911	309349
18333	25163	1	applied	\N	\N	\N	\N	141912	141912	309350
18333	25164	2	applied	\N	\N	\N	\N	141913	141913	309351
18333	25165	3	applied	\N	\N	\N	\N	141914	141914	309352
18333	25166	4	applied	\N	\N	\N	\N	141915	141915	309353
18336	25170	0	applied	\N	\N	\N	\N	141919	141919	309357
18336	25171	1	applied	\N	\N	\N	\N	141920	141920	309358
18336	25172	2	applied	\N	\N	\N	\N	141921	141921	309359
18336	25173	3	applied	\N	\N	\N	\N	141922	141922	309360
18336	25174	4	applied	\N	\N	\N	\N	141923	141923	309361
18338	25175	0	applied	\N	\N	\N	\N	141929	141929	309367
18308	25116	9	applied	\N	\N	\N	\N	141740	141740	309178
18308	25117	10	applied	\N	\N	\N	\N	141741	141741	309179
18346	25194	1	applied	\N	\N	\N	\N	141950	141950	309384
18346	25195	2	applied	\N	\N	\N	\N	141951	141951	309385
18346	25196	3	applied	\N	\N	\N	\N	141952	141952	309386
18346	25197	4	applied	\N	\N	\N	\N	141953	141953	141953
18346	25198	5	applied	\N	\N	\N	\N	141954	141954	309387
18346	25199	6	applied	\N	\N	\N	\N	141955	141955	309388
18348	25193	0	applied	\N	\N	\N	\N	141960	141960	309392
18348	25194	1	applied	\N	\N	\N	\N	141961	141961	309393
18348	25195	2	applied	\N	\N	\N	\N	141962	141962	309394
18348	25196	3	applied	\N	\N	\N	\N	141963	141963	309395
18348	25197	4	applied	\N	\N	\N	\N	141964	141964	141964
18348	25198	5	applied	\N	\N	\N	\N	141965	141965	309396
18348	25199	6	applied	\N	\N	\N	\N	141966	141966	309397
18356	25218	0	applied	\N	\N	\N	\N	141995	141995	309421
18356	25219	1	applied	\N	\N	\N	\N	141996	141996	309422
18356	25220	2	applied	\N	\N	\N	\N	141997	141997	309423
18359	25228	1	applied	\N	\N	\N	\N	142005	142005	309431
18361	25227	0	applied	\N	\N	\N	\N	142008	142008	309434
18361	25228	1	applied	\N	\N	\N	\N	142009	142009	309435
18363	25229	0	applied	\N	\N	\N	\N	142012	142012	309438
18363	25230	1	applied	\N	\N	\N	\N	142013	142013	309439
18366	25236	0	applied	\N	\N	\N	\N	142021	142021	309447
18366	25237	1	applied	\N	\N	\N	\N	142022	142022	309448
18370	25107	0	applied	\N	\N	\N	\N	142157	142157	309582
18370	25108	1	applied	\N	\N	\N	\N	142158	142158	309583
18370	25109	2	applied	\N	\N	\N	\N	142159	142159	309584
18370	25110	3	applied	\N	\N	\N	\N	142160	142160	309585
18370	25131	4	applied	\N	\N	\N	\N	142161	142161	309586
18370	25132	5	applied	\N	\N	\N	\N	142162	142162	309587
18370	25133	6	applied	\N	\N	\N	\N	142163	142163	309588
18370	25134	7	applied	\N	\N	\N	\N	142164	142164	309589
18370	25079	8	applied	\N	\N	\N	\N	142165	142165	309590
18370	25086	11	applied	\N	\N	\N	\N	142167	142167	309592
18370	25087	12	applied	\N	\N	\N	\N	142168	142168	309593
18370	25019	13	applied	\N	\N	\N	\N	142169	142169	309594
18370	25021	14	applied	\N	\N	\N	\N	142170	142170	309595
18370	25024	15	applied	\N	\N	\N	\N	142171	142171	309596
18370	25026	16	applied	\N	\N	\N	\N	142172	142172	309597
18370	25028	17	applied	\N	\N	\N	\N	142173	142173	309598
18370	25030	18	applied	\N	\N	\N	\N	142174	142174	309599
18370	25031	19	applied	\N	\N	\N	\N	142175	142175	309600
18370	25035	20	applied	\N	\N	\N	\N	142176	142176	309601
18370	25037	21	applied	\N	\N	\N	\N	142177	142177	309602
18370	25040	22	applied	\N	\N	\N	\N	142178	142178	309603
18370	25042	23	applied	\N	\N	\N	\N	142179	142179	309604
18370	25043	24	applied	\N	\N	\N	\N	142180	142180	309605
18370	25045	25	applied	\N	\N	\N	\N	142181	142181	309606
18370	25046	26	applied	\N	\N	\N	\N	142182	142182	309607
18370	25051	28	applied	\N	\N	\N	\N	142184	142184	309609
18370	25055	29	applied	\N	\N	\N	\N	142185	142185	309610
18370	25056	30	applied	\N	\N	\N	\N	142186	142186	309611
18370	25059	31	applied	\N	\N	\N	\N	142187	142187	309612
18370	25062	32	applied	\N	\N	\N	\N	142188	142188	309613
18370	25064	33	applied	\N	\N	\N	\N	142189	142189	309614
18370	25066	34	applied	\N	\N	\N	\N	142190	142190	309615
18370	25068	35	applied	\N	\N	\N	\N	142191	142191	309616
18370	25069	36	applied	\N	\N	\N	\N	142192	142192	309617
18370	25073	37	applied	\N	\N	\N	\N	142193	142193	309618
18370	25075	38	applied	\N	\N	\N	\N	142194	142194	309619
18370	25078	39	applied	\N	\N	\N	\N	142195	142195	309620
18370	25081	40	applied	\N	\N	\N	\N	142196	142196	309621
18370	25085	41	applied	\N	\N	\N	\N	142197	142197	309622
18370	25091	42	applied	\N	\N	\N	\N	142198	142198	309623
18370	25094	43	applied	\N	\N	\N	\N	142199	142199	309624
18370	25099	45	applied	\N	\N	\N	\N	142201	142201	309626
18370	25102	46	applied	\N	\N	\N	\N	142202	142202	309627
18370	25104	47	applied	\N	\N	\N	\N	142203	142203	309628
18370	25111	48	applied	\N	\N	\N	\N	142204	142204	309629
18370	25112	49	applied	\N	\N	\N	\N	142205	142205	309630
18370	25113	50	applied	\N	\N	\N	\N	142206	142206	309631
18370	25114	51	applied	\N	\N	\N	\N	142207	142207	309632
18370	25115	52	applied	\N	\N	\N	\N	142208	142208	309633
18370	25126	53	applied	\N	\N	\N	\N	142209	142209	309634
18370	25128	54	applied	\N	\N	\N	\N	142210	142210	309635
18370	25135	55	applied	\N	\N	\N	\N	142211	142211	309636
18370	25136	56	applied	\N	\N	\N	\N	142212	142212	309637
18370	25140	57	applied	\N	\N	\N	\N	142213	142213	309638
18370	25142	58	applied	\N	\N	\N	\N	142214	142214	309639
18370	25144	59	applied	\N	\N	\N	\N	142215	142215	309640
18370	25146	60	applied	\N	\N	\N	\N	142216	142216	309641
18370	25151	62	applied	\N	\N	\N	\N	142218	142218	309643
18370	25152	63	applied	\N	\N	\N	\N	142219	142219	309644
18370	25155	64	applied	\N	\N	\N	\N	142220	142220	309645
18370	25156	65	applied	\N	\N	\N	\N	142221	142221	309646
18370	25160	66	applied	\N	\N	\N	\N	142222	142222	309647
18370	25162	67	applied	\N	\N	\N	\N	142223	142223	309648
18370	25163	68	applied	\N	\N	\N	\N	142224	142224	309649
18370	25167	69	applied	\N	\N	\N	\N	142225	142225	309650
18370	25169	70	applied	\N	\N	\N	\N	142226	142226	309651
18370	25170	71	applied	\N	\N	\N	\N	142227	142227	309652
18370	25171	72	applied	\N	\N	\N	\N	142228	142228	309653
18370	25175	73	applied	\N	\N	\N	\N	142229	142229	309654
18370	25177	74	applied	\N	\N	\N	\N	142230	142230	309655
18370	25178	75	applied	\N	\N	\N	\N	142231	142231	309656
18370	25179	76	applied	\N	\N	\N	\N	142232	142232	309657
18370	25186	77	applied	\N	\N	\N	\N	142233	142233	309658
18370	25193	79	applied	\N	\N	\N	\N	142235	142235	309660
18370	25194	80	applied	\N	\N	\N	\N	142236	142236	309661
18370	25195	81	applied	\N	\N	\N	\N	142237	142237	309662
18370	25200	82	applied	\N	\N	\N	\N	142238	142238	309663
18370	25207	83	applied	\N	\N	\N	\N	142239	142239	309664
18370	25209	84	applied	\N	\N	\N	\N	142240	142240	309665
18370	25210	85	applied	\N	\N	\N	\N	142241	142241	309666
18370	25214	86	applied	\N	\N	\N	\N	142242	142242	309667
18370	25216	87	applied	\N	\N	\N	\N	142243	142243	309668
18370	25218	88	applied	\N	\N	\N	\N	142244	142244	309669
18370	25221	89	applied	\N	\N	\N	\N	142245	142245	309670
18370	25222	90	applied	\N	\N	\N	\N	142246	142246	309671
18370	25225	91	applied	\N	\N	\N	\N	142247	142247	309672
18370	25227	92	applied	\N	\N	\N	\N	142248	142248	309673
18343	25186	0	applied	\N	\N	\N	\N	141940	141940	309376
18343	25187	1	applied	\N	\N	\N	\N	141941	141941	309377
18367	24914	58	applied	\N	\N	\N	\N	142080	142080	309505
18367	24920	59	applied	\N	\N	\N	\N	142081	142081	309506
18367	24921	60	applied	\N	\N	\N	\N	142082	142082	309507
18367	24922	61	applied	\N	\N	\N	\N	142083	142083	309508
18367	24923	62	applied	\N	\N	\N	\N	142084	142084	309509
18367	24929	63	applied	\N	\N	\N	\N	142085	142085	309510
18367	24931	64	applied	\N	\N	\N	\N	142086	142086	309511
18367	24934	65	applied	\N	\N	\N	\N	142087	142087	309512
18367	24935	66	applied	\N	\N	\N	\N	142088	142088	309513
18367	24939	67	applied	\N	\N	\N	\N	142089	142089	309514
18367	24941	68	applied	\N	\N	\N	\N	142090	142090	309515
18367	24943	69	applied	\N	\N	\N	\N	142091	142091	309516
18367	24945	70	applied	\N	\N	\N	\N	142092	142092	309517
18367	24952	71	applied	\N	\N	\N	\N	142093	142093	309518
18367	24953	72	applied	\N	\N	\N	\N	142094	142094	309519
18367	24954	73	applied	\N	\N	\N	\N	142095	142095	309520
18367	24956	75	applied	\N	\N	\N	\N	142097	142097	309522
18367	24962	76	applied	\N	\N	\N	\N	142098	142098	309523
18367	24966	77	applied	\N	\N	\N	\N	142099	142099	309524
18367	24971	78	applied	\N	\N	\N	\N	142100	142100	309525
18367	24973	79	applied	\N	\N	\N	\N	142101	142101	309526
18367	24974	80	applied	\N	\N	\N	\N	142102	142102	309527
18367	24978	81	applied	\N	\N	\N	\N	142103	142103	309528
18367	24981	82	applied	\N	\N	\N	\N	142104	142104	309529
18367	24985	83	applied	\N	\N	\N	\N	142105	142105	309530
18367	24988	84	applied	\N	\N	\N	\N	142106	142106	309531
18367	24990	85	applied	\N	\N	\N	\N	142107	142107	309532
18367	24992	86	applied	\N	\N	\N	\N	142108	142108	309533
18367	24995	87	applied	\N	\N	\N	\N	142109	142109	309534
18367	24996	88	applied	\N	\N	\N	\N	142110	142110	309535
18367	24998	89	applied	\N	\N	\N	\N	142111	142111	309536
18367	24999	90	applied	\N	\N	\N	\N	142112	142112	309537
18367	25005	92	applied	\N	\N	\N	\N	142114	142114	309539
18367	25007	93	applied	\N	\N	\N	\N	142115	142115	309540
18367	25008	94	applied	\N	\N	\N	\N	142116	142116	309541
18367	25009	95	applied	\N	\N	\N	\N	142117	142117	309542
18367	25014	96	applied	\N	\N	\N	\N	142118	142118	309543
18367	25017	97	applied	\N	\N	\N	\N	142119	142119	309544
18367	25019	98	applied	\N	\N	\N	\N	142120	142120	309545
18367	25021	99	applied	\N	\N	\N	\N	142121	142121	309546
18367	25024	100	applied	\N	\N	\N	\N	142122	142122	309547
18367	25026	101	applied	\N	\N	\N	\N	142123	142123	309548
18367	25028	102	applied	\N	\N	\N	\N	142124	142124	309549
18367	25030	103	applied	\N	\N	\N	\N	142125	142125	309550
18367	25031	104	applied	\N	\N	\N	\N	142126	142126	309551
18367	25035	105	applied	\N	\N	\N	\N	142127	142127	309552
18367	25037	106	applied	\N	\N	\N	\N	142128	142128	309553
18367	25040	107	applied	\N	\N	\N	\N	142129	142129	309554
18367	25043	109	applied	\N	\N	\N	\N	142131	142131	309556
18367	25045	110	applied	\N	\N	\N	\N	142132	142132	309557
18367	25046	111	applied	\N	\N	\N	\N	142133	142133	309558
18367	25050	112	applied	\N	\N	\N	\N	142134	142134	309559
18367	25051	113	applied	\N	\N	\N	\N	142135	142135	309560
18367	25055	114	applied	\N	\N	\N	\N	142136	142136	309561
18367	25056	115	applied	\N	\N	\N	\N	142137	142137	309562
18367	25059	116	applied	\N	\N	\N	\N	142138	142138	309563
18367	25062	117	applied	\N	\N	\N	\N	142139	142139	309564
18367	25064	118	applied	\N	\N	\N	\N	142140	142140	309565
18367	25066	119	applied	\N	\N	\N	\N	142141	142141	309566
18367	25068	120	applied	\N	\N	\N	\N	142142	142142	309567
18367	25069	121	applied	\N	\N	\N	\N	142143	142143	309568
18367	25073	122	applied	\N	\N	\N	\N	142144	142144	309569
18367	25075	123	applied	\N	\N	\N	\N	142145	142145	309570
18367	25078	124	applied	\N	\N	\N	\N	142146	142146	309571
18370	25231	94	applied	\N	\N	\N	\N	142250	142250	309675
18370	25232	95	applied	\N	\N	\N	\N	142251	142251	309676
18370	25236	96	applied	\N	\N	\N	\N	142252	142252	309677
18370	25238	97	applied	\N	\N	\N	\N	142253	142253	309678
18370	25239	98	applied	\N	\N	\N	\N	142254	142254	309679
18370	25129	99	applied	\N	\N	\N	\N	142255	142255	309680
18370	25096	100	applied	\N	\N	\N	\N	142256	142256	309681
18370	25082	101	applied	\N	\N	\N	\N	142257	142257	309682
18370	25089	102	applied	\N	\N	\N	\N	142258	142258	309683
18370	25093	103	applied	\N	\N	\N	\N	142259	142259	309684
18370	25020	104	applied	\N	\N	\N	\N	142260	142260	309685
18370	25023	105	applied	\N	\N	\N	\N	142261	142261	309686
18370	25032	106	applied	\N	\N	\N	\N	142262	142262	309687
18370	25121	107	applied	\N	\N	\N	\N	142263	142263	309688
18370	25101	108	applied	\N	\N	\N	\N	142264	142264	309689
18370	25106	109	applied	\N	\N	\N	\N	142265	142265	309690
18370	25183	111	applied	\N	\N	\N	\N	142267	142267	142267
18370	25191	112	applied	\N	\N	\N	\N	142268	142268	142268
18370	25192	113	applied	\N	\N	\N	\N	142269	142269	142269
18372	25243	0	applied	\N	\N	\N	\N	142284	142284	309704
18372	25244	1	applied	\N	\N	\N	\N	142285	142285	309705
18375	25249	0	applied	\N	\N	\N	\N	142290	142290	309710
18375	25250	1	applied	\N	\N	\N	\N	142291	142291	309711
18375	25251	2	applied	\N	\N	\N	\N	142292	142292	309712
18377	25252	0	applied	\N	\N	\N	\N	142296	142296	309716
18377	25253	1	applied	\N	\N	\N	\N	142297	142297	309717
18380	25256	0	applied	\N	\N	\N	\N	142300	142300	309720
18380	25257	2	applied	\N	\N	\N	\N	142301	142301	309721
18380	25258	3	applied	\N	\N	\N	\N	142302	142302	309722
18380	25259	4	applied	\N	\N	\N	\N	142303	142303	309723
18380	25260	5	applied	\N	\N	\N	\N	142304	142304	309724
18385	25266	0	applied	\N	\N	\N	\N	142432	142432	309848
18388	25272	0	applied	\N	\N	\N	\N	142441	142441	309857
18388	25273	1	applied	\N	\N	\N	\N	142442	142442	309858
18388	25274	2	applied	\N	\N	\N	\N	142443	142443	309859
18390	25275	0	applied	\N	\N	\N	\N	142447	142447	309863
18390	25276	1	applied	\N	\N	\N	\N	142448	142448	309864
18397	25284	0	applied	\N	\N	\N	\N	142462	142462	309878
18397	25285	1	applied	\N	\N	\N	\N	142463	142463	309879
18400	25289	0	applied	\N	\N	\N	\N	142471	142471	309887
18400	25290	1	applied	\N	\N	\N	\N	142472	142472	309888
18400	25291	2	applied	\N	\N	\N	\N	142473	142473	309889
18400	25292	3	applied	\N	\N	\N	\N	142474	142474	309890
18403	25295	0	applied	\N	\N	\N	\N	142480	142480	309896
18403	25296	1	applied	\N	\N	\N	\N	142481	142481	309897
18403	25297	2	applied	\N	\N	\N	\N	142482	142482	309898
18367	24909	55	applied	\N	\N	\N	\N	142077	142077	309502
18367	24910	56	applied	\N	\N	\N	\N	142078	142078	309503
18370	25061	118	applied	\N	\N	\N	\N	142274	142274	309694
18370	25070	119	applied	\N	\N	\N	\N	142275	142275	309695
18370	25076	120	applied	\N	\N	\N	\N	142276	142276	309696
18370	25088	121	applied	\N	\N	\N	\N	142277	142277	309697
18370	25100	122	applied	\N	\N	\N	\N	142278	142278	309698
18370	25122	123	applied	\N	\N	\N	\N	142279	142279	309699
18370	25123	124	applied	\N	\N	\N	\N	142280	142280	309700
18370	25137	125	applied	\N	\N	\N	\N	142281	142281	309701
18373	25245	0	applied	\N	\N	\N	\N	142286	142286	309706
18373	25246	1	applied	\N	\N	\N	\N	142287	142287	309707
18378	25254	0	applied	\N	\N	\N	\N	142298	142298	309718
18378	25255	1	applied	\N	\N	\N	\N	142299	142299	309719
18381	25243	0	applied	\N	\N	\N	\N	142305	142305	309725
18381	25245	1	applied	\N	\N	\N	\N	142306	142306	309726
18381	25247	2	applied	\N	\N	\N	\N	142307	142307	309727
18381	25249	3	applied	\N	\N	\N	\N	142308	142308	309728
18381	25254	5	applied	\N	\N	\N	\N	142310	142310	309730
18381	25256	6	applied	\N	\N	\N	\N	142311	142311	309731
18381	25257	7	applied	\N	\N	\N	\N	142312	142312	309732
18381	25143	8	applied	\N	\N	\N	\N	142313	142313	309733
18381	25149	9	applied	\N	\N	\N	\N	142314	142314	309734
18381	25159	11	applied	\N	\N	\N	\N	142315	142315	309735
18381	25166	12	applied	\N	\N	\N	\N	142316	142316	309736
18381	25172	13	applied	\N	\N	\N	\N	142317	142317	309737
18381	25180	14	applied	\N	\N	\N	\N	142318	142318	309738
18381	25190	15	applied	\N	\N	\N	\N	142319	142319	309739
18381	25201	16	applied	\N	\N	\N	\N	142320	142320	309740
18381	25211	17	applied	\N	\N	\N	\N	142321	142321	309741
18381	25219	18	applied	\N	\N	\N	\N	142322	142322	309742
18381	25228	19	applied	\N	\N	\N	\N	142323	142323	309743
18381	25233	20	applied	\N	\N	\N	\N	142324	142324	309744
18381	25240	21	applied	\N	\N	\N	\N	142325	142325	309745
18381	25260	23	applied	\N	\N	\N	\N	142327	142327	309747
18381	25202	24	applied	\N	\N	\N	\N	142328	142328	142328
18381	25203	25	applied	\N	\N	\N	\N	142329	142329	142329
18381	25204	26	applied	\N	\N	\N	\N	142330	142330	142330
18381	25205	27	applied	\N	\N	\N	\N	142331	142331	142331
18381	25124	28	applied	\N	\N	\N	\N	142332	142332	309748
18381	25125	29	applied	\N	\N	\N	\N	142333	142333	309749
18381	25022	30	applied	\N	\N	\N	\N	142334	142334	309750
18381	25025	31	applied	\N	\N	\N	\N	142335	142335	309751
18381	25027	32	applied	\N	\N	\N	\N	142336	142336	309752
18381	25029	33	applied	\N	\N	\N	\N	142337	142337	309753
18381	25033	34	applied	\N	\N	\N	\N	142338	142338	309754
18381	25034	35	applied	\N	\N	\N	\N	142339	142339	309755
18381	25036	36	applied	\N	\N	\N	\N	142340	142340	309756
18381	25038	37	applied	\N	\N	\N	\N	142341	142341	309757
18381	25041	38	applied	\N	\N	\N	\N	142342	142342	309758
18381	25048	40	applied	\N	\N	\N	\N	142344	142344	309760
18381	25049	41	applied	\N	\N	\N	\N	142345	142345	309761
18381	25052	42	applied	\N	\N	\N	\N	142346	142346	309762
18381	25053	43	applied	\N	\N	\N	\N	142347	142347	309763
18381	25057	44	applied	\N	\N	\N	\N	142348	142348	309764
18381	25058	45	applied	\N	\N	\N	\N	142349	142349	309765
18381	25060	46	applied	\N	\N	\N	\N	142350	142350	309766
18381	25063	47	applied	\N	\N	\N	\N	142351	142351	309767
18381	25065	48	applied	\N	\N	\N	\N	142352	142352	309768
18381	25067	49	applied	\N	\N	\N	\N	142353	142353	309769
18381	25071	50	applied	\N	\N	\N	\N	142354	142354	309770
18381	25072	51	applied	\N	\N	\N	\N	142355	142355	309771
18381	25074	52	applied	\N	\N	\N	\N	142356	142356	309772
18381	25077	53	applied	\N	\N	\N	\N	142357	142357	309773
18381	25083	54	applied	\N	\N	\N	\N	142358	142358	309774
18381	25084	55	applied	\N	\N	\N	\N	142359	142359	309775
18381	25092	57	applied	\N	\N	\N	\N	142361	142361	309777
18381	25095	58	applied	\N	\N	\N	\N	142362	142362	309778
18381	25098	59	applied	\N	\N	\N	\N	142363	142363	309779
18381	25103	60	applied	\N	\N	\N	\N	142364	142364	309780
18381	25105	61	applied	\N	\N	\N	\N	142365	142365	309781
18381	25116	62	applied	\N	\N	\N	\N	142366	142366	309782
18381	25117	63	applied	\N	\N	\N	\N	142367	142367	309783
18381	25118	64	applied	\N	\N	\N	\N	142368	142368	309784
18381	25119	65	applied	\N	\N	\N	\N	142369	142369	309785
18381	25120	66	applied	\N	\N	\N	\N	142370	142370	309786
18381	25127	67	applied	\N	\N	\N	\N	142371	142371	309787
18381	25130	68	applied	\N	\N	\N	\N	142372	142372	309788
18381	25138	69	applied	\N	\N	\N	\N	142373	142373	309789
18381	25139	70	applied	\N	\N	\N	\N	142374	142374	309790
18381	25141	71	applied	\N	\N	\N	\N	142375	142375	309791
18381	25145	72	applied	\N	\N	\N	\N	142376	142376	309792
18381	25148	74	applied	\N	\N	\N	\N	142378	142378	309794
18381	25153	75	applied	\N	\N	\N	\N	142379	142379	309795
18381	25154	76	applied	\N	\N	\N	\N	142380	142380	309796
18381	25157	77	applied	\N	\N	\N	\N	142381	142381	309797
18381	25158	78	applied	\N	\N	\N	\N	142382	142382	309798
18381	25161	79	applied	\N	\N	\N	\N	142383	142383	309799
18381	25164	80	applied	\N	\N	\N	\N	142384	142384	309800
18381	25165	81	applied	\N	\N	\N	\N	142385	142385	309801
18381	25168	82	applied	\N	\N	\N	\N	142386	142386	309802
18381	25173	83	applied	\N	\N	\N	\N	142387	142387	309803
18405	25298	0	applied	\N	\N	\N	\N	142486	142486	309902
18405	25299	1	applied	\N	\N	\N	\N	142487	142487	309903
18405	25300	2	applied	\N	\N	\N	\N	142488	142488	309904
18407	25301	0	applied	\N	\N	\N	\N	142492	142492	309908
18407	25302	1	applied	\N	\N	\N	\N	142493	142493	309909
18407	25303	2	applied	\N	\N	\N	\N	142494	142494	309910
18410	25310	1	applied	\N	\N	\N	\N	142501	142501	309917
18410	25311	2	applied	\N	\N	\N	\N	142502	142502	309918
18415	25315	0	applied	\N	\N	\N	\N	142522	142522	309938
18415	25316	1	applied	\N	\N	\N	\N	142523	142523	309939
18415	25317	2	applied	\N	\N	\N	\N	142524	142524	309940
18415	25318	3	applied	\N	\N	\N	\N	142525	142525	309941
18415	25319	4	applied	\N	\N	\N	\N	142526	142526	309942
18415	25320	5	applied	\N	\N	\N	\N	142527	142527	309943
18415	25321	6	applied	\N	\N	\N	\N	142528	142528	309944
18415	25322	7	applied	\N	\N	\N	\N	142529	142529	309945
18415	25323	8	applied	\N	\N	\N	\N	142530	142530	309946
18415	25324	9	applied	\N	\N	\N	\N	142531	142531	309947
18417	25325	0	applied	\N	\N	\N	\N	142539	142539	309955
18417	25326	1	applied	\N	\N	\N	\N	142540	142540	309956
18370	25039	115	applied	\N	\N	\N	\N	142271	142271	309691
18370	25047	116	applied	\N	\N	\N	\N	142272	142272	309692
18381	25185	88	applied	\N	\N	\N	\N	142392	142392	309808
18381	25187	89	applied	\N	\N	\N	\N	142393	142393	309809
18381	25189	90	applied	\N	\N	\N	\N	142394	142394	309810
18381	25196	91	applied	\N	\N	\N	\N	142395	142395	309811
18381	25198	92	applied	\N	\N	\N	\N	142396	142396	309812
18381	25199	93	applied	\N	\N	\N	\N	142397	142397	309813
18381	25206	94	applied	\N	\N	\N	\N	142398	142398	309814
18381	25208	95	applied	\N	\N	\N	\N	142399	142399	309815
18381	25212	96	applied	\N	\N	\N	\N	142400	142400	309816
18381	25213	97	applied	\N	\N	\N	\N	142401	142401	309817
18381	25215	98	applied	\N	\N	\N	\N	142402	142402	309818
18381	25217	99	applied	\N	\N	\N	\N	142403	142403	309819
18381	25220	100	applied	\N	\N	\N	\N	142404	142404	309820
18381	25223	101	applied	\N	\N	\N	\N	142405	142405	309821
18381	25224	102	applied	\N	\N	\N	\N	142406	142406	309822
18381	25226	103	applied	\N	\N	\N	\N	142407	142407	309823
18381	25234	105	applied	\N	\N	\N	\N	142409	142409	309825
18381	25235	106	applied	\N	\N	\N	\N	142410	142410	309826
18381	25237	107	applied	\N	\N	\N	\N	142411	142411	309827
18381	25241	108	applied	\N	\N	\N	\N	142412	142412	309828
18381	25242	109	applied	\N	\N	\N	\N	142413	142413	309829
18381	25244	110	applied	\N	\N	\N	\N	142414	142414	309830
18381	25246	111	applied	\N	\N	\N	\N	142415	142415	309831
18381	25248	112	applied	\N	\N	\N	\N	142416	142416	309832
18381	25250	113	applied	\N	\N	\N	\N	142417	142417	309833
18381	25253	114	applied	\N	\N	\N	\N	142418	142418	309834
18381	25255	115	applied	\N	\N	\N	\N	142419	142419	309835
18381	25258	116	applied	\N	\N	\N	\N	142420	142420	309836
18381	25259	117	applied	\N	\N	\N	\N	142421	142421	309837
18383	25261	0	applied	\N	\N	\N	\N	142427	142427	309843
18383	25262	1	applied	\N	\N	\N	\N	142428	142428	309844
18383	25263	2	applied	\N	\N	\N	\N	142429	142429	309845
18383	25265	4	applied	\N	\N	\N	\N	142431	142431	309847
18386	25268	0	applied	\N	\N	\N	\N	142434	142434	309850
18386	25269	1	applied	\N	\N	\N	\N	142435	142435	309851
18386	25270	2	applied	\N	\N	\N	\N	142436	142436	309852
18386	25271	3	applied	\N	\N	\N	\N	142437	142437	309853
18389	25272	0	applied	\N	\N	\N	\N	142444	142444	309860
18389	25273	1	applied	\N	\N	\N	\N	142445	142445	309861
18389	25274	2	applied	\N	\N	\N	\N	142446	142446	309862
18391	25275	0	applied	\N	\N	\N	\N	142449	142449	309865
18391	25276	1	applied	\N	\N	\N	\N	142450	142450	309866
18393	25277	0	applied	\N	\N	\N	\N	142453	142453	309869
18393	25278	1	applied	\N	\N	\N	\N	142454	142454	309870
18395	25279	0	applied	\N	\N	\N	\N	142457	142457	309873
18395	25280	1	applied	\N	\N	\N	\N	142458	142458	309874
18395	25281	2	applied	\N	\N	\N	\N	142459	142459	309875
18398	25286	0	applied	\N	\N	\N	\N	142464	142464	309880
18398	25288	2	applied	\N	\N	\N	\N	142466	142466	309882
18406	25298	0	applied	\N	\N	\N	\N	142489	142489	309905
18406	25299	1	applied	\N	\N	\N	\N	142490	142490	309906
18406	25300	2	applied	\N	\N	\N	\N	142491	142491	309907
18408	25304	0	applied	\N	\N	\N	\N	142495	142495	309911
18408	25305	1	applied	\N	\N	\N	\N	142496	142496	309912
18418	25313	0	applied	\N	\N	\N	\N	142542	142542	309958
18418	25308	1	applied	\N	\N	\N	\N	142543	142543	309959
18418	25320	2	applied	\N	\N	\N	\N	142544	142544	309960
18418	25321	3	applied	\N	\N	\N	\N	142545	142545	309961
18418	25323	4	applied	\N	\N	\N	\N	142546	142546	309962
18418	25327	5	applied	\N	\N	\N	\N	142547	142547	309963
18418	25328	6	applied	\N	\N	\N	\N	142548	142548	309964
18422	25298	0	applied	\N	\N	\N	\N	142559	142559	309975
18422	25299	1	applied	\N	\N	\N	\N	142560	142560	309976
18422	25301	2	applied	\N	\N	\N	\N	142561	142561	309977
18422	25306	4	applied	\N	\N	\N	\N	142563	142563	309979
18422	25309	5	applied	\N	\N	\N	\N	142564	142564	309980
18422	25312	6	applied	\N	\N	\N	\N	142565	142565	309981
18422	25315	7	applied	\N	\N	\N	\N	142566	142566	309982
18422	25316	8	applied	\N	\N	\N	\N	142567	142567	309983
18422	25317	9	applied	\N	\N	\N	\N	142568	142568	309984
18422	25325	10	applied	\N	\N	\N	\N	142569	142569	309985
18422	25329	11	applied	\N	\N	\N	\N	142570	142570	309986
18422	25313	12	applied	\N	\N	\N	\N	142571	142571	309987
18422	25300	13	applied	\N	\N	\N	\N	142572	142572	309988
18422	25302	14	applied	\N	\N	\N	\N	142573	142573	309989
18422	25305	15	applied	\N	\N	\N	\N	142574	142574	309990
18422	25307	16	applied	\N	\N	\N	\N	142575	142575	309991
18422	25308	17	applied	\N	\N	\N	\N	142576	142576	309992
18422	25320	18	applied	\N	\N	\N	\N	142577	142577	309993
18422	25321	19	applied	\N	\N	\N	\N	142578	142578	309994
18422	25310	21	applied	\N	\N	\N	\N	142580	142580	309996
18422	25318	22	applied	\N	\N	\N	\N	142581	142581	309997
18422	25323	23	applied	\N	\N	\N	\N	142582	142582	309998
18422	25311	24	applied	\N	\N	\N	\N	142583	142583	309999
18422	25314	25	applied	\N	\N	\N	\N	142584	142584	310000
18422	25319	26	applied	\N	\N	\N	\N	142585	142585	310001
18422	25322	27	applied	\N	\N	\N	\N	142586	142586	310002
18422	25324	28	applied	\N	\N	\N	\N	142587	142587	310003
18422	25326	29	applied	\N	\N	\N	\N	142588	142588	310004
18422	25330	30	applied	\N	\N	\N	\N	142589	142589	310005
18422	25327	31	applied	\N	\N	\N	\N	142590	142590	310006
18422	25328	32	applied	\N	\N	\N	\N	142591	142591	310007
18422	25332	33	applied	\N	\N	\N	\N	142592	142592	310008
18427	25293	0	applied	\N	\N	\N	\N	142604	142604	310020
18427	25295	1	applied	\N	\N	\N	\N	142605	142605	310021
18427	25298	2	applied	\N	\N	\N	\N	142606	142606	310022
18427	25301	4	applied	\N	\N	\N	\N	142608	142608	310024
18427	25304	5	applied	\N	\N	\N	\N	142609	142609	310025
18427	25306	6	applied	\N	\N	\N	\N	142610	142610	310026
18427	25309	7	applied	\N	\N	\N	\N	142611	142611	310027
18427	25312	8	applied	\N	\N	\N	\N	142612	142612	310028
18427	25315	9	applied	\N	\N	\N	\N	142613	142613	310029
18427	25316	10	applied	\N	\N	\N	\N	142614	142614	310030
18427	25317	11	applied	\N	\N	\N	\N	142615	142615	310031
18427	25325	12	applied	\N	\N	\N	\N	142616	142616	310032
18427	25329	13	applied	\N	\N	\N	\N	142617	142617	310033
18427	25331	14	applied	\N	\N	\N	\N	142618	142618	310034
18427	25335	15	applied	\N	\N	\N	\N	142619	142619	310035
18427	25338	16	applied	\N	\N	\N	\N	142620	142620	310036
18427	25340	17	applied	\N	\N	\N	\N	142621	142621	310037
18381	25176	85	applied	\N	\N	\N	\N	142389	142389	309805
18381	25181	86	applied	\N	\N	\N	\N	142390	142390	309806
18402	25297	2	applied	\N	\N	\N	\N	142479	142479	309895
18409	25306	0	applied	\N	\N	\N	\N	142497	142497	309913
18409	25307	1	applied	\N	\N	\N	\N	142498	142498	309914
18409	25308	2	applied	\N	\N	\N	\N	142499	142499	309915
18412	25312	0	applied	\N	\N	\N	\N	142506	142506	309922
18412	25313	1	applied	\N	\N	\N	\N	142507	142507	309923
18412	25314	2	applied	\N	\N	\N	\N	142508	142508	309924
18419	25329	0	applied	\N	\N	\N	\N	142549	142549	309965
18419	25330	1	applied	\N	\N	\N	\N	142550	142550	309966
18419	25328	2	applied	\N	\N	\N	\N	142551	142551	309967
18421	25331	0	applied	\N	\N	\N	\N	142555	142555	309971
18421	25333	2	applied	\N	\N	\N	\N	142557	142557	309973
18421	25334	3	applied	\N	\N	\N	\N	142558	142558	309974
18424	25335	0	applied	\N	\N	\N	\N	142596	142596	310012
18424	25336	2	applied	\N	\N	\N	\N	142597	142597	310013
18424	25337	3	applied	\N	\N	\N	\N	142598	142598	310014
18426	25340	0	applied	\N	\N	\N	\N	142601	142601	310017
18426	25341	1	applied	\N	\N	\N	\N	142602	142602	310018
18426	25342	2	applied	\N	\N	\N	\N	142603	142603	310019
18427	25343	18	applied	\N	\N	\N	\N	142622	142622	310038
18427	25294	19	applied	\N	\N	\N	\N	142623	142623	310039
18427	25313	20	applied	\N	\N	\N	\N	142624	142624	310040
18427	25308	21	applied	\N	\N	\N	\N	142625	142625	310041
18427	25320	22	applied	\N	\N	\N	\N	142626	142626	310042
18427	25296	23	applied	\N	\N	\N	\N	142627	142627	310043
18427	25300	24	applied	\N	\N	\N	\N	142628	142628	310044
18427	25302	25	applied	\N	\N	\N	\N	142629	142629	310045
18427	25307	27	applied	\N	\N	\N	\N	142631	142631	310047
18427	25321	28	applied	\N	\N	\N	\N	142632	142632	310048
18427	25297	29	applied	\N	\N	\N	\N	142633	142633	310049
18427	25303	30	applied	\N	\N	\N	\N	142634	142634	310050
18427	25310	31	applied	\N	\N	\N	\N	142635	142635	310051
18427	25318	32	applied	\N	\N	\N	\N	142636	142636	310052
18427	25333	33	applied	\N	\N	\N	\N	142637	142637	310053
18427	25344	34	applied	\N	\N	\N	\N	142638	142638	310054
18427	25323	35	applied	\N	\N	\N	\N	142639	142639	310055
18427	25311	36	applied	\N	\N	\N	\N	142640	142640	310056
18427	25314	37	applied	\N	\N	\N	\N	142641	142641	310057
18427	25319	38	applied	\N	\N	\N	\N	142642	142642	310058
18428	25343	0	applied	\N	\N	\N	\N	142658	142658	310074
18428	25344	1	applied	\N	\N	\N	\N	142659	142659	310075
18428	25345	2	applied	\N	\N	\N	\N	142660	142660	310076
18428	25346	3	applied	\N	\N	\N	\N	142661	142661	310077
18431	25351	1	applied	\N	\N	\N	\N	142669	142669	310085
18431	25352	2	applied	\N	\N	\N	\N	142670	142670	310086
18431	25353	3	applied	\N	\N	\N	\N	142671	142671	310087
18431	25354	4	applied	\N	\N	\N	\N	142672	142672	310088
18431	25355	5	applied	\N	\N	\N	\N	142673	142673	310089
18431	25356	6	applied	\N	\N	\N	\N	142674	142674	310090
18435	25107	0	applied	\N	\N	\N	\N	142696	142696	310112
18435	25108	2	applied	\N	\N	\N	\N	142698	142698	310113
18435	24843	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	142697	142697	\N
18435	25109	3	applied	\N	\N	\N	\N	142699	142699	310114
18435	25110	4	applied	\N	\N	\N	\N	142700	142700	310115
18435	25131	5	applied	\N	\N	\N	\N	142701	142701	310116
18435	25132	6	applied	\N	\N	\N	\N	142702	142702	310117
18435	25133	7	applied	\N	\N	\N	\N	142703	142703	310118
18435	25134	8	applied	\N	\N	\N	\N	142704	142704	310119
18435	25079	9	applied	\N	\N	\N	\N	142705	142705	310120
18435	25086	11	applied	\N	\N	\N	\N	142707	142707	310122
18435	25087	12	applied	\N	\N	\N	\N	142708	142708	310123
18435	24844	17	applied	\N	\N	\N	\N	142713	142713	310124
18435	24875	13	failed	Amount_insufficient_to_create_account	\N	\N	\N	142709	142709	\N
18435	24876	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	142710	142710	\N
18435	24877	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	142711	142711	\N
18435	24878	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	142712	142712	\N
18435	24845	18	applied	\N	\N	\N	\N	142714	142714	310125
18435	24846	19	applied	\N	\N	\N	\N	142715	142715	310126
18435	24847	20	applied	\N	\N	\N	\N	142716	142716	310127
18435	24857	21	applied	\N	\N	\N	\N	142717	142717	310128
18435	24858	22	applied	\N	\N	\N	\N	142718	142718	310129
18435	24864	23	applied	\N	\N	\N	\N	142719	142719	310130
18435	24865	24	applied	\N	\N	\N	\N	142720	142720	310131
18435	24870	25	applied	\N	\N	\N	\N	142721	142721	310132
18435	24874	26	applied	\N	\N	\N	\N	142722	142722	310133
18435	24883	28	applied	\N	\N	\N	\N	142724	142724	310135
18435	24887	29	applied	\N	\N	\N	\N	142725	142725	310136
18435	24890	30	applied	\N	\N	\N	\N	142726	142726	310137
18435	24891	31	applied	\N	\N	\N	\N	142727	142727	310138
18435	24892	32	applied	\N	\N	\N	\N	142728	142728	310139
18435	24900	33	applied	\N	\N	\N	\N	142729	142729	310140
18435	24903	34	applied	\N	\N	\N	\N	142730	142730	310141
18435	24904	35	applied	\N	\N	\N	\N	142731	142731	310142
18435	24909	36	applied	\N	\N	\N	\N	142732	142732	310143
18435	24910	37	applied	\N	\N	\N	\N	142733	142733	310144
18435	24913	38	applied	\N	\N	\N	\N	142734	142734	310145
18435	24914	39	applied	\N	\N	\N	\N	142735	142735	310146
18435	24920	40	applied	\N	\N	\N	\N	142736	142736	310147
18435	24921	41	applied	\N	\N	\N	\N	142737	142737	310148
18435	24922	42	applied	\N	\N	\N	\N	142738	142738	310149
18435	24923	43	applied	\N	\N	\N	\N	142739	142739	310150
18435	24931	45	applied	\N	\N	\N	\N	142741	142741	310152
18435	24934	46	applied	\N	\N	\N	\N	142742	142742	310153
18435	24935	47	applied	\N	\N	\N	\N	142743	142743	310154
18435	24939	48	applied	\N	\N	\N	\N	142744	142744	310155
18435	24941	49	applied	\N	\N	\N	\N	142745	142745	310156
18435	24943	50	applied	\N	\N	\N	\N	142746	142746	310157
18435	24945	51	applied	\N	\N	\N	\N	142747	142747	310158
18435	24952	52	applied	\N	\N	\N	\N	142748	142748	310159
18435	24953	53	applied	\N	\N	\N	\N	142749	142749	310160
18435	24954	54	applied	\N	\N	\N	\N	142750	142750	310161
18435	24955	55	applied	\N	\N	\N	\N	142751	142751	310162
18435	24956	56	applied	\N	\N	\N	\N	142752	142752	310163
18435	24962	57	applied	\N	\N	\N	\N	142753	142753	310164
18435	24966	58	applied	\N	\N	\N	\N	142754	142754	310165
18435	24971	59	applied	\N	\N	\N	\N	142755	142755	310166
18435	24973	60	applied	\N	\N	\N	\N	142756	142756	310167
18402	25295	0	applied	\N	\N	\N	\N	142477	142477	309893
18402	25296	1	applied	\N	\N	\N	\N	142478	142478	309894
18416	25320	4	applied	\N	\N	\N	\N	142536	142536	309952
18416	25321	5	applied	\N	\N	\N	\N	142537	142537	309953
18416	25323	6	applied	\N	\N	\N	\N	142538	142538	309954
18423	25335	0	applied	\N	\N	\N	\N	142593	142593	310009
18423	25336	2	applied	\N	\N	\N	\N	142594	142594	310010
18423	25337	3	applied	\N	\N	\N	\N	142595	142595	310011
18425	25338	0	applied	\N	\N	\N	\N	142599	142599	310015
18425	25339	1	applied	\N	\N	\N	\N	142600	142600	310016
18430	25347	0	applied	\N	\N	\N	\N	142665	142665	310081
18430	25348	1	applied	\N	\N	\N	\N	142666	142666	310082
18430	25349	2	applied	\N	\N	\N	\N	142667	142667	310083
18433	25350	0	applied	\N	\N	\N	\N	142682	142682	310098
18433	25351	1	applied	\N	\N	\N	\N	142683	142683	310099
18433	25353	3	applied	\N	\N	\N	\N	142685	142685	310101
18433	25354	4	applied	\N	\N	\N	\N	142686	142686	310102
18433	25355	5	applied	\N	\N	\N	\N	142687	142687	310103
18433	25356	6	applied	\N	\N	\N	\N	142688	142688	310104
18435	24978	62	applied	\N	\N	\N	\N	142758	142758	310169
18435	24981	64	applied	\N	\N	\N	\N	142759	142759	310170
18435	24985	65	applied	\N	\N	\N	\N	142760	142760	310171
18435	24988	66	applied	\N	\N	\N	\N	142761	142761	310172
18435	24990	67	applied	\N	\N	\N	\N	142762	142762	310173
18435	24992	68	applied	\N	\N	\N	\N	142763	142763	310174
18435	24995	69	applied	\N	\N	\N	\N	142764	142764	310175
18435	24996	70	applied	\N	\N	\N	\N	142765	142765	310176
18435	24998	71	applied	\N	\N	\N	\N	142766	142766	310177
18435	24999	72	applied	\N	\N	\N	\N	142767	142767	310178
18435	25003	73	applied	\N	\N	\N	\N	142768	142768	310179
18435	25005	74	applied	\N	\N	\N	\N	142769	142769	310180
18435	25008	76	applied	\N	\N	\N	\N	142771	142771	310182
18435	25009	77	applied	\N	\N	\N	\N	142772	142772	310183
18435	25014	78	applied	\N	\N	\N	\N	142773	142773	310184
18435	25017	79	applied	\N	\N	\N	\N	142774	142774	310185
18435	25019	80	applied	\N	\N	\N	\N	142775	142775	310186
18435	25021	81	applied	\N	\N	\N	\N	142776	142776	310187
18435	25024	82	applied	\N	\N	\N	\N	142777	142777	310188
18435	25026	83	applied	\N	\N	\N	\N	142778	142778	310189
18436	25357	0	applied	\N	\N	\N	\N	142821	142821	310232
18436	25358	1	applied	\N	\N	\N	\N	142822	142822	310233
18436	25359	2	applied	\N	\N	\N	\N	142823	142823	310234
18438	25358	0	applied	\N	\N	\N	\N	142827	142827	310238
18438	25359	1	applied	\N	\N	\N	\N	142828	142828	310239
18440	25357	0	applied	\N	\N	\N	\N	142831	142831	310242
18440	25358	1	applied	\N	\N	\N	\N	142832	142832	310243
18440	25359	2	applied	\N	\N	\N	\N	142833	142833	310244
18443	25367	1	applied	\N	\N	\N	\N	142844	142844	310255
18443	25368	2	applied	\N	\N	\N	\N	142845	142845	310256
18450	25379	0	applied	\N	\N	\N	\N	142867	142867	310278
18450	25380	1	applied	\N	\N	\N	\N	142868	142868	310279
18450	25381	2	applied	\N	\N	\N	\N	142869	142869	310280
18454	25382	0	applied	\N	\N	\N	\N	142994	142994	310405
18454	25383	1	applied	\N	\N	\N	\N	142995	142995	310406
18454	25384	2	applied	\N	\N	\N	\N	142996	142996	310407
18457	25385	0	applied	\N	\N	\N	\N	143003	143003	310414
18457	25388	1	applied	\N	\N	\N	\N	143004	143004	310415
18457	25386	2	applied	\N	\N	\N	\N	143005	143005	310416
18457	25387	3	applied	\N	\N	\N	\N	143006	143006	310417
18465	25392	0	applied	\N	\N	\N	\N	143026	143026	310437
18465	25393	1	applied	\N	\N	\N	\N	143027	143027	310438
18469	25401	0	applied	\N	\N	\N	\N	143044	143044	310455
18469	25402	1	applied	\N	\N	\N	\N	143045	143045	310456
18469	25404	3	applied	\N	\N	1000000000	\N	143047	143047	310458
18469	25405	4	applied	\N	\N	\N	\N	143048	143048	310459
18469	25406	5	applied	\N	\N	\N	\N	143049	143049	310460
18469	25407	6	applied	\N	\N	\N	\N	143050	143050	310461
18469	25408	7	applied	\N	\N	\N	\N	143051	143051	310462
18469	25409	8	applied	\N	\N	\N	\N	143052	143052	310463
18469	25410	9	applied	\N	\N	\N	\N	143053	143053	310464
18469	25411	10	applied	\N	\N	\N	\N	143054	143054	310465
18474	25415	0	applied	\N	\N	\N	\N	143066	143066	310477
18474	25416	1	applied	\N	\N	\N	\N	143067	143067	310478
18474	25417	2	applied	\N	\N	\N	\N	143068	143068	310479
18474	25418	3	applied	\N	\N	\N	\N	143069	143069	310480
18474	25419	4	applied	\N	\N	\N	\N	143070	143070	310481
18474	25420	5	applied	\N	\N	\N	\N	143071	143071	310482
18474	25421	6	applied	\N	\N	\N	\N	143072	143072	310483
18474	25422	7	applied	\N	\N	\N	\N	143073	143073	310484
18477	25416	1	applied	\N	\N	\N	\N	143091	143091	310502
18477	25417	2	applied	\N	\N	\N	\N	143092	143092	310503
18477	25418	3	applied	\N	\N	\N	\N	143093	143093	310504
18477	25419	4	applied	\N	\N	\N	\N	143094	143094	310505
18477	25420	5	applied	\N	\N	\N	\N	143095	143095	310506
18477	25421	6	applied	\N	\N	\N	\N	143096	143096	310507
18477	25422	7	applied	\N	\N	\N	\N	143097	143097	310508
18484	25423	0	applied	\N	\N	\N	\N	143146	143146	310557
18484	25424	1	applied	\N	\N	\N	\N	143147	143147	310558
18484	25425	2	applied	\N	\N	\N	\N	143148	143148	310559
18484	25426	3	applied	\N	\N	\N	\N	143149	143149	310560
18484	25427	4	applied	\N	\N	\N	\N	143150	143150	310561
18484	25428	5	applied	\N	\N	\N	\N	143151	143151	310562
18484	25429	6	applied	\N	\N	\N	\N	143152	143152	310563
18484	25430	7	applied	\N	\N	\N	\N	143153	143153	310564
18484	25431	8	applied	\N	\N	\N	\N	143154	143154	310565
18489	25445	0	applied	\N	\N	\N	\N	143184	143184	310595
18489	25446	1	applied	\N	\N	\N	\N	143185	143185	310596
18491	25447	0	applied	\N	\N	\N	\N	143189	143189	310600
18491	25448	1	applied	\N	\N	\N	\N	143190	143190	310601
18491	25449	2	applied	\N	\N	\N	\N	143191	143191	310602
18496	25454	0	applied	\N	\N	\N	\N	143208	143208	310619
18496	25455	1	applied	\N	\N	1000000000	\N	143209	143209	310620
18496	25456	2	applied	\N	\N	\N	\N	143210	143210	310621
18496	25457	3	applied	\N	\N	\N	\N	143211	143211	310622
18498	25462	0	applied	\N	\N	\N	\N	143216	143216	310627
18498	25463	1	applied	\N	\N	\N	\N	143217	143217	310628
18498	25464	2	applied	\N	\N	\N	\N	143218	143218	310629
18498	25465	3	applied	\N	\N	\N	\N	143219	143219	310630
18510	25491	0	applied	\N	\N	\N	\N	143378	143378	310789
18510	25492	1	applied	\N	\N	\N	\N	143379	143379	310790
18512	25493	0	applied	\N	\N	\N	\N	143383	143383	143383
18416	25317	2	applied	\N	\N	\N	\N	142534	142534	309950
18416	25318	3	applied	\N	\N	\N	\N	142535	142535	309951
18420	25328	2	applied	\N	\N	\N	\N	142554	142554	309970
18429	25347	0	applied	\N	\N	\N	\N	142662	142662	310078
18429	25348	1	applied	\N	\N	\N	\N	142663	142663	310079
18429	25349	2	applied	\N	\N	\N	\N	142664	142664	310080
18439	25358	0	applied	\N	\N	\N	\N	142829	142829	310240
18439	25359	1	applied	\N	\N	\N	\N	142830	142830	310241
18442	25366	0	applied	\N	\N	\N	\N	142840	142840	310251
18442	25367	1	applied	\N	\N	\N	\N	142841	142841	310252
18442	25368	2	applied	\N	\N	\N	\N	142842	142842	310253
18444	25369	0	applied	\N	\N	\N	\N	142846	142846	310257
18444	25370	1	applied	\N	\N	\N	\N	142847	142847	310258
18452	25379	0	applied	\N	\N	\N	\N	142873	142873	310284
18452	25380	1	applied	\N	\N	\N	\N	142874	142874	310285
18452	25381	2	applied	\N	\N	\N	\N	142875	142875	310286
18453	25261	0	applied	\N	\N	\N	\N	142876	142876	310287
18453	25262	1	applied	\N	\N	\N	\N	142877	142877	310288
18453	25266	2	applied	\N	\N	\N	\N	142878	142878	310289
18453	25268	3	applied	\N	\N	\N	\N	142879	142879	310290
18453	25269	4	applied	\N	\N	\N	\N	142880	142880	310291
18453	25272	5	applied	\N	\N	\N	\N	142881	142881	310292
18453	25275	6	applied	\N	\N	\N	\N	142882	142882	310293
18453	25277	7	applied	\N	\N	\N	\N	142883	142883	310294
18453	25279	8	applied	\N	\N	\N	\N	142884	142884	310295
18453	25282	9	applied	\N	\N	\N	\N	142885	142885	310296
18453	25284	10	applied	\N	\N	\N	\N	142886	142886	310297
18453	25286	11	applied	\N	\N	\N	\N	142887	142887	310298
18453	25289	12	applied	\N	\N	\N	\N	142888	142888	310299
18453	25293	14	applied	\N	\N	\N	\N	142890	142890	310301
18453	25295	15	applied	\N	\N	\N	\N	142891	142891	310302
18453	25298	16	applied	\N	\N	\N	\N	142892	142892	310303
18453	25299	17	applied	\N	\N	\N	\N	142893	142893	310304
18453	25301	18	applied	\N	\N	\N	\N	142894	142894	310305
18453	25304	19	applied	\N	\N	\N	\N	142895	142895	310306
18453	25306	20	applied	\N	\N	\N	\N	142896	142896	310307
18453	25309	21	applied	\N	\N	\N	\N	142897	142897	310308
18453	25312	22	applied	\N	\N	\N	\N	142898	142898	310309
18453	25315	23	applied	\N	\N	\N	\N	142899	142899	310310
18453	25316	24	applied	\N	\N	\N	\N	142900	142900	310311
18453	25317	25	applied	\N	\N	\N	\N	142901	142901	310312
18453	25325	26	applied	\N	\N	\N	\N	142902	142902	310313
18453	25329	27	applied	\N	\N	\N	\N	142903	142903	310314
18453	25331	28	applied	\N	\N	\N	\N	142904	142904	310315
18453	25335	29	applied	\N	\N	\N	\N	142905	142905	310316
18453	25340	31	applied	\N	\N	\N	\N	142907	142907	310318
18453	25343	32	applied	\N	\N	\N	\N	142908	142908	310319
18453	25347	33	applied	\N	\N	\N	\N	142909	142909	310320
18453	25350	34	applied	\N	\N	\N	\N	142910	142910	310321
18453	25351	35	applied	\N	\N	\N	\N	142911	142911	310322
18453	25357	36	applied	\N	\N	\N	\N	142912	142912	310323
18453	25360	37	applied	\N	\N	\N	\N	142913	142913	310324
18453	25361	38	applied	\N	\N	\N	\N	142914	142914	310325
18453	25366	39	applied	\N	\N	\N	\N	142915	142915	310326
18453	25369	40	applied	\N	\N	\N	\N	142916	142916	310327
18453	25372	41	applied	\N	\N	\N	\N	142917	142917	310328
18453	25375	42	applied	\N	\N	\N	\N	142918	142918	310329
18453	25379	43	applied	\N	\N	\N	\N	142919	142919	310330
18453	25263	44	applied	\N	\N	\N	\N	142920	142920	310331
18453	25313	45	applied	\N	\N	\N	\N	142921	142921	310332
18453	25308	46	applied	\N	\N	\N	\N	142922	142922	310333
18453	25321	48	applied	\N	\N	\N	\N	142924	142924	310335
18453	25323	49	applied	\N	\N	\N	\N	142925	142925	310336
18453	25264	50	applied	\N	\N	\N	\N	142926	142926	310337
18453	25265	51	applied	\N	\N	\N	\N	142927	142927	310338
18453	25267	52	applied	\N	\N	\N	\N	142928	142928	310339
18453	25270	53	applied	\N	\N	\N	\N	142929	142929	310340
18453	25274	54	applied	\N	\N	\N	\N	142930	142930	310341
18453	25281	55	applied	\N	\N	\N	\N	142931	142931	310342
18453	25327	56	applied	\N	\N	\N	\N	142932	142932	310343
18453	25328	57	applied	\N	\N	\N	\N	142933	142933	310344
18453	25332	58	applied	\N	\N	\N	\N	142934	142934	310345
18453	25336	59	applied	\N	\N	\N	\N	142935	142935	310346
18453	25339	60	applied	\N	\N	\N	\N	142936	142936	310347
18453	25341	61	applied	\N	\N	\N	\N	142937	142937	310348
18453	25345	62	applied	\N	\N	\N	\N	142938	142938	310349
18453	25348	63	applied	\N	\N	\N	\N	142939	142939	310350
18453	25356	65	applied	\N	\N	\N	\N	142941	142941	310352
18453	25359	66	applied	\N	\N	\N	\N	142942	142942	310353
18453	25362	67	applied	\N	\N	\N	\N	142943	142943	310354
18453	25365	68	applied	\N	\N	\N	\N	142944	142944	310355
18453	25367	69	applied	\N	\N	\N	\N	142945	142945	310356
18453	25371	70	applied	\N	\N	\N	\N	142946	142946	310357
18453	25373	71	applied	\N	\N	\N	\N	142947	142947	310358
18453	25288	72	applied	\N	\N	\N	\N	142948	142948	310359
18453	25297	73	applied	\N	\N	\N	\N	142949	142949	310360
18453	25303	74	applied	\N	\N	\N	\N	142950	142950	310361
18453	25310	75	applied	\N	\N	\N	\N	142951	142951	310362
18453	25318	76	applied	\N	\N	\N	\N	142952	142952	310363
18453	25333	77	applied	\N	\N	\N	\N	142953	142953	310364
18453	25344	78	applied	\N	\N	\N	\N	142954	142954	310365
18453	25352	79	applied	\N	\N	\N	\N	142955	142955	310366
18512	25495	2	applied	\N	\N	\N	\N	143385	143385	310795
18514	25404	1	applied	\N	\N	1000000000	\N	143390	143390	310798
18514	25455	2	applied	\N	\N	1000000000	\N	143391	143391	310799
18514	25496	3	applied	\N	\N	1000000000	\N	143392	143392	310800
18514	25459	4	applied	\N	\N	\N	\N	143393	143393	310801
18514	25332	5	applied	\N	\N	\N	\N	143394	143394	310802
18514	25336	6	applied	\N	\N	\N	\N	143395	143395	310803
18514	25339	7	applied	\N	\N	\N	\N	143396	143396	310804
18514	25341	8	applied	\N	\N	\N	\N	143397	143397	310805
18514	25345	9	applied	\N	\N	\N	\N	143398	143398	310806
18514	25348	10	applied	\N	\N	\N	\N	143399	143399	310807
18514	25355	11	applied	\N	\N	\N	\N	143400	143400	310808
18514	25356	12	applied	\N	\N	\N	\N	143401	143401	310809
18514	25359	13	applied	\N	\N	\N	\N	143402	143402	310810
18514	25362	14	applied	\N	\N	\N	\N	143403	143403	310811
18514	25365	15	applied	\N	\N	\N	\N	143404	143404	310812
18514	25367	16	applied	\N	\N	\N	\N	143405	143405	310813
18514	25373	18	applied	\N	\N	\N	\N	143407	143407	310815
18514	25378	19	applied	\N	\N	\N	\N	143408	143408	310816
18420	25329	0	applied	\N	\N	\N	\N	142552	142552	309968
18420	25330	1	applied	\N	\N	\N	\N	142553	142553	309969
18427	25334	43	applied	\N	\N	\N	\N	142647	142647	310063
18427	25337	44	applied	\N	\N	\N	\N	142648	142648	310064
18427	25342	45	applied	\N	\N	\N	\N	142649	142649	310065
18427	25327	46	applied	\N	\N	\N	\N	142650	142650	310066
18427	25328	47	applied	\N	\N	\N	\N	142651	142651	310067
18427	25332	48	applied	\N	\N	\N	\N	142652	142652	310068
18427	25336	49	applied	\N	\N	\N	\N	142653	142653	310069
18427	25339	50	applied	\N	\N	\N	\N	142654	142654	310070
18427	25341	51	applied	\N	\N	\N	\N	142655	142655	310071
18427	25345	52	applied	\N	\N	\N	\N	142656	142656	310072
18427	25346	53	applied	\N	\N	\N	\N	142657	142657	310073
18432	25350	0	applied	\N	\N	\N	\N	142675	142675	310091
18432	25351	1	applied	\N	\N	\N	\N	142676	142676	310092
18432	25352	2	applied	\N	\N	\N	\N	142677	142677	310093
18432	25353	3	applied	\N	\N	\N	\N	142678	142678	310094
18432	25354	4	applied	\N	\N	\N	\N	142679	142679	310095
18432	25356	6	applied	\N	\N	\N	\N	142681	142681	310097
18434	25350	0	applied	\N	\N	\N	\N	142689	142689	310105
18434	25351	1	applied	\N	\N	\N	\N	142690	142690	310106
18434	25352	2	applied	\N	\N	\N	\N	142691	142691	310107
18434	25353	3	applied	\N	\N	\N	\N	142692	142692	310108
18434	25354	4	applied	\N	\N	\N	\N	142693	142693	310109
18434	25355	5	applied	\N	\N	\N	\N	142694	142694	310110
18434	25356	6	applied	\N	\N	\N	\N	142695	142695	310111
18445	25372	0	applied	\N	\N	\N	\N	142849	142849	310260
18445	25373	1	applied	\N	\N	\N	\N	142850	142850	310261
18445	25374	2	applied	\N	\N	\N	\N	142851	142851	310262
18447	25375	0	applied	\N	\N	\N	\N	142855	142855	310266
18447	25376	1	applied	\N	\N	\N	\N	142856	142856	310267
18447	25377	2	applied	\N	\N	\N	\N	142857	142857	310268
18447	25378	3	applied	\N	\N	\N	\N	142858	142858	310269
18449	25375	0	applied	\N	\N	\N	\N	142863	142863	310274
18449	25377	2	applied	\N	\N	\N	\N	142865	142865	310276
18449	25378	3	applied	\N	\N	\N	\N	142866	142866	310277
18453	25364	80	applied	\N	\N	\N	\N	142956	142956	310367
18453	25376	81	applied	\N	\N	\N	\N	142957	142957	310368
18453	25271	82	applied	\N	\N	\N	\N	142958	142958	310369
18453	25273	83	applied	\N	\N	\N	\N	142959	142959	310370
18453	25276	84	applied	\N	\N	\N	\N	142960	142960	310371
18453	25278	85	applied	\N	\N	\N	\N	142961	142961	310372
18453	25280	86	applied	\N	\N	\N	\N	142962	142962	310373
18453	25283	87	applied	\N	\N	\N	\N	142963	142963	310374
18453	25285	88	applied	\N	\N	\N	\N	142964	142964	310375
18453	25287	89	applied	\N	\N	\N	\N	142965	142965	310376
18453	25291	90	applied	\N	\N	\N	\N	142966	142966	310377
18453	25292	91	applied	\N	\N	\N	\N	142967	142967	310378
18453	25294	92	applied	\N	\N	\N	\N	142968	142968	310379
18453	25296	93	applied	\N	\N	\N	\N	142969	142969	310380
18453	25302	95	applied	\N	\N	\N	\N	142971	142971	310382
18453	25305	96	applied	\N	\N	\N	\N	142972	142972	310383
18453	25307	97	applied	\N	\N	\N	\N	142973	142973	310384
18453	25311	98	applied	\N	\N	\N	\N	142974	142974	310385
18453	25314	99	applied	\N	\N	\N	\N	142975	142975	310386
18453	25319	100	applied	\N	\N	\N	\N	142976	142976	310387
18453	25322	101	applied	\N	\N	\N	\N	142977	142977	310388
18456	25385	0	applied	\N	\N	\N	\N	143000	143000	310411
18456	25386	1	applied	\N	\N	\N	\N	143001	143001	310412
18456	25387	2	applied	\N	\N	\N	\N	143002	143002	310413
18458	25385	0	applied	\N	\N	\N	\N	143007	143007	310418
18458	25388	1	applied	\N	\N	\N	\N	143008	143008	310419
18458	25386	2	applied	\N	\N	\N	\N	143009	143009	310420
18458	25387	3	applied	\N	\N	\N	\N	143010	143010	310421
18464	25392	0	applied	\N	\N	\N	\N	143024	143024	310435
18464	25393	1	applied	\N	\N	\N	\N	143025	143025	310436
18466	25393	1	applied	\N	\N	\N	\N	143029	143029	310440
18473	25412	0	applied	\N	\N	\N	\N	143063	143063	310474
18473	25414	1	applied	\N	\N	\N	\N	143064	143064	310475
18473	25413	2	applied	\N	\N	\N	\N	143065	143065	310476
18476	25415	0	applied	\N	\N	\N	\N	143082	143082	310493
18476	25416	1	applied	\N	\N	\N	\N	143083	143083	310494
18476	25417	2	applied	\N	\N	\N	\N	143084	143084	310495
18476	25418	3	applied	\N	\N	\N	\N	143085	143085	310496
18476	25419	4	applied	\N	\N	\N	\N	143086	143086	310497
18476	25420	5	applied	\N	\N	\N	\N	143087	143087	310498
18476	25421	6	applied	\N	\N	\N	\N	143088	143088	310499
18476	25422	7	applied	\N	\N	\N	\N	143089	143089	310500
18480	25415	0	applied	\N	\N	\N	\N	143114	143114	310525
18480	25416	1	applied	\N	\N	\N	\N	143115	143115	310526
18480	25417	2	applied	\N	\N	\N	\N	143116	143116	310527
18480	25418	3	applied	\N	\N	\N	\N	143117	143117	310528
18480	25420	5	applied	\N	\N	\N	\N	143119	143119	310530
18480	25421	6	applied	\N	\N	\N	\N	143120	143120	310531
18480	25422	7	applied	\N	\N	\N	\N	143121	143121	310532
18483	25415	0	applied	\N	\N	\N	\N	143138	143138	310549
18483	25416	1	applied	\N	\N	\N	\N	143139	143139	310550
18483	25417	2	applied	\N	\N	\N	\N	143140	143140	310551
18483	25418	3	applied	\N	\N	\N	\N	143141	143141	310552
18483	25419	4	applied	\N	\N	\N	\N	143142	143142	310553
18483	25420	5	applied	\N	\N	\N	\N	143143	143143	310554
18483	25421	6	applied	\N	\N	\N	\N	143144	143144	310555
18483	25422	7	applied	\N	\N	\N	\N	143145	143145	310556
18488	25441	0	applied	\N	\N	\N	\N	143180	143180	310591
18488	25442	1	applied	\N	\N	\N	\N	143181	143181	310592
18488	25443	2	applied	\N	\N	\N	\N	143182	143182	310593
18488	25444	3	applied	\N	\N	\N	\N	143183	143183	310594
18493	25450	0	applied	\N	\N	\N	\N	143196	143196	310607
18493	25452	2	applied	\N	\N	\N	\N	143198	143198	310609
18493	25453	3	applied	\N	\N	\N	\N	143199	143199	310610
18500	25107	0	applied	\N	\N	\N	\N	143227	143227	310638
18500	25108	1	applied	\N	\N	\N	\N	143228	143228	310639
18500	25109	2	applied	\N	\N	\N	\N	143229	143229	310640
18500	25110	3	applied	\N	\N	\N	\N	143230	143230	310641
18500	25131	4	applied	\N	\N	\N	\N	143231	143231	310642
18500	25132	5	applied	\N	\N	\N	\N	143232	143232	310643
18500	25133	6	applied	\N	\N	\N	\N	143233	143233	310644
18500	25134	7	applied	\N	\N	\N	\N	143234	143234	310645
18500	25079	8	applied	\N	\N	\N	\N	143235	143235	310646
18500	25080	9	applied	\N	\N	\N	\N	143236	143236	310647
18500	25086	10	applied	\N	\N	\N	\N	143237	143237	310648
18500	25087	11	applied	\N	\N	\N	\N	143238	143238	310649
18427	25324	40	applied	\N	\N	\N	\N	142644	142644	310060
18427	25326	41	applied	\N	\N	\N	\N	142645	142645	310061
18435	25035	87	applied	\N	\N	\N	\N	142782	142782	310193
18435	25037	88	applied	\N	\N	\N	\N	142783	142783	310194
18435	25040	89	applied	\N	\N	\N	\N	142784	142784	310195
18435	25042	90	applied	\N	\N	\N	\N	142785	142785	310196
18435	25043	91	applied	\N	\N	\N	\N	142786	142786	310197
18435	25045	92	applied	\N	\N	\N	\N	142787	142787	310198
18435	25046	93	applied	\N	\N	\N	\N	142788	142788	310199
18435	25050	94	applied	\N	\N	\N	\N	142789	142789	310200
18435	25051	95	applied	\N	\N	\N	\N	142790	142790	310201
18435	25055	96	applied	\N	\N	\N	\N	142791	142791	310202
18435	25056	97	applied	\N	\N	\N	\N	142792	142792	310203
18435	25059	98	applied	\N	\N	\N	\N	142793	142793	310204
18435	25062	99	applied	\N	\N	\N	\N	142794	142794	310205
18435	25066	101	applied	\N	\N	\N	\N	142796	142796	310207
18435	25068	102	applied	\N	\N	\N	\N	142797	142797	310208
18435	25069	103	applied	\N	\N	\N	\N	142798	142798	310209
18435	25073	104	applied	\N	\N	\N	\N	142799	142799	310210
18435	25075	105	applied	\N	\N	\N	\N	142800	142800	310211
18435	25078	106	applied	\N	\N	\N	\N	142801	142801	310212
18435	25081	107	applied	\N	\N	\N	\N	142802	142802	310213
18435	25085	108	applied	\N	\N	\N	\N	142803	142803	310214
18435	25091	109	applied	\N	\N	\N	\N	142804	142804	310215
18435	25094	110	applied	\N	\N	\N	\N	142805	142805	310216
18435	25097	111	applied	\N	\N	\N	\N	142806	142806	310217
18435	25099	112	applied	\N	\N	\N	\N	142807	142807	310218
18435	25102	113	applied	\N	\N	\N	\N	142808	142808	310219
18435	25104	114	applied	\N	\N	\N	\N	142809	142809	310220
18435	25111	115	applied	\N	\N	\N	\N	142810	142810	310221
18435	25112	116	applied	\N	\N	\N	\N	142811	142811	310222
18435	25114	118	applied	\N	\N	\N	\N	142813	142813	310224
18435	25115	119	applied	\N	\N	\N	\N	142814	142814	310225
18435	25126	120	applied	\N	\N	\N	\N	142815	142815	310226
18435	25128	121	applied	\N	\N	\N	\N	142816	142816	310227
18435	25135	122	applied	\N	\N	\N	\N	142817	142817	310228
18435	25136	123	applied	\N	\N	\N	\N	142818	142818	310229
18435	25140	124	applied	\N	\N	\N	\N	142819	142819	310230
18435	25142	125	applied	\N	\N	\N	\N	142820	142820	310231
18437	25357	0	applied	\N	\N	\N	\N	142824	142824	310235
18437	25358	1	applied	\N	\N	\N	\N	142825	142825	310236
18437	25359	2	applied	\N	\N	\N	\N	142826	142826	310237
18441	25360	0	applied	\N	\N	\N	\N	142834	142834	310245
18441	25361	1	applied	\N	\N	\N	\N	142835	142835	310246
18441	25362	2	applied	\N	\N	\N	\N	142836	142836	310247
18441	25363	3	applied	\N	\N	\N	\N	142837	142837	310248
18441	25364	4	applied	\N	\N	\N	\N	142838	142838	310249
18446	25372	0	applied	\N	\N	\N	\N	142852	142852	310263
18446	25373	1	applied	\N	\N	\N	\N	142853	142853	310264
18446	25374	2	applied	\N	\N	\N	\N	142854	142854	310265
18448	25375	0	applied	\N	\N	\N	\N	142859	142859	310270
18448	25376	1	applied	\N	\N	\N	\N	142860	142860	310271
18448	25377	2	applied	\N	\N	\N	\N	142861	142861	310272
18448	25378	3	applied	\N	\N	\N	\N	142862	142862	310273
18451	25379	0	applied	\N	\N	\N	\N	142870	142870	310281
18451	25380	1	applied	\N	\N	\N	\N	142871	142871	310282
18451	25381	2	applied	\N	\N	\N	\N	142872	142872	310283
18455	25382	0	applied	\N	\N	\N	\N	142997	142997	310408
18455	25383	1	applied	\N	\N	\N	\N	142998	142998	310409
18455	25384	2	applied	\N	\N	\N	\N	142999	142999	310410
18459	25385	0	applied	\N	\N	\N	\N	143011	143011	310422
18459	25388	1	applied	\N	\N	\N	\N	143012	143012	310423
18459	25386	2	applied	\N	\N	\N	\N	143013	143013	310424
18462	25389	0	applied	\N	\N	\N	\N	143019	143019	310430
18462	25390	1	applied	\N	\N	\N	\N	143020	143020	310431
18462	25391	2	applied	\N	\N	\N	\N	143021	143021	310432
18467	25394	0	applied	\N	\N	\N	\N	143030	143030	310441
18467	25395	1	applied	\N	\N	\N	\N	143031	143031	310442
18467	25396	2	applied	\N	\N	\N	\N	143032	143032	310443
18467	25397	3	applied	\N	\N	\N	\N	143033	143033	310444
18467	25398	4	applied	\N	\N	\N	\N	143034	143034	310445
18467	25399	5	applied	\N	\N	\N	\N	143035	143035	310446
18467	25400	6	applied	\N	\N	\N	\N	143036	143036	310447
18470	25412	0	applied	\N	\N	\N	\N	143055	143055	310466
18470	25413	1	applied	\N	\N	\N	\N	143056	143056	310467
18472	25412	0	applied	\N	\N	\N	\N	143060	143060	310471
18472	25414	1	applied	\N	\N	\N	\N	143061	143061	310472
18472	25413	2	applied	\N	\N	\N	\N	143062	143062	310473
18479	25415	0	applied	\N	\N	\N	\N	143106	143106	310517
18479	25417	2	applied	\N	\N	\N	\N	143108	143108	310519
18479	25418	3	applied	\N	\N	\N	\N	143109	143109	310520
18479	25419	4	applied	\N	\N	\N	\N	143110	143110	310521
18479	25420	5	applied	\N	\N	\N	\N	143111	143111	310522
18479	25421	6	applied	\N	\N	\N	\N	143112	143112	310523
18479	25422	7	applied	\N	\N	\N	\N	143113	143113	310524
18481	25415	0	applied	\N	\N	\N	\N	143122	143122	310533
18481	25416	1	applied	\N	\N	\N	\N	143123	143123	310534
18481	25417	2	applied	\N	\N	\N	\N	143124	143124	310535
18481	25418	3	applied	\N	\N	\N	\N	143125	143125	310536
18481	25419	4	applied	\N	\N	\N	\N	143126	143126	310537
18481	25420	5	applied	\N	\N	\N	\N	143127	143127	310538
18481	25421	6	applied	\N	\N	\N	\N	143128	143128	310539
18500	24981	12	applied	\N	\N	\N	\N	143239	143239	310650
18500	24985	14	applied	\N	\N	\N	\N	143240	143240	310651
18500	24988	15	applied	\N	\N	\N	\N	143241	143241	310652
18500	24992	17	applied	\N	\N	\N	\N	143243	143243	310654
18500	24995	18	applied	\N	\N	\N	\N	143244	143244	310655
18500	24996	19	applied	\N	\N	\N	\N	143245	143245	310656
18500	24998	20	applied	\N	\N	\N	\N	143246	143246	310657
18500	24999	21	applied	\N	\N	\N	\N	143247	143247	310658
18500	25003	22	applied	\N	\N	\N	\N	143248	143248	310659
18500	25005	23	applied	\N	\N	\N	\N	143249	143249	310660
18500	25007	24	applied	\N	\N	\N	\N	143250	143250	310661
18500	25008	25	applied	\N	\N	\N	\N	143251	143251	310662
18500	25009	26	applied	\N	\N	\N	\N	143252	143252	310663
18500	25014	27	applied	\N	\N	\N	\N	143253	143253	310664
18500	25017	28	applied	\N	\N	\N	\N	143254	143254	310665
18500	25404	29	applied	\N	\N	1000000000	\N	143255	143255	310666
18500	25455	30	applied	\N	\N	1000000000	\N	143256	143256	310667
18500	25019	31	applied	\N	\N	\N	\N	143257	143257	310668
18500	25021	32	applied	\N	\N	\N	\N	143258	143258	310669
18435	25030	85	applied	\N	\N	\N	\N	142780	142780	310191
18435	25031	86	applied	\N	\N	\N	\N	142781	142781	310192
18453	25334	105	applied	\N	\N	\N	\N	142981	142981	310392
18453	25337	106	applied	\N	\N	\N	\N	142982	142982	310393
18453	25342	107	applied	\N	\N	\N	\N	142983	142983	310394
18453	25346	108	applied	\N	\N	\N	\N	142984	142984	310395
18453	25349	109	applied	\N	\N	\N	\N	142985	142985	310396
18453	25353	110	applied	\N	\N	\N	\N	142986	142986	310397
18453	25354	111	applied	\N	\N	\N	\N	142987	142987	310398
18453	25358	112	applied	\N	\N	\N	\N	142988	142988	310399
18453	25363	113	applied	\N	\N	\N	\N	142989	142989	310400
18453	25368	114	applied	\N	\N	\N	\N	142990	142990	310401
18453	25370	115	applied	\N	\N	\N	\N	142991	142991	310402
18453	25374	116	applied	\N	\N	\N	\N	142992	142992	310403
18453	25377	117	applied	\N	\N	\N	\N	142993	142993	310404
18460	25388	1	applied	\N	\N	\N	\N	143016	143016	310427
18460	25386	2	applied	\N	\N	\N	\N	143017	143017	310428
18460	25387	3	applied	\N	\N	\N	\N	143018	143018	310429
18463	25392	0	applied	\N	\N	\N	\N	143022	143022	310433
18463	25393	1	applied	\N	\N	\N	\N	143023	143023	310434
18468	25394	0	applied	\N	\N	\N	\N	143037	143037	310448
18468	25395	1	applied	\N	\N	\N	\N	143038	143038	310449
18468	25396	2	applied	\N	\N	\N	\N	143039	143039	310450
18468	25397	3	applied	\N	\N	\N	\N	143040	143040	310451
18468	25398	4	applied	\N	\N	\N	\N	143041	143041	310452
18468	25399	5	applied	\N	\N	\N	\N	143042	143042	310453
18468	25400	6	applied	\N	\N	\N	\N	143043	143043	310454
18471	25412	0	applied	\N	\N	\N	\N	143057	143057	310468
18471	25414	1	applied	\N	\N	\N	\N	143058	143058	310469
18471	25413	2	applied	\N	\N	\N	\N	143059	143059	310470
18475	25415	0	applied	\N	\N	\N	\N	143074	143074	310485
18475	25417	2	applied	\N	\N	\N	\N	143076	143076	310487
18475	25418	3	applied	\N	\N	\N	\N	143077	143077	310488
18475	25419	4	applied	\N	\N	\N	\N	143078	143078	310489
18475	25420	5	applied	\N	\N	\N	\N	143079	143079	310490
18475	25421	6	applied	\N	\N	\N	\N	143080	143080	310491
18475	25422	7	applied	\N	\N	\N	\N	143081	143081	310492
18478	25415	0	applied	\N	\N	\N	\N	143098	143098	310509
18478	25416	1	applied	\N	\N	\N	\N	143099	143099	310510
18478	25417	2	applied	\N	\N	\N	\N	143100	143100	310511
18478	25418	3	applied	\N	\N	\N	\N	143101	143101	310512
18478	25419	4	applied	\N	\N	\N	\N	143102	143102	310513
18478	25420	5	applied	\N	\N	\N	\N	143103	143103	310514
18478	25421	6	applied	\N	\N	\N	\N	143104	143104	310515
18478	25422	7	applied	\N	\N	\N	\N	143105	143105	310516
18481	25422	7	applied	\N	\N	\N	\N	143129	143129	310540
18482	25415	0	applied	\N	\N	\N	\N	143130	143130	310541
18482	25417	2	applied	\N	\N	\N	\N	143132	143132	310543
18482	25418	3	applied	\N	\N	\N	\N	143133	143133	310544
18482	25419	4	applied	\N	\N	\N	\N	143134	143134	310545
18482	25420	5	applied	\N	\N	\N	\N	143135	143135	310546
18482	25421	6	applied	\N	\N	\N	\N	143136	143136	310547
18482	25422	7	applied	\N	\N	\N	\N	143137	143137	310548
18485	25433	0	applied	\N	\N	\N	\N	143156	143156	310567
18485	25434	1	applied	\N	\N	\N	\N	143157	143157	310568
18485	25435	2	applied	\N	\N	\N	\N	143158	143158	310569
18485	25436	3	applied	\N	\N	\N	\N	143159	143159	310570
18485	25437	4	applied	\N	\N	\N	\N	143160	143160	310571
18485	25438	5	applied	\N	\N	\N	\N	143161	143161	310572
18485	25439	6	applied	\N	\N	\N	\N	143162	143162	310573
18485	25440	7	applied	\N	\N	\N	\N	143163	143163	310574
18486	25433	0	applied	\N	\N	\N	\N	143164	143164	310575
18486	25434	1	applied	\N	\N	\N	\N	143165	143165	310576
18486	25436	3	applied	\N	\N	\N	\N	143167	143167	310578
18486	25437	4	applied	\N	\N	\N	\N	143168	143168	310579
18486	25438	5	applied	\N	\N	\N	\N	143169	143169	310580
18486	25439	6	applied	\N	\N	\N	\N	143170	143170	310581
18486	25440	7	applied	\N	\N	\N	\N	143171	143171	310582
18487	25433	0	applied	\N	\N	\N	\N	143172	143172	310583
18487	25434	1	applied	\N	\N	\N	\N	143173	143173	310584
18487	25435	2	applied	\N	\N	\N	\N	143174	143174	310585
18487	25436	3	applied	\N	\N	\N	\N	143175	143175	310586
18487	25437	4	applied	\N	\N	\N	\N	143176	143176	310587
18487	25438	5	applied	\N	\N	\N	\N	143177	143177	310588
18487	25439	6	applied	\N	\N	\N	\N	143178	143178	310589
18487	25440	7	applied	\N	\N	\N	\N	143179	143179	310590
18490	25447	0	applied	\N	\N	\N	\N	143186	143186	310597
18490	25448	1	applied	\N	\N	\N	\N	143187	143187	310598
18490	25449	2	applied	\N	\N	\N	\N	143188	143188	310599
18492	25451	1	applied	\N	\N	\N	\N	143193	143193	310604
18492	25452	2	applied	\N	\N	\N	\N	143194	143194	310605
18492	25453	3	applied	\N	\N	\N	\N	143195	143195	310606
18494	25454	0	applied	\N	\N	\N	\N	143200	143200	310611
18495	25454	0	applied	\N	\N	\N	\N	143204	143204	310615
18495	25455	1	applied	\N	\N	1000000000	\N	143205	143205	310616
18495	25456	2	applied	\N	\N	\N	\N	143206	143206	310617
18495	25457	3	applied	\N	\N	\N	\N	143207	143207	310618
18497	25458	0	applied	\N	\N	\N	\N	143212	143212	310623
18497	25459	1	applied	\N	\N	\N	\N	143213	143213	310624
18497	25460	2	applied	\N	\N	\N	\N	143214	143214	310625
18497	25461	3	applied	\N	\N	\N	\N	143215	143215	310626
18504	25480	0	applied	\N	\N	\N	\N	143362	143362	310773
18504	25481	1	applied	\N	\N	\N	\N	143363	143363	310774
18504	25482	2	applied	\N	\N	\N	\N	143364	143364	310775
18511	25490	0	applied	\N	\N	\N	\N	143380	143380	310791
18511	25492	2	applied	\N	\N	\N	\N	143382	143382	310793
18513	25493	0	applied	\N	\N	\N	\N	143386	143386	143386
18513	25494	1	applied	\N	\N	\N	\N	143387	143387	310796
18513	25495	2	applied	\N	\N	\N	\N	143388	143388	310797
18515	25498	0	applied	\N	\N	\N	\N	143445	143445	310853
18515	25496	1	applied	\N	\N	1000000000	\N	143446	143446	310854
18515	25497	2	applied	\N	\N	\N	\N	143447	143447	310855
18515	25499	3	applied	\N	\N	\N	\N	143448	143448	310856
18515	25500	4	applied	\N	\N	\N	\N	143449	143449	310857
18518	25509	0	applied	\N	\N	\N	\N	143461	143461	310869
18518	25510	1	applied	\N	\N	\N	\N	143462	143462	310870
18518	25508	2	applied	\N	\N	\N	\N	143463	143463	310871
18527	25526	0	applied	\N	\N	\N	\N	143490	143490	310897
18527	25527	1	applied	\N	\N	\N	\N	143491	143491	310898
18527	25528	2	applied	\N	\N	\N	\N	143492	143492	310899
18530	25535	0	applied	\N	\N	\N	\N	143499	143499	310906
18453	25326	103	applied	\N	\N	\N	\N	142979	142979	310390
18453	25330	104	applied	\N	\N	\N	\N	142980	142980	310391
18499	25467	1	applied	\N	\N	\N	\N	143221	143221	310632
18499	25468	2	applied	\N	\N	\N	\N	143222	143222	310633
18499	25469	3	applied	\N	\N	\N	\N	143223	143223	310634
18499	25470	4	applied	\N	\N	\N	\N	143224	143224	310635
18499	25471	5	applied	\N	\N	\N	\N	143225	143225	310636
18499	25472	6	applied	\N	\N	\N	\N	143226	143226	310637
18501	25473	0	applied	\N	\N	\N	\N	143352	143352	310763
18501	25474	1	applied	\N	\N	\N	\N	143353	143353	310764
18501	25475	2	applied	\N	\N	\N	\N	143354	143354	310765
18503	25476	0	applied	\N	\N	\N	\N	143358	143358	310769
18503	25477	1	applied	\N	\N	\N	\N	143359	143359	310770
18503	25478	2	applied	\N	\N	\N	\N	143360	143360	310771
18503	25479	3	applied	\N	\N	\N	\N	143361	143361	310772
18506	25483	0	applied	\N	\N	\N	\N	143368	143368	310779
18506	25485	2	applied	\N	\N	\N	\N	143370	143370	310781
18506	25486	3	applied	\N	\N	\N	\N	143371	143371	310782
18506	25487	4	applied	\N	\N	\N	\N	143372	143372	310783
18506	25488	5	applied	\N	\N	\N	\N	143373	143373	310784
18506	25489	6	applied	\N	\N	\N	\N	143374	143374	310785
18522	25511	0	applied	\N	\N	\N	\N	143467	143467	310875
18522	25512	1	applied	\N	\N	\N	\N	143468	143468	310876
18522	25513	2	applied	\N	\N	\N	\N	143469	143469	310877
18522	25514	3	applied	\N	\N	\N	\N	143470	143470	310878
18522	25515	4	applied	\N	\N	\N	\N	143471	143471	310879
18522	25516	5	applied	\N	\N	\N	\N	143472	143472	310880
18522	25517	6	applied	\N	\N	\N	\N	143473	143473	310881
18525	25522	0	applied	\N	\N	\N	\N	143482	143482	310889
18525	25523	1	applied	\N	\N	\N	\N	143483	143483	310890
18525	25524	2	applied	\N	\N	\N	\N	143484	143484	310891
18525	25525	3	applied	\N	\N	\N	\N	143485	143485	310892
18529	25533	1	applied	\N	\N	\N	\N	143497	143497	310904
18529	25534	2	applied	\N	\N	\N	\N	143498	143498	310905
18530	25537	2	applied	\N	\N	\N	\N	143501	143501	310908
18533	25552	0	applied	\N	\N	\N	\N	143516	143516	310923
18533	25553	1	applied	\N	\N	\N	\N	143517	143517	310924
18533	25554	2	applied	\N	\N	\N	\N	143518	143518	310925
18535	25552	0	applied	\N	\N	\N	\N	143522	143522	310929
18535	25553	1	applied	\N	\N	\N	\N	143523	143523	310930
18535	25554	2	applied	\N	\N	\N	\N	143524	143524	310931
18537	25555	0	applied	\N	\N	\N	\N	143532	143532	310937
18537	25556	1	applied	\N	\N	\N	\N	143533	143533	310938
18537	25557	2	applied	\N	\N	\N	\N	143534	143534	310939
18537	25558	3	applied	\N	\N	\N	\N	143535	143535	310940
18537	25559	4	applied	\N	\N	\N	\N	143536	143536	310941
18537	25560	5	applied	\N	\N	\N	\N	143537	143537	310942
18537	25561	6	applied	\N	\N	\N	\N	143538	143538	310943
18538	25563	1	applied	\N	\N	\N	\N	143540	143540	310945
18538	25564	2	applied	\N	\N	\N	\N	143541	143541	310946
18540	25565	0	applied	\N	\N	\N	\N	143545	143545	310950
18540	25566	1	applied	\N	\N	\N	\N	143546	143546	310951
18540	25567	2	applied	\N	\N	\N	\N	143547	143547	310952
18542	25568	0	applied	\N	\N	\N	\N	143551	143551	310956
18542	25569	1	applied	\N	\N	\N	\N	143552	143552	310957
18542	25570	2	applied	\N	\N	\N	\N	143553	143553	310958
18542	25571	3	applied	\N	\N	\N	\N	143554	143554	310959
18545	25575	0	applied	\N	\N	\N	\N	143561	143561	310966
18545	25576	1	applied	\N	\N	\N	\N	143562	143562	310967
18545	25577	2	applied	\N	\N	\N	\N	143563	143563	310968
18547	25578	0	applied	\N	\N	\N	\N	143567	143567	310972
18547	25579	1	applied	\N	\N	\N	\N	143568	143568	310973
18547	25580	2	applied	\N	\N	\N	\N	143569	143569	310974
18547	25581	3	applied	\N	\N	\N	\N	143570	143570	310975
18549	25579	1	applied	\N	\N	\N	\N	143576	143576	310981
18549	25580	2	applied	\N	\N	\N	\N	143577	143577	310982
18549	25581	3	applied	\N	\N	\N	\N	143578	143578	310983
18552	25594	0	applied	\N	\N	\N	\N	143591	143591	310996
18552	25595	1	applied	\N	\N	\N	\N	143592	143592	310997
18552	25596	2	applied	\N	\N	\N	\N	143593	143593	310998
18552	25597	3	applied	\N	\N	\N	\N	143594	143594	310999
18555	25598	0	applied	\N	\N	\N	\N	143608	143608	311013
18555	25599	1	applied	\N	\N	\N	\N	143609	143609	311014
18555	25600	2	applied	\N	\N	\N	\N	143610	143610	311015
18555	25601	3	applied	\N	\N	\N	\N	143611	143611	311016
18555	25602	4	applied	\N	\N	\N	\N	143612	143612	311017
18555	25603	5	applied	\N	\N	\N	\N	143613	143613	311018
18555	25604	6	applied	\N	\N	\N	\N	143614	143614	311019
18555	25605	7	applied	\N	\N	\N	\N	143615	143615	311020
18555	25606	8	applied	\N	\N	\N	\N	143616	143616	311021
18555	25608	10	applied	\N	\N	\N	\N	143618	143618	311023
18555	25609	11	applied	\N	\N	\N	\N	143619	143619	311024
18555	25610	12	applied	\N	\N	\N	\N	143620	143620	311025
18558	25615	0	applied	\N	\N	\N	\N	143629	143629	311034
18558	25616	1	applied	\N	\N	\N	\N	143630	143630	311035
18558	25617	2	applied	\N	\N	\N	\N	143631	143631	311036
18558	25618	3	applied	\N	\N	\N	\N	143632	143632	311037
18560	25619	0	applied	\N	\N	\N	\N	143636	143636	311041
18560	25620	1	applied	\N	\N	\N	\N	143637	143637	311042
18560	25621	2	applied	\N	\N	\N	\N	143638	143638	311043
18563	25629	0	applied	\N	\N	\N	\N	143648	143648	311053
18563	25630	1	applied	\N	\N	\N	\N	143649	143649	311054
18563	25631	2	applied	\N	\N	\N	\N	143650	143650	311055
18563	25632	3	applied	\N	\N	\N	\N	143651	143651	311056
18563	25633	4	applied	\N	\N	\N	\N	143652	143652	311057
18565	25634	0	applied	\N	\N	\N	\N	143656	143656	311061
18565	25636	2	applied	\N	\N	\N	\N	143658	143658	311063
18565	25631	3	applied	\N	\N	\N	\N	143659	143659	311064
18565	25632	4	applied	\N	\N	\N	\N	143660	143660	311065
18565	25637	5	applied	\N	\N	\N	\N	143661	143661	311066
18565	25633	6	applied	\N	\N	\N	\N	143662	143662	311067
18566	25634	0	applied	\N	\N	\N	\N	143663	143663	311068
18567	25638	0	applied	\N	\N	\N	\N	143670	143670	311075
18567	25639	1	applied	\N	\N	\N	\N	143671	143671	311076
18576	25647	0	applied	\N	\N	\N	\N	143685	143685	311090
18578	25648	0	applied	\N	\N	\N	\N	143687	143687	311092
18578	25649	1	applied	\N	\N	\N	\N	143688	143688	311093
18581	25657	0	applied	\N	\N	1000000000	\N	143696	143696	311101
18581	25658	1	applied	\N	\N	\N	\N	143697	143697	311102
18581	25659	2	applied	\N	\N	\N	\N	143698	143698	311103
18581	25660	3	applied	\N	\N	\N	\N	143699	143699	311104
18494	25456	2	applied	\N	\N	\N	\N	143202	143202	310613
18499	25466	0	applied	\N	\N	\N	\N	143220	143220	310631
18500	25035	38	applied	\N	\N	\N	\N	143264	143264	310675
18500	25037	39	applied	\N	\N	\N	\N	143265	143265	310676
18500	25040	40	applied	\N	\N	\N	\N	143266	143266	310677
18500	25042	41	applied	\N	\N	\N	\N	143267	143267	310678
18500	25043	42	applied	\N	\N	\N	\N	143268	143268	310679
18500	25045	43	applied	\N	\N	\N	\N	143269	143269	310680
18500	25046	44	applied	\N	\N	\N	\N	143270	143270	310681
18500	25050	45	applied	\N	\N	\N	\N	143271	143271	310682
18500	25051	46	applied	\N	\N	\N	\N	143272	143272	310683
18500	25055	47	applied	\N	\N	\N	\N	143273	143273	310684
18500	25056	48	applied	\N	\N	\N	\N	143274	143274	310685
18500	25059	49	applied	\N	\N	\N	\N	143275	143275	310686
18500	25062	50	applied	\N	\N	\N	\N	143276	143276	310687
18500	25064	51	applied	\N	\N	\N	\N	143277	143277	310688
18500	25066	52	applied	\N	\N	\N	\N	143278	143278	310689
18500	25068	53	applied	\N	\N	\N	\N	143279	143279	310690
18500	25073	55	applied	\N	\N	\N	\N	143281	143281	310692
18500	25075	56	applied	\N	\N	\N	\N	143282	143282	310693
18500	25078	57	applied	\N	\N	\N	\N	143283	143283	310694
18500	25081	58	applied	\N	\N	\N	\N	143284	143284	310695
18500	25085	59	applied	\N	\N	\N	\N	143285	143285	310696
18500	25091	60	applied	\N	\N	\N	\N	143286	143286	310697
18500	25094	61	applied	\N	\N	\N	\N	143287	143287	310698
18500	25097	62	applied	\N	\N	\N	\N	143288	143288	310699
18500	25099	63	applied	\N	\N	\N	\N	143289	143289	310700
18500	25102	64	applied	\N	\N	\N	\N	143290	143290	310701
18500	25104	65	applied	\N	\N	\N	\N	143291	143291	310702
18500	25111	66	applied	\N	\N	\N	\N	143292	143292	310703
18500	25112	67	applied	\N	\N	\N	\N	143293	143293	310704
18500	25113	68	applied	\N	\N	\N	\N	143294	143294	310705
18500	25114	69	applied	\N	\N	\N	\N	143295	143295	310706
18500	25115	70	applied	\N	\N	\N	\N	143296	143296	310707
18500	25128	72	applied	\N	\N	\N	\N	143298	143298	310709
18500	25135	73	applied	\N	\N	\N	\N	143299	143299	310710
18500	25136	74	applied	\N	\N	\N	\N	143300	143300	310711
18500	25140	75	applied	\N	\N	\N	\N	143301	143301	310712
18500	25142	76	applied	\N	\N	\N	\N	143302	143302	310713
18500	25144	77	applied	\N	\N	\N	\N	143303	143303	310714
18500	25146	78	applied	\N	\N	\N	\N	143304	143304	310715
18500	25150	79	applied	\N	\N	\N	\N	143305	143305	310716
18500	25151	80	applied	\N	\N	\N	\N	143306	143306	310717
18500	25152	81	applied	\N	\N	\N	\N	143307	143307	310718
18500	25155	82	applied	\N	\N	\N	\N	143308	143308	310719
18500	25156	83	applied	\N	\N	\N	\N	143309	143309	310720
18500	25160	84	applied	\N	\N	\N	\N	143310	143310	310721
18500	25162	85	applied	\N	\N	\N	\N	143311	143311	310722
18500	25163	86	applied	\N	\N	\N	\N	143312	143312	310723
18500	25167	87	applied	\N	\N	\N	\N	143313	143313	310724
18500	25170	89	applied	\N	\N	\N	\N	143315	143315	310726
18500	25171	90	applied	\N	\N	\N	\N	143316	143316	310727
18500	25175	91	applied	\N	\N	\N	\N	143317	143317	310728
18500	25177	92	applied	\N	\N	\N	\N	143318	143318	310729
18500	25178	93	applied	\N	\N	\N	\N	143319	143319	310730
18500	25179	94	applied	\N	\N	\N	\N	143320	143320	310731
18500	25186	95	applied	\N	\N	\N	\N	143321	143321	310732
18500	25188	96	applied	\N	\N	\N	\N	143322	143322	310733
18500	25193	97	applied	\N	\N	\N	\N	143323	143323	310734
18500	25194	98	applied	\N	\N	\N	\N	143324	143324	310735
18500	25195	99	applied	\N	\N	\N	\N	143325	143325	310736
18500	25200	100	applied	\N	\N	\N	\N	143326	143326	310737
18500	25207	101	applied	\N	\N	\N	\N	143327	143327	310738
18500	25209	102	applied	\N	\N	\N	\N	143328	143328	310739
18500	25210	103	applied	\N	\N	\N	\N	143329	143329	310740
18500	25214	104	applied	\N	\N	\N	\N	143330	143330	310741
18500	25218	106	applied	\N	\N	\N	\N	143332	143332	310743
18500	25221	107	applied	\N	\N	\N	\N	143333	143333	310744
18500	25222	108	applied	\N	\N	\N	\N	143334	143334	310745
18500	25225	109	applied	\N	\N	\N	\N	143335	143335	310746
18500	25227	110	applied	\N	\N	\N	\N	143336	143336	310747
18500	25229	111	applied	\N	\N	\N	\N	143337	143337	310748
18500	25231	112	applied	\N	\N	\N	\N	143338	143338	310749
18500	25232	113	applied	\N	\N	\N	\N	143339	143339	310750
18500	25236	114	applied	\N	\N	\N	\N	143340	143340	310751
18500	25238	115	applied	\N	\N	\N	\N	143341	143341	310752
18500	25239	116	applied	\N	\N	\N	\N	143342	143342	310753
18500	25243	117	applied	\N	\N	\N	\N	143343	143343	310754
18500	25245	118	applied	\N	\N	\N	\N	143344	143344	310755
18500	25247	119	applied	\N	\N	\N	\N	143345	143345	310756
18500	25249	120	applied	\N	\N	\N	\N	143346	143346	310757
18500	25252	121	applied	\N	\N	\N	\N	143347	143347	310758
18500	25256	123	applied	\N	\N	\N	\N	143349	143349	310760
18500	25257	124	applied	\N	\N	\N	\N	143350	143350	310761
18500	25261	125	applied	\N	\N	\N	\N	143351	143351	310762
18502	25473	0	applied	\N	\N	\N	\N	143355	143355	310766
18502	25474	1	applied	\N	\N	\N	\N	143356	143356	310767
18502	25475	2	applied	\N	\N	\N	\N	143357	143357	310768
18505	25480	0	applied	\N	\N	\N	\N	143365	143365	310776
18505	25481	1	applied	\N	\N	\N	\N	143366	143366	310777
18505	25482	2	applied	\N	\N	\N	\N	143367	143367	310778
18582	25661	0	applied	\N	\N	\N	\N	143700	143700	311105
18582	25662	1	applied	\N	\N	\N	\N	143701	143701	311106
18582	25663	2	applied	\N	\N	\N	\N	143702	143702	311107
18582	25664	3	applied	\N	\N	\N	\N	143703	143703	311108
18582	25665	4	applied	\N	\N	\N	\N	143704	143704	311109
18582	25666	5	applied	\N	\N	\N	\N	143705	143705	311110
18582	25667	6	applied	\N	\N	\N	\N	143706	143706	311111
18592	25683	1	applied	\N	\N	\N	\N	143738	143738	311143
18592	25684	2	applied	\N	\N	\N	\N	143739	143739	311144
18592	25685	4	applied	\N	\N	\N	\N	143740	143740	311145
18592	25686	5	applied	\N	\N	\N	\N	143741	143741	311146
18597	25682	0	applied	\N	\N	\N	\N	143762	143762	311167
18597	25683	1	applied	\N	\N	\N	\N	143763	143763	311168
18597	25684	2	applied	\N	\N	\N	\N	143764	143764	311169
18597	25685	4	applied	\N	\N	\N	\N	143765	143765	311170
18597	25686	5	applied	\N	\N	\N	\N	143766	143766	311171
18600	25687	0	applied	\N	\N	\N	\N	143773	143773	311178
18600	25688	1	applied	\N	\N	\N	\N	143774	143774	311179
18605	25695	0	applied	\N	\N	\N	\N	143783	143783	311188
18605	25696	1	applied	\N	\N	\N	\N	143784	143784	311189
18608	25697	0	applied	\N	\N	\N	\N	143789	143789	311194
18500	25028	35	applied	\N	\N	\N	\N	143261	143261	310672
18500	25030	36	applied	\N	\N	\N	\N	143262	143262	310673
18514	25383	21	applied	\N	\N	\N	\N	143410	143410	310818
18514	25388	22	applied	\N	\N	\N	\N	143411	143411	310819
18514	25390	23	applied	\N	\N	\N	\N	143412	143412	310820
18514	25393	24	applied	\N	\N	\N	\N	143413	143413	310821
18514	25399	25	applied	\N	\N	\N	\N	143414	143414	310822
18514	25400	26	applied	\N	\N	\N	\N	143415	143415	310823
18514	25405	27	applied	\N	\N	\N	\N	143416	143416	310824
18514	25409	28	applied	\N	\N	\N	\N	143417	143417	310825
18514	25410	29	applied	\N	\N	\N	\N	143418	143418	310826
18514	25414	30	applied	\N	\N	\N	\N	143419	143419	310827
18514	25417	31	applied	\N	\N	\N	\N	143420	143420	310828
18514	25421	32	applied	\N	\N	\N	\N	143421	143421	310829
18514	25434	33	applied	\N	\N	\N	\N	143422	143422	310830
18514	25436	34	applied	\N	\N	\N	\N	143423	143423	310831
18514	25438	36	applied	\N	\N	\N	\N	143425	143425	310833
18514	25439	37	applied	\N	\N	\N	\N	143426	143426	310834
18514	25440	38	applied	\N	\N	\N	\N	143427	143427	310835
18514	25443	39	applied	\N	\N	\N	\N	143428	143428	310836
18514	25446	40	applied	\N	\N	\N	\N	143429	143429	310837
18514	25449	41	applied	\N	\N	\N	\N	143430	143430	310838
18514	25451	42	applied	\N	\N	\N	\N	143431	143431	310839
18514	25457	43	applied	\N	\N	\N	\N	143432	143432	310840
18514	25461	44	applied	\N	\N	\N	\N	143433	143433	310841
18514	25463	45	applied	\N	\N	\N	\N	143434	143434	310842
18514	25469	46	applied	\N	\N	\N	\N	143435	143435	310843
18514	25470	47	applied	\N	\N	\N	\N	143436	143436	310844
18514	25475	48	applied	\N	\N	\N	\N	143437	143437	310845
18514	25477	49	applied	\N	\N	\N	\N	143438	143438	310846
18514	25482	50	applied	\N	\N	\N	\N	143439	143439	310847
18514	25486	51	applied	\N	\N	\N	\N	143440	143440	310848
18514	25491	53	applied	\N	\N	\N	\N	143442	143442	310850
18514	25495	54	applied	\N	\N	\N	\N	143443	143443	310851
18514	25497	55	applied	\N	\N	\N	\N	143444	143444	310852
18516	25501	0	applied	\N	\N	\N	\N	143450	143450	310858
18516	25502	1	applied	\N	\N	\N	\N	143451	143451	310859
18516	25503	2	applied	\N	\N	\N	\N	143452	143452	310860
18516	25504	3	applied	\N	\N	\N	\N	143453	143453	310861
18516	25505	4	applied	\N	\N	\N	\N	143454	143454	310862
18516	25506	5	applied	\N	\N	\N	\N	143455	143455	310863
18516	25507	6	applied	\N	\N	\N	\N	143456	143456	310864
18517	25503	0	applied	\N	\N	\N	\N	143457	143457	310865
18517	25506	1	applied	\N	\N	\N	\N	143458	143458	310866
18517	25507	2	applied	\N	\N	\N	\N	143459	143459	310867
18517	25508	3	applied	\N	\N	\N	\N	143460	143460	310868
18519	25509	0	applied	\N	\N	\N	\N	143464	143464	310872
18519	25510	1	applied	\N	\N	\N	\N	143465	143465	310873
18523	25518	0	applied	\N	\N	\N	\N	143474	143474	143474
18523	25519	1	applied	\N	\N	\N	\N	143475	143475	310882
18523	25520	2	applied	\N	\N	\N	\N	143476	143476	310883
18523	25521	3	applied	\N	\N	\N	\N	143477	143477	310884
18524	25522	0	applied	\N	\N	\N	\N	143478	143478	310885
18524	25523	1	applied	\N	\N	\N	\N	143479	143479	310886
18524	25524	2	applied	\N	\N	\N	\N	143480	143480	310887
18524	25525	3	applied	\N	\N	\N	\N	143481	143481	310888
18526	25522	0	applied	\N	\N	\N	\N	143486	143486	310893
18526	25523	1	applied	\N	\N	\N	\N	143487	143487	310894
18526	25524	2	applied	\N	\N	\N	\N	143488	143488	310895
18526	25525	3	applied	\N	\N	\N	\N	143489	143489	310896
18528	25529	0	applied	\N	\N	\N	\N	143493	143493	310900
18528	25530	1	applied	\N	\N	\N	\N	143494	143494	310901
18528	25531	2	applied	\N	\N	\N	\N	143495	143495	310902
18531	25539	1	applied	\N	\N	\N	\N	143503	143503	310910
18532	25545	0	applied	\N	\N	\N	\N	143509	143509	310916
18532	25546	1	applied	\N	\N	\N	\N	143510	143510	310917
18532	25547	2	applied	\N	\N	\N	\N	143511	143511	310918
18532	25548	3	applied	\N	\N	\N	\N	143512	143512	310919
18532	25549	4	applied	\N	\N	\N	\N	143513	143513	310920
18532	25550	5	applied	\N	\N	\N	\N	143514	143514	310921
18532	25551	6	applied	\N	\N	\N	\N	143515	143515	310922
18534	25552	0	applied	\N	\N	\N	\N	143519	143519	310926
18534	25553	1	applied	\N	\N	\N	\N	143520	143520	310927
18534	25554	2	applied	\N	\N	\N	\N	143521	143521	310928
18539	25565	0	applied	\N	\N	\N	\N	143542	143542	310947
18539	25566	1	applied	\N	\N	\N	\N	143543	143543	310948
18539	25567	2	applied	\N	\N	\N	\N	143544	143544	310949
18544	25575	0	applied	\N	\N	\N	\N	143558	143558	310963
18544	25576	1	applied	\N	\N	\N	\N	143559	143559	310964
18544	25577	2	applied	\N	\N	\N	\N	143560	143560	310965
18548	25578	0	applied	\N	\N	\N	\N	143571	143571	310976
18548	25579	1	applied	\N	\N	\N	\N	143572	143572	310977
18548	25581	3	applied	\N	\N	\N	\N	143574	143574	310979
18551	25584	0	applied	\N	\N	\N	\N	143581	143581	310986
18551	25585	1	applied	\N	\N	\N	\N	143582	143582	310987
18551	25586	2	applied	\N	\N	\N	\N	143583	143583	310988
18551	25587	3	applied	\N	\N	\N	\N	143584	143584	310989
18551	25588	4	applied	\N	\N	\N	\N	143585	143585	310990
18551	25589	5	applied	\N	\N	\N	\N	143586	143586	310991
18551	25590	6	applied	\N	\N	\N	\N	143587	143587	310992
18551	25591	7	applied	\N	\N	\N	\N	143588	143588	310993
18551	25592	8	applied	\N	\N	\N	\N	143589	143589	310994
18551	25593	9	applied	\N	\N	\N	\N	143590	143590	310995
18557	25615	0	applied	\N	\N	\N	\N	143625	143625	311030
18557	25616	1	applied	\N	\N	\N	\N	143626	143626	311031
18557	25617	2	applied	\N	\N	\N	\N	143627	143627	311032
18557	25618	3	applied	\N	\N	\N	\N	143628	143628	311033
18559	25619	0	applied	\N	\N	\N	\N	143633	143633	311038
18559	25621	2	applied	\N	\N	\N	\N	143635	143635	311040
18562	25629	0	applied	\N	\N	\N	\N	143646	143646	311051
18562	25630	1	applied	\N	\N	\N	\N	143647	143647	311052
18569	25640	0	applied	\N	\N	\N	\N	143674	143674	311079
18569	25641	1	applied	\N	\N	\N	\N	143675	143675	311080
18569	25642	2	applied	\N	\N	\N	\N	143676	143676	311081
18571	25643	0	applied	\N	\N	\N	\N	143677	143677	311082
18571	25644	1	applied	\N	\N	\N	\N	143678	143678	311083
18571	25645	2	applied	\N	\N	\N	\N	143679	143679	311084
18571	25646	3	applied	\N	\N	\N	\N	143680	143680	311085
18585	25668	0	applied	\N	\N	\N	\N	143715	143715	311120
18585	25669	1	applied	\N	\N	\N	\N	143716	143716	311121
18585	25670	2	applied	\N	\N	\N	\N	143717	143717	311122
18585	25671	3	applied	\N	\N	\N	\N	143718	143718	311123
18509	25492	2	applied	\N	\N	\N	\N	143377	143377	310788
18514	25380	20	applied	\N	\N	\N	\N	143409	143409	310817
18531	25543	5	applied	\N	\N	\N	\N	143507	143507	310914
18531	25544	6	applied	\N	\N	\N	\N	143508	143508	310915
18536	25518	0	applied	\N	\N	\N	\N	143525	143525	143525
18536	25493	2	applied	\N	\N	\N	\N	143527	143527	143527
18536	25404	3	applied	\N	\N	1000000000	\N	143528	143528	310933
18536	25455	4	applied	\N	\N	1000000000	\N	143529	143529	310934
18536	25496	5	applied	\N	\N	1000000000	\N	143530	143530	310935
18536	25459	6	applied	\N	\N	\N	\N	143531	143531	310936
18541	25565	0	applied	\N	\N	\N	\N	143548	143548	310953
18541	25566	1	applied	\N	\N	\N	\N	143549	143549	310954
18541	25567	2	applied	\N	\N	\N	\N	143550	143550	310955
18543	25572	0	applied	\N	\N	\N	\N	143555	143555	310960
18543	25573	1	applied	\N	\N	\N	\N	143556	143556	310961
18543	25574	2	applied	\N	\N	\N	\N	143557	143557	310962
18546	25575	0	applied	\N	\N	\N	\N	143564	143564	310969
18546	25576	1	applied	\N	\N	\N	\N	143565	143565	310970
18546	25577	2	applied	\N	\N	\N	\N	143566	143566	310971
18550	25582	0	applied	\N	\N	\N	\N	143579	143579	310984
18550	25583	1	applied	\N	\N	\N	\N	143580	143580	310985
18554	25598	0	applied	\N	\N	\N	\N	143595	143595	311000
18554	25599	1	applied	\N	\N	\N	\N	143596	143596	311001
18554	25600	2	applied	\N	\N	\N	\N	143597	143597	311002
18554	25601	3	applied	\N	\N	\N	\N	143598	143598	311003
18554	25603	5	applied	\N	\N	\N	\N	143600	143600	311005
18554	25604	6	applied	\N	\N	\N	\N	143601	143601	311006
18554	25605	7	applied	\N	\N	\N	\N	143602	143602	311007
18554	25606	8	applied	\N	\N	\N	\N	143603	143603	311008
18554	25607	9	applied	\N	\N	\N	\N	143604	143604	311009
18554	25608	10	applied	\N	\N	\N	\N	143605	143605	311010
18554	25609	11	applied	\N	\N	\N	\N	143606	143606	311011
18554	25610	12	applied	\N	\N	\N	\N	143607	143607	311012
18556	25611	0	applied	\N	\N	\N	\N	143621	143621	311026
18556	25612	1	applied	\N	\N	\N	\N	143622	143622	311027
18556	25613	2	applied	\N	\N	\N	\N	143623	143623	311028
18556	25614	3	applied	\N	\N	\N	\N	143624	143624	311029
18561	25622	0	applied	\N	\N	\N	\N	143639	143639	311044
18561	25623	1	applied	\N	\N	\N	\N	143640	143640	311045
18561	25624	2	applied	\N	\N	\N	\N	143641	143641	311046
18561	25625	3	applied	\N	\N	\N	\N	143642	143642	311047
18561	25627	5	applied	\N	\N	\N	\N	143644	143644	311049
18561	25628	6	applied	\N	\N	\N	\N	143645	143645	311050
18564	25634	0	applied	\N	\N	\N	\N	143653	143653	311058
18564	25635	1	applied	\N	\N	\N	\N	143654	143654	311059
18564	25636	2	applied	\N	\N	\N	\N	143655	143655	311060
18580	25655	0	applied	\N	\N	\N	\N	143694	143694	311099
18580	25656	1	applied	\N	\N	\N	\N	143695	143695	311100
18584	25668	0	applied	\N	\N	\N	\N	143711	143711	311116
18584	25669	1	applied	\N	\N	\N	\N	143712	143712	311117
18584	25670	2	applied	\N	\N	\N	\N	143713	143713	311118
18584	25671	3	applied	\N	\N	\N	\N	143714	143714	311119
18586	25668	0	applied	\N	\N	\N	\N	143719	143719	311124
18586	25669	1	applied	\N	\N	\N	\N	143720	143720	311125
18586	25670	2	applied	\N	\N	\N	\N	143721	143721	311126
18586	25671	3	applied	\N	\N	\N	\N	143722	143722	311127
18588	25675	1	applied	\N	\N	\N	\N	143726	143726	311131
18588	25676	2	applied	\N	\N	\N	\N	143727	143727	311132
18588	25677	3	applied	\N	\N	\N	\N	143728	143728	311133
18588	25678	4	applied	\N	\N	\N	\N	143729	143729	311134
18588	25679	5	applied	\N	\N	\N	\N	143730	143730	311135
18589	25680	0	applied	\N	\N	\N	\N	143731	143731	311136
18589	25681	1	applied	\N	\N	\N	\N	143732	143732	311137
18591	25680	0	applied	\N	\N	\N	\N	143735	143735	311140
18591	25681	1	applied	\N	\N	\N	\N	143736	143736	311141
18594	25682	0	applied	\N	\N	\N	\N	143747	143747	311152
18594	25683	1	applied	\N	\N	\N	\N	143748	143748	311153
18594	25684	2	applied	\N	\N	\N	\N	143749	143749	311154
18594	25685	4	applied	\N	\N	\N	\N	143750	143750	311155
18594	25686	5	applied	\N	\N	\N	\N	143751	143751	311156
18595	25682	0	applied	\N	\N	\N	\N	143752	143752	311157
18595	25683	1	applied	\N	\N	\N	\N	143753	143753	311158
18595	25684	2	applied	\N	\N	\N	\N	143754	143754	311159
18595	25685	4	applied	\N	\N	\N	\N	143755	143755	311160
18595	25686	5	applied	\N	\N	\N	\N	143756	143756	311161
18596	25683	1	applied	\N	\N	\N	\N	143758	143758	311163
18596	25684	2	applied	\N	\N	\N	\N	143759	143759	311164
18596	25685	4	applied	\N	\N	\N	\N	143760	143760	311165
18596	25686	5	applied	\N	\N	\N	\N	143761	143761	311166
18598	25682	0	applied	\N	\N	\N	\N	143767	143767	311172
18598	25683	1	applied	\N	\N	\N	\N	143768	143768	311173
18598	25684	2	applied	\N	\N	\N	\N	143769	143769	311174
18598	25685	4	applied	\N	\N	\N	\N	143770	143770	311175
18598	25686	5	applied	\N	\N	\N	\N	143771	143771	311176
18599	25684	0	applied	\N	\N	\N	\N	143772	143772	311177
18602	25689	0	applied	\N	\N	\N	\N	143777	143777	311182
18602	25690	1	applied	\N	\N	\N	\N	143778	143778	311183
18604	25692	0	applied	\N	\N	\N	\N	143780	143780	311185
18604	25693	1	applied	\N	\N	\N	\N	143781	143781	311186
18604	25694	2	applied	\N	\N	\N	\N	143782	143782	311187
18606	25695	0	applied	\N	\N	\N	\N	143785	143785	311190
18607	25697	0	applied	\N	\N	\N	\N	143787	143787	311192
18607	25698	1	applied	\N	\N	\N	\N	143788	143788	311193
18609	25697	0	applied	\N	\N	\N	\N	143791	143791	311196
18609	25698	1	applied	\N	\N	\N	\N	143792	143792	311197
18611	25699	0	applied	\N	\N	\N	\N	143795	143795	311200
18611	25700	1	applied	\N	\N	\N	\N	143796	143796	311201
18611	25701	2	applied	\N	\N	\N	\N	143797	143797	311202
18613	25702	0	applied	\N	\N	1000000000	\N	143801	143801	311206
18617	25721	0	applied	\N	\N	\N	\N	143838	143838	311243
18624	25729	0	applied	\N	\N	\N	\N	143854	143854	311259
18624	25730	1	applied	\N	\N	\N	\N	143855	143855	311260
18624	25731	2	applied	\N	\N	\N	\N	143856	143856	311261
18627	25739	0	applied	\N	\N	\N	\N	143864	143864	311269
18627	25740	1	applied	\N	\N	\N	\N	143865	143865	311270
18627	25741	2	applied	\N	\N	\N	\N	143866	143866	311271
18627	25742	3	applied	\N	\N	\N	\N	143867	143867	311272
18638	25768	0	applied	\N	\N	\N	\N	143918	143918	311323
18638	25769	1	applied	\N	\N	\N	\N	143919	143919	311324
18638	25770	2	applied	\N	\N	\N	\N	143920	143920	311325
18638	25771	3	applied	\N	\N	\N	\N	143921	143921	311326
18531	25541	3	applied	\N	\N	\N	\N	143505	143505	310912
18531	25542	4	applied	\N	\N	\N	\N	143506	143506	310913
18566	25632	4	applied	\N	\N	\N	\N	143667	143667	311072
18566	25637	5	applied	\N	\N	\N	\N	143668	143668	311073
18566	25633	6	applied	\N	\N	\N	\N	143669	143669	311074
18568	25638	0	applied	\N	\N	\N	\N	143672	143672	311077
18568	25639	1	applied	\N	\N	\N	\N	143673	143673	311078
18572	25643	0	applied	\N	\N	\N	\N	143681	143681	311086
18572	25644	1	applied	\N	\N	\N	\N	143682	143682	311087
18572	25645	2	applied	\N	\N	\N	\N	143683	143683	311088
18572	25646	3	applied	\N	\N	\N	\N	143684	143684	311089
18577	25647	0	applied	\N	\N	\N	\N	143686	143686	311091
18579	25650	0	applied	\N	\N	\N	\N	143689	143689	311094
18579	25651	1	applied	\N	\N	\N	\N	143690	143690	311095
18579	25652	2	applied	\N	\N	\N	\N	143691	143691	311096
18579	25654	4	applied	\N	\N	\N	\N	143693	143693	311098
18583	25668	0	applied	\N	\N	\N	\N	143707	143707	311112
18583	25669	1	applied	\N	\N	\N	\N	143708	143708	311113
18583	25670	2	applied	\N	\N	\N	\N	143709	143709	311114
18583	25671	3	applied	\N	\N	\N	\N	143710	143710	311115
18587	25672	0	applied	\N	\N	\N	\N	143723	143723	311128
18587	25673	1	applied	\N	\N	\N	\N	143724	143724	311129
18590	25680	0	applied	\N	\N	\N	\N	143733	143733	311138
18590	25681	1	applied	\N	\N	\N	\N	143734	143734	311139
18593	25682	0	applied	\N	\N	\N	\N	143742	143742	311147
18593	25683	1	applied	\N	\N	\N	\N	143743	143743	311148
18593	25684	2	applied	\N	\N	\N	\N	143744	143744	311149
18593	25685	4	applied	\N	\N	\N	\N	143745	143745	311150
18593	25686	5	applied	\N	\N	\N	\N	143746	143746	311151
18601	25687	0	applied	\N	\N	\N	\N	143775	143775	311180
18601	25688	1	applied	\N	\N	\N	\N	143776	143776	311181
18610	25697	0	applied	\N	\N	\N	\N	143793	143793	311198
18610	25698	1	applied	\N	\N	\N	\N	143794	143794	311199
18612	25699	0	applied	\N	\N	\N	\N	143798	143798	311203
18612	25700	1	applied	\N	\N	\N	\N	143799	143799	311204
18612	25701	2	applied	\N	\N	\N	\N	143800	143800	311205
18614	25702	0	applied	\N	\N	1000000000	\N	143818	143818	311223
18614	25703	1	applied	\N	\N	\N	\N	143819	143819	311224
18614	25704	2	applied	\N	\N	\N	\N	143820	143820	311225
18614	25705	3	applied	\N	\N	\N	\N	143821	143821	311226
18614	25706	4	applied	\N	\N	\N	\N	143822	143822	311227
18614	25707	5	applied	\N	\N	\N	\N	143823	143823	311228
18614	25708	6	applied	\N	\N	\N	\N	143824	143824	311229
18614	25709	7	applied	\N	\N	\N	\N	143825	143825	311230
18614	25710	8	applied	\N	\N	\N	\N	143826	143826	311231
18614	25711	9	applied	\N	\N	\N	\N	143827	143827	311232
18614	25712	10	applied	\N	\N	\N	\N	143828	143828	311233
18614	25714	12	applied	\N	\N	\N	\N	143830	143830	311235
18614	25715	13	applied	\N	\N	\N	\N	143831	143831	311236
18614	25716	14	applied	\N	\N	\N	\N	143832	143832	311237
18614	25717	15	applied	\N	\N	\N	\N	143833	143833	311238
18614	25718	16	applied	\N	\N	\N	\N	143834	143834	311239
18619	25722	0	applied	\N	\N	\N	\N	143841	143841	311246
18619	25723	1	applied	\N	\N	\N	\N	143842	143842	311247
18621	25724	0	applied	\N	\N	\N	\N	143846	143846	311251
18621	25725	1	applied	\N	\N	\N	\N	143847	143847	311252
18621	25726	2	applied	\N	\N	\N	\N	143848	143848	311253
18626	25737	0	applied	\N	\N	\N	\N	143862	143862	311267
18626	25738	1	applied	\N	\N	\N	\N	143863	143863	311268
18629	25739	0	applied	\N	\N	\N	\N	143874	143874	311279
18629	25740	1	applied	\N	\N	\N	\N	143875	143875	311280
18629	25741	2	applied	\N	\N	\N	\N	143876	143876	311281
18629	25742	3	applied	\N	\N	\N	\N	143877	143877	311282
18634	25753	0	applied	\N	\N	\N	\N	143898	143898	311303
18634	25754	1	applied	\N	\N	\N	\N	143899	143899	311304
18634	25755	2	applied	\N	\N	\N	\N	143900	143900	311305
18634	25756	3	applied	\N	\N	\N	\N	143901	143901	311306
18634	25757	4	applied	\N	\N	\N	\N	143902	143902	311307
18637	25760	0	applied	\N	\N	\N	\N	143910	143910	311315
18637	25761	1	applied	\N	\N	\N	\N	143911	143911	311316
18637	25762	2	applied	\N	\N	\N	\N	143912	143912	311317
18637	25763	3	applied	\N	\N	\N	\N	143913	143913	311318
18637	25764	4	applied	\N	\N	\N	\N	143914	143914	311319
18637	25765	5	applied	\N	\N	\N	\N	143915	143915	311320
18637	25766	6	applied	\N	\N	1000000000	\N	143916	143916	311321
18637	25767	7	applied	\N	\N	\N	\N	143917	143917	311322
18640	25772	0	applied	\N	\N	\N	\N	143926	143926	311331
18640	25773	1	applied	\N	\N	\N	\N	143927	143927	311332
18640	25774	2	applied	\N	\N	\N	\N	143928	143928	311333
18640	25776	4	applied	\N	\N	\N	\N	143930	143930	311335
18640	25777	5	applied	\N	\N	\N	\N	143931	143931	311336
18640	25778	6	applied	\N	\N	\N	\N	143932	143932	311337
18642	25779	0	applied	\N	\N	\N	\N	143940	143940	311345
18642	25780	1	applied	\N	\N	\N	\N	143941	143941	311346
18643	25779	0	applied	\N	\N	\N	\N	143942	143942	311347
18643	25780	1	applied	\N	\N	\N	\N	143943	143943	311348
18645	25779	0	applied	\N	\N	\N	\N	143946	143946	311351
18645	25780	1	applied	\N	\N	\N	\N	143947	143947	311352
18647	25781	0	applied	\N	\N	\N	\N	143950	143950	311355
18647	25782	1	applied	\N	\N	\N	\N	143951	143951	311356
18647	25783	2	applied	\N	\N	\N	\N	143952	143952	311357
18647	25784	3	applied	\N	\N	\N	\N	143953	143953	311358
18647	25785	4	applied	\N	\N	\N	\N	143954	143954	311359
18649	25786	0	applied	\N	\N	\N	\N	143960	143960	311365
18649	25787	1	applied	\N	\N	\N	\N	143961	143961	311366
18651	25788	1	applied	\N	\N	\N	\N	143964	143964	311369
18652	25789	0	applied	\N	\N	\N	\N	143965	143965	311370
18652	25790	1	applied	\N	\N	\N	\N	143966	143966	311371
18652	25791	2	applied	\N	\N	\N	\N	143967	143967	311372
18655	25796	0	applied	\N	\N	\N	\N	143976	143976	311381
18655	25797	1	applied	\N	\N	\N	\N	143977	143977	311382
18655	25798	2	applied	\N	\N	\N	\N	143978	143978	311383
18655	25799	3	applied	\N	\N	\N	\N	143979	143979	311384
18655	25800	4	applied	\N	\N	\N	\N	143980	143980	311385
18655	25801	5	applied	\N	\N	\N	\N	143981	143981	311386
18657	25796	0	applied	\N	\N	\N	\N	143988	143988	311393
18657	25797	1	applied	\N	\N	\N	\N	143989	143989	311394
18657	25798	2	applied	\N	\N	\N	\N	143990	143990	311395
18658	25796	0	applied	\N	\N	\N	\N	143994	143994	311399
18658	25797	1	applied	\N	\N	\N	\N	143995	143995	311400
18658	25798	2	applied	\N	\N	\N	\N	143996	143996	311401
18566	25636	2	applied	\N	\N	\N	\N	143665	143665	311070
18566	25631	3	applied	\N	\N	\N	\N	143666	143666	311071
18618	25723	1	applied	\N	\N	\N	\N	143840	143840	311245
18623	25729	0	applied	\N	\N	\N	\N	143851	143851	311256
18623	25730	1	applied	\N	\N	\N	\N	143852	143852	311257
18628	25739	0	applied	\N	\N	\N	\N	143869	143869	311274
18628	25740	1	applied	\N	\N	\N	\N	143870	143870	311275
18628	25741	2	applied	\N	\N	\N	\N	143871	143871	311276
18628	25742	3	applied	\N	\N	\N	\N	143872	143872	311277
18628	25743	4	applied	\N	\N	\N	\N	143873	143873	311278
18631	25744	0	applied	\N	\N	\N	\N	143884	143884	311289
18631	25745	1	applied	\N	\N	\N	\N	143885	143885	311290
18631	25746	2	applied	\N	\N	\N	\N	143886	143886	311291
18631	25747	3	applied	\N	\N	\N	\N	143887	143887	311292
18631	25748	4	applied	\N	\N	\N	\N	143888	143888	311293
18633	25749	0	applied	\N	\N	\N	\N	143894	143894	311299
18633	25750	1	applied	\N	\N	\N	\N	143895	143895	311300
18633	25751	2	applied	\N	\N	\N	\N	143896	143896	311301
18633	25752	3	applied	\N	\N	\N	\N	143897	143897	311302
18636	25758	0	applied	\N	\N	\N	\N	143908	143908	311313
18636	25759	1	applied	\N	\N	\N	\N	143909	143909	311314
18639	25769	1	applied	\N	\N	\N	\N	143923	143923	311328
18639	25770	2	applied	\N	\N	\N	\N	143924	143924	311329
18639	25771	3	applied	\N	\N	\N	\N	143925	143925	311330
18648	25781	0	applied	\N	\N	\N	\N	143955	143955	311360
18648	25782	1	applied	\N	\N	\N	\N	143956	143956	311361
18648	25783	2	applied	\N	\N	\N	\N	143957	143957	311362
18648	25784	3	applied	\N	\N	\N	\N	143958	143958	311363
18648	25785	4	applied	\N	\N	\N	\N	143959	143959	311364
18654	25792	0	applied	\N	\N	\N	\N	143972	143972	311377
18654	25793	1	applied	\N	\N	\N	\N	143973	143973	311378
18654	25794	2	applied	\N	\N	\N	\N	143974	143974	311379
18654	25795	3	applied	\N	\N	\N	\N	143975	143975	311380
18657	25799	3	applied	\N	\N	\N	\N	143991	143991	311396
18657	25800	4	applied	\N	\N	\N	\N	143992	143992	311397
18657	25801	5	applied	\N	\N	\N	\N	143993	143993	311398
18660	25802	0	applied	\N	\N	\N	\N	144006	144006	311411
18660	25804	2	applied	\N	\N	\N	\N	144008	144008	311413
18661	25805	0	applied	\N	\N	\N	\N	144009	144009	311414
18661	25806	1	applied	\N	\N	\N	\N	144010	144010	311415
18661	25807	2	applied	\N	\N	\N	\N	144011	144011	311416
18663	25768	0	applied	\N	\N	\N	\N	144015	144015	311420
18663	25769	1	applied	\N	\N	\N	\N	144016	144016	311421
18663	25772	2	applied	\N	\N	\N	\N	144017	144017	311422
18663	25773	3	applied	\N	\N	\N	\N	144018	144018	311423
18663	25807	4	applied	\N	\N	\N	\N	144019	144019	311424
18663	25766	5	applied	\N	\N	1000000000	\N	144020	144020	311425
18663	25720	6	applied	\N	\N	\N	\N	144021	144021	311426
18663	25725	7	applied	\N	\N	\N	\N	144022	144022	311427
18663	25726	8	applied	\N	\N	\N	\N	144023	144023	311428
18663	25728	9	applied	\N	\N	\N	\N	144024	144024	311429
18663	25730	10	applied	\N	\N	\N	\N	144025	144025	311430
18663	25735	11	applied	\N	\N	\N	\N	144026	144026	311431
18663	25738	13	applied	\N	\N	\N	\N	144028	144028	311433
18663	25741	14	applied	\N	\N	\N	\N	144029	144029	311434
18663	25799	15	applied	\N	\N	\N	\N	144030	144030	311435
18665	25814	0	applied	\N	\N	\N	\N	144061	144061	311466
18665	25815	1	applied	\N	\N	\N	\N	144062	144062	311467
18672	25816	0	applied	\N	\N	\N	\N	144077	144077	311482
18672	25817	1	applied	\N	\N	1000000000	\N	144078	144078	311483
18672	25818	2	applied	\N	\N	\N	\N	144079	144079	311484
18672	25819	3	applied	\N	\N	\N	\N	144080	144080	311485
18676	25820	0	applied	\N	\N	1000000000	\N	144200	144200	311603
18676	25821	1	applied	\N	\N	\N	\N	144201	144201	311604
18676	25822	2	applied	\N	\N	\N	\N	144202	144202	311605
18678	25823	0	applied	\N	\N	\N	\N	144205	144205	311608
18678	25824	1	applied	\N	\N	1000000000	\N	144206	144206	311609
18678	25826	3	applied	\N	\N	1000000000	\N	144208	144208	311611
18678	25827	4	applied	\N	\N	\N	\N	144209	144209	311612
18682	25842	0	applied	\N	\N	\N	\N	144316	144316	311719
18682	25843	1	applied	\N	\N	1000000000	\N	144317	144317	311720
18682	25844	2	applied	\N	\N	\N	\N	144318	144318	311721
18682	25845	3	applied	\N	\N	\N	\N	144319	144319	311722
18682	25846	4	applied	\N	\N	\N	\N	144320	144320	311723
18682	25847	5	applied	\N	\N	\N	\N	144321	144321	311724
18687	25851	0	applied	\N	\N	\N	\N	144332	144332	311735
18687	25852	2	applied	\N	\N	\N	\N	144333	144333	311736
18691	25851	0	applied	\N	\N	\N	\N	144336	144336	311739
18691	25853	1	applied	\N	\N	\N	\N	144337	144337	311740
18691	25854	2	applied	\N	\N	\N	\N	144338	144338	311741
18691	25855	3	applied	\N	\N	\N	\N	144339	144339	311742
18691	25852	4	applied	\N	\N	\N	\N	144340	144340	311743
18691	25856	5	applied	\N	\N	\N	\N	144341	144341	311744
18691	25857	6	applied	\N	\N	\N	\N	144342	144342	311745
18694	25858	0	applied	\N	\N	\N	\N	144354	144354	311757
18694	25859	1	applied	\N	\N	\N	\N	144355	144355	311758
18694	25860	2	applied	\N	\N	\N	\N	144356	144356	311759
18698	25862	0	applied	\N	\N	\N	\N	144367	144367	311770
18698	25863	1	applied	\N	\N	\N	\N	144368	144368	311771
18698	25864	2	applied	\N	\N	\N	\N	144369	144369	311772
18700	25865	0	applied	\N	\N	\N	\N	144407	144407	311810
18700	25866	1	applied	\N	\N	\N	\N	144408	144408	311811
18700	25867	2	applied	\N	\N	\N	\N	144409	144409	311812
18700	25868	3	applied	\N	\N	\N	\N	144410	144410	311813
18703	25874	0	applied	\N	\N	\N	\N	144420	144420	311823
18703	25875	1	applied	\N	\N	\N	\N	144421	144421	311824
18705	25876	0	applied	\N	\N	\N	\N	144424	144424	311827
18705	25877	1	applied	\N	\N	\N	\N	144425	144425	311828
18712	25891	0	applied	\N	\N	\N	\N	144469	144469	311872
18712	25892	1	applied	\N	\N	\N	\N	144470	144470	311873
18712	25893	2	applied	\N	\N	\N	\N	144471	144471	311874
18712	25894	3	applied	\N	\N	\N	\N	144472	144472	311875
18712	25895	4	applied	\N	\N	\N	\N	144473	144473	311876
18712	25897	6	applied	\N	\N	\N	\N	144475	144475	311878
18712	25898	7	applied	\N	\N	\N	\N	144476	144476	311879
18712	25899	8	applied	\N	\N	\N	\N	144477	144477	311880
18714	25901	0	applied	\N	\N	\N	\N	144489	144489	311892
18714	25902	1	applied	\N	\N	\N	\N	144490	144490	311893
18714	25903	2	applied	\N	\N	\N	\N	144491	144491	311894
18717	25906	0	applied	\N	\N	\N	\N	144496	144496	311899
18616	25721	0	applied	\N	\N	\N	\N	143837	143837	311242
18618	25722	0	applied	\N	\N	\N	\N	143839	143839	311244
18613	25706	4	applied	\N	\N	\N	\N	143805	143805	311210
18613	25707	5	applied	\N	\N	\N	\N	143806	143806	311211
18613	25708	6	applied	\N	\N	\N	\N	143807	143807	311212
18613	25710	8	applied	\N	\N	\N	\N	143809	143809	311214
18613	25711	9	applied	\N	\N	\N	\N	143810	143810	311215
18613	25712	10	applied	\N	\N	\N	\N	143811	143811	311216
18613	25713	11	applied	\N	\N	\N	\N	143812	143812	311217
18613	25714	12	applied	\N	\N	\N	\N	143813	143813	311218
18613	25715	13	applied	\N	\N	\N	\N	143814	143814	311219
18613	25716	14	applied	\N	\N	\N	\N	143815	143815	311220
18613	25717	15	applied	\N	\N	\N	\N	143816	143816	311221
18613	25718	16	applied	\N	\N	\N	\N	143817	143817	311222
18615	25719	0	applied	\N	\N	\N	\N	143835	143835	311240
18615	25720	1	applied	\N	\N	\N	\N	143836	143836	311241
18620	25724	0	applied	\N	\N	\N	\N	143843	143843	311248
18620	25725	1	applied	\N	\N	\N	\N	143844	143844	311249
18620	25726	2	applied	\N	\N	\N	\N	143845	143845	311250
18622	25727	0	applied	\N	\N	\N	\N	143849	143849	311254
18622	25728	1	applied	\N	\N	\N	\N	143850	143850	311255
18625	25733	1	applied	\N	\N	\N	\N	143858	143858	311263
18625	25734	2	applied	\N	\N	\N	\N	143859	143859	311264
18625	25735	3	applied	\N	\N	\N	\N	143860	143860	311265
18625	25736	4	applied	\N	\N	\N	\N	143861	143861	311266
18630	25744	0	applied	\N	\N	\N	\N	143879	143879	311284
18630	25745	1	applied	\N	\N	\N	\N	143880	143880	311285
18630	25746	2	applied	\N	\N	\N	\N	143881	143881	311286
18630	25747	3	applied	\N	\N	\N	\N	143882	143882	311287
18630	25748	4	applied	\N	\N	\N	\N	143883	143883	311288
18632	25744	0	applied	\N	\N	\N	\N	143889	143889	311294
18632	25745	1	applied	\N	\N	\N	\N	143890	143890	311295
18632	25746	2	applied	\N	\N	\N	\N	143891	143891	311296
18632	25747	3	applied	\N	\N	\N	\N	143892	143892	311297
18632	25748	4	applied	\N	\N	\N	\N	143893	143893	311298
18635	25753	0	applied	\N	\N	\N	\N	143903	143903	311308
18635	25754	1	applied	\N	\N	\N	\N	143904	143904	311309
18635	25756	3	applied	\N	\N	\N	\N	143906	143906	311311
18635	25757	4	applied	\N	\N	\N	\N	143907	143907	311312
18641	25772	0	applied	\N	\N	\N	\N	143933	143933	311338
18641	25773	1	applied	\N	\N	\N	\N	143934	143934	311339
18641	25774	2	applied	\N	\N	\N	\N	143935	143935	311340
18641	25775	3	applied	\N	\N	\N	\N	143936	143936	311341
18641	25776	4	applied	\N	\N	\N	\N	143937	143937	311342
18641	25777	5	applied	\N	\N	\N	\N	143938	143938	311343
18641	25778	6	applied	\N	\N	\N	\N	143939	143939	311344
18644	25779	0	applied	\N	\N	\N	\N	143944	143944	311349
18644	25780	1	applied	\N	\N	\N	\N	143945	143945	311350
18646	25779	0	applied	\N	\N	\N	\N	143948	143948	311353
18646	25780	1	applied	\N	\N	\N	\N	143949	143949	311354
18650	25787	0	applied	\N	\N	\N	\N	143962	143962	311367
18653	25792	0	applied	\N	\N	\N	\N	143968	143968	311373
18653	25793	1	applied	\N	\N	\N	\N	143969	143969	311374
18653	25795	3	applied	\N	\N	\N	\N	143971	143971	311376
18656	25796	0	applied	\N	\N	\N	\N	143982	143982	311387
18656	25797	1	applied	\N	\N	\N	\N	143983	143983	311388
18656	25798	2	applied	\N	\N	\N	\N	143984	143984	311389
18656	25799	3	applied	\N	\N	\N	\N	143985	143985	311390
18656	25800	4	applied	\N	\N	\N	\N	143986	143986	311391
18656	25801	5	applied	\N	\N	\N	\N	143987	143987	311392
18659	25796	0	applied	\N	\N	\N	\N	144000	144000	311405
18659	25797	1	applied	\N	\N	\N	\N	144001	144001	311406
18659	25798	2	applied	\N	\N	\N	\N	144002	144002	311407
18659	25799	3	applied	\N	\N	\N	\N	144003	144003	311408
18659	25800	4	applied	\N	\N	\N	\N	144004	144004	311409
18659	25801	5	applied	\N	\N	\N	\N	144005	144005	311410
18662	25808	0	applied	\N	\N	\N	\N	144012	144012	311417
18662	25809	1	applied	\N	\N	\N	\N	144013	144013	311418
18662	25810	2	applied	\N	\N	\N	\N	144014	144014	311419
18667	25815	1	applied	\N	\N	\N	\N	144066	144066	311471
18673	25518	0	applied	\N	\N	\N	\N	144081	144081	144081
18673	25538	1	applied	\N	\N	1000000000	\N	144082	144082	311486
18673	25578	2	applied	\N	\N	\N	\N	144083	144083	311487
18673	25594	3	applied	\N	\N	\N	\N	144084	144084	311488
18673	25615	4	applied	\N	\N	\N	\N	144085	144085	311489
18673	25622	5	applied	\N	\N	\N	\N	144086	144086	311490
18673	25634	6	applied	\N	\N	\N	\N	144087	144087	311491
18673	25640	7	applied	\N	\N	\N	\N	144088	144088	311492
18673	25643	8	applied	\N	\N	\N	\N	144089	144089	311493
18673	25768	9	applied	\N	\N	\N	\N	144090	144090	311494
18673	25769	10	applied	\N	\N	\N	\N	144091	144091	311495
18673	25772	11	applied	\N	\N	\N	\N	144092	144092	311496
18673	25773	12	applied	\N	\N	\N	\N	144093	144093	311497
18673	25493	13	applied	\N	\N	\N	\N	144094	144094	144094
18673	25455	15	applied	\N	\N	1000000000	\N	144096	144096	311499
18673	25496	16	applied	\N	\N	1000000000	\N	144097	144097	311500
18673	25657	17	applied	\N	\N	1000000000	\N	144098	144098	311501
18673	25674	18	applied	\N	\N	1000000000	\N	144099	144099	311502
18673	25702	19	applied	\N	\N	1000000000	\N	144100	144100	311503
18673	25293	20	applied	\N	\N	\N	\N	144101	144101	311504
18717	25907	1	applied	\N	\N	\N	\N	144497	144497	311900
18719	25911	0	applied	\N	\N	\N	\N	144501	144501	311904
18719	25912	1	applied	\N	\N	\N	\N	144502	144502	311905
18719	25913	2	applied	\N	\N	\N	\N	144503	144503	311906
18719	25914	3	applied	\N	\N	\N	\N	144504	144504	311907
18729	25931	0	applied	\N	\N	\N	\N	144532	144532	311935
18729	25932	1	applied	\N	\N	\N	\N	144533	144533	311936
18735	25942	0	applied	\N	\N	\N	\N	144555	144555	311958
18735	25943	1	applied	\N	\N	\N	\N	144556	144556	311959
18735	25944	2	applied	\N	\N	\N	\N	144557	144557	311960
18740	25949	0	applied	\N	\N	\N	\N	144580	144580	311983
18740	25950	1	applied	\N	\N	\N	\N	144581	144581	311984
18740	25951	2	applied	\N	\N	\N	\N	144582	144582	311985
18744	25963	1	applied	\N	\N	\N	\N	144597	144597	312000
18744	25964	2	applied	\N	\N	\N	\N	144598	144598	312001
18747	25969	0	applied	\N	\N	\N	\N	144603	144603	312006
18747	25970	1	applied	\N	\N	\N	\N	144604	144604	312007
18747	25971	2	applied	\N	\N	\N	\N	144605	144605	312008
18747	25972	3	applied	\N	\N	\N	\N	144606	144606	312009
18747	25973	4	applied	\N	\N	\N	\N	144607	144607	312010
18749	25974	0	applied	\N	\N	\N	\N	144611	144611	312014
18613	25704	2	applied	\N	\N	\N	\N	143803	143803	311208
18613	25705	3	applied	\N	\N	\N	\N	143804	143804	311209
18664	25812	1	applied	\N	\N	\N	\N	144059	144059	311464
18664	25813	2	applied	\N	\N	\N	\N	144060	144060	311465
18666	25814	0	applied	\N	\N	\N	\N	144063	144063	311468
18666	25815	1	applied	\N	\N	\N	\N	144064	144064	311469
18668	25814	0	applied	\N	\N	\N	\N	144067	144067	311472
18668	25815	1	applied	\N	\N	\N	\N	144068	144068	311473
18671	25816	0	applied	\N	\N	\N	\N	144073	144073	311478
18671	25817	1	applied	\N	\N	1000000000	\N	144074	144074	311479
18671	25818	2	applied	\N	\N	\N	\N	144075	144075	311480
18671	25819	3	applied	\N	\N	\N	\N	144076	144076	311481
18673	25295	21	applied	\N	\N	\N	\N	144102	144102	311505
18673	25298	22	applied	\N	\N	\N	\N	144103	144103	311506
18673	25299	23	applied	\N	\N	\N	\N	144104	144104	311507
18673	25304	25	applied	\N	\N	\N	\N	144106	144106	311509
18673	25306	26	applied	\N	\N	\N	\N	144107	144107	311510
18673	25309	27	applied	\N	\N	\N	\N	144108	144108	311511
18673	25312	28	applied	\N	\N	\N	\N	144109	144109	311512
18673	25315	29	applied	\N	\N	\N	\N	144110	144110	311513
18673	25316	30	applied	\N	\N	\N	\N	144111	144111	311514
18673	25317	31	applied	\N	\N	\N	\N	144112	144112	311515
18673	25325	32	applied	\N	\N	\N	\N	144113	144113	311516
18673	25329	33	applied	\N	\N	\N	\N	144114	144114	311517
18673	25331	34	applied	\N	\N	\N	\N	144115	144115	311518
18673	25335	35	applied	\N	\N	\N	\N	144116	144116	311519
18673	25338	36	applied	\N	\N	\N	\N	144117	144117	311520
18673	25340	37	applied	\N	\N	\N	\N	144118	144118	311521
18673	25343	38	applied	\N	\N	\N	\N	144119	144119	311522
18673	25347	39	applied	\N	\N	\N	\N	144120	144120	311523
18673	25350	40	applied	\N	\N	\N	\N	144121	144121	311524
18673	25357	42	applied	\N	\N	\N	\N	144123	144123	311526
18679	25828	0	applied	\N	\N	\N	\N	144210	144210	311613
18679	25829	1	applied	\N	\N	\N	\N	144211	144211	311614
18679	25830	2	applied	\N	\N	\N	\N	144212	144212	311615
18683	25848	0	applied	\N	\N	\N	\N	144322	144322	311725
18683	25849	1	applied	\N	\N	\N	\N	144323	144323	311726
18688	25851	0	applied	\N	\N	\N	\N	144334	144334	311737
18688	25852	2	applied	\N	\N	\N	\N	144335	144335	311738
18701	25865	0	applied	\N	\N	\N	\N	144411	144411	311814
18701	25866	1	applied	\N	\N	\N	\N	144412	144412	311815
18701	25867	2	applied	\N	\N	\N	\N	144413	144413	311816
18701	25868	3	applied	\N	\N	\N	\N	144414	144414	311817
18704	25876	0	applied	\N	\N	\N	\N	144422	144422	311825
18704	25877	1	applied	\N	\N	\N	\N	144423	144423	311826
18706	25876	0	applied	\N	\N	\N	\N	144426	144426	311829
18706	25877	1	applied	\N	\N	\N	\N	144427	144427	311830
18707	25879	1	applied	\N	\N	\N	\N	144429	144429	311832
18707	25880	2	applied	\N	\N	\N	\N	144430	144430	311833
18707	25881	3	applied	\N	\N	\N	\N	144431	144431	311834
18707	25882	4	applied	\N	\N	\N	\N	144432	144432	311835
18707	25883	5	applied	\N	\N	\N	\N	144433	144433	311836
18707	25884	6	applied	\N	\N	\N	\N	144434	144434	311837
18710	25890	0	applied	\N	\N	\N	\N	144441	144441	311844
18713	25891	0	applied	\N	\N	\N	\N	144479	144479	311882
18713	25892	1	applied	\N	\N	\N	\N	144480	144480	311883
18713	25893	2	applied	\N	\N	\N	\N	144481	144481	311884
18713	25894	3	applied	\N	\N	\N	\N	144482	144482	311885
18713	25895	4	applied	\N	\N	\N	\N	144483	144483	311886
18713	25896	5	applied	\N	\N	\N	\N	144484	144484	311887
18713	25897	6	applied	\N	\N	\N	\N	144485	144485	311888
18713	25898	7	applied	\N	\N	\N	\N	144486	144486	311889
18713	25899	8	applied	\N	\N	\N	\N	144487	144487	311890
18715	25904	0	applied	\N	\N	\N	\N	144492	144492	311895
18715	25905	1	applied	\N	\N	\N	\N	144493	144493	311896
18723	25920	0	applied	\N	\N	\N	\N	144513	144513	311916
18723	25921	1	applied	\N	\N	\N	\N	144514	144514	311917
18723	25922	2	applied	\N	\N	\N	\N	144515	144515	311918
18723	25923	3	applied	\N	\N	1000000000	\N	144516	144516	311919
18723	25924	4	applied	\N	\N	\N	\N	144517	144517	311920
18723	25925	5	applied	\N	\N	\N	\N	144518	144518	311921
18728	25929	0	applied	\N	\N	\N	\N	144530	144530	311933
18728	25930	1	applied	\N	\N	\N	\N	144531	144531	311934
18733	25938	0	applied	\N	\N	\N	\N	144544	144544	311947
18733	25939	1	applied	\N	\N	\N	\N	144545	144545	311948
18733	25940	2	applied	\N	\N	\N	\N	144546	144546	311949
18733	25941	3	applied	\N	\N	\N	\N	144547	144547	311950
18738	25949	0	applied	\N	\N	\N	\N	144572	144572	311975
18738	25950	1	applied	\N	\N	\N	\N	144573	144573	311976
18738	25952	3	applied	\N	\N	\N	\N	144575	144575	311978
18743	25958	0	applied	\N	\N	\N	\N	144592	144592	311995
18743	25959	1	applied	\N	\N	\N	\N	144593	144593	311996
18743	25960	2	applied	\N	\N	\N	\N	144594	144594	311997
18743	25961	3	applied	\N	\N	\N	\N	144595	144595	311998
18745	25965	0	applied	\N	\N	\N	\N	144599	144599	312002
18745	25966	1	applied	\N	\N	\N	\N	144600	144600	312003
18751	25981	0	applied	\N	\N	\N	\N	144618	144618	312021
18751	25982	1	applied	\N	\N	\N	\N	144619	144619	312022
18758	25991	0	applied	\N	\N	\N	\N	144636	144636	312039
18758	25992	1	applied	\N	\N	\N	\N	144637	144637	312040
18763	25996	0	applied	\N	\N	\N	\N	144650	144650	312053
18763	25997	1	applied	\N	\N	\N	\N	144651	144651	312054
18763	25998	2	applied	\N	\N	\N	\N	144652	144652	312055
18767	25999	0	applied	\N	\N	\N	\N	144662	144662	144662
18767	26000	1	applied	\N	\N	\N	\N	144663	144663	312064
18771	26002	0	applied	\N	\N	\N	\N	144671	144671	312072
18771	26003	1	applied	\N	\N	\N	\N	144672	144672	312073
18784	26024	0	applied	\N	\N	\N	\N	144710	144710	312111
18784	26025	1	applied	\N	\N	\N	\N	144711	144711	312112
18784	26026	2	applied	\N	\N	\N	\N	144712	144712	312113
18786	26027	0	applied	\N	\N	\N	\N	144718	144718	312119
18786	26028	1	applied	\N	\N	\N	\N	144719	144719	312120
18786	26029	2	applied	\N	\N	\N	\N	144720	144720	312121
18786	26030	3	applied	\N	\N	\N	\N	144721	144721	312122
18786	26031	4	applied	\N	\N	\N	\N	144722	144722	312123
18791	26039	0	applied	\N	\N	\N	\N	144738	144738	312139
18791	26040	1	applied	\N	\N	\N	\N	144739	144739	312140
18799	26058	0	applied	\N	\N	\N	\N	144774	144774	312175
18799	26059	1	applied	\N	\N	\N	\N	144775	144775	312176
18799	26060	2	applied	\N	\N	\N	\N	144776	144776	312177
18802	26065	0	applied	\N	\N	\N	\N	144781	144781	312182
18658	25801	5	applied	\N	\N	\N	\N	143999	143999	311404
18664	25811	0	applied	\N	\N	\N	\N	144058	144058	311463
18663	25751	19	applied	\N	\N	\N	\N	144034	144034	311439
18663	25752	20	applied	\N	\N	\N	\N	144035	144035	311440
18663	25756	21	applied	\N	\N	\N	\N	144036	144036	311441
18663	25757	22	applied	\N	\N	\N	\N	144037	144037	311442
18663	25759	23	applied	\N	\N	\N	\N	144038	144038	311443
18663	25763	24	applied	\N	\N	\N	\N	144039	144039	311444
18663	25764	25	applied	\N	\N	\N	\N	144040	144040	311445
18663	25767	26	applied	\N	\N	\N	\N	144041	144041	311446
18663	25771	27	applied	\N	\N	\N	\N	144042	144042	311447
18663	25776	28	applied	\N	\N	\N	\N	144043	144043	311448
18663	25777	29	applied	\N	\N	\N	\N	144044	144044	311449
18663	25783	31	applied	\N	\N	\N	\N	144046	144046	311451
18663	25784	32	applied	\N	\N	\N	\N	144047	144047	311452
18663	25787	33	applied	\N	\N	\N	\N	144048	144048	311453
18663	25788	34	applied	\N	\N	\N	\N	144049	144049	311454
18663	25790	35	applied	\N	\N	\N	\N	144050	144050	311455
18663	25794	36	applied	\N	\N	\N	\N	144051	144051	311456
18663	25795	37	applied	\N	\N	\N	\N	144052	144052	311457
18663	25800	38	applied	\N	\N	\N	\N	144053	144053	311458
18663	25801	39	applied	\N	\N	\N	\N	144054	144054	311459
18663	25803	40	applied	\N	\N	\N	\N	144055	144055	311460
18663	25806	41	applied	\N	\N	\N	\N	144056	144056	311461
18663	25810	42	applied	\N	\N	\N	\N	144057	144057	311462
18670	25816	0	applied	\N	\N	\N	\N	144069	144069	311474
18670	25817	1	applied	\N	\N	1000000000	\N	144070	144070	311475
18670	25818	2	applied	\N	\N	\N	\N	144071	144071	311476
18670	25819	3	applied	\N	\N	\N	\N	144072	144072	311477
18674	25821	1	applied	\N	\N	\N	\N	144195	144195	311598
18674	25822	2	applied	\N	\N	\N	\N	144196	144196	311599
18680	25831	0	applied	\N	\N	\N	\N	144213	144213	311616
18680	25832	1	applied	\N	\N	\N	\N	144214	144214	311617
18680	25833	2	applied	\N	\N	\N	\N	144215	144215	311618
18680	25834	3	applied	\N	\N	\N	\N	144216	144216	311619
18680	25835	4	applied	\N	\N	\N	\N	144217	144217	311620
18680	25836	5	applied	\N	\N	\N	\N	144218	144218	311621
18680	25837	6	applied	\N	\N	\N	\N	144219	144219	311622
18680	25838	7	applied	\N	\N	\N	\N	144220	144220	311623
18680	25839	8	applied	\N	\N	\N	\N	144221	144221	311624
18680	25840	9	applied	\N	\N	\N	\N	144222	144222	311625
18680	25841	10	applied	\N	\N	\N	\N	144223	144223	311626
18685	25850	0	applied	\N	\N	\N	\N	144327	144327	311730
18685	25848	1	applied	\N	\N	\N	\N	144328	144328	311731
18685	25849	2	applied	\N	\N	\N	\N	144329	144329	311732
18692	25851	0	applied	\N	\N	\N	\N	144343	144343	311746
18692	25853	1	applied	\N	\N	\N	\N	144344	144344	311747
18692	25855	3	applied	\N	\N	\N	\N	144346	144346	311749
18692	25852	4	applied	\N	\N	\N	\N	144347	144347	311750
18692	25856	5	applied	\N	\N	\N	\N	144348	144348	311751
18692	25857	6	applied	\N	\N	\N	\N	144349	144349	311752
18696	25862	0	applied	\N	\N	\N	\N	144361	144361	311764
18696	25863	1	applied	\N	\N	\N	\N	144362	144362	311765
18696	25864	2	applied	\N	\N	\N	\N	144363	144363	311766
18709	25890	0	applied	\N	\N	\N	\N	144440	144440	311843
18720	25915	0	applied	\N	\N	\N	\N	144505	144505	311908
18720	25916	1	applied	\N	\N	\N	\N	144506	144506	311909
18722	25917	0	applied	\N	\N	\N	\N	144510	144510	311913
18722	25918	1	applied	\N	\N	\N	\N	144511	144511	311914
18722	25919	2	applied	\N	\N	\N	\N	144512	144512	311915
18725	25926	0	applied	\N	\N	\N	\N	144522	144522	311925
18725	25927	1	applied	\N	\N	\N	\N	144523	144523	311926
18725	25928	2	applied	\N	\N	\N	\N	144524	144524	311927
18727	25930	1	applied	\N	\N	\N	\N	144529	144529	311932
18732	25933	0	applied	\N	\N	\N	\N	144539	144539	311942
18732	25934	1	applied	\N	\N	\N	\N	144540	144540	311943
18732	25935	2	applied	\N	\N	\N	\N	144541	144541	311944
18732	25936	3	applied	\N	\N	\N	\N	144542	144542	311945
18732	25937	4	applied	\N	\N	\N	\N	144543	144543	311946
18737	25942	0	applied	\N	\N	\N	\N	144565	144565	311968
18737	25943	1	applied	\N	\N	\N	\N	144566	144566	311969
18737	25944	2	applied	\N	\N	\N	\N	144567	144567	311970
18737	25945	3	applied	\N	\N	\N	\N	144568	144568	311971
18737	25946	4	applied	\N	\N	\N	\N	144569	144569	311972
18737	25947	5	applied	\N	\N	\N	\N	144570	144570	311973
18737	25948	6	applied	\N	\N	\N	\N	144571	144571	311974
18742	25958	0	applied	\N	\N	\N	\N	144588	144588	311991
18742	25959	1	applied	\N	\N	\N	\N	144589	144589	311992
18742	25960	2	applied	\N	\N	\N	\N	144590	144590	311993
18748	25955	0	applied	\N	\N	\N	\N	144608	144608	312011
18748	25959	1	applied	\N	\N	\N	\N	144609	144609	312012
18748	25935	2	applied	\N	\N	\N	\N	144610	144610	312013
18750	25976	0	applied	\N	\N	\N	\N	144613	144613	312016
18750	25977	1	applied	\N	\N	\N	\N	144614	144614	312017
18750	25978	2	applied	\N	\N	\N	\N	144615	144615	312018
18750	25979	3	applied	\N	\N	\N	\N	144616	144616	312019
18750	25980	4	applied	\N	\N	\N	\N	144617	144617	312020
18753	25985	0	applied	\N	\N	1000000000	\N	144622	144622	312025
18753	25986	1	applied	\N	\N	\N	\N	144623	144623	312026
18753	25987	2	applied	\N	\N	\N	\N	144624	144624	312027
18753	25988	3	applied	\N	\N	\N	\N	144625	144625	312028
18802	26067	2	applied	\N	\N	\N	\N	144783	144783	312184
18802	26068	3	applied	\N	\N	\N	\N	144784	144784	312185
18802	26069	4	applied	\N	\N	\N	\N	144785	144785	312186
18804	26070	0	applied	\N	\N	\N	\N	144791	144791	312192
18809	26077	0	applied	\N	\N	\N	\N	144804	144804	312205
18809	26078	1	applied	\N	\N	\N	\N	144805	144805	312206
18811	26077	0	applied	\N	\N	\N	\N	144808	144808	312209
18811	26078	1	applied	\N	\N	\N	\N	144809	144809	312210
18814	26079	0	applied	\N	\N	\N	\N	144820	144820	312221
18814	26080	1	applied	\N	\N	\N	\N	144821	144821	312222
18814	26081	2	applied	\N	\N	\N	\N	144822	144822	312223
18814	26082	3	applied	\N	\N	\N	\N	144823	144823	312224
18814	26083	4	applied	\N	\N	\N	\N	144824	144824	312225
18816	26085	0	applied	\N	\N	\N	\N	144826	144826	312227
18823	26090	0	applied	\N	\N	\N	\N	144833	144833	312234
18823	26091	1	applied	\N	\N	\N	\N	144834	144834	312235
18835	26101	0	applied	\N	\N	\N	\N	144851	144851	312252
18838	26103	0	applied	\N	\N	\N	\N	144854	144854	312255
18838	26104	1	applied	\N	\N	\N	\N	144855	144855	312256
18838	26105	2	applied	\N	\N	\N	\N	144856	144856	312257
18663	25746	17	applied	\N	\N	\N	\N	144032	144032	311437
18663	25747	18	applied	\N	\N	\N	\N	144033	144033	311438
18673	25372	47	applied	\N	\N	\N	\N	144128	144128	311531
18673	25375	48	applied	\N	\N	\N	\N	144129	144129	311532
18673	25379	49	applied	\N	\N	\N	\N	144130	144130	311533
18673	25382	50	applied	\N	\N	\N	\N	144131	144131	311534
18673	25385	51	applied	\N	\N	\N	\N	144132	144132	311535
18673	25389	52	applied	\N	\N	\N	\N	144133	144133	311536
18673	25392	53	applied	\N	\N	\N	\N	144134	144134	311537
18673	25394	54	applied	\N	\N	\N	\N	144135	144135	311538
18673	25395	55	applied	\N	\N	\N	\N	144136	144136	311539
18673	25401	56	applied	\N	\N	\N	\N	144137	144137	311540
18673	25402	57	applied	\N	\N	\N	\N	144138	144138	311541
18673	25403	58	applied	\N	\N	\N	\N	144139	144139	311542
18673	25412	59	applied	\N	\N	\N	\N	144140	144140	311543
18673	25415	60	applied	\N	\N	\N	\N	144141	144141	311544
18673	25416	61	applied	\N	\N	\N	\N	144142	144142	311545
18673	25424	63	applied	\N	\N	\N	\N	144144	144144	311547
18673	25425	64	applied	\N	\N	\N	\N	144145	144145	311548
18673	25426	65	applied	\N	\N	\N	\N	144146	144146	311549
18673	25433	66	applied	\N	\N	\N	\N	144147	144147	311550
18673	25441	68	applied	\N	\N	\N	\N	144148	144148	311551
18673	25445	69	applied	\N	\N	\N	\N	144149	144149	311552
18673	25447	70	applied	\N	\N	\N	\N	144150	144150	311553
18673	25450	71	applied	\N	\N	\N	\N	144151	144151	311554
18673	25454	72	applied	\N	\N	\N	\N	144152	144152	311555
18673	25458	73	applied	\N	\N	\N	\N	144153	144153	311556
18673	25462	74	applied	\N	\N	\N	\N	144154	144154	311557
18673	25466	75	applied	\N	\N	\N	\N	144155	144155	311558
18673	25467	76	applied	\N	\N	\N	\N	144156	144156	311559
18673	25473	77	applied	\N	\N	\N	\N	144157	144157	311560
18673	25476	78	applied	\N	\N	\N	\N	144158	144158	311561
18673	25480	79	applied	\N	\N	\N	\N	144159	144159	311562
18673	25484	81	applied	\N	\N	\N	\N	144161	144161	311564
18673	25490	82	applied	\N	\N	\N	\N	144162	144162	311565
18673	25494	83	applied	\N	\N	\N	\N	144163	144163	311566
18673	25498	84	applied	\N	\N	\N	\N	144164	144164	311567
18673	25501	85	applied	\N	\N	\N	\N	144165	144165	311568
18673	25502	86	applied	\N	\N	\N	\N	144166	144166	311569
18673	25509	87	applied	\N	\N	\N	\N	144167	144167	311570
18673	25511	88	applied	\N	\N	\N	\N	144168	144168	311571
18673	25512	89	applied	\N	\N	\N	\N	144169	144169	311572
18673	25519	90	applied	\N	\N	\N	\N	144170	144170	311573
18673	25522	91	applied	\N	\N	\N	\N	144171	144171	311574
18673	25526	92	applied	\N	\N	\N	\N	144172	144172	311575
18673	25529	93	applied	\N	\N	\N	\N	144173	144173	311576
18673	25532	94	applied	\N	\N	\N	\N	144174	144174	311577
18673	25535	95	applied	\N	\N	\N	\N	144175	144175	311578
18673	25539	96	applied	\N	\N	\N	\N	144176	144176	311579
18673	25545	98	applied	\N	\N	\N	\N	144178	144178	311581
18673	25546	99	applied	\N	\N	\N	\N	144179	144179	311582
18673	25552	100	applied	\N	\N	\N	\N	144180	144180	311583
18673	25555	101	applied	\N	\N	\N	\N	144181	144181	311584
18673	25556	102	applied	\N	\N	\N	\N	144182	144182	311585
18673	25562	103	applied	\N	\N	\N	\N	144183	144183	311586
18673	25565	104	applied	\N	\N	\N	\N	144184	144184	311587
18673	25568	105	applied	\N	\N	\N	\N	144185	144185	311588
18673	25572	106	applied	\N	\N	\N	\N	144186	144186	311589
18673	25575	107	applied	\N	\N	\N	\N	144187	144187	311590
18673	25579	108	applied	\N	\N	\N	\N	144188	144188	311591
18673	25582	109	applied	\N	\N	\N	\N	144189	144189	311592
18673	25584	110	applied	\N	\N	\N	\N	144190	144190	311593
18673	25585	111	applied	\N	\N	\N	\N	144191	144191	311594
18673	25586	112	applied	\N	\N	\N	\N	144192	144192	311595
18673	25595	113	applied	\N	\N	\N	\N	144193	144193	311596
18675	25821	1	applied	\N	\N	\N	\N	144198	144198	311601
18675	25822	2	applied	\N	\N	\N	\N	144199	144199	311602
18677	25820	0	applied	\N	\N	1000000000	\N	144203	144203	311606
18677	25822	1	applied	\N	\N	\N	\N	144204	144204	311607
18681	25768	0	applied	\N	\N	\N	\N	144224	144224	311627
18681	25769	1	applied	\N	\N	\N	\N	144225	144225	311628
18681	25772	2	applied	\N	\N	\N	\N	144226	144226	311629
18681	25773	3	applied	\N	\N	\N	\N	144227	144227	311630
18681	25817	4	applied	\N	\N	1000000000	\N	144228	144228	311631
18681	25702	5	applied	\N	\N	1000000000	\N	144229	144229	311632
18681	25820	6	applied	\N	\N	1000000000	\N	144230	144230	311633
18681	25824	7	applied	\N	\N	1000000000	\N	144231	144231	311634
18681	25825	8	applied	\N	\N	1000000000	\N	144232	144232	311635
18681	25826	9	applied	\N	\N	1000000000	\N	144233	144233	311636
18681	25807	10	applied	\N	\N	\N	\N	144234	144234	311637
18681	25690	11	applied	\N	\N	\N	\N	144235	144235	311638
18681	25693	12	applied	\N	\N	\N	\N	144236	144236	311639
18681	25734	14	applied	\N	\N	\N	\N	144238	144238	311641
18681	25694	15	applied	\N	\N	\N	\N	144239	144239	311642
18681	25701	16	applied	\N	\N	\N	\N	144240	144240	311643
18681	25710	17	applied	\N	\N	\N	\N	144241	144241	311644
18681	25813	18	applied	\N	\N	\N	\N	144242	144242	311645
18681	25713	19	applied	\N	\N	\N	\N	144243	144243	311646
18681	25696	20	applied	\N	\N	\N	\N	144244	144244	311647
18681	25698	21	applied	\N	\N	\N	\N	144245	144245	311648
18755	25989	0	applied	\N	\N	\N	\N	144630	144630	312033
18755	25990	1	applied	\N	\N	\N	\N	144631	144631	312034
18760	25996	0	applied	\N	\N	\N	\N	144641	144641	312044
18760	25997	1	applied	\N	\N	\N	\N	144642	144642	312045
18760	25998	2	applied	\N	\N	\N	\N	144643	144643	312046
18762	25996	0	applied	\N	\N	\N	\N	144647	144647	312050
18762	25997	1	applied	\N	\N	\N	\N	144648	144648	312051
18762	25998	2	applied	\N	\N	\N	\N	144649	144649	312052
18766	25999	0	applied	\N	\N	\N	\N	144659	144659	144659
18766	26000	1	applied	\N	\N	\N	\N	144660	144660	312062
18766	26001	2	applied	\N	\N	\N	\N	144661	144661	312063
18769	26003	1	applied	\N	\N	\N	\N	144668	144668	312069
18773	26007	0	applied	\N	\N	\N	\N	144676	144676	312077
18773	26008	1	applied	\N	\N	\N	\N	144677	144677	312078
18776	26009	0	applied	\N	\N	\N	\N	144682	144682	312083
18776	26010	1	applied	\N	\N	\N	\N	144683	144683	312084
18776	26011	2	applied	\N	\N	\N	\N	144684	144684	312085
18776	26012	3	applied	\N	\N	\N	\N	144685	144685	312086
18776	26013	4	applied	\N	\N	\N	\N	144686	144686	312087
18776	26014	6	applied	\N	\N	\N	\N	144687	144687	312088
18776	26015	7	applied	\N	\N	\N	\N	144688	144688	312089
18673	25361	44	applied	\N	\N	\N	\N	144125	144125	311528
18673	25369	46	applied	\N	\N	\N	\N	144127	144127	311530
18681	25731	26	applied	\N	\N	\N	\N	144250	144250	311653
18681	25799	27	applied	\N	\N	\N	\N	144251	144251	311654
18681	25742	28	applied	\N	\N	\N	\N	144252	144252	311655
18681	25748	29	applied	\N	\N	\N	\N	144253	144253	311656
18681	25755	30	applied	\N	\N	\N	\N	144254	144254	311657
18681	25765	31	applied	\N	\N	\N	\N	144255	144255	311658
18681	25778	32	applied	\N	\N	\N	\N	144256	144256	311659
18681	25714	33	applied	\N	\N	\N	\N	144257	144257	311660
18681	25715	34	applied	\N	\N	\N	\N	144258	144258	311661
18681	25716	35	applied	\N	\N	\N	\N	144259	144259	311662
18681	25717	36	applied	\N	\N	\N	\N	144260	144260	311663
18681	25718	37	applied	\N	\N	\N	\N	144261	144261	311664
18681	25720	38	applied	\N	\N	\N	\N	144262	144262	311665
18681	25725	39	applied	\N	\N	\N	\N	144263	144263	311666
18681	25728	41	applied	\N	\N	\N	\N	144265	144265	311668
18681	25730	42	applied	\N	\N	\N	\N	144266	144266	311669
18681	25735	43	applied	\N	\N	\N	\N	144267	144267	311670
18681	25736	44	applied	\N	\N	\N	\N	144268	144268	311671
18681	25738	45	applied	\N	\N	\N	\N	144269	144269	311672
18681	25741	46	applied	\N	\N	\N	\N	144270	144270	311673
18681	25785	47	applied	\N	\N	\N	\N	144271	144271	311674
18681	25791	48	applied	\N	\N	\N	\N	144272	144272	311675
18681	25798	49	applied	\N	\N	\N	\N	144273	144273	311676
18681	25809	50	applied	\N	\N	\N	\N	144274	144274	311677
18681	25819	51	applied	\N	\N	\N	\N	144275	144275	311678
18681	25829	52	applied	\N	\N	\N	\N	144276	144276	311679
18681	25837	53	applied	\N	\N	\N	\N	144277	144277	311680
18681	25743	54	applied	\N	\N	\N	\N	144278	144278	311681
18681	25746	55	applied	\N	\N	\N	\N	144279	144279	311682
18681	25747	56	applied	\N	\N	\N	\N	144280	144280	311683
18681	25752	58	applied	\N	\N	\N	\N	144282	144282	311685
18681	25756	59	applied	\N	\N	\N	\N	144283	144283	311686
18681	25757	60	applied	\N	\N	\N	\N	144284	144284	311687
18681	25759	61	applied	\N	\N	\N	\N	144285	144285	311688
18681	25763	62	applied	\N	\N	\N	\N	144286	144286	311689
18681	25764	63	applied	\N	\N	\N	\N	144287	144287	311690
18681	25767	64	applied	\N	\N	\N	\N	144288	144288	311691
18681	25771	65	applied	\N	\N	\N	\N	144289	144289	311692
18681	25776	66	applied	\N	\N	\N	\N	144290	144290	311693
18681	25777	67	applied	\N	\N	\N	\N	144291	144291	311694
18681	25780	68	applied	\N	\N	\N	\N	144292	144292	311695
18681	25783	69	applied	\N	\N	\N	\N	144293	144293	311696
18681	25784	70	applied	\N	\N	\N	\N	144294	144294	311697
18681	25787	71	applied	\N	\N	\N	\N	144295	144295	311698
18681	25788	72	applied	\N	\N	\N	\N	144296	144296	311699
18681	25790	73	applied	\N	\N	\N	\N	144297	144297	311700
18681	25795	75	applied	\N	\N	\N	\N	144299	144299	311702
18681	25800	76	applied	\N	\N	\N	\N	144300	144300	311703
18681	25801	77	applied	\N	\N	\N	\N	144301	144301	311704
18681	25803	78	applied	\N	\N	\N	\N	144302	144302	311705
18681	25806	79	applied	\N	\N	\N	\N	144303	144303	311706
18681	25810	80	applied	\N	\N	\N	\N	144304	144304	311707
18681	25812	81	applied	\N	\N	\N	\N	144305	144305	311708
18681	25815	82	applied	\N	\N	\N	\N	144306	144306	311709
18681	25818	83	applied	\N	\N	\N	\N	144307	144307	311710
18681	25822	84	applied	\N	\N	\N	\N	144308	144308	311711
18681	25827	85	applied	\N	\N	\N	\N	144309	144309	311712
18681	25830	86	applied	\N	\N	\N	\N	144310	144310	311713
18681	25836	87	applied	\N	\N	\N	\N	144311	144311	311714
18681	25838	88	applied	\N	\N	\N	\N	144312	144312	311715
18681	25839	89	applied	\N	\N	\N	\N	144313	144313	311716
18681	25840	90	applied	\N	\N	\N	\N	144314	144314	311717
18684	25850	0	applied	\N	\N	\N	\N	144324	144324	311727
18684	25848	1	applied	\N	\N	\N	\N	144325	144325	311728
18684	25849	2	applied	\N	\N	\N	\N	144326	144326	311729
18686	25851	0	applied	\N	\N	\N	\N	144330	144330	311733
18686	25852	2	applied	\N	\N	\N	\N	144331	144331	311734
18693	25858	0	applied	\N	\N	\N	\N	144350	144350	311753
18693	25859	1	applied	\N	\N	\N	\N	144351	144351	311754
18693	25860	2	applied	\N	\N	\N	\N	144352	144352	311755
18693	25861	3	applied	\N	\N	\N	\N	144353	144353	311756
18695	25862	0	applied	\N	\N	\N	\N	144358	144358	311761
18695	25863	1	applied	\N	\N	\N	\N	144359	144359	311762
18695	25864	2	applied	\N	\N	\N	\N	144360	144360	311763
18697	25862	0	applied	\N	\N	\N	\N	144364	144364	311767
18697	25863	1	applied	\N	\N	\N	\N	144365	144365	311768
18697	25864	2	applied	\N	\N	\N	\N	144366	144366	311769
18699	25828	1	applied	\N	\N	\N	\N	144371	144371	311774
18699	25831	2	applied	\N	\N	\N	\N	144372	144372	311775
18699	25832	3	applied	\N	\N	\N	\N	144373	144373	311776
18699	25833	4	applied	\N	\N	\N	\N	144374	144374	311777
18699	25834	5	applied	\N	\N	\N	\N	144375	144375	311778
18699	25835	6	applied	\N	\N	\N	\N	144376	144376	311779
18699	25842	7	applied	\N	\N	\N	\N	144377	144377	311780
18699	25844	8	applied	\N	\N	\N	\N	144378	144378	311781
18699	25850	9	applied	\N	\N	\N	\N	144379	144379	311782
18699	25851	10	applied	\N	\N	\N	\N	144380	144380	311783
18699	25853	11	applied	\N	\N	\N	\N	144381	144381	311784
18699	25854	12	applied	\N	\N	\N	\N	144382	144382	311785
18699	25858	13	applied	\N	\N	\N	\N	144383	144383	311786
18699	25859	14	applied	\N	\N	\N	\N	144384	144384	311787
18699	25862	15	applied	\N	\N	\N	\N	144385	144385	311788
18699	25848	16	applied	\N	\N	\N	\N	144386	144386	311789
18699	25829	17	applied	\N	\N	\N	\N	144387	144387	311790
18699	25837	18	applied	\N	\N	\N	\N	144388	144388	311791
18699	25847	19	applied	\N	\N	\N	\N	144389	144389	311792
18699	25864	21	applied	\N	\N	\N	\N	144391	144391	311794
18699	25830	22	applied	\N	\N	\N	\N	144392	144392	311795
18699	25836	23	applied	\N	\N	\N	\N	144393	144393	311796
18699	25838	24	applied	\N	\N	\N	\N	144394	144394	311797
18699	25839	25	applied	\N	\N	\N	\N	144395	144395	311798
18699	25840	26	applied	\N	\N	\N	\N	144396	144396	311799
18699	25841	27	applied	\N	\N	\N	\N	144397	144397	311800
18699	25845	28	applied	\N	\N	\N	\N	144398	144398	311801
18699	25846	29	applied	\N	\N	\N	\N	144399	144399	311802
18699	25849	30	applied	\N	\N	\N	\N	144400	144400	311803
18699	25852	31	applied	\N	\N	\N	\N	144401	144401	311804
18699	25856	33	applied	\N	\N	\N	\N	144402	144402	311805
18699	25857	34	applied	\N	\N	\N	\N	144403	144403	311806
18699	25860	35	applied	\N	\N	\N	\N	144404	144404	311807
18681	25712	24	applied	\N	\N	\N	\N	144248	144248	311651
18681	25723	25	applied	\N	\N	\N	\N	144249	144249	311652
18702	25870	1	applied	\N	\N	\N	\N	144416	144416	311819
18702	25871	2	applied	\N	\N	\N	\N	144417	144417	311820
18702	25872	3	applied	\N	\N	\N	\N	144418	144418	311821
18702	25873	4	applied	\N	\N	\N	\N	144419	144419	311822
18708	25885	0	applied	\N	\N	\N	\N	144435	144435	311838
18708	25886	1	applied	\N	\N	\N	\N	144436	144436	311839
18708	25887	2	applied	\N	\N	\N	\N	144437	144437	311840
18708	25888	3	applied	\N	\N	\N	\N	144438	144438	311841
18708	25889	4	applied	\N	\N	\N	\N	144439	144439	311842
18711	25578	0	applied	\N	\N	\N	\N	144442	144442	311845
18711	25594	1	applied	\N	\N	\N	\N	144443	144443	311846
18711	25615	2	applied	\N	\N	\N	\N	144444	144444	311847
18711	25634	4	applied	\N	\N	\N	\N	144446	144446	311849
18711	25640	5	applied	\N	\N	\N	\N	144447	144447	311850
18711	25643	6	applied	\N	\N	\N	\N	144448	144448	311851
18711	25768	7	applied	\N	\N	\N	\N	144449	144449	311852
18711	25769	8	applied	\N	\N	\N	\N	144450	144450	311853
18711	25772	9	applied	\N	\N	\N	\N	144451	144451	311854
18711	25773	10	applied	\N	\N	\N	\N	144452	144452	311855
18711	25657	12	applied	\N	\N	1000000000	\N	144454	144454	311857
18711	25817	13	applied	\N	\N	1000000000	\N	144455	144455	311858
18711	25674	14	applied	\N	\N	1000000000	\N	144456	144456	311859
18711	25702	15	applied	\N	\N	1000000000	\N	144457	144457	311860
18711	25820	16	applied	\N	\N	1000000000	\N	144458	144458	311861
18711	25824	17	applied	\N	\N	1000000000	\N	144459	144459	311862
18711	25826	19	applied	\N	\N	1000000000	\N	144461	144461	311864
18711	25848	20	applied	\N	\N	\N	\N	144462	144462	311865
18711	25807	21	applied	\N	\N	\N	\N	144463	144463	311866
18711	25766	22	applied	\N	\N	1000000000	\N	144464	144464	311867
18711	25734	23	applied	\N	\N	\N	\N	144465	144465	311868
18711	25813	24	applied	\N	\N	\N	\N	144466	144466	311869
18711	25799	25	applied	\N	\N	\N	\N	144467	144467	311870
18711	25660	26	applied	\N	\N	\N	\N	144468	144468	311871
18716	25906	0	applied	\N	\N	\N	\N	144494	144494	311897
18716	25907	1	applied	\N	\N	\N	\N	144495	144495	311898
18718	25908	0	applied	\N	\N	\N	\N	144498	144498	311901
18718	25909	1	applied	\N	\N	\N	\N	144499	144499	311902
18718	25910	2	applied	\N	\N	\N	\N	144500	144500	311903
18721	25917	0	applied	\N	\N	\N	\N	144507	144507	311910
18721	25918	1	applied	\N	\N	\N	\N	144508	144508	311911
18721	25919	2	applied	\N	\N	\N	\N	144509	144509	311912
18724	25926	0	applied	\N	\N	\N	\N	144519	144519	311922
18724	25927	1	applied	\N	\N	\N	\N	144520	144520	311923
18724	25928	2	applied	\N	\N	\N	\N	144521	144521	311924
18726	25926	0	applied	\N	\N	\N	\N	144525	144525	311928
18726	25928	2	applied	\N	\N	\N	\N	144527	144527	311930
18731	25933	0	applied	\N	\N	\N	\N	144534	144534	311937
18731	25934	1	applied	\N	\N	\N	\N	144535	144535	311938
18731	25935	2	applied	\N	\N	\N	\N	144536	144536	311939
18731	25936	3	applied	\N	\N	\N	\N	144537	144537	311940
18731	25937	4	applied	\N	\N	\N	\N	144538	144538	311941
18734	25942	0	applied	\N	\N	\N	\N	144548	144548	311951
18734	25943	1	applied	\N	\N	\N	\N	144549	144549	311952
18734	25944	2	applied	\N	\N	\N	\N	144550	144550	311953
18734	25945	3	applied	\N	\N	\N	\N	144551	144551	311954
18734	25946	4	applied	\N	\N	\N	\N	144552	144552	311955
18734	25947	5	applied	\N	\N	\N	\N	144553	144553	311956
18734	25948	6	applied	\N	\N	\N	\N	144554	144554	311957
18736	25942	0	applied	\N	\N	\N	\N	144558	144558	311961
18736	25943	1	applied	\N	\N	\N	\N	144559	144559	311962
18736	25944	2	applied	\N	\N	\N	\N	144560	144560	311963
18736	25946	4	applied	\N	\N	\N	\N	144562	144562	311965
18736	25947	5	applied	\N	\N	\N	\N	144563	144563	311966
18736	25948	6	applied	\N	\N	\N	\N	144564	144564	311967
18739	25949	0	applied	\N	\N	\N	\N	144576	144576	311979
18739	25950	1	applied	\N	\N	\N	\N	144577	144577	311980
18739	25951	2	applied	\N	\N	\N	\N	144578	144578	311981
18739	25952	3	applied	\N	\N	\N	\N	144579	144579	311982
18741	25953	0	applied	\N	\N	\N	\N	144583	144583	311986
18741	25954	1	applied	\N	\N	\N	\N	144584	144584	311987
18741	25955	2	applied	\N	\N	\N	\N	144585	144585	311988
18741	25956	3	applied	\N	\N	\N	\N	144586	144586	311989
18741	25957	4	applied	\N	\N	\N	\N	144587	144587	311990
18746	25967	0	applied	\N	\N	\N	\N	144601	144601	312004
18746	25968	1	applied	\N	\N	\N	\N	144602	144602	312005
18754	25986	1	applied	\N	\N	\N	\N	144627	144627	312030
18754	25987	2	applied	\N	\N	\N	\N	144628	144628	312031
18754	25988	3	applied	\N	\N	\N	\N	144629	144629	312032
18756	25989	0	applied	\N	\N	\N	\N	144632	144632	312035
18756	25990	1	applied	\N	\N	\N	\N	144633	144633	312036
18761	25996	0	applied	\N	\N	\N	\N	144644	144644	312047
18761	25997	1	applied	\N	\N	\N	\N	144645	144645	312048
18761	25998	2	applied	\N	\N	\N	\N	144646	144646	312049
18764	25996	0	applied	\N	\N	\N	\N	144653	144653	312056
18764	25997	1	applied	\N	\N	\N	\N	144654	144654	312057
18764	25998	2	applied	\N	\N	\N	\N	144655	144655	312058
18765	25996	0	applied	\N	\N	\N	\N	144656	144656	312059
18765	25997	1	applied	\N	\N	\N	\N	144657	144657	312060
18765	25998	2	applied	\N	\N	\N	\N	144658	144658	312061
18774	26007	0	applied	\N	\N	\N	\N	144678	144678	312079
18774	26008	1	applied	\N	\N	\N	\N	144679	144679	312080
18777	26019	0	applied	\N	\N	\N	\N	144692	144692	312093
18777	26020	1	applied	\N	\N	\N	\N	144693	144693	312094
18777	26021	2	applied	\N	\N	\N	\N	144694	144694	312095
18789	26034	0	applied	\N	\N	\N	\N	144730	144730	312131
18789	26036	2	applied	\N	\N	\N	\N	144732	144732	312133
18789	26037	3	applied	\N	\N	\N	\N	144733	144733	312134
18789	26038	4	applied	\N	\N	\N	\N	144734	144734	312135
18794	26041	0	applied	\N	\N	\N	\N	144748	144748	312149
18794	26042	1	applied	\N	\N	\N	\N	144749	144749	312150
18794	26043	2	applied	\N	\N	\N	\N	144750	144750	312151
18794	26044	3	applied	\N	\N	\N	\N	144751	144751	312152
18794	26045	4	applied	\N	\N	\N	\N	144752	144752	312153
18794	26046	5	applied	\N	\N	\N	\N	144753	144753	312154
18795	26047	0	applied	\N	\N	\N	\N	144754	144754	312155
18795	26048	1	applied	\N	\N	\N	\N	144755	144755	312156
18795	26049	2	applied	\N	\N	\N	\N	144756	144756	312157
18795	26050	3	applied	\N	\N	\N	\N	144757	144757	312158
18699	25863	37	applied	\N	\N	\N	\N	144406	144406	311809
18702	25869	0	applied	\N	\N	\N	\N	144415	144415	311818
18757	25992	1	applied	\N	\N	\N	\N	144635	144635	312038
18759	25993	0	applied	\N	\N	\N	\N	144638	144638	312041
18759	25994	1	applied	\N	\N	\N	\N	144639	144639	312042
18759	25995	2	applied	\N	\N	\N	\N	144640	144640	312043
18768	26002	0	applied	\N	\N	\N	\N	144665	144665	312066
18768	26003	1	applied	\N	\N	\N	\N	144666	144666	312067
18770	26002	0	applied	\N	\N	\N	\N	144669	144669	312070
18770	26003	1	applied	\N	\N	\N	\N	144670	144670	312071
18772	26004	0	applied	\N	\N	\N	\N	144673	144673	312074
18772	26005	1	applied	\N	\N	\N	\N	144674	144674	312075
18772	26006	2	applied	\N	\N	\N	\N	144675	144675	312076
18775	26007	0	applied	\N	\N	\N	\N	144680	144680	312081
18775	26008	1	applied	\N	\N	\N	\N	144681	144681	312082
18778	26019	0	applied	\N	\N	\N	\N	144695	144695	312096
18778	26021	2	applied	\N	\N	\N	\N	144697	144697	312098
18780	26022	0	applied	\N	\N	\N	\N	144701	144701	312102
18780	26023	1	applied	\N	\N	\N	\N	144702	144702	312103
18782	26022	0	applied	\N	\N	\N	\N	144705	144705	312106
18782	26023	1	applied	\N	\N	\N	\N	144706	144706	312107
18785	26027	0	applied	\N	\N	\N	\N	144713	144713	312114
18785	26028	1	applied	\N	\N	\N	\N	144714	144714	312115
18785	26029	2	applied	\N	\N	\N	\N	144715	144715	312116
18785	26030	3	applied	\N	\N	\N	\N	144716	144716	312117
18785	26031	4	applied	\N	\N	\N	\N	144717	144717	312118
18787	26032	0	applied	\N	\N	\N	\N	144723	144723	312124
18787	26033	1	applied	\N	\N	\N	\N	144724	144724	312125
18792	26039	0	applied	\N	\N	\N	\N	144740	144740	312141
18792	26040	1	applied	\N	\N	\N	\N	144741	144741	312142
18795	26051	4	applied	\N	\N	\N	\N	144758	144758	312159
18795	26052	5	applied	\N	\N	\N	\N	144759	144759	312160
18795	26054	7	applied	\N	\N	\N	\N	144761	144761	312162
18795	26055	8	applied	\N	\N	\N	\N	144762	144762	312163
18795	26056	9	applied	\N	\N	\N	\N	144763	144763	312164
18795	26057	10	applied	\N	\N	\N	\N	144764	144764	312165
18796	26058	0	applied	\N	\N	\N	\N	144765	144765	312166
18796	26059	1	applied	\N	\N	\N	\N	144766	144766	312167
18796	26060	2	applied	\N	\N	\N	\N	144767	144767	312168
18798	26058	0	applied	\N	\N	\N	\N	144771	144771	312172
18798	26059	1	applied	\N	\N	\N	\N	144772	144772	312173
18798	26060	2	applied	\N	\N	\N	\N	144773	144773	312174
18800	26061	0	applied	\N	\N	\N	\N	144777	144777	312178
18800	26062	1	applied	\N	\N	\N	\N	144778	144778	312179
18803	26065	0	applied	\N	\N	\N	\N	144786	144786	312187
18803	26066	1	applied	\N	\N	\N	\N	144787	144787	312188
18803	26067	2	applied	\N	\N	\N	\N	144788	144788	312189
18803	26068	3	applied	\N	\N	\N	\N	144789	144789	312190
18805	26072	0	applied	\N	\N	\N	\N	144793	144793	312194
18805	26073	1	applied	\N	\N	\N	\N	144794	144794	312195
18807	26074	0	applied	\N	\N	\N	\N	144798	144798	312199
18807	26075	1	applied	\N	\N	\N	\N	144799	144799	312200
18807	26076	2	applied	\N	\N	\N	\N	144800	144800	312201
18808	26074	0	applied	\N	\N	\N	\N	144801	144801	312202
18808	26075	1	applied	\N	\N	\N	\N	144802	144802	312203
18808	26076	2	applied	\N	\N	\N	\N	144803	144803	312204
18810	26077	0	applied	\N	\N	\N	\N	144806	144806	312207
18810	26078	1	applied	\N	\N	\N	\N	144807	144807	312208
18812	26079	0	applied	\N	\N	\N	\N	144810	144810	312211
18812	26080	1	applied	\N	\N	\N	\N	144811	144811	312212
18812	26081	2	applied	\N	\N	\N	\N	144812	144812	312213
18812	26082	3	applied	\N	\N	\N	\N	144813	144813	312214
18812	26083	4	applied	\N	\N	\N	\N	144814	144814	312215
18813	26079	0	applied	\N	\N	\N	\N	144815	144815	312216
18813	26081	2	applied	\N	\N	\N	\N	144817	144817	312218
18813	26082	3	applied	\N	\N	\N	\N	144818	144818	312219
18813	26083	4	applied	\N	\N	\N	\N	144819	144819	312220
18815	26084	0	applied	\N	\N	\N	\N	144825	144825	312226
18817	26085	0	applied	\N	\N	\N	\N	144827	144827	312228
18821	26088	0	applied	\N	\N	\N	\N	144831	144831	312232
18822	26089	0	applied	\N	\N	\N	\N	144832	144832	312233
18824	26090	0	applied	\N	\N	\N	\N	144835	144835	312236
18824	26091	1	applied	\N	\N	\N	\N	144836	144836	312237
18826	26092	0	applied	\N	\N	\N	\N	144839	144839	312240
18828	26093	0	applied	\N	\N	\N	\N	144841	144841	312242
18829	26093	0	applied	\N	\N	\N	\N	144842	144842	312243
18831	26094	0	applied	\N	\N	\N	\N	144844	144844	312245
18831	26095	1	applied	\N	\N	\N	\N	144845	144845	312246
18831	26096	2	applied	\N	\N	\N	\N	144846	144846	312247
18833	26098	0	applied	\N	\N	\N	\N	144848	144848	312249
18834	26100	1	applied	\N	\N	\N	\N	144850	144850	312251
18836	26102	0	applied	\N	\N	\N	\N	144852	144852	312253
18839	26106	0	applied	\N	\N	\N	\N	144857	144857	312258
18842	26109	0	applied	\N	\N	\N	\N	144861	144861	312262
18842	26110	1	applied	\N	\N	\N	\N	144862	144862	312263
18845	26115	0	applied	\N	\N	\N	\N	144867	144867	312268
18845	26116	1	applied	\N	\N	\N	\N	144868	144868	312269
18845	26117	2	applied	\N	\N	\N	\N	144869	144869	312270
18850	26122	0	applied	\N	\N	\N	\N	144877	144877	312278
18853	26122	0	applied	\N	\N	\N	\N	144880	144880	312281
18857	26127	0	applied	\N	\N	\N	\N	144886	144886	312287
18860	26129	0	applied	\N	\N	\N	\N	144889	144889	312290
18860	26130	1	applied	\N	\N	\N	\N	144890	144890	312291
18860	26131	2	applied	\N	\N	\N	\N	144891	144891	312292
18865	26134	0	applied	\N	\N	\N	\N	144901	144901	312302
18865	26135	1	applied	\N	\N	\N	\N	144902	144902	312303
18877	26144	0	applied	\N	\N	\N	\N	144991	144991	312392
18882	26152	0	applied	\N	\N	\N	\N	144999	144999	312400
18890	26161	0	applied	\N	\N	\N	\N	145011	145011	312412
18890	26162	1	applied	\N	\N	\N	\N	145012	145012	312413
18893	26163	0	applied	\N	\N	\N	\N	145017	145017	312418
18893	26164	1	applied	\N	\N	\N	\N	145018	145018	312419
18899	26167	0	applied	\N	\N	\N	\N	145029	145029	312430
18899	26168	1	applied	\N	\N	\N	\N	145030	145030	312431
18902	25518	0	applied	\N	\N	\N	\N	145034	145034	145034
18902	25538	1	applied	\N	\N	1000000000	\N	145035	145035	312435
18902	25578	2	applied	\N	\N	\N	\N	145036	145036	312436
18902	25594	3	applied	\N	\N	\N	\N	145037	145037	312437
18902	25615	4	applied	\N	\N	\N	\N	145038	145038	312438
18902	25622	5	applied	\N	\N	\N	\N	145039	145039	312439
18904	26169	0	applied	\N	\N	\N	\N	145043	145043	312443
18904	26170	1	applied	\N	\N	\N	\N	145044	145044	312444
18757	25991	0	applied	\N	\N	\N	\N	144634	144634	312037
18779	26020	1	applied	\N	\N	\N	\N	144699	144699	312100
18779	26021	2	applied	\N	\N	\N	\N	144700	144700	312101
18781	26022	0	applied	\N	\N	\N	\N	144703	144703	312104
18781	26023	1	applied	\N	\N	\N	\N	144704	144704	312105
18783	26024	0	applied	\N	\N	\N	\N	144707	144707	312108
18783	26025	1	applied	\N	\N	\N	\N	144708	144708	312109
18783	26026	2	applied	\N	\N	\N	\N	144709	144709	312110
18788	26034	0	applied	\N	\N	\N	\N	144725	144725	312126
18788	26035	1	applied	\N	\N	\N	\N	144726	144726	312127
18788	26036	2	applied	\N	\N	\N	\N	144727	144727	312128
18788	26037	3	applied	\N	\N	\N	\N	144728	144728	312129
18788	26038	4	applied	\N	\N	\N	\N	144729	144729	312130
18790	26036	0	applied	\N	\N	\N	\N	144735	144735	312136
18790	26037	1	applied	\N	\N	\N	\N	144736	144736	312137
18790	26038	2	applied	\N	\N	\N	\N	144737	144737	312138
18793	26041	0	applied	\N	\N	\N	\N	144742	144742	312143
18793	26043	2	applied	\N	\N	\N	\N	144744	144744	312145
18793	26044	3	applied	\N	\N	\N	\N	144745	144745	312146
18793	26045	4	applied	\N	\N	\N	\N	144746	144746	312147
18793	26046	5	applied	\N	\N	\N	\N	144747	144747	312148
18797	26058	0	applied	\N	\N	\N	\N	144768	144768	312169
18797	26059	1	applied	\N	\N	\N	\N	144769	144769	312170
18797	26060	2	applied	\N	\N	\N	\N	144770	144770	312171
18801	26063	0	applied	\N	\N	\N	\N	144779	144779	312180
18801	26064	1	applied	\N	\N	\N	\N	144780	144780	312181
18806	26074	0	applied	\N	\N	\N	\N	144795	144795	312196
18806	26075	1	applied	\N	\N	\N	\N	144796	144796	312197
18806	26076	2	applied	\N	\N	\N	\N	144797	144797	312198
18818	26086	0	applied	\N	\N	\N	\N	144828	144828	312229
18818	26087	1	applied	\N	\N	\N	\N	144829	144829	312230
18820	26088	0	applied	\N	\N	\N	\N	144830	144830	312231
18825	26090	0	applied	\N	\N	\N	\N	144837	144837	312238
18827	26093	0	applied	\N	\N	\N	\N	144840	144840	312241
18830	26093	0	applied	\N	\N	\N	\N	144843	144843	312244
18832	26097	0	applied	\N	\N	\N	\N	144847	144847	312248
18837	26102	0	applied	\N	\N	\N	\N	144853	144853	312254
18843	26111	0	applied	\N	\N	\N	\N	144863	144863	312264
18843	26112	1	applied	\N	\N	\N	\N	144864	144864	312265
18843	26113	2	applied	\N	\N	\N	\N	144865	144865	312266
18846	26115	0	applied	\N	\N	\N	\N	144870	144870	312271
18846	26116	1	applied	\N	\N	\N	\N	144871	144871	312272
18846	26117	2	applied	\N	\N	\N	\N	144872	144872	312273
18848	26119	0	applied	\N	\N	\N	\N	144874	144874	312275
18851	26122	0	applied	\N	\N	\N	\N	144878	144878	312279
18855	26123	0	applied	\N	\N	\N	\N	144882	144882	312283
18855	26124	1	applied	\N	\N	\N	\N	144883	144883	312284
18858	26128	0	applied	\N	\N	\N	\N	144887	144887	312288
18861	26129	0	applied	\N	\N	\N	\N	144892	144892	312293
18861	26131	2	applied	\N	\N	\N	\N	144894	144894	312295
18863	26132	0	applied	\N	\N	\N	\N	144897	144897	312298
18863	26133	1	applied	\N	\N	\N	\N	144898	144898	312299
18868	26139	0	applied	\N	\N	\N	\N	144906	144906	312307
18873	26144	0	applied	\N	\N	\N	\N	144917	144917	312318
18880	26149	0	applied	\N	\N	\N	\N	144996	144996	312397
18883	26153	0	applied	\N	\N	\N	\N	145000	145000	312401
18885	26154	0	applied	\N	\N	\N	\N	145002	145002	312403
18885	26155	1	applied	\N	\N	\N	\N	145003	145003	312404
18888	26160	0	applied	\N	\N	\N	\N	145008	145008	312409
18891	26163	0	applied	\N	\N	\N	\N	145013	145013	312414
18891	26164	1	applied	\N	\N	\N	\N	145014	145014	312415
18894	26163	0	applied	\N	\N	\N	\N	145019	145019	312420
18894	26164	1	applied	\N	\N	\N	\N	145020	145020	312421
18897	26165	0	applied	\N	\N	\N	\N	145027	145027	312428
18904	26171	2	applied	\N	\N	\N	\N	145045	145045	312445
18906	26173	0	applied	\N	\N	\N	\N	145048	145048	312448
18907	26178	4	applied	\N	\N	\N	\N	145053	145053	312453
18910	26179	0	applied	\N	\N	\N	\N	145054	145054	312454
18912	26182	0	applied	\N	\N	\N	\N	145057	145057	312457
18912	26183	1	applied	\N	\N	\N	\N	145058	145058	312458
18915	26184	0	applied	\N	\N	\N	\N	145063	145063	312463
18922	26191	0	applied	\N	\N	\N	\N	145119	145119	312519
18924	26192	0	applied	\N	\N	\N	\N	145121	145121	312521
18927	26195	0	applied	\N	\N	\N	\N	145125	145125	312525
18931	26197	0	applied	\N	\N	\N	\N	145129	145129	312529
18931	26198	1	applied	\N	\N	\N	\N	145130	145130	312530
18933	26197	0	applied	\N	\N	\N	\N	145133	145133	312533
18933	26198	1	applied	\N	\N	\N	\N	145134	145134	312534
18938	26202	0	applied	\N	\N	\N	\N	145139	145139	312539
18938	26203	1	applied	\N	\N	\N	\N	145140	145140	312540
18940	26204	0	applied	\N	\N	\N	\N	145143	145143	312543
18941	26205	0	applied	\N	\N	\N	\N	145144	145144	312544
18941	26206	1	applied	\N	\N	\N	\N	145145	145145	312545
18776	26017	9	applied	\N	\N	\N	\N	144690	144690	312091
18776	26018	10	applied	\N	\N	\N	\N	144691	144691	312092
18854	26122	0	applied	\N	\N	\N	\N	144881	144881	312282
18859	26128	0	applied	\N	\N	\N	\N	144888	144888	312289
18862	26132	0	applied	\N	\N	\N	\N	144895	144895	312296
18862	26133	1	applied	\N	\N	\N	\N	144896	144896	312297
18867	26137	0	applied	\N	\N	\N	\N	144904	144904	312305
18867	26138	1	applied	\N	\N	\N	\N	144905	144905	312306
18870	26140	0	applied	\N	\N	\N	\N	144910	144910	312311
18870	26141	1	applied	\N	\N	\N	\N	144911	144911	312312
18870	26142	2	applied	\N	\N	\N	\N	144912	144912	312313
18872	26143	0	applied	\N	\N	\N	\N	144916	144916	312317
18874	26144	0	applied	\N	\N	\N	\N	144918	144918	312319
18879	26148	0	applied	\N	\N	\N	\N	144995	144995	312396
18887	26157	0	applied	\N	\N	\N	\N	145005	145005	312406
18887	26158	1	applied	\N	\N	\N	\N	145006	145006	312407
18887	26159	2	applied	\N	\N	\N	\N	145007	145007	312408
18896	26161	0	applied	\N	\N	\N	\N	145023	145023	312424
18896	26163	2	applied	\N	\N	\N	\N	145025	145025	312426
18896	26164	3	applied	\N	\N	\N	\N	145026	145026	312427
18901	26169	0	applied	\N	\N	\N	\N	145033	145033	312434
18911	26180	0	applied	\N	\N	\N	\N	145055	145055	312455
18920	26189	34	applied	\N	\N	\N	\N	145106	145106	312506
18920	26147	35	applied	\N	\N	\N	\N	145107	145107	312507
18920	26151	36	applied	\N	\N	\N	\N	145108	145108	312508
18920	26155	37	applied	\N	\N	\N	\N	145109	145109	312509
18920	26159	38	applied	\N	\N	\N	\N	145110	145110	312510
18920	26164	39	applied	\N	\N	\N	\N	145111	145111	312511
18920	26168	40	applied	\N	\N	\N	\N	145112	145112	312512
18920	26172	41	applied	\N	\N	\N	\N	145113	145113	312513
18920	26178	42	applied	\N	\N	\N	\N	145114	145114	312514
18920	26181	43	applied	\N	\N	\N	\N	145115	145115	312515
18920	26185	44	applied	\N	\N	\N	\N	145116	145116	312516
18920	26190	45	applied	\N	\N	\N	\N	145117	145117	312517
18923	26191	0	applied	\N	\N	\N	\N	145120	145120	312520
18926	26195	0	applied	\N	\N	\N	\N	145124	145124	312524
18928	26195	0	applied	\N	\N	\N	\N	145126	145126	312526
18930	26196	0	applied	\N	\N	\N	\N	145128	145128	312528
18935	26200	0	applied	\N	\N	\N	\N	145136	145136	312536
18937	26201	0	applied	\N	\N	\N	\N	145138	145138	312538
18947	26211	0	applied	\N	\N	\N	\N	145159	145159	312559
18947	26212	1	applied	\N	\N	\N	\N	145160	145160	312560
18947	26213	2	applied	\N	\N	\N	\N	145161	145161	312561
18950	26214	0	applied	\N	\N	\N	\N	145166	145166	312566
18954	26217	0	applied	\N	\N	\N	\N	145171	145171	312571
18954	26218	1	applied	\N	\N	\N	\N	145172	145172	312572
18954	26219	2	applied	\N	\N	\N	\N	145173	145173	312573
18963	26225	0	applied	\N	\N	\N	\N	145187	145187	312587
18965	26226	0	applied	\N	\N	\N	\N	145189	145189	312589
18970	26229	0	applied	\N	\N	\N	\N	145198	145198	312598
18973	26232	0	applied	\N	\N	\N	\N	145203	145203	312603
18973	26233	1	applied	\N	\N	\N	\N	145204	145204	312604
18982	26240	0	applied	\N	\N	\N	\N	145219	145219	312619
18982	26241	1	applied	\N	\N	\N	\N	145220	145220	312620
18984	26242	0	applied	\N	\N	\N	\N	145223	145223	312623
18987	26243	0	applied	\N	\N	\N	\N	145229	145229	312629
18987	26244	1	applied	\N	\N	\N	\N	145230	145230	312630
18987	26245	2	applied	\N	\N	\N	\N	145231	145231	312631
18987	26246	3	applied	\N	\N	\N	\N	145232	145232	312632
18991	26248	0	applied	\N	\N	\N	\N	145239	145239	312639
18991	26249	1	applied	\N	\N	\N	\N	145240	145240	312640
18995	26250	0	applied	\N	\N	\N	\N	145247	145247	312647
19000	26254	0	applied	\N	\N	\N	\N	145254	145254	312654
19011	26259	0	applied	\N	\N	\N	\N	145292	145292	312692
19011	26260	1	applied	\N	\N	\N	\N	145293	145293	312693
19020	26265	0	applied	\N	\N	\N	\N	145308	145308	312708
19020	26267	2	applied	\N	\N	\N	\N	145310	145310	312710
19020	26268	3	applied	\N	\N	\N	\N	145311	145311	312711
19023	26269	0	applied	\N	\N	\N	\N	145317	145317	312717
19028	26278	0	applied	\N	\N	\N	\N	145327	145327	312727
19031	26283	0	applied	\N	\N	\N	\N	145332	145332	312732
19036	26287	0	applied	\N	\N	\N	\N	145338	145338	312738
19047	26302	0	applied	\N	\N	\N	\N	145363	145363	312763
19050	26305	0	applied	\N	\N	\N	\N	145371	145371	312771
19050	26306	1	applied	\N	\N	\N	\N	145372	145372	312772
19050	26307	2	applied	\N	\N	\N	\N	145373	145373	312773
19050	26308	3	applied	\N	\N	\N	\N	145374	145374	312774
19050	26309	4	applied	\N	\N	\N	\N	145375	145375	312775
19053	26311	0	applied	\N	\N	\N	\N	145380	145380	312780
19053	26312	1	applied	\N	\N	\N	\N	145381	145381	312781
19053	26313	2	applied	\N	\N	\N	\N	145382	145382	312782
19054	26314	0	applied	\N	\N	\N	\N	145383	145383	312783
19054	26316	2	applied	\N	\N	\N	\N	145385	145385	312785
19054	26317	3	applied	\N	\N	\N	\N	145386	145386	312786
19054	26318	4	applied	\N	\N	\N	\N	145387	145387	312787
19054	26319	5	applied	\N	\N	\N	\N	145388	145388	312788
19056	26320	0	applied	\N	\N	\N	\N	145391	145391	312791
19056	26321	1	applied	\N	\N	\N	\N	145392	145392	312792
19058	26320	0	applied	\N	\N	\N	\N	145395	145395	312795
19058	26321	1	applied	\N	\N	\N	\N	145396	145396	312796
19065	26333	0	applied	\N	\N	\N	\N	145424	145424	312824
19065	26334	1	applied	\N	\N	\N	\N	145425	145425	312825
19065	26335	2	applied	\N	\N	\N	\N	145426	145426	312826
19065	26336	3	applied	\N	\N	\N	\N	145427	145427	312827
19067	26337	0	applied	\N	\N	\N	\N	145430	145430	145430
19067	26338	1	applied	\N	\N	\N	\N	145431	145431	312829
18841	26108	1	applied	\N	\N	\N	\N	144860	144860	312261
18844	26114	0	applied	\N	\N	\N	\N	144866	144866	312267
18856	26126	1	applied	\N	\N	\N	\N	144885	144885	312286
18864	26134	0	applied	\N	\N	\N	\N	144899	144899	312300
18864	26135	1	applied	\N	\N	\N	\N	144900	144900	312301
18866	26136	0	applied	\N	\N	\N	\N	144903	144903	312304
18869	26140	0	applied	\N	\N	\N	\N	144907	144907	312308
18869	26141	1	applied	\N	\N	\N	\N	144908	144908	312309
18869	26142	2	applied	\N	\N	\N	\N	144909	144909	312310
18871	26140	0	applied	\N	\N	\N	\N	144913	144913	312314
18871	26141	1	applied	\N	\N	\N	\N	144914	144914	312315
18871	26142	2	applied	\N	\N	\N	\N	144915	144915	312316
18876	26074	0	applied	\N	\N	\N	\N	144920	144920	312321
18876	26077	1	applied	\N	\N	\N	\N	144921	144921	312322
18876	26079	2	applied	\N	\N	\N	\N	144922	144922	312323
18876	26080	3	applied	\N	\N	\N	\N	144923	144923	312324
18876	26084	5	applied	\N	\N	\N	\N	144925	144925	312326
18876	26085	6	applied	\N	\N	\N	\N	144926	144926	312327
18876	26086	7	applied	\N	\N	\N	\N	144927	144927	312328
18876	26088	8	applied	\N	\N	\N	\N	144928	144928	312329
18876	26089	9	applied	\N	\N	\N	\N	144929	144929	312330
18876	26090	10	applied	\N	\N	\N	\N	144930	144930	312331
18876	26092	11	applied	\N	\N	\N	\N	144931	144931	312332
18876	26093	12	applied	\N	\N	\N	\N	144932	144932	312333
18876	26094	13	applied	\N	\N	\N	\N	144933	144933	312334
18876	26095	14	applied	\N	\N	\N	\N	144934	144934	312335
18876	26097	15	applied	\N	\N	\N	\N	144935	144935	312336
18876	26098	16	applied	\N	\N	\N	\N	144936	144936	312337
18876	26099	17	applied	\N	\N	\N	\N	144937	144937	312338
18876	26101	18	applied	\N	\N	\N	\N	144938	144938	312339
18876	26102	19	applied	\N	\N	\N	\N	144939	144939	312340
18876	26103	20	applied	\N	\N	\N	\N	144940	144940	312341
18876	26106	22	applied	\N	\N	\N	\N	144942	144942	312343
18876	26107	23	applied	\N	\N	\N	\N	144943	144943	312344
18876	26109	24	applied	\N	\N	\N	\N	144944	144944	312345
18876	26110	25	applied	\N	\N	\N	\N	144945	144945	312346
18876	26111	26	applied	\N	\N	\N	\N	144946	144946	312347
18876	26112	27	applied	\N	\N	\N	\N	144947	144947	312348
18876	26114	28	applied	\N	\N	\N	\N	144948	144948	312349
18876	26115	29	applied	\N	\N	\N	\N	144949	144949	312350
18876	26116	30	applied	\N	\N	\N	\N	144950	144950	312351
18876	26118	31	applied	\N	\N	\N	\N	144951	144951	312352
18876	26119	32	applied	\N	\N	\N	\N	144952	144952	312353
18876	26120	33	applied	\N	\N	\N	\N	144953	144953	312354
18876	26122	34	applied	\N	\N	\N	\N	144954	144954	312355
18876	26123	36	applied	\N	\N	\N	\N	144955	144955	312356
18876	26124	37	applied	\N	\N	\N	\N	144956	144956	312357
18876	26125	38	applied	\N	\N	\N	\N	144957	144957	312358
18876	26128	40	applied	\N	\N	\N	\N	144959	144959	312360
18876	26129	41	applied	\N	\N	\N	\N	144960	144960	312361
18876	26130	42	applied	\N	\N	\N	\N	144961	144961	312362
18876	26132	43	applied	\N	\N	\N	\N	144962	144962	312363
18876	26134	44	applied	\N	\N	\N	\N	144963	144963	312364
18876	26135	45	applied	\N	\N	\N	\N	144964	144964	312365
18876	26136	46	applied	\N	\N	\N	\N	144965	144965	312366
18876	26137	47	applied	\N	\N	\N	\N	144966	144966	312367
18876	26139	48	applied	\N	\N	\N	\N	144967	144967	312368
18876	26140	49	applied	\N	\N	\N	\N	144968	144968	312369
18876	26141	50	applied	\N	\N	\N	\N	144969	144969	312370
18876	26143	51	applied	\N	\N	\N	\N	144970	144970	312371
18876	26144	52	applied	\N	\N	\N	\N	144971	144971	312372
18876	26075	53	applied	\N	\N	\N	\N	144972	144972	312373
18876	26076	54	applied	\N	\N	\N	\N	144973	144973	312374
18876	26083	55	applied	\N	\N	\N	\N	144974	144974	312375
18876	26091	57	applied	\N	\N	\N	\N	144976	144976	312377
18876	26096	58	applied	\N	\N	\N	\N	144977	144977	312378
18876	26100	59	applied	\N	\N	\N	\N	144978	144978	312379
18876	26105	60	applied	\N	\N	\N	\N	144979	144979	312380
18876	26108	61	applied	\N	\N	\N	\N	144980	144980	312381
18876	26113	62	applied	\N	\N	\N	\N	144981	144981	312382
18876	26117	63	applied	\N	\N	\N	\N	144982	144982	312383
18876	26121	64	applied	\N	\N	\N	\N	144983	144983	312384
18876	26078	65	applied	\N	\N	\N	\N	144984	144984	312385
18876	26082	66	applied	\N	\N	\N	\N	144985	144985	312386
18876	26126	67	applied	\N	\N	\N	\N	144986	144986	312387
18876	26131	68	applied	\N	\N	\N	\N	144987	144987	312388
18876	26133	69	applied	\N	\N	\N	\N	144988	144988	312389
18876	26138	70	applied	\N	\N	\N	\N	144989	144989	312390
18876	26142	71	applied	\N	\N	\N	\N	144990	144990	312391
18878	26145	0	applied	\N	\N	\N	\N	144992	144992	312393
18878	26147	2	applied	\N	\N	\N	\N	144994	144994	312395
18881	26150	0	applied	\N	\N	\N	\N	144997	144997	312398
18881	26151	1	applied	\N	\N	\N	\N	144998	144998	312399
18884	26153	0	applied	\N	\N	\N	\N	145001	145001	312402
18886	26156	0	applied	\N	\N	\N	\N	145004	145004	312405
18889	26161	0	applied	\N	\N	\N	\N	145009	145009	312410
18889	26162	1	applied	\N	\N	\N	\N	145010	145010	312411
18892	26163	0	applied	\N	\N	\N	\N	145015	145015	312416
18892	26164	1	applied	\N	\N	\N	\N	145016	145016	312417
18895	26163	0	applied	\N	\N	\N	\N	145021	145021	312422
18895	26164	1	applied	\N	\N	\N	\N	145022	145022	312423
19072	26341	0	applied	\N	\N	\N	\N	145437	145437	312835
19072	26342	1	applied	\N	\N	\N	\N	145438	145438	312836
19074	26341	0	applied	\N	\N	\N	\N	145441	145441	312839
19074	26342	1	applied	\N	\N	\N	\N	145442	145442	312840
19079	26347	0	applied	\N	\N	\N	\N	145449	145449	312847
19087	26362	0	applied	\N	\N	\N	\N	145481	145481	312869
19090	26351	0	applied	\N	\N	\N	\N	145490	145490	145490
19090	26363	1	applied	\N	\N	1000000000	\N	145491	145491	312877
19090	26364	2	applied	\N	\N	\N	\N	145492	145492	312878
19090	26347	3	applied	\N	\N	\N	\N	145493	145493	312879
19090	26348	4	applied	\N	\N	\N	\N	145494	145494	312880
19090	26357	5	applied	\N	\N	\N	\N	145495	145495	145495
19090	26358	6	applied	\N	\N	\N	\N	145496	145496	145496
19090	26359	7	applied	\N	\N	\N	\N	145497	145497	145497
19090	26368	8	applied	\N	\N	\N	\N	145498	145498	145498
19090	26349	9	applied	\N	\N	\N	\N	145499	145499	312881
19090	26352	10	applied	\N	\N	\N	\N	145500	145500	312882
19090	26353	11	applied	\N	\N	\N	\N	145501	145501	312883
19090	26354	12	applied	\N	\N	\N	\N	145502	145502	312884
19090	26355	13	applied	\N	\N	\N	\N	145503	145503	312885
19090	26356	14	applied	\N	\N	\N	\N	145504	145504	312886
18856	26125	0	applied	\N	\N	\N	\N	144884	144884	312285
18903	26170	0	applied	\N	\N	\N	\N	145040	145040	312440
18903	26171	1	applied	\N	\N	\N	\N	145041	145041	312441
18903	26172	2	applied	\N	\N	\N	\N	145042	145042	312442
18905	26173	0	applied	\N	\N	\N	\N	145047	145047	312447
18913	26182	0	applied	\N	\N	\N	\N	145059	145059	312459
18925	26193	0	applied	\N	\N	\N	\N	145122	145122	312522
18925	26194	1	applied	\N	\N	\N	\N	145123	145123	312523
18932	26197	0	applied	\N	\N	\N	\N	145131	145131	312531
18932	26198	1	applied	\N	\N	\N	\N	145132	145132	312532
18934	26199	0	applied	\N	\N	\N	\N	145135	145135	312535
18936	26200	0	applied	\N	\N	\N	\N	145137	145137	312537
18939	26202	0	applied	\N	\N	\N	\N	145141	145141	312541
18939	26203	1	applied	\N	\N	\N	\N	145142	145142	312542
18942	26205	0	applied	\N	\N	\N	\N	145148	145148	312548
18942	26206	1	applied	\N	\N	\N	\N	145149	145149	312549
18942	26207	2	applied	\N	\N	\N	\N	145150	145150	312550
18942	26208	3	applied	\N	\N	\N	\N	145151	145151	312551
18944	26209	0	applied	\N	\N	1000000000	\N	145154	145154	312554
18944	26210	1	applied	\N	\N	\N	\N	145155	145155	312555
18946	26209	0	applied	\N	\N	1000000000	\N	145158	145158	312558
18953	26215	0	applied	\N	\N	\N	\N	145169	145169	312569
18953	26216	1	applied	\N	\N	\N	\N	145170	145170	312570
18955	26220	0	applied	\N	\N	\N	\N	145174	145174	312574
18962	26223	1	applied	\N	\N	\N	\N	145185	145185	312585
18962	26224	2	applied	\N	\N	\N	\N	145186	145186	312586
18964	26225	0	applied	\N	\N	\N	\N	145188	145188	312588
18967	26227	0	applied	\N	\N	\N	\N	145192	145192	312592
18967	26228	1	applied	\N	\N	\N	\N	145193	145193	312593
18969	26227	0	applied	\N	\N	\N	\N	145196	145196	312596
18969	26228	1	applied	\N	\N	\N	\N	145197	145197	312597
18971	26231	0	applied	\N	\N	\N	\N	145200	145200	312600
18979	26239	0	applied	\N	\N	\N	\N	145217	145217	312617
18993	26248	0	applied	\N	\N	\N	\N	145243	145243	312643
18993	26249	1	applied	\N	\N	\N	\N	145244	145244	312644
18994	26248	0	applied	\N	\N	\N	\N	145245	145245	312645
18994	26249	1	applied	\N	\N	\N	\N	145246	145246	312646
19001	26254	0	applied	\N	\N	\N	\N	145255	145255	312655
19006	26255	0	applied	\N	\N	\N	\N	145286	145286	312686
19006	26256	1	applied	\N	\N	\N	\N	145287	145287	312687
19012	26259	0	applied	\N	\N	\N	\N	145294	145294	312694
19012	26260	1	applied	\N	\N	\N	\N	145295	145295	312695
19015	26261	0	applied	\N	\N	\N	\N	145300	145300	312700
19015	26262	1	applied	\N	\N	\N	\N	145301	145301	312701
19021	26265	0	applied	\N	\N	\N	\N	145312	145312	312712
19021	26266	1	applied	\N	\N	\N	\N	145313	145313	312713
19021	26267	2	applied	\N	\N	\N	\N	145314	145314	312714
19021	26268	3	applied	\N	\N	\N	\N	145315	145315	312715
19024	26269	0	applied	\N	\N	\N	\N	145318	145318	312718
19027	26276	0	applied	\N	\N	\N	\N	145325	145325	312725
19027	26277	1	applied	\N	\N	\N	\N	145326	145326	312726
19030	26282	0	applied	\N	\N	\N	\N	145331	145331	312731
19033	26283	0	applied	\N	\N	\N	\N	145334	145334	312734
19037	26288	0	applied	\N	\N	\N	\N	145339	145339	312739
19043	26292	0	applied	\N	\N	\N	\N	145351	145351	312751
19043	26293	1	applied	\N	\N	\N	\N	145352	145352	312752
19043	26295	3	applied	\N	\N	\N	\N	145354	145354	312754
19043	26296	4	applied	\N	\N	\N	\N	145355	145355	312755
19043	26297	5	applied	\N	\N	\N	\N	145356	145356	312756
19046	26302	0	applied	\N	\N	\N	\N	145362	145362	312762
19048	26303	0	applied	\N	\N	\N	\N	145364	145364	312764
19048	26304	1	applied	\N	\N	\N	\N	145365	145365	312765
19049	26305	0	applied	\N	\N	\N	\N	145366	145366	312766
19049	26306	1	applied	\N	\N	\N	\N	145367	145367	312767
19049	26307	2	applied	\N	\N	\N	\N	145368	145368	312768
19049	26308	3	applied	\N	\N	\N	\N	145369	145369	312769
19049	26309	4	applied	\N	\N	\N	\N	145370	145370	312770
19051	26310	0	applied	\N	\N	\N	\N	145376	145376	312776
19055	26320	0	applied	\N	\N	\N	\N	145389	145389	312789
19055	26321	1	applied	\N	\N	\N	\N	145390	145390	312790
19057	26320	0	applied	\N	\N	\N	\N	145393	145393	312793
19057	26321	1	applied	\N	\N	\N	\N	145394	145394	312794
19060	26321	1	applied	\N	\N	\N	\N	145400	145400	312800
19066	26337	0	applied	\N	\N	\N	\N	145428	145428	145428
19066	26338	1	applied	\N	\N	\N	\N	145429	145429	312828
19071	26341	0	applied	\N	\N	\N	\N	145435	145435	312833
19071	26342	1	applied	\N	\N	\N	\N	145436	145436	312834
19075	26343	0	applied	\N	\N	\N	\N	145443	145443	312841
19078	26345	0	applied	\N	\N	\N	\N	145447	145447	312845
19078	26346	1	applied	\N	\N	\N	\N	145448	145448	312846
19080	26348	0	applied	\N	\N	\N	\N	145450	145450	312848
19083	26351	0	applied	\N	\N	\N	\N	145454	145454	145454
19083	26352	1	applied	\N	\N	\N	\N	145455	145455	312852
19083	26353	2	applied	\N	\N	\N	\N	145456	145456	312853
19086	26354	0	applied	\N	\N	\N	\N	145473	145473	312864
19086	26355	1	applied	\N	\N	\N	\N	145474	145474	312865
19086	26356	2	applied	\N	\N	\N	\N	145475	145475	312866
19086	26357	3	applied	\N	\N	\N	\N	145476	145476	145476
19086	26359	5	applied	\N	\N	\N	\N	145478	145478	145478
19086	26360	6	applied	\N	\N	\N	\N	145479	145479	312867
19086	26361	7	applied	\N	\N	1000000000	\N	145480	145480	312868
19096	26322	0	applied	\N	\N	1000000000	\N	145537	145537	312919
19096	26264	1	applied	\N	\N	\N	\N	145538	145538	312920
19096	26324	2	applied	\N	\N	1000000000	\N	145539	145539	312921
19096	26325	3	applied	\N	\N	1000000000	\N	145540	145540	312922
19096	26326	4	applied	\N	\N	1000000000	\N	145541	145541	312923
19096	26327	5	applied	\N	\N	1000000000	\N	145542	145542	312924
19096	26328	6	applied	\N	\N	1000000000	\N	145543	145543	312925
19096	26329	7	applied	\N	\N	1000000000	\N	145544	145544	312926
19096	26330	8	applied	\N	\N	1000000000	\N	145545	145545	312927
19096	26363	9	applied	\N	\N	1000000000	\N	145546	145546	312928
19096	26364	10	applied	\N	\N	\N	\N	145547	145547	312929
19096	26260	11	applied	\N	\N	\N	\N	145548	145548	312930
19096	26267	12	applied	\N	\N	\N	\N	145549	145549	312931
19096	26297	14	applied	\N	\N	\N	\N	145551	145551	312933
19096	26373	15	applied	\N	\N	\N	\N	145552	145552	312934
18900	26167	0	applied	\N	\N	\N	\N	145031	145031	312432
18900	26168	1	applied	\N	\N	\N	\N	145032	145032	312433
18943	26210	1	applied	\N	\N	\N	\N	145153	145153	312553
18945	26209	0	applied	\N	\N	1000000000	\N	145156	145156	312556
18945	26210	1	applied	\N	\N	\N	\N	145157	145157	312557
18948	26211	0	applied	\N	\N	\N	\N	145162	145162	312562
18948	26212	1	applied	\N	\N	\N	\N	145163	145163	312563
18948	26213	2	applied	\N	\N	\N	\N	145164	145164	312564
18952	26215	0	applied	\N	\N	\N	\N	145167	145167	312567
18957	26221	0	applied	\N	\N	\N	\N	145176	145176	312576
18961	26222	0	applied	\N	\N	\N	\N	145181	145181	312581
18961	26223	1	applied	\N	\N	\N	\N	145182	145182	312582
18961	26224	2	applied	\N	\N	\N	\N	145183	145183	312583
18966	26227	0	applied	\N	\N	\N	\N	145190	145190	312590
18966	26228	1	applied	\N	\N	\N	\N	145191	145191	312591
18968	26227	0	applied	\N	\N	\N	\N	145194	145194	312594
18968	26228	1	applied	\N	\N	\N	\N	145195	145195	312595
18974	26232	0	applied	\N	\N	\N	\N	145205	145205	312605
18974	26233	1	applied	\N	\N	\N	\N	145206	145206	312606
18975	26232	0	applied	\N	\N	\N	\N	145207	145207	312607
18975	26233	1	applied	\N	\N	\N	\N	145208	145208	312608
18978	26239	0	applied	\N	\N	\N	\N	145216	145216	312616
18980	26239	0	applied	\N	\N	\N	\N	145218	145218	312618
18983	26240	0	applied	\N	\N	\N	\N	145221	145221	312621
18983	26241	1	applied	\N	\N	\N	\N	145222	145222	312622
18989	26247	0	applied	\N	\N	\N	\N	145237	145237	312637
18992	26248	0	applied	\N	\N	\N	\N	145241	145241	312641
18992	26249	1	applied	\N	\N	\N	\N	145242	145242	312642
18996	26250	0	applied	\N	\N	\N	\N	145248	145248	312648
18998	26252	0	applied	\N	\N	\N	\N	145250	145250	312650
18998	26253	1	applied	\N	\N	\N	\N	145251	145251	312651
19005	26226	0	applied	\N	\N	\N	\N	145256	145256	312656
19005	26227	1	applied	\N	\N	\N	\N	145257	145257	312657
19005	26229	2	applied	\N	\N	\N	\N	145258	145258	312658
19005	26230	3	applied	\N	\N	\N	\N	145259	145259	312659
19005	26231	4	applied	\N	\N	\N	\N	145260	145260	312660
19005	26232	5	applied	\N	\N	\N	\N	145261	145261	312661
19005	26234	6	applied	\N	\N	\N	\N	145262	145262	312662
19005	26235	7	applied	\N	\N	\N	\N	145263	145263	312663
19005	26236	8	applied	\N	\N	\N	\N	145264	145264	312664
19005	26237	9	applied	\N	\N	\N	\N	145265	145265	312665
19005	26240	11	applied	\N	\N	\N	\N	145267	145267	312667
19005	26242	12	applied	\N	\N	\N	\N	145268	145268	312668
19005	26243	13	applied	\N	\N	\N	\N	145269	145269	312669
19005	26247	14	applied	\N	\N	\N	\N	145270	145270	312670
19005	26248	15	applied	\N	\N	\N	\N	145271	145271	312671
19005	26250	16	applied	\N	\N	\N	\N	145272	145272	312672
19005	26251	17	applied	\N	\N	\N	\N	145273	145273	312673
19005	26252	18	applied	\N	\N	\N	\N	145274	145274	312674
19005	26254	19	applied	\N	\N	\N	\N	145275	145275	312675
19005	26255	20	applied	\N	\N	\N	\N	145276	145276	312676
19005	26228	21	applied	\N	\N	\N	\N	145277	145277	312677
19005	26233	22	applied	\N	\N	\N	\N	145278	145278	312678
19005	26238	23	applied	\N	\N	\N	\N	145279	145279	312679
19005	26241	24	applied	\N	\N	\N	\N	145280	145280	312680
19005	26249	25	applied	\N	\N	\N	\N	145281	145281	312681
19005	26244	26	applied	\N	\N	\N	\N	145282	145282	312682
19005	26246	28	applied	\N	\N	\N	\N	145284	145284	312684
19005	26253	29	applied	\N	\N	\N	\N	145285	145285	312685
19007	26257	0	applied	\N	\N	\N	\N	145288	145288	312688
19010	26258	0	applied	\N	\N	\N	\N	145291	145291	312691
19014	26261	0	applied	\N	\N	\N	\N	145298	145298	312698
19014	26262	1	applied	\N	\N	\N	\N	145299	145299	312699
19018	26263	0	applied	\N	\N	\N	\N	145306	145306	312706
19018	26264	1	applied	\N	\N	\N	\N	145307	145307	312707
19025	26270	0	applied	\N	\N	\N	\N	145319	145319	312719
19026	26271	0	applied	\N	\N	\N	\N	145320	145320	312720
19026	26272	1	applied	\N	\N	\N	\N	145321	145321	312721
19026	26273	2	applied	\N	\N	\N	\N	145322	145322	312722
19026	26274	3	applied	\N	\N	\N	\N	145323	145323	312723
19026	26275	4	applied	\N	\N	\N	\N	145324	145324	312724
19029	26279	0	applied	\N	\N	\N	\N	145328	145328	312728
19029	26280	1	applied	\N	\N	\N	\N	145329	145329	312729
19032	26283	0	applied	\N	\N	\N	\N	145333	145333	312733
19034	26284	0	applied	\N	\N	\N	\N	145335	145335	312735
19034	26285	1	applied	\N	\N	\N	\N	145336	145336	312736
19039	26289	0	applied	\N	\N	\N	\N	145342	145342	312742
19039	26290	1	applied	\N	\N	\N	\N	145343	145343	312743
19042	26292	0	applied	\N	\N	\N	\N	145345	145345	312745
19042	26293	1	applied	\N	\N	\N	\N	145346	145346	312746
19042	26294	2	applied	\N	\N	\N	\N	145347	145347	312747
19042	26295	3	applied	\N	\N	\N	\N	145348	145348	312748
19042	26296	4	applied	\N	\N	\N	\N	145349	145349	312749
19042	26297	5	applied	\N	\N	\N	\N	145350	145350	312750
19045	26302	0	applied	\N	\N	\N	\N	145361	145361	312761
19059	26320	0	applied	\N	\N	\N	\N	145397	145397	312797
19059	26321	1	applied	\N	\N	\N	\N	145398	145398	312798
19063	26323	1	applied	\N	\N	\N	\N	145414	145414	312814
19063	26324	2	applied	\N	\N	1000000000	\N	145415	145415	312815
19063	26325	3	applied	\N	\N	1000000000	\N	145416	145416	312816
19096	26378	16	applied	\N	\N	\N	\N	145553	145553	312935
19096	26381	17	applied	\N	\N	\N	\N	145554	145554	312936
19096	26244	18	applied	\N	\N	\N	\N	145555	145555	312937
19096	26245	19	applied	\N	\N	\N	\N	145556	145556	312938
19096	26246	20	applied	\N	\N	\N	\N	145557	145557	312939
19096	26375	21	applied	\N	\N	\N	\N	145558	145558	312940
19096	26377	22	applied	\N	\N	\N	\N	145559	145559	312941
19096	26380	23	applied	\N	\N	\N	\N	145560	145560	312942
19103	26385	0	applied	\N	\N	\N	\N	145588	145588	312970
19103	26386	1	applied	\N	\N	\N	\N	145589	145589	312971
19103	26387	2	applied	\N	\N	\N	\N	145590	145590	312972
19103	26388	3	applied	\N	\N	\N	\N	145591	145591	312973
19103	26389	4	applied	\N	\N	\N	\N	145592	145592	312974
19103	26390	5	applied	\N	\N	\N	\N	145593	145593	312975
19105	26393	0	applied	\N	\N	\N	\N	145596	145596	312978
19105	26394	1	applied	\N	\N	\N	\N	145597	145597	312979
19105	26395	2	applied	\N	\N	\N	\N	145598	145598	312980
19108	26405	0	applied	\N	\N	\N	\N	145614	145614	312993
19108	26406	1	applied	\N	\N	\N	\N	145615	145615	312994
19108	26407	2	applied	\N	\N	\N	\N	145616	145616	145616
19108	26408	3	applied	\N	\N	\N	\N	145617	145617	312995
18941	26208	3	applied	\N	\N	\N	\N	145147	145147	312547
18943	26209	0	applied	\N	\N	1000000000	\N	145152	145152	312552
18960	26222	0	applied	\N	\N	\N	\N	145178	145178	312578
18960	26223	1	applied	\N	\N	\N	\N	145179	145179	312579
18960	26224	2	applied	\N	\N	\N	\N	145180	145180	312580
18972	26232	0	applied	\N	\N	\N	\N	145201	145201	312601
18976	26232	0	applied	\N	\N	\N	\N	145209	145209	312609
18976	26233	1	applied	\N	\N	\N	\N	145210	145210	312610
18977	26234	0	applied	\N	\N	\N	\N	145211	145211	312611
18977	26235	1	applied	\N	\N	\N	\N	145212	145212	312612
18977	26236	2	applied	\N	\N	\N	\N	145213	145213	312613
18977	26237	3	applied	\N	\N	\N	\N	145214	145214	312614
18977	26238	4	applied	\N	\N	\N	\N	145215	145215	312615
18986	26243	0	applied	\N	\N	\N	\N	145225	145225	312625
18986	26244	1	applied	\N	\N	\N	\N	145226	145226	312626
18986	26245	2	applied	\N	\N	\N	\N	145227	145227	312627
18986	26246	3	applied	\N	\N	\N	\N	145228	145228	312628
18988	26243	0	applied	\N	\N	\N	\N	145233	145233	312633
18988	26244	1	applied	\N	\N	\N	\N	145234	145234	312634
18988	26245	2	applied	\N	\N	\N	\N	145235	145235	312635
18988	26246	3	applied	\N	\N	\N	\N	145236	145236	312636
18990	26247	0	applied	\N	\N	\N	\N	145238	145238	312638
18999	26252	0	applied	\N	\N	\N	\N	145252	145252	312652
18999	26253	1	applied	\N	\N	\N	\N	145253	145253	312653
19009	26258	0	applied	\N	\N	\N	\N	145290	145290	312690
19013	26259	0	applied	\N	\N	\N	\N	145296	145296	312696
19013	26260	1	applied	\N	\N	\N	\N	145297	145297	312697
19016	26261	0	applied	\N	\N	\N	\N	145302	145302	312702
19016	26262	1	applied	\N	\N	\N	\N	145303	145303	312703
19017	26261	0	applied	\N	\N	\N	\N	145304	145304	312704
19017	26262	1	applied	\N	\N	\N	\N	145305	145305	312705
19022	26269	0	applied	\N	\N	\N	\N	145316	145316	312716
19035	26286	0	applied	\N	\N	\N	\N	145337	145337	312737
19038	26289	0	applied	\N	\N	\N	\N	145340	145340	312740
19038	26290	1	applied	\N	\N	\N	\N	145341	145341	312741
19040	26291	0	applied	\N	\N	\N	\N	145344	145344	312744
19044	26298	0	applied	\N	\N	\N	\N	145357	145357	312757
19044	26299	1	applied	\N	\N	\N	\N	145358	145358	312758
19044	26301	3	applied	\N	\N	\N	\N	145360	145360	312760
19052	26311	0	applied	\N	\N	\N	\N	145377	145377	312777
19052	26312	1	applied	\N	\N	\N	\N	145378	145378	312778
19052	26313	2	applied	\N	\N	\N	\N	145379	145379	312779
19061	26320	0	applied	\N	\N	\N	\N	145401	145401	312801
19061	26321	1	applied	\N	\N	\N	\N	145402	145402	312802
19062	26322	0	applied	\N	\N	1000000000	\N	145403	145403	312803
19062	26323	1	applied	\N	\N	\N	\N	145404	145404	312804
19062	26324	2	applied	\N	\N	1000000000	\N	145405	145405	312805
19062	26325	3	applied	\N	\N	1000000000	\N	145406	145406	312806
19062	26326	4	applied	\N	\N	1000000000	\N	145407	145407	312807
19062	26327	5	applied	\N	\N	1000000000	\N	145408	145408	312808
19062	26328	6	applied	\N	\N	1000000000	\N	145409	145409	312809
19062	26329	7	applied	\N	\N	1000000000	\N	145410	145410	312810
19062	26331	9	applied	\N	\N	\N	\N	145412	145412	312812
19063	26326	4	applied	\N	\N	1000000000	\N	145417	145417	312817
19063	26327	5	applied	\N	\N	1000000000	\N	145418	145418	312818
19063	26328	6	applied	\N	\N	1000000000	\N	145419	145419	312819
19063	26329	7	applied	\N	\N	1000000000	\N	145420	145420	312820
19063	26330	8	applied	\N	\N	1000000000	\N	145421	145421	312821
19063	26331	9	applied	\N	\N	\N	\N	145422	145422	312822
19064	26332	0	applied	\N	\N	\N	\N	145423	145423	312823
19068	26339	0	applied	\N	\N	\N	\N	145432	145432	312830
19069	26339	0	applied	\N	\N	\N	\N	145433	145433	312831
19070	26340	0	applied	\N	\N	\N	\N	145434	145434	312832
19073	26341	0	applied	\N	\N	\N	\N	145439	145439	312837
19073	26342	1	applied	\N	\N	\N	\N	145440	145440	312838
19076	26344	0	applied	\N	\N	\N	\N	145444	145444	312842
19077	26345	0	applied	\N	\N	\N	\N	145445	145445	312843
19077	26346	1	applied	\N	\N	\N	\N	145446	145446	312844
19082	26349	0	applied	\N	\N	\N	\N	145452	145452	312850
19082	26350	1	applied	\N	\N	\N	\N	145453	145453	312851
19084	26354	0	applied	\N	\N	\N	\N	145457	145457	312854
19084	26355	1	applied	\N	\N	\N	\N	145458	145458	312855
19084	26357	3	applied	\N	\N	\N	\N	145460	145460	145460
19084	26358	4	applied	\N	\N	\N	\N	145461	145461	145461
19084	26359	5	applied	\N	\N	\N	\N	145462	145462	145462
19084	26360	6	applied	\N	\N	\N	\N	145463	145463	312857
19084	26361	7	applied	\N	\N	1000000000	\N	145464	145464	312858
19085	26354	0	applied	\N	\N	\N	\N	145465	145465	312859
19085	26355	1	applied	\N	\N	\N	\N	145466	145466	312860
19085	26356	2	applied	\N	\N	\N	\N	145467	145467	312861
19085	26357	3	applied	\N	\N	\N	\N	145468	145468	145468
19085	26358	4	applied	\N	\N	\N	\N	145469	145469	145469
19085	26359	5	applied	\N	\N	\N	\N	145470	145470	145470
19085	26360	6	applied	\N	\N	\N	\N	145471	145471	312862
19089	26363	0	applied	\N	\N	1000000000	\N	145483	145483	312871
19089	26364	1	applied	\N	\N	\N	\N	145484	145484	312872
19089	26365	2	applied	\N	\N	\N	\N	145485	145485	312873
19089	26366	3	applied	\N	\N	\N	\N	145486	145486	312874
19089	26368	5	applied	\N	\N	\N	\N	145488	145488	145488
19089	26369	6	applied	\N	\N	\N	\N	145489	145489	312876
19092	26376	0	applied	\N	\N	\N	\N	145525	145525	312907
19092	26377	1	applied	\N	\N	\N	\N	145526	145526	312908
19092	26378	2	applied	\N	\N	\N	\N	145527	145527	312909
19094	26379	0	applied	\N	\N	\N	\N	145531	145531	312913
19094	26380	1	applied	\N	\N	\N	\N	145532	145532	312914
19094	26381	2	applied	\N	\N	\N	\N	145533	145533	312915
19098	26379	0	applied	\N	\N	\N	\N	145564	145564	312946
19098	26380	1	applied	\N	\N	\N	\N	145565	145565	312947
19098	26381	2	applied	\N	\N	\N	\N	145566	145566	312948
19101	26385	0	applied	\N	\N	\N	\N	145576	145576	312958
19101	26386	1	applied	\N	\N	\N	\N	145577	145577	312959
19101	26387	2	applied	\N	\N	\N	\N	145578	145578	312960
19101	26388	3	applied	\N	\N	\N	\N	145579	145579	312961
19101	26389	4	applied	\N	\N	\N	\N	145580	145580	312962
19106	26397	0	applied	\N	\N	\N	\N	145600	145600	145600
19106	26398	1	applied	\N	\N	\N	\N	145601	145601	312982
19106	26399	2	applied	\N	\N	\N	\N	145602	145602	145602
19106	26400	3	applied	\N	\N	\N	\N	145603	145603	312983
19106	26401	4	applied	\N	\N	\N	\N	145604	145604	312984
19106	26402	5	applied	\N	\N	\N	\N	145605	145605	312985
18956	26220	0	applied	\N	\N	\N	\N	145175	145175	312575
18958	26221	0	applied	\N	\N	\N	\N	145177	145177	312577
19091	26371	1	applied	\N	\N	\N	\N	145520	145520	312902
19091	26372	2	applied	\N	\N	\N	\N	145521	145521	312903
19091	26374	3	applied	\N	\N	\N	\N	145522	145522	312904
19091	26373	4	applied	\N	\N	\N	\N	145523	145523	312905
19091	26375	5	applied	\N	\N	\N	\N	145524	145524	312906
19093	26376	0	applied	\N	\N	\N	\N	145528	145528	312910
19093	26377	1	applied	\N	\N	\N	\N	145529	145529	312911
19093	26378	2	applied	\N	\N	\N	\N	145530	145530	312912
19097	26379	0	applied	\N	\N	\N	\N	145561	145561	312943
19097	26380	1	applied	\N	\N	\N	\N	145562	145562	312944
19097	26381	2	applied	\N	\N	\N	\N	145563	145563	312945
19100	26385	0	applied	\N	\N	\N	\N	145570	145570	312952
19100	26386	1	applied	\N	\N	\N	\N	145571	145571	312953
19100	26388	3	applied	\N	\N	\N	\N	145573	145573	312955
19100	26389	4	applied	\N	\N	\N	\N	145574	145574	312956
19100	26390	5	applied	\N	\N	\N	\N	145575	145575	312957
19102	26385	0	applied	\N	\N	\N	\N	145582	145582	312964
19102	26386	1	applied	\N	\N	\N	\N	145583	145583	312965
19102	26387	2	applied	\N	\N	\N	\N	145584	145584	312966
19102	26388	3	applied	\N	\N	\N	\N	145585	145585	312967
19102	26389	4	applied	\N	\N	\N	\N	145586	145586	312968
19102	26390	5	applied	\N	\N	\N	\N	145587	145587	312969
19104	26391	0	applied	\N	\N	\N	\N	145594	145594	312976
19104	26392	1	applied	\N	\N	\N	\N	145595	145595	312977
19106	26403	6	applied	\N	\N	\N	\N	145606	145606	312986
19106	26404	7	applied	\N	\N	\N	\N	145607	145607	312987
19110	26414	0	applied	\N	\N	\N	\N	145623	145623	145623
19110	26415	1	applied	\N	\N	\N	\N	145624	145624	313001
19110	26416	2	applied	\N	\N	\N	\N	145625	145625	313002
19111	26418	1	applied	\N	\N	\N	\N	145627	145627	313004
19113	26419	0	applied	\N	\N	\N	\N	145629	145629	313006
19118	26426	0	applied	\N	\N	\N	\N	145638	145638	313015
19118	26427	1	applied	\N	\N	\N	\N	145639	145639	313016
19120	26426	0	applied	\N	\N	\N	\N	145642	145642	313019
19120	26427	1	applied	\N	\N	\N	\N	145643	145643	313020
19122	26428	0	applied	\N	\N	\N	\N	145672	145672	313049
19122	26429	1	applied	\N	\N	\N	\N	145673	145673	313050
19122	26430	2	applied	\N	\N	\N	\N	145674	145674	313051
19122	26431	3	applied	\N	\N	\N	\N	145675	145675	313052
19123	26428	0	applied	\N	\N	\N	\N	145676	145676	313053
19123	26429	1	applied	\N	\N	\N	\N	145677	145677	313054
19123	26430	2	applied	\N	\N	\N	\N	145678	145678	313055
19123	26431	3	applied	\N	\N	\N	\N	145679	145679	313056
19124	26432	0	applied	\N	\N	\N	\N	145680	145680	313057
19124	26433	1	applied	\N	\N	\N	\N	145681	145681	313058
19125	26433	1	applied	\N	\N	\N	\N	145683	145683	313060
19127	26434	0	applied	\N	\N	\N	\N	145686	145686	313063
19127	26435	1	applied	\N	\N	\N	\N	145687	145687	313064
19129	26434	0	applied	\N	\N	\N	\N	145690	145690	313067
19129	26435	1	applied	\N	\N	\N	\N	145691	145691	313068
19131	26440	0	applied	\N	\N	\N	\N	145745	145745	313122
19131	26441	1	applied	\N	\N	\N	\N	145746	145746	313123
19131	26436	2	applied	\N	\N	1000000000	\N	145747	145747	313124
19131	26438	3	applied	\N	\N	\N	\N	145748	145748	313125
19131	26437	4	applied	\N	\N	\N	\N	145749	145749	313126
19131	26439	5	applied	\N	\N	\N	\N	145750	145750	313127
19132	26440	0	applied	\N	\N	\N	\N	145751	145751	313128
19132	26441	1	applied	\N	\N	\N	\N	145752	145752	313129
19132	26436	2	applied	\N	\N	1000000000	\N	145753	145753	313130
19132	26438	3	applied	\N	\N	\N	\N	145754	145754	313131
19132	26437	4	applied	\N	\N	\N	\N	145755	145755	313132
19134	26448	0	applied	\N	\N	\N	\N	145763	145763	313140
19134	26449	1	applied	\N	\N	\N	\N	145764	145764	313141
19134	26450	2	applied	\N	\N	\N	\N	145765	145765	313142
19134	26451	3	applied	\N	\N	\N	\N	145766	145766	313143
19134	26452	4	applied	\N	\N	\N	\N	145767	145767	313144
19135	26458	0	applied	\N	\N	\N	\N	145773	145773	313150
19135	26459	1	applied	\N	\N	\N	\N	145774	145774	313151
19135	26460	2	applied	\N	\N	\N	\N	145775	145775	313152
19136	26461	0	applied	\N	\N	\N	\N	145776	145776	313153
19136	26462	1	applied	\N	\N	\N	\N	145777	145777	313154
19136	26463	2	applied	\N	\N	\N	\N	145778	145778	313155
19144	26478	0	applied	\N	\N	\N	\N	145808	145808	313185
19144	26479	1	applied	\N	\N	\N	\N	145809	145809	313186
19144	26480	2	applied	\N	\N	\N	\N	145810	145810	313187
19146	26481	0	applied	\N	\N	\N	\N	145814	145814	313191
19146	26482	1	applied	\N	\N	\N	\N	145815	145815	313192
19149	26487	0	applied	\N	\N	\N	\N	145824	145824	313201
19149	26488	1	applied	\N	\N	\N	\N	145825	145825	313202
19149	26489	2	applied	\N	\N	\N	\N	145826	145826	313203
19149	26490	3	applied	\N	\N	\N	\N	145827	145827	313204
19150	26491	0	applied	\N	\N	\N	\N	145828	145828	313205
19150	26492	1	applied	\N	\N	\N	\N	145829	145829	313206
19150	26493	2	applied	\N	\N	\N	\N	145830	145830	313207
19150	26494	3	applied	\N	\N	\N	\N	145831	145831	313208
19150	26495	4	applied	\N	\N	\N	\N	145832	145832	313209
19150	26496	5	applied	\N	\N	\N	\N	145833	145833	313210
19150	26497	6	applied	\N	\N	\N	\N	145834	145834	313211
19150	26498	7	applied	\N	\N	\N	\N	145835	145835	313212
19150	26499	8	applied	\N	\N	\N	\N	145836	145836	313213
19150	26500	9	applied	\N	\N	\N	\N	145837	145837	313214
19150	26501	10	applied	\N	\N	\N	\N	145838	145838	313215
19150	26502	11	applied	\N	\N	\N	\N	145839	145839	313216
19150	26504	13	applied	\N	\N	\N	\N	145841	145841	313218
19150	26505	14	applied	\N	\N	\N	\N	145842	145842	313219
19150	26506	15	applied	\N	\N	\N	\N	145843	145843	313220
19150	26507	16	applied	\N	\N	\N	\N	145844	145844	313221
19150	26508	17	applied	\N	\N	\N	\N	145845	145845	313222
19150	26509	18	applied	\N	\N	\N	\N	145846	145846	313223
19153	26510	0	applied	\N	\N	\N	\N	145855	145855	313232
19153	26511	2	applied	\N	\N	\N	\N	145856	145856	313233
19153	26512	3	applied	\N	\N	\N	\N	145857	145857	313234
19153	26513	4	applied	\N	\N	\N	\N	145858	145858	313235
19159	26521	0	applied	\N	\N	\N	\N	145877	145877	313254
19159	26522	1	applied	\N	\N	\N	\N	145878	145878	313255
19159	26523	2	applied	\N	\N	\N	\N	145879	145879	313256
19159	26524	3	applied	\N	\N	\N	\N	145880	145880	313257
19166	26536	0	applied	\N	\N	\N	\N	145907	145907	313284
19166	26537	1	applied	\N	\N	\N	\N	145908	145908	313285
19088	26362	0	applied	\N	\N	\N	\N	145482	145482	312870
19091	26370	0	applied	\N	\N	\N	\N	145519	145519	312901
19090	26370	19	applied	\N	\N	\N	\N	145509	145509	312891
19090	26371	20	applied	\N	\N	\N	\N	145510	145510	312892
19090	26361	21	applied	\N	\N	1000000000	\N	145511	145511	312893
19090	26372	22	applied	\N	\N	\N	\N	145512	145512	312894
19090	26373	23	applied	\N	\N	\N	\N	145513	145513	312895
19090	26350	24	applied	\N	\N	\N	\N	145514	145514	312896
19090	26360	25	applied	\N	\N	\N	\N	145515	145515	312897
19090	26369	26	applied	\N	\N	\N	\N	145516	145516	312898
19090	26374	27	applied	\N	\N	\N	\N	145517	145517	312899
19090	26375	28	applied	\N	\N	\N	\N	145518	145518	312900
19095	26379	0	applied	\N	\N	\N	\N	145534	145534	312916
19095	26380	1	applied	\N	\N	\N	\N	145535	145535	312917
19095	26381	2	applied	\N	\N	\N	\N	145536	145536	312918
19099	26382	0	applied	\N	\N	\N	\N	145567	145567	312949
19099	26384	2	applied	\N	\N	\N	\N	145569	145569	312951
19107	26405	0	applied	\N	\N	\N	\N	145608	145608	312988
19107	26406	1	applied	\N	\N	\N	\N	145609	145609	312989
19107	26407	2	applied	\N	\N	\N	\N	145610	145610	145610
19107	26408	3	applied	\N	\N	\N	\N	145611	145611	312990
19107	26409	4	applied	\N	\N	\N	\N	145612	145612	312991
19107	26410	5	applied	\N	\N	\N	\N	145613	145613	312992
19109	26411	0	applied	\N	\N	\N	\N	145620	145620	312998
19109	26412	1	applied	\N	\N	\N	\N	145621	145621	312999
19109	26413	2	applied	\N	\N	\N	\N	145622	145622	313000
19112	26419	0	applied	\N	\N	\N	\N	145628	145628	313005
19117	26426	0	applied	\N	\N	\N	\N	145636	145636	313013
19117	26427	1	applied	\N	\N	\N	\N	145637	145637	313014
19119	26426	0	applied	\N	\N	\N	\N	145640	145640	313017
19119	26427	1	applied	\N	\N	\N	\N	145641	145641	313018
19126	26434	0	applied	\N	\N	\N	\N	145684	145684	313061
19128	26434	0	applied	\N	\N	\N	\N	145688	145688	313065
19128	26435	1	applied	\N	\N	\N	\N	145689	145689	313066
19133	26442	0	applied	\N	\N	\N	\N	145757	145757	313134
19133	26443	1	applied	\N	\N	\N	\N	145758	145758	313135
19133	26444	2	applied	\N	\N	\N	\N	145759	145759	313136
19133	26445	3	applied	\N	\N	\N	\N	145760	145760	313137
19133	26446	4	applied	\N	\N	\N	\N	145761	145761	313138
19133	26447	5	applied	\N	\N	\N	\N	145762	145762	313139
19151	26510	0	applied	\N	\N	\N	\N	145847	145847	313224
19151	26511	2	applied	\N	\N	\N	\N	145848	145848	313225
19151	26512	3	applied	\N	\N	\N	\N	145849	145849	313226
19151	26513	4	applied	\N	\N	\N	\N	145850	145850	313227
19158	26518	0	applied	\N	\N	\N	\N	145874	145874	313251
19158	26519	1	applied	\N	\N	\N	\N	145875	145875	313252
19158	26520	2	applied	\N	\N	\N	\N	145876	145876	313253
19161	26525	0	applied	\N	\N	\N	\N	145887	145887	313264
19161	26531	2	applied	\N	\N	\N	\N	145889	145889	313266
19161	26527	3	applied	\N	\N	\N	\N	145890	145890	313267
19161	26532	4	applied	\N	\N	\N	\N	145891	145891	313268
19161	26528	5	applied	\N	\N	\N	\N	145892	145892	313269
19161	26529	6	applied	\N	\N	\N	\N	145893	145893	313270
19161	26530	7	applied	\N	\N	\N	\N	145894	145894	313271
19163	26533	0	applied	\N	\N	\N	\N	145898	145898	313275
19163	26534	1	applied	\N	\N	\N	\N	145899	145899	313276
19163	26535	2	applied	\N	\N	\N	\N	145900	145900	313277
19166	26539	3	applied	\N	\N	\N	\N	145910	145910	313287
19166	26540	4	applied	\N	\N	\N	\N	145911	145911	313288
19166	26541	5	applied	\N	\N	\N	\N	145912	145912	313289
19166	26542	6	applied	\N	\N	\N	\N	145913	145913	313290
19167	26536	0	applied	\N	\N	\N	\N	145914	145914	313291
19167	26537	1	applied	\N	\N	\N	\N	145915	145915	313292
19167	26538	2	applied	\N	\N	\N	\N	145916	145916	313293
19167	26540	4	applied	\N	\N	\N	\N	145918	145918	313295
19167	26541	5	applied	\N	\N	\N	\N	145919	145919	313296
19167	26542	6	applied	\N	\N	\N	\N	145920	145920	313297
19169	26550	0	applied	\N	\N	\N	\N	145928	145928	313305
19169	26551	1	applied	\N	\N	\N	\N	145929	145929	313306
19169	26552	2	applied	\N	\N	\N	\N	145930	145930	313307
19170	26553	0	applied	\N	\N	\N	\N	145931	145931	313308
19170	26554	1	applied	\N	\N	\N	\N	145932	145932	313309
19170	26555	2	applied	\N	\N	\N	\N	145933	145933	313310
19173	26559	0	applied	\N	\N	\N	\N	145940	145940	313317
19173	26560	1	applied	\N	\N	\N	\N	145941	145941	313318
19173	26561	2	applied	\N	\N	\N	\N	145942	145942	313319
19173	26562	3	applied	\N	\N	\N	\N	145943	145943	313320
19173	26563	4	applied	\N	\N	\N	\N	145944	145944	313321
19173	26564	5	applied	\N	\N	\N	\N	145945	145945	313322
19173	26565	6	applied	\N	\N	\N	\N	145946	145946	313323
19173	26567	8	applied	\N	\N	\N	\N	145948	145948	313325
19173	26568	9	applied	\N	\N	\N	\N	145949	145949	313326
19173	26569	10	applied	\N	\N	\N	\N	145950	145950	313327
19173	26570	11	applied	\N	\N	\N	\N	145951	145951	313328
19173	26571	12	applied	\N	\N	\N	\N	145952	145952	313329
19173	26572	13	applied	\N	\N	\N	\N	145953	145953	313330
19176	26577	0	applied	\N	\N	\N	\N	145961	145961	313338
19176	26578	1	applied	\N	\N	\N	\N	145962	145962	313339
19176	26579	2	applied	\N	\N	\N	\N	145963	145963	313340
19177	26580	0	applied	\N	\N	\N	\N	145964	145964	313341
19177	26581	1	applied	\N	\N	\N	\N	145965	145965	313342
19177	26582	2	applied	\N	\N	\N	\N	145966	145966	313343
19179	26583	0	applied	\N	\N	\N	\N	145970	145970	313347
19179	26584	1	applied	\N	\N	\N	\N	145971	145971	313348
19179	26585	2	applied	\N	\N	\N	\N	145972	145972	313349
19179	26586	3	applied	\N	\N	\N	\N	145973	145973	313350
19183	26588	0	applied	\N	\N	\N	\N	146109	146109	146109
19183	26589	1	applied	\N	\N	\N	\N	146110	146110	313485
19183	26590	2	applied	\N	\N	\N	\N	146111	146111	313486
19183	26591	3	applied	\N	\N	\N	\N	146112	146112	313487
19186	26595	0	applied	\N	\N	\N	\N	146118	146118	146118
19186	26596	1	applied	\N	\N	\N	\N	146119	146119	313493
19186	26597	2	applied	\N	\N	\N	\N	146120	146120	313494
19186	26598	3	applied	\N	\N	\N	\N	146121	146121	313495
19186	26599	4	applied	\N	\N	\N	\N	146122	146122	313496
19186	26594	5	applied	\N	\N	\N	\N	146123	146123	313497
19197	26622	0	applied	\N	\N	\N	\N	146171	146171	313544
19197	26623	1	applied	\N	\N	\N	\N	146172	146172	313545
19197	26624	2	applied	\N	\N	\N	\N	146173	146173	313546
19197	26625	3	applied	\N	\N	\N	\N	146174	146174	313547
19197	26626	4	applied	\N	\N	\N	\N	146175	146175	313548
19197	26627	5	applied	\N	\N	\N	\N	146176	146176	313549
19090	26367	18	applied	\N	\N	\N	\N	145508	145508	312890
19116	26422	2	applied	\N	\N	\N	\N	145632	145632	313009
19116	26423	3	applied	\N	\N	\N	\N	145633	145633	313010
19116	26424	4	applied	\N	\N	\N	\N	145634	145634	313011
19116	26425	5	applied	\N	\N	\N	\N	145635	145635	313012
19121	26322	0	applied	\N	\N	1000000000	\N	145644	145644	313021
19121	26209	1	applied	\N	\N	1000000000	\N	145645	145645	313022
19121	26264	2	applied	\N	\N	\N	\N	145646	145646	313023
19121	26325	4	applied	\N	\N	1000000000	\N	145648	145648	313025
19121	26326	5	applied	\N	\N	1000000000	\N	145649	145649	313026
19121	26216	6	applied	\N	\N	\N	\N	145650	145650	313027
19121	26327	7	applied	\N	\N	1000000000	\N	145651	145651	313028
19121	26328	8	applied	\N	\N	1000000000	\N	145652	145652	313029
19121	26329	9	applied	\N	\N	1000000000	\N	145653	145653	313030
19121	26330	10	applied	\N	\N	1000000000	\N	145654	145654	313031
19121	26363	11	applied	\N	\N	1000000000	\N	145655	145655	313032
19121	26364	12	applied	\N	\N	\N	\N	145656	145656	313033
19121	26260	13	applied	\N	\N	\N	\N	145657	145657	313034
19121	26267	14	applied	\N	\N	\N	\N	145658	145658	313035
19121	26198	15	applied	\N	\N	\N	\N	145659	145659	313036
19121	26372	16	applied	\N	\N	\N	\N	145660	145660	313037
19121	26297	17	applied	\N	\N	\N	\N	145661	145661	313038
19121	26373	18	applied	\N	\N	\N	\N	145662	145662	313039
19121	26378	19	applied	\N	\N	\N	\N	145663	145663	313040
19121	26381	20	applied	\N	\N	\N	\N	145664	145664	313041
19121	26384	21	applied	\N	\N	\N	\N	145665	145665	313042
19121	26389	22	applied	\N	\N	\N	\N	145666	145666	313043
19121	26391	24	applied	\N	\N	\N	\N	145668	145668	313045
19121	26395	25	applied	\N	\N	\N	\N	145669	145669	313046
19121	26401	26	applied	\N	\N	\N	\N	145670	145670	313047
19121	26402	28	applied	\N	\N	\N	\N	145671	145671	313048
19130	26322	0	applied	\N	\N	1000000000	\N	145692	145692	313069
19130	26324	1	applied	\N	\N	1000000000	\N	145693	145693	313070
19130	26325	2	applied	\N	\N	1000000000	\N	145694	145694	313071
19130	26326	3	applied	\N	\N	1000000000	\N	145695	145695	313072
19130	26327	4	applied	\N	\N	1000000000	\N	145696	145696	313073
19130	26328	5	applied	\N	\N	1000000000	\N	145697	145697	313074
19130	26329	6	applied	\N	\N	1000000000	\N	145698	145698	313075
19130	26330	7	applied	\N	\N	1000000000	\N	145699	145699	313076
19130	26363	8	applied	\N	\N	1000000000	\N	145700	145700	313077
19130	26364	9	applied	\N	\N	\N	\N	145701	145701	313078
19130	26436	11	applied	\N	\N	1000000000	\N	145703	145703	313080
19130	26372	12	applied	\N	\N	\N	\N	145704	145704	313081
19130	26437	13	applied	\N	\N	\N	\N	145705	145705	313082
19130	26297	14	applied	\N	\N	\N	\N	145706	145706	313083
19130	26373	15	applied	\N	\N	\N	\N	145707	145707	313084
19130	26378	16	applied	\N	\N	\N	\N	145708	145708	313085
19130	26381	17	applied	\N	\N	\N	\N	145709	145709	313086
19130	26384	18	applied	\N	\N	\N	\N	145710	145710	313087
19130	26389	19	applied	\N	\N	\N	\N	145711	145711	313088
19130	26390	20	applied	\N	\N	\N	\N	145712	145712	313089
19130	26391	21	applied	\N	\N	\N	\N	145713	145713	313090
19130	26395	22	applied	\N	\N	\N	\N	145714	145714	313091
19130	26401	23	applied	\N	\N	\N	\N	145715	145715	313092
19130	26402	24	applied	\N	\N	\N	\N	145716	145716	313093
19130	26410	25	applied	\N	\N	\N	\N	145717	145717	313094
19130	26375	26	applied	\N	\N	\N	\N	145718	145718	313095
19130	26377	27	applied	\N	\N	\N	\N	145719	145719	313096
19130	26380	28	applied	\N	\N	\N	\N	145720	145720	313097
19130	26383	29	applied	\N	\N	\N	\N	145721	145721	313098
19130	26387	30	applied	\N	\N	\N	\N	145722	145722	313099
19130	26392	32	applied	\N	\N	\N	\N	145724	145724	313101
19130	26396	33	applied	\N	\N	\N	\N	145725	145725	313102
19130	26403	34	applied	\N	\N	\N	\N	145726	145726	313103
19130	26404	35	applied	\N	\N	\N	\N	145727	145727	313104
19130	26408	36	applied	\N	\N	\N	\N	145728	145728	313105
19130	26409	37	applied	\N	\N	\N	\N	145729	145729	313106
19130	26412	38	applied	\N	\N	\N	\N	145730	145730	313107
19130	26416	39	applied	\N	\N	\N	\N	145731	145731	313108
19130	26418	40	applied	\N	\N	\N	\N	145732	145732	313109
19130	26419	41	applied	\N	\N	\N	\N	145733	145733	313110
19130	26423	42	applied	\N	\N	\N	\N	145734	145734	313111
19130	26424	43	applied	\N	\N	\N	\N	145735	145735	313112
19130	26425	44	applied	\N	\N	\N	\N	145736	145736	313113
19130	26427	45	applied	\N	\N	\N	\N	145737	145737	313114
19130	26430	46	applied	\N	\N	\N	\N	145738	145738	313115
19130	26431	47	applied	\N	\N	\N	\N	145739	145739	313116
19130	26435	49	applied	\N	\N	\N	\N	145741	145741	313118
19130	26438	50	applied	\N	\N	\N	\N	145742	145742	313119
19130	26439	51	applied	\N	\N	\N	\N	145743	145743	313120
19130	26413	52	applied	\N	\N	\N	\N	145744	145744	313121
19137	26464	0	applied	\N	\N	\N	\N	145779	145779	313156
19137	26465	1	applied	\N	\N	\N	\N	145780	145780	313157
19137	26466	2	applied	\N	\N	\N	\N	145781	145781	313158
19137	26467	3	applied	\N	\N	\N	\N	145782	145782	313159
19138	26464	0	applied	\N	\N	\N	\N	145783	145783	313160
19138	26466	1	applied	\N	\N	\N	\N	145784	145784	313161
19138	26467	2	applied	\N	\N	\N	\N	145785	145785	313162
19197	26628	6	applied	\N	\N	\N	\N	146177	146177	313550
19208	26662	0	applied	\N	\N	\N	\N	146363	146363	313734
19208	26663	1	applied	\N	\N	\N	\N	146364	146364	313735
19208	26664	2	applied	\N	\N	\N	\N	146365	146365	313736
19210	26665	0	applied	\N	\N	\N	\N	146369	146369	313740
19210	26667	2	applied	\N	\N	\N	\N	146371	146371	313742
19210	26668	3	applied	\N	\N	\N	\N	146372	146372	313743
19214	26672	0	applied	\N	\N	\N	\N	146383	146383	313754
19214	26673	1	applied	\N	\N	\N	\N	146384	146384	313755
19214	26674	2	applied	\N	\N	\N	\N	146385	146385	313756
19214	26675	3	applied	\N	\N	\N	\N	146386	146386	313757
19214	26676	4	applied	\N	\N	\N	\N	146387	146387	313758
19214	26677	5	applied	\N	\N	\N	\N	146388	146388	313759
19214	26678	6	applied	\N	\N	\N	\N	146389	146389	313760
19214	26679	7	applied	\N	\N	\N	\N	146390	146390	313761
19214	26680	8	applied	\N	\N	\N	\N	146391	146391	313762
19214	26681	9	applied	\N	\N	\N	\N	146392	146392	313763
19214	26682	10	applied	\N	\N	\N	\N	146393	146393	313764
19214	26683	11	applied	\N	\N	\N	\N	146394	146394	313765
19214	26684	12	applied	\N	\N	\N	\N	146395	146395	313766
19108	26410	5	applied	\N	\N	\N	\N	145619	145619	312997
19116	26421	1	applied	\N	\N	\N	\N	145631	145631	313008
19134	26457	9	applied	\N	\N	\N	\N	145772	145772	313149
19139	26464	0	applied	\N	\N	\N	\N	145786	145786	313163
19139	26465	1	applied	\N	\N	\N	\N	145787	145787	313164
19139	26466	2	applied	\N	\N	\N	\N	145788	145788	313165
19139	26467	3	applied	\N	\N	\N	\N	145789	145789	313166
19140	26468	0	applied	\N	\N	\N	\N	145790	145790	313167
19140	26469	1	applied	\N	\N	\N	\N	145791	145791	313168
19140	26470	2	applied	\N	\N	\N	\N	145792	145792	313169
19141	26468	0	applied	\N	\N	\N	\N	145793	145793	313170
19141	26469	1	applied	\N	\N	\N	\N	145794	145794	313171
19141	26470	2	applied	\N	\N	\N	\N	145795	145795	313172
19142	26471	0	applied	\N	\N	\N	\N	145796	145796	313173
19142	26472	1	applied	\N	\N	\N	\N	145797	145797	313174
19142	26473	2	applied	\N	\N	\N	\N	145798	145798	313175
19142	26474	3	applied	\N	\N	\N	\N	145799	145799	313176
19142	26475	4	applied	\N	\N	\N	\N	145800	145800	313177
19142	26477	6	applied	\N	\N	\N	\N	145802	145802	313179
19143	26471	0	applied	\N	\N	\N	\N	145803	145803	313180
19143	26472	1	applied	\N	\N	\N	\N	145804	145804	313181
19143	26473	2	applied	\N	\N	\N	\N	145805	145805	313182
19143	26474	3	applied	\N	\N	\N	\N	145806	145806	313183
19148	26487	0	applied	\N	\N	\N	\N	145820	145820	313197
19148	26488	1	applied	\N	\N	\N	\N	145821	145821	313198
19148	26489	2	applied	\N	\N	\N	\N	145822	145822	313199
19148	26490	3	applied	\N	\N	\N	\N	145823	145823	313200
19152	26510	0	applied	\N	\N	\N	\N	145851	145851	313228
19152	26511	2	applied	\N	\N	\N	\N	145852	145852	313229
19152	26512	3	applied	\N	\N	\N	\N	145853	145853	313230
19152	26513	4	applied	\N	\N	\N	\N	145854	145854	313231
19155	26510	0	applied	\N	\N	\N	\N	145863	145863	313240
19155	26511	2	applied	\N	\N	\N	\N	145864	145864	313241
19155	26512	3	applied	\N	\N	\N	\N	145865	145865	313242
19156	26514	0	applied	\N	\N	\N	\N	145867	145867	313244
19156	26515	1	applied	\N	\N	\N	\N	145868	145868	313245
19156	26516	2	applied	\N	\N	\N	\N	145869	145869	313246
19156	26517	3	applied	\N	\N	\N	\N	145870	145870	313247
19164	26533	0	applied	\N	\N	\N	\N	145901	145901	313278
19164	26534	1	applied	\N	\N	\N	\N	145902	145902	313279
19164	26535	2	applied	\N	\N	\N	\N	145903	145903	313280
19165	26533	0	applied	\N	\N	\N	\N	145904	145904	313281
19165	26534	1	applied	\N	\N	\N	\N	145905	145905	313282
19165	26535	2	applied	\N	\N	\N	\N	145906	145906	313283
19168	26543	0	applied	\N	\N	\N	\N	145921	145921	313298
19168	26544	1	applied	\N	\N	\N	\N	145922	145922	313299
19168	26545	2	applied	\N	\N	\N	\N	145923	145923	313300
19168	26546	3	applied	\N	\N	\N	\N	145924	145924	313301
19168	26547	4	applied	\N	\N	\N	\N	145925	145925	313302
19168	26548	5	applied	\N	\N	\N	\N	145926	145926	313303
19171	26553	0	applied	\N	\N	\N	\N	145934	145934	313311
19171	26554	1	applied	\N	\N	\N	\N	145935	145935	313312
19171	26555	2	applied	\N	\N	\N	\N	145936	145936	313313
19174	26573	0	applied	\N	\N	\N	\N	145954	145954	313331
19174	26574	1	applied	\N	\N	\N	\N	145955	145955	313332
19174	26575	2	applied	\N	\N	\N	\N	145956	145956	313333
19174	26576	3	applied	\N	\N	\N	\N	145957	145957	313334
19181	26583	0	applied	\N	\N	\N	\N	146100	146100	313477
19181	26584	1	applied	\N	\N	\N	\N	146101	146101	313478
19181	26585	2	applied	\N	\N	\N	\N	146102	146102	313479
19181	26586	3	applied	\N	\N	\N	\N	146103	146103	313480
19181	26587	4	applied	\N	\N	\N	\N	146104	146104	313481
19185	26592	0	applied	\N	\N	\N	\N	146116	146116	313491
19185	26593	1	applied	\N	\N	\N	\N	146117	146117	313492
19188	26603	0	applied	\N	\N	\N	\N	146136	146136	313509
19188	26604	1	applied	\N	\N	\N	\N	146137	146137	313510
19190	26606	0	applied	\N	\N	\N	\N	146142	146142	313515
19190	26607	1	applied	\N	\N	\N	\N	146143	146143	313516
19190	26608	2	applied	\N	\N	\N	\N	146144	146144	313517
19193	26616	0	applied	\N	\N	\N	\N	146159	146159	313532
19193	26617	1	applied	\N	\N	\N	\N	146160	146160	313533
19193	26618	2	applied	\N	\N	\N	\N	146161	146161	313534
19195	26616	0	applied	\N	\N	\N	\N	146165	146165	313538
19195	26617	1	applied	\N	\N	\N	\N	146166	146166	313539
19195	26618	2	applied	\N	\N	\N	\N	146167	146167	313540
19198	26622	0	applied	\N	\N	\N	\N	146178	146178	313551
19198	26623	1	applied	\N	\N	\N	\N	146179	146179	313552
19198	26624	2	applied	\N	\N	\N	\N	146180	146180	313553
19198	26625	3	applied	\N	\N	\N	\N	146181	146181	313554
19198	26626	4	applied	\N	\N	\N	\N	146182	146182	313555
19198	26627	5	applied	\N	\N	\N	\N	146183	146183	313556
19198	26628	6	applied	\N	\N	\N	\N	146184	146184	313557
19202	26630	1	applied	\N	\N	\N	\N	146325	146325	313696
19202	26633	2	applied	\N	\N	\N	\N	146326	146326	313697
19202	26634	3	applied	\N	\N	\N	\N	146327	146327	313698
19202	26635	4	applied	\N	\N	\N	\N	146328	146328	313699
19206	26659	0	applied	\N	\N	\N	\N	146358	146358	313729
19206	26660	1	applied	\N	\N	\N	\N	146359	146359	313730
19206	26661	2	applied	\N	\N	\N	\N	146360	146360	313731
19211	26665	0	applied	\N	\N	\N	\N	146373	146373	313744
19211	26666	1	applied	\N	\N	\N	\N	146374	146374	313745
19211	26667	2	applied	\N	\N	\N	\N	146375	146375	313746
19211	26668	3	applied	\N	\N	\N	\N	146376	146376	313747
19213	26669	0	applied	\N	\N	\N	\N	146380	146380	313751
19213	26670	1	applied	\N	\N	\N	\N	146381	146381	313752
19213	26671	2	applied	\N	\N	\N	\N	146382	146382	313753
19215	26672	0	applied	\N	\N	\N	\N	146403	146403	313774
19215	26673	1	applied	\N	\N	\N	\N	146404	146404	313775
19215	26675	3	applied	\N	\N	\N	\N	146406	146406	313777
19215	26676	4	applied	\N	\N	\N	\N	146407	146407	313778
19215	26677	5	applied	\N	\N	\N	\N	146408	146408	313779
19215	26679	6	applied	\N	\N	\N	\N	146409	146409	313780
19215	26680	7	applied	\N	\N	\N	\N	146410	146410	313781
19215	26681	8	applied	\N	\N	\N	\N	146411	146411	313782
19215	26682	9	applied	\N	\N	\N	\N	146412	146412	313783
19215	26684	10	applied	\N	\N	\N	\N	146413	146413	313784
19215	26685	11	applied	\N	\N	\N	\N	146414	146414	313785
19215	26686	12	applied	\N	\N	\N	\N	146415	146415	313786
19215	26687	13	applied	\N	\N	\N	\N	146416	146416	313787
19223	26702	0	applied	\N	\N	\N	\N	146487	146487	313858
19223	26703	1	applied	\N	\N	\N	\N	146488	146488	313859
19223	26706	2	applied	\N	\N	\N	\N	146489	146489	313860
19134	26454	6	applied	\N	\N	\N	\N	145769	145769	313146
19134	26455	7	applied	\N	\N	\N	\N	145770	145770	313147
19145	26480	2	applied	\N	\N	\N	\N	145813	145813	313190
19147	26484	0	applied	\N	\N	\N	\N	145817	145817	313194
19147	26485	1	applied	\N	\N	\N	\N	145818	145818	313195
19147	26486	2	applied	\N	\N	\N	\N	145819	145819	313196
19154	26510	0	applied	\N	\N	\N	\N	145859	145859	313236
19154	26512	3	applied	\N	\N	\N	\N	145861	145861	313238
19154	26513	4	applied	\N	\N	\N	\N	145862	145862	313239
19157	26518	0	applied	\N	\N	\N	\N	145871	145871	313248
19157	26519	1	applied	\N	\N	\N	\N	145872	145872	313249
19157	26520	2	applied	\N	\N	\N	\N	145873	145873	313250
19160	26525	0	applied	\N	\N	\N	\N	145881	145881	313258
19160	26526	1	applied	\N	\N	\N	\N	145882	145882	313259
19160	26527	2	applied	\N	\N	\N	\N	145883	145883	313260
19160	26528	3	applied	\N	\N	\N	\N	145884	145884	313261
19160	26529	4	applied	\N	\N	\N	\N	145885	145885	313262
19160	26530	5	applied	\N	\N	\N	\N	145886	145886	313263
19162	26533	0	applied	\N	\N	\N	\N	145895	145895	313272
19162	26534	1	applied	\N	\N	\N	\N	145896	145896	313273
19162	26535	2	applied	\N	\N	\N	\N	145897	145897	313274
19172	26556	0	applied	\N	\N	\N	\N	145937	145937	313314
19172	26557	1	applied	\N	\N	\N	\N	145938	145938	313315
19175	26577	0	applied	\N	\N	\N	\N	145958	145958	313335
19175	26578	1	applied	\N	\N	\N	\N	145959	145959	313336
19175	26579	2	applied	\N	\N	\N	\N	145960	145960	313337
19178	26580	0	applied	\N	\N	\N	\N	145967	145967	313344
19178	26581	1	applied	\N	\N	\N	\N	145968	145968	313345
19178	26582	2	applied	\N	\N	\N	\N	145969	145969	313346
19180	26322	0	applied	\N	\N	1000000000	\N	145975	145975	313352
19180	26311	1	applied	\N	\N	\N	\N	145976	145976	313353
19180	26312	2	applied	\N	\N	\N	\N	145977	145977	313354
19180	26314	3	applied	\N	\N	\N	\N	145978	145978	313355
19180	26560	4	applied	\N	\N	\N	\N	145979	145979	313356
19180	26561	5	applied	\N	\N	\N	\N	145980	145980	313357
19180	26562	6	applied	\N	\N	\N	\N	145981	145981	313358
19180	26565	7	applied	\N	\N	\N	\N	145982	145982	313359
19180	26584	8	applied	\N	\N	\N	\N	145983	145983	313360
19180	26325	10	applied	\N	\N	1000000000	\N	145985	145985	313362
19180	26326	11	applied	\N	\N	1000000000	\N	145986	145986	313363
19180	26315	12	applied	\N	\N	\N	\N	145987	145987	313364
19180	26316	13	applied	\N	\N	\N	\N	145988	145988	313365
19180	26317	14	applied	\N	\N	\N	\N	145989	145989	313366
19180	26318	15	applied	\N	\N	\N	\N	145990	145990	313367
19180	26320	16	applied	\N	\N	\N	\N	145991	145991	313368
19180	26323	17	applied	\N	\N	\N	\N	145992	145992	313369
19180	26332	18	applied	\N	\N	\N	\N	145993	145993	313370
19180	26333	19	applied	\N	\N	\N	\N	145994	145994	313371
19180	26338	20	applied	\N	\N	\N	\N	145995	145995	313372
19180	26339	21	applied	\N	\N	\N	\N	145996	145996	313373
19180	26340	22	applied	\N	\N	\N	\N	145997	145997	313374
19180	26341	23	applied	\N	\N	\N	\N	145998	145998	313375
19180	26343	24	applied	\N	\N	\N	\N	145999	145999	313376
19180	26344	25	applied	\N	\N	\N	\N	146000	146000	313377
19180	26345	26	applied	\N	\N	\N	\N	146001	146001	313378
19180	26347	27	applied	\N	\N	\N	\N	146002	146002	313379
19180	26348	28	applied	\N	\N	\N	\N	146003	146003	313380
19180	26352	30	applied	\N	\N	\N	\N	146005	146005	313382
19180	26353	31	applied	\N	\N	\N	\N	146006	146006	313383
19180	26354	32	applied	\N	\N	\N	\N	146007	146007	313384
19180	26355	33	applied	\N	\N	\N	\N	146008	146008	313385
19180	26356	34	applied	\N	\N	\N	\N	146009	146009	313386
19180	26362	35	applied	\N	\N	\N	\N	146010	146010	313387
19180	26365	36	applied	\N	\N	\N	\N	146011	146011	313388
19180	26366	37	applied	\N	\N	\N	\N	146012	146012	313389
19180	26367	38	applied	\N	\N	\N	\N	146013	146013	313390
19180	26370	39	applied	\N	\N	\N	\N	146014	146014	313391
19180	26371	40	applied	\N	\N	\N	\N	146015	146015	313392
19180	26376	41	applied	\N	\N	\N	\N	146016	146016	313393
19180	26379	42	applied	\N	\N	\N	\N	146017	146017	313394
19180	26382	43	applied	\N	\N	\N	\N	146018	146018	313395
19180	26385	44	applied	\N	\N	\N	\N	146019	146019	313396
19180	26386	45	applied	\N	\N	\N	\N	146020	146020	313397
19180	26394	48	applied	\N	\N	\N	\N	146022	146022	313399
19180	26398	49	applied	\N	\N	\N	\N	146023	146023	313400
19180	26400	50	applied	\N	\N	\N	\N	146024	146024	313401
19180	26405	51	applied	\N	\N	\N	\N	146025	146025	313402
19180	26406	52	applied	\N	\N	\N	\N	146026	146026	313403
19180	26411	53	applied	\N	\N	\N	\N	146027	146027	313404
19180	26415	54	applied	\N	\N	\N	\N	146028	146028	313405
19180	26417	55	applied	\N	\N	\N	\N	146029	146029	313406
19180	26420	56	applied	\N	\N	\N	\N	146030	146030	313407
19180	26421	57	applied	\N	\N	\N	\N	146031	146031	313408
19180	26422	58	applied	\N	\N	\N	\N	146032	146032	313409
19180	26426	59	applied	\N	\N	\N	\N	146033	146033	313410
19180	26428	60	applied	\N	\N	\N	\N	146034	146034	313411
19180	26429	61	applied	\N	\N	\N	\N	146035	146035	313412
19180	26432	62	applied	\N	\N	\N	\N	146036	146036	313413
19180	26434	63	applied	\N	\N	\N	\N	146037	146037	313414
19180	26441	65	applied	\N	\N	\N	\N	146039	146039	313416
19180	26442	66	applied	\N	\N	\N	\N	146040	146040	313417
19180	26443	67	applied	\N	\N	\N	\N	146041	146041	313418
19223	26704	3	applied	\N	\N	\N	\N	146490	146490	313861
19223	26705	4	applied	\N	\N	\N	\N	146491	146491	313862
19223	26707	5	applied	\N	\N	\N	\N	146492	146492	313863
19226	26708	0	applied	\N	\N	1000000000	\N	146502	146502	313871
19226	26709	1	applied	\N	\N	\N	\N	146503	146503	313872
19226	26710	2	applied	\N	\N	\N	\N	146504	146504	313873
19226	26711	3	applied	\N	\N	\N	\N	146505	146505	313874
19226	26712	4	applied	\N	\N	\N	\N	146506	146506	313875
19233	26713	0	applied	\N	\N	\N	\N	146533	146533	313902
19233	26714	1	applied	\N	\N	\N	\N	146534	146534	313903
19233	26715	2	applied	\N	\N	\N	\N	146535	146535	313904
19236	26716	0	applied	\N	\N	\N	\N	146542	146542	313911
19236	26717	1	applied	\N	\N	\N	\N	146543	146543	313912
19240	26719	0	applied	\N	\N	\N	\N	146553	146553	313922
19240	26720	1	applied	\N	\N	\N	\N	146554	146554	313923
19240	26721	2	applied	\N	\N	\N	\N	146555	146555	313924
19248	26738	0	applied	\N	\N	1000000000	\N	146584	146584	313953
19248	26739	1	applied	\N	\N	\N	\N	146585	146585	313954
19248	26740	2	applied	\N	\N	\N	\N	146586	146586	313955
19145	26478	0	applied	\N	\N	\N	\N	145811	145811	313188
19145	26479	1	applied	\N	\N	\N	\N	145812	145812	313189
19180	26461	72	applied	\N	\N	\N	\N	146046	146046	313423
19180	26464	73	applied	\N	\N	\N	\N	146047	146047	313424
19180	26468	74	applied	\N	\N	\N	\N	146048	146048	313425
19180	26471	75	applied	\N	\N	\N	\N	146049	146049	313426
19180	26472	76	applied	\N	\N	\N	\N	146050	146050	313427
19180	26478	77	applied	\N	\N	\N	\N	146051	146051	313428
19180	26481	78	applied	\N	\N	\N	\N	146052	146052	313429
19180	26484	79	applied	\N	\N	\N	\N	146053	146053	313430
19180	26487	80	applied	\N	\N	\N	\N	146054	146054	313431
19180	26492	82	applied	\N	\N	\N	\N	146056	146056	313433
19180	26493	83	applied	\N	\N	\N	\N	146057	146057	313434
19180	26494	84	applied	\N	\N	\N	\N	146058	146058	313435
19180	26495	85	applied	\N	\N	\N	\N	146059	146059	313436
19180	26327	86	applied	\N	\N	1000000000	\N	146060	146060	313437
19180	26328	87	applied	\N	\N	1000000000	\N	146061	146061	313438
19180	26329	88	applied	\N	\N	1000000000	\N	146062	146062	313439
19180	26330	89	applied	\N	\N	1000000000	\N	146063	146063	313440
19180	26363	90	applied	\N	\N	1000000000	\N	146064	146064	313441
19180	26364	91	applied	\N	\N	\N	\N	146065	146065	313442
19180	26510	92	applied	\N	\N	\N	\N	146066	146066	313443
19180	26514	93	applied	\N	\N	\N	\N	146067	146067	313444
19180	26518	94	applied	\N	\N	\N	\N	146068	146068	313445
19180	26521	95	applied	\N	\N	\N	\N	146069	146069	313446
19180	26525	96	applied	\N	\N	\N	\N	146070	146070	313447
19180	26526	97	applied	\N	\N	\N	\N	146071	146071	313448
19180	26536	99	applied	\N	\N	\N	\N	146073	146073	313450
19180	26537	100	applied	\N	\N	\N	\N	146074	146074	313451
19180	26543	101	applied	\N	\N	\N	\N	146075	146075	313452
19180	26544	102	applied	\N	\N	\N	\N	146076	146076	313453
19180	26550	103	applied	\N	\N	\N	\N	146077	146077	313454
19180	26553	104	applied	\N	\N	\N	\N	146078	146078	313455
19180	26556	105	applied	\N	\N	\N	\N	146079	146079	313456
19180	26559	106	applied	\N	\N	\N	\N	146080	146080	313457
19180	26563	107	applied	\N	\N	\N	\N	146081	146081	313458
19180	26564	108	applied	\N	\N	\N	\N	146082	146082	313459
19180	26573	109	applied	\N	\N	\N	\N	146083	146083	313460
19180	26577	110	applied	\N	\N	\N	\N	146084	146084	313461
19180	26580	111	applied	\N	\N	\N	\N	146085	146085	313462
19180	26583	112	applied	\N	\N	\N	\N	146086	146086	313463
19180	26331	113	applied	\N	\N	\N	\N	146087	146087	313464
19180	26436	115	applied	\N	\N	1000000000	\N	146089	146089	313466
19180	26372	116	applied	\N	\N	\N	\N	146090	146090	313467
19180	26497	117	applied	\N	\N	\N	\N	146091	146091	313468
19180	26437	118	applied	\N	\N	\N	\N	146092	146092	313469
19180	26498	119	applied	\N	\N	\N	\N	146093	146093	313470
19180	26499	120	applied	\N	\N	\N	\N	146094	146094	313471
19180	26515	121	applied	\N	\N	\N	\N	146095	146095	313472
19180	26373	122	applied	\N	\N	\N	\N	146096	146096	313473
19180	26378	123	applied	\N	\N	\N	\N	146097	146097	313474
19180	26313	124	applied	\N	\N	\N	\N	146098	146098	313475
19180	26381	125	applied	\N	\N	\N	\N	146099	146099	313476
19182	26588	0	applied	\N	\N	\N	\N	146105	146105	146105
19182	26589	1	applied	\N	\N	\N	\N	146106	146106	313482
19182	26590	2	applied	\N	\N	\N	\N	146107	146107	313483
19182	26591	3	applied	\N	\N	\N	\N	146108	146108	313484
19184	26592	0	applied	\N	\N	\N	\N	146113	146113	313488
19184	26593	1	applied	\N	\N	\N	\N	146114	146114	313489
19184	26594	2	applied	\N	\N	\N	\N	146115	146115	313490
19187	26595	0	applied	\N	\N	\N	\N	146127	146127	146127
19187	26597	2	applied	\N	\N	\N	\N	146129	146129	313502
19187	26598	3	applied	\N	\N	\N	\N	146130	146130	313503
19187	26599	4	applied	\N	\N	\N	\N	146131	146131	313504
19187	26594	5	applied	\N	\N	\N	\N	146132	146132	313505
19187	26600	6	applied	\N	\N	\N	\N	146133	146133	313506
19187	26601	7	applied	\N	\N	\N	\N	146134	146134	313507
19187	26602	9	applied	\N	\N	\N	\N	146135	146135	313508
19192	26609	0	applied	\N	\N	\N	\N	146152	146152	313525
19192	26610	1	applied	\N	\N	\N	\N	146153	146153	313526
19192	26611	2	applied	\N	\N	\N	\N	146154	146154	313527
19192	26612	3	applied	\N	\N	\N	\N	146155	146155	313528
19192	26613	4	applied	\N	\N	\N	\N	146156	146156	313529
19192	26614	5	applied	\N	\N	\N	\N	146157	146157	313530
19192	26615	6	applied	\N	\N	\N	\N	146158	146158	313531
19196	26619	0	applied	\N	\N	\N	\N	146168	146168	313541
19196	26620	1	applied	\N	\N	\N	\N	146169	146169	313542
19200	26588	0	applied	\N	\N	\N	\N	146192	146192	146192
19200	26595	1	applied	\N	\N	\N	\N	146193	146193	146193
19200	26322	2	applied	\N	\N	1000000000	\N	146194	146194	313565
19200	26209	3	applied	\N	\N	1000000000	\N	146195	146195	313566
19200	26061	4	applied	\N	\N	\N	\N	146196	146196	313567
19200	26063	5	applied	\N	\N	\N	\N	146197	146197	313568
19200	26264	6	applied	\N	\N	\N	\N	146198	146198	313569
19200	26560	7	applied	\N	\N	\N	\N	146199	146199	313570
19200	26561	8	applied	\N	\N	\N	\N	146200	146200	313571
19200	26562	9	applied	\N	\N	\N	\N	146201	146201	313572
19200	26565	10	applied	\N	\N	\N	\N	146202	146202	313573
19200	26065	11	applied	\N	\N	\N	\N	146203	146203	313574
19200	26066	12	applied	\N	\N	\N	\N	146204	146204	313575
19200	26070	13	applied	\N	\N	\N	\N	146205	146205	313576
19200	26325	15	applied	\N	\N	1000000000	\N	146207	146207	313578
19200	26326	16	applied	\N	\N	1000000000	\N	146208	146208	313579
19200	26072	17	applied	\N	\N	\N	\N	146209	146209	313580
19200	26074	18	applied	\N	\N	\N	\N	146210	146210	313581
19200	26077	19	applied	\N	\N	\N	\N	146211	146211	313582
19200	26079	20	applied	\N	\N	\N	\N	146212	146212	313583
19200	26080	21	applied	\N	\N	\N	\N	146213	146213	313584
19200	26081	22	applied	\N	\N	\N	\N	146214	146214	313585
19200	26084	23	applied	\N	\N	\N	\N	146215	146215	313586
19200	26085	24	applied	\N	\N	\N	\N	146216	146216	313587
19200	26086	25	applied	\N	\N	\N	\N	146217	146217	313588
19200	26088	26	applied	\N	\N	\N	\N	146218	146218	313589
19200	26089	27	applied	\N	\N	\N	\N	146219	146219	313590
19200	26090	28	applied	\N	\N	\N	\N	146220	146220	313591
19200	26092	29	applied	\N	\N	\N	\N	146221	146221	313592
19200	26093	30	applied	\N	\N	\N	\N	146222	146222	313593
19200	26094	31	applied	\N	\N	\N	\N	146223	146223	313594
19200	26095	32	applied	\N	\N	\N	\N	146224	146224	313595
19200	26097	33	applied	\N	\N	\N	\N	146225	146225	313596
19180	26449	69	applied	\N	\N	\N	\N	146043	146043	313420
19180	26458	71	applied	\N	\N	\N	\N	146045	146045	313422
19189	26604	1	applied	\N	\N	\N	\N	146140	146140	313513
19189	26605	2	applied	\N	\N	\N	\N	146141	146141	313514
19191	26609	0	applied	\N	\N	\N	\N	146145	146145	313518
19191	26610	1	applied	\N	\N	\N	\N	146146	146146	313519
19191	26611	2	applied	\N	\N	\N	\N	146147	146147	313520
19191	26612	3	applied	\N	\N	\N	\N	146148	146148	313521
19191	26613	4	applied	\N	\N	\N	\N	146149	146149	313522
19191	26614	5	applied	\N	\N	\N	\N	146150	146150	313523
19191	26615	6	applied	\N	\N	\N	\N	146151	146151	313524
19194	26616	0	applied	\N	\N	\N	\N	146162	146162	313535
19194	26617	1	applied	\N	\N	\N	\N	146163	146163	313536
19194	26618	2	applied	\N	\N	\N	\N	146164	146164	313537
19199	26622	0	applied	\N	\N	\N	\N	146185	146185	313558
19199	26623	1	applied	\N	\N	\N	\N	146186	146186	313559
19199	26624	2	applied	\N	\N	\N	\N	146187	146187	313560
19199	26625	3	applied	\N	\N	\N	\N	146188	146188	313561
19199	26627	5	applied	\N	\N	\N	\N	146190	146190	313563
19199	26628	6	applied	\N	\N	\N	\N	146191	146191	313564
19200	26098	34	applied	\N	\N	\N	\N	146226	146226	313597
19200	26099	35	applied	\N	\N	\N	\N	146227	146227	313598
19200	26101	36	applied	\N	\N	\N	\N	146228	146228	313599
19200	26102	37	applied	\N	\N	\N	\N	146229	146229	313600
19200	26103	38	applied	\N	\N	\N	\N	146230	146230	313601
19200	26104	39	applied	\N	\N	\N	\N	146231	146231	313602
19200	26216	40	applied	\N	\N	\N	\N	146232	146232	313603
19200	26106	41	applied	\N	\N	\N	\N	146233	146233	313604
19200	26107	42	applied	\N	\N	\N	\N	146234	146234	313605
19200	26109	43	applied	\N	\N	\N	\N	146235	146235	313606
19200	26110	44	applied	\N	\N	\N	\N	146236	146236	313607
19200	26111	45	applied	\N	\N	\N	\N	146237	146237	313608
19200	26112	46	applied	\N	\N	\N	\N	146238	146238	313609
19200	26114	47	applied	\N	\N	\N	\N	146239	146239	313610
19200	26116	49	applied	\N	\N	\N	\N	146241	146241	313612
19200	26118	50	applied	\N	\N	\N	\N	146242	146242	313613
19200	26119	51	applied	\N	\N	\N	\N	146243	146243	313614
19200	26120	52	applied	\N	\N	\N	\N	146244	146244	313615
19200	26122	53	applied	\N	\N	\N	\N	146245	146245	313616
19203	26636	0	applied	\N	\N	\N	\N	146329	146329	313700
19203	26637	1	applied	\N	\N	\N	\N	146330	146330	313701
19203	26638	2	applied	\N	\N	\N	\N	146331	146331	313702
19203	26639	3	applied	\N	\N	\N	\N	146332	146332	313703
19203	26640	4	applied	\N	\N	\N	\N	146333	146333	313704
19203	26641	5	applied	\N	\N	\N	\N	146334	146334	313705
19207	26659	0	applied	\N	\N	\N	\N	146361	146361	313732
19207	26661	1	applied	\N	\N	\N	\N	146362	146362	313733
19209	26662	0	applied	\N	\N	\N	\N	146366	146366	313737
19209	26663	1	applied	\N	\N	\N	\N	146367	146367	313738
19209	26664	2	applied	\N	\N	\N	\N	146368	146368	313739
19212	26666	1	applied	\N	\N	\N	\N	146378	146378	313749
19212	26668	2	applied	\N	\N	\N	\N	146379	146379	313750
19216	26672	0	applied	\N	\N	\N	\N	146417	146417	313788
19216	26673	1	applied	\N	\N	\N	\N	146418	146418	313789
19216	26674	2	applied	\N	\N	\N	\N	146419	146419	313790
19216	26675	3	applied	\N	\N	\N	\N	146420	146420	313791
19216	26676	4	applied	\N	\N	\N	\N	146421	146421	313792
19216	26677	5	applied	\N	\N	\N	\N	146422	146422	313793
19216	26678	6	applied	\N	\N	\N	\N	146423	146423	313794
19216	26679	7	applied	\N	\N	\N	\N	146424	146424	313795
19216	26680	8	applied	\N	\N	\N	\N	146425	146425	313796
19216	26681	9	applied	\N	\N	\N	\N	146426	146426	313797
19216	26682	10	applied	\N	\N	\N	\N	146427	146427	313798
19216	26683	11	applied	\N	\N	\N	\N	146428	146428	313799
19216	26684	12	applied	\N	\N	\N	\N	146429	146429	313800
19216	26685	13	applied	\N	\N	\N	\N	146430	146430	313801
19216	26687	15	applied	\N	\N	\N	\N	146432	146432	313803
19216	26688	16	applied	\N	\N	\N	\N	146433	146433	313804
19216	26689	17	applied	\N	\N	\N	\N	146434	146434	313805
19216	26690	18	applied	\N	\N	\N	\N	146435	146435	313806
19216	26691	19	applied	\N	\N	\N	\N	146436	146436	313807
19219	26692	0	applied	\N	\N	\N	\N	146457	146457	313828
19219	26693	1	applied	\N	\N	\N	\N	146458	146458	313829
19219	26694	2	applied	\N	\N	\N	\N	146459	146459	313830
19219	26695	3	applied	\N	\N	\N	\N	146460	146460	313831
19219	26696	4	applied	\N	\N	\N	\N	146461	146461	313832
19219	26697	5	applied	\N	\N	\N	\N	146462	146462	313833
19219	26698	6	applied	\N	\N	\N	\N	146463	146463	313834
19219	26699	8	applied	\N	\N	\N	\N	146464	146464	313835
19219	26700	9	applied	\N	\N	\N	\N	146465	146465	313836
19219	26701	10	applied	\N	\N	\N	\N	146466	146466	313837
19220	26692	0	applied	\N	\N	\N	\N	146467	146467	313838
19220	26694	2	applied	\N	\N	\N	\N	146469	146469	313840
19220	26695	3	applied	\N	\N	\N	\N	146470	146470	313841
19220	26696	4	applied	\N	\N	\N	\N	146471	146471	313842
19220	26697	5	applied	\N	\N	\N	\N	146472	146472	313843
19220	26698	6	applied	\N	\N	\N	\N	146473	146473	313844
19220	26699	8	applied	\N	\N	\N	\N	146474	146474	313845
19220	26700	9	applied	\N	\N	\N	\N	146475	146475	313846
19220	26701	10	applied	\N	\N	\N	\N	146476	146476	313847
19232	26712	0	applied	\N	\N	\N	\N	146532	146532	313901
19234	26713	0	applied	\N	\N	\N	\N	146536	146536	313905
19234	26714	1	applied	\N	\N	\N	\N	146537	146537	313906
19234	26715	2	applied	\N	\N	\N	\N	146538	146538	313907
19237	26716	0	applied	\N	\N	\N	\N	146545	146545	313914
19237	26717	1	applied	\N	\N	\N	\N	146546	146546	313915
19237	26718	2	applied	\N	\N	\N	\N	146547	146547	313916
19238	26717	0	applied	\N	\N	\N	\N	146548	146548	313917
19241	26719	0	applied	\N	\N	\N	\N	146556	146556	313925
19241	26720	1	applied	\N	\N	\N	\N	146557	146557	313926
19241	26721	2	applied	\N	\N	\N	\N	146558	146558	313927
19245	26734	0	applied	\N	\N	\N	\N	146574	146574	313943
19245	26735	1	applied	\N	\N	\N	\N	146575	146575	313944
19245	26736	2	applied	\N	\N	\N	\N	146576	146576	313945
19245	26737	3	applied	\N	\N	\N	\N	146577	146577	313946
19250	26748	0	applied	\N	\N	\N	\N	146594	146594	313963
19250	26749	1	applied	\N	\N	\N	\N	146595	146595	313964
19250	26750	2	applied	\N	\N	\N	\N	146596	146596	313965
19258	26762	0	applied	\N	\N	\N	\N	146716	146716	314083
19258	26763	1	applied	\N	\N	\N	\N	146717	146717	314084
19258	26764	2	applied	\N	\N	\N	\N	146718	146718	314085
19258	26765	3	applied	\N	\N	\N	\N	146719	146719	314086
19186	26601	7	applied	\N	\N	\N	\N	146125	146125	313499
19186	26602	9	applied	\N	\N	\N	\N	146126	146126	313500
19200	26127	57	applied	\N	\N	\N	\N	146249	146249	313620
19200	26128	59	applied	\N	\N	\N	\N	146250	146250	313621
19200	26129	60	applied	\N	\N	\N	\N	146251	146251	313622
19200	26130	61	applied	\N	\N	\N	\N	146252	146252	313623
19200	26132	62	applied	\N	\N	\N	\N	146253	146253	313624
19200	26134	63	applied	\N	\N	\N	\N	146254	146254	313625
19200	26135	64	applied	\N	\N	\N	\N	146255	146255	313626
19200	26137	66	applied	\N	\N	\N	\N	146257	146257	313628
19200	26139	67	applied	\N	\N	\N	\N	146258	146258	313629
19200	26140	68	applied	\N	\N	\N	\N	146259	146259	313630
19200	26141	69	applied	\N	\N	\N	\N	146260	146260	313631
19200	26143	70	applied	\N	\N	\N	\N	146261	146261	313632
19200	26144	71	applied	\N	\N	\N	\N	146262	146262	313633
19200	26145	72	applied	\N	\N	\N	\N	146263	146263	313634
19200	26146	73	applied	\N	\N	\N	\N	146264	146264	313635
19200	26148	74	applied	\N	\N	\N	\N	146265	146265	313636
19200	26149	75	applied	\N	\N	\N	\N	146266	146266	313637
19200	26150	76	applied	\N	\N	\N	\N	146267	146267	313638
19200	26152	77	applied	\N	\N	\N	\N	146268	146268	313639
19200	26153	78	applied	\N	\N	\N	\N	146269	146269	313640
19200	26154	79	applied	\N	\N	\N	\N	146270	146270	313641
19200	26156	80	applied	\N	\N	\N	\N	146271	146271	313642
19200	26157	81	applied	\N	\N	\N	\N	146272	146272	313643
19200	26160	83	applied	\N	\N	\N	\N	146274	146274	313645
19200	26161	84	applied	\N	\N	\N	\N	146275	146275	313646
19200	26162	85	applied	\N	\N	\N	\N	146276	146276	313647
19200	26163	86	applied	\N	\N	\N	\N	146277	146277	313648
19200	26327	87	applied	\N	\N	1000000000	\N	146278	146278	313649
19200	26328	88	applied	\N	\N	1000000000	\N	146279	146279	313650
19200	26329	89	applied	\N	\N	1000000000	\N	146280	146280	313651
19200	26330	90	applied	\N	\N	1000000000	\N	146281	146281	313652
19200	26363	91	applied	\N	\N	1000000000	\N	146282	146282	313653
19200	26364	92	applied	\N	\N	\N	\N	146283	146283	313654
19200	26165	93	applied	\N	\N	\N	\N	146284	146284	313655
19200	26166	94	applied	\N	\N	\N	\N	146285	146285	313656
19200	26167	95	applied	\N	\N	\N	\N	146286	146286	313657
19200	26169	96	applied	\N	\N	\N	\N	146287	146287	313658
19200	26170	97	applied	\N	\N	\N	\N	146288	146288	313659
19200	26171	98	applied	\N	\N	\N	\N	146289	146289	313660
19200	26174	100	applied	\N	\N	\N	\N	146291	146291	313662
19200	26175	101	applied	\N	\N	\N	\N	146292	146292	313663
19200	26176	102	applied	\N	\N	\N	\N	146293	146293	313664
19200	26177	103	applied	\N	\N	\N	\N	146294	146294	313665
19200	26179	104	applied	\N	\N	\N	\N	146295	146295	313666
19200	26180	105	applied	\N	\N	\N	\N	146296	146296	313667
19200	26182	106	applied	\N	\N	\N	\N	146297	146297	313668
19200	26183	107	applied	\N	\N	\N	\N	146298	146298	313669
19200	26184	108	applied	\N	\N	\N	\N	146299	146299	313670
19200	26186	109	applied	\N	\N	\N	\N	146300	146300	313671
19200	26187	110	applied	\N	\N	\N	\N	146301	146301	313672
19200	26188	111	applied	\N	\N	\N	\N	146302	146302	313673
19200	26189	112	applied	\N	\N	\N	\N	146303	146303	313674
19200	26191	113	applied	\N	\N	\N	\N	146304	146304	313675
19200	26192	114	applied	\N	\N	\N	\N	146305	146305	313676
19200	26193	115	applied	\N	\N	\N	\N	146306	146306	313677
19200	26196	117	applied	\N	\N	\N	\N	146308	146308	313679
19200	26197	118	applied	\N	\N	\N	\N	146309	146309	313680
19200	26199	119	applied	\N	\N	\N	\N	146310	146310	313681
19200	26200	120	applied	\N	\N	\N	\N	146311	146311	313682
19200	26201	121	applied	\N	\N	\N	\N	146312	146312	313683
19200	26202	122	applied	\N	\N	\N	\N	146313	146313	313684
19200	26204	123	applied	\N	\N	\N	\N	146314	146314	313685
19200	26205	124	applied	\N	\N	\N	\N	146315	146315	313686
19200	26206	125	applied	\N	\N	\N	\N	146316	146316	313687
19201	26629	0	applied	\N	\N	\N	\N	146317	146317	313688
19201	26630	1	applied	\N	\N	\N	\N	146318	146318	313689
19201	26631	2	applied	\N	\N	\N	\N	146319	146319	313690
19201	26632	3	applied	\N	\N	\N	\N	146320	146320	313691
19201	26633	4	applied	\N	\N	\N	\N	146321	146321	313692
19201	26634	5	applied	\N	\N	\N	\N	146322	146322	313693
19201	26635	6	applied	\N	\N	\N	\N	146323	146323	313694
19204	26637	1	applied	\N	\N	\N	\N	146336	146336	313707
19204	26638	2	applied	\N	\N	\N	\N	146337	146337	313708
19204	26639	3	applied	\N	\N	\N	\N	146338	146338	313709
19204	26640	4	applied	\N	\N	\N	\N	146339	146339	313710
19204	26641	5	applied	\N	\N	\N	\N	146340	146340	313711
19205	26642	0	applied	\N	\N	\N	\N	146341	146341	313712
19205	26643	1	applied	\N	\N	\N	\N	146342	146342	313713
19205	26644	2	applied	\N	\N	\N	\N	146343	146343	313714
19205	26645	3	applied	\N	\N	\N	\N	146344	146344	313715
19205	26646	4	applied	\N	\N	\N	\N	146345	146345	313716
19205	26647	5	applied	\N	\N	\N	\N	146346	146346	313717
19205	26648	6	applied	\N	\N	\N	\N	146347	146347	313718
19205	26649	7	applied	\N	\N	\N	\N	146348	146348	313719
19205	26650	8	applied	\N	\N	\N	\N	146349	146349	313720
19205	26651	9	applied	\N	\N	\N	\N	146350	146350	313721
19205	26652	10	applied	\N	\N	\N	\N	146351	146351	313722
19205	26654	12	applied	\N	\N	\N	\N	146353	146353	313724
19205	26655	13	applied	\N	\N	\N	\N	146354	146354	313725
19205	26656	14	applied	\N	\N	\N	\N	146355	146355	313726
19258	26766	4	applied	\N	\N	\N	\N	146720	146720	314087
19258	26767	5	applied	\N	\N	\N	\N	146721	146721	314088
19258	26768	6	applied	\N	\N	\N	\N	146722	146722	314089
19258	26769	7	applied	\N	\N	\N	\N	146723	146723	314090
19258	26770	8	applied	\N	\N	\N	\N	146724	146724	314091
19258	26771	9	applied	\N	\N	\N	\N	146725	146725	314092
19262	26772	0	applied	\N	\N	\N	\N	146756	146756	314123
19262	26773	1	applied	\N	\N	\N	\N	146757	146757	314124
19262	26774	2	applied	\N	\N	\N	\N	146758	146758	314125
19268	26785	0	applied	\N	\N	\N	\N	146788	146788	314155
19268	26786	1	applied	\N	\N	\N	\N	146789	146789	314156
19268	26787	2	applied	\N	\N	\N	\N	146790	146790	314157
19271	26788	0	applied	\N	\N	\N	\N	146797	146797	314164
19271	26790	2	applied	\N	\N	\N	\N	146799	146799	314166
19274	26795	0	applied	\N	\N	\N	\N	146807	146807	314174
19274	26796	1	applied	\N	\N	\N	\N	146808	146808	314175
19274	26797	2	applied	\N	\N	\N	\N	146809	146809	314176
19279	26802	0	applied	\N	\N	\N	\N	146826	146826	314193
19279	26803	1	applied	\N	\N	\N	\N	146827	146827	314194
19200	26124	55	applied	\N	\N	\N	\N	146247	146247	313618
19200	26125	56	applied	\N	\N	\N	\N	146248	146248	313619
19214	26686	14	applied	\N	\N	\N	\N	146397	146397	313768
19214	26688	16	applied	\N	\N	\N	\N	146399	146399	313770
19214	26689	17	applied	\N	\N	\N	\N	146400	146400	313771
19214	26690	18	applied	\N	\N	\N	\N	146401	146401	313772
19214	26691	19	applied	\N	\N	\N	\N	146402	146402	313773
19217	26692	0	applied	\N	\N	\N	\N	146437	146437	313808
19217	26693	1	applied	\N	\N	\N	\N	146438	146438	313809
19217	26694	2	applied	\N	\N	\N	\N	146439	146439	313810
19217	26695	3	applied	\N	\N	\N	\N	146440	146440	313811
19217	26696	4	applied	\N	\N	\N	\N	146441	146441	313812
19217	26697	5	applied	\N	\N	\N	\N	146442	146442	313813
19217	26698	6	applied	\N	\N	\N	\N	146443	146443	313814
19217	26699	8	applied	\N	\N	\N	\N	146444	146444	313815
19217	26700	9	applied	\N	\N	\N	\N	146445	146445	313816
19217	26701	10	applied	\N	\N	\N	\N	146446	146446	313817
19218	26692	0	applied	\N	\N	\N	\N	146447	146447	313818
19218	26693	1	applied	\N	\N	\N	\N	146448	146448	313819
19218	26695	3	applied	\N	\N	\N	\N	146450	146450	313821
19218	26696	4	applied	\N	\N	\N	\N	146451	146451	313822
19218	26697	5	applied	\N	\N	\N	\N	146452	146452	313823
19218	26698	6	applied	\N	\N	\N	\N	146453	146453	313824
19218	26699	8	applied	\N	\N	\N	\N	146454	146454	313825
19218	26700	9	applied	\N	\N	\N	\N	146455	146455	313826
19218	26701	10	applied	\N	\N	\N	\N	146456	146456	313827
19221	26702	0	applied	\N	\N	\N	\N	146477	146477	313848
19221	26703	1	applied	\N	\N	\N	\N	146478	146478	313849
19221	26704	2	applied	\N	\N	\N	\N	146479	146479	313850
19221	26705	3	applied	\N	\N	\N	\N	146480	146480	313851
19222	26702	0	applied	\N	\N	\N	\N	146481	146481	313852
19222	26703	1	applied	\N	\N	\N	\N	146482	146482	313853
19222	26706	2	applied	\N	\N	\N	\N	146483	146483	313854
19222	26704	3	applied	\N	\N	\N	\N	146484	146484	313855
19222	26705	4	applied	\N	\N	\N	\N	146485	146485	313856
19224	26588	0	applied	\N	\N	\N	\N	146493	146493	146493
19224	26595	1	applied	\N	\N	\N	\N	146494	146494	146494
19224	26708	2	applied	\N	\N	1000000000	\N	146495	146495	313864
19224	26651	3	applied	\N	\N	\N	\N	146496	146496	313865
19225	26708	0	applied	\N	\N	1000000000	\N	146497	146497	313866
19225	26709	1	applied	\N	\N	\N	\N	146498	146498	313867
19225	26710	2	applied	\N	\N	\N	\N	146499	146499	313868
19225	26711	3	applied	\N	\N	\N	\N	146500	146500	313869
19225	26712	4	applied	\N	\N	\N	\N	146501	146501	313870
19227	26708	0	applied	\N	\N	1000000000	\N	146507	146507	313876
19227	26709	1	applied	\N	\N	\N	\N	146508	146508	313877
19227	26710	2	applied	\N	\N	\N	\N	146509	146509	313878
19227	26711	3	applied	\N	\N	\N	\N	146510	146510	313879
19227	26712	4	applied	\N	\N	\N	\N	146511	146511	313880
19228	26709	1	applied	\N	\N	\N	\N	146513	146513	313882
19228	26710	2	applied	\N	\N	\N	\N	146514	146514	313883
19228	26711	3	applied	\N	\N	\N	\N	146515	146515	313884
19228	26712	4	applied	\N	\N	\N	\N	146516	146516	313885
19229	26708	0	applied	\N	\N	1000000000	\N	146517	146517	313886
19229	26709	1	applied	\N	\N	\N	\N	146518	146518	313887
19229	26710	2	applied	\N	\N	\N	\N	146519	146519	313888
19229	26711	3	applied	\N	\N	\N	\N	146520	146520	313889
19229	26712	4	applied	\N	\N	\N	\N	146521	146521	313890
19230	26708	0	applied	\N	\N	1000000000	\N	146522	146522	313891
19230	26709	1	applied	\N	\N	\N	\N	146523	146523	313892
19230	26710	2	applied	\N	\N	\N	\N	146524	146524	313893
19230	26711	3	applied	\N	\N	\N	\N	146525	146525	313894
19230	26712	4	applied	\N	\N	\N	\N	146526	146526	313895
19231	26708	0	applied	\N	\N	1000000000	\N	146527	146527	313896
19231	26709	1	applied	\N	\N	\N	\N	146528	146528	313897
19231	26710	2	applied	\N	\N	\N	\N	146529	146529	313898
19231	26711	3	applied	\N	\N	\N	\N	146530	146530	313899
19231	26712	4	applied	\N	\N	\N	\N	146531	146531	313900
19235	26716	0	applied	\N	\N	\N	\N	146539	146539	313908
19235	26718	2	applied	\N	\N	\N	\N	146541	146541	313910
19239	26719	0	applied	\N	\N	\N	\N	146550	146550	313919
19239	26720	1	applied	\N	\N	\N	\N	146551	146551	313920
19239	26721	2	applied	\N	\N	\N	\N	146552	146552	313921
19244	26727	0	applied	\N	\N	\N	\N	146567	146567	313936
19244	26728	1	applied	\N	\N	\N	\N	146568	146568	313937
19244	26729	2	applied	\N	\N	\N	\N	146569	146569	313938
19244	26730	3	applied	\N	\N	\N	\N	146570	146570	313939
19244	26731	4	applied	\N	\N	\N	\N	146571	146571	313940
19244	26732	5	applied	\N	\N	\N	\N	146572	146572	313941
19244	26733	6	applied	\N	\N	\N	\N	146573	146573	313942
19247	26738	0	applied	\N	\N	1000000000	\N	146581	146581	313950
19247	26739	1	applied	\N	\N	\N	\N	146582	146582	313951
19247	26740	2	applied	\N	\N	\N	\N	146583	146583	313952
19249	26741	0	applied	\N	\N	\N	\N	146587	146587	313956
19249	26742	1	applied	\N	\N	\N	\N	146588	146588	313957
19249	26744	3	applied	\N	\N	\N	\N	146590	146590	313959
19249	26745	4	applied	\N	\N	\N	\N	146591	146591	313960
19249	26746	5	applied	\N	\N	\N	\N	146592	146592	313961
19249	26747	6	applied	\N	\N	\N	\N	146593	146593	313962
19254	26754	0	applied	\N	\N	\N	\N	146606	146606	313975
19254	26755	1	applied	\N	\N	\N	\N	146607	146607	313976
19254	26756	2	applied	\N	\N	\N	\N	146608	146608	313977
19254	26757	3	applied	\N	\N	\N	\N	146609	146609	313978
19254	26758	4	applied	\N	\N	\N	\N	146610	146610	313979
19254	26759	5	applied	\N	\N	\N	\N	146611	146611	313980
19254	26760	6	applied	\N	\N	\N	\N	146612	146612	313981
19254	26761	7	applied	\N	\N	\N	\N	146613	146613	313982
19261	26762	0	applied	\N	\N	\N	\N	146746	146746	314113
19261	26763	1	applied	\N	\N	\N	\N	146747	146747	314114
19261	26764	2	applied	\N	\N	\N	\N	146748	146748	314115
19261	26765	3	applied	\N	\N	\N	\N	146749	146749	314116
19261	26767	5	applied	\N	\N	\N	\N	146751	146751	314118
19261	26768	6	applied	\N	\N	\N	\N	146752	146752	314119
19261	26769	7	applied	\N	\N	\N	\N	146753	146753	314120
19261	26770	8	applied	\N	\N	\N	\N	146754	146754	314121
19261	26771	9	applied	\N	\N	\N	\N	146755	146755	314122
19263	26775	0	applied	\N	\N	\N	\N	146759	146759	314126
19263	26776	1	applied	\N	\N	\N	\N	146760	146760	314127
19263	26777	2	applied	\N	\N	\N	\N	146761	146761	314128
19266	26772	0	applied	\N	\N	\N	\N	146769	146769	314136
19266	26775	1	applied	\N	\N	\N	\N	146770	146770	314137
19205	26658	16	applied	\N	\N	\N	\N	146357	146357	313728
19214	26685	13	applied	\N	\N	\N	\N	146396	146396	313767
19243	26722	0	applied	\N	\N	\N	\N	146562	146562	313931
19243	26723	1	applied	\N	\N	\N	\N	146563	146563	313932
19243	26724	2	applied	\N	\N	\N	\N	146564	146564	313933
19243	26725	3	applied	\N	\N	\N	\N	146565	146565	313934
19243	26726	4	applied	\N	\N	\N	\N	146566	146566	313935
19246	26739	1	applied	\N	\N	\N	\N	146579	146579	313948
19246	26740	2	applied	\N	\N	\N	\N	146580	146580	313949
19251	26748	0	applied	\N	\N	\N	\N	146597	146597	313966
19251	26749	1	applied	\N	\N	\N	\N	146598	146598	313967
19251	26750	2	applied	\N	\N	\N	\N	146599	146599	313968
19253	26751	0	applied	\N	\N	\N	\N	146603	146603	313972
19253	26752	1	applied	\N	\N	\N	\N	146604	146604	313973
19253	26753	2	applied	\N	\N	\N	\N	146605	146605	313974
19256	26588	0	applied	\N	\N	\N	\N	146622	146622	146622
19256	26595	1	applied	\N	\N	\N	\N	146623	146623	146623
19256	26708	2	applied	\N	\N	1000000000	\N	146624	146624	313991
19256	26322	3	applied	\N	\N	1000000000	\N	146625	146625	313992
19256	26723	4	applied	\N	\N	\N	\N	146626	146626	313993
19256	26560	5	applied	\N	\N	\N	\N	146627	146627	313994
19256	26561	6	applied	\N	\N	\N	\N	146628	146628	313995
19256	26562	7	applied	\N	\N	\N	\N	146629	146629	313996
19256	26738	8	applied	\N	\N	1000000000	\N	146630	146630	313997
19256	26565	9	applied	\N	\N	\N	\N	146631	146631	313998
19256	26584	10	applied	\N	\N	\N	\N	146632	146632	313999
19256	26325	12	applied	\N	\N	1000000000	\N	146634	146634	314001
19256	26326	13	applied	\N	\N	1000000000	\N	146635	146635	314002
19256	26327	14	applied	\N	\N	1000000000	\N	146636	146636	314003
19256	26328	15	applied	\N	\N	1000000000	\N	146637	146637	314004
19256	26329	16	applied	\N	\N	1000000000	\N	146638	146638	314005
19256	26330	17	applied	\N	\N	1000000000	\N	146639	146639	314006
19256	26363	18	applied	\N	\N	1000000000	\N	146640	146640	314007
19256	26364	19	applied	\N	\N	\N	\N	146641	146641	314008
19256	26361	20	applied	\N	\N	1000000000	\N	146642	146642	314009
19256	26436	21	applied	\N	\N	1000000000	\N	146643	146643	314010
19256	26372	22	applied	\N	\N	\N	\N	146644	146644	314011
19256	26497	23	applied	\N	\N	\N	\N	146645	146645	314012
19256	26437	24	applied	\N	\N	\N	\N	146646	146646	314013
19256	26498	25	applied	\N	\N	\N	\N	146647	146647	314014
19256	26499	26	applied	\N	\N	\N	\N	146648	146648	314015
19256	26515	27	applied	\N	\N	\N	\N	146649	146649	314016
19256	26373	28	applied	\N	\N	\N	\N	146650	146650	314017
19256	26378	29	applied	\N	\N	\N	\N	146651	146651	314018
19256	26384	31	applied	\N	\N	\N	\N	146653	146653	314020
19256	26389	32	applied	\N	\N	\N	\N	146654	146654	314021
19256	26390	33	applied	\N	\N	\N	\N	146655	146655	314022
19256	26391	34	applied	\N	\N	\N	\N	146656	146656	314023
19256	26395	35	applied	\N	\N	\N	\N	146657	146657	314024
19256	26401	36	applied	\N	\N	\N	\N	146658	146658	314025
19256	26402	37	applied	\N	\N	\N	\N	146659	146659	314026
19256	26410	38	applied	\N	\N	\N	\N	146660	146660	314027
19256	26447	39	applied	\N	\N	\N	\N	146661	146661	314028
19256	26452	40	applied	\N	\N	\N	\N	146662	146662	314029
19256	26757	41	applied	\N	\N	\N	\N	146663	146663	314030
19256	26651	42	applied	\N	\N	\N	\N	146664	146664	314031
19256	26456	43	applied	\N	\N	\N	\N	146665	146665	314032
19256	26457	44	applied	\N	\N	\N	\N	146666	146666	314033
19256	26375	45	applied	\N	\N	\N	\N	146667	146667	314034
19256	26377	46	applied	\N	\N	\N	\N	146668	146668	314035
19256	26383	48	applied	\N	\N	\N	\N	146670	146670	314037
19256	26387	49	applied	\N	\N	\N	\N	146671	146671	314038
19256	26388	50	applied	\N	\N	\N	\N	146672	146672	314039
19256	26392	51	applied	\N	\N	\N	\N	146673	146673	314040
19256	26396	52	applied	\N	\N	\N	\N	146674	146674	314041
19256	26403	53	applied	\N	\N	\N	\N	146675	146675	314042
19256	26404	54	applied	\N	\N	\N	\N	146676	146676	314043
19256	26408	55	applied	\N	\N	\N	\N	146677	146677	314044
19256	26409	56	applied	\N	\N	\N	\N	146678	146678	314045
19256	26412	57	applied	\N	\N	\N	\N	146679	146679	314046
19256	26460	58	applied	\N	\N	\N	\N	146680	146680	314047
19256	26462	59	applied	\N	\N	\N	\N	146681	146681	314048
19256	26466	60	applied	\N	\N	\N	\N	146682	146682	314049
19256	26470	61	applied	\N	\N	\N	\N	146683	146683	314050
19256	26474	62	applied	\N	\N	\N	\N	146684	146684	314051
19256	26475	63	applied	\N	\N	\N	\N	146685	146685	314052
19256	26483	65	applied	\N	\N	\N	\N	146687	146687	314054
19256	26485	66	applied	\N	\N	\N	\N	146688	146688	314055
19256	26488	67	applied	\N	\N	\N	\N	146689	146689	314056
19256	26416	68	applied	\N	\N	\N	\N	146690	146690	314057
19256	26418	69	applied	\N	\N	\N	\N	146691	146691	314058
19256	26419	70	applied	\N	\N	\N	\N	146692	146692	314059
19256	26423	71	applied	\N	\N	\N	\N	146693	146693	314060
19256	26424	72	applied	\N	\N	\N	\N	146694	146694	314061
19256	26425	73	applied	\N	\N	\N	\N	146695	146695	314062
19256	26427	74	applied	\N	\N	\N	\N	146696	146696	314063
19256	26430	75	applied	\N	\N	\N	\N	146697	146697	314064
19256	26431	76	applied	\N	\N	\N	\N	146698	146698	314065
19256	26433	77	applied	\N	\N	\N	\N	146699	146699	314066
19256	26435	79	applied	\N	\N	\N	\N	146700	146700	314067
19256	26438	80	applied	\N	\N	\N	\N	146701	146701	314068
19256	26439	81	applied	\N	\N	\N	\N	146702	146702	314069
19266	26782	3	applied	\N	\N	\N	\N	146772	146772	314139
19266	26785	4	applied	\N	\N	\N	\N	146773	146773	314140
19266	26773	5	applied	\N	\N	\N	\N	146774	146774	314141
19266	26777	6	applied	\N	\N	\N	\N	146775	146775	314142
19266	26780	7	applied	\N	\N	\N	\N	146776	146776	314143
19266	26774	8	applied	\N	\N	\N	\N	146777	146777	314144
19266	26776	9	applied	\N	\N	\N	\N	146778	146778	314145
19266	26779	10	applied	\N	\N	\N	\N	146779	146779	314146
19266	26784	11	applied	\N	\N	\N	\N	146780	146780	314147
19266	26786	12	applied	\N	\N	\N	\N	146781	146781	314148
19266	26781	13	applied	\N	\N	\N	\N	146782	146782	314149
19266	26783	14	applied	\N	\N	\N	\N	146783	146783	314150
19266	26787	15	applied	\N	\N	\N	\N	146784	146784	314151
19269	26785	0	applied	\N	\N	\N	\N	146791	146791	314158
19269	26786	1	applied	\N	\N	\N	\N	146792	146792	314159
19269	26787	2	applied	\N	\N	\N	\N	146793	146793	314160
19276	26796	1	applied	\N	\N	\N	\N	146814	146814	314181
19276	26797	2	applied	\N	\N	\N	\N	146815	146815	314182
19242	26720	1	applied	\N	\N	\N	\N	146560	146560	313929
19242	26721	2	applied	\N	\N	\N	\N	146561	146561	313930
19255	26755	1	applied	\N	\N	\N	\N	146615	146615	313984
19255	26756	2	applied	\N	\N	\N	\N	146616	146616	313985
19255	26757	3	applied	\N	\N	\N	\N	146617	146617	313986
19255	26758	4	applied	\N	\N	\N	\N	146618	146618	313987
19255	26759	5	applied	\N	\N	\N	\N	146619	146619	313988
19255	26760	6	applied	\N	\N	\N	\N	146620	146620	313989
19255	26761	7	applied	\N	\N	\N	\N	146621	146621	313990
19256	26444	82	applied	\N	\N	\N	\N	146703	146703	314070
19256	26445	83	applied	\N	\N	\N	\N	146704	146704	314071
19256	26453	84	applied	\N	\N	\N	\N	146705	146705	314072
19257	26762	0	applied	\N	\N	\N	\N	146706	146706	314073
19257	26763	1	applied	\N	\N	\N	\N	146707	146707	314074
19257	26764	2	applied	\N	\N	\N	\N	146708	146708	314075
19257	26765	3	applied	\N	\N	\N	\N	146709	146709	314076
19257	26766	4	applied	\N	\N	\N	\N	146710	146710	314077
19257	26767	5	applied	\N	\N	\N	\N	146711	146711	314078
19257	26769	7	applied	\N	\N	\N	\N	146713	146713	314080
19257	26770	8	applied	\N	\N	\N	\N	146714	146714	314081
19257	26771	9	applied	\N	\N	\N	\N	146715	146715	314082
19259	26762	0	applied	\N	\N	\N	\N	146726	146726	314093
19259	26763	1	applied	\N	\N	\N	\N	146727	146727	314094
19259	26764	2	applied	\N	\N	\N	\N	146728	146728	314095
19259	26765	3	applied	\N	\N	\N	\N	146729	146729	314096
19259	26766	4	applied	\N	\N	\N	\N	146730	146730	314097
19259	26767	5	applied	\N	\N	\N	\N	146731	146731	314098
19259	26768	6	applied	\N	\N	\N	\N	146732	146732	314099
19259	26769	7	applied	\N	\N	\N	\N	146733	146733	314100
19259	26770	8	applied	\N	\N	\N	\N	146734	146734	314101
19259	26771	9	applied	\N	\N	\N	\N	146735	146735	314102
19260	26762	0	applied	\N	\N	\N	\N	146736	146736	314103
19260	26763	1	applied	\N	\N	\N	\N	146737	146737	314104
19260	26764	2	applied	\N	\N	\N	\N	146738	146738	314105
19260	26766	4	applied	\N	\N	\N	\N	146740	146740	314107
19260	26767	5	applied	\N	\N	\N	\N	146741	146741	314108
19260	26768	6	applied	\N	\N	\N	\N	146742	146742	314109
19260	26769	7	applied	\N	\N	\N	\N	146743	146743	314110
19260	26770	8	applied	\N	\N	\N	\N	146744	146744	314111
19260	26771	9	applied	\N	\N	\N	\N	146745	146745	314112
19264	26778	0	applied	\N	\N	\N	\N	146762	146762	314129
19264	26779	1	applied	\N	\N	\N	\N	146763	146763	314130
19264	26780	2	applied	\N	\N	\N	\N	146764	146764	314131
19264	26781	3	applied	\N	\N	\N	\N	146765	146765	314132
19265	26782	0	applied	\N	\N	\N	\N	146766	146766	314133
19265	26783	1	applied	\N	\N	\N	\N	146767	146767	314134
19265	26784	2	applied	\N	\N	\N	\N	146768	146768	314135
19267	26785	0	applied	\N	\N	\N	\N	146785	146785	314152
19267	26786	1	applied	\N	\N	\N	\N	146786	146786	314153
19267	26787	2	applied	\N	\N	\N	\N	146787	146787	314154
19270	26786	1	applied	\N	\N	\N	\N	146795	146795	314162
19270	26787	2	applied	\N	\N	\N	\N	146796	146796	314163
19272	26791	0	applied	\N	\N	\N	\N	146800	146800	314167
19272	26792	1	applied	\N	\N	\N	\N	146801	146801	314168
19272	26793	2	applied	\N	\N	\N	\N	146802	146802	314169
19272	26794	3	applied	\N	\N	\N	\N	146803	146803	314170
19273	26795	0	applied	\N	\N	\N	\N	146804	146804	314171
19273	26796	1	applied	\N	\N	\N	\N	146805	146805	314172
19273	26797	2	applied	\N	\N	\N	\N	146806	146806	314173
19278	26802	0	applied	\N	\N	\N	\N	146820	146820	314187
19278	26803	1	applied	\N	\N	\N	\N	146821	146821	314188
19278	26804	2	applied	\N	\N	\N	\N	146822	146822	314189
19278	26805	3	applied	\N	\N	\N	\N	146823	146823	314190
19278	26806	4	applied	\N	\N	\N	\N	146824	146824	314191
19278	26807	5	applied	\N	\N	\N	\N	146825	146825	314192
19280	26808	0	applied	\N	\N	\N	\N	146832	146832	314199
19280	26810	2	applied	\N	\N	\N	\N	146834	146834	314201
19283	26815	0	applied	\N	\N	\N	\N	146842	146842	314209
19283	26816	1	applied	\N	\N	\N	\N	146843	146843	314210
19283	26817	2	applied	\N	\N	\N	\N	146844	146844	314211
19283	26818	3	applied	\N	\N	\N	\N	146845	146845	314212
19283	26819	4	applied	\N	\N	\N	\N	146846	146846	314213
19283	26820	5	applied	\N	\N	\N	\N	146847	146847	314214
19283	26821	6	applied	\N	\N	\N	\N	146848	146848	314215
19285	26822	0	applied	\N	\N	\N	\N	146856	146856	314223
19285	26823	1	applied	\N	\N	\N	\N	146857	146857	314224
19285	26824	2	applied	\N	\N	\N	\N	146858	146858	314225
19285	26825	3	applied	\N	\N	\N	\N	146859	146859	314226
19285	26826	4	applied	\N	\N	\N	\N	146860	146860	314227
19285	26827	5	applied	\N	\N	\N	\N	146861	146861	314228
19285	26828	6	applied	\N	\N	\N	\N	146862	146862	314229
19285	26829	7	applied	\N	\N	\N	\N	146863	146863	314230
19291	26849	1	applied	\N	\N	\N	\N	146906	146906	314273
19291	26850	2	applied	\N	\N	\N	\N	146907	146907	314274
19291	26851	3	applied	\N	\N	\N	\N	146908	146908	314275
19291	26852	4	applied	\N	\N	\N	\N	146909	146909	314276
19291	26853	5	applied	\N	\N	\N	\N	146910	146910	314277
19291	26854	6	applied	\N	\N	\N	\N	146911	146911	314278
19298	26865	0	applied	\N	\N	\N	\N	146938	146938	314305
19298	26866	1	applied	\N	\N	\N	\N	146939	146939	314306
19298	26867	2	applied	\N	\N	\N	\N	146940	146940	314307
19300	26871	0	applied	\N	\N	\N	\N	146944	146944	314311
19300	26872	1	applied	\N	\N	\N	\N	146945	146945	314312
19300	26873	2	applied	\N	\N	\N	\N	146946	146946	314313
19300	26874	3	applied	\N	\N	\N	\N	146947	146947	314314
19303	26878	0	applied	\N	\N	\N	\N	146951	146951	314318
19303	26879	1	applied	\N	\N	\N	\N	146952	146952	314319
19303	26880	2	applied	\N	\N	\N	\N	146953	146953	314320
19303	26882	4	applied	\N	\N	\N	\N	146955	146955	314322
19303	26883	5	applied	\N	\N	\N	\N	146956	146956	314323
19303	26884	6	applied	\N	\N	\N	\N	146957	146957	314324
19303	26885	7	applied	\N	\N	\N	\N	146958	146958	314325
19303	26886	8	applied	\N	\N	\N	\N	146959	146959	314326
19303	26887	9	applied	\N	\N	\N	\N	146960	146960	314327
19303	26888	10	applied	\N	\N	\N	\N	146961	146961	314328
19303	26889	11	applied	\N	\N	\N	\N	146962	146962	314329
19303	26890	12	applied	\N	\N	\N	\N	146963	146963	314330
19303	26891	13	applied	\N	\N	\N	\N	146964	146964	314331
19303	26892	14	applied	\N	\N	\N	\N	146965	146965	314332
19303	26893	15	applied	\N	\N	\N	\N	146966	146966	314333
19303	26894	16	applied	\N	\N	\N	\N	146967	146967	314334
19303	26895	17	applied	\N	\N	\N	\N	146968	146968	314335
19252	26752	1	applied	\N	\N	\N	\N	146601	146601	313970
19252	26753	2	applied	\N	\N	\N	\N	146602	146602	313971
19286	26822	0	applied	\N	\N	\N	\N	146864	146864	314231
19286	26823	1	applied	\N	\N	\N	\N	146865	146865	314232
19286	26824	2	applied	\N	\N	\N	\N	146866	146866	314233
19286	26825	3	applied	\N	\N	\N	\N	146867	146867	314234
19286	26826	4	applied	\N	\N	\N	\N	146868	146868	314235
19286	26827	5	applied	\N	\N	\N	\N	146869	146869	314236
19286	26828	6	applied	\N	\N	\N	\N	146870	146870	314237
19289	26834	0	applied	\N	\N	\N	\N	146884	146884	314251
19289	26835	1	applied	\N	\N	\N	\N	146885	146885	314252
19289	26836	2	applied	\N	\N	\N	\N	146886	146886	314253
19289	26837	3	applied	\N	\N	\N	\N	146887	146887	314254
19289	26838	4	applied	\N	\N	\N	\N	146888	146888	314255
19289	26839	5	applied	\N	\N	1000000000	\N	146889	146889	314256
19289	26840	6	applied	\N	\N	1000000000	\N	146890	146890	314257
19289	26841	7	applied	\N	\N	1000000000	\N	146891	146891	314258
19289	26842	8	applied	\N	\N	\N	\N	146892	146892	314259
19289	26843	9	applied	\N	\N	\N	\N	146893	146893	314260
19289	26844	10	applied	\N	\N	\N	\N	146894	146894	314261
19289	26845	11	applied	\N	\N	\N	\N	146895	146895	314262
19289	26846	12	applied	\N	\N	1000000000	\N	146896	146896	314263
19289	26847	13	applied	\N	\N	1000000000	\N	146897	146897	314264
19294	26855	0	applied	\N	\N	\N	\N	146922	146922	314289
19294	26856	1	applied	\N	\N	\N	\N	146923	146923	314290
19296	26858	0	applied	\N	\N	\N	\N	146928	146928	314295
19296	26859	1	applied	\N	\N	\N	\N	146929	146929	314296
19296	26860	2	applied	\N	\N	\N	\N	146930	146930	314297
19296	26861	3	applied	\N	\N	\N	\N	146931	146931	314298
19296	26862	4	applied	\N	\N	\N	\N	146932	146932	314299
19296	26863	5	applied	\N	\N	\N	\N	146933	146933	314300
19296	26864	6	applied	\N	\N	\N	\N	146934	146934	314301
19301	26875	0	applied	\N	\N	\N	\N	146948	146948	314315
19301	26876	1	applied	\N	\N	\N	\N	146949	146949	314316
19301	26877	2	applied	\N	\N	\N	\N	146950	146950	314317
19303	26896	18	applied	\N	\N	\N	\N	146969	146969	146969
19303	26897	19	applied	\N	\N	\N	\N	146970	146970	314336
19305	26878	0	applied	\N	\N	\N	\N	146991	146991	314356
19305	26879	1	applied	\N	\N	\N	\N	146992	146992	314357
19305	26880	2	applied	\N	\N	\N	\N	146993	146993	314358
19305	26881	3	applied	\N	\N	\N	\N	146994	146994	314359
19305	26883	5	applied	\N	\N	\N	\N	146996	146996	314361
19305	26884	6	applied	\N	\N	\N	\N	146997	146997	314362
19305	26885	7	applied	\N	\N	\N	\N	146998	146998	314363
19305	26886	8	applied	\N	\N	\N	\N	146999	146999	314364
19305	26887	9	applied	\N	\N	\N	\N	147000	147000	314365
19305	26888	10	applied	\N	\N	\N	\N	147001	147001	314366
19305	26889	11	applied	\N	\N	\N	\N	147002	147002	314367
19305	26890	12	applied	\N	\N	\N	\N	147003	147003	314368
19305	26891	13	applied	\N	\N	\N	\N	147004	147004	314369
19305	26892	14	applied	\N	\N	\N	\N	147005	147005	314370
19305	26893	15	applied	\N	\N	\N	\N	147006	147006	314371
19305	26894	16	applied	\N	\N	\N	\N	147007	147007	314372
19305	26895	17	applied	\N	\N	\N	\N	147008	147008	314373
19305	26896	18	applied	\N	\N	\N	\N	147009	147009	147009
19305	26897	19	applied	\N	\N	\N	\N	147010	147010	314374
19306	26878	0	applied	\N	\N	\N	\N	147011	147011	314375
19306	26880	2	applied	\N	\N	\N	\N	147013	147013	314377
19306	26881	3	applied	\N	\N	\N	\N	147014	147014	314378
19306	26882	4	applied	\N	\N	\N	\N	147015	147015	314379
19306	26883	5	applied	\N	\N	\N	\N	147016	147016	314380
19306	26884	6	applied	\N	\N	\N	\N	147017	147017	314381
19306	26885	7	applied	\N	\N	\N	\N	147018	147018	314382
19306	26886	8	applied	\N	\N	\N	\N	147019	147019	314383
19306	26887	9	applied	\N	\N	\N	\N	147020	147020	314384
19306	26888	10	applied	\N	\N	\N	\N	147021	147021	314385
19306	26889	11	applied	\N	\N	\N	\N	147022	147022	314386
19306	26890	12	applied	\N	\N	\N	\N	147023	147023	314387
19306	26891	13	applied	\N	\N	\N	\N	147024	147024	314388
19306	26892	14	applied	\N	\N	\N	\N	147025	147025	314389
19306	26893	15	applied	\N	\N	\N	\N	147026	147026	314390
19306	26894	16	applied	\N	\N	\N	\N	147027	147027	314391
19306	26895	17	applied	\N	\N	\N	\N	147028	147028	314392
19309	26906	1	applied	\N	\N	\N	\N	147046	147046	314409
19316	26924	0	applied	\N	\N	\N	\N	147073	147073	314436
19316	26925	1	applied	\N	\N	\N	\N	147074	147074	314437
19316	26926	2	applied	\N	\N	\N	\N	147075	147075	314438
19316	26927	3	applied	\N	\N	\N	\N	147076	147076	314439
19316	26928	4	applied	\N	\N	\N	\N	147077	147077	314440
19316	26929	5	applied	\N	\N	\N	\N	147078	147078	314441
19316	26930	6	applied	\N	\N	\N	\N	147079	147079	314442
19324	26955	0	applied	\N	\N	\N	\N	147283	147283	314643
19324	26956	1	applied	\N	\N	\N	\N	147284	147284	314644
19324	26957	2	applied	\N	\N	\N	\N	147285	147285	314645
19324	26958	3	applied	\N	\N	\N	\N	147286	147286	314646
19324	26959	4	applied	\N	\N	\N	\N	147287	147287	314647
19324	26960	5	applied	\N	\N	\N	\N	147288	147288	314648
19324	26961	6	applied	\N	\N	\N	\N	147289	147289	314649
19324	26962	7	applied	\N	\N	\N	\N	147290	147290	314650
19327	26964	0	applied	\N	\N	\N	\N	147312	147312	314672
19327	26965	1	applied	\N	\N	\N	\N	147313	147313	314673
19327	26966	2	applied	\N	\N	\N	\N	147314	147314	314674
19327	26967	3	applied	\N	\N	\N	\N	147315	147315	314675
19327	26968	4	applied	\N	\N	\N	\N	147316	147316	314676
19327	26969	5	applied	\N	\N	\N	\N	147317	147317	314677
19327	26970	6	applied	\N	\N	\N	\N	147318	147318	314678
19327	26971	7	applied	\N	\N	\N	\N	147319	147319	314679
19327	26972	8	applied	\N	\N	\N	\N	147320	147320	314680
19327	26973	9	applied	\N	\N	\N	\N	147321	147321	314681
19327	26974	10	applied	\N	\N	\N	\N	147322	147322	314682
19329	26964	0	applied	\N	\N	\N	\N	147334	147334	314694
19329	26965	1	applied	\N	\N	\N	\N	147335	147335	314695
19329	26966	2	applied	\N	\N	\N	\N	147336	147336	314696
19329	26967	3	applied	\N	\N	\N	\N	147337	147337	314697
19329	26968	4	applied	\N	\N	\N	\N	147338	147338	314698
19329	26970	6	applied	\N	\N	\N	\N	147340	147340	314700
19329	26971	7	applied	\N	\N	\N	\N	147341	147341	314701
19329	26972	8	applied	\N	\N	\N	\N	147342	147342	314702
19329	26973	9	applied	\N	\N	\N	\N	147343	147343	314703
19329	26974	10	applied	\N	\N	\N	\N	147344	147344	314704
19339	27012	0	applied	\N	\N	\N	\N	147403	147403	314762
19275	26796	1	applied	\N	\N	\N	\N	146811	146811	314178
19275	26797	2	applied	\N	\N	\N	\N	146812	146812	314179
19277	26801	3	applied	\N	\N	\N	\N	146819	146819	314186
19282	26811	0	applied	\N	\N	\N	\N	146838	146838	314205
19282	26812	1	applied	\N	\N	\N	\N	146839	146839	314206
19282	26813	2	applied	\N	\N	\N	\N	146840	146840	314207
19282	26814	3	applied	\N	\N	\N	\N	146841	146841	314208
19287	26822	0	applied	\N	\N	\N	\N	146872	146872	314239
19287	26823	1	applied	\N	\N	\N	\N	146873	146873	314240
19287	26825	3	applied	\N	\N	\N	\N	146875	146875	314242
19287	26826	4	applied	\N	\N	\N	\N	146876	146876	314243
19287	26827	5	applied	\N	\N	\N	\N	146877	146877	314244
19287	26828	6	applied	\N	\N	\N	\N	146878	146878	314245
19287	26829	7	applied	\N	\N	\N	\N	146879	146879	314246
19290	26848	0	applied	\N	\N	\N	\N	146898	146898	314265
19290	26849	1	applied	\N	\N	\N	\N	146899	146899	314266
19290	26850	2	applied	\N	\N	\N	\N	146900	146900	314267
19290	26851	3	applied	\N	\N	\N	\N	146901	146901	314268
19290	26852	4	applied	\N	\N	\N	\N	146902	146902	314269
19290	26853	5	applied	\N	\N	\N	\N	146903	146903	314270
19290	26854	6	applied	\N	\N	\N	\N	146904	146904	314271
19292	26848	0	applied	\N	\N	\N	\N	146912	146912	314279
19292	26849	1	applied	\N	\N	\N	\N	146913	146913	314280
19292	26850	2	applied	\N	\N	\N	\N	146914	146914	314281
19292	26851	3	applied	\N	\N	\N	\N	146915	146915	314282
19292	26853	5	applied	\N	\N	\N	\N	146917	146917	314284
19292	26854	6	applied	\N	\N	\N	\N	146918	146918	314285
19295	26855	0	applied	\N	\N	\N	\N	146925	146925	314292
19295	26856	1	applied	\N	\N	\N	\N	146926	146926	314293
19295	26857	2	applied	\N	\N	\N	\N	146927	146927	314294
19297	26865	0	applied	\N	\N	\N	\N	146935	146935	314302
19297	26866	1	applied	\N	\N	\N	\N	146936	146936	314303
19297	26867	2	applied	\N	\N	\N	\N	146937	146937	314304
19299	26868	0	applied	\N	\N	\N	\N	146941	146941	314308
19299	26869	1	applied	\N	\N	\N	\N	146942	146942	314309
19299	26870	2	applied	\N	\N	\N	\N	146943	146943	314310
19307	26898	0	applied	\N	\N	\N	\N	147031	147031	314394
19307	26899	1	applied	\N	\N	\N	\N	147032	147032	314395
19307	26900	2	applied	\N	\N	\N	\N	147033	147033	314396
19307	26901	3	applied	\N	\N	\N	\N	147034	147034	314397
19307	26902	4	applied	\N	\N	\N	\N	147035	147035	314398
19307	26904	6	applied	\N	\N	\N	\N	147037	147037	314400
19312	26921	0	applied	\N	\N	\N	\N	147061	147061	314424
19312	26922	1	applied	\N	\N	\N	\N	147062	147062	314425
19312	26923	2	applied	\N	\N	\N	\N	147063	147063	314426
19317	26931	0	applied	\N	\N	\N	\N	147080	147080	314443
19317	26932	1	applied	\N	\N	\N	\N	147081	147081	314444
19317	26933	2	applied	\N	\N	\N	\N	147082	147082	314445
19317	26934	3	applied	\N	\N	\N	\N	147083	147083	314446
19317	26935	4	applied	\N	\N	\N	\N	147084	147084	314447
19317	26936	5	applied	\N	\N	\N	\N	147085	147085	314448
19317	26937	6	applied	\N	\N	\N	\N	147086	147086	314449
19317	26938	7	applied	\N	\N	\N	\N	147087	147087	314450
19319	26939	0	applied	\N	\N	\N	\N	147096	147096	314459
19319	26940	1	applied	\N	\N	\N	\N	147097	147097	314460
19319	26941	2	applied	\N	\N	\N	\N	147098	147098	314461
19321	26588	0	applied	\N	\N	\N	\N	147103	147103	147103
19321	26798	2	applied	\N	\N	\N	\N	147105	147105	314466
19321	26708	3	applied	\N	\N	1000000000	\N	147106	147106	314467
19321	26815	4	applied	\N	\N	\N	\N	147107	147107	314468
19321	26723	5	applied	\N	\N	\N	\N	147108	147108	314469
19321	26560	6	applied	\N	\N	\N	\N	147109	147109	314470
19321	26561	7	applied	\N	\N	\N	\N	147110	147110	314471
19321	26562	8	applied	\N	\N	\N	\N	147111	147111	314472
19321	26738	9	applied	\N	\N	1000000000	\N	147112	147112	314473
19321	26823	10	applied	\N	\N	\N	\N	147113	147113	314474
19321	26824	11	applied	\N	\N	\N	\N	147114	147114	314475
19321	26565	12	applied	\N	\N	\N	\N	147115	147115	314476
19321	26584	13	applied	\N	\N	\N	\N	147116	147116	314477
19321	26825	14	applied	\N	\N	\N	\N	147117	147117	314478
19321	26826	15	applied	\N	\N	\N	\N	147118	147118	314479
19321	26827	16	applied	\N	\N	\N	\N	147119	147119	314480
19321	26878	17	applied	\N	\N	\N	\N	147120	147120	314481
19321	26882	19	applied	\N	\N	\N	\N	147122	147122	314483
19321	26883	20	applied	\N	\N	\N	\N	147123	147123	314484
19321	26884	21	applied	\N	\N	\N	\N	147124	147124	314485
19321	26910	22	applied	\N	\N	\N	\N	147125	147125	314486
19321	26911	23	applied	\N	\N	\N	\N	147126	147126	314487
19321	26912	24	applied	\N	\N	\N	\N	147127	147127	314488
19321	26914	25	applied	\N	\N	\N	\N	147128	147128	314489
19321	26915	26	applied	\N	\N	\N	\N	147129	147129	314490
19321	26932	27	applied	\N	\N	\N	\N	147130	147130	314491
19321	26933	28	applied	\N	\N	\N	\N	147131	147131	314492
19321	26934	29	applied	\N	\N	\N	\N	147132	147132	314493
19321	26935	30	applied	\N	\N	\N	\N	147133	147133	314494
19321	26936	31	applied	\N	\N	\N	\N	147134	147134	314495
19321	26887	32	applied	\N	\N	\N	\N	147135	147135	314496
19321	26836	33	applied	\N	\N	\N	\N	147136	147136	314497
19321	26840	35	applied	\N	\N	1000000000	\N	147138	147138	314499
19321	26841	36	applied	\N	\N	1000000000	\N	147139	147139	314500
19321	26757	37	applied	\N	\N	\N	\N	147140	147140	314501
19321	26651	38	applied	\N	\N	\N	\N	147141	147141	314502
19339	27013	1	applied	\N	\N	\N	\N	147404	147404	314763
19339	27014	2	applied	\N	\N	\N	\N	147405	147405	147405
19339	27015	3	applied	\N	\N	\N	\N	147406	147406	314764
19339	27016	4	applied	\N	\N	\N	\N	147407	147407	147407
19339	27017	5	applied	\N	\N	\N	\N	147408	147408	314765
19339	27018	6	applied	\N	\N	\N	\N	147409	147409	147409
19339	27019	7	applied	\N	\N	\N	\N	147410	147410	314766
19339	27020	8	applied	\N	\N	\N	\N	147411	147411	314767
19339	27021	9	applied	\N	\N	\N	\N	147412	147412	314768
19346	27028	0	applied	\N	\N	\N	\N	147459	147459	314803
19346	27029	1	applied	\N	\N	\N	\N	147460	147460	314804
19346	27030	2	applied	\N	\N	\N	\N	147461	147461	314805
19346	27031	3	applied	\N	\N	\N	\N	147462	147462	314806
19353	27036	0	applied	\N	\N	\N	\N	147497	147497	314837
19356	26964	0	applied	\N	\N	\N	\N	147525	147525	314865
19356	27052	2	applied	\N	\N	\N	\N	147527	147527	314867
19356	27053	3	applied	\N	\N	\N	\N	147528	147528	314868
19356	27054	4	applied	\N	\N	\N	\N	147529	147529	314869
19356	26887	5	applied	\N	\N	\N	\N	147530	147530	314870
19277	26799	1	applied	\N	\N	\N	\N	146817	146817	314184
19277	26800	2	applied	\N	\N	\N	\N	146818	146818	314185
19279	26807	5	applied	\N	\N	\N	\N	146831	146831	314198
19281	26809	1	applied	\N	\N	\N	\N	146836	146836	314203
19281	26810	2	applied	\N	\N	\N	\N	146837	146837	314204
19284	26815	0	applied	\N	\N	\N	\N	146849	146849	314216
19284	26816	1	applied	\N	\N	\N	\N	146850	146850	314217
19284	26817	2	applied	\N	\N	\N	\N	146851	146851	314218
19284	26818	3	applied	\N	\N	\N	\N	146852	146852	314219
19284	26819	4	applied	\N	\N	\N	\N	146853	146853	314220
19284	26820	5	applied	\N	\N	\N	\N	146854	146854	314221
19284	26821	6	applied	\N	\N	\N	\N	146855	146855	314222
19288	26830	0	applied	\N	\N	\N	\N	146880	146880	314247
19288	26831	1	applied	\N	\N	\N	\N	146881	146881	314248
19288	26832	2	applied	\N	\N	\N	\N	146882	146882	314249
19288	26833	3	applied	\N	\N	\N	\N	146883	146883	314250
19293	26855	0	applied	\N	\N	\N	\N	146919	146919	314286
19293	26856	1	applied	\N	\N	\N	\N	146920	146920	314287
19293	26857	2	applied	\N	\N	\N	\N	146921	146921	314288
19304	26879	1	applied	\N	\N	\N	\N	146972	146972	314338
19304	26880	2	applied	\N	\N	\N	\N	146973	146973	314339
19304	26881	3	applied	\N	\N	\N	\N	146974	146974	314340
19304	26882	4	applied	\N	\N	\N	\N	146975	146975	314341
19304	26883	5	applied	\N	\N	\N	\N	146976	146976	314342
19304	26884	6	applied	\N	\N	\N	\N	146977	146977	314343
19304	26885	7	applied	\N	\N	\N	\N	146978	146978	314344
19304	26886	8	applied	\N	\N	\N	\N	146979	146979	314345
19304	26887	9	applied	\N	\N	\N	\N	146980	146980	314346
19304	26888	10	applied	\N	\N	\N	\N	146981	146981	314347
19304	26889	11	applied	\N	\N	\N	\N	146982	146982	314348
19304	26890	12	applied	\N	\N	\N	\N	146983	146983	314349
19304	26891	13	applied	\N	\N	\N	\N	146984	146984	314350
19304	26892	14	applied	\N	\N	\N	\N	146985	146985	314351
19304	26893	15	applied	\N	\N	\N	\N	146986	146986	314352
19304	26894	16	applied	\N	\N	\N	\N	146987	146987	314353
19304	26896	18	applied	\N	\N	\N	\N	146989	146989	146989
19304	26897	19	applied	\N	\N	\N	\N	146990	146990	314355
19311	26910	0	applied	\N	\N	\N	\N	147050	147050	314413
19311	26911	1	applied	\N	\N	\N	\N	147051	147051	314414
19311	26912	2	applied	\N	\N	\N	\N	147052	147052	314415
19311	26913	3	applied	\N	\N	\N	\N	147053	147053	314416
19311	26914	4	applied	\N	\N	\N	\N	147054	147054	314417
19311	26915	5	applied	\N	\N	\N	\N	147055	147055	314418
19311	26916	6	applied	\N	\N	\N	\N	147056	147056	314419
19311	26917	7	applied	\N	\N	1000000000	\N	147057	147057	314420
19311	26918	8	applied	\N	\N	1000000000	\N	147058	147058	314421
19311	26919	9	applied	\N	\N	\N	\N	147059	147059	314422
19311	26920	10	applied	\N	\N	\N	\N	147060	147060	314423
19314	26921	0	applied	\N	\N	\N	\N	147067	147067	314430
19314	26922	1	applied	\N	\N	\N	\N	147068	147068	314431
19314	26923	2	applied	\N	\N	\N	\N	147069	147069	314432
19315	26922	1	applied	\N	\N	\N	\N	147071	147071	314434
19315	26923	2	applied	\N	\N	\N	\N	147072	147072	314435
19321	26844	39	applied	\N	\N	\N	\N	147142	147142	314503
19321	26845	40	applied	\N	\N	\N	\N	147143	147143	314504
19321	26846	41	applied	\N	\N	1000000000	\N	147144	147144	314505
19321	26847	42	applied	\N	\N	1000000000	\N	147145	147145	314506
19321	26917	43	applied	\N	\N	1000000000	\N	147146	147146	314507
19321	26918	44	applied	\N	\N	1000000000	\N	147147	147147	314508
19321	26896	45	applied	\N	\N	\N	\N	147148	147148	147148
19322	26798	0	applied	\N	\N	\N	\N	147149	147149	314509
19322	26708	1	applied	\N	\N	1000000000	\N	147150	147150	314510
19322	26815	2	applied	\N	\N	\N	\N	147151	147151	314511
19322	26723	3	applied	\N	\N	\N	\N	147152	147152	314512
19322	26738	4	applied	\N	\N	1000000000	\N	147153	147153	314513
19322	26823	5	applied	\N	\N	\N	\N	147154	147154	314514
19322	26824	6	applied	\N	\N	\N	\N	147155	147155	314515
19322	26616	8	applied	\N	\N	\N	\N	147157	147157	314517
19322	26619	9	applied	\N	\N	\N	\N	147158	147158	314518
19322	26622	10	applied	\N	\N	\N	\N	147159	147159	314519
19322	26623	11	applied	\N	\N	\N	\N	147160	147160	314520
19326	26964	0	applied	\N	\N	\N	\N	147301	147301	314661
19326	26965	1	applied	\N	\N	\N	\N	147302	147302	314662
19326	26966	2	applied	\N	\N	\N	\N	147303	147303	314663
19326	26967	3	applied	\N	\N	\N	\N	147304	147304	314664
19326	26968	4	applied	\N	\N	\N	\N	147305	147305	314665
19326	26969	5	applied	\N	\N	\N	\N	147306	147306	314666
19326	26970	6	applied	\N	\N	\N	\N	147307	147307	314667
19326	26971	7	applied	\N	\N	\N	\N	147308	147308	314668
19326	26972	8	applied	\N	\N	\N	\N	147309	147309	314669
19326	26973	9	applied	\N	\N	\N	\N	147310	147310	314670
19326	26974	10	applied	\N	\N	\N	\N	147311	147311	314671
19331	26975	0	applied	\N	\N	\N	\N	147355	147355	314715
19331	26977	2	applied	\N	\N	\N	\N	147357	147357	314717
19331	26978	3	applied	\N	\N	\N	\N	147358	147358	314718
19331	26979	5	applied	\N	\N	\N	\N	147359	147359	314719
19331	26980	6	applied	\N	\N	\N	\N	147360	147360	314720
19331	26981	7	applied	\N	\N	\N	\N	147361	147361	314721
19331	26982	8	applied	\N	\N	\N	\N	147362	147362	314722
19331	26983	9	applied	\N	\N	\N	\N	147363	147363	314723
19331	26984	10	applied	\N	\N	\N	\N	147364	147364	314724
19334	26985	0	applied	\N	\N	\N	\N	147373	147373	314733
19334	26986	1	applied	\N	\N	\N	\N	147374	147374	314734
19334	26987	2	applied	\N	\N	\N	\N	147375	147375	314735
19334	26988	3	applied	\N	\N	\N	\N	147376	147376	314736
19336	27004	0	applied	\N	\N	\N	\N	147392	147392	314752
19336	27005	1	applied	\N	\N	\N	\N	147393	147393	314753
19336	27006	2	applied	\N	\N	\N	\N	147394	147394	314754
19336	27007	3	applied	\N	\N	\N	\N	147395	147395	314755
19338	27009	1	applied	\N	\N	\N	\N	147400	147400	314760
19338	27010	2	applied	\N	\N	\N	\N	147401	147401	314761
19338	27011	3	applied	\N	\N	\N	\N	147402	147402	147402
19345	27025	0	applied	\N	\N	\N	\N	147456	147456	314800
19345	27026	1	applied	\N	\N	\N	\N	147457	147457	314801
19345	27027	2	applied	\N	\N	\N	\N	147458	147458	314802
19352	27035	0	applied	\N	\N	\N	\N	147494	147494	314834
19352	27036	1	applied	\N	\N	\N	\N	147495	147495	314835
19352	27037	2	applied	\N	\N	\N	\N	147496	147496	314836
19354	27035	0	applied	\N	\N	\N	\N	147498	147498	314838
19354	27038	1	applied	\N	\N	\N	\N	147499	147499	314839
19354	27039	2	applied	\N	\N	\N	\N	147500	147500	314840
19279	26805	3	applied	\N	\N	\N	\N	146829	146829	314196
19279	26806	4	applied	\N	\N	\N	\N	146830	146830	314197
19308	26900	2	applied	\N	\N	\N	\N	147040	147040	314403
19308	26901	3	applied	\N	\N	\N	\N	147041	147041	314404
19308	26902	4	applied	\N	\N	\N	\N	147042	147042	314405
19308	26903	5	applied	\N	\N	\N	\N	147043	147043	314406
19308	26904	6	applied	\N	\N	\N	\N	147044	147044	314407
19310	26907	0	applied	\N	\N	\N	\N	147047	147047	314410
19310	26908	1	applied	\N	\N	\N	\N	147048	147048	314411
19310	26909	2	applied	\N	\N	\N	\N	147049	147049	314412
19313	26921	0	applied	\N	\N	\N	\N	147064	147064	314427
19313	26922	1	applied	\N	\N	\N	\N	147065	147065	314428
19313	26923	2	applied	\N	\N	\N	\N	147066	147066	314429
19318	26931	0	applied	\N	\N	\N	\N	147088	147088	314451
19318	26932	1	applied	\N	\N	\N	\N	147089	147089	314452
19318	26933	2	applied	\N	\N	\N	\N	147090	147090	314453
19318	26935	4	applied	\N	\N	\N	\N	147092	147092	314455
19318	26936	5	applied	\N	\N	\N	\N	147093	147093	314456
19318	26937	6	applied	\N	\N	\N	\N	147094	147094	314457
19318	26938	7	applied	\N	\N	\N	\N	147095	147095	314458
19320	26942	0	applied	\N	\N	\N	\N	147099	147099	314462
19320	26943	1	applied	\N	\N	\N	\N	147100	147100	314463
19320	26944	2	applied	\N	\N	\N	\N	147101	147101	314464
19320	26945	3	applied	\N	\N	\N	\N	147102	147102	314465
19323	26946	0	applied	\N	\N	\N	\N	147274	147274	314634
19323	26947	1	applied	\N	\N	\N	\N	147275	147275	314635
19323	26948	2	applied	\N	\N	\N	\N	147276	147276	314636
19323	26949	3	applied	\N	\N	\N	\N	147277	147277	314637
19323	26950	4	applied	\N	\N	\N	\N	147278	147278	314638
19323	26951	5	applied	\N	\N	\N	\N	147279	147279	314639
19323	26952	6	applied	\N	\N	\N	\N	147280	147280	314640
19323	26953	7	applied	\N	\N	\N	\N	147281	147281	314641
19328	26964	0	applied	\N	\N	\N	\N	147323	147323	314683
19328	26965	1	applied	\N	\N	\N	\N	147324	147324	314684
19328	26966	2	applied	\N	\N	\N	\N	147325	147325	314685
19328	26967	3	applied	\N	\N	\N	\N	147326	147326	314686
19328	26968	4	applied	\N	\N	\N	\N	147327	147327	314687
19328	26969	5	applied	\N	\N	\N	\N	147328	147328	314688
19328	26970	6	applied	\N	\N	\N	\N	147329	147329	314689
19328	26971	7	applied	\N	\N	\N	\N	147330	147330	314690
19328	26972	8	applied	\N	\N	\N	\N	147331	147331	314691
19328	26973	9	applied	\N	\N	\N	\N	147332	147332	314692
19328	26974	10	applied	\N	\N	\N	\N	147333	147333	314693
19330	26975	0	applied	\N	\N	\N	\N	147345	147345	314705
19330	26976	1	applied	\N	\N	\N	\N	147346	147346	314706
19330	26977	2	applied	\N	\N	\N	\N	147347	147347	314707
19330	26978	3	applied	\N	\N	\N	\N	147348	147348	314708
19330	26979	5	applied	\N	\N	\N	\N	147349	147349	314709
19330	26981	7	applied	\N	\N	\N	\N	147351	147351	314711
19330	26982	8	applied	\N	\N	\N	\N	147352	147352	314712
19330	26983	9	applied	\N	\N	\N	\N	147353	147353	314713
19330	26984	10	applied	\N	\N	\N	\N	147354	147354	314714
19333	26985	0	applied	\N	\N	\N	\N	147369	147369	314729
19333	26986	1	applied	\N	\N	\N	\N	147370	147370	314730
19333	26987	2	applied	\N	\N	\N	\N	147371	147371	314731
19333	26988	3	applied	\N	\N	\N	\N	147372	147372	314732
19335	26989	0	applied	\N	\N	\N	\N	147377	147377	314737
19335	26990	1	applied	\N	\N	\N	\N	147378	147378	314738
19335	26991	2	applied	\N	\N	\N	\N	147379	147379	314739
19335	26992	3	applied	\N	\N	\N	\N	147380	147380	314740
19335	26993	4	applied	\N	\N	\N	\N	147381	147381	314741
19335	26994	5	applied	\N	\N	\N	\N	147382	147382	314742
19335	26995	6	applied	\N	\N	\N	\N	147383	147383	314743
19335	26996	7	applied	\N	\N	\N	\N	147384	147384	314744
19335	26998	9	applied	\N	\N	\N	\N	147386	147386	314746
19335	26999	10	applied	\N	\N	\N	\N	147387	147387	314747
19335	27000	11	applied	\N	\N	\N	\N	147388	147388	314748
19335	27001	12	applied	\N	\N	\N	\N	147389	147389	314749
19335	27002	13	applied	\N	\N	\N	\N	147390	147390	314750
19335	27003	14	applied	\N	\N	\N	\N	147391	147391	314751
19341	27012	0	applied	\N	\N	\N	\N	147423	147423	314776
19341	27013	1	applied	\N	\N	\N	\N	147424	147424	314777
19341	27014	2	applied	\N	\N	\N	\N	147425	147425	147425
19341	27015	3	applied	\N	\N	\N	\N	147426	147426	314778
19341	27016	4	applied	\N	\N	\N	\N	147427	147427	147427
19341	27017	5	applied	\N	\N	\N	\N	147428	147428	314779
19341	27018	6	applied	\N	\N	\N	\N	147429	147429	147429
19341	27019	7	applied	\N	\N	\N	\N	147430	147430	314780
19341	27020	8	applied	\N	\N	\N	\N	147431	147431	314781
19341	27021	9	applied	\N	\N	\N	\N	147432	147432	314782
19343	27013	1	applied	\N	\N	\N	\N	147444	147444	314791
19343	27014	2	applied	\N	\N	\N	\N	147445	147445	147445
19343	27015	3	applied	\N	\N	\N	\N	147446	147446	314792
19343	27016	4	applied	\N	\N	\N	\N	147447	147447	147447
19343	27017	5	applied	\N	\N	\N	\N	147448	147448	314793
19343	27018	6	applied	\N	\N	\N	\N	147449	147449	147449
19343	27019	7	applied	\N	\N	\N	\N	147450	147450	314794
19343	27020	8	applied	\N	\N	\N	\N	147451	147451	314795
19343	27021	9	applied	\N	\N	\N	\N	147452	147452	314796
19349	26964	0	applied	\N	\N	\N	\N	147467	147467	314811
19349	26955	1	applied	\N	\N	\N	\N	147468	147468	314812
19349	26956	2	applied	\N	\N	\N	\N	147469	147469	314813
19349	26958	3	applied	\N	\N	\N	\N	147470	147470	314814
19349	26959	4	applied	\N	\N	\N	\N	147471	147471	314815
19354	27040	3	applied	\N	\N	\N	\N	147501	147501	314841
19354	27041	4	applied	\N	\N	\N	\N	147502	147502	314842
19354	27043	6	applied	\N	\N	\N	\N	147504	147504	314844
19354	27037	7	applied	\N	\N	\N	\N	147505	147505	314845
19354	27044	8	applied	\N	\N	\N	\N	147506	147506	314846
19354	27045	9	applied	\N	\N	\N	\N	147507	147507	314847
19354	27046	10	applied	\N	\N	\N	\N	147508	147508	314848
19354	27047	11	applied	\N	\N	\N	\N	147509	147509	314849
19355	27048	0	applied	\N	\N	\N	\N	147510	147510	314850
19355	27049	1	applied	\N	\N	\N	\N	147511	147511	314851
19355	27050	2	applied	\N	\N	\N	\N	147512	147512	314852
19355	27051	3	applied	\N	\N	\N	\N	147513	147513	314853
19355	27052	4	applied	\N	\N	\N	\N	147514	147514	314854
19355	27053	5	applied	\N	\N	\N	\N	147515	147515	314855
19355	27054	6	applied	\N	\N	\N	\N	147516	147516	314856
19355	27055	7	applied	\N	\N	\N	\N	147517	147517	314857
19355	27057	9	applied	\N	\N	\N	\N	147519	147519	314859
19308	26898	0	applied	\N	\N	\N	\N	147038	147038	314401
19308	26899	1	applied	\N	\N	\N	\N	147039	147039	314402
19322	26642	16	applied	\N	\N	\N	\N	147165	147165	314525
19322	26643	17	applied	\N	\N	\N	\N	147166	147166	314526
19322	26644	18	applied	\N	\N	\N	\N	147167	147167	314527
19322	26645	19	applied	\N	\N	\N	\N	147168	147168	314528
19322	26646	20	applied	\N	\N	\N	\N	147169	147169	314529
19322	26659	21	applied	\N	\N	\N	\N	147170	147170	314530
19322	26662	22	applied	\N	\N	\N	\N	147171	147171	314531
19322	26665	23	applied	\N	\N	\N	\N	147172	147172	314532
19322	26669	24	applied	\N	\N	\N	\N	147173	147173	314533
19322	26672	25	applied	\N	\N	\N	\N	147174	147174	314534
19322	26673	26	applied	\N	\N	\N	\N	147175	147175	314535
19322	26674	27	applied	\N	\N	\N	\N	147176	147176	314536
19322	26675	28	applied	\N	\N	\N	\N	147177	147177	314537
19322	26676	29	applied	\N	\N	\N	\N	147178	147178	314538
19322	26677	30	applied	\N	\N	\N	\N	147179	147179	314539
19322	26692	31	applied	\N	\N	\N	\N	147180	147180	314540
19322	26694	33	applied	\N	\N	\N	\N	147182	147182	314542
19322	26702	34	applied	\N	\N	\N	\N	147183	147183	314543
19322	26703	35	applied	\N	\N	\N	\N	147184	147184	314544
19322	26709	36	applied	\N	\N	\N	\N	147185	147185	314545
19322	26713	37	applied	\N	\N	\N	\N	147186	147186	314546
19322	26716	38	applied	\N	\N	\N	\N	147187	147187	314547
19322	26719	39	applied	\N	\N	\N	\N	147188	147188	314548
19322	26722	40	applied	\N	\N	\N	\N	147189	147189	314549
19322	26728	41	applied	\N	\N	\N	\N	147190	147190	314550
19322	26729	42	applied	\N	\N	\N	\N	147191	147191	314551
19322	26734	43	applied	\N	\N	\N	\N	147192	147192	314552
19322	26741	44	applied	\N	\N	\N	\N	147193	147193	314553
19322	26742	45	applied	\N	\N	\N	\N	147194	147194	314554
19322	26748	46	applied	\N	\N	\N	\N	147195	147195	314555
19322	26751	47	applied	\N	\N	\N	\N	147196	147196	314556
19322	26754	48	applied	\N	\N	\N	\N	147197	147197	314557
19322	26762	50	applied	\N	\N	\N	\N	147199	147199	314559
19322	26763	51	applied	\N	\N	\N	\N	147200	147200	314560
19322	26764	52	applied	\N	\N	\N	\N	147201	147201	314561
19322	26772	53	applied	\N	\N	\N	\N	147202	147202	314562
19322	26775	54	applied	\N	\N	\N	\N	147203	147203	314563
19322	26778	55	applied	\N	\N	\N	\N	147204	147204	314564
19322	26782	56	applied	\N	\N	\N	\N	147205	147205	314565
19322	26785	57	applied	\N	\N	\N	\N	147206	147206	314566
19322	26788	58	applied	\N	\N	\N	\N	147207	147207	314567
19322	26791	59	applied	\N	\N	\N	\N	147208	147208	314568
19322	26795	60	applied	\N	\N	\N	\N	147209	147209	314569
19322	26799	61	applied	\N	\N	\N	\N	147210	147210	314570
19322	26802	62	applied	\N	\N	\N	\N	147211	147211	314571
19322	26803	63	applied	\N	\N	\N	\N	147212	147212	314572
19322	26808	64	applied	\N	\N	\N	\N	147213	147213	314573
19322	26811	65	applied	\N	\N	\N	\N	147214	147214	314574
19322	26817	67	applied	\N	\N	\N	\N	147216	147216	314576
19322	26822	68	applied	\N	\N	\N	\N	147217	147217	314577
19322	26830	69	applied	\N	\N	\N	\N	147218	147218	314578
19322	26834	70	applied	\N	\N	\N	\N	147219	147219	314579
19322	26835	71	applied	\N	\N	\N	\N	147220	147220	314580
19322	26848	72	applied	\N	\N	\N	\N	147221	147221	314581
19322	26849	73	applied	\N	\N	\N	\N	147222	147222	314582
19322	26855	74	applied	\N	\N	\N	\N	147223	147223	314583
19322	26858	75	applied	\N	\N	\N	\N	147224	147224	314584
19322	26859	76	applied	\N	\N	\N	\N	147225	147225	314585
19322	26865	77	applied	\N	\N	\N	\N	147226	147226	314586
19322	26868	78	applied	\N	\N	\N	\N	147227	147227	314587
19322	26871	79	applied	\N	\N	\N	\N	147228	147228	314588
19322	26875	80	applied	\N	\N	\N	\N	147229	147229	314589
19322	26879	81	applied	\N	\N	\N	\N	147230	147230	314590
19322	26880	82	applied	\N	\N	\N	\N	147231	147231	314591
19322	26886	84	applied	\N	\N	\N	\N	147233	147233	314593
19322	26898	85	applied	\N	\N	\N	\N	147234	147234	314594
19322	26899	86	applied	\N	\N	\N	\N	147235	147235	314595
19322	26907	87	applied	\N	\N	\N	\N	147236	147236	314596
19322	26913	88	applied	\N	\N	\N	\N	147237	147237	314597
19322	26921	89	applied	\N	\N	\N	\N	147238	147238	314598
19322	26924	90	applied	\N	\N	\N	\N	147239	147239	314599
19322	26925	91	applied	\N	\N	\N	\N	147240	147240	314600
19322	26931	92	applied	\N	\N	\N	\N	147241	147241	314601
19322	26939	93	applied	\N	\N	\N	\N	147242	147242	314602
19322	26942	94	applied	\N	\N	\N	\N	147243	147243	314603
19322	26946	95	applied	\N	\N	\N	\N	147244	147244	314604
19322	26947	96	applied	\N	\N	\N	\N	147245	147245	314605
19322	26948	97	applied	\N	\N	\N	\N	147246	147246	314606
19322	26826	98	applied	\N	\N	\N	\N	147247	147247	314607
19322	26827	99	applied	\N	\N	\N	\N	147248	147248	314608
19322	26881	101	applied	\N	\N	\N	\N	147250	147250	314610
19322	26882	102	applied	\N	\N	\N	\N	147251	147251	314611
19322	26883	103	applied	\N	\N	\N	\N	147252	147252	314612
19322	26884	104	applied	\N	\N	\N	\N	147253	147253	314613
19322	26910	106	applied	\N	\N	\N	\N	147254	147254	314614
19322	26911	107	applied	\N	\N	\N	\N	147255	147255	314615
19322	26912	108	applied	\N	\N	\N	\N	147256	147256	314616
19322	26914	109	applied	\N	\N	\N	\N	147257	147257	314617
19322	26915	110	applied	\N	\N	\N	\N	147258	147258	314618
19322	26932	111	applied	\N	\N	\N	\N	147259	147259	314619
19322	26933	112	applied	\N	\N	\N	\N	147260	147260	314620
19322	26934	113	applied	\N	\N	\N	\N	147261	147261	314621
19349	26960	5	applied	\N	\N	\N	\N	147472	147472	314816
19349	26977	6	applied	\N	\N	\N	\N	147473	147473	314817
19349	26978	7	applied	\N	\N	\N	\N	147474	147474	314818
19349	26979	8	applied	\N	\N	\N	\N	147475	147475	314819
19349	26981	11	applied	\N	\N	\N	\N	147477	147477	314821
19349	26989	12	applied	\N	\N	\N	\N	147478	147478	314822
19349	26990	13	applied	\N	\N	\N	\N	147479	147479	314823
19349	26991	14	applied	\N	\N	\N	\N	147480	147480	314824
19349	26992	15	applied	\N	\N	\N	\N	147481	147481	314825
19349	26993	16	applied	\N	\N	\N	\N	147482	147482	314826
19349	27003	17	applied	\N	\N	\N	\N	147483	147483	314827
19349	27011	18	applied	\N	\N	\N	\N	147484	147484	147484
19349	27014	19	applied	\N	\N	\N	\N	147485	147485	147485
19349	27016	20	applied	\N	\N	\N	\N	147486	147486	147486
19349	27018	21	applied	\N	\N	\N	\N	147487	147487	147487
19351	27035	0	applied	\N	\N	\N	\N	147491	147491	314831
19351	27036	1	applied	\N	\N	\N	\N	147492	147492	314832
19351	27037	2	applied	\N	\N	\N	\N	147493	147493	314833
19322	26630	13	applied	\N	\N	\N	\N	147162	147162	314522
19322	26636	14	applied	\N	\N	\N	\N	147163	147163	314523
19322	26617	117	applied	\N	\N	\N	\N	147265	147265	314625
19322	26836	118	applied	\N	\N	\N	\N	147266	147266	314626
19322	26625	119	applied	\N	\N	\N	\N	147267	147267	314627
19322	26618	120	applied	\N	\N	\N	\N	147268	147268	314628
19322	26620	121	applied	\N	\N	\N	\N	147269	147269	314629
19322	26624	122	applied	\N	\N	\N	\N	147270	147270	314630
19322	26839	123	applied	\N	\N	1000000000	\N	147271	147271	314631
19322	26841	125	applied	\N	\N	1000000000	\N	147273	147273	314633
19325	26955	0	applied	\N	\N	\N	\N	147292	147292	314652
19325	26956	1	applied	\N	\N	\N	\N	147293	147293	314653
19325	26957	2	applied	\N	\N	\N	\N	147294	147294	314654
19325	26958	3	applied	\N	\N	\N	\N	147295	147295	314655
19325	26959	4	applied	\N	\N	\N	\N	147296	147296	314656
19325	26960	5	applied	\N	\N	\N	\N	147297	147297	314657
19325	26961	6	applied	\N	\N	\N	\N	147298	147298	314658
19325	26962	7	applied	\N	\N	\N	\N	147299	147299	314659
19325	26963	8	applied	\N	\N	\N	\N	147300	147300	314660
19332	26985	0	applied	\N	\N	\N	\N	147365	147365	314725
19332	26986	1	applied	\N	\N	\N	\N	147366	147366	314726
19332	26987	2	applied	\N	\N	\N	\N	147367	147367	314727
19332	26988	3	applied	\N	\N	\N	\N	147368	147368	314728
19337	27004	0	applied	\N	\N	\N	\N	147396	147396	314756
19337	27005	1	applied	\N	\N	\N	\N	147397	147397	314757
19337	27007	2	applied	\N	\N	\N	\N	147398	147398	314758
19340	27012	0	applied	\N	\N	\N	\N	147413	147413	314769
19340	27013	1	applied	\N	\N	\N	\N	147414	147414	314770
19340	27014	2	applied	\N	\N	\N	\N	147415	147415	147415
19340	27016	4	applied	\N	\N	\N	\N	147417	147417	147417
19340	27017	5	applied	\N	\N	\N	\N	147418	147418	314772
19340	27018	6	applied	\N	\N	\N	\N	147419	147419	147419
19340	27019	7	applied	\N	\N	\N	\N	147420	147420	314773
19340	27020	8	applied	\N	\N	\N	\N	147421	147421	314774
19340	27021	9	applied	\N	\N	\N	\N	147422	147422	314775
19342	27012	0	applied	\N	\N	\N	\N	147433	147433	314783
19342	27013	1	applied	\N	\N	\N	\N	147434	147434	314784
19342	27014	2	applied	\N	\N	\N	\N	147435	147435	147435
19342	27015	3	applied	\N	\N	\N	\N	147436	147436	314785
19342	27016	4	applied	\N	\N	\N	\N	147437	147437	147437
19342	27017	5	applied	\N	\N	\N	\N	147438	147438	314786
19342	27018	6	applied	\N	\N	\N	\N	147439	147439	147439
19342	27019	7	applied	\N	\N	\N	\N	147440	147440	314787
19342	27020	8	applied	\N	\N	\N	\N	147441	147441	314788
19342	27021	9	applied	\N	\N	\N	\N	147442	147442	314789
19344	27023	1	applied	\N	\N	\N	\N	147454	147454	314798
19344	27024	2	applied	\N	\N	\N	\N	147455	147455	314799
19347	27028	0	applied	\N	\N	\N	\N	147463	147463	314807
19347	27029	1	applied	\N	\N	\N	\N	147464	147464	314808
19347	27030	2	applied	\N	\N	\N	\N	147465	147465	314809
19347	27031	3	applied	\N	\N	\N	\N	147466	147466	314810
19350	27032	0	applied	\N	\N	\N	\N	147488	147488	314828
19350	27033	1	applied	\N	\N	\N	\N	147489	147489	314829
19350	27034	2	applied	\N	\N	\N	\N	147490	147490	314830
19357	27048	0	applied	\N	\N	\N	\N	147536	147536	314875
19357	27049	1	applied	\N	\N	\N	\N	147537	147537	314876
19357	27050	2	applied	\N	\N	\N	\N	147538	147538	314877
19357	27051	3	applied	\N	\N	\N	\N	147539	147539	314878
19357	27052	4	applied	\N	\N	\N	\N	147540	147540	314879
19357	27053	5	applied	\N	\N	\N	\N	147541	147541	314880
19357	27054	6	applied	\N	\N	\N	\N	147542	147542	314881
19357	27056	8	applied	\N	\N	1000000000	\N	147544	147544	314883
19357	27057	9	applied	\N	\N	\N	\N	147545	147545	314884
19357	27058	10	applied	\N	\N	\N	\N	147546	147546	314885
19357	27059	11	applied	\N	\N	\N	\N	147547	147547	314886
19357	27060	12	applied	\N	\N	\N	\N	147548	147548	314887
19357	27061	13	applied	\N	\N	\N	\N	147549	147549	314888
19357	27062	14	applied	\N	\N	\N	\N	147550	147550	314889
19360	27063	0	applied	\N	\N	\N	\N	147581	147581	314920
19360	27064	1	applied	\N	\N	\N	\N	147582	147582	314921
19360	27065	2	applied	\N	\N	\N	\N	147583	147583	314922
19363	27070	0	applied	\N	\N	\N	\N	147592	147592	314931
19363	27071	1	applied	\N	\N	\N	\N	147593	147593	314932
19363	27072	2	applied	\N	\N	\N	\N	147594	147594	314933
19363	27073	3	applied	\N	\N	\N	\N	147595	147595	314934
19363	27074	4	applied	\N	\N	\N	\N	147596	147596	314935
19370	27088	0	applied	\N	\N	\N	\N	147623	147623	314962
19370	27090	2	applied	\N	\N	\N	\N	147625	147625	314964
19370	27091	3	applied	\N	\N	\N	\N	147626	147626	147626
19370	27092	4	applied	\N	\N	\N	\N	147627	147627	314965
19373	27093	0	applied	\N	\N	\N	\N	147636	147636	314973
19373	27094	1	applied	\N	\N	\N	\N	147637	147637	314974
19373	27095	2	applied	\N	\N	\N	\N	147638	147638	314975
19375	27096	0	applied	\N	\N	\N	\N	147642	147642	314979
19375	27097	1	applied	\N	\N	\N	\N	147643	147643	314980
19375	27098	2	applied	\N	\N	\N	\N	147644	147644	314981
19378	27096	0	applied	\N	\N	\N	\N	147651	147651	314988
19378	27097	1	applied	\N	\N	\N	\N	147652	147652	314989
19378	27098	2	applied	\N	\N	\N	\N	147653	147653	314990
19382	27099	0	applied	\N	\N	\N	\N	147663	147663	315000
19382	27100	1	applied	\N	\N	\N	\N	147664	147664	315001
19385	27101	0	applied	\N	\N	\N	\N	147673	147673	315010
19385	27102	1	applied	\N	\N	\N	\N	147674	147674	315011
19385	27104	3	applied	\N	\N	\N	\N	147676	147676	315013
19392	27127	0	applied	\N	\N	\N	\N	147714	147714	315051
19392	27128	1	applied	\N	\N	\N	\N	147715	147715	315052
19397	27133	0	applied	\N	\N	\N	\N	147726	147726	315063
19397	27134	1	applied	\N	\N	\N	\N	147727	147727	315064
19397	27135	2	applied	\N	\N	\N	\N	147728	147728	315065
19397	27136	3	applied	\N	\N	\N	\N	147729	147729	315066
19403	27141	0	applied	\N	\N	\N	\N	147747	147747	315084
19403	27142	1	applied	\N	\N	\N	\N	147748	147748	315085
19407	27148	0	applied	\N	\N	\N	\N	147761	147761	315098
19407	27149	1	applied	\N	\N	\N	\N	147762	147762	315099
19407	27150	2	applied	\N	\N	\N	\N	147763	147763	315100
19407	27151	3	applied	\N	\N	\N	\N	147764	147764	315101
19409	27152	0	applied	\N	\N	\N	\N	147890	147890	315217
19409	27153	1	applied	\N	\N	\N	\N	147891	147891	315218
19409	27154	2	applied	\N	\N	\N	\N	147892	147892	315219
19415	27169	1	applied	\N	\N	\N	\N	147913	147913	315240
19415	27170	2	applied	\N	\N	\N	\N	147914	147914	315241
19322	26936	115	applied	\N	\N	\N	\N	147263	147263	314623
19322	26887	116	applied	\N	\N	\N	\N	147264	147264	314624
19355	27061	13	applied	\N	\N	\N	\N	147523	147523	314863
19355	27062	14	applied	\N	\N	\N	\N	147524	147524	314864
19359	27048	0	applied	\N	\N	\N	\N	147566	147566	314905
19359	27050	2	applied	\N	\N	\N	\N	147568	147568	314907
19359	27051	3	applied	\N	\N	\N	\N	147569	147569	314908
19359	27052	4	applied	\N	\N	\N	\N	147570	147570	314909
19359	27053	5	applied	\N	\N	\N	\N	147571	147571	314910
19359	27054	6	applied	\N	\N	\N	\N	147572	147572	314911
19359	27055	7	applied	\N	\N	\N	\N	147573	147573	314912
19359	27056	8	applied	\N	\N	1000000000	\N	147574	147574	314913
19359	27057	9	applied	\N	\N	\N	\N	147575	147575	314914
19359	27058	10	applied	\N	\N	\N	\N	147576	147576	314915
19359	27059	11	applied	\N	\N	\N	\N	147577	147577	314916
19359	27060	12	applied	\N	\N	\N	\N	147578	147578	314917
19359	27061	13	applied	\N	\N	\N	\N	147579	147579	314918
19359	27062	14	applied	\N	\N	\N	\N	147580	147580	314919
19364	27075	0	applied	\N	\N	\N	\N	147597	147597	314936
19364	27076	1	applied	\N	\N	\N	\N	147598	147598	314937
19364	27077	2	applied	\N	\N	\N	\N	147599	147599	314938
19369	27086	1	applied	\N	\N	\N	\N	147621	147621	314960
19369	27087	2	applied	\N	\N	\N	\N	147622	147622	314961
19379	27051	0	applied	\N	\N	\N	\N	147654	147654	314991
19379	27052	1	applied	\N	\N	\N	\N	147655	147655	314992
19379	27053	2	applied	\N	\N	\N	\N	147656	147656	314993
19379	27054	3	applied	\N	\N	\N	\N	147657	147657	314994
19379	27056	4	applied	\N	\N	1000000000	\N	147658	147658	314995
19381	27099	0	applied	\N	\N	\N	\N	147661	147661	314998
19381	27100	1	applied	\N	\N	\N	\N	147662	147662	314999
19383	27101	0	applied	\N	\N	\N	\N	147665	147665	315002
19383	27102	1	applied	\N	\N	\N	\N	147666	147666	315003
19383	27103	2	applied	\N	\N	\N	\N	147667	147667	315004
19383	27104	3	applied	\N	\N	\N	\N	147668	147668	315005
19389	27122	0	applied	\N	\N	\N	\N	147699	147699	315036
19389	27124	2	applied	\N	\N	\N	\N	147701	147701	315038
19389	27125	3	applied	\N	\N	\N	\N	147702	147702	315039
19389	27126	4	applied	\N	\N	\N	\N	147703	147703	315040
19395	27129	0	applied	\N	\N	\N	\N	147718	147718	315055
19395	27130	1	applied	\N	\N	\N	\N	147719	147719	315056
19395	27131	2	applied	\N	\N	\N	\N	147720	147720	315057
19395	27132	3	applied	\N	\N	\N	\N	147721	147721	315058
19406	27145	0	applied	\N	\N	\N	\N	147758	147758	315095
19406	27147	1	applied	\N	\N	\N	\N	147759	147759	315096
19406	27146	2	applied	\N	\N	\N	\N	147760	147760	315097
19408	26588	0	applied	\N	\N	\N	\N	147765	147765	147765
19408	26595	1	applied	\N	\N	\N	\N	147766	147766	147766
19408	26798	2	applied	\N	\N	\N	\N	147767	147767	315102
19408	26363	3	applied	\N	\N	1000000000	\N	147768	147768	315103
19408	26354	4	applied	\N	\N	\N	\N	147769	147769	315104
19408	26708	5	applied	\N	\N	1000000000	\N	147770	147770	315105
19408	26364	6	applied	\N	\N	\N	\N	147771	147771	315106
19408	26355	7	applied	\N	\N	\N	\N	147772	147772	315107
19408	26815	8	applied	\N	\N	\N	\N	147773	147773	315108
19408	26723	9	applied	\N	\N	\N	\N	147774	147774	315109
19408	26362	11	applied	\N	\N	\N	\N	147776	147776	315111
19408	26365	12	applied	\N	\N	\N	\N	147777	147777	315112
19408	26366	13	applied	\N	\N	\N	\N	147778	147778	315113
19408	26367	14	applied	\N	\N	\N	\N	147779	147779	315114
19408	26560	15	applied	\N	\N	\N	\N	147780	147780	315115
19408	26561	16	applied	\N	\N	\N	\N	147781	147781	315116
19408	26562	17	applied	\N	\N	\N	\N	147782	147782	315117
19408	26738	18	applied	\N	\N	1000000000	\N	147783	147783	315118
19408	26823	19	applied	\N	\N	\N	\N	147784	147784	315119
19408	26824	20	applied	\N	\N	\N	\N	147785	147785	315120
19408	26370	21	applied	\N	\N	\N	\N	147786	147786	315121
19408	26371	22	applied	\N	\N	\N	\N	147787	147787	315122
19408	26376	23	applied	\N	\N	\N	\N	147788	147788	315123
19408	26379	24	applied	\N	\N	\N	\N	147789	147789	315124
19408	26382	25	applied	\N	\N	\N	\N	147790	147790	315125
19408	26385	26	applied	\N	\N	\N	\N	147791	147791	315126
19408	26393	28	applied	\N	\N	\N	\N	147793	147793	315128
19408	26394	29	applied	\N	\N	\N	\N	147794	147794	315129
19408	26398	30	applied	\N	\N	\N	\N	147795	147795	315130
19408	26565	31	applied	\N	\N	\N	\N	147796	147796	315131
19408	26584	32	applied	\N	\N	\N	\N	147797	147797	315132
19408	26825	33	applied	\N	\N	\N	\N	147798	147798	315133
19408	26357	34	applied	\N	\N	\N	\N	147799	147799	147799
19408	27051	35	applied	\N	\N	\N	\N	147800	147800	315134
19408	27052	36	applied	\N	\N	\N	\N	147801	147801	315135
19408	27053	37	applied	\N	\N	\N	\N	147802	147802	315136
19408	27054	38	applied	\N	\N	\N	\N	147803	147803	315137
19408	26400	39	applied	\N	\N	\N	\N	147804	147804	315138
19408	26405	40	applied	\N	\N	\N	\N	147805	147805	315139
19408	26406	41	applied	\N	\N	\N	\N	147806	147806	315140
19408	26411	42	applied	\N	\N	\N	\N	147807	147807	315141
19408	26415	43	applied	\N	\N	\N	\N	147808	147808	315142
19408	26420	45	applied	\N	\N	\N	\N	147810	147810	315144
19408	26421	46	applied	\N	\N	\N	\N	147811	147811	315145
19408	26422	47	applied	\N	\N	\N	\N	147812	147812	315146
19408	26426	48	applied	\N	\N	\N	\N	147813	147813	315147
19408	26428	49	applied	\N	\N	\N	\N	147814	147814	315148
19408	26429	50	applied	\N	\N	\N	\N	147815	147815	315149
19408	26432	51	applied	\N	\N	\N	\N	147816	147816	315150
19417	27171	0	applied	\N	\N	\N	\N	147919	147919	315246
19417	27172	1	applied	\N	\N	\N	\N	147920	147920	315247
19417	27173	2	applied	\N	\N	\N	\N	147921	147921	315248
19417	27174	3	applied	\N	\N	\N	\N	147922	147922	315249
19421	27178	0	applied	\N	\N	\N	\N	147936	147936	315261
19421	27179	1	applied	\N	\N	\N	\N	147937	147937	315262
19421	27180	2	applied	\N	\N	\N	\N	147938	147938	315263
19421	27181	3	applied	\N	\N	\N	\N	147939	147939	315264
19421	27182	4	applied	\N	\N	\N	\N	147940	147940	315265
19421	27184	6	applied	\N	\N	\N	\N	147942	147942	315267
19425	27191	0	applied	\N	\N	\N	\N	147959	147959	315284
19425	27192	1	applied	\N	\N	\N	\N	147960	147960	315285
19425	27193	2	applied	\N	\N	\N	\N	147961	147961	315286
19425	27194	3	applied	\N	\N	\N	\N	147962	147962	315287
19430	27202	0	applied	\N	\N	1000000000	\N	147977	147977	315302
19430	27203	1	applied	\N	\N	\N	\N	147978	147978	315303
19430	27204	2	applied	\N	\N	\N	\N	147979	147979	315304
19355	27059	11	applied	\N	\N	\N	\N	147521	147521	314861
19355	27060	12	applied	\N	\N	\N	\N	147522	147522	314862
19356	26896	9	applied	\N	\N	\N	\N	147534	147534	147534
19356	27003	10	applied	\N	\N	\N	\N	147535	147535	314874
19362	27066	0	applied	\N	\N	\N	\N	147588	147588	314927
19362	27067	1	applied	\N	\N	\N	\N	147589	147589	314928
19362	27068	2	applied	\N	\N	\N	\N	147590	147590	314929
19362	27069	3	applied	\N	\N	\N	\N	147591	147591	314930
19365	27075	0	applied	\N	\N	\N	\N	147600	147600	314939
19365	27077	2	applied	\N	\N	\N	\N	147602	147602	314941
19367	27078	0	applied	\N	\N	\N	\N	147606	147606	314945
19367	27079	1	applied	\N	\N	\N	\N	147607	147607	314946
19367	27080	2	applied	\N	\N	\N	\N	147608	147608	314947
19367	27081	3	applied	\N	\N	\N	\N	147609	147609	314948
19367	27082	4	applied	\N	\N	\N	\N	147610	147610	314949
19367	27083	5	applied	\N	\N	\N	\N	147611	147611	314950
19367	27084	6	applied	\N	\N	\N	\N	147612	147612	314951
19372	27093	0	applied	\N	\N	\N	\N	147633	147633	314970
19372	27094	1	applied	\N	\N	\N	\N	147634	147634	314971
19372	27095	2	applied	\N	\N	\N	\N	147635	147635	314972
19374	27096	0	applied	\N	\N	\N	\N	147639	147639	314976
19374	27097	1	applied	\N	\N	\N	\N	147640	147640	314977
19374	27098	2	applied	\N	\N	\N	\N	147641	147641	314978
19377	27096	0	applied	\N	\N	\N	\N	147648	147648	314985
19377	27097	1	applied	\N	\N	\N	\N	147649	147649	314986
19380	27096	0	applied	\N	\N	\N	\N	147659	147659	314996
19380	27097	1	applied	\N	\N	\N	\N	147660	147660	314997
19384	27101	0	applied	\N	\N	\N	\N	147669	147669	315006
19384	27102	1	applied	\N	\N	\N	\N	147670	147670	315007
19384	27103	2	applied	\N	\N	\N	\N	147671	147671	315008
19384	27104	3	applied	\N	\N	\N	\N	147672	147672	315009
19386	27105	0	applied	\N	\N	\N	\N	147677	147677	315014
19386	27106	1	applied	\N	\N	\N	\N	147678	147678	315015
19386	27107	2	applied	\N	\N	\N	\N	147679	147679	315016
19387	27108	0	applied	\N	\N	\N	\N	147680	147680	315017
19387	27109	1	applied	\N	\N	\N	\N	147681	147681	315018
19387	27110	2	applied	\N	\N	\N	\N	147682	147682	315019
19387	27111	3	applied	\N	\N	\N	\N	147683	147683	315020
19387	27112	4	applied	\N	\N	1000000000	\N	147684	147684	315021
19387	27113	5	applied	\N	\N	\N	\N	147685	147685	315022
19387	27114	6	applied	\N	\N	\N	\N	147686	147686	315023
19387	27116	8	applied	\N	\N	\N	\N	147688	147688	315025
19387	27117	9	applied	\N	\N	\N	\N	147689	147689	315026
19387	27118	10	applied	\N	\N	\N	\N	147690	147690	315027
19387	27119	11	applied	\N	\N	\N	\N	147691	147691	315028
19387	27120	12	applied	\N	\N	\N	\N	147692	147692	315029
19387	27121	13	applied	\N	\N	\N	\N	147693	147693	315030
19390	27122	0	applied	\N	\N	\N	\N	147704	147704	315041
19390	27123	1	applied	\N	\N	1000000000	\N	147705	147705	315042
19390	27124	2	applied	\N	\N	\N	\N	147706	147706	315043
19390	27125	3	applied	\N	\N	\N	\N	147707	147707	315044
19390	27126	4	applied	\N	\N	\N	\N	147708	147708	315045
19396	27133	0	applied	\N	\N	\N	\N	147722	147722	315059
19396	27134	1	applied	\N	\N	\N	\N	147723	147723	315060
19396	27135	2	applied	\N	\N	\N	\N	147724	147724	315061
19396	27136	3	applied	\N	\N	\N	\N	147725	147725	315062
19399	27133	0	applied	\N	\N	\N	\N	147734	147734	315071
19399	27135	2	applied	\N	\N	\N	\N	147736	147736	315073
19399	27136	3	applied	\N	\N	\N	\N	147737	147737	315074
19400	27137	0	applied	\N	\N	\N	\N	147738	147738	315075
19400	27138	1	applied	\N	\N	\N	\N	147739	147739	315076
19400	27139	2	applied	\N	\N	\N	\N	147740	147740	315077
19400	27140	3	applied	\N	\N	\N	\N	147741	147741	315078
19402	27141	0	applied	\N	\N	\N	\N	147743	147743	315080
19402	27142	1	applied	\N	\N	\N	\N	147744	147744	315081
19402	27143	2	applied	\N	\N	\N	\N	147745	147745	315082
19402	27144	3	applied	\N	\N	\N	\N	147746	147746	315083
19408	26434	52	applied	\N	\N	\N	\N	147817	147817	315151
19408	26440	53	applied	\N	\N	\N	\N	147818	147818	315152
19408	26441	54	applied	\N	\N	\N	\N	147819	147819	315153
19408	26442	55	applied	\N	\N	\N	\N	147820	147820	315154
19408	26443	56	applied	\N	\N	\N	\N	147821	147821	315155
19408	26448	57	applied	\N	\N	\N	\N	147822	147822	315156
19408	26450	59	applied	\N	\N	\N	\N	147824	147824	315158
19408	26458	60	applied	\N	\N	\N	\N	147825	147825	315159
19408	26461	61	applied	\N	\N	\N	\N	147826	147826	315160
19408	26464	62	applied	\N	\N	\N	\N	147827	147827	315161
19408	26358	63	applied	\N	\N	\N	\N	147828	147828	147828
19408	26359	64	applied	\N	\N	\N	\N	147829	147829	147829
19408	26368	65	applied	\N	\N	\N	\N	147830	147830	147830
19408	26397	66	applied	\N	\N	\N	\N	147831	147831	147831
19408	26399	67	applied	\N	\N	\N	\N	147832	147832	147832
19408	26468	68	applied	\N	\N	\N	\N	147833	147833	315162
19408	26471	69	applied	\N	\N	\N	\N	147834	147834	315163
19411	27155	0	applied	\N	\N	\N	\N	147896	147896	315223
19411	27156	1	applied	\N	\N	\N	\N	147897	147897	315224
19411	27157	2	applied	\N	\N	\N	\N	147898	147898	315225
19411	27158	3	applied	\N	\N	\N	\N	147899	147899	315226
19411	27159	4	applied	\N	\N	\N	\N	147900	147900	315227
19411	27161	6	applied	\N	\N	\N	\N	147902	147902	315229
19414	27168	0	applied	\N	\N	\N	\N	147909	147909	315236
19414	27169	1	applied	\N	\N	\N	\N	147910	147910	315237
19414	27170	2	applied	\N	\N	\N	\N	147911	147911	315238
19416	27171	0	applied	\N	\N	\N	\N	147915	147915	315242
19416	27172	1	applied	\N	\N	\N	\N	147916	147916	315243
19416	27173	2	applied	\N	\N	\N	\N	147917	147917	315244
19416	27174	3	applied	\N	\N	\N	\N	147918	147918	315245
19419	26588	0	applied	\N	\N	\N	\N	147926	147926	147926
19419	26595	1	applied	\N	\N	\N	\N	147927	147927	147927
19419	26798	2	applied	\N	\N	\N	\N	147928	147928	315253
19420	27178	0	applied	\N	\N	\N	\N	147929	147929	315254
19420	27179	1	applied	\N	\N	\N	\N	147930	147930	315255
19420	27180	2	applied	\N	\N	\N	\N	147931	147931	315256
19420	27181	3	applied	\N	\N	\N	\N	147932	147932	315257
19420	27182	4	applied	\N	\N	\N	\N	147933	147933	315258
19420	27184	6	applied	\N	\N	\N	\N	147935	147935	315260
19427	27195	0	applied	\N	\N	\N	\N	147967	147967	315292
19427	27196	1	applied	\N	\N	1000000000	\N	147968	147968	315293
19427	27197	2	applied	\N	\N	\N	\N	147969	147969	315294
19427	27198	3	applied	\N	\N	\N	\N	147970	147970	315295
19437	27223	0	applied	\N	\N	\N	\N	148012	148012	315337
19356	26918	7	applied	\N	\N	1000000000	\N	147532	147532	314872
19356	27056	8	applied	\N	\N	1000000000	\N	147533	147533	314873
19358	27051	3	applied	\N	\N	\N	\N	147554	147554	314893
19358	27052	4	applied	\N	\N	\N	\N	147555	147555	314894
19358	27053	5	applied	\N	\N	\N	\N	147556	147556	314895
19358	27054	6	applied	\N	\N	\N	\N	147557	147557	314896
19358	27055	7	applied	\N	\N	\N	\N	147558	147558	314897
19358	27057	9	applied	\N	\N	\N	\N	147560	147560	314899
19358	27058	10	applied	\N	\N	\N	\N	147561	147561	314900
19358	27059	11	applied	\N	\N	\N	\N	147562	147562	314901
19358	27060	12	applied	\N	\N	\N	\N	147563	147563	314902
19358	27061	13	applied	\N	\N	\N	\N	147564	147564	314903
19358	27062	14	applied	\N	\N	\N	\N	147565	147565	314904
19361	27066	0	applied	\N	\N	\N	\N	147584	147584	314923
19361	27067	1	applied	\N	\N	\N	\N	147585	147585	314924
19361	27068	2	applied	\N	\N	\N	\N	147586	147586	314925
19361	27069	3	applied	\N	\N	\N	\N	147587	147587	314926
19366	27075	0	applied	\N	\N	\N	\N	147603	147603	314942
19366	27076	1	applied	\N	\N	\N	\N	147604	147604	314943
19366	27077	2	applied	\N	\N	\N	\N	147605	147605	314944
19368	27078	0	applied	\N	\N	\N	\N	147613	147613	314952
19368	27079	1	applied	\N	\N	\N	\N	147614	147614	314953
19368	27080	2	applied	\N	\N	\N	\N	147615	147615	314954
19368	27081	3	applied	\N	\N	\N	\N	147616	147616	314955
19368	27082	4	applied	\N	\N	\N	\N	147617	147617	314956
19368	27084	6	applied	\N	\N	\N	\N	147619	147619	314958
19371	27088	0	applied	\N	\N	\N	\N	147628	147628	314966
19371	27089	1	applied	\N	\N	\N	\N	147629	147629	314967
19371	27090	2	applied	\N	\N	\N	\N	147630	147630	314968
19371	27091	3	applied	\N	\N	\N	\N	147631	147631	147631
19371	27092	4	applied	\N	\N	\N	\N	147632	147632	314969
19376	27096	0	applied	\N	\N	\N	\N	147645	147645	314982
19376	27097	1	applied	\N	\N	\N	\N	147646	147646	314983
19376	27098	2	applied	\N	\N	\N	\N	147647	147647	314984
19388	27122	0	applied	\N	\N	\N	\N	147694	147694	315031
19388	27123	1	applied	\N	\N	1000000000	\N	147695	147695	315032
19388	27124	2	applied	\N	\N	\N	\N	147696	147696	315033
19388	27125	3	applied	\N	\N	\N	\N	147697	147697	315034
19388	27126	4	applied	\N	\N	\N	\N	147698	147698	315035
19391	27122	0	applied	\N	\N	\N	\N	147709	147709	315046
19391	27124	2	applied	\N	\N	\N	\N	147711	147711	315048
19391	27125	3	applied	\N	\N	\N	\N	147712	147712	315049
19391	27126	4	applied	\N	\N	\N	\N	147713	147713	315050
19393	27127	0	applied	\N	\N	\N	\N	147716	147716	315053
19393	27128	1	applied	\N	\N	\N	\N	147717	147717	315054
19398	27133	0	applied	\N	\N	\N	\N	147730	147730	315067
19398	27134	1	applied	\N	\N	\N	\N	147731	147731	315068
19398	27135	2	applied	\N	\N	\N	\N	147732	147732	315069
19398	27136	3	applied	\N	\N	\N	\N	147733	147733	315070
19401	27112	0	applied	\N	\N	1000000000	\N	147742	147742	315079
19404	27141	0	applied	\N	\N	\N	\N	147749	147749	315086
19404	27142	1	applied	\N	\N	\N	\N	147750	147750	315087
19404	27143	2	applied	\N	\N	\N	\N	147751	147751	315088
19404	27144	3	applied	\N	\N	\N	\N	147752	147752	315089
19405	27145	0	applied	\N	\N	\N	\N	147753	147753	315090
19405	27143	1	applied	\N	\N	\N	\N	147754	147754	315091
19405	27146	2	applied	\N	\N	\N	\N	147755	147755	315092
19405	27144	3	applied	\N	\N	\N	\N	147756	147756	315093
19405	27147	4	applied	\N	\N	\N	\N	147757	147757	315094
19422	27181	1	applied	\N	\N	\N	\N	147944	147944	315269
19422	27184	2	applied	\N	\N	\N	\N	147945	147945	315270
19426	27191	0	applied	\N	\N	\N	\N	147963	147963	315288
19426	27192	1	applied	\N	\N	\N	\N	147964	147964	315289
19426	27193	2	applied	\N	\N	\N	\N	147965	147965	315290
19426	27194	3	applied	\N	\N	\N	\N	147966	147966	315291
19428	27199	0	applied	\N	\N	\N	\N	147971	147971	315296
19428	27200	1	applied	\N	\N	\N	\N	147972	147972	315297
19428	27201	2	applied	\N	\N	\N	\N	147973	147973	315298
19431	27212	0	applied	\N	\N	\N	\N	147987	147987	315312
19431	27213	1	applied	\N	\N	\N	\N	147988	147988	315313
19431	27214	2	applied	\N	\N	\N	\N	147989	147989	315314
19437	27224	1	applied	\N	\N	\N	\N	148013	148013	315338
19437	27225	2	applied	\N	\N	\N	\N	148014	148014	315339
19439	27226	0	applied	\N	\N	\N	\N	148015	148015	315340
19439	27227	1	applied	\N	\N	\N	\N	148016	148016	315341
19439	27229	3	applied	\N	\N	\N	\N	148018	148018	315343
19439	27230	4	applied	\N	\N	\N	\N	148019	148019	315344
19439	27231	5	applied	\N	\N	\N	\N	148020	148020	315345
19439	27232	6	applied	\N	\N	\N	\N	148021	148021	315346
19439	27233	7	applied	\N	\N	\N	\N	148022	148022	315347
19439	27234	8	applied	\N	\N	1000000000	\N	148023	148023	315348
19439	27235	9	applied	\N	\N	\N	\N	148024	148024	315349
19439	27236	10	applied	\N	\N	\N	\N	148025	148025	315350
19439	27237	11	applied	\N	\N	\N	\N	148026	148026	315351
19439	27238	12	applied	\N	\N	\N	\N	148027	148027	315352
19439	27239	13	applied	\N	\N	\N	\N	148028	148028	315353
19439	27240	14	applied	\N	\N	\N	\N	148029	148029	315354
19439	27241	15	applied	\N	\N	\N	\N	148030	148030	315355
19439	27242	16	applied	\N	\N	\N	\N	148031	148031	315356
19439	27243	17	applied	\N	\N	\N	\N	148032	148032	315357
19441	27244	0	applied	\N	\N	\N	\N	148051	148051	315376
19441	27246	2	applied	\N	\N	\N	\N	148053	148053	315378
19441	27247	3	applied	\N	\N	\N	\N	148054	148054	315379
19446	27255	0	applied	\N	\N	\N	\N	148062	148062	315387
19446	27256	1	applied	\N	\N	\N	\N	148063	148063	315388
19446	27257	2	applied	\N	\N	\N	\N	148064	148064	315389
19454	27272	0	applied	\N	\N	\N	\N	148110	148110	315435
19454	27273	1	applied	\N	\N	\N	\N	148111	148111	315436
19454	27274	2	applied	\N	\N	\N	\N	148112	148112	315437
19462	27295	0	applied	\N	\N	\N	\N	148141	148141	315466
19462	27296	1	applied	\N	\N	\N	\N	148142	148142	315467
19464	27297	0	applied	\N	\N	\N	\N	148145	148145	315470
19464	27298	1	applied	\N	\N	\N	\N	148146	148146	315471
19464	27299	2	applied	\N	\N	\N	\N	148147	148147	315472
19464	27300	3	applied	\N	\N	\N	\N	148148	148148	315473
19467	27304	0	applied	\N	\N	\N	\N	148156	148156	315481
19467	27305	1	applied	\N	\N	\N	\N	148157	148157	315482
19467	27307	3	applied	\N	\N	1000000000	\N	148159	148159	315484
19467	27308	4	applied	\N	\N	\N	\N	148160	148160	315485
19467	27309	5	applied	\N	\N	\N	\N	148161	148161	315486
19467	27310	6	applied	\N	\N	\N	\N	148162	148162	315487
19358	27049	1	applied	\N	\N	\N	\N	147552	147552	314891
19358	27050	2	applied	\N	\N	\N	\N	147553	147553	314892
19408	26487	74	applied	\N	\N	\N	\N	147839	147839	315168
19408	26491	75	applied	\N	\N	\N	\N	147840	147840	315169
19408	26492	76	applied	\N	\N	\N	\N	147841	147841	315170
19408	26493	77	applied	\N	\N	\N	\N	147842	147842	315171
19408	26494	78	applied	\N	\N	\N	\N	147843	147843	315172
19408	26495	79	applied	\N	\N	\N	\N	147844	147844	315173
19408	26407	80	applied	\N	\N	\N	\N	147845	147845	147845
19408	26414	81	applied	\N	\N	\N	\N	147846	147846	147846
19408	26510	82	applied	\N	\N	\N	\N	147847	147847	315174
19408	26514	83	applied	\N	\N	\N	\N	147848	147848	315175
19408	26518	84	applied	\N	\N	\N	\N	147849	147849	315176
19408	26521	85	applied	\N	\N	\N	\N	147850	147850	315177
19408	26525	86	applied	\N	\N	\N	\N	147851	147851	315178
19408	26526	87	applied	\N	\N	\N	\N	147852	147852	315179
19408	26533	88	applied	\N	\N	\N	\N	147853	147853	315180
19408	26536	89	applied	\N	\N	\N	\N	147854	147854	315181
19408	26543	91	applied	\N	\N	\N	\N	147856	147856	315183
19408	26544	92	applied	\N	\N	\N	\N	147857	147857	315184
19408	26550	93	applied	\N	\N	\N	\N	147858	147858	315185
19408	26553	94	applied	\N	\N	\N	\N	147859	147859	315186
19408	26556	95	applied	\N	\N	\N	\N	147860	147860	315187
19408	26559	96	applied	\N	\N	\N	\N	147861	147861	315188
19408	26563	97	applied	\N	\N	\N	\N	147862	147862	315189
19408	26564	99	applied	\N	\N	\N	\N	147863	147863	315190
19408	26573	100	applied	\N	\N	\N	\N	147864	147864	315191
19408	26577	101	applied	\N	\N	\N	\N	147865	147865	315192
19408	26580	102	applied	\N	\N	\N	\N	147866	147866	315193
19408	26583	103	applied	\N	\N	\N	\N	147867	147867	315194
19408	26589	104	applied	\N	\N	\N	\N	147868	147868	315195
19408	26592	105	applied	\N	\N	\N	\N	147869	147869	315196
19408	26596	106	applied	\N	\N	\N	\N	147870	147870	315197
19408	26597	107	applied	\N	\N	\N	\N	147871	147871	315198
19408	26606	109	applied	\N	\N	\N	\N	147873	147873	315200
19408	26609	110	applied	\N	\N	\N	\N	147874	147874	315201
19408	26610	111	applied	\N	\N	\N	\N	147875	147875	315202
19408	26616	112	applied	\N	\N	\N	\N	147876	147876	315203
19408	26619	113	applied	\N	\N	\N	\N	147877	147877	315204
19408	26622	114	applied	\N	\N	\N	\N	147878	147878	315205
19408	26623	115	applied	\N	\N	\N	\N	147879	147879	315206
19408	26629	116	applied	\N	\N	\N	\N	147880	147880	315207
19408	26630	117	applied	\N	\N	\N	\N	147881	147881	315208
19408	26636	118	applied	\N	\N	\N	\N	147882	147882	315209
19408	26637	119	applied	\N	\N	\N	\N	147883	147883	315210
19408	26642	120	applied	\N	\N	\N	\N	147884	147884	315211
19408	26643	121	applied	\N	\N	\N	\N	147885	147885	315212
19408	26644	122	applied	\N	\N	\N	\N	147886	147886	315213
19408	26645	123	applied	\N	\N	\N	\N	147887	147887	315214
19408	26646	124	applied	\N	\N	\N	\N	147888	147888	315215
19410	27152	0	applied	\N	\N	\N	\N	147893	147893	315220
19410	27153	1	applied	\N	\N	\N	\N	147894	147894	315221
19410	27154	2	applied	\N	\N	\N	\N	147895	147895	315222
19413	27162	0	applied	\N	\N	\N	\N	147903	147903	315230
19413	27163	1	applied	\N	\N	\N	\N	147904	147904	315231
19413	27164	2	applied	\N	\N	\N	\N	147905	147905	315232
19413	27165	3	applied	\N	\N	\N	\N	147906	147906	315233
19413	27166	4	applied	\N	\N	\N	\N	147907	147907	315234
19413	27167	5	applied	\N	\N	\N	\N	147908	147908	315235
19418	27175	0	applied	\N	\N	\N	\N	147923	147923	315250
19418	27176	1	applied	\N	\N	\N	\N	147924	147924	315251
19418	27177	2	applied	\N	\N	\N	\N	147925	147925	315252
19423	27178	0	applied	\N	\N	\N	\N	147946	147946	315271
19423	27179	1	applied	\N	\N	\N	\N	147947	147947	315272
19423	27180	2	applied	\N	\N	\N	\N	147948	147948	315273
19423	27181	3	applied	\N	\N	\N	\N	147949	147949	315274
19423	27183	5	applied	\N	\N	\N	\N	147951	147951	315276
19423	27184	6	applied	\N	\N	\N	\N	147952	147952	315277
19424	27185	0	applied	\N	\N	\N	\N	147953	147953	315278
19424	27186	1	applied	\N	\N	\N	\N	147954	147954	315279
19424	27187	2	applied	\N	\N	\N	\N	147955	147955	315280
19424	27188	3	applied	\N	\N	\N	\N	147956	147956	315281
19424	27189	4	applied	\N	\N	\N	\N	147957	147957	315282
19424	27190	5	applied	\N	\N	\N	\N	147958	147958	315283
19429	27199	0	applied	\N	\N	\N	\N	147974	147974	315299
19429	27200	1	applied	\N	\N	\N	\N	147975	147975	315300
19429	27201	2	applied	\N	\N	\N	\N	147976	147976	315301
19432	27212	0	applied	\N	\N	\N	\N	147990	147990	315315
19432	27213	1	applied	\N	\N	\N	\N	147991	147991	315316
19432	27214	2	applied	\N	\N	\N	\N	147992	147992	315317
19435	27215	0	applied	\N	\N	\N	\N	148001	148001	315326
19435	27216	1	applied	\N	\N	\N	\N	148002	148002	315327
19435	27218	3	applied	\N	\N	\N	\N	148004	148004	315329
19435	27219	4	applied	\N	\N	\N	\N	148005	148005	315330
19435	27220	5	applied	\N	\N	\N	\N	148006	148006	315331
19435	27221	6	applied	\N	\N	\N	\N	148007	148007	315332
19435	27222	7	applied	\N	\N	\N	\N	148008	148008	315333
19436	27223	0	applied	\N	\N	\N	\N	148009	148009	315334
19436	27224	1	applied	\N	\N	\N	\N	148010	148010	315335
19436	27225	2	applied	\N	\N	\N	\N	148011	148011	315336
19440	27226	0	applied	\N	\N	\N	\N	148033	148033	315358
19440	27227	1	applied	\N	\N	\N	\N	148034	148034	315359
19440	27228	2	applied	\N	\N	\N	\N	148035	148035	315360
19440	27229	3	applied	\N	\N	\N	\N	148036	148036	315361
19440	27230	4	applied	\N	\N	\N	\N	148037	148037	315362
19446	27258	3	applied	\N	\N	\N	\N	148065	148065	315390
19446	27259	4	applied	\N	\N	\N	\N	148066	148066	315391
19451	27262	0	applied	\N	\N	\N	\N	148093	148093	315418
19453	27265	0	applied	\N	\N	\N	\N	148100	148100	315425
19453	27266	1	applied	\N	\N	\N	\N	148101	148101	315426
19453	27260	2	applied	\N	\N	\N	\N	148102	148102	315427
19453	27261	3	applied	\N	\N	\N	\N	148103	148103	315428
19453	27264	4	applied	\N	\N	\N	\N	148104	148104	315429
19453	27267	5	applied	\N	\N	\N	\N	148105	148105	315430
19453	27268	6	applied	\N	\N	\N	\N	148106	148106	315431
19453	27269	7	applied	\N	\N	\N	\N	148107	148107	315432
19453	27270	8	applied	\N	\N	\N	\N	148108	148108	315433
19453	27271	9	applied	\N	\N	\N	\N	148109	148109	315434
19456	27275	0	applied	\N	\N	\N	\N	148116	148116	315441
19456	27276	1	applied	\N	\N	\N	\N	148117	148117	315442
19456	27277	2	applied	\N	\N	\N	\N	148118	148118	315443
19461	27292	0	applied	\N	\N	\N	\N	148138	148138	315463
19408	26478	71	applied	\N	\N	\N	\N	147836	147836	315165
19408	26481	72	applied	\N	\N	\N	\N	147837	147837	315166
19430	27208	6	applied	\N	\N	\N	\N	147983	147983	315308
19430	27209	7	applied	\N	\N	\N	\N	147984	147984	315309
19430	27210	8	applied	\N	\N	\N	\N	147985	147985	315310
19430	27211	9	applied	\N	\N	\N	\N	147986	147986	315311
19433	27215	0	applied	\N	\N	\N	\N	147993	147993	315318
19433	27216	1	applied	\N	\N	\N	\N	147994	147994	315319
19433	27217	2	applied	\N	\N	\N	\N	147995	147995	315320
19433	27218	3	applied	\N	\N	\N	\N	147996	147996	315321
19433	27219	4	applied	\N	\N	\N	\N	147997	147997	315322
19433	27220	5	applied	\N	\N	\N	\N	147998	147998	315323
19433	27221	6	applied	\N	\N	\N	\N	147999	147999	315324
19433	27222	7	applied	\N	\N	\N	\N	148000	148000	315325
19440	27231	5	applied	\N	\N	\N	\N	148038	148038	315363
19440	27233	7	applied	\N	\N	\N	\N	148040	148040	315365
19440	27234	8	applied	\N	\N	1000000000	\N	148041	148041	315366
19440	27235	9	applied	\N	\N	\N	\N	148042	148042	315367
19440	27236	10	applied	\N	\N	\N	\N	148043	148043	315368
19440	27237	11	applied	\N	\N	\N	\N	148044	148044	315369
19440	27238	12	applied	\N	\N	\N	\N	148045	148045	315370
19440	27239	13	applied	\N	\N	\N	\N	148046	148046	315371
19440	27240	14	applied	\N	\N	\N	\N	148047	148047	315372
19440	27241	15	applied	\N	\N	\N	\N	148048	148048	315373
19440	27242	16	applied	\N	\N	\N	\N	148049	148049	315374
19440	27243	17	applied	\N	\N	\N	\N	148050	148050	315375
19442	27248	0	applied	\N	\N	\N	\N	148055	148055	315380
19442	27249	1	applied	\N	\N	\N	\N	148056	148056	315381
19442	27250	2	applied	\N	\N	\N	\N	148057	148057	315382
19442	27251	3	applied	\N	\N	\N	\N	148058	148058	315383
19443	27252	0	applied	\N	\N	\N	\N	148059	148059	315384
19443	27254	2	applied	\N	\N	\N	\N	148061	148061	315386
19447	27255	0	applied	\N	\N	\N	\N	148067	148067	315392
19448	27255	0	applied	\N	\N	\N	\N	148074	148074	315399
19448	27256	1	applied	\N	\N	\N	\N	148075	148075	315400
19448	27257	2	applied	\N	\N	\N	\N	148076	148076	315401
19448	27260	3	applied	\N	\N	\N	\N	148077	148077	315402
19448	27261	4	applied	\N	\N	\N	\N	148078	148078	315403
19448	27258	5	applied	\N	\N	\N	\N	148079	148079	315404
19448	27259	6	applied	\N	\N	\N	\N	148080	148080	315405
19450	27262	0	applied	\N	\N	\N	\N	148088	148088	315413
19450	27260	1	applied	\N	\N	\N	\N	148089	148089	315414
19450	27261	2	applied	\N	\N	\N	\N	148090	148090	315415
19450	27263	3	applied	\N	\N	\N	\N	148091	148091	315416
19450	27264	4	applied	\N	\N	\N	\N	148092	148092	315417
19452	27262	0	applied	\N	\N	\N	\N	148095	148095	315420
19452	27260	1	applied	\N	\N	\N	\N	148096	148096	315421
19452	27263	3	applied	\N	\N	\N	\N	148098	148098	315423
19452	27264	4	applied	\N	\N	\N	\N	148099	148099	315424
19455	27275	0	applied	\N	\N	\N	\N	148113	148113	315438
19455	27276	1	applied	\N	\N	\N	\N	148114	148114	315439
19455	27277	2	applied	\N	\N	\N	\N	148115	148115	315440
19457	27278	0	applied	\N	\N	\N	\N	148119	148119	315444
19457	27279	1	applied	\N	\N	\N	\N	148120	148120	315445
19457	27280	2	applied	\N	\N	\N	\N	148121	148121	315446
19457	27281	3	applied	\N	\N	\N	\N	148122	148122	315447
19458	27282	0	applied	\N	\N	\N	\N	148123	148123	315448
19458	27283	1	applied	\N	\N	\N	\N	148124	148124	315449
19458	27284	2	applied	\N	\N	\N	\N	148125	148125	315450
19458	27285	3	applied	\N	\N	\N	\N	148126	148126	315451
19458	27286	4	applied	\N	\N	\N	\N	148127	148127	315452
19458	27287	5	applied	\N	\N	\N	\N	148128	148128	315453
19458	27288	6	applied	\N	\N	\N	\N	148129	148129	315454
19458	27290	8	applied	\N	\N	\N	\N	148131	148131	315456
19458	27291	9	applied	\N	\N	\N	\N	148132	148132	315457
19460	27292	0	applied	\N	\N	\N	\N	148136	148136	315461
19460	27293	1	applied	\N	\N	\N	\N	148137	148137	315462
19463	27295	0	applied	\N	\N	\N	\N	148143	148143	315468
19463	27296	1	applied	\N	\N	\N	\N	148144	148144	315469
19468	27315	0	applied	\N	\N	\N	\N	148167	148167	315492
19468	27316	1	applied	\N	\N	\N	\N	148168	148168	315493
19468	27317	2	applied	\N	\N	\N	\N	148169	148169	315494
19475	27335	0	applied	\N	\N	\N	\N	148191	148191	315516
19475	27336	1	applied	\N	\N	\N	\N	148192	148192	315517
19475	27337	2	applied	\N	\N	\N	\N	148193	148193	315518
19475	27338	3	applied	\N	\N	\N	\N	148194	148194	315519
19475	27339	4	applied	\N	\N	\N	\N	148195	148195	315520
19480	27347	0	applied	\N	\N	\N	\N	148221	148221	315546
19483	27348	0	applied	\N	\N	\N	\N	148227	148227	315552
19483	27349	2	applied	\N	\N	\N	\N	148229	148229	315554
19484	27350	0	applied	\N	\N	\N	\N	148230	148230	315555
19484	27351	1	applied	\N	\N	\N	\N	148231	148231	315556
19484	27349	2	applied	\N	\N	\N	\N	148232	148232	315557
19487	27352	0	applied	\N	\N	\N	\N	148239	148239	315564
19487	27355	1	applied	\N	\N	\N	\N	148240	148240	315565
19487	27353	2	applied	\N	\N	\N	\N	148241	148241	315566
19487	27354	3	applied	\N	\N	\N	\N	148242	148242	315567
19489	27355	0	applied	\N	\N	\N	\N	148247	148247	315572
19489	27356	1	applied	\N	\N	\N	\N	148248	148248	315573
19489	27357	2	applied	\N	\N	\N	\N	148249	148249	315574
19489	27358	3	applied	\N	\N	\N	\N	148250	148250	315575
19491	27359	0	applied	\N	\N	1000000000	\N	148255	148255	315580
19491	27360	1	applied	\N	\N	\N	\N	148256	148256	315581
19491	27363	2	applied	\N	\N	\N	\N	148257	148257	315582
19491	27361	3	applied	\N	\N	\N	\N	148258	148258	315583
19496	27377	0	applied	\N	\N	\N	\N	148282	148282	315607
19496	27378	1	applied	\N	\N	\N	\N	148283	148283	315608
19496	27379	2	applied	\N	\N	\N	\N	148284	148284	315609
19502	27383	0	applied	\N	\N	\N	\N	148303	148303	315628
19502	27384	1	applied	\N	\N	\N	\N	148304	148304	315629
19502	27385	2	applied	\N	\N	\N	\N	148305	148305	315630
19502	27386	3	applied	\N	\N	\N	\N	148306	148306	315631
19506	27387	0	applied	\N	\N	\N	\N	148323	148323	315648
19506	27388	1	applied	\N	\N	\N	\N	148324	148324	315649
19506	27389	2	applied	\N	\N	\N	\N	148325	148325	315650
19506	27390	3	applied	\N	\N	\N	\N	148326	148326	315651
19506	27391	4	applied	\N	\N	\N	\N	148327	148327	315652
19506	27392	5	applied	\N	\N	\N	\N	148328	148328	315653
19511	27393	0	applied	\N	\N	\N	\N	148347	148347	315672
19511	27394	1	applied	\N	\N	\N	\N	148348	148348	315673
19511	27395	2	applied	\N	\N	\N	\N	148349	148349	315674
19430	27206	4	applied	\N	\N	\N	\N	147981	147981	315306
19430	27207	5	applied	\N	\N	\N	\N	147982	147982	315307
19447	27261	4	applied	\N	\N	\N	\N	148071	148071	315396
19447	27258	5	applied	\N	\N	\N	\N	148072	148072	315397
19447	27259	6	applied	\N	\N	\N	\N	148073	148073	315398
19449	27255	0	applied	\N	\N	\N	\N	148081	148081	315406
19449	27256	1	applied	\N	\N	\N	\N	148082	148082	315407
19449	27257	2	applied	\N	\N	\N	\N	148083	148083	315408
19449	27260	3	applied	\N	\N	\N	\N	148084	148084	315409
19449	27261	4	applied	\N	\N	\N	\N	148085	148085	315410
19449	27258	5	applied	\N	\N	\N	\N	148086	148086	315411
19449	27259	6	applied	\N	\N	\N	\N	148087	148087	315412
19459	27292	0	applied	\N	\N	\N	\N	148133	148133	315458
19459	27294	2	applied	\N	\N	\N	\N	148135	148135	315460
19466	27301	0	applied	\N	\N	\N	\N	148153	148153	315478
19466	27302	1	applied	\N	\N	\N	\N	148154	148154	315479
19466	27303	2	applied	\N	\N	\N	\N	148155	148155	315480
19469	27318	0	applied	\N	\N	\N	\N	148170	148170	315495
19474	27328	0	applied	\N	\N	\N	\N	148184	148184	315509
19474	27329	1	applied	\N	\N	\N	\N	148185	148185	315510
19474	27330	2	applied	\N	\N	\N	\N	148186	148186	315511
19474	27331	3	applied	\N	\N	1000000000	\N	148187	148187	315512
19474	27332	4	applied	\N	\N	1000000000	\N	148188	148188	315513
19474	27333	5	applied	\N	\N	\N	\N	148189	148189	315514
19474	27334	6	applied	\N	\N	\N	\N	148190	148190	315515
19477	27335	0	applied	\N	\N	\N	\N	148200	148200	315525
19477	27336	1	applied	\N	\N	\N	\N	148201	148201	315526
19477	27337	2	applied	\N	\N	\N	\N	148202	148202	315527
19477	27338	3	applied	\N	\N	\N	\N	148203	148203	315528
19485	27350	0	applied	\N	\N	\N	\N	148233	148233	315558
19485	27351	1	applied	\N	\N	\N	\N	148234	148234	315559
19485	27349	2	applied	\N	\N	\N	\N	148235	148235	315560
19490	27359	0	applied	\N	\N	1000000000	\N	148251	148251	315576
19490	27360	1	applied	\N	\N	\N	\N	148252	148252	315577
19490	27361	2	applied	\N	\N	\N	\N	148253	148253	315578
19490	27362	3	applied	\N	\N	\N	\N	148254	148254	315579
19493	27360	0	applied	\N	\N	\N	\N	148265	148265	315590
19493	27363	1	applied	\N	\N	\N	\N	148266	148266	315591
19493	27361	2	applied	\N	\N	\N	\N	148267	148267	315592
19493	27362	3	applied	\N	\N	\N	\N	148268	148268	315593
19494	27364	0	applied	\N	\N	\N	\N	148269	148269	315594
19494	27365	1	applied	\N	\N	\N	\N	148270	148270	315595
19494	27366	2	applied	\N	\N	\N	\N	148271	148271	315596
19495	27367	0	applied	\N	\N	\N	\N	148272	148272	315597
19495	27368	1	applied	\N	\N	\N	\N	148273	148273	315598
19495	27370	3	applied	\N	\N	\N	\N	148275	148275	315600
19495	27371	4	applied	\N	\N	\N	\N	148276	148276	315601
19495	27372	5	applied	\N	\N	\N	\N	148277	148277	315602
19495	27373	6	applied	\N	\N	\N	\N	148278	148278	315603
19495	27374	7	applied	\N	\N	\N	\N	148279	148279	315604
19495	27375	8	applied	\N	\N	\N	\N	148280	148280	315605
19495	27376	9	applied	\N	\N	\N	\N	148281	148281	315606
19500	27383	0	applied	\N	\N	\N	\N	148295	148295	315620
19500	27384	1	applied	\N	\N	\N	\N	148296	148296	315621
19500	27385	2	applied	\N	\N	\N	\N	148297	148297	315622
19500	27386	3	applied	\N	\N	\N	\N	148298	148298	315623
19504	27387	0	applied	\N	\N	\N	\N	148311	148311	315636
19504	27388	1	applied	\N	\N	\N	\N	148312	148312	315637
19504	27389	2	applied	\N	\N	\N	\N	148313	148313	315638
19504	27390	3	applied	\N	\N	\N	\N	148314	148314	315639
19504	27391	4	applied	\N	\N	\N	\N	148315	148315	315640
19509	27393	0	applied	\N	\N	\N	\N	148339	148339	315664
19509	27394	1	applied	\N	\N	\N	\N	148340	148340	315665
19509	27395	2	applied	\N	\N	\N	\N	148341	148341	315666
19509	27396	3	applied	\N	\N	\N	\N	148342	148342	315667
19512	27393	0	applied	\N	\N	\N	\N	148351	148351	315676
19512	27394	1	applied	\N	\N	\N	\N	148352	148352	315677
19512	27395	2	applied	\N	\N	\N	\N	148353	148353	315678
19512	27396	3	applied	\N	\N	\N	\N	148354	148354	315679
19515	27397	0	applied	\N	\N	\N	\N	148362	148362	315687
19515	27400	1	applied	\N	\N	\N	\N	148363	148363	315688
19515	27398	2	applied	\N	\N	\N	\N	148364	148364	315689
19515	27399	3	applied	\N	\N	\N	\N	148365	148365	315690
19515	27401	4	applied	\N	\N	\N	\N	148366	148366	315691
19515	27402	5	applied	\N	\N	\N	\N	148367	148367	315692
19516	27403	0	applied	\N	\N	\N	\N	148368	148368	315693
19516	27404	1	applied	\N	\N	\N	\N	148369	148369	315694
19516	27406	3	applied	\N	\N	\N	\N	148371	148371	315696
19520	27407	0	applied	\N	\N	\N	\N	148387	148387	315712
19520	27408	1	applied	\N	\N	\N	\N	148388	148388	315713
19520	27409	2	applied	\N	\N	\N	\N	148389	148389	315714
19523	27410	0	applied	\N	\N	\N	\N	148396	148396	315721
19523	27411	1	applied	\N	\N	\N	\N	148397	148397	315722
19523	27412	2	applied	\N	\N	\N	\N	148398	148398	315723
19524	27413	0	applied	\N	\N	\N	\N	148399	148399	315724
19524	27414	1	applied	\N	\N	\N	\N	148400	148400	315725
19525	27413	0	applied	\N	\N	\N	\N	148401	148401	315726
19525	27414	1	applied	\N	\N	\N	\N	148402	148402	315727
19525	27415	2	applied	\N	\N	\N	\N	148403	148403	315728
19527	27416	0	applied	\N	\N	\N	\N	148407	148407	315732
19527	27417	1	applied	\N	\N	\N	\N	148408	148408	315733
19527	27418	2	applied	\N	\N	\N	\N	148409	148409	315734
19527	27419	3	applied	\N	\N	\N	\N	148410	148410	315735
19529	27417	1	applied	\N	\N	\N	\N	148416	148416	315741
19529	27418	2	applied	\N	\N	\N	\N	148417	148417	315742
19529	27419	3	applied	\N	\N	\N	\N	148418	148418	315743
19530	27416	0	applied	\N	\N	\N	\N	148419	148419	315744
19530	27417	1	applied	\N	\N	\N	\N	148420	148420	315745
19530	27418	2	applied	\N	\N	\N	\N	148421	148421	315746
19530	27419	3	applied	\N	\N	\N	\N	148422	148422	315747
19532	27423	0	applied	\N	\N	\N	\N	148426	148426	315751
19533	27430	0	applied	\N	\N	\N	\N	148433	148433	315758
19533	27431	2	applied	\N	\N	\N	\N	148434	148434	315759
19533	27432	3	applied	\N	\N	\N	\N	148435	148435	315760
19538	27400	0	applied	\N	\N	\N	\N	148445	148445	315770
19538	27403	1	applied	\N	\N	\N	\N	148446	148446	315771
19538	27407	2	applied	\N	\N	\N	\N	148447	148447	315772
19538	27410	3	applied	\N	\N	\N	\N	148448	148448	315773
19538	27413	4	applied	\N	\N	\N	\N	148449	148449	315774
19538	27420	6	applied	\N	\N	\N	\N	148451	148451	315776
19538	27423	7	applied	\N	\N	\N	\N	148452	148452	315777
19447	27257	2	applied	\N	\N	\N	\N	148069	148069	315394
19447	27260	3	applied	\N	\N	\N	\N	148070	148070	315395
19465	27299	2	applied	\N	\N	\N	\N	148151	148151	315476
19465	27300	3	applied	\N	\N	\N	\N	148152	148152	315477
19467	27311	7	applied	\N	\N	\N	\N	148163	148163	315488
19467	27312	8	applied	\N	\N	\N	\N	148164	148164	315489
19467	27313	9	applied	\N	\N	\N	\N	148165	148165	315490
19467	27314	10	applied	\N	\N	\N	\N	148166	148166	315491
19470	27318	0	applied	\N	\N	\N	\N	148171	148171	315496
19470	27319	1	applied	\N	\N	\N	\N	148172	148172	315497
19470	27320	2	applied	\N	\N	\N	\N	148173	148173	315498
19471	27318	0	applied	\N	\N	\N	\N	148174	148174	315499
19471	27319	1	applied	\N	\N	\N	\N	148175	148175	315500
19471	27320	2	applied	\N	\N	\N	\N	148176	148176	315501
19472	27321	0	applied	\N	\N	\N	\N	148177	148177	315502
19472	27322	1	applied	\N	\N	\N	\N	148178	148178	315503
19472	27324	3	applied	\N	\N	\N	\N	148180	148180	315505
19473	27325	0	applied	\N	\N	\N	\N	148181	148181	315506
19473	27326	1	applied	\N	\N	\N	\N	148182	148182	315507
19473	27327	2	applied	\N	\N	\N	\N	148183	148183	315508
19476	27335	0	applied	\N	\N	\N	\N	148196	148196	315521
19476	27337	1	applied	\N	\N	\N	\N	148197	148197	315522
19476	27338	2	applied	\N	\N	\N	\N	148198	148198	315523
19476	27339	3	applied	\N	\N	\N	\N	148199	148199	315524
19478	27340	0	applied	\N	\N	\N	\N	148205	148205	315530
19478	27341	1	applied	\N	\N	\N	\N	148206	148206	315531
19478	27336	2	applied	\N	\N	\N	\N	148207	148207	315532
19478	27342	3	applied	\N	\N	\N	\N	148208	148208	315533
19478	27343	4	applied	\N	\N	\N	\N	148209	148209	315534
19478	27344	5	applied	\N	\N	\N	\N	148210	148210	315535
19478	27345	6	applied	\N	\N	\N	\N	148211	148211	315536
19478	27346	8	applied	\N	\N	\N	\N	148212	148212	315537
19479	27341	1	applied	\N	\N	\N	\N	148214	148214	315539
19479	27336	2	applied	\N	\N	\N	\N	148215	148215	315540
19479	27342	3	applied	\N	\N	\N	\N	148216	148216	315541
19479	27343	4	applied	\N	\N	\N	\N	148217	148217	315542
19479	27344	5	applied	\N	\N	\N	\N	148218	148218	315543
19479	27345	6	applied	\N	\N	\N	\N	148219	148219	315544
19481	27348	0	applied	\N	\N	\N	\N	148222	148222	315547
19481	27347	1	applied	\N	\N	\N	\N	148223	148223	315548
19492	27359	0	applied	\N	\N	1000000000	\N	148260	148260	315585
19492	27360	1	applied	\N	\N	\N	\N	148261	148261	315586
19492	27363	2	applied	\N	\N	\N	\N	148262	148262	315587
19492	27361	3	applied	\N	\N	\N	\N	148263	148263	315588
19492	27362	4	applied	\N	\N	\N	\N	148264	148264	315589
19497	27377	0	applied	\N	\N	\N	\N	148285	148285	315610
19497	27378	1	applied	\N	\N	\N	\N	148286	148286	315611
19497	27379	2	applied	\N	\N	\N	\N	148287	148287	315612
19499	27384	1	applied	\N	\N	\N	\N	148292	148292	315617
19499	27385	2	applied	\N	\N	\N	\N	148293	148293	315618
19499	27386	3	applied	\N	\N	\N	\N	148294	148294	315619
19503	27383	0	applied	\N	\N	\N	\N	148307	148307	315632
19503	27384	1	applied	\N	\N	\N	\N	148308	148308	315633
19503	27385	2	applied	\N	\N	\N	\N	148309	148309	315634
19503	27386	3	applied	\N	\N	\N	\N	148310	148310	315635
19507	27387	0	applied	\N	\N	\N	\N	148329	148329	315654
19507	27388	1	applied	\N	\N	\N	\N	148330	148330	315655
19507	27389	2	applied	\N	\N	\N	\N	148331	148331	315656
19507	27390	3	applied	\N	\N	\N	\N	148332	148332	315657
19507	27391	4	applied	\N	\N	\N	\N	148333	148333	315658
19507	27392	5	applied	\N	\N	\N	\N	148334	148334	315659
19508	27393	0	applied	\N	\N	\N	\N	148335	148335	315660
19508	27394	1	applied	\N	\N	\N	\N	148336	148336	315661
19508	27395	2	applied	\N	\N	\N	\N	148337	148337	315662
19514	27397	0	applied	\N	\N	\N	\N	148359	148359	315684
19514	27398	1	applied	\N	\N	\N	\N	148360	148360	315685
19514	27399	2	applied	\N	\N	\N	\N	148361	148361	315686
19517	27403	0	applied	\N	\N	\N	\N	148372	148372	315697
19517	27404	1	applied	\N	\N	\N	\N	148373	148373	315698
19517	27405	2	applied	\N	\N	\N	\N	148374	148374	315699
19517	27406	3	applied	\N	\N	\N	\N	148375	148375	315700
19519	27407	0	applied	\N	\N	\N	\N	148384	148384	315709
19519	27408	1	applied	\N	\N	\N	\N	148385	148385	315710
19519	27409	2	applied	\N	\N	\N	\N	148386	148386	315711
19526	27413	0	applied	\N	\N	\N	\N	148404	148404	315729
19526	27414	1	applied	\N	\N	\N	\N	148405	148405	315730
19526	27415	2	applied	\N	\N	\N	\N	148406	148406	315731
19528	27416	0	applied	\N	\N	\N	\N	148411	148411	315736
19528	27417	1	applied	\N	\N	\N	\N	148412	148412	315737
19528	27418	2	applied	\N	\N	\N	\N	148413	148413	315738
19537	27433	0	applied	\N	\N	\N	\N	148442	148442	315767
19537	27434	1	applied	\N	\N	\N	\N	148443	148443	315768
19537	27435	2	applied	\N	\N	\N	\N	148444	148444	315769
19538	27424	8	applied	\N	\N	\N	\N	148453	148453	315778
19538	27430	9	applied	\N	\N	\N	\N	148454	148454	315779
19538	27433	10	applied	\N	\N	\N	\N	148455	148455	315780
19538	27401	11	applied	\N	\N	\N	\N	148456	148456	315781
19538	27404	12	applied	\N	\N	\N	\N	148457	148457	315782
19538	27408	13	applied	\N	\N	\N	\N	148458	148458	315783
19538	27406	14	applied	\N	\N	\N	\N	148459	148459	315784
19538	27418	15	applied	\N	\N	\N	\N	148460	148460	315785
19538	27412	16	applied	\N	\N	\N	\N	148461	148461	315786
19538	27402	17	applied	\N	\N	\N	\N	148462	148462	315787
19538	27405	18	applied	\N	\N	\N	\N	148463	148463	315788
19538	27409	19	applied	\N	\N	\N	\N	148464	148464	315789
19538	27411	20	applied	\N	\N	\N	\N	148465	148465	315790
19538	27419	22	applied	\N	\N	\N	\N	148467	148467	315792
19538	27422	23	applied	\N	\N	\N	\N	148468	148468	315793
19538	27425	24	applied	\N	\N	\N	\N	148469	148469	315794
19538	27426	25	applied	\N	\N	\N	\N	148470	148470	315795
19538	27432	26	applied	\N	\N	\N	\N	148471	148471	315796
19539	27436	0	applied	\N	\N	\N	\N	148481	148481	315806
19539	27437	1	applied	\N	\N	\N	\N	148482	148482	315807
19539	27438	2	applied	\N	\N	\N	\N	148483	148483	315808
19539	27439	3	applied	\N	\N	\N	\N	148484	148484	315809
19549	27456	0	applied	\N	\N	\N	\N	148538	148538	315863
19549	27457	1	applied	\N	\N	\N	\N	148539	148539	315864
19549	27458	2	applied	\N	\N	\N	\N	148540	148540	315865
19549	27459	3	applied	\N	\N	\N	\N	148541	148541	315866
19549	27460	4	applied	\N	\N	\N	\N	148542	148542	315867
19549	27461	5	applied	\N	\N	\N	\N	148543	148543	315868
19549	27462	6	applied	\N	\N	\N	\N	148544	148544	315869
19465	27298	1	applied	\N	\N	\N	\N	148150	148150	315475
19482	27349	2	applied	\N	\N	\N	\N	148226	148226	315551
19486	27352	0	applied	\N	\N	\N	\N	148236	148236	315561
19486	27353	1	applied	\N	\N	\N	\N	148237	148237	315562
19486	27354	2	applied	\N	\N	\N	\N	148238	148238	315563
19488	27355	0	applied	\N	\N	\N	\N	148243	148243	315568
19488	27356	1	applied	\N	\N	\N	\N	148244	148244	315569
19488	27357	2	applied	\N	\N	\N	\N	148245	148245	315570
19488	27358	3	applied	\N	\N	\N	\N	148246	148246	315571
19498	27380	0	applied	\N	\N	\N	\N	148288	148288	315613
19498	27382	2	applied	\N	\N	\N	\N	148290	148290	315615
19501	27383	0	applied	\N	\N	\N	\N	148299	148299	315624
19501	27384	1	applied	\N	\N	\N	\N	148300	148300	315625
19501	27385	2	applied	\N	\N	\N	\N	148301	148301	315626
19501	27386	3	applied	\N	\N	\N	\N	148302	148302	315627
19505	27387	0	applied	\N	\N	\N	\N	148317	148317	315642
19505	27388	1	applied	\N	\N	\N	\N	148318	148318	315643
19505	27389	2	applied	\N	\N	\N	\N	148319	148319	315644
19505	27390	3	applied	\N	\N	\N	\N	148320	148320	315645
19505	27391	4	applied	\N	\N	\N	\N	148321	148321	315646
19505	27392	5	applied	\N	\N	\N	\N	148322	148322	315647
19510	27393	0	applied	\N	\N	\N	\N	148343	148343	315668
19510	27394	1	applied	\N	\N	\N	\N	148344	148344	315669
19510	27395	2	applied	\N	\N	\N	\N	148345	148345	315670
19510	27396	3	applied	\N	\N	\N	\N	148346	148346	315671
19513	27393	0	applied	\N	\N	\N	\N	148355	148355	315680
19513	27395	2	applied	\N	\N	\N	\N	148357	148357	315682
19513	27396	3	applied	\N	\N	\N	\N	148358	148358	315683
19518	27359	0	applied	\N	\N	1000000000	\N	148376	148376	315701
19518	27329	1	applied	\N	\N	\N	\N	148377	148377	315702
19518	27307	2	applied	\N	\N	1000000000	\N	148378	148378	315703
19518	27331	3	applied	\N	\N	1000000000	\N	148379	148379	315704
19518	27332	4	applied	\N	\N	1000000000	\N	148380	148380	315705
19518	27333	5	applied	\N	\N	\N	\N	148381	148381	315706
19518	27344	6	applied	\N	\N	\N	\N	148382	148382	315707
19518	27339	7	applied	\N	\N	\N	\N	148383	148383	315708
19521	27407	0	applied	\N	\N	\N	\N	148390	148390	315715
19521	27408	1	applied	\N	\N	\N	\N	148391	148391	315716
19521	27409	2	applied	\N	\N	\N	\N	148392	148392	315717
19522	27410	0	applied	\N	\N	\N	\N	148393	148393	315718
19522	27411	1	applied	\N	\N	\N	\N	148394	148394	315719
19522	27412	2	applied	\N	\N	\N	\N	148395	148395	315720
19531	27421	1	applied	\N	\N	\N	\N	148424	148424	315749
19531	27422	2	applied	\N	\N	\N	\N	148425	148425	315750
19532	27424	1	applied	\N	\N	\N	\N	148427	148427	315752
19532	27425	2	applied	\N	\N	\N	\N	148428	148428	315753
19532	27426	3	applied	\N	\N	\N	\N	148429	148429	315754
19532	27427	4	applied	\N	\N	\N	\N	148430	148430	315755
19532	27428	5	applied	\N	\N	\N	\N	148431	148431	315756
19532	27429	6	applied	\N	\N	\N	\N	148432	148432	315757
19534	27430	0	applied	\N	\N	\N	\N	148436	148436	315761
19534	27431	2	applied	\N	\N	\N	\N	148437	148437	315762
19534	27432	3	applied	\N	\N	\N	\N	148438	148438	315763
19536	27433	0	applied	\N	\N	\N	\N	148439	148439	315764
19536	27434	1	applied	\N	\N	\N	\N	148440	148440	315765
19536	27435	2	applied	\N	\N	\N	\N	148441	148441	315766
19538	27434	27	applied	\N	\N	\N	\N	148472	148472	315797
19538	27429	28	applied	\N	\N	\N	\N	148473	148473	315798
19538	27417	30	applied	\N	\N	\N	\N	148475	148475	315800
19538	27421	31	applied	\N	\N	\N	\N	148476	148476	315801
19538	27427	32	applied	\N	\N	\N	\N	148477	148477	315802
19538	27428	33	applied	\N	\N	\N	\N	148478	148478	315803
19538	27431	34	applied	\N	\N	\N	\N	148479	148479	315804
19538	27435	35	applied	\N	\N	\N	\N	148480	148480	315805
19540	27436	0	applied	\N	\N	\N	\N	148485	148485	315810
19540	27437	1	applied	\N	\N	\N	\N	148486	148486	315811
19540	27438	2	applied	\N	\N	\N	\N	148487	148487	315812
19541	27436	0	applied	\N	\N	\N	\N	148488	148488	315813
19541	27437	1	applied	\N	\N	\N	\N	148489	148489	315814
19541	27438	2	applied	\N	\N	\N	\N	148490	148490	315815
19541	27439	3	applied	\N	\N	\N	\N	148491	148491	315816
19542	27440	0	applied	\N	\N	\N	\N	148492	148492	315817
19542	27441	1	applied	\N	\N	\N	\N	148493	148493	315818
19542	27442	2	applied	\N	\N	\N	\N	148494	148494	315819
19543	27444	1	applied	\N	\N	\N	\N	148496	148496	315821
19543	27445	2	applied	\N	\N	\N	\N	148497	148497	315822
19543	27446	3	applied	\N	\N	\N	\N	148498	148498	315823
19543	27447	4	applied	\N	\N	\N	\N	148499	148499	315824
19543	27448	5	applied	\N	\N	\N	\N	148500	148500	315825
19543	27449	6	applied	\N	\N	\N	\N	148501	148501	315826
19544	27443	0	applied	\N	\N	\N	\N	148502	148502	315827
19544	27444	1	applied	\N	\N	\N	\N	148503	148503	315828
19544	27445	2	applied	\N	\N	\N	\N	148504	148504	315829
19544	27450	3	applied	\N	\N	\N	\N	148505	148505	315830
19544	27446	4	applied	\N	\N	\N	\N	148506	148506	315831
19544	27451	5	applied	\N	\N	\N	\N	148507	148507	315832
19544	27452	6	applied	\N	\N	\N	\N	148508	148508	315833
19544	27447	7	applied	\N	\N	\N	\N	148509	148509	315834
19544	27448	8	applied	\N	\N	\N	\N	148510	148510	315835
19544	27449	9	applied	\N	\N	\N	\N	148511	148511	315836
19545	27444	1	applied	\N	\N	\N	\N	148513	148513	315838
19545	27445	2	applied	\N	\N	\N	\N	148514	148514	315839
19545	27450	3	applied	\N	\N	\N	\N	148515	148515	315840
19545	27446	4	applied	\N	\N	\N	\N	148516	148516	315841
19545	27451	5	applied	\N	\N	\N	\N	148517	148517	315842
19545	27452	6	applied	\N	\N	\N	\N	148518	148518	315843
19545	27447	7	applied	\N	\N	\N	\N	148519	148519	315844
19545	27448	8	applied	\N	\N	\N	\N	148520	148520	315845
19546	27443	0	applied	\N	\N	\N	\N	148522	148522	315847
19546	27444	1	applied	\N	\N	\N	\N	148523	148523	315848
19546	27445	2	applied	\N	\N	\N	\N	148524	148524	315849
19546	27450	3	applied	\N	\N	\N	\N	148525	148525	315850
19546	27446	4	applied	\N	\N	\N	\N	148526	148526	315851
19546	27451	5	applied	\N	\N	\N	\N	148527	148527	315852
19546	27452	6	applied	\N	\N	\N	\N	148528	148528	315853
19546	27447	7	applied	\N	\N	\N	\N	148529	148529	315854
19546	27449	9	applied	\N	\N	\N	\N	148531	148531	315856
19548	27453	0	applied	\N	\N	\N	\N	148535	148535	315860
19548	27454	1	applied	\N	\N	\N	\N	148536	148536	315861
19548	27455	2	applied	\N	\N	\N	\N	148537	148537	315862
19482	27348	0	applied	\N	\N	\N	\N	148224	148224	315549
19482	27347	1	applied	\N	\N	\N	\N	148225	148225	315550
19550	27456	0	applied	\N	\N	\N	\N	148545	148545	315870
19550	27457	1	applied	\N	\N	\N	\N	148546	148546	315871
19550	27458	2	applied	\N	\N	\N	\N	148547	148547	315872
19550	27459	3	applied	\N	\N	\N	\N	148548	148548	315873
19550	27460	4	applied	\N	\N	\N	\N	148549	148549	315874
19550	27461	5	applied	\N	\N	\N	\N	148550	148550	315875
19550	27462	6	applied	\N	\N	\N	\N	148551	148551	315876
19551	27202	0	applied	\N	\N	1000000000	\N	148552	148552	315877
19551	26798	1	applied	\N	\N	\N	\N	148553	148553	315878
19551	26708	2	applied	\N	\N	1000000000	\N	148554	148554	315879
19551	26815	3	applied	\N	\N	\N	\N	148555	148555	315880
19551	26723	4	applied	\N	\N	\N	\N	148556	148556	315881
19551	26738	6	applied	\N	\N	1000000000	\N	148558	148558	315883
19551	26823	7	applied	\N	\N	\N	\N	148559	148559	315884
19551	26824	8	applied	\N	\N	\N	\N	148560	148560	315885
19551	26825	9	applied	\N	\N	\N	\N	148561	148561	315886
19551	27051	10	applied	\N	\N	\N	\N	148562	148562	315887
19551	27052	11	applied	\N	\N	\N	\N	148563	148563	315888
19551	27053	12	applied	\N	\N	\N	\N	148564	148564	315889
19551	27054	13	applied	\N	\N	\N	\N	148565	148565	315890
19551	27196	14	applied	\N	\N	1000000000	\N	148566	148566	315891
19551	26826	15	applied	\N	\N	\N	\N	148567	148567	315892
19551	26827	16	applied	\N	\N	\N	\N	148568	148568	315893
19551	26878	17	applied	\N	\N	\N	\N	148569	148569	315894
19551	26881	18	applied	\N	\N	\N	\N	148570	148570	315895
19551	26882	19	applied	\N	\N	\N	\N	148571	148571	315896
19551	26883	20	applied	\N	\N	\N	\N	148572	148572	315897
19551	26884	21	applied	\N	\N	\N	\N	148573	148573	315898
19551	26910	22	applied	\N	\N	\N	\N	148574	148574	315899
19551	26911	23	applied	\N	\N	\N	\N	148575	148575	315900
19551	26912	24	applied	\N	\N	\N	\N	148576	148576	315901
19551	26914	25	applied	\N	\N	\N	\N	148577	148577	315902
19551	26932	27	applied	\N	\N	\N	\N	148579	148579	315904
19551	26933	28	applied	\N	\N	\N	\N	148580	148580	315905
19551	26934	29	applied	\N	\N	\N	\N	148581	148581	315906
19551	26935	30	applied	\N	\N	\N	\N	148582	148582	315907
19551	26936	31	applied	\N	\N	\N	\N	148583	148583	315908
19551	26955	32	applied	\N	\N	\N	\N	148584	148584	315909
19551	26956	33	applied	\N	\N	\N	\N	148585	148585	315910
19551	26958	34	applied	\N	\N	\N	\N	148586	148586	315911
19551	26959	35	applied	\N	\N	\N	\N	148587	148587	315912
19551	26960	36	applied	\N	\N	\N	\N	148588	148588	315913
19551	26977	37	applied	\N	\N	\N	\N	148589	148589	315914
19551	26978	38	applied	\N	\N	\N	\N	148590	148590	315915
19551	26979	39	applied	\N	\N	\N	\N	148591	148591	315916
19551	26980	40	applied	\N	\N	\N	\N	148592	148592	315917
19551	26981	41	applied	\N	\N	\N	\N	148593	148593	315918
19551	26989	42	applied	\N	\N	\N	\N	148594	148594	315919
19551	26991	44	applied	\N	\N	\N	\N	148596	148596	315921
19551	26992	45	applied	\N	\N	\N	\N	148597	148597	315922
19551	26993	46	applied	\N	\N	\N	\N	148598	148598	315923
19551	26887	47	applied	\N	\N	\N	\N	148599	148599	315924
19551	27329	48	applied	\N	\N	\N	\N	148600	148600	315925
19551	26836	49	applied	\N	\N	\N	\N	148601	148601	315926
19551	27207	50	applied	\N	\N	\N	\N	148602	148602	315927
19551	27221	51	applied	\N	\N	\N	\N	148603	148603	315928
19551	27232	52	applied	\N	\N	\N	\N	148604	148604	315929
19551	27344	53	applied	\N	\N	\N	\N	148605	148605	315930
19551	26839	54	applied	\N	\N	1000000000	\N	148606	148606	315931
19551	26840	55	applied	\N	\N	1000000000	\N	148607	148607	315932
19551	26841	56	applied	\N	\N	1000000000	\N	148608	148608	315933
19551	26757	57	applied	\N	\N	\N	\N	148609	148609	315934
19551	26651	58	applied	\N	\N	\N	\N	148610	148610	315935
19551	26844	59	applied	\N	\N	\N	\N	148611	148611	315936
19551	26846	61	applied	\N	\N	1000000000	\N	148613	148613	315938
19551	26847	62	applied	\N	\N	1000000000	\N	148614	148614	315939
19551	26917	63	applied	\N	\N	1000000000	\N	148615	148615	315940
19551	26918	64	applied	\N	\N	1000000000	\N	148616	148616	315941
19551	27056	65	applied	\N	\N	1000000000	\N	148617	148617	315942
19551	27112	66	applied	\N	\N	1000000000	\N	148618	148618	315943
19551	27234	67	applied	\N	\N	1000000000	\N	148619	148619	315944
19551	27307	68	applied	\N	\N	1000000000	\N	148620	148620	315945
19551	27331	69	applied	\N	\N	1000000000	\N	148621	148621	315946
19551	27332	70	applied	\N	\N	1000000000	\N	148622	148622	315947
19551	27333	71	applied	\N	\N	\N	\N	148623	148623	315948
19551	27339	72	applied	\N	\N	\N	\N	148624	148624	315949
19551	26896	73	applied	\N	\N	\N	\N	148625	148625	148625
19551	27003	74	applied	\N	\N	\N	\N	148626	148626	315950
19551	27011	75	applied	\N	\N	\N	\N	148627	148627	148627
19551	27014	76	applied	\N	\N	\N	\N	148628	148628	148628
19551	27018	78	applied	\N	\N	\N	\N	148630	148630	148630
19552	27463	0	applied	\N	\N	\N	\N	148631	148631	315951
19552	27464	1	applied	\N	\N	\N	\N	148632	148632	315952
19552	27465	2	applied	\N	\N	\N	\N	148633	148633	315953
19552	27466	3	applied	\N	\N	\N	\N	148634	148634	315954
19552	27467	4	applied	\N	\N	\N	\N	148635	148635	315955
19552	27468	5	applied	\N	\N	\N	\N	148636	148636	315956
19555	27469	0	applied	\N	\N	\N	\N	148644	148644	315964
19555	27470	1	applied	\N	\N	\N	\N	148645	148645	315965
19555	27472	2	applied	\N	\N	\N	\N	148646	148646	315966
19555	27471	3	applied	\N	\N	\N	\N	148647	148647	315967
19559	27473	0	applied	\N	\N	\N	\N	148693	148693	316013
19559	27474	1	applied	\N	\N	\N	\N	148694	148694	316014
19561	27478	0	applied	\N	\N	\N	\N	148697	148697	316017
19561	27479	1	applied	\N	\N	\N	\N	148698	148698	316018
19561	27480	2	applied	\N	\N	\N	\N	148699	148699	316019
19569	27496	0	applied	\N	\N	\N	\N	148846	148846	316166
19569	27497	1	applied	\N	\N	\N	\N	148847	148847	316167
19569	27498	2	applied	\N	\N	\N	\N	148848	148848	316168
19587	27527	0	applied	\N	\N	\N	\N	148903	148903	316223
19587	27528	1	applied	\N	\N	\N	\N	148904	148904	316224
19587	27529	2	applied	\N	\N	\N	\N	148905	148905	316225
19591	27530	0	applied	\N	\N	\N	\N	148912	148912	316232
19591	27531	1	applied	\N	\N	\N	\N	148913	148913	316233
19591	27532	2	applied	\N	\N	\N	\N	148914	148914	316234
19595	27533	0	applied	\N	\N	\N	\N	148921	148921	316241
19595	27534	1	applied	\N	\N	\N	\N	148922	148922	316242
19595	27535	2	applied	\N	\N	\N	\N	148923	148923	316243
19547	27454	1	applied	\N	\N	\N	\N	148533	148533	315858
19547	27455	2	applied	\N	\N	\N	\N	148534	148534	315859
19554	27470	1	applied	\N	\N	\N	\N	148641	148641	315961
19554	27472	2	applied	\N	\N	\N	\N	148642	148642	315962
19554	27471	3	applied	\N	\N	\N	\N	148643	148643	315963
19556	27469	0	applied	\N	\N	\N	\N	148648	148648	315968
19556	27470	1	applied	\N	\N	\N	\N	148649	148649	315969
19556	27472	2	applied	\N	\N	\N	\N	148650	148650	315970
19556	27471	3	applied	\N	\N	\N	\N	148651	148651	315971
19557	27436	0	applied	\N	\N	\N	\N	148652	148652	315972
19557	27440	1	applied	\N	\N	\N	\N	148653	148653	315973
19557	27443	2	applied	\N	\N	\N	\N	148654	148654	315974
19557	27444	3	applied	\N	\N	\N	\N	148655	148655	315975
19557	27445	4	applied	\N	\N	\N	\N	148656	148656	315976
19557	27453	5	applied	\N	\N	\N	\N	148657	148657	315977
19557	27456	6	applied	\N	\N	\N	\N	148658	148658	315978
19557	27457	8	applied	\N	\N	\N	\N	148659	148659	315979
19557	27463	9	applied	\N	\N	\N	\N	148660	148660	315980
19557	27469	11	applied	\N	\N	\N	\N	148662	148662	315982
19557	27437	12	applied	\N	\N	\N	\N	148663	148663	315983
19557	27438	13	applied	\N	\N	\N	\N	148664	148664	315984
19599	27550	0	applied	\N	\N	\N	\N	148941	148941	316261
19599	27551	1	applied	\N	\N	\N	\N	148942	148942	316262
19599	27552	2	applied	\N	\N	\N	\N	148943	148943	316263
19608	27569	0	applied	\N	\N	\N	\N	148984	148984	316304
19608	27570	1	applied	\N	\N	\N	\N	148985	148985	316305
19608	27571	2	applied	\N	\N	\N	\N	148986	148986	316306
19608	27572	3	applied	\N	\N	\N	\N	148987	148987	316307
19608	27573	4	applied	\N	\N	\N	\N	148988	148988	316308
19608	27574	5	applied	\N	\N	\N	\N	148989	148989	316309
19608	27575	6	applied	\N	\N	\N	\N	148990	148990	316310
19611	27579	0	applied	\N	\N	\N	\N	149013	149013	316333
19611	27580	1	applied	\N	\N	\N	\N	149014	149014	316334
19611	27581	2	applied	\N	\N	\N	\N	149015	149015	316335
19611	27583	4	applied	\N	\N	\N	\N	149017	149017	316337
19611	27584	5	applied	\N	\N	\N	\N	149018	149018	316338
19611	27585	6	applied	\N	\N	\N	\N	149019	149019	316339
19614	27593	0	applied	\N	\N	\N	\N	149034	149034	316354
19614	27594	1	applied	\N	\N	\N	\N	149035	149035	316355
19614	27595	2	applied	\N	\N	\N	\N	149036	149036	316356
19614	27596	3	applied	\N	\N	\N	\N	149037	149037	316357
19614	27597	4	applied	\N	\N	\N	\N	149038	149038	316358
19614	27598	5	applied	\N	\N	\N	\N	149039	149039	316359
19614	27599	6	applied	\N	\N	\N	\N	149040	149040	316360
19614	27600	7	applied	\N	\N	\N	\N	149041	149041	316361
19614	27601	8	applied	\N	\N	\N	\N	149042	149042	316362
19617	27602	0	applied	\N	\N	\N	\N	149061	149061	316381
19617	27603	1	applied	\N	\N	\N	\N	149062	149062	316382
19617	27604	2	applied	\N	\N	\N	\N	149063	149063	316383
19617	27605	4	applied	\N	\N	\N	\N	149064	149064	316384
19617	27607	6	applied	\N	\N	\N	\N	149066	149066	316386
19617	27608	7	applied	\N	\N	\N	\N	149067	149067	316387
19617	27609	8	applied	\N	\N	\N	\N	149068	149068	316388
19617	27610	9	applied	\N	\N	\N	\N	149069	149069	316389
19622	27611	0	applied	\N	\N	\N	\N	149220	149220	316540
19622	27612	1	applied	\N	\N	\N	\N	149221	149221	316541
19622	27613	2	applied	\N	\N	\N	\N	149222	149222	316542
19622	27614	3	applied	\N	\N	\N	\N	149223	149223	316543
19622	27615	4	applied	\N	\N	\N	\N	149224	149224	316544
19622	27616	5	applied	\N	\N	\N	\N	149225	149225	316545
19622	27617	6	applied	\N	\N	\N	\N	149226	149226	316546
19624	27621	0	applied	\N	\N	\N	\N	149230	149230	316550
19624	27622	1	applied	\N	\N	\N	\N	149231	149231	316551
19624	27623	2	applied	\N	\N	\N	\N	149232	149232	316552
19624	27624	3	applied	\N	\N	\N	\N	149233	149233	316553
19624	27625	4	applied	\N	\N	\N	\N	149234	149234	316554
19624	27627	6	applied	\N	\N	\N	\N	149236	149236	316556
19625	27628	0	applied	\N	\N	\N	\N	149237	149237	316557
19625	27629	1	applied	\N	\N	\N	\N	149238	149238	316558
19625	27630	2	applied	\N	\N	\N	\N	149239	149239	316559
19625	27631	3	applied	\N	\N	\N	\N	149240	149240	316560
19625	27632	4	applied	\N	\N	\N	\N	149241	149241	316561
19625	27633	5	applied	\N	\N	\N	\N	149242	149242	316562
19625	27634	6	applied	\N	\N	\N	\N	149243	149243	316563
19625	27635	7	applied	\N	\N	\N	\N	149244	149244	316564
19625	27636	8	applied	\N	\N	\N	\N	149245	149245	316565
19625	27637	9	applied	\N	\N	\N	\N	149246	149246	316566
19625	27638	10	applied	\N	\N	\N	\N	149247	149247	316567
19625	27639	11	applied	\N	\N	\N	\N	149248	149248	316568
19625	27640	12	applied	\N	\N	\N	\N	149249	149249	316569
19630	27651	0	applied	\N	\N	\N	\N	149286	149286	316606
19630	27652	1	applied	\N	\N	\N	\N	149287	149287	316607
19639	27671	0	applied	\N	\N	\N	\N	149390	149390	316710
19639	27672	1	applied	\N	\N	\N	\N	149391	149391	316711
19639	27673	2	applied	\N	\N	\N	\N	149392	149392	316712
19642	27671	0	applied	\N	\N	\N	\N	149399	149399	316719
19642	27672	1	applied	\N	\N	\N	\N	149400	149400	316720
19642	27673	2	applied	\N	\N	\N	\N	149401	149401	316721
19644	27674	0	applied	\N	\N	\N	\N	149409	149409	316729
19644	27675	1	applied	\N	\N	\N	\N	149410	149410	316730
19644	27676	2	applied	\N	\N	\N	\N	149411	149411	316731
19644	27677	3	applied	\N	\N	\N	\N	149412	149412	316732
19644	27678	4	applied	\N	\N	\N	\N	149413	149413	316733
19644	27679	5	applied	\N	\N	\N	\N	149414	149414	316734
19644	27680	6	applied	\N	\N	\N	\N	149415	149415	316735
19647	27579	0	applied	\N	\N	\N	\N	149428	149428	316748
19647	27580	1	applied	\N	\N	\N	\N	149429	149429	316749
19647	27586	2	applied	\N	\N	\N	\N	149430	149430	316750
19647	27593	4	applied	\N	\N	\N	\N	149432	149432	316752
19647	27594	5	applied	\N	\N	\N	\N	149433	149433	316753
19647	27595	6	applied	\N	\N	\N	\N	149434	149434	316754
19647	27602	7	applied	\N	\N	\N	\N	149435	149435	316755
19647	27603	8	applied	\N	\N	\N	\N	149436	149436	316756
19647	27604	9	applied	\N	\N	\N	\N	149437	149437	316757
19647	27611	10	applied	\N	\N	\N	\N	149438	149438	316758
19647	27612	11	applied	\N	\N	\N	\N	149439	149439	316759
19647	27618	12	applied	\N	\N	\N	\N	149440	149440	316760
19647	27621	13	applied	\N	\N	\N	\N	149441	149441	316761
19647	27622	14	applied	\N	\N	\N	\N	149442	149442	316762
19647	27628	15	applied	\N	\N	\N	\N	149443	149443	316763
19647	27629	16	applied	\N	\N	\N	\N	149444	149444	316764
19647	27630	17	applied	\N	\N	\N	\N	149445	149445	316765
19553	27470	1	applied	\N	\N	\N	\N	148638	148638	315958
19553	27471	2	applied	\N	\N	\N	\N	148639	148639	315959
19557	27441	17	applied	\N	\N	\N	\N	148668	148668	315988
19557	27450	18	applied	\N	\N	\N	\N	148669	148669	315989
19557	27451	19	applied	\N	\N	\N	\N	148670	148670	315990
19557	27452	20	applied	\N	\N	\N	\N	148671	148671	315991
19557	27454	21	applied	\N	\N	\N	\N	148672	148672	315992
19557	27458	22	applied	\N	\N	\N	\N	148673	148673	315993
19557	27459	23	applied	\N	\N	\N	\N	148674	148674	315994
19557	27466	24	applied	\N	\N	\N	\N	148675	148675	315995
19557	27467	25	applied	\N	\N	\N	\N	148676	148676	315996
19557	27472	26	applied	\N	\N	\N	\N	148677	148677	315997
19557	27447	27	applied	\N	\N	\N	\N	148678	148678	315998
19557	27449	29	applied	\N	\N	\N	\N	148680	148680	316000
19557	27455	30	applied	\N	\N	\N	\N	148681	148681	316001
19557	27460	31	applied	\N	\N	\N	\N	148682	148682	316002
19557	27470	32	applied	\N	\N	\N	\N	148683	148683	316003
19557	27461	33	applied	\N	\N	\N	\N	148684	148684	316004
19557	27462	34	applied	\N	\N	\N	\N	148685	148685	316005
19557	27465	35	applied	\N	\N	\N	\N	148686	148686	316006
19557	27468	36	applied	\N	\N	\N	\N	148687	148687	316007
19557	27471	37	applied	\N	\N	\N	\N	148688	148688	316008
19558	27473	0	applied	\N	\N	\N	\N	148689	148689	316009
19558	27474	1	applied	\N	\N	\N	\N	148690	148690	316010
19558	27472	2	applied	\N	\N	\N	\N	148691	148691	316011
19558	27475	3	applied	\N	\N	\N	\N	148692	148692	316012
19560	27476	0	applied	\N	\N	\N	\N	148695	148695	316015
19560	27477	1	applied	\N	\N	\N	\N	148696	148696	316016
19562	27482	0	applied	\N	\N	\N	\N	148701	148701	316021
19562	27484	2	applied	\N	\N	\N	\N	148703	148703	316023
19562	27485	3	applied	\N	\N	\N	\N	148704	148704	316024
19563	27486	0	applied	\N	\N	\N	\N	148705	148705	316025
19563	27487	1	applied	\N	\N	\N	\N	148706	148706	316026
19563	27488	2	applied	\N	\N	\N	\N	148707	148707	316027
19564	27489	0	applied	\N	\N	\N	\N	148708	148708	316028
19564	27490	1	applied	\N	\N	\N	\N	148709	148709	316029
19564	27491	2	applied	\N	\N	\N	\N	148710	148710	316030
19565	27492	0	applied	\N	\N	\N	\N	148711	148711	316031
19565	27493	1	applied	\N	\N	\N	\N	148712	148712	316032
19565	27494	2	applied	\N	\N	\N	\N	148713	148713	316033
19566	27492	0	applied	\N	\N	\N	\N	148714	148714	316034
19566	27493	1	applied	\N	\N	\N	\N	148715	148715	316035
19566	27495	2	applied	\N	\N	\N	\N	148716	148716	316036
19566	27494	3	applied	\N	\N	\N	\N	148717	148717	316037
19567	27496	0	applied	\N	\N	\N	\N	148718	148718	316038
19567	27498	2	applied	\N	\N	\N	\N	148720	148720	316040
19568	27202	0	applied	\N	\N	1000000000	\N	148721	148721	316041
19568	27191	1	applied	\N	\N	\N	\N	148722	148722	316042
19568	27359	2	applied	\N	\N	1000000000	\N	148723	148723	316043
19568	27195	3	applied	\N	\N	\N	\N	148724	148724	316044
19568	27203	4	applied	\N	\N	\N	\N	148725	148725	316045
19568	27199	5	applied	\N	\N	\N	\N	148726	148726	316046
19568	27196	6	applied	\N	\N	1000000000	\N	148727	148727	316047
19568	27204	7	applied	\N	\N	\N	\N	148728	148728	316048
19568	27205	8	applied	\N	\N	\N	\N	148729	148729	316049
19568	27212	9	applied	\N	\N	\N	\N	148730	148730	316050
19568	27215	10	applied	\N	\N	\N	\N	148731	148731	316051
19568	27216	11	applied	\N	\N	\N	\N	148732	148732	316052
19568	27223	12	applied	\N	\N	\N	\N	148733	148733	316053
19568	27226	13	applied	\N	\N	\N	\N	148734	148734	316054
19568	27227	14	applied	\N	\N	\N	\N	148735	148735	316055
19568	27229	16	applied	\N	\N	\N	\N	148737	148737	316057
19568	27230	17	applied	\N	\N	\N	\N	148738	148738	316058
19568	27244	18	applied	\N	\N	\N	\N	148739	148739	316059
19568	27248	19	applied	\N	\N	\N	\N	148740	148740	316060
19568	27252	20	applied	\N	\N	\N	\N	148741	148741	316061
19568	27255	21	applied	\N	\N	\N	\N	148742	148742	316062
19568	27256	22	applied	\N	\N	\N	\N	148743	148743	316063
19568	27262	23	applied	\N	\N	\N	\N	148744	148744	316064
19568	27265	24	applied	\N	\N	\N	\N	148745	148745	316065
19568	27266	25	applied	\N	\N	\N	\N	148746	148746	316066
19568	27272	26	applied	\N	\N	\N	\N	148747	148747	316067
19568	27275	27	applied	\N	\N	\N	\N	148748	148748	316068
19568	27278	28	applied	\N	\N	\N	\N	148749	148749	316069
19568	27282	29	applied	\N	\N	\N	\N	148750	148750	316070
19568	27283	30	applied	\N	\N	\N	\N	148751	148751	316071
19568	27284	31	applied	\N	\N	\N	\N	148752	148752	316072
19568	27295	33	applied	\N	\N	\N	\N	148754	148754	316074
19568	27297	34	applied	\N	\N	\N	\N	148755	148755	316075
19568	27301	35	applied	\N	\N	\N	\N	148756	148756	316076
19568	27304	36	applied	\N	\N	\N	\N	148757	148757	316077
19568	27305	37	applied	\N	\N	\N	\N	148758	148758	316078
19568	27306	38	applied	\N	\N	\N	\N	148759	148759	316079
19568	27315	39	applied	\N	\N	\N	\N	148760	148760	316080
19568	27318	40	applied	\N	\N	\N	\N	148761	148761	316081
19568	27321	41	applied	\N	\N	\N	\N	148762	148762	316082
19568	27325	42	applied	\N	\N	\N	\N	148763	148763	316083
19568	27328	43	applied	\N	\N	\N	\N	148764	148764	316084
19568	27335	44	applied	\N	\N	\N	\N	148765	148765	316085
19568	27340	45	applied	\N	\N	\N	\N	148766	148766	316086
19568	27341	46	applied	\N	\N	\N	\N	148767	148767	316087
19568	27348	47	applied	\N	\N	\N	\N	148768	148768	316088
19568	27352	48	applied	\N	\N	\N	\N	148769	148769	316089
19568	27360	50	applied	\N	\N	\N	\N	148771	148771	316091
19568	27364	51	applied	\N	\N	\N	\N	148772	148772	316092
19568	27367	52	applied	\N	\N	\N	\N	148773	148773	316093
19568	27368	53	applied	\N	\N	\N	\N	148774	148774	316094
19568	27369	54	applied	\N	\N	\N	\N	148775	148775	316095
19568	27377	55	applied	\N	\N	\N	\N	148776	148776	316096
19568	27380	56	applied	\N	\N	\N	\N	148777	148777	316097
19568	27383	57	applied	\N	\N	\N	\N	148778	148778	316098
19568	27387	58	applied	\N	\N	\N	\N	148779	148779	316099
19568	27388	59	applied	\N	\N	\N	\N	148780	148780	316100
19568	27393	60	applied	\N	\N	\N	\N	148781	148781	316101
19568	27397	61	applied	\N	\N	\N	\N	148782	148782	316102
19568	27400	62	applied	\N	\N	\N	\N	148783	148783	316103
19568	27403	63	applied	\N	\N	\N	\N	148784	148784	316104
19568	27407	64	applied	\N	\N	\N	\N	148785	148785	316105
19568	27410	65	applied	\N	\N	\N	\N	148786	148786	316106
19568	27416	67	applied	\N	\N	\N	\N	148788	148788	316108
19568	27420	68	applied	\N	\N	\N	\N	148789	148789	316109
19557	27446	15	applied	\N	\N	\N	\N	148666	148666	315986
19557	27439	16	applied	\N	\N	\N	\N	148667	148667	315987
19568	27433	72	applied	\N	\N	\N	\N	148793	148793	316113
19568	27436	73	applied	\N	\N	\N	\N	148794	148794	316114
19568	27440	74	applied	\N	\N	\N	\N	148795	148795	316115
19568	27443	75	applied	\N	\N	\N	\N	148796	148796	316116
19568	27444	76	applied	\N	\N	\N	\N	148797	148797	316117
19568	27445	77	applied	\N	\N	\N	\N	148798	148798	316118
19568	27453	78	applied	\N	\N	\N	\N	148799	148799	316119
19568	27456	79	applied	\N	\N	\N	\N	148800	148800	316120
19568	27457	80	applied	\N	\N	\N	\N	148801	148801	316121
19568	27464	82	applied	\N	\N	\N	\N	148803	148803	316123
19568	27469	83	applied	\N	\N	\N	\N	148804	148804	316124
19568	27473	84	applied	\N	\N	\N	\N	148805	148805	316125
19568	27476	85	applied	\N	\N	\N	\N	148806	148806	316126
19568	27478	87	applied	\N	\N	\N	\N	148807	148807	316127
19568	27482	88	applied	\N	\N	\N	\N	148808	148808	316128
19568	27486	89	applied	\N	\N	\N	\N	148809	148809	316129
19568	27489	90	applied	\N	\N	\N	\N	148810	148810	316130
19568	27492	91	applied	\N	\N	\N	\N	148811	148811	316131
19568	27496	92	applied	\N	\N	\N	\N	148812	148812	316132
19568	27329	93	applied	\N	\N	\N	\N	148813	148813	316133
19568	27192	94	applied	\N	\N	\N	\N	148814	148814	316134
19568	27193	95	applied	\N	\N	\N	\N	148815	148815	316135
19568	27207	96	applied	\N	\N	\N	\N	148816	148816	316136
19568	27221	97	applied	\N	\N	\N	\N	148817	148817	316137
19568	27232	98	applied	\N	\N	\N	\N	148818	148818	316138
19568	27206	100	applied	\N	\N	\N	\N	148820	148820	316140
19568	27218	101	applied	\N	\N	\N	\N	148821	148821	316141
19568	27231	102	applied	\N	\N	\N	\N	148822	148822	316142
19568	27246	103	applied	\N	\N	\N	\N	148823	148823	316143
19568	27257	104	applied	\N	\N	\N	\N	148824	148824	316144
19568	27234	105	applied	\N	\N	1000000000	\N	148825	148825	316145
19568	27307	106	applied	\N	\N	1000000000	\N	148826	148826	316146
19568	27331	107	applied	\N	\N	1000000000	\N	148827	148827	316147
19568	27332	108	applied	\N	\N	1000000000	\N	148828	148828	316148
19568	27333	109	applied	\N	\N	\N	\N	148829	148829	316149
19568	27344	110	applied	\N	\N	\N	\N	148830	148830	316150
19568	27197	111	applied	\N	\N	\N	\N	148831	148831	316151
19568	27200	112	applied	\N	\N	\N	\N	148832	148832	316152
19568	27208	113	applied	\N	\N	\N	\N	148833	148833	316153
19568	27339	114	applied	\N	\N	\N	\N	148834	148834	316154
19568	27198	115	applied	\N	\N	\N	\N	148835	148835	316155
19568	27209	117	applied	\N	\N	\N	\N	148837	148837	316157
19568	27214	118	applied	\N	\N	\N	\N	148838	148838	316158
19568	27217	119	applied	\N	\N	\N	\N	148839	148839	316159
19568	27222	120	applied	\N	\N	\N	\N	148840	148840	316160
19568	27224	121	applied	\N	\N	\N	\N	148841	148841	316161
19568	27233	122	applied	\N	\N	\N	\N	148842	148842	316162
19568	27210	123	applied	\N	\N	\N	\N	148843	148843	316163
19568	27211	124	applied	\N	\N	\N	\N	148844	148844	316164
19568	27213	125	applied	\N	\N	\N	\N	148845	148845	316165
19570	27498	0	applied	\N	\N	\N	\N	148849	148849	316169
19572	27496	0	applied	\N	\N	\N	\N	148854	148854	316174
19572	27499	1	applied	\N	\N	\N	\N	148855	148855	316175
19572	27497	2	applied	\N	\N	\N	\N	148856	148856	316176
19572	27500	3	applied	\N	\N	\N	\N	148857	148857	316177
19574	27500	0	applied	\N	\N	\N	\N	148860	148860	316180
19576	27504	0	applied	\N	\N	\N	\N	148865	148865	316185
19576	27506	2	applied	\N	\N	\N	\N	148867	148867	316187
19576	27507	3	applied	\N	\N	\N	\N	148868	148868	316188
19577	27508	0	applied	\N	\N	\N	\N	148869	148869	316189
19577	27509	1	applied	\N	\N	\N	\N	148870	148870	316190
19577	27510	2	applied	\N	\N	\N	\N	148871	148871	316191
19577	27511	3	applied	\N	\N	\N	\N	148872	148872	316192
19579	27518	0	applied	\N	\N	\N	\N	148879	148879	316199
19580	27519	0	applied	\N	\N	\N	\N	148880	148880	316200
19580	27518	1	applied	\N	\N	\N	\N	148881	148881	316201
19581	27520	0	applied	\N	\N	\N	\N	148882	148882	316202
19581	27521	1	applied	\N	\N	\N	\N	148883	148883	316203
19581	27522	2	applied	\N	\N	\N	\N	148884	148884	316204
19582	27520	0	applied	\N	\N	\N	\N	148885	148885	316205
19582	27521	1	applied	\N	\N	\N	\N	148886	148886	316206
19582	27522	2	applied	\N	\N	\N	\N	148887	148887	316207
19584	27523	0	applied	\N	\N	\N	\N	148892	148892	316212
19584	27525	2	applied	\N	\N	\N	\N	148894	148894	316214
19584	27526	3	applied	\N	\N	\N	\N	148895	148895	316215
19585	27523	0	applied	\N	\N	\N	\N	148896	148896	316216
19585	27524	1	applied	\N	\N	\N	\N	148897	148897	316217
19585	27525	2	applied	\N	\N	\N	\N	148898	148898	316218
19585	27526	3	applied	\N	\N	\N	\N	148899	148899	316219
19586	27527	0	applied	\N	\N	\N	\N	148900	148900	316220
19586	27528	1	applied	\N	\N	\N	\N	148901	148901	316221
19586	27529	2	applied	\N	\N	\N	\N	148902	148902	316222
19590	27527	0	applied	\N	\N	\N	\N	148909	148909	316229
19590	27528	1	applied	\N	\N	\N	\N	148910	148910	316230
19590	27529	2	applied	\N	\N	\N	\N	148911	148911	316231
19597	27540	0	applied	\N	\N	\N	\N	148928	148928	316248
19597	27541	1	applied	\N	\N	\N	\N	148929	148929	316249
19597	27542	2	applied	\N	\N	\N	\N	148930	148930	316250
19598	27550	0	applied	\N	\N	\N	\N	148938	148938	316258
19598	27552	2	applied	\N	\N	\N	\N	148940	148940	316260
19601	27553	0	applied	\N	\N	\N	\N	148951	148951	316271
19601	27554	1	applied	\N	\N	\N	\N	148952	148952	316272
19601	27555	2	applied	\N	\N	\N	\N	148953	148953	316273
19601	27556	3	applied	\N	\N	\N	\N	148954	148954	316274
19601	27557	4	applied	\N	\N	\N	\N	148955	148955	316275
19601	27558	5	applied	\N	\N	\N	\N	148956	148956	316276
19601	27559	6	applied	\N	\N	\N	\N	148957	148957	316277
19603	27563	0	applied	\N	\N	\N	\N	148961	148961	316281
19603	27564	1	applied	\N	\N	\N	\N	148962	148962	316282
19603	27565	2	applied	\N	\N	\N	\N	148963	148963	316283
19606	27566	0	applied	\N	\N	\N	\N	148970	148970	316290
19606	27567	1	applied	\N	\N	\N	\N	148971	148971	316291
19606	27568	2	applied	\N	\N	\N	\N	148972	148972	316292
19610	27576	0	applied	\N	\N	\N	\N	149010	149010	316330
19610	27577	1	applied	\N	\N	\N	\N	149011	149011	316331
19621	27611	0	applied	\N	\N	\N	\N	149213	149213	316533
19621	27612	1	applied	\N	\N	\N	\N	149214	149214	316534
19621	27613	2	applied	\N	\N	\N	\N	149215	149215	316535
19621	27614	3	applied	\N	\N	\N	\N	149216	149216	316536
19568	27424	70	applied	\N	\N	\N	\N	148791	148791	316111
19568	27430	71	applied	\N	\N	\N	\N	148792	148792	316112
19571	27500	3	applied	\N	\N	\N	\N	148853	148853	316173
19573	27499	0	applied	\N	\N	\N	\N	148858	148858	316178
19573	27500	1	applied	\N	\N	\N	\N	148859	148859	316179
19575	27499	0	applied	\N	\N	\N	\N	148861	148861	316181
19575	27501	1	applied	\N	\N	\N	\N	148862	148862	316182
19575	27502	2	applied	\N	\N	\N	\N	148863	148863	316183
19575	27503	3	applied	\N	\N	\N	\N	148864	148864	316184
19578	27512	0	applied	\N	\N	\N	\N	148873	148873	316193
19578	27513	1	applied	\N	\N	\N	\N	148874	148874	316194
19578	27514	2	applied	\N	\N	\N	\N	148875	148875	316195
19578	27515	3	applied	\N	\N	\N	\N	148876	148876	316196
19578	27517	6	applied	\N	\N	\N	\N	148878	148878	316198
19583	27523	0	applied	\N	\N	\N	\N	148888	148888	316208
19583	27524	1	applied	\N	\N	\N	\N	148889	148889	316209
19583	27525	2	applied	\N	\N	\N	\N	148890	148890	316210
19583	27526	3	applied	\N	\N	\N	\N	148891	148891	316211
19588	27527	0	applied	\N	\N	\N	\N	148906	148906	316226
19588	27528	1	applied	\N	\N	\N	\N	148907	148907	316227
19588	27529	2	applied	\N	\N	\N	\N	148908	148908	316228
19592	27530	0	applied	\N	\N	\N	\N	148915	148915	316235
19597	27543	3	applied	\N	\N	\N	\N	148931	148931	316251
19597	27544	4	applied	\N	\N	\N	\N	148932	148932	316252
19597	27545	5	applied	\N	\N	\N	\N	148933	148933	316253
19597	27546	6	applied	\N	\N	\N	\N	148934	148934	316254
19597	27547	7	applied	\N	\N	\N	\N	148935	148935	316255
19597	27548	8	applied	\N	\N	\N	\N	148936	148936	316256
19597	27549	9	applied	\N	\N	\N	\N	148937	148937	316257
19600	27554	1	applied	\N	\N	\N	\N	148945	148945	316265
19600	27555	2	applied	\N	\N	\N	\N	148946	148946	316266
19600	27556	3	applied	\N	\N	\N	\N	148947	148947	316267
19600	27557	4	applied	\N	\N	\N	\N	148948	148948	316268
19600	27558	5	applied	\N	\N	\N	\N	148949	148949	316269
19600	27559	6	applied	\N	\N	\N	\N	148950	148950	316270
19602	27560	0	applied	\N	\N	\N	\N	148958	148958	316278
19602	27561	1	applied	\N	\N	\N	\N	148959	148959	316279
19602	27562	2	applied	\N	\N	\N	\N	148960	148960	316280
19605	27566	0	applied	\N	\N	\N	\N	148967	148967	316287
19605	27567	1	applied	\N	\N	\N	\N	148968	148968	316288
19605	27568	2	applied	\N	\N	\N	\N	148969	148969	316289
19607	27202	0	applied	\N	\N	1000000000	\N	148973	148973	316293
19607	27359	1	applied	\N	\N	1000000000	\N	148974	148974	316294
19607	27203	2	applied	\N	\N	\N	\N	148975	148975	316295
19607	27329	4	applied	\N	\N	\N	\N	148977	148977	316297
19607	27207	5	applied	\N	\N	\N	\N	148978	148978	316298
19607	27221	6	applied	\N	\N	\N	\N	148979	148979	316299
19607	27232	7	applied	\N	\N	\N	\N	148980	148980	316300
19607	27344	8	applied	\N	\N	\N	\N	148981	148981	316301
19607	27135	9	applied	\N	\N	\N	\N	148982	148982	316302
19607	27142	10	applied	\N	\N	\N	\N	148983	148983	316303
19613	27586	0	applied	\N	\N	\N	\N	149027	149027	316347
19613	27587	1	applied	\N	\N	\N	\N	149028	149028	316348
19613	27588	2	applied	\N	\N	\N	\N	149029	149029	316349
19613	27589	3	applied	\N	\N	\N	\N	149030	149030	316350
19613	27590	4	applied	\N	\N	\N	\N	149031	149031	316351
19613	27591	5	applied	\N	\N	\N	\N	149032	149032	316352
19613	27592	6	applied	\N	\N	\N	\N	149033	149033	316353
19616	27593	0	applied	\N	\N	\N	\N	149052	149052	316372
19616	27594	1	applied	\N	\N	\N	\N	149053	149053	316373
19616	27595	2	applied	\N	\N	\N	\N	149054	149054	316374
19616	27596	3	applied	\N	\N	\N	\N	149055	149055	316375
19616	27597	4	applied	\N	\N	\N	\N	149056	149056	316376
19616	27599	6	applied	\N	\N	\N	\N	149058	149058	316378
19616	27600	7	applied	\N	\N	\N	\N	149059	149059	316379
19616	27601	8	applied	\N	\N	\N	\N	149060	149060	316380
19619	27602	0	applied	\N	\N	\N	\N	149079	149079	316399
19619	27603	1	applied	\N	\N	\N	\N	149080	149080	316400
19619	27604	2	applied	\N	\N	\N	\N	149081	149081	316401
19619	27605	4	applied	\N	\N	\N	\N	149082	149082	316402
19619	27606	5	applied	\N	\N	\N	\N	149083	149083	316403
19619	27607	6	applied	\N	\N	\N	\N	149084	149084	316404
19619	27608	7	applied	\N	\N	\N	\N	149085	149085	316405
19619	27609	8	applied	\N	\N	\N	\N	149086	149086	316406
19619	27610	9	applied	\N	\N	\N	\N	149087	149087	316407
19620	27473	0	applied	\N	\N	\N	\N	149088	149088	316408
19620	27476	1	applied	\N	\N	\N	\N	149089	149089	316409
19620	27478	2	applied	\N	\N	\N	\N	149090	149090	316410
19620	27482	3	applied	\N	\N	\N	\N	149091	149091	316411
19620	27489	5	applied	\N	\N	\N	\N	149093	149093	316413
19620	27492	6	applied	\N	\N	\N	\N	149094	149094	316414
19620	27496	7	applied	\N	\N	\N	\N	149095	149095	316415
19620	27499	8	applied	\N	\N	\N	\N	149096	149096	316416
19620	27501	9	applied	\N	\N	\N	\N	149097	149097	316417
19620	27504	10	applied	\N	\N	\N	\N	149098	149098	316418
19620	27508	11	applied	\N	\N	\N	\N	149099	149099	316419
19620	27509	12	applied	\N	\N	\N	\N	149100	149100	316420
19620	27512	13	applied	\N	\N	\N	\N	149101	149101	316421
19620	27520	14	applied	\N	\N	\N	\N	149102	149102	316422
19620	27523	15	applied	\N	\N	\N	\N	149103	149103	316423
19620	27527	16	applied	\N	\N	\N	\N	149104	149104	316424
19620	27530	17	applied	\N	\N	\N	\N	149105	149105	316425
19620	27533	18	applied	\N	\N	\N	\N	149106	149106	316426
19620	27536	19	applied	\N	\N	\N	\N	149107	149107	316427
19620	27540	20	applied	\N	\N	\N	\N	149108	149108	316428
19620	27542	22	applied	\N	\N	\N	\N	149110	149110	316430
19620	27550	23	applied	\N	\N	\N	\N	149111	149111	316431
19620	27553	24	applied	\N	\N	\N	\N	149112	149112	316432
19620	27554	25	applied	\N	\N	\N	\N	149113	149113	316433
19620	27560	26	applied	\N	\N	\N	\N	149114	149114	316434
19620	27563	27	applied	\N	\N	\N	\N	149115	149115	316435
19620	27566	28	applied	\N	\N	\N	\N	149116	149116	316436
19620	27569	29	applied	\N	\N	\N	\N	149117	149117	316437
19620	27570	30	applied	\N	\N	\N	\N	149118	149118	316438
19620	27576	31	applied	\N	\N	\N	\N	149119	149119	316439
19620	27579	32	applied	\N	\N	\N	\N	149120	149120	316440
19620	27580	33	applied	\N	\N	\N	\N	149121	149121	316441
19620	27586	34	applied	\N	\N	\N	\N	149122	149122	316442
19620	27587	35	applied	\N	\N	\N	\N	149123	149123	316443
19620	27593	36	applied	\N	\N	\N	\N	149124	149124	316444
19620	27594	37	applied	\N	\N	\N	\N	149125	149125	316445
19571	27499	1	applied	\N	\N	\N	\N	148851	148851	316171
19571	27497	2	applied	\N	\N	\N	\N	148852	148852	316172
19594	27532	2	applied	\N	\N	\N	\N	148920	148920	316240
19596	27536	0	applied	\N	\N	\N	\N	148924	148924	316244
19596	27537	1	applied	\N	\N	\N	\N	148925	148925	316245
19596	27538	2	applied	\N	\N	\N	\N	148926	148926	316246
19596	27539	3	applied	\N	\N	\N	\N	148927	148927	316247
19604	27566	0	applied	\N	\N	\N	\N	148964	148964	316284
19604	27567	1	applied	\N	\N	\N	\N	148965	148965	316285
19604	27568	2	applied	\N	\N	\N	\N	148966	148966	316286
19609	27202	0	applied	\N	\N	1000000000	\N	148991	148991	316311
19609	27359	1	applied	\N	\N	1000000000	\N	148992	148992	316312
19609	27123	2	applied	\N	\N	1000000000	\N	148993	148993	316313
19609	27203	3	applied	\N	\N	\N	\N	148994	148994	316314
19609	27196	4	applied	\N	\N	1000000000	\N	148995	148995	316315
19609	27329	6	applied	\N	\N	\N	\N	148997	148997	316317
19609	27207	7	applied	\N	\N	\N	\N	148998	148998	316318
19609	27221	8	applied	\N	\N	\N	\N	148999	148999	316319
19609	27232	9	applied	\N	\N	\N	\N	149000	149000	316320
19609	27234	10	applied	\N	\N	1000000000	\N	149001	149001	316321
19609	27307	11	applied	\N	\N	1000000000	\N	149002	149002	316322
19609	27331	12	applied	\N	\N	1000000000	\N	149003	149003	316323
19609	27332	13	applied	\N	\N	1000000000	\N	149004	149004	316324
19609	27333	14	applied	\N	\N	\N	\N	149005	149005	316325
19609	27344	15	applied	\N	\N	\N	\N	149006	149006	316326
19609	27339	16	applied	\N	\N	\N	\N	149007	149007	316327
19609	27135	17	applied	\N	\N	\N	\N	149008	149008	316328
19609	27142	18	applied	\N	\N	\N	\N	149009	149009	316329
19612	27586	0	applied	\N	\N	\N	\N	149020	149020	316340
19612	27587	1	applied	\N	\N	\N	\N	149021	149021	316341
19612	27588	2	applied	\N	\N	\N	\N	149022	149022	316342
19612	27589	3	applied	\N	\N	\N	\N	149023	149023	316343
19612	27590	4	applied	\N	\N	\N	\N	149024	149024	316344
19612	27591	5	applied	\N	\N	\N	\N	149025	149025	316345
19612	27592	6	applied	\N	\N	\N	\N	149026	149026	316346
19615	27594	1	applied	\N	\N	\N	\N	149044	149044	316364
19615	27595	2	applied	\N	\N	\N	\N	149045	149045	316365
19615	27596	3	applied	\N	\N	\N	\N	149046	149046	316366
19615	27597	4	applied	\N	\N	\N	\N	149047	149047	316367
19615	27598	5	applied	\N	\N	\N	\N	149048	149048	316368
19615	27599	6	applied	\N	\N	\N	\N	149049	149049	316369
19615	27600	7	applied	\N	\N	\N	\N	149050	149050	316370
19615	27601	8	applied	\N	\N	\N	\N	149051	149051	316371
19618	27602	0	applied	\N	\N	\N	\N	149070	149070	316390
19618	27603	1	applied	\N	\N	\N	\N	149071	149071	316391
19618	27604	2	applied	\N	\N	\N	\N	149072	149072	316392
19618	27605	4	applied	\N	\N	\N	\N	149073	149073	316393
19618	27606	5	applied	\N	\N	\N	\N	149074	149074	316394
19618	27607	6	applied	\N	\N	\N	\N	149075	149075	316395
19618	27608	7	applied	\N	\N	\N	\N	149076	149076	316396
19618	27609	8	applied	\N	\N	\N	\N	149077	149077	316397
19620	27602	39	applied	\N	\N	\N	\N	149127	149127	316447
19620	27603	40	applied	\N	\N	\N	\N	149128	149128	316448
19620	27604	41	applied	\N	\N	\N	\N	149129	149129	316449
19620	27474	42	applied	\N	\N	\N	\N	149130	149130	316450
19620	27477	43	applied	\N	\N	\N	\N	149131	149131	316451
19620	27479	44	applied	\N	\N	\N	\N	149132	149132	316452
19620	27483	45	applied	\N	\N	\N	\N	149133	149133	316453
19620	27475	46	applied	\N	\N	\N	\N	149134	149134	316454
19620	27488	47	applied	\N	\N	\N	\N	149135	149135	316455
19620	27490	48	applied	\N	\N	\N	\N	149136	149136	316456
19620	27493	49	applied	\N	\N	\N	\N	149137	149137	316457
19620	27497	50	applied	\N	\N	\N	\N	149138	149138	316458
19620	27503	51	applied	\N	\N	\N	\N	149139	149139	316459
19620	27480	52	applied	\N	\N	\N	\N	149140	149140	316460
19620	27481	53	applied	\N	\N	\N	\N	149141	149141	316461
19620	27484	54	applied	\N	\N	\N	\N	149142	149142	316462
19620	27507	56	applied	\N	\N	\N	\N	149144	149144	316464
19620	27510	57	applied	\N	\N	\N	\N	149145	149145	316465
19620	27511	58	applied	\N	\N	\N	\N	149146	149146	316466
19620	27513	59	applied	\N	\N	\N	\N	149147	149147	316467
19620	27518	60	applied	\N	\N	\N	\N	149148	149148	316468
19620	27485	61	applied	\N	\N	\N	\N	149149	149149	316469
19620	27494	62	applied	\N	\N	\N	\N	149150	149150	316470
19626	27628	0	applied	\N	\N	\N	\N	149250	149250	316570
19626	27629	1	applied	\N	\N	\N	\N	149251	149251	316571
19626	27630	2	applied	\N	\N	\N	\N	149252	149252	316572
19626	27631	3	applied	\N	\N	\N	\N	149253	149253	316573
19626	27632	4	applied	\N	\N	\N	\N	149254	149254	316574
19626	27633	5	applied	\N	\N	\N	\N	149255	149255	316575
19626	27634	6	applied	\N	\N	\N	\N	149256	149256	316576
19626	27635	7	applied	\N	\N	\N	\N	149257	149257	316577
19626	27636	8	applied	\N	\N	\N	\N	149258	149258	316578
19626	27638	10	applied	\N	\N	\N	\N	149260	149260	316580
19626	27639	11	applied	\N	\N	\N	\N	149261	149261	316581
19626	27640	12	applied	\N	\N	\N	\N	149262	149262	316582
19628	27641	0	applied	\N	\N	\N	\N	149276	149276	316596
19628	27642	1	applied	\N	\N	\N	\N	149277	149277	316597
19628	27643	2	applied	\N	\N	\N	\N	149278	149278	316598
19628	27644	3	applied	\N	\N	\N	\N	149279	149279	316599
19628	27645	4	applied	\N	\N	\N	\N	149280	149280	316600
19628	27646	5	applied	\N	\N	\N	\N	149281	149281	316601
19628	27647	6	applied	\N	\N	\N	\N	149282	149282	316602
19631	27654	0	applied	\N	\N	\N	\N	149289	149289	316609
19631	27655	1	applied	\N	\N	\N	\N	149290	149290	316610
19631	27656	2	applied	\N	\N	\N	\N	149291	149291	316611
19631	27657	3	applied	\N	\N	\N	\N	149292	149292	316612
19631	27658	4	applied	\N	\N	\N	\N	149293	149293	316613
19631	27659	5	applied	\N	\N	\N	\N	149294	149294	316614
19633	27593	0	applied	\N	\N	\N	\N	149303	149303	316623
19633	27594	1	applied	\N	\N	\N	\N	149304	149304	316624
19633	27595	2	applied	\N	\N	\N	\N	149305	149305	316625
19633	27602	3	applied	\N	\N	\N	\N	149306	149306	316626
19633	27603	4	applied	\N	\N	\N	\N	149307	149307	316627
19633	27604	5	applied	\N	\N	\N	\N	149308	149308	316628
19633	27611	6	applied	\N	\N	\N	\N	149309	149309	316629
19633	27612	7	applied	\N	\N	\N	\N	149310	149310	316630
19633	27618	8	applied	\N	\N	\N	\N	149311	149311	316631
19633	27621	9	applied	\N	\N	\N	\N	149312	149312	316632
19633	27622	10	applied	\N	\N	\N	\N	149313	149313	316633
19633	27628	11	applied	\N	\N	\N	\N	149314	149314	316634
19592	27532	2	applied	\N	\N	\N	\N	148917	148917	316237
19594	27531	1	applied	\N	\N	\N	\N	148919	148919	316239
19620	27544	67	applied	\N	\N	\N	\N	149155	149155	316475
19620	27555	68	applied	\N	\N	\N	\N	149156	149156	316476
19620	27571	69	applied	\N	\N	\N	\N	149157	149157	316477
19620	27522	70	applied	\N	\N	\N	\N	149158	149158	316478
19620	27526	71	applied	\N	\N	\N	\N	149159	149159	316479
19620	27528	72	applied	\N	\N	\N	\N	149160	149160	316480
19620	27532	73	applied	\N	\N	\N	\N	149161	149161	316481
19620	27534	74	applied	\N	\N	\N	\N	149162	149162	316482
19620	27537	75	applied	\N	\N	\N	\N	149163	149163	316483
19620	27545	76	applied	\N	\N	\N	\N	149164	149164	316484
19620	27546	77	applied	\N	\N	\N	\N	149165	149165	316485
19620	27547	78	applied	\N	\N	\N	\N	149166	149166	316486
19620	27552	79	applied	\N	\N	\N	\N	149167	149167	316487
19620	27556	80	applied	\N	\N	\N	\N	149168	149168	316488
19620	27557	81	applied	\N	\N	\N	\N	149169	149169	316489
19620	27561	82	applied	\N	\N	\N	\N	149170	149170	316490
19620	27567	84	applied	\N	\N	\N	\N	149172	149172	316492
19620	27572	85	applied	\N	\N	\N	\N	149173	149173	316493
19620	27573	86	applied	\N	\N	\N	\N	149174	149174	316494
19620	27577	87	applied	\N	\N	\N	\N	149175	149175	316495
19620	27581	88	applied	\N	\N	\N	\N	149176	149176	316496
19620	27583	89	applied	\N	\N	\N	\N	149177	149177	316497
19620	27588	90	applied	\N	\N	\N	\N	149178	149178	316498
19620	27590	91	applied	\N	\N	\N	\N	149179	149179	316499
19620	27597	92	applied	\N	\N	\N	\N	149180	149180	316500
19620	27598	93	applied	\N	\N	\N	\N	149181	149181	316501
19620	27599	94	applied	\N	\N	\N	\N	149182	149182	316502
19620	27607	96	applied	\N	\N	\N	\N	149183	149183	316503
19620	27608	97	applied	\N	\N	\N	\N	149184	149184	316504
19620	27585	98	applied	\N	\N	\N	\N	149185	149185	316505
19620	27589	99	applied	\N	\N	\N	\N	149186	149186	316506
19620	27609	100	applied	\N	\N	\N	\N	149187	149187	316507
19620	27495	102	applied	\N	\N	\N	\N	149189	149189	316509
19620	27498	103	applied	\N	\N	\N	\N	149190	149190	316510
19620	27500	104	applied	\N	\N	\N	\N	149191	149191	316511
19620	27502	105	applied	\N	\N	\N	\N	149192	149192	316512
19620	27506	106	applied	\N	\N	\N	\N	149193	149193	316513
19620	27515	107	applied	\N	\N	\N	\N	149194	149194	316514
19620	27516	108	applied	\N	\N	\N	\N	149195	149195	316515
19620	27517	109	applied	\N	\N	\N	\N	149196	149196	316516
19620	27519	110	applied	\N	\N	\N	\N	149197	149197	316517
19620	27521	111	applied	\N	\N	\N	\N	149198	149198	316518
19620	27525	112	applied	\N	\N	\N	\N	149199	149199	316519
19620	27529	113	applied	\N	\N	\N	\N	149200	149200	316520
19620	27531	114	applied	\N	\N	\N	\N	149201	149201	316521
19620	27535	115	applied	\N	\N	\N	\N	149202	149202	316522
19620	27539	116	applied	\N	\N	\N	\N	149203	149203	316523
19620	27543	117	applied	\N	\N	\N	\N	149204	149204	316524
19620	27549	119	applied	\N	\N	\N	\N	149206	149206	316526
19620	27551	120	applied	\N	\N	\N	\N	149207	149207	316527
19620	27558	121	applied	\N	\N	\N	\N	149208	149208	316528
19620	27559	122	applied	\N	\N	\N	\N	149209	149209	316529
19620	27562	123	applied	\N	\N	\N	\N	149210	149210	316530
19620	27564	124	applied	\N	\N	\N	\N	149211	149211	316531
19620	27568	125	applied	\N	\N	\N	\N	149212	149212	316532
19621	27615	4	applied	\N	\N	\N	\N	149217	149217	316537
19621	27616	5	applied	\N	\N	\N	\N	149218	149218	316538
19621	27617	6	applied	\N	\N	\N	\N	149219	149219	316539
19623	27618	0	applied	\N	\N	\N	\N	149227	149227	316547
19623	27619	1	applied	\N	\N	\N	\N	149228	149228	316548
19623	27620	2	applied	\N	\N	\N	\N	149229	149229	316549
19627	27628	0	applied	\N	\N	\N	\N	149263	149263	316583
19627	27629	1	applied	\N	\N	\N	\N	149264	149264	316584
19627	27630	2	applied	\N	\N	\N	\N	149265	149265	316585
19627	27632	4	applied	\N	\N	\N	\N	149267	149267	316587
19627	27633	5	applied	\N	\N	\N	\N	149268	149268	316588
19627	27634	6	applied	\N	\N	\N	\N	149269	149269	316589
19627	27635	7	applied	\N	\N	\N	\N	149270	149270	316590
19627	27636	8	applied	\N	\N	\N	\N	149271	149271	316591
19627	27637	9	applied	\N	\N	\N	\N	149272	149272	316592
19627	27638	10	applied	\N	\N	\N	\N	149273	149273	316593
19627	27639	11	applied	\N	\N	\N	\N	149274	149274	316594
19627	27640	12	applied	\N	\N	\N	\N	149275	149275	316595
19629	27648	0	applied	\N	\N	\N	\N	149283	149283	316603
19629	27649	1	applied	\N	\N	\N	\N	149284	149284	316604
19629	27650	2	applied	\N	\N	\N	\N	149285	149285	316605
19632	27654	0	applied	\N	\N	\N	\N	149296	149296	316616
19632	27655	1	applied	\N	\N	\N	\N	149297	149297	316617
19632	27656	2	applied	\N	\N	\N	\N	149298	149298	316618
19632	27657	3	applied	\N	\N	\N	\N	149299	149299	316619
19632	27659	5	applied	\N	\N	\N	\N	149301	149301	316621
19632	27660	6	applied	\N	\N	\N	\N	149302	149302	316622
19634	27661	0	applied	\N	\N	\N	\N	149371	149371	316691
19634	27662	1	applied	\N	\N	\N	\N	149372	149372	316692
19634	27663	2	applied	\N	\N	\N	\N	149373	149373	316693
19635	27664	0	applied	\N	\N	\N	\N	149374	149374	316694
19635	27665	1	applied	\N	\N	\N	\N	149375	149375	316695
19635	27666	2	applied	\N	\N	\N	\N	149376	149376	316696
19635	27667	3	applied	\N	\N	\N	\N	149377	149377	316697
19635	27668	4	applied	\N	\N	\N	\N	149378	149378	316698
19635	27669	5	applied	\N	\N	\N	\N	149379	149379	316699
19635	27670	6	applied	\N	\N	\N	\N	149380	149380	316700
19637	27671	0	applied	\N	\N	\N	\N	149384	149384	316704
19637	27672	1	applied	\N	\N	\N	\N	149385	149385	316705
19637	27673	2	applied	\N	\N	\N	\N	149386	149386	316706
19638	27671	0	applied	\N	\N	\N	\N	149387	149387	316707
19638	27673	2	applied	\N	\N	\N	\N	149389	149389	316709
19640	27671	0	applied	\N	\N	\N	\N	149393	149393	316713
19640	27672	1	applied	\N	\N	\N	\N	149394	149394	316714
19640	27673	2	applied	\N	\N	\N	\N	149395	149395	316715
19641	27671	0	applied	\N	\N	\N	\N	149396	149396	316716
19641	27672	1	applied	\N	\N	\N	\N	149397	149397	316717
19641	27673	2	applied	\N	\N	\N	\N	149398	149398	316718
19643	27674	0	applied	\N	\N	\N	\N	149402	149402	316722
19643	27675	1	applied	\N	\N	\N	\N	149403	149403	316723
19646	27681	0	applied	\N	\N	\N	\N	149422	149422	316742
19646	27682	1	applied	\N	\N	\N	\N	149423	149423	316743
19646	27683	2	applied	\N	\N	\N	\N	149424	149424	316744
19646	27684	3	applied	\N	\N	\N	\N	149425	149425	316745
19646	27685	4	applied	\N	\N	\N	\N	149426	149426	316746
19620	27514	64	applied	\N	\N	\N	\N	149152	149152	316472
19620	27524	65	applied	\N	\N	\N	\N	149153	149153	316473
19633	27642	17	applied	\N	\N	\N	\N	149319	149319	316639
19633	27648	18	applied	\N	\N	\N	\N	149320	149320	316640
19633	27651	19	applied	\N	\N	\N	\N	149321	149321	316641
19633	27654	20	applied	\N	\N	\N	\N	149322	149322	316642
19633	27655	21	applied	\N	\N	\N	\N	149323	149323	316643
19633	27596	22	applied	\N	\N	\N	\N	149324	149324	316644
19633	27597	23	applied	\N	\N	\N	\N	149325	149325	316645
19633	27598	24	applied	\N	\N	\N	\N	149326	149326	316646
19633	27599	25	applied	\N	\N	\N	\N	149327	149327	316647
19633	27607	26	applied	\N	\N	\N	\N	149328	149328	316648
19633	27608	27	applied	\N	\N	\N	\N	149329	149329	316649
19633	27613	28	applied	\N	\N	\N	\N	149330	149330	316650
19633	27614	29	applied	\N	\N	\N	\N	149331	149331	316651
19633	27619	30	applied	\N	\N	\N	\N	149332	149332	316652
19633	27625	31	applied	\N	\N	\N	\N	149333	149333	316653
19633	27626	32	applied	\N	\N	\N	\N	149334	149334	316654
19633	27637	34	applied	\N	\N	\N	\N	149336	149336	316656
19633	27638	35	applied	\N	\N	\N	\N	149337	149337	316657
19633	27639	36	applied	\N	\N	\N	\N	149338	149338	316658
19646	27686	5	applied	\N	\N	\N	\N	149427	149427	316747
19649	27694	0	applied	\N	\N	\N	\N	149543	149543	316863
19649	27695	1	applied	\N	\N	\N	\N	149544	149544	316864
19649	27696	2	applied	\N	\N	\N	\N	149545	149545	316865
19651	27697	0	applied	\N	\N	\N	\N	149549	149549	316869
19651	27698	1	applied	\N	\N	\N	\N	149550	149550	316870
19651	27699	2	applied	\N	\N	\N	\N	149551	149551	316871
19654	27706	0	applied	\N	\N	\N	\N	149564	149564	316884
19654	27707	1	applied	\N	\N	\N	\N	149565	149565	316885
19654	27708	2	applied	\N	\N	\N	\N	149566	149566	316886
19659	27719	0	applied	\N	\N	\N	\N	149583	149583	316903
19659	27720	1	applied	\N	\N	\N	\N	149584	149584	316904
19659	27721	2	applied	\N	\N	\N	\N	149585	149585	316905
19664	27729	1	applied	\N	\N	\N	\N	149601	149601	316921
19664	27731	2	applied	\N	\N	\N	\N	149602	149602	316922
19666	27740	0	applied	\N	\N	\N	\N	149612	149612	316932
19666	27741	1	applied	\N	\N	\N	\N	149613	149613	316933
19666	27742	2	applied	\N	\N	\N	\N	149614	149614	316934
19666	27743	3	applied	\N	\N	\N	\N	149615	149615	316935
19666	27744	4	applied	\N	\N	\N	\N	149616	149616	316936
19666	27745	5	applied	\N	\N	\N	\N	149617	149617	316937
19666	27746	6	applied	\N	\N	\N	\N	149618	149618	316938
19666	27747	7	applied	\N	\N	\N	\N	149619	149619	316939
19666	27748	8	applied	\N	\N	\N	\N	149620	149620	316940
19666	27749	9	applied	\N	\N	\N	\N	149621	149621	316941
19671	27750	0	applied	\N	\N	\N	\N	149658	149658	316978
19671	27751	1	applied	\N	\N	\N	\N	149659	149659	316979
19671	27752	2	applied	\N	\N	\N	\N	149660	149660	316980
19671	27753	3	applied	\N	\N	\N	\N	149661	149661	316981
19671	27755	5	applied	\N	\N	\N	\N	149663	149663	316983
19671	27756	6	applied	\N	\N	\N	\N	149664	149664	316984
19671	27757	7	applied	\N	\N	\N	\N	149665	149665	316985
19673	27758	0	applied	\N	\N	\N	\N	149671	149671	316991
19673	27759	1	applied	\N	\N	\N	\N	149672	149672	316992
19673	27760	2	applied	\N	\N	\N	\N	149673	149673	316993
19673	27761	3	applied	\N	\N	\N	\N	149674	149674	316994
19673	27762	4	applied	\N	\N	\N	\N	149675	149675	316995
19673	27763	5	applied	\N	\N	\N	\N	149676	149676	316996
19673	27764	6	applied	\N	\N	\N	\N	149677	149677	316997
19673	27765	7	applied	\N	\N	\N	\N	149678	149678	316998
19673	27766	8	applied	\N	\N	\N	\N	149679	149679	316999
19673	27767	9	applied	\N	\N	\N	\N	149680	149680	317000
19673	27768	10	applied	\N	\N	\N	\N	149681	149681	317001
19673	27769	11	applied	\N	\N	\N	\N	149682	149682	317002
19673	27770	12	applied	\N	\N	\N	\N	149683	149683	317003
19673	27772	14	applied	\N	\N	\N	\N	149685	149685	317005
19673	27773	15	applied	\N	\N	\N	\N	149686	149686	317006
19673	27774	16	applied	\N	\N	\N	\N	149687	149687	317007
19673	27775	17	applied	\N	\N	\N	\N	149688	149688	317008
19676	27776	0	applied	\N	\N	\N	\N	149725	149725	317045
19676	27777	1	applied	\N	\N	\N	\N	149726	149726	317046
19676	27778	2	applied	\N	\N	\N	\N	149727	149727	317047
19676	27779	3	applied	\N	\N	\N	\N	149728	149728	317048
19676	27780	4	applied	\N	\N	\N	\N	149729	149729	317049
19676	27781	5	applied	\N	\N	\N	\N	149730	149730	317050
19676	27782	6	applied	\N	\N	\N	\N	149731	149731	317051
19676	27783	7	applied	\N	\N	\N	\N	149732	149732	317052
19676	27784	8	applied	\N	\N	\N	\N	149733	149733	317053
19676	27785	9	applied	\N	\N	\N	\N	149734	149734	317054
19676	27786	10	applied	\N	\N	\N	\N	149735	149735	317055
19676	27787	11	applied	\N	\N	\N	\N	149736	149736	317056
19676	27789	13	applied	\N	\N	\N	\N	149738	149738	317058
19676	27790	14	applied	\N	\N	\N	\N	149739	149739	317059
19676	27791	15	applied	\N	\N	\N	\N	149740	149740	317060
19676	27792	16	applied	\N	\N	\N	\N	149741	149741	317061
19676	27793	17	applied	\N	\N	\N	\N	149742	149742	317062
19682	27811	0	applied	\N	\N	\N	\N	149796	149796	317116
19682	27812	1	applied	\N	\N	\N	\N	149797	149797	317117
19682	27813	2	applied	\N	\N	\N	\N	149798	149798	317118
19682	27814	3	applied	\N	\N	\N	\N	149799	149799	317119
19682	27815	4	applied	\N	\N	\N	\N	149800	149800	317120
19682	27816	5	applied	\N	\N	\N	\N	149801	149801	317121
19682	27817	6	applied	\N	\N	\N	\N	149802	149802	317122
19682	27809	7	applied	\N	\N	\N	\N	149803	149803	317123
19682	27819	8	applied	\N	\N	\N	\N	149804	149804	317124
19684	27811	0	applied	\N	\N	\N	\N	149814	149814	317134
19684	27812	1	applied	\N	\N	\N	\N	149815	149815	317135
19684	27814	3	applied	\N	\N	\N	\N	149817	149817	317137
19684	27815	4	applied	\N	\N	\N	\N	149818	149818	317138
19684	27816	5	applied	\N	\N	\N	\N	149819	149819	317139
19684	27809	6	applied	\N	\N	\N	\N	149820	149820	317140
19684	27819	7	applied	\N	\N	\N	\N	149821	149821	317141
19689	27820	0	applied	\N	\N	\N	\N	149860	149860	317180
19689	27817	1	applied	\N	\N	\N	\N	149861	149861	317181
19689	27821	2	applied	\N	\N	\N	\N	149862	149862	317182
19689	27822	3	applied	\N	\N	\N	\N	149863	149863	317183
19689	27823	4	applied	\N	\N	\N	\N	149864	149864	317184
19689	27824	5	applied	\N	\N	\N	\N	149865	149865	317185
19689	27825	6	applied	\N	\N	\N	\N	149866	149866	317186
19689	27826	7	applied	\N	\N	\N	\N	149867	149867	317187
19689	27827	8	applied	\N	\N	\N	\N	149868	149868	317188
19633	27630	13	applied	\N	\N	\N	\N	149316	149316	316636
19633	27631	15	applied	\N	\N	\N	\N	149317	149317	316637
19633	27652	41	applied	\N	\N	\N	\N	149343	149343	316663
19633	27656	42	applied	\N	\N	\N	\N	149344	149344	316664
19633	27657	43	applied	\N	\N	\N	\N	149345	149345	316665
19633	27600	44	applied	\N	\N	\N	\N	149346	149346	316666
19633	27601	45	applied	\N	\N	\N	\N	149347	149347	316667
19633	27605	46	applied	\N	\N	\N	\N	149348	149348	316668
19633	27606	47	applied	\N	\N	\N	\N	149349	149349	316669
19633	27610	48	applied	\N	\N	\N	\N	149350	149350	316670
19633	27615	49	applied	\N	\N	\N	\N	149351	149351	316671
19633	27616	50	applied	\N	\N	\N	\N	149352	149352	316672
19633	27620	51	applied	\N	\N	\N	\N	149353	149353	316673
19633	27623	52	applied	\N	\N	\N	\N	149354	149354	316674
19633	27624	53	applied	\N	\N	\N	\N	149355	149355	316675
19633	27633	54	applied	\N	\N	\N	\N	149356	149356	316676
19633	27634	55	applied	\N	\N	\N	\N	149357	149357	316677
19633	27635	56	applied	\N	\N	\N	\N	149358	149358	316678
19633	27645	58	applied	\N	\N	\N	\N	149360	149360	316680
19633	27646	59	applied	\N	\N	\N	\N	149361	149361	316681
19633	27649	60	applied	\N	\N	\N	\N	149362	149362	316682
19633	27653	61	applied	\N	\N	\N	\N	149363	149363	316683
19633	27658	62	applied	\N	\N	\N	\N	149364	149364	316684
19633	27659	63	applied	\N	\N	\N	\N	149365	149365	316685
19633	27617	64	applied	\N	\N	\N	\N	149366	149366	316686
19633	27627	65	applied	\N	\N	\N	\N	149367	149367	316687
19633	27632	66	applied	\N	\N	\N	\N	149368	149368	316688
19633	27643	67	applied	\N	\N	\N	\N	149369	149369	316689
19633	27660	68	applied	\N	\N	\N	\N	149370	149370	316690
19636	27671	0	applied	\N	\N	\N	\N	149381	149381	316701
19636	27672	1	applied	\N	\N	\N	\N	149382	149382	316702
19636	27673	2	applied	\N	\N	\N	\N	149383	149383	316703
19643	27676	2	applied	\N	\N	\N	\N	149404	149404	316724
19643	27677	3	applied	\N	\N	\N	\N	149405	149405	316725
19643	27679	5	applied	\N	\N	\N	\N	149407	149407	316727
19643	27680	6	applied	\N	\N	\N	\N	149408	149408	316728
19645	27681	0	applied	\N	\N	\N	\N	149416	149416	316736
19645	27682	1	applied	\N	\N	\N	\N	149417	149417	316737
19645	27683	2	applied	\N	\N	\N	\N	149418	149418	316738
19645	27684	3	applied	\N	\N	\N	\N	149419	149419	316739
19645	27685	4	applied	\N	\N	\N	\N	149420	149420	316740
19645	27686	5	applied	\N	\N	\N	\N	149421	149421	316741
19648	27687	0	applied	\N	\N	\N	\N	149536	149536	316856
19648	27688	1	applied	\N	\N	\N	\N	149537	149537	316857
19648	27689	2	applied	\N	\N	\N	\N	149538	149538	316858
19648	27690	3	applied	\N	\N	\N	\N	149539	149539	316859
19648	27691	4	applied	\N	\N	\N	\N	149540	149540	316860
19648	27692	5	applied	\N	\N	\N	\N	149541	149541	316861
19648	27693	6	applied	\N	\N	\N	\N	149542	149542	316862
19650	27697	0	applied	\N	\N	\N	\N	149546	149546	316866
19650	27699	2	applied	\N	\N	\N	\N	149548	149548	316868
19653	27700	0	applied	\N	\N	\N	\N	149558	149558	316878
19653	27701	1	applied	\N	\N	\N	\N	149559	149559	316879
19653	27702	2	applied	\N	\N	\N	\N	149560	149560	316880
19653	27703	3	applied	\N	\N	\N	\N	149561	149561	316881
19653	27704	4	applied	\N	\N	\N	\N	149562	149562	316882
19653	27705	5	applied	\N	\N	\N	\N	149563	149563	316883
19655	27709	0	applied	\N	\N	\N	\N	149567	149567	316887
19655	27710	1	applied	\N	\N	\N	\N	149568	149568	316888
19655	27711	2	applied	\N	\N	\N	\N	149569	149569	316889
19656	27709	0	applied	\N	\N	\N	\N	149570	149570	316890
19656	27710	1	applied	\N	\N	\N	\N	149571	149571	316891
19656	27711	2	applied	\N	\N	\N	\N	149572	149572	316892
19658	27719	0	applied	\N	\N	\N	\N	149580	149580	316900
19658	27720	1	applied	\N	\N	\N	\N	149581	149581	316901
19658	27721	2	applied	\N	\N	\N	\N	149582	149582	316902
19660	27723	1	applied	\N	\N	\N	\N	149587	149587	316907
19660	27724	2	applied	\N	\N	\N	\N	149588	149588	316908
19661	27725	0	applied	\N	\N	\N	\N	149589	149589	316909
19661	27726	1	applied	\N	\N	\N	\N	149590	149590	316910
19661	27727	2	applied	\N	\N	\N	\N	149591	149591	316911
19665	27730	0	applied	\N	\N	\N	\N	149603	149603	316923
19665	27733	1	applied	\N	\N	\N	\N	149604	149604	316924
19665	27734	2	applied	\N	\N	\N	\N	149605	149605	316925
19665	27735	3	applied	\N	\N	\N	\N	149606	149606	316926
19665	27736	4	applied	\N	\N	\N	\N	149607	149607	316927
19665	27737	5	applied	\N	\N	\N	\N	149608	149608	316928
19665	27732	6	applied	\N	\N	\N	\N	149609	149609	316929
19665	27738	7	applied	\N	\N	\N	\N	149610	149610	316930
19665	27739	8	applied	\N	\N	\N	\N	149611	149611	316931
19670	27750	0	applied	\N	\N	\N	\N	149650	149650	316970
19670	27751	1	applied	\N	\N	\N	\N	149651	149651	316971
19670	27753	3	applied	\N	\N	\N	\N	149653	149653	316973
19670	27754	4	applied	\N	\N	\N	\N	149654	149654	316974
19670	27755	5	applied	\N	\N	\N	\N	149655	149655	316975
19670	27756	6	applied	\N	\N	\N	\N	149656	149656	316976
19670	27757	7	applied	\N	\N	\N	\N	149657	149657	316977
19677	27776	0	applied	\N	\N	\N	\N	149743	149743	317063
19677	27777	1	applied	\N	\N	\N	\N	149744	149744	317064
19677	27778	2	applied	\N	\N	\N	\N	149745	149745	317065
19677	27779	3	applied	\N	\N	\N	\N	149746	149746	317066
19677	27780	4	applied	\N	\N	\N	\N	149747	149747	317067
19677	27781	5	applied	\N	\N	\N	\N	149748	149748	317068
19677	27782	6	applied	\N	\N	\N	\N	149749	149749	317069
19677	27783	7	applied	\N	\N	\N	\N	149750	149750	317070
19677	27784	8	applied	\N	\N	\N	\N	149751	149751	317071
19677	27785	9	applied	\N	\N	\N	\N	149752	149752	317072
19677	27786	10	applied	\N	\N	\N	\N	149753	149753	317073
19677	27788	12	applied	\N	\N	\N	\N	149755	149755	317075
19677	27789	13	applied	\N	\N	\N	\N	149756	149756	317076
19677	27790	14	applied	\N	\N	\N	\N	149757	149757	317077
19677	27791	15	applied	\N	\N	\N	\N	149758	149758	317078
19677	27792	16	applied	\N	\N	\N	\N	149759	149759	317079
19677	27793	17	applied	\N	\N	\N	\N	149760	149760	317080
19679	27802	0	applied	\N	\N	\N	\N	149769	149769	317089
19679	27803	1	applied	\N	\N	\N	\N	149770	149770	317090
19679	27804	2	applied	\N	\N	\N	\N	149771	149771	317091
19679	27805	3	applied	\N	\N	\N	\N	149772	149772	317092
19679	27806	4	applied	\N	\N	\N	\N	149773	149773	317093
19679	27807	5	applied	\N	\N	\N	\N	149774	149774	317094
19679	27808	6	applied	\N	\N	\N	\N	149775	149775	317095
19679	27809	7	applied	\N	\N	\N	\N	149776	149776	317096
19633	27644	38	applied	\N	\N	\N	\N	149340	149340	316660
19633	27647	39	applied	\N	\N	\N	\N	149341	149341	316661
19647	27651	22	applied	\N	\N	\N	\N	149450	149450	316770
19647	27654	23	applied	\N	\N	\N	\N	149451	149451	316771
19647	27655	24	applied	\N	\N	\N	\N	149452	149452	316772
19647	27661	25	applied	\N	\N	\N	\N	149453	149453	316773
19647	27664	26	applied	\N	\N	\N	\N	149454	149454	316774
19647	27665	27	applied	\N	\N	\N	\N	149455	149455	316775
19647	27671	28	applied	\N	\N	\N	\N	149456	149456	316776
19647	27674	29	applied	\N	\N	\N	\N	149457	149457	316777
19647	27675	30	applied	\N	\N	\N	\N	149458	149458	316778
19647	27681	31	applied	\N	\N	\N	\N	149459	149459	316779
19647	27682	33	applied	\N	\N	\N	\N	149460	149460	316780
19647	27581	34	applied	\N	\N	\N	\N	149461	149461	316781
19647	27582	35	applied	\N	\N	\N	\N	149462	149462	316782
19647	27583	36	applied	\N	\N	\N	\N	149463	149463	316783
19647	27588	37	applied	\N	\N	\N	\N	149464	149464	316784
19647	27590	38	applied	\N	\N	\N	\N	149465	149465	316785
19647	27584	40	applied	\N	\N	\N	\N	149467	149467	316787
19647	27598	41	applied	\N	\N	\N	\N	149468	149468	316788
19647	27599	42	applied	\N	\N	\N	\N	149469	149469	316789
19663	27728	0	applied	\N	\N	\N	\N	149597	149597	316917
19663	27729	1	applied	\N	\N	\N	\N	149598	149598	316918
19663	27731	2	applied	\N	\N	\N	\N	149599	149599	316919
19668	27740	0	applied	\N	\N	\N	\N	149632	149632	316952
19668	27741	1	applied	\N	\N	\N	\N	149633	149633	316953
19668	27742	2	applied	\N	\N	\N	\N	149634	149634	316954
19668	27743	3	applied	\N	\N	\N	\N	149635	149635	316955
19668	27744	4	applied	\N	\N	\N	\N	149636	149636	316956
19668	27745	5	applied	\N	\N	\N	\N	149637	149637	316957
19668	27746	6	applied	\N	\N	\N	\N	149638	149638	316958
19668	27747	7	applied	\N	\N	\N	\N	149639	149639	316959
19668	27748	8	applied	\N	\N	\N	\N	149640	149640	316960
19668	27749	9	applied	\N	\N	\N	\N	149641	149641	316961
19672	27751	1	applied	\N	\N	\N	\N	149667	149667	316987
19672	27752	2	applied	\N	\N	\N	\N	149668	149668	316988
19672	27753	3	applied	\N	\N	\N	\N	149669	149669	316989
19672	27756	4	applied	\N	\N	\N	\N	149670	149670	316990
19675	27776	0	applied	\N	\N	\N	\N	149707	149707	317027
19675	27777	1	applied	\N	\N	\N	\N	149708	149708	317028
19675	27778	2	applied	\N	\N	\N	\N	149709	149709	317029
19675	27779	3	applied	\N	\N	\N	\N	149710	149710	317030
19675	27780	4	applied	\N	\N	\N	\N	149711	149711	317031
19675	27781	5	applied	\N	\N	\N	\N	149712	149712	317032
19675	27782	6	applied	\N	\N	\N	\N	149713	149713	317033
19675	27783	7	applied	\N	\N	\N	\N	149714	149714	317034
19675	27784	8	applied	\N	\N	\N	\N	149715	149715	317035
19675	27785	9	applied	\N	\N	\N	\N	149716	149716	317036
19675	27786	10	applied	\N	\N	\N	\N	149717	149717	317037
19675	27787	11	applied	\N	\N	\N	\N	149718	149718	317038
19675	27789	13	applied	\N	\N	\N	\N	149720	149720	317040
19675	27790	14	applied	\N	\N	\N	\N	149721	149721	317041
19675	27791	15	applied	\N	\N	\N	\N	149722	149722	317042
19675	27792	16	applied	\N	\N	\N	\N	149723	149723	317043
19675	27793	17	applied	\N	\N	\N	\N	149724	149724	317044
19680	27802	0	applied	\N	\N	\N	\N	149778	149778	317098
19680	27803	1	applied	\N	\N	\N	\N	149779	149779	317099
19680	27804	2	applied	\N	\N	\N	\N	149780	149780	317100
19680	27805	3	applied	\N	\N	\N	\N	149781	149781	317101
19680	27806	4	applied	\N	\N	\N	\N	149782	149782	317102
19680	27807	5	applied	\N	\N	\N	\N	149783	149783	317103
19680	27808	6	applied	\N	\N	\N	\N	149784	149784	317104
19680	27810	7	applied	\N	\N	\N	\N	149785	149785	317105
19687	27820	0	applied	\N	\N	\N	\N	149842	149842	317162
19687	27817	1	applied	\N	\N	\N	\N	149843	149843	317163
19687	27821	2	applied	\N	\N	\N	\N	149844	149844	317164
19687	27823	4	applied	\N	\N	\N	\N	149846	149846	317166
19687	27824	5	applied	\N	\N	\N	\N	149847	149847	317167
19687	27825	6	applied	\N	\N	\N	\N	149848	149848	317168
19687	27827	7	applied	\N	\N	\N	\N	149849	149849	317169
19687	27818	8	applied	\N	\N	\N	\N	149850	149850	317170
19688	27820	0	applied	\N	\N	\N	\N	149851	149851	317171
19688	27817	1	applied	\N	\N	\N	\N	149852	149852	317172
19688	27821	2	applied	\N	\N	\N	\N	149853	149853	317173
19688	27822	3	applied	\N	\N	\N	\N	149854	149854	317174
19688	27823	4	applied	\N	\N	\N	\N	149855	149855	317175
19688	27824	5	applied	\N	\N	\N	\N	149856	149856	317176
19688	27825	6	applied	\N	\N	\N	\N	149857	149857	317177
19688	27827	7	applied	\N	\N	\N	\N	149858	149858	317178
19688	27818	8	applied	\N	\N	\N	\N	149859	149859	317179
19695	27836	0	applied	\N	\N	\N	\N	150026	150026	317346
19695	27837	1	applied	\N	\N	\N	\N	150027	150027	317347
19695	27839	3	applied	\N	\N	\N	\N	150029	150029	317349
19695	27840	4	applied	\N	\N	\N	\N	150030	150030	317350
19695	27841	5	applied	\N	\N	\N	\N	150031	150031	317351
19695	27842	6	applied	\N	\N	\N	\N	150032	150032	317352
19695	27843	7	applied	\N	\N	\N	\N	150033	150033	317353
19695	27844	8	applied	\N	\N	\N	\N	150034	150034	317354
19698	27862	0	applied	\N	\N	\N	\N	150061	150061	317381
19698	27863	1	applied	\N	\N	\N	\N	150062	150062	317382
19698	27864	2	applied	\N	\N	\N	\N	150063	150063	317383
19698	27865	3	applied	\N	\N	\N	\N	150064	150064	317384
19698	27866	4	applied	\N	\N	\N	\N	150065	150065	317385
19698	27867	5	applied	\N	\N	\N	\N	150066	150066	317386
19698	27868	6	applied	\N	\N	\N	\N	150067	150067	317387
19698	27869	7	applied	\N	\N	\N	\N	150068	150068	317388
19698	27870	8	applied	\N	\N	\N	\N	150069	150069	317389
19698	27871	9	applied	\N	\N	\N	\N	150070	150070	317390
19698	27873	11	applied	\N	\N	\N	\N	150072	150072	317392
19698	27874	12	applied	\N	\N	\N	\N	150073	150073	317393
19698	27875	13	applied	\N	\N	\N	\N	150074	150074	317394
19698	27876	14	applied	\N	\N	\N	\N	150075	150075	317395
19698	27877	15	applied	\N	\N	\N	\N	150076	150076	317396
19698	27878	16	applied	\N	\N	\N	\N	150077	150077	317397
19698	27879	17	applied	\N	\N	\N	\N	150078	150078	317398
19701	27883	0	applied	\N	\N	\N	\N	150085	150085	317405
19701	27884	1	applied	\N	\N	\N	\N	150086	150086	317406
19701	27885	2	applied	\N	\N	\N	\N	150087	150087	317407
19710	27905	0	applied	\N	\N	\N	\N	150248	150248	317568
19710	27906	1	applied	\N	\N	\N	\N	150249	150249	317569
19710	27907	2	applied	\N	\N	\N	\N	150250	150250	317570
19717	27920	0	applied	\N	\N	\N	\N	150396	150396	317716
19647	27641	19	applied	\N	\N	\N	\N	149447	149447	316767
19647	27642	20	applied	\N	\N	\N	\N	149448	149448	316768
19647	27619	47	applied	\N	\N	\N	\N	149474	149474	316794
19647	27625	48	applied	\N	\N	\N	\N	149475	149475	316795
19647	27626	49	applied	\N	\N	\N	\N	149476	149476	316796
19647	27591	50	applied	\N	\N	\N	\N	149477	149477	316797
19647	27637	51	applied	\N	\N	\N	\N	149478	149478	316798
19647	27638	52	applied	\N	\N	\N	\N	149479	149479	316799
19647	27639	53	applied	\N	\N	\N	\N	149480	149480	316800
19647	27640	54	applied	\N	\N	\N	\N	149481	149481	316801
19647	27644	55	applied	\N	\N	\N	\N	149482	149482	316802
19647	27647	56	applied	\N	\N	\N	\N	149483	149483	316803
19647	27592	57	applied	\N	\N	\N	\N	149484	149484	316804
19647	27596	58	applied	\N	\N	\N	\N	149485	149485	316805
19647	27650	59	applied	\N	\N	\N	\N	149486	149486	316806
19647	27652	60	applied	\N	\N	\N	\N	149487	149487	316807
19647	27656	61	applied	\N	\N	\N	\N	149488	149488	316808
19647	27657	62	applied	\N	\N	\N	\N	149489	149489	316809
19647	27668	64	applied	\N	\N	\N	\N	149491	149491	316811
19647	27585	65	applied	\N	\N	\N	\N	149492	149492	316812
19647	27589	66	applied	\N	\N	\N	\N	149493	149493	316813
19647	27609	67	applied	\N	\N	\N	\N	149494	149494	316814
19647	27670	68	applied	\N	\N	\N	\N	149495	149495	316815
19647	27672	69	applied	\N	\N	\N	\N	149496	149496	316816
19647	27677	70	applied	\N	\N	\N	\N	149497	149497	316817
19647	27678	71	applied	\N	\N	\N	\N	149498	149498	316818
19647	27683	72	applied	\N	\N	\N	\N	149499	149499	316819
19647	27684	73	applied	\N	\N	\N	\N	149500	149500	316820
19647	27600	74	applied	\N	\N	\N	\N	149501	149501	316821
19647	27601	75	applied	\N	\N	\N	\N	149502	149502	316822
19647	27605	76	applied	\N	\N	\N	\N	149503	149503	316823
19647	27606	77	applied	\N	\N	\N	\N	149504	149504	316824
19647	27610	78	applied	\N	\N	\N	\N	149505	149505	316825
19647	27615	79	applied	\N	\N	\N	\N	149506	149506	316826
19647	27620	81	applied	\N	\N	\N	\N	149508	149508	316828
19647	27623	82	applied	\N	\N	\N	\N	149509	149509	316829
19647	27624	83	applied	\N	\N	\N	\N	149510	149510	316830
19647	27633	84	applied	\N	\N	\N	\N	149511	149511	316831
19647	27634	85	applied	\N	\N	\N	\N	149512	149512	316832
19647	27635	86	applied	\N	\N	\N	\N	149513	149513	316833
19647	27636	87	applied	\N	\N	\N	\N	149514	149514	316834
19647	27645	88	applied	\N	\N	\N	\N	149515	149515	316835
19647	27646	89	applied	\N	\N	\N	\N	149516	149516	316836
19647	27649	90	applied	\N	\N	\N	\N	149517	149517	316837
19647	27653	91	applied	\N	\N	\N	\N	149518	149518	316838
19647	27658	92	applied	\N	\N	\N	\N	149519	149519	316839
19647	27659	93	applied	\N	\N	\N	\N	149520	149520	316840
19647	27662	94	applied	\N	\N	\N	\N	149521	149521	316841
19647	27667	95	applied	\N	\N	\N	\N	149522	149522	316842
19647	27669	96	applied	\N	\N	\N	\N	149523	149523	316843
19647	27679	98	applied	\N	\N	\N	\N	149525	149525	316845
19647	27680	99	applied	\N	\N	\N	\N	149526	149526	316846
19647	27685	100	applied	\N	\N	\N	\N	149527	149527	316847
19647	27686	101	applied	\N	\N	\N	\N	149528	149528	316848
19647	27617	102	applied	\N	\N	\N	\N	149529	149529	316849
19647	27627	103	applied	\N	\N	\N	\N	149530	149530	316850
19647	27632	104	applied	\N	\N	\N	\N	149531	149531	316851
19647	27643	105	applied	\N	\N	\N	\N	149532	149532	316852
19647	27660	106	applied	\N	\N	\N	\N	149533	149533	316853
19647	27666	107	applied	\N	\N	\N	\N	149534	149534	316854
19647	27676	108	applied	\N	\N	\N	\N	149535	149535	316855
19652	27700	0	applied	\N	\N	\N	\N	149552	149552	316872
19652	27701	1	applied	\N	\N	\N	\N	149553	149553	316873
19652	27702	2	applied	\N	\N	\N	\N	149554	149554	316874
19652	27703	3	applied	\N	\N	\N	\N	149555	149555	316875
19652	27704	4	applied	\N	\N	\N	\N	149556	149556	316876
19657	27712	0	applied	\N	\N	\N	\N	149573	149573	316893
19657	27713	1	applied	\N	\N	\N	\N	149574	149574	316894
19657	27714	2	applied	\N	\N	\N	\N	149575	149575	316895
19657	27715	3	applied	\N	\N	\N	\N	149576	149576	316896
19657	27716	4	applied	\N	\N	\N	\N	149577	149577	316897
19657	27717	5	applied	\N	\N	\N	\N	149578	149578	316898
19657	27718	6	applied	\N	\N	\N	\N	149579	149579	316899
19662	27728	0	applied	\N	\N	\N	\N	149592	149592	316912
19662	27729	1	applied	\N	\N	\N	\N	149593	149593	316913
19662	27730	2	applied	\N	\N	\N	\N	149594	149594	316914
19662	27731	3	applied	\N	\N	\N	\N	149595	149595	316915
19662	27732	4	applied	\N	\N	\N	\N	149596	149596	316916
19667	27740	0	applied	\N	\N	\N	\N	149622	149622	316942
19667	27741	1	applied	\N	\N	\N	\N	149623	149623	316943
19667	27742	2	applied	\N	\N	\N	\N	149624	149624	316944
19667	27743	3	applied	\N	\N	\N	\N	149625	149625	316945
19667	27745	5	applied	\N	\N	\N	\N	149627	149627	316947
19667	27746	6	applied	\N	\N	\N	\N	149628	149628	316948
19667	27747	7	applied	\N	\N	\N	\N	149629	149629	316949
19667	27748	8	applied	\N	\N	\N	\N	149630	149630	316950
19667	27749	9	applied	\N	\N	\N	\N	149631	149631	316951
19669	27750	0	applied	\N	\N	\N	\N	149642	149642	316962
19669	27751	1	applied	\N	\N	\N	\N	149643	149643	316963
19669	27752	2	applied	\N	\N	\N	\N	149644	149644	316964
19669	27753	3	applied	\N	\N	\N	\N	149645	149645	316965
19669	27754	4	applied	\N	\N	\N	\N	149646	149646	316966
19669	27755	5	applied	\N	\N	\N	\N	149647	149647	316967
19669	27756	6	applied	\N	\N	\N	\N	149648	149648	316968
19669	27757	7	applied	\N	\N	\N	\N	149649	149649	316969
19674	27758	0	applied	\N	\N	\N	\N	149689	149689	317009
19674	27759	1	applied	\N	\N	\N	\N	149690	149690	317010
19674	27760	2	applied	\N	\N	\N	\N	149691	149691	317011
19674	27762	4	applied	\N	\N	\N	\N	149693	149693	317013
19674	27763	5	applied	\N	\N	\N	\N	149694	149694	317014
19674	27764	6	applied	\N	\N	\N	\N	149695	149695	317015
19674	27765	7	applied	\N	\N	\N	\N	149696	149696	317016
19674	27766	8	applied	\N	\N	\N	\N	149697	149697	317017
19674	27767	9	applied	\N	\N	\N	\N	149698	149698	317018
19674	27768	10	applied	\N	\N	\N	\N	149699	149699	317019
19674	27769	11	applied	\N	\N	\N	\N	149700	149700	317020
19674	27770	12	applied	\N	\N	\N	\N	149701	149701	317021
19674	27771	13	applied	\N	\N	\N	\N	149702	149702	317022
19674	27772	14	applied	\N	\N	\N	\N	149703	149703	317023
19674	27773	15	applied	\N	\N	\N	\N	149704	149704	317024
19674	27774	16	applied	\N	\N	\N	\N	149705	149705	317025
19674	27775	17	applied	\N	\N	\N	\N	149706	149706	317026
19647	27608	44	applied	\N	\N	\N	\N	149471	149471	316791
19647	27613	45	applied	\N	\N	\N	\N	149472	149472	316792
19678	27798	4	applied	\N	\N	\N	\N	149765	149765	317085
19678	27799	5	applied	\N	\N	\N	\N	149766	149766	317086
19678	27800	7	applied	\N	\N	\N	\N	149767	149767	317087
19678	27801	8	applied	\N	\N	\N	\N	149768	149768	317088
19679	27810	8	applied	\N	\N	\N	\N	149777	149777	317097
19681	27811	0	applied	\N	\N	\N	\N	149786	149786	317106
19681	27812	1	applied	\N	\N	\N	\N	149787	149787	317107
19681	27813	2	applied	\N	\N	\N	\N	149788	149788	317108
19681	27814	3	applied	\N	\N	\N	\N	149789	149789	317109
19681	27815	4	applied	\N	\N	\N	\N	149790	149790	317110
19681	27816	5	applied	\N	\N	\N	\N	149791	149791	317111
19681	27817	6	applied	\N	\N	\N	\N	149792	149792	317112
19681	27809	7	applied	\N	\N	\N	\N	149793	149793	317113
19681	27818	8	applied	\N	\N	\N	\N	149794	149794	317114
19681	27819	9	applied	\N	\N	\N	\N	149795	149795	317115
19683	27811	0	applied	\N	\N	\N	\N	149805	149805	317125
19683	27813	2	applied	\N	\N	\N	\N	149807	149807	317127
19683	27814	3	applied	\N	\N	\N	\N	149808	149808	317128
19683	27815	4	applied	\N	\N	\N	\N	149809	149809	317129
19683	27816	5	applied	\N	\N	\N	\N	149810	149810	317130
19683	27817	6	applied	\N	\N	\N	\N	149811	149811	317131
19683	27818	7	applied	\N	\N	\N	\N	149812	149812	317132
19683	27819	8	applied	\N	\N	\N	\N	149813	149813	317133
19685	27820	0	applied	\N	\N	\N	\N	149822	149822	317142
19685	27817	1	applied	\N	\N	\N	\N	149823	149823	317143
19685	27821	2	applied	\N	\N	\N	\N	149824	149824	317144
19685	27822	3	applied	\N	\N	\N	\N	149825	149825	317145
19685	27823	4	applied	\N	\N	\N	\N	149826	149826	317146
19685	27824	5	applied	\N	\N	\N	\N	149827	149827	317147
19685	27825	6	applied	\N	\N	\N	\N	149828	149828	317148
19685	27826	7	applied	\N	\N	\N	\N	149829	149829	317149
19685	27827	8	applied	\N	\N	\N	\N	149830	149830	317150
19686	27820	0	applied	\N	\N	\N	\N	149832	149832	317152
19686	27817	1	applied	\N	\N	\N	\N	149833	149833	317153
19686	27821	2	applied	\N	\N	\N	\N	149834	149834	317154
19686	27822	3	applied	\N	\N	\N	\N	149835	149835	317155
19686	27823	4	applied	\N	\N	\N	\N	149836	149836	317156
19686	27824	5	applied	\N	\N	\N	\N	149837	149837	317157
19686	27825	6	applied	\N	\N	\N	\N	149838	149838	317158
19686	27826	7	applied	\N	\N	\N	\N	149839	149839	317159
19686	27827	8	applied	\N	\N	\N	\N	149840	149840	317160
19686	27818	9	applied	\N	\N	\N	\N	149841	149841	317161
19690	27820	0	applied	\N	\N	\N	\N	149870	149870	317190
19690	27821	1	applied	\N	\N	\N	\N	149871	149871	317191
19690	27822	2	applied	\N	\N	\N	\N	149872	149872	317192
19692	27828	0	applied	\N	\N	\N	\N	149885	149885	317205
19692	27829	1	applied	\N	\N	\N	\N	149886	149886	317206
19692	27830	2	applied	\N	\N	\N	\N	149887	149887	317207
19692	27832	4	applied	\N	\N	\N	\N	149889	149889	317209
19692	27833	5	applied	\N	\N	\N	\N	149890	149890	317210
19692	27834	6	applied	\N	\N	\N	\N	149891	149891	317211
19692	27835	7	applied	\N	\N	\N	\N	149892	149892	317212
19699	27880	0	applied	\N	\N	\N	\N	150079	150079	317399
19699	27881	1	applied	\N	\N	\N	\N	150080	150080	317400
19699	27882	2	applied	\N	\N	\N	\N	150081	150081	317401
19702	27728	0	applied	\N	\N	\N	\N	150088	150088	317408
19702	27729	1	applied	\N	\N	\N	\N	150089	150089	317409
19702	27730	2	applied	\N	\N	\N	\N	150090	150090	317410
19702	27733	3	applied	\N	\N	\N	\N	150091	150091	317411
19702	27641	4	applied	\N	\N	\N	\N	150092	150092	317412
19702	27642	5	applied	\N	\N	\N	\N	150093	150093	317413
19702	27648	6	applied	\N	\N	\N	\N	150094	150094	317414
19702	27651	7	applied	\N	\N	\N	\N	150095	150095	317415
19702	27654	8	applied	\N	\N	\N	\N	150096	150096	317416
19702	27661	10	applied	\N	\N	\N	\N	150098	150098	317418
19702	27664	11	applied	\N	\N	\N	\N	150099	150099	317419
19702	27665	12	applied	\N	\N	\N	\N	150100	150100	317420
19702	27734	13	applied	\N	\N	\N	\N	150101	150101	317421
19702	27671	14	applied	\N	\N	\N	\N	150102	150102	317422
19702	27674	15	applied	\N	\N	\N	\N	150103	150103	317423
19702	27675	16	applied	\N	\N	\N	\N	150104	150104	317424
19702	27681	17	applied	\N	\N	\N	\N	150105	150105	317425
19702	27682	18	applied	\N	\N	\N	\N	150106	150106	317426
19702	27687	19	applied	\N	\N	\N	\N	150107	150107	317427
19702	27735	20	applied	\N	\N	\N	\N	150108	150108	317428
19702	27736	21	applied	\N	\N	\N	\N	150109	150109	317429
19702	27737	22	applied	\N	\N	\N	\N	150110	150110	317430
19702	27740	23	applied	\N	\N	\N	\N	150111	150111	317431
19702	27743	24	applied	\N	\N	\N	\N	150112	150112	317432
19702	27744	25	applied	\N	\N	\N	\N	150113	150113	317433
19702	27746	27	applied	\N	\N	\N	\N	150115	150115	317435
19702	27747	28	applied	\N	\N	\N	\N	150116	150116	317436
19702	27750	29	applied	\N	\N	\N	\N	150117	150117	317437
19702	27751	30	applied	\N	\N	\N	\N	150118	150118	317438
19702	27752	31	applied	\N	\N	\N	\N	150119	150119	317439
19702	27753	32	applied	\N	\N	\N	\N	150120	150120	317440
19702	27754	33	applied	\N	\N	\N	\N	150121	150121	317441
19702	27755	34	applied	\N	\N	\N	\N	150122	150122	317442
19702	27760	35	applied	\N	\N	\N	\N	150123	150123	317443
19702	27761	36	applied	\N	\N	\N	\N	150124	150124	317444
19702	27762	37	applied	\N	\N	\N	\N	150125	150125	317445
19702	27763	38	applied	\N	\N	\N	\N	150126	150126	317446
19702	27764	39	applied	\N	\N	\N	\N	150127	150127	317447
19702	27765	40	applied	\N	\N	\N	\N	150128	150128	317448
19702	27766	41	applied	\N	\N	\N	\N	150129	150129	317449
19702	27767	42	applied	\N	\N	\N	\N	150130	150130	317450
19702	27769	44	applied	\N	\N	\N	\N	150132	150132	317452
19702	27770	45	applied	\N	\N	\N	\N	150133	150133	317453
19702	27771	46	applied	\N	\N	\N	\N	150134	150134	317454
19702	27776	47	applied	\N	\N	\N	\N	150135	150135	317455
19702	27777	48	applied	\N	\N	\N	\N	150136	150136	317456
19702	27778	49	applied	\N	\N	\N	\N	150137	150137	317457
19702	27779	50	applied	\N	\N	\N	\N	150138	150138	317458
19702	27780	51	applied	\N	\N	\N	\N	150139	150139	317459
19702	27781	52	applied	\N	\N	\N	\N	150140	150140	317460
19702	27784	53	applied	\N	\N	\N	\N	150141	150141	317461
19702	27785	54	applied	\N	\N	\N	\N	150142	150142	317462
19702	27786	55	applied	\N	\N	\N	\N	150143	150143	317463
19702	27787	56	applied	\N	\N	\N	\N	150144	150144	317464
19702	27788	57	applied	\N	\N	\N	\N	150145	150145	317465
19678	27795	1	applied	\N	\N	\N	\N	149762	149762	317082
19678	27796	2	applied	\N	\N	\N	\N	149763	149763	317083
19690	27827	6	applied	\N	\N	\N	\N	149876	149876	317196
19691	27828	0	applied	\N	\N	\N	\N	149877	149877	317197
19691	27829	1	applied	\N	\N	\N	\N	149878	149878	317198
19691	27830	2	applied	\N	\N	\N	\N	149879	149879	317199
19691	27831	3	applied	\N	\N	\N	\N	149880	149880	317200
19691	27832	4	applied	\N	\N	\N	\N	149881	149881	317201
19691	27833	5	applied	\N	\N	\N	\N	149882	149882	317202
19691	27834	6	applied	\N	\N	\N	\N	149883	149883	317203
19691	27835	7	applied	\N	\N	\N	\N	149884	149884	317204
19693	27828	0	applied	\N	\N	\N	\N	149893	149893	317213
19693	27829	1	applied	\N	\N	\N	\N	149894	149894	317214
19693	27830	2	applied	\N	\N	\N	\N	149895	149895	317215
19693	27831	3	applied	\N	\N	\N	\N	149896	149896	317216
19693	27832	4	applied	\N	\N	\N	\N	149897	149897	317217
19693	27833	5	applied	\N	\N	\N	\N	149898	149898	317218
19693	27834	6	applied	\N	\N	\N	\N	149899	149899	317219
19694	27687	0	applied	\N	\N	\N	\N	149901	149901	317221
19694	27728	1	applied	\N	\N	\N	\N	149902	149902	317222
19694	27729	2	applied	\N	\N	\N	\N	149903	149903	317223
19694	27730	3	applied	\N	\N	\N	\N	149904	149904	317224
19694	27733	4	applied	\N	\N	\N	\N	149905	149905	317225
19694	27734	5	applied	\N	\N	\N	\N	149906	149906	317226
19694	27735	6	applied	\N	\N	\N	\N	149907	149907	317227
19694	27736	7	applied	\N	\N	\N	\N	149908	149908	317228
19694	27737	8	applied	\N	\N	\N	\N	149909	149909	317229
19694	27740	9	applied	\N	\N	\N	\N	149910	149910	317230
19694	27743	10	applied	\N	\N	\N	\N	149911	149911	317231
19694	27744	11	applied	\N	\N	\N	\N	149912	149912	317232
19694	27745	12	applied	\N	\N	\N	\N	149913	149913	317233
19694	27746	13	applied	\N	\N	\N	\N	149914	149914	317234
19694	27747	14	applied	\N	\N	\N	\N	149915	149915	317235
19694	27750	15	applied	\N	\N	\N	\N	149916	149916	317236
19694	27752	17	applied	\N	\N	\N	\N	149918	149918	317238
19694	27753	18	applied	\N	\N	\N	\N	149919	149919	317239
19694	27754	19	applied	\N	\N	\N	\N	149920	149920	317240
19694	27755	20	applied	\N	\N	\N	\N	149921	149921	317241
19694	27760	21	applied	\N	\N	\N	\N	149922	149922	317242
19694	27761	22	applied	\N	\N	\N	\N	149923	149923	317243
19694	27762	23	applied	\N	\N	\N	\N	149924	149924	317244
19694	27763	24	applied	\N	\N	\N	\N	149925	149925	317245
19694	27764	25	applied	\N	\N	\N	\N	149926	149926	317246
19694	27765	26	applied	\N	\N	\N	\N	149927	149927	317247
19694	27766	27	applied	\N	\N	\N	\N	149928	149928	317248
19694	27767	28	applied	\N	\N	\N	\N	149929	149929	317249
19694	27768	29	applied	\N	\N	\N	\N	149930	149930	317250
19694	27769	30	applied	\N	\N	\N	\N	149931	149931	317251
19694	27770	31	applied	\N	\N	\N	\N	149932	149932	317252
19694	27771	32	applied	\N	\N	\N	\N	149933	149933	317253
19694	27777	34	applied	\N	\N	\N	\N	149935	149935	317255
19694	27778	35	applied	\N	\N	\N	\N	149936	149936	317256
19694	27779	36	applied	\N	\N	\N	\N	149937	149937	317257
19694	27780	37	applied	\N	\N	\N	\N	149938	149938	317258
19694	27781	38	applied	\N	\N	\N	\N	149939	149939	317259
19694	27784	39	applied	\N	\N	\N	\N	149940	149940	317260
19694	27785	40	applied	\N	\N	\N	\N	149941	149941	317261
19694	27786	41	applied	\N	\N	\N	\N	149942	149942	317262
19694	27787	42	applied	\N	\N	\N	\N	149943	149943	317263
19694	27788	43	applied	\N	\N	\N	\N	149944	149944	317264
19694	27789	44	applied	\N	\N	\N	\N	149945	149945	317265
19694	27795	45	applied	\N	\N	\N	\N	149946	149946	317266
19694	27796	46	applied	\N	\N	\N	\N	149947	149947	317267
19694	27797	47	applied	\N	\N	\N	\N	149948	149948	317268
19694	27798	48	applied	\N	\N	\N	\N	149949	149949	317269
19694	27799	50	applied	\N	\N	\N	\N	149950	149950	317270
19694	27803	52	applied	\N	\N	\N	\N	149952	149952	317272
19694	27804	53	applied	\N	\N	\N	\N	149953	149953	317273
19694	27805	54	applied	\N	\N	\N	\N	149954	149954	317274
19694	27806	55	applied	\N	\N	\N	\N	149955	149955	317275
19694	27807	56	applied	\N	\N	\N	\N	149956	149956	317276
19694	27811	57	applied	\N	\N	\N	\N	149957	149957	317277
19694	27813	58	applied	\N	\N	\N	\N	149958	149958	317278
19694	27814	59	applied	\N	\N	\N	\N	149959	149959	317279
19694	27815	60	applied	\N	\N	\N	\N	149960	149960	317280
19694	27816	61	applied	\N	\N	\N	\N	149961	149961	317281
19694	27817	62	applied	\N	\N	\N	\N	149962	149962	317282
19694	27821	63	applied	\N	\N	\N	\N	149963	149963	317283
19694	27822	64	applied	\N	\N	\N	\N	149964	149964	317284
19694	27823	65	applied	\N	\N	\N	\N	149965	149965	317285
19694	27824	66	applied	\N	\N	\N	\N	149966	149966	317286
19694	27825	67	applied	\N	\N	\N	\N	149967	149967	317287
19694	27828	69	applied	\N	\N	\N	\N	149969	149969	317289
19694	27829	70	applied	\N	\N	\N	\N	149970	149970	317290
19694	27688	71	applied	\N	\N	\N	\N	149971	149971	317291
19694	27694	72	applied	\N	\N	\N	\N	149972	149972	317292
19694	27697	73	applied	\N	\N	\N	\N	149973	149973	317293
19694	27700	74	applied	\N	\N	\N	\N	149974	149974	317294
19694	27701	75	applied	\N	\N	\N	\N	149975	149975	317295
19694	27706	76	applied	\N	\N	\N	\N	149976	149976	317296
19694	27709	77	applied	\N	\N	\N	\N	149977	149977	317297
19694	27712	78	applied	\N	\N	\N	\N	149978	149978	317298
19694	27713	79	applied	\N	\N	\N	\N	149979	149979	317299
19694	27719	80	applied	\N	\N	\N	\N	149980	149980	317300
19694	27722	81	applied	\N	\N	\N	\N	149981	149981	317301
19694	27725	82	applied	\N	\N	\N	\N	149982	149982	317302
19694	27731	83	applied	\N	\N	\N	\N	149983	149983	317303
19694	27741	84	applied	\N	\N	\N	\N	149984	149984	317304
19696	27837	1	applied	\N	\N	\N	\N	150036	150036	317356
19696	27838	2	applied	\N	\N	\N	\N	150037	150037	317357
19696	27839	3	applied	\N	\N	\N	\N	150038	150038	317358
19696	27840	4	applied	\N	\N	\N	\N	150039	150039	317359
19696	27841	5	applied	\N	\N	\N	\N	150040	150040	317360
19696	27842	6	applied	\N	\N	\N	\N	150041	150041	317361
19696	27843	7	applied	\N	\N	\N	\N	150042	150042	317362
19696	27844	8	applied	\N	\N	\N	\N	150043	150043	317363
19706	27900	0	applied	\N	\N	\N	\N	150228	150228	317548
19706	27901	1	applied	\N	\N	\N	\N	150229	150229	317549
19706	27902	2	applied	\N	\N	\N	\N	150230	150230	317550
19706	27903	3	applied	\N	\N	\N	\N	150231	150231	317551
19706	27904	4	applied	\N	\N	\N	\N	150232	150232	317552
19713	27908	0	applied	\N	\N	\N	\N	150257	150257	317577
19690	27823	3	applied	\N	\N	\N	\N	149873	149873	317193
19690	27824	4	applied	\N	\N	\N	\N	149874	149874	317194
19694	27783	89	applied	\N	\N	\N	\N	149989	149989	317309
19694	27794	90	applied	\N	\N	\N	\N	149990	149990	317310
19694	27808	91	applied	\N	\N	\N	\N	149991	149991	317311
19694	27812	92	applied	\N	\N	\N	\N	149992	149992	317312
19694	27820	93	applied	\N	\N	\N	\N	149993	149993	317313
19694	27830	94	applied	\N	\N	\N	\N	149994	149994	317314
19694	27689	95	applied	\N	\N	\N	\N	149995	149995	317315
19694	27690	96	applied	\N	\N	\N	\N	149996	149996	317316
19694	27715	97	applied	\N	\N	\N	\N	149997	149997	317317
19694	27691	98	applied	\N	\N	\N	\N	149998	149998	317318
19694	27692	99	applied	\N	\N	\N	\N	149999	149999	317319
19694	27695	100	applied	\N	\N	\N	\N	150000	150000	317320
19694	27698	101	applied	\N	\N	\N	\N	150001	150001	317321
19694	27702	102	applied	\N	\N	\N	\N	150002	150002	317322
19694	27704	103	applied	\N	\N	\N	\N	150003	150003	317323
19694	27707	104	applied	\N	\N	\N	\N	150004	150004	317324
19694	27714	106	applied	\N	\N	\N	\N	150006	150006	317326
19694	27716	107	applied	\N	\N	\N	\N	150007	150007	317327
19694	27721	108	applied	\N	\N	\N	\N	150008	150008	317328
19713	27909	1	applied	\N	\N	\N	\N	150258	150258	317578
19718	27923	0	applied	\N	\N	\N	\N	150399	150399	317719
19718	27924	1	applied	\N	\N	\N	\N	150400	150400	317720
19718	27925	2	applied	\N	\N	\N	\N	150401	150401	317721
19723	27728	0	applied	\N	\N	\N	\N	150418	150418	317738
19723	27729	1	applied	\N	\N	\N	\N	150419	150419	317739
19723	27730	2	applied	\N	\N	\N	\N	150420	150420	317740
19723	27733	3	applied	\N	\N	\N	\N	150421	150421	317741
19723	27734	4	applied	\N	\N	\N	\N	150422	150422	317742
19723	27735	5	applied	\N	\N	\N	\N	150423	150423	317743
19723	27736	6	applied	\N	\N	\N	\N	150424	150424	317744
19723	27737	7	applied	\N	\N	\N	\N	150425	150425	317745
19723	27740	8	applied	\N	\N	\N	\N	150426	150426	317746
19723	27744	10	applied	\N	\N	\N	\N	150428	150428	317748
19723	27745	11	applied	\N	\N	\N	\N	150429	150429	317749
19723	27746	12	applied	\N	\N	\N	\N	150430	150430	317750
19723	27747	13	applied	\N	\N	\N	\N	150431	150431	317751
19723	27750	14	applied	\N	\N	\N	\N	150432	150432	317752
19723	27751	15	applied	\N	\N	\N	\N	150433	150433	317753
19723	27752	16	applied	\N	\N	\N	\N	150434	150434	317754
19723	27753	17	applied	\N	\N	\N	\N	150435	150435	317755
19723	27754	18	applied	\N	\N	\N	\N	150436	150436	317756
19723	27755	19	applied	\N	\N	\N	\N	150437	150437	317757
19723	27760	20	applied	\N	\N	\N	\N	150438	150438	317758
19723	27761	21	applied	\N	\N	\N	\N	150439	150439	317759
19723	27762	22	applied	\N	\N	\N	\N	150440	150440	317760
19723	27763	23	applied	\N	\N	\N	\N	150441	150441	317761
19723	27764	24	applied	\N	\N	\N	\N	150442	150442	317762
19723	27765	25	applied	\N	\N	\N	\N	150443	150443	317763
19723	27767	27	applied	\N	\N	\N	\N	150445	150445	317765
19723	27768	28	applied	\N	\N	\N	\N	150446	150446	317766
19723	27769	29	applied	\N	\N	\N	\N	150447	150447	317767
19723	27770	30	applied	\N	\N	\N	\N	150448	150448	317768
19723	27771	31	applied	\N	\N	\N	\N	150449	150449	317769
19723	27776	32	applied	\N	\N	\N	\N	150450	150450	317770
19723	27777	33	applied	\N	\N	\N	\N	150451	150451	317771
19723	27778	34	applied	\N	\N	\N	\N	150452	150452	317772
19723	27779	35	applied	\N	\N	\N	\N	150453	150453	317773
19723	27780	36	applied	\N	\N	\N	\N	150454	150454	317774
19723	27781	37	applied	\N	\N	\N	\N	150455	150455	317775
19723	27784	38	applied	\N	\N	\N	\N	150456	150456	317776
19723	27785	39	applied	\N	\N	\N	\N	150457	150457	317777
19723	27786	40	applied	\N	\N	\N	\N	150458	150458	317778
19723	27787	41	applied	\N	\N	\N	\N	150459	150459	317779
19723	27788	42	applied	\N	\N	\N	\N	150460	150460	317780
19723	27795	44	applied	\N	\N	\N	\N	150462	150462	317782
19723	27796	45	applied	\N	\N	\N	\N	150463	150463	317783
19723	27797	46	applied	\N	\N	\N	\N	150464	150464	317784
19723	27798	47	applied	\N	\N	\N	\N	150465	150465	317785
19723	27799	48	applied	\N	\N	\N	\N	150466	150466	317786
19723	27802	49	applied	\N	\N	\N	\N	150467	150467	317787
19723	27803	50	applied	\N	\N	\N	\N	150468	150468	317788
19723	27804	51	applied	\N	\N	\N	\N	150469	150469	317789
19723	27805	52	applied	\N	\N	\N	\N	150470	150470	317790
19723	27806	53	applied	\N	\N	\N	\N	150471	150471	317791
19723	27807	54	applied	\N	\N	\N	\N	150472	150472	317792
19723	27811	55	applied	\N	\N	\N	\N	150473	150473	317793
19723	27813	56	applied	\N	\N	\N	\N	150474	150474	317794
19723	27814	57	applied	\N	\N	\N	\N	150475	150475	317795
19723	27815	58	applied	\N	\N	\N	\N	150476	150476	317796
19723	27816	59	applied	\N	\N	\N	\N	150477	150477	317797
19723	27821	61	applied	\N	\N	\N	\N	150479	150479	317799
19723	27822	62	applied	\N	\N	\N	\N	150480	150480	317800
19723	27823	63	applied	\N	\N	\N	\N	150481	150481	317801
19723	27824	64	applied	\N	\N	\N	\N	150482	150482	317802
19723	27825	65	applied	\N	\N	\N	\N	150483	150483	317803
19723	27826	66	applied	\N	\N	\N	\N	150484	150484	317804
19723	27828	67	applied	\N	\N	\N	\N	150485	150485	317805
19723	27829	68	applied	\N	\N	\N	\N	150486	150486	317806
19723	27831	69	applied	\N	\N	\N	\N	150487	150487	317807
19723	27832	70	applied	\N	\N	\N	\N	150488	150488	317808
19723	27833	71	applied	\N	\N	\N	\N	150489	150489	317809
19723	27836	72	applied	\N	\N	\N	\N	150490	150490	317810
19723	27838	73	applied	\N	\N	\N	\N	150491	150491	317811
19723	27839	74	applied	\N	\N	\N	\N	150492	150492	317812
19723	27840	75	applied	\N	\N	\N	\N	150493	150493	317813
19723	27841	76	applied	\N	\N	\N	\N	150494	150494	317814
19723	27845	78	applied	\N	\N	\N	\N	150496	150496	317816
19723	27848	79	applied	\N	\N	\N	\N	150497	150497	317817
19723	27849	80	applied	\N	\N	\N	\N	150498	150498	317818
19723	27850	81	applied	\N	\N	\N	\N	150499	150499	317819
19723	27851	82	applied	\N	\N	\N	\N	150500	150500	317820
19723	27852	83	applied	\N	\N	\N	\N	150501	150501	317821
19723	27853	84	applied	\N	\N	\N	\N	150502	150502	317822
19723	27854	85	applied	\N	\N	\N	\N	150503	150503	317823
19723	27855	86	applied	\N	\N	\N	\N	150504	150504	317824
19723	27856	87	applied	\N	\N	\N	\N	150505	150505	317825
19723	27857	88	applied	\N	\N	\N	\N	150506	150506	317826
19723	27862	89	applied	\N	\N	\N	\N	150507	150507	317827
19723	27863	90	applied	\N	\N	\N	\N	150508	150508	317828
19723	27864	91	applied	\N	\N	\N	\N	150509	150509	317829
19694	27758	86	applied	\N	\N	\N	\N	149986	149986	317306
19694	27759	87	applied	\N	\N	\N	\N	149987	149987	317307
19694	27749	113	applied	\N	\N	\N	\N	150013	150013	317333
19694	27757	114	applied	\N	\N	\N	\N	150014	150014	317334
19694	27774	115	applied	\N	\N	\N	\N	150015	150015	317335
19694	27775	116	applied	\N	\N	\N	\N	150016	150016	317336
19694	27792	117	applied	\N	\N	\N	\N	150017	150017	317337
19694	27793	118	applied	\N	\N	\N	\N	150018	150018	317338
19694	27800	119	applied	\N	\N	\N	\N	150019	150019	317339
19694	27809	120	applied	\N	\N	\N	\N	150020	150020	317340
19694	27818	121	applied	\N	\N	\N	\N	150021	150021	317341
19694	27835	122	applied	\N	\N	\N	\N	150022	150022	317342
19694	27693	123	applied	\N	\N	\N	\N	150023	150023	317343
19694	27696	124	applied	\N	\N	\N	\N	150024	150024	317344
19694	27699	125	applied	\N	\N	\N	\N	150025	150025	317345
19697	27845	0	applied	\N	\N	\N	\N	150044	150044	317364
19697	27847	2	applied	\N	\N	\N	\N	150046	150046	317366
19697	27848	3	applied	\N	\N	\N	\N	150047	150047	317367
19697	27849	4	applied	\N	\N	\N	\N	150048	150048	317368
19697	27850	5	applied	\N	\N	\N	\N	150049	150049	317369
19697	27851	6	applied	\N	\N	\N	\N	150050	150050	317370
19697	27852	7	applied	\N	\N	\N	\N	150051	150051	317371
19697	27853	8	applied	\N	\N	\N	\N	150052	150052	317372
19697	27854	9	applied	\N	\N	\N	\N	150053	150053	317373
19697	27855	10	applied	\N	\N	\N	\N	150054	150054	317374
19697	27856	11	applied	\N	\N	\N	\N	150055	150055	317375
19697	27857	12	applied	\N	\N	\N	\N	150056	150056	317376
19697	27858	13	applied	\N	\N	\N	\N	150057	150057	317377
19697	27859	14	applied	\N	\N	\N	\N	150058	150058	317378
19697	27860	15	applied	\N	\N	\N	\N	150059	150059	317379
19697	27861	16	applied	\N	\N	\N	\N	150060	150060	317380
19700	27883	0	applied	\N	\N	\N	\N	150082	150082	317402
19700	27885	2	applied	\N	\N	\N	\N	150084	150084	317404
19702	27789	58	applied	\N	\N	\N	\N	150146	150146	317466
19702	27795	59	applied	\N	\N	\N	\N	150147	150147	317467
19702	27796	60	applied	\N	\N	\N	\N	150148	150148	317468
19702	27797	61	applied	\N	\N	\N	\N	150149	150149	317469
19702	27798	62	applied	\N	\N	\N	\N	150150	150150	317470
19702	27799	63	applied	\N	\N	\N	\N	150151	150151	317471
19702	27802	64	applied	\N	\N	\N	\N	150152	150152	317472
19702	27803	65	applied	\N	\N	\N	\N	150153	150153	317473
19702	27804	66	applied	\N	\N	\N	\N	150154	150154	317474
19702	27805	67	applied	\N	\N	\N	\N	150155	150155	317475
19702	27806	68	applied	\N	\N	\N	\N	150156	150156	317476
19702	27807	69	applied	\N	\N	\N	\N	150157	150157	317477
19702	27811	70	applied	\N	\N	\N	\N	150158	150158	317478
19702	27813	71	applied	\N	\N	\N	\N	150159	150159	317479
19702	27814	72	applied	\N	\N	\N	\N	150160	150160	317480
19702	27816	74	applied	\N	\N	\N	\N	150162	150162	317482
19702	27817	75	applied	\N	\N	\N	\N	150163	150163	317483
19702	27821	76	applied	\N	\N	\N	\N	150164	150164	317484
19702	27822	77	applied	\N	\N	\N	\N	150165	150165	317485
19702	27823	78	applied	\N	\N	\N	\N	150166	150166	317486
19702	27824	79	applied	\N	\N	\N	\N	150167	150167	317487
19702	27825	80	applied	\N	\N	\N	\N	150168	150168	317488
19702	27826	82	applied	\N	\N	\N	\N	150169	150169	317489
19703	27883	0	applied	\N	\N	\N	\N	150213	150213	317533
19703	27884	1	applied	\N	\N	\N	\N	150214	150214	317534
19703	27885	2	applied	\N	\N	\N	\N	150215	150215	317535
19705	27894	0	applied	\N	\N	\N	\N	150222	150222	317542
19705	27895	1	applied	\N	\N	\N	\N	150223	150223	317543
19705	27896	2	applied	\N	\N	\N	\N	150224	150224	317544
19705	27897	3	applied	\N	\N	\N	\N	150225	150225	317545
19705	27898	4	applied	\N	\N	\N	\N	150226	150226	317546
19708	27900	0	applied	\N	\N	\N	\N	150238	150238	317558
19708	27901	1	applied	\N	\N	\N	\N	150239	150239	317559
19708	27902	2	applied	\N	\N	\N	\N	150240	150240	317560
19708	27903	3	applied	\N	\N	\N	\N	150241	150241	317561
19708	27904	4	applied	\N	\N	\N	\N	150242	150242	317562
19712	27905	0	applied	\N	\N	\N	\N	150254	150254	317574
19712	27906	1	applied	\N	\N	\N	\N	150255	150255	317575
19712	27907	2	applied	\N	\N	\N	\N	150256	150256	317576
19715	27359	0	applied	\N	\N	1000000000	\N	150262	150262	317582
19715	27728	1	applied	\N	\N	\N	\N	150263	150263	317583
19715	27729	2	applied	\N	\N	\N	\N	150264	150264	317584
19715	27730	3	applied	\N	\N	\N	\N	150265	150265	317585
19715	27733	4	applied	\N	\N	\N	\N	150266	150266	317586
19715	27356	5	applied	\N	\N	\N	\N	150267	150267	317587
19715	27734	6	applied	\N	\N	\N	\N	150268	150268	317588
19715	27360	7	applied	\N	\N	\N	\N	150269	150269	317589
19715	27367	9	applied	\N	\N	\N	\N	150271	150271	317591
19715	27368	10	applied	\N	\N	\N	\N	150272	150272	317592
19715	27369	11	applied	\N	\N	\N	\N	150273	150273	317593
19715	27377	12	applied	\N	\N	\N	\N	150274	150274	317594
19715	27380	13	applied	\N	\N	\N	\N	150275	150275	317595
19715	27383	14	applied	\N	\N	\N	\N	150276	150276	317596
19715	27387	15	applied	\N	\N	\N	\N	150277	150277	317597
19715	27388	16	applied	\N	\N	\N	\N	150278	150278	317598
19715	27393	17	applied	\N	\N	\N	\N	150279	150279	317599
19715	27397	18	applied	\N	\N	\N	\N	150280	150280	317600
19715	27735	19	applied	\N	\N	\N	\N	150281	150281	317601
19715	27736	20	applied	\N	\N	\N	\N	150282	150282	317602
19715	27737	21	applied	\N	\N	\N	\N	150283	150283	317603
19715	27740	22	applied	\N	\N	\N	\N	150284	150284	317604
19715	27743	23	applied	\N	\N	\N	\N	150285	150285	317605
19715	27744	24	applied	\N	\N	\N	\N	150286	150286	317606
19715	27746	26	applied	\N	\N	\N	\N	150288	150288	317608
19715	27747	27	applied	\N	\N	\N	\N	150289	150289	317609
19715	27750	28	applied	\N	\N	\N	\N	150290	150290	317610
19715	27751	29	applied	\N	\N	\N	\N	150291	150291	317611
19715	27752	30	applied	\N	\N	\N	\N	150292	150292	317612
19715	27753	31	applied	\N	\N	\N	\N	150293	150293	317613
19715	27754	32	applied	\N	\N	\N	\N	150294	150294	317614
19715	27755	33	applied	\N	\N	\N	\N	150295	150295	317615
19715	27760	34	applied	\N	\N	\N	\N	150296	150296	317616
19715	27761	35	applied	\N	\N	\N	\N	150297	150297	317617
19715	27762	36	applied	\N	\N	\N	\N	150298	150298	317618
19715	27763	37	applied	\N	\N	\N	\N	150299	150299	317619
19715	27764	38	applied	\N	\N	\N	\N	150300	150300	317620
19715	27765	39	applied	\N	\N	\N	\N	150301	150301	317621
19715	27766	40	applied	\N	\N	\N	\N	150302	150302	317622
19715	27767	41	applied	\N	\N	\N	\N	150303	150303	317623
19694	27738	112	applied	\N	\N	\N	\N	150012	150012	317332
19702	27833	87	applied	\N	\N	\N	\N	150174	150174	317494
19702	27836	88	applied	\N	\N	\N	\N	150175	150175	317495
19702	27838	89	applied	\N	\N	\N	\N	150176	150176	317496
19702	27839	90	applied	\N	\N	\N	\N	150177	150177	317497
19702	27840	91	applied	\N	\N	\N	\N	150178	150178	317498
19702	27841	92	applied	\N	\N	\N	\N	150179	150179	317499
19702	27842	93	applied	\N	\N	\N	\N	150180	150180	317500
19702	27845	94	applied	\N	\N	\N	\N	150181	150181	317501
19702	27848	95	applied	\N	\N	\N	\N	150182	150182	317502
19702	27849	96	applied	\N	\N	\N	\N	150183	150183	317503
19702	27850	97	applied	\N	\N	\N	\N	150184	150184	317504
19702	27851	98	applied	\N	\N	\N	\N	150185	150185	317505
19702	27852	99	applied	\N	\N	\N	\N	150186	150186	317506
19702	27853	100	applied	\N	\N	\N	\N	150187	150187	317507
19702	27854	101	applied	\N	\N	\N	\N	150188	150188	317508
19702	27855	102	applied	\N	\N	\N	\N	150189	150189	317509
19702	27857	104	applied	\N	\N	\N	\N	150191	150191	317511
19702	27862	105	applied	\N	\N	\N	\N	150192	150192	317512
19702	27863	106	applied	\N	\N	\N	\N	150193	150193	317513
19702	27864	107	applied	\N	\N	\N	\N	150194	150194	317514
19702	27865	108	applied	\N	\N	\N	\N	150195	150195	317515
19702	27866	109	applied	\N	\N	\N	\N	150196	150196	317516
19702	27869	110	applied	\N	\N	\N	\N	150197	150197	317517
19702	27870	111	applied	\N	\N	\N	\N	150198	150198	317518
19702	27871	112	applied	\N	\N	\N	\N	150199	150199	317519
19702	27872	113	applied	\N	\N	\N	\N	150200	150200	317520
19702	27873	114	applied	\N	\N	\N	\N	150201	150201	317521
19702	27874	115	applied	\N	\N	\N	\N	150202	150202	317522
19702	27875	116	applied	\N	\N	\N	\N	150203	150203	317523
19702	27886	117	applied	\N	\N	\N	\N	150204	150204	317524
19702	27887	118	applied	\N	\N	\N	\N	150205	150205	317525
19702	27688	119	applied	\N	\N	\N	\N	150206	150206	317526
19702	27697	121	applied	\N	\N	\N	\N	150208	150208	317528
19702	27700	122	applied	\N	\N	\N	\N	150209	150209	317529
19702	27701	123	applied	\N	\N	\N	\N	150210	150210	317530
19702	27706	124	applied	\N	\N	\N	\N	150211	150211	317531
19702	27709	125	applied	\N	\N	\N	\N	150212	150212	317532
19704	27888	0	applied	\N	\N	\N	\N	150216	150216	317536
19704	27889	1	applied	\N	\N	\N	\N	150217	150217	317537
19704	27890	2	applied	\N	\N	\N	\N	150218	150218	317538
19704	27891	3	applied	\N	\N	\N	\N	150219	150219	317539
19704	27892	4	applied	\N	\N	\N	\N	150220	150220	317540
19704	27893	5	applied	\N	\N	\N	\N	150221	150221	317541
19707	27900	0	applied	\N	\N	\N	\N	150233	150233	317553
19707	27901	1	applied	\N	\N	\N	\N	150234	150234	317554
19707	27902	2	applied	\N	\N	\N	\N	150235	150235	317555
19707	27903	3	applied	\N	\N	\N	\N	150236	150236	317556
19707	27904	4	applied	\N	\N	\N	\N	150237	150237	317557
19709	27901	1	applied	\N	\N	\N	\N	150244	150244	317564
19709	27902	2	applied	\N	\N	\N	\N	150245	150245	317565
19709	27903	3	applied	\N	\N	\N	\N	150246	150246	317566
19709	27904	4	applied	\N	\N	\N	\N	150247	150247	317567
19711	27905	0	applied	\N	\N	\N	\N	150251	150251	317571
19711	27906	1	applied	\N	\N	\N	\N	150252	150252	317572
19711	27907	2	applied	\N	\N	\N	\N	150253	150253	317573
19714	27908	0	applied	\N	\N	\N	\N	150259	150259	317579
19714	27910	1	applied	\N	\N	\N	\N	150260	150260	317580
19714	27909	2	applied	\N	\N	\N	\N	150261	150261	317581
19715	27768	42	applied	\N	\N	\N	\N	150304	150304	317624
19715	27769	43	applied	\N	\N	\N	\N	150305	150305	317625
19715	27770	44	applied	\N	\N	\N	\N	150306	150306	317626
19715	27771	45	applied	\N	\N	\N	\N	150307	150307	317627
19715	27776	46	applied	\N	\N	\N	\N	150308	150308	317628
19715	27777	47	applied	\N	\N	\N	\N	150309	150309	317629
19715	27779	49	applied	\N	\N	\N	\N	150311	150311	317631
19715	27780	50	applied	\N	\N	\N	\N	150312	150312	317632
19715	27781	51	applied	\N	\N	\N	\N	150313	150313	317633
19715	27400	52	applied	\N	\N	\N	\N	150314	150314	317634
19715	27403	53	applied	\N	\N	\N	\N	150315	150315	317635
19715	27407	54	applied	\N	\N	\N	\N	150316	150316	317636
19715	27410	55	applied	\N	\N	\N	\N	150317	150317	317637
19715	27413	56	applied	\N	\N	\N	\N	150318	150318	317638
19715	27416	57	applied	\N	\N	\N	\N	150319	150319	317639
19715	27420	58	applied	\N	\N	\N	\N	150320	150320	317640
19715	27423	59	applied	\N	\N	\N	\N	150321	150321	317641
19715	27424	60	applied	\N	\N	\N	\N	150322	150322	317642
19715	27430	61	applied	\N	\N	\N	\N	150323	150323	317643
19715	27433	62	applied	\N	\N	\N	\N	150324	150324	317644
19715	27436	63	applied	\N	\N	\N	\N	150325	150325	317645
19715	27440	64	applied	\N	\N	\N	\N	150326	150326	317646
19716	27911	0	applied	\N	\N	\N	\N	150387	150387	317707
19716	27912	1	applied	\N	\N	\N	\N	150388	150388	317708
19716	27913	2	applied	\N	\N	\N	\N	150389	150389	317709
19716	27914	3	applied	\N	\N	\N	\N	150390	150390	317710
19716	27915	4	applied	\N	\N	\N	\N	150391	150391	317711
19716	27916	5	applied	\N	\N	\N	\N	150392	150392	317712
19716	27917	6	applied	\N	\N	\N	\N	150393	150393	317713
19716	27918	7	applied	\N	\N	\N	\N	150394	150394	317714
19716	27919	8	applied	\N	\N	\N	\N	150395	150395	317715
19719	27926	0	applied	\N	\N	\N	\N	150402	150402	317722
19719	27927	1	applied	\N	\N	\N	\N	150403	150403	317723
19719	27928	2	applied	\N	\N	\N	\N	150404	150404	317724
19719	27929	3	applied	\N	\N	\N	\N	150405	150405	317725
19721	27932	0	applied	\N	\N	\N	\N	150412	150412	317732
19721	27933	1	applied	\N	\N	\N	\N	150413	150413	317733
19721	27934	2	applied	\N	\N	\N	\N	150414	150414	317734
19728	27936	1	applied	\N	\N	\N	\N	150539	150539	317859
19728	27937	2	applied	\N	\N	\N	\N	150540	150540	317860
19728	27938	3	applied	\N	\N	\N	\N	150541	150541	317861
19728	27939	4	applied	\N	\N	\N	\N	150542	150542	317862
19728	27940	5	applied	\N	\N	\N	\N	150543	150543	317863
19732	27944	0	applied	\N	\N	\N	\N	150554	150554	317874
19732	27945	1	applied	\N	\N	\N	\N	150555	150555	317875
19732	27946	2	applied	\N	\N	\N	\N	150556	150556	317876
19736	27954	0	applied	\N	\N	\N	\N	150569	150569	317889
19736	27955	1	applied	\N	\N	\N	\N	150570	150570	317890
19737	27954	0	applied	\N	\N	\N	\N	150571	150571	317891
19737	27955	1	applied	\N	\N	\N	\N	150572	150572	317892
19739	27956	0	applied	\N	\N	\N	\N	150667	150667	317987
19739	27957	1	applied	\N	\N	\N	\N	150668	150668	317988
19702	27829	84	applied	\N	\N	\N	\N	150171	150171	317491
19702	27831	85	applied	\N	\N	\N	\N	150172	150172	317492
19715	27457	70	applied	\N	\N	\N	\N	150332	150332	317652
19715	27463	71	applied	\N	\N	\N	\N	150333	150333	317653
19715	27464	72	applied	\N	\N	\N	\N	150334	150334	317654
19715	27469	73	applied	\N	\N	\N	\N	150335	150335	317655
19715	27473	74	applied	\N	\N	\N	\N	150336	150336	317656
19715	27476	75	applied	\N	\N	\N	\N	150337	150337	317657
19715	27478	76	applied	\N	\N	\N	\N	150338	150338	317658
19715	27482	77	applied	\N	\N	\N	\N	150339	150339	317659
19715	27486	78	applied	\N	\N	\N	\N	150340	150340	317660
19715	27489	79	applied	\N	\N	\N	\N	150341	150341	317661
19715	27492	80	applied	\N	\N	\N	\N	150342	150342	317662
19715	27496	81	applied	\N	\N	\N	\N	150343	150343	317663
19715	27499	82	applied	\N	\N	\N	\N	150344	150344	317664
19715	27501	83	applied	\N	\N	\N	\N	150345	150345	317665
19715	27504	84	applied	\N	\N	\N	\N	150346	150346	317666
19715	27508	85	applied	\N	\N	\N	\N	150347	150347	317667
19715	27512	87	applied	\N	\N	\N	\N	150349	150349	317669
19715	27520	88	applied	\N	\N	\N	\N	150350	150350	317670
19715	27523	89	applied	\N	\N	\N	\N	150351	150351	317671
19715	27527	90	applied	\N	\N	\N	\N	150352	150352	317672
19715	27530	91	applied	\N	\N	\N	\N	150353	150353	317673
19715	27533	92	applied	\N	\N	\N	\N	150354	150354	317674
19715	27536	93	applied	\N	\N	\N	\N	150355	150355	317675
19715	27540	94	applied	\N	\N	\N	\N	150356	150356	317676
19715	27541	95	applied	\N	\N	\N	\N	150357	150357	317677
19715	27542	96	applied	\N	\N	\N	\N	150358	150358	317678
19715	27550	97	applied	\N	\N	\N	\N	150359	150359	317679
19715	27553	98	applied	\N	\N	\N	\N	150360	150360	317680
19715	27554	99	applied	\N	\N	\N	\N	150361	150361	317681
19715	27560	100	applied	\N	\N	\N	\N	150362	150362	317682
19715	27563	101	applied	\N	\N	\N	\N	150363	150363	317683
19715	27566	102	applied	\N	\N	\N	\N	150364	150364	317684
19715	27570	104	applied	\N	\N	\N	\N	150366	150366	317686
19715	27576	105	applied	\N	\N	\N	\N	150367	150367	317687
19715	27579	106	applied	\N	\N	\N	\N	150368	150368	317688
19715	27580	107	applied	\N	\N	\N	\N	150369	150369	317689
19715	27586	108	applied	\N	\N	\N	\N	150370	150370	317690
19715	27587	110	applied	\N	\N	\N	\N	150371	150371	317691
19715	27593	111	applied	\N	\N	\N	\N	150372	150372	317692
19715	27594	112	applied	\N	\N	\N	\N	150373	150373	317693
19715	27595	113	applied	\N	\N	\N	\N	150374	150374	317694
19715	27602	114	applied	\N	\N	\N	\N	150375	150375	317695
19715	27603	115	applied	\N	\N	\N	\N	150376	150376	317696
19715	27604	116	applied	\N	\N	\N	\N	150377	150377	317697
19715	27611	117	applied	\N	\N	\N	\N	150378	150378	317698
19715	27612	118	applied	\N	\N	\N	\N	150379	150379	317699
19715	27618	119	applied	\N	\N	\N	\N	150380	150380	317700
19715	27621	120	applied	\N	\N	\N	\N	150381	150381	317701
19715	27628	122	applied	\N	\N	\N	\N	150383	150383	317703
19715	27629	123	applied	\N	\N	\N	\N	150384	150384	317704
19715	27630	124	applied	\N	\N	\N	\N	150385	150385	317705
19715	27631	125	applied	\N	\N	\N	\N	150386	150386	317706
19717	27921	1	applied	\N	\N	\N	\N	150397	150397	317717
19717	27922	2	applied	\N	\N	\N	\N	150398	150398	317718
19720	27926	0	applied	\N	\N	\N	\N	150406	150406	317726
19720	27927	1	applied	\N	\N	\N	\N	150407	150407	317727
19720	27930	2	applied	\N	\N	\N	\N	150408	150408	317728
19720	27931	3	applied	\N	\N	\N	\N	150409	150409	317729
19720	27928	4	applied	\N	\N	\N	\N	150410	150410	317730
19720	27929	5	applied	\N	\N	\N	\N	150411	150411	317731
19722	27932	0	applied	\N	\N	\N	\N	150415	150415	317735
19722	27933	1	applied	\N	\N	\N	\N	150416	150416	317736
19722	27934	2	applied	\N	\N	\N	\N	150417	150417	317737
19724	27923	0	applied	\N	\N	\N	\N	150514	150514	317834
19724	27927	2	applied	\N	\N	\N	\N	150516	150516	317836
19724	27932	3	applied	\N	\N	\N	\N	150517	150517	317837
19724	27924	4	applied	\N	\N	\N	\N	150518	150518	317838
19724	27930	5	applied	\N	\N	\N	\N	150519	150519	317839
19724	27931	6	applied	\N	\N	\N	\N	150520	150520	317840
19724	27933	7	applied	\N	\N	\N	\N	150521	150521	317841
19724	27925	8	applied	\N	\N	\N	\N	150522	150522	317842
19724	27928	9	applied	\N	\N	\N	\N	150523	150523	317843
19724	27929	10	applied	\N	\N	\N	\N	150524	150524	317844
19724	27934	11	applied	\N	\N	\N	\N	150525	150525	317845
19725	27932	0	applied	\N	\N	\N	\N	150526	150526	317846
19725	27934	1	applied	\N	\N	\N	\N	150527	150527	317847
19726	27935	0	applied	\N	\N	\N	\N	150528	150528	317848
19726	27936	1	applied	\N	\N	\N	\N	150529	150529	317849
19726	27937	2	applied	\N	\N	\N	\N	150530	150530	317850
19726	27938	3	applied	\N	\N	\N	\N	150531	150531	317851
19726	27940	5	applied	\N	\N	\N	\N	150533	150533	317853
19727	27935	0	applied	\N	\N	\N	\N	150534	150534	317854
19727	27936	1	applied	\N	\N	\N	\N	150535	150535	317855
19727	27937	2	applied	\N	\N	\N	\N	150536	150536	317856
19727	27938	3	applied	\N	\N	\N	\N	150537	150537	317857
19729	27941	0	applied	\N	\N	\N	\N	150544	150544	317864
19729	27942	1	applied	\N	\N	\N	\N	150545	150545	317865
19731	27944	0	applied	\N	\N	\N	\N	150551	150551	317871
19731	27945	1	applied	\N	\N	\N	\N	150552	150552	317872
19731	27946	2	applied	\N	\N	\N	\N	150553	150553	317873
19733	27947	0	applied	\N	\N	\N	\N	150557	150557	317877
19733	27948	1	applied	\N	\N	\N	\N	150558	150558	317878
19733	27949	2	applied	\N	\N	\N	\N	150559	150559	317879
19733	27950	3	applied	\N	\N	\N	\N	150560	150560	317880
19733	27951	4	applied	\N	\N	\N	\N	150561	150561	317881
19733	27952	5	applied	\N	\N	\N	\N	150562	150562	317882
19734	27954	1	applied	\N	\N	\N	\N	150564	150564	317884
19734	27955	2	applied	\N	\N	\N	\N	150565	150565	317885
19738	27837	0	applied	\N	\N	\N	\N	150573	150573	317893
19738	27846	1	applied	\N	\N	\N	\N	150574	150574	317894
19738	27847	2	applied	\N	\N	\N	\N	150575	150575	317895
19738	27867	3	applied	\N	\N	\N	\N	150576	150576	317896
19738	27868	4	applied	\N	\N	\N	\N	150577	150577	317897
19740	27956	0	applied	\N	\N	\N	\N	150670	150670	317990
19740	27957	1	applied	\N	\N	\N	\N	150671	150671	317991
19740	27958	2	applied	\N	\N	\N	\N	150672	150672	317992
19746	27983	0	applied	\N	\N	\N	\N	150700	150700	318020
19746	27984	1	applied	\N	\N	\N	\N	150701	150701	318021
19746	27985	2	applied	\N	\N	\N	\N	150702	150702	318022
19765	28018	0	applied	\N	\N	\N	\N	150830	150830	318150
19715	27445	67	applied	\N	\N	\N	\N	150329	150329	317649
19715	27453	68	applied	\N	\N	\N	\N	150330	150330	317650
19730	27941	0	applied	\N	\N	\N	\N	150546	150546	317866
19730	27939	1	applied	\N	\N	\N	\N	150547	150547	317867
19730	27940	2	applied	\N	\N	\N	\N	150548	150548	317868
19730	27943	3	applied	\N	\N	\N	\N	150549	150549	317869
19730	27942	4	applied	\N	\N	\N	\N	150550	150550	317870
19735	27953	0	applied	\N	\N	\N	\N	150566	150566	317886
19735	27954	1	applied	\N	\N	\N	\N	150567	150567	317887
19735	27955	2	applied	\N	\N	\N	\N	150568	150568	317888
19738	27880	5	applied	\N	\N	\N	\N	150578	150578	317898
19738	27883	6	applied	\N	\N	\N	\N	150579	150579	317899
19738	27888	7	applied	\N	\N	\N	\N	150580	150580	317900
19738	27889	8	applied	\N	\N	\N	\N	150581	150581	317901
19738	27894	9	applied	\N	\N	\N	\N	150582	150582	317902
19738	27895	10	applied	\N	\N	\N	\N	150583	150583	317903
19738	27900	11	applied	\N	\N	\N	\N	150584	150584	317904
19738	27905	12	applied	\N	\N	\N	\N	150585	150585	317905
19738	27911	14	applied	\N	\N	\N	\N	150587	150587	317907
19738	27912	15	applied	\N	\N	\N	\N	150588	150588	317908
19738	27913	16	applied	\N	\N	\N	\N	150589	150589	317909
19738	27920	17	applied	\N	\N	\N	\N	150590	150590	317910
19738	27923	18	applied	\N	\N	\N	\N	150591	150591	317911
19738	27926	19	applied	\N	\N	\N	\N	150592	150592	317912
19738	27927	20	applied	\N	\N	\N	\N	150593	150593	317913
19738	27932	21	applied	\N	\N	\N	\N	150594	150594	317914
19738	27935	22	applied	\N	\N	\N	\N	150595	150595	317915
19738	27936	23	applied	\N	\N	\N	\N	150596	150596	317916
19738	27941	24	applied	\N	\N	\N	\N	150597	150597	317917
19738	27944	25	applied	\N	\N	\N	\N	150598	150598	317918
19738	27947	26	applied	\N	\N	\N	\N	150599	150599	317919
19738	27948	27	applied	\N	\N	\N	\N	150600	150600	317920
19738	27953	28	applied	\N	\N	\N	\N	150601	150601	317921
19738	27703	29	applied	\N	\N	\N	\N	150602	150602	317922
19738	27858	31	applied	\N	\N	\N	\N	150604	150604	317924
19738	27859	32	applied	\N	\N	\N	\N	150605	150605	317925
19738	27877	33	applied	\N	\N	\N	\N	150606	150606	317926
19738	27705	34	applied	\N	\N	\N	\N	150607	150607	317927
19738	27708	35	applied	\N	\N	\N	\N	150608	150608	317928
19738	27710	36	applied	\N	\N	\N	\N	150609	150609	317929
19738	27879	37	applied	\N	\N	\N	\N	150610	150610	317930
19738	27881	38	applied	\N	\N	\N	\N	150611	150611	317931
19738	27885	39	applied	\N	\N	\N	\N	150612	150612	317932
19738	27890	40	applied	\N	\N	\N	\N	150613	150613	317933
19738	27893	41	applied	\N	\N	\N	\N	150614	150614	317934
19738	27896	42	applied	\N	\N	\N	\N	150615	150615	317935
19738	27899	43	applied	\N	\N	\N	\N	150616	150616	317936
19738	27903	44	applied	\N	\N	\N	\N	150617	150617	317937
19738	27906	45	applied	\N	\N	\N	\N	150618	150618	317938
19738	27717	46	applied	\N	\N	\N	\N	150619	150619	317939
19738	27720	48	applied	\N	\N	\N	\N	150621	150621	317941
19738	27723	50	applied	\N	\N	\N	\N	150622	150622	317942
19738	27727	51	applied	\N	\N	\N	\N	150623	150623	317943
19738	27739	52	applied	\N	\N	\N	\N	150624	150624	317944
19738	27748	53	applied	\N	\N	\N	\N	150625	150625	317945
19738	27756	54	applied	\N	\N	\N	\N	150626	150626	317946
19738	27772	55	applied	\N	\N	\N	\N	150627	150627	317947
19738	27773	56	applied	\N	\N	\N	\N	150628	150628	317948
19738	27790	57	applied	\N	\N	\N	\N	150629	150629	317949
19738	27791	58	applied	\N	\N	\N	\N	150630	150630	317950
19738	27801	59	applied	\N	\N	\N	\N	150631	150631	317951
19738	27810	60	applied	\N	\N	\N	\N	150632	150632	317952
19738	27819	61	applied	\N	\N	\N	\N	150633	150633	317953
19738	27827	62	applied	\N	\N	\N	\N	150634	150634	317954
19738	27834	63	applied	\N	\N	\N	\N	150635	150635	317955
19738	27843	64	applied	\N	\N	\N	\N	150636	150636	317956
19738	27861	66	applied	\N	\N	\N	\N	150638	150638	317958
19738	27876	67	applied	\N	\N	\N	\N	150639	150639	317959
19738	27878	68	applied	\N	\N	\N	\N	150640	150640	317960
19738	27882	69	applied	\N	\N	\N	\N	150641	150641	317961
19738	27884	70	applied	\N	\N	\N	\N	150642	150642	317962
19738	27891	71	applied	\N	\N	\N	\N	150643	150643	317963
19738	27892	72	applied	\N	\N	\N	\N	150644	150644	317964
19738	27897	73	applied	\N	\N	\N	\N	150645	150645	317965
19738	27898	74	applied	\N	\N	\N	\N	150646	150646	317966
19738	27904	75	applied	\N	\N	\N	\N	150647	150647	317967
19738	27907	76	applied	\N	\N	\N	\N	150648	150648	317968
19738	27910	77	applied	\N	\N	\N	\N	150649	150649	317969
19738	27915	78	applied	\N	\N	\N	\N	150650	150650	317970
19738	27916	79	applied	\N	\N	\N	\N	150651	150651	317971
19738	27921	80	applied	\N	\N	\N	\N	150652	150652	317972
19738	27925	81	applied	\N	\N	\N	\N	150653	150653	317973
19738	27929	83	applied	\N	\N	\N	\N	150655	150655	317975
19738	27909	84	applied	\N	\N	\N	\N	150656	150656	317976
19738	27917	85	applied	\N	\N	\N	\N	150657	150657	317977
19738	27918	86	applied	\N	\N	\N	\N	150658	150658	317978
19738	27919	87	applied	\N	\N	\N	\N	150659	150659	317979
19738	27922	88	applied	\N	\N	\N	\N	150660	150660	317980
19738	27924	89	applied	\N	\N	\N	\N	150661	150661	317981
19738	27930	90	applied	\N	\N	\N	\N	150662	150662	317982
19738	27931	91	applied	\N	\N	\N	\N	150663	150663	317983
19738	27933	92	applied	\N	\N	\N	\N	150664	150664	317984
19738	27939	93	applied	\N	\N	\N	\N	150665	150665	317985
19738	27940	94	applied	\N	\N	\N	\N	150666	150666	317986
19741	27959	0	applied	\N	\N	\N	\N	150673	150673	317993
19741	27960	1	applied	\N	\N	\N	\N	150674	150674	317994
19741	27961	2	applied	\N	\N	\N	\N	150675	150675	317995
19743	27962	0	applied	\N	\N	\N	\N	150679	150679	317999
19747	27986	0	applied	\N	\N	\N	\N	150703	150703	318023
19747	27987	1	applied	\N	\N	\N	\N	150704	150704	318024
19747	27988	2	applied	\N	\N	\N	\N	150705	150705	318025
19749	27908	0	applied	\N	\N	\N	\N	150709	150709	318029
19749	27911	1	applied	\N	\N	\N	\N	150710	150710	318030
19749	27912	2	applied	\N	\N	\N	\N	150711	150711	318031
19749	27913	3	applied	\N	\N	\N	\N	150712	150712	318032
19749	27920	4	applied	\N	\N	\N	\N	150713	150713	318033
19749	27914	5	applied	\N	\N	\N	\N	150714	150714	318034
19749	27923	6	applied	\N	\N	\N	\N	150715	150715	318035
19754	27995	0	applied	\N	\N	\N	\N	150802	150802	318122
19754	27996	1	applied	\N	\N	\N	\N	150803	150803	318123
19754	27997	2	applied	\N	\N	\N	\N	150804	150804	318124
19756	27998	0	applied	\N	\N	\N	\N	150807	150807	318127
19723	27866	93	applied	\N	\N	\N	\N	150511	150511	317831
19723	27869	94	applied	\N	\N	\N	\N	150512	150512	317832
19744	27964	0	applied	\N	\N	\N	\N	150681	150681	318001
19744	27965	1	applied	\N	\N	\N	\N	150682	150682	318002
19744	27966	2	applied	\N	\N	\N	\N	150683	150683	318003
19744	27967	3	applied	\N	\N	\N	\N	150684	150684	318004
19744	27968	4	applied	\N	\N	\N	\N	150685	150685	318005
19744	27969	5	applied	\N	\N	\N	\N	150686	150686	318006
19744	27970	6	applied	\N	\N	\N	\N	150687	150687	318007
19745	27971	0	applied	\N	\N	\N	\N	150688	150688	318008
19745	27972	1	applied	\N	\N	\N	\N	150689	150689	318009
19745	27973	2	applied	\N	\N	\N	\N	150690	150690	318010
19745	27974	3	applied	\N	\N	\N	\N	150691	150691	318011
19745	27975	4	applied	\N	\N	\N	\N	150692	150692	318012
19745	27976	5	applied	\N	\N	\N	\N	150693	150693	318013
19745	27977	6	applied	\N	\N	\N	\N	150694	150694	318014
19745	27979	8	applied	\N	\N	\N	\N	150696	150696	318016
19745	27980	9	applied	\N	\N	\N	\N	150697	150697	318017
19745	27981	10	applied	\N	\N	\N	\N	150698	150698	318018
19745	27982	11	applied	\N	\N	\N	\N	150699	150699	318019
19748	27986	0	applied	\N	\N	\N	\N	150706	150706	318026
19756	27999	1	applied	\N	\N	\N	\N	150808	150808	318128
19756	28000	2	applied	\N	\N	\N	\N	150809	150809	318129
19759	28001	0	applied	\N	\N	\N	\N	150813	150813	318133
19759	28002	1	applied	\N	\N	\N	\N	150814	150814	318134
19759	28003	2	applied	\N	\N	\N	\N	150815	150815	318135
19761	28006	0	applied	\N	\N	\N	\N	150818	150818	318138
19761	28007	1	applied	\N	\N	\N	\N	150819	150819	318139
19761	28008	2	applied	\N	\N	\N	\N	150820	150820	318140
19761	28009	3	applied	\N	\N	\N	\N	150821	150821	318141
19761	28010	4	applied	\N	\N	\N	\N	150822	150822	318142
19761	28011	5	applied	\N	\N	\N	\N	150823	150823	318143
19770	28029	1	applied	\N	\N	\N	\N	150953	150953	318273
19770	28030	2	applied	\N	\N	\N	\N	150954	150954	318274
19779	28056	0	applied	\N	\N	\N	\N	150990	150990	318310
19779	28057	1	applied	\N	\N	\N	\N	150991	150991	318311
19779	28058	2	applied	\N	\N	\N	\N	150992	150992	318312
19779	28059	3	applied	\N	\N	\N	\N	150993	150993	318313
19779	28060	4	applied	\N	\N	\N	\N	150994	150994	318314
19779	28061	5	applied	\N	\N	\N	\N	150995	150995	318315
19779	28062	6	applied	\N	\N	\N	\N	150996	150996	318316
19787	28082	0	applied	\N	\N	\N	\N	151033	151033	318353
19787	28083	1	applied	\N	\N	\N	\N	151034	151034	318354
19787	28084	2	applied	\N	\N	\N	\N	151035	151035	318355
19787	28085	3	applied	\N	\N	1000000000	\N	151036	151036	318356
19787	28086	4	applied	\N	\N	\N	\N	151037	151037	318357
19787	28087	5	applied	\N	\N	\N	\N	151038	151038	318358
19787	28088	6	applied	\N	\N	\N	\N	151039	151039	318359
19789	28094	1	applied	\N	\N	\N	\N	151045	151045	318365
19789	28095	2	applied	\N	\N	\N	\N	151046	151046	318366
19795	28103	0	applied	\N	\N	\N	\N	151062	151062	318382
19795	28104	1	applied	\N	\N	\N	\N	151063	151063	318383
19795	28105	2	applied	\N	\N	\N	\N	151064	151064	318384
19799	28109	0	applied	\N	\N	\N	\N	151079	151079	318399
19799	28110	1	applied	\N	\N	\N	\N	151080	151080	318400
19799	28111	2	applied	\N	\N	\N	\N	151081	151081	318401
19799	28112	3	applied	\N	\N	\N	\N	151082	151082	318402
19799	28113	4	applied	\N	\N	\N	\N	151083	151083	318403
19799	28114	5	applied	\N	\N	\N	\N	151084	151084	318404
19799	28115	6	applied	\N	\N	\N	\N	151085	151085	318405
19799	28116	7	applied	\N	\N	\N	\N	151086	151086	318406
19801	28109	0	applied	\N	\N	\N	\N	151095	151095	318415
19801	28110	1	applied	\N	\N	\N	\N	151096	151096	318416
19801	28111	2	applied	\N	\N	\N	\N	151097	151097	318417
19801	28113	4	applied	\N	\N	\N	\N	151099	151099	318419
19801	28114	5	applied	\N	\N	\N	\N	151100	151100	318420
19801	28115	6	applied	\N	\N	\N	\N	151101	151101	318421
19801	28116	7	applied	\N	\N	\N	\N	151102	151102	318422
19808	28138	0	applied	\N	\N	\N	\N	151137	151137	318457
19808	28139	1	applied	\N	\N	\N	\N	151138	151138	318458
19808	28140	2	applied	\N	\N	\N	\N	151139	151139	318459
19814	28144	0	applied	\N	\N	\N	\N	151151	151151	318471
19814	28145	1	applied	\N	\N	\N	\N	151152	151152	318472
19815	28146	0	applied	\N	\N	\N	\N	151153	151153	318473
19815	28147	1	applied	\N	\N	\N	\N	151154	151154	318474
19815	28148	2	applied	\N	\N	\N	\N	151155	151155	318475
19815	28149	3	applied	\N	\N	\N	\N	151156	151156	318476
19815	28150	4	applied	\N	\N	\N	\N	151157	151157	318477
19815	28151	5	applied	\N	\N	\N	\N	151158	151158	318478
19815	28152	6	applied	\N	\N	\N	\N	151159	151159	318479
19819	28161	1	applied	\N	\N	\N	\N	151170	151170	318490
19819	28162	2	applied	\N	\N	\N	\N	151171	151171	318491
19819	28163	3	applied	\N	\N	\N	\N	151172	151172	318492
19824	28177	0	applied	\N	\N	\N	\N	151191	151191	318509
19824	28178	1	applied	\N	\N	\N	\N	151192	151192	318510
19824	28179	2	applied	\N	\N	\N	\N	151193	151193	318511
19830	28182	0	applied	\N	\N	\N	\N	151207	151207	318525
19830	28183	1	applied	\N	\N	\N	\N	151208	151208	318526
19830	28184	2	applied	\N	\N	\N	\N	151209	151209	318527
19833	28188	0	applied	\N	\N	\N	\N	151216	151216	318534
19833	28189	1	applied	\N	\N	\N	\N	151217	151217	318535
19833	28190	2	applied	\N	\N	\N	\N	151218	151218	318536
19843	28208	0	applied	\N	\N	\N	\N	151249	151249	318567
19843	28209	1	applied	\N	\N	\N	\N	151250	151250	318568
19843	28210	2	applied	\N	\N	\N	\N	151251	151251	318569
19847	28109	0	applied	\N	\N	\N	\N	151265	151265	318583
19847	28111	2	applied	\N	\N	\N	\N	151267	151267	318585
19847	28112	3	applied	\N	\N	\N	\N	151268	151268	318586
19847	27728	4	applied	\N	\N	\N	\N	151269	151269	318587
19847	27729	5	applied	\N	\N	\N	\N	151270	151270	318588
19847	27730	6	applied	\N	\N	\N	\N	151271	151271	318589
19847	27733	7	applied	\N	\N	\N	\N	151272	151272	318590
19847	27734	8	applied	\N	\N	\N	\N	151273	151273	318591
19847	27735	9	applied	\N	\N	\N	\N	151274	151274	318592
19847	27736	10	applied	\N	\N	\N	\N	151275	151275	318593
19847	27737	11	applied	\N	\N	\N	\N	151276	151276	318594
19847	27740	12	applied	\N	\N	\N	\N	151277	151277	318595
19847	27743	13	applied	\N	\N	\N	\N	151278	151278	318596
19847	27744	14	applied	\N	\N	\N	\N	151279	151279	318597
19847	27745	15	applied	\N	\N	\N	\N	151280	151280	318598
19847	27746	16	applied	\N	\N	\N	\N	151281	151281	318599
19847	27747	17	applied	\N	\N	\N	\N	151282	151282	318600
19742	27961	2	applied	\N	\N	\N	\N	150678	150678	317998
19749	27927	8	applied	\N	\N	\N	\N	150717	150717	318037
19749	27932	9	applied	\N	\N	\N	\N	150718	150718	318038
19749	27935	10	applied	\N	\N	\N	\N	150719	150719	318039
19749	27936	11	applied	\N	\N	\N	\N	150720	150720	318040
19749	27941	12	applied	\N	\N	\N	\N	150721	150721	318041
19749	27944	13	applied	\N	\N	\N	\N	150722	150722	318042
19749	27947	14	applied	\N	\N	\N	\N	150723	150723	318043
19749	27948	15	applied	\N	\N	\N	\N	150724	150724	318044
19749	27953	16	applied	\N	\N	\N	\N	150725	150725	318045
19749	27956	17	applied	\N	\N	\N	\N	150726	150726	318046
19749	27959	18	applied	\N	\N	\N	\N	150727	150727	318047
19749	27962	19	applied	\N	\N	\N	\N	150728	150728	318048
19749	27964	20	applied	\N	\N	\N	\N	150729	150729	318049
19749	27965	21	applied	\N	\N	\N	\N	150730	150730	318050
19749	27972	23	applied	\N	\N	\N	\N	150732	150732	318052
19749	27973	24	applied	\N	\N	\N	\N	150733	150733	318053
19749	27974	25	applied	\N	\N	\N	\N	150734	150734	318054
19749	27983	26	applied	\N	\N	\N	\N	150735	150735	318055
19749	27986	27	applied	\N	\N	\N	\N	150736	150736	318056
19749	27989	28	applied	\N	\N	\N	\N	150737	150737	318057
19749	27910	29	applied	\N	\N	\N	\N	150738	150738	318058
19749	27915	30	applied	\N	\N	\N	\N	150739	150739	318059
19750	27989	0	applied	\N	\N	\N	\N	150793	150793	318113
19750	27991	1	applied	\N	\N	\N	\N	150794	150794	318114
19750	27990	2	applied	\N	\N	\N	\N	150795	150795	318115
19753	27992	0	applied	\N	\N	\N	\N	150799	150799	318119
19753	27993	1	applied	\N	\N	\N	\N	150800	150800	318120
19753	27994	2	applied	\N	\N	\N	\N	150801	150801	318121
19755	27996	0	applied	\N	\N	\N	\N	150805	150805	318125
19755	27997	1	applied	\N	\N	\N	\N	150806	150806	318126
19762	28013	1	applied	\N	\N	\N	\N	150825	150825	318145
19762	28014	2	applied	\N	\N	\N	\N	150826	150826	318146
19764	28015	0	applied	\N	\N	\N	\N	150827	150827	318147
19764	28016	1	applied	\N	\N	\N	\N	150828	150828	318148
19764	28017	2	applied	\N	\N	\N	\N	150829	150829	318149
19771	28031	0	applied	\N	\N	\N	\N	150955	150955	318275
19771	28032	1	applied	\N	\N	\N	\N	150956	150956	318276
19771	28033	2	applied	\N	\N	\N	\N	150957	150957	318277
19774	28047	0	applied	\N	\N	\N	\N	150971	150971	318291
19774	28048	1	applied	\N	\N	\N	\N	150972	150972	318292
19774	28049	2	applied	\N	\N	\N	\N	150973	150973	318293
19784	28072	0	applied	\N	\N	\N	\N	151016	151016	318336
19784	28073	1	applied	\N	\N	\N	\N	151017	151017	318337
19784	28074	2	applied	\N	\N	\N	\N	151018	151018	318338
19790	28096	0	applied	\N	\N	\N	\N	151047	151047	318367
19790	28097	1	applied	\N	\N	\N	\N	151048	151048	318368
19792	28099	0	applied	\N	\N	\N	\N	151053	151053	318373
19792	28100	1	applied	\N	\N	\N	\N	151054	151054	318374
19792	28101	2	applied	\N	\N	\N	\N	151055	151055	318375
19792	28102	3	applied	\N	\N	\N	\N	151056	151056	318376
19809	28138	0	applied	\N	\N	\N	\N	151140	151140	318460
19809	28139	1	applied	\N	\N	\N	\N	151141	151141	318461
19809	28140	2	applied	\N	\N	\N	\N	151142	151142	318462
19817	28158	0	applied	\N	\N	\N	\N	151165	151165	318485
19817	28159	1	applied	\N	\N	\N	\N	151166	151166	318486
19820	28166	3	applied	\N	\N	\N	\N	151175	151175	318493
19820	28167	4	applied	\N	\N	\N	\N	151176	151176	318494
19820	28168	5	applied	\N	\N	\N	\N	151177	151177	318495
19820	28169	6	applied	\N	\N	\N	\N	151178	151178	318496
19822	28170	0	applied	\N	\N	\N	\N	151184	151184	318502
19822	28171	1	applied	\N	\N	\N	\N	151185	151185	318503
19825	28180	0	applied	\N	\N	\N	\N	151194	151194	318512
19825	28181	1	applied	\N	\N	\N	\N	151195	151195	318513
19827	28182	0	applied	\N	\N	\N	\N	151198	151198	318516
19827	28183	1	applied	\N	\N	\N	\N	151199	151199	318517
19827	28184	2	applied	\N	\N	\N	\N	151200	151200	318518
19836	28195	0	applied	\N	\N	\N	\N	151226	151226	318544
19836	28196	1	applied	\N	\N	\N	\N	151227	151227	318545
19836	28197	2	applied	\N	\N	\N	\N	151228	151228	318546
19841	28204	0	applied	\N	\N	\N	\N	151242	151242	318560
19841	28205	1	applied	\N	\N	\N	\N	151243	151243	318561
19841	28206	2	applied	\N	\N	\N	\N	151244	151244	318562
19841	28207	3	applied	\N	\N	\N	\N	151245	151245	318563
19844	28208	0	applied	\N	\N	\N	\N	151252	151252	318570
19844	28209	1	applied	\N	\N	\N	\N	151253	151253	318571
19844	28210	2	applied	\N	\N	\N	\N	151254	151254	318572
19850	28221	0	applied	\N	\N	\N	\N	151299	151299	318617
19850	28222	1	applied	\N	\N	\N	\N	151300	151300	318618
19850	28223	2	applied	\N	\N	\N	\N	151301	151301	318619
19850	28224	3	applied	\N	\N	1000000000	\N	151302	151302	318620
19850	28225	4	applied	\N	\N	\N	\N	151303	151303	318621
19850	28226	5	applied	\N	\N	\N	\N	151304	151304	318622
19853	28227	0	applied	\N	\N	\N	\N	151316	151316	318634
19853	28228	1	applied	\N	\N	\N	\N	151317	151317	318635
19853	28232	2	applied	\N	\N	\N	\N	151318	151318	318636
19853	28230	4	applied	\N	\N	\N	\N	151320	151320	318638
19853	28231	5	applied	\N	\N	\N	\N	151321	151321	318639
19856	28233	0	applied	\N	\N	\N	\N	151328	151328	318646
19856	28234	1	applied	\N	\N	\N	\N	151329	151329	318647
19856	28235	2	applied	\N	\N	\N	\N	151330	151330	318648
19856	28236	3	applied	\N	\N	1000000000	\N	151331	151331	318649
19856	28237	4	applied	\N	\N	\N	\N	151332	151332	318650
19856	28238	5	applied	\N	\N	\N	\N	151333	151333	318651
19862	28248	0	applied	\N	\N	\N	\N	151359	151359	318677
19862	28249	1	applied	\N	\N	\N	\N	151360	151360	318678
19862	28250	2	applied	\N	\N	\N	\N	151361	151361	318679
19862	28251	4	applied	\N	\N	\N	\N	151362	151362	318680
19862	28252	5	applied	\N	\N	\N	\N	151363	151363	318681
19867	28260	0	applied	\N	\N	\N	\N	151396	151396	318714
19867	28261	1	applied	\N	\N	\N	\N	151397	151397	318715
19867	28262	2	applied	\N	\N	\N	\N	151398	151398	318716
19867	28264	4	applied	\N	\N	\N	\N	151400	151400	318718
19867	28265	5	applied	\N	\N	\N	\N	151401	151401	318719
19867	28266	6	applied	\N	\N	\N	\N	151402	151402	318720
19867	28267	7	applied	\N	\N	\N	\N	151403	151403	318721
19867	28268	8	applied	\N	\N	\N	\N	151404	151404	318722
19867	28269	9	applied	\N	\N	\N	\N	151405	151405	318723
19867	28270	10	applied	\N	\N	\N	\N	151406	151406	318724
19748	27988	2	applied	\N	\N	\N	\N	150708	150708	318028
19749	27926	7	applied	\N	\N	\N	\N	150716	150716	318036
19749	27928	34	applied	\N	\N	\N	\N	150743	150743	318063
19749	27929	35	applied	\N	\N	\N	\N	150744	150744	318064
19749	27909	36	applied	\N	\N	\N	\N	150745	150745	318065
19749	27917	37	applied	\N	\N	\N	\N	150746	150746	318066
19749	27918	38	applied	\N	\N	\N	\N	150747	150747	318067
19749	27922	40	applied	\N	\N	\N	\N	150749	150749	318069
19749	27924	41	applied	\N	\N	\N	\N	150750	150750	318070
19749	27930	42	applied	\N	\N	\N	\N	150751	150751	318071
19749	27931	43	applied	\N	\N	\N	\N	150752	150752	318072
19749	27933	44	applied	\N	\N	\N	\N	150753	150753	318073
19749	27939	45	applied	\N	\N	\N	\N	150754	150754	318074
19749	27940	46	applied	\N	\N	\N	\N	150755	150755	318075
19749	27943	47	applied	\N	\N	\N	\N	150756	150756	318076
19749	27946	48	applied	\N	\N	\N	\N	150757	150757	318077
19749	27949	49	applied	\N	\N	\N	\N	150758	150758	318078
19749	27950	50	applied	\N	\N	\N	\N	150759	150759	318079
19749	27954	51	applied	\N	\N	\N	\N	150760	150760	318080
19749	27957	52	applied	\N	\N	\N	\N	150761	150761	318081
19749	27960	53	applied	\N	\N	\N	\N	150762	150762	318082
19749	27966	54	applied	\N	\N	\N	\N	150763	150763	318083
19749	27969	55	applied	\N	\N	\N	\N	150764	150764	318084
19749	27975	57	applied	\N	\N	\N	\N	150766	150766	318086
19749	27980	58	applied	\N	\N	\N	\N	150767	150767	318087
19749	27981	59	applied	\N	\N	\N	\N	150768	150768	318088
19749	27982	60	applied	\N	\N	\N	\N	150769	150769	318089
19749	27984	61	applied	\N	\N	\N	\N	150770	150770	318090
19749	27987	62	applied	\N	\N	\N	\N	150771	150771	318091
19749	27990	63	applied	\N	\N	\N	\N	150772	150772	318092
19749	27934	64	applied	\N	\N	\N	\N	150773	150773	318093
19749	27937	65	applied	\N	\N	\N	\N	150774	150774	318094
19749	27938	66	applied	\N	\N	\N	\N	150775	150775	318095
19749	27942	67	applied	\N	\N	\N	\N	150776	150776	318096
19749	27945	68	applied	\N	\N	\N	\N	150777	150777	318097
19749	27951	69	applied	\N	\N	\N	\N	150778	150778	318098
19749	27952	70	applied	\N	\N	\N	\N	150779	150779	318099
19749	27955	71	applied	\N	\N	\N	\N	150780	150780	318100
19749	27958	72	applied	\N	\N	\N	\N	150781	150781	318101
19749	27963	74	applied	\N	\N	\N	\N	150783	150783	318103
19749	27967	75	applied	\N	\N	\N	\N	150784	150784	318104
19749	27968	76	applied	\N	\N	\N	\N	150785	150785	318105
19749	27976	77	applied	\N	\N	\N	\N	150786	150786	318106
19749	27977	78	applied	\N	\N	\N	\N	150787	150787	318107
19749	27978	79	applied	\N	\N	\N	\N	150788	150788	318108
19749	27979	80	applied	\N	\N	\N	\N	150789	150789	318109
19749	27985	81	applied	\N	\N	\N	\N	150790	150790	318110
19749	27988	82	applied	\N	\N	\N	\N	150791	150791	318111
19749	27991	83	applied	\N	\N	\N	\N	150792	150792	318112
19751	27992	0	applied	\N	\N	\N	\N	150796	150796	318116
19751	27993	1	applied	\N	\N	\N	\N	150797	150797	318117
19751	27994	2	applied	\N	\N	\N	\N	150798	150798	318118
19758	28001	0	applied	\N	\N	\N	\N	150810	150810	318130
19758	28002	1	applied	\N	\N	\N	\N	150811	150811	318131
19758	28003	2	applied	\N	\N	\N	\N	150812	150812	318132
19760	28005	1	applied	\N	\N	\N	\N	150817	150817	318137
19765	28019	1	applied	\N	\N	\N	\N	150831	150831	318151
19765	28020	2	applied	\N	\N	1000000000	\N	150832	150832	318152
19765	28021	3	applied	\N	\N	\N	\N	150833	150833	318153
19765	28022	4	applied	\N	\N	\N	\N	150834	150834	318154
19765	28023	5	applied	\N	\N	1000000000	\N	150835	150835	318155
19765	28024	6	applied	\N	\N	\N	\N	150836	150836	318156
19765	28025	7	applied	\N	\N	\N	\N	150837	150837	318157
19765	28026	8	applied	\N	\N	\N	\N	150838	150838	318158
19765	28027	9	applied	\N	\N	\N	\N	150839	150839	318159
19766	28020	0	applied	\N	\N	1000000000	\N	150840	150840	318160
19766	28023	1	applied	\N	\N	1000000000	\N	150841	150841	318161
19766	28024	2	applied	\N	\N	\N	\N	150842	150842	318162
19766	28025	3	applied	\N	\N	\N	\N	150843	150843	318163
19766	28026	4	applied	\N	\N	\N	\N	150844	150844	318164
19766	28027	5	applied	\N	\N	\N	\N	150845	150845	318165
19767	28019	1	applied	\N	\N	\N	\N	150847	150847	318167
19767	28020	2	applied	\N	\N	1000000000	\N	150848	150848	318168
19767	28021	3	applied	\N	\N	\N	\N	150849	150849	318169
19767	28022	4	applied	\N	\N	\N	\N	150850	150850	318170
19767	28023	5	applied	\N	\N	1000000000	\N	150851	150851	318171
19767	28024	6	applied	\N	\N	\N	\N	150852	150852	318172
19767	28025	7	applied	\N	\N	\N	\N	150853	150853	318173
19767	28026	8	applied	\N	\N	\N	\N	150854	150854	318174
19767	28027	9	applied	\N	\N	\N	\N	150855	150855	318175
19768	27935	0	applied	\N	\N	\N	\N	150856	150856	318176
19768	27936	1	applied	\N	\N	\N	\N	150857	150857	318177
19768	27941	2	applied	\N	\N	\N	\N	150858	150858	318178
19768	27944	3	applied	\N	\N	\N	\N	150859	150859	318179
19768	27947	4	applied	\N	\N	\N	\N	150860	150860	318180
19768	27948	5	applied	\N	\N	\N	\N	150861	150861	318181
19768	27953	6	applied	\N	\N	\N	\N	150862	150862	318182
19768	27959	8	applied	\N	\N	\N	\N	150864	150864	318184
19768	27962	9	applied	\N	\N	\N	\N	150865	150865	318185
19768	27964	10	applied	\N	\N	\N	\N	150866	150866	318186
19768	27965	11	applied	\N	\N	\N	\N	150867	150867	318187
19768	27971	12	applied	\N	\N	\N	\N	150868	150868	318188
19768	27972	13	applied	\N	\N	\N	\N	150869	150869	318189
19768	27973	14	applied	\N	\N	\N	\N	150870	150870	318190
19768	27974	15	applied	\N	\N	\N	\N	150871	150871	318191
19768	27983	16	applied	\N	\N	\N	\N	150872	150872	318192
19768	27986	17	applied	\N	\N	\N	\N	150873	150873	318193
19768	27989	18	applied	\N	\N	\N	\N	150874	150874	318194
19768	27992	19	applied	\N	\N	\N	\N	150875	150875	318195
19768	27995	20	applied	\N	\N	\N	\N	150876	150876	318196
19768	27998	21	applied	\N	\N	\N	\N	150877	150877	318197
19768	28001	22	applied	\N	\N	\N	\N	150878	150878	318198
19768	28004	23	applied	\N	\N	\N	\N	150879	150879	318199
19768	28007	25	applied	\N	\N	\N	\N	150881	150881	318201
19768	28012	26	applied	\N	\N	\N	\N	150882	150882	318202
19768	28015	27	applied	\N	\N	\N	\N	150883	150883	318203
19769	28028	0	applied	\N	\N	\N	\N	150949	150949	318269
19769	28029	1	applied	\N	\N	\N	\N	150950	150950	318270
19769	28030	2	applied	\N	\N	\N	\N	150951	150951	318271
19772	28034	0	applied	\N	\N	\N	\N	150958	150958	318278
19772	28035	1	applied	\N	\N	\N	\N	150959	150959	318279
19749	27921	32	applied	\N	\N	\N	\N	150741	150741	318061
19749	27925	33	applied	\N	\N	\N	\N	150742	150742	318062
19768	28022	31	applied	\N	\N	\N	\N	150887	150887	318207
19768	27938	32	applied	\N	\N	\N	\N	150888	150888	318208
19768	28023	33	applied	\N	\N	1000000000	\N	150889	150889	318209
19768	28024	34	applied	\N	\N	\N	\N	150890	150890	318210
19768	28025	35	applied	\N	\N	\N	\N	150891	150891	318211
19768	28026	36	applied	\N	\N	\N	\N	150892	150892	318212
19768	27939	37	applied	\N	\N	\N	\N	150893	150893	318213
19768	27940	38	applied	\N	\N	\N	\N	150894	150894	318214
19768	27943	39	applied	\N	\N	\N	\N	150895	150895	318215
19768	27946	40	applied	\N	\N	\N	\N	150896	150896	318216
19768	27949	41	applied	\N	\N	\N	\N	150897	150897	318217
19768	27950	42	applied	\N	\N	\N	\N	150898	150898	318218
19768	27954	43	applied	\N	\N	\N	\N	150899	150899	318219
19768	27960	45	applied	\N	\N	\N	\N	150901	150901	318221
19768	27966	46	applied	\N	\N	\N	\N	150902	150902	318222
19768	27942	47	applied	\N	\N	\N	\N	150903	150903	318223
19768	27945	48	applied	\N	\N	\N	\N	150904	150904	318224
19768	27951	49	applied	\N	\N	\N	\N	150905	150905	318225
19768	27952	50	applied	\N	\N	\N	\N	150906	150906	318226
19768	28027	51	applied	\N	\N	\N	\N	150907	150907	318227
19772	28036	2	applied	\N	\N	\N	\N	150960	150960	318280
19772	28037	3	applied	\N	\N	\N	\N	150961	150961	318281
19772	28038	4	applied	\N	\N	\N	\N	150962	150962	318282
19772	28039	5	applied	\N	\N	\N	\N	150963	150963	318283
19775	28050	0	applied	\N	\N	\N	\N	150974	150974	318294
19775	28051	1	applied	\N	\N	\N	\N	150975	150975	318295
19775	28052	2	applied	\N	\N	\N	\N	150976	150976	318296
19777	28053	0	applied	\N	\N	\N	\N	150980	150980	318300
19777	28054	1	applied	\N	\N	\N	\N	150981	150981	318301
19780	28056	0	applied	\N	\N	\N	\N	150997	150997	318317
19780	28057	1	applied	\N	\N	\N	\N	150998	150998	318318
19780	28058	2	applied	\N	\N	\N	\N	150999	150999	318319
19780	28059	3	applied	\N	\N	\N	\N	151000	151000	318320
19780	28060	4	applied	\N	\N	\N	\N	151001	151001	318321
19780	28061	5	applied	\N	\N	\N	\N	151002	151002	318322
19780	28062	6	applied	\N	\N	\N	\N	151003	151003	318323
19785	28075	0	applied	\N	\N	\N	\N	151019	151019	318339
19785	28076	1	applied	\N	\N	\N	\N	151020	151020	318340
19785	28077	2	applied	\N	\N	\N	\N	151021	151021	318341
19785	28078	3	applied	\N	\N	\N	\N	151022	151022	318342
19785	28079	4	applied	\N	\N	\N	\N	151023	151023	318343
19785	28080	5	applied	\N	\N	\N	\N	151024	151024	318344
19785	28081	7	applied	\N	\N	\N	\N	151025	151025	318345
19788	28089	0	applied	\N	\N	\N	\N	151040	151040	318360
19788	28090	1	applied	\N	\N	\N	\N	151041	151041	318361
19788	28092	3	applied	\N	\N	\N	\N	151043	151043	318363
19793	28103	0	applied	\N	\N	\N	\N	151057	151057	318377
19793	28104	1	applied	\N	\N	\N	\N	151058	151058	318378
19796	28103	0	applied	\N	\N	\N	\N	151065	151065	318385
19796	28104	1	applied	\N	\N	\N	\N	151066	151066	318386
19796	28105	2	applied	\N	\N	\N	\N	151067	151067	318387
19797	28106	0	applied	\N	\N	\N	\N	151068	151068	318388
19797	28107	1	applied	\N	\N	\N	\N	151069	151069	318389
19797	28108	2	applied	\N	\N	\N	\N	151070	151070	318390
19802	28117	0	applied	\N	\N	\N	\N	151103	151103	318423
19802	28118	1	applied	\N	\N	\N	\N	151104	151104	318424
19802	28119	2	applied	\N	\N	\N	\N	151105	151105	318425
19802	28120	3	applied	\N	\N	\N	\N	151106	151106	318426
19803	28121	0	applied	\N	\N	\N	\N	151107	151107	318427
19803	28122	1	applied	\N	\N	\N	\N	151108	151108	318428
19803	28123	2	applied	\N	\N	\N	\N	151109	151109	318429
19803	28125	4	applied	\N	\N	\N	\N	151111	151111	318431
19803	28126	5	applied	\N	\N	\N	\N	151112	151112	318432
19803	28127	6	applied	\N	\N	\N	\N	151113	151113	318433
19803	28128	7	applied	\N	\N	\N	\N	151114	151114	318434
19803	28129	8	applied	\N	\N	\N	\N	151115	151115	318435
19803	28130	9	applied	\N	\N	\N	\N	151116	151116	318436
19805	28131	0	applied	\N	\N	\N	\N	151127	151127	318447
19805	28132	1	applied	\N	\N	\N	\N	151128	151128	318448
19805	28133	2	applied	\N	\N	\N	\N	151129	151129	318449
19810	28138	0	applied	\N	\N	\N	\N	151143	151143	318463
19810	28139	1	applied	\N	\N	\N	\N	151144	151144	318464
19810	28140	2	applied	\N	\N	\N	\N	151145	151145	318465
19818	28158	0	applied	\N	\N	\N	\N	151167	151167	318487
19818	28159	1	applied	\N	\N	\N	\N	151168	151168	318488
19823	28172	0	applied	\N	\N	\N	\N	151186	151186	318504
19823	28173	1	applied	\N	\N	\N	\N	151187	151187	318505
19823	28175	3	applied	\N	\N	\N	\N	151189	151189	318507
19823	28176	4	applied	\N	\N	\N	\N	151190	151190	318508
19828	28182	0	applied	\N	\N	\N	\N	151201	151201	318519
19828	28183	1	applied	\N	\N	\N	\N	151202	151202	318520
19828	28184	2	applied	\N	\N	\N	\N	151203	151203	318521
19831	28182	0	applied	\N	\N	\N	\N	151210	151210	318528
19831	28183	1	applied	\N	\N	\N	\N	151211	151211	318529
19831	28184	2	applied	\N	\N	\N	\N	151212	151212	318530
19832	28185	0	applied	\N	\N	\N	\N	151213	151213	318531
19832	28186	1	applied	\N	\N	\N	\N	151214	151214	318532
19832	28187	2	applied	\N	\N	\N	\N	151215	151215	318533
19834	28188	0	applied	\N	\N	\N	\N	151219	151219	318537
19834	28189	1	applied	\N	\N	\N	\N	151220	151220	318538
19834	28190	2	applied	\N	\N	\N	\N	151221	151221	318539
19837	28198	0	applied	\N	\N	\N	\N	151229	151229	318547
19837	28199	1	applied	\N	\N	\N	\N	151230	151230	318548
19839	28201	0	applied	\N	\N	\N	\N	151235	151235	318553
19839	28202	1	applied	\N	\N	\N	\N	151236	151236	318554
19839	28203	2	applied	\N	\N	\N	\N	151237	151237	318555
19845	28208	0	applied	\N	\N	\N	\N	151255	151255	318573
19845	28209	1	applied	\N	\N	\N	\N	151256	151256	318574
19845	28210	2	applied	\N	\N	\N	\N	151257	151257	318575
19846	28211	0	applied	\N	\N	\N	\N	151258	151258	318576
19846	28212	1	applied	\N	\N	\N	\N	151259	151259	318577
19846	28213	2	applied	\N	\N	\N	\N	151260	151260	318578
19846	28214	3	applied	\N	\N	\N	\N	151261	151261	318579
19846	28215	4	applied	\N	\N	\N	\N	151262	151262	318580
19846	28216	5	applied	\N	\N	\N	\N	151263	151263	318581
19846	28217	6	applied	\N	\N	\N	\N	151264	151264	318582
19848	28218	0	applied	\N	\N	\N	\N	151290	151290	318608
19848	28219	1	applied	\N	\N	\N	\N	151291	151291	318609
19848	28220	2	applied	\N	\N	\N	\N	151292	151292	318610
19768	28020	29	applied	\N	\N	1000000000	\N	150885	150885	318205
19768	27937	30	applied	\N	\N	\N	\N	150886	150886	318206
19768	27981	56	applied	\N	\N	\N	\N	150912	150912	318232
19768	27982	57	applied	\N	\N	\N	\N	150913	150913	318233
19768	27984	58	applied	\N	\N	\N	\N	150914	150914	318234
19768	27987	59	applied	\N	\N	\N	\N	150915	150915	318235
19768	27990	60	applied	\N	\N	\N	\N	150916	150916	318236
19768	27955	61	applied	\N	\N	\N	\N	150917	150917	318237
19768	27994	62	applied	\N	\N	\N	\N	150918	150918	318238
19768	27997	63	applied	\N	\N	\N	\N	150919	150919	318239
19768	27999	64	applied	\N	\N	\N	\N	150920	150920	318240
19768	28002	65	applied	\N	\N	\N	\N	150921	150921	318241
19768	28005	66	applied	\N	\N	\N	\N	150922	150922	318242
19768	28008	67	applied	\N	\N	\N	\N	150923	150923	318243
19768	28009	68	applied	\N	\N	\N	\N	150924	150924	318244
19768	28014	69	applied	\N	\N	\N	\N	150925	150925	318245
19768	28019	71	applied	\N	\N	\N	\N	150927	150927	318247
19768	27958	72	applied	\N	\N	\N	\N	150928	150928	318248
19768	27961	73	applied	\N	\N	\N	\N	150929	150929	318249
19768	27963	74	applied	\N	\N	\N	\N	150930	150930	318250
19768	27967	75	applied	\N	\N	\N	\N	150931	150931	318251
19768	27968	76	applied	\N	\N	\N	\N	150932	150932	318252
19768	27976	77	applied	\N	\N	\N	\N	150933	150933	318253
19768	27977	78	applied	\N	\N	\N	\N	150934	150934	318254
19768	27978	79	applied	\N	\N	\N	\N	150935	150935	318255
19768	27979	80	applied	\N	\N	\N	\N	150936	150936	318256
19768	27985	81	applied	\N	\N	\N	\N	150937	150937	318257
19768	27988	82	applied	\N	\N	\N	\N	150938	150938	318258
19768	27991	83	applied	\N	\N	\N	\N	150939	150939	318259
19768	27993	84	applied	\N	\N	\N	\N	150940	150940	318260
19768	27996	85	applied	\N	\N	\N	\N	150941	150941	318261
19768	28000	87	applied	\N	\N	\N	\N	150942	150942	318262
19768	28010	89	applied	\N	\N	\N	\N	150944	150944	318264
19768	28011	90	applied	\N	\N	\N	\N	150945	150945	318265
19768	28013	91	applied	\N	\N	\N	\N	150946	150946	318266
19768	28016	92	applied	\N	\N	\N	\N	150947	150947	318267
19768	28021	93	applied	\N	\N	\N	\N	150948	150948	318268
19773	28040	0	applied	\N	\N	\N	\N	150964	150964	318284
19773	28041	1	applied	\N	\N	\N	\N	150965	150965	318285
19773	28042	2	applied	\N	\N	\N	\N	150966	150966	318286
19773	28043	3	applied	\N	\N	\N	\N	150967	150967	318287
19773	28044	4	applied	\N	\N	\N	\N	150968	150968	318288
19773	28045	5	applied	\N	\N	\N	\N	150969	150969	318289
19773	28046	6	applied	\N	\N	\N	\N	150970	150970	318290
19776	28050	0	applied	\N	\N	\N	\N	150977	150977	318297
19776	28051	1	applied	\N	\N	\N	\N	150978	150978	318298
19776	28052	2	applied	\N	\N	\N	\N	150979	150979	318299
19778	28056	0	applied	\N	\N	\N	\N	150983	150983	318303
19778	28058	2	applied	\N	\N	\N	\N	150985	150985	318305
19778	28059	3	applied	\N	\N	\N	\N	150986	150986	318306
19778	28060	4	applied	\N	\N	\N	\N	150987	150987	318307
19778	28061	5	applied	\N	\N	\N	\N	150988	150988	318308
19778	28062	6	applied	\N	\N	\N	\N	150989	150989	318309
19781	28063	0	applied	\N	\N	\N	\N	151004	151004	318324
19781	28064	1	applied	\N	\N	\N	\N	151005	151005	318325
19781	28065	2	applied	\N	\N	\N	\N	151006	151006	318326
19781	28066	3	applied	\N	\N	\N	\N	151007	151007	318327
19781	28067	4	applied	\N	\N	\N	\N	151008	151008	318328
19781	28068	5	applied	\N	\N	\N	\N	151009	151009	318329
19781	28069	6	applied	\N	\N	\N	\N	151010	151010	318330
19781	28070	7	applied	\N	\N	\N	\N	151011	151011	318331
19781	28071	8	applied	\N	\N	\N	\N	151012	151012	318332
19783	28072	0	applied	\N	\N	\N	\N	151013	151013	318333
19783	28073	1	applied	\N	\N	\N	\N	151014	151014	318334
19786	28082	0	applied	\N	\N	\N	\N	151026	151026	318346
19786	28083	1	applied	\N	\N	\N	\N	151027	151027	318347
19786	28084	2	applied	\N	\N	\N	\N	151028	151028	318348
19786	28085	3	applied	\N	\N	1000000000	\N	151029	151029	318349
19786	28086	4	applied	\N	\N	\N	\N	151030	151030	318350
19786	28087	5	applied	\N	\N	\N	\N	151031	151031	318351
19786	28088	6	applied	\N	\N	\N	\N	151032	151032	318352
19791	28096	0	applied	\N	\N	\N	\N	151050	151050	318370
19791	28097	1	applied	\N	\N	\N	\N	151051	151051	318371
19791	28098	2	applied	\N	\N	\N	\N	151052	151052	318372
19794	28103	0	applied	\N	\N	\N	\N	151059	151059	318379
19794	28104	1	applied	\N	\N	\N	\N	151060	151060	318380
19794	28105	2	applied	\N	\N	\N	\N	151061	151061	318381
19798	28109	0	applied	\N	\N	\N	\N	151071	151071	318391
19798	28110	1	applied	\N	\N	\N	\N	151072	151072	318392
19798	28111	2	applied	\N	\N	\N	\N	151073	151073	318393
19798	28113	4	applied	\N	\N	\N	\N	151075	151075	318395
19798	28114	5	applied	\N	\N	\N	\N	151076	151076	318396
19798	28115	6	applied	\N	\N	\N	\N	151077	151077	318397
19798	28116	7	applied	\N	\N	\N	\N	151078	151078	318398
19800	28109	0	applied	\N	\N	\N	\N	151087	151087	318407
19800	28110	1	applied	\N	\N	\N	\N	151088	151088	318408
19800	28111	2	applied	\N	\N	\N	\N	151089	151089	318409
19800	28112	3	applied	\N	\N	\N	\N	151090	151090	318410
19800	28113	4	applied	\N	\N	\N	\N	151091	151091	318411
19800	28114	5	applied	\N	\N	\N	\N	151092	151092	318412
19800	28115	6	applied	\N	\N	\N	\N	151093	151093	318413
19800	28116	7	applied	\N	\N	\N	\N	151094	151094	318414
19804	28121	0	applied	\N	\N	\N	\N	151117	151117	318437
19804	28122	1	applied	\N	\N	\N	\N	151118	151118	318438
19804	28123	2	applied	\N	\N	\N	\N	151119	151119	318439
19804	28124	3	applied	\N	\N	\N	\N	151120	151120	318440
19804	28126	5	applied	\N	\N	\N	\N	151122	151122	318442
19804	28127	6	applied	\N	\N	\N	\N	151123	151123	318443
19804	28128	7	applied	\N	\N	\N	\N	151124	151124	318444
19804	28129	8	applied	\N	\N	\N	\N	151125	151125	318445
19804	28130	9	applied	\N	\N	\N	\N	151126	151126	318446
19806	28134	0	applied	\N	\N	\N	\N	151130	151130	318450
19806	28135	1	applied	\N	\N	\N	\N	151131	151131	318451
19806	28136	2	applied	\N	\N	\N	\N	151132	151132	318452
19806	28137	3	applied	\N	\N	\N	\N	151133	151133	318453
19807	28138	0	applied	\N	\N	\N	\N	151134	151134	318454
19807	28139	1	applied	\N	\N	\N	\N	151135	151135	318455
19807	28140	2	applied	\N	\N	\N	\N	151136	151136	318456
19811	28141	0	applied	\N	\N	\N	\N	151146	151146	318466
19812	28142	0	applied	\N	\N	\N	\N	151147	151147	318467
19812	28143	1	applied	\N	\N	\N	\N	151148	151148	318468
19813	28144	0	applied	\N	\N	\N	\N	151149	151149	318469
19768	27980	55	applied	\N	\N	\N	\N	150911	150911	318231
19816	28155	2	applied	\N	\N	\N	\N	151162	151162	318482
19816	28156	3	applied	\N	\N	\N	\N	151163	151163	318483
19816	28157	4	applied	\N	\N	\N	\N	151164	151164	318484
19821	28109	0	applied	\N	\N	\N	\N	151179	151179	318497
19821	28110	1	applied	\N	\N	\N	\N	151180	151180	318498
19821	28112	3	applied	\N	\N	\N	\N	151182	151182	318500
19821	28085	4	applied	\N	\N	1000000000	\N	151183	151183	318501
19826	28180	0	applied	\N	\N	\N	\N	151196	151196	318514
19826	28181	1	applied	\N	\N	\N	\N	151197	151197	318515
19829	28182	0	applied	\N	\N	\N	\N	151204	151204	318522
19829	28183	1	applied	\N	\N	\N	\N	151205	151205	318523
19829	28184	2	applied	\N	\N	\N	\N	151206	151206	318524
19835	28191	0	applied	\N	\N	\N	\N	151222	151222	318540
19835	28192	1	applied	\N	\N	\N	\N	151223	151223	318541
19835	28193	2	applied	\N	\N	\N	\N	151224	151224	318542
19835	28194	3	applied	\N	\N	\N	\N	151225	151225	318543
19838	28198	0	applied	\N	\N	\N	\N	151232	151232	318550
19838	28199	1	applied	\N	\N	\N	\N	151233	151233	318551
19838	28200	2	applied	\N	\N	\N	\N	151234	151234	318552
19840	28204	0	applied	\N	\N	\N	\N	151238	151238	318556
19840	28205	1	applied	\N	\N	\N	\N	151239	151239	318557
19840	28207	3	applied	\N	\N	\N	\N	151241	151241	318559
19842	28208	0	applied	\N	\N	\N	\N	151246	151246	318564
19842	28209	1	applied	\N	\N	\N	\N	151247	151247	318565
19842	28210	2	applied	\N	\N	\N	\N	151248	151248	318566
19847	27750	18	applied	\N	\N	\N	\N	151283	151283	318601
19847	27751	19	applied	\N	\N	\N	\N	151284	151284	318602
19847	27752	20	applied	\N	\N	\N	\N	151285	151285	318603
19847	27753	21	applied	\N	\N	\N	\N	151286	151286	318604
19847	27754	22	applied	\N	\N	\N	\N	151287	151287	318605
19847	27755	23	applied	\N	\N	\N	\N	151288	151288	318606
19847	27760	24	applied	\N	\N	\N	\N	151289	151289	318607
19849	28221	0	applied	\N	\N	\N	\N	151293	151293	318611
19849	28222	1	applied	\N	\N	\N	\N	151294	151294	318612
19849	28223	2	applied	\N	\N	\N	\N	151295	151295	318613
19849	28225	4	applied	\N	\N	\N	\N	151297	151297	318615
19849	28226	5	applied	\N	\N	\N	\N	151298	151298	318616
19851	28227	0	applied	\N	\N	\N	\N	151305	151305	318623
19851	28228	1	applied	\N	\N	\N	\N	151306	151306	318624
19851	28229	2	applied	\N	\N	\N	\N	151307	151307	318625
19851	28230	3	applied	\N	\N	\N	\N	151308	151308	318626
19851	28231	4	applied	\N	\N	\N	\N	151309	151309	318627
19852	28227	0	applied	\N	\N	\N	\N	151310	151310	318628
19852	28228	1	applied	\N	\N	\N	\N	151311	151311	318629
19852	28232	2	applied	\N	\N	\N	\N	151312	151312	318630
19852	28229	3	applied	\N	\N	\N	\N	151313	151313	318631
19852	28230	4	applied	\N	\N	\N	\N	151314	151314	318632
19852	28231	5	applied	\N	\N	\N	\N	151315	151315	318633
19857	28233	0	applied	\N	\N	\N	\N	151334	151334	318652
19857	28234	1	applied	\N	\N	\N	\N	151335	151335	318653
19857	28235	2	applied	\N	\N	\N	\N	151336	151336	318654
19857	28236	3	applied	\N	\N	1000000000	\N	151337	151337	318655
19857	28237	4	applied	\N	\N	\N	\N	151338	151338	318656
19857	28238	5	applied	\N	\N	\N	\N	151339	151339	318657
19858	28239	0	applied	\N	\N	\N	\N	151340	151340	318658
19858	28241	2	applied	\N	\N	\N	\N	151342	151342	318660
19858	28242	3	applied	\N	\N	\N	\N	151343	151343	318661
19860	28248	0	applied	\N	\N	\N	\N	151349	151349	318667
19860	28249	1	applied	\N	\N	\N	\N	151350	151350	318668
19860	28250	2	applied	\N	\N	\N	\N	151351	151351	318669
19860	28251	4	applied	\N	\N	\N	\N	151352	151352	318670
19860	28252	5	applied	\N	\N	\N	\N	151353	151353	318671
19861	28248	0	applied	\N	\N	\N	\N	151354	151354	318672
19861	28249	1	applied	\N	\N	\N	\N	151355	151355	318673
19864	28253	0	applied	\N	\N	\N	\N	151369	151369	318687
19864	28254	1	applied	\N	\N	\N	\N	151370	151370	318688
19864	28255	2	applied	\N	\N	\N	\N	151371	151371	318689
19871	28280	0	applied	\N	\N	\N	\N	151442	151442	318760
19871	28281	1	applied	\N	\N	\N	\N	151443	151443	318761
19871	28282	2	applied	\N	\N	\N	\N	151444	151444	318762
19872	28283	0	applied	\N	\N	\N	\N	151445	151445	318763
19872	28285	2	applied	\N	\N	\N	\N	151447	151447	318765
19875	28239	0	applied	\N	\N	\N	\N	151454	151454	318772
19875	28257	1	applied	\N	\N	\N	\N	151455	151455	318773
19875	28262	2	applied	\N	\N	\N	\N	151456	151456	318774
19875	28228	3	applied	\N	\N	\N	\N	151457	151457	318775
19875	28245	4	applied	\N	\N	\N	\N	151458	151458	318776
19875	28246	5	applied	\N	\N	\N	\N	151459	151459	318777
19875	28249	6	applied	\N	\N	\N	\N	151460	151460	318778
19875	28290	7	applied	\N	\N	\N	\N	151461	151461	318779
19875	28291	8	applied	\N	\N	\N	\N	151462	151462	318780
19875	28220	9	applied	\N	\N	\N	\N	151463	151463	318781
19875	28224	10	applied	\N	\N	1000000000	\N	151464	151464	318782
19875	28236	11	applied	\N	\N	1000000000	\N	151465	151465	318783
19875	28225	12	applied	\N	\N	\N	\N	151466	151466	318784
19875	28229	13	applied	\N	\N	\N	\N	151467	151467	318785
19875	28237	14	applied	\N	\N	\N	\N	151468	151468	318786
19886	28314	0	applied	\N	\N	\N	\N	151554	151554	318872
19886	28316	1	applied	\N	\N	\N	\N	151555	151555	318873
19886	28315	2	applied	\N	\N	\N	\N	151556	151556	318874
19891	28327	0	applied	\N	\N	\N	\N	151581	151581	318899
19891	28328	1	applied	\N	\N	\N	\N	151582	151582	318900
19891	28329	2	applied	\N	\N	\N	\N	151583	151583	318901
19891	28330	3	applied	\N	\N	\N	\N	151584	151584	318902
19891	28331	4	applied	\N	\N	\N	\N	151585	151585	318903
19891	28332	5	applied	\N	\N	\N	\N	151586	151586	318904
19891	28333	6	applied	\N	\N	\N	\N	151587	151587	318905
19891	28334	7	applied	\N	\N	\N	\N	151588	151588	318906
19891	28335	8	applied	\N	\N	\N	\N	151589	151589	318907
19891	28336	9	applied	\N	\N	\N	\N	151590	151590	318908
19891	28337	10	applied	\N	\N	\N	\N	151591	151591	318909
19894	28338	0	applied	\N	\N	\N	\N	151600	151600	318918
19894	28339	1	applied	\N	\N	\N	\N	151601	151601	318919
19894	28341	3	applied	\N	\N	\N	\N	151603	151603	318921
19897	28342	0	applied	\N	\N	\N	\N	151612	151612	318930
19897	28343	1	applied	\N	\N	\N	\N	151613	151613	318931
19897	28344	2	applied	\N	\N	1000000000	\N	151614	151614	318932
19897	28345	3	applied	\N	\N	\N	\N	151615	151615	318933
19900	28342	0	applied	\N	\N	\N	\N	151624	151624	318942
19816	28153	0	applied	\N	\N	\N	\N	151160	151160	318480
19816	28154	1	applied	\N	\N	\N	\N	151161	151161	318481
19854	28230	4	applied	\N	\N	\N	\N	151326	151326	318644
19854	28231	5	applied	\N	\N	\N	\N	151327	151327	318645
19859	28243	0	applied	\N	\N	\N	\N	151344	151344	318662
19859	28244	1	applied	\N	\N	\N	\N	151345	151345	318663
19859	28245	2	applied	\N	\N	\N	\N	151346	151346	318664
19859	28246	3	applied	\N	\N	\N	\N	151347	151347	318665
19859	28247	4	applied	\N	\N	\N	\N	151348	151348	318666
19861	28251	4	applied	\N	\N	\N	\N	151357	151357	318675
19861	28252	5	applied	\N	\N	\N	\N	151358	151358	318676
19863	28248	0	applied	\N	\N	\N	\N	151364	151364	318682
19863	28249	1	applied	\N	\N	\N	\N	151365	151365	318683
19863	28250	2	applied	\N	\N	\N	\N	151366	151366	318684
19863	28251	4	applied	\N	\N	\N	\N	151367	151367	318685
19863	28252	5	applied	\N	\N	\N	\N	151368	151368	318686
19865	28256	0	applied	\N	\N	\N	\N	151372	151372	318690
19865	28257	1	applied	\N	\N	\N	\N	151373	151373	318691
19865	28258	2	applied	\N	\N	\N	\N	151374	151374	318692
19865	28259	3	applied	\N	\N	\N	\N	151375	151375	318693
19866	28260	0	applied	\N	\N	\N	\N	151376	151376	318694
19866	28261	1	applied	\N	\N	\N	\N	151377	151377	318695
19866	28262	2	applied	\N	\N	\N	\N	151378	151378	318696
19866	28263	3	applied	\N	\N	\N	\N	151379	151379	318697
19866	28264	4	applied	\N	\N	\N	\N	151380	151380	318698
19866	28266	6	applied	\N	\N	\N	\N	151382	151382	318700
19866	28267	7	applied	\N	\N	\N	\N	151383	151383	318701
19866	28268	8	applied	\N	\N	\N	\N	151384	151384	318702
19866	28269	9	applied	\N	\N	\N	\N	151385	151385	318703
19866	28270	10	applied	\N	\N	\N	\N	151386	151386	318704
19866	28271	11	applied	\N	\N	\N	\N	151387	151387	318705
19866	28272	12	applied	\N	\N	\N	\N	151388	151388	318706
19866	28273	13	applied	\N	\N	\N	\N	151389	151389	318707
19866	28274	14	applied	\N	\N	\N	\N	151390	151390	318708
19866	28275	15	applied	\N	\N	\N	\N	151391	151391	318709
19866	28276	16	applied	\N	\N	\N	\N	151392	151392	318710
19866	28277	17	applied	\N	\N	\N	\N	151393	151393	318711
19866	28278	18	applied	\N	\N	\N	\N	151394	151394	318712
19866	28279	19	applied	\N	\N	\N	\N	151395	151395	318713
19868	28260	0	applied	\N	\N	\N	\N	151416	151416	318734
19868	28261	1	applied	\N	\N	\N	\N	151417	151417	318735
19868	28263	3	applied	\N	\N	\N	\N	151419	151419	318737
19868	28264	4	applied	\N	\N	\N	\N	151420	151420	318738
19868	28265	5	applied	\N	\N	\N	\N	151421	151421	318739
19868	28266	6	applied	\N	\N	\N	\N	151422	151422	318740
19868	28267	7	applied	\N	\N	\N	\N	151423	151423	318741
19868	28268	8	applied	\N	\N	\N	\N	151424	151424	318742
19868	28269	9	applied	\N	\N	\N	\N	151425	151425	318743
19876	28286	0	applied	\N	\N	\N	\N	151470	151470	318788
19876	28287	1	applied	\N	\N	\N	\N	151471	151471	318789
19876	28288	2	applied	\N	\N	\N	\N	151472	151472	318790
19876	28289	3	applied	\N	\N	\N	\N	151473	151473	318791
19877	28292	0	applied	\N	\N	\N	\N	151474	151474	318792
19877	28293	1	applied	\N	\N	\N	\N	151475	151475	318793
19880	28239	0	applied	\N	\N	\N	\N	151486	151486	318804
19880	28109	1	applied	\N	\N	\N	\N	151487	151487	318805
19880	28110	2	applied	\N	\N	\N	\N	151488	151488	318806
19880	28112	4	applied	\N	\N	\N	\N	151490	151490	318808
19880	28228	5	applied	\N	\N	\N	\N	151491	151491	318809
19880	28245	6	applied	\N	\N	\N	\N	151492	151492	318810
19880	28020	7	applied	\N	\N	1000000000	\N	151493	151493	318811
19880	28022	8	applied	\N	\N	\N	\N	151494	151494	318812
19880	28246	9	applied	\N	\N	\N	\N	151495	151495	318813
19880	28249	10	applied	\N	\N	\N	\N	151496	151496	318814
19880	28290	11	applied	\N	\N	\N	\N	151497	151497	318815
19880	28291	12	applied	\N	\N	\N	\N	151498	151498	318816
19880	28220	13	applied	\N	\N	\N	\N	151499	151499	318817
19880	28023	14	applied	\N	\N	1000000000	\N	151500	151500	318818
19880	28024	15	applied	\N	\N	\N	\N	151501	151501	318819
19880	28025	16	applied	\N	\N	\N	\N	151502	151502	318820
19880	28026	17	applied	\N	\N	\N	\N	151503	151503	318821
19880	28225	18	applied	\N	\N	\N	\N	151504	151504	318822
19880	28229	19	applied	\N	\N	\N	\N	151505	151505	318823
19880	28042	21	applied	\N	\N	\N	\N	151507	151507	318825
19880	28058	22	applied	\N	\N	\N	\N	151508	151508	318826
19880	28237	23	applied	\N	\N	\N	\N	151509	151509	318827
19880	28238	24	applied	\N	\N	\N	\N	151510	151510	318828
19880	28027	25	applied	\N	\N	\N	\N	151511	151511	318829
19880	28085	26	applied	\N	\N	1000000000	\N	151512	151512	318830
19880	28224	27	applied	\N	\N	1000000000	\N	151513	151513	318831
19880	28236	28	applied	\N	\N	1000000000	\N	151514	151514	318832
19880	28071	29	applied	\N	\N	\N	\N	151515	151515	318833
19880	28077	30	applied	\N	\N	\N	\N	151516	151516	318834
19880	28090	31	applied	\N	\N	\N	\N	151517	151517	318835
19880	28102	32	applied	\N	\N	\N	\N	151518	151518	318836
19880	28115	33	applied	\N	\N	\N	\N	151519	151519	318837
19880	28126	34	applied	\N	\N	\N	\N	151520	151520	318838
19880	28132	35	applied	\N	\N	\N	\N	151521	151521	318839
19880	28139	36	applied	\N	\N	\N	\N	151522	151522	318840
19880	28155	38	applied	\N	\N	\N	\N	151524	151524	318842
19880	28163	39	applied	\N	\N	\N	\N	151525	151525	318843
19880	28175	40	applied	\N	\N	\N	\N	151526	151526	318844
19880	28183	41	applied	\N	\N	\N	\N	151527	151527	318845
19880	28194	42	applied	\N	\N	\N	\N	151528	151528	318846
19880	28205	43	applied	\N	\N	\N	\N	151529	151529	318847
19880	28217	44	applied	\N	\N	\N	\N	151530	151530	318848
19880	28230	45	applied	\N	\N	\N	\N	151531	151531	318849
19880	28252	46	applied	\N	\N	\N	\N	151532	151532	318850
19880	28268	47	applied	\N	\N	\N	\N	151533	151533	318851
19880	28270	48	applied	\N	\N	\N	\N	151534	151534	318852
19880	28288	49	applied	\N	\N	\N	\N	151535	151535	318853
19880	28299	50	applied	\N	\N	\N	\N	151536	151536	318854
19883	28304	0	applied	\N	\N	\N	\N	151543	151543	318861
19883	28306	1	applied	\N	\N	\N	\N	151544	151544	318862
19887	28314	0	applied	\N	\N	\N	\N	151557	151557	318875
19887	28315	2	applied	\N	\N	\N	\N	151559	151559	318877
19888	28317	0	applied	\N	\N	\N	\N	151560	151560	318878
19888	28318	1	applied	\N	\N	\N	\N	151561	151561	318879
19888	28319	2	applied	\N	\N	\N	\N	151562	151562	318880
19895	28338	0	applied	\N	\N	\N	\N	151604	151604	318922
19895	28339	1	applied	\N	\N	\N	\N	151605	151605	318923
19854	28232	2	applied	\N	\N	\N	\N	151324	151324	318642
19854	28229	3	applied	\N	\N	\N	\N	151325	151325	318643
19867	28275	15	applied	\N	\N	\N	\N	151411	151411	318729
19867	28276	16	applied	\N	\N	\N	\N	151412	151412	318730
19867	28277	17	applied	\N	\N	\N	\N	151413	151413	318731
19867	28278	18	applied	\N	\N	\N	\N	151414	151414	318732
19867	28279	19	applied	\N	\N	\N	\N	151415	151415	318733
19868	28270	10	applied	\N	\N	\N	\N	151426	151426	318744
19868	28271	11	applied	\N	\N	\N	\N	151427	151427	318745
19868	28272	12	applied	\N	\N	\N	\N	151428	151428	318746
19868	28273	13	applied	\N	\N	\N	\N	151429	151429	318747
19868	28274	14	applied	\N	\N	\N	\N	151430	151430	318748
19868	28275	15	applied	\N	\N	\N	\N	151431	151431	318749
19868	28276	16	applied	\N	\N	\N	\N	151432	151432	318750
19868	28277	17	applied	\N	\N	\N	\N	151433	151433	318751
19868	28278	18	applied	\N	\N	\N	\N	151434	151434	318752
19869	28280	0	applied	\N	\N	\N	\N	151436	151436	318754
19869	28281	1	applied	\N	\N	\N	\N	151437	151437	318755
19869	28282	2	applied	\N	\N	\N	\N	151438	151438	318756
19870	28280	0	applied	\N	\N	\N	\N	151439	151439	318757
19870	28281	1	applied	\N	\N	\N	\N	151440	151440	318758
19870	28282	2	applied	\N	\N	\N	\N	151441	151441	318759
19873	28283	0	applied	\N	\N	\N	\N	151448	151448	318766
19873	28285	1	applied	\N	\N	\N	\N	151449	151449	318767
19874	28286	0	applied	\N	\N	\N	\N	151450	151450	318768
19874	28287	1	applied	\N	\N	\N	\N	151451	151451	318769
19874	28288	2	applied	\N	\N	\N	\N	151452	151452	318770
19874	28289	3	applied	\N	\N	\N	\N	151453	151453	318771
19878	28294	0	applied	\N	\N	\N	\N	151476	151476	318794
19878	28295	1	applied	\N	\N	\N	\N	151477	151477	318795
19878	28296	2	applied	\N	\N	\N	\N	151478	151478	318796
19879	28297	0	applied	\N	\N	\N	\N	151479	151479	318797
19879	28299	2	applied	\N	\N	\N	\N	151481	151481	318799
19879	28300	3	applied	\N	\N	\N	\N	151482	151482	318800
19879	28301	4	applied	\N	\N	\N	\N	151483	151483	318801
19879	28302	5	applied	\N	\N	\N	\N	151484	151484	318802
19879	28303	6	applied	\N	\N	\N	\N	151485	151485	318803
19881	28304	0	applied	\N	\N	\N	\N	151537	151537	318855
19881	28305	1	applied	\N	\N	\N	\N	151538	151538	318856
19881	28306	2	applied	\N	\N	\N	\N	151539	151539	318857
19882	28304	0	applied	\N	\N	\N	\N	151540	151540	318858
19882	28305	1	applied	\N	\N	\N	\N	151541	151541	318859
19882	28306	2	applied	\N	\N	\N	\N	151542	151542	318860
19884	28307	0	applied	\N	\N	\N	\N	151545	151545	318863
19884	28308	1	applied	\N	\N	\N	\N	151546	151546	318864
19885	28314	0	applied	\N	\N	\N	\N	151552	151552	318870
19885	28315	1	applied	\N	\N	\N	\N	151553	151553	318871
19890	28327	0	applied	\N	\N	\N	\N	151570	151570	318888
19890	28329	2	applied	\N	\N	\N	\N	151572	151572	318890
19890	28330	3	applied	\N	\N	\N	\N	151573	151573	318891
19890	28331	4	applied	\N	\N	\N	\N	151574	151574	318892
19890	28332	5	applied	\N	\N	\N	\N	151575	151575	318893
19890	28333	6	applied	\N	\N	\N	\N	151576	151576	318894
19890	28334	7	applied	\N	\N	\N	\N	151577	151577	318895
19890	28335	8	applied	\N	\N	\N	\N	151578	151578	318896
19890	28336	9	applied	\N	\N	\N	\N	151579	151579	318897
19890	28337	10	applied	\N	\N	\N	\N	151580	151580	318898
19893	28338	0	applied	\N	\N	\N	\N	151596	151596	318914
19893	28339	1	applied	\N	\N	\N	\N	151597	151597	318915
19893	28340	2	applied	\N	\N	\N	\N	151598	151598	318916
19893	28341	3	applied	\N	\N	\N	\N	151599	151599	318917
19901	28346	0	applied	\N	\N	\N	\N	151628	151628	318946
19901	28347	1	applied	\N	\N	\N	\N	151629	151629	318947
19901	28348	2	applied	\N	\N	\N	\N	151630	151630	318948
19901	28350	4	applied	\N	\N	\N	\N	151632	151632	318950
19901	28351	5	applied	\N	\N	\N	\N	151633	151633	318951
19901	28352	6	applied	\N	\N	\N	\N	151634	151634	318952
19904	28353	0	applied	\N	\N	\N	\N	151645	151645	318963
19904	28354	1	applied	\N	\N	\N	\N	151646	151646	318964
19904	28355	2	applied	\N	\N	\N	\N	151647	151647	318965
19907	28356	0	applied	\N	\N	\N	\N	151668	151668	318986
19907	28357	1	applied	\N	\N	\N	\N	151669	151669	318987
19907	28358	2	applied	\N	\N	\N	\N	151670	151670	318988
19907	28359	3	applied	\N	\N	\N	\N	151671	151671	318989
19907	28360	4	applied	\N	\N	\N	\N	151672	151672	318990
19907	28361	5	applied	\N	\N	\N	\N	151673	151673	318991
19907	28362	6	applied	\N	\N	\N	\N	151674	151674	318992
19907	28363	7	applied	\N	\N	\N	\N	151675	151675	318993
19907	28364	8	applied	\N	\N	\N	\N	151676	151676	318994
19907	28365	9	applied	\N	\N	\N	\N	151677	151677	318995
19909	28367	1	applied	\N	\N	\N	\N	151683	151683	319001
19909	28368	2	applied	\N	\N	\N	\N	151684	151684	319002
19909	28369	3	applied	\N	\N	\N	\N	151685	151685	319003
19913	28376	0	applied	\N	\N	\N	\N	151702	151702	319020
19913	28377	1	applied	\N	\N	\N	\N	151703	151703	319021
19913	28378	2	applied	\N	\N	\N	\N	151704	151704	319022
19913	28379	3	applied	\N	\N	\N	\N	151705	151705	319023
19915	28380	0	applied	\N	\N	\N	\N	151710	151710	319028
19915	28381	1	applied	\N	\N	\N	\N	151711	151711	319029
19915	28382	2	applied	\N	\N	\N	\N	151712	151712	319030
19918	28393	0	applied	\N	\N	\N	\N	151723	151723	319041
19918	28394	1	applied	\N	\N	\N	\N	151724	151724	319042
19918	28395	2	applied	\N	\N	\N	\N	151725	151725	319043
19918	28396	3	applied	\N	\N	\N	\N	151726	151726	319044
19918	28397	4	applied	\N	\N	\N	\N	151727	151727	319045
19918	28398	5	applied	\N	\N	\N	\N	151728	151728	319046
19921	28366	0	applied	\N	\N	\N	\N	151741	151741	319059
19921	28370	1	applied	\N	\N	\N	\N	151742	151742	319060
19921	28371	2	applied	\N	\N	\N	\N	151743	151743	319061
19921	28376	3	applied	\N	\N	\N	\N	151744	151744	319062
19921	28404	4	applied	\N	\N	\N	\N	151745	151745	319063
19921	28383	5	applied	\N	\N	\N	\N	151746	151746	319064
19921	28328	6	applied	\N	\N	\N	\N	151747	151747	319065
19921	28329	7	applied	\N	\N	\N	\N	151748	151748	319066
19921	28330	8	applied	\N	\N	\N	\N	151749	151749	319067
19921	28389	9	applied	\N	\N	\N	\N	151750	151750	319068
19921	28390	10	applied	\N	\N	\N	\N	151751	151751	319069
19921	28393	11	applied	\N	\N	\N	\N	151752	151752	319070
19921	28332	12	applied	\N	\N	\N	\N	151753	151753	319071
19921	28339	13	applied	\N	\N	\N	\N	151754	151754	319072
19925	28406	0	applied	\N	\N	\N	\N	151762	151762	319080
19867	28273	13	applied	\N	\N	\N	\N	151409	151409	318727
19867	28274	14	applied	\N	\N	\N	\N	151410	151410	318728
19884	28312	5	applied	\N	\N	\N	\N	151550	151550	318868
19884	28313	6	applied	\N	\N	\N	\N	151551	151551	318869
19889	28320	0	applied	\N	\N	\N	\N	151563	151563	318881
19889	28321	1	applied	\N	\N	\N	\N	151564	151564	318882
19889	28322	2	applied	\N	\N	\N	\N	151565	151565	318883
19889	28323	3	applied	\N	\N	\N	\N	151566	151566	318884
19889	28324	4	applied	\N	\N	\N	\N	151567	151567	318885
19889	28325	5	applied	\N	\N	\N	\N	151568	151568	318886
19889	28326	6	applied	\N	\N	\N	\N	151569	151569	318887
19892	28338	0	applied	\N	\N	\N	\N	151592	151592	318910
19892	28339	1	applied	\N	\N	\N	\N	151593	151593	318911
19892	28340	2	applied	\N	\N	\N	\N	151594	151594	318912
19892	28341	3	applied	\N	\N	\N	\N	151595	151595	318913
19895	28341	3	applied	\N	\N	\N	\N	151607	151607	318925
19896	28338	0	applied	\N	\N	\N	\N	151608	151608	318926
19896	28339	1	applied	\N	\N	\N	\N	151609	151609	318927
19896	28340	2	applied	\N	\N	\N	\N	151610	151610	318928
19896	28341	3	applied	\N	\N	\N	\N	151611	151611	318929
19898	28342	0	applied	\N	\N	\N	\N	151616	151616	318934
19898	28343	1	applied	\N	\N	\N	\N	151617	151617	318935
19898	28344	2	applied	\N	\N	1000000000	\N	151618	151618	318936
19898	28345	3	applied	\N	\N	\N	\N	151619	151619	318937
19899	28342	0	applied	\N	\N	\N	\N	151620	151620	318938
19899	28343	1	applied	\N	\N	\N	\N	151621	151621	318939
19899	28344	2	applied	\N	\N	1000000000	\N	151622	151622	318940
19899	28345	3	applied	\N	\N	\N	\N	151623	151623	318941
19903	28353	0	applied	\N	\N	\N	\N	151642	151642	318960
19903	28354	1	applied	\N	\N	\N	\N	151643	151643	318961
19903	28355	2	applied	\N	\N	\N	\N	151644	151644	318962
19905	28357	1	applied	\N	\N	\N	\N	151649	151649	318967
19905	28358	2	applied	\N	\N	\N	\N	151650	151650	318968
19905	28359	3	applied	\N	\N	\N	\N	151651	151651	318969
19905	28360	4	applied	\N	\N	\N	\N	151652	151652	318970
19905	28361	5	applied	\N	\N	\N	\N	151653	151653	318971
19905	28362	6	applied	\N	\N	\N	\N	151654	151654	318972
19905	28363	7	applied	\N	\N	\N	\N	151655	151655	318973
19905	28364	8	applied	\N	\N	\N	\N	151656	151656	318974
19905	28365	9	applied	\N	\N	\N	\N	151657	151657	318975
19906	28356	0	applied	\N	\N	\N	\N	151658	151658	318976
19906	28357	1	applied	\N	\N	\N	\N	151659	151659	318977
19906	28358	2	applied	\N	\N	\N	\N	151660	151660	318978
19906	28359	3	applied	\N	\N	\N	\N	151661	151661	318979
19906	28360	4	applied	\N	\N	\N	\N	151662	151662	318980
19906	28361	5	applied	\N	\N	\N	\N	151663	151663	318981
19906	28362	6	applied	\N	\N	\N	\N	151664	151664	318982
19906	28364	8	applied	\N	\N	\N	\N	151666	151666	318984
19906	28365	9	applied	\N	\N	\N	\N	151667	151667	318985
19908	28366	0	applied	\N	\N	\N	\N	151678	151678	318996
19908	28367	1	applied	\N	\N	\N	\N	151679	151679	318997
19908	28368	2	applied	\N	\N	\N	\N	151680	151680	318998
19908	28369	3	applied	\N	\N	\N	\N	151681	151681	318999
19912	28370	0	applied	\N	\N	\N	\N	151696	151696	319014
19912	28371	1	applied	\N	\N	\N	\N	151697	151697	319015
19912	28372	2	applied	\N	\N	\N	\N	151698	151698	319016
19912	28373	3	applied	\N	\N	\N	\N	151699	151699	319017
19912	28374	4	applied	\N	\N	\N	\N	151700	151700	319018
19912	28375	5	applied	\N	\N	\N	\N	151701	151701	319019
19914	28376	0	applied	\N	\N	\N	\N	151706	151706	319024
19914	28377	1	applied	\N	\N	\N	\N	151707	151707	319025
19917	28388	0	applied	\N	\N	\N	\N	151718	151718	319036
19917	28389	1	applied	\N	\N	\N	\N	151719	151719	319037
19917	28391	3	applied	\N	\N	\N	\N	151721	151721	319039
19917	28392	4	applied	\N	\N	\N	\N	151722	151722	319040
19920	28400	0	applied	\N	\N	\N	\N	151737	151737	319055
19920	28401	1	applied	\N	\N	\N	\N	151738	151738	319056
19920	28402	2	applied	\N	\N	\N	\N	151739	151739	319057
19920	28403	3	applied	\N	\N	\N	\N	151740	151740	319058
19932	28413	0	applied	\N	\N	\N	\N	151786	151786	319104
19932	28416	1	applied	\N	\N	\N	\N	151787	151787	319105
19932	28417	2	applied	\N	\N	\N	\N	151788	151788	319106
19932	28414	3	applied	\N	\N	\N	\N	151789	151789	319107
19932	28418	4	applied	\N	\N	\N	\N	151790	151790	319108
19934	28419	0	applied	\N	\N	\N	\N	151795	151795	319113
19934	28420	1	applied	\N	\N	\N	\N	151796	151796	319114
19934	28421	2	applied	\N	\N	\N	\N	151797	151797	319115
19934	28422	3	applied	\N	\N	\N	\N	151798	151798	319116
19936	28423	0	applied	\N	\N	\N	\N	151801	151801	319119
19938	28425	0	applied	\N	\N	\N	\N	151805	151805	319123
19938	28426	1	applied	\N	\N	\N	\N	151806	151806	319124
19938	28427	2	applied	\N	\N	\N	\N	151807	151807	319125
19942	28425	0	applied	\N	\N	\N	\N	151817	151817	319135
19942	28426	1	applied	\N	\N	\N	\N	151818	151818	319136
19942	28427	2	applied	\N	\N	\N	\N	151819	151819	319137
19944	28366	0	applied	\N	\N	\N	\N	151823	151823	319141
19944	28239	1	applied	\N	\N	\N	\N	151824	151824	319142
19944	28109	2	applied	\N	\N	\N	\N	151825	151825	319143
19944	28110	3	applied	\N	\N	\N	\N	151826	151826	319144
19944	28111	4	applied	\N	\N	\N	\N	151827	151827	319145
19944	28112	5	applied	\N	\N	\N	\N	151828	151828	319146
19944	28370	6	applied	\N	\N	\N	\N	151829	151829	319147
19944	28371	7	applied	\N	\N	\N	\N	151830	151830	319148
19944	28376	8	applied	\N	\N	\N	\N	151831	151831	319149
19944	28404	9	applied	\N	\N	\N	\N	151832	151832	319150
19944	28328	11	applied	\N	\N	\N	\N	151834	151834	319152
19944	28329	12	applied	\N	\N	\N	\N	151835	151835	319153
19944	27992	13	applied	\N	\N	\N	\N	151836	151836	319154
19944	28330	14	applied	\N	\N	\N	\N	151837	151837	319155
19944	27995	15	applied	\N	\N	\N	\N	151838	151838	319156
19944	27998	16	applied	\N	\N	\N	\N	151839	151839	319157
19944	28001	17	applied	\N	\N	\N	\N	151840	151840	319158
19944	28004	18	applied	\N	\N	\N	\N	151841	151841	319159
19944	28389	19	applied	\N	\N	\N	\N	151842	151842	319160
19944	28390	20	applied	\N	\N	\N	\N	151843	151843	319161
19944	28393	21	applied	\N	\N	\N	\N	151844	151844	319162
19944	28006	22	applied	\N	\N	\N	\N	151845	151845	319163
19944	28007	23	applied	\N	\N	\N	\N	151846	151846	319164
19944	28012	24	applied	\N	\N	\N	\N	151847	151847	319165
19944	28015	25	applied	\N	\N	\N	\N	151848	151848	319166
19944	28018	26	applied	\N	\N	\N	\N	151849	151849	319167
19884	28310	3	applied	\N	\N	\N	\N	151548	151548	318866
19884	28311	4	applied	\N	\N	\N	\N	151549	151549	318867
19902	28346	0	applied	\N	\N	\N	\N	151635	151635	318953
19902	28347	1	applied	\N	\N	\N	\N	151636	151636	318954
19902	28348	2	applied	\N	\N	\N	\N	151637	151637	318955
19902	28349	3	applied	\N	\N	\N	\N	151638	151638	318956
19902	28350	4	applied	\N	\N	\N	\N	151639	151639	318957
19902	28351	5	applied	\N	\N	\N	\N	151640	151640	318958
19902	28352	6	applied	\N	\N	\N	\N	151641	151641	318959
19910	28366	0	applied	\N	\N	\N	\N	151686	151686	319004
19910	28367	1	applied	\N	\N	\N	\N	151687	151687	319005
19910	28368	2	applied	\N	\N	\N	\N	151688	151688	319006
19910	28369	3	applied	\N	\N	\N	\N	151689	151689	319007
19911	28370	0	applied	\N	\N	\N	\N	151690	151690	319008
19911	28371	1	applied	\N	\N	\N	\N	151691	151691	319009
19911	28373	3	applied	\N	\N	\N	\N	151693	151693	319011
19911	28374	4	applied	\N	\N	\N	\N	151694	151694	319012
19911	28375	5	applied	\N	\N	\N	\N	151695	151695	319013
19914	28378	2	applied	\N	\N	\N	\N	151708	151708	319026
19914	28379	3	applied	\N	\N	\N	\N	151709	151709	319027
19916	28383	0	applied	\N	\N	\N	\N	151713	151713	319031
19916	28384	1	applied	\N	\N	\N	\N	151714	151714	319032
19916	28385	2	applied	\N	\N	\N	\N	151715	151715	319033
19916	28386	3	applied	\N	\N	\N	\N	151716	151716	319034
19922	28400	0	applied	\N	\N	\N	\N	151756	151756	319074
19922	28401	1	applied	\N	\N	\N	\N	151757	151757	319075
19922	28402	2	applied	\N	\N	\N	\N	151758	151758	319076
19922	28403	3	applied	\N	\N	\N	\N	151759	151759	319077
19924	28405	0	applied	\N	\N	\N	\N	151761	151761	319079
19929	28415	0	applied	\N	\N	\N	\N	151775	151775	319093
19931	28413	0	applied	\N	\N	\N	\N	151781	151781	319099
19931	28417	2	applied	\N	\N	\N	\N	151783	151783	319101
19931	28414	3	applied	\N	\N	\N	\N	151784	151784	319102
19931	28418	4	applied	\N	\N	\N	\N	151785	151785	319103
19933	28419	0	applied	\N	\N	\N	\N	151791	151791	319109
19933	28420	1	applied	\N	\N	\N	\N	151792	151792	319110
19933	28421	2	applied	\N	\N	\N	\N	151793	151793	319111
19933	28422	3	applied	\N	\N	\N	\N	151794	151794	319112
19935	28423	0	applied	\N	\N	\N	\N	151799	151799	319117
19935	28424	1	applied	\N	\N	\N	\N	151800	151800	319118
19941	28425	0	applied	\N	\N	\N	\N	151814	151814	319132
19941	28426	1	applied	\N	\N	\N	\N	151815	151815	319133
19941	28427	2	applied	\N	\N	\N	\N	151816	151816	319134
19945	28428	0	applied	\N	\N	\N	\N	151948	151948	319266
19945	28429	1	applied	\N	\N	\N	\N	151949	151949	319267
19945	28430	2	applied	\N	\N	\N	\N	151950	151950	319268
19945	28431	3	applied	\N	\N	\N	\N	151951	151951	319269
19945	28433	5	applied	\N	\N	\N	\N	151953	151953	319271
19945	28434	6	applied	\N	\N	\N	\N	151954	151954	319272
19951	28460	0	applied	\N	\N	\N	\N	151998	151998	319316
19951	28461	1	applied	\N	\N	\N	\N	151999	151999	319317
19951	28462	2	applied	\N	\N	\N	\N	152000	152000	319318
19957	28489	0	applied	\N	\N	\N	\N	152043	152043	319361
19957	28490	1	applied	\N	\N	\N	\N	152044	152044	319362
19957	28491	2	applied	\N	\N	\N	\N	152045	152045	319363
19957	28492	3	applied	\N	\N	\N	\N	152046	152046	319364
19959	28493	0	applied	\N	\N	\N	\N	152172	152172	319490
19959	28494	1	applied	\N	\N	\N	\N	152173	152173	319491
19959	28495	2	applied	\N	\N	\N	\N	152174	152174	319492
19964	28366	0	applied	\N	\N	\N	\N	152187	152187	319505
19964	28370	1	applied	\N	\N	\N	\N	152188	152188	319506
19964	28371	2	applied	\N	\N	\N	\N	152189	152189	319507
19964	28376	3	applied	\N	\N	\N	\N	152190	152190	319508
19964	28383	5	applied	\N	\N	\N	\N	152192	152192	319510
19964	28328	6	applied	\N	\N	\N	\N	152193	152193	319511
19964	28329	7	applied	\N	\N	\N	\N	152194	152194	319512
19964	28330	8	applied	\N	\N	\N	\N	152195	152195	319513
19964	28447	9	applied	\N	\N	\N	\N	152196	152196	319514
19969	28519	0	applied	\N	\N	\N	\N	152218	152218	319536
19969	28520	1	applied	\N	\N	\N	\N	152219	152219	319537
19969	28521	2	applied	\N	\N	\N	\N	152220	152220	319538
19972	28522	0	applied	\N	\N	\N	\N	152231	152231	319549
19972	28523	1	applied	\N	\N	\N	\N	152232	152232	319550
19972	28524	2	applied	\N	\N	\N	\N	152233	152233	319551
19972	28525	3	applied	\N	\N	\N	\N	152234	152234	319552
19972	28526	4	applied	\N	\N	\N	\N	152235	152235	319553
19972	28527	5	applied	\N	\N	\N	\N	152236	152236	319554
19972	28528	6	applied	\N	\N	\N	\N	152237	152237	319555
19975	28522	0	applied	\N	\N	\N	\N	152252	152252	319570
19975	28524	2	applied	\N	\N	\N	\N	152254	152254	319572
19975	28525	3	applied	\N	\N	\N	\N	152255	152255	319573
19975	28526	4	applied	\N	\N	\N	\N	152256	152256	319574
19975	28527	5	applied	\N	\N	\N	\N	152257	152257	319575
19975	28528	6	applied	\N	\N	\N	\N	152258	152258	319576
19979	28529	0	applied	\N	\N	\N	\N	152275	152275	319593
19979	28530	1	applied	\N	\N	\N	\N	152276	152276	319594
19979	28531	2	applied	\N	\N	\N	\N	152277	152277	319595
19979	28532	3	applied	\N	\N	\N	\N	152278	152278	319596
19979	28533	4	applied	\N	\N	\N	\N	152279	152279	319597
19979	28534	5	applied	\N	\N	\N	\N	152280	152280	319598
19979	28535	6	applied	\N	\N	\N	\N	152281	152281	319599
19979	28536	7	applied	\N	\N	\N	\N	152282	152282	319600
19979	28537	8	applied	\N	\N	\N	\N	152283	152283	319601
19981	28544	0	applied	\N	\N	\N	\N	152290	152290	319608
19981	28546	2	applied	\N	\N	\N	\N	152292	152292	319610
19981	28547	3	applied	\N	\N	\N	\N	152293	152293	319611
19981	28548	4	applied	\N	\N	\N	\N	152294	152294	319612
19981	28549	5	applied	\N	\N	\N	\N	152295	152295	319613
19990	28562	0	applied	\N	\N	\N	\N	152327	152327	319645
19990	28563	1	applied	\N	\N	\N	\N	152328	152328	319646
19990	28564	2	applied	\N	\N	\N	\N	152329	152329	319647
19991	28565	0	applied	\N	\N	\N	\N	152330	152330	319648
19991	28566	1	applied	\N	\N	\N	\N	152331	152331	319649
19991	28567	2	applied	\N	\N	\N	\N	152332	152332	319650
19991	28568	3	applied	\N	\N	\N	\N	152333	152333	319651
19991	28569	4	applied	\N	\N	\N	\N	152334	152334	319652
19991	28570	5	applied	\N	\N	\N	\N	152335	152335	319653
19991	28571	6	applied	\N	\N	\N	\N	152336	152336	319654
19991	28572	7	applied	\N	\N	\N	\N	152337	152337	319655
19991	28573	8	applied	\N	\N	\N	\N	152338	152338	319656
19991	28574	9	applied	\N	\N	\N	\N	152339	152339	319657
19991	28575	10	applied	\N	\N	\N	\N	152340	152340	319658
19900	28345	3	applied	\N	\N	\N	\N	151627	151627	318945
19919	28396	3	applied	\N	\N	\N	\N	151733	151733	319051
19919	28397	4	applied	\N	\N	\N	\N	151734	151734	319052
19919	28398	5	applied	\N	\N	\N	\N	151735	151735	319053
19919	28399	6	applied	\N	\N	\N	\N	151736	151736	319054
19923	28405	0	applied	\N	\N	\N	\N	151760	151760	319078
19925	28407	1	applied	\N	\N	\N	\N	151763	151763	319081
19925	28408	2	applied	\N	\N	\N	\N	151764	151764	319082
19926	28406	0	applied	\N	\N	\N	\N	151765	151765	319083
19926	28407	1	applied	\N	\N	\N	\N	151766	151766	319084
19926	28408	2	applied	\N	\N	\N	\N	151767	151767	319085
19927	28409	0	applied	\N	\N	\N	\N	151768	151768	319086
19927	28410	1	applied	\N	\N	\N	\N	151769	151769	319087
19927	28411	2	applied	\N	\N	\N	\N	151770	151770	319088
19927	28412	3	applied	\N	\N	\N	\N	151771	151771	319089
19928	28413	0	applied	\N	\N	\N	\N	151772	151772	319090
19928	28414	1	applied	\N	\N	\N	\N	151773	151773	319091
19930	28413	0	applied	\N	\N	\N	\N	151776	151776	319094
19930	28416	1	applied	\N	\N	\N	\N	151777	151777	319095
19930	28417	2	applied	\N	\N	\N	\N	151778	151778	319096
19930	28414	3	applied	\N	\N	\N	\N	151779	151779	319097
19930	28418	4	applied	\N	\N	\N	\N	151780	151780	319098
19937	28423	0	applied	\N	\N	\N	\N	151803	151803	319121
19937	28424	1	applied	\N	\N	\N	\N	151804	151804	319122
19939	28425	0	applied	\N	\N	\N	\N	151808	151808	319126
19939	28426	1	applied	\N	\N	\N	\N	151809	151809	319127
19939	28427	2	applied	\N	\N	\N	\N	151810	151810	319128
19940	28425	0	applied	\N	\N	\N	\N	151811	151811	319129
19940	28426	1	applied	\N	\N	\N	\N	151812	151812	319130
19940	28427	2	applied	\N	\N	\N	\N	151813	151813	319131
19943	28425	0	applied	\N	\N	\N	\N	151820	151820	319138
19943	28426	1	applied	\N	\N	\N	\N	151821	151821	319139
19943	28427	2	applied	\N	\N	\N	\N	151822	151822	319140
19946	28436	1	applied	\N	\N	\N	\N	151956	151956	319274
19946	28437	2	applied	\N	\N	\N	\N	151957	151957	319275
19947	28438	0	applied	\N	\N	\N	\N	151958	151958	319276
19947	28439	1	applied	\N	\N	\N	\N	151959	151959	319277
19947	28440	2	applied	\N	\N	\N	\N	151960	151960	319278
19947	28441	3	applied	\N	\N	\N	\N	151961	151961	319279
19947	28442	4	applied	\N	\N	\N	\N	151962	151962	319280
19947	28443	5	applied	\N	\N	\N	\N	151963	151963	319281
19947	28444	6	applied	\N	\N	\N	\N	151964	151964	319282
19948	28445	0	applied	\N	\N	\N	\N	151965	151965	319283
19948	28446	1	applied	\N	\N	\N	\N	151966	151966	319284
19948	28447	2	applied	\N	\N	\N	\N	151967	151967	319285
19948	28448	3	applied	\N	\N	\N	\N	151968	151968	319286
19948	28449	4	applied	\N	\N	\N	\N	151969	151969	319287
19948	28450	5	applied	\N	\N	\N	\N	151970	151970	319288
19948	28451	6	applied	\N	\N	\N	\N	151971	151971	319289
19948	28453	8	applied	\N	\N	\N	\N	151973	151973	319291
19948	28454	9	applied	\N	\N	\N	\N	151974	151974	319292
19948	28455	10	applied	\N	\N	\N	\N	151975	151975	319293
19948	28456	11	applied	\N	\N	\N	\N	151976	151976	319294
19948	28457	12	applied	\N	\N	\N	\N	151977	151977	319295
19948	28458	13	applied	\N	\N	\N	\N	151978	151978	319296
19948	28459	14	applied	\N	\N	\N	\N	151979	151979	319297
19950	28460	0	applied	\N	\N	\N	\N	151995	151995	319313
19950	28461	1	applied	\N	\N	\N	\N	151996	151996	319314
19950	28462	2	applied	\N	\N	\N	\N	151997	151997	319315
19953	28463	0	applied	\N	\N	\N	\N	152004	152004	319322
19953	28464	1	applied	\N	\N	\N	\N	152005	152005	319323
19953	28465	2	applied	\N	\N	\N	\N	152006	152006	319324
19953	28466	3	applied	\N	\N	\N	\N	152007	152007	319325
19953	28467	4	applied	\N	\N	\N	\N	152008	152008	319326
19953	28468	5	applied	\N	\N	\N	\N	152009	152009	319327
19953	28470	7	applied	\N	\N	\N	\N	152011	152011	319329
19953	28471	8	applied	\N	\N	\N	\N	152012	152012	319330
19953	28472	9	applied	\N	\N	\N	\N	152013	152013	319331
19954	28473	0	applied	\N	\N	\N	\N	152014	152014	319332
19954	28474	1	applied	\N	\N	\N	\N	152015	152015	319333
19954	28475	2	applied	\N	\N	\N	\N	152016	152016	319334
19954	28476	3	applied	\N	\N	\N	\N	152017	152017	319335
19954	28477	4	applied	\N	\N	\N	\N	152018	152018	319336
19954	28478	5	applied	\N	\N	\N	\N	152019	152019	319337
19954	28479	6	applied	\N	\N	\N	\N	152020	152020	319338
19954	28480	7	applied	\N	\N	\N	\N	152021	152021	319339
19954	28481	8	applied	\N	\N	\N	\N	152022	152022	319340
19954	28482	9	applied	\N	\N	\N	\N	152023	152023	319341
19954	28483	10	applied	\N	\N	\N	\N	152024	152024	319342
19954	28484	11	applied	\N	\N	\N	\N	152025	152025	319343
19954	28485	12	applied	\N	\N	\N	\N	152026	152026	319344
19956	28477	1	applied	\N	\N	\N	\N	152033	152033	319351
19956	28478	2	applied	\N	\N	\N	\N	152034	152034	319352
19956	28479	3	applied	\N	\N	\N	\N	152035	152035	319353
19956	28480	4	applied	\N	\N	\N	\N	152036	152036	319354
19956	28481	5	applied	\N	\N	\N	\N	152037	152037	319355
19956	28487	6	applied	\N	\N	\N	\N	152038	152038	319356
19956	28482	7	applied	\N	\N	\N	\N	152039	152039	319357
19956	28483	8	applied	\N	\N	\N	\N	152040	152040	319358
19956	28484	9	applied	\N	\N	\N	\N	152041	152041	319359
19956	28488	10	applied	\N	\N	\N	\N	152042	152042	319360
19958	28366	0	applied	\N	\N	\N	\N	152047	152047	319365
19958	28239	1	applied	\N	\N	\N	\N	152048	152048	319366
19958	28109	2	applied	\N	\N	\N	\N	152049	152049	319367
19958	28110	3	applied	\N	\N	\N	\N	152050	152050	319368
19958	28111	4	applied	\N	\N	\N	\N	152051	152051	319369
19958	28112	5	applied	\N	\N	\N	\N	152052	152052	319370
19966	28502	0	applied	\N	\N	\N	\N	152201	152201	319519
19966	28503	1	applied	\N	\N	\N	\N	152202	152202	319520
19966	28504	2	applied	\N	\N	\N	\N	152203	152203	319521
19966	28505	3	applied	\N	\N	\N	\N	152204	152204	319522
19971	28522	0	applied	\N	\N	\N	\N	152224	152224	319542
19971	28523	1	applied	\N	\N	\N	\N	152225	152225	319543
19971	28524	2	applied	\N	\N	\N	\N	152226	152226	319544
19971	28525	3	applied	\N	\N	\N	\N	152227	152227	319545
19971	28526	4	applied	\N	\N	\N	\N	152228	152228	319546
19971	28527	5	applied	\N	\N	\N	\N	152229	152229	319547
19971	28528	6	applied	\N	\N	\N	\N	152230	152230	319548
19978	28529	0	applied	\N	\N	\N	\N	152266	152266	319584
19978	28530	1	applied	\N	\N	\N	\N	152267	152267	319585
19978	28531	2	applied	\N	\N	\N	\N	152268	152268	319586
19919	28393	0	applied	\N	\N	\N	\N	151730	151730	319048
19919	28394	1	applied	\N	\N	\N	\N	151731	151731	319049
19944	28041	32	applied	\N	\N	\N	\N	151855	151855	319173
19944	28047	33	applied	\N	\N	\N	\N	151856	151856	319174
19944	28050	34	applied	\N	\N	\N	\N	151857	151857	319175
19944	28053	36	applied	\N	\N	\N	\N	151858	151858	319176
19944	28056	37	applied	\N	\N	\N	\N	151859	151859	319177
19944	28057	38	applied	\N	\N	\N	\N	151860	151860	319178
19944	28063	39	applied	\N	\N	\N	\N	151861	151861	319179
19944	28064	40	applied	\N	\N	\N	\N	151862	151862	319180
19944	28065	41	applied	\N	\N	\N	\N	151863	151863	319181
19944	28072	42	applied	\N	\N	\N	\N	151864	151864	319182
19944	28075	43	applied	\N	\N	\N	\N	151865	151865	319183
19944	28076	44	applied	\N	\N	\N	\N	151866	151866	319184
19944	28082	45	applied	\N	\N	\N	\N	151867	151867	319185
19944	28083	46	applied	\N	\N	\N	\N	151868	151868	319186
19944	28089	47	applied	\N	\N	\N	\N	151869	151869	319187
19944	28093	48	applied	\N	\N	\N	\N	151870	151870	319188
19944	28099	50	applied	\N	\N	\N	\N	151872	151872	319190
19944	28103	51	applied	\N	\N	\N	\N	151873	151873	319191
19944	28106	52	applied	\N	\N	\N	\N	151874	151874	319192
19958	28371	7	applied	\N	\N	\N	\N	152054	152054	319372
19958	28376	8	applied	\N	\N	\N	\N	152055	152055	319373
19958	28404	9	applied	\N	\N	\N	\N	152056	152056	319374
19958	28383	10	applied	\N	\N	\N	\N	152057	152057	319375
19958	28328	11	applied	\N	\N	\N	\N	152058	152058	319376
19958	28329	12	applied	\N	\N	\N	\N	152059	152059	319377
19958	28330	13	applied	\N	\N	\N	\N	152060	152060	319378
19958	28447	14	applied	\N	\N	\N	\N	152061	152061	319379
19958	28448	15	applied	\N	\N	\N	\N	152062	152062	319380
19958	28389	16	applied	\N	\N	\N	\N	152063	152063	319381
19958	28390	17	applied	\N	\N	\N	\N	152064	152064	319382
19958	28393	18	applied	\N	\N	\N	\N	152065	152065	319383
19958	28450	19	applied	\N	\N	\N	\N	152066	152066	319384
19958	28228	21	applied	\N	\N	\N	\N	152068	152068	319386
19958	28063	23	applied	\N	\N	\N	\N	152069	152069	319387
19958	28064	24	applied	\N	\N	\N	\N	152070	152070	319388
19958	28065	25	applied	\N	\N	\N	\N	152071	152071	319389
19958	28072	26	applied	\N	\N	\N	\N	152072	152072	319390
19958	28075	27	applied	\N	\N	\N	\N	152073	152073	319391
19958	28076	28	applied	\N	\N	\N	\N	152074	152074	319392
19958	28082	29	applied	\N	\N	\N	\N	152075	152075	319393
19958	28083	30	applied	\N	\N	\N	\N	152076	152076	319394
19958	28089	31	applied	\N	\N	\N	\N	152077	152077	319395
19958	28093	32	applied	\N	\N	\N	\N	152078	152078	319396
19958	28096	33	applied	\N	\N	\N	\N	152079	152079	319397
19958	28099	34	applied	\N	\N	\N	\N	152080	152080	319398
19958	28103	35	applied	\N	\N	\N	\N	152081	152081	319399
19958	28106	36	applied	\N	\N	\N	\N	152082	152082	319400
19958	28113	37	applied	\N	\N	\N	\N	152083	152083	319401
19958	28118	39	applied	\N	\N	\N	\N	152085	152085	319403
19958	28121	40	applied	\N	\N	\N	\N	152086	152086	319404
19958	28122	41	applied	\N	\N	\N	\N	152087	152087	319405
19958	28123	42	applied	\N	\N	\N	\N	152088	152088	319406
19958	28124	43	applied	\N	\N	\N	\N	152089	152089	319407
19958	28131	44	applied	\N	\N	\N	\N	152090	152090	319408
19958	28134	45	applied	\N	\N	\N	\N	152091	152091	319409
19958	28135	46	applied	\N	\N	\N	\N	152092	152092	319410
19958	28138	47	applied	\N	\N	\N	\N	152093	152093	319411
19958	28141	48	applied	\N	\N	\N	\N	152094	152094	319412
19958	28142	49	applied	\N	\N	\N	\N	152095	152095	319413
19958	28452	50	applied	\N	\N	\N	\N	152096	152096	319414
19958	28332	51	applied	\N	\N	\N	\N	152097	152097	319415
19958	28144	52	applied	\N	\N	\N	\N	152098	152098	319416
19958	28146	53	applied	\N	\N	\N	\N	152099	152099	319417
19958	28147	54	applied	\N	\N	\N	\N	152100	152100	319418
19958	28153	56	applied	\N	\N	\N	\N	152102	152102	319420
19958	28154	57	applied	\N	\N	\N	\N	152103	152103	319421
19958	28158	58	applied	\N	\N	\N	\N	152104	152104	319422
19958	28161	59	applied	\N	\N	\N	\N	152105	152105	319423
19958	28166	60	applied	\N	\N	\N	\N	152106	152106	319424
19958	28167	61	applied	\N	\N	\N	\N	152107	152107	319425
19958	28170	62	applied	\N	\N	\N	\N	152108	152108	319426
19958	28172	63	applied	\N	\N	\N	\N	152109	152109	319427
19958	28177	64	applied	\N	\N	\N	\N	152110	152110	319428
19958	28180	65	applied	\N	\N	\N	\N	152111	152111	319429
19958	28185	66	applied	\N	\N	\N	\N	152112	152112	319430
19958	28188	67	applied	\N	\N	\N	\N	152113	152113	319431
19958	28191	68	applied	\N	\N	\N	\N	152114	152114	319432
19958	28195	69	applied	\N	\N	\N	\N	152115	152115	319433
19958	28198	70	applied	\N	\N	\N	\N	152116	152116	319434
19958	28201	71	applied	\N	\N	\N	\N	152117	152117	319435
19958	28208	73	applied	\N	\N	\N	\N	152119	152119	319437
19958	28211	74	applied	\N	\N	\N	\N	152120	152120	319438
19958	28212	75	applied	\N	\N	\N	\N	152121	152121	319439
19958	28218	76	applied	\N	\N	\N	\N	152122	152122	319440
19958	28221	77	applied	\N	\N	\N	\N	152123	152123	319441
19958	28227	78	applied	\N	\N	\N	\N	152124	152124	319442
19958	28233	79	applied	\N	\N	\N	\N	152125	152125	319443
19958	28240	80	applied	\N	\N	\N	\N	152126	152126	319444
19958	28243	81	applied	\N	\N	\N	\N	152127	152127	319445
19958	28248	82	applied	\N	\N	\N	\N	152128	152128	319446
19958	28253	83	applied	\N	\N	\N	\N	152129	152129	319447
19958	28256	84	applied	\N	\N	\N	\N	152130	152130	319448
19958	28263	85	applied	\N	\N	\N	\N	152131	152131	319449
19958	28264	86	applied	\N	\N	\N	\N	152132	152132	319450
19958	28265	87	applied	\N	\N	\N	\N	152133	152133	319451
19958	28266	88	applied	\N	\N	\N	\N	152134	152134	319452
19958	28280	90	applied	\N	\N	\N	\N	152136	152136	319454
19958	28283	91	applied	\N	\N	\N	\N	152137	152137	319455
19958	28286	92	applied	\N	\N	\N	\N	152138	152138	319456
19958	28292	93	applied	\N	\N	\N	\N	152139	152139	319457
19958	28294	94	applied	\N	\N	\N	\N	152140	152140	319458
19958	28297	95	applied	\N	\N	\N	\N	152141	152141	319459
19958	28298	96	applied	\N	\N	\N	\N	152142	152142	319460
19958	28304	97	applied	\N	\N	\N	\N	152143	152143	319461
19958	28307	98	applied	\N	\N	\N	\N	152144	152144	319462
19958	28308	99	applied	\N	\N	\N	\N	152145	152145	319463
19958	28314	100	applied	\N	\N	\N	\N	152146	152146	319464
19958	28317	101	applied	\N	\N	\N	\N	152147	152147	319465
19958	28320	102	applied	\N	\N	\N	\N	152148	152148	319466
19958	28321	103	applied	\N	\N	\N	\N	152149	152149	319467
19944	28228	29	applied	\N	\N	\N	\N	151852	151852	319170
19944	28034	30	applied	\N	\N	\N	\N	151853	151853	319171
19944	28122	57	applied	\N	\N	\N	\N	151879	151879	319197
19944	28123	58	applied	\N	\N	\N	\N	151880	151880	319198
19944	28124	59	applied	\N	\N	\N	\N	151881	151881	319199
19944	28131	60	applied	\N	\N	\N	\N	151882	151882	319200
19944	28134	61	applied	\N	\N	\N	\N	151883	151883	319201
19944	28135	62	applied	\N	\N	\N	\N	151884	151884	319202
19944	28138	63	applied	\N	\N	\N	\N	151885	151885	319203
19944	28141	64	applied	\N	\N	\N	\N	151886	151886	319204
19944	28142	65	applied	\N	\N	\N	\N	151887	151887	319205
19944	28332	66	applied	\N	\N	\N	\N	151888	151888	319206
19944	28144	67	applied	\N	\N	\N	\N	151889	151889	319207
19944	28146	68	applied	\N	\N	\N	\N	151890	151890	319208
19944	28147	69	applied	\N	\N	\N	\N	151891	151891	319209
19944	28148	70	applied	\N	\N	\N	\N	151892	151892	319210
19944	28153	71	applied	\N	\N	\N	\N	151893	151893	319211
19944	28154	72	applied	\N	\N	\N	\N	151894	151894	319212
19944	28161	74	applied	\N	\N	\N	\N	151896	151896	319214
19944	28166	75	applied	\N	\N	\N	\N	151897	151897	319215
19944	28167	76	applied	\N	\N	\N	\N	151898	151898	319216
19944	28170	77	applied	\N	\N	\N	\N	151899	151899	319217
19944	28172	78	applied	\N	\N	\N	\N	151900	151900	319218
19944	28177	79	applied	\N	\N	\N	\N	151901	151901	319219
19944	28180	80	applied	\N	\N	\N	\N	151902	151902	319220
19944	28185	81	applied	\N	\N	\N	\N	151903	151903	319221
19944	28188	82	applied	\N	\N	\N	\N	151904	151904	319222
19944	28191	83	applied	\N	\N	\N	\N	151905	151905	319223
19944	28195	84	applied	\N	\N	\N	\N	151906	151906	319224
19944	28198	85	applied	\N	\N	\N	\N	151907	151907	319225
19944	28201	86	applied	\N	\N	\N	\N	151908	151908	319226
19944	28204	87	applied	\N	\N	\N	\N	151909	151909	319227
19944	28208	88	applied	\N	\N	\N	\N	151910	151910	319228
19944	28211	89	applied	\N	\N	\N	\N	151911	151911	319229
19944	28218	91	applied	\N	\N	\N	\N	151913	151913	319231
19944	28221	92	applied	\N	\N	\N	\N	151914	151914	319232
19944	28227	93	applied	\N	\N	\N	\N	151915	151915	319233
19944	28233	94	applied	\N	\N	\N	\N	151916	151916	319234
19944	28240	95	applied	\N	\N	\N	\N	151917	151917	319235
19944	28243	96	applied	\N	\N	\N	\N	151918	151918	319236
19944	28248	97	applied	\N	\N	\N	\N	151919	151919	319237
19944	28253	98	applied	\N	\N	\N	\N	151920	151920	319238
19944	28256	99	applied	\N	\N	\N	\N	151921	151921	319239
19944	28263	100	applied	\N	\N	\N	\N	151922	151922	319240
19944	28264	101	applied	\N	\N	\N	\N	151923	151923	319241
19944	28265	102	applied	\N	\N	\N	\N	151924	151924	319242
19944	28266	103	applied	\N	\N	\N	\N	151925	151925	319243
19944	28267	104	applied	\N	\N	\N	\N	151926	151926	319244
19944	28280	105	applied	\N	\N	\N	\N	151927	151927	319245
19944	28283	106	applied	\N	\N	\N	\N	151928	151928	319246
19944	28292	108	applied	\N	\N	\N	\N	151930	151930	319248
19944	28294	109	applied	\N	\N	\N	\N	151931	151931	319249
19944	28297	110	applied	\N	\N	\N	\N	151932	151932	319250
19944	28298	111	applied	\N	\N	\N	\N	151933	151933	319251
19944	28304	112	applied	\N	\N	\N	\N	151934	151934	319252
19944	28307	113	applied	\N	\N	\N	\N	151935	151935	319253
19944	28308	114	applied	\N	\N	\N	\N	151936	151936	319254
19944	28314	115	applied	\N	\N	\N	\N	151937	151937	319255
19944	28317	116	applied	\N	\N	\N	\N	151938	151938	319256
19944	28320	117	applied	\N	\N	\N	\N	151939	151939	319257
19944	28321	118	applied	\N	\N	\N	\N	151940	151940	319258
19944	28327	119	applied	\N	\N	\N	\N	151941	151941	319259
19944	28331	120	applied	\N	\N	\N	\N	151942	151942	319260
19944	28338	121	applied	\N	\N	\N	\N	151943	151943	319261
19944	28342	122	applied	\N	\N	\N	\N	151944	151944	319262
19944	28346	123	applied	\N	\N	\N	\N	151945	151945	319263
19944	28353	125	applied	\N	\N	\N	\N	151947	151947	319265
19949	28445	0	applied	\N	\N	\N	\N	151980	151980	319298
19949	28446	1	applied	\N	\N	\N	\N	151981	151981	319299
19949	28447	2	applied	\N	\N	\N	\N	151982	151982	319300
19949	28448	3	applied	\N	\N	\N	\N	151983	151983	319301
19949	28449	4	applied	\N	\N	\N	\N	151984	151984	319302
19949	28450	5	applied	\N	\N	\N	\N	151985	151985	319303
19949	28451	6	applied	\N	\N	\N	\N	151986	151986	319304
19949	28452	7	applied	\N	\N	\N	\N	151987	151987	319305
19949	28453	8	applied	\N	\N	\N	\N	151988	151988	319306
19949	28454	9	applied	\N	\N	\N	\N	151989	151989	319307
19949	28455	10	applied	\N	\N	\N	\N	151990	151990	319308
19949	28456	11	applied	\N	\N	\N	\N	151991	151991	319309
19949	28457	12	applied	\N	\N	\N	\N	151992	151992	319310
19949	28458	13	applied	\N	\N	\N	\N	151993	151993	319311
19949	28459	14	applied	\N	\N	\N	\N	151994	151994	319312
19952	28461	1	applied	\N	\N	\N	\N	152002	152002	319320
19952	28462	2	applied	\N	\N	\N	\N	152003	152003	319321
19955	28473	0	applied	\N	\N	\N	\N	152027	152027	319345
19955	28474	1	applied	\N	\N	\N	\N	152028	152028	319346
19955	28475	2	applied	\N	\N	\N	\N	152029	152029	319347
19955	28476	3	applied	\N	\N	\N	\N	152030	152030	319348
19955	28485	4	applied	\N	\N	\N	\N	152031	152031	319349
19958	28327	104	applied	\N	\N	\N	\N	152150	152150	319468
19958	28331	105	applied	\N	\N	\N	\N	152151	152151	319469
19958	28338	106	applied	\N	\N	\N	\N	152152	152152	319470
19958	28342	107	applied	\N	\N	\N	\N	152153	152153	319471
19958	28346	108	applied	\N	\N	\N	\N	152154	152154	319472
19958	28347	109	applied	\N	\N	\N	\N	152155	152155	319473
19958	28353	110	applied	\N	\N	\N	\N	152156	152156	319474
19958	28356	111	applied	\N	\N	\N	\N	152157	152157	319475
19958	28357	112	applied	\N	\N	\N	\N	152158	152158	319476
19958	28367	114	applied	\N	\N	\N	\N	152160	152160	319478
19958	28372	115	applied	\N	\N	\N	\N	152161	152161	319479
19958	28377	116	applied	\N	\N	\N	\N	152162	152162	319480
19958	28380	117	applied	\N	\N	\N	\N	152163	152163	319481
19958	28384	118	applied	\N	\N	\N	\N	152164	152164	319482
19958	28388	119	applied	\N	\N	\N	\N	152165	152165	319483
19958	28394	120	applied	\N	\N	\N	\N	152166	152166	319484
19958	28395	121	applied	\N	\N	\N	\N	152167	152167	319485
19958	28400	122	applied	\N	\N	\N	\N	152168	152168	319486
19958	28406	123	applied	\N	\N	\N	\N	152169	152169	319487
19958	28409	124	applied	\N	\N	\N	\N	152170	152170	319488
19958	28413	125	applied	\N	\N	\N	\N	152171	152171	319489
19961	28496	0	applied	\N	\N	\N	\N	152178	152178	319496
19961	28497	1	applied	\N	\N	\N	\N	152179	152179	319497
19944	28117	54	applied	\N	\N	\N	\N	151876	151876	319194
19944	28118	55	applied	\N	\N	\N	\N	151877	151877	319195
19961	28498	2	applied	\N	\N	\N	\N	152180	152180	319498
19962	28499	0	applied	\N	\N	\N	\N	152181	152181	319499
19962	28500	1	applied	\N	\N	\N	\N	152182	152182	319500
19962	28501	2	applied	\N	\N	\N	\N	152183	152183	319501
19963	28499	0	applied	\N	\N	\N	\N	152184	152184	319502
19963	28500	1	applied	\N	\N	\N	\N	152185	152185	319503
19963	28501	2	applied	\N	\N	\N	\N	152186	152186	319504
19965	28503	1	applied	\N	\N	\N	\N	152198	152198	319516
19965	28504	2	applied	\N	\N	\N	\N	152199	152199	319517
19965	28505	3	applied	\N	\N	\N	\N	152200	152200	319518
19967	28506	0	applied	\N	\N	\N	\N	152205	152205	319523
19967	28507	1	applied	\N	\N	\N	\N	152206	152206	319524
19967	28508	2	applied	\N	\N	\N	\N	152207	152207	319525
19967	28509	3	applied	\N	\N	\N	\N	152208	152208	319526
19967	28510	4	applied	\N	\N	\N	\N	152209	152209	319527
19967	28511	5	applied	\N	\N	\N	\N	152210	152210	319528
19968	28512	0	applied	\N	\N	\N	\N	152211	152211	319529
19968	28513	1	applied	\N	\N	\N	\N	152212	152212	319530
19968	28514	2	applied	\N	\N	\N	\N	152213	152213	319531
19968	28515	3	applied	\N	\N	\N	\N	152214	152214	319532
19968	28516	4	applied	\N	\N	\N	\N	152215	152215	319533
19968	28517	5	applied	\N	\N	\N	\N	152216	152216	319534
19968	28518	6	applied	\N	\N	\N	\N	152217	152217	319535
19970	28520	1	applied	\N	\N	\N	\N	152222	152222	319540
19970	28521	2	applied	\N	\N	\N	\N	152223	152223	319541
19973	28522	0	applied	\N	\N	\N	\N	152238	152238	319556
19973	28523	1	applied	\N	\N	\N	\N	152239	152239	319557
19973	28524	2	applied	\N	\N	\N	\N	152240	152240	319558
19973	28525	3	applied	\N	\N	\N	\N	152241	152241	319559
19973	28526	4	applied	\N	\N	\N	\N	152242	152242	319560
19973	28527	5	applied	\N	\N	\N	\N	152243	152243	319561
19973	28528	6	applied	\N	\N	\N	\N	152244	152244	319562
19974	28522	0	applied	\N	\N	\N	\N	152245	152245	319563
19974	28523	1	applied	\N	\N	\N	\N	152246	152246	319564
19974	28524	2	applied	\N	\N	\N	\N	152247	152247	319565
19974	28525	3	applied	\N	\N	\N	\N	152248	152248	319566
19974	28526	4	applied	\N	\N	\N	\N	152249	152249	319567
19974	28527	5	applied	\N	\N	\N	\N	152250	152250	319568
19974	28528	6	applied	\N	\N	\N	\N	152251	152251	319569
19976	28523	1	applied	\N	\N	\N	\N	152260	152260	319578
19980	28538	0	applied	\N	\N	\N	\N	152284	152284	319602
19980	28539	1	applied	\N	\N	\N	\N	152285	152285	319603
19980	28540	2	applied	\N	\N	\N	\N	152286	152286	319604
19980	28541	3	applied	\N	\N	\N	\N	152287	152287	319605
19980	28542	4	applied	\N	\N	\N	\N	152288	152288	319606
19980	28543	5	applied	\N	\N	\N	\N	152289	152289	319607
19983	28550	0	applied	\N	\N	\N	\N	152299	152299	319617
19983	28551	1	applied	\N	\N	\N	\N	152300	152300	319618
19983	28552	2	applied	\N	\N	\N	\N	152301	152301	319619
19987	28557	0	applied	\N	\N	\N	\N	152312	152312	319630
19987	28558	1	applied	\N	\N	\N	\N	152313	152313	319631
19987	28559	2	applied	\N	\N	\N	\N	152314	152314	319632
19987	28560	3	applied	\N	\N	\N	\N	152315	152315	319633
19987	28561	4	applied	\N	\N	\N	\N	152316	152316	319634
19989	28557	0	applied	\N	\N	\N	\N	152322	152322	319640
19989	28559	2	applied	\N	\N	\N	\N	152324	152324	319642
19989	28560	3	applied	\N	\N	\N	\N	152325	152325	319643
19989	28561	4	applied	\N	\N	\N	\N	152326	152326	319644
19995	28577	0	applied	\N	\N	\N	\N	152357	152357	319675
19995	28578	1	applied	\N	\N	\N	\N	152358	152358	319676
19995	28579	2	applied	\N	\N	\N	\N	152359	152359	319677
20001	28585	0	applied	\N	\N	\N	\N	152490	152490	319808
20001	28586	1	applied	\N	\N	\N	\N	152491	152491	319809
20001	28587	2	applied	\N	\N	\N	\N	152492	152492	319810
20001	28588	3	applied	\N	\N	\N	\N	152493	152493	319811
20001	28589	4	applied	\N	\N	\N	\N	152494	152494	319812
20014	28616	0	applied	\N	\N	\N	\N	152555	152555	319873
20014	28617	1	applied	\N	\N	\N	\N	152556	152556	319874
20014	28618	2	applied	\N	\N	\N	\N	152557	152557	319875
20017	28619	0	applied	\N	\N	\N	\N	152564	152564	319882
20017	28620	1	applied	\N	\N	\N	\N	152565	152565	319883
20017	28622	3	applied	\N	\N	\N	\N	152567	152567	319885
20019	28623	0	applied	\N	\N	\N	\N	152572	152572	319890
20019	28624	1	applied	\N	\N	1000000000	\N	152573	152573	319891
20019	28625	2	applied	\N	\N	\N	\N	152574	152574	319892
20019	28626	3	applied	\N	\N	\N	\N	152575	152575	319893
20022	28631	0	applied	\N	\N	\N	\N	152584	152584	319902
20022	28632	1	applied	\N	\N	\N	\N	152585	152585	319903
20022	28633	2	applied	\N	\N	1000000000	\N	152586	152586	319904
20022	28634	3	applied	\N	\N	\N	\N	152587	152587	319905
20022	28635	4	applied	\N	\N	\N	\N	152588	152588	319906
20022	28636	5	applied	\N	\N	\N	\N	152589	152589	319907
20022	28637	6	applied	\N	\N	\N	\N	152590	152590	319908
20022	28638	7	applied	\N	\N	\N	\N	152591	152591	319909
20022	28639	8	applied	\N	\N	1000000000	\N	152592	152592	319910
20031	28659	0	applied	\N	\N	\N	\N	152617	152617	319935
20031	28660	1	applied	\N	\N	\N	\N	152618	152618	319936
20031	28661	2	applied	\N	\N	\N	\N	152619	152619	319937
20031	28662	3	applied	\N	\N	1000000000	\N	152620	152620	319938
20034	28670	0	applied	\N	\N	\N	\N	152628	152628	319946
20034	28671	1	applied	\N	\N	\N	\N	152629	152629	319947
20034	28672	2	applied	\N	\N	\N	\N	152630	152630	319948
20038	28673	0	applied	\N	\N	\N	\N	152642	152642	319960
20038	28674	1	applied	\N	\N	\N	\N	152643	152643	319961
20038	28675	2	applied	\N	\N	\N	\N	152644	152644	319962
20038	28676	3	applied	\N	\N	\N	\N	152645	152645	319963
20038	28677	4	applied	\N	\N	\N	\N	152646	152646	319964
20043	28684	0	applied	\N	\N	\N	\N	152656	152656	319974
20043	28685	1	applied	\N	\N	\N	\N	152657	152657	319975
20043	28686	2	applied	\N	\N	\N	\N	152658	152658	319976
20043	28687	3	applied	\N	\N	\N	\N	152659	152659	319977
20052	28702	0	applied	\N	\N	\N	\N	152688	152688	320006
20052	28703	1	applied	\N	\N	\N	\N	152689	152689	320007
20052	28704	2	applied	\N	\N	\N	\N	152690	152690	320008
20052	28705	3	applied	\N	\N	\N	\N	152691	152691	320009
20052	28707	5	applied	\N	\N	\N	\N	152693	152693	320011
20052	28708	6	applied	\N	\N	\N	\N	152694	152694	320012
20052	28709	7	applied	\N	\N	\N	\N	152695	152695	320013
20052	28710	8	applied	\N	\N	\N	\N	152696	152696	320014
19960	28497	1	applied	\N	\N	\N	\N	152176	152176	319494
19960	28498	2	applied	\N	\N	\N	\N	152177	152177	319495
19976	28528	6	applied	\N	\N	\N	\N	152265	152265	319583
19978	28532	3	applied	\N	\N	\N	\N	152269	152269	319587
19978	28533	4	applied	\N	\N	\N	\N	152270	152270	319588
19978	28534	5	applied	\N	\N	\N	\N	152271	152271	319589
19978	28535	6	applied	\N	\N	\N	\N	152272	152272	319590
19978	28536	7	applied	\N	\N	\N	\N	152273	152273	319591
19978	28537	8	applied	\N	\N	\N	\N	152274	152274	319592
19982	28550	0	applied	\N	\N	\N	\N	152296	152296	319614
19982	28551	1	applied	\N	\N	\N	\N	152297	152297	319615
19982	28552	2	applied	\N	\N	\N	\N	152298	152298	319616
19984	28553	0	applied	\N	\N	\N	\N	152302	152302	319620
19984	28550	1	applied	\N	\N	\N	\N	152303	152303	319621
19984	28551	2	applied	\N	\N	\N	\N	152304	152304	319622
19984	28552	3	applied	\N	\N	\N	\N	152305	152305	319623
19985	28555	1	applied	\N	\N	\N	\N	152307	152307	319625
19985	28556	2	applied	\N	\N	\N	\N	152308	152308	319626
19986	28554	0	applied	\N	\N	\N	\N	152309	152309	319627
19986	28555	1	applied	\N	\N	\N	\N	152310	152310	319628
19986	28556	2	applied	\N	\N	\N	\N	152311	152311	319629
19988	28557	0	applied	\N	\N	\N	\N	152317	152317	319635
19988	28558	1	applied	\N	\N	\N	\N	152318	152318	319636
19988	28559	2	applied	\N	\N	\N	\N	152319	152319	319637
19988	28560	3	applied	\N	\N	\N	\N	152320	152320	319638
19988	28561	4	applied	\N	\N	\N	\N	152321	152321	319639
19992	28565	0	applied	\N	\N	\N	\N	152342	152342	319660
19992	28566	1	applied	\N	\N	\N	\N	152343	152343	319661
19992	28567	2	applied	\N	\N	\N	\N	152344	152344	319662
19992	28568	3	applied	\N	\N	\N	\N	152345	152345	319663
19992	28569	4	applied	\N	\N	\N	\N	152346	152346	319664
19992	28570	5	applied	\N	\N	\N	\N	152347	152347	319665
19992	28575	7	applied	\N	\N	\N	\N	152349	152349	319667
19992	28576	8	applied	\N	\N	\N	\N	152350	152350	319668
19994	28577	0	applied	\N	\N	\N	\N	152354	152354	319672
19994	28578	1	applied	\N	\N	\N	\N	152355	152355	319673
19994	28579	2	applied	\N	\N	\N	\N	152356	152356	319674
19997	28580	0	applied	\N	\N	\N	\N	152363	152363	319681
19997	28581	1	applied	\N	\N	\N	\N	152364	152364	319682
19997	28582	2	applied	\N	\N	\N	\N	152365	152365	319683
19997	28583	3	applied	\N	\N	\N	\N	152366	152366	319684
19997	28584	4	applied	\N	\N	\N	\N	152367	152367	319685
19999	28585	0	applied	\N	\N	\N	\N	152373	152373	319691
19999	28586	1	applied	\N	\N	\N	\N	152374	152374	319692
19999	28587	2	applied	\N	\N	\N	\N	152375	152375	319693
19999	28588	3	applied	\N	\N	\N	\N	152376	152376	319694
19999	28589	4	applied	\N	\N	\N	\N	152377	152377	319695
20003	28590	0	applied	\N	\N	\N	\N	152500	152500	319818
20003	28592	2	applied	\N	\N	\N	\N	152502	152502	319820
20003	28593	3	applied	\N	\N	\N	\N	152503	152503	319821
20003	28594	4	applied	\N	\N	\N	\N	152504	152504	319822
20005	28595	0	applied	\N	\N	\N	\N	152510	152510	319828
20005	28596	1	applied	\N	\N	\N	\N	152511	152511	319829
20005	28597	2	applied	\N	\N	\N	\N	152512	152512	319830
20005	28598	3	applied	\N	\N	\N	\N	152513	152513	319831
20005	28599	4	applied	\N	\N	\N	\N	152514	152514	319832
20008	28595	0	applied	\N	\N	\N	\N	152524	152524	319842
20008	28596	1	applied	\N	\N	\N	\N	152525	152525	319843
20008	28597	2	applied	\N	\N	\N	\N	152526	152526	319844
20008	28598	3	applied	\N	\N	\N	\N	152527	152527	319845
20008	28599	4	applied	\N	\N	\N	\N	152528	152528	319846
20010	28610	0	applied	\N	\N	\N	\N	152540	152540	319858
20010	28611	1	applied	\N	\N	\N	\N	152541	152541	319859
20010	28612	2	applied	\N	\N	\N	\N	152542	152542	319860
20010	28614	4	applied	\N	\N	\N	\N	152544	152544	319862
20010	28615	5	applied	\N	\N	\N	\N	152545	152545	319863
20013	28616	0	applied	\N	\N	\N	\N	152552	152552	319870
20013	28617	1	applied	\N	\N	\N	\N	152553	152553	319871
20013	28618	2	applied	\N	\N	\N	\N	152554	152554	319872
20016	28616	0	applied	\N	\N	\N	\N	152561	152561	319879
20016	28617	1	applied	\N	\N	\N	\N	152562	152562	319880
20016	28618	2	applied	\N	\N	\N	\N	152563	152563	319881
20021	28627	0	applied	\N	\N	\N	\N	152580	152580	319898
20021	28628	1	applied	\N	\N	1000000000	\N	152581	152581	319899
20021	28629	2	applied	\N	\N	\N	\N	152582	152582	319900
20021	28630	3	applied	\N	\N	\N	\N	152583	152583	319901
20024	28650	0	applied	\N	\N	\N	\N	152603	152603	319921
20024	28651	1	applied	\N	\N	\N	\N	152604	152604	319922
20024	28652	2	applied	\N	\N	\N	\N	152605	152605	319923
20024	28653	3	applied	\N	\N	\N	\N	152606	152606	319924
20027	28655	1	applied	\N	\N	\N	\N	152613	152613	319931
20027	28656	2	applied	\N	\N	\N	\N	152614	152614	319932
20027	28657	3	applied	\N	\N	\N	\N	152615	152615	319933
20027	28658	4	applied	\N	\N	\N	\N	152616	152616	319934
20033	28667	0	applied	\N	\N	\N	\N	152625	152625	319943
20033	28668	1	applied	\N	\N	\N	\N	152626	152626	319944
20033	28669	2	applied	\N	\N	\N	\N	152627	152627	319945
20041	28678	0	applied	\N	\N	\N	\N	152650	152650	319968
20041	28679	1	applied	\N	\N	\N	\N	152651	152651	319969
20041	28680	2	applied	\N	\N	\N	\N	152652	152652	319970
20042	28681	0	applied	\N	\N	\N	\N	152653	152653	319971
20042	28682	1	applied	\N	\N	\N	\N	152654	152654	319972
20042	28683	2	applied	\N	\N	\N	\N	152655	152655	319973
20050	28695	0	applied	\N	\N	\N	\N	152681	152681	319999
20050	28696	1	applied	\N	\N	\N	\N	152682	152682	320000
20050	28697	2	applied	\N	\N	\N	\N	152683	152683	320001
20054	28737	1	applied	\N	\N	\N	\N	152723	152723	320041
20054	28738	2	applied	\N	\N	\N	\N	152724	152724	320042
20054	28739	3	applied	\N	\N	\N	\N	152725	152725	320043
20059	28743	0	applied	\N	\N	\N	\N	152788	152788	320106
20059	28744	1	applied	\N	\N	\N	\N	152789	152789	320107
20059	28745	2	applied	\N	\N	\N	\N	152790	152790	320108
20063	28775	0	applied	\N	\N	\N	\N	152823	152823	320141
20063	28776	1	applied	\N	\N	\N	\N	152824	152824	320142
20063	28777	2	applied	\N	\N	\N	\N	152825	152825	320143
20070	28778	0	applied	\N	\N	\N	\N	152935	152935	320253
20070	28779	1	applied	\N	\N	\N	\N	152936	152936	320254
20070	28780	2	applied	\N	\N	\N	\N	152937	152937	320255
20070	28781	3	applied	\N	\N	\N	\N	152938	152938	320256
20072	28782	0	applied	\N	\N	\N	\N	152943	152943	320261
20072	28783	1	applied	\N	\N	\N	\N	152944	152944	320262
20072	28784	2	applied	\N	\N	\N	\N	152945	152945	320263
19976	28527	5	applied	\N	\N	\N	\N	152264	152264	319582
19996	28577	0	applied	\N	\N	\N	\N	152360	152360	319678
19996	28578	1	applied	\N	\N	\N	\N	152361	152361	319679
19996	28579	2	applied	\N	\N	\N	\N	152362	152362	319680
19998	28580	0	applied	\N	\N	\N	\N	152368	152368	319686
19998	28581	1	applied	\N	\N	\N	\N	152369	152369	319687
19998	28582	2	applied	\N	\N	\N	\N	152370	152370	319688
19998	28583	3	applied	\N	\N	\N	\N	152371	152371	319689
19998	28584	4	applied	\N	\N	\N	\N	152372	152372	319690
20000	28565	0	applied	\N	\N	\N	\N	152378	152378	319696
20000	28580	1	applied	\N	\N	\N	\N	152379	152379	319697
20000	28581	2	applied	\N	\N	\N	\N	152380	152380	319698
20000	28473	3	applied	\N	\N	\N	\N	152381	152381	319699
20000	28558	5	applied	\N	\N	\N	\N	152383	152383	319701
20000	28474	6	applied	\N	\N	\N	\N	152384	152384	319702
20000	28475	7	applied	\N	\N	\N	\N	152385	152385	319703
20000	28476	8	applied	\N	\N	\N	\N	152386	152386	319704
20000	28486	9	applied	\N	\N	\N	\N	152387	152387	319705
20000	28489	10	applied	\N	\N	\N	\N	152388	152388	319706
20006	28595	0	applied	\N	\N	\N	\N	152515	152515	319833
20006	28596	1	applied	\N	\N	\N	\N	152516	152516	319834
20006	28597	2	applied	\N	\N	\N	\N	152517	152517	319835
20006	28598	3	applied	\N	\N	\N	\N	152518	152518	319836
20006	28599	4	applied	\N	\N	\N	\N	152519	152519	319837
20011	28616	0	applied	\N	\N	\N	\N	152546	152546	319864
20011	28617	1	applied	\N	\N	\N	\N	152547	152547	319865
20011	28618	2	applied	\N	\N	\N	\N	152548	152548	319866
20015	28616	0	applied	\N	\N	\N	\N	152558	152558	319876
20015	28617	1	applied	\N	\N	\N	\N	152559	152559	319877
20015	28618	2	applied	\N	\N	\N	\N	152560	152560	319878
20018	28619	0	applied	\N	\N	\N	\N	152568	152568	319886
20018	28621	2	applied	\N	\N	\N	\N	152570	152570	319888
20018	28622	3	applied	\N	\N	\N	\N	152571	152571	319889
20020	28623	0	applied	\N	\N	\N	\N	152576	152576	319894
20020	28624	1	applied	\N	\N	1000000000	\N	152577	152577	319895
20020	28625	2	applied	\N	\N	\N	\N	152578	152578	319896
20020	28626	3	applied	\N	\N	\N	\N	152579	152579	319897
20026	28654	0	applied	\N	\N	\N	\N	152607	152607	319925
20026	28655	1	applied	\N	\N	\N	\N	152608	152608	319926
20026	28656	2	applied	\N	\N	\N	\N	152609	152609	319927
20026	28657	3	applied	\N	\N	\N	\N	152610	152610	319928
20026	28658	4	applied	\N	\N	\N	\N	152611	152611	319929
20032	28663	0	applied	\N	\N	\N	\N	152621	152621	319939
20032	28664	1	applied	\N	\N	\N	\N	152622	152622	319940
20032	28665	2	applied	\N	\N	\N	\N	152623	152623	319941
20032	28666	3	applied	\N	\N	\N	\N	152624	152624	319942
20035	28670	0	applied	\N	\N	\N	\N	152631	152631	319949
20035	28672	2	applied	\N	\N	\N	\N	152633	152633	319951
20044	28684	0	applied	\N	\N	\N	\N	152660	152660	319978
20044	28685	1	applied	\N	\N	\N	\N	152661	152661	319979
20044	28686	2	applied	\N	\N	\N	\N	152662	152662	319980
20044	28687	3	applied	\N	\N	\N	\N	152663	152663	319981
20046	28688	0	applied	\N	\N	\N	\N	152668	152668	319986
20046	28689	1	applied	\N	\N	\N	\N	152669	152669	319987
20046	28690	2	applied	\N	\N	\N	\N	152670	152670	319988
20046	28691	3	applied	\N	\N	\N	\N	152671	152671	319989
20046	28692	4	applied	\N	\N	\N	\N	152672	152672	319990
20046	28693	5	applied	\N	\N	\N	\N	152673	152673	319991
20046	28694	6	applied	\N	\N	\N	\N	152674	152674	319992
20048	28695	0	applied	\N	\N	\N	\N	152675	152675	319993
20048	28696	1	applied	\N	\N	\N	\N	152676	152676	319994
20048	28697	2	applied	\N	\N	\N	\N	152677	152677	319995
20053	28733	0	applied	\N	\N	\N	\N	152719	152719	320037
20053	28735	2	applied	\N	\N	\N	\N	152721	152721	320039
20065	28775	0	applied	\N	\N	\N	\N	152829	152829	320147
20065	28776	1	applied	\N	\N	\N	\N	152830	152830	320148
20067	28673	0	applied	\N	\N	\N	\N	152834	152834	320152
20067	28675	1	applied	\N	\N	\N	\N	152835	152835	320153
20067	28659	2	applied	\N	\N	\N	\N	152836	152836	320154
20067	28703	3	applied	\N	\N	\N	\N	152837	152837	320155
20067	28704	4	applied	\N	\N	\N	\N	152838	152838	320156
20067	28705	5	applied	\N	\N	\N	\N	152839	152839	320157
20067	28706	6	applied	\N	\N	\N	\N	152840	152840	320158
20067	28707	7	applied	\N	\N	\N	\N	152841	152841	320159
20067	28708	8	applied	\N	\N	\N	\N	152842	152842	320160
20067	28709	9	applied	\N	\N	\N	\N	152843	152843	320161
20067	28710	10	applied	\N	\N	\N	\N	152844	152844	320162
20067	28711	11	applied	\N	\N	\N	\N	152845	152845	320163
20067	28712	12	applied	\N	\N	\N	\N	152846	152846	320164
20067	28714	14	applied	\N	\N	\N	\N	152848	152848	320166
20067	28715	15	applied	\N	\N	\N	\N	152849	152849	320167
20067	28716	16	applied	\N	\N	\N	\N	152850	152850	320168
20067	28717	17	applied	\N	\N	\N	\N	152851	152851	320169
20067	28718	18	applied	\N	\N	\N	\N	152852	152852	320170
20067	28719	19	applied	\N	\N	\N	\N	152853	152853	320171
20067	28720	20	applied	\N	\N	\N	\N	152854	152854	320172
20067	28721	21	applied	\N	\N	\N	\N	152855	152855	320173
20067	28722	22	applied	\N	\N	\N	\N	152856	152856	320174
20067	28723	23	applied	\N	\N	\N	\N	152857	152857	320175
20067	28724	24	applied	\N	\N	\N	\N	152858	152858	320176
20067	28725	25	applied	\N	\N	\N	\N	152859	152859	320177
20067	28726	26	applied	\N	\N	\N	\N	152860	152860	320178
20067	28727	27	applied	\N	\N	\N	\N	152861	152861	320179
20067	28728	28	applied	\N	\N	\N	\N	152862	152862	320180
20067	28729	29	applied	\N	\N	\N	\N	152863	152863	320181
20067	28660	31	applied	\N	\N	\N	\N	152865	152865	320183
20067	28763	32	applied	\N	\N	\N	\N	152866	152866	320184
20067	28766	33	applied	\N	\N	\N	\N	152867	152867	320185
20067	28767	34	applied	\N	\N	\N	\N	152868	152868	320186
20067	28686	35	applied	\N	\N	\N	\N	152869	152869	320187
20067	28741	36	applied	\N	\N	\N	\N	152870	152870	320188
20067	28757	37	applied	\N	\N	\N	\N	152871	152871	320189
20067	28769	38	applied	\N	\N	\N	\N	152872	152872	320190
20067	28665	39	applied	\N	\N	\N	\N	152873	152873	320191
20067	28668	40	applied	\N	\N	\N	\N	152874	152874	320192
20067	28671	41	applied	\N	\N	\N	\N	152875	152875	320193
20067	28676	42	applied	\N	\N	\N	\N	152876	152876	320194
20067	28679	43	applied	\N	\N	\N	\N	152877	152877	320195
20067	28682	44	applied	\N	\N	\N	\N	152878	152878	320196
20067	28661	45	applied	\N	\N	\N	\N	152879	152879	320197
19993	28577	0	applied	\N	\N	\N	\N	152351	152351	319669
19993	28579	2	applied	\N	\N	\N	\N	152353	152353	319671
20000	28506	15	applied	\N	\N	\N	\N	152393	152393	319711
20000	28507	16	applied	\N	\N	\N	\N	152394	152394	319712
20000	28512	17	applied	\N	\N	\N	\N	152395	152395	319713
20000	28513	18	applied	\N	\N	\N	\N	152396	152396	319714
20000	28519	19	applied	\N	\N	\N	\N	152397	152397	319715
20000	28522	20	applied	\N	\N	\N	\N	152398	152398	319716
20000	28523	21	applied	\N	\N	\N	\N	152399	152399	319717
20000	28529	22	applied	\N	\N	\N	\N	152400	152400	319718
20000	28530	23	applied	\N	\N	\N	\N	152401	152401	319719
20000	28531	24	applied	\N	\N	\N	\N	152402	152402	319720
20000	28538	25	applied	\N	\N	\N	\N	152403	152403	319721
20000	28539	26	applied	\N	\N	\N	\N	152404	152404	319722
20000	28544	27	applied	\N	\N	\N	\N	152405	152405	319723
20000	28553	28	applied	\N	\N	\N	\N	152406	152406	319724
20000	28557	29	applied	\N	\N	\N	\N	152407	152407	319725
20000	28562	30	applied	\N	\N	\N	\N	152408	152408	319726
20000	28567	32	applied	\N	\N	\N	\N	152410	152410	319728
20000	28568	33	applied	\N	\N	\N	\N	152411	152411	319729
20000	28577	34	applied	\N	\N	\N	\N	152412	152412	319730
20000	28582	35	applied	\N	\N	\N	\N	152413	152413	319731
20000	28586	36	applied	\N	\N	\N	\N	152414	152414	319732
20000	28551	37	applied	\N	\N	\N	\N	152415	152415	319733
20000	28477	38	applied	\N	\N	\N	\N	152416	152416	319734
20000	28547	39	applied	\N	\N	\N	\N	152417	152417	319735
20000	28478	40	applied	\N	\N	\N	\N	152418	152418	319736
20000	28479	41	applied	\N	\N	\N	\N	152419	152419	319737
20000	28480	42	applied	\N	\N	\N	\N	152420	152420	319738
20000	28481	43	applied	\N	\N	\N	\N	152421	152421	319739
20000	28487	44	applied	\N	\N	\N	\N	152422	152422	319740
20000	28490	45	applied	\N	\N	\N	\N	152423	152423	319741
20000	28494	46	applied	\N	\N	\N	\N	152424	152424	319742
20000	28482	47	applied	\N	\N	\N	\N	152425	152425	319743
20000	28484	49	applied	\N	\N	\N	\N	152427	152427	319745
20000	28485	50	applied	\N	\N	\N	\N	152428	152428	319746
20000	28491	51	applied	\N	\N	\N	\N	152429	152429	319747
20000	28505	52	applied	\N	\N	\N	\N	152430	152430	319748
20000	28514	53	applied	\N	\N	\N	\N	152431	152431	319749
20000	28525	54	applied	\N	\N	\N	\N	152432	152432	319750
20000	28532	55	applied	\N	\N	\N	\N	152433	152433	319751
20000	28548	56	applied	\N	\N	\N	\N	152434	152434	319752
20000	28488	57	applied	\N	\N	\N	\N	152435	152435	319753
20000	28492	58	applied	\N	\N	\N	\N	152436	152436	319754
20000	28495	59	applied	\N	\N	\N	\N	152437	152437	319755
20000	28497	60	applied	\N	\N	\N	\N	152438	152438	319756
20000	28501	61	applied	\N	\N	\N	\N	152439	152439	319757
20000	28504	62	applied	\N	\N	\N	\N	152440	152440	319758
20000	28508	63	applied	\N	\N	\N	\N	152441	152441	319759
20000	28509	64	applied	\N	\N	\N	\N	152442	152442	319760
20000	28517	66	applied	\N	\N	\N	\N	152444	152444	319762
20000	28521	67	applied	\N	\N	\N	\N	152445	152445	319763
20000	28524	68	applied	\N	\N	\N	\N	152446	152446	319764
20000	28528	69	applied	\N	\N	\N	\N	152447	152447	319765
20000	28535	70	applied	\N	\N	\N	\N	152448	152448	319766
20000	28536	71	applied	\N	\N	\N	\N	152449	152449	319767
20000	28537	72	applied	\N	\N	\N	\N	152450	152450	319768
20000	28540	73	applied	\N	\N	\N	\N	152451	152451	319769
20000	28543	74	applied	\N	\N	\N	\N	152452	152452	319770
20000	28549	75	applied	\N	\N	\N	\N	152453	152453	319771
20000	28552	76	applied	\N	\N	\N	\N	152454	152454	319772
20000	28554	77	applied	\N	\N	\N	\N	152455	152455	319773
20000	28559	79	applied	\N	\N	\N	\N	152456	152456	319774
20000	28563	80	applied	\N	\N	\N	\N	152457	152457	319775
20000	28572	81	applied	\N	\N	\N	\N	152458	152458	319776
20000	28573	82	applied	\N	\N	\N	\N	152459	152459	319777
20000	28579	84	applied	\N	\N	\N	\N	152461	152461	319779
20000	28584	85	applied	\N	\N	\N	\N	152462	152462	319780
20000	28588	86	applied	\N	\N	\N	\N	152463	152463	319781
20000	28561	87	applied	\N	\N	\N	\N	152464	152464	319782
20000	28569	88	applied	\N	\N	\N	\N	152465	152465	319783
20000	28498	89	applied	\N	\N	\N	\N	152466	152466	319784
20000	28500	90	applied	\N	\N	\N	\N	152467	152467	319785
20000	28503	91	applied	\N	\N	\N	\N	152468	152468	319786
20000	28510	92	applied	\N	\N	\N	\N	152469	152469	319787
20000	28511	93	applied	\N	\N	\N	\N	152470	152470	319788
20000	28515	94	applied	\N	\N	\N	\N	152471	152471	319789
20000	28518	95	applied	\N	\N	\N	\N	152472	152472	319790
20000	28520	96	applied	\N	\N	\N	\N	152473	152473	319791
20000	28526	97	applied	\N	\N	\N	\N	152474	152474	319792
20000	28527	98	applied	\N	\N	\N	\N	152475	152475	319793
20000	28533	99	applied	\N	\N	\N	\N	152476	152476	319794
20000	28541	101	applied	\N	\N	\N	\N	152478	152478	319796
20000	28542	102	applied	\N	\N	\N	\N	152479	152479	319797
20000	28546	103	applied	\N	\N	\N	\N	152480	152480	319798
20000	28550	104	applied	\N	\N	\N	\N	152481	152481	319799
20000	28556	105	applied	\N	\N	\N	\N	152482	152482	319800
20000	28560	106	applied	\N	\N	\N	\N	152483	152483	319801
20000	28564	107	applied	\N	\N	\N	\N	152484	152484	319802
20000	28571	108	applied	\N	\N	\N	\N	152485	152485	319803
20000	28575	109	applied	\N	\N	\N	\N	152486	152486	319804
20000	28576	110	applied	\N	\N	\N	\N	152487	152487	319805
20000	28578	111	applied	\N	\N	\N	\N	152488	152488	319806
20000	28583	112	applied	\N	\N	\N	\N	152489	152489	319807
20002	28590	0	applied	\N	\N	\N	\N	152495	152495	319813
20002	28591	1	applied	\N	\N	\N	\N	152496	152496	319814
20002	28592	2	applied	\N	\N	\N	\N	152497	152497	319815
20002	28593	3	applied	\N	\N	\N	\N	152498	152498	319816
20004	28595	0	applied	\N	\N	\N	\N	152505	152505	319823
20004	28596	1	applied	\N	\N	\N	\N	152506	152506	319824
20004	28597	2	applied	\N	\N	\N	\N	152507	152507	319825
20004	28598	3	applied	\N	\N	\N	\N	152508	152508	319826
20004	28599	4	applied	\N	\N	\N	\N	152509	152509	319827
20007	28595	0	applied	\N	\N	\N	\N	152520	152520	319838
20007	28596	1	applied	\N	\N	\N	\N	152521	152521	319839
20007	28598	2	applied	\N	\N	\N	\N	152522	152522	319840
20007	28599	3	applied	\N	\N	\N	\N	152523	152523	319841
20009	28600	0	applied	\N	\N	\N	\N	152529	152529	319847
20009	28597	1	applied	\N	\N	\N	\N	152530	152530	319848
20009	28601	2	applied	\N	\N	\N	\N	152531	152531	319849
20009	28602	3	applied	\N	\N	\N	\N	152532	152532	319850
20009	28603	4	applied	\N	\N	\N	\N	152533	152533	319851
20000	28496	12	applied	\N	\N	\N	\N	152390	152390	319708
20000	28499	13	applied	\N	\N	\N	\N	152391	152391	319709
20009	28608	9	applied	\N	\N	\N	\N	152538	152538	319856
20009	28609	10	applied	\N	\N	\N	\N	152539	152539	319857
20012	28616	0	applied	\N	\N	\N	\N	152549	152549	319867
20012	28617	1	applied	\N	\N	\N	\N	152550	152550	319868
20012	28618	2	applied	\N	\N	\N	\N	152551	152551	319869
20023	28641	0	applied	\N	\N	\N	\N	152594	152594	319912
20023	28642	1	applied	\N	\N	\N	\N	152595	152595	319913
20023	28643	2	applied	\N	\N	\N	\N	152596	152596	319914
20023	28644	3	applied	\N	\N	\N	\N	152597	152597	319915
20023	28645	4	applied	\N	\N	\N	\N	152598	152598	319916
20023	28646	5	applied	\N	\N	\N	\N	152599	152599	319917
20023	28647	6	applied	\N	\N	\N	\N	152600	152600	319918
20023	28648	7	applied	\N	\N	\N	\N	152601	152601	319919
20023	28649	8	applied	\N	\N	\N	\N	152602	152602	319920
20036	28671	1	applied	\N	\N	\N	\N	152635	152635	319953
20036	28672	2	applied	\N	\N	\N	\N	152636	152636	319954
20037	28673	0	applied	\N	\N	\N	\N	152637	152637	319955
20037	28674	1	applied	\N	\N	\N	\N	152638	152638	319956
20037	28675	2	applied	\N	\N	\N	\N	152639	152639	319957
20037	28676	3	applied	\N	\N	\N	\N	152640	152640	319958
20037	28677	4	applied	\N	\N	\N	\N	152641	152641	319959
20040	28678	0	applied	\N	\N	\N	\N	152647	152647	319965
20040	28679	1	applied	\N	\N	\N	\N	152648	152648	319966
20040	28680	2	applied	\N	\N	\N	\N	152649	152649	319967
20045	28684	0	applied	\N	\N	\N	\N	152664	152664	319982
20045	28685	1	applied	\N	\N	\N	\N	152665	152665	319983
20045	28686	2	applied	\N	\N	\N	\N	152666	152666	319984
20045	28687	3	applied	\N	\N	\N	\N	152667	152667	319985
20049	28695	0	applied	\N	\N	\N	\N	152678	152678	319996
20049	28696	1	applied	\N	\N	\N	\N	152679	152679	319997
20051	28698	0	applied	\N	\N	\N	\N	152684	152684	320002
20051	28699	1	applied	\N	\N	\N	\N	152685	152685	320003
20051	28700	2	applied	\N	\N	\N	\N	152686	152686	320004
20051	28701	3	applied	\N	\N	\N	\N	152687	152687	320005
20052	28711	9	applied	\N	\N	\N	\N	152697	152697	320015
20052	28712	10	applied	\N	\N	\N	\N	152698	152698	320016
20052	28713	11	applied	\N	\N	\N	\N	152699	152699	320017
20052	28714	12	applied	\N	\N	\N	\N	152700	152700	320018
20052	28715	13	applied	\N	\N	\N	\N	152701	152701	320019
20052	28716	15	applied	\N	\N	\N	\N	152702	152702	320020
20052	28717	16	applied	\N	\N	\N	\N	152703	152703	320021
20052	28718	17	applied	\N	\N	\N	\N	152704	152704	320022
20052	28719	18	applied	\N	\N	\N	\N	152705	152705	320023
20052	28720	19	applied	\N	\N	\N	\N	152706	152706	320024
20052	28721	20	applied	\N	\N	\N	\N	152707	152707	320025
20052	28722	21	applied	\N	\N	\N	\N	152708	152708	320026
20052	28724	23	applied	\N	\N	\N	\N	152710	152710	320028
20052	28725	24	applied	\N	\N	\N	\N	152711	152711	320029
20052	28726	25	applied	\N	\N	\N	\N	152712	152712	320030
20052	28727	26	applied	\N	\N	\N	\N	152713	152713	320031
20052	28728	27	applied	\N	\N	\N	\N	152714	152714	320032
20052	28729	28	applied	\N	\N	\N	\N	152715	152715	320033
20052	28730	29	applied	\N	\N	\N	\N	152716	152716	320034
20052	28731	30	applied	\N	\N	\N	\N	152717	152717	320035
20052	28732	31	applied	\N	\N	\N	\N	152718	152718	320036
20055	28703	0	applied	\N	\N	\N	\N	152726	152726	320044
20056	28740	0	applied	\N	\N	\N	\N	152754	152754	320072
20056	28741	1	applied	\N	\N	\N	\N	152755	152755	320073
20056	28742	2	applied	\N	\N	\N	\N	152756	152756	320074
20058	28743	0	applied	\N	\N	\N	\N	152785	152785	320103
20058	28744	1	applied	\N	\N	\N	\N	152786	152786	320104
20058	28745	2	applied	\N	\N	\N	\N	152787	152787	320105
20062	28776	1	applied	\N	\N	\N	\N	152821	152821	320139
20062	28777	2	applied	\N	\N	\N	\N	152822	152822	320140
20066	28775	0	applied	\N	\N	\N	\N	152831	152831	320149
20066	28776	1	applied	\N	\N	\N	\N	152832	152832	320150
20066	28777	2	applied	\N	\N	\N	\N	152833	152833	320151
20068	28775	0	applied	\N	\N	\N	\N	152929	152929	320247
20068	28777	1	applied	\N	\N	\N	\N	152930	152930	320248
20069	28778	0	applied	\N	\N	\N	\N	152931	152931	320249
20069	28779	1	applied	\N	\N	\N	\N	152932	152932	320250
20069	28780	2	applied	\N	\N	\N	\N	152933	152933	320251
20069	28781	3	applied	\N	\N	\N	\N	152934	152934	320252
20071	28782	0	applied	\N	\N	\N	\N	152939	152939	320257
20071	28783	1	applied	\N	\N	\N	\N	152940	152940	320258
20071	28784	2	applied	\N	\N	\N	\N	152941	152941	320259
20071	28785	3	applied	\N	\N	\N	\N	152942	152942	320260
20078	28792	0	applied	\N	\N	\N	\N	152964	152964	320282
20078	28794	2	applied	\N	\N	\N	\N	152966	152966	320284
20081	28800	0	applied	\N	\N	\N	\N	152979	152979	320297
20081	28801	1	applied	\N	\N	\N	\N	152980	152980	320298
20081	28802	2	applied	\N	\N	\N	\N	152981	152981	320299
20081	28803	3	applied	\N	\N	\N	\N	152982	152982	320300
20081	28804	4	applied	\N	\N	\N	\N	152983	152983	320301
20081	28805	5	applied	\N	\N	\N	\N	152984	152984	320302
20081	28806	6	applied	\N	\N	\N	\N	152985	152985	320303
20083	28814	0	applied	\N	\N	\N	\N	152993	152993	152993
20083	28815	1	applied	\N	\N	1000000000	\N	152994	152994	320311
20083	28816	2	applied	\N	\N	\N	\N	152995	152995	320312
20083	28817	3	applied	\N	\N	\N	\N	152996	152996	320313
20083	28818	4	applied	\N	\N	\N	\N	152997	152997	320314
20083	28819	5	applied	\N	\N	\N	\N	152998	152998	320315
20083	28820	6	applied	\N	\N	\N	\N	152999	152999	320316
20083	28821	7	applied	\N	\N	\N	\N	153000	153000	320317
20088	28862	1	applied	\N	\N	\N	\N	153069	153069	320383
20088	28863	2	applied	\N	\N	\N	\N	153070	153070	320384
20088	28864	3	applied	\N	\N	\N	\N	153071	153071	320385
20088	28865	4	applied	\N	\N	\N	\N	153072	153072	320386
20088	28866	5	applied	\N	\N	\N	\N	153073	153073	320387
20088	28867	6	applied	\N	\N	\N	\N	153074	153074	320388
20088	28868	7	applied	\N	\N	\N	\N	153075	153075	320389
20088	28869	8	applied	\N	\N	\N	\N	153076	153076	320390
20088	28870	9	applied	\N	\N	\N	\N	153077	153077	320391
20088	28871	10	applied	\N	\N	\N	\N	153078	153078	320392
20088	28872	11	applied	\N	\N	\N	\N	153079	153079	320393
20088	28873	12	applied	\N	\N	\N	\N	153080	153080	320394
20093	28906	0	applied	\N	\N	\N	\N	153136	153136	320450
20093	28907	1	applied	\N	\N	\N	\N	153137	153137	320451
20093	28908	2	applied	\N	\N	\N	\N	153138	153138	320452
20093	28909	3	applied	\N	\N	\N	\N	153139	153139	320453
20009	28607	8	applied	\N	\N	\N	\N	152537	152537	319855
20055	28708	5	applied	\N	\N	\N	\N	152731	152731	320049
20055	28709	6	applied	\N	\N	\N	\N	152732	152732	320050
20055	28710	7	applied	\N	\N	\N	\N	152733	152733	320051
20055	28711	8	applied	\N	\N	\N	\N	152734	152734	320052
20055	28712	9	applied	\N	\N	\N	\N	152735	152735	320053
20055	28713	10	applied	\N	\N	\N	\N	152736	152736	320054
20055	28714	11	applied	\N	\N	\N	\N	152737	152737	320055
20055	28715	12	applied	\N	\N	\N	\N	152738	152738	320056
20055	28716	13	applied	\N	\N	\N	\N	152739	152739	320057
20055	28717	14	applied	\N	\N	\N	\N	152740	152740	320058
20055	28718	15	applied	\N	\N	\N	\N	152741	152741	320059
20055	28719	16	applied	\N	\N	\N	\N	152742	152742	320060
20055	28720	17	applied	\N	\N	\N	\N	152743	152743	320061
20055	28721	18	applied	\N	\N	\N	\N	152744	152744	320062
20055	28723	20	applied	\N	\N	\N	\N	152746	152746	320064
20055	28724	21	applied	\N	\N	\N	\N	152747	152747	320065
20055	28725	22	applied	\N	\N	\N	\N	152748	152748	320066
20055	28726	23	applied	\N	\N	\N	\N	152749	152749	320067
20055	28727	24	applied	\N	\N	\N	\N	152750	152750	320068
20055	28728	25	applied	\N	\N	\N	\N	152751	152751	320069
20055	28729	26	applied	\N	\N	\N	\N	152752	152752	320070
20055	28730	27	applied	\N	\N	\N	\N	152753	152753	320071
20057	28703	0	applied	\N	\N	\N	\N	152757	152757	320075
20057	28704	1	applied	\N	\N	\N	\N	152758	152758	320076
20057	28705	2	applied	\N	\N	\N	\N	152759	152759	320077
20057	28706	3	applied	\N	\N	\N	\N	152760	152760	320078
20057	28707	4	applied	\N	\N	\N	\N	152761	152761	320079
20057	28708	5	applied	\N	\N	\N	\N	152762	152762	320080
20057	28709	6	applied	\N	\N	\N	\N	152763	152763	320081
20057	28710	7	applied	\N	\N	\N	\N	152764	152764	320082
20057	28712	9	applied	\N	\N	\N	\N	152766	152766	320084
20057	28713	10	applied	\N	\N	\N	\N	152767	152767	320085
20057	28714	11	applied	\N	\N	\N	\N	152768	152768	320086
20057	28715	12	applied	\N	\N	\N	\N	152769	152769	320087
20057	28716	13	applied	\N	\N	\N	\N	152770	152770	320088
20057	28717	14	applied	\N	\N	\N	\N	152771	152771	320089
20057	28718	15	applied	\N	\N	\N	\N	152772	152772	320090
20057	28719	16	applied	\N	\N	\N	\N	152773	152773	320091
20057	28720	17	applied	\N	\N	\N	\N	152774	152774	320092
20057	28721	18	applied	\N	\N	\N	\N	152775	152775	320093
20057	28722	19	applied	\N	\N	\N	\N	152776	152776	320094
20057	28723	20	applied	\N	\N	\N	\N	152777	152777	320095
20057	28724	21	applied	\N	\N	\N	\N	152778	152778	320096
20057	28725	22	applied	\N	\N	\N	\N	152779	152779	320097
20057	28726	23	applied	\N	\N	\N	\N	152780	152780	320098
20057	28727	24	applied	\N	\N	\N	\N	152781	152781	320099
20057	28729	26	applied	\N	\N	\N	\N	152783	152783	320101
20057	28730	27	applied	\N	\N	\N	\N	152784	152784	320102
20060	28746	0	applied	\N	\N	\N	\N	152791	152791	320109
20060	28747	1	applied	\N	\N	\N	\N	152792	152792	320110
20060	28748	2	applied	\N	\N	\N	\N	152793	152793	320111
20060	28749	3	applied	\N	\N	\N	\N	152794	152794	320112
20060	28750	4	applied	\N	\N	\N	\N	152795	152795	320113
20060	28751	5	applied	\N	\N	\N	\N	152796	152796	320114
20060	28752	6	applied	\N	\N	\N	\N	152797	152797	320115
20060	28753	7	applied	\N	\N	\N	\N	152798	152798	320116
20060	28754	8	applied	\N	\N	\N	\N	152799	152799	320117
20060	28755	9	applied	\N	\N	\N	\N	152800	152800	320118
20060	28756	10	applied	\N	\N	\N	\N	152801	152801	320119
20060	28757	11	applied	\N	\N	\N	\N	152802	152802	320120
20060	28758	12	applied	\N	\N	\N	\N	152803	152803	320121
20060	28759	13	applied	\N	\N	\N	\N	152804	152804	320122
20061	28761	1	applied	\N	\N	\N	\N	152806	152806	320124
20061	28762	2	applied	\N	\N	\N	\N	152807	152807	320125
20061	28763	3	applied	\N	\N	\N	\N	152808	152808	320126
20061	28764	4	applied	\N	\N	\N	\N	152809	152809	320127
20061	28765	5	applied	\N	\N	\N	\N	152810	152810	320128
20061	28766	6	applied	\N	\N	\N	\N	152811	152811	320129
20061	28767	7	applied	\N	\N	\N	\N	152812	152812	320130
20061	28768	8	applied	\N	\N	\N	\N	152813	152813	320131
20061	28769	9	applied	\N	\N	\N	\N	152814	152814	320132
20061	28770	10	applied	\N	\N	\N	\N	152815	152815	320133
20061	28771	11	applied	\N	\N	\N	\N	152816	152816	320134
20061	28772	12	applied	\N	\N	\N	\N	152817	152817	320135
20061	28773	13	applied	\N	\N	\N	\N	152818	152818	320136
20061	28774	14	applied	\N	\N	\N	\N	152819	152819	320137
20064	28775	0	applied	\N	\N	\N	\N	152826	152826	320144
20064	28776	1	applied	\N	\N	\N	\N	152827	152827	320145
20067	28664	46	applied	\N	\N	\N	\N	152880	152880	320198
20067	28669	47	applied	\N	\N	\N	\N	152881	152881	320199
20067	28662	48	applied	\N	\N	1000000000	\N	152882	152882	320200
20067	28773	49	applied	\N	\N	\N	\N	152883	152883	320201
20067	28666	50	applied	\N	\N	\N	\N	152884	152884	320202
20067	28677	51	applied	\N	\N	\N	\N	152885	152885	320203
20067	28774	52	applied	\N	\N	\N	\N	152886	152886	320204
20067	28672	53	applied	\N	\N	\N	\N	152887	152887	320205
20067	28680	54	applied	\N	\N	\N	\N	152888	152888	320206
20067	28687	55	applied	\N	\N	\N	\N	152889	152889	320207
20067	28690	56	applied	\N	\N	\N	\N	152890	152890	320208
20067	28691	57	applied	\N	\N	\N	\N	152891	152891	320209
20067	28697	58	applied	\N	\N	\N	\N	152892	152892	320210
20067	28700	59	applied	\N	\N	\N	\N	152893	152893	320211
20067	28732	60	applied	\N	\N	\N	\N	152894	152894	320212
20067	28735	61	applied	\N	\N	\N	\N	152895	152895	320213
20067	28742	63	applied	\N	\N	\N	\N	152897	152897	320215
20067	28744	64	applied	\N	\N	\N	\N	152898	152898	320216
20067	28750	65	applied	\N	\N	\N	\N	152899	152899	320217
20067	28755	66	applied	\N	\N	\N	\N	152900	152900	320218
20067	28756	67	applied	\N	\N	\N	\N	152901	152901	320219
20067	28758	68	applied	\N	\N	\N	\N	152902	152902	320220
20073	28782	0	applied	\N	\N	\N	\N	152947	152947	320265
20073	28783	1	applied	\N	\N	\N	\N	152948	152948	320266
20073	28784	2	applied	\N	\N	\N	\N	152949	152949	320267
20073	28785	3	applied	\N	\N	\N	\N	152950	152950	320268
20077	28789	0	applied	\N	\N	\N	\N	152961	152961	320279
20077	28790	1	applied	\N	\N	\N	\N	152962	152962	320280
20077	28791	2	applied	\N	\N	\N	\N	152963	152963	320281
20079	28795	0	applied	\N	\N	\N	\N	152967	152967	320285
20079	28796	1	applied	\N	\N	\N	\N	152968	152968	320286
20079	28797	2	applied	\N	\N	\N	\N	152969	152969	320287
20055	28707	4	applied	\N	\N	\N	\N	152730	152730	320048
20067	28777	72	applied	\N	\N	\N	\N	152906	152906	320224
20067	28683	73	applied	\N	\N	\N	\N	152907	152907	320225
20067	28685	74	applied	\N	\N	\N	\N	152908	152908	320226
20067	28692	75	applied	\N	\N	\N	\N	152909	152909	320227
20067	28693	76	applied	\N	\N	\N	\N	152910	152910	320228
20067	28696	77	applied	\N	\N	\N	\N	152911	152911	320229
20067	28699	78	applied	\N	\N	\N	\N	152912	152912	320230
20067	28731	80	applied	\N	\N	\N	\N	152913	152913	320231
20067	28734	81	applied	\N	\N	\N	\N	152914	152914	320232
20067	28738	82	applied	\N	\N	\N	\N	152915	152915	320233
20067	28745	83	applied	\N	\N	\N	\N	152916	152916	320234
20067	28752	85	applied	\N	\N	\N	\N	152918	152918	320236
20067	28753	86	applied	\N	\N	\N	\N	152919	152919	320237
20067	28754	87	applied	\N	\N	\N	\N	152920	152920	320238
20067	28764	88	applied	\N	\N	\N	\N	152921	152921	320239
20067	28765	89	applied	\N	\N	\N	\N	152922	152922	320240
20067	28768	90	applied	\N	\N	\N	\N	152923	152923	320241
20067	28776	91	applied	\N	\N	\N	\N	152924	152924	320242
20067	28694	92	applied	\N	\N	\N	\N	152925	152925	320243
20067	28701	93	applied	\N	\N	\N	\N	152926	152926	320244
20067	28737	94	applied	\N	\N	\N	\N	152927	152927	320245
20067	28759	95	applied	\N	\N	\N	\N	152928	152928	320246
20072	28785	3	applied	\N	\N	\N	\N	152946	152946	320264
20074	28782	0	applied	\N	\N	\N	\N	152951	152951	320269
20074	28783	1	applied	\N	\N	\N	\N	152952	152952	320270
20074	28784	2	applied	\N	\N	\N	\N	152953	152953	320271
20074	28785	3	applied	\N	\N	\N	\N	152954	152954	320272
20075	28787	1	applied	\N	\N	\N	\N	152956	152956	320274
20075	28788	2	applied	\N	\N	\N	\N	152957	152957	320275
20076	28789	0	applied	\N	\N	\N	\N	152958	152958	320276
20076	28790	1	applied	\N	\N	\N	\N	152959	152959	320277
20076	28791	2	applied	\N	\N	\N	\N	152960	152960	320278
20080	28800	0	applied	\N	\N	\N	\N	152972	152972	320290
20080	28801	1	applied	\N	\N	\N	\N	152973	152973	320291
20080	28802	2	applied	\N	\N	\N	\N	152974	152974	320292
20080	28803	3	applied	\N	\N	\N	\N	152975	152975	320293
20080	28804	4	applied	\N	\N	\N	\N	152976	152976	320294
20080	28805	5	applied	\N	\N	\N	\N	152977	152977	320295
20080	28806	6	applied	\N	\N	\N	\N	152978	152978	320296
20082	28807	0	applied	\N	\N	\N	\N	152986	152986	320304
20082	28808	1	applied	\N	\N	\N	\N	152987	152987	320305
20082	28809	2	applied	\N	\N	\N	\N	152988	152988	320306
20082	28810	3	applied	\N	\N	\N	\N	152989	152989	320307
20082	28812	5	applied	\N	\N	1000000000	\N	152991	152991	320309
20082	28813	7	applied	\N	\N	\N	\N	152992	152992	320310
20084	28814	0	applied	\N	\N	\N	\N	153001	153001	153001
20084	28815	1	applied	\N	\N	1000000000	\N	153002	153002	320318
20084	28816	2	applied	\N	\N	\N	\N	153003	153003	320319
20084	28817	3	applied	\N	\N	\N	\N	153004	153004	320320
20084	28818	4	applied	\N	\N	\N	\N	153005	153005	320321
20084	28819	5	applied	\N	\N	\N	\N	153006	153006	320322
20084	28820	6	applied	\N	\N	\N	\N	153007	153007	320323
20084	28821	7	applied	\N	\N	\N	\N	153008	153008	320324
20087	28834	0	applied	\N	\N	\N	\N	153029	153029	153029
20087	28822	1	applied	\N	\N	\N	\N	153030	153030	320344
20087	28823	2	applied	\N	\N	\N	\N	153031	153031	320345
20087	28824	3	applied	\N	\N	\N	\N	153032	153032	320346
20087	28825	4	applied	\N	\N	\N	\N	153033	153033	320347
20087	28835	5	applied	\N	\N	\N	\N	153034	153034	320348
20087	28826	7	applied	\N	\N	\N	\N	153036	153036	320350
20087	28827	8	applied	\N	\N	\N	\N	153037	153037	320351
20087	28828	9	applied	\N	\N	\N	\N	153038	153038	320352
20087	28829	10	applied	\N	\N	\N	\N	153039	153039	320353
20087	28830	11	applied	\N	\N	\N	\N	153040	153040	320354
20087	28831	12	applied	\N	\N	\N	\N	153041	153041	320355
20087	28837	13	applied	\N	\N	\N	\N	153042	153042	320356
20087	28838	14	applied	\N	\N	\N	\N	153043	153043	320357
20087	28839	15	applied	\N	\N	\N	\N	153044	153044	320358
20087	28840	16	applied	\N	\N	\N	\N	153045	153045	320359
20087	28841	17	applied	\N	\N	\N	\N	153046	153046	320360
20087	28842	18	applied	\N	\N	\N	\N	153047	153047	320361
20087	28843	19	applied	\N	\N	\N	\N	153048	153048	320362
20087	28844	20	applied	\N	\N	\N	\N	153049	153049	320363
20087	28845	21	applied	\N	\N	\N	\N	153050	153050	320364
20087	28846	22	applied	\N	\N	\N	\N	153051	153051	320365
20087	28848	24	applied	\N	\N	\N	\N	153053	153053	320367
20087	28849	25	applied	\N	\N	\N	\N	153054	153054	320368
20087	28850	26	applied	\N	\N	\N	\N	153055	153055	320369
20087	28851	27	applied	\N	\N	\N	\N	153056	153056	320370
20087	28852	28	applied	\N	\N	\N	\N	153057	153057	320371
20087	28853	29	applied	\N	\N	\N	\N	153058	153058	320372
20087	28854	30	applied	\N	\N	\N	\N	153059	153059	320373
20087	28832	31	applied	\N	\N	\N	\N	153060	153060	320374
20087	28855	32	applied	\N	\N	\N	\N	153061	153061	320375
20087	28856	33	applied	\N	\N	\N	\N	153062	153062	320376
20087	28857	34	applied	\N	\N	1000000000	\N	153063	153063	320377
20087	28858	35	applied	\N	\N	\N	\N	153064	153064	320378
20087	28833	36	applied	\N	\N	\N	\N	153065	153065	320379
20087	28859	37	applied	\N	\N	\N	\N	153066	153066	320380
20087	28860	38	applied	\N	\N	\N	\N	153067	153067	320381
20090	28874	0	applied	\N	\N	\N	\N	153094	153094	320408
20090	28885	2	applied	\N	\N	\N	\N	153096	153096	320410
20090	28886	3	applied	\N	\N	\N	\N	153097	153097	320411
20091	28887	0	applied	\N	\N	\N	\N	153098	153098	320412
20091	28888	1	applied	\N	\N	\N	\N	153099	153099	320413
20091	28889	2	applied	\N	\N	\N	\N	153100	153100	320414
20091	28890	3	applied	\N	\N	\N	\N	153101	153101	320415
20091	28891	4	applied	\N	\N	\N	\N	153102	153102	320416
20091	28892	5	applied	\N	\N	\N	\N	153103	153103	320417
20091	28893	6	applied	\N	\N	\N	\N	153104	153104	320418
20091	28894	7	applied	\N	\N	\N	\N	153105	153105	320419
20091	28895	8	applied	\N	\N	\N	\N	153106	153106	320420
20091	28896	9	applied	\N	\N	\N	\N	153107	153107	320421
20091	28897	10	applied	\N	\N	\N	\N	153108	153108	320422
20092	28887	0	applied	\N	\N	\N	\N	153117	153117	320431
20092	28888	1	applied	\N	\N	\N	\N	153118	153118	320432
20092	28889	2	applied	\N	\N	\N	\N	153119	153119	320433
20092	28891	4	applied	\N	\N	\N	\N	153121	153121	320435
20092	28892	5	applied	\N	\N	\N	\N	153122	153122	320436
20067	28771	70	applied	\N	\N	\N	\N	152904	152904	320222
20067	28772	71	applied	\N	\N	\N	\N	152905	152905	320223
20085	28816	2	applied	\N	\N	\N	\N	153011	153011	320326
20085	28817	3	applied	\N	\N	\N	\N	153012	153012	320327
20085	28818	4	applied	\N	\N	\N	\N	153013	153013	320328
20085	28819	5	applied	\N	\N	\N	\N	153014	153014	320329
20085	28820	6	applied	\N	\N	\N	\N	153015	153015	320330
20085	28821	7	applied	\N	\N	\N	\N	153016	153016	320331
20086	28822	0	applied	\N	\N	\N	\N	153017	153017	320332
20086	28823	1	applied	\N	\N	\N	\N	153018	153018	320333
20086	28824	2	applied	\N	\N	\N	\N	153019	153019	320334
20086	28825	3	applied	\N	\N	\N	\N	153020	153020	320335
20086	28826	4	applied	\N	\N	\N	\N	153021	153021	320336
20086	28827	5	applied	\N	\N	\N	\N	153022	153022	320337
20086	28828	6	applied	\N	\N	\N	\N	153023	153023	320338
20086	28829	7	applied	\N	\N	\N	\N	153024	153024	320339
20086	28831	9	applied	\N	\N	\N	\N	153026	153026	320341
20086	28832	10	applied	\N	\N	\N	\N	153027	153027	320342
20086	28833	11	applied	\N	\N	\N	\N	153028	153028	320343
20089	28874	0	applied	\N	\N	\N	\N	153081	153081	320395
20091	28898	11	applied	\N	\N	\N	\N	153109	153109	320423
20091	28899	12	applied	\N	\N	\N	\N	153110	153110	320424
20091	28900	13	applied	\N	\N	\N	\N	153111	153111	320425
20091	28901	14	applied	\N	\N	\N	\N	153112	153112	320426
20091	28902	15	applied	\N	\N	\N	\N	153113	153113	320427
20091	28903	16	applied	\N	\N	\N	\N	153114	153114	320428
20091	28904	17	applied	\N	\N	\N	\N	153115	153115	320429
20091	28905	18	applied	\N	\N	\N	\N	153116	153116	320430
20094	28814	0	applied	\N	\N	\N	\N	153153	153153	153153
20094	28834	1	applied	\N	\N	\N	\N	153154	153154	153154
20094	28817	2	applied	\N	\N	\N	\N	153155	153155	320467
20094	28818	3	applied	\N	\N	\N	\N	153156	153156	320468
20094	28823	5	applied	\N	\N	\N	\N	153158	153158	320470
20094	28826	6	applied	\N	\N	\N	\N	153159	153159	320471
20094	28827	7	applied	\N	\N	\N	\N	153160	153160	320472
20094	28828	8	applied	\N	\N	\N	\N	153161	153161	320473
20094	28829	9	applied	\N	\N	\N	\N	153162	153162	320474
20094	28830	10	applied	\N	\N	\N	\N	153163	153163	320475
20094	28831	11	applied	\N	\N	\N	\N	153164	153164	320476
20094	28837	12	applied	\N	\N	\N	\N	153165	153165	320477
20094	28838	13	applied	\N	\N	\N	\N	153166	153166	320478
20094	28839	14	applied	\N	\N	\N	\N	153167	153167	320479
20094	28840	15	applied	\N	\N	\N	\N	153168	153168	320480
20094	28841	16	applied	\N	\N	\N	\N	153169	153169	320481
20096	28923	0	applied	\N	\N	\N	\N	153187	153187	320499
20096	28924	1	applied	\N	\N	\N	\N	153188	153188	320500
20096	28925	3	applied	\N	\N	\N	\N	153189	153189	320501
20100	28930	0	applied	\N	\N	\N	\N	153216	153216	320528
20100	28932	2	applied	\N	\N	\N	\N	153218	153218	320530
20100	28933	3	applied	\N	\N	\N	\N	153219	153219	320531
20100	28934	4	applied	\N	\N	\N	\N	153220	153220	320532
20100	28935	5	applied	\N	\N	\N	\N	153221	153221	320533
20100	28936	6	applied	\N	\N	\N	\N	153222	153222	320534
20100	28937	7	applied	\N	\N	\N	\N	153223	153223	320535
20100	28938	8	applied	\N	\N	\N	\N	153224	153224	320536
20100	28939	9	applied	\N	\N	\N	\N	153225	153225	320537
20100	28940	10	applied	\N	\N	\N	\N	153226	153226	320538
20100	28941	11	applied	\N	\N	\N	\N	153227	153227	320539
20106	28953	0	applied	\N	\N	\N	\N	153277	153277	320589
20106	28954	1	applied	\N	\N	\N	\N	153278	153278	320590
20106	28955	2	applied	\N	\N	\N	\N	153279	153279	320591
20106	28956	3	applied	\N	\N	\N	\N	153280	153280	320592
20106	28957	4	applied	\N	\N	\N	\N	153281	153281	320593
20106	28958	5	applied	\N	\N	\N	\N	153282	153282	320594
20106	28960	7	applied	\N	\N	\N	\N	153284	153284	320596
20106	28961	8	applied	\N	\N	\N	\N	153285	153285	320597
20109	28966	0	applied	\N	\N	\N	\N	153294	153294	320606
20109	28967	1	applied	\N	\N	\N	\N	153295	153295	320607
20114	28983	0	applied	\N	\N	\N	\N	153311	153311	320623
20114	28984	1	applied	\N	\N	\N	\N	153312	153312	320624
20114	28985	2	applied	\N	\N	\N	\N	153313	153313	320625
20114	28986	3	applied	\N	\N	\N	\N	153314	153314	320626
20114	28987	4	applied	\N	\N	\N	\N	153315	153315	320627
20114	28988	5	applied	\N	\N	\N	\N	153316	153316	320628
20114	28989	6	applied	\N	\N	\N	\N	153317	153317	320629
20121	28990	0	applied	\N	\N	\N	\N	153347	153347	320659
20121	29001	1	applied	\N	\N	\N	\N	153348	153348	320660
20121	29002	2	applied	\N	\N	\N	\N	153349	153349	320661
20121	29003	3	applied	\N	\N	\N	\N	153350	153350	320662
20121	29004	4	applied	\N	\N	\N	\N	153351	153351	320663
20121	29006	6	applied	\N	\N	\N	\N	153353	153353	320665
20124	29015	0	applied	\N	\N	\N	\N	153370	153370	320682
20124	29016	1	applied	\N	\N	\N	\N	153371	153371	320683
20124	29017	2	applied	\N	\N	\N	\N	153372	153372	320684
20124	29018	3	applied	\N	\N	\N	\N	153373	153373	320685
20124	29019	4	applied	\N	\N	\N	\N	153374	153374	320686
20124	29020	5	applied	\N	\N	\N	\N	153375	153375	320687
20127	29021	0	applied	\N	\N	\N	\N	153395	153395	320707
20127	29022	1	applied	\N	\N	\N	\N	153396	153396	320708
20127	29023	2	applied	\N	\N	\N	\N	153397	153397	320709
20127	29024	3	applied	\N	\N	\N	\N	153398	153398	320710
20127	29025	4	applied	\N	\N	\N	\N	153399	153399	320711
20127	29026	5	applied	\N	\N	\N	\N	153400	153400	320712
20127	29029	6	applied	\N	\N	\N	\N	153401	153401	320713
20127	29030	7	applied	\N	\N	\N	\N	153402	153402	320714
20127	29031	8	applied	\N	\N	\N	\N	153403	153403	320715
20127	29028	10	applied	\N	\N	\N	\N	153405	153405	320717
20129	29032	0	applied	\N	\N	\N	\N	153413	153413	320725
20129	29033	1	applied	\N	\N	\N	\N	153414	153414	320726
20129	29034	2	applied	\N	\N	\N	\N	153415	153415	320727
20129	29029	3	applied	\N	\N	\N	\N	153416	153416	320728
20129	29030	4	applied	\N	\N	\N	\N	153417	153417	320729
20129	29031	5	applied	\N	\N	\N	\N	153418	153418	320730
20129	29035	6	applied	\N	\N	\N	\N	153419	153419	320731
20138	29054	0	applied	\N	\N	\N	\N	153478	153478	320790
20138	29055	1	applied	\N	\N	\N	\N	153479	153479	320791
20138	29056	2	applied	\N	\N	\N	\N	153480	153480	320792
20149	29072	0	applied	\N	\N	\N	\N	153617	153617	320929
20149	29073	1	applied	\N	\N	\N	\N	153618	153618	320930
20149	29074	2	applied	\N	\N	\N	\N	153619	153619	320931
20157	29094	0	applied	\N	\N	\N	\N	153645	153645	320957
20157	29095	1	applied	\N	\N	\N	\N	153646	153646	320958
20085	28815	1	applied	\N	\N	1000000000	\N	153010	153010	320325
20089	28879	5	applied	\N	\N	\N	\N	153086	153086	320400
20089	28880	6	applied	\N	\N	\N	\N	153087	153087	320401
20089	28881	7	applied	\N	\N	\N	\N	153088	153088	320402
20089	28882	8	applied	\N	\N	\N	\N	153089	153089	320403
20089	28883	9	applied	\N	\N	\N	\N	153090	153090	320404
20089	28884	10	applied	\N	\N	\N	\N	153091	153091	320405
20089	28885	11	applied	\N	\N	\N	\N	153092	153092	320406
20089	28886	12	applied	\N	\N	\N	\N	153093	153093	320407
20092	28893	6	applied	\N	\N	\N	\N	153123	153123	320437
20092	28894	7	applied	\N	\N	\N	\N	153124	153124	320438
20092	28895	8	applied	\N	\N	\N	\N	153125	153125	320439
20092	28896	9	applied	\N	\N	\N	\N	153126	153126	320440
20092	28897	10	applied	\N	\N	\N	\N	153127	153127	320441
20092	28898	11	applied	\N	\N	\N	\N	153128	153128	320442
20092	28899	12	applied	\N	\N	\N	\N	153129	153129	320443
20092	28900	13	applied	\N	\N	\N	\N	153130	153130	320444
20092	28902	15	applied	\N	\N	\N	\N	153132	153132	320446
20092	28903	16	applied	\N	\N	\N	\N	153133	153133	320447
20092	28904	17	applied	\N	\N	\N	\N	153134	153134	320448
20092	28905	18	applied	\N	\N	\N	\N	153135	153135	320449
20095	28906	0	applied	\N	\N	\N	\N	153170	153170	320482
20095	28907	1	applied	\N	\N	\N	\N	153171	153171	320483
20095	28908	2	applied	\N	\N	\N	\N	153172	153172	320484
20095	28909	3	applied	\N	\N	\N	\N	153173	153173	320485
20095	28910	4	applied	\N	\N	\N	\N	153174	153174	320486
20095	28911	5	applied	\N	\N	\N	\N	153175	153175	320487
20095	28912	6	applied	\N	\N	\N	\N	153176	153176	320488
20095	28913	7	applied	\N	\N	\N	\N	153177	153177	320489
20095	28914	8	applied	\N	\N	\N	\N	153178	153178	320490
20095	28915	9	applied	\N	\N	\N	\N	153179	153179	320491
20095	28916	10	applied	\N	\N	\N	\N	153180	153180	320492
20095	28917	11	applied	\N	\N	\N	\N	153181	153181	320493
20095	28919	13	applied	\N	\N	\N	\N	153183	153183	320495
20095	28920	14	applied	\N	\N	\N	\N	153184	153184	320496
20095	28921	15	applied	\N	\N	\N	\N	153185	153185	320497
20095	28922	16	applied	\N	\N	\N	\N	153186	153186	320498
20097	28923	0	applied	\N	\N	\N	\N	153190	153190	320502
20097	28926	1	applied	\N	\N	\N	\N	153191	153191	320503
20097	28927	3	applied	\N	\N	\N	\N	153192	153192	320504
20097	28924	4	applied	\N	\N	\N	\N	153193	153193	320505
20097	28928	5	applied	\N	\N	\N	\N	153194	153194	320506
20097	28925	6	applied	\N	\N	\N	\N	153195	153195	320507
20097	28929	7	applied	\N	\N	\N	\N	153196	153196	320508
20098	28923	0	applied	\N	\N	\N	\N	153197	153197	320509
20098	28926	1	applied	\N	\N	\N	\N	153198	153198	320510
20098	28927	3	applied	\N	\N	\N	\N	153199	153199	320511
20098	28924	4	applied	\N	\N	\N	\N	153200	153200	320512
20098	28928	5	applied	\N	\N	\N	\N	153201	153201	320513
20098	28929	7	applied	\N	\N	\N	\N	153203	153203	320515
20101	28942	0	applied	\N	\N	\N	\N	153228	153228	320540
20101	28943	1	applied	\N	\N	\N	\N	153229	153229	320541
20101	28944	2	applied	\N	\N	\N	\N	153230	153230	320542
20103	28953	0	applied	\N	\N	\N	\N	153250	153250	320562
20103	28954	1	applied	\N	\N	\N	\N	153251	153251	320563
20103	28955	2	applied	\N	\N	\N	\N	153252	153252	320564
20103	28956	3	applied	\N	\N	\N	\N	153253	153253	320565
20103	28957	4	applied	\N	\N	\N	\N	153254	153254	320566
20103	28958	5	applied	\N	\N	\N	\N	153255	153255	320567
20103	28959	6	applied	\N	\N	\N	\N	153256	153256	320568
20103	28960	7	applied	\N	\N	\N	\N	153257	153257	320569
20103	28961	8	applied	\N	\N	\N	\N	153258	153258	320570
20107	28962	0	applied	\N	\N	\N	\N	153286	153286	320598
20107	28963	1	applied	\N	\N	\N	\N	153287	153287	320599
20107	28964	2	applied	\N	\N	\N	\N	153288	153288	320600
20112	28977	0	applied	\N	\N	\N	\N	153305	153305	320617
20112	28978	1	applied	\N	\N	\N	\N	153306	153306	320618
20119	28998	0	applied	\N	\N	\N	\N	153337	153337	320649
20119	28999	1	applied	\N	\N	\N	\N	153338	153338	320650
20119	29000	2	applied	\N	\N	\N	\N	153339	153339	320651
20122	29007	0	applied	\N	\N	\N	\N	153354	153354	320666
20122	29008	1	applied	\N	\N	\N	\N	153355	153355	320667
20122	29009	2	applied	\N	\N	\N	\N	153356	153356	320668
20122	29010	3	applied	\N	\N	\N	\N	153357	153357	320669
20122	29011	4	applied	\N	\N	\N	\N	153358	153358	320670
20122	29012	5	applied	\N	\N	\N	\N	153359	153359	320671
20122	29013	6	applied	\N	\N	\N	\N	153360	153360	320672
20122	29014	7	applied	\N	\N	\N	\N	153361	153361	320673
20125	29021	0	applied	\N	\N	\N	\N	153376	153376	320688
20125	29022	1	applied	\N	\N	\N	\N	153377	153377	320689
20125	29023	2	applied	\N	\N	\N	\N	153378	153378	320690
20125	29025	4	applied	\N	\N	\N	\N	153380	153380	320692
20125	29026	5	applied	\N	\N	\N	\N	153381	153381	320693
20125	29027	6	applied	\N	\N	\N	\N	153382	153382	320694
20125	29028	7	applied	\N	\N	\N	\N	153383	153383	320695
20132	29036	0	applied	\N	\N	\N	\N	153434	153434	320746
20132	29037	1	applied	\N	\N	\N	\N	153435	153435	320747
20132	29038	2	applied	\N	\N	\N	\N	153436	153436	320748
20132	29039	3	applied	\N	\N	\N	\N	153437	153437	320749
20132	29040	4	applied	\N	\N	\N	\N	153438	153438	320750
20132	29041	5	applied	\N	\N	\N	\N	153439	153439	320751
20134	29042	0	applied	\N	\N	\N	\N	153446	153446	320758
20134	29043	1	applied	\N	\N	\N	\N	153447	153447	320759
20134	29044	2	applied	\N	\N	\N	\N	153448	153448	320760
20134	29045	3	applied	\N	\N	\N	\N	153449	153449	320761
20134	29046	4	applied	\N	\N	\N	\N	153450	153450	320762
20134	29047	5	applied	\N	\N	\N	\N	153451	153451	320763
20134	29049	7	applied	\N	\N	\N	\N	153453	153453	320765
20134	29050	8	applied	\N	\N	\N	\N	153454	153454	320766
20134	29051	9	applied	\N	\N	\N	\N	153455	153455	320767
20139	29054	0	applied	\N	\N	\N	\N	153481	153481	320793
20139	29055	1	applied	\N	\N	\N	\N	153482	153482	320794
20139	29056	2	applied	\N	\N	\N	\N	153483	153483	320795
20143	29062	0	applied	\N	\N	\N	\N	153495	153495	320807
20143	29063	1	applied	\N	\N	\N	\N	153496	153496	320808
20143	29064	2	applied	\N	\N	\N	\N	153497	153497	320809
20143	29065	3	applied	\N	\N	\N	\N	153498	153498	320810
20143	29066	4	applied	\N	\N	\N	\N	153499	153499	320811
20143	29067	5	applied	\N	\N	\N	\N	153500	153500	320812
20147	29057	0	applied	\N	\N	\N	\N	153516	153516	320828
20147	29058	1	applied	\N	\N	\N	\N	153517	153517	320829
20089	28876	2	applied	\N	\N	\N	\N	153083	153083	320397
20089	28877	3	applied	\N	\N	\N	\N	153084	153084	320398
20093	28914	8	applied	\N	\N	\N	\N	153144	153144	320458
20093	28915	9	applied	\N	\N	\N	\N	153145	153145	320459
20093	28916	10	applied	\N	\N	\N	\N	153146	153146	320460
20093	28917	11	applied	\N	\N	\N	\N	153147	153147	320461
20093	28918	12	applied	\N	\N	\N	\N	153148	153148	320462
20093	28919	13	applied	\N	\N	\N	\N	153149	153149	320463
20093	28920	14	applied	\N	\N	\N	\N	153150	153150	320464
20093	28921	15	applied	\N	\N	\N	\N	153151	153151	320465
20093	28922	16	applied	\N	\N	\N	\N	153152	153152	320466
20099	28930	0	applied	\N	\N	\N	\N	153204	153204	320516
20099	28931	1	applied	\N	\N	\N	\N	153205	153205	320517
20099	28932	2	applied	\N	\N	\N	\N	153206	153206	320518
20099	28933	3	applied	\N	\N	\N	\N	153207	153207	320519
20099	28934	4	applied	\N	\N	\N	\N	153208	153208	320520
20099	28935	5	applied	\N	\N	\N	\N	153209	153209	320521
20099	28936	6	applied	\N	\N	\N	\N	153210	153210	320522
20099	28938	8	applied	\N	\N	\N	\N	153212	153212	320524
20099	28939	9	applied	\N	\N	\N	\N	153213	153213	320525
20101	28945	3	applied	\N	\N	\N	\N	153231	153231	320543
20101	28946	4	applied	\N	\N	\N	\N	153232	153232	320544
20101	28947	5	applied	\N	\N	\N	\N	153233	153233	320545
20101	28948	6	applied	\N	\N	\N	\N	153234	153234	320546
20101	28949	7	applied	\N	\N	\N	\N	153235	153235	320547
20101	28950	8	applied	\N	\N	\N	\N	153236	153236	320548
20101	28951	9	applied	\N	\N	\N	\N	153237	153237	320549
20101	28952	10	applied	\N	\N	\N	\N	153238	153238	320550
20104	28953	0	applied	\N	\N	\N	\N	153259	153259	320571
20104	28954	1	applied	\N	\N	\N	\N	153260	153260	320572
20104	28955	2	applied	\N	\N	\N	\N	153261	153261	320573
20104	28956	3	applied	\N	\N	\N	\N	153262	153262	320574
20104	28957	4	applied	\N	\N	\N	\N	153263	153263	320575
20104	28958	5	applied	\N	\N	\N	\N	153264	153264	320576
20104	28960	7	applied	\N	\N	\N	\N	153266	153266	320578
20104	28961	8	applied	\N	\N	\N	\N	153267	153267	320579
20108	28962	0	applied	\N	\N	\N	\N	153290	153290	320602
20108	28963	1	applied	\N	\N	\N	\N	153291	153291	320603
20108	28964	2	applied	\N	\N	\N	\N	153292	153292	320604
20108	28965	3	applied	\N	\N	\N	\N	153293	153293	320605
20110	28968	0	applied	\N	\N	\N	\N	153296	153296	320608
20110	28969	1	applied	\N	\N	\N	\N	153297	153297	320609
20113	28979	0	applied	\N	\N	\N	\N	153307	153307	320619
20113	28980	1	applied	\N	\N	\N	\N	153308	153308	320620
20113	28981	2	applied	\N	\N	\N	\N	153309	153309	320621
20113	28982	3	applied	\N	\N	\N	\N	153310	153310	320622
20116	28970	0	applied	\N	\N	\N	\N	153318	153318	320630
20116	28971	1	applied	\N	\N	\N	\N	153319	153319	320631
20116	28972	2	applied	\N	\N	\N	\N	153320	153320	320632
20116	28990	3	applied	\N	\N	\N	\N	153321	153321	320633
20120	28990	0	applied	\N	\N	\N	\N	153340	153340	320652
20120	29001	1	applied	\N	\N	\N	\N	153341	153341	320653
20120	29002	2	applied	\N	\N	\N	\N	153342	153342	320654
20120	29003	3	applied	\N	\N	\N	\N	153343	153343	320655
20120	29004	4	applied	\N	\N	\N	\N	153344	153344	320656
20120	29005	5	applied	\N	\N	\N	\N	153345	153345	320657
20120	29006	6	applied	\N	\N	\N	\N	153346	153346	320658
20126	29021	0	applied	\N	\N	\N	\N	153384	153384	320696
20126	29022	1	applied	\N	\N	\N	\N	153385	153385	320697
20126	29023	2	applied	\N	\N	\N	\N	153386	153386	320698
20126	29024	3	applied	\N	\N	\N	\N	153387	153387	320699
20126	29025	4	applied	\N	\N	\N	\N	153388	153388	320700
20126	29026	5	applied	\N	\N	\N	\N	153389	153389	320701
20126	29029	6	applied	\N	\N	\N	\N	153390	153390	320702
20126	29030	7	applied	\N	\N	\N	\N	153391	153391	320703
20126	29031	8	applied	\N	\N	\N	\N	153392	153392	320704
20126	29028	10	applied	\N	\N	\N	\N	153394	153394	320706
20130	29032	0	applied	\N	\N	\N	\N	153420	153420	320732
20130	29033	1	applied	\N	\N	\N	\N	153421	153421	320733
20130	29034	2	applied	\N	\N	\N	\N	153422	153422	320734
20130	29029	3	applied	\N	\N	\N	\N	153423	153423	320735
20130	29030	4	applied	\N	\N	\N	\N	153424	153424	320736
20130	29031	5	applied	\N	\N	\N	\N	153425	153425	320737
20130	29035	6	applied	\N	\N	\N	\N	153426	153426	320738
20133	29036	0	applied	\N	\N	\N	\N	153440	153440	320752
20133	29037	1	applied	\N	\N	\N	\N	153441	153441	320753
20133	29038	2	applied	\N	\N	\N	\N	153442	153442	320754
20133	29039	3	applied	\N	\N	\N	\N	153443	153443	320755
20133	29040	4	applied	\N	\N	\N	\N	153444	153444	320756
20133	29041	5	applied	\N	\N	\N	\N	153445	153445	320757
20135	29042	0	applied	\N	\N	\N	\N	153456	153456	320768
20135	29043	1	applied	\N	\N	\N	\N	153457	153457	320769
20135	29045	3	applied	\N	\N	\N	\N	153459	153459	320771
20135	29046	4	applied	\N	\N	\N	\N	153460	153460	320772
20135	29047	5	applied	\N	\N	\N	\N	153461	153461	320773
20135	29048	6	applied	\N	\N	\N	\N	153462	153462	320774
20135	29049	7	applied	\N	\N	\N	\N	153463	153463	320775
20135	29050	8	applied	\N	\N	\N	\N	153464	153464	320776
20135	29051	9	applied	\N	\N	\N	\N	153465	153465	320777
20137	29052	0	applied	\N	\N	\N	\N	153476	153476	320788
20137	29053	1	applied	\N	\N	\N	\N	153477	153477	320789
20140	29054	0	applied	\N	\N	\N	\N	153484	153484	320796
20140	29055	1	applied	\N	\N	\N	\N	153485	153485	320797
20140	29056	2	applied	\N	\N	\N	\N	153486	153486	320798
20141	29054	0	applied	\N	\N	\N	\N	153487	153487	320799
20141	29055	1	applied	\N	\N	\N	\N	153488	153488	320800
20141	29056	2	applied	\N	\N	\N	\N	153489	153489	320801
20144	29062	0	applied	\N	\N	\N	\N	153501	153501	320813
20144	29065	2	applied	\N	\N	\N	\N	153503	153503	320815
20144	29066	3	applied	\N	\N	\N	\N	153504	153504	320816
20144	29067	4	applied	\N	\N	\N	\N	153505	153505	320817
20148	29069	0	applied	\N	\N	\N	\N	153614	153614	320926
20148	29070	1	applied	\N	\N	\N	\N	153615	153615	320927
20148	29071	2	applied	\N	\N	\N	\N	153616	153616	320928
20153	29082	0	applied	\N	\N	\N	\N	153630	153630	320942
20153	29083	1	applied	\N	\N	\N	\N	153631	153631	320943
20153	29084	2	applied	\N	\N	\N	\N	153632	153632	320944
20153	29085	3	applied	\N	\N	\N	\N	153633	153633	320945
20153	29086	4	applied	\N	\N	\N	\N	153634	153634	320946
20153	29087	5	applied	\N	\N	\N	\N	153635	153635	320947
20156	29091	0	applied	\N	\N	\N	\N	153642	153642	320954
20156	29092	1	applied	\N	\N	\N	\N	153643	153643	320955
20093	28911	5	applied	\N	\N	\N	\N	153141	153141	320455
20093	28912	6	applied	\N	\N	\N	\N	153142	153142	320456
20102	28944	2	applied	\N	\N	\N	\N	153241	153241	320553
20102	28945	3	applied	\N	\N	\N	\N	153242	153242	320554
20102	28946	4	applied	\N	\N	\N	\N	153243	153243	320555
20102	28947	5	applied	\N	\N	\N	\N	153244	153244	320556
20102	28948	6	applied	\N	\N	\N	\N	153245	153245	320557
20102	28949	7	applied	\N	\N	\N	\N	153246	153246	320558
20102	28950	8	applied	\N	\N	\N	\N	153247	153247	320559
20102	28951	9	applied	\N	\N	\N	\N	153248	153248	320560
20102	28952	10	applied	\N	\N	\N	\N	153249	153249	320561
20105	28953	0	applied	\N	\N	\N	\N	153268	153268	320580
20105	28954	1	applied	\N	\N	\N	\N	153269	153269	320581
20105	28955	2	applied	\N	\N	\N	\N	153270	153270	320582
20105	28956	3	applied	\N	\N	\N	\N	153271	153271	320583
20105	28957	4	applied	\N	\N	\N	\N	153272	153272	320584
20105	28958	5	applied	\N	\N	\N	\N	153273	153273	320585
20105	28959	6	applied	\N	\N	\N	\N	153274	153274	320586
20105	28961	8	applied	\N	\N	\N	\N	153276	153276	320588
20111	28970	0	applied	\N	\N	\N	\N	153298	153298	320610
20111	28971	1	applied	\N	\N	\N	\N	153299	153299	320611
20111	28972	2	applied	\N	\N	\N	\N	153300	153300	320612
20111	28973	3	applied	\N	\N	\N	\N	153301	153301	320613
20111	28974	4	applied	\N	\N	\N	\N	153302	153302	320614
20111	28975	5	applied	\N	\N	\N	\N	153303	153303	320615
20111	28976	6	applied	\N	\N	\N	\N	153304	153304	320616
20117	28983	0	applied	\N	\N	\N	\N	153323	153323	320635
20117	28984	1	applied	\N	\N	\N	\N	153324	153324	320636
20117	28985	2	applied	\N	\N	\N	\N	153325	153325	320637
20117	28986	3	applied	\N	\N	\N	\N	153326	153326	320638
20117	28987	4	applied	\N	\N	\N	\N	153327	153327	320639
20117	28988	5	applied	\N	\N	\N	\N	153328	153328	320640
20117	28989	6	applied	\N	\N	\N	\N	153329	153329	320641
20118	28991	0	applied	\N	\N	\N	\N	153330	153330	320642
20118	28993	2	applied	\N	\N	\N	\N	153332	153332	320644
20118	28994	3	applied	\N	\N	\N	\N	153333	153333	320645
20118	28995	4	applied	\N	\N	\N	\N	153334	153334	320646
20118	28996	5	applied	\N	\N	\N	\N	153335	153335	320647
20118	28997	6	applied	\N	\N	\N	\N	153336	153336	320648
20123	29007	0	applied	\N	\N	\N	\N	153362	153362	320674
20123	29008	1	applied	\N	\N	\N	\N	153363	153363	320675
20123	29009	2	applied	\N	\N	\N	\N	153364	153364	320676
20123	29010	3	applied	\N	\N	\N	\N	153365	153365	320677
20123	29011	4	applied	\N	\N	\N	\N	153366	153366	320678
20123	29012	5	applied	\N	\N	\N	\N	153367	153367	320679
20123	29013	6	applied	\N	\N	\N	\N	153368	153368	320680
20123	29014	7	applied	\N	\N	\N	\N	153369	153369	320681
20128	29032	0	applied	\N	\N	\N	\N	153406	153406	320718
20128	29033	1	applied	\N	\N	\N	\N	153407	153407	320719
20128	29034	2	applied	\N	\N	\N	\N	153408	153408	320720
20128	29030	4	applied	\N	\N	\N	\N	153410	153410	320722
20128	29031	5	applied	\N	\N	\N	\N	153411	153411	320723
20128	29035	6	applied	\N	\N	\N	\N	153412	153412	320724
20131	29032	0	applied	\N	\N	\N	\N	153427	153427	320739
20131	29033	1	applied	\N	\N	\N	\N	153428	153428	320740
20131	29034	2	applied	\N	\N	\N	\N	153429	153429	320741
20131	29029	3	applied	\N	\N	\N	\N	153430	153430	320742
20131	29030	4	applied	\N	\N	\N	\N	153431	153431	320743
20131	29031	5	applied	\N	\N	\N	\N	153432	153432	320744
20131	29035	6	applied	\N	\N	\N	\N	153433	153433	320745
20136	29042	0	applied	\N	\N	\N	\N	153466	153466	320778
20136	29043	1	applied	\N	\N	\N	\N	153467	153467	320779
20136	29044	2	applied	\N	\N	\N	\N	153468	153468	320780
20136	29045	3	applied	\N	\N	\N	\N	153469	153469	320781
20136	29046	4	applied	\N	\N	\N	\N	153470	153470	320782
20136	29047	5	applied	\N	\N	\N	\N	153471	153471	320783
20136	29049	7	applied	\N	\N	\N	\N	153473	153473	320785
20136	29050	8	applied	\N	\N	\N	\N	153474	153474	320786
20136	29051	9	applied	\N	\N	\N	\N	153475	153475	320787
20142	29057	0	applied	\N	\N	\N	\N	153490	153490	320802
20142	29058	1	applied	\N	\N	\N	\N	153491	153491	320803
20142	29059	2	applied	\N	\N	\N	\N	153492	153492	320804
20142	29060	3	applied	\N	\N	\N	\N	153493	153493	320805
20142	29061	4	applied	\N	\N	\N	\N	153494	153494	320806
20145	29062	0	applied	\N	\N	\N	\N	153506	153506	320818
20145	29064	1	applied	\N	\N	\N	\N	153507	153507	320819
20145	29065	2	applied	\N	\N	\N	\N	153508	153508	320820
20145	29066	3	applied	\N	\N	\N	\N	153509	153509	320821
20145	29067	4	applied	\N	\N	\N	\N	153510	153510	320822
20146	29062	0	applied	\N	\N	\N	\N	153511	153511	320823
20146	29064	1	applied	\N	\N	\N	\N	153512	153512	320824
20146	29065	2	applied	\N	\N	\N	\N	153513	153513	320825
20146	29067	4	applied	\N	\N	\N	\N	153515	153515	320827
20147	29062	2	applied	\N	\N	\N	\N	153518	153518	320830
20147	29063	3	applied	\N	\N	\N	\N	153519	153519	320831
20147	29015	4	applied	\N	\N	\N	\N	153520	153520	320832
20147	29016	5	applied	\N	\N	\N	\N	153521	153521	320833
20147	29007	6	applied	\N	\N	\N	\N	153522	153522	320834
20147	28983	12	applied	\N	\N	\N	\N	153528	153528	320840
20147	29017	13	applied	\N	\N	\N	\N	153529	153529	320841
20147	29018	14	applied	\N	\N	\N	\N	153530	153530	320842
20147	28973	15	applied	\N	\N	\N	\N	153531	153531	320843
20147	28977	16	applied	\N	\N	\N	\N	153532	153532	320844
20147	28984	17	applied	\N	\N	\N	\N	153533	153533	320845
20151	29075	0	applied	\N	\N	\N	\N	153623	153623	320935
20151	29076	1	applied	\N	\N	\N	\N	153624	153624	320936
20151	29077	2	applied	\N	\N	\N	\N	153625	153625	320937
20154	29088	0	applied	\N	\N	\N	\N	153636	153636	320948
20154	29089	1	applied	\N	\N	\N	\N	153637	153637	320949
20154	29090	2	applied	\N	\N	\N	\N	153638	153638	320950
20160	29115	0	applied	\N	\N	\N	\N	153672	153672	320984
20099	28941	11	applied	\N	\N	\N	\N	153215	153215	320527
20102	28942	0	applied	\N	\N	\N	\N	153239	153239	320551
20147	28982	62	applied	\N	\N	\N	\N	153578	153578	320890
20147	28989	63	applied	\N	\N	\N	\N	153579	153579	320891
20147	28996	64	applied	\N	\N	\N	\N	153580	153580	320892
20147	28999	65	applied	\N	\N	\N	\N	153581	153581	320893
20147	29013	70	applied	\N	\N	\N	\N	153585	153585	320897
20147	29014	71	applied	\N	\N	\N	\N	153586	153586	320898
20147	29025	72	applied	\N	\N	\N	\N	153587	153587	320899
20147	29027	73	applied	\N	\N	\N	\N	153588	153588	320900
20147	29028	74	applied	\N	\N	\N	\N	153589	153589	320901
20147	29034	75	applied	\N	\N	\N	\N	153590	153590	320902
20147	29041	76	applied	\N	\N	\N	\N	153591	153591	320903
20147	29049	77	applied	\N	\N	\N	\N	153592	153592	320904
20147	29050	78	applied	\N	\N	\N	\N	153593	153593	320905
20147	29051	79	applied	\N	\N	\N	\N	153594	153594	320906
20147	29055	80	applied	\N	\N	\N	\N	153595	153595	320907
20147	29060	81	applied	\N	\N	\N	\N	153596	153596	320908
20147	29067	82	applied	\N	\N	\N	\N	153597	153597	320909
20147	29005	83	applied	\N	\N	\N	\N	153598	153598	320910
20147	29006	84	applied	\N	\N	\N	\N	153599	153599	320911
20147	29010	85	applied	\N	\N	\N	\N	153600	153600	320912
20147	29011	86	applied	\N	\N	\N	\N	153601	153601	320913
20147	29029	87	applied	\N	\N	\N	\N	153602	153602	320914
20147	29030	88	applied	\N	\N	\N	\N	153603	153603	320915
20147	29031	89	applied	\N	\N	\N	\N	153604	153604	320916
20147	29035	90	applied	\N	\N	\N	\N	153605	153605	320917
20147	29040	91	applied	\N	\N	\N	\N	153606	153606	320918
20147	29046	92	applied	\N	\N	\N	\N	153607	153607	320919
20147	29047	93	applied	\N	\N	\N	\N	153608	153608	320920
20147	29048	94	applied	\N	\N	\N	\N	153609	153609	320921
20147	29053	95	applied	\N	\N	\N	\N	153610	153610	320922
20147	29056	96	applied	\N	\N	\N	\N	153611	153611	320923
20147	29061	97	applied	\N	\N	\N	\N	153612	153612	320924
20147	29066	98	applied	\N	\N	\N	\N	153613	153613	320925
20150	29072	0	applied	\N	\N	\N	\N	153620	153620	320932
20150	29073	1	applied	\N	\N	\N	\N	153621	153621	320933
20150	29074	2	applied	\N	\N	\N	\N	153622	153622	320934
20152	29078	0	applied	\N	\N	\N	\N	153626	153626	320938
20152	29079	1	applied	\N	\N	\N	\N	153627	153627	320939
20152	29080	2	applied	\N	\N	\N	\N	153628	153628	320940
20152	29081	3	applied	\N	\N	\N	\N	153629	153629	320941
20155	29091	0	applied	\N	\N	\N	\N	153639	153639	320951
20155	29092	1	applied	\N	\N	\N	\N	153640	153640	320952
20155	29093	2	applied	\N	\N	\N	\N	153641	153641	320953
20156	29093	2	applied	\N	\N	\N	\N	153644	153644	320956
20158	29094	0	applied	\N	\N	\N	\N	153651	153651	320963
20158	29095	1	applied	\N	\N	\N	\N	153652	153652	320964
20158	29096	2	applied	\N	\N	\N	\N	153653	153653	320965
20158	29097	3	applied	\N	\N	\N	\N	153654	153654	320966
20158	29098	4	applied	\N	\N	\N	\N	153655	153655	320967
20158	29099	5	applied	\N	\N	\N	\N	153656	153656	320968
20159	29100	0	applied	\N	\N	\N	\N	153657	153657	320969
20159	29101	1	applied	\N	\N	\N	\N	153658	153658	320970
20159	29102	2	applied	\N	\N	\N	\N	153659	153659	320971
20159	29103	3	applied	\N	\N	\N	\N	153660	153660	320972
20159	29104	4	applied	\N	\N	\N	\N	153661	153661	320973
20159	29105	5	applied	\N	\N	\N	\N	153662	153662	320974
20159	29106	6	applied	\N	\N	\N	\N	153663	153663	320975
20159	29107	7	applied	\N	\N	\N	\N	153664	153664	320976
20159	29108	8	applied	\N	\N	\N	\N	153665	153665	320977
20159	29109	9	applied	\N	\N	\N	\N	153666	153666	320978
20159	29110	10	applied	\N	\N	\N	\N	153667	153667	320979
20159	29111	11	applied	\N	\N	\N	\N	153668	153668	320980
20159	29112	12	applied	\N	\N	\N	\N	153669	153669	320981
20159	29113	13	applied	\N	\N	\N	\N	153670	153670	320982
20159	29114	14	applied	\N	\N	\N	\N	153671	153671	320983
20163	29124	0	applied	\N	\N	\N	\N	153814	153814	321124
20163	29125	1	applied	\N	\N	\N	\N	153815	153815	321125
20163	29126	2	applied	\N	\N	\N	\N	153816	153816	321126
20163	29127	3	applied	\N	\N	\N	\N	153817	153817	321127
20163	29128	4	applied	\N	\N	\N	\N	153818	153818	321128
20163	29129	5	applied	\N	\N	\N	\N	153819	153819	321129
20163	29130	6	applied	\N	\N	\N	\N	153820	153820	321130
20163	29131	7	applied	\N	\N	\N	\N	153821	153821	321131
20164	29124	0	applied	\N	\N	\N	\N	153827	153827	321137
20164	29125	1	applied	\N	\N	\N	\N	153828	153828	321138
20164	29126	2	applied	\N	\N	\N	\N	153829	153829	321139
20164	29127	3	applied	\N	\N	\N	\N	153830	153830	321140
20164	29128	4	applied	\N	\N	\N	\N	153831	153831	321141
20164	29129	5	applied	\N	\N	\N	\N	153832	153832	321142
20164	29130	6	applied	\N	\N	\N	\N	153833	153833	321143
20147	28995	51	applied	\N	\N	\N	\N	153567	153567	320879
20147	29012	52	applied	\N	\N	\N	\N	153568	153568	320880
20147	29026	53	applied	\N	\N	\N	\N	153569	153569	320881
20147	28975	54	applied	\N	\N	\N	\N	153570	153570	320882
20147	28978	55	applied	\N	\N	\N	\N	153571	153571	320883
20147	28980	56	applied	\N	\N	\N	\N	153572	153572	320884
20147	28988	57	applied	\N	\N	\N	\N	153573	153573	320885
20147	28997	58	applied	\N	\N	\N	\N	153574	153574	320886
20147	28976	59	applied	\N	\N	\N	\N	153575	153575	320887
20147	28987	60	applied	\N	\N	\N	\N	153576	153576	320888
20147	28981	61	applied	\N	\N	\N	\N	153577	153577	320889
20147	29000	66	applied	\N	\N	\N	\N	153582	153582	320894
20147	29003	67	applied	\N	\N	\N	\N	153583	153583	320895
20147	29004	69	applied	\N	\N	\N	\N	153584	153584	320896
20161	29115	0	applied	\N	\N	\N	\N	153681	153681	320993
20161	29116	1	applied	\N	\N	\N	\N	153682	153682	320994
20161	29117	2	applied	\N	\N	\N	\N	153683	153683	320995
20161	29118	3	applied	\N	\N	\N	\N	153684	153684	320996
20161	29119	4	applied	\N	\N	\N	\N	153685	153685	320997
20161	29120	5	applied	\N	\N	\N	\N	153686	153686	320998
20161	29121	6	applied	\N	\N	\N	\N	153687	153687	320999
20161	29122	7	applied	\N	\N	\N	\N	153688	153688	321000
20161	29123	8	applied	\N	\N	\N	\N	153689	153689	321001
20164	29131	7	applied	\N	\N	\N	\N	153834	153834	321144
20164	29132	8	applied	\N	\N	\N	\N	153835	153835	321145
20164	29133	9	applied	\N	\N	\N	\N	153836	153836	321146
20164	29134	10	applied	\N	\N	\N	\N	153837	153837	321147
20164	29135	11	applied	\N	\N	\N	\N	153838	153838	321148
20164	29136	12	applied	\N	\N	\N	\N	153839	153839	321149
20167	29163	0	applied	\N	\N	\N	\N	153872	153872	321182
20167	29165	2	applied	\N	\N	\N	\N	153874	153874	321184
20167	29166	3	applied	\N	\N	\N	\N	153875	153875	321185
20167	29167	4	applied	\N	\N	\N	\N	153876	153876	321186
20167	29168	5	applied	\N	\N	\N	\N	153877	153877	321187
20168	29169	0	applied	\N	\N	\N	\N	153878	153878	321188
20168	29170	1	applied	\N	\N	\N	\N	153879	153879	321189
20168	29171	2	applied	\N	\N	\N	\N	153880	153880	321190
20168	29172	3	applied	\N	\N	\N	\N	153881	153881	321191
20168	29173	4	applied	\N	\N	\N	\N	153882	153882	321192
20168	29174	5	applied	\N	\N	\N	\N	153883	153883	321193
20168	29175	6	applied	\N	\N	\N	\N	153884	153884	321194
20168	29176	7	applied	\N	\N	\N	\N	153885	153885	321195
20168	29177	8	applied	\N	\N	\N	\N	153886	153886	321196
20172	29188	0	applied	\N	\N	\N	\N	153906	153906	321216
20172	29189	1	applied	\N	\N	\N	\N	153907	153907	321217
20173	29190	0	applied	\N	\N	\N	\N	153908	153908	321218
20175	29199	1	applied	\N	\N	\N	\N	153917	153917	321227
20175	29200	2	applied	\N	\N	\N	\N	153918	153918	321228
20175	29201	3	applied	\N	\N	\N	\N	153919	153919	321229
20175	29202	4	applied	\N	\N	\N	\N	153920	153920	321230
20178	29213	0	applied	\N	\N	\N	\N	153936	153936	321246
20178	29214	1	applied	\N	\N	\N	\N	153937	153937	321247
20178	29215	2	applied	\N	\N	\N	\N	153938	153938	321248
20178	29216	3	applied	\N	\N	\N	\N	153939	153939	321249
20180	29217	0	applied	\N	\N	\N	\N	153944	153944	321254
20180	29218	1	applied	\N	\N	\N	\N	153945	153945	321255
20180	29219	2	applied	\N	\N	\N	\N	153946	153946	321256
20184	29230	0	applied	\N	\N	\N	\N	154099	154099	321409
20184	29231	1	applied	\N	\N	\N	\N	154100	154100	321410
20184	29232	2	applied	\N	\N	\N	\N	154101	154101	321411
20187	29243	0	applied	\N	\N	\N	\N	154236	154236	321544
20187	29244	1	applied	\N	\N	\N	\N	154237	154237	321545
20193	29263	0	applied	\N	\N	\N	\N	154262	154262	321570
20193	29264	1	applied	\N	\N	\N	\N	154263	154263	321571
20193	29265	2	applied	\N	\N	\N	\N	154264	154264	321572
20193	29266	3	applied	\N	\N	\N	\N	154265	154265	321573
20193	29267	4	applied	\N	\N	\N	\N	154266	154266	321574
20196	29268	0	applied	\N	\N	\N	\N	154279	154279	321587
20196	29269	1	applied	\N	\N	\N	\N	154280	154280	321588
20196	29270	2	applied	\N	\N	\N	\N	154281	154281	321589
20196	29271	3	applied	\N	\N	\N	\N	154282	154282	321590
20196	29272	4	applied	\N	\N	\N	\N	154283	154283	321591
20196	29273	5	applied	\N	\N	\N	\N	154284	154284	321592
20198	29274	0	applied	\N	\N	\N	\N	154289	154289	321597
20198	29275	1	applied	\N	\N	\N	\N	154290	154290	321598
20198	29276	2	applied	\N	\N	\N	\N	154291	154291	321599
20198	29277	3	applied	\N	\N	\N	\N	154292	154292	321600
20200	29286	0	applied	\N	\N	\N	\N	154301	154301	321609
20200	29288	2	applied	\N	\N	\N	\N	154303	154303	321611
20205	29292	0	applied	\N	\N	\N	\N	154316	154316	321624
20205	29293	1	applied	\N	\N	\N	\N	154317	154317	321625
20205	29294	2	applied	\N	\N	\N	\N	154318	154318	321626
20207	29295	0	applied	\N	\N	\N	\N	154394	154394	321702
20207	29296	1	applied	\N	\N	\N	\N	154395	154395	321703
20207	29297	2	applied	\N	\N	\N	\N	154396	154396	321704
20210	29298	0	applied	\N	\N	\N	\N	154403	154403	321711
20210	29299	1	applied	\N	\N	\N	\N	154404	154404	321712
20210	29300	2	applied	\N	\N	\N	\N	154405	154405	321713
20215	29312	0	applied	\N	\N	\N	\N	154426	154426	321734
20215	29313	1	applied	\N	\N	\N	\N	154427	154427	321735
20215	29314	2	applied	\N	\N	\N	\N	154428	154428	321736
20215	29315	3	applied	\N	\N	\N	\N	154429	154429	321737
20215	29316	4	applied	\N	\N	\N	\N	154430	154430	321738
20215	29317	5	applied	\N	\N	\N	\N	154431	154431	321739
20218	29312	0	applied	\N	\N	\N	\N	154445	154445	321753
20218	29313	1	applied	\N	\N	\N	\N	154446	154446	321754
20218	29314	2	applied	\N	\N	\N	\N	154447	154447	321755
20218	29315	3	applied	\N	\N	\N	\N	154448	154448	321756
20218	29316	4	applied	\N	\N	\N	\N	154449	154449	321757
20218	29317	5	applied	\N	\N	\N	\N	154450	154450	321758
20218	29318	6	applied	\N	\N	\N	\N	154451	154451	321759
20223	29319	0	applied	\N	\N	\N	\N	154489	154489	321797
20223	29320	1	applied	\N	\N	\N	\N	154490	154490	321798
20223	29321	2	applied	\N	\N	\N	\N	154491	154491	321799
20223	29322	3	applied	\N	\N	\N	\N	154492	154492	321800
20223	29323	4	applied	\N	\N	\N	\N	154493	154493	321801
20223	29324	5	applied	\N	\N	\N	\N	154494	154494	321802
20223	29315	6	applied	\N	\N	\N	\N	154495	154495	321803
20223	29318	7	applied	\N	\N	\N	\N	154496	154496	321804
20223	29325	8	applied	\N	\N	\N	\N	154497	154497	321805
20224	29327	0	applied	\N	\N	\N	\N	154499	154499	321807
20224	29328	1	applied	\N	\N	\N	\N	154500	154500	321808
20224	29329	2	applied	\N	\N	\N	\N	154501	154501	321809
20227	29330	0	applied	\N	\N	\N	\N	154508	154508	321816
20227	29331	1	applied	\N	\N	\N	\N	154509	154509	321817
20227	29332	2	applied	\N	\N	\N	\N	154510	154510	321818
20227	29333	3	applied	\N	\N	\N	\N	154511	154511	321819
20227	29334	4	applied	\N	\N	\N	\N	154512	154512	321820
20227	29335	5	applied	\N	\N	\N	\N	154513	154513	321821
20229	29336	0	applied	\N	\N	\N	\N	154520	154520	321828
20229	29337	1	applied	\N	\N	\N	\N	154521	154521	321829
20229	29338	2	applied	\N	\N	\N	\N	154522	154522	321830
20229	29339	3	applied	\N	\N	\N	\N	154523	154523	321831
20235	29349	0	applied	\N	\N	\N	\N	154544	154544	321852
20157	29097	3	applied	\N	\N	\N	\N	153648	153648	320960
20157	29098	4	applied	\N	\N	\N	\N	153649	153649	320961
20160	29119	4	applied	\N	\N	\N	\N	153676	153676	320988
20160	29120	5	applied	\N	\N	\N	\N	153677	153677	320989
20160	29121	6	applied	\N	\N	\N	\N	153678	153678	320990
20160	29122	7	applied	\N	\N	\N	\N	153679	153679	320991
20160	29123	8	applied	\N	\N	\N	\N	153680	153680	320992
20162	28930	0	applied	\N	\N	\N	\N	153690	153690	321002
20162	28874	1	applied	\N	\N	\N	\N	153691	153691	321003
20162	29058	3	applied	\N	\N	\N	\N	153693	153693	321005
20162	29062	4	applied	\N	\N	\N	\N	153694	153694	321006
20162	29063	5	applied	\N	\N	\N	\N	153695	153695	321007
20162	29015	6	applied	\N	\N	\N	\N	153696	153696	321008
20162	29016	7	applied	\N	\N	\N	\N	153697	153697	321009
20162	29007	8	applied	\N	\N	\N	\N	153698	153698	321010
20162	29021	9	applied	\N	\N	\N	\N	153699	153699	321011
20162	28814	10	applied	\N	\N	\N	\N	153700	153700	153700
20162	28970	11	applied	\N	\N	\N	\N	153701	153701	321012
20162	28971	12	applied	\N	\N	\N	\N	153702	153702	321013
20162	28972	13	applied	\N	\N	\N	\N	153703	153703	321014
20162	28990	14	applied	\N	\N	\N	\N	153704	153704	321015
20173	29191	1	applied	\N	\N	\N	\N	153909	153909	321219
20173	29192	2	applied	\N	\N	\N	\N	153910	153910	321220
20181	28874	0	applied	\N	\N	\N	\N	153947	153947	321257
20181	29057	1	applied	\N	\N	\N	\N	153948	153948	321258
20181	29015	3	applied	\N	\N	\N	\N	153950	153950	321260
20181	28366	4	applied	\N	\N	\N	\N	153951	153951	321261
20181	28239	5	applied	\N	\N	\N	\N	153952	153952	321262
20181	29007	6	applied	\N	\N	\N	\N	153953	153953	321263
20181	28370	7	applied	\N	\N	\N	\N	153954	153954	321264
20181	28970	8	applied	\N	\N	\N	\N	153955	153955	321265
20181	28971	9	applied	\N	\N	\N	\N	153956	153956	321266
20181	28972	10	applied	\N	\N	\N	\N	153957	153957	321267
20181	28990	11	applied	\N	\N	\N	\N	153958	153958	321268
20181	28887	12	applied	\N	\N	\N	\N	153959	153959	321269
20181	28383	13	applied	\N	\N	\N	\N	153960	153960	321270
20181	28581	14	applied	\N	\N	\N	\N	153961	153961	321271
20181	29100	15	applied	\N	\N	\N	\N	153962	153962	321272
20181	28942	16	applied	\N	\N	\N	\N	153963	153963	321273
20181	28943	17	applied	\N	\N	\N	\N	153964	153964	321274
20181	28801	18	applied	\N	\N	\N	\N	153965	153965	321275
20181	29018	20	applied	\N	\N	\N	\N	153967	153967	321277
20181	29163	21	applied	\N	\N	\N	\N	153968	153968	321278
20181	27728	22	applied	\N	\N	\N	\N	153969	153969	321279
20181	28889	23	applied	\N	\N	\N	\N	153970	153970	321280
20181	28890	24	applied	\N	\N	\N	\N	153971	153971	321281
20181	28891	25	applied	\N	\N	\N	\N	153972	153972	321282
20181	28892	26	applied	\N	\N	\N	\N	153973	153973	321283
20181	28545	27	applied	\N	\N	1000000000	\N	153974	153974	321284
20181	28944	28	applied	\N	\N	\N	\N	153975	153975	321285
20181	28945	29	applied	\N	\N	\N	\N	153976	153976	321286
20181	28946	30	applied	\N	\N	\N	\N	153977	153977	321287
20181	28953	31	applied	\N	\N	\N	\N	153978	153978	321288
20181	28793	32	applied	\N	\N	\N	\N	153979	153979	321289
20181	28802	33	applied	\N	\N	\N	\N	153980	153980	321290
20181	28807	34	applied	\N	\N	\N	\N	153981	153981	321291
20181	28808	35	applied	\N	\N	\N	\N	153982	153982	321292
20181	28824	37	applied	\N	\N	1000000000	\N	153984	153984	321294
20181	28447	38	applied	\N	\N	\N	\N	153985	153985	321295
20181	28448	39	applied	\N	\N	\N	\N	153986	153986	321296
20181	28389	40	applied	\N	\N	\N	\N	153987	153987	321297
20181	28390	41	applied	\N	\N	\N	\N	153988	153988	321298
20181	29019	42	applied	\N	\N	\N	\N	153989	153989	321299
20181	27706	43	applied	\N	\N	\N	\N	153990	153990	321300
20181	27709	44	applied	\N	\N	\N	\N	153991	153991	321301
20181	28450	45	applied	\N	\N	\N	\N	153992	153992	321302
20181	28451	46	applied	\N	\N	\N	\N	153993	153993	321303
20181	28817	47	applied	\N	\N	\N	\N	153994	153994	321304
20181	28818	48	applied	\N	\N	\N	\N	153995	153995	321305
20181	28822	49	applied	\N	\N	\N	\N	153996	153996	321306
20181	28823	50	applied	\N	\N	\N	\N	153997	153997	321307
20181	28228	51	applied	\N	\N	\N	\N	153998	153998	321308
20181	28826	52	applied	\N	\N	\N	\N	153999	153999	321309
20181	28452	54	applied	\N	\N	\N	\N	154001	154001	321311
20181	28703	55	applied	\N	\N	\N	\N	154002	154002	321312
20181	28704	56	applied	\N	\N	\N	\N	154003	154003	321313
20181	29165	57	applied	\N	\N	\N	\N	154004	154004	321314
20181	29120	58	applied	\N	\N	\N	\N	154005	154005	321315
20181	27707	59	applied	\N	\N	\N	\N	154006	154006	321316
20181	28245	60	applied	\N	\N	\N	\N	154007	154007	321317
20181	28766	61	applied	\N	\N	\N	\N	154008	154008	321318
20181	28767	62	applied	\N	\N	\N	\N	154009	154009	321319
20181	29191	63	applied	\N	\N	\N	\N	154010	154010	321320
20181	29194	64	applied	\N	\N	\N	\N	154011	154011	321321
20181	29195	65	applied	\N	\N	\N	\N	154012	154012	321322
20181	28020	66	applied	\N	\N	1000000000	\N	154013	154013	321323
20181	28547	67	applied	\N	\N	\N	\N	154014	154014	321324
20181	27715	68	applied	\N	\N	\N	\N	154015	154015	321325
20181	28769	70	applied	\N	\N	\N	\N	154017	154017	321327
20181	28022	71	applied	\N	\N	\N	\N	154018	154018	321328
20181	28993	72	applied	\N	\N	\N	\N	154019	154019	321329
20181	27711	73	applied	\N	\N	\N	\N	154020	154020	321330
20181	27714	74	applied	\N	\N	\N	\N	154021	154021	321331
20181	28246	75	applied	\N	\N	\N	\N	154022	154022	321332
20181	28249	76	applied	\N	\N	\N	\N	154023	154023	321333
20181	28290	77	applied	\N	\N	\N	\N	154024	154024	321334
20181	28261	78	applied	\N	\N	\N	\N	154025	154025	321335
20181	28220	79	applied	\N	\N	\N	\N	154026	154026	321336
20181	28023	80	applied	\N	\N	1000000000	\N	154027	154027	321337
20181	28024	81	applied	\N	\N	\N	\N	154028	154028	321338
20181	28994	82	applied	\N	\N	\N	\N	154029	154029	321339
20181	28995	83	applied	\N	\N	\N	\N	154030	154030	321340
20181	28225	84	applied	\N	\N	\N	\N	154031	154031	321341
20181	28229	85	applied	\N	\N	\N	\N	154032	154032	321342
20181	28039	86	applied	\N	\N	\N	\N	154033	154033	321343
20181	28042	87	applied	\N	\N	\N	\N	154034	154034	321344
20181	28058	88	applied	\N	\N	\N	\N	154035	154035	321345
20181	27721	90	applied	\N	\N	\N	\N	154037	154037	321347
20181	28237	91	applied	\N	\N	\N	\N	154038	154038	321348
20181	28238	92	applied	\N	\N	\N	\N	154039	154039	321349
20181	27724	93	applied	\N	\N	\N	\N	154040	154040	321350
20160	29117	2	applied	\N	\N	\N	\N	153674	153674	320986
20160	29118	3	applied	\N	\N	\N	\N	153675	153675	320987
20162	28943	19	applied	\N	\N	\N	\N	153709	153709	321020
20162	28801	20	applied	\N	\N	\N	\N	153710	153710	321021
20162	29115	21	applied	\N	\N	\N	\N	153711	153711	321022
20162	29116	22	applied	\N	\N	\N	\N	153712	153712	321023
20162	29017	23	applied	\N	\N	\N	\N	153713	153713	321024
20162	29018	24	applied	\N	\N	\N	\N	153714	153714	321025
20162	28984	25	applied	\N	\N	\N	\N	153715	153715	321026
20162	28985	26	applied	\N	\N	\N	\N	153716	153716	321027
20162	28889	27	applied	\N	\N	\N	\N	153717	153717	321028
20162	28890	28	applied	\N	\N	\N	\N	153718	153718	321029
20162	28891	29	applied	\N	\N	\N	\N	153719	153719	321030
20162	28892	30	applied	\N	\N	\N	\N	153720	153720	321031
20162	28893	31	applied	\N	\N	\N	\N	153721	153721	321032
20162	28906	32	applied	\N	\N	\N	\N	153722	153722	321033
20162	28945	34	applied	\N	\N	\N	\N	153724	153724	321035
20162	28946	35	applied	\N	\N	\N	\N	153725	153725	321036
20162	28953	36	applied	\N	\N	\N	\N	153726	153726	321037
20162	29117	37	applied	\N	\N	\N	\N	153727	153727	321038
20162	29118	38	applied	\N	\N	\N	\N	153728	153728	321039
20162	28834	39	applied	\N	\N	\N	\N	153729	153729	153729
20162	28793	40	applied	\N	\N	\N	\N	153730	153730	321040
20162	28802	41	applied	\N	\N	\N	\N	153731	153731	321041
20162	28807	42	applied	\N	\N	\N	\N	153732	153732	321042
20162	28808	43	applied	\N	\N	\N	\N	153733	153733	321043
20162	28809	44	applied	\N	\N	\N	\N	153734	153734	321044
20162	28824	45	applied	\N	\N	1000000000	\N	153735	153735	321045
20162	28795	46	applied	\N	\N	\N	\N	153736	153736	321046
20162	28800	47	applied	\N	\N	\N	\N	153737	153737	321047
20162	29019	48	applied	\N	\N	\N	\N	153738	153738	321048
20162	29020	49	applied	\N	\N	\N	\N	153739	153739	321049
20162	29065	51	applied	\N	\N	\N	\N	153741	153741	321051
20162	28817	52	applied	\N	\N	\N	\N	153742	153742	321052
20162	28818	53	applied	\N	\N	\N	\N	153743	153743	321053
20162	28822	54	applied	\N	\N	\N	\N	153744	153744	321054
20162	28823	55	applied	\N	\N	\N	\N	153745	153745	321055
20162	28992	56	applied	\N	\N	\N	\N	153746	153746	321056
20162	28826	57	applied	\N	\N	\N	\N	153747	153747	321057
20162	28827	58	applied	\N	\N	\N	\N	153748	153748	321058
20162	28828	59	applied	\N	\N	\N	\N	153749	153749	321059
20162	28829	60	applied	\N	\N	\N	\N	153750	153750	321060
20162	28830	61	applied	\N	\N	\N	\N	153751	153751	321061
20162	28831	62	applied	\N	\N	\N	\N	153752	153752	321062
20162	28837	63	applied	\N	\N	\N	\N	153753	153753	321063
20162	28838	64	applied	\N	\N	\N	\N	153754	153754	321064
20162	28839	65	applied	\N	\N	\N	\N	153755	153755	321065
20162	28840	66	applied	\N	\N	\N	\N	153756	153756	321066
20162	28842	68	applied	\N	\N	\N	\N	153758	153758	321068
20162	28843	69	applied	\N	\N	\N	\N	153759	153759	321069
20162	28844	70	applied	\N	\N	\N	\N	153760	153760	321070
20162	28845	71	applied	\N	\N	\N	\N	153761	153761	321071
20162	28846	72	applied	\N	\N	\N	\N	153762	153762	321072
20162	28847	73	applied	\N	\N	\N	\N	153763	153763	321073
20162	28848	74	applied	\N	\N	\N	\N	153764	153764	321074
20162	28849	75	applied	\N	\N	\N	\N	153765	153765	321075
20162	28850	76	applied	\N	\N	\N	\N	153766	153766	321076
20162	28851	77	applied	\N	\N	\N	\N	153767	153767	321077
20162	28852	78	applied	\N	\N	\N	\N	153768	153768	321078
20162	28853	79	applied	\N	\N	\N	\N	153769	153769	321079
20162	28854	80	applied	\N	\N	\N	\N	153770	153770	321080
20162	28862	81	applied	\N	\N	\N	\N	153771	153771	321081
20162	28863	82	applied	\N	\N	\N	\N	153772	153772	321082
20162	28864	83	applied	\N	\N	\N	\N	153773	153773	321083
20162	28866	85	applied	\N	\N	\N	\N	153775	153775	321085
20162	28867	86	applied	\N	\N	\N	\N	153776	153776	321086
20162	28868	87	applied	\N	\N	\N	\N	153777	153777	321087
20162	28869	88	applied	\N	\N	\N	\N	153778	153778	321088
20162	28870	89	applied	\N	\N	\N	\N	153779	153779	321089
20162	28875	90	applied	\N	\N	\N	\N	153780	153780	321090
20162	28876	91	applied	\N	\N	\N	\N	153781	153781	321091
20162	28877	92	applied	\N	\N	\N	\N	153782	153782	321092
20162	28878	93	applied	\N	\N	\N	\N	153783	153783	321093
20162	28880	94	applied	\N	\N	\N	\N	153784	153784	321094
20162	28881	95	applied	\N	\N	\N	\N	153785	153785	321095
20162	28882	96	applied	\N	\N	\N	\N	153786	153786	321096
20162	28883	97	applied	\N	\N	\N	\N	153787	153787	321097
20162	28884	98	applied	\N	\N	\N	\N	153788	153788	321098
20162	28894	99	applied	\N	\N	\N	\N	153789	153789	321099
20162	28895	100	applied	\N	\N	\N	\N	153790	153790	321100
20162	28897	102	applied	\N	\N	\N	\N	153792	153792	321102
20162	28898	103	applied	\N	\N	\N	\N	153793	153793	321103
20162	28899	104	applied	\N	\N	\N	\N	153794	153794	321104
20162	28900	105	applied	\N	\N	\N	\N	153795	153795	321105
20162	28901	106	applied	\N	\N	\N	\N	153796	153796	321106
20162	28902	107	applied	\N	\N	\N	\N	153797	153797	321107
20162	28907	108	applied	\N	\N	\N	\N	153798	153798	321108
20162	28908	110	applied	\N	\N	\N	\N	153799	153799	321109
20162	28909	111	applied	\N	\N	\N	\N	153800	153800	321110
20162	28910	112	applied	\N	\N	\N	\N	153801	153801	321111
20162	28911	113	applied	\N	\N	\N	\N	153802	153802	321112
20162	28912	114	applied	\N	\N	\N	\N	153803	153803	321113
20162	28913	115	applied	\N	\N	\N	\N	153804	153804	321114
20162	28914	116	applied	\N	\N	\N	\N	153805	153805	321115
20162	28915	117	applied	\N	\N	\N	\N	153806	153806	321116
20162	28918	118	applied	\N	\N	\N	\N	153807	153807	321117
20162	28804	120	applied	\N	\N	\N	\N	153809	153809	321119
20162	28815	121	applied	\N	\N	\N	\N	153810	153810	321120
20162	28955	122	applied	\N	\N	\N	\N	153811	153811	321121
20162	28956	123	applied	\N	\N	\N	\N	153812	153812	321122
20162	28957	124	applied	\N	\N	\N	\N	153813	153813	321123
20165	29137	0	applied	\N	\N	\N	\N	153840	153840	321150
20165	29138	1	applied	\N	\N	\N	\N	153841	153841	321151
20165	29139	2	applied	\N	\N	\N	\N	153842	153842	321152
20165	29140	3	applied	\N	\N	\N	\N	153843	153843	321153
20165	29141	4	applied	\N	\N	\N	\N	153844	153844	321154
20165	29142	5	applied	\N	\N	\N	\N	153845	153845	321155
20165	29143	6	applied	\N	\N	\N	\N	153846	153846	321156
20165	29144	7	applied	\N	\N	\N	\N	153847	153847	321157
20165	29145	8	applied	\N	\N	\N	\N	153848	153848	321158
20165	29146	9	applied	\N	\N	\N	\N	153849	153849	321159
20165	29147	10	applied	\N	\N	\N	\N	153850	153850	321160
20162	28942	18	applied	\N	\N	\N	\N	153708	153708	321019
20163	29135	11	applied	\N	\N	\N	\N	153825	153825	321135
20163	29136	12	applied	\N	\N	\N	\N	153826	153826	321136
20165	29148	11	applied	\N	\N	\N	\N	153851	153851	321161
20165	29149	12	applied	\N	\N	\N	\N	153852	153852	321162
20165	29150	13	applied	\N	\N	\N	\N	153853	153853	321163
20165	29151	14	applied	\N	\N	\N	\N	153854	153854	321164
20165	29152	15	applied	\N	\N	\N	\N	153855	153855	321165
20165	29153	16	applied	\N	\N	\N	\N	153856	153856	321166
20165	29154	17	applied	\N	\N	\N	\N	153857	153857	321167
20165	29156	19	applied	\N	\N	\N	\N	153859	153859	321169
20165	29157	20	applied	\N	\N	\N	\N	153860	153860	321170
20165	29158	21	applied	\N	\N	\N	\N	153861	153861	321171
20165	29159	22	applied	\N	\N	\N	\N	153862	153862	321172
20165	29160	23	applied	\N	\N	\N	\N	153863	153863	321173
20165	29161	24	applied	\N	\N	\N	\N	153864	153864	321174
20165	29162	25	applied	\N	\N	\N	\N	153865	153865	321175
20166	29163	0	applied	\N	\N	\N	\N	153866	153866	321176
20166	29164	1	applied	\N	\N	\N	\N	153867	153867	321177
20166	29165	2	applied	\N	\N	\N	\N	153868	153868	321178
20166	29166	3	applied	\N	\N	\N	\N	153869	153869	321179
20166	29167	4	applied	\N	\N	\N	\N	153870	153870	321180
20166	29168	5	applied	\N	\N	\N	\N	153871	153871	321181
20169	29169	0	applied	\N	\N	\N	\N	153887	153887	321197
20169	29170	1	applied	\N	\N	\N	\N	153888	153888	321198
20169	29171	2	applied	\N	\N	\N	\N	153889	153889	321199
20169	29173	4	applied	\N	\N	\N	\N	153891	153891	321201
20169	29174	5	applied	\N	\N	\N	\N	153892	153892	321202
20169	29175	6	applied	\N	\N	\N	\N	153893	153893	321203
20169	29176	7	applied	\N	\N	\N	\N	153894	153894	321204
20169	29177	8	applied	\N	\N	\N	\N	153895	153895	321205
20170	29178	0	applied	\N	\N	\N	\N	153896	153896	321206
20170	29179	1	applied	\N	\N	\N	\N	153897	153897	321207
20170	29180	2	applied	\N	\N	\N	\N	153898	153898	321208
20170	29181	3	applied	\N	\N	\N	\N	153899	153899	321209
20170	29182	4	applied	\N	\N	\N	\N	153900	153900	321210
20170	29183	5	applied	\N	\N	1000000000	\N	153901	153901	321211
20171	29184	0	applied	\N	\N	\N	\N	153902	153902	321212
20171	29185	1	applied	\N	\N	\N	\N	153903	153903	321213
20171	29186	2	applied	\N	\N	\N	\N	153904	153904	321214
20176	29198	0	applied	\N	\N	\N	\N	153921	153921	321231
20176	29199	1	applied	\N	\N	\N	\N	153922	153922	321232
20176	29201	3	applied	\N	\N	\N	\N	153924	153924	321234
20176	29202	4	applied	\N	\N	\N	\N	153925	153925	321235
20179	29213	0	applied	\N	\N	\N	\N	153940	153940	321250
20179	29214	1	applied	\N	\N	\N	\N	153941	153941	321251
20179	29215	2	applied	\N	\N	\N	\N	153942	153942	321252
20179	29216	3	applied	\N	\N	\N	\N	153943	153943	321253
20182	29137	0	applied	\N	\N	\N	\N	154046	154046	321356
20182	29138	1	applied	\N	\N	\N	\N	154047	154047	321357
20182	29139	2	applied	\N	\N	\N	\N	154048	154048	321358
20182	29140	3	applied	\N	\N	\N	\N	154049	154049	321359
20182	29141	4	applied	\N	\N	\N	\N	154050	154050	321360
20182	29142	5	applied	\N	\N	\N	\N	154051	154051	321361
20182	29143	6	applied	\N	\N	\N	\N	154052	154052	321362
20182	29144	7	applied	\N	\N	\N	\N	154053	154053	321363
20182	29145	8	applied	\N	\N	\N	\N	154054	154054	321364
20182	29146	9	applied	\N	\N	\N	\N	154055	154055	321365
20182	29148	11	applied	\N	\N	\N	\N	154057	154057	321367
20182	29149	12	applied	\N	\N	\N	\N	154058	154058	321368
20182	29163	13	applied	\N	\N	\N	\N	154059	154059	321369
20182	29169	14	applied	\N	\N	\N	\N	154060	154060	321370
20182	29170	15	applied	\N	\N	\N	\N	154061	154061	321371
20182	29178	16	applied	\N	\N	\N	\N	154062	154062	321372
20182	29190	17	applied	\N	\N	\N	\N	154063	154063	321373
20182	29033	18	applied	\N	\N	\N	\N	154064	154064	321374
20182	29037	19	applied	\N	\N	\N	\N	154065	154065	321375
20182	29038	20	applied	\N	\N	\N	\N	154066	154066	321376
20182	29039	21	applied	\N	\N	\N	\N	154067	154067	321377
20182	29165	22	applied	\N	\N	\N	\N	154068	154068	321378
20182	29173	23	applied	\N	\N	\N	\N	154069	154069	321379
20182	29120	24	applied	\N	\N	\N	\N	154070	154070	321380
20182	29105	25	applied	\N	\N	\N	\N	154071	154071	321381
20182	28819	26	applied	\N	\N	\N	\N	154072	154072	321382
20182	28780	28	applied	\N	\N	\N	\N	154074	154074	321384
20182	28783	29	applied	\N	\N	\N	\N	154075	154075	321385
20182	28812	30	applied	\N	\N	1000000000	\N	154076	154076	321386
20182	29106	31	applied	\N	\N	\N	\N	154077	154077	321387
20182	28781	32	applied	\N	\N	\N	\N	154078	154078	321388
20182	28784	33	applied	\N	\N	\N	\N	154079	154079	321389
20182	29191	34	applied	\N	\N	\N	\N	154080	154080	321390
20182	29194	35	applied	\N	\N	\N	\N	154081	154081	321391
20182	29195	36	applied	\N	\N	\N	\N	154082	154082	321392
20182	28857	37	applied	\N	\N	1000000000	\N	154083	154083	321393
20182	29183	38	applied	\N	\N	1000000000	\N	154084	154084	321394
20182	28993	39	applied	\N	\N	\N	\N	154085	154085	321395
20182	29134	40	applied	\N	\N	\N	\N	154086	154086	321396
20182	29135	41	applied	\N	\N	\N	\N	154087	154087	321397
20182	28858	42	applied	\N	\N	\N	\N	154088	154088	321398
20185	28930	0	applied	\N	\N	\N	\N	154102	154102	321412
20185	29057	2	applied	\N	\N	\N	\N	154104	154104	321414
20185	29058	3	applied	\N	\N	\N	\N	154105	154105	321415
20185	29062	4	applied	\N	\N	\N	\N	154106	154106	321416
20185	29063	5	applied	\N	\N	\N	\N	154107	154107	321417
20185	29015	6	applied	\N	\N	\N	\N	154108	154108	321418
20185	29016	7	applied	\N	\N	\N	\N	154109	154109	321419
20185	29007	8	applied	\N	\N	\N	\N	154110	154110	321420
20185	29021	9	applied	\N	\N	\N	\N	154111	154111	321421
20185	28565	10	applied	\N	\N	\N	\N	154112	154112	321422
20185	28580	11	applied	\N	\N	\N	\N	154113	154113	321423
20185	28585	12	applied	\N	\N	\N	\N	154114	154114	321424
20185	28595	13	applied	\N	\N	\N	\N	154115	154115	321425
20185	29137	14	applied	\N	\N	\N	\N	154116	154116	321426
20185	29138	15	applied	\N	\N	\N	\N	154117	154117	321427
20185	29139	16	applied	\N	\N	\N	\N	154118	154118	321428
20185	29140	17	applied	\N	\N	\N	\N	154119	154119	321429
20185	29142	19	applied	\N	\N	\N	\N	154121	154121	321431
20185	29143	20	applied	\N	\N	\N	\N	154122	154122	321432
20185	29144	21	applied	\N	\N	\N	\N	154123	154123	321433
20185	29145	22	applied	\N	\N	\N	\N	154124	154124	321434
20163	29133	9	applied	\N	\N	\N	\N	153823	153823	321133
20163	29134	10	applied	\N	\N	\N	\N	153824	153824	321134
20174	29196	3	applied	\N	\N	\N	\N	153914	153914	321224
20174	29197	4	applied	\N	\N	\N	\N	153915	153915	321225
20177	29203	0	applied	\N	\N	\N	\N	153926	153926	321236
20177	29204	1	applied	\N	\N	\N	\N	153927	153927	321237
20177	29205	2	applied	\N	\N	\N	\N	153928	153928	321238
20177	29206	3	applied	\N	\N	\N	\N	153929	153929	321239
20177	29207	4	applied	\N	\N	\N	\N	153930	153930	321240
20177	29208	5	applied	\N	\N	\N	\N	153931	153931	321241
20177	29209	6	applied	\N	\N	\N	\N	153932	153932	321242
20177	29210	7	applied	\N	\N	\N	\N	153933	153933	321243
20177	29211	8	applied	\N	\N	\N	\N	153934	153934	321244
20177	29212	9	applied	\N	\N	\N	\N	153935	153935	321245
20181	27726	94	applied	\N	\N	\N	\N	154041	154041	321351
20181	27732	95	applied	\N	\N	\N	\N	154042	154042	321352
20181	29123	96	applied	\N	\N	\N	\N	154043	154043	321353
20181	28071	97	applied	\N	\N	\N	\N	154044	154044	321354
20183	29220	0	applied	\N	\N	\N	\N	154089	154089	321399
20183	29221	1	applied	\N	\N	\N	\N	154090	154090	321400
20183	29222	2	applied	\N	\N	\N	\N	154091	154091	321401
20183	29223	3	applied	\N	\N	\N	\N	154092	154092	321402
20183	29224	4	applied	\N	\N	\N	\N	154093	154093	321403
20183	29225	5	applied	\N	\N	\N	\N	154094	154094	321404
20183	29226	6	applied	\N	\N	\N	\N	154095	154095	321405
20183	29227	7	applied	\N	\N	\N	\N	154096	154096	321406
20183	29228	8	applied	\N	\N	\N	\N	154097	154097	321407
20183	29229	9	applied	\N	\N	\N	\N	154098	154098	321408
20186	29233	0	applied	\N	\N	\N	\N	154226	154226	321534
20186	29234	1	applied	\N	\N	\N	\N	154227	154227	321535
20186	29235	2	applied	\N	\N	\N	\N	154228	154228	321536
20186	29236	3	applied	\N	\N	\N	\N	154229	154229	321537
20186	29237	4	applied	\N	\N	\N	\N	154230	154230	321538
20186	29238	5	applied	\N	\N	\N	\N	154231	154231	321539
20186	29240	7	applied	\N	\N	\N	\N	154233	154233	321541
20189	29243	0	applied	\N	\N	\N	\N	154242	154242	321550
20189	29244	1	applied	\N	\N	\N	\N	154243	154243	321551
20189	29245	2	applied	\N	\N	\N	\N	154244	154244	321552
20192	29259	0	applied	\N	\N	\N	\N	154258	154258	321566
20192	29260	1	applied	\N	\N	\N	\N	154259	154259	321567
20192	29261	2	applied	\N	\N	\N	\N	154260	154260	321568
20192	29262	3	applied	\N	\N	\N	\N	154261	154261	321569
20195	29268	0	applied	\N	\N	\N	\N	154273	154273	321581
20195	29269	1	applied	\N	\N	\N	\N	154274	154274	321582
20195	29270	2	applied	\N	\N	\N	\N	154275	154275	321583
20195	29271	3	applied	\N	\N	\N	\N	154276	154276	321584
20195	29272	4	applied	\N	\N	\N	\N	154277	154277	321585
20195	29273	5	applied	\N	\N	\N	\N	154278	154278	321586
20197	29274	0	applied	\N	\N	\N	\N	154285	154285	321593
20197	29275	1	applied	\N	\N	\N	\N	154286	154286	321594
20197	29277	3	applied	\N	\N	\N	\N	154288	154288	321596
20202	29289	0	applied	\N	\N	\N	\N	154307	154307	321615
20202	29290	1	applied	\N	\N	\N	\N	154308	154308	321616
20202	29291	2	applied	\N	\N	\N	\N	154309	154309	321617
20204	29292	0	applied	\N	\N	\N	\N	154313	154313	321621
20204	29293	1	applied	\N	\N	\N	\N	154314	154314	321622
20204	29294	2	applied	\N	\N	\N	\N	154315	154315	321623
20209	29298	0	applied	\N	\N	\N	\N	154400	154400	321708
20209	29299	1	applied	\N	\N	\N	\N	154401	154401	321709
20209	29300	2	applied	\N	\N	\N	\N	154402	154402	321710
20212	29295	0	applied	\N	\N	\N	\N	154409	154409	321717
20212	29298	1	applied	\N	\N	\N	\N	154410	154410	321718
20212	29296	2	applied	\N	\N	\N	\N	154411	154411	321719
20212	29299	3	applied	\N	\N	\N	\N	154412	154412	321720
20212	29300	4	applied	\N	\N	\N	\N	154413	154413	321721
20212	29297	5	applied	\N	\N	\N	\N	154414	154414	321722
20214	29310	1	applied	\N	\N	\N	\N	154424	154424	321732
20214	29311	2	applied	\N	\N	\N	\N	154425	154425	321733
20219	29312	0	applied	\N	\N	\N	\N	154452	154452	321760
20219	29313	1	applied	\N	\N	\N	\N	154453	154453	321761
20219	29314	2	applied	\N	\N	\N	\N	154454	154454	321762
20219	29315	3	applied	\N	\N	\N	\N	154455	154455	321763
20219	29316	4	applied	\N	\N	\N	\N	154456	154456	321764
20219	29317	5	applied	\N	\N	\N	\N	154457	154457	321765
20219	29318	6	applied	\N	\N	\N	\N	154458	154458	321766
20222	29319	0	applied	\N	\N	\N	\N	154479	154479	321787
20222	29320	1	applied	\N	\N	\N	\N	154480	154480	321788
20222	29321	2	applied	\N	\N	\N	\N	154481	154481	321789
20222	29322	3	applied	\N	\N	\N	\N	154482	154482	321790
20222	29323	4	applied	\N	\N	\N	\N	154483	154483	321791
20222	29324	5	applied	\N	\N	\N	\N	154484	154484	321792
20222	29315	6	applied	\N	\N	\N	\N	154485	154485	321793
20222	29325	8	applied	\N	\N	\N	\N	154487	154487	321795
20222	29326	9	applied	\N	\N	\N	\N	154488	154488	321796
20226	29327	0	applied	\N	\N	\N	\N	154505	154505	321813
20226	29328	1	applied	\N	\N	\N	\N	154506	154506	321814
20226	29329	2	applied	\N	\N	\N	\N	154507	154507	321815
20234	29349	0	applied	\N	\N	\N	\N	154540	154540	321848
20234	29350	1	applied	\N	\N	\N	\N	154541	154541	321849
20234	29351	2	applied	\N	\N	\N	\N	154542	154542	321850
20234	29352	3	applied	\N	\N	\N	\N	154543	154543	321851
20237	29354	0	applied	\N	\N	\N	\N	154601	154601	321909
20237	29355	1	applied	\N	\N	\N	\N	154602	154602	321910
20237	29356	2	applied	\N	\N	\N	\N	154603	154603	321911
20240	29360	0	applied	\N	\N	\N	\N	154611	154611	321919
20240	29361	1	applied	\N	\N	\N	\N	154612	154612	321920
20240	29362	2	applied	\N	\N	\N	\N	154613	154613	321921
20240	29363	3	applied	\N	\N	\N	\N	154614	154614	321922
20242	29365	1	applied	\N	\N	\N	\N	154620	154620	321928
20242	29366	2	applied	\N	\N	\N	\N	154621	154621	321929
20242	29367	3	applied	\N	\N	\N	\N	154622	154622	321930
20242	29368	4	applied	\N	\N	\N	\N	154623	154623	321931
20242	29369	5	applied	\N	\N	\N	\N	154624	154624	321932
20242	29370	6	applied	\N	\N	\N	\N	154625	154625	321933
20245	29382	0	applied	\N	\N	\N	\N	154637	154637	321945
20245	29383	1	applied	\N	\N	\N	\N	154638	154638	321946
20245	29384	2	applied	\N	\N	\N	\N	154639	154639	321947
20245	29385	3	applied	\N	\N	\N	\N	154640	154640	321948
20245	29386	4	applied	\N	\N	\N	\N	154641	154641	321949
20245	29387	5	applied	\N	\N	\N	\N	154642	154642	321950
20252	29410	0	applied	\N	\N	\N	\N	154681	154681	321989
20252	29411	1	applied	\N	\N	\N	\N	154682	154682	321990
20174	29193	0	applied	\N	\N	\N	\N	153911	153911	321221
20174	29194	1	applied	\N	\N	\N	\N	153912	153912	321222
20185	28971	27	applied	\N	\N	\N	\N	154129	154129	321438
20185	28972	28	applied	\N	\N	\N	\N	154130	154130	321439
20185	28990	29	applied	\N	\N	\N	\N	154131	154131	321440
20185	28887	30	applied	\N	\N	\N	\N	154132	154132	321441
20185	28581	31	applied	\N	\N	\N	\N	154133	154133	321442
20185	28983	32	applied	\N	\N	\N	\N	154134	154134	321443
20185	29100	33	applied	\N	\N	\N	\N	154135	154135	321444
20185	28942	34	applied	\N	\N	\N	\N	154136	154136	321445
20185	28943	36	applied	\N	\N	\N	\N	154137	154137	321446
20185	28675	37	applied	\N	\N	\N	\N	154138	154138	321447
20185	28801	38	applied	\N	\N	\N	\N	154139	154139	321448
20185	29115	39	applied	\N	\N	\N	\N	154140	154140	321449
20185	29116	40	applied	\N	\N	\N	\N	154141	154141	321450
20185	29017	41	applied	\N	\N	\N	\N	154142	154142	321451
20185	29018	42	applied	\N	\N	\N	\N	154143	154143	321452
20185	29163	43	applied	\N	\N	\N	\N	154144	154144	321453
20185	28985	45	applied	\N	\N	\N	\N	154146	154146	321455
20185	28889	46	applied	\N	\N	\N	\N	154147	154147	321456
20186	29241	8	applied	\N	\N	\N	\N	154234	154234	321542
20186	29242	9	applied	\N	\N	\N	\N	154235	154235	321543
20191	29250	0	applied	\N	\N	\N	\N	154249	154249	321557
20191	29251	1	applied	\N	\N	\N	\N	154250	154250	321558
20191	29252	2	applied	\N	\N	\N	\N	154251	154251	321559
20191	29253	3	applied	\N	\N	\N	\N	154252	154252	321560
20191	29254	4	applied	\N	\N	\N	\N	154253	154253	321561
20191	29255	5	applied	\N	\N	\N	\N	154254	154254	321562
20191	29256	6	applied	\N	\N	\N	\N	154255	154255	321563
20191	29257	7	applied	\N	\N	\N	\N	154256	154256	321564
20191	29258	8	applied	\N	\N	\N	\N	154257	154257	321565
20194	29268	0	applied	\N	\N	\N	\N	154267	154267	321575
20194	29269	1	applied	\N	\N	\N	\N	154268	154268	321576
20194	29270	2	applied	\N	\N	\N	\N	154269	154269	321577
20194	29272	4	applied	\N	\N	\N	\N	154271	154271	321579
20194	29273	5	applied	\N	\N	\N	\N	154272	154272	321580
20199	29278	0	applied	\N	\N	\N	\N	154293	154293	321601
20199	29279	1	applied	\N	\N	\N	\N	154294	154294	321602
20199	29280	2	applied	\N	\N	\N	\N	154295	154295	321603
20199	29281	3	applied	\N	\N	\N	\N	154296	154296	321604
20199	29282	4	applied	\N	\N	\N	\N	154297	154297	321605
20199	29283	5	applied	\N	\N	\N	\N	154298	154298	321606
20199	29284	6	applied	\N	\N	\N	\N	154299	154299	321607
20199	29285	7	applied	\N	\N	\N	\N	154300	154300	321608
20208	29298	0	applied	\N	\N	\N	\N	154397	154397	321705
20208	29299	1	applied	\N	\N	\N	\N	154398	154398	321706
20208	29300	2	applied	\N	\N	\N	\N	154399	154399	321707
20217	29312	0	applied	\N	\N	\N	\N	154440	154440	321748
20217	29313	1	applied	\N	\N	\N	\N	154441	154441	321749
20217	29314	2	applied	\N	\N	\N	\N	154442	154442	321750
20217	29317	4	applied	\N	\N	\N	\N	154444	154444	321752
20221	29319	0	applied	\N	\N	\N	\N	154469	154469	321777
20221	29320	1	applied	\N	\N	\N	\N	154470	154470	321778
20221	29321	2	applied	\N	\N	\N	\N	154471	154471	321779
20221	29322	3	applied	\N	\N	\N	\N	154472	154472	321780
20221	29323	4	applied	\N	\N	\N	\N	154473	154473	321781
20221	29324	5	applied	\N	\N	\N	\N	154474	154474	321782
20221	29315	6	applied	\N	\N	\N	\N	154475	154475	321783
20221	29318	7	applied	\N	\N	\N	\N	154476	154476	321784
20221	29325	8	applied	\N	\N	\N	\N	154477	154477	321785
20221	29326	9	applied	\N	\N	\N	\N	154478	154478	321786
20231	29340	0	applied	\N	\N	\N	\N	154527	154527	321835
20231	29341	1	applied	\N	\N	\N	\N	154528	154528	321836
20231	29342	2	applied	\N	\N	\N	\N	154529	154529	321837
20233	29349	0	applied	\N	\N	\N	\N	154536	154536	321844
20233	29350	1	applied	\N	\N	\N	\N	154537	154537	321845
20233	29352	3	applied	\N	\N	\N	\N	154539	154539	321847
20236	29301	0	applied	\N	\N	\N	\N	154548	154548	321856
20236	29344	1	applied	\N	\N	\N	\N	154549	154549	321857
20236	29345	2	applied	\N	\N	\N	\N	154550	154550	321858
20236	29346	3	applied	\N	\N	\N	\N	154551	154551	321859
20236	29302	4	applied	\N	\N	\N	\N	154552	154552	321860
20236	29309	5	applied	\N	\N	\N	\N	154553	154553	321861
20236	29312	6	applied	\N	\N	\N	\N	154554	154554	321862
20236	29353	7	applied	\N	\N	\N	\N	154555	154555	321863
20236	29313	8	applied	\N	\N	\N	\N	154556	154556	321864
20236	29319	9	applied	\N	\N	\N	\N	154557	154557	321865
20236	29320	10	applied	\N	\N	\N	\N	154558	154558	321866
20236	29321	11	applied	\N	\N	\N	\N	154559	154559	321867
20236	29327	12	applied	\N	\N	\N	\N	154560	154560	321868
20236	29330	13	applied	\N	\N	\N	\N	154561	154561	321869
20236	29331	14	applied	\N	\N	\N	\N	154562	154562	321870
20236	29340	16	applied	\N	\N	\N	\N	154564	154564	321872
20236	29343	17	applied	\N	\N	\N	\N	154565	154565	321873
20236	29349	18	applied	\N	\N	\N	\N	154566	154566	321874
20236	29303	19	applied	\N	\N	\N	\N	154567	154567	321875
20236	29304	20	applied	\N	\N	\N	\N	154568	154568	321876
20236	29305	21	applied	\N	\N	\N	\N	154569	154569	321877
20236	29306	22	applied	\N	\N	\N	\N	154570	154570	321878
20236	29311	23	applied	\N	\N	\N	\N	154571	154571	321879
20236	29315	24	applied	\N	\N	\N	\N	154572	154572	321880
20236	29307	25	applied	\N	\N	\N	\N	154573	154573	321881
20236	29314	26	applied	\N	\N	\N	\N	154574	154574	321882
20236	29328	27	applied	\N	\N	\N	\N	154575	154575	321883
20236	29339	28	applied	\N	\N	\N	\N	154576	154576	321884
20236	29352	29	applied	\N	\N	\N	\N	154577	154577	321885
20236	29318	30	applied	\N	\N	\N	\N	154578	154578	321886
20236	29325	31	applied	\N	\N	\N	\N	154579	154579	321887
20236	29329	33	applied	\N	\N	\N	\N	154581	154581	321889
20236	29334	34	applied	\N	\N	\N	\N	154582	154582	321890
20236	29335	35	applied	\N	\N	\N	\N	154583	154583	321891
20236	29337	36	applied	\N	\N	\N	\N	154584	154584	321892
20236	29341	38	applied	\N	\N	\N	\N	154585	154585	321893
20236	29347	39	applied	\N	\N	\N	\N	154586	154586	321894
20236	29350	40	applied	\N	\N	\N	\N	154587	154587	321895
20236	29308	41	applied	\N	\N	\N	\N	154588	154588	321896
20236	29310	42	applied	\N	\N	\N	\N	154589	154589	321897
20236	29316	43	applied	\N	\N	\N	\N	154590	154590	321898
20236	29317	44	applied	\N	\N	\N	\N	154591	154591	321899
20236	29322	45	applied	\N	\N	\N	\N	154592	154592	321900
20236	29323	46	applied	\N	\N	\N	\N	154593	154593	321901
20236	29324	47	applied	\N	\N	\N	\N	154594	154594	321902
20185	29147	24	applied	\N	\N	\N	\N	154126	154126	321436
20185	28814	25	applied	\N	\N	\N	\N	154127	154127	154127
20185	28893	50	applied	\N	\N	\N	\N	154151	154151	321460
20185	28906	51	applied	\N	\N	\N	\N	154152	154152	321461
20185	28591	52	applied	\N	\N	\N	\N	154153	154153	321462
20185	28545	53	applied	\N	\N	1000000000	\N	154154	154154	321463
20185	28558	54	applied	\N	\N	\N	\N	154155	154155	321464
20185	28944	55	applied	\N	\N	\N	\N	154156	154156	321465
20185	28945	56	applied	\N	\N	\N	\N	154157	154157	321466
20185	28946	57	applied	\N	\N	\N	\N	154158	154158	321467
20185	28953	58	applied	\N	\N	\N	\N	154159	154159	321468
20185	29117	59	applied	\N	\N	\N	\N	154160	154160	321469
20185	29118	60	applied	\N	\N	\N	\N	154161	154161	321470
20185	28834	61	applied	\N	\N	\N	\N	154162	154162	154162
20185	28793	62	applied	\N	\N	\N	\N	154163	154163	321471
20185	29178	64	applied	\N	\N	\N	\N	154165	154165	321473
20185	29190	65	applied	\N	\N	\N	\N	154166	154166	321474
20185	28802	66	applied	\N	\N	\N	\N	154167	154167	321475
20185	28807	67	applied	\N	\N	\N	\N	154168	154168	321476
20185	28808	68	applied	\N	\N	\N	\N	154169	154169	321477
20185	28809	69	applied	\N	\N	\N	\N	154170	154170	321478
20185	28824	70	applied	\N	\N	1000000000	\N	154171	154171	321479
20185	28795	71	applied	\N	\N	\N	\N	154172	154172	321480
20185	28800	72	applied	\N	\N	\N	\N	154173	154173	321481
20185	28447	73	applied	\N	\N	\N	\N	154174	154174	321482
20185	28448	74	applied	\N	\N	\N	\N	154175	154175	321483
20185	29019	75	applied	\N	\N	\N	\N	154176	154176	321484
20185	28356	76	applied	\N	\N	\N	\N	154177	154177	321485
20185	28357	77	applied	\N	\N	\N	\N	154178	154178	321486
20185	28358	78	applied	\N	\N	\N	\N	154179	154179	321487
20185	28367	79	applied	\N	\N	\N	\N	154180	154180	321488
20185	28377	81	applied	\N	\N	\N	\N	154182	154182	321490
20185	28380	82	applied	\N	\N	\N	\N	154183	154183	321491
20185	28384	83	applied	\N	\N	\N	\N	154184	154184	321492
20185	28388	84	applied	\N	\N	\N	\N	154185	154185	321493
20185	28450	85	applied	\N	\N	\N	\N	154186	154186	321494
20185	28451	86	applied	\N	\N	\N	\N	154187	154187	321495
20185	28817	87	applied	\N	\N	\N	\N	154188	154188	321496
20185	28818	88	applied	\N	\N	\N	\N	154189	154189	321497
20185	28822	89	applied	\N	\N	\N	\N	154190	154190	321498
20185	28823	90	applied	\N	\N	\N	\N	154191	154191	321499
20185	28592	91	applied	\N	\N	\N	\N	154192	154192	321500
20185	28596	92	applied	\N	\N	\N	\N	154193	154193	321501
20185	28992	93	applied	\N	\N	\N	\N	154194	154194	321502
20185	28394	94	applied	\N	\N	\N	\N	154195	154195	321503
20185	28395	95	applied	\N	\N	\N	\N	154196	154196	321504
20185	28400	96	applied	\N	\N	\N	\N	154197	154197	321505
20185	28409	98	applied	\N	\N	\N	\N	154199	154199	321507
20185	28826	99	applied	\N	\N	\N	\N	154200	154200	321508
20185	28827	100	applied	\N	\N	\N	\N	154201	154201	321509
20185	28828	101	applied	\N	\N	\N	\N	154202	154202	321510
20185	28829	102	applied	\N	\N	\N	\N	154203	154203	321511
20185	28830	103	applied	\N	\N	\N	\N	154204	154204	321512
20185	28831	104	applied	\N	\N	\N	\N	154205	154205	321513
20185	28837	105	applied	\N	\N	\N	\N	154206	154206	321514
20185	28838	106	applied	\N	\N	\N	\N	154207	154207	321515
20185	28839	107	applied	\N	\N	\N	\N	154208	154208	321516
20185	28840	108	applied	\N	\N	\N	\N	154209	154209	321517
20185	28841	109	applied	\N	\N	\N	\N	154210	154210	321518
20185	28842	110	applied	\N	\N	\N	\N	154211	154211	321519
20185	28843	111	applied	\N	\N	\N	\N	154212	154212	321520
20185	28844	112	applied	\N	\N	\N	\N	154213	154213	321521
20185	28845	113	applied	\N	\N	\N	\N	154214	154214	321522
20185	28847	115	applied	\N	\N	\N	\N	154216	154216	321524
20185	28848	116	applied	\N	\N	\N	\N	154217	154217	321525
20185	28849	117	applied	\N	\N	\N	\N	154218	154218	321526
20185	28850	118	applied	\N	\N	\N	\N	154219	154219	321527
20185	28851	119	applied	\N	\N	\N	\N	154220	154220	321528
20185	28852	120	applied	\N	\N	\N	\N	154221	154221	321529
20185	28853	121	applied	\N	\N	\N	\N	154222	154222	321530
20185	28854	122	applied	\N	\N	\N	\N	154223	154223	321531
20185	28862	123	applied	\N	\N	\N	\N	154224	154224	321532
20185	28863	124	applied	\N	\N	\N	\N	154225	154225	321533
20188	29243	0	applied	\N	\N	\N	\N	154239	154239	321547
20188	29244	1	applied	\N	\N	\N	\N	154240	154240	321548
20188	29245	2	applied	\N	\N	\N	\N	154241	154241	321549
20190	29246	0	applied	\N	\N	\N	\N	154245	154245	321553
20190	29247	1	applied	\N	\N	\N	\N	154246	154246	321554
20190	29248	2	applied	\N	\N	\N	\N	154247	154247	321555
20201	29286	0	applied	\N	\N	\N	\N	154304	154304	321612
20201	29287	1	applied	\N	\N	\N	\N	154305	154305	321613
20201	29288	2	applied	\N	\N	\N	\N	154306	154306	321614
20203	29292	0	applied	\N	\N	\N	\N	154310	154310	321618
20203	29293	1	applied	\N	\N	\N	\N	154311	154311	321619
20203	29294	2	applied	\N	\N	\N	\N	154312	154312	321620
20206	29220	0	applied	\N	\N	\N	\N	154319	154319	321627
20206	29269	1	applied	\N	\N	\N	\N	154320	154320	321628
20206	29270	2	applied	\N	\N	\N	\N	154321	154321	321629
20206	29275	3	applied	\N	\N	\N	\N	154322	154322	321630
20206	29278	4	applied	\N	\N	\N	\N	154323	154323	321631
20206	29221	5	applied	\N	\N	\N	\N	154324	154324	321632
20206	29222	6	applied	\N	\N	\N	\N	154325	154325	321633
20206	29230	7	applied	\N	\N	\N	\N	154326	154326	321634
20206	29233	8	applied	\N	\N	\N	\N	154327	154327	321635
20206	29234	9	applied	\N	\N	\N	\N	154328	154328	321636
20206	29243	11	applied	\N	\N	\N	\N	154330	154330	321638
20206	29246	12	applied	\N	\N	\N	\N	154331	154331	321639
20206	29250	13	applied	\N	\N	\N	\N	154332	154332	321640
20206	29251	14	applied	\N	\N	\N	\N	154333	154333	321641
20206	29252	15	applied	\N	\N	\N	\N	154334	154334	321642
20206	29259	16	applied	\N	\N	\N	\N	154335	154335	321643
20206	29263	17	applied	\N	\N	\N	\N	154336	154336	321644
20206	29264	18	applied	\N	\N	\N	\N	154337	154337	321645
20206	29268	19	applied	\N	\N	\N	\N	154338	154338	321646
20206	29274	20	applied	\N	\N	\N	\N	154339	154339	321647
20206	29279	21	applied	\N	\N	\N	\N	154340	154340	321648
20206	29280	22	applied	\N	\N	\N	\N	154341	154341	321649
20206	29286	23	applied	\N	\N	\N	\N	154342	154342	321650
20206	29289	24	applied	\N	\N	\N	\N	154343	154343	321651
20206	29292	25	applied	\N	\N	\N	\N	154344	154344	321652
20206	29223	26	applied	\N	\N	\N	\N	154345	154345	321653
20185	28891	48	applied	\N	\N	\N	\N	154149	154149	321458
20185	28892	49	applied	\N	\N	\N	\N	154150	154150	321459
20206	29248	32	applied	\N	\N	\N	\N	154351	154351	321659
20206	29261	33	applied	\N	\N	\N	\N	154352	154352	321660
20206	29271	34	applied	\N	\N	\N	\N	154353	154353	321661
20206	29228	35	applied	\N	\N	\N	\N	154354	154354	321662
20206	29229	36	applied	\N	\N	\N	\N	154355	154355	321663
20206	29231	37	applied	\N	\N	\N	\N	154356	154356	321664
20206	29236	38	applied	\N	\N	\N	\N	154357	154357	321665
20206	29237	39	applied	\N	\N	\N	\N	154358	154358	321666
20206	29238	40	applied	\N	\N	\N	\N	154359	154359	321667
20206	29244	41	applied	\N	\N	\N	\N	154360	154360	321668
20206	29247	42	applied	\N	\N	\N	\N	154361	154361	321669
20206	29253	43	applied	\N	\N	\N	\N	154362	154362	321670
20206	29257	44	applied	\N	\N	\N	\N	154363	154363	321671
20206	29258	45	applied	\N	\N	\N	\N	154364	154364	321672
20206	29262	46	applied	\N	\N	\N	\N	154365	154365	321673
20206	29265	47	applied	\N	\N	\N	\N	154366	154366	321674
20206	29272	49	applied	\N	\N	\N	\N	154368	154368	321676
20206	29276	50	applied	\N	\N	\N	\N	154369	154369	321677
20206	29281	51	applied	\N	\N	\N	\N	154370	154370	321678
20206	29282	52	applied	\N	\N	\N	\N	154371	154371	321679
20206	29287	53	applied	\N	\N	\N	\N	154372	154372	321680
20206	29291	54	applied	\N	\N	\N	\N	154373	154373	321681
20206	29232	55	applied	\N	\N	\N	\N	154374	154374	321682
20206	29239	56	applied	\N	\N	\N	\N	154375	154375	321683
20206	29240	57	applied	\N	\N	\N	\N	154376	154376	321684
20206	29241	58	applied	\N	\N	\N	\N	154377	154377	321685
20206	29245	59	applied	\N	\N	\N	\N	154378	154378	321686
20206	29249	60	applied	\N	\N	\N	\N	154379	154379	321687
20206	29254	61	applied	\N	\N	\N	\N	154380	154380	321688
20206	29255	62	applied	\N	\N	\N	\N	154381	154381	321689
20206	29256	63	applied	\N	\N	\N	\N	154382	154382	321690
20206	29260	64	applied	\N	\N	\N	\N	154383	154383	321691
20206	29273	66	applied	\N	\N	\N	\N	154385	154385	321693
20206	29277	67	applied	\N	\N	\N	\N	154386	154386	321694
20206	29283	68	applied	\N	\N	\N	\N	154387	154387	321695
20206	29284	69	applied	\N	\N	\N	\N	154388	154388	321696
20206	29288	70	applied	\N	\N	\N	\N	154389	154389	321697
20206	29290	71	applied	\N	\N	\N	\N	154390	154390	321698
20206	29293	72	applied	\N	\N	\N	\N	154391	154391	321699
20206	29285	73	applied	\N	\N	\N	\N	154392	154392	321700
20206	29294	74	applied	\N	\N	\N	\N	154393	154393	321701
20211	29298	0	applied	\N	\N	\N	\N	154406	154406	321714
20211	29299	1	applied	\N	\N	\N	\N	154407	154407	321715
20211	29300	2	applied	\N	\N	\N	\N	154408	154408	321716
20213	29301	0	applied	\N	\N	\N	\N	154415	154415	321723
20213	29302	1	applied	\N	\N	\N	\N	154416	154416	321724
20213	29303	2	applied	\N	\N	\N	\N	154417	154417	321725
20213	29304	3	applied	\N	\N	\N	\N	154418	154418	321726
20213	29306	5	applied	\N	\N	\N	\N	154420	154420	321728
20213	29307	6	applied	\N	\N	\N	\N	154421	154421	321729
20213	29308	7	applied	\N	\N	\N	\N	154422	154422	321730
20216	29312	0	applied	\N	\N	\N	\N	154433	154433	321741
20216	29313	1	applied	\N	\N	\N	\N	154434	154434	321742
20216	29314	2	applied	\N	\N	\N	\N	154435	154435	321743
20216	29315	3	applied	\N	\N	\N	\N	154436	154436	321744
20216	29316	4	applied	\N	\N	\N	\N	154437	154437	321745
20216	29317	5	applied	\N	\N	\N	\N	154438	154438	321746
20216	29318	6	applied	\N	\N	\N	\N	154439	154439	321747
20220	29319	0	applied	\N	\N	\N	\N	154459	154459	321767
20220	29320	1	applied	\N	\N	\N	\N	154460	154460	321768
20220	29321	2	applied	\N	\N	\N	\N	154461	154461	321769
20220	29322	3	applied	\N	\N	\N	\N	154462	154462	321770
20220	29323	4	applied	\N	\N	\N	\N	154463	154463	321771
20220	29324	5	applied	\N	\N	\N	\N	154464	154464	321772
20220	29318	7	applied	\N	\N	\N	\N	154466	154466	321774
20220	29325	8	applied	\N	\N	\N	\N	154467	154467	321775
20220	29326	9	applied	\N	\N	\N	\N	154468	154468	321776
20225	29327	0	applied	\N	\N	\N	\N	154502	154502	321810
20225	29328	1	applied	\N	\N	\N	\N	154503	154503	321811
20225	29329	2	applied	\N	\N	\N	\N	154504	154504	321812
20228	29330	0	applied	\N	\N	\N	\N	154514	154514	321822
20228	29331	1	applied	\N	\N	\N	\N	154515	154515	321823
20228	29332	2	applied	\N	\N	\N	\N	154516	154516	321824
20228	29333	3	applied	\N	\N	\N	\N	154517	154517	321825
20228	29334	4	applied	\N	\N	\N	\N	154518	154518	321826
20228	29335	5	applied	\N	\N	\N	\N	154519	154519	321827
20230	29340	0	applied	\N	\N	\N	\N	154524	154524	321832
20230	29341	1	applied	\N	\N	\N	\N	154525	154525	321833
20230	29342	2	applied	\N	\N	\N	\N	154526	154526	321834
20232	29343	0	applied	\N	\N	\N	\N	154530	154530	321838
20232	29345	2	applied	\N	\N	\N	\N	154532	154532	321840
20232	29346	3	applied	\N	\N	\N	\N	154533	154533	321841
20232	29347	4	applied	\N	\N	\N	\N	154534	154534	321842
20232	29348	5	applied	\N	\N	\N	\N	154535	154535	321843
20235	29350	1	applied	\N	\N	\N	\N	154545	154545	321853
20235	29351	2	applied	\N	\N	\N	\N	154546	154546	321854
20235	29352	3	applied	\N	\N	\N	\N	154547	154547	321855
20238	29357	0	applied	\N	\N	\N	\N	154604	154604	321912
20238	29358	1	applied	\N	\N	\N	\N	154605	154605	321913
20238	29359	2	applied	\N	\N	\N	\N	154606	154606	321914
20241	29360	0	applied	\N	\N	\N	\N	154615	154615	321923
20241	29361	1	applied	\N	\N	\N	\N	154616	154616	321924
20241	29362	2	applied	\N	\N	\N	\N	154617	154617	321925
20241	29363	3	applied	\N	\N	\N	\N	154618	154618	321926
20243	29371	0	applied	\N	\N	\N	\N	154626	154626	321934
20243	29372	1	applied	\N	\N	\N	\N	154627	154627	321935
20246	29388	0	applied	\N	\N	\N	\N	154643	154643	321951
20246	29389	1	applied	\N	\N	\N	\N	154644	154644	321952
20246	29390	2	applied	\N	\N	\N	\N	154645	154645	321953
20246	29391	3	applied	\N	\N	\N	\N	154646	154646	321954
20246	29392	4	applied	\N	\N	\N	\N	154647	154647	321955
20246	29393	5	applied	\N	\N	\N	\N	154648	154648	321956
20246	29394	6	applied	\N	\N	\N	\N	154649	154649	321957
20247	29395	0	applied	\N	\N	\N	\N	154650	154650	321958
20247	29396	1	applied	\N	\N	\N	\N	154651	154651	321959
20247	29397	2	applied	\N	\N	\N	\N	154652	154652	321960
20247	29398	3	applied	\N	\N	\N	\N	154653	154653	321961
20247	29399	4	applied	\N	\N	\N	\N	154654	154654	321962
20247	29400	5	applied	\N	\N	\N	\N	154655	154655	321963
20248	29395	0	applied	\N	\N	\N	\N	154659	154659	321967
20206	29226	29	applied	\N	\N	\N	\N	154348	154348	321656
20206	29227	30	applied	\N	\N	\N	\N	154349	154349	321657
20236	29348	52	applied	\N	\N	\N	\N	154599	154599	321907
20236	29351	53	applied	\N	\N	\N	\N	154600	154600	321908
20239	29360	0	applied	\N	\N	\N	\N	154607	154607	321915
20239	29361	1	applied	\N	\N	\N	\N	154608	154608	321916
20239	29362	2	applied	\N	\N	\N	\N	154609	154609	321917
20239	29363	3	applied	\N	\N	\N	\N	154610	154610	321918
20244	29374	0	applied	\N	\N	\N	\N	154629	154629	321937
20244	29375	1	applied	\N	\N	\N	\N	154630	154630	321938
20244	29376	2	applied	\N	\N	\N	\N	154631	154631	321939
20244	29377	3	applied	\N	\N	\N	\N	154632	154632	321940
20244	29378	4	applied	\N	\N	\N	\N	154633	154633	321941
20244	29379	5	applied	\N	\N	\N	\N	154634	154634	321942
20244	29380	6	applied	\N	\N	\N	\N	154635	154635	321943
20244	29381	7	applied	\N	\N	\N	\N	154636	154636	321944
20247	29401	6	applied	\N	\N	\N	\N	154656	154656	321964
20247	29402	7	applied	\N	\N	\N	\N	154657	154657	321965
20249	29404	0	applied	\N	\N	\N	\N	154668	154668	321976
20249	29405	1	applied	\N	\N	\N	\N	154669	154669	321977
20249	29406	2	applied	\N	\N	\N	\N	154670	154670	321978
20251	29410	0	applied	\N	\N	\N	\N	154674	154674	321982
20251	29411	1	applied	\N	\N	\N	\N	154675	154675	321983
20251	29412	2	applied	\N	\N	\N	\N	154676	154676	321984
20251	29413	3	applied	\N	\N	\N	\N	154677	154677	321985
20251	29414	4	applied	\N	\N	\N	\N	154678	154678	321986
20253	29417	0	applied	\N	\N	\N	\N	154688	154688	321996
20253	29418	1	applied	\N	\N	\N	\N	154689	154689	321997
20253	29419	2	applied	\N	\N	\N	\N	154690	154690	321998
20253	29420	3	applied	\N	\N	\N	\N	154691	154691	321999
20253	29421	4	applied	\N	\N	\N	\N	154692	154692	322000
20253	29422	5	applied	\N	\N	\N	\N	154693	154693	322001
20253	29423	6	applied	\N	\N	\N	\N	154694	154694	322002
20253	29424	7	applied	\N	\N	\N	\N	154695	154695	322003
20253	29426	9	applied	\N	\N	\N	\N	154697	154697	322005
20253	29427	10	applied	\N	\N	\N	\N	154698	154698	322006
20253	29428	11	applied	\N	\N	\N	\N	154699	154699	322007
20253	29429	12	applied	\N	\N	\N	\N	154700	154700	322008
20255	29430	0	applied	\N	\N	\N	\N	154714	154714	322022
20255	29431	1	applied	\N	\N	\N	\N	154715	154715	322023
20255	29432	2	applied	\N	\N	\N	\N	154716	154716	322024
20257	29430	0	applied	\N	\N	\N	\N	154719	154719	322027
20257	29431	1	applied	\N	\N	\N	\N	154720	154720	322028
20257	29432	2	applied	\N	\N	\N	\N	154721	154721	322029
20258	29433	0	applied	\N	\N	\N	\N	154722	154722	322030
20258	29434	1	applied	\N	\N	\N	\N	154723	154723	322031
20258	29435	2	applied	\N	\N	\N	\N	154724	154724	322032
20258	29436	3	applied	\N	\N	\N	\N	154725	154725	322033
20258	29437	4	applied	\N	\N	\N	\N	154726	154726	322034
20258	29438	5	applied	\N	\N	\N	\N	154727	154727	322035
20261	29443	0	applied	\N	\N	\N	\N	154735	154735	322043
20261	29446	1	applied	\N	\N	\N	\N	154736	154736	322044
20261	29444	2	applied	\N	\N	\N	\N	154737	154737	322045
20261	29445	3	applied	\N	\N	\N	\N	154738	154738	322046
20270	29459	0	applied	\N	\N	\N	\N	154773	154773	322081
20270	29460	1	applied	\N	\N	\N	\N	154774	154774	322082
20270	29461	2	applied	\N	\N	\N	\N	154775	154775	322083
20270	29462	3	applied	\N	\N	\N	\N	154776	154776	322084
20270	29463	4	applied	\N	\N	\N	\N	154777	154777	322085
20275	29471	0	applied	\N	\N	\N	\N	154800	154800	322108
20275	29472	1	applied	\N	\N	\N	\N	154801	154801	322109
20275	29473	2	applied	\N	\N	\N	\N	154802	154802	322110
20275	29474	3	applied	\N	\N	\N	\N	154803	154803	322111
20275	29475	4	applied	\N	\N	\N	\N	154804	154804	322112
20275	29476	5	applied	\N	\N	\N	\N	154805	154805	322113
20275	29477	6	applied	\N	\N	\N	\N	154806	154806	322114
20280	29485	1	applied	\N	\N	\N	\N	154949	154949	322255
20280	29486	2	applied	\N	\N	\N	\N	154950	154950	322256
20280	29487	3	applied	\N	\N	\N	\N	154951	154951	322257
20284	29491	0	applied	\N	\N	\N	\N	154965	154965	322271
20284	29492	1	applied	\N	\N	\N	\N	154966	154966	322272
20284	29493	2	applied	\N	\N	\N	\N	154967	154967	322273
20284	29494	4	applied	\N	\N	\N	\N	154968	154968	322274
20284	29495	5	applied	\N	\N	\N	\N	154969	154969	322275
20284	29496	6	applied	\N	\N	\N	\N	154970	154970	322276
20290	29497	0	applied	\N	\N	\N	\N	155002	155002	322308
20290	29498	1	applied	\N	\N	\N	\N	155003	155003	322309
20290	29502	2	applied	\N	\N	\N	\N	155004	155004	322310
20290	29499	3	applied	\N	\N	\N	\N	155005	155005	322311
20290	29500	4	applied	\N	\N	\N	\N	155006	155006	322312
20290	29503	5	applied	\N	\N	\N	\N	155007	155007	322313
20290	29501	6	applied	\N	\N	\N	\N	155008	155008	322314
20293	29498	1	applied	\N	\N	\N	\N	155024	155024	322330
20293	29502	2	applied	\N	\N	\N	\N	155025	155025	322331
20293	29499	3	applied	\N	\N	\N	\N	155026	155026	322332
20293	29500	4	applied	\N	\N	\N	\N	155027	155027	322333
20293	29503	5	applied	\N	\N	\N	\N	155028	155028	322334
20293	29501	6	applied	\N	\N	\N	\N	155029	155029	322335
20299	29523	0	applied	\N	\N	\N	\N	155055	155055	322361
20299	29524	1	applied	\N	\N	\N	\N	155056	155056	322362
20299	29525	2	applied	\N	\N	\N	\N	155057	155057	322363
20301	29533	0	applied	\N	\N	\N	\N	155065	155065	322371
20301	29534	1	applied	\N	\N	\N	\N	155066	155066	322372
20301	29535	2	applied	\N	\N	\N	\N	155067	155067	322373
20309	29556	0	applied	\N	\N	\N	\N	155094	155094	322400
20309	29557	1	applied	\N	\N	\N	\N	155095	155095	322401
20309	29558	2	applied	\N	\N	\N	\N	155096	155096	322402
20312	29566	0	applied	\N	\N	\N	\N	155107	155107	322413
20312	29568	2	applied	\N	\N	\N	\N	155109	155109	322415
20314	29569	0	applied	\N	\N	\N	\N	155112	155112	322418
20314	29570	1	applied	\N	\N	\N	\N	155113	155113	322419
20314	29571	2	applied	\N	\N	\N	\N	155114	155114	322420
20317	29572	0	applied	\N	\N	\N	\N	155121	155121	322427
20317	29573	1	applied	\N	\N	\N	\N	155122	155122	322428
20317	29574	2	applied	\N	\N	\N	\N	155123	155123	322429
20317	29575	3	applied	\N	\N	\N	\N	155124	155124	322430
20319	29572	0	applied	\N	\N	\N	\N	155133	155133	322439
20319	29576	1	applied	\N	\N	\N	\N	155134	155134	322440
20319	29577	2	applied	\N	\N	\N	\N	155135	155135	322441
20319	29578	3	applied	\N	\N	\N	\N	155136	155136	322442
20319	29575	4	applied	\N	\N	\N	\N	155137	155137	322443
20319	29583	5	applied	\N	\N	\N	\N	155138	155138	322444
20236	29333	49	applied	\N	\N	\N	\N	154596	154596	321904
20236	29338	50	applied	\N	\N	\N	\N	154597	154597	321905
20248	29400	5	applied	\N	\N	\N	\N	154664	154664	321972
20248	29401	6	applied	\N	\N	\N	\N	154665	154665	321973
20248	29402	7	applied	\N	\N	\N	\N	154666	154666	321974
20248	29403	9	applied	\N	\N	\N	\N	154667	154667	321975
20250	29407	0	applied	\N	\N	\N	\N	154671	154671	321979
20250	29408	1	applied	\N	\N	\N	\N	154672	154672	321980
20250	29409	2	applied	\N	\N	\N	\N	154673	154673	321981
20251	29415	5	applied	\N	\N	\N	\N	154679	154679	321987
20251	29416	6	applied	\N	\N	\N	\N	154680	154680	321988
20254	29417	0	applied	\N	\N	\N	\N	154701	154701	322009
20254	29418	1	applied	\N	\N	\N	\N	154702	154702	322010
20254	29419	2	applied	\N	\N	\N	\N	154703	154703	322011
20254	29420	3	applied	\N	\N	\N	\N	154704	154704	322012
20254	29421	4	applied	\N	\N	\N	\N	154705	154705	322013
20254	29422	5	applied	\N	\N	\N	\N	154706	154706	322014
20254	29423	6	applied	\N	\N	\N	\N	154707	154707	322015
20254	29425	8	applied	\N	\N	\N	\N	154709	154709	322017
20254	29426	9	applied	\N	\N	\N	\N	154710	154710	322018
20254	29427	10	applied	\N	\N	\N	\N	154711	154711	322019
20254	29428	11	applied	\N	\N	\N	\N	154712	154712	322020
20256	29430	0	applied	\N	\N	\N	\N	154717	154717	322025
20256	29432	1	applied	\N	\N	\N	\N	154718	154718	322026
20263	29443	0	applied	\N	\N	\N	\N	154743	154743	322051
20263	29446	1	applied	\N	\N	\N	\N	154744	154744	322052
20263	29444	2	applied	\N	\N	\N	\N	154745	154745	322053
20263	29445	3	applied	\N	\N	\N	\N	154746	154746	322054
20264	29447	0	applied	\N	\N	\N	\N	154747	154747	322055
20264	29448	1	applied	\N	\N	\N	\N	154748	154748	322056
20264	29446	2	applied	\N	\N	\N	\N	154749	154749	322057
20264	29449	3	applied	\N	\N	\N	\N	154750	154750	322058
20264	29450	4	applied	\N	\N	\N	\N	154751	154751	322059
20264	29451	5	applied	\N	\N	\N	\N	154752	154752	322060
20267	29453	0	applied	\N	\N	\N	\N	154764	154764	322072
20267	29454	1	applied	\N	\N	\N	\N	154765	154765	322073
20267	29455	2	applied	\N	\N	\N	\N	154766	154766	322074
20269	29456	0	applied	\N	\N	\N	\N	154770	154770	322078
20269	29457	1	applied	\N	\N	\N	\N	154771	154771	322079
20269	29458	2	applied	\N	\N	\N	\N	154772	154772	322080
20272	29459	0	applied	\N	\N	\N	\N	154781	154781	322089
20272	29460	1	applied	\N	\N	\N	\N	154782	154782	322090
20272	29461	2	applied	\N	\N	\N	\N	154783	154783	322091
20272	29462	3	applied	\N	\N	\N	\N	154784	154784	322092
20272	29463	4	applied	\N	\N	\N	\N	154785	154785	322093
20274	29464	0	applied	\N	\N	\N	\N	154793	154793	322101
20274	29465	1	applied	\N	\N	\N	\N	154794	154794	322102
20274	29466	2	applied	\N	\N	\N	\N	154795	154795	322103
20274	29467	3	applied	\N	\N	\N	\N	154796	154796	322104
20274	29468	4	applied	\N	\N	\N	\N	154797	154797	322105
20274	29470	6	applied	\N	\N	\N	\N	154799	154799	322107
20277	29478	0	applied	\N	\N	\N	\N	154813	154813	322121
20277	29479	1	applied	\N	\N	\N	\N	154814	154814	322122
20277	29480	2	applied	\N	\N	\N	\N	154815	154815	322123
20277	29481	3	applied	\N	\N	\N	\N	154816	154816	322124
20277	29482	4	applied	\N	\N	\N	\N	154817	154817	322125
20277	29483	5	applied	\N	\N	\N	\N	154818	154818	322126
20278	28930	0	applied	\N	\N	\N	\N	154819	154819	322127
20278	28874	1	applied	\N	\N	\N	\N	154820	154820	322128
20278	29057	2	applied	\N	\N	\N	\N	154821	154821	322129
20278	29058	3	applied	\N	\N	\N	\N	154822	154822	322130
20278	29062	4	applied	\N	\N	\N	\N	154823	154823	322131
20278	29063	5	applied	\N	\N	\N	\N	154824	154824	322132
20278	29015	6	applied	\N	\N	\N	\N	154825	154825	322133
20278	28366	7	applied	\N	\N	\N	\N	154826	154826	322134
20278	28239	8	applied	\N	\N	\N	\N	154827	154827	322135
20278	29007	10	applied	\N	\N	\N	\N	154829	154829	322137
20278	29021	11	applied	\N	\N	\N	\N	154830	154830	322138
20278	28565	12	applied	\N	\N	\N	\N	154831	154831	322139
20278	28580	13	applied	\N	\N	\N	\N	154832	154832	322140
20278	28585	14	applied	\N	\N	\N	\N	154833	154833	322141
20278	28595	15	applied	\N	\N	\N	\N	154834	154834	322142
20278	28109	16	applied	\N	\N	\N	\N	154835	154835	322143
20278	28110	17	applied	\N	\N	\N	\N	154836	154836	322144
20278	28111	18	applied	\N	\N	\N	\N	154837	154837	322145
20278	28112	19	applied	\N	\N	\N	\N	154838	154838	322146
20278	28370	20	applied	\N	\N	\N	\N	154839	154839	322147
20278	28371	21	applied	\N	\N	\N	\N	154840	154840	322148
20278	28376	22	applied	\N	\N	\N	\N	154841	154841	322149
20278	28404	23	applied	\N	\N	\N	\N	154842	154842	322150
20278	29137	24	applied	\N	\N	\N	\N	154843	154843	322151
20278	29138	25	applied	\N	\N	\N	\N	154844	154844	322152
20278	29140	27	applied	\N	\N	\N	\N	154846	154846	322154
20278	29141	28	applied	\N	\N	\N	\N	154847	154847	322155
20278	29142	29	applied	\N	\N	\N	\N	154848	154848	322156
20278	29143	30	applied	\N	\N	\N	\N	154849	154849	322157
20278	29144	31	applied	\N	\N	\N	\N	154850	154850	322158
20278	29145	32	applied	\N	\N	\N	\N	154851	154851	322159
20278	29146	33	applied	\N	\N	\N	\N	154852	154852	322160
20278	29147	34	applied	\N	\N	\N	\N	154853	154853	322161
20278	28814	35	applied	\N	\N	\N	\N	154854	154854	154854
20278	28970	36	applied	\N	\N	\N	\N	154855	154855	322162
20278	28971	37	applied	\N	\N	\N	\N	154856	154856	322163
20278	28972	38	applied	\N	\N	\N	\N	154857	154857	322164
20278	28990	39	applied	\N	\N	\N	\N	154858	154858	322165
20278	28887	40	applied	\N	\N	\N	\N	154859	154859	322166
20278	28383	41	applied	\N	\N	\N	\N	154860	154860	322167
20278	28581	42	applied	\N	\N	\N	\N	154861	154861	322168
20278	28028	44	applied	\N	\N	\N	\N	154863	154863	322170
20278	29100	45	applied	\N	\N	\N	\N	154864	154864	322171
20278	28942	46	applied	\N	\N	\N	\N	154865	154865	322172
20278	28943	47	applied	\N	\N	\N	\N	154866	154866	322173
20278	28675	48	applied	\N	\N	\N	\N	154867	154867	322174
20278	28801	49	applied	\N	\N	\N	\N	154868	154868	322175
20278	29344	50	applied	\N	\N	\N	\N	154869	154869	322176
20278	29345	51	applied	\N	\N	\N	\N	154870	154870	322177
20278	29346	52	applied	\N	\N	\N	\N	154871	154871	322178
20278	29115	53	applied	\N	\N	\N	\N	154872	154872	322179
20278	29116	54	applied	\N	\N	\N	\N	154873	154873	322180
20278	29017	55	applied	\N	\N	\N	\N	154874	154874	322181
20278	29018	56	applied	\N	\N	\N	\N	154875	154875	322182
20278	29163	57	applied	\N	\N	\N	\N	154876	154876	322183
20248	29397	2	applied	\N	\N	\N	\N	154661	154661	321969
20248	29398	3	applied	\N	\N	\N	\N	154662	154662	321970
20252	29416	6	applied	\N	\N	\N	\N	154687	154687	321995
20254	29429	12	applied	\N	\N	\N	\N	154713	154713	322021
20259	29440	0	applied	\N	\N	\N	\N	154729	154729	322037
20259	29441	1	applied	\N	\N	\N	\N	154730	154730	322038
20259	29442	2	applied	\N	\N	\N	\N	154731	154731	322039
20260	29443	0	applied	\N	\N	\N	\N	154732	154732	322040
20260	29444	1	applied	\N	\N	\N	\N	154733	154733	322041
20260	29445	2	applied	\N	\N	\N	\N	154734	154734	322042
20262	29443	0	applied	\N	\N	\N	\N	154739	154739	322047
20262	29446	1	applied	\N	\N	\N	\N	154740	154740	322048
20262	29444	2	applied	\N	\N	\N	\N	154741	154741	322049
20262	29445	3	applied	\N	\N	\N	\N	154742	154742	322050
20265	29447	0	applied	\N	\N	\N	\N	154754	154754	322062
20265	29448	1	applied	\N	\N	\N	\N	154755	154755	322063
20265	29446	2	applied	\N	\N	\N	\N	154756	154756	322064
20265	29449	3	applied	\N	\N	\N	\N	154757	154757	322065
20265	29451	5	applied	\N	\N	\N	\N	154759	154759	322067
20265	29452	6	applied	\N	\N	\N	\N	154760	154760	322068
20266	29453	0	applied	\N	\N	\N	\N	154761	154761	322069
20266	29454	1	applied	\N	\N	\N	\N	154762	154762	322070
20266	29455	2	applied	\N	\N	\N	\N	154763	154763	322071
20268	29456	0	applied	\N	\N	\N	\N	154767	154767	322075
20268	29457	1	applied	\N	\N	\N	\N	154768	154768	322076
20268	29458	2	applied	\N	\N	\N	\N	154769	154769	322077
20271	29459	0	applied	\N	\N	\N	\N	154778	154778	322086
20271	29461	1	applied	\N	\N	\N	\N	154779	154779	322087
20271	29463	2	applied	\N	\N	\N	\N	154780	154780	322088
20273	29464	0	applied	\N	\N	\N	\N	154786	154786	322094
20273	29465	1	applied	\N	\N	\N	\N	154787	154787	322095
20273	29466	2	applied	\N	\N	\N	\N	154788	154788	322096
20273	29467	3	applied	\N	\N	\N	\N	154789	154789	322097
20273	29468	4	applied	\N	\N	\N	\N	154790	154790	322098
20273	29470	6	applied	\N	\N	\N	\N	154792	154792	322100
20276	29478	0	applied	\N	\N	\N	\N	154807	154807	322115
20276	29479	1	applied	\N	\N	\N	\N	154808	154808	322116
20276	29480	2	applied	\N	\N	\N	\N	154809	154809	322117
20276	29481	3	applied	\N	\N	\N	\N	154810	154810	322118
20276	29482	4	applied	\N	\N	\N	\N	154811	154811	322119
20276	29483	5	applied	\N	\N	\N	\N	154812	154812	322120
20279	29484	0	applied	\N	\N	\N	\N	154944	154944	322250
20279	29485	1	applied	\N	\N	\N	\N	154945	154945	322251
20279	29486	2	applied	\N	\N	\N	\N	154946	154946	322252
20279	29487	3	applied	\N	\N	\N	\N	154947	154947	322253
20281	29487	0	applied	\N	\N	\N	\N	154952	154952	322258
20282	29484	0	applied	\N	\N	\N	\N	154953	154953	322259
20282	29488	1	applied	\N	\N	\N	\N	154954	154954	322260
20282	29485	2	applied	\N	\N	\N	\N	154955	154955	322261
20282	29489	3	applied	\N	\N	\N	\N	154956	154956	322262
20282	29490	5	applied	\N	\N	\N	\N	154958	154958	322264
20285	29491	0	applied	\N	\N	\N	\N	154971	154971	322277
20285	29492	1	applied	\N	\N	\N	\N	154972	154972	322278
20285	29493	2	applied	\N	\N	\N	\N	154973	154973	322279
20285	29494	4	applied	\N	\N	\N	\N	154974	154974	322280
20285	29495	5	applied	\N	\N	\N	\N	154975	154975	322281
20285	29496	6	applied	\N	\N	\N	\N	154976	154976	322282
20287	29497	0	applied	\N	\N	\N	\N	154983	154983	322289
20287	29498	1	applied	\N	\N	\N	\N	154984	154984	322290
20287	29499	2	applied	\N	\N	\N	\N	154985	154985	322291
20287	29500	3	applied	\N	\N	\N	\N	154986	154986	322292
20287	29501	4	applied	\N	\N	\N	\N	154987	154987	322293
20289	29497	0	applied	\N	\N	\N	\N	154995	154995	322301
20289	29498	1	applied	\N	\N	\N	\N	154996	154996	322302
20289	29502	2	applied	\N	\N	\N	\N	154997	154997	322303
20289	29499	3	applied	\N	\N	\N	\N	154998	154998	322304
20296	29508	1	applied	\N	\N	\N	\N	155037	155037	322343
20296	29509	2	applied	\N	\N	\N	\N	155038	155038	322344
20296	29510	3	applied	\N	\N	\N	\N	155039	155039	322345
20296	29511	4	applied	\N	\N	\N	\N	155040	155040	322346
20296	29512	5	applied	\N	\N	\N	\N	155041	155041	322347
20296	29513	6	applied	\N	\N	\N	\N	155042	155042	322348
20296	29514	7	applied	\N	\N	\N	\N	155043	155043	322349
20296	29515	8	applied	\N	\N	\N	\N	155044	155044	322350
20302	29536	0	applied	\N	\N	\N	\N	155068	155068	322374
20302	29537	1	applied	\N	\N	\N	\N	155069	155069	322375
20302	29538	2	applied	\N	\N	\N	\N	155070	155070	322376
20304	29539	0	applied	\N	\N	\N	\N	155074	155074	322380
20304	29540	1	applied	\N	\N	\N	\N	155075	155075	322381
20304	29541	2	applied	\N	\N	\N	\N	155076	155076	322382
20304	29542	3	applied	\N	\N	\N	\N	155077	155077	322383
20307	29553	0	applied	\N	\N	\N	\N	155088	155088	322394
20307	29555	2	applied	\N	\N	\N	\N	155090	155090	322396
20310	29559	0	applied	\N	\N	\N	\N	155097	155097	322403
20310	29560	1	applied	\N	\N	\N	\N	155098	155098	322404
20310	29561	2	applied	\N	\N	\N	\N	155099	155099	322405
20310	29562	3	applied	\N	\N	\N	\N	155100	155100	322406
20310	29563	4	applied	\N	\N	\N	\N	155101	155101	322407
20310	29564	5	applied	\N	\N	\N	\N	155102	155102	322408
20310	29565	6	applied	\N	\N	\N	\N	155103	155103	322409
20313	29566	0	applied	\N	\N	\N	\N	155110	155110	322416
20313	29568	1	applied	\N	\N	\N	\N	155111	155111	322417
20323	29600	0	applied	\N	\N	\N	\N	155167	155167	322473
20323	29601	1	applied	\N	\N	\N	\N	155168	155168	322474
20323	29602	2	applied	\N	\N	\N	\N	155169	155169	322475
20323	29603	3	applied	\N	\N	\N	\N	155170	155170	322476
20327	29604	0	applied	\N	\N	\N	\N	155183	155183	322489
20327	29605	1	applied	\N	\N	\N	\N	155184	155184	322490
20327	29607	3	applied	\N	\N	\N	\N	155186	155186	322492
20327	29608	4	applied	\N	\N	\N	\N	155187	155187	322493
20329	29360	0	applied	\N	\N	\N	\N	155193	155193	322499
20329	29344	1	applied	\N	\N	\N	\N	155194	155194	322500
20329	29345	2	applied	\N	\N	\N	\N	155195	155195	322501
20329	29346	3	applied	\N	\N	\N	\N	155196	155196	322502
20329	29336	4	applied	\N	\N	\N	\N	155197	155197	322503
20329	29353	5	applied	\N	\N	\N	\N	155198	155198	322504
20329	29340	6	applied	\N	\N	\N	\N	155199	155199	322505
20329	29343	7	applied	\N	\N	\N	\N	155200	155200	322506
20329	29365	8	applied	\N	\N	\N	\N	155201	155201	322507
20329	29366	9	applied	\N	\N	\N	\N	155202	155202	322508
20329	29367	10	applied	\N	\N	\N	\N	155203	155203	322509
20329	29349	11	applied	\N	\N	\N	\N	155204	155204	322510
20252	29413	3	applied	\N	\N	\N	\N	154684	154684	321992
20252	29414	4	applied	\N	\N	\N	\N	154685	154685	321993
20278	29269	62	applied	\N	\N	\N	\N	154881	154881	322188
20278	29270	63	applied	\N	\N	\N	\N	154882	154882	322189
20278	29275	64	applied	\N	\N	\N	\N	154883	154883	322190
20278	29278	65	applied	\N	\N	\N	\N	154884	154884	322191
20278	28984	66	applied	\N	\N	\N	\N	154885	154885	322192
20278	28985	67	applied	\N	\N	\N	\N	154886	154886	322193
20278	28889	68	applied	\N	\N	\N	\N	154887	154887	322194
20278	28890	69	applied	\N	\N	\N	\N	154888	154888	322195
20278	28891	70	applied	\N	\N	\N	\N	154889	154889	322196
20278	28892	71	applied	\N	\N	\N	\N	154890	154890	322197
20278	28893	72	applied	\N	\N	\N	\N	154891	154891	322198
20278	28906	74	applied	\N	\N	\N	\N	154892	154892	322199
20278	28330	75	applied	\N	\N	\N	\N	154893	154893	322200
20278	28591	76	applied	\N	\N	\N	\N	154894	154894	322201
20278	28558	78	applied	\N	\N	\N	\N	154896	154896	322203
20278	29360	79	applied	\N	\N	\N	\N	154897	154897	322204
20278	28944	80	applied	\N	\N	\N	\N	154898	154898	322205
20278	28945	81	applied	\N	\N	\N	\N	154899	154899	322206
20289	29500	4	applied	\N	\N	\N	\N	154999	154999	322305
20289	29503	5	applied	\N	\N	\N	\N	155000	155000	322306
20289	29501	6	applied	\N	\N	\N	\N	155001	155001	322307
20292	29497	0	applied	\N	\N	\N	\N	155016	155016	322322
20292	29498	1	applied	\N	\N	\N	\N	155017	155017	322323
20292	29502	2	applied	\N	\N	\N	\N	155018	155018	322324
20292	29499	3	applied	\N	\N	\N	\N	155019	155019	322325
20292	29500	4	applied	\N	\N	\N	\N	155020	155020	322326
20292	29503	5	applied	\N	\N	\N	\N	155021	155021	322327
20292	29501	6	applied	\N	\N	\N	\N	155022	155022	322328
20295	29504	0	applied	\N	\N	\N	\N	155033	155033	322339
20295	29505	1	applied	\N	\N	\N	\N	155034	155034	322340
20295	29506	2	applied	\N	\N	\N	\N	155035	155035	322341
20298	29523	0	applied	\N	\N	\N	\N	155052	155052	322358
20298	29525	2	applied	\N	\N	\N	\N	155054	155054	322360
20306	29546	0	applied	\N	\N	\N	\N	155081	155081	322387
20306	29547	1	applied	\N	\N	\N	\N	155082	155082	322388
20306	29548	2	applied	\N	\N	\N	\N	155083	155083	322389
20306	29549	3	applied	\N	\N	\N	\N	155084	155084	322390
20306	29550	4	applied	\N	\N	\N	\N	155085	155085	322391
20306	29551	5	applied	\N	\N	\N	\N	155086	155086	322392
20306	29552	6	applied	\N	\N	\N	\N	155087	155087	322393
20311	29566	0	applied	\N	\N	\N	\N	155104	155104	322410
20311	29567	1	applied	\N	\N	\N	\N	155105	155105	322411
20311	29568	2	applied	\N	\N	\N	\N	155106	155106	322412
20316	29573	0	applied	\N	\N	\N	\N	155119	155119	322425
20316	29574	1	applied	\N	\N	\N	\N	155120	155120	322426
20321	29594	0	applied	\N	\N	\N	\N	155157	155157	322463
20321	29595	1	applied	\N	\N	\N	\N	155158	155158	322464
20321	29596	2	applied	\N	\N	\N	\N	155159	155159	322465
20321	29598	4	applied	\N	\N	\N	\N	155161	155161	322467
20321	29599	5	applied	\N	\N	\N	\N	155162	155162	322468
20325	29600	0	applied	\N	\N	\N	\N	155175	155175	322481
20325	29601	1	applied	\N	\N	\N	\N	155176	155176	322482
20325	29602	2	applied	\N	\N	\N	\N	155177	155177	322483
20325	29603	3	applied	\N	\N	\N	\N	155178	155178	322484
20330	29609	0	applied	\N	\N	\N	\N	155318	155318	322624
20330	29610	1	applied	\N	\N	\N	\N	155319	155319	322625
20330	29611	2	applied	\N	\N	\N	\N	155320	155320	322626
20330	29612	3	applied	\N	\N	\N	\N	155321	155321	322627
20336	29626	0	applied	\N	\N	\N	\N	155345	155345	322651
20336	29627	1	applied	\N	\N	\N	\N	155346	155346	322652
20336	29628	2	applied	\N	\N	\N	\N	155347	155347	322653
20336	29629	3	applied	\N	\N	\N	\N	155348	155348	322654
20336	29630	4	applied	\N	\N	\N	\N	155349	155349	322655
20336	29631	5	applied	\N	\N	\N	\N	155350	155350	322656
20338	29637	1	applied	\N	\N	\N	\N	155356	155356	322662
20338	29638	2	applied	\N	\N	\N	\N	155357	155357	322663
20338	29639	3	applied	\N	\N	\N	\N	155358	155358	322664
20338	29640	4	applied	\N	\N	\N	\N	155359	155359	322665
20338	29641	5	applied	\N	\N	\N	\N	155360	155360	322666
20341	29604	0	applied	\N	\N	\N	\N	155373	155373	322679
20341	29605	1	applied	\N	\N	\N	\N	155374	155374	322680
20341	29609	2	applied	\N	\N	\N	\N	155375	155375	322681
20341	29613	3	applied	\N	\N	\N	\N	155376	155376	322682
20341	29616	4	applied	\N	\N	\N	\N	155377	155377	322683
20341	29619	5	applied	\N	\N	\N	\N	155378	155378	322684
20341	29620	6	applied	\N	\N	\N	\N	155379	155379	322685
20341	29626	7	applied	\N	\N	\N	\N	155380	155380	322686
20341	29627	8	applied	\N	\N	\N	\N	155381	155381	322687
20341	29632	9	applied	\N	\N	\N	\N	155382	155382	322688
20341	29636	10	applied	\N	\N	\N	\N	155383	155383	322689
20341	29607	12	applied	\N	\N	\N	\N	155385	155385	322691
20341	29608	13	applied	\N	\N	\N	\N	155386	155386	322692
20341	29610	14	applied	\N	\N	\N	\N	155387	155387	322693
20341	29614	15	applied	\N	\N	\N	\N	155388	155388	322694
20341	29618	16	applied	\N	\N	\N	\N	155389	155389	322695
20341	29622	17	applied	\N	\N	\N	\N	155390	155390	322696
20341	29623	18	applied	\N	\N	\N	\N	155391	155391	322697
20341	29628	19	applied	\N	\N	\N	\N	155392	155392	322698
20341	29630	20	applied	\N	\N	\N	\N	155393	155393	322699
20341	29633	21	applied	\N	\N	\N	\N	155394	155394	322700
20341	29638	22	applied	\N	\N	\N	\N	155395	155395	322701
20341	29611	23	applied	\N	\N	\N	\N	155396	155396	322702
20341	29612	24	applied	\N	\N	\N	\N	155397	155397	322703
20341	29621	25	applied	\N	\N	\N	\N	155398	155398	322704
20341	29635	26	applied	\N	\N	\N	\N	155399	155399	322705
20341	29639	27	applied	\N	\N	\N	\N	155400	155400	322706
20341	29641	29	applied	\N	\N	\N	\N	155402	155402	322708
20341	29615	30	applied	\N	\N	\N	\N	155403	155403	322709
20341	29617	31	applied	\N	\N	\N	\N	155404	155404	322710
20341	29624	32	applied	\N	\N	\N	\N	155405	155405	322711
20341	29625	33	applied	\N	\N	\N	\N	155406	155406	322712
20341	29629	34	applied	\N	\N	\N	\N	155407	155407	322713
20341	29631	35	applied	\N	\N	\N	\N	155408	155408	322714
20341	29634	36	applied	\N	\N	\N	\N	155409	155409	322715
20341	29637	37	applied	\N	\N	\N	\N	155410	155410	322716
20343	29642	0	applied	\N	\N	\N	\N	155416	155416	322722
20343	29643	1	applied	\N	\N	\N	\N	155417	155417	322723
20343	29644	2	applied	\N	\N	\N	\N	155418	155418	322724
20343	29645	3	applied	\N	\N	\N	\N	155419	155419	322725
20343	29646	4	applied	\N	\N	\N	\N	155420	155420	322726
20278	29353	60	applied	\N	\N	\N	\N	154879	154879	322186
20278	28031	61	applied	\N	\N	\N	\N	154880	154880	322187
20278	28834	86	applied	\N	\N	\N	\N	154904	154904	154904
20278	28793	87	applied	\N	\N	\N	\N	154905	154905	322211
20278	29170	88	applied	\N	\N	\N	\N	154906	154906	322212
20278	29178	89	applied	\N	\N	\N	\N	154907	154907	322213
20278	29190	90	applied	\N	\N	\N	\N	154908	154908	322214
20278	28802	91	applied	\N	\N	\N	\N	154909	154909	322215
20278	28807	92	applied	\N	\N	\N	\N	154910	154910	322216
20278	28808	93	applied	\N	\N	\N	\N	154911	154911	322217
20278	28809	94	applied	\N	\N	\N	\N	154912	154912	322218
20278	28824	95	applied	\N	\N	1000000000	\N	154913	154913	322219
20278	28795	96	applied	\N	\N	\N	\N	154914	154914	322220
20278	28800	97	applied	\N	\N	\N	\N	154915	154915	322221
20278	28447	98	applied	\N	\N	\N	\N	154916	154916	322222
20278	28448	99	applied	\N	\N	\N	\N	154917	154917	322223
20278	28390	101	applied	\N	\N	\N	\N	154919	154919	322225
20278	28393	102	applied	\N	\N	\N	\N	154920	154920	322226
20278	29365	103	applied	\N	\N	\N	\N	154921	154921	322227
20278	29019	104	applied	\N	\N	\N	\N	154922	154922	322228
20278	28450	105	applied	\N	\N	\N	\N	154923	154923	322229
20278	28451	106	applied	\N	\N	\N	\N	154924	154924	322230
20278	28817	107	applied	\N	\N	\N	\N	154925	154925	322231
20278	28818	108	applied	\N	\N	\N	\N	154926	154926	322232
20278	28822	109	applied	\N	\N	\N	\N	154927	154927	322233
20278	28823	110	applied	\N	\N	\N	\N	154928	154928	322234
20278	28228	111	applied	\N	\N	\N	\N	154929	154929	322235
20278	28592	112	applied	\N	\N	\N	\N	154930	154930	322236
20278	28596	113	applied	\N	\N	\N	\N	154931	154931	322237
20278	28992	114	applied	\N	\N	\N	\N	154932	154932	322238
20278	28826	115	applied	\N	\N	\N	\N	154933	154933	322239
20278	28827	116	applied	\N	\N	\N	\N	154934	154934	322240
20278	28829	118	applied	\N	\N	\N	\N	154936	154936	322242
20278	28830	119	applied	\N	\N	\N	\N	154937	154937	322243
20278	28831	120	applied	\N	\N	\N	\N	154938	154938	322244
20278	28837	121	applied	\N	\N	\N	\N	154939	154939	322245
20278	28838	122	applied	\N	\N	\N	\N	154940	154940	322246
20278	28839	123	applied	\N	\N	\N	\N	154941	154941	322247
20278	28840	124	applied	\N	\N	\N	\N	154942	154942	322248
20278	28841	125	applied	\N	\N	\N	\N	154943	154943	322249
20283	29484	0	applied	\N	\N	\N	\N	154959	154959	322265
20283	29488	1	applied	\N	\N	\N	\N	154960	154960	322266
20283	29485	2	applied	\N	\N	\N	\N	154961	154961	322267
20283	29489	3	applied	\N	\N	\N	\N	154962	154962	322268
20283	29486	4	applied	\N	\N	\N	\N	154963	154963	322269
20283	29490	5	applied	\N	\N	\N	\N	154964	154964	322270
20286	29491	0	applied	\N	\N	\N	\N	154977	154977	322283
20286	29492	1	applied	\N	\N	\N	\N	154978	154978	322284
20286	29494	4	applied	\N	\N	\N	\N	154980	154980	322286
20286	29495	5	applied	\N	\N	\N	\N	154981	154981	322287
20286	29496	6	applied	\N	\N	\N	\N	154982	154982	322288
20288	29497	0	applied	\N	\N	\N	\N	154988	154988	322294
20288	29498	1	applied	\N	\N	\N	\N	154989	154989	322295
20288	29502	2	applied	\N	\N	\N	\N	154990	154990	322296
20288	29499	3	applied	\N	\N	\N	\N	154991	154991	322297
20288	29500	4	applied	\N	\N	\N	\N	154992	154992	322298
20288	29503	5	applied	\N	\N	\N	\N	154993	154993	322299
20288	29501	6	applied	\N	\N	\N	\N	154994	154994	322300
20291	29497	0	applied	\N	\N	\N	\N	155009	155009	322315
20291	29498	1	applied	\N	\N	\N	\N	155010	155010	322316
20291	29502	2	applied	\N	\N	\N	\N	155011	155011	322317
20291	29499	3	applied	\N	\N	\N	\N	155012	155012	322318
20291	29500	4	applied	\N	\N	\N	\N	155013	155013	322319
20291	29503	5	applied	\N	\N	\N	\N	155014	155014	322320
20294	29504	0	applied	\N	\N	\N	\N	155030	155030	322336
20294	29505	1	applied	\N	\N	\N	\N	155031	155031	322337
20294	29506	2	applied	\N	\N	\N	\N	155032	155032	322338
20297	29516	0	applied	\N	\N	\N	\N	155045	155045	322351
20297	29517	1	applied	\N	\N	\N	\N	155046	155046	322352
20297	29518	2	applied	\N	\N	\N	\N	155047	155047	322353
20297	29519	3	applied	\N	\N	\N	\N	155048	155048	322354
20297	29520	4	applied	\N	\N	\N	\N	155049	155049	322355
20297	29521	5	applied	\N	\N	\N	\N	155050	155050	322356
20297	29522	6	applied	\N	\N	\N	\N	155051	155051	322357
20300	29526	0	applied	\N	\N	\N	\N	155058	155058	322364
20300	29527	1	applied	\N	\N	\N	\N	155059	155059	322365
20300	29528	2	applied	\N	\N	\N	\N	155060	155060	322366
20300	29529	3	applied	\N	\N	\N	\N	155061	155061	322367
20300	29530	4	applied	\N	\N	\N	\N	155062	155062	322368
20300	29531	5	applied	\N	\N	\N	\N	155063	155063	322369
20303	29536	0	applied	\N	\N	\N	\N	155071	155071	322377
20303	29537	1	applied	\N	\N	\N	\N	155072	155072	322378
20303	29538	2	applied	\N	\N	\N	\N	155073	155073	322379
20305	29543	0	applied	\N	\N	\N	\N	155078	155078	322384
20305	29544	1	applied	\N	\N	\N	\N	155079	155079	322385
20305	29545	2	applied	\N	\N	\N	\N	155080	155080	322386
20308	29553	0	applied	\N	\N	\N	\N	155091	155091	322397
20308	29554	1	applied	\N	\N	\N	\N	155092	155092	322398
20308	29555	2	applied	\N	\N	\N	\N	155093	155093	322399
20315	29572	0	applied	\N	\N	\N	\N	155115	155115	322421
20315	29573	1	applied	\N	\N	\N	\N	155116	155116	322422
20315	29574	2	applied	\N	\N	\N	\N	155117	155117	322423
20315	29575	3	applied	\N	\N	\N	\N	155118	155118	322424
20318	29572	0	applied	\N	\N	\N	\N	155125	155125	322431
20318	29576	1	applied	\N	\N	\N	\N	155126	155126	322432
20318	29577	2	applied	\N	\N	\N	\N	155127	155127	322433
20318	29579	4	applied	\N	\N	\N	\N	155129	155129	322435
20318	29580	5	applied	\N	\N	\N	\N	155130	155130	322436
20318	29581	6	applied	\N	\N	\N	\N	155131	155131	322437
20318	29582	7	applied	\N	\N	\N	\N	155132	155132	322438
20320	29586	0	applied	\N	\N	\N	\N	155145	155145	322451
20320	29587	2	applied	\N	\N	\N	\N	155146	155146	322452
20320	29588	3	applied	\N	\N	\N	\N	155147	155147	322453
20320	29575	4	applied	\N	\N	\N	\N	155148	155148	322454
20320	29583	5	applied	\N	\N	\N	\N	155149	155149	322455
20320	29584	6	applied	\N	\N	\N	\N	155150	155150	322456
20320	29585	7	applied	\N	\N	\N	\N	155151	155151	322457
20320	29589	8	applied	\N	\N	\N	\N	155152	155152	322458
20320	29590	9	applied	\N	\N	\N	\N	155153	155153	322459
20320	29591	10	applied	\N	\N	\N	\N	155154	155154	322460
20320	29592	11	applied	\N	\N	\N	\N	155155	155155	322461
20320	29593	12	applied	\N	\N	\N	\N	155156	155156	322462
20278	29118	85	applied	\N	\N	\N	\N	154903	154903	322210
20319	29581	10	applied	\N	\N	\N	\N	155143	155143	322449
20319	29582	12	applied	\N	\N	\N	\N	155144	155144	322450
20322	29600	0	applied	\N	\N	\N	\N	155163	155163	322469
20322	29601	1	applied	\N	\N	\N	\N	155164	155164	322470
20322	29602	2	applied	\N	\N	\N	\N	155165	155165	322471
20322	29603	3	applied	\N	\N	\N	\N	155166	155166	322472
20324	29600	0	applied	\N	\N	\N	\N	155171	155171	322477
20324	29601	1	applied	\N	\N	\N	\N	155172	155172	322478
20324	29602	2	applied	\N	\N	\N	\N	155173	155173	322479
20324	29603	3	applied	\N	\N	\N	\N	155174	155174	322480
20326	29600	0	applied	\N	\N	\N	\N	155179	155179	322485
20326	29601	1	applied	\N	\N	\N	\N	155180	155180	322486
20326	29602	2	applied	\N	\N	\N	\N	155181	155181	322487
20326	29603	3	applied	\N	\N	\N	\N	155182	155182	322488
20328	29604	0	applied	\N	\N	\N	\N	155188	155188	322494
20328	29605	1	applied	\N	\N	\N	\N	155189	155189	322495
20328	29607	3	applied	\N	\N	\N	\N	155191	155191	322497
20328	29608	4	applied	\N	\N	\N	\N	155192	155192	322498
20332	29613	0	applied	\N	\N	\N	\N	155326	155326	322632
20332	29614	1	applied	\N	\N	\N	\N	155327	155327	322633
20332	29615	2	applied	\N	\N	\N	\N	155328	155328	322634
20333	29616	0	applied	\N	\N	\N	\N	155329	155329	322635
20333	29617	1	applied	\N	\N	\N	\N	155330	155330	322636
20333	29618	2	applied	\N	\N	\N	\N	155331	155331	322637
20335	29626	0	applied	\N	\N	\N	\N	155339	155339	322645
20335	29627	1	applied	\N	\N	\N	\N	155340	155340	322646
20335	29628	2	applied	\N	\N	\N	\N	155341	155341	322647
20335	29629	3	applied	\N	\N	\N	\N	155342	155342	322648
20335	29630	4	applied	\N	\N	\N	\N	155343	155343	322649
20335	29631	5	applied	\N	\N	\N	\N	155344	155344	322650
20339	29636	0	applied	\N	\N	\N	\N	155361	155361	322667
20339	29637	1	applied	\N	\N	\N	\N	155362	155362	322668
20339	29639	3	applied	\N	\N	\N	\N	155364	155364	322670
20339	29640	4	applied	\N	\N	\N	\N	155365	155365	322671
20339	29641	5	applied	\N	\N	\N	\N	155366	155366	322672
20342	29642	0	applied	\N	\N	\N	\N	155411	155411	322717
20342	29643	1	applied	\N	\N	\N	\N	155412	155412	322718
20342	29644	2	applied	\N	\N	\N	\N	155413	155413	322719
20342	29645	3	applied	\N	\N	\N	\N	155414	155414	322720
20342	29646	4	applied	\N	\N	\N	\N	155415	155415	322721
20345	29653	0	applied	\N	\N	\N	\N	155427	155427	322733
20345	29654	1	applied	\N	\N	\N	\N	155428	155428	322734
20345	29655	2	applied	\N	\N	\N	\N	155429	155429	322735
20348	29665	0	applied	\N	\N	\N	\N	155442	155442	322748
20348	29666	1	applied	\N	\N	\N	\N	155443	155443	322749
20348	29667	2	applied	\N	\N	\N	\N	155444	155444	322750
20349	29668	0	applied	\N	\N	\N	\N	155445	155445	322751
20351	29668	0	applied	\N	\N	\N	\N	155451	155451	322757
20351	29670	2	applied	\N	\N	\N	\N	155453	155453	322759
20357	29676	0	applied	\N	\N	\N	\N	155468	155468	322774
20357	29677	1	applied	\N	\N	\N	\N	155469	155469	322775
20357	29678	2	applied	\N	\N	\N	\N	155470	155470	322776
20362	29692	0	applied	\N	\N	\N	\N	155530	155530	322836
20362	29693	1	applied	\N	\N	\N	\N	155531	155531	322837
20362	29694	2	applied	\N	\N	\N	\N	155532	155532	322838
20362	29695	3	applied	\N	\N	\N	\N	155533	155533	322839
20362	29696	4	applied	\N	\N	\N	\N	155534	155534	322840
20362	29697	5	applied	\N	\N	\N	\N	155535	155535	322841
20367	29704	0	applied	\N	\N	\N	\N	155551	155551	322857
20367	29705	1	applied	\N	\N	\N	\N	155552	155552	322858
20367	29706	2	applied	\N	\N	\N	\N	155553	155553	322859
20370	29713	0	applied	\N	\N	\N	\N	155576	155576	322882
20370	29714	1	applied	\N	\N	\N	\N	155577	155577	322883
20370	29729	2	applied	\N	\N	\N	\N	155578	155578	322884
20370	29716	4	applied	\N	\N	\N	\N	155580	155580	322886
20370	29717	5	applied	\N	\N	\N	\N	155581	155581	322887
20370	29718	6	applied	\N	\N	\N	\N	155582	155582	322888
20370	29719	7	applied	\N	\N	\N	\N	155583	155583	322889
20370	29720	8	applied	\N	\N	\N	\N	155584	155584	322890
20370	29721	9	applied	\N	\N	\N	\N	155585	155585	322891
20370	29722	10	applied	\N	\N	\N	\N	155586	155586	322892
20370	29723	11	applied	\N	\N	\N	\N	155587	155587	322893
20370	29724	12	applied	\N	\N	\N	\N	155588	155588	322894
20370	29725	13	applied	\N	\N	\N	\N	155589	155589	322895
20370	29726	14	applied	\N	\N	\N	\N	155590	155590	322896
20370	29727	15	applied	\N	\N	\N	\N	155591	155591	322897
20370	29728	16	applied	\N	\N	\N	\N	155592	155592	322898
20372	29730	0	applied	\N	\N	\N	\N	155610	155610	322916
20372	29731	1	applied	\N	\N	\N	\N	155611	155611	322917
20372	29732	2	applied	\N	\N	\N	\N	155612	155612	322918
20375	29737	0	applied	\N	\N	\N	\N	155620	155620	322926
20375	29738	1	applied	\N	\N	\N	\N	155621	155621	322927
20375	29739	2	applied	\N	\N	\N	\N	155622	155622	322928
20377	29737	0	applied	\N	\N	\N	\N	155626	155626	322932
20377	29738	1	applied	\N	\N	\N	\N	155627	155627	322933
20377	29739	2	applied	\N	\N	\N	\N	155628	155628	322934
20379	29740	0	applied	\N	\N	\N	\N	155687	155687	322993
20379	29741	1	applied	\N	\N	\N	\N	155688	155688	322994
20379	29743	2	applied	\N	\N	\N	\N	155689	155689	322995
20379	29742	3	applied	\N	\N	\N	\N	155690	155690	322996
20379	29744	4	applied	\N	\N	\N	\N	155691	155691	322997
20379	29745	5	applied	\N	\N	\N	\N	155692	155692	322998
20382	29749	0	applied	\N	\N	\N	\N	155699	155699	323005
20382	29750	1	applied	\N	\N	\N	\N	155700	155700	323006
20382	29751	2	applied	\N	\N	\N	\N	155701	155701	323007
20384	29754	0	applied	\N	\N	\N	\N	155704	155704	323010
20384	29756	2	applied	\N	\N	\N	\N	155706	155706	323012
20386	29758	0	applied	\N	\N	\N	\N	155735	155735	323041
20386	29759	1	applied	\N	\N	\N	\N	155736	155736	323042
20386	29760	2	applied	\N	\N	\N	\N	155737	155737	323043
20389	29761	0	applied	\N	\N	\N	\N	155741	155741	323047
20389	29762	1	applied	\N	\N	\N	\N	155742	155742	323048
20389	29763	2	applied	\N	\N	\N	\N	155743	155743	323049
20389	29764	3	applied	\N	\N	\N	\N	155744	155744	323050
20389	29765	4	applied	\N	\N	\N	\N	155745	155745	323051
20389	29766	5	applied	\N	\N	\N	\N	155746	155746	323052
20389	29767	6	applied	\N	\N	\N	\N	155747	155747	323053
20389	29768	7	applied	\N	\N	\N	\N	155748	155748	323054
20389	29769	8	applied	\N	\N	\N	\N	155749	155749	323055
20395	29782	0	applied	\N	\N	\N	\N	155775	155775	323081
20319	29585	7	applied	\N	\N	\N	\N	155140	155140	322446
20319	29579	8	applied	\N	\N	\N	\N	155141	155141	322447
20329	29371	16	applied	\N	\N	\N	\N	155209	155209	322515
20329	29375	17	applied	\N	\N	\N	\N	155210	155210	322516
20329	29376	18	applied	\N	\N	\N	\N	155211	155211	322517
20329	29382	19	applied	\N	\N	\N	\N	155212	155212	322518
20329	29383	20	applied	\N	\N	\N	\N	155213	155213	322519
20329	29388	21	applied	\N	\N	\N	\N	155214	155214	322520
20329	29389	22	applied	\N	\N	\N	\N	155215	155215	322521
20329	29395	23	applied	\N	\N	\N	\N	155216	155216	322522
20329	29396	24	applied	\N	\N	\N	\N	155217	155217	322523
20329	29397	25	applied	\N	\N	\N	\N	155218	155218	322524
20329	29404	26	applied	\N	\N	\N	\N	155219	155219	322525
20329	29407	27	applied	\N	\N	\N	\N	155220	155220	322526
20329	29410	28	applied	\N	\N	\N	\N	155221	155221	322527
20329	29411	29	applied	\N	\N	\N	\N	155222	155222	322528
20329	29417	30	applied	\N	\N	\N	\N	155223	155223	322529
20329	29418	31	applied	\N	\N	\N	\N	155224	155224	322530
20329	29420	33	applied	\N	\N	\N	\N	155226	155226	322532
20329	29430	34	applied	\N	\N	\N	\N	155227	155227	322533
20329	29433	35	applied	\N	\N	\N	\N	155228	155228	322534
20349	29669	1	applied	\N	\N	\N	\N	155446	155446	322752
20349	29670	2	applied	\N	\N	\N	\N	155447	155447	322753
20352	29668	0	applied	\N	\N	\N	\N	155454	155454	322760
20352	29669	1	applied	\N	\N	\N	\N	155455	155455	322761
20352	29670	2	applied	\N	\N	\N	\N	155456	155456	322762
20356	29673	0	applied	\N	\N	\N	\N	155465	155465	322771
20356	29674	2	applied	\N	\N	\N	\N	155466	155466	322772
20356	29675	3	applied	\N	\N	\N	\N	155467	155467	322773
20361	29688	0	applied	\N	\N	\N	\N	155526	155526	322832
20361	29689	1	applied	\N	\N	\N	\N	155527	155527	322833
20361	29690	2	applied	\N	\N	\N	\N	155528	155528	322834
20361	29691	3	applied	\N	\N	\N	\N	155529	155529	322835
20366	29701	0	applied	\N	\N	\N	\N	155548	155548	322854
20366	29703	2	applied	\N	\N	\N	\N	155550	155550	322856
20373	29734	0	applied	\N	\N	\N	\N	155614	155614	322920
20373	29735	1	applied	\N	\N	\N	\N	155615	155615	322921
20373	29736	2	applied	\N	\N	\N	\N	155616	155616	322922
20378	29688	0	applied	\N	\N	\N	\N	155629	155629	322935
20378	29731	1	applied	\N	\N	\N	\N	155630	155630	322936
20378	29692	2	applied	\N	\N	\N	\N	155631	155631	322937
20378	29698	3	applied	\N	\N	\N	\N	155632	155632	322938
20378	29701	4	applied	\N	\N	\N	\N	155633	155633	322939
20378	29705	5	applied	\N	\N	\N	\N	155634	155634	322940
20378	29707	6	applied	\N	\N	\N	\N	155635	155635	322941
20378	29708	7	applied	\N	\N	\N	\N	155636	155636	322942
20378	29713	8	applied	\N	\N	\N	\N	155637	155637	322943
20378	29730	9	applied	\N	\N	\N	\N	155638	155638	322944
20378	29734	10	applied	\N	\N	\N	\N	155639	155639	322945
20378	29737	11	applied	\N	\N	\N	\N	155640	155640	322946
20378	29741	13	applied	\N	\N	\N	\N	155642	155642	322948
20378	29689	14	applied	\N	\N	\N	\N	155643	155643	322949
20378	29693	15	applied	\N	\N	\N	\N	155644	155644	322950
20378	29694	16	applied	\N	\N	\N	\N	155645	155645	322951
20378	29695	17	applied	\N	\N	\N	\N	155646	155646	322952
20378	29704	18	applied	\N	\N	\N	\N	155647	155647	322953
20378	29715	19	applied	\N	\N	\N	\N	155648	155648	322954
20378	29690	20	applied	\N	\N	\N	\N	155649	155649	322955
20378	29716	21	applied	\N	\N	\N	\N	155650	155650	322956
20378	29717	22	applied	\N	\N	\N	\N	155651	155651	322957
20378	29691	23	applied	\N	\N	\N	\N	155652	155652	322958
20378	29696	24	applied	\N	\N	\N	\N	155653	155653	322959
20378	29700	25	applied	\N	\N	\N	\N	155654	155654	322960
20378	29703	26	applied	\N	\N	\N	\N	155655	155655	322961
20378	29706	27	applied	\N	\N	\N	\N	155656	155656	322962
20378	29711	28	applied	\N	\N	\N	\N	155657	155657	322963
20378	29729	30	applied	\N	\N	\N	\N	155659	155659	322965
20378	29697	31	applied	\N	\N	\N	\N	155660	155660	322966
20378	29699	32	applied	\N	\N	\N	\N	155661	155661	322967
20378	29702	33	applied	\N	\N	\N	\N	155662	155662	322968
20378	29709	34	applied	\N	\N	\N	\N	155663	155663	322969
20378	29710	35	applied	\N	\N	\N	\N	155664	155664	322970
20378	29714	36	applied	\N	\N	\N	\N	155665	155665	322971
20378	29732	37	applied	\N	\N	\N	\N	155666	155666	322972
20378	29736	38	applied	\N	\N	\N	\N	155667	155667	322973
20378	29738	39	applied	\N	\N	\N	\N	155668	155668	322974
20378	29742	40	applied	\N	\N	\N	\N	155669	155669	322975
20378	29733	41	applied	\N	\N	\N	\N	155670	155670	322976
20378	29735	42	applied	\N	\N	\N	\N	155671	155671	322977
20378	29718	43	applied	\N	\N	\N	\N	155672	155672	322978
20378	29719	44	applied	\N	\N	\N	\N	155673	155673	322979
20378	29720	45	applied	\N	\N	\N	\N	155674	155674	322980
20378	29722	47	applied	\N	\N	\N	\N	155676	155676	322982
20378	29723	48	applied	\N	\N	\N	\N	155677	155677	322983
20378	29739	49	applied	\N	\N	\N	\N	155678	155678	322984
20378	29743	50	applied	\N	\N	\N	\N	155679	155679	322985
20378	29744	51	applied	\N	\N	\N	\N	155680	155680	322986
20378	29724	52	applied	\N	\N	\N	\N	155681	155681	322987
20378	29725	53	applied	\N	\N	\N	\N	155682	155682	322988
20378	29726	54	applied	\N	\N	\N	\N	155683	155683	322989
20378	29727	55	applied	\N	\N	\N	\N	155684	155684	322990
20378	29728	56	applied	\N	\N	\N	\N	155685	155685	322991
20378	29745	57	applied	\N	\N	\N	\N	155686	155686	322992
20380	29746	0	applied	\N	\N	\N	\N	155693	155693	322999
20380	29747	1	applied	\N	\N	\N	\N	155694	155694	323000
20380	29748	2	applied	\N	\N	\N	\N	155695	155695	323001
20385	29731	0	applied	\N	\N	\N	\N	155707	155707	323013
20385	29689	1	applied	\N	\N	\N	\N	155708	155708	323014
20385	29694	3	applied	\N	\N	\N	\N	155710	155710	323016
20385	29695	4	applied	\N	\N	\N	\N	155711	155711	323017
20385	29587	5	applied	\N	\N	\N	\N	155712	155712	323018
20385	29715	6	applied	\N	\N	\N	\N	155713	155713	323019
20385	29716	7	applied	\N	\N	\N	\N	155714	155714	323020
20385	29717	8	applied	\N	\N	\N	\N	155715	155715	323021
20385	29590	9	applied	\N	\N	\N	\N	155716	155716	323022
20385	29591	10	applied	\N	\N	\N	\N	155717	155717	323023
20385	29592	11	applied	\N	\N	\N	\N	155718	155718	323024
20385	29593	12	applied	\N	\N	\N	\N	155719	155719	323025
20385	29718	13	applied	\N	\N	\N	\N	155720	155720	323026
20385	29719	14	applied	\N	\N	\N	\N	155721	155721	323027
20385	29720	15	applied	\N	\N	\N	\N	155722	155722	323028
20385	29721	16	applied	\N	\N	\N	\N	155723	155723	323029
20329	29357	13	applied	\N	\N	\N	\N	155206	155206	322512
20329	29361	14	applied	\N	\N	\N	\N	155207	155207	322513
20329	29448	40	applied	\N	\N	\N	\N	155233	155233	322539
20329	29453	41	applied	\N	\N	\N	\N	155234	155234	322540
20329	29456	42	applied	\N	\N	\N	\N	155235	155235	322541
20329	29459	43	applied	\N	\N	\N	\N	155236	155236	322542
20329	29464	44	applied	\N	\N	\N	\N	155237	155237	322543
20329	29465	45	applied	\N	\N	\N	\N	155238	155238	322544
20329	29471	46	applied	\N	\N	\N	\N	155239	155239	322545
20329	29472	47	applied	\N	\N	\N	\N	155240	155240	322546
20329	29478	48	applied	\N	\N	\N	\N	155241	155241	322547
20329	29479	49	applied	\N	\N	\N	\N	155242	155242	322548
20329	29484	50	applied	\N	\N	\N	\N	155243	155243	322549
20329	29488	51	applied	\N	\N	\N	\N	155244	155244	322550
20329	29491	52	applied	\N	\N	\N	\N	155245	155245	322551
20329	29492	53	applied	\N	\N	\N	\N	155246	155246	322552
20329	29497	54	applied	\N	\N	\N	\N	155247	155247	322553
20329	29498	55	applied	\N	\N	\N	\N	155248	155248	322554
20329	29507	57	applied	\N	\N	\N	\N	155250	155250	322556
20329	29508	58	applied	\N	\N	\N	\N	155251	155251	322557
20329	29509	59	applied	\N	\N	\N	\N	155252	155252	322558
20329	29516	60	applied	\N	\N	\N	\N	155253	155253	322559
20329	29517	61	applied	\N	\N	\N	\N	155254	155254	322560
20329	29523	62	applied	\N	\N	\N	\N	155255	155255	322561
20329	29526	63	applied	\N	\N	\N	\N	155256	155256	322562
20329	29527	64	applied	\N	\N	\N	\N	155257	155257	322563
20329	29533	65	applied	\N	\N	\N	\N	155258	155258	322564
20329	29536	66	applied	\N	\N	\N	\N	155259	155259	322565
20329	29539	67	applied	\N	\N	\N	\N	155260	155260	322566
20329	29543	68	applied	\N	\N	\N	\N	155261	155261	322567
20329	29546	69	applied	\N	\N	\N	\N	155262	155262	322568
20329	29547	70	applied	\N	\N	\N	\N	155263	155263	322569
20329	29553	71	applied	\N	\N	\N	\N	155264	155264	322570
20329	29556	72	applied	\N	\N	\N	\N	155265	155265	322571
20329	29560	74	applied	\N	\N	\N	\N	155267	155267	322573
20329	29566	75	applied	\N	\N	\N	\N	155268	155268	322574
20329	29569	76	applied	\N	\N	\N	\N	155269	155269	322575
20329	29572	77	applied	\N	\N	\N	\N	155270	155270	322576
20329	29576	78	applied	\N	\N	\N	\N	155271	155271	322577
20329	29577	79	applied	\N	\N	\N	\N	155272	155272	322578
20329	29578	80	applied	\N	\N	\N	\N	155273	155273	322579
20329	29586	81	applied	\N	\N	\N	\N	155274	155274	322580
20329	29594	82	applied	\N	\N	\N	\N	155275	155275	322581
20329	29595	83	applied	\N	\N	\N	\N	155276	155276	322582
20329	29600	84	applied	\N	\N	\N	\N	155277	155277	322583
20329	29604	85	applied	\N	\N	\N	\N	155278	155278	322584
20329	29605	86	applied	\N	\N	\N	\N	155279	155279	322585
20329	29587	87	applied	\N	\N	\N	\N	155280	155280	322586
20329	29337	88	applied	\N	\N	\N	\N	155281	155281	322587
20329	29341	89	applied	\N	\N	\N	\N	155282	155282	322588
20329	29350	92	applied	\N	\N	\N	\N	155284	155284	322590
20329	29356	93	applied	\N	\N	\N	\N	155285	155285	322591
20329	29358	94	applied	\N	\N	\N	\N	155286	155286	322592
20329	29338	95	applied	\N	\N	\N	\N	155287	155287	322593
20329	29342	96	applied	\N	\N	\N	\N	155288	155288	322594
20329	29348	97	applied	\N	\N	\N	\N	155289	155289	322595
20329	29351	98	applied	\N	\N	\N	\N	155290	155290	322596
20329	29355	99	applied	\N	\N	\N	\N	155291	155291	322597
20329	29359	100	applied	\N	\N	\N	\N	155292	155292	322598
20329	29362	101	applied	\N	\N	\N	\N	155293	155293	322599
20329	29339	102	applied	\N	\N	\N	\N	155294	155294	322600
20329	29352	103	applied	\N	\N	\N	\N	155295	155295	322601
20329	29369	104	applied	\N	\N	\N	\N	155296	155296	322602
20329	29378	105	applied	\N	\N	\N	\N	155297	155297	322603
20329	29390	106	applied	\N	\N	\N	\N	155298	155298	322604
20329	29400	107	applied	\N	\N	\N	\N	155299	155299	322605
20329	29591	109	applied	\N	\N	\N	\N	155301	155301	322607
20329	29592	110	applied	\N	\N	\N	\N	155302	155302	322608
20329	29593	111	applied	\N	\N	\N	\N	155303	155303	322609
20329	29370	112	applied	\N	\N	\N	\N	155304	155304	322610
20329	29372	113	applied	\N	\N	\N	\N	155305	155305	322611
20329	29379	114	applied	\N	\N	\N	\N	155306	155306	322612
20329	29380	115	applied	\N	\N	\N	\N	155307	155307	322613
20329	29384	116	applied	\N	\N	\N	\N	155308	155308	322614
20329	29386	117	applied	\N	\N	\N	\N	155309	155309	322615
20329	29391	118	applied	\N	\N	\N	\N	155310	155310	322616
20329	29392	119	applied	\N	\N	\N	\N	155311	155311	322617
20329	29398	120	applied	\N	\N	\N	\N	155312	155312	322618
20329	29401	121	applied	\N	\N	\N	\N	155313	155313	322619
20329	29403	122	applied	\N	\N	\N	\N	155314	155314	322620
20329	29406	123	applied	\N	\N	\N	\N	155315	155315	322621
20329	29408	124	applied	\N	\N	\N	\N	155316	155316	322622
20331	29609	0	applied	\N	\N	\N	\N	155322	155322	322628
20331	29610	1	applied	\N	\N	\N	\N	155323	155323	322629
20331	29611	2	applied	\N	\N	\N	\N	155324	155324	322630
20331	29612	3	applied	\N	\N	\N	\N	155325	155325	322631
20334	29619	0	applied	\N	\N	\N	\N	155332	155332	322638
20334	29620	1	applied	\N	\N	\N	\N	155333	155333	322639
20334	29621	2	applied	\N	\N	\N	\N	155334	155334	322640
20334	29622	3	applied	\N	\N	\N	\N	155335	155335	322641
20334	29623	4	applied	\N	\N	\N	\N	155336	155336	322642
20334	29624	5	applied	\N	\N	\N	\N	155337	155337	322643
20334	29625	6	applied	\N	\N	\N	\N	155338	155338	322644
20337	29632	0	applied	\N	\N	\N	\N	155351	155351	322657
20337	29633	1	applied	\N	\N	\N	\N	155352	155352	322658
20337	29634	2	applied	\N	\N	\N	\N	155353	155353	322659
20337	29635	3	applied	\N	\N	\N	\N	155354	155354	322660
20340	29636	0	applied	\N	\N	\N	\N	155367	155367	322673
20340	29638	2	applied	\N	\N	\N	\N	155369	155369	322675
20340	29639	3	applied	\N	\N	\N	\N	155370	155370	322676
20340	29640	4	applied	\N	\N	\N	\N	155371	155371	322677
20340	29641	5	applied	\N	\N	\N	\N	155372	155372	322678
20344	29647	0	applied	\N	\N	\N	\N	155421	155421	322727
20344	29648	1	applied	\N	\N	\N	\N	155422	155422	322728
20344	29649	2	applied	\N	\N	\N	\N	155423	155423	322729
20344	29650	3	applied	\N	\N	\N	\N	155424	155424	322730
20344	29651	4	applied	\N	\N	\N	\N	155425	155425	322731
20344	29652	5	applied	\N	\N	\N	\N	155426	155426	322732
20347	29656	0	applied	\N	\N	\N	\N	155433	155433	322739
20347	29657	1	applied	\N	\N	\N	\N	155434	155434	322740
20347	29658	2	applied	\N	\N	\N	\N	155435	155435	322741
20347	29659	3	applied	\N	\N	\N	\N	155436	155436	322742
20329	29440	37	applied	\N	\N	\N	\N	155230	155230	322536
20329	29443	38	applied	\N	\N	\N	\N	155231	155231	322537
20347	29661	5	applied	\N	\N	\N	\N	155438	155438	322744
20347	29662	6	applied	\N	\N	\N	\N	155439	155439	322745
20347	29663	7	applied	\N	\N	\N	\N	155440	155440	322746
20347	29664	8	applied	\N	\N	\N	\N	155441	155441	322747
20350	29668	0	applied	\N	\N	\N	\N	155448	155448	322754
20350	29669	1	applied	\N	\N	\N	\N	155449	155449	322755
20350	29670	2	applied	\N	\N	\N	\N	155450	155450	322756
20353	29668	0	applied	\N	\N	\N	\N	155457	155457	322763
20353	29669	1	applied	\N	\N	\N	\N	155458	155458	322764
20353	29670	2	applied	\N	\N	\N	\N	155459	155459	322765
20354	29671	0	applied	\N	\N	\N	\N	155460	155460	322766
20354	29672	1	applied	\N	\N	\N	\N	155461	155461	322767
20355	29673	0	applied	\N	\N	\N	\N	155462	155462	322768
20355	29674	2	applied	\N	\N	\N	\N	155463	155463	322769
20355	29675	3	applied	\N	\N	\N	\N	155464	155464	322770
20358	29679	0	applied	\N	\N	\N	\N	155471	155471	322777
20358	29681	2	applied	\N	\N	\N	\N	155473	155473	322779
20358	29682	3	applied	\N	\N	\N	\N	155474	155474	322780
20358	29683	4	applied	\N	\N	\N	\N	155475	155475	322781
20358	29684	5	applied	\N	\N	\N	\N	155476	155476	322782
20359	29642	0	applied	\N	\N	\N	\N	155477	155477	322783
20359	29643	1	applied	\N	\N	\N	\N	155478	155478	322784
20359	29647	2	applied	\N	\N	\N	\N	155479	155479	322785
20359	29648	3	applied	\N	\N	\N	\N	155480	155480	322786
20359	29653	4	applied	\N	\N	\N	\N	155481	155481	322787
20359	29656	5	applied	\N	\N	\N	\N	155482	155482	322788
20359	29657	6	applied	\N	\N	\N	\N	155483	155483	322789
20359	29658	7	applied	\N	\N	\N	\N	155484	155484	322790
20359	29665	8	applied	\N	\N	\N	\N	155485	155485	322791
20359	29668	9	applied	\N	\N	\N	\N	155486	155486	322792
20359	29671	10	applied	\N	\N	\N	\N	155487	155487	322793
20359	29673	11	applied	\N	\N	\N	\N	155488	155488	322794
20359	29679	13	applied	\N	\N	\N	\N	155490	155490	322796
20359	29680	14	applied	\N	\N	\N	\N	155491	155491	322797
20359	29685	15	applied	\N	\N	\N	\N	155492	155492	322798
20359	29644	16	applied	\N	\N	\N	\N	155493	155493	322799
20359	29649	17	applied	\N	\N	\N	\N	155494	155494	322800
20359	29652	18	applied	\N	\N	\N	\N	155495	155495	322801
20359	29654	19	applied	\N	\N	\N	\N	155496	155496	322802
20359	29660	20	applied	\N	\N	\N	\N	155497	155497	322803
20359	29661	21	applied	\N	\N	\N	\N	155498	155498	322804
20359	29662	22	applied	\N	\N	\N	\N	155499	155499	322805
20359	29666	23	applied	\N	\N	\N	\N	155500	155500	322806
20359	29670	24	applied	\N	\N	\N	\N	155501	155501	322807
20359	29675	25	applied	\N	\N	\N	\N	155502	155502	322808
20359	29677	26	applied	\N	\N	\N	\N	155503	155503	322809
20359	29682	27	applied	\N	\N	\N	\N	155504	155504	322810
20359	29683	28	applied	\N	\N	\N	\N	155505	155505	322811
20359	29645	30	applied	\N	\N	\N	\N	155507	155507	322813
20359	29646	31	applied	\N	\N	\N	\N	155508	155508	322814
20359	29650	32	applied	\N	\N	\N	\N	155509	155509	322815
20359	29651	33	applied	\N	\N	\N	\N	155510	155510	322816
20359	29655	34	applied	\N	\N	\N	\N	155511	155511	322817
20359	29659	35	applied	\N	\N	\N	\N	155512	155512	322818
20359	29663	36	applied	\N	\N	\N	\N	155513	155513	322819
20359	29664	37	applied	\N	\N	\N	\N	155514	155514	322820
20359	29667	38	applied	\N	\N	\N	\N	155515	155515	322821
20359	29669	39	applied	\N	\N	\N	\N	155516	155516	322822
20359	29672	40	applied	\N	\N	\N	\N	155517	155517	322823
20359	29674	41	applied	\N	\N	\N	\N	155518	155518	322824
20359	29678	42	applied	\N	\N	\N	\N	155519	155519	322825
20359	29681	43	applied	\N	\N	\N	\N	155520	155520	322826
20359	29684	44	applied	\N	\N	\N	\N	155521	155521	322827
20359	29687	45	applied	\N	\N	\N	\N	155522	155522	322828
20360	29687	1	applied	\N	\N	\N	\N	155524	155524	322830
20360	29686	2	applied	\N	\N	\N	\N	155525	155525	322831
20363	29692	0	applied	\N	\N	\N	\N	155536	155536	322842
20363	29693	1	applied	\N	\N	\N	\N	155537	155537	322843
20363	29694	2	applied	\N	\N	\N	\N	155538	155538	322844
20363	29695	3	applied	\N	\N	\N	\N	155539	155539	322845
20363	29696	4	applied	\N	\N	\N	\N	155540	155540	322846
20363	29697	5	applied	\N	\N	\N	\N	155541	155541	322847
20364	29698	0	applied	\N	\N	\N	\N	155542	155542	322848
20364	29699	1	applied	\N	\N	\N	\N	155543	155543	322849
20364	29700	2	applied	\N	\N	\N	\N	155544	155544	322850
20365	29701	0	applied	\N	\N	\N	\N	155545	155545	322851
20365	29702	1	applied	\N	\N	\N	\N	155546	155546	322852
20365	29703	2	applied	\N	\N	\N	\N	155547	155547	322853
20369	29713	0	applied	\N	\N	\N	\N	155560	155560	322866
20369	29714	1	applied	\N	\N	\N	\N	155561	155561	322867
20369	29716	3	applied	\N	\N	\N	\N	155563	155563	322869
20369	29717	4	applied	\N	\N	\N	\N	155564	155564	322870
20369	29718	5	applied	\N	\N	\N	\N	155565	155565	322871
20369	29719	6	applied	\N	\N	\N	\N	155566	155566	322872
20369	29720	7	applied	\N	\N	\N	\N	155567	155567	322873
20369	29721	8	applied	\N	\N	\N	\N	155568	155568	322874
20369	29722	9	applied	\N	\N	\N	\N	155569	155569	322875
20369	29723	10	applied	\N	\N	\N	\N	155570	155570	322876
20369	29724	11	applied	\N	\N	\N	\N	155571	155571	322877
20369	29725	12	applied	\N	\N	\N	\N	155572	155572	322878
20369	29726	13	applied	\N	\N	\N	\N	155573	155573	322879
20369	29727	14	applied	\N	\N	\N	\N	155574	155574	322880
20369	29728	15	applied	\N	\N	\N	\N	155575	155575	322881
20374	29737	0	applied	\N	\N	\N	\N	155617	155617	322923
20374	29738	1	applied	\N	\N	\N	\N	155618	155618	322924
20374	29739	2	applied	\N	\N	\N	\N	155619	155619	322925
20376	29738	1	applied	\N	\N	\N	\N	155624	155624	322930
20376	29739	2	applied	\N	\N	\N	\N	155625	155625	322931
20381	29749	0	applied	\N	\N	\N	\N	155696	155696	323002
20381	29750	1	applied	\N	\N	\N	\N	155697	155697	323003
20381	29751	2	applied	\N	\N	\N	\N	155698	155698	323004
20383	29752	0	applied	\N	\N	\N	\N	155702	155702	323008
20383	29753	1	applied	\N	\N	\N	\N	155703	155703	323009
20392	29773	0	applied	\N	\N	\N	\N	155762	155762	323068
20392	29774	1	applied	\N	\N	\N	\N	155763	155763	323069
20392	29775	2	applied	\N	\N	\N	\N	155764	155764	323070
20392	29776	3	applied	\N	\N	\N	\N	155765	155765	323071
20392	29777	4	applied	\N	\N	\N	\N	155766	155766	323072
20392	29778	5	applied	\N	\N	\N	\N	155767	155767	323073
20392	29779	6	applied	\N	\N	\N	\N	155768	155768	323074
20346	29654	1	applied	\N	\N	\N	\N	155431	155431	322737
20346	29655	2	applied	\N	\N	\N	\N	155432	155432	322738
20368	29710	3	applied	\N	\N	\N	\N	155557	155557	322863
20368	29711	4	applied	\N	\N	\N	\N	155558	155558	322864
20368	29712	5	applied	\N	\N	\N	\N	155559	155559	322865
20371	29713	0	applied	\N	\N	\N	\N	155593	155593	322899
20371	29714	1	applied	\N	\N	\N	\N	155594	155594	322900
20371	29729	2	applied	\N	\N	\N	\N	155595	155595	322901
20371	29715	3	applied	\N	\N	\N	\N	155596	155596	322902
20371	29716	4	applied	\N	\N	\N	\N	155597	155597	322903
20371	29717	5	applied	\N	\N	\N	\N	155598	155598	322904
20371	29718	6	applied	\N	\N	\N	\N	155599	155599	322905
20371	29719	7	applied	\N	\N	\N	\N	155600	155600	322906
20371	29721	9	applied	\N	\N	\N	\N	155602	155602	322908
20371	29722	10	applied	\N	\N	\N	\N	155603	155603	322909
20371	29723	11	applied	\N	\N	\N	\N	155604	155604	322910
20371	29724	12	applied	\N	\N	\N	\N	155605	155605	322911
20371	29725	13	applied	\N	\N	\N	\N	155606	155606	322912
20371	29726	14	applied	\N	\N	\N	\N	155607	155607	322913
20371	29727	15	applied	\N	\N	\N	\N	155608	155608	322914
20371	29728	16	applied	\N	\N	\N	\N	155609	155609	322915
20385	29722	17	applied	\N	\N	\N	\N	155724	155724	323030
20385	29723	18	applied	\N	\N	\N	\N	155725	155725	323031
20385	29639	19	applied	\N	\N	\N	\N	155726	155726	323032
20385	29640	20	applied	\N	\N	\N	\N	155727	155727	323033
20385	29641	21	applied	\N	\N	\N	\N	155728	155728	323034
20385	29757	22	applied	\N	\N	\N	\N	155729	155729	323035
20385	29724	23	applied	\N	\N	\N	\N	155730	155730	323036
20385	29725	24	applied	\N	\N	\N	\N	155731	155731	323037
20385	29727	26	applied	\N	\N	\N	\N	155733	155733	323039
20385	29728	27	applied	\N	\N	\N	\N	155734	155734	323040
20387	29758	0	applied	\N	\N	\N	\N	155738	155738	323044
20387	29759	1	applied	\N	\N	\N	\N	155739	155739	323045
20387	29760	2	applied	\N	\N	\N	\N	155740	155740	323046
20390	29770	0	applied	\N	\N	\N	\N	155750	155750	323056
20390	29771	1	applied	\N	\N	\N	\N	155751	155751	323057
20390	29772	2	applied	\N	\N	\N	\N	155752	155752	323058
20391	29773	0	applied	\N	\N	\N	\N	155753	155753	323059
20391	29774	1	applied	\N	\N	\N	\N	155754	155754	323060
20391	29775	2	applied	\N	\N	\N	\N	155755	155755	323061
20391	29776	3	applied	\N	\N	\N	\N	155756	155756	323062
20391	29777	4	applied	\N	\N	\N	\N	155757	155757	323063
20391	29778	5	applied	\N	\N	\N	\N	155758	155758	323064
20391	29779	6	applied	\N	\N	\N	\N	155759	155759	323065
20391	29780	7	applied	\N	\N	\N	\N	155760	155760	323066
20393	29782	0	applied	\N	\N	\N	\N	155771	155771	323077
20396	29782	0	applied	\N	\N	\N	\N	155778	155778	323084
20396	29783	1	applied	\N	\N	\N	\N	155779	155779	323085
20396	29784	2	applied	\N	\N	\N	\N	155780	155780	323086
20400	29787	0	applied	\N	\N	\N	\N	155910	155910	323216
20400	29788	1	applied	\N	\N	\N	\N	155911	155911	323217
20400	29789	2	applied	\N	\N	\N	\N	155912	155912	323218
20409	29814	0	applied	\N	\N	\N	\N	155988	155988	323294
20409	29819	1	applied	\N	\N	\N	\N	155989	155989	323295
20409	29815	2	applied	\N	\N	\N	\N	155990	155990	323296
20409	29816	3	applied	\N	\N	\N	\N	155991	155991	323297
20409	29817	4	applied	\N	\N	\N	\N	155992	155992	323298
20409	29818	5	applied	\N	\N	\N	\N	155993	155993	323299
20413	29820	0	applied	\N	\N	\N	\N	156012	156012	323318
20413	29825	1	applied	\N	\N	\N	\N	156013	156013	323319
20413	29826	2	applied	\N	\N	\N	\N	156014	156014	323320
20413	29819	4	applied	\N	\N	\N	\N	156016	156016	323322
20413	29822	5	applied	\N	\N	\N	\N	156017	156017	323323
20413	29823	6	applied	\N	\N	\N	\N	156018	156018	323324
20413	29827	7	applied	\N	\N	\N	\N	156019	156019	323325
20413	29824	8	applied	\N	\N	\N	\N	156020	156020	323326
20413	29828	9	applied	\N	\N	\N	\N	156021	156021	323327
20413	29829	10	applied	\N	\N	\N	\N	156022	156022	323328
20413	29830	11	applied	\N	\N	1000000000	\N	156023	156023	323329
20413	29831	12	applied	\N	\N	1000000000	\N	156024	156024	323330
20413	29832	13	applied	\N	\N	1000000000	\N	156025	156025	323331
20413	29833	14	applied	\N	\N	\N	\N	156026	156026	323332
20413	29834	15	applied	\N	\N	\N	\N	156027	156027	323333
20420	29840	0	applied	\N	\N	\N	\N	156069	156069	323375
20420	29841	1	applied	\N	\N	\N	\N	156070	156070	323376
20420	29842	2	applied	\N	\N	\N	\N	156071	156071	323377
20420	29843	3	applied	\N	\N	\N	\N	156072	156072	323378
20420	29845	5	applied	\N	\N	\N	\N	156074	156074	323380
20422	29846	0	applied	\N	\N	\N	\N	156081	156081	323387
20422	29847	1	applied	\N	\N	\N	\N	156082	156082	323388
20422	29848	2	applied	\N	\N	\N	\N	156083	156083	323389
20425	29852	0	applied	\N	\N	\N	\N	156090	156090	323396
20425	29853	1	applied	\N	\N	\N	\N	156091	156091	323397
20425	29854	3	applied	\N	\N	\N	\N	156092	156092	323398
20427	29852	0	applied	\N	\N	\N	\N	156096	156096	323402
20427	29853	1	applied	\N	\N	\N	\N	156097	156097	323403
20427	29854	3	applied	\N	\N	\N	\N	156098	156098	323404
20429	29855	0	applied	\N	\N	\N	\N	156102	156102	323408
20431	29856	0	applied	\N	\N	\N	\N	156111	156111	323417
20431	29857	1	applied	\N	\N	\N	\N	156112	156112	323418
20431	29855	2	applied	\N	\N	\N	\N	156113	156113	323419
20431	29858	3	applied	\N	\N	\N	\N	156114	156114	323420
20431	29859	4	applied	\N	\N	\N	\N	156115	156115	323421
20431	29861	6	applied	\N	\N	\N	\N	156117	156117	323423
20431	29862	7	applied	\N	\N	\N	\N	156118	156118	323424
20434	29863	0	applied	\N	\N	\N	\N	156131	156131	323437
20434	29864	1	applied	\N	\N	\N	\N	156132	156132	323438
20434	29865	2	applied	\N	\N	\N	\N	156133	156133	323439
20434	29866	3	applied	\N	\N	\N	\N	156134	156134	323440
20434	29868	4	applied	\N	\N	\N	\N	156135	156135	323441
20436	29869	0	applied	\N	\N	\N	\N	156146	156146	323452
20436	29870	1	applied	\N	\N	\N	\N	156147	156147	323453
20436	29878	2	applied	\N	\N	\N	\N	156148	156148	323454
20436	29867	3	applied	\N	\N	\N	\N	156149	156149	323455
20436	29871	4	applied	\N	\N	\N	\N	156150	156150	323456
20436	29872	5	applied	\N	\N	\N	\N	156151	156151	323457
20436	29873	6	applied	\N	\N	\N	\N	156152	156152	323458
20436	29874	7	applied	\N	\N	\N	\N	156153	156153	323459
20436	29875	8	applied	\N	\N	\N	\N	156154	156154	323460
20436	29877	10	applied	\N	\N	\N	\N	156156	156156	323462
20438	29869	0	applied	\N	\N	\N	\N	156168	156168	323474
20368	29708	1	applied	\N	\N	\N	\N	155555	155555	322861
20368	29709	2	applied	\N	\N	\N	\N	155556	155556	322862
20393	29784	2	applied	\N	\N	\N	\N	155773	155773	323079
20394	29782	0	applied	\N	\N	\N	\N	155774	155774	323080
20397	29782	0	applied	\N	\N	\N	\N	155781	155781	323087
20397	29783	1	applied	\N	\N	\N	\N	155782	155782	323088
20397	29784	2	applied	\N	\N	\N	\N	155783	155783	323089
20398	29785	0	applied	\N	\N	\N	\N	155784	155784	323090
20398	29786	1	applied	\N	\N	\N	\N	155785	155785	323091
20401	29787	0	applied	\N	\N	\N	\N	155913	155913	323219
20401	29788	1	applied	\N	\N	\N	\N	155914	155914	323220
20403	29790	0	applied	\N	\N	\N	\N	155947	155947	323253
20403	29791	1	applied	\N	\N	\N	\N	155948	155948	323254
20403	29792	2	applied	\N	\N	\N	\N	155949	155949	323255
20404	29793	0	applied	\N	\N	\N	\N	155950	155950	323256
20404	29794	1	applied	\N	\N	\N	\N	155951	155951	323257
20404	29795	2	applied	\N	\N	\N	\N	155952	155952	323258
20404	29796	3	applied	\N	\N	\N	\N	155953	155953	323259
20404	29797	4	applied	\N	\N	\N	\N	155954	155954	323260
20404	29798	5	applied	\N	\N	\N	\N	155955	155955	323261
20404	29799	6	applied	\N	\N	\N	\N	155956	155956	323262
20404	29800	7	applied	\N	\N	\N	\N	155957	155957	323263
20404	29801	8	applied	\N	\N	\N	\N	155958	155958	323264
20404	29802	9	applied	\N	\N	\N	\N	155959	155959	323265
20404	29803	10	applied	\N	\N	\N	\N	155960	155960	323266
20404	29804	11	applied	\N	\N	\N	\N	155961	155961	323267
20405	29793	0	applied	\N	\N	\N	\N	155962	155962	323268
20405	29795	2	applied	\N	\N	\N	\N	155964	155964	323270
20405	29796	3	applied	\N	\N	\N	\N	155965	155965	323271
20405	29797	4	applied	\N	\N	\N	\N	155966	155966	323272
20405	29798	5	applied	\N	\N	\N	\N	155967	155967	323273
20405	29799	6	applied	\N	\N	\N	\N	155968	155968	323274
20405	29800	7	applied	\N	\N	\N	\N	155969	155969	323275
20405	29801	8	applied	\N	\N	\N	\N	155970	155970	323276
20405	29802	9	applied	\N	\N	\N	\N	155971	155971	323277
20405	29803	10	applied	\N	\N	\N	\N	155972	155972	323278
20405	29804	11	applied	\N	\N	\N	\N	155973	155973	323279
20406	29805	0	applied	\N	\N	\N	\N	155974	155974	323280
20406	29806	1	applied	\N	\N	\N	\N	155975	155975	323281
20406	29807	2	applied	\N	\N	\N	\N	155976	155976	323282
20407	29808	0	applied	\N	\N	\N	\N	155977	155977	323283
20407	29809	1	applied	\N	\N	\N	\N	155978	155978	323284
20407	29810	2	applied	\N	\N	\N	\N	155979	155979	323285
20407	29812	4	applied	\N	\N	\N	\N	155981	155981	323287
20407	29813	5	applied	\N	\N	\N	\N	155982	155982	323288
20410	29814	0	applied	\N	\N	\N	\N	155994	155994	323300
20410	29819	1	applied	\N	\N	\N	\N	155995	155995	323301
20410	29815	2	applied	\N	\N	\N	\N	155996	155996	323302
20410	29816	3	applied	\N	\N	\N	\N	155997	155997	323303
20410	29817	4	applied	\N	\N	\N	\N	155998	155998	323304
20410	29818	5	applied	\N	\N	\N	\N	155999	155999	323305
20416	29835	0	applied	\N	\N	\N	\N	156048	156048	323354
20416	29836	1	applied	\N	\N	\N	\N	156049	156049	323355
20416	29837	2	applied	\N	\N	1000000000	\N	156050	156050	323356
20416	29838	3	applied	\N	\N	\N	\N	156051	156051	323357
20416	29839	4	applied	\N	\N	1000000000	\N	156052	156052	323358
20421	29840	0	applied	\N	\N	\N	\N	156075	156075	323381
20421	29841	1	applied	\N	\N	\N	\N	156076	156076	323382
20421	29842	2	applied	\N	\N	\N	\N	156077	156077	323383
20421	29844	4	applied	\N	\N	\N	\N	156079	156079	323385
20421	29845	5	applied	\N	\N	\N	\N	156080	156080	323386
20423	29849	0	applied	\N	\N	\N	\N	156084	156084	323390
20423	29850	1	applied	\N	\N	\N	\N	156085	156085	323391
20423	29851	2	applied	\N	\N	\N	\N	156086	156086	323392
20426	29852	0	applied	\N	\N	\N	\N	156093	156093	323399
20426	29853	1	applied	\N	\N	\N	\N	156094	156094	323400
20426	29854	3	applied	\N	\N	\N	\N	156095	156095	323401
20432	29863	0	applied	\N	\N	\N	\N	156119	156119	323425
20432	29864	1	applied	\N	\N	\N	\N	156120	156120	323426
20432	29865	2	applied	\N	\N	\N	\N	156121	156121	323427
20432	29866	3	applied	\N	\N	\N	\N	156122	156122	323428
20432	29867	4	applied	\N	\N	\N	\N	156123	156123	323429
20432	29868	5	applied	\N	\N	\N	\N	156124	156124	323430
20437	29869	0	applied	\N	\N	\N	\N	156157	156157	323463
20437	29870	1	applied	\N	\N	\N	\N	156158	156158	323464
20437	29867	3	applied	\N	\N	\N	\N	156160	156160	323466
20437	29871	4	applied	\N	\N	\N	\N	156161	156161	323467
20437	29872	5	applied	\N	\N	\N	\N	156162	156162	323468
20437	29873	6	applied	\N	\N	\N	\N	156163	156163	323469
20437	29874	7	applied	\N	\N	\N	\N	156164	156164	323470
20437	29875	8	applied	\N	\N	\N	\N	156165	156165	323471
20437	29876	9	applied	\N	\N	\N	\N	156166	156166	323472
20437	29877	10	applied	\N	\N	\N	\N	156167	156167	323473
20443	29885	0	applied	\N	\N	\N	\N	156189	156189	323495
20443	29886	1	applied	\N	\N	\N	\N	156190	156190	323496
20448	29891	0	applied	\N	\N	\N	\N	156202	156202	323508
20448	29892	1	applied	\N	\N	\N	\N	156203	156203	323509
20448	29893	2	applied	\N	\N	\N	\N	156204	156204	323510
20452	29897	0	applied	\N	\N	\N	\N	156214	156214	323520
20452	29899	2	applied	\N	\N	\N	\N	156216	156216	323522
20452	29900	3	applied	\N	\N	\N	\N	156217	156217	323523
20452	29901	4	applied	\N	\N	\N	\N	156218	156218	323524
20452	29902	5	applied	\N	\N	\N	\N	156219	156219	323525
20456	29903	0	applied	\N	\N	\N	\N	156238	156238	323544
20456	29904	1	applied	\N	\N	\N	\N	156239	156239	323545
20456	29905	2	applied	\N	\N	\N	\N	156240	156240	323546
20459	29906	0	applied	\N	\N	\N	\N	156247	156247	323553
20459	29907	1	applied	\N	\N	\N	\N	156248	156248	323554
20459	29908	2	applied	\N	\N	\N	\N	156249	156249	323555
20465	29915	0	applied	\N	\N	\N	\N	156263	156263	323569
20465	29916	1	applied	\N	\N	\N	\N	156264	156264	323570
20465	29917	2	applied	\N	\N	\N	\N	156265	156265	323571
20470	29927	0	applied	\N	\N	\N	\N	156404	156404	323710
20470	29928	1	applied	\N	\N	\N	\N	156405	156405	323711
20470	29929	2	applied	\N	\N	\N	\N	156406	156406	323712
20473	29933	0	applied	\N	\N	\N	\N	156414	156414	323720
20473	29934	1	applied	\N	\N	\N	\N	156415	156415	323721
20473	29935	2	applied	\N	\N	\N	\N	156416	156416	323722
20473	29936	3	applied	\N	\N	\N	\N	156417	156417	323723
20478	29746	1	applied	\N	\N	\N	\N	156430	156430	323736
20478	29749	2	applied	\N	\N	\N	\N	156431	156431	323737
20392	29781	8	applied	\N	\N	\N	\N	155770	155770	323076
20393	29783	1	applied	\N	\N	\N	\N	155772	155772	323078
20399	29609	1	applied	\N	\N	\N	\N	155787	155787	323093
20399	29613	2	applied	\N	\N	\N	\N	155788	155788	323094
20399	29616	3	applied	\N	\N	\N	\N	155789	155789	323095
20399	29619	4	applied	\N	\N	\N	\N	155790	155790	323096
20399	29620	5	applied	\N	\N	\N	\N	155791	155791	323097
20399	29627	7	applied	\N	\N	\N	\N	155793	155793	323099
20399	29632	8	applied	\N	\N	\N	\N	155794	155794	323100
20399	29636	9	applied	\N	\N	\N	\N	155795	155795	323101
20399	29642	10	applied	\N	\N	\N	\N	155796	155796	323102
20399	29643	11	applied	\N	\N	\N	\N	155797	155797	323103
20399	29647	12	applied	\N	\N	\N	\N	155798	155798	323104
20399	29648	13	applied	\N	\N	\N	\N	155799	155799	323105
20399	29653	14	applied	\N	\N	\N	\N	155800	155800	323106
20399	29656	15	applied	\N	\N	\N	\N	155801	155801	323107
20399	29657	16	applied	\N	\N	\N	\N	155802	155802	323108
20399	29658	17	applied	\N	\N	\N	\N	155803	155803	323109
20399	29665	18	applied	\N	\N	\N	\N	155804	155804	323110
20399	29668	19	applied	\N	\N	\N	\N	155805	155805	323111
20399	29671	20	applied	\N	\N	\N	\N	155806	155806	323112
20399	29673	21	applied	\N	\N	\N	\N	155807	155807	323113
20411	29814	0	applied	\N	\N	\N	\N	156000	156000	323306
20411	29815	2	applied	\N	\N	\N	\N	156002	156002	323308
20411	29816	3	applied	\N	\N	\N	\N	156003	156003	323309
20411	29817	4	applied	\N	\N	\N	\N	156004	156004	323310
20411	29818	5	applied	\N	\N	\N	\N	156005	156005	323311
20414	29825	0	applied	\N	\N	\N	\N	156028	156028	323334
20414	29826	1	applied	\N	\N	\N	\N	156029	156029	323335
20414	29828	2	applied	\N	\N	\N	\N	156030	156030	323336
20414	29829	3	applied	\N	\N	\N	\N	156031	156031	323337
20414	29827	4	applied	\N	\N	\N	\N	156032	156032	323338
20414	29830	5	applied	\N	\N	1000000000	\N	156033	156033	323339
20414	29831	6	applied	\N	\N	1000000000	\N	156034	156034	323340
20414	29832	7	applied	\N	\N	1000000000	\N	156035	156035	323341
20414	29833	8	applied	\N	\N	\N	\N	156036	156036	323342
20414	29834	9	applied	\N	\N	\N	\N	156037	156037	323343
20417	29835	0	applied	\N	\N	\N	\N	156053	156053	323359
20417	29836	1	applied	\N	\N	\N	\N	156054	156054	323360
20417	29838	3	applied	\N	\N	\N	\N	156056	156056	323362
20417	29839	4	applied	\N	\N	1000000000	\N	156057	156057	323363
20419	29840	0	applied	\N	\N	\N	\N	156063	156063	323369
20419	29841	1	applied	\N	\N	\N	\N	156064	156064	323370
20419	29842	2	applied	\N	\N	\N	\N	156065	156065	323371
20419	29843	3	applied	\N	\N	\N	\N	156066	156066	323372
20419	29844	4	applied	\N	\N	\N	\N	156067	156067	323373
20419	29845	5	applied	\N	\N	\N	\N	156068	156068	323374
20430	29856	0	applied	\N	\N	\N	\N	156103	156103	323409
20430	29857	1	applied	\N	\N	\N	\N	156104	156104	323410
20430	29855	2	applied	\N	\N	\N	\N	156105	156105	323411
20430	29858	3	applied	\N	\N	\N	\N	156106	156106	323412
20430	29859	4	applied	\N	\N	\N	\N	156107	156107	323413
20430	29860	5	applied	\N	\N	\N	\N	156108	156108	323414
20430	29861	6	applied	\N	\N	\N	\N	156109	156109	323415
20430	29862	7	applied	\N	\N	\N	\N	156110	156110	323416
20433	29863	0	applied	\N	\N	\N	\N	156125	156125	323431
20433	29864	1	applied	\N	\N	\N	\N	156126	156126	323432
20433	29866	3	applied	\N	\N	\N	\N	156128	156128	323434
20433	29867	4	applied	\N	\N	\N	\N	156129	156129	323435
20433	29868	5	applied	\N	\N	\N	\N	156130	156130	323436
20439	29879	0	applied	\N	\N	\N	\N	156178	156178	323484
20439	29880	1	applied	\N	\N	\N	\N	156179	156179	323485
20439	29881	2	applied	\N	\N	\N	\N	156180	156180	323486
20444	29885	0	applied	\N	\N	\N	\N	156191	156191	323497
20444	29886	1	applied	\N	\N	\N	\N	156192	156192	323498
20449	29891	0	applied	\N	\N	\N	\N	156205	156205	323511
20449	29892	1	applied	\N	\N	\N	\N	156206	156206	323512
20449	29893	2	applied	\N	\N	\N	\N	156207	156207	323513
20453	29897	0	applied	\N	\N	\N	\N	156220	156220	323526
20453	29898	1	applied	\N	\N	1000000000	\N	156221	156221	323527
20453	29899	2	applied	\N	\N	\N	\N	156222	156222	323528
20453	29900	3	applied	\N	\N	\N	\N	156223	156223	323529
20453	29901	4	applied	\N	\N	\N	\N	156224	156224	323530
20457	29906	0	applied	\N	\N	\N	\N	156241	156241	323547
20457	29907	1	applied	\N	\N	\N	\N	156242	156242	323548
20457	29908	2	applied	\N	\N	\N	\N	156243	156243	323549
20460	29906	0	applied	\N	\N	\N	\N	156250	156250	323556
20460	29907	1	applied	\N	\N	\N	\N	156251	156251	323557
20461	29909	0	applied	\N	\N	\N	\N	156252	156252	323558
20461	29910	1	applied	\N	\N	\N	\N	156253	156253	323559
20461	29911	2	applied	\N	\N	\N	\N	156254	156254	323560
20466	29918	0	applied	\N	\N	\N	\N	156266	156266	323572
20466	29919	1	applied	\N	\N	\N	\N	156267	156267	323573
20466	29920	2	applied	\N	\N	\N	\N	156268	156268	323574
20466	29917	3	applied	\N	\N	\N	\N	156269	156269	323575
20466	29921	4	applied	\N	\N	\N	\N	156270	156270	323576
20468	29923	0	applied	\N	\N	\N	\N	156396	156396	323702
20468	29924	1	applied	\N	\N	\N	\N	156397	156397	323703
20468	29925	2	applied	\N	\N	\N	\N	156398	156398	323704
20475	29938	0	applied	\N	\N	\N	\N	156419	156419	323725
20475	29937	1	applied	\N	\N	\N	\N	156420	156420	323726
20476	29939	0	applied	\N	\N	\N	\N	156421	156421	323727
20476	29940	1	applied	\N	\N	\N	\N	156422	156422	323728
20476	29941	2	applied	\N	\N	\N	\N	156423	156423	323729
20476	29942	3	applied	\N	\N	\N	\N	156424	156424	323730
20482	29969	0	applied	\N	\N	\N	\N	156582	156582	323888
20482	29970	1	applied	\N	\N	\N	\N	156583	156583	323889
20487	29976	0	applied	\N	\N	\N	\N	156629	156629	323935
20487	29977	1	applied	\N	\N	\N	\N	156630	156630	323936
20487	29978	2	applied	\N	\N	\N	\N	156631	156631	323937
20487	29979	3	applied	\N	\N	\N	\N	156632	156632	323938
20487	29980	4	applied	\N	\N	\N	\N	156633	156633	323939
20487	29981	5	applied	\N	\N	\N	\N	156634	156634	323940
20495	30001	0	applied	\N	\N	\N	\N	156667	156667	323973
20495	30002	1	applied	\N	\N	\N	\N	156668	156668	323974
20500	30004	1	applied	\N	\N	\N	\N	156679	156679	323985
20500	30005	2	applied	\N	\N	\N	\N	156680	156680	323986
20500	30006	3	applied	\N	\N	\N	\N	156681	156681	323987
20505	30010	0	applied	\N	\N	\N	\N	156692	156692	323998
20505	30011	1	applied	\N	\N	\N	\N	156693	156693	323999
20505	30012	2	applied	\N	\N	\N	\N	156694	156694	324000
20395	29784	2	applied	\N	\N	\N	\N	155777	155777	323083
20399	29731	0	applied	\N	\N	\N	\N	155786	155786	323092
20399	29688	26	applied	\N	\N	\N	\N	155812	155812	323118
20399	29692	27	applied	\N	\N	\N	\N	155813	155813	323119
20399	29698	28	applied	\N	\N	\N	\N	155814	155814	323120
20399	29701	29	applied	\N	\N	\N	\N	155815	155815	323121
20399	29705	30	applied	\N	\N	\N	\N	155816	155816	323122
20399	29707	31	applied	\N	\N	\N	\N	155817	155817	323123
20399	29708	32	applied	\N	\N	\N	\N	155818	155818	323124
20399	29713	33	applied	\N	\N	\N	\N	155819	155819	323125
20399	29730	34	applied	\N	\N	\N	\N	155820	155820	323126
20399	29734	35	applied	\N	\N	\N	\N	155821	155821	323127
20399	29737	36	applied	\N	\N	\N	\N	155822	155822	323128
20399	29740	37	applied	\N	\N	\N	\N	155823	155823	323129
20399	29741	38	applied	\N	\N	\N	\N	155824	155824	323130
20399	29746	39	applied	\N	\N	\N	\N	155825	155825	323131
20399	29749	40	applied	\N	\N	\N	\N	155826	155826	323132
20399	29752	41	applied	\N	\N	\N	\N	155827	155827	323133
20399	29758	43	applied	\N	\N	\N	\N	155829	155829	323135
20399	29761	44	applied	\N	\N	\N	\N	155830	155830	323136
20399	29762	45	applied	\N	\N	\N	\N	155831	155831	323137
20399	29763	46	applied	\N	\N	\N	\N	155832	155832	323138
20399	29770	47	applied	\N	\N	\N	\N	155833	155833	323139
20399	29773	48	applied	\N	\N	\N	\N	155834	155834	323140
20399	29774	49	applied	\N	\N	\N	\N	155835	155835	323141
20399	29775	50	applied	\N	\N	\N	\N	155836	155836	323142
20399	29782	51	applied	\N	\N	\N	\N	155837	155837	323143
20399	29689	52	applied	\N	\N	\N	\N	155838	155838	323144
20399	29693	53	applied	\N	\N	\N	\N	155839	155839	323145
20399	29694	54	applied	\N	\N	\N	\N	155840	155840	323146
20399	29695	55	applied	\N	\N	\N	\N	155841	155841	323147
20399	29415	56	applied	\N	\N	\N	\N	155842	155842	323148
20399	29421	57	applied	\N	\N	\N	\N	155843	155843	323149
20399	29715	58	applied	\N	\N	\N	\N	155844	155844	323150
20399	29424	60	applied	\N	\N	\N	\N	155846	155846	323152
20399	29425	61	applied	\N	\N	\N	\N	155847	155847	323153
20399	29431	62	applied	\N	\N	\N	\N	155848	155848	323154
20399	29716	63	applied	\N	\N	\N	\N	155849	155849	323155
20399	29717	64	applied	\N	\N	\N	\N	155850	155850	323156
20399	29438	65	applied	\N	\N	\N	\N	155851	155851	323157
20399	29439	66	applied	\N	\N	\N	\N	155852	155852	323158
20399	29442	67	applied	\N	\N	\N	\N	155853	155853	323159
20399	29446	68	applied	\N	\N	\N	\N	155854	155854	323160
20399	29449	69	applied	\N	\N	\N	\N	155855	155855	323161
20399	29450	70	applied	\N	\N	\N	\N	155856	155856	323162
20399	29455	71	applied	\N	\N	\N	\N	155857	155857	323163
20399	29458	72	applied	\N	\N	\N	\N	155858	155858	323164
20399	29460	73	applied	\N	\N	\N	\N	155859	155859	323165
20399	29462	74	applied	\N	\N	\N	\N	155860	155860	323166
20399	29467	75	applied	\N	\N	\N	\N	155861	155861	323167
20399	29475	77	applied	\N	\N	\N	\N	155863	155863	323169
20399	29476	78	applied	\N	\N	\N	\N	155864	155864	323170
20399	29718	79	applied	\N	\N	\N	\N	155865	155865	323171
20399	29719	80	applied	\N	\N	\N	\N	155866	155866	323172
20399	29720	81	applied	\N	\N	\N	\N	155867	155867	323173
20399	29721	82	applied	\N	\N	\N	\N	155868	155868	323174
20399	29722	83	applied	\N	\N	\N	\N	155869	155869	323175
20399	29723	84	applied	\N	\N	\N	\N	155870	155870	323176
20399	29482	85	applied	\N	\N	\N	\N	155871	155871	323177
20399	29483	86	applied	\N	\N	\N	\N	155872	155872	323178
20399	29486	87	applied	\N	\N	\N	\N	155873	155873	323179
20399	29490	88	applied	\N	\N	\N	\N	155874	155874	323180
20399	29493	91	applied	\N	\N	\N	\N	155875	155875	323181
20399	29494	92	applied	\N	\N	\N	\N	155876	155876	323182
20399	29502	93	applied	\N	\N	\N	\N	155877	155877	323183
20399	29503	94	applied	\N	\N	\N	\N	155878	155878	323184
20399	29511	96	applied	\N	\N	\N	\N	155880	155880	323186
20399	29512	97	applied	\N	\N	\N	\N	155881	155881	323187
20399	29513	98	applied	\N	\N	\N	\N	155882	155882	323188
20399	29519	99	applied	\N	\N	\N	\N	155883	155883	323189
20399	29520	100	applied	\N	\N	\N	\N	155884	155884	323190
20399	29525	101	applied	\N	\N	\N	\N	155885	155885	323191
20399	29529	102	applied	\N	\N	\N	\N	155886	155886	323192
20399	29530	103	applied	\N	\N	\N	\N	155887	155887	323193
20399	29535	104	applied	\N	\N	\N	\N	155888	155888	323194
20399	29538	105	applied	\N	\N	\N	\N	155889	155889	323195
20399	29542	106	applied	\N	\N	\N	\N	155890	155890	323196
20399	29544	107	applied	\N	\N	\N	\N	155891	155891	323197
20399	29550	108	applied	\N	\N	\N	\N	155892	155892	323198
20399	29551	109	applied	\N	\N	\N	\N	155893	155893	323199
20399	29554	110	applied	\N	\N	\N	\N	155894	155894	323200
20399	29363	111	applied	\N	\N	\N	\N	155895	155895	323201
20399	29373	113	applied	\N	\N	\N	\N	155897	155897	323203
20399	29377	114	applied	\N	\N	\N	\N	155898	155898	323204
20399	29381	115	applied	\N	\N	\N	\N	155899	155899	323205
20399	29385	116	applied	\N	\N	\N	\N	155900	155900	323206
20399	29387	117	applied	\N	\N	\N	\N	155901	155901	323207
20399	29393	118	applied	\N	\N	\N	\N	155902	155902	323208
20399	29394	119	applied	\N	\N	\N	\N	155903	155903	323209
20399	29399	120	applied	\N	\N	\N	\N	155904	155904	323210
20399	29402	121	applied	\N	\N	\N	\N	155905	155905	323211
20399	29405	122	applied	\N	\N	\N	\N	155906	155906	323212
20399	29409	123	applied	\N	\N	\N	\N	155907	155907	323213
20399	29412	124	applied	\N	\N	\N	\N	155908	155908	323214
20399	29413	125	applied	\N	\N	\N	\N	155909	155909	323215
20402	29740	0	applied	\N	\N	\N	\N	155916	155916	323222
20402	29741	1	applied	\N	\N	\N	\N	155917	155917	323223
20402	29746	2	applied	\N	\N	\N	\N	155918	155918	323224
20402	29752	4	applied	\N	\N	\N	\N	155920	155920	323226
20402	29754	5	applied	\N	\N	\N	\N	155921	155921	323227
20402	29758	6	applied	\N	\N	\N	\N	155922	155922	323228
20402	29761	7	applied	\N	\N	\N	\N	155923	155923	323229
20402	29762	8	applied	\N	\N	\N	\N	155924	155924	323230
20402	29763	9	applied	\N	\N	\N	\N	155925	155925	323231
20402	29770	10	applied	\N	\N	\N	\N	155926	155926	323232
20402	29773	11	applied	\N	\N	\N	\N	155927	155927	323233
20402	29774	12	applied	\N	\N	\N	\N	155928	155928	323234
20402	29775	13	applied	\N	\N	\N	\N	155929	155929	323235
20402	29782	14	applied	\N	\N	\N	\N	155930	155930	323236
20402	29785	15	applied	\N	\N	\N	\N	155931	155931	323237
20402	29787	16	applied	\N	\N	\N	\N	155932	155932	323238
20402	29790	17	applied	\N	\N	\N	\N	155933	155933	323239
20399	29679	23	applied	\N	\N	\N	\N	155809	155809	323115
20399	29680	24	applied	\N	\N	\N	\N	155810	155810	323116
20402	29750	21	applied	\N	\N	\N	\N	155937	155937	323243
20402	29756	23	applied	\N	\N	\N	\N	155939	155939	323245
20402	29759	24	applied	\N	\N	\N	\N	155940	155940	323246
20402	29764	25	applied	\N	\N	\N	\N	155941	155941	323247
20402	29768	26	applied	\N	\N	\N	\N	155942	155942	323248
20402	29769	27	applied	\N	\N	\N	\N	155943	155943	323249
20402	29772	28	applied	\N	\N	\N	\N	155944	155944	323250
20402	29776	29	applied	\N	\N	\N	\N	155945	155945	323251
20402	29780	30	applied	\N	\N	\N	\N	155946	155946	323252
20408	29814	0	applied	\N	\N	\N	\N	155983	155983	323289
20408	29815	1	applied	\N	\N	\N	\N	155984	155984	323290
20408	29816	2	applied	\N	\N	\N	\N	155985	155985	323291
20408	29817	3	applied	\N	\N	\N	\N	155986	155986	323292
20408	29818	4	applied	\N	\N	\N	\N	155987	155987	323293
20412	29820	0	applied	\N	\N	\N	\N	156006	156006	323312
20412	29821	1	applied	\N	\N	\N	\N	156007	156007	323313
20412	29819	2	applied	\N	\N	\N	\N	156008	156008	323314
20412	29823	4	applied	\N	\N	\N	\N	156010	156010	323316
20412	29824	5	applied	\N	\N	\N	\N	156011	156011	323317
20415	29825	0	applied	\N	\N	\N	\N	156038	156038	323344
20415	29826	1	applied	\N	\N	\N	\N	156039	156039	323345
20415	29828	2	applied	\N	\N	\N	\N	156040	156040	323346
20415	29829	3	applied	\N	\N	\N	\N	156041	156041	323347
20415	29827	4	applied	\N	\N	\N	\N	156042	156042	323348
20415	29830	5	applied	\N	\N	1000000000	\N	156043	156043	323349
20415	29831	6	applied	\N	\N	1000000000	\N	156044	156044	323350
20415	29832	7	applied	\N	\N	1000000000	\N	156045	156045	323351
20415	29833	8	applied	\N	\N	\N	\N	156046	156046	323352
20415	29834	9	applied	\N	\N	\N	\N	156047	156047	323353
20418	29835	0	applied	\N	\N	\N	\N	156058	156058	323364
20418	29836	1	applied	\N	\N	\N	\N	156059	156059	323365
20418	29838	3	applied	\N	\N	\N	\N	156061	156061	323367
20418	29839	4	applied	\N	\N	1000000000	\N	156062	156062	323368
20424	29852	0	applied	\N	\N	\N	\N	156087	156087	323393
20424	29853	1	applied	\N	\N	\N	\N	156088	156088	323394
20424	29854	3	applied	\N	\N	\N	\N	156089	156089	323395
20428	29852	0	applied	\N	\N	\N	\N	156099	156099	323405
20428	29853	1	applied	\N	\N	\N	\N	156100	156100	323406
20428	29854	3	applied	\N	\N	\N	\N	156101	156101	323407
20435	29869	0	applied	\N	\N	\N	\N	156136	156136	323442
20435	29870	1	applied	\N	\N	\N	\N	156137	156137	323443
20435	29867	2	applied	\N	\N	\N	\N	156138	156138	323444
20435	29871	3	applied	\N	\N	\N	\N	156139	156139	323445
20435	29872	4	applied	\N	\N	\N	\N	156140	156140	323446
20435	29873	5	applied	\N	\N	\N	\N	156141	156141	323447
20435	29874	6	applied	\N	\N	\N	\N	156142	156142	323448
20435	29875	7	applied	\N	\N	\N	\N	156143	156143	323449
20435	29876	8	applied	\N	\N	\N	\N	156144	156144	323450
20435	29877	9	applied	\N	\N	\N	\N	156145	156145	323451
20438	29870	1	applied	\N	\N	\N	\N	156169	156169	323475
20438	29878	2	applied	\N	\N	\N	\N	156170	156170	323476
20438	29872	4	applied	\N	\N	\N	\N	156172	156172	323478
20438	29873	5	applied	\N	\N	\N	\N	156173	156173	323479
20438	29874	6	applied	\N	\N	\N	\N	156174	156174	323480
20438	29875	7	applied	\N	\N	\N	\N	156175	156175	323481
20438	29876	8	applied	\N	\N	\N	\N	156176	156176	323482
20438	29877	9	applied	\N	\N	\N	\N	156177	156177	323483
20440	29879	0	applied	\N	\N	\N	\N	156181	156181	323487
20440	29880	1	applied	\N	\N	\N	\N	156182	156182	323488
20440	29881	2	applied	\N	\N	\N	\N	156183	156183	323489
20441	29879	0	applied	\N	\N	\N	\N	156184	156184	323490
20441	29880	1	applied	\N	\N	\N	\N	156185	156185	323491
20442	29882	0	applied	\N	\N	\N	\N	156186	156186	323492
20442	29883	1	applied	\N	\N	\N	\N	156187	156187	323493
20442	29884	2	applied	\N	\N	\N	\N	156188	156188	323494
20445	29885	0	applied	\N	\N	\N	\N	156193	156193	323499
20445	29886	1	applied	\N	\N	\N	\N	156194	156194	323500
20446	29888	1	applied	\N	\N	\N	\N	156196	156196	323502
20446	29889	2	applied	\N	\N	\N	\N	156197	156197	323503
20446	29890	3	applied	\N	\N	\N	\N	156198	156198	323504
20447	29891	0	applied	\N	\N	\N	\N	156199	156199	323505
20447	29892	1	applied	\N	\N	\N	\N	156200	156200	323506
20447	29893	2	applied	\N	\N	\N	\N	156201	156201	323507
20450	29891	0	applied	\N	\N	\N	\N	156208	156208	323514
20450	29892	1	applied	\N	\N	\N	\N	156209	156209	323515
20450	29893	2	applied	\N	\N	\N	\N	156210	156210	323516
20451	29894	0	applied	\N	\N	\N	\N	156211	156211	323517
20451	29895	1	applied	\N	\N	\N	\N	156212	156212	323518
20451	29896	2	applied	\N	\N	\N	\N	156213	156213	323519
20454	29897	0	applied	\N	\N	\N	\N	156226	156226	323532
20454	29898	1	applied	\N	\N	1000000000	\N	156227	156227	323533
20454	29899	2	applied	\N	\N	\N	\N	156228	156228	323534
20454	29900	3	applied	\N	\N	\N	\N	156229	156229	323535
20454	29902	5	applied	\N	\N	\N	\N	156231	156231	323537
20455	29897	0	applied	\N	\N	\N	\N	156232	156232	323538
20455	29898	1	applied	\N	\N	1000000000	\N	156233	156233	323539
20455	29899	2	applied	\N	\N	\N	\N	156234	156234	323540
20455	29900	3	applied	\N	\N	\N	\N	156235	156235	323541
20458	29906	0	applied	\N	\N	\N	\N	156244	156244	323550
20458	29907	1	applied	\N	\N	\N	\N	156245	156245	323551
20458	29908	2	applied	\N	\N	\N	\N	156246	156246	323552
20462	29912	0	applied	\N	\N	\N	\N	156255	156255	323561
20462	29913	1	applied	\N	\N	\N	\N	156256	156256	323562
20462	29914	2	applied	\N	\N	\N	\N	156257	156257	323563
20464	29915	0	applied	\N	\N	\N	\N	156261	156261	323567
20464	29916	1	applied	\N	\N	\N	\N	156262	156262	323568
20467	29898	0	applied	\N	\N	1000000000	\N	156271	156271	323577
20467	29782	1	applied	\N	\N	\N	\N	156272	156272	323578
20467	29785	2	applied	\N	\N	\N	\N	156273	156273	323579
20467	29790	4	applied	\N	\N	\N	\N	156275	156275	323581
20467	29793	5	applied	\N	\N	\N	\N	156276	156276	323582
20467	29794	6	applied	\N	\N	\N	\N	156277	156277	323583
20467	29795	7	applied	\N	\N	\N	\N	156278	156278	323584
20467	29796	8	applied	\N	\N	\N	\N	156279	156279	323585
20467	29805	9	applied	\N	\N	\N	\N	156280	156280	323586
20467	29808	10	applied	\N	\N	\N	\N	156281	156281	323587
20467	29809	11	applied	\N	\N	\N	\N	156282	156282	323588
20467	29814	12	applied	\N	\N	\N	\N	156283	156283	323589
20467	29820	13	applied	\N	\N	\N	\N	156284	156284	323590
20402	29745	19	applied	\N	\N	\N	\N	155935	155935	323241
20402	29748	20	applied	\N	\N	\N	\N	155936	155936	323242
20463	29913	1	applied	\N	\N	\N	\N	156259	156259	323565
20463	29914	2	applied	\N	\N	\N	\N	156260	156260	323566
20467	29825	14	applied	\N	\N	\N	\N	156285	156285	323591
20467	29826	15	applied	\N	\N	\N	\N	156286	156286	323592
20467	29835	16	applied	\N	\N	\N	\N	156287	156287	323593
20467	29840	17	applied	\N	\N	\N	\N	156288	156288	323594
20467	29841	18	applied	\N	\N	\N	\N	156289	156289	323595
20467	29846	19	applied	\N	\N	\N	\N	156290	156290	323596
20467	29849	20	applied	\N	\N	\N	\N	156291	156291	323597
20467	29852	21	applied	\N	\N	\N	\N	156292	156292	323598
20467	29856	22	applied	\N	\N	\N	\N	156293	156293	323599
20467	29863	24	applied	\N	\N	\N	\N	156295	156295	323601
20467	29869	25	applied	\N	\N	\N	\N	156296	156296	323602
20467	29879	26	applied	\N	\N	\N	\N	156297	156297	323603
20467	29882	27	applied	\N	\N	\N	\N	156298	156298	323604
20467	29885	28	applied	\N	\N	\N	\N	156299	156299	323605
20467	29887	29	applied	\N	\N	\N	\N	156300	156300	323606
20467	29891	30	applied	\N	\N	\N	\N	156301	156301	323607
20467	29894	31	applied	\N	\N	\N	\N	156302	156302	323608
20467	29897	32	applied	\N	\N	\N	\N	156303	156303	323609
20467	29903	33	applied	\N	\N	\N	\N	156304	156304	323610
20467	29906	34	applied	\N	\N	\N	\N	156305	156305	323611
20467	29909	35	applied	\N	\N	\N	\N	156306	156306	323612
20467	29912	36	applied	\N	\N	\N	\N	156307	156307	323613
20467	29915	37	applied	\N	\N	\N	\N	156308	156308	323614
20472	29933	0	applied	\N	\N	\N	\N	156410	156410	323716
20472	29934	1	applied	\N	\N	\N	\N	156411	156411	323717
20472	29936	3	applied	\N	\N	\N	\N	156413	156413	323719
20474	29937	0	applied	\N	\N	\N	\N	156418	156418	323724
20479	29943	0	applied	\N	\N	\N	\N	156554	156554	323860
20479	29944	1	applied	\N	\N	\N	\N	156555	156555	323861
20479	29945	2	applied	\N	\N	\N	\N	156556	156556	323862
20479	29946	3	applied	\N	\N	\N	\N	156557	156557	323863
20479	29947	4	applied	\N	\N	\N	\N	156558	156558	323864
20479	29948	5	applied	\N	\N	\N	\N	156559	156559	323865
20479	29949	6	applied	\N	\N	\N	\N	156560	156560	323866
20479	29950	7	applied	\N	\N	\N	\N	156561	156561	323867
20479	29951	8	applied	\N	\N	\N	\N	156562	156562	323868
20479	29952	9	applied	\N	\N	\N	\N	156563	156563	323869
20479	29953	10	applied	\N	\N	\N	\N	156564	156564	323870
20479	29954	11	applied	\N	\N	\N	\N	156565	156565	323871
20479	29956	13	applied	\N	\N	\N	\N	156567	156567	323873
20479	29957	14	applied	\N	\N	\N	\N	156568	156568	323874
20479	29958	15	applied	\N	\N	\N	\N	156569	156569	323875
20479	29959	16	applied	\N	\N	\N	\N	156570	156570	323876
20479	29960	17	applied	\N	\N	\N	\N	156571	156571	323877
20479	29961	18	applied	\N	\N	\N	\N	156572	156572	323878
20479	29962	19	applied	\N	\N	\N	\N	156573	156573	323879
20479	29963	20	applied	\N	\N	\N	\N	156574	156574	323880
20479	29964	21	applied	\N	\N	\N	\N	156575	156575	323881
20479	29965	22	applied	\N	\N	\N	\N	156576	156576	323882
20479	29966	23	applied	\N	\N	\N	\N	156577	156577	323883
20479	29967	24	applied	\N	\N	\N	\N	156578	156578	323884
20479	29968	25	applied	\N	\N	\N	\N	156579	156579	323885
20483	29971	0	applied	\N	\N	\N	\N	156584	156584	323890
20483	29972	1	applied	\N	\N	\N	\N	156585	156585	323891
20483	29973	2	applied	\N	\N	\N	\N	156586	156586	323892
20483	29974	3	applied	\N	\N	\N	\N	156587	156587	323893
20483	29975	4	applied	\N	\N	\N	\N	156588	156588	323894
20486	29943	0	applied	\N	\N	\N	\N	156599	156599	323905
20486	29944	1	applied	\N	\N	\N	\N	156600	156600	323906
20486	29946	3	applied	\N	\N	\N	\N	156602	156602	323908
20486	29947	4	applied	\N	\N	\N	\N	156603	156603	323909
20486	29948	5	applied	\N	\N	\N	\N	156604	156604	323910
20486	29949	6	applied	\N	\N	\N	\N	156605	156605	323911
20486	29950	7	applied	\N	\N	\N	\N	156606	156606	323912
20486	29951	8	applied	\N	\N	\N	\N	156607	156607	323913
20486	29952	9	applied	\N	\N	\N	\N	156608	156608	323914
20486	29953	10	applied	\N	\N	\N	\N	156609	156609	323915
20486	29969	11	applied	\N	\N	\N	\N	156610	156610	323916
20486	29954	12	applied	\N	\N	\N	\N	156611	156611	323917
20486	29955	13	applied	\N	\N	1000000000	\N	156612	156612	323918
20486	29956	14	applied	\N	\N	\N	\N	156613	156613	323919
20486	29957	15	applied	\N	\N	\N	\N	156614	156614	323920
20486	29958	16	applied	\N	\N	\N	\N	156615	156615	323921
20486	29959	17	applied	\N	\N	\N	\N	156616	156616	323922
20486	29960	18	applied	\N	\N	\N	\N	156617	156617	323923
20486	29962	20	applied	\N	\N	\N	\N	156619	156619	323925
20486	29974	21	applied	\N	\N	\N	\N	156620	156620	323926
20486	29963	22	applied	\N	\N	\N	\N	156621	156621	323927
20486	29964	23	applied	\N	\N	\N	\N	156622	156622	323928
20486	29973	24	applied	\N	\N	\N	\N	156623	156623	323929
20486	29965	25	applied	\N	\N	\N	\N	156624	156624	323930
20486	29966	26	applied	\N	\N	\N	\N	156625	156625	323931
20486	29967	27	applied	\N	\N	\N	\N	156626	156626	323932
20486	29968	28	applied	\N	\N	\N	\N	156627	156627	323933
20486	29970	29	applied	\N	\N	\N	\N	156628	156628	323934
20488	29976	0	applied	\N	\N	\N	\N	156635	156635	323941
20488	29977	1	applied	\N	\N	\N	\N	156636	156636	323942
20488	29978	2	applied	\N	\N	\N	\N	156637	156637	323943
20488	29979	3	applied	\N	\N	\N	\N	156638	156638	323944
20488	29980	4	applied	\N	\N	\N	\N	156639	156639	323945
20488	29981	5	applied	\N	\N	\N	\N	156640	156640	323946
20491	29983	1	applied	\N	\N	\N	\N	156649	156649	323955
20491	29984	2	applied	\N	\N	\N	\N	156650	156650	323956
20494	29998	0	applied	\N	\N	\N	\N	156664	156664	323970
20494	29999	1	applied	\N	\N	\N	\N	156665	156665	323971
20494	30000	2	applied	\N	\N	\N	\N	156666	156666	323972
20497	30002	0	applied	\N	\N	\N	\N	156671	156671	323977
20498	30001	0	applied	\N	\N	\N	\N	156672	156672	323978
20498	30002	1	applied	\N	\N	\N	\N	156673	156673	323979
20503	30010	0	applied	\N	\N	\N	\N	156689	156689	323995
20503	30011	1	applied	\N	\N	\N	\N	156690	156690	323996
20503	30012	2	applied	\N	\N	\N	\N	156691	156691	323997
20508	29943	0	applied	\N	\N	\N	\N	156699	156699	324005
20508	29944	1	applied	\N	\N	\N	\N	156700	156700	324006
20508	29945	2	applied	\N	\N	\N	\N	156701	156701	324007
20508	29946	3	applied	\N	\N	\N	\N	156702	156702	324008
20508	29731	5	applied	\N	\N	\N	\N	156704	156704	324010
20455	29902	5	applied	\N	\N	\N	\N	156237	156237	323543
20463	29912	0	applied	\N	\N	\N	\N	156258	156258	323564
20467	29866	41	applied	\N	\N	\N	\N	156312	156312	323618
20467	29827	42	applied	\N	\N	\N	\N	156313	156313	323619
20467	29847	43	applied	\N	\N	\N	\N	156314	156314	323620
20467	29859	44	applied	\N	\N	\N	\N	156315	156315	323621
20467	29870	45	applied	\N	\N	\N	\N	156316	156316	323622
20467	29888	46	applied	\N	\N	\N	\N	156317	156317	323623
20467	29783	47	applied	\N	\N	\N	\N	156318	156318	323624
20467	29786	49	applied	\N	\N	\N	\N	156320	156320	323626
20467	29788	50	applied	\N	\N	\N	\N	156321	156321	323627
20467	29791	51	applied	\N	\N	\N	\N	156322	156322	323628
20467	29797	52	applied	\N	\N	\N	\N	156323	156323	323629
20467	29830	53	applied	\N	\N	1000000000	\N	156324	156324	323630
20467	29831	54	applied	\N	\N	1000000000	\N	156325	156325	323631
20467	29832	55	applied	\N	\N	1000000000	\N	156326	156326	323632
20467	29837	56	applied	\N	\N	1000000000	\N	156327	156327	323633
20467	29839	57	applied	\N	\N	1000000000	\N	156328	156328	323634
20467	29867	58	applied	\N	\N	\N	\N	156329	156329	323635
20467	29871	59	applied	\N	\N	\N	\N	156330	156330	323636
20467	29872	60	applied	\N	\N	\N	\N	156331	156331	323637
20467	29873	61	applied	\N	\N	\N	\N	156332	156332	323638
20467	29875	62	applied	\N	\N	\N	\N	156333	156333	323639
20467	29876	63	applied	\N	\N	\N	\N	156334	156334	323640
20467	29799	64	applied	\N	\N	\N	\N	156335	156335	323641
20467	29911	66	applied	\N	\N	\N	\N	156337	156337	323643
20467	29789	67	applied	\N	\N	\N	\N	156338	156338	323644
20467	29800	68	applied	\N	\N	\N	\N	156339	156339	323645
20467	29801	69	applied	\N	\N	\N	\N	156340	156340	323646
20467	29806	70	applied	\N	\N	\N	\N	156341	156341	323647
20467	29816	71	applied	\N	\N	\N	\N	156342	156342	323648
20467	29817	72	applied	\N	\N	\N	\N	156343	156343	323649
20467	29821	73	applied	\N	\N	\N	\N	156344	156344	323650
20467	29922	74	applied	\N	\N	\N	\N	156345	156345	323651
20467	29812	75	applied	\N	\N	\N	\N	156346	156346	323652
20467	29813	76	applied	\N	\N	\N	\N	156347	156347	323653
20467	29819	77	applied	\N	\N	\N	\N	156348	156348	323654
20467	29824	78	applied	\N	\N	\N	\N	156349	156349	323655
20467	29828	79	applied	\N	\N	\N	\N	156350	156350	323656
20467	29829	80	applied	\N	\N	\N	\N	156351	156351	323657
20467	29836	81	applied	\N	\N	\N	\N	156352	156352	323658
20467	29845	83	applied	\N	\N	\N	\N	156354	156354	323660
20467	29848	84	applied	\N	\N	\N	\N	156355	156355	323661
20467	29851	85	applied	\N	\N	\N	\N	156356	156356	323662
20467	29854	86	applied	\N	\N	\N	\N	156357	156357	323663
20467	29861	87	applied	\N	\N	\N	\N	156358	156358	323664
20467	29862	88	applied	\N	\N	\N	\N	156359	156359	323665
20467	29865	89	applied	\N	\N	\N	\N	156360	156360	323666
20467	29878	90	applied	\N	\N	\N	\N	156361	156361	323667
20467	29881	91	applied	\N	\N	\N	\N	156362	156362	323668
20467	29883	92	applied	\N	\N	\N	\N	156363	156363	323669
20467	29886	93	applied	\N	\N	\N	\N	156364	156364	323670
20467	29890	94	applied	\N	\N	\N	\N	156365	156365	323671
20467	29892	95	applied	\N	\N	\N	\N	156366	156366	323672
20467	29895	96	applied	\N	\N	\N	\N	156367	156367	323673
20467	29900	97	applied	\N	\N	\N	\N	156368	156368	323674
20467	29905	98	applied	\N	\N	\N	\N	156369	156369	323675
20467	29910	101	applied	\N	\N	\N	\N	156371	156371	323677
20467	29913	102	applied	\N	\N	\N	\N	156372	156372	323678
20467	29917	103	applied	\N	\N	\N	\N	156373	156373	323679
20467	29921	104	applied	\N	\N	\N	\N	156374	156374	323680
20467	29877	105	applied	\N	\N	\N	\N	156375	156375	323681
20467	29792	106	applied	\N	\N	\N	\N	156376	156376	323682
20467	29798	107	applied	\N	\N	\N	\N	156377	156377	323683
20467	29802	108	applied	\N	\N	\N	\N	156378	156378	323684
20467	29803	109	applied	\N	\N	\N	\N	156379	156379	323685
20467	29804	110	applied	\N	\N	\N	\N	156380	156380	323686
20467	29807	111	applied	\N	\N	\N	\N	156381	156381	323687
20467	29810	112	applied	\N	\N	\N	\N	156382	156382	323688
20467	29811	113	applied	\N	\N	\N	\N	156383	156383	323689
20467	29818	114	applied	\N	\N	\N	\N	156384	156384	323690
20467	29823	115	applied	\N	\N	\N	\N	156385	156385	323691
20467	29833	116	applied	\N	\N	\N	\N	156386	156386	323692
20467	29838	118	applied	\N	\N	\N	\N	156388	156388	323694
20467	29843	119	applied	\N	\N	\N	\N	156389	156389	323695
20467	29844	120	applied	\N	\N	\N	\N	156390	156390	323696
20467	29850	121	applied	\N	\N	\N	\N	156391	156391	323697
20467	29853	122	applied	\N	\N	\N	\N	156392	156392	323698
20467	29858	123	applied	\N	\N	\N	\N	156393	156393	323699
20467	29860	124	applied	\N	\N	\N	\N	156394	156394	323700
20467	29868	125	applied	\N	\N	\N	\N	156395	156395	323701
20469	29923	0	applied	\N	\N	\N	\N	156400	156400	323706
20469	29924	1	applied	\N	\N	\N	\N	156401	156401	323707
20469	29925	2	applied	\N	\N	\N	\N	156402	156402	323708
20469	29926	3	applied	\N	\N	\N	\N	156403	156403	323709
20471	29930	0	applied	\N	\N	\N	\N	156407	156407	323713
20471	29931	1	applied	\N	\N	\N	\N	156408	156408	323714
20471	29932	2	applied	\N	\N	\N	\N	156409	156409	323715
20477	29939	0	applied	\N	\N	\N	\N	156425	156425	323731
20477	29941	2	applied	\N	\N	\N	\N	156427	156427	323733
20477	29942	3	applied	\N	\N	\N	\N	156428	156428	323734
20485	29971	0	applied	\N	\N	\N	\N	156594	156594	323900
20485	29972	1	applied	\N	\N	\N	\N	156595	156595	323901
20485	29973	2	applied	\N	\N	\N	\N	156596	156596	323902
20485	29974	3	applied	\N	\N	\N	\N	156597	156597	323903
20485	29975	4	applied	\N	\N	\N	\N	156598	156598	323904
20490	29982	0	applied	\N	\N	\N	\N	156645	156645	323951
20490	29983	1	applied	\N	\N	\N	\N	156646	156646	323952
20490	29984	2	applied	\N	\N	\N	\N	156647	156647	323953
20493	29994	0	applied	\N	\N	\N	\N	156660	156660	323966
20493	29995	1	applied	\N	\N	\N	\N	156661	156661	323967
20493	29996	2	applied	\N	\N	\N	\N	156662	156662	323968
20493	29997	3	applied	\N	\N	\N	\N	156663	156663	323969
20496	30001	0	applied	\N	\N	\N	\N	156669	156669	323975
20496	30002	1	applied	\N	\N	\N	\N	156670	156670	323976
20501	30004	1	applied	\N	\N	\N	\N	156683	156683	323989
20501	30005	2	applied	\N	\N	\N	\N	156684	156684	323990
20501	30006	3	applied	\N	\N	\N	\N	156685	156685	323991
20502	30007	0	applied	\N	\N	\N	\N	156686	156686	323992
20502	30008	1	applied	\N	\N	\N	\N	156687	156687	323993
20502	30009	2	applied	\N	\N	\N	\N	156688	156688	323994
20467	29899	39	applied	\N	\N	\N	\N	156310	156310	323616
20467	29815	40	applied	\N	\N	\N	\N	156311	156311	323617
20478	29762	7	applied	\N	\N	\N	\N	156436	156436	323742
20478	29763	8	applied	\N	\N	\N	\N	156437	156437	323743
20478	29770	9	applied	\N	\N	\N	\N	156438	156438	323744
20478	29773	10	applied	\N	\N	\N	\N	156439	156439	323745
20478	29774	11	applied	\N	\N	\N	\N	156440	156440	323746
20478	29775	12	applied	\N	\N	\N	\N	156441	156441	323747
20478	29782	13	applied	\N	\N	\N	\N	156442	156442	323748
20478	29785	14	applied	\N	\N	\N	\N	156443	156443	323749
20478	29787	15	applied	\N	\N	\N	\N	156444	156444	323750
20478	29790	16	applied	\N	\N	\N	\N	156445	156445	323751
20478	29793	17	applied	\N	\N	\N	\N	156446	156446	323752
20478	29794	18	applied	\N	\N	\N	\N	156447	156447	323753
20478	29795	19	applied	\N	\N	\N	\N	156448	156448	323754
20478	29796	20	applied	\N	\N	\N	\N	156449	156449	323755
20478	29805	21	applied	\N	\N	\N	\N	156450	156450	323756
20478	29940	22	applied	\N	\N	\N	\N	156451	156451	323757
20478	29809	24	applied	\N	\N	\N	\N	156453	156453	323759
20478	29814	25	applied	\N	\N	\N	\N	156454	156454	323760
20478	29820	26	applied	\N	\N	\N	\N	156455	156455	323761
20478	29825	27	applied	\N	\N	\N	\N	156456	156456	323762
20478	29826	28	applied	\N	\N	\N	\N	156457	156457	323763
20478	29835	29	applied	\N	\N	\N	\N	156458	156458	323764
20478	29840	30	applied	\N	\N	\N	\N	156459	156459	323765
20478	29841	31	applied	\N	\N	\N	\N	156460	156460	323766
20478	29846	32	applied	\N	\N	\N	\N	156461	156461	323767
20478	29849	33	applied	\N	\N	\N	\N	156462	156462	323768
20478	29852	34	applied	\N	\N	\N	\N	156463	156463	323769
20478	29856	35	applied	\N	\N	\N	\N	156464	156464	323770
20478	29857	36	applied	\N	\N	\N	\N	156465	156465	323771
20478	29863	37	applied	\N	\N	\N	\N	156466	156466	323772
20478	29869	38	applied	\N	\N	\N	\N	156467	156467	323773
20478	29879	39	applied	\N	\N	\N	\N	156468	156468	323774
20478	29885	41	applied	\N	\N	\N	\N	156470	156470	323776
20478	29887	42	applied	\N	\N	\N	\N	156471	156471	323777
20478	29891	43	applied	\N	\N	\N	\N	156472	156472	323778
20478	29894	44	applied	\N	\N	\N	\N	156473	156473	323779
20478	29897	45	applied	\N	\N	\N	\N	156474	156474	323780
20478	29903	46	applied	\N	\N	\N	\N	156475	156475	323781
20478	29906	47	applied	\N	\N	\N	\N	156476	156476	323782
20478	29909	48	applied	\N	\N	\N	\N	156477	156477	323783
20507	30013	0	applied	\N	\N	\N	\N	156695	156695	324001
20507	30014	1	applied	\N	\N	\N	\N	156696	156696	324002
20507	30015	2	applied	\N	\N	\N	\N	156697	156697	324003
20507	30016	3	applied	\N	\N	\N	\N	156698	156698	324004
20511	30018	0	applied	\N	\N	\N	\N	156829	156829	324135
20511	30019	1	applied	\N	\N	\N	\N	156830	156830	324136
20519	30045	0	applied	\N	\N	\N	\N	156909	156909	324215
20519	30046	1	applied	\N	\N	\N	\N	156910	156910	324216
20519	30050	3	applied	\N	\N	\N	\N	156912	156912	324218
20519	30047	4	applied	\N	\N	\N	\N	156913	156913	324219
20519	30048	5	applied	\N	\N	\N	\N	156914	156914	324220
20523	30051	0	applied	\N	\N	\N	\N	156931	156931	324237
20523	30052	1	applied	\N	\N	\N	\N	156932	156932	324238
20523	30053	2	applied	\N	\N	\N	\N	156933	156933	324239
20523	30054	3	applied	\N	\N	\N	\N	156934	156934	324240
20529	30080	0	applied	\N	\N	\N	\N	156968	156968	324274
20529	30081	1	applied	\N	\N	\N	\N	156969	156969	324275
20529	30082	2	applied	\N	\N	\N	\N	156970	156970	324276
20529	30083	3	applied	\N	\N	\N	\N	156971	156971	324277
20530	30084	0	applied	\N	\N	\N	\N	156972	156972	324278
20530	30085	1	applied	\N	\N	\N	\N	156973	156973	324279
20530	30086	2	applied	\N	\N	\N	\N	156974	156974	324280
20534	30087	0	applied	\N	\N	\N	\N	156988	156988	324294
20534	30088	1	applied	\N	\N	\N	\N	156989	156989	324295
20534	30090	3	applied	\N	\N	\N	\N	156991	156991	324297
20534	30091	4	applied	\N	\N	\N	\N	156992	156992	324298
20540	30101	0	applied	\N	\N	\N	\N	157034	157034	324340
20540	30102	1	applied	\N	\N	\N	\N	157035	157035	324341
20540	30103	2	applied	\N	\N	\N	\N	157036	157036	324342
20540	30104	3	applied	\N	\N	\N	\N	157037	157037	324343
20540	30105	4	applied	\N	\N	\N	\N	157038	157038	324344
20541	30106	0	applied	\N	\N	\N	\N	157039	157039	324345
20541	30107	1	applied	\N	\N	\N	\N	157040	157040	324346
20553	30134	0	applied	\N	\N	\N	\N	157076	157076	324381
20553	30135	1	applied	\N	\N	\N	\N	157077	157077	324382
20553	30136	2	applied	\N	\N	\N	\N	157078	157078	324383
20557	30137	0	applied	\N	\N	\N	\N	157090	157090	324395
20557	30138	1	applied	\N	\N	\N	\N	157091	157091	324396
20557	30140	2	applied	\N	\N	\N	\N	157092	157092	324397
20558	30141	0	applied	\N	\N	\N	\N	157093	157093	324398
20558	30143	2	applied	\N	\N	\N	\N	157095	157095	324400
20558	30144	3	applied	\N	\N	\N	\N	157096	157096	324401
20558	30145	4	applied	\N	\N	\N	\N	157097	157097	324402
20558	30146	5	applied	\N	\N	\N	\N	157098	157098	324403
20558	30147	6	applied	\N	\N	\N	\N	157099	157099	324404
20558	30148	7	applied	\N	\N	\N	\N	157100	157100	324405
20558	30149	8	applied	\N	\N	\N	\N	157101	157101	324406
20558	30150	9	applied	\N	\N	\N	\N	157102	157102	324407
20558	30151	10	applied	\N	\N	\N	\N	157103	157103	324408
20558	30152	11	applied	\N	\N	\N	\N	157104	157104	324409
20558	30153	12	applied	\N	\N	\N	\N	157105	157105	324410
20558	30154	13	applied	\N	\N	\N	\N	157106	157106	324411
20563	30156	0	applied	\N	\N	\N	\N	157187	157187	324491
20563	30157	1	applied	\N	\N	\N	\N	157188	157188	324492
20563	30158	2	applied	\N	\N	\N	\N	157189	157189	324493
20568	30159	0	applied	\N	\N	\N	\N	157214	157214	324518
20568	30161	2	applied	\N	\N	\N	\N	157216	157216	324520
20568	30162	3	applied	\N	\N	\N	\N	157217	157217	324521
20568	30163	4	applied	\N	\N	\N	\N	157218	157218	324522
20568	30164	5	applied	\N	\N	\N	\N	157219	157219	324523
20568	30165	6	applied	\N	\N	\N	\N	157220	157220	324524
20568	30166	7	applied	\N	\N	\N	\N	157221	157221	324525
20572	30159	0	applied	\N	\N	\N	\N	157244	157244	324548
20572	30160	1	applied	\N	\N	\N	\N	157245	157245	324549
20572	30161	2	applied	\N	\N	\N	\N	157246	157246	324550
20572	30162	3	applied	\N	\N	\N	\N	157247	157247	324551
20572	30163	4	applied	\N	\N	\N	\N	157248	157248	324552
20572	30164	5	applied	\N	\N	\N	\N	157249	157249	324553
20572	30165	6	applied	\N	\N	\N	\N	157250	157250	324554
20572	30166	7	applied	\N	\N	\N	\N	157251	157251	324555
20478	29754	4	applied	\N	\N	\N	\N	156433	156433	323739
20478	29758	5	applied	\N	\N	\N	\N	156434	156434	323740
20478	29923	52	applied	\N	\N	\N	\N	156481	156481	323787
20478	29927	53	applied	\N	\N	\N	\N	156482	156482	323788
20478	29930	54	applied	\N	\N	\N	\N	156483	156483	323789
20478	29933	55	applied	\N	\N	\N	\N	156484	156484	323790
20478	29938	56	applied	\N	\N	\N	\N	156485	156485	323791
20478	29864	57	applied	\N	\N	\N	\N	156486	156486	323792
20478	29899	58	applied	\N	\N	\N	\N	156487	156487	323793
20478	29866	60	applied	\N	\N	\N	\N	156489	156489	323795
20478	29827	61	applied	\N	\N	\N	\N	156490	156490	323796
20478	29847	62	applied	\N	\N	\N	\N	156491	156491	323797
20478	29859	63	applied	\N	\N	\N	\N	156492	156492	323798
20478	29870	64	applied	\N	\N	\N	\N	156493	156493	323799
20478	29888	65	applied	\N	\N	\N	\N	156494	156494	323800
20478	29747	67	applied	\N	\N	\N	\N	156495	156495	323801
20478	29751	68	applied	\N	\N	\N	\N	156496	156496	323802
20478	29755	69	applied	\N	\N	\N	\N	156497	156497	323803
20478	29748	70	applied	\N	\N	\N	\N	156498	156498	323804
20478	29750	71	applied	\N	\N	\N	\N	156499	156499	323805
20478	29830	72	applied	\N	\N	1000000000	\N	156500	156500	323806
20478	29831	73	applied	\N	\N	1000000000	\N	156501	156501	323807
20478	29832	74	applied	\N	\N	1000000000	\N	156502	156502	323808
20478	29839	76	applied	\N	\N	1000000000	\N	156504	156504	323810
20478	29867	77	applied	\N	\N	\N	\N	156505	156505	323811
20478	29871	78	applied	\N	\N	\N	\N	156506	156506	323812
20478	29872	79	applied	\N	\N	\N	\N	156507	156507	323813
20478	29873	80	applied	\N	\N	\N	\N	156508	156508	323814
20478	29875	81	applied	\N	\N	\N	\N	156509	156509	323815
20478	29876	82	applied	\N	\N	\N	\N	156510	156510	323816
20478	29760	83	applied	\N	\N	\N	\N	156511	156511	323817
20478	29765	84	applied	\N	\N	\N	\N	156512	156512	323818
20478	29766	85	applied	\N	\N	\N	\N	156513	156513	323819
20478	29767	86	applied	\N	\N	\N	\N	156514	156514	323820
20478	29771	87	applied	\N	\N	\N	\N	156515	156515	323821
20478	29777	88	applied	\N	\N	\N	\N	156516	156516	323822
20478	29778	89	applied	\N	\N	\N	\N	156517	156517	323823
20478	29779	90	applied	\N	\N	\N	\N	156518	156518	323824
20478	29783	91	applied	\N	\N	\N	\N	156519	156519	323825
20478	29902	92	applied	\N	\N	\N	\N	156520	156520	323826
20478	29911	93	applied	\N	\N	\N	\N	156521	156521	323827
20478	29924	94	applied	\N	\N	\N	\N	156522	156522	323828
20478	29936	95	applied	\N	\N	\N	\N	156523	156523	323829
20478	29753	97	applied	\N	\N	\N	\N	156525	156525	323831
20478	29756	98	applied	\N	\N	\N	\N	156526	156526	323832
20478	29759	99	applied	\N	\N	\N	\N	156527	156527	323833
20478	29764	100	applied	\N	\N	\N	\N	156528	156528	323834
20478	29768	101	applied	\N	\N	\N	\N	156529	156529	323835
20478	29769	102	applied	\N	\N	\N	\N	156530	156530	323836
20478	29772	103	applied	\N	\N	\N	\N	156531	156531	323837
20478	29776	104	applied	\N	\N	\N	\N	156532	156532	323838
20478	29780	105	applied	\N	\N	\N	\N	156533	156533	323839
20478	29781	106	applied	\N	\N	\N	\N	156534	156534	323840
20478	29784	107	applied	\N	\N	\N	\N	156535	156535	323841
20478	29786	108	applied	\N	\N	\N	\N	156536	156536	323842
20478	29788	109	applied	\N	\N	\N	\N	156537	156537	323843
20478	29791	110	applied	\N	\N	\N	\N	156538	156538	323844
20478	29797	111	applied	\N	\N	\N	\N	156539	156539	323845
20478	29799	112	applied	\N	\N	\N	\N	156540	156540	323846
20478	29801	114	applied	\N	\N	\N	\N	156542	156542	323848
20478	29806	115	applied	\N	\N	\N	\N	156543	156543	323849
20478	29816	116	applied	\N	\N	\N	\N	156544	156544	323850
20478	29817	117	applied	\N	\N	\N	\N	156545	156545	323851
20478	29821	118	applied	\N	\N	\N	\N	156546	156546	323852
20478	29922	119	applied	\N	\N	\N	\N	156547	156547	323853
20478	29812	120	applied	\N	\N	\N	\N	156548	156548	323854
20478	29813	121	applied	\N	\N	\N	\N	156549	156549	323855
20478	29819	122	applied	\N	\N	\N	\N	156550	156550	323856
20478	29824	123	applied	\N	\N	\N	\N	156551	156551	323857
20478	29828	124	applied	\N	\N	\N	\N	156552	156552	323858
20478	29829	125	applied	\N	\N	\N	\N	156553	156553	323859
20481	29969	0	applied	\N	\N	\N	\N	156580	156580	323886
20481	29970	1	applied	\N	\N	\N	\N	156581	156581	323887
20484	29971	0	applied	\N	\N	\N	\N	156589	156589	323895
20484	29972	1	applied	\N	\N	\N	\N	156590	156590	323896
20484	29974	3	applied	\N	\N	\N	\N	156592	156592	323898
20484	29975	4	applied	\N	\N	\N	\N	156593	156593	323899
20489	29978	0	applied	\N	\N	\N	\N	156641	156641	323947
20489	29979	1	applied	\N	\N	\N	\N	156642	156642	323948
20489	29980	2	applied	\N	\N	\N	\N	156643	156643	323949
20489	29981	3	applied	\N	\N	\N	\N	156644	156644	323950
20492	29985	0	applied	\N	\N	\N	\N	156651	156651	323957
20492	29986	1	applied	\N	\N	\N	\N	156652	156652	323958
20492	29987	2	applied	\N	\N	\N	\N	156653	156653	323959
20492	29988	3	applied	\N	\N	\N	\N	156654	156654	323960
20492	29989	4	applied	\N	\N	\N	\N	156655	156655	323961
20492	29990	5	applied	\N	\N	\N	\N	156656	156656	323962
20492	29991	6	applied	\N	\N	\N	\N	156657	156657	323963
20492	29992	7	applied	\N	\N	\N	\N	156658	156658	323964
20492	29993	8	applied	\N	\N	\N	\N	156659	156659	323965
20499	30003	0	applied	\N	\N	\N	\N	156674	156674	323980
20499	30005	2	applied	\N	\N	\N	\N	156676	156676	323982
20499	30006	3	applied	\N	\N	\N	\N	156677	156677	323983
20509	30015	0	applied	\N	\N	\N	\N	156824	156824	324130
20509	30016	1	applied	\N	\N	\N	\N	156825	156825	324131
20513	30020	0	applied	\N	\N	\N	\N	156833	156833	324139
20513	30022	1	applied	\N	\N	\N	\N	156834	156834	324140
20513	30021	2	applied	\N	\N	\N	\N	156835	156835	324141
20517	30023	0	applied	\N	\N	\N	\N	156883	156883	324189
20517	30024	1	applied	\N	\N	\N	\N	156884	156884	324190
20517	30025	2	applied	\N	\N	\N	\N	156885	156885	324191
20517	30026	3	applied	\N	\N	\N	\N	156886	156886	324192
20517	30027	4	applied	\N	\N	\N	\N	156887	156887	324193
20517	30028	5	applied	\N	\N	\N	\N	156888	156888	324194
20517	30029	6	applied	\N	\N	\N	\N	156889	156889	324195
20517	30030	7	applied	\N	\N	\N	\N	156890	156890	324196
20517	30031	8	applied	\N	\N	\N	\N	156891	156891	324197
20517	30033	10	applied	\N	\N	\N	\N	156893	156893	324199
20517	30034	12	applied	\N	\N	\N	\N	156894	156894	324200
20517	30035	13	applied	\N	\N	\N	\N	156895	156895	324201
20517	30036	14	applied	\N	\N	\N	\N	156896	156896	324202
20478	29915	50	applied	\N	\N	\N	\N	156479	156479	323785
20478	29919	51	applied	\N	\N	\N	\N	156480	156480	323786
20508	29577	10	applied	\N	\N	\N	\N	156709	156709	324015
20508	29578	11	applied	\N	\N	\N	\N	156710	156710	324016
20508	29586	12	applied	\N	\N	\N	\N	156711	156711	324017
20508	29594	13	applied	\N	\N	\N	\N	156712	156712	324018
20508	29595	14	applied	\N	\N	\N	\N	156713	156713	324019
20508	29600	15	applied	\N	\N	\N	\N	156714	156714	324020
20508	29604	16	applied	\N	\N	\N	\N	156715	156715	324021
20508	29605	17	applied	\N	\N	\N	\N	156716	156716	324022
20508	29609	18	applied	\N	\N	\N	\N	156717	156717	324023
20508	29940	19	applied	\N	\N	\N	\N	156718	156718	324024
20508	29949	21	applied	\N	\N	\N	\N	156719	156719	324025
20508	29613	22	applied	\N	\N	\N	\N	156720	156720	324026
20508	29616	23	applied	\N	\N	\N	\N	156721	156721	324027
20508	29619	24	applied	\N	\N	\N	\N	156722	156722	324028
20508	29626	26	applied	\N	\N	\N	\N	156724	156724	324030
20508	29627	27	applied	\N	\N	\N	\N	156725	156725	324031
20508	29632	28	applied	\N	\N	\N	\N	156726	156726	324032
20508	29636	29	applied	\N	\N	\N	\N	156727	156727	324033
20508	29642	30	applied	\N	\N	\N	\N	156728	156728	324034
20508	29643	31	applied	\N	\N	\N	\N	156729	156729	324035
20508	29647	32	applied	\N	\N	\N	\N	156730	156730	324036
20508	29648	33	applied	\N	\N	\N	\N	156731	156731	324037
20508	29653	34	applied	\N	\N	\N	\N	156732	156732	324038
20508	29656	35	applied	\N	\N	\N	\N	156733	156733	324039
20508	29657	36	applied	\N	\N	\N	\N	156734	156734	324040
20508	29658	37	applied	\N	\N	\N	\N	156735	156735	324041
20508	29665	38	applied	\N	\N	\N	\N	156736	156736	324042
20508	29668	39	applied	\N	\N	\N	\N	156737	156737	324043
20508	29671	40	applied	\N	\N	\N	\N	156738	156738	324044
20508	29673	41	applied	\N	\N	\N	\N	156739	156739	324045
20508	29679	43	applied	\N	\N	\N	\N	156741	156741	324047
20508	29680	44	applied	\N	\N	\N	\N	156742	156742	324048
20508	29685	45	applied	\N	\N	\N	\N	156743	156743	324049
20508	29688	46	applied	\N	\N	\N	\N	156744	156744	324050
20508	29692	47	applied	\N	\N	\N	\N	156745	156745	324051
20508	29698	48	applied	\N	\N	\N	\N	156746	156746	324052
20508	29701	49	applied	\N	\N	\N	\N	156747	156747	324053
20508	29705	50	applied	\N	\N	\N	\N	156748	156748	324054
20508	29707	51	applied	\N	\N	\N	\N	156749	156749	324055
20508	29708	52	applied	\N	\N	\N	\N	156750	156750	324056
20508	29713	53	applied	\N	\N	\N	\N	156751	156751	324057
20508	29730	54	applied	\N	\N	\N	\N	156752	156752	324058
20508	29734	55	applied	\N	\N	\N	\N	156753	156753	324059
20508	29737	56	applied	\N	\N	\N	\N	156754	156754	324060
20517	30037	15	applied	\N	\N	\N	\N	156897	156897	324203
20517	30038	16	applied	\N	\N	\N	\N	156898	156898	324204
20517	30040	18	applied	\N	\N	\N	\N	156900	156900	324206
20517	30041	19	applied	\N	\N	\N	\N	156901	156901	324207
20517	30042	20	applied	\N	\N	\N	\N	156902	156902	324208
20517	30043	21	applied	\N	\N	\N	\N	156903	156903	324209
20517	30044	22	applied	\N	\N	1000000000	\N	156904	156904	324210
20518	30045	0	applied	\N	\N	\N	\N	156905	156905	324211
20518	30046	1	applied	\N	\N	\N	\N	156906	156906	324212
20518	30047	2	applied	\N	\N	\N	\N	156907	156907	324213
20518	30048	3	applied	\N	\N	\N	\N	156908	156908	324214
20522	30051	0	applied	\N	\N	\N	\N	156927	156927	324233
20522	30052	1	applied	\N	\N	\N	\N	156928	156928	324234
20522	30053	2	applied	\N	\N	\N	\N	156929	156929	324235
20522	30054	3	applied	\N	\N	\N	\N	156930	156930	324236
20528	30080	0	applied	\N	\N	\N	\N	156964	156964	324270
20528	30081	1	applied	\N	\N	\N	\N	156965	156965	324271
20528	30082	2	applied	\N	\N	\N	\N	156966	156966	324272
20533	30087	0	applied	\N	\N	\N	\N	156983	156983	324289
20533	30088	1	applied	\N	\N	\N	\N	156984	156984	324290
20533	30089	2	applied	\N	\N	\N	\N	156985	156985	324291
20533	30090	3	applied	\N	\N	\N	\N	156986	156986	324292
20533	30091	4	applied	\N	\N	\N	\N	156987	156987	324293
20538	30092	0	applied	\N	\N	\N	\N	157025	157025	324331
20538	30093	1	applied	\N	\N	\N	\N	157026	157026	324332
20538	30094	2	applied	\N	\N	\N	\N	157027	157027	324333
20538	30095	3	applied	\N	\N	\N	\N	157028	157028	324334
20538	30096	4	applied	\N	\N	\N	\N	157029	157029	324335
20538	30097	5	applied	\N	\N	\N	\N	157030	157030	324336
20539	30098	0	applied	\N	\N	\N	\N	157031	157031	324337
20539	30099	1	applied	\N	\N	\N	\N	157032	157032	324338
20539	30100	2	applied	\N	\N	\N	\N	157033	157033	324339
20546	30124	0	applied	\N	\N	\N	\N	157060	157060	324365
20546	30125	1	applied	\N	\N	\N	\N	157061	157061	324366
20547	30124	0	applied	\N	\N	\N	\N	157063	157063	324368
20547	30125	1	applied	\N	\N	\N	\N	157064	157064	324369
20547	30126	2	applied	\N	\N	\N	\N	157065	157065	324370
20551	30127	0	applied	\N	\N	\N	\N	157066	157066	324371
20551	30128	1	applied	\N	\N	\N	\N	157067	157067	324372
20551	30129	2	applied	\N	\N	\N	\N	157068	157068	324373
20551	30130	3	applied	\N	\N	\N	\N	157069	157069	324374
20551	30131	4	applied	\N	\N	\N	\N	157070	157070	324375
20551	30132	5	applied	\N	\N	\N	\N	157071	157071	324376
20551	30133	6	applied	\N	\N	\N	\N	157072	157072	324377
20552	30134	0	applied	\N	\N	\N	\N	157073	157073	324378
20552	30135	1	applied	\N	\N	\N	\N	157074	157074	324379
20552	30136	2	applied	\N	\N	\N	\N	157075	157075	324380
20556	30137	0	applied	\N	\N	\N	\N	157086	157086	324391
20556	30138	1	applied	\N	\N	\N	\N	157087	157087	324392
20556	30139	2	applied	\N	\N	\N	\N	157088	157088	324393
20562	30157	0	applied	\N	\N	\N	\N	157185	157185	324489
20562	30158	1	applied	\N	\N	\N	\N	157186	157186	324490
20567	30159	0	applied	\N	\N	\N	\N	157206	157206	324510
20567	30160	1	applied	\N	\N	\N	\N	157207	157207	324511
20567	30161	2	applied	\N	\N	\N	\N	157208	157208	324512
20567	30162	3	applied	\N	\N	\N	\N	157209	157209	324513
20567	30163	4	applied	\N	\N	\N	\N	157210	157210	324514
20567	30164	5	applied	\N	\N	\N	\N	157211	157211	324515
20567	30165	6	applied	\N	\N	\N	\N	157212	157212	324516
20567	30166	7	applied	\N	\N	\N	\N	157213	157213	324517
20571	30159	0	applied	\N	\N	\N	\N	157238	157238	324542
20571	30162	1	applied	\N	\N	\N	\N	157239	157239	324543
20571	30163	2	applied	\N	\N	\N	\N	157240	157240	324544
20571	30164	3	applied	\N	\N	\N	\N	157241	157241	324545
20571	30165	4	applied	\N	\N	\N	\N	157242	157242	324546
20571	30166	5	applied	\N	\N	\N	\N	157243	157243	324547
20508	29576	9	applied	\N	\N	\N	\N	156708	156708	324014
20508	29752	61	applied	\N	\N	\N	\N	156759	156759	324065
20508	29754	62	applied	\N	\N	\N	\N	156760	156760	324066
20508	29758	63	applied	\N	\N	\N	\N	156761	156761	324067
20508	29761	64	applied	\N	\N	\N	\N	156762	156762	324068
20508	29762	65	applied	\N	\N	\N	\N	156763	156763	324069
20508	29763	66	applied	\N	\N	\N	\N	156764	156764	324070
20508	29770	67	applied	\N	\N	\N	\N	156765	156765	324071
20508	29773	68	applied	\N	\N	\N	\N	156766	156766	324072
20508	29774	69	applied	\N	\N	\N	\N	156767	156767	324073
20508	29775	70	applied	\N	\N	\N	\N	156768	156768	324074
20508	29782	71	applied	\N	\N	\N	\N	156769	156769	324075
20508	29785	72	applied	\N	\N	\N	\N	156770	156770	324076
20508	29787	73	applied	\N	\N	\N	\N	156771	156771	324077
20508	29790	74	applied	\N	\N	\N	\N	156772	156772	324078
20508	29794	76	applied	\N	\N	\N	\N	156774	156774	324080
20508	29795	77	applied	\N	\N	\N	\N	156775	156775	324081
20508	29796	78	applied	\N	\N	\N	\N	156776	156776	324082
20508	29805	79	applied	\N	\N	\N	\N	156777	156777	324083
20508	29808	80	applied	\N	\N	\N	\N	156778	156778	324084
20508	29809	81	applied	\N	\N	\N	\N	156779	156779	324085
20508	29814	82	applied	\N	\N	\N	\N	156780	156780	324086
20508	29820	83	applied	\N	\N	\N	\N	156781	156781	324087
20508	29825	84	applied	\N	\N	\N	\N	156782	156782	324088
20508	29826	85	applied	\N	\N	\N	\N	156783	156783	324089
20508	29835	86	applied	\N	\N	\N	\N	156784	156784	324090
20508	29840	87	applied	\N	\N	\N	\N	156785	156785	324091
20508	29841	88	applied	\N	\N	\N	\N	156786	156786	324092
20508	29846	89	applied	\N	\N	\N	\N	156787	156787	324093
20508	29849	90	applied	\N	\N	\N	\N	156788	156788	324094
20508	29852	91	applied	\N	\N	\N	\N	156789	156789	324095
20508	29857	93	applied	\N	\N	\N	\N	156791	156791	324097
20508	29863	94	applied	\N	\N	\N	\N	156792	156792	324098
20508	29869	95	applied	\N	\N	\N	\N	156793	156793	324099
20508	29879	96	applied	\N	\N	\N	\N	156794	156794	324100
20508	29882	97	applied	\N	\N	\N	\N	156795	156795	324101
20508	29885	98	applied	\N	\N	\N	\N	156796	156796	324102
20508	29887	99	applied	\N	\N	\N	\N	156797	156797	324103
20508	29891	100	applied	\N	\N	\N	\N	156798	156798	324104
20508	29894	101	applied	\N	\N	\N	\N	156799	156799	324105
20508	29897	102	applied	\N	\N	\N	\N	156800	156800	324106
20508	29903	103	applied	\N	\N	\N	\N	156801	156801	324107
20508	29906	104	applied	\N	\N	\N	\N	156802	156802	324108
20508	29909	105	applied	\N	\N	\N	\N	156803	156803	324109
20508	29912	106	applied	\N	\N	\N	\N	156804	156804	324110
20508	29915	107	applied	\N	\N	\N	\N	156805	156805	324111
20508	29919	108	applied	\N	\N	\N	\N	156806	156806	324112
20508	29927	110	applied	\N	\N	\N	\N	156808	156808	324114
20508	29930	111	applied	\N	\N	\N	\N	156809	156809	324115
20508	29933	112	applied	\N	\N	\N	\N	156810	156810	324116
20508	29938	113	applied	\N	\N	\N	\N	156811	156811	324117
20508	29939	114	applied	\N	\N	\N	\N	156812	156812	324118
20508	29947	115	applied	\N	\N	\N	\N	156813	156813	324119
20508	29948	116	applied	\N	\N	\N	\N	156814	156814	324120
20508	29950	117	applied	\N	\N	\N	\N	156815	156815	324121
20508	29951	118	applied	\N	\N	\N	\N	156816	156816	324122
20508	29952	119	applied	\N	\N	\N	\N	156817	156817	324123
20508	29953	120	applied	\N	\N	\N	\N	156818	156818	324124
20508	29969	121	applied	\N	\N	\N	\N	156819	156819	324125
20508	29972	122	applied	\N	\N	\N	\N	156820	156820	324126
20508	29976	123	applied	\N	\N	\N	\N	156821	156821	324127
20508	29977	124	applied	\N	\N	\N	\N	156822	156822	324128
20508	29982	125	applied	\N	\N	\N	\N	156823	156823	324129
20510	30018	1	applied	\N	\N	\N	\N	156827	156827	324133
20510	30019	2	applied	\N	\N	\N	\N	156828	156828	324134
20512	30020	0	applied	\N	\N	\N	\N	156831	156831	324137
20512	30021	1	applied	\N	\N	\N	\N	156832	156832	324138
20516	30023	0	applied	\N	\N	\N	\N	156861	156861	324167
20516	30024	1	applied	\N	\N	\N	\N	156862	156862	324168
20516	30025	2	applied	\N	\N	\N	\N	156863	156863	324169
20516	30026	3	applied	\N	\N	\N	\N	156864	156864	324170
20516	30027	4	applied	\N	\N	\N	\N	156865	156865	324171
20516	30028	5	applied	\N	\N	\N	\N	156866	156866	324172
20516	30029	6	applied	\N	\N	\N	\N	156867	156867	324173
20516	30030	7	applied	\N	\N	\N	\N	156868	156868	324174
20516	30031	8	applied	\N	\N	\N	\N	156869	156869	324175
20516	30032	9	applied	\N	\N	\N	\N	156870	156870	324176
20516	30033	10	applied	\N	\N	\N	\N	156871	156871	324177
20516	30034	12	applied	\N	\N	\N	\N	156872	156872	324178
20516	30036	14	applied	\N	\N	\N	\N	156874	156874	324180
20516	30037	15	applied	\N	\N	\N	\N	156875	156875	324181
20516	30038	16	applied	\N	\N	\N	\N	156876	156876	324182
20516	30039	17	applied	\N	\N	\N	\N	156877	156877	324183
20516	30040	18	applied	\N	\N	\N	\N	156878	156878	324184
20516	30041	19	applied	\N	\N	\N	\N	156879	156879	324185
20516	30042	20	applied	\N	\N	\N	\N	156880	156880	324186
20516	30043	21	applied	\N	\N	\N	\N	156881	156881	324187
20516	30044	22	applied	\N	\N	1000000000	\N	156882	156882	324188
20521	30045	0	applied	\N	\N	\N	\N	156921	156921	324227
20521	30046	1	applied	\N	\N	\N	\N	156922	156922	324228
20521	30049	2	applied	\N	\N	\N	\N	156923	156923	324229
20521	30050	3	applied	\N	\N	\N	\N	156924	156924	324230
20521	30047	4	applied	\N	\N	\N	\N	156925	156925	324231
20521	30048	5	applied	\N	\N	\N	\N	156926	156926	324232
20526	30068	0	applied	\N	\N	\N	\N	156952	156952	324258
20526	30070	2	applied	\N	\N	\N	\N	156954	156954	324260
20526	30071	3	applied	\N	\N	\N	\N	156955	156955	324261
20526	30072	4	applied	\N	\N	\N	\N	156956	156956	324262
20526	30073	5	applied	\N	\N	\N	\N	156957	156957	324263
20526	30074	6	applied	\N	\N	\N	\N	156958	156958	324264
20526	30075	7	applied	\N	\N	\N	\N	156959	156959	324265
20527	30076	0	applied	\N	\N	\N	\N	156960	156960	324266
20527	30077	1	applied	\N	\N	\N	\N	156961	156961	324267
20527	30078	2	applied	\N	\N	\N	\N	156962	156962	324268
20527	30079	3	applied	\N	\N	\N	\N	156963	156963	324269
20532	30087	0	applied	\N	\N	\N	\N	156978	156978	324284
20532	30088	1	applied	\N	\N	\N	\N	156979	156979	324285
20532	30089	2	applied	\N	\N	\N	\N	156980	156980	324286
20532	30090	3	applied	\N	\N	\N	\N	156981	156981	324287
20532	30091	4	applied	\N	\N	\N	\N	156982	156982	324288
20537	30092	0	applied	\N	\N	\N	\N	157019	157019	324325
20508	29749	60	applied	\N	\N	\N	\N	156758	156758	324064
20515	30023	0	applied	\N	\N	\N	\N	156839	156839	324145
20515	30024	1	applied	\N	\N	\N	\N	156840	156840	324146
20515	30025	2	applied	\N	\N	\N	\N	156841	156841	324147
20515	30026	3	applied	\N	\N	\N	\N	156842	156842	324148
20515	30027	4	applied	\N	\N	\N	\N	156843	156843	324149
20515	30028	5	applied	\N	\N	\N	\N	156844	156844	324150
20515	30029	6	applied	\N	\N	\N	\N	156845	156845	324151
20515	30030	7	applied	\N	\N	\N	\N	156846	156846	324152
20515	30031	8	applied	\N	\N	\N	\N	156847	156847	324153
20515	30032	9	applied	\N	\N	\N	\N	156848	156848	324154
20515	30033	10	applied	\N	\N	\N	\N	156849	156849	324155
20515	30034	12	applied	\N	\N	\N	\N	156850	156850	324156
20515	30035	13	applied	\N	\N	\N	\N	156851	156851	324157
20515	30037	15	applied	\N	\N	\N	\N	156853	156853	324159
20515	30038	16	applied	\N	\N	\N	\N	156854	156854	324160
20515	30039	17	applied	\N	\N	\N	\N	156855	156855	324161
20515	30040	18	applied	\N	\N	\N	\N	156856	156856	324162
20515	30041	19	applied	\N	\N	\N	\N	156857	156857	324163
20515	30042	20	applied	\N	\N	\N	\N	156858	156858	324164
20515	30043	21	applied	\N	\N	\N	\N	156859	156859	324165
20515	30044	22	applied	\N	\N	1000000000	\N	156860	156860	324166
20520	30045	0	applied	\N	\N	\N	\N	156915	156915	324221
20520	30046	1	applied	\N	\N	\N	\N	156916	156916	324222
20520	30049	2	applied	\N	\N	\N	\N	156917	156917	324223
20520	30050	3	applied	\N	\N	\N	\N	156918	156918	324224
20520	30047	4	applied	\N	\N	\N	\N	156919	156919	324225
20520	30048	5	applied	\N	\N	\N	\N	156920	156920	324226
20524	30051	0	applied	\N	\N	\N	\N	156935	156935	324241
20524	30052	1	applied	\N	\N	\N	\N	156936	156936	324242
20524	30054	3	applied	\N	\N	\N	\N	156938	156938	324244
20525	30055	0	applied	\N	\N	\N	\N	156939	156939	324245
20525	30056	1	applied	\N	\N	\N	\N	156940	156940	324246
20525	30057	2	applied	\N	\N	\N	\N	156941	156941	324247
20525	30058	3	applied	\N	\N	\N	\N	156942	156942	324248
20525	30059	4	applied	\N	\N	\N	\N	156943	156943	324249
20525	30060	5	applied	\N	\N	\N	\N	156944	156944	324250
20525	30061	6	applied	\N	\N	\N	\N	156945	156945	324251
20525	30062	7	applied	\N	\N	\N	\N	156946	156946	324252
20525	30063	8	applied	\N	\N	\N	\N	156947	156947	324253
20525	30064	9	applied	\N	\N	\N	\N	156948	156948	324254
20525	30065	10	applied	\N	\N	\N	\N	156949	156949	324255
20525	30066	11	applied	\N	\N	\N	\N	156950	156950	324256
20525	30067	12	applied	\N	\N	\N	\N	156951	156951	324257
20531	30084	0	applied	\N	\N	\N	\N	156975	156975	324281
20531	30085	1	applied	\N	\N	\N	\N	156976	156976	324282
20535	30087	0	applied	\N	\N	\N	\N	156993	156993	324299
20535	30088	1	applied	\N	\N	\N	\N	156994	156994	324300
20535	30089	2	applied	\N	\N	\N	\N	156995	156995	324301
20535	30090	3	applied	\N	\N	\N	\N	156996	156996	324302
20535	30091	4	applied	\N	\N	\N	\N	156997	156997	324303
20536	29943	0	applied	\N	\N	\N	\N	156998	156998	324304
20536	29944	1	applied	\N	\N	\N	\N	156999	156999	324305
20536	29945	2	applied	\N	\N	\N	\N	157000	157000	324306
20536	29946	3	applied	\N	\N	\N	\N	157001	157001	324307
20536	30076	4	applied	\N	\N	\N	\N	157002	157002	324308
20536	30080	5	applied	\N	\N	\N	\N	157003	157003	324309
20536	30087	6	applied	\N	\N	\N	\N	157004	157004	324310
20536	30088	7	applied	\N	\N	\N	\N	157005	157005	324311
20536	29898	8	applied	\N	\N	1000000000	\N	157006	157006	324312
20536	30056	9	applied	\N	\N	\N	\N	157007	157007	324313
20536	29785	10	applied	\N	\N	\N	\N	157008	157008	324314
20536	29790	12	applied	\N	\N	\N	\N	157010	157010	324316
20536	29793	13	applied	\N	\N	\N	\N	157011	157011	324317
20536	29971	14	applied	\N	\N	\N	\N	157012	157012	324318
20536	29794	15	applied	\N	\N	\N	\N	157013	157013	324319
20536	29795	16	applied	\N	\N	\N	\N	157014	157014	324320
20536	29796	17	applied	\N	\N	\N	\N	157015	157015	324321
20537	30093	1	applied	\N	\N	\N	\N	157020	157020	324326
20537	30094	2	applied	\N	\N	\N	\N	157021	157021	324327
20537	30095	3	applied	\N	\N	\N	\N	157022	157022	324328
20537	30096	4	applied	\N	\N	\N	\N	157023	157023	324329
20537	30097	5	applied	\N	\N	\N	\N	157024	157024	324330
20545	30124	0	applied	\N	\N	\N	\N	157057	157057	324362
20545	30125	1	applied	\N	\N	\N	\N	157058	157058	324363
20545	30126	2	applied	\N	\N	\N	\N	157059	157059	324364
20555	30137	0	applied	\N	\N	\N	\N	157082	157082	324387
20555	30138	1	applied	\N	\N	\N	\N	157083	157083	324388
20555	30140	3	applied	\N	\N	\N	\N	157085	157085	324390
20560	30141	0	applied	\N	\N	\N	\N	157168	157168	324472
20560	30142	1	applied	\N	\N	\N	\N	157169	157169	324473
20560	30143	2	applied	\N	\N	\N	\N	157170	157170	324474
20560	30144	3	applied	\N	\N	\N	\N	157171	157171	324475
20560	30145	4	applied	\N	\N	\N	\N	157172	157172	324476
20560	30146	5	applied	\N	\N	\N	\N	157173	157173	324477
20560	30147	6	applied	\N	\N	\N	\N	157174	157174	324478
20560	30148	7	applied	\N	\N	\N	\N	157175	157175	324479
20560	30149	8	applied	\N	\N	\N	\N	157176	157176	324480
20560	30150	9	applied	\N	\N	\N	\N	157177	157177	324481
20560	30151	10	applied	\N	\N	\N	\N	157178	157178	324482
20560	30152	11	applied	\N	\N	\N	\N	157179	157179	324483
20560	30153	12	applied	\N	\N	\N	\N	157180	157180	324484
20560	30154	13	applied	\N	\N	\N	\N	157181	157181	324485
20561	30156	0	applied	\N	\N	\N	\N	157182	157182	324486
20561	30158	2	applied	\N	\N	\N	\N	157184	157184	324488
20566	30159	0	applied	\N	\N	\N	\N	157198	157198	324502
20566	30160	1	applied	\N	\N	\N	\N	157199	157199	324503
20566	30161	2	applied	\N	\N	\N	\N	157200	157200	324504
20566	30162	3	applied	\N	\N	\N	\N	157201	157201	324505
20566	30163	4	applied	\N	\N	\N	\N	157202	157202	324506
20566	30164	5	applied	\N	\N	\N	\N	157203	157203	324507
20566	30165	6	applied	\N	\N	\N	\N	157204	157204	324508
20566	30166	7	applied	\N	\N	\N	\N	157205	157205	324509
20570	30159	0	applied	\N	\N	\N	\N	157230	157230	324534
20570	30160	1	applied	\N	\N	\N	\N	157231	157231	324535
20570	30161	2	applied	\N	\N	\N	\N	157232	157232	324536
20570	30162	3	applied	\N	\N	\N	\N	157233	157233	324537
20570	30163	4	applied	\N	\N	\N	\N	157234	157234	324538
20570	30164	5	applied	\N	\N	\N	\N	157235	157235	324539
20570	30165	6	applied	\N	\N	\N	\N	157236	157236	324540
20514	30022	1	applied	\N	\N	\N	\N	156837	156837	324143
20514	30021	2	applied	\N	\N	\N	\N	156838	156838	324144
20542	30108	0	applied	\N	\N	\N	\N	157041	157041	324347
20542	30109	1	applied	\N	\N	\N	\N	157042	157042	324348
20542	30110	2	applied	\N	\N	1000000000	\N	157043	157043	324349
20542	30111	3	applied	\N	\N	\N	\N	157044	157044	324350
20543	30112	0	applied	\N	\N	\N	\N	157045	157045	324351
20543	30114	2	applied	\N	\N	\N	\N	157047	157047	324352
20543	30115	3	applied	\N	\N	\N	\N	157048	157048	324353
20543	30116	4	applied	\N	\N	\N	\N	157049	157049	324354
20543	30117	5	applied	\N	\N	\N	\N	157050	157050	324355
20543	30118	6	applied	\N	\N	\N	\N	157051	157051	324356
20543	30119	7	applied	\N	\N	\N	\N	157052	157052	324357
20543	30120	8	applied	\N	\N	\N	\N	157053	157053	324358
20544	30121	0	applied	\N	\N	\N	\N	157054	157054	324359
20544	30122	1	applied	\N	\N	\N	\N	157055	157055	324360
20544	30123	2	applied	\N	\N	\N	\N	157056	157056	324361
20554	30134	0	applied	\N	\N	\N	\N	157079	157079	324384
20554	30135	1	applied	\N	\N	\N	\N	157080	157080	324385
20554	30136	2	applied	\N	\N	\N	\N	157081	157081	324386
20559	29943	0	applied	\N	\N	\N	\N	157107	157107	324412
20559	29944	1	applied	\N	\N	\N	\N	157108	157108	324413
20559	29945	2	applied	\N	\N	\N	\N	157109	157109	324414
20559	29946	3	applied	\N	\N	\N	\N	157110	157110	324415
20559	30076	4	applied	\N	\N	\N	\N	157111	157111	324416
20559	30080	5	applied	\N	\N	\N	\N	157112	157112	324417
20559	30087	6	applied	\N	\N	\N	\N	157113	157113	324418
20559	30088	7	applied	\N	\N	\N	\N	157114	157114	324419
20559	29898	9	applied	\N	\N	1000000000	\N	157116	157116	324420
20559	30056	10	applied	\N	\N	\N	\N	157117	157117	324421
20559	29971	11	applied	\N	\N	\N	\N	157118	157118	324422
20559	30142	12	applied	\N	\N	\N	\N	157119	157119	324423
20559	30143	13	applied	\N	\N	\N	\N	157120	157120	324424
20559	30144	15	applied	\N	\N	\N	\N	157121	157121	324425
20559	30145	16	applied	\N	\N	\N	\N	157122	157122	324426
20559	30146	17	applied	\N	\N	\N	\N	157123	157123	324427
20559	29940	18	applied	\N	\N	\N	\N	157124	157124	324428
20559	29949	19	applied	\N	\N	\N	\N	157125	157125	324429
20559	30061	20	applied	\N	\N	\N	\N	157126	157126	324430
20559	30068	21	applied	\N	\N	\N	\N	157127	157127	324431
20559	30155	22	applied	\N	\N	\N	\N	157128	157128	324432
20559	30147	23	applied	\N	\N	\N	\N	157129	157129	324433
20559	30148	24	applied	\N	\N	\N	\N	157130	157130	324434
20559	30149	25	applied	\N	\N	\N	\N	157131	157131	324435
20559	30150	26	applied	\N	\N	\N	\N	157132	157132	324436
20559	30110	27	applied	\N	\N	1000000000	\N	157133	157133	324437
20559	29864	28	applied	\N	\N	\N	\N	157134	157134	324438
20559	29899	29	applied	\N	\N	\N	\N	157135	157135	324439
20559	29815	30	applied	\N	\N	\N	\N	157136	157136	324440
20559	29866	31	applied	\N	\N	\N	\N	157137	157137	324441
20559	29830	32	applied	\N	\N	1000000000	\N	157138	157138	324442
20559	29831	33	applied	\N	\N	1000000000	\N	157139	157139	324443
20559	29832	34	applied	\N	\N	1000000000	\N	157140	157140	324444
20559	29837	35	applied	\N	\N	1000000000	\N	157141	157141	324445
20559	29839	36	applied	\N	\N	1000000000	\N	157142	157142	324446
20559	30030	38	applied	\N	\N	\N	\N	157144	157144	324448
20559	30063	39	applied	\N	\N	\N	\N	157145	157145	324449
20559	30064	40	applied	\N	\N	\N	\N	157146	157146	324450
20559	30065	41	applied	\N	\N	\N	\N	157147	157147	324451
20559	29867	42	applied	\N	\N	\N	\N	157148	157148	324452
20559	29871	43	applied	\N	\N	\N	\N	157149	157149	324453
20559	29872	44	applied	\N	\N	\N	\N	157150	157150	324454
20559	29873	45	applied	\N	\N	\N	\N	157151	157151	324455
20559	29875	46	applied	\N	\N	\N	\N	157152	157152	324456
20559	29876	47	applied	\N	\N	\N	\N	157153	157153	324457
20559	30066	48	applied	\N	\N	\N	\N	157154	157154	324458
20559	30072	49	applied	\N	\N	\N	\N	157155	157155	324459
20559	30073	50	applied	\N	\N	\N	\N	157156	157156	324460
20559	30074	51	applied	\N	\N	\N	\N	157157	157157	324461
20559	29816	52	applied	\N	\N	\N	\N	157158	157158	324462
20559	29817	53	applied	\N	\N	\N	\N	157159	157159	324463
20559	29821	54	applied	\N	\N	\N	\N	157160	157160	324464
20559	29922	55	applied	\N	\N	\N	\N	157161	157161	324465
20559	30041	56	applied	\N	\N	\N	\N	157162	157162	324466
20559	30042	57	applied	\N	\N	\N	\N	157163	157163	324467
20559	30044	59	applied	\N	\N	1000000000	\N	157165	157165	324469
20559	30067	60	applied	\N	\N	\N	\N	157166	157166	324470
20559	29877	61	applied	\N	\N	\N	\N	157167	157167	324471
20565	30159	0	applied	\N	\N	\N	\N	157190	157190	324494
20565	30160	1	applied	\N	\N	\N	\N	157191	157191	324495
20565	30161	2	applied	\N	\N	\N	\N	157192	157192	324496
20565	30162	3	applied	\N	\N	\N	\N	157193	157193	324497
20565	30163	4	applied	\N	\N	\N	\N	157194	157194	324498
20565	30164	5	applied	\N	\N	\N	\N	157195	157195	324499
20565	30165	6	applied	\N	\N	\N	\N	157196	157196	324500
20565	30166	7	applied	\N	\N	\N	\N	157197	157197	324501
20569	30159	0	applied	\N	\N	\N	\N	157222	157222	324526
20569	30160	1	applied	\N	\N	\N	\N	157223	157223	324527
20569	30161	2	applied	\N	\N	\N	\N	157224	157224	324528
20569	30162	3	applied	\N	\N	\N	\N	157225	157225	324529
20569	30163	4	applied	\N	\N	\N	\N	157226	157226	324530
20569	30165	6	applied	\N	\N	\N	\N	157228	157228	324532
20569	30166	7	applied	\N	\N	\N	\N	157229	157229	324533
20573	30076	0	applied	\N	\N	\N	\N	157252	157252	324556
20573	30080	1	applied	\N	\N	\N	\N	157253	157253	324557
20573	30087	2	applied	\N	\N	\N	\N	157254	157254	324558
20573	30088	3	applied	\N	\N	\N	\N	157255	157255	324559
20573	30056	5	applied	\N	\N	\N	\N	157257	157257	324560
20573	30113	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	157256	157256	\N
20573	29971	6	applied	\N	\N	\N	\N	157258	157258	324561
20573	30159	7	applied	\N	\N	\N	\N	157259	157259	324562
20573	30142	8	applied	\N	\N	\N	\N	157260	157260	324563
20573	30143	9	applied	\N	\N	\N	\N	157261	157261	324564
20573	30144	10	applied	\N	\N	\N	\N	157262	157262	324565
20573	30145	11	applied	\N	\N	\N	\N	157263	157263	324566
20573	30146	12	applied	\N	\N	\N	\N	157264	157264	324567
20573	30057	13	applied	\N	\N	\N	\N	157265	157265	324568
20573	30059	15	applied	\N	\N	\N	\N	157267	157267	324570
20573	30060	16	applied	\N	\N	\N	\N	157268	157268	324571
20573	30061	17	applied	\N	\N	\N	\N	157269	157269	324572
20536	29940	19	applied	\N	\N	\N	\N	157017	157017	324323
20536	29949	20	applied	\N	\N	\N	\N	157018	157018	324324
20573	30148	21	applied	\N	\N	\N	\N	157273	157273	324576
20573	30149	22	applied	\N	\N	\N	\N	157274	157274	324577
20573	30150	23	applied	\N	\N	\N	\N	157275	157275	324578
20573	29972	24	applied	\N	\N	\N	\N	157276	157276	324579
20573	29976	25	applied	\N	\N	\N	\N	157277	157277	324580
20573	29977	26	applied	\N	\N	\N	\N	157278	157278	324581
20573	29982	27	applied	\N	\N	\N	\N	157279	157279	324582
20573	29985	28	applied	\N	\N	\N	\N	157280	157280	324583
20573	29987	30	applied	\N	\N	\N	\N	157282	157282	324585
20573	29994	31	applied	\N	\N	\N	\N	157283	157283	324586
20573	29998	32	applied	\N	\N	\N	\N	157284	157284	324587
20573	30001	33	applied	\N	\N	\N	\N	157285	157285	324588
20573	30003	34	applied	\N	\N	\N	\N	157286	157286	324589
20573	30007	35	applied	\N	\N	\N	\N	157287	157287	324590
20573	30010	36	applied	\N	\N	\N	\N	157288	157288	324591
20573	30013	37	applied	\N	\N	\N	\N	157289	157289	324592
20573	30017	38	applied	\N	\N	\N	\N	157290	157290	324593
20573	30020	39	applied	\N	\N	\N	\N	157291	157291	324594
20573	30023	40	applied	\N	\N	\N	\N	157292	157292	324595
20573	30024	41	applied	\N	\N	\N	\N	157293	157293	324596
20573	30025	42	applied	\N	\N	\N	\N	157294	157294	324597
20573	30026	43	applied	\N	\N	\N	\N	157295	157295	324598
20573	30027	44	applied	\N	\N	\N	\N	157296	157296	324599
20573	30045	45	applied	\N	\N	\N	\N	157297	157297	324600
20573	30051	47	applied	\N	\N	\N	\N	157299	157299	324602
20573	30055	48	applied	\N	\N	\N	\N	157300	157300	324603
20573	30069	49	applied	\N	\N	\N	\N	157301	157301	324604
20573	30077	50	applied	\N	\N	\N	\N	157302	157302	324605
20573	30084	51	applied	\N	\N	\N	\N	157303	157303	324606
20573	30089	52	applied	\N	\N	\N	\N	157304	157304	324607
20573	30092	53	applied	\N	\N	\N	\N	157305	157305	324608
20573	30093	54	applied	\N	\N	\N	\N	157306	157306	324609
20573	30098	55	applied	\N	\N	\N	\N	157307	157307	324610
20573	30101	56	applied	\N	\N	\N	\N	157308	157308	324611
20573	30106	57	applied	\N	\N	\N	\N	157309	157309	324612
20573	30108	58	applied	\N	\N	\N	\N	157310	157310	324613
20573	30114	59	applied	\N	\N	\N	\N	157311	157311	324614
20573	30115	60	applied	\N	\N	\N	\N	157312	157312	324615
20573	30121	61	applied	\N	\N	\N	\N	157313	157313	324616
20573	30124	62	applied	\N	\N	\N	\N	157314	157314	324617
20573	30128	64	applied	\N	\N	\N	\N	157316	157316	324619
20573	30134	65	applied	\N	\N	\N	\N	157317	157317	324620
20573	30137	66	applied	\N	\N	\N	\N	157318	157318	324621
20573	30141	67	applied	\N	\N	\N	\N	157319	157319	324622
20573	30151	68	applied	\N	\N	\N	\N	157320	157320	324623
20573	30156	69	applied	\N	\N	\N	\N	157321	157321	324624
20573	30160	70	applied	\N	\N	\N	\N	157322	157322	324625
20573	30161	71	applied	\N	\N	\N	\N	157323	157323	324626
20573	30030	73	applied	\N	\N	\N	\N	157325	157325	324628
20573	29983	74	applied	\N	\N	\N	\N	157326	157326	324629
20573	29997	75	applied	\N	\N	\N	\N	157327	157327	324630
20573	30004	76	applied	\N	\N	\N	\N	157328	157328	324631
20573	30014	77	applied	\N	\N	\N	\N	157329	157329	324632
20573	30028	78	applied	\N	\N	\N	\N	157330	157330	324633
20573	30029	79	applied	\N	\N	\N	\N	157331	157331	324634
20573	30064	81	applied	\N	\N	\N	\N	157333	157333	324636
20573	30065	82	applied	\N	\N	\N	\N	157334	157334	324637
20573	30066	83	applied	\N	\N	\N	\N	157335	157335	324638
20573	30072	84	applied	\N	\N	\N	\N	157336	157336	324639
20573	30073	85	applied	\N	\N	\N	\N	157337	157337	324640
20573	30074	86	applied	\N	\N	\N	\N	157338	157338	324641
20573	29975	87	applied	\N	\N	\N	\N	157339	157339	324642
20573	29978	88	applied	\N	\N	\N	\N	157340	157340	324643
20573	29979	90	applied	\N	\N	\N	\N	157341	157341	324644
20573	29991	91	applied	\N	\N	\N	\N	157342	157342	324645
20573	29980	92	applied	\N	\N	\N	\N	157343	157343	324646
20573	29981	93	applied	\N	\N	\N	\N	157344	157344	324647
20573	29984	94	applied	\N	\N	\N	\N	157345	157345	324648
20573	29988	95	applied	\N	\N	\N	\N	157346	157346	324649
20573	29989	96	applied	\N	\N	\N	\N	157347	157347	324650
20573	29990	97	applied	\N	\N	\N	\N	157348	157348	324651
20574	30167	0	applied	\N	\N	\N	\N	157350	157350	324653
20574	30168	1	applied	\N	\N	\N	\N	157351	157351	324654
20574	30169	2	applied	\N	\N	\N	\N	157352	157352	324655
20574	30170	3	applied	\N	\N	\N	\N	157353	157353	324656
20575	30172	1	applied	\N	\N	\N	\N	157355	157355	324657
20575	30171	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	157354	157354	\N
20575	30173	2	applied	\N	\N	\N	\N	157356	157356	324658
20575	30174	3	applied	\N	\N	\N	\N	157357	157357	324659
20576	30172	1	applied	\N	\N	\N	\N	157359	157359	324660
20576	30173	2	applied	\N	\N	\N	\N	157360	157360	324661
20576	30174	3	applied	\N	\N	\N	\N	157361	157361	324662
20577	30175	0	applied	\N	\N	\N	\N	157362	157362	324663
20577	30176	1	applied	\N	\N	\N	\N	157363	157363	324664
20577	30177	2	applied	\N	\N	\N	\N	157364	157364	324665
20578	30175	0	applied	\N	\N	\N	\N	157365	157365	324666
20578	30176	1	applied	\N	\N	\N	\N	157366	157366	324667
20578	30177	2	applied	\N	\N	\N	\N	157367	157367	324668
20579	29943	0	applied	\N	\N	\N	\N	157368	157368	324669
20579	29944	1	applied	\N	\N	\N	\N	157369	157369	324670
20579	29945	2	applied	\N	\N	\N	\N	157370	157370	324671
20579	29946	3	applied	\N	\N	\N	\N	157371	157371	324672
20579	30076	4	applied	\N	\N	\N	\N	157372	157372	324673
20579	30080	5	applied	\N	\N	\N	\N	157373	157373	324674
20579	30087	6	applied	\N	\N	\N	\N	157374	157374	324675
20579	30088	7	applied	\N	\N	\N	\N	157375	157375	324676
20579	29939	8	applied	\N	\N	\N	\N	157376	157376	324677
20579	29947	10	applied	\N	\N	\N	\N	157378	157378	324678
20579	30113	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	157377	157377	\N
20579	29948	11	applied	\N	\N	\N	\N	157379	157379	324679
20579	30056	12	applied	\N	\N	\N	\N	157380	157380	324680
20579	29971	13	applied	\N	\N	\N	\N	157381	157381	324681
20579	30159	14	applied	\N	\N	\N	\N	157382	157382	324682
20579	30142	15	applied	\N	\N	\N	\N	157383	157383	324683
20579	30143	16	applied	\N	\N	\N	\N	157384	157384	324684
20579	30144	17	applied	\N	\N	\N	\N	157385	157385	324685
20579	30145	18	applied	\N	\N	\N	\N	157386	157386	324686
20579	30146	19	applied	\N	\N	\N	\N	157387	157387	324687
20573	30155	19	applied	\N	\N	\N	\N	157271	157271	324574
20573	30147	20	applied	\N	\N	\N	\N	157272	157272	324575
20579	29953	24	applied	\N	\N	\N	\N	157392	157392	324692
20579	29969	25	applied	\N	\N	\N	\N	157393	157393	324693
20579	30061	26	applied	\N	\N	\N	\N	157394	157394	324694
20579	30068	27	applied	\N	\N	\N	\N	157395	157395	324695
20579	30155	28	applied	\N	\N	\N	\N	157396	157396	324696
20579	30147	29	applied	\N	\N	\N	\N	157397	157397	324697
20579	30148	30	applied	\N	\N	\N	\N	157398	157398	324698
20579	30149	31	applied	\N	\N	\N	\N	157399	157399	324699
20579	30150	32	applied	\N	\N	\N	\N	157400	157400	324700
20579	29972	33	applied	\N	\N	\N	\N	157401	157401	324701
20579	29976	34	applied	\N	\N	\N	\N	157402	157402	324702
20579	29977	35	applied	\N	\N	\N	\N	157403	157403	324703
20579	29985	37	applied	\N	\N	\N	\N	157405	157405	324705
20579	29986	38	applied	\N	\N	\N	\N	157406	157406	324706
20579	29987	39	applied	\N	\N	\N	\N	157407	157407	324707
20579	29994	40	applied	\N	\N	\N	\N	157408	157408	324708
20579	29998	41	applied	\N	\N	\N	\N	157409	157409	324709
20579	30001	42	applied	\N	\N	\N	\N	157410	157410	324710
20579	30003	43	applied	\N	\N	\N	\N	157411	157411	324711
20579	30007	44	applied	\N	\N	\N	\N	157412	157412	324712
20579	30010	45	applied	\N	\N	\N	\N	157413	157413	324713
20579	30013	46	applied	\N	\N	\N	\N	157414	157414	324714
20579	30017	47	applied	\N	\N	\N	\N	157415	157415	324715
20579	30020	48	applied	\N	\N	\N	\N	157416	157416	324716
20579	30023	49	applied	\N	\N	\N	\N	157417	157417	324717
20579	30024	50	applied	\N	\N	\N	\N	157418	157418	324718
20579	30025	51	applied	\N	\N	\N	\N	157419	157419	324719
20579	30026	52	applied	\N	\N	\N	\N	157420	157420	324720
20579	30045	54	applied	\N	\N	\N	\N	157422	157422	324722
20579	30046	55	applied	\N	\N	\N	\N	157423	157423	324723
20579	30051	56	applied	\N	\N	\N	\N	157424	157424	324724
20579	30055	57	applied	\N	\N	\N	\N	157425	157425	324725
20579	30069	58	applied	\N	\N	\N	\N	157426	157426	324726
20579	30077	59	applied	\N	\N	\N	\N	157427	157427	324727
20579	30084	60	applied	\N	\N	\N	\N	157428	157428	324728
20579	30089	61	applied	\N	\N	\N	\N	157429	157429	324729
20579	30092	62	applied	\N	\N	\N	\N	157430	157430	324730
20579	30093	63	applied	\N	\N	\N	\N	157431	157431	324731
20579	30098	64	applied	\N	\N	\N	\N	157432	157432	324732
20579	30101	65	applied	\N	\N	\N	\N	157433	157433	324733
20579	30106	67	applied	\N	\N	\N	\N	157434	157434	324734
20579	30108	68	applied	\N	\N	\N	\N	157435	157435	324735
20579	30114	69	applied	\N	\N	\N	\N	157436	157436	324736
20579	30115	70	applied	\N	\N	\N	\N	157437	157437	324737
20579	30124	72	applied	\N	\N	\N	\N	157439	157439	324739
20579	30127	73	applied	\N	\N	\N	\N	157440	157440	324740
20579	30128	74	applied	\N	\N	\N	\N	157441	157441	324741
20579	30134	75	applied	\N	\N	\N	\N	157442	157442	324742
20579	30137	76	applied	\N	\N	\N	\N	157443	157443	324743
20579	30141	77	applied	\N	\N	\N	\N	157444	157444	324744
20579	30151	78	applied	\N	\N	\N	\N	157445	157445	324745
20579	30156	79	applied	\N	\N	\N	\N	157446	157446	324746
20579	30160	80	applied	\N	\N	\N	\N	157447	157447	324747
20579	30161	81	applied	\N	\N	\N	\N	157448	157448	324748
20579	30167	82	applied	\N	\N	\N	\N	157449	157449	324749
20579	30172	83	applied	\N	\N	\N	\N	157450	157450	324750
20579	30175	84	applied	\N	\N	\N	\N	157451	157451	324751
20579	29954	85	applied	\N	\N	\N	\N	157452	157452	324752
20579	29836	87	applied	\N	\N	\N	\N	157454	157454	324754
20579	29842	88	applied	\N	\N	\N	\N	157455	157455	324755
20579	29955	89	applied	\N	\N	1000000000	\N	157456	157456	324756
20579	30030	90	applied	\N	\N	\N	\N	157457	157457	324757
20579	30063	91	applied	\N	\N	\N	\N	157458	157458	324758
20579	30064	92	applied	\N	\N	\N	\N	157459	157459	324759
20579	30065	93	applied	\N	\N	\N	\N	157460	157460	324760
20579	29962	94	applied	\N	\N	\N	\N	157461	157461	324761
20579	29974	95	applied	\N	\N	\N	\N	157462	157462	324762
20579	29983	96	applied	\N	\N	\N	\N	157463	157463	324763
20579	29997	97	applied	\N	\N	\N	\N	157464	157464	324764
20579	30004	98	applied	\N	\N	\N	\N	157465	157465	324765
20579	30014	99	applied	\N	\N	\N	\N	157466	157466	324766
20579	30028	100	applied	\N	\N	\N	\N	157467	157467	324767
20585	30186	0	applied	\N	\N	\N	\N	157499	157499	324799
20585	30187	1	applied	\N	\N	\N	\N	157500	157500	324800
20585	30188	2	applied	\N	\N	\N	\N	157501	157501	324801
20585	30189	3	applied	\N	\N	\N	\N	157502	157502	324802
20585	30190	4	applied	\N	\N	\N	\N	157503	157503	324803
20585	30191	5	applied	\N	\N	\N	\N	157504	157504	324804
20585	30193	7	applied	\N	\N	\N	\N	157506	157506	324806
20585	30194	8	applied	\N	\N	\N	\N	157507	157507	324807
20585	30184	9	applied	\N	\N	\N	\N	157508	157508	324808
20589	30195	0	applied	\N	\N	\N	\N	157527	157527	324827
20589	30196	1	applied	\N	\N	\N	\N	157528	157528	324828
20589	30197	2	applied	\N	\N	\N	\N	157529	157529	324829
20589	30198	3	applied	\N	\N	\N	\N	157530	157530	324830
20594	30202	0	applied	\N	\N	\N	\N	157546	157546	324846
20594	30204	1	applied	\N	\N	\N	\N	157547	157547	324847
20594	30206	2	applied	\N	\N	\N	\N	157548	157548	324848
20594	30207	3	applied	\N	\N	\N	\N	157549	157549	324849
20600	30221	0	applied	\N	\N	\N	\N	157690	157690	324989
20600	30222	1	applied	\N	\N	\N	\N	157691	157691	324990
20600	30223	2	applied	\N	\N	\N	\N	157692	157692	324991
20605	30225	0	applied	\N	\N	\N	\N	157702	157702	325001
20611	30232	0	applied	\N	\N	\N	\N	157746	157746	325044
20611	30234	2	applied	\N	\N	\N	\N	157748	157748	325046
20611	30235	3	applied	\N	\N	\N	\N	157749	157749	325047
20611	30236	4	applied	\N	\N	\N	\N	157750	157750	325048
20611	30237	5	applied	\N	\N	\N	\N	157751	157751	325049
20611	30238	6	applied	\N	\N	\N	\N	157752	157752	325050
20611	30239	7	applied	\N	\N	\N	\N	157753	157753	325051
20611	30240	8	applied	\N	\N	\N	\N	157754	157754	325052
20611	30241	9	applied	\N	\N	\N	\N	157755	157755	325053
20612	30242	0	applied	\N	\N	\N	\N	157756	157756	325054
20612	30243	1	applied	\N	\N	\N	\N	157757	157757	325055
20612	30244	2	applied	\N	\N	\N	\N	157758	157758	325056
20618	30258	0	applied	\N	\N	\N	\N	157778	157778	325074
20618	30259	1	applied	\N	\N	\N	\N	157779	157779	325075
20618	30260	2	applied	\N	\N	\N	\N	157780	157780	325076
20618	30261	3	applied	\N	\N	\N	\N	157781	157781	157781
20579	29950	21	applied	\N	\N	\N	\N	157389	157389	324689
20579	29952	23	applied	\N	\N	\N	\N	157391	157391	324691
20586	30186	0	applied	\N	\N	\N	\N	157509	157509	324809
20586	30187	1	applied	\N	\N	\N	\N	157510	157510	324810
20586	30188	2	applied	\N	\N	\N	\N	157511	157511	324811
20586	30189	3	applied	\N	\N	\N	\N	157512	157512	324812
20586	30190	4	applied	\N	\N	\N	\N	157513	157513	324813
20586	30192	6	applied	\N	\N	\N	\N	157515	157515	324815
20586	30193	7	applied	\N	\N	\N	\N	157516	157516	324816
20586	30194	8	applied	\N	\N	\N	\N	157517	157517	324817
20586	30184	9	applied	\N	\N	\N	\N	157518	157518	324818
20590	30195	0	applied	\N	\N	\N	\N	157531	157531	324831
20590	30197	1	applied	\N	\N	\N	\N	157532	157532	324832
20590	30198	2	applied	\N	\N	\N	\N	157533	157533	324833
20591	30199	0	applied	\N	\N	\N	\N	157534	157534	324834
20591	30200	1	applied	\N	\N	\N	\N	157535	157535	324835
20591	30201	2	applied	\N	\N	\N	\N	157536	157536	324836
20595	30202	0	applied	\N	\N	\N	\N	157550	157550	324850
20595	30203	1	applied	\N	\N	\N	\N	157551	157551	324851
20595	30204	2	applied	\N	\N	\N	\N	157552	157552	324852
20595	30205	3	applied	\N	\N	\N	\N	157553	157553	324853
20595	30206	4	applied	\N	\N	\N	\N	157554	157554	324854
20595	30207	5	applied	\N	\N	\N	\N	157555	157555	324855
20596	30080	1	applied	\N	\N	\N	\N	157557	157557	324857
20596	30087	2	applied	\N	\N	\N	\N	157558	157558	324858
20596	30088	3	applied	\N	\N	\N	\N	157559	157559	324859
20596	30202	4	applied	\N	\N	\N	\N	157560	157560	324860
20596	30178	5	applied	\N	\N	\N	\N	157561	157561	324861
20596	30159	7	applied	\N	\N	\N	\N	157563	157563	324862
20596	30203	8	applied	\N	\N	\N	\N	157564	157564	324863
20596	30187	9	applied	\N	\N	\N	\N	157565	157565	324864
20596	30188	10	applied	\N	\N	\N	\N	157566	157566	324865
20596	30189	11	applied	\N	\N	\N	\N	157567	157567	324866
20596	30190	12	applied	\N	\N	\N	\N	157568	157568	324867
20596	30068	13	applied	\N	\N	\N	\N	157569	157569	324868
20596	30142	14	applied	\N	\N	\N	\N	157570	157570	324869
20596	30143	15	applied	\N	\N	\N	\N	157571	157571	324870
20596	30144	16	applied	\N	\N	\N	\N	157572	157572	324871
20596	30146	18	applied	\N	\N	\N	\N	157574	157574	324873
20596	30208	19	applied	\N	\N	\N	\N	157575	157575	324874
20596	30209	20	applied	\N	\N	\N	\N	157576	157576	324875
20596	30191	21	applied	\N	\N	\N	\N	157577	157577	324876
20596	30192	22	applied	\N	\N	\N	\N	157578	157578	324877
20596	30193	23	applied	\N	\N	\N	\N	157579	157579	324878
20596	30210	24	applied	\N	\N	\N	\N	157580	157580	324879
20596	30211	25	applied	\N	\N	\N	\N	157581	157581	324880
20596	30069	26	applied	\N	\N	\N	\N	157582	157582	324881
20596	30077	27	applied	\N	\N	\N	\N	157583	157583	324882
20596	30084	28	applied	\N	\N	\N	\N	157584	157584	324883
20596	30089	29	applied	\N	\N	\N	\N	157585	157585	324884
20596	30092	30	applied	\N	\N	\N	\N	157586	157586	324885
20596	30093	31	applied	\N	\N	\N	\N	157587	157587	324886
20596	30098	32	applied	\N	\N	\N	\N	157588	157588	324887
20596	30101	33	applied	\N	\N	\N	\N	157589	157589	324888
20596	30108	35	applied	\N	\N	\N	\N	157591	157591	324890
20596	30114	36	applied	\N	\N	\N	\N	157592	157592	324891
20596	30115	37	applied	\N	\N	\N	\N	157593	157593	324892
20596	30121	38	applied	\N	\N	\N	\N	157594	157594	324893
20596	30124	39	applied	\N	\N	\N	\N	157595	157595	324894
20596	30127	40	applied	\N	\N	\N	\N	157596	157596	324895
20596	30128	41	applied	\N	\N	\N	\N	157597	157597	324896
20596	30102	42	applied	\N	\N	\N	\N	157598	157598	324897
20596	30147	43	applied	\N	\N	\N	\N	157599	157599	324898
20596	30148	44	applied	\N	\N	\N	\N	157600	157600	324899
20596	30149	45	applied	\N	\N	\N	\N	157601	157601	324900
20596	30150	46	applied	\N	\N	\N	\N	157602	157602	324901
20596	30070	47	applied	\N	\N	\N	\N	157603	157603	324902
20596	30112	48	applied	\N	\N	\N	\N	157604	157604	324903
20618	30262	4	applied	\N	\N	\N	\N	157782	157782	325077
20618	30263	5	applied	\N	\N	\N	\N	157783	157783	325078
20619	30265	0	applied	\N	\N	1000000000	\N	157785	157785	325080
20619	30266	1	applied	\N	\N	1000000000	\N	157786	157786	325081
20619	30267	2	applied	\N	\N	\N	\N	157787	157787	325082
20619	30268	3	applied	\N	\N	\N	\N	157788	157788	325083
20619	30269	4	applied	\N	\N	\N	\N	157789	157789	325084
20635	30347	0	applied	\N	\N	\N	\N	157990	157990	325271
20635	30348	1	applied	\N	\N	\N	\N	157991	157991	325272
20635	30349	2	applied	\N	\N	\N	\N	157992	157992	325273
20636	30350	0	applied	\N	\N	\N	\N	157993	157993	325274
20636	30351	1	applied	\N	\N	\N	\N	157994	157994	325275
20643	30371	0	applied	\N	\N	\N	\N	158018	158018	325299
20643	30372	1	applied	\N	\N	\N	\N	158019	158019	325300
20643	30373	2	applied	\N	\N	\N	\N	158020	158020	325301
20648	30374	0	applied	\N	\N	\N	\N	158149	158149	325423
20648	30375	1	applied	\N	\N	\N	\N	158150	158150	325424
20648	30376	2	applied	\N	\N	\N	\N	158151	158151	325425
20657	30385	0	applied	\N	\N	\N	\N	158295	158295	325568
20657	30386	1	applied	\N	\N	\N	\N	158296	158296	325569
20657	30387	2	applied	\N	\N	\N	\N	158297	158297	325570
20657	30388	3	applied	\N	\N	\N	\N	158298	158298	325571
20662	30391	0	applied	\N	\N	\N	\N	158313	158313	325586
20669	30407	0	applied	\N	\N	\N	\N	158360	158360	325633
20669	30408	1	applied	\N	\N	\N	\N	158361	158361	325634
20669	30409	2	applied	\N	\N	\N	\N	158362	158362	325635
20675	30416	0	applied	\N	\N	\N	\N	158384	158384	325657
20675	30417	1	applied	\N	\N	\N	\N	158385	158385	325658
20675	30418	2	applied	\N	\N	\N	\N	158386	158386	325659
20675	30419	3	applied	\N	\N	\N	\N	158387	158387	325660
20675	30420	4	applied	\N	\N	\N	\N	158388	158388	325661
20675	30421	5	applied	\N	\N	\N	\N	158389	158389	325662
20675	30422	6	applied	\N	\N	\N	\N	158390	158390	325663
20675	30423	7	applied	\N	\N	\N	\N	158391	158391	325664
20680	30394	0	applied	\N	\N	\N	\N	158417	158417	325690
20680	30395	1	applied	\N	\N	\N	\N	158418	158418	325691
20680	30396	2	applied	\N	\N	\N	\N	158419	158419	325692
20680	30397	3	applied	\N	\N	\N	\N	158420	158420	325693
20680	30407	4	applied	\N	\N	\N	\N	158421	158421	325694
20680	30410	5	applied	\N	\N	\N	\N	158422	158422	325695
20680	30413	6	applied	\N	\N	\N	\N	158423	158423	325696
20680	30416	7	applied	\N	\N	\N	\N	158424	158424	325697
20580	30176	1	applied	\N	\N	\N	\N	157469	157469	324769
20580	30177	2	applied	\N	\N	\N	\N	157470	157470	324770
20582	30179	1	applied	\N	\N	\N	\N	157475	157475	324775
20582	30180	2	applied	\N	\N	\N	\N	157476	157476	324776
20582	30181	3	applied	\N	\N	\N	\N	157477	157477	324777
20582	30182	4	applied	\N	\N	\N	\N	157478	157478	324778
20582	30183	5	applied	\N	\N	\N	\N	157479	157479	324779
20582	30184	6	applied	\N	\N	\N	\N	157480	157480	324780
20582	30185	7	applied	\N	\N	\N	\N	157481	157481	324781
20587	30195	0	applied	\N	\N	\N	\N	157519	157519	324819
20587	30196	1	applied	\N	\N	\N	\N	157520	157520	324820
20587	30197	2	applied	\N	\N	\N	\N	157521	157521	324821
20587	30198	3	applied	\N	\N	\N	\N	157522	157522	324822
20592	30199	0	applied	\N	\N	\N	\N	157537	157537	324837
20592	30200	1	applied	\N	\N	\N	\N	157538	157538	324838
20592	30201	2	applied	\N	\N	\N	\N	157539	157539	324839
20596	30134	49	applied	\N	\N	\N	\N	157605	157605	324904
20596	30141	51	applied	\N	\N	\N	\N	157607	157607	324906
20596	30151	52	applied	\N	\N	\N	\N	157608	157608	324907
20596	30156	53	applied	\N	\N	\N	\N	157609	157609	324908
20596	30160	54	applied	\N	\N	\N	\N	157610	157610	324909
20596	30161	55	applied	\N	\N	\N	\N	157611	157611	324910
20596	30167	56	applied	\N	\N	\N	\N	157612	157612	324911
20596	30172	57	applied	\N	\N	\N	\N	157613	157613	324912
20596	30175	58	applied	\N	\N	\N	\N	157614	157614	324913
20596	30179	59	applied	\N	\N	\N	\N	157615	157615	324914
20596	30180	60	applied	\N	\N	\N	\N	157616	157616	324915
20596	30186	61	applied	\N	\N	\N	\N	157617	157617	324916
20596	30195	62	applied	\N	\N	\N	\N	157618	157618	324917
20596	30199	63	applied	\N	\N	\N	\N	157619	157619	324918
20596	30204	64	applied	\N	\N	\N	\N	157620	157620	324919
20596	30212	65	applied	\N	\N	\N	\N	157621	157621	324920
20596	30071	66	applied	\N	\N	\N	\N	157622	157622	324921
20596	30072	68	applied	\N	\N	\N	\N	157624	157624	324923
20596	30073	69	applied	\N	\N	\N	\N	157625	157625	324924
20596	30074	70	applied	\N	\N	\N	\N	157626	157626	324925
20596	30079	71	applied	\N	\N	\N	\N	157627	157627	324926
20596	30081	72	applied	\N	\N	\N	\N	157628	157628	324927
20596	30075	73	applied	\N	\N	\N	\N	157629	157629	324928
20596	30078	74	applied	\N	\N	\N	\N	157630	157630	324929
20596	30082	75	applied	\N	\N	\N	\N	157631	157631	324930
20596	30094	76	applied	\N	\N	\N	\N	157632	157632	324931
20596	30105	77	applied	\N	\N	\N	\N	157633	157633	324932
20596	30117	78	applied	\N	\N	\N	\N	157634	157634	324933
20596	30129	79	applied	\N	\N	\N	\N	157635	157635	324934
20596	30140	80	applied	\N	\N	\N	\N	157636	157636	324935
20596	30162	81	applied	\N	\N	\N	\N	157637	157637	324936
20596	30173	82	applied	\N	\N	\N	\N	157638	157638	324937
20596	30181	83	applied	\N	\N	\N	\N	157639	157639	324938
20596	30206	84	applied	\N	\N	\N	\N	157640	157640	324939
20596	30170	86	applied	\N	\N	\N	\N	157641	157641	324940
20596	30090	88	applied	\N	\N	\N	\N	157643	157643	324942
20596	30096	89	applied	\N	\N	\N	\N	157644	157644	324943
20596	30097	90	applied	\N	\N	\N	\N	157645	157645	324944
20596	30100	91	applied	\N	\N	\N	\N	157646	157646	324945
20596	30103	92	applied	\N	\N	\N	\N	157647	157647	324946
20596	30107	93	applied	\N	\N	\N	\N	157648	157648	324947
20596	30111	94	applied	\N	\N	\N	\N	157649	157649	324948
20597	30212	0	applied	\N	\N	\N	\N	157681	157681	324980
20597	30213	1	applied	\N	\N	\N	\N	157682	157682	324981
20603	30224	0	applied	\N	\N	\N	\N	157698	157698	324997
20603	30225	1	applied	\N	\N	\N	\N	157699	157699	324998
20607	30224	0	applied	\N	\N	\N	\N	157705	157705	325004
20607	30225	1	applied	\N	\N	\N	\N	157706	157706	325005
20608	29943	0	applied	\N	\N	\N	\N	157707	157707	325006
20608	29944	1	applied	\N	\N	\N	\N	157708	157708	325007
20608	29945	2	applied	\N	\N	\N	\N	157709	157709	325008
20608	30076	4	applied	\N	\N	\N	\N	157711	157711	325010
20608	30080	5	applied	\N	\N	\N	\N	157712	157712	325011
20608	30087	6	applied	\N	\N	\N	\N	157713	157713	325012
20608	30088	7	applied	\N	\N	\N	\N	157714	157714	325013
20608	30202	8	applied	\N	\N	\N	\N	157715	157715	325014
20608	30178	9	applied	\N	\N	\N	\N	157716	157716	325015
20608	29898	11	applied	\N	\N	1000000000	\N	157718	157718	325016
20608	30203	12	applied	\N	\N	\N	\N	157719	157719	325017
20608	30187	13	applied	\N	\N	\N	\N	157720	157720	325018
20608	30188	14	applied	\N	\N	\N	\N	157721	157721	325019
20608	30189	15	applied	\N	\N	\N	\N	157722	157722	325020
20608	30190	16	applied	\N	\N	\N	\N	157723	157723	325021
20608	30056	17	applied	\N	\N	\N	\N	157724	157724	325022
20608	29971	18	applied	\N	\N	\N	\N	157725	157725	325023
20608	30159	19	applied	\N	\N	\N	\N	157726	157726	325024
20608	30143	21	applied	\N	\N	\N	\N	157728	157728	325026
20608	30144	22	applied	\N	\N	\N	\N	157729	157729	325027
20614	30245	0	applied	\N	\N	\N	\N	157762	157762	325060
20614	30246	1	applied	\N	\N	\N	\N	157763	157763	325061
20614	30247	2	applied	\N	\N	\N	\N	157764	157764	325062
20621	30270	0	applied	\N	\N	\N	\N	157813	157813	325104
20621	30271	1	applied	\N	\N	\N	\N	157814	157814	157814
20621	30272	2	applied	\N	\N	1000000000	\N	157815	157815	325105
20621	30273	3	applied	\N	\N	1000000000	\N	157816	157816	325106
20621	30274	4	applied	\N	\N	1000000000	\N	157817	157817	325107
20622	30275	0	applied	\N	\N	\N	\N	157818	157818	325108
20622	30276	1	applied	\N	\N	\N	\N	157819	157819	325109
20622	30277	2	applied	\N	\N	\N	\N	157820	157820	325110
20622	30278	3	applied	\N	\N	\N	\N	157821	157821	325111
20622	30279	4	applied	\N	\N	\N	\N	157822	157822	157822
20622	30280	5	applied	\N	\N	\N	\N	157823	157823	325112
20633	30336	0	applied	\N	\N	\N	\N	157976	157976	325257
20633	30337	1	applied	\N	\N	\N	\N	157977	157977	325258
20633	30338	2	applied	\N	\N	\N	\N	157978	157978	325259
20633	30339	3	applied	\N	\N	\N	\N	157979	157979	325260
20633	30340	4	applied	\N	\N	\N	\N	157980	157980	325261
20633	30341	5	applied	\N	\N	\N	\N	157981	157981	325262
20633	30342	6	applied	\N	\N	\N	\N	157982	157982	325263
20633	30343	7	applied	\N	\N	\N	\N	157983	157983	325264
20633	30344	8	applied	\N	\N	\N	\N	157984	157984	325265
20633	30345	9	applied	\N	\N	\N	\N	157985	157985	325266
20633	30346	10	applied	\N	\N	\N	\N	157986	157986	325267
20638	30352	0	applied	\N	\N	\N	\N	157999	157999	325280
20581	30176	1	applied	\N	\N	\N	\N	157472	157472	324772
20582	30178	0	applied	\N	\N	\N	\N	157474	157474	324774
20583	30181	3	applied	\N	\N	\N	\N	157485	157485	324785
20583	30182	4	applied	\N	\N	\N	\N	157486	157486	324786
20583	30183	5	applied	\N	\N	\N	\N	157487	157487	324787
20583	30185	6	applied	\N	\N	\N	\N	157488	157488	324788
20584	30186	0	applied	\N	\N	\N	\N	157489	157489	324789
20584	30187	1	applied	\N	\N	\N	\N	157490	157490	324790
20584	30188	2	applied	\N	\N	\N	\N	157491	157491	324791
20584	30189	3	applied	\N	\N	\N	\N	157492	157492	324792
20584	30190	4	applied	\N	\N	\N	\N	157493	157493	324793
20584	30192	6	applied	\N	\N	\N	\N	157495	157495	324795
20584	30193	7	applied	\N	\N	\N	\N	157496	157496	324796
20584	30194	8	applied	\N	\N	\N	\N	157497	157497	324797
20584	30184	9	applied	\N	\N	\N	\N	157498	157498	324798
20588	30195	0	applied	\N	\N	\N	\N	157523	157523	324823
20588	30196	1	applied	\N	\N	\N	\N	157524	157524	324824
20588	30197	2	applied	\N	\N	\N	\N	157525	157525	324825
20588	30198	3	applied	\N	\N	\N	\N	157526	157526	324826
20593	30202	0	applied	\N	\N	\N	\N	157540	157540	324840
20593	30203	1	applied	\N	\N	\N	\N	157541	157541	324841
20593	30204	2	applied	\N	\N	\N	\N	157542	157542	324842
20593	30205	3	applied	\N	\N	\N	\N	157543	157543	324843
20593	30206	4	applied	\N	\N	\N	\N	157544	157544	324844
20593	30207	5	applied	\N	\N	\N	\N	157545	157545	324845
20598	30214	0	applied	\N	\N	\N	\N	157683	157683	324982
20598	30215	1	applied	\N	\N	\N	\N	157684	157684	324983
20599	30217	0	applied	\N	\N	\N	\N	157686	157686	324985
20599	30218	1	applied	\N	\N	\N	\N	157687	157687	324986
20599	30219	2	applied	\N	\N	\N	\N	157688	157688	324987
20599	30220	3	applied	\N	\N	\N	\N	157689	157689	324988
20604	30224	0	applied	\N	\N	\N	\N	157700	157700	324999
20604	30225	1	applied	\N	\N	\N	\N	157701	157701	325000
20609	30226	0	applied	\N	\N	\N	\N	157730	157730	325028
20609	30227	1	applied	\N	\N	\N	\N	157731	157731	325029
20609	30228	2	applied	\N	\N	\N	\N	157732	157732	325030
20609	30229	3	applied	\N	\N	\N	\N	157733	157733	325031
20609	30230	4	applied	\N	\N	\N	\N	157734	157734	325032
20609	30231	5	applied	\N	\N	\N	\N	157735	157735	325033
20610	30232	0	applied	\N	\N	\N	\N	157736	157736	325034
20610	30233	1	applied	\N	\N	\N	\N	157737	157737	325035
20610	30234	2	applied	\N	\N	\N	\N	157738	157738	325036
20610	30235	3	applied	\N	\N	\N	\N	157739	157739	325037
20610	30237	5	applied	\N	\N	\N	\N	157741	157741	325039
20610	30238	6	applied	\N	\N	\N	\N	157742	157742	325040
20610	30239	7	applied	\N	\N	\N	\N	157743	157743	325041
20610	30240	8	applied	\N	\N	\N	\N	157744	157744	325042
20610	30241	9	applied	\N	\N	\N	\N	157745	157745	325043
20615	30245	0	applied	\N	\N	\N	\N	157765	157765	325063
20615	30246	1	applied	\N	\N	\N	\N	157766	157766	325064
20615	30247	2	applied	\N	\N	\N	\N	157767	157767	325065
20616	30248	0	applied	\N	\N	\N	\N	157768	157768	325066
20616	30249	1	applied	\N	\N	\N	\N	157769	157769	325067
20616	30250	2	applied	\N	\N	\N	\N	157770	157770	325068
20616	30251	3	applied	\N	\N	\N	\N	157771	157771	157771
20616	30252	4	applied	\N	\N	\N	\N	157772	157772	325069
20617	30253	0	applied	\N	\N	\N	\N	157773	157773	325070
20617	30254	1	applied	\N	\N	\N	\N	157774	157774	325071
20617	30255	2	applied	\N	\N	\N	\N	157775	157775	157775
20617	30257	4	applied	\N	\N	\N	\N	157777	157777	325073
20623	30202	0	applied	\N	\N	\N	\N	157825	157825	325114
20623	30203	1	applied	\N	\N	\N	\N	157826	157826	325115
20623	30208	3	applied	\N	\N	\N	\N	157828	157828	325116
20623	30275	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	157827	157827	\N
20623	30209	4	applied	\N	\N	\N	\N	157829	157829	325117
20623	30211	5	applied	\N	\N	\N	\N	157830	157830	325118
20623	30204	6	applied	\N	\N	\N	\N	157831	157831	325119
20623	30212	7	applied	\N	\N	\N	\N	157832	157832	325120
20623	30214	8	applied	\N	\N	\N	\N	157833	157833	325121
20638	30353	1	applied	\N	\N	\N	\N	158000	158000	325281
20638	30354	2	applied	\N	\N	\N	\N	158001	158001	325282
20638	30355	3	applied	\N	\N	\N	\N	158002	158002	325283
20639	30356	0	applied	\N	\N	\N	\N	158003	158003	325284
20639	30357	1	applied	\N	\N	\N	\N	158004	158004	325285
20639	30358	2	applied	\N	\N	\N	\N	158005	158005	325286
20645	30372	1	applied	\N	\N	\N	\N	158025	158025	325306
20645	30373	2	applied	\N	\N	\N	\N	158026	158026	325307
20655	30382	0	applied	\N	\N	\N	\N	158288	158288	325561
20655	30383	1	applied	\N	\N	\N	\N	158289	158289	325562
20655	30384	2	applied	\N	\N	\N	\N	158290	158290	325563
20659	30385	0	applied	\N	\N	\N	\N	158303	158303	325576
20659	30386	1	applied	\N	\N	\N	\N	158304	158304	325577
20659	30387	2	applied	\N	\N	\N	\N	158305	158305	325578
20659	30388	3	applied	\N	\N	\N	\N	158306	158306	325579
20660	30389	0	applied	\N	\N	\N	\N	158307	158307	325580
20660	30390	1	applied	\N	\N	\N	\N	158308	158308	325581
20660	30391	2	applied	\N	\N	\N	\N	158309	158309	325582
20664	30392	0	applied	\N	\N	\N	\N	158316	158316	325589
20664	30393	1	applied	\N	\N	\N	\N	158317	158317	325590
20666	30394	0	applied	\N	\N	\N	\N	158331	158331	325604
20666	30395	1	applied	\N	\N	\N	\N	158332	158332	325605
20666	30397	3	applied	\N	\N	\N	\N	158334	158334	325607
20666	30398	4	applied	\N	\N	\N	\N	158335	158335	325608
20666	30399	5	applied	\N	\N	\N	\N	158336	158336	325609
20666	30400	6	applied	\N	\N	\N	\N	158337	158337	325610
20666	30401	7	applied	\N	\N	\N	\N	158338	158338	325611
20666	30402	8	applied	\N	\N	\N	\N	158339	158339	325612
20666	30403	9	applied	\N	\N	\N	\N	158340	158340	325613
20666	30404	10	applied	\N	\N	\N	\N	158341	158341	325614
20666	30405	11	applied	\N	\N	\N	\N	158342	158342	325615
20666	30406	12	applied	\N	\N	\N	\N	158343	158343	325616
20671	30410	0	applied	\N	\N	\N	\N	158366	158366	325639
20671	30411	2	applied	\N	\N	\N	\N	158367	158367	325640
20671	30412	3	applied	\N	\N	\N	\N	158368	158368	325641
20672	30413	0	applied	\N	\N	\N	\N	158369	158369	325642
20672	30414	1	applied	\N	\N	\N	\N	158370	158370	325643
20672	30415	2	applied	\N	\N	\N	\N	158371	158371	325644
20677	30417	1	applied	\N	\N	\N	\N	158403	158403	325676
20677	30418	2	applied	\N	\N	\N	\N	158404	158404	325677
20677	30419	3	applied	\N	\N	\N	\N	158405	158405	325678
20677	30420	4	applied	\N	\N	\N	\N	158406	158406	325679
20583	30179	1	applied	\N	\N	\N	\N	157483	157483	324783
20583	30180	2	applied	\N	\N	\N	\N	157484	157484	324784
20596	30126	98	applied	\N	\N	\N	\N	157653	157653	324952
20596	30132	99	applied	\N	\N	\N	\N	157654	157654	324953
20596	30133	100	applied	\N	\N	\N	\N	157655	157655	324954
20596	30136	101	applied	\N	\N	\N	\N	157656	157656	324955
20596	30139	102	applied	\N	\N	\N	\N	157657	157657	324956
20596	30153	103	applied	\N	\N	\N	\N	157658	157658	324957
20596	30154	104	applied	\N	\N	\N	\N	157659	157659	324958
20596	30158	105	applied	\N	\N	\N	\N	157660	157660	324959
20596	30163	106	applied	\N	\N	\N	\N	157661	157661	324960
20596	30083	107	applied	\N	\N	\N	\N	157662	157662	324961
20596	30091	109	applied	\N	\N	\N	\N	157664	157664	324963
20596	30095	110	applied	\N	\N	\N	\N	157665	157665	324964
20596	30099	111	applied	\N	\N	\N	\N	157666	157666	324965
20596	30104	112	applied	\N	\N	\N	\N	157667	157667	324966
20596	30109	113	applied	\N	\N	\N	\N	157668	157668	324967
20596	30116	114	applied	\N	\N	\N	\N	157669	157669	324968
20596	30119	115	applied	\N	\N	\N	\N	157670	157670	324969
20596	30123	116	applied	\N	\N	\N	\N	157671	157671	324970
20596	30125	117	applied	\N	\N	\N	\N	157672	157672	324971
20596	30130	118	applied	\N	\N	\N	\N	157673	157673	324972
20596	30131	119	applied	\N	\N	\N	\N	157674	157674	324973
20596	30135	120	applied	\N	\N	\N	\N	157675	157675	324974
20596	30138	121	applied	\N	\N	\N	\N	157676	157676	324975
20596	30152	122	applied	\N	\N	\N	\N	157677	157677	324976
20596	30157	123	applied	\N	\N	\N	\N	157678	157678	324977
20596	30164	124	applied	\N	\N	\N	\N	157679	157679	324978
20601	30221	0	applied	\N	\N	\N	\N	157693	157693	324992
20601	30222	1	applied	\N	\N	\N	\N	157694	157694	324993
20601	30223	2	applied	\N	\N	\N	\N	157695	157695	324994
20602	30224	0	applied	\N	\N	\N	\N	157696	157696	324995
20602	30225	1	applied	\N	\N	\N	\N	157697	157697	324996
20606	30224	0	applied	\N	\N	\N	\N	157703	157703	325002
20606	30225	1	applied	\N	\N	\N	\N	157704	157704	325003
20613	30242	0	applied	\N	\N	\N	\N	157759	157759	325057
20613	30243	1	applied	\N	\N	\N	\N	157760	157760	325058
20613	30244	2	applied	\N	\N	\N	\N	157761	157761	325059
20620	30202	0	applied	\N	\N	\N	\N	157790	157790	325085
20620	30178	1	applied	\N	\N	\N	\N	157791	157791	325086
20620	30203	3	applied	\N	\N	\N	\N	157793	157793	325087
20620	30187	4	applied	\N	\N	\N	\N	157794	157794	325088
20620	30188	5	applied	\N	\N	\N	\N	157795	157795	325089
20620	30189	6	applied	\N	\N	\N	\N	157796	157796	325090
20620	30190	7	applied	\N	\N	\N	\N	157797	157797	325091
20620	30208	8	applied	\N	\N	\N	\N	157798	157798	325092
20620	30209	9	applied	\N	\N	\N	\N	157799	157799	325093
20620	30191	10	applied	\N	\N	\N	\N	157800	157800	325094
20620	30192	11	applied	\N	\N	\N	\N	157801	157801	325095
20620	30193	12	applied	\N	\N	\N	\N	157802	157802	325096
20620	30210	13	applied	\N	\N	\N	\N	157803	157803	325097
20620	30211	14	applied	\N	\N	\N	\N	157804	157804	325098
20620	30110	15	applied	\N	\N	1000000000	\N	157805	157805	325099
20620	30265	16	applied	\N	\N	1000000000	\N	157806	157806	325100
20620	30266	17	applied	\N	\N	1000000000	\N	157807	157807	325101
20620	30267	18	applied	\N	\N	\N	\N	157808	157808	325102
20620	30251	19	applied	\N	\N	\N	\N	157809	157809	157809
20620	30255	20	applied	\N	\N	\N	\N	157810	157810	157810
20620	30261	21	applied	\N	\N	\N	\N	157811	157811	157811
20620	30170	22	applied	\N	\N	\N	\N	157812	157812	325103
20623	30217	9	applied	\N	\N	\N	\N	157834	157834	325122
20623	30221	10	applied	\N	\N	\N	\N	157835	157835	325123
20623	30224	11	applied	\N	\N	\N	\N	157836	157836	325124
20623	30226	12	applied	\N	\N	\N	\N	157837	157837	325125
20623	30227	13	applied	\N	\N	\N	\N	157838	157838	325126
20623	30232	14	applied	\N	\N	\N	\N	157839	157839	325127
20623	30233	15	applied	\N	\N	\N	\N	157840	157840	325128
20623	30234	16	applied	\N	\N	\N	\N	157841	157841	325129
20623	30245	18	applied	\N	\N	\N	\N	157843	157843	325131
20623	30248	19	applied	\N	\N	\N	\N	157844	157844	325132
20623	30253	20	applied	\N	\N	\N	\N	157845	157845	325133
20623	30254	21	applied	\N	\N	\N	\N	157846	157846	325134
20623	30258	22	applied	\N	\N	\N	\N	157847	157847	325135
20623	30265	23	applied	\N	\N	1000000000	\N	157848	157848	325136
20623	30266	24	applied	\N	\N	1000000000	\N	157849	157849	325137
20623	30267	25	applied	\N	\N	\N	\N	157850	157850	325138
20623	30205	26	applied	\N	\N	\N	\N	157851	157851	325139
20623	30215	28	applied	\N	\N	\N	\N	157852	157852	325140
20623	30251	29	applied	\N	\N	\N	\N	157853	157853	157853
20623	30255	30	applied	\N	\N	\N	\N	157854	157854	157854
20623	30261	31	applied	\N	\N	\N	\N	157855	157855	157855
20623	30271	32	applied	\N	\N	\N	\N	157856	157856	157856
20623	30279	33	applied	\N	\N	\N	\N	157857	157857	157857
20623	30273	35	applied	\N	\N	1000000000	\N	157859	157859	325142
20623	30274	36	applied	\N	\N	1000000000	\N	157860	157860	325143
20623	30206	37	applied	\N	\N	\N	\N	157861	157861	325144
20623	30219	38	applied	\N	\N	\N	\N	157862	157862	325145
20623	30229	39	applied	\N	\N	\N	\N	157863	157863	325146
20623	30235	40	applied	\N	\N	\N	\N	157864	157864	325147
20623	30249	41	applied	\N	\N	\N	\N	157865	157865	325148
20623	30264	42	applied	\N	\N	\N	\N	157866	157866	325149
20623	30278	43	applied	\N	\N	\N	\N	157867	157867	325150
20623	30220	44	applied	\N	\N	\N	\N	157868	157868	325151
20623	30223	45	applied	\N	\N	\N	\N	157869	157869	325152
20623	30228	46	applied	\N	\N	\N	\N	157870	157870	325153
20623	30236	47	applied	\N	\N	\N	\N	157871	157871	325154
20623	30237	48	applied	\N	\N	\N	\N	157872	157872	325155
20623	30241	49	applied	\N	\N	\N	\N	157873	157873	325156
20623	30244	50	applied	\N	\N	\N	\N	157874	157874	325157
20623	30247	51	applied	\N	\N	\N	\N	157875	157875	325158
20623	30252	52	applied	\N	\N	\N	\N	157876	157876	325159
20623	30256	53	applied	\N	\N	\N	\N	157877	157877	325160
20625	30275	0	applied	\N	\N	\N	\N	157904	157904	325187
20625	30276	1	applied	\N	\N	\N	\N	157905	157905	325188
20625	30277	2	applied	\N	\N	\N	\N	157906	157906	325189
20625	30278	3	applied	\N	\N	\N	\N	157907	157907	325190
20625	30279	4	applied	\N	\N	\N	\N	157908	157908	157908
20625	30280	5	applied	\N	\N	\N	\N	157909	157909	325191
20625	30281	6	applied	\N	\N	\N	\N	157910	157910	325192
20626	30282	0	applied	\N	\N	\N	\N	157911	157911	325193
20626	30283	1	applied	\N	\N	\N	\N	157912	157912	157912
20596	30120	96	applied	\N	\N	\N	\N	157651	157651	324950
20596	30122	97	applied	\N	\N	\N	\N	157652	157652	324951
20623	30281	58	applied	\N	\N	\N	\N	157882	157882	325165
20623	30207	59	applied	\N	\N	\N	\N	157883	157883	325166
20623	30213	60	applied	\N	\N	\N	\N	157884	157884	325167
20623	30216	61	applied	\N	\N	\N	\N	157885	157885	325168
20623	30218	62	applied	\N	\N	\N	\N	157886	157886	325169
20623	30222	63	applied	\N	\N	\N	\N	157887	157887	325170
20623	30225	64	applied	\N	\N	\N	\N	157888	157888	325171
20623	30231	66	applied	\N	\N	\N	\N	157890	157890	325173
20623	30238	67	applied	\N	\N	\N	\N	157891	157891	325174
20623	30239	68	applied	\N	\N	\N	\N	157892	157892	325175
20623	30240	69	applied	\N	\N	\N	\N	157893	157893	325176
20623	30243	70	applied	\N	\N	\N	\N	157894	157894	325177
20623	30246	71	applied	\N	\N	\N	\N	157895	157895	325178
20623	30250	72	applied	\N	\N	\N	\N	157896	157896	325179
20623	30260	73	applied	\N	\N	\N	\N	157897	157897	325180
20623	30262	74	applied	\N	\N	\N	\N	157898	157898	325181
20623	30263	75	applied	\N	\N	\N	\N	157899	157899	325182
20623	30268	76	applied	\N	\N	\N	\N	157900	157900	325183
20623	30270	77	applied	\N	\N	\N	\N	157901	157901	325184
20623	30276	78	applied	\N	\N	\N	\N	157902	157902	325185
20623	30277	79	applied	\N	\N	\N	\N	157903	157903	325186
20626	30284	2	applied	\N	\N	\N	\N	157913	157913	325194
20626	30285	3	applied	\N	\N	\N	\N	157914	157914	325195
20626	30287	5	applied	\N	\N	\N	\N	157916	157916	325197
20627	30288	0	applied	\N	\N	\N	\N	157917	157917	325198
20627	30289	1	applied	\N	\N	\N	\N	157918	157918	325199
20627	30290	2	applied	\N	\N	\N	\N	157919	157919	325200
20627	30291	3	applied	\N	\N	\N	\N	157920	157920	325201
20627	30292	4	applied	\N	\N	\N	\N	157921	157921	325202
20628	30293	0	applied	\N	\N	\N	\N	157922	157922	325203
20628	30294	1	applied	\N	\N	\N	\N	157923	157923	325204
20628	30295	2	applied	\N	\N	\N	\N	157924	157924	325205
20628	30296	3	applied	\N	\N	\N	\N	157925	157925	325206
20628	30297	4	applied	\N	\N	\N	\N	157926	157926	325207
20628	30298	5	applied	\N	\N	\N	\N	157927	157927	325208
20628	30299	6	applied	\N	\N	\N	\N	157928	157928	325209
20628	30300	7	applied	\N	\N	\N	\N	157929	157929	325210
20628	30301	8	applied	\N	\N	\N	\N	157930	157930	325211
20628	30302	9	applied	\N	\N	\N	\N	157931	157931	325212
20628	30304	11	applied	\N	\N	\N	\N	157933	157933	325214
20629	30305	0	applied	\N	\N	\N	\N	157934	157934	325215
20629	30306	1	applied	\N	\N	\N	\N	157935	157935	325216
20629	30307	2	applied	\N	\N	\N	\N	157936	157936	325217
20629	30308	3	applied	\N	\N	\N	\N	157937	157937	325218
20629	30309	4	applied	\N	\N	1000000000	\N	157938	157938	325219
20629	30310	5	applied	\N	\N	\N	\N	157939	157939	325220
20629	30311	6	applied	\N	\N	\N	\N	157940	157940	325221
20630	30312	0	applied	\N	\N	\N	\N	157941	157941	325222
20630	30313	1	applied	\N	\N	\N	\N	157942	157942	325223
20630	30314	2	applied	\N	\N	\N	\N	157943	157943	325224
20630	30315	3	applied	\N	\N	\N	\N	157944	157944	325225
20630	30316	4	applied	\N	\N	\N	\N	157945	157945	325226
20630	30317	5	applied	\N	\N	\N	\N	157946	157946	325227
20630	30318	6	applied	\N	\N	\N	\N	157947	157947	325228
20630	30319	7	applied	\N	\N	\N	\N	157948	157948	325229
20630	30321	10	applied	\N	\N	\N	\N	157950	157950	325231
20630	30322	11	applied	\N	\N	\N	\N	157951	157951	325232
20630	30323	12	applied	\N	\N	\N	\N	157952	157952	325233
20631	30324	0	applied	\N	\N	\N	\N	157953	157953	325234
20631	30325	1	applied	\N	\N	\N	\N	157954	157954	325235
20631	30326	2	applied	\N	\N	\N	\N	157955	157955	325236
20631	30327	3	applied	\N	\N	\N	\N	157956	157956	325237
20631	30328	4	applied	\N	\N	\N	\N	157957	157957	325238
20631	30329	5	applied	\N	\N	\N	\N	157958	157958	325239
20634	30347	0	applied	\N	\N	\N	\N	157987	157987	325268
20634	30348	1	applied	\N	\N	\N	\N	157988	157988	325269
20634	30349	2	applied	\N	\N	\N	\N	157989	157989	325270
20640	30359	0	applied	\N	\N	\N	\N	158006	158006	325287
20640	30360	1	applied	\N	\N	\N	\N	158007	158007	325288
20640	30361	2	applied	\N	\N	\N	\N	158008	158008	325289
20641	30362	0	applied	\N	\N	\N	\N	158009	158009	325290
20641	30364	2	applied	\N	\N	\N	\N	158011	158011	325292
20641	30365	3	applied	\N	\N	\N	\N	158012	158012	325293
20641	30366	4	applied	\N	\N	\N	\N	158013	158013	325294
20641	30367	5	applied	\N	\N	\N	\N	158014	158014	325295
20642	30368	0	applied	\N	\N	\N	\N	158015	158015	325296
20642	30369	1	applied	\N	\N	\N	\N	158016	158016	325297
20642	30370	2	applied	\N	\N	\N	\N	158017	158017	325298
20646	30324	0	applied	\N	\N	\N	\N	158027	158027	325308
20646	30312	1	applied	\N	\N	\N	\N	158028	158028	325309
20646	30313	2	applied	\N	\N	\N	\N	158029	158029	325310
20646	30314	3	applied	\N	\N	\N	\N	158030	158030	325311
20646	30336	4	applied	\N	\N	\N	\N	158031	158031	325312
20646	30337	5	applied	\N	\N	\N	\N	158032	158032	325313
20646	30338	6	applied	\N	\N	\N	\N	158033	158033	325314
20646	30315	7	applied	\N	\N	\N	\N	158034	158034	325315
20646	30202	8	applied	\N	\N	\N	\N	158035	158035	325316
20646	30325	10	applied	\N	\N	\N	\N	158037	158037	325318
20646	30326	12	applied	\N	\N	\N	\N	158039	158039	325319
20646	30275	11	failed	Amount_insufficient_to_create_account	\N	\N	\N	158038	158038	\N
20646	30340	13	applied	\N	\N	\N	\N	158040	158040	325320
20646	30341	14	applied	\N	\N	\N	\N	158041	158041	325321
20646	30342	15	applied	\N	\N	\N	\N	158042	158042	325322
20646	30343	16	applied	\N	\N	\N	\N	158043	158043	325323
20646	30195	17	applied	\N	\N	\N	\N	158044	158044	325324
20646	30199	18	applied	\N	\N	\N	\N	158045	158045	325325
20646	30208	19	applied	\N	\N	\N	\N	158046	158046	325326
20646	30209	20	applied	\N	\N	\N	\N	158047	158047	325327
20646	30329	21	applied	\N	\N	\N	\N	158048	158048	325328
20646	30330	22	applied	\N	\N	\N	\N	158049	158049	325329
20646	30331	23	applied	\N	\N	\N	\N	158050	158050	325330
20646	30211	24	applied	\N	\N	\N	\N	158051	158051	325331
20646	30204	25	applied	\N	\N	\N	\N	158052	158052	325332
20646	30214	27	applied	\N	\N	\N	\N	158054	158054	325334
20646	30217	28	applied	\N	\N	\N	\N	158055	158055	325335
20646	30221	29	applied	\N	\N	\N	\N	158056	158056	325336
20646	30224	30	applied	\N	\N	\N	\N	158057	158057	325337
20646	30226	31	applied	\N	\N	\N	\N	158058	158058	325338
20646	30227	32	applied	\N	\N	\N	\N	158059	158059	325339
20623	30269	56	applied	\N	\N	\N	\N	157880	157880	325163
20623	30280	57	applied	\N	\N	\N	\N	157881	157881	325164
20631	30333	9	applied	\N	\N	\N	\N	157962	157962	325243
20631	30334	10	applied	\N	\N	\N	\N	157963	157963	325244
20631	30335	11	applied	\N	\N	\N	\N	157964	157964	325245
20632	30336	0	applied	\N	\N	\N	\N	157965	157965	325246
20632	30337	1	applied	\N	\N	\N	\N	157966	157966	325247
20632	30338	2	applied	\N	\N	\N	\N	157967	157967	325248
20632	30339	3	applied	\N	\N	\N	\N	157968	157968	325249
20632	30340	4	applied	\N	\N	\N	\N	157969	157969	325250
20632	30341	5	applied	\N	\N	\N	\N	157970	157970	325251
20632	30343	7	applied	\N	\N	\N	\N	157972	157972	325253
20632	30344	8	applied	\N	\N	\N	\N	157973	157973	325254
20632	30345	9	applied	\N	\N	\N	\N	157974	157974	325255
20632	30346	10	applied	\N	\N	\N	\N	157975	157975	325256
20637	30352	0	applied	\N	\N	\N	\N	157995	157995	325276
20637	30353	1	applied	\N	\N	\N	\N	157996	157996	325277
20637	30354	2	applied	\N	\N	\N	\N	157997	157997	325278
20637	30355	3	applied	\N	\N	\N	\N	157998	157998	325279
20644	30371	0	applied	\N	\N	\N	\N	158021	158021	325302
20644	30372	1	applied	\N	\N	\N	\N	158022	158022	325303
20644	30373	2	applied	\N	\N	\N	\N	158023	158023	325304
20646	30232	33	applied	\N	\N	\N	\N	158060	158060	325340
20646	30233	34	applied	\N	\N	\N	\N	158061	158061	325341
20646	30234	35	applied	\N	\N	\N	\N	158062	158062	325342
20646	30242	36	applied	\N	\N	\N	\N	158063	158063	325343
20646	30245	37	applied	\N	\N	\N	\N	158064	158064	325344
20646	30253	40	applied	\N	\N	\N	\N	158066	158066	325346
20646	30254	41	applied	\N	\N	\N	\N	158067	158067	325347
20646	30258	42	applied	\N	\N	\N	\N	158068	158068	325348
20646	30282	43	applied	\N	\N	\N	\N	158069	158069	325349
20646	30288	44	applied	\N	\N	\N	\N	158070	158070	325350
20646	30293	45	applied	\N	\N	\N	\N	158071	158071	325351
20646	30294	46	applied	\N	\N	\N	\N	158072	158072	325352
20646	30295	47	applied	\N	\N	\N	\N	158073	158073	325353
20646	30305	48	applied	\N	\N	\N	\N	158074	158074	325354
20646	30306	49	applied	\N	\N	\N	\N	158075	158075	325355
20646	30316	50	applied	\N	\N	\N	\N	158076	158076	325356
20646	30317	51	applied	\N	\N	\N	\N	158077	158077	325357
20646	30327	52	applied	\N	\N	\N	\N	158078	158078	325358
20646	30328	53	applied	\N	\N	\N	\N	158079	158079	325359
20646	30339	54	applied	\N	\N	\N	\N	158080	158080	325360
20646	30347	55	applied	\N	\N	\N	\N	158081	158081	325361
20646	30352	57	applied	\N	\N	\N	\N	158083	158083	325363
20646	30356	58	applied	\N	\N	\N	\N	158084	158084	325364
20646	30359	59	applied	\N	\N	\N	\N	158085	158085	325365
20646	30362	60	applied	\N	\N	\N	\N	158086	158086	325366
20646	30363	61	applied	\N	\N	\N	\N	158087	158087	325367
20646	30368	62	applied	\N	\N	\N	\N	158088	158088	325368
20646	30371	63	applied	\N	\N	\N	\N	158089	158089	325369
20646	30265	64	applied	\N	\N	1000000000	\N	158090	158090	325370
20646	30266	65	applied	\N	\N	1000000000	\N	158091	158091	325371
20646	30267	66	applied	\N	\N	\N	\N	158092	158092	325372
20646	30251	67	applied	\N	\N	\N	\N	158093	158093	158093
20646	30255	68	applied	\N	\N	\N	\N	158094	158094	158094
20646	30197	69	applied	\N	\N	\N	\N	158095	158095	325373
20646	30261	70	applied	\N	\N	\N	\N	158096	158096	158096
20646	30271	71	applied	\N	\N	\N	\N	158097	158097	158097
20646	30291	72	applied	\N	\N	\N	\N	158098	158098	325374
20646	30279	74	applied	\N	\N	\N	\N	158100	158100	158100
20646	30283	75	applied	\N	\N	\N	\N	158101	158101	158101
20646	30300	76	applied	\N	\N	\N	\N	158102	158102	325376
20646	30301	77	applied	\N	\N	\N	\N	158103	158103	325377
20646	30272	78	applied	\N	\N	1000000000	\N	158104	158104	325378
20646	30273	79	applied	\N	\N	1000000000	\N	158105	158105	325379
20649	30374	0	applied	\N	\N	\N	\N	158153	158153	325427
20649	30375	1	applied	\N	\N	\N	\N	158154	158154	325428
20649	30376	2	applied	\N	\N	\N	\N	158155	158155	325429
20649	30377	3	applied	\N	\N	\N	\N	158156	158156	325430
20653	30379	0	applied	\N	\N	\N	\N	158282	158282	325555
20653	30380	1	applied	\N	\N	\N	\N	158283	158283	325556
20653	30381	2	applied	\N	\N	\N	\N	158284	158284	325557
20654	30382	0	applied	\N	\N	\N	\N	158285	158285	325558
20654	30383	1	applied	\N	\N	\N	\N	158286	158286	325559
20654	30384	2	applied	\N	\N	\N	\N	158287	158287	325560
20658	30386	1	applied	\N	\N	\N	\N	158300	158300	325573
20658	30387	2	applied	\N	\N	\N	\N	158301	158301	325574
20658	30388	3	applied	\N	\N	\N	\N	158302	158302	325575
20663	30392	0	applied	\N	\N	\N	\N	158314	158314	325587
20663	30393	1	applied	\N	\N	\N	\N	158315	158315	325588
20665	30394	0	applied	\N	\N	\N	\N	158318	158318	325591
20665	30395	1	applied	\N	\N	\N	\N	158319	158319	325592
20665	30396	2	applied	\N	\N	\N	\N	158320	158320	325593
20665	30397	3	applied	\N	\N	\N	\N	158321	158321	325594
20665	30398	4	applied	\N	\N	\N	\N	158322	158322	325595
20665	30399	5	applied	\N	\N	\N	\N	158323	158323	325596
20665	30400	6	applied	\N	\N	\N	\N	158324	158324	325597
20665	30401	7	applied	\N	\N	\N	\N	158325	158325	325598
20665	30402	8	applied	\N	\N	\N	\N	158326	158326	325599
20665	30403	9	applied	\N	\N	\N	\N	158327	158327	325600
20665	30404	10	applied	\N	\N	\N	\N	158328	158328	325601
20665	30406	12	applied	\N	\N	\N	\N	158330	158330	325603
20670	30410	0	applied	\N	\N	\N	\N	158363	158363	325636
20670	30411	2	applied	\N	\N	\N	\N	158364	158364	325637
20670	30412	3	applied	\N	\N	\N	\N	158365	158365	325638
20676	30416	0	applied	\N	\N	\N	\N	158393	158393	325666
20676	30417	1	applied	\N	\N	\N	\N	158394	158394	325667
20676	30418	2	applied	\N	\N	\N	\N	158395	158395	325668
20676	30419	3	applied	\N	\N	\N	\N	158396	158396	325669
20676	30420	4	applied	\N	\N	\N	\N	158397	158397	325670
20676	30421	5	applied	\N	\N	\N	\N	158398	158398	325671
20676	30422	6	applied	\N	\N	\N	\N	158399	158399	325672
20676	30423	7	applied	\N	\N	\N	\N	158400	158400	325673
20676	30424	8	applied	\N	\N	\N	\N	158401	158401	325674
20681	30428	0	applied	\N	\N	\N	\N	158449	158449	325722
20681	30429	1	applied	\N	\N	\N	\N	158450	158450	325723
20681	30430	2	applied	\N	\N	\N	\N	158451	158451	325724
20686	30435	1	applied	\N	\N	\N	\N	158587	158587	325859
20686	30436	2	applied	\N	\N	\N	\N	158588	158588	325860
20692	30444	0	applied	\N	\N	\N	\N	158604	158604	325876
20692	30445	1	applied	\N	\N	\N	\N	158605	158605	325877
20631	30331	7	applied	\N	\N	\N	\N	157960	157960	325241
20631	30332	8	applied	\N	\N	\N	\N	157961	157961	325242
20646	30205	83	applied	\N	\N	\N	\N	158109	158109	325383
20646	30215	84	applied	\N	\N	\N	\N	158110	158110	325384
20646	30206	85	applied	\N	\N	\N	\N	158111	158111	325385
20646	30201	86	applied	\N	\N	\N	\N	158112	158112	325386
20646	30219	87	applied	\N	\N	\N	\N	158113	158113	325387
20646	30235	89	applied	\N	\N	\N	\N	158115	158115	325389
20646	30249	90	applied	\N	\N	\N	\N	158116	158116	325390
20646	30264	91	applied	\N	\N	\N	\N	158117	158117	325391
20646	30278	92	applied	\N	\N	\N	\N	158118	158118	325392
20646	30289	93	applied	\N	\N	\N	\N	158119	158119	325393
20646	30309	94	applied	\N	\N	1000000000	\N	158120	158120	325394
20646	30323	95	applied	\N	\N	\N	\N	158121	158121	325395
20646	30304	96	applied	\N	\N	\N	\N	158122	158122	325396
20646	30322	97	applied	\N	\N	\N	\N	158123	158123	325397
20646	30345	98	applied	\N	\N	\N	\N	158124	158124	325398
20646	30354	99	applied	\N	\N	\N	\N	158125	158125	325399
20646	30367	100	applied	\N	\N	\N	\N	158126	158126	325400
20646	30220	101	applied	\N	\N	\N	\N	158127	158127	325401
20646	30223	102	applied	\N	\N	\N	\N	158128	158128	325402
20646	30228	103	applied	\N	\N	\N	\N	158129	158129	325403
20646	30236	104	applied	\N	\N	\N	\N	158130	158130	325404
20646	30241	106	applied	\N	\N	\N	\N	158132	158132	325406
20646	30244	107	applied	\N	\N	\N	\N	158133	158133	325407
20646	30247	108	applied	\N	\N	\N	\N	158134	158134	325408
20646	30252	109	applied	\N	\N	\N	\N	158135	158135	325409
20646	30256	110	applied	\N	\N	\N	\N	158136	158136	325410
20646	30257	111	applied	\N	\N	\N	\N	158137	158137	325411
20646	30259	112	applied	\N	\N	\N	\N	158138	158138	325412
20646	30269	113	applied	\N	\N	\N	\N	158139	158139	325413
20646	30280	114	applied	\N	\N	\N	\N	158140	158140	325414
20646	30281	115	applied	\N	\N	\N	\N	158141	158141	325415
20646	30285	116	applied	\N	\N	\N	\N	158142	158142	325416
20646	30286	117	applied	\N	\N	\N	\N	158143	158143	325417
20646	30290	118	applied	\N	\N	\N	\N	158144	158144	325418
20646	30302	119	applied	\N	\N	\N	\N	158145	158145	325419
20646	30303	120	applied	\N	\N	\N	\N	158146	158146	325420
20646	30310	121	applied	\N	\N	\N	\N	158147	158147	325421
20651	30324	0	applied	\N	\N	\N	\N	158157	158157	325431
20651	30312	1	applied	\N	\N	\N	\N	158158	158158	325432
20651	30313	2	applied	\N	\N	\N	\N	158159	158159	325433
20651	30314	3	applied	\N	\N	\N	\N	158160	158160	325434
20651	30336	4	applied	\N	\N	\N	\N	158161	158161	325435
20651	30337	5	applied	\N	\N	\N	\N	158162	158162	325436
20651	30338	6	applied	\N	\N	\N	\N	158163	158163	325437
20651	30315	7	applied	\N	\N	\N	\N	158164	158164	325438
20651	30076	8	applied	\N	\N	\N	\N	158165	158165	325439
20651	30080	9	applied	\N	\N	\N	\N	158166	158166	325440
20651	30087	10	applied	\N	\N	\N	\N	158167	158167	325441
20651	30088	11	applied	\N	\N	\N	\N	158168	158168	325442
20651	30202	12	applied	\N	\N	\N	\N	158169	158169	325443
20651	30178	13	applied	\N	\N	\N	\N	158170	158170	325444
20651	29982	15	applied	\N	\N	\N	\N	158172	158172	325445
20651	30159	16	applied	\N	\N	\N	\N	158173	158173	325446
20651	30203	17	applied	\N	\N	\N	\N	158174	158174	325447
20651	30325	18	applied	\N	\N	\N	\N	158175	158175	325448
20651	30326	19	applied	\N	\N	\N	\N	158176	158176	325449
20651	30187	20	applied	\N	\N	\N	\N	158177	158177	325450
20651	30188	21	applied	\N	\N	\N	\N	158178	158178	325451
20651	30189	22	applied	\N	\N	\N	\N	158179	158179	325452
20651	30190	23	applied	\N	\N	\N	\N	158180	158180	325453
20651	30340	24	applied	\N	\N	\N	\N	158181	158181	325454
20651	30341	25	applied	\N	\N	\N	\N	158182	158182	325455
20651	30342	26	applied	\N	\N	\N	\N	158183	158183	325456
20651	30343	27	applied	\N	\N	\N	\N	158184	158184	325457
20651	29985	28	applied	\N	\N	\N	\N	158185	158185	325458
20692	30446	2	applied	\N	\N	\N	\N	158606	158606	325878
20693	30447	0	applied	\N	\N	\N	\N	158607	158607	325879
20693	30448	1	applied	\N	\N	\N	\N	158608	158608	325880
20693	30449	2	applied	\N	\N	\N	\N	158609	158609	325881
20693	30450	3	applied	\N	\N	\N	\N	158610	158610	325882
20693	30451	4	applied	\N	\N	\N	\N	158611	158611	325883
20693	30452	5	applied	\N	\N	\N	\N	158612	158612	325884
20693	30453	6	applied	\N	\N	\N	\N	158613	158613	325885
20693	30454	7	applied	\N	\N	\N	\N	158614	158614	325886
20697	30455	0	applied	\N	\N	\N	\N	158657	158657	325928
20697	30456	1	applied	\N	\N	\N	\N	158658	158658	325929
20697	30457	2	applied	\N	\N	\N	\N	158659	158659	325930
20697	30459	4	applied	\N	\N	1000000000	\N	158661	158661	325932
20697	30460	5	applied	\N	\N	\N	\N	158662	158662	325933
20698	30461	0	applied	\N	\N	\N	\N	158663	158663	325934
20698	30462	1	applied	\N	\N	\N	\N	158664	158664	325935
20699	30463	0	applied	\N	\N	\N	\N	158665	158665	325936
20699	30464	1	applied	\N	\N	\N	\N	158666	158666	325937
20699	30465	2	applied	\N	\N	\N	\N	158667	158667	325938
20699	30466	3	applied	\N	\N	\N	\N	158668	158668	325939
20699	30467	4	applied	\N	\N	\N	\N	158669	158669	325940
20699	30468	5	applied	\N	\N	\N	\N	158670	158670	325941
20699	30469	6	applied	\N	\N	\N	\N	158671	158671	325942
20699	30470	7	applied	\N	\N	\N	\N	158672	158672	325943
20703	30471	0	applied	\N	\N	\N	\N	158697	158697	325968
20703	30472	1	applied	\N	\N	\N	\N	158698	158698	325969
20703	30473	2	applied	\N	\N	\N	\N	158699	158699	325970
20714	30488	0	applied	\N	\N	\N	\N	158730	158730	326001
20714	30490	2	applied	\N	\N	\N	\N	158732	158732	326003
20718	30491	0	applied	\N	\N	\N	\N	158816	158816	326086
20718	30492	1	applied	\N	\N	\N	\N	158817	158817	326087
20718	30493	2	applied	\N	\N	\N	\N	158818	158818	326088
20724	30496	0	applied	\N	\N	\N	\N	158946	158946	326216
20724	30497	1	applied	\N	\N	\N	\N	158947	158947	326217
20724	30498	2	applied	\N	\N	\N	\N	158948	158948	326218
20724	30499	3	applied	\N	\N	\N	\N	158949	158949	326219
20724	30500	4	applied	\N	\N	\N	\N	158950	158950	326220
20724	30501	5	applied	\N	\N	\N	\N	158951	158951	326221
20724	30502	6	applied	\N	\N	\N	\N	158952	158952	326222
20724	30503	7	applied	\N	\N	\N	\N	158953	158953	326223
20724	30504	8	applied	\N	\N	\N	\N	158954	158954	326224
20724	30505	9	applied	\N	\N	\N	\N	158955	158955	326225
20729	30496	0	applied	\N	\N	\N	\N	158996	158996	326266
20729	30497	1	applied	\N	\N	\N	\N	158997	158997	326267
20646	30198	81	applied	\N	\N	\N	\N	158107	158107	325381
20646	30200	82	applied	\N	\N	\N	\N	158108	158108	325382
20651	29998	33	applied	\N	\N	\N	\N	158190	158190	325463
20651	30142	34	applied	\N	\N	\N	\N	158191	158191	325464
20651	30143	35	applied	\N	\N	\N	\N	158192	158192	325465
20651	30144	36	applied	\N	\N	\N	\N	158193	158193	325466
20651	30145	37	applied	\N	\N	\N	\N	158194	158194	325467
20651	30146	38	applied	\N	\N	\N	\N	158195	158195	325468
20651	30001	39	applied	\N	\N	\N	\N	158196	158196	325469
20651	30208	40	applied	\N	\N	\N	\N	158197	158197	325470
20651	30209	41	applied	\N	\N	\N	\N	158198	158198	325471
20651	30057	42	applied	\N	\N	\N	\N	158199	158199	325472
20651	30058	43	applied	\N	\N	\N	\N	158200	158200	325473
20651	30059	44	applied	\N	\N	\N	\N	158201	158201	325474
20651	30060	45	applied	\N	\N	\N	\N	158202	158202	325475
20651	30191	46	applied	\N	\N	\N	\N	158203	158203	325476
20651	30192	47	applied	\N	\N	\N	\N	158204	158204	325477
20651	30193	48	applied	\N	\N	\N	\N	158205	158205	325478
20651	30061	50	applied	\N	\N	\N	\N	158207	158207	325480
20651	30068	51	applied	\N	\N	\N	\N	158208	158208	325481
20651	30155	52	applied	\N	\N	\N	\N	158209	158209	325482
20651	30329	53	applied	\N	\N	\N	\N	158210	158210	325483
20651	30330	54	applied	\N	\N	\N	\N	158211	158211	325484
20651	30331	55	applied	\N	\N	\N	\N	158212	158212	325485
20651	30211	56	applied	\N	\N	\N	\N	158213	158213	325486
20651	30003	57	applied	\N	\N	\N	\N	158214	158214	325487
20651	30007	58	applied	\N	\N	\N	\N	158215	158215	325488
20651	30010	59	applied	\N	\N	\N	\N	158216	158216	325489
20651	30013	60	applied	\N	\N	\N	\N	158217	158217	325490
20651	30017	61	applied	\N	\N	\N	\N	158218	158218	325491
20651	30020	62	applied	\N	\N	\N	\N	158219	158219	325492
20651	30023	63	applied	\N	\N	\N	\N	158220	158220	325493
20651	30024	64	applied	\N	\N	\N	\N	158221	158221	325494
20651	30025	65	applied	\N	\N	\N	\N	158222	158222	325495
20651	30027	67	applied	\N	\N	\N	\N	158224	158224	325497
20651	30045	68	applied	\N	\N	\N	\N	158225	158225	325498
20651	30046	69	applied	\N	\N	\N	\N	158226	158226	325499
20651	30051	70	applied	\N	\N	\N	\N	158227	158227	325500
20651	30055	71	applied	\N	\N	\N	\N	158228	158228	325501
20651	30069	72	applied	\N	\N	\N	\N	158229	158229	325502
20651	30077	73	applied	\N	\N	\N	\N	158230	158230	325503
20651	30084	75	applied	\N	\N	\N	\N	158231	158231	325504
20651	30089	76	applied	\N	\N	\N	\N	158232	158232	325505
20651	30092	77	applied	\N	\N	\N	\N	158233	158233	325506
20651	30093	78	applied	\N	\N	\N	\N	158234	158234	325507
20651	30098	79	applied	\N	\N	\N	\N	158235	158235	325508
20651	30101	80	applied	\N	\N	\N	\N	158236	158236	325509
20651	30106	81	applied	\N	\N	\N	\N	158237	158237	325510
20651	30108	82	applied	\N	\N	\N	\N	158238	158238	325511
20651	30114	83	applied	\N	\N	\N	\N	158239	158239	325512
20651	30121	85	applied	\N	\N	\N	\N	158241	158241	325514
20651	30124	86	applied	\N	\N	\N	\N	158242	158242	325515
20651	30127	87	applied	\N	\N	\N	\N	158243	158243	325516
20651	30128	88	applied	\N	\N	\N	\N	158244	158244	325517
20651	30147	89	applied	\N	\N	\N	\N	158245	158245	325518
20651	30148	90	applied	\N	\N	\N	\N	158246	158246	325519
20651	30149	91	applied	\N	\N	\N	\N	158247	158247	325520
20651	30150	92	applied	\N	\N	\N	\N	158248	158248	325521
20651	30070	93	applied	\N	\N	\N	\N	158249	158249	325522
20651	30378	94	applied	\N	\N	\N	\N	158250	158250	325523
20651	30134	95	applied	\N	\N	\N	\N	158251	158251	325524
20651	30137	96	applied	\N	\N	\N	\N	158252	158252	325525
20651	30141	97	applied	\N	\N	\N	\N	158253	158253	325526
20651	30151	98	applied	\N	\N	\N	\N	158254	158254	325527
20651	30156	99	applied	\N	\N	\N	\N	158255	158255	325528
20651	30160	100	applied	\N	\N	\N	\N	158256	158256	325529
20651	30167	102	applied	\N	\N	\N	\N	158258	158258	325531
20651	30172	103	applied	\N	\N	\N	\N	158259	158259	325532
20651	30175	104	applied	\N	\N	\N	\N	158260	158260	325533
20651	30179	105	applied	\N	\N	\N	\N	158261	158261	325534
20651	30180	106	applied	\N	\N	\N	\N	158262	158262	325535
20651	30186	107	applied	\N	\N	\N	\N	158263	158263	325536
20651	30195	108	applied	\N	\N	\N	\N	158264	158264	325537
20651	30199	109	applied	\N	\N	\N	\N	158265	158265	325538
20651	30204	110	applied	\N	\N	\N	\N	158266	158266	325539
20651	30212	111	applied	\N	\N	\N	\N	158267	158267	325540
20651	30214	112	applied	\N	\N	\N	\N	158268	158268	325541
20651	30217	113	applied	\N	\N	\N	\N	158269	158269	325542
20651	30221	114	applied	\N	\N	\N	\N	158270	158270	325543
20651	30224	115	applied	\N	\N	\N	\N	158271	158271	325544
20651	30226	116	applied	\N	\N	\N	\N	158272	158272	325545
20651	30227	117	applied	\N	\N	\N	\N	158273	158273	325546
20651	30233	119	applied	\N	\N	\N	\N	158275	158275	325548
20651	30234	120	applied	\N	\N	\N	\N	158276	158276	325549
20651	30242	121	applied	\N	\N	\N	\N	158277	158277	325550
20651	30245	122	applied	\N	\N	\N	\N	158278	158278	325551
20651	30248	123	applied	\N	\N	\N	\N	158279	158279	325552
20651	30253	124	applied	\N	\N	\N	\N	158280	158280	325553
20651	30254	125	applied	\N	\N	\N	\N	158281	158281	325554
20656	30385	0	applied	\N	\N	\N	\N	158291	158291	325564
20656	30386	1	applied	\N	\N	\N	\N	158292	158292	325565
20656	30387	2	applied	\N	\N	\N	\N	158293	158293	325566
20656	30388	3	applied	\N	\N	\N	\N	158294	158294	325567
20661	30389	0	applied	\N	\N	\N	\N	158310	158310	325583
20661	30390	1	applied	\N	\N	\N	\N	158311	158311	325584
20661	30391	2	applied	\N	\N	\N	\N	158312	158312	325585
20667	30394	0	applied	\N	\N	\N	\N	158344	158344	325617
20667	30395	1	applied	\N	\N	\N	\N	158345	158345	325618
20667	30397	3	applied	\N	\N	\N	\N	158347	158347	325620
20667	30398	4	applied	\N	\N	\N	\N	158348	158348	325621
20667	30399	5	applied	\N	\N	\N	\N	158349	158349	325622
20667	30400	6	applied	\N	\N	\N	\N	158350	158350	325623
20667	30401	7	applied	\N	\N	\N	\N	158351	158351	325624
20667	30402	8	applied	\N	\N	\N	\N	158352	158352	325625
20667	30403	9	applied	\N	\N	\N	\N	158353	158353	325626
20667	30404	10	applied	\N	\N	\N	\N	158354	158354	325627
20667	30405	11	applied	\N	\N	\N	\N	158355	158355	325628
20667	30406	12	applied	\N	\N	\N	\N	158356	158356	325629
20668	30407	0	applied	\N	\N	\N	\N	158357	158357	325630
20668	30408	1	applied	\N	\N	\N	\N	158358	158358	325631
20668	30409	2	applied	\N	\N	\N	\N	158359	158359	325632
20673	30413	0	applied	\N	\N	\N	\N	158372	158372	325645
20651	29987	30	applied	\N	\N	\N	\N	158187	158187	325460
20651	30056	31	applied	\N	\N	\N	\N	158188	158188	325461
20674	30418	2	applied	\N	\N	\N	\N	158377	158377	325650
20674	30419	3	applied	\N	\N	\N	\N	158378	158378	325651
20674	30420	4	applied	\N	\N	\N	\N	158379	158379	325652
20674	30421	5	applied	\N	\N	\N	\N	158380	158380	325653
20674	30422	6	applied	\N	\N	\N	\N	158381	158381	325654
20674	30423	7	applied	\N	\N	\N	\N	158382	158382	325655
20674	30424	8	applied	\N	\N	\N	\N	158383	158383	325656
20677	30421	5	applied	\N	\N	\N	\N	158407	158407	325680
20677	30422	6	applied	\N	\N	\N	\N	158408	158408	325681
20677	30423	7	applied	\N	\N	\N	\N	158409	158409	325682
20677	30424	8	applied	\N	\N	\N	\N	158410	158410	325683
20678	30425	0	applied	\N	\N	\N	\N	158411	158411	325684
20678	30426	1	applied	\N	\N	\N	\N	158412	158412	325685
20678	30427	2	applied	\N	\N	\N	\N	158413	158413	325686
20679	30425	0	applied	\N	\N	\N	\N	158414	158414	325687
20679	30426	1	applied	\N	\N	\N	\N	158415	158415	325688
20682	30428	0	applied	\N	\N	\N	\N	158452	158452	325725
20682	30429	1	applied	\N	\N	\N	\N	158453	158453	325726
20682	30430	2	applied	\N	\N	\N	\N	158454	158454	325727
20683	30324	0	applied	\N	\N	\N	\N	158455	158455	325728
20683	30312	1	applied	\N	\N	\N	\N	158456	158456	325729
20683	30313	2	applied	\N	\N	\N	\N	158457	158457	325730
20683	30314	3	applied	\N	\N	\N	\N	158458	158458	325731
20683	30336	4	applied	\N	\N	\N	\N	158459	158459	325732
20683	30337	5	applied	\N	\N	\N	\N	158460	158460	325733
20683	30338	6	applied	\N	\N	\N	\N	158461	158461	325734
20683	30315	7	applied	\N	\N	\N	\N	158462	158462	325735
20683	30325	8	applied	\N	\N	\N	\N	158463	158463	325736
20683	30326	9	applied	\N	\N	\N	\N	158464	158464	325737
20683	30340	10	applied	\N	\N	\N	\N	158465	158465	325738
20683	30341	11	applied	\N	\N	\N	\N	158466	158466	325739
20683	30342	12	applied	\N	\N	\N	\N	158467	158467	325740
20683	30282	14	applied	\N	\N	\N	\N	158469	158469	325742
20683	30288	15	applied	\N	\N	\N	\N	158470	158470	325743
20683	30293	16	applied	\N	\N	\N	\N	158471	158471	325744
20683	30294	17	applied	\N	\N	\N	\N	158472	158472	325745
20683	30329	18	applied	\N	\N	\N	\N	158473	158473	325746
20683	30330	19	applied	\N	\N	\N	\N	158474	158474	325747
20683	30331	20	applied	\N	\N	\N	\N	158475	158475	325748
20683	30295	21	applied	\N	\N	\N	\N	158476	158476	325749
20683	30305	22	applied	\N	\N	\N	\N	158477	158477	325750
20683	30306	23	applied	\N	\N	\N	\N	158478	158478	325751
20683	30316	24	applied	\N	\N	\N	\N	158479	158479	325752
20683	30317	25	applied	\N	\N	\N	\N	158480	158480	325753
20683	30327	26	applied	\N	\N	\N	\N	158481	158481	325754
20683	30328	27	applied	\N	\N	\N	\N	158482	158482	325755
20683	30339	28	applied	\N	\N	\N	\N	158483	158483	325756
20683	30347	29	applied	\N	\N	\N	\N	158484	158484	325757
20683	30352	31	applied	\N	\N	\N	\N	158486	158486	325759
20683	30356	32	applied	\N	\N	\N	\N	158487	158487	325760
20687	30434	0	applied	\N	\N	\N	\N	158589	158589	325861
20687	30435	1	applied	\N	\N	\N	\N	158590	158590	325862
20687	30436	2	applied	\N	\N	\N	\N	158591	158591	325863
20688	30437	0	applied	\N	\N	\N	\N	158592	158592	325864
20688	30438	1	applied	\N	\N	\N	\N	158593	158593	325865
20688	30439	2	applied	\N	\N	\N	\N	158594	158594	325866
20688	30440	3	applied	\N	\N	\N	\N	158595	158595	325867
20694	30447	0	applied	\N	\N	\N	\N	158615	158615	325887
20694	30448	1	applied	\N	\N	\N	\N	158616	158616	325888
20694	30449	2	applied	\N	\N	\N	\N	158617	158617	325889
20694	30450	3	applied	\N	\N	\N	\N	158618	158618	325890
20694	30451	4	applied	\N	\N	\N	\N	158619	158619	325891
20694	30452	5	applied	\N	\N	\N	\N	158620	158620	325892
20694	30453	6	applied	\N	\N	\N	\N	158621	158621	325893
20700	30463	0	applied	\N	\N	\N	\N	158673	158673	325944
20700	30464	1	applied	\N	\N	\N	\N	158674	158674	325945
20700	30465	2	applied	\N	\N	\N	\N	158675	158675	325946
20700	30466	3	applied	\N	\N	\N	\N	158676	158676	325947
20700	30467	4	applied	\N	\N	\N	\N	158677	158677	325948
20700	30468	5	applied	\N	\N	\N	\N	158678	158678	325949
20700	30469	6	applied	\N	\N	\N	\N	158679	158679	325950
20700	30470	7	applied	\N	\N	\N	\N	158680	158680	325951
20704	30471	0	applied	\N	\N	\N	\N	158700	158700	325971
20704	30472	1	applied	\N	\N	\N	\N	158701	158701	325972
20704	30473	2	applied	\N	\N	\N	\N	158702	158702	325973
20705	30474	0	applied	\N	\N	\N	\N	158703	158703	325974
20705	30475	1	applied	\N	\N	\N	\N	158704	158704	325975
20705	30476	2	applied	\N	\N	\N	\N	158705	158705	325976
20705	30477	3	applied	\N	\N	\N	\N	158706	158706	325977
20705	30478	4	applied	\N	\N	\N	\N	158707	158707	325978
20705	30480	6	applied	\N	\N	\N	\N	158709	158709	325980
20705	30481	7	applied	\N	\N	\N	\N	158710	158710	325981
20706	30482	0	applied	\N	\N	\N	\N	158711	158711	325982
20706	30483	1	applied	\N	\N	\N	\N	158712	158712	325983
20710	30484	0	applied	\N	\N	\N	\N	158715	158715	325986
20710	30485	1	applied	\N	\N	\N	\N	158716	158716	325987
20710	30486	2	applied	\N	\N	\N	\N	158717	158717	325988
20710	30487	3	applied	\N	\N	\N	\N	158718	158718	325989
20715	30488	0	applied	\N	\N	\N	\N	158733	158733	326004
20715	30489	1	applied	\N	\N	\N	\N	158734	158734	326005
20715	30490	2	applied	\N	\N	\N	\N	158735	158735	326006
20720	30494	0	applied	\N	\N	\N	\N	158819	158819	326089
20720	30495	1	applied	\N	\N	\N	\N	158820	158820	326090
20725	30496	0	applied	\N	\N	\N	\N	158956	158956	326226
20725	30497	1	applied	\N	\N	\N	\N	158957	158957	326227
20725	30498	2	applied	\N	\N	\N	\N	158958	158958	326228
20725	30500	4	applied	\N	\N	\N	\N	158960	158960	326230
20725	30501	5	applied	\N	\N	\N	\N	158961	158961	326231
20725	30502	6	applied	\N	\N	\N	\N	158962	158962	326232
20725	30503	7	applied	\N	\N	\N	\N	158963	158963	326233
20725	30504	8	applied	\N	\N	\N	\N	158964	158964	326234
20725	30505	9	applied	\N	\N	\N	\N	158965	158965	326235
20731	30506	0	applied	\N	\N	\N	\N	159016	159016	326286
20731	30507	1	applied	\N	\N	\N	\N	159017	159017	326287
20731	30508	2	applied	\N	\N	\N	\N	159018	159018	326288
20731	30509	3	applied	\N	\N	\N	\N	159019	159019	326289
20731	30510	4	applied	\N	\N	\N	\N	159020	159020	326290
20731	30511	5	applied	\N	\N	\N	\N	159021	159021	326291
20731	30512	6	applied	\N	\N	\N	\N	159022	159022	326292
20731	30513	7	applied	\N	\N	\N	\N	159023	159023	326293
20673	30415	2	applied	\N	\N	\N	\N	158374	158374	325647
20674	30416	0	applied	\N	\N	\N	\N	158375	158375	325648
20680	30400	12	applied	\N	\N	\N	\N	158429	158429	325702
20680	30401	13	applied	\N	\N	\N	\N	158430	158430	325703
20680	30409	14	applied	\N	\N	\N	\N	158431	158431	325704
20680	30421	15	applied	\N	\N	\N	\N	158432	158432	325705
20680	30402	16	applied	\N	\N	\N	\N	158433	158433	325706
20680	30408	17	applied	\N	\N	\N	\N	158434	158434	325707
20680	30412	18	applied	\N	\N	\N	\N	158435	158435	325708
20680	30414	19	applied	\N	\N	\N	\N	158436	158436	325709
20680	30419	20	applied	\N	\N	\N	\N	158437	158437	325710
20680	30420	22	applied	\N	\N	\N	\N	158438	158438	325711
20680	30427	23	applied	\N	\N	\N	\N	158439	158439	325712
20680	30403	24	applied	\N	\N	\N	\N	158440	158440	325713
20680	30405	26	applied	\N	\N	\N	\N	158442	158442	325715
20680	30406	27	applied	\N	\N	\N	\N	158443	158443	325716
20680	30411	28	applied	\N	\N	\N	\N	158444	158444	325717
20680	30415	29	applied	\N	\N	\N	\N	158445	158445	325718
20680	30422	30	applied	\N	\N	\N	\N	158446	158446	325719
20680	30423	31	applied	\N	\N	\N	\N	158447	158447	325720
20680	30424	32	applied	\N	\N	\N	\N	158448	158448	325721
20685	30431	0	applied	\N	\N	\N	\N	158583	158583	325855
20685	30432	1	applied	\N	\N	\N	\N	158584	158584	325856
20685	30433	2	applied	\N	\N	\N	\N	158585	158585	325857
20691	30444	0	applied	\N	\N	\N	\N	158601	158601	325873
20691	30445	1	applied	\N	\N	\N	\N	158602	158602	325874
20691	30446	2	applied	\N	\N	\N	\N	158603	158603	325875
20696	30455	0	applied	\N	\N	\N	\N	158651	158651	325922
20696	30456	1	applied	\N	\N	\N	\N	158652	158652	325923
20696	30457	2	applied	\N	\N	\N	\N	158653	158653	325924
20696	30459	4	applied	\N	\N	1000000000	\N	158655	158655	325926
20696	30460	5	applied	\N	\N	\N	\N	158656	158656	325927
20702	30463	0	applied	\N	\N	\N	\N	158689	158689	325960
20702	30464	1	applied	\N	\N	\N	\N	158690	158690	325961
20702	30465	2	applied	\N	\N	\N	\N	158691	158691	325962
20702	30466	3	applied	\N	\N	\N	\N	158692	158692	325963
20702	30467	4	applied	\N	\N	\N	\N	158693	158693	325964
20702	30468	5	applied	\N	\N	\N	\N	158694	158694	325965
20702	30469	6	applied	\N	\N	\N	\N	158695	158695	325966
20702	30470	7	applied	\N	\N	\N	\N	158696	158696	325967
20712	30484	0	applied	\N	\N	\N	\N	158723	158723	325994
20712	30485	1	applied	\N	\N	\N	\N	158724	158724	325995
20712	30486	2	applied	\N	\N	\N	\N	158725	158725	325996
20712	30487	3	applied	\N	\N	\N	\N	158726	158726	325997
20713	30488	0	applied	\N	\N	\N	\N	158727	158727	325998
20713	30489	1	applied	\N	\N	\N	\N	158728	158728	325999
20717	30491	0	applied	\N	\N	\N	\N	158813	158813	326083
20717	30492	1	applied	\N	\N	\N	\N	158814	158814	326084
20717	30493	2	applied	\N	\N	\N	\N	158815	158815	326085
20727	30496	0	applied	\N	\N	\N	\N	158976	158976	326246
20727	30497	1	applied	\N	\N	\N	\N	158977	158977	326247
20727	30498	2	applied	\N	\N	\N	\N	158978	158978	326248
20727	30499	3	applied	\N	\N	\N	\N	158979	158979	326249
20727	30500	4	applied	\N	\N	\N	\N	158980	158980	326250
20727	30501	5	applied	\N	\N	\N	\N	158981	158981	326251
20727	30502	6	applied	\N	\N	\N	\N	158982	158982	326252
20727	30503	7	applied	\N	\N	\N	\N	158983	158983	326253
20727	30504	8	applied	\N	\N	\N	\N	158984	158984	326254
20727	30505	9	applied	\N	\N	\N	\N	158985	158985	326255
20728	30496	0	applied	\N	\N	\N	\N	158986	158986	326256
20728	30497	1	applied	\N	\N	\N	\N	158987	158987	326257
20728	30498	2	applied	\N	\N	\N	\N	158988	158988	326258
20728	30500	4	applied	\N	\N	\N	\N	158990	158990	326260
20728	30501	5	applied	\N	\N	\N	\N	158991	158991	326261
20728	30502	6	applied	\N	\N	\N	\N	158992	158992	326262
20728	30503	7	applied	\N	\N	\N	\N	158993	158993	326263
20731	30514	8	applied	\N	\N	\N	\N	159024	159024	326294
20731	30515	9	applied	\N	\N	\N	\N	159025	159025	326295
20732	30516	0	applied	\N	\N	\N	\N	159026	159026	326296
20732	30517	1	applied	\N	\N	\N	\N	159027	159027	326297
20732	30518	2	applied	\N	\N	\N	\N	159028	159028	326298
20732	30519	3	applied	\N	\N	\N	\N	159029	159029	326299
20732	30520	4	applied	\N	\N	\N	\N	159030	159030	326300
20732	30521	5	applied	\N	\N	\N	\N	159031	159031	326301
20732	30522	6	applied	\N	\N	\N	\N	159032	159032	326302
20737	30526	0	applied	\N	\N	\N	\N	159046	159046	326316
20737	30527	1	applied	\N	\N	\N	\N	159047	159047	326317
20737	30528	2	applied	\N	\N	\N	\N	159048	159048	326318
20743	30551	1	applied	\N	\N	\N	\N	159088	159088	326358
20743	30552	2	applied	\N	\N	\N	\N	159089	159089	326359
20743	30553	3	applied	\N	\N	\N	\N	159090	159090	326360
20743	30554	4	applied	\N	\N	\N	\N	159091	159091	326361
20743	30555	5	applied	\N	\N	\N	\N	159092	159092	326362
20746	30561	0	applied	\N	\N	\N	\N	159104	159104	326374
20746	30562	1	applied	\N	\N	\N	\N	159105	159105	326375
20746	30563	2	applied	\N	\N	\N	\N	159106	159106	326376
20746	30564	3	applied	\N	\N	\N	\N	159107	159107	326377
20746	30565	4	applied	\N	\N	\N	\N	159108	159108	326378
20746	30566	5	applied	\N	\N	\N	\N	159109	159109	326379
20746	30567	6	applied	\N	\N	\N	\N	159110	159110	326380
20752	30582	0	applied	\N	\N	\N	\N	159144	159144	326414
20752	30583	1	applied	\N	\N	\N	\N	159145	159145	326415
20752	30584	2	applied	\N	\N	\N	\N	159146	159146	326416
20752	30586	4	applied	\N	\N	\N	\N	159148	159148	326418
20762	30447	0	applied	\N	\N	\N	\N	159245	159245	326515
20762	30455	1	applied	\N	\N	\N	\N	159246	159246	326516
20762	30456	2	applied	\N	\N	\N	\N	159247	159247	326517
20762	30457	3	applied	\N	\N	\N	\N	159248	159248	326518
20762	30588	4	applied	\N	\N	\N	\N	159249	159249	326519
20762	30535	5	applied	\N	\N	\N	\N	159250	159250	326520
20762	30536	6	applied	\N	\N	\N	\N	159251	159251	326521
20762	30574	7	applied	\N	\N	\N	\N	159252	159252	326522
20762	30589	8	applied	\N	\N	\N	\N	159253	159253	326523
20762	30590	9	applied	\N	\N	\N	\N	159254	159254	326524
20762	30595	10	applied	\N	\N	\N	\N	159255	159255	326525
20762	30596	11	applied	\N	\N	\N	\N	159256	159256	326526
20762	30575	12	applied	\N	\N	\N	\N	159257	159257	326527
20762	30576	13	applied	\N	\N	\N	\N	159258	159258	326528
20762	30577	14	applied	\N	\N	\N	\N	159259	159259	326529
20762	30537	15	applied	\N	\N	\N	\N	159260	159260	326530
20762	30538	16	applied	\N	\N	\N	\N	159261	159261	326531
20680	30418	9	applied	\N	\N	\N	\N	158426	158426	325699
20680	30399	11	applied	\N	\N	\N	\N	158428	158428	325701
20683	30368	36	applied	\N	\N	\N	\N	158491	158491	325764
20683	30371	37	applied	\N	\N	\N	\N	158492	158492	325765
20683	30374	38	applied	\N	\N	\N	\N	158493	158493	325766
20683	30379	39	applied	\N	\N	\N	\N	158494	158494	325767
20683	30382	40	applied	\N	\N	\N	\N	158495	158495	325768
20683	30385	41	applied	\N	\N	\N	\N	158496	158496	325769
20683	30389	42	applied	\N	\N	\N	\N	158497	158497	325770
20683	30392	43	applied	\N	\N	\N	\N	158498	158498	325771
20683	30394	44	applied	\N	\N	\N	\N	158499	158499	325772
20683	30395	45	applied	\N	\N	\N	\N	158500	158500	325773
20683	30396	46	applied	\N	\N	\N	\N	158501	158501	325774
20683	30397	47	applied	\N	\N	\N	\N	158502	158502	325775
20683	30407	48	applied	\N	\N	\N	\N	158503	158503	325776
20683	30413	50	applied	\N	\N	\N	\N	158505	158505	325778
20683	30416	51	applied	\N	\N	\N	\N	158506	158506	325779
20683	30417	52	applied	\N	\N	\N	\N	158507	158507	325780
20683	30418	53	applied	\N	\N	\N	\N	158508	158508	325781
20683	30289	54	applied	\N	\N	\N	\N	158509	158509	325782
20683	30283	55	applied	\N	\N	\N	\N	158510	158510	158510
20683	30291	56	applied	\N	\N	\N	\N	158511	158511	325783
20683	30296	57	applied	\N	\N	\N	\N	158512	158512	325784
20683	30284	58	applied	\N	\N	\N	\N	158513	158513	325785
20683	30300	59	applied	\N	\N	\N	\N	158514	158514	325786
20683	30301	60	applied	\N	\N	\N	\N	158515	158515	325787
20683	30285	61	applied	\N	\N	\N	\N	158516	158516	325788
20683	30286	62	applied	\N	\N	\N	\N	158517	158517	325789
20683	30290	63	applied	\N	\N	\N	\N	158518	158518	325790
20683	30287	64	applied	\N	\N	\N	\N	158519	158519	325791
20683	30292	65	applied	\N	\N	\N	\N	158520	158520	325792
20683	30298	67	applied	\N	\N	\N	\N	158522	158522	325794
20683	30299	68	applied	\N	\N	\N	\N	158523	158523	325795
20683	30307	69	applied	\N	\N	\N	\N	158524	158524	325796
20683	30308	70	applied	\N	\N	\N	\N	158525	158525	325797
20683	30318	71	applied	\N	\N	\N	\N	158526	158526	325798
20683	30319	72	applied	\N	\N	\N	\N	158527	158527	325799
20683	30333	74	applied	\N	\N	\N	\N	158528	158528	325800
20683	30334	75	applied	\N	\N	\N	\N	158529	158529	325801
20683	30346	76	applied	\N	\N	\N	\N	158530	158530	325802
20683	30348	77	applied	\N	\N	\N	\N	158531	158531	325803
20683	30351	78	applied	\N	\N	\N	\N	158532	158532	325804
20683	30353	79	applied	\N	\N	\N	\N	158533	158533	325805
20683	30358	80	applied	\N	\N	\N	\N	158534	158534	325806
20683	30361	81	applied	\N	\N	\N	\N	158535	158535	325807
20683	30365	82	applied	\N	\N	\N	\N	158536	158536	325808
20683	30366	83	applied	\N	\N	\N	\N	158537	158537	325809
20683	30373	85	applied	\N	\N	\N	\N	158539	158539	325811
20683	30376	86	applied	\N	\N	\N	\N	158540	158540	325812
20683	30381	87	applied	\N	\N	\N	\N	158541	158541	325813
20683	30384	88	applied	\N	\N	\N	\N	158542	158542	325814
20683	30387	89	applied	\N	\N	\N	\N	158543	158543	325815
20683	30391	90	applied	\N	\N	\N	\N	158544	158544	325816
20683	30393	91	applied	\N	\N	\N	\N	158545	158545	325817
20683	30398	92	applied	\N	\N	\N	\N	158546	158546	325818
20683	30399	93	applied	\N	\N	\N	\N	158547	158547	325819
20683	30400	94	applied	\N	\N	\N	\N	158548	158548	325820
20683	30302	95	applied	\N	\N	\N	\N	158549	158549	325821
20683	30303	96	applied	\N	\N	\N	\N	158550	158550	325822
20683	30402	97	applied	\N	\N	\N	\N	158551	158551	325823
20683	30408	98	applied	\N	\N	\N	\N	158552	158552	325824
20683	30412	99	applied	\N	\N	\N	\N	158553	158553	325825
20683	30414	100	applied	\N	\N	\N	\N	158554	158554	325826
20683	30420	102	applied	\N	\N	\N	\N	158556	158556	325828
20683	30427	103	applied	\N	\N	\N	\N	158557	158557	325829
20683	30309	104	applied	\N	\N	1000000000	\N	158558	158558	325830
20683	30323	105	applied	\N	\N	\N	\N	158559	158559	325831
20728	30504	8	applied	\N	\N	\N	\N	158994	158994	326264
20728	30505	9	applied	\N	\N	\N	\N	158995	158995	326265
20734	30523	0	applied	\N	\N	\N	\N	159036	159036	326306
20734	30524	1	applied	\N	\N	\N	\N	159037	159037	326307
20734	30525	2	applied	\N	\N	\N	\N	159038	159038	326308
20740	30533	0	applied	\N	\N	\N	\N	159063	159063	326333
20740	30534	1	applied	\N	\N	\N	\N	159064	159064	326334
20740	30535	2	applied	\N	\N	\N	\N	159065	159065	326335
20740	30536	3	applied	\N	\N	\N	\N	159066	159066	326336
20740	30537	4	applied	\N	\N	\N	\N	159067	159067	326337
20740	30538	5	applied	\N	\N	\N	\N	159068	159068	326338
20740	30539	6	applied	\N	\N	\N	\N	159069	159069	326339
20740	30541	8	applied	\N	\N	\N	\N	159071	159071	326341
20740	30542	9	applied	\N	\N	\N	\N	159072	159072	326342
20741	30543	0	applied	\N	\N	\N	\N	159073	159073	326343
20741	30544	1	applied	\N	\N	\N	\N	159074	159074	326344
20741	30545	2	applied	\N	\N	\N	\N	159075	159075	326345
20741	30546	3	applied	\N	\N	\N	\N	159076	159076	326346
20741	30547	4	applied	\N	\N	\N	\N	159077	159077	326347
20741	30548	5	applied	\N	\N	\N	\N	159078	159078	326348
20741	30549	6	applied	\N	\N	\N	\N	159079	159079	326349
20749	30568	0	applied	\N	\N	\N	\N	159124	159124	326394
20749	30569	1	applied	\N	\N	\N	\N	159125	159125	326395
20749	30570	2	applied	\N	\N	\N	\N	159126	159126	326396
20749	30571	3	applied	\N	\N	\N	\N	159127	159127	326397
20749	30572	4	applied	\N	\N	\N	\N	159128	159128	326398
20749	30573	5	applied	\N	\N	\N	\N	159129	159129	326399
20754	30582	0	applied	\N	\N	\N	\N	159154	159154	326424
20754	30584	2	applied	\N	\N	\N	\N	159156	159156	326426
20754	30585	3	applied	\N	\N	1000000000	\N	159157	159157	326427
20754	30586	4	applied	\N	\N	\N	\N	159158	159158	326428
20755	30587	0	applied	\N	\N	\N	\N	159159	159159	326429
20755	30588	1	applied	\N	\N	\N	\N	159160	159160	326430
20755	30589	2	applied	\N	\N	\N	\N	159161	159161	326431
20755	30590	3	applied	\N	\N	\N	\N	159162	159162	326432
20755	30591	4	applied	\N	\N	\N	\N	159163	159163	326433
20755	30592	5	applied	\N	\N	\N	\N	159164	159164	326434
20760	30593	0	applied	\N	\N	\N	\N	159171	159171	326441
20760	30594	1	applied	\N	\N	\N	\N	159172	159172	326442
20760	30516	2	applied	\N	\N	\N	\N	159173	159173	326443
20760	30517	3	applied	\N	\N	\N	\N	159174	159174	326444
20760	30523	4	applied	\N	\N	\N	\N	159175	159175	326445
20760	30588	5	applied	\N	\N	\N	\N	159176	159176	326446
20760	30535	6	applied	\N	\N	\N	\N	159177	159177	326447
20683	30362	34	applied	\N	\N	\N	\N	158489	158489	325762
20683	30363	35	applied	\N	\N	\N	\N	158490	158490	325763
20683	30321	109	applied	\N	\N	\N	\N	158563	158563	325835
20683	30335	111	applied	\N	\N	\N	\N	158565	158565	325837
20683	30344	112	applied	\N	\N	\N	\N	158566	158566	325838
20683	30349	113	applied	\N	\N	\N	\N	158567	158567	325839
20683	30355	114	applied	\N	\N	\N	\N	158568	158568	325840
20683	30357	115	applied	\N	\N	\N	\N	158569	158569	325841
20683	30360	116	applied	\N	\N	\N	\N	158570	158570	325842
20683	30364	117	applied	\N	\N	\N	\N	158571	158571	325843
20683	30370	118	applied	\N	\N	\N	\N	158572	158572	325844
20683	30372	119	applied	\N	\N	\N	\N	158573	158573	325845
20683	30377	120	applied	\N	\N	\N	\N	158574	158574	325846
20683	30380	121	applied	\N	\N	\N	\N	158575	158575	325847
20683	30383	122	applied	\N	\N	\N	\N	158576	158576	325848
20683	30386	123	applied	\N	\N	\N	\N	158577	158577	325849
20683	30390	124	applied	\N	\N	\N	\N	158578	158578	325850
20683	30403	125	applied	\N	\N	\N	\N	158579	158579	325851
20684	30431	0	applied	\N	\N	\N	\N	158580	158580	325852
20684	30433	2	applied	\N	\N	\N	\N	158582	158582	325854
20689	30441	0	applied	\N	\N	\N	\N	158596	158596	325868
20689	30442	1	applied	\N	\N	\N	\N	158597	158597	325869
20689	30443	2	applied	\N	\N	\N	\N	158598	158598	325870
20690	30444	0	applied	\N	\N	\N	\N	158599	158599	325871
20690	30445	1	applied	\N	\N	\N	\N	158600	158600	325872
20695	30447	0	applied	\N	\N	\N	\N	158623	158623	325895
20695	30455	1	applied	\N	\N	\N	\N	158624	158624	325896
20695	30456	2	applied	\N	\N	\N	\N	158625	158625	325897
20695	30457	3	applied	\N	\N	\N	\N	158626	158626	325898
20695	30324	4	applied	\N	\N	\N	\N	158627	158627	325899
20695	30312	5	applied	\N	\N	\N	\N	158628	158628	325900
20695	30313	6	applied	\N	\N	\N	\N	158629	158629	325901
20695	30314	7	applied	\N	\N	\N	\N	158630	158630	325902
20695	30336	8	applied	\N	\N	\N	\N	158631	158631	325903
20695	30337	9	applied	\N	\N	\N	\N	158632	158632	325904
20695	30315	11	applied	\N	\N	\N	\N	158634	158634	325906
20695	30076	12	applied	\N	\N	\N	\N	158635	158635	325907
20695	30080	13	applied	\N	\N	\N	\N	158636	158636	325908
20695	30087	14	applied	\N	\N	\N	\N	158637	158637	325909
20695	30088	15	applied	\N	\N	\N	\N	158638	158638	325910
20695	30202	16	applied	\N	\N	\N	\N	158639	158639	325911
20695	30178	17	applied	\N	\N	\N	\N	158640	158640	325912
20695	30159	19	applied	\N	\N	\N	\N	158642	158642	325913
20695	30113	18	failed	Amount_insufficient_to_create_account	\N	\N	\N	158641	158641	\N
20695	30203	20	applied	\N	\N	\N	\N	158643	158643	325914
20695	30325	21	applied	\N	\N	\N	\N	158644	158644	325915
20695	30326	22	applied	\N	\N	\N	\N	158645	158645	325916
20695	30187	23	applied	\N	\N	\N	\N	158646	158646	325917
20695	30188	24	applied	\N	\N	\N	\N	158647	158647	325918
20695	30189	25	applied	\N	\N	\N	\N	158648	158648	325919
20695	30190	26	applied	\N	\N	\N	\N	158649	158649	325920
20701	30463	0	applied	\N	\N	\N	\N	158681	158681	325952
20701	30464	1	applied	\N	\N	\N	\N	158682	158682	325953
20701	30465	2	applied	\N	\N	\N	\N	158683	158683	325954
20701	30466	3	applied	\N	\N	\N	\N	158684	158684	325955
20701	30467	4	applied	\N	\N	\N	\N	158685	158685	325956
20701	30468	5	applied	\N	\N	\N	\N	158686	158686	325957
20701	30469	6	applied	\N	\N	\N	\N	158687	158687	325958
20701	30470	7	applied	\N	\N	\N	\N	158688	158688	325959
20707	30482	0	applied	\N	\N	\N	\N	158713	158713	325984
20707	30483	1	applied	\N	\N	\N	\N	158714	158714	325985
20711	30484	0	applied	\N	\N	\N	\N	158719	158719	325990
20711	30485	1	applied	\N	\N	\N	\N	158720	158720	325991
20711	30486	2	applied	\N	\N	\N	\N	158721	158721	325992
20711	30487	3	applied	\N	\N	\N	\N	158722	158722	325993
20716	30447	0	applied	\N	\N	\N	\N	158736	158736	326007
20716	30455	1	applied	\N	\N	\N	\N	158737	158737	326008
20716	30457	3	applied	\N	\N	\N	\N	158739	158739	326010
20716	30324	4	applied	\N	\N	\N	\N	158740	158740	326011
20716	30312	5	applied	\N	\N	\N	\N	158741	158741	326012
20716	30313	6	applied	\N	\N	\N	\N	158742	158742	326013
20716	30314	7	applied	\N	\N	\N	\N	158743	158743	326014
20716	30336	8	applied	\N	\N	\N	\N	158744	158744	326015
20716	30337	9	applied	\N	\N	\N	\N	158745	158745	326016
20716	30338	10	applied	\N	\N	\N	\N	158746	158746	326017
20716	30315	11	applied	\N	\N	\N	\N	158747	158747	326018
20716	30202	12	applied	\N	\N	\N	\N	158748	158748	326019
20716	30178	13	applied	\N	\N	\N	\N	158749	158749	326020
20716	30159	15	applied	\N	\N	\N	\N	158751	158751	326021
20716	30203	16	applied	\N	\N	\N	\N	158752	158752	326022
20716	30325	17	applied	\N	\N	\N	\N	158753	158753	326023
20716	30326	18	applied	\N	\N	\N	\N	158754	158754	326024
20716	30187	19	applied	\N	\N	\N	\N	158755	158755	326025
20716	30188	20	applied	\N	\N	\N	\N	158756	158756	326026
20716	30189	21	applied	\N	\N	\N	\N	158757	158757	326027
20716	30190	22	applied	\N	\N	\N	\N	158758	158758	326028
20716	30340	23	applied	\N	\N	\N	\N	158759	158759	326029
20716	30341	24	applied	\N	\N	\N	\N	158760	158760	326030
20716	30342	25	applied	\N	\N	\N	\N	158761	158761	326031
20716	30343	26	applied	\N	\N	\N	\N	158762	158762	326032
20716	30142	27	applied	\N	\N	\N	\N	158763	158763	326033
20716	30143	28	applied	\N	\N	\N	\N	158764	158764	326034
20716	30144	29	applied	\N	\N	\N	\N	158765	158765	326035
20716	30145	30	applied	\N	\N	\N	\N	158766	158766	326036
20716	30146	31	applied	\N	\N	\N	\N	158767	158767	326037
20716	30208	32	applied	\N	\N	\N	\N	158768	158768	326038
20716	30209	33	applied	\N	\N	\N	\N	158769	158769	326039
20716	30191	34	applied	\N	\N	\N	\N	158770	158770	326040
20716	30192	35	applied	\N	\N	\N	\N	158771	158771	326041
20716	30193	36	applied	\N	\N	\N	\N	158772	158772	326042
20716	30210	37	applied	\N	\N	\N	\N	158773	158773	326043
20716	30061	38	applied	\N	\N	\N	\N	158774	158774	326044
20716	30068	39	applied	\N	\N	\N	\N	158775	158775	326045
20716	30155	40	applied	\N	\N	\N	\N	158776	158776	326046
20716	30329	41	applied	\N	\N	\N	\N	158777	158777	326047
20716	30330	42	applied	\N	\N	\N	\N	158778	158778	326048
20716	30331	43	applied	\N	\N	\N	\N	158779	158779	326049
20716	29809	45	applied	\N	\N	\N	\N	158781	158781	326051
20716	29814	46	applied	\N	\N	\N	\N	158782	158782	326052
20716	29820	47	applied	\N	\N	\N	\N	158783	158783	326053
20716	29825	48	applied	\N	\N	\N	\N	158784	158784	326054
20683	30311	107	applied	\N	\N	\N	\N	158561	158561	325833
20683	30320	108	applied	\N	\N	\N	\N	158562	158562	325834
20716	30148	53	applied	\N	\N	\N	\N	158789	158789	326059
20716	30149	54	applied	\N	\N	\N	\N	158790	158790	326060
20716	30150	55	applied	\N	\N	\N	\N	158791	158791	326061
20716	29841	56	applied	\N	\N	\N	\N	158792	158792	326062
20716	29846	57	applied	\N	\N	\N	\N	158793	158793	326063
20716	29849	58	applied	\N	\N	\N	\N	158794	158794	326064
20716	29852	59	applied	\N	\N	\N	\N	158795	158795	326065
20716	29856	60	applied	\N	\N	\N	\N	158796	158796	326066
20716	29857	61	applied	\N	\N	\N	\N	158797	158797	326067
20716	29863	62	applied	\N	\N	\N	\N	158798	158798	326068
20716	29869	63	applied	\N	\N	\N	\N	158799	158799	326069
20716	29879	64	applied	\N	\N	\N	\N	158800	158800	326070
20716	29882	65	applied	\N	\N	\N	\N	158801	158801	326071
20716	29885	68	applied	\N	\N	\N	\N	158802	158802	326072
20716	29891	70	applied	\N	\N	\N	\N	158804	158804	326074
20716	29894	71	applied	\N	\N	\N	\N	158805	158805	326075
20716	29897	72	applied	\N	\N	\N	\N	158806	158806	326076
20716	29903	73	applied	\N	\N	\N	\N	158807	158807	326077
20716	29906	74	applied	\N	\N	\N	\N	158808	158808	326078
20716	29909	75	applied	\N	\N	\N	\N	158809	158809	326079
20716	29912	76	applied	\N	\N	\N	\N	158810	158810	326080
20716	29915	77	applied	\N	\N	\N	\N	158811	158811	326081
20716	29919	78	applied	\N	\N	\N	\N	158812	158812	326082
20721	30447	0	applied	\N	\N	\N	\N	158821	158821	326091
20721	30455	1	applied	\N	\N	\N	\N	158822	158822	326092
20721	30456	2	applied	\N	\N	\N	\N	158823	158823	326093
20721	30457	3	applied	\N	\N	\N	\N	158824	158824	326094
20721	30347	4	applied	\N	\N	\N	\N	158825	158825	326095
20721	30350	5	applied	\N	\N	\N	\N	158826	158826	326096
20721	30352	6	applied	\N	\N	\N	\N	158827	158827	326097
20721	30359	8	applied	\N	\N	\N	\N	158829	158829	326099
20721	30362	9	applied	\N	\N	\N	\N	158830	158830	326100
20721	30363	10	applied	\N	\N	\N	\N	158831	158831	326101
20721	30368	11	applied	\N	\N	\N	\N	158832	158832	326102
20721	30371	12	applied	\N	\N	\N	\N	158833	158833	326103
20721	30374	13	applied	\N	\N	\N	\N	158834	158834	326104
20721	30379	14	applied	\N	\N	\N	\N	158835	158835	326105
20721	30382	15	applied	\N	\N	\N	\N	158836	158836	326106
20721	30385	16	applied	\N	\N	\N	\N	158837	158837	326107
20721	30389	17	applied	\N	\N	\N	\N	158838	158838	326108
20721	30392	18	applied	\N	\N	\N	\N	158839	158839	326109
20721	30394	19	applied	\N	\N	\N	\N	158840	158840	326110
20721	30395	20	applied	\N	\N	\N	\N	158841	158841	326111
20721	30396	21	applied	\N	\N	\N	\N	158842	158842	326112
20721	30397	22	applied	\N	\N	\N	\N	158843	158843	326113
20721	30407	23	applied	\N	\N	\N	\N	158844	158844	326114
20721	30413	25	applied	\N	\N	\N	\N	158846	158846	326116
20721	30416	26	applied	\N	\N	\N	\N	158847	158847	326117
20721	30417	27	applied	\N	\N	\N	\N	158848	158848	326118
20721	30418	28	applied	\N	\N	\N	\N	158849	158849	326119
20721	30425	29	applied	\N	\N	\N	\N	158850	158850	326120
20721	30428	30	applied	\N	\N	\N	\N	158851	158851	326121
20721	30431	31	applied	\N	\N	\N	\N	158852	158852	326122
20721	30434	32	applied	\N	\N	\N	\N	158853	158853	326123
20721	30437	33	applied	\N	\N	\N	\N	158854	158854	326124
20721	30441	34	applied	\N	\N	\N	\N	158855	158855	326125
20721	30444	35	applied	\N	\N	\N	\N	158856	158856	326126
20721	30448	36	applied	\N	\N	\N	\N	158857	158857	326127
20721	30449	37	applied	\N	\N	\N	\N	158858	158858	326128
20721	30458	38	applied	\N	\N	\N	\N	158859	158859	326129
20721	30463	39	applied	\N	\N	\N	\N	158860	158860	326130
20721	30464	40	applied	\N	\N	\N	\N	158861	158861	326131
20721	30471	42	applied	\N	\N	\N	\N	158863	158863	326133
20721	30474	43	applied	\N	\N	\N	\N	158864	158864	326134
20721	30475	44	applied	\N	\N	\N	\N	158865	158865	326135
20721	30482	45	applied	\N	\N	\N	\N	158866	158866	326136
20721	30484	46	applied	\N	\N	\N	\N	158867	158867	326137
20721	30488	47	applied	\N	\N	\N	\N	158868	158868	326138
20721	30491	48	applied	\N	\N	\N	\N	158869	158869	326139
20721	30348	49	applied	\N	\N	\N	\N	158870	158870	326140
20721	30459	50	applied	\N	\N	1000000000	\N	158871	158871	326141
20721	30476	51	applied	\N	\N	\N	\N	158872	158872	326142
20721	30351	52	applied	\N	\N	\N	\N	158873	158873	326143
20721	30353	53	applied	\N	\N	\N	\N	158874	158874	326144
20721	30354	54	applied	\N	\N	\N	\N	158875	158875	326145
20721	30367	55	applied	\N	\N	\N	\N	158876	158876	326146
20721	30375	56	applied	\N	\N	\N	\N	158877	158877	326147
20721	30349	57	applied	\N	\N	\N	\N	158878	158878	326148
20721	30355	59	applied	\N	\N	\N	\N	158880	158880	326150
20721	30357	60	applied	\N	\N	\N	\N	158881	158881	326151
20721	30360	61	applied	\N	\N	\N	\N	158882	158882	326152
20721	30364	62	applied	\N	\N	\N	\N	158883	158883	326153
20721	30370	63	applied	\N	\N	\N	\N	158884	158884	326154
20721	30372	64	applied	\N	\N	\N	\N	158885	158885	326155
20721	30377	65	applied	\N	\N	\N	\N	158886	158886	326156
20721	30380	66	applied	\N	\N	\N	\N	158887	158887	326157
20721	30383	67	applied	\N	\N	\N	\N	158888	158888	326158
20721	30386	68	applied	\N	\N	\N	\N	158889	158889	326159
20721	30390	69	applied	\N	\N	\N	\N	158890	158890	326160
20721	30361	70	applied	\N	\N	\N	\N	158891	158891	326161
20721	30365	71	applied	\N	\N	\N	\N	158892	158892	326162
20721	30366	72	applied	\N	\N	\N	\N	158893	158893	326163
20721	30369	73	applied	\N	\N	\N	\N	158894	158894	326164
20721	30373	74	applied	\N	\N	\N	\N	158895	158895	326165
20721	30381	76	applied	\N	\N	\N	\N	158897	158897	326167
20721	30384	77	applied	\N	\N	\N	\N	158898	158898	326168
20721	30387	78	applied	\N	\N	\N	\N	158899	158899	326169
20721	30391	79	applied	\N	\N	\N	\N	158900	158900	326170
20721	30393	80	applied	\N	\N	\N	\N	158901	158901	326171
20721	30398	81	applied	\N	\N	\N	\N	158902	158902	326172
20721	30399	82	applied	\N	\N	\N	\N	158903	158903	326173
20721	30400	83	applied	\N	\N	\N	\N	158904	158904	326174
20721	30388	84	applied	\N	\N	\N	\N	158905	158905	326175
20721	30401	85	applied	\N	\N	\N	\N	158906	158906	326176
20721	30409	86	applied	\N	\N	\N	\N	158907	158907	326177
20721	30421	87	applied	\N	\N	\N	\N	158908	158908	326178
20721	30429	88	applied	\N	\N	\N	\N	158909	158909	326179
20721	30439	89	applied	\N	\N	\N	\N	158910	158910	326180
20721	30402	90	applied	\N	\N	\N	\N	158911	158911	326181
20721	30408	91	applied	\N	\N	\N	\N	158912	158912	326182
20716	30147	52	applied	\N	\N	\N	\N	158788	158788	326058
20721	30427	97	applied	\N	\N	\N	\N	158917	158917	326187
20721	30430	98	applied	\N	\N	\N	\N	158918	158918	326188
20721	30433	99	applied	\N	\N	\N	\N	158919	158919	326189
20721	30435	100	applied	\N	\N	\N	\N	158920	158920	326190
20721	30440	101	applied	\N	\N	\N	\N	158921	158921	326191
20721	30442	102	applied	\N	\N	\N	\N	158922	158922	326192
20721	30446	103	applied	\N	\N	\N	\N	158923	158923	326193
20721	30403	104	applied	\N	\N	\N	\N	158924	158924	326194
20721	30404	105	applied	\N	\N	\N	\N	158925	158925	326195
20721	30405	106	applied	\N	\N	\N	\N	158926	158926	326196
20721	30406	107	applied	\N	\N	\N	\N	158927	158927	326197
20721	30411	108	applied	\N	\N	\N	\N	158928	158928	326198
20721	30415	109	applied	\N	\N	\N	\N	158929	158929	326199
20721	30422	110	applied	\N	\N	\N	\N	158930	158930	326200
20721	30424	112	applied	\N	\N	\N	\N	158932	158932	326202
20721	30426	113	applied	\N	\N	\N	\N	158933	158933	326203
20721	30432	114	applied	\N	\N	\N	\N	158934	158934	326204
20721	30436	115	applied	\N	\N	\N	\N	158935	158935	326205
20721	30438	116	applied	\N	\N	\N	\N	158936	158936	326206
20721	30443	117	applied	\N	\N	\N	\N	158937	158937	326207
20721	30445	118	applied	\N	\N	\N	\N	158938	158938	326208
20721	30450	119	applied	\N	\N	\N	\N	158939	158939	326209
20721	30451	120	applied	\N	\N	\N	\N	158940	158940	326210
20721	30461	121	applied	\N	\N	\N	\N	158941	158941	326211
20721	30467	122	applied	\N	\N	\N	\N	158942	158942	326212
20721	30452	123	applied	\N	\N	\N	\N	158943	158943	326213
20721	30466	124	applied	\N	\N	\N	\N	158944	158944	326214
20721	30479	125	applied	\N	\N	\N	\N	158945	158945	326215
20726	30496	0	applied	\N	\N	\N	\N	158966	158966	326236
20726	30497	1	applied	\N	\N	\N	\N	158967	158967	326237
20726	30499	3	applied	\N	\N	\N	\N	158969	158969	326239
20726	30500	4	applied	\N	\N	\N	\N	158970	158970	326240
20726	30501	5	applied	\N	\N	\N	\N	158971	158971	326241
20726	30502	6	applied	\N	\N	\N	\N	158972	158972	326242
20726	30503	7	applied	\N	\N	\N	\N	158973	158973	326243
20726	30504	8	applied	\N	\N	\N	\N	158974	158974	326244
20726	30505	9	applied	\N	\N	\N	\N	158975	158975	326245
20729	30499	3	applied	\N	\N	\N	\N	158999	158999	326269
20729	30500	4	applied	\N	\N	\N	\N	159000	159000	326270
20729	30501	5	applied	\N	\N	\N	\N	159001	159001	326271
20729	30502	6	applied	\N	\N	\N	\N	159002	159002	326272
20729	30503	7	applied	\N	\N	\N	\N	159003	159003	326273
20729	30504	8	applied	\N	\N	\N	\N	159004	159004	326274
20729	30505	9	applied	\N	\N	\N	\N	159005	159005	326275
20730	30506	0	applied	\N	\N	\N	\N	159006	159006	326276
20730	30507	1	applied	\N	\N	\N	\N	159007	159007	326277
20730	30509	3	applied	\N	\N	\N	\N	159009	159009	326279
20730	30510	4	applied	\N	\N	\N	\N	159010	159010	326280
20730	30511	5	applied	\N	\N	\N	\N	159011	159011	326281
20730	30512	6	applied	\N	\N	\N	\N	159012	159012	326282
20730	30513	7	applied	\N	\N	\N	\N	159013	159013	326283
20730	30514	8	applied	\N	\N	\N	\N	159014	159014	326284
20730	30515	9	applied	\N	\N	\N	\N	159015	159015	326285
20733	30523	0	applied	\N	\N	\N	\N	159033	159033	326303
20733	30524	1	applied	\N	\N	\N	\N	159034	159034	326304
20733	30525	2	applied	\N	\N	\N	\N	159035	159035	326305
20735	30516	0	applied	\N	\N	\N	\N	159039	159039	326309
20735	30517	1	applied	\N	\N	\N	\N	159040	159040	326310
20735	30523	2	applied	\N	\N	\N	\N	159041	159041	326311
20735	30521	3	applied	\N	\N	\N	\N	159042	159042	326312
20736	30526	0	applied	\N	\N	\N	\N	159043	159043	326313
20736	30527	1	applied	\N	\N	\N	\N	159044	159044	326314
20738	30529	0	applied	\N	\N	\N	\N	159049	159049	326319
20742	30543	0	applied	\N	\N	\N	\N	159080	159080	326350
20742	30544	1	applied	\N	\N	\N	\N	159081	159081	326351
20742	30545	2	applied	\N	\N	\N	\N	159082	159082	326352
20742	30546	3	applied	\N	\N	\N	\N	159083	159083	326353
20742	30547	4	applied	\N	\N	\N	\N	159084	159084	326354
20742	30548	5	applied	\N	\N	\N	\N	159085	159085	326355
20742	30549	6	applied	\N	\N	\N	\N	159086	159086	326356
20747	30561	0	applied	\N	\N	\N	\N	159111	159111	326381
20747	30562	1	applied	\N	\N	\N	\N	159112	159112	326382
20747	30563	2	applied	\N	\N	\N	\N	159113	159113	326383
20747	30564	3	applied	\N	\N	\N	\N	159114	159114	326384
20747	30565	4	applied	\N	\N	\N	\N	159115	159115	326385
20747	30566	5	applied	\N	\N	\N	\N	159116	159116	326386
20747	30567	6	applied	\N	\N	\N	\N	159117	159117	326387
20748	30568	0	applied	\N	\N	\N	\N	159118	159118	326388
20748	30570	2	applied	\N	\N	\N	\N	159120	159120	326390
20748	30571	3	applied	\N	\N	\N	\N	159121	159121	326391
20748	30572	4	applied	\N	\N	\N	\N	159122	159122	326392
20748	30573	5	applied	\N	\N	\N	\N	159123	159123	326393
20753	30582	0	applied	\N	\N	\N	\N	159149	159149	326419
20753	30583	1	applied	\N	\N	\N	\N	159150	159150	326420
20753	30584	2	applied	\N	\N	\N	\N	159151	159151	326421
20753	30585	3	applied	\N	\N	1000000000	\N	159152	159152	326422
20753	30586	4	applied	\N	\N	\N	\N	159153	159153	326423
20763	30593	0	applied	\N	\N	\N	\N	159363	159363	326633
20763	30594	1	applied	\N	\N	\N	\N	159364	159364	326634
20763	30588	2	applied	\N	\N	\N	\N	159365	159365	326635
20763	30535	3	applied	\N	\N	\N	\N	159366	159366	326636
20763	30536	4	applied	\N	\N	\N	\N	159367	159367	326637
20763	30574	5	applied	\N	\N	\N	\N	159368	159368	326638
20763	30589	6	applied	\N	\N	\N	\N	159369	159369	326639
20763	30595	8	applied	\N	\N	\N	\N	159371	159371	326641
20763	30596	9	applied	\N	\N	\N	\N	159372	159372	326642
20763	30575	10	applied	\N	\N	\N	\N	159373	159373	326643
20763	30576	11	applied	\N	\N	\N	\N	159374	159374	326644
20763	30577	12	applied	\N	\N	\N	\N	159375	159375	326645
20763	30537	13	applied	\N	\N	\N	\N	159376	159376	326646
20763	30538	15	applied	\N	\N	\N	\N	159377	159377	326647
20763	30543	16	applied	\N	\N	\N	\N	159378	159378	326648
20763	30544	17	applied	\N	\N	\N	\N	159379	159379	326649
20763	30546	18	applied	\N	\N	\N	\N	159380	159380	326650
20763	30550	19	applied	\N	\N	\N	\N	159381	159381	326651
20763	30551	20	applied	\N	\N	\N	\N	159382	159382	326652
20763	30552	21	applied	\N	\N	\N	\N	159383	159383	326653
20763	30556	22	applied	\N	\N	\N	\N	159384	159384	326654
20763	30557	23	applied	\N	\N	\N	\N	159385	159385	326655
20763	30561	24	applied	\N	\N	\N	\N	159386	159386	326656
20721	30420	96	applied	\N	\N	\N	\N	158916	158916	326186
20739	30534	1	applied	\N	\N	\N	\N	159054	159054	326324
20739	30535	2	applied	\N	\N	\N	\N	159055	159055	326325
20739	30536	3	applied	\N	\N	\N	\N	159056	159056	326326
20739	30537	4	applied	\N	\N	\N	\N	159057	159057	326327
20739	30538	5	applied	\N	\N	\N	\N	159058	159058	326328
20739	30539	6	applied	\N	\N	\N	\N	159059	159059	326329
20739	30540	7	applied	\N	\N	\N	\N	159060	159060	326330
20739	30541	8	applied	\N	\N	\N	\N	159061	159061	326331
20739	30542	9	applied	\N	\N	\N	\N	159062	159062	326332
20744	30550	0	applied	\N	\N	\N	\N	159093	159093	326363
20744	30551	1	applied	\N	\N	\N	\N	159094	159094	326364
20744	30552	2	applied	\N	\N	\N	\N	159095	159095	326365
20744	30553	3	applied	\N	\N	\N	\N	159096	159096	326366
20744	30554	4	applied	\N	\N	\N	\N	159097	159097	326367
20745	30556	0	applied	\N	\N	\N	\N	159099	159099	326369
20745	30557	1	applied	\N	\N	\N	\N	159100	159100	326370
20745	30558	2	applied	\N	\N	\N	\N	159101	159101	326371
20745	30559	3	applied	\N	\N	\N	\N	159102	159102	326372
20745	30560	4	applied	\N	\N	\N	\N	159103	159103	326373
20750	30568	0	applied	\N	\N	\N	\N	159130	159130	326400
20750	30569	1	applied	\N	\N	\N	\N	159131	159131	326401
20750	30570	2	applied	\N	\N	\N	\N	159132	159132	326402
20750	30571	3	applied	\N	\N	\N	\N	159133	159133	326403
20750	30572	4	applied	\N	\N	\N	\N	159134	159134	326404
20750	30573	5	applied	\N	\N	\N	\N	159135	159135	326405
20751	30574	0	applied	\N	\N	\N	\N	159136	159136	326406
20751	30575	1	applied	\N	\N	\N	\N	159137	159137	326407
20751	30576	2	applied	\N	\N	\N	\N	159138	159138	326408
20751	30577	3	applied	\N	\N	\N	\N	159139	159139	326409
20751	30578	4	applied	\N	\N	\N	\N	159140	159140	326410
20751	30580	6	applied	\N	\N	\N	\N	159142	159142	326412
20751	30581	7	applied	\N	\N	\N	\N	159143	159143	326413
20756	30587	0	applied	\N	\N	\N	\N	159165	159165	326435
20756	30588	1	applied	\N	\N	\N	\N	159166	159166	326436
20756	30589	2	applied	\N	\N	\N	\N	159167	159167	326437
20756	30590	3	applied	\N	\N	\N	\N	159168	159168	326438
20756	30591	4	applied	\N	\N	\N	\N	159169	159169	326439
20756	30592	5	applied	\N	\N	\N	\N	159170	159170	326440
20761	30593	0	applied	\N	\N	\N	\N	159231	159231	326501
20761	30594	1	applied	\N	\N	\N	\N	159232	159232	326502
20761	30595	2	applied	\N	\N	\N	\N	159233	159233	326503
20761	30596	3	applied	\N	\N	\N	\N	159234	159234	326504
20761	30598	4	applied	\N	\N	\N	\N	159235	159235	326505
20761	30599	5	applied	\N	\N	\N	\N	159236	159236	326506
20761	30597	6	applied	\N	\N	\N	\N	159237	159237	326507
20761	30601	7	applied	\N	\N	\N	\N	159238	159238	326508
20761	30603	9	applied	\N	\N	\N	\N	159240	159240	326510
20761	30605	10	applied	\N	\N	\N	\N	159241	159241	326511
20761	30606	11	applied	\N	\N	\N	\N	159242	159242	326512
20761	30607	12	applied	\N	\N	\N	\N	159243	159243	326513
20761	30608	13	applied	\N	\N	\N	\N	159244	159244	326514
20763	30562	25	applied	\N	\N	\N	\N	159387	159387	326657
20763	30578	26	applied	\N	\N	\N	\N	159388	159388	326658
20763	30597	27	applied	\N	\N	\N	\N	159389	159389	326659
20763	30601	28	applied	\N	\N	\N	\N	159390	159390	326660
20763	30602	29	applied	\N	\N	\N	\N	159391	159391	326661
20763	30603	30	applied	\N	\N	\N	\N	159392	159392	326662
20763	30564	31	applied	\N	\N	\N	\N	159393	159393	326663
20763	30568	32	applied	\N	\N	\N	\N	159394	159394	326664
20763	30570	33	applied	\N	\N	\N	\N	159395	159395	326665
20763	30571	34	applied	\N	\N	\N	\N	159396	159396	326666
20763	30604	35	applied	\N	\N	\N	\N	159397	159397	326667
20763	30585	37	applied	\N	\N	1000000000	\N	159399	159399	326669
20765	30594	0	applied	\N	\N	\N	\N	159412	159412	326682
20765	30603	1	applied	\N	\N	\N	\N	159413	159413	326683
20765	30609	2	applied	\N	\N	\N	\N	159414	159414	326684
20765	30610	3	applied	\N	\N	\N	\N	159415	159415	326685
20765	30611	4	applied	\N	\N	\N	\N	159416	159416	326686
20765	30600	5	applied	\N	\N	\N	\N	159417	159417	326687
20765	30612	6	applied	\N	\N	\N	\N	159418	159418	326688
20767	30593	0	applied	\N	\N	\N	\N	159424	159424	326694
20767	30594	1	applied	\N	\N	\N	\N	159425	159425	326695
20767	30595	2	applied	\N	\N	\N	\N	159426	159426	326696
20767	30596	3	applied	\N	\N	\N	\N	159427	159427	326697
20767	30598	4	applied	\N	\N	\N	\N	159428	159428	326698
20767	30599	5	applied	\N	\N	\N	\N	159429	159429	326699
20767	30597	6	applied	\N	\N	\N	\N	159430	159430	326700
20767	30601	7	applied	\N	\N	\N	\N	159431	159431	326701
20767	30603	9	applied	\N	\N	\N	\N	159433	159433	326703
20767	30605	10	applied	\N	\N	\N	\N	159434	159434	326704
20767	30606	11	applied	\N	\N	\N	\N	159435	159435	326705
20767	30607	12	applied	\N	\N	\N	\N	159436	159436	326706
20767	30608	13	applied	\N	\N	\N	\N	159437	159437	326707
20770	30614	0	applied	\N	\N	\N	\N	159446	159446	326716
20770	30615	1	applied	\N	\N	\N	\N	159447	159447	326717
20771	30616	0	applied	\N	\N	\N	\N	159448	159448	326718
20771	30617	1	applied	\N	\N	\N	\N	159449	159449	326719
20771	30618	2	applied	\N	\N	\N	\N	159450	159450	326720
20771	30619	3	applied	\N	\N	\N	\N	159451	159451	326721
20771	30620	4	applied	\N	\N	\N	\N	159452	159452	326722
20771	30621	5	applied	\N	\N	\N	\N	159453	159453	326723
20771	30622	6	applied	\N	\N	\N	\N	159454	159454	326724
20773	30616	0	applied	\N	\N	\N	\N	159472	159472	326742
20773	30617	1	applied	\N	\N	\N	\N	159473	159473	326743
20773	30619	3	applied	\N	\N	\N	\N	159475	159475	326745
20773	30620	4	applied	\N	\N	\N	\N	159476	159476	326746
20773	30621	5	applied	\N	\N	\N	\N	159477	159477	326747
20773	30622	6	applied	\N	\N	\N	\N	159478	159478	326748
20773	30623	7	applied	\N	\N	\N	\N	159479	159479	326749
20773	30624	8	applied	\N	\N	\N	\N	159480	159480	326750
20773	30625	9	applied	\N	\N	\N	\N	159481	159481	326751
20773	30626	10	applied	\N	\N	\N	\N	159482	159482	326752
20773	30627	11	applied	\N	\N	\N	\N	159483	159483	326753
20778	30634	0	applied	\N	\N	\N	\N	159513	159513	326783
20778	30635	1	applied	\N	\N	\N	\N	159514	159514	326784
20778	30636	2	applied	\N	\N	\N	\N	159515	159515	326785
20778	30637	3	applied	\N	\N	\N	\N	159516	159516	326786
20778	30638	4	applied	\N	\N	\N	\N	159517	159517	326787
20779	30639	0	applied	\N	\N	\N	\N	159518	159518	326788
20779	30640	1	applied	\N	\N	\N	\N	159519	159519	326789
20739	30533	0	applied	\N	\N	\N	\N	159053	159053	326323
20760	30596	12	applied	\N	\N	\N	\N	159183	159183	326453
20760	30575	13	applied	\N	\N	\N	\N	159184	159184	326454
20760	30576	14	applied	\N	\N	\N	\N	159185	159185	326455
20760	30577	15	applied	\N	\N	\N	\N	159186	159186	326456
20760	30537	16	applied	\N	\N	\N	\N	159187	159187	326457
20760	30538	17	applied	\N	\N	\N	\N	159188	159188	326458
20760	30543	18	applied	\N	\N	\N	\N	159189	159189	326459
20760	30544	19	applied	\N	\N	\N	\N	159190	159190	326460
20760	30546	20	applied	\N	\N	\N	\N	159191	159191	326461
20760	30550	21	applied	\N	\N	\N	\N	159192	159192	326462
20760	30551	22	applied	\N	\N	\N	\N	159193	159193	326463
20760	30552	23	applied	\N	\N	\N	\N	159194	159194	326464
20760	30556	24	applied	\N	\N	\N	\N	159195	159195	326465
20760	30557	25	applied	\N	\N	\N	\N	159196	159196	326466
20760	30562	27	applied	\N	\N	\N	\N	159198	159198	326468
20760	30578	28	applied	\N	\N	\N	\N	159199	159199	326469
20760	30526	29	applied	\N	\N	\N	\N	159200	159200	326470
20760	30529	30	applied	\N	\N	\N	\N	159201	159201	326471
20760	30533	31	applied	\N	\N	\N	\N	159202	159202	326472
20760	30534	32	applied	\N	\N	\N	\N	159203	159203	326473
20760	30545	33	applied	\N	\N	\N	\N	159204	159204	326474
20760	30553	34	applied	\N	\N	\N	\N	159205	159205	326475
20760	30558	35	applied	\N	\N	\N	\N	159206	159206	326476
20760	30563	36	applied	\N	\N	\N	\N	159207	159207	326477
20760	30569	37	applied	\N	\N	\N	\N	159208	159208	326478
20760	30597	38	applied	\N	\N	\N	\N	159209	159209	326479
20760	30579	39	applied	\N	\N	\N	\N	159210	159210	326480
20760	30582	40	applied	\N	\N	\N	\N	159211	159211	326481
20760	30587	41	applied	\N	\N	\N	\N	159212	159212	326482
20760	30598	42	applied	\N	\N	\N	\N	159213	159213	326483
20760	30600	44	applied	\N	\N	\N	\N	159215	159215	326485
20760	30601	45	applied	\N	\N	\N	\N	159216	159216	326486
20760	30602	46	applied	\N	\N	\N	\N	159217	159217	326487
20760	30603	47	applied	\N	\N	\N	\N	159218	159218	326488
20760	30564	48	applied	\N	\N	\N	\N	159219	159219	326489
20760	30568	49	applied	\N	\N	\N	\N	159220	159220	326490
20760	30570	50	applied	\N	\N	\N	\N	159221	159221	326491
20760	30571	51	applied	\N	\N	\N	\N	159222	159222	326492
20760	30604	52	applied	\N	\N	\N	\N	159223	159223	326493
20760	30521	53	applied	\N	\N	\N	\N	159224	159224	326494
20760	30531	54	applied	\N	\N	\N	\N	159225	159225	326495
20760	30549	55	applied	\N	\N	\N	\N	159226	159226	326496
20760	30566	56	applied	\N	\N	\N	\N	159227	159227	326497
20760	30585	57	applied	\N	\N	1000000000	\N	159228	159228	326498
20760	30586	58	applied	\N	\N	\N	\N	159229	159229	326499
20760	30605	59	applied	\N	\N	\N	\N	159230	159230	326500
20764	30595	1	applied	\N	\N	\N	\N	159401	159401	326671
20764	30596	2	applied	\N	\N	\N	\N	159402	159402	326672
20764	30598	3	applied	\N	\N	\N	\N	159403	159403	326673
20764	30599	4	applied	\N	\N	\N	\N	159404	159404	326674
20764	30597	5	applied	\N	\N	\N	\N	159405	159405	326675
20764	30601	6	applied	\N	\N	\N	\N	159406	159406	326676
20764	30602	7	applied	\N	\N	\N	\N	159407	159407	326677
20764	30605	8	applied	\N	\N	\N	\N	159408	159408	326678
20764	30606	9	applied	\N	\N	\N	\N	159409	159409	326679
20764	30607	10	applied	\N	\N	\N	\N	159410	159410	326680
20764	30608	11	applied	\N	\N	\N	\N	159411	159411	326681
20768	30609	0	applied	\N	\N	\N	\N	159438	159438	326708
20768	30610	1	applied	\N	\N	\N	\N	159439	159439	326709
20768	30611	2	applied	\N	\N	\N	\N	159440	159440	326710
20768	30600	3	applied	\N	\N	\N	\N	159441	159441	326711
20768	30612	4	applied	\N	\N	\N	\N	159442	159442	326712
20769	30614	1	applied	\N	\N	\N	\N	159444	159444	326714
20769	30615	2	applied	\N	\N	\N	\N	159445	159445	326715
20771	30623	7	applied	\N	\N	\N	\N	159455	159455	326725
20771	30624	8	applied	\N	\N	\N	\N	159456	159456	326726
20771	30625	9	applied	\N	\N	\N	\N	159457	159457	326727
20771	30626	10	applied	\N	\N	\N	\N	159458	159458	326728
20771	30627	11	applied	\N	\N	\N	\N	159459	159459	326729
20774	30616	0	applied	\N	\N	\N	\N	159484	159484	326754
20774	30617	1	applied	\N	\N	\N	\N	159485	159485	326755
20775	30616	0	applied	\N	\N	\N	\N	159496	159496	326766
20775	30623	1	applied	\N	\N	\N	\N	159497	159497	326767
20775	30624	2	applied	\N	\N	\N	\N	159498	159498	326768
20775	30625	3	applied	\N	\N	\N	\N	159499	159499	326769
20775	30626	4	applied	\N	\N	\N	\N	159500	159500	326770
20775	30627	5	applied	\N	\N	\N	\N	159501	159501	326771
20783	30651	0	applied	\N	\N	\N	\N	159536	159536	326806
20783	30653	2	applied	\N	\N	\N	\N	159538	159538	326808
20783	30654	3	applied	\N	\N	\N	\N	159539	159539	326809
20783	30655	4	applied	\N	\N	\N	\N	159540	159540	326810
20783	30656	5	applied	\N	\N	\N	\N	159541	159541	326811
20788	30657	0	applied	\N	\N	\N	\N	159588	159588	326858
20794	30672	0	applied	\N	\N	\N	\N	159607	159607	326877
20794	30673	1	applied	\N	\N	\N	\N	159608	159608	326878
20794	30674	2	applied	\N	\N	\N	\N	159609	159609	326879
20794	30675	3	applied	\N	\N	\N	\N	159610	159610	326880
20794	30676	4	applied	\N	\N	\N	\N	159611	159611	326881
20794	30677	5	applied	\N	\N	\N	\N	159612	159612	326882
20795	30678	0	applied	\N	\N	\N	\N	159613	159613	326883
20795	30679	1	applied	\N	\N	\N	\N	159614	159614	326884
20795	30680	2	applied	\N	\N	\N	\N	159615	159615	326885
20795	30681	3	applied	\N	\N	\N	\N	159616	159616	326886
20795	30682	4	applied	\N	\N	\N	\N	159617	159617	326887
20795	30684	6	applied	\N	\N	\N	\N	159619	159619	326889
20800	30688	0	applied	\N	\N	\N	\N	159629	159629	326899
20800	30689	1	applied	\N	\N	\N	\N	159630	159630	326900
20800	30690	2	applied	\N	\N	\N	\N	159631	159631	326901
20801	30691	0	applied	\N	\N	\N	\N	159632	159632	326902
20801	30692	1	applied	\N	\N	\N	\N	159633	159633	326903
20802	30693	0	applied	\N	\N	\N	\N	159634	159634	326904
20802	30694	1	applied	\N	\N	\N	\N	159635	159635	326905
20802	30695	2	applied	\N	\N	\N	\N	159636	159636	326906
20802	30696	3	applied	\N	\N	\N	\N	159637	159637	326907
20802	30697	4	applied	\N	\N	\N	\N	159638	159638	326908
20802	30698	5	applied	\N	\N	\N	\N	159639	159639	326909
20802	30699	6	applied	\N	\N	\N	\N	159640	159640	326910
20803	30700	0	applied	\N	\N	\N	\N	159641	159641	326911
20803	30701	1	applied	\N	\N	\N	\N	159642	159642	326912
20808	30712	0	applied	\N	\N	\N	\N	159657	159657	326926
20760	30595	11	applied	\N	\N	\N	\N	159182	159182	326452
20762	30550	20	applied	\N	\N	\N	\N	159265	159265	326535
20762	30551	21	applied	\N	\N	\N	\N	159266	159266	326536
20762	30552	22	applied	\N	\N	\N	\N	159267	159267	326537
20762	30556	23	applied	\N	\N	\N	\N	159268	159268	326538
20762	30557	24	applied	\N	\N	\N	\N	159269	159269	326539
20762	30561	25	applied	\N	\N	\N	\N	159270	159270	326540
20762	30562	26	applied	\N	\N	\N	\N	159271	159271	326541
20762	30578	27	applied	\N	\N	\N	\N	159272	159272	326542
20762	30425	28	applied	\N	\N	\N	\N	159273	159273	326543
20762	30428	29	applied	\N	\N	\N	\N	159274	159274	326544
20762	30431	30	applied	\N	\N	\N	\N	159275	159275	326545
20762	30434	31	applied	\N	\N	\N	\N	159276	159276	326546
20762	30437	32	applied	\N	\N	\N	\N	159277	159277	326547
20762	30444	34	applied	\N	\N	\N	\N	159279	159279	326549
20762	30448	35	applied	\N	\N	\N	\N	159280	159280	326550
20762	30449	36	applied	\N	\N	\N	\N	159281	159281	326551
20762	30458	37	applied	\N	\N	\N	\N	159282	159282	326552
20762	30597	38	applied	\N	\N	\N	\N	159283	159283	326553
20762	30601	39	applied	\N	\N	\N	\N	159284	159284	326554
20762	30564	40	applied	\N	\N	\N	\N	159285	159285	326555
20762	30568	41	applied	\N	\N	\N	\N	159286	159286	326556
20762	30570	42	applied	\N	\N	\N	\N	159287	159287	326557
20762	30571	43	applied	\N	\N	\N	\N	159288	159288	326558
20762	30604	44	applied	\N	\N	\N	\N	159289	159289	326559
20762	30463	45	applied	\N	\N	\N	\N	159290	159290	326560
20762	30464	46	applied	\N	\N	\N	\N	159291	159291	326561
20762	30465	47	applied	\N	\N	\N	\N	159292	159292	326562
20762	30471	48	applied	\N	\N	\N	\N	159293	159293	326563
20762	30474	49	applied	\N	\N	\N	\N	159294	159294	326564
20762	30482	51	applied	\N	\N	\N	\N	159296	159296	326566
20762	30484	52	applied	\N	\N	\N	\N	159297	159297	326567
20762	30488	53	applied	\N	\N	\N	\N	159298	159298	326568
20762	30491	54	applied	\N	\N	\N	\N	159299	159299	326569
20762	30494	55	applied	\N	\N	\N	\N	159300	159300	326570
20762	30496	56	applied	\N	\N	\N	\N	159301	159301	326571
20762	30497	57	applied	\N	\N	\N	\N	159302	159302	326572
20762	30498	58	applied	\N	\N	\N	\N	159303	159303	326573
20762	30506	59	applied	\N	\N	\N	\N	159304	159304	326574
20762	30507	60	applied	\N	\N	\N	\N	159305	159305	326575
20762	30508	61	applied	\N	\N	\N	\N	159306	159306	326576
20762	30516	62	applied	\N	\N	\N	\N	159307	159307	326577
20762	30517	63	applied	\N	\N	\N	\N	159308	159308	326578
20762	30523	64	applied	\N	\N	\N	\N	159309	159309	326579
20762	30526	65	applied	\N	\N	\N	\N	159310	159310	326580
20762	30529	66	applied	\N	\N	\N	\N	159311	159311	326581
20762	30534	68	applied	\N	\N	\N	\N	159313	159313	326583
20762	30545	69	applied	\N	\N	\N	\N	159314	159314	326584
20762	30553	70	applied	\N	\N	\N	\N	159315	159315	326585
20762	30558	71	applied	\N	\N	\N	\N	159316	159316	326586
20762	30563	72	applied	\N	\N	\N	\N	159317	159317	326587
20762	30569	74	applied	\N	\N	\N	\N	159318	159318	326588
20762	30579	75	applied	\N	\N	\N	\N	159319	159319	326589
20762	30582	76	applied	\N	\N	\N	\N	159320	159320	326590
20762	30587	77	applied	\N	\N	\N	\N	159321	159321	326591
20762	30598	78	applied	\N	\N	\N	\N	159322	159322	326592
20762	30599	79	applied	\N	\N	\N	\N	159323	159323	326593
20762	30509	80	applied	\N	\N	\N	\N	159324	159324	326594
20762	30459	81	applied	\N	\N	1000000000	\N	159325	159325	326595
20762	30476	82	applied	\N	\N	\N	\N	159326	159326	326596
20762	30430	83	applied	\N	\N	\N	\N	159327	159327	326597
20762	30433	84	applied	\N	\N	\N	\N	159328	159328	326598
20762	30585	86	applied	\N	\N	1000000000	\N	159330	159330	326600
20762	30440	87	applied	\N	\N	\N	\N	159331	159331	326601
20762	30442	88	applied	\N	\N	\N	\N	159332	159332	326602
20762	30446	89	applied	\N	\N	\N	\N	159333	159333	326603
20762	30404	90	applied	\N	\N	\N	\N	159334	159334	326604
20774	30618	2	applied	\N	\N	\N	\N	159486	159486	326756
20774	30619	3	applied	\N	\N	\N	\N	159487	159487	326757
20774	30620	4	applied	\N	\N	\N	\N	159488	159488	326758
20774	30621	5	applied	\N	\N	\N	\N	159489	159489	326759
20774	30622	6	applied	\N	\N	\N	\N	159490	159490	326760
20774	30623	7	applied	\N	\N	\N	\N	159491	159491	326761
20774	30624	8	applied	\N	\N	\N	\N	159492	159492	326762
20774	30625	9	applied	\N	\N	\N	\N	159493	159493	326763
20774	30626	10	applied	\N	\N	\N	\N	159494	159494	326764
20774	30627	11	applied	\N	\N	\N	\N	159495	159495	326765
20782	30651	0	applied	\N	\N	\N	\N	159530	159530	326800
20782	30653	2	applied	\N	\N	\N	\N	159532	159532	326802
20782	30654	3	applied	\N	\N	\N	\N	159533	159533	326803
20782	30655	4	applied	\N	\N	\N	\N	159534	159534	326804
20782	30656	5	applied	\N	\N	\N	\N	159535	159535	326805
20786	30447	0	applied	\N	\N	\N	\N	159548	159548	326818
20786	30455	1	applied	\N	\N	\N	\N	159549	159549	326819
20786	30456	2	applied	\N	\N	\N	\N	159550	159550	326820
20786	30457	3	applied	\N	\N	\N	\N	159551	159551	326821
20786	30593	4	applied	\N	\N	\N	\N	159552	159552	326822
20786	30594	5	applied	\N	\N	\N	\N	159553	159553	326823
20786	30616	6	applied	\N	\N	\N	\N	159554	159554	326824
20786	30652	7	applied	\N	\N	\N	\N	159555	159555	326825
20786	30588	8	applied	\N	\N	\N	\N	159556	159556	326826
20786	30535	9	applied	\N	\N	\N	\N	159557	159557	326827
20786	30536	10	applied	\N	\N	\N	\N	159558	159558	326828
20786	30574	11	applied	\N	\N	\N	\N	159559	159559	326829
20786	30590	13	applied	\N	\N	\N	\N	159561	159561	326831
20786	30595	14	applied	\N	\N	\N	\N	159562	159562	326832
20786	30596	15	applied	\N	\N	\N	\N	159563	159563	326833
20786	30575	16	applied	\N	\N	\N	\N	159564	159564	326834
20786	30576	17	applied	\N	\N	\N	\N	159565	159565	326835
20786	30577	18	applied	\N	\N	\N	\N	159566	159566	326836
20786	30537	19	applied	\N	\N	\N	\N	159567	159567	326837
20786	30538	20	applied	\N	\N	\N	\N	159568	159568	326838
20786	30543	21	applied	\N	\N	\N	\N	159569	159569	326839
20786	30544	22	applied	\N	\N	\N	\N	159570	159570	326840
20786	30374	23	applied	\N	\N	\N	\N	159571	159571	326841
20786	30379	24	applied	\N	\N	\N	\N	159572	159572	326842
20786	30546	25	applied	\N	\N	\N	\N	159573	159573	326843
20786	30550	26	applied	\N	\N	\N	\N	159574	159574	326844
20786	30551	27	applied	\N	\N	\N	\N	159575	159575	326845
20786	30552	28	applied	\N	\N	\N	\N	159576	159576	326846
20762	30544	18	applied	\N	\N	\N	\N	159263	159263	326533
20762	30546	19	applied	\N	\N	\N	\N	159264	159264	326534
20762	30422	95	applied	\N	\N	\N	\N	159339	159339	326609
20762	30423	96	applied	\N	\N	\N	\N	159340	159340	326610
20762	30424	97	applied	\N	\N	\N	\N	159341	159341	326611
20762	30426	98	applied	\N	\N	\N	\N	159342	159342	326612
20762	30432	99	applied	\N	\N	\N	\N	159343	159343	326613
20762	30436	100	applied	\N	\N	\N	\N	159344	159344	326614
20762	30438	101	applied	\N	\N	\N	\N	159345	159345	326615
20762	30443	102	applied	\N	\N	\N	\N	159346	159346	326616
20762	30445	103	applied	\N	\N	\N	\N	159347	159347	326617
20762	30450	104	applied	\N	\N	\N	\N	159348	159348	326618
20762	30451	105	applied	\N	\N	\N	\N	159349	159349	326619
20762	30461	106	applied	\N	\N	\N	\N	159350	159350	326620
20762	30467	107	applied	\N	\N	\N	\N	159351	159351	326621
20762	30453	108	applied	\N	\N	\N	\N	159352	159352	326622
20762	30454	109	applied	\N	\N	\N	\N	159353	159353	326623
20762	30460	110	applied	\N	\N	\N	\N	159354	159354	326624
20762	30468	112	applied	\N	\N	\N	\N	159356	159356	326626
20762	30469	113	applied	\N	\N	\N	\N	159357	159357	326627
20762	30470	114	applied	\N	\N	\N	\N	159358	159358	326628
20762	30472	115	applied	\N	\N	\N	\N	159359	159359	326629
20762	30304	116	applied	\N	\N	\N	\N	159360	159360	326630
20762	30322	117	applied	\N	\N	\N	\N	159361	159361	326631
20762	30345	118	applied	\N	\N	\N	\N	159362	159362	326632
20766	30609	0	applied	\N	\N	\N	\N	159419	159419	326689
20766	30610	1	applied	\N	\N	\N	\N	159420	159420	326690
20766	30611	2	applied	\N	\N	\N	\N	159421	159421	326691
20766	30600	3	applied	\N	\N	\N	\N	159422	159422	326692
20766	30612	4	applied	\N	\N	\N	\N	159423	159423	326693
20772	30616	0	applied	\N	\N	\N	\N	159460	159460	326730
20772	30617	1	applied	\N	\N	\N	\N	159461	159461	326731
20772	30618	2	applied	\N	\N	\N	\N	159462	159462	326732
20772	30619	3	applied	\N	\N	\N	\N	159463	159463	326733
20772	30621	5	applied	\N	\N	\N	\N	159465	159465	326735
20772	30622	6	applied	\N	\N	\N	\N	159466	159466	326736
20772	30623	7	applied	\N	\N	\N	\N	159467	159467	326737
20772	30624	8	applied	\N	\N	\N	\N	159468	159468	326738
20772	30625	9	applied	\N	\N	\N	\N	159469	159469	326739
20772	30626	10	applied	\N	\N	\N	\N	159470	159470	326740
20772	30627	11	applied	\N	\N	\N	\N	159471	159471	326741
20776	30628	0	applied	\N	\N	\N	\N	159502	159502	326772
20776	30629	1	applied	\N	\N	\N	\N	159503	159503	326773
20776	30630	2	applied	\N	\N	\N	\N	159504	159504	326774
20776	30631	3	applied	\N	\N	\N	\N	159505	159505	326775
20776	30632	4	applied	\N	\N	\N	\N	159506	159506	326776
20777	30633	0	applied	\N	\N	\N	\N	159507	159507	326777
20777	30634	1	applied	\N	\N	\N	\N	159508	159508	326778
20777	30635	2	applied	\N	\N	\N	\N	159509	159509	326779
20777	30636	3	applied	\N	\N	\N	\N	159510	159510	326780
20777	30638	5	applied	\N	\N	\N	\N	159512	159512	326782
20789	30659	0	applied	\N	\N	\N	\N	159589	159589	326859
20789	30660	1	applied	\N	\N	\N	\N	159590	159590	326860
20789	30661	2	applied	\N	\N	\N	\N	159591	159591	326861
20789	30662	3	applied	\N	\N	\N	\N	159592	159592	326862
20789	30658	4	applied	\N	\N	\N	\N	159593	159593	326863
20790	30663	0	applied	\N	\N	\N	\N	159594	159594	326864
20790	30664	1	applied	\N	\N	\N	\N	159595	159595	326865
20790	30665	2	applied	\N	\N	\N	\N	159596	159596	326866
20796	30678	0	applied	\N	\N	\N	\N	159620	159620	326890
20796	30679	1	applied	\N	\N	\N	\N	159621	159621	326891
20796	30680	2	applied	\N	\N	\N	\N	159622	159622	326892
20796	30681	3	applied	\N	\N	\N	\N	159623	159623	326893
20796	30682	4	applied	\N	\N	\N	\N	159624	159624	326894
20796	30683	5	applied	\N	\N	\N	\N	159625	159625	326895
20804	30700	0	applied	\N	\N	\N	\N	159643	159643	326913
20810	30714	0	applied	\N	\N	\N	\N	159662	159662	326931
20810	30715	1	applied	\N	\N	\N	\N	159663	159663	326932
20815	30719	0	applied	\N	\N	\N	\N	159673	159673	326942
20815	30720	1	applied	\N	\N	\N	\N	159674	159674	326943
20818	30593	0	applied	\N	\N	\N	\N	159679	159679	326948
20818	30594	1	applied	\N	\N	\N	\N	159680	159680	326949
20818	30616	2	applied	\N	\N	\N	\N	159681	159681	326950
20818	30702	3	applied	\N	\N	\N	\N	159682	159682	326951
20818	30703	4	applied	\N	\N	\N	\N	159683	159683	326952
20818	30704	5	applied	\N	\N	\N	\N	159684	159684	326953
20818	30705	6	applied	\N	\N	\N	\N	159685	159685	326954
20818	30706	7	applied	\N	\N	\N	\N	159686	159686	159686
20818	30652	8	applied	\N	\N	\N	\N	159687	159687	326955
20818	30641	9	applied	\N	\N	\N	\N	159688	159688	326956
20818	30651	10	applied	\N	\N	\N	\N	159689	159689	326957
20818	30659	11	applied	\N	\N	\N	\N	159690	159690	326958
20818	30535	13	applied	\N	\N	\N	\N	159692	159692	326960
20818	30536	14	applied	\N	\N	\N	\N	159693	159693	326961
20818	30574	15	applied	\N	\N	\N	\N	159694	159694	326962
20818	30589	16	applied	\N	\N	\N	\N	159695	159695	326963
20818	30590	17	applied	\N	\N	\N	\N	159696	159696	326964
20818	30595	18	applied	\N	\N	\N	\N	159697	159697	326965
20818	30596	19	applied	\N	\N	\N	\N	159698	159698	326966
20818	30575	20	applied	\N	\N	\N	\N	159699	159699	326967
20818	30576	21	applied	\N	\N	\N	\N	159700	159700	326968
20818	30577	22	applied	\N	\N	\N	\N	159701	159701	326969
20818	30537	23	applied	\N	\N	\N	\N	159702	159702	326970
20818	30538	24	applied	\N	\N	\N	\N	159703	159703	326971
20818	30543	25	applied	\N	\N	\N	\N	159704	159704	326972
20818	30544	26	applied	\N	\N	\N	\N	159705	159705	326973
20818	30546	27	applied	\N	\N	\N	\N	159706	159706	326974
20818	30550	28	applied	\N	\N	\N	\N	159707	159707	326975
20818	30552	30	applied	\N	\N	\N	\N	159709	159709	326977
20818	30556	31	applied	\N	\N	\N	\N	159710	159710	326978
20818	30557	32	applied	\N	\N	\N	\N	159711	159711	326979
20818	30561	33	applied	\N	\N	\N	\N	159712	159712	326980
20818	30562	34	applied	\N	\N	\N	\N	159713	159713	326981
20818	30578	35	applied	\N	\N	\N	\N	159714	159714	326982
20818	30526	36	applied	\N	\N	\N	\N	159715	159715	326983
20818	30529	37	applied	\N	\N	\N	\N	159716	159716	326984
20818	30533	38	applied	\N	\N	\N	\N	159717	159717	326985
20818	30534	39	applied	\N	\N	\N	\N	159718	159718	326986
20818	30545	40	applied	\N	\N	\N	\N	159719	159719	326987
20818	30673	41	applied	\N	\N	\N	\N	159720	159720	326988
20818	30674	42	applied	\N	\N	\N	\N	159721	159721	326989
20818	30675	43	applied	\N	\N	\N	\N	159722	159722	326990
20762	30406	92	applied	\N	\N	\N	\N	159336	159336	326606
20762	30411	93	applied	\N	\N	\N	\N	159337	159337	326607
20780	30645	4	applied	\N	\N	\N	\N	159524	159524	326794
20780	30646	5	applied	\N	\N	\N	\N	159525	159525	326795
20780	30647	6	applied	\N	\N	\N	\N	159526	159526	326796
20780	30648	7	applied	\N	\N	\N	\N	159527	159527	326797
20781	30649	0	applied	\N	\N	\N	\N	159528	159528	326798
20781	30650	1	applied	\N	\N	\N	\N	159529	159529	326799
20785	30651	0	applied	\N	\N	\N	\N	159542	159542	326812
20785	30652	1	applied	\N	\N	\N	\N	159543	159543	326813
20785	30653	2	applied	\N	\N	\N	\N	159544	159544	326814
20785	30654	3	applied	\N	\N	\N	\N	159545	159545	326815
20785	30655	4	applied	\N	\N	\N	\N	159546	159546	326816
20785	30656	5	applied	\N	\N	\N	\N	159547	159547	326817
20791	30666	0	applied	\N	\N	\N	\N	159597	159597	326867
20791	30667	1	applied	\N	\N	\N	\N	159598	159598	326868
20791	30668	2	applied	\N	\N	\N	\N	159599	159599	326869
20791	30669	3	applied	\N	\N	\N	\N	159600	159600	326870
20798	30686	0	applied	\N	\N	\N	\N	159627	159627	326897
20798	30687	1	applied	\N	\N	\N	\N	159628	159628	326898
20805	30702	0	applied	\N	\N	\N	\N	159645	159645	326915
20805	30703	1	applied	\N	\N	\N	\N	159646	159646	326916
20805	30704	2	applied	\N	\N	\N	\N	159647	159647	326917
20805	30705	3	applied	\N	\N	\N	\N	159648	159648	326918
20805	30706	4	applied	\N	\N	\N	\N	159649	159649	159649
20805	30707	5	applied	\N	\N	\N	\N	159650	159650	326919
20805	30708	6	applied	\N	\N	\N	\N	159651	159651	326920
20806	30709	0	applied	\N	\N	\N	\N	159652	159652	326921
20806	30710	1	applied	\N	\N	\N	\N	159653	159653	326922
20811	30714	0	applied	\N	\N	\N	\N	159664	159664	326933
20811	30715	1	applied	\N	\N	\N	\N	159665	159665	326934
20816	30719	0	applied	\N	\N	\N	\N	159675	159675	326944
20816	30720	1	applied	\N	\N	\N	\N	159676	159676	326945
20818	30676	44	applied	\N	\N	\N	\N	159723	159723	326991
20818	30553	46	applied	\N	\N	\N	\N	159725	159725	326993
20818	30558	47	applied	\N	\N	\N	\N	159726	159726	326994
20818	30563	48	applied	\N	\N	\N	\N	159727	159727	326995
20818	30569	49	applied	\N	\N	\N	\N	159728	159728	326996
20818	30597	50	applied	\N	\N	\N	\N	159729	159729	326997
20818	30579	51	applied	\N	\N	\N	\N	159730	159730	326998
20818	30582	52	applied	\N	\N	\N	\N	159731	159731	326999
20818	30587	53	applied	\N	\N	\N	\N	159732	159732	327000
20818	30598	54	applied	\N	\N	\N	\N	159733	159733	327001
20818	30599	55	applied	\N	\N	\N	\N	159734	159734	327002
20818	30600	56	applied	\N	\N	\N	\N	159735	159735	327003
20818	30601	57	applied	\N	\N	\N	\N	159736	159736	327004
20818	30602	58	applied	\N	\N	\N	\N	159737	159737	327005
20818	30603	59	applied	\N	\N	\N	\N	159738	159738	327006
20818	30609	60	applied	\N	\N	\N	\N	159739	159739	327007
20818	30610	61	applied	\N	\N	\N	\N	159740	159740	327008
20818	30721	63	applied	\N	\N	\N	\N	159742	159742	327010
20818	30722	64	applied	\N	\N	\N	\N	159743	159743	327011
20818	30618	65	applied	\N	\N	\N	\N	159744	159744	327012
20818	30619	66	applied	\N	\N	\N	\N	159745	159745	327013
20818	30620	67	applied	\N	\N	\N	\N	159746	159746	327014
20818	30621	68	applied	\N	\N	\N	\N	159747	159747	327015
20818	30622	69	applied	\N	\N	\N	\N	159748	159748	327016
20818	30628	70	applied	\N	\N	\N	\N	159749	159749	327017
20818	30630	71	applied	\N	\N	\N	\N	159750	159750	327018
20818	30631	72	applied	\N	\N	\N	\N	159751	159751	327019
20818	30633	73	applied	\N	\N	\N	\N	159752	159752	327020
20818	30660	74	applied	\N	\N	\N	\N	159753	159753	327021
20818	30664	75	applied	\N	\N	\N	\N	159754	159754	327022
20818	30680	76	applied	\N	\N	\N	\N	159755	159755	327023
20818	30681	77	applied	\N	\N	\N	\N	159756	159756	327024
20818	30614	78	applied	\N	\N	\N	\N	159757	159757	327025
20818	30624	80	applied	\N	\N	\N	\N	159759	159759	327027
20818	30629	81	applied	\N	\N	\N	\N	159760	159760	327028
20818	30634	82	applied	\N	\N	\N	\N	159761	159761	327029
20818	30635	83	applied	\N	\N	\N	\N	159762	159762	327030
20818	30639	84	applied	\N	\N	\N	\N	159763	159763	327031
20818	30642	85	applied	\N	\N	\N	\N	159764	159764	327032
20818	30643	86	applied	\N	\N	\N	\N	159765	159765	327033
20818	30644	87	applied	\N	\N	\N	\N	159766	159766	327034
20818	30649	88	applied	\N	\N	\N	\N	159767	159767	327035
20818	30653	89	applied	\N	\N	\N	\N	159768	159768	327036
20824	30728	0	applied	\N	\N	\N	\N	159811	159811	327079
20824	30729	1	applied	\N	\N	\N	\N	159812	159812	327080
20824	30727	2	applied	\N	\N	\N	\N	159813	159813	327081
20831	30734	0	applied	\N	\N	\N	\N	159829	159829	327097
20831	30735	1	applied	\N	\N	\N	\N	159830	159830	327098
20831	30736	2	applied	\N	\N	\N	\N	159831	159831	327099
20835	30742	1	applied	\N	\N	\N	\N	159843	159843	327109
20841	30748	0	applied	\N	\N	\N	\N	159896	159896	327160
20841	30749	1	applied	\N	\N	\N	\N	159897	159897	327161
20841	30750	2	applied	\N	\N	\N	\N	159898	159898	327162
20843	30751	0	applied	\N	\N	\N	\N	159902	159902	327166
20843	30752	1	applied	\N	\N	\N	\N	159903	159903	327167
20848	30744	0	applied	\N	\N	\N	\N	159913	159913	327177
20848	30745	1	applied	\N	\N	\N	\N	159914	159914	327178
20848	30748	2	applied	\N	\N	\N	\N	159915	159915	327179
20848	30758	3	applied	\N	\N	\N	\N	159916	159916	327180
20851	30763	0	applied	\N	\N	\N	\N	159925	159925	327189
20851	30764	2	applied	\N	\N	\N	\N	159926	159926	327190
20851	30765	3	applied	\N	\N	\N	\N	159927	159927	327191
20857	30780	0	applied	\N	\N	\N	\N	159960	159960	327224
20857	30781	1	applied	\N	\N	\N	\N	159961	159961	327225
20857	30782	2	applied	\N	\N	\N	\N	159962	159962	327226
20863	30807	0	applied	\N	\N	\N	\N	159992	159992	327255
20863	30808	1	applied	\N	\N	\N	\N	159993	159993	327256
20863	30809	2	applied	\N	\N	\N	\N	159994	159994	327257
20863	30810	3	applied	\N	\N	\N	\N	159995	159995	327258
20863	30811	4	applied	\N	\N	\N	\N	159996	159996	327259
20865	30817	0	applied	\N	\N	\N	\N	160002	160002	327265
20865	30818	1	applied	\N	\N	\N	\N	160003	160003	327266
20870	30819	0	applied	\N	\N	\N	\N	160118	160118	327379
20870	30820	1	applied	\N	\N	\N	\N	160119	160119	327380
20870	30821	2	applied	\N	\N	\N	\N	160120	160120	327381
20872	30826	0	applied	\N	\N	\N	\N	160125	160125	327386
20872	30827	1	applied	\N	\N	\N	\N	160126	160126	327387
20875	30831	0	applied	\N	\N	\N	\N	160132	160132	327393
20875	30832	1	applied	\N	\N	\N	\N	160133	160133	327394
20780	30642	1	applied	\N	\N	\N	\N	159521	159521	326791
20780	30643	2	applied	\N	\N	\N	\N	159522	159522	326792
20786	30597	34	applied	\N	\N	\N	\N	159582	159582	326852
20786	30382	35	applied	\N	\N	\N	\N	159583	159583	326853
20786	30601	36	applied	\N	\N	\N	\N	159584	159584	326854
20786	30602	37	applied	\N	\N	\N	\N	159585	159585	326855
20787	30657	0	applied	\N	\N	\N	\N	159586	159586	326856
20787	30658	1	applied	\N	\N	\N	\N	159587	159587	326857
20792	30666	0	applied	\N	\N	\N	\N	159601	159601	326871
20792	30667	1	applied	\N	\N	\N	\N	159602	159602	326872
20792	30668	2	applied	\N	\N	\N	\N	159603	159603	326873
20792	30669	3	applied	\N	\N	\N	\N	159604	159604	326874
20793	30670	0	applied	\N	\N	\N	\N	159605	159605	326875
20793	30671	1	applied	\N	\N	\N	\N	159606	159606	326876
20807	30709	0	applied	\N	\N	\N	\N	159654	159654	326923
20807	30711	1	applied	\N	\N	\N	\N	159655	159655	326924
20807	30710	2	applied	\N	\N	\N	\N	159656	159656	326925
20812	30714	0	applied	\N	\N	\N	\N	159666	159666	326935
20817	30719	0	applied	\N	\N	\N	\N	159677	159677	326946
20817	30720	1	applied	\N	\N	\N	\N	159678	159678	326947
20822	30725	0	applied	\N	\N	\N	\N	159808	159808	327076
20822	30726	1	applied	\N	\N	\N	\N	159809	159809	327077
20826	30728	0	applied	\N	\N	\N	\N	159816	159816	327084
20826	30729	1	applied	\N	\N	\N	\N	159817	159817	327085
20826	30727	2	applied	\N	\N	\N	\N	159818	159818	327086
20828	30732	0	applied	\N	\N	\N	\N	159821	159821	327089
20828	30733	1	applied	\N	\N	\N	\N	159822	159822	327090
20829	30734	0	applied	\N	\N	\N	\N	159823	159823	327091
20829	30735	1	applied	\N	\N	\N	\N	159824	159824	327092
20829	30736	2	applied	\N	\N	\N	\N	159825	159825	327093
20832	30734	0	applied	\N	\N	\N	\N	159832	159832	327100
20832	30735	1	applied	\N	\N	\N	\N	159833	159833	327101
20832	30736	2	applied	\N	\N	\N	\N	159834	159834	327102
20833	30737	0	applied	\N	\N	\N	\N	159835	159835	327103
20833	30739	2	applied	\N	\N	\N	\N	159837	159837	159837
20837	30741	0	applied	\N	\N	\N	\N	159881	159881	327145
20837	30742	1	applied	\N	\N	\N	\N	159882	159882	327146
20839	30743	0	applied	\N	\N	\N	\N	159888	159888	327152
20839	30744	1	applied	\N	\N	\N	\N	159889	159889	327153
20839	30745	2	applied	\N	\N	\N	\N	159890	159890	327154
20839	30746	3	applied	\N	\N	\N	\N	159891	159891	327155
20839	30747	4	applied	\N	\N	\N	\N	159892	159892	327156
20842	30748	0	applied	\N	\N	\N	\N	159899	159899	327163
20842	30749	1	applied	\N	\N	\N	\N	159900	159900	327164
20842	30750	2	applied	\N	\N	\N	\N	159901	159901	327165
20844	30753	0	applied	\N	\N	\N	\N	159904	159904	327168
20860	30801	0	applied	\N	\N	\N	\N	159981	159981	327245
20860	30802	1	applied	\N	\N	\N	\N	159982	159982	327246
20860	30803	2	applied	\N	\N	\N	\N	159983	159983	327247
20866	30817	0	applied	\N	\N	\N	\N	160004	160004	327267
20868	30819	0	applied	\N	\N	\N	\N	160112	160112	327373
20868	30820	1	applied	\N	\N	\N	\N	160113	160113	327374
20868	30821	2	applied	\N	\N	\N	\N	160114	160114	327375
20873	30826	0	applied	\N	\N	\N	\N	160127	160127	327388
20873	30827	1	applied	\N	\N	\N	\N	160128	160128	327389
20875	30833	2	applied	\N	\N	\N	\N	160134	160134	327395
20875	30834	3	applied	\N	\N	\N	\N	160135	160135	327396
20876	30831	0	applied	\N	\N	\N	\N	160136	160136	327397
20876	30832	1	applied	\N	\N	\N	\N	160137	160137	327398
20876	30833	2	applied	\N	\N	\N	\N	160138	160138	327399
20876	30834	3	applied	\N	\N	\N	\N	160139	160139	327400
20880	30770	0	applied	\N	\N	\N	\N	160246	160246	327505
20880	30780	1	applied	\N	\N	\N	\N	160247	160247	327506
20880	30786	2	applied	\N	\N	\N	\N	160248	160248	327507
20880	30787	3	applied	\N	\N	\N	\N	160249	160249	327508
20880	30807	4	applied	\N	\N	\N	\N	160250	160250	327509
20880	30751	6	applied	\N	\N	\N	\N	160252	160252	327511
20880	30753	7	applied	\N	\N	\N	\N	160253	160253	327512
20880	30755	8	applied	\N	\N	\N	\N	160254	160254	327513
20880	30759	9	applied	\N	\N	\N	\N	160255	160255	327514
20880	30760	10	applied	\N	\N	\N	\N	160256	160256	327515
20880	30763	11	applied	\N	\N	\N	\N	160257	160257	327516
20880	30766	12	applied	\N	\N	\N	\N	160258	160258	327517
20880	30767	13	applied	\N	\N	\N	\N	160259	160259	327518
20880	30805	14	applied	\N	\N	\N	\N	160260	160260	160260
20880	30771	15	applied	\N	\N	\N	\N	160261	160261	327519
20880	30772	16	applied	\N	\N	\N	\N	160262	160262	327520
20880	30773	17	applied	\N	\N	\N	\N	160263	160263	327521
20880	30774	18	applied	\N	\N	\N	\N	160264	160264	327522
20880	30781	19	applied	\N	\N	\N	\N	160265	160265	327523
20880	30784	20	applied	\N	\N	\N	\N	160266	160266	327524
20880	30788	22	applied	\N	\N	\N	\N	160267	160267	327525
20880	30790	24	applied	\N	\N	\N	\N	160269	160269	327527
20880	30791	25	applied	\N	\N	\N	\N	160270	160270	327528
20880	30801	26	applied	\N	\N	\N	\N	160271	160271	327529
20880	30804	27	applied	\N	\N	\N	\N	160272	160272	327530
20880	30808	28	applied	\N	\N	\N	\N	160273	160273	327531
20880	30809	29	applied	\N	\N	\N	\N	160274	160274	327532
20880	30812	30	applied	\N	\N	\N	\N	160275	160275	327533
20880	30813	31	applied	\N	\N	\N	\N	160276	160276	327534
20880	30817	32	applied	\N	\N	\N	\N	160277	160277	327535
20880	30819	33	applied	\N	\N	\N	\N	160278	160278	327536
20880	30822	34	applied	\N	\N	\N	\N	160279	160279	327537
20880	30823	35	applied	\N	\N	\N	\N	160280	160280	327538
20880	30826	36	applied	\N	\N	\N	\N	160281	160281	327539
20880	30828	37	applied	\N	\N	\N	\N	160282	160282	327540
20880	30831	38	applied	\N	\N	\N	\N	160283	160283	327541
20880	30832	39	applied	\N	\N	\N	\N	160284	160284	327542
20880	30838	41	applied	\N	\N	\N	\N	160286	160286	327544
20880	30752	42	applied	\N	\N	\N	\N	160287	160287	327545
20880	30756	43	applied	\N	\N	\N	\N	160288	160288	327546
20880	30764	44	applied	\N	\N	\N	\N	160289	160289	327547
20883	30841	0	applied	\N	\N	\N	\N	160340	160340	327598
20883	30842	1	applied	\N	\N	\N	\N	160341	160341	327599
20883	30843	2	applied	\N	\N	\N	\N	160342	160342	327600
20883	30844	3	applied	\N	\N	\N	\N	160343	160343	327601
20887	30845	0	applied	\N	\N	\N	\N	160350	160350	327608
20887	30846	1	applied	\N	\N	\N	\N	160351	160351	327609
20894	30851	0	applied	\N	\N	\N	\N	160363	160363	327621
20894	30852	1	applied	\N	\N	\N	\N	160364	160364	327622
20894	30853	2	applied	\N	\N	\N	\N	160365	160365	327623
20896	30856	0	applied	\N	\N	\N	\N	160368	160368	327626
20786	30561	31	applied	\N	\N	\N	\N	159579	159579	326849
20786	30562	32	applied	\N	\N	\N	\N	159580	159580	326850
20813	30716	0	applied	\N	\N	\N	\N	159668	159668	326937
20813	30717	1	applied	\N	\N	\N	\N	159669	159669	326938
20813	30718	2	applied	\N	\N	\N	\N	159670	159670	326939
20814	30719	0	applied	\N	\N	\N	\N	159671	159671	326940
20814	30720	1	applied	\N	\N	\N	\N	159672	159672	326941
20823	30727	0	applied	\N	\N	\N	\N	159810	159810	327078
20827	30730	0	applied	\N	\N	\N	\N	159819	159819	327087
20827	30731	1	applied	\N	\N	\N	\N	159820	159820	327088
20830	30734	0	applied	\N	\N	\N	\N	159826	159826	327094
20830	30735	1	applied	\N	\N	\N	\N	159827	159827	327095
20830	30736	2	applied	\N	\N	\N	\N	159828	159828	327096
20834	30737	0	applied	\N	\N	\N	\N	159838	159838	327105
20834	30739	2	applied	\N	\N	\N	\N	159840	159840	159840
20834	30740	3	applied	\N	\N	\N	\N	159841	159841	327107
20836	30616	0	applied	\N	\N	\N	\N	159844	159844	327110
20836	30702	1	applied	\N	\N	\N	\N	159845	159845	327111
20836	30703	2	applied	\N	\N	\N	\N	159846	159846	327112
20836	30704	3	applied	\N	\N	\N	\N	159847	159847	327113
20836	30705	4	applied	\N	\N	\N	\N	159848	159848	327114
20836	30706	5	applied	\N	\N	\N	\N	159849	159849	159849
20836	30652	6	applied	\N	\N	\N	\N	159850	159850	327115
20836	30737	7	applied	\N	\N	\N	\N	159851	159851	327116
20836	30641	8	applied	\N	\N	\N	\N	159852	159852	327117
20836	30651	9	applied	\N	\N	\N	\N	159853	159853	327118
20836	30659	10	applied	\N	\N	\N	\N	159854	159854	327119
20836	30609	11	applied	\N	\N	\N	\N	159855	159855	327120
20836	30610	12	applied	\N	\N	\N	\N	159856	159856	327121
20836	30611	13	applied	\N	\N	\N	\N	159857	159857	327122
20836	30722	15	applied	\N	\N	\N	\N	159859	159859	327124
20836	30618	16	applied	\N	\N	\N	\N	159860	159860	327125
20836	30619	17	applied	\N	\N	\N	\N	159861	159861	327126
20836	30620	18	applied	\N	\N	\N	\N	159862	159862	327127
20836	30621	19	applied	\N	\N	\N	\N	159863	159863	327128
20836	30622	20	applied	\N	\N	\N	\N	159864	159864	327129
20836	30628	21	applied	\N	\N	\N	\N	159865	159865	327130
20836	30673	22	applied	\N	\N	\N	\N	159866	159866	327131
20836	30674	23	applied	\N	\N	\N	\N	159867	159867	327132
20836	30675	24	applied	\N	\N	\N	\N	159868	159868	327133
20836	30676	25	applied	\N	\N	\N	\N	159869	159869	327134
20836	30679	26	applied	\N	\N	\N	\N	159870	159870	327135
20836	30630	27	applied	\N	\N	\N	\N	159871	159871	327136
20836	30631	28	applied	\N	\N	\N	\N	159872	159872	327137
20836	30633	29	applied	\N	\N	\N	\N	159873	159873	327138
20836	30660	30	applied	\N	\N	\N	\N	159874	159874	327139
20836	30680	32	applied	\N	\N	\N	\N	159876	159876	327141
20836	30681	33	applied	\N	\N	\N	\N	159877	159877	327142
20836	30662	34	applied	\N	\N	\N	\N	159878	159878	327143
20836	30666	35	applied	\N	\N	\N	\N	159879	159879	327144
20836	30739	36	applied	\N	\N	\N	\N	159880	159880	159880
20840	30748	0	applied	\N	\N	\N	\N	159893	159893	327157
20840	30749	1	applied	\N	\N	\N	\N	159894	159894	327158
20840	30750	2	applied	\N	\N	\N	\N	159895	159895	327159
20845	30753	0	applied	\N	\N	\N	\N	159905	159905	327169
20845	30754	1	applied	\N	\N	\N	\N	159906	159906	327170
20849	30758	0	applied	\N	\N	\N	\N	159917	159917	327181
20849	30759	1	applied	\N	\N	\N	\N	159918	159918	327182
20849	30760	2	applied	\N	\N	\N	\N	159919	159919	327183
20849	30761	3	applied	\N	\N	\N	\N	159920	159920	327184
20849	30762	4	applied	\N	\N	\N	\N	159921	159921	327185
20852	30766	0	applied	\N	\N	\N	\N	159928	159928	327192
20852	30768	2	applied	\N	\N	\N	\N	159930	159930	327194
20852	30769	3	applied	\N	\N	\N	\N	159931	159931	327195
20853	30770	0	applied	\N	\N	\N	\N	159932	159932	327196
20853	30771	1	applied	\N	\N	\N	\N	159933	159933	327197
20853	30772	2	applied	\N	\N	\N	\N	159934	159934	327198
20853	30773	3	applied	\N	\N	\N	\N	159935	159935	327199
20896	30857	1	applied	\N	\N	\N	\N	160369	160369	327627
20902	30861	0	applied	\N	\N	\N	\N	160382	160382	327640
20902	30862	1	applied	\N	\N	\N	\N	160383	160383	327641
20905	30865	0	applied	\N	\N	\N	\N	160388	160388	327646
20905	30866	1	applied	\N	\N	\N	\N	160389	160389	327647
20905	30867	2	applied	\N	\N	\N	\N	160390	160390	327648
20905	30868	3	applied	\N	\N	\N	\N	160391	160391	327649
20905	30869	4	applied	\N	\N	\N	\N	160392	160392	327650
20911	30886	0	applied	\N	\N	\N	\N	160419	160419	327677
20911	30887	1	applied	\N	\N	\N	\N	160420	160420	327678
20914	30889	1	applied	\N	\N	\N	\N	160551	160551	327807
20914	30890	2	applied	\N	\N	\N	\N	160552	160552	327808
20914	30891	3	applied	\N	\N	\N	\N	160553	160553	327809
20916	30892	0	applied	\N	\N	\N	\N	160558	160558	327814
20916	30893	1	applied	\N	\N	\N	\N	160559	160559	327815
20916	30894	2	applied	\N	\N	\N	\N	160560	160560	327816
20916	30895	3	applied	\N	\N	\N	\N	160561	160561	327817
20916	30896	4	applied	\N	\N	\N	\N	160562	160562	327818
20918	30897	0	applied	\N	\N	\N	\N	160568	160568	327824
20918	30898	1	applied	\N	\N	\N	\N	160569	160569	327825
20923	30905	0	applied	\N	\N	\N	\N	160580	160580	327836
20923	30906	1	applied	\N	\N	\N	\N	160581	160581	327837
20923	30907	2	applied	\N	\N	\N	\N	160582	160582	327838
20928	30918	0	applied	\N	\N	\N	\N	160595	160595	327851
20928	30919	1	applied	\N	\N	\N	\N	160596	160596	327852
20928	30920	2	applied	\N	\N	\N	\N	160597	160597	327853
20937	30933	0	applied	\N	\N	\N	\N	160647	160647	327903
20937	30934	1	applied	\N	\N	\N	\N	160648	160648	327904
20937	30936	3	applied	\N	\N	\N	\N	160650	160650	327906
20937	30937	4	applied	\N	\N	\N	\N	160651	160651	327907
20937	30938	5	applied	\N	\N	\N	\N	160652	160652	327908
20937	30939	6	applied	\N	\N	\N	\N	160653	160653	327909
20937	30940	7	applied	\N	\N	\N	\N	160654	160654	327910
20937	30941	8	applied	\N	\N	\N	\N	160655	160655	327911
20938	30942	0	applied	\N	\N	1000000000	\N	160656	160656	327912
20938	30943	1	applied	\N	\N	\N	\N	160657	160657	327913
20938	30944	2	applied	\N	\N	\N	\N	160658	160658	327914
20941	30955	0	applied	\N	\N	\N	\N	160669	160669	327925
20941	30956	1	applied	\N	\N	\N	\N	160670	160670	327926
20944	30967	0	applied	\N	\N	\N	\N	160681	160681	327937
20944	30968	1	applied	\N	\N	\N	\N	160682	160682	327938
20944	30969	2	applied	\N	\N	\N	\N	160683	160683	327939
20944	30970	3	applied	\N	\N	\N	\N	160684	160684	327940
20808	30713	2	applied	\N	\N	\N	\N	159659	159659	326928
20809	30715	1	applied	\N	\N	\N	\N	159661	159661	326930
20818	30670	94	applied	\N	\N	\N	\N	159773	159773	327041
20818	30672	95	applied	\N	\N	\N	\N	159774	159774	327042
20818	30678	96	applied	\N	\N	\N	\N	159775	159775	327043
20818	30685	98	applied	\N	\N	\N	\N	159776	159776	327044
20818	30686	99	applied	\N	\N	\N	\N	159777	159777	327045
20818	30688	100	applied	\N	\N	\N	\N	159778	159778	327046
20818	30691	101	applied	\N	\N	\N	\N	159779	159779	327047
20818	30693	102	applied	\N	\N	\N	\N	159780	159780	327048
20818	30694	103	applied	\N	\N	\N	\N	159781	159781	327049
20818	30695	104	applied	\N	\N	\N	\N	159782	159782	327050
20818	30700	105	applied	\N	\N	\N	\N	159783	159783	327051
20818	30707	106	applied	\N	\N	\N	\N	159784	159784	327052
20818	30709	107	applied	\N	\N	\N	\N	159785	159785	327053
20818	30712	108	applied	\N	\N	\N	\N	159786	159786	327054
20818	30716	110	applied	\N	\N	\N	\N	159788	159788	327056
20818	30719	111	applied	\N	\N	\N	\N	159789	159789	327057
20818	30564	112	applied	\N	\N	\N	\N	159790	159790	327058
20818	30568	113	applied	\N	\N	\N	\N	159791	159791	327059
20818	30570	114	applied	\N	\N	\N	\N	159792	159792	327060
20818	30571	115	applied	\N	\N	\N	\N	159793	159793	327061
20818	30604	116	applied	\N	\N	\N	\N	159794	159794	327062
20818	30662	117	applied	\N	\N	\N	\N	159795	159795	327063
20818	30666	118	applied	\N	\N	\N	\N	159796	159796	327064
20818	30531	119	applied	\N	\N	\N	\N	159797	159797	327065
20818	30549	120	applied	\N	\N	\N	\N	159798	159798	327066
20818	30566	121	applied	\N	\N	\N	\N	159799	159799	327067
20818	30585	122	applied	\N	\N	1000000000	\N	159800	159800	327068
20818	30586	123	applied	\N	\N	\N	\N	159801	159801	327069
20818	30605	124	applied	\N	\N	\N	\N	159802	159802	327070
20818	30627	125	applied	\N	\N	\N	\N	159803	159803	327071
20820	30724	1	applied	\N	\N	\N	\N	159805	159805	327073
20821	30725	0	applied	\N	\N	\N	\N	159806	159806	327074
20821	30726	1	applied	\N	\N	\N	\N	159807	159807	327075
20825	30728	0	applied	\N	\N	\N	\N	159814	159814	327082
20825	30727	1	applied	\N	\N	\N	\N	159815	159815	327083
20838	30743	0	applied	\N	\N	\N	\N	159883	159883	327147
20838	30744	1	applied	\N	\N	\N	\N	159884	159884	327148
20838	30745	2	applied	\N	\N	\N	\N	159885	159885	327149
20838	30746	3	applied	\N	\N	\N	\N	159886	159886	327150
20838	30747	4	applied	\N	\N	\N	\N	159887	159887	327151
20846	30753	0	applied	\N	\N	\N	\N	159907	159907	327171
20846	30754	1	applied	\N	\N	\N	\N	159908	159908	327172
20847	30755	0	applied	\N	\N	\N	\N	159909	159909	327173
20847	30756	1	applied	\N	\N	\N	\N	159910	159910	327174
20847	30754	2	applied	\N	\N	\N	\N	159911	159911	327175
20847	30757	3	applied	\N	\N	\N	\N	159912	159912	327176
20850	30764	2	applied	\N	\N	\N	\N	159923	159923	327187
20850	30765	3	applied	\N	\N	\N	\N	159924	159924	327188
20853	30774	4	applied	\N	\N	\N	\N	159936	159936	327200
20853	30775	5	applied	\N	\N	\N	\N	159937	159937	327201
20853	30776	6	applied	\N	\N	\N	\N	159938	159938	327202
20853	30777	7	applied	\N	\N	\N	\N	159939	159939	327203
20853	30778	8	applied	\N	\N	\N	\N	159940	159940	327204
20853	30779	9	applied	\N	\N	\N	\N	159941	159941	327205
20854	30770	0	applied	\N	\N	\N	\N	159942	159942	327206
20854	30771	1	applied	\N	\N	\N	\N	159943	159943	327207
20854	30772	2	applied	\N	\N	\N	\N	159944	159944	327208
20854	30773	3	applied	\N	\N	\N	\N	159945	159945	327209
20854	30774	4	applied	\N	\N	\N	\N	159946	159946	327210
20854	30775	5	applied	\N	\N	\N	\N	159947	159947	327211
20854	30776	6	applied	\N	\N	\N	\N	159948	159948	327212
20854	30777	7	applied	\N	\N	\N	\N	159949	159949	327213
20854	30779	9	applied	\N	\N	\N	\N	159951	159951	327215
20855	30780	0	applied	\N	\N	\N	\N	159952	159952	327216
20855	30781	1	applied	\N	\N	\N	\N	159953	159953	327217
20855	30782	2	applied	\N	\N	\N	\N	159954	159954	327218
20855	30783	3	applied	\N	\N	\N	\N	159955	159955	327219
20856	30780	0	applied	\N	\N	\N	\N	159956	159956	327220
20856	30781	1	applied	\N	\N	\N	\N	159957	159957	327221
20856	30782	2	applied	\N	\N	\N	\N	159958	159958	327222
20856	30783	3	applied	\N	\N	\N	\N	159959	159959	327223
20858	30784	0	applied	\N	\N	\N	\N	159964	159964	327228
20858	30785	1	applied	\N	\N	\N	\N	159965	159965	327229
20859	30786	0	applied	\N	\N	\N	\N	159966	159966	327230
20859	30787	1	applied	\N	\N	\N	\N	159967	159967	327231
20859	30788	2	applied	\N	\N	\N	\N	159968	159968	327232
20861	30804	0	applied	\N	\N	\N	\N	159984	159984	327248
20861	30805	1	applied	\N	\N	\N	\N	159985	159985	159985
20864	30812	0	applied	\N	\N	\N	\N	159997	159997	327260
20864	30813	1	applied	\N	\N	\N	\N	159998	159998	327261
20864	30814	2	applied	\N	\N	\N	\N	159999	159999	327262
20864	30815	3	applied	\N	\N	\N	\N	160000	160000	327263
20864	30816	4	applied	\N	\N	\N	\N	160001	160001	327264
20869	30819	0	applied	\N	\N	\N	\N	160115	160115	327376
20869	30820	1	applied	\N	\N	\N	\N	160116	160116	327377
20869	30821	2	applied	\N	\N	\N	\N	160117	160117	327378
20871	30822	0	applied	\N	\N	\N	\N	160121	160121	327382
20871	30823	1	applied	\N	\N	\N	\N	160122	160122	327383
20871	30824	2	applied	\N	\N	\N	\N	160123	160123	327384
20871	30825	3	applied	\N	\N	\N	\N	160124	160124	327385
20878	30835	0	applied	\N	\N	\N	\N	160241	160241	327500
20878	30836	1	applied	\N	\N	\N	\N	160242	160242	327501
20878	30837	2	applied	\N	\N	\N	\N	160243	160243	327502
20899	30861	0	applied	\N	\N	\N	\N	160376	160376	327634
20903	30861	0	applied	\N	\N	\N	\N	160384	160384	327642
20903	30862	1	applied	\N	\N	\N	\N	160385	160385	327643
20906	30865	0	applied	\N	\N	\N	\N	160393	160393	327651
20906	30866	1	applied	\N	\N	\N	\N	160394	160394	327652
20906	30867	2	applied	\N	\N	\N	\N	160395	160395	327653
20906	30868	3	applied	\N	\N	\N	\N	160396	160396	327654
20906	30869	4	applied	\N	\N	\N	\N	160397	160397	327655
20908	30870	0	applied	\N	\N	\N	\N	160403	160403	327661
20908	30871	1	applied	\N	\N	\N	\N	160404	160404	327662
20912	30770	0	applied	\N	\N	\N	\N	160421	160421	327679
20912	30780	1	applied	\N	\N	\N	\N	160422	160422	327680
20912	30786	2	applied	\N	\N	\N	\N	160423	160423	327681
20912	30787	3	applied	\N	\N	\N	\N	160424	160424	327682
20912	30807	4	applied	\N	\N	\N	\N	160425	160425	327683
20912	30728	5	applied	\N	\N	\N	\N	160426	160426	327684
20912	30737	6	applied	\N	\N	\N	\N	160427	160427	327685
20818	30667	93	applied	\N	\N	\N	\N	159772	159772	327040
20859	30793	7	applied	\N	\N	\N	\N	159973	159973	327237
20859	30794	8	applied	\N	\N	\N	\N	159974	159974	327238
20859	30795	9	applied	\N	\N	\N	\N	159975	159975	327239
20859	30796	10	applied	\N	\N	\N	\N	159976	159976	327240
20859	30797	11	applied	\N	\N	\N	\N	159977	159977	327241
20859	30798	12	applied	\N	\N	\N	\N	159978	159978	327242
20859	30799	13	applied	\N	\N	\N	\N	159979	159979	327243
20859	30800	14	applied	\N	\N	\N	\N	159980	159980	327244
20862	30807	0	applied	\N	\N	\N	\N	159987	159987	327250
20862	30808	1	applied	\N	\N	\N	\N	159988	159988	327251
20862	30809	2	applied	\N	\N	\N	\N	159989	159989	327252
20862	30810	3	applied	\N	\N	\N	\N	159990	159990	327253
20862	30811	4	applied	\N	\N	\N	\N	159991	159991	327254
20867	30770	0	applied	\N	\N	\N	\N	160006	160006	327269
20867	30780	1	applied	\N	\N	\N	\N	160007	160007	327270
20867	30786	2	applied	\N	\N	\N	\N	160008	160008	327271
20867	30807	4	applied	\N	\N	\N	\N	160010	160010	327273
20867	30737	5	applied	\N	\N	\N	\N	160011	160011	327274
20867	30744	6	applied	\N	\N	\N	\N	160012	160012	327275
20867	30745	7	applied	\N	\N	\N	\N	160013	160013	327276
20867	30748	8	applied	\N	\N	\N	\N	160014	160014	327277
20867	30758	9	applied	\N	\N	\N	\N	160015	160015	327278
20867	30712	10	applied	\N	\N	\N	\N	160016	160016	327279
20867	30714	11	applied	\N	\N	\N	\N	160017	160017	327280
20867	30716	12	applied	\N	\N	\N	\N	160018	160018	327281
20867	30719	13	applied	\N	\N	\N	\N	160019	160019	327282
20867	30723	14	applied	\N	\N	\N	\N	160020	160020	327283
20867	30725	15	applied	\N	\N	\N	\N	160021	160021	327284
20867	30728	16	applied	\N	\N	\N	\N	160022	160022	327285
20867	30730	17	applied	\N	\N	\N	\N	160023	160023	327286
20867	30732	18	applied	\N	\N	\N	\N	160024	160024	327287
20867	30734	19	applied	\N	\N	\N	\N	160025	160025	327288
20867	30741	21	applied	\N	\N	\N	\N	160027	160027	327290
20867	30743	22	applied	\N	\N	\N	\N	160028	160028	327291
20867	30749	23	applied	\N	\N	\N	\N	160029	160029	327292
20867	30751	24	applied	\N	\N	\N	\N	160030	160030	327293
20867	30753	25	applied	\N	\N	\N	\N	160031	160031	327294
20867	30755	26	applied	\N	\N	\N	\N	160032	160032	327295
20867	30759	27	applied	\N	\N	\N	\N	160033	160033	327296
20867	30760	28	applied	\N	\N	\N	\N	160034	160034	327297
20867	30763	29	applied	\N	\N	\N	\N	160035	160035	327298
20867	30766	30	applied	\N	\N	\N	\N	160036	160036	327299
20867	30767	31	applied	\N	\N	\N	\N	160037	160037	327300
20867	30805	32	applied	\N	\N	\N	\N	160038	160038	160038
20867	30771	33	applied	\N	\N	\N	\N	160039	160039	327301
20867	30772	34	applied	\N	\N	\N	\N	160040	160040	327302
20867	30773	35	applied	\N	\N	\N	\N	160041	160041	327303
20867	30774	36	applied	\N	\N	\N	\N	160042	160042	327304
20867	30784	38	applied	\N	\N	\N	\N	160044	160044	327306
20867	30788	39	applied	\N	\N	\N	\N	160045	160045	327307
20867	30789	40	applied	\N	\N	\N	\N	160046	160046	327308
20867	30790	41	applied	\N	\N	\N	\N	160047	160047	327309
20867	30791	42	applied	\N	\N	\N	\N	160048	160048	327310
20867	30801	43	applied	\N	\N	\N	\N	160049	160049	327311
20867	30804	44	applied	\N	\N	\N	\N	160050	160050	327312
20867	30808	45	applied	\N	\N	\N	\N	160051	160051	327313
20867	30809	46	applied	\N	\N	\N	\N	160052	160052	327314
20867	30812	47	applied	\N	\N	\N	\N	160053	160053	327315
20867	30813	48	applied	\N	\N	\N	\N	160054	160054	327316
20867	30817	49	applied	\N	\N	\N	\N	160055	160055	327317
20867	30739	50	applied	\N	\N	\N	\N	160056	160056	160056
20867	30717	51	applied	\N	\N	\N	\N	160057	160057	327318
20867	30711	52	applied	\N	\N	\N	\N	160058	160058	327319
20867	30793	53	applied	\N	\N	\N	\N	160059	160059	327320
20867	30713	55	applied	\N	\N	\N	\N	160061	160061	327322
20867	30715	56	applied	\N	\N	\N	\N	160062	160062	327323
20867	30795	57	applied	\N	\N	\N	\N	160063	160063	327324
20867	30796	58	applied	\N	\N	\N	\N	160064	160064	327325
20867	30727	59	applied	\N	\N	\N	\N	160065	160065	327326
20867	30736	60	applied	\N	\N	\N	\N	160066	160066	327327
20867	30747	61	applied	\N	\N	\N	\N	160067	160067	327328
20867	30756	62	applied	\N	\N	\N	\N	160068	160068	327329
20867	30764	63	applied	\N	\N	\N	\N	160069	160069	327330
20867	30775	64	applied	\N	\N	\N	\N	160070	160070	327331
20867	30782	65	applied	\N	\N	\N	\N	160071	160071	327332
20867	30792	66	applied	\N	\N	\N	\N	160072	160072	327333
20867	30803	67	applied	\N	\N	\N	\N	160073	160073	327334
20867	30718	68	applied	\N	\N	\N	\N	160074	160074	327335
20867	30720	69	applied	\N	\N	\N	\N	160075	160075	327336
20867	30724	70	applied	\N	\N	\N	\N	160076	160076	327337
20867	30729	72	applied	\N	\N	\N	\N	160078	160078	327339
20867	30816	73	applied	\N	\N	\N	\N	160079	160079	327340
20867	30731	74	applied	\N	\N	\N	\N	160080	160080	327341
20867	30733	75	applied	\N	\N	\N	\N	160081	160081	327342
20867	30735	76	applied	\N	\N	\N	\N	160082	160082	327343
20867	30740	77	applied	\N	\N	\N	\N	160083	160083	327344
20867	30742	78	applied	\N	\N	\N	\N	160084	160084	327345
20867	30746	79	applied	\N	\N	\N	\N	160085	160085	327346
20867	30750	80	applied	\N	\N	\N	\N	160086	160086	327347
20867	30752	81	applied	\N	\N	\N	\N	160087	160087	327348
20867	30754	82	applied	\N	\N	\N	\N	160088	160088	327349
20867	30757	83	applied	\N	\N	\N	\N	160089	160089	327350
20867	30761	84	applied	\N	\N	\N	\N	160090	160090	327351
20867	30762	85	applied	\N	\N	\N	\N	160091	160091	327352
20867	30765	86	applied	\N	\N	\N	\N	160092	160092	327353
20867	30768	88	applied	\N	\N	\N	\N	160093	160093	327354
20867	30776	90	applied	\N	\N	\N	\N	160095	160095	327356
20867	30777	91	applied	\N	\N	\N	\N	160096	160096	327357
20867	30778	92	applied	\N	\N	\N	\N	160097	160097	327358
20867	30779	93	applied	\N	\N	\N	\N	160098	160098	327359
20867	30783	94	applied	\N	\N	\N	\N	160099	160099	327360
20867	30785	95	applied	\N	\N	\N	\N	160100	160100	327361
20867	30797	96	applied	\N	\N	\N	\N	160101	160101	327362
20867	30798	97	applied	\N	\N	\N	\N	160102	160102	327363
20867	30799	98	applied	\N	\N	\N	\N	160103	160103	327364
20867	30800	99	applied	\N	\N	\N	\N	160104	160104	327365
20867	30802	100	applied	\N	\N	\N	\N	160105	160105	327366
20867	30806	101	applied	\N	\N	\N	\N	160106	160106	327367
20867	30810	102	applied	\N	\N	\N	\N	160107	160107	327368
20867	30811	103	applied	\N	\N	\N	\N	160108	160108	327369
20859	30790	4	applied	\N	\N	\N	\N	159970	159970	327234
20859	30791	5	applied	\N	\N	\N	\N	159971	159971	327235
20874	30829	1	applied	\N	\N	\N	\N	160130	160130	327391
20874	30830	2	applied	\N	\N	\N	\N	160131	160131	327392
20877	30770	0	applied	\N	\N	\N	\N	160140	160140	327401
20877	30780	1	applied	\N	\N	\N	\N	160141	160141	327402
20877	30786	2	applied	\N	\N	\N	\N	160142	160142	327403
20877	30787	3	applied	\N	\N	\N	\N	160143	160143	327404
20877	30807	4	applied	\N	\N	\N	\N	160144	160144	327405
20877	30737	5	applied	\N	\N	\N	\N	160145	160145	327406
20877	30744	6	applied	\N	\N	\N	\N	160146	160146	327407
20877	30745	7	applied	\N	\N	\N	\N	160147	160147	327408
20877	30748	8	applied	\N	\N	\N	\N	160148	160148	327409
20877	30758	9	applied	\N	\N	\N	\N	160149	160149	327410
20877	30734	10	applied	\N	\N	\N	\N	160150	160150	327411
20877	30738	11	applied	\N	\N	\N	\N	160151	160151	327412
20877	30741	12	applied	\N	\N	\N	\N	160152	160152	327413
20877	30743	13	applied	\N	\N	\N	\N	160153	160153	327414
20877	30751	15	applied	\N	\N	\N	\N	160155	160155	327416
20877	30753	16	applied	\N	\N	\N	\N	160156	160156	327417
20877	30755	17	applied	\N	\N	\N	\N	160157	160157	327418
20877	30759	18	applied	\N	\N	\N	\N	160158	160158	327419
20877	30760	19	applied	\N	\N	\N	\N	160159	160159	327420
20877	30763	20	applied	\N	\N	\N	\N	160160	160160	327421
20877	30766	21	applied	\N	\N	\N	\N	160161	160161	327422
20877	30767	22	applied	\N	\N	\N	\N	160162	160162	327423
20877	30805	23	applied	\N	\N	\N	\N	160163	160163	160163
20877	30771	24	applied	\N	\N	\N	\N	160164	160164	327424
20877	30772	25	applied	\N	\N	\N	\N	160165	160165	327425
20877	30773	26	applied	\N	\N	\N	\N	160166	160166	327426
20877	30774	27	applied	\N	\N	\N	\N	160167	160167	327427
20877	30781	28	applied	\N	\N	\N	\N	160168	160168	327428
20877	30784	29	applied	\N	\N	\N	\N	160169	160169	327429
20877	30788	30	applied	\N	\N	\N	\N	160170	160170	327430
20877	30790	32	applied	\N	\N	\N	\N	160172	160172	327432
20877	30791	33	applied	\N	\N	\N	\N	160173	160173	327433
20877	30801	34	applied	\N	\N	\N	\N	160174	160174	327434
20877	30804	35	applied	\N	\N	\N	\N	160175	160175	327435
20877	30808	36	applied	\N	\N	\N	\N	160176	160176	327436
20877	30809	37	applied	\N	\N	\N	\N	160177	160177	327437
20877	30812	38	applied	\N	\N	\N	\N	160178	160178	327438
20877	30813	39	applied	\N	\N	\N	\N	160179	160179	327439
20877	30817	40	applied	\N	\N	\N	\N	160180	160180	327440
20877	30819	41	applied	\N	\N	\N	\N	160181	160181	327441
20877	30822	42	applied	\N	\N	\N	\N	160182	160182	327442
20877	30823	43	applied	\N	\N	\N	\N	160183	160183	327443
20877	30826	44	applied	\N	\N	\N	\N	160184	160184	327444
20877	30828	45	applied	\N	\N	\N	\N	160185	160185	327445
20877	30831	46	applied	\N	\N	\N	\N	160186	160186	327446
20877	30832	47	applied	\N	\N	\N	\N	160187	160187	327447
20877	30735	50	applied	\N	\N	\N	\N	160189	160189	327448
20877	30740	51	applied	\N	\N	\N	\N	160190	160190	327449
20877	30736	52	applied	\N	\N	\N	\N	160191	160191	327450
20877	30747	53	applied	\N	\N	\N	\N	160192	160192	327451
20877	30756	54	applied	\N	\N	\N	\N	160193	160193	327452
20877	30764	55	applied	\N	\N	\N	\N	160194	160194	327453
20877	30775	56	applied	\N	\N	\N	\N	160195	160195	327454
20877	30782	57	applied	\N	\N	\N	\N	160196	160196	327455
20877	30792	58	applied	\N	\N	\N	\N	160197	160197	327456
20877	30793	59	applied	\N	\N	\N	\N	160198	160198	327457
20877	30794	60	applied	\N	\N	\N	\N	160199	160199	327458
20877	30795	61	applied	\N	\N	\N	\N	160200	160200	327459
20877	30796	62	applied	\N	\N	\N	\N	160201	160201	327460
20877	30803	63	applied	\N	\N	\N	\N	160202	160202	327461
20877	30742	64	applied	\N	\N	\N	\N	160203	160203	327462
20877	30746	65	applied	\N	\N	\N	\N	160204	160204	327463
20877	30820	67	applied	\N	\N	\N	\N	160206	160206	327465
20877	30829	68	applied	\N	\N	\N	\N	160207	160207	327466
20877	30750	69	applied	\N	\N	\N	\N	160208	160208	327467
20877	30752	70	applied	\N	\N	\N	\N	160209	160209	327468
20877	30754	71	applied	\N	\N	\N	\N	160210	160210	327469
20877	30757	72	applied	\N	\N	\N	\N	160211	160211	327470
20877	30761	73	applied	\N	\N	\N	\N	160212	160212	327471
20877	30762	74	applied	\N	\N	\N	\N	160213	160213	327472
20877	30765	75	applied	\N	\N	\N	\N	160214	160214	327473
20877	30768	76	applied	\N	\N	\N	\N	160215	160215	327474
20877	30769	77	applied	\N	\N	\N	\N	160216	160216	327475
20877	30776	78	applied	\N	\N	\N	\N	160217	160217	327476
20877	30777	79	applied	\N	\N	\N	\N	160218	160218	327477
20877	30778	80	applied	\N	\N	\N	\N	160219	160219	327478
20877	30779	81	applied	\N	\N	\N	\N	160220	160220	327479
20877	30783	82	applied	\N	\N	\N	\N	160221	160221	327480
20877	30797	84	applied	\N	\N	\N	\N	160223	160223	327482
20877	30798	85	applied	\N	\N	\N	\N	160224	160224	327483
20877	30799	86	applied	\N	\N	\N	\N	160225	160225	327484
20877	30800	87	applied	\N	\N	\N	\N	160226	160226	327485
20877	30802	88	applied	\N	\N	\N	\N	160227	160227	327486
20877	30806	89	applied	\N	\N	\N	\N	160228	160228	327487
20877	30810	90	applied	\N	\N	\N	\N	160229	160229	327488
20877	30811	91	applied	\N	\N	\N	\N	160230	160230	327489
20877	30814	92	applied	\N	\N	\N	\N	160231	160231	327490
20877	30815	93	applied	\N	\N	\N	\N	160232	160232	327491
20877	30818	94	applied	\N	\N	\N	\N	160233	160233	327492
20877	30821	95	applied	\N	\N	\N	\N	160234	160234	327493
20877	30824	96	applied	\N	\N	\N	\N	160235	160235	327494
20877	30825	97	applied	\N	\N	\N	\N	160236	160236	327495
20877	30827	98	applied	\N	\N	\N	\N	160237	160237	327496
20877	30830	99	applied	\N	\N	\N	\N	160238	160238	327497
20877	30834	101	applied	\N	\N	\N	\N	160240	160240	327499
20879	30838	0	applied	\N	\N	\N	\N	160244	160244	327503
20879	30839	1	applied	\N	\N	\N	\N	160245	160245	327504
20881	30840	0	applied	\N	\N	\N	\N	160335	160335	327593
20884	30841	0	applied	\N	\N	\N	\N	160344	160344	327602
20884	30842	1	applied	\N	\N	\N	\N	160345	160345	327603
20884	30843	2	applied	\N	\N	\N	\N	160346	160346	327604
20884	30844	3	applied	\N	\N	\N	\N	160347	160347	327605
20888	30847	0	applied	\N	\N	\N	\N	160352	160352	327610
20888	30848	1	applied	\N	\N	\N	\N	160353	160353	327611
20892	30849	0	applied	\N	\N	\N	\N	160358	160358	327616
20892	30850	1	applied	\N	\N	\N	\N	160359	160359	327617
20897	30858	0	applied	\N	\N	\N	\N	160370	160370	327628
20897	30859	1	applied	\N	\N	\N	\N	160371	160371	327629
20867	30815	105	applied	\N	\N	\N	\N	160110	160110	327371
20867	30818	106	applied	\N	\N	\N	\N	160111	160111	327372
20880	30794	49	applied	\N	\N	\N	\N	160294	160294	327552
20880	30795	50	applied	\N	\N	\N	\N	160295	160295	327553
20880	30796	51	applied	\N	\N	\N	\N	160296	160296	327554
20880	30803	52	applied	\N	\N	\N	\N	160297	160297	327555
20880	30754	53	applied	\N	\N	\N	\N	160298	160298	327556
20880	30757	54	applied	\N	\N	\N	\N	160299	160299	327557
20880	30761	55	applied	\N	\N	\N	\N	160300	160300	327558
20880	30762	56	applied	\N	\N	\N	\N	160301	160301	327559
20880	30765	57	applied	\N	\N	\N	\N	160302	160302	327560
20880	30816	58	applied	\N	\N	\N	\N	160303	160303	327561
20880	30820	59	applied	\N	\N	\N	\N	160304	160304	327562
20880	30829	60	applied	\N	\N	\N	\N	160305	160305	327563
20880	30837	61	applied	\N	\N	\N	\N	160306	160306	327564
20880	30768	62	applied	\N	\N	\N	\N	160307	160307	327565
20880	30776	64	applied	\N	\N	\N	\N	160309	160309	327567
20880	30777	65	applied	\N	\N	\N	\N	160310	160310	327568
20880	30778	66	applied	\N	\N	\N	\N	160311	160311	327569
20880	30779	67	applied	\N	\N	\N	\N	160312	160312	327570
20880	30783	68	applied	\N	\N	\N	\N	160313	160313	327571
20880	30785	69	applied	\N	\N	\N	\N	160314	160314	327572
20880	30797	70	applied	\N	\N	\N	\N	160315	160315	327573
20880	30798	71	applied	\N	\N	\N	\N	160316	160316	327574
20880	30799	72	applied	\N	\N	\N	\N	160317	160317	327575
20880	30800	73	applied	\N	\N	\N	\N	160318	160318	327576
20880	30802	74	applied	\N	\N	\N	\N	160319	160319	327577
20880	30806	75	applied	\N	\N	\N	\N	160320	160320	327578
20880	30810	76	applied	\N	\N	\N	\N	160321	160321	327579
20880	30811	77	applied	\N	\N	\N	\N	160322	160322	327580
20880	30814	78	applied	\N	\N	\N	\N	160323	160323	327581
20880	30815	79	applied	\N	\N	\N	\N	160324	160324	327582
20880	30821	81	applied	\N	\N	\N	\N	160326	160326	327584
20880	30824	82	applied	\N	\N	\N	\N	160327	160327	327585
20880	30825	83	applied	\N	\N	\N	\N	160328	160328	327586
20880	30827	84	applied	\N	\N	\N	\N	160329	160329	327587
20880	30830	85	applied	\N	\N	\N	\N	160330	160330	327588
20880	30833	86	applied	\N	\N	\N	\N	160331	160331	327589
20880	30834	87	applied	\N	\N	\N	\N	160332	160332	327590
20880	30836	88	applied	\N	\N	\N	\N	160333	160333	327591
20880	30839	89	applied	\N	\N	\N	\N	160334	160334	327592
20882	30841	0	applied	\N	\N	\N	\N	160336	160336	327594
20882	30842	1	applied	\N	\N	\N	\N	160337	160337	327595
20882	30843	2	applied	\N	\N	\N	\N	160338	160338	327596
20882	30844	3	applied	\N	\N	\N	\N	160339	160339	327597
20886	30845	0	applied	\N	\N	\N	\N	160348	160348	327606
20886	30846	1	applied	\N	\N	\N	\N	160349	160349	327607
20889	30847	0	applied	\N	\N	\N	\N	160354	160354	327612
20891	30847	0	applied	\N	\N	\N	\N	160356	160356	327614
20891	30848	1	applied	\N	\N	\N	\N	160357	160357	327615
20893	30851	0	applied	\N	\N	\N	\N	160360	160360	327618
20893	30852	1	applied	\N	\N	\N	\N	160361	160361	327619
20893	30853	2	applied	\N	\N	\N	\N	160362	160362	327620
20895	30854	0	applied	\N	\N	\N	\N	160366	160366	327624
20895	30855	1	applied	\N	\N	\N	\N	160367	160367	327625
20897	30860	2	applied	\N	\N	\N	\N	160372	160372	327630
20898	30858	0	applied	\N	\N	\N	\N	160373	160373	327631
20898	30859	1	applied	\N	\N	\N	\N	160374	160374	327632
20898	30860	2	applied	\N	\N	\N	\N	160375	160375	327633
20900	30861	0	applied	\N	\N	\N	\N	160378	160378	327636
20900	30862	1	applied	\N	\N	\N	\N	160379	160379	327637
20901	30861	0	applied	\N	\N	\N	\N	160380	160380	327638
20901	30862	1	applied	\N	\N	\N	\N	160381	160381	327639
20904	30863	0	applied	\N	\N	\N	\N	160386	160386	327644
20907	30865	0	applied	\N	\N	\N	\N	160398	160398	327656
20907	30866	1	applied	\N	\N	\N	\N	160399	160399	327657
20907	30867	2	applied	\N	\N	\N	\N	160400	160400	327658
20907	30868	3	applied	\N	\N	\N	\N	160401	160401	327659
20907	30869	4	applied	\N	\N	\N	\N	160402	160402	327660
20909	30872	0	applied	\N	\N	\N	\N	160405	160405	327663
20909	30873	1	applied	\N	\N	\N	\N	160406	160406	327664
20909	30874	2	applied	\N	\N	\N	\N	160407	160407	327665
20909	30875	3	applied	\N	\N	\N	\N	160408	160408	327666
20909	30876	4	applied	\N	\N	\N	\N	160409	160409	327667
20909	30877	5	applied	\N	\N	\N	\N	160410	160410	327668
20909	30878	6	applied	\N	\N	\N	\N	160411	160411	327669
20910	30879	0	applied	\N	\N	\N	\N	160412	160412	327670
20910	30880	1	applied	\N	\N	\N	\N	160413	160413	327671
20910	30881	2	applied	\N	\N	\N	\N	160414	160414	327672
20910	30882	3	applied	\N	\N	\N	\N	160415	160415	327673
20910	30884	5	applied	\N	\N	\N	\N	160417	160417	327675
20910	30885	6	applied	\N	\N	\N	\N	160418	160418	327676
20913	30888	0	applied	\N	\N	1000000000	\N	160546	160546	327802
20913	30889	1	applied	\N	\N	\N	\N	160547	160547	327803
20922	30903	0	applied	\N	\N	\N	\N	160578	160578	327834
20922	30904	1	applied	\N	\N	\N	\N	160579	160579	327835
20924	30908	0	applied	\N	\N	\N	\N	160583	160583	327839
20924	30909	1	applied	\N	\N	\N	\N	160584	160584	327840
20924	30910	2	applied	\N	\N	\N	\N	160585	160585	327841
20924	30911	3	applied	\N	\N	\N	\N	160586	160586	327842
20924	30912	4	applied	\N	\N	\N	\N	160587	160587	327843
20927	30916	0	applied	\N	\N	\N	\N	160593	160593	327849
20927	30917	1	applied	\N	\N	\N	\N	160594	160594	327850
20929	30921	0	applied	\N	\N	\N	\N	160598	160598	327854
20929	30922	1	applied	\N	\N	\N	\N	160599	160599	327855
20930	30923	0	applied	\N	\N	\N	\N	160600	160600	327856
20930	30925	2	applied	\N	\N	\N	\N	160602	160602	327858
20930	30926	3	applied	\N	\N	\N	\N	160603	160603	327859
20930	30927	4	applied	\N	\N	\N	\N	160604	160604	327860
20930	30928	5	applied	\N	\N	\N	\N	160605	160605	327861
20930	30929	7	applied	\N	\N	\N	\N	160606	160606	327862
20930	30930	8	applied	\N	\N	\N	\N	160607	160607	327863
20932	30931	0	applied	\N	\N	\N	\N	160616	160616	327872
20932	30932	1	applied	\N	\N	\N	\N	160617	160617	327873
20935	30933	0	applied	\N	\N	\N	\N	160629	160629	327885
20935	30934	1	applied	\N	\N	\N	\N	160630	160630	327886
20935	30935	2	applied	\N	\N	\N	\N	160631	160631	327887
20935	30936	3	applied	\N	\N	\N	\N	160632	160632	327888
20935	30937	4	applied	\N	\N	\N	\N	160633	160633	327889
20935	30938	5	applied	\N	\N	\N	\N	160634	160634	327890
20935	30939	6	applied	\N	\N	\N	\N	160635	160635	327891
20935	30940	7	applied	\N	\N	\N	\N	160636	160636	327892
20880	30793	48	applied	\N	\N	\N	\N	160293	160293	327551
20912	30730	11	applied	\N	\N	\N	\N	160432	160432	327690
20912	30732	12	applied	\N	\N	\N	\N	160433	160433	327691
20912	30734	13	applied	\N	\N	\N	\N	160434	160434	327692
20912	30738	14	applied	\N	\N	\N	\N	160435	160435	327693
20912	30741	15	applied	\N	\N	\N	\N	160436	160436	327694
20912	30743	16	applied	\N	\N	\N	\N	160437	160437	327695
20912	30749	17	applied	\N	\N	\N	\N	160438	160438	327696
20912	30751	18	applied	\N	\N	\N	\N	160439	160439	327697
20912	30753	19	applied	\N	\N	\N	\N	160440	160440	327698
20912	30755	20	applied	\N	\N	\N	\N	160441	160441	327699
20912	30759	21	applied	\N	\N	\N	\N	160442	160442	327700
20912	30760	22	applied	\N	\N	\N	\N	160443	160443	327701
20912	30763	23	applied	\N	\N	\N	\N	160444	160444	327702
20912	30766	24	applied	\N	\N	\N	\N	160445	160445	327703
20912	30842	26	applied	\N	\N	\N	\N	160447	160447	327705
20912	30805	27	applied	\N	\N	\N	\N	160448	160448	160448
20912	30771	28	applied	\N	\N	\N	\N	160449	160449	327706
20912	30772	29	applied	\N	\N	\N	\N	160450	160450	327707
20912	30773	30	applied	\N	\N	\N	\N	160451	160451	327708
20912	30774	31	applied	\N	\N	\N	\N	160452	160452	327709
20912	30781	32	applied	\N	\N	\N	\N	160453	160453	327710
20912	30784	33	applied	\N	\N	\N	\N	160454	160454	327711
20912	30788	34	applied	\N	\N	\N	\N	160455	160455	327712
20912	30789	35	applied	\N	\N	\N	\N	160456	160456	327713
20912	30790	36	applied	\N	\N	\N	\N	160457	160457	327714
20912	30791	37	applied	\N	\N	\N	\N	160458	160458	327715
20912	30801	38	applied	\N	\N	\N	\N	160459	160459	327716
20912	30804	39	applied	\N	\N	\N	\N	160460	160460	327717
20912	30808	40	applied	\N	\N	\N	\N	160461	160461	327718
20912	30809	41	applied	\N	\N	\N	\N	160462	160462	327719
20912	30813	43	applied	\N	\N	\N	\N	160464	160464	327721
20912	30817	44	applied	\N	\N	\N	\N	160465	160465	327722
20912	30819	45	applied	\N	\N	\N	\N	160466	160466	327723
20912	30822	46	applied	\N	\N	\N	\N	160467	160467	327724
20912	30823	47	applied	\N	\N	\N	\N	160468	160468	327725
20912	30826	48	applied	\N	\N	\N	\N	160469	160469	327726
20912	30828	49	applied	\N	\N	\N	\N	160470	160470	327727
20912	30831	50	applied	\N	\N	\N	\N	160471	160471	327728
20912	30832	51	applied	\N	\N	\N	\N	160472	160472	327729
20912	30835	52	applied	\N	\N	\N	\N	160473	160473	327730
20912	30838	53	applied	\N	\N	\N	\N	160474	160474	327731
20912	30840	54	applied	\N	\N	\N	\N	160475	160475	327732
20912	30841	55	applied	\N	\N	\N	\N	160476	160476	327733
20912	30845	56	applied	\N	\N	\N	\N	160477	160477	327734
20912	30847	57	applied	\N	\N	\N	\N	160478	160478	327735
20912	30849	58	applied	\N	\N	\N	\N	160479	160479	327736
20912	30854	60	applied	\N	\N	\N	\N	160481	160481	327738
20912	30856	62	applied	\N	\N	\N	\N	160482	160482	327739
20912	30858	63	applied	\N	\N	\N	\N	160483	160483	327740
20912	30861	64	applied	\N	\N	\N	\N	160484	160484	327741
20912	30863	65	applied	\N	\N	\N	\N	160485	160485	327742
20912	30865	66	applied	\N	\N	\N	\N	160486	160486	327743
20912	30866	67	applied	\N	\N	\N	\N	160487	160487	327744
20912	30870	68	applied	\N	\N	\N	\N	160488	160488	327745
20912	30872	69	applied	\N	\N	\N	\N	160489	160489	327746
20912	30873	70	applied	\N	\N	\N	\N	160490	160490	327747
20912	30874	71	applied	\N	\N	\N	\N	160491	160491	327748
20912	30879	72	applied	\N	\N	\N	\N	160492	160492	327749
20912	30880	73	applied	\N	\N	\N	\N	160493	160493	327750
20912	30881	74	applied	\N	\N	\N	\N	160494	160494	327751
20912	30886	75	applied	\N	\N	\N	\N	160495	160495	327752
20912	30739	76	applied	\N	\N	\N	\N	160496	160496	160496
20912	30794	78	applied	\N	\N	\N	\N	160498	160498	327754
20912	30729	79	applied	\N	\N	\N	\N	160499	160499	327755
20912	30795	80	applied	\N	\N	\N	\N	160500	160500	327756
20912	30796	81	applied	\N	\N	\N	\N	160501	160501	327757
20912	30727	82	applied	\N	\N	\N	\N	160502	160502	327758
20913	30890	2	applied	\N	\N	\N	\N	160548	160548	327804
20913	30891	3	applied	\N	\N	\N	\N	160549	160549	327805
20920	30899	0	applied	\N	\N	\N	\N	160572	160572	327828
20920	30900	1	applied	\N	\N	\N	\N	160573	160573	327829
20920	30901	2	applied	\N	\N	\N	\N	160574	160574	327830
20920	30902	3	applied	\N	\N	\N	\N	160575	160575	327831
20925	30913	0	applied	\N	\N	\N	\N	160588	160588	327844
20925	30914	1	applied	\N	\N	\N	\N	160589	160589	327845
20925	30915	2	applied	\N	\N	\N	\N	160590	160590	327846
20931	30923	0	applied	\N	\N	\N	\N	160608	160608	327864
20931	30924	1	applied	\N	\N	\N	\N	160609	160609	327865
20931	30926	3	applied	\N	\N	\N	\N	160611	160611	327867
20931	30927	4	applied	\N	\N	\N	\N	160612	160612	327868
20931	30928	5	applied	\N	\N	\N	\N	160613	160613	327869
20931	30929	7	applied	\N	\N	\N	\N	160614	160614	327870
20931	30930	8	applied	\N	\N	\N	\N	160615	160615	327871
20933	30931	0	applied	\N	\N	\N	\N	160618	160618	327874
20933	30932	1	applied	\N	\N	\N	\N	160619	160619	327875
20936	30933	0	applied	\N	\N	\N	\N	160638	160638	327894
20936	30934	1	applied	\N	\N	\N	\N	160639	160639	327895
20936	30935	2	applied	\N	\N	\N	\N	160640	160640	327896
20936	30936	3	applied	\N	\N	\N	\N	160641	160641	327897
20936	30937	4	applied	\N	\N	\N	\N	160642	160642	327898
20936	30938	5	applied	\N	\N	\N	\N	160643	160643	327899
20936	30939	6	applied	\N	\N	\N	\N	160644	160644	327900
20936	30940	7	applied	\N	\N	\N	\N	160645	160645	327901
20936	30941	8	applied	\N	\N	\N	\N	160646	160646	327902
20940	30952	1	applied	\N	\N	1000000000	\N	160666	160666	327922
20940	30953	2	applied	\N	\N	\N	\N	160667	160667	327923
20940	30954	3	applied	\N	\N	\N	\N	160668	160668	327924
20943	30962	0	applied	\N	\N	\N	\N	160676	160676	327932
20943	30963	1	applied	\N	\N	\N	\N	160677	160677	327933
20943	30964	2	applied	\N	\N	\N	\N	160678	160678	327934
20943	30965	3	applied	\N	\N	\N	\N	160679	160679	327935
20943	30966	4	applied	\N	\N	\N	\N	160680	160680	327936
20947	30971	0	applied	\N	\N	\N	\N	160699	160699	327955
20947	30972	1	applied	\N	\N	\N	\N	160700	160700	327956
20947	30973	2	applied	\N	\N	\N	\N	160701	160701	327957
20947	30974	3	applied	\N	\N	\N	\N	160702	160702	327958
20947	30975	4	applied	\N	\N	\N	\N	160703	160703	327959
20947	30976	5	applied	\N	\N	\N	\N	160704	160704	327960
20947	30977	6	applied	\N	\N	\N	\N	160705	160705	327961
20951	30983	0	applied	\N	\N	\N	\N	160713	160713	327969
20912	30758	10	applied	\N	\N	\N	\N	160431	160431	327689
20912	30775	87	applied	\N	\N	\N	\N	160507	160507	327763
20912	30782	88	applied	\N	\N	\N	\N	160508	160508	327764
20912	30792	89	applied	\N	\N	\N	\N	160509	160509	327765
20912	30803	90	applied	\N	\N	\N	\N	160510	160510	327766
20912	30816	91	applied	\N	\N	\N	\N	160511	160511	327767
20912	30820	92	applied	\N	\N	\N	\N	160512	160512	327768
20912	30829	93	applied	\N	\N	\N	\N	160513	160513	327769
20912	30837	94	applied	\N	\N	\N	\N	160514	160514	327770
20912	30844	95	applied	\N	\N	\N	\N	160515	160515	327771
20912	30853	96	applied	\N	\N	\N	\N	160516	160516	327772
20912	30860	97	applied	\N	\N	\N	\N	160517	160517	327773
20912	30868	98	applied	\N	\N	\N	\N	160518	160518	327774
20912	30876	99	applied	\N	\N	\N	\N	160519	160519	327775
20912	30883	100	applied	\N	\N	\N	\N	160520	160520	327776
20912	30733	102	applied	\N	\N	\N	\N	160522	160522	327778
20912	30735	103	applied	\N	\N	\N	\N	160523	160523	327779
20912	30740	104	applied	\N	\N	\N	\N	160524	160524	327780
20912	30742	105	applied	\N	\N	\N	\N	160525	160525	327781
20912	30746	106	applied	\N	\N	\N	\N	160526	160526	327782
20912	30750	107	applied	\N	\N	\N	\N	160527	160527	327783
20912	30752	108	applied	\N	\N	\N	\N	160528	160528	327784
20912	30754	109	applied	\N	\N	\N	\N	160529	160529	327785
20912	30757	110	applied	\N	\N	\N	\N	160530	160530	327786
20912	30761	111	applied	\N	\N	\N	\N	160531	160531	327787
20912	30762	112	applied	\N	\N	\N	\N	160532	160532	327788
20912	30765	113	applied	\N	\N	\N	\N	160533	160533	327789
20912	30768	114	applied	\N	\N	\N	\N	160534	160534	327790
20912	30769	115	applied	\N	\N	\N	\N	160535	160535	327791
20912	30776	116	applied	\N	\N	\N	\N	160536	160536	327792
20912	30777	117	applied	\N	\N	\N	\N	160537	160537	327793
20912	30779	119	applied	\N	\N	\N	\N	160539	160539	327795
20912	30783	120	applied	\N	\N	\N	\N	160540	160540	327796
20912	30785	121	applied	\N	\N	\N	\N	160541	160541	327797
20912	30797	122	applied	\N	\N	\N	\N	160542	160542	327798
20912	30798	123	applied	\N	\N	\N	\N	160543	160543	327799
20912	30799	124	applied	\N	\N	\N	\N	160544	160544	327800
20912	30800	125	applied	\N	\N	\N	\N	160545	160545	327801
20915	30888	0	applied	\N	\N	1000000000	\N	160554	160554	327810
20915	30889	1	applied	\N	\N	\N	\N	160555	160555	327811
20915	30890	2	applied	\N	\N	\N	\N	160556	160556	327812
20915	30891	3	applied	\N	\N	\N	\N	160557	160557	327813
20917	30892	0	applied	\N	\N	\N	\N	160563	160563	327819
20917	30893	1	applied	\N	\N	\N	\N	160564	160564	327820
20917	30894	2	applied	\N	\N	\N	\N	160565	160565	327821
20917	30895	3	applied	\N	\N	\N	\N	160566	160566	327822
20917	30896	4	applied	\N	\N	\N	\N	160567	160567	327823
20919	30898	1	applied	\N	\N	\N	\N	160571	160571	327827
20921	30903	0	applied	\N	\N	\N	\N	160576	160576	327832
20921	30904	1	applied	\N	\N	\N	\N	160577	160577	327833
20926	30916	0	applied	\N	\N	\N	\N	160591	160591	327847
20926	30917	1	applied	\N	\N	\N	\N	160592	160592	327848
20934	30933	0	applied	\N	\N	\N	\N	160620	160620	327876
20934	30934	1	applied	\N	\N	\N	\N	160621	160621	327877
20934	30935	2	applied	\N	\N	\N	\N	160622	160622	327878
20934	30936	3	applied	\N	\N	\N	\N	160623	160623	327879
20934	30937	4	applied	\N	\N	\N	\N	160624	160624	327880
20934	30938	5	applied	\N	\N	\N	\N	160625	160625	327881
20934	30939	6	applied	\N	\N	\N	\N	160626	160626	327882
20934	30940	7	applied	\N	\N	\N	\N	160627	160627	327883
20934	30941	8	applied	\N	\N	\N	\N	160628	160628	327884
20939	30945	0	applied	\N	\N	\N	\N	160659	160659	327915
20939	30946	1	applied	\N	\N	\N	\N	160660	160660	327916
20939	30948	3	applied	\N	\N	\N	\N	160662	160662	327918
20939	30949	4	applied	\N	\N	\N	\N	160663	160663	327919
20939	30950	5	applied	\N	\N	\N	\N	160664	160664	327920
20945	30971	0	applied	\N	\N	\N	\N	160685	160685	327941
20945	30972	1	applied	\N	\N	\N	\N	160686	160686	327942
20945	30973	2	applied	\N	\N	\N	\N	160687	160687	327943
20945	30974	3	applied	\N	\N	\N	\N	160688	160688	327944
20945	30975	4	applied	\N	\N	\N	\N	160689	160689	327945
20945	30976	5	applied	\N	\N	\N	\N	160690	160690	327946
20945	30977	6	applied	\N	\N	\N	\N	160691	160691	327947
20950	30981	0	applied	\N	\N	\N	\N	160711	160711	327967
20950	30982	1	applied	\N	\N	\N	\N	160712	160712	327968
20952	30985	0	applied	\N	\N	\N	\N	160715	160715	327971
20952	30986	1	applied	\N	\N	\N	\N	160716	160716	327972
20960	30999	0	applied	\N	\N	\N	\N	160739	160739	327995
20960	31000	1	applied	\N	\N	\N	\N	160740	160740	327996
20962	31002	0	applied	\N	\N	\N	\N	160745	160745	328001
20962	31003	1	applied	\N	\N	\N	\N	160746	160746	328002
20962	31004	2	applied	\N	\N	\N	\N	160747	160747	328003
20962	31005	3	applied	\N	\N	\N	\N	160748	160748	328004
20965	31009	0	applied	\N	\N	\N	\N	160767	160767	328023
20965	31010	1	applied	\N	\N	\N	\N	160768	160768	328024
20965	31011	2	applied	\N	\N	\N	\N	160769	160769	328025
20965	31012	3	applied	\N	\N	\N	\N	160770	160770	328026
20965	31013	4	applied	\N	\N	\N	\N	160771	160771	328027
20968	31014	0	applied	\N	\N	\N	\N	160776	160776	328032
20968	31015	1	applied	\N	\N	\N	\N	160777	160777	328033
20979	31032	0	applied	\N	\N	\N	\N	160808	160808	328064
20979	31033	1	applied	\N	\N	\N	\N	160809	160809	328065
20985	31038	0	applied	\N	\N	\N	\N	160820	160820	328076
20985	31039	1	applied	\N	\N	\N	\N	160821	160821	328077
20985	31040	2	applied	\N	\N	\N	\N	160822	160822	328078
20988	31042	1	applied	\N	\N	\N	\N	160828	160828	328084
20990	31043	0	applied	\N	\N	\N	\N	160831	160831	328087
20990	31044	1	applied	\N	\N	\N	\N	160832	160832	328088
20995	31048	0	applied	\N	\N	\N	\N	160844	160844	328100
20995	31049	1	applied	\N	\N	\N	\N	160845	160845	328101
20995	31050	2	applied	\N	\N	\N	\N	160846	160846	328102
20995	31051	3	applied	\N	\N	\N	\N	160847	160847	328103
20997	31052	0	applied	\N	\N	\N	\N	160852	160852	328108
20997	31053	1	applied	\N	\N	\N	\N	160853	160853	328109
20997	31054	2	applied	\N	\N	\N	\N	160854	160854	328110
20997	31055	3	applied	\N	\N	\N	\N	160855	160855	328111
20997	31056	4	applied	\N	\N	\N	\N	160856	160856	328112
20997	31057	5	applied	\N	\N	\N	\N	160857	160857	328113
20997	31058	6	applied	\N	\N	\N	\N	160858	160858	328114
20997	31059	7	applied	\N	\N	\N	\N	160859	160859	328115
20997	31060	8	applied	\N	\N	\N	\N	160860	160860	328116
20912	30764	86	applied	\N	\N	\N	\N	160506	160506	327762
20942	30959	2	applied	\N	\N	\N	\N	160673	160673	327929
20942	30960	3	applied	\N	\N	\N	\N	160674	160674	327930
20942	30961	4	applied	\N	\N	\N	\N	160675	160675	327931
20946	30971	0	applied	\N	\N	\N	\N	160692	160692	327948
20946	30972	1	applied	\N	\N	\N	\N	160693	160693	327949
20946	30973	2	applied	\N	\N	\N	\N	160694	160694	327950
20946	30974	3	applied	\N	\N	\N	\N	160695	160695	327951
20946	30975	4	applied	\N	\N	\N	\N	160696	160696	327952
20946	30976	5	applied	\N	\N	\N	\N	160697	160697	327953
20946	30977	6	applied	\N	\N	\N	\N	160698	160698	327954
20948	30978	0	applied	\N	\N	\N	\N	160706	160706	327962
20948	30980	2	applied	\N	\N	\N	\N	160708	160708	327964
20953	30985	0	applied	\N	\N	\N	\N	160717	160717	327973
20953	30986	1	applied	\N	\N	\N	\N	160718	160718	327974
20955	30990	0	applied	\N	\N	\N	\N	160722	160722	327978
20955	30991	1	applied	\N	\N	\N	\N	160723	160723	327979
20958	30999	0	applied	\N	\N	\N	\N	160733	160733	327989
20958	31000	1	applied	\N	\N	\N	\N	160734	160734	327990
20958	31001	2	applied	\N	\N	\N	\N	160735	160735	327991
20961	30999	0	applied	\N	\N	\N	\N	160742	160742	327998
20961	31000	1	applied	\N	\N	\N	\N	160743	160743	327999
20961	31001	2	applied	\N	\N	\N	\N	160744	160744	328000
20967	31014	0	applied	\N	\N	\N	\N	160774	160774	328030
20967	31015	1	applied	\N	\N	\N	\N	160775	160775	328031
20972	30942	0	applied	\N	\N	1000000000	\N	160784	160784	328040
20972	30933	1	applied	\N	\N	\N	\N	160785	160785	328041
20972	30770	2	applied	\N	\N	\N	\N	160786	160786	328042
20981	31034	0	applied	\N	\N	\N	\N	160812	160812	328068
20981	31035	1	applied	\N	\N	\N	\N	160813	160813	328069
20982	31034	0	applied	\N	\N	\N	\N	160814	160814	328070
20982	31035	1	applied	\N	\N	\N	\N	160815	160815	328071
20987	31041	0	applied	\N	\N	\N	\N	160825	160825	328081
20987	31042	1	applied	\N	\N	\N	\N	160826	160826	328082
20989	31043	0	applied	\N	\N	\N	\N	160829	160829	328085
20989	31044	1	applied	\N	\N	\N	\N	160830	160830	328086
20994	31048	0	applied	\N	\N	\N	\N	160840	160840	328096
20994	31049	1	applied	\N	\N	\N	\N	160841	160841	328097
20994	31050	2	applied	\N	\N	\N	\N	160842	160842	328098
20994	31051	3	applied	\N	\N	\N	\N	160843	160843	328099
20997	31061	9	applied	\N	\N	\N	\N	160861	160861	328117
20997	31062	10	applied	\N	\N	\N	\N	160862	160862	328118
20997	31063	11	applied	\N	\N	\N	\N	160863	160863	328119
20997	31064	12	applied	\N	\N	\N	\N	160864	160864	328120
20999	31053	1	applied	\N	\N	\N	\N	160879	160879	328135
20999	31054	2	applied	\N	\N	\N	\N	160880	160880	328136
20999	31055	3	applied	\N	\N	\N	\N	160881	160881	328137
20999	31056	4	applied	\N	\N	\N	\N	160882	160882	328138
20999	31057	5	applied	\N	\N	\N	\N	160883	160883	328139
20999	31058	6	applied	\N	\N	\N	\N	160884	160884	328140
20999	31059	7	applied	\N	\N	\N	\N	160885	160885	328141
20999	31060	8	applied	\N	\N	\N	\N	160886	160886	328142
20999	31061	9	applied	\N	\N	\N	\N	160887	160887	328143
20999	31062	10	applied	\N	\N	\N	\N	160888	160888	328144
20999	31063	11	applied	\N	\N	\N	\N	160889	160889	328145
20999	31064	12	applied	\N	\N	\N	\N	160890	160890	328146
21000	30942	0	applied	\N	\N	1000000000	\N	160891	160891	328147
21000	30933	1	applied	\N	\N	\N	\N	160892	160892	328148
21000	30934	2	applied	\N	\N	\N	\N	160893	160893	328149
21000	30999	4	applied	\N	\N	\N	\N	160895	160895	328151
21000	30935	5	applied	\N	\N	\N	\N	160896	160896	328152
21000	30936	6	applied	\N	\N	\N	\N	160897	160897	328153
21000	31008	7	applied	\N	\N	\N	\N	160898	160898	328154
21000	30905	8	applied	\N	\N	\N	\N	160899	160899	328155
21000	30906	9	applied	\N	\N	\N	\N	160900	160900	328156
21000	30908	10	applied	\N	\N	\N	\N	160901	160901	328157
21000	30909	11	applied	\N	\N	\N	\N	160902	160902	328158
21000	30914	12	applied	\N	\N	\N	\N	160903	160903	328159
21000	30926	13	applied	\N	\N	\N	\N	160904	160904	328160
21000	30946	14	applied	\N	\N	\N	\N	160905	160905	328161
21000	31052	15	applied	\N	\N	\N	\N	160906	160906	328162
21000	31053	16	applied	\N	\N	\N	\N	160907	160907	328163
21000	31054	17	applied	\N	\N	\N	\N	160908	160908	328164
21000	31055	18	applied	\N	\N	\N	\N	160909	160909	328165
21000	30910	19	applied	\N	\N	\N	\N	160910	160910	328166
21000	30913	20	applied	\N	\N	\N	\N	160911	160911	328167
21000	30916	21	applied	\N	\N	\N	\N	160912	160912	328168
21000	30918	22	applied	\N	\N	\N	\N	160913	160913	328169
21000	30923	24	applied	\N	\N	\N	\N	160915	160915	328171
21000	30924	25	applied	\N	\N	\N	\N	160916	160916	328172
21000	30925	26	applied	\N	\N	\N	\N	160917	160917	328173
21000	30931	27	applied	\N	\N	\N	\N	160918	160918	328174
21000	30937	28	applied	\N	\N	\N	\N	160919	160919	328175
21000	30938	29	applied	\N	\N	\N	\N	160920	160920	328176
21000	30943	30	applied	\N	\N	\N	\N	160921	160921	328177
21000	30945	31	applied	\N	\N	\N	\N	160922	160922	328178
21000	30947	32	applied	\N	\N	\N	\N	160923	160923	328179
21000	30953	33	applied	\N	\N	\N	\N	160924	160924	328180
21000	30955	34	applied	\N	\N	\N	\N	160925	160925	328181
21000	30959	35	applied	\N	\N	\N	\N	160926	160926	328182
21000	30964	37	applied	\N	\N	\N	\N	160927	160927	328183
21000	30967	38	applied	\N	\N	\N	\N	160928	160928	328184
21000	30968	39	applied	\N	\N	\N	\N	160929	160929	328185
21000	30971	40	applied	\N	\N	\N	\N	160930	160930	328186
21001	31066	1	applied	\N	\N	\N	\N	161017	161017	328273
21001	31067	2	applied	\N	\N	\N	\N	161018	161018	328274
21001	31068	3	applied	\N	\N	\N	\N	161019	161019	328275
21001	31069	4	applied	\N	\N	\N	\N	161020	161020	328276
21004	31070	0	applied	\N	\N	\N	\N	161028	161028	328284
21004	31071	1	applied	\N	\N	\N	\N	161029	161029	328285
21006	31070	0	applied	\N	\N	\N	\N	161032	161032	328288
21006	31071	1	applied	\N	\N	\N	\N	161033	161033	328289
21010	31077	0	applied	\N	\N	\N	\N	161047	161047	328303
21010	31078	1	applied	\N	\N	\N	\N	161048	161048	328304
21012	31079	0	applied	\N	\N	\N	\N	161174	161174	328428
21012	31080	1	applied	\N	\N	\N	\N	161175	161175	328429
21012	31081	2	applied	\N	\N	\N	\N	161176	161176	328430
21015	31089	0	applied	\N	\N	\N	\N	161187	161187	328441
21015	31090	1	applied	\N	\N	\N	\N	161188	161188	328442
21015	31091	2	applied	\N	\N	\N	\N	161189	161189	328443
20942	30957	0	applied	\N	\N	\N	\N	160671	160671	327927
20942	30958	1	applied	\N	\N	\N	\N	160672	160672	327928
20954	30988	1	applied	\N	\N	\N	\N	160720	160720	327976
20954	30989	2	applied	\N	\N	\N	\N	160721	160721	327977
20956	30990	0	applied	\N	\N	\N	\N	160724	160724	327980
20956	30991	1	applied	\N	\N	\N	\N	160725	160725	327981
20957	30992	0	applied	\N	\N	\N	\N	160726	160726	327982
20957	30993	1	applied	\N	\N	\N	\N	160727	160727	327983
20957	30994	2	applied	\N	\N	\N	\N	160728	160728	327984
20957	30995	3	applied	\N	\N	\N	\N	160729	160729	327985
20957	30996	4	applied	\N	\N	\N	\N	160730	160730	327986
20957	30998	6	applied	\N	\N	\N	\N	160732	160732	327988
20964	30942	0	applied	\N	\N	1000000000	\N	160751	160751	328007
20964	30933	1	applied	\N	\N	\N	\N	160752	160752	328008
20964	30934	2	applied	\N	\N	\N	\N	160753	160753	328009
20964	30952	3	applied	\N	\N	1000000000	\N	160754	160754	328010
20964	30999	4	applied	\N	\N	\N	\N	160755	160755	328011
20964	30935	5	applied	\N	\N	\N	\N	160756	160756	328012
20964	30936	6	applied	\N	\N	\N	\N	160757	160757	328013
20964	31008	7	applied	\N	\N	\N	\N	160758	160758	328014
20964	30888	8	applied	\N	\N	1000000000	\N	160759	160759	328015
20964	30946	9	applied	\N	\N	\N	\N	160760	160760	328016
20964	30900	10	applied	\N	\N	\N	\N	160761	160761	328017
20964	30906	11	applied	\N	\N	\N	\N	160762	160762	328018
20964	30908	12	applied	\N	\N	\N	\N	160763	160763	328019
20964	30909	13	applied	\N	\N	\N	\N	160764	160764	328020
20964	30914	14	applied	\N	\N	\N	\N	160765	160765	328021
20966	31014	0	applied	\N	\N	\N	\N	160772	160772	328028
20966	31015	1	applied	\N	\N	\N	\N	160773	160773	328029
20970	31014	0	applied	\N	\N	\N	\N	160780	160780	328036
20970	31015	1	applied	\N	\N	\N	\N	160781	160781	328037
20971	31016	0	applied	\N	\N	\N	\N	160782	160782	328038
20971	31017	1	applied	\N	\N	\N	\N	160783	160783	328039
20975	31026	0	applied	\N	\N	\N	\N	160796	160796	328052
20975	31027	1	applied	\N	\N	\N	\N	160797	160797	328053
20975	31028	2	applied	\N	\N	\N	\N	160798	160798	328054
20976	31026	0	applied	\N	\N	\N	\N	160799	160799	328055
20976	31027	1	applied	\N	\N	\N	\N	160800	160800	328056
20976	31028	2	applied	\N	\N	\N	\N	160801	160801	328057
20984	31036	0	applied	\N	\N	\N	\N	160818	160818	328074
20984	31037	1	applied	\N	\N	\N	\N	160819	160819	328075
20986	31041	0	applied	\N	\N	\N	\N	160823	160823	328079
20986	31042	1	applied	\N	\N	\N	\N	160824	160824	328080
20993	31049	1	applied	\N	\N	\N	\N	160839	160839	328095
20996	31048	0	applied	\N	\N	\N	\N	160848	160848	328104
20996	31049	1	applied	\N	\N	\N	\N	160849	160849	328105
20996	31050	2	applied	\N	\N	\N	\N	160850	160850	328106
20996	31051	3	applied	\N	\N	\N	\N	160851	160851	328107
20998	31052	0	applied	\N	\N	\N	\N	160865	160865	328121
20998	31053	1	applied	\N	\N	\N	\N	160866	160866	328122
20998	31054	2	applied	\N	\N	\N	\N	160867	160867	328123
20998	31055	3	applied	\N	\N	\N	\N	160868	160868	328124
20998	31056	4	applied	\N	\N	\N	\N	160869	160869	328125
20998	31057	5	applied	\N	\N	\N	\N	160870	160870	328126
20998	31058	6	applied	\N	\N	\N	\N	160871	160871	328127
20998	31059	7	applied	\N	\N	\N	\N	160872	160872	328128
20998	31060	8	applied	\N	\N	\N	\N	160873	160873	328129
20998	31061	9	applied	\N	\N	\N	\N	160874	160874	328130
20998	31062	10	applied	\N	\N	\N	\N	160875	160875	328131
20998	31064	12	applied	\N	\N	\N	\N	160877	160877	328133
21003	31070	0	applied	\N	\N	\N	\N	161026	161026	328282
21003	31071	1	applied	\N	\N	\N	\N	161027	161027	328283
21008	31072	0	applied	\N	\N	\N	\N	161039	161039	328295
21008	31073	1	applied	\N	\N	\N	\N	161040	161040	328296
21008	31074	2	applied	\N	\N	\N	\N	161041	161041	328297
21008	31075	3	applied	\N	\N	\N	\N	161042	161042	328298
21008	31076	4	applied	\N	\N	\N	\N	161043	161043	328299
21011	30942	0	applied	\N	\N	1000000000	\N	161049	161049	328305
21011	30593	1	applied	\N	\N	\N	\N	161050	161050	328306
21015	31093	4	applied	\N	\N	\N	\N	161191	161191	328445
21018	31094	0	applied	\N	\N	\N	\N	161197	161197	328451
21018	31095	1	applied	\N	\N	\N	\N	161198	161198	328452
21021	31096	0	applied	\N	\N	\N	\N	161203	161203	328457
21021	31097	1	applied	\N	\N	\N	\N	161204	161204	328458
21021	31098	2	applied	\N	\N	\N	\N	161205	161205	328459
21021	31100	4	applied	\N	\N	\N	\N	161207	161207	328461
21021	31101	5	applied	\N	\N	\N	\N	161208	161208	328462
21025	31096	0	applied	\N	\N	\N	\N	161227	161227	328481
21025	31097	1	applied	\N	\N	\N	\N	161228	161228	328482
21025	31098	2	applied	\N	\N	\N	\N	161229	161229	328483
21025	31099	3	applied	\N	\N	\N	\N	161230	161230	328484
21025	31100	4	applied	\N	\N	\N	\N	161231	161231	328485
21025	31101	5	applied	\N	\N	\N	\N	161232	161232	328486
21027	31096	0	applied	\N	\N	\N	\N	161239	161239	328493
21027	31097	1	applied	\N	\N	\N	\N	161240	161240	328494
21027	31098	2	applied	\N	\N	\N	\N	161241	161241	328495
21027	31099	3	applied	\N	\N	\N	\N	161242	161242	328496
21027	31100	4	applied	\N	\N	\N	\N	161243	161243	328497
21027	31101	5	applied	\N	\N	\N	\N	161244	161244	328498
21029	31102	0	applied	\N	\N	\N	\N	161251	161251	328505
21029	31103	1	applied	\N	\N	\N	\N	161252	161252	328506
21040	31111	1	applied	\N	\N	\N	\N	161273	161273	328527
21040	31112	2	applied	\N	\N	\N	\N	161274	161274	328528
21042	31110	0	applied	\N	\N	\N	\N	161278	161278	328532
21042	31111	1	applied	\N	\N	\N	\N	161279	161279	328533
21042	31112	2	applied	\N	\N	\N	\N	161280	161280	328534
21047	31120	0	applied	\N	\N	\N	\N	161292	161292	328546
21047	31121	1	applied	\N	\N	\N	\N	161293	161293	328547
21047	31122	2	applied	\N	\N	\N	\N	161294	161294	328548
21053	31123	0	applied	\N	\N	\N	\N	161307	161307	328561
21053	31124	1	applied	\N	\N	\N	\N	161308	161308	328562
21054	31125	0	applied	\N	\N	\N	\N	161309	161309	328563
21054	31126	1	applied	\N	\N	\N	\N	161310	161310	328564
21054	31127	2	applied	\N	\N	\N	\N	161311	161311	328565
21054	31128	3	applied	\N	\N	\N	\N	161312	161312	328566
21056	31129	0	applied	\N	\N	\N	\N	161317	161317	328571
21056	31130	1	applied	\N	\N	\N	\N	161318	161318	328572
21059	31134	1	applied	\N	\N	\N	\N	161324	161324	328578
21059	31135	2	applied	\N	\N	\N	\N	161325	161325	328579
21059	31136	3	applied	\N	\N	\N	\N	161326	161326	328580
21059	31137	4	applied	\N	\N	\N	\N	161327	161327	328581
20949	30982	1	applied	\N	\N	\N	\N	160710	160710	327966
20954	30987	0	applied	\N	\N	\N	\N	160719	160719	327975
20959	31001	2	applied	\N	\N	\N	\N	160738	160738	327994
20963	31006	0	applied	\N	\N	\N	\N	160749	160749	328005
20963	31007	1	applied	\N	\N	\N	\N	160750	160750	328006
20969	31014	0	applied	\N	\N	\N	\N	160778	160778	328034
20969	31015	1	applied	\N	\N	\N	\N	160779	160779	328035
20973	31018	0	applied	\N	\N	\N	\N	160788	160788	328044
20973	31019	1	applied	\N	\N	\N	\N	160789	160789	328045
20973	31020	2	applied	\N	\N	\N	\N	160790	160790	328046
20973	31021	3	applied	\N	\N	\N	\N	160791	160791	328047
20973	31022	4	applied	\N	\N	\N	\N	160792	160792	328048
20973	31023	5	applied	\N	\N	\N	\N	160793	160793	328049
20974	31024	0	applied	\N	\N	\N	\N	160794	160794	328050
20974	31025	1	applied	\N	\N	\N	\N	160795	160795	328051
20977	31030	1	applied	\N	\N	\N	\N	160803	160803	328059
20977	31031	2	applied	\N	\N	\N	\N	160804	160804	328060
20978	31029	0	applied	\N	\N	\N	\N	160805	160805	328061
20978	31030	1	applied	\N	\N	\N	\N	160806	160806	328062
20978	31031	2	applied	\N	\N	\N	\N	160807	160807	328063
20980	31034	0	applied	\N	\N	\N	\N	160810	160810	328066
20980	31035	1	applied	\N	\N	\N	\N	160811	160811	328067
20983	31036	0	applied	\N	\N	\N	\N	160816	160816	328072
20983	31037	1	applied	\N	\N	\N	\N	160817	160817	328073
20991	31043	0	applied	\N	\N	\N	\N	160833	160833	328089
20991	31044	1	applied	\N	\N	\N	\N	160834	160834	328090
20992	31045	0	applied	\N	\N	\N	\N	160835	160835	328091
20992	31046	1	applied	\N	\N	\N	\N	160836	160836	328092
20992	31047	2	applied	\N	\N	\N	\N	160837	160837	328093
21007	31072	0	applied	\N	\N	\N	\N	161034	161034	328290
21007	31073	1	applied	\N	\N	\N	\N	161035	161035	328291
21007	31075	3	applied	\N	\N	\N	\N	161037	161037	328293
21007	31076	4	applied	\N	\N	\N	\N	161038	161038	328294
21011	30594	2	applied	\N	\N	\N	\N	161051	161051	328307
21011	30616	3	applied	\N	\N	\N	\N	161052	161052	328308
21011	30933	4	applied	\N	\N	\N	\N	161053	161053	328309
21011	30702	5	applied	\N	\N	\N	\N	161054	161054	328310
21011	30770	6	applied	\N	\N	\N	\N	161055	161055	328311
21011	30934	7	applied	\N	\N	\N	\N	161056	161056	328312
21011	30952	8	applied	\N	\N	1000000000	\N	161057	161057	328313
21011	30999	9	applied	\N	\N	\N	\N	161058	161058	328314
21011	30780	10	applied	\N	\N	\N	\N	161059	161059	328315
21011	30703	11	applied	\N	\N	\N	\N	161060	161060	328316
21011	30704	12	applied	\N	\N	\N	\N	161061	161061	328317
21011	30705	13	applied	\N	\N	\N	\N	161062	161062	328318
21011	30706	14	applied	\N	\N	\N	\N	161063	161063	161063
21011	30935	15	applied	\N	\N	\N	\N	161064	161064	328319
21011	31008	17	applied	\N	\N	\N	\N	161066	161066	328321
21011	30786	18	applied	\N	\N	\N	\N	161067	161067	328322
21011	30787	19	applied	\N	\N	\N	\N	161068	161068	328323
21011	30807	20	applied	\N	\N	\N	\N	161069	161069	328324
21011	30652	21	applied	\N	\N	\N	\N	161070	161070	328325
21011	30737	22	applied	\N	\N	\N	\N	161071	161071	328326
21011	30744	23	applied	\N	\N	\N	\N	161072	161072	328327
21011	30641	24	applied	\N	\N	\N	\N	161073	161073	328328
21011	30651	25	applied	\N	\N	\N	\N	161074	161074	328329
21011	30659	26	applied	\N	\N	\N	\N	161075	161075	328330
21011	30888	27	applied	\N	\N	1000000000	\N	161076	161076	328331
21011	30588	28	applied	\N	\N	\N	\N	161077	161077	328332
21011	30535	29	applied	\N	\N	\N	\N	161078	161078	328333
21011	30536	30	applied	\N	\N	\N	\N	161079	161079	328334
21011	30574	31	applied	\N	\N	\N	\N	161080	161080	328335
21011	30589	32	applied	\N	\N	\N	\N	161081	161081	328336
21011	30595	34	applied	\N	\N	\N	\N	161083	161083	328338
21011	30596	35	applied	\N	\N	\N	\N	161084	161084	328339
21011	30745	36	applied	\N	\N	\N	\N	161085	161085	328340
21011	30748	37	applied	\N	\N	\N	\N	161086	161086	328341
21011	30758	38	applied	\N	\N	\N	\N	161087	161087	328342
21011	30575	39	applied	\N	\N	\N	\N	161088	161088	328343
21011	30576	40	applied	\N	\N	\N	\N	161089	161089	328344
21011	30577	41	applied	\N	\N	\N	\N	161090	161090	328345
21011	30537	42	applied	\N	\N	\N	\N	161091	161091	328346
21011	30538	43	applied	\N	\N	\N	\N	161092	161092	328347
21011	30543	44	applied	\N	\N	\N	\N	161093	161093	328348
21011	30544	45	applied	\N	\N	\N	\N	161094	161094	328349
21011	30494	46	applied	\N	\N	\N	\N	161095	161095	328350
21019	31094	0	applied	\N	\N	\N	\N	161199	161199	328453
21019	31095	1	applied	\N	\N	\N	\N	161200	161200	328454
21023	31096	0	applied	\N	\N	\N	\N	161215	161215	328469
21023	31098	2	applied	\N	\N	\N	\N	161217	161217	328471
21023	31099	3	applied	\N	\N	\N	\N	161218	161218	328472
21023	31100	4	applied	\N	\N	\N	\N	161219	161219	328473
21023	31101	5	applied	\N	\N	\N	\N	161220	161220	328474
21026	31096	0	applied	\N	\N	\N	\N	161233	161233	328487
21026	31097	1	applied	\N	\N	\N	\N	161234	161234	328488
21026	31098	2	applied	\N	\N	\N	\N	161235	161235	328489
21026	31099	3	applied	\N	\N	\N	\N	161236	161236	328490
21026	31100	4	applied	\N	\N	\N	\N	161237	161237	328491
21026	31101	5	applied	\N	\N	\N	\N	161238	161238	328492
21030	31102	0	applied	\N	\N	\N	\N	161253	161253	328507
21030	31103	1	applied	\N	\N	\N	\N	161254	161254	328508
21033	31102	0	applied	\N	\N	\N	\N	161261	161261	328515
21033	31104	1	applied	\N	\N	\N	\N	161262	161262	328516
21033	31103	2	applied	\N	\N	\N	\N	161263	161263	328517
21033	31106	3	applied	\N	\N	\N	\N	161264	161264	328518
21044	31118	0	applied	\N	\N	\N	\N	161286	161286	328540
21044	31119	1	applied	\N	\N	\N	\N	161287	161287	328541
21051	31123	0	applied	\N	\N	\N	\N	161303	161303	328557
21051	31124	1	applied	\N	\N	\N	\N	161304	161304	328558
21060	31138	0	applied	\N	\N	\N	\N	161328	161328	328582
21060	31139	1	applied	\N	\N	\N	\N	161329	161329	328583
21060	31140	2	applied	\N	\N	\N	\N	161330	161330	328584
21060	31141	3	applied	\N	\N	\N	\N	161331	161331	328585
21062	31147	0	applied	\N	\N	\N	\N	161399	161399	328653
21062	31142	1	applied	\N	\N	\N	\N	161400	161400	328654
21062	31143	2	applied	\N	\N	\N	\N	161401	161401	328655
21062	31144	3	applied	\N	\N	\N	\N	161402	161402	328656
21062	31145	4	applied	\N	\N	\N	\N	161403	161403	328657
21062	31148	5	applied	\N	\N	\N	\N	161404	161404	328658
21064	31147	0	applied	\N	\N	\N	\N	161415	161415	328669
21064	31142	1	applied	\N	\N	\N	\N	161416	161416	328670
20959	30999	0	applied	\N	\N	\N	\N	160736	160736	327992
20959	31000	1	applied	\N	\N	\N	\N	160737	160737	327993
21000	30983	45	applied	\N	\N	\N	\N	160935	160935	328191
21000	30985	46	applied	\N	\N	\N	\N	160936	160936	328192
21000	30987	47	applied	\N	\N	\N	\N	160937	160937	328193
21000	30990	48	applied	\N	\N	\N	\N	160938	160938	328194
21000	30992	49	applied	\N	\N	\N	\N	160939	160939	328195
21000	31018	50	applied	\N	\N	\N	\N	160940	160940	328196
21000	31019	51	applied	\N	\N	\N	\N	160941	160941	328197
21000	31020	52	applied	\N	\N	\N	\N	160942	160942	328198
21000	31021	53	applied	\N	\N	\N	\N	160943	160943	328199
21000	31026	54	applied	\N	\N	\N	\N	160944	160944	328200
21000	30993	55	applied	\N	\N	\N	\N	160945	160945	328201
21000	30994	56	applied	\N	\N	\N	\N	160946	160946	328202
21000	31000	57	applied	\N	\N	\N	\N	160947	160947	328203
21000	31002	58	applied	\N	\N	\N	\N	160948	160948	328204
21000	31003	59	applied	\N	\N	\N	\N	160949	160949	328205
21000	31006	60	applied	\N	\N	\N	\N	160950	160950	328206
21000	31010	62	applied	\N	\N	\N	\N	160952	160952	328208
21000	31014	63	applied	\N	\N	\N	\N	160953	160953	328209
21000	31016	64	applied	\N	\N	\N	\N	160954	160954	328210
21000	31024	65	applied	\N	\N	\N	\N	160955	160955	328211
21000	31027	66	applied	\N	\N	\N	\N	160956	160956	328212
21000	31029	67	applied	\N	\N	\N	\N	160957	160957	328213
21000	31032	68	applied	\N	\N	\N	\N	160958	160958	328214
21000	31034	69	applied	\N	\N	\N	\N	160959	160959	328215
21000	31036	70	applied	\N	\N	\N	\N	160960	160960	328216
21000	31038	71	applied	\N	\N	\N	\N	160961	160961	328217
21000	31041	72	applied	\N	\N	\N	\N	160962	160962	328218
21000	31043	73	applied	\N	\N	\N	\N	160963	160963	328219
21000	31045	74	applied	\N	\N	\N	\N	160964	160964	328220
21000	31048	75	applied	\N	\N	\N	\N	160965	160965	328221
21000	31049	76	applied	\N	\N	\N	\N	160966	160966	328222
21000	31056	77	applied	\N	\N	\N	\N	160967	160967	328223
21000	31058	79	applied	\N	\N	\N	\N	160969	160969	328225
21000	31059	80	applied	\N	\N	\N	\N	160970	160970	328226
21000	30912	81	applied	\N	\N	\N	\N	160971	160971	328227
21000	30919	82	applied	\N	\N	\N	\N	160972	160972	328228
21000	30930	83	applied	\N	\N	\N	\N	160973	160973	328229
21000	30941	84	applied	\N	\N	\N	\N	160974	160974	328230
21000	30950	85	applied	\N	\N	\N	\N	160975	160975	328231
21000	30965	86	applied	\N	\N	\N	\N	160976	160976	328232
21000	30975	87	applied	\N	\N	\N	\N	160977	160977	328233
21000	30979	88	applied	\N	\N	\N	\N	160978	160978	328234
21000	30988	89	applied	\N	\N	\N	\N	160979	160979	328235
21000	30995	90	applied	\N	\N	\N	\N	160980	160980	328236
21000	31004	91	applied	\N	\N	\N	\N	160981	160981	328237
21000	30907	92	applied	\N	\N	\N	\N	160982	160982	328238
21000	30911	93	applied	\N	\N	\N	\N	160983	160983	328239
21000	30915	94	applied	\N	\N	\N	\N	160984	160984	328240
21000	30920	96	applied	\N	\N	\N	\N	160986	160986	328242
21000	30922	97	applied	\N	\N	\N	\N	160987	160987	328243
21000	30927	98	applied	\N	\N	\N	\N	160988	160988	328244
21000	30928	99	applied	\N	\N	\N	\N	160989	160989	328245
21000	30929	100	applied	\N	\N	\N	\N	160990	160990	328246
21000	31013	101	applied	\N	\N	\N	\N	160991	160991	328247
21000	31022	102	applied	\N	\N	\N	\N	160992	160992	328248
21000	31030	103	applied	\N	\N	\N	\N	160993	160993	328249
21000	31040	104	applied	\N	\N	\N	\N	160994	160994	328250
21000	31047	105	applied	\N	\N	\N	\N	160995	160995	328251
21000	31064	106	applied	\N	\N	\N	\N	160996	160996	328252
21000	30932	107	applied	\N	\N	\N	\N	160997	160997	328253
21000	30939	108	applied	\N	\N	\N	\N	160998	160998	328254
21000	30940	109	applied	\N	\N	\N	\N	160999	160999	328255
21000	30944	110	applied	\N	\N	\N	\N	161000	161000	328256
21000	30948	111	applied	\N	\N	\N	\N	161001	161001	328257
21000	30954	113	applied	\N	\N	\N	\N	161003	161003	328259
21000	30956	114	applied	\N	\N	\N	\N	161004	161004	328260
21064	31144	3	applied	\N	\N	\N	\N	161418	161418	328672
21064	31145	4	applied	\N	\N	\N	\N	161419	161419	328673
21064	31148	5	applied	\N	\N	\N	\N	161420	161420	328674
21069	31149	0	applied	\N	\N	\N	\N	161554	161554	328808
21069	31151	1	applied	\N	\N	\N	\N	161555	161555	328809
21069	31150	2	applied	\N	\N	\N	\N	161556	161556	328810
21073	31161	0	applied	\N	\N	\N	\N	161569	161569	328823
21073	31162	1	applied	\N	\N	\N	\N	161570	161570	328824
21077	31163	0	applied	\N	\N	\N	\N	161577	161577	328831
21077	31164	1	applied	\N	\N	\N	\N	161578	161578	328832
21082	31170	0	applied	\N	\N	\N	\N	161589	161589	328843
21082	31171	1	applied	\N	\N	\N	\N	161590	161590	328844
21087	31177	0	applied	\N	\N	\N	\N	161608	161608	328862
21087	31178	1	applied	\N	\N	\N	\N	161609	161609	328863
21089	31178	1	applied	\N	\N	\N	\N	161613	161613	328867
21091	31179	0	applied	\N	\N	\N	\N	161616	161616	328870
21091	31180	1	applied	\N	\N	\N	\N	161617	161617	328871
21091	31181	2	applied	\N	\N	\N	\N	161618	161618	328872
21091	31182	3	applied	\N	\N	\N	\N	161619	161619	328873
21091	31183	4	applied	\N	\N	\N	\N	161620	161620	328874
21095	31184	0	applied	\N	\N	\N	\N	161635	161635	328889
21095	31185	1	applied	\N	\N	\N	\N	161636	161636	328890
21095	31186	2	applied	\N	\N	\N	\N	161637	161637	328891
21095	31187	3	applied	\N	\N	\N	\N	161638	161638	328892
21098	31188	0	applied	\N	\N	\N	\N	161647	161647	328901
21098	31189	1	applied	\N	\N	\N	\N	161648	161648	328902
21098	31190	2	applied	\N	\N	\N	\N	161649	161649	328903
21102	31191	0	applied	\N	\N	\N	\N	161657	161657	328911
21105	31194	0	applied	\N	\N	\N	\N	161663	161663	328917
21105	31195	1	applied	\N	\N	\N	\N	161664	161664	328918
21107	31194	0	applied	\N	\N	\N	\N	161673	161673	328927
21107	31197	1	applied	\N	\N	\N	\N	161674	161674	328928
21107	31195	2	applied	\N	\N	\N	\N	161675	161675	328929
21107	31196	3	applied	\N	\N	\N	\N	161676	161676	328930
21107	31198	4	applied	\N	\N	\N	\N	161677	161677	328931
21114	31202	0	applied	\N	\N	\N	\N	161694	161694	328948
21114	31203	1	applied	\N	\N	\N	\N	161695	161695	328949
21114	31204	2	applied	\N	\N	\N	\N	161696	161696	328950
21119	31212	0	applied	\N	\N	\N	\N	161706	161706	328960
21119	31213	1	applied	\N	\N	\N	\N	161707	161707	328961
21119	31214	2	applied	\N	\N	\N	\N	161708	161708	328962
21119	31215	3	applied	\N	\N	\N	\N	161709	161709	328963
21121	31216	0	applied	\N	\N	\N	\N	161713	161713	328967
21121	31217	1	applied	\N	\N	\N	\N	161714	161714	328968
21000	30973	42	applied	\N	\N	\N	\N	160932	160932	328188
21000	30978	43	applied	\N	\N	\N	\N	160933	160933	328189
21000	30974	119	applied	\N	\N	\N	\N	161009	161009	328265
21000	30976	120	applied	\N	\N	\N	\N	161010	161010	328266
21000	30977	121	applied	\N	\N	\N	\N	161011	161011	328267
21000	30980	122	applied	\N	\N	\N	\N	161012	161012	328268
21000	30982	123	applied	\N	\N	\N	\N	161013	161013	328269
21000	30984	124	applied	\N	\N	\N	\N	161014	161014	328270
21000	30986	125	applied	\N	\N	\N	\N	161015	161015	328271
21002	31065	0	applied	\N	\N	\N	\N	161021	161021	328277
21002	31066	1	applied	\N	\N	\N	\N	161022	161022	328278
21002	31067	2	applied	\N	\N	\N	\N	161023	161023	328279
21002	31068	3	applied	\N	\N	\N	\N	161024	161024	328280
21002	31069	4	applied	\N	\N	\N	\N	161025	161025	328281
21005	31070	0	applied	\N	\N	\N	\N	161030	161030	328286
21005	31071	1	applied	\N	\N	\N	\N	161031	161031	328287
21009	31072	0	applied	\N	\N	\N	\N	161044	161044	328300
21009	31073	1	applied	\N	\N	\N	\N	161045	161045	328301
21011	30496	47	applied	\N	\N	\N	\N	161096	161096	328351
21011	30497	48	applied	\N	\N	\N	\N	161097	161097	328352
21011	30498	49	applied	\N	\N	\N	\N	161098	161098	328353
21011	30946	50	applied	\N	\N	\N	\N	161099	161099	328354
21011	30900	51	applied	\N	\N	\N	\N	161100	161100	328355
21011	30906	52	applied	\N	\N	\N	\N	161101	161101	328356
21011	30908	53	applied	\N	\N	\N	\N	161102	161102	328357
21011	30909	54	applied	\N	\N	\N	\N	161103	161103	328358
21011	30914	55	applied	\N	\N	\N	\N	161104	161104	328359
21011	30506	56	applied	\N	\N	\N	\N	161105	161105	328360
21011	31052	57	applied	\N	\N	\N	\N	161106	161106	328361
21011	31053	58	applied	\N	\N	\N	\N	161107	161107	328362
21011	31054	59	applied	\N	\N	\N	\N	161108	161108	328363
21011	31055	60	applied	\N	\N	\N	\N	161109	161109	328364
21011	30546	61	applied	\N	\N	\N	\N	161110	161110	328365
21011	30550	62	applied	\N	\N	\N	\N	161111	161111	328366
21011	30552	64	applied	\N	\N	\N	\N	161113	161113	328368
21011	30556	65	applied	\N	\N	\N	\N	161114	161114	328369
21011	30557	66	applied	\N	\N	\N	\N	161115	161115	328370
21011	30561	67	applied	\N	\N	\N	\N	161116	161116	328371
21011	30562	68	applied	\N	\N	\N	\N	161117	161117	328372
21011	30507	69	applied	\N	\N	\N	\N	161118	161118	328373
21011	30508	70	applied	\N	\N	\N	\N	161119	161119	328374
21011	30516	71	applied	\N	\N	\N	\N	161120	161120	328375
21011	30517	72	applied	\N	\N	\N	\N	161121	161121	328376
21011	30523	73	applied	\N	\N	\N	\N	161122	161122	328377
21011	30842	74	applied	\N	\N	\N	\N	161123	161123	328378
21011	30578	75	applied	\N	\N	\N	\N	161124	161124	328379
21011	30526	76	applied	\N	\N	\N	\N	161125	161125	328380
21011	30529	77	applied	\N	\N	\N	\N	161126	161126	328381
21011	30533	78	applied	\N	\N	\N	\N	161127	161127	328382
21011	30534	79	applied	\N	\N	\N	\N	161128	161128	328383
21011	30673	81	applied	\N	\N	\N	\N	161130	161130	328385
21011	30674	82	applied	\N	\N	\N	\N	161131	161131	328386
21011	30675	83	applied	\N	\N	\N	\N	161132	161132	328387
21011	30676	84	applied	\N	\N	\N	\N	161133	161133	328388
21011	30679	85	applied	\N	\N	\N	\N	161134	161134	328389
21011	30553	86	applied	\N	\N	\N	\N	161135	161135	328390
21011	30558	87	applied	\N	\N	\N	\N	161136	161136	328391
21011	30563	88	applied	\N	\N	\N	\N	161137	161137	328392
21011	30569	89	applied	\N	\N	\N	\N	161138	161138	328393
21011	30597	90	applied	\N	\N	\N	\N	161139	161139	328394
21011	30579	91	applied	\N	\N	\N	\N	161140	161140	328395
21011	30582	92	applied	\N	\N	\N	\N	161141	161141	328396
21011	30587	93	applied	\N	\N	\N	\N	161142	161142	328397
21011	30598	94	applied	\N	\N	\N	\N	161143	161143	328398
21011	30599	96	applied	\N	\N	\N	\N	161144	161144	328399
21011	30600	97	applied	\N	\N	\N	\N	161145	161145	328400
21011	30601	99	applied	\N	\N	\N	\N	161147	161147	328401
21011	30602	100	applied	\N	\N	\N	\N	161148	161148	328402
21011	30603	101	applied	\N	\N	\N	\N	161149	161149	328403
21011	30609	102	applied	\N	\N	\N	\N	161150	161150	328404
21011	30610	103	applied	\N	\N	\N	\N	161151	161151	328405
21011	30611	104	applied	\N	\N	\N	\N	161152	161152	328406
21011	30721	105	applied	\N	\N	\N	\N	161153	161153	328407
21011	30722	106	applied	\N	\N	\N	\N	161154	161154	328408
21011	30618	107	applied	\N	\N	\N	\N	161155	161155	328409
21011	30619	108	applied	\N	\N	\N	\N	161156	161156	328410
21011	30620	109	applied	\N	\N	\N	\N	161157	161157	328411
21011	30621	110	applied	\N	\N	\N	\N	161158	161158	328412
21011	30622	111	applied	\N	\N	\N	\N	161159	161159	328413
21011	30628	112	applied	\N	\N	\N	\N	161160	161160	328414
21011	30630	113	applied	\N	\N	\N	\N	161161	161161	328415
21011	30631	114	applied	\N	\N	\N	\N	161162	161162	328416
21011	30660	116	applied	\N	\N	\N	\N	161164	161164	328418
21011	30664	117	applied	\N	\N	\N	\N	161165	161165	328419
21011	30680	118	applied	\N	\N	\N	\N	161166	161166	328420
21011	30681	119	applied	\N	\N	\N	\N	161167	161167	328421
21011	30614	120	applied	\N	\N	\N	\N	161168	161168	328422
21011	30623	121	applied	\N	\N	\N	\N	161169	161169	328423
21013	31079	0	applied	\N	\N	\N	\N	161177	161177	328431
21013	31080	1	applied	\N	\N	\N	\N	161178	161178	328432
21013	31081	2	applied	\N	\N	\N	\N	161179	161179	328433
21016	31089	0	applied	\N	\N	\N	\N	161192	161192	328446
21016	31090	1	applied	\N	\N	\N	\N	161193	161193	328447
21016	31091	2	applied	\N	\N	\N	\N	161194	161194	328448
21016	31092	3	applied	\N	\N	\N	\N	161195	161195	328449
21016	31093	4	applied	\N	\N	\N	\N	161196	161196	328450
21022	31096	0	applied	\N	\N	\N	\N	161209	161209	328463
21022	31097	1	applied	\N	\N	\N	\N	161210	161210	328464
21022	31099	3	applied	\N	\N	\N	\N	161212	161212	328466
21022	31100	4	applied	\N	\N	\N	\N	161213	161213	328467
21022	31101	5	applied	\N	\N	\N	\N	161214	161214	328468
21028	31096	0	applied	\N	\N	\N	\N	161245	161245	328499
21028	31097	1	applied	\N	\N	\N	\N	161246	161246	328500
21028	31098	2	applied	\N	\N	\N	\N	161247	161247	328501
21028	31099	3	applied	\N	\N	\N	\N	161248	161248	328502
21028	31100	4	applied	\N	\N	\N	\N	161249	161249	328503
21028	31101	5	applied	\N	\N	\N	\N	161250	161250	328504
21032	31104	0	applied	\N	\N	\N	\N	161258	161258	328512
21032	31105	1	applied	\N	\N	\N	\N	161259	161259	328513
21032	31106	2	applied	\N	\N	\N	\N	161260	161260	328514
21034	31107	0	applied	\N	\N	\N	\N	161265	161265	328519
21034	31108	1	applied	\N	\N	\N	\N	161266	161266	328520
21000	30966	116	applied	\N	\N	\N	\N	161006	161006	328262
21000	30969	117	applied	\N	\N	\N	\N	161007	161007	328263
21011	30635	125	applied	\N	\N	\N	\N	161173	161173	328427
21014	31082	0	applied	\N	\N	\N	\N	161180	161180	328434
21014	31083	1	applied	\N	\N	\N	\N	161181	161181	328435
21014	31084	2	applied	\N	\N	\N	\N	161182	161182	328436
21014	31085	3	applied	\N	\N	\N	\N	161183	161183	328437
21014	31086	4	applied	\N	\N	\N	\N	161184	161184	328438
21014	31087	5	applied	\N	\N	\N	\N	161185	161185	328439
21020	31094	0	applied	\N	\N	\N	\N	161201	161201	328455
21020	31095	1	applied	\N	\N	\N	\N	161202	161202	328456
21024	31096	0	applied	\N	\N	\N	\N	161221	161221	328475
21024	31097	1	applied	\N	\N	\N	\N	161222	161222	328476
21024	31098	2	applied	\N	\N	\N	\N	161223	161223	328477
21024	31099	3	applied	\N	\N	\N	\N	161224	161224	328478
21024	31100	4	applied	\N	\N	\N	\N	161225	161225	328479
21024	31101	5	applied	\N	\N	\N	\N	161226	161226	328480
21031	31104	0	applied	\N	\N	\N	\N	161255	161255	328509
21031	31105	1	applied	\N	\N	\N	\N	161256	161256	328510
21031	31106	2	applied	\N	\N	\N	\N	161257	161257	328511
21035	31107	0	applied	\N	\N	\N	\N	161267	161267	328521
21035	31108	1	applied	\N	\N	\N	\N	161268	161268	328522
21038	31107	0	applied	\N	\N	\N	\N	161269	161269	328523
21038	31108	1	applied	\N	\N	\N	\N	161270	161270	328524
21041	31110	0	applied	\N	\N	\N	\N	161275	161275	328529
21041	31112	2	applied	\N	\N	\N	\N	161277	161277	328531
21043	31113	0	applied	\N	\N	\N	\N	161281	161281	328535
21043	31114	1	applied	\N	\N	\N	\N	161282	161282	328536
21043	31115	2	applied	\N	\N	\N	\N	161283	161283	328537
21043	31116	3	applied	\N	\N	\N	\N	161284	161284	328538
21043	31117	4	applied	\N	\N	\N	\N	161285	161285	328539
21045	31118	0	applied	\N	\N	\N	\N	161288	161288	328542
21045	31119	1	applied	\N	\N	\N	\N	161289	161289	328543
21046	31118	0	applied	\N	\N	\N	\N	161290	161290	328544
21046	31119	1	applied	\N	\N	\N	\N	161291	161291	328545
21048	31120	0	applied	\N	\N	\N	\N	161295	161295	328549
21048	31121	1	applied	\N	\N	\N	\N	161296	161296	328550
21048	31122	2	applied	\N	\N	\N	\N	161297	161297	328551
21049	31120	0	applied	\N	\N	\N	\N	161298	161298	328552
21049	31121	1	applied	\N	\N	\N	\N	161299	161299	328553
21049	31122	2	applied	\N	\N	\N	\N	161300	161300	328554
21050	31124	1	applied	\N	\N	\N	\N	161302	161302	328556
21052	31123	0	applied	\N	\N	\N	\N	161305	161305	328559
21052	31124	1	applied	\N	\N	\N	\N	161306	161306	328560
21055	31125	0	applied	\N	\N	\N	\N	161313	161313	328567
21055	31126	1	applied	\N	\N	\N	\N	161314	161314	328568
21055	31127	2	applied	\N	\N	\N	\N	161315	161315	328569
21055	31128	3	applied	\N	\N	\N	\N	161316	161316	328570
21057	31129	0	applied	\N	\N	\N	\N	161319	161319	328573
21057	31130	1	applied	\N	\N	\N	\N	161320	161320	328574
21058	31131	0	applied	\N	\N	\N	\N	161321	161321	328575
21058	31132	1	applied	\N	\N	\N	\N	161322	161322	328576
21061	31138	0	applied	\N	\N	\N	\N	161332	161332	328586
21061	30942	1	applied	\N	\N	1000000000	\N	161333	161333	328587
21061	30933	2	applied	\N	\N	\N	\N	161334	161334	328588
21061	30934	3	applied	\N	\N	\N	\N	161335	161335	328589
21061	30999	5	applied	\N	\N	\N	\N	161337	161337	328591
21061	30935	6	applied	\N	\N	\N	\N	161338	161338	328592
21061	30936	7	applied	\N	\N	\N	\N	161339	161339	328593
21061	31008	8	applied	\N	\N	\N	\N	161340	161340	328594
21061	31139	9	applied	\N	\N	\N	\N	161341	161341	328595
21065	31138	0	applied	\N	\N	\N	\N	161421	161421	328675
21065	30942	1	applied	\N	\N	1000000000	\N	161422	161422	328676
21065	30933	2	applied	\N	\N	\N	\N	161423	161423	328677
21065	30934	3	applied	\N	\N	\N	\N	161424	161424	328678
21065	30952	4	applied	\N	\N	1000000000	\N	161425	161425	328679
21065	30999	5	applied	\N	\N	\N	\N	161426	161426	328680
21065	30935	6	applied	\N	\N	\N	\N	161427	161427	328681
21065	30936	7	applied	\N	\N	\N	\N	161428	161428	328682
21065	31008	8	applied	\N	\N	\N	\N	161429	161429	328683
21065	31139	9	applied	\N	\N	\N	\N	161430	161430	328684
21065	30888	10	applied	\N	\N	1000000000	\N	161431	161431	328685
21065	31084	11	applied	\N	\N	\N	\N	161432	161432	328686
21065	31085	12	applied	\N	\N	\N	\N	161433	161433	328687
21065	31142	13	applied	\N	\N	\N	\N	161434	161434	328688
21065	31144	15	applied	\N	\N	\N	\N	161436	161436	328690
21065	31145	16	applied	\N	\N	\N	\N	161437	161437	328691
21065	31086	17	applied	\N	\N	\N	\N	161438	161438	328692
21065	31146	18	applied	\N	\N	\N	\N	161439	161439	328693
21065	30946	19	applied	\N	\N	\N	\N	161440	161440	328694
21065	30900	20	applied	\N	\N	\N	\N	161441	161441	328695
21065	30906	21	applied	\N	\N	\N	\N	161442	161442	328696
21065	30908	22	applied	\N	\N	\N	\N	161443	161443	328697
21065	30909	23	applied	\N	\N	\N	\N	161444	161444	328698
21065	30914	24	applied	\N	\N	\N	\N	161445	161445	328699
21065	31052	25	applied	\N	\N	\N	\N	161446	161446	328700
21065	31053	26	applied	\N	\N	\N	\N	161447	161447	328701
21065	31054	27	applied	\N	\N	\N	\N	161448	161448	328702
21065	31055	28	applied	\N	\N	\N	\N	161449	161449	328703
21065	30842	29	applied	\N	\N	\N	\N	161450	161450	328704
21065	30840	30	applied	\N	\N	\N	\N	161451	161451	328705
21065	30845	32	applied	\N	\N	\N	\N	161453	161453	328707
21065	30847	33	applied	\N	\N	\N	\N	161454	161454	328708
21065	30849	34	applied	\N	\N	\N	\N	161455	161455	328709
21065	30851	35	applied	\N	\N	\N	\N	161456	161456	328710
21065	30854	36	applied	\N	\N	\N	\N	161457	161457	328711
21065	30856	37	applied	\N	\N	\N	\N	161458	161458	328712
21065	30858	38	applied	\N	\N	\N	\N	161459	161459	328713
21065	30861	39	applied	\N	\N	\N	\N	161460	161460	328714
21065	30863	40	applied	\N	\N	\N	\N	161461	161461	328715
21065	30865	41	applied	\N	\N	\N	\N	161462	161462	328716
21065	30866	42	applied	\N	\N	\N	\N	161463	161463	328717
21065	30870	43	applied	\N	\N	\N	\N	161464	161464	328718
21065	30872	44	applied	\N	\N	\N	\N	161465	161465	328719
21065	30873	45	applied	\N	\N	\N	\N	161466	161466	328720
21065	30874	46	applied	\N	\N	\N	\N	161467	161467	328721
21065	30879	47	applied	\N	\N	\N	\N	161468	161468	328722
21065	30881	49	applied	\N	\N	\N	\N	161470	161470	328724
21065	30886	50	applied	\N	\N	\N	\N	161471	161471	328725
21065	30889	51	applied	\N	\N	\N	\N	161472	161472	328726
21065	30892	52	applied	\N	\N	\N	\N	161473	161473	328727
21011	30629	123	applied	\N	\N	\N	\N	161171	161171	328425
21011	30634	124	applied	\N	\N	\N	\N	161172	161172	328426
21061	31143	14	applied	\N	\N	\N	\N	161346	161346	328600
21061	31144	15	applied	\N	\N	\N	\N	161347	161347	328601
21061	31145	16	applied	\N	\N	\N	\N	161348	161348	328602
21061	31086	17	applied	\N	\N	\N	\N	161349	161349	328603
21061	31146	18	applied	\N	\N	\N	\N	161350	161350	328604
21061	30946	19	applied	\N	\N	\N	\N	161351	161351	328605
21061	30900	20	applied	\N	\N	\N	\N	161352	161352	328606
21061	30906	21	applied	\N	\N	\N	\N	161353	161353	328607
21061	30908	22	applied	\N	\N	\N	\N	161354	161354	328608
21061	30909	23	applied	\N	\N	\N	\N	161355	161355	328609
21061	30914	24	applied	\N	\N	\N	\N	161356	161356	328610
21061	31052	25	applied	\N	\N	\N	\N	161357	161357	328611
21061	31053	26	applied	\N	\N	\N	\N	161358	161358	328612
21061	31054	27	applied	\N	\N	\N	\N	161359	161359	328613
21061	31055	28	applied	\N	\N	\N	\N	161360	161360	328614
21061	31018	29	applied	\N	\N	\N	\N	161361	161361	328615
21061	31020	31	applied	\N	\N	\N	\N	161363	161363	328617
21061	31021	32	applied	\N	\N	\N	\N	161364	161364	328618
21061	31026	33	applied	\N	\N	\N	\N	161365	161365	328619
21061	30894	34	applied	\N	\N	\N	\N	161366	161366	328620
21061	30868	35	applied	\N	\N	\N	\N	161367	161367	328621
21061	30876	36	applied	\N	\N	\N	\N	161368	161368	328622
21061	30883	37	applied	\N	\N	\N	\N	161369	161369	328623
21061	30890	38	applied	\N	\N	\N	\N	161370	161370	328624
21061	30902	39	applied	\N	\N	\N	\N	161371	161371	328625
21061	30912	40	applied	\N	\N	\N	\N	161372	161372	328626
21061	30919	41	applied	\N	\N	\N	\N	161373	161373	328627
21061	30930	42	applied	\N	\N	\N	\N	161374	161374	328628
21061	30941	43	applied	\N	\N	\N	\N	161375	161375	328629
21061	30950	44	applied	\N	\N	\N	\N	161376	161376	328630
21061	30965	45	applied	\N	\N	\N	\N	161377	161377	328631
21061	30975	46	applied	\N	\N	\N	\N	161378	161378	328632
21061	30988	48	applied	\N	\N	\N	\N	161380	161380	328634
21061	30995	49	applied	\N	\N	\N	\N	161381	161381	328635
21061	31004	50	applied	\N	\N	\N	\N	161382	161382	328636
21061	31013	51	applied	\N	\N	\N	\N	161383	161383	328637
21061	31022	52	applied	\N	\N	\N	\N	161384	161384	328638
21061	31030	53	applied	\N	\N	\N	\N	161385	161385	328639
21061	31040	54	applied	\N	\N	\N	\N	161386	161386	328640
21061	31047	55	applied	\N	\N	\N	\N	161387	161387	328641
21061	31064	56	applied	\N	\N	\N	\N	161388	161388	328642
21061	31069	57	applied	\N	\N	\N	\N	161389	161389	328643
21061	31074	58	applied	\N	\N	\N	\N	161390	161390	328644
21061	31081	59	applied	\N	\N	\N	\N	161391	161391	328645
21061	31093	60	applied	\N	\N	\N	\N	161392	161392	328646
21061	31100	61	applied	\N	\N	\N	\N	161393	161393	328647
21061	31105	62	applied	\N	\N	\N	\N	161394	161394	328648
21061	31117	63	applied	\N	\N	\N	\N	161395	161395	328649
21061	31128	65	applied	\N	\N	\N	\N	161397	161397	328651
21061	31136	66	applied	\N	\N	\N	\N	161398	161398	328652
21065	30893	53	applied	\N	\N	\N	\N	161474	161474	328728
21065	30897	54	applied	\N	\N	\N	\N	161475	161475	328729
21065	30899	55	applied	\N	\N	\N	\N	161476	161476	328730
21065	30903	56	applied	\N	\N	\N	\N	161477	161477	328731
21065	30905	58	applied	\N	\N	\N	\N	161478	161478	328732
21065	30910	59	applied	\N	\N	\N	\N	161479	161479	328733
21065	30913	60	applied	\N	\N	\N	\N	161480	161480	328734
21065	30916	61	applied	\N	\N	\N	\N	161481	161481	328735
21065	30918	62	applied	\N	\N	\N	\N	161482	161482	328736
21065	30921	63	applied	\N	\N	\N	\N	161483	161483	328737
21065	30923	64	applied	\N	\N	\N	\N	161484	161484	328738
21065	30924	65	applied	\N	\N	\N	\N	161485	161485	328739
21065	30925	66	applied	\N	\N	\N	\N	161486	161486	328740
21065	30931	67	applied	\N	\N	\N	\N	161487	161487	328741
21065	30938	69	applied	\N	\N	\N	\N	161489	161489	328743
21065	30943	70	applied	\N	\N	\N	\N	161490	161490	328744
21065	30945	71	applied	\N	\N	\N	\N	161491	161491	328745
21065	30947	72	applied	\N	\N	\N	\N	161492	161492	328746
21065	30953	73	applied	\N	\N	\N	\N	161493	161493	328747
21065	30955	74	applied	\N	\N	\N	\N	161494	161494	328748
21065	30959	75	applied	\N	\N	\N	\N	161495	161495	328749
21065	30964	76	applied	\N	\N	\N	\N	161496	161496	328750
21065	30967	77	applied	\N	\N	\N	\N	161497	161497	328751
21065	30968	78	applied	\N	\N	\N	\N	161498	161498	328752
21065	30971	79	applied	\N	\N	\N	\N	161499	161499	328753
21065	30972	80	applied	\N	\N	\N	\N	161500	161500	328754
21065	30973	81	applied	\N	\N	\N	\N	161501	161501	328755
21065	30978	82	applied	\N	\N	\N	\N	161502	161502	328756
21065	30981	83	applied	\N	\N	\N	\N	161503	161503	328757
21065	30983	84	applied	\N	\N	\N	\N	161504	161504	328758
21065	30987	86	applied	\N	\N	\N	\N	161506	161506	328760
21065	30990	87	applied	\N	\N	\N	\N	161507	161507	328761
21065	30992	88	applied	\N	\N	\N	\N	161508	161508	328762
21065	31018	89	applied	\N	\N	\N	\N	161509	161509	328763
21065	31019	90	applied	\N	\N	\N	\N	161510	161510	328764
21065	31020	91	applied	\N	\N	\N	\N	161511	161511	328765
21065	31021	92	applied	\N	\N	\N	\N	161512	161512	328766
21065	31026	93	applied	\N	\N	\N	\N	161513	161513	328767
21065	30894	94	applied	\N	\N	\N	\N	161514	161514	328768
21065	30993	95	applied	\N	\N	\N	\N	161515	161515	328769
21065	30994	96	applied	\N	\N	\N	\N	161516	161516	328770
21065	31000	97	applied	\N	\N	\N	\N	161517	161517	328771
21065	31002	98	applied	\N	\N	\N	\N	161518	161518	328772
21066	31149	0	applied	\N	\N	\N	\N	161546	161546	328800
21066	31150	1	applied	\N	\N	\N	\N	161547	161547	328801
21071	31158	0	applied	\N	\N	\N	\N	161563	161563	328817
21071	31160	2	applied	\N	\N	\N	\N	161565	161565	328819
21074	31161	0	applied	\N	\N	\N	\N	161571	161571	328825
21074	31162	1	applied	\N	\N	\N	\N	161572	161572	328826
21076	31161	0	applied	\N	\N	\N	\N	161575	161575	328829
21076	31162	1	applied	\N	\N	\N	\N	161576	161576	328830
21078	31165	0	applied	\N	\N	\N	\N	161579	161579	328833
21078	31166	1	applied	\N	\N	\N	\N	161580	161580	328834
21078	31167	2	applied	\N	\N	\N	\N	161581	161581	328835
21080	31168	0	applied	\N	\N	\N	\N	161585	161585	328839
21080	31169	1	applied	\N	\N	\N	\N	161586	161586	328840
21083	31172	0	applied	\N	\N	\N	\N	161591	161591	328845
21083	31173	1	applied	\N	\N	\N	\N	161592	161592	328846
21083	31174	2	applied	\N	\N	\N	\N	161593	161593	328847
21083	31175	3	applied	\N	\N	\N	\N	161594	161594	328848
21061	31084	11	applied	\N	\N	\N	\N	161343	161343	328597
21061	31085	12	applied	\N	\N	\N	\N	161344	161344	328598
21063	31142	4	applied	\N	\N	\N	\N	161409	161409	328663
21063	31143	5	applied	\N	\N	\N	\N	161410	161410	328664
21063	31144	6	applied	\N	\N	\N	\N	161411	161411	328665
21063	31145	7	applied	\N	\N	\N	\N	161412	161412	328666
21063	31141	8	applied	\N	\N	\N	\N	161413	161413	328667
21063	31148	9	applied	\N	\N	\N	\N	161414	161414	328668
21067	31149	0	applied	\N	\N	\N	\N	161548	161548	328802
21067	31151	1	applied	\N	\N	\N	\N	161549	161549	328803
21067	31150	2	applied	\N	\N	\N	\N	161550	161550	328804
21079	31165	0	applied	\N	\N	\N	\N	161582	161582	328836
21079	31166	1	applied	\N	\N	\N	\N	161583	161583	328837
21079	31167	2	applied	\N	\N	\N	\N	161584	161584	328838
21081	31168	0	applied	\N	\N	\N	\N	161587	161587	328841
21081	31169	1	applied	\N	\N	\N	\N	161588	161588	328842
21083	31176	5	applied	\N	\N	\N	\N	161595	161595	328849
21084	31172	0	applied	\N	\N	\N	\N	161596	161596	328850
21084	31174	2	applied	\N	\N	\N	\N	161598	161598	328852
21084	31175	3	applied	\N	\N	\N	\N	161599	161599	328853
21084	31176	5	applied	\N	\N	\N	\N	161600	161600	328854
21090	31177	0	applied	\N	\N	\N	\N	161614	161614	328868
21090	31178	1	applied	\N	\N	\N	\N	161615	161615	328869
21092	31138	0	applied	\N	\N	\N	\N	161621	161621	328875
21092	31139	1	applied	\N	\N	\N	\N	161622	161622	328876
21092	31142	2	applied	\N	\N	\N	\N	161623	161623	328877
21092	31143	3	applied	\N	\N	\N	\N	161624	161624	328878
21092	31144	4	applied	\N	\N	\N	\N	161625	161625	328879
21092	31145	5	applied	\N	\N	\N	\N	161626	161626	328880
21093	31184	0	applied	\N	\N	\N	\N	161627	161627	328881
21093	31185	1	applied	\N	\N	\N	\N	161628	161628	328882
21093	31186	2	applied	\N	\N	\N	\N	161629	161629	328883
21093	31187	3	applied	\N	\N	\N	\N	161630	161630	328884
21096	31184	0	applied	\N	\N	\N	\N	161639	161639	328893
21096	31186	2	applied	\N	\N	\N	\N	161641	161641	328895
21096	31187	3	applied	\N	\N	\N	\N	161642	161642	328896
21097	31184	0	applied	\N	\N	\N	\N	161643	161643	328897
21097	31185	1	applied	\N	\N	\N	\N	161644	161644	328898
21097	31186	2	applied	\N	\N	\N	\N	161645	161645	328899
21097	31187	3	applied	\N	\N	\N	\N	161646	161646	328900
21099	31188	0	applied	\N	\N	\N	\N	161650	161650	328904
21099	31189	1	applied	\N	\N	\N	\N	161651	161651	328905
21099	31190	2	applied	\N	\N	\N	\N	161652	161652	328906
21100	31188	0	applied	\N	\N	\N	\N	161653	161653	328907
21100	31189	1	applied	\N	\N	\N	\N	161654	161654	328908
21100	31190	2	applied	\N	\N	\N	\N	161655	161655	328909
21101	31191	0	applied	\N	\N	\N	\N	161656	161656	328910
21103	31192	0	applied	\N	\N	\N	\N	161658	161658	328912
21103	31193	1	applied	\N	\N	\N	\N	161659	161659	328913
21106	31192	0	applied	\N	\N	\N	\N	161666	161666	328920
21106	31197	2	applied	\N	\N	\N	\N	161668	161668	328922
21106	31195	3	applied	\N	\N	\N	\N	161669	161669	328923
21106	31193	4	applied	\N	\N	\N	\N	161670	161670	328924
21106	31196	5	applied	\N	\N	\N	\N	161671	161671	328925
21106	31198	6	applied	\N	\N	\N	\N	161672	161672	328926
21108	31197	0	applied	\N	\N	\N	\N	161678	161678	328932
21108	31199	1	applied	\N	\N	\N	\N	161679	161679	328933
21108	31198	2	applied	\N	\N	\N	\N	161680	161680	328934
21108	31200	3	applied	\N	\N	\N	\N	161681	161681	328935
21110	31201	0	applied	\N	\N	\N	\N	161686	161686	328940
21111	31201	0	applied	\N	\N	\N	\N	161687	161687	328941
21112	31202	0	applied	\N	\N	\N	\N	161688	161688	328942
21112	31203	1	applied	\N	\N	\N	\N	161689	161689	328943
21112	31204	2	applied	\N	\N	\N	\N	161690	161690	328944
21115	31205	0	applied	\N	\N	\N	\N	161697	161697	328951
21115	31206	1	applied	\N	\N	\N	\N	161698	161698	328952
21117	31208	1	applied	\N	\N	\N	\N	161702	161702	328956
21120	31216	0	applied	\N	\N	\N	\N	161710	161710	328964
21120	31217	1	applied	\N	\N	\N	\N	161711	161711	328965
21120	31218	2	applied	\N	\N	\N	\N	161712	161712	328966
21123	31225	0	applied	\N	\N	\N	\N	161722	161722	328976
21123	31226	1	applied	\N	\N	\N	\N	161723	161723	328977
21125	31225	0	applied	\N	\N	\N	\N	161727	161727	328981
21125	31226	1	applied	\N	\N	\N	\N	161728	161728	328982
21130	31231	0	applied	\N	\N	\N	\N	161737	161737	328991
21130	31232	1	applied	\N	\N	\N	\N	161738	161738	328992
21130	31233	2	applied	\N	\N	\N	\N	161739	161739	328993
21133	31231	0	applied	\N	\N	\N	\N	161746	161746	329000
21133	31232	1	applied	\N	\N	\N	\N	161747	161747	329001
21133	31233	2	applied	\N	\N	\N	\N	161748	161748	329002
21134	31234	0	applied	\N	\N	\N	\N	161749	161749	329003
21134	31235	1	applied	\N	\N	\N	\N	161750	161750	329004
21134	31237	3	applied	\N	\N	\N	\N	161752	161752	329006
21135	31234	0	applied	\N	\N	\N	\N	161753	161753	329007
21135	31235	1	applied	\N	\N	\N	\N	161754	161754	329008
21135	31236	2	applied	\N	\N	\N	\N	161755	161755	329009
21135	31237	3	applied	\N	\N	\N	\N	161756	161756	329010
21137	31234	0	applied	\N	\N	\N	\N	161757	161757	329011
21137	31235	1	applied	\N	\N	\N	\N	161758	161758	329012
21139	31234	0	applied	\N	\N	\N	\N	161763	161763	329017
21139	31235	1	applied	\N	\N	\N	\N	161764	161764	329018
21139	31236	2	applied	\N	\N	\N	\N	161765	161765	329019
21139	31237	3	applied	\N	\N	\N	\N	161766	161766	329020
21140	31234	0	applied	\N	\N	\N	\N	161767	161767	329021
21140	31235	1	applied	\N	\N	\N	\N	161768	161768	329022
21140	31238	2	applied	\N	\N	\N	\N	161769	161769	329023
21140	31239	3	applied	\N	\N	\N	\N	161770	161770	329024
21140	31236	4	applied	\N	\N	\N	\N	161771	161771	329025
21140	31240	6	applied	\N	\N	\N	\N	161773	161773	329027
21141	31241	0	applied	\N	\N	\N	\N	161774	161774	329028
21141	31242	1	applied	\N	\N	\N	\N	161775	161775	329029
21145	31247	0	applied	\N	\N	\N	\N	161784	161784	329038
21145	31248	1	applied	\N	\N	\N	\N	161785	161785	329039
21145	31249	2	applied	\N	\N	\N	\N	161786	161786	329040
21146	31250	0	applied	\N	\N	\N	\N	161787	161787	329041
21146	31251	1	applied	\N	\N	\N	\N	161788	161788	329042
21150	31260	0	applied	\N	\N	\N	\N	161805	161805	329059
21150	31262	1	applied	\N	\N	\N	\N	161806	161806	329060
21150	31263	2	applied	\N	\N	\N	\N	161807	161807	329061
21150	31261	3	applied	\N	\N	\N	\N	161808	161808	329062
21150	31264	4	applied	\N	\N	\N	\N	161809	161809	329063
21150	31265	5	applied	\N	\N	\N	\N	161810	161810	329064
21063	31139	1	applied	\N	\N	\N	\N	161406	161406	328660
21063	31140	2	applied	\N	\N	\N	\N	161407	161407	328661
21065	31014	103	applied	\N	\N	\N	\N	161523	161523	328777
21065	31016	104	applied	\N	\N	\N	\N	161524	161524	328778
21065	31024	105	applied	\N	\N	\N	\N	161525	161525	328779
21065	31027	106	applied	\N	\N	\N	\N	161526	161526	328780
21065	31029	107	applied	\N	\N	\N	\N	161527	161527	328781
21065	31032	108	applied	\N	\N	\N	\N	161528	161528	328782
21065	31034	109	applied	\N	\N	\N	\N	161529	161529	328783
21065	31036	110	applied	\N	\N	\N	\N	161530	161530	328784
21065	31038	111	applied	\N	\N	\N	\N	161531	161531	328785
21065	31041	112	applied	\N	\N	\N	\N	161532	161532	328786
21065	31043	113	applied	\N	\N	\N	\N	161533	161533	328787
21065	31045	114	applied	\N	\N	\N	\N	161534	161534	328788
21065	31048	115	applied	\N	\N	\N	\N	161535	161535	328789
21065	31049	116	applied	\N	\N	\N	\N	161536	161536	328790
21065	31056	117	applied	\N	\N	\N	\N	161537	161537	328791
21065	31057	118	applied	\N	\N	\N	\N	161538	161538	328792
21065	31059	120	applied	\N	\N	\N	\N	161540	161540	328794
21065	31065	121	applied	\N	\N	\N	\N	161541	161541	328795
21065	31066	122	applied	\N	\N	\N	\N	161542	161542	328796
21065	31070	123	applied	\N	\N	\N	\N	161543	161543	328797
21065	31072	124	applied	\N	\N	\N	\N	161544	161544	328798
21065	31073	125	applied	\N	\N	\N	\N	161545	161545	328799
21068	31149	0	applied	\N	\N	\N	\N	161551	161551	328805
21068	31151	1	applied	\N	\N	\N	\N	161552	161552	328806
21068	31150	2	applied	\N	\N	\N	\N	161553	161553	328807
21070	31152	0	applied	\N	\N	\N	\N	161557	161557	328811
21070	31153	1	applied	\N	\N	\N	\N	161558	161558	328812
21070	31154	2	applied	\N	\N	\N	\N	161559	161559	328813
21070	31155	3	applied	\N	\N	\N	\N	161560	161560	328814
21070	31156	4	applied	\N	\N	\N	\N	161561	161561	328815
21070	31157	5	applied	\N	\N	\N	\N	161562	161562	328816
21072	31158	0	applied	\N	\N	\N	\N	161566	161566	328820
21072	31160	2	applied	\N	\N	\N	\N	161568	161568	328822
21075	31161	0	applied	\N	\N	\N	\N	161573	161573	328827
21075	31162	1	applied	\N	\N	\N	\N	161574	161574	328828
21085	31172	0	applied	\N	\N	\N	\N	161601	161601	328855
21085	31173	1	applied	\N	\N	\N	\N	161602	161602	328856
21085	31174	2	applied	\N	\N	\N	\N	161603	161603	328857
21085	31175	3	applied	\N	\N	\N	\N	161604	161604	328858
21085	31176	5	applied	\N	\N	\N	\N	161605	161605	328859
21086	31177	0	applied	\N	\N	\N	\N	161606	161606	328860
21086	31178	1	applied	\N	\N	\N	\N	161607	161607	328861
21088	31177	0	applied	\N	\N	\N	\N	161610	161610	328864
21088	31178	1	applied	\N	\N	\N	\N	161611	161611	328865
21094	31184	0	applied	\N	\N	\N	\N	161631	161631	328885
21094	31185	1	applied	\N	\N	\N	\N	161632	161632	328886
21094	31186	2	applied	\N	\N	\N	\N	161633	161633	328887
21094	31187	3	applied	\N	\N	\N	\N	161634	161634	328888
21104	31195	1	applied	\N	\N	\N	\N	161661	161661	328915
21104	31196	2	applied	\N	\N	\N	\N	161662	161662	328916
21109	31197	0	applied	\N	\N	\N	\N	161682	161682	328936
21109	31199	1	applied	\N	\N	\N	\N	161683	161683	328937
21109	31198	2	applied	\N	\N	\N	\N	161684	161684	328938
21109	31200	3	applied	\N	\N	\N	\N	161685	161685	328939
21113	31202	0	applied	\N	\N	\N	\N	161691	161691	328945
21113	31203	1	applied	\N	\N	\N	\N	161692	161692	328946
21113	31204	2	applied	\N	\N	\N	\N	161693	161693	328947
21116	31205	0	applied	\N	\N	\N	\N	161699	161699	328953
21116	31206	1	applied	\N	\N	\N	\N	161700	161700	328954
21118	31209	0	applied	\N	\N	\N	\N	161703	161703	328957
21118	31210	1	applied	\N	\N	\N	\N	161704	161704	328958
21118	31211	2	applied	\N	\N	\N	\N	161705	161705	328959
21124	31227	0	applied	\N	\N	\N	\N	161724	161724	328978
21124	31225	1	applied	\N	\N	\N	\N	161725	161725	328979
21126	31227	0	applied	\N	\N	\N	\N	161729	161729	328983
21126	31228	1	applied	\N	\N	\N	\N	161730	161730	328984
21128	31229	0	applied	\N	\N	\N	\N	161733	161733	328987
21152	31271	0	applied	\N	\N	\N	\N	161816	161816	329070
21152	31272	1	applied	\N	\N	\N	\N	161817	161817	329071
21155	31273	0	applied	\N	\N	\N	\N	161822	161822	329076
21155	31274	1	applied	\N	\N	\N	\N	161823	161823	329077
21157	31275	0	applied	\N	\N	\N	\N	161826	161826	329080
21157	31276	1	applied	\N	\N	\N	\N	161827	161827	329081
21160	31285	0	applied	\N	\N	\N	\N	161836	161836	329090
21160	31286	1	applied	\N	\N	\N	\N	161837	161837	329091
21165	31289	0	applied	\N	\N	\N	\N	161846	161846	329100
21165	31290	1	applied	\N	\N	\N	\N	161847	161847	329101
21167	31293	0	applied	\N	\N	\N	\N	161850	161850	329104
21167	31294	1	applied	\N	\N	\N	\N	161851	161851	329105
21171	31138	0	applied	\N	\N	\N	\N	161981	161981	329235
21171	31250	2	applied	\N	\N	\N	\N	161983	161983	329237
21171	31142	3	applied	\N	\N	\N	\N	161984	161984	329238
21171	31143	4	applied	\N	\N	\N	\N	161985	161985	329239
21171	31144	5	applied	\N	\N	\N	\N	161986	161986	329240
21171	31145	6	applied	\N	\N	\N	\N	161987	161987	329241
21171	31268	7	applied	\N	\N	\N	\N	161988	161988	329242
21173	31295	0	applied	\N	\N	\N	\N	161991	161991	329245
21173	31296	1	applied	\N	\N	\N	\N	161992	161992	329246
21178	31297	0	applied	\N	\N	\N	\N	162007	162007	329261
21178	31298	1	applied	\N	\N	\N	\N	162008	162008	329262
21178	31299	2	applied	\N	\N	\N	\N	162009	162009	329263
21178	31300	3	applied	\N	\N	\N	\N	162010	162010	329264
21178	31301	4	applied	\N	\N	\N	\N	162011	162011	329265
21180	31302	0	applied	\N	\N	\N	\N	162014	162014	329268
21180	31303	1	applied	\N	\N	\N	\N	162015	162015	329269
21188	31250	0	applied	\N	\N	\N	\N	162040	162040	329294
21188	31079	2	applied	\N	\N	\N	\N	162042	162042	329296
21188	31082	3	applied	\N	\N	\N	\N	162043	162043	329297
21188	31083	4	applied	\N	\N	\N	\N	162044	162044	329298
21188	31089	5	applied	\N	\N	\N	\N	162045	162045	329299
21188	31090	6	applied	\N	\N	\N	\N	162046	162046	329300
21188	31094	7	applied	\N	\N	\N	\N	162047	162047	329301
21188	31096	8	applied	\N	\N	\N	\N	162048	162048	329302
21188	31097	9	applied	\N	\N	\N	\N	162049	162049	329303
21188	31098	10	applied	\N	\N	\N	\N	162050	162050	329304
21188	31102	11	applied	\N	\N	\N	\N	162051	162051	329305
21188	31104	12	applied	\N	\N	\N	\N	162052	162052	329306
21188	31107	13	applied	\N	\N	\N	\N	162053	162053	329307
21188	31109	14	applied	\N	\N	\N	\N	162054	162054	329308
21188	31110	15	applied	\N	\N	\N	\N	162055	162055	329309
21065	31006	100	applied	\N	\N	\N	\N	161520	161520	328774
21065	31009	101	applied	\N	\N	\N	\N	161521	161521	328775
21122	31221	2	applied	\N	\N	\N	\N	161718	161718	328972
21122	31222	3	applied	\N	\N	\N	\N	161719	161719	328973
21122	31223	4	applied	\N	\N	\N	\N	161720	161720	328974
21122	31224	5	applied	\N	\N	\N	\N	161721	161721	328975
21127	31227	0	applied	\N	\N	\N	\N	161731	161731	328985
21127	31228	1	applied	\N	\N	\N	\N	161732	161732	328986
21128	31230	1	applied	\N	\N	\N	\N	161734	161734	328988
21129	31229	0	applied	\N	\N	\N	\N	161735	161735	328989
21129	31230	1	applied	\N	\N	\N	\N	161736	161736	328990
21131	31231	0	applied	\N	\N	\N	\N	161740	161740	328994
21131	31232	1	applied	\N	\N	\N	\N	161741	161741	328995
21132	31231	0	applied	\N	\N	\N	\N	161743	161743	328997
21132	31232	1	applied	\N	\N	\N	\N	161744	161744	328998
21132	31233	2	applied	\N	\N	\N	\N	161745	161745	328999
21138	31234	0	applied	\N	\N	\N	\N	161759	161759	329013
21138	31235	1	applied	\N	\N	\N	\N	161760	161760	329014
21138	31236	2	applied	\N	\N	\N	\N	161761	161761	329015
21138	31237	3	applied	\N	\N	\N	\N	161762	161762	329016
21142	31241	0	applied	\N	\N	\N	\N	161776	161776	329030
21142	31242	1	applied	\N	\N	\N	\N	161777	161777	329031
21143	31241	0	applied	\N	\N	\N	\N	161778	161778	329032
21143	31242	1	applied	\N	\N	\N	\N	161779	161779	329033
21144	31243	0	applied	\N	\N	\N	\N	161780	161780	329034
21144	31244	1	applied	\N	\N	\N	\N	161781	161781	329035
21144	31245	2	applied	\N	\N	\N	\N	161782	161782	329036
21144	31246	3	applied	\N	\N	\N	\N	161783	161783	329037
21148	31260	0	applied	\N	\N	\N	\N	161797	161797	329051
21151	31266	0	applied	\N	\N	\N	\N	161811	161811	329065
21151	31267	1	applied	\N	\N	\N	\N	161812	161812	329066
21151	31268	2	applied	\N	\N	\N	\N	161813	161813	329067
21151	31269	3	applied	\N	\N	\N	\N	161814	161814	329068
21151	31270	4	applied	\N	\N	\N	\N	161815	161815	329069
21153	31271	0	applied	\N	\N	\N	\N	161818	161818	329072
21153	31272	1	applied	\N	\N	\N	\N	161819	161819	329073
21158	31277	0	applied	\N	\N	\N	\N	161828	161828	329082
21158	31278	1	applied	\N	\N	\N	\N	161829	161829	329083
21161	31285	0	applied	\N	\N	\N	\N	161838	161838	329092
21161	31286	1	applied	\N	\N	\N	\N	161839	161839	329093
21162	31285	0	applied	\N	\N	\N	\N	161840	161840	329094
21162	31286	1	applied	\N	\N	\N	\N	161841	161841	329095
21163	31287	0	applied	\N	\N	\N	\N	161842	161842	329096
21163	31288	1	applied	\N	\N	\N	\N	161843	161843	329097
21168	31293	0	applied	\N	\N	\N	\N	161852	161852	329106
21169	31138	0	applied	\N	\N	\N	\N	161854	161854	329108
21169	30942	1	applied	\N	\N	1000000000	\N	161855	161855	329109
21169	30933	2	applied	\N	\N	\N	\N	161856	161856	329110
21169	30934	3	applied	\N	\N	\N	\N	161857	161857	329111
21169	30952	4	applied	\N	\N	1000000000	\N	161858	161858	329112
21169	30999	5	applied	\N	\N	\N	\N	161859	161859	329113
21169	30935	6	applied	\N	\N	\N	\N	161860	161860	329114
21169	30936	7	applied	\N	\N	\N	\N	161861	161861	329115
21169	31008	8	applied	\N	\N	\N	\N	161862	161862	329116
21169	31139	9	applied	\N	\N	\N	\N	161863	161863	329117
21169	31250	10	applied	\N	\N	\N	\N	161864	161864	329118
21169	30888	11	applied	\N	\N	1000000000	\N	161865	161865	329119
21169	31084	12	applied	\N	\N	\N	\N	161866	161866	329120
21169	31085	13	applied	\N	\N	\N	\N	161867	161867	329121
21169	30835	14	applied	\N	\N	\N	\N	161868	161868	329122
21169	31142	15	applied	\N	\N	\N	\N	161869	161869	329123
21169	31144	17	applied	\N	\N	\N	\N	161871	161871	329125
21169	31145	18	applied	\N	\N	\N	\N	161872	161872	329126
21169	31086	19	applied	\N	\N	\N	\N	161873	161873	329127
21169	31146	20	applied	\N	\N	\N	\N	161874	161874	329128
21169	30838	21	applied	\N	\N	\N	\N	161875	161875	329129
21169	30946	22	applied	\N	\N	\N	\N	161876	161876	329130
21169	30900	23	applied	\N	\N	\N	\N	161877	161877	329131
21169	30906	24	applied	\N	\N	\N	\N	161878	161878	329132
21169	30908	25	applied	\N	\N	\N	\N	161879	161879	329133
21175	31295	0	applied	\N	\N	\N	\N	161995	161995	329249
21175	31296	1	applied	\N	\N	\N	\N	161996	161996	329250
21177	31297	0	applied	\N	\N	\N	\N	162002	162002	329256
21177	31298	1	applied	\N	\N	\N	\N	162003	162003	329257
21177	31299	2	applied	\N	\N	\N	\N	162004	162004	329258
21177	31300	3	applied	\N	\N	\N	\N	162005	162005	329259
21177	31301	4	applied	\N	\N	\N	\N	162006	162006	329260
21181	31305	1	applied	\N	\N	\N	\N	162017	162017	329271
21181	31306	2	applied	\N	\N	\N	\N	162018	162018	329272
21181	31307	3	applied	\N	\N	\N	\N	162019	162019	329273
21184	31310	0	applied	\N	\N	\N	\N	162024	162024	329278
21184	31311	1	applied	\N	\N	\N	\N	162025	162025	329279
21184	31312	2	applied	\N	\N	\N	\N	162026	162026	329280
21184	31313	3	applied	\N	\N	\N	\N	162027	162027	329281
21184	31314	4	applied	\N	\N	\N	\N	162028	162028	329282
21184	31315	5	applied	\N	\N	\N	\N	162029	162029	329283
21187	31316	0	applied	\N	\N	\N	\N	162038	162038	329292
21187	31317	1	applied	\N	\N	\N	\N	162039	162039	329293
21189	31138	0	applied	\N	\N	\N	\N	162147	162147	329401
21189	31139	1	applied	\N	\N	\N	\N	162148	162148	329402
21189	31250	2	applied	\N	\N	\N	\N	162149	162149	329403
21189	31084	3	applied	\N	\N	\N	\N	162150	162150	329404
21189	31085	4	applied	\N	\N	\N	\N	162151	162151	329405
21189	31143	6	applied	\N	\N	\N	\N	162153	162153	329407
21189	31144	7	applied	\N	\N	\N	\N	162154	162154	329408
21189	31145	8	applied	\N	\N	\N	\N	162155	162155	329409
21189	31086	9	applied	\N	\N	\N	\N	162156	162156	329410
21189	31146	10	applied	\N	\N	\N	\N	162157	162157	329411
21189	31043	11	applied	\N	\N	\N	\N	162158	162158	329412
21189	31052	12	applied	\N	\N	\N	\N	162159	162159	329413
21189	31053	13	applied	\N	\N	\N	\N	162160	162160	329414
21189	31054	14	applied	\N	\N	\N	\N	162161	162161	329415
21189	31055	15	applied	\N	\N	\N	\N	162162	162162	329416
21189	31045	16	applied	\N	\N	\N	\N	162163	162163	329417
21189	31048	17	applied	\N	\N	\N	\N	162164	162164	329418
21189	31049	18	applied	\N	\N	\N	\N	162165	162165	329419
21189	31056	19	applied	\N	\N	\N	\N	162166	162166	329420
21189	31057	20	applied	\N	\N	\N	\N	162167	162167	329421
21189	31058	21	applied	\N	\N	\N	\N	162168	162168	329422
21189	31065	23	applied	\N	\N	\N	\N	162170	162170	329424
21189	31066	24	applied	\N	\N	\N	\N	162171	162171	329425
21122	31219	0	applied	\N	\N	\N	\N	161716	161716	328970
21122	31220	1	applied	\N	\N	\N	\N	161717	161717	328971
21146	31256	7	applied	\N	\N	\N	\N	161793	161793	329047
21146	31257	8	applied	\N	\N	\N	\N	161794	161794	329048
21146	31258	9	applied	\N	\N	\N	\N	161795	161795	329049
21146	31259	10	applied	\N	\N	\N	\N	161796	161796	329050
21149	31260	0	applied	\N	\N	\N	\N	161799	161799	329053
21149	31262	1	applied	\N	\N	\N	\N	161800	161800	329054
21149	31263	2	applied	\N	\N	\N	\N	161801	161801	329055
21149	31261	3	applied	\N	\N	\N	\N	161802	161802	329056
21149	31264	4	applied	\N	\N	\N	\N	161803	161803	329057
21149	31265	5	applied	\N	\N	\N	\N	161804	161804	329058
21154	31273	0	applied	\N	\N	\N	\N	161820	161820	329074
21154	31274	1	applied	\N	\N	\N	\N	161821	161821	329075
21156	31275	0	applied	\N	\N	\N	\N	161824	161824	329078
21156	31276	1	applied	\N	\N	\N	\N	161825	161825	329079
21159	31279	0	applied	\N	\N	\N	\N	161830	161830	329084
21159	31280	1	applied	\N	\N	\N	\N	161831	161831	329085
21159	31282	3	applied	\N	\N	\N	\N	161833	161833	329087
21159	31283	4	applied	\N	\N	\N	\N	161834	161834	329088
21159	31284	5	applied	\N	\N	\N	\N	161835	161835	329089
21164	31289	0	applied	\N	\N	\N	\N	161844	161844	329098
21164	31290	1	applied	\N	\N	\N	\N	161845	161845	329099
21166	31291	0	applied	\N	\N	\N	\N	161848	161848	329102
21166	31292	1	applied	\N	\N	\N	\N	161849	161849	329103
21170	31295	0	applied	\N	\N	\N	\N	161979	161979	329233
21170	31296	1	applied	\N	\N	\N	\N	161980	161980	329234
21179	31302	0	applied	\N	\N	\N	\N	162012	162012	329266
21179	31303	1	applied	\N	\N	\N	\N	162013	162013	329267
21182	31308	0	applied	\N	\N	\N	\N	162020	162020	329274
21182	31309	1	applied	\N	\N	\N	\N	162021	162021	329275
21185	31310	0	applied	\N	\N	\N	\N	162030	162030	329284
21185	31311	1	applied	\N	\N	\N	\N	162031	162031	329285
21185	31312	2	applied	\N	\N	\N	\N	162032	162032	329286
21185	31314	4	applied	\N	\N	\N	\N	162034	162034	329288
21185	31315	5	applied	\N	\N	\N	\N	162035	162035	329289
21189	31070	25	applied	\N	\N	\N	\N	162172	162172	329426
21189	31072	26	applied	\N	\N	\N	\N	162173	162173	329427
21189	31073	27	applied	\N	\N	\N	\N	162174	162174	329428
21189	31077	28	applied	\N	\N	\N	\N	162175	162175	329429
21189	31079	29	applied	\N	\N	\N	\N	162176	162176	329430
21189	31082	30	applied	\N	\N	\N	\N	162177	162177	329431
21189	31083	31	applied	\N	\N	\N	\N	162178	162178	329432
21189	31089	32	applied	\N	\N	\N	\N	162179	162179	329433
21189	31090	33	applied	\N	\N	\N	\N	162180	162180	329434
21189	31094	34	applied	\N	\N	\N	\N	162181	162181	329435
21189	31096	35	applied	\N	\N	\N	\N	162182	162182	329436
21189	31097	36	applied	\N	\N	\N	\N	162183	162183	329437
21189	31098	37	applied	\N	\N	\N	\N	162184	162184	329438
21189	31102	38	applied	\N	\N	\N	\N	162185	162185	329439
21189	31107	40	applied	\N	\N	\N	\N	162187	162187	329441
21189	31109	41	applied	\N	\N	\N	\N	162188	162188	329442
21189	31110	42	applied	\N	\N	\N	\N	162189	162189	329443
21189	31113	43	applied	\N	\N	\N	\N	162190	162190	329444
21189	31114	44	applied	\N	\N	\N	\N	162191	162191	329445
21189	31118	45	applied	\N	\N	\N	\N	162192	162192	329446
21189	31120	46	applied	\N	\N	\N	\N	162193	162193	329447
21189	31123	47	applied	\N	\N	\N	\N	162194	162194	329448
21189	31125	48	applied	\N	\N	\N	\N	162195	162195	329449
21189	31126	49	applied	\N	\N	\N	\N	162196	162196	329450
21189	31129	50	applied	\N	\N	\N	\N	162197	162197	329451
21189	31131	51	applied	\N	\N	\N	\N	162198	162198	329452
21189	31133	52	applied	\N	\N	\N	\N	162199	162199	329453
21189	31134	53	applied	\N	\N	\N	\N	162200	162200	329454
21189	31140	54	applied	\N	\N	\N	\N	162201	162201	329455
21189	31147	55	applied	\N	\N	\N	\N	162202	162202	329456
21189	31152	57	applied	\N	\N	\N	\N	162204	162204	329458
21189	31153	58	applied	\N	\N	\N	\N	162205	162205	329459
21189	31154	59	applied	\N	\N	\N	\N	162206	162206	329460
21189	31158	60	applied	\N	\N	\N	\N	162207	162207	329461
21189	31161	61	applied	\N	\N	\N	\N	162208	162208	329462
21189	31163	62	applied	\N	\N	\N	\N	162209	162209	329463
21189	31165	63	applied	\N	\N	\N	\N	162210	162210	329464
21189	31168	64	applied	\N	\N	\N	\N	162211	162211	329465
21189	31170	65	applied	\N	\N	\N	\N	162212	162212	329466
21189	31172	66	applied	\N	\N	\N	\N	162213	162213	329467
21189	31173	67	applied	\N	\N	\N	\N	162214	162214	329468
21189	31177	68	applied	\N	\N	\N	\N	162215	162215	329469
21189	31179	69	applied	\N	\N	\N	\N	162216	162216	329470
21190	31318	0	applied	\N	\N	\N	\N	162272	162272	329526
21190	31319	1	applied	\N	\N	\N	\N	162273	162273	329527
21190	31320	2	applied	\N	\N	\N	\N	162274	162274	329528
21190	31322	4	applied	\N	\N	\N	\N	162276	162276	329530
21190	31323	5	applied	\N	\N	\N	\N	162277	162277	329531
21190	31324	6	applied	\N	\N	\N	\N	162278	162278	329532
21190	31325	7	applied	\N	\N	\N	\N	162279	162279	329533
21192	31326	0	applied	\N	\N	\N	\N	162288	162288	329542
21192	31327	1	applied	\N	\N	\N	\N	162289	162289	329543
21192	31328	2	applied	\N	\N	\N	\N	162290	162290	329544
21197	31331	0	applied	\N	\N	\N	\N	162300	162300	329554
21197	31332	2	applied	\N	\N	\N	\N	162301	162301	329555
21203	31345	0	applied	\N	\N	\N	\N	162322	162322	329576
21203	31346	1	applied	\N	\N	\N	\N	162323	162323	329577
21203	31347	2	applied	\N	\N	\N	\N	162324	162324	329578
21203	31348	3	applied	\N	\N	\N	\N	162325	162325	329579
21203	31349	4	applied	\N	\N	\N	\N	162326	162326	329580
21203	31350	5	applied	\N	\N	\N	\N	162327	162327	329581
21209	31355	0	applied	\N	\N	\N	\N	162461	162461	329715
21211	31359	0	applied	\N	\N	\N	\N	162465	162465	329719
21211	31360	1	applied	\N	\N	\N	\N	162466	162466	329720
21218	31365	0	applied	\N	\N	\N	\N	162477	162477	329731
21218	31366	1	applied	\N	\N	\N	\N	162478	162478	329732
21218	31367	2	applied	\N	\N	\N	\N	162479	162479	329733
21218	31368	3	applied	\N	\N	\N	\N	162480	162480	329734
21221	31369	0	applied	\N	\N	\N	\N	162483	162483	329737
21221	31370	1	applied	\N	\N	\N	\N	162484	162484	329738
21221	31371	2	applied	\N	\N	\N	\N	162485	162485	329739
21221	31372	3	applied	\N	\N	\N	\N	162486	162486	329740
21221	31373	4	applied	\N	\N	\N	\N	162487	162487	329741
21221	31374	5	applied	\N	\N	\N	\N	162488	162488	329742
21224	31377	0	applied	\N	\N	\N	\N	162493	162493	329747
21224	31378	1	applied	\N	\N	\N	\N	162494	162494	329748
21146	31253	4	applied	\N	\N	\N	\N	161790	161790	329044
21146	31254	5	applied	\N	\N	\N	\N	161791	161791	329045
21169	31054	30	applied	\N	\N	\N	\N	161884	161884	329138
21169	31055	31	applied	\N	\N	\N	\N	161885	161885	329139
21169	30842	32	applied	\N	\N	\N	\N	161886	161886	329140
21169	30840	33	applied	\N	\N	\N	\N	161887	161887	329141
21169	30841	34	applied	\N	\N	\N	\N	161888	161888	329142
21169	30845	35	applied	\N	\N	\N	\N	161889	161889	329143
21169	30847	36	applied	\N	\N	\N	\N	161890	161890	329144
21169	30849	37	applied	\N	\N	\N	\N	161891	161891	329145
21169	30851	38	applied	\N	\N	\N	\N	161892	161892	329146
21169	30854	39	applied	\N	\N	\N	\N	161893	161893	329147
21169	30856	40	applied	\N	\N	\N	\N	161894	161894	329148
21169	30858	41	applied	\N	\N	\N	\N	161895	161895	329149
21169	30861	42	applied	\N	\N	\N	\N	161896	161896	329150
21169	30863	43	applied	\N	\N	\N	\N	161897	161897	329151
21169	30865	44	applied	\N	\N	\N	\N	161898	161898	329152
21169	30866	45	applied	\N	\N	\N	\N	161899	161899	329153
21169	30872	47	applied	\N	\N	\N	\N	161901	161901	329155
21169	30873	48	applied	\N	\N	\N	\N	161902	161902	329156
21169	30874	49	applied	\N	\N	\N	\N	161903	161903	329157
21169	30879	50	applied	\N	\N	\N	\N	161904	161904	329158
21169	30880	51	applied	\N	\N	\N	\N	161905	161905	329159
21169	30881	52	applied	\N	\N	\N	\N	161906	161906	329160
21169	30886	53	applied	\N	\N	\N	\N	161907	161907	329161
21169	30889	54	applied	\N	\N	\N	\N	161908	161908	329162
21169	30892	55	applied	\N	\N	\N	\N	161909	161909	329163
21169	30893	56	applied	\N	\N	\N	\N	161910	161910	329164
21169	30897	57	applied	\N	\N	\N	\N	161911	161911	329165
21169	30899	58	applied	\N	\N	\N	\N	161912	161912	329166
21169	30903	59	applied	\N	\N	\N	\N	161913	161913	329167
21169	30905	60	applied	\N	\N	\N	\N	161914	161914	329168
21169	30910	61	applied	\N	\N	\N	\N	161915	161915	329169
21169	30913	62	applied	\N	\N	\N	\N	161916	161916	329170
21169	30918	64	applied	\N	\N	\N	\N	161918	161918	329172
21169	30921	65	applied	\N	\N	\N	\N	161919	161919	329173
21169	30923	66	applied	\N	\N	\N	\N	161920	161920	329174
21169	30924	67	applied	\N	\N	\N	\N	161921	161921	329175
21169	30925	68	applied	\N	\N	\N	\N	161922	161922	329176
21169	30931	69	applied	\N	\N	\N	\N	161923	161923	329177
21169	30937	70	applied	\N	\N	\N	\N	161924	161924	329178
21169	30938	71	applied	\N	\N	\N	\N	161925	161925	329179
21169	30943	73	applied	\N	\N	\N	\N	161926	161926	329180
21169	30945	74	applied	\N	\N	\N	\N	161927	161927	329181
21169	30947	75	applied	\N	\N	\N	\N	161928	161928	329182
21169	30953	76	applied	\N	\N	\N	\N	161929	161929	329183
21169	30955	77	applied	\N	\N	\N	\N	161930	161930	329184
21169	30959	78	applied	\N	\N	\N	\N	161931	161931	329185
21169	30964	79	applied	\N	\N	\N	\N	161932	161932	329186
21169	30967	80	applied	\N	\N	\N	\N	161933	161933	329187
21169	30971	82	applied	\N	\N	\N	\N	161935	161935	329189
21169	30972	83	applied	\N	\N	\N	\N	161936	161936	329190
21169	30973	84	applied	\N	\N	\N	\N	161937	161937	329191
21169	30978	85	applied	\N	\N	\N	\N	161938	161938	329192
21169	30981	86	applied	\N	\N	\N	\N	161939	161939	329193
21169	30983	87	applied	\N	\N	\N	\N	161940	161940	329194
21169	30985	88	applied	\N	\N	\N	\N	161941	161941	329195
21169	30987	89	applied	\N	\N	\N	\N	161942	161942	329196
21169	30990	90	applied	\N	\N	\N	\N	161943	161943	329197
21169	30992	91	applied	\N	\N	\N	\N	161944	161944	329198
21169	31018	92	applied	\N	\N	\N	\N	161945	161945	329199
21169	31019	93	applied	\N	\N	\N	\N	161946	161946	329200
21169	31020	94	applied	\N	\N	\N	\N	161947	161947	329201
21169	31021	95	applied	\N	\N	\N	\N	161948	161948	329202
21169	31026	96	applied	\N	\N	\N	\N	161949	161949	329203
21169	30894	97	applied	\N	\N	\N	\N	161950	161950	329204
21169	30994	99	applied	\N	\N	\N	\N	161952	161952	329206
21169	31000	100	applied	\N	\N	\N	\N	161953	161953	329207
21169	31002	101	applied	\N	\N	\N	\N	161954	161954	329208
21226	31381	0	applied	\N	\N	\N	\N	162497	162497	329751
21226	31382	1	applied	\N	\N	\N	\N	162498	162498	329752
21226	31383	2	applied	\N	\N	\N	\N	162499	162499	329753
21226	31384	3	applied	\N	\N	\N	\N	162500	162500	329754
21234	31396	0	applied	\N	\N	\N	\N	162522	162522	329776
21234	31397	1	applied	\N	\N	\N	\N	162523	162523	329777
21236	31398	0	applied	\N	\N	\N	\N	162526	162526	329780
21236	31399	1	applied	\N	\N	\N	\N	162527	162527	329781
21241	31410	0	applied	\N	\N	\N	\N	162560	162560	329814
21241	31411	2	applied	\N	\N	\N	\N	162561	162561	329815
21246	31412	0	applied	\N	\N	\N	\N	162586	162586	329840
21246	31413	1	applied	\N	\N	\N	\N	162587	162587	329841
21248	31416	0	applied	\N	\N	\N	\N	162590	162590	329844
21248	31418	2	applied	\N	\N	\N	\N	162592	162592	329846
21248	31419	3	applied	\N	\N	\N	\N	162593	162593	329847
21248	31420	4	applied	\N	\N	\N	\N	162594	162594	329848
21248	31421	5	applied	\N	\N	\N	\N	162595	162595	329849
21255	31431	0	applied	\N	\N	\N	\N	162630	162630	329884
21255	31432	1	applied	\N	\N	\N	\N	162631	162631	329885
21257	31433	0	applied	\N	\N	\N	\N	162634	162634	329888
21257	31434	1	applied	\N	\N	\N	\N	162635	162635	329889
21260	31439	0	applied	\N	\N	\N	\N	162640	162640	329894
21260	31440	1	applied	\N	\N	\N	\N	162641	162641	329895
21261	31441	0	applied	\N	\N	\N	\N	162642	162642	329896
21261	31442	1	applied	\N	\N	\N	\N	162643	162643	329897
21261	31443	2	applied	\N	\N	\N	\N	162644	162644	329898
21261	31444	3	applied	\N	\N	\N	\N	162645	162645	329899
21261	31445	4	applied	\N	\N	\N	\N	162646	162646	329900
21261	31446	5	applied	\N	\N	\N	\N	162647	162647	329901
21261	31448	7	applied	\N	\N	\N	\N	162649	162649	329903
21273	31464	0	applied	\N	\N	\N	\N	162708	162708	329962
21273	31465	1	applied	\N	\N	\N	\N	162709	162709	329963
21282	31497	0	applied	\N	\N	\N	\N	162833	162833	330087
21282	31498	1	applied	\N	\N	\N	\N	162834	162834	330088
21282	31499	2	applied	\N	\N	\N	\N	162835	162835	330089
21282	31500	3	applied	\N	\N	\N	\N	162836	162836	330090
21282	31501	4	applied	\N	\N	\N	\N	162837	162837	330091
21282	31502	6	applied	\N	\N	\N	\N	162838	162838	330092
21287	31513	0	applied	\N	\N	\N	\N	162855	162855	330109
21287	31514	1	applied	\N	\N	\N	\N	162856	162856	330110
21287	31515	2	applied	\N	\N	\N	\N	162857	162857	330111
21290	31520	0	applied	\N	\N	\N	\N	162866	162866	330120
21290	31521	1	applied	\N	\N	\N	\N	162867	162867	330121
21169	30914	27	applied	\N	\N	\N	\N	161881	161881	329135
21169	31052	28	applied	\N	\N	\N	\N	161882	161882	329136
21169	31014	106	applied	\N	\N	\N	\N	161959	161959	329213
21169	31016	107	applied	\N	\N	\N	\N	161960	161960	329214
21169	31024	108	applied	\N	\N	\N	\N	161961	161961	329215
21169	31027	109	applied	\N	\N	\N	\N	161962	161962	329216
21169	31029	110	applied	\N	\N	\N	\N	161963	161963	329217
21169	31032	111	applied	\N	\N	\N	\N	161964	161964	329218
21169	31034	112	applied	\N	\N	\N	\N	161965	161965	329219
21169	31036	113	applied	\N	\N	\N	\N	161966	161966	329220
21169	31038	114	applied	\N	\N	\N	\N	161967	161967	329221
21169	31041	115	applied	\N	\N	\N	\N	161968	161968	329222
21169	31043	116	applied	\N	\N	\N	\N	161969	161969	329223
21169	31045	117	applied	\N	\N	\N	\N	161970	161970	329224
21169	31048	118	applied	\N	\N	\N	\N	161971	161971	329225
21169	31049	119	applied	\N	\N	\N	\N	161972	161972	329226
21169	31056	120	applied	\N	\N	\N	\N	161973	161973	329227
21169	31057	121	applied	\N	\N	\N	\N	161974	161974	329228
21169	31059	123	applied	\N	\N	\N	\N	161976	161976	329230
21169	31065	124	applied	\N	\N	\N	\N	161977	161977	329231
21169	31066	125	applied	\N	\N	\N	\N	161978	161978	329232
21172	31295	0	applied	\N	\N	\N	\N	161989	161989	329243
21172	31296	1	applied	\N	\N	\N	\N	161990	161990	329244
21174	31295	0	applied	\N	\N	\N	\N	161993	161993	329247
21174	31296	1	applied	\N	\N	\N	\N	161994	161994	329248
21176	31297	0	applied	\N	\N	\N	\N	161997	161997	329251
21176	31298	1	applied	\N	\N	\N	\N	161998	161998	329252
21176	31299	2	applied	\N	\N	\N	\N	161999	161999	329253
21176	31300	3	applied	\N	\N	\N	\N	162000	162000	329254
21176	31301	4	applied	\N	\N	\N	\N	162001	162001	329255
21183	31308	0	applied	\N	\N	\N	\N	162022	162022	329276
21183	31309	1	applied	\N	\N	\N	\N	162023	162023	329277
21186	31316	0	applied	\N	\N	\N	\N	162036	162036	329290
21186	31317	1	applied	\N	\N	\N	\N	162037	162037	329291
21188	31114	17	applied	\N	\N	\N	\N	162057	162057	329311
21188	31118	18	applied	\N	\N	\N	\N	162058	162058	329312
21188	31120	19	applied	\N	\N	\N	\N	162059	162059	329313
21188	31123	20	applied	\N	\N	\N	\N	162060	162060	329314
21188	31125	21	applied	\N	\N	\N	\N	162061	162061	329315
21188	31126	22	applied	\N	\N	\N	\N	162062	162062	329316
21188	31129	23	applied	\N	\N	\N	\N	162063	162063	329317
21188	31131	24	applied	\N	\N	\N	\N	162064	162064	329318
21188	31133	25	applied	\N	\N	\N	\N	162065	162065	329319
21188	31134	26	applied	\N	\N	\N	\N	162066	162066	329320
21188	31140	27	applied	\N	\N	\N	\N	162067	162067	329321
21188	31147	28	applied	\N	\N	\N	\N	162068	162068	329322
21188	31149	29	applied	\N	\N	\N	\N	162069	162069	329323
21188	31152	30	applied	\N	\N	\N	\N	162070	162070	329324
21188	31153	31	applied	\N	\N	\N	\N	162071	162071	329325
21188	31154	32	applied	\N	\N	\N	\N	162072	162072	329326
21188	31161	34	applied	\N	\N	\N	\N	162074	162074	329328
21188	31163	35	applied	\N	\N	\N	\N	162075	162075	329329
21188	31165	36	applied	\N	\N	\N	\N	162076	162076	329330
21188	31168	37	applied	\N	\N	\N	\N	162077	162077	329331
21188	31170	38	applied	\N	\N	\N	\N	162078	162078	329332
21188	31172	39	applied	\N	\N	\N	\N	162079	162079	329333
21188	31173	40	applied	\N	\N	\N	\N	162080	162080	329334
21188	31177	41	applied	\N	\N	\N	\N	162081	162081	329335
21188	31179	42	applied	\N	\N	\N	\N	162082	162082	329336
21188	31180	43	applied	\N	\N	\N	\N	162083	162083	329337
21188	31184	44	applied	\N	\N	\N	\N	162084	162084	329338
21188	31185	45	applied	\N	\N	\N	\N	162085	162085	329339
21188	31188	46	applied	\N	\N	\N	\N	162086	162086	329340
21188	31191	47	applied	\N	\N	\N	\N	162087	162087	329341
21188	31192	48	applied	\N	\N	\N	\N	162088	162088	329342
21188	31194	49	applied	\N	\N	\N	\N	162089	162089	329343
21188	31199	51	applied	\N	\N	\N	\N	162091	162091	329345
21188	31201	52	applied	\N	\N	\N	\N	162092	162092	329346
21188	31202	53	applied	\N	\N	\N	\N	162093	162093	329347
21188	31205	54	applied	\N	\N	\N	\N	162094	162094	329348
21188	31207	55	applied	\N	\N	\N	\N	162095	162095	329349
21188	31209	56	applied	\N	\N	\N	\N	162096	162096	329350
21188	31212	58	applied	\N	\N	\N	\N	162097	162097	329351
21188	31213	59	applied	\N	\N	\N	\N	162098	162098	329352
21188	31216	60	applied	\N	\N	\N	\N	162099	162099	329353
21188	31219	61	applied	\N	\N	\N	\N	162100	162100	329354
21188	31220	62	applied	\N	\N	\N	\N	162101	162101	329355
21188	31221	63	applied	\N	\N	\N	\N	162102	162102	329356
21188	31227	64	applied	\N	\N	\N	\N	162103	162103	329357
21188	31229	65	applied	\N	\N	\N	\N	162104	162104	329358
21188	31231	66	applied	\N	\N	\N	\N	162105	162105	329359
21188	31234	67	applied	\N	\N	\N	\N	162106	162106	329360
21188	31238	69	applied	\N	\N	\N	\N	162108	162108	329362
21188	31241	70	applied	\N	\N	\N	\N	162109	162109	329363
21188	31243	71	applied	\N	\N	\N	\N	162110	162110	329364
21188	31244	72	applied	\N	\N	\N	\N	162111	162111	329365
21188	31247	73	applied	\N	\N	\N	\N	162112	162112	329366
21188	31251	74	applied	\N	\N	\N	\N	162113	162113	329367
21188	31252	75	applied	\N	\N	\N	\N	162114	162114	329368
21188	31253	76	applied	\N	\N	\N	\N	162115	162115	329369
21188	31254	77	applied	\N	\N	\N	\N	162116	162116	329370
21188	31260	78	applied	\N	\N	\N	\N	162117	162117	329371
21188	31262	79	applied	\N	\N	\N	\N	162118	162118	329372
21188	31263	80	applied	\N	\N	\N	\N	162119	162119	329373
21188	31266	81	applied	\N	\N	\N	\N	162120	162120	329374
21188	31267	82	applied	\N	\N	\N	\N	162121	162121	329375
21188	31271	83	applied	\N	\N	\N	\N	162122	162122	329376
21188	31273	84	applied	\N	\N	\N	\N	162123	162123	329377
21188	31277	86	applied	\N	\N	\N	\N	162125	162125	329379
21188	31279	87	applied	\N	\N	\N	\N	162126	162126	329380
21188	31280	88	applied	\N	\N	\N	\N	162127	162127	329381
21188	31281	89	applied	\N	\N	\N	\N	162128	162128	329382
21188	31285	90	applied	\N	\N	\N	\N	162129	162129	329383
21188	31287	91	applied	\N	\N	\N	\N	162130	162130	329384
21191	31318	0	applied	\N	\N	\N	\N	162280	162280	329534
21191	31319	1	applied	\N	\N	\N	\N	162281	162281	329535
21191	31320	2	applied	\N	\N	\N	\N	162282	162282	329536
21191	31321	3	applied	\N	\N	\N	\N	162283	162283	329537
21191	31322	4	applied	\N	\N	\N	\N	162284	162284	329538
21191	31323	5	applied	\N	\N	\N	\N	162285	162285	329539
21191	31324	6	applied	\N	\N	\N	\N	162286	162286	329540
21191	31325	7	applied	\N	\N	\N	\N	162287	162287	329541
21169	31006	103	applied	\N	\N	\N	\N	161956	161956	329210
21169	31009	104	applied	\N	\N	\N	\N	161957	161957	329211
21188	31295	95	applied	\N	\N	\N	\N	162134	162134	329388
21188	31297	96	applied	\N	\N	\N	\N	162135	162135	329389
21188	31298	97	applied	\N	\N	\N	\N	162136	162136	329390
21188	31299	98	applied	\N	\N	\N	\N	162137	162137	329391
21188	31302	99	applied	\N	\N	\N	\N	162138	162138	329392
21188	31304	100	applied	\N	\N	\N	\N	162139	162139	329393
21188	31305	101	applied	\N	\N	\N	\N	162140	162140	329394
21188	31308	102	applied	\N	\N	\N	\N	162141	162141	329395
21188	31310	103	applied	\N	\N	\N	\N	162142	162142	329396
21188	31311	104	applied	\N	\N	\N	\N	162143	162143	329397
21188	31312	105	applied	\N	\N	\N	\N	162144	162144	329398
21188	31318	107	applied	\N	\N	\N	\N	162146	162146	329400
21189	31180	70	applied	\N	\N	\N	\N	162217	162217	329471
21189	31184	71	applied	\N	\N	\N	\N	162218	162218	329472
21189	31185	72	applied	\N	\N	\N	\N	162219	162219	329473
21189	31188	73	applied	\N	\N	\N	\N	162220	162220	329474
21189	31191	74	applied	\N	\N	\N	\N	162221	162221	329475
21189	31192	75	applied	\N	\N	\N	\N	162222	162222	329476
21189	31194	77	applied	\N	\N	\N	\N	162223	162223	329477
21189	31197	78	applied	\N	\N	\N	\N	162224	162224	329478
21189	31199	79	applied	\N	\N	\N	\N	162225	162225	329479
21189	31201	80	applied	\N	\N	\N	\N	162226	162226	329480
21189	31202	81	applied	\N	\N	\N	\N	162227	162227	329481
21189	31205	82	applied	\N	\N	\N	\N	162228	162228	329482
21189	31207	83	applied	\N	\N	\N	\N	162229	162229	329483
21189	31209	84	applied	\N	\N	\N	\N	162230	162230	329484
21189	31212	85	applied	\N	\N	\N	\N	162231	162231	329485
21189	31216	87	applied	\N	\N	\N	\N	162233	162233	329487
21189	31219	88	applied	\N	\N	\N	\N	162234	162234	329488
21189	31220	89	applied	\N	\N	\N	\N	162235	162235	329489
21189	31221	90	applied	\N	\N	\N	\N	162236	162236	329490
21189	31227	91	applied	\N	\N	\N	\N	162237	162237	329491
21189	31229	92	applied	\N	\N	\N	\N	162238	162238	329492
21189	31231	93	applied	\N	\N	\N	\N	162239	162239	329493
21189	31234	94	applied	\N	\N	\N	\N	162240	162240	329494
21189	31235	95	applied	\N	\N	\N	\N	162241	162241	329495
21189	31238	96	applied	\N	\N	\N	\N	162242	162242	329496
21189	31241	97	applied	\N	\N	\N	\N	162243	162243	329497
21189	31243	98	applied	\N	\N	\N	\N	162244	162244	329498
21189	31244	99	applied	\N	\N	\N	\N	162245	162245	329499
21189	31247	100	applied	\N	\N	\N	\N	162246	162246	329500
21189	31251	101	applied	\N	\N	\N	\N	162247	162247	329501
21189	31252	102	applied	\N	\N	\N	\N	162248	162248	329502
21189	31254	104	applied	\N	\N	\N	\N	162250	162250	329504
21189	31260	105	applied	\N	\N	\N	\N	162251	162251	329505
21189	31262	106	applied	\N	\N	\N	\N	162252	162252	329506
21189	31263	107	applied	\N	\N	\N	\N	162253	162253	329507
21189	31266	108	applied	\N	\N	\N	\N	162254	162254	329508
21189	31267	109	applied	\N	\N	\N	\N	162255	162255	329509
21189	31271	110	applied	\N	\N	\N	\N	162256	162256	329510
21189	31273	111	applied	\N	\N	\N	\N	162257	162257	329511
21189	31275	112	applied	\N	\N	\N	\N	162258	162258	329512
21189	31277	113	applied	\N	\N	\N	\N	162259	162259	329513
21189	31279	114	applied	\N	\N	\N	\N	162260	162260	329514
21189	31280	115	applied	\N	\N	\N	\N	162261	162261	329515
21189	31281	116	applied	\N	\N	\N	\N	162262	162262	329516
21189	31285	117	applied	\N	\N	\N	\N	162263	162263	329517
21189	31287	118	applied	\N	\N	\N	\N	162264	162264	329518
21189	31289	119	applied	\N	\N	\N	\N	162265	162265	329519
21189	31293	121	applied	\N	\N	\N	\N	162267	162267	329521
21189	31295	122	applied	\N	\N	\N	\N	162268	162268	329522
21189	31297	123	applied	\N	\N	\N	\N	162269	162269	329523
21189	31298	124	applied	\N	\N	\N	\N	162270	162270	329524
21189	31299	125	applied	\N	\N	\N	\N	162271	162271	329525
21193	31326	0	applied	\N	\N	\N	\N	162291	162291	329545
21193	31327	1	applied	\N	\N	\N	\N	162292	162292	329546
21193	31328	2	applied	\N	\N	\N	\N	162293	162293	329547
21194	31329	0	applied	\N	\N	\N	\N	162294	162294	329548
21194	31330	1	applied	\N	\N	\N	\N	162295	162295	329549
21195	31331	0	applied	\N	\N	\N	\N	162296	162296	329550
21195	31332	2	applied	\N	\N	\N	\N	162297	162297	329551
21196	31331	0	applied	\N	\N	\N	\N	162298	162298	329552
21196	31332	2	applied	\N	\N	\N	\N	162299	162299	329553
21199	31335	0	applied	\N	\N	\N	\N	162304	162304	329558
21199	31336	1	applied	\N	\N	\N	\N	162305	162305	329559
21199	31338	3	applied	\N	\N	\N	\N	162307	162307	329561
21199	31339	4	applied	\N	\N	\N	\N	162308	162308	329562
21199	31340	5	applied	\N	\N	\N	\N	162309	162309	329563
21199	31341	6	applied	\N	\N	\N	\N	162310	162310	329564
21199	31342	7	applied	\N	\N	\N	\N	162311	162311	329565
21199	31343	8	applied	\N	\N	\N	\N	162312	162312	329566
21199	31344	9	applied	\N	\N	\N	\N	162313	162313	329567
21200	31342	0	applied	\N	\N	\N	\N	162314	162314	329568
21201	31342	0	applied	\N	\N	\N	\N	162315	162315	329569
21202	31345	0	applied	\N	\N	\N	\N	162316	162316	329570
21202	31346	1	applied	\N	\N	\N	\N	162317	162317	329571
21202	31347	2	applied	\N	\N	\N	\N	162318	162318	329572
21202	31348	3	applied	\N	\N	\N	\N	162319	162319	329573
21202	31349	4	applied	\N	\N	\N	\N	162320	162320	329574
21205	31138	0	applied	\N	\N	\N	\N	162330	162330	329584
21205	30933	2	applied	\N	\N	\N	\N	162332	162332	329586
21205	30934	3	applied	\N	\N	\N	\N	162333	162333	329587
21205	30952	4	applied	\N	\N	1000000000	\N	162334	162334	329588
21205	30999	5	applied	\N	\N	\N	\N	162335	162335	329589
21205	30935	6	applied	\N	\N	\N	\N	162336	162336	329590
21205	30936	7	applied	\N	\N	\N	\N	162337	162337	329591
21205	31008	8	applied	\N	\N	\N	\N	162338	162338	329592
21205	31139	9	applied	\N	\N	\N	\N	162339	162339	329593
21205	30819	10	applied	\N	\N	\N	\N	162340	162340	329594
21205	31250	11	applied	\N	\N	\N	\N	162341	162341	329595
21205	30888	12	applied	\N	\N	1000000000	\N	162342	162342	329596
21205	31084	13	applied	\N	\N	\N	\N	162343	162343	329597
21205	31085	14	applied	\N	\N	\N	\N	162344	162344	329598
21205	31142	15	applied	\N	\N	\N	\N	162345	162345	329599
21205	31143	16	applied	\N	\N	\N	\N	162346	162346	329600
21205	31144	17	applied	\N	\N	\N	\N	162347	162347	329601
21205	31145	18	applied	\N	\N	\N	\N	162348	162348	329602
21205	31086	19	applied	\N	\N	\N	\N	162349	162349	329603
21205	31146	20	applied	\N	\N	\N	\N	162350	162350	329604
21188	31291	93	applied	\N	\N	\N	\N	162132	162132	329386
21188	31293	94	applied	\N	\N	\N	\N	162133	162133	329387
21204	31352	1	applied	\N	\N	\N	\N	162329	162329	329583
21206	31317	0	applied	\N	\N	\N	\N	162455	162455	329709
21206	31342	1	applied	\N	\N	\N	\N	162456	162456	329710
21208	31355	0	applied	\N	\N	\N	\N	162459	162459	329713
21208	31356	1	applied	\N	\N	\N	\N	162460	162460	329714
21210	31357	0	applied	\N	\N	\N	\N	162463	162463	329717
21210	31358	1	applied	\N	\N	\N	\N	162464	162464	329718
21213	31359	0	applied	\N	\N	\N	\N	162469	162469	329723
21213	31360	1	applied	\N	\N	\N	\N	162470	162470	329724
21215	31361	0	applied	\N	\N	\N	\N	162473	162473	329727
21215	31362	1	applied	\N	\N	\N	\N	162474	162474	329728
21222	31375	0	applied	\N	\N	\N	\N	162489	162489	329743
21222	31376	1	applied	\N	\N	\N	\N	162490	162490	329744
21223	31377	0	applied	\N	\N	\N	\N	162491	162491	329745
21223	31378	1	applied	\N	\N	\N	\N	162492	162492	329746
21225	31379	0	applied	\N	\N	\N	\N	162495	162495	329749
21228	31385	0	applied	\N	\N	\N	\N	162505	162505	329759
21228	31386	1	applied	\N	\N	\N	\N	162506	162506	329760
21228	31387	2	applied	\N	\N	\N	\N	162507	162507	329761
21228	31388	3	applied	\N	\N	\N	\N	162508	162508	329762
21229	31385	0	applied	\N	\N	\N	\N	162509	162509	329763
21229	31386	1	applied	\N	\N	\N	\N	162510	162510	329764
21229	31387	2	applied	\N	\N	\N	\N	162511	162511	329765
21229	31388	3	applied	\N	\N	\N	\N	162512	162512	329766
21230	31389	0	applied	\N	\N	\N	\N	162513	162513	329767
21231	31390	0	applied	\N	\N	\N	\N	162514	162514	329768
21231	31391	1	applied	\N	\N	\N	\N	162515	162515	329769
21231	31392	2	applied	\N	\N	\N	\N	162516	162516	329770
21231	31393	3	applied	\N	\N	\N	\N	162517	162517	329771
21233	31394	0	applied	\N	\N	\N	\N	162520	162520	329774
21233	31395	1	applied	\N	\N	\N	\N	162521	162521	329775
21235	31396	0	applied	\N	\N	\N	\N	162524	162524	329778
21238	31400	0	applied	\N	\N	\N	\N	162538	162538	329792
21238	31401	1	applied	\N	\N	\N	\N	162539	162539	329793
21238	31402	2	applied	\N	\N	\N	\N	162540	162540	329794
21238	31408	3	applied	\N	\N	\N	\N	162541	162541	329795
21238	31403	4	applied	\N	\N	\N	\N	162542	162542	329796
21238	31409	5	applied	\N	\N	\N	\N	162543	162543	329797
21238	31404	6	applied	\N	\N	\N	\N	162544	162544	329798
21238	31405	7	applied	\N	\N	\N	\N	162545	162545	329799
21238	31406	8	applied	\N	\N	\N	\N	162546	162546	329800
21238	31407	9	applied	\N	\N	\N	\N	162547	162547	329801
21240	31410	0	applied	\N	\N	\N	\N	162558	162558	329812
21240	31411	2	applied	\N	\N	\N	\N	162559	162559	329813
21243	31138	0	applied	\N	\N	\N	\N	162564	162564	329818
21243	31139	1	applied	\N	\N	\N	\N	162565	162565	329819
21243	31400	2	applied	\N	\N	\N	\N	162566	162566	329820
21243	31250	3	applied	\N	\N	\N	\N	162567	162567	329821
21243	31402	5	applied	\N	\N	\N	\N	162569	162569	329823
21243	31142	6	applied	\N	\N	\N	\N	162570	162570	329824
21243	31143	7	applied	\N	\N	\N	\N	162571	162571	329825
21243	31144	8	applied	\N	\N	\N	\N	162572	162572	329826
21243	31145	9	applied	\N	\N	\N	\N	162573	162573	329827
21243	31403	10	applied	\N	\N	\N	\N	162574	162574	329828
21243	31268	11	applied	\N	\N	\N	\N	162575	162575	329829
21243	31317	12	applied	\N	\N	\N	\N	162576	162576	329830
21243	31342	13	applied	\N	\N	\N	\N	162577	162577	329831
21243	31404	14	applied	\N	\N	\N	\N	162578	162578	329832
21243	31405	15	applied	\N	\N	\N	\N	162579	162579	329833
21243	31406	16	applied	\N	\N	\N	\N	162580	162580	329834
21243	31407	17	applied	\N	\N	\N	\N	162581	162581	329835
21245	31412	0	applied	\N	\N	\N	\N	162584	162584	329838
21245	31413	1	applied	\N	\N	\N	\N	162585	162585	329839
21247	31414	0	applied	\N	\N	\N	\N	162588	162588	329842
21250	31422	0	applied	\N	\N	\N	\N	162604	162604	329858
21250	31423	1	applied	\N	\N	\N	\N	162605	162605	329859
21250	31424	2	applied	\N	\N	\N	\N	162606	162606	329860
21250	31425	3	applied	\N	\N	\N	\N	162607	162607	329861
21250	31426	4	applied	\N	\N	\N	\N	162608	162608	329862
21250	31427	5	applied	\N	\N	\N	\N	162609	162609	329863
21250	31428	6	applied	\N	\N	\N	\N	162610	162610	329864
21250	31429	7	applied	\N	\N	\N	\N	162611	162611	329865
21251	31422	0	applied	\N	\N	\N	\N	162612	162612	329866
21251	31423	1	applied	\N	\N	\N	\N	162613	162613	329867
21254	31430	0	applied	\N	\N	\N	\N	162629	162629	329883
21256	31431	0	applied	\N	\N	\N	\N	162632	162632	329886
21256	31432	1	applied	\N	\N	\N	\N	162633	162633	329887
21263	31441	0	applied	\N	\N	\N	\N	162658	162658	329912
21263	31442	1	applied	\N	\N	\N	\N	162659	162659	329913
21263	31443	2	applied	\N	\N	\N	\N	162660	162660	329914
21263	31445	4	applied	\N	\N	\N	\N	162662	162662	329916
21263	31446	5	applied	\N	\N	\N	\N	162663	162663	329917
21263	31447	6	applied	\N	\N	\N	\N	162664	162664	329918
21263	31448	7	applied	\N	\N	\N	\N	162665	162665	329919
21265	31449	0	applied	\N	\N	\N	\N	162670	162670	329924
21265	31450	1	applied	\N	\N	\N	\N	162671	162671	329925
21265	31451	2	applied	\N	\N	\N	\N	162672	162672	329926
21265	31452	3	applied	\N	\N	\N	\N	162673	162673	329927
21267	31449	0	applied	\N	\N	\N	\N	162678	162678	329932
21267	31450	1	applied	\N	\N	\N	\N	162679	162679	329933
21267	31451	2	applied	\N	\N	\N	\N	162680	162680	329934
21267	31452	3	applied	\N	\N	\N	\N	162681	162681	329935
21278	31493	0	applied	\N	\N	\N	\N	162773	162773	330027
21278	31494	1	applied	\N	\N	\N	\N	162774	162774	330028
21278	31495	2	applied	\N	\N	\N	\N	162775	162775	330029
21278	31496	3	applied	\N	\N	\N	\N	162776	162776	330030
21286	31511	1	applied	\N	\N	\N	\N	162853	162853	330107
21286	31512	2	applied	\N	\N	\N	\N	162854	162854	330108
21289	31516	0	applied	\N	\N	\N	\N	162862	162862	330116
21289	31517	1	applied	\N	\N	\N	\N	162863	162863	330117
21289	31518	2	applied	\N	\N	\N	\N	162864	162864	330118
21289	31519	3	applied	\N	\N	\N	\N	162865	162865	330119
21291	31520	0	applied	\N	\N	\N	\N	162872	162872	330126
21291	31521	1	applied	\N	\N	\N	\N	162873	162873	330127
21291	31522	2	applied	\N	\N	\N	\N	162874	162874	330128
21291	31523	3	applied	\N	\N	\N	\N	162875	162875	330129
21291	31524	4	applied	\N	\N	\N	\N	162876	162876	330130
21291	31525	5	applied	\N	\N	\N	\N	162877	162877	330131
21299	31536	0	applied	\N	\N	\N	\N	162910	162910	330164
21299	31537	1	applied	\N	\N	\N	\N	162911	162911	330165
21198	31334	1	applied	\N	\N	\N	\N	162303	162303	329557
21202	31350	5	applied	\N	\N	\N	\N	162321	162321	329575
21205	30914	26	applied	\N	\N	\N	\N	162356	162356	329610
21205	31052	27	applied	\N	\N	\N	\N	162357	162357	329611
21205	31053	28	applied	\N	\N	\N	\N	162358	162358	329612
21205	31054	29	applied	\N	\N	\N	\N	162359	162359	329613
21205	31055	30	applied	\N	\N	\N	\N	162360	162360	329614
21205	30842	31	applied	\N	\N	\N	\N	162361	162361	329615
21205	31018	32	applied	\N	\N	\N	\N	162362	162362	329616
21205	31019	33	applied	\N	\N	\N	\N	162363	162363	329617
21205	31020	34	applied	\N	\N	\N	\N	162364	162364	329618
21205	31021	35	applied	\N	\N	\N	\N	162365	162365	329619
21205	31026	36	applied	\N	\N	\N	\N	162366	162366	329620
21205	30894	37	applied	\N	\N	\N	\N	162367	162367	329621
21205	30822	38	applied	\N	\N	\N	\N	162368	162368	329622
21205	30823	39	applied	\N	\N	\N	\N	162369	162369	329623
21205	30826	40	applied	\N	\N	\N	\N	162370	162370	329624
21205	30828	41	applied	\N	\N	\N	\N	162371	162371	329625
21205	30832	43	applied	\N	\N	\N	\N	162373	162373	329627
21205	30835	44	applied	\N	\N	\N	\N	162374	162374	329628
21205	30838	45	applied	\N	\N	\N	\N	162375	162375	329629
21205	30840	46	applied	\N	\N	\N	\N	162376	162376	329630
21205	30841	47	applied	\N	\N	\N	\N	162377	162377	329631
21205	30845	48	applied	\N	\N	\N	\N	162378	162378	329632
21205	30847	49	applied	\N	\N	\N	\N	162379	162379	329633
21205	30849	50	applied	\N	\N	\N	\N	162380	162380	329634
21205	30851	51	applied	\N	\N	\N	\N	162381	162381	329635
21205	30854	52	applied	\N	\N	\N	\N	162382	162382	329636
21205	30856	53	applied	\N	\N	\N	\N	162383	162383	329637
21205	30858	54	applied	\N	\N	\N	\N	162384	162384	329638
21205	30861	55	applied	\N	\N	\N	\N	162385	162385	329639
21205	30863	56	applied	\N	\N	\N	\N	162386	162386	329640
21205	30865	57	applied	\N	\N	\N	\N	162387	162387	329641
21205	30866	58	applied	\N	\N	\N	\N	162388	162388	329642
21205	30872	60	applied	\N	\N	\N	\N	162390	162390	329644
21205	30873	61	applied	\N	\N	\N	\N	162391	162391	329645
21205	30874	62	applied	\N	\N	\N	\N	162392	162392	329646
21205	30879	63	applied	\N	\N	\N	\N	162393	162393	329647
21205	30880	64	applied	\N	\N	\N	\N	162394	162394	329648
21205	30881	65	applied	\N	\N	\N	\N	162395	162395	329649
21205	30886	66	applied	\N	\N	\N	\N	162396	162396	329650
21205	30889	67	applied	\N	\N	\N	\N	162397	162397	329651
21205	30892	68	applied	\N	\N	\N	\N	162398	162398	329652
21205	30893	69	applied	\N	\N	\N	\N	162399	162399	329653
21205	30897	70	applied	\N	\N	\N	\N	162400	162400	329654
21205	30899	71	applied	\N	\N	\N	\N	162401	162401	329655
21205	30903	72	applied	\N	\N	\N	\N	162402	162402	329656
21205	30905	73	applied	\N	\N	\N	\N	162403	162403	329657
21205	30910	74	applied	\N	\N	\N	\N	162404	162404	329658
21205	30913	75	applied	\N	\N	\N	\N	162405	162405	329659
21205	30918	77	applied	\N	\N	\N	\N	162407	162407	329661
21205	30921	78	applied	\N	\N	\N	\N	162408	162408	329662
21205	30923	79	applied	\N	\N	\N	\N	162409	162409	329663
21205	30924	80	applied	\N	\N	\N	\N	162410	162410	329664
21205	30925	81	applied	\N	\N	\N	\N	162411	162411	329665
21205	30931	82	applied	\N	\N	\N	\N	162412	162412	329666
21205	30937	83	applied	\N	\N	\N	\N	162413	162413	329667
21205	30938	84	applied	\N	\N	\N	\N	162414	162414	329668
21205	30943	85	applied	\N	\N	\N	\N	162415	162415	329669
21205	30945	86	applied	\N	\N	\N	\N	162416	162416	329670
21205	30947	87	applied	\N	\N	\N	\N	162417	162417	329671
21205	30953	88	applied	\N	\N	\N	\N	162418	162418	329672
21205	30955	89	applied	\N	\N	\N	\N	162419	162419	329673
21205	30959	90	applied	\N	\N	\N	\N	162420	162420	329674
21205	30964	91	applied	\N	\N	\N	\N	162421	162421	329675
21205	30967	92	applied	\N	\N	\N	\N	162422	162422	329676
21205	30971	94	applied	\N	\N	\N	\N	162424	162424	329678
21205	30972	95	applied	\N	\N	\N	\N	162425	162425	329679
21205	30973	96	applied	\N	\N	\N	\N	162426	162426	329680
21299	31538	2	applied	\N	\N	\N	\N	162912	162912	330166
21300	31539	0	applied	\N	\N	\N	\N	162913	162913	330167
21300	31540	1	applied	\N	\N	\N	\N	162914	162914	330168
21300	31541	2	applied	\N	\N	\N	\N	162915	162915	330169
21300	31542	3	applied	\N	\N	\N	\N	162916	162916	330170
21305	31543	0	applied	\N	\N	\N	\N	163052	163052	330306
21305	31544	1	applied	\N	\N	\N	\N	163053	163053	330307
21305	31545	2	applied	\N	\N	\N	\N	163054	163054	330308
21307	31546	0	applied	\N	\N	\N	\N	163058	163058	330312
21307	31547	1	applied	\N	\N	\N	\N	163059	163059	330313
21307	31548	2	applied	\N	\N	\N	\N	163060	163060	330314
21311	31546	0	applied	\N	\N	\N	\N	163190	163190	330444
21311	31547	1	applied	\N	\N	\N	\N	163191	163191	330445
21316	31555	0	applied	\N	\N	\N	\N	163206	163206	330460
21316	31556	1	applied	\N	\N	\N	\N	163207	163207	330461
21316	31557	2	applied	\N	\N	\N	\N	163208	163208	330462
21317	31558	0	applied	\N	\N	\N	\N	163209	163209	330463
21317	31559	1	applied	\N	\N	\N	\N	163210	163210	330464
21317	31560	2	applied	\N	\N	\N	\N	163211	163211	330465
21317	31561	3	applied	\N	\N	\N	\N	163212	163212	330466
21317	31562	4	applied	\N	\N	\N	\N	163213	163213	330467
21317	31563	5	applied	\N	\N	\N	\N	163214	163214	330468
21317	31564	6	applied	\N	\N	\N	\N	163215	163215	330469
21317	31565	7	applied	\N	\N	\N	\N	163216	163216	330470
21317	31566	8	applied	\N	\N	\N	\N	163217	163217	330471
21317	31567	9	applied	\N	\N	\N	\N	163218	163218	330472
21317	31568	10	applied	\N	\N	\N	\N	163219	163219	330473
21317	31569	11	applied	\N	\N	\N	\N	163220	163220	330474
21317	31570	12	applied	\N	\N	\N	\N	163221	163221	330475
21319	31559	1	applied	\N	\N	\N	\N	163236	163236	330490
21319	31560	2	applied	\N	\N	\N	\N	163237	163237	330491
21319	31561	3	applied	\N	\N	\N	\N	163238	163238	330492
21319	31562	4	applied	\N	\N	\N	\N	163239	163239	330493
21319	31563	5	applied	\N	\N	\N	\N	163240	163240	330494
21319	31564	6	applied	\N	\N	\N	\N	163241	163241	330495
21319	31565	7	applied	\N	\N	\N	\N	163242	163242	330496
21319	31566	8	applied	\N	\N	\N	\N	163243	163243	330497
21319	31567	9	applied	\N	\N	\N	\N	163244	163244	330498
21319	31568	10	applied	\N	\N	\N	\N	163245	163245	330499
21319	31569	11	applied	\N	\N	\N	\N	163246	163246	330500
21319	31570	12	applied	\N	\N	\N	\N	163247	163247	330501
21324	31582	0	applied	\N	\N	\N	\N	163262	163262	330516
21324	31583	1	applied	\N	\N	\N	\N	163263	163263	330517
21205	30906	23	applied	\N	\N	\N	\N	162353	162353	329607
21205	30908	24	applied	\N	\N	\N	\N	162354	162354	329608
21205	30985	100	applied	\N	\N	\N	\N	162430	162430	329684
21205	30987	101	applied	\N	\N	\N	\N	162431	162431	329685
21205	30990	102	applied	\N	\N	\N	\N	162432	162432	329686
21205	30992	103	applied	\N	\N	\N	\N	162433	162433	329687
21205	30993	104	applied	\N	\N	\N	\N	162434	162434	329688
21205	30994	105	applied	\N	\N	\N	\N	162435	162435	329689
21205	31000	107	applied	\N	\N	\N	\N	162436	162436	329690
21205	31003	109	applied	\N	\N	\N	\N	162438	162438	329692
21205	31006	110	applied	\N	\N	\N	\N	162439	162439	329693
21205	31009	111	applied	\N	\N	\N	\N	162440	162440	329694
21205	31010	112	applied	\N	\N	\N	\N	162441	162441	329695
21205	31014	113	applied	\N	\N	\N	\N	162442	162442	329696
21205	31016	114	applied	\N	\N	\N	\N	162443	162443	329697
21205	31024	115	applied	\N	\N	\N	\N	162444	162444	329698
21205	31027	116	applied	\N	\N	\N	\N	162445	162445	329699
21205	31029	117	applied	\N	\N	\N	\N	162446	162446	329700
21205	31032	118	applied	\N	\N	\N	\N	162447	162447	329701
21205	31034	119	applied	\N	\N	\N	\N	162448	162448	329702
21205	31036	120	applied	\N	\N	\N	\N	162449	162449	329703
21205	31038	121	applied	\N	\N	\N	\N	162450	162450	329704
21205	31041	122	applied	\N	\N	\N	\N	162451	162451	329705
21205	31043	123	applied	\N	\N	\N	\N	162452	162452	329706
21205	31045	124	applied	\N	\N	\N	\N	162453	162453	329707
21207	31353	0	applied	\N	\N	\N	\N	162457	162457	329711
21207	31354	1	applied	\N	\N	\N	\N	162458	162458	329712
21212	31359	0	applied	\N	\N	\N	\N	162467	162467	329721
21212	31360	1	applied	\N	\N	\N	\N	162468	162468	329722
21214	31361	0	applied	\N	\N	\N	\N	162471	162471	329725
21214	31362	1	applied	\N	\N	\N	\N	162472	162472	329726
21216	31363	0	applied	\N	\N	\N	\N	162475	162475	329729
21216	31364	1	applied	\N	\N	\N	\N	162476	162476	329730
21219	31365	0	applied	\N	\N	\N	\N	162481	162481	329735
21219	31366	1	applied	\N	\N	\N	\N	162482	162482	329736
21227	31385	0	applied	\N	\N	\N	\N	162501	162501	329755
21227	31386	1	applied	\N	\N	\N	\N	162502	162502	329756
21227	31387	2	applied	\N	\N	\N	\N	162503	162503	329757
21227	31388	3	applied	\N	\N	\N	\N	162504	162504	329758
21232	31394	0	applied	\N	\N	\N	\N	162518	162518	329772
21232	31395	1	applied	\N	\N	\N	\N	162519	162519	329773
21237	31401	1	applied	\N	\N	\N	\N	162529	162529	329783
21237	31402	2	applied	\N	\N	\N	\N	162530	162530	329784
21237	31403	3	applied	\N	\N	\N	\N	162531	162531	329785
21237	31317	4	applied	\N	\N	\N	\N	162532	162532	329786
21237	31342	5	applied	\N	\N	\N	\N	162533	162533	329787
21237	31404	6	applied	\N	\N	\N	\N	162534	162534	329788
21237	31405	7	applied	\N	\N	\N	\N	162535	162535	329789
21237	31406	8	applied	\N	\N	\N	\N	162536	162536	329790
21237	31407	9	applied	\N	\N	\N	\N	162537	162537	329791
21239	31400	0	applied	\N	\N	\N	\N	162548	162548	329802
21239	31401	1	applied	\N	\N	\N	\N	162549	162549	329803
21239	31402	2	applied	\N	\N	\N	\N	162550	162550	329804
21239	31408	3	applied	\N	\N	\N	\N	162551	162551	329805
21239	31403	4	applied	\N	\N	\N	\N	162552	162552	329806
21239	31409	5	applied	\N	\N	\N	\N	162553	162553	329807
21239	31404	6	applied	\N	\N	\N	\N	162554	162554	329808
21239	31406	8	applied	\N	\N	\N	\N	162556	162556	329810
21239	31407	9	applied	\N	\N	\N	\N	162557	162557	329811
21242	31410	0	applied	\N	\N	\N	\N	162562	162562	329816
21242	31411	2	applied	\N	\N	\N	\N	162563	162563	329817
21244	31412	0	applied	\N	\N	\N	\N	162582	162582	329836
21244	31413	1	applied	\N	\N	\N	\N	162583	162583	329837
21249	31422	0	applied	\N	\N	\N	\N	162596	162596	329850
21249	31423	1	applied	\N	\N	\N	\N	162597	162597	329851
21249	31424	2	applied	\N	\N	\N	\N	162598	162598	329852
21249	31425	3	applied	\N	\N	\N	\N	162599	162599	329853
21249	31426	4	applied	\N	\N	\N	\N	162600	162600	329854
21249	31427	5	applied	\N	\N	\N	\N	162601	162601	329855
21249	31428	6	applied	\N	\N	\N	\N	162602	162602	329856
21249	31429	7	applied	\N	\N	\N	\N	162603	162603	329857
21252	31422	0	applied	\N	\N	\N	\N	162620	162620	329874
21252	31423	1	applied	\N	\N	\N	\N	162621	162621	329875
21252	31425	3	applied	\N	\N	\N	\N	162623	162623	329877
21252	31426	4	applied	\N	\N	\N	\N	162624	162624	329878
21252	31427	5	applied	\N	\N	\N	\N	162625	162625	329879
21252	31428	6	applied	\N	\N	\N	\N	162626	162626	329880
21252	31429	7	applied	\N	\N	\N	\N	162627	162627	329881
21253	31430	0	applied	\N	\N	\N	\N	162628	162628	329882
21258	31435	0	applied	\N	\N	\N	\N	162636	162636	329890
21258	31436	1	applied	\N	\N	\N	\N	162637	162637	329891
21262	31441	0	applied	\N	\N	\N	\N	162650	162650	329904
21262	31442	1	applied	\N	\N	\N	\N	162651	162651	329905
21262	31443	2	applied	\N	\N	\N	\N	162652	162652	329906
21262	31444	3	applied	\N	\N	\N	\N	162653	162653	329907
21262	31445	4	applied	\N	\N	\N	\N	162654	162654	329908
21262	31446	5	applied	\N	\N	\N	\N	162655	162655	329909
21262	31447	6	applied	\N	\N	\N	\N	162656	162656	329910
21262	31448	7	applied	\N	\N	\N	\N	162657	162657	329911
21264	31450	1	applied	\N	\N	\N	\N	162667	162667	329921
21264	31451	2	applied	\N	\N	\N	\N	162668	162668	329922
21264	31452	3	applied	\N	\N	\N	\N	162669	162669	329923
21266	31449	0	applied	\N	\N	\N	\N	162674	162674	329928
21266	31450	1	applied	\N	\N	\N	\N	162675	162675	329929
21266	31451	2	applied	\N	\N	\N	\N	162676	162676	329930
21266	31452	3	applied	\N	\N	\N	\N	162677	162677	329931
21270	31454	0	applied	\N	\N	\N	\N	162688	162688	329942
21271	31455	0	applied	\N	\N	\N	\N	162689	162689	329943
21271	31456	1	applied	\N	\N	\N	\N	162690	162690	329944
21271	31457	2	applied	\N	\N	\N	\N	162691	162691	329945
21271	31458	3	applied	\N	\N	\N	\N	162692	162692	329946
21271	31459	4	applied	\N	\N	\N	\N	162693	162693	329947
21271	31460	5	applied	\N	\N	\N	\N	162694	162694	329948
21271	31462	7	applied	\N	\N	1000000000	\N	162696	162696	329950
21271	31463	8	applied	\N	\N	1000000000	\N	162697	162697	329951
21274	31474	0	applied	\N	\N	\N	\N	162710	162710	329964
21274	31475	1	applied	\N	\N	\N	\N	162711	162711	329965
21274	31476	2	applied	\N	\N	\N	\N	162712	162712	329966
21274	31477	3	applied	\N	\N	\N	\N	162713	162713	329967
21274	31478	4	applied	\N	\N	1000000000	\N	162714	162714	329968
21274	31466	5	applied	\N	\N	1000000000	\N	162715	162715	329969
21205	30981	98	applied	\N	\N	\N	\N	162428	162428	329682
21205	30983	99	applied	\N	\N	\N	\N	162429	162429	329683
21251	31427	5	applied	\N	\N	\N	\N	162617	162617	329871
21251	31428	6	applied	\N	\N	\N	\N	162618	162618	329872
21251	31429	7	applied	\N	\N	\N	\N	162619	162619	329873
21259	31437	0	applied	\N	\N	\N	\N	162638	162638	329892
21259	31438	1	applied	\N	\N	\N	\N	162639	162639	329893
21268	31449	0	applied	\N	\N	\N	\N	162682	162682	329936
21268	31450	1	applied	\N	\N	\N	\N	162683	162683	329937
21268	31451	2	applied	\N	\N	\N	\N	162684	162684	329938
21268	31452	3	applied	\N	\N	\N	\N	162685	162685	329939
21269	31453	0	applied	\N	\N	\N	\N	162686	162686	329940
21269	31454	1	applied	\N	\N	\N	\N	162687	162687	329941
21272	31464	0	applied	\N	\N	\N	\N	162698	162698	329952
21272	31465	1	applied	\N	\N	\N	\N	162699	162699	329953
21272	31467	3	applied	\N	\N	\N	\N	162701	162701	329955
21272	31468	4	applied	\N	\N	1000000000	\N	162702	162702	329956
21272	31469	5	applied	\N	\N	1000000000	\N	162703	162703	329957
21272	31470	6	applied	\N	\N	\N	\N	162704	162704	329958
21272	31471	7	applied	\N	\N	\N	\N	162705	162705	329959
21272	31472	8	applied	\N	\N	1000000000	\N	162706	162706	329960
21272	31473	9	applied	\N	\N	1000000000	\N	162707	162707	329961
21274	31479	6	applied	\N	\N	1000000000	\N	162716	162716	329970
21274	31480	7	applied	\N	\N	1000000000	\N	162717	162717	329971
21274	31481	8	applied	\N	\N	\N	\N	162718	162718	329972
21274	31482	9	applied	\N	\N	1000000000	\N	162719	162719	329973
21274	31467	10	applied	\N	\N	\N	\N	162720	162720	329974
21274	31483	11	applied	\N	\N	\N	\N	162721	162721	329975
21274	31484	12	applied	\N	\N	\N	\N	162722	162722	329976
21274	31468	13	applied	\N	\N	1000000000	\N	162723	162723	329977
21274	31469	14	applied	\N	\N	1000000000	\N	162724	162724	329978
21274	31470	15	applied	\N	\N	\N	\N	162725	162725	329979
21274	31471	16	applied	\N	\N	\N	\N	162726	162726	329980
21274	31473	18	applied	\N	\N	1000000000	\N	162728	162728	329982
21274	31485	19	applied	\N	\N	1000000000	\N	162729	162729	329983
21274	31486	20	applied	\N	\N	1000000000	\N	162730	162730	329984
21274	31487	21	applied	\N	\N	\N	\N	162731	162731	329985
21274	31488	22	applied	\N	\N	1000000000	\N	162732	162732	329986
21274	31489	23	applied	\N	\N	\N	\N	162733	162733	329987
21274	31490	24	applied	\N	\N	\N	\N	162734	162734	329988
21274	31491	25	applied	\N	\N	\N	\N	162735	162735	329989
21274	31492	26	applied	\N	\N	\N	\N	162736	162736	329990
21275	31493	0	applied	\N	\N	\N	\N	162737	162737	329991
21275	31494	1	applied	\N	\N	\N	\N	162738	162738	329992
21275	31495	2	applied	\N	\N	\N	\N	162739	162739	329993
21275	31496	3	applied	\N	\N	\N	\N	162740	162740	329994
21277	31416	0	applied	\N	\N	\N	\N	162741	162741	329995
21277	31464	1	applied	\N	\N	\N	\N	162742	162742	329996
21277	31422	2	applied	\N	\N	\N	\N	162743	162743	329997
21277	31417	3	applied	\N	\N	\N	\N	162744	162744	329998
21277	31423	4	applied	\N	\N	\N	\N	162745	162745	329999
21277	31424	5	applied	\N	\N	\N	\N	162746	162746	330000
21277	31419	7	applied	\N	\N	\N	\N	162748	162748	330002
21277	31420	8	applied	\N	\N	\N	\N	162749	162749	330003
21277	31477	9	applied	\N	\N	\N	\N	162750	162750	330004
21277	31478	10	applied	\N	\N	1000000000	\N	162751	162751	330005
21277	31479	11	applied	\N	\N	1000000000	\N	162752	162752	330006
21277	31480	12	applied	\N	\N	1000000000	\N	162753	162753	330007
21277	31481	13	applied	\N	\N	\N	\N	162754	162754	330008
21277	31482	14	applied	\N	\N	1000000000	\N	162755	162755	330009
21277	31461	15	applied	\N	\N	1000000000	\N	162756	162756	330010
21277	31462	16	applied	\N	\N	1000000000	\N	162757	162757	330011
21277	31463	17	applied	\N	\N	1000000000	\N	162758	162758	330012
21277	31466	18	applied	\N	\N	1000000000	\N	162759	162759	330013
21277	31468	19	applied	\N	\N	1000000000	\N	162760	162760	330014
21277	31469	20	applied	\N	\N	1000000000	\N	162761	162761	330015
21277	31470	21	applied	\N	\N	\N	\N	162762	162762	330016
21284	31503	0	applied	\N	\N	\N	\N	162845	162845	330099
21284	31505	2	applied	\N	\N	\N	\N	162847	162847	330101
21294	31530	0	applied	\N	\N	\N	\N	162886	162886	330140
21294	31531	1	applied	\N	\N	\N	\N	162887	162887	330141
21294	31532	2	applied	\N	\N	\N	\N	162888	162888	330142
21294	31533	3	applied	\N	\N	\N	\N	162889	162889	330143
21294	31534	4	applied	\N	\N	\N	\N	162890	162890	330144
21294	31535	5	applied	\N	\N	\N	\N	162891	162891	330145
21301	31539	0	applied	\N	\N	\N	\N	162917	162917	330171
21301	31540	1	applied	\N	\N	\N	\N	162918	162918	330172
21301	31541	2	applied	\N	\N	\N	\N	162919	162919	330173
21301	31542	3	applied	\N	\N	\N	\N	162920	162920	330174
21303	31543	0	applied	\N	\N	\N	\N	163046	163046	330300
21303	31544	1	applied	\N	\N	\N	\N	163047	163047	330301
21303	31545	2	applied	\N	\N	\N	\N	163048	163048	330302
21308	31547	0	applied	\N	\N	\N	\N	163061	163061	330315
21310	31138	0	applied	\N	\N	\N	\N	163065	163065	330319
21310	30933	2	applied	\N	\N	\N	\N	163067	163067	330321
21310	30934	3	applied	\N	\N	\N	\N	163068	163068	330322
21310	30952	4	applied	\N	\N	1000000000	\N	163069	163069	330323
21310	30999	5	applied	\N	\N	\N	\N	163070	163070	330324
21310	30935	6	applied	\N	\N	\N	\N	163071	163071	330325
21310	30936	7	applied	\N	\N	\N	\N	163072	163072	330326
21310	31008	8	applied	\N	\N	\N	\N	163073	163073	330327
21310	31416	9	applied	\N	\N	\N	\N	163074	163074	330328
21310	31139	10	applied	\N	\N	\N	\N	163075	163075	330329
21310	31400	11	applied	\N	\N	\N	\N	163076	163076	330330
21310	31250	12	applied	\N	\N	\N	\N	163077	163077	330331
21310	31422	13	applied	\N	\N	\N	\N	163078	163078	330332
21310	31417	14	applied	\N	\N	\N	\N	163079	163079	330333
21310	31401	15	applied	\N	\N	\N	\N	163080	163080	330334
21310	31423	16	applied	\N	\N	\N	\N	163081	163081	330335
21310	31424	17	applied	\N	\N	\N	\N	163082	163082	330336
21310	31425	18	applied	\N	\N	\N	\N	163083	163083	330337
21310	31084	19	applied	\N	\N	\N	\N	163084	163084	330338
21310	31402	21	applied	\N	\N	\N	\N	163086	163086	330340
21310	30899	22	applied	\N	\N	\N	\N	163087	163087	330341
21310	31142	23	applied	\N	\N	\N	\N	163088	163088	330342
21310	31143	24	applied	\N	\N	\N	\N	163089	163089	330343
21310	31144	25	applied	\N	\N	\N	\N	163090	163090	330344
21310	31145	26	applied	\N	\N	\N	\N	163091	163091	330345
21310	30926	27	applied	\N	\N	\N	\N	163092	163092	330346
21251	31425	3	applied	\N	\N	\N	\N	162615	162615	329869
21251	31426	4	applied	\N	\N	\N	\N	162616	162616	329870
21277	31486	26	applied	\N	\N	1000000000	\N	162767	162767	330021
21277	31487	27	applied	\N	\N	\N	\N	162768	162768	330022
21277	31488	28	applied	\N	\N	1000000000	\N	162769	162769	330023
21277	31489	29	applied	\N	\N	\N	\N	162770	162770	330024
21277	31490	30	applied	\N	\N	\N	\N	162771	162771	330025
21277	31495	31	applied	\N	\N	\N	\N	162772	162772	330026
21280	31464	0	applied	\N	\N	\N	\N	162777	162777	330031
21280	31441	1	applied	\N	\N	\N	\N	162778	162778	330032
21280	31442	2	applied	\N	\N	\N	\N	162779	162779	330033
21280	31443	3	applied	\N	\N	\N	\N	162780	162780	330034
21280	31449	5	applied	\N	\N	\N	\N	162782	162782	330036
21280	31450	6	applied	\N	\N	\N	\N	162783	162783	330037
21280	31453	7	applied	\N	\N	\N	\N	162784	162784	330038
21280	31455	8	applied	\N	\N	\N	\N	162785	162785	330039
21280	31456	9	applied	\N	\N	\N	\N	162786	162786	330040
21280	31457	10	applied	\N	\N	\N	\N	162787	162787	330041
21280	31465	11	applied	\N	\N	\N	\N	162788	162788	330042
21280	31474	12	applied	\N	\N	\N	\N	162789	162789	330043
21280	31475	13	applied	\N	\N	\N	\N	162790	162790	330044
21280	31476	14	applied	\N	\N	\N	\N	162791	162791	330045
21280	31493	15	applied	\N	\N	\N	\N	162792	162792	330046
21280	31458	16	applied	\N	\N	\N	\N	162793	162793	330047
21280	31477	17	applied	\N	\N	\N	\N	162794	162794	330048
21280	31478	18	applied	\N	\N	1000000000	\N	162795	162795	330049
21280	31445	19	applied	\N	\N	\N	\N	162796	162796	330050
21280	31480	21	applied	\N	\N	1000000000	\N	162798	162798	330052
21280	31481	22	applied	\N	\N	\N	\N	162799	162799	330053
21280	31482	23	applied	\N	\N	1000000000	\N	162800	162800	330054
21280	31446	24	applied	\N	\N	\N	\N	162801	162801	330055
21280	31484	25	applied	\N	\N	\N	\N	162802	162802	330056
21280	31496	26	applied	\N	\N	\N	\N	162803	162803	330057
21280	31461	27	applied	\N	\N	1000000000	\N	162804	162804	330058
21280	31462	28	applied	\N	\N	1000000000	\N	162805	162805	330059
21280	31463	29	applied	\N	\N	1000000000	\N	162806	162806	330060
21280	31466	30	applied	\N	\N	1000000000	\N	162807	162807	330061
21280	31447	31	applied	\N	\N	\N	\N	162808	162808	330062
21280	31448	32	applied	\N	\N	\N	\N	162809	162809	330063
21280	31451	33	applied	\N	\N	\N	\N	162810	162810	330064
21280	31452	34	applied	\N	\N	\N	\N	162811	162811	330065
21280	31454	35	applied	\N	\N	\N	\N	162812	162812	330066
21280	31459	36	applied	\N	\N	\N	\N	162813	162813	330067
21280	31460	37	applied	\N	\N	\N	\N	162814	162814	330068
21280	31467	38	applied	\N	\N	\N	\N	162815	162815	330069
21280	31483	39	applied	\N	\N	\N	\N	162816	162816	330070
21280	31469	41	applied	\N	\N	1000000000	\N	162818	162818	330072
21280	31470	42	applied	\N	\N	\N	\N	162819	162819	330073
21280	31471	43	applied	\N	\N	\N	\N	162820	162820	330074
21280	31472	44	applied	\N	\N	1000000000	\N	162821	162821	330075
21280	31473	45	applied	\N	\N	1000000000	\N	162822	162822	330076
21280	31485	46	applied	\N	\N	1000000000	\N	162823	162823	330077
21280	31486	47	applied	\N	\N	1000000000	\N	162824	162824	330078
21280	31487	48	applied	\N	\N	\N	\N	162825	162825	330079
21280	31488	49	applied	\N	\N	1000000000	\N	162826	162826	330080
21280	31489	50	applied	\N	\N	\N	\N	162827	162827	330081
21280	31490	51	applied	\N	\N	\N	\N	162828	162828	330082
21280	31495	52	applied	\N	\N	\N	\N	162829	162829	330083
21280	31491	53	applied	\N	\N	\N	\N	162830	162830	330084
21280	31492	54	applied	\N	\N	\N	\N	162831	162831	330085
21280	31494	55	applied	\N	\N	\N	\N	162832	162832	330086
21283	31497	0	applied	\N	\N	\N	\N	162839	162839	330093
21283	31498	1	applied	\N	\N	\N	\N	162840	162840	330094
21283	31499	2	applied	\N	\N	\N	\N	162841	162841	330095
21283	31501	4	applied	\N	\N	\N	\N	162843	162843	330097
21310	31086	28	applied	\N	\N	\N	\N	163093	163093	330347
21310	31146	29	applied	\N	\N	\N	\N	163094	163094	330348
21310	30946	30	applied	\N	\N	\N	\N	163095	163095	330349
21310	30900	31	applied	\N	\N	\N	\N	163096	163096	330350
21310	30906	32	applied	\N	\N	\N	\N	163097	163097	330351
21310	30908	33	applied	\N	\N	\N	\N	163098	163098	330352
21310	30909	34	applied	\N	\N	\N	\N	163099	163099	330353
21310	30914	35	applied	\N	\N	\N	\N	163100	163100	330354
21310	31419	36	applied	\N	\N	\N	\N	163101	163101	330355
21310	31420	37	applied	\N	\N	\N	\N	163102	163102	330356
21310	30903	38	applied	\N	\N	\N	\N	163103	163103	330357
21310	30905	39	applied	\N	\N	\N	\N	163104	163104	330358
21310	31052	40	applied	\N	\N	\N	\N	163105	163105	330359
21310	31053	41	applied	\N	\N	\N	\N	163106	163106	330360
21310	31054	42	applied	\N	\N	\N	\N	163107	163107	330361
21310	30910	44	applied	\N	\N	\N	\N	163109	163109	330363
21310	30913	45	applied	\N	\N	\N	\N	163110	163110	330364
21310	30916	47	applied	\N	\N	\N	\N	163111	163111	330365
21310	30918	48	applied	\N	\N	\N	\N	163112	163112	330366
21310	30921	49	applied	\N	\N	\N	\N	163113	163113	330367
21310	30923	50	applied	\N	\N	\N	\N	163114	163114	330368
21310	30924	51	applied	\N	\N	\N	\N	163115	163115	330369
21310	30925	52	applied	\N	\N	\N	\N	163116	163116	330370
21310	30931	53	applied	\N	\N	\N	\N	163117	163117	330371
21310	30937	54	applied	\N	\N	\N	\N	163118	163118	330372
21310	30938	55	applied	\N	\N	\N	\N	163119	163119	330373
21310	30943	56	applied	\N	\N	\N	\N	163120	163120	330374
21310	30945	57	applied	\N	\N	\N	\N	163121	163121	330375
21310	30947	58	applied	\N	\N	\N	\N	163122	163122	330376
21310	30953	59	applied	\N	\N	\N	\N	163123	163123	330377
21310	30955	60	applied	\N	\N	\N	\N	163124	163124	330378
21310	30964	62	applied	\N	\N	\N	\N	163126	163126	330380
21310	30967	63	applied	\N	\N	\N	\N	163127	163127	330381
21310	30968	64	applied	\N	\N	\N	\N	163128	163128	330382
21310	30971	65	applied	\N	\N	\N	\N	163129	163129	330383
21310	30972	66	applied	\N	\N	\N	\N	163130	163130	330384
21310	30973	67	applied	\N	\N	\N	\N	163131	163131	330385
21310	30978	68	applied	\N	\N	\N	\N	163132	163132	330386
21310	30981	69	applied	\N	\N	\N	\N	163133	163133	330387
21310	30983	70	applied	\N	\N	\N	\N	163134	163134	330388
21310	30985	71	applied	\N	\N	\N	\N	163135	163135	330389
21310	30987	72	applied	\N	\N	\N	\N	163136	163136	330390
21310	30990	73	applied	\N	\N	\N	\N	163137	163137	330391
21310	30992	74	applied	\N	\N	\N	\N	163138	163138	330392
21277	31472	23	applied	\N	\N	1000000000	\N	162764	162764	330018
21277	31485	25	applied	\N	\N	1000000000	\N	162766	162766	330020
21285	31509	3	applied	\N	\N	\N	\N	162851	162851	330105
21288	31516	0	applied	\N	\N	\N	\N	162858	162858	330112
21288	31517	1	applied	\N	\N	\N	\N	162859	162859	330113
21288	31518	2	applied	\N	\N	\N	\N	162860	162860	330114
21288	31519	3	applied	\N	\N	\N	\N	162861	162861	330115
21290	31522	2	applied	\N	\N	\N	\N	162868	162868	330122
21290	31523	3	applied	\N	\N	\N	\N	162869	162869	330123
21290	31524	4	applied	\N	\N	\N	\N	162870	162870	330124
21290	31525	5	applied	\N	\N	\N	\N	162871	162871	330125
21292	31526	0	applied	\N	\N	\N	\N	162878	162878	330132
21292	31527	1	applied	\N	\N	\N	\N	162879	162879	330133
21292	31528	2	applied	\N	\N	\N	\N	162880	162880	330134
21292	31529	3	applied	\N	\N	\N	\N	162881	162881	330135
21293	31526	0	applied	\N	\N	\N	\N	162882	162882	330136
21293	31528	2	applied	\N	\N	\N	\N	162884	162884	330138
21293	31529	3	applied	\N	\N	\N	\N	162885	162885	330139
21295	31530	0	applied	\N	\N	\N	\N	162892	162892	330146
21295	31531	1	applied	\N	\N	\N	\N	162893	162893	330147
21295	31532	2	applied	\N	\N	\N	\N	162894	162894	330148
21295	31533	3	applied	\N	\N	\N	\N	162895	162895	330149
21295	31534	4	applied	\N	\N	\N	\N	162896	162896	330150
21295	31535	5	applied	\N	\N	\N	\N	162897	162897	330151
21296	31530	0	applied	\N	\N	\N	\N	162898	162898	330152
21296	31531	1	applied	\N	\N	\N	\N	162899	162899	330153
21296	31532	2	applied	\N	\N	\N	\N	162900	162900	330154
21296	31533	3	applied	\N	\N	\N	\N	162901	162901	330155
21296	31534	4	applied	\N	\N	\N	\N	162902	162902	330156
21296	31535	5	applied	\N	\N	\N	\N	162903	162903	330157
21297	31536	0	applied	\N	\N	\N	\N	162904	162904	330158
21297	31537	1	applied	\N	\N	\N	\N	162905	162905	330159
21298	31536	0	applied	\N	\N	\N	\N	162907	162907	330161
21298	31537	1	applied	\N	\N	\N	\N	162908	162908	330162
21298	31538	2	applied	\N	\N	\N	\N	162909	162909	330163
21302	31138	0	applied	\N	\N	\N	\N	162921	162921	330175
21302	31416	1	applied	\N	\N	\N	\N	162922	162922	330176
21302	31464	2	applied	\N	\N	\N	\N	162923	162923	330177
21302	31109	3	applied	\N	\N	\N	\N	162924	162924	330178
21302	31139	4	applied	\N	\N	\N	\N	162925	162925	330179
21302	31400	5	applied	\N	\N	\N	\N	162926	162926	330180
21302	31250	6	applied	\N	\N	\N	\N	162927	162927	330181
21302	31422	7	applied	\N	\N	\N	\N	162928	162928	330182
21302	31417	8	applied	\N	\N	\N	\N	162929	162929	330183
21302	31401	9	applied	\N	\N	\N	\N	162930	162930	330184
21302	31423	10	applied	\N	\N	\N	\N	162931	162931	330185
21302	31424	11	applied	\N	\N	\N	\N	162932	162932	330186
21302	31425	12	applied	\N	\N	\N	\N	162933	162933	330187
21302	31142	14	applied	\N	\N	\N	\N	162935	162935	330189
21302	31143	15	applied	\N	\N	\N	\N	162936	162936	330190
21302	31144	16	applied	\N	\N	\N	\N	162937	162937	330191
21302	31145	17	applied	\N	\N	\N	\N	162938	162938	330192
21302	31419	18	applied	\N	\N	\N	\N	162939	162939	330193
21302	31420	19	applied	\N	\N	\N	\N	162940	162940	330194
21302	31110	20	applied	\N	\N	\N	\N	162941	162941	330195
21302	31113	21	applied	\N	\N	\N	\N	162942	162942	330196
21302	31114	22	applied	\N	\N	\N	\N	162943	162943	330197
21302	31118	23	applied	\N	\N	\N	\N	162944	162944	330198
21304	31543	0	applied	\N	\N	\N	\N	163049	163049	330303
21304	31544	1	applied	\N	\N	\N	\N	163050	163050	330304
21304	31545	2	applied	\N	\N	\N	\N	163051	163051	330305
21309	31546	0	applied	\N	\N	\N	\N	163062	163062	330316
21309	31547	1	applied	\N	\N	\N	\N	163063	163063	330317
21309	31548	2	applied	\N	\N	\N	\N	163064	163064	330318
21312	31547	1	applied	\N	\N	\N	\N	163194	163194	330448
21312	31548	2	applied	\N	\N	\N	\N	163195	163195	330449
21320	31571	0	applied	\N	\N	\N	\N	163248	163248	330502
21320	31572	1	applied	\N	\N	\N	\N	163249	163249	330503
21320	31573	2	applied	\N	\N	\N	\N	163250	163250	330504
21320	31574	3	applied	\N	\N	\N	\N	163251	163251	330505
21323	31579	0	applied	\N	\N	\N	\N	163259	163259	330513
21323	31580	1	applied	\N	\N	\N	\N	163260	163260	330514
21323	31581	2	applied	\N	\N	\N	\N	163261	163261	330515
21325	31586	0	applied	\N	\N	\N	\N	163266	163266	330520
21325	31587	2	applied	\N	\N	\N	\N	163267	163267	330521
21325	31588	3	applied	\N	\N	\N	\N	163268	163268	330522
21328	31589	0	applied	\N	\N	\N	\N	163275	163275	330529
21328	31590	1	applied	\N	\N	\N	\N	163276	163276	330530
21328	31591	2	applied	\N	\N	\N	\N	163277	163277	330531
21332	31592	0	applied	\N	\N	\N	\N	163288	163288	330542
21332	31594	2	applied	\N	\N	\N	\N	163290	163290	330544
21332	31595	3	applied	\N	\N	\N	\N	163291	163291	330545
21332	31596	4	applied	\N	\N	\N	\N	163292	163292	330546
21334	31597	0	applied	\N	\N	\N	\N	163296	163296	330550
21334	31598	1	applied	\N	\N	\N	\N	163297	163297	330551
21336	31599	0	applied	\N	\N	\N	\N	163302	163302	330556
21336	31600	1	applied	\N	\N	\N	\N	163303	163303	330557
21336	31601	2	applied	\N	\N	\N	\N	163304	163304	330558
21343	31610	0	applied	\N	\N	\N	\N	163325	163325	330579
21343	31611	1	applied	\N	\N	\N	\N	163326	163326	330580
21343	31612	2	applied	\N	\N	\N	\N	163327	163327	330581
21343	31613	3	applied	\N	\N	\N	\N	163328	163328	330582
21343	31614	4	applied	\N	\N	\N	\N	163329	163329	330583
21343	31615	5	applied	\N	\N	\N	\N	163330	163330	330584
21346	31610	0	applied	\N	\N	\N	\N	163343	163343	330597
21346	31611	1	applied	\N	\N	\N	\N	163344	163344	330598
21346	31613	3	applied	\N	\N	\N	\N	163346	163346	330600
21346	31614	4	applied	\N	\N	\N	\N	163347	163347	330601
21346	31615	5	applied	\N	\N	\N	\N	163348	163348	330602
21348	31616	0	applied	\N	\N	\N	\N	163349	163349	330603
21348	31617	1	applied	\N	\N	\N	\N	163350	163350	330604
21348	31618	2	applied	\N	\N	\N	\N	163351	163351	330605
21348	31619	3	applied	\N	\N	\N	\N	163352	163352	330606
21348	31620	4	applied	\N	\N	\N	\N	163353	163353	330607
21348	31621	5	applied	\N	\N	\N	\N	163354	163354	330608
21348	31622	6	applied	\N	\N	\N	\N	163355	163355	330609
21348	31623	7	applied	\N	\N	1000000000	\N	163356	163356	330610
21348	31624	8	applied	\N	\N	\N	\N	163357	163357	330611
21348	31625	9	applied	\N	\N	\N	\N	163358	163358	330612
21348	31626	10	applied	\N	\N	\N	\N	163359	163359	330613
21348	31627	11	applied	\N	\N	\N	\N	163360	163360	330614
21353	31638	0	applied	\N	\N	\N	\N	163381	163381	330635
21285	31508	2	applied	\N	\N	\N	\N	162850	162850	330104
21302	31129	28	applied	\N	\N	\N	\N	162949	162949	330203
21302	31131	29	applied	\N	\N	\N	\N	162950	162950	330204
21302	31133	30	applied	\N	\N	\N	\N	162951	162951	330205
21302	31134	31	applied	\N	\N	\N	\N	162952	162952	330206
21302	31140	32	applied	\N	\N	\N	\N	162953	162953	330207
21302	31147	33	applied	\N	\N	\N	\N	162954	162954	330208
21302	31149	34	applied	\N	\N	\N	\N	162955	162955	330209
21302	31152	35	applied	\N	\N	\N	\N	162956	162956	330210
21302	31153	36	applied	\N	\N	\N	\N	162957	162957	330211
21302	31154	37	applied	\N	\N	\N	\N	162958	162958	330212
21302	31158	38	applied	\N	\N	\N	\N	162959	162959	330213
21302	31161	39	applied	\N	\N	\N	\N	162960	162960	330214
21302	31163	40	applied	\N	\N	\N	\N	162961	162961	330215
21302	31165	41	applied	\N	\N	\N	\N	162962	162962	330216
21302	31170	43	applied	\N	\N	\N	\N	162964	162964	330218
21302	31172	44	applied	\N	\N	\N	\N	162965	162965	330219
21302	31173	45	applied	\N	\N	\N	\N	162966	162966	330220
21302	31177	46	applied	\N	\N	\N	\N	162967	162967	330221
21302	31179	47	applied	\N	\N	\N	\N	162968	162968	330222
21302	31180	48	applied	\N	\N	\N	\N	162969	162969	330223
21302	31184	49	applied	\N	\N	\N	\N	162970	162970	330224
21302	31185	50	applied	\N	\N	\N	\N	162971	162971	330225
21302	31188	51	applied	\N	\N	\N	\N	162972	162972	330226
21302	31191	52	applied	\N	\N	\N	\N	162973	162973	330227
21302	31192	53	applied	\N	\N	\N	\N	162974	162974	330228
21302	31194	54	applied	\N	\N	\N	\N	162975	162975	330229
21302	31197	55	applied	\N	\N	\N	\N	162976	162976	330230
21302	31199	56	applied	\N	\N	\N	\N	162977	162977	330231
21302	31201	57	applied	\N	\N	\N	\N	162978	162978	330232
21302	31202	58	applied	\N	\N	\N	\N	162979	162979	330233
21302	31207	60	applied	\N	\N	\N	\N	162981	162981	330235
21302	31209	61	applied	\N	\N	\N	\N	162982	162982	330236
21302	31212	62	applied	\N	\N	\N	\N	162983	162983	330237
21302	31213	63	applied	\N	\N	\N	\N	162984	162984	330238
21302	31216	64	applied	\N	\N	\N	\N	162985	162985	330239
21302	31219	65	applied	\N	\N	\N	\N	162986	162986	330240
21302	31220	66	applied	\N	\N	\N	\N	162987	162987	330241
21302	31221	67	applied	\N	\N	\N	\N	162988	162988	330242
21302	31227	68	applied	\N	\N	\N	\N	162989	162989	330243
21302	31229	69	applied	\N	\N	\N	\N	162990	162990	330244
21302	31231	70	applied	\N	\N	\N	\N	162991	162991	330245
21302	31234	71	applied	\N	\N	\N	\N	162992	162992	330246
21302	31235	72	applied	\N	\N	\N	\N	162993	162993	330247
21302	31238	73	applied	\N	\N	\N	\N	162994	162994	330248
21302	31241	74	applied	\N	\N	\N	\N	162995	162995	330249
21302	31243	75	applied	\N	\N	\N	\N	162996	162996	330250
21302	31247	77	applied	\N	\N	\N	\N	162998	162998	330252
21302	31251	78	applied	\N	\N	\N	\N	162999	162999	330253
21302	31252	79	applied	\N	\N	\N	\N	163000	163000	330254
21302	31253	80	applied	\N	\N	\N	\N	163001	163001	330255
21302	31254	81	applied	\N	\N	\N	\N	163002	163002	330256
21302	31260	82	applied	\N	\N	\N	\N	163003	163003	330257
21302	31262	83	applied	\N	\N	\N	\N	163004	163004	330258
21302	31263	84	applied	\N	\N	\N	\N	163005	163005	330259
21302	31266	85	applied	\N	\N	\N	\N	163006	163006	330260
21302	31267	86	applied	\N	\N	\N	\N	163007	163007	330261
21302	31271	87	applied	\N	\N	\N	\N	163008	163008	330262
21302	31273	88	applied	\N	\N	\N	\N	163009	163009	330263
21302	31275	89	applied	\N	\N	\N	\N	163010	163010	330264
21302	31277	90	applied	\N	\N	\N	\N	163011	163011	330265
21302	31279	91	applied	\N	\N	\N	\N	163012	163012	330266
21302	31280	92	applied	\N	\N	\N	\N	163013	163013	330267
21302	31285	94	applied	\N	\N	\N	\N	163015	163015	330269
21302	31287	95	applied	\N	\N	\N	\N	163016	163016	330270
21302	31289	96	applied	\N	\N	\N	\N	163017	163017	330271
21302	31291	97	applied	\N	\N	\N	\N	163018	163018	330272
21302	31293	98	applied	\N	\N	\N	\N	163019	163019	330273
21353	31639	1	applied	\N	\N	\N	\N	163382	163382	330636
21353	31640	2	applied	\N	\N	\N	\N	163383	163383	330637
21353	31641	3	applied	\N	\N	\N	\N	163384	163384	330638
21360	31659	0	applied	\N	\N	\N	\N	163432	163432	330686
21360	31660	1	applied	\N	\N	\N	\N	163433	163433	330687
21360	31661	2	applied	\N	\N	\N	\N	163434	163434	330688
21360	31662	3	applied	\N	\N	\N	\N	163435	163435	330689
21360	31663	4	applied	\N	\N	\N	\N	163436	163436	330690
21360	31664	5	applied	\N	\N	\N	\N	163437	163437	330691
21360	31665	6	applied	\N	\N	\N	\N	163438	163438	330692
21360	31666	7	applied	\N	\N	\N	\N	163439	163439	330693
21360	31668	9	applied	\N	\N	\N	\N	163441	163441	330695
21360	31669	10	applied	\N	\N	\N	\N	163442	163442	330696
21360	31670	11	applied	\N	\N	\N	\N	163443	163443	330697
21360	31671	12	applied	\N	\N	\N	\N	163444	163444	330698
21360	31672	13	applied	\N	\N	\N	\N	163445	163445	330699
21360	31673	14	applied	\N	\N	\N	\N	163446	163446	330700
21360	31674	15	applied	\N	\N	\N	\N	163447	163447	330701
21360	31675	16	applied	\N	\N	\N	\N	163448	163448	330702
21360	31676	17	applied	\N	\N	\N	\N	163449	163449	330703
21360	31677	18	applied	\N	\N	\N	\N	163450	163450	330704
21369	31684	0	applied	\N	\N	\N	\N	163495	163495	330749
21369	31685	1	applied	\N	\N	\N	\N	163496	163496	330750
21369	31686	2	applied	\N	\N	\N	\N	163497	163497	330751
21369	31687	3	applied	\N	\N	\N	\N	163498	163498	330752
21380	31698	0	applied	\N	\N	\N	\N	163535	163535	330789
21380	31699	1	applied	\N	\N	\N	\N	163536	163536	330790
21380	31701	3	applied	\N	\N	\N	\N	163538	163538	330792
21386	31715	0	applied	\N	\N	\N	\N	163565	163565	330819
21386	31716	1	applied	\N	\N	\N	\N	163566	163566	330820
21386	31717	2	applied	\N	\N	\N	\N	163567	163567	330821
21392	31602	0	applied	\N	\N	\N	\N	163585	163585	330839
21392	31603	1	applied	\N	\N	\N	\N	163586	163586	330840
21392	31616	2	applied	\N	\N	\N	\N	163587	163587	330841
21392	31599	3	applied	\N	\N	\N	\N	163588	163588	330842
21392	31719	4	applied	\N	\N	1000000000	\N	163589	163589	330843
21392	31604	5	applied	\N	\N	\N	\N	163590	163590	330844
21392	31607	6	applied	\N	\N	\N	\N	163591	163591	330845
21392	31610	7	applied	\N	\N	\N	\N	163592	163592	330846
21392	31611	8	applied	\N	\N	\N	\N	163593	163593	330847
21392	31617	9	applied	\N	\N	\N	\N	163594	163594	330848
21392	31618	10	applied	\N	\N	\N	\N	163595	163595	330849
21392	31619	11	applied	\N	\N	\N	\N	163596	163596	330850
21302	31126	27	applied	\N	\N	\N	\N	162948	162948	330202
21302	31302	103	applied	\N	\N	\N	\N	163024	163024	330278
21302	31304	104	applied	\N	\N	\N	\N	163025	163025	330279
21302	31305	105	applied	\N	\N	\N	\N	163026	163026	330280
21302	31308	107	applied	\N	\N	\N	\N	163027	163027	330281
21302	31310	108	applied	\N	\N	\N	\N	163028	163028	330282
21302	31311	109	applied	\N	\N	\N	\N	163029	163029	330283
21302	31312	110	applied	\N	\N	\N	\N	163030	163030	330284
21302	31316	111	applied	\N	\N	\N	\N	163031	163031	330285
21302	31318	112	applied	\N	\N	\N	\N	163032	163032	330286
21302	31319	113	applied	\N	\N	\N	\N	163033	163033	330287
21302	31320	114	applied	\N	\N	\N	\N	163034	163034	330288
21302	31321	115	applied	\N	\N	\N	\N	163035	163035	330289
21302	31326	116	applied	\N	\N	\N	\N	163036	163036	330290
21302	31329	117	applied	\N	\N	\N	\N	163037	163037	330291
21302	31331	118	applied	\N	\N	\N	\N	163038	163038	330292
21302	31333	119	applied	\N	\N	\N	\N	163039	163039	330293
21302	31336	121	applied	\N	\N	\N	\N	163041	163041	330295
21302	31337	122	applied	\N	\N	\N	\N	163042	163042	330296
21302	31345	123	applied	\N	\N	\N	\N	163043	163043	330297
21302	31346	124	applied	\N	\N	\N	\N	163044	163044	330298
21302	31347	125	applied	\N	\N	\N	\N	163045	163045	330299
21306	31546	0	applied	\N	\N	\N	\N	163055	163055	330309
21306	31547	1	applied	\N	\N	\N	\N	163056	163056	330310
21306	31548	2	applied	\N	\N	\N	\N	163057	163057	330311
21310	31018	75	applied	\N	\N	\N	\N	163139	163139	330393
21310	31019	76	applied	\N	\N	\N	\N	163140	163140	330394
21310	31020	77	applied	\N	\N	\N	\N	163141	163141	330395
21310	31021	78	applied	\N	\N	\N	\N	163142	163142	330396
21310	31026	79	applied	\N	\N	\N	\N	163143	163143	330397
21310	30993	80	applied	\N	\N	\N	\N	163144	163144	330398
21310	30994	81	applied	\N	\N	\N	\N	163145	163145	330399
21310	31000	82	applied	\N	\N	\N	\N	163146	163146	330400
21310	31003	84	applied	\N	\N	\N	\N	163148	163148	330402
21310	31006	85	applied	\N	\N	\N	\N	163149	163149	330403
21310	31403	86	applied	\N	\N	\N	\N	163150	163150	330404
21310	31009	87	applied	\N	\N	\N	\N	163151	163151	330405
21310	31010	88	applied	\N	\N	\N	\N	163152	163152	330406
21310	31014	89	applied	\N	\N	\N	\N	163153	163153	330407
21310	31016	90	applied	\N	\N	\N	\N	163154	163154	330408
21310	31024	91	applied	\N	\N	\N	\N	163155	163155	330409
21310	31027	92	applied	\N	\N	\N	\N	163156	163156	330410
21310	31029	93	applied	\N	\N	\N	\N	163157	163157	330411
21310	31032	94	applied	\N	\N	\N	\N	163158	163158	330412
21310	31034	95	applied	\N	\N	\N	\N	163159	163159	330413
21310	31036	96	applied	\N	\N	\N	\N	163160	163160	330414
21310	31038	97	applied	\N	\N	\N	\N	163161	163161	330415
21310	31041	98	applied	\N	\N	\N	\N	163162	163162	330416
21310	31043	99	applied	\N	\N	\N	\N	163163	163163	330417
21310	31048	101	applied	\N	\N	\N	\N	163165	163165	330419
21310	31049	102	applied	\N	\N	\N	\N	163166	163166	330420
21310	31056	103	applied	\N	\N	\N	\N	163167	163167	330421
21310	31057	104	applied	\N	\N	\N	\N	163168	163168	330422
21310	31058	105	applied	\N	\N	\N	\N	163169	163169	330423
21310	31059	106	applied	\N	\N	\N	\N	163170	163170	330424
21310	31065	107	applied	\N	\N	\N	\N	163171	163171	330425
21310	31066	108	applied	\N	\N	\N	\N	163172	163172	330426
21310	31070	109	applied	\N	\N	\N	\N	163173	163173	330427
21310	31072	110	applied	\N	\N	\N	\N	163174	163174	330428
21310	31073	111	applied	\N	\N	\N	\N	163175	163175	330429
21310	31077	112	applied	\N	\N	\N	\N	163176	163176	330430
21310	31079	113	applied	\N	\N	\N	\N	163177	163177	330431
21310	31082	114	applied	\N	\N	\N	\N	163178	163178	330432
21310	31083	115	applied	\N	\N	\N	\N	163179	163179	330433
21310	31089	116	applied	\N	\N	\N	\N	163180	163180	330434
21310	31094	118	applied	\N	\N	\N	\N	163182	163182	330436
21310	31096	119	applied	\N	\N	\N	\N	163183	163183	330437
21310	31097	120	applied	\N	\N	\N	\N	163184	163184	330438
21310	31098	121	applied	\N	\N	\N	\N	163185	163185	330439
21310	31102	122	applied	\N	\N	\N	\N	163186	163186	330440
21310	31104	123	applied	\N	\N	\N	\N	163187	163187	330441
21310	31107	124	applied	\N	\N	\N	\N	163188	163188	330442
21310	31109	125	applied	\N	\N	\N	\N	163189	163189	330443
21313	31549	0	applied	\N	\N	\N	\N	163196	163196	330450
21313	31550	1	applied	\N	\N	\N	\N	163197	163197	330451
21314	31551	0	applied	\N	\N	\N	\N	163198	163198	330452
21314	31552	1	applied	\N	\N	\N	\N	163199	163199	330453
21314	31553	2	applied	\N	\N	\N	\N	163200	163200	330454
21314	31554	3	applied	\N	\N	\N	\N	163201	163201	330455
21315	31551	0	applied	\N	\N	\N	\N	163202	163202	330456
21315	31552	1	applied	\N	\N	\N	\N	163203	163203	330457
21315	31554	3	applied	\N	\N	\N	\N	163205	163205	330459
21318	31558	0	applied	\N	\N	\N	\N	163222	163222	330476
21318	31559	1	applied	\N	\N	\N	\N	163223	163223	330477
21318	31560	2	applied	\N	\N	\N	\N	163224	163224	330478
21318	31561	3	applied	\N	\N	\N	\N	163225	163225	330479
21318	31562	4	applied	\N	\N	\N	\N	163226	163226	330480
21318	31563	5	applied	\N	\N	\N	\N	163227	163227	330481
21318	31564	6	applied	\N	\N	\N	\N	163228	163228	330482
21318	31565	7	applied	\N	\N	\N	\N	163229	163229	330483
21318	31566	8	applied	\N	\N	\N	\N	163230	163230	330484
21318	31567	9	applied	\N	\N	\N	\N	163231	163231	330485
21318	31568	10	applied	\N	\N	\N	\N	163232	163232	330486
21318	31569	11	applied	\N	\N	\N	\N	163233	163233	330487
21318	31570	12	applied	\N	\N	\N	\N	163234	163234	330488
21321	31575	0	applied	\N	\N	\N	\N	163252	163252	330506
21321	31576	1	applied	\N	\N	\N	\N	163253	163253	330507
21321	31578	3	applied	\N	\N	\N	\N	163255	163255	330509
21322	31579	0	applied	\N	\N	\N	\N	163256	163256	330510
21322	31580	1	applied	\N	\N	\N	\N	163257	163257	330511
21322	31581	2	applied	\N	\N	\N	\N	163258	163258	330512
21326	31586	0	applied	\N	\N	\N	\N	163269	163269	330523
21326	31587	2	applied	\N	\N	\N	\N	163270	163270	330524
21326	31588	3	applied	\N	\N	\N	\N	163271	163271	330525
21327	31589	0	applied	\N	\N	\N	\N	163272	163272	330526
21327	31590	1	applied	\N	\N	\N	\N	163273	163273	330527
21327	31591	2	applied	\N	\N	\N	\N	163274	163274	330528
21330	31590	0	applied	\N	\N	\N	\N	163281	163281	330535
21335	31592	0	applied	\N	\N	\N	\N	163298	163298	330552
21335	31593	1	applied	\N	\N	\N	\N	163299	163299	330553
21335	31597	2	applied	\N	\N	\N	\N	163300	163300	330554
21302	31297	100	applied	\N	\N	\N	\N	163021	163021	330275
21302	31298	101	applied	\N	\N	\N	\N	163022	163022	330276
21329	31591	2	applied	\N	\N	\N	\N	163280	163280	330534
21330	31591	1	applied	\N	\N	\N	\N	163282	163282	330536
21331	31592	0	applied	\N	\N	\N	\N	163283	163283	330537
21331	31593	1	applied	\N	\N	\N	\N	163284	163284	330538
21331	31594	2	applied	\N	\N	\N	\N	163285	163285	330539
21331	31595	3	applied	\N	\N	\N	\N	163286	163286	330540
21331	31596	4	applied	\N	\N	\N	\N	163287	163287	330541
21333	31594	0	applied	\N	\N	\N	\N	163293	163293	330547
21333	31595	1	applied	\N	\N	\N	\N	163294	163294	330548
21333	31596	2	applied	\N	\N	\N	\N	163295	163295	330549
21338	31599	0	applied	\N	\N	\N	\N	163308	163308	330562
21338	31600	1	applied	\N	\N	\N	\N	163309	163309	330563
21338	31601	2	applied	\N	\N	\N	\N	163310	163310	330564
21339	31599	0	applied	\N	\N	\N	\N	163311	163311	330565
21339	31601	2	applied	\N	\N	\N	\N	163313	163313	330567
21340	31602	0	applied	\N	\N	\N	\N	163314	163314	330568
21340	31603	1	applied	\N	\N	\N	\N	163315	163315	330569
21340	31604	2	applied	\N	\N	\N	\N	163316	163316	330570
21340	31605	3	applied	\N	\N	\N	\N	163317	163317	330571
21340	31606	4	applied	\N	\N	\N	\N	163318	163318	330572
21342	31607	0	applied	\N	\N	\N	\N	163322	163322	330576
21342	31608	1	applied	\N	\N	\N	\N	163323	163323	330577
21342	31609	2	applied	\N	\N	\N	\N	163324	163324	330578
21345	31610	0	applied	\N	\N	\N	\N	163337	163337	330591
21345	31611	1	applied	\N	\N	\N	\N	163338	163338	330592
21345	31612	2	applied	\N	\N	\N	\N	163339	163339	330593
21345	31613	3	applied	\N	\N	\N	\N	163340	163340	330594
21345	31614	4	applied	\N	\N	\N	\N	163341	163341	330595
21345	31615	5	applied	\N	\N	\N	\N	163342	163342	330596
21349	31628	0	applied	\N	\N	\N	\N	163361	163361	330615
21349	31630	2	applied	\N	\N	\N	\N	163363	163363	330617
21349	31631	3	applied	\N	\N	\N	\N	163364	163364	330618
21350	31628	0	applied	\N	\N	\N	\N	163365	163365	330619
21350	31629	1	applied	\N	\N	\N	\N	163366	163366	330620
21350	31630	2	applied	\N	\N	\N	\N	163367	163367	330621
21350	31631	3	applied	\N	\N	\N	\N	163368	163368	330622
21352	31632	0	applied	\N	\N	\N	\N	163375	163375	330629
21352	31633	1	applied	\N	\N	\N	\N	163376	163376	330630
21352	31634	2	applied	\N	\N	\N	\N	163377	163377	330631
21352	31635	3	applied	\N	\N	\N	\N	163378	163378	330632
21352	31636	4	applied	\N	\N	\N	\N	163379	163379	330633
21352	31637	5	applied	\N	\N	\N	\N	163380	163380	330634
21354	31642	0	applied	\N	\N	\N	\N	163385	163385	330639
21354	31643	1	applied	\N	\N	\N	\N	163386	163386	330640
21354	31644	2	applied	\N	\N	\N	\N	163387	163387	330641
21354	31645	3	applied	\N	\N	\N	\N	163388	163388	330642
21355	31643	1	applied	\N	\N	\N	\N	163390	163390	330644
21355	31644	2	applied	\N	\N	\N	\N	163391	163391	330645
21355	31645	3	applied	\N	\N	\N	\N	163392	163392	330646
21357	31649	0	applied	\N	\N	\N	\N	163396	163396	330650
21357	31650	1	applied	\N	\N	\N	\N	163397	163397	330651
21357	31651	2	applied	\N	\N	\N	\N	163398	163398	330652
21357	31652	3	applied	\N	\N	\N	\N	163399	163399	330653
21357	31653	4	applied	\N	\N	\N	\N	163400	163400	330654
21357	31654	5	applied	\N	\N	\N	\N	163401	163401	330655
21357	31655	6	applied	\N	\N	\N	\N	163402	163402	330656
21357	31656	7	applied	\N	\N	\N	\N	163403	163403	330657
21357	31657	8	applied	\N	\N	\N	\N	163404	163404	330658
21357	31658	9	applied	\N	\N	\N	\N	163405	163405	330659
21358	31592	0	applied	\N	\N	\N	\N	163406	163406	330660
21358	31602	1	applied	\N	\N	\N	\N	163407	163407	330661
21358	31603	2	applied	\N	\N	\N	\N	163408	163408	330662
21358	31572	4	applied	\N	\N	\N	\N	163410	163410	330664
21358	31623	5	applied	\N	\N	1000000000	\N	163411	163411	330665
21358	31640	6	applied	\N	\N	\N	\N	163412	163412	330666
21359	31659	0	applied	\N	\N	\N	\N	163413	163413	330667
21359	31660	1	applied	\N	\N	\N	\N	163414	163414	330668
21359	31661	2	applied	\N	\N	\N	\N	163415	163415	330669
21359	31662	3	applied	\N	\N	\N	\N	163416	163416	330670
21359	31663	4	applied	\N	\N	\N	\N	163417	163417	330671
21359	31664	5	applied	\N	\N	\N	\N	163418	163418	330672
21359	31665	6	applied	\N	\N	\N	\N	163419	163419	330673
21359	31666	7	applied	\N	\N	\N	\N	163420	163420	330674
21359	31667	8	applied	\N	\N	\N	\N	163421	163421	330675
21359	31668	9	applied	\N	\N	\N	\N	163422	163422	330676
21359	31669	10	applied	\N	\N	\N	\N	163423	163423	330677
21359	31670	11	applied	\N	\N	\N	\N	163424	163424	330678
21359	31671	12	applied	\N	\N	\N	\N	163425	163425	330679
21359	31673	14	applied	\N	\N	\N	\N	163427	163427	330681
21359	31674	15	applied	\N	\N	\N	\N	163428	163428	330682
21359	31675	16	applied	\N	\N	\N	\N	163429	163429	330683
21359	31676	17	applied	\N	\N	\N	\N	163430	163430	330684
21359	31677	18	applied	\N	\N	\N	\N	163431	163431	330685
21361	31678	0	applied	\N	\N	\N	\N	163451	163451	330705
21361	31679	1	applied	\N	\N	\N	\N	163452	163452	330706
21361	31680	2	applied	\N	\N	\N	\N	163453	163453	330707
21361	31681	3	applied	\N	\N	\N	\N	163454	163454	330708
21361	31682	5	applied	\N	\N	\N	\N	163455	163455	330709
21361	31683	6	applied	\N	\N	\N	\N	163456	163456	330710
21362	31678	0	applied	\N	\N	\N	\N	163457	163457	330711
21368	31684	0	applied	\N	\N	\N	\N	163491	163491	330745
21368	31685	1	applied	\N	\N	\N	\N	163492	163492	330746
21368	31686	2	applied	\N	\N	\N	\N	163493	163493	330747
21368	31687	3	applied	\N	\N	\N	\N	163494	163494	330748
21370	31689	1	applied	\N	\N	\N	\N	163500	163500	330754
21370	31690	2	applied	\N	\N	\N	\N	163501	163501	330755
21370	31691	3	applied	\N	\N	\N	\N	163502	163502	330756
21370	31692	4	applied	\N	\N	\N	\N	163503	163503	330757
21370	31693	5	applied	\N	\N	\N	\N	163504	163504	330758
21372	31694	0	applied	\N	\N	\N	\N	163511	163511	330765
21372	31695	1	applied	\N	\N	\N	\N	163512	163512	330766
21372	31696	2	applied	\N	\N	\N	\N	163513	163513	330767
21372	31697	3	applied	\N	\N	\N	\N	163514	163514	330768
21375	31694	0	applied	\N	\N	\N	\N	163523	163523	330777
21375	31695	1	applied	\N	\N	\N	\N	163524	163524	330778
21375	31696	2	applied	\N	\N	\N	\N	163525	163525	330779
21375	31697	3	applied	\N	\N	\N	\N	163526	163526	330780
21382	31708	0	applied	\N	\N	\N	\N	163545	163545	330799
21382	31709	1	applied	\N	\N	\N	\N	163546	163546	330800
21382	31710	2	applied	\N	\N	\N	\N	163547	163547	330801
21329	31590	1	applied	\N	\N	\N	\N	163279	163279	330533
21341	31607	0	applied	\N	\N	\N	\N	163319	163319	330573
21341	31608	1	applied	\N	\N	\N	\N	163320	163320	330574
21341	31609	2	applied	\N	\N	\N	\N	163321	163321	330575
21344	31610	0	applied	\N	\N	\N	\N	163331	163331	330585
21344	31611	1	applied	\N	\N	\N	\N	163332	163332	330586
21344	31612	2	applied	\N	\N	\N	\N	163333	163333	330587
21344	31613	3	applied	\N	\N	\N	\N	163334	163334	330588
21344	31614	4	applied	\N	\N	\N	\N	163335	163335	330589
21344	31615	5	applied	\N	\N	\N	\N	163336	163336	330590
21351	31632	0	applied	\N	\N	\N	\N	163369	163369	330623
21351	31633	1	applied	\N	\N	\N	\N	163370	163370	330624
21351	31634	2	applied	\N	\N	\N	\N	163371	163371	330625
21351	31635	3	applied	\N	\N	\N	\N	163372	163372	330626
21351	31636	4	applied	\N	\N	\N	\N	163373	163373	330627
21356	31646	0	applied	\N	\N	\N	\N	163393	163393	330647
21356	31647	1	applied	\N	\N	\N	\N	163394	163394	330648
21356	31648	2	applied	\N	\N	\N	\N	163395	163395	330649
21363	31678	0	applied	\N	\N	\N	\N	163463	163463	330717
21363	31679	1	applied	\N	\N	\N	\N	163464	163464	330718
21363	31680	2	applied	\N	\N	\N	\N	163465	163465	330719
21363	31681	3	applied	\N	\N	\N	\N	163466	163466	330720
21363	31682	5	applied	\N	\N	\N	\N	163467	163467	330721
21363	31683	6	applied	\N	\N	\N	\N	163468	163468	330722
21365	31678	0	applied	\N	\N	\N	\N	163475	163475	330729
21365	31679	1	applied	\N	\N	\N	\N	163476	163476	330730
21365	31680	2	applied	\N	\N	\N	\N	163477	163477	330731
21365	31681	3	applied	\N	\N	\N	\N	163478	163478	330732
21365	31682	5	applied	\N	\N	\N	\N	163479	163479	330733
21365	31683	6	applied	\N	\N	\N	\N	163480	163480	330734
21367	31684	0	applied	\N	\N	\N	\N	163487	163487	330741
21367	31686	2	applied	\N	\N	\N	\N	163489	163489	330743
21367	31687	3	applied	\N	\N	\N	\N	163490	163490	330744
21374	31694	0	applied	\N	\N	\N	\N	163519	163519	330773
21374	31695	1	applied	\N	\N	\N	\N	163520	163520	330774
21374	31696	2	applied	\N	\N	\N	\N	163521	163521	330775
21374	31697	3	applied	\N	\N	\N	\N	163522	163522	330776
21377	31694	0	applied	\N	\N	\N	\N	163531	163531	330785
21377	31695	1	applied	\N	\N	\N	\N	163532	163532	330786
21377	31696	2	applied	\N	\N	\N	\N	163533	163533	330787
21377	31697	3	applied	\N	\N	\N	\N	163534	163534	330788
21381	31702	0	applied	\N	\N	\N	\N	163539	163539	330793
21381	31703	1	applied	\N	\N	\N	\N	163540	163540	330794
21381	31704	2	applied	\N	\N	\N	\N	163541	163541	330795
21381	31705	3	applied	\N	\N	\N	\N	163542	163542	330796
21381	31706	4	applied	\N	\N	\N	\N	163543	163543	330797
21381	31707	5	applied	\N	\N	\N	\N	163544	163544	330798
21382	31712	4	applied	\N	\N	\N	\N	163549	163549	330803
21382	31713	5	applied	\N	\N	\N	\N	163550	163550	330804
21382	31714	6	applied	\N	\N	\N	\N	163551	163551	330805
21384	31715	0	applied	\N	\N	\N	\N	163559	163559	330813
21384	31716	1	applied	\N	\N	\N	\N	163560	163560	330814
21384	31717	2	applied	\N	\N	\N	\N	163561	163561	330815
21388	31718	0	applied	\N	\N	\N	\N	163571	163571	330825
21388	31719	1	applied	\N	\N	1000000000	\N	163572	163572	330826
21388	31720	2	applied	\N	\N	\N	\N	163573	163573	330827
21388	31721	3	applied	\N	\N	\N	\N	163574	163574	330828
21390	31722	0	applied	\N	\N	\N	\N	163579	163579	330833
21390	31723	1	applied	\N	\N	\N	\N	163580	163580	330834
21390	31724	2	applied	\N	\N	\N	\N	163581	163581	330835
21391	31725	0	applied	\N	\N	\N	\N	163582	163582	330836
21391	31726	1	applied	\N	\N	\N	\N	163583	163583	330837
21391	31727	2	applied	\N	\N	\N	\N	163584	163584	330838
21393	31729	1	applied	\N	\N	\N	\N	163710	163710	330964
21393	31730	2	applied	\N	\N	\N	\N	163711	163711	330965
21393	31731	3	applied	\N	\N	\N	\N	163712	163712	330966
21400	31735	0	applied	\N	\N	\N	\N	163739	163739	330993
21400	31736	1	applied	\N	\N	\N	\N	163740	163740	330994
21400	31737	2	applied	\N	\N	\N	\N	163741	163741	330995
21400	31738	3	applied	\N	\N	\N	\N	163742	163742	330996
21400	31739	4	applied	\N	\N	\N	\N	163743	163743	330997
21400	31740	5	applied	\N	\N	\N	\N	163744	163744	330998
21400	31741	6	applied	\N	\N	\N	\N	163745	163745	330999
21400	31742	7	applied	\N	\N	\N	\N	163746	163746	331000
21400	31743	8	applied	\N	\N	\N	\N	163747	163747	331001
21400	31744	9	applied	\N	\N	\N	\N	163748	163748	331002
21400	31745	10	applied	\N	\N	\N	\N	163749	163749	331003
21401	31735	0	applied	\N	\N	\N	\N	163750	163750	331004
21401	31736	1	applied	\N	\N	\N	\N	163751	163751	331005
21401	31738	3	applied	\N	\N	\N	\N	163753	163753	331007
21401	31739	4	applied	\N	\N	\N	\N	163754	163754	331008
21401	31740	5	applied	\N	\N	\N	\N	163755	163755	331009
21401	31741	6	applied	\N	\N	\N	\N	163756	163756	331010
21401	31742	7	applied	\N	\N	\N	\N	163757	163757	331011
21401	31743	8	applied	\N	\N	\N	\N	163758	163758	331012
21401	31744	9	applied	\N	\N	\N	\N	163759	163759	331013
21401	31745	10	applied	\N	\N	\N	\N	163760	163760	331014
21404	31746	0	applied	\N	\N	\N	\N	163779	163779	331033
21404	31747	1	applied	\N	\N	\N	\N	163780	163780	331034
21404	31748	2	applied	\N	\N	\N	\N	163781	163781	331035
21404	31749	3	applied	\N	\N	\N	\N	163782	163782	331036
21404	31750	4	applied	\N	\N	\N	\N	163783	163783	331037
21405	31753	0	applied	\N	\N	\N	\N	163786	163786	331040
21405	31754	1	applied	\N	\N	\N	\N	163787	163787	331041
21405	31755	2	applied	\N	\N	\N	\N	163788	163788	331042
21410	31757	0	applied	\N	\N	\N	\N	163808	163808	331062
21410	31758	1	applied	\N	\N	\N	\N	163809	163809	331063
21410	31760	2	applied	\N	\N	\N	\N	163810	163810	331064
21411	31592	0	applied	\N	\N	\N	\N	163811	163811	331065
21411	31602	1	applied	\N	\N	\N	\N	163812	163812	331066
21411	31603	2	applied	\N	\N	\N	\N	163813	163813	331067
21411	31616	3	applied	\N	\N	\N	\N	163814	163814	331068
21411	31735	4	applied	\N	\N	\N	\N	163815	163815	331069
21411	31746	5	applied	\N	\N	\N	\N	163816	163816	331070
21411	31757	6	applied	\N	\N	\N	\N	163817	163817	331071
21411	31758	7	applied	\N	\N	\N	\N	163818	163818	331072
21411	31416	8	applied	\N	\N	\N	\N	163819	163819	331073
21411	31400	9	applied	\N	\N	\N	\N	163820	163820	331074
21411	31422	10	applied	\N	\N	\N	\N	163821	163821	331075
21411	31417	11	applied	\N	\N	\N	\N	163822	163822	331076
21411	31401	12	applied	\N	\N	\N	\N	163823	163823	331077
21337	31601	2	applied	\N	\N	\N	\N	163307	163307	330561
21362	31683	6	applied	\N	\N	\N	\N	163462	163462	330716
21364	31678	0	applied	\N	\N	\N	\N	163469	163469	330723
21364	31679	1	applied	\N	\N	\N	\N	163470	163470	330724
21364	31680	2	applied	\N	\N	\N	\N	163471	163471	330725
21364	31681	3	applied	\N	\N	\N	\N	163472	163472	330726
21364	31682	5	applied	\N	\N	\N	\N	163473	163473	330727
21364	31683	6	applied	\N	\N	\N	\N	163474	163474	330728
21366	31678	0	applied	\N	\N	\N	\N	163481	163481	330735
21366	31679	1	applied	\N	\N	\N	\N	163482	163482	330736
21366	31680	2	applied	\N	\N	\N	\N	163483	163483	330737
21366	31681	3	applied	\N	\N	\N	\N	163484	163484	330738
21366	31682	5	applied	\N	\N	\N	\N	163485	163485	330739
21366	31683	6	applied	\N	\N	\N	\N	163486	163486	330740
21371	31688	0	applied	\N	\N	\N	\N	163505	163505	330759
21371	31690	2	applied	\N	\N	\N	\N	163507	163507	330761
21371	31691	3	applied	\N	\N	\N	\N	163508	163508	330762
21371	31692	4	applied	\N	\N	\N	\N	163509	163509	330763
21371	31693	5	applied	\N	\N	\N	\N	163510	163510	330764
21373	31694	0	applied	\N	\N	\N	\N	163515	163515	330769
21373	31695	1	applied	\N	\N	\N	\N	163516	163516	330770
21373	31696	2	applied	\N	\N	\N	\N	163517	163517	330771
21373	31697	3	applied	\N	\N	\N	\N	163518	163518	330772
21376	31694	0	applied	\N	\N	\N	\N	163527	163527	330781
21376	31695	1	applied	\N	\N	\N	\N	163528	163528	330782
21376	31696	2	applied	\N	\N	\N	\N	163529	163529	330783
21376	31697	3	applied	\N	\N	\N	\N	163530	163530	330784
21383	31708	0	applied	\N	\N	\N	\N	163552	163552	330806
21383	31709	1	applied	\N	\N	\N	\N	163553	163553	330807
21383	31710	2	applied	\N	\N	\N	\N	163554	163554	330808
21383	31711	3	applied	\N	\N	\N	\N	163555	163555	330809
21383	31713	5	applied	\N	\N	\N	\N	163557	163557	330811
21383	31714	6	applied	\N	\N	\N	\N	163558	163558	330812
21385	31715	0	applied	\N	\N	\N	\N	163562	163562	330816
21385	31716	1	applied	\N	\N	\N	\N	163563	163563	330817
21385	31717	2	applied	\N	\N	\N	\N	163564	163564	330818
21387	31715	0	applied	\N	\N	\N	\N	163568	163568	330822
21387	31716	1	applied	\N	\N	\N	\N	163569	163569	330823
21387	31717	2	applied	\N	\N	\N	\N	163570	163570	330824
21389	31718	0	applied	\N	\N	\N	\N	163575	163575	330829
21389	31719	1	applied	\N	\N	1000000000	\N	163576	163576	330830
21389	31720	2	applied	\N	\N	\N	\N	163577	163577	330831
21389	31721	3	applied	\N	\N	\N	\N	163578	163578	330832
21394	31728	0	applied	\N	\N	\N	\N	163713	163713	330967
21394	31729	1	applied	\N	\N	\N	\N	163714	163714	330968
21394	31730	2	applied	\N	\N	\N	\N	163715	163715	330969
21394	31731	3	applied	\N	\N	\N	\N	163716	163716	330970
21396	31733	1	applied	\N	\N	\N	\N	163722	163722	330976
21396	31734	2	applied	\N	\N	\N	\N	163723	163723	330977
21398	31732	0	applied	\N	\N	\N	\N	163726	163726	330980
21398	31734	1	applied	\N	\N	\N	\N	163727	163727	330981
21402	31735	0	applied	\N	\N	\N	\N	163761	163761	331015
21402	31736	1	applied	\N	\N	\N	\N	163762	163762	331016
21402	31737	2	applied	\N	\N	\N	\N	163763	163763	331017
21402	31738	3	applied	\N	\N	\N	\N	163764	163764	331018
21402	31739	4	applied	\N	\N	\N	\N	163765	163765	331019
21402	31740	5	applied	\N	\N	\N	\N	163766	163766	331020
21402	31741	6	applied	\N	\N	\N	\N	163767	163767	331021
21402	31742	7	applied	\N	\N	\N	\N	163768	163768	331022
21402	31743	8	applied	\N	\N	\N	\N	163769	163769	331023
21402	31744	9	applied	\N	\N	\N	\N	163770	163770	331024
21402	31745	10	applied	\N	\N	\N	\N	163771	163771	331025
21403	31746	0	applied	\N	\N	\N	\N	163772	163772	331026
21403	31748	2	applied	\N	\N	\N	\N	163774	163774	331028
21403	31749	3	applied	\N	\N	\N	\N	163775	163775	331029
21403	31750	4	applied	\N	\N	\N	\N	163776	163776	331030
21403	31751	5	applied	\N	\N	\N	\N	163777	163777	331031
21403	31752	6	applied	\N	\N	\N	\N	163778	163778	331032
21404	31751	5	applied	\N	\N	\N	\N	163784	163784	331038
21404	31752	6	applied	\N	\N	\N	\N	163785	163785	331039
21407	31753	0	applied	\N	\N	\N	\N	163794	163794	331048
21407	31754	1	applied	\N	\N	\N	\N	163795	163795	331049
21407	31755	2	applied	\N	\N	\N	\N	163796	163796	331050
21407	31756	3	applied	\N	\N	\N	\N	163797	163797	331051
21409	31757	0	applied	\N	\N	\N	\N	163803	163803	331057
21409	31758	1	applied	\N	\N	\N	\N	163804	163804	331058
21409	31759	2	applied	\N	\N	\N	\N	163805	163805	331059
21409	31760	3	applied	\N	\N	\N	\N	163806	163806	331060
21409	31761	4	applied	\N	\N	\N	\N	163807	163807	331061
21414	31763	1	applied	\N	\N	\N	\N	163940	163940	331194
21414	31764	2	applied	\N	\N	\N	\N	163941	163941	331195
21416	31765	0	applied	\N	\N	\N	\N	163953	163953	331207
21416	31766	1	applied	\N	\N	\N	\N	163954	163954	331208
21416	31767	2	applied	\N	\N	\N	\N	163955	163955	331209
21416	31768	3	applied	\N	\N	\N	\N	163956	163956	331210
21416	31769	4	applied	\N	\N	\N	\N	163957	163957	331211
21416	31770	5	applied	\N	\N	\N	\N	163958	163958	331212
21416	31771	6	applied	\N	\N	\N	\N	163959	163959	331213
21416	31772	7	applied	\N	\N	\N	\N	163960	163960	331214
21416	31773	9	applied	\N	\N	\N	\N	163961	163961	331215
21416	31774	10	applied	\N	\N	\N	\N	163962	163962	331216
21416	31775	11	applied	\N	\N	\N	\N	163963	163963	331217
21420	31779	0	applied	\N	\N	\N	\N	163990	163990	331244
21420	31780	1	applied	\N	\N	\N	\N	163991	163991	331245
21420	31781	2	applied	\N	\N	\N	\N	163992	163992	331246
21425	31789	1	applied	\N	\N	\N	\N	164006	164006	331260
21425	31790	2	applied	\N	\N	\N	\N	164007	164007	331261
21425	31791	3	applied	\N	\N	\N	\N	164008	164008	331262
21428	31798	0	applied	\N	\N	\N	\N	164019	164019	331273
21428	31799	1	applied	\N	\N	\N	\N	164020	164020	331274
21428	31800	2	applied	\N	\N	\N	\N	164021	164021	331275
21428	31801	3	applied	\N	\N	\N	\N	164022	164022	331276
21428	31802	4	applied	\N	\N	\N	\N	164023	164023	331277
21428	31803	5	applied	\N	\N	\N	\N	164024	164024	331278
21428	31804	6	applied	\N	\N	\N	\N	164025	164025	331279
21428	31805	7	applied	\N	\N	\N	\N	164026	164026	331280
21428	31806	8	applied	\N	\N	\N	\N	164027	164027	331281
21428	31807	9	applied	\N	\N	\N	\N	164028	164028	331282
21431	31808	0	applied	\N	\N	\N	\N	164042	164042	331296
21431	31809	1	applied	\N	\N	\N	\N	164043	164043	331297
21431	31810	2	applied	\N	\N	\N	\N	164044	164044	331298
21362	31682	5	applied	\N	\N	\N	\N	163461	163461	330715
21392	31642	16	applied	\N	\N	\N	\N	163601	163601	330855
21392	31646	17	applied	\N	\N	\N	\N	163602	163602	330856
21392	31649	18	applied	\N	\N	\N	\N	163603	163603	330857
21392	31650	19	applied	\N	\N	\N	\N	163604	163604	330858
21392	31651	20	applied	\N	\N	\N	\N	163605	163605	330859
21392	31659	21	applied	\N	\N	\N	\N	163606	163606	330860
21392	31660	22	applied	\N	\N	\N	\N	163607	163607	330861
21392	31661	23	applied	\N	\N	\N	\N	163608	163608	330862
21392	31662	24	applied	\N	\N	\N	\N	163609	163609	330863
21392	31663	25	applied	\N	\N	\N	\N	163610	163610	330864
21392	31664	26	applied	\N	\N	\N	\N	163611	163611	330865
21392	31678	27	applied	\N	\N	\N	\N	163612	163612	330866
21392	31679	28	applied	\N	\N	\N	\N	163613	163613	330867
21392	31684	29	applied	\N	\N	\N	\N	163614	163614	330868
21392	31689	31	applied	\N	\N	\N	\N	163616	163616	330870
21392	31694	32	applied	\N	\N	\N	\N	163617	163617	330871
21392	31698	33	applied	\N	\N	\N	\N	163618	163618	330872
21392	31702	34	applied	\N	\N	\N	\N	163619	163619	330873
21392	31703	35	applied	\N	\N	\N	\N	163620	163620	330874
21392	31708	36	applied	\N	\N	\N	\N	163621	163621	330875
21392	31709	37	applied	\N	\N	\N	\N	163622	163622	330876
21392	31715	38	applied	\N	\N	\N	\N	163623	163623	330877
21392	31718	39	applied	\N	\N	\N	\N	163624	163624	330878
21392	31722	40	applied	\N	\N	\N	\N	163625	163625	330879
21392	31725	41	applied	\N	\N	\N	\N	163626	163626	330880
21392	31608	42	applied	\N	\N	\N	\N	163627	163627	330881
21392	31597	43	applied	\N	\N	\N	\N	163628	163628	330882
21392	31623	44	applied	\N	\N	1000000000	\N	163629	163629	330883
21392	31640	45	applied	\N	\N	\N	\N	163630	163630	330884
21392	31598	46	applied	\N	\N	\N	\N	163631	163631	330885
21392	31601	48	applied	\N	\N	\N	\N	163633	163633	330887
21392	31605	49	applied	\N	\N	\N	\N	163634	163634	330888
21392	31609	50	applied	\N	\N	\N	\N	163635	163635	330889
21392	31612	51	applied	\N	\N	\N	\N	163636	163636	330890
21392	31614	52	applied	\N	\N	\N	\N	163637	163637	330891
21392	31620	53	applied	\N	\N	\N	\N	163638	163638	330892
21392	31621	54	applied	\N	\N	\N	\N	163639	163639	330893
21392	31622	55	applied	\N	\N	\N	\N	163640	163640	330894
21392	31631	56	applied	\N	\N	\N	\N	163641	163641	330895
21392	31606	57	applied	\N	\N	\N	\N	163642	163642	330896
21392	31613	58	applied	\N	\N	\N	\N	163643	163643	330897
21392	31615	59	applied	\N	\N	\N	\N	163644	163644	330898
21392	31624	60	applied	\N	\N	\N	\N	163645	163645	330899
21392	31625	61	applied	\N	\N	\N	\N	163646	163646	330900
21392	31626	62	applied	\N	\N	\N	\N	163647	163647	330901
21392	31630	63	applied	\N	\N	\N	\N	163648	163648	330902
21392	31635	65	applied	\N	\N	\N	\N	163650	163650	330904
21392	31641	66	applied	\N	\N	\N	\N	163651	163651	330905
21392	31644	67	applied	\N	\N	\N	\N	163652	163652	330906
21392	31647	68	applied	\N	\N	\N	\N	163653	163653	330907
21392	31652	69	applied	\N	\N	\N	\N	163654	163654	330908
21392	31656	70	applied	\N	\N	\N	\N	163655	163655	330909
21392	31657	71	applied	\N	\N	\N	\N	163656	163656	330910
21392	31636	72	applied	\N	\N	\N	\N	163657	163657	330911
21392	31637	73	applied	\N	\N	\N	\N	163658	163658	330912
21392	31639	74	applied	\N	\N	\N	\N	163659	163659	330913
21392	31645	75	applied	\N	\N	\N	\N	163660	163660	330914
21392	31648	76	applied	\N	\N	\N	\N	163661	163661	330915
21392	31653	77	applied	\N	\N	\N	\N	163662	163662	330916
21392	31654	78	applied	\N	\N	\N	\N	163663	163663	330917
21392	31655	79	applied	\N	\N	\N	\N	163664	163664	330918
21392	31665	80	applied	\N	\N	\N	\N	163665	163665	330919
21392	31669	82	applied	\N	\N	\N	\N	163667	163667	330921
21392	31670	83	applied	\N	\N	\N	\N	163668	163668	330922
21392	31671	84	applied	\N	\N	\N	\N	163669	163669	330923
21392	31672	85	applied	\N	\N	\N	\N	163670	163670	330924
21392	31681	86	applied	\N	\N	\N	\N	163671	163671	330925
21406	31753	0	applied	\N	\N	\N	\N	163790	163790	331044
21406	31754	1	applied	\N	\N	\N	\N	163791	163791	331045
21406	31755	2	applied	\N	\N	\N	\N	163792	163792	331046
21406	31756	3	applied	\N	\N	\N	\N	163793	163793	331047
21412	31762	0	applied	\N	\N	\N	\N	163933	163933	331187
21412	31763	1	applied	\N	\N	\N	\N	163934	163934	331188
21412	31764	2	applied	\N	\N	\N	\N	163935	163935	331189
21419	31776	0	applied	\N	\N	\N	\N	163987	163987	331241
21419	31777	1	applied	\N	\N	\N	\N	163988	163988	331242
21419	31778	2	applied	\N	\N	\N	\N	163989	163989	331243
21422	31782	0	applied	\N	\N	\N	\N	163996	163996	331250
21422	31784	2	applied	\N	\N	\N	\N	163998	163998	331252
21434	31814	0	applied	\N	\N	\N	\N	164051	164051	331305
21434	31815	1	applied	\N	\N	\N	\N	164052	164052	331306
21434	31816	2	applied	\N	\N	\N	\N	164053	164053	331307
21434	31817	3	applied	\N	\N	\N	\N	164054	164054	331308
21434	31818	4	applied	\N	\N	\N	\N	164055	164055	331309
21434	31819	5	applied	\N	\N	\N	\N	164056	164056	331310
21439	31831	0	applied	\N	\N	\N	\N	164075	164075	331329
21439	31832	1	applied	\N	\N	\N	\N	164076	164076	331330
21439	31833	2	applied	\N	\N	\N	\N	164077	164077	331331
21439	31834	3	applied	\N	\N	\N	\N	164078	164078	331332
21439	31835	4	applied	\N	\N	\N	\N	164079	164079	331333
21445	31856	0	applied	\N	\N	\N	\N	164106	164106	331360
21445	31857	1	applied	\N	\N	\N	\N	164107	164107	331361
21445	31858	2	applied	\N	\N	\N	\N	164108	164108	331362
21448	31866	0	applied	\N	\N	\N	\N	164119	164119	331373
21448	31868	2	applied	\N	\N	\N	\N	164121	164121	331375
21448	31869	3	applied	\N	\N	\N	\N	164122	164122	331376
21457	31887	0	applied	\N	\N	\N	\N	164211	164211	331465
21457	31888	1	applied	\N	\N	\N	\N	164212	164212	331466
21457	31889	2	applied	\N	\N	\N	\N	164213	164213	331467
21457	31890	3	applied	\N	\N	\N	\N	164214	164214	331468
21457	31891	4	applied	\N	\N	\N	\N	164215	164215	331469
21457	31892	5	applied	\N	\N	\N	\N	164216	164216	331470
21457	31893	6	applied	\N	\N	\N	\N	164217	164217	331471
21464	31904	0	applied	\N	\N	\N	\N	164240	164240	331494
21464	31905	1	applied	\N	\N	\N	\N	164241	164241	331495
21464	31906	2	applied	\N	\N	\N	\N	164242	164242	331496
21467	31907	0	applied	\N	\N	\N	\N	164263	164263	331517
21467	31908	1	applied	\N	\N	\N	\N	164264	164264	331518
21467	31909	2	applied	\N	\N	\N	\N	164265	164265	331519
21467	31910	3	applied	\N	\N	\N	\N	164266	164266	331520
21392	31638	15	applied	\N	\N	\N	\N	163600	163600	330854
21392	31695	91	applied	\N	\N	\N	\N	163676	163676	330930
21392	31699	92	applied	\N	\N	\N	\N	163677	163677	330931
21392	31706	93	applied	\N	\N	\N	\N	163678	163678	330932
21392	31707	94	applied	\N	\N	\N	\N	163679	163679	330933
21392	31710	95	applied	\N	\N	\N	\N	163680	163680	330934
21392	31711	96	applied	\N	\N	\N	\N	163681	163681	330935
21392	31717	97	applied	\N	\N	\N	\N	163682	163682	330936
21392	31721	98	applied	\N	\N	\N	\N	163683	163683	330937
21392	31724	99	applied	\N	\N	\N	\N	163684	163684	330938
21392	31727	100	applied	\N	\N	\N	\N	163685	163685	330939
21392	31673	101	applied	\N	\N	\N	\N	163686	163686	330940
21392	31674	102	applied	\N	\N	\N	\N	163687	163687	330941
21392	31675	103	applied	\N	\N	\N	\N	163688	163688	330942
21392	31676	104	applied	\N	\N	\N	\N	163689	163689	330943
21392	31680	106	applied	\N	\N	\N	\N	163691	163691	330945
21392	31683	107	applied	\N	\N	\N	\N	163692	163692	330946
21392	31686	108	applied	\N	\N	\N	\N	163693	163693	330947
21392	31627	109	applied	\N	\N	\N	\N	163694	163694	330948
21392	31629	110	applied	\N	\N	\N	\N	163695	163695	330949
21392	31643	112	applied	\N	\N	\N	\N	163696	163696	330950
21392	31658	113	applied	\N	\N	\N	\N	163697	163697	330951
21392	31666	114	applied	\N	\N	\N	\N	163698	163698	330952
21392	31667	115	applied	\N	\N	\N	\N	163699	163699	330953
21392	31685	116	applied	\N	\N	\N	\N	163700	163700	330954
21392	31697	117	applied	\N	\N	\N	\N	163701	163701	330955
21392	31712	118	applied	\N	\N	\N	\N	163702	163702	330956
21392	31720	119	applied	\N	\N	\N	\N	163703	163703	330957
21392	31692	120	applied	\N	\N	\N	\N	163704	163704	330958
21392	31693	121	applied	\N	\N	\N	\N	163705	163705	330959
21392	31696	122	applied	\N	\N	\N	\N	163706	163706	330960
21392	31704	124	applied	\N	\N	\N	\N	163708	163708	330962
21395	31728	0	applied	\N	\N	\N	\N	163717	163717	330971
21395	31729	1	applied	\N	\N	\N	\N	163718	163718	330972
21395	31730	2	applied	\N	\N	\N	\N	163719	163719	330973
21395	31731	3	applied	\N	\N	\N	\N	163720	163720	330974
21397	31719	0	applied	\N	\N	1000000000	\N	163724	163724	330978
21397	31701	1	applied	\N	\N	\N	\N	163725	163725	330979
21399	31735	0	applied	\N	\N	\N	\N	163728	163728	330982
21399	31736	1	applied	\N	\N	\N	\N	163729	163729	330983
21399	31737	2	applied	\N	\N	\N	\N	163730	163730	330984
21399	31738	3	applied	\N	\N	\N	\N	163731	163731	330985
21399	31739	4	applied	\N	\N	\N	\N	163732	163732	330986
21399	31740	5	applied	\N	\N	\N	\N	163733	163733	330987
21399	31741	6	applied	\N	\N	\N	\N	163734	163734	330988
21399	31742	7	applied	\N	\N	\N	\N	163735	163735	330989
21399	31743	8	applied	\N	\N	\N	\N	163736	163736	330990
21399	31745	10	applied	\N	\N	\N	\N	163738	163738	330992
21408	31757	0	applied	\N	\N	\N	\N	163798	163798	331052
21408	31758	1	applied	\N	\N	\N	\N	163799	163799	331053
21408	31759	2	applied	\N	\N	\N	\N	163800	163800	331054
21408	31760	3	applied	\N	\N	\N	\N	163801	163801	331055
21408	31761	4	applied	\N	\N	\N	\N	163802	163802	331056
21413	31762	0	applied	\N	\N	\N	\N	163936	163936	331190
21413	31763	1	applied	\N	\N	\N	\N	163937	163937	331191
21413	31764	2	applied	\N	\N	\N	\N	163938	163938	331192
21415	31765	0	applied	\N	\N	\N	\N	163942	163942	331196
21415	31766	1	applied	\N	\N	\N	\N	163943	163943	331197
21415	31767	2	applied	\N	\N	\N	\N	163944	163944	331198
21415	31768	3	applied	\N	\N	\N	\N	163945	163945	331199
21415	31769	4	applied	\N	\N	\N	\N	163946	163946	331200
21415	31770	5	applied	\N	\N	\N	\N	163947	163947	331201
21415	31771	6	applied	\N	\N	\N	\N	163948	163948	331202
21415	31773	9	applied	\N	\N	\N	\N	163950	163950	331204
21415	31774	10	applied	\N	\N	\N	\N	163951	163951	331205
21415	31775	11	applied	\N	\N	\N	\N	163952	163952	331206
21418	31765	0	applied	\N	\N	\N	\N	163976	163976	331230
21418	31766	1	applied	\N	\N	\N	\N	163977	163977	331231
21418	31767	2	applied	\N	\N	\N	\N	163978	163978	331232
21418	31768	3	applied	\N	\N	\N	\N	163979	163979	331233
21418	31769	4	applied	\N	\N	\N	\N	163980	163980	331234
21418	31770	5	applied	\N	\N	\N	\N	163981	163981	331235
21418	31771	6	applied	\N	\N	\N	\N	163982	163982	331236
21418	31772	7	applied	\N	\N	\N	\N	163983	163983	331237
21418	31773	9	applied	\N	\N	\N	\N	163984	163984	331238
21418	31774	10	applied	\N	\N	\N	\N	163985	163985	331239
21418	31775	11	applied	\N	\N	\N	\N	163986	163986	331240
21424	31785	0	applied	\N	\N	\N	\N	164002	164002	331256
21424	31786	1	applied	\N	\N	\N	\N	164003	164003	331257
21427	31792	0	applied	\N	\N	\N	\N	164013	164013	331267
21427	31793	1	applied	\N	\N	\N	\N	164014	164014	331268
21427	31794	2	applied	\N	\N	\N	\N	164015	164015	331269
21427	31795	3	applied	\N	\N	\N	\N	164016	164016	331270
21427	31796	4	applied	\N	\N	\N	\N	164017	164017	331271
21427	31797	5	applied	\N	\N	\N	\N	164018	164018	331272
21430	31808	0	applied	\N	\N	\N	\N	164039	164039	331293
21430	31809	1	applied	\N	\N	\N	\N	164040	164040	331294
21430	31810	2	applied	\N	\N	\N	\N	164041	164041	331295
21435	31814	0	applied	\N	\N	\N	\N	164057	164057	331311
21435	31815	1	applied	\N	\N	\N	\N	164058	164058	331312
21435	31816	2	applied	\N	\N	\N	\N	164059	164059	331313
21435	31817	3	applied	\N	\N	\N	\N	164060	164060	331314
21435	31818	4	applied	\N	\N	\N	\N	164061	164061	331315
21435	31819	5	applied	\N	\N	\N	\N	164062	164062	331316
21437	31784	0	applied	\N	\N	\N	\N	164070	164070	331324
21440	31837	1	applied	\N	\N	\N	\N	164081	164081	331335
21440	31838	2	applied	\N	\N	\N	\N	164082	164082	331336
21440	31839	3	applied	\N	\N	\N	\N	164083	164083	331337
21440	31840	4	applied	\N	\N	\N	\N	164084	164084	331338
21440	31841	5	applied	\N	\N	\N	\N	164085	164085	331339
21446	31856	0	applied	\N	\N	\N	\N	164109	164109	331363
21446	31857	1	applied	\N	\N	\N	\N	164110	164110	331364
21446	31858	2	applied	\N	\N	\N	\N	164111	164111	331365
21453	31735	0	applied	\N	\N	\N	\N	164145	164145	331399
21453	31746	1	applied	\N	\N	\N	\N	164146	164146	331400
21453	31757	2	applied	\N	\N	\N	\N	164147	164147	331401
21453	31758	3	applied	\N	\N	\N	\N	164148	164148	331402
21453	31765	4	applied	\N	\N	\N	\N	164149	164149	331403
21453	31766	5	applied	\N	\N	\N	\N	164150	164150	331404
21453	31871	6	applied	\N	\N	\N	\N	164151	164151	331405
21453	31831	7	applied	\N	\N	\N	\N	164152	164152	331406
21392	31691	90	applied	\N	\N	\N	\N	163675	163675	330929
21411	31402	17	applied	\N	\N	\N	\N	163828	163828	331082
21411	31049	18	applied	\N	\N	\N	\N	163829	163829	331083
21411	31419	19	applied	\N	\N	\N	\N	163830	163830	331084
21411	31420	20	applied	\N	\N	\N	\N	163831	163831	331085
21411	31056	21	applied	\N	\N	\N	\N	163832	163832	331086
21411	31057	22	applied	\N	\N	\N	\N	163833	163833	331087
21411	31058	23	applied	\N	\N	\N	\N	163834	163834	331088
21411	31059	24	applied	\N	\N	\N	\N	163835	163835	331089
21411	31065	25	applied	\N	\N	\N	\N	163836	163836	331090
21411	31066	26	applied	\N	\N	\N	\N	163837	163837	331091
21411	31070	27	applied	\N	\N	\N	\N	163838	163838	331092
21411	31072	28	applied	\N	\N	\N	\N	163839	163839	331093
21411	31073	29	applied	\N	\N	\N	\N	163840	163840	331094
21411	31077	30	applied	\N	\N	\N	\N	163841	163841	331095
21411	31079	31	applied	\N	\N	\N	\N	163842	163842	331096
21411	31082	32	applied	\N	\N	\N	\N	163843	163843	331097
21411	31089	34	applied	\N	\N	\N	\N	163845	163845	331099
21411	31090	35	applied	\N	\N	\N	\N	163846	163846	331100
21411	31094	36	applied	\N	\N	\N	\N	163847	163847	331101
21411	31096	37	applied	\N	\N	\N	\N	163848	163848	331102
21411	31097	38	applied	\N	\N	\N	\N	163849	163849	331103
21411	31098	39	applied	\N	\N	\N	\N	163850	163850	331104
21411	31102	40	applied	\N	\N	\N	\N	163851	163851	331105
21411	31104	41	applied	\N	\N	\N	\N	163852	163852	331106
21411	31107	42	applied	\N	\N	\N	\N	163853	163853	331107
21411	31109	43	applied	\N	\N	\N	\N	163854	163854	331108
21411	31110	44	applied	\N	\N	\N	\N	163855	163855	331109
21411	31113	45	applied	\N	\N	\N	\N	163856	163856	331110
21411	31114	46	applied	\N	\N	\N	\N	163857	163857	331111
21411	31118	47	applied	\N	\N	\N	\N	163858	163858	331112
21411	31120	48	applied	\N	\N	\N	\N	163859	163859	331113
21411	31123	49	applied	\N	\N	\N	\N	163860	163860	331114
21411	31126	51	applied	\N	\N	\N	\N	163862	163862	331116
21411	31129	52	applied	\N	\N	\N	\N	163863	163863	331117
21411	31131	53	applied	\N	\N	\N	\N	163864	163864	331118
21411	31133	54	applied	\N	\N	\N	\N	163865	163865	331119
21411	31134	55	applied	\N	\N	\N	\N	163866	163866	331120
21411	31140	56	applied	\N	\N	\N	\N	163867	163867	331121
21411	31147	57	applied	\N	\N	\N	\N	163868	163868	331122
21411	31149	58	applied	\N	\N	\N	\N	163869	163869	331123
21411	31152	59	applied	\N	\N	\N	\N	163870	163870	331124
21411	31153	60	applied	\N	\N	\N	\N	163871	163871	331125
21411	31154	61	applied	\N	\N	\N	\N	163872	163872	331126
21411	31158	62	applied	\N	\N	\N	\N	163873	163873	331127
21411	31161	63	applied	\N	\N	\N	\N	163874	163874	331128
21411	31163	64	applied	\N	\N	\N	\N	163875	163875	331129
21411	31165	65	applied	\N	\N	\N	\N	163876	163876	331130
21411	31168	66	applied	\N	\N	\N	\N	163877	163877	331131
21411	31172	68	applied	\N	\N	\N	\N	163879	163879	331133
21411	31173	69	applied	\N	\N	\N	\N	163880	163880	331134
21411	31177	70	applied	\N	\N	\N	\N	163881	163881	331135
21411	31179	71	applied	\N	\N	\N	\N	163882	163882	331136
21411	31180	72	applied	\N	\N	\N	\N	163883	163883	331137
21411	31184	73	applied	\N	\N	\N	\N	163884	163884	331138
21411	31185	74	applied	\N	\N	\N	\N	163885	163885	331139
21411	31188	75	applied	\N	\N	\N	\N	163886	163886	331140
21411	31191	76	applied	\N	\N	\N	\N	163887	163887	331141
21411	31192	77	applied	\N	\N	\N	\N	163888	163888	331142
21411	31194	78	applied	\N	\N	\N	\N	163889	163889	331143
21411	31197	79	applied	\N	\N	\N	\N	163890	163890	331144
21411	31199	80	applied	\N	\N	\N	\N	163891	163891	331145
21411	31201	81	applied	\N	\N	\N	\N	163892	163892	331146
21411	31202	82	applied	\N	\N	\N	\N	163893	163893	331147
21411	31205	83	applied	\N	\N	\N	\N	163894	163894	331148
21411	31209	85	applied	\N	\N	\N	\N	163896	163896	331150
21411	31212	86	applied	\N	\N	\N	\N	163897	163897	331151
21411	31213	87	applied	\N	\N	\N	\N	163898	163898	331152
21411	31216	88	applied	\N	\N	\N	\N	163899	163899	331153
21453	31832	8	applied	\N	\N	\N	\N	164153	164153	331407
21453	31838	9	applied	\N	\N	\N	\N	164154	164154	331408
21453	31842	10	applied	\N	\N	\N	\N	164155	164155	331409
21453	31843	11	applied	\N	\N	\N	\N	164156	164156	331410
21453	31851	12	applied	\N	\N	\N	\N	164157	164157	331411
21453	31852	13	applied	\N	\N	\N	\N	164158	164158	331412
21453	31866	14	applied	\N	\N	\N	\N	164159	164159	331413
21453	31784	15	applied	\N	\N	\N	\N	164160	164160	331414
21453	31830	16	applied	\N	\N	\N	\N	164161	164161	331415
21453	31835	17	applied	\N	\N	\N	\N	164162	164162	331416
21454	31881	0	applied	\N	\N	\N	\N	164163	164163	331417
21454	31882	1	applied	\N	\N	\N	\N	164164	164164	331418
21458	31894	0	applied	\N	\N	\N	\N	164218	164218	331472
21458	31895	1	applied	\N	\N	\N	\N	164219	164219	331473
21458	31896	2	applied	\N	\N	\N	\N	164220	164220	331474
21458	31897	3	applied	\N	\N	\N	\N	164221	164221	331475
21458	31898	4	applied	\N	\N	\N	\N	164222	164222	331476
21458	31899	5	applied	\N	\N	\N	\N	164223	164223	331477
21458	31900	6	applied	\N	\N	\N	\N	164224	164224	331478
21460	31901	0	applied	\N	\N	\N	\N	164228	164228	331482
21460	31902	1	applied	\N	\N	\N	\N	164229	164229	331483
21460	31903	2	applied	\N	\N	\N	\N	164230	164230	331484
21463	31904	0	applied	\N	\N	\N	\N	164237	164237	331491
21463	31905	1	applied	\N	\N	\N	\N	164238	164238	331492
21463	31906	2	applied	\N	\N	\N	\N	164239	164239	331493
21465	31907	0	applied	\N	\N	\N	\N	164243	164243	331497
21465	31908	1	applied	\N	\N	\N	\N	164244	164244	331498
21465	31909	2	applied	\N	\N	\N	\N	164245	164245	331499
21465	31911	4	applied	\N	\N	\N	\N	164247	164247	331501
21465	31912	5	applied	\N	\N	\N	\N	164248	164248	331502
21465	31913	6	applied	\N	\N	\N	\N	164249	164249	331503
21465	31914	7	applied	\N	\N	\N	\N	164250	164250	331504
21465	31915	8	applied	\N	\N	\N	\N	164251	164251	331505
21465	31916	9	applied	\N	\N	\N	\N	164252	164252	331506
21476	31920	0	applied	\N	\N	\N	\N	164295	164295	331549
21476	31921	1	applied	\N	\N	\N	\N	164296	164296	331550
21476	31922	2	applied	\N	\N	\N	\N	164297	164297	331551
21476	31923	3	applied	\N	\N	\N	\N	164298	164298	331552
21476	31924	4	applied	\N	\N	\N	\N	164299	164299	331553
21476	31925	5	applied	\N	\N	\N	\N	164300	164300	331554
21476	31926	6	applied	\N	\N	\N	\N	164301	164301	331555
21476	31927	7	applied	\N	\N	\N	\N	164302	164302	331556
21411	31423	14	applied	\N	\N	\N	\N	163825	163825	331079
21411	31424	15	applied	\N	\N	\N	\N	163826	163826	331080
21411	31229	93	applied	\N	\N	\N	\N	163904	163904	331158
21411	31231	94	applied	\N	\N	\N	\N	163905	163905	331159
21411	31234	95	applied	\N	\N	\N	\N	163906	163906	331160
21411	31235	96	applied	\N	\N	\N	\N	163907	163907	331161
21411	31238	97	applied	\N	\N	\N	\N	163908	163908	331162
21411	31241	98	applied	\N	\N	\N	\N	163909	163909	331163
21411	31243	99	applied	\N	\N	\N	\N	163910	163910	331164
21411	31244	100	applied	\N	\N	\N	\N	163911	163911	331165
21411	31247	101	applied	\N	\N	\N	\N	163912	163912	331166
21411	31251	102	applied	\N	\N	\N	\N	163913	163913	331167
21411	31252	103	applied	\N	\N	\N	\N	163914	163914	331168
21411	31253	104	applied	\N	\N	\N	\N	163915	163915	331169
21411	31254	105	applied	\N	\N	\N	\N	163916	163916	331170
21411	31260	107	applied	\N	\N	\N	\N	163917	163917	331171
21411	31263	109	applied	\N	\N	\N	\N	163919	163919	331173
21411	31266	110	applied	\N	\N	\N	\N	163920	163920	331174
21411	31267	111	applied	\N	\N	\N	\N	163921	163921	331175
21411	31271	112	applied	\N	\N	\N	\N	163922	163922	331176
21411	31273	113	applied	\N	\N	\N	\N	163923	163923	331177
21411	31275	114	applied	\N	\N	\N	\N	163924	163924	331178
21411	31277	115	applied	\N	\N	\N	\N	163925	163925	331179
21411	31279	116	applied	\N	\N	\N	\N	163926	163926	331180
21411	31280	117	applied	\N	\N	\N	\N	163927	163927	331181
21411	31281	118	applied	\N	\N	\N	\N	163928	163928	331182
21411	31285	119	applied	\N	\N	\N	\N	163929	163929	331183
21411	31287	120	applied	\N	\N	\N	\N	163930	163930	331184
21411	31289	121	applied	\N	\N	\N	\N	163931	163931	331185
21411	31291	122	applied	\N	\N	\N	\N	163932	163932	331186
21417	31765	0	applied	\N	\N	\N	\N	163964	163964	331218
21417	31766	1	applied	\N	\N	\N	\N	163965	163965	331219
21417	31768	3	applied	\N	\N	\N	\N	163967	163967	331221
21417	31776	4	applied	\N	\N	\N	\N	163968	163968	331222
21417	31769	5	applied	\N	\N	\N	\N	163969	163969	331223
21417	31770	6	applied	\N	\N	\N	\N	163970	163970	331224
21417	31771	7	applied	\N	\N	\N	\N	163971	163971	331225
21417	31772	9	applied	\N	\N	\N	\N	163972	163972	331226
21417	31773	10	applied	\N	\N	\N	\N	163973	163973	331227
21417	31774	11	applied	\N	\N	\N	\N	163974	163974	331228
21417	31775	12	applied	\N	\N	\N	\N	163975	163975	331229
21421	31782	0	applied	\N	\N	\N	\N	163993	163993	331247
21421	31783	1	applied	\N	\N	\N	\N	163994	163994	331248
21421	31784	2	applied	\N	\N	\N	\N	163995	163995	331249
21423	31785	0	applied	\N	\N	\N	\N	163999	163999	331253
21423	31786	1	applied	\N	\N	\N	\N	164000	164000	331254
21423	31787	2	applied	\N	\N	\N	\N	164001	164001	331255
21426	31788	0	applied	\N	\N	\N	\N	164009	164009	331263
21426	31790	2	applied	\N	\N	\N	\N	164011	164011	331265
21426	31791	3	applied	\N	\N	\N	\N	164012	164012	331266
21429	31798	0	applied	\N	\N	\N	\N	164029	164029	331283
21429	31799	1	applied	\N	\N	\N	\N	164030	164030	331284
21429	31800	2	applied	\N	\N	\N	\N	164031	164031	331285
21429	31801	3	applied	\N	\N	\N	\N	164032	164032	331286
21429	31802	4	applied	\N	\N	\N	\N	164033	164033	331287
21429	31803	5	applied	\N	\N	\N	\N	164034	164034	331288
21429	31804	6	applied	\N	\N	\N	\N	164035	164035	331289
21429	31805	7	applied	\N	\N	\N	\N	164036	164036	331290
21429	31806	8	applied	\N	\N	\N	\N	164037	164037	331291
21429	31807	9	applied	\N	\N	\N	\N	164038	164038	331292
21432	31808	0	applied	\N	\N	\N	\N	164045	164045	331299
21432	31809	1	applied	\N	\N	\N	\N	164046	164046	331300
21432	31810	2	applied	\N	\N	\N	\N	164047	164047	331301
21433	31811	0	applied	\N	\N	\N	\N	164048	164048	331302
21433	31813	2	applied	\N	\N	\N	\N	164050	164050	331304
21436	31820	0	applied	\N	\N	\N	\N	164063	164063	331317
21436	31821	1	applied	\N	\N	\N	\N	164064	164064	331318
21436	31822	2	applied	\N	\N	\N	\N	164065	164065	331319
21436	31823	3	applied	\N	\N	\N	\N	164066	164066	331320
21436	31824	4	applied	\N	\N	\N	\N	164067	164067	331321
21436	31825	5	applied	\N	\N	\N	\N	164068	164068	331322
21436	31826	6	applied	\N	\N	\N	\N	164069	164069	331323
21444	31850	0	applied	\N	\N	\N	\N	164100	164100	331354
21444	31851	1	applied	\N	\N	\N	\N	164101	164101	331355
21444	31852	2	applied	\N	\N	\N	\N	164102	164102	331356
21444	31853	3	applied	\N	\N	\N	\N	164103	164103	331357
21444	31854	4	applied	\N	\N	\N	\N	164104	164104	331358
21444	31855	5	applied	\N	\N	\N	\N	164105	164105	331359
21447	31859	0	applied	\N	\N	\N	\N	164112	164112	331366
21447	31860	1	applied	\N	\N	\N	\N	164113	164113	331367
21447	31862	3	applied	\N	\N	\N	\N	164115	164115	331369
21447	31863	4	applied	\N	\N	\N	\N	164116	164116	331370
21447	31864	6	applied	\N	\N	\N	\N	164117	164117	331371
21447	31865	7	applied	\N	\N	\N	\N	164118	164118	331372
21450	31871	0	applied	\N	\N	\N	\N	164127	164127	331381
21450	31831	1	applied	\N	\N	\N	\N	164128	164128	331382
21450	31832	2	applied	\N	\N	\N	\N	164129	164129	331383
21450	31838	3	applied	\N	\N	\N	\N	164130	164130	331384
21450	31842	4	applied	\N	\N	\N	\N	164131	164131	331385
21450	31843	5	applied	\N	\N	\N	\N	164132	164132	331386
21450	31851	6	applied	\N	\N	\N	\N	164133	164133	331387
21450	31852	7	applied	\N	\N	\N	\N	164134	164134	331388
21450	31866	8	applied	\N	\N	\N	\N	164135	164135	331389
21450	31830	9	applied	\N	\N	\N	\N	164136	164136	331390
21450	31835	10	applied	\N	\N	\N	\N	164137	164137	331391
21452	31878	0	applied	\N	\N	\N	\N	164142	164142	331396
21452	31880	2	applied	\N	\N	\N	\N	164144	164144	331398
21456	31592	0	applied	\N	\N	\N	\N	164169	164169	331423
21456	31602	1	applied	\N	\N	\N	\N	164170	164170	331424
21456	31603	2	applied	\N	\N	\N	\N	164171	164171	331425
21456	31616	3	applied	\N	\N	\N	\N	164172	164172	331426
21456	31735	4	applied	\N	\N	\N	\N	164173	164173	331427
21456	31746	5	applied	\N	\N	\N	\N	164174	164174	331428
21456	31757	6	applied	\N	\N	\N	\N	164175	164175	331429
21456	31758	7	applied	\N	\N	\N	\N	164176	164176	331430
21456	31765	8	applied	\N	\N	\N	\N	164177	164177	331431
21456	31766	9	applied	\N	\N	\N	\N	164178	164178	331432
21456	31719	10	applied	\N	\N	1000000000	\N	164179	164179	331433
21456	31871	11	applied	\N	\N	\N	\N	164180	164180	331434
21456	31831	12	applied	\N	\N	\N	\N	164181	164181	331435
21456	31832	13	applied	\N	\N	\N	\N	164182	164182	331436
21456	31838	14	applied	\N	\N	\N	\N	164183	164183	331437
21411	31227	92	applied	\N	\N	\N	\N	163903	163903	331157
21441	31836	0	applied	\N	\N	\N	\N	164086	164086	331340
21441	31837	1	applied	\N	\N	\N	\N	164087	164087	331341
21441	31838	2	applied	\N	\N	\N	\N	164088	164088	331342
21441	31839	3	applied	\N	\N	\N	\N	164089	164089	331343
21441	31840	4	applied	\N	\N	\N	\N	164090	164090	331344
21441	31841	5	applied	\N	\N	\N	\N	164091	164091	331345
21443	31842	0	applied	\N	\N	\N	\N	164092	164092	331346
21443	31843	1	applied	\N	\N	\N	\N	164093	164093	331347
21443	31844	2	applied	\N	\N	\N	\N	164094	164094	331348
21443	31845	3	applied	\N	\N	\N	\N	164095	164095	331349
21443	31846	4	applied	\N	\N	\N	\N	164096	164096	331350
21443	31847	5	applied	\N	\N	\N	\N	164097	164097	331351
21443	31848	6	applied	\N	\N	\N	\N	164098	164098	331352
21443	31849	7	applied	\N	\N	\N	\N	164099	164099	331353
21449	31871	1	applied	\N	\N	\N	\N	164124	164124	331378
21449	31872	2	applied	\N	\N	\N	\N	164125	164125	331379
21449	31873	3	applied	\N	\N	\N	\N	164126	164126	331380
21451	31874	0	applied	\N	\N	\N	\N	164138	164138	331392
21451	31875	1	applied	\N	\N	\N	\N	164139	164139	331393
21451	31876	2	applied	\N	\N	\N	\N	164140	164140	331394
21451	31877	3	applied	\N	\N	\N	\N	164141	164141	331395
21455	31884	0	applied	\N	\N	\N	\N	164166	164166	331420
21455	31885	1	applied	\N	\N	\N	\N	164167	164167	331421
21455	31886	2	applied	\N	\N	\N	\N	164168	164168	331422
21456	31842	15	applied	\N	\N	\N	\N	164184	164184	331438
21456	31843	16	applied	\N	\N	\N	\N	164185	164185	331439
21456	31851	17	applied	\N	\N	\N	\N	164186	164186	331440
21456	31852	18	applied	\N	\N	\N	\N	164187	164187	331441
21456	31866	19	applied	\N	\N	\N	\N	164188	164188	331442
21456	31572	20	applied	\N	\N	\N	\N	164189	164189	331443
21456	31623	22	applied	\N	\N	1000000000	\N	164191	164191	331445
21456	31640	23	applied	\N	\N	\N	\N	164192	164192	331446
21456	31502	24	applied	\N	\N	\N	\N	164193	164193	331447
21456	31504	25	applied	\N	\N	\N	\N	164194	164194	331448
21456	31509	26	applied	\N	\N	\N	\N	164195	164195	331449
21456	31511	27	applied	\N	\N	\N	\N	164196	164196	331450
21456	31514	28	applied	\N	\N	\N	\N	164197	164197	331451
21456	31519	29	applied	\N	\N	\N	\N	164198	164198	331452
21456	31523	30	applied	\N	\N	\N	\N	164199	164199	331453
21456	31524	31	applied	\N	\N	\N	\N	164200	164200	331454
21456	31528	32	applied	\N	\N	\N	\N	164201	164201	331455
21456	31532	33	applied	\N	\N	\N	\N	164202	164202	331456
21456	31533	34	applied	\N	\N	\N	\N	164203	164203	331457
21456	31538	35	applied	\N	\N	\N	\N	164204	164204	331458
21456	31541	36	applied	\N	\N	\N	\N	164205	164205	331459
21456	31545	37	applied	\N	\N	\N	\N	164206	164206	331460
21456	31549	39	applied	\N	\N	\N	\N	164208	164208	331462
21456	31784	40	applied	\N	\N	\N	\N	164209	164209	331463
21456	31554	41	applied	\N	\N	\N	\N	164210	164210	331464
21459	31901	0	applied	\N	\N	\N	\N	164225	164225	331479
21459	31902	1	applied	\N	\N	\N	\N	164226	164226	331480
21459	31903	2	applied	\N	\N	\N	\N	164227	164227	331481
21461	31904	0	applied	\N	\N	\N	\N	164231	164231	331485
21461	31905	1	applied	\N	\N	\N	\N	164232	164232	331486
21461	31906	2	applied	\N	\N	\N	\N	164233	164233	331487
21462	31904	0	applied	\N	\N	\N	\N	164234	164234	331488
21462	31905	1	applied	\N	\N	\N	\N	164235	164235	331489
21462	31906	2	applied	\N	\N	\N	\N	164236	164236	331490
21466	31907	0	applied	\N	\N	\N	\N	164253	164253	331507
21466	31908	1	applied	\N	\N	\N	\N	164254	164254	331508
21466	31909	2	applied	\N	\N	\N	\N	164255	164255	331509
21466	31910	3	applied	\N	\N	\N	\N	164256	164256	331510
21466	31912	5	applied	\N	\N	\N	\N	164258	164258	331512
21466	31913	6	applied	\N	\N	\N	\N	164259	164259	331513
21466	31914	7	applied	\N	\N	\N	\N	164260	164260	331514
21466	31915	8	applied	\N	\N	\N	\N	164261	164261	331515
21466	31916	9	applied	\N	\N	\N	\N	164262	164262	331516
21468	31907	0	applied	\N	\N	\N	\N	164273	164273	331527
21468	31908	1	applied	\N	\N	\N	\N	164274	164274	331528
21468	31909	2	applied	\N	\N	\N	\N	164275	164275	331529
21468	31910	3	applied	\N	\N	\N	\N	164276	164276	331530
21468	31911	4	applied	\N	\N	\N	\N	164277	164277	331531
21468	31912	5	applied	\N	\N	\N	\N	164278	164278	331532
21468	31913	6	applied	\N	\N	\N	\N	164279	164279	331533
21468	31914	7	applied	\N	\N	\N	\N	164280	164280	331534
21468	31915	8	applied	\N	\N	\N	\N	164281	164281	331535
21468	31916	9	applied	\N	\N	\N	\N	164282	164282	331536
21470	31917	0	applied	\N	\N	\N	\N	164286	164286	331540
21470	31919	2	applied	\N	\N	\N	\N	164288	164288	331542
21471	31917	0	applied	\N	\N	\N	\N	164289	164289	331543
21471	31918	1	applied	\N	\N	\N	\N	164290	164290	331544
21471	31919	2	applied	\N	\N	\N	\N	164291	164291	331545
21472	31917	0	applied	\N	\N	\N	\N	164292	164292	331546
21472	31918	1	applied	\N	\N	\N	\N	164293	164293	331547
21472	31919	2	applied	\N	\N	\N	\N	164294	164294	331548
21477	31930	0	applied	\N	\N	\N	\N	164305	164305	331559
21477	31931	1	applied	\N	\N	\N	\N	164306	164306	331560
21477	31932	2	applied	\N	\N	\N	\N	164307	164307	331561
21477	31933	3	applied	\N	\N	\N	\N	164308	164308	331562
21478	31930	0	applied	\N	\N	\N	\N	164309	164309	331563
21478	31931	1	applied	\N	\N	\N	\N	164310	164310	331564
21478	31932	2	applied	\N	\N	\N	\N	164311	164311	331565
21478	31933	3	applied	\N	\N	\N	\N	164312	164312	331566
21480	31930	0	applied	\N	\N	\N	\N	164317	164317	331571
21480	31932	2	applied	\N	\N	\N	\N	164319	164319	331573
21480	31933	3	applied	\N	\N	\N	\N	164320	164320	331574
21481	31930	0	applied	\N	\N	\N	\N	164321	164321	331575
21481	31931	1	applied	\N	\N	\N	\N	164322	164322	331576
21481	31932	2	applied	\N	\N	\N	\N	164323	164323	331577
21481	31933	3	applied	\N	\N	\N	\N	164324	164324	331578
21482	31930	0	applied	\N	\N	\N	\N	164325	164325	331579
21482	31931	1	applied	\N	\N	\N	\N	164326	164326	331580
21482	31932	2	applied	\N	\N	\N	\N	164327	164327	331581
21486	31943	0	applied	\N	\N	\N	\N	164342	164342	331596
21486	31944	1	applied	\N	\N	\N	\N	164343	164343	331597
21486	31945	2	applied	\N	\N	\N	\N	164344	164344	331598
21488	31946	0	applied	\N	\N	\N	\N	164348	164348	331602
21488	31947	1	applied	\N	\N	\N	\N	164349	164349	331603
21488	31948	2	applied	\N	\N	\N	\N	164350	164350	331604
21491	31955	0	applied	\N	\N	\N	\N	164357	164357	331611
21438	31830	3	applied	\N	\N	\N	\N	164074	164074	331328
21467	31914	7	applied	\N	\N	\N	\N	164270	164270	331524
21467	31915	8	applied	\N	\N	\N	\N	164271	164271	331525
21467	31916	9	applied	\N	\N	\N	\N	164272	164272	331526
21469	31917	0	applied	\N	\N	\N	\N	164283	164283	331537
21469	31918	1	applied	\N	\N	\N	\N	164284	164284	331538
21469	31919	2	applied	\N	\N	\N	\N	164285	164285	331539
21484	31934	0	applied	\N	\N	\N	\N	164333	164333	331587
21484	31935	1	applied	\N	\N	\N	\N	164334	164334	331588
21487	31946	0	applied	\N	\N	\N	\N	164345	164345	331599
21487	31947	1	applied	\N	\N	\N	\N	164346	164346	331600
21487	31948	2	applied	\N	\N	\N	\N	164347	164347	331601
21494	31955	0	applied	\N	\N	\N	\N	164361	164361	331615
21494	31956	1	applied	\N	\N	\N	\N	164362	164362	331616
21495	31957	0	applied	\N	\N	\N	\N	164363	164363	331617
21495	31956	1	applied	\N	\N	\N	\N	164364	164364	331618
21495	31958	2	applied	\N	\N	\N	\N	164365	164365	331619
21498	31964	0	applied	\N	\N	\N	\N	164376	164376	331630
21498	31965	1	applied	\N	\N	\N	\N	164377	164377	331631
21499	31966	0	applied	\N	\N	\N	\N	164378	164378	331632
21499	31967	1	applied	\N	\N	\N	\N	164379	164379	331633
21501	31968	0	applied	\N	\N	\N	\N	164382	164382	331636
21501	31969	1	applied	\N	\N	\N	\N	164383	164383	331637
21503	31970	0	applied	\N	\N	\N	\N	164386	164386	331640
21503	31971	1	applied	\N	\N	\N	\N	164387	164387	331641
21503	31972	2	applied	\N	\N	\N	\N	164388	164388	331642
21503	31973	3	applied	\N	\N	\N	\N	164389	164389	331643
21504	31974	0	applied	\N	\N	\N	\N	164390	164390	331644
21505	31976	0	applied	\N	\N	\N	\N	164392	164392	331646
21505	31977	1	applied	\N	\N	\N	\N	164393	164393	331647
21505	31978	2	applied	\N	\N	\N	\N	164394	164394	331648
21505	31979	3	applied	\N	\N	\N	\N	164395	164395	331649
21505	31980	4	applied	\N	\N	\N	\N	164396	164396	331650
21505	31981	5	applied	\N	\N	\N	\N	164397	164397	331651
21507	31982	0	applied	\N	\N	\N	\N	164404	164404	331658
21507	31983	1	applied	\N	\N	\N	\N	164405	164405	331659
21507	31984	2	applied	\N	\N	\N	\N	164406	164406	331660
21507	31985	3	applied	\N	\N	\N	\N	164407	164407	331661
21508	31982	0	applied	\N	\N	\N	\N	164408	164408	331662
21508	31983	1	applied	\N	\N	\N	\N	164409	164409	331663
21508	31984	2	applied	\N	\N	\N	\N	164410	164410	331664
21508	31985	3	applied	\N	\N	\N	\N	164411	164411	331665
21510	31989	0	applied	\N	\N	\N	\N	164415	164415	331669
21510	31990	1	applied	\N	\N	\N	\N	164416	164416	331670
21510	31992	3	applied	\N	\N	\N	\N	164418	164418	331672
21510	31993	4	applied	\N	\N	\N	\N	164419	164419	331673
21510	31994	5	applied	\N	\N	\N	\N	164420	164420	331674
21510	31995	6	applied	\N	\N	\N	\N	164421	164421	331675
21513	32002	0	applied	\N	\N	\N	\N	164432	164432	331686
21513	32003	1	applied	\N	\N	\N	\N	164433	164433	331687
21513	32004	2	applied	\N	\N	\N	\N	164434	164434	331688
21513	32005	3	applied	\N	\N	\N	\N	164435	164435	331689
21514	32006	0	applied	\N	\N	\N	\N	164436	164436	331690
21514	32007	1	applied	\N	\N	\N	\N	164437	164437	331691
21514	32008	2	applied	\N	\N	\N	\N	164438	164438	331692
21515	31592	0	applied	\N	\N	\N	\N	164439	164439	331693
21515	31602	1	applied	\N	\N	\N	\N	164440	164440	331694
21515	31603	2	applied	\N	\N	\N	\N	164441	164441	331695
21515	31616	3	applied	\N	\N	\N	\N	164442	164442	331696
21515	31138	4	applied	\N	\N	\N	\N	164443	164443	331697
21515	30952	6	applied	\N	\N	1000000000	\N	164445	164445	331699
21515	30999	7	applied	\N	\N	\N	\N	164446	164446	331700
21515	31735	8	applied	\N	\N	\N	\N	164447	164447	331701
21515	31746	9	applied	\N	\N	\N	\N	164448	164448	331702
21515	31757	10	applied	\N	\N	\N	\N	164449	164449	331703
21515	31758	11	applied	\N	\N	\N	\N	164450	164450	331704
21515	31765	12	applied	\N	\N	\N	\N	164451	164451	331705
21515	31766	13	applied	\N	\N	\N	\N	164452	164452	331706
21515	31416	14	applied	\N	\N	\N	\N	164453	164453	331707
21515	31139	15	applied	\N	\N	\N	\N	164454	164454	331708
21515	31400	16	applied	\N	\N	\N	\N	164455	164455	331709
21515	31250	17	applied	\N	\N	\N	\N	164456	164456	331710
21515	31950	18	applied	\N	\N	\N	\N	164457	164457	331711
21515	31422	19	applied	\N	\N	\N	\N	164458	164458	331712
21515	31960	20	applied	\N	\N	\N	\N	164459	164459	331713
21515	31417	21	applied	\N	\N	\N	\N	164460	164460	331714
21515	31401	22	applied	\N	\N	\N	\N	164461	164461	331715
21516	32009	0	applied	\N	\N	\N	\N	164564	164564	331818
21516	32011	2	applied	\N	\N	\N	\N	164566	164566	331820
21518	31592	0	applied	\N	\N	\N	\N	164570	164570	331824
21518	31602	1	applied	\N	\N	\N	\N	164571	164571	331825
21518	31603	2	applied	\N	\N	\N	\N	164572	164572	331826
21518	31616	3	applied	\N	\N	\N	\N	164573	164573	331827
21518	31735	4	applied	\N	\N	\N	\N	164574	164574	331828
21518	31746	5	applied	\N	\N	\N	\N	164575	164575	331829
21518	31757	6	applied	\N	\N	\N	\N	164576	164576	331830
21518	31758	7	applied	\N	\N	\N	\N	164577	164577	331831
21518	31765	8	applied	\N	\N	\N	\N	164578	164578	331832
21518	31766	9	applied	\N	\N	\N	\N	164579	164579	331833
21518	31950	10	applied	\N	\N	\N	\N	164580	164580	331834
21518	31960	11	applied	\N	\N	\N	\N	164581	164581	331835
21518	31719	12	applied	\N	\N	1000000000	\N	164582	164582	331836
21518	31871	13	applied	\N	\N	\N	\N	164583	164583	331837
21518	31110	14	applied	\N	\N	\N	\N	164584	164584	331838
21518	31114	16	applied	\N	\N	\N	\N	164586	164586	331840
21518	31118	17	applied	\N	\N	\N	\N	164587	164587	331841
21518	31831	18	applied	\N	\N	\N	\N	164588	164588	331842
21518	31832	19	applied	\N	\N	\N	\N	164589	164589	331843
21518	31838	20	applied	\N	\N	\N	\N	164590	164590	331844
21518	31842	21	applied	\N	\N	\N	\N	164591	164591	331845
21518	31843	22	applied	\N	\N	\N	\N	164592	164592	331846
21518	31851	23	applied	\N	\N	\N	\N	164593	164593	331847
21518	31852	24	applied	\N	\N	\N	\N	164594	164594	331848
21518	31866	25	applied	\N	\N	\N	\N	164595	164595	331849
21518	31120	26	applied	\N	\N	\N	\N	164596	164596	331850
21518	31123	27	applied	\N	\N	\N	\N	164597	164597	331851
21518	31125	28	applied	\N	\N	\N	\N	164598	164598	331852
21518	31126	29	applied	\N	\N	\N	\N	164599	164599	331853
21518	31129	30	applied	\N	\N	\N	\N	164600	164600	331854
21518	31131	31	applied	\N	\N	\N	\N	164601	164601	331855
21467	31912	5	applied	\N	\N	\N	\N	164268	164268	331522
21467	31913	6	applied	\N	\N	\N	\N	164269	164269	331523
21479	31932	2	applied	\N	\N	\N	\N	164315	164315	331569
21479	31933	3	applied	\N	\N	\N	\N	164316	164316	331570
21483	31930	0	applied	\N	\N	\N	\N	164329	164329	331583
21483	31931	1	applied	\N	\N	\N	\N	164330	164330	331584
21483	31932	2	applied	\N	\N	\N	\N	164331	164331	331585
21483	31933	3	applied	\N	\N	\N	\N	164332	164332	331586
21485	31936	0	applied	\N	\N	\N	\N	164335	164335	331589
21485	31937	1	applied	\N	\N	\N	\N	164336	164336	331590
21485	31938	2	applied	\N	\N	\N	\N	164337	164337	331591
21485	31939	3	applied	\N	\N	\N	\N	164338	164338	331592
21485	31940	4	applied	\N	\N	\N	\N	164339	164339	331593
21485	31941	5	applied	\N	\N	\N	\N	164340	164340	331594
21485	31942	6	applied	\N	\N	\N	\N	164341	164341	331595
21490	31953	0	applied	\N	\N	\N	\N	164355	164355	331609
21490	31954	1	applied	\N	\N	\N	\N	164356	164356	331610
21497	31959	0	applied	\N	\N	\N	\N	164371	164371	331625
21497	31961	2	applied	\N	\N	\N	\N	164373	164373	331627
21497	31962	3	applied	\N	\N	\N	\N	164374	164374	331628
21497	31963	4	applied	\N	\N	\N	\N	164375	164375	331629
21500	31968	0	applied	\N	\N	\N	\N	164380	164380	331634
21500	31969	1	applied	\N	\N	\N	\N	164381	164381	331635
21502	31968	0	applied	\N	\N	\N	\N	164384	164384	331638
21502	31969	1	applied	\N	\N	\N	\N	164385	164385	331639
21506	31976	0	applied	\N	\N	\N	\N	164398	164398	331652
21506	31977	1	applied	\N	\N	\N	\N	164399	164399	331653
21506	31978	2	applied	\N	\N	\N	\N	164400	164400	331654
21506	31979	3	applied	\N	\N	\N	\N	164401	164401	331655
21506	31980	4	applied	\N	\N	\N	\N	164402	164402	331656
21506	31981	5	applied	\N	\N	\N	\N	164403	164403	331657
21511	31996	0	applied	\N	\N	\N	\N	164422	164422	331676
21511	31997	1	applied	\N	\N	\N	\N	164423	164423	331677
21511	31998	2	applied	\N	\N	\N	\N	164424	164424	331678
21511	32000	4	applied	\N	\N	\N	\N	164426	164426	331680
21511	32001	5	applied	\N	\N	\N	\N	164427	164427	331681
21517	32012	0	applied	\N	\N	\N	\N	164567	164567	331821
21517	32013	1	applied	\N	\N	\N	\N	164568	164568	331822
21517	32014	2	applied	\N	\N	\N	\N	164569	164569	331823
21518	31134	33	applied	\N	\N	\N	\N	164603	164603	331857
21518	31140	34	applied	\N	\N	\N	\N	164604	164604	331858
21518	31147	35	applied	\N	\N	\N	\N	164605	164605	331859
21518	31149	36	applied	\N	\N	\N	\N	164606	164606	331860
21518	31152	37	applied	\N	\N	\N	\N	164607	164607	331861
21518	31153	38	applied	\N	\N	\N	\N	164608	164608	331862
21518	31154	39	applied	\N	\N	\N	\N	164609	164609	331863
21518	31158	40	applied	\N	\N	\N	\N	164610	164610	331864
21518	31161	41	applied	\N	\N	\N	\N	164611	164611	331865
21518	31163	42	applied	\N	\N	\N	\N	164612	164612	331866
21518	31165	43	applied	\N	\N	\N	\N	164613	164613	331867
21518	31170	45	applied	\N	\N	\N	\N	164615	164615	331869
21518	31172	47	applied	\N	\N	\N	\N	164616	164616	331870
21518	31173	48	applied	\N	\N	\N	\N	164617	164617	331871
21518	31177	49	applied	\N	\N	\N	\N	164618	164618	331872
21518	31179	50	applied	\N	\N	\N	\N	164619	164619	331873
21518	31180	51	applied	\N	\N	\N	\N	164620	164620	331874
21518	31184	52	applied	\N	\N	\N	\N	164621	164621	331875
21518	31185	53	applied	\N	\N	\N	\N	164622	164622	331876
21518	31188	54	applied	\N	\N	\N	\N	164623	164623	331877
21518	31191	55	applied	\N	\N	\N	\N	164624	164624	331878
21518	31192	56	applied	\N	\N	\N	\N	164625	164625	331879
21518	31194	57	applied	\N	\N	\N	\N	164626	164626	331880
21518	31197	58	applied	\N	\N	\N	\N	164627	164627	331881
21518	31199	59	applied	\N	\N	\N	\N	164628	164628	331882
21518	31201	60	applied	\N	\N	\N	\N	164629	164629	331883
21518	31202	61	applied	\N	\N	\N	\N	164630	164630	331884
21518	31207	63	applied	\N	\N	\N	\N	164632	164632	331886
21518	31209	64	applied	\N	\N	\N	\N	164633	164633	331887
21518	31212	65	applied	\N	\N	\N	\N	164634	164634	331888
21518	31213	66	applied	\N	\N	\N	\N	164635	164635	331889
21518	31216	67	applied	\N	\N	\N	\N	164636	164636	331890
21518	31219	68	applied	\N	\N	\N	\N	164637	164637	331891
21518	31220	69	applied	\N	\N	\N	\N	164638	164638	331892
21518	31221	70	applied	\N	\N	\N	\N	164639	164639	331893
21518	31227	71	applied	\N	\N	\N	\N	164640	164640	331894
21518	31229	72	applied	\N	\N	\N	\N	164641	164641	331895
21518	31231	73	applied	\N	\N	\N	\N	164642	164642	331896
21518	31234	74	applied	\N	\N	\N	\N	164643	164643	331897
21518	31235	75	applied	\N	\N	\N	\N	164644	164644	331898
21518	31238	76	applied	\N	\N	\N	\N	164645	164645	331899
21521	32019	0	applied	\N	\N	\N	\N	164702	164702	331956
21521	32020	1	applied	\N	\N	\N	\N	164703	164703	331957
21524	32019	0	applied	\N	\N	\N	\N	164710	164710	331964
21524	32020	1	applied	\N	\N	\N	\N	164711	164711	331965
21524	32021	2	applied	\N	\N	\N	\N	164712	164712	331966
21525	32022	0	applied	\N	\N	\N	\N	164713	164713	331967
21525	32023	1	applied	\N	\N	\N	\N	164714	164714	331968
21525	32024	2	applied	\N	\N	\N	\N	164715	164715	331969
21528	32031	0	applied	\N	\N	\N	\N	164723	164723	331977
21528	32032	1	applied	\N	\N	\N	\N	164724	164724	331978
21530	32031	0	applied	\N	\N	\N	\N	164728	164728	331982
21530	32032	1	applied	\N	\N	\N	\N	164729	164729	331983
21530	32033	2	applied	\N	\N	\N	\N	164730	164730	331984
21532	32034	0	applied	\N	\N	\N	\N	164731	164731	331985
21532	32035	1	applied	\N	\N	\N	\N	164732	164732	331986
21532	32036	2	applied	\N	\N	\N	\N	164733	164733	331987
21541	31592	0	applied	\N	\N	\N	\N	164755	164755	332009
21541	31602	1	applied	\N	\N	\N	\N	164756	164756	332010
21541	31616	3	applied	\N	\N	\N	\N	164758	164758	332012
21541	31735	4	applied	\N	\N	\N	\N	164759	164759	332013
21541	31746	5	applied	\N	\N	\N	\N	164760	164760	332014
21541	31757	6	applied	\N	\N	\N	\N	164761	164761	332015
21541	31758	7	applied	\N	\N	\N	\N	164762	164762	332016
21541	31765	8	applied	\N	\N	\N	\N	164763	164763	332017
21541	31766	9	applied	\N	\N	\N	\N	164764	164764	332018
21541	31416	10	applied	\N	\N	\N	\N	164765	164765	332019
21541	31464	11	applied	\N	\N	\N	\N	164766	164766	332020
21541	31266	12	applied	\N	\N	\N	\N	164767	164767	332021
21541	31400	13	applied	\N	\N	\N	\N	164768	164768	332022
21541	31950	14	applied	\N	\N	\N	\N	164769	164769	332023
21541	31422	15	applied	\N	\N	\N	\N	164770	164770	332024
21541	31960	16	applied	\N	\N	\N	\N	164771	164771	332025
21476	31929	9	applied	\N	\N	\N	\N	164304	164304	331558
21479	31930	0	applied	\N	\N	\N	\N	164313	164313	331567
21489	31951	2	applied	\N	\N	\N	\N	164353	164353	331607
21489	31952	3	applied	\N	\N	\N	\N	164354	164354	331608
21492	31955	0	applied	\N	\N	\N	\N	164358	164358	331612
21492	31956	1	applied	\N	\N	\N	\N	164359	164359	331613
21496	31959	0	applied	\N	\N	\N	\N	164366	164366	331620
21496	31961	2	applied	\N	\N	\N	\N	164368	164368	331622
21496	31962	3	applied	\N	\N	\N	\N	164369	164369	331623
21496	31963	4	applied	\N	\N	\N	\N	164370	164370	331624
21509	31986	0	applied	\N	\N	\N	\N	164412	164412	331666
21509	31987	1	applied	\N	\N	\N	\N	164413	164413	331667
21509	31988	2	applied	\N	\N	\N	\N	164414	164414	331668
21512	32002	0	applied	\N	\N	\N	\N	164428	164428	331682
21512	32003	1	applied	\N	\N	\N	\N	164429	164429	331683
21512	32004	2	applied	\N	\N	\N	\N	164430	164430	331684
21512	32005	3	applied	\N	\N	\N	\N	164431	164431	331685
21523	32019	0	applied	\N	\N	\N	\N	164708	164708	331962
21523	32021	1	applied	\N	\N	\N	\N	164709	164709	331963
21529	32031	0	applied	\N	\N	\N	\N	164725	164725	331979
21529	32032	1	applied	\N	\N	\N	\N	164726	164726	331980
21529	32033	2	applied	\N	\N	\N	\N	164727	164727	331981
21533	32034	0	applied	\N	\N	\N	\N	164734	164734	331988
21533	32036	2	applied	\N	\N	\N	\N	164736	164736	331990
21538	31950	0	applied	\N	\N	\N	\N	164749	164749	332003
21541	31417	17	applied	\N	\N	\N	\N	164772	164772	332026
21541	31401	18	applied	\N	\N	\N	\N	164773	164773	332027
21541	31719	19	applied	\N	\N	1000000000	\N	164774	164774	332028
21541	31423	20	applied	\N	\N	\N	\N	164775	164775	332029
21541	31424	21	applied	\N	\N	\N	\N	164776	164776	332030
21541	31425	22	applied	\N	\N	\N	\N	164777	164777	332031
21541	31402	23	applied	\N	\N	\N	\N	164778	164778	332032
21541	31419	24	applied	\N	\N	\N	\N	164779	164779	332033
21541	31420	25	applied	\N	\N	\N	\N	164780	164780	332034
21541	31871	26	applied	\N	\N	\N	\N	164781	164781	332035
21541	31831	27	applied	\N	\N	\N	\N	164782	164782	332036
21541	31832	28	applied	\N	\N	\N	\N	164783	164783	332037
21541	31838	29	applied	\N	\N	\N	\N	164784	164784	332038
21541	31842	30	applied	\N	\N	\N	\N	164785	164785	332039
21541	31851	32	applied	\N	\N	\N	\N	164787	164787	332041
21541	31852	33	applied	\N	\N	\N	\N	164788	164788	332042
21541	31866	34	applied	\N	\N	\N	\N	164789	164789	332043
21541	31403	35	applied	\N	\N	\N	\N	164790	164790	332044
21541	31268	36	applied	\N	\N	\N	\N	164791	164791	332045
21541	31317	37	applied	\N	\N	\N	\N	164792	164792	332046
21541	31269	38	applied	\N	\N	\N	\N	164793	164793	332047
21541	31572	39	applied	\N	\N	\N	\N	164794	164794	332048
21541	31458	40	applied	\N	\N	\N	\N	164795	164795	332049
21541	31342	41	applied	\N	\N	\N	\N	164796	164796	332050
21541	31477	42	applied	\N	\N	\N	\N	164797	164797	332051
21541	31478	43	applied	\N	\N	1000000000	\N	164798	164798	332052
21541	31479	44	applied	\N	\N	1000000000	\N	164799	164799	332053
21541	31480	45	applied	\N	\N	1000000000	\N	164800	164800	332054
21541	31481	46	applied	\N	\N	\N	\N	164801	164801	332055
21541	31623	48	applied	\N	\N	1000000000	\N	164803	164803	332057
21541	31640	49	applied	\N	\N	\N	\N	164804	164804	332058
21541	31784	50	applied	\N	\N	\N	\N	164805	164805	332059
21541	31484	51	applied	\N	\N	\N	\N	164806	164806	332060
21541	31496	52	applied	\N	\N	\N	\N	164807	164807	332061
21541	31507	53	applied	\N	\N	\N	\N	164808	164808	332062
21541	31517	54	applied	\N	\N	\N	\N	164809	164809	332063
21541	31527	55	applied	\N	\N	\N	\N	164810	164810	332064
21541	31540	56	applied	\N	\N	\N	\N	164811	164811	332065
21541	31830	57	applied	\N	\N	\N	\N	164812	164812	332066
21541	31404	58	applied	\N	\N	\N	\N	164813	164813	332067
21542	32040	0	applied	\N	\N	\N	\N	164880	164880	332134
21542	32041	1	applied	\N	\N	\N	\N	164881	164881	332135
21542	32042	2	applied	\N	\N	\N	\N	164882	164882	332136
21542	32038	3	applied	\N	\N	\N	\N	164883	164883	332137
21542	32043	4	applied	\N	\N	\N	\N	164884	164884	332138
21542	32044	5	applied	\N	\N	\N	\N	164885	164885	332139
21542	32045	6	applied	\N	\N	\N	\N	164886	164886	332140
21542	32046	7	applied	\N	\N	\N	\N	164887	164887	332141
21542	32048	9	applied	\N	\N	\N	\N	164889	164889	332143
21544	32040	0	applied	\N	\N	\N	\N	164897	164897	332151
21544	32041	1	applied	\N	\N	\N	\N	164898	164898	332152
21544	32042	2	applied	\N	\N	\N	\N	164899	164899	332153
21544	32043	3	applied	\N	\N	\N	\N	164900	164900	332154
21544	32044	4	applied	\N	\N	\N	\N	164901	164901	332155
21544	32045	5	applied	\N	\N	\N	\N	164902	164902	332156
21544	32046	6	applied	\N	\N	\N	\N	164903	164903	332157
21544	32047	7	applied	\N	\N	\N	\N	164904	164904	332158
21544	32048	8	applied	\N	\N	\N	\N	164905	164905	332159
21550	32054	0	applied	\N	\N	\N	\N	164916	164916	332170
21550	32055	1	applied	\N	\N	\N	\N	164917	164917	332171
21550	32056	2	applied	\N	\N	\N	\N	164918	164918	332172
21556	32062	0	applied	\N	\N	\N	\N	165053	165053	332307
21556	32063	1	applied	\N	\N	\N	\N	165054	165054	332308
21556	32064	2	applied	\N	\N	\N	\N	165055	165055	332309
21558	32066	1	applied	\N	\N	\N	\N	165060	165060	332314
21558	32067	2	applied	\N	\N	\N	\N	165061	165061	332315
21563	32071	0	applied	\N	\N	\N	\N	165074	165074	332328
21563	32072	1	applied	\N	\N	\N	\N	165075	165075	332329
21567	32077	0	applied	\N	\N	\N	\N	165088	165088	332342
21567	32078	1	applied	\N	\N	\N	\N	165089	165089	332343
21569	32077	0	applied	\N	\N	\N	\N	165093	165093	332347
21569	32078	1	applied	\N	\N	\N	\N	165094	165094	332348
21569	32079	2	applied	\N	\N	\N	\N	165095	165095	332349
21571	32078	0	applied	\N	\N	\N	\N	165099	165099	332353
21571	32079	1	applied	\N	\N	\N	\N	165100	165100	332354
21577	32086	0	applied	\N	\N	\N	\N	165120	165120	332374
21577	32087	1	applied	\N	\N	\N	\N	165121	165121	332375
21577	32088	2	applied	\N	\N	\N	\N	165122	165122	332376
21578	32089	0	applied	\N	\N	\N	\N	165123	165123	332377
21580	32083	0	applied	\N	\N	\N	\N	165127	165127	332381
21580	32084	2	applied	\N	\N	\N	\N	165129	165129	332383
21580	32085	3	applied	\N	\N	\N	\N	165130	165130	332384
21580	32087	4	applied	\N	\N	\N	\N	165131	165131	332385
21580	32088	5	applied	\N	\N	\N	\N	165132	165132	332386
21580	32090	6	applied	\N	\N	\N	\N	165133	165133	332387
21580	32091	7	applied	\N	\N	\N	\N	165134	165134	332388
21489	31949	0	applied	\N	\N	\N	\N	164351	164351	331605
21489	31950	1	applied	\N	\N	\N	\N	164352	164352	331606
21515	31425	26	applied	\N	\N	\N	\N	164465	164465	331719
21515	31084	27	applied	\N	\N	\N	\N	164466	164466	331720
21515	31402	29	applied	\N	\N	\N	\N	164468	164468	331722
21515	31142	30	applied	\N	\N	\N	\N	164469	164469	331723
21515	31143	31	applied	\N	\N	\N	\N	164470	164470	331724
21515	31144	32	applied	\N	\N	\N	\N	164471	164471	331725
21515	31145	33	applied	\N	\N	\N	\N	164472	164472	331726
21515	31086	34	applied	\N	\N	\N	\N	164473	164473	331727
21515	31146	35	applied	\N	\N	\N	\N	164474	164474	331728
21515	30946	36	applied	\N	\N	\N	\N	164475	164475	331729
21515	31419	37	applied	\N	\N	\N	\N	164476	164476	331730
21515	31420	38	applied	\N	\N	\N	\N	164477	164477	331731
21515	31052	39	applied	\N	\N	\N	\N	164478	164478	331732
21515	31053	40	applied	\N	\N	\N	\N	164479	164479	331733
21515	31054	41	applied	\N	\N	\N	\N	164480	164480	331734
21515	31055	42	applied	\N	\N	\N	\N	164481	164481	331735
21515	31871	43	applied	\N	\N	\N	\N	164482	164482	331736
21515	31018	44	applied	\N	\N	\N	\N	164483	164483	331737
21515	31020	46	applied	\N	\N	\N	\N	164485	164485	331739
21515	31021	47	applied	\N	\N	\N	\N	164486	164486	331740
21515	31026	48	applied	\N	\N	\N	\N	164487	164487	331741
21515	31831	49	applied	\N	\N	\N	\N	164488	164488	331742
21515	31832	50	applied	\N	\N	\N	\N	164489	164489	331743
21515	31838	51	applied	\N	\N	\N	\N	164490	164490	331744
21515	31842	52	applied	\N	\N	\N	\N	164491	164491	331745
21515	31843	53	applied	\N	\N	\N	\N	164492	164492	331746
21515	31851	54	applied	\N	\N	\N	\N	164493	164493	331747
21515	31852	55	applied	\N	\N	\N	\N	164494	164494	331748
21515	31866	56	applied	\N	\N	\N	\N	164495	164495	331749
21515	31403	57	applied	\N	\N	\N	\N	164496	164496	331750
21515	31268	58	applied	\N	\N	\N	\N	164497	164497	331751
21515	31317	59	applied	\N	\N	\N	\N	164498	164498	331752
21515	31342	60	applied	\N	\N	\N	\N	164499	164499	331753
21515	31477	61	applied	\N	\N	\N	\N	164500	164500	331754
21515	31479	63	applied	\N	\N	1000000000	\N	164502	164502	331756
21515	31480	64	applied	\N	\N	1000000000	\N	164503	164503	331757
21515	31481	65	applied	\N	\N	\N	\N	164504	164504	331758
21515	31482	66	applied	\N	\N	1000000000	\N	164505	164505	331759
21515	31623	67	applied	\N	\N	1000000000	\N	164506	164506	331760
21515	31640	68	applied	\N	\N	\N	\N	164507	164507	331761
21515	31784	69	applied	\N	\N	\N	\N	164508	164508	331762
21515	31830	70	applied	\N	\N	\N	\N	164509	164509	331763
21515	31404	71	applied	\N	\N	\N	\N	164510	164510	331764
21515	31405	72	applied	\N	\N	\N	\N	164511	164511	331765
21515	31406	73	applied	\N	\N	\N	\N	164512	164512	331766
21515	31407	74	applied	\N	\N	\N	\N	164513	164513	331767
21515	31461	75	applied	\N	\N	1000000000	\N	164514	164514	331768
21515	31462	76	applied	\N	\N	1000000000	\N	164515	164515	331769
21515	31463	77	applied	\N	\N	1000000000	\N	164516	164516	331770
21515	31466	78	applied	\N	\N	1000000000	\N	164517	164517	331771
21515	31835	79	applied	\N	\N	\N	\N	164518	164518	331772
21515	31469	81	applied	\N	\N	1000000000	\N	164520	164520	331774
21515	31470	82	applied	\N	\N	\N	\N	164521	164521	331775
21515	31471	83	applied	\N	\N	\N	\N	164522	164522	331776
21515	31472	84	applied	\N	\N	1000000000	\N	164523	164523	331777
21515	31473	85	applied	\N	\N	1000000000	\N	164524	164524	331778
21515	31485	86	applied	\N	\N	1000000000	\N	164525	164525	331779
21515	31486	87	applied	\N	\N	1000000000	\N	164526	164526	331780
21515	31487	88	applied	\N	\N	\N	\N	164527	164527	331781
21515	31488	89	applied	\N	\N	1000000000	\N	164528	164528	331782
21515	31489	90	applied	\N	\N	\N	\N	164529	164529	331783
21515	31490	91	applied	\N	\N	\N	\N	164530	164530	331784
21515	31495	92	applied	\N	\N	\N	\N	164531	164531	331785
21515	31501	93	applied	\N	\N	\N	\N	164532	164532	331786
21515	31502	94	applied	\N	\N	\N	\N	164533	164533	331787
21515	31504	95	applied	\N	\N	\N	\N	164534	164534	331788
21515	31509	96	applied	\N	\N	\N	\N	164535	164535	331789
21515	31511	97	applied	\N	\N	\N	\N	164536	164536	331790
21583	32093	0	applied	\N	\N	\N	\N	165147	165147	332401
21583	32094	1	applied	\N	\N	\N	\N	165148	165148	332402
21583	32095	3	applied	\N	\N	\N	\N	165150	165150	332404
21583	32096	4	applied	\N	\N	\N	\N	165151	165151	332405
21583	32097	5	applied	\N	\N	\N	\N	165152	165152	332406
21583	32098	6	applied	\N	\N	\N	\N	165153	165153	332407
21583	32091	7	applied	\N	\N	\N	\N	165154	165154	332408
21583	32099	8	applied	\N	\N	\N	\N	165155	165155	332409
21583	32100	9	applied	\N	\N	\N	\N	165156	165156	332410
21583	32101	10	applied	\N	\N	\N	\N	165157	165157	332411
21588	32108	0	applied	\N	\N	\N	\N	165170	165170	332424
21588	32109	1	applied	\N	\N	\N	\N	165171	165171	332425
21588	32110	2	applied	\N	\N	\N	\N	165172	165172	332426
21590	32111	0	applied	\N	\N	\N	\N	165176	165176	332430
21590	32112	1	applied	\N	\N	\N	\N	165177	165177	332431
21590	32113	2	applied	\N	\N	\N	\N	165178	165178	332432
21590	32114	3	applied	\N	\N	\N	\N	165179	165179	332433
21590	32115	5	applied	\N	\N	\N	\N	165180	165180	332434
21590	32117	7	applied	\N	\N	\N	\N	165182	165182	332436
21595	32118	0	applied	\N	\N	\N	\N	165323	165323	332577
21595	32119	1	applied	\N	\N	\N	\N	165324	165324	332578
21595	32120	2	applied	\N	\N	\N	\N	165325	165325	332579
21595	32121	3	applied	\N	\N	\N	\N	165326	165326	332580
21595	32122	4	applied	\N	\N	\N	\N	165327	165327	332581
21595	32123	5	applied	\N	\N	\N	\N	165328	165328	332582
21601	32127	0	applied	\N	\N	\N	\N	165347	165347	332601
21601	32128	1	applied	\N	\N	\N	\N	165348	165348	332602
21601	32129	2	applied	\N	\N	\N	\N	165349	165349	332603
21603	32130	0	applied	\N	\N	\N	\N	165353	165353	332607
21603	32131	1	applied	\N	\N	\N	\N	165354	165354	332608
21609	32133	0	applied	\N	\N	\N	\N	165365	165365	332619
21609	32134	1	applied	\N	\N	\N	\N	165366	165366	332620
21609	32135	2	applied	\N	\N	\N	\N	165367	165367	332621
21612	32139	0	applied	\N	\N	\N	\N	165376	165376	332630
21612	32141	2	applied	\N	\N	\N	\N	165378	165378	332632
21618	31735	0	applied	\N	\N	\N	\N	165394	165394	332648
21618	31746	1	applied	\N	\N	\N	\N	165395	165395	332649
21618	31757	2	applied	\N	\N	\N	\N	165396	165396	332650
21618	31758	3	applied	\N	\N	\N	\N	165397	165397	332651
21618	31765	4	applied	\N	\N	\N	\N	165398	165398	332652
21515	31423	24	applied	\N	\N	\N	\N	164463	164463	331717
21515	31424	25	applied	\N	\N	\N	\N	164464	164464	331718
21515	31528	102	applied	\N	\N	\N	\N	164541	164541	331795
21515	31532	103	applied	\N	\N	\N	\N	164542	164542	331796
21515	31533	104	applied	\N	\N	\N	\N	164543	164543	331797
21515	31538	105	applied	\N	\N	\N	\N	164544	164544	331798
21515	31541	106	applied	\N	\N	\N	\N	164545	164545	331799
21515	31545	107	applied	\N	\N	\N	\N	164546	164546	331800
21515	31547	109	applied	\N	\N	\N	\N	164547	164547	331801
21515	31549	110	applied	\N	\N	\N	\N	164548	164548	331802
21515	31554	111	applied	\N	\N	\N	\N	164549	164549	331803
21515	31556	112	applied	\N	\N	\N	\N	164550	164550	331804
21515	31563	113	applied	\N	\N	\N	\N	164551	164551	331805
21515	31566	114	applied	\N	\N	\N	\N	164552	164552	331806
21515	31567	115	applied	\N	\N	\N	\N	164553	164553	331807
21515	31568	116	applied	\N	\N	\N	\N	164554	164554	331808
21515	31571	117	applied	\N	\N	\N	\N	164555	164555	331809
21515	31578	118	applied	\N	\N	\N	\N	164556	164556	331810
21515	31585	120	applied	\N	\N	\N	\N	164558	164558	331812
21515	31588	121	applied	\N	\N	\N	\N	164559	164559	331813
21515	31591	122	applied	\N	\N	\N	\N	164560	164560	331814
21515	31595	123	applied	\N	\N	\N	\N	164561	164561	331815
21515	31597	124	applied	\N	\N	\N	\N	164562	164562	331816
21515	31601	125	applied	\N	\N	\N	\N	164563	164563	331817
21518	31241	77	applied	\N	\N	\N	\N	164646	164646	331900
21518	31243	78	applied	\N	\N	\N	\N	164647	164647	331901
21518	31244	79	applied	\N	\N	\N	\N	164648	164648	331902
21518	31247	80	applied	\N	\N	\N	\N	164649	164649	331903
21518	31251	81	applied	\N	\N	\N	\N	164650	164650	331904
21518	31252	82	applied	\N	\N	\N	\N	164651	164651	331905
21518	31253	83	applied	\N	\N	\N	\N	164652	164652	331906
21518	31254	84	applied	\N	\N	\N	\N	164653	164653	331907
21518	31260	85	applied	\N	\N	\N	\N	164654	164654	331908
21518	31262	86	applied	\N	\N	\N	\N	164655	164655	331909
21518	31266	88	applied	\N	\N	\N	\N	164657	164657	331911
21518	31267	89	applied	\N	\N	\N	\N	164658	164658	331912
21518	31271	90	applied	\N	\N	\N	\N	164659	164659	331913
21518	31273	91	applied	\N	\N	\N	\N	164660	164660	331914
21518	31275	92	applied	\N	\N	\N	\N	164661	164661	331915
21518	31277	93	applied	\N	\N	\N	\N	164662	164662	331916
21518	31279	94	applied	\N	\N	\N	\N	164663	164663	331917
21518	31280	95	applied	\N	\N	\N	\N	164664	164664	331918
21518	31281	96	applied	\N	\N	\N	\N	164665	164665	331919
21518	31285	97	applied	\N	\N	\N	\N	164666	164666	331920
21518	31287	98	applied	\N	\N	\N	\N	164667	164667	331921
21518	31289	99	applied	\N	\N	\N	\N	164668	164668	331922
21518	31291	100	applied	\N	\N	\N	\N	164669	164669	331923
21518	31293	101	applied	\N	\N	\N	\N	164670	164670	331924
21518	31295	102	applied	\N	\N	\N	\N	164671	164671	331925
21518	31297	103	applied	\N	\N	\N	\N	164672	164672	331926
21518	31299	105	applied	\N	\N	\N	\N	164674	164674	331928
21518	31302	106	applied	\N	\N	\N	\N	164675	164675	331929
21518	31304	107	applied	\N	\N	\N	\N	164676	164676	331930
21518	31305	108	applied	\N	\N	\N	\N	164677	164677	331931
21518	31308	109	applied	\N	\N	\N	\N	164678	164678	331932
21518	31310	110	applied	\N	\N	\N	\N	164679	164679	331933
21518	31311	111	applied	\N	\N	\N	\N	164680	164680	331934
21518	31312	112	applied	\N	\N	\N	\N	164681	164681	331935
21518	31316	113	applied	\N	\N	\N	\N	164682	164682	331936
21518	31318	114	applied	\N	\N	\N	\N	164683	164683	331937
21518	31319	115	applied	\N	\N	\N	\N	164684	164684	331938
21518	31320	116	applied	\N	\N	\N	\N	164685	164685	331939
21518	31321	117	applied	\N	\N	\N	\N	164686	164686	331940
21518	31326	118	applied	\N	\N	\N	\N	164687	164687	331941
21518	31329	119	applied	\N	\N	\N	\N	164688	164688	331942
21518	31331	120	applied	\N	\N	\N	\N	164689	164689	331943
21518	31335	122	applied	\N	\N	\N	\N	164691	164691	331945
21518	31336	123	applied	\N	\N	\N	\N	164692	164692	331946
21518	31337	124	applied	\N	\N	\N	\N	164693	164693	331947
21518	31345	125	applied	\N	\N	\N	\N	164694	164694	331948
21519	32012	0	applied	\N	\N	\N	\N	164695	164695	331949
21519	32013	1	applied	\N	\N	\N	\N	164696	164696	331950
21519	32014	2	applied	\N	\N	\N	\N	164697	164697	331951
21520	32015	0	applied	\N	\N	\N	\N	164698	164698	331952
21520	32016	1	applied	\N	\N	\N	\N	164699	164699	331953
21520	32017	2	applied	\N	\N	\N	\N	164700	164700	331954
21520	32018	3	applied	\N	\N	\N	\N	164701	164701	331955
21522	32019	0	applied	\N	\N	\N	\N	164705	164705	331959
21522	32020	1	applied	\N	\N	\N	\N	164706	164706	331960
21522	32021	2	applied	\N	\N	\N	\N	164707	164707	331961
21526	31960	0	applied	\N	\N	\N	\N	164716	164716	331970
21527	32025	0	applied	\N	\N	\N	\N	164717	164717	331971
21527	32027	2	applied	\N	\N	\N	\N	164719	164719	331973
21527	32028	3	applied	\N	\N	\N	\N	164720	164720	331974
21527	32029	4	applied	\N	\N	\N	\N	164721	164721	331975
21527	32030	5	applied	\N	\N	\N	\N	164722	164722	331976
21534	32034	0	applied	\N	\N	\N	\N	164737	164737	331991
21534	32035	1	applied	\N	\N	\N	\N	164738	164738	331992
21534	32036	2	applied	\N	\N	\N	\N	164739	164739	331993
21535	32034	0	applied	\N	\N	\N	\N	164740	164740	331994
21535	32035	1	applied	\N	\N	\N	\N	164741	164741	331995
21535	32036	2	applied	\N	\N	\N	\N	164742	164742	331996
21536	32034	0	applied	\N	\N	\N	\N	164743	164743	331997
21536	32035	1	applied	\N	\N	\N	\N	164744	164744	331998
21536	32036	2	applied	\N	\N	\N	\N	164745	164745	331999
21537	32037	0	applied	\N	\N	\N	\N	164746	164746	332000
21537	32038	1	applied	\N	\N	\N	\N	164747	164747	332001
21537	32039	2	applied	\N	\N	\N	\N	164748	164748	332002
21539	32038	1	applied	\N	\N	\N	\N	164751	164751	332005
21539	32039	2	applied	\N	\N	\N	\N	164752	164752	332006
21540	32037	0	applied	\N	\N	\N	\N	164753	164753	332007
21540	32039	1	applied	\N	\N	\N	\N	164754	164754	332008
21545	32049	0	applied	\N	\N	\N	\N	164906	164906	332160
21545	32050	1	applied	\N	\N	\N	\N	164907	164907	332161
21545	32051	2	applied	\N	\N	\N	\N	164908	164908	332162
21551	32057	0	applied	\N	\N	\N	\N	164919	164919	332173
21551	32058	1	applied	\N	\N	\N	\N	164920	164920	332174
21557	32062	0	applied	\N	\N	\N	\N	165056	165056	332310
21557	32063	1	applied	\N	\N	\N	\N	165057	165057	332311
21557	32064	2	applied	\N	\N	\N	\N	165058	165058	332312
21561	32071	0	applied	\N	\N	\N	\N	165068	165068	332322
21561	32072	1	applied	\N	\N	\N	\N	165069	165069	332323
21515	31519	99	applied	\N	\N	\N	\N	164538	164538	331792
21515	31523	100	applied	\N	\N	\N	\N	164539	164539	331793
21541	31462	63	applied	\N	\N	1000000000	\N	164818	164818	332072
21541	31463	64	applied	\N	\N	1000000000	\N	164819	164819	332073
21541	31466	65	applied	\N	\N	1000000000	\N	164820	164820	332074
21541	31835	66	applied	\N	\N	\N	\N	164821	164821	332075
21541	31270	67	applied	\N	\N	\N	\N	164822	164822	332076
21541	31468	68	applied	\N	\N	1000000000	\N	164823	164823	332077
21541	31469	69	applied	\N	\N	1000000000	\N	164824	164824	332078
21541	31470	70	applied	\N	\N	\N	\N	164825	164825	332079
21541	31471	71	applied	\N	\N	\N	\N	164826	164826	332080
21541	31473	73	applied	\N	\N	1000000000	\N	164828	164828	332082
21541	31485	74	applied	\N	\N	1000000000	\N	164829	164829	332083
21541	31486	75	applied	\N	\N	1000000000	\N	164830	164830	332084
21541	31550	76	applied	\N	\N	\N	\N	164831	164831	332085
21541	31562	77	applied	\N	\N	\N	\N	164832	164832	332086
21541	31574	78	applied	\N	\N	\N	\N	164833	164833	332087
21541	31583	79	applied	\N	\N	\N	\N	164834	164834	332088
21541	31596	80	applied	\N	\N	\N	\N	164835	164835	332089
21541	31608	81	applied	\N	\N	\N	\N	164836	164836	332090
21541	31487	82	applied	\N	\N	\N	\N	164837	164837	332091
21541	31488	83	applied	\N	\N	1000000000	\N	164838	164838	332092
21541	31489	84	applied	\N	\N	\N	\N	164839	164839	332093
21541	31490	85	applied	\N	\N	\N	\N	164840	164840	332094
21541	31495	86	applied	\N	\N	\N	\N	164841	164841	332095
21541	31501	87	applied	\N	\N	\N	\N	164842	164842	332096
21541	31502	88	applied	\N	\N	\N	\N	164843	164843	332097
21541	31504	89	applied	\N	\N	\N	\N	164844	164844	332098
21541	31509	90	applied	\N	\N	\N	\N	164845	164845	332099
21541	31511	91	applied	\N	\N	\N	\N	164846	164846	332100
21541	31514	92	applied	\N	\N	\N	\N	164847	164847	332101
21541	31523	94	applied	\N	\N	\N	\N	164849	164849	332103
21541	31524	95	applied	\N	\N	\N	\N	164850	164850	332104
21541	31528	96	applied	\N	\N	\N	\N	164851	164851	332105
21541	31532	97	applied	\N	\N	\N	\N	164852	164852	332106
21541	31533	98	applied	\N	\N	\N	\N	164853	164853	332107
21541	31538	99	applied	\N	\N	\N	\N	164854	164854	332108
21541	31541	100	applied	\N	\N	\N	\N	164855	164855	332109
21541	31545	101	applied	\N	\N	\N	\N	164856	164856	332110
21541	31547	102	applied	\N	\N	\N	\N	164857	164857	332111
21541	31549	103	applied	\N	\N	\N	\N	164858	164858	332112
21541	31554	104	applied	\N	\N	\N	\N	164859	164859	332113
21541	31556	105	applied	\N	\N	\N	\N	164860	164860	332114
21541	31563	106	applied	\N	\N	\N	\N	164861	164861	332115
21541	31566	107	applied	\N	\N	\N	\N	164862	164862	332116
21541	31567	109	applied	\N	\N	\N	\N	164863	164863	332117
21541	31568	110	applied	\N	\N	\N	\N	164864	164864	332118
21541	31578	112	applied	\N	\N	\N	\N	164866	164866	332120
21541	31580	113	applied	\N	\N	\N	\N	164867	164867	332121
21541	31585	114	applied	\N	\N	\N	\N	164868	164868	332122
21541	31588	115	applied	\N	\N	\N	\N	164869	164869	332123
21541	31591	116	applied	\N	\N	\N	\N	164870	164870	332124
21541	31595	117	applied	\N	\N	\N	\N	164871	164871	332125
21541	31597	118	applied	\N	\N	\N	\N	164872	164872	332126
21541	31601	119	applied	\N	\N	\N	\N	164873	164873	332127
21541	31605	120	applied	\N	\N	\N	\N	164874	164874	332128
21541	31609	121	applied	\N	\N	\N	\N	164875	164875	332129
21541	31612	122	applied	\N	\N	\N	\N	164876	164876	332130
21541	31614	123	applied	\N	\N	\N	\N	164877	164877	332131
21541	31620	124	applied	\N	\N	\N	\N	164878	164878	332132
21541	31621	125	applied	\N	\N	\N	\N	164879	164879	332133
21543	32038	0	applied	\N	\N	\N	\N	164890	164890	332144
21543	32043	1	applied	\N	\N	\N	\N	164891	164891	332145
21543	32045	3	applied	\N	\N	\N	\N	164893	164893	332147
21543	32046	4	applied	\N	\N	\N	\N	164894	164894	332148
21543	32047	5	applied	\N	\N	\N	\N	164895	164895	332149
21543	32048	6	applied	\N	\N	\N	\N	164896	164896	332150
21552	32057	0	applied	\N	\N	\N	\N	164921	164921	332175
21552	32058	1	applied	\N	\N	\N	\N	164922	164922	332176
21561	32073	2	applied	\N	\N	\N	\N	165070	165070	332324
21572	32080	0	applied	\N	\N	\N	\N	165101	165101	332355
21572	32081	1	applied	\N	\N	\N	\N	165102	165102	332356
21572	32079	2	applied	\N	\N	\N	\N	165103	165103	332357
21572	32082	3	applied	\N	\N	\N	\N	165104	165104	332358
21574	32077	0	applied	\N	\N	\N	\N	165108	165108	332362
21574	32080	1	applied	\N	\N	\N	\N	165109	165109	332363
21574	32078	2	applied	\N	\N	\N	\N	165110	165110	332364
21574	32081	3	applied	\N	\N	\N	\N	165111	165111	332365
21574	32079	4	applied	\N	\N	\N	\N	165112	165112	332366
21579	32089	0	applied	\N	\N	\N	\N	165124	165124	332378
21579	32090	1	applied	\N	\N	\N	\N	165125	165125	332379
21579	32091	2	applied	\N	\N	\N	\N	165126	165126	332380
21581	32092	0	applied	\N	\N	\N	\N	165135	165135	332389
21586	32105	0	applied	\N	\N	\N	\N	165164	165164	332418
21586	32106	1	applied	\N	\N	\N	\N	165165	165165	332419
21586	32107	2	applied	\N	\N	\N	\N	165166	165166	332420
21592	32111	0	applied	\N	\N	\N	\N	165308	165308	332562
21592	32112	1	applied	\N	\N	\N	\N	165309	165309	332563
21592	32113	2	applied	\N	\N	\N	\N	165310	165310	332564
21592	32114	3	applied	\N	\N	\N	\N	165311	165311	332565
21592	32115	5	applied	\N	\N	\N	\N	165312	165312	332566
21592	32116	6	applied	\N	\N	\N	\N	165313	165313	332567
21592	32117	7	applied	\N	\N	\N	\N	165314	165314	332568
21597	32124	0	applied	\N	\N	\N	\N	165335	165335	332589
21597	32125	1	applied	\N	\N	\N	\N	165336	165336	332590
21599	32127	0	applied	\N	\N	\N	\N	165341	165341	332595
21599	32128	1	applied	\N	\N	\N	\N	165342	165342	332596
21599	32129	2	applied	\N	\N	\N	\N	165343	165343	332597
21602	32127	0	applied	\N	\N	\N	\N	165350	165350	332604
21602	32128	1	applied	\N	\N	\N	\N	165351	165351	332605
21602	32129	2	applied	\N	\N	\N	\N	165352	165352	332606
21604	32130	0	applied	\N	\N	\N	\N	165355	165355	332609
21604	32132	1	applied	\N	\N	\N	\N	165356	165356	332610
21604	32131	2	applied	\N	\N	\N	\N	165357	165357	332611
21610	32136	0	applied	\N	\N	\N	\N	165368	165368	332622
21610	32134	1	applied	\N	\N	\N	\N	165369	165369	332623
21610	32137	2	applied	\N	\N	\N	\N	165370	165370	332624
21610	32135	3	applied	\N	\N	\N	\N	165371	165371	332625
21610	32138	4	applied	\N	\N	\N	\N	165372	165372	332626
21617	32145	0	applied	\N	\N	\N	\N	165391	165391	332645
21541	31406	60	applied	\N	\N	\N	\N	164815	164815	332069
21541	31461	62	applied	\N	\N	1000000000	\N	164817	164817	332071
21548	32051	1	applied	\N	\N	\N	\N	164913	164913	332167
21549	32052	0	applied	\N	\N	\N	\N	164914	164914	332168
21549	32053	1	applied	\N	\N	\N	\N	164915	164915	332169
21553	32057	0	applied	\N	\N	\N	\N	164923	164923	332177
21553	32058	1	applied	\N	\N	\N	\N	164924	164924	332178
21554	31735	0	applied	\N	\N	\N	\N	164925	164925	332179
21554	31746	1	applied	\N	\N	\N	\N	164926	164926	332180
21554	31757	2	applied	\N	\N	\N	\N	164927	164927	332181
21554	31758	3	applied	\N	\N	\N	\N	164928	164928	332182
21554	31765	4	applied	\N	\N	\N	\N	164929	164929	332183
21554	31766	5	applied	\N	\N	\N	\N	164930	164930	332184
21554	31694	6	applied	\N	\N	\N	\N	164931	164931	332185
21554	31698	7	applied	\N	\N	\N	\N	164932	164932	332186
21554	31950	8	applied	\N	\N	\N	\N	164933	164933	332187
21554	31719	10	applied	\N	\N	1000000000	\N	164935	164935	332189
21554	31702	11	applied	\N	\N	\N	\N	164936	164936	332190
21554	31703	12	applied	\N	\N	\N	\N	164937	164937	332191
21554	31708	13	applied	\N	\N	\N	\N	164938	164938	332192
21554	31709	14	applied	\N	\N	\N	\N	164939	164939	332193
21554	31715	15	applied	\N	\N	\N	\N	164940	164940	332194
21554	31718	16	applied	\N	\N	\N	\N	164941	164941	332195
21554	31722	17	applied	\N	\N	\N	\N	164942	164942	332196
21554	31725	18	applied	\N	\N	\N	\N	164943	164943	332197
21554	31728	19	applied	\N	\N	\N	\N	164944	164944	332198
21554	31732	20	applied	\N	\N	\N	\N	164945	164945	332199
21554	31736	21	applied	\N	\N	\N	\N	164946	164946	332200
21554	31871	22	applied	\N	\N	\N	\N	164947	164947	332201
21554	31737	23	applied	\N	\N	\N	\N	164948	164948	332202
21554	31738	24	applied	\N	\N	\N	\N	164949	164949	332203
21554	31747	25	applied	\N	\N	\N	\N	164950	164950	332204
21554	31753	27	applied	\N	\N	\N	\N	164952	164952	332206
21554	31831	28	applied	\N	\N	\N	\N	164953	164953	332207
21554	31832	29	applied	\N	\N	\N	\N	164954	164954	332208
21554	31838	30	applied	\N	\N	\N	\N	164955	164955	332209
21554	31842	31	applied	\N	\N	\N	\N	164956	164956	332210
21554	31843	32	applied	\N	\N	\N	\N	164957	164957	332211
21554	31851	33	applied	\N	\N	\N	\N	164958	164958	332212
21554	31852	34	applied	\N	\N	\N	\N	164959	164959	332213
21554	31866	35	applied	\N	\N	\N	\N	164960	164960	332214
21554	31759	36	applied	\N	\N	\N	\N	164961	164961	332215
21554	31762	37	applied	\N	\N	\N	\N	164962	164962	332216
21554	31767	38	applied	\N	\N	\N	\N	164963	164963	332217
21554	31768	39	applied	\N	\N	\N	\N	164964	164964	332218
21554	31776	40	applied	\N	\N	\N	\N	164965	164965	332219
21554	31779	41	applied	\N	\N	\N	\N	164966	164966	332220
21554	31782	42	applied	\N	\N	\N	\N	164967	164967	332221
21554	31788	44	applied	\N	\N	\N	\N	164969	164969	332223
21554	31792	45	applied	\N	\N	\N	\N	164970	164970	332224
21554	31793	46	applied	\N	\N	\N	\N	164971	164971	332225
21554	31798	47	applied	\N	\N	\N	\N	164972	164972	332226
21554	31799	48	applied	\N	\N	\N	\N	164973	164973	332227
21554	31800	49	applied	\N	\N	\N	\N	164974	164974	332228
21554	31808	50	applied	\N	\N	\N	\N	164975	164975	332229
21554	31811	51	applied	\N	\N	\N	\N	164976	164976	332230
21554	31814	52	applied	\N	\N	\N	\N	164977	164977	332231
21554	31815	53	applied	\N	\N	\N	\N	164978	164978	332232
21554	31820	54	applied	\N	\N	\N	\N	164979	164979	332233
21554	31821	55	applied	\N	\N	\N	\N	164980	164980	332234
21554	31827	56	applied	\N	\N	\N	\N	164981	164981	332235
21554	31836	57	applied	\N	\N	\N	\N	164982	164982	332236
21554	31837	58	applied	\N	\N	\N	\N	164983	164983	332237
21554	31844	59	applied	\N	\N	\N	\N	164984	164984	332238
21554	31850	61	applied	\N	\N	\N	\N	164986	164986	332240
21554	31856	62	applied	\N	\N	\N	\N	164987	164987	332241
21554	31859	63	applied	\N	\N	\N	\N	164988	164988	332242
21554	31860	64	applied	\N	\N	\N	\N	164989	164989	332243
21554	31867	65	applied	\N	\N	\N	\N	164990	164990	332244
21554	31870	66	applied	\N	\N	\N	\N	164991	164991	332245
21554	31874	67	applied	\N	\N	\N	\N	164992	164992	332246
21559	32065	0	applied	\N	\N	\N	\N	165062	165062	332316
21559	32066	1	applied	\N	\N	\N	\N	165063	165063	332317
21559	32067	2	applied	\N	\N	\N	\N	165064	165064	332318
21564	32074	0	applied	\N	\N	\N	\N	165076	165076	332330
21564	32073	1	applied	\N	\N	\N	\N	165077	165077	332331
21564	32075	2	applied	\N	\N	\N	\N	165078	165078	332332
21564	32076	3	applied	\N	\N	\N	\N	165079	165079	332333
21566	32074	0	applied	\N	\N	\N	\N	165084	165084	332338
21566	32073	1	applied	\N	\N	\N	\N	165085	165085	332339
21566	32076	3	applied	\N	\N	\N	\N	165087	165087	332341
21568	32077	0	applied	\N	\N	\N	\N	165090	165090	332344
21568	32078	1	applied	\N	\N	\N	\N	165091	165091	332345
21568	32079	2	applied	\N	\N	\N	\N	165092	165092	332346
21570	32077	0	applied	\N	\N	\N	\N	165096	165096	332350
21570	32078	1	applied	\N	\N	\N	\N	165097	165097	332351
21570	32079	2	applied	\N	\N	\N	\N	165098	165098	332352
21575	32086	0	applied	\N	\N	\N	\N	165114	165114	332368
21575	32087	1	applied	\N	\N	\N	\N	165115	165115	332369
21575	32088	2	applied	\N	\N	\N	\N	165116	165116	332370
21582	32093	0	applied	\N	\N	\N	\N	165136	165136	332390
21582	32094	1	applied	\N	\N	\N	\N	165137	165137	332391
21582	32090	2	applied	\N	\N	\N	\N	165138	165138	332392
21582	32095	3	applied	\N	\N	\N	\N	165139	165139	332393
21582	32096	4	applied	\N	\N	\N	\N	165140	165140	332394
21582	32097	5	applied	\N	\N	\N	\N	165141	165141	332395
21582	32091	7	applied	\N	\N	\N	\N	165143	165143	332397
21582	32099	8	applied	\N	\N	\N	\N	165144	165144	332398
21582	32100	9	applied	\N	\N	\N	\N	165145	165145	332399
21582	32101	10	applied	\N	\N	\N	\N	165146	165146	332400
21584	32102	0	applied	\N	\N	\N	\N	165158	165158	332412
21584	32103	1	applied	\N	\N	\N	\N	165159	165159	332413
21584	32104	2	applied	\N	\N	\N	\N	165160	165160	332414
21591	31592	0	applied	\N	\N	\N	\N	165183	165183	332437
21591	31602	1	applied	\N	\N	\N	\N	165184	165184	332438
21591	31603	2	applied	\N	\N	\N	\N	165185	165185	332439
21591	31616	3	applied	\N	\N	\N	\N	165186	165186	332440
21591	31735	4	applied	\N	\N	\N	\N	165187	165187	332441
21591	31746	5	applied	\N	\N	\N	\N	165188	165188	332442
21591	31757	6	applied	\N	\N	\N	\N	165189	165189	332443
21591	31758	7	applied	\N	\N	\N	\N	165190	165190	332444
21591	31765	8	applied	\N	\N	\N	\N	165191	165191	332445
21548	32049	0	applied	\N	\N	\N	\N	164912	164912	332166
21554	31888	72	applied	\N	\N	\N	\N	164997	164997	332251
21554	31894	73	applied	\N	\N	\N	\N	164998	164998	332252
21554	31895	74	applied	\N	\N	\N	\N	164999	164999	332253
21554	31901	75	applied	\N	\N	\N	\N	165000	165000	332254
21554	31904	76	applied	\N	\N	\N	\N	165001	165001	332255
21554	31907	77	applied	\N	\N	\N	\N	165002	165002	332256
21554	31908	78	applied	\N	\N	\N	\N	165003	165003	332257
21554	31909	79	applied	\N	\N	\N	\N	165004	165004	332258
21554	31917	80	applied	\N	\N	\N	\N	165005	165005	332259
21554	31920	81	applied	\N	\N	\N	\N	165006	165006	332260
21554	31921	82	applied	\N	\N	\N	\N	165007	165007	332261
21554	31922	83	applied	\N	\N	\N	\N	165008	165008	332262
21554	31930	84	applied	\N	\N	\N	\N	165009	165009	332263
21554	31934	85	applied	\N	\N	\N	\N	165010	165010	332264
21554	31937	87	applied	\N	\N	\N	\N	165012	165012	332266
21554	31943	88	applied	\N	\N	\N	\N	165013	165013	332267
21554	31946	89	applied	\N	\N	\N	\N	165014	165014	332268
21554	31949	90	applied	\N	\N	\N	\N	165015	165015	332269
21554	31953	91	applied	\N	\N	\N	\N	165016	165016	332270
21554	31955	92	applied	\N	\N	\N	\N	165017	165017	332271
21554	31957	93	applied	\N	\N	\N	\N	165018	165018	332272
21554	31959	94	applied	\N	\N	\N	\N	165019	165019	332273
21554	31961	95	applied	\N	\N	\N	\N	165020	165020	332274
21554	31964	96	applied	\N	\N	\N	\N	165021	165021	332275
21554	31966	97	applied	\N	\N	\N	\N	165022	165022	332276
21554	31968	98	applied	\N	\N	\N	\N	165023	165023	332277
21554	31970	99	applied	\N	\N	\N	\N	165024	165024	332278
21554	31971	100	applied	\N	\N	\N	\N	165025	165025	332279
21554	31974	101	applied	\N	\N	\N	\N	165026	165026	332280
21554	31976	102	applied	\N	\N	\N	\N	165027	165027	332281
21554	31978	104	applied	\N	\N	\N	\N	165029	165029	332283
21554	31982	105	applied	\N	\N	\N	\N	165030	165030	332284
21554	31986	106	applied	\N	\N	\N	\N	165031	165031	332285
21554	31989	107	applied	\N	\N	\N	\N	165032	165032	332286
21554	31990	108	applied	\N	\N	\N	\N	165033	165033	332287
21554	31996	110	applied	\N	\N	\N	\N	165034	165034	332288
21554	31997	111	applied	\N	\N	\N	\N	165035	165035	332289
21554	32002	112	applied	\N	\N	\N	\N	165036	165036	332290
21554	32006	113	applied	\N	\N	\N	\N	165037	165037	332291
21554	32009	114	applied	\N	\N	\N	\N	165038	165038	332292
21554	32012	115	applied	\N	\N	\N	\N	165039	165039	332293
21554	32015	116	applied	\N	\N	\N	\N	165040	165040	332294
21554	32019	117	applied	\N	\N	\N	\N	165041	165041	332295
21554	32022	118	applied	\N	\N	\N	\N	165042	165042	332296
21554	32025	119	applied	\N	\N	\N	\N	165043	165043	332297
21554	32026	120	applied	\N	\N	\N	\N	165044	165044	332298
21554	32034	122	applied	\N	\N	\N	\N	165046	165046	332300
21554	32037	123	applied	\N	\N	\N	\N	165047	165047	332301
21554	32040	124	applied	\N	\N	\N	\N	165048	165048	332302
21554	32041	125	applied	\N	\N	\N	\N	165049	165049	332303
21555	32059	0	applied	\N	\N	\N	\N	165050	165050	332304
21555	32060	1	applied	\N	\N	\N	\N	165051	165051	332305
21555	32061	2	applied	\N	\N	\N	\N	165052	165052	332306
21560	32068	0	applied	\N	\N	\N	\N	165065	165065	332319
21560	32069	1	applied	\N	\N	\N	\N	165066	165066	332320
21560	32070	2	applied	\N	\N	\N	\N	165067	165067	332321
21562	32071	0	applied	\N	\N	\N	\N	165071	165071	332325
21562	32072	1	applied	\N	\N	\N	\N	165072	165072	332326
21562	32073	2	applied	\N	\N	\N	\N	165073	165073	332327
21565	32074	0	applied	\N	\N	\N	\N	165080	165080	332334
21565	32073	1	applied	\N	\N	\N	\N	165081	165081	332335
21565	32075	2	applied	\N	\N	\N	\N	165082	165082	332336
21573	32083	0	applied	\N	\N	\N	\N	165105	165105	332359
21573	32084	1	applied	\N	\N	\N	\N	165106	165106	332360
21573	32085	2	applied	\N	\N	\N	\N	165107	165107	332361
21576	32086	0	applied	\N	\N	\N	\N	165117	165117	332371
21576	32087	1	applied	\N	\N	\N	\N	165118	165118	332372
21576	32088	2	applied	\N	\N	\N	\N	165119	165119	332373
21585	32102	0	applied	\N	\N	\N	\N	165161	165161	332415
21585	32103	1	applied	\N	\N	\N	\N	165162	165162	332416
21585	32104	2	applied	\N	\N	\N	\N	165163	165163	332417
21587	32108	0	applied	\N	\N	\N	\N	165167	165167	332421
21587	32109	1	applied	\N	\N	\N	\N	165168	165168	332422
21587	32110	2	applied	\N	\N	\N	\N	165169	165169	332423
21589	32108	0	applied	\N	\N	\N	\N	165173	165173	332427
21589	32109	1	applied	\N	\N	\N	\N	165174	165174	332428
21589	32110	2	applied	\N	\N	\N	\N	165175	165175	332429
21594	32095	0	applied	\N	\N	\N	\N	165321	165321	332575
21596	32118	0	applied	\N	\N	\N	\N	165329	165329	332583
21596	32119	1	applied	\N	\N	\N	\N	165330	165330	332584
21596	32120	2	applied	\N	\N	\N	\N	165331	165331	332585
21596	32121	3	applied	\N	\N	\N	\N	165332	165332	332586
21596	32122	4	applied	\N	\N	\N	\N	165333	165333	332587
21596	32123	5	applied	\N	\N	\N	\N	165334	165334	332588
21598	32124	0	applied	\N	\N	\N	\N	165338	165338	332592
21598	32125	1	applied	\N	\N	\N	\N	165339	165339	332593
21598	32126	2	applied	\N	\N	\N	\N	165340	165340	332594
21600	32127	0	applied	\N	\N	\N	\N	165344	165344	332598
21600	32128	1	applied	\N	\N	\N	\N	165345	165345	332599
21600	32129	2	applied	\N	\N	\N	\N	165346	165346	332600
21607	32130	0	applied	\N	\N	\N	\N	165361	165361	332615
21607	32132	1	applied	\N	\N	\N	\N	165362	165362	332616
21607	32131	2	applied	\N	\N	\N	\N	165363	165363	332617
21611	32139	0	applied	\N	\N	\N	\N	165373	165373	332627
21611	32141	2	applied	\N	\N	\N	\N	165375	165375	332629
21614	32142	0	applied	\N	\N	\N	\N	165382	165382	332636
21614	32143	1	applied	\N	\N	\N	\N	165383	165383	332637
21614	32144	2	applied	\N	\N	\N	\N	165384	165384	332638
21616	32145	0	applied	\N	\N	\N	\N	165388	165388	332642
21616	32146	1	applied	\N	\N	\N	\N	165389	165389	332643
21616	32147	2	applied	\N	\N	\N	\N	165390	165390	332644
21623	32148	0	applied	\N	\N	\N	\N	165529	165529	332783
21623	32149	1	applied	\N	\N	\N	\N	165530	165530	332784
21623	32150	2	applied	\N	\N	\N	\N	165531	165531	332785
21623	32151	3	applied	\N	\N	\N	\N	165532	165532	332786
21629	32157	0	applied	\N	\N	\N	\N	165675	165675	332929
21629	32158	1	applied	\N	\N	\N	\N	165676	165676	332930
21629	32156	2	applied	\N	\N	\N	\N	165677	165677	332931
21629	32159	3	applied	\N	\N	\N	\N	165678	165678	332932
21554	31884	70	applied	\N	\N	\N	\N	164995	164995	332249
21554	31887	71	applied	\N	\N	\N	\N	164996	164996	332250
21591	31719	12	applied	\N	\N	1000000000	\N	165195	165195	332449
21591	31871	13	applied	\N	\N	\N	\N	165196	165196	332450
21591	31831	14	applied	\N	\N	\N	\N	165197	165197	332451
21591	31832	15	applied	\N	\N	\N	\N	165198	165198	332452
21591	31838	16	applied	\N	\N	\N	\N	165199	165199	332453
21591	31842	17	applied	\N	\N	\N	\N	165200	165200	332454
21591	31843	18	applied	\N	\N	\N	\N	165201	165201	332455
21591	31851	19	applied	\N	\N	\N	\N	165202	165202	332456
21591	31852	20	applied	\N	\N	\N	\N	165203	165203	332457
21591	31866	21	applied	\N	\N	\N	\N	165204	165204	332458
21591	31351	22	applied	\N	\N	\N	\N	165205	165205	332459
21591	31353	23	applied	\N	\N	\N	\N	165206	165206	332460
21591	31355	24	applied	\N	\N	\N	\N	165207	165207	332461
21591	31359	26	applied	\N	\N	\N	\N	165209	165209	332463
21591	31361	27	applied	\N	\N	\N	\N	165210	165210	332464
21591	31363	28	applied	\N	\N	\N	\N	165211	165211	332465
21591	31365	29	applied	\N	\N	\N	\N	165212	165212	332466
21591	31366	30	applied	\N	\N	\N	\N	165213	165213	332467
21591	31369	31	applied	\N	\N	\N	\N	165214	165214	332468
21591	31370	32	applied	\N	\N	\N	\N	165215	165215	332469
21591	31371	33	applied	\N	\N	\N	\N	165216	165216	332470
21591	31375	34	applied	\N	\N	\N	\N	165217	165217	332471
21591	31377	35	applied	\N	\N	\N	\N	165218	165218	332472
21591	31379	36	applied	\N	\N	\N	\N	165219	165219	332473
21591	31381	37	applied	\N	\N	\N	\N	165220	165220	332474
21591	31382	38	applied	\N	\N	\N	\N	165221	165221	332475
21591	31385	39	applied	\N	\N	\N	\N	165222	165222	332476
21591	31386	40	applied	\N	\N	\N	\N	165223	165223	332477
21591	31389	41	applied	\N	\N	\N	\N	165224	165224	332478
21591	31391	43	applied	\N	\N	\N	\N	165226	165226	332480
21591	31394	44	applied	\N	\N	\N	\N	165227	165227	332481
21591	31396	45	applied	\N	\N	\N	\N	165228	165228	332482
21591	31398	46	applied	\N	\N	\N	\N	165229	165229	332483
21591	31408	47	applied	\N	\N	\N	\N	165230	165230	332484
21591	31410	48	applied	\N	\N	\N	\N	165231	165231	332485
21591	31412	49	applied	\N	\N	\N	\N	165232	165232	332486
21591	31414	50	applied	\N	\N	\N	\N	165233	165233	332487
21591	31418	51	applied	\N	\N	\N	\N	165234	165234	332488
21591	31426	52	applied	\N	\N	\N	\N	165235	165235	332489
21591	31427	53	applied	\N	\N	\N	\N	165236	165236	332490
21591	31430	54	applied	\N	\N	\N	\N	165237	165237	332491
21591	31431	55	applied	\N	\N	\N	\N	165238	165238	332492
21591	31433	56	applied	\N	\N	\N	\N	165239	165239	332493
21591	31435	57	applied	\N	\N	\N	\N	165240	165240	332494
21591	31437	58	applied	\N	\N	\N	\N	165241	165241	332495
21591	31441	60	applied	\N	\N	\N	\N	165243	165243	332497
21591	31442	61	applied	\N	\N	\N	\N	165244	165244	332498
21591	31443	62	applied	\N	\N	\N	\N	165245	165245	332499
21591	31444	63	applied	\N	\N	\N	\N	165246	165246	332500
21591	31449	64	applied	\N	\N	\N	\N	165247	165247	332501
21591	31450	65	applied	\N	\N	\N	\N	165248	165248	332502
21591	31453	66	applied	\N	\N	\N	\N	165249	165249	332503
21591	31455	67	applied	\N	\N	\N	\N	165250	165250	332504
21591	31456	68	applied	\N	\N	\N	\N	165251	165251	332505
21591	31457	69	applied	\N	\N	\N	\N	165252	165252	332506
21591	31465	70	applied	\N	\N	\N	\N	165253	165253	332507
21591	31474	71	applied	\N	\N	\N	\N	165254	165254	332508
21591	31475	72	applied	\N	\N	\N	\N	165255	165255	332509
21591	31476	73	applied	\N	\N	\N	\N	165256	165256	332510
21591	31493	74	applied	\N	\N	\N	\N	165257	165257	332511
21591	31497	75	applied	\N	\N	\N	\N	165258	165258	332512
21591	31503	77	applied	\N	\N	\N	\N	165260	165260	332514
21591	31506	78	applied	\N	\N	\N	\N	165261	165261	332515
21591	31510	79	applied	\N	\N	\N	\N	165262	165262	332516
21591	31513	80	applied	\N	\N	\N	\N	165263	165263	332517
21591	31516	81	applied	\N	\N	\N	\N	165264	165264	332518
21591	31520	82	applied	\N	\N	\N	\N	165265	165265	332519
21591	31521	83	applied	\N	\N	\N	\N	165266	165266	332520
21591	31526	84	applied	\N	\N	\N	\N	165267	165267	332521
21591	31530	85	applied	\N	\N	\N	\N	165268	165268	332522
21629	32161	5	applied	\N	\N	\N	\N	165680	165680	332934
21629	32162	6	applied	\N	\N	\N	\N	165681	165681	332935
21629	32163	7	applied	\N	\N	\N	\N	165682	165682	332936
21632	32167	0	applied	\N	\N	\N	\N	165689	165689	332943
21632	32168	1	applied	\N	\N	\N	\N	165690	165690	332944
21632	32169	2	applied	\N	\N	\N	\N	165691	165691	332945
21636	32171	0	applied	\N	\N	\N	\N	165705	165705	332959
21636	32173	2	applied	\N	\N	\N	\N	165707	165707	332961
21636	32174	3	applied	\N	\N	\N	\N	165708	165708	332962
21636	32176	4	applied	\N	\N	\N	\N	165709	165709	332963
21636	32175	5	applied	\N	\N	\N	\N	165710	165710	332964
21638	32177	0	applied	\N	\N	\N	\N	165715	165715	332969
21638	32176	1	applied	\N	\N	\N	\N	165716	165716	332970
21638	32178	2	applied	\N	\N	\N	\N	165717	165717	332971
21638	32175	3	applied	\N	\N	\N	\N	165718	165718	332972
21640	32180	0	applied	\N	\N	\N	\N	165724	165724	332978
21640	32179	1	applied	\N	\N	\N	\N	165725	165725	332979
21640	32181	2	applied	\N	\N	\N	\N	165726	165726	332980
21640	32182	3	applied	\N	\N	\N	\N	165727	165727	332981
21642	32183	0	applied	\N	\N	\N	\N	165731	165731	332985
21642	32184	1	applied	\N	\N	\N	\N	165732	165732	332986
21642	32185	2	applied	\N	\N	\N	\N	165733	165733	332987
21653	31592	0	applied	\N	\N	\N	\N	165778	165778	333032
21653	31603	2	applied	\N	\N	\N	\N	165780	165780	333034
21653	31616	3	applied	\N	\N	\N	\N	165781	165781	333035
21653	31735	4	applied	\N	\N	\N	\N	165782	165782	333036
21653	31746	5	applied	\N	\N	\N	\N	165783	165783	333037
21653	31757	6	applied	\N	\N	\N	\N	165784	165784	333038
21653	31758	7	applied	\N	\N	\N	\N	165785	165785	333039
21653	31765	8	applied	\N	\N	\N	\N	165786	165786	333040
21653	31766	9	applied	\N	\N	\N	\N	165787	165787	333041
21653	31464	10	applied	\N	\N	\N	\N	165788	165788	333042
21653	31950	11	applied	\N	\N	\N	\N	165789	165789	333043
21653	31433	12	applied	\N	\N	\N	\N	165790	165790	333044
21653	31960	13	applied	\N	\N	\N	\N	165791	165791	333045
21653	32167	14	applied	\N	\N	\N	\N	165792	165792	333046
21653	31719	15	applied	\N	\N	1000000000	\N	165793	165793	333047
21653	31435	16	applied	\N	\N	\N	\N	165794	165794	333048
21653	32196	17	applied	\N	\N	\N	\N	165795	165795	333049
21591	31950	10	applied	\N	\N	\N	\N	165193	165193	332447
21591	31960	11	applied	\N	\N	\N	\N	165194	165194	332448
21591	31546	90	applied	\N	\N	\N	\N	165273	165273	332527
21591	31551	91	applied	\N	\N	\N	\N	165274	165274	332528
21591	31552	92	applied	\N	\N	\N	\N	165275	165275	332529
21591	31555	93	applied	\N	\N	\N	\N	165276	165276	332530
21591	31558	94	applied	\N	\N	\N	\N	165277	165277	332531
21591	31559	95	applied	\N	\N	\N	\N	165278	165278	332532
21591	31560	96	applied	\N	\N	\N	\N	165279	165279	332533
21591	31561	97	applied	\N	\N	\N	\N	165280	165280	332534
21591	31575	98	applied	\N	\N	\N	\N	165281	165281	332535
21591	31576	99	applied	\N	\N	\N	\N	165282	165282	332536
21591	31579	100	applied	\N	\N	\N	\N	165283	165283	332537
21591	31582	101	applied	\N	\N	\N	\N	165284	165284	332538
21591	31586	102	applied	\N	\N	\N	\N	165285	165285	332539
21591	31589	103	applied	\N	\N	\N	\N	165286	165286	332540
21591	31593	104	applied	\N	\N	\N	\N	165287	165287	332541
21591	31599	105	applied	\N	\N	\N	\N	165288	165288	332542
21591	31607	108	applied	\N	\N	\N	\N	165290	165290	332544
21591	31610	109	applied	\N	\N	\N	\N	165291	165291	332545
21591	31611	110	applied	\N	\N	\N	\N	165292	165292	332546
21591	31617	111	applied	\N	\N	\N	\N	165293	165293	332547
21591	31618	112	applied	\N	\N	\N	\N	165294	165294	332548
21591	31619	113	applied	\N	\N	\N	\N	165295	165295	332549
21591	31628	114	applied	\N	\N	\N	\N	165296	165296	332550
21591	31632	115	applied	\N	\N	\N	\N	165297	165297	332551
21591	31633	116	applied	\N	\N	\N	\N	165298	165298	332552
21591	31638	117	applied	\N	\N	\N	\N	165299	165299	332553
21591	31642	118	applied	\N	\N	\N	\N	165300	165300	332554
21591	31646	119	applied	\N	\N	\N	\N	165301	165301	332555
21591	31649	120	applied	\N	\N	\N	\N	165302	165302	332556
21591	31650	121	applied	\N	\N	\N	\N	165303	165303	332557
21591	31651	122	applied	\N	\N	\N	\N	165304	165304	332558
21591	31659	123	applied	\N	\N	\N	\N	165305	165305	332559
21591	31661	125	applied	\N	\N	\N	\N	165307	165307	332561
21593	32118	0	applied	\N	\N	\N	\N	165315	165315	332569
21593	32119	1	applied	\N	\N	\N	\N	165316	165316	332570
21593	32120	2	applied	\N	\N	\N	\N	165317	165317	332571
21593	32121	3	applied	\N	\N	\N	\N	165318	165318	332572
21593	32122	4	applied	\N	\N	\N	\N	165319	165319	332573
21593	32123	5	applied	\N	\N	\N	\N	165320	165320	332574
21605	32130	0	applied	\N	\N	\N	\N	165358	165358	332612
21605	32132	1	applied	\N	\N	\N	\N	165359	165359	332613
21605	32131	2	applied	\N	\N	\N	\N	165360	165360	332614
21608	32133	0	applied	\N	\N	\N	\N	165364	165364	332618
21613	32142	0	applied	\N	\N	\N	\N	165379	165379	332633
21613	32143	1	applied	\N	\N	\N	\N	165380	165380	332634
21613	32144	2	applied	\N	\N	\N	\N	165381	165381	332635
21615	32145	0	applied	\N	\N	\N	\N	165385	165385	332639
21615	32146	1	applied	\N	\N	\N	\N	165386	165386	332640
21622	32148	0	applied	\N	\N	\N	\N	165523	165523	332777
21622	32149	1	applied	\N	\N	\N	\N	165524	165524	332778
21622	32150	2	applied	\N	\N	\N	\N	165525	165525	332779
21622	32151	3	applied	\N	\N	\N	\N	165526	165526	332780
21622	32152	4	applied	\N	\N	\N	\N	165527	165527	332781
21622	32153	5	applied	\N	\N	\N	\N	165528	165528	332782
21625	32148	0	applied	\N	\N	\N	\N	165539	165539	332793
21625	32149	1	applied	\N	\N	\N	\N	165540	165540	332794
21625	32150	2	applied	\N	\N	\N	\N	165541	165541	332795
21625	32151	3	applied	\N	\N	\N	\N	165542	165542	332796
21625	32152	4	applied	\N	\N	\N	\N	165543	165543	332797
21625	32153	5	applied	\N	\N	\N	\N	165544	165544	332798
21628	32154	0	applied	\N	\N	\N	\N	165672	165672	332926
21628	32156	1	applied	\N	\N	\N	\N	165673	165673	332927
21628	32155	2	applied	\N	\N	\N	\N	165674	165674	332928
21631	32167	0	applied	\N	\N	\N	\N	165686	165686	332940
21631	32169	2	applied	\N	\N	\N	\N	165688	165688	332942
21635	32171	0	applied	\N	\N	\N	\N	165700	165700	332954
21635	32172	1	applied	\N	\N	\N	\N	165701	165701	332955
21635	32173	2	applied	\N	\N	\N	\N	165702	165702	332956
21635	32174	3	applied	\N	\N	\N	\N	165703	165703	332957
21635	32175	4	applied	\N	\N	\N	\N	165704	165704	332958
21637	32171	0	applied	\N	\N	\N	\N	165711	165711	332965
21637	32172	1	applied	\N	\N	\N	\N	165712	165712	332966
21637	32173	2	applied	\N	\N	\N	\N	165713	165713	332967
21637	32174	3	applied	\N	\N	\N	\N	165714	165714	332968
21643	32186	0	applied	\N	\N	\N	\N	165734	165734	332988
21643	32187	1	applied	\N	\N	\N	\N	165735	165735	332989
21643	32188	2	applied	\N	\N	\N	\N	165736	165736	332990
21645	32191	0	applied	\N	\N	\N	\N	165742	165742	332996
21645	32189	1	applied	\N	\N	\N	\N	165743	165743	332997
21645	32192	2	applied	\N	\N	\N	\N	165744	165744	332998
21645	32193	4	applied	\N	\N	\N	\N	165746	165746	333000
21648	32202	0	applied	\N	\N	\N	\N	165763	165763	333017
21648	32203	1	applied	\N	\N	\N	\N	165764	165764	333018
21648	32204	2	applied	\N	\N	\N	\N	165765	165765	333019
21657	32217	0	applied	\N	\N	\N	\N	165924	165924	333178
21657	32218	1	applied	\N	\N	\N	\N	165925	165925	333179
21657	32219	2	applied	\N	\N	\N	\N	165926	165926	333180
21657	32220	3	applied	\N	\N	\N	\N	165927	165927	333181
21660	32228	0	applied	\N	\N	\N	\N	165935	165935	333189
21660	32229	1	applied	\N	\N	\N	\N	165936	165936	333190
21662	32228	0	applied	\N	\N	\N	\N	165940	165940	333194
21662	32230	1	applied	\N	\N	\N	\N	165941	165941	333195
21662	32229	2	applied	\N	\N	\N	\N	165942	165942	333196
21665	32235	0	applied	\N	\N	\N	\N	165948	165948	333202
21665	32236	1	applied	\N	\N	\N	\N	165949	165949	333203
21665	32237	2	applied	\N	\N	\N	\N	165950	165950	333204
21669	32239	1	applied	\N	\N	\N	\N	166087	166087	333341
21669	32236	2	applied	\N	\N	\N	\N	166088	166088	333342
21669	32241	3	applied	\N	\N	\N	\N	166089	166089	333343
21669	32237	4	applied	\N	\N	\N	\N	166090	166090	333344
21669	32240	5	applied	\N	\N	\N	\N	166091	166091	333345
21671	32242	0	applied	\N	\N	\N	\N	166098	166098	333352
21671	32243	1	applied	\N	\N	\N	\N	166099	166099	333353
21671	32244	2	applied	\N	\N	\N	\N	166100	166100	333354
21671	32245	3	applied	\N	\N	\N	\N	166101	166101	333355
21671	32246	4	applied	\N	\N	\N	\N	166102	166102	333356
21671	32247	5	applied	\N	\N	\N	\N	166103	166103	333357
21678	32258	0	applied	\N	\N	\N	\N	166117	166117	333371
21678	32259	1	applied	\N	\N	\N	\N	166118	166118	333372
21678	32260	2	applied	\N	\N	\N	\N	166119	166119	333373
21591	31536	87	applied	\N	\N	\N	\N	165270	165270	332524
21591	31539	88	applied	\N	\N	\N	\N	165271	165271	332525
21621	32149	1	applied	\N	\N	\N	\N	165520	165520	332774
21621	32150	2	applied	\N	\N	\N	\N	165521	165521	332775
21621	32151	3	applied	\N	\N	\N	\N	165522	165522	332776
21630	32164	0	applied	\N	\N	\N	\N	165683	165683	332937
21630	32165	1	applied	\N	\N	\N	\N	165684	165684	332938
21630	32166	2	applied	\N	\N	\N	\N	165685	165685	332939
21633	32167	0	applied	\N	\N	\N	\N	165692	165692	332946
21633	32168	1	applied	\N	\N	\N	\N	165693	165693	332947
21633	32170	2	applied	\N	\N	\N	\N	165694	165694	332948
21633	32169	3	applied	\N	\N	\N	\N	165695	165695	332949
21647	32194	0	applied	\N	\N	\N	\N	165755	165755	333009
21647	32196	2	applied	\N	\N	\N	\N	165757	165757	333011
21647	32197	3	applied	\N	\N	\N	\N	165758	165758	333012
21647	32198	5	applied	\N	\N	\N	\N	165759	165759	333013
21647	32199	6	applied	\N	\N	\N	\N	165760	165760	333014
21647	32200	7	applied	\N	\N	\N	\N	165761	165761	333015
21647	32201	8	applied	\N	\N	\N	\N	165762	165762	333016
21650	32202	0	applied	\N	\N	\N	\N	165769	165769	333023
21650	32203	1	applied	\N	\N	\N	\N	165770	165770	333024
21650	32204	2	applied	\N	\N	\N	\N	165771	165771	333025
21652	32202	0	applied	\N	\N	\N	\N	165775	165775	333029
21652	32203	1	applied	\N	\N	\N	\N	165776	165776	333030
21652	32204	2	applied	\N	\N	\N	\N	165777	165777	333031
21654	32205	0	applied	\N	\N	\N	\N	165903	165903	333157
21654	32206	1	applied	\N	\N	\N	\N	165904	165904	333158
21654	32207	2	applied	\N	\N	\N	\N	165905	165905	333159
21654	32208	3	applied	\N	\N	\N	\N	165906	165906	333160
21654	32210	5	applied	\N	\N	\N	\N	165908	165908	333162
21654	32211	6	applied	\N	\N	\N	\N	165909	165909	333163
21654	32212	7	applied	\N	\N	\N	\N	165910	165910	333164
21654	32213	8	applied	\N	\N	\N	\N	165911	165911	333165
21659	32225	0	applied	\N	\N	\N	\N	165932	165932	333186
21659	32226	1	applied	\N	\N	\N	\N	165933	165933	333187
21659	32227	2	applied	\N	\N	\N	\N	165934	165934	333188
21664	32235	0	applied	\N	\N	\N	\N	165947	165947	333201
21666	31592	0	applied	\N	\N	\N	\N	165951	165951	333205
21666	31602	1	applied	\N	\N	\N	\N	165952	165952	333206
21666	31603	2	applied	\N	\N	\N	\N	165953	165953	333207
21666	31616	3	applied	\N	\N	\N	\N	165954	165954	333208
21666	31735	4	applied	\N	\N	\N	\N	165955	165955	333209
21666	31746	5	applied	\N	\N	\N	\N	165956	165956	333210
21666	31757	6	applied	\N	\N	\N	\N	165957	165957	333211
21666	31758	7	applied	\N	\N	\N	\N	165958	165958	333212
21666	31766	9	applied	\N	\N	\N	\N	165960	165960	333214
21666	31416	10	applied	\N	\N	\N	\N	165961	165961	333215
21666	31464	11	applied	\N	\N	\N	\N	165962	165962	333216
21666	31277	12	applied	\N	\N	\N	\N	165963	165963	333217
21666	31400	13	applied	\N	\N	\N	\N	165964	165964	333218
21666	31950	14	applied	\N	\N	\N	\N	165965	165965	333219
21666	31422	15	applied	\N	\N	\N	\N	165966	165966	333220
21666	31960	16	applied	\N	\N	\N	\N	165967	165967	333221
21666	31417	17	applied	\N	\N	\N	\N	165968	165968	333222
21666	31401	18	applied	\N	\N	\N	\N	165969	165969	333223
21666	32167	19	applied	\N	\N	\N	\N	165970	165970	333224
21666	31719	20	applied	\N	\N	1000000000	\N	165971	165971	333225
21666	31279	21	applied	\N	\N	\N	\N	165972	165972	333226
21666	32221	22	applied	\N	\N	\N	\N	165973	165973	333227
21666	31423	23	applied	\N	\N	\N	\N	165974	165974	333228
21666	31424	24	applied	\N	\N	\N	\N	165975	165975	333229
21666	31402	26	applied	\N	\N	\N	\N	165977	165977	333231
21666	32218	27	applied	\N	\N	\N	\N	165978	165978	333232
21666	32196	28	applied	\N	\N	\N	\N	165979	165979	333233
21666	32232	29	applied	\N	\N	1000000000	\N	165980	165980	333234
21666	32197	30	applied	\N	\N	\N	\N	165981	165981	333235
21666	31419	31	applied	\N	\N	\N	\N	165982	165982	333236
21666	31420	32	applied	\N	\N	\N	\N	165983	165983	333237
21666	31280	33	applied	\N	\N	\N	\N	165984	165984	333238
21666	31281	34	applied	\N	\N	\N	\N	165985	165985	333239
21666	31285	35	applied	\N	\N	\N	\N	165986	165986	333240
21682	32264	0	applied	\N	\N	\N	\N	166262	166262	333516
21682	32265	1	applied	\N	\N	\N	\N	166263	166263	333517
21682	32266	2	applied	\N	\N	\N	\N	166264	166264	333518
21683	32267	0	applied	\N	\N	\N	\N	166265	166265	333519
21683	32268	1	applied	\N	\N	\N	\N	166266	166266	333520
21683	32269	2	applied	\N	\N	\N	\N	166267	166267	333521
21686	32267	0	applied	\N	\N	\N	\N	166277	166277	333531
21694	32290	0	applied	\N	\N	\N	\N	166327	166327	333581
21694	32291	1	applied	\N	\N	\N	\N	166328	166328	333582
21694	32292	2	applied	\N	\N	\N	\N	166329	166329	333583
21694	32293	3	applied	\N	\N	\N	\N	166330	166330	333584
21694	32294	4	applied	\N	\N	\N	\N	166331	166331	333585
21694	32295	5	applied	\N	\N	\N	\N	166332	166332	333586
21704	32317	0	applied	\N	\N	\N	\N	166374	166374	333628
21704	32318	1	applied	\N	\N	\N	\N	166375	166375	333629
21707	32320	0	applied	\N	\N	1000000000	\N	166384	166384	333638
21707	32321	1	applied	\N	\N	\N	\N	166385	166385	333639
21707	32322	2	applied	\N	\N	\N	\N	166386	166386	333640
21707	32323	3	applied	\N	\N	\N	\N	166387	166387	333641
21707	32319	4	applied	\N	\N	\N	\N	166388	166388	333642
21707	32325	5	applied	\N	\N	\N	\N	166389	166389	333643
21707	32326	6	applied	\N	\N	\N	\N	166390	166390	333644
21710	32330	0	applied	\N	\N	\N	\N	166400	166400	333654
21710	32331	1	applied	\N	\N	\N	\N	166401	166401	333655
21710	32332	2	applied	\N	\N	\N	\N	166402	166402	333656
21710	32333	3	applied	\N	\N	\N	\N	166403	166403	333657
21710	32334	4	applied	\N	\N	\N	\N	166404	166404	333658
21714	32338	0	applied	\N	\N	\N	\N	166413	166413	333667
21714	32339	1	applied	\N	\N	\N	\N	166414	166414	333668
21714	32340	2	applied	\N	\N	\N	\N	166415	166415	333669
21714	32341	3	applied	\N	\N	\N	\N	166416	166416	333670
21714	32342	4	applied	\N	\N	\N	\N	166417	166417	333671
21714	32343	5	applied	\N	\N	\N	\N	166418	166418	333672
21717	32344	0	applied	\N	\N	\N	\N	166431	166431	333685
21717	32345	1	applied	\N	\N	\N	\N	166432	166432	333686
21717	32346	2	applied	\N	\N	\N	\N	166433	166433	333687
21717	32347	3	applied	\N	\N	\N	\N	166434	166434	333688
21717	32348	4	applied	\N	\N	\N	\N	166435	166435	333689
21717	32350	6	applied	\N	\N	\N	\N	166437	166437	333691
21717	32351	7	applied	\N	\N	\N	\N	166438	166438	333692
21617	32147	2	applied	\N	\N	\N	\N	165393	165393	332647
21621	32148	0	applied	\N	\N	\N	\N	165519	165519	332773
21618	31632	9	applied	\N	\N	\N	\N	165403	165403	332657
21618	31871	10	applied	\N	\N	\N	\N	165404	165404	332658
21618	31633	11	applied	\N	\N	\N	\N	165405	165405	332659
21618	31638	12	applied	\N	\N	\N	\N	165406	165406	332660
21618	31642	13	applied	\N	\N	\N	\N	165407	165407	332661
21618	31646	14	applied	\N	\N	\N	\N	165408	165408	332662
21618	31649	15	applied	\N	\N	\N	\N	165409	165409	332663
21618	31650	16	applied	\N	\N	\N	\N	165410	165410	332664
21618	31651	17	applied	\N	\N	\N	\N	165411	165411	332665
21618	31659	18	applied	\N	\N	\N	\N	165412	165412	332666
21618	31660	19	applied	\N	\N	\N	\N	165413	165413	332667
21618	31661	20	applied	\N	\N	\N	\N	165414	165414	332668
21618	31662	21	applied	\N	\N	\N	\N	165415	165415	332669
21618	31663	22	applied	\N	\N	\N	\N	165416	165416	332670
21618	31678	24	applied	\N	\N	\N	\N	165418	165418	332672
21618	31679	25	applied	\N	\N	\N	\N	165419	165419	332673
21618	31684	26	applied	\N	\N	\N	\N	165420	165420	332674
21618	31688	27	applied	\N	\N	\N	\N	165421	165421	332675
21618	31689	28	applied	\N	\N	\N	\N	165422	165422	332676
21618	31694	29	applied	\N	\N	\N	\N	165423	165423	332677
21618	31698	30	applied	\N	\N	\N	\N	165424	165424	332678
21618	31702	31	applied	\N	\N	\N	\N	165425	165425	332679
21618	31703	32	applied	\N	\N	\N	\N	165426	165426	332680
21618	31708	33	applied	\N	\N	\N	\N	165427	165427	332681
21618	31709	34	applied	\N	\N	\N	\N	165428	165428	332682
21618	31715	35	applied	\N	\N	\N	\N	165429	165429	332683
21618	31718	36	applied	\N	\N	\N	\N	165430	165430	332684
21618	31722	37	applied	\N	\N	\N	\N	165431	165431	332685
21618	31725	38	applied	\N	\N	\N	\N	165432	165432	332686
21618	31728	39	applied	\N	\N	\N	\N	165433	165433	332687
21618	31736	41	applied	\N	\N	\N	\N	165435	165435	332689
21618	31737	42	applied	\N	\N	\N	\N	165436	165436	332690
21618	31738	43	applied	\N	\N	\N	\N	165437	165437	332691
21618	31747	44	applied	\N	\N	\N	\N	165438	165438	332692
21618	31748	45	applied	\N	\N	\N	\N	165439	165439	332693
21618	31753	46	applied	\N	\N	\N	\N	165440	165440	332694
21618	31831	47	applied	\N	\N	\N	\N	165441	165441	332695
21618	31832	48	applied	\N	\N	\N	\N	165442	165442	332696
21618	31838	49	applied	\N	\N	\N	\N	165443	165443	332697
21618	31842	50	applied	\N	\N	\N	\N	165444	165444	332698
21618	31843	51	applied	\N	\N	\N	\N	165445	165445	332699
21618	31851	52	applied	\N	\N	\N	\N	165446	165446	332700
21618	31852	53	applied	\N	\N	\N	\N	165447	165447	332701
21618	31866	54	applied	\N	\N	\N	\N	165448	165448	332702
21618	31759	55	applied	\N	\N	\N	\N	165449	165449	332703
21618	31762	56	applied	\N	\N	\N	\N	165450	165450	332704
21618	31768	58	applied	\N	\N	\N	\N	165452	165452	332706
21618	31776	59	applied	\N	\N	\N	\N	165453	165453	332707
21618	31779	60	applied	\N	\N	\N	\N	165454	165454	332708
21618	31782	61	applied	\N	\N	\N	\N	165455	165455	332709
21618	31785	63	applied	\N	\N	\N	\N	165456	165456	332710
21618	31788	64	applied	\N	\N	\N	\N	165457	165457	332711
21618	31792	65	applied	\N	\N	\N	\N	165458	165458	332712
21618	31793	66	applied	\N	\N	\N	\N	165459	165459	332713
21618	31798	67	applied	\N	\N	\N	\N	165460	165460	332714
21618	31799	68	applied	\N	\N	\N	\N	165461	165461	332715
21618	31800	69	applied	\N	\N	\N	\N	165462	165462	332716
21618	31808	70	applied	\N	\N	\N	\N	165463	165463	332717
21618	31811	71	applied	\N	\N	\N	\N	165464	165464	332718
21618	31814	72	applied	\N	\N	\N	\N	165465	165465	332719
21618	31815	73	applied	\N	\N	\N	\N	165466	165466	332720
21618	31820	74	applied	\N	\N	\N	\N	165467	165467	332721
21618	31827	76	applied	\N	\N	\N	\N	165469	165469	332723
21618	31836	77	applied	\N	\N	\N	\N	165470	165470	332724
21618	31837	78	applied	\N	\N	\N	\N	165471	165471	332725
21618	31844	79	applied	\N	\N	\N	\N	165472	165472	332726
21618	31845	80	applied	\N	\N	\N	\N	165473	165473	332727
21618	31850	81	applied	\N	\N	\N	\N	165474	165474	332728
21618	31856	82	applied	\N	\N	\N	\N	165475	165475	332729
21666	31287	36	applied	\N	\N	\N	\N	165987	165987	333241
21666	31871	37	applied	\N	\N	\N	\N	165988	165988	333242
21666	31289	38	applied	\N	\N	\N	\N	165989	165989	333243
21666	31291	39	applied	\N	\N	\N	\N	165990	165990	333244
21666	32172	40	applied	\N	\N	\N	\N	165991	165991	333245
21666	32173	41	applied	\N	\N	\N	\N	165992	165992	333246
21666	32174	42	applied	\N	\N	\N	\N	165993	165993	333247
21666	31293	43	applied	\N	\N	\N	\N	165994	165994	333248
21666	31295	44	applied	\N	\N	\N	\N	165995	165995	333249
21666	31298	46	applied	\N	\N	\N	\N	165997	165997	333251
21666	31299	47	applied	\N	\N	\N	\N	165998	165998	333252
21666	31302	48	applied	\N	\N	\N	\N	165999	165999	333253
21666	31304	49	applied	\N	\N	\N	\N	166000	166000	333254
21666	31305	50	applied	\N	\N	\N	\N	166001	166001	333255
21666	31308	51	applied	\N	\N	\N	\N	166002	166002	333256
21666	31310	52	applied	\N	\N	\N	\N	166003	166003	333257
21666	31311	53	applied	\N	\N	\N	\N	166004	166004	333258
21666	31312	54	applied	\N	\N	\N	\N	166005	166005	333259
21666	31316	55	applied	\N	\N	\N	\N	166006	166006	333260
21666	31318	56	applied	\N	\N	\N	\N	166007	166007	333261
21666	31319	57	applied	\N	\N	\N	\N	166008	166008	333262
21666	31320	58	applied	\N	\N	\N	\N	166009	166009	333263
21666	31321	59	applied	\N	\N	\N	\N	166010	166010	333264
21666	31326	60	applied	\N	\N	\N	\N	166011	166011	333265
21666	31329	61	applied	\N	\N	\N	\N	166012	166012	333266
21666	31831	63	applied	\N	\N	\N	\N	166014	166014	333268
21666	31832	64	applied	\N	\N	\N	\N	166015	166015	333269
21666	31838	65	applied	\N	\N	\N	\N	166016	166016	333270
21666	31842	66	applied	\N	\N	\N	\N	166017	166017	333271
21666	31843	67	applied	\N	\N	\N	\N	166018	166018	333272
21666	31851	68	applied	\N	\N	\N	\N	166019	166019	333273
21666	31852	69	applied	\N	\N	\N	\N	166020	166020	333274
21666	31866	70	applied	\N	\N	\N	\N	166021	166021	333275
21666	31333	71	applied	\N	\N	\N	\N	166022	166022	333276
21666	31335	72	applied	\N	\N	\N	\N	166023	166023	333277
21666	31336	73	applied	\N	\N	\N	\N	166024	166024	333278
21666	31337	74	applied	\N	\N	\N	\N	166025	166025	333279
21666	31345	75	applied	\N	\N	\N	\N	166026	166026	333280
21666	31346	76	applied	\N	\N	\N	\N	166027	166027	333281
21666	31347	77	applied	\N	\N	\N	\N	166028	166028	333282
21666	31403	78	applied	\N	\N	\N	\N	166029	166029	333283
21618	31719	8	applied	\N	\N	1000000000	\N	165402	165402	332656
21618	31874	87	applied	\N	\N	\N	\N	165480	165480	332734
21618	31878	88	applied	\N	\N	\N	\N	165481	165481	332735
21618	31881	89	applied	\N	\N	\N	\N	165482	165482	332736
21618	31884	90	applied	\N	\N	\N	\N	165483	165483	332737
21618	31887	91	applied	\N	\N	\N	\N	165484	165484	332738
21618	31888	92	applied	\N	\N	\N	\N	165485	165485	332739
21618	31894	93	applied	\N	\N	\N	\N	165486	165486	332740
21618	31895	94	applied	\N	\N	\N	\N	165487	165487	332741
21618	31901	95	applied	\N	\N	\N	\N	165488	165488	332742
21618	31904	96	applied	\N	\N	\N	\N	165489	165489	332743
21618	31907	97	applied	\N	\N	\N	\N	165490	165490	332744
21618	31908	98	applied	\N	\N	\N	\N	165491	165491	332745
21618	31909	99	applied	\N	\N	\N	\N	165492	165492	332746
21618	31917	100	applied	\N	\N	\N	\N	165493	165493	332747
21618	31920	101	applied	\N	\N	\N	\N	165494	165494	332748
21618	31921	102	applied	\N	\N	\N	\N	165495	165495	332749
21618	31930	104	applied	\N	\N	\N	\N	165497	165497	332751
21618	31934	105	applied	\N	\N	\N	\N	165498	165498	332752
21618	31936	106	applied	\N	\N	\N	\N	165499	165499	332753
21618	31937	107	applied	\N	\N	\N	\N	165500	165500	332754
21618	31943	108	applied	\N	\N	\N	\N	165501	165501	332755
21618	31946	109	applied	\N	\N	\N	\N	165502	165502	332756
21618	31949	110	applied	\N	\N	\N	\N	165503	165503	332757
21618	31953	111	applied	\N	\N	\N	\N	165504	165504	332758
21618	31955	112	applied	\N	\N	\N	\N	165505	165505	332759
21618	31957	113	applied	\N	\N	\N	\N	165506	165506	332760
21618	31959	114	applied	\N	\N	\N	\N	165507	165507	332761
21618	31961	115	applied	\N	\N	\N	\N	165508	165508	332762
21618	31964	116	applied	\N	\N	\N	\N	165509	165509	332763
21618	31966	117	applied	\N	\N	\N	\N	165510	165510	332764
21618	31968	118	applied	\N	\N	\N	\N	165511	165511	332765
21618	31970	119	applied	\N	\N	\N	\N	165512	165512	332766
21618	31974	121	applied	\N	\N	\N	\N	165514	165514	332768
21618	31976	122	applied	\N	\N	\N	\N	165515	165515	332769
21618	31977	123	applied	\N	\N	\N	\N	165516	165516	332770
21618	31978	124	applied	\N	\N	\N	\N	165517	165517	332771
21618	31982	125	applied	\N	\N	\N	\N	165518	165518	332772
21624	32148	0	applied	\N	\N	\N	\N	165533	165533	332787
21624	32149	1	applied	\N	\N	\N	\N	165534	165534	332788
21624	32150	2	applied	\N	\N	\N	\N	165535	165535	332789
21624	32151	3	applied	\N	\N	\N	\N	165536	165536	332790
21624	32152	4	applied	\N	\N	\N	\N	165537	165537	332791
21624	32153	5	applied	\N	\N	\N	\N	165538	165538	332792
21626	31964	0	applied	\N	\N	\N	\N	165545	165545	332799
21626	31966	1	applied	\N	\N	\N	\N	165546	165546	332800
21626	31968	2	applied	\N	\N	\N	\N	165547	165547	332801
21626	31970	3	applied	\N	\N	\N	\N	165548	165548	332802
21626	31971	4	applied	\N	\N	\N	\N	165549	165549	332803
21626	31976	6	applied	\N	\N	\N	\N	165551	165551	332805
21626	31977	7	applied	\N	\N	\N	\N	165552	165552	332806
21626	31978	8	applied	\N	\N	\N	\N	165553	165553	332807
21626	31982	9	applied	\N	\N	\N	\N	165554	165554	332808
21626	31986	10	applied	\N	\N	\N	\N	165555	165555	332809
21626	31989	11	applied	\N	\N	\N	\N	165556	165556	332810
21626	31990	12	applied	\N	\N	\N	\N	165557	165557	332811
21626	31996	13	applied	\N	\N	\N	\N	165558	165558	332812
21626	31997	14	applied	\N	\N	\N	\N	165559	165559	332813
21626	32002	15	applied	\N	\N	\N	\N	165560	165560	332814
21626	32006	16	applied	\N	\N	\N	\N	165561	165561	332815
21626	32009	17	applied	\N	\N	\N	\N	165562	165562	332816
21626	32012	18	applied	\N	\N	\N	\N	165563	165563	332817
21626	32015	19	applied	\N	\N	\N	\N	165564	165564	332818
21626	32019	20	applied	\N	\N	\N	\N	165565	165565	332819
21626	32022	21	applied	\N	\N	\N	\N	165566	165566	332820
21626	32026	23	applied	\N	\N	\N	\N	165568	165568	332822
21626	32031	24	applied	\N	\N	\N	\N	165569	165569	332823
21626	32034	25	applied	\N	\N	\N	\N	165570	165570	332824
21626	32037	26	applied	\N	\N	\N	\N	165571	165571	332825
21626	32040	27	applied	\N	\N	\N	\N	165572	165572	332826
21626	32041	28	applied	\N	\N	\N	\N	165573	165573	332827
21626	32042	29	applied	\N	\N	\N	\N	165574	165574	332828
21626	32049	30	applied	\N	\N	\N	\N	165575	165575	332829
21626	32059	31	applied	\N	\N	\N	\N	165576	165576	332830
21626	32062	32	applied	\N	\N	\N	\N	165577	165577	332831
21626	32065	33	applied	\N	\N	\N	\N	165578	165578	332832
21626	32068	34	applied	\N	\N	\N	\N	165579	165579	332833
21626	32071	35	applied	\N	\N	\N	\N	165580	165580	332834
21626	32074	36	applied	\N	\N	\N	\N	165581	165581	332835
21626	32077	37	applied	\N	\N	\N	\N	165582	165582	332836
21626	32080	38	applied	\N	\N	\N	\N	165583	165583	332837
21626	32086	40	applied	\N	\N	\N	\N	165585	165585	332839
21626	32089	41	applied	\N	\N	\N	\N	165586	165586	332840
21626	32092	42	applied	\N	\N	\N	\N	165587	165587	332841
21626	32093	43	applied	\N	\N	\N	\N	165588	165588	332842
21626	32094	44	applied	\N	\N	\N	\N	165589	165589	332843
21626	32102	45	applied	\N	\N	\N	\N	165590	165590	332844
21626	32105	46	applied	\N	\N	\N	\N	165591	165591	332845
21626	32108	47	applied	\N	\N	\N	\N	165592	165592	332846
21626	32111	48	applied	\N	\N	\N	\N	165593	165593	332847
21626	32112	49	applied	\N	\N	\N	\N	165594	165594	332848
21626	32118	50	applied	\N	\N	\N	\N	165595	165595	332849
21626	32119	51	applied	\N	\N	\N	\N	165596	165596	332850
21626	32124	52	applied	\N	\N	\N	\N	165597	165597	332851
21626	32127	53	applied	\N	\N	\N	\N	165598	165598	332852
21626	32130	54	applied	\N	\N	\N	\N	165599	165599	332853
21626	32133	55	applied	\N	\N	\N	\N	165600	165600	332854
21626	32139	57	applied	\N	\N	\N	\N	165602	165602	332856
21626	32142	58	applied	\N	\N	\N	\N	165603	165603	332857
21626	32145	59	applied	\N	\N	\N	\N	165604	165604	332858
21626	32148	60	applied	\N	\N	\N	\N	165605	165605	332859
21626	31965	61	applied	\N	\N	\N	\N	165606	165606	332860
21626	31967	62	applied	\N	\N	\N	\N	165607	165607	332861
21626	31969	63	applied	\N	\N	\N	\N	165608	165608	332862
21626	31972	64	applied	\N	\N	\N	\N	165609	165609	332863
21626	31973	65	applied	\N	\N	\N	\N	165610	165610	332864
21626	31983	66	applied	\N	\N	\N	\N	165611	165611	332865
21626	31987	67	applied	\N	\N	\N	\N	165612	165612	332866
21626	31992	68	applied	\N	\N	\N	\N	165613	165613	332867
21626	31993	69	applied	\N	\N	\N	\N	165614	165614	332868
21626	31998	70	applied	\N	\N	\N	\N	165615	165615	332869
21618	31860	84	applied	\N	\N	\N	\N	165477	165477	332731
21618	31867	85	applied	\N	\N	\N	\N	165478	165478	332732
21626	32010	75	applied	\N	\N	\N	\N	165620	165620	332874
21626	32013	76	applied	\N	\N	\N	\N	165621	165621	332875
21626	32016	77	applied	\N	\N	\N	\N	165622	165622	332876
21626	32020	78	applied	\N	\N	\N	\N	165623	165623	332877
21626	32024	79	applied	\N	\N	\N	\N	165624	165624	332878
21626	32029	80	applied	\N	\N	\N	\N	165625	165625	332879
21626	32030	81	applied	\N	\N	\N	\N	165626	165626	332880
21626	32033	82	applied	\N	\N	\N	\N	165627	165627	332881
21626	32036	83	applied	\N	\N	\N	\N	165628	165628	332882
21626	32039	84	applied	\N	\N	\N	\N	165629	165629	332883
21626	32043	85	applied	\N	\N	\N	\N	165630	165630	332884
21626	32044	86	applied	\N	\N	\N	\N	165631	165631	332885
21626	32045	87	applied	\N	\N	\N	\N	165632	165632	332886
21626	32051	88	applied	\N	\N	\N	\N	165633	165633	332887
21626	32052	89	applied	\N	\N	\N	\N	165634	165634	332888
21626	32054	90	applied	\N	\N	\N	\N	165635	165635	332889
21626	32057	92	applied	\N	\N	\N	\N	165637	165637	332891
21626	32061	93	applied	\N	\N	\N	\N	165638	165638	332892
21626	32064	94	applied	\N	\N	\N	\N	165639	165639	332893
21626	32066	95	applied	\N	\N	\N	\N	165640	165640	332894
21626	32095	96	applied	\N	\N	\N	\N	165641	165641	332895
21626	32117	97	applied	\N	\N	\N	\N	165642	165642	332896
21626	32069	98	applied	\N	\N	\N	\N	165643	165643	332897
21626	32073	99	applied	\N	\N	\N	\N	165644	165644	332898
21626	32075	100	applied	\N	\N	\N	\N	165645	165645	332899
21626	32079	101	applied	\N	\N	\N	\N	165646	165646	332900
21626	32082	102	applied	\N	\N	\N	\N	165647	165647	332901
21626	32084	103	applied	\N	\N	\N	\N	165648	165648	332902
21626	32088	104	applied	\N	\N	\N	\N	165649	165649	332903
21626	31985	105	applied	\N	\N	\N	\N	165650	165650	332904
21626	31994	106	applied	\N	\N	\N	\N	165651	165651	332905
21626	32005	108	applied	\N	\N	\N	\N	165652	165652	332906
21626	31979	110	applied	\N	\N	\N	\N	165654	165654	332908
21626	31980	111	applied	\N	\N	\N	\N	165655	165655	332909
21626	31981	112	applied	\N	\N	\N	\N	165656	165656	332910
21626	31984	113	applied	\N	\N	\N	\N	165657	165657	332911
21626	31988	114	applied	\N	\N	\N	\N	165658	165658	332912
21626	31991	115	applied	\N	\N	\N	\N	165659	165659	332913
21626	31995	116	applied	\N	\N	\N	\N	165660	165660	332914
21626	31999	117	applied	\N	\N	\N	\N	165661	165661	332915
21626	32001	118	applied	\N	\N	\N	\N	165662	165662	332916
21626	32004	119	applied	\N	\N	\N	\N	165663	165663	332917
21626	32007	120	applied	\N	\N	\N	\N	165664	165664	332918
21626	32011	121	applied	\N	\N	\N	\N	165665	165665	332919
21626	32014	122	applied	\N	\N	\N	\N	165666	165666	332920
21626	32017	123	applied	\N	\N	\N	\N	165667	165667	332921
21626	32021	124	applied	\N	\N	\N	\N	165668	165668	332922
21626	32023	125	applied	\N	\N	\N	\N	165669	165669	332923
21627	32155	1	applied	\N	\N	\N	\N	165671	165671	332925
21634	32167	0	applied	\N	\N	\N	\N	165696	165696	332950
21634	32168	1	applied	\N	\N	\N	\N	165697	165697	332951
21634	32170	2	applied	\N	\N	\N	\N	165698	165698	332952
21634	32169	3	applied	\N	\N	\N	\N	165699	165699	332953
21639	32177	0	applied	\N	\N	\N	\N	165719	165719	332973
21639	32176	1	applied	\N	\N	\N	\N	165720	165720	332974
21639	32178	2	applied	\N	\N	\N	\N	165721	165721	332975
21639	32175	3	applied	\N	\N	\N	\N	165722	165722	332976
21639	32179	4	applied	\N	\N	\N	\N	165723	165723	332977
21641	32183	0	applied	\N	\N	\N	\N	165728	165728	332982
21641	32184	1	applied	\N	\N	\N	\N	165729	165729	332983
21641	32185	2	applied	\N	\N	\N	\N	165730	165730	332984
21644	32186	0	applied	\N	\N	\N	\N	165737	165737	332991
21644	32189	1	applied	\N	\N	\N	\N	165738	165738	332992
21644	32187	2	applied	\N	\N	\N	\N	165739	165739	332993
21644	32188	4	applied	\N	\N	\N	\N	165741	165741	332995
21646	32194	0	applied	\N	\N	\N	\N	165747	165747	333001
21646	32195	1	applied	\N	\N	\N	\N	165748	165748	333002
21646	32196	2	applied	\N	\N	\N	\N	165749	165749	333003
21646	32197	3	applied	\N	\N	\N	\N	165750	165750	333004
21646	32198	5	applied	\N	\N	\N	\N	165751	165751	333005
21646	32199	6	applied	\N	\N	\N	\N	165752	165752	333006
21646	32200	7	applied	\N	\N	\N	\N	165753	165753	333007
21646	32201	8	applied	\N	\N	\N	\N	165754	165754	333008
21649	32202	0	applied	\N	\N	\N	\N	165766	165766	333020
21649	32203	1	applied	\N	\N	\N	\N	165767	165767	333021
21649	32204	2	applied	\N	\N	\N	\N	165768	165768	333022
21651	32202	0	applied	\N	\N	\N	\N	165772	165772	333026
21651	32203	1	applied	\N	\N	\N	\N	165773	165773	333027
21651	32204	2	applied	\N	\N	\N	\N	165774	165774	333028
21655	32205	0	applied	\N	\N	\N	\N	165912	165912	333166
21655	32207	2	applied	\N	\N	\N	\N	165914	165914	333168
21655	32208	3	applied	\N	\N	\N	\N	165915	165915	333169
21655	32209	4	applied	\N	\N	\N	\N	165916	165916	333170
21655	32210	5	applied	\N	\N	\N	\N	165917	165917	333171
21655	32211	6	applied	\N	\N	\N	\N	165918	165918	333172
21655	32212	7	applied	\N	\N	\N	\N	165919	165919	333173
21655	32213	8	applied	\N	\N	\N	\N	165920	165920	333174
21658	32221	0	applied	\N	\N	\N	\N	165928	165928	333182
21658	32222	1	applied	\N	\N	\N	\N	165929	165929	333183
21658	32223	2	applied	\N	\N	\N	\N	165930	165930	333184
21658	32224	3	applied	\N	\N	\N	\N	165931	165931	333185
21661	32228	0	applied	\N	\N	\N	\N	165937	165937	333191
21661	32230	1	applied	\N	\N	\N	\N	165938	165938	333192
21661	32229	2	applied	\N	\N	\N	\N	165939	165939	333193
21667	32238	0	applied	\N	\N	\N	\N	166076	166076	333330
21667	32239	1	applied	\N	\N	\N	\N	166077	166077	333331
21667	32240	3	applied	\N	\N	\N	\N	166079	166079	333333
21670	32238	0	applied	\N	\N	\N	\N	166092	166092	333346
21670	32239	1	applied	\N	\N	\N	\N	166093	166093	333347
21670	32236	2	applied	\N	\N	\N	\N	166094	166094	333348
21670	32241	3	applied	\N	\N	\N	\N	166095	166095	333349
21670	32237	4	applied	\N	\N	\N	\N	166096	166096	333350
21670	32240	5	applied	\N	\N	\N	\N	166097	166097	333351
21674	32251	0	applied	\N	\N	\N	\N	166107	166107	333361
21674	32252	1	applied	\N	\N	\N	\N	166108	166108	333362
21674	32253	2	applied	\N	\N	\N	\N	166109	166109	333363
21679	32261	0	applied	\N	\N	\N	\N	166120	166120	333374
21679	32262	1	applied	\N	\N	\N	\N	166121	166121	333375
21679	32263	2	applied	\N	\N	\N	\N	166122	166122	333376
21684	32267	0	applied	\N	\N	\N	\N	166269	166269	333523
21626	32000	72	applied	\N	\N	\N	\N	165617	165617	332871
21626	32003	73	applied	\N	\N	\N	\N	165618	165618	332872
21653	31442	23	applied	\N	\N	\N	\N	165801	165801	333055
21653	31443	24	applied	\N	\N	\N	\N	165802	165802	333056
21653	31444	25	applied	\N	\N	\N	\N	165803	165803	333057
21653	31449	26	applied	\N	\N	\N	\N	165804	165804	333058
21653	31450	27	applied	\N	\N	\N	\N	165805	165805	333059
21653	31453	28	applied	\N	\N	\N	\N	165806	165806	333060
21653	31455	29	applied	\N	\N	\N	\N	165807	165807	333061
21653	31456	30	applied	\N	\N	\N	\N	165808	165808	333062
21653	31457	31	applied	\N	\N	\N	\N	165809	165809	333063
21653	31465	32	applied	\N	\N	\N	\N	165810	165810	333064
21653	31474	33	applied	\N	\N	\N	\N	165811	165811	333065
21653	31475	34	applied	\N	\N	\N	\N	165812	165812	333066
21653	31476	35	applied	\N	\N	\N	\N	165813	165813	333067
21653	31493	36	applied	\N	\N	\N	\N	165814	165814	333068
21653	31497	37	applied	\N	\N	\N	\N	165815	165815	333069
21653	31498	38	applied	\N	\N	\N	\N	165816	165816	333070
21653	31506	40	applied	\N	\N	\N	\N	165818	165818	333072
21653	31510	41	applied	\N	\N	\N	\N	165819	165819	333073
21653	32172	42	applied	\N	\N	\N	\N	165820	165820	333074
21653	32173	43	applied	\N	\N	\N	\N	165821	165821	333075
21653	32174	44	applied	\N	\N	\N	\N	165822	165822	333076
21653	31831	45	applied	\N	\N	\N	\N	165823	165823	333077
21653	31832	46	applied	\N	\N	\N	\N	165824	165824	333078
21653	31838	47	applied	\N	\N	\N	\N	165825	165825	333079
21653	31842	48	applied	\N	\N	\N	\N	165826	165826	333080
21653	31843	49	applied	\N	\N	\N	\N	165827	165827	333081
21653	31851	50	applied	\N	\N	\N	\N	165828	165828	333082
21653	31852	51	applied	\N	\N	\N	\N	165829	165829	333083
21653	31866	52	applied	\N	\N	\N	\N	165830	165830	333084
21653	31513	53	applied	\N	\N	\N	\N	165831	165831	333085
21653	31516	54	applied	\N	\N	\N	\N	165832	165832	333086
21653	31520	55	applied	\N	\N	\N	\N	165833	165833	333087
21653	31526	57	applied	\N	\N	\N	\N	165835	165835	333089
21653	31530	58	applied	\N	\N	\N	\N	165836	165836	333090
21653	31531	59	applied	\N	\N	\N	\N	165837	165837	333091
21653	31536	60	applied	\N	\N	\N	\N	165838	165838	333092
21653	31539	61	applied	\N	\N	\N	\N	165839	165839	333093
21653	31543	62	applied	\N	\N	\N	\N	165840	165840	333094
21653	31546	63	applied	\N	\N	\N	\N	165841	165841	333095
21653	31551	64	applied	\N	\N	\N	\N	165842	165842	333096
21653	31552	65	applied	\N	\N	\N	\N	165843	165843	333097
21653	31555	66	applied	\N	\N	\N	\N	165844	165844	333098
21653	31558	67	applied	\N	\N	\N	\N	165845	165845	333099
21653	31559	68	applied	\N	\N	\N	\N	165846	165846	333100
21653	31560	69	applied	\N	\N	\N	\N	165847	165847	333101
21653	31561	70	applied	\N	\N	\N	\N	165848	165848	333102
21653	31575	71	applied	\N	\N	\N	\N	165849	165849	333103
21653	31576	72	applied	\N	\N	\N	\N	165850	165850	333104
21653	31582	74	applied	\N	\N	\N	\N	165852	165852	333106
21653	31586	75	applied	\N	\N	\N	\N	165853	165853	333107
21653	31589	76	applied	\N	\N	\N	\N	165854	165854	333108
21653	31593	77	applied	\N	\N	\N	\N	165855	165855	333109
21653	31599	78	applied	\N	\N	\N	\N	165856	165856	333110
21653	31604	79	applied	\N	\N	\N	\N	165857	165857	333111
21653	31607	80	applied	\N	\N	\N	\N	165858	165858	333112
21653	31610	81	applied	\N	\N	\N	\N	165859	165859	333113
21653	31611	82	applied	\N	\N	\N	\N	165860	165860	333114
21653	31617	83	applied	\N	\N	\N	\N	165861	165861	333115
21653	31618	84	applied	\N	\N	\N	\N	165862	165862	333116
21653	31619	85	applied	\N	\N	\N	\N	165863	165863	333117
21653	31628	86	applied	\N	\N	\N	\N	165864	165864	333118
21653	31632	87	applied	\N	\N	\N	\N	165865	165865	333119
21653	31633	88	applied	\N	\N	\N	\N	165866	165866	333120
21653	31638	89	applied	\N	\N	\N	\N	165867	165867	333121
21653	31646	92	applied	\N	\N	\N	\N	165869	165869	333123
21653	31649	93	applied	\N	\N	\N	\N	165870	165870	333124
21653	31650	94	applied	\N	\N	\N	\N	165871	165871	333125
21653	31651	95	applied	\N	\N	\N	\N	165872	165872	333126
21653	31659	96	applied	\N	\N	\N	\N	165873	165873	333127
21684	32268	1	applied	\N	\N	\N	\N	166270	166270	333524
21684	32269	2	applied	\N	\N	\N	\N	166271	166271	333525
21684	32270	3	applied	\N	\N	\N	\N	166272	166272	333526
21687	32267	0	applied	\N	\N	\N	\N	166278	166278	333532
21695	32290	0	applied	\N	\N	\N	\N	166333	166333	333587
21695	32291	1	applied	\N	\N	\N	\N	166334	166334	333588
21695	32292	2	applied	\N	\N	\N	\N	166335	166335	333589
21695	32293	3	applied	\N	\N	\N	\N	166336	166336	333590
21697	32296	0	applied	\N	\N	\N	\N	166343	166343	333597
21697	32294	1	applied	\N	\N	\N	\N	166344	166344	333598
21697	32295	2	applied	\N	\N	\N	\N	166345	166345	333599
21697	32298	4	applied	\N	\N	\N	\N	166347	166347	333601
21699	32299	0	applied	\N	\N	\N	\N	166351	166351	333605
21699	32300	1	applied	\N	\N	\N	\N	166352	166352	333606
21699	32301	2	applied	\N	\N	\N	\N	166353	166353	333607
21701	32299	0	applied	\N	\N	\N	\N	166356	166356	333610
21701	32300	1	applied	\N	\N	\N	\N	166357	166357	333611
21701	32301	2	applied	\N	\N	\N	\N	166358	166358	333612
21712	32335	0	applied	\N	\N	\N	\N	166408	166408	333662
21712	32336	1	applied	\N	\N	\N	\N	166409	166409	333663
21712	32337	2	applied	\N	\N	\N	\N	166410	166410	333664
21715	32338	0	applied	\N	\N	\N	\N	166419	166419	333673
21715	32339	1	applied	\N	\N	\N	\N	166420	166420	333674
21715	32340	2	applied	\N	\N	\N	\N	166421	166421	333675
21715	32341	3	applied	\N	\N	\N	\N	166422	166422	333676
21715	32342	4	applied	\N	\N	\N	\N	166423	166423	333677
21715	32343	5	applied	\N	\N	\N	\N	166424	166424	333678
21718	32357	1	applied	\N	\N	\N	\N	166444	166444	333698
21718	32358	2	applied	\N	\N	\N	\N	166445	166445	333699
21721	32362	0	applied	\N	\N	\N	\N	166452	166452	333706
21721	32363	1	applied	\N	\N	\N	\N	166453	166453	333707
21721	32364	2	applied	\N	\N	\N	\N	166454	166454	333708
21723	32365	0	applied	\N	\N	\N	\N	166458	166458	333712
21723	32366	1	applied	\N	\N	\N	\N	166459	166459	333713
21723	32367	2	applied	\N	\N	\N	\N	166460	166460	333714
21725	32368	0	applied	\N	\N	\N	\N	166464	166464	333718
21725	32369	1	applied	\N	\N	\N	\N	166465	166465	333719
21735	32372	0	applied	\N	\N	\N	\N	166606	166606	333860
21735	32373	1	applied	\N	\N	\N	\N	166607	166607	333861
21735	32374	2	applied	\N	\N	\N	\N	166608	166608	333862
21735	32375	3	applied	\N	\N	\N	\N	166609	166609	333863
21653	31437	20	applied	\N	\N	\N	\N	165798	165798	333052
21653	31439	21	applied	\N	\N	\N	\N	165799	165799	333053
21653	31664	101	applied	\N	\N	\N	\N	165878	165878	333132
21653	31678	102	applied	\N	\N	\N	\N	165879	165879	333133
21653	31679	103	applied	\N	\N	\N	\N	165880	165880	333134
21653	31684	104	applied	\N	\N	\N	\N	165881	165881	333135
21653	31688	105	applied	\N	\N	\N	\N	165882	165882	333136
21653	31689	106	applied	\N	\N	\N	\N	165883	165883	333137
21653	31694	107	applied	\N	\N	\N	\N	165884	165884	333138
21653	31698	108	applied	\N	\N	\N	\N	165885	165885	333139
21653	31702	109	applied	\N	\N	\N	\N	165886	165886	333140
21653	31703	110	applied	\N	\N	\N	\N	165887	165887	333141
21653	31708	111	applied	\N	\N	\N	\N	165888	165888	333142
21653	31709	112	applied	\N	\N	\N	\N	165889	165889	333143
21653	31718	114	applied	\N	\N	\N	\N	165891	165891	333145
21653	31722	115	applied	\N	\N	\N	\N	165892	165892	333146
21653	31725	116	applied	\N	\N	\N	\N	165893	165893	333147
21653	31728	117	applied	\N	\N	\N	\N	165894	165894	333148
21653	31732	118	applied	\N	\N	\N	\N	165895	165895	333149
21653	31736	119	applied	\N	\N	\N	\N	165896	165896	333150
21653	31737	120	applied	\N	\N	\N	\N	165897	165897	333151
21653	31738	121	applied	\N	\N	\N	\N	165898	165898	333152
21653	31747	122	applied	\N	\N	\N	\N	165899	165899	333153
21653	31748	123	applied	\N	\N	\N	\N	165900	165900	333154
21653	31753	124	applied	\N	\N	\N	\N	165901	165901	333155
21653	31759	125	applied	\N	\N	\N	\N	165902	165902	333156
21656	32214	0	applied	\N	\N	\N	\N	165921	165921	333175
21656	32215	1	applied	\N	\N	\N	\N	165922	165922	333176
21656	32216	2	applied	\N	\N	\N	\N	165923	165923	333177
21663	32231	0	applied	\N	\N	\N	\N	165943	165943	333197
21663	32233	2	applied	\N	\N	\N	\N	165945	165945	333199
21663	32234	3	applied	\N	\N	\N	\N	165946	165946	333200
21666	31351	79	applied	\N	\N	\N	\N	166030	166030	333284
21666	31353	80	applied	\N	\N	\N	\N	166031	166031	333285
21666	31355	81	applied	\N	\N	\N	\N	166032	166032	333286
21666	31357	82	applied	\N	\N	\N	\N	166033	166033	333287
21666	31359	83	applied	\N	\N	\N	\N	166034	166034	333288
21666	31361	84	applied	\N	\N	\N	\N	166035	166035	333289
21666	31363	85	applied	\N	\N	\N	\N	166036	166036	333290
21666	31365	86	applied	\N	\N	\N	\N	166037	166037	333291
21666	31366	87	applied	\N	\N	\N	\N	166038	166038	333292
21666	31369	88	applied	\N	\N	\N	\N	166039	166039	333293
21666	31370	90	applied	\N	\N	\N	\N	166040	166040	333294
21666	31371	91	applied	\N	\N	\N	\N	166041	166041	333295
21666	31375	92	applied	\N	\N	\N	\N	166042	166042	333296
21666	31377	93	applied	\N	\N	\N	\N	166043	166043	333297
21666	31379	94	applied	\N	\N	\N	\N	166044	166044	333298
21666	31381	95	applied	\N	\N	\N	\N	166045	166045	333299
21666	31385	97	applied	\N	\N	\N	\N	166047	166047	333301
21666	31386	98	applied	\N	\N	\N	\N	166048	166048	333302
21666	31389	99	applied	\N	\N	\N	\N	166049	166049	333303
21666	31390	100	applied	\N	\N	\N	\N	166050	166050	333304
21666	31391	101	applied	\N	\N	\N	\N	166051	166051	333305
21666	31394	102	applied	\N	\N	\N	\N	166052	166052	333306
21666	31396	103	applied	\N	\N	\N	\N	166053	166053	333307
21666	31398	104	applied	\N	\N	\N	\N	166054	166054	333308
21666	31408	105	applied	\N	\N	\N	\N	166055	166055	333309
21666	31410	106	applied	\N	\N	\N	\N	166056	166056	333310
21666	31412	107	applied	\N	\N	\N	\N	166057	166057	333311
21666	31414	108	applied	\N	\N	\N	\N	166058	166058	333312
21666	31418	109	applied	\N	\N	\N	\N	166059	166059	333313
21666	31426	110	applied	\N	\N	\N	\N	166060	166060	333314
21666	31427	111	applied	\N	\N	\N	\N	166061	166061	333315
21666	31430	112	applied	\N	\N	\N	\N	166062	166062	333316
21666	31433	114	applied	\N	\N	\N	\N	166064	166064	333318
21666	31435	115	applied	\N	\N	\N	\N	166065	166065	333319
21666	31437	116	applied	\N	\N	\N	\N	166066	166066	333320
21666	31439	117	applied	\N	\N	\N	\N	166067	166067	333321
21666	31441	118	applied	\N	\N	\N	\N	166068	166068	333322
21666	31442	119	applied	\N	\N	\N	\N	166069	166069	333323
21666	31443	120	applied	\N	\N	\N	\N	166070	166070	333324
21666	31444	121	applied	\N	\N	\N	\N	166071	166071	333325
21666	31449	122	applied	\N	\N	\N	\N	166072	166072	333326
21666	31450	123	applied	\N	\N	\N	\N	166073	166073	333327
21666	31453	124	applied	\N	\N	\N	\N	166074	166074	333328
21666	31455	125	applied	\N	\N	\N	\N	166075	166075	333329
21668	32238	0	applied	\N	\N	\N	\N	166080	166080	333334
21668	32239	1	applied	\N	\N	\N	\N	166081	166081	333335
21668	32236	2	applied	\N	\N	\N	\N	166082	166082	333336
21668	32241	3	applied	\N	\N	\N	\N	166083	166083	333337
21668	32240	5	applied	\N	\N	\N	\N	166085	166085	333339
21673	32248	0	applied	\N	\N	\N	\N	166104	166104	333358
21673	32249	1	applied	\N	\N	\N	\N	166105	166105	333359
21673	32250	2	applied	\N	\N	\N	\N	166106	166106	333360
21675	32251	0	applied	\N	\N	\N	\N	166110	166110	333364
21681	32089	0	applied	\N	\N	\N	\N	166137	166137	333391
21681	32167	1	applied	\N	\N	\N	\N	166138	166138	333392
21681	32254	2	applied	\N	\N	\N	\N	166139	166139	333393
21681	32221	3	applied	\N	\N	\N	\N	166140	166140	333394
21681	32092	4	applied	\N	\N	\N	\N	166141	166141	333395
21681	32218	5	applied	\N	\N	\N	\N	166142	166142	333396
21681	32196	6	applied	\N	\N	\N	\N	166143	166143	333397
21681	32232	7	applied	\N	\N	1000000000	\N	166144	166144	333398
21681	32197	8	applied	\N	\N	\N	\N	166145	166145	333399
21681	32093	9	applied	\N	\N	\N	\N	166146	166146	333400
21681	32094	10	applied	\N	\N	\N	\N	166147	166147	333401
21681	32105	12	applied	\N	\N	\N	\N	166149	166149	333403
21681	32108	13	applied	\N	\N	\N	\N	166150	166150	333404
21681	32111	14	applied	\N	\N	\N	\N	166151	166151	333405
21681	32112	15	applied	\N	\N	\N	\N	166152	166152	333406
21681	32118	16	applied	\N	\N	\N	\N	166153	166153	333407
21681	32119	17	applied	\N	\N	\N	\N	166154	166154	333408
21681	32124	18	applied	\N	\N	\N	\N	166155	166155	333409
21681	32127	19	applied	\N	\N	\N	\N	166156	166156	333410
21681	32130	20	applied	\N	\N	\N	\N	166157	166157	333411
21681	32133	21	applied	\N	\N	\N	\N	166158	166158	333412
21681	32136	22	applied	\N	\N	\N	\N	166159	166159	333413
21681	32139	23	applied	\N	\N	\N	\N	166160	166160	333414
21681	32142	24	applied	\N	\N	\N	\N	166161	166161	333415
21681	32145	25	applied	\N	\N	\N	\N	166162	166162	333416
21681	32148	26	applied	\N	\N	\N	\N	166163	166163	333417
21653	31661	98	applied	\N	\N	\N	\N	165875	165875	333129
21653	31663	100	applied	\N	\N	\N	\N	165877	165877	333131
21677	32256	2	applied	\N	\N	\N	\N	166115	166115	333369
21677	32257	3	applied	\N	\N	\N	\N	166116	166116	333370
21680	31950	0	applied	\N	\N	\N	\N	166123	166123	333377
21680	31960	1	applied	\N	\N	\N	\N	166124	166124	333378
21680	32167	2	applied	\N	\N	\N	\N	166125	166125	333379
21680	32254	3	applied	\N	\N	\N	\N	166126	166126	333380
21680	32221	4	applied	\N	\N	\N	\N	166127	166127	333381
21680	32218	5	applied	\N	\N	\N	\N	166128	166128	333382
21680	32196	6	applied	\N	\N	\N	\N	166129	166129	333383
21680	32232	7	applied	\N	\N	1000000000	\N	166130	166130	333384
21680	32197	8	applied	\N	\N	\N	\N	166131	166131	333385
21680	32172	9	applied	\N	\N	\N	\N	166132	166132	333386
21680	32173	10	applied	\N	\N	\N	\N	166133	166133	333387
21680	32174	11	applied	\N	\N	\N	\N	166134	166134	333388
21680	32117	13	applied	\N	\N	\N	\N	166136	166136	333390
21681	32149	27	applied	\N	\N	\N	\N	166164	166164	333418
21681	32154	28	applied	\N	\N	\N	\N	166165	166165	333419
21681	32157	29	applied	\N	\N	\N	\N	166166	166166	333420
21681	32158	30	applied	\N	\N	\N	\N	166167	166167	333421
21681	32164	31	applied	\N	\N	\N	\N	166168	166168	333422
21681	32168	32	applied	\N	\N	\N	\N	166169	166169	333423
21681	32171	33	applied	\N	\N	\N	\N	166170	166170	333424
21681	32177	34	applied	\N	\N	\N	\N	166171	166171	333425
21681	32180	35	applied	\N	\N	\N	\N	166172	166172	333426
21681	32183	36	applied	\N	\N	\N	\N	166173	166173	333427
21681	32186	37	applied	\N	\N	\N	\N	166174	166174	333428
21681	32191	38	applied	\N	\N	\N	\N	166175	166175	333429
21681	32194	39	applied	\N	\N	\N	\N	166176	166176	333430
21681	32195	41	applied	\N	\N	\N	\N	166177	166177	333431
21681	32202	42	applied	\N	\N	\N	\N	166178	166178	333432
21681	32206	44	applied	\N	\N	\N	\N	166180	166180	333434
21681	32207	45	applied	\N	\N	\N	\N	166181	166181	333435
21681	32214	46	applied	\N	\N	\N	\N	166182	166182	333436
21681	32217	47	applied	\N	\N	\N	\N	166183	166183	333437
21681	32222	48	applied	\N	\N	\N	\N	166184	166184	333438
21681	32225	49	applied	\N	\N	\N	\N	166185	166185	333439
21681	32228	50	applied	\N	\N	\N	\N	166186	166186	333440
21681	32231	51	applied	\N	\N	\N	\N	166187	166187	333441
21681	32235	52	applied	\N	\N	\N	\N	166188	166188	333442
21681	32239	53	applied	\N	\N	\N	\N	166189	166189	333443
21681	32242	54	applied	\N	\N	\N	\N	166190	166190	333444
21681	32243	55	applied	\N	\N	\N	\N	166191	166191	333445
21681	32248	56	applied	\N	\N	\N	\N	166192	166192	333446
21681	32251	57	applied	\N	\N	\N	\N	166193	166193	333447
21681	32255	58	applied	\N	\N	\N	\N	166194	166194	333448
21681	32258	59	applied	\N	\N	\N	\N	166195	166195	333449
21681	32264	61	applied	\N	\N	\N	\N	166197	166197	333451
21681	32172	62	applied	\N	\N	\N	\N	166198	166198	333452
21681	32173	63	applied	\N	\N	\N	\N	166199	166199	333453
21681	32174	64	applied	\N	\N	\N	\N	166200	166200	333454
21681	32099	65	applied	\N	\N	\N	\N	166201	166201	333455
21681	32100	66	applied	\N	\N	\N	\N	166202	166202	333456
21681	32101	67	applied	\N	\N	\N	\N	166203	166203	333457
21681	32103	68	applied	\N	\N	\N	\N	166204	166204	333458
21681	32106	69	applied	\N	\N	\N	\N	166205	166205	333459
21681	32109	70	applied	\N	\N	\N	\N	166206	166206	333460
21681	32115	71	applied	\N	\N	\N	\N	166207	166207	333461
21689	32271	0	applied	\N	\N	\N	\N	166286	166286	333540
21689	32274	1	applied	\N	\N	\N	\N	166287	166287	333541
21689	32275	2	applied	\N	\N	\N	\N	166288	166288	333542
21689	32273	3	applied	\N	\N	\N	\N	166289	166289	333543
21689	32272	4	applied	\N	\N	\N	\N	166290	166290	333544
21691	32277	1	applied	\N	\N	\N	\N	166303	166303	333557
21691	32278	2	applied	\N	\N	\N	\N	166304	166304	333558
21691	32279	3	applied	\N	\N	\N	\N	166305	166305	333559
21691	32280	4	applied	\N	\N	\N	\N	166306	166306	333560
21691	32281	5	applied	\N	\N	\N	\N	166307	166307	333561
21691	32282	6	applied	\N	\N	\N	\N	166308	166308	333562
21691	32283	7	applied	\N	\N	\N	\N	166309	166309	333563
21691	32284	8	applied	\N	\N	\N	\N	166310	166310	333564
21691	32285	10	applied	\N	\N	\N	\N	166311	166311	333565
21691	32286	11	applied	\N	\N	\N	\N	166312	166312	333566
21700	32299	0	applied	\N	\N	\N	\N	166354	166354	333608
21700	32300	1	applied	\N	\N	\N	\N	166355	166355	333609
21702	32302	0	applied	\N	\N	\N	\N	166359	166359	333613
21702	32303	1	applied	\N	\N	\N	\N	166360	166360	333614
21702	32304	2	applied	\N	\N	\N	\N	166361	166361	333615
21703	32305	0	applied	\N	\N	\N	\N	166362	166362	333616
21703	32307	2	applied	\N	\N	\N	\N	166364	166364	333618
21703	32308	3	applied	\N	\N	\N	\N	166365	166365	333619
21703	32309	4	applied	\N	\N	\N	\N	166366	166366	333620
21703	32310	5	applied	\N	\N	\N	\N	166367	166367	333621
21703	32311	6	applied	\N	\N	\N	\N	166368	166368	333622
21703	32312	7	applied	\N	\N	\N	\N	166369	166369	333623
21703	32313	8	applied	\N	\N	\N	\N	166370	166370	333624
21703	32314	9	applied	\N	\N	\N	\N	166371	166371	333625
21703	32315	10	applied	\N	\N	\N	\N	166372	166372	333626
21703	32316	11	applied	\N	\N	\N	\N	166373	166373	333627
21705	32317	0	applied	\N	\N	\N	\N	166376	166376	333630
21705	32319	1	applied	\N	\N	\N	\N	166377	166377	333631
21705	32318	2	applied	\N	\N	\N	\N	166378	166378	333632
21708	32327	0	applied	\N	\N	\N	\N	166392	166392	333646
21708	32328	1	applied	\N	\N	\N	\N	166393	166393	333647
21708	32329	2	applied	\N	\N	\N	\N	166394	166394	333648
21726	32369	1	applied	\N	\N	\N	\N	166467	166467	333721
21736	32372	0	applied	\N	\N	\N	\N	166615	166615	333869
21736	32373	1	applied	\N	\N	\N	\N	166616	166616	333870
21736	32374	2	applied	\N	\N	\N	\N	166617	166617	333871
21736	32375	3	applied	\N	\N	\N	\N	166618	166618	333872
21736	32376	4	applied	\N	\N	\N	\N	166619	166619	333873
21736	32377	5	applied	\N	\N	\N	\N	166620	166620	333874
21736	32378	6	applied	\N	\N	\N	\N	166621	166621	333875
21736	32379	7	applied	\N	\N	\N	\N	166622	166622	333876
21736	32380	8	applied	\N	\N	\N	\N	166623	166623	333877
21739	32381	0	applied	\N	\N	\N	\N	166755	166755	334009
21739	32382	1	applied	\N	\N	\N	\N	166756	166756	334010
21739	32383	2	applied	\N	\N	\N	\N	166757	166757	334011
21739	32384	3	applied	\N	\N	\N	\N	166758	166758	334012
21739	32385	4	applied	\N	\N	\N	\N	166759	166759	334013
21739	32386	5	applied	\N	\N	\N	\N	166760	166760	334014
21677	32255	1	applied	\N	\N	\N	\N	166114	166114	333368
21681	32095	75	applied	\N	\N	\N	\N	166211	166211	333465
21681	32117	76	applied	\N	\N	\N	\N	166212	166212	333466
21681	32096	77	applied	\N	\N	\N	\N	166213	166213	333467
21681	32097	78	applied	\N	\N	\N	\N	166214	166214	333468
21681	32098	79	applied	\N	\N	\N	\N	166215	166215	333469
21681	32104	80	applied	\N	\N	\N	\N	166216	166216	333470
21681	32107	81	applied	\N	\N	\N	\N	166217	166217	333471
21681	32110	82	applied	\N	\N	\N	\N	166218	166218	333472
21681	32113	83	applied	\N	\N	\N	\N	166219	166219	333473
21681	32114	84	applied	\N	\N	\N	\N	166220	166220	333474
21681	32122	85	applied	\N	\N	\N	\N	166221	166221	333475
21681	32123	86	applied	\N	\N	\N	\N	166222	166222	333476
21681	32125	87	applied	\N	\N	\N	\N	166223	166223	333477
21681	32131	89	applied	\N	\N	\N	\N	166225	166225	333479
21681	32134	90	applied	\N	\N	\N	\N	166226	166226	333480
21681	32137	91	applied	\N	\N	\N	\N	166227	166227	333481
21681	32141	92	applied	\N	\N	\N	\N	166228	166228	333482
21681	32143	93	applied	\N	\N	\N	\N	166229	166229	333483
21681	32147	94	applied	\N	\N	\N	\N	166230	166230	333484
21681	32150	95	applied	\N	\N	\N	\N	166231	166231	333485
21681	32151	96	applied	\N	\N	\N	\N	166232	166232	333486
21681	32155	97	applied	\N	\N	\N	\N	166233	166233	333487
21681	32159	98	applied	\N	\N	\N	\N	166234	166234	333488
21681	32160	99	applied	\N	\N	1000000000	\N	166235	166235	333489
21681	32126	100	applied	\N	\N	\N	\N	166236	166236	333490
21681	32128	101	applied	\N	\N	\N	\N	166237	166237	333491
21681	32132	102	applied	\N	\N	\N	\N	166238	166238	333492
21681	32135	103	applied	\N	\N	\N	\N	166239	166239	333493
21681	32138	104	applied	\N	\N	\N	\N	166240	166240	333494
21681	32144	106	applied	\N	\N	\N	\N	166242	166242	333496
21681	32146	107	applied	\N	\N	\N	\N	166243	166243	333497
21681	32152	108	applied	\N	\N	\N	\N	166244	166244	333498
21681	32153	109	applied	\N	\N	\N	\N	166245	166245	333499
21681	32156	110	applied	\N	\N	\N	\N	166246	166246	333500
21681	32161	111	applied	\N	\N	\N	\N	166247	166247	333501
21681	32166	112	applied	\N	\N	\N	\N	166248	166248	333502
21681	32169	113	applied	\N	\N	\N	\N	166249	166249	333503
21681	32175	114	applied	\N	\N	\N	\N	166250	166250	333504
21681	32179	115	applied	\N	\N	\N	\N	166251	166251	333505
21681	32162	116	applied	\N	\N	\N	\N	166252	166252	333506
21681	32163	117	applied	\N	\N	\N	\N	166253	166253	333507
21681	32165	118	applied	\N	\N	\N	\N	166254	166254	333508
21681	32170	119	applied	\N	\N	\N	\N	166255	166255	333509
21681	32176	120	applied	\N	\N	\N	\N	166256	166256	333510
21681	32178	121	applied	\N	\N	\N	\N	166257	166257	333511
21681	32185	123	applied	\N	\N	\N	\N	166259	166259	333513
21681	32189	124	applied	\N	\N	\N	\N	166260	166260	333514
21681	32190	125	applied	\N	\N	\N	\N	166261	166261	333515
21685	32267	0	applied	\N	\N	\N	\N	166273	166273	333527
21685	32268	1	applied	\N	\N	\N	\N	166274	166274	333528
21685	32269	2	applied	\N	\N	\N	\N	166275	166275	333529
21685	32270	3	applied	\N	\N	\N	\N	166276	166276	333530
21688	32267	0	applied	\N	\N	\N	\N	166279	166279	333533
21688	32268	1	applied	\N	\N	\N	\N	166280	166280	333534
21688	32271	2	applied	\N	\N	\N	\N	166281	166281	333535
21688	32269	3	applied	\N	\N	\N	\N	166282	166282	333536
21688	32272	4	applied	\N	\N	\N	\N	166283	166283	333537
21688	32270	5	applied	\N	\N	\N	\N	166284	166284	333538
21688	32273	6	applied	\N	\N	\N	\N	166285	166285	333539
21690	32276	0	applied	\N	\N	\N	\N	166291	166291	333545
21690	32277	1	applied	\N	\N	\N	\N	166292	166292	333546
21690	32279	3	applied	\N	\N	\N	\N	166294	166294	333548
21690	32280	4	applied	\N	\N	\N	\N	166295	166295	333549
21690	32281	5	applied	\N	\N	\N	\N	166296	166296	333550
21690	32282	6	applied	\N	\N	\N	\N	166297	166297	333551
21690	32283	7	applied	\N	\N	\N	\N	166298	166298	333552
21690	32284	8	applied	\N	\N	\N	\N	166299	166299	333553
21690	32285	10	applied	\N	\N	\N	\N	166300	166300	333554
21690	32286	11	applied	\N	\N	\N	\N	166301	166301	333555
21692	32276	0	applied	\N	\N	\N	\N	166313	166313	333567
21692	32277	1	applied	\N	\N	\N	\N	166314	166314	333568
21692	32278	2	applied	\N	\N	\N	\N	166315	166315	333569
21692	32279	3	applied	\N	\N	\N	\N	166316	166316	333570
21692	32280	4	applied	\N	\N	\N	\N	166317	166317	333571
21692	32281	5	applied	\N	\N	\N	\N	166318	166318	333572
21692	32282	6	applied	\N	\N	\N	\N	166319	166319	333573
21692	32283	7	applied	\N	\N	\N	\N	166320	166320	333574
21741	32382	1	applied	\N	\N	\N	\N	166768	166768	334022
21741	32383	2	applied	\N	\N	\N	\N	166769	166769	334023
21741	32384	3	applied	\N	\N	\N	\N	166770	166770	334024
21741	32385	4	applied	\N	\N	\N	\N	166771	166771	334025
21741	32386	5	applied	\N	\N	\N	\N	166772	166772	334026
21750	32396	0	applied	\N	\N	\N	\N	166797	166797	334051
21750	32397	1	applied	\N	\N	\N	\N	166798	166798	334052
21750	32398	2	applied	\N	\N	\N	\N	166799	166799	334053
21754	32320	0	applied	\N	\N	1000000000	\N	166906	166906	334160
21754	32267	1	applied	\N	\N	\N	\N	166907	166907	334161
21754	32274	2	applied	\N	\N	\N	\N	166908	166908	334162
21754	32275	3	applied	\N	\N	\N	\N	166909	166909	334163
21754	32276	4	applied	\N	\N	\N	\N	166910	166910	334164
21754	32277	5	applied	\N	\N	\N	\N	166911	166911	334165
21754	32373	6	applied	\N	\N	\N	\N	166912	166912	334166
21756	32402	0	applied	\N	\N	\N	\N	166916	166916	334170
21756	32404	2	applied	\N	\N	\N	\N	166918	166918	334172
21763	32414	0	applied	\N	\N	\N	\N	166942	166942	334196
21763	32413	1	applied	\N	\N	\N	\N	166943	166943	334197
21763	32415	2	applied	\N	\N	\N	\N	166944	166944	334198
21763	32416	3	applied	\N	\N	\N	\N	166945	166945	334199
21768	32420	0	applied	\N	\N	\N	\N	166958	166958	334212
21768	32421	1	applied	\N	\N	\N	\N	166959	166959	334213
21768	32422	2	applied	\N	\N	\N	\N	166960	166960	334214
21768	32423	3	applied	\N	\N	\N	\N	166961	166961	334215
21768	32424	4	applied	\N	\N	\N	\N	166962	166962	334216
21768	32425	5	applied	\N	\N	\N	\N	166963	166963	334217
21770	32426	0	applied	\N	\N	\N	\N	166970	166970	334224
21770	32427	1	applied	\N	\N	\N	\N	166971	166971	334225
21770	32428	2	applied	\N	\N	\N	\N	166972	166972	334226
21773	32429	0	applied	\N	\N	\N	\N	166979	166979	334233
21773	32430	1	applied	\N	\N	\N	\N	166980	166980	334234
21681	32120	73	applied	\N	\N	\N	\N	166209	166209	333463
21681	32121	74	applied	\N	\N	\N	\N	166210	166210	333464
21693	32288	1	applied	\N	\N	\N	\N	166325	166325	333579
21693	32289	2	applied	\N	\N	\N	\N	166326	166326	333580
21696	32290	0	applied	\N	\N	\N	\N	166337	166337	333591
21696	32291	1	applied	\N	\N	\N	\N	166338	166338	333592
21696	32292	2	applied	\N	\N	\N	\N	166339	166339	333593
21696	32293	3	applied	\N	\N	\N	\N	166340	166340	333594
21696	32294	4	applied	\N	\N	\N	\N	166341	166341	333595
21696	32295	5	applied	\N	\N	\N	\N	166342	166342	333596
21698	32299	0	applied	\N	\N	\N	\N	166348	166348	333602
21698	32300	1	applied	\N	\N	\N	\N	166349	166349	333603
21698	32301	2	applied	\N	\N	\N	\N	166350	166350	333604
21706	32321	1	applied	\N	\N	\N	\N	166380	166380	333634
21706	32322	2	applied	\N	\N	\N	\N	166381	166381	333635
21706	32323	3	applied	\N	\N	\N	\N	166382	166382	333636
21706	32324	4	applied	\N	\N	\N	\N	166383	166383	333637
21709	32330	0	applied	\N	\N	\N	\N	166395	166395	333649
21709	32331	1	applied	\N	\N	\N	\N	166396	166396	333650
21709	32332	2	applied	\N	\N	\N	\N	166397	166397	333651
21709	32333	3	applied	\N	\N	\N	\N	166398	166398	333652
21709	32334	4	applied	\N	\N	\N	\N	166399	166399	333653
21711	32330	0	applied	\N	\N	\N	\N	166405	166405	333659
21711	32331	1	applied	\N	\N	\N	\N	166406	166406	333660
21711	32334	2	applied	\N	\N	\N	\N	166407	166407	333661
21713	32335	0	applied	\N	\N	\N	\N	166411	166411	333665
21713	32337	1	applied	\N	\N	\N	\N	166412	166412	333666
21716	32338	0	applied	\N	\N	\N	\N	166425	166425	333679
21716	32339	1	applied	\N	\N	\N	\N	166426	166426	333680
21716	32340	2	applied	\N	\N	\N	\N	166427	166427	333681
21716	32341	3	applied	\N	\N	\N	\N	166428	166428	333682
21716	32342	4	applied	\N	\N	\N	\N	166429	166429	333683
21719	32359	0	applied	\N	\N	\N	\N	166446	166446	333700
21719	32360	1	applied	\N	\N	\N	\N	166447	166447	333701
21719	32361	2	applied	\N	\N	\N	\N	166448	166448	333702
21724	32365	0	applied	\N	\N	\N	\N	166461	166461	333715
21724	32366	1	applied	\N	\N	\N	\N	166462	166462	333716
21724	32367	2	applied	\N	\N	\N	\N	166463	166463	333717
21727	32368	0	applied	\N	\N	\N	\N	166468	166468	333722
21727	32369	1	applied	\N	\N	\N	\N	166469	166469	333723
21728	32370	0	applied	\N	\N	\N	\N	166470	166470	333724
21728	32371	1	applied	\N	\N	\N	\N	166471	166471	333725
21742	32387	0	applied	\N	\N	\N	\N	166773	166773	334027
21742	32388	1	applied	\N	\N	\N	\N	166774	166774	334028
21742	32389	2	applied	\N	\N	\N	\N	166775	166775	334029
21745	32387	0	applied	\N	\N	\N	\N	166782	166782	334036
21745	32388	1	applied	\N	\N	\N	\N	166783	166783	334037
21745	32389	2	applied	\N	\N	\N	\N	166784	166784	334038
21746	32391	1	applied	\N	\N	\N	\N	166786	166786	334040
21746	32392	2	applied	\N	\N	\N	\N	166787	166787	334041
21751	32399	0	applied	\N	\N	\N	\N	166800	166800	334054
21751	32400	1	applied	\N	\N	\N	\N	166801	166801	334055
21751	32401	2	applied	\N	\N	\N	\N	166802	166802	334056
21753	32320	0	applied	\N	\N	1000000000	\N	166806	166806	334060
21753	32302	1	applied	\N	\N	\N	\N	166807	166807	334061
21753	32305	2	applied	\N	\N	\N	\N	166808	166808	334062
21753	32306	3	applied	\N	\N	\N	\N	166809	166809	334063
21753	32307	4	applied	\N	\N	\N	\N	166810	166810	334064
21753	32308	5	applied	\N	\N	\N	\N	166811	166811	334065
21753	32317	6	applied	\N	\N	\N	\N	166812	166812	334066
21753	32321	7	applied	\N	\N	\N	\N	166813	166813	334067
21753	32322	8	applied	\N	\N	\N	\N	166814	166814	334068
21753	32327	9	applied	\N	\N	\N	\N	166815	166815	334069
21753	32330	10	applied	\N	\N	\N	\N	166816	166816	334070
21753	32335	12	applied	\N	\N	\N	\N	166818	166818	334072
21753	32338	13	applied	\N	\N	\N	\N	166819	166819	334073
21753	32339	14	applied	\N	\N	\N	\N	166820	166820	334074
21753	32344	15	applied	\N	\N	\N	\N	166821	166821	334075
21753	32345	16	applied	\N	\N	\N	\N	166822	166822	334076
21753	32346	17	applied	\N	\N	\N	\N	166823	166823	334077
21753	32347	18	applied	\N	\N	\N	\N	166824	166824	334078
21753	32356	19	applied	\N	\N	\N	\N	166825	166825	334079
21753	32359	20	applied	\N	\N	\N	\N	166826	166826	334080
21753	32362	21	applied	\N	\N	\N	\N	166827	166827	334081
21753	32365	22	applied	\N	\N	\N	\N	166828	166828	334082
21753	32381	23	applied	\N	\N	\N	\N	166829	166829	334083
21753	32382	24	applied	\N	\N	\N	\N	166830	166830	334084
21753	32387	25	applied	\N	\N	\N	\N	166831	166831	334085
21753	32390	26	applied	\N	\N	\N	\N	166832	166832	334086
21753	32393	27	applied	\N	\N	\N	\N	166833	166833	334087
21753	32399	29	applied	\N	\N	\N	\N	166835	166835	334089
21753	32303	30	applied	\N	\N	\N	\N	166836	166836	334090
21753	32373	31	applied	\N	\N	\N	\N	166837	166837	334091
21753	32313	32	applied	\N	\N	\N	\N	166838	166838	334092
21753	32314	33	applied	\N	\N	\N	\N	166839	166839	334093
21753	32315	34	applied	\N	\N	\N	\N	166840	166840	334094
21753	32316	35	applied	\N	\N	\N	\N	166841	166841	334095
21753	32318	36	applied	\N	\N	\N	\N	166842	166842	334096
21753	32323	37	applied	\N	\N	\N	\N	166843	166843	334097
21753	32324	38	applied	\N	\N	\N	\N	166844	166844	334098
21753	32329	39	applied	\N	\N	\N	\N	166845	166845	334099
21753	32334	40	applied	\N	\N	\N	\N	166846	166846	334100
21753	32337	41	applied	\N	\N	\N	\N	166847	166847	334101
21753	32341	42	applied	\N	\N	\N	\N	166848	166848	334102
21753	32342	43	applied	\N	\N	\N	\N	166849	166849	334103
21753	32349	44	applied	\N	\N	\N	\N	166850	166850	334104
21753	32351	46	applied	\N	\N	\N	\N	166852	166852	334106
21753	32354	47	applied	\N	\N	\N	\N	166853	166853	334107
21753	32357	48	applied	\N	\N	\N	\N	166854	166854	334108
21753	32361	49	applied	\N	\N	\N	\N	166855	166855	334109
21753	32363	50	applied	\N	\N	\N	\N	166856	166856	334110
21753	32367	51	applied	\N	\N	\N	\N	166857	166857	334111
21753	32368	52	applied	\N	\N	\N	\N	166858	166858	334112
21753	32370	53	applied	\N	\N	\N	\N	166859	166859	334113
21753	32372	54	applied	\N	\N	\N	\N	166860	166860	334114
21753	32374	55	applied	\N	\N	\N	\N	166861	166861	334115
21753	32375	56	applied	\N	\N	\N	\N	166862	166862	334116
21753	32376	57	applied	\N	\N	\N	\N	166863	166863	334117
21753	32383	58	applied	\N	\N	\N	\N	166864	166864	334118
21753	32384	59	applied	\N	\N	\N	\N	166865	166865	334119
21753	32388	60	applied	\N	\N	\N	\N	166866	166866	334120
21692	32285	10	applied	\N	\N	\N	\N	166322	166322	333576
21693	32287	0	applied	\N	\N	\N	\N	166324	166324	333578
21720	32362	0	applied	\N	\N	\N	\N	166449	166449	333703
21720	32363	1	applied	\N	\N	\N	\N	166450	166450	333704
21720	32364	2	applied	\N	\N	\N	\N	166451	166451	333705
21722	32365	0	applied	\N	\N	\N	\N	166455	166455	333709
21722	32366	1	applied	\N	\N	\N	\N	166456	166456	333710
21722	32367	2	applied	\N	\N	\N	\N	166457	166457	333711
21733	32320	0	applied	\N	\N	1000000000	\N	166472	166472	333726
21733	32267	1	applied	\N	\N	\N	\N	166473	166473	333727
21733	32268	2	applied	\N	\N	\N	\N	166474	166474	333728
21733	32271	3	applied	\N	\N	\N	\N	166475	166475	333729
21733	32278	4	applied	\N	\N	\N	\N	166476	166476	333730
21733	32274	5	applied	\N	\N	\N	\N	166477	166477	333731
21733	32279	6	applied	\N	\N	\N	\N	166478	166478	333732
21733	32280	7	applied	\N	\N	\N	\N	166479	166479	333733
21733	32290	9	applied	\N	\N	\N	\N	166481	166481	333735
21733	32291	10	applied	\N	\N	\N	\N	166482	166482	333736
21733	32296	11	applied	\N	\N	\N	\N	166483	166483	333737
21733	32299	12	applied	\N	\N	\N	\N	166484	166484	333738
21733	32302	13	applied	\N	\N	\N	\N	166485	166485	333739
21733	32305	14	applied	\N	\N	\N	\N	166486	166486	333740
21733	32306	15	applied	\N	\N	\N	\N	166487	166487	333741
21733	32307	16	applied	\N	\N	\N	\N	166488	166488	333742
21733	32308	17	applied	\N	\N	\N	\N	166489	166489	333743
21733	32317	18	applied	\N	\N	\N	\N	166490	166490	333744
21733	32321	19	applied	\N	\N	\N	\N	166491	166491	333745
21733	32322	20	applied	\N	\N	\N	\N	166492	166492	333746
21733	32327	21	applied	\N	\N	\N	\N	166493	166493	333747
21733	32330	22	applied	\N	\N	\N	\N	166494	166494	333748
21733	32331	23	applied	\N	\N	\N	\N	166495	166495	333749
21733	32335	24	applied	\N	\N	\N	\N	166496	166496	333750
21733	32339	26	applied	\N	\N	\N	\N	166498	166498	333752
21733	32344	27	applied	\N	\N	\N	\N	166499	166499	333753
21733	32345	28	applied	\N	\N	\N	\N	166500	166500	333754
21733	32346	29	applied	\N	\N	\N	\N	166501	166501	333755
21733	32347	30	applied	\N	\N	\N	\N	166502	166502	333756
21733	32356	31	applied	\N	\N	\N	\N	166503	166503	333757
21733	32359	32	applied	\N	\N	\N	\N	166504	166504	333758
21733	32362	33	applied	\N	\N	\N	\N	166505	166505	333759
21733	32365	34	applied	\N	\N	\N	\N	166506	166506	333760
21733	32275	35	applied	\N	\N	\N	\N	166507	166507	333761
21733	32276	36	applied	\N	\N	\N	\N	166508	166508	333762
21733	32277	37	applied	\N	\N	\N	\N	166509	166509	333763
21733	32193	38	applied	\N	\N	\N	\N	166510	166510	333764
21733	32200	39	applied	\N	\N	\N	\N	166511	166511	333765
21733	32201	41	applied	\N	\N	\N	\N	166512	166512	333766
21733	32203	42	applied	\N	\N	\N	\N	166513	166513	333767
21733	32212	44	applied	\N	\N	\N	\N	166515	166515	333769
21733	32213	45	applied	\N	\N	\N	\N	166516	166516	333770
21733	32216	46	applied	\N	\N	\N	\N	166517	166517	333771
21733	32220	47	applied	\N	\N	\N	\N	166518	166518	333772
21733	32224	48	applied	\N	\N	\N	\N	166519	166519	333773
21733	32226	49	applied	\N	\N	\N	\N	166520	166520	333774
21733	32230	50	applied	\N	\N	\N	\N	166521	166521	333775
21733	32234	51	applied	\N	\N	\N	\N	166522	166522	333776
21733	32236	52	applied	\N	\N	\N	\N	166523	166523	333777
21733	32241	53	applied	\N	\N	\N	\N	166524	166524	333778
21733	32246	54	applied	\N	\N	\N	\N	166525	166525	333779
21733	32247	55	applied	\N	\N	\N	\N	166526	166526	333780
21733	32249	56	applied	\N	\N	\N	\N	166527	166527	333781
21733	32253	57	applied	\N	\N	\N	\N	166528	166528	333782
21733	32257	58	applied	\N	\N	\N	\N	166529	166529	333783
21733	32260	59	applied	\N	\N	\N	\N	166530	166530	333784
21733	32266	61	applied	\N	\N	\N	\N	166532	166532	333786
21733	32270	62	applied	\N	\N	\N	\N	166533	166533	333787
21733	32273	63	applied	\N	\N	\N	\N	166534	166534	333788
21733	32284	64	applied	\N	\N	\N	\N	166535	166535	333789
21733	32285	65	applied	\N	\N	\N	\N	166536	166536	333790
21733	32286	66	applied	\N	\N	\N	\N	166537	166537	333791
21733	32289	67	applied	\N	\N	\N	\N	166538	166538	333792
21733	32292	68	applied	\N	\N	\N	\N	166539	166539	333793
21733	32293	69	applied	\N	\N	\N	\N	166540	166540	333794
21733	32298	70	applied	\N	\N	\N	\N	166541	166541	333795
21733	32300	71	applied	\N	\N	\N	\N	166542	166542	333796
21733	32303	72	applied	\N	\N	\N	\N	166543	166543	333797
21733	32313	73	applied	\N	\N	\N	\N	166544	166544	333798
21733	32314	74	applied	\N	\N	\N	\N	166545	166545	333799
21753	32391	61	applied	\N	\N	\N	\N	166867	166867	334121
21753	32394	62	applied	\N	\N	\N	\N	166868	166868	334122
21753	32400	64	applied	\N	\N	\N	\N	166870	166870	334124
21753	32304	65	applied	\N	\N	\N	\N	166871	166871	334125
21753	32309	66	applied	\N	\N	\N	\N	166872	166872	334126
21753	32310	67	applied	\N	\N	\N	\N	166873	166873	334127
21753	32311	68	applied	\N	\N	\N	\N	166874	166874	334128
21753	32312	69	applied	\N	\N	\N	\N	166875	166875	334129
21753	32319	70	applied	\N	\N	\N	\N	166876	166876	334130
21753	32325	71	applied	\N	\N	\N	\N	166877	166877	334131
21753	32326	72	applied	\N	\N	\N	\N	166878	166878	334132
21753	32328	73	applied	\N	\N	\N	\N	166879	166879	334133
21753	32332	74	applied	\N	\N	\N	\N	166880	166880	334134
21753	32333	75	applied	\N	\N	\N	\N	166881	166881	334135
21753	32336	76	applied	\N	\N	\N	\N	166882	166882	334136
21753	32340	77	applied	\N	\N	\N	\N	166883	166883	334137
21753	32343	78	applied	\N	\N	\N	\N	166884	166884	334138
21753	32348	79	applied	\N	\N	\N	\N	166885	166885	334139
21753	32353	81	applied	\N	\N	\N	\N	166887	166887	334141
21753	32355	82	applied	\N	\N	\N	\N	166888	166888	334142
21753	32358	83	applied	\N	\N	\N	\N	166889	166889	334143
21753	32360	84	applied	\N	\N	\N	\N	166890	166890	334144
21753	32364	85	applied	\N	\N	\N	\N	166891	166891	334145
21753	32366	86	applied	\N	\N	\N	\N	166892	166892	334146
21753	32369	87	applied	\N	\N	\N	\N	166893	166893	334147
21753	32371	88	applied	\N	\N	\N	\N	166894	166894	334148
21753	32377	89	applied	\N	\N	\N	\N	166895	166895	334149
21753	32378	90	applied	\N	\N	\N	\N	166896	166896	334150
21753	32379	91	applied	\N	\N	\N	\N	166897	166897	334151
21753	32380	92	applied	\N	\N	\N	\N	166898	166898	334152
21753	32385	93	applied	\N	\N	\N	\N	166899	166899	334153
21753	32386	94	applied	\N	\N	\N	\N	166900	166900	334154
21753	32389	95	applied	\N	\N	\N	\N	166901	166901	334155
21753	32392	96	applied	\N	\N	\N	\N	166902	166902	334156
21717	32355	11	applied	\N	\N	\N	\N	166442	166442	333696
21733	32324	79	applied	\N	\N	\N	\N	166550	166550	333804
21733	32329	80	applied	\N	\N	\N	\N	166551	166551	333805
21733	32334	81	applied	\N	\N	\N	\N	166552	166552	333806
21733	32337	82	applied	\N	\N	\N	\N	166553	166553	333807
21733	32341	83	applied	\N	\N	\N	\N	166554	166554	333808
21733	32342	84	applied	\N	\N	\N	\N	166555	166555	333809
21733	32349	85	applied	\N	\N	\N	\N	166556	166556	333810
21733	32350	86	applied	\N	\N	\N	\N	166557	166557	333811
21733	32351	87	applied	\N	\N	\N	\N	166558	166558	333812
21733	32354	88	applied	\N	\N	\N	\N	166559	166559	333813
21733	32357	89	applied	\N	\N	\N	\N	166560	166560	333814
21733	32361	90	applied	\N	\N	\N	\N	166561	166561	333815
21733	32367	92	applied	\N	\N	\N	\N	166563	166563	333817
21733	32368	93	applied	\N	\N	\N	\N	166564	166564	333818
21733	32370	94	applied	\N	\N	\N	\N	166565	166565	333819
21733	32372	95	applied	\N	\N	\N	\N	166566	166566	333820
21733	32182	96	applied	\N	\N	\N	\N	166567	166567	333821
21733	32184	97	applied	\N	\N	\N	\N	166568	166568	333822
21733	32187	98	applied	\N	\N	\N	\N	166569	166569	333823
21733	32188	99	applied	\N	\N	\N	\N	166570	166570	333824
21733	32192	100	applied	\N	\N	\N	\N	166571	166571	333825
21733	32198	101	applied	\N	\N	\N	\N	166572	166572	333826
21733	32199	102	applied	\N	\N	\N	\N	166573	166573	333827
21733	32204	103	applied	\N	\N	\N	\N	166574	166574	333828
21733	32208	104	applied	\N	\N	\N	\N	166575	166575	333829
21733	32209	105	applied	\N	\N	\N	\N	166576	166576	333830
21733	32210	106	applied	\N	\N	\N	\N	166577	166577	333831
21733	32215	107	applied	\N	\N	\N	\N	166578	166578	333832
21733	32223	109	applied	\N	\N	\N	\N	166580	166580	333834
21733	32227	110	applied	\N	\N	\N	\N	166581	166581	333835
21733	32229	111	applied	\N	\N	\N	\N	166582	166582	333836
21733	32233	112	applied	\N	\N	\N	\N	166583	166583	333837
21733	32237	113	applied	\N	\N	\N	\N	166584	166584	333838
21733	32240	114	applied	\N	\N	\N	\N	166585	166585	333839
21733	32244	115	applied	\N	\N	\N	\N	166586	166586	333840
21733	32245	116	applied	\N	\N	\N	\N	166587	166587	333841
21733	32250	117	applied	\N	\N	\N	\N	166588	166588	333842
21733	32252	118	applied	\N	\N	\N	\N	166589	166589	333843
21733	32256	119	applied	\N	\N	\N	\N	166590	166590	333844
21733	32259	120	applied	\N	\N	\N	\N	166591	166591	333845
21733	32263	121	applied	\N	\N	\N	\N	166592	166592	333846
21733	32265	122	applied	\N	\N	\N	\N	166593	166593	333847
21733	32269	123	applied	\N	\N	\N	\N	166594	166594	333848
21733	32272	124	applied	\N	\N	\N	\N	166595	166595	333849
21734	32372	0	applied	\N	\N	\N	\N	166597	166597	333851
21734	32373	1	applied	\N	\N	\N	\N	166598	166598	333852
21734	32374	2	applied	\N	\N	\N	\N	166599	166599	333853
21734	32375	3	applied	\N	\N	\N	\N	166600	166600	333854
21734	32376	4	applied	\N	\N	\N	\N	166601	166601	333855
21734	32377	5	applied	\N	\N	\N	\N	166602	166602	333856
21734	32378	6	applied	\N	\N	\N	\N	166603	166603	333857
21734	32379	7	applied	\N	\N	\N	\N	166604	166604	333858
21734	32380	8	applied	\N	\N	\N	\N	166605	166605	333859
21735	32376	4	applied	\N	\N	\N	\N	166610	166610	333864
21735	32377	5	applied	\N	\N	\N	\N	166611	166611	333865
21735	32378	6	applied	\N	\N	\N	\N	166612	166612	333866
21735	32379	7	applied	\N	\N	\N	\N	166613	166613	333867
21735	32380	8	applied	\N	\N	\N	\N	166614	166614	333868
21737	32267	1	applied	\N	\N	\N	\N	166625	166625	333879
21737	31986	2	applied	\N	\N	\N	\N	166626	166626	333880
21737	32167	3	applied	\N	\N	\N	\N	166627	166627	333881
21737	32254	4	applied	\N	\N	\N	\N	166628	166628	333882
21737	32221	5	applied	\N	\N	\N	\N	166629	166629	333883
21737	32218	6	applied	\N	\N	\N	\N	166630	166630	333884
21737	31989	7	applied	\N	\N	\N	\N	166631	166631	333885
21737	31990	8	applied	\N	\N	\N	\N	166632	166632	333886
21737	32196	9	applied	\N	\N	\N	\N	166633	166633	333887
21737	32232	10	applied	\N	\N	1000000000	\N	166634	166634	333888
21737	31996	11	applied	\N	\N	\N	\N	166635	166635	333889
21737	31997	12	applied	\N	\N	\N	\N	166636	166636	333890
21737	32002	13	applied	\N	\N	\N	\N	166637	166637	333891
21737	32006	14	applied	\N	\N	\N	\N	166638	166638	333892
21737	32009	15	applied	\N	\N	\N	\N	166639	166639	333893
21738	32381	0	applied	\N	\N	\N	\N	166749	166749	334003
21738	32382	1	applied	\N	\N	\N	\N	166750	166750	334004
21738	32383	2	applied	\N	\N	\N	\N	166751	166751	334005
21738	32384	3	applied	\N	\N	\N	\N	166752	166752	334006
21738	32385	4	applied	\N	\N	\N	\N	166753	166753	334007
21740	32381	0	applied	\N	\N	\N	\N	166761	166761	334015
21740	32382	1	applied	\N	\N	\N	\N	166762	166762	334016
21740	32383	2	applied	\N	\N	\N	\N	166763	166763	334017
21740	32384	3	applied	\N	\N	\N	\N	166764	166764	334018
21740	32385	4	applied	\N	\N	\N	\N	166765	166765	334019
21740	32386	5	applied	\N	\N	\N	\N	166766	166766	334020
21743	32387	0	applied	\N	\N	\N	\N	166776	166776	334030
21743	32388	1	applied	\N	\N	\N	\N	166777	166777	334031
21743	32389	2	applied	\N	\N	\N	\N	166778	166778	334032
21747	32393	0	applied	\N	\N	\N	\N	166788	166788	334042
21747	32394	1	applied	\N	\N	\N	\N	166789	166789	334043
21747	32395	2	applied	\N	\N	\N	\N	166790	166790	334044
21749	32396	0	applied	\N	\N	\N	\N	166794	166794	334048
21749	32397	1	applied	\N	\N	\N	\N	166795	166795	334049
21749	32398	2	applied	\N	\N	\N	\N	166796	166796	334050
21752	32399	0	applied	\N	\N	\N	\N	166803	166803	334057
21752	32401	2	applied	\N	\N	\N	\N	166805	166805	334059
21755	32402	0	applied	\N	\N	\N	\N	166913	166913	334167
21755	32403	1	applied	\N	\N	\N	\N	166914	166914	334168
21755	32404	2	applied	\N	\N	\N	\N	166915	166915	334169
21760	32411	0	applied	\N	\N	\N	\N	166934	166934	334188
21760	32412	1	applied	\N	\N	\N	\N	166935	166935	334189
21762	32411	0	applied	\N	\N	\N	\N	166939	166939	334193
21762	32412	1	applied	\N	\N	\N	\N	166940	166940	334194
21762	32413	2	applied	\N	\N	\N	\N	166941	166941	334195
21767	32420	0	applied	\N	\N	\N	\N	166952	166952	334206
21767	32421	1	applied	\N	\N	\N	\N	166953	166953	334207
21767	32422	2	applied	\N	\N	\N	\N	166954	166954	334208
21767	32423	3	applied	\N	\N	\N	\N	166955	166955	334209
21767	32424	4	applied	\N	\N	\N	\N	166956	166956	334210
21767	32425	5	applied	\N	\N	\N	\N	166957	166957	334211
21733	32316	76	applied	\N	\N	\N	\N	166547	166547	333801
21733	32323	78	applied	\N	\N	\N	\N	166549	166549	333803
21737	32174	20	applied	\N	\N	\N	\N	166644	166644	333898
21737	32274	21	applied	\N	\N	\N	\N	166645	166645	333899
21737	32015	22	applied	\N	\N	\N	\N	166646	166646	333900
21737	32019	23	applied	\N	\N	\N	\N	166647	166647	333901
21737	32022	24	applied	\N	\N	\N	\N	166648	166648	333902
21737	32025	25	applied	\N	\N	\N	\N	166649	166649	333903
21737	32026	26	applied	\N	\N	\N	\N	166650	166650	333904
21737	32031	27	applied	\N	\N	\N	\N	166651	166651	333905
21737	32034	28	applied	\N	\N	\N	\N	166652	166652	333906
21737	32037	29	applied	\N	\N	\N	\N	166653	166653	333907
21737	32040	30	applied	\N	\N	\N	\N	166654	166654	333908
21737	32041	31	applied	\N	\N	\N	\N	166655	166655	333909
21737	32042	32	applied	\N	\N	\N	\N	166656	166656	333910
21737	32049	33	applied	\N	\N	\N	\N	166657	166657	333911
21737	32059	34	applied	\N	\N	\N	\N	166658	166658	333912
21737	32062	35	applied	\N	\N	\N	\N	166659	166659	333913
21737	32068	37	applied	\N	\N	\N	\N	166661	166661	333915
21737	32071	38	applied	\N	\N	\N	\N	166662	166662	333916
21737	32074	39	applied	\N	\N	\N	\N	166663	166663	333917
21737	32077	40	applied	\N	\N	\N	\N	166664	166664	333918
21737	32080	41	applied	\N	\N	\N	\N	166665	166665	333919
21737	32083	42	applied	\N	\N	\N	\N	166666	166666	333920
21737	32086	43	applied	\N	\N	\N	\N	166667	166667	333921
21737	32089	44	applied	\N	\N	\N	\N	166668	166668	333922
21737	32092	45	applied	\N	\N	\N	\N	166669	166669	333923
21737	32093	46	applied	\N	\N	\N	\N	166670	166670	333924
21737	32094	47	applied	\N	\N	\N	\N	166671	166671	333925
21737	32102	48	applied	\N	\N	\N	\N	166672	166672	333926
21737	32105	49	applied	\N	\N	\N	\N	166673	166673	333927
21737	32108	50	applied	\N	\N	\N	\N	166674	166674	333928
21737	32111	51	applied	\N	\N	\N	\N	166675	166675	333929
21737	32112	52	applied	\N	\N	\N	\N	166676	166676	333930
21737	32119	54	applied	\N	\N	\N	\N	166678	166678	333932
21737	32124	55	applied	\N	\N	\N	\N	166679	166679	333933
21737	32127	56	applied	\N	\N	\N	\N	166680	166680	333934
21737	32130	57	applied	\N	\N	\N	\N	166681	166681	333935
21737	32133	58	applied	\N	\N	\N	\N	166682	166682	333936
21737	32136	59	applied	\N	\N	\N	\N	166683	166683	333937
21737	32139	60	applied	\N	\N	\N	\N	166684	166684	333938
21737	32142	61	applied	\N	\N	\N	\N	166685	166685	333939
21737	32145	63	applied	\N	\N	\N	\N	166686	166686	333940
21737	32148	64	applied	\N	\N	\N	\N	166687	166687	333941
21737	32149	65	applied	\N	\N	\N	\N	166688	166688	333942
21737	32154	66	applied	\N	\N	\N	\N	166689	166689	333943
21737	32157	67	applied	\N	\N	\N	\N	166690	166690	333944
21737	32158	68	applied	\N	\N	\N	\N	166691	166691	333945
21737	32164	69	applied	\N	\N	\N	\N	166692	166692	333946
21737	32168	70	applied	\N	\N	\N	\N	166693	166693	333947
21737	32177	72	applied	\N	\N	\N	\N	166695	166695	333949
21737	32180	73	applied	\N	\N	\N	\N	166696	166696	333950
21737	32183	74	applied	\N	\N	\N	\N	166697	166697	333951
21737	32186	75	applied	\N	\N	\N	\N	166698	166698	333952
21737	32191	76	applied	\N	\N	\N	\N	166699	166699	333953
21737	32194	77	applied	\N	\N	\N	\N	166700	166700	333954
21737	32195	78	applied	\N	\N	\N	\N	166701	166701	333955
21737	32202	79	applied	\N	\N	\N	\N	166702	166702	333956
21737	32205	80	applied	\N	\N	\N	\N	166703	166703	333957
21737	32206	81	applied	\N	\N	\N	\N	166704	166704	333958
21737	32207	82	applied	\N	\N	\N	\N	166705	166705	333959
21737	32214	83	applied	\N	\N	\N	\N	166706	166706	333960
21737	32217	84	applied	\N	\N	\N	\N	166707	166707	333961
21737	32222	85	applied	\N	\N	\N	\N	166708	166708	333962
21737	32225	86	applied	\N	\N	\N	\N	166709	166709	333963
21737	32228	87	applied	\N	\N	\N	\N	166710	166710	333964
21737	32235	89	applied	\N	\N	\N	\N	166712	166712	333966
21737	32239	90	applied	\N	\N	\N	\N	166713	166713	333967
21737	32242	91	applied	\N	\N	\N	\N	166714	166714	333968
21737	32243	92	applied	\N	\N	\N	\N	166715	166715	333969
21737	32248	93	applied	\N	\N	\N	\N	166716	166716	333970
21737	32251	94	applied	\N	\N	\N	\N	166717	166717	333971
21737	32255	95	applied	\N	\N	\N	\N	166718	166718	333972
21737	32258	96	applied	\N	\N	\N	\N	166719	166719	333973
21737	32261	97	applied	\N	\N	\N	\N	166720	166720	333974
21737	32264	98	applied	\N	\N	\N	\N	166721	166721	333975
21737	32268	99	applied	\N	\N	\N	\N	166722	166722	333976
21737	32271	100	applied	\N	\N	\N	\N	166723	166723	333977
21737	32278	101	applied	\N	\N	\N	\N	166724	166724	333978
21737	32279	102	applied	\N	\N	\N	\N	166725	166725	333979
21737	32280	103	applied	\N	\N	\N	\N	166726	166726	333980
21737	32287	104	applied	\N	\N	\N	\N	166727	166727	333981
21737	32291	106	applied	\N	\N	\N	\N	166729	166729	333983
21737	32296	107	applied	\N	\N	\N	\N	166730	166730	333984
21737	32299	108	applied	\N	\N	\N	\N	166731	166731	333985
21737	32302	109	applied	\N	\N	\N	\N	166732	166732	333986
21737	32305	110	applied	\N	\N	\N	\N	166733	166733	333987
21737	32306	111	applied	\N	\N	\N	\N	166734	166734	333988
21737	32307	112	applied	\N	\N	\N	\N	166735	166735	333989
21737	32308	113	applied	\N	\N	\N	\N	166736	166736	333990
21737	32317	114	applied	\N	\N	\N	\N	166737	166737	333991
21737	32321	115	applied	\N	\N	\N	\N	166738	166738	333992
21737	32322	116	applied	\N	\N	\N	\N	166739	166739	333993
21737	32327	117	applied	\N	\N	\N	\N	166740	166740	333994
21737	32330	118	applied	\N	\N	\N	\N	166741	166741	333995
21737	32331	119	applied	\N	\N	\N	\N	166742	166742	333996
21737	32335	120	applied	\N	\N	\N	\N	166743	166743	333997
21737	32338	121	applied	\N	\N	\N	\N	166744	166744	333998
21737	32344	123	applied	\N	\N	\N	\N	166746	166746	334000
21737	32345	124	applied	\N	\N	\N	\N	166747	166747	334001
21737	32346	125	applied	\N	\N	\N	\N	166748	166748	334002
21744	32387	0	applied	\N	\N	\N	\N	166779	166779	334033
21744	32388	1	applied	\N	\N	\N	\N	166780	166780	334034
21744	32389	2	applied	\N	\N	\N	\N	166781	166781	334035
21748	32393	0	applied	\N	\N	\N	\N	166791	166791	334045
21748	32394	1	applied	\N	\N	\N	\N	166792	166792	334046
21748	32395	2	applied	\N	\N	\N	\N	166793	166793	334047
21758	32408	0	applied	\N	\N	\N	\N	166922	166922	334176
21758	32409	1	applied	\N	\N	\N	\N	166923	166923	334177
21758	32410	2	applied	\N	\N	\N	\N	166924	166924	334178
21761	32411	0	applied	\N	\N	\N	\N	166936	166936	334190
21761	32412	1	applied	\N	\N	\N	\N	166937	166937	334191
21737	32012	17	applied	\N	\N	\N	\N	166641	166641	333895
21737	32172	18	applied	\N	\N	\N	\N	166642	166642	333896
21757	32406	1	applied	\N	\N	\N	\N	166920	166920	334174
21757	32407	2	applied	\N	\N	\N	\N	166921	166921	334175
21759	32402	0	applied	\N	\N	\N	\N	166925	166925	334179
21759	32405	1	applied	\N	\N	\N	\N	166926	166926	334180
21759	32408	2	applied	\N	\N	\N	\N	166927	166927	334181
21759	32403	3	applied	\N	\N	\N	\N	166928	166928	334182
21759	32406	4	applied	\N	\N	\N	\N	166929	166929	334183
21759	32410	5	applied	\N	\N	\N	\N	166930	166930	334184
21759	32404	6	applied	\N	\N	\N	\N	166931	166931	334185
21759	32407	7	applied	\N	\N	\N	\N	166932	166932	334186
21759	32409	8	applied	\N	\N	\N	\N	166933	166933	334187
21761	32413	2	applied	\N	\N	\N	\N	166938	166938	334192
21765	32417	0	applied	\N	\N	\N	\N	166946	166946	334200
21765	32418	1	applied	\N	\N	\N	\N	166947	166947	334201
21765	32419	2	applied	\N	\N	\N	\N	166948	166948	334202
21766	32417	0	applied	\N	\N	\N	\N	166949	166949	334203
21766	32419	2	applied	\N	\N	\N	\N	166951	166951	334205
21769	32420	0	applied	\N	\N	\N	\N	166964	166964	334218
21769	32421	1	applied	\N	\N	\N	\N	166965	166965	334219
21769	32422	2	applied	\N	\N	\N	\N	166966	166966	334220
21769	32423	3	applied	\N	\N	\N	\N	166967	166967	334221
21769	32424	4	applied	\N	\N	\N	\N	166968	166968	334222
21769	32425	5	applied	\N	\N	\N	\N	166969	166969	334223
21771	32426	0	applied	\N	\N	\N	\N	166973	166973	334227
21771	32427	1	applied	\N	\N	\N	\N	166974	166974	334228
21771	32428	2	applied	\N	\N	\N	\N	166975	166975	334229
21772	32429	0	applied	\N	\N	\N	\N	166976	166976	334230
21772	32430	1	applied	\N	\N	\N	\N	166977	166977	334231
21772	32431	2	applied	\N	\N	\N	\N	166978	166978	334232
21774	32432	0	applied	\N	\N	\N	\N	166982	166982	334236
21774	32433	1	applied	\N	\N	\N	\N	166983	166983	334237
21774	32434	2	applied	\N	\N	\N	\N	166984	166984	334238
21775	32436	1	applied	\N	\N	\N	\N	166986	166986	334240
21775	32437	2	applied	\N	\N	\N	\N	166987	166987	334241
21775	32438	3	applied	\N	\N	\N	\N	166988	166988	334242
21775	32439	4	applied	\N	\N	\N	\N	166989	166989	334243
21775	32440	5	applied	\N	\N	\N	\N	166990	166990	334244
21775	32441	6	applied	\N	\N	\N	\N	166991	166991	334245
21775	32442	7	applied	\N	\N	\N	\N	166992	166992	334246
21775	32443	8	applied	\N	\N	\N	\N	166993	166993	334247
21776	32381	0	applied	\N	\N	\N	\N	166994	166994	334248
21776	32382	1	applied	\N	\N	\N	\N	166995	166995	334249
21776	32387	2	applied	\N	\N	\N	\N	166996	166996	334250
21776	32390	3	applied	\N	\N	\N	\N	166997	166997	334251
21776	32393	4	applied	\N	\N	\N	\N	166998	166998	334252
21776	32396	5	applied	\N	\N	\N	\N	166999	166999	334253
21776	32399	6	applied	\N	\N	\N	\N	167000	167000	334254
21776	32402	7	applied	\N	\N	\N	\N	167001	167001	334255
21776	32408	9	applied	\N	\N	\N	\N	167003	167003	334257
21776	32411	10	applied	\N	\N	\N	\N	167004	167004	334258
21776	32414	11	applied	\N	\N	\N	\N	167005	167005	334259
21776	32417	12	applied	\N	\N	\N	\N	167006	167006	334260
21776	32420	13	applied	\N	\N	\N	\N	167007	167007	334261
21776	32421	14	applied	\N	\N	\N	\N	167008	167008	334262
21776	32426	15	applied	\N	\N	\N	\N	167009	167009	334263
21776	32429	16	applied	\N	\N	\N	\N	167010	167010	334264
21776	32432	17	applied	\N	\N	\N	\N	167011	167011	334265
21776	32435	18	applied	\N	\N	\N	\N	167012	167012	334266
21776	32436	19	applied	\N	\N	\N	\N	167013	167013	334267
21776	32437	20	applied	\N	\N	\N	\N	167014	167014	334268
21776	32444	21	applied	\N	\N	\N	\N	167015	167015	334269
21776	32282	22	applied	\N	\N	\N	\N	167016	167016	334270
21776	32283	23	applied	\N	\N	\N	\N	167017	167017	334271
21776	32373	24	applied	\N	\N	\N	\N	167018	167018	334272
21776	32375	26	applied	\N	\N	\N	\N	167020	167020	334274
21776	32376	27	applied	\N	\N	\N	\N	167021	167021	334275
21776	32383	28	applied	\N	\N	\N	\N	167022	167022	334276
21776	32288	29	applied	\N	\N	\N	\N	167023	167023	334277
21776	32294	30	applied	\N	\N	\N	\N	167024	167024	334278
21776	32295	31	applied	\N	\N	\N	\N	167025	167025	334279
21776	32297	32	applied	\N	\N	\N	\N	167026	167026	334280
21776	32301	33	applied	\N	\N	\N	\N	167027	167027	334281
21776	32384	34	applied	\N	\N	\N	\N	167028	167028	334282
21776	32388	35	applied	\N	\N	\N	\N	167029	167029	334283
21776	32391	36	applied	\N	\N	\N	\N	167030	167030	334284
21776	32394	37	applied	\N	\N	\N	\N	167031	167031	334285
21776	32398	38	applied	\N	\N	\N	\N	167032	167032	334286
21776	32400	39	applied	\N	\N	\N	\N	167033	167033	334287
21776	32404	41	applied	\N	\N	\N	\N	167034	167034	334288
21776	32407	42	applied	\N	\N	\N	\N	167035	167035	334289
21776	32412	44	applied	\N	\N	\N	\N	167037	167037	334291
21776	32415	45	applied	\N	\N	\N	\N	167038	167038	334292
21776	32418	46	applied	\N	\N	\N	\N	167039	167039	334293
21776	32422	47	applied	\N	\N	\N	\N	167040	167040	334294
21776	32425	48	applied	\N	\N	\N	\N	167041	167041	334295
21776	32427	49	applied	\N	\N	\N	\N	167042	167042	334296
21776	32430	50	applied	\N	\N	\N	\N	167043	167043	334297
21776	32433	51	applied	\N	\N	\N	\N	167044	167044	334298
21776	32304	52	applied	\N	\N	\N	\N	167045	167045	334299
21776	32309	53	applied	\N	\N	\N	\N	167046	167046	334300
21776	32310	54	applied	\N	\N	\N	\N	167047	167047	334301
21776	32311	55	applied	\N	\N	\N	\N	167048	167048	334302
21776	32312	56	applied	\N	\N	\N	\N	167049	167049	334303
21776	32319	57	applied	\N	\N	\N	\N	167050	167050	334304
21776	32325	58	applied	\N	\N	\N	\N	167051	167051	334305
21776	32326	59	applied	\N	\N	\N	\N	167052	167052	334306
21776	32332	61	applied	\N	\N	\N	\N	167054	167054	334308
21776	32333	62	applied	\N	\N	\N	\N	167055	167055	334309
21776	32336	63	applied	\N	\N	\N	\N	167056	167056	334310
21776	32340	64	applied	\N	\N	\N	\N	167057	167057	334311
21776	32441	65	applied	\N	\N	\N	\N	167058	167058	334312
21776	32442	66	applied	\N	\N	\N	\N	167059	167059	334313
21776	32443	67	applied	\N	\N	\N	\N	167060	167060	334314
21776	32445	68	applied	\N	\N	\N	\N	167061	167061	334315
21776	32343	69	applied	\N	\N	\N	\N	167062	167062	334316
21777	32444	0	applied	\N	\N	\N	\N	167063	167063	334317
21777	32446	1	applied	\N	\N	\N	\N	167064	167064	334318
21777	32445	2	applied	\N	\N	\N	\N	167065	167065	334319
21777	32447	3	applied	\N	\N	\N	\N	167066	167066	334320
21777	32448	4	applied	\N	\N	\N	\N	167067	167067	334321
21753	32397	98	applied	\N	\N	\N	\N	166904	166904	334158
21753	32401	99	applied	\N	\N	\N	\N	166905	166905	334159
21780	32453	0	applied	\N	\N	\N	\N	167072	167072	334326
21780	32454	1	applied	\N	\N	\N	\N	167073	167073	334327
21780	32455	2	applied	\N	\N	\N	\N	167074	167074	334328
21781	32453	0	applied	\N	\N	\N	\N	167075	167075	334329
21781	32454	1	applied	\N	\N	\N	\N	167076	167076	334330
21781	32455	2	applied	\N	\N	\N	\N	167077	167077	334331
21783	32453	0	applied	\N	\N	\N	\N	167078	167078	334332
21783	32454	1	applied	\N	\N	\N	\N	167079	167079	334333
21783	32455	2	applied	\N	\N	\N	\N	167080	167080	334334
21784	32453	0	applied	\N	\N	\N	\N	167081	167081	334335
21784	32455	1	applied	\N	\N	\N	\N	167082	167082	334336
21785	32453	0	applied	\N	\N	\N	\N	167083	167083	334337
21785	32454	1	applied	\N	\N	\N	\N	167084	167084	334338
21785	32455	2	applied	\N	\N	\N	\N	167085	167085	334339
21786	32456	0	applied	\N	\N	\N	\N	167086	167086	334340
21786	32454	1	applied	\N	\N	\N	\N	167087	167087	334341
21789	32461	0	applied	\N	\N	\N	\N	167095	167095	334349
21789	32462	1	applied	\N	\N	\N	\N	167096	167096	334350
21789	32463	2	applied	\N	\N	\N	\N	167097	167097	334351
21789	32464	3	applied	\N	\N	\N	\N	167098	167098	334352
21789	32465	4	applied	\N	\N	\N	\N	167099	167099	334353
21789	32466	5	applied	\N	\N	\N	\N	167100	167100	334354
21789	32467	6	applied	\N	\N	\N	\N	167101	167101	334355
21789	32468	7	applied	\N	\N	\N	\N	167102	167102	334356
21794	32476	0	applied	\N	\N	\N	\N	167193	167193	334447
21794	32477	1	applied	\N	\N	\N	\N	167194	167194	334448
21794	32478	2	applied	\N	\N	\N	\N	167195	167195	334449
21794	32479	3	applied	\N	\N	\N	\N	167196	167196	334450
21794	32480	4	applied	\N	\N	\N	\N	167197	167197	334451
21794	32481	5	applied	\N	\N	\N	\N	167198	167198	334452
21796	32365	0	applied	\N	\N	\N	\N	167324	167324	334578
21796	32381	1	applied	\N	\N	\N	\N	167325	167325	334579
21796	32387	3	applied	\N	\N	\N	\N	167327	167327	334581
21796	32390	4	applied	\N	\N	\N	\N	167328	167328	334582
21796	32393	5	applied	\N	\N	\N	\N	167329	167329	334583
21796	32396	6	applied	\N	\N	\N	\N	167330	167330	334584
21796	32399	7	applied	\N	\N	\N	\N	167331	167331	334585
21796	32402	8	applied	\N	\N	\N	\N	167332	167332	334586
21796	32405	9	applied	\N	\N	\N	\N	167333	167333	334587
21796	32408	10	applied	\N	\N	\N	\N	167334	167334	334588
21796	32411	11	applied	\N	\N	\N	\N	167335	167335	334589
21796	32414	12	applied	\N	\N	\N	\N	167336	167336	334590
21796	32417	14	applied	\N	\N	\N	\N	167337	167337	334591
21796	32420	15	applied	\N	\N	\N	\N	167338	167338	334592
21796	32421	16	applied	\N	\N	\N	\N	167339	167339	334593
21796	32426	17	applied	\N	\N	\N	\N	167340	167340	334594
21796	32429	18	applied	\N	\N	\N	\N	167341	167341	334595
21796	32432	19	applied	\N	\N	\N	\N	167342	167342	334596
21796	32436	21	applied	\N	\N	\N	\N	167344	167344	334598
21796	32437	22	applied	\N	\N	\N	\N	167345	167345	334599
21796	32444	23	applied	\N	\N	\N	\N	167346	167346	334600
21796	32446	24	applied	\N	\N	\N	\N	167347	167347	334601
21796	32450	25	applied	\N	\N	\N	\N	167348	167348	334602
21796	32453	26	applied	\N	\N	\N	\N	167349	167349	334603
21796	32456	27	applied	\N	\N	\N	\N	167350	167350	334604
21796	32458	28	applied	\N	\N	\N	\N	167351	167351	334605
21796	32461	29	applied	\N	\N	\N	\N	167352	167352	334606
21796	32462	30	applied	\N	\N	\N	\N	167353	167353	334607
21796	32469	31	applied	\N	\N	\N	\N	167354	167354	334608
21796	32476	32	applied	\N	\N	\N	\N	167355	167355	334609
21796	32477	33	applied	\N	\N	\N	\N	167356	167356	334610
21796	32482	34	applied	\N	\N	\N	\N	167357	167357	334611
21796	32366	35	applied	\N	\N	\N	\N	167358	167358	334612
21796	32373	36	applied	\N	\N	\N	\N	167359	167359	334613
21796	32471	38	applied	\N	\N	\N	\N	167361	167361	334615
21796	32472	39	applied	\N	\N	\N	\N	167362	167362	334616
21796	32474	40	applied	\N	\N	\N	\N	167363	167363	334617
21796	32367	41	applied	\N	\N	\N	\N	167364	167364	334618
21796	32368	42	applied	\N	\N	\N	\N	167365	167365	334619
21796	32370	43	applied	\N	\N	\N	\N	167366	167366	334620
21796	32372	44	applied	\N	\N	\N	\N	167367	167367	334621
21796	32374	45	applied	\N	\N	\N	\N	167368	167368	334622
21796	32375	46	applied	\N	\N	\N	\N	167369	167369	334623
21796	32376	47	applied	\N	\N	\N	\N	167370	167370	334624
21796	32383	48	applied	\N	\N	\N	\N	167371	167371	334625
21796	32384	49	applied	\N	\N	\N	\N	167372	167372	334626
21796	32388	50	applied	\N	\N	\N	\N	167373	167373	334627
21796	32391	51	applied	\N	\N	\N	\N	167374	167374	334628
21796	32394	52	applied	\N	\N	\N	\N	167375	167375	334629
21796	32398	53	applied	\N	\N	\N	\N	167376	167376	334630
21796	32404	55	applied	\N	\N	\N	\N	167378	167378	334632
21796	32407	56	applied	\N	\N	\N	\N	167379	167379	334633
21796	32409	57	applied	\N	\N	\N	\N	167380	167380	334634
21796	32412	58	applied	\N	\N	\N	\N	167381	167381	334635
21796	32415	59	applied	\N	\N	\N	\N	167382	167382	334636
21796	32418	60	applied	\N	\N	\N	\N	167383	167383	334637
21796	32422	61	applied	\N	\N	\N	\N	167384	167384	334638
21796	32425	62	applied	\N	\N	\N	\N	167385	167385	334639
21796	32427	63	applied	\N	\N	\N	\N	167386	167386	334640
21796	32430	64	applied	\N	\N	\N	\N	167387	167387	334641
21796	32433	65	applied	\N	\N	\N	\N	167388	167388	334642
21796	32441	66	applied	\N	\N	\N	\N	167389	167389	334643
21796	32442	67	applied	\N	\N	\N	\N	167390	167390	334644
21796	32443	68	applied	\N	\N	\N	\N	167391	167391	334645
21796	32445	69	applied	\N	\N	\N	\N	167392	167392	334646
21796	32447	70	applied	\N	\N	\N	\N	167393	167393	334647
21796	32455	72	applied	\N	\N	\N	\N	167395	167395	334649
21796	32460	73	applied	\N	\N	\N	\N	167396	167396	334650
21796	32463	74	applied	\N	\N	\N	\N	167397	167397	334651
21796	32467	75	applied	\N	\N	\N	\N	167398	167398	334652
21796	32468	76	applied	\N	\N	\N	\N	167399	167399	334653
21796	32475	77	applied	\N	\N	\N	\N	167400	167400	334654
21796	32480	78	applied	\N	\N	\N	\N	167401	167401	334655
21796	32481	79	applied	\N	\N	\N	\N	167402	167402	334656
21796	32483	80	applied	\N	\N	\N	\N	167403	167403	334657
21796	32369	81	applied	\N	\N	\N	\N	167404	167404	334658
21796	32371	82	applied	\N	\N	\N	\N	167405	167405	334659
21796	32377	83	applied	\N	\N	\N	\N	167406	167406	334660
21796	32378	84	applied	\N	\N	\N	\N	167407	167407	334661
21796	32379	85	applied	\N	\N	\N	\N	167408	167408	334662
21779	32450	0	applied	\N	\N	\N	\N	167069	167069	334323
21779	32451	1	applied	\N	\N	\N	\N	167070	167070	334324
21792	32411	1	applied	\N	\N	\N	\N	167119	167119	334373
21792	32414	2	applied	\N	\N	\N	\N	167120	167120	334374
21792	32417	3	applied	\N	\N	\N	\N	167121	167121	334375
21792	32420	4	applied	\N	\N	\N	\N	167122	167122	334376
21792	32421	5	applied	\N	\N	\N	\N	167123	167123	334377
21792	32426	6	applied	\N	\N	\N	\N	167124	167124	334378
21792	32429	7	applied	\N	\N	\N	\N	167125	167125	334379
21792	32432	8	applied	\N	\N	\N	\N	167126	167126	334380
21792	32435	9	applied	\N	\N	\N	\N	167127	167127	334381
21792	32436	10	applied	\N	\N	\N	\N	167128	167128	334382
21792	32437	11	applied	\N	\N	\N	\N	167129	167129	334383
21792	32444	12	applied	\N	\N	\N	\N	167130	167130	334384
21792	32446	13	applied	\N	\N	\N	\N	167131	167131	334385
21792	32450	14	applied	\N	\N	\N	\N	167132	167132	334386
21792	32456	16	applied	\N	\N	\N	\N	167134	167134	334388
21792	32458	17	applied	\N	\N	\N	\N	167135	167135	334389
21792	32461	18	applied	\N	\N	\N	\N	167136	167136	334390
21792	32462	19	applied	\N	\N	\N	\N	167137	167137	334391
21792	32469	20	applied	\N	\N	\N	\N	167138	167138	334392
21792	32409	21	applied	\N	\N	\N	\N	167139	167139	334393
21792	32412	22	applied	\N	\N	\N	\N	167140	167140	334394
21792	32415	23	applied	\N	\N	\N	\N	167141	167141	334395
21792	32418	24	applied	\N	\N	\N	\N	167142	167142	334396
21792	32422	25	applied	\N	\N	\N	\N	167143	167143	334397
21792	32470	26	applied	\N	\N	\N	\N	167144	167144	334398
21792	32471	27	applied	\N	\N	\N	\N	167145	167145	334399
21792	32472	28	applied	\N	\N	\N	\N	167146	167146	334400
21792	32474	29	applied	\N	\N	\N	\N	167147	167147	334401
21792	32410	30	applied	\N	\N	\N	\N	167148	167148	334402
21792	32413	31	applied	\N	\N	\N	\N	167149	167149	334403
21792	32427	33	applied	\N	\N	\N	\N	167151	167151	334405
21792	32430	34	applied	\N	\N	\N	\N	167152	167152	334406
21792	32433	35	applied	\N	\N	\N	\N	167153	167153	334407
21792	32416	36	applied	\N	\N	\N	\N	167154	167154	334408
21792	32419	37	applied	\N	\N	\N	\N	167155	167155	334409
21792	32423	38	applied	\N	\N	\N	\N	167156	167156	334410
21792	32424	39	applied	\N	\N	\N	\N	167157	167157	334411
21792	32428	40	applied	\N	\N	\N	\N	167158	167158	334412
21792	32431	41	applied	\N	\N	\N	\N	167159	167159	334413
21792	32441	42	applied	\N	\N	\N	\N	167160	167160	334414
21792	32442	43	applied	\N	\N	\N	\N	167161	167161	334415
21792	32443	44	applied	\N	\N	\N	\N	167162	167162	334416
21792	32445	45	applied	\N	\N	\N	\N	167163	167163	334417
21792	32447	46	applied	\N	\N	\N	\N	167164	167164	334418
21792	32451	47	applied	\N	\N	\N	\N	167165	167165	334419
21792	32455	48	applied	\N	\N	\N	\N	167166	167166	334420
21792	32463	50	applied	\N	\N	\N	\N	167168	167168	334422
21792	32467	51	applied	\N	\N	\N	\N	167169	167169	334423
21792	32468	52	applied	\N	\N	\N	\N	167170	167170	334424
21792	32475	53	applied	\N	\N	\N	\N	167171	167171	334425
21792	32434	54	applied	\N	\N	\N	\N	167172	167172	334426
21792	32438	55	applied	\N	\N	\N	\N	167173	167173	334427
21792	32439	56	applied	\N	\N	\N	\N	167174	167174	334428
21792	32440	57	applied	\N	\N	\N	\N	167175	167175	334429
21792	32448	58	applied	\N	\N	\N	\N	167176	167176	334430
21792	32449	59	applied	\N	\N	\N	\N	167177	167177	334431
21792	32452	60	applied	\N	\N	\N	\N	167178	167178	334432
21792	32454	61	applied	\N	\N	\N	\N	167179	167179	334433
21792	32457	62	applied	\N	\N	\N	\N	167180	167180	334434
21792	32459	63	applied	\N	\N	\N	\N	167181	167181	334435
21792	32464	64	applied	\N	\N	\N	\N	167182	167182	334436
21792	32465	65	applied	\N	\N	\N	\N	167183	167183	334437
21792	32473	67	applied	\N	\N	\N	\N	167185	167185	334439
21796	32380	86	applied	\N	\N	\N	\N	167409	167409	334663
21796	32385	87	applied	\N	\N	\N	\N	167410	167410	334664
21796	32386	88	applied	\N	\N	\N	\N	167411	167411	334665
21796	32389	89	applied	\N	\N	\N	\N	167412	167412	334666
21796	32392	90	applied	\N	\N	\N	\N	167413	167413	334667
21796	32395	91	applied	\N	\N	\N	\N	167414	167414	334668
21796	32397	92	applied	\N	\N	\N	\N	167415	167415	334669
21796	32401	93	applied	\N	\N	\N	\N	167416	167416	334670
21796	32403	94	applied	\N	\N	\N	\N	167417	167417	334671
21796	32406	95	applied	\N	\N	\N	\N	167418	167418	334672
21796	32410	96	applied	\N	\N	\N	\N	167419	167419	334673
21796	32413	97	applied	\N	\N	\N	\N	167420	167420	334674
21796	32416	98	applied	\N	\N	\N	\N	167421	167421	334675
21796	32419	99	applied	\N	\N	\N	\N	167422	167422	334676
21796	32423	100	applied	\N	\N	\N	\N	167423	167423	334677
21796	32428	102	applied	\N	\N	\N	\N	167425	167425	334679
21796	32431	103	applied	\N	\N	\N	\N	167426	167426	334680
21796	32434	104	applied	\N	\N	\N	\N	167427	167427	334681
21797	32482	0	applied	\N	\N	\N	\N	167444	167444	334698
21797	32485	1	applied	\N	\N	\N	\N	167445	167445	334699
21797	32484	2	applied	\N	\N	\N	\N	167446	167446	334700
21797	32483	3	applied	\N	\N	\N	\N	167447	167447	334701
21797	32486	4	applied	\N	\N	\N	\N	167448	167448	334702
21797	32487	5	applied	\N	\N	\N	\N	167449	167449	334703
21801	32488	0	applied	\N	\N	\N	\N	167462	167462	334716
21801	32489	1	applied	\N	\N	\N	\N	167463	167463	334717
21801	32490	2	applied	\N	\N	\N	\N	167464	167464	334718
21806	32320	0	applied	\N	\N	1000000000	\N	167489	167489	334743
21806	32267	1	applied	\N	\N	\N	\N	167490	167490	334744
21806	32254	2	applied	\N	\N	\N	\N	167491	167491	334745
21806	32274	3	applied	\N	\N	\N	\N	167492	167492	334746
21806	32276	5	applied	\N	\N	\N	\N	167494	167494	334748
21806	32277	6	applied	\N	\N	\N	\N	167495	167495	334749
21806	32373	7	applied	\N	\N	\N	\N	167496	167496	334750
21806	32470	8	applied	\N	\N	\N	\N	167497	167497	334751
21806	32471	9	applied	\N	\N	\N	\N	167498	167498	334752
21806	32472	10	applied	\N	\N	\N	\N	167499	167499	334753
21806	32474	11	applied	\N	\N	\N	\N	167500	167500	334754
21808	32497	0	applied	\N	\N	\N	\N	167507	167507	334761
21808	32498	1	applied	\N	\N	\N	\N	167508	167508	334762
21808	32499	2	applied	\N	\N	\N	\N	167509	167509	334763
21808	32500	3	applied	\N	\N	\N	\N	167510	167510	334764
21808	32501	4	applied	\N	\N	\N	\N	167511	167511	334765
21808	32502	5	applied	\N	\N	\N	\N	167512	167512	334766
21810	32506	0	applied	\N	\N	\N	\N	167516	167516	334770
21810	32507	1	applied	\N	\N	\N	\N	167517	167517	334771
21810	32508	2	applied	\N	\N	\N	\N	167518	167518	334772
21792	32408	0	applied	\N	\N	\N	\N	167118	167118	334372
21790	32461	0	applied	\N	\N	\N	\N	167103	167103	334357
21790	32462	1	applied	\N	\N	\N	\N	167104	167104	334358
21790	32463	2	applied	\N	\N	\N	\N	167105	167105	334359
21790	32464	3	applied	\N	\N	\N	\N	167106	167106	334360
21790	32465	4	applied	\N	\N	\N	\N	167107	167107	334361
21790	32466	5	applied	\N	\N	\N	\N	167108	167108	334362
21790	32467	6	applied	\N	\N	\N	\N	167109	167109	334363
21790	32468	7	applied	\N	\N	\N	\N	167110	167110	334364
21795	32320	0	applied	\N	\N	1000000000	\N	167199	167199	334453
21795	32267	1	applied	\N	\N	\N	\N	167200	167200	334454
21795	32254	2	applied	\N	\N	\N	\N	167201	167201	334455
21795	32221	3	applied	\N	\N	\N	\N	167202	167202	334456
21795	32218	4	applied	\N	\N	\N	\N	167203	167203	334457
21795	32232	6	applied	\N	\N	1000000000	\N	167205	167205	334459
21795	32197	7	applied	\N	\N	\N	\N	167206	167206	334460
21795	32171	8	applied	\N	\N	\N	\N	167207	167207	334461
21795	32177	9	applied	\N	\N	\N	\N	167208	167208	334462
21795	32180	10	applied	\N	\N	\N	\N	167209	167209	334463
21795	32183	11	applied	\N	\N	\N	\N	167210	167210	334464
21795	32186	12	applied	\N	\N	\N	\N	167211	167211	334465
21795	32191	13	applied	\N	\N	\N	\N	167212	167212	334466
21795	32194	14	applied	\N	\N	\N	\N	167213	167213	334467
21795	32195	15	applied	\N	\N	\N	\N	167214	167214	334468
21795	32202	16	applied	\N	\N	\N	\N	167215	167215	334469
21795	32205	17	applied	\N	\N	\N	\N	167216	167216	334470
21795	32206	18	applied	\N	\N	\N	\N	167217	167217	334471
21795	32207	19	applied	\N	\N	\N	\N	167218	167218	334472
21795	32214	20	applied	\N	\N	\N	\N	167219	167219	334473
21795	32217	21	applied	\N	\N	\N	\N	167220	167220	334474
21795	32225	23	applied	\N	\N	\N	\N	167222	167222	334476
21795	32228	24	applied	\N	\N	\N	\N	167223	167223	334477
21795	32231	25	applied	\N	\N	\N	\N	167224	167224	334478
21795	32235	26	applied	\N	\N	\N	\N	167225	167225	334479
21795	32239	27	applied	\N	\N	\N	\N	167226	167226	334480
21795	32242	28	applied	\N	\N	\N	\N	167227	167227	334481
21795	32243	29	applied	\N	\N	\N	\N	167228	167228	334482
21795	32248	30	applied	\N	\N	\N	\N	167229	167229	334483
21795	32251	31	applied	\N	\N	\N	\N	167230	167230	334484
21795	32255	32	applied	\N	\N	\N	\N	167231	167231	334485
21795	32258	33	applied	\N	\N	\N	\N	167232	167232	334486
21795	32261	34	applied	\N	\N	\N	\N	167233	167233	334487
21795	32264	35	applied	\N	\N	\N	\N	167234	167234	334488
21795	32268	36	applied	\N	\N	\N	\N	167235	167235	334489
21795	32271	37	applied	\N	\N	\N	\N	167236	167236	334490
21795	32172	38	applied	\N	\N	\N	\N	167237	167237	334491
21795	32174	41	applied	\N	\N	\N	\N	167239	167239	334493
21795	32278	42	applied	\N	\N	\N	\N	167240	167240	334494
21795	32274	43	applied	\N	\N	\N	\N	167241	167241	334495
21795	32279	44	applied	\N	\N	\N	\N	167242	167242	334496
21795	32280	45	applied	\N	\N	\N	\N	167243	167243	334497
21795	32287	46	applied	\N	\N	\N	\N	167244	167244	334498
21795	32290	47	applied	\N	\N	\N	\N	167245	167245	334499
21795	32291	48	applied	\N	\N	\N	\N	167246	167246	334500
21795	32296	49	applied	\N	\N	\N	\N	167247	167247	334501
21795	32299	50	applied	\N	\N	\N	\N	167248	167248	334502
21795	32302	51	applied	\N	\N	\N	\N	167249	167249	334503
21795	32305	52	applied	\N	\N	\N	\N	167250	167250	334504
21795	32306	53	applied	\N	\N	\N	\N	167251	167251	334505
21795	32307	54	applied	\N	\N	\N	\N	167252	167252	334506
21795	32308	55	applied	\N	\N	\N	\N	167253	167253	334507
21795	32317	56	applied	\N	\N	\N	\N	167254	167254	334508
21795	32322	58	applied	\N	\N	\N	\N	167256	167256	334510
21795	32327	59	applied	\N	\N	\N	\N	167257	167257	334511
21795	32330	60	applied	\N	\N	\N	\N	167258	167258	334512
21795	32331	61	applied	\N	\N	\N	\N	167259	167259	334513
21795	32335	62	applied	\N	\N	\N	\N	167260	167260	334514
21795	32338	63	applied	\N	\N	\N	\N	167261	167261	334515
21795	32339	64	applied	\N	\N	\N	\N	167262	167262	334516
21795	32344	65	applied	\N	\N	\N	\N	167263	167263	334517
21795	32345	66	applied	\N	\N	\N	\N	167264	167264	334518
21795	32346	67	applied	\N	\N	\N	\N	167265	167265	334519
21795	32347	68	applied	\N	\N	\N	\N	167266	167266	334520
21795	32356	69	applied	\N	\N	\N	\N	167267	167267	334521
21795	32359	70	applied	\N	\N	\N	\N	167268	167268	334522
21795	32362	71	applied	\N	\N	\N	\N	167269	167269	334523
21795	32365	72	applied	\N	\N	\N	\N	167270	167270	334524
21795	32381	73	applied	\N	\N	\N	\N	167271	167271	334525
21795	32387	75	applied	\N	\N	\N	\N	167273	167273	334527
21795	32390	76	applied	\N	\N	\N	\N	167274	167274	334528
21795	32393	77	applied	\N	\N	\N	\N	167275	167275	334529
21795	32396	78	applied	\N	\N	\N	\N	167276	167276	334530
21795	32399	79	applied	\N	\N	\N	\N	167277	167277	334531
21795	32402	80	applied	\N	\N	\N	\N	167278	167278	334532
21795	32405	81	applied	\N	\N	\N	\N	167279	167279	334533
21795	32408	82	applied	\N	\N	\N	\N	167280	167280	334534
21795	32411	83	applied	\N	\N	\N	\N	167281	167281	334535
21795	32414	84	applied	\N	\N	\N	\N	167282	167282	334536
21795	32417	85	applied	\N	\N	\N	\N	167283	167283	334537
21795	32420	86	applied	\N	\N	\N	\N	167284	167284	334538
21795	32421	87	applied	\N	\N	\N	\N	167285	167285	334539
21795	32426	88	applied	\N	\N	\N	\N	167286	167286	334540
21795	32429	89	applied	\N	\N	\N	\N	167287	167287	334541
21812	32506	0	applied	\N	\N	\N	\N	167522	167522	334776
21812	32508	2	applied	\N	\N	\N	\N	167524	167524	334778
21820	32527	0	applied	\N	\N	\N	\N	167561	167561	334815
21820	32528	1	applied	\N	\N	\N	\N	167562	167562	334816
21820	32529	2	applied	\N	\N	\N	\N	167563	167563	334817
21820	32530	3	applied	\N	\N	\N	\N	167564	167564	334818
21820	32531	4	applied	\N	\N	\N	\N	167565	167565	334819
21820	32532	5	applied	\N	\N	\N	\N	167566	167566	334820
21827	32551	0	applied	\N	\N	\N	\N	167609	167609	334863
21827	32552	1	applied	\N	\N	\N	\N	167610	167610	334864
21827	32553	2	applied	\N	\N	\N	\N	167611	167611	334865
21827	32554	3	applied	\N	\N	\N	\N	167612	167612	334866
21827	32555	4	applied	\N	\N	\N	\N	167613	167613	334867
21827	32556	5	applied	\N	\N	\N	\N	167614	167614	334868
21829	32559	0	applied	\N	\N	\N	\N	167617	167617	334871
21829	32560	1	applied	\N	\N	\N	\N	167618	167618	334872
21829	32561	2	applied	\N	\N	\N	\N	167619	167619	334873
21788	32459	1	applied	\N	\N	\N	\N	167093	167093	334347
21788	32460	2	applied	\N	\N	\N	\N	167094	167094	334348
21791	32473	4	applied	\N	\N	\N	\N	167115	167115	334369
21791	32474	5	applied	\N	\N	\N	\N	167116	167116	334370
21791	32475	6	applied	\N	\N	\N	\N	167117	167117	334371
21793	32469	0	applied	\N	\N	\N	\N	167186	167186	334440
21793	32470	1	applied	\N	\N	\N	\N	167187	167187	334441
21793	32471	2	applied	\N	\N	\N	\N	167188	167188	334442
21793	32472	3	applied	\N	\N	\N	\N	167189	167189	334443
21793	32473	4	applied	\N	\N	\N	\N	167190	167190	334444
21793	32474	5	applied	\N	\N	\N	\N	167191	167191	334445
21793	32475	6	applied	\N	\N	\N	\N	167192	167192	334446
21795	32432	90	applied	\N	\N	\N	\N	167288	167288	334542
21795	32435	91	applied	\N	\N	\N	\N	167289	167289	334543
21795	32436	92	applied	\N	\N	\N	\N	167290	167290	334544
21795	32437	93	applied	\N	\N	\N	\N	167291	167291	334545
21795	32444	94	applied	\N	\N	\N	\N	167292	167292	334546
21795	32446	95	applied	\N	\N	\N	\N	167293	167293	334547
21795	32453	97	applied	\N	\N	\N	\N	167295	167295	334549
21795	32456	98	applied	\N	\N	\N	\N	167296	167296	334550
21795	32458	99	applied	\N	\N	\N	\N	167297	167297	334551
21795	32461	100	applied	\N	\N	\N	\N	167298	167298	334552
21795	32462	101	applied	\N	\N	\N	\N	167299	167299	334553
21795	32469	102	applied	\N	\N	\N	\N	167300	167300	334554
21795	32476	103	applied	\N	\N	\N	\N	167301	167301	334555
21795	32477	104	applied	\N	\N	\N	\N	167302	167302	334556
21795	32482	105	applied	\N	\N	\N	\N	167303	167303	334557
21795	32275	106	applied	\N	\N	\N	\N	167304	167304	334558
21795	32276	107	applied	\N	\N	\N	\N	167305	167305	334559
21795	32277	108	applied	\N	\N	\N	\N	167306	167306	334560
21799	32482	0	applied	\N	\N	\N	\N	167456	167456	334710
21799	32485	1	applied	\N	\N	\N	\N	167457	167457	334711
21799	32484	2	applied	\N	\N	\N	\N	167458	167458	334712
21799	32483	3	applied	\N	\N	\N	\N	167459	167459	334713
21799	32487	5	applied	\N	\N	\N	\N	167461	167461	334715
21803	32491	0	applied	\N	\N	\N	\N	167471	167471	334725
21803	32492	1	applied	\N	\N	\N	\N	167472	167472	334726
21803	32493	2	applied	\N	\N	\N	\N	167473	167473	334727
21803	32494	3	applied	\N	\N	\N	\N	167474	167474	334728
21803	32495	4	applied	\N	\N	\N	\N	167475	167475	334729
21803	32496	5	applied	\N	\N	\N	\N	167476	167476	334730
21809	32503	0	applied	\N	\N	\N	\N	167513	167513	334767
21809	32504	1	applied	\N	\N	\N	\N	167514	167514	334768
21809	32505	2	applied	\N	\N	\N	\N	167515	167515	334769
21811	32506	0	applied	\N	\N	\N	\N	167519	167519	334773
21811	32507	1	applied	\N	\N	\N	\N	167520	167520	334774
21811	32508	2	applied	\N	\N	\N	\N	167521	167521	334775
21814	32509	0	applied	\N	\N	\N	\N	167531	167531	334785
21814	32510	1	applied	\N	\N	\N	\N	167532	167532	334786
21814	32511	2	applied	\N	\N	\N	\N	167533	167533	334787
21814	32513	4	applied	\N	\N	\N	\N	167535	167535	334789
21814	32514	5	applied	\N	\N	\N	\N	167536	167536	334790
21816	32515	0	applied	\N	\N	\N	\N	167537	167537	334791
21816	32516	1	applied	\N	\N	\N	\N	167538	167538	334792
21816	32517	2	applied	\N	\N	\N	\N	167539	167539	334793
21816	32518	3	applied	\N	\N	\N	\N	167540	167540	334794
21816	32519	4	applied	\N	\N	\N	\N	167541	167541	334795
21816	32520	5	applied	\N	\N	\N	\N	167542	167542	334796
21819	32527	0	applied	\N	\N	\N	\N	167555	167555	334809
21819	32528	1	applied	\N	\N	\N	\N	167556	167556	334810
21819	32529	2	applied	\N	\N	\N	\N	167557	167557	334811
21819	32530	3	applied	\N	\N	\N	\N	167558	167558	334812
21819	32531	4	applied	\N	\N	\N	\N	167559	167559	334813
21819	32532	5	applied	\N	\N	\N	\N	167560	167560	334814
21822	32533	0	applied	\N	\N	\N	\N	167567	167567	334821
21822	32534	1	applied	\N	\N	\N	\N	167568	167568	334822
21822	32536	3	applied	\N	\N	\N	\N	167570	167570	334824
21822	32537	4	applied	\N	\N	\N	\N	167571	167571	334825
21822	32538	5	applied	\N	\N	\N	\N	167572	167572	334826
21822	32539	6	applied	\N	\N	\N	\N	167573	167573	334827
21822	32540	7	applied	\N	\N	\N	\N	167574	167574	334828
21822	32541	8	applied	\N	\N	\N	\N	167575	167575	334829
21822	32542	9	applied	\N	\N	\N	\N	167576	167576	334830
21822	32543	10	applied	\N	\N	\N	\N	167577	167577	334831
21822	32544	11	applied	\N	\N	\N	\N	167578	167578	334832
21825	32551	0	applied	\N	\N	\N	\N	167597	167597	334851
21825	32552	1	applied	\N	\N	\N	\N	167598	167598	334852
21825	32553	2	applied	\N	\N	\N	\N	167599	167599	334853
21825	32554	3	applied	\N	\N	\N	\N	167600	167600	334854
21825	32555	4	applied	\N	\N	\N	\N	167601	167601	334855
21825	32556	5	applied	\N	\N	\N	\N	167602	167602	334856
21833	32572	0	applied	\N	\N	\N	\N	167634	167634	334888
21835	32574	0	applied	\N	\N	\N	\N	167638	167638	334892
21835	32575	1	applied	\N	\N	\N	\N	167639	167639	334893
21835	32576	2	applied	\N	\N	\N	\N	167640	167640	334894
21835	32577	3	applied	\N	\N	\N	\N	167641	167641	334895
21835	32578	4	applied	\N	\N	\N	\N	167642	167642	334896
21835	32579	5	applied	\N	\N	\N	\N	167643	167643	334897
21841	32586	0	applied	\N	\N	\N	\N	167774	167774	335028
21841	32587	1	applied	\N	\N	\N	\N	167775	167775	335029
21841	32588	2	applied	\N	\N	\N	\N	167776	167776	335030
21845	32592	0	applied	\N	\N	\N	\N	167789	167789	335043
21845	32593	1	applied	\N	\N	\N	\N	167790	167790	335044
21845	32594	2	applied	\N	\N	\N	\N	167791	167791	335045
21845	32595	3	applied	\N	\N	\N	\N	167792	167792	335046
21845	32596	4	applied	\N	\N	\N	\N	167793	167793	335047
21845	32597	5	applied	\N	\N	\N	\N	167794	167794	335048
21847	32598	0	applied	\N	\N	\N	\N	167920	167920	335174
21847	32600	2	applied	\N	\N	\N	\N	167922	167922	335176
21847	32601	3	applied	\N	\N	\N	\N	167923	167923	335177
21847	32602	4	applied	\N	\N	\N	\N	167924	167924	335178
21847	32603	5	applied	\N	\N	\N	\N	167925	167925	335179
21847	32604	6	applied	\N	\N	\N	\N	167926	167926	335180
21847	32605	7	applied	\N	\N	\N	\N	167927	167927	335181
21847	32606	8	applied	\N	\N	\N	\N	167928	167928	335182
21849	32598	0	applied	\N	\N	\N	\N	167938	167938	335192
21849	32599	1	applied	\N	\N	\N	\N	167939	167939	335193
21849	32600	2	applied	\N	\N	\N	\N	167940	167940	335194
21849	32601	3	applied	\N	\N	\N	\N	167941	167941	335195
21849	32602	4	applied	\N	\N	\N	\N	167942	167942	335196
21849	32603	5	applied	\N	\N	\N	\N	167943	167943	335197
21849	32604	6	applied	\N	\N	\N	\N	167944	167944	335198
21791	32470	1	applied	\N	\N	\N	\N	167112	167112	334366
21791	32471	2	applied	\N	\N	\N	\N	167113	167113	334367
21795	32470	112	applied	\N	\N	\N	\N	167310	167310	334564
21795	32471	113	applied	\N	\N	\N	\N	167311	167311	334565
21795	32472	114	applied	\N	\N	\N	\N	167312	167312	334566
21795	32175	115	applied	\N	\N	\N	\N	167313	167313	334567
21795	32179	116	applied	\N	\N	\N	\N	167314	167314	334568
21795	32474	117	applied	\N	\N	\N	\N	167315	167315	334569
21795	32181	118	applied	\N	\N	\N	\N	167316	167316	334570
21795	32185	119	applied	\N	\N	\N	\N	167317	167317	334571
21795	32189	120	applied	\N	\N	\N	\N	167318	167318	334572
21795	32190	121	applied	\N	\N	\N	\N	167319	167319	334573
21795	32193	122	applied	\N	\N	\N	\N	167320	167320	334574
21795	32201	124	applied	\N	\N	\N	\N	167322	167322	334576
21795	32203	125	applied	\N	\N	\N	\N	167323	167323	334577
21798	32482	0	applied	\N	\N	\N	\N	167450	167450	334704
21798	32485	1	applied	\N	\N	\N	\N	167451	167451	334705
21798	32484	2	applied	\N	\N	\N	\N	167452	167452	334706
21798	32483	3	applied	\N	\N	\N	\N	167453	167453	334707
21798	32486	4	applied	\N	\N	\N	\N	167454	167454	334708
21798	32487	5	applied	\N	\N	\N	\N	167455	167455	334709
21802	32491	0	applied	\N	\N	\N	\N	167465	167465	334719
21802	32492	1	applied	\N	\N	\N	\N	167466	167466	334720
21802	32493	2	applied	\N	\N	\N	\N	167467	167467	334721
21802	32494	3	applied	\N	\N	\N	\N	167468	167468	334722
21802	32495	4	applied	\N	\N	\N	\N	167469	167469	334723
21802	32496	5	applied	\N	\N	\N	\N	167470	167470	334724
21805	32491	0	applied	\N	\N	\N	\N	167483	167483	334737
21805	32492	1	applied	\N	\N	\N	\N	167484	167484	334738
21805	32494	3	applied	\N	\N	\N	\N	167486	167486	334740
21805	32495	4	applied	\N	\N	\N	\N	167487	167487	334741
21805	32496	5	applied	\N	\N	\N	\N	167488	167488	334742
21813	32509	0	applied	\N	\N	\N	\N	167525	167525	334779
21813	32510	1	applied	\N	\N	\N	\N	167526	167526	334780
21813	32511	2	applied	\N	\N	\N	\N	167527	167527	334781
21813	32512	3	applied	\N	\N	\N	\N	167528	167528	334782
21813	32513	4	applied	\N	\N	\N	\N	167529	167529	334783
21813	32514	5	applied	\N	\N	\N	\N	167530	167530	334784
21818	32521	0	applied	\N	\N	\N	\N	167549	167549	334803
21818	32522	1	applied	\N	\N	\N	\N	167550	167550	334804
21818	32523	2	applied	\N	\N	\N	\N	167551	167551	334805
21818	32524	3	applied	\N	\N	\N	\N	167552	167552	334806
21818	32525	4	applied	\N	\N	\N	\N	167553	167553	334807
21818	32526	5	applied	\N	\N	\N	\N	167554	167554	334808
21824	32545	0	applied	\N	\N	\N	\N	167591	167591	334845
21824	32547	2	applied	\N	\N	\N	\N	167593	167593	334847
21824	32548	3	applied	\N	\N	\N	\N	167594	167594	334848
21824	32549	4	applied	\N	\N	\N	\N	167595	167595	334849
21824	32550	5	applied	\N	\N	\N	\N	167596	167596	334850
21832	32572	0	applied	\N	\N	\N	\N	167632	167632	334886
21832	32573	1	applied	\N	\N	\N	\N	167633	167633	334887
21834	32572	0	applied	\N	\N	\N	\N	167636	167636	334890
21834	32573	1	applied	\N	\N	\N	\N	167637	167637	334891
21837	32580	0	applied	\N	\N	\N	\N	167762	167762	335016
21837	32581	1	applied	\N	\N	\N	\N	167763	167763	335017
21837	32582	2	applied	\N	\N	\N	\N	167764	167764	335018
21840	32586	0	applied	\N	\N	\N	\N	167771	167771	335025
21840	32587	1	applied	\N	\N	\N	\N	167772	167772	335026
21840	32588	2	applied	\N	\N	\N	\N	167773	167773	335027
21844	32592	0	applied	\N	\N	\N	\N	167783	167783	335037
21844	32593	1	applied	\N	\N	\N	\N	167784	167784	335038
21844	32595	3	applied	\N	\N	\N	\N	167786	167786	335040
21844	32596	4	applied	\N	\N	\N	\N	167787	167787	335041
21844	32597	5	applied	\N	\N	\N	\N	167788	167788	335042
21846	32320	0	applied	\N	\N	1000000000	\N	167795	167795	335049
21846	32267	1	applied	\N	\N	\N	\N	167796	167796	335050
21846	32254	2	applied	\N	\N	\N	\N	167797	167797	335051
21846	32221	3	applied	\N	\N	\N	\N	167798	167798	335052
21846	32218	4	applied	\N	\N	\N	\N	167799	167799	335053
21846	32232	5	applied	\N	\N	1000000000	\N	167800	167800	335054
21846	31762	6	applied	\N	\N	\N	\N	167801	167801	335055
21846	31767	7	applied	\N	\N	\N	\N	167802	167802	335056
21846	31768	8	applied	\N	\N	\N	\N	167803	167803	335057
21846	31776	9	applied	\N	\N	\N	\N	167804	167804	335058
21846	31779	10	applied	\N	\N	\N	\N	167805	167805	335059
21846	31782	11	applied	\N	\N	\N	\N	167806	167806	335060
21846	31785	12	applied	\N	\N	\N	\N	167807	167807	335061
21846	31792	14	applied	\N	\N	\N	\N	167809	167809	335063
21846	31793	15	applied	\N	\N	\N	\N	167810	167810	335064
21846	32274	16	applied	\N	\N	\N	\N	167811	167811	335065
21846	31798	17	applied	\N	\N	\N	\N	167812	167812	335066
21846	31799	18	applied	\N	\N	\N	\N	167813	167813	335067
21846	31800	19	applied	\N	\N	\N	\N	167814	167814	335068
21846	31808	20	applied	\N	\N	\N	\N	167815	167815	335069
21846	31811	21	applied	\N	\N	\N	\N	167816	167816	335070
21846	31814	22	applied	\N	\N	\N	\N	167817	167817	335071
21846	31815	23	applied	\N	\N	\N	\N	167818	167818	335072
21846	31820	24	applied	\N	\N	\N	\N	167819	167819	335073
21846	31821	25	applied	\N	\N	\N	\N	167820	167820	335074
21846	31827	26	applied	\N	\N	\N	\N	167821	167821	335075
21846	31836	27	applied	\N	\N	\N	\N	167822	167822	335076
21846	31837	28	applied	\N	\N	\N	\N	167823	167823	335077
21846	31844	29	applied	\N	\N	\N	\N	167824	167824	335078
21849	32605	7	applied	\N	\N	\N	\N	167945	167945	335199
21849	32606	8	applied	\N	\N	\N	\N	167946	167946	335200
21861	32628	0	applied	\N	\N	\N	\N	168004	168004	335258
21861	32629	1	applied	\N	\N	\N	\N	168005	168005	335259
21861	32630	2	applied	\N	\N	\N	\N	168006	168006	335260
21866	32639	0	applied	\N	\N	\N	\N	168019	168019	335273
21870	32267	0	applied	\N	\N	\N	\N	168026	168026	335280
21870	32167	1	applied	\N	\N	\N	\N	168027	168027	335281
21870	32254	2	applied	\N	\N	\N	\N	168028	168028	335282
21870	32221	3	applied	\N	\N	\N	\N	168029	168029	335283
21870	32025	4	applied	\N	\N	\N	\N	168030	168030	335284
21870	32218	5	applied	\N	\N	\N	\N	168031	168031	335285
21870	32196	6	applied	\N	\N	\N	\N	168032	168032	335286
21870	32232	7	applied	\N	\N	1000000000	\N	168033	168033	335287
21870	32026	8	applied	\N	\N	\N	\N	168034	168034	335288
21870	32031	9	applied	\N	\N	\N	\N	168035	168035	335289
21870	32034	11	applied	\N	\N	\N	\N	168037	168037	335291
21870	32037	13	applied	\N	\N	\N	\N	168038	168038	335292
21795	32178	110	applied	\N	\N	\N	\N	167308	167308	334562
21795	32373	111	applied	\N	\N	\N	\N	167309	167309	334563
21796	32449	109	applied	\N	\N	\N	\N	167432	167432	334686
21796	32452	110	applied	\N	\N	\N	\N	167433	167433	334687
21796	32454	111	applied	\N	\N	\N	\N	167434	167434	334688
21796	32457	112	applied	\N	\N	\N	\N	167435	167435	334689
21796	32459	113	applied	\N	\N	\N	\N	167436	167436	334690
21796	32464	114	applied	\N	\N	\N	\N	167437	167437	334691
21796	32465	115	applied	\N	\N	\N	\N	167438	167438	334692
21796	32466	116	applied	\N	\N	\N	\N	167439	167439	334693
21796	32473	117	applied	\N	\N	\N	\N	167440	167440	334694
21796	32478	118	applied	\N	\N	\N	\N	167441	167441	334695
21796	32479	119	applied	\N	\N	\N	\N	167442	167442	334696
21796	32484	120	applied	\N	\N	\N	\N	167443	167443	334697
21804	32491	0	applied	\N	\N	\N	\N	167477	167477	334731
21804	32492	1	applied	\N	\N	\N	\N	167478	167478	334732
21804	32494	3	applied	\N	\N	\N	\N	167480	167480	334734
21804	32495	4	applied	\N	\N	\N	\N	167481	167481	334735
21804	32496	5	applied	\N	\N	\N	\N	167482	167482	334736
21807	32497	0	applied	\N	\N	\N	\N	167501	167501	334755
21807	32498	1	applied	\N	\N	\N	\N	167502	167502	334756
21807	32499	2	applied	\N	\N	\N	\N	167503	167503	334757
21807	32500	3	applied	\N	\N	\N	\N	167504	167504	334758
21807	32501	4	applied	\N	\N	\N	\N	167505	167505	334759
21807	32502	5	applied	\N	\N	\N	\N	167506	167506	334760
21817	32515	0	applied	\N	\N	\N	\N	167543	167543	334797
21817	32516	1	applied	\N	\N	\N	\N	167544	167544	334798
21817	32517	2	applied	\N	\N	\N	\N	167545	167545	334799
21817	32518	3	applied	\N	\N	\N	\N	167546	167546	334800
21817	32519	4	applied	\N	\N	\N	\N	167547	167547	334801
21817	32520	5	applied	\N	\N	\N	\N	167548	167548	334802
21823	32533	0	applied	\N	\N	\N	\N	167579	167579	334833
21823	32535	2	applied	\N	\N	\N	\N	167581	167581	334835
21823	32536	3	applied	\N	\N	\N	\N	167582	167582	334836
21823	32537	4	applied	\N	\N	\N	\N	167583	167583	334837
21823	32538	5	applied	\N	\N	\N	\N	167584	167584	334838
21823	32539	6	applied	\N	\N	\N	\N	167585	167585	334839
21823	32540	7	applied	\N	\N	\N	\N	167586	167586	334840
21823	32541	8	applied	\N	\N	\N	\N	167587	167587	334841
21823	32542	9	applied	\N	\N	\N	\N	167588	167588	334842
21823	32543	10	applied	\N	\N	\N	\N	167589	167589	334843
21823	32544	11	applied	\N	\N	\N	\N	167590	167590	334844
21826	32551	0	applied	\N	\N	\N	\N	167603	167603	334857
21826	32552	1	applied	\N	\N	\N	\N	167604	167604	334858
21826	32553	2	applied	\N	\N	\N	\N	167605	167605	334859
21826	32554	3	applied	\N	\N	\N	\N	167606	167606	334860
21826	32555	4	applied	\N	\N	\N	\N	167607	167607	334861
21826	32556	5	applied	\N	\N	\N	\N	167608	167608	334862
21828	32558	1	applied	\N	\N	\N	\N	167616	167616	334870
21831	32563	0	applied	\N	\N	\N	\N	167623	167623	334877
21831	32564	1	applied	\N	\N	\N	\N	167624	167624	334878
21831	32565	2	applied	\N	\N	\N	\N	167625	167625	334879
21831	32566	3	applied	\N	\N	\N	\N	167626	167626	334880
21831	32567	4	applied	\N	\N	\N	\N	167627	167627	334881
21831	32568	5	applied	\N	\N	\N	\N	167628	167628	334882
21831	32569	6	applied	\N	\N	\N	\N	167629	167629	334883
21831	32570	7	applied	\N	\N	\N	\N	167630	167630	334884
21831	32571	8	applied	\N	\N	\N	\N	167631	167631	334885
21836	32320	0	applied	\N	\N	1000000000	\N	167644	167644	334898
21836	32296	1	applied	\N	\N	\N	\N	167645	167645	334899
21836	32299	2	applied	\N	\N	\N	\N	167646	167646	334900
21836	32302	3	applied	\N	\N	\N	\N	167647	167647	334901
21836	32305	4	applied	\N	\N	\N	\N	167648	167648	334902
21836	32306	5	applied	\N	\N	\N	\N	167649	167649	334903
21836	32308	7	applied	\N	\N	\N	\N	167651	167651	334905
21836	32317	8	applied	\N	\N	\N	\N	167652	167652	334906
21836	32321	9	applied	\N	\N	\N	\N	167653	167653	334907
21836	32322	10	applied	\N	\N	\N	\N	167654	167654	334908
21836	32327	11	applied	\N	\N	\N	\N	167655	167655	334909
21836	32330	12	applied	\N	\N	\N	\N	167656	167656	334910
21836	32331	13	applied	\N	\N	\N	\N	167657	167657	334911
21836	32335	14	applied	\N	\N	\N	\N	167658	167658	334912
21836	32338	15	applied	\N	\N	\N	\N	167659	167659	334913
21836	32339	16	applied	\N	\N	\N	\N	167660	167660	334914
21836	32344	17	applied	\N	\N	\N	\N	167661	167661	334915
21836	32345	18	applied	\N	\N	\N	\N	167662	167662	334916
21836	32346	19	applied	\N	\N	\N	\N	167663	167663	334917
21836	32347	20	applied	\N	\N	\N	\N	167664	167664	334918
21836	32356	21	applied	\N	\N	\N	\N	167665	167665	334919
21836	32359	22	applied	\N	\N	\N	\N	167666	167666	334920
21836	32365	24	applied	\N	\N	\N	\N	167668	167668	334922
21836	32381	25	applied	\N	\N	\N	\N	167669	167669	334923
21836	32382	26	applied	\N	\N	\N	\N	167670	167670	334924
21836	32387	27	applied	\N	\N	\N	\N	167671	167671	334925
21836	32390	28	applied	\N	\N	\N	\N	167672	167672	334926
21836	32393	29	applied	\N	\N	\N	\N	167673	167673	334927
21836	32396	30	applied	\N	\N	\N	\N	167674	167674	334928
21836	32399	31	applied	\N	\N	\N	\N	167675	167675	334929
21836	32402	32	applied	\N	\N	\N	\N	167676	167676	334930
21836	32405	33	applied	\N	\N	\N	\N	167677	167677	334931
21836	32408	34	applied	\N	\N	\N	\N	167678	167678	334932
21836	32411	35	applied	\N	\N	\N	\N	167679	167679	334933
21836	32414	36	applied	\N	\N	\N	\N	167680	167680	334934
21836	32417	37	applied	\N	\N	\N	\N	167681	167681	334935
21846	31850	31	applied	\N	\N	\N	\N	167826	167826	335080
21846	31856	32	applied	\N	\N	\N	\N	167827	167827	335081
21846	31860	34	applied	\N	\N	\N	\N	167829	167829	335083
21846	31867	35	applied	\N	\N	\N	\N	167830	167830	335084
21846	31870	36	applied	\N	\N	\N	\N	167831	167831	335085
21846	31874	37	applied	\N	\N	\N	\N	167832	167832	335086
21846	31878	38	applied	\N	\N	\N	\N	167833	167833	335087
21846	31881	39	applied	\N	\N	\N	\N	167834	167834	335088
21846	32275	40	applied	\N	\N	\N	\N	167835	167835	335089
21846	32276	41	applied	\N	\N	\N	\N	167836	167836	335090
21846	32277	42	applied	\N	\N	\N	\N	167837	167837	335091
21846	31884	43	applied	\N	\N	\N	\N	167838	167838	335092
21846	31887	44	applied	\N	\N	\N	\N	167839	167839	335093
21846	31888	45	applied	\N	\N	\N	\N	167840	167840	335094
21846	31894	46	applied	\N	\N	\N	\N	167841	167841	335095
21846	31895	47	applied	\N	\N	\N	\N	167842	167842	335096
21846	31901	48	applied	\N	\N	\N	\N	167843	167843	335097
21846	31904	49	applied	\N	\N	\N	\N	167844	167844	335098
21796	32448	108	applied	\N	\N	\N	\N	167431	167431	334685
21836	32426	40	applied	\N	\N	\N	\N	167684	167684	334938
21836	32429	41	applied	\N	\N	\N	\N	167685	167685	334939
21836	32432	42	applied	\N	\N	\N	\N	167686	167686	334940
21836	32435	43	applied	\N	\N	\N	\N	167687	167687	334941
21836	32436	44	applied	\N	\N	\N	\N	167688	167688	334942
21836	32437	45	applied	\N	\N	\N	\N	167689	167689	334943
21836	32444	46	applied	\N	\N	\N	\N	167690	167690	334944
21836	32446	47	applied	\N	\N	\N	\N	167691	167691	334945
21836	32450	48	applied	\N	\N	\N	\N	167692	167692	334946
21836	32453	49	applied	\N	\N	\N	\N	167693	167693	334947
21836	32456	50	applied	\N	\N	\N	\N	167694	167694	334948
21836	32458	51	applied	\N	\N	\N	\N	167695	167695	334949
21836	32461	52	applied	\N	\N	\N	\N	167696	167696	334950
21836	32462	53	applied	\N	\N	\N	\N	167697	167697	334951
21836	32469	54	applied	\N	\N	\N	\N	167698	167698	334952
21836	32476	55	applied	\N	\N	\N	\N	167699	167699	334953
21839	32586	0	applied	\N	\N	\N	\N	167768	167768	335022
21839	32587	1	applied	\N	\N	\N	\N	167769	167769	335023
21839	32588	2	applied	\N	\N	\N	\N	167770	167770	335024
21843	32589	0	applied	\N	\N	\N	\N	167780	167780	335034
21843	32590	1	applied	\N	\N	\N	\N	167781	167781	335035
21843	32591	2	applied	\N	\N	\N	\N	167782	167782	335036
21848	32598	0	applied	\N	\N	\N	\N	167929	167929	335183
21848	32599	1	applied	\N	\N	\N	\N	167930	167930	335184
21848	32600	2	applied	\N	\N	\N	\N	167931	167931	335185
21848	32601	3	applied	\N	\N	\N	\N	167932	167932	335186
21848	32602	4	applied	\N	\N	\N	\N	167933	167933	335187
21848	32603	5	applied	\N	\N	\N	\N	167934	167934	335188
21848	32604	6	applied	\N	\N	\N	\N	167935	167935	335189
21848	32605	7	applied	\N	\N	\N	\N	167936	167936	335190
21848	32606	8	applied	\N	\N	\N	\N	167937	167937	335191
21850	32607	0	applied	\N	\N	\N	\N	167947	167947	335201
21850	32609	2	applied	\N	\N	\N	\N	167949	167949	335203
21853	32613	0	applied	\N	\N	\N	\N	167956	167956	335210
21853	32614	1	applied	\N	\N	\N	\N	167957	167957	335211
21853	32615	2	applied	\N	\N	\N	\N	167958	167958	335212
21853	32616	3	applied	\N	\N	\N	\N	167959	167959	335213
21853	32617	4	applied	\N	\N	\N	\N	167960	167960	335214
21853	32618	5	applied	\N	\N	\N	\N	167961	167961	335215
21853	32619	6	applied	\N	\N	\N	\N	167962	167962	335216
21853	32620	7	applied	\N	\N	\N	\N	167963	167963	335217
21853	32621	8	applied	\N	\N	\N	\N	167964	167964	335218
21856	32613	0	applied	\N	\N	\N	\N	167983	167983	335237
21856	32614	1	applied	\N	\N	\N	\N	167984	167984	335238
21856	32615	2	applied	\N	\N	\N	\N	167985	167985	335239
21856	32616	3	applied	\N	\N	\N	\N	167986	167986	335240
21856	32617	4	applied	\N	\N	\N	\N	167987	167987	335241
21856	32618	5	applied	\N	\N	\N	\N	167988	167988	335242
21856	32620	7	applied	\N	\N	\N	\N	167990	167990	335244
21856	32621	8	applied	\N	\N	\N	\N	167991	167991	335245
21858	32622	0	applied	\N	\N	\N	\N	167995	167995	335249
21858	32623	1	applied	\N	\N	\N	\N	167996	167996	335250
21858	32624	2	applied	\N	\N	\N	\N	167997	167997	335251
21862	32631	0	applied	\N	\N	\N	\N	168007	168007	335261
21862	32632	1	applied	\N	\N	\N	\N	168008	168008	335262
21862	32633	2	applied	\N	\N	\N	\N	168009	168009	335263
21877	32646	0	applied	\N	\N	\N	\N	168217	168217	335471
21877	32647	1	applied	\N	\N	\N	\N	168218	168218	335472
21877	32648	2	applied	\N	\N	\N	\N	168219	168219	335473
21880	32652	0	applied	\N	\N	\N	\N	168229	168229	335483
21880	32653	1	applied	\N	\N	\N	\N	168230	168230	335484
21880	32654	2	applied	\N	\N	\N	\N	168231	168231	335485
21880	32655	3	applied	\N	\N	\N	\N	168232	168232	335486
21880	32656	4	applied	\N	\N	\N	\N	168233	168233	335487
21882	32658	0	applied	\N	\N	\N	\N	168235	168235	335489
21882	32659	1	applied	\N	\N	\N	\N	168236	168236	335490
21882	32660	2	applied	\N	\N	\N	\N	168237	168237	335491
21882	32661	3	applied	\N	\N	\N	\N	168238	168238	335492
21882	32662	4	applied	\N	\N	\N	\N	168239	168239	335493
21882	32663	5	applied	\N	\N	\N	\N	168240	168240	335494
21887	32673	0	applied	\N	\N	\N	\N	168253	168253	335507
21887	32674	1	applied	\N	\N	\N	\N	168254	168254	335508
21887	32675	2	applied	\N	\N	\N	\N	168255	168255	335509
21892	32681	0	applied	\N	\N	\N	\N	168264	168264	335518
21892	32679	1	applied	\N	\N	\N	\N	168265	168265	335519
21892	32680	2	applied	\N	\N	\N	\N	168266	168266	335520
21896	32685	0	applied	\N	\N	\N	\N	168277	168277	335531
21896	32686	1	applied	\N	\N	\N	\N	168278	168278	335532
21896	32687	2	applied	\N	\N	\N	\N	168279	168279	335533
21901	32694	0	applied	\N	\N	\N	\N	168298	168298	335552
21901	32696	2	applied	\N	\N	\N	\N	168300	168300	335554
21903	32697	0	applied	\N	\N	\N	\N	168304	168304	335558
21903	32698	1	applied	\N	\N	\N	\N	168305	168305	335559
21903	32699	2	applied	\N	\N	\N	\N	168306	168306	335560
21905	32476	0	applied	\N	\N	\N	\N	168310	168310	335564
21905	32477	1	applied	\N	\N	\N	\N	168311	168311	335565
21905	32482	2	applied	\N	\N	\N	\N	168312	168312	335566
21905	32485	4	applied	\N	\N	\N	\N	168313	168313	335567
21905	32488	5	applied	\N	\N	\N	\N	168314	168314	335568
21905	32491	6	applied	\N	\N	\N	\N	168315	168315	335569
21905	32492	7	applied	\N	\N	\N	\N	168316	168316	335570
21905	32497	8	applied	\N	\N	\N	\N	168317	168317	335571
21905	32498	9	applied	\N	\N	\N	\N	168318	168318	335572
21905	32503	10	applied	\N	\N	\N	\N	168319	168319	335573
21905	32506	11	applied	\N	\N	\N	\N	168320	168320	335574
21905	32509	12	applied	\N	\N	\N	\N	168321	168321	335575
21905	32515	14	applied	\N	\N	\N	\N	168323	168323	335577
21905	32516	15	applied	\N	\N	\N	\N	168324	168324	335578
21905	32521	16	applied	\N	\N	\N	\N	168325	168325	335579
21905	32522	17	applied	\N	\N	\N	\N	168326	168326	335580
21905	32527	18	applied	\N	\N	\N	\N	168327	168327	335581
21905	32528	19	applied	\N	\N	\N	\N	168328	168328	335582
21905	32533	20	applied	\N	\N	\N	\N	168329	168329	335583
21905	32534	21	applied	\N	\N	\N	\N	168330	168330	335584
21905	32535	22	applied	\N	\N	\N	\N	168331	168331	335585
21905	32536	23	applied	\N	\N	\N	\N	168332	168332	335586
21905	32545	24	applied	\N	\N	\N	\N	168333	168333	335587
21905	32546	25	applied	\N	\N	\N	\N	168334	168334	335588
21905	32551	26	applied	\N	\N	\N	\N	168335	168335	335589
21905	32552	27	applied	\N	\N	\N	\N	168336	168336	335590
21829	32558	5	applied	\N	\N	\N	\N	167622	167622	334876
21836	32420	38	applied	\N	\N	\N	\N	167682	167682	334936
21836	32492	61	applied	\N	\N	\N	\N	167705	167705	334959
21836	32497	62	applied	\N	\N	\N	\N	167706	167706	334960
21836	32498	63	applied	\N	\N	\N	\N	167707	167707	334961
21836	32503	64	applied	\N	\N	\N	\N	167708	167708	334962
21836	32506	65	applied	\N	\N	\N	\N	167709	167709	334963
21836	32509	66	applied	\N	\N	\N	\N	167710	167710	334964
21836	32510	67	applied	\N	\N	\N	\N	167711	167711	334965
21836	32515	68	applied	\N	\N	\N	\N	167712	167712	334966
21836	32516	69	applied	\N	\N	\N	\N	167713	167713	334967
21836	32521	70	applied	\N	\N	\N	\N	167714	167714	334968
21836	32522	71	applied	\N	\N	\N	\N	167715	167715	334969
21836	32527	72	applied	\N	\N	\N	\N	167716	167716	334970
21836	32528	73	applied	\N	\N	\N	\N	167717	167717	334971
21836	32533	74	applied	\N	\N	\N	\N	167718	167718	334972
21836	32535	76	applied	\N	\N	\N	\N	167720	167720	334974
21836	32536	77	applied	\N	\N	\N	\N	167721	167721	334975
21836	32545	78	applied	\N	\N	\N	\N	167722	167722	334976
21836	32546	79	applied	\N	\N	\N	\N	167723	167723	334977
21836	32551	80	applied	\N	\N	\N	\N	167724	167724	334978
21836	32552	81	applied	\N	\N	\N	\N	167725	167725	334979
21836	32559	82	applied	\N	\N	\N	\N	167726	167726	334980
21836	32560	83	applied	\N	\N	\N	\N	167727	167727	334981
21836	32563	84	applied	\N	\N	\N	\N	167728	167728	334982
21836	32564	85	applied	\N	\N	\N	\N	167729	167729	334983
21836	32565	86	applied	\N	\N	\N	\N	167730	167730	334984
21836	32572	87	applied	\N	\N	\N	\N	167731	167731	334985
21836	32574	88	applied	\N	\N	\N	\N	167732	167732	334986
21836	32575	89	applied	\N	\N	\N	\N	167733	167733	334987
21836	32580	90	applied	\N	\N	\N	\N	167734	167734	334988
21836	32373	91	applied	\N	\N	\N	\N	167735	167735	334989
21836	32471	93	applied	\N	\N	\N	\N	167737	167737	334991
21836	32472	94	applied	\N	\N	\N	\N	167738	167738	334992
21836	32474	95	applied	\N	\N	\N	\N	167739	167739	334993
21836	32294	96	applied	\N	\N	\N	\N	167740	167740	334994
21836	32295	97	applied	\N	\N	\N	\N	167741	167741	334995
21836	32297	98	applied	\N	\N	\N	\N	167742	167742	334996
21836	32301	99	applied	\N	\N	\N	\N	167743	167743	334997
21836	32298	100	applied	\N	\N	\N	\N	167744	167744	334998
21836	32300	101	applied	\N	\N	\N	\N	167745	167745	334999
21836	32303	102	applied	\N	\N	\N	\N	167746	167746	335000
21836	32313	103	applied	\N	\N	\N	\N	167747	167747	335001
21836	32314	104	applied	\N	\N	\N	\N	167748	167748	335002
21836	32315	105	applied	\N	\N	\N	\N	167749	167749	335003
21836	32316	106	applied	\N	\N	\N	\N	167750	167750	335004
21836	32318	107	applied	\N	\N	\N	\N	167751	167751	335005
21836	32323	108	applied	\N	\N	\N	\N	167752	167752	335006
21836	32329	110	applied	\N	\N	\N	\N	167754	167754	335008
21836	32334	111	applied	\N	\N	\N	\N	167755	167755	335009
21836	32337	113	applied	\N	\N	\N	\N	167756	167756	335010
21836	32341	114	applied	\N	\N	\N	\N	167757	167757	335011
21836	32342	115	applied	\N	\N	\N	\N	167758	167758	335012
21836	32349	116	applied	\N	\N	\N	\N	167759	167759	335013
21836	32350	117	applied	\N	\N	\N	\N	167760	167760	335014
21836	32351	118	applied	\N	\N	\N	\N	167761	167761	335015
21838	32583	0	applied	\N	\N	\N	\N	167765	167765	335019
21838	32584	1	applied	\N	\N	\N	\N	167766	167766	335020
21838	32585	2	applied	\N	\N	\N	\N	167767	167767	335021
21842	32586	0	applied	\N	\N	\N	\N	167777	167777	335031
21842	32587	1	applied	\N	\N	\N	\N	167778	167778	335032
21842	32588	2	applied	\N	\N	\N	\N	167779	167779	335033
21852	32610	0	applied	\N	\N	\N	\N	167953	167953	335207
21852	32611	1	applied	\N	\N	\N	\N	167954	167954	335208
21855	32613	0	applied	\N	\N	\N	\N	167974	167974	335228
21855	32614	1	applied	\N	\N	\N	\N	167975	167975	335229
21855	32615	2	applied	\N	\N	\N	\N	167976	167976	335230
21855	32616	3	applied	\N	\N	\N	\N	167977	167977	335231
21855	32617	4	applied	\N	\N	\N	\N	167978	167978	335232
21855	32618	5	applied	\N	\N	\N	\N	167979	167979	335233
21855	32619	6	applied	\N	\N	\N	\N	167980	167980	335234
21855	32620	7	applied	\N	\N	\N	\N	167981	167981	335235
21855	32621	8	applied	\N	\N	\N	\N	167982	167982	335236
21857	32622	0	applied	\N	\N	\N	\N	167992	167992	335246
21857	32623	1	applied	\N	\N	\N	\N	167993	167993	335247
21857	32624	2	applied	\N	\N	\N	\N	167994	167994	335248
21859	32622	0	applied	\N	\N	\N	\N	167998	167998	335252
21859	32623	1	applied	\N	\N	\N	\N	167999	167999	335253
21859	32624	2	applied	\N	\N	\N	\N	168000	168000	335254
21864	32637	0	applied	\N	\N	\N	\N	168013	168013	335267
21864	32639	2	applied	\N	\N	\N	\N	168015	168015	335269
21867	32637	0	applied	\N	\N	\N	\N	168020	168020	335274
21867	32638	1	applied	\N	\N	\N	\N	168021	168021	335275
21867	32639	2	applied	\N	\N	\N	\N	168022	168022	335276
21871	32320	0	applied	\N	\N	1000000000	\N	168148	168148	335402
21871	32287	1	applied	\N	\N	\N	\N	168149	168149	335403
21871	32290	2	applied	\N	\N	\N	\N	168150	168150	335404
21871	32291	3	applied	\N	\N	\N	\N	168151	168151	335405
21871	32296	4	applied	\N	\N	\N	\N	168152	168152	335406
21871	32299	5	applied	\N	\N	\N	\N	168153	168153	335407
21871	32302	6	applied	\N	\N	\N	\N	168154	168154	335408
21871	32305	7	applied	\N	\N	\N	\N	168155	168155	335409
21871	32306	8	applied	\N	\N	\N	\N	168156	168156	335410
21871	32307	9	applied	\N	\N	\N	\N	168157	168157	335411
21905	32559	28	applied	\N	\N	\N	\N	168337	168337	335591
21905	32560	29	applied	\N	\N	\N	\N	168338	168338	335592
21905	32564	31	applied	\N	\N	\N	\N	168340	168340	335594
21905	32565	32	applied	\N	\N	\N	\N	168341	168341	335595
21905	32572	33	applied	\N	\N	\N	\N	168342	168342	335596
21905	32574	34	applied	\N	\N	\N	\N	168343	168343	335597
21905	32575	35	applied	\N	\N	\N	\N	168344	168344	335598
21905	32580	36	applied	\N	\N	\N	\N	168345	168345	335599
21905	32583	37	applied	\N	\N	\N	\N	168346	168346	335600
21905	32586	38	applied	\N	\N	\N	\N	168347	168347	335601
21905	32589	39	applied	\N	\N	\N	\N	168348	168348	335602
21905	32592	40	applied	\N	\N	\N	\N	168349	168349	335603
21905	32593	41	applied	\N	\N	\N	\N	168350	168350	335604
21905	32598	42	applied	\N	\N	\N	\N	168351	168351	335605
21905	32599	43	applied	\N	\N	\N	\N	168352	168352	335606
21905	32600	44	applied	\N	\N	\N	\N	168353	168353	335607
21905	32607	45	applied	\N	\N	\N	\N	168354	168354	335608
21905	32610	46	applied	\N	\N	\N	\N	168355	168355	335609
21836	32491	60	applied	\N	\N	\N	\N	167704	167704	334958
21846	31920	54	applied	\N	\N	\N	\N	167849	167849	335103
21846	31921	55	applied	\N	\N	\N	\N	167850	167850	335104
21846	31922	56	applied	\N	\N	\N	\N	167851	167851	335105
21846	31930	57	applied	\N	\N	\N	\N	167852	167852	335106
21846	31934	58	applied	\N	\N	\N	\N	167853	167853	335107
21846	31936	59	applied	\N	\N	\N	\N	167854	167854	335108
21846	31937	60	applied	\N	\N	\N	\N	167855	167855	335109
21846	31943	61	applied	\N	\N	\N	\N	167856	167856	335110
21846	31946	62	applied	\N	\N	\N	\N	167857	167857	335111
21846	31949	63	applied	\N	\N	\N	\N	167858	167858	335112
21846	31953	64	applied	\N	\N	\N	\N	167859	167859	335113
21846	31955	65	applied	\N	\N	\N	\N	167860	167860	335114
21846	31957	66	applied	\N	\N	\N	\N	167861	167861	335115
21846	31959	67	applied	\N	\N	\N	\N	167862	167862	335116
21846	31961	68	applied	\N	\N	\N	\N	167863	167863	335117
21846	31964	69	applied	\N	\N	\N	\N	167864	167864	335118
21846	31968	71	applied	\N	\N	\N	\N	167866	167866	335120
21846	31970	72	applied	\N	\N	\N	\N	167867	167867	335121
21846	31971	73	applied	\N	\N	\N	\N	167868	167868	335122
21846	31974	74	applied	\N	\N	\N	\N	167869	167869	335123
21846	31976	75	applied	\N	\N	\N	\N	167870	167870	335124
21846	31977	76	applied	\N	\N	\N	\N	167871	167871	335125
21846	31978	77	applied	\N	\N	\N	\N	167872	167872	335126
21846	31982	78	applied	\N	\N	\N	\N	167873	167873	335127
21846	31986	79	applied	\N	\N	\N	\N	167874	167874	335128
21846	31989	80	applied	\N	\N	\N	\N	167875	167875	335129
21846	31990	81	applied	\N	\N	\N	\N	167876	167876	335130
21846	31996	82	applied	\N	\N	\N	\N	167877	167877	335131
21846	31997	83	applied	\N	\N	\N	\N	167878	167878	335132
21846	32002	84	applied	\N	\N	\N	\N	167879	167879	335133
21846	32006	85	applied	\N	\N	\N	\N	167880	167880	335134
21846	32009	86	applied	\N	\N	\N	\N	167881	167881	335135
21846	32015	88	applied	\N	\N	\N	\N	167883	167883	335137
21846	32019	89	applied	\N	\N	\N	\N	167884	167884	335138
21846	32022	90	applied	\N	\N	\N	\N	167885	167885	335139
21846	32025	92	applied	\N	\N	\N	\N	167886	167886	335140
21846	32026	93	applied	\N	\N	\N	\N	167887	167887	335141
21846	32031	94	applied	\N	\N	\N	\N	167888	167888	335142
21846	32034	95	applied	\N	\N	\N	\N	167889	167889	335143
21846	32037	96	applied	\N	\N	\N	\N	167890	167890	335144
21846	32040	97	applied	\N	\N	\N	\N	167891	167891	335145
21846	32041	98	applied	\N	\N	\N	\N	167892	167892	335146
21846	32042	99	applied	\N	\N	\N	\N	167893	167893	335147
21846	32049	100	applied	\N	\N	\N	\N	167894	167894	335148
21846	32059	101	applied	\N	\N	\N	\N	167895	167895	335149
21846	32062	102	applied	\N	\N	\N	\N	167896	167896	335150
21846	32065	103	applied	\N	\N	\N	\N	167897	167897	335151
21846	32068	104	applied	\N	\N	\N	\N	167898	167898	335152
21846	32074	106	applied	\N	\N	\N	\N	167900	167900	335154
21846	32077	107	applied	\N	\N	\N	\N	167901	167901	335155
21846	32080	108	applied	\N	\N	\N	\N	167902	167902	335156
21846	32083	109	applied	\N	\N	\N	\N	167903	167903	335157
21846	32086	110	applied	\N	\N	\N	\N	167904	167904	335158
21846	32089	111	applied	\N	\N	\N	\N	167905	167905	335159
21846	32092	112	applied	\N	\N	\N	\N	167906	167906	335160
21846	32093	113	applied	\N	\N	\N	\N	167907	167907	335161
21846	32094	114	applied	\N	\N	\N	\N	167908	167908	335162
21846	32102	115	applied	\N	\N	\N	\N	167909	167909	335163
21846	32105	116	applied	\N	\N	\N	\N	167910	167910	335164
21846	32108	117	applied	\N	\N	\N	\N	167911	167911	335165
21846	32111	118	applied	\N	\N	\N	\N	167912	167912	335166
21846	32112	119	applied	\N	\N	\N	\N	167913	167913	335167
21846	32118	120	applied	\N	\N	\N	\N	167914	167914	335168
21846	32119	121	applied	\N	\N	\N	\N	167915	167915	335169
21846	32127	123	applied	\N	\N	\N	\N	167917	167917	335171
21846	32130	124	applied	\N	\N	\N	\N	167918	167918	335172
21846	32133	125	applied	\N	\N	\N	\N	167919	167919	335173
21851	32607	0	applied	\N	\N	\N	\N	167950	167950	335204
21851	32608	1	applied	\N	\N	\N	\N	167951	167951	335205
21851	32609	2	applied	\N	\N	\N	\N	167952	167952	335206
21854	32613	0	applied	\N	\N	\N	\N	167965	167965	335219
21854	32614	1	applied	\N	\N	\N	\N	167966	167966	335220
21854	32615	2	applied	\N	\N	\N	\N	167967	167967	335221
21854	32616	3	applied	\N	\N	\N	\N	167968	167968	335222
21854	32617	4	applied	\N	\N	\N	\N	167969	167969	335223
21854	32618	5	applied	\N	\N	\N	\N	167970	167970	335224
21854	32619	6	applied	\N	\N	\N	\N	167971	167971	335225
21854	32620	7	applied	\N	\N	\N	\N	167972	167972	335226
21854	32621	8	applied	\N	\N	\N	\N	167973	167973	335227
21860	32625	0	applied	\N	\N	\N	\N	168001	168001	335255
21860	32627	2	applied	\N	\N	\N	\N	168003	168003	335257
21863	32634	0	applied	\N	\N	\N	\N	168010	168010	335264
21863	32635	1	applied	\N	\N	\N	\N	168011	168011	335265
21863	32636	2	applied	\N	\N	\N	\N	168012	168012	335266
21865	32637	0	applied	\N	\N	\N	\N	168016	168016	335270
21865	32638	1	applied	\N	\N	\N	\N	168017	168017	335271
21865	32639	2	applied	\N	\N	\N	\N	168018	168018	335272
21868	32637	0	applied	\N	\N	\N	\N	168023	168023	335277
21868	32638	1	applied	\N	\N	\N	\N	168024	168024	335278
21868	32639	2	applied	\N	\N	\N	\N	168025	168025	335279
21871	32308	10	applied	\N	\N	\N	\N	168158	168158	335412
21871	32317	13	applied	\N	\N	\N	\N	168159	168159	335413
21871	32321	14	applied	\N	\N	\N	\N	168160	168160	335414
21871	32322	15	applied	\N	\N	\N	\N	168161	168161	335415
21871	32327	16	applied	\N	\N	\N	\N	168162	168162	335416
21871	32330	17	applied	\N	\N	\N	\N	168163	168163	335417
21871	32335	19	applied	\N	\N	\N	\N	168165	168165	335419
21871	32338	20	applied	\N	\N	\N	\N	168166	168166	335420
21871	32339	21	applied	\N	\N	\N	\N	168167	168167	335421
21871	32344	22	applied	\N	\N	\N	\N	168168	168168	335422
21871	32345	23	applied	\N	\N	\N	\N	168169	168169	335423
21871	32346	24	applied	\N	\N	\N	\N	168170	168170	335424
21871	32347	25	applied	\N	\N	\N	\N	168171	168171	335425
21871	32356	26	applied	\N	\N	\N	\N	168172	168172	335426
21871	32359	27	applied	\N	\N	\N	\N	168173	168173	335427
21871	32362	28	applied	\N	\N	\N	\N	168174	168174	335428
21871	32365	29	applied	\N	\N	\N	\N	168175	168175	335429
21871	32381	30	applied	\N	\N	\N	\N	168176	168176	335430
21873	32637	0	applied	\N	\N	\N	\N	168180	168180	335434
21873	32640	1	applied	\N	\N	\N	\N	168181	168181	335435
21846	31908	51	applied	\N	\N	\N	\N	167846	167846	335100
21846	31909	52	applied	\N	\N	\N	\N	167847	167847	335101
21870	32040	18	applied	\N	\N	\N	\N	168043	168043	335297
21870	32041	19	applied	\N	\N	\N	\N	168044	168044	335298
21870	32042	20	applied	\N	\N	\N	\N	168045	168045	335299
21870	32049	21	applied	\N	\N	\N	\N	168046	168046	335300
21870	32059	22	applied	\N	\N	\N	\N	168047	168047	335301
21870	32062	23	applied	\N	\N	\N	\N	168048	168048	335302
21870	32065	24	applied	\N	\N	\N	\N	168049	168049	335303
21870	32068	25	applied	\N	\N	\N	\N	168050	168050	335304
21870	32071	26	applied	\N	\N	\N	\N	168051	168051	335305
21870	32074	27	applied	\N	\N	\N	\N	168052	168052	335306
21870	32077	28	applied	\N	\N	\N	\N	168053	168053	335307
21870	32080	29	applied	\N	\N	\N	\N	168054	168054	335308
21870	32083	30	applied	\N	\N	\N	\N	168055	168055	335309
21870	32086	31	applied	\N	\N	\N	\N	168056	168056	335310
21870	32089	32	applied	\N	\N	\N	\N	168057	168057	335311
21870	32092	33	applied	\N	\N	\N	\N	168058	168058	335312
21870	32094	35	applied	\N	\N	\N	\N	168060	168060	335314
21870	32102	36	applied	\N	\N	\N	\N	168061	168061	335315
21870	32105	37	applied	\N	\N	\N	\N	168062	168062	335316
21870	32108	38	applied	\N	\N	\N	\N	168063	168063	335317
21870	32111	39	applied	\N	\N	\N	\N	168064	168064	335318
21870	32112	40	applied	\N	\N	\N	\N	168065	168065	335319
21870	32118	41	applied	\N	\N	\N	\N	168066	168066	335320
21870	32119	42	applied	\N	\N	\N	\N	168067	168067	335321
21870	32124	43	applied	\N	\N	\N	\N	168068	168068	335322
21870	32127	44	applied	\N	\N	\N	\N	168069	168069	335323
21870	32130	45	applied	\N	\N	\N	\N	168070	168070	335324
21870	32133	46	applied	\N	\N	\N	\N	168071	168071	335325
21870	32136	47	applied	\N	\N	\N	\N	168072	168072	335326
21870	32139	48	applied	\N	\N	\N	\N	168073	168073	335327
21870	32142	49	applied	\N	\N	\N	\N	168074	168074	335328
21870	32145	50	applied	\N	\N	\N	\N	168075	168075	335329
21870	32149	52	applied	\N	\N	\N	\N	168077	168077	335331
21870	32154	53	applied	\N	\N	\N	\N	168078	168078	335332
21870	32157	54	applied	\N	\N	\N	\N	168079	168079	335333
21870	32158	55	applied	\N	\N	\N	\N	168080	168080	335334
21870	32164	56	applied	\N	\N	\N	\N	168081	168081	335335
21870	32168	57	applied	\N	\N	\N	\N	168082	168082	335336
21870	32171	58	applied	\N	\N	\N	\N	168083	168083	335337
21870	32177	59	applied	\N	\N	\N	\N	168084	168084	335338
21870	32180	60	applied	\N	\N	\N	\N	168085	168085	335339
21870	32183	61	applied	\N	\N	\N	\N	168086	168086	335340
21870	32186	62	applied	\N	\N	\N	\N	168087	168087	335341
21870	32191	63	applied	\N	\N	\N	\N	168088	168088	335342
21870	32194	64	applied	\N	\N	\N	\N	168089	168089	335343
21870	32195	65	applied	\N	\N	\N	\N	168090	168090	335344
21870	32202	66	applied	\N	\N	\N	\N	168091	168091	335345
21870	32205	67	applied	\N	\N	\N	\N	168092	168092	335346
21870	32207	69	applied	\N	\N	\N	\N	168094	168094	335348
21870	32214	70	applied	\N	\N	\N	\N	168095	168095	335349
21870	32217	71	applied	\N	\N	\N	\N	168096	168096	335350
21870	32222	72	applied	\N	\N	\N	\N	168097	168097	335351
21870	32225	73	applied	\N	\N	\N	\N	168098	168098	335352
21870	32228	74	applied	\N	\N	\N	\N	168099	168099	335353
21870	32231	75	applied	\N	\N	\N	\N	168100	168100	335354
21870	32235	76	applied	\N	\N	\N	\N	168101	168101	335355
21870	32239	77	applied	\N	\N	\N	\N	168102	168102	335356
21870	32242	78	applied	\N	\N	\N	\N	168103	168103	335357
21870	32243	79	applied	\N	\N	\N	\N	168104	168104	335358
21870	32248	80	applied	\N	\N	\N	\N	168105	168105	335359
21870	32251	81	applied	\N	\N	\N	\N	168106	168106	335360
21870	32255	82	applied	\N	\N	\N	\N	168107	168107	335361
21870	32258	83	applied	\N	\N	\N	\N	168108	168108	335362
21870	32261	84	applied	\N	\N	\N	\N	168109	168109	335363
21870	32268	86	applied	\N	\N	\N	\N	168111	168111	335365
21870	32271	87	applied	\N	\N	\N	\N	168112	168112	335366
21870	32278	88	applied	\N	\N	\N	\N	168113	168113	335367
21870	32279	89	applied	\N	\N	\N	\N	168114	168114	335368
21870	32280	90	applied	\N	\N	\N	\N	168115	168115	335369
21870	32275	91	applied	\N	\N	\N	\N	168116	168116	335370
21870	32276	92	applied	\N	\N	\N	\N	168117	168117	335371
21870	32277	93	applied	\N	\N	\N	\N	168118	168118	335372
21870	32027	94	applied	\N	\N	\N	\N	168119	168119	335373
21870	32028	95	applied	\N	\N	\N	\N	168120	168120	335374
21870	32032	96	applied	\N	\N	\N	\N	168121	168121	335375
21870	32035	97	applied	\N	\N	\N	\N	168122	168122	335376
21870	32038	98	applied	\N	\N	\N	\N	168123	168123	335377
21870	32029	99	applied	\N	\N	\N	\N	168124	168124	335378
21870	32030	100	applied	\N	\N	\N	\N	168125	168125	335379
21870	32033	101	applied	\N	\N	\N	\N	168126	168126	335380
21870	32046	103	applied	\N	\N	\N	\N	168128	168128	335382
21870	32047	104	applied	\N	\N	\N	\N	168129	168129	335383
21870	32048	105	applied	\N	\N	\N	\N	168130	168130	335384
21870	32050	106	applied	\N	\N	\N	\N	168131	168131	335385
21870	32053	107	applied	\N	\N	\N	\N	168132	168132	335386
21870	32056	108	applied	\N	\N	\N	\N	168133	168133	335387
21870	32058	109	applied	\N	\N	\N	\N	168134	168134	335388
21870	32060	110	applied	\N	\N	\N	\N	168135	168135	335389
21870	32063	111	applied	\N	\N	\N	\N	168136	168136	335390
21870	32039	112	applied	\N	\N	\N	\N	168137	168137	335391
21870	32043	113	applied	\N	\N	\N	\N	168138	168138	335392
21870	32044	114	applied	\N	\N	\N	\N	168139	168139	335393
21873	32641	2	applied	\N	\N	\N	\N	168182	168182	335436
21873	32638	3	applied	\N	\N	\N	\N	168183	168183	335437
21873	32642	4	applied	\N	\N	\N	\N	168184	168184	335438
21873	32643	5	applied	\N	\N	\N	\N	168185	168185	335439
21873	32645	7	applied	\N	\N	\N	\N	168187	168187	335441
21875	32628	0	applied	\N	\N	\N	\N	168196	168196	335450
21875	32631	1	applied	\N	\N	\N	\N	168197	168197	335451
21875	32634	2	applied	\N	\N	\N	\N	168198	168198	335452
21875	32637	3	applied	\N	\N	\N	\N	168199	168199	335453
21875	32640	4	applied	\N	\N	\N	\N	168200	168200	335454
21875	32641	5	applied	\N	\N	\N	\N	168201	168201	335455
21875	32629	6	applied	\N	\N	\N	\N	168202	168202	335456
21875	32632	7	applied	\N	\N	\N	\N	168203	168203	335457
21875	32630	8	applied	\N	\N	\N	\N	168204	168204	335458
21875	32636	9	applied	\N	\N	\N	\N	168205	168205	335459
21875	32638	10	applied	\N	\N	\N	\N	168206	168206	335460
21875	32642	11	applied	\N	\N	\N	\N	168207	168207	335461
21875	32643	12	applied	\N	\N	\N	\N	168208	168208	335462
21870	32173	15	applied	\N	\N	\N	\N	168040	168040	335294
21870	32174	16	applied	\N	\N	\N	\N	168041	168041	335295
21870	32055	119	applied	\N	\N	\N	\N	168144	168144	335398
21870	32057	120	applied	\N	\N	\N	\N	168145	168145	335399
21870	32061	121	applied	\N	\N	\N	\N	168146	168146	335400
21870	32064	122	applied	\N	\N	\N	\N	168147	168147	335401
21871	32382	31	applied	\N	\N	\N	\N	168177	168177	335431
21871	32387	32	applied	\N	\N	\N	\N	168178	168178	335432
21871	32390	33	applied	\N	\N	\N	\N	168179	168179	335433
21874	32637	0	applied	\N	\N	\N	\N	168188	168188	335442
21874	32640	1	applied	\N	\N	\N	\N	168189	168189	335443
21874	32641	2	applied	\N	\N	\N	\N	168190	168190	335444
21874	32638	3	applied	\N	\N	\N	\N	168191	168191	335445
21874	32642	4	applied	\N	\N	\N	\N	168192	168192	335446
21874	32643	5	applied	\N	\N	\N	\N	168193	168193	335447
21874	32644	6	applied	\N	\N	\N	\N	168194	168194	335448
21874	32645	7	applied	\N	\N	\N	\N	168195	168195	335449
21876	32646	0	applied	\N	\N	\N	\N	168214	168214	335468
21876	32648	2	applied	\N	\N	\N	\N	168216	168216	335470
21879	32652	0	applied	\N	\N	\N	\N	168223	168223	335477
21879	32653	1	applied	\N	\N	\N	\N	168224	168224	335478
21879	32654	2	applied	\N	\N	\N	\N	168225	168225	335479
21879	32655	3	applied	\N	\N	\N	\N	168226	168226	335480
21879	32656	4	applied	\N	\N	\N	\N	168227	168227	335481
21879	32657	5	applied	\N	\N	\N	\N	168228	168228	335482
21891	32679	0	applied	\N	\N	\N	\N	168262	168262	335516
21891	32680	1	applied	\N	\N	\N	\N	168263	168263	335517
21894	32681	0	applied	\N	\N	\N	\N	168270	168270	335524
21894	32679	1	applied	\N	\N	\N	\N	168271	168271	335525
21894	32680	2	applied	\N	\N	\N	\N	168272	168272	335526
21898	32688	0	applied	\N	\N	\N	\N	168283	168283	335537
21898	32689	1	applied	\N	\N	\N	\N	168284	168284	335538
21898	32690	2	applied	\N	\N	\N	\N	168285	168285	335539
21898	32691	3	applied	\N	\N	\N	\N	168286	168286	335540
21898	32693	5	applied	\N	\N	\N	\N	168288	168288	335542
21920	32731	0	applied	\N	\N	\N	\N	168492	168492	335746
21920	32732	1	applied	\N	\N	\N	\N	168493	168493	335747
21920	32733	2	applied	\N	\N	\N	\N	168494	168494	335748
21920	32734	3	applied	\N	\N	\N	\N	168495	168495	335749
21920	32735	4	applied	\N	\N	\N	\N	168496	168496	335750
21920	32736	5	applied	\N	\N	\N	\N	168497	168497	335751
21926	32761	0	applied	\N	\N	\N	\N	168529	168529	335783
21926	32762	1	applied	\N	\N	\N	\N	168530	168530	335784
21926	32763	2	applied	\N	\N	\N	\N	168531	168531	335785
21930	32761	0	applied	\N	\N	\N	\N	168540	168540	335794
21930	32762	1	applied	\N	\N	\N	\N	168541	168541	335795
21930	32763	2	applied	\N	\N	\N	\N	168542	168542	335796
21933	32769	0	applied	\N	\N	\N	\N	168550	168550	335804
21933	32770	1	applied	\N	\N	\N	\N	168551	168551	335805
21938	32771	0	applied	\N	\N	\N	\N	168560	168560	335814
21938	32773	2	applied	\N	\N	\N	\N	168562	168562	335816
21939	32771	0	applied	\N	\N	\N	\N	168563	168563	335817
21939	32772	1	applied	\N	\N	\N	\N	168564	168564	335818
21939	32773	2	applied	\N	\N	\N	\N	168565	168565	335819
21941	32774	0	applied	\N	\N	\N	\N	168569	168569	335823
21941	32775	1	applied	\N	\N	\N	\N	168570	168570	335824
21941	32776	2	applied	\N	\N	\N	\N	168571	168571	335825
21944	32784	0	applied	\N	\N	\N	\N	168582	168582	335835
21944	32785	1	applied	\N	\N	\N	\N	168583	168583	335836
21944	32786	2	applied	\N	\N	\N	\N	168584	168584	335837
21947	32787	0	applied	\N	\N	\N	\N	168591	168591	335844
21947	32788	1	applied	\N	\N	\N	\N	168592	168592	335845
21947	32789	2	applied	\N	\N	\N	\N	168593	168593	335846
21951	32793	0	applied	\N	\N	\N	\N	168606	168606	335859
21951	32794	1	applied	\N	\N	\N	\N	168607	168607	335860
21951	32795	2	applied	\N	\N	\N	\N	168608	168608	335861
21951	32797	4	applied	\N	\N	\N	\N	168610	168610	335863
21951	32798	5	applied	\N	\N	\N	\N	168611	168611	335864
21951	32799	6	applied	\N	\N	\N	\N	168612	168612	335865
21951	32800	7	applied	\N	\N	\N	\N	168613	168613	335866
21951	32801	8	applied	\N	\N	\N	\N	168614	168614	335867
21957	32814	0	applied	\N	\N	\N	\N	168645	168645	335898
21957	32815	1	applied	\N	\N	\N	\N	168646	168646	335899
21957	32816	2	applied	\N	\N	\N	\N	168647	168647	335900
21957	32817	3	applied	\N	\N	\N	\N	168648	168648	335901
21957	32818	4	applied	\N	\N	\N	\N	168649	168649	335902
21957	32819	5	applied	\N	\N	\N	\N	168650	168650	335903
21957	32820	6	applied	\N	\N	\N	\N	168651	168651	335904
21957	32821	7	applied	\N	\N	\N	\N	168652	168652	335905
21957	32822	8	applied	\N	\N	\N	\N	168653	168653	335906
21959	32814	0	applied	\N	\N	\N	\N	168663	168663	335916
21959	32815	1	applied	\N	\N	\N	\N	168664	168664	335917
21959	32817	3	applied	\N	\N	\N	\N	168666	168666	335919
21959	32818	4	applied	\N	\N	\N	\N	168667	168667	335920
21959	32819	5	applied	\N	\N	\N	\N	168668	168668	335921
21959	32820	6	applied	\N	\N	\N	\N	168669	168669	335922
21959	32821	7	applied	\N	\N	\N	\N	168670	168670	335923
21959	32822	8	applied	\N	\N	\N	\N	168671	168671	335924
21961	32823	0	applied	\N	\N	\N	\N	168675	168675	335928
21961	32824	1	applied	\N	\N	\N	\N	168676	168676	335929
21961	32825	2	applied	\N	\N	\N	\N	168677	168677	335930
21972	32829	0	applied	\N	\N	\N	\N	168701	168701	335953
21972	32830	1	applied	\N	\N	\N	\N	168702	168702	335954
21972	32831	2	applied	\N	\N	\N	\N	168703	168703	335955
21972	32832	3	applied	\N	\N	\N	\N	168704	168704	335956
21972	32833	4	applied	\N	\N	\N	\N	168705	168705	335957
21972	32834	5	applied	\N	\N	\N	\N	168706	168706	335958
21979	32835	0	applied	\N	\N	\N	\N	168735	168735	335987
21979	32837	2	applied	\N	\N	\N	\N	168737	168737	335989
21980	32835	0	applied	\N	\N	\N	\N	168738	168738	335990
21980	32836	1	applied	\N	\N	\N	\N	168739	168739	335991
21980	32837	2	applied	\N	\N	\N	\N	168740	168740	335992
21985	32847	0	applied	\N	\N	\N	\N	168878	168878	336130
21985	32848	1	applied	\N	\N	\N	\N	168879	168879	336131
21985	32849	2	applied	\N	\N	\N	\N	168880	168880	336132
21991	32861	0	applied	\N	\N	\N	\N	168898	168898	336150
21991	32862	1	applied	\N	\N	\N	\N	168899	168899	336151
21991	32863	2	applied	\N	\N	\N	\N	168900	168900	336152
21995	32870	0	applied	\N	\N	\N	\N	168913	168913	336165
21995	32871	1	applied	\N	\N	\N	\N	168914	168914	336166
21995	32872	2	applied	\N	\N	\N	\N	168915	168915	336167
21998	32876	0	applied	\N	\N	\N	\N	168922	168922	336174
21870	32051	116	applied	\N	\N	\N	\N	168141	168141	335395
21870	32052	117	applied	\N	\N	\N	\N	168142	168142	335396
21875	32645	17	applied	\N	\N	\N	\N	168213	168213	335467
21883	32664	0	applied	\N	\N	\N	\N	168241	168241	335495
21883	32665	1	applied	\N	\N	\N	\N	168242	168242	335496
21883	32666	2	applied	\N	\N	\N	\N	168243	168243	335497
21885	32667	0	applied	\N	\N	\N	\N	168247	168247	335501
21885	32668	1	applied	\N	\N	\N	\N	168248	168248	335502
21885	32669	2	applied	\N	\N	\N	\N	168249	168249	335503
21888	32676	0	applied	\N	\N	\N	\N	168256	168256	335510
21888	32677	1	applied	\N	\N	\N	\N	168257	168257	335511
21888	32678	2	applied	\N	\N	\N	\N	168258	168258	335512
21897	32685	0	applied	\N	\N	\N	\N	168280	168280	335534
21897	32686	1	applied	\N	\N	\N	\N	168281	168281	335535
21897	32687	2	applied	\N	\N	\N	\N	168282	168282	335536
21899	32688	0	applied	\N	\N	\N	\N	168289	168289	335543
21899	32689	1	applied	\N	\N	\N	\N	168290	168290	335544
21899	32690	2	applied	\N	\N	\N	\N	168291	168291	335545
21899	32692	4	applied	\N	\N	\N	\N	168293	168293	335547
21899	32693	5	applied	\N	\N	\N	\N	168294	168294	335548
21904	32697	0	applied	\N	\N	\N	\N	168307	168307	335561
21904	32698	1	applied	\N	\N	\N	\N	168308	168308	335562
21904	32699	2	applied	\N	\N	\N	\N	168309	168309	335563
21906	32700	0	applied	\N	\N	\N	\N	168435	168435	335689
21906	32701	1	applied	\N	\N	\N	\N	168436	168436	335690
21906	32702	2	applied	\N	\N	\N	\N	168437	168437	335691
21911	32712	0	applied	\N	\N	\N	\N	168459	168459	335713
21911	32713	1	applied	\N	\N	\N	\N	168460	168460	335714
21911	32714	2	applied	\N	\N	\N	\N	168461	168461	335715
21913	32715	0	applied	\N	\N	\N	\N	168462	168462	335716
21913	32716	1	applied	\N	\N	\N	\N	168463	168463	335717
21913	32717	2	applied	\N	\N	\N	\N	168464	168464	335718
21918	32725	0	applied	\N	\N	\N	\N	168480	168480	335734
21918	32726	1	applied	\N	\N	\N	\N	168481	168481	335735
21918	32728	3	applied	\N	\N	\N	\N	168483	168483	335737
21918	32729	4	applied	\N	\N	\N	\N	168484	168484	335738
21918	32730	5	applied	\N	\N	\N	\N	168485	168485	335739
21921	32733	0	applied	\N	\N	\N	\N	168498	168498	335752
21921	32734	1	applied	\N	\N	\N	\N	168499	168499	335753
21921	32735	2	applied	\N	\N	\N	\N	168500	168500	335754
21921	32736	3	applied	\N	\N	\N	\N	168501	168501	335755
21925	32761	0	applied	\N	\N	\N	\N	168526	168526	335780
21925	32762	1	applied	\N	\N	\N	\N	168527	168527	335781
21925	32763	2	applied	\N	\N	\N	\N	168528	168528	335782
21928	32761	0	applied	\N	\N	\N	\N	168535	168535	335789
21928	32762	1	applied	\N	\N	\N	\N	168536	168536	335790
21928	32763	2	applied	\N	\N	\N	\N	168537	168537	335791
21945	32787	0	applied	\N	\N	\N	\N	168585	168585	335838
21945	32788	1	applied	\N	\N	\N	\N	168586	168586	335839
21945	32789	2	applied	\N	\N	\N	\N	168587	168587	335840
21950	32794	1	applied	\N	\N	\N	\N	168598	168598	335851
21950	32795	2	applied	\N	\N	\N	\N	168599	168599	335852
21950	32796	3	applied	\N	\N	\N	\N	168600	168600	335853
21950	32797	4	applied	\N	\N	\N	\N	168601	168601	335854
21950	32798	5	applied	\N	\N	\N	\N	168602	168602	335855
21950	32799	6	applied	\N	\N	\N	\N	168603	168603	335856
21950	32800	7	applied	\N	\N	\N	\N	168604	168604	335857
21950	32801	8	applied	\N	\N	\N	\N	168605	168605	335858
21953	32808	0	applied	\N	\N	\N	\N	168621	168621	335874
21953	32809	1	applied	\N	\N	\N	\N	168622	168622	335875
21953	32810	2	applied	\N	\N	\N	\N	168623	168623	335876
21953	32811	3	applied	\N	\N	\N	\N	168624	168624	335877
21953	32812	4	applied	\N	\N	\N	\N	168625	168625	335878
21953	32813	5	applied	\N	\N	\N	\N	168626	168626	335879
21956	32814	0	applied	\N	\N	\N	\N	168636	168636	335889
21956	32815	1	applied	\N	\N	\N	\N	168637	168637	335890
21956	32817	3	applied	\N	\N	\N	\N	168639	168639	335892
21956	32818	4	applied	\N	\N	\N	\N	168640	168640	335893
21956	32819	5	applied	\N	\N	\N	\N	168641	168641	335894
21956	32820	6	applied	\N	\N	\N	\N	168642	168642	335895
21956	32821	7	applied	\N	\N	\N	\N	168643	168643	335896
21956	32822	8	applied	\N	\N	\N	\N	168644	168644	335897
21958	32814	0	applied	\N	\N	\N	\N	168654	168654	335907
21958	32815	1	applied	\N	\N	\N	\N	168655	168655	335908
21958	32816	2	applied	\N	\N	\N	\N	168656	168656	335909
21958	32817	3	applied	\N	\N	\N	\N	168657	168657	335910
21958	32818	4	applied	\N	\N	\N	\N	168658	168658	335911
21958	32819	5	applied	\N	\N	\N	\N	168659	168659	335912
21958	32820	6	applied	\N	\N	\N	\N	168660	168660	335913
21958	32821	7	applied	\N	\N	\N	\N	168661	168661	335914
21958	32822	8	applied	\N	\N	\N	\N	168662	168662	335915
21964	32826	0	applied	\N	\N	\N	\N	168684	168684	335937
21964	32828	2	applied	\N	\N	\N	\N	168686	168686	335939
21965	32826	0	applied	\N	\N	\N	\N	168687	168687	335940
21965	32827	1	applied	\N	\N	\N	\N	168688	168688	335941
21965	32828	2	applied	\N	\N	\N	\N	168689	168689	335942
21968	32823	0	applied	\N	\N	\N	\N	168695	168695	335947
21968	32826	1	applied	\N	\N	\N	\N	168696	168696	335948
21968	32824	2	applied	\N	\N	\N	\N	168697	168697	335949
21968	32828	3	applied	\N	\N	\N	\N	168698	168698	335950
21968	32825	4	applied	\N	\N	\N	\N	168699	168699	335951
21968	32827	5	applied	\N	\N	\N	\N	168700	168700	335952
21974	32829	0	applied	\N	\N	\N	\N	168711	168711	335963
21974	32830	1	applied	\N	\N	\N	\N	168712	168712	335964
21998	32877	1	applied	\N	\N	\N	\N	168923	168923	336175
21998	32878	2	applied	\N	\N	\N	\N	168924	168924	336176
22000	32879	0	applied	\N	\N	\N	\N	169050	169050	336301
22000	32880	1	applied	\N	\N	\N	\N	169051	169051	336302
22005	32888	0	applied	\N	\N	\N	\N	169065	169065	336316
22005	32889	1	applied	\N	\N	\N	\N	169066	169066	336317
22005	32890	2	applied	\N	\N	\N	\N	169067	169067	336318
22005	32891	3	applied	\N	\N	\N	\N	169068	169068	336319
22005	29757	4	applied	\N	\N	\N	\N	169069	169069	336320
22005	32892	5	applied	\N	\N	\N	\N	169070	169070	336321
22005	32893	6	applied	\N	\N	\N	\N	169071	169071	336322
22007	32894	0	applied	\N	\N	\N	\N	169075	169075	336326
22007	32895	1	applied	\N	\N	\N	\N	169076	169076	336327
22007	32896	2	applied	\N	\N	\N	\N	169077	169077	336328
22010	32897	0	applied	\N	\N	\N	\N	169084	169084	336335
22010	32899	2	applied	\N	\N	\N	\N	169085	169085	336336
22014	32903	0	applied	\N	\N	\N	\N	169095	169095	336346
22014	32904	1	applied	\N	\N	\N	\N	169096	169096	336347
21875	32635	14	applied	\N	\N	\N	\N	168210	168210	335464
21875	32639	15	applied	\N	\N	\N	\N	168211	168211	335465
21884	32665	1	applied	\N	\N	\N	\N	168245	168245	335499
21884	32666	2	applied	\N	\N	\N	\N	168246	168246	335500
21886	32670	0	applied	\N	\N	\N	\N	168250	168250	335504
21886	32671	1	applied	\N	\N	\N	\N	168251	168251	335505
21886	32672	2	applied	\N	\N	\N	\N	168252	168252	335506
21889	32676	0	applied	\N	\N	\N	\N	168259	168259	335513
21889	32677	1	applied	\N	\N	\N	\N	168260	168260	335514
21889	32678	2	applied	\N	\N	\N	\N	168261	168261	335515
21893	32681	0	applied	\N	\N	\N	\N	168267	168267	335521
21893	32679	1	applied	\N	\N	\N	\N	168268	168268	335522
21893	32680	2	applied	\N	\N	\N	\N	168269	168269	335523
21895	32681	0	applied	\N	\N	\N	\N	168273	168273	335527
21895	32682	1	applied	\N	\N	\N	\N	168274	168274	335528
21895	32683	2	applied	\N	\N	\N	\N	168275	168275	335529
21895	32684	3	applied	\N	\N	\N	\N	168276	168276	335530
21900	32694	0	applied	\N	\N	\N	\N	168295	168295	335549
21900	32696	2	applied	\N	\N	\N	\N	168297	168297	335551
21902	32694	0	applied	\N	\N	\N	\N	168301	168301	335555
21902	32695	1	applied	\N	\N	\N	\N	168302	168302	335556
21902	32696	2	applied	\N	\N	\N	\N	168303	168303	335557
21907	32703	0	applied	\N	\N	\N	\N	168438	168438	335692
21907	32704	1	applied	\N	\N	\N	\N	168439	168439	335693
21907	32705	2	applied	\N	\N	\N	\N	168440	168440	335694
21907	32706	3	applied	\N	\N	\N	\N	168441	168441	335695
21907	32707	4	applied	\N	\N	\N	\N	168442	168442	335696
21907	32708	5	applied	\N	\N	\N	\N	168443	168443	335697
21909	32703	0	applied	\N	\N	\N	\N	168450	168450	335704
21909	32704	1	applied	\N	\N	\N	\N	168451	168451	335705
21909	32705	2	applied	\N	\N	\N	\N	168452	168452	335706
21909	32706	3	applied	\N	\N	\N	\N	168453	168453	335707
21909	32707	4	applied	\N	\N	\N	\N	168454	168454	335708
21909	32708	5	applied	\N	\N	\N	\N	168455	168455	335709
21916	32719	0	applied	\N	\N	\N	\N	168472	168472	335726
21916	32720	1	applied	\N	\N	\N	\N	168473	168473	335727
21916	32721	3	applied	\N	\N	\N	\N	168474	168474	335728
21916	32722	4	applied	\N	\N	\N	\N	168475	168475	335729
21916	32723	5	applied	\N	\N	\N	\N	168476	168476	335730
21916	32724	6	applied	\N	\N	\N	\N	168477	168477	335731
21919	32731	0	applied	\N	\N	\N	\N	168486	168486	335740
21919	32732	1	applied	\N	\N	\N	\N	168487	168487	335741
21919	32733	2	applied	\N	\N	\N	\N	168488	168488	335742
21919	32734	3	applied	\N	\N	\N	\N	168489	168489	335743
21919	32735	4	applied	\N	\N	\N	\N	168490	168490	335744
21919	32736	5	applied	\N	\N	\N	\N	168491	168491	335745
21923	32737	0	applied	\N	\N	\N	\N	168502	168502	335756
21923	32738	1	applied	\N	\N	\N	\N	168503	168503	335757
21923	32739	2	applied	\N	\N	\N	\N	168504	168504	335758
21923	32740	3	applied	\N	\N	\N	\N	168505	168505	335759
21923	32742	5	applied	\N	\N	\N	\N	168507	168507	335761
21923	32743	6	applied	\N	\N	\N	\N	168508	168508	335762
21923	32744	7	applied	\N	\N	\N	\N	168509	168509	335763
21923	32745	8	applied	\N	\N	\N	\N	168510	168510	335764
21923	32746	9	applied	\N	\N	\N	\N	168511	168511	335765
21923	32747	10	applied	\N	\N	\N	\N	168512	168512	335766
21923	32748	11	applied	\N	\N	\N	\N	168513	168513	335767
21923	32749	12	applied	\N	\N	\N	\N	168514	168514	335768
21923	32750	13	applied	\N	\N	\N	\N	168515	168515	335769
21923	32751	14	applied	\N	\N	\N	\N	168516	168516	335770
21923	32752	15	applied	\N	\N	\N	\N	168517	168517	335771
21923	32753	16	applied	\N	\N	\N	\N	168518	168518	335772
21923	32754	17	applied	\N	\N	\N	\N	168519	168519	335773
21923	32755	18	applied	\N	\N	\N	\N	168520	168520	335774
21923	32756	19	applied	\N	\N	\N	\N	168521	168521	335775
21923	32757	20	applied	\N	\N	\N	\N	168522	168522	335776
21929	32762	1	applied	\N	\N	\N	\N	168539	168539	335793
21932	32769	0	applied	\N	\N	\N	\N	168548	168548	335802
21932	32770	1	applied	\N	\N	\N	\N	168549	168549	335803
21937	32771	0	applied	\N	\N	\N	\N	168557	168557	335811
21937	32772	1	applied	\N	\N	\N	\N	168558	168558	335812
21937	32773	2	applied	\N	\N	\N	\N	168559	168559	335813
21943	32777	0	applied	\N	\N	\N	\N	168575	168575	335829
21943	32778	1	applied	\N	\N	\N	\N	168576	168576	335830
21943	32779	2	applied	\N	\N	\N	\N	168577	168577	168577
21943	32780	3	applied	\N	\N	\N	\N	168578	168578	335831
21943	32781	4	applied	\N	\N	\N	\N	168579	168579	335832
21943	32782	5	applied	\N	\N	\N	\N	168580	168580	335833
21943	32783	6	applied	\N	\N	\N	\N	168581	168581	335834
21946	32787	0	applied	\N	\N	\N	\N	168588	168588	335841
21946	32788	1	applied	\N	\N	\N	\N	168589	168589	335842
21946	32789	2	applied	\N	\N	\N	\N	168590	168590	335843
21952	32803	1	applied	\N	\N	\N	\N	168616	168616	335869
21952	32804	2	applied	\N	\N	\N	\N	168617	168617	335870
21952	32805	3	applied	\N	\N	\N	\N	168618	168618	335871
21952	32806	4	applied	\N	\N	\N	\N	168619	168619	335872
21952	32807	5	applied	\N	\N	\N	\N	168620	168620	335873
21960	32823	0	applied	\N	\N	\N	\N	168672	168672	335925
21960	32824	1	applied	\N	\N	\N	\N	168673	168673	335926
21960	32825	2	applied	\N	\N	\N	\N	168674	168674	335927
21963	32826	0	applied	\N	\N	\N	\N	168681	168681	335934
21963	32827	1	applied	\N	\N	\N	\N	168682	168682	335935
21963	32828	2	applied	\N	\N	\N	\N	168683	168683	335936
21967	32721	0	applied	\N	\N	\N	\N	168693	168693	335946
21974	32831	2	applied	\N	\N	\N	\N	168713	168713	335965
21974	32832	3	applied	\N	\N	\N	\N	168714	168714	335966
21974	32833	4	applied	\N	\N	\N	\N	168715	168715	335967
21974	32834	5	applied	\N	\N	\N	\N	168716	168716	335968
21976	32830	1	applied	\N	\N	\N	\N	168724	168724	335976
21976	32831	2	applied	\N	\N	\N	\N	168725	168725	335977
21976	32832	3	applied	\N	\N	\N	\N	168726	168726	335978
21976	32833	4	applied	\N	\N	\N	\N	168727	168727	335979
21976	32834	5	applied	\N	\N	\N	\N	168728	168728	335980
21978	32835	0	applied	\N	\N	\N	\N	168732	168732	335984
21978	32836	1	applied	\N	\N	\N	\N	168733	168733	335985
21978	32837	2	applied	\N	\N	\N	\N	168734	168734	335986
21987	32850	0	applied	\N	\N	\N	\N	168884	168884	336136
21987	32851	1	applied	\N	\N	\N	\N	168885	168885	336137
21987	32852	2	applied	\N	\N	\N	\N	168886	168886	336138
21990	32861	0	applied	\N	\N	\N	\N	168895	168895	336147
21990	32862	1	applied	\N	\N	\N	\N	168896	168896	336148
21990	32863	2	applied	\N	\N	\N	\N	168897	168897	336149
21878	32650	1	applied	\N	\N	\N	\N	168221	168221	335475
21878	32651	2	applied	\N	\N	\N	\N	168222	168222	335476
21905	32625	51	applied	\N	\N	\N	\N	168360	168360	335614
21905	32628	52	applied	\N	\N	\N	\N	168361	168361	335615
21905	32631	53	applied	\N	\N	\N	\N	168362	168362	335616
21905	32634	54	applied	\N	\N	\N	\N	168363	168363	335617
21905	32637	55	applied	\N	\N	\N	\N	168364	168364	335618
21905	32640	56	applied	\N	\N	\N	\N	168365	168365	335619
21905	32641	57	applied	\N	\N	\N	\N	168366	168366	335620
21905	32646	58	applied	\N	\N	\N	\N	168367	168367	335621
21905	32649	59	applied	\N	\N	\N	\N	168368	168368	335622
21905	32652	60	applied	\N	\N	\N	\N	168369	168369	335623
21905	32653	61	applied	\N	\N	\N	\N	168370	168370	335624
21905	32658	62	applied	\N	\N	\N	\N	168371	168371	335625
21905	32659	63	applied	\N	\N	\N	\N	168372	168372	335626
21905	32664	64	applied	\N	\N	\N	\N	168373	168373	335627
21905	32667	65	applied	\N	\N	\N	\N	168374	168374	335628
21905	32670	66	applied	\N	\N	\N	\N	168375	168375	335629
21905	32676	68	applied	\N	\N	\N	\N	168377	168377	335631
21905	32681	69	applied	\N	\N	\N	\N	168378	168378	335632
21905	32682	70	applied	\N	\N	\N	\N	168379	168379	335633
21905	32685	71	applied	\N	\N	\N	\N	168380	168380	335634
21905	32688	72	applied	\N	\N	\N	\N	168381	168381	335635
21905	32689	73	applied	\N	\N	\N	\N	168382	168382	335636
21905	32694	74	applied	\N	\N	\N	\N	168383	168383	335637
21905	32697	75	applied	\N	\N	\N	\N	168384	168384	335638
21905	32478	76	applied	\N	\N	\N	\N	168385	168385	335639
21905	32479	77	applied	\N	\N	\N	\N	168386	168386	335640
21905	32480	78	applied	\N	\N	\N	\N	168387	168387	335641
21905	32481	79	applied	\N	\N	\N	\N	168388	168388	335642
21905	32484	80	applied	\N	\N	\N	\N	168389	168389	335643
21905	32483	81	applied	\N	\N	\N	\N	168390	168390	335644
21905	32486	82	applied	\N	\N	\N	\N	168391	168391	335645
21905	32490	83	applied	\N	\N	\N	\N	168392	168392	335646
21905	32496	85	applied	\N	\N	\N	\N	168394	168394	335648
21905	32499	86	applied	\N	\N	\N	\N	168395	168395	335649
21905	32502	87	applied	\N	\N	\N	\N	168396	168396	335650
21905	32505	88	applied	\N	\N	\N	\N	168397	168397	335651
21905	32507	89	applied	\N	\N	\N	\N	168398	168398	335652
21905	32513	90	applied	\N	\N	\N	\N	168399	168399	335653
21905	32514	91	applied	\N	\N	\N	\N	168400	168400	335654
21905	32517	92	applied	\N	\N	\N	\N	168401	168401	335655
21905	32518	93	applied	\N	\N	\N	\N	168402	168402	335656
21905	32523	94	applied	\N	\N	\N	\N	168403	168403	335657
21905	32526	95	applied	\N	\N	\N	\N	168404	168404	335658
21905	32531	96	applied	\N	\N	\N	\N	168405	168405	335659
21905	32532	97	applied	\N	\N	\N	\N	168406	168406	335660
21905	32541	98	applied	\N	\N	\N	\N	168407	168407	335661
21905	32542	99	applied	\N	\N	\N	\N	168408	168408	335662
21905	32543	100	applied	\N	\N	\N	\N	168409	168409	335663
21905	32549	102	applied	\N	\N	\N	\N	168411	168411	335665
21905	32550	103	applied	\N	\N	\N	\N	168412	168412	335666
21905	32553	104	applied	\N	\N	\N	\N	168413	168413	335667
21905	32554	105	applied	\N	\N	\N	\N	168414	168414	335668
21905	32557	106	applied	\N	\N	\N	\N	168415	168415	335669
21905	32558	107	applied	\N	\N	\N	\N	168416	168416	335670
21905	32569	108	applied	\N	\N	\N	\N	168417	168417	335671
21905	32570	109	applied	\N	\N	\N	\N	168418	168418	335672
21905	32571	110	applied	\N	\N	\N	\N	168419	168419	335673
21905	32578	111	applied	\N	\N	\N	\N	168420	168420	335674
21905	32579	112	applied	\N	\N	\N	\N	168421	168421	335675
21905	32581	113	applied	\N	\N	\N	\N	168422	168422	335676
21905	32585	114	applied	\N	\N	\N	\N	168423	168423	335677
21905	32587	115	applied	\N	\N	\N	\N	168424	168424	335678
21905	32591	116	applied	\N	\N	\N	\N	168425	168425	335679
21905	32594	117	applied	\N	\N	\N	\N	168426	168426	335680
21905	32603	119	applied	\N	\N	\N	\N	168428	168428	335682
21905	32604	120	applied	\N	\N	\N	\N	168429	168429	335683
21905	32605	121	applied	\N	\N	\N	\N	168430	168430	335684
21905	32609	122	applied	\N	\N	\N	\N	168431	168431	335685
21905	32612	123	applied	\N	\N	\N	\N	168432	168432	335686
21905	32617	124	applied	\N	\N	\N	\N	168433	168433	335687
21905	32487	125	applied	\N	\N	\N	\N	168434	168434	335688
21908	32703	0	applied	\N	\N	\N	\N	168444	168444	335698
21908	32704	1	applied	\N	\N	\N	\N	168445	168445	335699
21908	32705	2	applied	\N	\N	\N	\N	168446	168446	335700
21908	32706	3	applied	\N	\N	\N	\N	168447	168447	335701
21908	32707	4	applied	\N	\N	\N	\N	168448	168448	335702
21908	32708	5	applied	\N	\N	\N	\N	168449	168449	335703
21910	32709	0	applied	\N	\N	\N	\N	168456	168456	335710
21910	32710	1	applied	\N	\N	\N	\N	168457	168457	335711
21910	32711	2	applied	\N	\N	\N	\N	168458	168458	335712
21915	32720	1	applied	\N	\N	\N	\N	168467	168467	335721
21915	32721	3	applied	\N	\N	\N	\N	168468	168468	335722
21915	32722	4	applied	\N	\N	\N	\N	168469	168469	335723
21915	32723	5	applied	\N	\N	\N	\N	168470	168470	335724
21915	32724	6	applied	\N	\N	\N	\N	168471	168471	335725
21917	32721	0	applied	\N	\N	\N	\N	168478	168478	335732
21917	32722	1	applied	\N	\N	\N	\N	168479	168479	335733
21924	32758	0	applied	\N	\N	\N	\N	168523	168523	335777
21924	32759	1	applied	\N	\N	\N	\N	168524	168524	335778
21924	32760	2	applied	\N	\N	\N	\N	168525	168525	335779
21927	32761	0	applied	\N	\N	\N	\N	168532	168532	335786
21927	32762	1	applied	\N	\N	\N	\N	168533	168533	335787
21967	32779	1	applied	\N	\N	\N	\N	168694	168694	168694
21977	32835	0	applied	\N	\N	\N	\N	168729	168729	335981
21977	32836	1	applied	\N	\N	\N	\N	168730	168730	335982
21977	32837	2	applied	\N	\N	\N	\N	168731	168731	335983
21982	32836	1	applied	\N	\N	\N	\N	168867	168867	336119
21982	32837	2	applied	\N	\N	\N	\N	168868	168868	336120
21984	32844	0	applied	\N	\N	\N	\N	168875	168875	336127
21984	32845	1	applied	\N	\N	\N	\N	168876	168876	336128
21984	32846	2	applied	\N	\N	\N	\N	168877	168877	336129
21986	32847	0	applied	\N	\N	\N	\N	168881	168881	336133
21986	32848	1	applied	\N	\N	\N	\N	168882	168882	336134
21986	32849	2	applied	\N	\N	\N	\N	168883	168883	336135
21989	32855	0	applied	\N	\N	\N	\N	168889	168889	336141
21989	32856	1	applied	\N	\N	\N	\N	168890	168890	336142
21989	32857	2	applied	\N	\N	\N	\N	168891	168891	336143
21989	32858	3	applied	\N	\N	\N	\N	168892	168892	336144
21989	32859	4	applied	\N	\N	\N	\N	168893	168893	336145
21989	32860	5	applied	\N	\N	\N	\N	168894	168894	336146
21905	32614	48	applied	\N	\N	\N	\N	168357	168357	335611
21905	32615	49	applied	\N	\N	\N	\N	168358	168358	335612
21931	32766	2	applied	\N	\N	\N	\N	168545	168545	335799
21931	32767	3	applied	\N	\N	\N	\N	168546	168546	335800
21931	32768	4	applied	\N	\N	\N	\N	168547	168547	335801
21934	32769	0	applied	\N	\N	\N	\N	168552	168552	335806
21934	32770	1	applied	\N	\N	\N	\N	168553	168553	335807
21936	32771	0	applied	\N	\N	\N	\N	168554	168554	335808
21936	32772	1	applied	\N	\N	\N	\N	168555	168555	335809
21936	32773	2	applied	\N	\N	\N	\N	168556	168556	335810
21940	32771	0	applied	\N	\N	\N	\N	168566	168566	335820
21940	32772	1	applied	\N	\N	\N	\N	168567	168567	335821
21940	32773	2	applied	\N	\N	\N	\N	168568	168568	335822
21942	32774	0	applied	\N	\N	\N	\N	168572	168572	335826
21942	32775	1	applied	\N	\N	\N	\N	168573	168573	335827
21949	32790	0	applied	\N	\N	\N	\N	168594	168594	335847
21949	32791	1	applied	\N	\N	\N	\N	168595	168595	335848
21949	32792	2	applied	\N	\N	\N	\N	168596	168596	335849
21955	32814	0	applied	\N	\N	\N	\N	168627	168627	335880
21955	32815	1	applied	\N	\N	\N	\N	168628	168628	335881
21955	32816	2	applied	\N	\N	\N	\N	168629	168629	335882
21955	32817	3	applied	\N	\N	\N	\N	168630	168630	335883
21955	32818	4	applied	\N	\N	\N	\N	168631	168631	335884
21955	32819	5	applied	\N	\N	\N	\N	168632	168632	335885
21955	32820	6	applied	\N	\N	\N	\N	168633	168633	335886
21955	32821	7	applied	\N	\N	\N	\N	168634	168634	335887
21955	32822	8	applied	\N	\N	\N	\N	168635	168635	335888
21962	32826	0	applied	\N	\N	\N	\N	168678	168678	335931
21962	32827	1	applied	\N	\N	\N	\N	168679	168679	335932
21962	32828	2	applied	\N	\N	\N	\N	168680	168680	335933
21966	32826	0	applied	\N	\N	\N	\N	168690	168690	335943
21966	32828	2	applied	\N	\N	\N	\N	168692	168692	335945
21973	32829	0	applied	\N	\N	\N	\N	168707	168707	335959
21973	32830	1	applied	\N	\N	\N	\N	168708	168708	335960
21973	32833	2	applied	\N	\N	\N	\N	168709	168709	335961
21973	32834	3	applied	\N	\N	\N	\N	168710	168710	335962
21975	32829	0	applied	\N	\N	\N	\N	168717	168717	335969
21975	32830	1	applied	\N	\N	\N	\N	168718	168718	335970
21975	32831	2	applied	\N	\N	\N	\N	168719	168719	335971
21975	32832	3	applied	\N	\N	\N	\N	168720	168720	335972
21975	32833	4	applied	\N	\N	\N	\N	168721	168721	335973
21975	32834	5	applied	\N	\N	\N	\N	168722	168722	335974
21981	32320	0	applied	\N	\N	1000000000	\N	168741	168741	335993
21981	32267	1	applied	\N	\N	\N	\N	168742	168742	335994
21981	32074	2	applied	\N	\N	\N	\N	168743	168743	335995
21981	32167	3	applied	\N	\N	\N	\N	168744	168744	335996
21981	32254	4	applied	\N	\N	\N	\N	168745	168745	335997
21981	32218	6	applied	\N	\N	\N	\N	168747	168747	335999
21981	32077	7	applied	\N	\N	\N	\N	168748	168748	336000
21981	32196	8	applied	\N	\N	\N	\N	168749	168749	336001
21981	32232	9	applied	\N	\N	1000000000	\N	168750	168750	336002
21981	32080	10	applied	\N	\N	\N	\N	168751	168751	336003
21981	32083	11	applied	\N	\N	\N	\N	168752	168752	336004
21981	32086	12	applied	\N	\N	\N	\N	168753	168753	336005
21981	32089	13	applied	\N	\N	\N	\N	168754	168754	336006
21981	32092	14	applied	\N	\N	\N	\N	168755	168755	336007
21981	32197	15	applied	\N	\N	\N	\N	168756	168756	336008
21981	32093	16	applied	\N	\N	\N	\N	168757	168757	336009
21981	32094	17	applied	\N	\N	\N	\N	168758	168758	336010
21981	32102	18	applied	\N	\N	\N	\N	168759	168759	336011
21981	32105	19	applied	\N	\N	\N	\N	168760	168760	336012
21981	32108	20	applied	\N	\N	\N	\N	168761	168761	336013
21981	32111	21	applied	\N	\N	\N	\N	168762	168762	336014
21981	32118	23	applied	\N	\N	\N	\N	168764	168764	336016
21981	32119	24	applied	\N	\N	\N	\N	168765	168765	336017
21981	32124	25	applied	\N	\N	\N	\N	168766	168766	336018
21981	32127	26	applied	\N	\N	\N	\N	168767	168767	336019
21981	32130	27	applied	\N	\N	\N	\N	168768	168768	336020
21981	32133	28	applied	\N	\N	\N	\N	168769	168769	336021
21981	32136	29	applied	\N	\N	\N	\N	168770	168770	336022
21981	32139	30	applied	\N	\N	\N	\N	168771	168771	336023
21981	32142	31	applied	\N	\N	\N	\N	168772	168772	336024
21981	32145	32	applied	\N	\N	\N	\N	168773	168773	336025
21981	32148	33	applied	\N	\N	\N	\N	168774	168774	336026
21981	32149	34	applied	\N	\N	\N	\N	168775	168775	336027
21981	32154	35	applied	\N	\N	\N	\N	168776	168776	336028
21981	32157	36	applied	\N	\N	\N	\N	168777	168777	336029
21981	32158	37	applied	\N	\N	\N	\N	168778	168778	336030
21981	32164	38	applied	\N	\N	\N	\N	168779	168779	336031
21981	32171	40	applied	\N	\N	\N	\N	168781	168781	336033
21981	32177	41	applied	\N	\N	\N	\N	168782	168782	336034
21981	32180	42	applied	\N	\N	\N	\N	168783	168783	336035
21981	32183	43	applied	\N	\N	\N	\N	168784	168784	336036
21981	32186	44	applied	\N	\N	\N	\N	168785	168785	336037
21981	32191	45	applied	\N	\N	\N	\N	168786	168786	336038
21981	32194	46	applied	\N	\N	\N	\N	168787	168787	336039
21981	32195	47	applied	\N	\N	\N	\N	168788	168788	336040
21981	32202	48	applied	\N	\N	\N	\N	168789	168789	336041
21981	32205	49	applied	\N	\N	\N	\N	168790	168790	336042
21981	32206	50	applied	\N	\N	\N	\N	168791	168791	336043
21981	32207	51	applied	\N	\N	\N	\N	168792	168792	336044
21981	32214	52	applied	\N	\N	\N	\N	168793	168793	336045
21981	32217	53	applied	\N	\N	\N	\N	168794	168794	336046
21981	32222	54	applied	\N	\N	\N	\N	168795	168795	336047
21981	32225	55	applied	\N	\N	\N	\N	168796	168796	336048
21981	32231	57	applied	\N	\N	\N	\N	168798	168798	336050
21981	32235	58	applied	\N	\N	\N	\N	168799	168799	336051
21981	32239	59	applied	\N	\N	\N	\N	168800	168800	336052
21981	32242	60	applied	\N	\N	\N	\N	168801	168801	336053
21981	32243	61	applied	\N	\N	\N	\N	168802	168802	336054
21981	32248	62	applied	\N	\N	\N	\N	168803	168803	336055
21981	32251	63	applied	\N	\N	\N	\N	168804	168804	336056
21981	32255	65	applied	\N	\N	\N	\N	168805	168805	336057
21981	32258	66	applied	\N	\N	\N	\N	168806	168806	336058
21981	32261	67	applied	\N	\N	\N	\N	168807	168807	336059
21981	32264	68	applied	\N	\N	\N	\N	168808	168808	336060
21981	32268	69	applied	\N	\N	\N	\N	168809	168809	336061
21981	32271	70	applied	\N	\N	\N	\N	168810	168810	336062
21981	32172	71	applied	\N	\N	\N	\N	168811	168811	336063
21981	32173	72	applied	\N	\N	\N	\N	168812	168812	336064
21981	32174	73	applied	\N	\N	\N	\N	168813	168813	336065
21931	32764	0	applied	\N	\N	\N	\N	168543	168543	335797
21931	32765	1	applied	\N	\N	\N	\N	168544	168544	335798
21981	32290	79	applied	\N	\N	\N	\N	168819	168819	336071
21981	32291	80	applied	\N	\N	\N	\N	168820	168820	336072
21981	32296	81	applied	\N	\N	\N	\N	168821	168821	336073
21981	32299	82	applied	\N	\N	\N	\N	168822	168822	336074
21981	32302	83	applied	\N	\N	\N	\N	168823	168823	336075
21981	32305	84	applied	\N	\N	\N	\N	168824	168824	336076
21981	32306	85	applied	\N	\N	\N	\N	168825	168825	336077
21981	32307	86	applied	\N	\N	\N	\N	168826	168826	336078
21981	32308	87	applied	\N	\N	\N	\N	168827	168827	336079
21981	32317	88	applied	\N	\N	\N	\N	168828	168828	336080
21981	32321	89	applied	\N	\N	\N	\N	168829	168829	336081
21981	32322	90	applied	\N	\N	\N	\N	168830	168830	336082
21981	32327	91	applied	\N	\N	\N	\N	168831	168831	336083
21981	32330	92	applied	\N	\N	\N	\N	168832	168832	336084
21981	32331	93	applied	\N	\N	\N	\N	168833	168833	336085
21981	32335	94	applied	\N	\N	\N	\N	168834	168834	336086
21981	32339	96	applied	\N	\N	\N	\N	168836	168836	336088
21981	32344	97	applied	\N	\N	\N	\N	168837	168837	336089
21981	32345	98	applied	\N	\N	\N	\N	168838	168838	336090
21981	32346	99	applied	\N	\N	\N	\N	168839	168839	336091
21981	32347	100	applied	\N	\N	\N	\N	168840	168840	336092
21981	32356	101	applied	\N	\N	\N	\N	168841	168841	336093
21981	32359	102	applied	\N	\N	\N	\N	168842	168842	336094
21981	32362	103	applied	\N	\N	\N	\N	168843	168843	336095
21981	32365	104	applied	\N	\N	\N	\N	168844	168844	336096
21981	32381	105	applied	\N	\N	\N	\N	168845	168845	336097
21981	32382	106	applied	\N	\N	\N	\N	168846	168846	336098
21981	32387	107	applied	\N	\N	\N	\N	168847	168847	336099
21981	32390	108	applied	\N	\N	\N	\N	168848	168848	336100
21981	32393	109	applied	\N	\N	\N	\N	168849	168849	336101
21981	32396	110	applied	\N	\N	\N	\N	168850	168850	336102
21981	32399	111	applied	\N	\N	\N	\N	168851	168851	336103
21981	32405	113	applied	\N	\N	\N	\N	168853	168853	336105
21981	32408	114	applied	\N	\N	\N	\N	168854	168854	336106
21981	32411	115	applied	\N	\N	\N	\N	168855	168855	336107
21981	32414	116	applied	\N	\N	\N	\N	168856	168856	336108
21981	32417	117	applied	\N	\N	\N	\N	168857	168857	336109
21981	32420	118	applied	\N	\N	\N	\N	168858	168858	336110
21981	32421	119	applied	\N	\N	\N	\N	168859	168859	336111
21981	32426	120	applied	\N	\N	\N	\N	168860	168860	336112
21981	32429	121	applied	\N	\N	\N	\N	168861	168861	336113
21981	32432	122	applied	\N	\N	\N	\N	168862	168862	336114
21981	32435	123	applied	\N	\N	\N	\N	168863	168863	336115
21981	32436	124	applied	\N	\N	\N	\N	168864	168864	336116
21981	32437	125	applied	\N	\N	\N	\N	168865	168865	336117
21983	32838	0	applied	\N	\N	\N	\N	168869	168869	336121
21983	32839	1	applied	\N	\N	\N	\N	168870	168870	336122
21983	32840	2	applied	\N	\N	\N	\N	168871	168871	336123
21983	32842	4	applied	\N	\N	\N	\N	168873	168873	336125
21983	32843	5	applied	\N	\N	\N	\N	168874	168874	336126
21988	32853	0	applied	\N	\N	\N	\N	168887	168887	336139
21988	32854	1	applied	\N	\N	\N	\N	168888	168888	336140
21992	32861	0	applied	\N	\N	\N	\N	168901	168901	336153
21992	32862	1	applied	\N	\N	\N	\N	168902	168902	336154
21992	32863	2	applied	\N	\N	\N	\N	168903	168903	336155
21993	32861	0	applied	\N	\N	\N	\N	168904	168904	336156
21993	32862	1	applied	\N	\N	\N	\N	168905	168905	336157
21993	32863	2	applied	\N	\N	\N	\N	168906	168906	336158
21996	32873	0	applied	\N	\N	\N	\N	168916	168916	336168
21996	32874	1	applied	\N	\N	\N	\N	168917	168917	336169
21996	32875	2	applied	\N	\N	\N	\N	168918	168918	336170
22001	32879	0	applied	\N	\N	\N	\N	169053	169053	336304
22001	32880	1	applied	\N	\N	\N	\N	169054	169054	336305
22001	32881	2	applied	\N	\N	\N	\N	169055	169055	336306
22012	32901	1	applied	\N	\N	\N	\N	169090	169090	336341
22012	32902	2	applied	\N	\N	\N	\N	169091	169091	336342
22015	32903	0	applied	\N	\N	\N	\N	169097	169097	336348
22015	32905	1	applied	\N	\N	\N	\N	169098	169098	336349
22015	32904	2	applied	\N	\N	\N	\N	169099	169099	336350
22017	32906	0	applied	\N	\N	\N	\N	169104	169104	336355
22017	32907	1	applied	\N	\N	\N	\N	169105	169105	336356
22017	32905	2	applied	\N	\N	\N	\N	169106	169106	336357
22017	32908	3	applied	\N	\N	\N	\N	169107	169107	336358
22020	32906	0	applied	\N	\N	\N	\N	169116	169116	336367
22020	32907	1	applied	\N	\N	\N	\N	169117	169117	336368
22020	32905	2	applied	\N	\N	\N	\N	169118	169118	336369
22020	32908	3	applied	\N	\N	\N	\N	169119	169119	336370
22025	32912	0	applied	\N	\N	\N	\N	169133	169133	336384
22028	32918	0	applied	\N	\N	\N	\N	169140	169140	336391
22028	32919	1	applied	\N	\N	\N	\N	169141	169141	336392
22031	32923	0	applied	\N	\N	\N	\N	169152	169152	336403
22031	32924	1	applied	\N	\N	\N	\N	169153	169153	336404
22031	32925	2	applied	\N	\N	\N	\N	169154	169154	336405
22031	32930	3	applied	\N	\N	\N	\N	169155	169155	336406
22031	32926	4	applied	\N	\N	\N	\N	169156	169156	336407
22031	32931	5	applied	\N	\N	\N	\N	169157	169157	336408
22031	32932	6	applied	\N	\N	\N	\N	169158	169158	336409
22031	32927	7	applied	\N	\N	\N	\N	169159	169159	336410
22031	32928	8	applied	\N	\N	\N	\N	169160	169160	336411
22031	32929	9	applied	\N	\N	\N	\N	169161	169161	336412
22031	32933	10	applied	\N	\N	\N	\N	169162	169162	336413
22031	32934	11	applied	\N	\N	\N	\N	169163	169163	336414
22031	32935	12	applied	\N	\N	\N	\N	169164	169164	336415
22031	32936	13	applied	\N	\N	\N	\N	169165	169165	336416
22033	32937	0	applied	\N	\N	\N	\N	169168	169168	336419
22033	32939	1	applied	\N	\N	\N	\N	169169	169169	336420
22035	32940	0	applied	\N	\N	\N	\N	169174	169174	336425
22035	32941	1	applied	\N	\N	\N	\N	169175	169175	336426
22035	32942	2	applied	\N	\N	\N	\N	169176	169176	336427
22035	32943	3	applied	\N	\N	\N	\N	169177	169177	336428
22040	32959	0	applied	\N	\N	\N	\N	169318	169318	336569
22040	32960	1	applied	\N	\N	\N	\N	169319	169319	336570
22040	32961	2	applied	\N	\N	\N	\N	169320	169320	336571
22040	32962	3	applied	\N	\N	\N	\N	169321	169321	336572
22046	32983	0	applied	\N	\N	\N	\N	169360	169360	336611
22046	32984	1	applied	\N	\N	\N	\N	169361	169361	336612
22046	32985	2	applied	\N	\N	\N	\N	169362	169362	336613
22052	32986	0	applied	\N	\N	\N	\N	169373	169373	336624
22052	32987	1	applied	\N	\N	\N	\N	169374	169374	336625
22052	32988	2	applied	\N	\N	\N	\N	169375	169375	336626
21981	32279	76	applied	\N	\N	\N	\N	168816	168816	336068
21981	32280	77	applied	\N	\N	\N	\N	168817	168817	336069
21994	32868	4	applied	\N	\N	\N	\N	168911	168911	336163
21994	32869	5	applied	\N	\N	\N	\N	168912	168912	336164
22002	32879	0	applied	\N	\N	\N	\N	169056	169056	336307
22002	32880	1	applied	\N	\N	\N	\N	169057	169057	336308
22002	32881	2	applied	\N	\N	\N	\N	169058	169058	336309
22003	32882	0	applied	\N	\N	\N	\N	169059	169059	336310
22003	32883	1	applied	\N	\N	\N	\N	169060	169060	336311
22003	32884	2	applied	\N	\N	\N	\N	169061	169061	336312
22006	32894	0	applied	\N	\N	\N	\N	169072	169072	336323
22006	32895	1	applied	\N	\N	\N	\N	169073	169073	336324
22006	32896	2	applied	\N	\N	\N	\N	169074	169074	336325
22008	32894	0	applied	\N	\N	\N	\N	169078	169078	336329
22008	32895	1	applied	\N	\N	\N	\N	169079	169079	336330
22008	32896	2	applied	\N	\N	\N	\N	169080	169080	336331
22013	32900	0	applied	\N	\N	\N	\N	169092	169092	336343
22013	32901	1	applied	\N	\N	\N	\N	169093	169093	336344
22021	32906	0	applied	\N	\N	\N	\N	169120	169120	336371
22021	32907	1	applied	\N	\N	\N	\N	169121	169121	336372
22021	32905	2	applied	\N	\N	\N	\N	169122	169122	336373
22021	32908	3	applied	\N	\N	\N	\N	169123	169123	336374
22026	32915	0	applied	\N	\N	\N	\N	169134	169134	336385
22026	32916	1	applied	\N	\N	\N	\N	169135	169135	336386
22026	32917	2	applied	\N	\N	\N	\N	169136	169136	336387
22038	32953	0	applied	\N	\N	\N	\N	169312	169312	336563
22038	32954	1	applied	\N	\N	\N	\N	169313	169313	336564
22038	32955	2	applied	\N	\N	\N	\N	169314	169314	336565
22038	32956	3	applied	\N	\N	\N	\N	169315	169315	336566
22041	32963	0	applied	\N	\N	\N	\N	169322	169322	336573
22041	32964	1	applied	\N	\N	\N	\N	169323	169323	336574
22041	32965	2	applied	\N	\N	\N	\N	169324	169324	336575
22041	32966	3	applied	\N	\N	\N	\N	169325	169325	336576
22043	32967	0	applied	\N	\N	\N	\N	169330	169330	336581
22044	32969	0	applied	\N	\N	\N	\N	169332	169332	336583
22044	32970	1	applied	\N	\N	\N	\N	169333	169333	336584
22044	32971	2	applied	\N	\N	\N	\N	169334	169334	336585
22044	32972	3	applied	\N	\N	\N	\N	169335	169335	336586
22044	32973	4	applied	\N	\N	\N	\N	169336	169336	336587
22044	32974	5	applied	\N	\N	\N	\N	169337	169337	336588
22044	32975	6	applied	\N	\N	\N	\N	169338	169338	336589
22044	32976	7	applied	\N	\N	\N	\N	169339	169339	336590
22044	32977	8	applied	\N	\N	\N	\N	169340	169340	336591
22044	32978	9	applied	\N	\N	\N	\N	169341	169341	336592
22044	32979	10	applied	\N	\N	\N	\N	169342	169342	336593
22044	32980	11	applied	\N	\N	\N	\N	169343	169343	336594
22044	32981	12	applied	\N	\N	\N	\N	169344	169344	336595
22044	32982	13	applied	\N	\N	\N	\N	169345	169345	336596
22047	32983	0	applied	\N	\N	\N	\N	169363	169363	336614
22047	32984	1	applied	\N	\N	\N	\N	169364	169364	336615
22052	32989	3	applied	\N	\N	\N	\N	169376	169376	336627
22053	32990	0	applied	\N	\N	\N	\N	169377	169377	336628
22053	32991	1	applied	\N	\N	\N	\N	169378	169378	336629
22053	32992	2	applied	\N	\N	\N	\N	169379	169379	336630
22055	32993	0	applied	\N	\N	\N	\N	169383	169383	336634
22055	32994	1	applied	\N	\N	\N	\N	169384	169384	336635
22055	32995	2	applied	\N	\N	\N	\N	169385	169385	336636
22057	32996	0	applied	\N	\N	\N	\N	169386	169386	336637
22057	32997	1	applied	\N	\N	\N	\N	169387	169387	336638
22057	32998	2	applied	\N	\N	\N	\N	169388	169388	336639
22057	32999	3	applied	\N	\N	\N	\N	169389	169389	336640
22062	33013	0	applied	\N	\N	\N	\N	169409	169409	336660
22062	33014	1	applied	\N	\N	\N	\N	169410	169410	336661
22062	33015	2	applied	\N	\N	\N	\N	169411	169411	336662
22063	33013	0	applied	\N	\N	\N	\N	169412	169412	336663
22063	33014	1	applied	\N	\N	\N	\N	169413	169413	336664
22065	33016	0	applied	\N	\N	\N	\N	169418	169418	336669
22065	33017	1	applied	\N	\N	\N	\N	169419	169419	336670
22065	33018	2	applied	\N	\N	\N	\N	169420	169420	336671
22067	33019	0	applied	\N	\N	\N	\N	169425	169425	336676
22067	33020	1	applied	\N	\N	\N	\N	169426	169426	336677
22067	33022	2	applied	\N	\N	\N	\N	169427	169427	336678
22070	33029	0	applied	\N	\N	\N	\N	169440	169440	336691
22070	33030	1	applied	\N	\N	\N	\N	169441	169441	336692
22070	33031	2	applied	\N	\N	\N	\N	169442	169442	336693
22070	33032	3	applied	\N	\N	\N	\N	169443	169443	336694
22072	33033	0	applied	\N	\N	\N	\N	169455	169455	336705
22072	33034	1	applied	\N	\N	\N	\N	169456	169456	336706
22072	33035	2	applied	\N	\N	\N	\N	169457	169457	336707
22072	33036	3	applied	\N	\N	\N	\N	169458	169458	336708
22072	33037	4	applied	\N	\N	\N	\N	169459	169459	336709
22072	33038	5	applied	\N	\N	\N	\N	169460	169460	336710
22074	33034	1	applied	\N	\N	\N	\N	169468	169468	336718
22074	33035	2	applied	\N	\N	\N	\N	169469	169469	336719
22074	33036	3	applied	\N	\N	\N	\N	169470	169470	336720
22074	33037	4	applied	\N	\N	\N	\N	169471	169471	336721
22075	33033	0	applied	\N	\N	\N	\N	169473	169473	336723
22075	33034	1	applied	\N	\N	\N	\N	169474	169474	336724
22075	33035	2	applied	\N	\N	\N	\N	169475	169475	336725
22075	33036	3	applied	\N	\N	\N	\N	169476	169476	336726
22075	33037	4	applied	\N	\N	\N	\N	169477	169477	336727
22075	33038	5	applied	\N	\N	\N	\N	169478	169478	336728
22079	33046	0	applied	\N	\N	\N	\N	169494	169494	336744
22079	33047	1	applied	\N	\N	\N	\N	169495	169495	336745
22084	33055	0	applied	\N	\N	\N	\N	169577	169577	336827
22084	33059	1	applied	\N	\N	\N	\N	169578	169578	336828
22084	33057	2	applied	\N	\N	\N	\N	169579	169579	336829
22084	33058	3	applied	\N	\N	\N	\N	169580	169580	336830
22084	33061	5	applied	\N	\N	\N	\N	169582	169582	336832
22084	33056	6	applied	\N	\N	\N	\N	169583	169583	336833
22086	33059	0	applied	\N	\N	\N	\N	169591	169591	336841
22086	33060	1	applied	\N	\N	\N	\N	169592	169592	336842
22086	33061	2	applied	\N	\N	\N	\N	169593	169593	336843
22088	33062	0	applied	\N	\N	\N	\N	169601	169601	336851
22088	33063	1	applied	\N	\N	\N	\N	169602	169602	336852
22088	33064	2	applied	\N	\N	\N	\N	169603	169603	336853
22096	33087	0	applied	\N	\N	\N	\N	169634	169634	336884
22096	33088	1	applied	\N	\N	\N	\N	169635	169635	336885
22096	33089	2	applied	\N	\N	\N	\N	169636	169636	336886
22096	33090	3	applied	\N	\N	\N	\N	169637	169637	336887
22101	33101	0	applied	\N	\N	\N	\N	169662	169662	336912
22101	33102	1	applied	\N	\N	\N	\N	169663	169663	336913
21994	32865	1	applied	\N	\N	\N	\N	168908	168908	336160
21994	32866	2	applied	\N	\N	\N	\N	168909	168909	336161
21999	32703	1	applied	\N	\N	\N	\N	168926	168926	336178
21999	32704	2	applied	\N	\N	\N	\N	168927	168927	336179
21999	32709	4	applied	\N	\N	\N	\N	168928	168928	336180
21999	32712	5	applied	\N	\N	\N	\N	168929	168929	336181
21999	32715	6	applied	\N	\N	\N	\N	168930	168930	336182
21999	32719	7	applied	\N	\N	\N	\N	168931	168931	336183
21999	32720	8	applied	\N	\N	\N	\N	168932	168932	336184
21999	32725	9	applied	\N	\N	\N	\N	168933	168933	336185
21999	32726	10	applied	\N	\N	\N	\N	168934	168934	336186
21999	32731	11	applied	\N	\N	\N	\N	168935	168935	336187
21999	32732	12	applied	\N	\N	\N	\N	168936	168936	336188
21999	32737	13	applied	\N	\N	\N	\N	168937	168937	336189
21999	32738	14	applied	\N	\N	\N	\N	168938	168938	336190
21999	32739	15	applied	\N	\N	\N	\N	168939	168939	336191
21999	32740	16	applied	\N	\N	\N	\N	168940	168940	336192
21999	32741	17	applied	\N	\N	\N	\N	168941	168941	336193
21999	32743	19	applied	\N	\N	\N	\N	168943	168943	336195
21999	32758	20	applied	\N	\N	\N	\N	168944	168944	336196
21999	32761	21	applied	\N	\N	\N	\N	168945	168945	336197
21999	32764	22	applied	\N	\N	\N	\N	168946	168946	336198
21999	32765	23	applied	\N	\N	\N	\N	168947	168947	336199
21999	32769	24	applied	\N	\N	\N	\N	168948	168948	336200
21999	32771	25	applied	\N	\N	\N	\N	168949	168949	336201
21999	32774	26	applied	\N	\N	\N	\N	168950	168950	336202
21999	32777	27	applied	\N	\N	\N	\N	168951	168951	336203
21999	32778	28	applied	\N	\N	\N	\N	168952	168952	336204
21999	32784	29	applied	\N	\N	\N	\N	168953	168953	336205
21999	32787	30	applied	\N	\N	\N	\N	168954	168954	336206
21999	32790	31	applied	\N	\N	\N	\N	168955	168955	336207
21999	32793	32	applied	\N	\N	\N	\N	168956	168956	336208
21999	32794	33	applied	\N	\N	\N	\N	168957	168957	336209
21999	32795	34	applied	\N	\N	\N	\N	168958	168958	336210
21999	32803	36	applied	\N	\N	\N	\N	168960	168960	336212
21999	32808	37	applied	\N	\N	\N	\N	168961	168961	336213
21999	32809	38	applied	\N	\N	\N	\N	168962	168962	336214
21999	32814	39	applied	\N	\N	\N	\N	168963	168963	336215
21999	32815	40	applied	\N	\N	\N	\N	168964	168964	336216
21999	32816	41	applied	\N	\N	\N	\N	168965	168965	336217
21999	32823	42	applied	\N	\N	\N	\N	168966	168966	336218
21999	32826	43	applied	\N	\N	\N	\N	168967	168967	336219
21999	32829	44	applied	\N	\N	\N	\N	168968	168968	336220
21999	32830	45	applied	\N	\N	\N	\N	168969	168969	336221
21999	32835	46	applied	\N	\N	\N	\N	168970	168970	336222
21999	32838	47	applied	\N	\N	\N	\N	168971	168971	336223
21999	32839	48	applied	\N	\N	\N	\N	168972	168972	336224
21999	32844	49	applied	\N	\N	\N	\N	168973	168973	336225
21999	32847	50	applied	\N	\N	\N	\N	168974	168974	336226
21999	32850	51	applied	\N	\N	\N	\N	168975	168975	336227
21999	32855	53	applied	\N	\N	\N	\N	168977	168977	336229
21999	32856	54	applied	\N	\N	\N	\N	168978	168978	336230
21999	32861	55	applied	\N	\N	\N	\N	168979	168979	336231
21999	32864	56	applied	\N	\N	\N	\N	168980	168980	336232
21999	32865	57	applied	\N	\N	\N	\N	168981	168981	336233
21999	32870	58	applied	\N	\N	\N	\N	168982	168982	336234
21999	32873	59	applied	\N	\N	\N	\N	168983	168983	336235
21999	32876	60	applied	\N	\N	\N	\N	168984	168984	336236
21999	32721	61	applied	\N	\N	\N	\N	168985	168985	336237
21999	32779	62	applied	\N	\N	\N	\N	168986	168986	168986
21999	32489	63	applied	\N	\N	\N	\N	168987	168987	336238
21999	32493	64	applied	\N	\N	\N	\N	168988	168988	336239
21999	32494	65	applied	\N	\N	\N	\N	168989	168989	336240
21999	32500	66	applied	\N	\N	\N	\N	168990	168990	336241
21999	32501	67	applied	\N	\N	\N	\N	168991	168991	336242
21999	32504	68	applied	\N	\N	\N	\N	168992	168992	336243
21999	32511	70	applied	\N	\N	\N	\N	168994	168994	336245
21999	32512	71	applied	\N	\N	\N	\N	168995	168995	336246
21999	32519	72	applied	\N	\N	\N	\N	168996	168996	336247
21999	32520	73	applied	\N	\N	\N	\N	168997	168997	336248
21999	32524	74	applied	\N	\N	\N	\N	168998	168998	336249
21999	32525	75	applied	\N	\N	\N	\N	168999	168999	336250
21999	32529	76	applied	\N	\N	\N	\N	169000	169000	336251
21999	32530	77	applied	\N	\N	\N	\N	169001	169001	336252
21999	32537	78	applied	\N	\N	\N	\N	169002	169002	336253
21999	32538	79	applied	\N	\N	\N	\N	169003	169003	336254
21999	32539	80	applied	\N	\N	\N	\N	169004	169004	336255
21999	32540	81	applied	\N	\N	\N	\N	169005	169005	336256
21999	32547	82	applied	\N	\N	\N	\N	169006	169006	336257
21999	32548	83	applied	\N	\N	\N	\N	169007	169007	336258
21999	32555	84	applied	\N	\N	\N	\N	169008	169008	336259
21999	32556	85	applied	\N	\N	\N	\N	169009	169009	336260
21999	32562	87	applied	\N	\N	\N	\N	169011	169011	336262
21999	32566	88	applied	\N	\N	\N	\N	169012	169012	336263
21999	32567	89	applied	\N	\N	\N	\N	169013	169013	336264
21999	32568	90	applied	\N	\N	\N	\N	169014	169014	336265
21999	32573	91	applied	\N	\N	\N	\N	169015	169015	336266
21999	32576	92	applied	\N	\N	\N	\N	169016	169016	336267
21999	32577	93	applied	\N	\N	\N	\N	169017	169017	336268
21999	32582	94	applied	\N	\N	\N	\N	169018	169018	336269
21999	32584	95	applied	\N	\N	\N	\N	169019	169019	336270
21999	32588	96	applied	\N	\N	\N	\N	169020	169020	336271
21999	32590	97	applied	\N	\N	\N	\N	169021	169021	336272
21999	32595	98	applied	\N	\N	\N	\N	169022	169022	336273
22101	33103	2	applied	\N	\N	\N	\N	169664	169664	336914
22105	33124	0	applied	\N	\N	\N	\N	169685	169685	336935
22105	33125	1	applied	\N	\N	\N	\N	169686	169686	336936
22105	33126	2	applied	\N	\N	\N	\N	169687	169687	336937
22112	33139	0	applied	\N	\N	\N	\N	169715	169715	169715
22112	33062	1	applied	\N	\N	\N	\N	169716	169716	336964
22112	33065	2	applied	\N	\N	\N	\N	169717	169717	336965
22112	33069	3	applied	\N	\N	\N	\N	169718	169718	336966
22112	33070	4	applied	\N	\N	\N	\N	169719	169719	336967
22112	33071	5	applied	\N	\N	\N	\N	169720	169720	336968
22112	33081	6	applied	\N	\N	\N	\N	169721	169721	336969
22112	33084	7	applied	\N	\N	\N	\N	169722	169722	336970
22112	33087	8	applied	\N	\N	\N	\N	169723	169723	336971
22112	33091	9	applied	\N	\N	\N	\N	169724	169724	336972
22112	33094	10	applied	\N	\N	\N	\N	169725	169725	336973
22112	33095	11	applied	\N	\N	\N	\N	169726	169726	336974
22112	33125	12	applied	\N	\N	\N	\N	169727	169727	336975
22112	33129	13	applied	\N	\N	\N	\N	169728	169728	336976
21997	32877	1	applied	\N	\N	\N	\N	168920	168920	336172
21997	32878	2	applied	\N	\N	\N	\N	168921	168921	336173
21999	32608	103	applied	\N	\N	\N	\N	169027	169027	336278
21999	32611	104	applied	\N	\N	\N	\N	169028	169028	336279
21999	32616	105	applied	\N	\N	\N	\N	169029	169029	336280
21999	32618	106	applied	\N	\N	\N	\N	169030	169030	336281
21999	32619	107	applied	\N	\N	\N	\N	169031	169031	336282
21999	32623	108	applied	\N	\N	\N	\N	169032	169032	336283
21999	32626	109	applied	\N	\N	\N	\N	169033	169033	336284
21999	32630	110	applied	\N	\N	\N	\N	169034	169034	336285
21999	32633	111	applied	\N	\N	\N	\N	169035	169035	336286
21999	32635	112	applied	\N	\N	\N	\N	169036	169036	336287
21999	32639	113	applied	\N	\N	\N	\N	169037	169037	336288
21999	32644	114	applied	\N	\N	\N	\N	169038	169038	336289
21999	32645	115	applied	\N	\N	\N	\N	169039	169039	336290
21999	32647	116	applied	\N	\N	\N	\N	169040	169040	336291
21999	32651	117	applied	\N	\N	\N	\N	169041	169041	336292
21999	32656	118	applied	\N	\N	\N	\N	169042	169042	336293
21999	32660	120	applied	\N	\N	\N	\N	169044	169044	336295
21999	32661	121	applied	\N	\N	\N	\N	169045	169045	336296
21999	32665	122	applied	\N	\N	\N	\N	169046	169046	336297
21999	32669	123	applied	\N	\N	\N	\N	169047	169047	336298
21999	32671	124	applied	\N	\N	\N	\N	169048	169048	336299
21999	32675	125	applied	\N	\N	\N	\N	169049	169049	336300
22004	32885	0	applied	\N	\N	\N	\N	169062	169062	336313
22004	32886	1	applied	\N	\N	\N	\N	169063	169063	336314
22004	32887	2	applied	\N	\N	\N	\N	169064	169064	336315
22009	32897	0	applied	\N	\N	\N	\N	169081	169081	336332
22009	32898	2	applied	\N	\N	\N	\N	169082	169082	336333
22009	32899	3	applied	\N	\N	\N	\N	169083	169083	336334
22011	32897	0	applied	\N	\N	\N	\N	169086	169086	336337
22011	32898	2	applied	\N	\N	\N	\N	169087	169087	336338
22011	32899	3	applied	\N	\N	\N	\N	169088	169088	336339
22018	32906	0	applied	\N	\N	\N	\N	169108	169108	336359
22018	32905	2	applied	\N	\N	\N	\N	169110	169110	336361
22018	32908	3	applied	\N	\N	\N	\N	169111	169111	336362
22022	32909	0	applied	\N	\N	\N	\N	169124	169124	336375
22022	32910	1	applied	\N	\N	\N	\N	169125	169125	336376
22022	32911	2	applied	\N	\N	\N	\N	169126	169126	336377
22024	32912	0	applied	\N	\N	\N	\N	169130	169130	336381
22024	32913	1	applied	\N	\N	\N	\N	169131	169131	336382
22024	32914	2	applied	\N	\N	\N	\N	169132	169132	336383
22029	32921	0	applied	\N	\N	\N	\N	169143	169143	336394
22029	32922	1	applied	\N	\N	\N	\N	169144	169144	336395
22032	32937	0	applied	\N	\N	\N	\N	169166	169166	336417
22032	32938	1	applied	\N	\N	\N	\N	169167	169167	336418
22034	32937	0	applied	\N	\N	\N	\N	169171	169171	336422
22034	32939	1	applied	\N	\N	\N	\N	169172	169172	336423
22034	32938	2	applied	\N	\N	\N	\N	169173	169173	336424
22039	32957	0	applied	\N	\N	\N	\N	169316	169316	336567
22042	32963	0	applied	\N	\N	\N	\N	169326	169326	336577
22042	32964	1	applied	\N	\N	\N	\N	169327	169327	336578
22042	32965	2	applied	\N	\N	\N	\N	169328	169328	336579
22042	32966	3	applied	\N	\N	\N	\N	169329	169329	336580
22045	32969	0	applied	\N	\N	\N	\N	169346	169346	336597
22045	32970	1	applied	\N	\N	\N	\N	169347	169347	336598
22045	32971	2	applied	\N	\N	\N	\N	169348	169348	336599
22045	32972	3	applied	\N	\N	\N	\N	169349	169349	336600
22045	32973	4	applied	\N	\N	\N	\N	169350	169350	336601
22045	32974	5	applied	\N	\N	\N	\N	169351	169351	336602
22045	32975	6	applied	\N	\N	\N	\N	169352	169352	336603
22045	32976	7	applied	\N	\N	\N	\N	169353	169353	336604
22045	32977	8	applied	\N	\N	\N	\N	169354	169354	336605
22045	32978	9	applied	\N	\N	\N	\N	169355	169355	336606
22045	32979	10	applied	\N	\N	\N	\N	169356	169356	336607
22045	32980	11	applied	\N	\N	\N	\N	169357	169357	336608
22045	32982	13	applied	\N	\N	\N	\N	169359	169359	336610
22049	32986	0	applied	\N	\N	\N	\N	169369	169369	336620
22049	32987	1	applied	\N	\N	\N	\N	169370	169370	336621
22049	32988	2	applied	\N	\N	\N	\N	169371	169371	336622
22049	32989	3	applied	\N	\N	\N	\N	169372	169372	336623
22058	33000	0	applied	\N	\N	\N	\N	169390	169390	336641
22058	33001	1	applied	\N	\N	\N	\N	169391	169391	336642
22058	33002	2	applied	\N	\N	\N	\N	169392	169392	336643
22060	33000	0	applied	\N	\N	\N	\N	169396	169396	336647
22060	33001	1	applied	\N	\N	\N	\N	169397	169397	336648
22060	33002	2	applied	\N	\N	\N	\N	169398	169398	336649
22061	33003	0	applied	\N	\N	\N	\N	169399	169399	336650
22061	33004	1	applied	\N	\N	\N	\N	169400	169400	336651
22061	33005	2	applied	\N	\N	\N	\N	169401	169401	336652
22061	33006	3	applied	\N	\N	\N	\N	169402	169402	336653
22061	33007	4	applied	\N	\N	\N	\N	169403	169403	336654
22061	33009	6	applied	\N	\N	\N	\N	169405	169405	336656
22061	33010	7	applied	\N	\N	\N	\N	169406	169406	336657
22061	33011	8	applied	\N	\N	\N	\N	169407	169407	336658
22061	33012	9	applied	\N	\N	\N	\N	169408	169408	336659
22068	33023	0	applied	\N	\N	\N	\N	169428	169428	336679
22068	33024	1	applied	\N	\N	\N	\N	169429	169429	336680
22068	33025	2	applied	\N	\N	\N	\N	169430	169430	336681
22068	33026	3	applied	\N	\N	\N	\N	169431	169431	336682
22068	33027	4	applied	\N	\N	\N	\N	169432	169432	336683
22068	33028	5	applied	\N	\N	\N	\N	169433	169433	336684
22076	33033	0	applied	\N	\N	\N	\N	169479	169479	336729
22076	33034	1	applied	\N	\N	\N	\N	169480	169480	336730
22076	33035	2	applied	\N	\N	\N	\N	169481	169481	336731
22076	33036	3	applied	\N	\N	\N	\N	169482	169482	336732
22076	33037	4	applied	\N	\N	\N	\N	169483	169483	336733
22076	33038	5	applied	\N	\N	\N	\N	169484	169484	336734
22077	33040	1	applied	\N	\N	\N	\N	169486	169486	336736
22077	33041	2	applied	\N	\N	\N	\N	169487	169487	336737
22077	33042	3	applied	\N	\N	\N	\N	169488	169488	336738
22077	33043	4	applied	\N	\N	\N	\N	169489	169489	336739
22077	33044	5	applied	\N	\N	\N	\N	169490	169490	336740
22082	33033	0	applied	\N	\N	\N	\N	169503	169503	336753
22082	32990	1	applied	\N	\N	\N	\N	169504	169504	336754
22082	32993	2	applied	\N	\N	\N	\N	169505	169505	336755
22082	32996	3	applied	\N	\N	\N	\N	169506	169506	336756
22082	33000	4	applied	\N	\N	\N	\N	169507	169507	336757
22082	33003	5	applied	\N	\N	\N	\N	169508	169508	336758
22082	33004	6	applied	\N	\N	\N	\N	169509	169509	336759
22082	33035	7	applied	\N	\N	\N	\N	169510	169510	336760
22082	33036	8	applied	\N	\N	\N	\N	169511	169511	336761
21999	32601	100	applied	\N	\N	\N	\N	169024	169024	336275
21999	32602	101	applied	\N	\N	\N	\N	169025	169025	336276
22016	32908	3	applied	\N	\N	\N	\N	169103	169103	336354
22019	32906	0	applied	\N	\N	\N	\N	169112	169112	336363
22019	32907	1	applied	\N	\N	\N	\N	169113	169113	336364
22019	32905	2	applied	\N	\N	\N	\N	169114	169114	336365
22019	32908	3	applied	\N	\N	\N	\N	169115	169115	336366
22023	32909	0	applied	\N	\N	\N	\N	169127	169127	336378
22023	32910	1	applied	\N	\N	\N	\N	169128	169128	336379
22023	32911	2	applied	\N	\N	\N	\N	169129	169129	336380
22027	32918	0	applied	\N	\N	\N	\N	169137	169137	336388
22027	32919	1	applied	\N	\N	\N	\N	169138	169138	336389
22027	32920	2	applied	\N	\N	\N	\N	169139	169139	336390
22030	32923	0	applied	\N	\N	\N	\N	169145	169145	336396
22030	32924	1	applied	\N	\N	\N	\N	169146	169146	336397
22030	32926	3	applied	\N	\N	\N	\N	169148	169148	336399
22030	32927	4	applied	\N	\N	\N	\N	169149	169149	336400
22030	32928	5	applied	\N	\N	\N	\N	169150	169150	336401
22030	32929	6	applied	\N	\N	\N	\N	169151	169151	336402
22036	32320	0	applied	\N	\N	1000000000	\N	169178	169178	336429
22036	32267	1	applied	\N	\N	\N	\N	169179	169179	336430
22036	32149	2	applied	\N	\N	\N	\N	169180	169180	336431
22036	32154	3	applied	\N	\N	\N	\N	169181	169181	336432
22036	32157	4	applied	\N	\N	\N	\N	169182	169182	336433
22036	32158	5	applied	\N	\N	\N	\N	169183	169183	336434
22036	32164	6	applied	\N	\N	\N	\N	169184	169184	336435
22036	32167	7	applied	\N	\N	\N	\N	169185	169185	336436
22036	32254	8	applied	\N	\N	\N	\N	169186	169186	336437
22036	32221	9	applied	\N	\N	\N	\N	169187	169187	336438
22036	32923	10	applied	\N	\N	\N	\N	169188	169188	336439
22036	32924	11	applied	\N	\N	\N	\N	169189	169189	336440
22036	32218	13	applied	\N	\N	\N	\N	169191	169191	336442
22036	32196	14	applied	\N	\N	\N	\N	169192	169192	336443
22036	32232	15	applied	\N	\N	1000000000	\N	169193	169193	336444
22036	32168	16	applied	\N	\N	\N	\N	169194	169194	336445
22036	32197	17	applied	\N	\N	\N	\N	169195	169195	336446
22036	32171	18	applied	\N	\N	\N	\N	169196	169196	336447
22036	32177	19	applied	\N	\N	\N	\N	169197	169197	336448
22036	32180	20	applied	\N	\N	\N	\N	169198	169198	336449
22036	32183	21	applied	\N	\N	\N	\N	169199	169199	336450
22036	32186	22	applied	\N	\N	\N	\N	169200	169200	336451
22036	32191	23	applied	\N	\N	\N	\N	169201	169201	336452
22036	32194	24	applied	\N	\N	\N	\N	169202	169202	336453
22036	32195	25	applied	\N	\N	\N	\N	169203	169203	336454
22036	32202	26	applied	\N	\N	\N	\N	169204	169204	336455
22036	32205	27	applied	\N	\N	\N	\N	169205	169205	336456
22036	32206	28	applied	\N	\N	\N	\N	169206	169206	336457
22036	32214	30	applied	\N	\N	\N	\N	169208	169208	336459
22036	32217	31	applied	\N	\N	\N	\N	169209	169209	336460
22036	32222	32	applied	\N	\N	\N	\N	169210	169210	336461
22036	32225	33	applied	\N	\N	\N	\N	169211	169211	336462
22036	32228	34	applied	\N	\N	\N	\N	169212	169212	336463
22036	32231	35	applied	\N	\N	\N	\N	169213	169213	336464
22036	32235	36	applied	\N	\N	\N	\N	169214	169214	336465
22036	32239	37	applied	\N	\N	\N	\N	169215	169215	336466
22036	32242	38	applied	\N	\N	\N	\N	169216	169216	336467
22036	32243	39	applied	\N	\N	\N	\N	169217	169217	336468
22036	32248	40	applied	\N	\N	\N	\N	169218	169218	336469
22036	32251	41	applied	\N	\N	\N	\N	169219	169219	336470
22036	32255	42	applied	\N	\N	\N	\N	169220	169220	336471
22036	32258	43	applied	\N	\N	\N	\N	169221	169221	336472
22036	32261	44	applied	\N	\N	\N	\N	169222	169222	336473
22036	32264	45	applied	\N	\N	\N	\N	169223	169223	336474
22036	32271	47	applied	\N	\N	\N	\N	169225	169225	336476
22036	32172	48	applied	\N	\N	\N	\N	169226	169226	336477
22036	32173	49	applied	\N	\N	\N	\N	169227	169227	336478
22036	32174	50	applied	\N	\N	\N	\N	169228	169228	336479
22036	32278	51	applied	\N	\N	\N	\N	169229	169229	336480
22036	32274	52	applied	\N	\N	\N	\N	169230	169230	336481
22036	32279	53	applied	\N	\N	\N	\N	169231	169231	336482
22036	32280	54	applied	\N	\N	\N	\N	169232	169232	336483
22036	32926	55	applied	\N	\N	\N	\N	169233	169233	336484
22036	32287	56	applied	\N	\N	\N	\N	169234	169234	336485
22036	32290	57	applied	\N	\N	\N	\N	169235	169235	336486
22036	32291	58	applied	\N	\N	\N	\N	169236	169236	336487
22036	32296	59	applied	\N	\N	\N	\N	169237	169237	336488
22036	32299	60	applied	\N	\N	\N	\N	169238	169238	336489
22036	32302	61	applied	\N	\N	\N	\N	169239	169239	336490
22036	32305	62	applied	\N	\N	\N	\N	169240	169240	336491
22036	32307	64	applied	\N	\N	\N	\N	169242	169242	336493
22036	32308	65	applied	\N	\N	\N	\N	169243	169243	336494
22036	32317	66	applied	\N	\N	\N	\N	169244	169244	336495
22036	32321	67	applied	\N	\N	\N	\N	169245	169245	336496
22036	32322	68	applied	\N	\N	\N	\N	169246	169246	336497
22036	32327	69	applied	\N	\N	\N	\N	169247	169247	336498
22036	32330	70	applied	\N	\N	\N	\N	169248	169248	336499
22036	32331	71	applied	\N	\N	\N	\N	169249	169249	336500
22036	32335	72	applied	\N	\N	\N	\N	169250	169250	336501
22036	32338	73	applied	\N	\N	\N	\N	169251	169251	336502
22036	32339	74	applied	\N	\N	\N	\N	169252	169252	336503
22036	32344	75	applied	\N	\N	\N	\N	169253	169253	336504
22036	32345	76	applied	\N	\N	\N	\N	169254	169254	336505
22036	32346	77	applied	\N	\N	\N	\N	169255	169255	336506
22036	32347	78	applied	\N	\N	\N	\N	169256	169256	336507
22082	33054	9	applied	\N	\N	\N	\N	169512	169512	336762
22082	33013	11	applied	\N	\N	\N	\N	169514	169514	336764
22082	33016	12	applied	\N	\N	\N	\N	169515	169515	336765
22082	33019	13	applied	\N	\N	\N	\N	169516	169516	336766
22082	33023	14	applied	\N	\N	\N	\N	169517	169517	336767
22082	33024	15	applied	\N	\N	\N	\N	169518	169518	336768
22082	33029	16	applied	\N	\N	\N	\N	169519	169519	336769
22082	33034	17	applied	\N	\N	\N	\N	169520	169520	336770
22082	33039	18	applied	\N	\N	\N	\N	169521	169521	336771
22082	33040	19	applied	\N	\N	\N	\N	169522	169522	336772
22082	33045	20	applied	\N	\N	\N	\N	169523	169523	336773
22082	33048	21	applied	\N	\N	\N	\N	169524	169524	336774
22082	33051	22	applied	\N	\N	\N	\N	169525	169525	336775
22082	33055	23	applied	\N	\N	\N	\N	169526	169526	336776
22082	32991	24	applied	\N	\N	\N	\N	169527	169527	336777
22082	32994	25	applied	\N	\N	\N	\N	169528	169528	336778
22082	32992	26	applied	\N	\N	\N	\N	169529	169529	336779
22016	32907	1	applied	\N	\N	\N	\N	169101	169101	336352
22016	32905	2	applied	\N	\N	\N	\N	169102	169102	336353
22036	32381	83	applied	\N	\N	\N	\N	169261	169261	336512
22036	32382	84	applied	\N	\N	\N	\N	169262	169262	336513
22036	32387	85	applied	\N	\N	\N	\N	169263	169263	336514
22036	32390	86	applied	\N	\N	\N	\N	169264	169264	336515
22036	32393	87	applied	\N	\N	\N	\N	169265	169265	336516
22036	32396	88	applied	\N	\N	\N	\N	169266	169266	336517
22036	32399	89	applied	\N	\N	\N	\N	169267	169267	336518
22036	32402	90	applied	\N	\N	\N	\N	169268	169268	336519
22036	32405	91	applied	\N	\N	\N	\N	169269	169269	336520
22036	32408	92	applied	\N	\N	\N	\N	169270	169270	336521
22036	32411	93	applied	\N	\N	\N	\N	169271	169271	336522
22036	32414	94	applied	\N	\N	\N	\N	169272	169272	336523
22036	32417	95	applied	\N	\N	\N	\N	169273	169273	336524
22036	32420	96	applied	\N	\N	\N	\N	169274	169274	336525
22036	32421	97	applied	\N	\N	\N	\N	169275	169275	336526
22036	32426	98	applied	\N	\N	\N	\N	169276	169276	336527
22036	32432	100	applied	\N	\N	\N	\N	169278	169278	336529
22036	32435	101	applied	\N	\N	\N	\N	169279	169279	336530
22036	32436	102	applied	\N	\N	\N	\N	169280	169280	336531
22036	32437	103	applied	\N	\N	\N	\N	169281	169281	336532
22036	32444	104	applied	\N	\N	\N	\N	169282	169282	336533
22036	32446	105	applied	\N	\N	\N	\N	169283	169283	336534
22036	32450	106	applied	\N	\N	\N	\N	169284	169284	336535
22036	32453	108	applied	\N	\N	\N	\N	169285	169285	336536
22036	32456	109	applied	\N	\N	\N	\N	169286	169286	336537
22036	32458	110	applied	\N	\N	\N	\N	169287	169287	336538
22036	32461	111	applied	\N	\N	\N	\N	169288	169288	336539
22036	32462	112	applied	\N	\N	\N	\N	169289	169289	336540
22036	32469	113	applied	\N	\N	\N	\N	169290	169290	336541
22036	32476	114	applied	\N	\N	\N	\N	169291	169291	336542
22036	32477	115	applied	\N	\N	\N	\N	169292	169292	336543
22036	32482	116	applied	\N	\N	\N	\N	169293	169293	336544
22036	32488	118	applied	\N	\N	\N	\N	169295	169295	336546
22036	32491	119	applied	\N	\N	\N	\N	169296	169296	336547
22036	32492	120	applied	\N	\N	\N	\N	169297	169297	336548
22036	32497	121	applied	\N	\N	\N	\N	169298	169298	336549
22036	32498	122	applied	\N	\N	\N	\N	169299	169299	336550
22036	32503	123	applied	\N	\N	\N	\N	169300	169300	336551
22036	32506	124	applied	\N	\N	\N	\N	169301	169301	336552
22036	32509	125	applied	\N	\N	\N	\N	169302	169302	336553
22037	32944	0	applied	\N	\N	\N	\N	169303	169303	336554
22037	32945	1	applied	\N	\N	\N	\N	169304	169304	336555
22037	32946	2	applied	\N	\N	\N	\N	169305	169305	336556
22037	32947	3	applied	\N	\N	\N	\N	169306	169306	336557
22037	32948	4	applied	\N	\N	\N	\N	169307	169307	336558
22037	32949	5	applied	\N	\N	\N	\N	169308	169308	336559
22037	32950	6	applied	\N	\N	\N	\N	169309	169309	336560
22037	32951	7	applied	\N	\N	\N	\N	169310	169310	336561
22048	32983	0	applied	\N	\N	\N	\N	169366	169366	336617
22048	32984	1	applied	\N	\N	\N	\N	169367	169367	336618
22048	32985	2	applied	\N	\N	\N	\N	169368	169368	336619
22054	32993	0	applied	\N	\N	\N	\N	169380	169380	336631
22054	32994	1	applied	\N	\N	\N	\N	169381	169381	336632
22054	32995	2	applied	\N	\N	\N	\N	169382	169382	336633
22059	33000	0	applied	\N	\N	\N	\N	169393	169393	336644
22059	33001	1	applied	\N	\N	\N	\N	169394	169394	336645
22059	33002	2	applied	\N	\N	\N	\N	169395	169395	336646
22064	33013	0	applied	\N	\N	\N	\N	169415	169415	336666
22064	33014	1	applied	\N	\N	\N	\N	169416	169416	336667
22064	33015	2	applied	\N	\N	\N	\N	169417	169417	336668
22066	33019	0	applied	\N	\N	\N	\N	169421	169421	336672
22066	33020	1	applied	\N	\N	\N	\N	169422	169422	336673
22066	33021	2	applied	\N	\N	\N	\N	169423	169423	336674
22066	33022	3	applied	\N	\N	\N	\N	169424	169424	336675
22069	33024	1	applied	\N	\N	\N	\N	169435	169435	336686
22069	33025	2	applied	\N	\N	\N	\N	169436	169436	336687
22069	33026	3	applied	\N	\N	\N	\N	169437	169437	336688
22069	33027	4	applied	\N	\N	\N	\N	169438	169438	336689
22069	33028	5	applied	\N	\N	\N	\N	169439	169439	336690
22071	32923	0	applied	\N	\N	\N	\N	169444	169444	336695
22071	32924	1	applied	\N	\N	\N	\N	169445	169445	336696
22071	32925	2	applied	\N	\N	\N	\N	169446	169446	336697
22071	32926	3	applied	\N	\N	\N	\N	169447	169447	336698
22071	32721	4	applied	\N	\N	\N	\N	169448	169448	336699
22071	32779	5	applied	\N	\N	\N	\N	169449	169449	169449
22071	32470	6	applied	\N	\N	\N	\N	169450	169450	336700
22071	32471	7	applied	\N	\N	\N	\N	169451	169451	336701
22071	32472	8	applied	\N	\N	\N	\N	169452	169452	336702
22071	32474	9	applied	\N	\N	\N	\N	169453	169453	336703
22071	29757	10	applied	\N	\N	\N	\N	169454	169454	336704
22073	33034	1	applied	\N	\N	\N	\N	169462	169462	336712
22073	33035	2	applied	\N	\N	\N	\N	169463	169463	336713
22073	33036	3	applied	\N	\N	\N	\N	169464	169464	336714
22073	33037	4	applied	\N	\N	\N	\N	169465	169465	336715
22073	33038	5	applied	\N	\N	\N	\N	169466	169466	336716
22078	33045	0	applied	\N	\N	\N	\N	169491	169491	336741
22078	33046	1	applied	\N	\N	\N	\N	169492	169492	336742
22078	33047	2	applied	\N	\N	\N	\N	169493	169493	336743
22080	33045	0	applied	\N	\N	\N	\N	169496	169496	336746
22080	33048	1	applied	\N	\N	\N	\N	169497	169497	336747
22080	33049	2	applied	\N	\N	\N	\N	169498	169498	336748
22080	33050	3	applied	\N	\N	\N	\N	169499	169499	336749
22083	33055	0	applied	\N	\N	\N	\N	169572	169572	336822
22083	33059	1	applied	\N	\N	\N	\N	169573	169573	336823
22083	33058	2	applied	\N	\N	\N	\N	169574	169574	336824
22083	33060	3	applied	\N	\N	\N	\N	169575	169575	336825
22085	33055	0	applied	\N	\N	\N	\N	169584	169584	336834
22085	33059	1	applied	\N	\N	\N	\N	169585	169585	336835
22085	33057	2	applied	\N	\N	\N	\N	169586	169586	336836
22085	33058	3	applied	\N	\N	\N	\N	169587	169587	336837
22085	33060	4	applied	\N	\N	\N	\N	169588	169588	336838
22085	33061	5	applied	\N	\N	\N	\N	169589	169589	336839
22085	33056	6	applied	\N	\N	\N	\N	169590	169590	336840
22087	33055	0	applied	\N	\N	\N	\N	169594	169594	336844
22087	33059	1	applied	\N	\N	\N	\N	169595	169595	336845
22087	33057	2	applied	\N	\N	\N	\N	169596	169596	336846
22087	33058	3	applied	\N	\N	\N	\N	169597	169597	336847
22087	33060	4	applied	\N	\N	\N	\N	169598	169598	336848
22087	33061	5	applied	\N	\N	\N	\N	169599	169599	336849
22087	33056	6	applied	\N	\N	\N	\N	169600	169600	336850
22036	32359	80	applied	\N	\N	\N	\N	169258	169258	336509
22036	32362	81	applied	\N	\N	\N	\N	169259	169259	336510
22089	33062	0	applied	\N	\N	\N	\N	169604	169604	336854
22089	33063	1	applied	\N	\N	\N	\N	169605	169605	336855
22089	33064	2	applied	\N	\N	\N	\N	169606	169606	336856
22090	33065	0	applied	\N	\N	\N	\N	169607	169607	336857
22090	33066	1	applied	\N	\N	\N	\N	169608	169608	336858
22093	33081	0	applied	\N	\N	\N	\N	169625	169625	336875
22093	33082	1	applied	\N	\N	\N	\N	169626	169626	336876
22093	33083	2	applied	\N	\N	\N	\N	169627	169627	336877
22095	33084	0	applied	\N	\N	\N	\N	169631	169631	336881
22095	33085	1	applied	\N	\N	\N	\N	169632	169632	336882
22095	33086	2	applied	\N	\N	\N	\N	169633	169633	336883
22098	33094	0	applied	\N	\N	\N	\N	169641	169641	336891
22098	33095	1	applied	\N	\N	\N	\N	169642	169642	336892
22098	33096	2	applied	\N	\N	\N	\N	169643	169643	336893
22098	33097	3	applied	\N	\N	\N	\N	169644	169644	336894
22098	33098	4	applied	\N	\N	\N	\N	169645	169645	336895
22098	33100	6	applied	\N	\N	\N	\N	169647	169647	336897
22099	33094	0	applied	\N	\N	\N	\N	169648	169648	336898
22099	33095	1	applied	\N	\N	\N	\N	169649	169649	336899
22099	33096	2	applied	\N	\N	\N	\N	169650	169650	336900
22099	33097	3	applied	\N	\N	\N	\N	169651	169651	336901
22099	33098	4	applied	\N	\N	\N	\N	169652	169652	336902
22099	33099	5	applied	\N	\N	\N	\N	169653	169653	336903
22099	33100	6	applied	\N	\N	\N	\N	169654	169654	336904
22103	33107	0	applied	\N	\N	\N	\N	169668	169668	336918
22103	33108	1	applied	\N	\N	\N	\N	169669	169669	336919
22103	33109	2	applied	\N	\N	\N	\N	169670	169670	336920
22103	33110	3	applied	\N	\N	\N	\N	169671	169671	336921
22103	33111	4	applied	\N	\N	\N	\N	169672	169672	336922
22103	33112	5	applied	\N	\N	\N	\N	169673	169673	336923
22104	33117	0	applied	\N	\N	\N	\N	169678	169678	336928
22104	33118	1	applied	\N	\N	\N	\N	169679	169679	336929
22104	33120	3	applied	\N	\N	\N	\N	169681	169681	336931
22104	33121	4	applied	\N	\N	\N	\N	169682	169682	336932
22104	33122	5	applied	\N	\N	\N	\N	169683	169683	336933
22104	33123	6	applied	\N	\N	\N	\N	169684	169684	336934
22107	33128	0	applied	\N	\N	\N	\N	169693	169693	336943
22107	33129	1	applied	\N	\N	\N	\N	169694	169694	336944
22107	33130	2	applied	\N	\N	\N	\N	169695	169695	336945
22107	33131	3	applied	\N	\N	\N	\N	169696	169696	336946
22107	33132	4	applied	\N	\N	\N	\N	169697	169697	336947
22107	33133	5	applied	\N	\N	\N	\N	169698	169698	336948
22107	33134	6	applied	\N	\N	\N	\N	169699	169699	336949
22107	33135	7	applied	\N	\N	\N	\N	169700	169700	336950
22116	33148	0	applied	\N	\N	\N	\N	169785	169785	337033
22116	33147	1	applied	\N	\N	\N	\N	169786	169786	337034
22116	33149	2	applied	\N	\N	\N	\N	169787	169787	337035
22116	33150	3	applied	\N	\N	\N	\N	169788	169788	337036
22119	33162	0	applied	\N	\N	\N	\N	169807	169807	337055
22119	33163	1	applied	\N	\N	\N	\N	169808	169808	337056
22119	33164	2	applied	\N	\N	\N	\N	169809	169809	337057
22119	33165	3	applied	\N	\N	\N	\N	169810	169810	337058
22119	33166	4	applied	\N	\N	\N	\N	169811	169811	337059
22119	33167	5	applied	\N	\N	\N	\N	169812	169812	337060
22119	33168	6	applied	\N	\N	\N	\N	169813	169813	337061
22125	33177	0	applied	\N	\N	\N	\N	169835	169835	337083
22125	33178	1	applied	\N	\N	\N	\N	169836	169836	337084
22125	33179	2	applied	\N	\N	\N	\N	169837	169837	337085
22126	33180	0	applied	\N	\N	\N	\N	169838	169838	337086
22126	33181	1	applied	\N	\N	\N	\N	169839	169839	337087
22126	33182	2	applied	\N	\N	\N	\N	169840	169840	337088
22126	33183	3	applied	\N	\N	\N	\N	169841	169841	337089
22129	33190	0	applied	\N	\N	\N	\N	169848	169848	337096
22129	33191	1	applied	\N	\N	\N	\N	169849	169849	337097
22129	33193	3	applied	\N	\N	\N	\N	169851	169851	337099
22129	33194	4	applied	\N	\N	\N	\N	169852	169852	337100
22129	33195	5	applied	\N	\N	\N	\N	169853	169853	337101
22129	33196	6	applied	\N	\N	\N	\N	169854	169854	337102
22132	33197	0	applied	\N	\N	\N	\N	169867	169867	337115
22132	33198	1	applied	\N	\N	\N	\N	169868	169868	337116
22132	33199	2	applied	\N	\N	\N	\N	169869	169869	337117
22132	33200	3	applied	\N	\N	\N	\N	169870	169870	337118
22132	33201	4	applied	\N	\N	\N	\N	169871	169871	337119
22132	33202	5	applied	\N	\N	\N	\N	169872	169872	337120
22135	33203	0	applied	\N	\N	\N	\N	169877	169877	337125
22135	33204	1	applied	\N	\N	\N	\N	169878	169878	337126
22135	33205	2	applied	\N	\N	\N	\N	169879	169879	337127
22135	33206	3	applied	\N	\N	\N	\N	169880	169880	337128
22137	33207	0	applied	\N	\N	\N	\N	169885	169885	337133
22137	33208	1	applied	\N	\N	\N	\N	169886	169886	337134
22137	33210	3	applied	\N	\N	\N	\N	169888	169888	337136
22137	33211	4	applied	\N	\N	\N	\N	169889	169889	337137
22137	33212	5	applied	\N	\N	\N	\N	169890	169890	337138
22137	33213	6	applied	\N	\N	\N	\N	169891	169891	337139
22137	33214	7	applied	\N	\N	\N	\N	169892	169892	337140
22137	33215	8	applied	\N	\N	\N	\N	169893	169893	337141
22137	33216	9	applied	\N	\N	\N	\N	169894	169894	337142
22141	33226	0	applied	\N	\N	\N	\N	169915	169915	337162
22141	33227	1	applied	\N	\N	\N	\N	169916	169916	337163
22141	33228	2	applied	\N	\N	\N	\N	169917	169917	337164
22141	33229	3	applied	\N	\N	\N	\N	169918	169918	337165
22141	33230	4	applied	\N	\N	\N	\N	169919	169919	169919
22141	33231	5	applied	\N	\N	\N	\N	169920	169920	337166
22141	33232	6	applied	\N	\N	\N	\N	169921	169921	337167
22141	33233	7	applied	\N	\N	\N	\N	169922	169922	337168
22141	33234	8	applied	\N	\N	\N	\N	169923	169923	337169
22141	33236	10	applied	\N	\N	\N	\N	169925	169925	337171
22147	33241	0	applied	\N	\N	\N	\N	169955	169955	337198
22147	33242	1	applied	\N	\N	\N	\N	169956	169956	337199
22147	33243	2	applied	\N	\N	\N	\N	169957	169957	337200
22150	33254	0	applied	\N	\N	\N	\N	169968	169968	337211
22150	33255	1	applied	\N	\N	\N	\N	169969	169969	337212
22150	33256	2	applied	\N	\N	\N	\N	169970	169970	337213
22154	33257	0	applied	\N	\N	\N	\N	169991	169991	337234
22154	33258	1	applied	\N	\N	\N	\N	169992	169992	337235
22154	33259	2	applied	\N	\N	\N	\N	169993	169993	337236
22154	33260	3	applied	\N	\N	\N	\N	169994	169994	337237
22154	33261	4	applied	\N	\N	\N	\N	169995	169995	337238
22154	33262	5	applied	\N	\N	\N	\N	169996	169996	337239
22154	33263	6	applied	\N	\N	\N	\N	169997	169997	337240
22081	33051	0	applied	\N	\N	\N	\N	169500	169500	336750
22081	33052	1	applied	\N	\N	\N	\N	169501	169501	336751
22082	33001	32	applied	\N	\N	\N	\N	169535	169535	336785
22082	33007	33	applied	\N	\N	\N	\N	169536	169536	336786
22082	33008	34	applied	\N	\N	\N	\N	169537	169537	336787
22082	33009	35	applied	\N	\N	\N	\N	169538	169538	336788
22082	33015	36	applied	\N	\N	\N	\N	169539	169539	336789
22082	33017	37	applied	\N	\N	\N	\N	169540	169540	336790
22082	33021	38	applied	\N	\N	\N	\N	169541	169541	336791
22082	33032	39	applied	\N	\N	\N	\N	169542	169542	336792
22082	33042	40	applied	\N	\N	\N	\N	169543	169543	336793
22082	33056	41	applied	\N	\N	\N	\N	169544	169544	336794
22082	32999	42	applied	\N	\N	\N	\N	169545	169545	336795
22082	33027	43	applied	\N	\N	\N	\N	169546	169546	336796
22082	33028	44	applied	\N	\N	\N	\N	169547	169547	336797
22082	33030	45	applied	\N	\N	\N	\N	169548	169548	336798
22082	33043	47	applied	\N	\N	\N	\N	169550	169550	336800
22082	33044	48	applied	\N	\N	\N	\N	169551	169551	336801
22082	33046	49	applied	\N	\N	\N	\N	169552	169552	336802
22082	33049	50	applied	\N	\N	\N	\N	169553	169553	336803
22082	33052	51	applied	\N	\N	\N	\N	169554	169554	336804
22082	33057	52	applied	\N	\N	\N	\N	169555	169555	336805
22082	33002	53	applied	\N	\N	\N	\N	169556	169556	336806
22082	33010	54	applied	\N	\N	\N	\N	169557	169557	336807
22082	33011	55	applied	\N	\N	\N	\N	169558	169558	336808
22082	33012	56	applied	\N	\N	\N	\N	169559	169559	336809
22082	33014	57	applied	\N	\N	\N	\N	169560	169560	336810
22082	33018	58	applied	\N	\N	\N	\N	169561	169561	336811
22082	33020	59	applied	\N	\N	\N	\N	169562	169562	336812
22082	33025	60	applied	\N	\N	\N	\N	169563	169563	336813
22082	33026	61	applied	\N	\N	\N	\N	169564	169564	336814
22082	33031	62	applied	\N	\N	\N	\N	169565	169565	336815
22082	33041	64	applied	\N	\N	\N	\N	169567	169567	336817
22082	33047	65	applied	\N	\N	\N	\N	169568	169568	336818
22082	33050	66	applied	\N	\N	\N	\N	169569	169569	336819
22082	33053	67	applied	\N	\N	\N	\N	169570	169570	336820
22082	33058	68	applied	\N	\N	\N	\N	169571	169571	336821
22091	33067	0	applied	\N	\N	\N	\N	169609	169609	336859
22091	33068	1	applied	\N	\N	\N	\N	169610	169610	336860
22092	33065	0	applied	\N	\N	\N	\N	169611	169611	336861
22092	33069	1	applied	\N	\N	\N	\N	169612	169612	336862
22092	33070	2	applied	\N	\N	\N	\N	169613	169613	336863
22092	33071	3	applied	\N	\N	\N	\N	169614	169614	336864
22092	33072	4	applied	\N	\N	\N	\N	169615	169615	336865
22092	33073	5	applied	\N	\N	\N	\N	169616	169616	336866
22092	33074	6	applied	\N	\N	\N	\N	169617	169617	336867
22092	33075	7	applied	\N	\N	\N	\N	169618	169618	336868
22092	33076	8	applied	\N	\N	\N	\N	169619	169619	336869
22092	33078	11	applied	\N	\N	\N	\N	169621	169621	336871
22092	33079	12	applied	\N	\N	\N	\N	169622	169622	336872
22092	33066	13	applied	\N	\N	\N	\N	169623	169623	336873
22092	33080	14	applied	\N	\N	\N	\N	169624	169624	336874
22094	33081	0	applied	\N	\N	\N	\N	169628	169628	336878
22094	33082	1	applied	\N	\N	\N	\N	169629	169629	336879
22094	33083	2	applied	\N	\N	\N	\N	169630	169630	336880
22097	33091	0	applied	\N	\N	\N	\N	169638	169638	336888
22097	33092	1	applied	\N	\N	\N	\N	169639	169639	336889
22097	33093	2	applied	\N	\N	\N	\N	169640	169640	336890
22100	33094	0	applied	\N	\N	\N	\N	169655	169655	336905
22100	33095	1	applied	\N	\N	\N	\N	169656	169656	336906
22100	33096	2	applied	\N	\N	\N	\N	169657	169657	336907
22100	33097	3	applied	\N	\N	\N	\N	169658	169658	336908
22100	33098	4	applied	\N	\N	\N	\N	169659	169659	336909
22100	33099	5	applied	\N	\N	\N	\N	169660	169660	336910
22102	33104	0	applied	\N	\N	\N	\N	169665	169665	336915
22102	33105	1	applied	\N	\N	\N	\N	169666	169666	336916
22102	33106	2	applied	\N	\N	\N	\N	169667	169667	336917
22108	33136	0	applied	\N	\N	\N	\N	169701	169701	336951
22108	33137	1	applied	\N	\N	\N	\N	169702	169702	336952
22108	33138	2	applied	\N	\N	\N	\N	169703	169703	336953
22110	33136	0	applied	\N	\N	\N	\N	169707	169707	336957
22110	33137	1	applied	\N	\N	\N	\N	169708	169708	336958
22110	33138	2	applied	\N	\N	\N	\N	169709	169709	336959
22118	33162	0	applied	\N	\N	\N	\N	169800	169800	337048
22118	33163	1	applied	\N	\N	\N	\N	169801	169801	337049
22118	33164	2	applied	\N	\N	\N	\N	169802	169802	337050
22118	33165	3	applied	\N	\N	\N	\N	169803	169803	337051
22118	33166	4	applied	\N	\N	\N	\N	169804	169804	337052
22118	33167	5	applied	\N	\N	\N	\N	169805	169805	337053
22118	33168	6	applied	\N	\N	\N	\N	169806	169806	337054
22123	33178	1	applied	\N	\N	\N	\N	169830	169830	337078
22123	33179	2	applied	\N	\N	\N	\N	169831	169831	337079
22131	33197	0	applied	\N	\N	\N	\N	169861	169861	337109
22131	33198	1	applied	\N	\N	\N	\N	169862	169862	337110
22131	33199	2	applied	\N	\N	\N	\N	169863	169863	337111
22131	33200	3	applied	\N	\N	\N	\N	169864	169864	337112
22131	33201	4	applied	\N	\N	\N	\N	169865	169865	337113
22131	33202	5	applied	\N	\N	\N	\N	169866	169866	337114
22139	33223	0	applied	\N	\N	\N	\N	169901	169901	337149
22139	33224	1	applied	\N	\N	\N	\N	169902	169902	337150
22139	33225	2	applied	\N	\N	\N	\N	169903	169903	337151
22142	33226	0	applied	\N	\N	\N	\N	169926	169926	337172
22142	33229	1	applied	\N	\N	\N	\N	169927	169927	337173
22142	33231	2	applied	\N	\N	\N	\N	169928	169928	337174
22154	33264	7	applied	\N	\N	\N	\N	169998	169998	337241
22154	33265	8	applied	\N	\N	\N	\N	169999	169999	337242
22160	33269	0	applied	\N	\N	\N	\N	170028	170028	337271
22160	33270	1	applied	\N	\N	\N	\N	170029	170029	337272
22160	33271	2	applied	\N	\N	\N	\N	170030	170030	337273
22160	33272	3	applied	\N	\N	\N	\N	170031	170031	337274
22160	33273	4	applied	\N	\N	1000000000	\N	170032	170032	337275
22162	33274	0	applied	\N	\N	\N	\N	170036	170036	337279
22162	33275	1	applied	\N	\N	\N	\N	170037	170037	337280
22162	33276	2	applied	\N	\N	\N	\N	170038	170038	337281
22166	33280	0	applied	\N	\N	\N	\N	170058	170058	337301
22166	33281	1	applied	\N	\N	\N	\N	170059	170059	337302
22166	33282	2	applied	\N	\N	\N	\N	170060	170060	337303
22166	33283	3	applied	\N	\N	\N	\N	170061	170061	337304
22166	33284	4	applied	\N	\N	\N	\N	170062	170062	337305
22171	33299	0	applied	\N	\N	\N	\N	170087	170087	337330
22171	33300	1	applied	\N	\N	\N	\N	170088	170088	337331
22171	33301	2	applied	\N	\N	\N	\N	170089	170089	337332
22082	33022	31	applied	\N	\N	\N	\N	169534	169534	336784
22106	33124	0	applied	\N	\N	\N	\N	169689	169689	336939
22106	33125	1	applied	\N	\N	\N	\N	169690	169690	336940
22106	33126	2	applied	\N	\N	\N	\N	169691	169691	336941
22106	33127	3	applied	\N	\N	\N	\N	169692	169692	336942
22109	33136	0	applied	\N	\N	\N	\N	169704	169704	336954
22109	33137	1	applied	\N	\N	\N	\N	169705	169705	336955
22109	33138	2	applied	\N	\N	\N	\N	169706	169706	336956
22111	33139	0	applied	\N	\N	\N	\N	169710	169710	169710
22111	33140	1	applied	\N	\N	\N	\N	169711	169711	336960
22111	33141	2	applied	\N	\N	\N	\N	169712	169712	336961
22111	33142	3	applied	\N	\N	\N	\N	169713	169713	336962
22111	33143	4	applied	\N	\N	\N	\N	169714	169714	336963
22113	33145	1	applied	\N	\N	\N	\N	169775	169775	337023
22113	33146	2	applied	\N	\N	\N	\N	169776	169776	337024
22115	33147	0	applied	\N	\N	\N	\N	169781	169781	337029
22115	33144	1	applied	\N	\N	\N	\N	169782	169782	337030
22115	33145	2	applied	\N	\N	\N	\N	169783	169783	337031
22115	33146	3	applied	\N	\N	\N	\N	169784	169784	337032
22121	33169	0	applied	\N	\N	\N	\N	169821	169821	337069
22121	33170	1	applied	\N	\N	1000000000	\N	169822	169822	337070
22121	33171	2	applied	\N	\N	\N	\N	169823	169823	337071
22121	33172	3	applied	\N	\N	\N	\N	169824	169824	337072
22121	33173	4	applied	\N	\N	\N	\N	169825	169825	337073
22124	33177	0	applied	\N	\N	\N	\N	169832	169832	337080
22124	33178	1	applied	\N	\N	\N	\N	169833	169833	337081
22124	33179	2	applied	\N	\N	\N	\N	169834	169834	337082
22128	33187	0	applied	\N	\N	\N	\N	169845	169845	337093
22128	33188	1	applied	\N	\N	\N	\N	169846	169846	337094
22134	33203	0	applied	\N	\N	\N	\N	169873	169873	337121
22134	33204	1	applied	\N	\N	\N	\N	169874	169874	337122
22134	33205	2	applied	\N	\N	\N	\N	169875	169875	337123
22134	33206	3	applied	\N	\N	\N	\N	169876	169876	337124
22140	33226	0	applied	\N	\N	\N	\N	169904	169904	337152
22140	33227	1	applied	\N	\N	\N	\N	169905	169905	337153
22140	33228	2	applied	\N	\N	\N	\N	169906	169906	337154
22140	33229	3	applied	\N	\N	\N	\N	169907	169907	337155
22140	33230	4	applied	\N	\N	\N	\N	169908	169908	169908
22140	33231	5	applied	\N	\N	\N	\N	169909	169909	337156
22140	33232	6	applied	\N	\N	\N	\N	169910	169910	337157
22140	33233	7	applied	\N	\N	\N	\N	169911	169911	337158
22140	33234	8	applied	\N	\N	\N	\N	169912	169912	337159
22140	33235	9	applied	\N	\N	\N	\N	169913	169913	337160
22140	33236	10	applied	\N	\N	\N	\N	169914	169914	337161
22142	33234	3	applied	\N	\N	\N	\N	169929	169929	337175
22143	33228	1	applied	\N	\N	\N	\N	169931	169931	337177
22143	33230	2	applied	\N	\N	\N	\N	169932	169932	169932
22143	33235	3	applied	\N	\N	\N	\N	169933	169933	337178
22143	33236	4	applied	\N	\N	\N	\N	169934	169934	337179
22143	33232	5	applied	\N	\N	\N	\N	169935	169935	337180
22143	33233	6	applied	\N	\N	\N	\N	169936	169936	337181
22145	33227	0	applied	\N	\N	\N	\N	169944	169944	337188
22145	33228	1	applied	\N	\N	\N	\N	169945	169945	337189
22145	33230	2	applied	\N	\N	\N	\N	169946	169946	169946
22145	33235	3	applied	\N	\N	\N	\N	169947	169947	337190
22145	33236	4	applied	\N	\N	\N	\N	169948	169948	337191
22145	33232	5	applied	\N	\N	\N	\N	169949	169949	337192
22145	33233	6	applied	\N	\N	\N	\N	169950	169950	337193
22146	33237	0	applied	\N	\N	\N	\N	169951	169951	337194
22146	33238	1	applied	\N	\N	\N	\N	169952	169952	337195
22146	33239	2	applied	\N	\N	\N	\N	169953	169953	337196
22149	33251	0	applied	\N	\N	\N	\N	169965	169965	337208
22149	33252	1	applied	\N	\N	\N	\N	169966	169966	337209
22149	33253	2	applied	\N	\N	\N	\N	169967	169967	337210
22152	33257	0	applied	\N	\N	\N	\N	169971	169971	337214
22152	33258	1	applied	\N	\N	\N	\N	169972	169972	337215
22152	33259	2	applied	\N	\N	\N	\N	169973	169973	337216
22152	33260	3	applied	\N	\N	\N	\N	169974	169974	337217
22153	33257	0	applied	\N	\N	\N	\N	169981	169981	337224
22153	33258	1	applied	\N	\N	\N	\N	169982	169982	337225
22153	33259	2	applied	\N	\N	\N	\N	169983	169983	337226
22153	33260	3	applied	\N	\N	\N	\N	169984	169984	337227
22153	33261	4	applied	\N	\N	\N	\N	169985	169985	337228
22153	33262	5	applied	\N	\N	\N	\N	169986	169986	337229
22153	33263	6	applied	\N	\N	\N	\N	169987	169987	337230
22153	33264	7	applied	\N	\N	\N	\N	169988	169988	337231
22153	33265	8	applied	\N	\N	\N	\N	169989	169989	337232
22157	33257	0	applied	\N	\N	\N	\N	170011	170011	337254
22157	33258	1	applied	\N	\N	\N	\N	170012	170012	337255
22157	33259	2	applied	\N	\N	\N	\N	170013	170013	337256
22157	33260	3	applied	\N	\N	\N	\N	170014	170014	337257
22157	33261	4	applied	\N	\N	\N	\N	170015	170015	337258
22157	33262	5	applied	\N	\N	\N	\N	170016	170016	337259
22157	33263	6	applied	\N	\N	\N	\N	170017	170017	337260
22157	33264	7	applied	\N	\N	\N	\N	170018	170018	337261
22157	33265	8	applied	\N	\N	\N	\N	170019	170019	337262
22157	33266	9	applied	\N	\N	\N	\N	170020	170020	337263
22159	33269	0	applied	\N	\N	\N	\N	170023	170023	337266
22159	33270	1	applied	\N	\N	\N	\N	170024	170024	337267
22159	33271	2	applied	\N	\N	\N	\N	170025	170025	337268
22159	33272	3	applied	\N	\N	\N	\N	170026	170026	337269
22161	33274	0	applied	\N	\N	\N	\N	170033	170033	337276
22161	33275	1	applied	\N	\N	\N	\N	170034	170034	337277
22161	33276	2	applied	\N	\N	\N	\N	170035	170035	337278
22164	33277	0	applied	\N	\N	\N	\N	170052	170052	337295
22164	33278	1	applied	\N	\N	\N	\N	170053	170053	337296
22164	33279	2	applied	\N	\N	\N	\N	170054	170054	337297
22170	33291	0	applied	\N	\N	\N	\N	170079	170079	337322
22170	33292	1	applied	\N	\N	\N	\N	170080	170080	337323
22170	33293	2	applied	\N	\N	\N	\N	170081	170081	337324
22170	33294	3	applied	\N	\N	\N	\N	170082	170082	337325
22170	33295	4	applied	\N	\N	\N	\N	170083	170083	337326
22170	33296	5	applied	\N	\N	\N	\N	170084	170084	337327
22170	33297	6	applied	\N	\N	\N	\N	170085	170085	337328
22170	33298	7	applied	\N	\N	\N	\N	170086	170086	337329
22173	33306	0	applied	\N	\N	\N	\N	170094	170094	337337
22173	33307	1	applied	\N	\N	\N	\N	170095	170095	337338
22173	33308	2	applied	\N	\N	\N	\N	170096	170096	337339
22179	33326	0	applied	\N	\N	\N	\N	170127	170127	337370
22179	33327	1	applied	\N	\N	\N	\N	170128	170128	337371
22103	33114	7	applied	\N	\N	\N	\N	169675	169675	336925
22103	33116	9	applied	\N	\N	\N	\N	169677	169677	336927
22112	33108	18	applied	\N	\N	\N	\N	169733	169733	336981
22112	33109	19	applied	\N	\N	\N	\N	169734	169734	336982
22112	33117	20	applied	\N	\N	\N	\N	169735	169735	336983
22112	33118	21	applied	\N	\N	\N	\N	169736	169736	336984
22112	33124	22	applied	\N	\N	\N	\N	169737	169737	336985
22112	33128	23	applied	\N	\N	\N	\N	169738	169738	336986
22112	33130	24	applied	\N	\N	\N	\N	169739	169739	336987
22112	33136	25	applied	\N	\N	\N	\N	169740	169740	336988
22112	33141	26	applied	\N	\N	\N	\N	169741	169741	336989
22112	33063	27	applied	\N	\N	\N	\N	169742	169742	336990
22112	33064	28	applied	\N	\N	\N	\N	169743	169743	336991
22112	33067	29	applied	\N	\N	\N	\N	169744	169744	336992
22112	33068	30	applied	\N	\N	\N	\N	169745	169745	336993
22112	33072	31	applied	\N	\N	\N	\N	169746	169746	336994
22112	33073	32	applied	\N	\N	\N	\N	169747	169747	336995
22112	33074	33	applied	\N	\N	\N	\N	169748	169748	336996
22112	33076	35	applied	\N	\N	\N	\N	169750	169750	336998
22112	33077	36	applied	\N	\N	\N	\N	169751	169751	336999
22112	33078	37	applied	\N	\N	\N	\N	169752	169752	337000
22112	33079	38	applied	\N	\N	\N	\N	169753	169753	337001
22112	33082	39	applied	\N	\N	\N	\N	169754	169754	337002
22112	33085	40	applied	\N	\N	\N	\N	169755	169755	337003
22112	33088	41	applied	\N	\N	\N	\N	169756	169756	337004
22112	33066	42	applied	\N	\N	\N	\N	169757	169757	337005
22112	33080	43	applied	\N	\N	\N	\N	169758	169758	337006
22112	33090	44	applied	\N	\N	\N	\N	169759	169759	337007
22112	33097	46	applied	\N	\N	\N	\N	169760	169760	337008
22112	33111	47	applied	\N	\N	\N	\N	169761	169761	337009
22112	33121	48	applied	\N	\N	\N	\N	169762	169762	337010
22112	33135	49	applied	\N	\N	\N	\N	169763	169763	337011
22112	33083	50	applied	\N	\N	\N	\N	169764	169764	337012
22112	33086	51	applied	\N	\N	\N	\N	169765	169765	337013
22112	33092	53	applied	\N	\N	\N	\N	169767	169767	337015
22112	33096	54	applied	\N	\N	\N	\N	169768	169768	337016
22112	33098	55	applied	\N	\N	\N	\N	169769	169769	337017
22112	33103	56	applied	\N	\N	\N	\N	169770	169770	337018
22112	33106	57	applied	\N	\N	\N	\N	169771	169771	337019
22112	33110	58	applied	\N	\N	\N	\N	169772	169772	337020
22112	33112	59	applied	\N	\N	\N	\N	169773	169773	337021
22114	33147	0	applied	\N	\N	\N	\N	169777	169777	337025
22114	33144	1	applied	\N	\N	\N	\N	169778	169778	337026
22114	33145	2	applied	\N	\N	\N	\N	169779	169779	337027
22114	33146	3	applied	\N	\N	\N	\N	169780	169780	337028
22117	33152	0	applied	\N	\N	\N	\N	169790	169790	337038
22117	33153	1	applied	\N	\N	\N	\N	169791	169791	337039
22117	33154	2	applied	\N	\N	\N	\N	169792	169792	337040
22117	33155	3	applied	\N	\N	\N	\N	169793	169793	337041
22117	33156	4	applied	\N	\N	\N	\N	169794	169794	337042
22117	33158	6	applied	\N	\N	\N	\N	169796	169796	337044
22117	33159	7	applied	\N	\N	\N	\N	169797	169797	337045
22117	33160	8	applied	\N	\N	\N	\N	169798	169798	337046
22117	33161	9	applied	\N	\N	\N	\N	169799	169799	337047
22120	33162	0	applied	\N	\N	\N	\N	169814	169814	337062
22120	33163	1	applied	\N	\N	\N	\N	169815	169815	337063
22120	33164	2	applied	\N	\N	\N	\N	169816	169816	337064
22120	33165	3	applied	\N	\N	\N	\N	169817	169817	337065
22120	33166	4	applied	\N	\N	\N	\N	169818	169818	337066
22120	33167	5	applied	\N	\N	\N	\N	169819	169819	337067
22120	33168	6	applied	\N	\N	\N	\N	169820	169820	337068
22122	33174	0	applied	\N	\N	\N	\N	169826	169826	337074
22122	33175	1	applied	\N	\N	\N	\N	169827	169827	337075
22122	33176	2	applied	\N	\N	\N	\N	169828	169828	337076
22127	33184	0	applied	\N	\N	\N	\N	169842	169842	337090
22127	33185	1	applied	\N	\N	\N	\N	169843	169843	337091
22130	33197	0	applied	\N	\N	\N	\N	169855	169855	337103
22130	33198	1	applied	\N	\N	\N	\N	169856	169856	337104
22130	33199	2	applied	\N	\N	\N	\N	169857	169857	337105
22130	33200	3	applied	\N	\N	\N	\N	169858	169858	337106
22130	33201	4	applied	\N	\N	\N	\N	169859	169859	337107
22130	33202	5	applied	\N	\N	\N	\N	169860	169860	337108
22136	33203	0	applied	\N	\N	\N	\N	169881	169881	337129
22136	33204	1	applied	\N	\N	\N	\N	169882	169882	337130
22136	33205	2	applied	\N	\N	\N	\N	169883	169883	337131
22136	33206	3	applied	\N	\N	\N	\N	169884	169884	337132
22138	33217	0	applied	\N	\N	\N	\N	169895	169895	337143
22138	33218	1	applied	\N	\N	\N	\N	169896	169896	337144
22138	33219	2	applied	\N	\N	\N	\N	169897	169897	337145
22138	33220	3	applied	\N	\N	\N	\N	169898	169898	337146
22138	33221	4	applied	\N	\N	\N	\N	169899	169899	337147
22138	33222	5	applied	\N	\N	\N	\N	169900	169900	337148
22144	33228	1	applied	\N	\N	\N	\N	169938	169938	337183
22144	33230	2	applied	\N	\N	\N	\N	169939	169939	169939
22144	33235	3	applied	\N	\N	\N	\N	169940	169940	337184
22144	33236	4	applied	\N	\N	\N	\N	169941	169941	337185
22144	33232	5	applied	\N	\N	\N	\N	169942	169942	337186
22144	33233	6	applied	\N	\N	\N	\N	169943	169943	337187
22148	33244	0	applied	\N	\N	\N	\N	169958	169958	337201
22148	33245	1	applied	\N	\N	\N	\N	169959	169959	337202
22148	33246	2	applied	\N	\N	\N	\N	169960	169960	337203
22148	33247	3	applied	\N	\N	\N	\N	169961	169961	337204
22148	33248	4	applied	\N	\N	\N	\N	169962	169962	337205
22148	33249	5	applied	\N	\N	\N	\N	169963	169963	337206
22179	33328	2	applied	\N	\N	\N	\N	170129	170129	337372
22179	33329	3	applied	\N	\N	\N	\N	170130	170130	337373
22179	33330	4	applied	\N	\N	\N	\N	170131	170131	337374
22179	33331	5	applied	\N	\N	\N	\N	170132	170132	337375
22181	33336	1	applied	\N	\N	\N	\N	170137	170137	337380
22181	33337	2	applied	\N	\N	\N	\N	170138	170138	337381
22181	33338	3	applied	\N	\N	\N	\N	170139	170139	337382
22184	33280	0	applied	\N	\N	\N	\N	170152	170152	337395
22184	33285	1	applied	\N	\N	\N	\N	170153	170153	337396
22184	33286	2	applied	\N	\N	\N	\N	170154	170154	337397
22184	33291	3	applied	\N	\N	\N	\N	170155	170155	337398
22184	33139	4	applied	\N	\N	\N	\N	170156	170156	170156
22184	33292	5	applied	\N	\N	\N	\N	170157	170157	337399
22184	33293	7	applied	\N	\N	\N	\N	170158	170158	337400
22184	33294	8	applied	\N	\N	\N	\N	170159	170159	337401
22184	33295	9	applied	\N	\N	\N	\N	170160	170160	337402
22184	33033	10	applied	\N	\N	\N	\N	170161	170161	337403
22184	33188	11	applied	\N	\N	\N	\N	170162	170162	337404
22112	33101	15	applied	\N	\N	\N	\N	169730	169730	336978
22112	33104	16	applied	\N	\N	\N	\N	169731	169731	336979
22152	33264	7	applied	\N	\N	\N	\N	169978	169978	337221
22152	33265	8	applied	\N	\N	\N	\N	169979	169979	337222
22152	33266	9	applied	\N	\N	\N	\N	169980	169980	337223
22155	33257	0	applied	\N	\N	\N	\N	170001	170001	337244
22155	33258	1	applied	\N	\N	\N	\N	170002	170002	337245
22155	33259	2	applied	\N	\N	\N	\N	170003	170003	337246
22155	33260	3	applied	\N	\N	\N	\N	170004	170004	337247
22155	33261	4	applied	\N	\N	\N	\N	170005	170005	337248
22155	33262	5	applied	\N	\N	\N	\N	170006	170006	337249
22155	33263	6	applied	\N	\N	\N	\N	170007	170007	337250
22155	33264	7	applied	\N	\N	\N	\N	170008	170008	337251
22155	33265	8	applied	\N	\N	\N	\N	170009	170009	337252
22155	33266	9	applied	\N	\N	\N	\N	170010	170010	337253
22158	33267	0	applied	\N	\N	\N	\N	170021	170021	337264
22163	33267	0	applied	\N	\N	\N	\N	170039	170039	337282
22163	33269	1	applied	\N	\N	\N	\N	170040	170040	337283
22163	33274	2	applied	\N	\N	\N	\N	170041	170041	337284
22163	33277	3	applied	\N	\N	\N	\N	170042	170042	337285
22163	33270	4	applied	\N	\N	\N	\N	170043	170043	337286
22163	33268	5	applied	\N	\N	\N	\N	170044	170044	337287
22163	33271	6	applied	\N	\N	\N	\N	170045	170045	337288
22163	33272	7	applied	\N	\N	\N	\N	170046	170046	337289
22163	33275	8	applied	\N	\N	\N	\N	170047	170047	337290
22163	33278	9	applied	\N	\N	\N	\N	170048	170048	337291
22163	33273	10	applied	\N	\N	1000000000	\N	170049	170049	337292
22163	33276	11	applied	\N	\N	\N	\N	170050	170050	337293
22163	33279	12	applied	\N	\N	\N	\N	170051	170051	337294
22165	33277	0	applied	\N	\N	\N	\N	170055	170055	337298
22165	33278	1	applied	\N	\N	\N	\N	170056	170056	337299
22165	33279	2	applied	\N	\N	\N	\N	170057	170057	337300
22167	33281	1	applied	\N	\N	\N	\N	170064	170064	337307
22167	33282	2	applied	\N	\N	\N	\N	170065	170065	337308
22167	33283	3	applied	\N	\N	\N	\N	170066	170066	337309
22167	33284	4	applied	\N	\N	\N	\N	170067	170067	337310
22168	33280	0	applied	\N	\N	\N	\N	170068	170068	337311
22168	33281	1	applied	\N	\N	\N	\N	170069	170069	337312
22168	33282	2	applied	\N	\N	\N	\N	170070	170070	337313
22168	33283	3	applied	\N	\N	\N	\N	170071	170071	337314
22168	33284	4	applied	\N	\N	\N	\N	170072	170072	337315
22169	33285	0	applied	\N	\N	\N	\N	170073	170073	337316
22169	33286	1	applied	\N	\N	\N	\N	170074	170074	337317
22169	33287	2	applied	\N	\N	\N	\N	170075	170075	337318
22169	33288	3	applied	\N	\N	\N	\N	170076	170076	337319
22169	33289	4	applied	\N	\N	\N	\N	170077	170077	337320
22169	33290	5	applied	\N	\N	\N	\N	170078	170078	337321
22172	33302	0	applied	\N	\N	\N	\N	170090	170090	337333
22172	33304	2	applied	\N	\N	\N	\N	170092	170092	337335
22172	33305	3	applied	\N	\N	\N	\N	170093	170093	337336
22175	33309	0	applied	\N	\N	\N	\N	170104	170104	337347
22175	33310	1	applied	\N	\N	\N	\N	170105	170105	337348
22175	33311	2	applied	\N	\N	\N	\N	170106	170106	337349
22175	33312	3	applied	\N	\N	\N	\N	170107	170107	337350
22175	33313	4	applied	\N	\N	\N	\N	170108	170108	337351
22175	33314	5	applied	\N	\N	\N	\N	170109	170109	337352
22175	33315	6	applied	\N	\N	\N	\N	170110	170110	337353
22178	33326	0	applied	\N	\N	\N	\N	170121	170121	337364
22178	33327	1	applied	\N	\N	\N	\N	170122	170122	337365
22178	33328	2	applied	\N	\N	\N	\N	170123	170123	337366
22178	33329	3	applied	\N	\N	\N	\N	170124	170124	337367
22178	33330	4	applied	\N	\N	\N	\N	170125	170125	337368
22178	33331	5	applied	\N	\N	\N	\N	170126	170126	337369
22186	33352	0	applied	\N	\N	\N	\N	170284	170284	337526
22186	33354	2	applied	\N	\N	\N	\N	170286	170286	337528
22191	33369	0	applied	\N	\N	\N	\N	170301	170301	337543
22191	33370	1	applied	\N	\N	\N	\N	170302	170302	337544
22191	33371	2	applied	\N	\N	\N	\N	170303	170303	337545
22191	33372	3	applied	\N	\N	\N	\N	170304	170304	337546
22194	33380	0	applied	\N	\N	\N	\N	170316	170316	337558
22194	33381	1	applied	\N	\N	\N	\N	170317	170317	337559
22194	33382	2	applied	\N	\N	\N	\N	170318	170318	337560
22194	33383	3	applied	\N	\N	\N	\N	170319	170319	337561
22199	33241	0	applied	\N	\N	\N	\N	170337	170337	337577
22199	33244	1	applied	\N	\N	\N	\N	170338	170338	337578
22199	33245	2	applied	\N	\N	\N	\N	170339	170339	337579
22199	33251	3	applied	\N	\N	\N	\N	170340	170340	337580
22199	33254	4	applied	\N	\N	\N	\N	170341	170341	337581
22199	33257	5	applied	\N	\N	\N	\N	170342	170342	337582
22199	33258	7	applied	\N	\N	\N	\N	170343	170343	337583
22199	33267	9	applied	\N	\N	\N	\N	170345	170345	337585
22199	33269	10	applied	\N	\N	\N	\N	170346	170346	337586
22199	33274	11	applied	\N	\N	\N	\N	170347	170347	337587
22199	33277	12	applied	\N	\N	\N	\N	170348	170348	337588
22199	33281	13	applied	\N	\N	\N	\N	170349	170349	337589
22199	33287	14	applied	\N	\N	\N	\N	170350	170350	337590
22199	33296	15	applied	\N	\N	\N	\N	170351	170351	337591
22199	33299	16	applied	\N	\N	\N	\N	170352	170352	337592
22199	33302	17	applied	\N	\N	\N	\N	170353	170353	337593
22199	33306	18	applied	\N	\N	\N	\N	170354	170354	337594
22199	33309	19	applied	\N	\N	\N	\N	170355	170355	337595
22199	33310	20	applied	\N	\N	\N	\N	170356	170356	337596
22199	33316	21	applied	\N	\N	\N	\N	170357	170357	337597
22199	33319	22	applied	\N	\N	\N	\N	170358	170358	337598
22199	33320	23	applied	\N	\N	\N	\N	170359	170359	337599
22199	33326	24	applied	\N	\N	\N	\N	170360	170360	337600
22199	33332	26	applied	\N	\N	\N	\N	170362	170362	337602
22199	33335	27	applied	\N	\N	\N	\N	170363	170363	337603
22199	33339	28	applied	\N	\N	\N	\N	170364	170364	337604
22199	33340	29	applied	\N	\N	\N	\N	170365	170365	337605
22199	33345	30	applied	\N	\N	\N	\N	170366	170366	337606
22199	33346	31	applied	\N	\N	\N	\N	170367	170367	337607
22199	33352	32	applied	\N	\N	\N	\N	170368	170368	337608
22199	33355	33	applied	\N	\N	\N	\N	170369	170369	337609
22199	33360	34	applied	\N	\N	\N	\N	170370	170370	337610
22199	33363	35	applied	\N	\N	\N	\N	170371	170371	337611
22199	33366	36	applied	\N	\N	\N	\N	170372	170372	337612
22199	33369	37	applied	\N	\N	\N	\N	170373	170373	337613
22199	33373	38	applied	\N	\N	\N	\N	170374	170374	337614
22199	33374	39	applied	\N	\N	\N	\N	170375	170375	337615
22199	33380	40	applied	\N	\N	\N	\N	170376	170376	337616
22199	33385	41	applied	\N	\N	\N	\N	170377	170377	337617
22152	33263	6	applied	\N	\N	\N	\N	169977	169977	337220
22174	33313	4	applied	\N	\N	\N	\N	170101	170101	337344
22174	33314	5	applied	\N	\N	\N	\N	170102	170102	337345
22174	33315	6	applied	\N	\N	\N	\N	170103	170103	337346
22176	33316	0	applied	\N	\N	\N	\N	170111	170111	337354
22176	33317	1	applied	\N	\N	\N	\N	170112	170112	337355
22176	33318	2	applied	\N	\N	\N	\N	170113	170113	337356
22182	33339	0	applied	\N	\N	\N	\N	170140	170140	337383
22182	33340	1	applied	\N	\N	\N	\N	170141	170141	337384
22182	33341	2	applied	\N	\N	\N	\N	170142	170142	337385
22182	33342	3	applied	\N	\N	\N	\N	170143	170143	337386
22182	33343	4	applied	\N	\N	\N	\N	170144	170144	337387
22182	33344	5	applied	\N	\N	\N	\N	170145	170145	337388
22187	33355	0	applied	\N	\N	\N	\N	170287	170287	337529
22187	33356	1	applied	\N	\N	\N	\N	170288	170288	337530
22187	33358	3	applied	\N	\N	\N	\N	170290	170290	337532
22187	33359	4	applied	\N	\N	\N	\N	170291	170291	337533
22190	33366	0	applied	\N	\N	\N	\N	170298	170298	337540
22190	33367	1	applied	\N	\N	\N	\N	170299	170299	337541
22190	33368	2	applied	\N	\N	\N	\N	170300	170300	337542
22199	33386	42	applied	\N	\N	\N	\N	170378	170378	337618
22199	33397	43	applied	\N	\N	\N	\N	170379	170379	337619
22199	33387	44	applied	\N	\N	\N	\N	170380	170380	337620
22199	33388	45	applied	\N	\N	\N	\N	170381	170381	337621
22199	33389	46	applied	\N	\N	\N	\N	170382	170382	170382
22199	33356	47	applied	\N	\N	\N	\N	170383	170383	337622
22199	33230	48	applied	\N	\N	\N	\N	170384	170384	170384
22199	32895	49	applied	\N	\N	\N	\N	170385	170385	337623
22199	32896	50	applied	\N	\N	\N	\N	170386	170386	337624
22199	32927	51	applied	\N	\N	\N	\N	170387	170387	337625
22199	32898	52	applied	\N	\N	\N	\N	170388	170388	337626
22199	32941	54	applied	\N	\N	\N	\N	170390	170390	337628
22199	32956	55	applied	\N	\N	\N	\N	170391	170391	337629
22199	32964	56	applied	\N	\N	\N	\N	170392	170392	337630
22199	32974	57	applied	\N	\N	\N	\N	170393	170393	337631
22199	32987	58	applied	\N	\N	\N	\N	170394	170394	337632
22199	32998	59	applied	\N	\N	\N	\N	170395	170395	337633
22199	33006	60	applied	\N	\N	\N	\N	170396	170396	337634
22200	33397	0	applied	\N	\N	\N	\N	170462	170462	337699
22200	33398	1	applied	\N	\N	\N	\N	170463	170463	337700
22200	33399	2	applied	\N	\N	\N	\N	170464	170464	337701
22200	33400	3	applied	\N	\N	\N	\N	170465	170465	337702
22200	33401	4	applied	\N	\N	\N	\N	170466	170466	337703
22200	33402	5	applied	\N	\N	\N	\N	170467	170467	337704
22205	33410	0	applied	\N	\N	\N	\N	170485	170485	337722
22205	33411	1	applied	\N	\N	\N	\N	170486	170486	337723
22205	33412	2	applied	\N	\N	\N	\N	170487	170487	337724
22214	33437	0	applied	\N	\N	\N	\N	170600	170600	337837
22214	33438	1	applied	\N	\N	\N	\N	170601	170601	337838
22214	33439	2	applied	\N	\N	\N	\N	170602	170602	337839
22214	33440	3	applied	\N	\N	\N	\N	170603	170603	337840
22214	33441	4	applied	\N	\N	\N	\N	170604	170604	337841
22214	33442	5	applied	\N	\N	\N	\N	170605	170605	337842
22214	33443	6	applied	\N	\N	\N	\N	170606	170606	337843
22214	33444	7	applied	\N	\N	\N	\N	170607	170607	337844
22214	33445	8	applied	\N	\N	\N	\N	170608	170608	337845
22217	33449	0	applied	\N	\N	\N	\N	170612	170612	337849
22217	33450	1	applied	\N	\N	\N	\N	170613	170613	337850
22217	33451	2	applied	\N	\N	\N	\N	170614	170614	337851
22217	33452	3	applied	\N	\N	\N	\N	170615	170615	337852
22217	33453	4	applied	\N	\N	\N	\N	170616	170616	337853
22217	33454	5	applied	\N	\N	\N	\N	170617	170617	337854
22217	33455	6	applied	\N	\N	\N	\N	170618	170618	337855
22217	33456	7	applied	\N	\N	\N	\N	170619	170619	337856
22225	33466	0	applied	\N	\N	\N	\N	170634	170634	337871
22225	33467	2	applied	\N	\N	\N	\N	170636	170636	337873
22228	33469	0	applied	\N	\N	\N	\N	170642	170642	337879
22228	33468	1	applied	\N	\N	\N	\N	170643	170643	337880
22228	33470	2	applied	\N	\N	\N	\N	170644	170644	337881
22228	33471	3	applied	\N	\N	\N	\N	170645	170645	337882
22228	33472	4	applied	\N	\N	\N	\N	170646	170646	337883
22231	33462	0	applied	\N	\N	\N	\N	170656	170656	337893
22231	33403	1	applied	\N	\N	\N	\N	170657	170657	337894
22231	33406	2	applied	\N	\N	\N	\N	170658	170658	337895
22231	33410	3	applied	\N	\N	\N	\N	170659	170659	337896
22231	33414	4	applied	\N	\N	\N	\N	170660	170660	337897
22231	33417	5	applied	\N	\N	\N	\N	170661	170661	337898
22231	33421	6	applied	\N	\N	\N	\N	170662	170662	337899
22231	33422	7	applied	\N	\N	\N	\N	170663	170663	337900
22231	33423	8	applied	\N	\N	\N	\N	170664	170664	337901
22231	33431	9	applied	\N	\N	\N	\N	170665	170665	337902
22231	33437	11	applied	\N	\N	\N	\N	170667	170667	337904
22231	33438	12	applied	\N	\N	\N	\N	170668	170668	337905
22231	33439	13	applied	\N	\N	\N	\N	170669	170669	337906
22231	33446	14	applied	\N	\N	\N	\N	170670	170670	337907
22231	33449	15	applied	\N	\N	\N	\N	170671	170671	337908
22231	33463	16	applied	\N	\N	\N	\N	170672	170672	337909
22231	33466	17	applied	\N	\N	\N	\N	170673	170673	337910
22231	33404	18	applied	\N	\N	\N	\N	170674	170674	337911
22231	33407	19	applied	\N	\N	\N	\N	170675	170675	337912
22231	33412	20	applied	\N	\N	\N	\N	170676	170676	337913
22231	33415	21	applied	\N	\N	\N	\N	170677	170677	337914
22231	33418	22	applied	\N	\N	\N	\N	170678	170678	337915
22231	33425	23	applied	\N	\N	\N	\N	170679	170679	337916
22231	33426	24	applied	\N	\N	\N	\N	170680	170680	337917
22231	33409	25	applied	\N	\N	\N	\N	170681	170681	337918
22231	33420	26	applied	\N	\N	\N	\N	170682	170682	337919
22231	33430	28	applied	\N	\N	\N	\N	170684	170684	337921
22231	33435	29	applied	\N	\N	\N	\N	170685	170685	337922
22231	33436	30	applied	\N	\N	\N	\N	170686	170686	337923
22231	33442	31	applied	\N	\N	\N	\N	170687	170687	337924
22231	33443	32	applied	\N	\N	\N	\N	170688	170688	337925
22231	33444	33	applied	\N	\N	\N	\N	170689	170689	337926
22231	33448	34	applied	\N	\N	\N	\N	170690	170690	337927
22231	33453	35	applied	\N	\N	\N	\N	170691	170691	337928
22231	33445	36	applied	\N	\N	\N	\N	170692	170692	337929
22231	33451	37	applied	\N	\N	\N	\N	170693	170693	337930
22231	33458	38	applied	\N	\N	\N	\N	170694	170694	337931
22231	33470	39	applied	\N	\N	\N	\N	170695	170695	337932
22231	33455	40	applied	\N	\N	\N	\N	170696	170696	337933
22231	33456	41	applied	\N	\N	\N	\N	170697	170697	337934
22174	33311	2	applied	\N	\N	\N	\N	170099	170099	337342
22174	33312	3	applied	\N	\N	\N	\N	170100	170100	337343
22177	33322	3	applied	\N	\N	\N	\N	170117	170117	337360
22177	33323	4	applied	\N	\N	\N	\N	170118	170118	337361
22177	33324	5	applied	\N	\N	\N	\N	170119	170119	337362
22177	33325	6	applied	\N	\N	\N	\N	170120	170120	337363
22180	33332	0	applied	\N	\N	\N	\N	170133	170133	337376
22180	33333	1	applied	\N	\N	\N	\N	170134	170134	337377
22180	33334	2	applied	\N	\N	\N	\N	170135	170135	337378
22183	33339	0	applied	\N	\N	\N	\N	170146	170146	337389
22183	33340	1	applied	\N	\N	\N	\N	170147	170147	337390
22183	33341	2	applied	\N	\N	\N	\N	170148	170148	337391
22183	33342	3	applied	\N	\N	\N	\N	170149	170149	337392
22183	33343	4	applied	\N	\N	\N	\N	170150	170150	337393
22183	33344	5	applied	\N	\N	\N	\N	170151	170151	337394
22185	33346	1	applied	\N	\N	\N	\N	170278	170278	337520
22185	33347	3	applied	\N	\N	\N	\N	170279	170279	337521
22185	33348	4	applied	\N	\N	\N	\N	170280	170280	337522
22185	33349	5	applied	\N	\N	\N	\N	170281	170281	337523
22185	33350	6	applied	\N	\N	\N	\N	170282	170282	337524
22185	33351	7	applied	\N	\N	\N	\N	170283	170283	337525
22188	33360	0	applied	\N	\N	\N	\N	170292	170292	337534
22188	33361	1	applied	\N	\N	\N	\N	170293	170293	337535
22188	33362	2	applied	\N	\N	\N	\N	170294	170294	337536
22193	33373	0	applied	\N	\N	\N	\N	170309	170309	337551
22193	33374	1	applied	\N	\N	\N	\N	170310	170310	337552
22193	33375	2	applied	\N	\N	\N	\N	170311	170311	337553
22193	33376	3	applied	\N	\N	\N	\N	170312	170312	337554
22193	33377	4	applied	\N	\N	\N	\N	170313	170313	337555
22193	33378	5	applied	\N	\N	\N	\N	170314	170314	337556
22193	33379	6	applied	\N	\N	\N	\N	170315	170315	337557
22196	33385	1	applied	\N	\N	\N	\N	170325	170325	337566
22196	33386	2	applied	\N	\N	\N	\N	170326	170326	337567
22196	33387	3	applied	\N	\N	\N	\N	170327	170327	337568
22196	33388	4	applied	\N	\N	\N	\N	170328	170328	337569
22196	33389	5	applied	\N	\N	\N	\N	170329	170329	170329
22196	33390	6	applied	\N	\N	\N	\N	170330	170330	337570
22196	33391	7	applied	\N	\N	\N	\N	170331	170331	337571
22196	33392	8	applied	\N	\N	\N	\N	170332	170332	337572
22196	33393	9	applied	\N	\N	\N	\N	170333	170333	337573
22198	33394	0	applied	\N	\N	\N	\N	170334	170334	337574
22198	33395	1	applied	\N	\N	\N	\N	170335	170335	337575
22198	33396	2	applied	\N	\N	\N	\N	170336	170336	337576
22201	33397	0	applied	\N	\N	\N	\N	170468	170468	337705
22201	33398	1	applied	\N	\N	\N	\N	170469	170469	337706
22201	33399	2	applied	\N	\N	\N	\N	170470	170470	337707
22201	33400	3	applied	\N	\N	\N	\N	170471	170471	337708
22201	33402	5	applied	\N	\N	\N	\N	170473	170473	337710
22203	33406	0	applied	\N	\N	\N	\N	170477	170477	337714
22203	33407	1	applied	\N	\N	\N	\N	170478	170478	337715
22203	33408	2	applied	\N	\N	\N	\N	170479	170479	337716
22203	33409	3	applied	\N	\N	\N	\N	170480	170480	337717
22208	33398	0	applied	\N	\N	\N	\N	170496	170496	337733
22208	33403	1	applied	\N	\N	\N	\N	170497	170497	337734
22208	33406	2	applied	\N	\N	\N	\N	170498	170498	337735
22208	33410	3	applied	\N	\N	\N	\N	170499	170499	337736
22208	33414	4	applied	\N	\N	\N	\N	170500	170500	337737
22208	33417	5	applied	\N	\N	\N	\N	170501	170501	337738
22208	32982	7	applied	\N	\N	\N	\N	170502	170502	337739
22208	32984	8	applied	\N	\N	\N	\N	170503	170503	337740
22208	32988	9	applied	\N	\N	\N	\N	170504	170504	337741
22208	32991	10	applied	\N	\N	\N	\N	170505	170505	337742
22208	32994	11	applied	\N	\N	\N	\N	170506	170506	337743
22208	33409	13	applied	\N	\N	\N	\N	170508	170508	337745
22208	33001	14	applied	\N	\N	\N	\N	170509	170509	337746
22208	33007	15	applied	\N	\N	\N	\N	170510	170510	337747
22208	33008	16	applied	\N	\N	\N	\N	170511	170511	337748
22208	33009	17	applied	\N	\N	\N	\N	170512	170512	337749
22208	33015	18	applied	\N	\N	\N	\N	170513	170513	337750
22208	33017	19	applied	\N	\N	\N	\N	170514	170514	337751
22208	33021	20	applied	\N	\N	\N	\N	170515	170515	337752
22208	33420	21	applied	\N	\N	\N	\N	170516	170516	337753
22208	33413	22	applied	\N	\N	1000000000	\N	170517	170517	337754
22208	33027	23	applied	\N	\N	\N	\N	170518	170518	337755
22208	33028	24	applied	\N	\N	\N	\N	170519	170519	337756
22208	33030	25	applied	\N	\N	\N	\N	170520	170520	337757
22208	33038	26	applied	\N	\N	\N	\N	170521	170521	337758
22208	33043	27	applied	\N	\N	\N	\N	170522	170522	337759
22208	33044	28	applied	\N	\N	\N	\N	170523	170523	337760
22208	33049	30	applied	\N	\N	\N	\N	170525	170525	337762
22208	33052	31	applied	\N	\N	\N	\N	170526	170526	337763
22208	33057	32	applied	\N	\N	\N	\N	170527	170527	337764
22208	33061	33	applied	\N	\N	\N	\N	170528	170528	337765
22208	33063	34	applied	\N	\N	\N	\N	170529	170529	337766
22208	33067	35	applied	\N	\N	\N	\N	170530	170530	337767
22208	33076	36	applied	\N	\N	\N	\N	170531	170531	337768
22208	33077	37	applied	\N	\N	\N	\N	170532	170532	337769
22208	33078	38	applied	\N	\N	\N	\N	170533	170533	337770
22208	33079	39	applied	\N	\N	\N	\N	170534	170534	337771
22208	33082	40	applied	\N	\N	\N	\N	170535	170535	337772
22208	33085	41	applied	\N	\N	\N	\N	170536	170536	337773
22208	33088	42	applied	\N	\N	\N	\N	170537	170537	337774
22208	33093	43	applied	\N	\N	\N	\N	170538	170538	337775
22208	33099	44	applied	\N	\N	\N	\N	170539	170539	337776
22208	33100	45	applied	\N	\N	\N	\N	170540	170540	337777
22231	33460	43	applied	\N	\N	\N	\N	170699	170699	337936
22231	33464	44	applied	\N	\N	\N	\N	170700	170700	337937
22231	33468	45	applied	\N	\N	\N	\N	170701	170701	337938
22231	33471	46	applied	\N	\N	\N	\N	170702	170702	337939
22231	33413	48	applied	\N	\N	1000000000	\N	170703	170703	337940
22231	33405	49	applied	\N	\N	\N	\N	170704	170704	337941
22231	33408	50	applied	\N	\N	\N	\N	170705	170705	337942
22231	33411	51	applied	\N	\N	\N	\N	170706	170706	337943
22231	33416	52	applied	\N	\N	\N	\N	170707	170707	337944
22231	33419	53	applied	\N	\N	\N	\N	170708	170708	337945
22231	33424	54	applied	\N	\N	\N	\N	170709	170709	337946
22231	33428	55	applied	\N	\N	\N	\N	170710	170710	337947
22231	33429	56	applied	\N	\N	\N	\N	170711	170711	337948
22231	33433	57	applied	\N	\N	\N	\N	170712	170712	337949
22231	33434	58	applied	\N	\N	\N	\N	170713	170713	337950
22231	33440	59	applied	\N	\N	\N	\N	170714	170714	337951
22177	33320	1	applied	\N	\N	\N	\N	170115	170115	337358
22177	33321	2	applied	\N	\N	\N	\N	170116	170116	337359
22184	33125	16	applied	\N	\N	\N	\N	170167	170167	337409
22184	33129	17	applied	\N	\N	\N	\N	170168	170168	337410
22184	33140	18	applied	\N	\N	\N	\N	170169	170169	337411
22184	33148	19	applied	\N	\N	\N	\N	170170	170170	337412
22184	33163	20	applied	\N	\N	\N	\N	170171	170171	337413
22184	33170	21	applied	\N	\N	1000000000	\N	170172	170172	337414
22184	32897	22	applied	\N	\N	\N	\N	170173	170173	337415
22184	32900	23	applied	\N	\N	\N	\N	170174	170174	337416
22184	32903	24	applied	\N	\N	\N	\N	170175	170175	337417
22184	32906	25	applied	\N	\N	\N	\N	170176	170176	337418
22184	32909	26	applied	\N	\N	\N	\N	170177	170177	337419
22184	32912	27	applied	\N	\N	\N	\N	170178	170178	337420
22184	32915	28	applied	\N	\N	\N	\N	170179	170179	337421
22184	32918	29	applied	\N	\N	\N	\N	170180	170180	337422
22184	32930	31	applied	\N	\N	\N	\N	170182	170182	337424
22184	33035	32	applied	\N	\N	\N	\N	170183	170183	337425
22184	33036	33	applied	\N	\N	\N	\N	170184	170184	337426
22184	33054	34	applied	\N	\N	\N	\N	170185	170185	337427
22184	32926	35	applied	\N	\N	\N	\N	170186	170186	337428
22184	32931	36	applied	\N	\N	\N	\N	170187	170187	337429
22184	32932	37	applied	\N	\N	\N	\N	170188	170188	337430
22184	32937	38	applied	\N	\N	\N	\N	170189	170189	337431
22184	32940	39	applied	\N	\N	\N	\N	170190	170190	337432
22184	32944	40	applied	\N	\N	\N	\N	170191	170191	337433
22184	32945	41	applied	\N	\N	\N	\N	170192	170192	337434
22184	32946	42	applied	\N	\N	\N	\N	170193	170193	337435
22184	32953	43	applied	\N	\N	\N	\N	170194	170194	337436
22184	32957	44	applied	\N	\N	\N	\N	170195	170195	337437
22184	32959	45	applied	\N	\N	\N	\N	170196	170196	337438
22184	32963	46	applied	\N	\N	\N	\N	170197	170197	337439
22184	32969	48	applied	\N	\N	\N	\N	170199	170199	337441
22184	32970	49	applied	\N	\N	\N	\N	170200	170200	337442
22184	32971	50	applied	\N	\N	\N	\N	170201	170201	337443
22184	32972	51	applied	\N	\N	\N	\N	170202	170202	337444
22184	32983	52	applied	\N	\N	\N	\N	170203	170203	337445
22184	32986	53	applied	\N	\N	\N	\N	170204	170204	337446
22184	32990	54	applied	\N	\N	\N	\N	170205	170205	337447
22184	32993	55	applied	\N	\N	\N	\N	170206	170206	337448
22184	32996	56	applied	\N	\N	\N	\N	170207	170207	337449
22184	33000	57	applied	\N	\N	\N	\N	170208	170208	337450
22184	33003	58	applied	\N	\N	\N	\N	170209	170209	337451
22184	33004	59	applied	\N	\N	\N	\N	170210	170210	337452
22184	33005	60	applied	\N	\N	\N	\N	170211	170211	337453
22184	33013	61	applied	\N	\N	\N	\N	170212	170212	337454
22184	33016	62	applied	\N	\N	\N	\N	170213	170213	337455
22184	33019	63	applied	\N	\N	\N	\N	170214	170214	337456
22184	33024	65	applied	\N	\N	\N	\N	170216	170216	337458
22184	33029	66	applied	\N	\N	\N	\N	170217	170217	337459
22184	33034	67	applied	\N	\N	\N	\N	170218	170218	337460
22184	33039	68	applied	\N	\N	\N	\N	170219	170219	337461
22184	33040	69	applied	\N	\N	\N	\N	170220	170220	337462
22184	33045	70	applied	\N	\N	\N	\N	170221	170221	337463
22184	33048	71	applied	\N	\N	\N	\N	170222	170222	337464
22184	33051	72	applied	\N	\N	\N	\N	170223	170223	337465
22184	33055	73	applied	\N	\N	\N	\N	170224	170224	337466
22184	33059	74	applied	\N	\N	\N	\N	170225	170225	337467
22184	33062	75	applied	\N	\N	\N	\N	170226	170226	337468
22184	33065	76	applied	\N	\N	\N	\N	170227	170227	337469
22184	33069	77	applied	\N	\N	\N	\N	170228	170228	337470
22184	33070	78	applied	\N	\N	\N	\N	170229	170229	337471
22184	33071	79	applied	\N	\N	\N	\N	170230	170230	337472
22184	33081	80	applied	\N	\N	\N	\N	170231	170231	337473
22184	33087	82	applied	\N	\N	\N	\N	170233	170233	337475
22184	33091	83	applied	\N	\N	\N	\N	170234	170234	337476
22184	33094	84	applied	\N	\N	\N	\N	170235	170235	337477
22184	33095	85	applied	\N	\N	\N	\N	170236	170236	337478
22184	33101	86	applied	\N	\N	\N	\N	170237	170237	337479
22184	33104	87	applied	\N	\N	\N	\N	170238	170238	337480
22184	33107	88	applied	\N	\N	\N	\N	170239	170239	337481
22184	33108	89	applied	\N	\N	\N	\N	170240	170240	337482
22184	33109	90	applied	\N	\N	\N	\N	170241	170241	337483
22184	33117	91	applied	\N	\N	\N	\N	170242	170242	337484
22184	33118	92	applied	\N	\N	\N	\N	170243	170243	337485
22184	33124	93	applied	\N	\N	\N	\N	170244	170244	337486
22184	33128	94	applied	\N	\N	\N	\N	170245	170245	337487
22184	33130	95	applied	\N	\N	\N	\N	170246	170246	337488
22184	33136	96	applied	\N	\N	\N	\N	170247	170247	337489
22184	33141	97	applied	\N	\N	\N	\N	170248	170248	337490
22184	33149	99	applied	\N	\N	\N	\N	170250	170250	337492
22184	33152	100	applied	\N	\N	\N	\N	170251	170251	337493
22184	33153	101	applied	\N	\N	\N	\N	170252	170252	337494
22184	33154	102	applied	\N	\N	\N	\N	170253	170253	337495
22184	33162	103	applied	\N	\N	\N	\N	170254	170254	337496
22184	33164	104	applied	\N	\N	\N	\N	170255	170255	337497
22184	33169	105	applied	\N	\N	\N	\N	170256	170256	337498
22184	33174	106	applied	\N	\N	\N	\N	170257	170257	337499
22184	33177	107	applied	\N	\N	\N	\N	170258	170258	337500
22184	33180	108	applied	\N	\N	\N	\N	170259	170259	337501
22184	33184	109	applied	\N	\N	\N	\N	170260	170260	337502
22184	33187	110	applied	\N	\N	\N	\N	170261	170261	337503
22184	33190	111	applied	\N	\N	\N	\N	170262	170262	337504
22184	33191	112	applied	\N	\N	\N	\N	170263	170263	337505
22208	33102	46	applied	\N	\N	\N	\N	170541	170541	337778
22208	33105	47	applied	\N	\N	\N	\N	170542	170542	337779
22208	33115	49	applied	\N	\N	\N	\N	170544	170544	337781
22208	33116	50	applied	\N	\N	\N	\N	170545	170545	337782
22208	33119	51	applied	\N	\N	\N	\N	170546	170546	337783
22208	33120	52	applied	\N	\N	\N	\N	170547	170547	337784
22208	33127	53	applied	\N	\N	\N	\N	170548	170548	337785
22208	33131	54	applied	\N	\N	\N	\N	170549	170549	337786
22208	33132	55	applied	\N	\N	\N	\N	170550	170550	337787
22208	33137	56	applied	\N	\N	\N	\N	170551	170551	337788
22208	33143	57	applied	\N	\N	\N	\N	170552	170552	337789
22208	33144	58	applied	\N	\N	\N	\N	170553	170553	337790
22208	33151	59	applied	\N	\N	\N	\N	170554	170554	337791
22208	33157	60	applied	\N	\N	\N	\N	170555	170555	337792
22211	33431	0	applied	\N	\N	\N	\N	170576	170576	337813
22211	33432	1	applied	\N	\N	\N	\N	170577	170577	337814
22211	33433	2	applied	\N	\N	\N	\N	170578	170578	337815
22211	33434	3	applied	\N	\N	\N	\N	170579	170579	337816
22184	32894	15	applied	\N	\N	\N	\N	170166	170166	337408
22184	33208	117	applied	\N	\N	\N	\N	170268	170268	337510
22184	33209	118	applied	\N	\N	\N	\N	170269	170269	337511
22184	33217	119	applied	\N	\N	\N	\N	170270	170270	337512
22184	33218	120	applied	\N	\N	\N	\N	170271	170271	337513
22184	33223	121	applied	\N	\N	\N	\N	170272	170272	337514
22184	33226	122	applied	\N	\N	\N	\N	170273	170273	337515
22184	33227	123	applied	\N	\N	\N	\N	170274	170274	337516
22184	33228	124	applied	\N	\N	\N	\N	170275	170275	337517
22184	33237	125	applied	\N	\N	\N	\N	170276	170276	337518
22189	33363	0	applied	\N	\N	\N	\N	170295	170295	337537
22189	33364	1	applied	\N	\N	\N	\N	170296	170296	337538
22189	33365	2	applied	\N	\N	\N	\N	170297	170297	337539
22192	33369	0	applied	\N	\N	\N	\N	170305	170305	337547
22192	33370	1	applied	\N	\N	\N	\N	170306	170306	337548
22192	33371	2	applied	\N	\N	\N	\N	170307	170307	337549
22192	33372	3	applied	\N	\N	\N	\N	170308	170308	337550
22195	33381	1	applied	\N	\N	\N	\N	170321	170321	337563
22195	33382	2	applied	\N	\N	\N	\N	170322	170322	337564
22195	33383	3	applied	\N	\N	\N	\N	170323	170323	337565
22202	33403	0	applied	\N	\N	\N	\N	170474	170474	337711
22202	33404	1	applied	\N	\N	\N	\N	170475	170475	337712
22202	33405	2	applied	\N	\N	\N	\N	170476	170476	337713
22207	33417	0	applied	\N	\N	\N	\N	170492	170492	337729
22207	33418	1	applied	\N	\N	\N	\N	170493	170493	337730
22207	33419	2	applied	\N	\N	\N	\N	170494	170494	337731
22207	33420	3	applied	\N	\N	\N	\N	170495	170495	337732
22210	33421	0	applied	\N	\N	\N	\N	170566	170566	337803
22210	33422	1	applied	\N	\N	\N	\N	170567	170567	337804
22210	33423	2	applied	\N	\N	\N	\N	170568	170568	337805
22210	33424	3	applied	\N	\N	\N	\N	170569	170569	337806
22210	33425	4	applied	\N	\N	\N	\N	170570	170570	337807
22210	33426	5	applied	\N	\N	\N	\N	170571	170571	337808
22210	33428	7	applied	\N	\N	\N	\N	170573	170573	337810
22210	33429	8	applied	\N	\N	\N	\N	170574	170574	337811
22210	33430	9	applied	\N	\N	\N	\N	170575	170575	337812
22221	33457	0	applied	\N	\N	\N	\N	170620	170620	337857
22221	33458	1	applied	\N	\N	\N	\N	170621	170621	337858
22221	33459	2	applied	\N	\N	\N	\N	170622	170622	337859
22221	33460	3	applied	\N	\N	\N	\N	170623	170623	337860
22221	33461	4	applied	\N	\N	\N	\N	170624	170624	337861
22224	33466	0	applied	\N	\N	\N	\N	170631	170631	337868
22224	33468	1	applied	\N	\N	\N	\N	170632	170632	337869
22224	33467	2	applied	\N	\N	\N	\N	170633	170633	337870
22227	33466	0	applied	\N	\N	\N	\N	170639	170639	337876
22227	33468	1	applied	\N	\N	\N	\N	170640	170640	337877
22227	33467	2	applied	\N	\N	\N	\N	170641	170641	337878
22235	33485	0	applied	\N	\N	\N	\N	170742	170742	337979
22235	33486	1	applied	\N	\N	\N	\N	170743	170743	337980
22235	33488	3	applied	\N	\N	\N	\N	170745	170745	337982
22235	33489	4	applied	\N	\N	\N	\N	170746	170746	337983
22235	33490	5	applied	\N	\N	\N	\N	170747	170747	337984
22235	33491	6	applied	\N	\N	\N	\N	170748	170748	337985
22235	33492	7	applied	\N	\N	\N	\N	170749	170749	337986
22237	33485	0	applied	\N	\N	\N	\N	170758	170758	337995
22237	33486	1	applied	\N	\N	\N	\N	170759	170759	337996
22237	33487	2	applied	\N	\N	\N	\N	170760	170760	337997
22237	33488	3	applied	\N	\N	\N	\N	170761	170761	337998
22237	33489	4	applied	\N	\N	\N	\N	170762	170762	337999
22237	33490	5	applied	\N	\N	\N	\N	170763	170763	338000
22237	33491	6	applied	\N	\N	\N	\N	170764	170764	338001
22237	33492	7	applied	\N	\N	\N	\N	170765	170765	338002
22240	33496	0	applied	\N	\N	\N	\N	170776	170776	338013
22240	33497	1	applied	\N	\N	\N	\N	170777	170777	338014
22240	33498	2	applied	\N	\N	\N	\N	170778	170778	338015
22240	33500	4	applied	\N	\N	\N	\N	170780	170780	338017
22240	33501	5	applied	\N	\N	\N	\N	170781	170781	338018
22240	33502	6	applied	\N	\N	\N	\N	170782	170782	338019
22242	33496	0	applied	\N	\N	\N	\N	170786	170786	338023
22242	33498	1	applied	\N	\N	\N	\N	170787	170787	338024
22242	33499	2	applied	\N	\N	\N	\N	170788	170788	338025
22242	33500	3	applied	\N	\N	\N	\N	170789	170789	338026
22244	33506	0	applied	\N	\N	\N	\N	170794	170794	338031
22244	33507	1	applied	\N	\N	\N	\N	170795	170795	338032
22244	33508	2	applied	\N	\N	\N	\N	170796	170796	338033
22244	33509	3	applied	\N	\N	\N	\N	170797	170797	338034
22244	33510	4	applied	\N	\N	\N	\N	170798	170798	338035
22244	33511	5	applied	\N	\N	\N	\N	170799	170799	338036
22244	33512	6	applied	\N	\N	\N	\N	170800	170800	338037
22244	33513	7	applied	\N	\N	\N	\N	170801	170801	338038
22246	33496	0	applied	\N	\N	\N	\N	170811	170811	338048
22246	33507	2	applied	\N	\N	\N	\N	170813	170813	338050
22246	33508	3	applied	\N	\N	\N	\N	170814	170814	338051
22246	33498	4	applied	\N	\N	\N	\N	170815	170815	338052
22246	33510	5	applied	\N	\N	\N	\N	170816	170816	338053
22246	33511	6	applied	\N	\N	\N	\N	170817	170817	338054
22246	33499	7	applied	\N	\N	\N	\N	170818	170818	338055
22246	33500	8	applied	\N	\N	\N	\N	170819	170819	338056
22253	33524	0	applied	\N	\N	\N	\N	170847	170847	338084
22253	33525	1	applied	\N	\N	\N	\N	170848	170848	338085
22253	33526	2	applied	\N	\N	\N	\N	170849	170849	338086
22253	33527	3	applied	\N	\N	\N	\N	170850	170850	338087
22253	33528	4	applied	\N	\N	\N	\N	170851	170851	338088
22253	33529	5	applied	\N	\N	\N	\N	170852	170852	338089
22253	33530	6	applied	\N	\N	\N	\N	170853	170853	338090
22256	33534	0	applied	\N	\N	\N	\N	170860	170860	338097
22256	33535	1	applied	\N	\N	\N	\N	170861	170861	338098
22258	33537	0	applied	\N	\N	\N	\N	170867	170867	338104
22258	33538	1	applied	\N	\N	\N	\N	170868	170868	338105
22258	33539	2	applied	\N	\N	\N	\N	170869	170869	338106
22258	33540	3	applied	\N	\N	\N	\N	170870	170870	338107
22260	33541	0	applied	\N	\N	\N	\N	170875	170875	338112
22260	33542	1	applied	\N	\N	\N	\N	170876	170876	338113
22260	33543	2	applied	\N	\N	\N	\N	170877	170877	338114
22263	33544	0	applied	\N	\N	\N	\N	170883	170883	338120
22263	33545	1	applied	\N	\N	\N	\N	170884	170884	338121
22263	33546	2	applied	\N	\N	\N	\N	170885	170885	338122
22266	33552	0	applied	\N	\N	\N	\N	170902	170902	338139
22266	33553	1	applied	\N	\N	\N	\N	170903	170903	338140
22266	33554	2	applied	\N	\N	\N	\N	170904	170904	338141
22266	33555	3	applied	\N	\N	\N	\N	170905	170905	338142
22184	33198	114	applied	\N	\N	\N	\N	170265	170265	337507
22184	33203	115	applied	\N	\N	\N	\N	170266	170266	337508
22199	32908	65	applied	\N	\N	\N	\N	170401	170401	337638
22199	33032	66	applied	\N	\N	\N	\N	170402	170402	337639
22199	33042	67	applied	\N	\N	\N	\N	170403	170403	337640
22199	33273	68	applied	\N	\N	1000000000	\N	170404	170404	337641
22199	33056	69	applied	\N	\N	\N	\N	170405	170405	337642
22199	33066	70	applied	\N	\N	\N	\N	170406	170406	337643
22199	33080	71	applied	\N	\N	\N	\N	170407	170407	337644
22199	32899	72	applied	\N	\N	\N	\N	170408	170408	337645
22199	32901	73	applied	\N	\N	\N	\N	170409	170409	337646
22199	32904	74	applied	\N	\N	\N	\N	170410	170410	337647
22199	32907	75	applied	\N	\N	\N	\N	170411	170411	337648
22199	32910	76	applied	\N	\N	\N	\N	170412	170412	337649
22199	32913	77	applied	\N	\N	\N	\N	170413	170413	337650
22199	32911	78	applied	\N	\N	\N	\N	170414	170414	337651
22199	32916	80	applied	\N	\N	\N	\N	170416	170416	337653
22199	33090	81	applied	\N	\N	\N	\N	170417	170417	337654
22199	33097	82	applied	\N	\N	\N	\N	170418	170418	337655
22199	33111	83	applied	\N	\N	\N	\N	170419	170419	337656
22199	33121	84	applied	\N	\N	\N	\N	170420	170420	337657
22199	33135	85	applied	\N	\N	\N	\N	170421	170421	337658
22199	33146	86	applied	\N	\N	\N	\N	170422	170422	337659
22199	33155	87	applied	\N	\N	\N	\N	170423	170423	337660
22199	33173	88	applied	\N	\N	\N	\N	170424	170424	337661
22199	33182	89	applied	\N	\N	\N	\N	170425	170425	337662
22199	33192	90	applied	\N	\N	\N	\N	170426	170426	337663
22199	33206	91	applied	\N	\N	\N	\N	170427	170427	337664
22199	33210	92	applied	\N	\N	\N	\N	170428	170428	337665
22199	33229	93	applied	\N	\N	\N	\N	170429	170429	337666
22199	33239	94	applied	\N	\N	\N	\N	170430	170430	337667
22199	33246	95	applied	\N	\N	\N	\N	170431	170431	337668
22199	33271	97	applied	\N	\N	\N	\N	170433	170433	337670
22199	33284	98	applied	\N	\N	\N	\N	170434	170434	337671
22199	33305	99	applied	\N	\N	\N	\N	170435	170435	337672
22199	33313	100	applied	\N	\N	\N	\N	170436	170436	337673
22199	33324	101	applied	\N	\N	\N	\N	170437	170437	337674
22199	33338	102	applied	\N	\N	\N	\N	170438	170438	337675
22199	33347	103	applied	\N	\N	\N	\N	170439	170439	337676
22199	33357	104	applied	\N	\N	\N	\N	170440	170440	337677
22199	33372	105	applied	\N	\N	\N	\N	170441	170441	337678
22199	33383	106	applied	\N	\N	\N	\N	170442	170442	337679
22199	33395	107	applied	\N	\N	\N	\N	170443	170443	337680
22199	32920	108	applied	\N	\N	\N	\N	170444	170444	337681
22199	32933	109	applied	\N	\N	\N	\N	170445	170445	337682
22199	32934	110	applied	\N	\N	\N	\N	170446	170446	337683
22199	32935	111	applied	\N	\N	\N	\N	170447	170447	337684
22199	32936	112	applied	\N	\N	\N	\N	170448	170448	337685
22199	32943	114	applied	\N	\N	\N	\N	170450	170450	337687
22199	32947	115	applied	\N	\N	\N	\N	170451	170451	337688
22199	32949	116	applied	\N	\N	\N	\N	170452	170452	337689
22199	32950	117	applied	\N	\N	\N	\N	170453	170453	337690
22199	32954	118	applied	\N	\N	\N	\N	170454	170454	337691
22199	32960	119	applied	\N	\N	\N	\N	170455	170455	337692
22199	32961	120	applied	\N	\N	\N	\N	170456	170456	337693
22199	32966	121	applied	\N	\N	\N	\N	170457	170457	337694
22199	32973	122	applied	\N	\N	\N	\N	170458	170458	337695
22199	32975	123	applied	\N	\N	\N	\N	170459	170459	337696
22199	32980	124	applied	\N	\N	\N	\N	170460	170460	337697
22199	32981	125	applied	\N	\N	\N	\N	170461	170461	337698
22204	33406	0	applied	\N	\N	\N	\N	170481	170481	337718
22204	33407	1	applied	\N	\N	\N	\N	170482	170482	337719
22204	33408	2	applied	\N	\N	\N	\N	170483	170483	337720
22204	33409	3	applied	\N	\N	\N	\N	170484	170484	337721
22206	33415	1	applied	\N	\N	\N	\N	170490	170490	337727
22206	33416	2	applied	\N	\N	\N	\N	170491	170491	337728
22209	33421	0	applied	\N	\N	\N	\N	170556	170556	337793
22209	33422	1	applied	\N	\N	\N	\N	170557	170557	337794
22209	33423	2	applied	\N	\N	\N	\N	170558	170558	337795
22209	33424	3	applied	\N	\N	\N	\N	170559	170559	337796
22209	33425	4	applied	\N	\N	\N	\N	170560	170560	337797
22209	33426	5	applied	\N	\N	\N	\N	170561	170561	337798
22209	33427	6	applied	\N	\N	\N	\N	170562	170562	337799
22209	33428	7	applied	\N	\N	\N	\N	170563	170563	337800
22209	33429	8	applied	\N	\N	\N	\N	170564	170564	337801
22209	33430	9	applied	\N	\N	\N	\N	170565	170565	337802
22213	33437	0	applied	\N	\N	\N	\N	170591	170591	337828
22213	33438	1	applied	\N	\N	\N	\N	170592	170592	337829
22213	33439	2	applied	\N	\N	\N	\N	170593	170593	337830
22213	33440	3	applied	\N	\N	\N	\N	170594	170594	337831
22213	33442	5	applied	\N	\N	\N	\N	170596	170596	337833
22213	33443	6	applied	\N	\N	\N	\N	170597	170597	337834
22213	33444	7	applied	\N	\N	\N	\N	170598	170598	337835
22213	33445	8	applied	\N	\N	\N	\N	170599	170599	337836
22215	33446	0	applied	\N	\N	\N	\N	170609	170609	337846
22215	33447	1	applied	\N	\N	\N	\N	170610	170610	337847
22215	33448	2	applied	\N	\N	\N	\N	170611	170611	337848
22223	33466	0	applied	\N	\N	\N	\N	170629	170629	337866
22223	33467	1	applied	\N	\N	\N	\N	170630	170630	337867
22226	33466	0	applied	\N	\N	\N	\N	170637	170637	337874
22226	33467	1	applied	\N	\N	\N	\N	170638	170638	337875
22230	33469	0	applied	\N	\N	\N	\N	170652	170652	337889
22230	33468	1	applied	\N	\N	\N	\N	170653	170653	337890
22230	33470	2	applied	\N	\N	\N	\N	170654	170654	337891
22266	33556	4	applied	\N	\N	\N	\N	170906	170906	338143
22266	33557	5	applied	\N	\N	\N	\N	170907	170907	338144
22266	33559	7	applied	\N	\N	\N	\N	170909	170909	338146
22266	33560	8	applied	\N	\N	\N	\N	170910	170910	338147
22266	33561	9	applied	\N	\N	\N	\N	170911	170911	338148
22266	33562	10	applied	\N	\N	\N	\N	170912	170912	338149
22268	33566	0	applied	\N	\N	\N	\N	170916	170916	338153
22268	33567	1	applied	\N	\N	\N	\N	170917	170917	338154
22268	33568	2	applied	\N	\N	\N	\N	170918	170918	338155
22274	33588	0	applied	\N	\N	\N	\N	170944	170944	338181
22274	33589	1	applied	\N	\N	\N	\N	170945	170945	338182
22274	33590	2	applied	\N	\N	\N	\N	170946	170946	338183
22276	33597	0	applied	\N	\N	\N	\N	170953	170953	338190
22276	33598	1	applied	\N	\N	\N	\N	170954	170954	338191
22276	33599	2	applied	\N	\N	\N	\N	170955	170955	338192
22281	33603	0	applied	\N	\N	\N	\N	170964	170964	338201
22281	33604	1	applied	\N	\N	\N	\N	170965	170965	338202
22285	33610	0	applied	\N	\N	\N	\N	171099	171099	338335
22199	32905	64	applied	\N	\N	\N	\N	170400	170400	337637
22212	33439	2	applied	\N	\N	\N	\N	170584	170584	337821
22212	33440	3	applied	\N	\N	\N	\N	170585	170585	337822
22212	33441	4	applied	\N	\N	\N	\N	170586	170586	337823
22212	33442	5	applied	\N	\N	\N	\N	170587	170587	337824
22212	33443	6	applied	\N	\N	\N	\N	170588	170588	337825
22212	33444	7	applied	\N	\N	\N	\N	170589	170589	337826
22212	33445	8	applied	\N	\N	\N	\N	170590	170590	337827
22222	33462	0	applied	\N	\N	\N	\N	170625	170625	337862
22222	33463	1	applied	\N	\N	\N	\N	170626	170626	337863
22222	33464	2	applied	\N	\N	\N	\N	170627	170627	337864
22222	33465	3	applied	\N	\N	\N	\N	170628	170628	337865
22229	33469	0	applied	\N	\N	\N	\N	170647	170647	337884
22229	33468	1	applied	\N	\N	\N	\N	170648	170648	337885
22229	33470	2	applied	\N	\N	\N	\N	170649	170649	337886
22229	33471	3	applied	\N	\N	\N	\N	170650	170650	337887
22229	33472	4	applied	\N	\N	\N	\N	170651	170651	337888
22232	33469	0	applied	\N	\N	\N	\N	170725	170725	337962
22232	33468	1	applied	\N	\N	\N	\N	170726	170726	337963
22232	33470	2	applied	\N	\N	\N	\N	170727	170727	337964
22232	33471	3	applied	\N	\N	\N	\N	170728	170728	337965
22232	33472	4	applied	\N	\N	\N	\N	170729	170729	337966
22233	33473	0	applied	\N	\N	\N	\N	170730	170730	337967
22233	33474	1	applied	\N	\N	\N	\N	170731	170731	337968
22233	33475	2	applied	\N	\N	\N	\N	170732	170732	337969
22233	33476	3	applied	\N	\N	\N	\N	170733	170733	337970
22233	33477	4	applied	\N	\N	\N	\N	170734	170734	337971
22233	33478	5	applied	\N	\N	\N	\N	170735	170735	337972
22234	33479	0	applied	\N	\N	\N	\N	170736	170736	337973
22234	33480	1	applied	\N	\N	\N	\N	170737	170737	337974
22234	33481	2	applied	\N	\N	\N	\N	170738	170738	337975
22234	33482	3	applied	\N	\N	\N	\N	170739	170739	337976
22234	33483	4	applied	\N	\N	\N	\N	170740	170740	337977
22238	33493	0	applied	\N	\N	\N	\N	170766	170766	338003
22238	33494	1	applied	\N	\N	\N	\N	170767	170767	338004
22238	33495	2	applied	\N	\N	\N	\N	170768	170768	338005
22239	33496	0	applied	\N	\N	\N	\N	170769	170769	338006
22239	33497	1	applied	\N	\N	\N	\N	170770	170770	338007
22239	33498	2	applied	\N	\N	\N	\N	170771	170771	338008
22239	33499	3	applied	\N	\N	\N	\N	170772	170772	338009
22239	33500	4	applied	\N	\N	\N	\N	170773	170773	338010
22239	33501	5	applied	\N	\N	\N	\N	170774	170774	338011
22239	33502	6	applied	\N	\N	\N	\N	170775	170775	338012
22241	33503	0	applied	\N	\N	\N	\N	170783	170783	338020
22241	33504	1	applied	\N	\N	\N	\N	170784	170784	338021
22241	33505	2	applied	\N	\N	\N	\N	170785	170785	338022
22243	33496	0	applied	\N	\N	\N	\N	170790	170790	338027
22243	33498	1	applied	\N	\N	\N	\N	170791	170791	338028
22245	33496	0	applied	\N	\N	\N	\N	170802	170802	338039
22245	33507	2	applied	\N	\N	\N	\N	170804	170804	338041
22245	33508	3	applied	\N	\N	\N	\N	170805	170805	338042
22245	33498	4	applied	\N	\N	\N	\N	170806	170806	338043
22245	33510	5	applied	\N	\N	\N	\N	170807	170807	338044
22245	33511	6	applied	\N	\N	\N	\N	170808	170808	338045
22245	33499	7	applied	\N	\N	\N	\N	170809	170809	338046
22245	33500	8	applied	\N	\N	\N	\N	170810	170810	338047
22247	33514	0	applied	\N	\N	\N	\N	170820	170820	338057
22247	33515	1	applied	\N	\N	\N	\N	170821	170821	338058
22247	33516	2	applied	\N	\N	\N	\N	170822	170822	338059
22247	33517	3	applied	\N	\N	\N	\N	170823	170823	338060
22252	33524	0	applied	\N	\N	\N	\N	170840	170840	338077
22252	33525	1	applied	\N	\N	\N	\N	170841	170841	338078
22252	33526	2	applied	\N	\N	\N	\N	170842	170842	338079
22252	33527	3	applied	\N	\N	\N	\N	170843	170843	338080
22252	33528	4	applied	\N	\N	\N	\N	170844	170844	338081
22252	33530	6	applied	\N	\N	\N	\N	170846	170846	338083
22257	33537	0	applied	\N	\N	\N	\N	170863	170863	338100
22257	33538	1	applied	\N	\N	\N	\N	170864	170864	338101
22257	33539	2	applied	\N	\N	\N	\N	170865	170865	338102
22257	33540	3	applied	\N	\N	\N	\N	170866	170866	338103
22259	33537	0	applied	\N	\N	\N	\N	170871	170871	338108
22259	33538	1	applied	\N	\N	\N	\N	170872	170872	338109
22259	33539	2	applied	\N	\N	\N	\N	170873	170873	338110
22259	33540	3	applied	\N	\N	\N	\N	170874	170874	338111
22272	33580	0	applied	\N	\N	\N	\N	170933	170933	338170
22272	33581	1	applied	\N	\N	\N	\N	170934	170934	338171
22272	33582	2	applied	\N	\N	\N	\N	170935	170935	338172
22272	33583	3	applied	\N	\N	\N	\N	170936	170936	338173
22272	33584	4	applied	\N	\N	\N	\N	170937	170937	338174
22272	33585	5	applied	\N	\N	\N	\N	170938	170938	338175
22272	33586	6	applied	\N	\N	\N	\N	170939	170939	338176
22275	33591	0	applied	\N	\N	\N	\N	170947	170947	338184
22275	33592	1	applied	\N	\N	\N	\N	170948	170948	338185
22275	33593	2	applied	\N	\N	\N	\N	170949	170949	338186
22275	33594	3	applied	\N	\N	\N	\N	170950	170950	338187
22275	33595	4	applied	\N	\N	\N	\N	170951	170951	338188
22275	33596	5	applied	\N	\N	\N	\N	170952	170952	338189
22282	33605	0	applied	\N	\N	\N	\N	170966	170966	338203
22282	33606	1	applied	\N	\N	\N	\N	170967	170967	338204
22282	33607	2	applied	\N	\N	\N	\N	170968	170968	338205
22282	33608	3	applied	\N	\N	\N	\N	170969	170969	338206
22284	33280	0	applied	\N	\N	\N	\N	170974	170974	338211
22284	33285	1	applied	\N	\N	\N	\N	170975	170975	338212
22284	33286	2	applied	\N	\N	\N	\N	170976	170976	338213
22284	33291	3	applied	\N	\N	\N	\N	170977	170977	338214
22284	33139	4	applied	\N	\N	\N	\N	170978	170978	170978
22284	33292	5	applied	\N	\N	\N	\N	170979	170979	338215
22284	33294	7	applied	\N	\N	\N	\N	170981	170981	338217
22284	33295	8	applied	\N	\N	\N	\N	170982	170982	338218
22284	33496	9	applied	\N	\N	\N	\N	170983	170983	338219
22284	33485	10	applied	\N	\N	\N	\N	170984	170984	338220
22284	32515	11	applied	\N	\N	\N	\N	170985	170985	338221
22284	33506	12	applied	\N	\N	\N	\N	170986	170986	338222
22284	33507	13	applied	\N	\N	\N	\N	170987	170987	338223
22284	33033	14	applied	\N	\N	\N	\N	170988	170988	338224
22284	33508	15	applied	\N	\N	\N	\N	170989	170989	338225
22284	33487	16	applied	\N	\N	\N	\N	170990	170990	338226
22284	33188	17	applied	\N	\N	\N	\N	170991	170991	338227
22284	32923	18	applied	\N	\N	\N	\N	170992	170992	338228
22284	32924	19	applied	\N	\N	\N	\N	170993	170993	338229
22284	32925	20	applied	\N	\N	\N	\N	170994	170994	338230
22211	33436	5	applied	\N	\N	\N	\N	170581	170581	337818
22212	33437	0	applied	\N	\N	\N	\N	170582	170582	337819
22231	33457	65	applied	\N	\N	\N	\N	170720	170720	337957
22231	33461	66	applied	\N	\N	\N	\N	170721	170721	337958
22231	33465	67	applied	\N	\N	\N	\N	170722	170722	337959
22231	33467	68	applied	\N	\N	\N	\N	170723	170723	337960
22231	33472	69	applied	\N	\N	\N	\N	170724	170724	337961
22236	33485	0	applied	\N	\N	\N	\N	170750	170750	337987
22236	33486	1	applied	\N	\N	\N	\N	170751	170751	337988
22236	33487	2	applied	\N	\N	\N	\N	170752	170752	337989
22236	33488	3	applied	\N	\N	\N	\N	170753	170753	337990
22236	33489	4	applied	\N	\N	\N	\N	170754	170754	337991
22236	33490	5	applied	\N	\N	\N	\N	170755	170755	337992
22236	33491	6	applied	\N	\N	\N	\N	170756	170756	337993
22236	33492	7	applied	\N	\N	\N	\N	170757	170757	337994
22251	33518	0	applied	\N	\N	\N	\N	170834	170834	338071
22251	33520	2	applied	\N	\N	\N	\N	170836	170836	338073
22251	33521	3	applied	\N	\N	\N	\N	170837	170837	338074
22251	33522	4	applied	\N	\N	\N	\N	170838	170838	338075
22251	33523	5	applied	\N	\N	\N	\N	170839	170839	338076
22254	33531	0	applied	\N	\N	\N	\N	170854	170854	338091
22254	33532	1	applied	\N	\N	\N	\N	170855	170855	338092
22254	33533	2	applied	\N	\N	\N	\N	170856	170856	338093
22261	33541	0	applied	\N	\N	\N	\N	170878	170878	338115
22261	33542	1	applied	\N	\N	\N	\N	170879	170879	338116
22269	33566	0	applied	\N	\N	\N	\N	170919	170919	338156
22269	33567	1	applied	\N	\N	\N	\N	170920	170920	338157
22269	33568	2	applied	\N	\N	\N	\N	170921	170921	338158
22271	33577	0	applied	\N	\N	\N	\N	170930	170930	338167
22271	33578	1	applied	\N	\N	\N	\N	170931	170931	338168
22271	33579	2	applied	\N	\N	\N	\N	170932	170932	338169
22277	33597	0	applied	\N	\N	\N	\N	170956	170956	338193
22277	33599	2	applied	\N	\N	\N	\N	170958	170958	338195
22284	33498	21	applied	\N	\N	\N	\N	170995	170995	338231
22284	33488	22	applied	\N	\N	\N	\N	170996	170996	338232
22284	33125	23	applied	\N	\N	\N	\N	170997	170997	338233
22284	33129	24	applied	\N	\N	\N	\N	170998	170998	338234
22284	33140	25	applied	\N	\N	\N	\N	170999	170999	338235
22284	33148	26	applied	\N	\N	\N	\N	171000	171000	338236
22284	33510	27	applied	\N	\N	\N	\N	171001	171001	338237
22284	33511	28	applied	\N	\N	\N	\N	171002	171002	338238
22284	33499	29	applied	\N	\N	\N	\N	171003	171003	338239
22284	33500	30	applied	\N	\N	\N	\N	171004	171004	338240
22284	33163	31	applied	\N	\N	\N	\N	171005	171005	338241
22284	33170	32	applied	\N	\N	1000000000	\N	171006	171006	338242
22284	32516	33	applied	\N	\N	\N	\N	171007	171007	338243
22284	32521	34	applied	\N	\N	\N	\N	171008	171008	338244
22284	32522	35	applied	\N	\N	\N	\N	171009	171009	338245
22284	32528	37	applied	\N	\N	\N	\N	171011	171011	338247
22284	32533	38	applied	\N	\N	\N	\N	171012	171012	338248
22284	32534	39	applied	\N	\N	\N	\N	171013	171013	338249
22286	33613	0	applied	\N	\N	\N	\N	171102	171102	338338
22286	33614	1	applied	\N	\N	\N	\N	171103	171103	338339
22286	33615	2	applied	\N	\N	\N	\N	171104	171104	338340
22293	33623	0	applied	\N	\N	\N	\N	171132	171132	338368
22293	33624	1	applied	\N	\N	\N	\N	171133	171133	338369
22293	33625	2	applied	\N	\N	\N	\N	171134	171134	338370
22293	33626	3	applied	\N	\N	\N	\N	171135	171135	338371
22293	33627	4	applied	\N	\N	\N	\N	171136	171136	338372
22293	33628	5	applied	\N	\N	\N	\N	171137	171137	338373
22293	33629	6	applied	\N	\N	\N	\N	171138	171138	338374
22296	33462	0	applied	\N	\N	\N	\N	171149	171149	338385
22296	33496	1	applied	\N	\N	\N	\N	171150	171150	338386
22296	33485	2	applied	\N	\N	\N	\N	171151	171151	338387
22296	33506	4	applied	\N	\N	\N	\N	171153	171153	338389
22296	33507	5	applied	\N	\N	\N	\N	171154	171154	338390
22296	33508	6	applied	\N	\N	\N	\N	171155	171155	338391
22296	33487	7	applied	\N	\N	\N	\N	171156	171156	338392
22296	33306	8	applied	\N	\N	\N	\N	171157	171157	338393
22296	33309	9	applied	\N	\N	\N	\N	171158	171158	338394
22296	33310	10	applied	\N	\N	\N	\N	171159	171159	338395
22296	33316	11	applied	\N	\N	\N	\N	171160	171160	338396
22296	33498	12	applied	\N	\N	\N	\N	171161	171161	338397
22296	33488	13	applied	\N	\N	\N	\N	171162	171162	338398
22296	33319	14	applied	\N	\N	\N	\N	171163	171163	338399
22296	33320	15	applied	\N	\N	\N	\N	171164	171164	338400
22296	33326	16	applied	\N	\N	\N	\N	171165	171165	338401
22296	33327	17	applied	\N	\N	\N	\N	171166	171166	338402
22296	33332	18	applied	\N	\N	\N	\N	171167	171167	338403
22296	33335	19	applied	\N	\N	\N	\N	171168	171168	338404
22296	33340	21	applied	\N	\N	\N	\N	171170	171170	338406
22296	33345	22	applied	\N	\N	\N	\N	171171	171171	338407
22296	33346	23	applied	\N	\N	\N	\N	171172	171172	338408
22296	33352	24	applied	\N	\N	\N	\N	171173	171173	338409
22296	33510	25	applied	\N	\N	\N	\N	171174	171174	338410
22296	33511	26	applied	\N	\N	\N	\N	171175	171175	338411
22296	33499	27	applied	\N	\N	\N	\N	171176	171176	338412
22296	33500	28	applied	\N	\N	\N	\N	171177	171177	338413
22296	33355	29	applied	\N	\N	\N	\N	171178	171178	338414
22296	33360	30	applied	\N	\N	\N	\N	171179	171179	338415
22296	33363	31	applied	\N	\N	\N	\N	171180	171180	338416
22296	33366	32	applied	\N	\N	\N	\N	171181	171181	338417
22296	33369	33	applied	\N	\N	\N	\N	171182	171182	338418
22296	33373	34	applied	\N	\N	\N	\N	171183	171183	338419
22296	33374	35	applied	\N	\N	\N	\N	171184	171184	338420
22296	33380	36	applied	\N	\N	\N	\N	171185	171185	338421
22296	33386	38	applied	\N	\N	\N	\N	171187	171187	338423
22296	33397	39	applied	\N	\N	\N	\N	171188	171188	338424
22296	33398	40	applied	\N	\N	\N	\N	171189	171189	338425
22296	33403	41	applied	\N	\N	\N	\N	171190	171190	338426
22296	33406	42	applied	\N	\N	\N	\N	171191	171191	338427
22296	33410	43	applied	\N	\N	\N	\N	171192	171192	338428
22296	33414	44	applied	\N	\N	\N	\N	171193	171193	338429
22296	33417	45	applied	\N	\N	\N	\N	171194	171194	338430
22296	33421	46	applied	\N	\N	\N	\N	171195	171195	338431
22296	33422	47	applied	\N	\N	\N	\N	171196	171196	338432
22296	33423	48	applied	\N	\N	\N	\N	171197	171197	338433
22296	33431	49	applied	\N	\N	\N	\N	171198	171198	338434
22296	33432	50	applied	\N	\N	\N	\N	171199	171199	338435
22296	33437	51	applied	\N	\N	\N	\N	171200	171200	338436
22296	33438	52	applied	\N	\N	\N	\N	171201	171201	338437
22296	33439	53	applied	\N	\N	\N	\N	171202	171202	338438
22231	33454	64	applied	\N	\N	\N	\N	170719	170719	337956
22248	33516	2	applied	\N	\N	\N	\N	170826	170826	338063
22248	33517	3	applied	\N	\N	\N	\N	170827	170827	338064
22250	33518	0	applied	\N	\N	\N	\N	170828	170828	338065
22250	33519	1	applied	\N	\N	\N	\N	170829	170829	338066
22250	33520	2	applied	\N	\N	\N	\N	170830	170830	338067
22250	33521	3	applied	\N	\N	\N	\N	170831	170831	338068
22250	33522	4	applied	\N	\N	\N	\N	170832	170832	338069
22250	33523	5	applied	\N	\N	\N	\N	170833	170833	338070
22255	33534	0	applied	\N	\N	\N	\N	170857	170857	338094
22255	33535	1	applied	\N	\N	\N	\N	170858	170858	338095
22255	33536	2	applied	\N	\N	\N	\N	170859	170859	338096
22262	33544	0	applied	\N	\N	\N	\N	170880	170880	338117
22262	33545	1	applied	\N	\N	\N	\N	170881	170881	338118
22262	33546	2	applied	\N	\N	\N	\N	170882	170882	338119
22264	33547	0	applied	\N	\N	\N	\N	170886	170886	338123
22264	33548	1	applied	\N	\N	\N	\N	170887	170887	338124
22264	33550	3	applied	\N	\N	\N	\N	170889	170889	338126
22264	33551	4	applied	\N	\N	\N	\N	170890	170890	338127
22265	33552	0	applied	\N	\N	\N	\N	170891	170891	338128
22265	33553	1	applied	\N	\N	\N	\N	170892	170892	338129
22265	33554	2	applied	\N	\N	\N	\N	170893	170893	338130
22265	33555	3	applied	\N	\N	\N	\N	170894	170894	338131
22265	33556	4	applied	\N	\N	\N	\N	170895	170895	338132
22265	33557	5	applied	\N	\N	\N	\N	170896	170896	338133
22265	33558	6	applied	\N	\N	\N	\N	170897	170897	338134
22265	33559	7	applied	\N	\N	\N	\N	170898	170898	338135
22265	33560	8	applied	\N	\N	\N	\N	170899	170899	338136
22265	33561	9	applied	\N	\N	\N	\N	170900	170900	338137
22265	33562	10	applied	\N	\N	\N	\N	170901	170901	338138
22267	33563	0	applied	\N	\N	\N	\N	170913	170913	338150
22267	33564	1	applied	\N	\N	\N	\N	170914	170914	338151
22267	33565	2	applied	\N	\N	\N	\N	170915	170915	338152
22270	33570	1	applied	\N	\N	\N	\N	170923	170923	338160
22270	33571	2	applied	\N	\N	\N	\N	170924	170924	338161
22270	33572	3	applied	\N	\N	\N	\N	170925	170925	338162
22270	33573	4	applied	\N	\N	\N	\N	170926	170926	338163
22270	33574	5	applied	\N	\N	\N	\N	170927	170927	338164
22270	33575	6	applied	\N	\N	\N	\N	170928	170928	338165
22270	33576	7	applied	\N	\N	\N	\N	170929	170929	338166
22273	33588	0	applied	\N	\N	\N	\N	170941	170941	338178
22273	33589	1	applied	\N	\N	\N	\N	170942	170942	338179
22273	33590	2	applied	\N	\N	\N	\N	170943	170943	338180
22278	33600	0	applied	\N	\N	\N	\N	170959	170959	338196
22278	33601	1	applied	\N	\N	\N	\N	170960	170960	338197
22278	33602	2	applied	\N	\N	\N	\N	170961	170961	338198
22280	33603	0	applied	\N	\N	\N	\N	170962	170962	338199
22280	33604	1	applied	\N	\N	\N	\N	170963	170963	338200
22283	33605	0	applied	\N	\N	\N	\N	170970	170970	338207
22283	33607	2	applied	\N	\N	\N	\N	170972	170972	338209
22283	33608	3	applied	\N	\N	\N	\N	170973	170973	338210
22288	33613	0	applied	\N	\N	\N	\N	171108	171108	338344
22288	33614	1	applied	\N	\N	\N	\N	171109	171109	338345
22288	33615	2	applied	\N	\N	\N	\N	171110	171110	338346
22290	33616	0	applied	\N	\N	\N	\N	171118	171118	338354
22290	33617	1	applied	\N	\N	\N	\N	171119	171119	338355
22290	33618	2	applied	\N	\N	\N	\N	171120	171120	338356
22290	33619	4	applied	\N	\N	\N	\N	171121	171121	338357
22290	33620	5	applied	\N	\N	\N	\N	171122	171122	338358
22290	33621	6	applied	\N	\N	\N	\N	171123	171123	338359
22290	33622	7	applied	\N	\N	\N	\N	171124	171124	338360
22295	33630	0	applied	\N	\N	\N	\N	171145	171145	338381
22295	33631	1	applied	\N	\N	\N	\N	171146	171146	338382
22295	33634	2	applied	\N	\N	\N	\N	171147	171147	338383
22295	33635	3	applied	\N	\N	\N	\N	171148	171148	338384
22296	33449	55	applied	\N	\N	\N	\N	171204	171204	338440
22296	33463	56	applied	\N	\N	\N	\N	171205	171205	338441
22296	33466	57	applied	\N	\N	\N	\N	171206	171206	338442
22296	33469	58	applied	\N	\N	\N	\N	171207	171207	338443
22296	33473	59	applied	\N	\N	\N	\N	171208	171208	338444
22296	33474	60	applied	\N	\N	\N	\N	171209	171209	338445
22296	33479	61	applied	\N	\N	\N	\N	171210	171210	338446
22296	33480	62	applied	\N	\N	\N	\N	171211	171211	338447
22296	33486	64	applied	\N	\N	\N	\N	171212	171212	338448
22296	33493	65	applied	\N	\N	\N	\N	171213	171213	338449
22296	33497	66	applied	\N	\N	\N	\N	171214	171214	338450
22296	33503	67	applied	\N	\N	\N	\N	171215	171215	338451
22296	33509	68	applied	\N	\N	\N	\N	171216	171216	338452
22296	33514	69	applied	\N	\N	\N	\N	171217	171217	338453
22296	33518	70	applied	\N	\N	\N	\N	171218	171218	338454
22296	33519	71	applied	\N	\N	\N	\N	171219	171219	338455
22296	33525	73	applied	\N	\N	\N	\N	171221	171221	338457
22300	33653	0	applied	\N	\N	\N	\N	171294	171294	338528
22300	33654	1	applied	\N	\N	\N	\N	171295	171295	338529
22300	33655	2	applied	\N	\N	\N	\N	171296	171296	338530
22302	33656	0	applied	\N	\N	\N	\N	171300	171300	338534
22302	33657	1	applied	\N	\N	\N	\N	171301	171301	338535
22302	33658	2	applied	\N	\N	\N	\N	171302	171302	338536
22305	33670	0	applied	\N	\N	\N	\N	171317	171317	338551
22305	33671	1	applied	\N	\N	\N	\N	171318	171318	338552
22305	33672	2	applied	\N	\N	\N	\N	171319	171319	338553
22307	33670	0	applied	\N	\N	\N	\N	171323	171323	338557
22307	33671	1	applied	\N	\N	\N	\N	171324	171324	338558
22307	33672	2	applied	\N	\N	\N	\N	171325	171325	338559
22309	33662	0	applied	\N	\N	\N	\N	171329	171329	338563
22309	33569	1	applied	\N	\N	\N	\N	171330	171330	338564
22309	33570	2	applied	\N	\N	\N	\N	171331	171331	338565
22309	33580	4	applied	\N	\N	\N	\N	171333	171333	338567
22309	33581	5	applied	\N	\N	\N	\N	171334	171334	338568
22309	33588	6	applied	\N	\N	\N	\N	171335	171335	338569
22309	33591	7	applied	\N	\N	\N	\N	171336	171336	338570
22309	33592	8	applied	\N	\N	\N	\N	171337	171337	338571
22309	33597	9	applied	\N	\N	\N	\N	171338	171338	338572
22309	33600	10	applied	\N	\N	\N	\N	171339	171339	338573
22309	33605	11	applied	\N	\N	\N	\N	171340	171340	338574
22309	33610	12	applied	\N	\N	\N	\N	171341	171341	338575
22309	33613	13	applied	\N	\N	\N	\N	171342	171342	338576
22309	33616	14	applied	\N	\N	\N	\N	171343	171343	338577
22309	33617	15	applied	\N	\N	\N	\N	171344	171344	338578
22309	33623	16	applied	\N	\N	\N	\N	171345	171345	338579
22309	33624	17	applied	\N	\N	\N	\N	171346	171346	338580
22243	33500	3	applied	\N	\N	\N	\N	170793	170793	338030
22248	33514	0	applied	\N	\N	\N	\N	170824	170824	338061
22284	33054	44	applied	\N	\N	\N	\N	171018	171018	338254
22284	32545	46	applied	\N	\N	\N	\N	171019	171019	338255
22284	32546	47	applied	\N	\N	\N	\N	171020	171020	338256
22284	32551	48	applied	\N	\N	\N	\N	171021	171021	338257
22284	32552	49	applied	\N	\N	\N	\N	171022	171022	338258
22284	32559	50	applied	\N	\N	\N	\N	171023	171023	338259
22284	32560	51	applied	\N	\N	\N	\N	171024	171024	338260
22284	32563	52	applied	\N	\N	\N	\N	171025	171025	338261
22284	32564	53	applied	\N	\N	\N	\N	171026	171026	338262
22284	32565	54	applied	\N	\N	\N	\N	171027	171027	338263
22284	32572	55	applied	\N	\N	\N	\N	171028	171028	338264
22284	32574	56	applied	\N	\N	\N	\N	171029	171029	338265
22284	32575	57	applied	\N	\N	\N	\N	171030	171030	338266
22284	32580	58	applied	\N	\N	\N	\N	171031	171031	338267
22284	32926	59	applied	\N	\N	\N	\N	171032	171032	338268
22284	33609	60	applied	\N	\N	\N	\N	171033	171033	338269
22284	32586	62	applied	\N	\N	\N	\N	171035	171035	338271
22284	32589	63	applied	\N	\N	\N	\N	171036	171036	338272
22284	32592	64	applied	\N	\N	\N	\N	171037	171037	338273
22284	32593	65	applied	\N	\N	\N	\N	171038	171038	338274
22284	32598	66	applied	\N	\N	\N	\N	171039	171039	338275
22284	32599	67	applied	\N	\N	\N	\N	171040	171040	338276
22284	32600	68	applied	\N	\N	\N	\N	171041	171041	338277
22284	32607	69	applied	\N	\N	\N	\N	171042	171042	338278
22284	32610	70	applied	\N	\N	\N	\N	171043	171043	338279
22284	32613	71	applied	\N	\N	\N	\N	171044	171044	338280
22284	32614	72	applied	\N	\N	\N	\N	171045	171045	338281
22284	32615	73	applied	\N	\N	\N	\N	171046	171046	338282
22284	32622	74	applied	\N	\N	\N	\N	171047	171047	338283
22284	32625	75	applied	\N	\N	\N	\N	171048	171048	338284
22284	32628	76	applied	\N	\N	\N	\N	171049	171049	338285
22284	32631	77	applied	\N	\N	\N	\N	171050	171050	338286
22284	32637	79	applied	\N	\N	\N	\N	171052	171052	338288
22284	32640	80	applied	\N	\N	\N	\N	171053	171053	338289
22284	32641	81	applied	\N	\N	\N	\N	171054	171054	338290
22284	32646	82	applied	\N	\N	\N	\N	171055	171055	338291
22284	32649	83	applied	\N	\N	\N	\N	171056	171056	338292
22284	32652	84	applied	\N	\N	\N	\N	171057	171057	338293
22284	32653	85	applied	\N	\N	\N	\N	171058	171058	338294
22284	32658	86	applied	\N	\N	\N	\N	171059	171059	338295
22284	32659	87	applied	\N	\N	\N	\N	171060	171060	338296
22284	32664	88	applied	\N	\N	\N	\N	171061	171061	338297
22284	32667	89	applied	\N	\N	\N	\N	171062	171062	338298
22284	32670	90	applied	\N	\N	\N	\N	171063	171063	338299
22284	32673	91	applied	\N	\N	\N	\N	171064	171064	338300
22284	32676	92	applied	\N	\N	\N	\N	171065	171065	338301
22284	32681	93	applied	\N	\N	\N	\N	171066	171066	338302
22284	32682	94	applied	\N	\N	\N	\N	171067	171067	338303
22284	32688	96	applied	\N	\N	\N	\N	171069	171069	338305
22284	32689	97	applied	\N	\N	\N	\N	171070	171070	338306
22284	32694	98	applied	\N	\N	\N	\N	171071	171071	338307
22284	32697	99	applied	\N	\N	\N	\N	171072	171072	338308
22284	32700	100	applied	\N	\N	\N	\N	171073	171073	338309
22284	32703	101	applied	\N	\N	\N	\N	171074	171074	338310
22284	32704	102	applied	\N	\N	\N	\N	171075	171075	338311
22284	32709	103	applied	\N	\N	\N	\N	171076	171076	338312
22284	32712	104	applied	\N	\N	\N	\N	171077	171077	338313
22284	32715	105	applied	\N	\N	\N	\N	171078	171078	338314
22284	32719	106	applied	\N	\N	\N	\N	171079	171079	338315
22284	32720	107	applied	\N	\N	\N	\N	171080	171080	338316
22284	32725	108	applied	\N	\N	\N	\N	171081	171081	338317
22284	32726	109	applied	\N	\N	\N	\N	171082	171082	338318
22284	32731	110	applied	\N	\N	\N	\N	171083	171083	338319
22284	32732	111	applied	\N	\N	\N	\N	171084	171084	338320
22284	32738	113	applied	\N	\N	\N	\N	171086	171086	338322
22284	32739	114	applied	\N	\N	\N	\N	171087	171087	338323
22284	32740	115	applied	\N	\N	\N	\N	171088	171088	338324
22284	32741	116	applied	\N	\N	\N	\N	171089	171089	338325
22284	32742	117	applied	\N	\N	\N	\N	171090	171090	338326
22284	32743	118	applied	\N	\N	\N	\N	171091	171091	338327
22284	32758	119	applied	\N	\N	\N	\N	171092	171092	338328
22284	32761	120	applied	\N	\N	\N	\N	171093	171093	338329
22284	32764	121	applied	\N	\N	\N	\N	171094	171094	338330
22284	32765	122	applied	\N	\N	\N	\N	171095	171095	338331
22284	32769	123	applied	\N	\N	\N	\N	171096	171096	338332
22284	32771	124	applied	\N	\N	\N	\N	171097	171097	338333
22284	32774	125	applied	\N	\N	\N	\N	171098	171098	338334
22287	33613	0	applied	\N	\N	\N	\N	171105	171105	338341
22287	33614	1	applied	\N	\N	\N	\N	171106	171106	338342
22287	33615	2	applied	\N	\N	\N	\N	171107	171107	338343
22289	33617	1	applied	\N	\N	\N	\N	171112	171112	338348
22289	33618	2	applied	\N	\N	\N	\N	171113	171113	338349
22289	33619	4	applied	\N	\N	\N	\N	171114	171114	338350
22289	33620	5	applied	\N	\N	\N	\N	171115	171115	338351
22289	33621	6	applied	\N	\N	\N	\N	171116	171116	338352
22289	33622	7	applied	\N	\N	\N	\N	171117	171117	338353
22294	33630	0	applied	\N	\N	\N	\N	171139	171139	338375
22294	33631	1	applied	\N	\N	\N	\N	171140	171140	338376
22294	33632	2	applied	\N	\N	\N	\N	171141	171141	338377
22294	33633	3	applied	\N	\N	\N	\N	171142	171142	338378
22294	33634	4	applied	\N	\N	\N	\N	171143	171143	338379
22294	33635	5	applied	\N	\N	\N	\N	171144	171144	338380
22309	33630	18	applied	\N	\N	\N	\N	171347	171347	338581
22309	33631	19	applied	\N	\N	\N	\N	171348	171348	338582
22309	33636	20	applied	\N	\N	\N	\N	171349	171349	338583
22309	33639	21	applied	\N	\N	\N	\N	171350	171350	338584
22309	33641	23	applied	\N	\N	\N	\N	171352	171352	338586
22309	33642	24	applied	\N	\N	\N	\N	171353	171353	338587
22309	33653	25	applied	\N	\N	\N	\N	171354	171354	338588
22309	33656	26	applied	\N	\N	\N	\N	171355	171355	338589
22309	33659	27	applied	\N	\N	\N	\N	171356	171356	338590
22309	33660	28	applied	\N	\N	\N	\N	171357	171357	338591
22309	33661	29	applied	\N	\N	\N	\N	171358	171358	338592
22309	33670	30	applied	\N	\N	\N	\N	171359	171359	338593
22309	33571	31	applied	\N	\N	\N	\N	171360	171360	338594
22309	33572	32	applied	\N	\N	\N	\N	171361	171361	338595
22309	33573	33	applied	\N	\N	\N	\N	171362	171362	338596
22309	33574	34	applied	\N	\N	\N	\N	171363	171363	338597
22309	33578	35	applied	\N	\N	\N	\N	171364	171364	338598
22309	33582	36	applied	\N	\N	\N	\N	171365	171365	338599
22284	32536	41	applied	\N	\N	\N	\N	171015	171015	338251
22284	33035	42	applied	\N	\N	\N	\N	171016	171016	338252
22291	33618	2	applied	\N	\N	\N	\N	171127	171127	338363
22291	33619	4	applied	\N	\N	\N	\N	171128	171128	338364
22291	33620	5	applied	\N	\N	\N	\N	171129	171129	338365
22291	33621	6	applied	\N	\N	\N	\N	171130	171130	338366
22291	33622	7	applied	\N	\N	\N	\N	171131	171131	338367
22297	33636	0	applied	\N	\N	\N	\N	171274	171274	338508
22297	33637	1	applied	\N	\N	\N	\N	171275	171275	338509
22297	33638	2	applied	\N	\N	\N	\N	171276	171276	338510
22299	33639	0	applied	\N	\N	\N	\N	171280	171280	338514
22299	33640	1	applied	\N	\N	\N	\N	171281	171281	338515
22299	33641	2	applied	\N	\N	\N	\N	171282	171282	338516
22299	33642	3	applied	\N	\N	\N	\N	171283	171283	338517
22299	33643	4	applied	\N	\N	\N	\N	171284	171284	338518
22299	33644	5	applied	\N	\N	\N	\N	171285	171285	338519
22299	33645	6	applied	\N	\N	\N	\N	171286	171286	338520
22299	33646	7	applied	\N	\N	\N	\N	171287	171287	338521
22299	33648	9	applied	\N	\N	\N	\N	171289	171289	338523
22299	33649	10	applied	\N	\N	\N	\N	171290	171290	338524
22299	33650	11	applied	\N	\N	\N	\N	171291	171291	338525
22299	33651	12	applied	\N	\N	\N	\N	171292	171292	338526
22299	33652	13	applied	\N	\N	\N	\N	171293	171293	338527
22306	33670	0	applied	\N	\N	\N	\N	171320	171320	338554
22306	33671	1	applied	\N	\N	\N	\N	171321	171321	338555
22306	33672	2	applied	\N	\N	\N	\N	171322	171322	338556
22310	33673	0	applied	\N	\N	\N	\N	171432	171432	338666
22310	33674	1	applied	\N	\N	\N	\N	171433	171433	338667
22310	33675	2	applied	\N	\N	\N	\N	171434	171434	338668
22310	33676	3	applied	\N	\N	\N	\N	171435	171435	338669
22311	33677	0	applied	\N	\N	\N	\N	171436	171436	338670
22311	33678	1	applied	\N	\N	\N	\N	171437	171437	338671
22311	33679	2	applied	\N	\N	\N	\N	171438	171438	338672
22316	33687	0	applied	\N	\N	\N	\N	171450	171450	338684
22321	33707	0	applied	\N	\N	\N	\N	171500	171500	338734
22321	33708	1	applied	\N	\N	\N	\N	171501	171501	338735
22321	33709	2	applied	\N	\N	\N	\N	171502	171502	338736
22321	33710	3	applied	\N	\N	\N	\N	171503	171503	338737
22321	33711	4	applied	\N	\N	\N	\N	171504	171504	338738
22321	33712	5	applied	\N	\N	\N	\N	171505	171505	338739
22321	33713	6	applied	\N	\N	\N	\N	171506	171506	338740
22321	33714	8	applied	\N	\N	\N	\N	171507	171507	338741
22321	33715	9	applied	\N	\N	\N	\N	171508	171508	338742
22321	33716	10	applied	\N	\N	\N	\N	171509	171509	338743
22321	33717	11	applied	\N	\N	\N	\N	171510	171510	338744
22325	33718	0	applied	\N	\N	\N	\N	171530	171530	338764
22325	33719	1	applied	\N	\N	\N	\N	171531	171531	338765
22325	33720	2	applied	\N	\N	\N	\N	171532	171532	338766
22325	33721	3	applied	\N	\N	\N	\N	171533	171533	338767
22325	33722	4	applied	\N	\N	\N	\N	171534	171534	338768
22325	33724	6	applied	\N	\N	\N	\N	171536	171536	338770
22327	33718	0	applied	\N	\N	\N	\N	171544	171544	338778
22327	33719	1	applied	\N	\N	\N	\N	171545	171545	338779
22327	33720	2	applied	\N	\N	\N	\N	171546	171546	338780
22327	33721	3	applied	\N	\N	\N	\N	171547	171547	338781
22327	33722	4	applied	\N	\N	\N	\N	171548	171548	338782
22327	33723	5	applied	\N	\N	\N	\N	171549	171549	338783
22327	33724	6	applied	\N	\N	\N	\N	171550	171550	338784
22332	33729	0	applied	\N	\N	\N	\N	171565	171565	338799
22332	33730	1	applied	\N	\N	\N	\N	171566	171566	338800
22332	33731	2	applied	\N	\N	\N	\N	171567	171567	338801
22332	33732	3	applied	\N	\N	\N	\N	171568	171568	338802
22332	33733	4	applied	\N	\N	\N	\N	171569	171569	338803
22332	33734	5	applied	\N	\N	\N	\N	171570	171570	338804
22332	33735	6	applied	\N	\N	\N	\N	171571	171571	338805
22335	33745	0	applied	\N	\N	\N	\N	171593	171593	338827
22335	33747	2	applied	\N	\N	\N	\N	171595	171595	338829
22335	33748	3	applied	\N	\N	\N	\N	171596	171596	338830
22335	33749	4	applied	\N	\N	\N	\N	171597	171597	338831
22335	33750	5	applied	\N	\N	\N	\N	171598	171598	338832
22335	33751	6	applied	\N	\N	\N	\N	171599	171599	338833
22343	33772	0	applied	\N	\N	\N	\N	171640	171640	338874
22343	33773	1	applied	\N	\N	\N	\N	171641	171641	338875
22343	33774	2	applied	\N	\N	\N	\N	171642	171642	338876
22343	33775	3	applied	\N	\N	\N	\N	171643	171643	338877
22343	33769	4	applied	\N	\N	\N	\N	171644	171644	338878
22343	33770	5	applied	\N	\N	\N	\N	171645	171645	338879
22343	33771	6	applied	\N	\N	\N	\N	171646	171646	338880
22345	33778	0	applied	\N	\N	\N	\N	171656	171656	338890
22345	33779	1	applied	\N	\N	\N	\N	171657	171657	338891
22345	33776	2	applied	\N	\N	\N	\N	171658	171658	338892
22345	33777	3	applied	\N	\N	\N	\N	171659	171659	338893
22357	33794	0	applied	\N	\N	\N	\N	171762	171762	338996
22357	33795	1	applied	\N	\N	\N	\N	171763	171763	338997
22357	33796	2	applied	\N	\N	\N	\N	171764	171764	338998
22364	33813	0	applied	\N	\N	\N	\N	171792	171792	339026
22364	33814	1	applied	\N	\N	\N	\N	171793	171793	339027
22364	33815	2	applied	\N	\N	\N	\N	171794	171794	339028
22364	33816	3	applied	\N	\N	\N	\N	171795	171795	339029
22366	33817	0	applied	\N	\N	\N	\N	171800	171800	339034
22366	33818	1	applied	\N	\N	\N	\N	171801	171801	339035
22366	33819	2	applied	\N	\N	\N	\N	171802	171802	339036
22371	33827	0	applied	\N	\N	\N	\N	171831	171831	339065
22374	33838	0	applied	\N	\N	\N	\N	171842	171842	339076
22374	33839	1	applied	\N	\N	\N	\N	171843	171843	339077
22374	33840	2	applied	\N	\N	\N	\N	171844	171844	339078
22377	33848	0	applied	\N	\N	\N	\N	171859	171859	339093
22377	33849	1	applied	\N	\N	\N	\N	171860	171860	339094
22377	33851	3	applied	\N	\N	\N	\N	171862	171862	339096
22377	33852	4	applied	\N	\N	\N	\N	171863	171863	339097
22377	33853	5	applied	\N	\N	\N	\N	171864	171864	339098
22380	33858	0	applied	\N	\N	\N	\N	171872	171872	339106
22380	33859	1	applied	\N	\N	\N	\N	171873	171873	339107
22380	33860	2	applied	\N	\N	\N	\N	171874	171874	339108
22382	33862	0	applied	\N	\N	\N	\N	171879	171879	339113
22384	33869	0	applied	\N	\N	\N	\N	171884	171884	339118
22384	33870	1	applied	\N	\N	\N	\N	171885	171885	339119
22384	33871	2	applied	\N	\N	\N	\N	171886	171886	339120
22387	33872	0	applied	\N	\N	\N	\N	171893	171893	339127
22387	33873	1	applied	\N	\N	\N	\N	171894	171894	339128
22387	33874	2	applied	\N	\N	\N	\N	171895	171895	339129
22391	33875	0	applied	\N	\N	\N	\N	171983	171983	339217
22285	33612	2	applied	\N	\N	\N	\N	171101	171101	338337
22291	33616	0	applied	\N	\N	\N	\N	171125	171125	338361
22296	33544	78	applied	\N	\N	\N	\N	171226	171226	338462
22296	33547	79	applied	\N	\N	\N	\N	171227	171227	338463
22296	33552	80	applied	\N	\N	\N	\N	171228	171228	338464
22296	33553	81	applied	\N	\N	\N	\N	171229	171229	338465
22296	33554	82	applied	\N	\N	\N	\N	171230	171230	338466
22296	33563	83	applied	\N	\N	\N	\N	171231	171231	338467
22296	33566	84	applied	\N	\N	\N	\N	171232	171232	338468
22296	33569	85	applied	\N	\N	\N	\N	171233	171233	338469
22296	33570	86	applied	\N	\N	\N	\N	171234	171234	338470
22296	33577	87	applied	\N	\N	\N	\N	171235	171235	338471
22296	33580	88	applied	\N	\N	\N	\N	171236	171236	338472
22296	33581	89	applied	\N	\N	\N	\N	171237	171237	338473
22296	33588	90	applied	\N	\N	\N	\N	171238	171238	338474
22296	33609	91	applied	\N	\N	\N	\N	171239	171239	338475
22296	33591	92	applied	\N	\N	\N	\N	171240	171240	338476
22296	33592	93	applied	\N	\N	\N	\N	171241	171241	338477
22296	33600	95	applied	\N	\N	\N	\N	171243	171243	338479
22296	33605	96	applied	\N	\N	\N	\N	171244	171244	338480
22296	33610	97	applied	\N	\N	\N	\N	171245	171245	338481
22296	33613	98	applied	\N	\N	\N	\N	171246	171246	338482
22296	33616	99	applied	\N	\N	\N	\N	171247	171247	338483
22296	33617	100	applied	\N	\N	\N	\N	171248	171248	338484
22296	33623	101	applied	\N	\N	\N	\N	171249	171249	338485
22296	33624	102	applied	\N	\N	\N	\N	171250	171250	338486
22296	33630	103	applied	\N	\N	\N	\N	171251	171251	338487
22296	33631	104	applied	\N	\N	\N	\N	171252	171252	338488
22296	33387	105	applied	\N	\N	\N	\N	171253	171253	338489
22296	33388	106	applied	\N	\N	\N	\N	171254	171254	338490
22296	33389	107	applied	\N	\N	\N	\N	171255	171255	171255
22296	33303	108	applied	\N	\N	\N	\N	171256	171256	338491
22296	33356	109	applied	\N	\N	\N	\N	171257	171257	338492
22296	33304	110	applied	\N	\N	\N	\N	171258	171258	338493
22296	33305	112	applied	\N	\N	\N	\N	171260	171260	338495
22296	33313	113	applied	\N	\N	\N	\N	171261	171261	338496
22296	33377	114	applied	\N	\N	\N	\N	171262	171262	338497
22296	33384	115	applied	\N	\N	\N	\N	171263	171263	171263
22296	33308	116	applied	\N	\N	\N	\N	171264	171264	338498
22296	33311	117	applied	\N	\N	\N	\N	171265	171265	338499
22296	33312	118	applied	\N	\N	\N	\N	171266	171266	338500
22296	33317	119	applied	\N	\N	\N	\N	171267	171267	338501
22296	33321	120	applied	\N	\N	\N	\N	171268	171268	338502
22296	33323	121	applied	\N	\N	\N	\N	171269	171269	338503
22296	33324	122	applied	\N	\N	\N	\N	171270	171270	338504
22296	33338	123	applied	\N	\N	\N	\N	171271	171271	338505
22296	33347	124	applied	\N	\N	\N	\N	171272	171272	338506
22296	33357	125	applied	\N	\N	\N	\N	171273	171273	338507
22298	33636	0	applied	\N	\N	\N	\N	171277	171277	338511
22298	33637	1	applied	\N	\N	\N	\N	171278	171278	338512
22301	33653	0	applied	\N	\N	\N	\N	171297	171297	338531
22301	33654	1	applied	\N	\N	\N	\N	171298	171298	338532
22301	33655	2	applied	\N	\N	\N	\N	171299	171299	338533
22303	33656	0	applied	\N	\N	\N	\N	171303	171303	338537
22303	33657	1	applied	\N	\N	\N	\N	171304	171304	338538
22303	33658	2	applied	\N	\N	\N	\N	171305	171305	338539
22304	33659	0	applied	\N	\N	\N	\N	171306	171306	338540
22304	33660	1	applied	\N	\N	\N	\N	171307	171307	338541
22304	33661	2	applied	\N	\N	\N	\N	171308	171308	338542
22304	33662	3	applied	\N	\N	\N	\N	171309	171309	338543
22304	33663	4	applied	\N	\N	\N	\N	171310	171310	338544
22304	33664	5	applied	\N	\N	\N	\N	171311	171311	338545
22304	33665	6	applied	\N	\N	\N	\N	171312	171312	338546
22304	33666	7	applied	\N	\N	\N	\N	171313	171313	338547
22304	33667	8	applied	\N	\N	\N	\N	171314	171314	338548
22304	33668	9	applied	\N	\N	\N	\N	171315	171315	338549
22308	33670	0	applied	\N	\N	\N	\N	171326	171326	338560
22308	33671	1	applied	\N	\N	\N	\N	171327	171327	338561
22308	33672	2	applied	\N	\N	\N	\N	171328	171328	338562
22313	33683	0	applied	\N	\N	\N	\N	171442	171442	338676
22313	33684	1	applied	\N	\N	\N	\N	171443	171443	338677
22313	33685	2	applied	\N	\N	\N	\N	171444	171444	338678
22313	33686	3	applied	\N	\N	\N	\N	171445	171445	338679
22318	33695	0	applied	\N	\N	\N	\N	171466	171466	338700
22318	33696	1	applied	\N	\N	\N	\N	171467	171467	338701
22318	33697	2	applied	\N	\N	\N	\N	171468	171468	338702
22318	33698	3	applied	\N	\N	\N	\N	171469	171469	338703
22318	33699	4	applied	\N	\N	\N	\N	171470	171470	338704
22318	33700	5	applied	\N	\N	\N	\N	171471	171471	338705
22318	33701	6	applied	\N	\N	\N	\N	171472	171472	338706
22318	33702	7	applied	\N	\N	\N	\N	171473	171473	338707
22318	33703	8	applied	\N	\N	\N	\N	171474	171474	338708
22318	33705	10	applied	\N	\N	\N	\N	171476	171476	338710
22318	33706	11	applied	\N	\N	\N	\N	171477	171477	338711
22319	33707	0	applied	\N	\N	\N	\N	171478	171478	338712
22319	33708	1	applied	\N	\N	\N	\N	171479	171479	338713
22319	33709	2	applied	\N	\N	\N	\N	171480	171480	338714
22319	33710	3	applied	\N	\N	\N	\N	171481	171481	338715
22319	33711	4	applied	\N	\N	\N	\N	171482	171482	338716
22319	33712	5	applied	\N	\N	\N	\N	171483	171483	338717
22319	33713	6	applied	\N	\N	\N	\N	171484	171484	338718
22319	33714	8	applied	\N	\N	\N	\N	171485	171485	338719
22319	33715	9	applied	\N	\N	\N	\N	171486	171486	338720
22319	33716	10	applied	\N	\N	\N	\N	171487	171487	338721
22391	33876	1	applied	\N	\N	\N	\N	171984	171984	339218
22391	33877	2	applied	\N	\N	\N	\N	171985	171985	339219
22403	33898	0	applied	\N	\N	\N	\N	172035	172035	339269
22403	33899	1	applied	\N	\N	\N	\N	172036	172036	339270
22403	33901	3	applied	\N	\N	\N	\N	172038	172038	339272
22403	33902	4	applied	\N	\N	\N	\N	172039	172039	339273
22403	33903	5	applied	\N	\N	\N	\N	172040	172040	339274
22403	33904	6	applied	\N	\N	\N	\N	172041	172041	339275
22405	33905	0	applied	\N	\N	\N	\N	172068	172068	339302
22405	33906	1	applied	\N	\N	\N	\N	172069	172069	339303
22407	33907	0	applied	\N	\N	\N	\N	172072	172072	339306
22407	33908	1	applied	\N	\N	\N	\N	172073	172073	339307
22419	33930	0	applied	\N	\N	\N	\N	172134	172134	339368
22419	33931	1	applied	\N	\N	\N	\N	172135	172135	339369
22422	33932	0	applied	\N	\N	\N	\N	172145	172145	339379
22422	33933	1	applied	\N	\N	\N	\N	172146	172146	339380
22422	33934	2	applied	\N	\N	\N	\N	172147	172147	339381
22422	33935	3	applied	\N	\N	\N	\N	172148	172148	339382
22296	33534	75	applied	\N	\N	\N	\N	171223	171223	338459
22296	33537	76	applied	\N	\N	\N	\N	171224	171224	338460
22309	33587	41	applied	\N	\N	\N	\N	171370	171370	338604
22309	33594	42	applied	\N	\N	\N	\N	171371	171371	338605
22309	33606	43	applied	\N	\N	\N	\N	171372	171372	338606
22309	33621	44	applied	\N	\N	\N	\N	171373	171373	338607
22309	33629	45	applied	\N	\N	\N	\N	171374	171374	338608
22309	33643	46	applied	\N	\N	\N	\N	171375	171375	338609
22309	33644	47	applied	\N	\N	\N	\N	171376	171376	338610
22309	33667	48	applied	\N	\N	\N	\N	171377	171377	338611
22309	33590	49	applied	\N	\N	\N	\N	171378	171378	338612
22309	33595	50	applied	\N	\N	\N	\N	171379	171379	338613
22309	33596	51	applied	\N	\N	\N	\N	171380	171380	338614
22309	33599	52	applied	\N	\N	\N	\N	171381	171381	338615
22309	33601	53	applied	\N	\N	\N	\N	171382	171382	338616
22309	33603	54	applied	\N	\N	\N	\N	171383	171383	338617
22309	33607	55	applied	\N	\N	\N	\N	171384	171384	338618
22309	33612	56	applied	\N	\N	\N	\N	171385	171385	338619
22309	33618	58	applied	\N	\N	\N	\N	171387	171387	338621
22309	33619	59	applied	\N	\N	\N	\N	171388	171388	338622
22309	33627	60	applied	\N	\N	\N	\N	171389	171389	338623
22309	33628	61	applied	\N	\N	\N	\N	171390	171390	338624
22309	33632	62	applied	\N	\N	\N	\N	171391	171391	338625
22309	33633	63	applied	\N	\N	\N	\N	171392	171392	338626
22309	33637	64	applied	\N	\N	\N	\N	171393	171393	338627
22309	33645	65	applied	\N	\N	\N	\N	171394	171394	338628
22309	33646	66	applied	\N	\N	\N	\N	171395	171395	338629
22309	33647	67	applied	\N	\N	\N	\N	171396	171396	338630
22309	33648	68	applied	\N	\N	\N	\N	171397	171397	338631
22309	33654	69	applied	\N	\N	\N	\N	171398	171398	338632
22309	33657	70	applied	\N	\N	\N	\N	171399	171399	338633
22309	33664	72	applied	\N	\N	\N	\N	171400	171400	338634
22309	33668	73	applied	\N	\N	\N	\N	171401	171401	338635
22309	33669	74	applied	\N	\N	\N	\N	171402	171402	338636
22309	33579	76	applied	\N	\N	\N	\N	171404	171404	338638
22309	33584	77	applied	\N	\N	\N	\N	171405	171405	338639
22309	33585	78	applied	\N	\N	\N	\N	171406	171406	338640
22309	33589	79	applied	\N	\N	\N	\N	171407	171407	338641
22309	33593	80	applied	\N	\N	\N	\N	171408	171408	338642
22309	33598	81	applied	\N	\N	\N	\N	171409	171409	338643
22309	33602	82	applied	\N	\N	\N	\N	171410	171410	338644
22309	33604	83	applied	\N	\N	\N	\N	171411	171411	338645
22309	33608	84	applied	\N	\N	\N	\N	171412	171412	338646
22309	33611	85	applied	\N	\N	\N	\N	171413	171413	338647
22309	33614	86	applied	\N	\N	\N	\N	171414	171414	338648
22309	33620	87	applied	\N	\N	\N	\N	171415	171415	338649
22309	33622	88	applied	\N	\N	\N	\N	171416	171416	338650
22309	33625	89	applied	\N	\N	\N	\N	171417	171417	338651
22309	33626	90	applied	\N	\N	\N	\N	171418	171418	338652
22309	33634	91	applied	\N	\N	\N	\N	171419	171419	338653
22309	33638	93	applied	\N	\N	\N	\N	171421	171421	338655
22309	33649	94	applied	\N	\N	\N	\N	171422	171422	338656
22309	33650	95	applied	\N	\N	\N	\N	171423	171423	338657
22309	33651	96	applied	\N	\N	\N	\N	171424	171424	338658
22309	33652	97	applied	\N	\N	\N	\N	171425	171425	338659
22309	33655	98	applied	\N	\N	\N	\N	171426	171426	338660
22309	33658	99	applied	\N	\N	\N	\N	171427	171427	338661
22309	33663	100	applied	\N	\N	\N	\N	171428	171428	338662
22309	33665	101	applied	\N	\N	\N	\N	171429	171429	338663
22309	33666	102	applied	\N	\N	\N	\N	171430	171430	338664
22309	33672	103	applied	\N	\N	\N	\N	171431	171431	338665
22312	33680	0	applied	\N	\N	\N	\N	171439	171439	338673
22312	33681	1	applied	\N	\N	\N	\N	171440	171440	338674
22312	33682	2	applied	\N	\N	\N	\N	171441	171441	338675
22314	33683	0	applied	\N	\N	\N	\N	171446	171446	338680
22314	33684	1	applied	\N	\N	\N	\N	171447	171447	338681
22314	33686	3	applied	\N	\N	\N	\N	171449	171449	338683
22317	33687	0	applied	\N	\N	\N	\N	171458	171458	338692
22317	33688	1	applied	\N	\N	\N	\N	171459	171459	338693
22317	33689	2	applied	\N	\N	\N	\N	171460	171460	338694
22317	33690	3	applied	\N	\N	\N	\N	171461	171461	338695
22317	33691	4	applied	\N	\N	\N	\N	171462	171462	338696
22317	33692	5	applied	\N	\N	\N	\N	171463	171463	338697
22317	33693	6	applied	\N	\N	\N	\N	171464	171464	338698
22317	33694	7	applied	\N	\N	\N	\N	171465	171465	338699
22319	33717	11	applied	\N	\N	\N	\N	171488	171488	338722
22320	33707	0	applied	\N	\N	\N	\N	171489	171489	338723
22320	33708	1	applied	\N	\N	\N	\N	171490	171490	338724
22320	33709	2	applied	\N	\N	\N	\N	171491	171491	338725
22320	33710	3	applied	\N	\N	\N	\N	171492	171492	338726
22320	33711	4	applied	\N	\N	\N	\N	171493	171493	338727
22320	33712	5	applied	\N	\N	\N	\N	171494	171494	338728
22320	33714	8	applied	\N	\N	\N	\N	171496	171496	338730
22320	33715	9	applied	\N	\N	\N	\N	171497	171497	338731
22320	33716	10	applied	\N	\N	\N	\N	171498	171498	338732
22320	33717	11	applied	\N	\N	\N	\N	171499	171499	338733
22323	33718	0	applied	\N	\N	\N	\N	171518	171518	338752
22323	33719	1	applied	\N	\N	\N	\N	171519	171519	338753
22323	33720	2	applied	\N	\N	\N	\N	171520	171520	338754
22323	33721	3	applied	\N	\N	\N	\N	171521	171521	338755
22323	33724	4	applied	\N	\N	\N	\N	171522	171522	338756
22324	33718	0	applied	\N	\N	\N	\N	171523	171523	338757
22324	33719	1	applied	\N	\N	\N	\N	171524	171524	338758
22324	33720	2	applied	\N	\N	\N	\N	171525	171525	338759
22324	33721	3	applied	\N	\N	\N	\N	171526	171526	338760
22324	33722	4	applied	\N	\N	\N	\N	171527	171527	338761
22324	33723	5	applied	\N	\N	\N	\N	171528	171528	338762
22324	33724	6	applied	\N	\N	\N	\N	171529	171529	338763
22326	33719	1	applied	\N	\N	\N	\N	171538	171538	338772
22326	33720	2	applied	\N	\N	\N	\N	171539	171539	338773
22326	33721	3	applied	\N	\N	\N	\N	171540	171540	338774
22326	33722	4	applied	\N	\N	\N	\N	171541	171541	338775
22326	33723	5	applied	\N	\N	\N	\N	171542	171542	338776
22326	33724	6	applied	\N	\N	\N	\N	171543	171543	338777
22329	33725	0	applied	\N	\N	\N	\N	171554	171554	338788
22329	33726	1	applied	\N	\N	\N	\N	171555	171555	338789
22329	33727	2	applied	\N	\N	\N	\N	171556	171556	338790
22330	33725	0	applied	\N	\N	\N	\N	171557	171557	338791
22330	33726	1	applied	\N	\N	\N	\N	171558	171558	338792
22330	33722	2	applied	\N	\N	\N	\N	171559	171559	338793
22330	33723	3	applied	\N	\N	\N	\N	171560	171560	338794
22331	33722	0	applied	\N	\N	\N	\N	171563	171563	338797
22309	33575	38	applied	\N	\N	\N	\N	171367	171367	338601
22309	33586	39	applied	\N	\N	\N	\N	171368	171368	338602
22316	33693	6	applied	\N	\N	\N	\N	171456	171456	338690
22316	33694	7	applied	\N	\N	\N	\N	171457	171457	338691
22322	33718	0	applied	\N	\N	\N	\N	171511	171511	338745
22322	33719	1	applied	\N	\N	\N	\N	171512	171512	338746
22322	33720	2	applied	\N	\N	\N	\N	171513	171513	338747
22322	33721	3	applied	\N	\N	\N	\N	171514	171514	338748
22322	33722	4	applied	\N	\N	\N	\N	171515	171515	338749
22322	33723	5	applied	\N	\N	\N	\N	171516	171516	338750
22322	33724	6	applied	\N	\N	\N	\N	171517	171517	338751
22328	33725	0	applied	\N	\N	\N	\N	171551	171551	338785
22328	33726	1	applied	\N	\N	\N	\N	171552	171552	338786
22328	33727	2	applied	\N	\N	\N	\N	171553	171553	338787
22331	33723	1	applied	\N	\N	\N	\N	171564	171564	338798
22333	33729	0	applied	\N	\N	\N	\N	171572	171572	338806
22333	33730	1	applied	\N	\N	\N	\N	171573	171573	338807
22333	33731	2	applied	\N	\N	\N	\N	171574	171574	338808
22333	33732	4	applied	\N	\N	\N	\N	171576	171576	338810
22333	33736	5	applied	\N	\N	\N	\N	171577	171577	338811
22333	33737	6	applied	\N	\N	\N	\N	171578	171578	338812
22333	33738	7	applied	\N	\N	\N	\N	171579	171579	338813
22333	33733	8	applied	\N	\N	\N	\N	171580	171580	338814
22333	33734	9	applied	\N	\N	\N	\N	171581	171581	338815
22333	33735	10	applied	\N	\N	\N	\N	171582	171582	338816
22334	33739	0	applied	\N	\N	\N	\N	171583	171583	338817
22334	33740	1	applied	\N	\N	\N	\N	171584	171584	338818
22334	33728	2	applied	\N	\N	\N	\N	171585	171585	338819
22334	33741	3	applied	\N	\N	\N	\N	171586	171586	338820
22334	33742	4	applied	\N	\N	\N	\N	171587	171587	338821
22334	33736	5	applied	\N	\N	\N	\N	171588	171588	338822
22334	33737	6	applied	\N	\N	\N	\N	171589	171589	338823
22334	33738	7	applied	\N	\N	\N	\N	171590	171590	338824
22334	33743	8	applied	\N	\N	\N	\N	171591	171591	338825
22336	33752	0	applied	\N	\N	\N	\N	171600	171600	338834
22336	33753	1	applied	\N	\N	\N	\N	171601	171601	338835
22336	33754	2	applied	\N	\N	\N	\N	171602	171602	338836
22337	33752	0	applied	\N	\N	\N	\N	171603	171603	338837
22337	33753	1	applied	\N	\N	\N	\N	171604	171604	338838
22337	33754	2	applied	\N	\N	\N	\N	171605	171605	338839
22339	33758	0	applied	\N	\N	\N	\N	171609	171609	338843
22339	33759	1	applied	\N	\N	\N	\N	171610	171610	338844
22339	33760	2	applied	\N	\N	\N	\N	171611	171611	338845
22339	33761	3	applied	\N	\N	\N	\N	171612	171612	338846
22340	33762	0	applied	\N	\N	\N	\N	171613	171613	338847
22347	33781	0	applied	\N	\N	\N	\N	171665	171665	338899
22347	33782	1	applied	\N	\N	\N	\N	171666	171666	338900
22347	33783	2	applied	\N	\N	\N	\N	171667	171667	338901
22347	33784	3	applied	\N	\N	\N	\N	171668	171668	338902
22351	33787	0	applied	\N	\N	\N	\N	171739	171739	338973
22351	33789	2	applied	\N	\N	\N	\N	171741	171741	338975
22353	33790	0	applied	\N	\N	\N	\N	171742	171742	338976
22353	33791	1	applied	\N	\N	\N	\N	171743	171743	338977
22353	33792	2	applied	\N	\N	\N	\N	171744	171744	338978
22353	33793	3	applied	\N	\N	\N	\N	171745	171745	338979
22360	33800	0	applied	\N	\N	\N	\N	171771	171771	339005
22360	33801	1	applied	\N	\N	\N	\N	171772	171772	339006
22360	33802	3	applied	\N	\N	\N	\N	171773	171773	339007
22360	33803	4	applied	\N	\N	\N	\N	171774	171774	339008
22368	33820	0	applied	\N	\N	\N	\N	171810	171810	339044
22368	33821	1	applied	\N	\N	\N	\N	171811	171811	339045
22368	33822	2	applied	\N	\N	\N	\N	171812	171812	339046
22368	33823	3	applied	\N	\N	\N	\N	171813	171813	339047
22368	33824	4	applied	\N	\N	\N	\N	171814	171814	339048
22368	33825	5	applied	\N	\N	\N	\N	171815	171815	339049
22368	33826	6	applied	\N	\N	\N	\N	171816	171816	339050
22372	33829	1	applied	\N	\N	\N	\N	171833	171833	339067
22372	33830	2	applied	\N	\N	\N	\N	171834	171834	339068
22378	33854	0	applied	\N	\N	\N	\N	171865	171865	339099
22378	33855	1	applied	\N	\N	\N	\N	171866	171866	339100
22378	33856	2	applied	\N	\N	\N	\N	171867	171867	339101
22378	33857	3	applied	\N	\N	\N	\N	171868	171868	339102
22383	33865	0	applied	\N	\N	\N	\N	171880	171880	339114
22383	33866	1	applied	\N	\N	\N	\N	171881	171881	339115
22383	33867	2	applied	\N	\N	\N	\N	171882	171882	339116
22383	33868	3	applied	\N	\N	\N	\N	171883	171883	339117
22390	33875	0	applied	\N	\N	\N	\N	171980	171980	339214
22390	33876	1	applied	\N	\N	\N	\N	171981	171981	339215
22390	33877	2	applied	\N	\N	\N	\N	171982	171982	339216
22392	33878	0	applied	\N	\N	\N	\N	171986	171986	339220
22392	33879	1	applied	\N	\N	\N	\N	171987	171987	339221
22392	33880	2	applied	\N	\N	\N	\N	171988	171988	339222
22394	33882	0	applied	\N	\N	\N	\N	171994	171994	339228
22394	33883	1	applied	\N	\N	\N	\N	171995	171995	339229
22394	33884	2	applied	\N	\N	\N	\N	171996	171996	339230
22397	33892	0	applied	\N	\N	\N	\N	172004	172004	339238
22397	33893	1	applied	\N	\N	\N	\N	172005	172005	339239
22397	33894	2	applied	\N	\N	\N	\N	172006	172006	339240
22397	33895	3	applied	\N	\N	\N	\N	172007	172007	339241
22397	33896	4	applied	\N	\N	\N	\N	172008	172008	339242
22397	33897	5	applied	\N	\N	\N	\N	172009	172009	339243
22400	33892	0	applied	\N	\N	\N	\N	172016	172016	339250
22400	33893	1	applied	\N	\N	\N	\N	172017	172017	339251
22400	33894	2	applied	\N	\N	\N	\N	172018	172018	339252
22400	33895	3	applied	\N	\N	\N	\N	172019	172019	339253
22400	33896	4	applied	\N	\N	\N	\N	172020	172020	339254
22400	33897	5	applied	\N	\N	\N	\N	172021	172021	339255
22401	33892	0	applied	\N	\N	\N	\N	172022	172022	339256
22401	33894	2	applied	\N	\N	\N	\N	172024	172024	339258
22401	33895	3	applied	\N	\N	\N	\N	172025	172025	339259
22401	33896	4	applied	\N	\N	\N	\N	172026	172026	339260
22401	33897	5	applied	\N	\N	\N	\N	172027	172027	339261
22409	33907	0	applied	\N	\N	\N	\N	172077	172077	339311
22409	33909	1	applied	\N	\N	\N	\N	172078	172078	339312
22409	33908	2	applied	\N	\N	\N	\N	172079	172079	339313
22410	33907	0	applied	\N	\N	\N	\N	172080	172080	339314
22410	33909	1	applied	\N	\N	\N	\N	172081	172081	339315
22410	33908	2	applied	\N	\N	\N	\N	172082	172082	339316
22411	33910	0	applied	\N	\N	\N	\N	172083	172083	339317
22411	33911	1	applied	\N	\N	\N	\N	172084	172084	339318
22411	33912	2	applied	\N	\N	\N	\N	172085	172085	339319
22411	33913	3	applied	\N	\N	\N	\N	172086	172086	339320
22316	33690	3	applied	\N	\N	\N	\N	171453	171453	338687
22316	33691	4	applied	\N	\N	\N	\N	171454	171454	338688
22338	33757	2	applied	\N	\N	\N	\N	171608	171608	338842
22341	33762	0	applied	\N	\N	\N	\N	171623	171623	338857
22341	33763	1	applied	\N	\N	\N	\N	171624	171624	338858
22341	33764	2	applied	\N	\N	\N	\N	171625	171625	338859
22341	33765	3	applied	\N	\N	\N	\N	171626	171626	338860
22341	33766	4	applied	\N	\N	\N	\N	171627	171627	338861
22341	33767	5	applied	\N	\N	\N	\N	171628	171628	338862
22341	33768	6	applied	\N	\N	\N	\N	171629	171629	338863
22341	33769	7	applied	\N	\N	\N	\N	171630	171630	338864
22341	33770	8	applied	\N	\N	\N	\N	171631	171631	338865
22341	33771	9	applied	\N	\N	\N	\N	171632	171632	338866
22344	33772	0	applied	\N	\N	\N	\N	171647	171647	338881
22344	33773	1	applied	\N	\N	\N	\N	171648	171648	338882
22344	33774	2	applied	\N	\N	\N	\N	171649	171649	338883
22344	33775	3	applied	\N	\N	\N	\N	171650	171650	338884
22344	33769	4	applied	\N	\N	\N	\N	171651	171651	338885
22344	33771	6	applied	\N	\N	\N	\N	171653	171653	338887
22344	33776	7	applied	\N	\N	\N	\N	171654	171654	338888
22344	33777	8	applied	\N	\N	\N	\N	171655	171655	338889
22346	33781	0	applied	\N	\N	\N	\N	171661	171661	338895
22346	33782	1	applied	\N	\N	\N	\N	171662	171662	338896
22346	33783	2	applied	\N	\N	\N	\N	171663	171663	338897
22346	33784	3	applied	\N	\N	\N	\N	171664	171664	338898
22348	33781	0	applied	\N	\N	\N	\N	171669	171669	338903
22348	33782	1	applied	\N	\N	\N	\N	171670	171670	338904
22348	33783	2	applied	\N	\N	\N	\N	171671	171671	338905
22348	33784	3	applied	\N	\N	\N	\N	171672	171672	338906
22350	33725	0	applied	\N	\N	\N	\N	171675	171675	338909
22350	33729	1	applied	\N	\N	\N	\N	171676	171676	338910
22350	33730	2	applied	\N	\N	\N	\N	171677	171677	338911
22350	33731	3	applied	\N	\N	\N	\N	171678	171678	338912
22350	33739	4	applied	\N	\N	\N	\N	171679	171679	338913
22350	33745	6	applied	\N	\N	\N	\N	171681	171681	338915
22350	33746	7	applied	\N	\N	\N	\N	171682	171682	338916
22350	33752	8	applied	\N	\N	\N	\N	171683	171683	338917
22350	33755	9	applied	\N	\N	\N	\N	171684	171684	338918
22350	33758	10	applied	\N	\N	\N	\N	171685	171685	338919
22350	33762	11	applied	\N	\N	\N	\N	171686	171686	338920
22350	33763	12	applied	\N	\N	\N	\N	171687	171687	338921
22350	33764	13	applied	\N	\N	\N	\N	171688	171688	338922
22350	33772	14	applied	\N	\N	\N	\N	171689	171689	338923
22350	33773	15	applied	\N	\N	\N	\N	171690	171690	338924
22350	33778	16	applied	\N	\N	\N	\N	171691	171691	338925
22350	33781	17	applied	\N	\N	\N	\N	171692	171692	338926
22350	33785	18	applied	\N	\N	\N	\N	171693	171693	338927
22350	33726	19	applied	\N	\N	\N	\N	171694	171694	338928
22350	33732	20	applied	\N	\N	\N	\N	171695	171695	338929
22350	33722	21	applied	\N	\N	\N	\N	171696	171696	338930
22350	33728	23	applied	\N	\N	\N	\N	171698	171698	338932
22350	33736	24	applied	\N	\N	\N	\N	171699	171699	338933
22350	33737	25	applied	\N	\N	\N	\N	171700	171700	338934
22350	33738	26	applied	\N	\N	\N	\N	171701	171701	338935
22350	33743	27	applied	\N	\N	\N	\N	171702	171702	338936
22350	33744	28	applied	\N	\N	\N	\N	171703	171703	338937
22350	33747	29	applied	\N	\N	\N	\N	171704	171704	338938
22350	33748	30	applied	\N	\N	\N	\N	171705	171705	338939
22350	33754	31	applied	\N	\N	\N	\N	171706	171706	338940
22350	33756	32	applied	\N	\N	\N	\N	171707	171707	338941
22350	33759	33	applied	\N	\N	\N	\N	171708	171708	338942
22350	33727	34	applied	\N	\N	\N	\N	171709	171709	338943
22350	33733	35	applied	\N	\N	\N	\N	171710	171710	338944
22350	33749	36	applied	\N	\N	\N	\N	171711	171711	338945
22350	33760	37	applied	\N	\N	\N	\N	171712	171712	338946
22350	33766	38	applied	\N	\N	\N	\N	171713	171713	338947
22350	33769	40	applied	\N	\N	\N	\N	171715	171715	338949
22350	33770	41	applied	\N	\N	\N	\N	171716	171716	338950
22350	33771	42	applied	\N	\N	\N	\N	171717	171717	338951
22350	33776	43	applied	\N	\N	\N	\N	171718	171718	338952
22350	33777	44	applied	\N	\N	\N	\N	171719	171719	338953
22350	33780	45	applied	\N	\N	\N	\N	171720	171720	338954
22350	33784	46	applied	\N	\N	\N	\N	171721	171721	338955
22350	33734	47	applied	\N	\N	\N	\N	171722	171722	338956
22350	33735	48	applied	\N	\N	\N	\N	171723	171723	338957
22350	33741	49	applied	\N	\N	\N	\N	171724	171724	338958
22350	33742	50	applied	\N	\N	\N	\N	171725	171725	338959
22350	33750	51	applied	\N	\N	\N	\N	171726	171726	338960
22350	33751	52	applied	\N	\N	\N	\N	171727	171727	338961
22350	33753	53	applied	\N	\N	\N	\N	171728	171728	338962
22350	33757	54	applied	\N	\N	\N	\N	171729	171729	338963
22350	33761	55	applied	\N	\N	\N	\N	171730	171730	338964
22350	33767	57	applied	\N	\N	\N	\N	171732	171732	338966
22350	33768	58	applied	\N	\N	\N	\N	171733	171733	338967
22350	33774	59	applied	\N	\N	\N	\N	171734	171734	338968
22350	33775	60	applied	\N	\N	\N	\N	171735	171735	338969
22350	33779	61	applied	\N	\N	\N	\N	171736	171736	338970
22350	33782	62	applied	\N	\N	\N	\N	171737	171737	338971
22350	33786	63	applied	\N	\N	\N	\N	171738	171738	338972
22355	33794	0	applied	\N	\N	\N	\N	171756	171756	338990
22355	33795	1	applied	\N	\N	\N	\N	171757	171757	338991
22355	33796	2	applied	\N	\N	\N	\N	171758	171758	338992
22358	33794	0	applied	\N	\N	\N	\N	171765	171765	338999
22358	33795	1	applied	\N	\N	\N	\N	171766	171766	339000
22411	33914	4	applied	\N	\N	\N	\N	172087	172087	339321
22411	33915	5	applied	\N	\N	\N	\N	172088	172088	339322
22411	33916	6	applied	\N	\N	\N	\N	172089	172089	339323
22411	33917	7	applied	\N	\N	\N	\N	172090	172090	339324
22411	33919	9	applied	\N	\N	\N	\N	172092	172092	339326
22413	33920	0	applied	\N	\N	\N	\N	172103	172103	339337
22413	33921	1	applied	\N	\N	\N	\N	172104	172104	339338
22413	33922	2	applied	\N	\N	\N	\N	172105	172105	339339
22413	33923	3	applied	\N	\N	\N	\N	172106	172106	339340
22416	33927	0	applied	\N	\N	\N	\N	172112	172112	339346
22416	33929	1	applied	\N	\N	\N	\N	172113	172113	339347
22416	33928	2	applied	\N	\N	\N	\N	172114	172114	339348
22418	33910	0	applied	\N	\N	\N	\N	172118	172118	339352
22418	33911	1	applied	\N	\N	\N	\N	172119	172119	339353
22418	33912	2	applied	\N	\N	\N	\N	172120	172120	339354
22418	33920	3	applied	\N	\N	\N	\N	172121	172121	339355
22418	33924	4	applied	\N	\N	\N	\N	172122	172122	339356
22418	33927	5	applied	\N	\N	\N	\N	172123	172123	339357
22330	33727	5	applied	\N	\N	\N	\N	171562	171562	338796
22338	33755	0	applied	\N	\N	\N	\N	171606	171606	338840
22340	33767	5	applied	\N	\N	\N	\N	171618	171618	338852
22340	33768	6	applied	\N	\N	\N	\N	171619	171619	338853
22340	33769	7	applied	\N	\N	\N	\N	171620	171620	338854
22340	33770	8	applied	\N	\N	\N	\N	171621	171621	338855
22340	33771	9	applied	\N	\N	\N	\N	171622	171622	338856
22342	33762	0	applied	\N	\N	\N	\N	171633	171633	338867
22342	33763	1	applied	\N	\N	\N	\N	171634	171634	338868
22342	33764	2	applied	\N	\N	\N	\N	171635	171635	338869
22342	33765	3	applied	\N	\N	\N	\N	171636	171636	338870
22342	33766	4	applied	\N	\N	\N	\N	171637	171637	338871
22342	33767	5	applied	\N	\N	\N	\N	171638	171638	338872
22342	33768	6	applied	\N	\N	\N	\N	171639	171639	338873
22349	33785	0	applied	\N	\N	\N	\N	171673	171673	338907
22349	33786	1	applied	\N	\N	\N	\N	171674	171674	338908
22354	33662	0	applied	\N	\N	\N	\N	171746	171746	338980
22354	33689	1	applied	\N	\N	\N	\N	171747	171747	338981
22354	33698	3	applied	\N	\N	\N	\N	171749	171749	338983
22354	33690	4	applied	\N	\N	\N	\N	171750	171750	338984
22354	33701	5	applied	\N	\N	\N	\N	171751	171751	338985
22354	33703	6	applied	\N	\N	\N	\N	171752	171752	338986
22354	33704	7	applied	\N	\N	\N	\N	171753	171753	338987
22354	33712	8	applied	\N	\N	\N	\N	171754	171754	338988
22354	33724	9	applied	\N	\N	\N	\N	171755	171755	338989
22356	33794	0	applied	\N	\N	\N	\N	171759	171759	338993
22356	33795	1	applied	\N	\N	\N	\N	171760	171760	338994
22356	33796	2	applied	\N	\N	\N	\N	171761	171761	338995
22358	33796	2	applied	\N	\N	\N	\N	171767	171767	339001
22359	33797	0	applied	\N	\N	\N	\N	171768	171768	339002
22359	33798	1	applied	\N	\N	\N	\N	171769	171769	339003
22359	33799	2	applied	\N	\N	\N	\N	171770	171770	339004
22361	33800	0	applied	\N	\N	\N	\N	171775	171775	339009
22361	33801	1	applied	\N	\N	\N	\N	171776	171776	339010
22361	33803	4	applied	\N	\N	\N	\N	171778	171778	339012
22362	33800	0	applied	\N	\N	\N	\N	171779	171779	339013
22362	33801	1	applied	\N	\N	\N	\N	171780	171780	339014
22362	33802	3	applied	\N	\N	\N	\N	171781	171781	339015
22362	33803	4	applied	\N	\N	\N	\N	171782	171782	339016
22363	33804	0	applied	\N	\N	\N	\N	171783	171783	339017
22363	33805	1	applied	\N	\N	\N	\N	171784	171784	339018
22363	33806	2	applied	\N	\N	\N	\N	171785	171785	339019
22363	33807	3	applied	\N	\N	\N	\N	171786	171786	339020
22363	33808	4	applied	\N	\N	\N	\N	171787	171787	339021
22363	33809	5	applied	\N	\N	\N	\N	171788	171788	339022
22363	33810	6	applied	\N	\N	\N	\N	171789	171789	339023
22363	33811	7	applied	\N	\N	\N	\N	171790	171790	339024
22363	33812	8	applied	\N	\N	\N	\N	171791	171791	339025
22365	33813	0	applied	\N	\N	\N	\N	171796	171796	339030
22365	33814	1	applied	\N	\N	\N	\N	171797	171797	339031
22365	33816	3	applied	\N	\N	\N	\N	171799	171799	339033
22367	33820	0	applied	\N	\N	\N	\N	171803	171803	339037
22367	33821	1	applied	\N	\N	\N	\N	171804	171804	339038
22367	33822	2	applied	\N	\N	\N	\N	171805	171805	339039
22367	33823	3	applied	\N	\N	\N	\N	171806	171806	339040
22367	33824	4	applied	\N	\N	\N	\N	171807	171807	339041
22367	33825	5	applied	\N	\N	\N	\N	171808	171808	339042
22367	33826	6	applied	\N	\N	\N	\N	171809	171809	339043
22369	33820	0	applied	\N	\N	\N	\N	171817	171817	339051
22369	33821	1	applied	\N	\N	\N	\N	171818	171818	339052
22369	33822	2	applied	\N	\N	\N	\N	171819	171819	339053
22369	33823	3	applied	\N	\N	\N	\N	171820	171820	339054
22369	33824	4	applied	\N	\N	\N	\N	171821	171821	339055
22369	33825	5	applied	\N	\N	\N	\N	171822	171822	339056
22369	33826	6	applied	\N	\N	\N	\N	171823	171823	339057
22373	33831	0	applied	\N	\N	\N	\N	171835	171835	339069
22373	33833	2	applied	\N	\N	\N	\N	171837	171837	339071
22373	33834	3	applied	\N	\N	\N	\N	171838	171838	339072
22373	33835	4	applied	\N	\N	\N	\N	171839	171839	339073
22373	33836	5	applied	\N	\N	\N	\N	171840	171840	339074
22373	33837	6	applied	\N	\N	\N	\N	171841	171841	339075
22376	33841	0	applied	\N	\N	\N	\N	171852	171852	339086
22376	33842	1	applied	\N	\N	\N	\N	171853	171853	339087
22376	33843	2	applied	\N	\N	\N	\N	171854	171854	339088
22376	33844	3	applied	\N	\N	\N	\N	171855	171855	339089
22376	33845	4	applied	\N	\N	\N	\N	171856	171856	339090
22376	33846	5	applied	\N	\N	\N	\N	171857	171857	339091
22376	33847	6	applied	\N	\N	\N	\N	171858	171858	339092
22379	33858	0	applied	\N	\N	\N	\N	171869	171869	339103
22379	33859	1	applied	\N	\N	\N	\N	171870	171870	339104
22379	33860	2	applied	\N	\N	\N	\N	171871	171871	339105
22381	33861	0	applied	\N	\N	\N	\N	171875	171875	339109
22381	33863	2	applied	\N	\N	\N	\N	171877	171877	339111
22381	33864	3	applied	\N	\N	\N	\N	171878	171878	339112
22386	33872	0	applied	\N	\N	\N	\N	171890	171890	339124
22386	33873	1	applied	\N	\N	\N	\N	171891	171891	339125
22386	33874	2	applied	\N	\N	\N	\N	171892	171892	339126
22388	33794	0	applied	\N	\N	\N	\N	171896	171896	339130
22388	33797	1	applied	\N	\N	\N	\N	171897	171897	339131
22388	33800	2	applied	\N	\N	\N	\N	171898	171898	339132
22388	33804	3	applied	\N	\N	\N	\N	171899	171899	339133
22388	33805	4	applied	\N	\N	\N	\N	171900	171900	339134
22388	33806	5	applied	\N	\N	\N	\N	171901	171901	339135
22388	33813	6	applied	\N	\N	\N	\N	171902	171902	339136
22388	33817	7	applied	\N	\N	\N	\N	171903	171903	339137
22388	33820	8	applied	\N	\N	\N	\N	171904	171904	339138
22388	33821	9	applied	\N	\N	\N	\N	171905	171905	339139
22388	33827	10	applied	\N	\N	\N	\N	171906	171906	339140
22388	33831	13	applied	\N	\N	\N	\N	171908	171908	339142
22388	33832	14	applied	\N	\N	\N	\N	171909	171909	339143
22388	33838	15	applied	\N	\N	\N	\N	171910	171910	339144
22388	33841	16	applied	\N	\N	\N	\N	171911	171911	339145
22388	33842	17	applied	\N	\N	\N	\N	171912	171912	339146
22388	33848	18	applied	\N	\N	\N	\N	171913	171913	339147
22388	33849	19	applied	\N	\N	\N	\N	171914	171914	339148
22388	33854	20	applied	\N	\N	\N	\N	171915	171915	339149
22388	33858	21	applied	\N	\N	\N	\N	171916	171916	339150
22388	33861	22	applied	\N	\N	\N	\N	171917	171917	339151
22388	33865	23	applied	\N	\N	\N	\N	171918	171918	339152
22388	33869	24	applied	\N	\N	\N	\N	171919	171919	339153
22388	33872	25	applied	\N	\N	\N	\N	171920	171920	339154
22388	33795	26	applied	\N	\N	\N	\N	171921	171921	339155
22340	33764	2	applied	\N	\N	\N	\N	171615	171615	338849
22340	33765	3	applied	\N	\N	\N	\N	171616	171616	338850
22370	33824	4	applied	\N	\N	\N	\N	171828	171828	339062
22370	33825	5	applied	\N	\N	\N	\N	171829	171829	339063
22370	33826	6	applied	\N	\N	\N	\N	171830	171830	339064
22375	33841	0	applied	\N	\N	\N	\N	171845	171845	339079
22375	33842	1	applied	\N	\N	\N	\N	171846	171846	339080
22375	33843	2	applied	\N	\N	\N	\N	171847	171847	339081
22375	33844	3	applied	\N	\N	\N	\N	171848	171848	339082
22375	33845	4	applied	\N	\N	\N	\N	171849	171849	339083
22375	33846	5	applied	\N	\N	\N	\N	171850	171850	339084
22375	33847	6	applied	\N	\N	\N	\N	171851	171851	339085
22385	33872	0	applied	\N	\N	\N	\N	171887	171887	339121
22385	33873	1	applied	\N	\N	\N	\N	171888	171888	339122
22385	33874	2	applied	\N	\N	\N	\N	171889	171889	339123
22388	33862	27	applied	\N	\N	\N	\N	171922	171922	339156
22388	33798	28	applied	\N	\N	\N	\N	171923	171923	339157
22388	33801	29	applied	\N	\N	\N	\N	171924	171924	339158
22388	33808	31	applied	\N	\N	\N	\N	171926	171926	339160
22388	33802	32	applied	\N	\N	\N	\N	171927	171927	339161
22388	33809	33	applied	\N	\N	\N	\N	171928	171928	339162
22388	33815	34	applied	\N	\N	\N	\N	171929	171929	339163
22388	33816	35	applied	\N	\N	\N	\N	171930	171930	339164
22388	33819	36	applied	\N	\N	\N	\N	171931	171931	339165
22388	33822	37	applied	\N	\N	\N	\N	171932	171932	339166
22388	33823	38	applied	\N	\N	\N	\N	171933	171933	339167
22388	33834	39	applied	\N	\N	\N	\N	171934	171934	339168
22388	33824	40	applied	\N	\N	\N	\N	171935	171935	339169
22388	33830	41	applied	\N	\N	\N	\N	171936	171936	339170
22388	33835	42	applied	\N	\N	\N	\N	171937	171937	339171
22388	33836	43	applied	\N	\N	\N	\N	171938	171938	339172
22388	33796	44	applied	\N	\N	\N	\N	171939	171939	339173
22388	33799	45	applied	\N	\N	\N	\N	171940	171940	339174
22389	33875	0	applied	\N	\N	\N	\N	171977	171977	339211
22389	33877	2	applied	\N	\N	\N	\N	171979	171979	339213
22396	33888	0	applied	\N	\N	\N	\N	172000	172000	339234
22396	33889	1	applied	\N	\N	\N	\N	172001	172001	339235
22396	33890	2	applied	\N	\N	\N	\N	172002	172002	339236
22396	33891	3	applied	\N	\N	\N	\N	172003	172003	339237
22406	33905	0	applied	\N	\N	\N	\N	172070	172070	339304
22406	33906	1	applied	\N	\N	\N	\N	172071	172071	339305
22408	33907	0	applied	\N	\N	\N	\N	172074	172074	339308
22408	33909	1	applied	\N	\N	\N	\N	172075	172075	339309
22408	33908	2	applied	\N	\N	\N	\N	172076	172076	339310
22415	33927	0	applied	\N	\N	\N	\N	172110	172110	339344
22415	33928	1	applied	\N	\N	\N	\N	172111	172111	339345
22417	33927	0	applied	\N	\N	\N	\N	172115	172115	339349
22417	33929	1	applied	\N	\N	\N	\N	172116	172116	339350
22417	33928	2	applied	\N	\N	\N	\N	172117	172117	339351
22420	33930	0	applied	\N	\N	\N	\N	172136	172136	339370
22423	33932	0	applied	\N	\N	\N	\N	172150	172150	339384
22423	33933	1	applied	\N	\N	\N	\N	172151	172151	339385
22423	33934	2	applied	\N	\N	\N	\N	172152	172152	339386
22423	33935	3	applied	\N	\N	\N	\N	172153	172153	339387
22423	33936	4	applied	\N	\N	\N	\N	172154	172154	339388
22423	33937	5	applied	\N	\N	\N	\N	172155	172155	339389
22423	33938	6	applied	\N	\N	\N	\N	172156	172156	339390
22424	33932	0	applied	\N	\N	\N	\N	172157	172157	339391
22424	33933	1	applied	\N	\N	\N	\N	172158	172158	339392
22424	33934	2	applied	\N	\N	\N	\N	172159	172159	339393
22424	33935	3	applied	\N	\N	\N	\N	172160	172160	339394
22424	33936	4	applied	\N	\N	\N	\N	172161	172161	339395
22424	33937	5	applied	\N	\N	\N	\N	172162	172162	339396
22424	33938	6	applied	\N	\N	\N	\N	172163	172163	339397
22429	33946	0	applied	\N	\N	\N	\N	172174	172174	339408
22429	33947	1	applied	\N	\N	\N	\N	172175	172175	339409
22431	33952	0	applied	\N	\N	\N	\N	172180	172180	339414
22431	33953	1	applied	\N	\N	\N	\N	172181	172181	339415
22431	33954	2	applied	\N	\N	\N	\N	172182	172182	339416
22431	33955	3	applied	\N	\N	\N	\N	172183	172183	339417
22438	33963	0	applied	\N	\N	\N	\N	172336	172336	339570
22438	33964	1	applied	\N	\N	\N	\N	172337	172337	339571
22438	33965	2	applied	\N	\N	\N	\N	172338	172338	339572
22438	33966	3	applied	\N	\N	\N	\N	172339	172339	339573
22438	33967	4	applied	\N	\N	\N	\N	172340	172340	339574
22438	33968	5	applied	\N	\N	\N	\N	172341	172341	339575
22438	33969	6	applied	\N	\N	\N	\N	172342	172342	339576
22438	33970	7	applied	\N	\N	\N	\N	172343	172343	339577
22443	33971	0	applied	\N	\N	\N	\N	172453	172453	339687
22443	33972	1	applied	\N	\N	\N	\N	172454	172454	339688
22443	33973	2	applied	\N	\N	\N	\N	172455	172455	339689
22450	33981	0	applied	\N	\N	\N	\N	172476	172476	339710
22450	33983	2	applied	\N	\N	\N	\N	172478	172478	339712
22452	33990	0	applied	\N	\N	\N	\N	172485	172485	339719
22452	33991	1	applied	\N	\N	\N	\N	172486	172486	339720
22452	33992	2	applied	\N	\N	\N	\N	172487	172487	339721
22459	33996	0	applied	\N	\N	\N	\N	172508	172508	339742
22459	33997	1	applied	\N	\N	\N	\N	172509	172509	339743
22459	33998	2	applied	\N	\N	\N	\N	172510	172510	339744
22463	34006	0	applied	\N	\N	\N	\N	172521	172521	339755
22463	34007	1	applied	\N	\N	\N	\N	172522	172522	339756
22463	34008	2	applied	\N	\N	\N	\N	172523	172523	339757
22466	34009	0	applied	\N	\N	\N	\N	172531	172531	339765
22466	34010	1	applied	\N	\N	\N	\N	172532	172532	339766
22466	34011	2	applied	\N	\N	\N	\N	172533	172533	339767
22466	34012	3	applied	\N	\N	\N	\N	172534	172534	339768
22470	34013	0	applied	\N	\N	\N	\N	172665	172665	339899
22470	34014	1	applied	\N	\N	\N	\N	172666	172666	339900
22472	34016	0	applied	\N	\N	\N	\N	172675	172675	339909
22472	34017	1	applied	\N	\N	\N	\N	172676	172676	339910
22472	34018	2	applied	\N	\N	\N	\N	172677	172677	339911
22472	34019	3	applied	\N	\N	\N	\N	172678	172678	339912
22472	34020	4	applied	\N	\N	\N	\N	172679	172679	339913
22472	34021	5	applied	\N	\N	\N	\N	172680	172680	339914
22472	34022	6	applied	\N	\N	\N	\N	172681	172681	339915
22476	34036	0	applied	\N	\N	\N	\N	172701	172701	339935
22476	34037	1	applied	\N	\N	\N	\N	172702	172702	339936
22476	34038	2	applied	\N	\N	\N	\N	172703	172703	339937
22476	34039	3	applied	\N	\N	\N	\N	172704	172704	339938
22476	34040	4	applied	\N	\N	\N	\N	172705	172705	339939
22476	34041	5	applied	\N	\N	\N	\N	172706	172706	339940
22478	34042	0	applied	\N	\N	\N	\N	172715	172715	339949
22370	33821	1	applied	\N	\N	\N	\N	171825	171825	339059
22370	33822	2	applied	\N	\N	\N	\N	171826	171826	339060
22388	33814	50	applied	\N	\N	\N	\N	171945	171945	339179
22388	33818	51	applied	\N	\N	\N	\N	171946	171946	339180
22388	33840	52	applied	\N	\N	\N	\N	171947	171947	339181
22388	33843	53	applied	\N	\N	\N	\N	171948	171948	339182
22388	33844	54	applied	\N	\N	\N	\N	171949	171949	339183
22388	33855	55	applied	\N	\N	\N	\N	171950	171950	339184
22388	33866	56	applied	\N	\N	\N	\N	171951	171951	339185
22388	33825	57	applied	\N	\N	\N	\N	171952	171952	339186
22388	33826	58	applied	\N	\N	\N	\N	171953	171953	339187
22388	33829	59	applied	\N	\N	\N	\N	171954	171954	339188
22388	33833	60	applied	\N	\N	\N	\N	171955	171955	339189
22388	33845	61	applied	\N	\N	\N	\N	171956	171956	339190
22388	33850	62	applied	\N	\N	\N	\N	171957	171957	339191
22388	33853	63	applied	\N	\N	\N	\N	171958	171958	339192
22388	33856	64	applied	\N	\N	\N	\N	171959	171959	339193
22388	33860	65	applied	\N	\N	\N	\N	171960	171960	339194
22388	33868	67	applied	\N	\N	\N	\N	171962	171962	339196
22388	33871	68	applied	\N	\N	\N	\N	171963	171963	339197
22388	33873	69	applied	\N	\N	\N	\N	171964	171964	339198
22388	33837	70	applied	\N	\N	\N	\N	171965	171965	339199
22388	33839	71	applied	\N	\N	\N	\N	171966	171966	339200
22388	33846	72	applied	\N	\N	\N	\N	171967	171967	339201
22388	33847	73	applied	\N	\N	\N	\N	171968	171968	339202
22388	33851	74	applied	\N	\N	\N	\N	171969	171969	339203
22388	33852	75	applied	\N	\N	\N	\N	171970	171970	339204
22388	33857	76	applied	\N	\N	\N	\N	171971	171971	339205
22388	33859	77	applied	\N	\N	\N	\N	171972	171972	339206
22388	33863	78	applied	\N	\N	\N	\N	171973	171973	339207
22388	33867	79	applied	\N	\N	\N	\N	171974	171974	339208
22388	33870	80	applied	\N	\N	\N	\N	171975	171975	339209
22388	33874	81	applied	\N	\N	\N	\N	171976	171976	339210
22393	33878	0	applied	\N	\N	\N	\N	171990	171990	339224
22393	33880	2	applied	\N	\N	\N	\N	171992	171992	339226
22393	33881	3	applied	\N	\N	\N	\N	171993	171993	339227
22395	33885	0	applied	\N	\N	\N	\N	171997	171997	339231
22395	33886	1	applied	\N	\N	\N	\N	171998	171998	339232
22395	33887	2	applied	\N	\N	\N	\N	171999	171999	339233
22398	33892	0	applied	\N	\N	\N	\N	172010	172010	339244
22398	33893	1	applied	\N	\N	\N	\N	172011	172011	339245
22398	33894	2	applied	\N	\N	\N	\N	172012	172012	339246
22398	33895	3	applied	\N	\N	\N	\N	172013	172013	339247
22398	33896	4	applied	\N	\N	\N	\N	172014	172014	339248
22398	33897	5	applied	\N	\N	\N	\N	172015	172015	339249
22402	33898	0	applied	\N	\N	\N	\N	172028	172028	339262
22402	33899	1	applied	\N	\N	\N	\N	172029	172029	339263
22402	33900	2	applied	\N	\N	\N	\N	172030	172030	339264
22402	33901	3	applied	\N	\N	\N	\N	172031	172031	339265
22402	33902	4	applied	\N	\N	\N	\N	172032	172032	339266
22402	33904	6	applied	\N	\N	\N	\N	172034	172034	339268
22404	33875	0	applied	\N	\N	\N	\N	172042	172042	339276
22404	33878	1	applied	\N	\N	\N	\N	172043	172043	339277
22404	33882	2	applied	\N	\N	\N	\N	172044	172044	339278
22404	33885	3	applied	\N	\N	\N	\N	172045	172045	339279
22404	33888	4	applied	\N	\N	\N	\N	172046	172046	339280
22404	33892	5	applied	\N	\N	\N	\N	172047	172047	339281
22404	33893	6	applied	\N	\N	\N	\N	172048	172048	339282
22404	33898	7	applied	\N	\N	\N	\N	172049	172049	339283
22404	33879	8	applied	\N	\N	\N	\N	172050	172050	339284
22404	33876	9	applied	\N	\N	\N	\N	172051	172051	339285
22404	33880	10	applied	\N	\N	\N	\N	172052	172052	339286
22404	33877	11	applied	\N	\N	\N	\N	172053	172053	339287
22404	33881	12	applied	\N	\N	\N	\N	172054	172054	339288
22404	33883	13	applied	\N	\N	\N	\N	172055	172055	339289
22404	33886	14	applied	\N	\N	\N	\N	172056	172056	339290
22404	33894	16	applied	\N	\N	\N	\N	172058	172058	339292
22404	33895	17	applied	\N	\N	\N	\N	172059	172059	339293
22404	33900	18	applied	\N	\N	\N	\N	172060	172060	339294
22404	33884	19	applied	\N	\N	\N	\N	172061	172061	339295
22404	33887	20	applied	\N	\N	\N	\N	172062	172062	339296
22404	33889	21	applied	\N	\N	\N	\N	172063	172063	339297
22404	33896	22	applied	\N	\N	\N	\N	172064	172064	339298
22404	33891	23	applied	\N	\N	\N	\N	172065	172065	339299
22404	33897	24	applied	\N	\N	\N	\N	172066	172066	339300
22404	33902	25	applied	\N	\N	\N	\N	172067	172067	339301
22412	33910	0	applied	\N	\N	\N	\N	172093	172093	339327
22412	33911	1	applied	\N	\N	\N	\N	172094	172094	339328
22412	33912	2	applied	\N	\N	\N	\N	172095	172095	339329
22412	33913	3	applied	\N	\N	\N	\N	172096	172096	339330
22412	33914	4	applied	\N	\N	\N	\N	172097	172097	339331
22412	33915	5	applied	\N	\N	\N	\N	172098	172098	339332
22412	33917	7	applied	\N	\N	\N	\N	172100	172100	339334
22412	33918	8	applied	\N	\N	\N	\N	172101	172101	339335
22412	33919	9	applied	\N	\N	\N	\N	172102	172102	339336
22414	33924	0	applied	\N	\N	\N	\N	172107	172107	339341
22414	33925	1	applied	\N	\N	\N	\N	172108	172108	339342
22414	33926	2	applied	\N	\N	\N	\N	172109	172109	339343
22421	33932	0	applied	\N	\N	\N	\N	172138	172138	339372
22421	33933	1	applied	\N	\N	\N	\N	172139	172139	339373
22421	33934	2	applied	\N	\N	\N	\N	172140	172140	339374
22421	33935	3	applied	\N	\N	\N	\N	172141	172141	339375
22421	33936	4	applied	\N	\N	\N	\N	172142	172142	339376
22421	33937	5	applied	\N	\N	\N	\N	172143	172143	339377
22478	34043	1	applied	\N	\N	\N	\N	172716	172716	339950
22478	34044	2	applied	\N	\N	\N	\N	172717	172717	339951
22478	34045	3	applied	\N	\N	\N	\N	172718	172718	339952
22478	34046	4	applied	\N	\N	\N	\N	172719	172719	339953
22478	34048	6	applied	\N	\N	\N	\N	172721	172721	339955
22478	34050	7	applied	\N	\N	\N	\N	172722	172722	339956
22478	34049	8	applied	\N	\N	\N	\N	172723	172723	339957
22480	34051	0	applied	\N	\N	\N	\N	172733	172733	339967
22480	34052	1	applied	\N	\N	\N	\N	172734	172734	339968
22480	34053	2	applied	\N	\N	\N	\N	172735	172735	339969
22480	34054	3	applied	\N	\N	\N	\N	172736	172736	339970
22480	34055	4	applied	\N	\N	\N	\N	172737	172737	339971
22480	34056	5	applied	\N	\N	\N	\N	172738	172738	339972
22480	34057	6	applied	\N	\N	\N	\N	172739	172739	339973
22480	34058	7	applied	\N	\N	\N	\N	172740	172740	339974
22490	34114	0	applied	\N	\N	\N	\N	172839	172839	340073
22490	34115	1	applied	\N	\N	\N	\N	172840	172840	340074
22490	34116	2	applied	\N	\N	\N	\N	172841	172841	340075
22388	33810	47	applied	\N	\N	\N	\N	171942	171942	339176
22388	33811	48	applied	\N	\N	\N	\N	171943	171943	339177
22418	33917	10	applied	\N	\N	\N	\N	172128	172128	339362
22418	33918	11	applied	\N	\N	\N	\N	172129	172129	339363
22418	33919	12	applied	\N	\N	\N	\N	172130	172130	339364
22418	33922	13	applied	\N	\N	\N	\N	172131	172131	339365
22418	33925	14	applied	\N	\N	\N	\N	172132	172132	339366
22418	33928	15	applied	\N	\N	\N	\N	172133	172133	339367
22421	33938	6	applied	\N	\N	\N	\N	172144	172144	339378
22428	33946	0	applied	\N	\N	\N	\N	172171	172171	339405
22428	33947	1	applied	\N	\N	\N	\N	172172	172172	339406
22428	33948	2	applied	\N	\N	\N	\N	172173	172173	339407
22430	33949	0	applied	\N	\N	\N	\N	172177	172177	339411
22430	33950	1	applied	\N	\N	\N	\N	172178	172178	339412
22430	33951	2	applied	\N	\N	\N	\N	172179	172179	339413
22432	33956	0	applied	\N	\N	\N	\N	172184	172184	339418
22432	33957	1	applied	\N	\N	\N	\N	172185	172185	339419
22432	33958	2	applied	\N	\N	\N	\N	172186	172186	339420
22433	33956	0	applied	\N	\N	\N	\N	172188	172188	339422
22433	33957	1	applied	\N	\N	\N	\N	172189	172189	339423
22433	33958	2	applied	\N	\N	\N	\N	172190	172190	339424
22433	33959	3	applied	\N	\N	\N	\N	172191	172191	339425
22436	33960	0	applied	\N	\N	\N	\N	172208	172208	339442
22436	33961	1	applied	\N	\N	\N	\N	172209	172209	339443
22436	33962	2	applied	\N	\N	\N	\N	172210	172210	339444
22439	33963	0	applied	\N	\N	\N	\N	172344	172344	339578
22439	33964	1	applied	\N	\N	\N	\N	172345	172345	339579
22439	33965	2	applied	\N	\N	\N	\N	172346	172346	339580
22439	33966	3	applied	\N	\N	\N	\N	172347	172347	339581
22439	33967	4	applied	\N	\N	\N	\N	172348	172348	339582
22439	33968	5	applied	\N	\N	\N	\N	172349	172349	339583
22439	33969	6	applied	\N	\N	\N	\N	172350	172350	339584
22439	33970	7	applied	\N	\N	\N	\N	172351	172351	339585
22441	33971	0	applied	\N	\N	\N	\N	172448	172448	339682
22445	33974	0	applied	\N	\N	\N	\N	172459	172459	339693
22445	33975	1	applied	\N	\N	\N	\N	172460	172460	339694
22445	33976	2	applied	\N	\N	\N	\N	172461	172461	339695
22446	33977	0	applied	\N	\N	\N	\N	172462	172462	339696
22446	33978	1	applied	\N	\N	\N	\N	172463	172463	339697
22446	33979	2	applied	\N	\N	\N	\N	172464	172464	339698
22446	33980	3	applied	\N	\N	\N	\N	172465	172465	339699
22448	33981	0	applied	\N	\N	\N	\N	172470	172470	339704
22448	33982	1	applied	\N	\N	\N	\N	172471	172471	339705
22448	33983	2	applied	\N	\N	\N	\N	172472	172472	339706
22453	33990	0	applied	\N	\N	\N	\N	172488	172488	339722
22453	33991	1	applied	\N	\N	\N	\N	172489	172489	339723
22453	33992	2	applied	\N	\N	\N	\N	172490	172490	339724
22455	33993	0	applied	\N	\N	\N	\N	172493	172493	339727
22457	33993	0	applied	\N	\N	\N	\N	172501	172501	339735
22457	33991	1	applied	\N	\N	\N	\N	172502	172502	339736
22457	33995	3	applied	\N	\N	\N	\N	172504	172504	339738
22461	33999	0	applied	\N	\N	\N	\N	172514	172514	339748
22461	34002	1	applied	\N	\N	\N	\N	172515	172515	339749
22461	34000	2	applied	\N	\N	\N	\N	172516	172516	339750
22461	34001	3	applied	\N	\N	\N	\N	172517	172517	339751
22464	34006	0	applied	\N	\N	\N	\N	172524	172524	339758
22464	34007	1	applied	\N	\N	\N	\N	172525	172525	339759
22464	34008	2	applied	\N	\N	\N	\N	172526	172526	339760
22468	34013	0	applied	\N	\N	\N	\N	172660	172660	339894
22468	34014	1	applied	\N	\N	\N	\N	172661	172661	339895
22485	34077	0	applied	\N	\N	\N	\N	172776	172776	340010
22485	34078	1	applied	\N	\N	\N	\N	172777	172777	340011
22485	34079	2	applied	\N	\N	\N	\N	172778	172778	340012
22485	34080	3	applied	\N	\N	\N	\N	172779	172779	340013
22485	34081	4	applied	\N	\N	\N	\N	172780	172780	340014
22485	34082	5	applied	\N	\N	\N	\N	172781	172781	340015
22485	34084	7	applied	\N	\N	\N	\N	172783	172783	340017
22485	34086	8	applied	\N	\N	\N	\N	172784	172784	340018
22485	34085	9	applied	\N	\N	\N	\N	172785	172785	340019
22488	34105	0	applied	\N	\N	\N	\N	172822	172822	340056
22488	34106	1	applied	\N	\N	\N	\N	172823	172823	340057
22488	34107	2	applied	\N	\N	\N	\N	172824	172824	340058
22488	34108	3	applied	\N	\N	\N	\N	172825	172825	340059
22488	34109	4	applied	\N	\N	\N	\N	172826	172826	340060
22488	34110	5	applied	\N	\N	\N	\N	172827	172827	340061
22488	34111	6	applied	\N	\N	\N	\N	172828	172828	340062
22488	34112	7	applied	\N	\N	\N	\N	172829	172829	340063
22488	34113	8	applied	\N	\N	\N	\N	172830	172830	340064
22491	34114	0	applied	\N	\N	\N	\N	172845	172845	340079
22491	34115	1	applied	\N	\N	\N	\N	172846	172846	340080
22491	34116	2	applied	\N	\N	\N	\N	172847	172847	340081
22491	34117	3	applied	\N	\N	\N	\N	172848	172848	340082
22491	34119	5	applied	\N	\N	\N	\N	172850	172850	340084
22491	34120	6	applied	\N	\N	\N	\N	172851	172851	340085
22491	34121	7	applied	\N	\N	\N	\N	172852	172852	340086
22497	34122	0	applied	\N	\N	\N	\N	172884	172884	340118
22497	34123	1	applied	\N	\N	\N	\N	172885	172885	340119
22497	34124	2	applied	\N	\N	\N	\N	172886	172886	340120
22497	34125	3	applied	\N	\N	\N	\N	172887	172887	340121
22502	34153	0	applied	\N	\N	\N	\N	172928	172928	340162
22502	34154	1	applied	\N	\N	\N	\N	172929	172929	340163
22502	34155	2	applied	\N	\N	\N	\N	172930	172930	340164
22502	34156	3	applied	\N	\N	\N	\N	172931	172931	340165
22502	34157	4	applied	\N	\N	\N	\N	172932	172932	340166
22502	34158	5	applied	\N	\N	\N	\N	172933	172933	340167
22502	34159	6	applied	\N	\N	\N	\N	172934	172934	340168
22502	34160	7	applied	\N	\N	\N	\N	172935	172935	340169
22502	34161	8	applied	\N	\N	\N	\N	172936	172936	340170
22504	34163	1	applied	\N	\N	\N	\N	172938	172938	340172
22504	34164	2	applied	\N	\N	\N	\N	172939	172939	340173
22504	34165	3	applied	\N	\N	\N	\N	172940	172940	340174
22504	34166	4	applied	\N	\N	\N	\N	172941	172941	340175
22504	34167	5	applied	\N	\N	\N	\N	172942	172942	340176
22504	34168	6	applied	\N	\N	\N	\N	172943	172943	340177
22504	34169	7	applied	\N	\N	\N	\N	172944	172944	340178
22504	34170	8	applied	\N	\N	\N	\N	172945	172945	340179
22504	34171	9	applied	\N	\N	\N	\N	172946	172946	340180
22504	34172	10	applied	\N	\N	\N	\N	172947	172947	340181
22504	34173	11	applied	\N	\N	\N	\N	172948	172948	340182
22504	34174	12	applied	\N	\N	\N	\N	172949	172949	340183
22504	34175	13	applied	\N	\N	\N	\N	172950	172950	340184
22504	34176	14	applied	\N	\N	\N	\N	172951	172951	340185
22418	33909	7	applied	\N	\N	\N	\N	172125	172125	339359
22418	33923	8	applied	\N	\N	\N	\N	172126	172126	339360
22426	33942	3	applied	\N	\N	\N	\N	172167	172167	339401
22426	33943	4	applied	\N	\N	\N	\N	172168	172168	339402
22426	33944	5	applied	\N	\N	\N	\N	172169	172169	339403
22426	33945	6	applied	\N	\N	\N	\N	172170	172170	339404
22434	33956	0	applied	\N	\N	\N	\N	172192	172192	339426
22434	33957	1	applied	\N	\N	\N	\N	172193	172193	339427
22434	33958	2	applied	\N	\N	\N	\N	172194	172194	339428
22434	33959	3	applied	\N	\N	\N	\N	172195	172195	339429
22435	33787	0	applied	\N	\N	\N	\N	172196	172196	339430
22435	33790	1	applied	\N	\N	\N	\N	172197	172197	339431
22435	33794	2	applied	\N	\N	\N	\N	172198	172198	339432
22435	33797	3	applied	\N	\N	\N	\N	172199	172199	339433
22435	33800	4	applied	\N	\N	\N	\N	172200	172200	339434
22435	33804	5	applied	\N	\N	\N	\N	172201	172201	339435
22435	33805	6	applied	\N	\N	\N	\N	172202	172202	339436
22435	33806	7	applied	\N	\N	\N	\N	172203	172203	339437
22435	33817	9	applied	\N	\N	\N	\N	172205	172205	339439
22435	33820	10	applied	\N	\N	\N	\N	172206	172206	339440
22435	33821	11	applied	\N	\N	\N	\N	172207	172207	339441
22437	33689	0	applied	\N	\N	\N	\N	172211	172211	339445
22437	33697	1	applied	\N	\N	\N	\N	172212	172212	339446
22437	33698	2	applied	\N	\N	\N	\N	172213	172213	339447
22437	33673	3	applied	\N	\N	\N	\N	172214	172214	339448
22437	33677	4	applied	\N	\N	\N	\N	172215	172215	339449
22437	33680	5	applied	\N	\N	\N	\N	172216	172216	339450
22437	33683	6	applied	\N	\N	\N	\N	172217	172217	339451
22437	33687	7	applied	\N	\N	\N	\N	172218	172218	339452
22437	33688	8	applied	\N	\N	\N	\N	172219	172219	339453
22437	33695	9	applied	\N	\N	\N	\N	172220	172220	339454
22437	33696	10	applied	\N	\N	\N	\N	172221	172221	339455
22437	33707	11	applied	\N	\N	\N	\N	172222	172222	339456
22437	33708	12	applied	\N	\N	\N	\N	172223	172223	339457
22437	33718	14	applied	\N	\N	\N	\N	172225	172225	339459
22437	33719	15	applied	\N	\N	\N	\N	172226	172226	339460
22437	33725	16	applied	\N	\N	\N	\N	172227	172227	339461
22437	33729	17	applied	\N	\N	\N	\N	172228	172228	339462
22437	33730	18	applied	\N	\N	\N	\N	172229	172229	339463
22437	33731	19	applied	\N	\N	\N	\N	172230	172230	339464
22437	33739	20	applied	\N	\N	\N	\N	172231	172231	339465
22437	33740	21	applied	\N	\N	\N	\N	172232	172232	339466
22437	33745	22	applied	\N	\N	\N	\N	172233	172233	339467
22437	33746	23	applied	\N	\N	\N	\N	172234	172234	339468
22437	33752	24	applied	\N	\N	\N	\N	172235	172235	339469
22437	33755	25	applied	\N	\N	\N	\N	172236	172236	339470
22437	33758	26	applied	\N	\N	\N	\N	172237	172237	339471
22437	33762	27	applied	\N	\N	\N	\N	172238	172238	339472
22437	33763	28	applied	\N	\N	\N	\N	172239	172239	339473
22437	33764	29	applied	\N	\N	\N	\N	172240	172240	339474
22437	33773	31	applied	\N	\N	\N	\N	172242	172242	339476
22437	33778	32	applied	\N	\N	\N	\N	172243	172243	339477
22437	33781	33	applied	\N	\N	\N	\N	172244	172244	339478
22437	33785	34	applied	\N	\N	\N	\N	172245	172245	339479
22437	33787	35	applied	\N	\N	\N	\N	172246	172246	339480
22437	33790	36	applied	\N	\N	\N	\N	172247	172247	339481
22437	33794	37	applied	\N	\N	\N	\N	172248	172248	339482
22437	33797	38	applied	\N	\N	\N	\N	172249	172249	339483
22437	33800	39	applied	\N	\N	\N	\N	172250	172250	339484
22437	33804	40	applied	\N	\N	\N	\N	172251	172251	339485
22437	33805	41	applied	\N	\N	\N	\N	172252	172252	339486
22437	33806	42	applied	\N	\N	\N	\N	172253	172253	339487
22437	33813	43	applied	\N	\N	\N	\N	172254	172254	339488
22437	33817	44	applied	\N	\N	\N	\N	172255	172255	339489
22437	33820	45	applied	\N	\N	\N	\N	172256	172256	339490
22437	33821	46	applied	\N	\N	\N	\N	172257	172257	339491
22437	33828	48	applied	\N	\N	\N	\N	172259	172259	339493
22437	33831	49	applied	\N	\N	\N	\N	172260	172260	339494
22437	33832	50	applied	\N	\N	\N	\N	172261	172261	339495
22437	33838	51	applied	\N	\N	\N	\N	172262	172262	339496
22437	33841	52	applied	\N	\N	\N	\N	172263	172263	339497
22437	33842	53	applied	\N	\N	\N	\N	172264	172264	339498
22437	33848	54	applied	\N	\N	\N	\N	172265	172265	339499
22437	33849	55	applied	\N	\N	\N	\N	172266	172266	339500
22437	33854	56	applied	\N	\N	\N	\N	172267	172267	339501
22437	33858	57	applied	\N	\N	\N	\N	172268	172268	339502
22437	33861	58	applied	\N	\N	\N	\N	172269	172269	339503
22437	33865	59	applied	\N	\N	\N	\N	172270	172270	339504
22437	33869	60	applied	\N	\N	\N	\N	172271	172271	339505
22437	33872	61	applied	\N	\N	\N	\N	172272	172272	339506
22437	33875	62	applied	\N	\N	\N	\N	172273	172273	339507
22437	33878	63	applied	\N	\N	\N	\N	172274	172274	339508
22437	33885	65	applied	\N	\N	\N	\N	172276	172276	339510
22437	33888	66	applied	\N	\N	\N	\N	172277	172277	339511
22437	33892	67	applied	\N	\N	\N	\N	172278	172278	339512
22437	33893	68	applied	\N	\N	\N	\N	172279	172279	339513
22437	33898	69	applied	\N	\N	\N	\N	172280	172280	339514
22437	33899	70	applied	\N	\N	\N	\N	172281	172281	339515
22437	33905	71	applied	\N	\N	\N	\N	172282	172282	339516
22437	33907	72	applied	\N	\N	\N	\N	172283	172283	339517
22437	33910	73	applied	\N	\N	\N	\N	172284	172284	339518
22437	33911	74	applied	\N	\N	\N	\N	172285	172285	339519
22437	33912	75	applied	\N	\N	\N	\N	172286	172286	339520
22437	33920	76	applied	\N	\N	\N	\N	172287	172287	339521
22504	34177	15	applied	\N	\N	\N	\N	172952	172952	340186
22504	34178	16	applied	\N	\N	\N	\N	172953	172953	340187
22509	34182	0	applied	\N	\N	\N	\N	173005	173005	340239
22509	34190	1	applied	\N	\N	\N	\N	173006	173006	340240
22509	34184	3	applied	\N	\N	\N	\N	173008	173008	340242
22509	34185	4	applied	\N	\N	\N	\N	173009	173009	340243
22509	34186	5	applied	\N	\N	\N	\N	173010	173010	340244
22509	34187	6	applied	\N	\N	\N	\N	173011	173011	340245
22509	34191	7	applied	\N	\N	\N	\N	173012	173012	340246
22509	34192	8	applied	\N	\N	\N	\N	173013	173013	340247
22509	34193	9	applied	\N	\N	\N	\N	173014	173014	340248
22509	34194	10	applied	\N	\N	\N	\N	173015	173015	340249
22509	34195	11	applied	\N	\N	\N	\N	173016	173016	340250
22509	34196	12	applied	\N	\N	\N	\N	173017	173017	340251
22509	34188	13	applied	\N	\N	\N	\N	173018	173018	340252
22509	34179	14	applied	\N	\N	\N	\N	173019	173019	340253
22509	34197	15	applied	\N	\N	\N	\N	173020	173020	340254
22509	34198	16	applied	\N	\N	\N	\N	173021	173021	340255
22426	33939	0	applied	\N	\N	\N	\N	172164	172164	339398
22426	33940	1	applied	\N	\N	\N	\N	172165	172165	339399
22437	33933	81	applied	\N	\N	\N	\N	172292	172292	339526
22437	33939	82	applied	\N	\N	\N	\N	172293	172293	339527
22437	33940	83	applied	\N	\N	\N	\N	172294	172294	339528
22437	33946	84	applied	\N	\N	\N	\N	172295	172295	339529
22437	33949	85	applied	\N	\N	\N	\N	172296	172296	339530
22437	33952	86	applied	\N	\N	\N	\N	172297	172297	339531
22437	33956	87	applied	\N	\N	\N	\N	172298	172298	339532
22437	33960	88	applied	\N	\N	\N	\N	172299	172299	339533
22437	33862	89	applied	\N	\N	\N	\N	172300	172300	339534
22437	33674	90	applied	\N	\N	\N	\N	172301	172301	339535
22437	33690	91	applied	\N	\N	\N	\N	172302	172302	339536
22437	33675	92	applied	\N	\N	\N	\N	172303	172303	339537
22437	33701	94	applied	\N	\N	\N	\N	172304	172304	339538
22437	33679	95	applied	\N	\N	\N	\N	172305	172305	339539
22437	33682	96	applied	\N	\N	\N	\N	172306	172306	339540
22437	33685	97	applied	\N	\N	\N	\N	172307	172307	339541
22437	33692	99	applied	\N	\N	\N	\N	172309	172309	339543
22437	33686	100	applied	\N	\N	\N	\N	172310	172310	339544
22437	33700	101	applied	\N	\N	\N	\N	172311	172311	339545
22437	33714	102	applied	\N	\N	\N	\N	172312	172312	339546
22437	33702	103	applied	\N	\N	\N	\N	172313	172313	339547
22437	33676	104	applied	\N	\N	\N	\N	172314	172314	339548
22437	33678	105	applied	\N	\N	\N	\N	172315	172315	339549
22437	33681	106	applied	\N	\N	\N	\N	172316	172316	339550
22437	33684	107	applied	\N	\N	\N	\N	172317	172317	339551
22437	33703	108	applied	\N	\N	\N	\N	172318	172318	339552
22437	33704	109	applied	\N	\N	\N	\N	172319	172319	339553
22437	33712	110	applied	\N	\N	\N	\N	172320	172320	339554
22437	33705	111	applied	\N	\N	\N	\N	172321	172321	339555
22437	33710	112	applied	\N	\N	\N	\N	172322	172322	339556
22437	33711	113	applied	\N	\N	\N	\N	172323	172323	339557
22437	33713	114	applied	\N	\N	\N	\N	172324	172324	339558
22437	33723	116	applied	\N	\N	\N	\N	172326	172326	339560
22437	33728	117	applied	\N	\N	\N	\N	172327	172327	339561
22437	33736	118	applied	\N	\N	\N	\N	172328	172328	339562
22437	33737	119	applied	\N	\N	\N	\N	172329	172329	339563
22437	33738	120	applied	\N	\N	\N	\N	172330	172330	339564
22437	33743	121	applied	\N	\N	\N	\N	172331	172331	339565
22437	33744	122	applied	\N	\N	\N	\N	172332	172332	339566
22437	33747	123	applied	\N	\N	\N	\N	172333	172333	339567
22437	33748	124	applied	\N	\N	\N	\N	172334	172334	339568
22437	33754	125	applied	\N	\N	\N	\N	172335	172335	339569
22440	33875	0	applied	\N	\N	\N	\N	172352	172352	339586
22440	33878	1	applied	\N	\N	\N	\N	172353	172353	339587
22440	33882	2	applied	\N	\N	\N	\N	172354	172354	339588
22440	33885	3	applied	\N	\N	\N	\N	172355	172355	339589
22440	33888	4	applied	\N	\N	\N	\N	172356	172356	339590
22440	33892	5	applied	\N	\N	\N	\N	172357	172357	339591
22440	33898	7	applied	\N	\N	\N	\N	172359	172359	339593
22440	33899	8	applied	\N	\N	\N	\N	172360	172360	339594
22440	33905	9	applied	\N	\N	\N	\N	172361	172361	339595
22440	33907	10	applied	\N	\N	\N	\N	172362	172362	339596
22440	33910	11	applied	\N	\N	\N	\N	172363	172363	339597
22440	33911	12	applied	\N	\N	\N	\N	172364	172364	339598
22440	33912	13	applied	\N	\N	\N	\N	172365	172365	339599
22440	33920	14	applied	\N	\N	\N	\N	172366	172366	339600
22440	33924	15	applied	\N	\N	\N	\N	172367	172367	339601
22440	33927	16	applied	\N	\N	\N	\N	172368	172368	339602
22440	33930	17	applied	\N	\N	\N	\N	172369	172369	339603
22440	33932	18	applied	\N	\N	\N	\N	172370	172370	339604
22440	33933	19	applied	\N	\N	\N	\N	172371	172371	339605
22440	33939	21	applied	\N	\N	\N	\N	172372	172372	339606
22440	33940	22	applied	\N	\N	\N	\N	172373	172373	339607
22440	33946	23	applied	\N	\N	\N	\N	172374	172374	339608
22440	33952	25	applied	\N	\N	\N	\N	172376	172376	339610
22440	33956	26	applied	\N	\N	\N	\N	172377	172377	339611
22440	33960	27	applied	\N	\N	\N	\N	172378	172378	339612
22440	33963	28	applied	\N	\N	\N	\N	172379	172379	339613
22440	33964	29	applied	\N	\N	\N	\N	172380	172380	339614
22440	33879	30	applied	\N	\N	\N	\N	172381	172381	339615
22440	33876	31	applied	\N	\N	\N	\N	172382	172382	339616
22440	33880	32	applied	\N	\N	\N	\N	172383	172383	339617
22440	33877	33	applied	\N	\N	\N	\N	172384	172384	339618
22440	33881	34	applied	\N	\N	\N	\N	172385	172385	339619
22440	33883	35	applied	\N	\N	\N	\N	172386	172386	339620
22440	33886	36	applied	\N	\N	\N	\N	172387	172387	339621
22440	33890	37	applied	\N	\N	\N	\N	172388	172388	339622
22440	33894	38	applied	\N	\N	\N	\N	172389	172389	339623
22440	33895	39	applied	\N	\N	\N	\N	172390	172390	339624
22440	33900	40	applied	\N	\N	\N	\N	172391	172391	339625
22440	33906	42	applied	\N	\N	\N	\N	172393	172393	339627
22440	33909	43	applied	\N	\N	\N	\N	172394	172394	339628
22440	33884	44	applied	\N	\N	\N	\N	172395	172395	339629
22440	33887	45	applied	\N	\N	\N	\N	172396	172396	339630
22440	33889	46	applied	\N	\N	\N	\N	172397	172397	339631
22440	33896	47	applied	\N	\N	\N	\N	172398	172398	339632
22440	33914	48	applied	\N	\N	\N	\N	172399	172399	339633
22440	33915	49	applied	\N	\N	\N	\N	172400	172400	339634
22440	33916	50	applied	\N	\N	\N	\N	172401	172401	339635
22440	33921	51	applied	\N	\N	\N	\N	172402	172402	339636
22440	33926	52	applied	\N	\N	\N	\N	172403	172403	339637
22440	33929	53	applied	\N	\N	\N	\N	172404	172404	339638
22440	33931	54	applied	\N	\N	\N	\N	172405	172405	339639
22440	33891	55	applied	\N	\N	\N	\N	172406	172406	339640
22440	33901	56	applied	\N	\N	\N	\N	172407	172407	339641
22440	33913	57	applied	\N	\N	\N	\N	172408	172408	339642
22440	33935	59	applied	\N	\N	\N	\N	172410	172410	339644
22440	33941	60	applied	\N	\N	\N	\N	172411	172411	339645
22440	33954	61	applied	\N	\N	\N	\N	172412	172412	339646
22440	33966	62	applied	\N	\N	\N	\N	172413	172413	339647
22440	33958	63	applied	\N	\N	\N	\N	172414	172414	339648
22440	33965	64	applied	\N	\N	\N	\N	172415	172415	339649
22440	33937	65	applied	\N	\N	\N	\N	172416	172416	339650
22440	33938	66	applied	\N	\N	\N	\N	172417	172417	339651
22440	33942	67	applied	\N	\N	\N	\N	172418	172418	339652
22440	33943	68	applied	\N	\N	\N	\N	172419	172419	339653
22440	33948	69	applied	\N	\N	\N	\N	172420	172420	339654
22440	33951	70	applied	\N	\N	\N	\N	172421	172421	339655
22440	33955	71	applied	\N	\N	\N	\N	172422	172422	339656
22440	33957	72	applied	\N	\N	\N	\N	172423	172423	339657
22437	33927	78	applied	\N	\N	\N	\N	172289	172289	339523
22437	33930	79	applied	\N	\N	\N	\N	172290	172290	339524
22440	33902	77	applied	\N	\N	\N	\N	172428	172428	339662
22440	33903	78	applied	\N	\N	\N	\N	172429	172429	339663
22440	33908	79	applied	\N	\N	\N	\N	172430	172430	339664
22440	33917	80	applied	\N	\N	\N	\N	172431	172431	339665
22440	33918	81	applied	\N	\N	\N	\N	172432	172432	339666
22440	33919	82	applied	\N	\N	\N	\N	172433	172433	339667
22440	33922	83	applied	\N	\N	\N	\N	172434	172434	339668
22440	33925	84	applied	\N	\N	\N	\N	172435	172435	339669
22440	33928	85	applied	\N	\N	\N	\N	172436	172436	339670
22440	33934	86	applied	\N	\N	\N	\N	172437	172437	339671
22440	33936	87	applied	\N	\N	\N	\N	172438	172438	339672
22440	33944	88	applied	\N	\N	\N	\N	172439	172439	339673
22440	33945	89	applied	\N	\N	\N	\N	172440	172440	339674
22440	33947	90	applied	\N	\N	\N	\N	172441	172441	339675
22440	33950	91	applied	\N	\N	\N	\N	172442	172442	339676
22440	33953	92	applied	\N	\N	\N	\N	172443	172443	339677
22440	33961	94	applied	\N	\N	\N	\N	172445	172445	339679
22440	33969	95	applied	\N	\N	\N	\N	172446	172446	339680
22440	33970	96	applied	\N	\N	\N	\N	172447	172447	339681
22442	33971	0	applied	\N	\N	\N	\N	172450	172450	339684
22442	33972	1	applied	\N	\N	\N	\N	172451	172451	339685
22442	33973	2	applied	\N	\N	\N	\N	172452	172452	339686
22444	33974	0	applied	\N	\N	\N	\N	172456	172456	339690
22444	33975	1	applied	\N	\N	\N	\N	172457	172457	339691
22444	33976	2	applied	\N	\N	\N	\N	172458	172458	339692
22447	33977	0	applied	\N	\N	\N	\N	172466	172466	339700
22447	33978	1	applied	\N	\N	\N	\N	172467	172467	339701
22447	33979	2	applied	\N	\N	\N	\N	172468	172468	339702
22447	33980	3	applied	\N	\N	\N	\N	172469	172469	339703
22449	33981	0	applied	\N	\N	\N	\N	172473	172473	339707
22449	33982	1	applied	\N	\N	\N	\N	172474	172474	339708
22449	33983	2	applied	\N	\N	\N	\N	172475	172475	339709
22451	33985	1	applied	\N	\N	\N	\N	172480	172480	339714
22451	33986	2	applied	\N	\N	\N	\N	172481	172481	339715
22451	33987	3	applied	\N	\N	\N	\N	172482	172482	339716
22451	33988	4	applied	\N	\N	\N	\N	172483	172483	339717
22451	33989	5	applied	\N	\N	\N	\N	172484	172484	339718
22454	33990	0	applied	\N	\N	\N	\N	172491	172491	339725
22454	33992	1	applied	\N	\N	\N	\N	172492	172492	339726
22456	33993	0	applied	\N	\N	\N	\N	172497	172497	339731
22456	33991	1	applied	\N	\N	\N	\N	172498	172498	339732
22456	33994	2	applied	\N	\N	\N	\N	172499	172499	339733
22456	33995	3	applied	\N	\N	\N	\N	172500	172500	339734
22458	33996	0	applied	\N	\N	\N	\N	172505	172505	339739
22458	33997	1	applied	\N	\N	\N	\N	172506	172506	339740
22458	33998	2	applied	\N	\N	\N	\N	172507	172507	339741
22460	33999	0	applied	\N	\N	\N	\N	172511	172511	339745
22460	34000	1	applied	\N	\N	\N	\N	172512	172512	339746
22465	34009	0	applied	\N	\N	\N	\N	172527	172527	339761
22465	34010	1	applied	\N	\N	\N	\N	172528	172528	339762
22465	34011	2	applied	\N	\N	\N	\N	172529	172529	339763
22465	34012	3	applied	\N	\N	\N	\N	172530	172530	339764
22469	34013	0	applied	\N	\N	\N	\N	172662	172662	339896
22469	34014	1	applied	\N	\N	\N	\N	172663	172663	339897
22469	34015	2	applied	\N	\N	\N	\N	172664	172664	339898
22475	34036	0	applied	\N	\N	\N	\N	172695	172695	339929
22475	34037	1	applied	\N	\N	\N	\N	172696	172696	339930
22475	34038	2	applied	\N	\N	\N	\N	172697	172697	339931
22475	34039	3	applied	\N	\N	\N	\N	172698	172698	339932
22475	34040	4	applied	\N	\N	\N	\N	172699	172699	339933
22475	34041	5	applied	\N	\N	\N	\N	172700	172700	339934
22477	34042	0	applied	\N	\N	\N	\N	172707	172707	339941
22477	34043	1	applied	\N	\N	\N	\N	172708	172708	339942
22477	34044	2	applied	\N	\N	\N	\N	172709	172709	339943
22477	34046	4	applied	\N	\N	\N	\N	172711	172711	339945
22477	34047	5	applied	\N	\N	\N	\N	172712	172712	339946
22477	34048	6	applied	\N	\N	\N	\N	172713	172713	339947
22477	34049	7	applied	\N	\N	\N	\N	172714	172714	339948
22482	34059	0	applied	\N	\N	\N	\N	172749	172749	339983
22482	34060	1	applied	\N	\N	\N	\N	172750	172750	339984
22482	34061	2	applied	\N	\N	\N	\N	172751	172751	339985
22482	34062	3	applied	\N	\N	\N	\N	172752	172752	339986
22482	34063	4	applied	\N	\N	\N	\N	172753	172753	339987
22482	34064	5	applied	\N	\N	\N	\N	172754	172754	339988
22482	34065	6	applied	\N	\N	\N	\N	172755	172755	339989
22482	34066	7	applied	\N	\N	\N	\N	172756	172756	339990
22482	34067	8	applied	\N	\N	\N	\N	172757	172757	339991
22482	34068	9	applied	\N	\N	\N	\N	172758	172758	339992
22482	34069	10	applied	\N	\N	\N	\N	172759	172759	339993
22482	34070	11	applied	\N	\N	\N	\N	172760	172760	339994
22482	34072	14	applied	\N	\N	\N	\N	172762	172762	339996
22482	34073	15	applied	\N	\N	\N	\N	172763	172763	339997
22482	34074	16	applied	\N	\N	\N	\N	172764	172764	339998
22482	34075	17	applied	\N	\N	\N	\N	172765	172765	339999
22482	34076	18	applied	\N	\N	\N	\N	172766	172766	340000
22484	34077	0	applied	\N	\N	\N	\N	172767	172767	340001
22484	34078	1	applied	\N	\N	\N	\N	172768	172768	340002
22484	34079	2	applied	\N	\N	\N	\N	172769	172769	340003
22484	34080	3	applied	\N	\N	\N	\N	172770	172770	340004
22484	34081	4	applied	\N	\N	\N	\N	172771	172771	340005
22484	34082	5	applied	\N	\N	\N	\N	172772	172772	340006
22484	34083	6	applied	\N	\N	\N	\N	172773	172773	340007
22484	34084	7	applied	\N	\N	\N	\N	172774	172774	340008
22484	34085	8	applied	\N	\N	\N	\N	172775	172775	340009
22487	34087	0	applied	\N	\N	\N	\N	172804	172804	340038
22487	34088	1	applied	\N	\N	\N	\N	172805	172805	340039
22487	34090	3	applied	\N	\N	\N	\N	172807	172807	340041
22487	34091	4	applied	\N	\N	\N	\N	172808	172808	340042
22487	34092	5	applied	\N	\N	\N	\N	172809	172809	340043
22487	34093	6	applied	\N	\N	\N	\N	172810	172810	340044
22487	34094	7	applied	\N	\N	\N	\N	172811	172811	340045
22487	34095	8	applied	\N	\N	\N	\N	172812	172812	340046
22487	34096	9	applied	\N	\N	\N	\N	172813	172813	340047
22487	34097	10	applied	\N	\N	\N	\N	172814	172814	340048
22487	34098	11	applied	\N	\N	\N	\N	172815	172815	340049
22487	34099	12	applied	\N	\N	\N	\N	172816	172816	340050
22487	34100	13	applied	\N	\N	\N	\N	172817	172817	340051
22487	34101	14	applied	\N	\N	\N	\N	172818	172818	340052
22487	34102	15	applied	\N	\N	\N	\N	172819	172819	340053
22487	34103	16	applied	\N	\N	\N	\N	172820	172820	340054
22440	33967	74	applied	\N	\N	\N	\N	172425	172425	339659
22440	33968	75	applied	\N	\N	\N	\N	172426	172426	339660
22462	34004	1	applied	\N	\N	\N	\N	172519	172519	339753
22462	34005	2	applied	\N	\N	\N	\N	172520	172520	339754
22467	33662	0	applied	\N	\N	\N	\N	172535	172535	339769
22467	33636	1	applied	\N	\N	\N	\N	172536	172536	339770
22467	33639	2	applied	\N	\N	\N	\N	172537	172537	339771
22467	33640	3	applied	\N	\N	\N	\N	172538	172538	339772
22467	33641	4	applied	\N	\N	\N	\N	172539	172539	339773
22467	33642	5	applied	\N	\N	\N	\N	172540	172540	339774
22467	33653	6	applied	\N	\N	\N	\N	172541	172541	339775
22467	33656	7	applied	\N	\N	\N	\N	172542	172542	339776
22467	33659	8	applied	\N	\N	\N	\N	172543	172543	339777
22467	33660	9	applied	\N	\N	\N	\N	172544	172544	339778
22467	33661	10	applied	\N	\N	\N	\N	172545	172545	339779
22467	33689	11	applied	\N	\N	\N	\N	172546	172546	339780
22467	33670	12	applied	\N	\N	\N	\N	172547	172547	339781
22467	33697	13	applied	\N	\N	\N	\N	172548	172548	339782
22467	33673	15	applied	\N	\N	\N	\N	172550	172550	339784
22467	33677	16	applied	\N	\N	\N	\N	172551	172551	339785
22467	33680	17	applied	\N	\N	\N	\N	172552	172552	339786
22467	33683	18	applied	\N	\N	\N	\N	172553	172553	339787
22467	33687	19	applied	\N	\N	\N	\N	172554	172554	339788
22467	33688	20	applied	\N	\N	\N	\N	172555	172555	339789
22467	33695	21	applied	\N	\N	\N	\N	172556	172556	339790
22467	33696	22	applied	\N	\N	\N	\N	172557	172557	339791
22467	33707	23	applied	\N	\N	\N	\N	172558	172558	339792
22467	33708	24	applied	\N	\N	\N	\N	172559	172559	339793
22467	33709	25	applied	\N	\N	\N	\N	172560	172560	339794
22467	33718	26	applied	\N	\N	\N	\N	172561	172561	339795
22467	33719	27	applied	\N	\N	\N	\N	172562	172562	339796
22467	33725	28	applied	\N	\N	\N	\N	172563	172563	339797
22467	33729	29	applied	\N	\N	\N	\N	172564	172564	339798
22467	33730	30	applied	\N	\N	\N	\N	172565	172565	339799
22467	33739	32	applied	\N	\N	\N	\N	172567	172567	339801
22467	33740	33	applied	\N	\N	\N	\N	172568	172568	339802
22467	33745	34	applied	\N	\N	\N	\N	172569	172569	339803
22467	33746	35	applied	\N	\N	\N	\N	172570	172570	339804
22467	33752	36	applied	\N	\N	\N	\N	172571	172571	339805
22467	33755	37	applied	\N	\N	\N	\N	172572	172572	339806
22467	33758	38	applied	\N	\N	\N	\N	172573	172573	339807
22467	33762	39	applied	\N	\N	\N	\N	172574	172574	339808
22467	33763	40	applied	\N	\N	\N	\N	172575	172575	339809
22467	33764	41	applied	\N	\N	\N	\N	172576	172576	339810
22467	33772	42	applied	\N	\N	\N	\N	172577	172577	339811
22467	33773	43	applied	\N	\N	\N	\N	172578	172578	339812
22467	33778	44	applied	\N	\N	\N	\N	172579	172579	339813
22467	33781	45	applied	\N	\N	\N	\N	172580	172580	339814
22467	33785	46	applied	\N	\N	\N	\N	172581	172581	339815
22467	33787	47	applied	\N	\N	\N	\N	172582	172582	339816
22467	33794	49	applied	\N	\N	\N	\N	172584	172584	339818
22467	33797	50	applied	\N	\N	\N	\N	172585	172585	339819
22467	33800	51	applied	\N	\N	\N	\N	172586	172586	339820
22467	33804	52	applied	\N	\N	\N	\N	172587	172587	339821
22467	33805	53	applied	\N	\N	\N	\N	172588	172588	339822
22467	33806	54	applied	\N	\N	\N	\N	172589	172589	339823
22467	33813	55	applied	\N	\N	\N	\N	172590	172590	339824
22467	33817	56	applied	\N	\N	\N	\N	172591	172591	339825
22467	33820	57	applied	\N	\N	\N	\N	172592	172592	339826
22467	33821	58	applied	\N	\N	\N	\N	172593	172593	339827
22467	33827	59	applied	\N	\N	\N	\N	172594	172594	339828
22467	33828	60	applied	\N	\N	\N	\N	172595	172595	339829
22467	33831	61	applied	\N	\N	\N	\N	172596	172596	339830
22467	33832	62	applied	\N	\N	\N	\N	172597	172597	339831
22467	33838	64	applied	\N	\N	\N	\N	172598	172598	339832
22467	33841	65	applied	\N	\N	\N	\N	172599	172599	339833
22467	33848	67	applied	\N	\N	\N	\N	172601	172601	339835
22467	33849	68	applied	\N	\N	\N	\N	172602	172602	339836
22467	33854	69	applied	\N	\N	\N	\N	172603	172603	339837
22467	33858	70	applied	\N	\N	\N	\N	172604	172604	339838
22467	33861	71	applied	\N	\N	\N	\N	172605	172605	339839
22467	33865	72	applied	\N	\N	\N	\N	172606	172606	339840
22467	33869	73	applied	\N	\N	\N	\N	172607	172607	339841
22467	33872	74	applied	\N	\N	\N	\N	172608	172608	339842
22467	33875	75	applied	\N	\N	\N	\N	172609	172609	339843
22467	33878	76	applied	\N	\N	\N	\N	172610	172610	339844
22467	33882	77	applied	\N	\N	\N	\N	172611	172611	339845
22467	33885	78	applied	\N	\N	\N	\N	172612	172612	339846
22467	33888	79	applied	\N	\N	\N	\N	172613	172613	339847
22467	33892	80	applied	\N	\N	\N	\N	172614	172614	339848
22467	33893	81	applied	\N	\N	\N	\N	172615	172615	339849
22467	33898	82	applied	\N	\N	\N	\N	172616	172616	339850
22467	33905	84	applied	\N	\N	\N	\N	172618	172618	339852
22467	33907	85	applied	\N	\N	\N	\N	172619	172619	339853
22467	33910	86	applied	\N	\N	\N	\N	172620	172620	339854
22467	33911	87	applied	\N	\N	\N	\N	172621	172621	339855
22467	33912	88	applied	\N	\N	\N	\N	172622	172622	339856
22467	33920	89	applied	\N	\N	\N	\N	172623	172623	339857
22467	33924	90	applied	\N	\N	\N	\N	172624	172624	339858
22467	33927	91	applied	\N	\N	\N	\N	172625	172625	339859
22467	33930	92	applied	\N	\N	\N	\N	172626	172626	339860
22467	33932	93	applied	\N	\N	\N	\N	172627	172627	339861
22467	33933	94	applied	\N	\N	\N	\N	172628	172628	339862
22467	33939	95	applied	\N	\N	\N	\N	172629	172629	339863
22487	34104	17	applied	\N	\N	\N	\N	172821	172821	340055
22493	34114	0	applied	\N	\N	\N	\N	172861	172861	340095
22493	34115	1	applied	\N	\N	\N	\N	172862	172862	340096
22493	34116	2	applied	\N	\N	\N	\N	172863	172863	340097
22493	34118	4	applied	\N	\N	\N	\N	172865	172865	340099
22493	34119	5	applied	\N	\N	\N	\N	172866	172866	340100
22493	34120	6	applied	\N	\N	\N	\N	172867	172867	340101
22493	34121	7	applied	\N	\N	\N	\N	172868	172868	340102
22496	34122	0	applied	\N	\N	\N	\N	172881	172881	340115
22496	34123	1	applied	\N	\N	\N	\N	172882	172882	340116
22496	34125	2	applied	\N	\N	\N	\N	172883	172883	340117
22510	34200	0	applied	\N	\N	\N	\N	173025	173025	340259
22510	34201	1	applied	\N	\N	\N	\N	173026	173026	340260
22510	34202	2	applied	\N	\N	\N	\N	173027	173027	340261
22510	34203	3	applied	\N	\N	\N	\N	173028	173028	340262
22512	34204	0	applied	\N	\N	\N	\N	173033	173033	340267
22512	34205	1	applied	\N	\N	\N	\N	173034	173034	340268
22512	34206	2	applied	\N	\N	\N	\N	173035	173035	340269
22455	33994	2	applied	\N	\N	\N	\N	172495	172495	339729
22455	33995	3	applied	\N	\N	\N	\N	172496	172496	339730
22467	33956	100	applied	\N	\N	\N	\N	172634	172634	339868
22467	33960	101	applied	\N	\N	\N	\N	172635	172635	339869
22467	33963	102	applied	\N	\N	\N	\N	172636	172636	339870
22467	33964	103	applied	\N	\N	\N	\N	172637	172637	339871
22467	33971	104	applied	\N	\N	\N	\N	172638	172638	339872
22467	33974	105	applied	\N	\N	\N	\N	172639	172639	339873
22467	33977	106	applied	\N	\N	\N	\N	172640	172640	339874
22467	33981	107	applied	\N	\N	\N	\N	172641	172641	339875
22467	33984	108	applied	\N	\N	\N	\N	172642	172642	339876
22467	33985	109	applied	\N	\N	\N	\N	172643	172643	339877
22467	33990	110	applied	\N	\N	\N	\N	172644	172644	339878
22467	33993	111	applied	\N	\N	\N	\N	172645	172645	339879
22467	33996	112	applied	\N	\N	\N	\N	172646	172646	339880
22467	33999	113	applied	\N	\N	\N	\N	172647	172647	339881
22467	34003	114	applied	\N	\N	\N	\N	172648	172648	339882
22467	34006	115	applied	\N	\N	\N	\N	172649	172649	339883
22467	33862	117	applied	\N	\N	\N	\N	172651	172651	339885
22467	33690	118	applied	\N	\N	\N	\N	172652	172652	339886
22467	33372	119	applied	\N	\N	\N	\N	172653	172653	339887
22467	33383	120	applied	\N	\N	\N	\N	172654	172654	339888
22467	33395	121	applied	\N	\N	\N	\N	172655	172655	339889
22467	33409	122	applied	\N	\N	\N	\N	172656	172656	339890
22467	33420	123	applied	\N	\N	\N	\N	172657	172657	339891
22467	33427	124	applied	\N	\N	\N	\N	172658	172658	339892
22467	33703	125	applied	\N	\N	\N	\N	172659	172659	339893
22471	34016	0	applied	\N	\N	\N	\N	172668	172668	339902
22471	34017	1	applied	\N	\N	\N	\N	172669	172669	339903
22471	34018	2	applied	\N	\N	\N	\N	172670	172670	339904
22471	34019	3	applied	\N	\N	\N	\N	172671	172671	339905
22471	34020	4	applied	\N	\N	\N	\N	172672	172672	339906
22471	34021	5	applied	\N	\N	\N	\N	172673	172673	339907
22471	34022	6	applied	\N	\N	\N	\N	172674	172674	339908
22474	34024	1	applied	\N	\N	\N	\N	172683	172683	339917
22474	34025	2	applied	\N	\N	\N	\N	172684	172684	339918
22474	34026	3	applied	\N	\N	\N	\N	172685	172685	339919
22474	34027	4	applied	\N	\N	\N	\N	172686	172686	339920
22474	34028	5	applied	\N	\N	\N	\N	172687	172687	339921
22474	34029	6	applied	\N	\N	\N	\N	172688	172688	339922
22474	34030	7	applied	\N	\N	\N	\N	172689	172689	339923
22474	34031	8	applied	\N	\N	\N	\N	172690	172690	339924
22474	34032	9	applied	\N	\N	\N	\N	172691	172691	339925
22474	34033	10	applied	\N	\N	\N	\N	172692	172692	339926
22474	34034	11	applied	\N	\N	\N	\N	172693	172693	339927
22474	34035	12	applied	\N	\N	\N	\N	172694	172694	339928
22479	34042	0	applied	\N	\N	\N	\N	172724	172724	339958
22479	34043	1	applied	\N	\N	\N	\N	172725	172725	339959
22479	34044	2	applied	\N	\N	\N	\N	172726	172726	339960
22479	34045	3	applied	\N	\N	\N	\N	172727	172727	339961
22479	34047	5	applied	\N	\N	\N	\N	172729	172729	339963
22479	34048	6	applied	\N	\N	\N	\N	172730	172730	339964
22479	34050	7	applied	\N	\N	\N	\N	172731	172731	339965
22479	34049	8	applied	\N	\N	\N	\N	172732	172732	339966
22481	34051	0	applied	\N	\N	\N	\N	172741	172741	339975
22481	34052	1	applied	\N	\N	\N	\N	172742	172742	339976
22481	34053	2	applied	\N	\N	\N	\N	172743	172743	339977
22481	34054	3	applied	\N	\N	\N	\N	172744	172744	339978
22481	34055	4	applied	\N	\N	\N	\N	172745	172745	339979
22481	34056	5	applied	\N	\N	\N	\N	172746	172746	339980
22481	34057	6	applied	\N	\N	\N	\N	172747	172747	339981
22481	34058	7	applied	\N	\N	\N	\N	172748	172748	339982
22486	34087	0	applied	\N	\N	\N	\N	172786	172786	340020
22486	34088	1	applied	\N	\N	\N	\N	172787	172787	340021
22486	34089	2	applied	\N	\N	\N	\N	172788	172788	340022
22486	34090	3	applied	\N	\N	\N	\N	172789	172789	340023
22486	34092	5	applied	\N	\N	\N	\N	172791	172791	340025
22486	34093	6	applied	\N	\N	\N	\N	172792	172792	340026
22486	34094	7	applied	\N	\N	\N	\N	172793	172793	340027
22486	34095	8	applied	\N	\N	\N	\N	172794	172794	340028
22486	34096	9	applied	\N	\N	\N	\N	172795	172795	340029
22486	34097	10	applied	\N	\N	\N	\N	172796	172796	340030
22486	34098	11	applied	\N	\N	\N	\N	172797	172797	340031
22486	34099	12	applied	\N	\N	\N	\N	172798	172798	340032
22486	34100	13	applied	\N	\N	\N	\N	172799	172799	340033
22486	34101	14	applied	\N	\N	\N	\N	172800	172800	340034
22486	34102	15	applied	\N	\N	\N	\N	172801	172801	340035
22486	34103	16	applied	\N	\N	\N	\N	172802	172802	340036
22486	34104	17	applied	\N	\N	\N	\N	172803	172803	340037
22489	34114	0	applied	\N	\N	\N	\N	172831	172831	340065
22489	34115	1	applied	\N	\N	\N	\N	172832	172832	340066
22489	34116	2	applied	\N	\N	\N	\N	172833	172833	340067
22489	34118	4	applied	\N	\N	\N	\N	172835	172835	340069
22489	34119	5	applied	\N	\N	\N	\N	172836	172836	340070
22489	34120	6	applied	\N	\N	\N	\N	172837	172837	340071
22489	34121	7	applied	\N	\N	\N	\N	172838	172838	340072
22492	34114	0	applied	\N	\N	\N	\N	172853	172853	340087
22492	34115	1	applied	\N	\N	\N	\N	172854	172854	340088
22492	34116	2	applied	\N	\N	\N	\N	172855	172855	340089
22492	34117	3	applied	\N	\N	\N	\N	172856	172856	340090
22492	34118	4	applied	\N	\N	\N	\N	172857	172857	340091
22492	34119	5	applied	\N	\N	\N	\N	172858	172858	340092
22492	34120	6	applied	\N	\N	\N	\N	172859	172859	340093
22492	34121	7	applied	\N	\N	\N	\N	172860	172860	340094
22495	34122	0	applied	\N	\N	\N	\N	172877	172877	340111
22495	34123	1	applied	\N	\N	\N	\N	172878	172878	340112
22495	34124	2	applied	\N	\N	\N	\N	172879	172879	340113
22495	34125	3	applied	\N	\N	\N	\N	172880	172880	340114
22498	34119	1	applied	\N	\N	\N	\N	172889	172889	340123
22498	34124	2	applied	\N	\N	\N	\N	172890	172890	340124
22505	34162	0	applied	\N	\N	\N	\N	172954	172954	340188
22505	34163	1	applied	\N	\N	\N	\N	172955	172955	340189
22505	34164	2	applied	\N	\N	\N	\N	172956	172956	340190
22505	34165	3	applied	\N	\N	\N	\N	172957	172957	340191
22505	34166	4	applied	\N	\N	\N	\N	172958	172958	340192
22505	34167	5	applied	\N	\N	\N	\N	172959	172959	340193
22505	34168	6	applied	\N	\N	\N	\N	172960	172960	340194
22505	34169	7	applied	\N	\N	\N	\N	172961	172961	340195
22505	34170	8	applied	\N	\N	\N	\N	172962	172962	340196
22505	34171	9	applied	\N	\N	\N	\N	172963	172963	340197
22505	34172	10	applied	\N	\N	\N	\N	172964	172964	340198
22505	34173	11	applied	\N	\N	\N	\N	172965	172965	340199
22467	33946	97	applied	\N	\N	\N	\N	172631	172631	339865
22467	33949	98	applied	\N	\N	\N	\N	172632	172632	339866
22494	34115	1	applied	\N	\N	\N	\N	172870	172870	340104
22494	34116	2	applied	\N	\N	\N	\N	172871	172871	340105
22494	34117	3	applied	\N	\N	\N	\N	172872	172872	340106
22494	34118	4	applied	\N	\N	\N	\N	172873	172873	340107
22494	34119	5	applied	\N	\N	\N	\N	172874	172874	340108
22494	34120	6	applied	\N	\N	\N	\N	172875	172875	340109
22494	34121	7	applied	\N	\N	\N	\N	172876	172876	340110
22499	34126	0	applied	\N	\N	\N	\N	172891	172891	340125
22499	34127	1	applied	\N	\N	\N	\N	172892	172892	340126
22499	34128	2	applied	\N	\N	\N	\N	172893	172893	340127
22499	34129	3	applied	\N	\N	\N	\N	172894	172894	340128
22499	34130	4	applied	\N	\N	\N	\N	172895	172895	340129
22499	34131	5	applied	\N	\N	\N	\N	172896	172896	340130
22499	34132	6	applied	\N	\N	\N	\N	172897	172897	340131
22499	34133	7	applied	\N	\N	\N	\N	172898	172898	340132
22499	34134	8	applied	\N	\N	\N	\N	172899	172899	340133
22499	34136	10	applied	\N	\N	\N	\N	172901	172901	340135
22499	34137	11	applied	\N	\N	\N	\N	172902	172902	340136
22499	34138	12	applied	\N	\N	\N	\N	172903	172903	340137
22499	34139	13	applied	\N	\N	\N	\N	172904	172904	340138
22499	34140	14	applied	\N	\N	\N	\N	172905	172905	340139
22499	34141	15	applied	\N	\N	\N	\N	172906	172906	340140
22499	34142	16	applied	\N	\N	\N	\N	172907	172907	340141
22499	34143	17	applied	\N	\N	\N	\N	172908	172908	340142
22499	34144	18	applied	\N	\N	\N	\N	172909	172909	340143
22499	34145	19	applied	\N	\N	\N	\N	172910	172910	340144
22499	34146	20	applied	\N	\N	\N	\N	172911	172911	340145
22499	34147	21	applied	\N	\N	\N	\N	172912	172912	340146
22499	34148	22	applied	\N	\N	\N	\N	172913	172913	340147
22499	34124	23	applied	\N	\N	\N	\N	172914	172914	340148
22499	34149	24	applied	\N	\N	\N	\N	172915	172915	340149
22499	34150	25	applied	\N	\N	\N	\N	172916	172916	340150
22499	34152	27	applied	\N	\N	\N	\N	172918	172918	340152
22501	34153	0	applied	\N	\N	\N	\N	172919	172919	340153
22501	34154	1	applied	\N	\N	\N	\N	172920	172920	340154
22501	34155	2	applied	\N	\N	\N	\N	172921	172921	340155
22501	34156	3	applied	\N	\N	\N	\N	172922	172922	340156
22501	34157	4	applied	\N	\N	\N	\N	172923	172923	340157
22501	34158	5	applied	\N	\N	\N	\N	172924	172924	340158
22501	34159	6	applied	\N	\N	\N	\N	172925	172925	340159
22501	34160	7	applied	\N	\N	\N	\N	172926	172926	340160
22501	34161	8	applied	\N	\N	\N	\N	172927	172927	340161
22505	34174	12	applied	\N	\N	\N	\N	172966	172966	340200
22505	34175	13	applied	\N	\N	\N	\N	172967	172967	340201
22505	34176	14	applied	\N	\N	\N	\N	172968	172968	340202
22505	34179	15	applied	\N	\N	\N	\N	172969	172969	340203
22505	34177	16	applied	\N	\N	\N	\N	172970	172970	340204
22505	34180	17	applied	\N	\N	\N	\N	172971	172971	340205
22506	34181	0	applied	\N	\N	\N	\N	172973	172973	340207
22507	34181	0	applied	\N	\N	\N	\N	172974	172974	340208
22507	34182	2	applied	\N	\N	\N	\N	172975	172975	340209
22507	34183	3	applied	\N	\N	\N	\N	172976	172976	340210
22507	34184	4	applied	\N	\N	\N	\N	172977	172977	340211
22507	34185	5	applied	\N	\N	\N	\N	172978	172978	340212
22507	34186	6	applied	\N	\N	\N	\N	172979	172979	340213
22507	34187	7	applied	\N	\N	\N	\N	172980	172980	340214
22507	34188	8	applied	\N	\N	\N	\N	172981	172981	340215
22507	34179	9	applied	\N	\N	\N	\N	172982	172982	340216
22507	34180	10	applied	\N	\N	\N	\N	172983	172983	340217
22507	34189	11	applied	\N	\N	\N	\N	172984	172984	340218
22508	34182	0	applied	\N	\N	\N	\N	172985	172985	340219
22508	34190	1	applied	\N	\N	\N	\N	172986	172986	340220
22508	34183	2	applied	\N	\N	\N	\N	172987	172987	340221
22508	34184	3	applied	\N	\N	\N	\N	172988	172988	340222
22508	34186	5	applied	\N	\N	\N	\N	172990	172990	340224
22508	34187	6	applied	\N	\N	\N	\N	172991	172991	340225
22508	34191	7	applied	\N	\N	\N	\N	172992	172992	340226
22508	34192	8	applied	\N	\N	\N	\N	172993	172993	340227
22508	34193	9	applied	\N	\N	\N	\N	172994	172994	340228
22508	34194	10	applied	\N	\N	\N	\N	172995	172995	340229
22508	34195	11	applied	\N	\N	\N	\N	172996	172996	340230
22508	34196	12	applied	\N	\N	\N	\N	172997	172997	340231
22508	34188	13	applied	\N	\N	\N	\N	172998	172998	340232
22508	34179	14	applied	\N	\N	\N	\N	172999	172999	340233
22508	34197	15	applied	\N	\N	\N	\N	173000	173000	340234
22508	34198	16	applied	\N	\N	\N	\N	173001	173001	340235
22508	34180	17	applied	\N	\N	\N	\N	173002	173002	340236
22508	34189	18	applied	\N	\N	\N	\N	173003	173003	340237
22508	34199	19	applied	\N	\N	\N	\N	173004	173004	340238
22511	34200	0	applied	\N	\N	\N	\N	173029	173029	340263
22511	34202	2	applied	\N	\N	\N	\N	173031	173031	340265
22511	34203	3	applied	\N	\N	\N	\N	173032	173032	340266
22514	34207	0	applied	\N	\N	\N	\N	173036	173036	340270
22516	34207	0	applied	\N	\N	\N	\N	173044	173044	340278
22516	34208	1	applied	\N	\N	\N	\N	173045	173045	340279
22516	34209	2	applied	\N	\N	\N	\N	173046	173046	340280
22516	34210	3	applied	\N	\N	\N	\N	173047	173047	340281
22518	34217	0	applied	\N	\N	\N	\N	173054	173054	340288
22518	34218	1	applied	\N	\N	\N	\N	173055	173055	340289
22518	34219	2	applied	\N	\N	\N	\N	173056	173056	340290
22518	34220	3	applied	\N	\N	\N	\N	173057	173057	340291
22518	34221	4	applied	\N	\N	\N	\N	173058	173058	340292
22518	34222	5	applied	\N	\N	\N	\N	173059	173059	340293
22518	34223	6	applied	\N	\N	\N	\N	173060	173060	340294
22518	34224	7	applied	\N	\N	\N	\N	173061	173061	340295
22518	34225	8	applied	\N	\N	\N	\N	173062	173062	340296
22525	34261	1	applied	\N	\N	\N	\N	173120	173120	340354
22525	34262	2	applied	\N	\N	\N	\N	173121	173121	340355
22525	34263	3	applied	\N	\N	\N	\N	173122	173122	340356
22533	34283	0	applied	\N	\N	\N	\N	173164	173164	340398
22533	34284	1	applied	\N	\N	\N	\N	173165	173165	340399
22533	34285	2	applied	\N	\N	\N	\N	173166	173166	340400
22533	34286	3	applied	\N	\N	\N	\N	173167	173167	340401
22533	34287	4	applied	\N	\N	\N	\N	173168	173168	340402
22533	34288	5	applied	\N	\N	\N	\N	173169	173169	340403
22533	34289	6	applied	\N	\N	\N	\N	173170	173170	340404
22533	34290	7	applied	\N	\N	\N	\N	173171	173171	340405
22533	34291	8	applied	\N	\N	\N	\N	173172	173172	340406
22533	34292	9	applied	\N	\N	\N	\N	173173	173173	340407
22533	34293	10	applied	\N	\N	\N	\N	173174	173174	340408
22490	34120	4	applied	\N	\N	\N	\N	172843	172843	340077
22490	34121	5	applied	\N	\N	\N	\N	172844	172844	340078
22521	34235	0	applied	\N	\N	\N	\N	173081	173081	340315
22521	34236	1	applied	\N	\N	\N	\N	173082	173082	340316
22521	34237	2	applied	\N	\N	\N	\N	173083	173083	340317
22521	34238	3	applied	\N	\N	\N	\N	173084	173084	340318
22521	34239	4	applied	\N	\N	\N	\N	173085	173085	340319
22521	34240	5	applied	\N	\N	\N	\N	173086	173086	340320
22521	34241	6	applied	\N	\N	\N	\N	173087	173087	340321
22521	34242	7	applied	\N	\N	\N	\N	173088	173088	340322
22521	34243	8	applied	\N	\N	\N	\N	173089	173089	340323
22521	34244	9	applied	\N	\N	\N	\N	173090	173090	340324
22521	34245	10	applied	\N	\N	\N	\N	173091	173091	340325
22521	34247	12	applied	\N	\N	\N	\N	173093	173093	340327
22523	34248	0	applied	\N	\N	\N	\N	173107	173107	340341
22523	34249	1	applied	\N	\N	\N	\N	173108	173108	340342
22523	34250	2	applied	\N	\N	\N	\N	173109	173109	340343
22523	34251	3	applied	\N	\N	\N	\N	173110	173110	340344
22523	34252	4	applied	\N	\N	\N	\N	173111	173111	340345
22523	34253	5	applied	\N	\N	\N	\N	173112	173112	340346
22523	34254	6	applied	\N	\N	\N	\N	173113	173113	340347
22523	34255	7	applied	\N	\N	\N	\N	173114	173114	340348
22523	34256	8	applied	\N	\N	\N	\N	173115	173115	340349
22528	34264	0	applied	\N	\N	\N	\N	173129	173129	340363
22528	34265	1	applied	\N	\N	\N	\N	173130	173130	340364
22528	34267	2	applied	\N	\N	\N	\N	173131	173131	340365
22528	34269	3	applied	\N	\N	\N	\N	173132	173132	340366
22533	34294	11	applied	\N	\N	\N	\N	173175	173175	340409
22533	34295	12	applied	\N	\N	\N	\N	173176	173176	340410
22534	34297	1	applied	\N	\N	\N	\N	173178	173178	340412
22534	34298	2	applied	\N	\N	\N	\N	173179	173179	340413
22534	34299	3	applied	\N	\N	\N	\N	173180	173180	340414
22534	34300	4	applied	\N	\N	\N	\N	173181	173181	340415
22534	34301	5	applied	\N	\N	\N	\N	173182	173182	340416
22534	34302	6	applied	\N	\N	\N	\N	173183	173183	340417
22534	34303	7	applied	\N	\N	\N	\N	173184	173184	340418
22536	34304	0	applied	\N	\N	\N	\N	173188	173188	340422
22536	34305	1	applied	\N	\N	\N	\N	173189	173189	340423
22536	34306	2	applied	\N	\N	\N	\N	173190	173190	340424
22537	34307	0	applied	\N	\N	\N	\N	173191	173191	340425
22537	34308	1	applied	\N	\N	\N	\N	173192	173192	340426
22537	34309	2	applied	\N	\N	\N	\N	173193	173193	340427
22537	34310	3	applied	\N	\N	\N	\N	173194	173194	340428
22537	34311	4	applied	\N	\N	\N	\N	173195	173195	340429
22537	34312	5	applied	\N	\N	\N	\N	173196	173196	340430
22537	34314	7	applied	\N	\N	\N	\N	173198	173198	340432
22537	34315	8	applied	\N	\N	\N	\N	173199	173199	340433
22537	34316	9	applied	\N	\N	\N	\N	173200	173200	340434
22537	34317	10	applied	\N	\N	\N	\N	173201	173201	340435
22537	34318	11	applied	\N	\N	\N	\N	173202	173202	340436
22539	34319	0	applied	\N	\N	\N	\N	173215	173215	340449
22539	34320	1	applied	\N	\N	\N	\N	173216	173216	340450
22539	34321	2	applied	\N	\N	\N	\N	173217	173217	340451
22541	34322	0	applied	\N	\N	\N	\N	173221	173221	340455
22547	34329	0	applied	\N	\N	\N	\N	173235	173235	340469
22547	34330	1	applied	\N	\N	\N	\N	173236	173236	340470
22547	34331	2	applied	\N	\N	\N	\N	173237	173237	340471
22547	34332	3	applied	\N	\N	\N	\N	173238	173238	340472
22547	34333	4	applied	\N	\N	\N	\N	173239	173239	340473
22547	34334	5	applied	\N	\N	\N	\N	173240	173240	340474
22547	34335	6	applied	\N	\N	\N	\N	173241	173241	340475
22547	34337	8	applied	\N	\N	\N	\N	173243	173243	340477
22547	34338	9	applied	\N	\N	\N	\N	173244	173244	340478
22547	34339	10	applied	\N	\N	\N	\N	173245	173245	340479
22547	34340	11	applied	\N	\N	\N	\N	173246	173246	340480
22547	34341	12	applied	\N	\N	\N	\N	173247	173247	340481
22549	34342	0	applied	\N	\N	\N	\N	173261	173261	340495
22549	34343	1	applied	\N	\N	\N	\N	173262	173262	340496
22549	34344	2	applied	\N	\N	\N	\N	173263	173263	340497
22552	34349	0	applied	\N	\N	\N	\N	173274	173274	340508
22552	34350	1	applied	\N	\N	\N	\N	173275	173275	340509
22552	34351	2	applied	\N	\N	\N	\N	173276	173276	340510
22552	34352	3	applied	\N	\N	\N	\N	173277	173277	340511
22552	34353	4	applied	\N	\N	\N	\N	173278	173278	340512
22552	34354	5	applied	\N	\N	\N	\N	173279	173279	340513
22554	34355	0	applied	\N	\N	\N	\N	173280	173280	340514
22554	34356	1	applied	\N	\N	\N	\N	173281	173281	340515
22556	34358	0	applied	\N	\N	\N	\N	173287	173287	340521
22556	34359	1	applied	\N	\N	\N	\N	173288	173288	340522
22556	34360	2	applied	\N	\N	\N	\N	173289	173289	340523
22556	34361	3	applied	\N	\N	\N	\N	173290	173290	340524
22558	34362	0	applied	\N	\N	\N	\N	173294	173294	340528
22558	34363	1	applied	\N	\N	\N	\N	173295	173295	340529
22558	34364	2	applied	\N	\N	\N	\N	173296	173296	340530
22559	34362	0	applied	\N	\N	\N	\N	173297	173297	340531
22559	34363	1	applied	\N	\N	\N	\N	173298	173298	340532
22559	34364	2	applied	\N	\N	\N	\N	173299	173299	340533
22561	34365	0	applied	\N	\N	\N	\N	173303	173303	340537
22561	34366	1	applied	\N	\N	\N	\N	173304	173304	340538
22561	34367	2	applied	\N	\N	\N	\N	173305	173305	340539
22561	34368	3	applied	\N	\N	1000000000	\N	173306	173306	340540
22561	34369	4	applied	\N	\N	\N	\N	173307	173307	340541
22561	34370	5	applied	\N	\N	\N	\N	173308	173308	340542
22561	34372	7	applied	\N	\N	\N	\N	173310	173310	340544
22563	34373	0	applied	\N	\N	\N	\N	173314	173314	340548
22563	34374	1	applied	\N	\N	\N	\N	173315	173315	340549
22563	34375	3	applied	\N	\N	\N	\N	173316	173316	340550
22571	34394	0	applied	\N	\N	\N	\N	173356	173356	340590
22571	34395	1	applied	\N	\N	\N	\N	173357	173357	340591
22571	34396	2	applied	\N	\N	\N	\N	173358	173358	340592
22573	34397	0	applied	\N	\N	1000000000	\N	173362	173362	340596
22573	34398	1	applied	\N	\N	\N	\N	173363	173363	340597
22573	34399	2	applied	\N	\N	\N	\N	173364	173364	340598
22573	34400	3	applied	\N	\N	\N	\N	173365	173365	340599
22573	34401	4	applied	\N	\N	\N	\N	173366	173366	340600
22573	34402	5	applied	\N	\N	\N	\N	173367	173367	340601
22573	34403	6	applied	\N	\N	\N	\N	173368	173368	340602
22573	34404	7	applied	\N	\N	\N	\N	173369	173369	340603
22573	34405	8	applied	\N	\N	\N	\N	173370	173370	340604
22576	34397	0	applied	\N	\N	1000000000	\N	173385	173385	340619
22576	34398	1	applied	\N	\N	\N	\N	173386	173386	340620
22509	34189	18	applied	\N	\N	\N	\N	173023	173023	340257
22509	34199	19	applied	\N	\N	\N	\N	173024	173024	340258
22519	34227	1	applied	\N	\N	\N	\N	173064	173064	340298
22519	34228	2	applied	\N	\N	\N	\N	173065	173065	340299
22519	34229	3	applied	\N	\N	\N	\N	173066	173066	340300
22519	34230	4	applied	\N	\N	\N	\N	173067	173067	340301
22519	34231	5	applied	\N	\N	\N	\N	173068	173068	340302
22519	34232	6	applied	\N	\N	\N	\N	173069	173069	340303
22519	34233	7	applied	\N	\N	\N	\N	173070	173070	340304
22519	34234	8	applied	\N	\N	\N	\N	173071	173071	340305
22522	34235	0	applied	\N	\N	\N	\N	173094	173094	340328
22522	34236	1	applied	\N	\N	\N	\N	173095	173095	340329
22522	34237	2	applied	\N	\N	\N	\N	173096	173096	340330
22522	34238	3	applied	\N	\N	\N	\N	173097	173097	340331
22522	34239	4	applied	\N	\N	\N	\N	173098	173098	340332
22522	34240	5	applied	\N	\N	\N	\N	173099	173099	340333
22522	34241	6	applied	\N	\N	\N	\N	173100	173100	340334
22522	34242	7	applied	\N	\N	\N	\N	173101	173101	340335
22522	34244	9	applied	\N	\N	\N	\N	173103	173103	340337
22522	34245	10	applied	\N	\N	\N	\N	173104	173104	340338
22522	34246	11	applied	\N	\N	\N	\N	173105	173105	340339
22522	34247	12	applied	\N	\N	\N	\N	173106	173106	340340
22524	34257	0	applied	\N	\N	\N	\N	173116	173116	340350
22524	34258	1	applied	\N	\N	\N	\N	173117	173117	340351
22524	34259	2	applied	\N	\N	\N	\N	173118	173118	340352
22529	34270	0	applied	\N	\N	\N	\N	173133	173133	340367
22529	34271	1	applied	\N	\N	\N	\N	173134	173134	340368
22529	34272	2	applied	\N	\N	\N	\N	173135	173135	340369
22529	34266	3	applied	\N	\N	\N	\N	173136	173136	340370
22529	34273	4	applied	\N	\N	\N	\N	173137	173137	340371
22529	34274	5	applied	\N	\N	\N	\N	173138	173138	340372
22529	34268	6	applied	\N	\N	\N	\N	173139	173139	340373
22529	34275	7	applied	\N	\N	\N	\N	173140	173140	340374
22529	34276	8	applied	\N	\N	\N	\N	173141	173141	340375
22531	34271	1	applied	\N	\N	\N	\N	173150	173150	340384
22531	34272	2	applied	\N	\N	\N	\N	173151	173151	340385
22531	34266	3	applied	\N	\N	\N	\N	173152	173152	340386
22531	34273	4	applied	\N	\N	\N	\N	173153	173153	340387
22531	34274	5	applied	\N	\N	\N	\N	173154	173154	340388
22531	34268	6	applied	\N	\N	\N	\N	173155	173155	340389
22531	34275	7	applied	\N	\N	\N	\N	173156	173156	340390
22531	34276	8	applied	\N	\N	\N	\N	173157	173157	340391
22535	34304	0	applied	\N	\N	\N	\N	173185	173185	340419
22535	34305	1	applied	\N	\N	\N	\N	173186	173186	340420
22535	34306	2	applied	\N	\N	\N	\N	173187	173187	340421
22538	34307	0	applied	\N	\N	\N	\N	173203	173203	340437
22538	34308	1	applied	\N	\N	\N	\N	173204	173204	340438
22538	34309	2	applied	\N	\N	\N	\N	173205	173205	340439
22538	34310	3	applied	\N	\N	\N	\N	173206	173206	340440
22538	34311	4	applied	\N	\N	\N	\N	173207	173207	340441
22538	34313	6	applied	\N	\N	\N	\N	173209	173209	340443
22538	34314	7	applied	\N	\N	\N	\N	173210	173210	340444
22538	34315	8	applied	\N	\N	\N	\N	173211	173211	340445
22538	34316	9	applied	\N	\N	\N	\N	173212	173212	340446
22538	34317	10	applied	\N	\N	\N	\N	173213	173213	340447
22538	34318	11	applied	\N	\N	\N	\N	173214	173214	340448
22540	34319	0	applied	\N	\N	\N	\N	173218	173218	340452
22540	34320	1	applied	\N	\N	\N	\N	173219	173219	340453
22540	34321	2	applied	\N	\N	\N	\N	173220	173220	340454
22542	34322	0	applied	\N	\N	\N	\N	173222	173222	340456
22542	34323	1	applied	\N	\N	\N	\N	173223	173223	340457
22542	34324	2	applied	\N	\N	\N	\N	173224	173224	340458
22544	34322	0	applied	\N	\N	\N	\N	173228	173228	340462
22544	34323	1	applied	\N	\N	\N	\N	173229	173229	340463
22550	34345	0	applied	\N	\N	\N	\N	173264	173264	340498
22550	34346	1	applied	\N	\N	\N	\N	173265	173265	340499
22550	34348	3	applied	\N	\N	\N	\N	173267	173267	340501
22555	34358	0	applied	\N	\N	\N	\N	173283	173283	340517
22555	34359	1	applied	\N	\N	\N	\N	173284	173284	340518
22555	34360	2	applied	\N	\N	\N	\N	173285	173285	340519
22555	34361	3	applied	\N	\N	\N	\N	173286	173286	340520
22557	34362	0	applied	\N	\N	\N	\N	173291	173291	340525
22557	34363	1	applied	\N	\N	\N	\N	173292	173292	340526
22557	34364	2	applied	\N	\N	\N	\N	173293	173293	340527
22562	34373	0	applied	\N	\N	\N	\N	173311	173311	340545
22562	34374	1	applied	\N	\N	\N	\N	173312	173312	340546
22562	34375	3	applied	\N	\N	\N	\N	173313	173313	340547
22564	34376	0	applied	\N	\N	\N	\N	173317	173317	340551
22564	34377	1	applied	\N	\N	\N	\N	173318	173318	340552
22564	34378	2	applied	\N	\N	\N	\N	173319	173319	340553
22567	34379	0	applied	\N	\N	\N	\N	173326	173326	340560
22567	34380	1	applied	\N	\N	\N	\N	173327	173327	340561
22567	34382	3	applied	\N	\N	\N	\N	173329	173329	340563
22567	34383	4	applied	\N	\N	\N	\N	173330	173330	340564
22567	34384	5	applied	\N	\N	\N	\N	173331	173331	340565
22567	34385	6	applied	\N	\N	\N	\N	173332	173332	340566
22567	34386	7	applied	\N	\N	\N	\N	173333	173333	340567
22567	34387	8	applied	\N	\N	\N	\N	173334	173334	340568
22567	34388	9	applied	\N	\N	\N	\N	173335	173335	340569
22567	34389	10	applied	\N	\N	\N	\N	173336	173336	340570
22567	34390	11	applied	\N	\N	\N	\N	173337	173337	340571
22569	34391	0	applied	\N	\N	\N	\N	173350	173350	340584
22569	34392	1	applied	\N	\N	\N	\N	173351	173351	340585
22569	34393	2	applied	\N	\N	\N	\N	173352	173352	340586
22576	34399	2	applied	\N	\N	\N	\N	173387	173387	340621
22576	34400	3	applied	\N	\N	\N	\N	173388	173388	340622
22576	34401	4	applied	\N	\N	\N	\N	173389	173389	340623
22576	34407	5	applied	\N	\N	\N	\N	173390	173390	340624
22576	34411	7	applied	\N	\N	\N	\N	173392	173392	340626
22576	34402	8	applied	\N	\N	\N	\N	173393	173393	340627
22576	34403	9	applied	\N	\N	\N	\N	173394	173394	340628
22576	34405	10	applied	\N	\N	\N	\N	173395	173395	340629
22576	34409	11	applied	\N	\N	\N	\N	173396	173396	340630
22576	34412	12	applied	\N	\N	\N	\N	173397	173397	340631
22576	34413	13	applied	\N	\N	\N	\N	173398	173398	340632
22576	34406	14	applied	\N	\N	\N	\N	173399	173399	340633
22576	34414	15	applied	\N	\N	\N	\N	173400	173400	340634
22576	34415	16	applied	\N	\N	\N	\N	173401	173401	340635
22578	34410	0	applied	\N	\N	\N	\N	173413	173413	340647
22578	34411	1	applied	\N	\N	\N	\N	173414	173414	340648
22578	34416	2	applied	\N	\N	\N	\N	173415	173415	340649
22578	34412	3	applied	\N	\N	\N	\N	173416	173416	340650
22514	34209	2	applied	\N	\N	\N	\N	173038	173038	340272
22514	34210	3	applied	\N	\N	\N	\N	173039	173039	340273
22517	34211	0	applied	\N	\N	\N	\N	173048	173048	340282
22517	34212	1	applied	\N	\N	\N	\N	173049	173049	340283
22517	34213	2	applied	\N	\N	\N	\N	173050	173050	340284
22517	34214	3	applied	\N	\N	\N	\N	173051	173051	340285
22517	34215	4	applied	\N	\N	\N	\N	173052	173052	340286
22517	34216	5	applied	\N	\N	\N	\N	173053	173053	340287
22520	34226	0	applied	\N	\N	\N	\N	173072	173072	340306
22520	34227	1	applied	\N	\N	\N	\N	173073	173073	340307
22520	34228	2	applied	\N	\N	\N	\N	173074	173074	340308
22520	34229	3	applied	\N	\N	\N	\N	173075	173075	340309
22520	34230	4	applied	\N	\N	\N	\N	173076	173076	340310
22520	34231	5	applied	\N	\N	\N	\N	173077	173077	340311
22520	34232	6	applied	\N	\N	\N	\N	173078	173078	340312
22520	34233	7	applied	\N	\N	\N	\N	173079	173079	340313
22527	34264	0	applied	\N	\N	\N	\N	173123	173123	340357
22527	34265	1	applied	\N	\N	\N	\N	173124	173124	340358
22527	34266	2	applied	\N	\N	\N	\N	173125	173125	340359
22527	34267	3	applied	\N	\N	\N	\N	173126	173126	340360
22527	34268	4	applied	\N	\N	\N	\N	173127	173127	340361
22527	34269	5	applied	\N	\N	\N	\N	173128	173128	340362
22530	34270	0	applied	\N	\N	\N	\N	173142	173142	340376
22530	34271	1	applied	\N	\N	\N	\N	173143	173143	340377
22530	34272	2	applied	\N	\N	\N	\N	173144	173144	340378
22530	34266	3	applied	\N	\N	\N	\N	173145	173145	340379
22530	34273	4	applied	\N	\N	\N	\N	173146	173146	340380
22530	34274	5	applied	\N	\N	\N	\N	173147	173147	340381
22530	34268	6	applied	\N	\N	\N	\N	173148	173148	340382
22532	34277	0	applied	\N	\N	\N	\N	173158	173158	340392
22532	34278	1	applied	\N	\N	\N	\N	173159	173159	340393
22532	34279	2	applied	\N	\N	\N	\N	173160	173160	340394
22532	34281	5	applied	\N	\N	\N	\N	173162	173162	340396
22532	34282	6	applied	\N	\N	\N	\N	173163	173163	340397
22543	34322	0	applied	\N	\N	\N	\N	173225	173225	340459
22543	34323	1	applied	\N	\N	\N	\N	173226	173226	340460
22543	34324	2	applied	\N	\N	\N	\N	173227	173227	340461
22545	34325	0	applied	\N	\N	\N	\N	173230	173230	340464
22545	34326	1	applied	\N	\N	\N	\N	173231	173231	340465
22545	34324	2	applied	\N	\N	\N	\N	173232	173232	340466
22545	34327	3	applied	\N	\N	\N	\N	173233	173233	340467
22545	34328	4	applied	\N	\N	\N	\N	173234	173234	340468
22548	34329	0	applied	\N	\N	\N	\N	173248	173248	340482
22548	34330	1	applied	\N	\N	\N	\N	173249	173249	340483
22548	34331	2	applied	\N	\N	\N	\N	173250	173250	340484
22548	34332	3	applied	\N	\N	\N	\N	173251	173251	340485
22548	34333	4	applied	\N	\N	\N	\N	173252	173252	340486
22548	34334	5	applied	\N	\N	\N	\N	173253	173253	340487
22548	34336	7	applied	\N	\N	\N	\N	173255	173255	340489
22548	34337	8	applied	\N	\N	\N	\N	173256	173256	340490
22548	34338	9	applied	\N	\N	\N	\N	173257	173257	340491
22548	34339	10	applied	\N	\N	\N	\N	173258	173258	340492
22548	34340	11	applied	\N	\N	\N	\N	173259	173259	340493
22548	34341	12	applied	\N	\N	\N	\N	173260	173260	340494
22551	34349	0	applied	\N	\N	\N	\N	173268	173268	340502
22551	34350	1	applied	\N	\N	\N	\N	173269	173269	340503
22551	34351	2	applied	\N	\N	\N	\N	173270	173270	340504
22551	34352	3	applied	\N	\N	\N	\N	173271	173271	340505
22551	34353	4	applied	\N	\N	\N	\N	173272	173272	340506
22551	34354	5	applied	\N	\N	\N	\N	173273	173273	340507
22560	34362	0	applied	\N	\N	\N	\N	173300	173300	340534
22560	34363	1	applied	\N	\N	\N	\N	173301	173301	340535
22560	34364	2	applied	\N	\N	\N	\N	173302	173302	340536
22565	34376	0	applied	\N	\N	\N	\N	173320	173320	340554
22565	34378	2	applied	\N	\N	\N	\N	173322	173322	340556
22568	34379	0	applied	\N	\N	\N	\N	173338	173338	340572
22568	34380	1	applied	\N	\N	\N	\N	173339	173339	340573
22568	34381	2	applied	\N	\N	\N	\N	173340	173340	340574
22568	34382	3	applied	\N	\N	\N	\N	173341	173341	340575
22568	34383	4	applied	\N	\N	\N	\N	173342	173342	340576
22568	34384	5	applied	\N	\N	\N	\N	173343	173343	340577
22568	34385	6	applied	\N	\N	\N	\N	173344	173344	340578
22568	34386	7	applied	\N	\N	\N	\N	173345	173345	340579
22568	34387	8	applied	\N	\N	\N	\N	173346	173346	340580
22568	34388	9	applied	\N	\N	\N	\N	173347	173347	340581
22568	34389	10	applied	\N	\N	\N	\N	173348	173348	340582
22568	34390	11	applied	\N	\N	\N	\N	173349	173349	340583
22570	34394	0	applied	\N	\N	\N	\N	173353	173353	340587
22570	34395	1	applied	\N	\N	\N	\N	173354	173354	340588
22570	34396	2	applied	\N	\N	\N	\N	173355	173355	340589
22572	34395	1	applied	\N	\N	\N	\N	173360	173360	340594
22572	34396	2	applied	\N	\N	\N	\N	173361	173361	340595
22574	34397	0	applied	\N	\N	1000000000	\N	173372	173372	340606
22574	34398	1	applied	\N	\N	\N	\N	173373	173373	340607
22574	34399	2	applied	\N	\N	\N	\N	173374	173374	340608
22574	34400	3	applied	\N	\N	\N	\N	173375	173375	340609
22574	34401	4	applied	\N	\N	\N	\N	173376	173376	340610
22574	34402	5	applied	\N	\N	\N	\N	173377	173377	340611
22574	34403	6	applied	\N	\N	\N	\N	173378	173378	340612
22574	34404	7	applied	\N	\N	\N	\N	173379	173379	340613
22574	34405	8	applied	\N	\N	\N	\N	173380	173380	340614
22574	34406	9	applied	\N	\N	\N	\N	173381	173381	340615
22577	34410	0	applied	\N	\N	\N	\N	173402	173402	340636
22577	34411	1	applied	\N	\N	\N	\N	173403	173403	340637
22577	34416	2	applied	\N	\N	\N	\N	173404	173404	340638
22577	34412	3	applied	\N	\N	\N	\N	173405	173405	340639
22577	34417	5	applied	\N	\N	\N	\N	173407	173407	340641
22577	34414	6	applied	\N	\N	\N	\N	173408	173408	340642
22577	34418	7	applied	\N	\N	\N	\N	173409	173409	340643
22577	34419	8	applied	\N	\N	\N	\N	173410	173410	340644
22577	34420	9	applied	\N	\N	\N	\N	173411	173411	340645
22577	34415	10	applied	\N	\N	\N	\N	173412	173412	340646
22579	34421	0	applied	\N	\N	\N	\N	173424	173424	340658
22579	34422	1	applied	\N	\N	\N	\N	173425	173425	340659
22579	34423	2	applied	\N	\N	\N	\N	173426	173426	340660
22579	34424	3	applied	\N	\N	\N	\N	173427	173427	340661
22579	34425	4	applied	\N	\N	\N	\N	173428	173428	340662
22581	34426	0	applied	\N	\N	\N	\N	173433	173433	340667
22582	34430	0	applied	\N	\N	\N	\N	173558	173558	340792
22582	34431	1	applied	\N	\N	\N	\N	173559	173559	340793
22582	34432	2	applied	\N	\N	\N	\N	173560	173560	340794
22582	34433	3	applied	\N	\N	\N	\N	173561	173561	340795
22515	34210	3	applied	\N	\N	\N	\N	173043	173043	340277
22575	34408	1	applied	\N	\N	\N	\N	173383	173383	340617
22575	34409	2	applied	\N	\N	\N	\N	173384	173384	340618
22580	34426	0	applied	\N	\N	\N	\N	173429	173429	340663
22580	34427	1	applied	\N	\N	\N	\N	173430	173430	340664
22580	34428	2	applied	\N	\N	\N	\N	173431	173431	340665
22580	34429	3	applied	\N	\N	\N	\N	173432	173432	340666
22582	34434	4	applied	\N	\N	\N	\N	173562	173562	340796
22582	34435	5	applied	\N	\N	\N	\N	173563	173563	340797
22584	34436	0	applied	\N	\N	\N	\N	173573	173573	340807
22584	34437	1	applied	\N	\N	\N	\N	173574	173574	340808
22584	34438	2	applied	\N	\N	\N	\N	173575	173575	340809
22584	34439	3	applied	\N	\N	\N	\N	173576	173576	340810
22584	34440	4	applied	\N	\N	\N	\N	173577	173577	340811
22584	34441	5	applied	\N	\N	\N	\N	173578	173578	340812
22584	34442	6	applied	\N	\N	\N	\N	173579	173579	340813
22584	34443	7	applied	\N	\N	\N	\N	173580	173580	340814
22585	34436	0	applied	\N	\N	\N	\N	173582	173582	340816
22585	34437	1	applied	\N	\N	\N	\N	173583	173583	340817
22585	34438	2	applied	\N	\N	\N	\N	173584	173584	340818
22585	34439	3	applied	\N	\N	\N	\N	173585	173585	340819
22585	34440	4	applied	\N	\N	\N	\N	173586	173586	340820
22585	34441	5	applied	\N	\N	\N	\N	173587	173587	340821
22585	34442	6	applied	\N	\N	\N	\N	173588	173588	340822
22585	34443	7	applied	\N	\N	\N	\N	173589	173589	340823
22585	34444	8	applied	\N	\N	\N	\N	173590	173590	340824
22587	34445	0	applied	\N	\N	\N	\N	173595	173595	340829
22587	34446	1	applied	\N	\N	\N	\N	173596	173596	340830
22587	34447	2	applied	\N	\N	\N	\N	173597	173597	340831
22587	34448	3	applied	\N	\N	\N	\N	173598	173598	340832
22593	34472	0	applied	\N	\N	\N	\N	173637	173637	340870
22593	34471	1	applied	\N	\N	\N	\N	173638	173638	173638
22593	34473	2	applied	\N	\N	\N	\N	173639	173639	340871
22597	34475	0	applied	\N	\N	\N	\N	173653	173653	340883
22597	34476	1	applied	\N	\N	\N	\N	173654	173654	340884
22597	34477	2	applied	\N	\N	\N	\N	173655	173655	340885
22598	34478	0	applied	\N	\N	\N	\N	173656	173656	340886
22598	34479	1	applied	\N	\N	\N	\N	173657	173657	340887
22598	34480	2	applied	\N	\N	\N	\N	173658	173658	340888
22598	34481	3	applied	\N	\N	\N	\N	173659	173659	340889
22598	34482	4	applied	\N	\N	\N	\N	173660	173660	340890
22598	34483	5	applied	\N	\N	\N	\N	173661	173661	340891
22598	34484	6	applied	\N	\N	\N	\N	173662	173662	340892
22598	34485	7	applied	\N	\N	\N	\N	173663	173663	340893
22598	34486	8	applied	\N	\N	\N	\N	173664	173664	340894
22598	34487	9	applied	\N	\N	\N	\N	173665	173665	340895
22598	34488	10	applied	\N	\N	\N	\N	173666	173666	340896
22598	34489	11	applied	\N	\N	\N	\N	173667	173667	340897
22598	34490	12	applied	\N	\N	\N	\N	173668	173668	340898
22598	34492	14	applied	\N	\N	\N	\N	173670	173670	340900
22603	34497	0	applied	\N	\N	\N	\N	173707	173707	340937
22603	34498	1	applied	\N	\N	\N	\N	173708	173708	340938
22603	34499	2	applied	\N	\N	\N	\N	173709	173709	340939
22603	34500	3	applied	\N	\N	\N	\N	173710	173710	340940
22603	34501	4	applied	\N	\N	\N	\N	173711	173711	340941
22603	34502	5	applied	\N	\N	\N	\N	173712	173712	340942
22605	34503	0	applied	\N	\N	\N	\N	173715	173715	340945
22606	34503	0	applied	\N	\N	\N	\N	173717	173717	340947
22606	34504	1	applied	\N	\N	\N	\N	173718	173718	340948
22617	34521	0	applied	\N	\N	\N	\N	173772	173772	341002
22617	34522	1	applied	\N	\N	\N	\N	173773	173773	341003
22617	34523	2	applied	\N	\N	\N	\N	173774	173774	341004
22617	34524	3	applied	\N	\N	\N	\N	173775	173775	341005
22626	34532	0	applied	\N	\N	\N	\N	173807	173807	341037
22626	34534	1	applied	\N	\N	\N	\N	173808	173808	341038
22640	34559	0	applied	\N	\N	\N	\N	173871	173871	341101
22640	34560	1	applied	\N	\N	\N	\N	173872	173872	341102
22640	34561	2	applied	\N	\N	\N	\N	173873	173873	341103
22647	34565	0	applied	\N	\N	\N	\N	173895	173895	341125
22647	34566	1	applied	\N	\N	\N	\N	173896	173896	341126
22647	34567	2	applied	\N	\N	\N	\N	173897	173897	341127
22647	34568	3	applied	\N	\N	\N	\N	173898	173898	341128
22647	34569	4	applied	\N	\N	\N	\N	173899	173899	341129
22647	34570	5	applied	\N	\N	\N	\N	173900	173900	341130
22647	34571	6	applied	\N	\N	\N	\N	173901	173901	341131
22649	34572	0	applied	\N	\N	\N	\N	173909	173909	341139
22649	34573	1	applied	\N	\N	\N	\N	173910	173910	341140
22649	34574	2	applied	\N	\N	\N	\N	173911	173911	341141
22654	34578	0	applied	\N	\N	\N	\N	173925	173925	341155
22654	34580	1	applied	\N	\N	\N	\N	173926	173926	341156
22654	34581	2	applied	\N	\N	\N	\N	173927	173927	341157
22660	34586	1	applied	\N	\N	\N	\N	173944	173944	341174
22660	34587	2	applied	\N	\N	\N	\N	173945	173945	341175
22660	34588	3	applied	\N	\N	\N	\N	173946	173946	341176
22660	34589	4	applied	\N	\N	\N	\N	173947	173947	341177
22660	34590	5	applied	\N	\N	\N	\N	173948	173948	341178
22660	34591	6	applied	\N	\N	\N	\N	173949	173949	341179
22661	34592	0	applied	\N	\N	\N	\N	173950	173950	341180
22661	34593	1	applied	\N	\N	\N	\N	173951	173951	341181
22661	34594	2	applied	\N	\N	\N	\N	173952	173952	341182
22661	34595	3	applied	\N	\N	\N	\N	173953	173953	341183
22661	34596	4	applied	\N	\N	\N	\N	173954	173954	341184
22661	34597	5	applied	\N	\N	\N	\N	173955	173955	341185
22661	34598	6	applied	\N	\N	\N	\N	173956	173956	341186
22661	34599	7	applied	\N	\N	\N	\N	173957	173957	341187
22661	34600	8	applied	\N	\N	\N	\N	173958	173958	341188
22661	34601	9	applied	\N	\N	\N	\N	173959	173959	341189
22678	34639	1	applied	\N	\N	\N	\N	174020	174020	341250
22678	34640	2	applied	\N	\N	\N	\N	174021	174021	341251
22680	34641	0	applied	\N	\N	\N	\N	174025	174025	341255
22680	34642	1	applied	\N	\N	\N	\N	174026	174026	341256
22680	34643	2	applied	\N	\N	\N	\N	174027	174027	341257
22687	34654	0	applied	\N	\N	\N	\N	174052	174052	341282
22687	34655	1	applied	\N	\N	\N	\N	174053	174053	341283
22687	34656	2	applied	\N	\N	\N	\N	174054	174054	341284
22687	34657	3	applied	\N	\N	\N	\N	174055	174055	341285
22690	34660	0	applied	\N	\N	\N	\N	174062	174062	341292
22690	34661	1	applied	\N	\N	\N	\N	174063	174063	341293
22690	34662	2	applied	\N	\N	\N	\N	174064	174064	341294
22690	34663	3	applied	\N	\N	\N	\N	174065	174065	341295
22690	34664	4	applied	\N	\N	\N	\N	174066	174066	341296
22566	34377	1	applied	\N	\N	\N	\N	173324	173324	340558
22566	34378	2	applied	\N	\N	\N	\N	173325	173325	340559
22578	34419	8	applied	\N	\N	\N	\N	173421	173421	340655
22578	34420	9	applied	\N	\N	\N	\N	173422	173422	340656
22578	34415	10	applied	\N	\N	\N	\N	173423	173423	340657
22583	34436	0	applied	\N	\N	\N	\N	173564	173564	340798
22583	34437	1	applied	\N	\N	\N	\N	173565	173565	340799
22583	34438	2	applied	\N	\N	\N	\N	173566	173566	340800
22583	34439	3	applied	\N	\N	\N	\N	173567	173567	340801
22583	34440	4	applied	\N	\N	\N	\N	173568	173568	340802
22583	34441	5	applied	\N	\N	\N	\N	173569	173569	340803
22583	34442	6	applied	\N	\N	\N	\N	173570	173570	340804
22583	34443	7	applied	\N	\N	\N	\N	173571	173571	340805
22583	34444	8	applied	\N	\N	\N	\N	173572	173572	340806
22591	34455	0	applied	\N	\N	\N	\N	173605	173605	340839
22591	34456	1	applied	\N	\N	\N	\N	173606	173606	340840
22591	34457	2	applied	\N	\N	\N	\N	173607	173607	340841
22591	34458	3	applied	\N	\N	\N	\N	173608	173608	340842
22591	34460	5	applied	\N	\N	\N	\N	173610	173610	340844
22591	34461	6	applied	\N	\N	\N	\N	173611	173611	340845
22591	34462	7	applied	\N	\N	\N	\N	173612	173612	340846
22591	34463	8	applied	\N	\N	\N	\N	173613	173613	340847
22591	34464	9	applied	\N	\N	\N	\N	173614	173614	340848
22591	34465	10	applied	\N	\N	\N	\N	173615	173615	340849
22591	34466	11	applied	\N	\N	\N	\N	173616	173616	340850
22591	34467	12	applied	\N	\N	\N	\N	173617	173617	340851
22591	34468	13	applied	\N	\N	\N	\N	173618	173618	340852
22591	34469	14	applied	\N	\N	\N	\N	173619	173619	340853
22591	34470	15	applied	\N	\N	\N	\N	173620	173620	340854
22594	34472	0	applied	\N	\N	\N	\N	173641	173641	340873
22594	34471	1	applied	\N	\N	\N	\N	173642	173642	173642
22594	34473	2	applied	\N	\N	\N	\N	173643	173643	340874
22594	34474	3	applied	\N	\N	\N	\N	173644	173644	340875
22599	34478	0	applied	\N	\N	\N	\N	173671	173671	340901
22599	34480	2	applied	\N	\N	\N	\N	173673	173673	340903
22599	34481	3	applied	\N	\N	\N	\N	173674	173674	340904
22599	34482	4	applied	\N	\N	\N	\N	173675	173675	340905
22599	34483	5	applied	\N	\N	\N	\N	173676	173676	340906
22599	34484	6	applied	\N	\N	\N	\N	173677	173677	340907
22599	34485	7	applied	\N	\N	\N	\N	173678	173678	340908
22599	34486	8	applied	\N	\N	\N	\N	173679	173679	340909
22599	34487	9	applied	\N	\N	\N	\N	173680	173680	340910
22599	34488	10	applied	\N	\N	\N	\N	173681	173681	340911
22599	34489	11	applied	\N	\N	\N	\N	173682	173682	340912
22599	34490	12	applied	\N	\N	\N	\N	173683	173683	340913
22599	34491	13	applied	\N	\N	\N	\N	173684	173684	340914
22599	34492	14	applied	\N	\N	\N	\N	173685	173685	340915
22601	34493	0	applied	\N	\N	\N	\N	173697	173697	340927
22601	34494	1	applied	\N	\N	\N	\N	173698	173698	340928
22601	34495	2	applied	\N	\N	\N	\N	173699	173699	340929
22611	34515	0	applied	\N	\N	\N	\N	173744	173744	340974
22611	34516	1	applied	\N	\N	\N	\N	173745	173745	340975
22613	34518	0	applied	\N	\N	\N	\N	173752	173752	340982
22613	34519	1	applied	\N	\N	\N	\N	173753	173753	340983
22613	34512	2	applied	\N	\N	\N	\N	173754	173754	340984
22613	34513	3	applied	\N	\N	\N	\N	173755	173755	340985
22613	34514	4	applied	\N	\N	\N	\N	173756	173756	340986
22613	34517	5	applied	\N	\N	\N	\N	173757	173757	340987
22613	34520	6	applied	\N	\N	\N	\N	173758	173758	340988
22615	34521	0	applied	\N	\N	\N	\N	173766	173766	340996
22615	34522	1	applied	\N	\N	\N	\N	173767	173767	340997
22615	34523	2	applied	\N	\N	\N	\N	173768	173768	340998
22615	34524	3	applied	\N	\N	\N	\N	173769	173769	340999
22618	34521	0	applied	\N	\N	\N	\N	173776	173776	341006
22618	34522	1	applied	\N	\N	\N	\N	173777	173777	341007
22618	34524	2	applied	\N	\N	\N	\N	173778	173778	341008
22620	34526	1	applied	\N	\N	\N	\N	173784	173784	341014
22620	34527	2	applied	\N	\N	\N	\N	173785	173785	341015
22622	34528	0	applied	\N	\N	\N	\N	173791	173791	341021
22622	34529	1	applied	\N	\N	\N	\N	173792	173792	341022
22622	34530	2	applied	\N	\N	\N	\N	173793	173793	341023
22622	34531	3	applied	\N	\N	\N	\N	173794	173794	341024
22627	34536	0	applied	\N	\N	\N	\N	173810	173810	341040
22627	34537	1	applied	\N	\N	\N	\N	173811	173811	341041
22627	34538	2	applied	\N	\N	\N	\N	173812	173812	341042
22627	34539	3	applied	\N	\N	\N	\N	173813	173813	341043
22627	34540	4	applied	\N	\N	\N	\N	173814	173814	341044
22627	34541	5	applied	\N	\N	\N	\N	173815	173815	341045
22629	34542	0	applied	\N	\N	\N	\N	173822	173822	341052
22629	34543	1	applied	\N	\N	\N	\N	173823	173823	341053
22629	34544	2	applied	\N	\N	\N	\N	173824	173824	341054
22632	34545	0	applied	\N	\N	\N	\N	173833	173833	341063
22632	34547	2	applied	\N	\N	\N	\N	173835	173835	341065
22632	34548	3	applied	\N	\N	\N	\N	173836	173836	341066
22634	34549	0	applied	\N	\N	\N	\N	173841	173841	341071
22634	34550	1	applied	\N	\N	\N	\N	173842	173842	341072
22634	34551	2	applied	\N	\N	\N	\N	173843	173843	341073
22634	34552	3	applied	\N	\N	\N	\N	173844	173844	341074
22634	34553	4	applied	\N	\N	\N	\N	173845	173845	341075
22634	34554	5	applied	\N	\N	\N	\N	173846	173846	341076
22636	34549	0	applied	\N	\N	\N	\N	173853	173853	341083
22636	34550	1	applied	\N	\N	\N	\N	173854	173854	341084
22636	34551	2	applied	\N	\N	\N	\N	173855	173855	341085
22636	34552	3	applied	\N	\N	\N	\N	173856	173856	341086
22690	34665	5	applied	\N	\N	\N	\N	174067	174067	341297
22690	34666	6	applied	\N	\N	\N	\N	174068	174068	341298
22690	34667	7	applied	\N	\N	\N	\N	174069	174069	341299
22692	34668	0	applied	\N	\N	\N	\N	174078	174078	341308
22692	34670	2	applied	\N	\N	\N	\N	174080	174080	341310
22695	34671	0	applied	\N	\N	\N	\N	174093	174093	341323
22695	34672	1	applied	\N	\N	\N	\N	174094	174094	341324
22695	34673	2	applied	\N	\N	\N	\N	174095	174095	341325
22695	34674	3	applied	\N	\N	\N	\N	174096	174096	341326
22695	34675	4	applied	\N	\N	\N	\N	174097	174097	341327
22695	34676	5	applied	\N	\N	\N	\N	174098	174098	341328
22698	34686	0	applied	\N	\N	\N	\N	174112	174112	341342
22698	34687	1	applied	\N	\N	\N	\N	174113	174113	341343
22698	34688	2	applied	\N	\N	\N	\N	174114	174114	341344
22698	34689	3	applied	\N	\N	\N	\N	174115	174115	341345
22701	34686	0	applied	\N	\N	\N	\N	174124	174124	341354
22701	34687	1	applied	\N	\N	\N	\N	174125	174125	341355
22701	34688	2	applied	\N	\N	\N	\N	174126	174126	341356
22578	34417	5	applied	\N	\N	\N	\N	173418	173418	340652
22578	34414	6	applied	\N	\N	\N	\N	173419	173419	340653
22581	33984	5	applied	\N	\N	\N	\N	173438	173438	340672
22581	33985	6	applied	\N	\N	\N	\N	173439	173439	340673
22581	33990	7	applied	\N	\N	\N	\N	173440	173440	340674
22581	33993	8	applied	\N	\N	\N	\N	173441	173441	340675
22581	33996	9	applied	\N	\N	\N	\N	173442	173442	340676
22581	33999	10	applied	\N	\N	\N	\N	173443	173443	340677
22581	34003	11	applied	\N	\N	\N	\N	173444	173444	340678
22581	34006	12	applied	\N	\N	\N	\N	173445	173445	340679
22581	34009	13	applied	\N	\N	\N	\N	173446	173446	340680
22581	34013	14	applied	\N	\N	\N	\N	173447	173447	340681
22581	34236	15	applied	\N	\N	\N	\N	173448	173448	340682
22581	34237	16	applied	\N	\N	\N	\N	173449	173449	340683
22581	34238	17	applied	\N	\N	\N	\N	173450	173450	340684
22581	34239	18	applied	\N	\N	\N	\N	173451	173451	340685
22581	34016	19	applied	\N	\N	\N	\N	173452	173452	340686
22581	34017	20	applied	\N	\N	\N	\N	173453	173453	340687
22581	34038	22	applied	\N	\N	\N	\N	173455	173455	340689
22581	34039	23	applied	\N	\N	\N	\N	173456	173456	340690
22581	34043	24	applied	\N	\N	\N	\N	173457	173457	340691
22581	34044	25	applied	\N	\N	\N	\N	173458	173458	340692
22581	34045	26	applied	\N	\N	\N	\N	173459	173459	340693
22581	34046	27	applied	\N	\N	\N	\N	173460	173460	340694
22581	34047	28	applied	\N	\N	\N	\N	173461	173461	340695
22581	34048	29	applied	\N	\N	\N	\N	173462	173462	340696
22581	34052	30	applied	\N	\N	\N	\N	173463	173463	340697
22581	34053	31	applied	\N	\N	\N	\N	173464	173464	340698
22581	34054	32	applied	\N	\N	\N	\N	173465	173465	340699
22581	34055	33	applied	\N	\N	\N	\N	173466	173466	340700
22581	34056	34	applied	\N	\N	\N	\N	173467	173467	340701
22581	34059	35	applied	\N	\N	\N	\N	173468	173468	340702
22581	34060	36	applied	\N	\N	\N	\N	173469	173469	340703
22581	34061	37	applied	\N	\N	\N	\N	173470	173470	340704
22581	34064	39	applied	\N	\N	\N	\N	173472	173472	340706
22581	34065	40	applied	\N	\N	\N	\N	173473	173473	340707
22581	34066	41	applied	\N	\N	\N	\N	173474	173474	340708
22581	34067	42	applied	\N	\N	\N	\N	173475	173475	340709
22581	34068	43	applied	\N	\N	\N	\N	173476	173476	340710
22581	34069	44	applied	\N	\N	\N	\N	173477	173477	340711
22581	34070	45	applied	\N	\N	\N	\N	173478	173478	340712
22581	34071	46	applied	\N	\N	\N	\N	173479	173479	340713
22581	34078	47	applied	\N	\N	\N	\N	173480	173480	340714
22581	34079	48	applied	\N	\N	\N	\N	173481	173481	340715
22581	34080	50	applied	\N	\N	\N	\N	173482	173482	340716
22581	34081	51	applied	\N	\N	\N	\N	173483	173483	340717
22581	34082	52	applied	\N	\N	\N	\N	173484	173484	340718
22581	34083	53	applied	\N	\N	\N	\N	173485	173485	340719
22581	34088	54	applied	\N	\N	\N	\N	173486	173486	340720
22581	34089	55	applied	\N	\N	\N	\N	173487	173487	340721
22581	34091	57	applied	\N	\N	\N	\N	173489	173489	340723
22581	34093	58	applied	\N	\N	\N	\N	173490	173490	340724
22581	34094	59	applied	\N	\N	\N	\N	173491	173491	340725
22581	34095	60	applied	\N	\N	\N	\N	173492	173492	340726
22581	34096	61	applied	\N	\N	\N	\N	173493	173493	340727
22581	34097	62	applied	\N	\N	\N	\N	173494	173494	340728
22581	34098	63	applied	\N	\N	\N	\N	173495	173495	340729
22581	34099	64	applied	\N	\N	\N	\N	173496	173496	340730
22581	34100	65	applied	\N	\N	\N	\N	173497	173497	340731
22581	34106	66	applied	\N	\N	\N	\N	173498	173498	340732
22581	34107	67	applied	\N	\N	\N	\N	173499	173499	340733
22581	34108	68	applied	\N	\N	\N	\N	173500	173500	340734
22581	34109	69	applied	\N	\N	\N	\N	173501	173501	340735
22581	34110	70	applied	\N	\N	\N	\N	173502	173502	340736
22581	34111	71	applied	\N	\N	\N	\N	173503	173503	340737
22581	34116	72	applied	\N	\N	\N	\N	173504	173504	340738
22581	34126	74	applied	\N	\N	\N	\N	173506	173506	340740
22581	34130	75	applied	\N	\N	\N	\N	173507	173507	340741
22581	34131	76	applied	\N	\N	\N	\N	173508	173508	340742
22581	34132	77	applied	\N	\N	\N	\N	173509	173509	340743
22581	34133	78	applied	\N	\N	\N	\N	173510	173510	340744
22581	34134	79	applied	\N	\N	\N	\N	173511	173511	340745
22581	34135	80	applied	\N	\N	\N	\N	173512	173512	340746
22581	34136	81	applied	\N	\N	\N	\N	173513	173513	340747
22581	34137	82	applied	\N	\N	\N	\N	173514	173514	340748
22581	34138	83	applied	\N	\N	\N	\N	173515	173515	340749
22581	34139	84	applied	\N	\N	\N	\N	173516	173516	340750
22581	34140	85	applied	\N	\N	\N	\N	173517	173517	340751
22581	34141	86	applied	\N	\N	\N	\N	173518	173518	340752
22581	34142	87	applied	\N	\N	\N	\N	173519	173519	340753
22581	34143	88	applied	\N	\N	\N	\N	173520	173520	340754
22581	34144	89	applied	\N	\N	\N	\N	173521	173521	340755
22581	34146	91	applied	\N	\N	\N	\N	173523	173523	340757
22581	34154	92	applied	\N	\N	\N	\N	173524	173524	340758
22581	34155	93	applied	\N	\N	\N	\N	173525	173525	340759
22581	34156	94	applied	\N	\N	\N	\N	173526	173526	340760
22581	34157	95	applied	\N	\N	\N	\N	173527	173527	340761
22581	34158	96	applied	\N	\N	\N	\N	173528	173528	340762
22581	34159	97	applied	\N	\N	\N	\N	173529	173529	340763
22581	34164	98	applied	\N	\N	\N	\N	173530	173530	340764
22581	34023	99	applied	\N	\N	\N	\N	173531	173531	340765
22581	34024	100	applied	\N	\N	\N	\N	173532	173532	340766
22581	34025	101	applied	\N	\N	\N	\N	173533	173533	340767
22581	34026	102	applied	\N	\N	\N	\N	173534	173534	340768
22636	34553	4	applied	\N	\N	\N	\N	173857	173857	341087
22636	34554	5	applied	\N	\N	\N	\N	173858	173858	341088
22638	34555	0	applied	\N	\N	\N	\N	173863	173863	341093
22638	34556	1	applied	\N	\N	\N	\N	173864	173864	341094
22638	34558	3	applied	\N	\N	\N	\N	173866	173866	341096
22641	34559	0	applied	\N	\N	\N	\N	173874	173874	341104
22641	34560	1	applied	\N	\N	\N	\N	173875	173875	341105
22641	34561	2	applied	\N	\N	\N	\N	173876	173876	341106
22643	34562	0	applied	\N	\N	\N	\N	173880	173880	341110
22643	34563	1	applied	\N	\N	\N	\N	173881	173881	341111
22643	34564	2	applied	\N	\N	\N	\N	173882	173882	341112
22645	34562	0	applied	\N	\N	\N	\N	173886	173886	341116
22645	34564	1	applied	\N	\N	\N	\N	173887	173887	341117
22656	34582	0	applied	\N	\N	\N	\N	173932	173932	341162
22656	34583	1	applied	\N	\N	\N	\N	173933	173933	341163
22656	34584	2	applied	\N	\N	\N	\N	173934	173934	341164
22659	34582	0	applied	\N	\N	\N	\N	173941	173941	341171
22659	34583	1	applied	\N	\N	\N	\N	173942	173942	341172
22581	33974	2	applied	\N	\N	\N	\N	173435	173435	340669
22581	33977	3	applied	\N	\N	\N	\N	173436	173436	340670
22581	34072	107	applied	\N	\N	\N	\N	173539	173539	340773
22581	34077	108	applied	\N	\N	\N	\N	173540	173540	340774
22581	34087	109	applied	\N	\N	\N	\N	173541	173541	340775
22581	34092	110	applied	\N	\N	\N	\N	173542	173542	340776
22581	34105	111	applied	\N	\N	\N	\N	173543	173543	340777
22581	34114	112	applied	\N	\N	\N	\N	173544	173544	340778
22581	34115	113	applied	\N	\N	\N	\N	173545	173545	340779
22581	34122	114	applied	\N	\N	\N	\N	173546	173546	340780
22581	34127	115	applied	\N	\N	\N	\N	173547	173547	340781
22581	34128	116	applied	\N	\N	\N	\N	173548	173548	340782
22581	34129	117	applied	\N	\N	\N	\N	173549	173549	340783
22581	34153	118	applied	\N	\N	\N	\N	173550	173550	340784
22581	34162	119	applied	\N	\N	\N	\N	173551	173551	340785
22581	34163	120	applied	\N	\N	\N	\N	173552	173552	340786
22581	34190	122	applied	\N	\N	\N	\N	173554	173554	340788
22581	34200	123	applied	\N	\N	\N	\N	173555	173555	340789
22581	34204	124	applied	\N	\N	\N	\N	173556	173556	340790
22581	34207	125	applied	\N	\N	\N	\N	173557	173557	340791
22586	34445	0	applied	\N	\N	\N	\N	173591	173591	340825
22586	34446	1	applied	\N	\N	\N	\N	173592	173592	340826
22586	34447	2	applied	\N	\N	\N	\N	173593	173593	340827
22586	34448	3	applied	\N	\N	\N	\N	173594	173594	340828
22588	34449	0	applied	\N	\N	\N	\N	173599	173599	340833
22588	34450	1	applied	\N	\N	\N	\N	173600	173600	340834
22588	34451	2	applied	\N	\N	\N	\N	173601	173601	340835
22589	34452	0	applied	\N	\N	\N	\N	173602	173602	340836
22589	34453	1	applied	\N	\N	\N	\N	173603	173603	340837
22589	34454	2	applied	\N	\N	\N	\N	173604	173604	340838
22592	34426	0	applied	\N	\N	\N	\N	173621	173621	340855
22592	34283	1	applied	\N	\N	\N	\N	173622	173622	340856
22592	34284	3	applied	\N	\N	\N	\N	173624	173624	340857
22592	34285	4	applied	\N	\N	\N	\N	173625	173625	340858
22592	34286	5	applied	\N	\N	\N	\N	173626	173626	340859
22592	34289	6	applied	\N	\N	\N	\N	173627	173627	340860
22592	34290	7	applied	\N	\N	\N	\N	173628	173628	340861
22592	34296	8	applied	\N	\N	\N	\N	173629	173629	340862
22592	34307	9	applied	\N	\N	\N	\N	173630	173630	340863
22592	34311	10	applied	\N	\N	\N	\N	173631	173631	340864
22592	34368	11	applied	\N	\N	1000000000	\N	173632	173632	340865
22592	34383	12	applied	\N	\N	\N	\N	173633	173633	340866
22592	34406	13	applied	\N	\N	\N	\N	173634	173634	340867
22592	34386	15	applied	\N	\N	\N	\N	173635	173635	340868
22592	34387	16	applied	\N	\N	\N	\N	173636	173636	340869
22595	34472	0	applied	\N	\N	\N	\N	173645	173645	340876
22595	34471	1	applied	\N	\N	\N	\N	173646	173646	173646
22595	34475	2	applied	\N	\N	\N	\N	173647	173647	340877
22595	34474	4	applied	\N	\N	\N	\N	173649	173649	340879
22596	34475	0	applied	\N	\N	\N	\N	173650	173650	340880
22596	34476	1	applied	\N	\N	\N	\N	173651	173651	340881
22596	34477	2	applied	\N	\N	\N	\N	173652	173652	340882
22600	34478	0	applied	\N	\N	\N	\N	173686	173686	340916
22600	34479	1	applied	\N	\N	\N	\N	173687	173687	340917
22600	34480	2	applied	\N	\N	\N	\N	173688	173688	340918
22600	34481	3	applied	\N	\N	\N	\N	173689	173689	340919
22600	34482	4	applied	\N	\N	\N	\N	173690	173690	340920
22600	34483	5	applied	\N	\N	\N	\N	173691	173691	340921
22600	34484	6	applied	\N	\N	\N	\N	173692	173692	340922
22600	34486	7	applied	\N	\N	\N	\N	173693	173693	340923
22600	34487	8	applied	\N	\N	\N	\N	173694	173694	340924
22600	34488	9	applied	\N	\N	\N	\N	173695	173695	340925
22600	34489	10	applied	\N	\N	\N	\N	173696	173696	340926
22602	34497	0	applied	\N	\N	\N	\N	173701	173701	340931
22602	34499	2	applied	\N	\N	\N	\N	173703	173703	340933
22602	34500	3	applied	\N	\N	\N	\N	173704	173704	340934
22602	34501	4	applied	\N	\N	\N	\N	173705	173705	340935
22602	34502	5	applied	\N	\N	\N	\N	173706	173706	340936
22604	34503	0	applied	\N	\N	\N	\N	173713	173713	340943
22604	34504	1	applied	\N	\N	\N	\N	173714	173714	340944
22607	34505	0	applied	\N	\N	\N	\N	173719	173719	340949
22607	34506	1	applied	\N	\N	\N	\N	173720	173720	340950
22607	34507	2	applied	\N	\N	\N	\N	173721	173721	340951
22607	34508	3	applied	\N	\N	\N	\N	173722	173722	340952
22607	34509	4	applied	\N	\N	\N	\N	173723	173723	340953
22607	34510	5	applied	\N	\N	\N	\N	173724	173724	340954
22607	34511	6	applied	\N	\N	\N	\N	173725	173725	340955
22609	34515	0	applied	\N	\N	\N	\N	173736	173736	340966
22609	34516	1	applied	\N	\N	\N	\N	173737	173737	340967
22609	34512	2	applied	\N	\N	\N	\N	173738	173738	340968
22609	34514	4	applied	\N	\N	\N	\N	173740	173740	340970
22609	34517	5	applied	\N	\N	\N	\N	173741	173741	340971
22612	34515	0	applied	\N	\N	\N	\N	173746	173746	340976
22612	34516	1	applied	\N	\N	\N	\N	173747	173747	340977
22612	34512	2	applied	\N	\N	\N	\N	173748	173748	340978
22612	34513	3	applied	\N	\N	\N	\N	173749	173749	340979
22612	34514	4	applied	\N	\N	\N	\N	173750	173750	340980
22612	34517	5	applied	\N	\N	\N	\N	173751	173751	340981
22614	34518	0	applied	\N	\N	\N	\N	173759	173759	340989
22614	34519	1	applied	\N	\N	\N	\N	173760	173760	340990
22614	34512	2	applied	\N	\N	\N	\N	173761	173761	340991
22614	34513	3	applied	\N	\N	\N	\N	173762	173762	340992
22614	34514	4	applied	\N	\N	\N	\N	173763	173763	340993
22614	34517	5	applied	\N	\N	\N	\N	173764	173764	340994
22614	34520	6	applied	\N	\N	\N	\N	173765	173765	340995
22623	34532	0	applied	\N	\N	\N	\N	173795	173795	341025
22623	34534	2	applied	\N	\N	\N	\N	173797	173797	341027
22623	34535	3	applied	\N	\N	\N	\N	173798	173798	341028
22625	34532	0	applied	\N	\N	\N	\N	173803	173803	341033
22625	34533	1	applied	\N	\N	\N	\N	173804	173804	341034
22625	34534	2	applied	\N	\N	\N	\N	173805	173805	341035
22625	34535	3	applied	\N	\N	\N	\N	173806	173806	341036
22628	34536	0	applied	\N	\N	\N	\N	173816	173816	341046
22628	34537	1	applied	\N	\N	\N	\N	173817	173817	341047
22628	34538	2	applied	\N	\N	\N	\N	173818	173818	341048
22628	34539	3	applied	\N	\N	\N	\N	173819	173819	341049
22628	34540	4	applied	\N	\N	\N	\N	173820	173820	341050
22628	34541	5	applied	\N	\N	\N	\N	173821	173821	341051
22630	34545	0	applied	\N	\N	\N	\N	173825	173825	341055
22630	34546	1	applied	\N	\N	\N	\N	173826	173826	341056
22630	34547	2	applied	\N	\N	\N	\N	173827	173827	341057
22630	34548	3	applied	\N	\N	\N	\N	173828	173828	341058
22581	34062	106	applied	\N	\N	\N	\N	173538	173538	340772
22608	34508	3	applied	\N	\N	\N	\N	173729	173729	340959
22608	34509	4	applied	\N	\N	\N	\N	173730	173730	340960
22608	34510	5	applied	\N	\N	\N	\N	173731	173731	340961
22608	34511	6	applied	\N	\N	\N	\N	173732	173732	340962
22608	34512	7	applied	\N	\N	\N	\N	173733	173733	340963
22608	34513	8	applied	\N	\N	\N	\N	173734	173734	340964
22608	34514	9	applied	\N	\N	\N	\N	173735	173735	340965
22610	34515	0	applied	\N	\N	\N	\N	173742	173742	340972
22610	34516	1	applied	\N	\N	\N	\N	173743	173743	340973
22616	34522	0	applied	\N	\N	\N	\N	173770	173770	341000
22616	34524	1	applied	\N	\N	\N	\N	173771	173771	341001
22619	34521	0	applied	\N	\N	\N	\N	173779	173779	341009
22619	34522	1	applied	\N	\N	\N	\N	173780	173780	341010
22619	34523	2	applied	\N	\N	\N	\N	173781	173781	341011
22619	34524	3	applied	\N	\N	\N	\N	173782	173782	341012
22621	34521	0	applied	\N	\N	\N	\N	173786	173786	341016
22621	34523	2	applied	\N	\N	\N	\N	173788	173788	341018
22621	34526	3	applied	\N	\N	\N	\N	173789	173789	341019
22621	34527	4	applied	\N	\N	\N	\N	173790	173790	341020
22624	34532	0	applied	\N	\N	\N	\N	173799	173799	341029
22624	34533	1	applied	\N	\N	\N	\N	173800	173800	341030
22624	34534	2	applied	\N	\N	\N	\N	173801	173801	341031
22624	34535	3	applied	\N	\N	\N	\N	173802	173802	341032
22631	34545	0	applied	\N	\N	\N	\N	173829	173829	341059
22631	34546	1	applied	\N	\N	\N	\N	173830	173830	341060
22631	34547	2	applied	\N	\N	\N	\N	173831	173831	341061
22631	34548	3	applied	\N	\N	\N	\N	173832	173832	341062
22633	34545	0	applied	\N	\N	\N	\N	173837	173837	341067
22633	34546	1	applied	\N	\N	\N	\N	173838	173838	341068
22633	34547	2	applied	\N	\N	\N	\N	173839	173839	341069
22633	34548	3	applied	\N	\N	\N	\N	173840	173840	341070
22635	34549	0	applied	\N	\N	\N	\N	173847	173847	341077
22635	34551	2	applied	\N	\N	\N	\N	173849	173849	341079
22635	34552	3	applied	\N	\N	\N	\N	173850	173850	341080
22635	34553	4	applied	\N	\N	\N	\N	173851	173851	341081
22635	34554	5	applied	\N	\N	\N	\N	173852	173852	341082
22637	34555	0	applied	\N	\N	\N	\N	173859	173859	341089
22637	34556	1	applied	\N	\N	\N	\N	173860	173860	341090
22637	34557	2	applied	\N	\N	\N	\N	173861	173861	341091
22637	34558	3	applied	\N	\N	\N	\N	173862	173862	341092
22639	34555	0	applied	\N	\N	\N	\N	173867	173867	341097
22639	34556	1	applied	\N	\N	\N	\N	173868	173868	341098
22639	34557	2	applied	\N	\N	\N	\N	173869	173869	341099
22639	34558	3	applied	\N	\N	\N	\N	173870	173870	341100
22642	34562	0	applied	\N	\N	\N	\N	173877	173877	341107
22642	34563	1	applied	\N	\N	\N	\N	173878	173878	341108
22642	34564	2	applied	\N	\N	\N	\N	173879	173879	341109
22644	34562	0	applied	\N	\N	\N	\N	173883	173883	341113
22644	34564	2	applied	\N	\N	\N	\N	173885	173885	341115
22646	34565	0	applied	\N	\N	\N	\N	173888	173888	341118
22646	34566	1	applied	\N	\N	\N	\N	173889	173889	341119
22646	34567	2	applied	\N	\N	\N	\N	173890	173890	341120
22646	34568	3	applied	\N	\N	\N	\N	173891	173891	341121
22646	34569	4	applied	\N	\N	\N	\N	173892	173892	341122
22646	34570	5	applied	\N	\N	\N	\N	173893	173893	341123
22646	34571	6	applied	\N	\N	\N	\N	173894	173894	341124
22648	34565	0	applied	\N	\N	\N	\N	173902	173902	341132
22648	34566	1	applied	\N	\N	\N	\N	173903	173903	341133
22648	34567	2	applied	\N	\N	\N	\N	173904	173904	341134
22648	34568	3	applied	\N	\N	\N	\N	173905	173905	341135
22648	34569	4	applied	\N	\N	\N	\N	173906	173906	341136
22648	34570	5	applied	\N	\N	\N	\N	173907	173907	341137
22648	34571	6	applied	\N	\N	\N	\N	173908	173908	341138
22650	34575	0	applied	\N	\N	\N	\N	173912	173912	341142
22651	34576	1	applied	\N	\N	\N	\N	173916	173916	341146
22651	34577	2	applied	\N	\N	\N	\N	173917	173917	341147
22653	34578	0	applied	\N	\N	\N	\N	173921	173921	341151
22653	34579	1	applied	\N	\N	\N	\N	173922	173922	341152
22653	34580	2	applied	\N	\N	\N	\N	173923	173923	341153
22653	34581	3	applied	\N	\N	\N	\N	173924	173924	341154
22655	34578	0	applied	\N	\N	\N	\N	173928	173928	341158
22655	34579	1	applied	\N	\N	\N	\N	173929	173929	341159
22655	34580	2	applied	\N	\N	\N	\N	173930	173930	341160
22655	34581	3	applied	\N	\N	\N	\N	173931	173931	341161
22658	34582	0	applied	\N	\N	\N	\N	173938	173938	341168
22658	34583	1	applied	\N	\N	\N	\N	173939	173939	341169
22658	34584	2	applied	\N	\N	\N	\N	173940	173940	341170
22663	34602	0	applied	\N	\N	\N	\N	173970	173970	341200
22663	34603	1	applied	\N	\N	\N	\N	173971	173971	341201
22663	34604	2	applied	\N	\N	\N	\N	173972	173972	341202
22663	34606	4	applied	\N	\N	\N	\N	173974	173974	341204
22663	34607	5	applied	\N	\N	\N	\N	173975	173975	341205
22663	34608	6	applied	\N	\N	\N	\N	173976	173976	341206
22663	34609	7	applied	\N	\N	\N	\N	173977	173977	341207
22663	34610	8	applied	\N	\N	\N	\N	173978	173978	341208
22668	34611	0	applied	\N	\N	\N	\N	173983	173983	341213
22668	34612	1	applied	\N	\N	\N	\N	173984	173984	341214
22668	34613	2	applied	\N	\N	\N	\N	173985	173985	341215
22668	34614	3	applied	\N	\N	\N	\N	173986	173986	341216
22670	34615	0	applied	\N	\N	\N	\N	173990	173990	341220
22670	34616	1	applied	\N	\N	\N	\N	173991	173991	341221
22670	34617	2	applied	\N	\N	\N	\N	173992	173992	341222
22673	34625	0	applied	\N	\N	\N	\N	174003	174003	341233
22673	34626	1	applied	\N	\N	\N	\N	174004	174004	341234
22673	34627	2	applied	\N	\N	\N	\N	174005	174005	341235
22675	34631	0	applied	\N	\N	\N	\N	174009	174009	341239
22675	34633	2	applied	\N	\N	\N	\N	174011	174011	341241
22675	34634	3	applied	\N	\N	\N	\N	174012	174012	341242
22685	34651	0	applied	\N	\N	\N	\N	174045	174045	341275
22685	34652	1	applied	\N	\N	\N	\N	174046	174046	341276
22685	34653	2	applied	\N	\N	\N	\N	174047	174047	341277
22689	34658	0	applied	\N	\N	\N	\N	174060	174060	341290
22689	34659	1	applied	\N	\N	\N	\N	174061	174061	341291
22694	34671	0	applied	\N	\N	\N	\N	174087	174087	341317
22694	34672	1	applied	\N	\N	\N	\N	174088	174088	341318
22694	34673	2	applied	\N	\N	\N	\N	174089	174089	341319
22694	34674	3	applied	\N	\N	\N	\N	174090	174090	341320
22694	34675	4	applied	\N	\N	\N	\N	174091	174091	341321
22694	34676	5	applied	\N	\N	\N	\N	174092	174092	341322
22697	34686	0	applied	\N	\N	\N	\N	174108	174108	341338
22608	34505	0	applied	\N	\N	\N	\N	173726	173726	340956
22608	34506	1	applied	\N	\N	\N	\N	173727	173727	340957
22652	34577	2	applied	\N	\N	\N	\N	173920	173920	341150
22657	34582	0	applied	\N	\N	\N	\N	173935	173935	341165
22657	34583	1	applied	\N	\N	\N	\N	173936	173936	341166
22657	34584	2	applied	\N	\N	\N	\N	173937	173937	341167
22662	34592	0	applied	\N	\N	\N	\N	173960	173960	341190
22662	34593	1	applied	\N	\N	\N	\N	173961	173961	341191
22662	34594	2	applied	\N	\N	\N	\N	173962	173962	341192
22662	34595	3	applied	\N	\N	\N	\N	173963	173963	341193
22662	34596	4	applied	\N	\N	\N	\N	173964	173964	341194
22662	34597	5	applied	\N	\N	\N	\N	173965	173965	341195
22662	34598	6	applied	\N	\N	\N	\N	173966	173966	341196
22662	34599	7	applied	\N	\N	\N	\N	173967	173967	341197
22662	34600	8	applied	\N	\N	\N	\N	173968	173968	341198
22662	34601	9	applied	\N	\N	\N	\N	173969	173969	341199
22667	34611	0	applied	\N	\N	\N	\N	173979	173979	341209
22667	34612	1	applied	\N	\N	\N	\N	173980	173980	341210
22667	34614	3	applied	\N	\N	\N	\N	173982	173982	341212
22669	34615	0	applied	\N	\N	\N	\N	173987	173987	341217
22669	34616	1	applied	\N	\N	\N	\N	173988	173988	341218
22669	34617	2	applied	\N	\N	\N	\N	173989	173989	341219
22672	34625	0	applied	\N	\N	\N	\N	174000	174000	341230
22672	34626	1	applied	\N	\N	\N	\N	174001	174001	341231
22672	34627	2	applied	\N	\N	\N	\N	174002	174002	341232
22674	34628	0	applied	\N	\N	\N	\N	174006	174006	341236
22674	34629	1	applied	\N	\N	\N	\N	174007	174007	341237
22674	34630	2	applied	\N	\N	\N	\N	174008	174008	341238
22677	34635	0	applied	\N	\N	\N	\N	174016	174016	341246
22677	34636	1	applied	\N	\N	\N	\N	174017	174017	341247
22677	34637	2	applied	\N	\N	\N	\N	174018	174018	341248
22679	34638	0	applied	\N	\N	\N	\N	174022	174022	341252
22679	34639	1	applied	\N	\N	\N	\N	174023	174023	341253
22679	34640	2	applied	\N	\N	\N	\N	174024	174024	341254
22682	34645	1	applied	\N	\N	\N	\N	174036	174036	341266
22682	34646	2	applied	\N	\N	\N	\N	174037	174037	341267
22682	34647	3	applied	\N	\N	\N	\N	174038	174038	341268
22682	34648	4	applied	\N	\N	\N	\N	174039	174039	341269
22682	34649	5	applied	\N	\N	\N	\N	174040	174040	341270
22682	34650	6	applied	\N	\N	\N	\N	174041	174041	341271
22684	34651	0	applied	\N	\N	\N	\N	174042	174042	341272
22684	34652	1	applied	\N	\N	\N	\N	174043	174043	341273
22684	34653	2	applied	\N	\N	\N	\N	174044	174044	341274
22686	34654	0	applied	\N	\N	\N	\N	174048	174048	341278
22686	34655	1	applied	\N	\N	\N	\N	174049	174049	341279
22686	34656	2	applied	\N	\N	\N	\N	174050	174050	341280
22686	34657	3	applied	\N	\N	\N	\N	174051	174051	341281
22697	34687	1	applied	\N	\N	\N	\N	174109	174109	341339
22697	34688	2	applied	\N	\N	\N	\N	174110	174110	341340
22697	34689	3	applied	\N	\N	\N	\N	174111	174111	341341
22700	34687	1	applied	\N	\N	\N	\N	174121	174121	341351
22700	34688	2	applied	\N	\N	\N	\N	174122	174122	341352
22700	34689	3	applied	\N	\N	\N	\N	174123	174123	341353
22704	34696	0	applied	\N	\N	\N	\N	174140	174140	341370
22704	34697	1	applied	\N	\N	\N	\N	174141	174141	341371
22704	34698	2	applied	\N	\N	\N	\N	174142	174142	341372
22704	34699	3	applied	\N	\N	\N	\N	174143	174143	341373
22704	34700	4	applied	\N	\N	\N	\N	174144	174144	341374
22704	34701	5	applied	\N	\N	\N	\N	174145	174145	341375
22704	34702	6	applied	\N	\N	\N	\N	174146	174146	341376
22706	34703	0	applied	\N	\N	\N	\N	174154	174154	341384
22706	34704	1	applied	\N	\N	\N	\N	174155	174155	341385
22707	34703	0	applied	\N	\N	\N	\N	174156	174156	341386
22707	34704	1	applied	\N	\N	\N	\N	174157	174157	341387
22708	34703	0	applied	\N	\N	\N	\N	174158	174158	341388
22708	34704	1	applied	\N	\N	\N	\N	174159	174159	341389
22709	34706	1	applied	\N	\N	\N	\N	174161	174161	341391
22709	34707	2	applied	\N	\N	\N	\N	174162	174162	341392
22711	34710	0	applied	\N	\N	\N	\N	174170	174170	341400
22711	34711	1	applied	\N	\N	\N	\N	174171	174171	341401
22711	34712	2	applied	\N	\N	\N	\N	174172	174172	341402
22711	34713	3	applied	\N	\N	\N	\N	174173	174173	341403
22711	34714	4	applied	\N	\N	\N	\N	174174	174174	341404
22711	34715	5	applied	\N	\N	\N	\N	174175	174175	341405
22713	34710	0	applied	\N	\N	\N	\N	174182	174182	341412
22713	34711	1	applied	\N	\N	\N	\N	174183	174183	341413
22713	34712	2	applied	\N	\N	\N	\N	174184	174184	341414
22713	34713	3	applied	\N	\N	\N	\N	174185	174185	341415
22713	34714	4	applied	\N	\N	\N	\N	174186	174186	341416
22713	34715	5	applied	\N	\N	\N	\N	174187	174187	341417
22716	34722	0	applied	\N	\N	\N	\N	174194	174194	341424
22716	34723	1	applied	\N	\N	\N	\N	174195	174195	341425
22723	34729	0	applied	\N	\N	\N	\N	174209	174209	341439
22723	34728	1	applied	\N	\N	\N	\N	174210	174210	341440
22723	34730	2	applied	\N	\N	\N	\N	174211	174211	341441
22723	34731	3	applied	\N	\N	\N	\N	174212	174212	341442
22726	34734	0	applied	\N	\N	\N	\N	174219	174219	341449
22726	34735	1	applied	\N	\N	\N	\N	174220	174220	341450
22726	34736	2	applied	\N	\N	\N	\N	174221	174221	341451
22726	34737	3	applied	\N	\N	\N	\N	174222	174222	341452
22731	34744	0	applied	\N	\N	\N	\N	174235	174235	341465
22731	34745	1	applied	\N	\N	\N	\N	174236	174236	341466
22731	34746	2	applied	\N	\N	\N	\N	174237	174237	341467
22737	34753	0	applied	\N	\N	\N	\N	174258	174258	341488
22737	34754	1	applied	\N	\N	\N	\N	174259	174259	341489
22737	34755	2	applied	\N	\N	\N	\N	174260	174260	341490
22737	34756	3	applied	\N	\N	\N	\N	174261	174261	341491
22737	34757	4	applied	\N	\N	\N	\N	174262	174262	341492
22737	34759	6	applied	\N	\N	\N	\N	174264	174264	341494
22737	34760	7	applied	\N	\N	\N	\N	174265	174265	341495
22737	34761	8	applied	\N	\N	\N	\N	174266	174266	341496
22737	34762	9	applied	\N	\N	\N	\N	174267	174267	341497
22737	34763	10	applied	\N	\N	\N	\N	174268	174268	341498
22737	34764	11	applied	\N	\N	\N	\N	174269	174269	341499
22737	34765	12	applied	\N	\N	\N	\N	174270	174270	341500
22737	34766	13	applied	\N	\N	\N	\N	174271	174271	341501
22740	34773	0	applied	\N	\N	\N	\N	174282	174282	341512
22740	34774	1	applied	\N	\N	\N	\N	174283	174283	341513
22740	34775	2	applied	\N	\N	\N	\N	174284	174284	341514
22740	34776	3	applied	\N	\N	\N	\N	174285	174285	341515
22742	34781	0	applied	\N	\N	\N	\N	174290	174290	341520
22742	34782	1	applied	\N	\N	\N	\N	174291	174291	341521
22650	34577	2	applied	\N	\N	\N	\N	173914	173914	341144
22652	34575	0	applied	\N	\N	\N	\N	173918	173918	341148
22671	34622	4	applied	\N	\N	\N	\N	173997	173997	341227
22671	34623	5	applied	\N	\N	\N	\N	173998	173998	341228
22671	34624	6	applied	\N	\N	\N	\N	173999	173999	341229
22676	34635	0	applied	\N	\N	\N	\N	174013	174013	341243
22676	34636	1	applied	\N	\N	\N	\N	174014	174014	341244
22676	34637	2	applied	\N	\N	\N	\N	174015	174015	341245
22681	34644	0	applied	\N	\N	\N	\N	174028	174028	341258
22681	34645	1	applied	\N	\N	\N	\N	174029	174029	341259
22681	34646	2	applied	\N	\N	\N	\N	174030	174030	341260
22681	34647	3	applied	\N	\N	\N	\N	174031	174031	341261
22681	34648	4	applied	\N	\N	\N	\N	174032	174032	341262
22681	34649	5	applied	\N	\N	\N	\N	174033	174033	341263
22681	34650	6	applied	\N	\N	\N	\N	174034	174034	341264
22688	34654	0	applied	\N	\N	\N	\N	174056	174056	341286
22688	34655	1	applied	\N	\N	\N	\N	174057	174057	341287
22688	34656	2	applied	\N	\N	\N	\N	174058	174058	341288
22691	34660	0	applied	\N	\N	\N	\N	174070	174070	341300
22691	34661	1	applied	\N	\N	\N	\N	174071	174071	341301
22691	34662	2	applied	\N	\N	\N	\N	174072	174072	341302
22691	34663	3	applied	\N	\N	\N	\N	174073	174073	341303
22691	34664	4	applied	\N	\N	\N	\N	174074	174074	341304
22691	34665	5	applied	\N	\N	\N	\N	174075	174075	341305
22691	34666	6	applied	\N	\N	\N	\N	174076	174076	341306
22691	34667	7	applied	\N	\N	\N	\N	174077	174077	341307
22693	34671	0	applied	\N	\N	\N	\N	174081	174081	341311
22693	34672	1	applied	\N	\N	\N	\N	174082	174082	341312
22693	34673	2	applied	\N	\N	\N	\N	174083	174083	341313
22693	34674	3	applied	\N	\N	\N	\N	174084	174084	341314
22693	34675	4	applied	\N	\N	\N	\N	174085	174085	341315
22693	34676	5	applied	\N	\N	\N	\N	174086	174086	341316
22696	34677	0	applied	\N	\N	\N	\N	174099	174099	341329
22696	34678	1	applied	\N	\N	\N	\N	174100	174100	341330
22696	34680	3	applied	\N	\N	\N	\N	174102	174102	341332
22696	34681	4	applied	\N	\N	\N	\N	174103	174103	341333
22696	34682	5	applied	\N	\N	\N	\N	174104	174104	341334
22696	34683	6	applied	\N	\N	\N	\N	174105	174105	341335
22696	34684	7	applied	\N	\N	\N	\N	174106	174106	341336
22696	34685	8	applied	\N	\N	\N	\N	174107	174107	341337
22699	34686	0	applied	\N	\N	\N	\N	174116	174116	341346
22699	34687	1	applied	\N	\N	\N	\N	174117	174117	341347
22699	34688	2	applied	\N	\N	\N	\N	174118	174118	341348
22699	34689	3	applied	\N	\N	\N	\N	174119	174119	341349
22703	34690	0	applied	\N	\N	\N	\N	174134	174134	341364
22703	34691	1	applied	\N	\N	\N	\N	174135	174135	341365
22703	34692	2	applied	\N	\N	\N	\N	174136	174136	341366
22703	34693	3	applied	\N	\N	\N	\N	174137	174137	341367
22703	34694	4	applied	\N	\N	\N	\N	174138	174138	341368
22703	34695	5	applied	\N	\N	\N	\N	174139	174139	341369
22710	34706	1	applied	\N	\N	\N	\N	174166	174166	341396
22710	34707	2	applied	\N	\N	\N	\N	174167	174167	341397
22710	34708	3	applied	\N	\N	\N	\N	174168	174168	341398
22710	34709	4	applied	\N	\N	\N	\N	174169	174169	341399
22718	34725	0	applied	\N	\N	\N	\N	174200	174200	341430
22718	34726	1	applied	\N	\N	\N	\N	174201	174201	341431
22722	34727	0	applied	\N	\N	\N	\N	174208	174208	341438
22725	34734	0	applied	\N	\N	\N	\N	174215	174215	341445
22725	34735	1	applied	\N	\N	\N	\N	174216	174216	341446
22725	34736	2	applied	\N	\N	\N	\N	174217	174217	341447
22725	34737	3	applied	\N	\N	\N	\N	174218	174218	341448
22728	34738	0	applied	\N	\N	\N	\N	174227	174227	341457
22728	34739	1	applied	\N	\N	\N	\N	174228	174228	341458
22733	34750	0	applied	\N	\N	\N	\N	174241	174241	341471
22733	34751	1	applied	\N	\N	\N	\N	174242	174242	341472
22733	34752	2	applied	\N	\N	\N	\N	174243	174243	341473
22736	34754	1	applied	\N	\N	\N	\N	174245	174245	341475
22736	34755	2	applied	\N	\N	\N	\N	174246	174246	341476
22736	34756	3	applied	\N	\N	\N	\N	174247	174247	341477
22736	34757	4	applied	\N	\N	\N	\N	174248	174248	341478
22736	34758	5	applied	\N	\N	\N	\N	174249	174249	341479
22736	34759	6	applied	\N	\N	\N	\N	174250	174250	341480
22736	34760	7	applied	\N	\N	\N	\N	174251	174251	341481
22736	34761	8	applied	\N	\N	\N	\N	174252	174252	341482
22736	34762	9	applied	\N	\N	\N	\N	174253	174253	341483
22736	34763	10	applied	\N	\N	\N	\N	174254	174254	341484
22736	34764	11	applied	\N	\N	\N	\N	174255	174255	341485
22736	34765	12	applied	\N	\N	\N	\N	174256	174256	341486
22736	34766	13	applied	\N	\N	\N	\N	174257	174257	341487
22739	34773	0	applied	\N	\N	\N	\N	174278	174278	341508
22739	34774	1	applied	\N	\N	\N	\N	174279	174279	341509
22739	34775	2	applied	\N	\N	\N	\N	174280	174280	341510
22741	34777	0	applied	\N	\N	\N	\N	174286	174286	341516
22741	34778	1	applied	\N	\N	\N	\N	174287	174287	341517
22741	34779	2	applied	\N	\N	\N	\N	174288	174288	341518
22741	34780	3	applied	\N	\N	\N	\N	174289	174289	341519
22742	34783	2	applied	\N	\N	\N	\N	174292	174292	341522
22742	34784	3	applied	\N	\N	\N	\N	174293	174293	341523
22742	34785	4	applied	\N	\N	\N	\N	174294	174294	341524
22742	34786	5	applied	\N	\N	\N	\N	174295	174295	341525
22745	34794	0	applied	\N	\N	\N	\N	174308	174308	341538
22745	34795	1	applied	\N	\N	\N	\N	174309	174309	341539
22745	34792	2	applied	\N	\N	\N	\N	174310	174310	341540
22745	34793	3	applied	\N	\N	\N	\N	174311	174311	341541
22745	34796	4	applied	\N	\N	\N	\N	174312	174312	341542
22747	34801	0	applied	\N	\N	\N	\N	174317	174317	341547
22747	34802	1	applied	\N	\N	\N	\N	174318	174318	341548
22747	34803	2	applied	\N	\N	\N	\N	174319	174319	341549
22750	34803	1	applied	\N	\N	\N	\N	174327	174327	341557
22751	34801	0	applied	\N	\N	\N	\N	174328	174328	341558
22751	34803	1	applied	\N	\N	\N	\N	174329	174329	341559
22754	34471	0	applied	\N	\N	\N	\N	174335	174335	174335
22754	34654	1	applied	\N	\N	\N	\N	174336	174336	341565
22754	34660	2	applied	\N	\N	\N	\N	174337	174337	341566
22754	34661	3	applied	\N	\N	\N	\N	174338	174338	341567
22754	34236	4	applied	\N	\N	\N	\N	174339	174339	341568
22754	34237	5	applied	\N	\N	\N	\N	174340	174340	341569
22754	34238	6	applied	\N	\N	\N	\N	174341	174341	341570
22754	34239	7	applied	\N	\N	\N	\N	174342	174342	341571
22756	34804	0	applied	\N	\N	\N	\N	174465	174465	341694
22756	34805	1	applied	\N	\N	\N	\N	174466	174466	341695
22756	34806	2	applied	\N	\N	\N	\N	174467	174467	341696
22671	34619	1	applied	\N	\N	\N	\N	173994	173994	341224
22671	34620	2	applied	\N	\N	\N	\N	173995	173995	341225
22702	34693	3	applied	\N	\N	\N	\N	174131	174131	341361
22702	34694	4	applied	\N	\N	\N	\N	174132	174132	341362
22702	34695	5	applied	\N	\N	\N	\N	174133	174133	341363
22705	34696	0	applied	\N	\N	\N	\N	174147	174147	341377
22705	34697	1	applied	\N	\N	\N	\N	174148	174148	341378
22705	34698	2	applied	\N	\N	\N	\N	174149	174149	341379
22705	34699	3	applied	\N	\N	\N	\N	174150	174150	341380
22705	34700	4	applied	\N	\N	\N	\N	174151	174151	341381
22705	34701	5	applied	\N	\N	\N	\N	174152	174152	341382
22705	34702	6	applied	\N	\N	\N	\N	174153	174153	341383
22715	34720	0	applied	\N	\N	\N	\N	174192	174192	341422
22715	34721	1	applied	\N	\N	\N	\N	174193	174193	341423
22720	34725	0	applied	\N	\N	\N	\N	174204	174204	341434
22720	34726	1	applied	\N	\N	\N	\N	174205	174205	341435
22724	34732	0	applied	\N	\N	\N	\N	174213	174213	341443
22724	34733	1	applied	\N	\N	\N	\N	174214	174214	341444
22727	34735	1	applied	\N	\N	\N	\N	174224	174224	341454
22727	34736	2	applied	\N	\N	\N	\N	174225	174225	341455
22727	34737	3	applied	\N	\N	\N	\N	174226	174226	341456
22730	34740	0	applied	\N	\N	\N	\N	174231	174231	341461
22730	34741	1	applied	\N	\N	\N	\N	174232	174232	341462
22730	34742	2	applied	\N	\N	\N	\N	174233	174233	341463
22730	34743	3	applied	\N	\N	\N	\N	174234	174234	341464
22738	34767	0	applied	\N	\N	\N	\N	174272	174272	341502
22738	34768	1	applied	\N	\N	\N	\N	174273	174273	341503
22738	34769	2	applied	\N	\N	\N	\N	174274	174274	341504
22738	34770	3	applied	\N	\N	\N	\N	174275	174275	341505
22738	34771	4	applied	\N	\N	\N	\N	174276	174276	341506
22738	34772	5	applied	\N	\N	\N	\N	174277	174277	341507
22744	34787	0	applied	\N	\N	\N	\N	174301	174301	341531
22744	34788	1	applied	\N	\N	\N	\N	174302	174302	341532
22744	34792	2	applied	\N	\N	\N	\N	174303	174303	341533
22744	34789	4	applied	\N	\N	\N	\N	174305	174305	341535
22744	34790	5	applied	\N	\N	\N	\N	174306	174306	341536
22744	34791	6	applied	\N	\N	\N	\N	174307	174307	341537
22746	34797	0	applied	\N	\N	\N	\N	174313	174313	341543
22746	34798	1	applied	\N	\N	\N	\N	174314	174314	341544
22746	34799	2	applied	\N	\N	\N	\N	174315	174315	341545
22746	34800	3	applied	\N	\N	\N	\N	174316	174316	341546
22749	34801	0	applied	\N	\N	\N	\N	174323	174323	341553
22749	34802	1	applied	\N	\N	\N	\N	174324	174324	341554
22749	34803	2	applied	\N	\N	\N	\N	174325	174325	341555
22753	34801	0	applied	\N	\N	\N	\N	174333	174333	341563
22753	34803	1	applied	\N	\N	\N	\N	174334	174334	341564
22755	34804	0	applied	\N	\N	\N	\N	174455	174455	341684
22755	34805	1	applied	\N	\N	\N	\N	174456	174456	341685
22755	34806	2	applied	\N	\N	\N	\N	174457	174457	341686
22755	34807	3	applied	\N	\N	\N	\N	174458	174458	341687
22755	34809	5	applied	\N	\N	\N	\N	174460	174460	341689
22755	34810	6	applied	\N	\N	\N	\N	174461	174461	341690
22755	34811	7	applied	\N	\N	\N	\N	174462	174462	341691
22755	34812	8	applied	\N	\N	\N	\N	174463	174463	341692
22755	34813	9	applied	\N	\N	\N	\N	174464	174464	341693
22756	34807	3	applied	\N	\N	\N	\N	174468	174468	341697
22756	34808	4	applied	\N	\N	\N	\N	174469	174469	341698
22756	34809	5	applied	\N	\N	\N	\N	174470	174470	341699
22756	34810	6	applied	\N	\N	\N	\N	174471	174471	341700
22756	34811	7	applied	\N	\N	\N	\N	174472	174472	341701
22756	34812	8	applied	\N	\N	\N	\N	174473	174473	341702
22756	34813	9	applied	\N	\N	\N	\N	174474	174474	341703
22758	34817	0	applied	\N	\N	\N	\N	174478	174478	341707
22758	34818	1	applied	\N	\N	\N	\N	174479	174479	341708
22758	34819	2	applied	\N	\N	\N	\N	174480	174480	341709
22761	34824	0	applied	\N	\N	\N	\N	174491	174491	341720
22761	34828	2	applied	\N	\N	\N	\N	174493	174493	341722
22761	34829	3	applied	\N	\N	\N	\N	174494	174494	341723
22763	34830	0	applied	\N	\N	\N	\N	174495	174495	341724
22763	34831	1	applied	\N	\N	\N	\N	174496	174496	341725
22763	34826	2	applied	\N	\N	\N	\N	174497	174497	341726
22763	34827	3	applied	\N	\N	\N	\N	174498	174498	341727
22763	34832	4	applied	\N	\N	\N	\N	174499	174499	341728
22765	34830	0	applied	\N	\N	\N	\N	174505	174505	341734
22765	34831	1	applied	\N	\N	\N	\N	174506	174506	341735
22765	34826	2	applied	\N	\N	\N	\N	174507	174507	341736
22765	34827	3	applied	\N	\N	\N	\N	174508	174508	341737
22765	34832	4	applied	\N	\N	\N	\N	174509	174509	341738
22767	34836	0	applied	\N	\N	\N	\N	174513	174513	341742
22767	34837	1	applied	\N	\N	\N	\N	174514	174514	341743
22776	34873	0	applied	\N	\N	\N	\N	174599	174599	341825
22776	34874	1	applied	\N	\N	\N	\N	174600	174600	341826
22779	34883	0	applied	\N	\N	\N	\N	174609	174609	341835
22779	34884	1	applied	\N	\N	\N	\N	174610	174610	341836
22779	34885	2	applied	\N	\N	\N	\N	174611	174611	341837
22782	34890	0	applied	\N	\N	\N	\N	174620	174620	341846
22782	34891	1	applied	\N	\N	\N	\N	174621	174621	341847
22782	34892	2	applied	\N	\N	\N	\N	174622	174622	341848
22782	34893	3	applied	\N	\N	\N	\N	174623	174623	341849
22782	34894	4	applied	\N	\N	\N	\N	174624	174624	341850
22782	34895	5	applied	\N	\N	\N	\N	174625	174625	341851
22782	34896	6	applied	\N	\N	\N	\N	174626	174626	341852
22784	34890	0	applied	\N	\N	\N	\N	174634	174634	341860
22784	34891	1	applied	\N	\N	\N	\N	174635	174635	341861
22784	34892	2	applied	\N	\N	\N	\N	174636	174636	341862
22784	34893	3	applied	\N	\N	\N	\N	174637	174637	341863
22784	34894	4	applied	\N	\N	\N	\N	174638	174638	341864
22784	34895	5	applied	\N	\N	\N	\N	174639	174639	341865
22787	34900	0	applied	\N	\N	\N	\N	174648	174648	341874
22787	34901	1	applied	\N	\N	\N	\N	174649	174649	341875
22787	34902	2	applied	\N	\N	\N	\N	174650	174650	341876
22787	34903	3	applied	\N	\N	\N	\N	174651	174651	341877
22789	34904	0	applied	\N	\N	\N	\N	174655	174655	341881
22789	34905	1	applied	\N	\N	\N	\N	174656	174656	341882
22789	34906	2	applied	\N	\N	\N	\N	174657	174657	341883
22789	34907	3	applied	\N	\N	\N	\N	174658	174658	341884
22789	34908	4	applied	\N	\N	\N	\N	174659	174659	341885
22789	34909	5	applied	\N	\N	\N	\N	174660	174660	341886
22789	34910	6	applied	\N	\N	\N	\N	174661	174661	341887
22789	34911	7	applied	\N	\N	\N	\N	174662	174662	341888
22792	34930	0	applied	\N	\N	\N	\N	174681	174681	341907
22792	34931	1	applied	\N	\N	\N	\N	174682	174682	341908
22702	34690	0	applied	\N	\N	\N	\N	174128	174128	341358
22702	34691	1	applied	\N	\N	\N	\N	174129	174129	341359
22712	34712	2	applied	\N	\N	\N	\N	174178	174178	341408
22712	34713	3	applied	\N	\N	\N	\N	174179	174179	341409
22712	34714	4	applied	\N	\N	\N	\N	174180	174180	341410
22712	34715	5	applied	\N	\N	\N	\N	174181	174181	341411
22714	34716	0	applied	\N	\N	\N	\N	174188	174188	341418
22714	34717	1	applied	\N	\N	\N	\N	174189	174189	341419
22714	34718	2	applied	\N	\N	\N	\N	174190	174190	341420
22714	34719	3	applied	\N	\N	\N	\N	174191	174191	341421
22717	34722	0	applied	\N	\N	\N	\N	174197	174197	341427
22717	34723	1	applied	\N	\N	\N	\N	174198	174198	341428
22717	34724	2	applied	\N	\N	\N	\N	174199	174199	341429
22719	34725	0	applied	\N	\N	\N	\N	174202	174202	341432
22719	34726	1	applied	\N	\N	\N	\N	174203	174203	341433
22721	34727	0	applied	\N	\N	\N	\N	174206	174206	341436
22721	34728	1	applied	\N	\N	\N	\N	174207	174207	341437
22729	34738	0	applied	\N	\N	\N	\N	174229	174229	341459
22732	34747	0	applied	\N	\N	\N	\N	174238	174238	341468
22732	34748	1	applied	\N	\N	\N	\N	174239	174239	341469
22732	34749	2	applied	\N	\N	\N	\N	174240	174240	341470
22743	34787	0	applied	\N	\N	\N	\N	174296	174296	341526
22743	34788	1	applied	\N	\N	\N	\N	174297	174297	341527
22743	34789	2	applied	\N	\N	\N	\N	174298	174298	341528
22743	34790	3	applied	\N	\N	\N	\N	174299	174299	341529
22743	34791	4	applied	\N	\N	\N	\N	174300	174300	341530
22748	34801	0	applied	\N	\N	\N	\N	174320	174320	341550
22748	34802	1	applied	\N	\N	\N	\N	174321	174321	341551
22748	34803	2	applied	\N	\N	\N	\N	174322	174322	341552
22752	34801	0	applied	\N	\N	\N	\N	174330	174330	341560
22752	34802	1	applied	\N	\N	\N	\N	174331	174331	341561
22752	34803	2	applied	\N	\N	\N	\N	174332	174332	341562
22757	34814	0	applied	\N	\N	\N	\N	174475	174475	341704
22757	34815	1	applied	\N	\N	\N	\N	174476	174476	341705
22760	34824	0	applied	\N	\N	\N	\N	174485	174485	341714
22760	34825	1	applied	\N	\N	\N	\N	174486	174486	341715
22760	34826	2	applied	\N	\N	\N	\N	174487	174487	341716
22760	34827	3	applied	\N	\N	\N	\N	174488	174488	341717
22760	34828	5	applied	\N	\N	\N	\N	174489	174489	341718
22760	34829	6	applied	\N	\N	\N	\N	174490	174490	341719
22786	34900	0	applied	\N	\N	\N	\N	174644	174644	341870
22786	34901	1	applied	\N	\N	\N	\N	174645	174645	341871
22786	34902	2	applied	\N	\N	\N	\N	174646	174646	341872
22786	34903	3	applied	\N	\N	\N	\N	174647	174647	341873
22792	34932	2	applied	\N	\N	\N	\N	174683	174683	341909
22797	34933	0	applied	\N	\N	\N	\N	174704	174704	341930
22797	34934	1	applied	\N	\N	\N	\N	174705	174705	341931
22797	34935	2	applied	\N	\N	\N	\N	174706	174706	341932
22797	34936	3	applied	\N	\N	\N	\N	174707	174707	341933
22797	34937	4	applied	\N	\N	\N	\N	174708	174708	341934
22799	34939	0	applied	\N	\N	\N	\N	174716	174716	341942
22799	34940	1	applied	\N	\N	\N	\N	174717	174717	341943
22799	34941	2	applied	\N	\N	\N	\N	174718	174718	341944
22799	34942	3	applied	\N	\N	\N	\N	174719	174719	341945
22803	34943	0	applied	\N	\N	\N	\N	174731	174731	341957
22803	34944	1	applied	\N	\N	\N	\N	174732	174732	341958
22803	34945	2	applied	\N	\N	\N	\N	174733	174733	341959
22804	34943	0	applied	\N	\N	\N	\N	174734	174734	341960
22804	34944	1	applied	\N	\N	\N	\N	174735	174735	341961
22804	34945	2	applied	\N	\N	\N	\N	174736	174736	341962
22805	34946	0	applied	\N	\N	\N	\N	174737	174737	341963
22805	34947	1	applied	\N	\N	\N	\N	174738	174738	341964
22805	34948	2	applied	\N	\N	\N	\N	174739	174739	341965
22807	34946	0	applied	\N	\N	\N	\N	174741	174741	341967
22807	34949	1	applied	\N	\N	\N	\N	174742	174742	341968
22807	34950	2	applied	\N	\N	\N	\N	174743	174743	341969
22807	34951	4	applied	\N	\N	\N	\N	174745	174745	341971
22807	34952	5	applied	\N	\N	\N	\N	174746	174746	341972
22808	34953	0	applied	\N	\N	\N	\N	174747	174747	341973
22808	34954	1	applied	\N	\N	\N	\N	174748	174748	341974
22808	34955	2	applied	\N	\N	\N	\N	174749	174749	341975
22810	34959	0	applied	\N	\N	\N	\N	174753	174753	341979
22810	34960	1	applied	\N	\N	\N	\N	174754	174754	341980
22810	34961	2	applied	\N	\N	\N	\N	174755	174755	341981
22815	34962	0	applied	\N	\N	\N	\N	174768	174768	341994
22815	34963	1	applied	\N	\N	\N	\N	174769	174769	341995
22815	34964	2	applied	\N	\N	\N	\N	174770	174770	341996
22817	34965	0	applied	\N	\N	\N	\N	174773	174773	341999
22817	34966	1	applied	\N	\N	\N	\N	174774	174774	342000
22817	34967	2	applied	\N	\N	\N	\N	174775	174775	342001
22817	34968	3	applied	\N	\N	\N	\N	174776	174776	342002
22817	34969	4	applied	\N	\N	\N	\N	174777	174777	342003
22819	34971	1	applied	\N	\N	\N	\N	174784	174784	342010
22819	34972	2	applied	\N	\N	\N	\N	174785	174785	342011
22819	34973	3	applied	\N	\N	\N	\N	174786	174786	342012
22819	34974	4	applied	\N	\N	\N	\N	174787	174787	342013
22819	34975	5	applied	\N	\N	\N	\N	174788	174788	342014
22819	34976	6	applied	\N	\N	\N	\N	174789	174789	342015
22820	34977	0	applied	\N	\N	\N	\N	174790	174790	342016
22820	34978	1	applied	\N	\N	\N	\N	174791	174791	342017
22820	34979	2	applied	\N	\N	\N	\N	174792	174792	342018
22822	34984	0	applied	\N	\N	\N	\N	174797	174797	342023
22822	34985	1	applied	\N	\N	\N	\N	174798	174798	342024
22822	34986	2	applied	\N	\N	\N	\N	174799	174799	342025
22827	34997	0	applied	\N	\N	\N	\N	174818	174818	342044
22827	34998	1	applied	\N	\N	\N	\N	174819	174819	342045
22827	34999	2	applied	\N	\N	\N	\N	174820	174820	342046
22829	35000	0	applied	\N	\N	\N	\N	174824	174824	342050
22829	35002	2	applied	\N	\N	\N	\N	174826	174826	342052
22829	35003	3	applied	\N	\N	\N	\N	174827	174827	342053
22832	35004	0	applied	\N	\N	\N	\N	174836	174836	342062
22832	35005	1	applied	\N	\N	\N	\N	174837	174837	342063
22832	35006	2	applied	\N	\N	\N	\N	174838	174838	342064
22832	35007	3	applied	\N	\N	\N	\N	174839	174839	342065
22834	35008	0	applied	\N	\N	\N	\N	174843	174843	342069
22834	35009	1	applied	\N	\N	\N	\N	174844	174844	342070
22834	35010	2	applied	\N	\N	\N	\N	174845	174845	342071
22836	35011	0	applied	\N	\N	\N	\N	174849	174849	342075
22836	35012	1	applied	\N	\N	\N	\N	174850	174850	342076
22847	35032	0	applied	\N	\N	\N	\N	174879	174879	342105
22847	35033	1	applied	\N	\N	\N	\N	174880	174880	342106
22847	35034	2	applied	\N	\N	\N	\N	174881	174881	342107
22709	34709	4	applied	\N	\N	\N	\N	174164	174164	341394
22712	34710	0	applied	\N	\N	\N	\N	174176	174176	341406
22754	34039	11	applied	\N	\N	\N	\N	174346	174346	341575
22754	34043	12	applied	\N	\N	\N	\N	174347	174347	341576
22754	34044	13	applied	\N	\N	\N	\N	174348	174348	341577
22754	34045	14	applied	\N	\N	\N	\N	174349	174349	341578
22754	34046	15	applied	\N	\N	\N	\N	174350	174350	341579
22754	34047	16	applied	\N	\N	\N	\N	174351	174351	341580
22754	34048	17	applied	\N	\N	\N	\N	174352	174352	341581
22754	34052	18	applied	\N	\N	\N	\N	174353	174353	341582
22754	34053	19	applied	\N	\N	\N	\N	174354	174354	341583
22754	34054	20	applied	\N	\N	\N	\N	174355	174355	341584
22754	34055	21	applied	\N	\N	\N	\N	174356	174356	341585
22754	34056	22	applied	\N	\N	\N	\N	174357	174357	341586
22754	34059	23	applied	\N	\N	\N	\N	174358	174358	341587
22754	34061	25	applied	\N	\N	\N	\N	174360	174360	341589
22754	34063	26	applied	\N	\N	\N	\N	174361	174361	341590
22754	34064	27	applied	\N	\N	\N	\N	174362	174362	341591
22754	34065	28	applied	\N	\N	\N	\N	174363	174363	341592
22754	34066	29	applied	\N	\N	\N	\N	174364	174364	341593
22754	34067	30	applied	\N	\N	\N	\N	174365	174365	341594
22754	34068	31	applied	\N	\N	\N	\N	174366	174366	341595
22754	34069	32	applied	\N	\N	\N	\N	174367	174367	341596
22754	34070	33	applied	\N	\N	\N	\N	174368	174368	341597
22754	34071	34	applied	\N	\N	\N	\N	174369	174369	341598
22754	34078	35	applied	\N	\N	\N	\N	174370	174370	341599
22754	34079	36	applied	\N	\N	\N	\N	174371	174371	341600
22754	34080	37	applied	\N	\N	\N	\N	174372	174372	341601
22754	34081	38	applied	\N	\N	\N	\N	174373	174373	341602
22754	34082	39	applied	\N	\N	\N	\N	174374	174374	341603
22754	34083	40	applied	\N	\N	\N	\N	174375	174375	341604
22754	34089	42	applied	\N	\N	\N	\N	174377	174377	341606
22754	34090	43	applied	\N	\N	\N	\N	174378	174378	341607
22754	34091	44	applied	\N	\N	\N	\N	174379	174379	341608
22754	34093	45	applied	\N	\N	\N	\N	174380	174380	341609
22754	34094	46	applied	\N	\N	\N	\N	174381	174381	341610
22754	34095	47	applied	\N	\N	\N	\N	174382	174382	341611
22754	34096	48	applied	\N	\N	\N	\N	174383	174383	341612
22754	34097	49	applied	\N	\N	\N	\N	174384	174384	341613
22754	34098	50	applied	\N	\N	\N	\N	174385	174385	341614
22754	34099	51	applied	\N	\N	\N	\N	174386	174386	341615
22754	34100	52	applied	\N	\N	\N	\N	174387	174387	341616
22754	34106	53	applied	\N	\N	\N	\N	174388	174388	341617
22754	34482	54	applied	\N	\N	\N	\N	174389	174389	341618
22754	34664	55	applied	\N	\N	\N	\N	174390	174390	341619
22754	34107	56	applied	\N	\N	\N	\N	174391	174391	341620
22754	34108	57	applied	\N	\N	\N	\N	174392	174392	341621
22754	34110	59	applied	\N	\N	\N	\N	174394	174394	341623
22754	34111	60	applied	\N	\N	\N	\N	174395	174395	341624
22754	34116	61	applied	\N	\N	\N	\N	174396	174396	341625
22754	34123	62	applied	\N	\N	\N	\N	174397	174397	341626
22754	34126	63	applied	\N	\N	\N	\N	174398	174398	341627
22754	34130	64	applied	\N	\N	\N	\N	174399	174399	341628
22754	34131	65	applied	\N	\N	\N	\N	174400	174400	341629
22754	34132	66	applied	\N	\N	\N	\N	174401	174401	341630
22754	34133	67	applied	\N	\N	\N	\N	174402	174402	341631
22754	34134	68	applied	\N	\N	\N	\N	174403	174403	341632
22754	34135	69	applied	\N	\N	\N	\N	174404	174404	341633
22754	34136	70	applied	\N	\N	\N	\N	174405	174405	341634
22754	34137	71	applied	\N	\N	\N	\N	174406	174406	341635
22754	34138	72	applied	\N	\N	\N	\N	174407	174407	341636
22754	34139	73	applied	\N	\N	\N	\N	174408	174408	341637
22754	34140	74	applied	\N	\N	\N	\N	174409	174409	341638
22754	34142	76	applied	\N	\N	\N	\N	174411	174411	341640
22754	34143	77	applied	\N	\N	\N	\N	174412	174412	341641
22754	34144	78	applied	\N	\N	\N	\N	174413	174413	341642
22754	34145	79	applied	\N	\N	\N	\N	174414	174414	341643
22754	34146	80	applied	\N	\N	\N	\N	174415	174415	341644
22754	34154	82	applied	\N	\N	\N	\N	174416	174416	341645
22754	34155	83	applied	\N	\N	\N	\N	174417	174417	341646
22754	34156	84	applied	\N	\N	\N	\N	174418	174418	341647
22754	34157	85	applied	\N	\N	\N	\N	174419	174419	341648
22754	34158	86	applied	\N	\N	\N	\N	174420	174420	341649
22754	34159	87	applied	\N	\N	\N	\N	174421	174421	341650
22754	34164	88	applied	\N	\N	\N	\N	174422	174422	341651
22754	34165	89	applied	\N	\N	\N	\N	174423	174423	341652
22754	34166	90	applied	\N	\N	\N	\N	174424	174424	341653
22754	34167	91	applied	\N	\N	\N	\N	174425	174425	341654
22754	34168	92	applied	\N	\N	\N	\N	174426	174426	341655
22754	34170	94	applied	\N	\N	\N	\N	174428	174428	341657
22754	34171	95	applied	\N	\N	\N	\N	174429	174429	341658
22754	34172	96	applied	\N	\N	\N	\N	174430	174430	341659
22754	34173	97	applied	\N	\N	\N	\N	174431	174431	341660
22754	34174	98	applied	\N	\N	\N	\N	174432	174432	341661
22754	34175	99	applied	\N	\N	\N	\N	174433	174433	341662
22754	34181	100	applied	\N	\N	\N	\N	174434	174434	341663
22754	34183	101	applied	\N	\N	\N	\N	174435	174435	341664
22754	34184	102	applied	\N	\N	\N	\N	174436	174436	341665
22754	34185	103	applied	\N	\N	\N	\N	174437	174437	341666
22754	34186	104	applied	\N	\N	\N	\N	174438	174438	341667
22754	34187	105	applied	\N	\N	\N	\N	174439	174439	341668
22754	34191	106	applied	\N	\N	\N	\N	174440	174440	341669
22754	34192	107	applied	\N	\N	\N	\N	174441	174441	341670
22754	34193	108	applied	\N	\N	\N	\N	174442	174442	341671
22754	34194	109	applied	\N	\N	\N	\N	174443	174443	341672
22849	35036	1	applied	\N	\N	\N	\N	174886	174886	342112
22849	35037	2	applied	\N	\N	\N	\N	174887	174887	342113
22858	35043	0	applied	\N	\N	1000000000	\N	174914	174914	342140
22858	35044	1	applied	\N	\N	\N	\N	174915	174915	342141
22858	35045	2	applied	\N	\N	\N	\N	174916	174916	342142
22858	35041	3	applied	\N	\N	\N	\N	174917	174917	342143
22858	35046	4	applied	\N	\N	\N	\N	174918	174918	342144
22863	35047	0	applied	\N	\N	\N	\N	174936	174936	342162
22863	35048	1	applied	\N	\N	\N	\N	174937	174937	342163
22863	35049	2	applied	\N	\N	\N	\N	174938	174938	342164
22863	35050	3	applied	\N	\N	\N	\N	174939	174939	342165
22864	35051	0	applied	\N	\N	\N	\N	174940	174940	342166
22864	35052	1	applied	\N	\N	\N	\N	174941	174941	342167
22864	35053	2	applied	\N	\N	\N	\N	174942	174942	342168
22864	35055	4	applied	\N	\N	\N	\N	174944	174944	342170
22869	35056	0	applied	\N	\N	\N	\N	174962	174962	342188
22754	34037	9	applied	\N	\N	\N	\N	174344	174344	341573
22754	34038	10	applied	\N	\N	\N	\N	174345	174345	341574
22754	34213	114	applied	\N	\N	\N	\N	174448	174448	341677
22754	34214	115	applied	\N	\N	\N	\N	174449	174449	341678
22754	34215	116	applied	\N	\N	\N	\N	174450	174450	341679
22754	34218	117	applied	\N	\N	\N	\N	174451	174451	341680
22754	34219	118	applied	\N	\N	\N	\N	174452	174452	341681
22754	34220	119	applied	\N	\N	\N	\N	174453	174453	341682
22754	34221	120	applied	\N	\N	\N	\N	174454	174454	341683
22759	34820	0	applied	\N	\N	\N	\N	174481	174481	341710
22759	34821	1	applied	\N	\N	\N	\N	174482	174482	341711
22759	34822	2	applied	\N	\N	\N	\N	174483	174483	341712
22759	34823	3	applied	\N	\N	\N	\N	174484	174484	341713
22764	34830	0	applied	\N	\N	\N	\N	174500	174500	341729
22764	34831	1	applied	\N	\N	\N	\N	174501	174501	341730
22764	34826	2	applied	\N	\N	\N	\N	174502	174502	341731
22764	34827	3	applied	\N	\N	\N	\N	174503	174503	341732
22764	34832	4	applied	\N	\N	\N	\N	174504	174504	341733
22766	34834	1	applied	\N	\N	\N	\N	174511	174511	341740
22766	34835	2	applied	\N	\N	\N	\N	174512	174512	341741
22769	34838	0	applied	\N	\N	\N	\N	174519	174519	341748
22769	34839	1	applied	\N	\N	\N	\N	174520	174520	341749
22769	34840	2	applied	\N	\N	\N	\N	174521	174521	341750
22769	34841	3	applied	\N	\N	\N	\N	174522	174522	341751
22771	34846	0	applied	\N	\N	\N	\N	174527	174527	341756
22771	34847	1	applied	\N	\N	\N	\N	174528	174528	341757
22771	34848	2	applied	\N	\N	\N	\N	174529	174529	341758
22771	34849	3	applied	\N	\N	\N	\N	174530	174530	341759
22771	34850	4	applied	\N	\N	\N	\N	174531	174531	341760
22771	34851	5	applied	\N	\N	\N	\N	174532	174532	341761
22773	34852	0	applied	\N	\N	\N	\N	174554	174554	341782
22773	34853	1	applied	\N	\N	\N	\N	174555	174555	341783
22773	34854	2	applied	\N	\N	\N	\N	174556	174556	341784
22773	34855	3	applied	\N	\N	\N	\N	174557	174557	341785
22773	34857	5	applied	\N	\N	\N	\N	174559	174559	341787
22773	34858	6	applied	\N	\N	\N	\N	174560	174560	341788
22773	34859	7	applied	\N	\N	\N	\N	174561	174561	341789
22773	34860	8	applied	\N	\N	\N	\N	174562	174562	341790
22773	34861	9	applied	\N	\N	\N	\N	174563	174563	341791
22773	34862	10	applied	\N	\N	\N	\N	174564	174564	174564
22773	34863	11	applied	\N	\N	\N	\N	174565	174565	341792
22773	34864	12	applied	\N	\N	\N	\N	174566	174566	341793
22773	34865	13	applied	\N	\N	\N	\N	174567	174567	341794
22773	34866	14	applied	\N	\N	\N	\N	174568	174568	341795
22773	34867	15	applied	\N	\N	\N	\N	174569	174569	341796
22773	34868	16	applied	\N	\N	\N	\N	174570	174570	341797
22773	34869	17	applied	\N	\N	\N	\N	174571	174571	341798
22773	34870	18	applied	\N	\N	\N	\N	174572	174572	341799
22773	34871	19	applied	\N	\N	\N	\N	174573	174573	341800
22773	34872	20	applied	\N	\N	\N	\N	174574	174574	341801
22775	34874	1	applied	\N	\N	\N	\N	174597	174597	341823
22775	34875	2	applied	\N	\N	\N	\N	174598	174598	341824
22778	34880	0	applied	\N	\N	\N	\N	174606	174606	341832
22778	34881	1	applied	\N	\N	\N	\N	174607	174607	341833
22778	34882	2	applied	\N	\N	\N	\N	174608	174608	341834
22781	34886	0	applied	\N	\N	\N	\N	174616	174616	341842
22781	34887	1	applied	\N	\N	\N	\N	174617	174617	341843
22781	34888	2	applied	\N	\N	\N	\N	174618	174618	341844
22781	34889	3	applied	\N	\N	\N	\N	174619	174619	341845
22785	34897	0	applied	\N	\N	\N	\N	174641	174641	341867
22785	34898	1	applied	\N	\N	\N	\N	174642	174642	341868
22785	34899	2	applied	\N	\N	\N	\N	174643	174643	341869
22788	34901	0	applied	\N	\N	\N	\N	174652	174652	341878
22788	34902	1	applied	\N	\N	\N	\N	174653	174653	341879
22788	34903	2	applied	\N	\N	\N	\N	174654	174654	341880
22791	34919	0	applied	\N	\N	\N	\N	174670	174670	341896
22791	34921	3	applied	\N	\N	\N	\N	174672	174672	341898
22791	34922	4	applied	\N	\N	\N	\N	174673	174673	341899
22791	34923	5	applied	\N	\N	\N	\N	174674	174674	341900
22791	34924	6	applied	\N	\N	\N	\N	174675	174675	341901
22791	34925	7	applied	\N	\N	\N	\N	174676	174676	341902
22791	34926	8	applied	\N	\N	\N	\N	174677	174677	341903
22791	34927	9	applied	\N	\N	\N	\N	174678	174678	341904
22791	34928	10	applied	\N	\N	\N	\N	174679	174679	341905
22791	34929	11	applied	\N	\N	\N	\N	174680	174680	341906
22794	34933	0	applied	\N	\N	\N	\N	174690	174690	341916
22794	34934	1	applied	\N	\N	\N	\N	174691	174691	341917
22794	34935	2	applied	\N	\N	\N	\N	174692	174692	341918
22794	34936	3	applied	\N	\N	\N	\N	174693	174693	341919
22794	34937	4	applied	\N	\N	\N	\N	174694	174694	341920
22794	34938	5	applied	\N	\N	\N	\N	174695	174695	341921
22796	34933	0	applied	\N	\N	\N	\N	174702	174702	341928
22798	34933	0	applied	\N	\N	\N	\N	174710	174710	341936
22798	34934	1	applied	\N	\N	\N	\N	174711	174711	341937
22798	34935	2	applied	\N	\N	\N	\N	174712	174712	341938
22798	34936	3	applied	\N	\N	\N	\N	174713	174713	341939
22798	34937	4	applied	\N	\N	\N	\N	174714	174714	341940
22798	34938	5	applied	\N	\N	\N	\N	174715	174715	341941
22801	34939	0	applied	\N	\N	\N	\N	174724	174724	341950
22801	34940	1	applied	\N	\N	\N	\N	174725	174725	341951
22801	34941	2	applied	\N	\N	\N	\N	174726	174726	341952
22801	34942	3	applied	\N	\N	\N	\N	174727	174727	341953
22802	34943	0	applied	\N	\N	\N	\N	174728	174728	341954
22802	34944	1	applied	\N	\N	\N	\N	174729	174729	341955
22802	34945	2	applied	\N	\N	\N	\N	174730	174730	341956
22809	34956	0	applied	\N	\N	\N	\N	174750	174750	341976
22809	34957	1	applied	\N	\N	\N	\N	174751	174751	341977
22809	34958	2	applied	\N	\N	\N	\N	174752	174752	341978
22812	34960	1	applied	\N	\N	\N	\N	174760	174760	341986
22812	34961	2	applied	\N	\N	\N	\N	174761	174761	341987
22814	34962	0	applied	\N	\N	\N	\N	174765	174765	341991
22814	34963	1	applied	\N	\N	\N	\N	174766	174766	341992
22814	34964	2	applied	\N	\N	\N	\N	174767	174767	341993
22821	34980	0	applied	\N	\N	\N	\N	174793	174793	342019
22821	34981	1	applied	\N	\N	\N	\N	174794	174794	342020
22821	34982	2	applied	\N	\N	\N	\N	174795	174795	342021
22821	34983	3	applied	\N	\N	\N	\N	174796	174796	342022
22826	34987	0	applied	\N	\N	\N	\N	174811	174811	342037
22826	34988	1	applied	\N	\N	\N	\N	174812	174812	342038
22826	34989	2	applied	\N	\N	\N	\N	174813	174813	342039
22826	34991	3	applied	\N	\N	\N	\N	174814	174814	342040
22826	34992	4	applied	\N	\N	\N	\N	174815	174815	342041
22754	34196	111	applied	\N	\N	\N	\N	174445	174445	341674
22754	34201	112	applied	\N	\N	\N	\N	174446	174446	341675
22770	34842	0	applied	\N	\N	\N	\N	174523	174523	341752
22770	34843	1	applied	\N	\N	\N	\N	174524	174524	341753
22770	34844	2	applied	\N	\N	\N	\N	174525	174525	341754
22770	34845	3	applied	\N	\N	\N	\N	174526	174526	341755
22772	34852	0	applied	\N	\N	\N	\N	174533	174533	341762
22772	34853	1	applied	\N	\N	\N	\N	174534	174534	341763
22772	34854	2	applied	\N	\N	\N	\N	174535	174535	341764
22772	34855	3	applied	\N	\N	\N	\N	174536	174536	341765
22772	34856	4	applied	\N	\N	\N	\N	174537	174537	341766
22772	34857	5	applied	\N	\N	\N	\N	174538	174538	341767
22772	34858	6	applied	\N	\N	\N	\N	174539	174539	341768
22772	34859	7	applied	\N	\N	\N	\N	174540	174540	341769
22772	34860	8	applied	\N	\N	\N	\N	174541	174541	341770
22772	34861	9	applied	\N	\N	\N	\N	174542	174542	341771
22772	34862	10	applied	\N	\N	\N	\N	174543	174543	174543
22772	34863	11	applied	\N	\N	\N	\N	174544	174544	341772
22772	34865	13	applied	\N	\N	\N	\N	174546	174546	341774
22772	34866	14	applied	\N	\N	\N	\N	174547	174547	341775
22772	34867	15	applied	\N	\N	\N	\N	174548	174548	341776
22772	34868	16	applied	\N	\N	\N	\N	174549	174549	341777
22772	34869	17	applied	\N	\N	\N	\N	174550	174550	341778
22772	34870	18	applied	\N	\N	\N	\N	174551	174551	341779
22772	34871	19	applied	\N	\N	\N	\N	174552	174552	341780
22772	34872	20	applied	\N	\N	\N	\N	174553	174553	341781
22774	34852	0	applied	\N	\N	\N	\N	174575	174575	341802
22774	34853	1	applied	\N	\N	\N	\N	174576	174576	341803
22774	34854	2	applied	\N	\N	\N	\N	174577	174577	341804
22774	34855	3	applied	\N	\N	\N	\N	174578	174578	341805
22774	34856	4	applied	\N	\N	\N	\N	174579	174579	341806
22774	34857	5	applied	\N	\N	\N	\N	174580	174580	341807
22774	34858	6	applied	\N	\N	\N	\N	174581	174581	341808
22774	34859	7	applied	\N	\N	\N	\N	174582	174582	341809
22774	34861	9	applied	\N	\N	\N	\N	174584	174584	341811
22774	34862	10	applied	\N	\N	\N	\N	174585	174585	174585
22774	34863	11	applied	\N	\N	\N	\N	174586	174586	341812
22774	34864	12	applied	\N	\N	\N	\N	174587	174587	341813
22774	34865	13	applied	\N	\N	\N	\N	174588	174588	341814
22774	34866	14	applied	\N	\N	\N	\N	174589	174589	341815
22774	34867	15	applied	\N	\N	\N	\N	174590	174590	341816
22774	34868	16	applied	\N	\N	\N	\N	174591	174591	341817
22774	34869	17	applied	\N	\N	\N	\N	174592	174592	341818
22774	34870	18	applied	\N	\N	\N	\N	174593	174593	341819
22774	34871	19	applied	\N	\N	\N	\N	174594	174594	341820
22774	34872	20	applied	\N	\N	\N	\N	174595	174595	341821
22777	34876	0	applied	\N	\N	\N	\N	174602	174602	341828
22777	34877	1	applied	\N	\N	\N	\N	174603	174603	341829
22777	34878	2	applied	\N	\N	\N	\N	174604	174604	341830
22777	34879	3	applied	\N	\N	\N	\N	174605	174605	341831
22780	34887	1	applied	\N	\N	\N	\N	174613	174613	341839
22780	34888	2	applied	\N	\N	\N	\N	174614	174614	341840
22780	34889	3	applied	\N	\N	\N	\N	174615	174615	341841
22783	34890	0	applied	\N	\N	\N	\N	174627	174627	341853
22783	34891	1	applied	\N	\N	\N	\N	174628	174628	341854
22783	34892	2	applied	\N	\N	\N	\N	174629	174629	341855
22783	34893	3	applied	\N	\N	\N	\N	174630	174630	341856
22783	34894	4	applied	\N	\N	\N	\N	174631	174631	341857
22783	34895	5	applied	\N	\N	\N	\N	174632	174632	341858
22783	34896	6	applied	\N	\N	\N	\N	174633	174633	341859
22790	34912	0	applied	\N	\N	\N	\N	174663	174663	341889
22790	34913	1	applied	\N	\N	\N	\N	174664	174664	341890
22790	34914	2	applied	\N	\N	\N	\N	174665	174665	341891
22790	34915	3	applied	\N	\N	\N	\N	174666	174666	341892
22790	34916	4	applied	\N	\N	\N	\N	174667	174667	341893
22790	34917	5	applied	\N	\N	\N	\N	174668	174668	341894
22793	34933	0	applied	\N	\N	\N	\N	174684	174684	341910
22793	34934	1	applied	\N	\N	\N	\N	174685	174685	341911
22793	34935	2	applied	\N	\N	\N	\N	174686	174686	341912
22793	34936	3	applied	\N	\N	\N	\N	174687	174687	341913
22793	34937	4	applied	\N	\N	\N	\N	174688	174688	341914
22793	34938	5	applied	\N	\N	\N	\N	174689	174689	341915
22795	34933	0	applied	\N	\N	\N	\N	174696	174696	341922
22795	34934	1	applied	\N	\N	\N	\N	174697	174697	341923
22795	34935	2	applied	\N	\N	\N	\N	174698	174698	341924
22795	34936	3	applied	\N	\N	\N	\N	174699	174699	341925
22795	34937	4	applied	\N	\N	\N	\N	174700	174700	341926
22795	34938	5	applied	\N	\N	\N	\N	174701	174701	341927
22800	34939	0	applied	\N	\N	\N	\N	174720	174720	341946
22800	34940	1	applied	\N	\N	\N	\N	174721	174721	341947
22800	34941	2	applied	\N	\N	\N	\N	174722	174722	341948
22800	34942	3	applied	\N	\N	\N	\N	174723	174723	341949
22811	34959	0	applied	\N	\N	\N	\N	174756	174756	341982
22811	34960	1	applied	\N	\N	\N	\N	174757	174757	341983
22811	34961	2	applied	\N	\N	\N	\N	174758	174758	341984
22813	34962	0	applied	\N	\N	\N	\N	174762	174762	341988
22813	34963	1	applied	\N	\N	\N	\N	174763	174763	341989
22813	34964	2	applied	\N	\N	\N	\N	174764	174764	341990
22816	34963	0	applied	\N	\N	\N	\N	174771	174771	341997
22816	34964	1	applied	\N	\N	\N	\N	174772	174772	341998
22818	34965	0	applied	\N	\N	\N	\N	174778	174778	342004
22818	34966	1	applied	\N	\N	\N	\N	174779	174779	342005
22818	34967	2	applied	\N	\N	\N	\N	174780	174780	342006
22818	34968	3	applied	\N	\N	\N	\N	174781	174781	342007
22826	34993	5	applied	\N	\N	\N	\N	174816	174816	342042
22826	34996	6	applied	\N	\N	\N	\N	174817	174817	342043
22831	35004	0	applied	\N	\N	\N	\N	174832	174832	342058
22831	35005	1	applied	\N	\N	\N	\N	174833	174833	342059
22831	35007	3	applied	\N	\N	\N	\N	174835	174835	342061
22833	35008	0	applied	\N	\N	\N	\N	174840	174840	342066
22833	35009	1	applied	\N	\N	\N	\N	174841	174841	342067
22833	35010	2	applied	\N	\N	\N	\N	174842	174842	342068
22838	35014	0	applied	\N	\N	\N	\N	174854	174854	342080
22838	35015	1	applied	\N	\N	\N	\N	174855	174855	342081
22838	35016	2	applied	\N	\N	\N	\N	174856	174856	342082
22838	35017	3	applied	\N	\N	\N	\N	174857	174857	342083
22838	35018	4	applied	\N	\N	\N	\N	174858	174858	342084
22838	35019	5	applied	\N	\N	\N	\N	174859	174859	342085
22838	35020	6	applied	\N	\N	\N	\N	174860	174860	342086
22844	35024	0	applied	\N	\N	\N	\N	174867	174867	342093
22844	35025	1	applied	\N	\N	\N	\N	174868	174868	342094
22844	35026	2	applied	\N	\N	\N	\N	174869	174869	342095
22768	34839	1	applied	\N	\N	\N	\N	174516	174516	341745
22768	34840	2	applied	\N	\N	\N	\N	174517	174517	341746
22825	34988	1	applied	\N	\N	\N	\N	174802	174802	342028
22825	34989	2	applied	\N	\N	\N	\N	174803	174803	342029
22825	34990	3	applied	\N	\N	\N	\N	174804	174804	342030
22825	34991	4	applied	\N	\N	\N	\N	174805	174805	342031
22825	34992	5	applied	\N	\N	\N	\N	174806	174806	342032
22825	34993	6	applied	\N	\N	\N	\N	174807	174807	342033
22825	34994	7	applied	\N	\N	\N	\N	174808	174808	342034
22825	34995	8	applied	\N	\N	\N	\N	174809	174809	342035
22825	34996	9	applied	\N	\N	\N	\N	174810	174810	342036
22828	34998	1	applied	\N	\N	\N	\N	174822	174822	342048
22828	34999	2	applied	\N	\N	\N	\N	174823	174823	342049
22830	35000	0	applied	\N	\N	\N	\N	174828	174828	342054
22830	35001	1	applied	\N	\N	\N	\N	174829	174829	342055
22830	35002	2	applied	\N	\N	\N	\N	174830	174830	342056
22830	35003	3	applied	\N	\N	\N	\N	174831	174831	342057
22835	35008	0	applied	\N	\N	\N	\N	174846	174846	342072
22835	35009	1	applied	\N	\N	\N	\N	174847	174847	342073
22835	35010	2	applied	\N	\N	\N	\N	174848	174848	342074
22837	35011	0	applied	\N	\N	\N	\N	174851	174851	342077
22837	35012	1	applied	\N	\N	\N	\N	174852	174852	342078
22837	35013	2	applied	\N	\N	\N	\N	174853	174853	342079
22839	35021	0	applied	\N	\N	\N	\N	174861	174861	342087
22839	35022	1	applied	\N	\N	\N	\N	174862	174862	342088
22839	35023	2	applied	\N	\N	\N	\N	174863	174863	342089
22840	35021	0	applied	\N	\N	\N	\N	174864	174864	342090
22840	35023	2	applied	\N	\N	\N	\N	174866	174866	342092
22845	35027	0	applied	\N	\N	1000000000	\N	174870	174870	342096
22845	35028	1	applied	\N	\N	\N	\N	174871	174871	342097
22845	35029	2	applied	\N	\N	\N	\N	174872	174872	342098
22845	35030	3	applied	\N	\N	\N	\N	174873	174873	342099
22848	35035	0	applied	\N	\N	\N	\N	174882	174882	342108
22848	35036	1	applied	\N	\N	\N	\N	174883	174883	342109
22848	35037	2	applied	\N	\N	\N	\N	174884	174884	342110
22850	35035	0	applied	\N	\N	\N	\N	174888	174888	342114
22850	35036	1	applied	\N	\N	\N	\N	174889	174889	342115
22850	35037	2	applied	\N	\N	\N	\N	174890	174890	342116
22851	35035	0	applied	\N	\N	\N	\N	174891	174891	342117
22851	35036	1	applied	\N	\N	\N	\N	174892	174892	342118
22851	35037	2	applied	\N	\N	\N	\N	174893	174893	342119
22853	35013	0	applied	\N	\N	\N	\N	174894	174894	342120
22854	35038	0	applied	\N	\N	\N	\N	174895	174895	342121
22854	35040	2	applied	\N	\N	\N	\N	174897	174897	342123
22854	35041	3	applied	\N	\N	\N	\N	174898	174898	342124
22854	35042	4	applied	\N	\N	\N	\N	174899	174899	342125
22855	35038	0	applied	\N	\N	\N	\N	174900	174900	342126
22855	35039	1	applied	\N	\N	\N	\N	174901	174901	342127
22856	35038	0	applied	\N	\N	\N	\N	174905	174905	342131
22856	35039	1	applied	\N	\N	\N	\N	174906	174906	342132
22856	35040	2	applied	\N	\N	\N	\N	174907	174907	342133
22856	35042	3	applied	\N	\N	\N	\N	174908	174908	342134
22859	35043	0	applied	\N	\N	1000000000	\N	174919	174919	342145
22859	35044	1	applied	\N	\N	\N	\N	174920	174920	342146
22859	35045	2	applied	\N	\N	\N	\N	174921	174921	342147
22859	35041	3	applied	\N	\N	\N	\N	174922	174922	342148
22859	35046	4	applied	\N	\N	\N	\N	174923	174923	342149
22867	35056	0	applied	\N	\N	\N	\N	174954	174954	342180
22867	35057	1	applied	\N	\N	\N	\N	174955	174955	342181
22867	35059	3	applied	\N	\N	\N	\N	174957	174957	342183
22870	35056	0	applied	\N	\N	\N	\N	174966	174966	342192
22870	35060	1	applied	\N	\N	\N	\N	174967	174967	342193
22870	35057	2	applied	\N	\N	\N	\N	174968	174968	342194
22870	35058	3	applied	\N	\N	1000000000	\N	174969	174969	342195
22870	35059	4	applied	\N	\N	\N	\N	174970	174970	342196
22871	35060	0	applied	\N	\N	\N	\N	174971	174971	342197
22871	35061	1	applied	\N	\N	\N	\N	174972	174972	342198
22871	35062	2	applied	\N	\N	\N	\N	174973	174973	342199
22874	35071	0	applied	\N	\N	\N	\N	174982	174982	342208
22874	35072	1	applied	\N	\N	\N	\N	174983	174983	342209
22874	35073	2	applied	\N	\N	\N	\N	174984	174984	342210
22874	35074	3	applied	\N	\N	\N	\N	174985	174985	342211
22874	35075	4	applied	\N	\N	\N	\N	174986	174986	342212
22874	35076	5	applied	\N	\N	\N	\N	174987	174987	342213
22879	35077	0	applied	\N	\N	\N	\N	175006	175006	342232
22879	35078	1	applied	\N	\N	\N	\N	175007	175007	342233
22879	35079	2	applied	\N	\N	\N	\N	175008	175008	342234
22881	35081	0	applied	\N	\N	\N	\N	175014	175014	342240
22881	35082	1	applied	\N	\N	\N	\N	175015	175015	342241
22884	35090	0	applied	\N	\N	\N	\N	175023	175023	342249
22884	35091	1	applied	\N	\N	\N	\N	175024	175024	342250
22884	35092	3	applied	\N	\N	\N	\N	175025	175025	342251
22884	35093	4	applied	\N	\N	\N	\N	175026	175026	342252
22884	35094	5	applied	\N	\N	\N	\N	175027	175027	342253
22884	35095	6	applied	\N	\N	\N	\N	175028	175028	342254
22891	35103	0	applied	\N	\N	\N	\N	175097	175097	342323
22891	35104	1	applied	\N	\N	\N	\N	175098	175098	342324
22891	35105	2	applied	\N	\N	\N	\N	175099	175099	342325
22893	35103	0	applied	\N	\N	\N	\N	175103	175103	342329
22893	35105	1	applied	\N	\N	\N	\N	175104	175104	342330
22896	35109	0	applied	\N	\N	\N	\N	175111	175111	342337
22896	35110	1	applied	\N	\N	\N	\N	175112	175112	342338
22896	35111	2	applied	\N	\N	\N	\N	175113	175113	342339
22898	35113	0	applied	\N	\N	\N	\N	175119	175119	342345
22898	35114	1	applied	\N	\N	\N	\N	175120	175120	342346
22898	35115	2	applied	\N	\N	\N	\N	175121	175121	342347
22901	35116	0	applied	\N	\N	\N	\N	175128	175128	342354
22901	35117	1	applied	\N	\N	\N	\N	175129	175129	342355
22901	35118	2	applied	\N	\N	\N	\N	175130	175130	342356
22905	35123	0	applied	\N	\N	\N	\N	175146	175146	342372
22905	35124	1	applied	\N	\N	\N	\N	175147	175147	342373
22905	35125	2	applied	\N	\N	\N	\N	175148	175148	342374
22908	35126	0	applied	\N	\N	\N	\N	175167	175167	342393
22908	35127	1	applied	\N	\N	\N	\N	175168	175168	342394
22908	35128	2	applied	\N	\N	\N	\N	175169	175169	342395
22908	35129	3	applied	\N	\N	\N	\N	175170	175170	342396
22908	35133	4	applied	\N	\N	\N	\N	175171	175171	342397
22908	35134	5	applied	\N	\N	\N	\N	175172	175172	342398
22908	35135	6	applied	\N	\N	\N	\N	175173	175173	342399
22908	35137	8	applied	\N	\N	\N	\N	175175	175175	342401
22908	35138	9	applied	\N	\N	\N	\N	175176	175176	342402
22823	34930	0	applied	\N	\N	\N	\N	174800	174800	342026
22825	34987	0	applied	\N	\N	\N	\N	174801	174801	342027
22846	35031	3	applied	\N	\N	\N	\N	174877	174877	342103
22846	35030	4	applied	\N	\N	\N	\N	174878	174878	342104
22857	35043	0	applied	\N	\N	1000000000	\N	174909	174909	342135
22857	35044	1	applied	\N	\N	\N	\N	174910	174910	342136
22857	35045	2	applied	\N	\N	\N	\N	174911	174911	342137
22857	35041	3	applied	\N	\N	\N	\N	174912	174912	342138
22857	35046	4	applied	\N	\N	\N	\N	174913	174913	342139
22862	35048	1	applied	\N	\N	\N	\N	174933	174933	342159
22862	35049	2	applied	\N	\N	\N	\N	174934	174934	342160
22862	35050	3	applied	\N	\N	\N	\N	174935	174935	342161
22866	35056	0	applied	\N	\N	\N	\N	174950	174950	342176
22866	35057	1	applied	\N	\N	\N	\N	174951	174951	342177
22866	35058	2	applied	\N	\N	1000000000	\N	174952	174952	342178
22866	35059	3	applied	\N	\N	\N	\N	174953	174953	342179
22868	35056	0	applied	\N	\N	\N	\N	174958	174958	342184
22868	35057	1	applied	\N	\N	\N	\N	174959	174959	342185
22868	35058	2	applied	\N	\N	1000000000	\N	174960	174960	342186
22868	35059	3	applied	\N	\N	\N	\N	174961	174961	342187
22888	35099	0	applied	\N	\N	\N	\N	175042	175042	342268
22888	35100	1	applied	\N	\N	\N	\N	175043	175043	342269
22888	35101	2	applied	\N	\N	\N	\N	175044	175044	342270
22888	35102	3	applied	\N	\N	\N	\N	175045	175045	342271
22890	35056	0	applied	\N	\N	\N	\N	175050	175050	342276
22890	35063	2	applied	\N	\N	\N	\N	175052	175052	342278
22890	35066	3	applied	\N	\N	\N	\N	175053	175053	342279
22890	35071	4	applied	\N	\N	\N	\N	175054	175054	342280
22890	35072	5	applied	\N	\N	\N	\N	175055	175055	342281
22890	35077	6	applied	\N	\N	\N	\N	175056	175056	342282
22890	35081	7	applied	\N	\N	\N	\N	175057	175057	342283
22890	35083	8	applied	\N	\N	\N	\N	175058	175058	342284
22890	35086	9	applied	\N	\N	\N	\N	175059	175059	342285
22890	35090	10	applied	\N	\N	\N	\N	175060	175060	342286
22890	35091	11	applied	\N	\N	\N	\N	175061	175061	342287
22890	35096	12	applied	\N	\N	\N	\N	175062	175062	342288
22890	35099	13	applied	\N	\N	\N	\N	175063	175063	342289
22890	35057	14	applied	\N	\N	\N	\N	175064	175064	342290
22890	35061	15	applied	\N	\N	\N	\N	175065	175065	342291
22890	35067	17	applied	\N	\N	1000000000	\N	175067	175067	342293
22890	35059	18	applied	\N	\N	\N	\N	175068	175068	342294
22890	35065	19	applied	\N	\N	\N	\N	175069	175069	342295
22890	35068	20	applied	\N	\N	\N	\N	175070	175070	342296
22890	35073	21	applied	\N	\N	\N	\N	175071	175071	342297
22890	35075	22	applied	\N	\N	\N	\N	175072	175072	342298
22890	35079	23	applied	\N	\N	\N	\N	175073	175073	342299
22890	35082	24	applied	\N	\N	\N	\N	175074	175074	342300
22890	35084	25	applied	\N	\N	\N	\N	175075	175075	342301
22890	35087	26	applied	\N	\N	\N	\N	175076	175076	342302
22890	35094	27	applied	\N	\N	\N	\N	175077	175077	342303
22890	35070	28	applied	\N	\N	\N	\N	175078	175078	342304
22890	35078	29	applied	\N	\N	\N	\N	175079	175079	342305
22890	35088	30	applied	\N	\N	\N	\N	175080	175080	342306
22890	35100	31	applied	\N	\N	\N	\N	175081	175081	342307
22890	35062	32	applied	\N	\N	\N	\N	175082	175082	342308
22890	35064	33	applied	\N	\N	\N	\N	175083	175083	342309
22890	35069	34	applied	\N	\N	\N	\N	175084	175084	342310
22890	35074	35	applied	\N	\N	\N	\N	175085	175085	342311
22890	35095	36	applied	\N	\N	\N	\N	175086	175086	342312
22890	35101	38	applied	\N	\N	\N	\N	175088	175088	342314
22890	35076	39	applied	\N	\N	\N	\N	175089	175089	342315
22890	35080	40	applied	\N	\N	\N	\N	175090	175090	342316
22890	35085	41	applied	\N	\N	\N	\N	175091	175091	342317
22890	35089	42	applied	\N	\N	\N	\N	175092	175092	342318
22890	35092	43	applied	\N	\N	\N	\N	175093	175093	342319
22890	35093	44	applied	\N	\N	\N	\N	175094	175094	342320
22890	35098	45	applied	\N	\N	\N	\N	175095	175095	342321
22890	35102	46	applied	\N	\N	\N	\N	175096	175096	342322
22892	35103	0	applied	\N	\N	\N	\N	175100	175100	342326
22892	35104	1	applied	\N	\N	\N	\N	175101	175101	342327
22892	35105	2	applied	\N	\N	\N	\N	175102	175102	342328
22897	35109	0	applied	\N	\N	\N	\N	175115	175115	342341
22897	35110	1	applied	\N	\N	\N	\N	175116	175116	342342
22897	35111	2	applied	\N	\N	\N	\N	175117	175117	342343
22897	35112	3	applied	\N	\N	\N	\N	175118	175118	342344
22899	35114	1	applied	\N	\N	\N	\N	175123	175123	342349
22899	35115	2	applied	\N	\N	\N	\N	175124	175124	342350
22902	35116	0	applied	\N	\N	\N	\N	175131	175131	342357
22902	35117	1	applied	\N	\N	\N	\N	175132	175132	342358
22902	35118	2	applied	\N	\N	\N	\N	175133	175133	342359
22908	35139	10	applied	\N	\N	\N	\N	175177	175177	342403
22908	35140	11	applied	\N	\N	\N	\N	175178	175178	342404
22909	35141	0	applied	\N	\N	\N	\N	175179	175179	342405
22909	35142	1	applied	\N	\N	\N	\N	175180	175180	342406
22909	35143	2	applied	\N	\N	\N	\N	175181	175181	342407
22911	35144	0	applied	\N	\N	\N	\N	175185	175185	342411
22911	35145	1	applied	\N	\N	\N	\N	175186	175186	342412
22911	35146	2	applied	\N	\N	\N	\N	175187	175187	342413
22913	35147	0	applied	\N	\N	\N	\N	175191	175191	342417
22913	35148	1	applied	\N	\N	\N	\N	175192	175192	342418
22913	35149	2	applied	\N	\N	\N	\N	175193	175193	342419
22913	35151	4	applied	\N	\N	\N	\N	175195	175195	342421
22913	35152	5	applied	\N	\N	\N	\N	175196	175196	342422
22913	35153	6	applied	\N	\N	\N	\N	175197	175197	342423
22913	35154	7	applied	\N	\N	\N	\N	175198	175198	342424
22913	35155	8	applied	\N	\N	\N	\N	175199	175199	342425
22913	35156	9	applied	\N	\N	\N	\N	175200	175200	342426
22914	35157	0	applied	\N	\N	\N	\N	175201	175201	342427
22914	35158	1	applied	\N	\N	\N	\N	175202	175202	342428
22914	35159	2	applied	\N	\N	\N	\N	175203	175203	342429
22914	35160	3	applied	\N	\N	\N	\N	175204	175204	342430
22918	35165	0	applied	\N	\N	\N	\N	175215	175215	342441
22918	35166	1	applied	\N	\N	\N	\N	175216	175216	342442
22918	35167	2	applied	\N	\N	\N	\N	175217	175217	342443
22918	35168	3	applied	\N	\N	\N	\N	175218	175218	342444
22919	35144	0	applied	\N	\N	\N	\N	175219	175219	342445
22919	35147	1	applied	\N	\N	\N	\N	175220	175220	342446
22919	35149	3	applied	\N	\N	\N	\N	175222	175222	342448
22920	35169	0	applied	\N	\N	\N	\N	175248	175248	342474
22920	35171	1	applied	\N	\N	\N	\N	175249	175249	342475
22920	35170	2	applied	\N	\N	\N	\N	175250	175250	342476
22846	35028	1	applied	\N	\N	\N	\N	174875	174875	342101
22846	35029	2	applied	\N	\N	\N	\N	174876	174876	342102
22860	35044	1	applied	\N	\N	\N	\N	174925	174925	342151
22860	35045	2	applied	\N	\N	\N	\N	174926	174926	342152
22860	35041	3	applied	\N	\N	\N	\N	174927	174927	342153
22861	35047	0	applied	\N	\N	\N	\N	174928	174928	342154
22861	35048	1	applied	\N	\N	\N	\N	174929	174929	342155
22861	35049	2	applied	\N	\N	\N	\N	174930	174930	342156
22861	35050	3	applied	\N	\N	\N	\N	174931	174931	342157
22865	35051	0	applied	\N	\N	\N	\N	174945	174945	342171
22865	35052	1	applied	\N	\N	\N	\N	174946	174946	342172
22865	35053	2	applied	\N	\N	\N	\N	174947	174947	342173
22865	35055	4	applied	\N	\N	\N	\N	174949	174949	342175
22872	35063	0	applied	\N	\N	\N	\N	174974	174974	342200
22872	35064	1	applied	\N	\N	\N	\N	174975	174975	342201
22872	35065	2	applied	\N	\N	\N	\N	174976	174976	342202
22875	35071	0	applied	\N	\N	\N	\N	174988	174988	342214
22875	35072	1	applied	\N	\N	\N	\N	174989	174989	342215
22875	35073	2	applied	\N	\N	\N	\N	174990	174990	342216
22875	35074	3	applied	\N	\N	\N	\N	174991	174991	342217
22875	35075	4	applied	\N	\N	\N	\N	174992	174992	342218
22875	35076	5	applied	\N	\N	\N	\N	174993	174993	342219
22877	35077	0	applied	\N	\N	\N	\N	174998	174998	342224
22877	35078	1	applied	\N	\N	\N	\N	174999	174999	342225
22877	35079	2	applied	\N	\N	\N	\N	175000	175000	342226
22877	35080	3	applied	\N	\N	\N	\N	175001	175001	342227
22882	35083	0	applied	\N	\N	\N	\N	175016	175016	342242
22882	35084	1	applied	\N	\N	\N	\N	175017	175017	342243
22882	35085	2	applied	\N	\N	\N	\N	175018	175018	342244
22885	35090	0	applied	\N	\N	\N	\N	175029	175029	342255
22885	35091	1	applied	\N	\N	\N	\N	175030	175030	342256
22885	35092	3	applied	\N	\N	\N	\N	175031	175031	342257
22885	35094	5	applied	\N	\N	\N	\N	175033	175033	342259
22885	35095	6	applied	\N	\N	\N	\N	175034	175034	342260
22887	35099	0	applied	\N	\N	\N	\N	175038	175038	342264
22887	35100	1	applied	\N	\N	\N	\N	175039	175039	342265
22887	35101	2	applied	\N	\N	\N	\N	175040	175040	342266
22887	35102	3	applied	\N	\N	\N	\N	175041	175041	342267
22889	35099	0	applied	\N	\N	\N	\N	175046	175046	342272
22889	35100	1	applied	\N	\N	\N	\N	175047	175047	342273
22889	35101	2	applied	\N	\N	\N	\N	175048	175048	342274
22889	35102	3	applied	\N	\N	\N	\N	175049	175049	342275
22894	35106	0	applied	\N	\N	\N	\N	175105	175105	342331
22894	35107	1	applied	\N	\N	\N	\N	175106	175106	342332
22894	35108	2	applied	\N	\N	\N	\N	175107	175107	342333
22903	35104	0	applied	\N	\N	\N	\N	175134	175134	342360
22903	35112	1	applied	\N	\N	\N	\N	175135	175135	342361
22903	35119	2	applied	\N	\N	\N	\N	175136	175136	342362
22903	35110	4	applied	\N	\N	\N	\N	175138	175138	342364
22903	35114	6	applied	\N	\N	\N	\N	175139	175139	342365
22903	35117	7	applied	\N	\N	\N	\N	175140	175140	342366
22903	35120	8	applied	\N	\N	\N	\N	175141	175141	342367
22906	35123	0	applied	\N	\N	\N	\N	175149	175149	342375
22906	35124	1	applied	\N	\N	\N	\N	175150	175150	342376
22906	35125	2	applied	\N	\N	\N	\N	175151	175151	342377
22916	35163	0	applied	\N	\N	\N	\N	175209	175209	342435
22916	35164	1	applied	\N	\N	\N	\N	175210	175210	342436
22919	35157	4	applied	\N	\N	\N	\N	175223	175223	342449
22919	35161	5	applied	\N	\N	\N	\N	175224	175224	342450
22919	35165	6	applied	\N	\N	\N	\N	175225	175225	342451
22919	35169	7	applied	\N	\N	\N	\N	175226	175226	342452
22919	35166	8	applied	\N	\N	\N	\N	175227	175227	342453
22919	35145	9	applied	\N	\N	\N	\N	175228	175228	342454
22919	35170	10	applied	\N	\N	\N	\N	175229	175229	342455
22919	35158	12	applied	\N	\N	\N	\N	175231	175231	342457
22919	35151	13	applied	\N	\N	\N	\N	175232	175232	342458
22919	35146	14	applied	\N	\N	\N	\N	175233	175233	342459
22919	35152	15	applied	\N	\N	\N	\N	175234	175234	342460
22919	35153	16	applied	\N	\N	\N	\N	175235	175235	342461
22919	35154	17	applied	\N	\N	\N	\N	175236	175236	342462
22919	35160	18	applied	\N	\N	\N	\N	175237	175237	342463
22919	35162	19	applied	\N	\N	\N	\N	175238	175238	342464
22919	35167	20	applied	\N	\N	\N	\N	175239	175239	342465
22919	35171	21	applied	\N	\N	\N	\N	175240	175240	342466
22919	35163	22	applied	\N	\N	\N	\N	175241	175241	342467
22923	35173	0	applied	\N	\N	\N	\N	175260	175260	342486
22923	35175	1	applied	\N	\N	\N	\N	175261	175261	342487
22923	35176	2	applied	\N	\N	\N	\N	175262	175262	342488
22925	35173	0	applied	\N	\N	\N	\N	175267	175267	342493
22925	35174	1	applied	\N	\N	\N	\N	175268	175268	342494
22925	35176	3	applied	\N	\N	\N	\N	175270	175270	342496
22927	35177	0	applied	\N	\N	\N	\N	175275	175275	342501
22927	35178	1	applied	\N	\N	\N	\N	175276	175276	342502
22927	35179	2	applied	\N	\N	\N	\N	175277	175277	342503
22930	35180	0	applied	\N	\N	\N	\N	175361	175361	342587
22930	35181	1	applied	\N	\N	\N	\N	175362	175362	342588
22930	35182	2	applied	\N	\N	\N	\N	175363	175363	342589
22931	35180	0	applied	\N	\N	\N	\N	175364	175364	342590
22937	35183	0	applied	\N	\N	\N	\N	175380	175380	342606
22937	35184	1	applied	\N	\N	\N	\N	175381	175381	342607
22937	35185	2	applied	\N	\N	\N	\N	175382	175382	342608
22937	35186	3	applied	\N	\N	\N	\N	175383	175383	342609
22940	35190	0	applied	\N	\N	\N	\N	175390	175390	342616
22940	35191	1	applied	\N	\N	\N	\N	175391	175391	342617
22940	35192	2	applied	\N	\N	\N	\N	175392	175392	342618
22945	35193	0	applied	\N	\N	\N	\N	175520	175520	342746
22945	35201	2	applied	\N	\N	\N	\N	175522	175522	342748
22945	35202	3	applied	\N	\N	\N	\N	175523	175523	342749
22945	35203	4	applied	\N	\N	\N	\N	175524	175524	342750
22945	35204	5	applied	\N	\N	\N	\N	175525	175525	342751
22945	35205	6	applied	\N	\N	\N	\N	175526	175526	342752
22945	35206	7	applied	\N	\N	\N	\N	175527	175527	342753
22945	35207	8	applied	\N	\N	\N	\N	175528	175528	342754
22945	35208	9	applied	\N	\N	\N	\N	175529	175529	342755
22945	35209	10	applied	\N	\N	\N	\N	175530	175530	342756
22945	35210	11	applied	\N	\N	\N	\N	175531	175531	342757
22945	35211	12	applied	\N	\N	\N	\N	175532	175532	342758
22945	35212	13	applied	\N	\N	\N	\N	175533	175533	342759
22945	35213	14	applied	\N	\N	\N	\N	175534	175534	342760
22945	35214	15	applied	\N	\N	\N	\N	175535	175535	342761
22948	35215	0	applied	\N	\N	\N	\N	175542	175542	342768
22855	35041	3	applied	\N	\N	\N	\N	174903	174903	342129
22860	35043	0	applied	\N	\N	1000000000	\N	174924	174924	342150
22873	35066	0	applied	\N	\N	\N	\N	174977	174977	342203
22873	35068	2	applied	\N	\N	\N	\N	174979	174979	342205
22873	35069	3	applied	\N	\N	\N	\N	174980	174980	342206
22873	35070	4	applied	\N	\N	\N	\N	174981	174981	342207
22876	35077	0	applied	\N	\N	\N	\N	174994	174994	342220
22876	35078	1	applied	\N	\N	\N	\N	174995	174995	342221
22876	35079	2	applied	\N	\N	\N	\N	174996	174996	342222
22876	35080	3	applied	\N	\N	\N	\N	174997	174997	342223
22878	35077	0	applied	\N	\N	\N	\N	175002	175002	342228
22878	35078	1	applied	\N	\N	\N	\N	175003	175003	342229
22878	35079	2	applied	\N	\N	\N	\N	175004	175004	342230
22878	35080	3	applied	\N	\N	\N	\N	175005	175005	342231
22880	35077	0	applied	\N	\N	\N	\N	175010	175010	342236
22880	35078	1	applied	\N	\N	\N	\N	175011	175011	342237
22880	35079	2	applied	\N	\N	\N	\N	175012	175012	342238
22880	35080	3	applied	\N	\N	\N	\N	175013	175013	342239
22883	35086	0	applied	\N	\N	\N	\N	175019	175019	342245
22883	35087	1	applied	\N	\N	\N	\N	175020	175020	342246
22883	35088	2	applied	\N	\N	\N	\N	175021	175021	342247
22883	35089	3	applied	\N	\N	\N	\N	175022	175022	342248
22886	35096	0	applied	\N	\N	\N	\N	175035	175035	342261
22886	35098	2	applied	\N	\N	\N	\N	175037	175037	342263
22895	35106	0	applied	\N	\N	\N	\N	175108	175108	342334
22895	35107	1	applied	\N	\N	\N	\N	175109	175109	342335
22895	35108	2	applied	\N	\N	\N	\N	175110	175110	342336
22900	35116	0	applied	\N	\N	\N	\N	175125	175125	342351
22900	35117	1	applied	\N	\N	\N	\N	175126	175126	342352
22900	35118	2	applied	\N	\N	\N	\N	175127	175127	342353
22904	35121	0	applied	\N	\N	\N	\N	175142	175142	342368
22904	35120	1	applied	\N	\N	\N	\N	175143	175143	342369
22904	35119	2	applied	\N	\N	\N	\N	175144	175144	342370
22904	35122	3	applied	\N	\N	\N	\N	175145	175145	342371
22907	35126	0	applied	\N	\N	\N	\N	175152	175152	342378
22907	35127	1	applied	\N	\N	\N	\N	175153	175153	342379
22907	35128	2	applied	\N	\N	\N	\N	175154	175154	342380
22907	35129	3	applied	\N	\N	\N	\N	175155	175155	342381
22907	35130	4	applied	\N	\N	\N	\N	175156	175156	342382
22907	35132	6	applied	\N	\N	\N	\N	175158	175158	342384
22907	35133	7	applied	\N	\N	\N	\N	175159	175159	342385
22907	35134	8	applied	\N	\N	\N	\N	175160	175160	342386
22907	35135	9	applied	\N	\N	\N	\N	175161	175161	342387
22907	35136	10	applied	\N	\N	\N	\N	175162	175162	342388
22907	35137	11	applied	\N	\N	\N	\N	175163	175163	342389
22907	35138	12	applied	\N	\N	\N	\N	175164	175164	342390
22907	35139	13	applied	\N	\N	\N	\N	175165	175165	342391
22907	35140	14	applied	\N	\N	\N	\N	175166	175166	342392
22910	35141	0	applied	\N	\N	\N	\N	175182	175182	342408
22910	35142	1	applied	\N	\N	\N	\N	175183	175183	342409
22910	35143	2	applied	\N	\N	\N	\N	175184	175184	342410
22912	35144	0	applied	\N	\N	\N	\N	175188	175188	342414
22912	35145	1	applied	\N	\N	\N	\N	175189	175189	342415
22912	35146	2	applied	\N	\N	\N	\N	175190	175190	342416
22915	35161	0	applied	\N	\N	\N	\N	175205	175205	342431
22915	35163	2	applied	\N	\N	\N	\N	175207	175207	342433
22915	35164	3	applied	\N	\N	\N	\N	175208	175208	342434
22917	35161	0	applied	\N	\N	\N	\N	175211	175211	342437
22917	35162	1	applied	\N	\N	\N	\N	175212	175212	342438
22917	35163	2	applied	\N	\N	\N	\N	175213	175213	342439
22917	35164	3	applied	\N	\N	\N	\N	175214	175214	342440
22928	35043	0	applied	\N	\N	1000000000	\N	175278	175278	342504
22928	35027	1	applied	\N	\N	1000000000	\N	175279	175279	342505
22928	35039	2	applied	\N	\N	\N	\N	175280	175280	342506
22928	35166	3	applied	\N	\N	\N	\N	175281	175281	342507
22928	35058	4	applied	\N	\N	1000000000	\N	175282	175282	342508
22928	35129	5	applied	\N	\N	\N	\N	175283	175283	342509
22928	35067	6	applied	\N	\N	1000000000	\N	175284	175284	342510
22928	35170	7	applied	\N	\N	\N	\N	175285	175285	342511
22928	35001	8	applied	\N	\N	\N	\N	175286	175286	342512
22928	34935	9	applied	\N	\N	\N	\N	175287	175287	342513
22928	35049	11	applied	\N	\N	\N	\N	175289	175289	342515
22928	34937	12	applied	\N	\N	\N	\N	175290	175290	342516
22928	34938	13	applied	\N	\N	\N	\N	175291	175291	342517
22928	35163	14	applied	\N	\N	\N	\N	175292	175292	342518
22928	35054	15	applied	\N	\N	1000000000	\N	175293	175293	342519
22928	35137	16	applied	\N	\N	\N	\N	175294	175294	342520
22928	35138	17	applied	\N	\N	\N	\N	175295	175295	342521
22928	35139	18	applied	\N	\N	\N	\N	175296	175296	342522
22928	35140	19	applied	\N	\N	\N	\N	175297	175297	342523
22935	35183	0	applied	\N	\N	\N	\N	175372	175372	342598
22935	35184	1	applied	\N	\N	\N	\N	175373	175373	342599
22935	35185	2	applied	\N	\N	\N	\N	175374	175374	342600
22935	35186	3	applied	\N	\N	\N	\N	175375	175375	342601
22944	35193	0	applied	\N	\N	\N	\N	175504	175504	342730
22944	35194	1	applied	\N	\N	\N	\N	175505	175505	342731
22944	35201	2	applied	\N	\N	\N	\N	175506	175506	342732
22944	35203	4	applied	\N	\N	\N	\N	175508	175508	342734
22944	35204	5	applied	\N	\N	\N	\N	175509	175509	342735
22944	35205	6	applied	\N	\N	\N	\N	175510	175510	342736
22944	35206	7	applied	\N	\N	\N	\N	175511	175511	342737
22944	35207	8	applied	\N	\N	\N	\N	175512	175512	342738
22944	35208	9	applied	\N	\N	\N	\N	175513	175513	342739
22948	35216	1	applied	\N	\N	\N	\N	175543	175543	342769
22948	35217	2	applied	\N	\N	\N	\N	175544	175544	342770
22954	35226	0	applied	\N	\N	\N	\N	175741	175741	342967
22954	35227	1	applied	\N	\N	\N	\N	175742	175742	342968
22954	35228	2	applied	\N	\N	\N	\N	175743	175743	342969
22958	35251	0	applied	\N	\N	\N	\N	175805	175805	343031
22958	35252	1	applied	\N	\N	\N	\N	175806	175806	343032
22958	35253	2	applied	\N	\N	\N	\N	175807	175807	343033
22958	35254	3	applied	\N	\N	\N	\N	175808	175808	343034
22960	35251	0	applied	\N	\N	\N	\N	175813	175813	343039
22960	35253	2	applied	\N	\N	\N	\N	175815	175815	343041
22960	35254	3	applied	\N	\N	\N	\N	175816	175816	343042
22962	35255	0	applied	\N	\N	\N	\N	175820	175820	343046
22962	35256	1	applied	\N	\N	\N	\N	175821	175821	343047
22962	35257	2	applied	\N	\N	\N	\N	175822	175822	343048
22964	35255	0	applied	\N	\N	\N	\N	175826	175826	343052
22964	35256	1	applied	\N	\N	\N	\N	175827	175827	343053
22964	35257	2	applied	\N	\N	\N	\N	175828	175828	343054
22869	35058	2	applied	\N	\N	1000000000	\N	174964	174964	342190
22869	35059	3	applied	\N	\N	\N	\N	174965	174965	342191
22919	35164	26	applied	\N	\N	\N	\N	175245	175245	342471
22919	35168	27	applied	\N	\N	\N	\N	175246	175246	342472
22919	35172	28	applied	\N	\N	\N	\N	175247	175247	342473
22921	35169	0	applied	\N	\N	\N	\N	175252	175252	342478
22921	35171	1	applied	\N	\N	\N	\N	175253	175253	342479
22921	35170	2	applied	\N	\N	\N	\N	175254	175254	342480
22921	35172	3	applied	\N	\N	\N	\N	175255	175255	342481
22934	35183	0	applied	\N	\N	\N	\N	175368	175368	342594
22934	35184	1	applied	\N	\N	\N	\N	175369	175369	342595
22934	35185	2	applied	\N	\N	\N	\N	175370	175370	342596
22934	35186	3	applied	\N	\N	\N	\N	175371	175371	342597
22938	35187	0	applied	\N	\N	\N	\N	175384	175384	342610
22938	35188	1	applied	\N	\N	\N	\N	175385	175385	342611
22941	35096	0	applied	\N	\N	\N	\N	175393	175393	342619
22941	35099	1	applied	\N	\N	\N	\N	175394	175394	342620
22941	35103	2	applied	\N	\N	\N	\N	175395	175395	342621
22941	35106	3	applied	\N	\N	\N	\N	175396	175396	342622
22941	35109	4	applied	\N	\N	\N	\N	175397	175397	342623
22941	35113	5	applied	\N	\N	\N	\N	175398	175398	342624
22941	35116	6	applied	\N	\N	\N	\N	175399	175399	342625
22941	35121	7	applied	\N	\N	\N	\N	175400	175400	342626
22941	35123	8	applied	\N	\N	\N	\N	175401	175401	342627
22941	35126	9	applied	\N	\N	\N	\N	175402	175402	342628
22941	35127	10	applied	\N	\N	\N	\N	175403	175403	342629
22941	35128	11	applied	\N	\N	\N	\N	175404	175404	342630
22941	35141	12	applied	\N	\N	\N	\N	175405	175405	342631
22941	35144	13	applied	\N	\N	\N	\N	175406	175406	342632
22941	35147	14	applied	\N	\N	\N	\N	175407	175407	342633
22941	35148	15	applied	\N	\N	\N	\N	175408	175408	342634
22941	35157	17	applied	\N	\N	\N	\N	175410	175410	342636
22941	35161	18	applied	\N	\N	\N	\N	175411	175411	342637
22941	35165	19	applied	\N	\N	\N	\N	175412	175412	342638
22941	35169	20	applied	\N	\N	\N	\N	175413	175413	342639
22941	35173	21	applied	\N	\N	\N	\N	175414	175414	342640
22941	35177	22	applied	\N	\N	\N	\N	175415	175415	342641
22941	35180	23	applied	\N	\N	\N	\N	175416	175416	342642
22941	35183	24	applied	\N	\N	\N	\N	175417	175417	342643
22941	35187	25	applied	\N	\N	\N	\N	175418	175418	342644
22941	35190	26	applied	\N	\N	\N	\N	175419	175419	342645
22941	35166	27	applied	\N	\N	\N	\N	175420	175420	342646
22941	35129	28	applied	\N	\N	\N	\N	175421	175421	342647
22941	35170	29	applied	\N	\N	\N	\N	175422	175422	342648
22941	35100	30	applied	\N	\N	\N	\N	175423	175423	342649
22941	35112	31	applied	\N	\N	\N	\N	175424	175424	342650
22941	35119	32	applied	\N	\N	\N	\N	175425	175425	342651
22941	35150	34	applied	\N	\N	\N	\N	175427	175427	342653
22941	35158	35	applied	\N	\N	\N	\N	175428	175428	342654
22941	35176	36	applied	\N	\N	\N	\N	175429	175429	342655
22941	35185	37	applied	\N	\N	\N	\N	175430	175430	342656
22941	35163	38	applied	\N	\N	\N	\N	175431	175431	342657
22941	35097	39	applied	\N	\N	\N	\N	175432	175432	342658
22941	35101	40	applied	\N	\N	\N	\N	175433	175433	342659
22941	35104	41	applied	\N	\N	\N	\N	175434	175434	342660
22941	35108	42	applied	\N	\N	\N	\N	175435	175435	342661
22941	35110	43	applied	\N	\N	\N	\N	175436	175436	342662
22941	35114	44	applied	\N	\N	\N	\N	175437	175437	342663
22941	35117	45	applied	\N	\N	\N	\N	175438	175438	342664
22941	35120	46	applied	\N	\N	\N	\N	175439	175439	342665
22941	35125	47	applied	\N	\N	\N	\N	175440	175440	342666
22941	35134	48	applied	\N	\N	\N	\N	175441	175441	342667
22941	35135	49	applied	\N	\N	\N	\N	175442	175442	342668
22941	35142	51	applied	\N	\N	\N	\N	175444	175444	342670
22941	35145	52	applied	\N	\N	\N	\N	175445	175445	342671
22941	35151	53	applied	\N	\N	\N	\N	175446	175446	342672
22941	35137	54	applied	\N	\N	\N	\N	175447	175447	342673
22941	35138	55	applied	\N	\N	\N	\N	175448	175448	342674
22941	35139	56	applied	\N	\N	\N	\N	175449	175449	342675
22941	35140	57	applied	\N	\N	\N	\N	175450	175450	342676
22941	35155	58	applied	\N	\N	\N	\N	175451	175451	342677
22941	35156	59	applied	\N	\N	\N	\N	175452	175452	342678
22941	35159	60	applied	\N	\N	\N	\N	175453	175453	342679
22941	35164	61	applied	\N	\N	\N	\N	175454	175454	342680
22941	35168	62	applied	\N	\N	\N	\N	175455	175455	342681
22941	35172	63	applied	\N	\N	\N	\N	175456	175456	342682
22941	35175	64	applied	\N	\N	\N	\N	175457	175457	342683
22941	35178	65	applied	\N	\N	\N	\N	175458	175458	342684
22941	35181	66	applied	\N	\N	\N	\N	175459	175459	342685
22941	35188	68	applied	\N	\N	\N	\N	175461	175461	342687
22941	35191	69	applied	\N	\N	\N	\N	175462	175462	342688
22941	35098	70	applied	\N	\N	\N	\N	175463	175463	342689
22941	35102	71	applied	\N	\N	\N	\N	175464	175464	342690
22941	35105	72	applied	\N	\N	\N	\N	175465	175465	342691
22941	35107	73	applied	\N	\N	\N	\N	175466	175466	342692
22941	35111	74	applied	\N	\N	\N	\N	175467	175467	342693
22941	35115	75	applied	\N	\N	\N	\N	175468	175468	342694
22941	35118	76	applied	\N	\N	\N	\N	175469	175469	342695
22941	35122	77	applied	\N	\N	\N	\N	175470	175470	342696
22941	35124	78	applied	\N	\N	\N	\N	175471	175471	342697
22941	35130	79	applied	\N	\N	\N	\N	175472	175472	342698
22941	35131	80	applied	\N	\N	\N	\N	175473	175473	342699
22941	35132	81	applied	\N	\N	\N	\N	175474	175474	342700
22941	35143	82	applied	\N	\N	\N	\N	175475	175475	342701
22944	35209	10	applied	\N	\N	\N	\N	175514	175514	342740
22944	35211	12	applied	\N	\N	\N	\N	175516	175516	342742
22944	35212	13	applied	\N	\N	\N	\N	175517	175517	342743
22944	35213	14	applied	\N	\N	\N	\N	175518	175518	342744
22944	35214	15	applied	\N	\N	\N	\N	175519	175519	342745
22947	35215	0	applied	\N	\N	\N	\N	175539	175539	342765
22947	35216	1	applied	\N	\N	\N	\N	175540	175540	342766
22947	35217	2	applied	\N	\N	\N	\N	175541	175541	342767
22950	34890	0	applied	\N	\N	\N	\N	175548	175548	342774
22950	35043	1	applied	\N	\N	1000000000	\N	175549	175549	342775
22950	34654	2	applied	\N	\N	\N	\N	175550	175550	342776
22950	34660	3	applied	\N	\N	\N	\N	175551	175551	342777
22950	34661	4	applied	\N	\N	\N	\N	175552	175552	342778
22950	35027	5	applied	\N	\N	1000000000	\N	175553	175553	342779
22950	35039	6	applied	\N	\N	\N	\N	175554	175554	342780
22950	34618	7	applied	\N	\N	\N	\N	175555	175555	342781
22950	34619	8	applied	\N	\N	\N	\N	175556	175556	342782
22919	35156	24	applied	\N	\N	\N	\N	175243	175243	342469
22919	35159	25	applied	\N	\N	\N	\N	175244	175244	342470
22922	35176	3	applied	\N	\N	\N	\N	175259	175259	342485
22924	35173	0	applied	\N	\N	\N	\N	175263	175263	342489
22924	35174	1	applied	\N	\N	\N	\N	175264	175264	342490
22924	35175	2	applied	\N	\N	\N	\N	175265	175265	342491
22924	35176	3	applied	\N	\N	\N	\N	175266	175266	342492
22926	35173	0	applied	\N	\N	\N	\N	175271	175271	342497
22926	35174	1	applied	\N	\N	\N	\N	175272	175272	342498
22926	35175	2	applied	\N	\N	\N	\N	175273	175273	342499
22926	35176	3	applied	\N	\N	\N	\N	175274	175274	342500
22929	35116	0	applied	\N	\N	\N	\N	175298	175298	342524
22929	35121	1	applied	\N	\N	\N	\N	175299	175299	342525
22929	35123	2	applied	\N	\N	\N	\N	175300	175300	342526
22929	35126	3	applied	\N	\N	\N	\N	175301	175301	342527
22929	35127	4	applied	\N	\N	\N	\N	175302	175302	342528
22929	35128	5	applied	\N	\N	\N	\N	175303	175303	342529
22929	35141	6	applied	\N	\N	\N	\N	175304	175304	342530
22929	35147	8	applied	\N	\N	\N	\N	175306	175306	342532
22929	35148	9	applied	\N	\N	\N	\N	175307	175307	342533
22929	35149	10	applied	\N	\N	\N	\N	175308	175308	342534
22929	35157	11	applied	\N	\N	\N	\N	175309	175309	342535
22929	35161	12	applied	\N	\N	\N	\N	175310	175310	342536
22929	35165	13	applied	\N	\N	\N	\N	175311	175311	342537
22929	35169	14	applied	\N	\N	\N	\N	175312	175312	342538
22929	35173	15	applied	\N	\N	\N	\N	175313	175313	342539
22929	35177	16	applied	\N	\N	\N	\N	175314	175314	342540
22929	35166	17	applied	\N	\N	\N	\N	175315	175315	342541
22929	35129	18	applied	\N	\N	\N	\N	175316	175316	342542
22929	35117	19	applied	\N	\N	\N	\N	175317	175317	342543
22929	35120	20	applied	\N	\N	\N	\N	175318	175318	342544
22929	35170	21	applied	\N	\N	\N	\N	175319	175319	342545
22929	35119	22	applied	\N	\N	\N	\N	175320	175320	342546
22929	35133	23	applied	\N	\N	\N	\N	175321	175321	342547
22929	35158	25	applied	\N	\N	\N	\N	175323	175323	342549
22929	35176	26	applied	\N	\N	\N	\N	175324	175324	342550
22929	35125	27	applied	\N	\N	\N	\N	175325	175325	342551
22929	35134	28	applied	\N	\N	\N	\N	175326	175326	342552
22929	35135	29	applied	\N	\N	\N	\N	175327	175327	342553
22929	35136	30	applied	\N	\N	\N	\N	175328	175328	342554
22929	35142	31	applied	\N	\N	\N	\N	175329	175329	342555
22929	35145	32	applied	\N	\N	\N	\N	175330	175330	342556
22929	35151	33	applied	\N	\N	\N	\N	175331	175331	342557
22929	35118	34	applied	\N	\N	\N	\N	175332	175332	342558
22929	35163	35	applied	\N	\N	\N	\N	175333	175333	342559
22929	35137	36	applied	\N	\N	\N	\N	175334	175334	342560
22929	35138	37	applied	\N	\N	\N	\N	175335	175335	342561
22929	35139	38	applied	\N	\N	\N	\N	175336	175336	342562
22929	35140	39	applied	\N	\N	\N	\N	175337	175337	342563
22929	35155	40	applied	\N	\N	\N	\N	175338	175338	342564
22929	35159	42	applied	\N	\N	\N	\N	175340	175340	342566
22929	35164	43	applied	\N	\N	\N	\N	175341	175341	342567
22929	35168	44	applied	\N	\N	\N	\N	175342	175342	342568
22929	35172	45	applied	\N	\N	\N	\N	175343	175343	342569
22929	35175	46	applied	\N	\N	\N	\N	175344	175344	342570
22929	35122	47	applied	\N	\N	\N	\N	175345	175345	342571
22929	35124	48	applied	\N	\N	\N	\N	175346	175346	342572
22929	35130	49	applied	\N	\N	\N	\N	175347	175347	342573
22929	35131	50	applied	\N	\N	\N	\N	175348	175348	342574
22929	35132	51	applied	\N	\N	\N	\N	175349	175349	342575
22929	35143	52	applied	\N	\N	\N	\N	175350	175350	342576
22929	35146	53	applied	\N	\N	\N	\N	175351	175351	342577
22929	35152	54	applied	\N	\N	\N	\N	175352	175352	342578
22929	35153	55	applied	\N	\N	\N	\N	175353	175353	342579
22929	35154	56	applied	\N	\N	\N	\N	175354	175354	342580
22929	35160	57	applied	\N	\N	\N	\N	175355	175355	342581
22929	35167	59	applied	\N	\N	\N	\N	175357	175357	342583
22929	35171	60	applied	\N	\N	\N	\N	175358	175358	342584
22929	35174	61	applied	\N	\N	\N	\N	175359	175359	342585
22929	35179	62	applied	\N	\N	\N	\N	175360	175360	342586
22933	35180	0	applied	\N	\N	\N	\N	175365	175365	342591
22933	35181	1	applied	\N	\N	\N	\N	175366	175366	342592
22933	35182	2	applied	\N	\N	\N	\N	175367	175367	342593
22936	35183	0	applied	\N	\N	\N	\N	175376	175376	342602
22936	35184	1	applied	\N	\N	\N	\N	175377	175377	342603
22936	35185	2	applied	\N	\N	\N	\N	175378	175378	342604
22936	35186	3	applied	\N	\N	\N	\N	175379	175379	342605
22939	35187	0	applied	\N	\N	\N	\N	175387	175387	342613
22939	35188	1	applied	\N	\N	\N	\N	175388	175388	342614
22939	35189	2	applied	\N	\N	\N	\N	175389	175389	342615
22941	35146	83	applied	\N	\N	\N	\N	175476	175476	342702
22941	35152	84	applied	\N	\N	\N	\N	175477	175477	342703
22941	35154	86	applied	\N	\N	\N	\N	175479	175479	342705
22941	35160	87	applied	\N	\N	\N	\N	175480	175480	342706
22941	35162	88	applied	\N	\N	\N	\N	175481	175481	342707
22941	35167	89	applied	\N	\N	\N	\N	175482	175482	342708
22941	35171	90	applied	\N	\N	\N	\N	175483	175483	342709
22941	35174	91	applied	\N	\N	\N	\N	175484	175484	342710
22941	35179	92	applied	\N	\N	\N	\N	175485	175485	342711
22941	35182	93	applied	\N	\N	\N	\N	175486	175486	342712
22941	35186	94	applied	\N	\N	\N	\N	175487	175487	342713
22941	35189	95	applied	\N	\N	\N	\N	175488	175488	342714
22941	35192	96	applied	\N	\N	\N	\N	175489	175489	342715
22942	35193	0	applied	\N	\N	\N	\N	175490	175490	342716
22942	35194	1	applied	\N	\N	\N	\N	175491	175491	342717
22942	35195	2	applied	\N	\N	\N	\N	175492	175492	342718
22942	35196	3	applied	\N	\N	\N	\N	175493	175493	342719
22942	35197	4	applied	\N	\N	\N	\N	175494	175494	342720
22942	35199	6	applied	\N	\N	\N	\N	175496	175496	342722
22942	35200	7	applied	\N	\N	\N	\N	175497	175497	342723
22943	35195	0	applied	\N	\N	\N	\N	175498	175498	342724
22943	35196	1	applied	\N	\N	\N	\N	175499	175499	342725
22943	35197	2	applied	\N	\N	\N	\N	175500	175500	342726
22943	35198	3	applied	\N	\N	\N	\N	175501	175501	342727
22943	35199	4	applied	\N	\N	\N	\N	175502	175502	342728
22943	35200	5	applied	\N	\N	\N	\N	175503	175503	342729
22952	35218	0	applied	\N	\N	\N	\N	175681	175681	342907
22952	35219	1	applied	\N	\N	\N	\N	175682	175682	342908
22952	35220	2	applied	\N	\N	\N	\N	175683	175683	342909
22952	35221	3	applied	\N	\N	\N	\N	175684	175684	342910
22952	35222	4	applied	\N	\N	\N	\N	175685	175685	342911
22952	35223	5	applied	\N	\N	\N	\N	175686	175686	342912
22922	35173	0	applied	\N	\N	\N	\N	175256	175256	342482
22922	35174	1	applied	\N	\N	\N	\N	175257	175257	342483
22949	35216	1	applied	\N	\N	\N	\N	175546	175546	342772
22949	35217	2	applied	\N	\N	\N	\N	175547	175547	342773
22952	35224	6	applied	\N	\N	\N	\N	175687	175687	342913
22952	35225	7	applied	\N	\N	\N	\N	175688	175688	342914
22955	35229	0	applied	\N	\N	\N	\N	175744	175744	342970
22955	35230	1	applied	\N	\N	\N	\N	175745	175745	342971
22955	35231	2	applied	\N	\N	\N	\N	175746	175746	342972
22957	35232	0	applied	\N	\N	\N	\N	175786	175786	343012
22957	35233	1	applied	\N	\N	\N	\N	175787	175787	343013
22957	35234	2	applied	\N	\N	1000000000	\N	175788	175788	343014
22957	35235	3	applied	\N	\N	\N	\N	175789	175789	343015
22957	35236	4	applied	\N	\N	\N	\N	175790	175790	343016
22957	35237	5	applied	\N	\N	\N	\N	175791	175791	343017
22957	35238	6	applied	\N	\N	\N	\N	175792	175792	343018
22957	35240	8	applied	\N	\N	\N	\N	175794	175794	343020
22957	35241	9	applied	\N	\N	\N	\N	175795	175795	343021
22957	35242	10	applied	\N	\N	\N	\N	175796	175796	343022
22957	35243	11	applied	\N	\N	\N	\N	175797	175797	343023
22957	35244	12	applied	\N	\N	\N	\N	175798	175798	343024
22957	35245	13	applied	\N	\N	\N	\N	175799	175799	343025
22957	35246	14	applied	\N	\N	\N	\N	175800	175800	343026
22957	35247	15	applied	\N	\N	\N	\N	175801	175801	343027
22957	35248	16	applied	\N	\N	\N	\N	175802	175802	343028
22957	35249	17	applied	\N	\N	\N	\N	175803	175803	343029
22959	35251	0	applied	\N	\N	\N	\N	175809	175809	343035
22959	35252	1	applied	\N	\N	\N	\N	175810	175810	343036
22959	35253	2	applied	\N	\N	\N	\N	175811	175811	343037
22959	35254	3	applied	\N	\N	\N	\N	175812	175812	343038
22963	35255	0	applied	\N	\N	\N	\N	175823	175823	343049
22963	35256	1	applied	\N	\N	\N	\N	175824	175824	343050
22968	35262	0	applied	\N	\N	\N	\N	175838	175838	343064
22968	35263	1	applied	\N	\N	\N	\N	175839	175839	343065
22968	35264	2	applied	\N	\N	\N	\N	175840	175840	343066
22968	35265	3	applied	\N	\N	\N	\N	175841	175841	343067
22968	35266	4	applied	\N	\N	\N	\N	175842	175842	343068
22968	35267	5	applied	\N	\N	\N	\N	175843	175843	343069
22974	35270	0	applied	\N	\N	\N	\N	175856	175856	343082
22974	35271	1	applied	\N	\N	\N	\N	175857	175857	343083
22974	35272	2	applied	\N	\N	\N	\N	175858	175858	343084
22976	35274	0	applied	\N	\N	\N	\N	175862	175862	343088
22976	35276	1	applied	\N	\N	\N	\N	175863	175863	343089
22979	35277	0	applied	\N	\N	\N	\N	175868	175868	343094
22979	35278	1	applied	\N	\N	\N	\N	175869	175869	343095
22982	35279	0	applied	\N	\N	\N	\N	175998	175998	343224
22982	35280	1	applied	\N	\N	\N	\N	175999	175999	343225
22982	35281	2	applied	\N	\N	\N	\N	176000	176000	343226
22982	35283	4	applied	\N	\N	\N	\N	176002	176002	343228
22982	35284	5	applied	\N	\N	\N	\N	176003	176003	343229
22982	35285	6	applied	\N	\N	\N	\N	176004	176004	343230
22982	35286	7	applied	\N	\N	\N	\N	176005	176005	343231
22985	35287	0	applied	\N	\N	\N	\N	176016	176016	343242
22985	35288	1	applied	\N	\N	\N	\N	176017	176017	343243
22985	35289	2	applied	\N	\N	\N	\N	176018	176018	343244
22985	35294	3	applied	\N	\N	\N	\N	176019	176019	343245
22985	35290	4	applied	\N	\N	\N	\N	176020	176020	343246
22985	35295	5	applied	\N	\N	\N	\N	176021	176021	343247
22985	35291	6	applied	\N	\N	\N	\N	176022	176022	343248
22985	35292	7	applied	\N	\N	\N	\N	176023	176023	343249
22985	35293	8	applied	\N	\N	\N	\N	176024	176024	343250
22985	35296	9	applied	\N	\N	\N	\N	176025	176025	343251
22987	35294	0	applied	\N	\N	\N	\N	176028	176028	343254
22987	35297	1	applied	\N	\N	\N	\N	176029	176029	343255
22987	35299	3	applied	\N	\N	\N	\N	176031	176031	343257
22987	35300	4	applied	\N	\N	\N	\N	176032	176032	343258
22987	35301	5	applied	\N	\N	\N	\N	176033	176033	343259
22995	35316	0	applied	\N	\N	\N	\N	176064	176064	343290
22995	35317	1	applied	\N	\N	\N	\N	176065	176065	343291
22995	35318	2	applied	\N	\N	\N	\N	176066	176066	343292
22995	35319	3	applied	\N	\N	\N	\N	176067	176067	343293
22995	35320	4	applied	\N	\N	\N	\N	176068	176068	343294
22995	35321	5	applied	\N	\N	\N	\N	176069	176069	343295
22996	35322	0	applied	\N	\N	\N	\N	176070	176070	343296
22996	35323	1	applied	\N	\N	\N	\N	176071	176071	343297
22996	35324	2	applied	\N	\N	\N	\N	176072	176072	343298
22996	35325	3	applied	\N	\N	\N	\N	176073	176073	343299
22996	35326	4	applied	\N	\N	\N	\N	176074	176074	343300
22996	35327	5	applied	\N	\N	\N	\N	176075	176075	343301
22996	35328	6	applied	\N	\N	\N	\N	176076	176076	343302
22996	35330	8	applied	\N	\N	\N	\N	176078	176078	343304
22996	35331	9	applied	\N	\N	\N	\N	176079	176079	343305
22996	35332	10	applied	\N	\N	\N	\N	176080	176080	343306
22996	35333	11	applied	\N	\N	\N	\N	176081	176081	343307
22996	35334	12	applied	\N	\N	\N	\N	176082	176082	343308
22996	35335	13	applied	\N	\N	\N	\N	176083	176083	343309
22998	35336	0	applied	\N	\N	\N	\N	176087	176087	343313
22998	35337	1	applied	\N	\N	\N	\N	176088	176088	343314
22998	35338	2	applied	\N	\N	\N	\N	176089	176089	343315
23002	35339	0	applied	\N	\N	\N	\N	176099	176099	343325
23002	35340	1	applied	\N	\N	\N	\N	176100	176100	343326
23002	35341	2	applied	\N	\N	\N	\N	176101	176101	343327
23005	35349	0	applied	\N	\N	\N	\N	176109	176109	343335
23005	35350	1	applied	\N	\N	\N	\N	176110	176110	343336
23005	35351	2	applied	\N	\N	\N	\N	176111	176111	343337
23007	35349	0	applied	\N	\N	\N	\N	176115	176115	343341
23007	35351	2	applied	\N	\N	\N	\N	176117	176117	343343
23008	35349	0	applied	\N	\N	\N	\N	176118	176118	343344
23008	35351	1	applied	\N	\N	\N	\N	176119	176119	343345
23011	35352	0	applied	\N	\N	\N	\N	176136	176136	343362
23011	35353	1	applied	\N	\N	\N	\N	176137	176137	343363
23011	35354	2	applied	\N	\N	\N	\N	176138	176138	343364
23011	35355	3	applied	\N	\N	\N	\N	176139	176139	343365
23011	35356	4	applied	\N	\N	\N	\N	176140	176140	343366
23011	35350	5	applied	\N	\N	\N	\N	176141	176141	343367
23011	35357	6	applied	\N	\N	\N	\N	176142	176142	343368
23011	35358	7	applied	\N	\N	\N	\N	176143	176143	343369
23013	35359	0	applied	\N	\N	\N	\N	176151	176151	343377
23013	35360	1	applied	\N	\N	\N	\N	176152	176152	343378
23013	35361	2	applied	\N	\N	\N	\N	176153	176153	343379
23018	35362	0	applied	\N	\N	\N	\N	176171	176171	343397
23018	35363	1	applied	\N	\N	\N	\N	176172	176172	343398
22949	35215	0	applied	\N	\N	\N	\N	175545	175545	342771
22950	34638	14	applied	\N	\N	\N	\N	175562	175562	342788
22950	34641	15	applied	\N	\N	\N	\N	175563	175563	342789
22950	34644	16	applied	\N	\N	\N	\N	175564	175564	342790
22950	34645	17	applied	\N	\N	\N	\N	175565	175565	342791
22950	34651	18	applied	\N	\N	\N	\N	175566	175566	342792
22950	34655	19	applied	\N	\N	\N	\N	175567	175567	342793
22950	34658	20	applied	\N	\N	\N	\N	175568	175568	342794
22950	34662	21	applied	\N	\N	\N	\N	175569	175569	342795
22950	34663	22	applied	\N	\N	\N	\N	175570	175570	342796
22950	34668	23	applied	\N	\N	\N	\N	175571	175571	342797
22950	34671	24	applied	\N	\N	\N	\N	175572	175572	342798
22950	34677	25	applied	\N	\N	\N	\N	175573	175573	342799
22950	34678	26	applied	\N	\N	\N	\N	175574	175574	342800
22950	34679	27	applied	\N	\N	\N	\N	175575	175575	342801
22950	34680	28	applied	\N	\N	\N	\N	175576	175576	342802
22950	34686	29	applied	\N	\N	\N	\N	175577	175577	342803
22950	34696	31	applied	\N	\N	\N	\N	175579	175579	342805
22950	34697	32	applied	\N	\N	\N	\N	175580	175580	342806
22950	34698	33	applied	\N	\N	\N	\N	175581	175581	342807
22950	34703	34	applied	\N	\N	\N	\N	175582	175582	342808
22950	34705	35	applied	\N	\N	\N	\N	175583	175583	342809
22950	34706	36	applied	\N	\N	\N	\N	175584	175584	342810
22950	34710	37	applied	\N	\N	\N	\N	175585	175585	342811
22950	34711	38	applied	\N	\N	\N	\N	175586	175586	342812
22950	34716	39	applied	\N	\N	\N	\N	175587	175587	342813
22950	34717	40	applied	\N	\N	\N	\N	175588	175588	342814
22950	34720	41	applied	\N	\N	\N	\N	175589	175589	342815
22950	34722	42	applied	\N	\N	\N	\N	175590	175590	342816
22950	34725	43	applied	\N	\N	\N	\N	175591	175591	342817
22950	34727	44	applied	\N	\N	\N	\N	175592	175592	342818
22950	34729	45	applied	\N	\N	\N	\N	175593	175593	342819
22950	34732	46	applied	\N	\N	\N	\N	175594	175594	342820
22950	34735	49	applied	\N	\N	\N	\N	175596	175596	342822
22950	34738	50	applied	\N	\N	\N	\N	175597	175597	342823
22950	34740	51	applied	\N	\N	\N	\N	175598	175598	342824
22950	34741	52	applied	\N	\N	\N	\N	175599	175599	342825
22950	34744	53	applied	\N	\N	\N	\N	175600	175600	342826
22950	34747	54	applied	\N	\N	\N	\N	175601	175601	342827
22950	34750	55	applied	\N	\N	\N	\N	175602	175602	342828
22950	34753	56	applied	\N	\N	\N	\N	175603	175603	342829
22950	34754	57	applied	\N	\N	\N	\N	175604	175604	342830
22950	34755	58	applied	\N	\N	\N	\N	175605	175605	342831
22950	34756	59	applied	\N	\N	\N	\N	175606	175606	342832
22950	34767	60	applied	\N	\N	\N	\N	175607	175607	342833
22950	34768	61	applied	\N	\N	\N	\N	175608	175608	342834
22950	34773	62	applied	\N	\N	\N	\N	175609	175609	342835
22950	34777	63	applied	\N	\N	\N	\N	175610	175610	342836
22950	34781	64	applied	\N	\N	\N	\N	175611	175611	342837
22950	34787	66	applied	\N	\N	\N	\N	175613	175613	342839
22950	34788	67	applied	\N	\N	\N	\N	175614	175614	342840
22950	34794	68	applied	\N	\N	\N	\N	175615	175615	342841
22950	34797	69	applied	\N	\N	\N	\N	175616	175616	342842
22950	34801	70	applied	\N	\N	\N	\N	175617	175617	342843
22950	34804	71	applied	\N	\N	\N	\N	175618	175618	342844
22950	34805	72	applied	\N	\N	\N	\N	175619	175619	342845
22950	34806	73	applied	\N	\N	\N	\N	175620	175620	342846
22950	34814	74	applied	\N	\N	\N	\N	175621	175621	342847
22950	34817	75	applied	\N	\N	\N	\N	175622	175622	342848
22950	34820	76	applied	\N	\N	\N	\N	175623	175623	342849
22950	34824	77	applied	\N	\N	\N	\N	175624	175624	342850
22950	34825	78	applied	\N	\N	\N	\N	175625	175625	342851
22950	34830	79	applied	\N	\N	\N	\N	175626	175626	342852
22950	34833	80	applied	\N	\N	\N	\N	175627	175627	342853
22950	34836	81	applied	\N	\N	\N	\N	175628	175628	342854
22950	34842	83	applied	\N	\N	\N	\N	175630	175630	342856
22950	34846	84	applied	\N	\N	\N	\N	175631	175631	342857
22950	34847	85	applied	\N	\N	\N	\N	175632	175632	342858
22950	34852	86	applied	\N	\N	\N	\N	175633	175633	342859
22950	34853	87	applied	\N	\N	\N	\N	175634	175634	342860
22950	34854	88	applied	\N	\N	\N	\N	175635	175635	342861
22950	34855	89	applied	\N	\N	\N	\N	175636	175636	342862
22950	34856	90	applied	\N	\N	\N	\N	175637	175637	342863
22950	34857	91	applied	\N	\N	\N	\N	175638	175638	342864
22950	34873	92	applied	\N	\N	\N	\N	175639	175639	342865
22950	34876	93	applied	\N	\N	\N	\N	175640	175640	342866
22950	34880	94	applied	\N	\N	\N	\N	175641	175641	342867
22950	34883	95	applied	\N	\N	\N	\N	175642	175642	342868
22950	34886	96	applied	\N	\N	\N	\N	175643	175643	342869
22950	34891	97	applied	\N	\N	\N	\N	175644	175644	342870
22950	34892	98	applied	\N	\N	\N	\N	175645	175645	342871
22950	34900	100	applied	\N	\N	\N	\N	175647	175647	342873
22950	34904	101	applied	\N	\N	\N	\N	175648	175648	342874
22950	34907	102	applied	\N	\N	\N	\N	175649	175649	342875
22950	34912	103	applied	\N	\N	\N	\N	175650	175650	342876
22950	34913	104	applied	\N	\N	\N	\N	175651	175651	342877
22950	34919	105	applied	\N	\N	\N	\N	175652	175652	342878
22950	34920	106	applied	\N	\N	\N	\N	175653	175653	342879
22950	34930	107	applied	\N	\N	\N	\N	175654	175654	342880
22950	34933	108	applied	\N	\N	\N	\N	175655	175655	342881
22950	34934	109	applied	\N	\N	\N	\N	175656	175656	342882
22950	34939	110	applied	\N	\N	\N	\N	175657	175657	342883
23018	35364	2	applied	\N	\N	\N	\N	176173	176173	343399
23018	35365	3	applied	\N	\N	\N	\N	176174	176174	343400
23018	35366	4	applied	\N	\N	\N	\N	176175	176175	343401
23018	35367	5	applied	\N	\N	\N	\N	176176	176176	343402
23018	35368	6	applied	\N	\N	\N	\N	176177	176177	343403
23018	35370	8	applied	\N	\N	\N	\N	176179	176179	343405
23018	35371	9	applied	\N	\N	\N	\N	176180	176180	343406
23018	35372	10	applied	\N	\N	\N	\N	176181	176181	343407
23018	35373	11	applied	\N	\N	\N	\N	176182	176182	343408
23018	35374	12	applied	\N	\N	\N	\N	176183	176183	343409
23022	35375	0	applied	\N	\N	\N	\N	176255	176255	343481
23022	35376	1	applied	\N	\N	\N	\N	176256	176256	343482
23022	35377	2	applied	\N	\N	\N	\N	176257	176257	343483
23025	35375	0	applied	\N	\N	\N	\N	176261	176261	343487
23025	35376	1	applied	\N	\N	\N	\N	176262	176262	343488
23025	35377	2	applied	\N	\N	\N	\N	176263	176263	343489
23027	35375	0	applied	\N	\N	\N	\N	176267	176267	343493
23031	35378	0	applied	\N	\N	\N	\N	176273	176273	343499
23031	35379	1	applied	\N	\N	\N	\N	176274	176274	343500
22950	34631	11	applied	\N	\N	\N	\N	175559	175559	342785
22950	34664	12	applied	\N	\N	\N	\N	175560	175560	342786
22950	34956	115	applied	\N	\N	\N	\N	175662	175662	342888
22950	34959	116	applied	\N	\N	\N	\N	175663	175663	342889
22950	34962	117	applied	\N	\N	\N	\N	175664	175664	342890
22950	34965	118	applied	\N	\N	\N	\N	175665	175665	342891
22950	34970	119	applied	\N	\N	\N	\N	175666	175666	342892
22950	34971	120	applied	\N	\N	\N	\N	175667	175667	342893
22950	34977	121	applied	\N	\N	\N	\N	175668	175668	342894
22950	34980	122	applied	\N	\N	\N	\N	175669	175669	342895
22950	34984	123	applied	\N	\N	\N	\N	175670	175670	342896
22950	34987	124	applied	\N	\N	\N	\N	175671	175671	342897
22950	34988	125	applied	\N	\N	\N	\N	175672	175672	342898
22951	35218	0	applied	\N	\N	\N	\N	175673	175673	342899
22951	35219	1	applied	\N	\N	\N	\N	175674	175674	342900
22951	35220	2	applied	\N	\N	\N	\N	175675	175675	342901
22951	35221	3	applied	\N	\N	\N	\N	175676	175676	342902
22951	35222	4	applied	\N	\N	\N	\N	175677	175677	342903
22951	35224	6	applied	\N	\N	\N	\N	175679	175679	342905
22951	35225	7	applied	\N	\N	\N	\N	175680	175680	342906
22953	35177	0	applied	\N	\N	\N	\N	175689	175689	342915
22953	35180	1	applied	\N	\N	\N	\N	175690	175690	342916
22953	35183	2	applied	\N	\N	\N	\N	175691	175691	342917
22953	35187	3	applied	\N	\N	\N	\N	175692	175692	342918
22953	35190	4	applied	\N	\N	\N	\N	175693	175693	342919
22953	35193	5	applied	\N	\N	\N	\N	175694	175694	342920
22953	35194	6	applied	\N	\N	\N	\N	175695	175695	342921
22953	35201	7	applied	\N	\N	\N	\N	175696	175696	342922
22953	35202	8	applied	\N	\N	\N	\N	175697	175697	342923
22953	35203	9	applied	\N	\N	\N	\N	175698	175698	342924
22953	35215	10	applied	\N	\N	\N	\N	175699	175699	342925
22953	35218	11	applied	\N	\N	\N	\N	175700	175700	342926
22953	35219	12	applied	\N	\N	\N	\N	175701	175701	342927
22953	35226	13	applied	\N	\N	\N	\N	175702	175702	342928
22953	35181	16	applied	\N	\N	\N	\N	175704	175704	342930
22953	35184	17	applied	\N	\N	\N	\N	175705	175705	342931
22953	35185	18	applied	\N	\N	\N	\N	175706	175706	342932
22953	35223	19	applied	\N	\N	\N	\N	175707	175707	342933
22953	35179	20	applied	\N	\N	\N	\N	175708	175708	342934
22953	35188	21	applied	\N	\N	\N	\N	175709	175709	342935
22953	35191	22	applied	\N	\N	\N	\N	175710	175710	342936
22953	35195	23	applied	\N	\N	\N	\N	175711	175711	342937
22953	35198	24	applied	\N	\N	\N	\N	175712	175712	342938
22953	35199	25	applied	\N	\N	\N	\N	175713	175713	342939
22953	35200	26	applied	\N	\N	\N	\N	175714	175714	342940
22953	35204	27	applied	\N	\N	\N	\N	175715	175715	342941
22953	35222	28	applied	\N	\N	\N	\N	175716	175716	342942
22953	35208	29	applied	\N	\N	\N	\N	175717	175717	342943
22953	35209	30	applied	\N	\N	\N	\N	175718	175718	342944
22953	35210	31	applied	\N	\N	\N	\N	175719	175719	342945
22953	35212	33	applied	\N	\N	\N	\N	175721	175721	342947
22953	35216	34	applied	\N	\N	\N	\N	175722	175722	342948
22953	35213	35	applied	\N	\N	\N	\N	175723	175723	342949
22953	35214	36	applied	\N	\N	\N	\N	175724	175724	342950
22953	35182	37	applied	\N	\N	\N	\N	175725	175725	342951
22953	35186	38	applied	\N	\N	\N	\N	175726	175726	342952
22953	35189	39	applied	\N	\N	\N	\N	175727	175727	342953
22953	35192	40	applied	\N	\N	\N	\N	175728	175728	342954
22953	35196	41	applied	\N	\N	\N	\N	175729	175729	342955
22953	35197	42	applied	\N	\N	\N	\N	175730	175730	342956
22953	35205	43	applied	\N	\N	\N	\N	175731	175731	342957
22953	35206	44	applied	\N	\N	\N	\N	175732	175732	342958
22953	35207	45	applied	\N	\N	\N	\N	175733	175733	342959
22953	35217	46	applied	\N	\N	\N	\N	175734	175734	342960
22953	35220	47	applied	\N	\N	\N	\N	175735	175735	342961
22953	35221	48	applied	\N	\N	\N	\N	175736	175736	342962
22953	35224	50	applied	\N	\N	\N	\N	175738	175738	342964
22953	35225	51	applied	\N	\N	\N	\N	175739	175739	342965
22953	35228	52	applied	\N	\N	\N	\N	175740	175740	342966
22956	35193	0	applied	\N	\N	\N	\N	175747	175747	342973
22956	35194	1	applied	\N	\N	\N	\N	175748	175748	342974
22956	35201	2	applied	\N	\N	\N	\N	175749	175749	342975
22956	35202	3	applied	\N	\N	\N	\N	175750	175750	342976
22956	35203	4	applied	\N	\N	\N	\N	175751	175751	342977
22956	35215	5	applied	\N	\N	\N	\N	175752	175752	342978
22956	35218	6	applied	\N	\N	\N	\N	175753	175753	342979
22956	35219	7	applied	\N	\N	\N	\N	175754	175754	342980
22956	35226	8	applied	\N	\N	\N	\N	175755	175755	342981
22956	35229	9	applied	\N	\N	\N	\N	175756	175756	342982
22956	35223	10	applied	\N	\N	\N	\N	175757	175757	342983
22956	35195	11	applied	\N	\N	\N	\N	175758	175758	342984
22956	35196	12	applied	\N	\N	\N	\N	175759	175759	342985
22956	35198	14	applied	\N	\N	\N	\N	175761	175761	342987
22956	35199	15	applied	\N	\N	\N	\N	175762	175762	342988
22956	35200	16	applied	\N	\N	\N	\N	175763	175763	342989
22956	35204	17	applied	\N	\N	\N	\N	175764	175764	342990
22956	35222	18	applied	\N	\N	\N	\N	175765	175765	342991
22956	35205	19	applied	\N	\N	\N	\N	175766	175766	342992
22956	35206	20	applied	\N	\N	\N	\N	175767	175767	342993
22956	35207	21	applied	\N	\N	\N	\N	175768	175768	342994
22956	35208	23	applied	\N	\N	\N	\N	175769	175769	342995
22956	35209	24	applied	\N	\N	\N	\N	175770	175770	342996
22956	35210	25	applied	\N	\N	\N	\N	175771	175771	342997
22956	35211	26	applied	\N	\N	\N	\N	175772	175772	342998
22956	35212	27	applied	\N	\N	\N	\N	175773	175773	342999
22956	35216	28	applied	\N	\N	\N	\N	175774	175774	343000
22956	35213	29	applied	\N	\N	\N	\N	175775	175775	343001
22956	35214	30	applied	\N	\N	\N	\N	175776	175776	343002
22956	35220	32	applied	\N	\N	\N	\N	175778	175778	343004
22956	35221	33	applied	\N	\N	\N	\N	175779	175779	343005
22956	35227	34	applied	\N	\N	\N	\N	175780	175780	343006
22956	35230	35	applied	\N	\N	\N	\N	175781	175781	343007
22956	35224	36	applied	\N	\N	\N	\N	175782	175782	343008
22956	35225	37	applied	\N	\N	\N	\N	175783	175783	343009
22956	35228	38	applied	\N	\N	\N	\N	175784	175784	343010
22956	35231	39	applied	\N	\N	\N	\N	175785	175785	343011
22961	35255	0	applied	\N	\N	\N	\N	175817	175817	343043
22961	35256	1	applied	\N	\N	\N	\N	175818	175818	343044
22961	35257	2	applied	\N	\N	\N	\N	175819	175819	343045
22965	35256	0	applied	\N	\N	\N	\N	175829	175829	343055
22965	35257	1	applied	\N	\N	\N	\N	175830	175830	343056
22970	35268	0	applied	\N	\N	\N	\N	175846	175846	343072
22950	34946	112	applied	\N	\N	\N	\N	175659	175659	342885
22950	34949	113	applied	\N	\N	\N	\N	175660	175660	342886
22966	35260	2	applied	\N	\N	\N	\N	175833	175833	343059
22966	35261	3	applied	\N	\N	\N	\N	175834	175834	343060
22970	35269	1	applied	\N	\N	\N	\N	175847	175847	343073
22972	35269	1	applied	\N	\N	\N	\N	175851	175851	343077
22973	35270	0	applied	\N	\N	\N	\N	175852	175852	343078
22973	35271	1	applied	\N	\N	\N	\N	175853	175853	343079
22973	35272	2	applied	\N	\N	\N	\N	175854	175854	343080
22973	35273	3	applied	\N	\N	\N	\N	175855	175855	343081
22975	35274	0	applied	\N	\N	\N	\N	175859	175859	343085
22975	35275	1	applied	\N	\N	\N	\N	175860	175860	343086
22975	35276	2	applied	\N	\N	\N	\N	175861	175861	343087
22977	35277	0	applied	\N	\N	\N	\N	175864	175864	343090
22977	35278	1	applied	\N	\N	\N	\N	175865	175865	343091
22980	34939	0	applied	\N	\N	\N	\N	175870	175870	343096
22980	35043	1	applied	\N	\N	1000000000	\N	175871	175871	343097
22980	35234	2	applied	\N	\N	1000000000	\N	175872	175872	343098
22980	34943	3	applied	\N	\N	\N	\N	175873	175873	343099
22980	34946	4	applied	\N	\N	\N	\N	175874	175874	343100
22980	34949	5	applied	\N	\N	\N	\N	175875	175875	343101
22980	35027	7	applied	\N	\N	1000000000	\N	175877	175877	343103
22980	35039	8	applied	\N	\N	\N	\N	175878	175878	343104
22980	34956	9	applied	\N	\N	\N	\N	175879	175879	343105
22980	34959	10	applied	\N	\N	\N	\N	175880	175880	343106
22980	34962	11	applied	\N	\N	\N	\N	175881	175881	343107
22980	34965	12	applied	\N	\N	\N	\N	175882	175882	343108
22980	34970	13	applied	\N	\N	\N	\N	175883	175883	343109
22988	35294	0	applied	\N	\N	\N	\N	176034	176034	343260
22988	35299	1	applied	\N	\N	\N	\N	176035	176035	343261
22988	35300	2	applied	\N	\N	\N	\N	176036	176036	343262
22988	35301	3	applied	\N	\N	\N	\N	176037	176037	343263
22991	35305	0	applied	\N	\N	\N	\N	176047	176047	343273
22991	35306	1	applied	\N	\N	\N	\N	176048	176048	343274
22991	35303	2	applied	\N	\N	\N	\N	176049	176049	343275
22991	35307	3	applied	\N	\N	\N	\N	176050	176050	343276
22991	35308	4	applied	\N	\N	\N	\N	176051	176051	343277
22993	35310	1	applied	\N	\N	\N	\N	176058	176058	343284
22993	35311	2	applied	\N	\N	\N	\N	176059	176059	343285
22997	35336	0	applied	\N	\N	\N	\N	176084	176084	343310
22997	35337	1	applied	\N	\N	\N	\N	176085	176085	343311
22997	35338	2	applied	\N	\N	\N	\N	176086	176086	343312
23000	35339	0	applied	\N	\N	\N	\N	176093	176093	343319
23000	35340	1	applied	\N	\N	\N	\N	176094	176094	343320
23000	35341	2	applied	\N	\N	\N	\N	176095	176095	343321
23004	35345	0	applied	\N	\N	\N	\N	176105	176105	343331
23004	35346	1	applied	\N	\N	\N	\N	176106	176106	343332
23004	35347	2	applied	\N	\N	\N	\N	176107	176107	343333
23004	35348	3	applied	\N	\N	\N	\N	176108	176108	343334
23006	35349	0	applied	\N	\N	\N	\N	176112	176112	343338
23006	35350	1	applied	\N	\N	\N	\N	176113	176113	343339
23006	35351	2	applied	\N	\N	\N	\N	176114	176114	343340
23009	35352	0	applied	\N	\N	\N	\N	176120	176120	343346
23009	35354	2	applied	\N	\N	\N	\N	176122	176122	343348
23009	35355	3	applied	\N	\N	\N	\N	176123	176123	343349
23009	35356	4	applied	\N	\N	\N	\N	176124	176124	343350
23009	35350	5	applied	\N	\N	\N	\N	176125	176125	343351
23009	35357	6	applied	\N	\N	\N	\N	176126	176126	343352
23009	35358	7	applied	\N	\N	\N	\N	176127	176127	343353
23012	35352	0	applied	\N	\N	\N	\N	176144	176144	343370
23012	35353	1	applied	\N	\N	\N	\N	176145	176145	343371
23012	35354	2	applied	\N	\N	\N	\N	176146	176146	343372
23012	35355	3	applied	\N	\N	\N	\N	176147	176147	343373
23012	35356	4	applied	\N	\N	\N	\N	176148	176148	343374
23012	35357	5	applied	\N	\N	\N	\N	176149	176149	343375
23012	35358	6	applied	\N	\N	\N	\N	176150	176150	343376
23026	35375	0	applied	\N	\N	\N	\N	176264	176264	343490
23026	35376	1	applied	\N	\N	\N	\N	176265	176265	343491
23026	35377	2	applied	\N	\N	\N	\N	176266	176266	343492
23029	35379	1	applied	\N	\N	\N	\N	176269	176269	343495
23034	35387	0	applied	\N	\N	\N	\N	176286	176286	343512
23034	35388	1	applied	\N	\N	\N	\N	176287	176287	343513
23034	35389	2	applied	\N	\N	\N	\N	176288	176288	343514
23034	35390	3	applied	\N	\N	\N	\N	176289	176289	343515
23034	35391	4	applied	\N	\N	\N	\N	176290	176290	343516
23034	35392	5	applied	\N	\N	\N	\N	176291	176291	343517
23034	35393	6	applied	\N	\N	\N	\N	176292	176292	343518
23034	35394	7	applied	\N	\N	\N	\N	176293	176293	343519
23034	35395	8	applied	\N	\N	\N	\N	176294	176294	343520
23034	35396	9	applied	\N	\N	\N	\N	176295	176295	343521
23037	35397	0	applied	\N	\N	\N	\N	176316	176316	343542
23037	35398	1	applied	\N	\N	\N	\N	176317	176317	343543
23037	35399	2	applied	\N	\N	\N	\N	176318	176318	343544
23037	35400	3	applied	\N	\N	\N	\N	176319	176319	343545
23037	35401	4	applied	\N	\N	\N	\N	176320	176320	343546
23037	35403	6	applied	\N	\N	\N	\N	176322	176322	343548
23037	35404	7	applied	\N	\N	\N	\N	176323	176323	343549
23037	35405	8	applied	\N	\N	\N	\N	176324	176324	343550
23037	35406	9	applied	\N	\N	\N	\N	176325	176325	343551
23042	35417	0	applied	\N	\N	\N	\N	176346	176346	343572
23042	35418	1	applied	\N	\N	\N	\N	176347	176347	343573
23042	35419	2	applied	\N	\N	\N	\N	176348	176348	343574
23044	35420	0	applied	\N	\N	\N	\N	176352	176352	343578
23044	35421	1	applied	\N	\N	\N	\N	176353	176353	343579
23044	35422	2	applied	\N	\N	\N	\N	176354	176354	343580
23044	35423	3	applied	\N	\N	\N	\N	176355	176355	343581
23047	35043	0	applied	\N	\N	1000000000	\N	176363	176363	343589
23047	35234	1	applied	\N	\N	1000000000	\N	176364	176364	343590
23047	35166	2	applied	\N	\N	\N	\N	176365	176365	343591
23047	35129	4	applied	\N	\N	\N	\N	176367	176367	343593
23047	35067	5	applied	\N	\N	1000000000	\N	176368	176368	343594
23047	35170	6	applied	\N	\N	\N	\N	176369	176369	343595
23047	35049	7	applied	\N	\N	\N	\N	176370	176370	343596
23047	35223	8	applied	\N	\N	\N	\N	176371	176371	343597
23047	35198	9	applied	\N	\N	\N	\N	176372	176372	343598
23047	35238	10	applied	\N	\N	\N	\N	176373	176373	343599
23047	35290	11	applied	\N	\N	\N	\N	176374	176374	343600
23047	35208	12	applied	\N	\N	\N	\N	176375	176375	343601
23047	35209	13	applied	\N	\N	\N	\N	176376	176376	343602
23047	35300	14	applied	\N	\N	\N	\N	176377	176377	343603
23047	35213	15	applied	\N	\N	\N	\N	176378	176378	343604
22966	35258	0	applied	\N	\N	\N	\N	175831	175831	343057
22966	35259	1	applied	\N	\N	\N	\N	175832	175832	343058
22969	35269	1	applied	\N	\N	\N	\N	175845	175845	343071
22971	35268	0	applied	\N	\N	\N	\N	175848	175848	343074
22971	35269	1	applied	\N	\N	\N	\N	175849	175849	343075
22978	35277	0	applied	\N	\N	\N	\N	175866	175866	343092
22978	35278	1	applied	\N	\N	\N	\N	175867	175867	343093
22981	35279	0	applied	\N	\N	\N	\N	175990	175990	343216
22981	35280	1	applied	\N	\N	\N	\N	175991	175991	343217
22981	35281	2	applied	\N	\N	\N	\N	175992	175992	343218
22981	35282	3	applied	\N	\N	\N	\N	175993	175993	343219
22981	35283	4	applied	\N	\N	\N	\N	175994	175994	343220
22981	35284	5	applied	\N	\N	\N	\N	175995	175995	343221
22981	35285	6	applied	\N	\N	\N	\N	175996	175996	343222
22981	35286	7	applied	\N	\N	\N	\N	175997	175997	343223
22984	35294	0	applied	\N	\N	\N	\N	176013	176013	343239
22984	35296	2	applied	\N	\N	\N	\N	176015	176015	343241
22986	35295	0	applied	\N	\N	\N	\N	176026	176026	343252
22986	35296	1	applied	\N	\N	\N	\N	176027	176027	343253
22989	35297	0	applied	\N	\N	\N	\N	176038	176038	343264
22989	35298	1	applied	\N	\N	\N	\N	176039	176039	343265
22989	35302	2	applied	\N	\N	\N	\N	176040	176040	343266
22989	35303	3	applied	\N	\N	\N	\N	176041	176041	343267
22989	35304	4	applied	\N	\N	\N	\N	176042	176042	343268
22992	35305	0	applied	\N	\N	\N	\N	176052	176052	343278
22992	35306	1	applied	\N	\N	\N	\N	176053	176053	343279
22992	35303	2	applied	\N	\N	\N	\N	176054	176054	343280
22992	35307	3	applied	\N	\N	\N	\N	176055	176055	343281
22992	35308	4	applied	\N	\N	\N	\N	176056	176056	343282
22994	35312	0	applied	\N	\N	\N	\N	176060	176060	343286
22994	35313	1	applied	\N	\N	\N	\N	176061	176061	343287
22994	35314	2	applied	\N	\N	\N	\N	176062	176062	343288
23001	35339	0	applied	\N	\N	\N	\N	176096	176096	343322
23001	35340	1	applied	\N	\N	\N	\N	176097	176097	343323
23001	35341	2	applied	\N	\N	\N	\N	176098	176098	343324
23010	35352	0	applied	\N	\N	\N	\N	176128	176128	343354
23010	35353	1	applied	\N	\N	\N	\N	176129	176129	343355
23010	35354	2	applied	\N	\N	\N	\N	176130	176130	343356
23010	35355	3	applied	\N	\N	\N	\N	176131	176131	343357
23010	35356	4	applied	\N	\N	\N	\N	176132	176132	343358
23010	35350	5	applied	\N	\N	\N	\N	176133	176133	343359
23010	35357	6	applied	\N	\N	\N	\N	176134	176134	343360
23010	35358	7	applied	\N	\N	\N	\N	176135	176135	343361
23015	35359	0	applied	\N	\N	\N	\N	176157	176157	343383
23017	35362	0	applied	\N	\N	\N	\N	176158	176158	343384
23017	35363	1	applied	\N	\N	\N	\N	176159	176159	343385
23017	35364	2	applied	\N	\N	\N	\N	176160	176160	343386
23017	35365	3	applied	\N	\N	\N	\N	176161	176161	343387
23017	35367	5	applied	\N	\N	\N	\N	176163	176163	343389
23017	35368	6	applied	\N	\N	\N	\N	176164	176164	343390
23017	35369	7	applied	\N	\N	\N	\N	176165	176165	343391
23017	35370	8	applied	\N	\N	\N	\N	176166	176166	343392
23017	35371	9	applied	\N	\N	\N	\N	176167	176167	343393
23017	35372	10	applied	\N	\N	\N	\N	176168	176168	343394
23017	35373	11	applied	\N	\N	\N	\N	176169	176169	343395
23017	35374	12	applied	\N	\N	\N	\N	176170	176170	343396
23019	35362	0	applied	\N	\N	\N	\N	176184	176184	343410
23019	35363	1	applied	\N	\N	\N	\N	176185	176185	343411
23019	35364	2	applied	\N	\N	\N	\N	176186	176186	343412
23019	35365	3	applied	\N	\N	\N	\N	176187	176187	343413
23019	35366	4	applied	\N	\N	\N	\N	176188	176188	343414
23019	35367	5	applied	\N	\N	\N	\N	176189	176189	343415
23019	35368	6	applied	\N	\N	\N	\N	176190	176190	343416
23019	35369	7	applied	\N	\N	\N	\N	176191	176191	343417
23019	35371	9	applied	\N	\N	\N	\N	176193	176193	343419
23019	35372	10	applied	\N	\N	\N	\N	176194	176194	343420
23019	35373	11	applied	\N	\N	\N	\N	176195	176195	343421
23019	35374	12	applied	\N	\N	\N	\N	176196	176196	343422
23024	35375	0	applied	\N	\N	\N	\N	176258	176258	343484
23024	35376	1	applied	\N	\N	\N	\N	176259	176259	343485
23024	35377	2	applied	\N	\N	\N	\N	176260	176260	343486
23030	35378	0	applied	\N	\N	\N	\N	176270	176270	343496
23030	35379	1	applied	\N	\N	\N	\N	176271	176271	343497
23030	35380	2	applied	\N	\N	\N	\N	176272	176272	343498
23035	35387	0	applied	\N	\N	\N	\N	176296	176296	343522
23035	35388	1	applied	\N	\N	\N	\N	176297	176297	343523
23035	35389	2	applied	\N	\N	\N	\N	176298	176298	343524
23035	35390	3	applied	\N	\N	\N	\N	176299	176299	343525
23035	35391	4	applied	\N	\N	\N	\N	176300	176300	343526
23035	35392	5	applied	\N	\N	\N	\N	176301	176301	343527
23035	35394	7	applied	\N	\N	\N	\N	176303	176303	343529
23035	35395	8	applied	\N	\N	\N	\N	176304	176304	343530
23035	35396	9	applied	\N	\N	\N	\N	176305	176305	343531
23038	35407	0	applied	\N	\N	\N	\N	176326	176326	343552
23038	35408	1	applied	\N	\N	\N	\N	176327	176327	343553
23038	35409	2	applied	\N	\N	\N	\N	176328	176328	343554
23038	35410	3	applied	\N	\N	\N	\N	176329	176329	343555
23038	35411	4	applied	\N	\N	\N	\N	176330	176330	343556
23038	35412	5	applied	\N	\N	\N	\N	176331	176331	343557
23038	35413	6	applied	\N	\N	\N	\N	176332	176332	343558
23040	35414	0	applied	\N	\N	\N	\N	176340	176340	343566
23040	35415	1	applied	\N	\N	\N	\N	176341	176341	343567
23040	35416	2	applied	\N	\N	\N	\N	176342	176342	343568
23043	35417	0	applied	\N	\N	\N	\N	176349	176349	343575
23047	35214	16	applied	\N	\N	\N	\N	176379	176379	343605
23047	35163	17	applied	\N	\N	\N	\N	176380	176380	343606
23047	35137	19	applied	\N	\N	\N	\N	176382	176382	343608
23047	35138	20	applied	\N	\N	\N	\N	176383	176383	343609
23047	35139	21	applied	\N	\N	\N	\N	176384	176384	343610
23047	35140	22	applied	\N	\N	\N	\N	176385	176385	343611
23049	35427	0	applied	\N	\N	\N	\N	176393	176393	343619
23049	35428	1	applied	\N	\N	\N	\N	176394	176394	343620
23049	35429	2	applied	\N	\N	\N	\N	176395	176395	343621
23049	35430	3	applied	\N	\N	\N	\N	176396	176396	343622
23049	35431	4	applied	\N	\N	\N	\N	176397	176397	343623
23049	35432	5	applied	\N	\N	\N	\N	176398	176398	343624
23049	35433	6	applied	\N	\N	\N	\N	176399	176399	343625
23051	35434	0	applied	\N	\N	\N	\N	176403	176403	343629
23051	35435	1	applied	\N	\N	\N	\N	176404	176404	343630
23051	35436	2	applied	\N	\N	\N	\N	176405	176405	343631
23059	35452	0	applied	\N	\N	\N	\N	176432	176432	343658
23059	35453	1	applied	\N	\N	\N	\N	176433	176433	343659
22967	35261	2	applied	\N	\N	\N	\N	175837	175837	343063
22969	35268	0	applied	\N	\N	\N	\N	175844	175844	343070
22980	34984	17	applied	\N	\N	\N	\N	175887	175887	343113
22980	34987	18	applied	\N	\N	\N	\N	175888	175888	343114
22980	34988	19	applied	\N	\N	\N	\N	175889	175889	343115
22980	34989	20	applied	\N	\N	\N	\N	175890	175890	343116
22980	34997	21	applied	\N	\N	\N	\N	175891	175891	343117
22980	35000	22	applied	\N	\N	\N	\N	175892	175892	343118
22980	35004	23	applied	\N	\N	\N	\N	175893	175893	343119
22980	35008	24	applied	\N	\N	\N	\N	175894	175894	343120
22980	35011	25	applied	\N	\N	\N	\N	175895	175895	343121
22980	35014	26	applied	\N	\N	\N	\N	175896	175896	343122
22980	35015	27	applied	\N	\N	\N	\N	175897	175897	343123
22980	35021	28	applied	\N	\N	\N	\N	175898	175898	343124
22980	35024	29	applied	\N	\N	\N	\N	175899	175899	343125
22980	35032	31	applied	\N	\N	\N	\N	175901	175901	343127
22980	35035	32	applied	\N	\N	\N	\N	175902	175902	343128
22980	35038	33	applied	\N	\N	\N	\N	175903	175903	343129
22980	35044	34	applied	\N	\N	\N	\N	175904	175904	343130
22980	35047	35	applied	\N	\N	\N	\N	175905	175905	343131
22980	35051	36	applied	\N	\N	\N	\N	175906	175906	343132
22980	35056	37	applied	\N	\N	\N	\N	175907	175907	343133
22980	35060	38	applied	\N	\N	\N	\N	175908	175908	343134
22980	35063	39	applied	\N	\N	\N	\N	175909	175909	343135
22980	35066	40	applied	\N	\N	\N	\N	175910	175910	343136
22980	35071	41	applied	\N	\N	\N	\N	175911	175911	343137
22980	35072	42	applied	\N	\N	\N	\N	175912	175912	343138
22980	35077	43	applied	\N	\N	\N	\N	175913	175913	343139
22980	35081	44	applied	\N	\N	\N	\N	175914	175914	343140
22980	35083	45	applied	\N	\N	\N	\N	175915	175915	343141
22980	35086	46	applied	\N	\N	\N	\N	175916	175916	343142
22980	35091	48	applied	\N	\N	\N	\N	175918	175918	343144
22980	35096	49	applied	\N	\N	\N	\N	175919	175919	343145
22980	35099	50	applied	\N	\N	\N	\N	175920	175920	343146
22980	35103	51	applied	\N	\N	\N	\N	175921	175921	343147
22980	35106	52	applied	\N	\N	\N	\N	175922	175922	343148
22980	35109	53	applied	\N	\N	\N	\N	175923	175923	343149
22980	35113	54	applied	\N	\N	\N	\N	175924	175924	343150
22980	35116	55	applied	\N	\N	\N	\N	175925	175925	343151
22980	35121	56	applied	\N	\N	\N	\N	175926	175926	343152
22980	35123	57	applied	\N	\N	\N	\N	175927	175927	343153
22980	35126	58	applied	\N	\N	\N	\N	175928	175928	343154
22980	35127	59	applied	\N	\N	\N	\N	175929	175929	343155
22980	35128	60	applied	\N	\N	\N	\N	175930	175930	343156
22980	35141	61	applied	\N	\N	\N	\N	175931	175931	343157
22980	35144	62	applied	\N	\N	\N	\N	175932	175932	343158
22980	35147	63	applied	\N	\N	\N	\N	175933	175933	343159
22980	35149	65	applied	\N	\N	\N	\N	175935	175935	343161
22980	35157	66	applied	\N	\N	\N	\N	175936	175936	343162
22980	35161	67	applied	\N	\N	\N	\N	175937	175937	343163
22980	35165	68	applied	\N	\N	\N	\N	175938	175938	343164
22980	35169	69	applied	\N	\N	\N	\N	175939	175939	343165
22980	35173	70	applied	\N	\N	\N	\N	175940	175940	343166
22980	35177	71	applied	\N	\N	\N	\N	175941	175941	343167
22980	35180	72	applied	\N	\N	\N	\N	175942	175942	343168
22980	35183	73	applied	\N	\N	\N	\N	175943	175943	343169
22980	35187	74	applied	\N	\N	\N	\N	175944	175944	343170
22980	35190	75	applied	\N	\N	\N	\N	175945	175945	343171
22980	35193	76	applied	\N	\N	\N	\N	175946	175946	343172
22980	35194	77	applied	\N	\N	\N	\N	175947	175947	343173
22980	35201	78	applied	\N	\N	\N	\N	175948	175948	343174
22980	35202	79	applied	\N	\N	\N	\N	175949	175949	343175
22980	35203	80	applied	\N	\N	\N	\N	175950	175950	343176
22980	35218	82	applied	\N	\N	\N	\N	175952	175952	343178
22980	35219	83	applied	\N	\N	\N	\N	175953	175953	343179
22980	35226	84	applied	\N	\N	\N	\N	175954	175954	343180
22980	35229	85	applied	\N	\N	\N	\N	175955	175955	343181
22980	35232	86	applied	\N	\N	\N	\N	175956	175956	343182
22980	35233	87	applied	\N	\N	\N	\N	175957	175957	343183
22980	35235	88	applied	\N	\N	\N	\N	175958	175958	343184
22980	35236	89	applied	\N	\N	\N	\N	175959	175959	343185
22980	35237	90	applied	\N	\N	\N	\N	175960	175960	343186
22980	35251	91	applied	\N	\N	\N	\N	175961	175961	343187
22980	35255	92	applied	\N	\N	\N	\N	175962	175962	343188
22980	35258	93	applied	\N	\N	\N	\N	175963	175963	343189
22980	35262	94	applied	\N	\N	\N	\N	175964	175964	343190
22980	35263	95	applied	\N	\N	\N	\N	175965	175965	343191
22980	35268	96	applied	\N	\N	\N	\N	175966	175966	343192
22980	35270	97	applied	\N	\N	\N	\N	175967	175967	343193
22980	35277	99	applied	\N	\N	\N	\N	175969	175969	343195
22980	35166	100	applied	\N	\N	\N	\N	175970	175970	343196
22980	35058	101	applied	\N	\N	1000000000	\N	175971	175971	343197
22980	35129	103	applied	\N	\N	\N	\N	175972	175972	343198
22980	35067	104	applied	\N	\N	1000000000	\N	175973	175973	343199
22980	35170	105	applied	\N	\N	\N	\N	175974	175974	343200
22980	35001	106	applied	\N	\N	\N	\N	175975	175975	343201
22980	35049	107	applied	\N	\N	\N	\N	175976	175976	343202
22980	35223	108	applied	\N	\N	\N	\N	175977	175977	343203
22980	35198	109	applied	\N	\N	\N	\N	175978	175978	343204
22980	35238	110	applied	\N	\N	\N	\N	175979	175979	343205
22980	35208	111	applied	\N	\N	\N	\N	175980	175980	343206
22980	35209	112	applied	\N	\N	\N	\N	175981	175981	343207
22980	35213	113	applied	\N	\N	\N	\N	175982	175982	343208
22980	35214	114	applied	\N	\N	\N	\N	175983	175983	343209
23043	35418	1	applied	\N	\N	\N	\N	176350	176350	343576
23052	35437	0	applied	\N	\N	\N	\N	176406	176406	343632
23052	35438	1	applied	\N	\N	\N	\N	176407	176407	343633
23060	35452	0	applied	\N	\N	\N	\N	176436	176436	343662
23060	35453	1	applied	\N	\N	\N	\N	176437	176437	343663
23060	35454	2	applied	\N	\N	\N	\N	176438	176438	343664
23060	35455	4	applied	\N	\N	\N	\N	176439	176439	343665
23064	35462	0	applied	\N	\N	\N	\N	176452	176452	343678
23064	35463	1	applied	\N	\N	\N	\N	176453	176453	343679
23064	35464	2	applied	\N	\N	\N	\N	176454	176454	343680
23064	35465	3	applied	\N	\N	\N	\N	176455	176455	343681
23071	35472	0	applied	\N	\N	\N	\N	176479	176479	343705
23071	35473	1	applied	\N	\N	\N	\N	176480	176480	343706
23071	35474	2	applied	\N	\N	\N	\N	176481	176481	343707
23075	35479	0	applied	\N	\N	\N	\N	176493	176493	343719
23075	35480	1	applied	\N	\N	\N	\N	176494	176494	343720
23075	35481	2	applied	\N	\N	\N	\N	176495	176495	343721
22980	34977	15	applied	\N	\N	\N	\N	175885	175885	343111
22980	34980	16	applied	\N	\N	\N	\N	175886	175886	343112
22980	35138	118	applied	\N	\N	\N	\N	175987	175987	343213
22980	35139	119	applied	\N	\N	\N	\N	175988	175988	343214
22980	35140	120	applied	\N	\N	\N	\N	175989	175989	343215
22983	35287	0	applied	\N	\N	\N	\N	176006	176006	343232
22983	35288	1	applied	\N	\N	\N	\N	176007	176007	343233
22983	35289	2	applied	\N	\N	\N	\N	176008	176008	343234
22983	35290	3	applied	\N	\N	\N	\N	176009	176009	343235
22983	35291	4	applied	\N	\N	\N	\N	176010	176010	343236
22983	35292	5	applied	\N	\N	\N	\N	176011	176011	343237
22983	35293	6	applied	\N	\N	\N	\N	176012	176012	343238
22990	35297	0	applied	\N	\N	\N	\N	176043	176043	343269
22990	35298	1	applied	\N	\N	\N	\N	176044	176044	343270
22990	35302	2	applied	\N	\N	\N	\N	176045	176045	343271
22999	35339	0	applied	\N	\N	\N	\N	176090	176090	343316
22999	35340	1	applied	\N	\N	\N	\N	176091	176091	343317
22999	35341	2	applied	\N	\N	\N	\N	176092	176092	343318
23003	35342	0	applied	\N	\N	\N	\N	176102	176102	343328
23003	35343	1	applied	\N	\N	\N	\N	176103	176103	343329
23003	35344	2	applied	\N	\N	\N	\N	176104	176104	343330
23014	35359	0	applied	\N	\N	\N	\N	176154	176154	343380
23014	35360	1	applied	\N	\N	\N	\N	176155	176155	343381
23014	35361	2	applied	\N	\N	\N	\N	176156	176156	343382
23020	35234	0	applied	\N	\N	1000000000	\N	176197	176197	343423
23020	35229	1	applied	\N	\N	\N	\N	176198	176198	343424
23020	35232	2	applied	\N	\N	\N	\N	176199	176199	343425
23020	35233	3	applied	\N	\N	\N	\N	176200	176200	343426
23020	35235	4	applied	\N	\N	\N	\N	176201	176201	343427
23020	35236	5	applied	\N	\N	\N	\N	176202	176202	343428
23020	35237	6	applied	\N	\N	\N	\N	176203	176203	343429
23020	35255	8	applied	\N	\N	\N	\N	176205	176205	343431
23020	35258	9	applied	\N	\N	\N	\N	176206	176206	343432
23020	35262	10	applied	\N	\N	\N	\N	176207	176207	343433
23020	35263	11	applied	\N	\N	\N	\N	176208	176208	343434
23020	35268	12	applied	\N	\N	\N	\N	176209	176209	343435
23020	35270	13	applied	\N	\N	\N	\N	176210	176210	343436
23020	35274	14	applied	\N	\N	\N	\N	176211	176211	343437
23020	35277	15	applied	\N	\N	\N	\N	176212	176212	343438
23020	35279	16	applied	\N	\N	\N	\N	176213	176213	343439
23020	35280	17	applied	\N	\N	\N	\N	176214	176214	343440
23020	35281	18	applied	\N	\N	\N	\N	176215	176215	343441
23020	35287	19	applied	\N	\N	\N	\N	176216	176216	343442
23020	35288	20	applied	\N	\N	\N	\N	176217	176217	343443
23020	35289	21	applied	\N	\N	\N	\N	176218	176218	343444
23020	35294	22	applied	\N	\N	\N	\N	176219	176219	343445
23020	35297	23	applied	\N	\N	\N	\N	176220	176220	343446
23020	35302	25	applied	\N	\N	\N	\N	176222	176222	343448
23020	35305	26	applied	\N	\N	\N	\N	176223	176223	343449
23020	35306	27	applied	\N	\N	\N	\N	176224	176224	343450
23020	35309	28	applied	\N	\N	\N	\N	176225	176225	343451
23020	35312	29	applied	\N	\N	\N	\N	176226	176226	343452
23020	35316	30	applied	\N	\N	\N	\N	176227	176227	343453
23020	35317	31	applied	\N	\N	\N	\N	176228	176228	343454
23020	35322	32	applied	\N	\N	\N	\N	176229	176229	343455
23020	35323	33	applied	\N	\N	\N	\N	176230	176230	343456
23020	35324	34	applied	\N	\N	\N	\N	176231	176231	343457
23020	35325	35	applied	\N	\N	\N	\N	176232	176232	343458
23020	35336	36	applied	\N	\N	\N	\N	176233	176233	343459
23020	35339	37	applied	\N	\N	\N	\N	176234	176234	343460
23020	35342	38	applied	\N	\N	\N	\N	176235	176235	343461
23020	35345	39	applied	\N	\N	\N	\N	176236	176236	343462
23020	35349	40	applied	\N	\N	\N	\N	176237	176237	343463
23020	35353	42	applied	\N	\N	\N	\N	176239	176239	343465
23020	35359	43	applied	\N	\N	\N	\N	176240	176240	343466
23020	35362	44	applied	\N	\N	\N	\N	176241	176241	343467
23020	35363	45	applied	\N	\N	\N	\N	176242	176242	343468
23020	35364	46	applied	\N	\N	\N	\N	176243	176243	343469
23020	35365	47	applied	\N	\N	\N	\N	176244	176244	343470
23020	35375	48	applied	\N	\N	\N	\N	176245	176245	343471
23020	35230	49	applied	\N	\N	\N	\N	176246	176246	343472
23020	35238	50	applied	\N	\N	\N	\N	176247	176247	343473
23020	35290	51	applied	\N	\N	\N	\N	176248	176248	343474
23020	35239	52	applied	\N	\N	\N	\N	176249	176249	343475
23020	35240	53	applied	\N	\N	\N	\N	176250	176250	343476
23020	35261	54	applied	\N	\N	\N	\N	176251	176251	343477
23020	35272	55	applied	\N	\N	\N	\N	176252	176252	343478
23020	35284	56	applied	\N	\N	\N	\N	176253	176253	343479
23020	35295	57	applied	\N	\N	\N	\N	176254	176254	343480
23032	35379	1	applied	\N	\N	\N	\N	176277	176277	343503
23032	35380	2	applied	\N	\N	\N	\N	176278	176278	343504
23033	35381	0	applied	\N	\N	\N	\N	176279	176279	343505
23033	35382	1	applied	\N	\N	\N	\N	176280	176280	343506
23033	35383	2	applied	\N	\N	\N	\N	176281	176281	343507
23033	35380	3	applied	\N	\N	\N	\N	176282	176282	343508
23033	35384	4	applied	\N	\N	\N	\N	176283	176283	343509
23033	35385	5	applied	\N	\N	\N	\N	176284	176284	343510
23033	35386	6	applied	\N	\N	\N	\N	176285	176285	343511
23041	35414	0	applied	\N	\N	\N	\N	176343	176343	343569
23041	35415	1	applied	\N	\N	\N	\N	176344	176344	343570
23041	35416	2	applied	\N	\N	\N	\N	176345	176345	343571
23046	35424	0	applied	\N	\N	\N	\N	176360	176360	343586
23046	35425	1	applied	\N	\N	\N	\N	176361	176361	343587
23046	35426	2	applied	\N	\N	\N	\N	176362	176362	343588
23054	35439	0	applied	\N	\N	\N	\N	176415	176415	343641
23054	35441	2	applied	\N	\N	\N	\N	176417	176417	343643
23054	35442	3	applied	\N	\N	\N	\N	176418	176418	343644
23054	35443	4	applied	\N	\N	\N	\N	176419	176419	343645
23054	35444	5	applied	\N	\N	\N	\N	176420	176420	343646
23054	35445	6	applied	\N	\N	\N	\N	176421	176421	343647
23056	35449	0	applied	\N	\N	\N	\N	176425	176425	343651
23056	35450	1	applied	\N	\N	\N	\N	176426	176426	343652
23056	35451	2	applied	\N	\N	\N	\N	176427	176427	343653
23058	35452	0	applied	\N	\N	\N	\N	176428	176428	343654
23058	35453	1	applied	\N	\N	\N	\N	176429	176429	343655
23058	35454	2	applied	\N	\N	\N	\N	176430	176430	343656
23058	35455	4	applied	\N	\N	\N	\N	176431	176431	343657
23066	35462	0	applied	\N	\N	\N	\N	176460	176460	343686
23066	35463	1	applied	\N	\N	\N	\N	176461	176461	343687
23066	35464	2	applied	\N	\N	\N	\N	176462	176462	343688
23066	35465	3	applied	\N	\N	\N	\N	176463	176463	343689
22980	35054	116	applied	\N	\N	1000000000	\N	175985	175985	343211
22980	35137	117	applied	\N	\N	\N	\N	175986	175986	343212
23036	35400	3	applied	\N	\N	\N	\N	176309	176309	343535
23036	35401	4	applied	\N	\N	\N	\N	176310	176310	343536
23036	35402	5	applied	\N	\N	\N	\N	176311	176311	343537
23036	35403	6	applied	\N	\N	\N	\N	176312	176312	343538
23036	35404	7	applied	\N	\N	\N	\N	176313	176313	343539
23036	35405	8	applied	\N	\N	\N	\N	176314	176314	343540
23036	35406	9	applied	\N	\N	\N	\N	176315	176315	343541
23039	35407	0	applied	\N	\N	\N	\N	176333	176333	343559
23039	35408	1	applied	\N	\N	\N	\N	176334	176334	343560
23039	35409	2	applied	\N	\N	\N	\N	176335	176335	343561
23039	35410	3	applied	\N	\N	\N	\N	176336	176336	343562
23039	35411	4	applied	\N	\N	\N	\N	176337	176337	343563
23039	35412	5	applied	\N	\N	\N	\N	176338	176338	343564
23039	35413	6	applied	\N	\N	\N	\N	176339	176339	343565
23045	35420	0	applied	\N	\N	\N	\N	176356	176356	343582
23045	35421	1	applied	\N	\N	\N	\N	176357	176357	343583
23045	35423	3	applied	\N	\N	\N	\N	176359	176359	343585
23048	35427	0	applied	\N	\N	\N	\N	176386	176386	343612
23048	35428	1	applied	\N	\N	\N	\N	176387	176387	343613
23048	35429	2	applied	\N	\N	\N	\N	176388	176388	343614
23048	35430	3	applied	\N	\N	\N	\N	176389	176389	343615
23048	35431	4	applied	\N	\N	\N	\N	176390	176390	343616
23048	35432	5	applied	\N	\N	\N	\N	176391	176391	343617
23048	35433	6	applied	\N	\N	\N	\N	176392	176392	343618
23050	35434	0	applied	\N	\N	\N	\N	176400	176400	343626
23050	35435	1	applied	\N	\N	\N	\N	176401	176401	343627
23050	35436	2	applied	\N	\N	\N	\N	176402	176402	343628
23053	35439	0	applied	\N	\N	\N	\N	176408	176408	343634
23053	35440	1	applied	\N	\N	\N	\N	176409	176409	343635
23053	35441	2	applied	\N	\N	\N	\N	176410	176410	343636
23053	35442	3	applied	\N	\N	\N	\N	176411	176411	343637
23053	35443	4	applied	\N	\N	\N	\N	176412	176412	343638
23053	35445	6	applied	\N	\N	\N	\N	176414	176414	343640
23055	35446	0	applied	\N	\N	\N	\N	176422	176422	343648
23055	35447	1	applied	\N	\N	\N	\N	176423	176423	343649
23055	35448	2	applied	\N	\N	\N	\N	176424	176424	343650
23062	35456	0	applied	\N	\N	\N	\N	176446	176446	343672
23062	35457	1	applied	\N	\N	\N	\N	176447	176447	343673
23062	35458	2	applied	\N	\N	\N	\N	176448	176448	343674
23062	35459	3	applied	\N	\N	\N	\N	176449	176449	343675
23062	35460	4	applied	\N	\N	\N	\N	176450	176450	343676
23062	35461	5	applied	\N	\N	\N	\N	176451	176451	343677
23065	35462	0	applied	\N	\N	\N	\N	176456	176456	343682
23065	35463	1	applied	\N	\N	\N	\N	176457	176457	343683
23065	35464	2	applied	\N	\N	\N	\N	176458	176458	343684
23065	35465	3	applied	\N	\N	\N	\N	176459	176459	343685
23067	35466	0	applied	\N	\N	\N	\N	176464	176464	343690
23067	35467	1	applied	\N	\N	\N	\N	176465	176465	343691
23067	35469	3	applied	\N	\N	\N	\N	176467	176467	343693
23067	35470	4	applied	\N	\N	\N	\N	176468	176468	343694
23067	35471	5	applied	\N	\N	\N	\N	176469	176469	343695
23072	35476	1	applied	\N	\N	\N	\N	176483	176483	343709
23072	35477	2	applied	\N	\N	\N	\N	176484	176484	343710
23072	35478	3	applied	\N	\N	\N	\N	176485	176485	343711
23074	35479	0	applied	\N	\N	\N	\N	176490	176490	343716
23074	35480	1	applied	\N	\N	\N	\N	176491	176491	343717
23074	35481	2	applied	\N	\N	\N	\N	176492	176492	343718
23076	35482	0	applied	\N	\N	\N	\N	176496	176496	343722
23076	35483	1	applied	\N	\N	\N	\N	176497	176497	343723
23079	35484	0	applied	\N	\N	\N	\N	176507	176507	343733
23079	35485	1	applied	\N	\N	\N	\N	176508	176508	343734
23079	35486	2	applied	\N	\N	\N	\N	176509	176509	343735
23079	35487	3	applied	\N	\N	\N	\N	176510	176510	343736
23081	35492	0	applied	\N	\N	\N	\N	176514	176514	343740
23081	35494	2	applied	\N	\N	\N	\N	176516	176516	343742
23083	35499	0	applied	\N	\N	\N	\N	176521	176521	343747
23083	35500	1	applied	\N	\N	\N	\N	176522	176522	343748
23083	35501	2	applied	\N	\N	\N	\N	176523	176523	343749
23084	35502	0	applied	\N	\N	\N	\N	176524	176524	343750
23084	35503	1	applied	\N	\N	\N	\N	176525	176525	343751
23084	35504	2	applied	\N	\N	\N	\N	176526	176526	343752
23084	35505	3	applied	\N	\N	\N	\N	176527	176527	343753
23084	35506	4	applied	\N	\N	\N	\N	176528	176528	343754
23084	35507	5	applied	\N	\N	\N	\N	176529	176529	343755
23084	35508	6	applied	\N	\N	\N	\N	176530	176530	343756
23084	35509	7	applied	\N	\N	\N	\N	176531	176531	343757
23084	35510	8	applied	\N	\N	\N	\N	176532	176532	343758
23084	35511	9	applied	\N	\N	\N	\N	176533	176533	343759
23089	35456	0	applied	\N	\N	\N	\N	176545	176545	343771
23089	35457	1	applied	\N	\N	\N	\N	176546	176546	343772
23089	35466	3	applied	\N	\N	\N	\N	176548	176548	343774
23089	35467	4	applied	\N	\N	\N	\N	176549	176549	343775
23089	35472	5	applied	\N	\N	\N	\N	176550	176550	343776
23089	35475	6	applied	\N	\N	\N	\N	176551	176551	343777
23089	35479	7	applied	\N	\N	\N	\N	176552	176552	343778
23089	35482	8	applied	\N	\N	\N	\N	176553	176553	343779
23089	35484	9	applied	\N	\N	\N	\N	176554	176554	343780
23089	35489	10	applied	\N	\N	\N	\N	176555	176555	343781
23089	35492	11	applied	\N	\N	\N	\N	176556	176556	343782
23089	35495	12	applied	\N	\N	\N	\N	176557	176557	343783
23089	35499	13	applied	\N	\N	\N	\N	176558	176558	343784
23089	35502	14	applied	\N	\N	\N	\N	176559	176559	343785
23089	35503	15	applied	\N	\N	\N	\N	176560	176560	343786
23089	35504	16	applied	\N	\N	\N	\N	176561	176561	343787
23089	35512	17	applied	\N	\N	\N	\N	176562	176562	343788
23089	35515	18	applied	\N	\N	\N	\N	176563	176563	343789
23089	35517	20	applied	\N	\N	\N	\N	176565	176565	343791
23089	35518	21	applied	\N	\N	\N	\N	176566	176566	343792
23089	35458	22	applied	\N	\N	\N	\N	176567	176567	343793
23090	35515	0	applied	\N	\N	\N	\N	176617	176617	343843
23090	35516	1	applied	\N	\N	\N	\N	176618	176618	343844
23090	35517	2	applied	\N	\N	\N	\N	176619	176619	343845
23090	35518	3	applied	\N	\N	\N	\N	176620	176620	343846
23090	35528	4	applied	\N	\N	\N	\N	176621	176621	343847
23090	35523	5	applied	\N	\N	\N	\N	176622	176622	343848
23090	35529	6	applied	\N	\N	\N	\N	176623	176623	343849
23090	35524	7	applied	\N	\N	\N	\N	176624	176624	343850
23090	35525	8	applied	\N	\N	\N	\N	176625	176625	343851
23090	35526	9	applied	\N	\N	\N	\N	176626	176626	343852
23090	35519	10	applied	\N	\N	\N	\N	176627	176627	343853
23036	35397	0	applied	\N	\N	\N	\N	176306	176306	343532
23036	35398	1	applied	\N	\N	\N	\N	176307	176307	343533
23061	35458	2	applied	\N	\N	\N	\N	176442	176442	343668
23061	35459	3	applied	\N	\N	\N	\N	176443	176443	343669
23061	35460	4	applied	\N	\N	\N	\N	176444	176444	343670
23061	35461	5	applied	\N	\N	\N	\N	176445	176445	343671
23068	35466	0	applied	\N	\N	\N	\N	176470	176470	343696
23068	35467	1	applied	\N	\N	\N	\N	176471	176471	343697
23068	35468	2	applied	\N	\N	\N	\N	176472	176472	343698
23068	35469	3	applied	\N	\N	\N	\N	176473	176473	343699
23068	35470	4	applied	\N	\N	\N	\N	176474	176474	343700
23068	35471	5	applied	\N	\N	\N	\N	176475	176475	343701
23070	35472	0	applied	\N	\N	\N	\N	176476	176476	343702
23070	35473	1	applied	\N	\N	\N	\N	176477	176477	343703
23070	35474	2	applied	\N	\N	\N	\N	176478	176478	343704
23073	35475	0	applied	\N	\N	\N	\N	176486	176486	343712
23073	35476	1	applied	\N	\N	\N	\N	176487	176487	343713
23073	35477	2	applied	\N	\N	\N	\N	176488	176488	343714
23077	35484	0	applied	\N	\N	\N	\N	176498	176498	343724
23077	35485	1	applied	\N	\N	\N	\N	176499	176499	343725
23077	35486	2	applied	\N	\N	\N	\N	176500	176500	343726
23077	35487	3	applied	\N	\N	\N	\N	176501	176501	343727
23077	35488	4	applied	\N	\N	\N	\N	176502	176502	343728
23082	35495	0	applied	\N	\N	\N	\N	176517	176517	343743
23082	35496	1	applied	\N	\N	\N	\N	176518	176518	343744
23082	35497	2	applied	\N	\N	\N	\N	176519	176519	343745
23082	35498	3	applied	\N	\N	\N	\N	176520	176520	343746
23085	35512	0	applied	\N	\N	\N	\N	176534	176534	343760
23085	35513	1	applied	\N	\N	\N	\N	176535	176535	343761
23087	35512	0	applied	\N	\N	\N	\N	176539	176539	343765
23087	35513	1	applied	\N	\N	\N	\N	176540	176540	343766
23087	35514	2	applied	\N	\N	\N	\N	176541	176541	343767
23089	35459	23	applied	\N	\N	\N	\N	176568	176568	343794
23089	35463	24	applied	\N	\N	\N	\N	176569	176569	343795
23089	35464	26	applied	\N	\N	\N	\N	176571	176571	343797
23089	35461	27	applied	\N	\N	\N	\N	176572	176572	343798
23089	35465	28	applied	\N	\N	\N	\N	176573	176573	343799
23089	35468	29	applied	\N	\N	\N	\N	176574	176574	343800
23089	35469	30	applied	\N	\N	\N	\N	176575	176575	343801
23089	35473	31	applied	\N	\N	\N	\N	176576	176576	343802
23089	35470	32	applied	\N	\N	\N	\N	176577	176577	343803
23089	35471	33	applied	\N	\N	\N	\N	176578	176578	343804
23089	35474	34	applied	\N	\N	\N	\N	176579	176579	343805
23089	35476	35	applied	\N	\N	\N	\N	176580	176580	343806
23089	35480	36	applied	\N	\N	\N	\N	176581	176581	343807
23089	35487	37	applied	\N	\N	\N	\N	176582	176582	343808
23089	35488	38	applied	\N	\N	\N	\N	176583	176583	343809
23089	35491	39	applied	\N	\N	\N	\N	176584	176584	343810
23089	35493	40	applied	\N	\N	\N	\N	176585	176585	343811
23089	35497	41	applied	\N	\N	\N	\N	176586	176586	343812
23098	35548	0	applied	\N	\N	\N	\N	176667	176667	343893
23098	35549	1	applied	\N	\N	\N	\N	176668	176668	343894
23098	35550	2	applied	\N	\N	\N	\N	176669	176669	343895
23098	35551	3	applied	\N	\N	\N	\N	176670	176670	343896
23098	35552	4	applied	\N	\N	\N	\N	176671	176671	343897
23098	35553	5	applied	\N	\N	\N	\N	176672	176672	343898
23103	35564	0	applied	\N	\N	\N	\N	176684	176684	343910
23103	35565	1	applied	\N	\N	\N	\N	176685	176685	343911
23103	35566	2	applied	\N	\N	\N	\N	176686	176686	343912
23108	35573	0	applied	\N	\N	\N	\N	176700	176700	343926
23108	35574	1	applied	\N	\N	\N	\N	176701	176701	343927
23108	35575	2	applied	\N	\N	\N	\N	176702	176702	343928
23108	35576	3	applied	\N	\N	\N	\N	176703	176703	343929
23110	35577	0	applied	\N	\N	\N	\N	176708	176708	343934
23110	35578	1	applied	\N	\N	\N	\N	176709	176709	343935
23110	35579	2	applied	\N	\N	\N	\N	176710	176710	343936
23120	35602	1	applied	\N	\N	\N	\N	176743	176743	343969
23120	35603	2	applied	\N	\N	\N	\N	176744	176744	343970
23120	35604	3	applied	\N	\N	\N	\N	176745	176745	343971
23120	35605	4	applied	\N	\N	\N	\N	176746	176746	343972
23120	35606	5	applied	\N	\N	\N	\N	176747	176747	343973
23123	35610	0	applied	\N	\N	\N	\N	176754	176754	343980
23123	35611	1	applied	\N	\N	\N	\N	176755	176755	343981
23123	35612	2	applied	\N	\N	\N	\N	176756	176756	343982
23126	35621	0	applied	\N	\N	\N	\N	176765	176765	343991
23126	35620	1	applied	\N	\N	\N	\N	176766	176766	343992
23126	35622	2	applied	\N	\N	\N	\N	176767	176767	343993
23129	35623	0	applied	\N	\N	\N	\N	176778	176778	344004
23129	35624	1	applied	\N	\N	\N	\N	176779	176779	344005
23129	35625	2	applied	\N	\N	\N	\N	176780	176780	344006
23129	35626	3	applied	\N	\N	\N	\N	176781	176781	344007
23129	35627	4	applied	\N	\N	\N	\N	176782	176782	344008
23133	35629	1	applied	\N	\N	\N	\N	176918	176918	344144
23133	35630	2	applied	\N	\N	\N	\N	176919	176919	344145
23133	35631	3	applied	\N	\N	\N	\N	176920	176920	344146
23133	35632	5	applied	\N	\N	\N	\N	176921	176921	344147
23133	35634	6	applied	\N	\N	\N	\N	176922	176922	344148
23133	35633	7	applied	\N	\N	\N	\N	176923	176923	344149
23133	35635	8	applied	\N	\N	\N	\N	176924	176924	344150
23133	35636	9	applied	\N	\N	\N	\N	176925	176925	344151
23138	35637	0	applied	\N	\N	\N	\N	177027	177027	344253
23138	35638	1	applied	\N	\N	\N	\N	177028	177028	344254
23138	35634	2	applied	\N	\N	\N	\N	177029	177029	344255
23138	35635	3	applied	\N	\N	\N	\N	177030	177030	344256
23138	35639	4	applied	\N	\N	\N	\N	177031	177031	344257
23138	35640	5	applied	\N	\N	\N	\N	177032	177032	344258
23138	35636	6	applied	\N	\N	\N	\N	177033	177033	344259
23138	35641	7	applied	\N	\N	\N	\N	177034	177034	344260
23139	35643	0	applied	\N	\N	\N	\N	177036	177036	344262
23139	35644	1	applied	\N	\N	\N	\N	177037	177037	344263
23139	35645	2	applied	\N	\N	\N	\N	177038	177038	344264
23139	35646	3	applied	\N	\N	\N	\N	177039	177039	344265
23139	35647	4	applied	\N	\N	\N	\N	177040	177040	344266
23139	35648	5	applied	\N	\N	\N	\N	177041	177041	344267
23139	35649	6	applied	\N	\N	\N	\N	177042	177042	344268
23144	35653	0	applied	\N	\N	\N	\N	177067	177067	344293
23144	35654	1	applied	\N	\N	\N	\N	177068	177068	344294
23144	35655	2	applied	\N	\N	\N	\N	177069	177069	344295
23144	35656	3	applied	\N	\N	\N	\N	177070	177070	344296
23145	35657	0	applied	\N	\N	\N	\N	177071	177071	344297
23145	35658	1	applied	\N	\N	\N	\N	177072	177072	344298
23145	35659	2	applied	\N	\N	\N	\N	177073	177073	344299
23059	35455	4	applied	\N	\N	\N	\N	176435	176435	343661
23061	35456	0	applied	\N	\N	\N	\N	176440	176440	343666
23080	35490	1	applied	\N	\N	\N	\N	176512	176512	343738
23080	35491	2	applied	\N	\N	\N	\N	176513	176513	343739
23086	35512	0	applied	\N	\N	\N	\N	176536	176536	343762
23086	35513	1	applied	\N	\N	\N	\N	176537	176537	343763
23086	35514	2	applied	\N	\N	\N	\N	176538	176538	343764
23088	35512	0	applied	\N	\N	\N	\N	176542	176542	343768
23088	35513	1	applied	\N	\N	\N	\N	176543	176543	343769
23088	35514	2	applied	\N	\N	\N	\N	176544	176544	343770
23091	35532	0	applied	\N	\N	\N	\N	176634	176634	343860
23091	35533	1	applied	\N	\N	\N	\N	176635	176635	343861
23091	35534	2	applied	\N	\N	\N	\N	176636	176636	343862
23094	35538	0	applied	\N	\N	\N	\N	176647	176647	343873
23094	35539	1	applied	\N	\N	\N	\N	176648	176648	343874
23094	35540	2	applied	\N	\N	\N	\N	176649	176649	343875
23094	35541	3	applied	\N	\N	\N	\N	176650	176650	343876
23094	35542	4	applied	\N	\N	\N	\N	176651	176651	343877
23094	35544	6	applied	\N	\N	\N	\N	176653	176653	343879
23096	35545	0	applied	\N	\N	\N	\N	176661	176661	343887
23096	35546	1	applied	\N	\N	\N	\N	176662	176662	343888
23096	35547	2	applied	\N	\N	\N	\N	176663	176663	343889
23099	35554	0	applied	\N	\N	\N	\N	176673	176673	343899
23099	35555	1	applied	\N	\N	\N	\N	176674	176674	343900
23099	35556	2	applied	\N	\N	\N	\N	176675	176675	343901
23101	35558	0	applied	\N	\N	\N	\N	176677	176677	343903
23101	35559	1	applied	\N	\N	\N	\N	176678	176678	343904
23101	35557	2	applied	\N	\N	\N	\N	176679	176679	343905
23104	35567	0	applied	\N	\N	\N	\N	176687	176687	343913
23104	35568	1	applied	\N	\N	\N	\N	176688	176688	343914
23104	35569	2	applied	\N	\N	\N	\N	176689	176689	343915
23106	35570	0	applied	\N	\N	\N	\N	176693	176693	343919
23106	35571	1	applied	\N	\N	\N	\N	176694	176694	343920
23106	35572	2	applied	\N	\N	\N	\N	176695	176695	343921
23109	35574	1	applied	\N	\N	\N	\N	176705	176705	343931
23109	35575	2	applied	\N	\N	\N	\N	176706	176706	343932
23109	35576	3	applied	\N	\N	\N	\N	176707	176707	343933
23113	35583	0	applied	\N	\N	\N	\N	176717	176717	343943
23113	35584	1	applied	\N	\N	\N	\N	176718	176718	343944
23113	35585	2	applied	\N	\N	\N	\N	176719	176719	343945
23113	35586	3	applied	\N	\N	\N	\N	176720	176720	343946
23116	35597	0	applied	\N	\N	\N	\N	176731	176731	343957
23116	35598	1	applied	\N	\N	\N	\N	176732	176732	343958
23116	35599	2	applied	\N	\N	\N	\N	176733	176733	343959
23116	35600	3	applied	\N	\N	\N	\N	176734	176734	343960
23121	35607	0	applied	\N	\N	\N	\N	176748	176748	343974
23121	35608	1	applied	\N	\N	\N	\N	176749	176749	343975
23121	35609	2	applied	\N	\N	\N	\N	176750	176750	343976
23124	35613	0	applied	\N	\N	\N	\N	176757	176757	343983
23124	35614	1	applied	\N	\N	\N	\N	176758	176758	343984
23124	35616	3	applied	\N	\N	\N	\N	176760	176760	343986
23124	35617	4	applied	\N	\N	\N	\N	176761	176761	343987
23124	35618	5	applied	\N	\N	\N	\N	176762	176762	343988
23124	35619	6	applied	\N	\N	\N	\N	176763	176763	343989
23134	35628	0	applied	\N	\N	\N	\N	176926	176926	344152
23134	35629	1	applied	\N	\N	\N	\N	176927	176927	344153
23134	35630	2	applied	\N	\N	\N	\N	176928	176928	344154
23134	35631	3	applied	\N	\N	\N	\N	176929	176929	344155
23134	35632	5	applied	\N	\N	\N	\N	176930	176930	344156
23134	35634	6	applied	\N	\N	\N	\N	176931	176931	344157
23134	35633	7	applied	\N	\N	\N	\N	176932	176932	344158
23134	35635	8	applied	\N	\N	\N	\N	176933	176933	344159
23134	35636	9	applied	\N	\N	\N	\N	176934	176934	344160
23140	35643	0	applied	\N	\N	\N	\N	177043	177043	344269
23140	35644	1	applied	\N	\N	\N	\N	177044	177044	344270
23140	35645	2	applied	\N	\N	\N	\N	177045	177045	344271
23140	35647	4	applied	\N	\N	\N	\N	177047	177047	344273
23140	35648	5	applied	\N	\N	\N	\N	177048	177048	344274
23140	35649	6	applied	\N	\N	\N	\N	177049	177049	344275
23146	35660	0	applied	\N	\N	\N	\N	177074	177074	344300
23146	35661	1	applied	\N	\N	\N	\N	177075	177075	344301
23146	35662	2	applied	\N	\N	\N	\N	177076	177076	344302
23147	35663	0	applied	\N	\N	\N	\N	177077	177077	344303
23147	35664	1	applied	\N	\N	\N	\N	177078	177078	344304
23147	35665	2	applied	\N	\N	\N	\N	177079	177079	344305
23147	35666	3	applied	\N	\N	\N	\N	177080	177080	344306
23147	35667	4	applied	\N	\N	\N	\N	177081	177081	344307
23147	35668	5	applied	\N	\N	\N	\N	177082	177082	344308
23147	35669	6	applied	\N	\N	\N	\N	177083	177083	344309
23147	35670	7	applied	\N	\N	\N	\N	177084	177084	344310
23147	35671	8	applied	\N	\N	\N	\N	177085	177085	344311
23147	35672	9	applied	\N	\N	\N	\N	177086	177086	344312
23148	35674	1	applied	\N	\N	\N	\N	177088	177088	344314
23148	35675	2	applied	\N	\N	\N	\N	177089	177089	344315
23151	35305	0	applied	\N	\N	\N	\N	177096	177096	344322
23151	35306	1	applied	\N	\N	\N	\N	177097	177097	344323
23151	35309	2	applied	\N	\N	\N	\N	177098	177098	344324
23151	35312	3	applied	\N	\N	\N	\N	177099	177099	344325
23151	35316	4	applied	\N	\N	\N	\N	177100	177100	344326
23151	35317	5	applied	\N	\N	\N	\N	177101	177101	344327
23151	35322	6	applied	\N	\N	\N	\N	177102	177102	344328
23151	35323	7	applied	\N	\N	\N	\N	177103	177103	344329
23151	35324	8	applied	\N	\N	\N	\N	177104	177104	344330
23151	35325	9	applied	\N	\N	\N	\N	177105	177105	344331
23153	35676	0	applied	\N	\N	\N	\N	177225	177225	344451
23153	35677	1	applied	\N	\N	\N	\N	177226	177226	344452
23153	35678	2	applied	\N	\N	\N	\N	177227	177227	344453
23153	35679	3	applied	\N	\N	\N	\N	177228	177228	344454
23158	35680	0	applied	\N	\N	\N	\N	177279	177279	344505
23158	35682	1	applied	\N	\N	\N	\N	177280	177280	344506
23158	35683	2	applied	\N	\N	\N	\N	177281	177281	344507
23158	35681	3	applied	\N	\N	\N	\N	177282	177282	344508
23158	35684	4	applied	\N	\N	\N	\N	177283	177283	344509
23158	35685	5	applied	\N	\N	\N	\N	177284	177284	344510
23158	35686	6	applied	\N	\N	\N	\N	177285	177285	344511
23165	35694	0	applied	\N	\N	\N	\N	177311	177311	344537
23165	35695	1	applied	\N	\N	\N	\N	177312	177312	344538
23165	35696	2	applied	\N	\N	\N	\N	177313	177313	344539
23165	35697	3	applied	\N	\N	\N	\N	177314	177314	344540
23170	35700	0	applied	\N	\N	\N	\N	177324	177324	344550
23170	35701	1	applied	\N	\N	\N	\N	177325	177325	344551
23170	35702	2	applied	\N	\N	\N	\N	177326	177326	344552
23078	35487	2	applied	\N	\N	\N	\N	176505	176505	343731
23078	35488	3	applied	\N	\N	\N	\N	176506	176506	343732
23089	35513	46	applied	\N	\N	\N	\N	176591	176591	343817
23089	35519	47	applied	\N	\N	\N	\N	176592	176592	343818
23089	35520	48	applied	\N	\N	\N	\N	176593	176593	343819
23089	35521	49	applied	\N	\N	\N	\N	176594	176594	343820
23089	35522	50	applied	\N	\N	\N	\N	176595	176595	343821
23089	35477	51	applied	\N	\N	\N	\N	176596	176596	343822
23089	35486	52	applied	\N	\N	\N	\N	176597	176597	343823
23089	35498	53	applied	\N	\N	\N	\N	176598	176598	343824
23089	35506	54	applied	\N	\N	\N	\N	176599	176599	343825
23089	35523	55	applied	\N	\N	\N	\N	176600	176600	343826
23089	35478	56	applied	\N	\N	\N	\N	176601	176601	343827
23089	35481	57	applied	\N	\N	\N	\N	176602	176602	343828
23089	35483	58	applied	\N	\N	\N	\N	176603	176603	343829
23089	35490	60	applied	\N	\N	\N	\N	176605	176605	343831
23089	35494	61	applied	\N	\N	\N	\N	176606	176606	343832
23089	35496	62	applied	\N	\N	\N	\N	176607	176607	343833
23089	35501	63	applied	\N	\N	\N	\N	176608	176608	343834
23089	35509	64	applied	\N	\N	\N	\N	176609	176609	343835
23089	35510	65	applied	\N	\N	\N	\N	176610	176610	343836
23089	35511	66	applied	\N	\N	\N	\N	176611	176611	343837
23089	35514	67	applied	\N	\N	\N	\N	176612	176612	343838
23089	35524	68	applied	\N	\N	\N	\N	176613	176613	343839
23089	35525	69	applied	\N	\N	\N	\N	176614	176614	343840
23089	35526	70	applied	\N	\N	\N	\N	176615	176615	343841
23089	35527	71	applied	\N	\N	\N	\N	176616	176616	343842
23092	35535	0	applied	\N	\N	\N	\N	176637	176637	343863
23092	35536	1	applied	\N	\N	\N	\N	176638	176638	343864
23092	35537	2	applied	\N	\N	\N	\N	176639	176639	343865
23095	35538	0	applied	\N	\N	\N	\N	176654	176654	343880
23095	35540	2	applied	\N	\N	\N	\N	176656	176656	343882
23095	35541	3	applied	\N	\N	\N	\N	176657	176657	343883
23095	35542	4	applied	\N	\N	\N	\N	176658	176658	343884
23095	35543	5	applied	\N	\N	\N	\N	176659	176659	343885
23095	35544	6	applied	\N	\N	\N	\N	176660	176660	343886
23097	35545	0	applied	\N	\N	\N	\N	176664	176664	343890
23097	35546	1	applied	\N	\N	\N	\N	176665	176665	343891
23097	35547	2	applied	\N	\N	\N	\N	176666	176666	343892
23102	35560	0	applied	\N	\N	\N	\N	176680	176680	343906
23102	35561	1	applied	\N	\N	\N	\N	176681	176681	343907
23102	35562	2	applied	\N	\N	\N	\N	176682	176682	343908
23102	35563	3	applied	\N	\N	\N	\N	176683	176683	343909
23105	35567	0	applied	\N	\N	\N	\N	176690	176690	343916
23105	35568	1	applied	\N	\N	\N	\N	176691	176691	343917
23105	35569	2	applied	\N	\N	\N	\N	176692	176692	343918
23107	35573	0	applied	\N	\N	\N	\N	176696	176696	343922
23107	35575	2	applied	\N	\N	\N	\N	176698	176698	343924
23107	35576	3	applied	\N	\N	\N	\N	176699	176699	343925
23111	35577	0	applied	\N	\N	\N	\N	176711	176711	343937
23111	35578	1	applied	\N	\N	\N	\N	176712	176712	343938
23111	35579	2	applied	\N	\N	\N	\N	176713	176713	343939
23117	35598	0	applied	\N	\N	\N	\N	176735	176735	343961
23119	35601	0	applied	\N	\N	\N	\N	176736	176736	343962
23119	35602	1	applied	\N	\N	\N	\N	176737	176737	343963
23119	35603	2	applied	\N	\N	\N	\N	176738	176738	343964
23119	35604	3	applied	\N	\N	\N	\N	176739	176739	343965
23119	35605	4	applied	\N	\N	\N	\N	176740	176740	343966
23119	35606	5	applied	\N	\N	\N	\N	176741	176741	343967
23125	35620	0	applied	\N	\N	\N	\N	176764	176764	343990
23127	35623	0	applied	\N	\N	\N	\N	176768	176768	343994
23127	35624	1	applied	\N	\N	\N	\N	176769	176769	343995
23127	35625	2	applied	\N	\N	\N	\N	176770	176770	343996
23127	35627	4	applied	\N	\N	\N	\N	176772	176772	343998
23130	35234	0	applied	\N	\N	1000000000	\N	176783	176783	344009
23130	35166	1	applied	\N	\N	\N	\N	176784	176784	344010
23130	35129	2	applied	\N	\N	\N	\N	176785	176785	344011
23130	35223	3	applied	\N	\N	\N	\N	176786	176786	344012
23130	35170	4	applied	\N	\N	\N	\N	176787	176787	344013
23130	35133	5	applied	\N	\N	\N	\N	176788	176788	344014
23130	35626	6	applied	\N	\N	\N	\N	176789	176789	344015
23130	35598	7	applied	\N	\N	\N	\N	176790	176790	344016
23130	35150	8	applied	\N	\N	\N	\N	176791	176791	344017
23130	35158	9	applied	\N	\N	\N	\N	176792	176792	344018
23130	35198	10	applied	\N	\N	\N	\N	176793	176793	344019
23130	35238	11	applied	\N	\N	\N	\N	176794	176794	344020
23130	35290	12	applied	\N	\N	\N	\N	176795	176795	344021
23130	35176	13	applied	\N	\N	\N	\N	176796	176796	344022
23130	35185	14	applied	\N	\N	\N	\N	176797	176797	344023
23130	35204	16	applied	\N	\N	\N	\N	176799	176799	344025
23130	35222	17	applied	\N	\N	\N	\N	176800	176800	344026
23130	35239	18	applied	\N	\N	\N	\N	176801	176801	344027
23130	35240	19	applied	\N	\N	\N	\N	176802	176802	344028
23130	35627	20	applied	\N	\N	\N	\N	176803	176803	344029
23130	35261	21	applied	\N	\N	\N	\N	176804	176804	344030
23130	35272	22	applied	\N	\N	\N	\N	176805	176805	344031
23130	35284	23	applied	\N	\N	\N	\N	176806	176806	344032
23130	35295	24	applied	\N	\N	\N	\N	176807	176807	344033
23130	35303	25	applied	\N	\N	\N	\N	176808	176808	344034
23130	35315	26	applied	\N	\N	\N	\N	176809	176809	344035
23130	35328	27	applied	\N	\N	\N	\N	176810	176810	344036
23130	35329	28	applied	\N	\N	\N	\N	176811	176811	344037
23130	35346	29	applied	\N	\N	\N	\N	176812	176812	344038
23174	35047	0	applied	\N	\N	\N	\N	177335	177335	344561
23174	35051	1	applied	\N	\N	\N	\N	177336	177336	344562
23174	35234	3	applied	\N	\N	1000000000	\N	177338	177338	344564
23174	35060	4	applied	\N	\N	\N	\N	177339	177339	344565
23174	35063	5	applied	\N	\N	\N	\N	177340	177340	344566
23174	35066	6	applied	\N	\N	\N	\N	177341	177341	344567
23174	35071	7	applied	\N	\N	\N	\N	177342	177342	344568
23174	35072	8	applied	\N	\N	\N	\N	177343	177343	344569
23174	35077	9	applied	\N	\N	\N	\N	177344	177344	344570
23174	35081	10	applied	\N	\N	\N	\N	177345	177345	344571
23174	35083	11	applied	\N	\N	\N	\N	177346	177346	344572
23174	35086	12	applied	\N	\N	\N	\N	177347	177347	344573
23174	35090	13	applied	\N	\N	\N	\N	177348	177348	344574
23174	35091	14	applied	\N	\N	\N	\N	177349	177349	344575
23174	35096	15	applied	\N	\N	\N	\N	177350	177350	344576
23174	35099	16	applied	\N	\N	\N	\N	177351	177351	344577
23174	35103	17	applied	\N	\N	\N	\N	177352	177352	344578
23174	35106	18	applied	\N	\N	\N	\N	177353	177353	344579
23089	35507	44	applied	\N	\N	\N	\N	176589	176589	343815
23089	35508	45	applied	\N	\N	\N	\N	176590	176590	343816
23090	35527	15	applied	\N	\N	\N	\N	176632	176632	343858
23090	35531	16	applied	\N	\N	\N	\N	176633	176633	343859
23093	35538	0	applied	\N	\N	\N	\N	176640	176640	343866
23093	35539	1	applied	\N	\N	\N	\N	176641	176641	343867
23093	35540	2	applied	\N	\N	\N	\N	176642	176642	343868
23093	35541	3	applied	\N	\N	\N	\N	176643	176643	343869
23093	35542	4	applied	\N	\N	\N	\N	176644	176644	343870
23093	35543	5	applied	\N	\N	\N	\N	176645	176645	343871
23093	35544	6	applied	\N	\N	\N	\N	176646	176646	343872
23100	35557	0	applied	\N	\N	\N	\N	176676	176676	343902
23112	35580	0	applied	\N	\N	\N	\N	176714	176714	343940
23112	35581	1	applied	\N	\N	\N	\N	176715	176715	343941
23112	35582	2	applied	\N	\N	\N	\N	176716	176716	343942
23115	35587	0	applied	\N	\N	\N	\N	176721	176721	343947
23115	35588	1	applied	\N	\N	\N	\N	176722	176722	343948
23115	35589	2	applied	\N	\N	\N	\N	176723	176723	343949
23115	35591	4	applied	\N	\N	\N	\N	176725	176725	343951
23115	35592	5	applied	\N	\N	\N	\N	176726	176726	343952
23115	35593	6	applied	\N	\N	\N	\N	176727	176727	343953
23115	35594	7	applied	\N	\N	\N	\N	176728	176728	343954
23115	35595	8	applied	\N	\N	\N	\N	176729	176729	343955
23115	35596	9	applied	\N	\N	\N	\N	176730	176730	343956
23122	35610	0	applied	\N	\N	\N	\N	176751	176751	343977
23122	35611	1	applied	\N	\N	\N	\N	176752	176752	343978
23122	35612	2	applied	\N	\N	\N	\N	176753	176753	343979
23128	35623	0	applied	\N	\N	\N	\N	176773	176773	343999
23128	35624	1	applied	\N	\N	\N	\N	176774	176774	344000
23128	35625	2	applied	\N	\N	\N	\N	176775	176775	344001
23128	35626	3	applied	\N	\N	\N	\N	176776	176776	344002
23128	35627	4	applied	\N	\N	\N	\N	176777	176777	344003
23130	35354	30	applied	\N	\N	\N	\N	176813	176813	344039
23130	35367	31	applied	\N	\N	\N	\N	176814	176814	344040
23130	35392	33	applied	\N	\N	\N	\N	176816	176816	344042
23130	35125	34	applied	\N	\N	\N	\N	176817	176817	344043
23130	35134	35	applied	\N	\N	\N	\N	176818	176818	344044
23130	35135	36	applied	\N	\N	\N	\N	176819	176819	344045
23130	35136	37	applied	\N	\N	\N	\N	176820	176820	344046
23130	35142	38	applied	\N	\N	\N	\N	176821	176821	344047
23130	35145	39	applied	\N	\N	\N	\N	176822	176822	344048
23130	35151	40	applied	\N	\N	\N	\N	176823	176823	344049
23130	35208	41	applied	\N	\N	\N	\N	176824	176824	344050
23130	35209	42	applied	\N	\N	\N	\N	176825	176825	344051
23130	35300	43	applied	\N	\N	\N	\N	176826	176826	344052
23130	35213	44	applied	\N	\N	\N	\N	176827	176827	344053
23130	35214	45	applied	\N	\N	\N	\N	176828	176828	344054
23130	35163	46	applied	\N	\N	\N	\N	176829	176829	344055
23130	35137	47	applied	\N	\N	\N	\N	176830	176830	344056
23130	35138	48	applied	\N	\N	\N	\N	176831	176831	344057
23130	35140	50	applied	\N	\N	\N	\N	176833	176833	344059
23131	35623	0	applied	\N	\N	\N	\N	176906	176906	344132
23131	35624	1	applied	\N	\N	\N	\N	176907	176907	344133
23131	35625	2	applied	\N	\N	\N	\N	176908	176908	344134
23131	35626	3	applied	\N	\N	\N	\N	176909	176909	344135
23131	35627	4	applied	\N	\N	\N	\N	176910	176910	344136
23132	35628	0	applied	\N	\N	\N	\N	176911	176911	344137
23132	35629	1	applied	\N	\N	\N	\N	176912	176912	344138
23132	35630	2	applied	\N	\N	\N	\N	176913	176913	344139
23132	35631	3	applied	\N	\N	\N	\N	176914	176914	344140
23132	35632	5	applied	\N	\N	\N	\N	176915	176915	344141
23132	35633	6	applied	\N	\N	\N	\N	176916	176916	344142
23136	35558	0	applied	\N	\N	\N	\N	176942	176942	344168
23136	35560	1	applied	\N	\N	\N	\N	176943	176943	344169
23136	35564	2	applied	\N	\N	\N	\N	176944	176944	344170
23136	35567	3	applied	\N	\N	\N	\N	176945	176945	344171
23136	35573	5	applied	\N	\N	\N	\N	176947	176947	344173
23136	35577	6	applied	\N	\N	\N	\N	176948	176948	344174
23136	35580	7	applied	\N	\N	\N	\N	176949	176949	344175
23136	35583	8	applied	\N	\N	\N	\N	176950	176950	344176
23136	35587	9	applied	\N	\N	\N	\N	176951	176951	344177
23136	35588	10	applied	\N	\N	\N	\N	176952	176952	344178
23136	35589	11	applied	\N	\N	\N	\N	176953	176953	344179
23136	35597	12	applied	\N	\N	\N	\N	176954	176954	344180
23136	35601	13	applied	\N	\N	\N	\N	176955	176955	344181
23136	35602	14	applied	\N	\N	\N	\N	176956	176956	344182
23136	35607	15	applied	\N	\N	\N	\N	176957	176957	344183
23136	35610	16	applied	\N	\N	\N	\N	176958	176958	344184
23136	35613	17	applied	\N	\N	\N	\N	176959	176959	344185
23136	35614	18	applied	\N	\N	\N	\N	176960	176960	344186
23136	35621	19	applied	\N	\N	\N	\N	176961	176961	344187
23136	35623	20	applied	\N	\N	\N	\N	176962	176962	344188
23136	35561	22	applied	\N	\N	\N	\N	176964	176964	344190
23136	35559	23	applied	\N	\N	\N	\N	176965	176965	344191
23136	35562	24	applied	\N	\N	\N	\N	176966	176966	344192
23136	35566	25	applied	\N	\N	\N	\N	176967	176967	344193
23136	35568	26	applied	\N	\N	\N	\N	176968	176968	344194
23136	35626	27	applied	\N	\N	\N	\N	176969	176969	344195
23136	35598	28	applied	\N	\N	\N	\N	176970	176970	344196
23136	35575	29	applied	\N	\N	\N	\N	176971	176971	344197
23136	35585	30	applied	\N	\N	\N	\N	176972	176972	344198
23136	35557	31	applied	\N	\N	\N	\N	176973	176973	344199
23136	35563	32	applied	\N	\N	\N	\N	176974	176974	344200
23136	35565	33	applied	\N	\N	\N	\N	176975	176975	344201
23136	35569	34	applied	\N	\N	\N	\N	176976	176976	344202
23136	35571	35	applied	\N	\N	\N	\N	176977	176977	344203
23136	35574	36	applied	\N	\N	\N	\N	176978	176978	344204
23136	35578	37	applied	\N	\N	\N	\N	176979	176979	344205
23136	35584	39	applied	\N	\N	\N	\N	176981	176981	344207
23136	35590	40	applied	\N	\N	\N	\N	176982	176982	344208
23136	35627	41	applied	\N	\N	\N	\N	176983	176983	344209
23136	35631	42	applied	\N	\N	\N	\N	176984	176984	344210
23136	35632	43	applied	\N	\N	\N	\N	176985	176985	344211
23136	35572	44	applied	\N	\N	\N	\N	176986	176986	344212
23136	35593	45	applied	\N	\N	\N	\N	176987	176987	344213
23136	35609	46	applied	\N	\N	\N	\N	176988	176988	344214
23136	35615	47	applied	\N	\N	\N	\N	176989	176989	344215
23136	35595	48	applied	\N	\N	\N	\N	176990	176990	344216
23136	35596	49	applied	\N	\N	\N	\N	176991	176991	344217
23136	35576	50	applied	\N	\N	\N	\N	176992	176992	344218
23136	35579	51	applied	\N	\N	\N	\N	176993	176993	344219
23136	35581	52	applied	\N	\N	\N	\N	176994	176994	344220
23090	35521	12	applied	\N	\N	\N	\N	176629	176629	343855
23090	35522	13	applied	\N	\N	\N	\N	176630	176630	343856
23130	35168	55	applied	\N	\N	\N	\N	176838	176838	344064
23130	35172	56	applied	\N	\N	\N	\N	176839	176839	344065
23130	35175	57	applied	\N	\N	\N	\N	176840	176840	344066
23130	35178	58	applied	\N	\N	\N	\N	176841	176841	344067
23130	35181	59	applied	\N	\N	\N	\N	176842	176842	344068
23130	35184	60	applied	\N	\N	\N	\N	176843	176843	344069
23130	35188	61	applied	\N	\N	\N	\N	176844	176844	344070
23130	35191	62	applied	\N	\N	\N	\N	176845	176845	344071
23130	35195	63	applied	\N	\N	\N	\N	176846	176846	344072
23130	35199	64	applied	\N	\N	\N	\N	176847	176847	344073
23130	35210	65	applied	\N	\N	\N	\N	176848	176848	344074
23130	35211	66	applied	\N	\N	\N	\N	176849	176849	344075
23130	35212	67	applied	\N	\N	\N	\N	176850	176850	344076
23130	35216	68	applied	\N	\N	\N	\N	176851	176851	344077
23130	35224	69	applied	\N	\N	\N	\N	176852	176852	344078
23130	35225	70	applied	\N	\N	\N	\N	176853	176853	344079
23130	35231	72	applied	\N	\N	\N	\N	176855	176855	344081
23130	35406	73	applied	\N	\N	\N	\N	176856	176856	344082
23130	35413	74	applied	\N	\N	\N	\N	176857	176857	344083
23130	35422	75	applied	\N	\N	\N	\N	176858	176858	344084
23130	35433	76	applied	\N	\N	\N	\N	176859	176859	344085
23130	35443	77	applied	\N	\N	\N	\N	176860	176860	344086
23130	35454	78	applied	\N	\N	\N	\N	176861	176861	344087
23130	35464	79	applied	\N	\N	\N	\N	176862	176862	344088
23130	35477	80	applied	\N	\N	\N	\N	176863	176863	344089
23130	35486	81	applied	\N	\N	\N	\N	176864	176864	344090
23130	35498	82	applied	\N	\N	\N	\N	176865	176865	344091
23130	35506	83	applied	\N	\N	\N	\N	176866	176866	344092
23130	35523	84	applied	\N	\N	\N	\N	176867	176867	344093
23130	35529	85	applied	\N	\N	\N	\N	176868	176868	344094
23130	35540	86	applied	\N	\N	\N	\N	176869	176869	344095
23130	35550	87	applied	\N	\N	\N	\N	176870	176870	344096
23130	35575	89	applied	\N	\N	\N	\N	176872	176872	344098
23130	35585	90	applied	\N	\N	\N	\N	176873	176873	344099
23130	35593	91	applied	\N	\N	\N	\N	176874	176874	344100
23130	35609	92	applied	\N	\N	\N	\N	176875	176875	344101
23130	35615	93	applied	\N	\N	\N	\N	176876	176876	344102
23130	35246	94	applied	\N	\N	\N	\N	176877	176877	344103
23130	35247	95	applied	\N	\N	\N	\N	176878	176878	344104
23130	35248	96	applied	\N	\N	\N	\N	176879	176879	344105
23130	35249	97	applied	\N	\N	\N	\N	176880	176880	344106
23130	35250	98	applied	\N	\N	\N	\N	176881	176881	344107
23130	35252	99	applied	\N	\N	\N	\N	176882	176882	344108
23130	35257	100	applied	\N	\N	\N	\N	176883	176883	344109
23130	35260	101	applied	\N	\N	\N	\N	176884	176884	344110
23130	35266	102	applied	\N	\N	\N	\N	176885	176885	344111
23130	35267	103	applied	\N	\N	\N	\N	176886	176886	344112
23130	35269	104	applied	\N	\N	\N	\N	176887	176887	344113
23130	35275	106	applied	\N	\N	\N	\N	176889	176889	344115
23130	35285	107	applied	\N	\N	\N	\N	176890	176890	344116
23130	35311	108	applied	\N	\N	\N	\N	176891	176891	344117
23130	35314	109	applied	\N	\N	\N	\N	176892	176892	344118
23130	35318	110	applied	\N	\N	\N	\N	176893	176893	344119
23130	35319	111	applied	\N	\N	\N	\N	176894	176894	344120
23130	35326	112	applied	\N	\N	\N	\N	176895	176895	344121
23130	35327	113	applied	\N	\N	\N	\N	176896	176896	344122
23130	35334	114	applied	\N	\N	\N	\N	176897	176897	344123
23130	35335	115	applied	\N	\N	\N	\N	176898	176898	344124
23130	35337	116	applied	\N	\N	\N	\N	176899	176899	344125
23130	35340	117	applied	\N	\N	\N	\N	176900	176900	344126
23130	35343	118	applied	\N	\N	\N	\N	176901	176901	344127
23130	35348	119	applied	\N	\N	\N	\N	176902	176902	344128
23130	35350	120	applied	\N	\N	\N	\N	176903	176903	344129
23130	35357	123	applied	\N	\N	\N	\N	176904	176904	344130
23135	35628	0	applied	\N	\N	\N	\N	176935	176935	344161
23135	35629	1	applied	\N	\N	\N	\N	176936	176936	344162
23135	35630	2	applied	\N	\N	\N	\N	176937	176937	344163
23135	35631	3	applied	\N	\N	\N	\N	176938	176938	344164
23135	35632	5	applied	\N	\N	\N	\N	176939	176939	344165
23135	35633	6	applied	\N	\N	\N	\N	176940	176940	344166
23135	35635	7	applied	\N	\N	\N	\N	176941	176941	344167
23136	35586	53	applied	\N	\N	\N	\N	176995	176995	344221
23136	35591	54	applied	\N	\N	\N	\N	176996	176996	344222
23136	35592	55	applied	\N	\N	\N	\N	176997	176997	344223
23136	35594	56	applied	\N	\N	\N	\N	176998	176998	344224
23136	35599	57	applied	\N	\N	\N	\N	176999	176999	344225
23136	35603	58	applied	\N	\N	\N	\N	177000	177000	344226
23136	35605	59	applied	\N	\N	\N	\N	177001	177001	344227
23136	35611	60	applied	\N	\N	\N	\N	177002	177002	344228
23136	35617	61	applied	\N	\N	\N	\N	177003	177003	344229
23136	35620	63	applied	\N	\N	\N	\N	177005	177005	344231
23136	35624	64	applied	\N	\N	\N	\N	177006	177006	344232
23136	35633	65	applied	\N	\N	\N	\N	177007	177007	344233
23136	35600	66	applied	\N	\N	\N	\N	177008	177008	344234
23136	35604	67	applied	\N	\N	\N	\N	177009	177009	344235
23136	35606	68	applied	\N	\N	\N	\N	177010	177010	344236
23136	35608	69	applied	\N	\N	\N	\N	177011	177011	344237
23136	35612	70	applied	\N	\N	\N	\N	177012	177012	344238
23136	35616	71	applied	\N	\N	\N	\N	177013	177013	344239
23136	35619	72	applied	\N	\N	\N	\N	177014	177014	344240
23136	35622	73	applied	\N	\N	\N	\N	177015	177015	344241
23141	35643	0	applied	\N	\N	\N	\N	177050	177050	344276
23141	35644	1	applied	\N	\N	\N	\N	177051	177051	344277
23141	35645	2	applied	\N	\N	\N	\N	177052	177052	344278
23141	35646	3	applied	\N	\N	\N	\N	177053	177053	344279
23141	35647	4	applied	\N	\N	\N	\N	177054	177054	344280
23141	35649	6	applied	\N	\N	\N	\N	177056	177056	344282
23149	35673	0	applied	\N	\N	\N	\N	177090	177090	344316
23149	35674	1	applied	\N	\N	\N	\N	177091	177091	344317
23149	35675	2	applied	\N	\N	\N	\N	177092	177092	344318
23159	35680	0	applied	\N	\N	\N	\N	177286	177286	344512
23159	35682	1	applied	\N	\N	\N	\N	177287	177287	344513
23159	35683	2	applied	\N	\N	\N	\N	177288	177288	344514
23159	35681	3	applied	\N	\N	\N	\N	177289	177289	344515
23159	35684	4	applied	\N	\N	\N	\N	177290	177290	344516
23159	35685	5	applied	\N	\N	\N	\N	177291	177291	344517
23159	35686	6	applied	\N	\N	\N	\N	177292	177292	344518
23160	35687	0	applied	\N	\N	\N	\N	177293	177293	344519
23160	35688	1	applied	\N	\N	\N	\N	177294	177294	344520
23166	35698	0	applied	\N	\N	\N	\N	177315	177315	344541
23130	35156	52	applied	\N	\N	\N	\N	176835	176835	344061
23130	35159	53	applied	\N	\N	\N	\N	176836	176836	344062
23137	35634	2	applied	\N	\N	\N	\N	177020	177020	344246
23137	35635	3	applied	\N	\N	\N	\N	177021	177021	344247
23137	35639	4	applied	\N	\N	\N	\N	177022	177022	344248
23137	35640	5	applied	\N	\N	\N	\N	177023	177023	344249
23137	35636	6	applied	\N	\N	\N	\N	177024	177024	344250
23137	35641	7	applied	\N	\N	\N	\N	177025	177025	344251
23137	35642	8	applied	\N	\N	\N	\N	177026	177026	344252
23142	35643	0	applied	\N	\N	\N	\N	177057	177057	344283
23142	35644	1	applied	\N	\N	\N	\N	177058	177058	344284
23142	35645	2	applied	\N	\N	\N	\N	177059	177059	344285
23142	35646	3	applied	\N	\N	\N	\N	177060	177060	344286
23142	35647	4	applied	\N	\N	\N	\N	177061	177061	344287
23142	35648	5	applied	\N	\N	\N	\N	177062	177062	344288
23142	35649	6	applied	\N	\N	\N	\N	177063	177063	344289
23143	35650	0	applied	\N	\N	\N	\N	177064	177064	344290
23143	35651	1	applied	\N	\N	\N	\N	177065	177065	344291
23150	35673	0	applied	\N	\N	\N	\N	177093	177093	344319
23150	35674	1	applied	\N	\N	\N	\N	177094	177094	344320
23150	35675	2	applied	\N	\N	\N	\N	177095	177095	344321
23155	35680	0	applied	\N	\N	\N	\N	177229	177229	344455
23155	35681	1	applied	\N	\N	\N	\N	177230	177230	344456
23161	35687	0	applied	\N	\N	\N	\N	177295	177295	344521
23161	35688	1	applied	\N	\N	\N	\N	177296	177296	344522
23162	35689	0	applied	\N	\N	\N	\N	177297	177297	344523
23162	35690	1	applied	\N	\N	\N	\N	177298	177298	344524
23162	35691	2	applied	\N	\N	\N	\N	177299	177299	344525
23162	35692	3	applied	\N	\N	\N	\N	177300	177300	344526
23162	35693	4	applied	\N	\N	\N	\N	177301	177301	344527
23166	35699	1	applied	\N	\N	\N	\N	177316	177316	344542
23167	35698	0	applied	\N	\N	\N	\N	177317	177317	344543
23167	35699	1	applied	\N	\N	\N	\N	177318	177318	344544
23171	35700	0	applied	\N	\N	\N	\N	177327	177327	344553
23171	35702	2	applied	\N	\N	\N	\N	177329	177329	344555
23172	35700	0	applied	\N	\N	\N	\N	177330	177330	344556
23172	35701	1	applied	\N	\N	\N	\N	177331	177331	344557
23172	35702	2	applied	\N	\N	\N	\N	177332	177332	344558
23176	35705	0	applied	\N	\N	\N	\N	177463	177463	344689
23176	35706	1	applied	\N	\N	\N	\N	177464	177464	344690
23176	35708	2	applied	\N	\N	\N	\N	177465	177465	344691
23176	35707	3	applied	\N	\N	\N	\N	177466	177466	344692
23176	35709	4	applied	\N	\N	\N	\N	177467	177467	344693
23177	35710	0	applied	\N	\N	\N	\N	177468	177468	344694
23177	35708	1	applied	\N	\N	\N	\N	177469	177469	344695
23177	35709	2	applied	\N	\N	\N	\N	177470	177470	344696
23177	35711	3	applied	\N	\N	\N	\N	177471	177471	344697
23178	35712	0	applied	\N	\N	\N	\N	177472	177472	344698
23178	35713	1	applied	\N	\N	\N	\N	177473	177473	344699
23179	35564	0	applied	\N	\N	\N	\N	177474	177474	344700
23179	35570	2	applied	\N	\N	\N	\N	177476	177476	344702
23179	35573	3	applied	\N	\N	\N	\N	177477	177477	344703
23179	35577	4	applied	\N	\N	\N	\N	177478	177478	344704
23179	35580	5	applied	\N	\N	\N	\N	177479	177479	344705
23179	35583	6	applied	\N	\N	\N	\N	177480	177480	344706
23179	35587	7	applied	\N	\N	\N	\N	177481	177481	344707
23179	35588	8	applied	\N	\N	\N	\N	177482	177482	344708
23179	35589	9	applied	\N	\N	\N	\N	177483	177483	344709
23179	35597	10	applied	\N	\N	\N	\N	177484	177484	344710
23179	35601	11	applied	\N	\N	\N	\N	177485	177485	344711
23179	35602	12	applied	\N	\N	\N	\N	177486	177486	344712
23179	35607	13	applied	\N	\N	\N	\N	177487	177487	344713
23179	35610	14	applied	\N	\N	\N	\N	177488	177488	344714
23179	35613	15	applied	\N	\N	\N	\N	177489	177489	344715
23179	35614	16	applied	\N	\N	\N	\N	177490	177490	344716
23179	35621	17	applied	\N	\N	\N	\N	177491	177491	344717
23179	35628	19	applied	\N	\N	\N	\N	177493	177493	344719
23179	35629	20	applied	\N	\N	\N	\N	177494	177494	344720
23179	35637	21	applied	\N	\N	\N	\N	177495	177495	344721
23179	35638	22	applied	\N	\N	\N	\N	177496	177496	344722
23179	35643	23	applied	\N	\N	\N	\N	177497	177497	344723
23179	35644	24	applied	\N	\N	\N	\N	177498	177498	344724
23179	35650	25	applied	\N	\N	\N	\N	177499	177499	344725
23179	35653	26	applied	\N	\N	\N	\N	177500	177500	344726
23179	35657	27	applied	\N	\N	\N	\N	177501	177501	344727
23179	35660	28	applied	\N	\N	\N	\N	177502	177502	344728
23179	35663	29	applied	\N	\N	\N	\N	177503	177503	344729
23179	35664	30	applied	\N	\N	\N	\N	177504	177504	344730
23179	35665	31	applied	\N	\N	\N	\N	177505	177505	344731
23179	35673	32	applied	\N	\N	\N	\N	177506	177506	344732
23179	35676	33	applied	\N	\N	\N	\N	177507	177507	344733
23179	35680	34	applied	\N	\N	\N	\N	177508	177508	344734
23179	35683	36	applied	\N	\N	\N	\N	177510	177510	344736
23179	35687	37	applied	\N	\N	\N	\N	177511	177511	344737
23179	35689	38	applied	\N	\N	\N	\N	177512	177512	344738
23179	35690	39	applied	\N	\N	\N	\N	177513	177513	344739
23179	35694	40	applied	\N	\N	\N	\N	177514	177514	344740
23179	35695	41	applied	\N	\N	\N	\N	177515	177515	344741
23179	35698	42	applied	\N	\N	\N	\N	177516	177516	344742
23179	35700	43	applied	\N	\N	\N	\N	177517	177517	344743
23179	35703	44	applied	\N	\N	\N	\N	177518	177518	344744
23179	35705	45	applied	\N	\N	\N	\N	177519	177519	344745
23179	35706	46	applied	\N	\N	\N	\N	177520	177520	344746
23179	35710	47	applied	\N	\N	\N	\N	177521	177521	344747
23179	35712	48	applied	\N	\N	\N	\N	177522	177522	344748
23179	35714	49	applied	\N	\N	\N	\N	177523	177523	344749
23179	35715	50	applied	\N	\N	\N	\N	177524	177524	344750
23179	35565	51	applied	\N	\N	\N	\N	177525	177525	344751
23179	35566	53	applied	\N	\N	\N	\N	177527	177527	344753
23179	35568	54	applied	\N	\N	\N	\N	177528	177528	344754
23179	35626	55	applied	\N	\N	\N	\N	177529	177529	344755
23179	35598	56	applied	\N	\N	\N	\N	177530	177530	344756
23179	35571	57	applied	\N	\N	\N	\N	177531	177531	344757
23179	35574	58	applied	\N	\N	\N	\N	177532	177532	344758
23180	35714	0	applied	\N	\N	\N	\N	177599	177599	344825
23180	35715	1	applied	\N	\N	\N	\N	177600	177600	344826
23180	35717	2	applied	\N	\N	\N	\N	177601	177601	344827
23180	35718	3	applied	\N	\N	\N	\N	177602	177602	344828
23180	35719	5	applied	\N	\N	\N	\N	177603	177603	344829
23180	35716	6	applied	\N	\N	\N	\N	177604	177604	344830
23180	35720	7	applied	\N	\N	\N	\N	177605	177605	344831
23184	34946	0	applied	\N	\N	\N	\N	177642	177642	344868
23136	35634	75	applied	\N	\N	\N	\N	177017	177017	344243
23137	35637	0	applied	\N	\N	\N	\N	177018	177018	344244
23151	35349	14	applied	\N	\N	\N	\N	177110	177110	344336
23151	35352	15	applied	\N	\N	\N	\N	177111	177111	344337
23151	35353	16	applied	\N	\N	\N	\N	177112	177112	344338
23151	35359	17	applied	\N	\N	\N	\N	177113	177113	344339
23151	35362	18	applied	\N	\N	\N	\N	177114	177114	344340
23151	35363	19	applied	\N	\N	\N	\N	177115	177115	344341
23151	35364	20	applied	\N	\N	\N	\N	177116	177116	344342
23151	35365	21	applied	\N	\N	\N	\N	177117	177117	344343
23151	35375	22	applied	\N	\N	\N	\N	177118	177118	344344
23151	35378	23	applied	\N	\N	\N	\N	177119	177119	344345
23151	35381	24	applied	\N	\N	\N	\N	177120	177120	344346
23151	35382	25	applied	\N	\N	\N	\N	177121	177121	344347
23151	35387	26	applied	\N	\N	\N	\N	177122	177122	344348
23151	35388	27	applied	\N	\N	\N	\N	177123	177123	344349
23151	35389	28	applied	\N	\N	\N	\N	177124	177124	344350
23151	35397	29	applied	\N	\N	\N	\N	177125	177125	344351
23151	35399	31	applied	\N	\N	\N	\N	177127	177127	344353
23151	35407	32	applied	\N	\N	\N	\N	177128	177128	344354
23151	35408	33	applied	\N	\N	\N	\N	177129	177129	344355
23151	35414	34	applied	\N	\N	\N	\N	177130	177130	344356
23151	35417	35	applied	\N	\N	\N	\N	177131	177131	344357
23151	35420	36	applied	\N	\N	\N	\N	177132	177132	344358
23151	35424	37	applied	\N	\N	\N	\N	177133	177133	344359
23151	35427	38	applied	\N	\N	\N	\N	177134	177134	344360
23151	35428	39	applied	\N	\N	\N	\N	177135	177135	344361
23151	35434	40	applied	\N	\N	\N	\N	177136	177136	344362
23151	35439	41	applied	\N	\N	\N	\N	177137	177137	344363
23151	35440	42	applied	\N	\N	\N	\N	177138	177138	344364
23151	35446	43	applied	\N	\N	\N	\N	177139	177139	344365
23151	35449	44	applied	\N	\N	\N	\N	177140	177140	344366
23151	35452	45	applied	\N	\N	\N	\N	177141	177141	344367
23151	35456	46	applied	\N	\N	\N	\N	177142	177142	344368
23151	35462	48	applied	\N	\N	\N	\N	177144	177144	344370
23151	35466	49	applied	\N	\N	\N	\N	177145	177145	344371
23151	35467	50	applied	\N	\N	\N	\N	177146	177146	344372
23151	35472	51	applied	\N	\N	\N	\N	177147	177147	344373
23151	35475	52	applied	\N	\N	\N	\N	177148	177148	344374
23151	35479	53	applied	\N	\N	\N	\N	177149	177149	344375
23151	35482	54	applied	\N	\N	\N	\N	177150	177150	344376
23151	35484	55	applied	\N	\N	\N	\N	177151	177151	344377
23151	35489	56	applied	\N	\N	\N	\N	177152	177152	344378
23151	35492	57	applied	\N	\N	\N	\N	177153	177153	344379
23151	35495	58	applied	\N	\N	\N	\N	177154	177154	344380
23151	35499	59	applied	\N	\N	\N	\N	177155	177155	344381
23151	35502	60	applied	\N	\N	\N	\N	177156	177156	344382
23151	35503	61	applied	\N	\N	\N	\N	177157	177157	344383
23151	35504	62	applied	\N	\N	\N	\N	177158	177158	344384
23151	35512	63	applied	\N	\N	\N	\N	177159	177159	344385
23151	35516	65	applied	\N	\N	\N	\N	177161	177161	344387
23151	35517	66	applied	\N	\N	\N	\N	177162	177162	344388
23151	35518	67	applied	\N	\N	\N	\N	177163	177163	344389
23151	35528	68	applied	\N	\N	\N	\N	177164	177164	344390
23151	35532	69	applied	\N	\N	\N	\N	177165	177165	344391
23151	35535	70	applied	\N	\N	\N	\N	177166	177166	344392
23151	35538	71	applied	\N	\N	\N	\N	177167	177167	344393
23151	35539	72	applied	\N	\N	\N	\N	177168	177168	344394
23151	35545	73	applied	\N	\N	\N	\N	177169	177169	344395
23151	35548	74	applied	\N	\N	\N	\N	177170	177170	344396
23151	35549	75	applied	\N	\N	\N	\N	177171	177171	344397
23151	35554	76	applied	\N	\N	\N	\N	177172	177172	344398
23151	35558	77	applied	\N	\N	\N	\N	177173	177173	344399
23151	35560	78	applied	\N	\N	\N	\N	177174	177174	344400
23151	35564	79	applied	\N	\N	\N	\N	177175	177175	344401
23151	35567	80	applied	\N	\N	\N	\N	177176	177176	344402
23151	35573	83	applied	\N	\N	\N	\N	177178	177178	344404
23151	35577	84	applied	\N	\N	\N	\N	177179	177179	344405
23151	35580	85	applied	\N	\N	\N	\N	177180	177180	344406
23151	35583	86	applied	\N	\N	\N	\N	177181	177181	344407
23151	35587	87	applied	\N	\N	\N	\N	177182	177182	344408
23151	35588	88	applied	\N	\N	\N	\N	177183	177183	344409
23151	35589	89	applied	\N	\N	\N	\N	177184	177184	344410
23151	35597	90	applied	\N	\N	\N	\N	177185	177185	344411
23151	35601	91	applied	\N	\N	\N	\N	177186	177186	344412
23151	35602	92	applied	\N	\N	\N	\N	177187	177187	344413
23151	35607	93	applied	\N	\N	\N	\N	177188	177188	344414
23151	35610	94	applied	\N	\N	\N	\N	177189	177189	344415
23151	35613	95	applied	\N	\N	\N	\N	177190	177190	344416
23151	35614	96	applied	\N	\N	\N	\N	177191	177191	344417
23151	35621	97	applied	\N	\N	\N	\N	177192	177192	344418
23151	35623	98	applied	\N	\N	\N	\N	177193	177193	344419
23151	35629	100	applied	\N	\N	\N	\N	177195	177195	344421
23151	35637	101	applied	\N	\N	\N	\N	177196	177196	344422
23151	35638	102	applied	\N	\N	\N	\N	177197	177197	344423
23151	35643	103	applied	\N	\N	\N	\N	177198	177198	344424
23151	35644	104	applied	\N	\N	\N	\N	177199	177199	344425
23151	35650	105	applied	\N	\N	\N	\N	177200	177200	344426
23151	35653	106	applied	\N	\N	\N	\N	177201	177201	344427
23151	35657	107	applied	\N	\N	\N	\N	177202	177202	344428
23151	35660	108	applied	\N	\N	\N	\N	177203	177203	344429
23151	35663	109	applied	\N	\N	\N	\N	177204	177204	344430
23179	35578	59	applied	\N	\N	\N	\N	177533	177533	344759
23179	35575	60	applied	\N	\N	\N	\N	177534	177534	344760
23179	35585	61	applied	\N	\N	\N	\N	177535	177535	344761
23179	35582	62	applied	\N	\N	\N	\N	177536	177536	344762
23179	35584	63	applied	\N	\N	\N	\N	177537	177537	344763
23179	35590	64	applied	\N	\N	\N	\N	177538	177538	344764
23179	35631	66	applied	\N	\N	\N	\N	177540	177540	344766
23179	35632	67	applied	\N	\N	\N	\N	177541	177541	344767
23179	35572	68	applied	\N	\N	\N	\N	177542	177542	344768
23179	35593	69	applied	\N	\N	\N	\N	177543	177543	344769
23179	35609	70	applied	\N	\N	\N	\N	177544	177544	344770
23179	35615	71	applied	\N	\N	\N	\N	177545	177545	344771
23179	35630	72	applied	\N	\N	\N	\N	177546	177546	344772
23179	35645	73	applied	\N	\N	\N	\N	177547	177547	344773
23179	35595	74	applied	\N	\N	\N	\N	177548	177548	344774
23179	35596	75	applied	\N	\N	\N	\N	177549	177549	344775
23179	35656	76	applied	\N	\N	\N	\N	177550	177550	344776
23179	35666	77	applied	\N	\N	\N	\N	177551	177551	344777
23179	35679	78	applied	\N	\N	\N	\N	177552	177552	344778
23179	35684	79	applied	\N	\N	\N	\N	177553	177553	344779
23151	35339	11	applied	\N	\N	\N	\N	177107	177107	344333
23151	35342	12	applied	\N	\N	\N	\N	177108	177108	344334
23151	35328	114	applied	\N	\N	\N	\N	177209	177209	344435
23151	35626	115	applied	\N	\N	\N	\N	177210	177210	344436
23151	35598	116	applied	\N	\N	\N	\N	177211	177211	344437
23151	35329	117	applied	\N	\N	\N	\N	177212	177212	344438
23151	35346	118	applied	\N	\N	\N	\N	177213	177213	344439
23151	35354	119	applied	\N	\N	\N	\N	177214	177214	344440
23151	35367	120	applied	\N	\N	\N	\N	177215	177215	344441
23151	35380	121	applied	\N	\N	\N	\N	177216	177216	344442
23151	35392	122	applied	\N	\N	\N	\N	177217	177217	344443
23151	35627	123	applied	\N	\N	\N	\N	177218	177218	344444
23151	35631	124	applied	\N	\N	\N	\N	177219	177219	344445
23151	35632	125	applied	\N	\N	\N	\N	177220	177220	344446
23152	35676	0	applied	\N	\N	\N	\N	177221	177221	344447
23152	35677	1	applied	\N	\N	\N	\N	177222	177222	344448
23152	35678	2	applied	\N	\N	\N	\N	177223	177223	344449
23152	35679	3	applied	\N	\N	\N	\N	177224	177224	344450
23156	35637	1	applied	\N	\N	\N	\N	177232	177232	344458
23156	35638	2	applied	\N	\N	\N	\N	177233	177233	344459
23156	35643	3	applied	\N	\N	\N	\N	177234	177234	344460
23156	35644	4	applied	\N	\N	\N	\N	177235	177235	344461
23156	35650	5	applied	\N	\N	\N	\N	177236	177236	344462
23156	35653	6	applied	\N	\N	\N	\N	177237	177237	344463
23156	35657	7	applied	\N	\N	\N	\N	177238	177238	344464
23156	35660	8	applied	\N	\N	\N	\N	177239	177239	344465
23156	35663	9	applied	\N	\N	\N	\N	177240	177240	344466
23156	35664	10	applied	\N	\N	\N	\N	177241	177241	344467
23156	35665	11	applied	\N	\N	\N	\N	177242	177242	344468
23156	35673	12	applied	\N	\N	\N	\N	177243	177243	344469
23156	35676	13	applied	\N	\N	\N	\N	177244	177244	344470
23156	35630	14	applied	\N	\N	\N	\N	177245	177245	344471
23156	35645	15	applied	\N	\N	\N	\N	177246	177246	344472
23156	35635	16	applied	\N	\N	\N	\N	177247	177247	344473
23156	35640	18	applied	\N	\N	\N	\N	177249	177249	344475
23156	35646	19	applied	\N	\N	\N	\N	177250	177250	344476
23156	35647	20	applied	\N	\N	\N	\N	177251	177251	344477
23156	35652	21	applied	\N	\N	\N	\N	177252	177252	344478
23156	35655	22	applied	\N	\N	\N	\N	177253	177253	344479
23156	35658	23	applied	\N	\N	\N	\N	177254	177254	344480
23156	35662	24	applied	\N	\N	\N	\N	177255	177255	344481
23156	35667	25	applied	\N	\N	\N	\N	177256	177256	344482
23156	35668	26	applied	\N	\N	\N	\N	177257	177257	344483
23156	35670	27	applied	\N	\N	\N	\N	177258	177258	344484
23156	35636	28	applied	\N	\N	\N	\N	177259	177259	344485
23156	35641	29	applied	\N	\N	\N	\N	177260	177260	344486
23156	35642	30	applied	\N	\N	\N	\N	177261	177261	344487
23156	35648	32	applied	\N	\N	\N	\N	177262	177262	344488
23156	35649	33	applied	\N	\N	\N	\N	177263	177263	344489
23156	35651	34	applied	\N	\N	\N	\N	177264	177264	344490
23156	35659	36	applied	\N	\N	\N	\N	177266	177266	344492
23156	35661	37	applied	\N	\N	\N	\N	177267	177267	344493
23156	35669	38	applied	\N	\N	\N	\N	177268	177268	344494
23156	35671	39	applied	\N	\N	\N	\N	177269	177269	344495
23156	35672	40	applied	\N	\N	\N	\N	177270	177270	344496
23156	35674	41	applied	\N	\N	\N	\N	177271	177271	344497
23156	35678	42	applied	\N	\N	\N	\N	177272	177272	344498
23156	35656	43	applied	\N	\N	\N	\N	177273	177273	344499
23156	35666	44	applied	\N	\N	\N	\N	177274	177274	344500
23156	35679	45	applied	\N	\N	\N	\N	177275	177275	344501
23156	35675	46	applied	\N	\N	\N	\N	177276	177276	344502
23156	35677	47	applied	\N	\N	\N	\N	177277	177277	344503
23163	35689	0	applied	\N	\N	\N	\N	177302	177302	344528
23163	35690	1	applied	\N	\N	\N	\N	177303	177303	344529
23163	35691	2	applied	\N	\N	\N	\N	177304	177304	344530
23163	35692	3	applied	\N	\N	\N	\N	177305	177305	344531
23164	35694	0	applied	\N	\N	\N	\N	177307	177307	344533
23164	35695	1	applied	\N	\N	\N	\N	177308	177308	344534
23164	35696	2	applied	\N	\N	\N	\N	177309	177309	344535
23164	35697	3	applied	\N	\N	\N	\N	177310	177310	344536
23168	35698	0	applied	\N	\N	\N	\N	177319	177319	344545
23168	35699	1	applied	\N	\N	\N	\N	177320	177320	344546
23169	35700	0	applied	\N	\N	\N	\N	177321	177321	344547
23169	35701	1	applied	\N	\N	\N	\N	177322	177322	344548
23169	35702	2	applied	\N	\N	\N	\N	177323	177323	344549
23173	35703	0	applied	\N	\N	\N	\N	177333	177333	344559
23173	35704	1	applied	\N	\N	\N	\N	177334	177334	344560
23174	35113	20	applied	\N	\N	\N	\N	177355	177355	344581
23174	35116	21	applied	\N	\N	\N	\N	177356	177356	344582
23174	35121	22	applied	\N	\N	\N	\N	177357	177357	344583
23174	35123	23	applied	\N	\N	\N	\N	177358	177358	344584
23174	35126	24	applied	\N	\N	\N	\N	177359	177359	344585
23174	35128	26	applied	\N	\N	\N	\N	177361	177361	344587
23174	35141	27	applied	\N	\N	\N	\N	177362	177362	344588
23174	35144	28	applied	\N	\N	\N	\N	177363	177363	344589
23174	35147	29	applied	\N	\N	\N	\N	177364	177364	344590
23174	35148	30	applied	\N	\N	\N	\N	177365	177365	344591
23174	35149	31	applied	\N	\N	\N	\N	177366	177366	344592
23174	35157	32	applied	\N	\N	\N	\N	177367	177367	344593
23174	35161	33	applied	\N	\N	\N	\N	177368	177368	344594
23174	35165	34	applied	\N	\N	\N	\N	177369	177369	344595
23174	35169	35	applied	\N	\N	\N	\N	177370	177370	344596
23174	35173	36	applied	\N	\N	\N	\N	177371	177371	344597
23174	35177	37	applied	\N	\N	\N	\N	177372	177372	344598
23174	35180	38	applied	\N	\N	\N	\N	177373	177373	344599
23174	35183	39	applied	\N	\N	\N	\N	177374	177374	344600
23174	35187	40	applied	\N	\N	\N	\N	177375	177375	344601
23174	35190	41	applied	\N	\N	\N	\N	177376	177376	344602
23174	35194	43	applied	\N	\N	\N	\N	177378	177378	344604
23174	35201	44	applied	\N	\N	\N	\N	177379	177379	344605
23182	35714	0	applied	\N	\N	\N	\N	177618	177618	344844
23182	35715	1	applied	\N	\N	\N	\N	177619	177619	344845
23182	35717	2	applied	\N	\N	\N	\N	177620	177620	344846
23182	35718	3	applied	\N	\N	\N	\N	177621	177621	344847
23182	35719	5	applied	\N	\N	\N	\N	177622	177622	344848
23182	35721	6	applied	\N	\N	\N	\N	177623	177623	344849
23182	35722	7	applied	\N	\N	\N	\N	177624	177624	344850
23182	35723	8	applied	\N	\N	\N	\N	177625	177625	344851
23182	35724	9	applied	\N	\N	\N	\N	177626	177626	344852
23182	35725	10	applied	\N	\N	\N	\N	177627	177627	344853
23182	35716	11	applied	\N	\N	\N	\N	177628	177628	344854
23182	35720	12	applied	\N	\N	\N	\N	177629	177629	344855
23151	35665	111	applied	\N	\N	\N	\N	177206	177206	344432
23151	35673	112	applied	\N	\N	\N	\N	177207	177207	344433
23174	35219	49	applied	\N	\N	\N	\N	177384	177384	344610
23174	35226	50	applied	\N	\N	\N	\N	177385	177385	344611
23174	35229	51	applied	\N	\N	\N	\N	177386	177386	344612
23174	35232	52	applied	\N	\N	\N	\N	177387	177387	344613
23174	35233	53	applied	\N	\N	\N	\N	177388	177388	344614
23174	35235	54	applied	\N	\N	\N	\N	177389	177389	344615
23174	35236	55	applied	\N	\N	\N	\N	177390	177390	344616
23174	35237	56	applied	\N	\N	\N	\N	177391	177391	344617
23174	35251	57	applied	\N	\N	\N	\N	177392	177392	344618
23174	35255	58	applied	\N	\N	\N	\N	177393	177393	344619
23174	35258	59	applied	\N	\N	\N	\N	177394	177394	344620
23174	35262	60	applied	\N	\N	\N	\N	177395	177395	344621
23174	35263	61	applied	\N	\N	\N	\N	177396	177396	344622
23174	35268	62	applied	\N	\N	\N	\N	177397	177397	344623
23174	35270	63	applied	\N	\N	\N	\N	177398	177398	344624
23174	35274	64	applied	\N	\N	\N	\N	177399	177399	344625
23174	35279	66	applied	\N	\N	\N	\N	177401	177401	344627
23174	35280	68	applied	\N	\N	\N	\N	177402	177402	344628
23174	35281	69	applied	\N	\N	\N	\N	177403	177403	344629
23174	35287	70	applied	\N	\N	\N	\N	177404	177404	344630
23174	35288	71	applied	\N	\N	\N	\N	177405	177405	344631
23174	35289	72	applied	\N	\N	\N	\N	177406	177406	344632
23174	35294	73	applied	\N	\N	\N	\N	177407	177407	344633
23174	35297	74	applied	\N	\N	\N	\N	177408	177408	344634
23174	35298	75	applied	\N	\N	\N	\N	177409	177409	344635
23174	35302	76	applied	\N	\N	\N	\N	177410	177410	344636
23174	35305	77	applied	\N	\N	\N	\N	177411	177411	344637
23174	35306	78	applied	\N	\N	\N	\N	177412	177412	344638
23174	35309	79	applied	\N	\N	\N	\N	177413	177413	344639
23174	35312	80	applied	\N	\N	\N	\N	177414	177414	344640
23174	35316	81	applied	\N	\N	\N	\N	177415	177415	344641
23174	35317	82	applied	\N	\N	\N	\N	177416	177416	344642
23174	35323	84	applied	\N	\N	\N	\N	177418	177418	344644
23174	35324	85	applied	\N	\N	\N	\N	177419	177419	344645
23174	35325	86	applied	\N	\N	\N	\N	177420	177420	344646
23174	35336	87	applied	\N	\N	\N	\N	177421	177421	344647
23174	35339	88	applied	\N	\N	\N	\N	177422	177422	344648
23174	35342	89	applied	\N	\N	\N	\N	177423	177423	344649
23174	35345	90	applied	\N	\N	\N	\N	177424	177424	344650
23174	35349	91	applied	\N	\N	\N	\N	177425	177425	344651
23174	35352	92	applied	\N	\N	\N	\N	177426	177426	344652
23174	35353	93	applied	\N	\N	\N	\N	177427	177427	344653
23174	35359	94	applied	\N	\N	\N	\N	177428	177428	344654
23174	35362	95	applied	\N	\N	\N	\N	177429	177429	344655
23174	35363	96	applied	\N	\N	\N	\N	177430	177430	344656
23174	35364	97	applied	\N	\N	\N	\N	177431	177431	344657
23174	35365	98	applied	\N	\N	\N	\N	177432	177432	344658
23174	35375	99	applied	\N	\N	\N	\N	177433	177433	344659
23174	35381	101	applied	\N	\N	\N	\N	177435	177435	344661
23174	35382	102	applied	\N	\N	\N	\N	177436	177436	344662
23174	35387	103	applied	\N	\N	\N	\N	177437	177437	344663
23174	35388	104	applied	\N	\N	\N	\N	177438	177438	344664
23174	35389	105	applied	\N	\N	\N	\N	177439	177439	344665
23174	35397	106	applied	\N	\N	\N	\N	177440	177440	344666
23174	35398	107	applied	\N	\N	\N	\N	177441	177441	344667
23174	35399	108	applied	\N	\N	\N	\N	177442	177442	344668
23174	35407	109	applied	\N	\N	\N	\N	177443	177443	344669
23174	35408	110	applied	\N	\N	\N	\N	177444	177444	344670
23174	35414	111	applied	\N	\N	\N	\N	177445	177445	344671
23174	35417	112	applied	\N	\N	\N	\N	177446	177446	344672
23174	35420	113	applied	\N	\N	\N	\N	177447	177447	344673
23174	35424	114	applied	\N	\N	\N	\N	177448	177448	344674
23174	35427	115	applied	\N	\N	\N	\N	177449	177449	344675
23174	35428	116	applied	\N	\N	\N	\N	177450	177450	344676
23174	35439	118	applied	\N	\N	\N	\N	177452	177452	344678
23174	35440	119	applied	\N	\N	\N	\N	177453	177453	344679
23174	35446	120	applied	\N	\N	\N	\N	177454	177454	344680
23174	35449	121	applied	\N	\N	\N	\N	177455	177455	344681
23174	35452	122	applied	\N	\N	\N	\N	177456	177456	344682
23174	35456	123	applied	\N	\N	\N	\N	177457	177457	344683
23174	35457	124	applied	\N	\N	\N	\N	177458	177458	344684
23174	35462	125	applied	\N	\N	\N	\N	177459	177459	344685
23175	35705	0	applied	\N	\N	\N	\N	177460	177460	344686
23175	35706	1	applied	\N	\N	\N	\N	177461	177461	344687
23175	35707	2	applied	\N	\N	\N	\N	177462	177462	344688
23179	35691	80	applied	\N	\N	\N	\N	177554	177554	344780
23179	35702	81	applied	\N	\N	\N	\N	177555	177555	344781
23179	35707	82	applied	\N	\N	\N	\N	177556	177556	344782
23179	35716	83	applied	\N	\N	\N	\N	177557	177557	344783
23179	35576	84	applied	\N	\N	\N	\N	177558	177558	344784
23179	35581	86	applied	\N	\N	\N	\N	177560	177560	344786
23179	35586	87	applied	\N	\N	\N	\N	177561	177561	344787
23179	35591	88	applied	\N	\N	\N	\N	177562	177562	344788
23179	35592	89	applied	\N	\N	\N	\N	177563	177563	344789
23179	35594	90	applied	\N	\N	\N	\N	177564	177564	344790
23179	35599	91	applied	\N	\N	\N	\N	177565	177565	344791
23179	35603	92	applied	\N	\N	\N	\N	177566	177566	344792
23179	35605	93	applied	\N	\N	\N	\N	177567	177567	344793
23179	35611	94	applied	\N	\N	\N	\N	177568	177568	344794
23179	35617	95	applied	\N	\N	\N	\N	177569	177569	344795
23179	35618	96	applied	\N	\N	\N	\N	177570	177570	344796
23179	35620	97	applied	\N	\N	\N	\N	177571	177571	344797
23179	35624	99	applied	\N	\N	\N	\N	177572	177572	344798
23179	35633	100	applied	\N	\N	\N	\N	177573	177573	344799
23179	35635	101	applied	\N	\N	\N	\N	177574	177574	344800
23179	35639	102	applied	\N	\N	\N	\N	177575	177575	344801
23179	35646	104	applied	\N	\N	\N	\N	177577	177577	344803
23179	35647	105	applied	\N	\N	\N	\N	177578	177578	344804
23183	35714	0	applied	\N	\N	\N	\N	177630	177630	344856
23183	35715	1	applied	\N	\N	\N	\N	177631	177631	344857
23183	35717	2	applied	\N	\N	\N	\N	177632	177632	344858
23183	35718	3	applied	\N	\N	\N	\N	177633	177633	344859
23183	35719	5	applied	\N	\N	\N	\N	177634	177634	344860
23183	35721	6	applied	\N	\N	\N	\N	177635	177635	344861
23183	35722	7	applied	\N	\N	\N	\N	177636	177636	344862
23183	35723	8	applied	\N	\N	\N	\N	177637	177637	344863
23183	35724	9	applied	\N	\N	\N	\N	177638	177638	344864
23183	35725	10	applied	\N	\N	\N	\N	177639	177639	344865
23183	35716	11	applied	\N	\N	\N	\N	177640	177640	344866
23183	35720	12	applied	\N	\N	\N	\N	177641	177641	344867
23174	35203	46	applied	\N	\N	\N	\N	177381	177381	344607
23174	35215	47	applied	\N	\N	\N	\N	177382	177382	344608
23179	35662	109	applied	\N	\N	\N	\N	177582	177582	344808
23179	35667	110	applied	\N	\N	\N	\N	177583	177583	344809
23179	35668	111	applied	\N	\N	\N	\N	177584	177584	344810
23179	35670	112	applied	\N	\N	\N	\N	177585	177585	344811
23179	35675	113	applied	\N	\N	\N	\N	177586	177586	344812
23179	35677	114	applied	\N	\N	\N	\N	177587	177587	344813
23179	35600	115	applied	\N	\N	\N	\N	177588	177588	344814
23179	35604	116	applied	\N	\N	\N	\N	177589	177589	344815
23179	35606	117	applied	\N	\N	\N	\N	177590	177590	344816
23179	35608	118	applied	\N	\N	\N	\N	177591	177591	344817
23179	35612	119	applied	\N	\N	\N	\N	177592	177592	344818
23179	35619	121	applied	\N	\N	\N	\N	177594	177594	344820
23179	35622	122	applied	\N	\N	\N	\N	177595	177595	344821
23179	35625	123	applied	\N	\N	\N	\N	177596	177596	344822
23179	35634	124	applied	\N	\N	\N	\N	177597	177597	344823
23179	35636	125	applied	\N	\N	\N	\N	177598	177598	344824
23181	35714	0	applied	\N	\N	\N	\N	177606	177606	344832
23181	35715	1	applied	\N	\N	\N	\N	177607	177607	344833
23181	35717	2	applied	\N	\N	\N	\N	177608	177608	344834
23181	35718	3	applied	\N	\N	\N	\N	177609	177609	344835
23181	35719	5	applied	\N	\N	\N	\N	177610	177610	344836
23181	35721	6	applied	\N	\N	\N	\N	177611	177611	344837
23181	35722	7	applied	\N	\N	\N	\N	177612	177612	344838
23181	35723	8	applied	\N	\N	\N	\N	177613	177613	344839
23181	35724	9	applied	\N	\N	\N	\N	177614	177614	344840
23181	35725	10	applied	\N	\N	\N	\N	177615	177615	344841
23181	35716	11	applied	\N	\N	\N	\N	177616	177616	344842
23184	35043	1	applied	\N	\N	1000000000	\N	177643	177643	344869
23184	35234	2	applied	\N	\N	1000000000	\N	177644	177644	344870
23184	34949	3	applied	\N	\N	\N	\N	177645	177645	344871
23184	34953	4	applied	\N	\N	\N	\N	177646	177646	344872
23184	35027	5	applied	\N	\N	1000000000	\N	177647	177647	344873
23184	35039	6	applied	\N	\N	\N	\N	177648	177648	344874
23184	34956	7	applied	\N	\N	\N	\N	177649	177649	344875
23184	34959	8	applied	\N	\N	\N	\N	177650	177650	344876
23184	34962	9	applied	\N	\N	\N	\N	177651	177651	344877
23184	34965	10	applied	\N	\N	\N	\N	177652	177652	344878
23184	34970	11	applied	\N	\N	\N	\N	177653	177653	344879
23184	34971	12	applied	\N	\N	\N	\N	177654	177654	344880
23184	34977	13	applied	\N	\N	\N	\N	177655	177655	344881
23184	34980	14	applied	\N	\N	\N	\N	177656	177656	344882
23184	34984	15	applied	\N	\N	\N	\N	177657	177657	344883
23184	34987	16	applied	\N	\N	\N	\N	177658	177658	344884
23184	34989	18	applied	\N	\N	\N	\N	177660	177660	344886
23184	34997	19	applied	\N	\N	\N	\N	177661	177661	344887
23184	35000	20	applied	\N	\N	\N	\N	177662	177662	344888
23184	35004	21	applied	\N	\N	\N	\N	177663	177663	344889
23184	35008	22	applied	\N	\N	\N	\N	177664	177664	344890
23184	35011	23	applied	\N	\N	\N	\N	177665	177665	344891
23184	35014	24	applied	\N	\N	\N	\N	177666	177666	344892
23184	35015	25	applied	\N	\N	\N	\N	177667	177667	344893
23184	35021	26	applied	\N	\N	\N	\N	177668	177668	344894
23184	35024	27	applied	\N	\N	\N	\N	177669	177669	344895
23184	35028	28	applied	\N	\N	\N	\N	177670	177670	344896
23184	35032	29	applied	\N	\N	\N	\N	177671	177671	344897
23184	35035	30	applied	\N	\N	\N	\N	177672	177672	344898
23184	35038	31	applied	\N	\N	\N	\N	177673	177673	344899
23184	35044	32	applied	\N	\N	\N	\N	177674	177674	344900
23184	35047	33	applied	\N	\N	\N	\N	177675	177675	344901
23184	35056	35	applied	\N	\N	\N	\N	177677	177677	344903
23184	35060	36	applied	\N	\N	\N	\N	177678	177678	344904
23184	35063	37	applied	\N	\N	\N	\N	177679	177679	344905
23184	35066	38	applied	\N	\N	\N	\N	177680	177680	344906
23184	35071	39	applied	\N	\N	\N	\N	177681	177681	344907
23184	35072	40	applied	\N	\N	\N	\N	177682	177682	344908
23184	35077	41	applied	\N	\N	\N	\N	177683	177683	344909
23184	35081	42	applied	\N	\N	\N	\N	177684	177684	344910
23184	35083	43	applied	\N	\N	\N	\N	177685	177685	344911
23184	35086	44	applied	\N	\N	\N	\N	177686	177686	344912
23184	35090	45	applied	\N	\N	\N	\N	177687	177687	344913
23184	35091	46	applied	\N	\N	\N	\N	177688	177688	344914
23184	35096	47	applied	\N	\N	\N	\N	177689	177689	344915
23184	35099	48	applied	\N	\N	\N	\N	177690	177690	344916
23184	35103	49	applied	\N	\N	\N	\N	177691	177691	344917
23184	35106	50	applied	\N	\N	\N	\N	177692	177692	344918
23184	35113	52	applied	\N	\N	\N	\N	177694	177694	344920
23184	35116	53	applied	\N	\N	\N	\N	177695	177695	344921
23184	35121	54	applied	\N	\N	\N	\N	177696	177696	344922
23184	35123	55	applied	\N	\N	\N	\N	177697	177697	344923
23184	35126	56	applied	\N	\N	\N	\N	177698	177698	344924
23184	35127	57	applied	\N	\N	\N	\N	177699	177699	344925
23184	35128	58	applied	\N	\N	\N	\N	177700	177700	344926
23184	35141	59	applied	\N	\N	\N	\N	177701	177701	344927
23184	35144	60	applied	\N	\N	\N	\N	177702	177702	344928
23184	35147	61	applied	\N	\N	\N	\N	177703	177703	344929
23184	35148	62	applied	\N	\N	\N	\N	177704	177704	344930
23184	35149	63	applied	\N	\N	\N	\N	177705	177705	344931
23184	35157	64	applied	\N	\N	\N	\N	177706	177706	344932
23184	35161	65	applied	\N	\N	\N	\N	177707	177707	344933
23184	35165	66	applied	\N	\N	\N	\N	177708	177708	344934
23184	35169	67	applied	\N	\N	\N	\N	177709	177709	344935
23184	35177	69	applied	\N	\N	\N	\N	177711	177711	344937
23184	35180	70	applied	\N	\N	\N	\N	177712	177712	344938
23184	35183	71	applied	\N	\N	\N	\N	177713	177713	344939
23184	35187	72	applied	\N	\N	\N	\N	177714	177714	344940
23184	35190	73	applied	\N	\N	\N	\N	177715	177715	344941
23184	35193	74	applied	\N	\N	\N	\N	177716	177716	344942
23184	35194	75	applied	\N	\N	\N	\N	177717	177717	344943
23184	35201	76	applied	\N	\N	\N	\N	177718	177718	344944
23184	35202	77	applied	\N	\N	\N	\N	177719	177719	344945
23184	35203	78	applied	\N	\N	\N	\N	177720	177720	344946
23184	35215	79	applied	\N	\N	\N	\N	177721	177721	344947
23184	35218	80	applied	\N	\N	\N	\N	177722	177722	344948
23184	35219	81	applied	\N	\N	\N	\N	177723	177723	344949
23184	35226	82	applied	\N	\N	\N	\N	177724	177724	344950
23184	35229	83	applied	\N	\N	\N	\N	177725	177725	344951
23184	35232	84	applied	\N	\N	\N	\N	177726	177726	344952
23184	35235	86	applied	\N	\N	\N	\N	177728	177728	344954
23184	35236	87	applied	\N	\N	\N	\N	177729	177729	344955
23179	35655	107	applied	\N	\N	\N	\N	177580	177580	344806
23179	35658	108	applied	\N	\N	\N	\N	177581	177581	344807
23184	35262	93	applied	\N	\N	\N	\N	177734	177734	344960
23184	35263	94	applied	\N	\N	\N	\N	177735	177735	344961
23184	35268	95	applied	\N	\N	\N	\N	177736	177736	344962
23184	35270	96	applied	\N	\N	\N	\N	177737	177737	344963
23184	35274	97	applied	\N	\N	\N	\N	177738	177738	344964
23184	35277	98	applied	\N	\N	\N	\N	177739	177739	344965
23184	35279	99	applied	\N	\N	\N	\N	177740	177740	344966
23184	35280	100	applied	\N	\N	\N	\N	177741	177741	344967
23184	35281	101	applied	\N	\N	\N	\N	177742	177742	344968
23184	35287	102	applied	\N	\N	\N	\N	177743	177743	344969
23184	35288	103	applied	\N	\N	\N	\N	177744	177744	344970
23184	35289	104	applied	\N	\N	\N	\N	177745	177745	344971
23184	35294	105	applied	\N	\N	\N	\N	177746	177746	344972
23184	35297	106	applied	\N	\N	\N	\N	177747	177747	344973
23184	35298	107	applied	\N	\N	\N	\N	177748	177748	344974
23184	35302	108	applied	\N	\N	\N	\N	177749	177749	344975
23184	35306	110	applied	\N	\N	\N	\N	177751	177751	344977
23184	35309	111	applied	\N	\N	\N	\N	177752	177752	344978
23184	35312	112	applied	\N	\N	\N	\N	177753	177753	344979
23184	35316	113	applied	\N	\N	\N	\N	177754	177754	344980
23184	35317	114	applied	\N	\N	\N	\N	177755	177755	344981
23184	35322	115	applied	\N	\N	\N	\N	177756	177756	344982
23184	35323	116	applied	\N	\N	\N	\N	177757	177757	344983
23184	35324	117	applied	\N	\N	\N	\N	177758	177758	344984
23184	35325	118	applied	\N	\N	\N	\N	177759	177759	344985
23184	35336	119	applied	\N	\N	\N	\N	177760	177760	344986
23184	35339	120	applied	\N	\N	\N	\N	177761	177761	344987
23184	35342	121	applied	\N	\N	\N	\N	177762	177762	344988
23184	35345	122	applied	\N	\N	\N	\N	177763	177763	344989
23184	35349	123	applied	\N	\N	\N	\N	177764	177764	344990
23184	35352	124	applied	\N	\N	\N	\N	177765	177765	344991
23184	35353	125	applied	\N	\N	\N	\N	177766	177766	344992
23185	35721	1	applied	\N	\N	\N	\N	177768	177768	344994
23185	35722	2	applied	\N	\N	\N	\N	177769	177769	344995
23185	35723	3	applied	\N	\N	\N	\N	177770	177770	344996
23185	35724	4	applied	\N	\N	\N	\N	177771	177771	344997
23185	35725	5	applied	\N	\N	\N	\N	177772	177772	344998
23185	35727	6	applied	\N	\N	\N	\N	177773	177773	344999
23186	35728	0	applied	\N	\N	\N	\N	177774	177774	345000
23186	35729	1	applied	\N	\N	\N	\N	177775	177775	345001
23186	35730	2	applied	\N	\N	\N	\N	177776	177776	345002
23186	35731	3	applied	\N	\N	\N	\N	177777	177777	345003
23186	35732	4	applied	\N	\N	\N	\N	177778	177778	345004
23187	35733	0	applied	\N	\N	\N	\N	177779	177779	345005
23187	35734	1	applied	\N	\N	\N	\N	177780	177780	345006
23188	35733	0	applied	\N	\N	\N	\N	177781	177781	345007
23188	35734	1	applied	\N	\N	\N	\N	177782	177782	345008
23189	35735	0	applied	\N	\N	\N	\N	177783	177783	345009
23190	35735	0	applied	\N	\N	\N	\N	177785	177785	345011
23190	35736	1	applied	\N	\N	\N	\N	177786	177786	345012
23191	35735	0	applied	\N	\N	\N	\N	177787	177787	345013
23191	35736	1	applied	\N	\N	\N	\N	177788	177788	345014
23192	35737	0	applied	\N	\N	\N	\N	177789	177789	345015
23192	35738	1	applied	\N	\N	\N	\N	177790	177790	345016
23192	35739	2	applied	\N	\N	\N	\N	177791	177791	345017
23193	35737	0	applied	\N	\N	\N	\N	177792	177792	345018
23193	35738	1	applied	\N	\N	\N	\N	177793	177793	345019
23193	35739	2	applied	\N	\N	\N	\N	177794	177794	345020
23194	35737	0	applied	\N	\N	\N	\N	177795	177795	345021
23194	35738	1	applied	\N	\N	\N	\N	177796	177796	345022
23194	35739	2	applied	\N	\N	\N	\N	177797	177797	345023
23195	35737	0	applied	\N	\N	\N	\N	177798	177798	345024
23195	35738	1	applied	\N	\N	\N	\N	177799	177799	345025
23195	35739	2	applied	\N	\N	\N	\N	177800	177800	345026
23196	35738	1	applied	\N	\N	\N	\N	177802	177802	345028
23196	35739	2	applied	\N	\N	\N	\N	177803	177803	345029
23197	35739	0	applied	\N	\N	\N	\N	177804	177804	345030
23198	35740	0	applied	\N	\N	\N	\N	177805	177805	345031
23198	35741	1	applied	\N	\N	\N	\N	177806	177806	345032
23199	35742	0	applied	\N	\N	\N	\N	177807	177807	345033
23199	35743	1	applied	\N	\N	\N	\N	177808	177808	345034
23200	35744	0	applied	\N	\N	\N	\N	177809	177809	345035
23200	35745	1	applied	\N	\N	\N	\N	177810	177810	345036
23201	35746	0	applied	\N	\N	\N	\N	177811	177811	345037
23201	35747	1	applied	\N	\N	\N	\N	177812	177812	345038
23201	35748	2	applied	\N	\N	\N	\N	177813	177813	345039
23202	35749	0	applied	\N	\N	\N	\N	177814	177814	345040
23202	35750	1	applied	\N	\N	\N	\N	177815	177815	345041
23202	35751	2	applied	\N	\N	\N	\N	177816	177816	345042
23202	35752	3	applied	\N	\N	\N	\N	177817	177817	345043
23203	35750	1	applied	\N	\N	\N	\N	177819	177819	345045
23203	35751	2	applied	\N	\N	\N	\N	177820	177820	345046
23203	35752	3	applied	\N	\N	\N	\N	177821	177821	345047
23204	35749	0	applied	\N	\N	\N	\N	177822	177822	345048
23204	35750	1	applied	\N	\N	\N	\N	177823	177823	345049
23204	35751	2	applied	\N	\N	\N	\N	177824	177824	345050
23204	35752	3	applied	\N	\N	\N	\N	177825	177825	345051
23205	35749	0	applied	\N	\N	\N	\N	177826	177826	345052
23205	35750	1	applied	\N	\N	\N	\N	177827	177827	345053
23205	35751	2	applied	\N	\N	\N	\N	177828	177828	345054
23205	35752	3	applied	\N	\N	\N	\N	177829	177829	345055
23206	35753	0	applied	\N	\N	\N	\N	177830	177830	345056
23206	35754	1	applied	\N	\N	\N	\N	177831	177831	345057
23207	35753	0	applied	\N	\N	\N	\N	177832	177832	345058
23207	35754	1	applied	\N	\N	\N	\N	177833	177833	345059
23208	35753	0	applied	\N	\N	\N	\N	177834	177834	345060
23209	35753	0	applied	\N	\N	\N	\N	177836	177836	345062
23209	35754	1	applied	\N	\N	\N	\N	177837	177837	345063
23210	35754	0	applied	\N	\N	\N	\N	177838	177838	345064
23211	35754	0	applied	\N	\N	\N	\N	177839	177839	345065
23212	35755	0	applied	\N	\N	\N	\N	177840	177840	345066
23212	35756	1	applied	\N	\N	\N	\N	177841	177841	345067
23213	35755	0	applied	\N	\N	\N	\N	177842	177842	345068
23213	35756	1	applied	\N	\N	\N	\N	177843	177843	345069
23214	35528	0	applied	\N	\N	\N	\N	177844	177844	345070
23214	35532	1	applied	\N	\N	\N	\N	177845	177845	345071
23214	35535	2	applied	\N	\N	\N	\N	177846	177846	345072
23214	35538	3	applied	\N	\N	\N	\N	177847	177847	345073
23214	35539	4	applied	\N	\N	\N	\N	177848	177848	345074
23214	35545	5	applied	\N	\N	\N	\N	177849	177849	345075
23184	35251	90	applied	\N	\N	\N	\N	177731	177731	344957
23184	35255	91	applied	\N	\N	\N	\N	177732	177732	344958
23214	35560	10	applied	\N	\N	\N	\N	177854	177854	345080
23214	35564	11	applied	\N	\N	\N	\N	177855	177855	345081
23214	35567	12	applied	\N	\N	\N	\N	177856	177856	345082
23214	35570	13	applied	\N	\N	\N	\N	177857	177857	345083
23214	35573	14	applied	\N	\N	\N	\N	177858	177858	345084
23214	35577	15	applied	\N	\N	\N	\N	177859	177859	345085
23214	35580	16	applied	\N	\N	\N	\N	177860	177860	345086
23214	35583	17	applied	\N	\N	\N	\N	177861	177861	345087
23214	35587	18	applied	\N	\N	\N	\N	177862	177862	345088
23214	35588	19	applied	\N	\N	\N	\N	177863	177863	345089
23214	35589	20	applied	\N	\N	\N	\N	177864	177864	345090
23214	35597	21	applied	\N	\N	\N	\N	177865	177865	345091
23214	35601	22	applied	\N	\N	\N	\N	177866	177866	345092
23214	35602	23	applied	\N	\N	\N	\N	177867	177867	345093
23214	35610	25	applied	\N	\N	\N	\N	177869	177869	345095
23214	35613	26	applied	\N	\N	\N	\N	177870	177870	345096
23214	35614	27	applied	\N	\N	\N	\N	177871	177871	345097
23214	35621	28	applied	\N	\N	\N	\N	177872	177872	345098
23214	35623	29	applied	\N	\N	\N	\N	177873	177873	345099
23214	35628	30	applied	\N	\N	\N	\N	177874	177874	345100
23214	35629	31	applied	\N	\N	\N	\N	177875	177875	345101
23214	35637	32	applied	\N	\N	\N	\N	177876	177876	345102
23214	35638	33	applied	\N	\N	\N	\N	177877	177877	345103
23214	35643	34	applied	\N	\N	\N	\N	177878	177878	345104
23214	35644	35	applied	\N	\N	\N	\N	177879	177879	345105
23214	35650	36	applied	\N	\N	\N	\N	177880	177880	345106
23214	35653	37	applied	\N	\N	\N	\N	177881	177881	345107
23214	35657	38	applied	\N	\N	\N	\N	177882	177882	345108
23214	35660	39	applied	\N	\N	\N	\N	177883	177883	345109
23214	35663	40	applied	\N	\N	\N	\N	177884	177884	345110
23214	35665	42	applied	\N	\N	\N	\N	177886	177886	345112
23214	35673	43	applied	\N	\N	\N	\N	177887	177887	345113
23214	35676	44	applied	\N	\N	\N	\N	177888	177888	345114
23214	35680	45	applied	\N	\N	\N	\N	177889	177889	345115
23214	35682	46	applied	\N	\N	\N	\N	177890	177890	345116
23214	35683	47	applied	\N	\N	\N	\N	177891	177891	345117
23214	35687	48	applied	\N	\N	\N	\N	177892	177892	345118
23214	35689	49	applied	\N	\N	\N	\N	177893	177893	345119
23214	35690	51	applied	\N	\N	\N	\N	177894	177894	345120
23214	35694	52	applied	\N	\N	\N	\N	177895	177895	345121
23214	35695	53	applied	\N	\N	\N	\N	177896	177896	345122
23214	35698	54	applied	\N	\N	\N	\N	177897	177897	345123
23214	35700	55	applied	\N	\N	\N	\N	177898	177898	345124
23214	35703	56	applied	\N	\N	\N	\N	177899	177899	345125
23214	35705	57	applied	\N	\N	\N	\N	177900	177900	345126
23214	35706	58	applied	\N	\N	\N	\N	177901	177901	345127
23214	35712	60	applied	\N	\N	\N	\N	177903	177903	345129
23214	35714	61	applied	\N	\N	\N	\N	177904	177904	345130
23214	35715	62	applied	\N	\N	\N	\N	177905	177905	345131
23214	35717	63	applied	\N	\N	\N	\N	177906	177906	345132
23214	35718	64	applied	\N	\N	\N	\N	177907	177907	345133
23214	35719	65	applied	\N	\N	\N	\N	177908	177908	345134
23214	35726	66	applied	\N	\N	\N	\N	177909	177909	345135
23214	35728	67	applied	\N	\N	\N	\N	177910	177910	345136
23214	35729	68	applied	\N	\N	\N	\N	177911	177911	345137
23214	35733	69	applied	\N	\N	\N	\N	177912	177912	345138
23214	35735	70	applied	\N	\N	\N	\N	177913	177913	345139
23214	35737	71	applied	\N	\N	\N	\N	177914	177914	345140
23214	35740	72	applied	\N	\N	\N	\N	177915	177915	345141
23214	35742	73	applied	\N	\N	\N	\N	177916	177916	345142
23214	35744	74	applied	\N	\N	\N	\N	177917	177917	345143
23214	35746	75	applied	\N	\N	\N	\N	177918	177918	345144
23214	35750	77	applied	\N	\N	\N	\N	177920	177920	345146
23214	35753	78	applied	\N	\N	\N	\N	177921	177921	345147
23214	35531	79	applied	\N	\N	\N	\N	177922	177922	345148
23214	35530	80	applied	\N	\N	\N	\N	177923	177923	345149
23214	35529	81	applied	\N	\N	\N	\N	177924	177924	345150
23214	35540	82	applied	\N	\N	\N	\N	177925	177925	345151
23214	35550	83	applied	\N	\N	\N	\N	177926	177926	345152
23214	35561	84	applied	\N	\N	\N	\N	177927	177927	345153
23214	35626	85	applied	\N	\N	\N	\N	177928	177928	345154
23214	35598	86	applied	\N	\N	\N	\N	177929	177929	345155
23214	35533	87	applied	\N	\N	\N	\N	177930	177930	345156
23214	35536	88	applied	\N	\N	\N	\N	177931	177931	345157
23214	35543	89	applied	\N	\N	\N	\N	177932	177932	345158
23214	35544	90	applied	\N	\N	\N	\N	177933	177933	345159
23214	35575	91	applied	\N	\N	\N	\N	177934	177934	345160
23214	35585	92	applied	\N	\N	\N	\N	177935	177935	345161
23214	35631	94	applied	\N	\N	\N	\N	177937	177937	345163
23214	35632	95	applied	\N	\N	\N	\N	177938	177938	345164
23214	35534	96	applied	\N	\N	\N	\N	177939	177939	345165
23214	35537	97	applied	\N	\N	\N	\N	177940	177940	345166
23214	35541	98	applied	\N	\N	\N	\N	177941	177941	345167
23214	35542	99	applied	\N	\N	\N	\N	177942	177942	345168
23214	35546	100	applied	\N	\N	\N	\N	177943	177943	345169
23214	35551	101	applied	\N	\N	\N	\N	177944	177944	345170
23214	35552	102	applied	\N	\N	\N	\N	177945	177945	345171
23214	35555	103	applied	\N	\N	\N	\N	177946	177946	345172
23214	35559	104	applied	\N	\N	\N	\N	177947	177947	345173
23214	35562	105	applied	\N	\N	\N	\N	177948	177948	345174
23214	35566	106	applied	\N	\N	\N	\N	177949	177949	345175
23214	35568	107	applied	\N	\N	\N	\N	177950	177950	345176
23214	35572	108	applied	\N	\N	\N	\N	177951	177951	345177
23214	35593	109	applied	\N	\N	\N	\N	177952	177952	345178
23214	35553	111	applied	\N	\N	\N	\N	177954	177954	345180
23214	35556	112	applied	\N	\N	\N	\N	177955	177955	345181
23214	35557	113	applied	\N	\N	\N	\N	177956	177956	345182
23214	35563	114	applied	\N	\N	\N	\N	177957	177957	345183
23214	35565	115	applied	\N	\N	\N	\N	177958	177958	345184
23214	35569	116	applied	\N	\N	\N	\N	177959	177959	345185
23214	35571	117	applied	\N	\N	\N	\N	177960	177960	345186
23214	35574	118	applied	\N	\N	\N	\N	177961	177961	345187
23214	35578	119	applied	\N	\N	\N	\N	177962	177962	345188
23214	35582	120	applied	\N	\N	\N	\N	177963	177963	345189
23214	35584	121	applied	\N	\N	\N	\N	177964	177964	345190
23214	35590	122	applied	\N	\N	\N	\N	177965	177965	345191
23214	35609	123	applied	\N	\N	\N	\N	177966	177966	345192
23214	35615	124	applied	\N	\N	\N	\N	177967	177967	345193
23214	35630	125	applied	\N	\N	\N	\N	177968	177968	345194
23214	35554	8	applied	\N	\N	\N	\N	177852	177852	345078
23214	35558	9	applied	\N	\N	\N	\N	177853	177853	345079
23219	35626	1	applied	\N	\N	\N	\N	177980	177980	345206
23219	35627	2	applied	\N	\N	\N	\N	177981	177981	345207
23219	35631	3	applied	\N	\N	\N	\N	177982	177982	345208
23219	35632	4	applied	\N	\N	\N	\N	177983	177983	345209
23220	35762	0	applied	\N	\N	\N	\N	177984	177984	345210
23220	35763	1	applied	\N	\N	\N	\N	177985	177985	345211
23221	35764	0	applied	\N	\N	\N	\N	177986	177986	345212
23221	35765	1	applied	\N	\N	\N	\N	177987	177987	345213
23221	35766	2	applied	\N	\N	\N	\N	177988	177988	345214
23225	35767	0	applied	\N	\N	\N	\N	178056	178056	345282
23225	35768	1	applied	\N	\N	\N	\N	178057	178057	345283
23225	35769	2	applied	\N	\N	\N	\N	178058	178058	345284
23225	35770	3	applied	\N	\N	\N	\N	178059	178059	345285
23226	35767	0	applied	\N	\N	\N	\N	178061	178061	345287
23226	35768	1	applied	\N	\N	\N	\N	178062	178062	345288
23226	35769	2	applied	\N	\N	\N	\N	178063	178063	345289
23226	35770	3	applied	\N	\N	\N	\N	178064	178064	345290
23226	35771	4	applied	\N	\N	\N	\N	178065	178065	345291
23230	35772	0	applied	\N	\N	\N	\N	178196	178196	345422
23230	35773	1	applied	\N	\N	\N	\N	178197	178197	345423
23234	35776	0	applied	\N	\N	\N	\N	178204	178204	345430
23235	35777	0	applied	\N	\N	\N	\N	178205	178205	345431
23235	35778	1	applied	\N	\N	\N	\N	178206	178206	345432
23236	35777	0	applied	\N	\N	\N	\N	178207	178207	345433
23236	35778	1	applied	\N	\N	\N	\N	178208	178208	345434
23240	35781	0	applied	\N	\N	\N	\N	178215	178215	345441
23240	35782	1	applied	\N	\N	\N	\N	178216	178216	345442
23241	35783	0	applied	\N	\N	\N	\N	178217	178217	345443
23241	35784	1	applied	\N	\N	\N	\N	178218	178218	345444
23246	35788	1	applied	\N	\N	\N	\N	178234	178234	345460
23246	35789	2	applied	\N	\N	\N	\N	178235	178235	345461
23246	35790	3	applied	\N	\N	\N	\N	178236	178236	345462
23247	35787	0	applied	\N	\N	\N	\N	178237	178237	345463
23247	35788	1	applied	\N	\N	\N	\N	178238	178238	345464
23247	35789	2	applied	\N	\N	\N	\N	178239	178239	345465
23247	35790	3	applied	\N	\N	\N	\N	178240	178240	345466
23250	35758	0	applied	\N	\N	1000000000	\N	178245	178245	345471
23250	35767	1	applied	\N	\N	\N	\N	178246	178246	345472
23250	35626	2	applied	\N	\N	\N	\N	178247	178247	345473
23250	35598	3	applied	\N	\N	\N	\N	178248	178248	345474
23250	35627	4	applied	\N	\N	\N	\N	178249	178249	345475
23250	35631	5	applied	\N	\N	\N	\N	178250	178250	345476
23250	35632	6	applied	\N	\N	\N	\N	178251	178251	345477
23251	35791	0	applied	\N	\N	\N	\N	178252	178252	345478
23251	35792	1	applied	\N	\N	\N	\N	178253	178253	345479
23255	35794	1	applied	\N	\N	\N	\N	178261	178261	345487
23256	35795	0	applied	\N	\N	\N	\N	178262	178262	345488
23256	35796	1	applied	\N	\N	\N	\N	178263	178263	345489
23257	35797	0	applied	\N	\N	\N	\N	178264	178264	345490
23257	35798	1	applied	\N	\N	\N	\N	178265	178265	345491
23260	35799	0	applied	\N	\N	\N	\N	178270	178270	345496
23260	35800	1	applied	\N	\N	\N	\N	178271	178271	345497
23261	35801	0	applied	\N	\N	\N	\N	178272	178272	345498
23261	35802	1	applied	\N	\N	\N	\N	178273	178273	345499
23262	35803	0	applied	\N	\N	\N	\N	178274	178274	345500
23262	35804	1	applied	\N	\N	\N	\N	178275	178275	345501
23263	35805	0	applied	\N	\N	\N	\N	178276	178276	345502
23263	35806	1	applied	\N	\N	\N	\N	178277	178277	345503
23263	35807	2	applied	\N	\N	\N	\N	178278	178278	345504
23267	35808	0	applied	\N	\N	\N	\N	178286	178286	345512
23267	35809	1	applied	\N	\N	\N	\N	178287	178287	345513
23273	35813	1	applied	\N	\N	\N	\N	178302	178302	345528
23273	35814	2	applied	\N	\N	\N	\N	178303	178303	345529
23273	35815	3	applied	\N	\N	\N	\N	178304	178304	345530
23273	35816	4	applied	\N	\N	\N	\N	178305	178305	345531
23273	35817	5	applied	\N	\N	\N	\N	178306	178306	345532
23274	35818	0	applied	\N	\N	\N	\N	178307	178307	345533
23274	35819	1	applied	\N	\N	\N	\N	178308	178308	345534
23280	35825	0	applied	\N	\N	\N	\N	178320	178320	345546
23280	35826	1	applied	\N	\N	\N	\N	178321	178321	345547
23286	35831	0	applied	\N	\N	\N	\N	178444	178444	345670
23286	35832	1	applied	\N	\N	\N	\N	178445	178445	345671
23286	35833	2	applied	\N	\N	\N	\N	178446	178446	345672
23286	35834	3	applied	\N	\N	\N	\N	178447	178447	345673
23286	35835	4	applied	\N	\N	\N	\N	178448	178448	345674
23286	35836	5	applied	\N	\N	\N	\N	178449	178449	345675
23287	35837	0	applied	\N	\N	\N	\N	178450	178450	345676
23294	35847	0	applied	\N	\N	\N	\N	178591	178591	345817
23294	35848	1	applied	\N	\N	\N	\N	178592	178592	345818
23294	35849	2	applied	\N	\N	\N	\N	178593	178593	345819
23294	35850	3	applied	\N	\N	\N	\N	178594	178594	345820
23300	35859	0	applied	\N	\N	\N	\N	178609	178609	345835
23300	35860	1	applied	\N	\N	\N	\N	178610	178610	345836
23301	35861	0	applied	\N	\N	\N	\N	178611	178611	345837
23301	35862	1	applied	\N	\N	\N	\N	178612	178612	345838
23305	35863	0	applied	\N	\N	\N	\N	178742	178742	345968
23305	35864	1	applied	\N	\N	\N	\N	178743	178743	345969
23312	35767	0	applied	\N	\N	\N	\N	178757	178757	345983
23312	35765	1	applied	\N	\N	\N	\N	178758	178758	345984
23312	35768	2	applied	\N	\N	\N	\N	178759	178759	345985
23312	35769	3	applied	\N	\N	\N	\N	178760	178760	345986
23312	35772	4	applied	\N	\N	\N	\N	178761	178761	345987
23312	35774	5	applied	\N	\N	\N	\N	178762	178762	345988
23312	35779	7	applied	\N	\N	\N	\N	178764	178764	345990
23312	35781	8	applied	\N	\N	\N	\N	178765	178765	345991
23312	35783	9	applied	\N	\N	\N	\N	178766	178766	345992
23312	35785	10	applied	\N	\N	\N	\N	178767	178767	345993
23312	35787	11	applied	\N	\N	\N	\N	178768	178768	345994
23312	35788	12	applied	\N	\N	\N	\N	178769	178769	345995
23312	35791	13	applied	\N	\N	\N	\N	178770	178770	345996
23312	35793	14	applied	\N	\N	\N	\N	178771	178771	345997
23312	35795	15	applied	\N	\N	\N	\N	178772	178772	345998
23312	35797	16	applied	\N	\N	\N	\N	178773	178773	345999
23312	35799	17	applied	\N	\N	\N	\N	178774	178774	346000
23312	35801	18	applied	\N	\N	\N	\N	178775	178775	346001
23312	35803	19	applied	\N	\N	\N	\N	178776	178776	346002
23312	35805	20	applied	\N	\N	\N	\N	178777	178777	346003
23312	35808	21	applied	\N	\N	\N	\N	178778	178778	346004
23312	35810	22	applied	\N	\N	\N	\N	178779	178779	346005
23215	35758	1	applied	\N	\N	1000000000	\N	177970	177970	345196
23215	35759	2	applied	\N	\N	\N	\N	177971	177971	345197
23217	35760	0	applied	\N	\N	\N	\N	177975	177975	345201
23217	35761	1	applied	\N	\N	\N	\N	177976	177976	345202
23222	35698	0	applied	\N	\N	\N	\N	177989	177989	345215
23222	35758	1	applied	\N	\N	1000000000	\N	177990	177990	345216
23222	35700	2	applied	\N	\N	\N	\N	177991	177991	345217
23222	35703	3	applied	\N	\N	\N	\N	177992	177992	345218
23222	35705	4	applied	\N	\N	\N	\N	177993	177993	345219
23222	35706	5	applied	\N	\N	\N	\N	177994	177994	345220
23222	35710	6	applied	\N	\N	\N	\N	177995	177995	345221
23222	35712	7	applied	\N	\N	\N	\N	177996	177996	345222
23222	35714	8	applied	\N	\N	\N	\N	177997	177997	345223
23222	35715	9	applied	\N	\N	\N	\N	177998	177998	345224
23222	35717	10	applied	\N	\N	\N	\N	177999	177999	345225
23222	35719	12	applied	\N	\N	\N	\N	178001	178001	345227
23222	35726	13	applied	\N	\N	\N	\N	178002	178002	345228
23222	35728	14	applied	\N	\N	\N	\N	178003	178003	345229
23222	35729	15	applied	\N	\N	\N	\N	178004	178004	345230
23222	35733	16	applied	\N	\N	\N	\N	178005	178005	345231
23222	35735	17	applied	\N	\N	\N	\N	178006	178006	345232
23222	35737	18	applied	\N	\N	\N	\N	178007	178007	345233
23222	35740	19	applied	\N	\N	\N	\N	178008	178008	345234
23222	35742	20	applied	\N	\N	\N	\N	178009	178009	345235
23222	35744	21	applied	\N	\N	\N	\N	178010	178010	345236
23222	35746	22	applied	\N	\N	\N	\N	178011	178011	345237
23222	35749	23	applied	\N	\N	\N	\N	178012	178012	345238
23222	35750	24	applied	\N	\N	\N	\N	178013	178013	345239
23222	35753	25	applied	\N	\N	\N	\N	178014	178014	345240
23222	35755	26	applied	\N	\N	\N	\N	178015	178015	345241
23222	35757	27	applied	\N	\N	\N	\N	178016	178016	345242
23222	35762	29	applied	\N	\N	\N	\N	178018	178018	345244
23222	35702	30	applied	\N	\N	\N	\N	178019	178019	345245
23222	35707	31	applied	\N	\N	\N	\N	178020	178020	345246
23222	35699	33	applied	\N	\N	\N	\N	178021	178021	345247
23222	35701	34	applied	\N	\N	\N	\N	178022	178022	345248
23222	35704	35	applied	\N	\N	\N	\N	178023	178023	345249
23222	35708	36	applied	\N	\N	\N	\N	178024	178024	345250
23222	35709	37	applied	\N	\N	\N	\N	178025	178025	345251
23222	35711	38	applied	\N	\N	\N	\N	178026	178026	345252
23222	35713	39	applied	\N	\N	\N	\N	178027	178027	345253
23222	35721	40	applied	\N	\N	\N	\N	178028	178028	345254
23222	35722	41	applied	\N	\N	\N	\N	178029	178029	345255
23222	35723	42	applied	\N	\N	\N	\N	178030	178030	345256
23222	35724	43	applied	\N	\N	\N	\N	178031	178031	345257
23222	35725	44	applied	\N	\N	\N	\N	178032	178032	345258
23222	35727	45	applied	\N	\N	\N	\N	178033	178033	345259
23222	35732	47	applied	\N	\N	\N	\N	178035	178035	345261
23222	35734	48	applied	\N	\N	\N	\N	178036	178036	345262
23222	35736	49	applied	\N	\N	\N	\N	178037	178037	345263
23222	35739	50	applied	\N	\N	\N	\N	178038	178038	345264
23222	35741	51	applied	\N	\N	\N	\N	178039	178039	345265
23222	35743	52	applied	\N	\N	\N	\N	178040	178040	345266
23222	35716	53	applied	\N	\N	\N	\N	178041	178041	345267
23222	35745	54	applied	\N	\N	\N	\N	178042	178042	345268
23222	35748	55	applied	\N	\N	\N	\N	178043	178043	345269
23222	35751	56	applied	\N	\N	\N	\N	178044	178044	345270
23222	35752	57	applied	\N	\N	\N	\N	178045	178045	345271
23222	35754	58	applied	\N	\N	\N	\N	178046	178046	345272
23222	35756	59	applied	\N	\N	\N	\N	178047	178047	345273
23222	35759	60	applied	\N	\N	\N	\N	178048	178048	345274
23222	35761	61	applied	\N	\N	\N	\N	178049	178049	345275
23222	35763	62	applied	\N	\N	\N	\N	178050	178050	345276
23222	35720	64	applied	\N	\N	\N	\N	178052	178052	345278
23222	35730	65	applied	\N	\N	\N	\N	178053	178053	345279
23222	35738	66	applied	\N	\N	\N	\N	178054	178054	345280
23222	35747	67	applied	\N	\N	\N	\N	178055	178055	345281
23227	35767	0	applied	\N	\N	\N	\N	178066	178066	345292
23227	35768	1	applied	\N	\N	\N	\N	178067	178067	345293
23227	35769	2	applied	\N	\N	\N	\N	178068	178068	345294
23227	35770	3	applied	\N	\N	\N	\N	178069	178069	345295
23227	35771	4	applied	\N	\N	\N	\N	178070	178070	345296
23231	35772	0	applied	\N	\N	\N	\N	178198	178198	345424
23231	35773	1	applied	\N	\N	\N	\N	178199	178199	345425
23232	35774	0	applied	\N	\N	\N	\N	178200	178200	345426
23232	35775	1	applied	\N	\N	\N	\N	178201	178201	345427
23237	35779	0	applied	\N	\N	\N	\N	178209	178209	345435
23237	35780	1	applied	\N	\N	\N	\N	178210	178210	345436
23242	35783	0	applied	\N	\N	\N	\N	178219	178219	345445
23243	35785	0	applied	\N	\N	\N	\N	178221	178221	345447
23243	35786	1	applied	\N	\N	\N	\N	178222	178222	345448
23312	35813	24	applied	\N	\N	\N	\N	178781	178781	346007
23312	35814	25	applied	\N	\N	\N	\N	178782	178782	346008
23312	35818	26	applied	\N	\N	\N	\N	178783	178783	346009
23312	35820	27	applied	\N	\N	\N	\N	178784	178784	346010
23312	35821	28	applied	\N	\N	\N	\N	178785	178785	346011
23312	35824	29	applied	\N	\N	\N	\N	178786	178786	346012
23312	35825	30	applied	\N	\N	\N	\N	178787	178787	346013
23312	35827	31	applied	\N	\N	\N	\N	178788	178788	346014
23312	35829	32	applied	\N	\N	\N	\N	178789	178789	346015
23312	35831	33	applied	\N	\N	\N	\N	178790	178790	346016
23312	35832	34	applied	\N	\N	\N	\N	178791	178791	346017
23312	35833	35	applied	\N	\N	\N	\N	178792	178792	346018
23312	35837	36	applied	\N	\N	\N	\N	178793	178793	346019
23312	35839	37	applied	\N	\N	\N	\N	178794	178794	346020
23312	35842	39	applied	\N	\N	\N	\N	178796	178796	346022
23312	35845	40	applied	\N	\N	\N	\N	178797	178797	346023
23312	35847	41	applied	\N	\N	\N	\N	178798	178798	346024
23312	35848	42	applied	\N	\N	\N	\N	178799	178799	346025
23312	35851	43	applied	\N	\N	\N	\N	178800	178800	346026
23312	35853	44	applied	\N	\N	\N	\N	178801	178801	346027
23312	35854	45	applied	\N	\N	\N	\N	178802	178802	346028
23312	35857	46	applied	\N	\N	\N	\N	178803	178803	346029
23312	35859	47	applied	\N	\N	\N	\N	178804	178804	346030
23312	35861	48	applied	\N	\N	\N	\N	178805	178805	346031
23312	35863	49	applied	\N	\N	\N	\N	178806	178806	346032
23312	35865	50	applied	\N	\N	\N	\N	178807	178807	346033
23312	35867	51	applied	\N	\N	\N	\N	178808	178808	346034
23312	35868	52	applied	\N	\N	\N	\N	178809	178809	346035
23312	35871	53	applied	\N	\N	\N	\N	178810	178810	346036
23312	35873	54	applied	\N	\N	\N	\N	178811	178811	346037
23216	35758	1	applied	\N	\N	1000000000	\N	177973	177973	345199
23216	35759	2	applied	\N	\N	\N	\N	177974	177974	345200
23228	35457	1	applied	\N	\N	\N	\N	178072	178072	345298
23228	35758	2	applied	\N	\N	1000000000	\N	178073	178073	345299
23228	35767	3	applied	\N	\N	\N	\N	178074	178074	345300
23228	35462	4	applied	\N	\N	\N	\N	178075	178075	345301
23228	35466	5	applied	\N	\N	\N	\N	178076	178076	345302
23228	35467	6	applied	\N	\N	\N	\N	178077	178077	345303
23228	35472	7	applied	\N	\N	\N	\N	178078	178078	345304
23228	35475	8	applied	\N	\N	\N	\N	178079	178079	345305
23228	35479	9	applied	\N	\N	\N	\N	178080	178080	345306
23228	35482	10	applied	\N	\N	\N	\N	178081	178081	345307
23228	35484	11	applied	\N	\N	\N	\N	178082	178082	345308
23228	35489	12	applied	\N	\N	\N	\N	178083	178083	345309
23228	35492	13	applied	\N	\N	\N	\N	178084	178084	345310
23228	35499	15	applied	\N	\N	\N	\N	178086	178086	345312
23228	35502	16	applied	\N	\N	\N	\N	178087	178087	345313
23228	35503	17	applied	\N	\N	\N	\N	178088	178088	345314
23228	35504	18	applied	\N	\N	\N	\N	178089	178089	345315
23228	35512	19	applied	\N	\N	\N	\N	178090	178090	345316
23228	35515	20	applied	\N	\N	\N	\N	178091	178091	345317
23228	35516	21	applied	\N	\N	\N	\N	178092	178092	345318
23228	35517	22	applied	\N	\N	\N	\N	178093	178093	345319
23228	35518	23	applied	\N	\N	\N	\N	178094	178094	345320
23228	35528	24	applied	\N	\N	\N	\N	178095	178095	345321
23228	35532	25	applied	\N	\N	\N	\N	178096	178096	345322
23228	35535	26	applied	\N	\N	\N	\N	178097	178097	345323
23228	35538	27	applied	\N	\N	\N	\N	178098	178098	345324
23228	35539	28	applied	\N	\N	\N	\N	178099	178099	345325
23228	35545	29	applied	\N	\N	\N	\N	178100	178100	345326
23228	35548	30	applied	\N	\N	\N	\N	178101	178101	345327
23228	35554	32	applied	\N	\N	\N	\N	178103	178103	345329
23228	35558	33	applied	\N	\N	\N	\N	178104	178104	345330
23228	35560	34	applied	\N	\N	\N	\N	178105	178105	345331
23228	35564	35	applied	\N	\N	\N	\N	178106	178106	345332
23228	35567	36	applied	\N	\N	\N	\N	178107	178107	345333
23228	35570	37	applied	\N	\N	\N	\N	178108	178108	345334
23228	35573	38	applied	\N	\N	\N	\N	178109	178109	345335
23228	35577	39	applied	\N	\N	\N	\N	178110	178110	345336
23228	35580	40	applied	\N	\N	\N	\N	178111	178111	345337
23228	35583	41	applied	\N	\N	\N	\N	178112	178112	345338
23228	35587	42	applied	\N	\N	\N	\N	178113	178113	345339
23228	35588	43	applied	\N	\N	\N	\N	178114	178114	345340
23228	35589	44	applied	\N	\N	\N	\N	178115	178115	345341
23228	35597	45	applied	\N	\N	\N	\N	178116	178116	345342
23228	35601	46	applied	\N	\N	\N	\N	178117	178117	345343
23228	35602	47	applied	\N	\N	\N	\N	178118	178118	345344
23228	35610	49	applied	\N	\N	\N	\N	178120	178120	345346
23228	35613	50	applied	\N	\N	\N	\N	178121	178121	345347
23228	35614	51	applied	\N	\N	\N	\N	178122	178122	345348
23228	35621	52	applied	\N	\N	\N	\N	178123	178123	345349
23228	35623	53	applied	\N	\N	\N	\N	178124	178124	345350
23228	35628	54	applied	\N	\N	\N	\N	178125	178125	345351
23228	35629	55	applied	\N	\N	\N	\N	178126	178126	345352
23228	35637	56	applied	\N	\N	\N	\N	178127	178127	345353
23228	35638	57	applied	\N	\N	\N	\N	178128	178128	345354
23228	35643	58	applied	\N	\N	\N	\N	178129	178129	345355
23228	35644	59	applied	\N	\N	\N	\N	178130	178130	345356
23228	35650	60	applied	\N	\N	\N	\N	178131	178131	345357
23228	35653	61	applied	\N	\N	\N	\N	178132	178132	345358
23228	35657	62	applied	\N	\N	\N	\N	178133	178133	345359
23228	35660	63	applied	\N	\N	\N	\N	178134	178134	345360
23228	35663	64	applied	\N	\N	\N	\N	178135	178135	345361
23228	35665	66	applied	\N	\N	\N	\N	178137	178137	345363
23228	35673	67	applied	\N	\N	\N	\N	178138	178138	345364
23228	35676	68	applied	\N	\N	\N	\N	178139	178139	345365
23228	35680	69	applied	\N	\N	\N	\N	178140	178140	345366
23228	35682	70	applied	\N	\N	\N	\N	178141	178141	345367
23228	35683	71	applied	\N	\N	\N	\N	178142	178142	345368
23228	35687	72	applied	\N	\N	\N	\N	178143	178143	345369
23228	35689	73	applied	\N	\N	\N	\N	178144	178144	345370
23228	35690	74	applied	\N	\N	\N	\N	178145	178145	345371
23228	35694	75	applied	\N	\N	\N	\N	178146	178146	345372
23228	35695	76	applied	\N	\N	\N	\N	178147	178147	345373
23228	35698	77	applied	\N	\N	\N	\N	178148	178148	345374
23228	35700	78	applied	\N	\N	\N	\N	178149	178149	345375
23228	35703	79	applied	\N	\N	\N	\N	178150	178150	345376
23228	35705	80	applied	\N	\N	\N	\N	178151	178151	345377
23228	35706	81	applied	\N	\N	\N	\N	178152	178152	345378
23228	35712	83	applied	\N	\N	\N	\N	178154	178154	345380
23228	35714	84	applied	\N	\N	\N	\N	178155	178155	345381
23248	35791	0	applied	\N	\N	\N	\N	178241	178241	345467
23248	35792	1	applied	\N	\N	\N	\N	178242	178242	345468
23252	35791	0	applied	\N	\N	\N	\N	178254	178254	345480
23252	35792	1	applied	\N	\N	\N	\N	178255	178255	345481
23253	35793	0	applied	\N	\N	\N	\N	178256	178256	345482
23253	35794	1	applied	\N	\N	\N	\N	178257	178257	345483
23258	35799	0	applied	\N	\N	\N	\N	178266	178266	345492
23258	35800	1	applied	\N	\N	\N	\N	178267	178267	345493
23264	35805	0	applied	\N	\N	\N	\N	178279	178279	345505
23264	35806	1	applied	\N	\N	\N	\N	178280	178280	345506
23264	35807	2	applied	\N	\N	\N	\N	178281	178281	345507
23268	35808	0	applied	\N	\N	\N	\N	178288	178288	345514
23268	35809	1	applied	\N	\N	\N	\N	178289	178289	345515
23269	35810	0	applied	\N	\N	\N	\N	178290	178290	345516
23275	35818	0	applied	\N	\N	\N	\N	178309	178309	345535
23275	35819	1	applied	\N	\N	\N	\N	178310	178310	345536
23281	35827	0	applied	\N	\N	\N	\N	178322	178322	345548
23281	35828	1	applied	\N	\N	\N	\N	178323	178323	345549
23288	35839	0	applied	\N	\N	\N	\N	178452	178452	345678
23288	35840	1	applied	\N	\N	\N	\N	178453	178453	345679
23295	35847	0	applied	\N	\N	\N	\N	178595	178595	345821
23295	35848	1	applied	\N	\N	\N	\N	178596	178596	345822
23295	35849	2	applied	\N	\N	\N	\N	178597	178597	345823
23295	35850	3	applied	\N	\N	\N	\N	178598	178598	345824
23302	35359	0	applied	\N	\N	\N	\N	178613	178613	345839
23302	35758	1	applied	\N	\N	1000000000	\N	178614	178614	345840
23302	35767	2	applied	\N	\N	\N	\N	178615	178615	345841
23302	35362	3	applied	\N	\N	\N	\N	178616	178616	345842
23302	35363	4	applied	\N	\N	\N	\N	178617	178617	345843
23302	35364	5	applied	\N	\N	\N	\N	178618	178618	345844
23218	35761	1	applied	\N	\N	\N	\N	177978	177978	345204
23228	35456	0	applied	\N	\N	\N	\N	178071	178071	345297
23228	35719	88	applied	\N	\N	\N	\N	178159	178159	345385
23228	35726	89	applied	\N	\N	\N	\N	178160	178160	345386
23228	35728	90	applied	\N	\N	\N	\N	178161	178161	345387
23228	35729	91	applied	\N	\N	\N	\N	178162	178162	345388
23228	35733	92	applied	\N	\N	\N	\N	178163	178163	345389
23228	35735	93	applied	\N	\N	\N	\N	178164	178164	345390
23228	35737	94	applied	\N	\N	\N	\N	178165	178165	345391
23228	35740	95	applied	\N	\N	\N	\N	178166	178166	345392
23228	35742	96	applied	\N	\N	\N	\N	178167	178167	345393
23228	35744	97	applied	\N	\N	\N	\N	178168	178168	345394
23228	35746	98	applied	\N	\N	\N	\N	178169	178169	345395
23228	35749	99	applied	\N	\N	\N	\N	178170	178170	345396
23228	35750	100	applied	\N	\N	\N	\N	178171	178171	345397
23228	35755	102	applied	\N	\N	\N	\N	178173	178173	345399
23228	35757	103	applied	\N	\N	\N	\N	178174	178174	345400
23228	35760	104	applied	\N	\N	\N	\N	178175	178175	345401
23228	35762	105	applied	\N	\N	\N	\N	178176	178176	345402
23228	35765	106	applied	\N	\N	\N	\N	178177	178177	345403
23228	35768	107	applied	\N	\N	\N	\N	178178	178178	345404
23228	35769	108	applied	\N	\N	\N	\N	178179	178179	345405
23228	35458	109	applied	\N	\N	\N	\N	178180	178180	345406
23228	35459	110	applied	\N	\N	\N	\N	178181	178181	345407
23228	35463	111	applied	\N	\N	\N	\N	178182	178182	345408
23228	35460	112	applied	\N	\N	\N	\N	178183	178183	345409
23228	35626	113	applied	\N	\N	\N	\N	178184	178184	345410
23228	35598	114	applied	\N	\N	\N	\N	178185	178185	345411
23228	35464	115	applied	\N	\N	\N	\N	178186	178186	345412
23228	35461	116	applied	\N	\N	\N	\N	178187	178187	345413
23228	35465	117	applied	\N	\N	\N	\N	178188	178188	345414
23228	35469	119	applied	\N	\N	\N	\N	178190	178190	345416
23228	35473	120	applied	\N	\N	\N	\N	178191	178191	345417
23228	35627	121	applied	\N	\N	\N	\N	178192	178192	345418
23228	35631	122	applied	\N	\N	\N	\N	178193	178193	345419
23228	35632	123	applied	\N	\N	\N	\N	178194	178194	345420
23228	35470	125	applied	\N	\N	\N	\N	178195	178195	345421
23233	35774	0	applied	\N	\N	\N	\N	178202	178202	345428
23233	35775	1	applied	\N	\N	\N	\N	178203	178203	345429
23238	35779	0	applied	\N	\N	\N	\N	178211	178211	345437
23238	35780	1	applied	\N	\N	\N	\N	178212	178212	345438
23239	35781	0	applied	\N	\N	\N	\N	178213	178213	345439
23239	35782	1	applied	\N	\N	\N	\N	178214	178214	345440
23244	35758	0	applied	\N	\N	1000000000	\N	178223	178223	345449
23244	35767	1	applied	\N	\N	\N	\N	178224	178224	345450
23244	35626	2	applied	\N	\N	\N	\N	178225	178225	345451
23244	35627	3	applied	\N	\N	\N	\N	178226	178226	345452
23244	35632	5	applied	\N	\N	\N	\N	178228	178228	345454
23245	35787	0	applied	\N	\N	\N	\N	178229	178229	345455
23245	35788	1	applied	\N	\N	\N	\N	178230	178230	345456
23245	35789	2	applied	\N	\N	\N	\N	178231	178231	345457
23245	35790	3	applied	\N	\N	\N	\N	178232	178232	345458
23249	35791	0	applied	\N	\N	\N	\N	178243	178243	345469
23249	35792	1	applied	\N	\N	\N	\N	178244	178244	345470
23254	35793	0	applied	\N	\N	\N	\N	178258	178258	345484
23254	35794	1	applied	\N	\N	\N	\N	178259	178259	345485
23259	35799	0	applied	\N	\N	\N	\N	178268	178268	345494
23259	35800	1	applied	\N	\N	\N	\N	178269	178269	345495
23265	35808	0	applied	\N	\N	\N	\N	178282	178282	345508
23265	35809	1	applied	\N	\N	\N	\N	178283	178283	345509
23270	35810	0	applied	\N	\N	\N	\N	178292	178292	345518
23270	35811	1	applied	\N	\N	\N	\N	178293	178293	345519
23276	35818	0	applied	\N	\N	\N	\N	178311	178311	345537
23277	35820	0	applied	\N	\N	\N	\N	178313	178313	345539
23277	35821	1	applied	\N	\N	\N	\N	178314	178314	345540
23277	35822	2	applied	\N	\N	\N	\N	178315	178315	345541
23277	35823	3	applied	\N	\N	\N	\N	178316	178316	345542
23282	35827	0	applied	\N	\N	\N	\N	178324	178324	345550
23282	35828	1	applied	\N	\N	\N	\N	178325	178325	345551
23283	35829	0	applied	\N	\N	\N	\N	178326	178326	345552
23283	35830	1	applied	\N	\N	\N	\N	178327	178327	345553
23289	35839	0	applied	\N	\N	\N	\N	178454	178454	345680
23289	35840	1	applied	\N	\N	\N	\N	178455	178455	345681
23296	35851	0	applied	\N	\N	\N	\N	178599	178599	345825
23296	35852	1	applied	\N	\N	\N	\N	178600	178600	345826
23303	35863	0	applied	\N	\N	\N	\N	178738	178738	345964
23303	35864	1	applied	\N	\N	\N	\N	178739	178739	345965
23309	35871	0	applied	\N	\N	\N	\N	178752	178752	345978
23309	35872	1	applied	\N	\N	\N	\N	178753	178753	345979
23316	35880	1	applied	\N	\N	\N	\N	178876	178876	346102
23316	35881	2	applied	\N	\N	\N	\N	178877	178877	346103
23316	35882	3	applied	\N	\N	\N	\N	178878	178878	346104
23322	35891	0	applied	\N	\N	\N	\N	178893	178893	346119
23322	35892	1	applied	\N	\N	\N	\N	178894	178894	346120
23323	35893	0	applied	\N	\N	\N	\N	178895	178895	346121
23323	35894	1	applied	\N	\N	\N	\N	178896	178896	346122
23332	35482	0	applied	\N	\N	\N	\N	178912	178912	346138
23332	35484	1	applied	\N	\N	\N	\N	178913	178913	346139
23332	35758	2	applied	\N	\N	1000000000	\N	178914	178914	346140
23332	35767	3	applied	\N	\N	\N	\N	178915	178915	346141
23332	35489	4	applied	\N	\N	\N	\N	178916	178916	346142
23332	35492	5	applied	\N	\N	\N	\N	178917	178917	346143
23332	35495	6	applied	\N	\N	\N	\N	178918	178918	346144
23332	35499	7	applied	\N	\N	\N	\N	178919	178919	346145
23332	35502	8	applied	\N	\N	\N	\N	178920	178920	346146
23332	35504	10	applied	\N	\N	\N	\N	178922	178922	346148
23332	35512	11	applied	\N	\N	\N	\N	178923	178923	346149
23332	35515	12	applied	\N	\N	\N	\N	178924	178924	346150
23332	35516	13	applied	\N	\N	\N	\N	178925	178925	346151
23332	35517	14	applied	\N	\N	\N	\N	178926	178926	346152
23332	35518	15	applied	\N	\N	\N	\N	178927	178927	346153
23332	35528	16	applied	\N	\N	\N	\N	178928	178928	346154
23332	35532	17	applied	\N	\N	\N	\N	178929	178929	346155
23332	35535	18	applied	\N	\N	\N	\N	178930	178930	346156
23332	35538	19	applied	\N	\N	\N	\N	178931	178931	346157
23332	35539	20	applied	\N	\N	\N	\N	178932	178932	346158
23332	35545	21	applied	\N	\N	\N	\N	178933	178933	346159
23332	35548	22	applied	\N	\N	\N	\N	178934	178934	346160
23332	35549	23	applied	\N	\N	\N	\N	178935	178935	346161
23332	35554	24	applied	\N	\N	\N	\N	178936	178936	346162
23332	35558	25	applied	\N	\N	\N	\N	178937	178937	346163
23228	35717	86	applied	\N	\N	\N	\N	178157	178157	345383
23228	35718	87	applied	\N	\N	\N	\N	178158	178158	345384
23272	35813	1	applied	\N	\N	\N	\N	178296	178296	345522
23272	35814	2	applied	\N	\N	\N	\N	178297	178297	345523
23272	35815	3	applied	\N	\N	\N	\N	178298	178298	345524
23272	35816	4	applied	\N	\N	\N	\N	178299	178299	345525
23272	35817	5	applied	\N	\N	\N	\N	178300	178300	345526
23278	35824	0	applied	\N	\N	\N	\N	178317	178317	345543
23279	35825	0	applied	\N	\N	\N	\N	178318	178318	345544
23279	35826	1	applied	\N	\N	\N	\N	178319	178319	345545
23284	35755	0	applied	\N	\N	\N	\N	178328	178328	345554
23284	35757	1	applied	\N	\N	\N	\N	178329	178329	345555
23284	35760	2	applied	\N	\N	\N	\N	178330	178330	345556
23284	35762	3	applied	\N	\N	\N	\N	178331	178331	345557
23284	35767	5	applied	\N	\N	\N	\N	178333	178333	345559
23284	35765	6	applied	\N	\N	\N	\N	178334	178334	345560
23284	35768	7	applied	\N	\N	\N	\N	178335	178335	345561
23284	35769	8	applied	\N	\N	\N	\N	178336	178336	345562
23284	35772	9	applied	\N	\N	\N	\N	178337	178337	345563
23284	35774	10	applied	\N	\N	\N	\N	178338	178338	345564
23284	35777	11	applied	\N	\N	\N	\N	178339	178339	345565
23284	35779	12	applied	\N	\N	\N	\N	178340	178340	345566
23284	35781	13	applied	\N	\N	\N	\N	178341	178341	345567
23284	35783	14	applied	\N	\N	\N	\N	178342	178342	345568
23284	35785	15	applied	\N	\N	\N	\N	178343	178343	345569
23284	35787	16	applied	\N	\N	\N	\N	178344	178344	345570
23284	35788	17	applied	\N	\N	\N	\N	178345	178345	345571
23284	35791	18	applied	\N	\N	\N	\N	178346	178346	345572
23284	35793	19	applied	\N	\N	\N	\N	178347	178347	345573
23284	35795	20	applied	\N	\N	\N	\N	178348	178348	345574
23284	35797	21	applied	\N	\N	\N	\N	178349	178349	345575
23284	35799	22	applied	\N	\N	\N	\N	178350	178350	345576
23284	35801	23	applied	\N	\N	\N	\N	178351	178351	345577
23284	35803	24	applied	\N	\N	\N	\N	178352	178352	345578
23284	35808	26	applied	\N	\N	\N	\N	178354	178354	345580
23284	35810	27	applied	\N	\N	\N	\N	178355	178355	345581
23284	35812	28	applied	\N	\N	\N	\N	178356	178356	345582
23284	35813	29	applied	\N	\N	\N	\N	178357	178357	345583
23284	35814	30	applied	\N	\N	\N	\N	178358	178358	345584
23284	35818	31	applied	\N	\N	\N	\N	178359	178359	345585
23284	35820	32	applied	\N	\N	\N	\N	178360	178360	345586
23284	35821	33	applied	\N	\N	\N	\N	178361	178361	345587
23284	35824	34	applied	\N	\N	\N	\N	178362	178362	345588
23284	35825	35	applied	\N	\N	\N	\N	178363	178363	345589
23284	35827	36	applied	\N	\N	\N	\N	178364	178364	345590
23284	35829	37	applied	\N	\N	\N	\N	178365	178365	345591
23284	35806	38	applied	\N	\N	\N	\N	178366	178366	345592
23284	35645	39	applied	\N	\N	\N	\N	178367	178367	345593
23284	35595	40	applied	\N	\N	\N	\N	178368	178368	345594
23284	35596	41	applied	\N	\N	\N	\N	178369	178369	345595
23284	35666	43	applied	\N	\N	\N	\N	178371	178371	345597
23284	35679	44	applied	\N	\N	\N	\N	178372	178372	345598
23284	35684	45	applied	\N	\N	\N	\N	178373	178373	345599
23284	35691	46	applied	\N	\N	\N	\N	178374	178374	345600
23284	35702	47	applied	\N	\N	\N	\N	178375	178375	345601
23284	35707	48	applied	\N	\N	\N	\N	178376	178376	345602
23284	35716	49	applied	\N	\N	\N	\N	178377	178377	345603
23284	35720	51	applied	\N	\N	\N	\N	178378	178378	345604
23284	35730	52	applied	\N	\N	\N	\N	178379	178379	345605
23284	35738	53	applied	\N	\N	\N	\N	178380	178380	345606
23284	35747	54	applied	\N	\N	\N	\N	178381	178381	345607
23284	35576	55	applied	\N	\N	\N	\N	178382	178382	345608
23284	35579	56	applied	\N	\N	\N	\N	178383	178383	345609
23284	35581	57	applied	\N	\N	\N	\N	178384	178384	345610
23284	35586	58	applied	\N	\N	\N	\N	178385	178385	345611
23284	35591	59	applied	\N	\N	\N	\N	178386	178386	345612
23284	35594	61	applied	\N	\N	\N	\N	178388	178388	345614
23284	35599	62	applied	\N	\N	\N	\N	178389	178389	345615
23284	35603	63	applied	\N	\N	\N	\N	178390	178390	345616
23284	35605	64	applied	\N	\N	\N	\N	178391	178391	345617
23284	35611	65	applied	\N	\N	\N	\N	178392	178392	345618
23284	35617	66	applied	\N	\N	\N	\N	178393	178393	345619
23284	35618	67	applied	\N	\N	\N	\N	178394	178394	345620
23284	35620	68	applied	\N	\N	\N	\N	178395	178395	345621
23284	35624	69	applied	\N	\N	\N	\N	178396	178396	345622
23284	35633	70	applied	\N	\N	\N	\N	178397	178397	345623
23284	35635	71	applied	\N	\N	\N	\N	178398	178398	345624
23284	35639	72	applied	\N	\N	\N	\N	178399	178399	345625
23284	35640	73	applied	\N	\N	\N	\N	178400	178400	345626
23284	35646	74	applied	\N	\N	\N	\N	178401	178401	345627
23284	35647	75	applied	\N	\N	\N	\N	178402	178402	345628
23332	35564	27	applied	\N	\N	\N	\N	178939	178939	346165
23332	35570	29	applied	\N	\N	\N	\N	178941	178941	346167
23332	35573	30	applied	\N	\N	\N	\N	178942	178942	346168
23332	35577	31	applied	\N	\N	\N	\N	178943	178943	346169
23332	35580	32	applied	\N	\N	\N	\N	178944	178944	346170
23332	35583	33	applied	\N	\N	\N	\N	178945	178945	346171
23332	35587	34	applied	\N	\N	\N	\N	178946	178946	346172
23332	35588	35	applied	\N	\N	\N	\N	178947	178947	346173
23332	35589	36	applied	\N	\N	\N	\N	178948	178948	346174
23332	35597	37	applied	\N	\N	\N	\N	178949	178949	346175
23332	35601	38	applied	\N	\N	\N	\N	178950	178950	346176
23332	35602	39	applied	\N	\N	\N	\N	178951	178951	346177
23332	35607	40	applied	\N	\N	\N	\N	178952	178952	346178
23332	35610	41	applied	\N	\N	\N	\N	178953	178953	346179
23332	35613	42	applied	\N	\N	\N	\N	178954	178954	346180
23332	35614	43	applied	\N	\N	\N	\N	178955	178955	346181
23332	35621	44	applied	\N	\N	\N	\N	178956	178956	346182
23332	35628	46	applied	\N	\N	\N	\N	178958	178958	346184
23332	35629	47	applied	\N	\N	\N	\N	178959	178959	346185
23332	35637	48	applied	\N	\N	\N	\N	178960	178960	346186
23332	35638	49	applied	\N	\N	\N	\N	178961	178961	346187
23332	35643	50	applied	\N	\N	\N	\N	178962	178962	346188
23332	35644	51	applied	\N	\N	\N	\N	178963	178963	346189
23332	35650	52	applied	\N	\N	\N	\N	178964	178964	346190
23332	35653	53	applied	\N	\N	\N	\N	178965	178965	346191
23332	35657	54	applied	\N	\N	\N	\N	178966	178966	346192
23332	35660	55	applied	\N	\N	\N	\N	178967	178967	346193
23332	35663	56	applied	\N	\N	\N	\N	178968	178968	346194
23332	35664	57	applied	\N	\N	\N	\N	178969	178969	346195
23332	35665	58	applied	\N	\N	\N	\N	178970	178970	346196
23332	35673	59	applied	\N	\N	\N	\N	178971	178971	346197
23271	35806	0	applied	\N	\N	\N	\N	178294	178294	345520
23272	35812	0	applied	\N	\N	\N	\N	178295	178295	345521
23284	35667	80	applied	\N	\N	\N	\N	178407	178407	345633
23284	35668	81	applied	\N	\N	\N	\N	178408	178408	345634
23284	35670	82	applied	\N	\N	\N	\N	178409	178409	345635
23284	35675	83	applied	\N	\N	\N	\N	178410	178410	345636
23284	35677	84	applied	\N	\N	\N	\N	178411	178411	345637
23284	35600	85	applied	\N	\N	\N	\N	178412	178412	345638
23284	35604	86	applied	\N	\N	\N	\N	178413	178413	345639
23284	35606	87	applied	\N	\N	\N	\N	178414	178414	345640
23284	35608	88	applied	\N	\N	\N	\N	178415	178415	345641
23284	35612	89	applied	\N	\N	\N	\N	178416	178416	345642
23284	35616	90	applied	\N	\N	\N	\N	178417	178417	345643
23284	35619	91	applied	\N	\N	\N	\N	178418	178418	345644
23284	35622	92	applied	\N	\N	\N	\N	178419	178419	345645
23284	35625	93	applied	\N	\N	\N	\N	178420	178420	345646
23284	35636	95	applied	\N	\N	\N	\N	178422	178422	345648
23284	35641	96	applied	\N	\N	\N	\N	178423	178423	345649
23284	35642	97	applied	\N	\N	\N	\N	178424	178424	345650
23284	35648	98	applied	\N	\N	\N	\N	178425	178425	345651
23284	35649	99	applied	\N	\N	\N	\N	178426	178426	345652
23284	35651	100	applied	\N	\N	\N	\N	178427	178427	345653
23284	35654	101	applied	\N	\N	\N	\N	178428	178428	345654
23284	35659	102	applied	\N	\N	\N	\N	178429	178429	345655
23284	35661	103	applied	\N	\N	\N	\N	178430	178430	345656
23284	35669	104	applied	\N	\N	\N	\N	178431	178431	345657
23284	35671	105	applied	\N	\N	\N	\N	178432	178432	345658
23284	35672	106	applied	\N	\N	\N	\N	178433	178433	345659
23284	35674	107	applied	\N	\N	\N	\N	178434	178434	345660
23284	35678	108	applied	\N	\N	\N	\N	178435	178435	345661
23284	35681	109	applied	\N	\N	\N	\N	178436	178436	345662
23284	35685	110	applied	\N	\N	\N	\N	178437	178437	345663
23285	35832	1	applied	\N	\N	\N	\N	178439	178439	345665
23285	35833	2	applied	\N	\N	\N	\N	178440	178440	345666
23285	35834	3	applied	\N	\N	\N	\N	178441	178441	345667
23285	35835	4	applied	\N	\N	\N	\N	178442	178442	345668
23285	35836	5	applied	\N	\N	\N	\N	178443	178443	345669
23290	35676	0	applied	\N	\N	\N	\N	178456	178456	345682
23290	35758	1	applied	\N	\N	1000000000	\N	178457	178457	345683
23290	35767	2	applied	\N	\N	\N	\N	178458	178458	345684
23290	35680	3	applied	\N	\N	\N	\N	178459	178459	345685
23290	35682	4	applied	\N	\N	\N	\N	178460	178460	345686
23290	35683	5	applied	\N	\N	\N	\N	178461	178461	345687
23290	35687	6	applied	\N	\N	\N	\N	178462	178462	345688
23290	35689	7	applied	\N	\N	\N	\N	178463	178463	345689
23290	35690	8	applied	\N	\N	\N	\N	178464	178464	345690
23290	35694	9	applied	\N	\N	\N	\N	178465	178465	345691
23290	35695	10	applied	\N	\N	\N	\N	178466	178466	345692
23290	35700	12	applied	\N	\N	\N	\N	178468	178468	345694
23290	35703	13	applied	\N	\N	\N	\N	178469	178469	345695
23290	35705	14	applied	\N	\N	\N	\N	178470	178470	345696
23290	35706	15	applied	\N	\N	\N	\N	178471	178471	345697
23290	35710	16	applied	\N	\N	\N	\N	178472	178472	345698
23290	35712	17	applied	\N	\N	\N	\N	178473	178473	345699
23290	35714	18	applied	\N	\N	\N	\N	178474	178474	345700
23290	35715	19	applied	\N	\N	\N	\N	178475	178475	345701
23290	35717	20	applied	\N	\N	\N	\N	178476	178476	345702
23290	35718	21	applied	\N	\N	\N	\N	178477	178477	345703
23290	35719	22	applied	\N	\N	\N	\N	178478	178478	345704
23290	35726	23	applied	\N	\N	\N	\N	178479	178479	345705
23290	35728	24	applied	\N	\N	\N	\N	178480	178480	345706
23290	35729	25	applied	\N	\N	\N	\N	178481	178481	345707
23290	35733	26	applied	\N	\N	\N	\N	178482	178482	345708
23290	35735	27	applied	\N	\N	\N	\N	178483	178483	345709
23290	35740	29	applied	\N	\N	\N	\N	178485	178485	345711
23290	35742	30	applied	\N	\N	\N	\N	178486	178486	345712
23290	35744	31	applied	\N	\N	\N	\N	178487	178487	345713
23290	35746	32	applied	\N	\N	\N	\N	178488	178488	345714
23290	35749	33	applied	\N	\N	\N	\N	178489	178489	345715
23290	35750	34	applied	\N	\N	\N	\N	178490	178490	345716
23290	35753	35	applied	\N	\N	\N	\N	178491	178491	345717
23290	35755	36	applied	\N	\N	\N	\N	178492	178492	345718
23290	35757	37	applied	\N	\N	\N	\N	178493	178493	345719
23290	35760	38	applied	\N	\N	\N	\N	178494	178494	345720
23290	35762	39	applied	\N	\N	\N	\N	178495	178495	345721
23290	35765	40	applied	\N	\N	\N	\N	178496	178496	345722
23290	35768	41	applied	\N	\N	\N	\N	178497	178497	345723
23290	35769	42	applied	\N	\N	\N	\N	178498	178498	345724
23290	35772	43	applied	\N	\N	\N	\N	178499	178499	345725
23290	35774	44	applied	\N	\N	\N	\N	178500	178500	345726
23290	35779	46	applied	\N	\N	\N	\N	178502	178502	345728
23290	35781	47	applied	\N	\N	\N	\N	178503	178503	345729
23290	35783	48	applied	\N	\N	\N	\N	178504	178504	345730
23290	35785	49	applied	\N	\N	\N	\N	178505	178505	345731
23290	35787	50	applied	\N	\N	\N	\N	178506	178506	345732
23290	35788	51	applied	\N	\N	\N	\N	178507	178507	345733
23290	35791	52	applied	\N	\N	\N	\N	178508	178508	345734
23290	35793	53	applied	\N	\N	\N	\N	178509	178509	345735
23290	35795	54	applied	\N	\N	\N	\N	178510	178510	345736
23290	35797	55	applied	\N	\N	\N	\N	178511	178511	345737
23290	35799	56	applied	\N	\N	\N	\N	178512	178512	345738
23290	35801	57	applied	\N	\N	\N	\N	178513	178513	345739
23290	35803	58	applied	\N	\N	\N	\N	178514	178514	345740
23290	35805	59	applied	\N	\N	\N	\N	178515	178515	345741
23290	35808	60	applied	\N	\N	\N	\N	178516	178516	345742
23290	35810	61	applied	\N	\N	\N	\N	178517	178517	345743
23290	35813	63	applied	\N	\N	\N	\N	178519	178519	345745
23290	35814	64	applied	\N	\N	\N	\N	178520	178520	345746
23290	35818	65	applied	\N	\N	\N	\N	178521	178521	345747
23290	35820	66	applied	\N	\N	\N	\N	178522	178522	345748
23290	35821	67	applied	\N	\N	\N	\N	178523	178523	345749
23290	35824	68	applied	\N	\N	\N	\N	178524	178524	345750
23290	35825	69	applied	\N	\N	\N	\N	178525	178525	345751
23290	35827	70	applied	\N	\N	\N	\N	178526	178526	345752
23290	35829	71	applied	\N	\N	\N	\N	178527	178527	345753
23290	35831	72	applied	\N	\N	\N	\N	178528	178528	345754
23290	35832	73	applied	\N	\N	\N	\N	178529	178529	345755
23290	35833	74	applied	\N	\N	\N	\N	178530	178530	345756
23290	35837	75	applied	\N	\N	\N	\N	178531	178531	345757
23290	35839	76	applied	\N	\N	\N	\N	178532	178532	345758
23290	35806	77	applied	\N	\N	\N	\N	178533	178533	345759
23290	35311	78	applied	\N	\N	\N	\N	178534	178534	345760
23284	35662	79	applied	\N	\N	\N	\N	178406	178406	345632
23290	35327	84	applied	\N	\N	\N	\N	178539	178539	345765
23290	35334	85	applied	\N	\N	\N	\N	178540	178540	345766
23290	35335	86	applied	\N	\N	\N	\N	178541	178541	345767
23290	35337	87	applied	\N	\N	\N	\N	178542	178542	345768
23290	35340	88	applied	\N	\N	\N	\N	178543	178543	345769
23290	35343	89	applied	\N	\N	\N	\N	178544	178544	345770
23290	35348	90	applied	\N	\N	\N	\N	178545	178545	345771
23290	35350	91	applied	\N	\N	\N	\N	178546	178546	345772
23290	35357	92	applied	\N	\N	\N	\N	178547	178547	345773
23290	35358	93	applied	\N	\N	\N	\N	178548	178548	345774
23290	35361	94	applied	\N	\N	\N	\N	178549	178549	345775
23290	35366	95	applied	\N	\N	\N	\N	178550	178550	345776
23290	35368	96	applied	\N	\N	\N	\N	178551	178551	345777
23290	35369	97	applied	\N	\N	\N	\N	178552	178552	345778
23290	35370	98	applied	\N	\N	\N	\N	178553	178553	345779
23290	35376	99	applied	\N	\N	\N	\N	178554	178554	345780
23290	35383	101	applied	\N	\N	\N	\N	178556	178556	345782
23290	35384	102	applied	\N	\N	\N	\N	178557	178557	345783
23290	35394	103	applied	\N	\N	\N	\N	178558	178558	345784
23290	35395	104	applied	\N	\N	\N	\N	178559	178559	345785
23290	35396	105	applied	\N	\N	\N	\N	178560	178560	345786
23290	35400	106	applied	\N	\N	\N	\N	178561	178561	345787
23290	35401	107	applied	\N	\N	\N	\N	178562	178562	345788
23290	35402	108	applied	\N	\N	\N	\N	178563	178563	345789
23290	35409	109	applied	\N	\N	\N	\N	178564	178564	345790
23290	35412	110	applied	\N	\N	\N	\N	178565	178565	345791
23290	35416	111	applied	\N	\N	\N	\N	178566	178566	345792
23290	35419	112	applied	\N	\N	\N	\N	178567	178567	345793
23290	35423	113	applied	\N	\N	\N	\N	178568	178568	345794
23290	35426	114	applied	\N	\N	\N	\N	178569	178569	345795
23290	35429	115	applied	\N	\N	\N	\N	178570	178570	345796
23290	35430	116	applied	\N	\N	\N	\N	178571	178571	345797
23290	35438	118	applied	\N	\N	\N	\N	178573	178573	345799
23290	35442	119	applied	\N	\N	\N	\N	178574	178574	345800
23290	35444	120	applied	\N	\N	\N	\N	178575	178575	345801
23290	35447	121	applied	\N	\N	\N	\N	178576	178576	345802
23290	35451	122	applied	\N	\N	\N	\N	178577	178577	345803
23290	35453	123	applied	\N	\N	\N	\N	178578	178578	345804
23290	35458	124	applied	\N	\N	\N	\N	178579	178579	345805
23290	35459	125	applied	\N	\N	\N	\N	178580	178580	345806
23291	35841	0	applied	\N	\N	\N	\N	178581	178581	345807
23291	35842	1	applied	\N	\N	\N	\N	178582	178582	345808
23291	35843	2	applied	\N	\N	\N	\N	178583	178583	345809
23291	35844	3	applied	\N	\N	\N	\N	178584	178584	345810
23292	35845	0	applied	\N	\N	\N	\N	178585	178585	345811
23292	35846	1	applied	\N	\N	\N	\N	178586	178586	345812
23293	35847	0	applied	\N	\N	\N	\N	178587	178587	345813
23293	35848	1	applied	\N	\N	\N	\N	178588	178588	345814
23293	35850	3	applied	\N	\N	\N	\N	178590	178590	345816
23297	35851	0	applied	\N	\N	\N	\N	178601	178601	345827
23297	35852	1	applied	\N	\N	\N	\N	178602	178602	345828
23298	35853	0	applied	\N	\N	\N	\N	178603	178603	345829
23298	35854	1	applied	\N	\N	\N	\N	178604	178604	345830
23298	35855	2	applied	\N	\N	\N	\N	178605	178605	345831
23298	35856	3	applied	\N	\N	\N	\N	178606	178606	345832
23299	35857	0	applied	\N	\N	\N	\N	178607	178607	345833
23299	35858	1	applied	\N	\N	\N	\N	178608	178608	345834
23304	35863	0	applied	\N	\N	\N	\N	178740	178740	345966
23304	35864	1	applied	\N	\N	\N	\N	178741	178741	345967
23310	35871	0	applied	\N	\N	\N	\N	178754	178754	345980
23310	35872	1	applied	\N	\N	\N	\N	178755	178755	345981
23311	35873	0	applied	\N	\N	\N	\N	178756	178756	345982
23317	35879	0	applied	\N	\N	\N	\N	178879	178879	346105
23317	35880	1	applied	\N	\N	\N	\N	178880	178880	346106
23317	35882	3	applied	\N	\N	\N	\N	178882	178882	346108
23318	35883	0	applied	\N	\N	\N	\N	178883	178883	346109
23318	35884	1	applied	\N	\N	\N	\N	178884	178884	346110
23318	35885	2	applied	\N	\N	\N	\N	178885	178885	346111
23318	35886	3	applied	\N	\N	\N	\N	178886	178886	346112
23324	35806	0	applied	\N	\N	\N	\N	178897	178897	346123
23329	35895	0	applied	\N	\N	\N	\N	178904	178904	346130
23329	35896	1	applied	\N	\N	\N	\N	178905	178905	346131
23329	35897	2	applied	\N	\N	\N	\N	178906	178906	346132
23329	35898	3	applied	\N	\N	\N	\N	178907	178907	346133
23334	35901	0	applied	\N	\N	\N	\N	179010	179010	346236
23334	35902	1	applied	\N	\N	\N	\N	179011	179011	346237
23339	35907	0	applied	\N	\N	\N	\N	179018	179018	346244
23339	35908	1	applied	\N	\N	\N	\N	179019	179019	346245
23340	35909	0	applied	\N	\N	\N	\N	179020	179020	346246
23340	35910	1	applied	\N	\N	\N	\N	179021	179021	346247
23340	35912	3	applied	\N	\N	\N	\N	179023	179023	346249
23346	35920	0	applied	\N	\N	\N	\N	179041	179041	346267
23352	35923	0	applied	\N	\N	\N	\N	179057	179057	346283
23352	35924	1	applied	\N	\N	\N	\N	179058	179058	346284
23352	35925	2	applied	\N	\N	\N	\N	179059	179059	346285
23352	35926	3	applied	\N	\N	\N	\N	179060	179060	346286
23358	35935	0	applied	\N	\N	\N	\N	179173	179173	346399
23364	35941	0	applied	\N	\N	\N	\N	179185	179185	346411
23364	35942	1	applied	\N	\N	\N	\N	179186	179186	346412
23365	35943	0	applied	\N	\N	\N	\N	179187	179187	346413
23365	35944	1	applied	\N	\N	\N	\N	179188	179188	346414
23365	35945	2	applied	\N	\N	\N	\N	179189	179189	346415
23365	35946	3	applied	\N	\N	\N	\N	179190	179190	346416
23371	35955	0	applied	\N	\N	\N	\N	179204	179204	346430
23371	35956	1	applied	\N	\N	\N	\N	179205	179205	346431
23376	35957	0	applied	\N	\N	\N	\N	179214	179214	346440
23377	35959	0	applied	\N	\N	\N	\N	179216	179216	346442
23377	35960	1	applied	\N	\N	\N	\N	179217	179217	346443
23377	35961	2	applied	\N	\N	\N	\N	179218	179218	346444
23377	35962	3	applied	\N	\N	\N	\N	179219	179219	346445
23377	35963	4	applied	\N	\N	\N	\N	179220	179220	346446
23382	35965	0	applied	\N	\N	\N	\N	179231	179231	346457
23382	35966	1	applied	\N	\N	\N	\N	179232	179232	346458
23393	35983	0	applied	\N	\N	\N	\N	179282	179282	346508
23393	35984	1	applied	\N	\N	\N	\N	179283	179283	346509
23393	35985	2	applied	\N	\N	\N	\N	179284	179284	346510
23393	35986	3	applied	\N	\N	\N	\N	179285	179285	346511
23399	35987	0	applied	\N	\N	\N	\N	179395	179395	346621
23399	35988	1	applied	\N	\N	\N	\N	179396	179396	346622
23410	35913	0	applied	\N	\N	\N	\N	179437	179437	346663
23290	35318	80	applied	\N	\N	\N	\N	178536	178536	345762
23290	35319	82	applied	\N	\N	\N	\N	178537	178537	345763
23302	35387	11	applied	\N	\N	\N	\N	178624	178624	345850
23302	35388	12	applied	\N	\N	\N	\N	178625	178625	345851
23302	35389	13	applied	\N	\N	\N	\N	178626	178626	345852
23302	35397	14	applied	\N	\N	\N	\N	178627	178627	345853
23302	35398	15	applied	\N	\N	\N	\N	178628	178628	345854
23302	35399	16	applied	\N	\N	\N	\N	178629	178629	345855
23302	35407	17	applied	\N	\N	\N	\N	178630	178630	345856
23302	35408	18	applied	\N	\N	\N	\N	178631	178631	345857
23302	35414	19	applied	\N	\N	\N	\N	178632	178632	345858
23302	35417	20	applied	\N	\N	\N	\N	178633	178633	345859
23302	35420	21	applied	\N	\N	\N	\N	178634	178634	345860
23302	35424	22	applied	\N	\N	\N	\N	178635	178635	345861
23302	35427	23	applied	\N	\N	\N	\N	178636	178636	345862
23302	35428	24	applied	\N	\N	\N	\N	178637	178637	345863
23302	35439	26	applied	\N	\N	\N	\N	178639	178639	345865
23302	35440	27	applied	\N	\N	\N	\N	178640	178640	345866
23302	35446	28	applied	\N	\N	\N	\N	178641	178641	345867
23302	35449	29	applied	\N	\N	\N	\N	178642	178642	345868
23302	35452	30	applied	\N	\N	\N	\N	178643	178643	345869
23302	35456	31	applied	\N	\N	\N	\N	178644	178644	345870
23302	35457	32	applied	\N	\N	\N	\N	178645	178645	345871
23302	35462	33	applied	\N	\N	\N	\N	178646	178646	345872
23302	35466	34	applied	\N	\N	\N	\N	178647	178647	345873
23302	35467	35	applied	\N	\N	\N	\N	178648	178648	345874
23302	35472	36	applied	\N	\N	\N	\N	178649	178649	345875
23302	35475	37	applied	\N	\N	\N	\N	178650	178650	345876
23302	35479	38	applied	\N	\N	\N	\N	178651	178651	345877
23302	35482	39	applied	\N	\N	\N	\N	178652	178652	345878
23302	35484	40	applied	\N	\N	\N	\N	178653	178653	345879
23302	35489	41	applied	\N	\N	\N	\N	178654	178654	345880
23302	35495	43	applied	\N	\N	\N	\N	178656	178656	345882
23302	35499	44	applied	\N	\N	\N	\N	178657	178657	345883
23302	35502	45	applied	\N	\N	\N	\N	178658	178658	345884
23302	35503	46	applied	\N	\N	\N	\N	178659	178659	345885
23302	35504	47	applied	\N	\N	\N	\N	178660	178660	345886
23302	35512	48	applied	\N	\N	\N	\N	178661	178661	345887
23302	35515	49	applied	\N	\N	\N	\N	178662	178662	345888
23302	35516	50	applied	\N	\N	\N	\N	178663	178663	345889
23302	35517	51	applied	\N	\N	\N	\N	178664	178664	345890
23302	35518	52	applied	\N	\N	\N	\N	178665	178665	345891
23302	35528	53	applied	\N	\N	\N	\N	178666	178666	345892
23302	35532	54	applied	\N	\N	\N	\N	178667	178667	345893
23302	35535	55	applied	\N	\N	\N	\N	178668	178668	345894
23302	35538	56	applied	\N	\N	\N	\N	178669	178669	345895
23302	35539	57	applied	\N	\N	\N	\N	178670	178670	345896
23302	35545	58	applied	\N	\N	\N	\N	178671	178671	345897
23302	35549	60	applied	\N	\N	\N	\N	178673	178673	345899
23302	35554	61	applied	\N	\N	\N	\N	178674	178674	345900
23302	35558	62	applied	\N	\N	\N	\N	178675	178675	345901
23302	35560	63	applied	\N	\N	\N	\N	178676	178676	345902
23302	35564	64	applied	\N	\N	\N	\N	178677	178677	345903
23302	35567	65	applied	\N	\N	\N	\N	178678	178678	345904
23302	35570	66	applied	\N	\N	\N	\N	178679	178679	345905
23302	35573	67	applied	\N	\N	\N	\N	178680	178680	345906
23302	35577	68	applied	\N	\N	\N	\N	178681	178681	345907
23302	35580	69	applied	\N	\N	\N	\N	178682	178682	345908
23302	35583	70	applied	\N	\N	\N	\N	178683	178683	345909
23302	35587	71	applied	\N	\N	\N	\N	178684	178684	345910
23302	35588	72	applied	\N	\N	\N	\N	178685	178685	345911
23302	35589	73	applied	\N	\N	\N	\N	178686	178686	345912
23302	35597	74	applied	\N	\N	\N	\N	178687	178687	345913
23302	35601	75	applied	\N	\N	\N	\N	178688	178688	345914
23302	35607	77	applied	\N	\N	\N	\N	178690	178690	345916
23302	35610	78	applied	\N	\N	\N	\N	178691	178691	345917
23302	35613	79	applied	\N	\N	\N	\N	178692	178692	345918
23302	35614	80	applied	\N	\N	\N	\N	178693	178693	345919
23302	35621	81	applied	\N	\N	\N	\N	178694	178694	345920
23302	35623	82	applied	\N	\N	\N	\N	178695	178695	345921
23302	35628	83	applied	\N	\N	\N	\N	178696	178696	345922
23302	35629	84	applied	\N	\N	\N	\N	178697	178697	345923
23302	35637	85	applied	\N	\N	\N	\N	178698	178698	345924
23302	35638	86	applied	\N	\N	\N	\N	178699	178699	345925
23302	35643	87	applied	\N	\N	\N	\N	178700	178700	345926
23302	35644	89	applied	\N	\N	\N	\N	178701	178701	345927
23302	35650	90	applied	\N	\N	\N	\N	178702	178702	345928
23302	35653	91	applied	\N	\N	\N	\N	178703	178703	345929
23302	35657	92	applied	\N	\N	\N	\N	178704	178704	345930
23302	35660	93	applied	\N	\N	\N	\N	178705	178705	345931
23410	35758	1	applied	\N	\N	1000000000	\N	179438	179438	346664
23410	35767	2	applied	\N	\N	\N	\N	179439	179439	346665
23410	35680	3	applied	\N	\N	\N	\N	179440	179440	346666
23410	35682	4	applied	\N	\N	\N	\N	179441	179441	346667
23410	35683	5	applied	\N	\N	\N	\N	179442	179442	346668
23410	35687	6	applied	\N	\N	\N	\N	179443	179443	346669
23410	35689	7	applied	\N	\N	\N	\N	179444	179444	346670
23410	35690	8	applied	\N	\N	\N	\N	179445	179445	346671
23410	35694	9	applied	\N	\N	\N	\N	179446	179446	346672
23410	35695	10	applied	\N	\N	\N	\N	179447	179447	346673
23410	35698	11	applied	\N	\N	\N	\N	179448	179448	346674
23410	35700	12	applied	\N	\N	\N	\N	179449	179449	346675
23410	35703	13	applied	\N	\N	\N	\N	179450	179450	346676
23410	35705	14	applied	\N	\N	\N	\N	179451	179451	346677
23410	35706	15	applied	\N	\N	\N	\N	179452	179452	346678
23410	35710	16	applied	\N	\N	\N	\N	179453	179453	346679
23410	35714	18	applied	\N	\N	\N	\N	179455	179455	346681
23410	35715	19	applied	\N	\N	\N	\N	179456	179456	346682
23410	35717	20	applied	\N	\N	\N	\N	179457	179457	346683
23410	35718	21	applied	\N	\N	\N	\N	179458	179458	346684
23410	35719	22	applied	\N	\N	\N	\N	179459	179459	346685
23410	35726	23	applied	\N	\N	\N	\N	179460	179460	346686
23410	35728	24	applied	\N	\N	\N	\N	179461	179461	346687
23410	35729	25	applied	\N	\N	\N	\N	179462	179462	346688
23410	35733	26	applied	\N	\N	\N	\N	179463	179463	346689
23410	35735	27	applied	\N	\N	\N	\N	179464	179464	346690
23410	35737	28	applied	\N	\N	\N	\N	179465	179465	346691
23410	35740	29	applied	\N	\N	\N	\N	179466	179466	346692
23410	35742	30	applied	\N	\N	\N	\N	179467	179467	346693
23410	35744	31	applied	\N	\N	\N	\N	179468	179468	346694
23410	35746	32	applied	\N	\N	\N	\N	179469	179469	346695
23410	35749	33	applied	\N	\N	\N	\N	179470	179470	346696
23302	35382	10	applied	\N	\N	\N	\N	178623	178623	345849
23302	35680	99	applied	\N	\N	\N	\N	178711	178711	345937
23302	35682	100	applied	\N	\N	\N	\N	178712	178712	345938
23302	35683	101	applied	\N	\N	\N	\N	178713	178713	345939
23302	35687	102	applied	\N	\N	\N	\N	178714	178714	345940
23302	35689	103	applied	\N	\N	\N	\N	178715	178715	345941
23302	35690	104	applied	\N	\N	\N	\N	178716	178716	345942
23302	35694	105	applied	\N	\N	\N	\N	178717	178717	345943
23302	35695	106	applied	\N	\N	\N	\N	178718	178718	345944
23302	35698	107	applied	\N	\N	\N	\N	178719	178719	345945
23302	35700	108	applied	\N	\N	\N	\N	178720	178720	345946
23302	35703	109	applied	\N	\N	\N	\N	178721	178721	345947
23302	35705	110	applied	\N	\N	\N	\N	178722	178722	345948
23302	35706	111	applied	\N	\N	\N	\N	178723	178723	345949
23302	35710	112	applied	\N	\N	\N	\N	178724	178724	345950
23302	35712	113	applied	\N	\N	\N	\N	178725	178725	345951
23302	35714	114	applied	\N	\N	\N	\N	178726	178726	345952
23302	35717	116	applied	\N	\N	\N	\N	178728	178728	345954
23302	35718	117	applied	\N	\N	\N	\N	178729	178729	345955
23302	35719	118	applied	\N	\N	\N	\N	178730	178730	345956
23302	35726	119	applied	\N	\N	\N	\N	178731	178731	345957
23302	35728	120	applied	\N	\N	\N	\N	178732	178732	345958
23302	35729	121	applied	\N	\N	\N	\N	178733	178733	345959
23302	35733	122	applied	\N	\N	\N	\N	178734	178734	345960
23302	35735	123	applied	\N	\N	\N	\N	178735	178735	345961
23302	35737	124	applied	\N	\N	\N	\N	178736	178736	345962
23302	35740	125	applied	\N	\N	\N	\N	178737	178737	345963
23306	35863	0	applied	\N	\N	\N	\N	178744	178744	345970
23306	35864	1	applied	\N	\N	\N	\N	178745	178745	345971
23307	35865	0	applied	\N	\N	\N	\N	178746	178746	345972
23307	35866	1	applied	\N	\N	\N	\N	178747	178747	345973
23308	35867	0	applied	\N	\N	\N	\N	178748	178748	345974
23308	35868	1	applied	\N	\N	\N	\N	178749	178749	345975
23308	35870	3	applied	\N	\N	\N	\N	178751	178751	345977
23315	35879	0	applied	\N	\N	\N	\N	178871	178871	346097
23315	35880	1	applied	\N	\N	\N	\N	178872	178872	346098
23315	35881	2	applied	\N	\N	\N	\N	178873	178873	346099
23315	35882	3	applied	\N	\N	\N	\N	178874	178874	346100
23321	35891	0	applied	\N	\N	\N	\N	178891	178891	346117
23321	35892	1	applied	\N	\N	\N	\N	178892	178892	346118
23331	35899	0	applied	\N	\N	\N	\N	178910	178910	346136
23331	35900	1	applied	\N	\N	\N	\N	178911	178911	346137
23336	35903	0	applied	\N	\N	\N	\N	179014	179014	346240
23336	35904	1	applied	\N	\N	\N	\N	179015	179015	346241
23337	35905	0	applied	\N	\N	\N	\N	179016	179016	346242
23337	35906	1	applied	\N	\N	\N	\N	179017	179017	346243
23342	35909	0	applied	\N	\N	\N	\N	179028	179028	346254
23342	35910	1	applied	\N	\N	\N	\N	179029	179029	346255
23342	35911	2	applied	\N	\N	\N	\N	179030	179030	346256
23343	35913	0	applied	\N	\N	\N	\N	179032	179032	346258
23343	35914	1	applied	\N	\N	\N	\N	179033	179033	346259
23343	35915	2	applied	\N	\N	\N	\N	179034	179034	346260
23343	35916	3	applied	\N	\N	\N	\N	179035	179035	346261
23343	35917	4	applied	\N	\N	\N	\N	179036	179036	346262
23344	35918	0	applied	\N	\N	\N	\N	179037	179037	346263
23344	35919	1	applied	\N	\N	\N	\N	179038	179038	346264
23350	35923	0	applied	\N	\N	\N	\N	179049	179049	346275
23350	35924	1	applied	\N	\N	\N	\N	179050	179050	346276
23350	35925	2	applied	\N	\N	\N	\N	179051	179051	346277
23350	35926	3	applied	\N	\N	\N	\N	179052	179052	346278
23354	35927	0	applied	\N	\N	\N	\N	179163	179163	346389
23354	35928	1	applied	\N	\N	\N	\N	179164	179164	346390
23360	35935	0	applied	\N	\N	\N	\N	179176	179176	346402
23360	35936	2	applied	\N	\N	\N	\N	179177	179177	346403
23361	35937	0	applied	\N	\N	\N	\N	179178	179178	346404
23361	35938	2	applied	\N	\N	\N	\N	179180	179180	346406
23369	35951	0	applied	\N	\N	\N	\N	179200	179200	346426
23369	35952	1	applied	\N	\N	\N	\N	179201	179201	346427
23369	35953	2	applied	\N	\N	\N	\N	179202	179202	346428
23369	35954	3	applied	\N	\N	\N	\N	179203	179203	346429
23373	35955	0	applied	\N	\N	\N	\N	179208	179208	346434
23373	35956	1	applied	\N	\N	\N	\N	179209	179209	346435
23374	35957	0	applied	\N	\N	\N	\N	179210	179210	346436
23374	35958	1	applied	\N	\N	\N	\N	179211	179211	346437
23379	35961	0	applied	\N	\N	\N	\N	179225	179225	346451
23379	35964	1	applied	\N	\N	\N	\N	179226	179226	346452
23385	35971	0	applied	\N	\N	\N	\N	179249	179249	346475
23385	35972	1	applied	\N	\N	\N	\N	179250	179250	346476
23392	35983	0	applied	\N	\N	\N	\N	179278	179278	346504
23392	35984	1	applied	\N	\N	\N	\N	179279	179279	346505
23392	35985	2	applied	\N	\N	\N	\N	179280	179280	346506
23397	35913	0	applied	\N	\N	\N	\N	179296	179296	346522
23397	35841	1	applied	\N	\N	\N	\N	179297	179297	346523
23397	35842	2	applied	\N	\N	\N	\N	179298	179298	346524
23397	35845	3	applied	\N	\N	\N	\N	179299	179299	346525
23397	35847	4	applied	\N	\N	\N	\N	179300	179300	346526
23397	35848	5	applied	\N	\N	\N	\N	179301	179301	346527
23397	35851	6	applied	\N	\N	\N	\N	179302	179302	346528
23397	35853	7	applied	\N	\N	\N	\N	179303	179303	346529
23397	35854	8	applied	\N	\N	\N	\N	179304	179304	346530
23397	35857	9	applied	\N	\N	\N	\N	179305	179305	346531
23397	35859	10	applied	\N	\N	\N	\N	179306	179306	346532
23397	35861	11	applied	\N	\N	\N	\N	179307	179307	346533
23397	35863	12	applied	\N	\N	\N	\N	179308	179308	346534
23397	35865	13	applied	\N	\N	\N	\N	179309	179309	346535
23397	35867	14	applied	\N	\N	\N	\N	179310	179310	346536
23397	35868	15	applied	\N	\N	\N	\N	179311	179311	346537
23397	35873	17	applied	\N	\N	\N	\N	179313	179313	346539
23397	35875	18	applied	\N	\N	\N	\N	179314	179314	346540
23397	35876	19	applied	\N	\N	\N	\N	179315	179315	346541
23397	35879	20	applied	\N	\N	\N	\N	179316	179316	346542
23397	35880	21	applied	\N	\N	\N	\N	179317	179317	346543
23397	35883	22	applied	\N	\N	\N	\N	179318	179318	346544
23397	35884	23	applied	\N	\N	\N	\N	179319	179319	346545
23397	35887	24	applied	\N	\N	\N	\N	179320	179320	346546
23397	35889	25	applied	\N	\N	\N	\N	179321	179321	346547
23397	35891	26	applied	\N	\N	\N	\N	179322	179322	346548
23397	35893	27	applied	\N	\N	\N	\N	179323	179323	346549
23397	35895	28	applied	\N	\N	\N	\N	179324	179324	346550
23397	35896	29	applied	\N	\N	\N	\N	179325	179325	346551
23397	35899	30	applied	\N	\N	\N	\N	179326	179326	346552
23302	35665	96	applied	\N	\N	\N	\N	178708	178708	345934
23302	35673	97	applied	\N	\N	\N	\N	178709	178709	345935
23312	35776	60	applied	\N	\N	\N	\N	178817	178817	346043
23312	35778	61	applied	\N	\N	\N	\N	178818	178818	346044
23312	35780	62	applied	\N	\N	\N	\N	178819	178819	346045
23312	35782	63	applied	\N	\N	\N	\N	178820	178820	346046
23312	35784	64	applied	\N	\N	\N	\N	178821	178821	346047
23312	35786	65	applied	\N	\N	\N	\N	178822	178822	346048
23312	35789	66	applied	\N	\N	\N	\N	178823	178823	346049
23312	35790	67	applied	\N	\N	\N	\N	178824	178824	346050
23312	35792	68	applied	\N	\N	\N	\N	178825	178825	346051
23312	35794	69	applied	\N	\N	\N	\N	178826	178826	346052
23312	35796	70	applied	\N	\N	\N	\N	178827	178827	346053
23312	35798	71	applied	\N	\N	\N	\N	178828	178828	346054
23312	35800	72	applied	\N	\N	\N	\N	178829	178829	346055
23312	35802	73	applied	\N	\N	\N	\N	178830	178830	346056
23312	35804	74	applied	\N	\N	\N	\N	178831	178831	346057
23312	35807	75	applied	\N	\N	\N	\N	178832	178832	346058
23312	35811	77	applied	\N	\N	\N	\N	178834	178834	346060
23312	35815	78	applied	\N	\N	\N	\N	178835	178835	346061
23312	35816	79	applied	\N	\N	\N	\N	178836	178836	346062
23312	35817	80	applied	\N	\N	\N	\N	178837	178837	346063
23312	35819	81	applied	\N	\N	\N	\N	178838	178838	346064
23312	35822	82	applied	\N	\N	\N	\N	178839	178839	346065
23312	35823	83	applied	\N	\N	\N	\N	178840	178840	346066
23312	35826	84	applied	\N	\N	\N	\N	178841	178841	346067
23312	35828	85	applied	\N	\N	\N	\N	178842	178842	346068
23312	35830	86	applied	\N	\N	\N	\N	178843	178843	346069
23312	35834	87	applied	\N	\N	\N	\N	178844	178844	346070
23312	35835	88	applied	\N	\N	\N	\N	178845	178845	346071
23312	35836	89	applied	\N	\N	\N	\N	178846	178846	346072
23312	35838	91	applied	\N	\N	\N	\N	178847	178847	346073
23312	35840	92	applied	\N	\N	\N	\N	178848	178848	346074
23312	35843	93	applied	\N	\N	\N	\N	178849	178849	346075
23312	35846	95	applied	\N	\N	\N	\N	178851	178851	346077
23312	35849	96	applied	\N	\N	\N	\N	178852	178852	346078
23312	35850	97	applied	\N	\N	\N	\N	178853	178853	346079
23312	35852	98	applied	\N	\N	\N	\N	178854	178854	346080
23312	35855	99	applied	\N	\N	\N	\N	178855	178855	346081
23312	35856	100	applied	\N	\N	\N	\N	178856	178856	346082
23312	35858	101	applied	\N	\N	\N	\N	178857	178857	346083
23312	35860	102	applied	\N	\N	\N	\N	178858	178858	346084
23312	35862	103	applied	\N	\N	\N	\N	178859	178859	346085
23312	35864	104	applied	\N	\N	\N	\N	178860	178860	346086
23312	35866	105	applied	\N	\N	\N	\N	178861	178861	346087
23312	35869	106	applied	\N	\N	\N	\N	178862	178862	346088
23312	35870	107	applied	\N	\N	\N	\N	178863	178863	346089
23312	35872	108	applied	\N	\N	\N	\N	178864	178864	346090
23312	35874	109	applied	\N	\N	\N	\N	178865	178865	346091
23313	35875	0	applied	\N	\N	\N	\N	178866	178866	346092
23313	35874	2	applied	\N	\N	\N	\N	178868	178868	346094
23313	35877	3	applied	\N	\N	\N	\N	178869	178869	346095
23313	35878	4	applied	\N	\N	\N	\N	178870	178870	346096
23319	35887	0	applied	\N	\N	\N	\N	178887	178887	346113
23319	35888	1	applied	\N	\N	\N	\N	178888	178888	346114
23320	35889	0	applied	\N	\N	\N	\N	178889	178889	346115
23320	35890	1	applied	\N	\N	\N	\N	178890	178890	346116
23325	35893	0	applied	\N	\N	\N	\N	178898	178898	346124
23325	35894	1	applied	\N	\N	\N	\N	178899	178899	346125
23326	35895	0	applied	\N	\N	\N	\N	178900	178900	346126
23326	35896	1	applied	\N	\N	\N	\N	178901	178901	346127
23326	35897	2	applied	\N	\N	\N	\N	178902	178902	346128
23326	35898	3	applied	\N	\N	\N	\N	178903	178903	346129
23330	35899	0	applied	\N	\N	\N	\N	178908	178908	346134
23330	35900	1	applied	\N	\N	\N	\N	178909	178909	346135
23335	35903	0	applied	\N	\N	\N	\N	179012	179012	346238
23341	35909	0	applied	\N	\N	\N	\N	179024	179024	346250
23341	35910	1	applied	\N	\N	\N	\N	179025	179025	346251
23341	35911	2	applied	\N	\N	\N	\N	179026	179026	346252
23341	35912	3	applied	\N	\N	\N	\N	179027	179027	346253
23347	35920	0	applied	\N	\N	\N	\N	179042	179042	346268
23348	35921	0	applied	\N	\N	\N	\N	179043	179043	346269
23348	35922	1	applied	\N	\N	\N	\N	179044	179044	346270
23349	35923	0	applied	\N	\N	\N	\N	179045	179045	346271
23349	35924	1	applied	\N	\N	\N	\N	179046	179046	346272
23349	35925	2	applied	\N	\N	\N	\N	179047	179047	346273
23349	35926	3	applied	\N	\N	\N	\N	179048	179048	346274
23353	35742	0	applied	\N	\N	\N	\N	179061	179061	346287
23353	35913	1	applied	\N	\N	\N	\N	179062	179062	346288
23353	35744	2	applied	\N	\N	\N	\N	179063	179063	346289
23353	35746	3	applied	\N	\N	\N	\N	179064	179064	346290
23397	35901	31	applied	\N	\N	\N	\N	179327	179327	346553
23397	35905	33	applied	\N	\N	\N	\N	179329	179329	346555
23397	35907	34	applied	\N	\N	\N	\N	179330	179330	346556
23397	35909	35	applied	\N	\N	\N	\N	179331	179331	346557
23397	35910	36	applied	\N	\N	\N	\N	179332	179332	346558
23397	35914	37	applied	\N	\N	\N	\N	179333	179333	346559
23397	35915	38	applied	\N	\N	\N	\N	179334	179334	346560
23397	35918	39	applied	\N	\N	\N	\N	179335	179335	346561
23397	35921	40	applied	\N	\N	\N	\N	179336	179336	346562
23397	35923	41	applied	\N	\N	\N	\N	179337	179337	346563
23397	35924	42	applied	\N	\N	\N	\N	179338	179338	346564
23397	35927	43	applied	\N	\N	\N	\N	179339	179339	346565
23397	35929	44	applied	\N	\N	\N	\N	179340	179340	346566
23397	35930	45	applied	\N	\N	\N	\N	179341	179341	346567
23397	35933	46	applied	\N	\N	\N	\N	179342	179342	346568
23397	35935	47	applied	\N	\N	\N	\N	179343	179343	346569
23397	35937	48	applied	\N	\N	\N	\N	179344	179344	346570
23397	35941	50	applied	\N	\N	\N	\N	179346	179346	346572
23397	35943	51	applied	\N	\N	\N	\N	179347	179347	346573
23397	35944	52	applied	\N	\N	\N	\N	179348	179348	346574
23397	35947	53	applied	\N	\N	\N	\N	179349	179349	346575
23397	35948	54	applied	\N	\N	\N	\N	179350	179350	346576
23397	35951	55	applied	\N	\N	\N	\N	179351	179351	346577
23397	35952	56	applied	\N	\N	\N	\N	179352	179352	346578
23397	35955	57	applied	\N	\N	\N	\N	179353	179353	346579
23397	35957	58	applied	\N	\N	\N	\N	179354	179354	346580
23397	35959	59	applied	\N	\N	\N	\N	179355	179355	346581
23397	35960	60	applied	\N	\N	\N	\N	179356	179356	346582
23397	35961	61	applied	\N	\N	\N	\N	179357	179357	346583
23397	35965	62	applied	\N	\N	\N	\N	179358	179358	346584
23397	35967	63	applied	\N	\N	\N	\N	179359	179359	346585
23312	35773	57	applied	\N	\N	\N	\N	178814	178814	346040
23312	35806	58	applied	\N	\N	\N	\N	178815	178815	346041
23332	35687	64	applied	\N	\N	\N	\N	178976	178976	346202
23332	35689	65	applied	\N	\N	\N	\N	178977	178977	346203
23332	35690	66	applied	\N	\N	\N	\N	178978	178978	346204
23332	35694	67	applied	\N	\N	\N	\N	178979	178979	346205
23332	35695	68	applied	\N	\N	\N	\N	178980	178980	346206
23332	35698	69	applied	\N	\N	\N	\N	178981	178981	346207
23332	35700	70	applied	\N	\N	\N	\N	178982	178982	346208
23332	35703	71	applied	\N	\N	\N	\N	178983	178983	346209
23332	35705	72	applied	\N	\N	\N	\N	178984	178984	346210
23332	35706	73	applied	\N	\N	\N	\N	178985	178985	346211
23332	35710	74	applied	\N	\N	\N	\N	178986	178986	346212
23332	35712	75	applied	\N	\N	\N	\N	178987	178987	346213
23332	35714	76	applied	\N	\N	\N	\N	178988	178988	346214
23332	35715	77	applied	\N	\N	\N	\N	178989	178989	346215
23332	35718	79	applied	\N	\N	\N	\N	178991	178991	346217
23332	35719	80	applied	\N	\N	\N	\N	178992	178992	346218
23332	35726	81	applied	\N	\N	\N	\N	178993	178993	346219
23332	35728	82	applied	\N	\N	\N	\N	178994	178994	346220
23332	35729	83	applied	\N	\N	\N	\N	178995	178995	346221
23332	35733	84	applied	\N	\N	\N	\N	178996	178996	346222
23332	35735	85	applied	\N	\N	\N	\N	178997	178997	346223
23332	35737	87	applied	\N	\N	\N	\N	178998	178998	346224
23332	35740	88	applied	\N	\N	\N	\N	178999	178999	346225
23332	35742	89	applied	\N	\N	\N	\N	179000	179000	346226
23332	35744	90	applied	\N	\N	\N	\N	179001	179001	346227
23332	35746	91	applied	\N	\N	\N	\N	179002	179002	346228
23332	35749	92	applied	\N	\N	\N	\N	179003	179003	346229
23332	35750	93	applied	\N	\N	\N	\N	179004	179004	346230
23332	35753	94	applied	\N	\N	\N	\N	179005	179005	346231
23332	35755	95	applied	\N	\N	\N	\N	179006	179006	346232
23332	35760	97	applied	\N	\N	\N	\N	179008	179008	346234
23332	35762	98	applied	\N	\N	\N	\N	179009	179009	346235
23345	35918	0	applied	\N	\N	\N	\N	179039	179039	346265
23345	35919	1	applied	\N	\N	\N	\N	179040	179040	346266
23351	35923	0	applied	\N	\N	\N	\N	179053	179053	346279
23351	35924	1	applied	\N	\N	\N	\N	179054	179054	346280
23351	35925	2	applied	\N	\N	\N	\N	179055	179055	346281
23351	35926	3	applied	\N	\N	\N	\N	179056	179056	346282
23353	35749	4	applied	\N	\N	\N	\N	179065	179065	346291
23353	35750	5	applied	\N	\N	\N	\N	179066	179066	346292
23353	35753	6	applied	\N	\N	\N	\N	179067	179067	346293
23353	35755	7	applied	\N	\N	\N	\N	179068	179068	346294
23353	35757	8	applied	\N	\N	\N	\N	179069	179069	346295
23353	35760	9	applied	\N	\N	\N	\N	179070	179070	346296
23353	35762	10	applied	\N	\N	\N	\N	179071	179071	346297
23353	35765	11	applied	\N	\N	\N	\N	179072	179072	346298
23353	35769	13	applied	\N	\N	\N	\N	179074	179074	346300
23353	35772	14	applied	\N	\N	\N	\N	179075	179075	346301
23353	35774	15	applied	\N	\N	\N	\N	179076	179076	346302
23353	35777	16	applied	\N	\N	\N	\N	179077	179077	346303
23353	35779	17	applied	\N	\N	\N	\N	179078	179078	346304
23353	35781	18	applied	\N	\N	\N	\N	179079	179079	346305
23353	35783	19	applied	\N	\N	\N	\N	179080	179080	346306
23353	35785	20	applied	\N	\N	\N	\N	179081	179081	346307
23353	35787	21	applied	\N	\N	\N	\N	179082	179082	346308
23353	35788	22	applied	\N	\N	\N	\N	179083	179083	346309
23353	35791	23	applied	\N	\N	\N	\N	179084	179084	346310
23353	35793	24	applied	\N	\N	\N	\N	179085	179085	346311
23353	35795	25	applied	\N	\N	\N	\N	179086	179086	346312
23353	35797	26	applied	\N	\N	\N	\N	179087	179087	346313
23353	35799	27	applied	\N	\N	\N	\N	179088	179088	346314
23353	35801	28	applied	\N	\N	\N	\N	179089	179089	346315
23353	35805	30	applied	\N	\N	\N	\N	179091	179091	346317
23353	35808	31	applied	\N	\N	\N	\N	179092	179092	346318
23353	35810	32	applied	\N	\N	\N	\N	179093	179093	346319
23353	35812	33	applied	\N	\N	\N	\N	179094	179094	346320
23353	35813	34	applied	\N	\N	\N	\N	179095	179095	346321
23353	35814	35	applied	\N	\N	\N	\N	179096	179096	346322
23353	35818	36	applied	\N	\N	\N	\N	179097	179097	346323
23355	35927	0	applied	\N	\N	\N	\N	179165	179165	346391
23355	35928	1	applied	\N	\N	\N	\N	179166	179166	346392
23356	35929	0	applied	\N	\N	\N	\N	179167	179167	346393
23356	35930	1	applied	\N	\N	\N	\N	179168	179168	346394
23356	35931	2	applied	\N	\N	\N	\N	179169	179169	346395
23356	35932	3	applied	\N	\N	\N	\N	179170	179170	346396
23357	35933	0	applied	\N	\N	\N	\N	179171	179171	346397
23357	35934	1	applied	\N	\N	\N	\N	179172	179172	346398
23362	35939	0	applied	\N	\N	\N	\N	179181	179181	346407
23363	35941	0	applied	\N	\N	\N	\N	179183	179183	346409
23363	35942	1	applied	\N	\N	\N	\N	179184	179184	346410
23375	35957	0	applied	\N	\N	\N	\N	179212	179212	346438
23375	35958	1	applied	\N	\N	\N	\N	179213	179213	346439
23380	35961	0	applied	\N	\N	\N	\N	179227	179227	346453
23380	35964	1	applied	\N	\N	\N	\N	179228	179228	346454
23381	35965	0	applied	\N	\N	\N	\N	179229	179229	346455
23381	35966	1	applied	\N	\N	\N	\N	179230	179230	346456
23386	35971	0	applied	\N	\N	\N	\N	179251	179251	346477
23386	35972	1	applied	\N	\N	\N	\N	179252	179252	346478
23387	35913	0	applied	\N	\N	\N	\N	179253	179253	346479
23387	35758	1	applied	\N	\N	1000000000	\N	179254	179254	346480
23387	35767	2	applied	\N	\N	\N	\N	179255	179255	346481
23387	35806	3	applied	\N	\N	\N	\N	179256	179256	346482
23388	35913	0	applied	\N	\N	\N	\N	179257	179257	346483
23390	35973	0	applied	\N	\N	\N	\N	179258	179258	346484
23390	35975	2	applied	\N	\N	\N	\N	179260	179260	346486
23390	35976	3	applied	\N	\N	\N	\N	179261	179261	346487
23390	35977	4	applied	\N	\N	\N	\N	179262	179262	346488
23390	35978	5	applied	\N	\N	\N	\N	179263	179263	346489
23390	35979	6	applied	\N	\N	\N	\N	179264	179264	346490
23390	35980	7	applied	\N	\N	\N	\N	179265	179265	346491
23390	35981	8	applied	\N	\N	\N	\N	179266	179266	346492
23390	35982	9	applied	\N	\N	\N	\N	179267	179267	346493
23391	35973	0	applied	\N	\N	\N	\N	179268	179268	346494
23391	35974	1	applied	\N	\N	\N	\N	179269	179269	346495
23391	35975	2	applied	\N	\N	\N	\N	179270	179270	346496
23391	35976	3	applied	\N	\N	\N	\N	179271	179271	346497
23391	35977	4	applied	\N	\N	\N	\N	179272	179272	346498
23391	35978	5	applied	\N	\N	\N	\N	179273	179273	346499
23391	35979	6	applied	\N	\N	\N	\N	179274	179274	346500
23391	35980	7	applied	\N	\N	\N	\N	179275	179275	346501
23332	35683	63	applied	\N	\N	\N	\N	178975	178975	346201
23353	35825	40	applied	\N	\N	\N	\N	179101	179101	346327
23353	35827	41	applied	\N	\N	\N	\N	179102	179102	346328
23353	35829	42	applied	\N	\N	\N	\N	179103	179103	346329
23353	35831	43	applied	\N	\N	\N	\N	179104	179104	346330
23353	35832	44	applied	\N	\N	\N	\N	179105	179105	346331
23353	35833	45	applied	\N	\N	\N	\N	179106	179106	346332
23353	35837	46	applied	\N	\N	\N	\N	179107	179107	346333
23353	35839	47	applied	\N	\N	\N	\N	179108	179108	346334
23353	35841	48	applied	\N	\N	\N	\N	179109	179109	346335
23353	35842	49	applied	\N	\N	\N	\N	179110	179110	346336
23353	35845	50	applied	\N	\N	\N	\N	179111	179111	346337
23353	35847	51	applied	\N	\N	\N	\N	179112	179112	346338
23353	35848	52	applied	\N	\N	\N	\N	179113	179113	346339
23353	35853	54	applied	\N	\N	\N	\N	179115	179115	346341
23353	35854	55	applied	\N	\N	\N	\N	179116	179116	346342
23353	35857	56	applied	\N	\N	\N	\N	179117	179117	346343
23353	35859	57	applied	\N	\N	\N	\N	179118	179118	346344
23353	35861	58	applied	\N	\N	\N	\N	179119	179119	346345
23353	35863	59	applied	\N	\N	\N	\N	179120	179120	346346
23353	35865	60	applied	\N	\N	\N	\N	179121	179121	346347
23353	35867	61	applied	\N	\N	\N	\N	179122	179122	346348
23353	35868	62	applied	\N	\N	\N	\N	179123	179123	346349
23353	35871	63	applied	\N	\N	\N	\N	179124	179124	346350
23353	35873	64	applied	\N	\N	\N	\N	179125	179125	346351
23353	35875	65	applied	\N	\N	\N	\N	179126	179126	346352
23353	35876	66	applied	\N	\N	\N	\N	179127	179127	346353
23353	35879	67	applied	\N	\N	\N	\N	179128	179128	346354
23353	35880	68	applied	\N	\N	\N	\N	179129	179129	346355
23353	35883	69	applied	\N	\N	\N	\N	179130	179130	346356
23353	35887	71	applied	\N	\N	\N	\N	179132	179132	346358
23353	35889	72	applied	\N	\N	\N	\N	179133	179133	346359
23353	35891	73	applied	\N	\N	\N	\N	179134	179134	346360
23353	35893	74	applied	\N	\N	\N	\N	179135	179135	346361
23353	35895	75	applied	\N	\N	\N	\N	179136	179136	346362
23353	35896	76	applied	\N	\N	\N	\N	179137	179137	346363
23353	35899	77	applied	\N	\N	\N	\N	179138	179138	346364
23353	35901	78	applied	\N	\N	\N	\N	179139	179139	346365
23353	35903	79	applied	\N	\N	\N	\N	179140	179140	346366
23353	35905	80	applied	\N	\N	\N	\N	179141	179141	346367
23353	35907	81	applied	\N	\N	\N	\N	179142	179142	346368
23353	35909	82	applied	\N	\N	\N	\N	179143	179143	346369
23353	35910	83	applied	\N	\N	\N	\N	179144	179144	346370
23353	35914	84	applied	\N	\N	\N	\N	179145	179145	346371
23353	35915	85	applied	\N	\N	\N	\N	179146	179146	346372
23353	35918	86	applied	\N	\N	\N	\N	179147	179147	346373
23353	35923	89	applied	\N	\N	\N	\N	179149	179149	346375
23353	35924	90	applied	\N	\N	\N	\N	179150	179150	346376
23353	35166	91	applied	\N	\N	\N	\N	179151	179151	346377
23353	35058	92	applied	\N	\N	1000000000	\N	179152	179152	346378
23353	34950	93	applied	\N	\N	\N	\N	179153	179153	346379
23353	34954	94	applied	\N	\N	\N	\N	179154	179154	346380
23353	35129	95	applied	\N	\N	\N	\N	179155	179155	346381
23353	35067	96	applied	\N	\N	1000000000	\N	179156	179156	346382
23353	34947	97	applied	\N	\N	\N	\N	179157	179157	346383
23353	34951	98	applied	\N	\N	\N	\N	179158	179158	346384
23353	34955	99	applied	\N	\N	\N	\N	179159	179159	346385
23353	35170	100	applied	\N	\N	\N	\N	179160	179160	346386
23353	35001	101	applied	\N	\N	\N	\N	179161	179161	346387
23353	34952	102	applied	\N	\N	\N	\N	179162	179162	346388
23359	35935	0	applied	\N	\N	\N	\N	179174	179174	346400
23359	35936	2	applied	\N	\N	\N	\N	179175	179175	346401
23367	35947	0	applied	\N	\N	\N	\N	179192	179192	346418
23367	35948	1	applied	\N	\N	\N	\N	179193	179193	346419
23367	35949	2	applied	\N	\N	\N	\N	179194	179194	346420
23367	35950	3	applied	\N	\N	\N	\N	179195	179195	346421
23368	35951	0	applied	\N	\N	\N	\N	179196	179196	346422
23368	35952	1	applied	\N	\N	\N	\N	179197	179197	346423
23368	35953	2	applied	\N	\N	\N	\N	179198	179198	346424
23368	35954	3	applied	\N	\N	\N	\N	179199	179199	346425
23372	35955	0	applied	\N	\N	\N	\N	179206	179206	346432
23372	35956	1	applied	\N	\N	\N	\N	179207	179207	346433
23378	35959	0	applied	\N	\N	\N	\N	179221	179221	346447
23378	35960	1	applied	\N	\N	\N	\N	179222	179222	346448
23378	35962	2	applied	\N	\N	\N	\N	179223	179223	346449
23378	35963	3	applied	\N	\N	\N	\N	179224	179224	346450
23383	35955	0	applied	\N	\N	\N	\N	179233	179233	346459
23383	35957	1	applied	\N	\N	\N	\N	179234	179234	346460
23383	35960	3	applied	\N	\N	\N	\N	179236	179236	346462
23391	35981	8	applied	\N	\N	\N	\N	179276	179276	346502
23391	35982	9	applied	\N	\N	\N	\N	179277	179277	346503
23394	35983	0	applied	\N	\N	\N	\N	179286	179286	346512
23394	35984	1	applied	\N	\N	\N	\N	179287	179287	346513
23394	35985	2	applied	\N	\N	\N	\N	179288	179288	346514
23394	35986	3	applied	\N	\N	\N	\N	179289	179289	346515
23396	35983	0	applied	\N	\N	\N	\N	179292	179292	346518
23396	35984	1	applied	\N	\N	\N	\N	179293	179293	346519
23396	35985	2	applied	\N	\N	\N	\N	179294	179294	346520
23396	35986	3	applied	\N	\N	\N	\N	179295	179295	346521
23402	35993	0	applied	\N	\N	\N	\N	179401	179401	346627
23402	35994	1	applied	\N	\N	\N	\N	179402	179402	346628
23406	35997	0	applied	\N	\N	\N	\N	179421	179421	346647
23406	35998	1	applied	\N	\N	\N	\N	179422	179422	346648
23406	35999	2	applied	\N	\N	\N	\N	179423	179423	346649
23406	36001	4	applied	\N	\N	\N	\N	179425	179425	346651
23406	36002	5	applied	\N	\N	\N	\N	179426	179426	346652
23406	36003	6	applied	\N	\N	\N	\N	179427	179427	346653
23406	36004	7	applied	\N	\N	\N	\N	179428	179428	346654
23408	36009	0	applied	\N	\N	\N	\N	179433	179433	346659
23408	36010	1	applied	\N	\N	\N	\N	179434	179434	346660
23411	36011	0	applied	\N	\N	\N	\N	179562	179562	346788
23411	36012	1	applied	\N	\N	\N	\N	179563	179563	346789
23415	36015	0	applied	\N	\N	\N	\N	179574	179574	346800
23415	36016	1	applied	\N	\N	\N	\N	179575	179575	346801
23415	36017	2	applied	\N	\N	\N	\N	179576	179576	346802
23415	36018	3	applied	\N	\N	\N	\N	179577	179577	346803
23421	36021	0	applied	\N	\N	\N	\N	179619	179619	346845
23421	35989	1	applied	\N	\N	\N	\N	179620	179620	346846
23421	35991	2	applied	\N	\N	\N	\N	179621	179621	346847
23421	35993	3	applied	\N	\N	\N	\N	179622	179622	346848
23353	35821	38	applied	\N	\N	\N	\N	179099	179099	346325
23353	35824	39	applied	\N	\N	\N	\N	179100	179100	346326
23383	35962	8	applied	\N	\N	\N	\N	179241	179241	346467
23383	35963	9	applied	\N	\N	\N	\N	179242	179242	346468
23383	35964	10	applied	\N	\N	\N	\N	179243	179243	346469
23383	35966	11	applied	\N	\N	\N	\N	179244	179244	346470
23384	35967	0	applied	\N	\N	\N	\N	179245	179245	346471
23384	35968	1	applied	\N	\N	\N	\N	179246	179246	346472
23384	35969	2	applied	\N	\N	\N	\N	179247	179247	346473
23384	35970	3	applied	\N	\N	\N	\N	179248	179248	346474
23395	35985	0	applied	\N	\N	\N	\N	179290	179290	346516
23395	35986	1	applied	\N	\N	\N	\N	179291	179291	346517
23397	35968	64	applied	\N	\N	\N	\N	179360	179360	346586
23397	35971	65	applied	\N	\N	\N	\N	179361	179361	346587
23397	35973	66	applied	\N	\N	\N	\N	179362	179362	346588
23397	35974	67	applied	\N	\N	\N	\N	179363	179363	346589
23397	35975	68	applied	\N	\N	\N	\N	179364	179364	346590
23397	35976	69	applied	\N	\N	\N	\N	179365	179365	346591
23397	35983	71	applied	\N	\N	\N	\N	179367	179367	346593
23397	35984	72	applied	\N	\N	\N	\N	179368	179368	346594
23397	35463	73	applied	\N	\N	\N	\N	179369	179369	346595
23397	35470	74	applied	\N	\N	\N	\N	179370	179370	346596
23397	35471	75	applied	\N	\N	\N	\N	179371	179371	346597
23397	35474	76	applied	\N	\N	\N	\N	179372	179372	346598
23397	35476	77	applied	\N	\N	\N	\N	179373	179373	346599
23397	35480	78	applied	\N	\N	\N	\N	179374	179374	346600
23397	35487	79	applied	\N	\N	\N	\N	179375	179375	346601
23397	35488	80	applied	\N	\N	\N	\N	179376	179376	346602
23397	35491	82	applied	\N	\N	\N	\N	179377	179377	346603
23397	35493	83	applied	\N	\N	\N	\N	179378	179378	346604
23397	35497	84	applied	\N	\N	\N	\N	179379	179379	346605
23397	35500	85	applied	\N	\N	\N	\N	179380	179380	346606
23397	35505	86	applied	\N	\N	\N	\N	179381	179381	346607
23397	35507	87	applied	\N	\N	\N	\N	179382	179382	346608
23397	35513	89	applied	\N	\N	\N	\N	179384	179384	346610
23397	35519	90	applied	\N	\N	\N	\N	179385	179385	346611
23397	35520	91	applied	\N	\N	\N	\N	179386	179386	346612
23397	35521	92	applied	\N	\N	\N	\N	179387	179387	346613
23397	35522	93	applied	\N	\N	\N	\N	179388	179388	346614
23397	35530	94	applied	\N	\N	\N	\N	179389	179389	346615
23397	35533	95	applied	\N	\N	\N	\N	179390	179390	346616
23397	35536	96	applied	\N	\N	\N	\N	179391	179391	346617
23397	35543	97	applied	\N	\N	\N	\N	179392	179392	346618
23398	35987	0	applied	\N	\N	\N	\N	179393	179393	346619
23398	35988	1	applied	\N	\N	\N	\N	179394	179394	346620
23400	35989	0	applied	\N	\N	\N	\N	179397	179397	346623
23400	35990	1	applied	\N	\N	\N	\N	179398	179398	346624
23401	35991	0	applied	\N	\N	\N	\N	179399	179399	346625
23401	35992	1	applied	\N	\N	\N	\N	179400	179400	346626
23403	35995	0	applied	\N	\N	\N	\N	179403	179403	346629
23404	35997	0	applied	\N	\N	\N	\N	179405	179405	346631
23404	35998	1	applied	\N	\N	\N	\N	179406	179406	346632
23404	35999	2	applied	\N	\N	\N	\N	179407	179407	346633
23404	36000	3	applied	\N	\N	\N	\N	179408	179408	346634
23404	36001	4	applied	\N	\N	\N	\N	179409	179409	346635
23404	36002	5	applied	\N	\N	\N	\N	179410	179410	346636
23404	36003	6	applied	\N	\N	\N	\N	179411	179411	346637
23404	36004	7	applied	\N	\N	\N	\N	179412	179412	346638
23405	35997	0	applied	\N	\N	\N	\N	179413	179413	346639
23405	35998	1	applied	\N	\N	\N	\N	179414	179414	346640
23405	35999	2	applied	\N	\N	\N	\N	179415	179415	346641
23405	36000	3	applied	\N	\N	\N	\N	179416	179416	346642
23405	36001	4	applied	\N	\N	\N	\N	179417	179417	346643
23405	36002	5	applied	\N	\N	\N	\N	179418	179418	346644
23405	36003	6	applied	\N	\N	\N	\N	179419	179419	346645
23405	36004	7	applied	\N	\N	\N	\N	179420	179420	346646
23407	36006	1	applied	\N	\N	\N	\N	179430	179430	346656
23407	36007	2	applied	\N	\N	\N	\N	179431	179431	346657
23407	36008	3	applied	\N	\N	\N	\N	179432	179432	346658
23409	36009	0	applied	\N	\N	\N	\N	179435	179435	346661
23409	36010	1	applied	\N	\N	\N	\N	179436	179436	346662
23413	36015	0	applied	\N	\N	\N	\N	179566	179566	346792
23413	36016	1	applied	\N	\N	\N	\N	179567	179567	346793
23413	36017	2	applied	\N	\N	\N	\N	179568	179568	346794
23413	36018	3	applied	\N	\N	\N	\N	179569	179569	346795
23414	36015	0	applied	\N	\N	\N	\N	179570	179570	346796
23414	36016	1	applied	\N	\N	\N	\N	179571	179571	346797
23414	36017	2	applied	\N	\N	\N	\N	179572	179572	346798
23414	36018	3	applied	\N	\N	\N	\N	179573	179573	346799
23417	36019	0	applied	\N	\N	\N	\N	179610	179610	346836
23418	36019	0	applied	\N	\N	\N	\N	179612	179612	346838
23418	36020	1	applied	\N	\N	\N	\N	179613	179613	346839
23420	36025	1	applied	\N	\N	\N	\N	179618	179618	346844
23423	36032	0	applied	\N	\N	\N	\N	179662	179662	346888
23431	36036	0	applied	\N	\N	\N	\N	179683	179683	346909
23431	36037	1	applied	\N	\N	\N	\N	179684	179684	346910
23432	36038	0	applied	\N	\N	\N	\N	179685	179685	346911
23432	36039	1	applied	\N	\N	\N	\N	179686	179686	346912
23435	36038	0	applied	\N	\N	\N	\N	179691	179691	346917
23435	36039	1	applied	\N	\N	\N	\N	179692	179692	346918
23439	36040	0	applied	\N	\N	\N	\N	179697	179697	346923
23439	36041	1	applied	\N	\N	\N	\N	179698	179698	346924
23451	36046	0	applied	\N	\N	\N	\N	179723	179723	346949
23451	36047	1	applied	\N	\N	\N	\N	179724	179724	346950
23454	36021	0	applied	\N	\N	\N	\N	179729	179729	346955
23454	35955	1	applied	\N	\N	\N	\N	179730	179730	346956
23454	35957	2	applied	\N	\N	\N	\N	179731	179731	346957
23454	35959	3	applied	\N	\N	\N	\N	179732	179732	346958
23454	35961	5	applied	\N	\N	\N	\N	179734	179734	346960
23454	35965	6	applied	\N	\N	\N	\N	179735	179735	346961
23454	35967	7	applied	\N	\N	\N	\N	179736	179736	346962
23454	35968	8	applied	\N	\N	\N	\N	179737	179737	346963
23454	35971	9	applied	\N	\N	\N	\N	179738	179738	346964
23454	35973	10	applied	\N	\N	\N	\N	179739	179739	346965
23454	35974	11	applied	\N	\N	\N	\N	179740	179740	346966
23454	35975	12	applied	\N	\N	\N	\N	179741	179741	346967
23454	35976	13	applied	\N	\N	\N	\N	179742	179742	346968
23454	35977	14	applied	\N	\N	\N	\N	179743	179743	346969
23454	35983	15	applied	\N	\N	\N	\N	179744	179744	346970
23454	35984	16	applied	\N	\N	\N	\N	179745	179745	346971
23454	35987	17	applied	\N	\N	\N	\N	179746	179746	346972
23454	35989	18	applied	\N	\N	\N	\N	179747	179747	346973
23383	35965	5	applied	\N	\N	\N	\N	179238	179238	346464
23383	35956	6	applied	\N	\N	\N	\N	179239	179239	346465
23410	35760	38	applied	\N	\N	\N	\N	179475	179475	346701
23410	35762	39	applied	\N	\N	\N	\N	179476	179476	346702
23410	35765	40	applied	\N	\N	\N	\N	179477	179477	346703
23410	35768	41	applied	\N	\N	\N	\N	179478	179478	346704
23410	35769	42	applied	\N	\N	\N	\N	179479	179479	346705
23410	35772	43	applied	\N	\N	\N	\N	179480	179480	346706
23410	35774	44	applied	\N	\N	\N	\N	179481	179481	346707
23410	35777	45	applied	\N	\N	\N	\N	179482	179482	346708
23410	35779	46	applied	\N	\N	\N	\N	179483	179483	346709
23410	35781	47	applied	\N	\N	\N	\N	179484	179484	346710
23410	35783	48	applied	\N	\N	\N	\N	179485	179485	346711
23410	35785	49	applied	\N	\N	\N	\N	179486	179486	346712
23410	35787	50	applied	\N	\N	\N	\N	179487	179487	346713
23410	35788	51	applied	\N	\N	\N	\N	179488	179488	346714
23410	35791	52	applied	\N	\N	\N	\N	179489	179489	346715
23410	35793	53	applied	\N	\N	\N	\N	179490	179490	346716
23410	35797	55	applied	\N	\N	\N	\N	179492	179492	346718
23410	35799	56	applied	\N	\N	\N	\N	179493	179493	346719
23410	35801	57	applied	\N	\N	\N	\N	179494	179494	346720
23410	35803	58	applied	\N	\N	\N	\N	179495	179495	346721
23410	35805	59	applied	\N	\N	\N	\N	179496	179496	346722
23410	35808	60	applied	\N	\N	\N	\N	179497	179497	346723
23410	35810	61	applied	\N	\N	\N	\N	179498	179498	346724
23410	35812	62	applied	\N	\N	\N	\N	179499	179499	346725
23410	35813	63	applied	\N	\N	\N	\N	179500	179500	346726
23410	35814	64	applied	\N	\N	\N	\N	179501	179501	346727
23410	35818	65	applied	\N	\N	\N	\N	179502	179502	346728
23410	35820	66	applied	\N	\N	\N	\N	179503	179503	346729
23410	35821	67	applied	\N	\N	\N	\N	179504	179504	346730
23410	35824	68	applied	\N	\N	\N	\N	179505	179505	346731
23410	35825	69	applied	\N	\N	\N	\N	179506	179506	346732
23410	35827	70	applied	\N	\N	\N	\N	179507	179507	346733
23410	35831	72	applied	\N	\N	\N	\N	179509	179509	346735
23410	35832	73	applied	\N	\N	\N	\N	179510	179510	346736
23410	35833	74	applied	\N	\N	\N	\N	179511	179511	346737
23410	35837	75	applied	\N	\N	\N	\N	179512	179512	346738
23410	35839	76	applied	\N	\N	\N	\N	179513	179513	346739
23410	35841	77	applied	\N	\N	\N	\N	179514	179514	346740
23410	35842	78	applied	\N	\N	\N	\N	179515	179515	346741
23410	35845	79	applied	\N	\N	\N	\N	179516	179516	346742
23410	35847	80	applied	\N	\N	\N	\N	179517	179517	346743
23410	35848	81	applied	\N	\N	\N	\N	179518	179518	346744
23410	35851	82	applied	\N	\N	\N	\N	179519	179519	346745
23410	35853	83	applied	\N	\N	\N	\N	179520	179520	346746
23410	35854	84	applied	\N	\N	\N	\N	179521	179521	346747
23410	35857	85	applied	\N	\N	\N	\N	179522	179522	346748
23410	35859	86	applied	\N	\N	\N	\N	179523	179523	346749
23410	35861	87	applied	\N	\N	\N	\N	179524	179524	346750
23410	35865	89	applied	\N	\N	\N	\N	179526	179526	346752
23410	35867	90	applied	\N	\N	\N	\N	179527	179527	346753
23410	35868	91	applied	\N	\N	\N	\N	179528	179528	346754
23410	35871	92	applied	\N	\N	\N	\N	179529	179529	346755
23410	35873	93	applied	\N	\N	\N	\N	179530	179530	346756
23410	35875	94	applied	\N	\N	\N	\N	179531	179531	346757
23410	35876	95	applied	\N	\N	\N	\N	179532	179532	346758
23410	35879	96	applied	\N	\N	\N	\N	179533	179533	346759
23410	35880	97	applied	\N	\N	\N	\N	179534	179534	346760
23410	35883	98	applied	\N	\N	\N	\N	179535	179535	346761
23410	35884	99	applied	\N	\N	\N	\N	179536	179536	346762
23410	35887	100	applied	\N	\N	\N	\N	179537	179537	346763
23410	35889	101	applied	\N	\N	\N	\N	179538	179538	346764
23410	35891	102	applied	\N	\N	\N	\N	179539	179539	346765
23410	35893	103	applied	\N	\N	\N	\N	179540	179540	346766
23410	35895	104	applied	\N	\N	\N	\N	179541	179541	346767
23410	35899	106	applied	\N	\N	\N	\N	179543	179543	346769
23410	35901	107	applied	\N	\N	\N	\N	179544	179544	346770
23410	35903	108	applied	\N	\N	\N	\N	179545	179545	346771
23410	35905	110	applied	\N	\N	\N	\N	179546	179546	346772
23410	35907	111	applied	\N	\N	\N	\N	179547	179547	346773
23410	35909	112	applied	\N	\N	\N	\N	179548	179548	346774
23410	35910	113	applied	\N	\N	\N	\N	179549	179549	346775
23410	35914	114	applied	\N	\N	\N	\N	179550	179550	346776
23410	35915	115	applied	\N	\N	\N	\N	179551	179551	346777
23410	35918	116	applied	\N	\N	\N	\N	179552	179552	346778
23410	35921	117	applied	\N	\N	\N	\N	179553	179553	346779
23410	35923	118	applied	\N	\N	\N	\N	179554	179554	346780
23410	35924	119	applied	\N	\N	\N	\N	179555	179555	346781
23410	35927	120	applied	\N	\N	\N	\N	179556	179556	346782
23410	35929	121	applied	\N	\N	\N	\N	179557	179557	346783
23454	35991	19	applied	\N	\N	\N	\N	179748	179748	346974
23454	35995	21	applied	\N	\N	\N	\N	179750	179750	346976
23454	35997	22	applied	\N	\N	\N	\N	179751	179751	346977
23454	35998	23	applied	\N	\N	\N	\N	179752	179752	346978
23454	35999	24	applied	\N	\N	\N	\N	179753	179753	346979
23454	36000	25	applied	\N	\N	\N	\N	179754	179754	346980
23454	36005	26	applied	\N	\N	\N	\N	179755	179755	346981
23454	36006	27	applied	\N	\N	\N	\N	179756	179756	346982
23454	36009	28	applied	\N	\N	\N	\N	179757	179757	346983
23454	36011	29	applied	\N	\N	\N	\N	179758	179758	346984
23454	36013	30	applied	\N	\N	\N	\N	179759	179759	346985
23454	36015	31	applied	\N	\N	\N	\N	179760	179760	346986
23454	36016	32	applied	\N	\N	\N	\N	179761	179761	346987
23454	36019	33	applied	\N	\N	\N	\N	179762	179762	346988
23454	36022	34	applied	\N	\N	\N	\N	179763	179763	346989
23454	36024	35	applied	\N	\N	\N	\N	179764	179764	346990
23454	36026	36	applied	\N	\N	\N	\N	179765	179765	346991
23454	36028	38	applied	\N	\N	\N	\N	179767	179767	346993
23454	36032	39	applied	\N	\N	\N	\N	179768	179768	346994
23454	36034	40	applied	\N	\N	\N	\N	179769	179769	346995
23454	36036	41	applied	\N	\N	\N	\N	179770	179770	346996
23454	36038	42	applied	\N	\N	\N	\N	179771	179771	346997
23454	36040	43	applied	\N	\N	\N	\N	179772	179772	346998
23454	36042	44	applied	\N	\N	\N	\N	179773	179773	346999
23454	36044	45	applied	\N	\N	\N	\N	179774	179774	347000
23454	36046	46	applied	\N	\N	\N	\N	179775	179775	347001
23454	36048	47	applied	\N	\N	\N	\N	179776	179776	347002
23454	35956	48	applied	\N	\N	\N	\N	179777	179777	347003
23454	35958	49	applied	\N	\N	\N	\N	179778	179778	347004
23454	35962	50	applied	\N	\N	\N	\N	179779	179779	347005
23454	35963	51	applied	\N	\N	\N	\N	179780	179780	347006
23410	35753	35	applied	\N	\N	\N	\N	179472	179472	346698
23410	35755	36	applied	\N	\N	\N	\N	179473	179473	346699
23412	36013	0	applied	\N	\N	\N	\N	179564	179564	346790
23412	36014	2	applied	\N	\N	\N	\N	179565	179565	346791
23416	35987	0	applied	\N	\N	\N	\N	179578	179578	346804
23416	35989	1	applied	\N	\N	\N	\N	179579	179579	346805
23416	35991	2	applied	\N	\N	\N	\N	179580	179580	346806
23416	35993	3	applied	\N	\N	\N	\N	179581	179581	346807
23416	35995	4	applied	\N	\N	\N	\N	179582	179582	346808
23416	35997	5	applied	\N	\N	\N	\N	179583	179583	346809
23416	35998	6	applied	\N	\N	\N	\N	179584	179584	346810
23416	35999	7	applied	\N	\N	\N	\N	179585	179585	346811
23416	36000	8	applied	\N	\N	\N	\N	179586	179586	346812
23416	36005	9	applied	\N	\N	\N	\N	179587	179587	346813
23416	36006	10	applied	\N	\N	\N	\N	179588	179588	346814
23416	36009	11	applied	\N	\N	\N	\N	179589	179589	346815
23416	36011	12	applied	\N	\N	\N	\N	179590	179590	346816
23416	36013	13	applied	\N	\N	\N	\N	179591	179591	346817
23416	36016	15	applied	\N	\N	\N	\N	179593	179593	346819
23416	35988	16	applied	\N	\N	\N	\N	179594	179594	346820
23416	35990	17	applied	\N	\N	\N	\N	179595	179595	346821
23416	35992	18	applied	\N	\N	\N	\N	179596	179596	346822
23416	35994	19	applied	\N	\N	\N	\N	179597	179597	346823
23416	35996	20	applied	\N	\N	\N	\N	179598	179598	346824
23416	36001	21	applied	\N	\N	\N	\N	179599	179599	346825
23416	36002	22	applied	\N	\N	\N	\N	179600	179600	346826
23416	36003	23	applied	\N	\N	\N	\N	179601	179601	346827
23416	36004	24	applied	\N	\N	\N	\N	179602	179602	346828
23416	36007	25	applied	\N	\N	\N	\N	179603	179603	346829
23416	36008	26	applied	\N	\N	\N	\N	179604	179604	346830
23416	36010	27	applied	\N	\N	\N	\N	179605	179605	346831
23416	36012	28	applied	\N	\N	\N	\N	179606	179606	346832
23416	36014	29	applied	\N	\N	\N	\N	179607	179607	346833
23416	36017	30	applied	\N	\N	\N	\N	179608	179608	346834
23419	36021	0	applied	\N	\N	\N	\N	179614	179614	346840
23419	36022	1	applied	\N	\N	\N	\N	179615	179615	346841
23419	36023	2	applied	\N	\N	\N	\N	179616	179616	346842
23422	36026	0	applied	\N	\N	\N	\N	179656	179656	346882
23422	36027	1	applied	\N	\N	\N	\N	179657	179657	346883
23422	36028	2	applied	\N	\N	\N	\N	179658	179658	346884
23422	36029	3	applied	\N	\N	\N	\N	179659	179659	346885
23422	36030	4	applied	\N	\N	\N	\N	179660	179660	346886
23422	36031	5	applied	\N	\N	\N	\N	179661	179661	346887
23425	36032	0	applied	\N	\N	\N	\N	179671	179671	346897
23425	36033	1	applied	\N	\N	\N	\N	179672	179672	346898
23429	36036	0	applied	\N	\N	\N	\N	179679	179679	346905
23429	36037	1	applied	\N	\N	\N	\N	179680	179680	346906
23434	36038	0	applied	\N	\N	\N	\N	179689	179689	346915
23434	36039	1	applied	\N	\N	\N	\N	179690	179690	346916
23436	36038	0	applied	\N	\N	\N	\N	179693	179693	346919
23437	36040	0	applied	\N	\N	\N	\N	179695	179695	346921
23437	36041	1	applied	\N	\N	\N	\N	179696	179696	346922
23441	36040	0	applied	\N	\N	\N	\N	179701	179701	346927
23441	36041	1	applied	\N	\N	\N	\N	179702	179702	346928
23444	36040	0	applied	\N	\N	\N	\N	179705	179705	346931
23444	36041	1	applied	\N	\N	\N	\N	179706	179706	346932
23448	36042	0	applied	\N	\N	\N	\N	179709	179709	346935
23448	36043	1	applied	\N	\N	\N	\N	179710	179710	346936
23452	36048	0	applied	\N	\N	\N	\N	179725	179725	346951
23452	36049	1	applied	\N	\N	\N	\N	179726	179726	346952
23457	36053	0	applied	\N	\N	\N	\N	179830	179830	347056
23457	36054	1	applied	\N	\N	\N	\N	179831	179831	347057
23457	36055	2	applied	\N	\N	\N	\N	179832	179832	347058
23465	36071	0	applied	\N	\N	\N	\N	179969	179969	347195
23465	36072	1	applied	\N	\N	\N	\N	179970	179970	347196
23465	36073	2	applied	\N	\N	\N	\N	179971	179971	347197
23468	36075	0	applied	\N	\N	\N	\N	179980	179980	347206
23468	36076	1	applied	\N	\N	\N	\N	179981	179981	347207
23468	36077	2	applied	\N	\N	\N	\N	179982	179982	347208
23470	36081	0	applied	\N	\N	\N	\N	179986	179986	347212
23470	36082	1	applied	\N	\N	\N	\N	179987	179987	347213
23470	36083	2	applied	\N	\N	\N	\N	179988	179988	347214
23470	36084	3	applied	\N	\N	\N	\N	179989	179989	347215
23475	36088	0	applied	\N	\N	\N	\N	180004	180004	347230
23475	36089	1	applied	\N	\N	\N	\N	180005	180005	347231
23475	36090	2	applied	\N	\N	\N	\N	180006	180006	347232
23484	36107	0	applied	\N	\N	\N	\N	180033	180033	347259
23484	36108	1	applied	\N	\N	\N	\N	180034	180034	347260
23484	36109	2	applied	\N	\N	\N	\N	180035	180035	347261
23484	36110	3	applied	\N	\N	\N	\N	180036	180036	347262
23484	36111	4	applied	\N	\N	\N	\N	180037	180037	347263
23484	36112	5	applied	\N	\N	\N	\N	180038	180038	347264
23491	36118	1	applied	\N	\N	\N	\N	180053	180053	347279
23491	36119	2	applied	\N	\N	\N	\N	180054	180054	347280
23493	36120	0	applied	\N	\N	\N	\N	180058	180058	347284
23493	36121	1	applied	\N	\N	\N	\N	180059	180059	347285
23493	36122	2	applied	\N	\N	\N	\N	180060	180060	347286
23493	36123	3	applied	\N	\N	\N	\N	180061	180061	347287
23493	36124	4	applied	\N	\N	\N	\N	180062	180062	347288
23493	36125	5	applied	\N	\N	\N	\N	180063	180063	347289
23496	36126	0	applied	\N	\N	\N	\N	180074	180074	347300
23496	36127	1	applied	\N	\N	\N	\N	180075	180075	347301
23496	36128	2	applied	\N	\N	\N	\N	180076	180076	347302
23496	36129	3	applied	\N	\N	\N	\N	180077	180077	347303
23501	36130	0	applied	\N	\N	\N	\N	180103	180103	347329
23501	36131	1	applied	\N	\N	\N	\N	180104	180104	347330
23501	36132	2	applied	\N	\N	\N	\N	180105	180105	347331
23504	36140	0	applied	\N	\N	\N	\N	180120	180120	347346
23504	36142	2	applied	\N	\N	\N	\N	180122	180122	347348
23508	36143	0	applied	\N	\N	\N	\N	180132	180132	347358
23508	36144	1	applied	\N	\N	\N	\N	180133	180133	347359
23508	36145	2	applied	\N	\N	\N	\N	180134	180134	347360
23511	36146	0	applied	\N	\N	\N	\N	180142	180142	347368
23511	36147	1	applied	\N	\N	\N	\N	180143	180143	347369
23511	36148	2	applied	\N	\N	\N	\N	180144	180144	347370
23511	36149	3	applied	\N	\N	\N	\N	180145	180145	347371
23517	36155	0	applied	\N	\N	\N	\N	180161	180161	347387
23517	36156	3	applied	\N	\N	\N	\N	180164	180164	347390
23517	36157	4	applied	\N	\N	\N	\N	180165	180165	347391
23520	36158	0	applied	\N	\N	\N	\N	180175	180175	347401
23410	35933	123	applied	\N	\N	\N	\N	179559	179559	346785
23410	35935	124	applied	\N	\N	\N	\N	179560	179560	346786
23430	36037	1	applied	\N	\N	\N	\N	179682	179682	346908
23442	36040	0	applied	\N	\N	\N	\N	179703	179703	346929
23442	36041	1	applied	\N	\N	\N	\N	179704	179704	346930
23450	36026	0	applied	\N	\N	\N	\N	179713	179713	346939
23450	36027	1	applied	\N	\N	\N	\N	179714	179714	346940
23450	36028	3	applied	\N	\N	\N	\N	179715	179715	346941
23450	36032	4	applied	\N	\N	\N	\N	179716	179716	346942
23450	36034	5	applied	\N	\N	\N	\N	179717	179717	346943
23450	36036	6	applied	\N	\N	\N	\N	179718	179718	346944
23450	36038	7	applied	\N	\N	\N	\N	179719	179719	346945
23450	36040	8	applied	\N	\N	\N	\N	179720	179720	346946
23450	36042	9	applied	\N	\N	\N	\N	179721	179721	346947
23450	36044	10	applied	\N	\N	\N	\N	179722	179722	346948
23453	36048	0	applied	\N	\N	\N	\N	179727	179727	346953
23453	36049	1	applied	\N	\N	\N	\N	179728	179728	346954
23455	36050	0	applied	\N	\N	\N	\N	179824	179824	347050
23455	36052	2	applied	\N	\N	\N	\N	179826	179826	347052
23458	36053	0	applied	\N	\N	\N	\N	179833	179833	347059
23458	36054	1	applied	\N	\N	\N	\N	179834	179834	347060
23458	36055	2	applied	\N	\N	\N	\N	179835	179835	347061
23461	36053	0	applied	\N	\N	\N	\N	179839	179839	347065
23461	36054	1	applied	\N	\N	\N	\N	179840	179840	347066
23461	36055	2	applied	\N	\N	\N	\N	179841	179841	347067
23462	35939	0	applied	\N	\N	\N	\N	179842	179842	347068
23462	35941	1	applied	\N	\N	\N	\N	179843	179843	347069
23462	35943	2	applied	\N	\N	\N	\N	179844	179844	347070
23462	35944	3	applied	\N	\N	\N	\N	179845	179845	347071
23462	35947	4	applied	\N	\N	\N	\N	179846	179846	347072
23462	35948	5	applied	\N	\N	\N	\N	179847	179847	347073
23462	35951	6	applied	\N	\N	\N	\N	179848	179848	347074
23462	35952	7	applied	\N	\N	\N	\N	179849	179849	347075
23462	35955	8	applied	\N	\N	\N	\N	179850	179850	347076
23462	35959	10	applied	\N	\N	\N	\N	179852	179852	347078
23462	35960	11	applied	\N	\N	\N	\N	179853	179853	347079
23462	35961	12	applied	\N	\N	\N	\N	179854	179854	347080
23462	35965	13	applied	\N	\N	\N	\N	179855	179855	347081
23462	35967	14	applied	\N	\N	\N	\N	179856	179856	347082
23462	35968	15	applied	\N	\N	\N	\N	179857	179857	347083
23462	35971	16	applied	\N	\N	\N	\N	179858	179858	347084
23462	35973	17	applied	\N	\N	\N	\N	179859	179859	347085
23462	35974	18	applied	\N	\N	\N	\N	179860	179860	347086
23462	35975	19	applied	\N	\N	\N	\N	179861	179861	347087
23462	35976	20	applied	\N	\N	\N	\N	179862	179862	347088
23462	35977	21	applied	\N	\N	\N	\N	179863	179863	347089
23462	35983	22	applied	\N	\N	\N	\N	179864	179864	347090
23462	35984	23	applied	\N	\N	\N	\N	179865	179865	347091
23462	35987	24	applied	\N	\N	\N	\N	179866	179866	347092
23462	35989	25	applied	\N	\N	\N	\N	179867	179867	347093
23462	35993	27	applied	\N	\N	\N	\N	179869	179869	347095
23462	35995	28	applied	\N	\N	\N	\N	179870	179870	347096
23462	35997	29	applied	\N	\N	\N	\N	179871	179871	347097
23462	35998	30	applied	\N	\N	\N	\N	179872	179872	347098
23462	35999	31	applied	\N	\N	\N	\N	179873	179873	347099
23462	36000	32	applied	\N	\N	\N	\N	179874	179874	347100
23462	36005	33	applied	\N	\N	\N	\N	179875	179875	347101
23462	36006	34	applied	\N	\N	\N	\N	179876	179876	347102
23462	36009	35	applied	\N	\N	\N	\N	179877	179877	347103
23462	36011	36	applied	\N	\N	\N	\N	179878	179878	347104
23462	36013	37	applied	\N	\N	\N	\N	179879	179879	347105
23462	36015	38	applied	\N	\N	\N	\N	179880	179880	347106
23462	36016	39	applied	\N	\N	\N	\N	179881	179881	347107
23462	36019	40	applied	\N	\N	\N	\N	179882	179882	347108
23462	36022	41	applied	\N	\N	\N	\N	179883	179883	347109
23462	36024	42	applied	\N	\N	\N	\N	179884	179884	347110
23462	36027	44	applied	\N	\N	\N	\N	179886	179886	347112
23462	36028	45	applied	\N	\N	\N	\N	179887	179887	347113
23462	36032	46	applied	\N	\N	\N	\N	179888	179888	347114
23462	36034	47	applied	\N	\N	\N	\N	179889	179889	347115
23462	36036	48	applied	\N	\N	\N	\N	179890	179890	347116
23462	36038	49	applied	\N	\N	\N	\N	179891	179891	347117
23462	36040	50	applied	\N	\N	\N	\N	179892	179892	347118
23462	36042	51	applied	\N	\N	\N	\N	179893	179893	347119
23462	36044	52	applied	\N	\N	\N	\N	179894	179894	347120
23462	36046	53	applied	\N	\N	\N	\N	179895	179895	347121
23462	36048	54	applied	\N	\N	\N	\N	179896	179896	347122
23462	36050	55	applied	\N	\N	\N	\N	179897	179897	347123
23462	36053	56	applied	\N	\N	\N	\N	179898	179898	347124
23462	36051	57	applied	\N	\N	\N	\N	179899	179899	347125
23462	36054	58	applied	\N	\N	\N	\N	179900	179900	347126
23520	36154	1	applied	\N	\N	\N	\N	180176	180176	347402
23524	36172	0	applied	\N	\N	\N	\N	180264	180264	347490
23524	36173	1	applied	\N	\N	\N	\N	180265	180265	347491
23524	36174	2	applied	\N	\N	\N	\N	180266	180266	347492
23532	36196	0	applied	\N	\N	\N	\N	180307	180307	347533
23532	36197	1	applied	\N	\N	\N	\N	180308	180308	347534
23532	36198	2	applied	\N	\N	\N	\N	180309	180309	347535
23532	36199	3	applied	\N	\N	\N	\N	180310	180310	347536
23534	36200	0	applied	\N	\N	\N	\N	180314	180314	347540
23534	36201	1	applied	\N	\N	\N	\N	180315	180315	347541
23534	36202	2	applied	\N	\N	\N	\N	180316	180316	347542
23536	36205	0	applied	\N	\N	\N	\N	180324	180324	347550
23536	36204	2	applied	\N	\N	\N	\N	180326	180326	347552
23536	36206	3	applied	\N	\N	\N	\N	180327	180327	347553
23536	36207	4	applied	\N	\N	\N	\N	180328	180328	347554
23536	36208	5	applied	\N	\N	\N	\N	180329	180329	347555
23536	36209	6	applied	\N	\N	\N	\N	180330	180330	347556
23536	36210	7	applied	\N	\N	\N	\N	180331	180331	347557
23536	36211	8	applied	\N	\N	\N	\N	180332	180332	347558
23537	36212	0	applied	\N	\N	\N	\N	180333	180333	347559
23537	36213	1	applied	\N	\N	\N	\N	180334	180334	347560
23537	36214	2	applied	\N	\N	\N	\N	180335	180335	347561
23537	36215	3	applied	\N	\N	\N	\N	180336	180336	347562
23537	36216	4	applied	\N	\N	\N	\N	180337	180337	347563
23537	36217	5	applied	\N	\N	\N	\N	180338	180338	347564
23537	36218	6	applied	\N	\N	\N	\N	180339	180339	347565
23427	36034	0	applied	\N	\N	\N	\N	179675	179675	346901
23427	36035	1	applied	\N	\N	\N	\N	179676	179676	346902
23421	36005	9	applied	\N	\N	\N	\N	179628	179628	346854
23421	36006	10	applied	\N	\N	\N	\N	179629	179629	346855
23421	36009	11	applied	\N	\N	\N	\N	179630	179630	346856
23421	36011	12	applied	\N	\N	\N	\N	179631	179631	346857
23421	36013	13	applied	\N	\N	\N	\N	179632	179632	346858
23421	36015	14	applied	\N	\N	\N	\N	179633	179633	346859
23421	36016	15	applied	\N	\N	\N	\N	179634	179634	346860
23421	36019	16	applied	\N	\N	\N	\N	179635	179635	346861
23421	36022	17	applied	\N	\N	\N	\N	179636	179636	346862
23421	36024	18	applied	\N	\N	\N	\N	179637	179637	346863
23421	35990	19	applied	\N	\N	\N	\N	179638	179638	346864
23421	35992	20	applied	\N	\N	\N	\N	179639	179639	346865
23421	35994	21	applied	\N	\N	\N	\N	179640	179640	346866
23421	35996	22	applied	\N	\N	\N	\N	179641	179641	346867
23421	36001	23	applied	\N	\N	\N	\N	179642	179642	346868
23421	36002	24	applied	\N	\N	\N	\N	179643	179643	346869
23421	36004	26	applied	\N	\N	\N	\N	179645	179645	346871
23421	36007	27	applied	\N	\N	\N	\N	179646	179646	346872
23421	36008	28	applied	\N	\N	\N	\N	179647	179647	346873
23421	36010	29	applied	\N	\N	\N	\N	179648	179648	346874
23421	36012	30	applied	\N	\N	\N	\N	179649	179649	346875
23421	36014	31	applied	\N	\N	\N	\N	179650	179650	346876
23421	36017	32	applied	\N	\N	\N	\N	179651	179651	346877
23421	36018	33	applied	\N	\N	\N	\N	179652	179652	346878
23421	36020	34	applied	\N	\N	\N	\N	179653	179653	346879
23421	36023	35	applied	\N	\N	\N	\N	179654	179654	346880
23421	36025	36	applied	\N	\N	\N	\N	179655	179655	346881
23424	36026	0	applied	\N	\N	\N	\N	179663	179663	346889
23424	36027	1	applied	\N	\N	\N	\N	179664	179664	346890
23424	36028	2	applied	\N	\N	\N	\N	179665	179665	346891
23424	36032	3	applied	\N	\N	\N	\N	179666	179666	346892
23424	36029	4	applied	\N	\N	\N	\N	179667	179667	346893
23424	36031	6	applied	\N	\N	\N	\N	179669	179669	346895
23424	36033	7	applied	\N	\N	\N	\N	179670	179670	346896
23426	36032	0	applied	\N	\N	\N	\N	179673	179673	346899
23426	36033	1	applied	\N	\N	\N	\N	179674	179674	346900
23428	36036	0	applied	\N	\N	\N	\N	179677	179677	346903
23428	36037	1	applied	\N	\N	\N	\N	179678	179678	346904
23433	36038	0	applied	\N	\N	\N	\N	179687	179687	346913
23433	36039	1	applied	\N	\N	\N	\N	179688	179688	346914
23440	36040	0	applied	\N	\N	\N	\N	179699	179699	346925
23440	36041	1	applied	\N	\N	\N	\N	179700	179700	346926
23447	36042	0	applied	\N	\N	\N	\N	179707	179707	346933
23447	36043	1	applied	\N	\N	\N	\N	179708	179708	346934
23449	36044	0	applied	\N	\N	\N	\N	179711	179711	346937
23449	36045	1	applied	\N	\N	\N	\N	179712	179712	346938
23456	36053	0	applied	\N	\N	\N	\N	179827	179827	347053
23456	36054	1	applied	\N	\N	\N	\N	179828	179828	347054
23462	35681	59	applied	\N	\N	\N	\N	179901	179901	347127
23462	35684	60	applied	\N	\N	\N	\N	179902	179902	347128
23462	35691	61	applied	\N	\N	\N	\N	179903	179903	347129
23462	35702	62	applied	\N	\N	\N	\N	179904	179904	347130
23462	35685	63	applied	\N	\N	\N	\N	179905	179905	347131
23462	35707	64	applied	\N	\N	\N	\N	179906	179906	347132
23462	35806	65	applied	\N	\N	\N	\N	179907	179907	347133
23462	36021	66	applied	\N	\N	\N	\N	179908	179908	347134
23462	35686	67	applied	\N	\N	\N	\N	179909	179909	347135
23462	35688	68	applied	\N	\N	\N	\N	179910	179910	347136
23462	35716	69	applied	\N	\N	\N	\N	179911	179911	347137
23462	35692	70	applied	\N	\N	\N	\N	179912	179912	347138
23462	35693	71	applied	\N	\N	\N	\N	179913	179913	347139
23462	35696	72	applied	\N	\N	\N	\N	179914	179914	347140
23462	35697	73	applied	\N	\N	\N	\N	179915	179915	347141
23462	35699	74	applied	\N	\N	\N	\N	179916	179916	347142
23462	35704	76	applied	\N	\N	\N	\N	179918	179918	347144
23462	35708	77	applied	\N	\N	\N	\N	179919	179919	347145
23462	35709	78	applied	\N	\N	\N	\N	179920	179920	347146
23462	35711	79	applied	\N	\N	\N	\N	179921	179921	347147
23462	35713	80	applied	\N	\N	\N	\N	179922	179922	347148
23462	35721	81	applied	\N	\N	\N	\N	179923	179923	347149
23462	35722	82	applied	\N	\N	\N	\N	179924	179924	347150
23462	35723	83	applied	\N	\N	\N	\N	179925	179925	347151
23462	35724	84	applied	\N	\N	\N	\N	179926	179926	347152
23462	35725	85	applied	\N	\N	\N	\N	179927	179927	347153
23462	35727	86	applied	\N	\N	\N	\N	179928	179928	347154
23462	35731	87	applied	\N	\N	\N	\N	179929	179929	347155
23462	35732	88	applied	\N	\N	\N	\N	179930	179930	347156
23462	35734	89	applied	\N	\N	\N	\N	179931	179931	347157
23462	35736	90	applied	\N	\N	\N	\N	179932	179932	347158
23462	35739	91	applied	\N	\N	\N	\N	179933	179933	347159
23467	36076	1	applied	\N	\N	\N	\N	179978	179978	347204
23467	36077	2	applied	\N	\N	\N	\N	179979	179979	347205
23469	36078	0	applied	\N	\N	\N	\N	179983	179983	347209
23469	36079	1	applied	\N	\N	\N	\N	179984	179984	347210
23469	36080	2	applied	\N	\N	\N	\N	179985	179985	347211
23474	36088	0	applied	\N	\N	\N	\N	180001	180001	347227
23474	36089	1	applied	\N	\N	\N	\N	180002	180002	347228
23474	36090	2	applied	\N	\N	\N	\N	180003	180003	347229
23479	36021	0	applied	\N	\N	\N	\N	180013	180013	347239
23481	36101	0	applied	\N	\N	\N	\N	180024	180024	347250
23481	36102	1	applied	\N	\N	\N	\N	180025	180025	347251
23481	36103	2	applied	\N	\N	\N	\N	180026	180026	347252
23485	36107	0	applied	\N	\N	\N	\N	180039	180039	347265
23485	36108	1	applied	\N	\N	\N	\N	180040	180040	347266
23485	36109	2	applied	\N	\N	\N	\N	180041	180041	347267
23485	36110	3	applied	\N	\N	\N	\N	180042	180042	347268
23485	36112	5	applied	\N	\N	\N	\N	180044	180044	347270
23487	36113	0	applied	\N	\N	\N	\N	180045	180045	347271
23487	36114	1	applied	\N	\N	\N	\N	180046	180046	347272
23487	36115	2	applied	\N	\N	\N	\N	180047	180047	347273
23487	36116	3	applied	\N	\N	\N	\N	180048	180048	347274
23492	36117	0	applied	\N	\N	\N	\N	180055	180055	347281
23492	36118	1	applied	\N	\N	\N	\N	180056	180056	347282
23492	36119	2	applied	\N	\N	\N	\N	180057	180057	347283
23494	36120	0	applied	\N	\N	\N	\N	180064	180064	347290
23494	36121	1	applied	\N	\N	\N	\N	180065	180065	347291
23494	36122	2	applied	\N	\N	\N	\N	180066	180066	347292
23494	36123	3	applied	\N	\N	\N	\N	180067	180067	347293
23494	36124	4	applied	\N	\N	\N	\N	180068	180068	347294
23494	36125	5	applied	\N	\N	\N	\N	180069	180069	347295
23421	35998	6	applied	\N	\N	\N	\N	179625	179625	346851
23421	35999	7	applied	\N	\N	\N	\N	179626	179626	346852
23454	35972	56	applied	\N	\N	\N	\N	179785	179785	347011
23454	35978	57	applied	\N	\N	\N	\N	179786	179786	347012
23454	35979	58	applied	\N	\N	\N	\N	179787	179787	347013
23454	35980	59	applied	\N	\N	\N	\N	179788	179788	347014
23454	35981	60	applied	\N	\N	\N	\N	179789	179789	347015
23454	35982	61	applied	\N	\N	\N	\N	179790	179790	347016
23454	35985	62	applied	\N	\N	\N	\N	179791	179791	347017
23454	35986	63	applied	\N	\N	\N	\N	179792	179792	347018
23454	35988	64	applied	\N	\N	\N	\N	179793	179793	347019
23454	35990	65	applied	\N	\N	\N	\N	179794	179794	347020
23454	35992	66	applied	\N	\N	\N	\N	179795	179795	347021
23454	35994	67	applied	\N	\N	\N	\N	179796	179796	347022
23454	35996	68	applied	\N	\N	\N	\N	179797	179797	347023
23454	36001	69	applied	\N	\N	\N	\N	179798	179798	347024
23454	36002	70	applied	\N	\N	\N	\N	179799	179799	347025
23454	36003	71	applied	\N	\N	\N	\N	179800	179800	347026
23454	36007	73	applied	\N	\N	\N	\N	179802	179802	347028
23454	36008	74	applied	\N	\N	\N	\N	179803	179803	347029
23454	36010	75	applied	\N	\N	\N	\N	179804	179804	347030
23454	36012	76	applied	\N	\N	\N	\N	179805	179805	347031
23454	36014	77	applied	\N	\N	\N	\N	179806	179806	347032
23454	36017	78	applied	\N	\N	\N	\N	179807	179807	347033
23454	36018	79	applied	\N	\N	\N	\N	179808	179808	347034
23454	36020	80	applied	\N	\N	\N	\N	179809	179809	347035
23454	36023	81	applied	\N	\N	\N	\N	179810	179810	347036
23454	36025	82	applied	\N	\N	\N	\N	179811	179811	347037
23454	36029	83	applied	\N	\N	\N	\N	179812	179812	347038
23454	36030	84	applied	\N	\N	\N	\N	179813	179813	347039
23454	36031	85	applied	\N	\N	\N	\N	179814	179814	347040
23454	36033	86	applied	\N	\N	\N	\N	179815	179815	347041
23454	36035	87	applied	\N	\N	\N	\N	179816	179816	347042
23454	36037	88	applied	\N	\N	\N	\N	179817	179817	347043
23454	36041	90	applied	\N	\N	\N	\N	179819	179819	347045
23454	36043	91	applied	\N	\N	\N	\N	179820	179820	347046
23454	36045	92	applied	\N	\N	\N	\N	179821	179821	347047
23454	36047	93	applied	\N	\N	\N	\N	179822	179822	347048
23454	36049	94	applied	\N	\N	\N	\N	179823	179823	347049
23459	36053	0	applied	\N	\N	\N	\N	179836	179836	347062
23459	36054	1	applied	\N	\N	\N	\N	179837	179837	347063
23459	36055	2	applied	\N	\N	\N	\N	179838	179838	347064
23464	36065	0	applied	\N	\N	\N	\N	179963	179963	347189
23464	36066	1	applied	\N	\N	\N	\N	179964	179964	347190
23464	36067	2	applied	\N	\N	\N	\N	179965	179965	347191
23464	36068	3	applied	\N	\N	\N	\N	179966	179966	347192
23464	36069	4	applied	\N	\N	\N	\N	179967	179967	347193
23464	36070	5	applied	\N	\N	\N	\N	179968	179968	347194
23472	36081	0	applied	\N	\N	\N	\N	179994	179994	347220
23472	36082	1	applied	\N	\N	\N	\N	179995	179995	347221
23472	36084	3	applied	\N	\N	\N	\N	179997	179997	347223
23473	36085	0	applied	\N	\N	\N	\N	179998	179998	347224
23473	36086	1	applied	\N	\N	\N	\N	179999	179999	347225
23473	36087	2	applied	\N	\N	\N	\N	180000	180000	347226
23477	36088	0	applied	\N	\N	\N	\N	180010	180010	347236
23477	36089	1	applied	\N	\N	\N	\N	180011	180011	347237
23477	36090	2	applied	\N	\N	\N	\N	180012	180012	347238
23480	36091	0	applied	\N	\N	\N	\N	180014	180014	347240
23480	36092	1	applied	\N	\N	\N	\N	180015	180015	347241
23480	36093	2	applied	\N	\N	\N	\N	180016	180016	347242
23480	36094	3	applied	\N	\N	\N	\N	180017	180017	347243
23480	36095	4	applied	\N	\N	\N	\N	180018	180018	347244
23480	36096	5	applied	\N	\N	\N	\N	180019	180019	347245
23480	36097	6	applied	\N	\N	\N	\N	180020	180020	347246
23480	36098	7	applied	\N	\N	\N	\N	180021	180021	347247
23480	36099	8	applied	\N	\N	\N	\N	180022	180022	347248
23483	36104	0	applied	\N	\N	\N	\N	180030	180030	347256
23483	36105	1	applied	\N	\N	\N	\N	180031	180031	347257
23483	36106	2	applied	\N	\N	\N	\N	180032	180032	347258
23497	36126	0	applied	\N	\N	\N	\N	180078	180078	347304
23497	36127	1	applied	\N	\N	\N	\N	180079	180079	347305
23497	36128	2	applied	\N	\N	\N	\N	180080	180080	347306
23497	36129	3	applied	\N	\N	\N	\N	180081	180081	347307
23499	36021	0	applied	\N	\N	\N	\N	180086	180086	347312
23499	36051	1	applied	\N	\N	\N	\N	180087	180087	347313
23499	36054	2	applied	\N	\N	\N	\N	180088	180088	347314
23499	36061	3	applied	\N	\N	\N	\N	180089	180089	347315
23499	36062	4	applied	\N	\N	\N	\N	180090	180090	347316
23499	36064	5	applied	\N	\N	\N	\N	180091	180091	347317
23499	36069	6	applied	\N	\N	\N	\N	180092	180092	347318
23499	36070	7	applied	\N	\N	\N	\N	180093	180093	347319
23499	36073	8	applied	\N	\N	\N	\N	180094	180094	347320
23499	36080	10	applied	\N	\N	\N	\N	180096	180096	347322
23499	36083	11	applied	\N	\N	\N	\N	180097	180097	347323
23502	36133	0	applied	\N	\N	\N	\N	180106	180106	347332
23502	36134	1	applied	\N	\N	\N	\N	180107	180107	347333
23502	36135	2	applied	\N	\N	\N	\N	180108	180108	347334
23502	36136	3	applied	\N	\N	\N	\N	180109	180109	347335
23502	36137	4	applied	\N	\N	\N	\N	180110	180110	347336
23502	36138	5	applied	\N	\N	\N	\N	180111	180111	347337
23502	36139	6	applied	\N	\N	\N	\N	180112	180112	347338
23505	36140	0	applied	\N	\N	\N	\N	180123	180123	347349
23505	36141	1	applied	\N	\N	\N	\N	180124	180124	347350
23505	36142	2	applied	\N	\N	\N	\N	180125	180125	347351
23509	36143	0	applied	\N	\N	\N	\N	180135	180135	347361
23509	36144	1	applied	\N	\N	\N	\N	180136	180136	347362
23509	36145	2	applied	\N	\N	\N	\N	180137	180137	347363
23513	36150	0	applied	\N	\N	\N	\N	180150	180150	347376
23538	36212	0	applied	\N	\N	\N	\N	180343	180343	347569
23538	36213	1	applied	\N	\N	\N	\N	180344	180344	347570
23538	36214	2	applied	\N	\N	\N	\N	180345	180345	347571
23538	36215	3	applied	\N	\N	\N	\N	180346	180346	347572
23538	36216	4	applied	\N	\N	\N	\N	180347	180347	347573
23538	36217	5	applied	\N	\N	\N	\N	180348	180348	347574
23538	36218	6	applied	\N	\N	\N	\N	180349	180349	347575
23538	36219	7	applied	\N	\N	\N	\N	180350	180350	347576
23538	36220	8	applied	\N	\N	\N	\N	180351	180351	347577
23538	36221	9	applied	\N	\N	\N	\N	180352	180352	347578
23540	36222	0	applied	\N	\N	\N	\N	180356	180356	347582
23540	36223	1	applied	\N	\N	\N	\N	180357	180357	347583
23540	36224	2	applied	\N	\N	\N	\N	180358	180358	347584
23542	36222	0	applied	\N	\N	\N	\N	180362	180362	347588
23454	35966	53	applied	\N	\N	\N	\N	179782	179782	347008
23454	35969	54	applied	\N	\N	\N	\N	179783	179783	347009
23462	35751	96	applied	\N	\N	\N	\N	179938	179938	347164
23462	35752	97	applied	\N	\N	\N	\N	179939	179939	347165
23462	35754	98	applied	\N	\N	\N	\N	179940	179940	347166
23462	35756	99	applied	\N	\N	\N	\N	179941	179941	347167
23462	35759	100	applied	\N	\N	\N	\N	179942	179942	347168
23462	35761	101	applied	\N	\N	\N	\N	179943	179943	347169
23462	35763	102	applied	\N	\N	\N	\N	179944	179944	347170
23462	35766	103	applied	\N	\N	\N	\N	179945	179945	347171
23462	35770	104	applied	\N	\N	\N	\N	179946	179946	347172
23462	35771	105	applied	\N	\N	\N	\N	179947	179947	347173
23462	35773	106	applied	\N	\N	\N	\N	179948	179948	347174
23462	35775	107	applied	\N	\N	\N	\N	179949	179949	347175
23462	35776	110	applied	\N	\N	\N	\N	179950	179950	347176
23462	35778	111	applied	\N	\N	\N	\N	179951	179951	347177
23462	35780	112	applied	\N	\N	\N	\N	179952	179952	347178
23462	35782	113	applied	\N	\N	\N	\N	179953	179953	347179
23463	36057	1	applied	\N	\N	\N	\N	179955	179955	347181
23463	36058	2	applied	\N	\N	\N	\N	179956	179956	347182
23463	36059	3	applied	\N	\N	\N	\N	179957	179957	347183
23463	36060	4	applied	\N	\N	\N	\N	179958	179958	347184
23463	36061	5	applied	\N	\N	\N	\N	179959	179959	347185
23463	36062	6	applied	\N	\N	\N	\N	179960	179960	347186
23463	36063	7	applied	\N	\N	\N	\N	179961	179961	347187
23463	36064	8	applied	\N	\N	\N	\N	179962	179962	347188
23466	36071	0	applied	\N	\N	\N	\N	179973	179973	347199
23466	36072	1	applied	\N	\N	\N	\N	179974	179974	347200
23466	36073	2	applied	\N	\N	\N	\N	179975	179975	347201
23466	36074	3	applied	\N	\N	\N	\N	179976	179976	347202
23471	36081	0	applied	\N	\N	\N	\N	179990	179990	347216
23471	36082	1	applied	\N	\N	\N	\N	179991	179991	347217
23471	36083	2	applied	\N	\N	\N	\N	179992	179992	347218
23471	36084	3	applied	\N	\N	\N	\N	179993	179993	347219
23476	36089	1	applied	\N	\N	\N	\N	180008	180008	347234
23476	36090	2	applied	\N	\N	\N	\N	180009	180009	347235
23482	36104	0	applied	\N	\N	\N	\N	180027	180027	347253
23482	36105	1	applied	\N	\N	\N	\N	180028	180028	347254
23482	36106	2	applied	\N	\N	\N	\N	180029	180029	347255
23490	36117	0	applied	\N	\N	\N	\N	180049	180049	347275
23490	36118	1	applied	\N	\N	\N	\N	180050	180050	347276
23490	36119	2	applied	\N	\N	\N	\N	180051	180051	347277
23495	36126	0	applied	\N	\N	\N	\N	180070	180070	347296
23495	36127	1	applied	\N	\N	\N	\N	180071	180071	347297
23495	36128	2	applied	\N	\N	\N	\N	180072	180072	347298
23495	36129	3	applied	\N	\N	\N	\N	180073	180073	347299
23498	36126	0	applied	\N	\N	\N	\N	180082	180082	347308
23498	36127	1	applied	\N	\N	\N	\N	180083	180083	347309
23498	36128	2	applied	\N	\N	\N	\N	180084	180084	347310
23498	36129	3	applied	\N	\N	\N	\N	180085	180085	347311
23499	36089	13	applied	\N	\N	\N	\N	180099	180099	347325
23499	36097	14	applied	\N	\N	\N	\N	180100	180100	347326
23499	36098	15	applied	\N	\N	\N	\N	180101	180101	347327
23499	36100	16	applied	\N	\N	\N	\N	180102	180102	347328
23503	36133	0	applied	\N	\N	\N	\N	180113	180113	347339
23503	36134	1	applied	\N	\N	\N	\N	180114	180114	347340
23503	36135	2	applied	\N	\N	\N	\N	180115	180115	347341
23503	36136	3	applied	\N	\N	\N	\N	180116	180116	347342
23503	36137	4	applied	\N	\N	\N	\N	180117	180117	347343
23503	36138	5	applied	\N	\N	\N	\N	180118	180118	347344
23503	36139	6	applied	\N	\N	\N	\N	180119	180119	347345
23506	36140	0	applied	\N	\N	\N	\N	180126	180126	347352
23506	36141	1	applied	\N	\N	\N	\N	180127	180127	347353
23506	36142	2	applied	\N	\N	\N	\N	180128	180128	347354
23507	36140	0	applied	\N	\N	\N	\N	180129	180129	347355
23507	36141	1	applied	\N	\N	\N	\N	180130	180130	347356
23510	36146	0	applied	\N	\N	\N	\N	180138	180138	347364
23510	36147	1	applied	\N	\N	\N	\N	180139	180139	347365
23510	36148	2	applied	\N	\N	\N	\N	180140	180140	347366
23510	36149	3	applied	\N	\N	\N	\N	180141	180141	347367
23512	36146	0	applied	\N	\N	\N	\N	180146	180146	347372
23512	36147	1	applied	\N	\N	\N	\N	180147	180147	347373
23512	36148	2	applied	\N	\N	\N	\N	180148	180148	347374
23512	36149	3	applied	\N	\N	\N	\N	180149	180149	347375
23514	36151	0	applied	\N	\N	\N	\N	180151	180151	347377
23514	36152	1	applied	\N	\N	\N	\N	180152	180152	347378
23514	36153	2	applied	\N	\N	\N	\N	180153	180153	347379
23514	36154	3	applied	\N	\N	\N	\N	180154	180154	347380
23515	36151	0	applied	\N	\N	\N	\N	180155	180155	347381
23515	36152	1	applied	\N	\N	\N	\N	180156	180156	347382
23515	36153	2	applied	\N	\N	\N	\N	180157	180157	347383
23519	36158	0	applied	\N	\N	\N	\N	180167	180167	347393
23519	36154	1	applied	\N	\N	\N	\N	180168	180168	347394
23519	36152	2	applied	\N	\N	\N	\N	180169	180169	347395
23462	35743	93	applied	\N	\N	\N	\N	179935	179935	347161
23462	35745	94	applied	\N	\N	\N	\N	179936	179936	347162
23523	35957	17	applied	\N	\N	\N	\N	180219	180219	347445
23523	35959	18	applied	\N	\N	\N	\N	180220	180220	347446
23523	35960	19	applied	\N	\N	\N	\N	180221	180221	347447
23523	35961	20	applied	\N	\N	\N	\N	180222	180222	347448
23523	35965	21	applied	\N	\N	\N	\N	180223	180223	347449
23523	35967	22	applied	\N	\N	\N	\N	180224	180224	347450
23523	35971	24	applied	\N	\N	\N	\N	180226	180226	347452
23523	35973	25	applied	\N	\N	\N	\N	180227	180227	347453
23523	35974	26	applied	\N	\N	\N	\N	180228	180228	347454
23523	35975	27	applied	\N	\N	\N	\N	180229	180229	347455
23523	35976	28	applied	\N	\N	\N	\N	180230	180230	347456
23523	35977	29	applied	\N	\N	\N	\N	180231	180231	347457
23523	35983	30	applied	\N	\N	\N	\N	180232	180232	347458
23523	35984	31	applied	\N	\N	\N	\N	180233	180233	347459
23523	35987	32	applied	\N	\N	\N	\N	180234	180234	347460
23523	35989	33	applied	\N	\N	\N	\N	180235	180235	347461
23523	35991	34	applied	\N	\N	\N	\N	180236	180236	347462
23523	35993	35	applied	\N	\N	\N	\N	180237	180237	347463
23523	35995	36	applied	\N	\N	\N	\N	180238	180238	347464
23523	35997	37	applied	\N	\N	\N	\N	180239	180239	347465
23523	35998	38	applied	\N	\N	\N	\N	180240	180240	347466
23523	35999	39	applied	\N	\N	\N	\N	180241	180241	347467
23523	36005	41	applied	\N	\N	\N	\N	180243	180243	347469
23523	36006	42	applied	\N	\N	\N	\N	180244	180244	347470
23523	36009	43	applied	\N	\N	\N	\N	180245	180245	347471
23523	36011	44	applied	\N	\N	\N	\N	180246	180246	347472
23523	36013	45	applied	\N	\N	\N	\N	180247	180247	347473
23523	36015	46	applied	\N	\N	\N	\N	180248	180248	347474
23523	36016	47	applied	\N	\N	\N	\N	180249	180249	347475
23523	36019	48	applied	\N	\N	\N	\N	180250	180250	347476
23523	36022	49	applied	\N	\N	\N	\N	180251	180251	347477
23523	36024	50	applied	\N	\N	\N	\N	180252	180252	347478
23523	36026	51	applied	\N	\N	\N	\N	180253	180253	347479
23523	36027	52	applied	\N	\N	\N	\N	180254	180254	347480
23523	36028	53	applied	\N	\N	\N	\N	180255	180255	347481
23523	36032	54	applied	\N	\N	\N	\N	180256	180256	347482
23523	36034	55	applied	\N	\N	\N	\N	180257	180257	347483
23523	36036	56	applied	\N	\N	\N	\N	180258	180258	347484
23523	36040	58	applied	\N	\N	\N	\N	180260	180260	347486
23523	36042	59	applied	\N	\N	\N	\N	180261	180261	347487
23523	36044	60	applied	\N	\N	\N	\N	180262	180262	347488
23523	36046	61	applied	\N	\N	\N	\N	180263	180263	347489
23525	36175	0	applied	\N	\N	\N	\N	180267	180267	347493
23525	36176	1	applied	\N	\N	\N	\N	180268	180268	347494
23525	36177	2	applied	\N	\N	\N	\N	180269	180269	347495
23528	36178	0	applied	\N	\N	\N	\N	180270	180270	347496
23528	36179	1	applied	\N	\N	\N	\N	180271	180271	347497
23528	36180	2	applied	\N	\N	\N	\N	180272	180272	347498
23528	36181	3	applied	\N	\N	\N	\N	180273	180273	347499
23528	36182	4	applied	\N	\N	\N	\N	180274	180274	347500
23528	36183	5	applied	\N	\N	\N	\N	180275	180275	347501
23528	36184	6	applied	\N	\N	\N	\N	180276	180276	347502
23528	36185	7	applied	\N	\N	\N	\N	180277	180277	347503
23528	36186	8	applied	\N	\N	\N	\N	180278	180278	347504
23528	36188	10	applied	\N	\N	\N	\N	180280	180280	347506
23528	36189	11	applied	\N	\N	\N	\N	180281	180281	347507
23528	36190	12	applied	\N	\N	\N	\N	180282	180282	347508
23528	36191	13	applied	\N	\N	\N	\N	180283	180283	347509
23528	36192	14	applied	\N	\N	\N	\N	180284	180284	347510
23529	36178	0	applied	\N	\N	\N	\N	180285	180285	347511
23529	36179	1	applied	\N	\N	\N	\N	180286	180286	347512
23529	36180	2	applied	\N	\N	\N	\N	180287	180287	347513
23529	36181	3	applied	\N	\N	\N	\N	180288	180288	347514
23529	36182	4	applied	\N	\N	\N	\N	180289	180289	347515
23529	36183	5	applied	\N	\N	\N	\N	180290	180290	347516
23529	36184	6	applied	\N	\N	\N	\N	180291	180291	347517
23529	36185	7	applied	\N	\N	\N	\N	180292	180292	347518
23529	36186	8	applied	\N	\N	\N	\N	180293	180293	347519
23529	36187	9	applied	\N	\N	\N	\N	180294	180294	347520
23529	36188	10	applied	\N	\N	\N	\N	180295	180295	347521
23529	36190	12	applied	\N	\N	\N	\N	180297	180297	347523
23529	36191	13	applied	\N	\N	\N	\N	180298	180298	347524
23529	36192	14	applied	\N	\N	\N	\N	180299	180299	347525
23530	36193	0	applied	\N	\N	\N	\N	180300	180300	347526
23530	36194	1	applied	\N	\N	\N	\N	180301	180301	347527
23530	36195	2	applied	\N	\N	\N	\N	180302	180302	347528
23531	36196	0	applied	\N	\N	\N	\N	180303	180303	347529
23531	36197	1	applied	\N	\N	\N	\N	180304	180304	347530
23531	36198	2	applied	\N	\N	\N	\N	180305	180305	347531
23531	36199	3	applied	\N	\N	\N	\N	180306	180306	347532
23533	36200	0	applied	\N	\N	\N	\N	180311	180311	347537
23533	36201	1	applied	\N	\N	\N	\N	180312	180312	347538
23533	36202	2	applied	\N	\N	\N	\N	180313	180313	347539
23535	36181	0	applied	\N	\N	\N	\N	180317	180317	347543
23535	36182	1	applied	\N	\N	\N	\N	180318	180318	347544
23535	36183	2	applied	\N	\N	\N	\N	180319	180319	347545
23535	36185	4	applied	\N	\N	\N	\N	180321	180321	347547
23535	36203	5	applied	\N	\N	\N	\N	180322	180322	347548
23535	36204	6	applied	\N	\N	\N	\N	180323	180323	347549
23541	36222	0	applied	\N	\N	\N	\N	180359	180359	347585
23541	36223	1	applied	\N	\N	\N	\N	180360	180360	347586
23541	36224	2	applied	\N	\N	\N	\N	180361	180361	347587
23543	36225	0	applied	\N	\N	\N	\N	180364	180364	347590
23543	36226	1	applied	\N	\N	\N	\N	180365	180365	347591
23543	36227	2	applied	\N	\N	\N	\N	180366	180366	347592
23551	36238	0	applied	\N	\N	\N	\N	180390	180390	347616
23551	36239	1	applied	\N	\N	\N	\N	180391	180391	347617
23551	36240	2	applied	\N	\N	\N	\N	180392	180392	347618
23551	36241	3	applied	\N	\N	\N	\N	180393	180393	347619
23551	36242	4	applied	\N	\N	\N	\N	180394	180394	347620
23522	36170	8	applied	\N	\N	\N	\N	180201	180201	347427
23539	36223	1	applied	\N	\N	\N	\N	180354	180354	347580
23539	36224	2	applied	\N	\N	\N	\N	180355	180355	347581
23544	36228	0	applied	\N	\N	\N	\N	180367	180367	347593
23544	36229	1	applied	\N	\N	\N	\N	180368	180368	347594
23544	36230	2	applied	\N	\N	\N	\N	180369	180369	347595
23545	36231	0	applied	\N	\N	\N	\N	180370	180370	347596
23545	36232	1	applied	\N	\N	\N	\N	180371	180371	347597
23545	36233	2	applied	\N	\N	\N	\N	180372	180372	347598
23545	36234	3	applied	\N	\N	\N	\N	180373	180373	347599
23547	36235	0	applied	\N	\N	\N	\N	180377	180377	347603
23547	36236	1	applied	\N	\N	\N	\N	180378	180378	347604
23547	36237	2	applied	\N	\N	\N	\N	180379	180379	347605
23548	36235	0	applied	\N	\N	\N	\N	180380	180380	347606
23548	36236	1	applied	\N	\N	\N	\N	180381	180381	347607
23548	36237	2	applied	\N	\N	\N	\N	180382	180382	347608
23549	36238	0	applied	\N	\N	\N	\N	180383	180383	347609
23549	36240	2	applied	\N	\N	\N	\N	180385	180385	347611
23549	36241	3	applied	\N	\N	\N	\N	180386	180386	347612
23549	36242	4	applied	\N	\N	\N	\N	180387	180387	347613
23549	36243	5	applied	\N	\N	\N	\N	180388	180388	347614
23549	36244	6	applied	\N	\N	\N	\N	180389	180389	347615
23554	36245	0	applied	\N	\N	\N	\N	180410	180410	347636
23554	36246	1	applied	\N	\N	\N	\N	180411	180411	347637
23554	36247	2	applied	\N	\N	\N	\N	180412	180412	347638
23554	36248	3	applied	\N	\N	\N	\N	180413	180413	347639
23554	36249	4	applied	\N	\N	\N	\N	180414	180414	347640
23554	36250	5	applied	\N	\N	\N	\N	180415	180415	347641
23555	36245	0	applied	\N	\N	\N	\N	180416	180416	347642
23555	36246	1	applied	\N	\N	\N	\N	180417	180417	347643
23555	36247	2	applied	\N	\N	\N	\N	180418	180418	347644
23555	36248	3	applied	\N	\N	\N	\N	180419	180419	347645
23555	36249	4	applied	\N	\N	\N	\N	180420	180420	347646
23556	36251	0	applied	\N	\N	\N	\N	180422	180422	347648
23556	36252	1	applied	\N	\N	\N	\N	180423	180423	347649
23556	36253	2	applied	\N	\N	\N	\N	180424	180424	347650
23556	36254	3	applied	\N	\N	\N	\N	180425	180425	347651
23556	36255	4	applied	\N	\N	\N	\N	180426	180426	347652
23556	36256	5	applied	\N	\N	\N	\N	180427	180427	347653
23557	36251	0	applied	\N	\N	\N	\N	180428	180428	347654
23557	36252	1	applied	\N	\N	\N	\N	180429	180429	347655
23557	36253	2	applied	\N	\N	\N	\N	180430	180430	347656
23557	36254	3	applied	\N	\N	\N	\N	180431	180431	347657
23557	36255	4	applied	\N	\N	\N	\N	180432	180432	347658
23557	36256	5	applied	\N	\N	\N	\N	180433	180433	347659
23562	36263	0	applied	\N	\N	\N	\N	180456	180456	347682
23562	36264	1	applied	\N	\N	\N	\N	180457	180457	347683
23562	36265	2	applied	\N	\N	\N	\N	180458	180458	347684
23562	36266	3	applied	\N	\N	\N	\N	180459	180459	347685
23564	36268	1	applied	\N	\N	\N	\N	180465	180465	347691
23564	36269	2	applied	\N	\N	\N	\N	180466	180466	347692
23564	36270	3	applied	\N	\N	\N	\N	180467	180467	347693
23569	36277	0	applied	\N	\N	\N	\N	180484	180484	347710
23569	36278	1	applied	\N	\N	\N	\N	180485	180485	347711
23569	36279	2	applied	\N	\N	\N	\N	180486	180486	347712
23569	36280	3	applied	\N	\N	\N	\N	180487	180487	347713
23571	36281	0	applied	\N	\N	\N	\N	180492	180492	347718
23571	36282	1	applied	\N	\N	\N	\N	180493	180493	347719
23571	36283	2	applied	\N	\N	\N	\N	180494	180494	347720
23576	36284	0	applied	\N	\N	\N	\N	180509	180509	347735
23576	36285	1	applied	\N	\N	\N	\N	180510	180510	347736
23576	36286	2	applied	\N	\N	\N	\N	180511	180511	347737
23576	36287	3	applied	\N	\N	\N	\N	180512	180512	347738
23580	36291	0	applied	\N	\N	\N	\N	180523	180523	347749
23580	36292	1	applied	\N	\N	\N	\N	180524	180524	347750
23580	36294	3	applied	\N	\N	\N	\N	180526	180526	347752
23582	36298	0	applied	\N	\N	\N	\N	180530	180530	347756
23582	36299	1	applied	\N	\N	\N	\N	180531	180531	347757
23583	36298	0	applied	\N	\N	\N	\N	180534	180534	347760
23583	36299	1	applied	\N	\N	\N	\N	180535	180535	347761
23583	36300	2	applied	\N	\N	\N	\N	180536	180536	347762
23583	36301	3	applied	\N	\N	\N	\N	180537	180537	347763
23587	36302	0	applied	\N	\N	\N	\N	180549	180549	347775
23587	36303	1	applied	\N	\N	\N	\N	180550	180550	347776
23587	36304	2	applied	\N	\N	\N	\N	180551	180551	347777
23589	36308	0	applied	\N	\N	\N	\N	180555	180555	347781
23589	36309	1	applied	\N	\N	\N	\N	180556	180556	347782
23589	36310	2	applied	\N	\N	\N	\N	180557	180557	347783
23589	36311	3	applied	\N	\N	\N	\N	180558	180558	347784
23592	36312	0	applied	\N	\N	\N	\N	180569	180569	347795
23592	36313	1	applied	\N	\N	\N	\N	180570	180570	347796
23592	36315	3	applied	\N	\N	\N	\N	180572	180572	347798
23592	36316	4	applied	\N	\N	\N	\N	180573	180573	347799
23592	36317	5	applied	\N	\N	\N	\N	180574	180574	347800
23595	36305	0	applied	\N	\N	\N	\N	180587	180587	347813
23595	36308	1	applied	\N	\N	\N	\N	180588	180588	347814
23595	36312	2	applied	\N	\N	\N	\N	180589	180589	347815
23595	36313	3	applied	\N	\N	\N	\N	180590	180590	347816
23595	36306	4	applied	\N	\N	\N	\N	180591	180591	347817
23595	36309	5	applied	\N	\N	\N	\N	180592	180592	347818
23595	36307	6	applied	\N	\N	\N	\N	180593	180593	347819
23595	36310	7	applied	\N	\N	\N	\N	180594	180594	347820
23595	36315	8	applied	\N	\N	\N	\N	180595	180595	347821
23595	36316	9	applied	\N	\N	\N	\N	180596	180596	347822
23595	36311	10	applied	\N	\N	\N	\N	180597	180597	347823
23595	36314	11	applied	\N	\N	\N	\N	180598	180598	347824
23595	36317	12	applied	\N	\N	\N	\N	180599	180599	347825
23596	36319	1	applied	\N	\N	\N	\N	180601	180601	347827
23596	36320	2	applied	\N	\N	\N	\N	180602	180602	347828
23596	36321	3	applied	\N	\N	\N	\N	180603	180603	347829
23596	36322	4	applied	\N	\N	\N	\N	180604	180604	347830
23596	36323	5	applied	\N	\N	\N	\N	180605	180605	347831
23596	36324	6	applied	\N	\N	\N	\N	180606	180606	347832
23607	36267	0	applied	\N	\N	\N	\N	180685	180685	347909
23607	36327	1	applied	\N	\N	\N	\N	180686	180686	347910
23607	36328	2	applied	\N	\N	\N	\N	180687	180687	347911
23607	36329	3	applied	\N	\N	\N	\N	180688	180688	347912
23607	36330	4	applied	\N	\N	\N	\N	180689	180689	347913
23607	36331	5	applied	\N	\N	\N	\N	180690	180690	347914
23607	36332	6	applied	\N	\N	\N	\N	180691	180691	180691
23610	36344	0	applied	\N	\N	\N	\N	180698	180698	347921
23537	36220	8	applied	\N	\N	\N	\N	180341	180341	347567
23537	36221	9	applied	\N	\N	\N	\N	180342	180342	347568
23546	36237	2	applied	\N	\N	\N	\N	180376	180376	347602
23552	36239	1	applied	\N	\N	\N	\N	180398	180398	347624
23552	36240	2	applied	\N	\N	\N	\N	180399	180399	347625
23552	36241	3	applied	\N	\N	\N	\N	180400	180400	347626
23552	36242	4	applied	\N	\N	\N	\N	180401	180401	347627
23552	36243	5	applied	\N	\N	\N	\N	180402	180402	347628
23552	36244	6	applied	\N	\N	\N	\N	180403	180403	347629
23553	36245	0	applied	\N	\N	\N	\N	180404	180404	347630
23553	36246	1	applied	\N	\N	\N	\N	180405	180405	347631
23553	36247	2	applied	\N	\N	\N	\N	180406	180406	347632
23553	36248	3	applied	\N	\N	\N	\N	180407	180407	347633
23553	36249	4	applied	\N	\N	\N	\N	180408	180408	347634
23553	36250	5	applied	\N	\N	\N	\N	180409	180409	347635
23559	36251	0	applied	\N	\N	\N	\N	180440	180440	347666
23559	36252	1	applied	\N	\N	\N	\N	180441	180441	347667
23559	36253	2	applied	\N	\N	\N	\N	180442	180442	347668
23559	36254	3	applied	\N	\N	\N	\N	180443	180443	347669
23559	36256	5	applied	\N	\N	\N	\N	180445	180445	347671
23560	36257	0	applied	\N	\N	\N	\N	180446	180446	347672
23560	36258	1	applied	\N	\N	\N	\N	180447	180447	347673
23560	36259	2	applied	\N	\N	\N	\N	180448	180448	347674
23560	36260	3	applied	\N	\N	\N	\N	180449	180449	347675
23560	36261	4	applied	\N	\N	\N	\N	180450	180450	347676
23560	36262	5	applied	\N	\N	\N	\N	180451	180451	347677
23567	36271	0	applied	\N	\N	\N	\N	180472	180472	347698
23567	36272	1	applied	\N	\N	\N	\N	180473	180473	347699
23567	36273	2	applied	\N	\N	\N	\N	180474	180474	347700
23567	36274	3	applied	\N	\N	\N	\N	180475	180475	347701
23567	36275	4	applied	\N	\N	\N	\N	180476	180476	347702
23567	36276	5	applied	\N	\N	\N	\N	180477	180477	347703
23572	36281	0	applied	\N	\N	\N	\N	180495	180495	347721
23572	36282	1	applied	\N	\N	\N	\N	180496	180496	347722
23572	36283	2	applied	\N	\N	\N	\N	180497	180497	347723
23574	36285	1	applied	\N	\N	\N	\N	180502	180502	347728
23574	36286	2	applied	\N	\N	\N	\N	180503	180503	347729
23574	36287	3	applied	\N	\N	\N	\N	180504	180504	347730
23577	36284	0	applied	\N	\N	\N	\N	180513	180513	347739
23577	36286	1	applied	\N	\N	\N	\N	180514	180514	347740
23577	36287	2	applied	\N	\N	\N	\N	180515	180515	347741
23578	36288	0	applied	\N	\N	\N	\N	180516	180516	347742
23578	36289	1	applied	\N	\N	\N	\N	180517	180517	347743
23578	36290	2	applied	\N	\N	\N	\N	180518	180518	347744
23584	36298	0	applied	\N	\N	\N	\N	180538	180538	347764
23584	36299	1	applied	\N	\N	\N	\N	180539	180539	347765
23584	36300	2	applied	\N	\N	\N	\N	180540	180540	347766
23584	36301	3	applied	\N	\N	\N	\N	180541	180541	347767
23590	36308	0	applied	\N	\N	\N	\N	180559	180559	347785
23590	36309	1	applied	\N	\N	\N	\N	180560	180560	347786
23590	36310	2	applied	\N	\N	\N	\N	180561	180561	347787
23593	36312	0	applied	\N	\N	\N	\N	180575	180575	347801
23593	36313	1	applied	\N	\N	\N	\N	180576	180576	347802
23593	36314	2	applied	\N	\N	\N	\N	180577	180577	347803
23593	36315	3	applied	\N	\N	\N	\N	180578	180578	347804
23593	36316	4	applied	\N	\N	\N	\N	180579	180579	347805
23593	36317	5	applied	\N	\N	\N	\N	180580	180580	347806
23597	36325	0	applied	\N	\N	\N	\N	180607	180607	347833
23597	36326	1	applied	\N	\N	\N	\N	180608	180608	347834
23604	36344	0	applied	\N	\N	\N	\N	180677	180677	347901
23604	36345	1	applied	\N	\N	\N	\N	180678	180678	347902
23608	36344	0	applied	\N	\N	\N	\N	180692	180692	347915
23608	36346	1	applied	\N	\N	\N	\N	180693	180693	347916
23608	36345	2	applied	\N	\N	\N	\N	180694	180694	347917
23610	36346	1	applied	\N	\N	\N	\N	180699	180699	347922
23610	36345	2	applied	\N	\N	\N	\N	180700	180700	347923
23613	36350	0	applied	\N	\N	\N	\N	180714	180714	347937
23613	36352	2	applied	\N	\N	\N	\N	180716	180716	347939
23613	36353	3	applied	\N	\N	\N	\N	180717	180717	347940
23613	36354	4	applied	\N	\N	\N	\N	180718	180718	347941
23613	36355	5	applied	\N	\N	\N	\N	180719	180719	347942
23613	36356	6	applied	\N	\N	\N	\N	180720	180720	347943
23613	36357	7	applied	\N	\N	\N	\N	180721	180721	347944
23613	36358	8	applied	\N	\N	\N	\N	180722	180722	347945
23613	36359	9	applied	\N	\N	\N	\N	180723	180723	347946
23615	36360	0	applied	\N	\N	\N	\N	180724	180724	347947
23615	36361	1	applied	\N	\N	\N	\N	180725	180725	347948
23615	36362	2	applied	\N	\N	\N	\N	180726	180726	347949
23615	36363	3	applied	\N	\N	\N	\N	180727	180727	347950
23615	36364	4	applied	\N	\N	\N	\N	180728	180728	347951
23615	36365	5	applied	\N	\N	\N	\N	180729	180729	347952
23616	36360	0	applied	\N	\N	\N	\N	180730	180730	347953
23616	36361	1	applied	\N	\N	\N	\N	180731	180731	347954
23616	36363	3	applied	\N	\N	\N	\N	180733	180733	347956
23616	36364	4	applied	\N	\N	\N	\N	180734	180734	347957
23616	36365	5	applied	\N	\N	\N	\N	180735	180735	347958
23620	36369	0	applied	\N	\N	\N	\N	180748	180748	347971
23620	36370	1	applied	\N	\N	\N	\N	180749	180749	347972
23620	36371	2	applied	\N	\N	\N	\N	180750	180750	347973
23620	36372	3	applied	\N	\N	\N	\N	180751	180751	347974
23622	36373	0	applied	\N	\N	\N	\N	180756	180756	347979
23622	36374	1	applied	\N	\N	\N	\N	180757	180757	347980
23622	36375	2	applied	\N	\N	\N	\N	180758	180758	347981
23622	36377	4	applied	\N	\N	\N	\N	180760	180760	347982
23622	36378	5	applied	\N	\N	\N	\N	180761	180761	347983
23622	36379	6	applied	\N	\N	\N	\N	180762	180762	347984
23622	36380	7	applied	\N	\N	\N	\N	180763	180763	347985
23623	36373	0	applied	\N	\N	\N	\N	180764	180764	347986
23623	36374	1	applied	\N	\N	\N	\N	180765	180765	347987
23623	36375	2	applied	\N	\N	\N	\N	180766	180766	347988
23623	36377	4	applied	\N	\N	\N	\N	180768	180768	347989
23623	36376	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	180767	180767	\N
23623	36381	5	applied	\N	\N	\N	\N	180769	180769	347990
23623	36382	6	applied	\N	\N	\N	\N	180770	180770	347991
23623	36383	7	applied	\N	\N	\N	\N	180771	180771	347992
23627	36390	0	applied	\N	\N	\N	\N	180920	180920	348138
23627	36391	1	applied	\N	\N	\N	\N	180921	180921	348139
23627	36392	2	applied	\N	\N	\N	\N	180922	180922	348140
23627	36393	3	applied	\N	\N	\N	\N	180923	180923	348141
23627	36394	4	applied	\N	\N	\N	\N	180924	180924	348142
23627	36395	5	applied	\N	\N	\N	\N	180925	180925	348143
23546	36235	0	applied	\N	\N	\N	\N	180374	180374	347600
23546	36236	1	applied	\N	\N	\N	\N	180375	180375	347601
23558	36253	2	applied	\N	\N	\N	\N	180436	180436	347662
23558	36254	3	applied	\N	\N	\N	\N	180437	180437	347663
23558	36255	4	applied	\N	\N	\N	\N	180438	180438	347664
23558	36256	5	applied	\N	\N	\N	\N	180439	180439	347665
23561	36263	0	applied	\N	\N	\N	\N	180452	180452	347678
23561	36264	1	applied	\N	\N	\N	\N	180453	180453	347679
23561	36265	2	applied	\N	\N	\N	\N	180454	180454	347680
23561	36266	3	applied	\N	\N	\N	\N	180455	180455	347681
23563	36267	0	applied	\N	\N	\N	\N	180460	180460	347686
23563	36268	1	applied	\N	\N	\N	\N	180461	180461	347687
23563	36269	2	applied	\N	\N	\N	\N	180462	180462	347688
23563	36270	3	applied	\N	\N	\N	\N	180463	180463	347689
23565	36267	0	applied	\N	\N	\N	\N	180468	180468	347694
23565	36268	1	applied	\N	\N	\N	\N	180469	180469	347695
23565	36269	2	applied	\N	\N	\N	\N	180470	180470	347696
23565	36270	3	applied	\N	\N	\N	\N	180471	180471	347697
23568	36272	1	applied	\N	\N	\N	\N	180479	180479	347705
23568	36273	2	applied	\N	\N	\N	\N	180480	180480	347706
23568	36274	3	applied	\N	\N	\N	\N	180481	180481	347707
23568	36275	4	applied	\N	\N	\N	\N	180482	180482	347708
23568	36276	5	applied	\N	\N	\N	\N	180483	180483	347709
23570	36277	0	applied	\N	\N	\N	\N	180488	180488	347714
23570	36278	1	applied	\N	\N	\N	\N	180489	180489	347715
23570	36279	2	applied	\N	\N	\N	\N	180490	180490	347716
23570	36280	3	applied	\N	\N	\N	\N	180491	180491	347717
23573	36281	0	applied	\N	\N	\N	\N	180498	180498	347724
23573	36282	1	applied	\N	\N	\N	\N	180499	180499	347725
23573	36283	2	applied	\N	\N	\N	\N	180500	180500	347726
23575	36284	0	applied	\N	\N	\N	\N	180505	180505	347731
23575	36285	1	applied	\N	\N	\N	\N	180506	180506	347732
23575	36286	2	applied	\N	\N	\N	\N	180507	180507	347733
23575	36287	3	applied	\N	\N	\N	\N	180508	180508	347734
23579	36292	1	applied	\N	\N	\N	\N	180520	180520	347746
23579	36293	2	applied	\N	\N	\N	\N	180521	180521	347747
23579	36294	3	applied	\N	\N	\N	\N	180522	180522	347748
23581	36295	0	applied	\N	\N	\N	\N	180527	180527	347753
23581	36296	1	applied	\N	\N	\N	\N	180528	180528	347754
23581	36297	2	applied	\N	\N	\N	\N	180529	180529	347755
23585	36298	0	applied	\N	\N	\N	\N	180542	180542	347768
23585	36299	1	applied	\N	\N	\N	\N	180543	180543	347769
23585	36300	2	applied	\N	\N	\N	\N	180544	180544	347770
23585	36301	3	applied	\N	\N	\N	\N	180545	180545	347771
23588	36305	0	applied	\N	\N	\N	\N	180552	180552	347778
23588	36306	1	applied	\N	\N	\N	\N	180553	180553	347779
23588	36307	2	applied	\N	\N	\N	\N	180554	180554	347780
23594	36312	0	applied	\N	\N	\N	\N	180581	180581	347807
23594	36313	1	applied	\N	\N	\N	\N	180582	180582	347808
23594	36314	2	applied	\N	\N	\N	\N	180583	180583	347809
23594	36316	4	applied	\N	\N	\N	\N	180585	180585	347811
23594	36317	5	applied	\N	\N	\N	\N	180586	180586	347812
23598	36295	0	applied	\N	\N	\N	\N	180609	180609	347835
23598	36298	1	applied	\N	\N	\N	\N	180610	180610	347836
23598	36302	2	applied	\N	\N	\N	\N	180611	180611	347837
23598	36305	3	applied	\N	\N	\N	\N	180612	180612	347838
23598	36308	4	applied	\N	\N	\N	\N	180613	180613	347839
23598	36312	5	applied	\N	\N	\N	\N	180614	180614	347840
23598	36313	6	applied	\N	\N	\N	\N	180615	180615	347841
23598	36318	7	applied	\N	\N	\N	\N	180616	180616	347842
23598	36319	8	applied	\N	\N	\N	\N	180617	180617	347843
23598	36325	9	applied	\N	\N	\N	\N	180618	180618	347844
23598	36296	10	applied	\N	\N	\N	\N	180619	180619	347845
23598	36299	11	applied	\N	\N	\N	\N	180620	180620	347846
23598	36297	12	applied	\N	\N	\N	\N	180621	180621	347847
23598	36300	13	applied	\N	\N	\N	\N	180622	180622	347848
23598	36306	15	applied	\N	\N	\N	\N	180624	180624	347850
23598	36309	16	applied	\N	\N	\N	\N	180625	180625	347851
23598	36320	17	applied	\N	\N	\N	\N	180626	180626	347852
23598	36301	18	applied	\N	\N	\N	\N	180627	180627	347853
23598	36304	19	applied	\N	\N	\N	\N	180628	180628	347854
23598	36307	20	applied	\N	\N	\N	\N	180629	180629	347855
23598	36310	21	applied	\N	\N	\N	\N	180630	180630	347856
23598	36315	22	applied	\N	\N	\N	\N	180631	180631	347857
23598	36316	23	applied	\N	\N	\N	\N	180632	180632	347858
23598	36323	24	applied	\N	\N	\N	\N	180633	180633	347859
23598	36324	25	applied	\N	\N	\N	\N	180634	180634	347860
23598	36311	26	applied	\N	\N	\N	\N	180635	180635	347861
23598	36314	27	applied	\N	\N	\N	\N	180636	180636	347862
23598	36317	28	applied	\N	\N	\N	\N	180637	180637	347863
23598	36321	29	applied	\N	\N	\N	\N	180638	180638	347864
23598	36322	30	applied	\N	\N	\N	\N	180639	180639	347865
23623	36379	9	applied	\N	\N	\N	\N	180773	180773	347994
23623	36380	10	applied	\N	\N	\N	\N	180774	180774	347995
23625	36384	0	applied	\N	\N	\N	\N	180786	180786	348006
23625	36385	1	applied	\N	\N	\N	\N	180787	180787	348007
23625	36381	2	applied	\N	\N	\N	\N	180788	180788	348008
23625	36382	3	applied	\N	\N	\N	\N	180789	180789	348009
23625	36383	4	applied	\N	\N	\N	\N	180790	180790	348010
23625	36386	5	applied	\N	\N	\N	\N	180791	180791	348011
23625	36387	6	applied	\N	\N	\N	\N	180792	180792	348012
23625	36388	7	applied	\N	\N	\N	\N	180793	180793	348013
23625	36389	8	applied	\N	\N	\N	\N	180794	180794	348014
23628	36397	0	applied	\N	\N	\N	\N	180927	180927	348145
23628	36398	1	applied	\N	\N	\N	\N	180928	180928	348146
23628	36399	2	applied	\N	\N	\N	\N	180929	180929	348147
23638	36420	0	applied	\N	\N	\N	\N	180968	180968	348186
23638	36421	1	applied	\N	\N	\N	\N	180969	180969	348187
23638	36423	3	applied	\N	\N	\N	\N	180971	180971	348189
23638	36424	4	applied	\N	\N	\N	\N	180972	180972	348190
23638	36425	5	applied	\N	\N	\N	\N	180973	180973	348191
23638	36426	6	applied	\N	\N	\N	\N	180974	180974	348192
23638	36427	7	applied	\N	\N	\N	\N	180975	180975	348193
23638	36428	8	applied	\N	\N	\N	\N	180976	180976	348194
23643	36432	0	applied	\N	\N	\N	\N	181001	181001	348219
23643	36433	1	applied	\N	\N	\N	\N	181002	181002	348220
23643	36434	2	applied	\N	\N	\N	\N	181003	181003	348221
23643	36435	3	applied	\N	\N	\N	\N	181004	181004	348222
23643	36436	4	applied	\N	\N	\N	\N	181005	181005	348223
23643	36437	5	applied	\N	\N	\N	\N	181006	181006	348224
23643	36438	6	applied	\N	\N	\N	\N	181007	181007	348225
23645	36439	0	applied	\N	\N	\N	\N	181015	181015	348233
23551	36244	6	applied	\N	\N	\N	\N	180396	180396	347622
23558	36251	0	applied	\N	\N	\N	\N	180434	180434	347660
23586	36304	2	applied	\N	\N	\N	\N	180548	180548	347774
23591	36312	0	applied	\N	\N	\N	\N	180563	180563	347789
23591	36313	1	applied	\N	\N	\N	\N	180564	180564	347790
23591	36314	2	applied	\N	\N	\N	\N	180565	180565	347791
23591	36315	3	applied	\N	\N	\N	\N	180566	180566	347792
23591	36316	4	applied	\N	\N	\N	\N	180567	180567	347793
23591	36317	5	applied	\N	\N	\N	\N	180568	180568	347794
23598	36326	31	applied	\N	\N	\N	\N	180640	180640	347866
23599	36325	0	applied	\N	\N	\N	\N	180641	180641	347867
23599	36326	1	applied	\N	\N	\N	\N	180642	180642	347868
23600	36327	0	applied	\N	\N	\N	\N	180643	180643	347869
23600	36328	1	applied	\N	\N	\N	\N	180644	180644	347870
23600	36329	2	applied	\N	\N	\N	\N	180645	180645	347871
23600	36330	3	applied	\N	\N	\N	\N	180646	180646	347872
23600	36331	4	applied	\N	\N	\N	\N	180647	180647	347873
23600	36332	5	applied	\N	\N	\N	\N	180648	180648	180648
23600	36334	7	applied	\N	\N	\N	\N	180650	180650	347875
23600	36335	8	applied	\N	\N	\N	\N	180651	180651	347876
23600	36336	9	applied	\N	\N	\N	\N	180652	180652	347877
23600	36337	10	applied	\N	\N	\N	\N	180653	180653	347878
23600	36338	11	applied	\N	\N	\N	\N	180654	180654	347879
23600	36339	12	applied	\N	\N	\N	\N	180655	180655	347880
23600	36340	13	applied	\N	\N	\N	\N	180656	180656	347881
23601	36327	0	applied	\N	\N	\N	\N	180657	180657	347882
23601	36328	1	applied	\N	\N	\N	\N	180658	180658	347883
23601	36329	2	applied	\N	\N	\N	\N	180659	180659	347884
23601	36330	3	applied	\N	\N	\N	\N	180660	180660	347885
23601	36331	4	applied	\N	\N	\N	\N	180661	180661	347886
23601	36332	5	applied	\N	\N	\N	\N	180662	180662	180662
23601	36333	6	applied	\N	\N	\N	\N	180663	180663	347887
23601	36334	7	applied	\N	\N	\N	\N	180664	180664	347888
23601	36335	8	applied	\N	\N	\N	\N	180665	180665	347889
23601	36337	10	applied	\N	\N	\N	\N	180667	180667	347891
23601	36338	11	applied	\N	\N	\N	\N	180668	180668	347892
23601	36339	12	applied	\N	\N	\N	\N	180669	180669	347893
23601	36340	13	applied	\N	\N	\N	\N	180670	180670	347894
23602	36341	0	applied	\N	\N	\N	\N	180671	180671	347895
23602	36342	1	applied	\N	\N	\N	\N	180672	180672	347896
23602	36343	2	applied	\N	\N	\N	\N	180673	180673	347897
23603	36341	0	applied	\N	\N	\N	\N	180674	180674	347898
23603	36342	1	applied	\N	\N	\N	\N	180675	180675	347899
23603	36343	2	applied	\N	\N	\N	\N	180676	180676	347900
23605	36344	0	applied	\N	\N	\N	\N	180679	180679	347903
23605	36346	1	applied	\N	\N	\N	\N	180680	180680	347904
23605	36345	2	applied	\N	\N	\N	\N	180681	180681	347905
23606	36344	0	applied	\N	\N	\N	\N	180682	180682	347906
23606	36346	1	applied	\N	\N	\N	\N	180683	180683	347907
23606	36345	2	applied	\N	\N	\N	\N	180684	180684	347908
23609	36346	1	applied	\N	\N	\N	\N	180696	180696	347919
23609	36345	2	applied	\N	\N	\N	\N	180697	180697	347920
23611	36347	0	applied	\N	\N	\N	\N	180701	180701	347924
23611	36348	1	applied	\N	\N	\N	\N	180702	180702	347925
23611	36349	2	applied	\N	\N	\N	\N	180703	180703	347926
23612	36350	0	applied	\N	\N	\N	\N	180704	180704	347927
23612	36351	1	applied	\N	\N	\N	\N	180705	180705	347928
23612	36352	2	applied	\N	\N	\N	\N	180706	180706	347929
23612	36353	3	applied	\N	\N	\N	\N	180707	180707	347930
23612	36354	4	applied	\N	\N	\N	\N	180708	180708	347931
23612	36355	5	applied	\N	\N	\N	\N	180709	180709	347932
23612	36356	6	applied	\N	\N	\N	\N	180710	180710	347933
23612	36357	7	applied	\N	\N	\N	\N	180711	180711	347934
23612	36358	8	applied	\N	\N	\N	\N	180712	180712	347935
23612	36359	9	applied	\N	\N	\N	\N	180713	180713	347936
23617	36360	0	applied	\N	\N	\N	\N	180736	180736	347959
23617	36362	2	applied	\N	\N	\N	\N	180738	180738	347961
23617	36363	3	applied	\N	\N	\N	\N	180739	180739	347962
23617	36364	4	applied	\N	\N	\N	\N	180740	180740	347963
23617	36365	5	applied	\N	\N	\N	\N	180741	180741	347964
23618	36366	0	applied	\N	\N	\N	\N	180742	180742	347965
23618	36367	1	applied	\N	\N	\N	\N	180743	180743	347966
23618	36368	2	applied	\N	\N	\N	\N	180744	180744	347967
23619	36366	0	applied	\N	\N	\N	\N	180745	180745	347968
23619	36367	1	applied	\N	\N	\N	\N	180746	180746	347969
23619	36368	2	applied	\N	\N	\N	\N	180747	180747	347970
23621	36369	0	applied	\N	\N	\N	\N	180752	180752	347975
23621	36370	1	applied	\N	\N	\N	\N	180753	180753	347976
23632	36407	0	applied	\N	\N	\N	\N	180942	180942	348160
23632	36409	1	applied	\N	\N	\N	\N	180943	180943	348161
23632	36408	2	applied	\N	\N	\N	\N	180944	180944	348162
23634	36410	0	applied	\N	\N	\N	\N	180948	180948	348166
23634	36412	2	applied	\N	\N	\N	\N	180950	180950	348168
23649	36445	0	applied	\N	\N	\N	\N	181028	181028	348246
23649	36446	1	applied	\N	\N	\N	\N	181029	181029	348247
23649	36447	2	applied	\N	\N	\N	\N	181030	181030	348248
23649	36448	3	applied	\N	\N	\N	\N	181031	181031	348249
23653	36456	0	applied	\N	\N	\N	\N	181052	181052	348270
23653	36457	1	applied	\N	\N	\N	\N	181053	181053	348271
23653	36458	2	applied	\N	\N	\N	\N	181054	181054	348272
23658	36459	0	applied	\N	\N	\N	\N	181069	181069	348286
23658	36460	1	applied	\N	\N	\N	\N	181070	181070	348287
23658	36461	2	applied	\N	\N	\N	\N	181071	181071	348288
23658	36462	3	applied	\N	\N	\N	\N	181072	181072	348289
23658	36463	4	applied	\N	\N	\N	\N	181073	181073	348290
23658	36464	5	applied	\N	\N	\N	\N	181074	181074	348291
23658	36465	6	applied	\N	\N	\N	\N	181075	181075	348292
23658	36466	7	applied	\N	\N	\N	\N	181076	181076	348293
23658	36468	9	applied	\N	\N	\N	\N	181078	181078	348295
23660	36469	0	applied	\N	\N	\N	\N	181089	181089	348306
23660	36470	1	applied	\N	\N	\N	\N	181090	181090	348307
23660	36471	2	applied	\N	\N	\N	\N	181091	181091	348308
23666	36472	0	applied	\N	\N	\N	\N	181107	181107	348324
23666	36473	1	applied	\N	\N	\N	\N	181108	181108	348325
23666	36474	2	applied	\N	\N	\N	\N	181109	181109	348326
23666	36475	3	applied	\N	\N	\N	\N	181110	181110	348327
23667	36476	0	applied	\N	\N	\N	\N	181111	181111	348328
23667	36474	1	applied	\N	\N	\N	\N	181112	181112	348329
23670	36481	0	applied	\N	\N	\N	\N	181120	181120	348337
23670	36482	1	applied	\N	\N	\N	\N	181121	181121	348338
23670	36483	2	applied	\N	\N	\N	\N	181122	181122	348339
23670	36484	3	applied	\N	\N	\N	\N	181123	181123	348340
23582	36301	3	applied	\N	\N	\N	\N	180533	180533	347759
23586	36302	0	applied	\N	\N	\N	\N	180546	180546	347772
23624	36374	1	applied	\N	\N	\N	\N	180776	180776	347997
23624	36375	2	applied	\N	\N	\N	\N	180777	180777	347998
23624	36377	4	applied	\N	\N	\N	\N	180779	180779	347999
23624	36381	5	applied	\N	\N	\N	\N	180780	180780	348000
23624	36382	6	applied	\N	\N	\N	\N	180781	180781	348001
23624	36383	7	applied	\N	\N	\N	\N	180782	180782	348002
23624	36378	8	applied	\N	\N	\N	\N	180783	180783	348003
23624	36379	9	applied	\N	\N	\N	\N	180784	180784	348004
23624	36380	10	applied	\N	\N	\N	\N	180785	180785	348005
23626	36267	0	applied	\N	\N	\N	\N	180795	180795	348015
23626	36327	1	applied	\N	\N	\N	\N	180796	180796	348016
23626	36328	2	applied	\N	\N	\N	\N	180797	180797	348017
23626	36329	3	applied	\N	\N	\N	\N	180798	180798	348018
23626	36330	4	applied	\N	\N	\N	\N	180799	180799	348019
23626	36331	5	applied	\N	\N	\N	\N	180800	180800	348020
23626	36181	6	applied	\N	\N	\N	\N	180801	180801	348021
23626	36182	7	applied	\N	\N	\N	\N	180802	180802	348022
23626	36183	8	applied	\N	\N	\N	\N	180803	180803	348023
23626	36332	9	applied	\N	\N	\N	\N	180804	180804	180804
23626	36078	10	applied	\N	\N	\N	\N	180805	180805	348024
23626	36081	11	applied	\N	\N	\N	\N	180806	180806	348025
23626	36085	12	applied	\N	\N	\N	\N	180807	180807	348026
23626	36088	13	applied	\N	\N	\N	\N	180808	180808	348027
23626	36091	14	applied	\N	\N	\N	\N	180809	180809	348028
23626	36092	15	applied	\N	\N	\N	\N	180810	180810	348029
23626	36093	16	applied	\N	\N	\N	\N	180811	180811	348030
23626	36101	17	applied	\N	\N	\N	\N	180812	180812	348031
23626	36104	18	applied	\N	\N	\N	\N	180813	180813	348032
23626	36107	19	applied	\N	\N	\N	\N	180814	180814	348033
23626	36108	20	applied	\N	\N	\N	\N	180815	180815	348034
23626	36113	22	applied	\N	\N	\N	\N	180816	180816	348035
23626	36117	23	applied	\N	\N	\N	\N	180817	180817	348036
23626	36120	24	applied	\N	\N	\N	\N	180818	180818	348037
23626	36126	26	applied	\N	\N	\N	\N	180820	180820	348039
23626	36130	27	applied	\N	\N	\N	\N	180821	180821	348040
23626	36133	28	applied	\N	\N	\N	\N	180822	180822	348041
23626	36134	29	applied	\N	\N	\N	\N	180823	180823	348042
23626	36140	30	applied	\N	\N	\N	\N	180824	180824	348043
23626	36143	31	applied	\N	\N	\N	\N	180825	180825	348044
23626	36146	32	applied	\N	\N	\N	\N	180826	180826	348045
23626	36151	33	applied	\N	\N	\N	\N	180827	180827	348046
23626	36155	34	applied	\N	\N	\N	\N	180828	180828	348047
23626	36158	35	applied	\N	\N	\N	\N	180829	180829	348048
23626	36162	36	applied	\N	\N	\N	\N	180830	180830	348049
23626	36163	37	applied	\N	\N	\N	\N	180831	180831	348050
23626	36164	38	applied	\N	\N	\N	\N	180832	180832	348051
23626	36172	39	applied	\N	\N	\N	\N	180833	180833	348052
23626	36175	40	applied	\N	\N	\N	\N	180834	180834	348053
23626	36178	41	applied	\N	\N	\N	\N	180835	180835	348054
23626	36180	43	applied	\N	\N	\N	\N	180837	180837	348056
23626	36193	44	applied	\N	\N	\N	\N	180838	180838	348057
23626	36196	45	applied	\N	\N	\N	\N	180839	180839	348058
23626	36200	46	applied	\N	\N	\N	\N	180840	180840	348059
23626	36205	47	applied	\N	\N	\N	\N	180841	180841	348060
23626	36206	48	applied	\N	\N	\N	\N	180842	180842	348061
23626	36212	49	applied	\N	\N	\N	\N	180843	180843	348062
23626	36213	50	applied	\N	\N	\N	\N	180844	180844	348063
23626	36184	51	applied	\N	\N	\N	\N	180845	180845	348064
23626	36185	52	applied	\N	\N	\N	\N	180846	180846	348065
23626	36203	53	applied	\N	\N	\N	\N	180847	180847	348066
23626	36204	54	applied	\N	\N	\N	\N	180848	180848	348067
23626	36214	55	applied	\N	\N	\N	\N	180849	180849	348068
23626	36222	56	applied	\N	\N	\N	\N	180850	180850	348069
23626	36225	57	applied	\N	\N	\N	\N	180851	180851	348070
23626	36228	58	applied	\N	\N	\N	\N	180852	180852	348071
23626	36235	60	applied	\N	\N	\N	\N	180854	180854	348073
23626	36238	61	applied	\N	\N	\N	\N	180855	180855	348074
23626	36239	62	applied	\N	\N	\N	\N	180856	180856	348075
23626	36245	63	applied	\N	\N	\N	\N	180857	180857	348076
23626	36246	64	applied	\N	\N	\N	\N	180858	180858	348077
23626	36251	65	applied	\N	\N	\N	\N	180859	180859	348078
23626	36257	66	applied	\N	\N	\N	\N	180860	180860	348079
23626	36258	67	applied	\N	\N	\N	\N	180861	180861	348080
23626	36263	68	applied	\N	\N	\N	\N	180862	180862	348081
23626	36268	69	applied	\N	\N	\N	\N	180863	180863	348082
23626	36271	70	applied	\N	\N	\N	\N	180864	180864	348083
23626	36272	71	applied	\N	\N	\N	\N	180865	180865	348084
23626	36277	72	applied	\N	\N	\N	\N	180866	180866	348085
23626	36281	73	applied	\N	\N	\N	\N	180867	180867	348086
23626	36284	74	applied	\N	\N	\N	\N	180868	180868	348087
23670	36485	4	applied	\N	\N	\N	\N	181124	181124	348341
23670	36487	6	applied	\N	\N	\N	\N	181126	181126	348343
23677	36488	0	applied	\N	\N	\N	\N	181158	181158	348375
23677	36489	1	applied	\N	\N	\N	\N	181159	181159	348376
23677	36490	2	applied	\N	\N	\N	\N	181160	181160	348377
23681	36495	0	applied	\N	\N	\N	\N	181165	181165	348382
23681	36496	1	applied	\N	\N	\N	\N	181166	181166	348383
23681	36497	2	applied	\N	\N	\N	\N	181167	181167	348384
23681	36498	3	applied	\N	\N	\N	\N	181168	181168	348385
23681	36499	4	applied	\N	\N	\N	\N	181169	181169	348386
23681	36500	5	applied	\N	\N	\N	\N	181170	181170	348387
23681	36501	6	applied	\N	\N	\N	\N	181171	181171	348388
23681	36502	7	applied	\N	\N	\N	\N	181172	181172	348389
23685	36512	0	applied	\N	\N	\N	\N	181190	181190	348407
23685	36513	1	applied	\N	\N	\N	\N	181191	181191	348408
23685	36514	2	applied	\N	\N	\N	\N	181192	181192	348409
23688	36525	0	applied	\N	\N	\N	\N	181203	181203	348420
23688	36527	2	applied	\N	\N	\N	\N	181205	181205	348422
23691	36535	0	applied	\N	\N	\N	\N	181213	181213	348430
23691	36536	1	applied	\N	\N	\N	\N	181214	181214	348431
23691	36537	2	applied	\N	\N	\N	\N	181215	181215	348432
23694	36538	0	applied	\N	\N	\N	\N	181226	181226	348443
23694	36539	1	applied	\N	\N	\N	\N	181227	181227	348444
23694	36540	2	applied	\N	\N	\N	\N	181228	181228	348445
23694	36541	3	applied	\N	\N	\N	\N	181229	181229	348446
23694	36542	5	applied	\N	\N	\N	\N	181230	181230	348447
23694	36543	6	applied	\N	\N	\N	\N	181231	181231	348448
23694	36544	7	applied	\N	\N	\N	\N	181232	181232	348449
23698	36545	0	applied	\N	\N	\N	\N	181254	181254	348471
23698	36546	1	applied	\N	\N	\N	\N	181255	181255	348472
23621	36372	3	applied	\N	\N	\N	\N	180755	180755	347978
23624	36373	0	applied	\N	\N	\N	\N	180775	180775	347996
23626	36298	78	applied	\N	\N	\N	\N	180872	180872	348091
23626	36305	80	applied	\N	\N	\N	\N	180874	180874	348093
23626	36308	81	applied	\N	\N	\N	\N	180875	180875	348094
23626	36312	82	applied	\N	\N	\N	\N	180876	180876	348095
23626	36313	83	applied	\N	\N	\N	\N	180877	180877	348096
23626	36318	84	applied	\N	\N	\N	\N	180878	180878	348097
23626	36319	85	applied	\N	\N	\N	\N	180879	180879	348098
23626	36325	86	applied	\N	\N	\N	\N	180880	180880	348099
23626	36333	87	applied	\N	\N	\N	\N	180881	180881	348100
23626	36334	88	applied	\N	\N	\N	\N	180882	180882	348101
23626	36341	89	applied	\N	\N	\N	\N	180883	180883	348102
23626	36344	90	applied	\N	\N	\N	\N	180884	180884	348103
23626	36347	91	applied	\N	\N	\N	\N	180885	180885	348104
23626	36350	92	applied	\N	\N	\N	\N	180886	180886	348105
23626	36351	93	applied	\N	\N	\N	\N	180887	180887	348106
23626	36352	94	applied	\N	\N	\N	\N	180888	180888	348107
23626	36360	95	applied	\N	\N	\N	\N	180889	180889	348108
23626	36366	97	applied	\N	\N	\N	\N	180891	180891	348110
23626	36369	98	applied	\N	\N	\N	\N	180892	180892	348111
23626	36373	99	applied	\N	\N	\N	\N	180893	180893	348112
23626	36374	100	applied	\N	\N	\N	\N	180894	180894	348113
23626	36375	101	applied	\N	\N	\N	\N	180895	180895	348114
23626	36384	102	applied	\N	\N	\N	\N	180896	180896	348115
23626	36385	103	applied	\N	\N	\N	\N	180897	180897	348116
23626	36079	105	applied	\N	\N	\N	\N	180899	180899	348117
23626	36376	104	failed	Amount_insufficient_to_create_account	\N	\N	\N	180898	180898	\N
23626	36082	106	applied	\N	\N	\N	\N	180900	180900	348118
23626	36080	107	applied	\N	\N	\N	\N	180901	180901	348119
23626	36083	108	applied	\N	\N	\N	\N	180902	180902	348120
23626	36086	109	applied	\N	\N	\N	\N	180903	180903	348121
23626	36087	110	applied	\N	\N	\N	\N	180904	180904	348122
23626	36089	111	applied	\N	\N	\N	\N	180905	180905	348123
23626	36097	112	applied	\N	\N	\N	\N	180906	180906	348124
23626	36084	114	applied	\N	\N	\N	\N	180908	180908	348126
23626	36096	115	applied	\N	\N	\N	\N	180909	180909	348127
23626	36105	116	applied	\N	\N	\N	\N	180910	180910	348128
23626	36116	117	applied	\N	\N	\N	\N	180911	180911	348129
23626	36090	118	applied	\N	\N	\N	\N	180912	180912	348130
23626	36094	119	applied	\N	\N	\N	\N	180913	180913	348131
23626	36095	120	applied	\N	\N	\N	\N	180914	180914	348132
23626	36099	121	applied	\N	\N	\N	\N	180915	180915	348133
23626	36100	122	applied	\N	\N	\N	\N	180916	180916	348134
23626	36102	123	applied	\N	\N	\N	\N	180917	180917	348135
23626	36106	124	applied	\N	\N	\N	\N	180918	180918	348136
23626	36109	125	applied	\N	\N	\N	\N	180919	180919	348137
23629	36397	0	applied	\N	\N	\N	\N	180930	180930	348148
23629	36398	1	applied	\N	\N	\N	\N	180931	180931	348149
23629	36399	2	applied	\N	\N	\N	\N	180932	180932	348150
23631	36407	0	applied	\N	\N	\N	\N	180940	180940	348158
23636	36413	0	applied	\N	\N	\N	\N	180954	180954	348172
23636	36414	1	applied	\N	\N	\N	\N	180955	180955	348173
23636	36415	2	applied	\N	\N	\N	\N	180956	180956	348174
23636	36416	3	applied	\N	\N	\N	\N	180957	180957	348175
23636	36417	4	applied	\N	\N	\N	\N	180958	180958	348176
23636	36418	5	applied	\N	\N	\N	\N	180959	180959	348177
23636	36419	6	applied	\N	\N	\N	\N	180960	180960	348178
23639	36420	0	applied	\N	\N	\N	\N	180977	180977	348195
23639	36421	1	applied	\N	\N	\N	\N	180978	180978	348196
23639	36422	2	applied	\N	\N	\N	\N	180979	180979	348197
23639	36423	3	applied	\N	\N	\N	\N	180980	180980	348198
23639	36424	4	applied	\N	\N	\N	\N	180981	180981	348199
23639	36425	5	applied	\N	\N	\N	\N	180982	180982	348200
23639	36426	6	applied	\N	\N	\N	\N	180983	180983	348201
23639	36427	7	applied	\N	\N	\N	\N	180984	180984	348202
23639	36428	8	applied	\N	\N	\N	\N	180985	180985	348203
23641	36430	1	applied	\N	\N	\N	\N	180996	180996	348214
23641	36431	2	applied	\N	\N	\N	\N	180997	180997	348215
23644	36432	0	applied	\N	\N	\N	\N	181008	181008	348226
23644	36433	1	applied	\N	\N	\N	\N	181009	181009	348227
23644	36434	2	applied	\N	\N	\N	\N	181010	181010	348228
23644	36435	3	applied	\N	\N	\N	\N	181011	181011	348229
23644	36436	4	applied	\N	\N	\N	\N	181012	181012	348230
23644	36437	5	applied	\N	\N	\N	\N	181013	181013	348231
23644	36438	6	applied	\N	\N	\N	\N	181014	181014	348232
23646	36439	0	applied	\N	\N	\N	\N	181018	181018	348236
23646	36440	1	applied	\N	\N	\N	\N	181019	181019	348237
23646	36441	2	applied	\N	\N	\N	\N	181020	181020	348238
23648	36445	0	applied	\N	\N	\N	\N	181024	181024	348242
23648	36446	1	applied	\N	\N	\N	\N	181025	181025	348243
23648	36447	2	applied	\N	\N	\N	\N	181026	181026	348244
23648	36448	3	applied	\N	\N	\N	\N	181027	181027	348245
23651	36450	1	applied	\N	\N	\N	\N	181040	181040	348258
23651	36451	2	applied	\N	\N	\N	\N	181041	181041	348259
23651	36452	3	applied	\N	\N	\N	\N	181042	181042	348260
23651	36453	5	applied	\N	\N	\N	\N	181043	181043	348261
23651	36454	6	applied	\N	\N	\N	\N	181044	181044	348262
23651	36455	7	applied	\N	\N	\N	\N	181045	181045	348263
23656	36456	0	applied	\N	\N	\N	\N	181061	181061	348279
23656	36457	1	applied	\N	\N	\N	\N	181062	181062	348280
23656	36458	2	applied	\N	\N	\N	\N	181063	181063	348281
23657	36449	0	applied	\N	\N	\N	\N	181064	181064	348282
23657	36450	1	applied	\N	\N	\N	\N	181065	181065	348283
23657	36451	2	applied	\N	\N	\N	\N	181066	181066	348284
23657	36452	3	applied	\N	\N	\N	\N	181067	181067	348285
23663	36469	0	applied	\N	\N	\N	\N	181098	181098	348315
23663	36471	1	applied	\N	\N	\N	\N	181099	181099	348316
23665	36472	0	applied	\N	\N	\N	\N	181104	181104	348321
23665	36473	1	applied	\N	\N	\N	\N	181105	181105	348322
23665	36475	2	applied	\N	\N	\N	\N	181106	181106	348323
23669	36478	0	applied	\N	\N	\N	\N	181116	181116	348333
23669	36477	1	applied	\N	\N	\N	\N	181117	181117	348334
23669	36479	2	applied	\N	\N	\N	\N	181118	181118	348335
23669	36480	3	applied	\N	\N	\N	\N	181119	181119	348336
23673	36481	0	applied	\N	\N	\N	\N	181141	181141	348358
23673	36482	1	applied	\N	\N	\N	\N	181142	181142	348359
23673	36483	2	applied	\N	\N	\N	\N	181143	181143	348360
23673	36484	3	applied	\N	\N	\N	\N	181144	181144	348361
23673	36485	4	applied	\N	\N	\N	\N	181145	181145	348362
23673	36486	5	applied	\N	\N	\N	\N	181146	181146	348363
23626	36292	76	applied	\N	\N	\N	\N	180870	180870	348089
23626	36295	77	applied	\N	\N	\N	\N	180871	180871	348090
23630	36403	3	applied	\N	\N	\N	\N	180936	180936	348154
23630	36404	4	applied	\N	\N	\N	\N	180937	180937	348155
23630	36405	5	applied	\N	\N	\N	\N	180938	180938	348156
23630	36406	6	applied	\N	\N	\N	\N	180939	180939	348157
23633	36407	0	applied	\N	\N	\N	\N	180945	180945	348163
23633	36409	1	applied	\N	\N	\N	\N	180946	180946	348164
23633	36408	2	applied	\N	\N	\N	\N	180947	180947	348165
23635	36410	0	applied	\N	\N	\N	\N	180951	180951	348169
23635	36411	1	applied	\N	\N	\N	\N	180952	180952	348170
23635	36412	2	applied	\N	\N	\N	\N	180953	180953	348171
23637	36413	0	applied	\N	\N	\N	\N	180961	180961	348179
23637	36414	1	applied	\N	\N	\N	\N	180962	180962	348180
23637	36415	2	applied	\N	\N	\N	\N	180963	180963	348181
23637	36416	3	applied	\N	\N	\N	\N	180964	180964	348182
23637	36417	4	applied	\N	\N	\N	\N	180965	180965	348183
23637	36418	5	applied	\N	\N	\N	\N	180966	180966	348184
23640	36420	0	applied	\N	\N	\N	\N	180986	180986	348204
23640	36421	1	applied	\N	\N	\N	\N	180987	180987	348205
23640	36422	2	applied	\N	\N	\N	\N	180988	180988	348206
23640	36423	3	applied	\N	\N	\N	\N	180989	180989	348207
23640	36424	4	applied	\N	\N	\N	\N	180990	180990	348208
23640	36425	5	applied	\N	\N	\N	\N	180991	180991	348209
23640	36426	6	applied	\N	\N	\N	\N	180992	180992	348210
23640	36427	7	applied	\N	\N	\N	\N	180993	180993	348211
23640	36428	8	applied	\N	\N	\N	\N	180994	180994	348212
23642	36429	0	applied	\N	\N	\N	\N	180998	180998	348216
23642	36430	1	applied	\N	\N	\N	\N	180999	180999	348217
23642	36431	2	applied	\N	\N	\N	\N	181000	181000	348218
23647	36442	0	applied	\N	\N	\N	\N	181021	181021	348239
23647	36443	1	applied	\N	\N	\N	\N	181022	181022	348240
23647	36444	2	applied	\N	\N	\N	\N	181023	181023	348241
23652	36449	0	applied	\N	\N	\N	\N	181046	181046	348264
23652	36451	2	applied	\N	\N	\N	\N	181048	181048	348266
23652	36452	3	applied	\N	\N	\N	\N	181049	181049	348267
23652	36453	5	applied	\N	\N	\N	\N	181050	181050	348268
23652	36454	6	applied	\N	\N	\N	\N	181051	181051	348269
23654	36456	0	applied	\N	\N	\N	\N	181055	181055	348273
23654	36457	1	applied	\N	\N	\N	\N	181056	181056	348274
23654	36458	2	applied	\N	\N	\N	\N	181057	181057	348275
23659	36459	0	applied	\N	\N	\N	\N	181079	181079	348296
23659	36460	1	applied	\N	\N	\N	\N	181080	181080	348297
23659	36461	2	applied	\N	\N	\N	\N	181081	181081	348298
23659	36462	3	applied	\N	\N	\N	\N	181082	181082	348299
23659	36463	4	applied	\N	\N	\N	\N	181083	181083	348300
23659	36464	5	applied	\N	\N	\N	\N	181084	181084	348301
23659	36465	6	applied	\N	\N	\N	\N	181085	181085	348302
23659	36466	7	applied	\N	\N	\N	\N	181086	181086	348303
23659	36467	8	applied	\N	\N	\N	\N	181087	181087	348304
23661	36469	0	applied	\N	\N	\N	\N	181092	181092	348309
23661	36470	1	applied	\N	\N	\N	\N	181093	181093	348310
23661	36471	2	applied	\N	\N	\N	\N	181094	181094	348311
23668	36476	0	applied	\N	\N	\N	\N	181113	181113	348330
23668	36474	1	applied	\N	\N	\N	\N	181114	181114	348331
23668	36477	2	applied	\N	\N	\N	\N	181115	181115	348332
23671	36481	0	applied	\N	\N	\N	\N	181127	181127	348344
23671	36482	1	applied	\N	\N	\N	\N	181128	181128	348345
23671	36483	2	applied	\N	\N	\N	\N	181129	181129	348346
23671	36484	3	applied	\N	\N	\N	\N	181130	181130	348347
23671	36485	4	applied	\N	\N	\N	\N	181131	181131	348348
23671	36486	5	applied	\N	\N	\N	\N	181132	181132	348349
23671	36487	6	applied	\N	\N	\N	\N	181133	181133	348350
23673	36487	6	applied	\N	\N	\N	\N	181147	181147	348364
23674	36481	0	applied	\N	\N	\N	\N	181148	181148	348365
23674	36482	1	applied	\N	\N	\N	\N	181149	181149	348366
23674	36484	3	applied	\N	\N	\N	\N	181151	181151	348368
23674	36485	4	applied	\N	\N	\N	\N	181152	181152	348369
23676	36488	0	applied	\N	\N	\N	\N	181156	181156	348373
23676	36489	1	applied	\N	\N	\N	\N	181157	181157	348374
23678	36491	0	applied	\N	\N	\N	\N	181161	181161	348378
23678	36492	1	applied	\N	\N	\N	\N	181162	181162	348379
23678	36493	2	applied	\N	\N	\N	\N	181163	181163	348380
23678	36494	3	applied	\N	\N	\N	\N	181164	181164	348381
23682	36495	0	applied	\N	\N	\N	\N	181173	181173	348390
23682	36496	1	applied	\N	\N	\N	\N	181174	181174	348391
23682	36497	2	applied	\N	\N	\N	\N	181175	181175	348392
23682	36498	3	applied	\N	\N	\N	\N	181176	181176	348393
23682	36499	4	applied	\N	\N	\N	\N	181177	181177	348394
23682	36500	5	applied	\N	\N	\N	\N	181178	181178	348395
23682	36501	6	applied	\N	\N	\N	\N	181179	181179	348396
23682	36502	7	applied	\N	\N	\N	\N	181180	181180	348397
23686	36516	1	applied	\N	\N	\N	\N	181194	181194	348411
23686	36517	2	applied	\N	\N	\N	\N	181195	181195	348412
23689	36528	0	applied	\N	\N	\N	\N	181206	181206	348423
23689	36529	1	applied	\N	\N	\N	\N	181207	181207	348424
23689	36530	2	applied	\N	\N	\N	\N	181208	181208	348425
23689	36531	3	applied	\N	\N	\N	\N	181209	181209	348426
23690	36532	0	applied	\N	\N	\N	\N	181210	181210	348427
23690	36533	1	applied	\N	\N	\N	\N	181211	181211	348428
23690	36534	2	applied	\N	\N	\N	\N	181212	181212	348429
23693	36538	0	applied	\N	\N	\N	\N	181219	181219	348436
23693	36539	1	applied	\N	\N	\N	\N	181220	181220	348437
23693	36540	2	applied	\N	\N	\N	\N	181221	181221	348438
23693	36541	3	applied	\N	\N	\N	\N	181222	181222	348439
23693	36542	5	applied	\N	\N	\N	\N	181223	181223	348440
23693	36543	6	applied	\N	\N	\N	\N	181224	181224	348441
23693	36544	7	applied	\N	\N	\N	\N	181225	181225	348442
23697	36539	1	applied	\N	\N	\N	\N	181248	181248	348465
23697	36540	2	applied	\N	\N	\N	\N	181249	181249	348466
23697	36541	3	applied	\N	\N	\N	\N	181250	181250	348467
23697	36542	5	applied	\N	\N	\N	\N	181251	181251	348468
23697	36543	6	applied	\N	\N	\N	\N	181252	181252	348469
23697	36544	7	applied	\N	\N	\N	\N	181253	181253	348470
23707	36573	0	applied	\N	\N	\N	\N	181298	181298	348515
23707	36574	1	applied	\N	\N	\N	\N	181299	181299	348516
23707	36575	2	applied	\N	\N	\N	\N	181300	181300	348517
23712	36586	0	applied	\N	\N	\N	\N	181318	181318	348535
23712	36587	1	applied	\N	\N	\N	\N	181319	181319	348536
23712	36588	2	applied	\N	\N	\N	\N	181320	181320	348537
23712	36589	3	applied	\N	\N	\N	\N	181321	181321	348538
23716	36590	0	applied	\N	\N	\N	\N	181329	181329	348546
23630	36400	0	applied	\N	\N	\N	\N	180933	180933	348151
23630	36401	1	applied	\N	\N	\N	\N	180934	180934	348152
23650	36451	2	applied	\N	\N	\N	\N	181034	181034	348252
23650	36452	3	applied	\N	\N	\N	\N	181035	181035	348253
23650	36453	5	applied	\N	\N	\N	\N	181036	181036	348254
23650	36454	6	applied	\N	\N	\N	\N	181037	181037	348255
23650	36455	7	applied	\N	\N	\N	\N	181038	181038	348256
23655	36456	0	applied	\N	\N	\N	\N	181058	181058	348276
23655	36457	1	applied	\N	\N	\N	\N	181059	181059	348277
23655	36458	2	applied	\N	\N	\N	\N	181060	181060	348278
23662	36469	0	applied	\N	\N	\N	\N	181095	181095	348312
23662	36470	1	applied	\N	\N	\N	\N	181096	181096	348313
23662	36471	2	applied	\N	\N	\N	\N	181097	181097	348314
23664	36472	0	applied	\N	\N	\N	\N	181100	181100	348317
23664	36473	1	applied	\N	\N	\N	\N	181101	181101	348318
23664	36474	2	applied	\N	\N	\N	\N	181102	181102	348319
23672	36481	0	applied	\N	\N	\N	\N	181134	181134	348351
23672	36482	1	applied	\N	\N	\N	\N	181135	181135	348352
23672	36483	2	applied	\N	\N	\N	\N	181136	181136	348353
23672	36484	3	applied	\N	\N	\N	\N	181137	181137	348354
23672	36485	4	applied	\N	\N	\N	\N	181138	181138	348355
23672	36486	5	applied	\N	\N	\N	\N	181139	181139	348356
23672	36487	6	applied	\N	\N	\N	\N	181140	181140	348357
23675	36488	0	applied	\N	\N	\N	\N	181153	181153	348370
23675	36489	1	applied	\N	\N	\N	\N	181154	181154	348371
23675	36490	2	applied	\N	\N	\N	\N	181155	181155	348372
23684	36503	0	applied	\N	\N	\N	\N	181181	181181	348398
23684	36504	1	applied	\N	\N	\N	\N	181182	181182	348399
23684	36505	2	applied	\N	\N	\N	\N	181183	181183	348400
23684	36506	3	applied	\N	\N	\N	\N	181184	181184	348401
23684	36507	4	applied	\N	\N	\N	\N	181185	181185	348402
23684	36508	5	applied	\N	\N	\N	\N	181186	181186	348403
23684	36510	7	applied	\N	\N	\N	\N	181188	181188	348405
23684	36511	8	applied	\N	\N	\N	\N	181189	181189	348406
23687	36518	0	applied	\N	\N	\N	\N	181196	181196	348413
23687	36519	1	applied	\N	\N	\N	\N	181197	181197	348414
23687	36520	2	applied	\N	\N	\N	\N	181198	181198	348415
23687	36521	3	applied	\N	\N	\N	\N	181199	181199	348416
23687	36522	4	applied	\N	\N	\N	\N	181200	181200	348417
23687	36523	5	applied	\N	\N	\N	\N	181201	181201	348418
23687	36524	6	applied	\N	\N	\N	\N	181202	181202	348419
23692	36535	0	applied	\N	\N	\N	\N	181216	181216	348433
23692	36536	1	applied	\N	\N	\N	\N	181217	181217	348434
23692	36537	2	applied	\N	\N	\N	\N	181218	181218	348435
23695	36538	0	applied	\N	\N	\N	\N	181233	181233	348450
23695	36539	1	applied	\N	\N	\N	\N	181234	181234	348451
23695	36540	2	applied	\N	\N	\N	\N	181235	181235	348452
23695	36541	3	applied	\N	\N	\N	\N	181236	181236	348453
23695	36543	6	applied	\N	\N	\N	\N	181238	181238	348455
23695	36544	7	applied	\N	\N	\N	\N	181239	181239	348456
23696	36538	0	applied	\N	\N	\N	\N	181240	181240	348457
23696	36539	1	applied	\N	\N	\N	\N	181241	181241	348458
23696	36540	2	applied	\N	\N	\N	\N	181242	181242	348459
23696	36541	3	applied	\N	\N	\N	\N	181243	181243	348460
23696	36542	5	applied	\N	\N	\N	\N	181244	181244	348461
23696	36543	6	applied	\N	\N	\N	\N	181245	181245	348462
23696	36544	7	applied	\N	\N	\N	\N	181246	181246	348463
23699	36545	0	applied	\N	\N	\N	\N	181265	181265	348482
23699	36546	1	applied	\N	\N	\N	\N	181266	181266	348483
23699	36547	2	applied	\N	\N	\N	\N	181267	181267	348484
23699	36549	3	applied	\N	\N	\N	\N	181268	181268	348485
23699	36550	4	applied	\N	\N	\N	\N	181269	181269	348486
23699	36551	5	applied	\N	\N	\N	\N	181270	181270	348487
23699	36552	6	applied	\N	\N	\N	\N	181271	181271	348488
23701	36556	0	applied	\N	\N	\N	\N	181273	181273	348490
23701	36557	1	applied	\N	\N	\N	\N	181274	181274	348491
23701	36548	2	applied	\N	\N	\N	\N	181275	181275	348492
23701	36558	3	applied	\N	\N	\N	\N	181276	181276	348493
23701	36559	4	applied	\N	\N	\N	\N	181277	181277	348494
23701	36553	5	applied	\N	\N	\N	\N	181278	181278	348495
23701	36554	6	applied	\N	\N	\N	\N	181279	181279	348496
23701	36560	7	applied	\N	\N	\N	\N	181280	181280	348497
23701	36561	8	applied	\N	\N	\N	\N	181281	181281	348498
23701	36562	9	applied	\N	\N	\N	\N	181282	181282	348499
23702	36563	0	applied	\N	\N	\N	\N	181283	181283	348500
23702	36564	1	applied	\N	\N	\N	\N	181284	181284	348501
23702	36565	2	applied	\N	\N	\N	\N	181285	181285	348502
23702	36566	3	applied	\N	\N	\N	\N	181286	181286	348503
23704	36567	0	applied	\N	\N	\N	\N	181289	181289	348506
23704	36568	1	applied	\N	\N	\N	\N	181290	181290	348507
23704	36569	2	applied	\N	\N	\N	\N	181291	181291	348508
23705	36567	0	applied	\N	\N	\N	\N	181292	181292	348509
23705	36569	2	applied	\N	\N	\N	\N	181294	181294	348511
23706	36570	0	applied	\N	\N	\N	\N	181295	181295	348512
23710	36576	0	applied	\N	\N	\N	\N	181309	181309	348526
23710	36577	1	applied	\N	\N	\N	\N	181310	181310	348527
23710	36578	2	applied	\N	\N	\N	\N	181311	181311	348528
23715	36590	0	applied	\N	\N	\N	\N	181326	181326	348543
23715	36591	1	applied	\N	\N	\N	\N	181327	181327	348544
23715	36592	2	applied	\N	\N	\N	\N	181328	181328	348545
23724	36603	0	applied	\N	\N	\N	\N	181366	181366	348583
23724	36604	1	applied	\N	\N	\N	\N	181367	181367	348584
23724	36605	2	applied	\N	\N	\N	\N	181368	181368	348585
23724	36606	3	applied	\N	\N	\N	\N	181369	181369	348586
23724	36607	4	applied	\N	\N	\N	\N	181370	181370	348587
23724	36608	5	applied	\N	\N	\N	\N	181371	181371	348588
23726	36617	0	applied	\N	\N	\N	\N	181380	181380	348597
23726	36618	1	applied	\N	\N	\N	\N	181381	181381	348598
23726	36620	3	applied	\N	\N	\N	\N	181383	181383	348600
23726	36621	4	applied	\N	\N	\N	\N	181384	181384	348601
23726	36622	5	applied	\N	\N	\N	\N	181385	181385	348602
23726	36623	6	applied	\N	\N	\N	\N	181386	181386	348603
23729	36634	0	applied	\N	\N	\N	\N	181397	181397	348614
23729	36635	1	applied	\N	\N	\N	\N	181398	181398	348615
23729	36636	2	applied	\N	\N	\N	\N	181399	181399	348616
23730	36637	0	applied	\N	\N	\N	\N	181400	181400	348617
23730	36638	1	applied	\N	\N	\N	\N	181401	181401	348618
23730	36639	2	applied	\N	\N	\N	\N	181402	181402	348619
23730	36640	3	applied	\N	\N	\N	\N	181403	181403	348620
23730	36641	4	applied	\N	\N	\N	\N	181404	181404	348621
23730	36642	5	applied	\N	\N	\N	\N	181405	181405	348622
23730	36643	6	applied	\N	\N	\N	\N	181406	181406	348623
23650	36449	0	applied	\N	\N	\N	\N	181032	181032	348250
23650	36450	1	applied	\N	\N	\N	\N	181033	181033	348251
23698	36550	5	applied	\N	\N	\N	\N	181259	181259	348476
23698	36551	6	applied	\N	\N	\N	\N	181260	181260	348477
23698	36552	7	applied	\N	\N	\N	\N	181261	181261	348478
23698	36553	8	applied	\N	\N	\N	\N	181262	181262	348479
23698	36554	9	applied	\N	\N	\N	\N	181263	181263	348480
23703	36567	0	applied	\N	\N	\N	\N	181287	181287	348504
23703	36568	1	applied	\N	\N	\N	\N	181288	181288	348505
23708	36576	0	applied	\N	\N	\N	\N	181301	181301	348518
23708	36577	1	applied	\N	\N	\N	\N	181302	181302	348519
23708	36578	2	applied	\N	\N	\N	\N	181303	181303	348520
23708	36579	3	applied	\N	\N	\N	\N	181304	181304	348521
23713	36590	0	applied	\N	\N	\N	\N	181322	181322	348539
23713	36591	1	applied	\N	\N	\N	\N	181323	181323	348540
23718	36593	0	applied	\N	\N	\N	\N	181340	181340	348557
23718	36594	1	applied	\N	\N	\N	\N	181341	181341	348558
23718	36592	2	applied	\N	\N	\N	\N	181342	181342	348559
23718	36595	3	applied	\N	\N	\N	\N	181343	181343	348560
23718	36596	4	applied	\N	\N	\N	\N	181344	181344	348561
23718	36597	5	applied	\N	\N	\N	\N	181345	181345	348562
23718	36598	6	applied	\N	\N	\N	\N	181346	181346	348563
23718	36599	7	applied	\N	\N	\N	\N	181347	181347	348564
23720	36600	0	applied	\N	\N	\N	\N	181351	181351	348568
23720	36601	1	applied	\N	\N	\N	\N	181352	181352	348569
23720	36602	2	applied	\N	\N	\N	\N	181353	181353	348570
23722	36603	0	applied	\N	\N	\N	\N	181354	181354	348571
23722	36605	2	applied	\N	\N	\N	\N	181356	181356	348573
23722	36606	3	applied	\N	\N	\N	\N	181357	181357	348574
23722	36607	4	applied	\N	\N	\N	\N	181358	181358	348575
23722	36608	5	applied	\N	\N	\N	\N	181359	181359	348576
23728	36627	0	applied	\N	\N	\N	\N	181390	181390	348607
23728	36628	1	applied	\N	\N	\N	\N	181391	181391	348608
23728	36629	2	applied	\N	\N	\N	\N	181392	181392	348609
23728	36630	3	applied	\N	\N	\N	\N	181393	181393	348610
23728	36631	4	applied	\N	\N	\N	\N	181394	181394	348611
23728	36632	5	applied	\N	\N	\N	\N	181395	181395	348612
23728	36633	6	applied	\N	\N	\N	\N	181396	181396	348613
23730	36644	7	applied	\N	\N	\N	\N	181407	181407	348624
23730	36645	8	applied	\N	\N	\N	\N	181408	181408	348625
23730	36646	9	applied	\N	\N	\N	\N	181409	181409	348626
23733	36449	0	applied	\N	\N	\N	\N	181421	181421	348637
23733	36450	1	applied	\N	\N	\N	\N	181422	181422	348638
23733	36452	3	applied	\N	\N	\N	\N	181424	181424	348640
23733	36327	4	applied	\N	\N	\N	\N	181425	181425	348641
23733	36302	5	applied	\N	\N	\N	\N	181426	181426	348642
23733	36328	6	applied	\N	\N	\N	\N	181427	181427	348643
23733	36329	7	applied	\N	\N	\N	\N	181428	181428	348644
23733	36330	8	applied	\N	\N	\N	\N	181429	181429	348645
23733	36331	9	applied	\N	\N	\N	\N	181430	181430	348646
23733	36332	10	applied	\N	\N	\N	\N	181431	181431	181431
23733	36305	11	applied	\N	\N	\N	\N	181432	181432	348647
23733	36308	12	applied	\N	\N	\N	\N	181433	181433	348648
23733	36312	13	applied	\N	\N	\N	\N	181434	181434	348649
23733	36313	14	applied	\N	\N	\N	\N	181435	181435	348650
23733	36318	15	applied	\N	\N	\N	\N	181436	181436	348651
23733	36319	16	applied	\N	\N	\N	\N	181437	181437	348652
23733	36325	17	applied	\N	\N	\N	\N	181438	181438	348653
23733	36333	18	applied	\N	\N	\N	\N	181439	181439	348654
23733	36341	20	applied	\N	\N	\N	\N	181441	181441	348656
23733	36344	21	applied	\N	\N	\N	\N	181442	181442	348657
23733	36347	22	applied	\N	\N	\N	\N	181443	181443	348658
23733	36350	23	applied	\N	\N	\N	\N	181444	181444	348659
23733	36351	24	applied	\N	\N	\N	\N	181445	181445	348660
23733	36352	25	applied	\N	\N	\N	\N	181446	181446	348661
23733	36360	26	applied	\N	\N	\N	\N	181447	181447	348662
23733	36361	27	applied	\N	\N	\N	\N	181448	181448	348663
23733	36366	28	applied	\N	\N	\N	\N	181449	181449	348664
23734	36658	0	applied	\N	\N	\N	\N	181546	181546	348759
23734	36659	1	applied	\N	\N	\N	\N	181547	181547	348760
23734	36660	2	applied	\N	\N	\N	\N	181548	181548	348761
23734	36661	3	applied	\N	\N	\N	\N	181549	181549	348762
23734	36662	4	applied	\N	\N	\N	\N	181550	181550	348763
23737	36663	0	applied	\N	\N	\N	\N	181559	181559	348772
23737	36661	1	applied	\N	\N	\N	\N	181560	181560	348773
23737	36665	3	applied	\N	\N	\N	\N	181562	181562	348775
23737	36662	4	applied	\N	\N	\N	\N	181563	181563	348776
23737	36666	5	applied	\N	\N	\N	\N	181564	181564	348777
23741	36663	0	applied	\N	\N	\N	\N	181579	181579	348792
23741	36664	1	applied	\N	\N	\N	\N	181580	181580	348793
23741	36666	2	applied	\N	\N	\N	\N	181581	181581	348794
23741	36665	3	applied	\N	\N	\N	\N	181582	181582	348795
23748	36647	1	applied	\N	\N	\N	\N	181621	181621	348833
23748	36653	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	181620	181620	\N
23748	36648	2	applied	\N	\N	\N	\N	181622	181622	348834
23748	36654	3	applied	\N	\N	\N	\N	181623	181623	348835
23748	36658	4	applied	\N	\N	\N	\N	181624	181624	348836
23748	36663	5	applied	\N	\N	\N	\N	181625	181625	348837
23748	36667	6	applied	\N	\N	\N	\N	181626	181626	348838
23748	36669	7	applied	\N	\N	\N	\N	181627	181627	348839
23748	36672	8	applied	\N	\N	\N	\N	181628	181628	348840
23748	36674	10	applied	\N	\N	\N	\N	181630	181630	348842
23748	36675	11	applied	\N	\N	\N	\N	181631	181631	348843
23748	36676	12	applied	\N	\N	\N	\N	181632	181632	348844
23748	36677	13	applied	\N	\N	\N	\N	181633	181633	348845
23748	36678	14	applied	\N	\N	\N	\N	181634	181634	348846
23748	36695	15	applied	\N	\N	\N	\N	181635	181635	348847
23748	36696	16	applied	\N	\N	\N	\N	181636	181636	348848
23748	36655	17	applied	\N	\N	\N	\N	181637	181637	348849
23748	36649	18	applied	\N	\N	\N	\N	181638	181638	348850
23748	36650	19	applied	\N	\N	\N	\N	181639	181639	348851
23748	36651	20	applied	\N	\N	\N	\N	181640	181640	348852
23748	36656	21	applied	\N	\N	\N	\N	181641	181641	348853
23748	36659	22	applied	\N	\N	\N	\N	181642	181642	348854
23748	36652	23	applied	\N	\N	\N	\N	181643	181643	348855
23748	36665	24	applied	\N	\N	\N	\N	181644	181644	348856
23748	36681	25	applied	\N	\N	\N	\N	181645	181645	348857
23748	36700	27	applied	\N	\N	\N	\N	181647	181647	348859
23748	36662	28	applied	\N	\N	\N	\N	181648	181648	348860
23748	36666	29	applied	\N	\N	\N	\N	181649	181649	348861
23748	36668	30	applied	\N	\N	\N	\N	181650	181650	348862
23698	36548	3	applied	\N	\N	\N	\N	181257	181257	348474
23698	36549	4	applied	\N	\N	\N	\N	181258	181258	348475
23709	36577	1	applied	\N	\N	\N	\N	181306	181306	348523
23709	36578	2	applied	\N	\N	\N	\N	181307	181307	348524
23709	36579	3	applied	\N	\N	\N	\N	181308	181308	348525
23711	36580	0	applied	\N	\N	\N	\N	181312	181312	348529
23711	36581	1	applied	\N	\N	\N	\N	181313	181313	348530
23711	36582	2	applied	\N	\N	\N	\N	181314	181314	348531
23711	36583	3	applied	\N	\N	\N	\N	181315	181315	348532
23711	36584	4	applied	\N	\N	\N	\N	181316	181316	348533
23711	36585	5	applied	\N	\N	\N	\N	181317	181317	348534
23714	36591	1	applied	\N	\N	\N	\N	181325	181325	348542
23723	36603	0	applied	\N	\N	\N	\N	181360	181360	348577
23723	36604	1	applied	\N	\N	\N	\N	181361	181361	348578
23723	36605	2	applied	\N	\N	\N	\N	181362	181362	348579
23723	36606	3	applied	\N	\N	\N	\N	181363	181363	348580
23723	36607	4	applied	\N	\N	\N	\N	181364	181364	348581
23723	36608	5	applied	\N	\N	\N	\N	181365	181365	348582
23725	36609	0	applied	\N	\N	\N	\N	181372	181372	348589
23725	36610	1	applied	\N	\N	\N	\N	181373	181373	348590
23725	36611	2	applied	\N	\N	\N	\N	181374	181374	348591
23725	36612	3	applied	\N	\N	\N	\N	181375	181375	348592
23725	36613	4	applied	\N	\N	\N	\N	181376	181376	348593
23725	36614	5	applied	\N	\N	\N	\N	181377	181377	348594
23725	36615	6	applied	\N	\N	\N	\N	181378	181378	348595
23725	36616	7	applied	\N	\N	\N	\N	181379	181379	348596
23732	36654	1	applied	\N	\N	\N	\N	181417	181417	348633
23732	36655	2	applied	\N	\N	\N	\N	181418	181418	348634
23732	36656	3	applied	\N	\N	\N	\N	181419	181419	348635
23732	36657	4	applied	\N	\N	\N	\N	181420	181420	348636
23735	36658	0	applied	\N	\N	\N	\N	181551	181551	348764
23735	36659	1	applied	\N	\N	\N	\N	181552	181552	348765
23735	36660	2	applied	\N	\N	\N	\N	181553	181553	348766
23735	36661	3	applied	\N	\N	\N	\N	181554	181554	348767
23735	36662	4	applied	\N	\N	\N	\N	181555	181555	348768
23738	36663	0	applied	\N	\N	\N	\N	181565	181565	348778
23738	36661	1	applied	\N	\N	\N	\N	181566	181566	348779
23738	36664	2	applied	\N	\N	\N	\N	181567	181567	348780
23738	36665	3	applied	\N	\N	\N	\N	181568	181568	348781
23738	36662	4	applied	\N	\N	\N	\N	181569	181569	348782
23738	36666	5	applied	\N	\N	\N	\N	181570	181570	348783
23744	36669	0	applied	\N	\N	\N	\N	181587	181587	348800
23744	36670	1	applied	\N	\N	\N	\N	181588	181588	348801
23744	36671	2	applied	\N	\N	\N	\N	181589	181589	348802
23748	36657	31	applied	\N	\N	\N	\N	181651	181651	348863
23748	36660	32	applied	\N	\N	\N	\N	181652	181652	348864
23748	36661	33	applied	\N	\N	\N	\N	181653	181653	348865
23748	36664	34	applied	\N	\N	\N	\N	181654	181654	348866
23748	36670	35	applied	\N	\N	\N	\N	181655	181655	348867
23748	36682	36	applied	\N	\N	\N	\N	181656	181656	348868
23748	36683	37	applied	\N	\N	\N	\N	181657	181657	348869
23748	36685	39	applied	\N	\N	\N	\N	181659	181659	348871
23748	36686	40	applied	\N	\N	\N	\N	181660	181660	348872
23748	36693	41	applied	\N	\N	\N	\N	181661	181661	348873
23748	36694	42	applied	\N	\N	\N	\N	181662	181662	348874
23748	36698	43	applied	\N	\N	\N	\N	181663	181663	348875
23748	36671	44	applied	\N	\N	\N	\N	181664	181664	348876
23748	36679	45	applied	\N	\N	\N	\N	181665	181665	348877
23748	36680	46	applied	\N	\N	\N	\N	181666	181666	348878
23748	36688	47	applied	\N	\N	\N	\N	181667	181667	348879
23748	36689	48	applied	\N	\N	\N	\N	181668	181668	348880
23748	36690	49	applied	\N	\N	\N	\N	181669	181669	348881
23748	36691	50	applied	\N	\N	\N	\N	181670	181670	348882
23748	36692	51	applied	\N	\N	\N	\N	181671	181671	348883
23748	36697	52	applied	\N	\N	\N	\N	181672	181672	348884
23748	36699	53	applied	\N	\N	\N	\N	181673	181673	348885
23748	36701	54	applied	\N	\N	\N	\N	181674	181674	348886
23751	36703	1	applied	\N	\N	\N	\N	181680	181680	348892
23751	36704	2	applied	\N	\N	\N	\N	181681	181681	348893
23752	36702	0	applied	\N	\N	\N	\N	181682	181682	348894
23752	36703	1	applied	\N	\N	\N	\N	181683	181683	348895
23752	36704	2	applied	\N	\N	\N	\N	181684	181684	348896
23754	36705	0	applied	\N	\N	\N	\N	181688	181688	348900
23754	36706	1	applied	\N	\N	\N	\N	181689	181689	348901
23754	36707	2	applied	\N	\N	\N	\N	181690	181690	348902
23755	36705	0	applied	\N	\N	\N	\N	181691	181691	348903
23755	36706	1	applied	\N	\N	\N	\N	181692	181692	348904
23755	36707	2	applied	\N	\N	\N	\N	181693	181693	348905
23759	36658	0	applied	\N	\N	\N	\N	181825	181825	349036
23759	36663	1	applied	\N	\N	\N	\N	181826	181826	349037
23760	36712	0	applied	\N	\N	\N	\N	181950	181950	349161
23760	36713	1	applied	\N	\N	\N	\N	181951	181951	349162
23760	36714	2	applied	\N	\N	\N	\N	181952	181952	349163
23760	36716	4	applied	\N	\N	\N	\N	181954	181954	349165
23760	36717	5	applied	\N	\N	\N	\N	181955	181955	349166
23765	36718	0	applied	\N	\N	\N	\N	182099	182099	349309
23765	36719	1	applied	\N	\N	\N	\N	182100	182100	349310
23765	36720	2	applied	\N	\N	\N	\N	182101	182101	349311
23765	36721	3	applied	\N	\N	\N	\N	182102	182102	349312
23765	36722	4	applied	\N	\N	\N	\N	182103	182103	349313
23765	36723	5	applied	\N	\N	\N	\N	182104	182104	349314
23765	36724	6	applied	\N	\N	\N	\N	182105	182105	349315
23767	36728	0	applied	\N	\N	\N	\N	182111	182111	349321
23767	36729	2	applied	\N	\N	\N	\N	182112	182112	349322
23767	36730	3	applied	\N	\N	\N	\N	182113	182113	349323
23767	36731	4	applied	\N	\N	\N	\N	182114	182114	349324
23770	36733	0	applied	\N	\N	\N	\N	182118	182118	349328
23770	36734	1	applied	\N	\N	\N	\N	182119	182119	349329
23772	36732	0	applied	\N	\N	\N	\N	182124	182124	349334
23772	36736	2	applied	\N	\N	\N	\N	182126	182126	349336
23772	36737	3	applied	\N	\N	\N	\N	182127	182127	349337
23774	36745	0	applied	\N	\N	\N	\N	182135	182135	349345
23774	36746	1	applied	\N	\N	\N	\N	182136	182136	349346
23774	36747	2	applied	\N	\N	\N	\N	182137	182137	349347
23776	36745	0	applied	\N	\N	\N	\N	182141	182141	349351
23776	36746	1	applied	\N	\N	\N	\N	182142	182142	349352
23776	36747	2	applied	\N	\N	\N	\N	182143	182143	349353
23781	36755	0	applied	\N	\N	\N	\N	182154	182154	349364
23781	36756	1	applied	\N	\N	\N	\N	182155	182155	349365
23787	36763	0	applied	\N	\N	\N	\N	182178	182178	349388
23787	36761	1	applied	\N	\N	\N	\N	182179	182179	349389
23787	36762	2	applied	\N	\N	\N	\N	182180	182180	349390
23706	36572	2	applied	\N	\N	\N	\N	181297	181297	348514
23709	36576	0	applied	\N	\N	\N	\N	181305	181305	348522
23717	36594	1	applied	\N	\N	\N	\N	181333	181333	348550
23717	36592	2	applied	\N	\N	\N	\N	181334	181334	348551
23717	36595	3	applied	\N	\N	\N	\N	181335	181335	348552
23717	36596	4	applied	\N	\N	\N	\N	181336	181336	348553
23717	36597	5	applied	\N	\N	\N	\N	181337	181337	348554
23717	36598	6	applied	\N	\N	\N	\N	181338	181338	348555
23717	36599	7	applied	\N	\N	\N	\N	181339	181339	348556
23719	36600	0	applied	\N	\N	\N	\N	181348	181348	348565
23719	36601	1	applied	\N	\N	\N	\N	181349	181349	348566
23727	36624	0	applied	\N	\N	\N	\N	181387	181387	348604
23727	36625	1	applied	\N	\N	\N	\N	181388	181388	348605
23727	36626	2	applied	\N	\N	\N	\N	181389	181389	348606
23731	36647	0	applied	\N	\N	\N	\N	181410	181410	348627
23731	36648	1	applied	\N	\N	\N	\N	181411	181411	348628
23731	36649	2	applied	\N	\N	\N	\N	181412	181412	348629
23731	36650	3	applied	\N	\N	\N	\N	181413	181413	348630
23731	36651	4	applied	\N	\N	\N	\N	181414	181414	348631
23731	36652	5	applied	\N	\N	\N	\N	181415	181415	348632
23736	36658	0	applied	\N	\N	\N	\N	181556	181556	348769
23736	36659	1	applied	\N	\N	\N	\N	181557	181557	348770
23736	36660	2	applied	\N	\N	\N	\N	181558	181558	348771
23740	36663	0	applied	\N	\N	\N	\N	181575	181575	348788
23740	36664	1	applied	\N	\N	\N	\N	181576	181576	348789
23740	36666	2	applied	\N	\N	\N	\N	181577	181577	348790
23740	36665	3	applied	\N	\N	\N	\N	181578	181578	348791
23743	36668	1	applied	\N	\N	\N	\N	181586	181586	348799
23747	36695	0	applied	\N	\N	\N	\N	181613	181613	348826
23747	36696	1	applied	\N	\N	\N	\N	181614	181614	348827
23747	36697	2	applied	\N	\N	\N	\N	181615	181615	348828
23747	36698	3	applied	\N	\N	\N	\N	181616	181616	348829
23747	36699	4	applied	\N	\N	\N	\N	181617	181617	348830
23747	36700	5	applied	\N	\N	\N	\N	181618	181618	348831
23747	36701	6	applied	\N	\N	\N	\N	181619	181619	348832
23750	36703	0	applied	\N	\N	\N	\N	181678	181678	348890
23762	36469	1	applied	\N	\N	\N	\N	181963	181963	349173
23762	36472	2	applied	\N	\N	\N	\N	181964	181964	349174
23762	36476	3	applied	\N	\N	\N	\N	181965	181965	349175
23762	36478	4	applied	\N	\N	\N	\N	181966	181966	349176
23762	36481	5	applied	\N	\N	\N	\N	181967	181967	349177
23762	36482	6	applied	\N	\N	\N	\N	181968	181968	349178
23762	36488	7	applied	\N	\N	\N	\N	181969	181969	349179
23762	36491	8	applied	\N	\N	\N	\N	181970	181970	349180
23762	36495	9	applied	\N	\N	\N	\N	181971	181971	349181
23762	36496	10	applied	\N	\N	\N	\N	181972	181972	349182
23762	36503	11	applied	\N	\N	\N	\N	181973	181973	349183
23762	36504	12	applied	\N	\N	\N	\N	181974	181974	349184
23762	36512	13	applied	\N	\N	\N	\N	181975	181975	349185
23762	36515	14	applied	\N	\N	\N	\N	181976	181976	349186
23762	36518	15	applied	\N	\N	\N	\N	181977	181977	349187
23762	36519	16	applied	\N	\N	\N	\N	181978	181978	349188
23762	36525	17	applied	\N	\N	\N	\N	181979	181979	349189
23762	36528	18	applied	\N	\N	\N	\N	181980	181980	349190
23762	36532	19	applied	\N	\N	\N	\N	181981	181981	349191
23762	36535	20	applied	\N	\N	\N	\N	181982	181982	349192
23762	36538	21	applied	\N	\N	\N	\N	181983	181983	349193
23762	36539	22	applied	\N	\N	\N	\N	181984	181984	349194
23762	36545	23	applied	\N	\N	\N	\N	181985	181985	349195
23762	36546	24	applied	\N	\N	\N	\N	181986	181986	349196
23762	36547	25	applied	\N	\N	\N	\N	181987	181987	349197
23762	36556	26	applied	\N	\N	\N	\N	181988	181988	349198
23762	36557	27	applied	\N	\N	\N	\N	181989	181989	349199
23762	36563	28	applied	\N	\N	\N	\N	181990	181990	349200
23762	36567	29	applied	\N	\N	\N	\N	181991	181991	349201
23762	36570	30	applied	\N	\N	\N	\N	181992	181992	349202
23762	36573	31	applied	\N	\N	\N	\N	181993	181993	349203
23762	36580	33	applied	\N	\N	\N	\N	181995	181995	349205
23762	36581	34	applied	\N	\N	\N	\N	181996	181996	349206
23762	36586	35	applied	\N	\N	\N	\N	181997	181997	349207
23762	36590	36	applied	\N	\N	\N	\N	181998	181998	349208
23762	36593	37	applied	\N	\N	\N	\N	181999	181999	349209
23762	36594	38	applied	\N	\N	\N	\N	182000	182000	349210
23762	36600	39	applied	\N	\N	\N	\N	182001	182001	349211
23762	36603	40	applied	\N	\N	\N	\N	182002	182002	349212
23762	36604	41	applied	\N	\N	\N	\N	182003	182003	349213
23762	36609	42	applied	\N	\N	\N	\N	182004	182004	349214
23762	36610	43	applied	\N	\N	\N	\N	182005	182005	349215
23762	36617	44	applied	\N	\N	\N	\N	182006	182006	349216
23762	36618	45	applied	\N	\N	\N	\N	182007	182007	349217
23762	36624	46	applied	\N	\N	\N	\N	182008	182008	349218
23762	36627	47	applied	\N	\N	\N	\N	182009	182009	349219
23787	36764	3	applied	\N	\N	\N	\N	182181	182181	349391
23790	36765	1	applied	\N	\N	\N	\N	182192	182192	349402
23790	36766	2	applied	\N	\N	\N	\N	182193	182193	349403
23790	36764	3	applied	\N	\N	\N	\N	182194	182194	349404
23790	36767	4	applied	\N	\N	\N	\N	182195	182195	349405
23793	36768	0	applied	\N	\N	\N	\N	182201	182201	349411
23793	36769	1	applied	\N	\N	\N	\N	182202	182202	349412
23793	36770	2	applied	\N	\N	\N	\N	182203	182203	349413
23796	36768	0	applied	\N	\N	\N	\N	182210	182210	349420
23796	36771	1	applied	\N	\N	\N	\N	182211	182211	349421
23796	36772	2	applied	\N	\N	\N	\N	182212	182212	349422
23796	36773	3	applied	\N	\N	\N	\N	182213	182213	349423
23803	36781	0	applied	\N	\N	\N	\N	182244	182244	349454
23803	36782	1	applied	\N	\N	\N	\N	182245	182245	349455
23803	36783	2	applied	\N	\N	\N	\N	182246	182246	349456
23805	36784	0	applied	\N	\N	\N	\N	182250	182250	349460
23805	36785	1	applied	\N	\N	\N	\N	182251	182251	349461
23805	36787	3	applied	\N	\N	\N	\N	182253	182253	349463
23811	36799	0	applied	\N	\N	\N	\N	182276	182276	349486
23811	36800	1	applied	\N	\N	\N	\N	182277	182277	349487
23811	36801	2	applied	\N	\N	\N	\N	182278	182278	349488
23813	36802	0	applied	\N	\N	\N	\N	182282	182282	349492
23813	36803	1	applied	\N	\N	\N	\N	182283	182283	349493
23813	36804	2	applied	\N	\N	\N	\N	182284	182284	349494
23820	36818	0	applied	\N	\N	\N	\N	182314	182314	349524
23820	36819	1	applied	\N	\N	\N	\N	182315	182315	349525
23820	36820	2	applied	\N	\N	\N	\N	182316	182316	349526
23820	36821	3	applied	\N	\N	\N	\N	182317	182317	349527
23820	36822	4	applied	\N	\N	\N	\N	182318	182318	349528
23820	36823	5	applied	\N	\N	\N	\N	182319	182319	349529
23716	36592	2	applied	\N	\N	\N	\N	181331	181331	348548
23717	36593	0	applied	\N	\N	\N	\N	181332	181332	348549
23733	36375	32	applied	\N	\N	\N	\N	181453	181453	348668
23733	36385	34	applied	\N	\N	\N	\N	181455	181455	348670
23733	36390	35	applied	\N	\N	\N	\N	181456	181456	348671
23733	36391	36	applied	\N	\N	\N	\N	181457	181457	348672
23733	36397	37	applied	\N	\N	\N	\N	181458	181458	348673
23733	36400	38	applied	\N	\N	\N	\N	181459	181459	348674
23733	36401	39	applied	\N	\N	\N	\N	181460	181460	348675
23733	36407	40	applied	\N	\N	\N	\N	181461	181461	348676
23733	36410	41	applied	\N	\N	\N	\N	181462	181462	348677
23733	36413	42	applied	\N	\N	\N	\N	181463	181463	348678
23733	36414	43	applied	\N	\N	\N	\N	181464	181464	348679
23733	36420	44	applied	\N	\N	\N	\N	181465	181465	348680
23733	36421	45	applied	\N	\N	\N	\N	181466	181466	348681
23733	36429	46	applied	\N	\N	\N	\N	181467	181467	348682
23733	36432	47	applied	\N	\N	\N	\N	181468	181468	348683
23733	36433	48	applied	\N	\N	\N	\N	181469	181469	348684
23733	36439	49	applied	\N	\N	\N	\N	181470	181470	348685
23733	36445	51	applied	\N	\N	\N	\N	181472	181472	348687
23733	36453	52	applied	\N	\N	\N	\N	181473	181473	348688
23733	36456	53	applied	\N	\N	\N	\N	181474	181474	348689
23733	36459	54	applied	\N	\N	\N	\N	181475	181475	348690
23733	36460	55	applied	\N	\N	\N	\N	181476	181476	348691
23733	36461	56	applied	\N	\N	\N	\N	181477	181477	348692
23733	36469	57	applied	\N	\N	\N	\N	181478	181478	348693
23733	36472	58	applied	\N	\N	\N	\N	181479	181479	348694
23733	36476	59	applied	\N	\N	\N	\N	181480	181480	348695
23733	36478	60	applied	\N	\N	\N	\N	181481	181481	348696
23733	36481	61	applied	\N	\N	\N	\N	181482	181482	348697
23733	36482	62	applied	\N	\N	\N	\N	181483	181483	348698
23733	36488	63	applied	\N	\N	\N	\N	181484	181484	348699
23733	36491	64	applied	\N	\N	\N	\N	181485	181485	348700
23733	36495	65	applied	\N	\N	\N	\N	181486	181486	348701
23733	36496	66	applied	\N	\N	\N	\N	181487	181487	348702
23733	36504	68	applied	\N	\N	\N	\N	181489	181489	348704
23733	36512	69	applied	\N	\N	\N	\N	181490	181490	348705
23733	36515	70	applied	\N	\N	\N	\N	181491	181491	348706
23733	36518	71	applied	\N	\N	\N	\N	181492	181492	348707
23733	36519	72	applied	\N	\N	\N	\N	181493	181493	348708
23733	36525	73	applied	\N	\N	\N	\N	181494	181494	348709
23733	36528	74	applied	\N	\N	\N	\N	181495	181495	348710
23733	36532	75	applied	\N	\N	\N	\N	181496	181496	348711
23733	36535	76	applied	\N	\N	\N	\N	181497	181497	348712
23733	36538	77	applied	\N	\N	\N	\N	181498	181498	348713
23733	36539	78	applied	\N	\N	\N	\N	181499	181499	348714
23733	36545	79	applied	\N	\N	\N	\N	181500	181500	348715
23733	36546	81	applied	\N	\N	\N	\N	181501	181501	348716
23733	36547	82	applied	\N	\N	\N	\N	181502	181502	348717
23733	36556	83	applied	\N	\N	\N	\N	181503	181503	348718
23733	36557	84	applied	\N	\N	\N	\N	181504	181504	348719
23733	36567	86	applied	\N	\N	\N	\N	181506	181506	348721
23733	36570	87	applied	\N	\N	\N	\N	181507	181507	348722
23733	36573	88	applied	\N	\N	\N	\N	181508	181508	348723
23733	36576	89	applied	\N	\N	\N	\N	181509	181509	348724
23733	36580	90	applied	\N	\N	\N	\N	181510	181510	348725
23733	36581	91	applied	\N	\N	\N	\N	181511	181511	348726
23733	36586	92	applied	\N	\N	\N	\N	181512	181512	348727
23733	36590	93	applied	\N	\N	\N	\N	181513	181513	348728
23733	36593	94	applied	\N	\N	\N	\N	181514	181514	348729
23733	36594	95	applied	\N	\N	\N	\N	181515	181515	348730
23733	36600	96	applied	\N	\N	\N	\N	181516	181516	348731
23733	36603	97	applied	\N	\N	\N	\N	181517	181517	348732
23733	36604	98	applied	\N	\N	\N	\N	181518	181518	348733
23733	36609	99	applied	\N	\N	\N	\N	181519	181519	348734
23733	36610	100	applied	\N	\N	\N	\N	181520	181520	348735
23733	36617	101	applied	\N	\N	\N	\N	181521	181521	348736
23733	36624	103	applied	\N	\N	\N	\N	181523	181523	348738
23733	36627	104	applied	\N	\N	\N	\N	181524	181524	348739
23733	36628	105	applied	\N	\N	\N	\N	181525	181525	348740
23733	36634	106	applied	\N	\N	\N	\N	181526	181526	348741
23733	36637	107	applied	\N	\N	\N	\N	181527	181527	348742
23733	36638	108	applied	\N	\N	\N	\N	181528	181528	348743
23733	36639	109	applied	\N	\N	\N	\N	181529	181529	348744
23733	36647	110	applied	\N	\N	\N	\N	181530	181530	348745
23733	36648	111	applied	\N	\N	\N	\N	181531	181531	348746
23733	36654	112	applied	\N	\N	\N	\N	181532	181532	348747
23733	36497	115	applied	\N	\N	\N	\N	181535	181535	348748
23733	36653	114	failed	Amount_insufficient_to_create_account	\N	\N	\N	181534	181534	\N
23733	36498	116	applied	\N	\N	\N	\N	181536	181536	348749
23762	36628	48	applied	\N	\N	\N	\N	182010	182010	349220
23762	36634	49	applied	\N	\N	\N	\N	182011	182011	349221
23762	36637	50	applied	\N	\N	\N	\N	182012	182012	349222
23762	36638	51	applied	\N	\N	\N	\N	182013	182013	349223
23762	36639	52	applied	\N	\N	\N	\N	182014	182014	349224
23762	36647	53	applied	\N	\N	\N	\N	182015	182015	349225
23762	36648	54	applied	\N	\N	\N	\N	182016	182016	349226
23762	36654	55	applied	\N	\N	\N	\N	182017	182017	349227
23762	36658	56	applied	\N	\N	\N	\N	182018	182018	349228
23762	36663	57	applied	\N	\N	\N	\N	182019	182019	349229
23762	36667	58	applied	\N	\N	\N	\N	182020	182020	349230
23762	36669	59	applied	\N	\N	\N	\N	182021	182021	349231
23762	36672	60	applied	\N	\N	\N	\N	182022	182022	349232
23762	36673	61	applied	\N	\N	\N	\N	182023	182023	349233
23762	36674	62	applied	\N	\N	\N	\N	182024	182024	349234
23762	36675	63	applied	\N	\N	\N	\N	182025	182025	349235
23762	36676	64	applied	\N	\N	\N	\N	182026	182026	349236
23762	36677	65	applied	\N	\N	\N	\N	182027	182027	349237
23762	36678	66	applied	\N	\N	\N	\N	182028	182028	349238
23762	36695	67	applied	\N	\N	\N	\N	182029	182029	349239
23762	36696	68	applied	\N	\N	\N	\N	182030	182030	349240
23762	36702	69	applied	\N	\N	\N	\N	182031	182031	349241
23762	36705	70	applied	\N	\N	\N	\N	182032	182032	349242
23762	36708	71	applied	\N	\N	\N	\N	182033	182033	349243
23762	36712	72	applied	\N	\N	\N	\N	182034	182034	349244
23762	36713	73	applied	\N	\N	\N	\N	182035	182035	349245
23762	36497	74	applied	\N	\N	\N	\N	182036	182036	349246
23762	36505	76	applied	\N	\N	\N	\N	182038	182038	349248
23762	36473	77	applied	\N	\N	\N	\N	182039	182039	349249
23762	36485	78	applied	\N	\N	\N	\N	182040	182040	349250
23762	36508	79	applied	\N	\N	\N	\N	182041	182041	349251
23733	36373	30	applied	\N	\N	\N	\N	181451	181451	348666
23733	36374	31	applied	\N	\N	\N	\N	181452	181452	348667
23733	36306	120	applied	\N	\N	\N	\N	181540	181540	348753
23733	36309	121	applied	\N	\N	\N	\N	181541	181541	348754
23733	36320	122	applied	\N	\N	\N	\N	181542	181542	348755
23733	36337	123	applied	\N	\N	\N	\N	181543	181543	348756
23733	36349	124	applied	\N	\N	\N	\N	181544	181544	348757
23733	36508	125	applied	\N	\N	\N	\N	181545	181545	348758
23739	36663	0	applied	\N	\N	\N	\N	181571	181571	348784
23739	36664	1	applied	\N	\N	\N	\N	181572	181572	348785
23739	36666	2	applied	\N	\N	\N	\N	181573	181573	348786
23742	36663	0	applied	\N	\N	\N	\N	181583	181583	348796
23742	36666	1	applied	\N	\N	\N	\N	181584	181584	348797
23746	36672	0	applied	\N	\N	\N	\N	181590	181590	348803
23746	36673	1	applied	\N	\N	\N	\N	181591	181591	348804
23746	36674	2	applied	\N	\N	\N	\N	181592	181592	348805
23746	36675	3	applied	\N	\N	\N	\N	181593	181593	348806
23746	36676	4	applied	\N	\N	\N	\N	181594	181594	348807
23746	36677	5	applied	\N	\N	\N	\N	181595	181595	348808
23746	36678	6	applied	\N	\N	\N	\N	181596	181596	348809
23746	36679	7	applied	\N	\N	\N	\N	181597	181597	348810
23746	36680	8	applied	\N	\N	\N	\N	181598	181598	348811
23746	36681	9	applied	\N	\N	\N	\N	181599	181599	348812
23746	36682	10	applied	\N	\N	\N	\N	181600	181600	348813
23746	36683	11	applied	\N	\N	\N	\N	181601	181601	348814
23746	36684	12	applied	\N	\N	\N	\N	181602	181602	348815
23746	36685	13	applied	\N	\N	\N	\N	181603	181603	348816
23746	36687	15	applied	\N	\N	\N	\N	181605	181605	348818
23746	36688	16	applied	\N	\N	\N	\N	181606	181606	348819
23746	36689	17	applied	\N	\N	\N	\N	181607	181607	348820
23746	36690	18	applied	\N	\N	\N	\N	181608	181608	348821
23746	36691	19	applied	\N	\N	\N	\N	181609	181609	348822
23746	36692	20	applied	\N	\N	\N	\N	181610	181610	348823
23746	36693	21	applied	\N	\N	\N	\N	181611	181611	348824
23746	36694	22	applied	\N	\N	\N	\N	181612	181612	348825
23749	36702	0	applied	\N	\N	\N	\N	181675	181675	348887
23749	36703	1	applied	\N	\N	\N	\N	181676	181676	348888
23749	36704	2	applied	\N	\N	\N	\N	181677	181677	348889
23753	36702	0	applied	\N	\N	\N	\N	181685	181685	348897
23753	36703	1	applied	\N	\N	\N	\N	181686	181686	348898
23753	36704	2	applied	\N	\N	\N	\N	181687	181687	348899
23756	36705	0	applied	\N	\N	\N	\N	181694	181694	348906
23756	36706	1	applied	\N	\N	\N	\N	181695	181695	348907
23757	36449	0	applied	\N	\N	\N	\N	181697	181697	348909
23757	36450	1	applied	\N	\N	\N	\N	181698	181698	348910
23757	36451	2	applied	\N	\N	\N	\N	181699	181699	348911
23757	36452	3	applied	\N	\N	\N	\N	181700	181700	348912
23757	36410	5	applied	\N	\N	\N	\N	181702	181702	348913
23757	36653	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	181701	181701	\N
23757	36413	6	applied	\N	\N	\N	\N	181703	181703	348914
23757	36414	7	applied	\N	\N	\N	\N	181704	181704	348915
23757	36420	8	applied	\N	\N	\N	\N	181705	181705	348916
23757	36421	9	applied	\N	\N	\N	\N	181706	181706	348917
23757	36429	10	applied	\N	\N	\N	\N	181707	181707	348918
23757	36432	11	applied	\N	\N	\N	\N	181708	181708	348919
23757	36433	12	applied	\N	\N	\N	\N	181709	181709	348920
23757	36439	13	applied	\N	\N	\N	\N	181710	181710	348921
23757	36442	14	applied	\N	\N	\N	\N	181711	181711	348922
23757	36445	15	applied	\N	\N	\N	\N	181712	181712	348923
23757	36456	17	applied	\N	\N	\N	\N	181714	181714	348925
23757	36459	18	applied	\N	\N	\N	\N	181715	181715	348926
23757	36460	19	applied	\N	\N	\N	\N	181716	181716	348927
23757	36461	20	applied	\N	\N	\N	\N	181717	181717	348928
23757	36469	21	applied	\N	\N	\N	\N	181718	181718	348929
23757	36472	22	applied	\N	\N	\N	\N	181719	181719	348930
23757	36476	23	applied	\N	\N	\N	\N	181720	181720	348931
23757	36478	24	applied	\N	\N	\N	\N	181721	181721	348932
23757	36481	25	applied	\N	\N	\N	\N	181722	181722	348933
23757	36482	26	applied	\N	\N	\N	\N	181723	181723	348934
23757	36488	27	applied	\N	\N	\N	\N	181724	181724	348935
23757	36491	28	applied	\N	\N	\N	\N	181725	181725	348936
23757	36495	29	applied	\N	\N	\N	\N	181726	181726	348937
23757	36496	30	applied	\N	\N	\N	\N	181727	181727	348938
23757	36503	31	applied	\N	\N	\N	\N	181728	181728	348939
23757	36504	32	applied	\N	\N	\N	\N	181729	181729	348940
23757	36515	34	applied	\N	\N	\N	\N	181731	181731	348942
23757	36518	35	applied	\N	\N	\N	\N	181732	181732	348943
23757	36519	36	applied	\N	\N	\N	\N	181733	181733	348944
23757	36525	37	applied	\N	\N	\N	\N	181734	181734	348945
23757	36528	38	applied	\N	\N	\N	\N	181735	181735	348946
23757	36532	39	applied	\N	\N	\N	\N	181736	181736	348947
23757	36535	40	applied	\N	\N	\N	\N	181737	181737	348948
23757	36538	41	applied	\N	\N	\N	\N	181738	181738	348949
23757	36539	42	applied	\N	\N	\N	\N	181739	181739	348950
23757	36545	43	applied	\N	\N	\N	\N	181740	181740	348951
23757	36546	44	applied	\N	\N	\N	\N	181741	181741	348952
23757	36547	45	applied	\N	\N	\N	\N	181742	181742	348953
23757	36556	46	applied	\N	\N	\N	\N	181743	181743	348954
23757	36557	47	applied	\N	\N	\N	\N	181744	181744	348955
23757	36563	48	applied	\N	\N	\N	\N	181745	181745	348956
23757	36567	49	applied	\N	\N	\N	\N	181746	181746	348957
23757	36573	51	applied	\N	\N	\N	\N	181748	181748	348959
23757	36576	52	applied	\N	\N	\N	\N	181749	181749	348960
23757	36580	53	applied	\N	\N	\N	\N	181750	181750	348961
23757	36581	54	applied	\N	\N	\N	\N	181751	181751	348962
23757	36586	55	applied	\N	\N	\N	\N	181752	181752	348963
23757	36590	56	applied	\N	\N	\N	\N	181753	181753	348964
23757	36593	57	applied	\N	\N	\N	\N	181754	181754	348965
23757	36594	58	applied	\N	\N	\N	\N	181755	181755	348966
23757	36600	59	applied	\N	\N	\N	\N	181756	181756	348967
23757	36603	61	applied	\N	\N	\N	\N	181757	181757	348968
23757	36604	62	applied	\N	\N	\N	\N	181758	181758	348969
23757	36609	63	applied	\N	\N	\N	\N	181759	181759	348970
23757	36610	64	applied	\N	\N	\N	\N	181760	181760	348971
23757	36617	65	applied	\N	\N	\N	\N	181761	181761	348972
23757	36618	66	applied	\N	\N	\N	\N	181762	181762	348973
23757	36624	67	applied	\N	\N	\N	\N	181763	181763	348974
23757	36628	69	applied	\N	\N	\N	\N	181765	181765	348976
23757	36634	70	applied	\N	\N	\N	\N	181766	181766	348977
23757	36637	71	applied	\N	\N	\N	\N	181767	181767	348978
23757	36638	72	applied	\N	\N	\N	\N	181768	181768	348979
23733	36303	118	applied	\N	\N	\N	\N	181538	181538	348751
23733	36304	119	applied	\N	\N	\N	\N	181539	181539	348752
23757	36658	77	applied	\N	\N	\N	\N	181773	181773	348984
23757	36663	78	applied	\N	\N	\N	\N	181774	181774	348985
23757	36667	79	applied	\N	\N	\N	\N	181775	181775	348986
23757	36669	80	applied	\N	\N	\N	\N	181776	181776	348987
23757	36672	81	applied	\N	\N	\N	\N	181777	181777	348988
23757	36673	82	applied	\N	\N	\N	\N	181778	181778	348989
23757	36674	83	applied	\N	\N	\N	\N	181779	181779	348990
23757	36675	84	applied	\N	\N	\N	\N	181780	181780	348991
23757	36676	85	applied	\N	\N	\N	\N	181781	181781	348992
23757	36677	86	applied	\N	\N	\N	\N	181782	181782	348993
23757	36678	87	applied	\N	\N	\N	\N	181783	181783	348994
23757	36695	88	applied	\N	\N	\N	\N	181784	181784	348995
23757	36696	89	applied	\N	\N	\N	\N	181785	181785	348996
23757	36702	90	applied	\N	\N	\N	\N	181786	181786	348997
23757	36497	92	applied	\N	\N	\N	\N	181788	181788	348999
23757	36415	93	applied	\N	\N	\N	\N	181789	181789	349000
23757	36409	94	applied	\N	\N	\N	\N	181790	181790	349001
23757	36498	95	applied	\N	\N	\N	\N	181791	181791	349002
23757	36505	96	applied	\N	\N	\N	\N	181792	181792	349003
23757	36508	97	applied	\N	\N	\N	\N	181793	181793	349004
23757	36412	98	applied	\N	\N	\N	\N	181794	181794	349005
23757	36416	99	applied	\N	\N	\N	\N	181795	181795	349006
23757	36555	100	applied	\N	\N	1000000000	\N	181796	181796	349007
23757	36418	101	applied	\N	\N	\N	\N	181797	181797	349008
23757	36422	102	applied	\N	\N	\N	\N	181798	181798	349009
23757	36423	103	applied	\N	\N	\N	\N	181799	181799	349010
23757	36427	104	applied	\N	\N	\N	\N	181800	181800	349011
23757	36431	105	applied	\N	\N	\N	\N	181801	181801	349012
23757	36437	106	applied	\N	\N	\N	\N	181802	181802	349013
23757	36438	107	applied	\N	\N	\N	\N	181803	181803	349014
23757	36562	109	applied	\N	\N	\N	\N	181805	181805	349016
23757	36444	110	applied	\N	\N	\N	\N	181806	181806	349017
23757	36448	111	applied	\N	\N	\N	\N	181807	181807	349018
23757	36454	112	applied	\N	\N	\N	\N	181808	181808	349019
23757	36458	113	applied	\N	\N	\N	\N	181809	181809	349020
23757	36463	114	applied	\N	\N	\N	\N	181810	181810	349021
23757	36464	115	applied	\N	\N	\N	\N	181811	181811	349022
23757	36467	116	applied	\N	\N	\N	\N	181812	181812	349023
23757	36471	117	applied	\N	\N	\N	\N	181813	181813	349024
23757	36475	118	applied	\N	\N	\N	\N	181814	181814	349025
23757	36480	119	applied	\N	\N	\N	\N	181815	181815	349026
23757	36483	120	applied	\N	\N	\N	\N	181816	181816	349027
23757	36484	121	applied	\N	\N	\N	\N	181817	181817	349028
23757	36489	122	applied	\N	\N	\N	\N	181818	181818	349029
23757	36492	123	applied	\N	\N	\N	\N	181819	181819	349030
23757	36499	124	applied	\N	\N	\N	\N	181820	181820	349031
23758	36709	1	applied	\N	\N	\N	\N	181822	181822	349033
23758	36710	2	applied	\N	\N	\N	\N	181823	181823	349034
23758	36711	3	applied	\N	\N	\N	\N	181824	181824	349035
23761	36712	0	applied	\N	\N	\N	\N	181956	181956	349167
23761	36713	1	applied	\N	\N	\N	\N	181957	181957	349168
23761	36714	2	applied	\N	\N	\N	\N	181958	181958	349169
23761	36715	3	applied	\N	\N	\N	\N	181959	181959	349170
23761	36716	4	applied	\N	\N	\N	\N	181960	181960	349171
23761	36717	5	applied	\N	\N	\N	\N	181961	181961	349172
23763	36718	0	applied	\N	\N	\N	\N	182087	182087	349297
23763	36719	1	applied	\N	\N	\N	\N	182088	182088	349298
23763	36720	2	applied	\N	\N	\N	\N	182089	182089	349299
23763	36721	3	applied	\N	\N	\N	\N	182090	182090	349300
23763	36722	4	applied	\N	\N	\N	\N	182091	182091	349301
23763	36723	5	applied	\N	\N	\N	\N	182092	182092	349302
23763	36724	6	applied	\N	\N	\N	\N	182093	182093	349303
23775	36746	1	applied	\N	\N	\N	\N	182139	182139	349349
23775	36747	2	applied	\N	\N	\N	\N	182140	182140	349350
23777	36748	0	applied	\N	\N	\N	\N	182144	182144	349354
23777	36749	1	applied	\N	\N	\N	\N	182145	182145	349355
23777	36750	2	applied	\N	\N	\N	\N	182146	182146	349356
23782	36757	0	applied	\N	\N	\N	\N	182156	182156	349366
23782	36758	1	applied	\N	\N	\N	\N	182157	182157	349367
23782	36755	2	applied	\N	\N	\N	\N	182158	182158	349368
23782	36759	3	applied	\N	\N	\N	\N	182159	182159	349369
23782	36756	4	applied	\N	\N	\N	\N	182160	182160	349370
23782	36760	5	applied	\N	\N	\N	\N	182161	182161	349371
23784	36761	0	applied	\N	\N	\N	\N	182168	182168	349378
23784	36762	1	applied	\N	\N	\N	\N	182169	182169	349379
23788	36763	0	applied	\N	\N	\N	\N	182182	182182	349392
23788	36761	1	applied	\N	\N	\N	\N	182183	182183	349393
23788	36762	2	applied	\N	\N	\N	\N	182184	182184	349394
23794	36768	0	applied	\N	\N	\N	\N	182204	182204	349414
23794	36769	1	applied	\N	\N	\N	\N	182205	182205	349415
23794	36770	2	applied	\N	\N	\N	\N	182206	182206	349416
23797	36768	0	applied	\N	\N	\N	\N	182214	182214	349424
23797	36771	1	applied	\N	\N	\N	\N	182215	182215	349425
23797	36772	2	applied	\N	\N	\N	\N	182216	182216	349426
23797	36773	3	applied	\N	\N	\N	\N	182217	182217	349427
23800	36768	0	applied	\N	\N	\N	\N	182226	182226	349436
23800	36771	1	applied	\N	\N	\N	\N	182227	182227	349437
23800	36772	2	applied	\N	\N	\N	\N	182228	182228	349438
23800	36773	3	applied	\N	\N	\N	\N	182229	182229	349439
23801	36774	0	applied	\N	\N	\N	\N	182230	182230	349440
23801	36775	1	applied	\N	\N	\N	\N	182231	182231	349441
23801	36776	2	applied	\N	\N	\N	\N	182232	182232	349442
23801	36777	3	applied	\N	\N	\N	\N	182233	182233	349443
23801	36778	4	applied	\N	\N	\N	\N	182234	182234	349444
23801	36780	6	applied	\N	\N	\N	\N	182236	182236	349446
23804	36781	0	applied	\N	\N	\N	\N	182247	182247	349457
23804	36782	1	applied	\N	\N	\N	\N	182248	182248	349458
23804	36783	2	applied	\N	\N	\N	\N	182249	182249	349459
23806	36788	0	applied	\N	\N	\N	\N	182254	182254	349464
23806	36789	1	applied	\N	\N	\N	\N	182255	182255	349465
23806	36790	2	applied	\N	\N	\N	\N	182256	182256	349466
23806	36791	3	applied	\N	\N	\N	\N	182257	182257	349467
23806	36792	4	applied	\N	\N	\N	\N	182258	182258	349468
23806	36793	5	applied	\N	\N	\N	\N	182259	182259	349469
23815	36805	0	applied	\N	\N	\N	\N	182288	182288	349498
23815	36806	1	applied	\N	\N	\N	\N	182289	182289	349499
23815	36807	2	applied	\N	\N	\N	\N	182290	182290	349500
23818	36812	0	applied	\N	\N	\N	\N	182301	182301	349511
23818	36813	1	applied	\N	\N	\N	\N	182302	182302	349512
23818	36814	3	applied	\N	\N	\N	\N	182303	182303	349513
23757	36654	76	applied	\N	\N	\N	\N	181772	181772	348983
23759	36678	10	applied	\N	\N	\N	\N	181835	181835	349046
23759	36695	11	applied	\N	\N	\N	\N	181836	181836	349047
23759	36696	12	applied	\N	\N	\N	\N	181837	181837	349048
23759	36702	13	applied	\N	\N	\N	\N	181838	181838	349049
23759	36705	14	applied	\N	\N	\N	\N	181839	181839	349050
23759	36316	21	applied	\N	\N	\N	\N	181846	181846	349057
23759	36324	23	applied	\N	\N	\N	\N	181848	181848	349059
23759	36335	24	applied	\N	\N	\N	\N	181849	181849	349060
23759	36338	25	applied	\N	\N	\N	\N	181850	181850	349061
23759	36339	26	applied	\N	\N	\N	\N	181851	181851	349062
23759	36343	27	applied	\N	\N	\N	\N	181852	181852	349063
23759	36345	28	applied	\N	\N	\N	\N	181853	181853	349064
23759	36353	29	applied	\N	\N	\N	\N	181854	181854	349065
23759	36354	30	applied	\N	\N	\N	\N	181855	181855	349066
23759	36355	31	applied	\N	\N	\N	\N	181856	181856	349067
23759	36363	32	applied	\N	\N	\N	\N	181857	181857	349068
23759	36364	33	applied	\N	\N	\N	\N	181858	181858	349069
23759	36368	34	applied	\N	\N	\N	\N	181859	181859	349070
23759	36372	35	applied	\N	\N	\N	\N	181860	181860	349071
23759	36378	36	applied	\N	\N	\N	\N	181861	181861	349072
23759	36379	37	applied	\N	\N	\N	\N	181862	181862	349073
23759	36380	38	applied	\N	\N	\N	\N	181863	181863	349074
23759	36389	40	applied	\N	\N	\N	\N	181865	181865	349076
23759	36392	41	applied	\N	\N	\N	\N	181866	181866	349077
23759	36393	42	applied	\N	\N	\N	\N	181867	181867	349078
23759	36399	43	applied	\N	\N	\N	\N	181868	181868	349079
23759	36403	44	applied	\N	\N	\N	\N	181869	181869	349080
23759	36404	45	applied	\N	\N	\N	\N	181870	181870	349081
23759	36408	46	applied	\N	\N	\N	\N	181871	181871	349082
23759	36411	47	applied	\N	\N	\N	\N	181872	181872	349083
23759	36417	48	applied	\N	\N	\N	\N	181873	181873	349084
23759	36419	49	applied	\N	\N	\N	\N	181874	181874	349085
23759	36424	50	applied	\N	\N	\N	\N	181875	181875	349086
23759	36425	51	applied	\N	\N	\N	\N	181876	181876	349087
23759	36426	52	applied	\N	\N	\N	\N	181877	181877	349088
23759	36430	53	applied	\N	\N	\N	\N	181878	181878	349089
23759	36435	54	applied	\N	\N	\N	\N	181879	181879	349090
23759	36436	55	applied	\N	\N	\N	\N	181880	181880	349091
23759	36443	57	applied	\N	\N	\N	\N	181882	181882	349093
23759	36447	58	applied	\N	\N	\N	\N	181883	181883	349094
23759	36396	59	applied	\N	\N	\N	\N	181884	181884	349095
23759	36406	60	applied	\N	\N	\N	\N	181885	181885	349096
23759	36415	61	applied	\N	\N	\N	\N	181886	181886	349097
23759	36311	62	applied	\N	\N	\N	\N	181887	181887	349098
23759	36314	63	applied	\N	\N	\N	\N	181888	181888	349099
23759	36317	64	applied	\N	\N	\N	\N	181889	181889	349100
23759	36321	65	applied	\N	\N	\N	\N	181890	181890	349101
23759	36322	66	applied	\N	\N	\N	\N	181891	181891	349102
23759	36326	67	applied	\N	\N	\N	\N	181892	181892	349103
23759	36336	68	applied	\N	\N	\N	\N	181893	181893	349104
23759	36340	69	applied	\N	\N	\N	\N	181894	181894	349105
23759	36342	70	applied	\N	\N	\N	\N	181895	181895	349106
23759	36346	71	applied	\N	\N	\N	\N	181896	181896	349107
23759	36348	72	applied	\N	\N	\N	\N	181897	181897	349108
23759	36357	74	applied	\N	\N	\N	\N	181899	181899	349110
23759	36359	75	applied	\N	\N	\N	\N	181900	181900	349111
23759	36362	76	applied	\N	\N	\N	\N	181901	181901	349112
23759	36365	77	applied	\N	\N	\N	\N	181902	181902	349113
23759	36367	78	applied	\N	\N	\N	\N	181903	181903	349114
23759	36371	79	applied	\N	\N	\N	\N	181904	181904	349115
23759	36381	81	applied	\N	\N	\N	\N	181905	181905	349116
23759	36382	82	applied	\N	\N	\N	\N	181906	181906	349117
23759	36383	83	applied	\N	\N	\N	\N	181907	181907	349118
23759	36386	84	applied	\N	\N	\N	\N	181908	181908	349119
23759	36387	85	applied	\N	\N	\N	\N	181909	181909	349120
23759	36394	86	applied	\N	\N	\N	\N	181910	181910	349121
23759	36395	87	applied	\N	\N	\N	\N	181911	181911	349122
23759	36398	88	applied	\N	\N	\N	\N	181912	181912	349123
23759	36402	89	applied	\N	\N	\N	\N	181913	181913	349124
23759	36405	90	applied	\N	\N	\N	\N	181914	181914	349125
23818	36816	5	applied	\N	\N	\N	\N	182305	182305	349515
23818	36817	6	applied	\N	\N	\N	\N	182306	182306	349516
23824	36828	0	applied	\N	\N	\N	\N	182331	182331	349541
23843	36870	0	applied	\N	\N	\N	\N	182426	182426	349636
23843	36871	1	applied	\N	\N	\N	\N	182427	182427	349637
23843	36872	2	applied	\N	\N	\N	\N	182428	182428	349638
23843	36873	3	applied	\N	\N	\N	\N	182429	182429	349639
23843	36874	4	applied	\N	\N	\N	\N	182430	182430	349640
23759	36669	3	applied	\N	\N	\N	\N	181828	181828	349039
23759	36672	4	applied	\N	\N	\N	\N	181829	181829	349040
23759	36674	6	applied	\N	\N	\N	\N	181831	181831	349042
23759	36675	7	applied	\N	\N	\N	\N	181832	181832	349043
23759	36676	8	applied	\N	\N	\N	\N	181833	181833	349044
23759	36677	9	applied	\N	\N	\N	\N	181834	181834	349045
23759	36307	15	applied	\N	\N	\N	\N	181840	181840	349051
23759	36358	16	applied	\N	\N	\N	\N	181841	181841	349052
23759	36370	17	applied	\N	\N	\N	\N	181842	181842	349053
23759	36377	18	applied	\N	\N	\N	\N	181843	181843	349054
23759	36310	19	applied	\N	\N	\N	\N	181844	181844	349055
23759	36315	20	applied	\N	\N	\N	\N	181845	181845	349056
23759	36427	97	applied	\N	\N	\N	\N	181921	181921	349132
23759	36431	98	applied	\N	\N	\N	\N	181922	181922	349133
23759	36437	99	applied	\N	\N	\N	\N	181923	181923	349134
23759	36438	100	applied	\N	\N	\N	\N	181924	181924	349135
23759	36441	101	applied	\N	\N	\N	\N	181925	181925	349136
23759	36444	102	applied	\N	\N	\N	\N	181926	181926	349137
23759	36448	103	applied	\N	\N	\N	\N	181927	181927	349138
23759	36454	104	applied	\N	\N	\N	\N	181928	181928	349139
23759	36458	105	applied	\N	\N	\N	\N	181929	181929	349140
23759	36463	106	applied	\N	\N	\N	\N	181930	181930	349141
23759	36467	108	applied	\N	\N	\N	\N	181932	181932	349143
23759	36471	109	applied	\N	\N	\N	\N	181933	181933	349144
23759	36475	110	applied	\N	\N	\N	\N	181934	181934	349145
23759	36480	111	applied	\N	\N	\N	\N	181935	181935	349146
23759	36483	112	applied	\N	\N	\N	\N	181936	181936	349147
23759	36484	113	applied	\N	\N	\N	\N	181937	181937	349148
23759	36489	114	applied	\N	\N	\N	\N	181938	181938	349149
23759	36492	115	applied	\N	\N	\N	\N	181939	181939	349150
23759	36499	116	applied	\N	\N	\N	\N	181940	181940	349151
23759	36500	117	applied	\N	\N	\N	\N	181941	181941	349152
23759	36509	118	applied	\N	\N	\N	\N	181942	181942	349153
23759	36510	119	applied	\N	\N	\N	\N	181943	181943	349154
23759	36514	120	applied	\N	\N	\N	\N	181944	181944	349155
23759	36517	121	applied	\N	\N	\N	\N	181945	181945	349156
23759	36520	122	applied	\N	\N	\N	\N	181946	181946	349157
23759	36521	123	applied	\N	\N	\N	\N	181947	181947	349158
23759	36434	125	applied	\N	\N	\N	\N	181949	181949	349160
23766	36718	0	applied	\N	\N	\N	\N	182106	182106	349316
23766	36719	1	applied	\N	\N	\N	\N	182107	182107	349317
23766	36725	2	applied	\N	\N	\N	\N	182108	182108	349318
23766	36726	3	applied	\N	\N	\N	\N	182109	182109	349319
23766	36727	4	applied	\N	\N	\N	\N	182110	182110	349320
23769	36732	0	applied	\N	\N	\N	\N	182115	182115	349325
23769	36733	1	applied	\N	\N	\N	\N	182116	182116	349326
23769	36734	2	applied	\N	\N	\N	\N	182117	182117	349327
23771	36732	0	applied	\N	\N	\N	\N	182120	182120	349330
23771	36735	1	applied	\N	\N	\N	\N	182121	182121	349331
23771	36736	2	applied	\N	\N	\N	\N	182122	182122	349332
23771	36737	3	applied	\N	\N	\N	\N	182123	182123	349333
23780	36751	0	applied	\N	\N	\N	\N	182150	182150	349360
23780	36752	1	applied	\N	\N	\N	\N	182151	182151	349361
23780	36753	2	applied	\N	\N	\N	\N	182152	182152	349362
23786	36763	0	applied	\N	\N	\N	\N	182174	182174	349384
23786	36761	1	applied	\N	\N	\N	\N	182175	182175	349385
23786	36762	2	applied	\N	\N	\N	\N	182176	182176	349386
23786	36764	3	applied	\N	\N	\N	\N	182177	182177	349387
23789	36763	0	applied	\N	\N	\N	\N	182186	182186	349396
23789	36765	1	applied	\N	\N	\N	\N	182187	182187	349397
23789	36766	2	applied	\N	\N	\N	\N	182188	182188	349398
23789	36764	3	applied	\N	\N	\N	\N	182189	182189	349399
23789	36767	4	applied	\N	\N	\N	\N	182190	182190	349400
23792	36769	0	applied	\N	\N	\N	\N	182199	182199	349409
23792	36770	1	applied	\N	\N	\N	\N	182200	182200	349410
23799	36768	0	applied	\N	\N	\N	\N	182222	182222	349432
23799	36771	1	applied	\N	\N	\N	\N	182223	182223	349433
23799	36772	2	applied	\N	\N	\N	\N	182224	182224	349434
23799	36773	3	applied	\N	\N	\N	\N	182225	182225	349435
23808	36795	1	applied	\N	\N	\N	\N	182266	182266	349476
23808	36796	2	applied	\N	\N	\N	\N	182267	182267	349477
23808	36797	3	applied	\N	\N	\N	\N	182268	182268	349478
23808	36798	4	applied	\N	\N	\N	\N	182269	182269	349479
23810	36799	0	applied	\N	\N	\N	\N	182273	182273	349483
23810	36800	1	applied	\N	\N	\N	\N	182274	182274	349484
23810	36801	2	applied	\N	\N	\N	\N	182275	182275	349485
23812	36802	0	applied	\N	\N	\N	\N	182279	182279	349489
23812	36803	1	applied	\N	\N	\N	\N	182280	182280	349490
23812	36804	2	applied	\N	\N	\N	\N	182281	182281	349491
23817	36812	0	applied	\N	\N	\N	\N	182295	182295	349505
23817	36813	1	applied	\N	\N	\N	\N	182296	182296	349506
23817	36814	3	applied	\N	\N	\N	\N	182297	182297	349507
23817	36815	4	applied	\N	\N	\N	\N	182298	182298	349508
23817	36816	5	applied	\N	\N	\N	\N	182299	182299	349509
23817	36817	6	applied	\N	\N	\N	\N	182300	182300	349510
23822	36825	0	applied	\N	\N	\N	\N	182323	182323	349533
23827	36839	1	applied	\N	\N	\N	\N	182351	182351	349561
23827	36840	2	applied	\N	\N	\N	\N	182352	182352	349562
23830	36841	0	applied	\N	\N	\N	\N	182361	182361	349571
23837	36853	1	applied	\N	\N	\N	\N	182406	182406	349616
23839	36854	0	applied	\N	\N	\N	\N	182410	182410	349620
23839	36856	2	applied	\N	\N	\N	\N	182412	182412	349622
23841	36860	0	applied	\N	\N	\N	\N	182416	182416	349626
23841	36861	1	applied	\N	\N	\N	\N	182417	182417	349627
23841	36862	2	applied	\N	\N	\N	\N	182418	182418	349628
23841	36863	3	applied	\N	\N	\N	\N	182419	182419	349629
23841	36864	4	applied	\N	\N	\N	\N	182420	182420	349630
23841	36865	5	applied	\N	\N	\N	\N	182421	182421	349631
23841	36866	6	applied	\N	\N	\N	\N	182422	182422	349632
23844	36877	0	applied	\N	\N	\N	\N	182433	182433	349643
23844	36878	1	applied	\N	\N	\N	\N	182434	182434	349644
23844	36879	2	applied	\N	\N	\N	\N	182435	182435	349645
23847	36794	0	applied	\N	\N	1000000000	\N	182442	182442	349652
23847	36449	1	applied	\N	\N	\N	\N	182443	182443	349653
23847	36450	2	applied	\N	\N	\N	\N	182444	182444	349654
23847	36451	3	applied	\N	\N	\N	\N	182445	182445	349655
23759	36412	92	applied	\N	\N	\N	\N	181916	181916	349127
23759	36418	94	applied	\N	\N	\N	\N	181918	181918	349129
23759	36422	95	applied	\N	\N	\N	\N	181919	181919	349130
23759	36423	96	applied	\N	\N	\N	\N	181920	181920	349131
23762	36474	84	applied	\N	\N	\N	\N	182046	182046	349256
23762	36477	85	applied	\N	\N	\N	\N	182047	182047	349257
23762	36479	86	applied	\N	\N	\N	\N	182048	182048	349258
23762	36486	87	applied	\N	\N	\N	\N	182049	182049	349259
23762	36562	88	applied	\N	\N	\N	\N	182050	182050	349260
23762	36487	89	applied	\N	\N	\N	\N	182051	182051	349261
23762	36490	90	applied	\N	\N	\N	\N	182052	182052	349262
23762	36494	91	applied	\N	\N	\N	\N	182053	182053	349263
23762	36501	92	applied	\N	\N	\N	\N	182054	182054	349264
23762	36502	93	applied	\N	\N	\N	\N	182055	182055	349265
23762	36506	94	applied	\N	\N	\N	\N	182056	182056	349266
23762	36507	95	applied	\N	\N	\N	\N	182057	182057	349267
23762	36513	96	applied	\N	\N	\N	\N	182058	182058	349268
23762	36516	97	applied	\N	\N	\N	\N	182059	182059	349269
23762	36523	99	applied	\N	\N	\N	\N	182061	182061	349271
23762	36526	100	applied	\N	\N	\N	\N	182062	182062	349272
23762	36531	101	applied	\N	\N	\N	\N	182063	182063	349273
23762	36534	102	applied	\N	\N	\N	\N	182064	182064	349274
23762	36536	103	applied	\N	\N	\N	\N	182065	182065	349275
23762	36541	104	applied	\N	\N	\N	\N	182066	182066	349276
23762	36542	106	applied	\N	\N	\N	\N	182067	182067	349277
23762	36548	107	applied	\N	\N	\N	\N	182068	182068	349278
23762	36553	108	applied	\N	\N	\N	\N	182069	182069	349279
23762	36554	109	applied	\N	\N	\N	\N	182070	182070	349280
23762	36560	110	applied	\N	\N	\N	\N	182071	182071	349281
23762	36561	111	applied	\N	\N	\N	\N	182072	182072	349282
23762	36564	112	applied	\N	\N	\N	\N	182073	182073	349283
23762	36569	113	applied	\N	\N	\N	\N	182074	182074	349284
23762	36571	114	applied	\N	\N	\N	\N	182075	182075	349285
23762	36574	115	applied	\N	\N	\N	\N	182076	182076	349286
23762	36480	117	applied	\N	\N	\N	\N	182078	182078	349288
23762	36483	118	applied	\N	\N	\N	\N	182079	182079	349289
23762	36484	119	applied	\N	\N	\N	\N	182080	182080	349290
23762	36489	120	applied	\N	\N	\N	\N	182081	182081	349291
23762	36492	121	applied	\N	\N	\N	\N	182082	182082	349292
23762	36499	122	applied	\N	\N	\N	\N	182083	182083	349293
23762	36500	123	applied	\N	\N	\N	\N	182084	182084	349294
23762	36509	124	applied	\N	\N	\N	\N	182085	182085	349295
23762	36510	125	applied	\N	\N	\N	\N	182086	182086	349296
23764	36720	0	applied	\N	\N	\N	\N	182094	182094	349304
23764	36721	1	applied	\N	\N	\N	\N	182095	182095	349305
23764	36722	2	applied	\N	\N	\N	\N	182096	182096	349306
23764	36723	3	applied	\N	\N	\N	\N	182097	182097	349307
23764	36724	4	applied	\N	\N	\N	\N	182098	182098	349308
23773	36738	0	applied	\N	\N	\N	\N	182128	182128	349338
23773	36739	1	applied	\N	\N	\N	\N	182129	182129	349339
23773	36741	3	applied	\N	\N	\N	\N	182131	182131	349341
23773	36742	4	applied	\N	\N	\N	\N	182132	182132	349342
23773	36743	5	applied	\N	\N	\N	\N	182133	182133	349343
23773	36744	6	applied	\N	\N	\N	\N	182134	182134	349344
23778	36748	0	applied	\N	\N	\N	\N	182147	182147	349357
23778	36749	1	applied	\N	\N	\N	\N	182148	182148	349358
23778	36750	2	applied	\N	\N	\N	\N	182149	182149	349359
23783	36757	0	applied	\N	\N	\N	\N	182162	182162	349372
23783	36758	1	applied	\N	\N	\N	\N	182163	182163	349373
23783	36755	2	applied	\N	\N	\N	\N	182164	182164	349374
23783	36759	3	applied	\N	\N	\N	\N	182165	182165	349375
23783	36756	4	applied	\N	\N	\N	\N	182166	182166	349376
23783	36760	5	applied	\N	\N	\N	\N	182167	182167	349377
23785	36763	0	applied	\N	\N	\N	\N	182170	182170	349380
23785	36761	1	applied	\N	\N	\N	\N	182171	182171	349381
23785	36762	2	applied	\N	\N	\N	\N	182172	182172	349382
23791	36768	0	applied	\N	\N	\N	\N	182196	182196	349406
23791	36769	1	applied	\N	\N	\N	\N	182197	182197	349407
23791	36770	2	applied	\N	\N	\N	\N	182198	182198	349408
23795	36768	0	applied	\N	\N	\N	\N	182207	182207	349417
23795	36769	1	applied	\N	\N	\N	\N	182208	182208	349418
23795	36770	2	applied	\N	\N	\N	\N	182209	182209	349419
23798	36768	0	applied	\N	\N	\N	\N	182218	182218	349428
23798	36771	1	applied	\N	\N	\N	\N	182219	182219	349429
23798	36772	2	applied	\N	\N	\N	\N	182220	182220	349430
23798	36773	3	applied	\N	\N	\N	\N	182221	182221	349431
23802	36774	0	applied	\N	\N	\N	\N	182237	182237	349447
23802	36775	1	applied	\N	\N	\N	\N	182238	182238	349448
23802	36776	2	applied	\N	\N	\N	\N	182239	182239	349449
23802	36777	3	applied	\N	\N	\N	\N	182240	182240	349450
23802	36778	4	applied	\N	\N	\N	\N	182241	182241	349451
23802	36779	5	applied	\N	\N	\N	\N	182242	182242	349452
23847	36452	4	applied	\N	\N	\N	\N	182446	182446	349656
23847	36021	5	applied	\N	\N	\N	\N	182447	182447	349657
23847	36267	6	applied	\N	\N	\N	\N	182448	182448	349658
23847	36019	7	applied	\N	\N	\N	\N	182449	182449	349659
23847	36327	8	applied	\N	\N	\N	\N	182450	182450	349660
23847	36328	9	applied	\N	\N	\N	\N	182451	182451	349661
23847	36022	10	applied	\N	\N	\N	\N	182452	182452	349662
23847	36024	12	applied	\N	\N	\N	\N	182453	182453	349663
23847	36026	13	applied	\N	\N	\N	\N	182454	182454	349664
23847	36027	14	applied	\N	\N	\N	\N	182455	182455	349665
23847	36028	15	applied	\N	\N	\N	\N	182456	182456	349666
23847	36032	16	applied	\N	\N	\N	\N	182457	182457	349667
23847	36034	17	applied	\N	\N	\N	\N	182458	182458	349668
23847	36036	18	applied	\N	\N	\N	\N	182459	182459	349669
23847	36038	19	applied	\N	\N	\N	\N	182460	182460	349670
23847	36040	20	applied	\N	\N	\N	\N	182461	182461	349671
23847	36044	22	applied	\N	\N	\N	\N	182463	182463	349673
23847	36046	23	applied	\N	\N	\N	\N	182464	182464	349674
23847	36048	24	applied	\N	\N	\N	\N	182465	182465	349675
23847	36050	25	applied	\N	\N	\N	\N	182466	182466	349676
23847	36053	26	applied	\N	\N	\N	\N	182467	182467	349677
23847	36056	27	applied	\N	\N	\N	\N	182468	182468	349678
23847	36057	28	applied	\N	\N	\N	\N	182469	182469	349679
23847	36058	29	applied	\N	\N	\N	\N	182470	182470	349680
23847	36065	30	applied	\N	\N	\N	\N	182471	182471	349681
23847	36066	31	applied	\N	\N	\N	\N	182472	182472	349682
23847	36071	32	applied	\N	\N	\N	\N	182473	182473	349683
23847	36329	33	applied	\N	\N	\N	\N	182474	182474	349684
23847	36330	34	applied	\N	\N	\N	\N	182475	182475	349685
23847	36331	35	applied	\N	\N	\N	\N	182476	182476	349686
23847	36181	36	applied	\N	\N	\N	\N	182477	182477	349687
23853	35948	57	applied	\N	\N	\N	\N	182647	182647	349855
23762	36555	83	applied	\N	\N	1000000000	\N	182045	182045	349255
23814	36803	1	applied	\N	\N	\N	\N	182286	182286	349496
23814	36804	2	applied	\N	\N	\N	\N	182287	182287	349497
23816	36808	0	applied	\N	\N	\N	\N	182291	182291	349501
23816	36809	1	applied	\N	\N	\N	\N	182292	182292	349502
23816	36810	2	applied	\N	\N	\N	\N	182293	182293	349503
23816	36811	3	applied	\N	\N	\N	\N	182294	182294	349504
23819	36818	0	applied	\N	\N	\N	\N	182307	182307	349517
23819	36822	4	applied	\N	\N	\N	\N	182311	182311	349521
23819	36823	5	applied	\N	\N	\N	\N	182312	182312	349522
23819	36824	6	applied	\N	\N	\N	\N	182313	182313	349523
23820	36824	6	applied	\N	\N	\N	\N	182320	182320	349530
23825	36828	0	applied	\N	\N	\N	\N	182339	182339	349549
23825	36829	1	applied	\N	\N	\N	\N	182340	182340	349550
23825	36830	2	applied	\N	\N	\N	\N	182341	182341	349551
23825	36832	4	applied	\N	\N	\N	\N	182343	182343	349553
23825	36827	5	applied	\N	\N	\N	\N	182344	182344	349554
23825	36833	6	applied	\N	\N	\N	\N	182345	182345	349555
23825	36834	7	applied	\N	\N	\N	\N	182346	182346	349556
23828	36794	0	applied	\N	\N	1000000000	\N	182353	182353	349563
23842	36867	0	applied	\N	\N	\N	\N	182423	182423	349633
23842	36868	1	applied	\N	\N	\N	\N	182424	182424	349634
23842	36869	2	applied	\N	\N	\N	\N	182425	182425	349635
23845	36877	0	applied	\N	\N	\N	\N	182436	182436	349646
23845	36878	1	applied	\N	\N	\N	\N	182437	182437	349647
23845	36879	2	applied	\N	\N	\N	\N	182438	182438	349648
23850	36893	0	applied	\N	\N	\N	\N	182580	182580	349789
23850	36894	1	applied	\N	\N	\N	\N	182581	182581	349790
23850	36895	2	applied	\N	\N	\N	\N	182582	182582	349791
23850	36896	3	applied	\N	\N	\N	\N	182583	182583	349792
23853	36794	0	applied	\N	\N	1000000000	\N	182590	182590	349799
23853	36449	1	applied	\N	\N	\N	\N	182591	182591	349800
23853	36450	2	applied	\N	\N	\N	\N	182592	182592	349801
23853	36451	3	applied	\N	\N	\N	\N	182593	182593	349802
23853	36452	4	applied	\N	\N	\N	\N	182594	182594	349803
23853	36267	6	applied	\N	\N	\N	\N	182596	182596	349805
23853	35875	7	applied	\N	\N	\N	\N	182597	182597	349806
23853	35876	8	applied	\N	\N	\N	\N	182598	182598	349807
23853	36327	9	applied	\N	\N	\N	\N	182599	182599	349808
23853	35879	10	applied	\N	\N	\N	\N	182600	182600	349809
23853	35913	11	applied	\N	\N	\N	\N	182601	182601	349810
23853	36328	12	applied	\N	\N	\N	\N	182602	182602	349811
23853	36329	13	applied	\N	\N	\N	\N	182603	182603	349812
23853	36330	14	applied	\N	\N	\N	\N	182604	182604	349813
23853	36331	15	applied	\N	\N	\N	\N	182605	182605	349814
23853	36181	16	applied	\N	\N	\N	\N	182606	182606	349815
23853	36182	17	applied	\N	\N	\N	\N	182607	182607	349816
23853	36183	18	applied	\N	\N	\N	\N	182608	182608	349817
23853	36332	19	applied	\N	\N	\N	\N	182609	182609	182609
23853	35880	20	applied	\N	\N	\N	\N	182610	182610	349818
23853	35883	21	applied	\N	\N	\N	\N	182611	182611	349819
23853	36185	23	applied	\N	\N	\N	\N	182613	182613	349821
23853	36203	24	applied	\N	\N	\N	\N	182614	182614	349822
23853	36204	25	applied	\N	\N	\N	\N	182615	182615	349823
23853	35884	26	applied	\N	\N	\N	\N	182616	182616	349824
23853	35887	27	applied	\N	\N	\N	\N	182617	182617	349825
23853	35889	28	applied	\N	\N	\N	\N	182618	182618	349826
23853	35891	29	applied	\N	\N	\N	\N	182619	182619	349827
23853	35893	30	applied	\N	\N	\N	\N	182620	182620	349828
23853	35895	31	applied	\N	\N	\N	\N	182621	182621	349829
23853	35896	32	applied	\N	\N	\N	\N	182622	182622	349830
23853	35899	33	applied	\N	\N	\N	\N	182623	182623	349831
23853	35901	34	applied	\N	\N	\N	\N	182624	182624	349832
23853	35903	35	applied	\N	\N	\N	\N	182625	182625	349833
23853	35905	36	applied	\N	\N	\N	\N	182626	182626	349834
23853	35907	37	applied	\N	\N	\N	\N	182627	182627	349835
23853	35909	38	applied	\N	\N	\N	\N	182628	182628	349836
23853	35914	40	applied	\N	\N	\N	\N	182630	182630	349838
23853	35915	41	applied	\N	\N	\N	\N	182631	182631	349839
23853	35918	42	applied	\N	\N	\N	\N	182632	182632	349840
23853	35921	43	applied	\N	\N	\N	\N	182633	182633	349841
23853	35923	44	applied	\N	\N	\N	\N	182634	182634	349842
23853	35924	45	applied	\N	\N	\N	\N	182635	182635	349843
23853	35927	46	applied	\N	\N	\N	\N	182636	182636	349844
23853	35929	47	applied	\N	\N	\N	\N	182637	182637	349845
23853	35930	48	applied	\N	\N	\N	\N	182638	182638	349846
23853	35933	49	applied	\N	\N	\N	\N	182639	182639	349847
23853	35935	50	applied	\N	\N	\N	\N	182640	182640	349848
23853	35937	51	applied	\N	\N	\N	\N	182641	182641	349849
23853	35939	52	applied	\N	\N	\N	\N	182642	182642	349850
23853	35941	53	applied	\N	\N	\N	\N	182643	182643	349851
23853	35943	54	applied	\N	\N	\N	\N	182644	182644	349852
23853	35944	55	applied	\N	\N	\N	\N	182645	182645	349853
23807	36795	1	applied	\N	\N	\N	\N	182261	182261	349471
23807	36796	2	applied	\N	\N	\N	\N	182262	182262	349472
23807	36797	3	applied	\N	\N	\N	\N	182263	182263	349473
23807	36798	4	applied	\N	\N	\N	\N	182264	182264	349474
23809	36799	0	applied	\N	\N	\N	\N	182270	182270	349480
23809	36800	1	applied	\N	\N	\N	\N	182271	182271	349481
23809	36801	2	applied	\N	\N	\N	\N	182272	182272	349482
23814	36802	0	applied	\N	\N	\N	\N	182285	182285	349495
23819	36820	2	applied	\N	\N	\N	\N	182309	182309	349519
23819	36821	3	applied	\N	\N	\N	\N	182310	182310	349520
23838	36855	1	applied	\N	\N	\N	\N	182408	182408	349618
23838	36856	2	applied	\N	\N	\N	\N	182409	182409	349619
23840	36857	0	applied	\N	\N	\N	\N	182413	182413	349623
23840	36858	1	applied	\N	\N	\N	\N	182414	182414	349624
23840	36859	2	applied	\N	\N	\N	\N	182415	182415	349625
23846	36877	0	applied	\N	\N	\N	\N	182439	182439	349649
23846	36878	1	applied	\N	\N	\N	\N	182440	182440	349650
23846	36879	2	applied	\N	\N	\N	\N	182441	182441	349651
23851	36897	0	applied	\N	\N	\N	\N	182584	182584	349793
23851	36898	1	applied	\N	\N	\N	\N	182585	182585	349794
23851	36899	2	applied	\N	\N	\N	\N	182586	182586	349795
23853	35951	58	applied	\N	\N	\N	\N	182648	182648	349856
23853	35955	60	applied	\N	\N	\N	\N	182650	182650	349858
23853	35957	61	applied	\N	\N	\N	\N	182651	182651	349859
23853	35959	62	applied	\N	\N	\N	\N	182652	182652	349860
23853	35960	63	applied	\N	\N	\N	\N	182653	182653	349861
23853	35961	64	applied	\N	\N	\N	\N	182654	182654	349862
23853	35965	65	applied	\N	\N	\N	\N	182655	182655	349863
23853	35967	66	applied	\N	\N	\N	\N	182656	182656	349864
23853	35968	67	applied	\N	\N	\N	\N	182657	182657	349865
23853	35971	68	applied	\N	\N	\N	\N	182658	182658	349866
23853	35973	69	applied	\N	\N	\N	\N	182659	182659	349867
23853	35974	70	applied	\N	\N	\N	\N	182660	182660	349868
23853	35975	71	applied	\N	\N	\N	\N	182661	182661	349869
23853	35976	72	applied	\N	\N	\N	\N	182662	182662	349870
23853	35977	73	applied	\N	\N	\N	\N	182663	182663	349871
23853	35983	74	applied	\N	\N	\N	\N	182664	182664	349872
23853	35984	75	applied	\N	\N	\N	\N	182665	182665	349873
23853	35989	77	applied	\N	\N	\N	\N	182667	182667	349875
23853	35991	78	applied	\N	\N	\N	\N	182668	182668	349876
23853	35993	79	applied	\N	\N	\N	\N	182669	182669	349877
23853	35995	80	applied	\N	\N	\N	\N	182670	182670	349878
23853	35997	81	applied	\N	\N	\N	\N	182671	182671	349879
23853	35998	82	applied	\N	\N	\N	\N	182672	182672	349880
23853	35999	83	applied	\N	\N	\N	\N	182673	182673	349881
23853	36000	84	applied	\N	\N	\N	\N	182674	182674	349882
23853	36005	85	applied	\N	\N	\N	\N	182675	182675	349883
23853	36006	86	applied	\N	\N	\N	\N	182676	182676	349884
23853	36009	87	applied	\N	\N	\N	\N	182677	182677	349885
23853	36011	88	applied	\N	\N	\N	\N	182678	182678	349886
23862	36903	0	applied	\N	\N	\N	\N	182739	182739	349947
23862	36904	1	applied	\N	\N	\N	\N	182740	182740	349948
23862	36910	2	applied	\N	\N	\N	\N	182741	182741	349949
23862	36905	3	applied	\N	\N	\N	\N	182742	182742	349950
23862	36907	5	applied	\N	\N	\N	\N	182744	182744	349952
23862	36908	6	applied	\N	\N	\N	\N	182745	182745	349953
23862	36911	7	applied	\N	\N	\N	\N	182746	182746	349954
23862	36909	8	applied	\N	\N	\N	\N	182747	182747	349955
23862	36912	9	applied	\N	\N	\N	\N	182748	182748	349956
23865	36920	0	applied	\N	\N	\N	\N	182766	182766	349974
23865	36921	1	applied	\N	\N	\N	\N	182767	182767	349975
23865	36922	2	applied	\N	\N	\N	\N	182768	182768	349976
23870	36929	0	applied	\N	\N	\N	\N	182784	182784	349992
23870	36930	1	applied	\N	\N	\N	\N	182785	182785	349993
23870	36931	2	applied	\N	\N	\N	\N	182786	182786	349994
23872	36932	0	applied	\N	\N	\N	\N	182790	182790	349998
23872	36933	1	applied	\N	\N	\N	\N	182791	182791	349999
23872	36934	2	applied	\N	\N	\N	\N	182792	182792	350000
23872	36935	3	applied	\N	\N	\N	\N	182793	182793	350001
23872	36936	4	applied	\N	\N	\N	\N	182794	182794	350002
23875	36938	0	applied	\N	\N	\N	\N	182802	182802	350010
23875	36939	1	applied	\N	\N	\N	\N	182803	182803	350011
23875	36940	2	applied	\N	\N	\N	\N	182804	182804	350012
23875	36941	3	applied	\N	\N	\N	\N	182805	182805	350013
23875	36942	4	applied	\N	\N	\N	\N	182806	182806	350014
23875	36943	5	applied	\N	\N	\N	\N	182807	182807	350015
23875	36944	6	applied	\N	\N	\N	\N	182808	182808	350016
23875	36945	7	applied	\N	\N	\N	\N	182809	182809	350017
23875	36946	8	applied	\N	\N	\N	\N	182810	182810	350018
23875	36947	9	applied	\N	\N	\N	\N	182811	182811	350019
23877	36794	0	applied	\N	\N	1000000000	\N	182832	182832	350040
23877	36603	2	applied	\N	\N	\N	\N	182834	182834	350041
23877	36604	3	applied	\N	\N	\N	\N	182835	182835	350042
23877	36609	4	applied	\N	\N	\N	\N	182836	182836	350043
23877	36610	5	applied	\N	\N	\N	\N	182837	182837	350044
23877	36617	6	applied	\N	\N	\N	\N	182838	182838	350045
23877	36618	7	applied	\N	\N	\N	\N	182839	182839	350046
23877	36624	8	applied	\N	\N	\N	\N	182840	182840	350047
23877	36627	9	applied	\N	\N	\N	\N	182841	182841	350048
23877	36628	10	applied	\N	\N	\N	\N	182842	182842	350049
23877	36634	11	applied	\N	\N	\N	\N	182843	182843	350050
23877	36637	12	applied	\N	\N	\N	\N	182844	182844	350051
23877	36638	13	applied	\N	\N	\N	\N	182845	182845	350052
23877	36639	14	applied	\N	\N	\N	\N	182846	182846	350053
23877	36647	15	applied	\N	\N	\N	\N	182847	182847	350054
23877	36648	16	applied	\N	\N	\N	\N	182848	182848	350055
23877	36654	17	applied	\N	\N	\N	\N	182849	182849	350056
23877	36658	18	applied	\N	\N	\N	\N	182850	182850	350057
23877	36663	19	applied	\N	\N	\N	\N	182851	182851	350058
23877	36667	20	applied	\N	\N	\N	\N	182852	182852	350059
23877	36669	21	applied	\N	\N	\N	\N	182853	182853	350060
23877	36672	22	applied	\N	\N	\N	\N	182854	182854	350061
23877	36673	23	applied	\N	\N	\N	\N	182855	182855	350062
23877	36674	24	applied	\N	\N	\N	\N	182856	182856	350063
23877	36675	25	applied	\N	\N	\N	\N	182857	182857	350064
23877	36676	26	applied	\N	\N	\N	\N	182858	182858	350065
23877	36677	27	applied	\N	\N	\N	\N	182859	182859	350066
23877	36678	28	applied	\N	\N	\N	\N	182860	182860	350067
23877	36695	29	applied	\N	\N	\N	\N	182861	182861	350068
23829	36842	1	applied	\N	\N	\N	\N	182355	182355	349565
23838	36854	0	applied	\N	\N	\N	\N	182407	182407	349617
23848	36882	2	applied	\N	\N	\N	\N	182569	182569	349778
23848	36883	3	applied	\N	\N	\N	\N	182570	182570	349779
23848	36884	4	applied	\N	\N	\N	\N	182571	182571	349780
23848	36885	5	applied	\N	\N	\N	\N	182572	182572	349781
23848	36886	6	applied	\N	\N	\N	\N	182573	182573	349782
23848	36887	7	applied	\N	\N	\N	\N	182574	182574	349783
23848	36888	8	applied	\N	\N	\N	\N	182575	182575	349784
23848	36889	9	applied	\N	\N	\N	\N	182576	182576	349785
23860	36903	0	applied	\N	\N	\N	\N	182725	182725	349933
23860	36904	1	applied	\N	\N	\N	\N	182726	182726	349934
23860	36905	2	applied	\N	\N	\N	\N	182727	182727	349935
23860	36906	3	applied	\N	\N	\N	\N	182728	182728	349936
23860	36907	4	applied	\N	\N	\N	\N	182729	182729	349937
23860	36908	5	applied	\N	\N	\N	\N	182730	182730	349938
23860	36909	6	applied	\N	\N	\N	\N	182731	182731	349939
23867	36920	0	applied	\N	\N	\N	\N	182772	182772	349980
23867	36922	2	applied	\N	\N	\N	\N	182774	182774	349982
23876	36932	0	applied	\N	\N	\N	\N	182812	182812	350020
23876	36933	1	applied	\N	\N	\N	\N	182813	182813	350021
23876	36938	2	applied	\N	\N	\N	\N	182814	182814	350022
23876	36939	3	applied	\N	\N	\N	\N	182815	182815	350023
23876	36940	4	applied	\N	\N	\N	\N	182816	182816	350024
23876	36948	5	applied	\N	\N	\N	\N	182817	182817	350025
23876	36934	6	applied	\N	\N	\N	\N	182818	182818	350026
23876	36935	7	applied	\N	\N	\N	\N	182819	182819	350027
23876	36936	8	applied	\N	\N	\N	\N	182820	182820	350028
23876	36944	9	applied	\N	\N	\N	\N	182821	182821	350029
23876	36949	10	applied	\N	\N	\N	\N	182822	182822	350030
23876	36937	11	applied	\N	\N	\N	\N	182823	182823	350031
23876	36941	12	applied	\N	\N	\N	\N	182824	182824	350032
23876	36942	13	applied	\N	\N	\N	\N	182825	182825	350033
23876	36943	14	applied	\N	\N	\N	\N	182826	182826	350034
23876	36945	16	applied	\N	\N	\N	\N	182828	182828	350036
23876	36946	17	applied	\N	\N	\N	\N	182829	182829	350037
23876	36947	18	applied	\N	\N	\N	\N	182830	182830	350038
23876	36951	19	applied	\N	\N	\N	\N	182831	182831	350039
23877	36696	30	applied	\N	\N	\N	\N	182862	182862	350069
23877	36702	31	applied	\N	\N	\N	\N	182863	182863	350070
23877	36705	32	applied	\N	\N	\N	\N	182864	182864	350071
23877	36708	33	applied	\N	\N	\N	\N	182865	182865	350072
23877	36712	34	applied	\N	\N	\N	\N	182866	182866	350073
23877	36713	35	applied	\N	\N	\N	\N	182867	182867	350074
23877	36718	36	applied	\N	\N	\N	\N	182868	182868	350075
23877	36719	37	applied	\N	\N	\N	\N	182869	182869	350076
23877	36725	38	applied	\N	\N	\N	\N	182870	182870	350077
23877	36728	39	applied	\N	\N	\N	\N	182871	182871	350078
23877	36732	41	applied	\N	\N	\N	\N	182872	182872	350079
23877	36735	42	applied	\N	\N	\N	\N	182873	182873	350080
23877	36739	44	applied	\N	\N	\N	\N	182875	182875	350082
23877	36745	45	applied	\N	\N	\N	\N	182876	182876	350083
23877	36748	46	applied	\N	\N	\N	\N	182877	182877	350084
23877	36751	47	applied	\N	\N	\N	\N	182878	182878	350085
23877	36757	48	applied	\N	\N	\N	\N	182879	182879	350086
23877	36758	49	applied	\N	\N	\N	\N	182880	182880	350087
23877	36763	50	applied	\N	\N	\N	\N	182881	182881	350088
23877	36765	51	applied	\N	\N	\N	\N	182882	182882	350089
23877	36768	52	applied	\N	\N	\N	\N	182883	182883	350090
23877	36771	53	applied	\N	\N	\N	\N	182884	182884	350091
23877	36774	54	applied	\N	\N	\N	\N	182885	182885	350092
23877	36775	55	applied	\N	\N	\N	\N	182886	182886	350093
23877	36781	56	applied	\N	\N	\N	\N	182887	182887	350094
23877	36784	57	applied	\N	\N	\N	\N	182888	182888	350095
23877	36788	58	applied	\N	\N	\N	\N	182889	182889	350096
23877	36789	59	applied	\N	\N	\N	\N	182890	182890	350097
23877	36799	61	applied	\N	\N	\N	\N	182892	182892	350099
23882	36971	0	applied	\N	\N	\N	\N	182986	182986	350193
23882	36972	1	applied	\N	\N	\N	\N	182987	182987	350194
23882	36973	2	applied	\N	\N	\N	\N	182988	182988	350195
23882	36974	3	applied	\N	\N	\N	\N	182989	182989	350196
23882	36975	4	applied	\N	\N	\N	\N	182990	182990	350197
23882	36976	5	applied	\N	\N	\N	\N	182991	182991	350198
23882	36977	6	applied	\N	\N	\N	\N	182992	182992	350199
23885	36981	0	applied	\N	\N	\N	\N	182999	182999	350206
23885	36982	1	applied	\N	\N	\N	\N	183000	183000	350207
23885	36983	2	applied	\N	\N	\N	\N	183001	183001	350208
23885	36984	3	applied	\N	\N	\N	\N	183002	183002	350209
23885	36985	4	applied	\N	\N	\N	\N	183003	183003	350210
23885	36986	5	applied	\N	\N	\N	\N	183004	183004	350211
23885	36987	6	applied	\N	\N	\N	\N	183005	183005	350212
23888	36999	0	applied	\N	\N	\N	\N	183017	183017	350224
23888	37001	3	applied	\N	\N	\N	\N	183019	183019	350226
23893	37002	0	applied	\N	\N	\N	\N	183032	183032	350239
23893	37003	1	applied	\N	\N	\N	\N	183033	183033	350240
23893	37004	2	applied	\N	\N	\N	\N	183034	183034	350241
23896	37005	0	applied	\N	\N	\N	\N	183039	183039	350246
23896	37006	1	applied	\N	\N	\N	\N	183040	183040	350247
23896	37007	2	applied	\N	\N	\N	\N	183041	183041	350248
23896	37008	3	applied	\N	\N	\N	\N	183042	183042	350249
23898	37009	0	applied	\N	\N	\N	\N	183044	183044	350251
23898	37010	1	applied	\N	\N	\N	\N	183045	183045	350252
23898	37011	2	applied	\N	\N	\N	\N	183046	183046	350253
23902	37012	0	applied	\N	\N	\N	\N	183056	183056	350263
23902	37013	1	applied	\N	\N	\N	\N	183057	183057	350264
23902	37014	2	applied	\N	\N	\N	\N	183058	183058	350265
23905	37015	0	applied	\N	\N	\N	\N	183066	183066	350273
23905	37016	1	applied	\N	\N	\N	\N	183067	183067	350274
23905	37018	3	applied	\N	\N	\N	\N	183069	183069	350276
23910	37015	0	applied	\N	\N	\N	\N	183079	183079	350286
23910	37016	1	applied	\N	\N	\N	\N	183080	183080	350287
23910	37017	2	applied	\N	\N	\N	\N	183081	183081	350288
23918	37042	0	applied	\N	\N	\N	\N	183223	183223	350430
23918	37043	1	applied	\N	\N	\N	\N	183224	183224	350431
23918	37044	2	applied	\N	\N	\N	\N	183225	183225	350432
23918	37045	3	applied	\N	\N	\N	\N	183226	183226	350433
23918	37046	4	applied	\N	\N	\N	\N	183227	183227	350434
23918	37047	5	applied	\N	\N	\N	\N	183228	183228	350435
23918	37048	6	applied	\N	\N	\N	\N	183229	183229	350436
23918	37049	7	applied	\N	\N	\N	\N	183230	183230	350437
23918	37050	8	applied	\N	\N	\N	\N	183231	183231	350438
23918	37051	9	applied	\N	\N	\N	\N	183232	183232	350439
23843	36876	6	applied	\N	\N	\N	\N	182432	182432	349642
23848	36880	0	applied	\N	\N	\N	\N	182567	182567	349776
23847	36078	41	applied	\N	\N	\N	\N	182482	182482	349691
23847	36081	42	applied	\N	\N	\N	\N	182483	182483	349692
23847	36085	43	applied	\N	\N	\N	\N	182484	182484	349693
23847	36088	44	applied	\N	\N	\N	\N	182485	182485	349694
23847	36091	45	applied	\N	\N	\N	\N	182486	182486	349695
23847	36092	46	applied	\N	\N	\N	\N	182487	182487	349696
23847	36093	47	applied	\N	\N	\N	\N	182488	182488	349697
23847	36101	48	applied	\N	\N	\N	\N	182489	182489	349698
23847	36104	49	applied	\N	\N	\N	\N	182490	182490	349699
23847	36107	50	applied	\N	\N	\N	\N	182491	182491	349700
23847	36108	51	applied	\N	\N	\N	\N	182492	182492	349701
23847	36113	52	applied	\N	\N	\N	\N	182493	182493	349702
23847	36117	53	applied	\N	\N	\N	\N	182494	182494	349703
23847	36120	54	applied	\N	\N	\N	\N	182495	182495	349704
23847	36121	55	applied	\N	\N	\N	\N	182496	182496	349705
23847	36126	56	applied	\N	\N	\N	\N	182497	182497	349706
23847	36133	58	applied	\N	\N	\N	\N	182499	182499	349708
23847	36134	59	applied	\N	\N	\N	\N	182500	182500	349709
23847	36140	60	applied	\N	\N	\N	\N	182501	182501	349710
23847	36143	61	applied	\N	\N	\N	\N	182502	182502	349711
23847	36146	62	applied	\N	\N	\N	\N	182503	182503	349712
23847	36151	63	applied	\N	\N	\N	\N	182504	182504	349713
23847	36155	64	applied	\N	\N	\N	\N	182505	182505	349714
23847	36158	65	applied	\N	\N	\N	\N	182506	182506	349715
23847	36162	66	applied	\N	\N	\N	\N	182507	182507	349716
23847	36163	67	applied	\N	\N	\N	\N	182508	182508	349717
23847	36164	68	applied	\N	\N	\N	\N	182509	182509	349718
23847	36172	69	applied	\N	\N	\N	\N	182510	182510	349719
23847	36175	70	applied	\N	\N	\N	\N	182511	182511	349720
23847	36178	71	applied	\N	\N	\N	\N	182512	182512	349721
23847	36179	72	applied	\N	\N	\N	\N	182513	182513	349722
23847	36180	73	applied	\N	\N	\N	\N	182514	182514	349723
23847	36196	75	applied	\N	\N	\N	\N	182516	182516	349725
23847	36200	76	applied	\N	\N	\N	\N	182517	182517	349726
23847	36205	77	applied	\N	\N	\N	\N	182518	182518	349727
23847	36206	78	applied	\N	\N	\N	\N	182519	182519	349728
23847	36212	79	applied	\N	\N	\N	\N	182520	182520	349729
23847	36213	80	applied	\N	\N	\N	\N	182521	182521	349730
23847	36184	81	applied	\N	\N	\N	\N	182522	182522	349731
23847	36185	82	applied	\N	\N	\N	\N	182523	182523	349732
23847	36203	83	applied	\N	\N	\N	\N	182524	182524	349733
23847	36204	84	applied	\N	\N	\N	\N	182525	182525	349734
23847	36214	85	applied	\N	\N	\N	\N	182526	182526	349735
23847	36222	86	applied	\N	\N	\N	\N	182527	182527	349736
23847	36225	87	applied	\N	\N	\N	\N	182528	182528	349737
23847	36228	88	applied	\N	\N	\N	\N	182529	182529	349738
23847	36231	89	applied	\N	\N	\N	\N	182530	182530	349739
23847	36235	90	applied	\N	\N	\N	\N	182531	182531	349740
23847	36239	92	applied	\N	\N	\N	\N	182533	182533	349742
23847	36245	93	applied	\N	\N	\N	\N	182534	182534	349743
23847	36246	94	applied	\N	\N	\N	\N	182535	182535	349744
23847	36251	95	applied	\N	\N	\N	\N	182536	182536	349745
23847	36257	96	applied	\N	\N	\N	\N	182537	182537	349746
23847	36258	97	applied	\N	\N	\N	\N	182538	182538	349747
23847	36263	98	applied	\N	\N	\N	\N	182539	182539	349748
23847	36268	99	applied	\N	\N	\N	\N	182540	182540	349749
23847	36271	100	applied	\N	\N	\N	\N	182541	182541	349750
23847	36272	101	applied	\N	\N	\N	\N	182542	182542	349751
23847	36277	102	applied	\N	\N	\N	\N	182543	182543	349752
23847	36281	103	applied	\N	\N	\N	\N	182544	182544	349753
23847	36284	104	applied	\N	\N	\N	\N	182545	182545	349754
23847	36288	105	applied	\N	\N	\N	\N	182546	182546	349755
23847	36292	106	applied	\N	\N	\N	\N	182547	182547	349756
23847	36295	107	applied	\N	\N	\N	\N	182548	182548	349757
23847	36302	109	applied	\N	\N	\N	\N	182550	182550	349759
23847	36305	110	applied	\N	\N	\N	\N	182551	182551	349760
23847	36308	111	applied	\N	\N	\N	\N	182552	182552	349761
23847	36312	112	applied	\N	\N	\N	\N	182553	182553	349762
23847	36313	113	applied	\N	\N	\N	\N	182554	182554	349763
23847	36318	114	applied	\N	\N	\N	\N	182555	182555	349764
23847	36319	115	applied	\N	\N	\N	\N	182556	182556	349765
23847	36325	116	applied	\N	\N	\N	\N	182557	182557	349766
23847	36333	117	applied	\N	\N	\N	\N	182558	182558	349767
23847	36334	118	applied	\N	\N	\N	\N	182559	182559	349768
23847	36341	119	applied	\N	\N	\N	\N	182560	182560	349769
23847	36344	120	applied	\N	\N	\N	\N	182561	182561	349770
23847	36347	121	applied	\N	\N	\N	\N	182562	182562	349771
23847	36350	122	applied	\N	\N	\N	\N	182563	182563	349772
23847	36351	123	applied	\N	\N	\N	\N	182564	182564	349773
23847	36352	124	applied	\N	\N	\N	\N	182565	182565	349774
23918	37052	10	applied	\N	\N	\N	\N	183233	183233	350440
23920	37056	0	applied	\N	\N	\N	\N	183237	183237	350444
23920	37057	1	applied	\N	\N	\N	\N	183238	183238	350445
23920	37058	2	applied	\N	\N	\N	\N	183239	183239	350446
23920	37059	3	applied	\N	\N	\N	\N	183240	183240	350447
23923	37060	0	applied	\N	\N	\N	\N	183247	183247	350454
23923	37061	1	applied	\N	\N	\N	\N	183248	183248	350455
23923	37062	2	applied	\N	\N	\N	\N	183249	183249	350456
23925	37063	0	applied	\N	\N	\N	\N	183253	183253	350460
23925	37064	1	applied	\N	\N	\N	\N	183254	183254	350461
23925	37065	2	applied	\N	\N	\N	\N	183255	183255	350462
23927	37066	0	applied	\N	\N	\N	\N	183259	183259	350466
23927	37067	1	applied	\N	\N	\N	\N	183260	183260	350467
23927	37068	2	applied	\N	\N	\N	\N	183261	183261	350468
23931	37083	0	applied	\N	\N	\N	\N	183280	183280	350487
23931	37084	1	applied	\N	\N	\N	\N	183281	183281	350488
23933	37086	0	applied	\N	\N	\N	\N	183286	183286	350493
23933	37087	1	applied	\N	\N	\N	\N	183287	183287	350494
23933	37088	2	applied	\N	\N	\N	\N	183288	183288	350495
23939	37093	0	applied	\N	\N	\N	\N	183307	183307	350514
23939	37090	1	applied	\N	\N	\N	\N	183308	183308	350515
23939	37094	2	applied	\N	\N	\N	\N	183309	183309	350516
23939	37092	3	applied	\N	\N	\N	\N	183310	183310	350517
23939	37095	4	applied	\N	\N	\N	\N	183311	183311	350518
23943	37102	0	applied	\N	\N	\N	\N	183329	183329	350536
23943	37103	1	applied	\N	\N	\N	\N	183330	183330	350537
23943	37104	2	applied	\N	\N	\N	\N	183331	183331	350538
23946	37102	0	applied	\N	\N	\N	\N	183338	183338	350545
23946	37103	1	applied	\N	\N	\N	\N	183339	183339	350546
23946	37104	2	applied	\N	\N	\N	\N	183340	183340	350547
23847	36183	38	applied	\N	\N	\N	\N	182479	182479	349689
23847	36332	39	applied	\N	\N	\N	\N	182480	182480	182480
23852	36898	1	applied	\N	\N	\N	\N	182588	182588	349797
23852	36899	2	applied	\N	\N	\N	\N	182589	182589	349798
23853	36013	89	applied	\N	\N	\N	\N	182679	182679	349887
23853	36015	90	applied	\N	\N	\N	\N	182680	182680	349888
23853	36016	91	applied	\N	\N	\N	\N	182681	182681	349889
23853	36019	92	applied	\N	\N	\N	\N	182682	182682	349890
23853	36022	93	applied	\N	\N	\N	\N	182683	182683	349891
23853	36024	94	applied	\N	\N	\N	\N	182684	182684	349892
23853	36026	95	applied	\N	\N	\N	\N	182685	182685	349893
23853	36027	96	applied	\N	\N	\N	\N	182686	182686	349894
23853	36028	97	applied	\N	\N	\N	\N	182687	182687	349895
23853	36032	98	applied	\N	\N	\N	\N	182688	182688	349896
23853	36034	99	applied	\N	\N	\N	\N	182689	182689	349897
23853	36036	100	applied	\N	\N	\N	\N	182690	182690	349898
23853	36038	101	applied	\N	\N	\N	\N	182691	182691	349899
23853	36040	102	applied	\N	\N	\N	\N	182692	182692	349900
23853	36044	104	applied	\N	\N	\N	\N	182694	182694	349902
23853	36046	105	applied	\N	\N	\N	\N	182695	182695	349903
23853	36048	107	applied	\N	\N	\N	\N	182696	182696	349904
23853	36050	108	applied	\N	\N	\N	\N	182697	182697	349905
23853	36053	109	applied	\N	\N	\N	\N	182698	182698	349906
23853	36056	110	applied	\N	\N	\N	\N	182699	182699	349907
23853	36057	111	applied	\N	\N	\N	\N	182700	182700	349908
23853	36058	112	applied	\N	\N	\N	\N	182701	182701	349909
23853	36065	113	applied	\N	\N	\N	\N	182702	182702	349910
23853	36066	114	applied	\N	\N	\N	\N	182703	182703	349911
23853	36071	115	applied	\N	\N	\N	\N	182704	182704	349912
23853	36075	116	applied	\N	\N	\N	\N	182705	182705	349913
23853	36078	117	applied	\N	\N	\N	\N	182706	182706	349914
23853	36081	118	applied	\N	\N	\N	\N	182707	182707	349915
23853	36085	119	applied	\N	\N	\N	\N	182708	182708	349916
23853	36088	120	applied	\N	\N	\N	\N	182709	182709	349917
23853	36092	122	applied	\N	\N	\N	\N	182711	182711	349919
23853	36093	123	applied	\N	\N	\N	\N	182712	182712	349920
23853	36101	124	applied	\N	\N	\N	\N	182713	182713	349921
23853	36104	125	applied	\N	\N	\N	\N	182714	182714	349922
23854	36900	0	applied	\N	\N	\N	\N	182715	182715	349923
23854	36901	1	applied	\N	\N	\N	\N	182716	182716	349924
23854	36902	2	applied	\N	\N	\N	\N	182717	182717	349925
23859	36903	0	applied	\N	\N	\N	\N	182718	182718	349926
23859	36904	1	applied	\N	\N	\N	\N	182719	182719	349927
23859	36905	2	applied	\N	\N	\N	\N	182720	182720	349928
23859	36906	3	applied	\N	\N	\N	\N	182721	182721	349929
23859	36907	4	applied	\N	\N	\N	\N	182722	182722	349930
23859	36908	5	applied	\N	\N	\N	\N	182723	182723	349931
23859	36909	6	applied	\N	\N	\N	\N	182724	182724	349932
23861	36903	0	applied	\N	\N	\N	\N	182732	182732	349940
23861	36904	1	applied	\N	\N	\N	\N	182733	182733	349941
23861	36906	3	applied	\N	\N	\N	\N	182735	182735	349943
23861	36907	4	applied	\N	\N	\N	\N	182736	182736	349944
23861	36908	5	applied	\N	\N	\N	\N	182737	182737	349945
23861	36909	6	applied	\N	\N	\N	\N	182738	182738	349946
23863	36903	0	applied	\N	\N	\N	\N	182749	182749	349957
23863	36904	1	applied	\N	\N	\N	\N	182750	182750	349958
23863	36910	2	applied	\N	\N	\N	\N	182751	182751	349959
23863	36905	3	applied	\N	\N	\N	\N	182752	182752	349960
23863	36906	4	applied	\N	\N	\N	\N	182753	182753	349961
23863	36907	5	applied	\N	\N	\N	\N	182754	182754	349962
23863	36908	6	applied	\N	\N	\N	\N	182755	182755	349963
23863	36911	7	applied	\N	\N	\N	\N	182756	182756	349964
23863	36909	8	applied	\N	\N	\N	\N	182757	182757	349965
23863	36912	9	applied	\N	\N	\N	\N	182758	182758	349966
23864	36913	0	applied	\N	\N	\N	\N	182759	182759	349967
23864	36914	1	applied	\N	\N	\N	\N	182760	182760	349968
23864	36916	3	applied	\N	\N	\N	\N	182762	182762	349970
23864	36917	4	applied	\N	\N	\N	\N	182763	182763	349971
23864	36918	5	applied	\N	\N	\N	\N	182764	182764	349972
23864	36919	6	applied	\N	\N	\N	\N	182765	182765	349973
23866	36920	0	applied	\N	\N	\N	\N	182769	182769	349977
23866	36921	1	applied	\N	\N	\N	\N	182770	182770	349978
23866	36922	2	applied	\N	\N	\N	\N	182771	182771	349979
23868	36923	0	applied	\N	\N	\N	\N	182775	182775	349983
23868	36924	1	applied	\N	\N	\N	\N	182776	182776	349984
23869	36929	0	applied	\N	\N	\N	\N	182781	182781	349989
23869	36930	1	applied	\N	\N	\N	\N	182782	182782	349990
23869	36931	2	applied	\N	\N	\N	\N	182783	182783	349991
23879	36948	0	applied	\N	\N	\N	\N	182956	182956	350163
23879	36952	1	applied	\N	\N	\N	\N	182957	182957	350164
23879	36949	2	applied	\N	\N	\N	\N	182958	182958	350165
23879	36950	3	applied	\N	\N	\N	\N	182959	182959	350166
23879	36951	5	applied	\N	\N	\N	\N	182961	182961	350168
23879	36954	6	applied	\N	\N	\N	\N	182962	182962	350169
23883	36978	0	applied	\N	\N	\N	\N	182993	182993	350200
23883	36979	1	applied	\N	\N	\N	\N	182994	182994	350201
23883	36980	2	applied	\N	\N	\N	\N	182995	182995	350202
23889	36999	0	applied	\N	\N	\N	\N	183020	183020	350227
23889	37000	2	applied	\N	\N	\N	\N	183021	183021	350228
23889	37001	3	applied	\N	\N	\N	\N	183022	183022	350229
23891	37002	0	applied	\N	\N	\N	\N	183026	183026	350233
23891	37003	1	applied	\N	\N	\N	\N	183027	183027	350234
23891	37004	2	applied	\N	\N	\N	\N	183028	183028	350235
23894	37004	0	applied	\N	\N	\N	\N	183035	183035	350242
23897	37007	0	applied	\N	\N	\N	\N	183043	183043	350250
23899	37012	0	applied	\N	\N	\N	\N	183047	183047	350254
23899	37013	1	applied	\N	\N	\N	\N	183048	183048	350255
23899	37014	2	applied	\N	\N	\N	\N	183049	183049	350256
23912	37020	0	applied	\N	\N	\N	\N	183086	183086	350293
23912	37021	1	applied	\N	\N	\N	\N	183087	183087	350294
23912	37022	2	applied	\N	\N	\N	\N	183088	183088	350295
23912	37023	3	applied	\N	\N	\N	\N	183089	183089	350296
23912	37024	4	applied	\N	\N	\N	\N	183090	183090	350297
23912	37025	5	applied	\N	\N	\N	\N	183091	183091	350298
23912	37026	6	applied	\N	\N	\N	\N	183092	183092	350299
23914	37027	0	applied	\N	\N	\N	\N	183100	183100	350307
23914	37028	1	applied	\N	\N	\N	\N	183101	183101	350308
23914	37029	2	applied	\N	\N	\N	\N	183102	183102	350309
23915	37030	0	applied	\N	\N	\N	\N	183103	183103	350310
23915	37031	1	applied	\N	\N	\N	\N	183104	183104	350311
23915	37032	2	applied	\N	\N	\N	\N	183105	183105	350312
23915	37033	3	applied	\N	\N	\N	\N	183106	183106	350313
23849	36891	1	applied	\N	\N	\N	\N	182578	182578	349787
23849	36892	2	applied	\N	\N	\N	\N	182579	182579	349788
23871	36929	0	applied	\N	\N	\N	\N	182787	182787	349995
23871	36930	1	applied	\N	\N	\N	\N	182788	182788	349996
23871	36931	2	applied	\N	\N	\N	\N	182789	182789	349997
23873	36932	0	applied	\N	\N	\N	\N	182796	182796	350004
23873	36933	1	applied	\N	\N	\N	\N	182797	182797	350005
23873	36934	2	applied	\N	\N	\N	\N	182798	182798	350006
23873	36935	3	applied	\N	\N	\N	\N	182799	182799	350007
23873	36936	4	applied	\N	\N	\N	\N	182800	182800	350008
23873	36937	5	applied	\N	\N	\N	\N	182801	182801	350009
23881	36962	0	applied	\N	\N	\N	\N	182977	182977	350184
23881	36963	1	applied	\N	\N	\N	\N	182978	182978	350185
23881	36964	2	applied	\N	\N	\N	\N	182979	182979	350186
23881	36965	3	applied	\N	\N	\N	\N	182980	182980	350187
23881	36966	4	applied	\N	\N	\N	\N	182981	182981	350188
23881	36968	6	applied	\N	\N	\N	\N	182983	182983	350190
23881	36969	7	applied	\N	\N	\N	\N	182984	182984	350191
23881	36970	8	applied	\N	\N	\N	\N	182985	182985	350192
23887	36991	0	applied	\N	\N	\N	\N	183009	183009	350216
23887	36992	1	applied	\N	\N	\N	\N	183010	183010	350217
23887	36993	2	applied	\N	\N	\N	\N	183011	183011	350218
23887	36994	3	applied	\N	\N	1000000000	\N	183012	183012	350219
23887	36995	4	applied	\N	\N	\N	\N	183013	183013	350220
23887	36996	5	applied	\N	\N	\N	\N	183014	183014	350221
23887	36997	6	applied	\N	\N	\N	\N	183015	183015	350222
23887	36998	7	applied	\N	\N	\N	\N	183016	183016	350223
23890	36999	0	applied	\N	\N	\N	\N	183023	183023	350230
23890	37000	2	applied	\N	\N	\N	\N	183024	183024	350231
23890	37001	3	applied	\N	\N	\N	\N	183025	183025	350232
23901	37012	0	applied	\N	\N	\N	\N	183053	183053	350260
23901	37013	1	applied	\N	\N	\N	\N	183054	183054	350261
23904	37015	0	applied	\N	\N	\N	\N	183062	183062	350269
23904	37016	1	applied	\N	\N	\N	\N	183063	183063	350270
23904	37017	2	applied	\N	\N	\N	\N	183064	183064	350271
23904	37018	3	applied	\N	\N	\N	\N	183065	183065	350272
23906	37018	0	applied	\N	\N	\N	\N	183070	183070	350277
23909	37015	0	applied	\N	\N	\N	\N	183076	183076	350283
23909	37016	1	applied	\N	\N	\N	\N	183077	183077	350284
23909	37017	2	applied	\N	\N	\N	\N	183078	183078	350285
23911	37015	0	applied	\N	\N	\N	\N	183082	183082	350289
23911	37016	1	applied	\N	\N	\N	\N	183083	183083	350290
23911	37019	2	applied	\N	\N	\N	\N	183084	183084	350291
23911	37017	3	applied	\N	\N	\N	\N	183085	183085	350292
23915	37034	4	applied	\N	\N	\N	\N	183107	183107	350314
23915	37035	5	applied	\N	\N	\N	\N	183108	183108	350315
23915	37036	6	applied	\N	\N	\N	\N	183109	183109	350316
23915	37037	7	applied	\N	\N	\N	\N	183110	183110	350317
23915	37039	9	applied	\N	\N	\N	\N	183112	183112	350319
23915	37040	10	applied	\N	\N	\N	\N	183113	183113	350320
23915	37041	11	applied	\N	\N	\N	\N	183114	183114	350321
23917	37042	0	applied	\N	\N	\N	\N	183212	183212	350419
23917	37043	1	applied	\N	\N	\N	\N	183213	183213	350420
23917	37044	2	applied	\N	\N	\N	\N	183214	183214	350421
23917	37045	3	applied	\N	\N	\N	\N	183215	183215	350422
23917	37046	4	applied	\N	\N	\N	\N	183216	183216	350423
23917	37047	5	applied	\N	\N	\N	\N	183217	183217	350424
23917	37048	6	applied	\N	\N	\N	\N	183218	183218	350425
23917	37049	7	applied	\N	\N	\N	\N	183219	183219	350426
23917	37050	8	applied	\N	\N	\N	\N	183220	183220	350427
23917	37051	9	applied	\N	\N	\N	\N	183221	183221	350428
23917	37052	10	applied	\N	\N	\N	\N	183222	183222	350429
23919	37053	0	applied	\N	\N	\N	\N	183234	183234	350441
23919	37054	1	applied	\N	\N	\N	\N	183235	183235	350442
23922	37060	0	applied	\N	\N	\N	\N	183244	183244	350451
23922	37061	1	applied	\N	\N	\N	\N	183245	183245	350452
23922	37062	2	applied	\N	\N	\N	\N	183246	183246	350453
23924	37063	0	applied	\N	\N	\N	\N	183250	183250	350457
23924	37064	1	applied	\N	\N	\N	\N	183251	183251	350458
23924	37065	2	applied	\N	\N	\N	\N	183252	183252	350459
23926	37066	0	applied	\N	\N	\N	\N	183256	183256	350463
23926	37067	1	applied	\N	\N	\N	\N	183257	183257	350464
23926	37068	2	applied	\N	\N	\N	\N	183258	183258	350465
23929	37073	0	applied	\N	\N	\N	\N	183266	183266	350473
23929	37074	1	applied	\N	\N	\N	\N	183267	183267	350474
23929	37075	2	applied	\N	\N	\N	\N	183268	183268	350475
23929	37076	3	applied	\N	\N	\N	\N	183269	183269	350476
23932	37083	0	applied	\N	\N	\N	\N	183283	183283	350490
23932	37084	1	applied	\N	\N	\N	\N	183284	183284	350491
23932	37085	2	applied	\N	\N	\N	\N	183285	183285	350492
23934	37090	1	applied	\N	\N	\N	\N	183290	183290	350497
23934	37091	2	applied	\N	\N	\N	\N	183291	183291	350498
23934	37092	3	applied	\N	\N	\N	\N	183292	183292	350499
23936	37089	0	applied	\N	\N	\N	\N	183295	183295	350502
23936	37090	1	applied	\N	\N	\N	\N	183296	183296	350503
23936	37092	2	applied	\N	\N	\N	\N	183297	183297	350504
23938	37093	0	applied	\N	\N	\N	\N	183302	183302	350509
23938	37090	1	applied	\N	\N	\N	\N	183303	183303	350510
23938	37094	2	applied	\N	\N	\N	\N	183304	183304	350511
23938	37092	3	applied	\N	\N	\N	\N	183305	183305	350512
23938	37095	4	applied	\N	\N	\N	\N	183306	183306	350513
23940	37093	0	applied	\N	\N	\N	\N	183312	183312	350519
23940	37090	1	applied	\N	\N	\N	\N	183313	183313	350520
23940	37094	2	applied	\N	\N	\N	\N	183314	183314	350521
23940	37092	3	applied	\N	\N	\N	\N	183315	183315	350522
23940	37095	4	applied	\N	\N	\N	\N	183316	183316	350523
23941	37097	1	applied	\N	\N	\N	\N	183318	183318	350525
23950	37105	0	applied	\N	\N	\N	\N	183350	183350	350557
23950	37106	1	applied	\N	\N	\N	\N	183351	183351	350558
23950	37107	2	applied	\N	\N	\N	\N	183352	183352	350559
23950	37108	3	applied	\N	\N	\N	\N	183353	183353	350560
23950	37109	4	applied	\N	\N	\N	\N	183354	183354	350561
23950	37110	5	applied	\N	\N	\N	\N	183355	183355	350562
23951	37105	0	applied	\N	\N	\N	\N	183356	183356	350563
23951	37106	1	applied	\N	\N	\N	\N	183357	183357	350564
23951	37111	2	applied	\N	\N	\N	\N	183358	183358	350565
23951	37107	3	applied	\N	\N	\N	\N	183359	183359	350566
23951	37108	4	applied	\N	\N	\N	\N	183360	183360	350567
23951	37112	5	applied	\N	\N	\N	\N	183361	183361	350568
23951	37109	6	applied	\N	\N	\N	\N	183362	183362	350569
23951	37110	7	applied	\N	\N	\N	\N	183363	183363	350570
23951	37113	8	applied	\N	\N	\N	\N	183364	183364	350571
23868	36928	5	applied	\N	\N	\N	\N	182780	182780	349988
23877	36813	66	applied	\N	\N	\N	\N	182897	182897	350104
23877	36818	67	applied	\N	\N	\N	\N	182898	182898	350105
23877	36819	68	applied	\N	\N	\N	\N	182899	182899	350106
23877	36825	69	applied	\N	\N	\N	\N	182900	182900	350107
23877	36828	70	applied	\N	\N	\N	\N	182901	182901	350108
23877	36829	71	applied	\N	\N	\N	\N	182902	182902	350109
23877	36835	72	applied	\N	\N	\N	\N	182903	182903	350110
23877	36838	73	applied	\N	\N	\N	\N	182904	182904	350111
23877	36841	74	applied	\N	\N	\N	\N	182905	182905	350112
23877	36842	75	applied	\N	\N	\N	\N	182906	182906	350113
23877	36848	76	applied	\N	\N	\N	\N	182907	182907	350114
23877	36854	77	applied	\N	\N	\N	\N	182908	182908	350115
23877	36857	78	applied	\N	\N	\N	\N	182909	182909	350116
23877	36860	79	applied	\N	\N	\N	\N	182910	182910	350117
23877	36861	80	applied	\N	\N	\N	\N	182911	182911	350118
23877	36867	81	applied	\N	\N	\N	\N	182912	182912	350119
23877	36871	83	applied	\N	\N	\N	\N	182914	182914	350121
23877	36877	84	applied	\N	\N	\N	\N	182915	182915	350122
23877	36880	85	applied	\N	\N	\N	\N	182916	182916	350123
23877	36881	86	applied	\N	\N	\N	\N	182917	182917	350124
23877	36882	87	applied	\N	\N	\N	\N	182918	182918	350125
23877	36890	88	applied	\N	\N	\N	\N	182919	182919	350126
23877	36893	89	applied	\N	\N	\N	\N	182920	182920	350127
23877	36897	90	applied	\N	\N	\N	\N	182921	182921	350128
23877	36900	91	applied	\N	\N	\N	\N	182922	182922	350129
23877	36903	92	applied	\N	\N	\N	\N	182923	182923	350130
23877	36904	93	applied	\N	\N	\N	\N	182924	182924	350131
23877	36910	94	applied	\N	\N	\N	\N	182925	182925	350132
23877	36913	95	applied	\N	\N	\N	\N	182926	182926	350133
23877	36914	96	applied	\N	\N	\N	\N	182927	182927	350134
23877	36920	97	applied	\N	\N	\N	\N	182928	182928	350135
23877	36923	98	applied	\N	\N	\N	\N	182929	182929	350136
23877	36929	100	applied	\N	\N	\N	\N	182931	182931	350138
23877	36932	101	applied	\N	\N	\N	\N	182932	182932	350139
23877	36933	102	applied	\N	\N	\N	\N	182933	182933	350140
23877	36938	103	applied	\N	\N	\N	\N	182934	182934	350141
23877	36939	104	applied	\N	\N	\N	\N	182935	182935	350142
23877	36940	105	applied	\N	\N	\N	\N	182936	182936	350143
23877	36948	106	applied	\N	\N	\N	\N	182937	182937	350144
23877	36611	107	applied	\N	\N	\N	\N	182938	182938	350145
23877	36614	108	applied	\N	\N	\N	\N	182939	182939	350146
23877	36605	109	applied	\N	\N	\N	\N	182940	182940	350147
23877	36621	110	applied	\N	\N	\N	\N	182941	182941	350148
23877	36632	111	applied	\N	\N	\N	\N	182942	182942	350149
23877	36644	112	applied	\N	\N	\N	\N	182943	182943	350150
23877	36655	113	applied	\N	\N	\N	\N	182944	182944	350151
23877	36665	114	applied	\N	\N	\N	\N	182945	182945	350152
23877	36681	115	applied	\N	\N	\N	\N	182946	182946	350153
23877	36700	117	applied	\N	\N	\N	\N	182948	182948	350155
23877	36710	118	applied	\N	\N	\N	\N	182949	182949	350156
23877	36723	119	applied	\N	\N	\N	\N	182950	182950	350157
23877	36731	120	applied	\N	\N	\N	\N	182951	182951	350158
23877	36744	121	applied	\N	\N	\N	\N	182952	182952	350159
23877	36752	122	applied	\N	\N	\N	\N	182953	182953	350160
23877	36761	123	applied	\N	\N	\N	\N	182954	182954	350161
23877	36778	124	applied	\N	\N	\N	\N	182955	182955	350162
23880	36948	0	applied	\N	\N	\N	\N	182963	182963	350170
23880	36952	1	applied	\N	\N	\N	\N	182964	182964	350171
23880	36955	2	applied	\N	\N	\N	\N	182965	182965	350172
23880	36956	3	applied	\N	\N	\N	\N	182966	182966	350173
23880	36949	4	applied	\N	\N	\N	\N	182967	182967	350174
23880	36957	5	applied	\N	\N	\N	\N	182968	182968	350175
23880	36950	6	applied	\N	\N	\N	\N	182969	182969	350176
23880	36953	7	applied	\N	\N	\N	\N	182970	182970	350177
23880	36954	9	applied	\N	\N	\N	\N	182972	182972	350179
23880	36958	10	applied	\N	\N	\N	\N	182973	182973	350180
23880	36959	11	applied	\N	\N	\N	\N	182974	182974	350181
23880	36960	12	applied	\N	\N	\N	\N	182975	182975	350182
23880	36961	13	applied	\N	\N	\N	\N	182976	182976	350183
23884	36978	0	applied	\N	\N	\N	\N	182996	182996	350203
23884	36979	1	applied	\N	\N	\N	\N	182997	182997	350204
23884	36980	2	applied	\N	\N	\N	\N	182998	182998	350205
23886	36988	0	applied	\N	\N	\N	\N	183006	183006	350213
23886	36989	1	applied	\N	\N	\N	\N	183007	183007	350214
23886	36990	2	applied	\N	\N	\N	\N	183008	183008	350215
23892	37002	0	applied	\N	\N	\N	\N	183029	183029	350236
23892	37003	1	applied	\N	\N	\N	\N	183030	183030	350237
23892	37004	2	applied	\N	\N	\N	\N	183031	183031	350238
23895	37002	0	applied	\N	\N	\N	\N	183036	183036	350243
23895	37003	1	applied	\N	\N	\N	\N	183037	183037	350244
23941	37098	2	applied	\N	\N	\N	\N	183319	183319	350526
23941	37099	3	applied	\N	\N	\N	\N	183320	183320	350527
23941	37100	4	applied	\N	\N	\N	\N	183321	183321	350528
23941	37101	5	applied	\N	\N	\N	\N	183322	183322	350529
23944	37102	0	applied	\N	\N	\N	\N	183332	183332	350539
23944	37103	1	applied	\N	\N	\N	\N	183333	183333	350540
23944	37104	2	applied	\N	\N	\N	\N	183334	183334	350541
23947	37102	0	applied	\N	\N	\N	\N	183341	183341	350548
23947	37103	1	applied	\N	\N	\N	\N	183342	183342	350549
23947	37104	2	applied	\N	\N	\N	\N	183343	183343	350550
23957	37120	0	applied	\N	\N	\N	\N	183389	183389	350596
23957	37121	1	applied	\N	\N	\N	\N	183390	183390	350597
23957	37122	2	applied	\N	\N	\N	\N	183391	183391	350598
23962	37132	0	applied	\N	\N	\N	\N	183406	183406	350613
23962	37133	1	applied	\N	\N	\N	\N	183407	183407	350614
23962	37134	2	applied	\N	\N	\N	\N	183408	183408	350615
23962	37136	4	applied	\N	\N	\N	\N	183410	183410	350617
23962	37137	5	applied	\N	\N	\N	\N	183411	183411	350618
23962	37138	6	applied	\N	\N	\N	\N	183412	183412	350619
23967	37146	0	applied	\N	\N	\N	\N	183548	183548	350755
23967	37147	1	applied	\N	\N	\N	\N	183549	183549	350756
23974	37179	0	applied	\N	\N	\N	\N	183613	183613	350820
23974	37180	2	applied	\N	\N	\N	\N	183614	183614	350821
23974	37181	3	applied	\N	\N	\N	\N	183615	183615	350822
23979	37191	0	applied	\N	\N	\N	\N	183628	183628	350835
23979	37192	1	applied	\N	\N	\N	\N	183629	183629	350836
23979	37193	2	applied	\N	\N	\N	\N	183630	183630	350837
23981	37199	0	applied	\N	\N	\N	\N	183660	183660	350867
23981	37200	1	applied	\N	\N	\N	\N	183661	183661	350868
23981	37201	2	applied	\N	\N	\N	\N	183662	183662	350869
23877	36805	63	applied	\N	\N	\N	\N	182894	182894	350101
23877	36808	64	applied	\N	\N	\N	\N	182895	182895	350102
23903	37013	1	applied	\N	\N	\N	\N	183060	183060	350267
23903	37014	2	applied	\N	\N	\N	\N	183061	183061	350268
23908	37015	0	applied	\N	\N	\N	\N	183072	183072	350279
23908	37016	1	applied	\N	\N	\N	\N	183073	183073	350280
23908	37019	2	applied	\N	\N	\N	\N	183074	183074	350281
23908	37017	3	applied	\N	\N	\N	\N	183075	183075	350282
23913	37020	0	applied	\N	\N	\N	\N	183093	183093	350300
23913	37021	1	applied	\N	\N	\N	\N	183094	183094	350301
23913	37022	2	applied	\N	\N	\N	\N	183095	183095	350302
23913	37023	3	applied	\N	\N	\N	\N	183096	183096	350303
23913	37024	4	applied	\N	\N	\N	\N	183097	183097	350304
23913	37025	5	applied	\N	\N	\N	\N	183098	183098	350305
23913	37026	6	applied	\N	\N	\N	\N	183099	183099	350306
23916	36708	1	applied	\N	\N	\N	\N	183116	183116	350323
23916	36712	2	applied	\N	\N	\N	\N	183117	183117	350324
23916	36713	3	applied	\N	\N	\N	\N	183118	183118	350325
23916	36718	4	applied	\N	\N	\N	\N	183119	183119	350326
23916	36719	5	applied	\N	\N	\N	\N	183120	183120	350327
23916	36725	6	applied	\N	\N	\N	\N	183121	183121	350328
23916	36728	7	applied	\N	\N	\N	\N	183122	183122	350329
23916	36732	8	applied	\N	\N	\N	\N	183123	183123	350330
23916	36735	9	applied	\N	\N	\N	\N	183124	183124	350331
23916	36738	10	applied	\N	\N	\N	\N	183125	183125	350332
23916	36739	11	applied	\N	\N	\N	\N	183126	183126	350333
23916	36745	12	applied	\N	\N	\N	\N	183127	183127	350334
23916	36748	13	applied	\N	\N	\N	\N	183128	183128	350335
23916	36751	14	applied	\N	\N	\N	\N	183129	183129	350336
23916	36757	15	applied	\N	\N	\N	\N	183130	183130	350337
23916	36758	16	applied	\N	\N	\N	\N	183131	183131	350338
23916	36763	17	applied	\N	\N	\N	\N	183132	183132	350339
23916	36765	18	applied	\N	\N	\N	\N	183133	183133	350340
23916	36768	19	applied	\N	\N	\N	\N	183134	183134	350341
23916	36774	21	applied	\N	\N	\N	\N	183136	183136	350343
23916	36775	22	applied	\N	\N	\N	\N	183137	183137	350344
23916	36781	23	applied	\N	\N	\N	\N	183138	183138	350345
23916	36784	24	applied	\N	\N	\N	\N	183139	183139	350346
23916	36788	25	applied	\N	\N	\N	\N	183140	183140	350347
23916	36789	26	applied	\N	\N	\N	\N	183141	183141	350348
23916	36795	27	applied	\N	\N	\N	\N	183142	183142	350349
23916	36799	28	applied	\N	\N	\N	\N	183143	183143	350350
23916	36802	29	applied	\N	\N	\N	\N	183144	183144	350351
23916	36805	30	applied	\N	\N	\N	\N	183145	183145	350352
23916	36808	31	applied	\N	\N	\N	\N	183146	183146	350353
23916	36812	32	applied	\N	\N	\N	\N	183147	183147	350354
23916	36813	33	applied	\N	\N	\N	\N	183148	183148	350355
23916	36818	34	applied	\N	\N	\N	\N	183149	183149	350356
23916	36819	35	applied	\N	\N	\N	\N	183150	183150	350357
23916	36825	36	applied	\N	\N	\N	\N	183151	183151	350358
23916	36829	38	applied	\N	\N	\N	\N	183153	183153	350360
23916	36835	39	applied	\N	\N	\N	\N	183154	183154	350361
23916	36838	40	applied	\N	\N	\N	\N	183155	183155	350362
23916	36841	41	applied	\N	\N	\N	\N	183156	183156	350363
23916	36842	42	applied	\N	\N	\N	\N	183157	183157	350364
23916	36848	43	applied	\N	\N	\N	\N	183158	183158	350365
23916	36854	44	applied	\N	\N	\N	\N	183159	183159	350366
23916	36857	45	applied	\N	\N	\N	\N	183160	183160	350367
23916	36860	46	applied	\N	\N	\N	\N	183161	183161	350368
23916	36861	47	applied	\N	\N	\N	\N	183162	183162	350369
23916	36867	48	applied	\N	\N	\N	\N	183163	183163	350370
23916	36870	49	applied	\N	\N	\N	\N	183164	183164	350371
23916	36871	50	applied	\N	\N	\N	\N	183165	183165	350372
23916	36877	51	applied	\N	\N	\N	\N	183166	183166	350373
23916	36880	52	applied	\N	\N	\N	\N	183167	183167	350374
23916	36881	53	applied	\N	\N	\N	\N	183168	183168	350375
23916	36890	55	applied	\N	\N	\N	\N	183170	183170	350377
23916	36893	56	applied	\N	\N	\N	\N	183171	183171	350378
23916	36897	57	applied	\N	\N	\N	\N	183172	183172	350379
23916	36900	58	applied	\N	\N	\N	\N	183173	183173	350380
23916	36903	59	applied	\N	\N	\N	\N	183174	183174	350381
23916	36904	60	applied	\N	\N	\N	\N	183175	183175	350382
23916	36910	61	applied	\N	\N	\N	\N	183176	183176	350383
23916	36913	62	applied	\N	\N	\N	\N	183177	183177	350384
23916	36914	63	applied	\N	\N	\N	\N	183178	183178	350385
23916	36920	64	applied	\N	\N	\N	\N	183179	183179	350386
23916	36923	65	applied	\N	\N	\N	\N	183180	183180	350387
23916	36924	66	applied	\N	\N	\N	\N	183181	183181	350388
23916	36929	67	applied	\N	\N	\N	\N	183182	183182	350389
23916	36932	68	applied	\N	\N	\N	\N	183183	183183	350390
23916	36933	69	applied	\N	\N	\N	\N	183184	183184	350391
23916	36938	70	applied	\N	\N	\N	\N	183185	183185	350392
23916	36940	72	applied	\N	\N	\N	\N	183187	183187	350394
23916	36948	73	applied	\N	\N	\N	\N	183188	183188	350395
23916	36952	74	applied	\N	\N	\N	\N	183189	183189	350396
23916	36955	75	applied	\N	\N	\N	\N	183190	183190	350397
23916	36956	76	applied	\N	\N	\N	\N	183191	183191	350398
23916	36962	77	applied	\N	\N	\N	\N	183192	183192	350399
23916	36963	78	applied	\N	\N	\N	\N	183193	183193	350400
23916	36964	79	applied	\N	\N	\N	\N	183194	183194	350401
23916	36971	81	applied	\N	\N	\N	\N	183195	183195	350402
23916	36972	82	applied	\N	\N	\N	\N	183196	183196	350403
23916	36978	83	applied	\N	\N	\N	\N	183197	183197	350404
23916	36981	84	applied	\N	\N	\N	\N	183198	183198	350405
23916	36982	85	applied	\N	\N	\N	\N	183199	183199	350406
23916	36988	86	applied	\N	\N	\N	\N	183200	183200	350407
23916	36991	87	applied	\N	\N	\N	\N	183201	183201	350408
23916	36992	88	applied	\N	\N	\N	\N	183202	183202	350409
23916	37002	90	applied	\N	\N	\N	\N	183204	183204	350411
23916	37005	91	applied	\N	\N	\N	\N	183205	183205	350412
23916	37009	92	applied	\N	\N	\N	\N	183206	183206	350413
23916	37012	93	applied	\N	\N	\N	\N	183207	183207	350414
23916	37015	94	applied	\N	\N	\N	\N	183208	183208	350415
23916	37020	95	applied	\N	\N	\N	\N	183209	183209	350416
23916	37021	96	applied	\N	\N	\N	\N	183210	183210	350417
23916	37027	97	applied	\N	\N	\N	\N	183211	183211	350418
23921	37060	0	applied	\N	\N	\N	\N	183241	183241	350448
23921	37061	1	applied	\N	\N	\N	\N	183242	183242	350449
23921	37062	2	applied	\N	\N	\N	\N	183243	183243	350450
23928	37069	0	applied	\N	\N	\N	\N	183262	183262	350469
23928	37070	1	applied	\N	\N	\N	\N	183263	183263	350470
23928	37071	2	applied	\N	\N	\N	\N	183264	183264	350471
23900	37014	2	applied	\N	\N	\N	\N	183052	183052	350259
23903	37012	0	applied	\N	\N	\N	\N	183059	183059	350266
23930	37077	3	applied	\N	\N	\N	\N	183273	183273	350480
23930	37076	4	applied	\N	\N	\N	\N	183274	183274	350481
23930	37078	5	applied	\N	\N	\N	\N	183275	183275	350482
23930	37079	6	applied	\N	\N	\N	\N	183276	183276	350483
23930	37080	7	applied	\N	\N	\N	\N	183277	183277	350484
23930	37081	8	applied	\N	\N	\N	\N	183278	183278	350485
23930	37082	9	applied	\N	\N	\N	\N	183279	183279	350486
23935	37089	0	applied	\N	\N	\N	\N	183293	183293	350500
23935	37091	1	applied	\N	\N	\N	\N	183294	183294	350501
23937	37093	0	applied	\N	\N	\N	\N	183298	183298	350505
23937	37090	1	applied	\N	\N	\N	\N	183299	183299	350506
23937	37094	2	applied	\N	\N	\N	\N	183300	183300	350507
23937	37092	3	applied	\N	\N	\N	\N	183301	183301	350508
23942	37096	0	applied	\N	\N	\N	\N	183323	183323	350530
23942	37097	1	applied	\N	\N	\N	\N	183324	183324	350531
23942	37098	2	applied	\N	\N	\N	\N	183325	183325	350532
23942	37100	4	applied	\N	\N	\N	\N	183327	183327	350534
23942	37101	5	applied	\N	\N	\N	\N	183328	183328	350535
23945	37102	0	applied	\N	\N	\N	\N	183335	183335	350542
23945	37103	1	applied	\N	\N	\N	\N	183336	183336	350543
23945	37104	2	applied	\N	\N	\N	\N	183337	183337	350544
23949	37105	0	applied	\N	\N	\N	\N	183344	183344	350551
23949	37106	1	applied	\N	\N	\N	\N	183345	183345	350552
23949	37107	2	applied	\N	\N	\N	\N	183346	183346	350553
23949	37108	3	applied	\N	\N	\N	\N	183347	183347	350554
23949	37109	4	applied	\N	\N	\N	\N	183348	183348	350555
23949	37110	5	applied	\N	\N	\N	\N	183349	183349	350556
23953	37114	0	applied	\N	\N	\N	\N	183371	183371	350578
23953	37107	1	applied	\N	\N	\N	\N	183372	183372	350579
23953	37108	2	applied	\N	\N	\N	\N	183373	183373	350580
23953	37115	3	applied	\N	\N	\N	\N	183374	183374	350581
23953	37112	4	applied	\N	\N	\N	\N	183375	183375	350582
23955	37117	0	applied	\N	\N	\N	\N	183383	183383	350590
23955	37118	1	applied	\N	\N	\N	\N	183384	183384	350591
23955	37119	2	applied	\N	\N	\N	\N	183385	183385	350592
23963	37139	0	applied	\N	\N	\N	\N	183413	183413	350620
23963	37140	1	applied	\N	\N	\N	\N	183414	183414	350621
23963	37141	2	applied	\N	\N	\N	\N	183415	183415	350622
23965	37142	0	applied	\N	\N	\N	\N	183541	183541	350748
23965	37143	1	applied	\N	\N	\N	\N	183542	183542	350749
23965	37144	2	applied	\N	\N	\N	\N	183543	183543	350750
23970	37162	0	applied	\N	\N	\N	\N	183577	183577	350784
23970	37163	1	applied	\N	\N	\N	\N	183578	183578	350785
23970	37164	2	applied	\N	\N	\N	\N	183579	183579	350786
23970	37165	3	applied	\N	\N	\N	\N	183580	183580	350787
23970	37166	4	applied	\N	\N	\N	\N	183581	183581	350788
23970	37167	5	applied	\N	\N	\N	\N	183582	183582	350789
23970	37168	6	applied	\N	\N	\N	\N	183583	183583	350790
23970	37161	8	applied	\N	\N	\N	\N	183585	183585	350792
23970	37170	9	applied	\N	\N	\N	\N	183586	183586	350793
23972	37171	0	applied	\N	\N	\N	\N	183597	183597	350804
23972	37172	1	applied	\N	\N	\N	\N	183598	183598	350805
23972	37173	2	applied	\N	\N	\N	\N	183599	183599	350806
23972	37174	3	applied	\N	\N	\N	\N	183600	183600	350807
23972	37175	4	applied	\N	\N	\N	\N	183601	183601	350808
23972	37176	5	applied	\N	\N	\N	\N	183602	183602	350809
23972	37177	6	applied	\N	\N	\N	\N	183603	183603	350810
23972	37178	7	applied	\N	\N	\N	\N	183604	183604	350811
23977	37185	0	applied	\N	\N	\N	\N	183622	183622	350829
23977	37186	1	applied	\N	\N	\N	\N	183623	183623	350830
23977	37187	2	applied	\N	\N	\N	\N	183624	183624	350831
23984	37202	0	applied	\N	\N	\N	\N	183667	183667	350874
23984	37203	1	applied	\N	\N	\N	\N	183668	183668	350875
23984	37204	2	applied	\N	\N	\N	\N	183669	183669	350876
23989	37211	1	applied	\N	\N	\N	\N	183682	183682	350889
23989	37212	2	applied	\N	\N	\N	\N	183683	183683	350890
23992	37213	0	applied	\N	\N	\N	\N	183690	183690	350897
23992	37214	1	applied	\N	\N	\N	\N	183691	183691	350898
23992	37215	2	applied	\N	\N	\N	\N	183692	183692	350899
23998	37222	0	applied	\N	\N	\N	\N	183828	183828	351035
23998	37223	1	applied	\N	\N	\N	\N	183829	183829	351036
23998	37224	2	applied	\N	\N	\N	\N	183830	183830	351037
23998	37225	3	applied	\N	\N	\N	\N	183831	183831	351038
23998	37226	4	applied	\N	\N	\N	\N	183832	183832	351039
23998	37227	5	applied	\N	\N	\N	\N	183833	183833	351040
23998	37228	6	applied	\N	\N	\N	\N	183834	183834	351041
23998	37229	7	applied	\N	\N	\N	\N	183835	183835	351042
23998	37230	8	applied	\N	\N	\N	\N	183836	183836	351043
24001	37232	0	applied	\N	\N	\N	\N	183849	183849	351056
24003	37231	0	applied	\N	\N	\N	\N	183853	183853	351060
24003	37233	2	applied	\N	\N	\N	\N	183855	183855	351062
24005	37234	0	applied	\N	\N	\N	\N	183861	183861	351068
24005	37235	1	applied	\N	\N	\N	\N	183862	183862	351069
24005	37236	2	applied	\N	\N	\N	\N	183863	183863	351070
24005	37237	3	applied	\N	\N	\N	\N	183864	183864	351071
24005	37238	4	applied	\N	\N	\N	\N	183865	183865	351072
24007	37242	0	applied	\N	\N	\N	\N	183869	183869	351076
24007	37243	1	applied	\N	\N	\N	\N	183870	183870	351077
24012	37250	0	applied	\N	\N	\N	\N	183885	183885	351092
24012	37251	1	applied	\N	\N	\N	\N	183886	183886	351093
24012	37252	2	applied	\N	\N	\N	\N	183887	183887	351094
24014	37253	0	applied	\N	\N	\N	\N	183891	183891	351098
24014	37254	1	applied	\N	\N	\N	\N	183892	183892	351099
24014	37255	2	applied	\N	\N	\N	\N	183893	183893	351100
24019	37262	0	applied	\N	\N	\N	\N	183900	183900	351107
24019	37263	1	applied	\N	\N	\N	\N	183901	183901	351108
24019	37265	3	applied	\N	\N	\N	\N	183903	183903	351110
24024	37269	0	applied	\N	\N	\N	\N	183921	183921	351128
24024	37270	1	applied	\N	\N	\N	\N	183922	183922	351129
24024	37271	2	applied	\N	\N	\N	\N	183923	183923	351130
24024	37272	3	applied	\N	\N	\N	\N	183924	183924	351131
24024	37273	4	applied	\N	\N	\N	\N	183925	183925	351132
24024	37274	5	applied	\N	\N	\N	\N	183926	183926	351133
24026	37275	0	applied	\N	\N	\N	\N	183933	183933	351140
24026	37276	1	applied	\N	\N	\N	\N	183934	183934	351141
24026	37277	2	applied	\N	\N	\N	\N	183935	183935	351142
24026	37278	3	applied	\N	\N	\N	\N	183936	183936	351143
24026	37279	4	applied	\N	\N	\N	\N	183937	183937	351144
24026	37280	5	applied	\N	\N	\N	\N	183938	183938	351145
24029	37293	0	applied	\N	\N	\N	\N	183954	183954	351161
23930	37073	0	applied	\N	\N	\N	\N	183270	183270	350477
23930	37074	1	applied	\N	\N	\N	\N	183271	183271	350478
23952	37110	4	applied	\N	\N	\N	\N	183369	183369	350576
23952	37113	5	applied	\N	\N	\N	\N	183370	183370	350577
23954	37114	0	applied	\N	\N	\N	\N	183377	183377	350584
23954	37107	1	applied	\N	\N	\N	\N	183378	183378	350585
23954	37108	2	applied	\N	\N	\N	\N	183379	183379	350586
23954	37115	3	applied	\N	\N	\N	\N	183380	183380	350587
23954	37112	4	applied	\N	\N	\N	\N	183381	183381	350588
23954	37116	5	applied	\N	\N	\N	\N	183382	183382	350589
23956	37117	0	applied	\N	\N	\N	\N	183386	183386	350593
23956	37118	1	applied	\N	\N	\N	\N	183387	183387	350594
23956	37119	2	applied	\N	\N	\N	\N	183388	183388	350595
23959	37121	0	applied	\N	\N	\N	\N	183395	183395	350602
23959	37122	1	applied	\N	\N	\N	\N	183396	183396	350603
23961	37126	0	applied	\N	\N	\N	\N	183400	183400	350607
23961	37128	2	applied	\N	\N	\N	\N	183402	183402	350609
23961	37129	3	applied	\N	\N	\N	\N	183403	183403	350610
23961	37130	4	applied	\N	\N	\N	\N	183404	183404	350611
23961	37131	5	applied	\N	\N	\N	\N	183405	183405	350612
23964	36794	0	applied	\N	\N	1000000000	\N	183416	183416	350623
23964	36718	1	applied	\N	\N	\N	\N	183417	183417	350624
23964	36719	2	applied	\N	\N	\N	\N	183418	183418	350625
23964	37134	3	applied	\N	\N	\N	\N	183419	183419	350626
23964	36725	4	applied	\N	\N	\N	\N	183420	183420	350627
23964	36728	5	applied	\N	\N	\N	\N	183421	183421	350628
23964	36732	6	applied	\N	\N	\N	\N	183422	183422	350629
23964	36735	7	applied	\N	\N	\N	\N	183423	183423	350630
23964	36738	8	applied	\N	\N	\N	\N	183424	183424	350631
23964	36739	9	applied	\N	\N	\N	\N	183425	183425	350632
23964	36745	10	applied	\N	\N	\N	\N	183426	183426	350633
23964	36748	11	applied	\N	\N	\N	\N	183427	183427	350634
23964	36757	13	applied	\N	\N	\N	\N	183429	183429	350636
23964	36758	14	applied	\N	\N	\N	\N	183430	183430	350637
23964	36763	15	applied	\N	\N	\N	\N	183431	183431	350638
23964	36765	16	applied	\N	\N	\N	\N	183432	183432	350639
23964	36768	17	applied	\N	\N	\N	\N	183433	183433	350640
23964	36771	18	applied	\N	\N	\N	\N	183434	183434	350641
23964	36774	19	applied	\N	\N	\N	\N	183435	183435	350642
23964	36775	20	applied	\N	\N	\N	\N	183436	183436	350643
23964	36781	21	applied	\N	\N	\N	\N	183437	183437	350644
23964	36784	22	applied	\N	\N	\N	\N	183438	183438	350645
23964	36788	23	applied	\N	\N	\N	\N	183439	183439	350646
23964	36789	24	applied	\N	\N	\N	\N	183440	183440	350647
23964	36795	25	applied	\N	\N	\N	\N	183441	183441	350648
23964	36799	26	applied	\N	\N	\N	\N	183442	183442	350649
23964	36802	27	applied	\N	\N	\N	\N	183443	183443	350650
23964	36805	28	applied	\N	\N	\N	\N	183444	183444	350651
23964	36812	30	applied	\N	\N	\N	\N	183446	183446	350653
23964	36813	31	applied	\N	\N	\N	\N	183447	183447	350654
23964	36818	32	applied	\N	\N	\N	\N	183448	183448	350655
23964	36819	33	applied	\N	\N	\N	\N	183449	183449	350656
23964	36825	34	applied	\N	\N	\N	\N	183450	183450	350657
23964	36828	35	applied	\N	\N	\N	\N	183451	183451	350658
23964	36829	36	applied	\N	\N	\N	\N	183452	183452	350659
23964	36835	37	applied	\N	\N	\N	\N	183453	183453	350660
23964	36838	38	applied	\N	\N	\N	\N	183454	183454	350661
23964	36841	39	applied	\N	\N	\N	\N	183455	183455	350662
23964	36842	40	applied	\N	\N	\N	\N	183456	183456	350663
23964	36848	41	applied	\N	\N	\N	\N	183457	183457	350664
23964	36854	42	applied	\N	\N	\N	\N	183458	183458	350665
23964	36857	43	applied	\N	\N	\N	\N	183459	183459	350666
23964	36860	44	applied	\N	\N	\N	\N	183460	183460	350667
23964	36861	45	applied	\N	\N	\N	\N	183461	183461	350668
23964	36870	47	applied	\N	\N	\N	\N	183463	183463	350670
23964	36871	48	applied	\N	\N	\N	\N	183464	183464	350671
23964	36877	49	applied	\N	\N	\N	\N	183465	183465	350672
23964	36880	50	applied	\N	\N	\N	\N	183466	183466	350673
23964	36881	51	applied	\N	\N	\N	\N	183467	183467	350674
23964	36882	52	applied	\N	\N	\N	\N	183468	183468	350675
23964	36890	53	applied	\N	\N	\N	\N	183469	183469	350676
23964	36893	54	applied	\N	\N	\N	\N	183470	183470	350677
23964	36897	55	applied	\N	\N	\N	\N	183471	183471	350678
23964	36900	56	applied	\N	\N	\N	\N	183472	183472	350679
23964	36903	57	applied	\N	\N	\N	\N	183473	183473	350680
23964	36904	58	applied	\N	\N	\N	\N	183474	183474	350681
23964	36910	59	applied	\N	\N	\N	\N	183475	183475	350682
23964	36913	60	applied	\N	\N	\N	\N	183476	183476	350683
23964	36914	61	applied	\N	\N	\N	\N	183477	183477	350684
23964	36920	62	applied	\N	\N	\N	\N	183478	183478	350685
23964	36924	64	applied	\N	\N	\N	\N	183480	183480	350687
23964	36929	65	applied	\N	\N	\N	\N	183481	183481	350688
24029	37294	1	applied	\N	\N	\N	\N	183955	183955	351162
24029	37295	2	applied	\N	\N	\N	\N	183956	183956	351163
24036	37305	0	applied	\N	\N	\N	\N	183978	183978	351185
24036	37306	1	applied	\N	\N	\N	\N	183979	183979	351186
24036	37307	2	applied	\N	\N	\N	\N	183980	183980	351187
24038	37308	0	applied	\N	\N	\N	\N	183983	183983	351190
24038	37309	1	applied	\N	\N	\N	\N	183984	183984	351191
24045	37316	0	applied	\N	\N	\N	\N	183998	183998	351205
24045	37317	1	applied	\N	\N	\N	\N	183999	183999	351206
24047	37321	0	applied	\N	\N	\N	\N	184003	184003	351210
24047	37322	1	applied	\N	\N	\N	\N	184004	184004	351211
24047	37323	2	applied	\N	\N	\N	\N	184005	184005	351212
24047	37324	3	applied	\N	\N	\N	\N	184006	184006	351213
24047	37325	4	applied	\N	\N	\N	\N	184007	184007	351214
24050	37332	0	applied	\N	\N	\N	\N	184019	184019	351226
24050	37333	1	applied	\N	\N	\N	\N	184020	184020	351227
24050	37334	2	applied	\N	\N	\N	\N	184021	184021	351228
24050	37335	3	applied	\N	\N	\N	\N	184022	184022	351229
24057	37340	0	applied	\N	\N	\N	\N	184043	184043	351250
24057	37341	1	applied	\N	\N	\N	\N	184044	184044	351251
24062	37346	0	applied	\N	\N	\N	\N	184053	184053	351260
24062	37347	1	applied	\N	\N	\N	\N	184054	184054	351261
24067	37348	0	applied	\N	\N	\N	\N	184186	184186	351393
24067	37349	1	applied	\N	\N	\N	\N	184187	184187	351394
24067	37350	2	applied	\N	\N	\N	\N	184188	184188	351395
24067	37351	3	applied	\N	\N	\N	\N	184189	184189	351396
24067	37352	4	applied	\N	\N	\N	\N	184190	184190	351397
24067	37353	5	applied	\N	\N	\N	\N	184191	184191	351398
24073	37372	0	applied	\N	\N	\N	\N	184212	184212	351419
24073	37373	1	applied	\N	\N	\N	\N	184213	184213	351420
23952	37109	3	applied	\N	\N	\N	\N	183368	183368	350575
23960	37124	1	applied	\N	\N	\N	\N	183398	183398	350605
23960	37125	2	applied	\N	\N	\N	\N	183399	183399	350606
23964	36932	66	applied	\N	\N	\N	\N	183482	183482	350689
23964	36933	67	applied	\N	\N	\N	\N	183483	183483	350690
23964	36938	68	applied	\N	\N	\N	\N	183484	183484	350691
23964	36939	69	applied	\N	\N	\N	\N	183485	183485	350692
23964	36940	70	applied	\N	\N	\N	\N	183486	183486	350693
23964	36948	71	applied	\N	\N	\N	\N	183487	183487	350694
23964	36952	72	applied	\N	\N	\N	\N	183488	183488	350695
23964	36955	73	applied	\N	\N	\N	\N	183489	183489	350696
23964	36956	74	applied	\N	\N	\N	\N	183490	183490	350697
23964	36962	75	applied	\N	\N	\N	\N	183491	183491	350698
23964	36963	76	applied	\N	\N	\N	\N	183492	183492	350699
23964	36964	77	applied	\N	\N	\N	\N	183493	183493	350700
23964	36971	78	applied	\N	\N	\N	\N	183494	183494	350701
23964	36972	79	applied	\N	\N	\N	\N	183495	183495	350702
23964	36981	81	applied	\N	\N	\N	\N	183497	183497	350704
23964	36982	82	applied	\N	\N	\N	\N	183498	183498	350705
23964	36988	83	applied	\N	\N	\N	\N	183499	183499	350706
23964	36991	84	applied	\N	\N	\N	\N	183500	183500	350707
23964	36992	85	applied	\N	\N	\N	\N	183501	183501	350708
23964	36999	86	applied	\N	\N	\N	\N	183502	183502	350709
23964	37002	87	applied	\N	\N	\N	\N	183503	183503	350710
23964	37005	88	applied	\N	\N	\N	\N	183504	183504	350711
23964	37009	89	applied	\N	\N	\N	\N	183505	183505	350712
23964	37012	90	applied	\N	\N	\N	\N	183506	183506	350713
23964	37015	91	applied	\N	\N	\N	\N	183507	183507	350714
23964	37020	92	applied	\N	\N	\N	\N	183508	183508	350715
23964	37021	93	applied	\N	\N	\N	\N	183509	183509	350716
23964	37027	94	applied	\N	\N	\N	\N	183510	183510	350717
23964	37030	95	applied	\N	\N	\N	\N	183511	183511	350718
23964	37031	96	applied	\N	\N	\N	\N	183512	183512	350719
23966	37143	1	applied	\N	\N	\N	\N	183545	183545	350752
23966	37144	2	applied	\N	\N	\N	\N	183546	183546	350753
23966	37145	3	applied	\N	\N	\N	\N	183547	183547	350754
23968	37148	0	applied	\N	\N	\N	\N	183550	183550	350757
23968	37149	1	applied	\N	\N	\N	\N	183551	183551	350758
23968	37150	2	applied	\N	\N	\N	\N	183552	183552	350759
23968	37151	3	applied	\N	\N	\N	\N	183553	183553	350760
23968	37152	4	applied	\N	\N	\N	\N	183554	183554	350761
23968	37153	5	applied	\N	\N	\N	\N	183555	183555	350762
23968	37154	6	applied	\N	\N	\N	\N	183556	183556	350763
23968	37155	7	applied	\N	\N	\N	\N	183557	183557	350764
23968	37156	8	applied	\N	\N	\N	\N	183558	183558	350765
23968	37157	9	applied	\N	\N	\N	\N	183559	183559	350766
23968	37158	10	applied	\N	\N	\N	\N	183560	183560	350767
23968	37159	11	applied	\N	\N	\N	\N	183561	183561	350768
23968	37160	12	applied	\N	\N	\N	\N	183562	183562	350769
23971	37163	1	applied	\N	\N	\N	\N	183588	183588	350795
23971	37164	2	applied	\N	\N	\N	\N	183589	183589	350796
23971	37165	3	applied	\N	\N	\N	\N	183590	183590	350797
23971	37166	4	applied	\N	\N	\N	\N	183591	183591	350798
23971	37167	5	applied	\N	\N	\N	\N	183592	183592	350799
23971	37168	6	applied	\N	\N	\N	\N	183593	183593	350800
23971	37169	7	applied	\N	\N	\N	\N	183594	183594	350801
23971	37161	8	applied	\N	\N	\N	\N	183595	183595	350802
23971	37170	9	applied	\N	\N	\N	\N	183596	183596	350803
23973	37171	0	applied	\N	\N	\N	\N	183605	183605	350812
23973	37172	1	applied	\N	\N	\N	\N	183606	183606	350813
23973	37173	2	applied	\N	\N	\N	\N	183607	183607	350814
23973	37174	3	applied	\N	\N	\N	\N	183608	183608	350815
23973	37175	4	applied	\N	\N	\N	\N	183609	183609	350816
23973	37176	5	applied	\N	\N	\N	\N	183610	183610	350817
23973	37177	6	applied	\N	\N	\N	\N	183611	183611	350818
23975	37182	0	applied	\N	\N	\N	\N	183616	183616	350823
23975	37183	1	applied	\N	\N	\N	\N	183617	183617	350824
23975	37184	2	applied	\N	\N	\N	\N	183618	183618	350825
23980	37134	0	applied	\N	\N	\N	\N	183631	183631	350838
23980	37143	1	applied	\N	\N	\N	\N	183632	183632	350839
23980	37148	2	applied	\N	\N	\N	\N	183633	183633	350840
23980	37150	3	applied	\N	\N	\N	\N	183634	183634	350841
23980	37151	4	applied	\N	\N	\N	\N	183635	183635	350842
23980	37152	5	applied	\N	\N	\N	\N	183636	183636	350843
23980	37153	6	applied	\N	\N	\N	\N	183637	183637	350844
23980	37154	7	applied	\N	\N	\N	\N	183638	183638	350845
23980	37155	8	applied	\N	\N	\N	\N	183639	183639	350846
23980	37156	9	applied	\N	\N	\N	\N	183640	183640	350847
23980	37157	10	applied	\N	\N	\N	\N	183641	183641	350848
23980	37158	11	applied	\N	\N	\N	\N	183642	183642	350849
23980	37159	12	applied	\N	\N	\N	\N	183643	183643	350850
23980	37163	14	applied	\N	\N	\N	\N	183645	183645	350852
23980	37164	15	applied	\N	\N	\N	\N	183646	183646	350853
23980	37166	16	applied	\N	\N	\N	\N	183647	183647	350854
23980	37167	17	applied	\N	\N	\N	\N	183648	183648	350855
23980	37168	18	applied	\N	\N	\N	\N	183649	183649	350856
23980	37171	19	applied	\N	\N	\N	\N	183650	183650	350857
23980	37172	20	applied	\N	\N	\N	\N	183651	183651	350858
23980	37173	21	applied	\N	\N	\N	\N	183652	183652	350859
23980	37174	22	applied	\N	\N	\N	\N	183653	183653	350860
23980	37175	23	applied	\N	\N	\N	\N	183654	183654	350861
23980	37194	24	applied	\N	\N	\N	\N	183655	183655	350862
23980	37195	25	applied	\N	\N	\N	\N	183656	183656	350863
23980	37196	26	applied	\N	\N	\N	\N	183657	183657	350864
23980	37197	27	applied	\N	\N	\N	\N	183658	183658	350865
23980	37198	28	applied	\N	\N	\N	\N	183659	183659	350866
23982	37199	0	applied	\N	\N	\N	\N	183663	183663	350870
23987	37209	1	applied	\N	\N	\N	\N	183677	183677	350884
23996	37219	0	applied	\N	\N	\N	\N	183822	183822	351029
23996	37220	1	applied	\N	\N	\N	\N	183823	183823	351030
23996	37221	2	applied	\N	\N	\N	\N	183824	183824	351031
23999	37222	0	applied	\N	\N	\N	\N	183837	183837	351044
23999	37223	1	applied	\N	\N	\N	\N	183838	183838	351045
23999	37224	2	applied	\N	\N	\N	\N	183839	183839	351046
23999	37225	3	applied	\N	\N	\N	\N	183840	183840	351047
23999	37226	4	applied	\N	\N	\N	\N	183841	183841	351048
23999	37227	5	applied	\N	\N	\N	\N	183842	183842	351049
23999	37228	6	applied	\N	\N	\N	\N	183843	183843	351050
23999	37229	7	applied	\N	\N	\N	\N	183844	183844	351051
23999	37230	8	applied	\N	\N	\N	\N	183845	183845	351052
24008	37242	0	applied	\N	\N	\N	\N	183871	183871	351078
23958	37121	1	applied	\N	\N	\N	\N	183393	183393	350600
23958	37122	2	applied	\N	\N	\N	\N	183394	183394	350601
23964	37044	101	applied	\N	\N	\N	\N	183517	183517	350724
23964	37053	102	applied	\N	\N	\N	\N	183518	183518	350725
23964	37056	103	applied	\N	\N	\N	\N	183519	183519	350726
23964	37060	104	applied	\N	\N	\N	\N	183520	183520	350727
23964	37063	106	applied	\N	\N	\N	\N	183521	183521	350728
23964	37066	107	applied	\N	\N	\N	\N	183522	183522	350729
23964	37069	108	applied	\N	\N	\N	\N	183523	183523	350730
23964	37073	109	applied	\N	\N	\N	\N	183524	183524	350731
23964	37074	110	applied	\N	\N	\N	\N	183525	183525	350732
23964	37075	111	applied	\N	\N	\N	\N	183526	183526	350733
23964	37083	112	applied	\N	\N	\N	\N	183527	183527	350734
23964	37086	113	applied	\N	\N	\N	\N	183528	183528	350735
23964	37089	114	applied	\N	\N	\N	\N	183529	183529	350736
23964	37093	115	applied	\N	\N	\N	\N	183530	183530	350737
23964	37096	116	applied	\N	\N	\N	\N	183531	183531	350738
23964	37097	117	applied	\N	\N	\N	\N	183532	183532	350739
23964	37105	119	applied	\N	\N	\N	\N	183534	183534	350741
23964	37106	120	applied	\N	\N	\N	\N	183535	183535	350742
23964	37111	121	applied	\N	\N	\N	\N	183536	183536	350743
23964	37114	122	applied	\N	\N	\N	\N	183537	183537	350744
23964	37117	123	applied	\N	\N	\N	\N	183538	183538	350745
23964	37120	124	applied	\N	\N	\N	\N	183539	183539	350746
23964	37123	125	applied	\N	\N	\N	\N	183540	183540	350747
23969	37148	0	applied	\N	\N	\N	\N	183563	183563	350770
23969	37149	1	applied	\N	\N	\N	\N	183564	183564	350771
23969	37150	2	applied	\N	\N	\N	\N	183565	183565	350772
23969	37151	3	applied	\N	\N	\N	\N	183566	183566	350773
23969	37152	4	applied	\N	\N	\N	\N	183567	183567	350774
23969	37153	5	applied	\N	\N	\N	\N	183568	183568	350775
23969	37154	6	applied	\N	\N	\N	\N	183569	183569	350776
23969	37155	7	applied	\N	\N	\N	\N	183570	183570	350777
23969	37156	8	applied	\N	\N	\N	\N	183571	183571	350778
23969	37158	10	applied	\N	\N	\N	\N	183573	183573	350780
23969	37159	11	applied	\N	\N	\N	\N	183574	183574	350781
23969	37161	12	applied	\N	\N	\N	\N	183575	183575	350782
23969	37160	13	applied	\N	\N	\N	\N	183576	183576	350783
23976	37182	0	applied	\N	\N	\N	\N	183619	183619	350826
23976	37183	1	applied	\N	\N	\N	\N	183620	183620	350827
23976	37184	2	applied	\N	\N	\N	\N	183621	183621	350828
23978	37188	0	applied	\N	\N	\N	\N	183625	183625	350832
23978	37189	1	applied	\N	\N	\N	\N	183626	183626	350833
23978	37190	2	applied	\N	\N	\N	\N	183627	183627	350834
23983	37202	0	applied	\N	\N	\N	\N	183664	183664	350871
23983	37203	1	applied	\N	\N	\N	\N	183665	183665	350872
23983	37204	2	applied	\N	\N	\N	\N	183666	183666	350873
23985	37205	0	applied	\N	\N	\N	\N	183670	183670	350877
23985	37206	1	applied	\N	\N	\N	\N	183671	183671	350878
23985	37207	2	applied	\N	\N	\N	\N	183672	183672	350879
23990	37214	1	applied	\N	\N	\N	\N	183685	183685	350892
23990	37215	2	applied	\N	\N	\N	\N	183686	183686	350893
23993	37134	0	applied	\N	\N	\N	\N	183693	183693	350900
23993	37143	1	applied	\N	\N	\N	\N	183694	183694	350901
23993	37148	2	applied	\N	\N	\N	\N	183695	183695	350902
23993	37005	3	applied	\N	\N	\N	\N	183696	183696	350903
23993	37009	4	applied	\N	\N	\N	\N	183697	183697	350904
23993	37150	5	applied	\N	\N	\N	\N	183698	183698	350905
23993	37151	6	applied	\N	\N	\N	\N	183699	183699	350906
23993	37152	7	applied	\N	\N	\N	\N	183700	183700	350907
23993	37012	8	applied	\N	\N	\N	\N	183701	183701	350908
23993	37015	9	applied	\N	\N	\N	\N	183702	183702	350909
23993	37020	10	applied	\N	\N	\N	\N	183703	183703	350910
23993	37021	11	applied	\N	\N	\N	\N	183704	183704	350911
23993	37027	12	applied	\N	\N	\N	\N	183705	183705	350912
23993	37030	13	applied	\N	\N	\N	\N	183706	183706	350913
23993	37032	15	applied	\N	\N	\N	\N	183708	183708	350915
23993	37033	16	applied	\N	\N	\N	\N	183709	183709	350916
23993	37042	17	applied	\N	\N	\N	\N	183710	183710	350917
23993	37043	18	applied	\N	\N	\N	\N	183711	183711	350918
23993	37044	19	applied	\N	\N	\N	\N	183712	183712	350919
23993	37053	20	applied	\N	\N	\N	\N	183713	183713	350920
23993	37056	21	applied	\N	\N	\N	\N	183714	183714	350921
23993	37060	22	applied	\N	\N	\N	\N	183715	183715	350922
23993	37063	23	applied	\N	\N	\N	\N	183716	183716	350923
23993	37066	24	applied	\N	\N	\N	\N	183717	183717	350924
23993	37069	25	applied	\N	\N	\N	\N	183718	183718	350925
23993	37073	26	applied	\N	\N	\N	\N	183719	183719	350926
23993	37074	27	applied	\N	\N	\N	\N	183720	183720	350927
23993	37075	28	applied	\N	\N	\N	\N	183721	183721	350928
23993	37083	29	applied	\N	\N	\N	\N	183722	183722	350929
23993	37086	30	applied	\N	\N	\N	\N	183723	183723	350930
24008	37243	1	applied	\N	\N	\N	\N	183872	183872	351079
24010	37244	0	applied	\N	\N	\N	\N	183875	183875	351082
24010	37245	1	applied	\N	\N	\N	\N	183876	183876	351083
24010	37246	2	applied	\N	\N	\N	\N	183877	183877	351084
24010	37247	3	applied	\N	\N	\N	\N	183878	183878	351085
24010	37248	4	applied	\N	\N	\N	\N	183879	183879	351086
24010	37249	5	applied	\N	\N	\N	\N	183880	183880	351087
24013	37250	0	applied	\N	\N	\N	\N	183888	183888	351095
24013	37251	1	applied	\N	\N	\N	\N	183889	183889	351096
24013	37252	2	applied	\N	\N	\N	\N	183890	183890	351097
24017	37256	0	applied	\N	\N	\N	\N	183894	183894	351101
24017	37257	1	applied	\N	\N	\N	\N	183895	183895	351102
24017	37258	2	applied	\N	\N	\N	\N	183896	183896	351103
24030	37293	0	applied	\N	\N	\N	\N	183957	183957	351164
24030	37294	1	applied	\N	\N	\N	\N	183958	183958	351165
24030	37295	2	applied	\N	\N	\N	\N	183959	183959	351166
24031	37297	1	applied	\N	\N	\N	\N	183961	183961	351168
24031	37298	2	applied	\N	\N	\N	\N	183962	183962	351169
24048	37327	0	applied	\N	\N	\N	\N	184009	184009	351216
24048	37328	1	applied	\N	\N	\N	\N	184010	184010	351217
24048	37329	2	applied	\N	\N	\N	\N	184011	184011	351218
24048	37330	3	applied	\N	\N	\N	\N	184012	184012	351219
24048	37331	4	applied	\N	\N	\N	\N	184013	184013	351220
24051	37332	0	applied	\N	\N	\N	\N	184023	184023	351230
24051	37333	1	applied	\N	\N	\N	\N	184024	184024	351231
24051	37334	2	applied	\N	\N	\N	\N	184025	184025	351232
24051	37335	3	applied	\N	\N	\N	\N	184026	184026	351233
24054	37332	0	applied	\N	\N	\N	\N	184033	184033	351240
24054	37333	1	applied	\N	\N	\N	\N	184034	184034	351241
24054	37334	2	applied	\N	\N	\N	\N	184035	184035	351242
23964	37033	98	applied	\N	\N	\N	\N	183514	183514	350721
23964	37042	99	applied	\N	\N	\N	\N	183515	183515	350722
23988	37211	1	applied	\N	\N	\N	\N	183679	183679	350886
23988	37212	2	applied	\N	\N	\N	\N	183680	183680	350887
23991	37213	0	applied	\N	\N	\N	\N	183687	183687	350894
23991	37214	1	applied	\N	\N	\N	\N	183688	183688	350895
23991	37215	2	applied	\N	\N	\N	\N	183689	183689	350896
23993	37093	32	applied	\N	\N	\N	\N	183725	183725	350932
23993	37096	33	applied	\N	\N	\N	\N	183726	183726	350933
23993	37097	34	applied	\N	\N	\N	\N	183727	183727	350934
23993	37102	35	applied	\N	\N	\N	\N	183728	183728	350935
23993	37105	36	applied	\N	\N	\N	\N	183729	183729	350936
23993	37106	37	applied	\N	\N	\N	\N	183730	183730	350937
23993	37111	38	applied	\N	\N	\N	\N	183731	183731	350938
23993	37114	39	applied	\N	\N	\N	\N	183732	183732	350939
23993	37117	40	applied	\N	\N	\N	\N	183733	183733	350940
23993	37120	41	applied	\N	\N	\N	\N	183734	183734	350941
23993	37123	42	applied	\N	\N	\N	\N	183735	183735	350942
23993	37127	44	applied	\N	\N	\N	\N	183737	183737	350944
23993	37132	45	applied	\N	\N	\N	\N	183738	183738	350945
23993	37133	46	applied	\N	\N	\N	\N	183739	183739	350946
23993	37139	47	applied	\N	\N	\N	\N	183740	183740	350947
23993	37142	48	applied	\N	\N	\N	\N	183741	183741	350948
23993	37149	49	applied	\N	\N	\N	\N	183742	183742	350949
23993	37165	50	applied	\N	\N	\N	\N	183743	183743	350950
23993	37176	51	applied	\N	\N	\N	\N	183744	183744	350951
23993	37179	52	applied	\N	\N	\N	\N	183745	183745	350952
23993	37182	53	applied	\N	\N	\N	\N	183746	183746	350953
23993	37185	54	applied	\N	\N	\N	\N	183747	183747	350954
23993	37188	55	applied	\N	\N	\N	\N	183748	183748	350955
23993	37191	56	applied	\N	\N	\N	\N	183749	183749	350956
23993	37199	57	applied	\N	\N	\N	\N	183750	183750	350957
23993	37202	58	applied	\N	\N	\N	\N	183751	183751	350958
23993	37205	59	applied	\N	\N	\N	\N	183752	183752	350959
23993	37210	61	applied	\N	\N	\N	\N	183754	183754	350961
23993	37213	62	applied	\N	\N	\N	\N	183755	183755	350962
23995	37194	0	applied	\N	\N	\N	\N	183821	183821	351028
24000	37231	0	applied	\N	\N	\N	\N	183846	183846	351053
24000	37232	1	applied	\N	\N	\N	\N	183847	183847	351054
24000	37233	2	applied	\N	\N	\N	\N	183848	183848	351055
24002	37231	0	applied	\N	\N	\N	\N	183850	183850	351057
24002	37232	1	applied	\N	\N	\N	\N	183851	183851	351058
24002	37233	2	applied	\N	\N	\N	\N	183852	183852	351059
24004	37234	0	applied	\N	\N	\N	\N	183856	183856	351063
24004	37235	1	applied	\N	\N	\N	\N	183857	183857	351064
24004	37236	2	applied	\N	\N	\N	\N	183858	183858	351065
24004	37237	3	applied	\N	\N	\N	\N	183859	183859	351066
24004	37238	4	applied	\N	\N	\N	\N	183860	183860	351067
24009	37242	0	applied	\N	\N	\N	\N	183873	183873	351080
24009	37243	1	applied	\N	\N	\N	\N	183874	183874	351081
24011	37245	1	applied	\N	\N	\N	\N	183882	183882	351089
24011	37248	2	applied	\N	\N	\N	\N	183883	183883	351090
24011	37249	3	applied	\N	\N	\N	\N	183884	183884	351091
24018	37259	0	applied	\N	\N	\N	\N	183897	183897	351104
24018	37260	1	applied	\N	\N	\N	\N	183898	183898	351105
24018	37261	2	applied	\N	\N	\N	\N	183899	183899	351106
24021	37262	0	applied	\N	\N	\N	\N	183908	183908	351115
24021	37263	1	applied	\N	\N	\N	\N	183909	183909	351116
24021	37264	2	applied	\N	\N	\N	\N	183910	183910	351117
24021	37265	3	applied	\N	\N	\N	\N	183911	183911	351118
24023	37269	0	applied	\N	\N	\N	\N	183915	183915	351122
24023	37270	1	applied	\N	\N	\N	\N	183916	183916	351123
24023	37271	2	applied	\N	\N	\N	\N	183917	183917	351124
24023	37272	3	applied	\N	\N	\N	\N	183918	183918	351125
24023	37273	4	applied	\N	\N	\N	\N	183919	183919	351126
24023	37274	5	applied	\N	\N	\N	\N	183920	183920	351127
24025	37276	1	applied	\N	\N	\N	\N	183928	183928	351135
24025	37277	2	applied	\N	\N	\N	\N	183929	183929	351136
24025	37278	3	applied	\N	\N	\N	\N	183930	183930	351137
24025	37279	4	applied	\N	\N	\N	\N	183931	183931	351138
24025	37280	5	applied	\N	\N	\N	\N	183932	183932	351139
24028	37293	0	applied	\N	\N	\N	\N	183951	183951	351158
24028	37294	1	applied	\N	\N	\N	\N	183952	183952	351159
24028	37295	2	applied	\N	\N	\N	\N	183953	183953	351160
24033	37296	0	applied	\N	\N	\N	\N	183966	183966	351173
24033	37297	1	applied	\N	\N	\N	\N	183967	183967	351174
24033	37298	2	applied	\N	\N	\N	\N	183968	183968	351175
24035	37305	0	applied	\N	\N	\N	\N	183975	183975	351182
24035	37306	1	applied	\N	\N	\N	\N	183976	183976	351183
24035	37307	2	applied	\N	\N	\N	\N	183977	183977	351184
24037	37308	0	applied	\N	\N	\N	\N	183981	183981	351188
24037	37309	1	applied	\N	\N	\N	\N	183982	183982	351189
24042	37311	1	applied	\N	\N	\N	\N	183990	183990	351197
24042	37312	2	applied	\N	\N	\N	\N	183991	183991	351198
24044	37316	0	applied	\N	\N	\N	\N	183996	183996	351203
24044	37317	1	applied	\N	\N	\N	\N	183997	183997	351204
24046	37318	0	applied	\N	\N	\N	\N	184000	184000	351207
24046	37319	1	applied	\N	\N	\N	\N	184001	184001	351208
24046	37320	2	applied	\N	\N	\N	\N	184002	184002	351209
24053	37332	0	applied	\N	\N	\N	\N	184029	184029	351236
24053	37333	1	applied	\N	\N	\N	\N	184030	184030	351237
24053	37334	2	applied	\N	\N	\N	\N	184031	184031	351238
24053	37335	3	applied	\N	\N	\N	\N	184032	184032	351239
24056	37338	0	applied	\N	\N	\N	\N	184041	184041	351248
24056	37339	1	applied	\N	\N	\N	\N	184042	184042	351249
24059	37342	0	applied	\N	\N	\N	\N	184047	184047	351254
24059	37343	1	applied	\N	\N	\N	\N	184048	184048	351255
24061	37346	0	applied	\N	\N	\N	\N	184051	184051	351258
24063	37285	0	applied	\N	\N	\N	\N	184055	184055	351262
24063	37276	1	applied	\N	\N	\N	\N	184056	184056	351263
24063	37216	2	applied	\N	\N	\N	\N	184057	184057	351264
24063	37219	3	applied	\N	\N	\N	\N	184058	184058	351265
24063	37277	4	applied	\N	\N	\N	\N	184059	184059	351266
24063	37281	5	applied	\N	\N	\N	\N	184060	184060	351267
24063	37282	6	applied	\N	\N	\N	\N	184061	184061	351268
24063	37286	7	applied	\N	\N	\N	\N	184062	184062	351269
24063	37287	8	applied	\N	\N	\N	\N	184063	184063	351270
24063	37288	9	applied	\N	\N	\N	\N	184064	184064	351271
24063	37222	10	applied	\N	\N	\N	\N	184065	184065	351272
24063	37223	11	applied	\N	\N	\N	\N	184066	184066	351273
24063	37224	12	applied	\N	\N	\N	\N	184067	184067	351274
24063	37231	13	applied	\N	\N	\N	\N	184068	184068	351275
23986	37206	1	applied	\N	\N	\N	\N	183674	183674	350881
23986	37207	2	applied	\N	\N	\N	\N	183675	183675	350882
23993	37157	67	applied	\N	\N	\N	\N	183760	183760	350967
23993	37158	68	applied	\N	\N	\N	\N	183761	183761	350968
23993	37159	69	applied	\N	\N	\N	\N	183762	183762	350969
23993	37162	70	applied	\N	\N	\N	\N	183763	183763	350970
23993	37163	71	applied	\N	\N	\N	\N	183764	183764	350971
23993	37164	72	applied	\N	\N	\N	\N	183765	183765	350972
23993	37166	73	applied	\N	\N	\N	\N	183766	183766	350973
23993	37167	74	applied	\N	\N	\N	\N	183767	183767	350974
23993	37168	75	applied	\N	\N	\N	\N	183768	183768	350975
23993	37171	76	applied	\N	\N	\N	\N	183769	183769	350976
23993	37172	77	applied	\N	\N	\N	\N	183770	183770	350977
23993	37173	78	applied	\N	\N	\N	\N	183771	183771	350978
23993	37174	79	applied	\N	\N	\N	\N	183772	183772	350979
23993	37175	80	applied	\N	\N	\N	\N	183773	183773	350980
23993	37194	81	applied	\N	\N	\N	\N	183774	183774	350981
23993	37195	82	applied	\N	\N	\N	\N	183775	183775	350982
23993	37197	84	applied	\N	\N	\N	\N	183777	183777	350984
23993	37198	85	applied	\N	\N	\N	\N	183778	183778	350985
23993	37006	86	applied	\N	\N	\N	\N	183779	183779	350986
23993	37007	87	applied	\N	\N	\N	\N	183780	183780	350987
23993	37018	88	applied	\N	\N	\N	\N	183781	183781	350988
23993	37024	89	applied	\N	\N	\N	\N	183782	183782	350989
23993	37035	90	applied	\N	\N	\N	\N	183783	183783	350990
23993	37051	91	applied	\N	\N	\N	\N	183784	183784	350991
23993	37011	92	applied	\N	\N	\N	\N	183785	183785	350992
23993	37014	93	applied	\N	\N	\N	\N	183786	183786	350993
23993	37016	94	applied	\N	\N	\N	\N	183787	183787	350994
23993	37019	95	applied	\N	\N	\N	\N	183788	183788	350995
23993	37022	96	applied	\N	\N	\N	\N	183789	183789	350996
23993	37023	97	applied	\N	\N	\N	\N	183790	183790	350997
23993	37028	98	applied	\N	\N	\N	\N	183791	183791	350998
23993	37039	99	applied	\N	\N	\N	\N	183792	183792	350999
23993	37057	101	applied	\N	\N	\N	\N	183794	183794	351001
23993	37071	102	applied	\N	\N	\N	\N	183795	183795	351002
23993	37076	103	applied	\N	\N	\N	\N	183796	183796	351003
23993	37091	104	applied	\N	\N	\N	\N	183797	183797	351004
23993	37040	105	applied	\N	\N	\N	\N	183798	183798	351005
23993	37041	106	applied	\N	\N	\N	\N	183799	183799	351006
23993	37045	107	applied	\N	\N	\N	\N	183800	183800	351007
23993	37047	108	applied	\N	\N	\N	\N	183801	183801	351008
23993	37048	109	applied	\N	\N	\N	\N	183802	183802	351009
23993	37054	110	applied	\N	\N	\N	\N	183803	183803	351010
23993	37059	111	applied	\N	\N	\N	\N	183804	183804	351011
23993	37061	112	applied	\N	\N	\N	\N	183805	183805	351012
23993	37065	113	applied	\N	\N	\N	\N	183806	183806	351013
23993	37068	114	applied	\N	\N	\N	\N	183807	183807	351014
23993	37072	115	applied	\N	\N	\N	\N	183808	183808	351015
23993	37077	116	applied	\N	\N	\N	\N	183809	183809	351016
23993	37079	119	applied	\N	\N	\N	\N	183811	183811	351018
23993	37084	120	applied	\N	\N	\N	\N	183812	183812	351019
23993	37088	121	applied	\N	\N	\N	\N	183813	183813	351020
23993	37090	122	applied	\N	\N	\N	\N	183814	183814	351021
23993	37094	123	applied	\N	\N	\N	\N	183815	183815	351022
23993	37099	124	applied	\N	\N	\N	\N	183816	183816	351023
23993	37101	125	applied	\N	\N	\N	\N	183817	183817	351024
23994	37216	0	applied	\N	\N	\N	\N	183818	183818	351025
23994	37217	1	applied	\N	\N	\N	\N	183819	183819	351026
23994	37218	2	applied	\N	\N	\N	\N	183820	183820	351027
23997	37219	0	applied	\N	\N	\N	\N	183825	183825	351032
23997	37220	1	applied	\N	\N	\N	\N	183826	183826	351033
23997	37221	2	applied	\N	\N	\N	\N	183827	183827	351034
24006	37239	0	applied	\N	\N	\N	\N	183866	183866	351073
24006	37240	1	applied	\N	\N	\N	\N	183867	183867	351074
24006	37241	2	applied	\N	\N	\N	\N	183868	183868	351075
24020	37263	1	applied	\N	\N	\N	\N	183905	183905	351112
24020	37264	2	applied	\N	\N	\N	\N	183906	183906	351113
24020	37265	3	applied	\N	\N	\N	\N	183907	183907	351114
24022	37266	0	applied	\N	\N	\N	\N	183912	183912	351119
24022	37267	1	applied	\N	\N	\N	\N	183913	183913	351120
24022	37268	2	applied	\N	\N	\N	\N	183914	183914	351121
24027	37281	0	applied	\N	\N	\N	\N	183939	183939	351146
24027	37282	1	applied	\N	\N	\N	\N	183940	183940	351147
24027	37283	2	applied	\N	\N	\N	\N	183941	183941	351148
24027	37284	3	applied	\N	\N	\N	\N	183942	183942	351149
24027	37285	4	applied	\N	\N	\N	\N	183943	183943	351150
24027	37286	5	applied	\N	\N	\N	\N	183944	183944	351151
24027	37287	6	applied	\N	\N	\N	\N	183945	183945	351152
24027	37288	7	applied	\N	\N	\N	\N	183946	183946	351153
24027	37289	8	applied	\N	\N	\N	\N	183947	183947	351154
24027	37290	9	applied	\N	\N	\N	\N	183948	183948	351155
24063	37234	14	applied	\N	\N	\N	\N	184069	184069	351276
24063	37239	15	applied	\N	\N	\N	\N	184070	184070	351277
24063	37242	16	applied	\N	\N	\N	\N	184071	184071	351278
24063	37244	17	applied	\N	\N	\N	\N	184072	184072	351279
24063	37245	18	applied	\N	\N	\N	\N	184073	184073	351280
24063	37250	19	applied	\N	\N	\N	\N	184074	184074	351281
24063	37253	20	applied	\N	\N	\N	\N	184075	184075	351282
24063	37256	21	applied	\N	\N	\N	\N	184076	184076	351283
24063	37259	22	applied	\N	\N	\N	\N	184077	184077	351284
24063	37263	23	applied	\N	\N	\N	\N	184078	184078	351285
24063	37266	24	applied	\N	\N	\N	\N	184079	184079	351286
24063	37269	25	applied	\N	\N	\N	\N	184080	184080	351287
24063	37278	26	applied	\N	\N	\N	\N	184081	184081	351288
24063	37283	27	applied	\N	\N	\N	\N	184082	184082	351289
24063	37284	28	applied	\N	\N	\N	\N	184083	184083	351290
24063	37293	29	applied	\N	\N	\N	\N	184084	184084	351291
24063	37299	31	applied	\N	\N	\N	\N	184086	184086	351293
24063	37300	32	applied	\N	\N	\N	\N	184087	184087	351294
24063	37305	33	applied	\N	\N	\N	\N	184088	184088	351295
24063	37308	34	applied	\N	\N	\N	\N	184089	184089	351296
24063	37310	35	applied	\N	\N	\N	\N	184090	184090	351297
24063	37313	36	applied	\N	\N	\N	\N	184091	184091	351298
24063	37318	37	applied	\N	\N	\N	\N	184092	184092	351299
24063	37321	38	applied	\N	\N	\N	\N	184093	184093	351300
24063	37322	39	applied	\N	\N	\N	\N	184094	184094	351301
24063	37327	40	applied	\N	\N	\N	\N	184095	184095	351302
24063	37328	41	applied	\N	\N	\N	\N	184096	184096	351303
24063	37332	42	applied	\N	\N	\N	\N	184097	184097	351304
24063	37333	43	applied	\N	\N	\N	\N	184098	184098	351305
24063	37336	44	applied	\N	\N	\N	\N	184099	184099	351306
23993	37154	64	applied	\N	\N	\N	\N	183757	183757	350964
23993	37155	65	applied	\N	\N	\N	\N	183758	183758	350965
24034	37299	0	applied	\N	\N	\N	\N	183969	183969	351176
24034	37300	1	applied	\N	\N	\N	\N	183970	183970	351177
24034	37301	2	applied	\N	\N	\N	\N	183971	183971	351178
24034	37302	3	applied	\N	\N	\N	\N	183972	183972	351179
24034	37303	4	applied	\N	\N	\N	\N	183973	183973	351180
24034	37304	5	applied	\N	\N	\N	\N	183974	183974	351181
24039	37308	0	applied	\N	\N	\N	\N	183985	183985	351192
24039	37309	1	applied	\N	\N	\N	\N	183986	183986	351193
24041	37310	0	applied	\N	\N	\N	\N	183987	183987	351194
24041	37311	1	applied	\N	\N	\N	\N	183988	183988	351195
24043	37313	0	applied	\N	\N	\N	\N	183992	183992	351199
24043	37314	1	applied	\N	\N	\N	\N	183993	183993	351200
24043	37312	2	applied	\N	\N	\N	\N	183994	183994	351201
24043	37315	3	applied	\N	\N	\N	\N	183995	183995	351202
24049	37327	0	applied	\N	\N	\N	\N	184014	184014	351221
24049	37328	1	applied	\N	\N	\N	\N	184015	184015	351222
24049	37330	3	applied	\N	\N	\N	\N	184017	184017	351224
24049	37331	4	applied	\N	\N	\N	\N	184018	184018	351225
24052	37332	0	applied	\N	\N	\N	\N	184027	184027	351234
24052	37333	1	applied	\N	\N	\N	\N	184028	184028	351235
24054	37335	3	applied	\N	\N	\N	\N	184036	184036	351243
24055	37336	0	applied	\N	\N	\N	\N	184037	184037	351244
24055	37334	1	applied	\N	\N	\N	\N	184038	184038	351245
24055	37335	2	applied	\N	\N	\N	\N	184039	184039	351246
24055	37337	3	applied	\N	\N	\N	\N	184040	184040	351247
24058	37342	0	applied	\N	\N	\N	\N	184045	184045	351252
24058	37343	1	applied	\N	\N	\N	\N	184046	184046	351253
24060	37344	0	applied	\N	\N	\N	\N	184049	184049	351256
24060	37345	1	applied	\N	\N	\N	\N	184050	184050	351257
24068	37354	0	applied	\N	\N	\N	\N	184192	184192	351399
24068	37355	1	applied	\N	\N	\N	\N	184193	184193	351400
24068	37356	2	applied	\N	\N	\N	\N	184194	184194	351401
24068	37358	4	applied	\N	\N	\N	\N	184196	184196	351403
24068	37359	5	applied	\N	\N	\N	\N	184197	184197	351404
24068	37360	6	applied	\N	\N	\N	\N	184198	184198	351405
24068	37361	7	applied	\N	\N	\N	\N	184199	184199	351406
24068	37362	8	applied	\N	\N	\N	\N	184200	184200	351407
24068	37363	9	applied	\N	\N	\N	\N	184201	184201	351408
24069	37364	0	applied	\N	\N	\N	\N	184202	184202	351409
24069	37365	1	applied	\N	\N	\N	\N	184203	184203	351410
24071	37370	0	applied	\N	\N	\N	\N	184208	184208	351415
24071	37371	1	applied	\N	\N	\N	\N	184209	184209	351416
24072	37370	0	applied	\N	\N	\N	\N	184210	184210	351417
24072	37371	1	applied	\N	\N	\N	\N	184211	184211	351418
24076	37376	0	applied	\N	\N	\N	\N	184218	184218	351425
24076	37377	1	applied	\N	\N	\N	\N	184219	184219	351426
24082	37386	0	applied	\N	\N	\N	\N	184238	184238	351445
24082	37387	1	applied	\N	\N	\N	\N	184239	184239	351446
24088	37393	0	applied	\N	\N	\N	\N	184263	184263	351470
24088	37394	1	applied	\N	\N	\N	\N	184264	184264	351471
24088	37395	2	applied	\N	\N	\N	\N	184265	184265	351472
24088	37396	3	applied	\N	\N	\N	\N	184266	184266	351473
24088	37397	4	applied	\N	\N	\N	\N	184267	184267	351474
24088	37398	5	applied	\N	\N	\N	\N	184268	184268	351475
24088	37399	6	applied	\N	\N	\N	\N	184269	184269	351476
24088	37400	7	applied	\N	\N	\N	\N	184270	184270	351477
24095	37411	0	applied	\N	\N	\N	\N	184291	184291	351498
24095	37412	1	applied	\N	\N	\N	\N	184292	184292	351499
24101	37416	0	applied	\N	\N	\N	\N	184302	184302	351509
24101	37417	1	applied	\N	\N	\N	\N	184303	184303	351510
24111	37424	0	applied	\N	\N	\N	\N	184316	184316	351523
24119	37427	0	applied	\N	\N	\N	\N	184332	184332	351539
24119	37428	1	applied	\N	\N	\N	\N	184333	184333	351540
24119	37429	2	applied	\N	\N	\N	\N	184334	184334	351541
24119	37431	4	applied	\N	\N	\N	\N	184336	184336	351543
24119	37432	5	applied	\N	\N	\N	\N	184337	184337	351544
24119	37433	6	applied	\N	\N	\N	\N	184338	184338	351545
24119	37434	7	applied	\N	\N	\N	\N	184339	184339	351546
24119	37435	8	applied	\N	\N	\N	\N	184340	184340	351547
24119	37436	9	applied	\N	\N	\N	\N	184341	184341	351548
24121	37437	0	applied	\N	\N	\N	\N	184344	184344	351551
24121	37438	1	applied	\N	\N	\N	\N	184345	184345	351552
24123	37439	0	applied	\N	\N	\N	\N	184348	184348	351555
24123	37440	1	applied	\N	\N	\N	\N	184349	184349	351556
24123	37441	2	applied	\N	\N	\N	\N	184350	184350	351557
24123	37442	3	applied	\N	\N	\N	\N	184351	184351	351558
24126	37445	0	applied	\N	\N	\N	\N	184358	184358	351565
24126	37446	1	applied	\N	\N	\N	\N	184359	184359	351566
24126	37447	2	applied	\N	\N	\N	\N	184360	184360	351567
24126	37448	3	applied	\N	\N	\N	\N	184361	184361	351568
24128	37450	1	applied	\N	\N	\N	\N	184365	184365	351572
24131	37453	0	applied	\N	\N	\N	\N	184370	184370	351577
24131	37454	1	applied	\N	\N	\N	\N	184371	184371	351578
24131	37455	2	applied	\N	\N	\N	\N	184372	184372	351579
24131	37456	3	applied	\N	\N	\N	\N	184373	184373	351580
24131	37457	4	applied	\N	\N	\N	\N	184374	184374	351581
24131	37458	5	applied	\N	\N	\N	\N	184375	184375	351582
24131	37459	6	applied	\N	\N	\N	\N	184376	184376	351583
24131	37460	7	applied	\N	\N	\N	\N	184377	184377	351584
24134	37467	0	applied	\N	\N	\N	\N	184392	184392	351599
24134	37468	1	applied	\N	\N	\N	\N	184393	184393	351600
24143	37483	0	applied	\N	\N	\N	\N	184418	184418	351625
24143	37484	1	applied	\N	\N	\N	\N	184419	184419	351626
24143	37481	2	applied	\N	\N	\N	\N	184420	184420	351627
24143	37482	3	applied	\N	\N	\N	\N	184421	184421	351628
24157	37500	0	applied	\N	\N	\N	\N	184608	184608	351815
24157	37502	2	applied	\N	\N	\N	\N	184610	184610	351817
24161	37503	0	applied	\N	\N	\N	\N	184618	184618	351825
24161	37504	1	applied	\N	\N	\N	\N	184619	184619	351826
24164	37505	0	applied	\N	\N	\N	\N	184628	184628	351835
24164	37506	1	applied	\N	\N	\N	\N	184629	184629	351836
24164	37507	2	applied	\N	\N	\N	\N	184630	184630	351837
24164	33609	3	applied	\N	\N	\N	\N	184631	184631	351838
24164	37508	4	applied	\N	\N	\N	\N	184632	184632	351839
24164	37509	5	applied	\N	\N	\N	\N	184633	184633	351840
24164	37510	6	applied	\N	\N	\N	\N	184634	184634	351841
24164	37511	7	applied	\N	\N	\N	\N	184635	184635	351842
24166	37512	0	applied	\N	\N	\N	\N	184638	184638	351845
24166	37513	1	applied	\N	\N	\N	\N	184639	184639	351846
24171	37522	0	applied	\N	\N	\N	\N	184656	184656	351863
24032	37296	0	applied	\N	\N	\N	\N	183963	183963	351170
24032	37297	1	applied	\N	\N	\N	\N	183964	183964	351171
24063	37346	49	applied	\N	\N	\N	\N	184104	184104	351311
24063	37237	50	applied	\N	\N	\N	\N	184105	184105	351312
24063	37238	51	applied	\N	\N	\N	\N	184106	184106	351313
24063	37104	52	applied	\N	\N	\N	\N	184107	184107	351314
24063	37109	53	applied	\N	\N	\N	\N	184108	184108	351315
24063	37110	54	applied	\N	\N	\N	\N	184109	184109	351316
24063	37113	55	applied	\N	\N	\N	\N	184110	184110	351317
24063	37115	56	applied	\N	\N	\N	\N	184111	184111	351318
24063	37118	57	applied	\N	\N	\N	\N	184112	184112	351319
24063	37122	58	applied	\N	\N	\N	\N	184113	184113	351320
24063	37124	59	applied	\N	\N	\N	\N	184114	184114	351321
24063	37130	60	applied	\N	\N	\N	\N	184115	184115	351322
24063	37131	61	applied	\N	\N	\N	\N	184116	184116	351323
24063	37137	62	applied	\N	\N	\N	\N	184117	184117	351324
24063	37138	63	applied	\N	\N	\N	\N	184118	184118	351325
24063	37140	64	applied	\N	\N	\N	\N	184119	184119	351326
24063	37147	66	applied	\N	\N	\N	\N	184121	184121	351328
24063	37160	67	applied	\N	\N	\N	\N	184122	184122	351329
24063	37169	68	applied	\N	\N	\N	\N	184123	184123	351330
24063	37178	69	applied	\N	\N	\N	\N	184124	184124	351331
24063	37180	70	applied	\N	\N	\N	\N	184125	184125	351332
24063	37183	71	applied	\N	\N	\N	\N	184126	184126	351333
24063	37186	72	applied	\N	\N	\N	\N	184127	184127	351334
24063	37189	73	applied	\N	\N	\N	\N	184128	184128	351335
24063	37193	74	applied	\N	\N	\N	\N	184129	184129	351336
24063	37200	75	applied	\N	\N	\N	\N	184130	184130	351337
24063	37203	76	applied	\N	\N	\N	\N	184131	184131	351338
24063	37207	77	applied	\N	\N	\N	\N	184132	184132	351339
24063	37209	78	applied	\N	\N	\N	\N	184133	184133	351340
24063	37008	79	applied	\N	\N	\N	\N	184134	184134	351341
24063	37010	80	applied	\N	\N	\N	\N	184135	184135	351342
24063	37013	81	applied	\N	\N	\N	\N	184136	184136	351343
24063	37025	83	applied	\N	\N	\N	\N	184138	184138	351345
24063	37026	84	applied	\N	\N	\N	\N	184139	184139	351346
24063	37029	85	applied	\N	\N	\N	\N	184140	184140	351347
24063	37034	86	applied	\N	\N	\N	\N	184141	184141	351348
24063	37036	87	applied	\N	\N	\N	\N	184142	184142	351349
24063	37037	88	applied	\N	\N	\N	\N	184143	184143	351350
24063	37038	89	applied	\N	\N	\N	\N	184144	184144	351351
24063	37046	90	applied	\N	\N	\N	\N	184145	184145	351352
24063	37049	91	applied	\N	\N	\N	\N	184146	184146	351353
24063	37050	92	applied	\N	\N	\N	\N	184147	184147	351354
24063	37055	93	applied	\N	\N	\N	\N	184148	184148	351355
24063	37058	94	applied	\N	\N	\N	\N	184149	184149	351356
24063	37062	95	applied	\N	\N	\N	\N	184150	184150	351357
24063	37064	96	applied	\N	\N	\N	\N	184151	184151	351358
24063	37067	97	applied	\N	\N	\N	\N	184152	184152	351359
24063	37070	98	applied	\N	\N	\N	\N	184153	184153	351360
24063	37081	100	applied	\N	\N	\N	\N	184155	184155	351362
24063	37082	101	applied	\N	\N	\N	\N	184156	184156	351363
24063	37085	102	applied	\N	\N	\N	\N	184157	184157	351364
24063	37087	103	applied	\N	\N	\N	\N	184158	184158	351365
24063	37092	104	applied	\N	\N	\N	\N	184159	184159	351366
24063	37095	105	applied	\N	\N	\N	\N	184160	184160	351367
24063	37098	106	applied	\N	\N	\N	\N	184161	184161	351368
24063	37100	107	applied	\N	\N	\N	\N	184162	184162	351369
24063	37103	108	applied	\N	\N	\N	\N	184163	184163	351370
24063	37107	109	applied	\N	\N	\N	\N	184164	184164	351371
24063	37108	110	applied	\N	\N	\N	\N	184165	184165	351372
24063	37112	111	applied	\N	\N	\N	\N	184166	184166	351373
24063	37116	112	applied	\N	\N	\N	\N	184167	184167	351374
24063	37119	113	applied	\N	\N	\N	\N	184168	184168	351375
24063	37121	114	applied	\N	\N	\N	\N	184169	184169	351376
24063	37125	115	applied	\N	\N	\N	\N	184170	184170	351377
24063	37129	117	applied	\N	\N	\N	\N	184172	184172	351379
24063	37135	119	applied	\N	\N	\N	\N	184173	184173	351380
24063	37136	120	applied	\N	\N	\N	\N	184174	184174	351381
24063	37141	121	applied	\N	\N	\N	\N	184175	184175	351382
24063	37145	122	applied	\N	\N	\N	\N	184176	184176	351383
24063	37146	123	applied	\N	\N	\N	\N	184177	184177	351384
24063	37161	124	applied	\N	\N	\N	\N	184178	184178	351385
24063	37170	125	applied	\N	\N	\N	\N	184179	184179	351386
24066	37348	0	applied	\N	\N	\N	\N	184180	184180	351387
24066	37349	1	applied	\N	\N	\N	\N	184181	184181	351388
24066	37350	2	applied	\N	\N	\N	\N	184182	184182	351389
24066	37351	3	applied	\N	\N	\N	\N	184183	184183	351390
24066	37352	4	applied	\N	\N	\N	\N	184184	184184	351391
24066	37353	5	applied	\N	\N	\N	\N	184185	184185	351392
24070	37366	0	applied	\N	\N	\N	\N	184204	184204	351411
24070	37367	1	applied	\N	\N	\N	\N	184205	184205	351412
24171	37523	1	applied	\N	\N	\N	\N	184657	184657	351864
24171	37524	2	applied	\N	\N	\N	\N	184658	184658	351865
24171	37525	3	applied	\N	\N	\N	\N	184659	184659	351866
24171	37526	4	applied	\N	\N	\N	\N	184660	184660	351867
24174	37535	0	applied	\N	\N	\N	\N	184674	184674	351881
24174	37536	1	applied	\N	\N	\N	\N	184675	184675	351882
24176	37535	0	applied	\N	\N	\N	\N	184678	184678	351885
24176	37536	1	applied	\N	\N	\N	\N	184679	184679	351886
24179	37546	0	applied	\N	\N	\N	\N	184689	184689	351896
24186	37555	0	applied	\N	\N	\N	\N	184704	184704	351911
24186	37556	1	applied	\N	\N	\N	\N	184705	184705	351912
24186	37557	2	applied	\N	\N	\N	\N	184706	184706	351913
24191	37558	0	applied	\N	\N	\N	\N	184745	184745	351952
24191	37559	1	applied	\N	\N	\N	\N	184746	184746	351953
24202	37580	0	applied	\N	\N	\N	\N	184809	184809	352016
24202	37581	1	applied	\N	\N	\N	\N	184810	184810	352017
24205	37583	0	applied	\N	\N	\N	\N	184821	184821	352028
24205	37584	1	applied	\N	\N	\N	\N	184822	184822	352029
24205	37585	2	applied	\N	\N	\N	\N	184823	184823	352030
24205	37586	3	applied	\N	\N	\N	\N	184824	184824	352031
24205	37587	4	applied	\N	\N	\N	\N	184825	184825	352032
24205	37588	5	applied	\N	\N	\N	\N	184826	184826	352033
24212	37592	0	applied	\N	\N	\N	\N	184856	184856	352063
24212	37593	1	applied	\N	\N	\N	\N	184857	184857	352064
24212	37594	2	applied	\N	\N	\N	\N	184858	184858	352065
24212	37595	3	applied	\N	\N	\N	\N	184859	184859	352066
24212	37596	4	applied	\N	\N	\N	\N	184860	184860	352067
24212	37597	5	applied	\N	\N	\N	\N	184861	184861	352068
24212	37598	6	applied	\N	\N	\N	\N	184862	184862	352069
24219	37608	0	applied	\N	\N	\N	\N	184881	184881	352088
24063	37340	46	applied	\N	\N	\N	\N	184101	184101	351308
24063	37342	47	applied	\N	\N	\N	\N	184102	184102	351309
24075	37375	1	applied	\N	\N	\N	\N	184217	184217	351424
24077	37378	0	applied	\N	\N	\N	\N	184220	184220	351427
24077	37379	1	applied	\N	\N	\N	\N	184221	184221	351428
24078	37380	0	applied	\N	\N	\N	\N	184222	184222	351429
24078	37381	1	applied	\N	\N	\N	\N	184223	184223	351430
24078	37382	2	applied	\N	\N	\N	\N	184224	184224	351431
24078	37383	3	applied	\N	\N	\N	\N	184225	184225	351432
24078	37384	4	applied	\N	\N	\N	\N	184226	184226	351433
24078	37385	5	applied	\N	\N	\N	\N	184227	184227	351434
24080	37386	0	applied	\N	\N	\N	\N	184234	184234	351441
24080	37387	1	applied	\N	\N	\N	\N	184235	184235	351442
24085	37393	0	applied	\N	\N	\N	\N	184245	184245	351452
24085	37392	1	applied	\N	\N	\N	\N	184246	184246	351453
24086	37393	0	applied	\N	\N	\N	\N	184247	184247	351454
24086	37394	1	applied	\N	\N	\N	\N	184248	184248	351455
24086	37395	2	applied	\N	\N	\N	\N	184249	184249	351456
24086	37397	4	applied	\N	\N	\N	\N	184251	184251	351458
24086	37398	5	applied	\N	\N	\N	\N	184252	184252	351459
24086	37399	6	applied	\N	\N	\N	\N	184253	184253	351460
24086	37400	7	applied	\N	\N	\N	\N	184254	184254	351461
24089	37393	0	applied	\N	\N	\N	\N	184271	184271	351478
24089	37394	1	applied	\N	\N	\N	\N	184272	184272	351479
24089	37395	2	applied	\N	\N	\N	\N	184273	184273	351480
24089	37396	3	applied	\N	\N	\N	\N	184274	184274	351481
24089	37397	4	applied	\N	\N	\N	\N	184275	184275	351482
24089	37398	5	applied	\N	\N	\N	\N	184276	184276	351483
24089	37399	6	applied	\N	\N	\N	\N	184277	184277	351484
24089	37400	7	applied	\N	\N	\N	\N	184278	184278	351485
24090	37401	0	applied	\N	\N	\N	\N	184279	184279	351486
24090	37402	1	applied	\N	\N	\N	\N	184280	184280	351487
24092	37405	0	applied	\N	\N	\N	\N	184283	184283	351490
24092	37406	1	applied	\N	\N	\N	\N	184284	184284	351491
24093	37408	1	applied	\N	\N	\N	\N	184286	184286	351493
24093	37409	2	applied	\N	\N	\N	\N	184287	184287	351494
24093	37410	3	applied	\N	\N	\N	\N	184288	184288	351495
24096	37411	0	applied	\N	\N	\N	\N	184293	184293	351500
24096	37412	1	applied	\N	\N	\N	\N	184294	184294	351501
24097	37413	0	applied	\N	\N	\N	\N	184295	184295	351502
24097	37414	1	applied	\N	\N	\N	\N	184296	184296	351503
24098	37413	0	applied	\N	\N	\N	\N	184297	184297	351504
24098	37414	1	applied	\N	\N	\N	\N	184298	184298	351505
24100	37415	0	applied	\N	\N	\N	\N	184301	184301	351508
24102	37416	0	applied	\N	\N	\N	\N	184304	184304	351511
24102	37417	1	applied	\N	\N	\N	\N	184305	184305	351512
24104	37418	0	applied	\N	\N	\N	\N	184308	184308	351515
24104	37419	1	applied	\N	\N	\N	\N	184309	184309	351516
24105	37418	0	applied	\N	\N	\N	\N	184310	184310	351517
24112	37424	0	applied	\N	\N	\N	\N	184317	184317	351524
24122	37437	0	applied	\N	\N	\N	\N	184346	184346	351553
24122	37438	1	applied	\N	\N	\N	\N	184347	184347	351554
24124	37439	0	applied	\N	\N	\N	\N	184352	184352	351559
24124	37440	1	applied	\N	\N	\N	\N	184353	184353	351560
24124	37441	2	applied	\N	\N	\N	\N	184354	184354	351561
24124	37442	3	applied	\N	\N	\N	\N	184355	184355	351562
24129	37451	0	applied	\N	\N	\N	\N	184366	184366	351573
24129	37452	1	applied	\N	\N	\N	\N	184367	184367	351574
24132	37453	0	applied	\N	\N	\N	\N	184378	184378	351585
24132	37454	1	applied	\N	\N	\N	\N	184379	184379	351586
24132	37455	2	applied	\N	\N	\N	\N	184380	184380	351587
24132	37456	3	applied	\N	\N	\N	\N	184381	184381	351588
24132	37457	4	applied	\N	\N	\N	\N	184382	184382	351589
24132	37458	5	applied	\N	\N	\N	\N	184383	184383	351590
24132	37459	6	applied	\N	\N	\N	\N	184384	184384	351591
24132	37460	7	applied	\N	\N	\N	\N	184385	184385	351592
24135	37468	1	applied	\N	\N	\N	\N	184395	184395	351602
24137	37469	0	applied	\N	\N	\N	\N	184398	184398	351605
24137	37470	1	applied	\N	\N	\N	\N	184399	184399	351606
24139	37473	0	applied	\N	\N	\N	\N	184404	184404	351611
24139	37474	1	applied	\N	\N	\N	\N	184405	184405	351612
24140	37475	0	applied	\N	\N	\N	\N	184406	184406	351613
24140	37476	1	applied	\N	\N	\N	\N	184407	184407	351614
24140	37477	2	applied	\N	\N	\N	\N	184408	184408	351615
24140	37478	3	applied	\N	\N	\N	\N	184409	184409	351616
24140	37479	4	applied	\N	\N	\N	\N	184410	184410	351617
24140	37480	5	applied	\N	\N	\N	\N	184411	184411	351618
24147	37485	0	applied	\N	\N	\N	\N	184532	184532	351739
24147	37486	1	applied	\N	\N	\N	\N	184533	184533	351740
24152	37488	0	applied	\N	\N	\N	\N	184588	184588	351795
24152	37489	1	applied	\N	\N	\N	\N	184589	184589	351796
24152	37490	2	applied	\N	\N	\N	\N	184590	184590	351797
24152	37492	4	applied	\N	\N	\N	\N	184592	184592	351799
24154	37493	0	applied	\N	\N	\N	\N	184598	184598	351805
24154	37494	1	applied	\N	\N	\N	\N	184599	184599	351806
24154	37495	2	applied	\N	\N	\N	\N	184600	184600	351807
24158	37500	0	applied	\N	\N	\N	\N	184611	184611	351818
24158	37501	1	applied	\N	\N	\N	\N	184612	184612	351819
24158	37502	2	applied	\N	\N	\N	\N	184613	184613	351820
24159	37503	0	applied	\N	\N	\N	\N	184614	184614	351821
24159	37504	1	applied	\N	\N	\N	\N	184615	184615	351822
24169	37520	0	applied	\N	\N	\N	\N	184652	184652	351859
24169	37521	1	applied	\N	\N	\N	\N	184653	184653	351860
24172	37522	0	applied	\N	\N	\N	\N	184661	184661	351868
24172	37523	1	applied	\N	\N	\N	\N	184662	184662	351869
24172	37524	2	applied	\N	\N	\N	\N	184663	184663	351870
24172	37525	3	applied	\N	\N	\N	\N	184664	184664	351871
24172	37526	4	applied	\N	\N	\N	\N	184665	184665	351872
24175	37536	1	applied	\N	\N	\N	\N	184677	184677	351884
24180	37546	0	applied	\N	\N	\N	\N	184690	184690	351897
24180	37547	1	applied	\N	\N	\N	\N	184691	184691	351898
24182	37548	0	applied	\N	\N	\N	\N	184694	184694	351901
24182	37549	1	applied	\N	\N	\N	\N	184695	184695	351902
24182	37550	2	applied	\N	\N	\N	\N	184696	184696	351903
24184	37551	0	applied	\N	\N	\N	\N	184700	184700	351907
24184	37552	1	applied	\N	\N	\N	\N	184701	184701	351908
24187	37194	0	applied	\N	\N	\N	\N	184707	184707	351914
24187	37270	1	applied	\N	\N	\N	\N	184708	184708	351915
24187	37285	2	applied	\N	\N	\N	\N	184709	184709	351916
24187	37271	3	applied	\N	\N	\N	\N	184710	184710	351917
24187	37272	4	applied	\N	\N	\N	\N	184711	184711	351918
24187	37275	5	applied	\N	\N	\N	\N	184712	184712	351919
24074	37374	0	applied	\N	\N	\N	\N	184214	184214	351421
24074	37375	1	applied	\N	\N	\N	\N	184215	184215	351422
24079	37384	4	applied	\N	\N	\N	\N	184232	184232	351439
24079	37385	5	applied	\N	\N	\N	\N	184233	184233	351440
24081	37386	0	applied	\N	\N	\N	\N	184236	184236	351443
24081	37387	1	applied	\N	\N	\N	\N	184237	184237	351444
24083	37388	0	applied	\N	\N	\N	\N	184240	184240	351447
24083	37389	1	applied	\N	\N	\N	\N	184241	184241	351448
24083	37390	2	applied	\N	\N	\N	\N	184242	184242	351449
24083	37391	3	applied	\N	\N	\N	\N	184243	184243	351450
24087	37393	0	applied	\N	\N	\N	\N	184255	184255	351462
24087	37394	1	applied	\N	\N	\N	\N	184256	184256	351463
24087	37395	2	applied	\N	\N	\N	\N	184257	184257	351464
24087	37396	3	applied	\N	\N	\N	\N	184258	184258	351465
24087	37397	4	applied	\N	\N	\N	\N	184259	184259	351466
24087	37398	5	applied	\N	\N	\N	\N	184260	184260	351467
24087	37399	6	applied	\N	\N	\N	\N	184261	184261	351468
24087	37400	7	applied	\N	\N	\N	\N	184262	184262	351469
24091	37404	1	applied	\N	\N	\N	\N	184282	184282	351489
24094	37411	0	applied	\N	\N	\N	\N	184289	184289	351496
24094	37412	1	applied	\N	\N	\N	\N	184290	184290	351497
24099	37413	0	applied	\N	\N	\N	\N	184299	184299	351506
24099	37414	1	applied	\N	\N	\N	\N	184300	184300	351507
24103	37416	0	applied	\N	\N	\N	\N	184306	184306	351513
24103	37417	1	applied	\N	\N	\N	\N	184307	184307	351514
24106	37420	0	applied	\N	\N	\N	\N	184312	184312	351519
24106	37421	1	applied	\N	\N	\N	\N	184313	184313	351520
24106	37422	2	applied	\N	\N	\N	\N	184314	184314	351521
24108	37423	0	applied	\N	\N	\N	\N	184315	184315	351522
24115	37426	0	applied	\N	\N	\N	\N	184320	184320	351527
24118	37427	0	applied	\N	\N	\N	\N	184322	184322	351529
24118	37428	1	applied	\N	\N	\N	\N	184323	184323	351530
24118	37429	2	applied	\N	\N	\N	\N	184324	184324	351531
24118	37430	3	applied	\N	\N	\N	\N	184325	184325	351532
24118	37432	5	applied	\N	\N	\N	\N	184327	184327	351534
24118	37433	6	applied	\N	\N	\N	\N	184328	184328	351535
24118	37434	7	applied	\N	\N	\N	\N	184329	184329	351536
24118	37435	8	applied	\N	\N	\N	\N	184330	184330	351537
24118	37436	9	applied	\N	\N	\N	\N	184331	184331	351538
24120	37437	0	applied	\N	\N	\N	\N	184342	184342	351549
24120	37438	1	applied	\N	\N	\N	\N	184343	184343	351550
24125	37443	0	applied	\N	\N	\N	\N	184356	184356	351563
24125	37444	1	applied	\N	\N	\N	\N	184357	184357	351564
24133	37461	0	applied	\N	\N	\N	\N	184386	184386	351593
24133	37462	1	applied	\N	\N	\N	\N	184387	184387	351594
24133	37463	2	applied	\N	\N	\N	\N	184388	184388	351595
24133	37464	3	applied	\N	\N	\N	\N	184389	184389	351596
24133	37465	4	applied	\N	\N	\N	\N	184390	184390	351597
24133	37466	5	applied	\N	\N	\N	\N	184391	184391	351598
24142	37483	0	applied	\N	\N	\N	\N	184414	184414	351621
24142	37481	2	applied	\N	\N	\N	\N	184416	184416	351623
24142	37482	3	applied	\N	\N	\N	\N	184417	184417	351624
24148	37348	0	applied	\N	\N	\N	\N	184534	184534	351741
24148	37349	1	applied	\N	\N	\N	\N	184535	184535	351742
24148	37350	2	applied	\N	\N	\N	\N	184536	184536	351743
24148	37354	3	applied	\N	\N	\N	\N	184537	184537	351744
24148	37355	4	applied	\N	\N	\N	\N	184538	184538	351745
24148	37356	5	applied	\N	\N	\N	\N	184539	184539	351746
24148	37357	6	applied	\N	\N	\N	\N	184540	184540	351747
24148	37358	7	applied	\N	\N	\N	\N	184541	184541	351748
24148	37364	8	applied	\N	\N	\N	\N	184542	184542	351749
24148	37366	9	applied	\N	\N	\N	\N	184543	184543	351750
24148	37367	10	applied	\N	\N	\N	\N	184544	184544	351751
24148	37370	11	applied	\N	\N	\N	\N	184545	184545	351752
24148	37372	12	applied	\N	\N	\N	\N	184546	184546	351753
24148	37374	13	applied	\N	\N	\N	\N	184547	184547	351754
24148	37378	15	applied	\N	\N	\N	\N	184549	184549	351756
24148	37380	16	applied	\N	\N	\N	\N	184550	184550	351757
24148	37381	17	applied	\N	\N	\N	\N	184551	184551	351758
24148	37382	18	applied	\N	\N	\N	\N	184552	184552	351759
24148	37386	19	applied	\N	\N	\N	\N	184553	184553	351760
24148	37388	20	applied	\N	\N	\N	\N	184554	184554	351761
24148	37389	21	applied	\N	\N	\N	\N	184555	184555	351762
24148	37393	22	applied	\N	\N	\N	\N	184556	184556	351763
24148	37394	23	applied	\N	\N	\N	\N	184557	184557	351764
24148	37395	24	applied	\N	\N	\N	\N	184558	184558	351765
24148	37396	25	applied	\N	\N	\N	\N	184559	184559	351766
24148	37401	26	applied	\N	\N	\N	\N	184560	184560	351767
24148	37403	27	applied	\N	\N	\N	\N	184561	184561	351768
24148	37405	28	applied	\N	\N	\N	\N	184562	184562	351769
24148	37407	29	applied	\N	\N	\N	\N	184563	184563	351770
24148	37408	30	applied	\N	\N	\N	\N	184564	184564	351771
24187	37276	6	applied	\N	\N	\N	\N	184713	184713	351920
24187	37277	7	applied	\N	\N	\N	\N	184714	184714	351921
24187	37281	8	applied	\N	\N	\N	\N	184715	184715	351922
24187	37282	9	applied	\N	\N	\N	\N	184716	184716	351923
24187	37286	10	applied	\N	\N	\N	\N	184717	184717	351924
24187	37287	11	applied	\N	\N	\N	\N	184718	184718	351925
24187	37288	12	applied	\N	\N	\N	\N	184719	184719	351926
24187	33609	13	applied	\N	\N	\N	\N	184720	184720	351927
24187	37237	14	applied	\N	\N	\N	\N	184721	184721	351928
24187	37530	15	applied	\N	\N	\N	\N	184722	184722	351929
24187	37492	16	applied	\N	\N	\N	\N	184723	184723	351930
24187	37431	17	applied	\N	\N	\N	\N	184724	184724	351931
24187	37495	18	applied	\N	\N	\N	\N	184725	184725	351932
24187	37238	19	applied	\N	\N	\N	\N	184726	184726	351933
24187	37501	20	applied	\N	\N	\N	\N	184727	184727	351934
24187	37434	21	applied	\N	\N	\N	\N	184728	184728	351935
24187	37459	23	applied	\N	\N	\N	\N	184730	184730	351937
24187	37463	24	applied	\N	\N	\N	\N	184731	184731	351938
24187	37464	25	applied	\N	\N	\N	\N	184732	184732	351939
24187	37518	26	applied	\N	\N	\N	\N	184733	184733	351940
24187	37511	27	applied	\N	\N	\N	\N	184734	184734	351941
24187	37517	28	applied	\N	\N	\N	\N	184735	184735	351942
24187	37524	29	applied	\N	\N	\N	\N	184736	184736	351943
24187	37534	30	applied	\N	\N	\N	\N	184737	184737	351944
24187	37542	31	applied	\N	\N	\N	\N	184738	184738	351945
24187	37550	32	applied	\N	\N	\N	\N	184739	184739	351946
24187	37557	33	applied	\N	\N	\N	\N	184740	184740	351947
24192	37558	0	applied	\N	\N	\N	\N	184747	184747	351954
24192	37559	1	applied	\N	\N	\N	\N	184748	184748	351955
24195	37560	0	applied	\N	\N	\N	\N	184754	184754	351961
24079	37381	1	applied	\N	\N	\N	\N	184229	184229	351436
24079	37382	2	applied	\N	\N	\N	\N	184230	184230	351437
24127	37450	1	applied	\N	\N	\N	\N	184363	184363	351570
24130	37451	0	applied	\N	\N	\N	\N	184368	184368	351575
24130	37452	1	applied	\N	\N	\N	\N	184369	184369	351576
24136	37467	0	applied	\N	\N	\N	\N	184396	184396	351603
24136	37468	1	applied	\N	\N	\N	\N	184397	184397	351604
24138	37471	0	applied	\N	\N	\N	\N	184400	184400	351607
24138	37472	1	applied	\N	\N	\N	\N	184401	184401	351608
24138	37469	2	applied	\N	\N	\N	\N	184402	184402	351609
24138	37470	3	applied	\N	\N	\N	\N	184403	184403	351610
24141	37481	0	applied	\N	\N	\N	\N	184412	184412	351619
24141	37482	1	applied	\N	\N	\N	\N	184413	184413	351620
24144	37126	0	applied	\N	\N	\N	\N	184422	184422	351629
24144	37127	1	applied	\N	\N	\N	\N	184423	184423	351630
24144	37143	2	applied	\N	\N	\N	\N	184424	184424	351631
24144	37148	3	applied	\N	\N	\N	\N	184425	184425	351632
24144	37132	4	applied	\N	\N	\N	\N	184426	184426	351633
24144	37139	6	applied	\N	\N	\N	\N	184428	184428	351635
24144	37142	7	applied	\N	\N	\N	\N	184429	184429	351636
24144	37149	8	applied	\N	\N	\N	\N	184430	184430	351637
24144	37165	9	applied	\N	\N	\N	\N	184431	184431	351638
24144	37285	10	applied	\N	\N	\N	\N	184432	184432	351639
24144	37176	11	applied	\N	\N	\N	\N	184433	184433	351640
24144	37179	12	applied	\N	\N	\N	\N	184434	184434	351641
24144	37182	13	applied	\N	\N	\N	\N	184435	184435	351642
24144	37185	14	applied	\N	\N	\N	\N	184436	184436	351643
24144	37286	15	applied	\N	\N	\N	\N	184437	184437	351644
24144	37287	16	applied	\N	\N	\N	\N	184438	184438	351645
24144	37288	17	applied	\N	\N	\N	\N	184439	184439	351646
24144	37188	18	applied	\N	\N	\N	\N	184440	184440	351647
24144	37191	19	applied	\N	\N	\N	\N	184441	184441	351648
24144	37199	20	applied	\N	\N	\N	\N	184442	184442	351649
24144	37202	21	applied	\N	\N	\N	\N	184443	184443	351650
24144	37208	23	applied	\N	\N	\N	\N	184445	184445	351652
24144	37210	24	applied	\N	\N	\N	\N	184446	184446	351653
24144	37213	25	applied	\N	\N	\N	\N	184447	184447	351654
24144	37216	26	applied	\N	\N	\N	\N	184448	184448	351655
24144	37219	27	applied	\N	\N	\N	\N	184449	184449	351656
24144	37222	28	applied	\N	\N	\N	\N	184450	184450	351657
24144	37223	29	applied	\N	\N	\N	\N	184451	184451	351658
24144	37224	30	applied	\N	\N	\N	\N	184452	184452	351659
24144	37231	31	applied	\N	\N	\N	\N	184453	184453	351660
24144	37234	32	applied	\N	\N	\N	\N	184454	184454	351661
24144	37239	33	applied	\N	\N	\N	\N	184455	184455	351662
24144	37242	34	applied	\N	\N	\N	\N	184456	184456	351663
24144	37150	35	applied	\N	\N	\N	\N	184457	184457	351664
24144	37151	36	applied	\N	\N	\N	\N	184458	184458	351665
24144	37152	37	applied	\N	\N	\N	\N	184459	184459	351666
24144	37244	38	applied	\N	\N	\N	\N	184460	184460	351667
24144	37250	40	applied	\N	\N	\N	\N	184462	184462	351669
24144	37253	41	applied	\N	\N	\N	\N	184463	184463	351670
24144	37256	42	applied	\N	\N	\N	\N	184464	184464	351671
24144	37259	43	applied	\N	\N	\N	\N	184465	184465	351672
24144	37263	44	applied	\N	\N	\N	\N	184466	184466	351673
24144	37266	45	applied	\N	\N	\N	\N	184467	184467	351674
24144	37269	46	applied	\N	\N	\N	\N	184468	184468	351675
24144	37278	47	applied	\N	\N	\N	\N	184469	184469	351676
24144	37283	48	applied	\N	\N	\N	\N	184470	184470	351677
24144	37284	49	applied	\N	\N	\N	\N	184471	184471	351678
24144	37293	50	applied	\N	\N	\N	\N	184472	184472	351679
24144	37153	51	applied	\N	\N	\N	\N	184473	184473	351680
24144	37154	52	applied	\N	\N	\N	\N	184474	184474	351681
24144	37155	53	applied	\N	\N	\N	\N	184475	184475	351682
24144	37156	54	applied	\N	\N	\N	\N	184476	184476	351683
24144	37157	55	applied	\N	\N	\N	\N	184477	184477	351684
24144	37159	57	applied	\N	\N	\N	\N	184479	184479	351686
24144	37162	58	applied	\N	\N	\N	\N	184480	184480	351687
24144	37163	59	applied	\N	\N	\N	\N	184481	184481	351688
24144	37164	60	applied	\N	\N	\N	\N	184482	184482	351689
24144	37166	61	applied	\N	\N	\N	\N	184483	184483	351690
24144	37167	62	applied	\N	\N	\N	\N	184484	184484	351691
24144	37168	63	applied	\N	\N	\N	\N	184485	184485	351692
24144	37171	64	applied	\N	\N	\N	\N	184486	184486	351693
24144	37172	65	applied	\N	\N	\N	\N	184487	184487	351694
24144	37173	66	applied	\N	\N	\N	\N	184488	184488	351695
24144	37174	67	applied	\N	\N	\N	\N	184489	184489	351696
24144	37175	68	applied	\N	\N	\N	\N	184490	184490	351697
24144	37194	69	applied	\N	\N	\N	\N	184491	184491	351698
24144	37195	70	applied	\N	\N	\N	\N	184492	184492	351699
24144	37196	71	applied	\N	\N	\N	\N	184493	184493	351700
24144	37197	72	applied	\N	\N	\N	\N	184494	184494	351701
24148	37413	32	applied	\N	\N	\N	\N	184566	184566	351773
24148	37415	33	applied	\N	\N	\N	\N	184567	184567	351774
24148	37416	34	applied	\N	\N	\N	\N	184568	184568	351775
24148	37418	35	applied	\N	\N	\N	\N	184569	184569	351776
24148	37420	36	applied	\N	\N	\N	\N	184570	184570	351777
24148	37427	37	applied	\N	\N	\N	\N	184571	184571	351778
24148	37428	38	applied	\N	\N	\N	\N	184572	184572	351779
24148	37429	39	applied	\N	\N	\N	\N	184573	184573	351780
24148	37430	40	applied	\N	\N	\N	\N	184574	184574	351781
24148	37437	41	applied	\N	\N	\N	\N	184575	184575	351782
24148	37439	42	applied	\N	\N	\N	\N	184576	184576	351783
24148	37440	43	applied	\N	\N	\N	\N	184577	184577	351784
24148	37443	44	applied	\N	\N	\N	\N	184578	184578	351785
24148	37445	45	applied	\N	\N	\N	\N	184579	184579	351786
24148	37446	46	applied	\N	\N	\N	\N	184580	184580	351787
24148	37449	47	applied	\N	\N	\N	\N	184581	184581	351788
24148	37453	49	applied	\N	\N	\N	\N	184583	184583	351790
24148	37454	50	applied	\N	\N	\N	\N	184584	184584	351791
24148	37455	51	applied	\N	\N	\N	\N	184585	184585	351792
24151	37487	0	applied	\N	\N	\N	\N	184587	184587	351794
24156	37500	0	applied	\N	\N	\N	\N	184605	184605	351812
24156	37501	1	applied	\N	\N	\N	\N	184606	184606	351813
24156	37502	2	applied	\N	\N	\N	\N	184607	184607	351814
24160	37503	0	applied	\N	\N	\N	\N	184616	184616	351823
24160	37504	1	applied	\N	\N	\N	\N	184617	184617	351824
24163	37505	0	applied	\N	\N	\N	\N	184620	184620	351827
24163	37506	1	applied	\N	\N	\N	\N	184621	184621	351828
24163	37507	2	applied	\N	\N	\N	\N	184622	184622	351829
24163	33609	3	applied	\N	\N	\N	\N	184623	184623	351830
24163	37508	4	applied	\N	\N	\N	\N	184624	184624	351831
24113	37424	0	applied	\N	\N	\N	\N	184318	184318	351525
24114	37425	0	applied	\N	\N	\N	\N	184319	184319	351526
24144	37296	78	applied	\N	\N	\N	\N	184500	184500	351707
24144	37299	79	applied	\N	\N	\N	\N	184501	184501	351708
24144	37300	80	applied	\N	\N	\N	\N	184502	184502	351709
24144	37305	81	applied	\N	\N	\N	\N	184503	184503	351710
24144	37308	82	applied	\N	\N	\N	\N	184504	184504	351711
24144	37310	83	applied	\N	\N	\N	\N	184505	184505	351712
24144	37313	84	applied	\N	\N	\N	\N	184506	184506	351713
24144	37318	85	applied	\N	\N	\N	\N	184507	184507	351714
24144	37321	86	applied	\N	\N	\N	\N	184508	184508	351715
24144	37322	87	applied	\N	\N	\N	\N	184509	184509	351716
24144	37327	88	applied	\N	\N	\N	\N	184510	184510	351717
24144	37328	89	applied	\N	\N	\N	\N	184511	184511	351718
24144	37332	90	applied	\N	\N	\N	\N	184512	184512	351719
24144	37333	91	applied	\N	\N	\N	\N	184513	184513	351720
24144	37336	92	applied	\N	\N	\N	\N	184514	184514	351721
24144	37338	93	applied	\N	\N	\N	\N	184515	184515	351722
24144	37342	95	applied	\N	\N	\N	\N	184517	184517	351724
24144	37344	96	applied	\N	\N	\N	\N	184518	184518	351725
24144	37346	97	applied	\N	\N	\N	\N	184519	184519	351726
24144	37348	98	applied	\N	\N	\N	\N	184520	184520	351727
24144	37349	99	applied	\N	\N	\N	\N	184521	184521	351728
24144	37350	100	applied	\N	\N	\N	\N	184522	184522	351729
24144	37354	101	applied	\N	\N	\N	\N	184523	184523	351730
24144	37355	102	applied	\N	\N	\N	\N	184524	184524	351731
24144	37356	103	applied	\N	\N	\N	\N	184525	184525	351732
24144	37357	104	applied	\N	\N	\N	\N	184526	184526	351733
24144	37358	106	applied	\N	\N	\N	\N	184527	184527	351734
24144	37364	107	applied	\N	\N	\N	\N	184528	184528	351735
24144	37366	108	applied	\N	\N	\N	\N	184529	184529	351736
24145	37485	0	applied	\N	\N	\N	\N	184530	184530	351737
24145	37486	1	applied	\N	\N	\N	\N	184531	184531	351738
24150	37487	0	applied	\N	\N	\N	\N	184586	184586	351793
24153	37489	1	applied	\N	\N	\N	\N	184594	184594	351801
24153	37490	2	applied	\N	\N	\N	\N	184595	184595	351802
24153	37491	3	applied	\N	\N	\N	\N	184596	184596	351803
24153	37492	4	applied	\N	\N	\N	\N	184597	184597	351804
24155	37496	0	applied	\N	\N	\N	\N	184601	184601	351808
24155	37497	1	applied	\N	\N	\N	\N	184602	184602	351809
24155	37498	2	applied	\N	\N	\N	\N	184603	184603	351810
24155	37499	3	applied	\N	\N	\N	\N	184604	184604	351811
24167	37514	0	applied	\N	\N	\N	\N	184640	184640	351847
24167	37515	1	applied	\N	\N	\N	\N	184641	184641	351848
24167	37516	2	applied	\N	\N	\N	\N	184642	184642	351849
24167	37517	3	applied	\N	\N	\N	\N	184643	184643	351850
24167	37518	4	applied	\N	\N	\N	\N	184644	184644	351851
24167	37519	5	applied	\N	\N	\N	\N	184645	184645	351852
24170	37520	0	applied	\N	\N	\N	\N	184654	184654	351861
24170	37521	1	applied	\N	\N	\N	\N	184655	184655	351862
24177	37538	1	applied	\N	\N	\N	\N	184681	184681	351888
24178	37539	0	applied	\N	\N	\N	\N	184682	184682	351889
24178	37540	1	applied	\N	\N	\N	\N	184683	184683	351890
24178	37541	2	applied	\N	\N	\N	\N	184684	184684	351891
24178	37542	3	applied	\N	\N	\N	\N	184685	184685	351892
24178	37543	4	applied	\N	\N	\N	\N	184686	184686	351893
24178	37544	5	applied	\N	\N	\N	\N	184687	184687	351894
24178	37545	6	applied	\N	\N	\N	\N	184688	184688	351895
24181	37546	0	applied	\N	\N	\N	\N	184692	184692	351899
24181	37547	1	applied	\N	\N	\N	\N	184693	184693	351900
24183	37548	0	applied	\N	\N	\N	\N	184697	184697	351904
24183	37549	1	applied	\N	\N	\N	\N	184698	184698	351905
24183	37550	2	applied	\N	\N	\N	\N	184699	184699	351906
24185	37553	0	applied	\N	\N	\N	\N	184702	184702	351909
24185	37554	1	applied	\N	\N	\N	\N	184703	184703	351910
24193	37558	0	applied	\N	\N	\N	\N	184749	184749	351956
24196	37563	0	applied	\N	\N	\N	\N	184757	184757	351964
24196	37564	1	applied	\N	\N	\N	\N	184758	184758	351965
24196	37565	2	applied	\N	\N	\N	\N	184759	184759	351966
24196	37566	3	applied	\N	\N	\N	\N	184760	184760	351967
24199	37576	0	applied	\N	\N	\N	\N	184770	184770	351977
24199	37577	1	applied	\N	\N	\N	\N	184771	184771	351978
24199	37578	2	applied	\N	\N	\N	\N	184772	184772	351979
24199	37579	3	applied	\N	\N	\N	\N	184773	184773	351980
24201	37285	0	applied	\N	\N	\N	\N	184778	184778	351985
24201	37276	1	applied	\N	\N	\N	\N	184779	184779	351986
24201	37277	2	applied	\N	\N	\N	\N	184780	184780	351987
24201	37281	3	applied	\N	\N	\N	\N	184781	184781	351988
24201	37282	4	applied	\N	\N	\N	\N	184782	184782	351989
24201	37286	5	applied	\N	\N	\N	\N	184783	184783	351990
24201	37287	6	applied	\N	\N	\N	\N	184784	184784	351991
24201	37288	7	applied	\N	\N	\N	\N	184785	184785	351992
24201	37237	9	applied	\N	\N	\N	\N	184787	184787	351994
24201	37530	10	applied	\N	\N	\N	\N	184788	184788	351995
24201	37492	11	applied	\N	\N	\N	\N	184789	184789	351996
24201	37431	12	applied	\N	\N	\N	\N	184790	184790	351997
24201	37495	13	applied	\N	\N	\N	\N	184791	184791	351998
24201	37238	14	applied	\N	\N	\N	\N	184792	184792	351999
24201	37501	15	applied	\N	\N	\N	\N	184793	184793	352000
24201	37434	16	applied	\N	\N	\N	\N	184794	184794	352001
24201	37458	17	applied	\N	\N	\N	\N	184795	184795	352002
24201	37459	18	applied	\N	\N	\N	\N	184796	184796	352003
24201	37463	19	applied	\N	\N	\N	\N	184797	184797	352004
24201	37464	20	applied	\N	\N	\N	\N	184798	184798	352005
24201	37518	21	applied	\N	\N	\N	\N	184799	184799	352006
24201	37511	22	applied	\N	\N	\N	\N	184800	184800	352007
24201	37517	23	applied	\N	\N	\N	\N	184801	184801	352008
24201	37524	24	applied	\N	\N	\N	\N	184802	184802	352009
24201	37542	26	applied	\N	\N	\N	\N	184804	184804	352011
24201	37550	27	applied	\N	\N	\N	\N	184805	184805	352012
24201	37557	28	applied	\N	\N	\N	\N	184806	184806	352013
24201	37566	29	applied	\N	\N	\N	\N	184807	184807	352014
24201	37577	30	applied	\N	\N	\N	\N	184808	184808	352015
24208	37589	0	applied	\N	\N	\N	\N	184839	184839	352046
24208	37590	1	applied	\N	\N	\N	\N	184840	184840	352047
24208	37591	2	applied	\N	\N	\N	\N	184841	184841	352048
24211	37592	0	applied	\N	\N	\N	\N	184849	184849	352056
24211	37593	1	applied	\N	\N	\N	\N	184850	184850	352057
24211	37594	2	applied	\N	\N	\N	\N	184851	184851	352058
24211	37595	3	applied	\N	\N	\N	\N	184852	184852	352059
24211	37596	4	applied	\N	\N	\N	\N	184853	184853	352060
24211	37597	5	applied	\N	\N	\N	\N	184854	184854	352061
24144	37277	75	applied	\N	\N	\N	\N	184497	184497	351704
24144	37281	76	applied	\N	\N	\N	\N	184498	184498	351705
24165	37513	1	applied	\N	\N	\N	\N	184637	184637	351844
24168	37514	0	applied	\N	\N	\N	\N	184646	184646	351853
24168	37515	1	applied	\N	\N	\N	\N	184647	184647	351854
24168	37516	2	applied	\N	\N	\N	\N	184648	184648	351855
24168	37517	3	applied	\N	\N	\N	\N	184649	184649	351856
24168	37518	4	applied	\N	\N	\N	\N	184650	184650	351857
24168	37519	5	applied	\N	\N	\N	\N	184651	184651	351858
24173	37527	0	applied	\N	\N	\N	\N	184666	184666	351873
24173	37528	1	applied	\N	\N	\N	\N	184667	184667	351874
24173	37529	2	applied	\N	\N	\N	\N	184668	184668	351875
24173	37530	3	applied	\N	\N	\N	\N	184669	184669	351876
24173	37531	4	applied	\N	\N	\N	\N	184670	184670	351877
24173	37532	5	applied	\N	\N	\N	\N	184671	184671	351878
24173	37533	6	applied	\N	\N	\N	\N	184672	184672	351879
24173	37534	7	applied	\N	\N	\N	\N	184673	184673	351880
24189	37558	0	applied	\N	\N	\N	\N	184741	184741	351948
24190	37558	0	applied	\N	\N	\N	\N	184743	184743	351950
24190	37559	1	applied	\N	\N	\N	\N	184744	184744	351951
24194	37560	0	applied	\N	\N	\N	\N	184751	184751	351958
24194	37561	1	applied	\N	\N	\N	\N	184752	184752	351959
24194	37562	2	applied	\N	\N	\N	\N	184753	184753	351960
24197	37567	0	applied	\N	\N	\N	\N	184761	184761	351968
24197	37568	1	applied	\N	\N	\N	\N	184762	184762	351969
24197	37569	2	applied	\N	\N	\N	\N	184763	184763	351970
24197	37570	3	applied	\N	\N	\N	\N	184764	184764	351971
24197	37571	4	applied	\N	\N	\N	\N	184765	184765	351972
24197	37572	5	applied	\N	\N	\N	\N	184766	184766	351973
24200	37576	0	applied	\N	\N	\N	\N	184774	184774	351981
24200	37577	1	applied	\N	\N	\N	\N	184775	184775	351982
24200	37578	2	applied	\N	\N	\N	\N	184776	184776	351983
24200	37579	3	applied	\N	\N	\N	\N	184777	184777	351984
24204	37583	0	applied	\N	\N	\N	\N	184815	184815	352022
24204	37585	2	applied	\N	\N	\N	\N	184817	184817	352024
24204	37586	3	applied	\N	\N	\N	\N	184818	184818	352025
24204	37587	4	applied	\N	\N	\N	\N	184819	184819	352026
24204	37588	5	applied	\N	\N	\N	\N	184820	184820	352027
24209	37592	0	applied	\N	\N	\N	\N	184842	184842	352049
24209	37593	1	applied	\N	\N	\N	\N	184843	184843	352050
24209	37594	2	applied	\N	\N	\N	\N	184844	184844	352051
24209	37595	3	applied	\N	\N	\N	\N	184845	184845	352052
24209	37596	4	applied	\N	\N	\N	\N	184846	184846	352053
24209	37597	5	applied	\N	\N	\N	\N	184847	184847	352054
24209	37598	6	applied	\N	\N	\N	\N	184848	184848	352055
24211	37598	6	applied	\N	\N	\N	\N	184855	184855	352062
24213	37599	0	applied	\N	\N	\N	\N	184863	184863	352070
24213	37600	1	applied	\N	\N	\N	\N	184864	184864	352071
24213	37601	2	applied	\N	\N	\N	\N	184865	184865	352072
24214	37599	0	applied	\N	\N	\N	\N	184866	184866	352073
24214	37601	2	applied	\N	\N	\N	\N	184868	184868	352075
24216	37602	0	applied	\N	\N	\N	\N	184872	184872	352079
24216	37603	1	applied	\N	\N	\N	\N	184873	184873	352080
24216	37604	2	applied	\N	\N	\N	\N	184874	184874	352081
24218	37605	0	applied	\N	\N	\N	\N	184878	184878	352085
24218	37606	1	applied	\N	\N	\N	\N	184879	184879	352086
24218	37607	2	applied	\N	\N	\N	\N	184880	184880	352087
24221	37608	0	applied	\N	\N	\N	\N	184888	184888	352095
24221	37609	1	applied	\N	\N	\N	\N	184889	184889	352096
24221	37610	2	applied	\N	\N	\N	\N	184890	184890	352097
24222	37612	0	applied	\N	\N	\N	\N	184891	184891	352098
24222	37613	1	applied	\N	\N	\N	\N	184892	184892	352099
24222	37611	2	applied	\N	\N	\N	\N	184893	184893	352100
24222	37614	3	applied	\N	\N	\N	\N	184894	184894	352101
24223	37615	0	applied	\N	\N	\N	\N	184895	184895	352102
24223	37616	1	applied	\N	\N	\N	\N	184896	184896	352103
24225	37618	0	applied	\N	\N	\N	\N	184901	184901	352108
24225	37619	1	applied	\N	\N	\N	\N	184902	184902	352109
24225	37620	2	applied	\N	\N	\N	\N	184903	184903	352110
24225	37621	3	applied	\N	\N	\N	\N	184904	184904	352111
24227	37618	0	applied	\N	\N	\N	\N	184909	184909	352116
24227	37619	1	applied	\N	\N	\N	\N	184910	184910	352117
24227	37620	2	applied	\N	\N	\N	\N	184911	184911	352118
24227	37621	3	applied	\N	\N	\N	\N	184912	184912	352119
24228	37618	0	applied	\N	\N	\N	\N	184913	184913	352120
24228	37619	1	applied	\N	\N	\N	\N	184914	184914	352121
24228	37620	2	applied	\N	\N	\N	\N	184915	184915	352122
24228	37621	3	applied	\N	\N	\N	\N	184916	184916	352123
24231	37622	0	applied	\N	\N	\N	\N	184925	184925	352132
24231	37623	1	applied	\N	\N	\N	\N	184926	184926	352133
24231	37624	2	applied	\N	\N	\N	\N	184927	184927	352134
24232	37622	0	applied	\N	\N	\N	\N	184928	184928	352135
24232	37624	2	applied	\N	\N	\N	\N	184930	184930	352137
24233	37625	0	applied	\N	\N	\N	\N	184931	184931	352138
24233	37626	1	applied	\N	\N	\N	\N	184932	184932	352139
24233	37627	2	applied	\N	\N	\N	\N	184933	184933	352140
24234	37625	0	applied	\N	\N	\N	\N	184934	184934	352141
24234	37626	1	applied	\N	\N	\N	\N	184935	184935	352142
24234	37627	2	applied	\N	\N	\N	\N	184936	184936	352143
24236	37628	0	applied	\N	\N	\N	\N	184941	184941	352148
24236	37629	1	applied	\N	\N	\N	\N	184942	184942	352149
24236	37630	2	applied	\N	\N	\N	\N	184943	184943	352150
24236	37631	3	applied	\N	\N	\N	\N	184944	184944	352151
24238	37634	0	applied	\N	\N	\N	\N	184947	184947	352154
24238	37635	1	applied	\N	\N	\N	\N	184948	184948	352155
24238	37636	2	applied	\N	\N	\N	\N	184949	184949	352156
24240	37637	0	applied	\N	\N	\N	\N	184963	184963	352170
24241	37637	0	applied	\N	\N	\N	\N	184966	184966	352173
24241	37639	2	applied	\N	\N	\N	\N	184968	184968	352175
24245	37585	0	applied	\N	\N	\N	\N	184979	184979	352186
24245	37595	1	applied	\N	\N	\N	\N	184980	184980	352187
24245	37609	2	applied	\N	\N	\N	\N	184981	184981	352188
24245	37619	3	applied	\N	\N	\N	\N	184982	184982	352189
24245	37630	4	applied	\N	\N	\N	\N	184983	184983	352190
24245	37641	5	applied	\N	\N	\N	\N	184984	184984	352191
24248	37647	0	applied	\N	\N	\N	\N	184991	184991	352198
24248	37648	1	applied	\N	\N	\N	\N	184992	184992	352199
24248	37649	2	applied	\N	\N	\N	\N	184993	184993	352200
24248	37650	3	applied	\N	\N	\N	\N	184994	184994	352201
24248	37651	4	applied	\N	\N	\N	\N	184995	184995	352202
24248	37652	5	applied	\N	\N	\N	\N	184996	184996	352203
24248	37653	6	applied	\N	\N	\N	\N	184997	184997	352204
24163	37510	6	applied	\N	\N	\N	\N	184626	184626	351833
24163	37511	7	applied	\N	\N	\N	\N	184627	184627	351834
24198	37575	2	applied	\N	\N	\N	\N	184769	184769	351976
24203	37580	0	applied	\N	\N	\N	\N	184812	184812	352019
24203	37581	1	applied	\N	\N	\N	\N	184813	184813	352020
24203	37582	2	applied	\N	\N	\N	\N	184814	184814	352021
24206	37583	0	applied	\N	\N	\N	\N	184827	184827	352034
24206	37584	1	applied	\N	\N	\N	\N	184828	184828	352035
24206	37585	2	applied	\N	\N	\N	\N	184829	184829	352036
24206	37586	3	applied	\N	\N	\N	\N	184830	184830	352037
24206	37587	4	applied	\N	\N	\N	\N	184831	184831	352038
24206	37588	5	applied	\N	\N	\N	\N	184832	184832	352039
24207	37583	0	applied	\N	\N	\N	\N	184833	184833	352040
24207	37584	1	applied	\N	\N	\N	\N	184834	184834	352041
24207	37585	2	applied	\N	\N	\N	\N	184835	184835	352042
24207	37586	3	applied	\N	\N	\N	\N	184836	184836	352043
24207	37588	5	applied	\N	\N	\N	\N	184838	184838	352045
24215	37602	0	applied	\N	\N	\N	\N	184869	184869	352076
24215	37603	1	applied	\N	\N	\N	\N	184870	184870	352077
24215	37604	2	applied	\N	\N	\N	\N	184871	184871	352078
24217	37605	0	applied	\N	\N	\N	\N	184875	184875	352082
24217	37606	1	applied	\N	\N	\N	\N	184876	184876	352083
24217	37607	2	applied	\N	\N	\N	\N	184877	184877	352084
24220	37608	0	applied	\N	\N	\N	\N	184885	184885	352092
24220	37609	1	applied	\N	\N	\N	\N	184886	184886	352093
24220	37610	2	applied	\N	\N	\N	\N	184887	184887	352094
24230	37618	0	applied	\N	\N	\N	\N	184921	184921	352128
24230	37619	1	applied	\N	\N	\N	\N	184922	184922	352129
24230	37620	2	applied	\N	\N	\N	\N	184923	184923	352130
24230	37621	3	applied	\N	\N	\N	\N	184924	184924	352131
24235	37628	0	applied	\N	\N	\N	\N	184937	184937	352144
24235	37629	1	applied	\N	\N	\N	\N	184938	184938	352145
24235	37631	3	applied	\N	\N	\N	\N	184940	184940	352147
24237	37632	0	applied	\N	\N	\N	\N	184945	184945	352152
24237	37633	1	applied	\N	\N	\N	\N	184946	184946	352153
24244	37640	0	applied	\N	\N	\N	\N	184975	184975	352182
24244	37641	1	applied	\N	\N	\N	\N	184976	184976	352183
24244	37642	2	applied	\N	\N	\N	\N	184977	184977	352184
24244	37643	3	applied	\N	\N	\N	\N	184978	184978	352185
24246	37644	0	applied	\N	\N	\N	\N	184985	184985	352192
24246	37645	1	applied	\N	\N	\N	\N	184986	184986	352193
24246	37646	2	applied	\N	\N	\N	\N	184987	184987	352194
24248	37654	7	applied	\N	\N	\N	\N	184998	184998	352205
24248	37655	8	applied	\N	\N	\N	\N	184999	184999	352206
24248	37656	9	applied	\N	\N	\N	\N	185000	185000	352207
24248	37657	10	applied	\N	\N	\N	\N	185001	185001	352208
24248	37658	11	applied	\N	\N	\N	\N	185002	185002	352209
24248	37659	12	applied	\N	\N	\N	\N	185003	185003	352210
24251	37661	1	applied	\N	\N	\N	\N	185025	185025	352232
24251	37662	2	applied	\N	\N	\N	\N	185026	185026	352233
24251	37663	3	applied	\N	\N	\N	\N	185027	185027	352234
24251	37664	4	applied	\N	\N	\N	\N	185028	185028	352235
24251	37665	5	applied	\N	\N	\N	\N	185029	185029	352236
24251	37666	6	applied	\N	\N	\N	\N	185030	185030	352237
24252	37667	0	applied	\N	\N	\N	\N	185031	185031	352238
24252	37668	1	applied	\N	\N	\N	\N	185032	185032	352239
24252	37669	2	applied	\N	\N	\N	\N	185033	185033	352240
24252	37670	3	applied	\N	\N	\N	\N	185034	185034	352241
24252	37671	4	applied	\N	\N	\N	\N	185035	185035	352242
24252	37672	5	applied	\N	\N	\N	\N	185036	185036	352243
24252	37673	6	applied	\N	\N	\N	\N	185037	185037	352244
24252	37674	7	applied	\N	\N	\N	\N	185038	185038	352245
24257	37675	0	applied	\N	\N	\N	\N	185047	185047	352254
24257	37676	1	applied	\N	\N	\N	\N	185048	185048	352255
24257	37678	3	applied	\N	\N	\N	\N	185050	185050	352257
24257	37679	4	applied	\N	\N	\N	\N	185051	185051	352258
24257	37680	5	applied	\N	\N	\N	\N	185052	185052	352259
24257	37681	6	applied	\N	\N	\N	\N	185053	185053	352260
24257	37682	7	applied	\N	\N	\N	\N	185054	185054	352261
24257	37683	8	applied	\N	\N	\N	\N	185055	185055	352262
24257	37684	9	applied	\N	\N	\N	\N	185056	185056	352263
24257	37685	10	applied	\N	\N	\N	\N	185057	185057	352264
24257	37686	11	applied	\N	\N	\N	\N	185058	185058	352265
24257	37687	12	applied	\N	\N	\N	\N	185059	185059	352266
24259	37688	0	applied	\N	\N	\N	\N	185073	185073	352280
24259	37689	1	applied	\N	\N	\N	\N	185074	185074	352281
24259	37690	2	applied	\N	\N	\N	\N	185075	185075	352282
24259	37691	3	applied	\N	\N	\N	\N	185076	185076	352283
24262	37692	0	applied	\N	\N	\N	\N	185084	185084	352291
24262	37693	1	applied	\N	\N	\N	\N	185085	185085	352292
24266	37695	0	applied	\N	\N	1000000000	\N	185112	185112	352319
24266	37697	1	applied	\N	\N	\N	\N	185113	185113	352320
24266	37698	2	applied	\N	\N	\N	\N	185114	185114	352321
24266	37699	3	applied	\N	\N	\N	\N	185115	185115	352322
24266	37700	4	applied	\N	\N	\N	\N	185116	185116	352323
24266	37696	5	applied	\N	\N	\N	\N	185117	185117	352324
24266	37701	6	applied	\N	\N	\N	\N	185118	185118	352325
24266	37702	7	applied	\N	\N	\N	\N	185119	185119	352326
24266	37703	8	applied	\N	\N	\N	\N	185120	185120	352327
24266	37704	9	applied	\N	\N	\N	\N	185121	185121	352328
24266	37705	10	applied	\N	\N	\N	\N	185122	185122	352329
24266	37706	11	applied	\N	\N	\N	\N	185123	185123	352330
24266	37707	12	applied	\N	\N	\N	\N	185124	185124	352331
24266	37708	13	applied	\N	\N	\N	\N	185125	185125	352332
24266	37709	14	applied	\N	\N	\N	\N	185126	185126	352333
24269	37713	0	applied	\N	\N	\N	\N	185130	185130	352337
24269	37715	2	applied	\N	\N	\N	\N	185132	185132	352339
24269	37716	3	applied	\N	\N	\N	\N	185133	185133	352340
24272	37717	0	applied	\N	\N	\N	\N	185142	185142	352349
24272	37718	1	applied	\N	\N	\N	\N	185143	185143	352350
24272	37719	2	applied	\N	\N	\N	\N	185144	185144	352351
24284	37729	0	applied	\N	\N	\N	\N	185179	185179	352386
24284	37730	1	applied	\N	\N	\N	\N	185180	185180	352387
24284	37731	2	applied	\N	\N	\N	\N	185181	185181	352388
24288	37732	0	applied	\N	\N	\N	\N	185185	185185	352392
24288	37733	1	applied	\N	\N	\N	\N	185186	185186	352393
24288	37734	2	applied	\N	\N	\N	\N	185187	185187	352394
24290	37735	0	applied	\N	\N	\N	\N	185192	185192	352399
24290	37736	1	applied	\N	\N	\N	\N	185193	185193	352400
24290	37737	2	applied	\N	\N	\N	\N	185194	185194	352401
24290	37738	3	applied	\N	\N	\N	\N	185195	185195	352402
24295	37745	0	applied	\N	\N	\N	\N	185216	185216	352423
24198	37574	1	applied	\N	\N	\N	\N	184768	184768	351975
24224	37615	0	applied	\N	\N	\N	\N	184898	184898	352105
24224	37616	1	applied	\N	\N	\N	\N	184899	184899	352106
24224	37617	2	applied	\N	\N	\N	\N	184900	184900	352107
24226	37618	0	applied	\N	\N	\N	\N	184905	184905	352112
24226	37619	1	applied	\N	\N	\N	\N	184906	184906	352113
24226	37621	3	applied	\N	\N	\N	\N	184908	184908	352115
24229	37618	0	applied	\N	\N	\N	\N	184917	184917	352124
24229	37619	1	applied	\N	\N	\N	\N	184918	184918	352125
24229	37620	2	applied	\N	\N	\N	\N	184919	184919	352126
24229	37621	3	applied	\N	\N	\N	\N	184920	184920	352127
24239	33609	0	applied	\N	\N	\N	\N	184950	184950	352157
24239	37530	1	applied	\N	\N	\N	\N	184951	184951	352158
24239	37492	2	applied	\N	\N	\N	\N	184952	184952	352159
24239	37431	3	applied	\N	\N	\N	\N	184953	184953	352160
24239	37495	4	applied	\N	\N	\N	\N	184954	184954	352161
24239	37501	5	applied	\N	\N	\N	\N	184955	184955	352162
24239	37434	6	applied	\N	\N	\N	\N	184956	184956	352163
24239	37458	7	applied	\N	\N	\N	\N	184957	184957	352164
24239	37459	8	applied	\N	\N	\N	\N	184958	184958	352165
24239	37463	9	applied	\N	\N	\N	\N	184959	184959	352166
24239	37464	10	applied	\N	\N	\N	\N	184960	184960	352167
24239	37562	12	applied	\N	\N	\N	\N	184962	184962	352169
24242	37637	0	applied	\N	\N	\N	\N	184969	184969	352176
24242	37638	1	applied	\N	\N	\N	\N	184970	184970	352177
24242	37639	2	applied	\N	\N	\N	\N	184971	184971	352178
24249	37647	0	applied	\N	\N	\N	\N	185004	185004	352211
24249	37648	1	applied	\N	\N	\N	\N	185005	185005	352212
24249	37649	2	applied	\N	\N	\N	\N	185006	185006	352213
24249	37650	3	applied	\N	\N	\N	\N	185007	185007	352214
24249	37651	4	applied	\N	\N	\N	\N	185008	185008	352215
24249	37652	5	applied	\N	\N	\N	\N	185009	185009	352216
24249	37653	6	applied	\N	\N	\N	\N	185010	185010	352217
24249	37654	7	applied	\N	\N	\N	\N	185011	185011	352218
24249	37655	8	applied	\N	\N	\N	\N	185012	185012	352219
24249	37656	9	applied	\N	\N	\N	\N	185013	185013	352220
24249	37657	10	applied	\N	\N	\N	\N	185014	185014	352221
24249	37658	11	applied	\N	\N	\N	\N	185015	185015	352222
24261	37692	0	applied	\N	\N	\N	\N	185081	185081	352288
24261	37693	1	applied	\N	\N	\N	\N	185082	185082	352289
24261	37694	2	applied	\N	\N	\N	\N	185083	185083	352290
24264	37695	0	applied	\N	\N	1000000000	\N	185090	185090	352297
24264	37668	1	applied	\N	\N	\N	\N	185091	185091	352298
24264	37669	2	applied	\N	\N	\N	\N	185092	185092	352299
24264	37670	3	applied	\N	\N	\N	\N	185093	185093	352300
24264	37671	4	applied	\N	\N	\N	\N	185094	185094	352301
24264	37672	5	applied	\N	\N	\N	\N	185095	185095	352302
24264	37696	6	applied	\N	\N	\N	\N	185096	185096	352303
24271	37713	0	applied	\N	\N	\N	\N	185138	185138	352345
24271	37714	1	applied	\N	\N	\N	\N	185139	185139	352346
24271	37715	2	applied	\N	\N	\N	\N	185140	185140	352347
24271	37716	3	applied	\N	\N	\N	\N	185141	185141	352348
24273	37717	0	applied	\N	\N	\N	\N	185146	185146	352353
24273	37718	1	applied	\N	\N	\N	\N	185147	185147	352354
24273	37720	3	applied	\N	\N	\N	\N	185149	185149	352356
24275	37721	0	applied	\N	\N	\N	\N	185154	185154	352361
24275	37722	1	applied	\N	\N	\N	\N	185155	185155	352362
24275	37723	2	applied	\N	\N	\N	\N	185156	185156	352363
24275	37724	3	applied	\N	\N	\N	\N	185157	185157	352364
24278	37725	0	applied	\N	\N	\N	\N	185166	185166	352373
24278	37726	1	applied	\N	\N	\N	\N	185167	185167	352374
24278	37727	2	applied	\N	\N	\N	\N	185168	185168	352375
24278	37728	3	applied	\N	\N	\N	\N	185169	185169	352376
24287	37732	0	applied	\N	\N	\N	\N	185182	185182	352389
24287	37733	1	applied	\N	\N	\N	\N	185183	185183	352390
24287	37734	2	applied	\N	\N	\N	\N	185184	185184	352391
24289	37735	0	applied	\N	\N	\N	\N	185188	185188	352395
24289	37736	1	applied	\N	\N	\N	\N	185189	185189	352396
24289	37737	2	applied	\N	\N	\N	\N	185190	185190	352397
24289	37738	3	applied	\N	\N	\N	\N	185191	185191	352398
24291	37736	1	applied	\N	\N	\N	\N	185197	185197	352404
24291	37737	2	applied	\N	\N	\N	\N	185198	185198	352405
24291	37738	3	applied	\N	\N	\N	\N	185199	185199	352406
24294	37742	0	applied	\N	\N	\N	\N	185206	185206	352413
24294	37743	1	applied	\N	\N	\N	\N	185207	185207	352414
24294	37744	2	applied	\N	\N	\N	\N	185208	185208	352415
24294	37745	3	applied	\N	\N	\N	\N	185209	185209	352416
24294	37746	4	applied	\N	\N	\N	\N	185210	185210	352417
24294	37747	5	applied	\N	\N	\N	\N	185211	185211	352418
24294	37748	6	applied	\N	\N	\N	\N	185212	185212	352419
24294	37749	7	applied	\N	\N	\N	\N	185213	185213	352420
24294	37750	8	applied	\N	\N	\N	\N	185214	185214	352421
24297	37695	0	applied	\N	\N	1000000000	\N	185227	185227	352434
24297	37721	1	applied	\N	\N	\N	\N	185228	185228	352435
24297	37668	2	applied	\N	\N	\N	\N	185229	185229	352436
24297	37669	3	applied	\N	\N	\N	\N	185230	185230	352437
24297	37671	5	applied	\N	\N	\N	\N	185232	185232	352439
24297	37672	6	applied	\N	\N	\N	\N	185233	185233	352440
24297	37696	7	applied	\N	\N	\N	\N	185234	185234	352441
24302	37762	0	applied	\N	\N	\N	\N	185254	185254	352461
24302	37763	1	applied	\N	\N	\N	\N	185255	185255	352462
24302	37764	2	applied	\N	\N	\N	\N	185256	185256	352463
24314	37787	0	applied	\N	\N	\N	\N	185318	185318	352525
24314	37788	1	applied	\N	\N	\N	\N	185319	185319	352526
24314	37789	2	applied	\N	\N	\N	\N	185320	185320	352527
24314	37790	3	applied	\N	\N	\N	\N	185321	185321	352528
24314	37791	4	applied	\N	\N	\N	\N	185322	185322	352529
24314	37792	5	applied	\N	\N	\N	\N	185323	185323	352530
24314	37793	6	applied	\N	\N	\N	\N	185324	185324	352531
24317	37797	0	applied	\N	\N	\N	\N	185335	185335	352542
24317	37798	1	applied	\N	\N	\N	\N	185336	185336	352543
24317	37799	2	applied	\N	\N	\N	\N	185337	185337	352544
24317	37801	4	applied	\N	\N	\N	\N	185339	185339	352546
24317	37802	5	applied	\N	\N	\N	\N	185340	185340	352547
24317	37803	6	applied	\N	\N	\N	\N	185341	185341	352548
24323	37827	0	applied	\N	\N	\N	\N	185385	185385	352591
24323	37828	1	applied	\N	\N	\N	\N	185386	185386	352592
24323	37830	3	applied	\N	\N	\N	\N	185388	185388	352593
24323	37831	4	applied	\N	\N	\N	\N	185389	185389	352594
24219	37610	2	applied	\N	\N	\N	\N	184883	184883	352090
24219	37611	3	applied	\N	\N	\N	\N	184884	184884	352091
24243	37638	1	applied	\N	\N	\N	\N	184973	184973	352180
24243	37639	2	applied	\N	\N	\N	\N	184974	184974	352181
24247	37644	0	applied	\N	\N	\N	\N	184988	184988	352195
24247	37645	1	applied	\N	\N	\N	\N	184989	184989	352196
24247	37646	2	applied	\N	\N	\N	\N	184990	184990	352197
24250	37660	0	applied	\N	\N	\N	\N	185017	185017	352224
24250	37661	1	applied	\N	\N	\N	\N	185018	185018	352225
24250	37663	3	applied	\N	\N	\N	\N	185020	185020	352227
24250	37664	4	applied	\N	\N	\N	\N	185021	185021	352228
24250	37665	5	applied	\N	\N	\N	\N	185022	185022	352229
24250	37666	6	applied	\N	\N	\N	\N	185023	185023	352230
24253	37667	0	applied	\N	\N	\N	\N	185039	185039	352246
24253	37668	1	applied	\N	\N	\N	\N	185040	185040	352247
24253	37669	2	applied	\N	\N	\N	\N	185041	185041	352248
24253	37670	3	applied	\N	\N	\N	\N	185042	185042	352249
24253	37671	4	applied	\N	\N	\N	\N	185043	185043	352250
24253	37672	5	applied	\N	\N	\N	\N	185044	185044	352251
24253	37673	6	applied	\N	\N	\N	\N	185045	185045	352252
24253	37674	7	applied	\N	\N	\N	\N	185046	185046	352253
24258	37675	0	applied	\N	\N	\N	\N	185060	185060	352267
24258	37676	1	applied	\N	\N	\N	\N	185061	185061	352268
24258	37677	2	applied	\N	\N	\N	\N	185062	185062	352269
24258	37678	3	applied	\N	\N	\N	\N	185063	185063	352270
24258	37680	5	applied	\N	\N	\N	\N	185065	185065	352272
24258	37681	6	applied	\N	\N	\N	\N	185066	185066	352273
24258	37682	7	applied	\N	\N	\N	\N	185067	185067	352274
24258	37683	8	applied	\N	\N	\N	\N	185068	185068	352275
24258	37684	9	applied	\N	\N	\N	\N	185069	185069	352276
24258	37685	10	applied	\N	\N	\N	\N	185070	185070	352277
24258	37686	11	applied	\N	\N	\N	\N	185071	185071	352278
24258	37687	12	applied	\N	\N	\N	\N	185072	185072	352279
24260	37688	0	applied	\N	\N	\N	\N	185077	185077	352284
24260	37689	1	applied	\N	\N	\N	\N	185078	185078	352285
24260	37690	2	applied	\N	\N	\N	\N	185079	185079	352286
24260	37691	3	applied	\N	\N	\N	\N	185080	185080	352287
24263	37692	0	applied	\N	\N	\N	\N	185087	185087	352294
24263	37693	1	applied	\N	\N	\N	\N	185088	185088	352295
24263	37694	2	applied	\N	\N	\N	\N	185089	185089	352296
24265	37697	1	applied	\N	\N	\N	\N	185098	185098	352305
24265	37698	2	applied	\N	\N	\N	\N	185099	185099	352306
24265	37699	3	applied	\N	\N	\N	\N	185100	185100	352307
24265	37700	4	applied	\N	\N	\N	\N	185101	185101	352308
24265	37696	5	applied	\N	\N	\N	\N	185102	185102	352309
24265	37701	6	applied	\N	\N	\N	\N	185103	185103	352310
24265	37702	7	applied	\N	\N	\N	\N	185104	185104	352311
24265	37703	8	applied	\N	\N	\N	\N	185105	185105	352312
24265	37704	9	applied	\N	\N	\N	\N	185106	185106	352313
24265	37705	10	applied	\N	\N	\N	\N	185107	185107	352314
24265	37706	11	applied	\N	\N	\N	\N	185108	185108	352315
24265	37707	12	applied	\N	\N	\N	\N	185109	185109	352316
24265	37708	13	applied	\N	\N	\N	\N	185110	185110	352317
24265	37709	14	applied	\N	\N	\N	\N	185111	185111	352318
24267	37710	0	applied	\N	\N	\N	\N	185127	185127	352334
24267	37711	1	applied	\N	\N	\N	\N	185128	185128	352335
24267	37712	2	applied	\N	\N	\N	\N	185129	185129	352336
24270	37713	0	applied	\N	\N	\N	\N	185134	185134	352341
24270	37714	1	applied	\N	\N	\N	\N	185135	185135	352342
24270	37716	3	applied	\N	\N	\N	\N	185137	185137	352344
24274	37721	0	applied	\N	\N	\N	\N	185150	185150	352357
24274	37722	1	applied	\N	\N	\N	\N	185151	185151	352358
24274	37723	2	applied	\N	\N	\N	\N	185152	185152	352359
24274	37724	3	applied	\N	\N	\N	\N	185153	185153	352360
24276	37725	0	applied	\N	\N	\N	\N	185158	185158	352365
24276	37726	1	applied	\N	\N	\N	\N	185159	185159	352366
24276	37727	2	applied	\N	\N	\N	\N	185160	185160	352367
24276	37728	3	applied	\N	\N	\N	\N	185161	185161	352368
24279	37725	0	applied	\N	\N	\N	\N	185170	185170	352377
24279	37728	1	applied	\N	\N	\N	\N	185171	185171	352378
24292	37739	0	applied	\N	\N	\N	\N	185200	185200	352407
24292	37740	1	applied	\N	\N	\N	\N	185201	185201	352408
24292	37741	2	applied	\N	\N	\N	\N	185202	185202	352409
24294	37751	9	applied	\N	\N	\N	\N	185215	185215	352422
24296	37742	0	applied	\N	\N	\N	\N	185217	185217	352424
24296	37744	2	applied	\N	\N	\N	\N	185219	185219	352426
24296	37745	3	applied	\N	\N	\N	\N	185220	185220	352427
24296	37746	4	applied	\N	\N	\N	\N	185221	185221	352428
24296	37747	5	applied	\N	\N	\N	\N	185222	185222	352429
24296	37748	6	applied	\N	\N	\N	\N	185223	185223	352430
24296	37749	7	applied	\N	\N	\N	\N	185224	185224	352431
24296	37750	8	applied	\N	\N	\N	\N	185225	185225	352432
24296	37751	9	applied	\N	\N	\N	\N	185226	185226	352433
24298	37752	0	applied	\N	\N	\N	\N	185235	185235	352442
24301	37762	0	applied	\N	\N	\N	\N	185251	185251	352458
24301	37763	1	applied	\N	\N	\N	\N	185252	185252	352459
24301	37764	2	applied	\N	\N	\N	\N	185253	185253	352460
24306	37765	0	applied	\N	\N	\N	\N	185270	185270	352477
24306	37766	1	applied	\N	\N	\N	\N	185271	185271	352478
24306	37767	2	applied	\N	\N	\N	\N	185272	185272	352479
24306	37768	4	applied	\N	\N	\N	\N	185273	185273	352480
24306	37770	6	applied	\N	\N	\N	\N	185275	185275	352482
24306	37771	7	applied	\N	\N	\N	\N	185276	185276	352483
24311	37775	0	applied	\N	\N	\N	\N	185297	185297	352504
24311	37776	1	applied	\N	\N	\N	\N	185298	185298	352505
24311	37777	2	applied	\N	\N	\N	\N	185299	185299	352506
24313	37778	0	applied	\N	\N	\N	\N	185309	185309	352516
24313	37779	1	applied	\N	\N	\N	\N	185310	185310	352517
24313	37780	2	applied	\N	\N	\N	\N	185311	185311	352518
24313	37781	3	applied	\N	\N	\N	\N	185312	185312	352519
24313	37782	4	applied	\N	\N	\N	\N	185313	185313	352520
24313	37783	5	applied	\N	\N	\N	\N	185314	185314	352521
24313	37784	6	applied	\N	\N	\N	\N	185315	185315	352522
24313	37785	7	applied	\N	\N	\N	\N	185316	185316	352523
24313	37786	8	applied	\N	\N	\N	\N	185317	185317	352524
24316	37794	0	applied	\N	\N	\N	\N	185332	185332	352539
24316	37795	1	applied	\N	\N	\N	\N	185333	185333	352540
24324	37827	0	applied	\N	\N	\N	\N	185392	185392	352597
24324	37828	1	applied	\N	\N	\N	\N	185393	185393	352598
24324	37830	3	applied	\N	\N	\N	\N	185395	185395	352599
24324	37829	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	185394	185394	\N
24240	37639	2	applied	\N	\N	\N	\N	184965	184965	352172
24243	37637	0	applied	\N	\N	\N	\N	184972	184972	352179
24277	37727	2	applied	\N	\N	\N	\N	185164	185164	352371
24277	37728	3	applied	\N	\N	\N	\N	185165	185165	352372
24280	37725	0	applied	\N	\N	\N	\N	185172	185172	352379
24280	37726	1	applied	\N	\N	\N	\N	185173	185173	352380
24280	37727	2	applied	\N	\N	\N	\N	185174	185174	352381
24280	37728	3	applied	\N	\N	\N	\N	185175	185175	352382
24282	37729	0	applied	\N	\N	\N	\N	185176	185176	352383
24282	37730	1	applied	\N	\N	\N	\N	185177	185177	352384
24282	37731	2	applied	\N	\N	\N	\N	185178	185178	352385
24293	37740	1	applied	\N	\N	\N	\N	185204	185204	352411
24293	37741	2	applied	\N	\N	\N	\N	185205	185205	352412
24298	37753	1	applied	\N	\N	\N	\N	185236	185236	352443
24298	37754	2	applied	\N	\N	\N	\N	185237	185237	352444
24298	37755	3	applied	\N	\N	\N	\N	185238	185238	352445
24298	37756	4	applied	\N	\N	\N	\N	185239	185239	352446
24298	37757	5	applied	\N	\N	\N	\N	185240	185240	352447
24299	37752	0	applied	\N	\N	\N	\N	185241	185241	352448
24299	37753	1	applied	\N	\N	\N	\N	185242	185242	352449
24299	37754	2	applied	\N	\N	\N	\N	185243	185243	352450
24299	37755	3	applied	\N	\N	\N	\N	185244	185244	352451
24299	37756	4	applied	\N	\N	\N	\N	185245	185245	352452
24299	37757	5	applied	\N	\N	\N	\N	185246	185246	352453
24300	37758	0	applied	\N	\N	\N	\N	185247	185247	352454
24300	37759	1	applied	\N	\N	\N	\N	185248	185248	352455
24300	37760	2	applied	\N	\N	\N	\N	185249	185249	352456
24303	37762	0	applied	\N	\N	\N	\N	185257	185257	352464
24303	37763	1	applied	\N	\N	\N	\N	185258	185258	352465
24303	37764	2	applied	\N	\N	\N	\N	185259	185259	352466
24304	37762	0	applied	\N	\N	\N	\N	185260	185260	352467
24304	37763	1	applied	\N	\N	\N	\N	185261	185261	352468
24304	37764	2	applied	\N	\N	\N	\N	185262	185262	352469
24305	37765	0	applied	\N	\N	\N	\N	185263	185263	352470
24305	37766	1	applied	\N	\N	\N	\N	185264	185264	352471
24305	37767	2	applied	\N	\N	\N	\N	185265	185265	352472
24305	37768	4	applied	\N	\N	\N	\N	185266	185266	352473
24305	37769	5	applied	\N	\N	\N	\N	185267	185267	352474
24305	37770	6	applied	\N	\N	\N	\N	185268	185268	352475
24305	37771	7	applied	\N	\N	\N	\N	185269	185269	352476
24307	37765	0	applied	\N	\N	\N	\N	185277	185277	352484
24307	37766	1	applied	\N	\N	\N	\N	185278	185278	352485
24307	37767	2	applied	\N	\N	\N	\N	185279	185279	352486
24307	37769	5	applied	\N	\N	\N	\N	185281	185281	352488
24307	37770	6	applied	\N	\N	\N	\N	185282	185282	352489
24307	37771	7	applied	\N	\N	\N	\N	185283	185283	352490
24308	37765	0	applied	\N	\N	\N	\N	185284	185284	352491
24308	37766	1	applied	\N	\N	\N	\N	185285	185285	352492
24308	37767	2	applied	\N	\N	\N	\N	185286	185286	352493
24308	37768	4	applied	\N	\N	\N	\N	185287	185287	352494
24308	37769	5	applied	\N	\N	\N	\N	185288	185288	352495
24308	37770	6	applied	\N	\N	\N	\N	185289	185289	352496
24308	37771	7	applied	\N	\N	\N	\N	185290	185290	352497
24309	37772	0	applied	\N	\N	\N	\N	185291	185291	352498
24309	37773	1	applied	\N	\N	\N	\N	185292	185292	352499
24309	37774	2	applied	\N	\N	\N	\N	185293	185293	352500
24310	37775	0	applied	\N	\N	\N	\N	185294	185294	352501
24310	37776	1	applied	\N	\N	\N	\N	185295	185295	352502
24310	37777	2	applied	\N	\N	\N	\N	185296	185296	352503
24312	37779	1	applied	\N	\N	\N	\N	185301	185301	352508
24312	37780	2	applied	\N	\N	\N	\N	185302	185302	352509
24312	37781	3	applied	\N	\N	\N	\N	185303	185303	352510
24312	37782	4	applied	\N	\N	\N	\N	185304	185304	352511
24312	37783	5	applied	\N	\N	\N	\N	185305	185305	352512
24312	37784	6	applied	\N	\N	\N	\N	185306	185306	352513
24312	37785	7	applied	\N	\N	\N	\N	185307	185307	352514
24312	37786	8	applied	\N	\N	\N	\N	185308	185308	352515
24315	37787	0	applied	\N	\N	\N	\N	185325	185325	352532
24315	37788	1	applied	\N	\N	\N	\N	185326	185326	352533
24315	37789	2	applied	\N	\N	\N	\N	185327	185327	352534
24315	37790	3	applied	\N	\N	\N	\N	185328	185328	352535
24320	37810	0	applied	\N	\N	\N	\N	185361	185361	352568
24320	37811	1	applied	\N	\N	\N	\N	185362	185362	352569
24320	37812	2	applied	\N	\N	\N	\N	185363	185363	352570
24320	37813	3	applied	\N	\N	\N	\N	185364	185364	352571
24320	37815	5	applied	\N	\N	\N	\N	185366	185366	352573
24320	37816	6	applied	\N	\N	\N	\N	185367	185367	352574
24320	37817	7	applied	\N	\N	\N	\N	185368	185368	352575
24320	37818	8	applied	\N	\N	\N	\N	185369	185369	352576
24320	37819	9	applied	\N	\N	\N	\N	185370	185370	352577
24320	37820	10	applied	\N	\N	\N	\N	185371	185371	352578
24320	37821	11	applied	\N	\N	\N	\N	185372	185372	352579
24320	37822	12	applied	\N	\N	\N	\N	185373	185373	352580
24322	37827	0	applied	\N	\N	\N	\N	185378	185378	352585
24322	37828	1	applied	\N	\N	\N	\N	185379	185379	352586
24322	37830	3	applied	\N	\N	\N	\N	185381	185381	352587
24322	37831	4	applied	\N	\N	\N	\N	185382	185382	352588
24322	37832	5	applied	\N	\N	\N	\N	185383	185383	352589
24322	37833	6	applied	\N	\N	\N	\N	185384	185384	352590
24325	37834	0	applied	\N	\N	\N	\N	185397	185397	352601
24325	37835	1	applied	\N	\N	\N	\N	185398	185398	352602
24325	37836	2	applied	\N	\N	\N	\N	185399	185399	352603
24325	37837	3	applied	\N	\N	\N	\N	185400	185400	352604
24325	37838	4	applied	\N	\N	\N	\N	185401	185401	352605
24325	37839	5	applied	\N	\N	\N	\N	185402	185402	352606
24325	37840	6	applied	\N	\N	\N	\N	185403	185403	352607
24328	37841	0	applied	\N	\N	\N	\N	185410	185410	352614
24328	37842	1	applied	\N	\N	\N	\N	185411	185411	352615
24328	37843	2	applied	\N	\N	\N	\N	185412	185412	352616
24333	37848	0	applied	\N	\N	\N	\N	185442	185442	352646
24333	37849	1	applied	\N	\N	\N	\N	185443	185443	352647
24333	37850	2	applied	\N	\N	\N	\N	185444	185444	352648
24333	37851	3	applied	\N	\N	\N	\N	185445	185445	352649
24333	37852	4	applied	\N	\N	\N	\N	185446	185446	352650
24333	37853	5	applied	\N	\N	\N	\N	185447	185447	352651
24333	37854	6	applied	\N	\N	\N	\N	185448	185448	352652
24333	37855	7	applied	\N	\N	\N	\N	185449	185449	352653
24333	37856	8	applied	\N	\N	\N	\N	185450	185450	352654
24333	37857	9	applied	\N	\N	\N	\N	185451	185451	352655
24333	37858	10	applied	\N	\N	\N	\N	185452	185452	352656
24341	37867	0	applied	\N	\N	\N	\N	185489	185489	352693
24341	37868	1	applied	\N	\N	\N	\N	185490	185490	352694
24277	37725	0	applied	\N	\N	\N	\N	185162	185162	352369
24277	37726	1	applied	\N	\N	\N	\N	185163	185163	352370
24318	37805	1	applied	\N	\N	\N	\N	185343	185343	352550
24318	37806	2	applied	\N	\N	\N	\N	185344	185344	352551
24318	37807	3	applied	\N	\N	\N	\N	185345	185345	352552
24318	37808	4	applied	\N	\N	\N	\N	185346	185346	352553
24318	37809	5	applied	\N	\N	\N	\N	185347	185347	352554
24319	37810	0	applied	\N	\N	\N	\N	185348	185348	352555
24319	37811	1	applied	\N	\N	\N	\N	185349	185349	352556
24319	37812	2	applied	\N	\N	\N	\N	185350	185350	352557
24319	37813	3	applied	\N	\N	\N	\N	185351	185351	352558
24319	37814	4	applied	\N	\N	\N	\N	185352	185352	352559
24319	37815	5	applied	\N	\N	\N	\N	185353	185353	352560
24319	37816	6	applied	\N	\N	\N	\N	185354	185354	352561
24319	37817	7	applied	\N	\N	\N	\N	185355	185355	352562
24319	37818	8	applied	\N	\N	\N	\N	185356	185356	352563
24319	37819	9	applied	\N	\N	\N	\N	185357	185357	352564
24319	37820	10	applied	\N	\N	\N	\N	185358	185358	352565
24319	37822	12	applied	\N	\N	\N	\N	185360	185360	352567
24321	37823	0	applied	\N	\N	\N	\N	185374	185374	352581
24321	37824	1	applied	\N	\N	\N	\N	185375	185375	352582
24321	37825	2	applied	\N	\N	\N	\N	185376	185376	352583
24321	37826	3	applied	\N	\N	\N	\N	185377	185377	352584
24327	37841	0	applied	\N	\N	\N	\N	185407	185407	352611
24327	37842	1	applied	\N	\N	\N	\N	185408	185408	352612
24327	37843	2	applied	\N	\N	\N	\N	185409	185409	352613
24332	37848	0	applied	\N	\N	\N	\N	185431	185431	352635
24332	37849	1	applied	\N	\N	\N	\N	185432	185432	352636
24332	37850	2	applied	\N	\N	\N	\N	185433	185433	352637
24332	37851	3	applied	\N	\N	\N	\N	185434	185434	352638
24332	37852	4	applied	\N	\N	\N	\N	185435	185435	352639
24332	37853	5	applied	\N	\N	\N	\N	185436	185436	352640
24332	37854	6	applied	\N	\N	\N	\N	185437	185437	352641
24332	37855	7	applied	\N	\N	\N	\N	185438	185438	352642
24332	37857	9	applied	\N	\N	\N	\N	185440	185440	352644
24332	37858	10	applied	\N	\N	\N	\N	185441	185441	352645
24335	37848	0	applied	\N	\N	\N	\N	185464	185464	352668
24335	37849	1	applied	\N	\N	\N	\N	185465	185465	352669
24335	37850	2	applied	\N	\N	\N	\N	185466	185466	352670
24335	37851	3	applied	\N	\N	\N	\N	185467	185467	352671
24335	37852	4	applied	\N	\N	\N	\N	185468	185468	352672
24335	37853	5	applied	\N	\N	\N	\N	185469	185469	352673
24335	37854	6	applied	\N	\N	\N	\N	185470	185470	352674
24335	37855	7	applied	\N	\N	\N	\N	185471	185471	352675
24335	37856	8	applied	\N	\N	\N	\N	185472	185472	352676
24335	37857	9	applied	\N	\N	\N	\N	185473	185473	352677
24335	37858	10	applied	\N	\N	\N	\N	185474	185474	352678
24336	37859	0	applied	\N	\N	\N	\N	185475	185475	352679
24336	37860	1	applied	\N	\N	\N	\N	185476	185476	352680
24336	37861	2	applied	\N	\N	\N	\N	185477	185477	352681
24338	37863	2	applied	\N	\N	\N	\N	185482	185482	352686
24338	37864	3	applied	\N	\N	\N	\N	185483	185483	352687
24341	37869	2	applied	\N	\N	\N	\N	185491	185491	352695
24343	37870	0	applied	\N	\N	\N	\N	185495	185495	352699
24343	37871	1	applied	\N	\N	\N	\N	185496	185496	352700
24343	37872	2	applied	\N	\N	\N	\N	185497	185497	352701
24346	37876	0	applied	\N	\N	\N	\N	185504	185504	352708
24346	37877	1	applied	\N	\N	\N	\N	185505	185505	352709
24346	37878	2	applied	\N	\N	\N	\N	185506	185506	352710
24346	37879	3	applied	\N	\N	\N	\N	185507	185507	352711
24346	37880	4	applied	\N	\N	\N	\N	185508	185508	352712
24346	37881	5	applied	\N	\N	\N	\N	185509	185509	352713
24346	37882	6	applied	\N	\N	\N	\N	185510	185510	352714
24349	37886	0	applied	\N	\N	\N	\N	185517	185517	352721
24349	37887	1	applied	\N	\N	\N	\N	185518	185518	352722
24349	37888	2	applied	\N	\N	\N	\N	185519	185519	352723
24349	37890	4	applied	\N	\N	\N	\N	185521	185521	352725
24349	37891	5	applied	\N	\N	\N	\N	185522	185522	352726
24351	37892	0	applied	\N	\N	\N	\N	185529	185529	352733
24351	37893	1	applied	\N	\N	\N	\N	185530	185530	352734
24353	37892	0	applied	\N	\N	\N	\N	185533	185533	352737
24353	37893	1	applied	\N	\N	\N	\N	185534	185534	352738
24355	37894	0	applied	\N	\N	\N	\N	185537	185537	352741
24355	37895	1	applied	\N	\N	\N	\N	185538	185538	352742
24358	37899	0	applied	\N	\N	\N	\N	185545	185545	352749
24358	37900	1	applied	\N	\N	\N	\N	185546	185546	352750
24360	37899	0	applied	\N	\N	\N	\N	185549	185549	352753
24360	37900	1	applied	\N	\N	\N	\N	185550	185550	352754
24362	37901	0	applied	\N	\N	\N	\N	185553	185553	352757
24362	37902	1	applied	\N	\N	\N	\N	185554	185554	352758
24365	37906	0	applied	\N	\N	\N	\N	185561	185561	352765
24365	37907	1	applied	\N	\N	\N	\N	185562	185562	352766
24365	37909	3	applied	\N	\N	\N	\N	185564	185564	352768
24365	37910	4	applied	\N	\N	\N	\N	185565	185565	352769
24367	37917	0	applied	\N	\N	\N	\N	185572	185572	352776
24367	37918	1	applied	\N	\N	\N	\N	185573	185573	352777
24368	37917	0	applied	\N	\N	\N	\N	185574	185574	352778
24368	37918	1	applied	\N	\N	\N	\N	185575	185575	352779
24375	37932	0	applied	\N	\N	\N	\N	185597	185597	352801
24375	37933	1	applied	\N	\N	\N	\N	185598	185598	352802
24375	37934	2	applied	\N	\N	\N	\N	185599	185599	352803
24377	37932	0	applied	\N	\N	\N	\N	185603	185603	352807
24377	37933	1	applied	\N	\N	\N	\N	185604	185604	352808
24377	37934	2	applied	\N	\N	\N	\N	185605	185605	352809
24378	37906	0	applied	\N	\N	\N	\N	185606	185606	352810
24380	37935	0	applied	\N	\N	\N	\N	185637	185637	352841
24382	37939	0	applied	\N	\N	\N	\N	185641	185641	352845
24382	37940	1	applied	\N	\N	\N	\N	185642	185642	352846
24382	37942	3	applied	\N	\N	\N	\N	185644	185644	352848
24385	37943	0	applied	\N	\N	\N	\N	185652	185652	352856
24385	37944	1	applied	\N	\N	\N	\N	185653	185653	352857
24385	37945	2	applied	\N	\N	\N	\N	185654	185654	352858
24385	37946	3	applied	\N	\N	\N	\N	185655	185655	352859
24385	37947	4	applied	\N	\N	\N	\N	185656	185656	352860
24385	37948	5	applied	\N	\N	\N	\N	185657	185657	352861
24385	37949	6	applied	\N	\N	\N	\N	185658	185658	352862
24387	37950	0	applied	\N	\N	\N	\N	185666	185666	352870
24387	37951	1	applied	\N	\N	\N	\N	185667	185667	352871
24392	37950	0	applied	\N	\N	\N	\N	185677	185677	352881
24392	37952	1	applied	\N	\N	\N	\N	185678	185678	352882
24392	37954	2	applied	\N	\N	\N	\N	185679	185679	352883
24392	37951	3	applied	\N	\N	\N	\N	185680	185680	352884
24315	37792	5	applied	\N	\N	\N	\N	185330	185330	352537
24315	37793	6	applied	\N	\N	\N	\N	185331	185331	352538
24329	37843	2	applied	\N	\N	\N	\N	185415	185415	352619
24330	37844	0	applied	\N	\N	\N	\N	185416	185416	352620
24330	37845	1	applied	\N	\N	\N	\N	185417	185417	352621
24330	37846	2	applied	\N	\N	\N	\N	185418	185418	352622
24330	37847	3	applied	\N	\N	\N	\N	185419	185419	352623
24334	37848	0	applied	\N	\N	\N	\N	185453	185453	352657
24334	37849	1	applied	\N	\N	\N	\N	185454	185454	352658
24334	37850	2	applied	\N	\N	\N	\N	185455	185455	352659
24334	37851	3	applied	\N	\N	\N	\N	185456	185456	352660
24334	37852	4	applied	\N	\N	\N	\N	185457	185457	352661
24334	37853	5	applied	\N	\N	\N	\N	185458	185458	352662
24334	37854	6	applied	\N	\N	\N	\N	185459	185459	352663
24334	37855	7	applied	\N	\N	\N	\N	185460	185460	352664
24334	37856	8	applied	\N	\N	\N	\N	185461	185461	352665
24334	37857	9	applied	\N	\N	\N	\N	185462	185462	352666
24334	37858	10	applied	\N	\N	\N	\N	185463	185463	352667
24337	37860	1	applied	\N	\N	\N	\N	185479	185479	352683
24337	37861	2	applied	\N	\N	\N	\N	185480	185480	352684
24339	37862	0	applied	\N	\N	\N	\N	185484	185484	352688
24339	37863	2	applied	\N	\N	\N	\N	185485	185485	352689
24339	37864	3	applied	\N	\N	\N	\N	185486	185486	352690
24342	37867	0	applied	\N	\N	\N	\N	185492	185492	352696
24342	37868	1	applied	\N	\N	\N	\N	185493	185493	352697
24342	37869	2	applied	\N	\N	\N	\N	185494	185494	352698
24344	37873	0	applied	\N	\N	\N	\N	185498	185498	352702
24344	37874	1	applied	\N	\N	\N	\N	185499	185499	352703
24344	37875	2	applied	\N	\N	\N	\N	185500	185500	352704
24347	37883	0	applied	\N	\N	\N	\N	185511	185511	352715
24347	37884	1	applied	\N	\N	\N	\N	185512	185512	352716
24347	37885	2	applied	\N	\N	\N	\N	185513	185513	352717
24350	37886	0	applied	\N	\N	\N	\N	185523	185523	352727
24350	37887	1	applied	\N	\N	\N	\N	185524	185524	352728
24350	37889	3	applied	\N	\N	\N	\N	185526	185526	352730
24350	37890	4	applied	\N	\N	\N	\N	185527	185527	352731
24350	37891	5	applied	\N	\N	\N	\N	185528	185528	352732
24352	37892	0	applied	\N	\N	\N	\N	185531	185531	352735
24352	37893	1	applied	\N	\N	\N	\N	185532	185532	352736
24354	37892	0	applied	\N	\N	\N	\N	185535	185535	352739
24354	37893	1	applied	\N	\N	\N	\N	185536	185536	352740
24356	37896	0	applied	\N	\N	\N	\N	185539	185539	352743
24356	37897	1	applied	\N	\N	\N	\N	185540	185540	352744
24356	37898	2	applied	\N	\N	\N	\N	185541	185541	352745
24363	37903	0	applied	\N	\N	\N	\N	185555	185555	352759
24363	37904	1	applied	\N	\N	\N	\N	185556	185556	352760
24363	37905	2	applied	\N	\N	\N	\N	185557	185557	352761
24366	37911	0	applied	\N	\N	\N	\N	185566	185566	352770
24366	37912	1	applied	\N	\N	\N	\N	185567	185567	352771
24366	37913	2	applied	\N	\N	\N	\N	185568	185568	352772
24366	37915	4	applied	\N	\N	\N	\N	185570	185570	352774
24366	37916	5	applied	\N	\N	\N	\N	185571	185571	352775
24369	37919	0	applied	\N	\N	\N	\N	185576	185576	352780
24369	37920	1	applied	\N	\N	\N	\N	185577	185577	352781
24369	37921	2	applied	\N	\N	\N	\N	185578	185578	352782
24369	37922	3	applied	\N	\N	\N	\N	185579	185579	352783
24369	37923	4	applied	\N	\N	\N	\N	185580	185580	352784
24369	37924	5	applied	\N	\N	\N	\N	185581	185581	352785
24369	37925	6	applied	\N	\N	\N	\N	185582	185582	352786
24369	37926	7	applied	\N	\N	\N	\N	185583	185583	352787
24376	37932	0	applied	\N	\N	\N	\N	185600	185600	352804
24376	37933	1	applied	\N	\N	\N	\N	185601	185601	352805
24376	37934	2	applied	\N	\N	\N	\N	185602	185602	352806
24386	37943	0	applied	\N	\N	\N	\N	185659	185659	352863
24386	37944	1	applied	\N	\N	\N	\N	185660	185660	352864
24386	37945	2	applied	\N	\N	\N	\N	185661	185661	352865
24386	37947	4	applied	\N	\N	\N	\N	185663	185663	352867
24386	37948	5	applied	\N	\N	\N	\N	185664	185664	352868
24386	37949	6	applied	\N	\N	\N	\N	185665	185665	352869
24389	37950	0	applied	\N	\N	\N	\N	185670	185670	352874
24389	37951	1	applied	\N	\N	\N	\N	185671	185671	352875
24392	37953	4	applied	\N	\N	\N	\N	185681	185681	352885
24395	37955	0	applied	\N	\N	\N	\N	185687	185687	352891
24395	37956	1	applied	\N	\N	\N	\N	185688	185688	352892
24397	37957	0	applied	\N	\N	\N	\N	185750	185750	352954
24397	37958	1	applied	\N	\N	\N	\N	185751	185751	352955
24399	37959	0	applied	\N	\N	\N	\N	185754	185754	352958
24399	37960	1	applied	\N	\N	\N	\N	185755	185755	352959
24399	37961	2	applied	\N	\N	\N	\N	185756	185756	352960
24400	37959	0	applied	\N	\N	\N	\N	185757	185757	352961
24400	37960	1	applied	\N	\N	\N	\N	185758	185758	352962
24400	37961	2	applied	\N	\N	\N	\N	185759	185759	352963
24402	37966	1	applied	\N	\N	\N	\N	185764	185764	352968
24403	37967	0	applied	\N	\N	\N	\N	185765	185765	352969
24403	37968	1	applied	\N	\N	\N	\N	185766	185766	352970
24403	37969	2	applied	\N	\N	\N	\N	185767	185767	352971
24406	37970	0	applied	\N	\N	\N	\N	185773	185773	352977
24406	37971	1	applied	\N	\N	\N	\N	185774	185774	352978
24408	37978	0	applied	\N	\N	\N	\N	185781	185781	352985
24408	37979	1	applied	\N	\N	\N	\N	185782	185782	352986
24408	37980	2	applied	\N	\N	\N	\N	185783	185783	352987
24409	37981	0	applied	\N	\N	\N	\N	185784	185784	352988
24413	37988	0	applied	\N	\N	\N	\N	185793	185793	352997
24413	37989	1	applied	\N	\N	\N	\N	185794	185794	352998
24414	37990	0	applied	\N	\N	\N	\N	185795	185795	352999
24414	37991	1	applied	\N	\N	\N	\N	185796	185796	353000
24416	37990	0	applied	\N	\N	\N	\N	185799	185799	353003
24416	37991	1	applied	\N	\N	\N	\N	185800	185800	353004
24418	38000	1	applied	\N	\N	\N	\N	185809	185809	353013
24427	38015	0	applied	\N	\N	\N	\N	186009	186009	353212
24427	38016	1	applied	\N	\N	\N	\N	186010	186010	353213
24428	38017	0	applied	\N	\N	\N	\N	186011	186011	353214
24428	38018	1	applied	\N	\N	\N	\N	186012	186012	353215
24428	38019	2	applied	\N	\N	\N	\N	186013	186013	353216
24432	38017	0	applied	\N	\N	\N	\N	186023	186023	353226
24432	38018	1	applied	\N	\N	\N	\N	186024	186024	353227
24432	38019	2	applied	\N	\N	\N	\N	186025	186025	353228
24437	38022	0	applied	\N	\N	\N	\N	186035	186035	353238
24437	38023	1	applied	\N	\N	\N	\N	186036	186036	353239
24437	38024	2	applied	\N	\N	\N	\N	186037	186037	353240
24437	38025	3	applied	\N	\N	\N	\N	186038	186038	353241
24437	38026	4	applied	\N	\N	\N	\N	186039	186039	353242
24323	37833	6	applied	\N	\N	\N	\N	185391	185391	352596
24329	37841	0	applied	\N	\N	\N	\N	185413	185413	352617
24331	37848	0	applied	\N	\N	\N	\N	185420	185420	352624
24331	37849	1	applied	\N	\N	\N	\N	185421	185421	352625
24331	37850	2	applied	\N	\N	\N	\N	185422	185422	352626
24331	37851	3	applied	\N	\N	\N	\N	185423	185423	352627
24331	37852	4	applied	\N	\N	\N	\N	185424	185424	352628
24331	37853	5	applied	\N	\N	\N	\N	185425	185425	352629
24331	37854	6	applied	\N	\N	\N	\N	185426	185426	352630
24331	37855	7	applied	\N	\N	\N	\N	185427	185427	352631
24331	37856	8	applied	\N	\N	\N	\N	185428	185428	352632
24331	37857	9	applied	\N	\N	\N	\N	185429	185429	352633
24331	37858	10	applied	\N	\N	\N	\N	185430	185430	352634
24340	37865	0	applied	\N	\N	\N	\N	185487	185487	352691
24340	37866	1	applied	\N	\N	\N	\N	185488	185488	352692
24345	37873	0	applied	\N	\N	\N	\N	185501	185501	352705
24345	37874	1	applied	\N	\N	\N	\N	185502	185502	352706
24345	37875	2	applied	\N	\N	\N	\N	185503	185503	352707
24348	37884	1	applied	\N	\N	\N	\N	185515	185515	352719
24348	37885	2	applied	\N	\N	\N	\N	185516	185516	352720
24357	37896	0	applied	\N	\N	\N	\N	185542	185542	352746
24357	37897	1	applied	\N	\N	\N	\N	185543	185543	352747
24357	37898	2	applied	\N	\N	\N	\N	185544	185544	352748
24359	37899	0	applied	\N	\N	\N	\N	185547	185547	352751
24359	37900	1	applied	\N	\N	\N	\N	185548	185548	352752
24361	37901	0	applied	\N	\N	\N	\N	185551	185551	352755
24361	37902	1	applied	\N	\N	\N	\N	185552	185552	352756
24364	37903	0	applied	\N	\N	\N	\N	185558	185558	352762
24364	37904	1	applied	\N	\N	\N	\N	185559	185559	352763
24364	37905	2	applied	\N	\N	\N	\N	185560	185560	352764
24370	37919	0	applied	\N	\N	\N	\N	185584	185584	352788
24370	37920	1	applied	\N	\N	\N	\N	185585	185585	352789
24370	37921	2	applied	\N	\N	\N	\N	185586	185586	352790
24370	37922	3	applied	\N	\N	\N	\N	185587	185587	352791
24370	37924	5	applied	\N	\N	\N	\N	185589	185589	352793
24370	37925	6	applied	\N	\N	\N	\N	185590	185590	352794
24370	37926	7	applied	\N	\N	\N	\N	185591	185591	352795
24372	37927	0	applied	\N	\N	\N	\N	185592	185592	352796
24372	37928	1	applied	\N	\N	\N	\N	185593	185593	352797
24374	37929	0	applied	\N	\N	\N	\N	185594	185594	352798
24374	37930	1	applied	\N	\N	\N	\N	185595	185595	352799
24374	37931	2	applied	\N	\N	\N	\N	185596	185596	352800
24379	37935	0	applied	\N	\N	\N	\N	185636	185636	352840
24381	37936	0	applied	\N	\N	\N	\N	185638	185638	352842
24381	37937	1	applied	\N	\N	\N	\N	185639	185639	352843
24381	37938	2	applied	\N	\N	\N	\N	185640	185640	352844
24390	37950	0	applied	\N	\N	\N	\N	185672	185672	352876
24390	37951	1	applied	\N	\N	\N	\N	185673	185673	352877
24391	37952	0	applied	\N	\N	\N	\N	185674	185674	352878
24391	37953	1	applied	\N	\N	\N	\N	185675	185675	352879
24393	37952	0	applied	\N	\N	\N	\N	185682	185682	352886
24393	37953	1	applied	\N	\N	\N	\N	185683	185683	352887
24393	37954	2	applied	\N	\N	\N	\N	185684	185684	352888
24396	37906	0	applied	\N	\N	\N	\N	185689	185689	352893
24396	37911	1	applied	\N	\N	\N	\N	185690	185690	352894
24396	37919	2	applied	\N	\N	\N	\N	185691	185691	352895
24396	37932	3	applied	\N	\N	\N	\N	185692	185692	352896
24396	37896	4	applied	\N	\N	\N	\N	185693	185693	352897
24396	37899	5	applied	\N	\N	\N	\N	185694	185694	352898
24396	37901	6	applied	\N	\N	\N	\N	185695	185695	352899
24396	37903	7	applied	\N	\N	\N	\N	185696	185696	352900
24396	37907	8	applied	\N	\N	\N	\N	185697	185697	352901
24396	37908	9	applied	\N	\N	\N	\N	185698	185698	352902
24396	37912	10	applied	\N	\N	\N	\N	185699	185699	352903
24396	37913	11	applied	\N	\N	\N	\N	185700	185700	352904
24396	37917	12	applied	\N	\N	\N	\N	185701	185701	352905
24396	37921	14	applied	\N	\N	\N	\N	185703	185703	352907
24396	37922	15	applied	\N	\N	\N	\N	185704	185704	352908
24396	37927	16	applied	\N	\N	\N	\N	185705	185705	352909
24396	37929	17	applied	\N	\N	\N	\N	185706	185706	352910
24396	37933	18	applied	\N	\N	\N	\N	185707	185707	352911
24396	37935	19	applied	\N	\N	\N	\N	185708	185708	352912
24396	37936	20	applied	\N	\N	\N	\N	185709	185709	352913
24396	37939	21	applied	\N	\N	\N	\N	185710	185710	352914
24396	37940	22	applied	\N	\N	\N	\N	185711	185711	352915
24396	37943	23	applied	\N	\N	\N	\N	185712	185712	352916
24396	37944	24	applied	\N	\N	\N	\N	185713	185713	352917
24396	37945	25	applied	\N	\N	\N	\N	185714	185714	352918
24396	37950	26	applied	\N	\N	\N	\N	185715	185715	352919
24396	37952	27	applied	\N	\N	\N	\N	185716	185716	352920
24396	37955	28	applied	\N	\N	\N	\N	185717	185717	352921
24396	37897	29	applied	\N	\N	\N	\N	185718	185718	352922
24417	37992	0	applied	\N	\N	\N	\N	185801	185801	353005
24417	37993	1	applied	\N	\N	\N	\N	185802	185802	353006
24417	37994	2	applied	\N	\N	\N	\N	185803	185803	353007
24417	37995	3	applied	\N	\N	\N	\N	185804	185804	353008
24417	37996	4	applied	\N	\N	\N	\N	185805	185805	353009
24417	37997	5	applied	\N	\N	\N	\N	185806	185806	353010
24417	37998	6	applied	\N	\N	\N	\N	185807	185807	353011
24422	38001	0	applied	\N	\N	\N	\N	185984	185984	353187
24422	38004	1	applied	\N	\N	\N	\N	185985	185985	353188
24422	38005	2	applied	\N	\N	\N	\N	185986	185986	353189
24422	38003	3	applied	\N	\N	\N	\N	185987	185987	353190
24422	38002	4	applied	\N	\N	\N	\N	185988	185988	353191
24422	38006	5	applied	\N	\N	\N	\N	185989	185989	353192
24422	38007	6	applied	\N	\N	\N	\N	185990	185990	353193
24425	38015	0	applied	\N	\N	\N	\N	186005	186005	353208
24425	38016	1	applied	\N	\N	\N	\N	186006	186006	353209
24430	38018	1	applied	\N	\N	\N	\N	186018	186018	353221
24430	38019	2	applied	\N	\N	\N	\N	186019	186019	353222
24436	38022	0	applied	\N	\N	\N	\N	186028	186028	353231
24436	38023	1	applied	\N	\N	\N	\N	186029	186029	353232
24436	38024	2	applied	\N	\N	\N	\N	186030	186030	353233
24436	38025	3	applied	\N	\N	\N	\N	186031	186031	353234
24436	38026	4	applied	\N	\N	\N	\N	186032	186032	353235
24436	38027	5	applied	\N	\N	\N	\N	186033	186033	353236
24436	38028	6	applied	\N	\N	\N	\N	186034	186034	353237
24441	38037	0	applied	\N	\N	\N	\N	186050	186050	353253
24441	38038	1	applied	\N	\N	\N	\N	186051	186051	353254
24443	38035	0	applied	\N	\N	\N	\N	186060	186060	353263
24443	38037	1	applied	\N	\N	\N	\N	186061	186061	353264
24443	38036	2	applied	\N	\N	\N	\N	186062	186062	353265
24326	37841	0	applied	\N	\N	\N	\N	185404	185404	352608
24326	37842	1	applied	\N	\N	\N	\N	185405	185405	352609
24378	37908	5	applied	\N	\N	\N	\N	185611	185611	352815
24378	37912	6	applied	\N	\N	\N	\N	185612	185612	352816
24378	37913	7	applied	\N	\N	\N	\N	185613	185613	352817
24378	37917	8	applied	\N	\N	\N	\N	185614	185614	352818
24378	37920	9	applied	\N	\N	\N	\N	185615	185615	352819
24378	37921	10	applied	\N	\N	\N	\N	185616	185616	352820
24378	37922	11	applied	\N	\N	\N	\N	185617	185617	352821
24378	37927	12	applied	\N	\N	\N	\N	185618	185618	352822
24378	37929	13	applied	\N	\N	\N	\N	185619	185619	352823
24378	37933	14	applied	\N	\N	\N	\N	185620	185620	352824
24378	37904	15	applied	\N	\N	\N	\N	185621	185621	352825
24378	37905	16	applied	\N	\N	\N	\N	185622	185622	352826
24378	37909	17	applied	\N	\N	\N	\N	185623	185623	352827
24378	37910	18	applied	\N	\N	\N	\N	185624	185624	352828
24378	37914	19	applied	\N	\N	\N	\N	185625	185625	352829
24378	37915	20	applied	\N	\N	\N	\N	185626	185626	352830
24378	37923	22	applied	\N	\N	\N	\N	185628	185628	352832
24378	37924	23	applied	\N	\N	\N	\N	185629	185629	352833
24378	37916	24	applied	\N	\N	\N	\N	185630	185630	352834
24378	37925	25	applied	\N	\N	\N	\N	185631	185631	352835
24378	37928	26	applied	\N	\N	\N	\N	185632	185632	352836
24378	37930	27	applied	\N	\N	\N	\N	185633	185633	352837
24378	37926	28	applied	\N	\N	\N	\N	185634	185634	352838
24378	37931	29	applied	\N	\N	\N	\N	185635	185635	352839
24384	37943	0	applied	\N	\N	\N	\N	185645	185645	352849
24384	37944	1	applied	\N	\N	\N	\N	185646	185646	352850
24384	37945	2	applied	\N	\N	\N	\N	185647	185647	352851
24384	37946	3	applied	\N	\N	\N	\N	185648	185648	352852
24384	37947	4	applied	\N	\N	\N	\N	185649	185649	352853
24384	37948	5	applied	\N	\N	\N	\N	185650	185650	352854
24384	37949	6	applied	\N	\N	\N	\N	185651	185651	352855
24388	37950	0	applied	\N	\N	\N	\N	185668	185668	352872
24394	37955	0	applied	\N	\N	\N	\N	185685	185685	352889
24394	37956	1	applied	\N	\N	\N	\N	185686	185686	352890
24396	37900	31	applied	\N	\N	\N	\N	185720	185720	352924
24396	37902	32	applied	\N	\N	\N	\N	185721	185721	352925
24396	37904	33	applied	\N	\N	\N	\N	185722	185722	352926
24396	37905	34	applied	\N	\N	\N	\N	185723	185723	352927
24396	37909	35	applied	\N	\N	\N	\N	185724	185724	352928
24396	37910	36	applied	\N	\N	\N	\N	185725	185725	352929
24396	37914	37	applied	\N	\N	\N	\N	185726	185726	352930
24396	37915	38	applied	\N	\N	\N	\N	185727	185727	352931
24396	37918	39	applied	\N	\N	\N	\N	185728	185728	352932
24396	37923	40	applied	\N	\N	\N	\N	185729	185729	352933
24396	37924	41	applied	\N	\N	\N	\N	185730	185730	352934
24396	37916	42	applied	\N	\N	\N	\N	185731	185731	352935
24396	37925	43	applied	\N	\N	\N	\N	185732	185732	352936
24396	37928	44	applied	\N	\N	\N	\N	185733	185733	352937
24396	37934	46	applied	\N	\N	\N	\N	185735	185735	352939
24396	37926	47	applied	\N	\N	\N	\N	185736	185736	352940
24396	37931	48	applied	\N	\N	\N	\N	185737	185737	352941
24396	37937	49	applied	\N	\N	\N	\N	185738	185738	352942
24396	37946	50	applied	\N	\N	\N	\N	185739	185739	352943
24396	37954	51	applied	\N	\N	\N	\N	185740	185740	352944
24396	37938	52	applied	\N	\N	\N	\N	185741	185741	352945
24396	37941	53	applied	\N	\N	\N	\N	185742	185742	352946
24396	37942	54	applied	\N	\N	\N	\N	185743	185743	352947
24396	37947	55	applied	\N	\N	\N	\N	185744	185744	352948
24396	37948	56	applied	\N	\N	\N	\N	185745	185745	352949
24396	37949	57	applied	\N	\N	\N	\N	185746	185746	352950
24396	37951	58	applied	\N	\N	\N	\N	185747	185747	352951
24396	37953	59	applied	\N	\N	\N	\N	185748	185748	352952
24396	37956	60	applied	\N	\N	\N	\N	185749	185749	352953
24398	37957	0	applied	\N	\N	\N	\N	185752	185752	352956
24401	37963	1	applied	\N	\N	\N	\N	185761	185761	352965
24401	37964	2	applied	\N	\N	\N	\N	185762	185762	352966
24404	37967	0	applied	\N	\N	\N	\N	185768	185768	352972
24404	37968	1	applied	\N	\N	\N	\N	185769	185769	352973
24404	37969	2	applied	\N	\N	\N	\N	185770	185770	352974
24411	37982	0	applied	\N	\N	\N	\N	185787	185787	352991
24411	37983	1	applied	\N	\N	\N	\N	185788	185788	352992
24411	37984	2	applied	\N	\N	\N	\N	185789	185789	352993
24419	37999	0	applied	\N	\N	\N	\N	185810	185810	353014
24419	38000	1	applied	\N	\N	\N	\N	185811	185811	353015
24421	37906	0	applied	\N	\N	\N	\N	185859	185859	353063
24421	37911	1	applied	\N	\N	\N	\N	185860	185860	353064
24421	37919	2	applied	\N	\N	\N	\N	185861	185861	353065
24421	37932	3	applied	\N	\N	\N	\N	185862	185862	353066
24421	37721	4	applied	\N	\N	\N	\N	185863	185863	353067
24421	37848	5	applied	\N	\N	\N	\N	185864	185864	353068
24421	37717	7	applied	\N	\N	\N	\N	185866	185866	353070
24421	37718	8	applied	\N	\N	\N	\N	185867	185867	353071
24421	37722	9	applied	\N	\N	\N	\N	185868	185868	353072
24421	37725	10	applied	\N	\N	\N	\N	185869	185869	353073
24421	37729	11	applied	\N	\N	\N	\N	185870	185870	353074
24421	37732	12	applied	\N	\N	\N	\N	185871	185871	353075
24421	37735	13	applied	\N	\N	\N	\N	185872	185872	353076
24421	37739	14	applied	\N	\N	\N	\N	185873	185873	353077
24421	37742	15	applied	\N	\N	\N	\N	185874	185874	353078
24421	37743	16	applied	\N	\N	\N	\N	185875	185875	353079
24421	37744	17	applied	\N	\N	\N	\N	185876	185876	353080
24421	37752	18	applied	\N	\N	\N	\N	185877	185877	353081
24421	37753	19	applied	\N	\N	\N	\N	185878	185878	353082
24421	37758	20	applied	\N	\N	\N	\N	185879	185879	353083
24421	37762	21	applied	\N	\N	\N	\N	185880	185880	353084
24421	37765	22	applied	\N	\N	\N	\N	185881	185881	353085
24421	37772	24	applied	\N	\N	\N	\N	185883	185883	353087
24421	37775	25	applied	\N	\N	\N	\N	185884	185884	353088
24421	37778	26	applied	\N	\N	\N	\N	185885	185885	353089
24421	37779	27	applied	\N	\N	\N	\N	185886	185886	353090
24421	37780	28	applied	\N	\N	\N	\N	185887	185887	353091
24421	37787	29	applied	\N	\N	\N	\N	185888	185888	353092
24421	37788	30	applied	\N	\N	\N	\N	185889	185889	353093
24421	37794	31	applied	\N	\N	\N	\N	185890	185890	353094
24421	37797	32	applied	\N	\N	\N	\N	185891	185891	353095
24421	37798	33	applied	\N	\N	\N	\N	185892	185892	353096
24421	37804	34	applied	\N	\N	\N	\N	185893	185893	353097
24421	37805	35	applied	\N	\N	\N	\N	185894	185894	353098
24421	37810	36	applied	\N	\N	\N	\N	185895	185895	353099
24421	37811	37	applied	\N	\N	\N	\N	185896	185896	353100
24378	37919	2	applied	\N	\N	\N	\N	185608	185608	352812
24378	37903	3	applied	\N	\N	\N	\N	185609	185609	352813
24407	37973	1	applied	\N	\N	\N	\N	185776	185776	352980
24407	37974	2	applied	\N	\N	\N	\N	185777	185777	352981
24407	37975	3	applied	\N	\N	\N	\N	185778	185778	352982
24407	37976	4	applied	\N	\N	\N	\N	185779	185779	352983
24407	37977	5	applied	\N	\N	\N	\N	185780	185780	352984
24410	37982	0	applied	\N	\N	\N	\N	185785	185785	352989
24410	37981	1	applied	\N	\N	\N	\N	185786	185786	352990
24412	37985	0	applied	\N	\N	\N	\N	185790	185790	352994
24412	37986	1	applied	\N	\N	\N	\N	185791	185791	352995
24412	37987	2	applied	\N	\N	\N	\N	185792	185792	352996
24415	37990	0	applied	\N	\N	\N	\N	185797	185797	353001
24415	37991	1	applied	\N	\N	\N	\N	185798	185798	353002
24420	37957	0	applied	\N	\N	\N	\N	185812	185812	353016
24420	37959	1	applied	\N	\N	\N	\N	185813	185813	353017
24420	37962	2	applied	\N	\N	\N	\N	185814	185814	353018
24420	37963	3	applied	\N	\N	\N	\N	185815	185815	353019
24420	37967	5	applied	\N	\N	\N	\N	185817	185817	353021
24420	37970	6	applied	\N	\N	\N	\N	185818	185818	353022
24420	37972	7	applied	\N	\N	\N	\N	185819	185819	353023
24420	37978	8	applied	\N	\N	\N	\N	185820	185820	353024
24420	37982	9	applied	\N	\N	\N	\N	185821	185821	353025
24420	37983	10	applied	\N	\N	\N	\N	185822	185822	353026
24420	37985	12	applied	\N	\N	\N	\N	185823	185823	353027
24420	37988	13	applied	\N	\N	\N	\N	185824	185824	353028
24420	37990	14	applied	\N	\N	\N	\N	185825	185825	353029
24420	37992	15	applied	\N	\N	\N	\N	185826	185826	353030
24420	37993	16	applied	\N	\N	\N	\N	185827	185827	353031
24420	37994	17	applied	\N	\N	\N	\N	185828	185828	353032
24420	37999	18	applied	\N	\N	\N	\N	185829	185829	353033
24420	38001	19	applied	\N	\N	\N	\N	185830	185830	353034
24420	37974	20	applied	\N	\N	\N	\N	185831	185831	353035
24420	37975	21	applied	\N	\N	\N	\N	185832	185832	353036
24420	37977	23	applied	\N	\N	\N	\N	185834	185834	353038
24420	37958	24	applied	\N	\N	\N	\N	185835	185835	353039
24420	37960	25	applied	\N	\N	\N	\N	185836	185836	353040
24420	37964	26	applied	\N	\N	\N	\N	185837	185837	353041
24420	37966	27	applied	\N	\N	\N	\N	185838	185838	353042
24420	37968	28	applied	\N	\N	\N	\N	185839	185839	353043
24420	37971	29	applied	\N	\N	\N	\N	185840	185840	353044
24420	37973	30	applied	\N	\N	\N	\N	185841	185841	353045
24420	37979	31	applied	\N	\N	\N	\N	185842	185842	353046
24420	37981	32	applied	\N	\N	\N	\N	185843	185843	353047
24420	37984	33	applied	\N	\N	\N	\N	185844	185844	353048
24420	37987	34	applied	\N	\N	\N	\N	185845	185845	353049
24420	37989	35	applied	\N	\N	\N	\N	185846	185846	353050
24420	37991	36	applied	\N	\N	\N	\N	185847	185847	353051
24420	37996	37	applied	\N	\N	\N	\N	185848	185848	353052
24420	37997	38	applied	\N	\N	\N	\N	185849	185849	353053
24420	38000	40	applied	\N	\N	\N	\N	185851	185851	353055
24420	38002	41	applied	\N	\N	\N	\N	185852	185852	353056
24420	37961	42	applied	\N	\N	\N	\N	185853	185853	353057
24420	37969	43	applied	\N	\N	\N	\N	185854	185854	353058
24420	37980	44	applied	\N	\N	\N	\N	185855	185855	353059
24420	37986	45	applied	\N	\N	\N	\N	185856	185856	353060
24420	37995	46	applied	\N	\N	\N	\N	185857	185857	353061
24420	38003	47	applied	\N	\N	\N	\N	185858	185858	353062
24421	37812	38	applied	\N	\N	\N	\N	185897	185897	353101
24421	37813	39	applied	\N	\N	\N	\N	185898	185898	353102
24421	37823	40	applied	\N	\N	\N	\N	185899	185899	353103
24421	37827	41	applied	\N	\N	\N	\N	185900	185900	353104
24421	37828	42	applied	\N	\N	\N	\N	185901	185901	353105
24421	37841	43	applied	\N	\N	\N	\N	185902	185902	353106
24421	37844	44	applied	\N	\N	\N	\N	185903	185903	353107
24421	37849	45	applied	\N	\N	\N	\N	185904	185904	353108
24421	37851	47	applied	\N	\N	\N	\N	185906	185906	353110
24421	37859	48	applied	\N	\N	\N	\N	185907	185907	353111
24421	37862	49	applied	\N	\N	\N	\N	185908	185908	353112
24421	37865	50	applied	\N	\N	\N	\N	185909	185909	353113
24421	37867	51	applied	\N	\N	\N	\N	185910	185910	353114
24421	37870	52	applied	\N	\N	\N	\N	185911	185911	353115
24421	37873	53	applied	\N	\N	\N	\N	185912	185912	353116
24421	37876	54	applied	\N	\N	\N	\N	185913	185913	353117
24421	37877	55	applied	\N	\N	\N	\N	185914	185914	353118
24421	37883	56	applied	\N	\N	\N	\N	185915	185915	353119
24421	37886	57	applied	\N	\N	\N	\N	185916	185916	353120
24421	37887	58	applied	\N	\N	\N	\N	185917	185917	353121
24421	37892	59	applied	\N	\N	\N	\N	185918	185918	353122
24421	37894	60	applied	\N	\N	\N	\N	185919	185919	353123
24421	37896	61	applied	\N	\N	\N	\N	185920	185920	353124
24421	37899	62	applied	\N	\N	\N	\N	185921	185921	353125
24421	37903	64	applied	\N	\N	\N	\N	185923	185923	353127
24421	37907	65	applied	\N	\N	\N	\N	185924	185924	353128
24421	37908	66	applied	\N	\N	\N	\N	185925	185925	353129
24421	37912	67	applied	\N	\N	\N	\N	185926	185926	353130
24421	37913	68	applied	\N	\N	\N	\N	185927	185927	353131
24423	38001	0	applied	\N	\N	\N	\N	185991	185991	353194
24423	38004	1	applied	\N	\N	\N	\N	185992	185992	353195
24423	38005	2	applied	\N	\N	\N	\N	185993	185993	353196
24423	38003	3	applied	\N	\N	\N	\N	185994	185994	353197
24423	38002	4	applied	\N	\N	\N	\N	185995	185995	353198
24423	38006	5	applied	\N	\N	\N	\N	185996	185996	353199
24423	38007	6	applied	\N	\N	\N	\N	185997	185997	353200
24426	38015	0	applied	\N	\N	\N	\N	186007	186007	353210
24426	38016	1	applied	\N	\N	\N	\N	186008	186008	353211
24431	38017	0	applied	\N	\N	\N	\N	186020	186020	353223
24431	38018	1	applied	\N	\N	\N	\N	186021	186021	353224
24439	38031	0	applied	\N	\N	\N	\N	186044	186044	353247
24439	38032	1	applied	\N	\N	\N	\N	186045	186045	353248
24439	38033	2	applied	\N	\N	\N	\N	186046	186046	353249
24439	38034	3	applied	\N	\N	\N	\N	186047	186047	353250
24442	38031	0	applied	\N	\N	\N	\N	186052	186052	353255
24442	38032	1	applied	\N	\N	\N	\N	186053	186053	353256
24442	38035	2	applied	\N	\N	\N	\N	186054	186054	353257
24442	38037	3	applied	\N	\N	\N	\N	186055	186055	353258
24442	38033	4	applied	\N	\N	\N	\N	186056	186056	353259
24442	38036	5	applied	\N	\N	\N	\N	186057	186057	353260
24442	38034	6	applied	\N	\N	\N	\N	186058	186058	353261
24442	38038	7	applied	\N	\N	\N	\N	186059	186059	353262
24444	38039	0	applied	\N	\N	\N	\N	186064	186064	353267
24444	38040	1	applied	\N	\N	\N	\N	186065	186065	353268
24405	37970	0	applied	\N	\N	\N	\N	185771	185771	352975
24405	37971	1	applied	\N	\N	\N	\N	185772	185772	352976
24421	37922	72	applied	\N	\N	\N	\N	185931	185931	353135
24421	37927	73	applied	\N	\N	\N	\N	185932	185932	353136
24421	37929	74	applied	\N	\N	\N	\N	185933	185933	353137
24421	37933	75	applied	\N	\N	\N	\N	185934	185934	353138
24421	37935	76	applied	\N	\N	\N	\N	185935	185935	353139
24421	37936	77	applied	\N	\N	\N	\N	185936	185936	353140
24421	37939	78	applied	\N	\N	\N	\N	185937	185937	353141
24421	37940	80	applied	\N	\N	\N	\N	185938	185938	353142
24421	37943	81	applied	\N	\N	\N	\N	185939	185939	353143
24421	37945	83	applied	\N	\N	\N	\N	185941	185941	353145
24421	37950	84	applied	\N	\N	\N	\N	185942	185942	353146
24421	37952	85	applied	\N	\N	\N	\N	185943	185943	353147
24421	37955	86	applied	\N	\N	\N	\N	185944	185944	353148
24421	37957	87	applied	\N	\N	\N	\N	185945	185945	353149
24421	37959	88	applied	\N	\N	\N	\N	185946	185946	353150
24421	37962	89	applied	\N	\N	\N	\N	185947	185947	353151
24421	37963	90	applied	\N	\N	\N	\N	185948	185948	353152
24421	37965	91	applied	\N	\N	\N	\N	185949	185949	353153
24421	37967	92	applied	\N	\N	\N	\N	185950	185950	353154
24421	37970	93	applied	\N	\N	\N	\N	185951	185951	353155
24421	37972	94	applied	\N	\N	\N	\N	185952	185952	353156
24421	37978	95	applied	\N	\N	\N	\N	185953	185953	353157
24421	37982	96	applied	\N	\N	\N	\N	185954	185954	353158
24421	37983	97	applied	\N	\N	\N	\N	185955	185955	353159
24421	37985	98	applied	\N	\N	\N	\N	185956	185956	353160
24421	37990	100	applied	\N	\N	\N	\N	185958	185958	353162
24421	37992	101	applied	\N	\N	\N	\N	185959	185959	353163
24421	37993	102	applied	\N	\N	\N	\N	185960	185960	353164
24421	37994	103	applied	\N	\N	\N	\N	185961	185961	353165
24421	37999	104	applied	\N	\N	\N	\N	185962	185962	353166
24421	38001	105	applied	\N	\N	\N	\N	185963	185963	353167
24421	37974	107	applied	\N	\N	\N	\N	185965	185965	353168
24421	37829	106	failed	Amount_insufficient_to_create_account	\N	\N	\N	185964	185964	\N
24421	37975	108	applied	\N	\N	\N	\N	185966	185966	353169
24421	37976	109	applied	\N	\N	\N	\N	185967	185967	353170
24421	37977	110	applied	\N	\N	\N	\N	185968	185968	353171
24421	37714	111	applied	\N	\N	\N	\N	185969	185969	353172
24421	37720	112	applied	\N	\N	\N	\N	185970	185970	353173
24421	37723	113	applied	\N	\N	\N	\N	185971	185971	353174
24421	37715	114	applied	\N	\N	\N	\N	185972	185972	353175
24421	37727	115	applied	\N	\N	\N	\N	185973	185973	353176
24421	37734	117	applied	\N	\N	\N	\N	185975	185975	353178
24421	37728	118	applied	\N	\N	\N	\N	185976	185976	353179
24421	37737	119	applied	\N	\N	\N	\N	185977	185977	353180
24421	37745	120	applied	\N	\N	\N	\N	185978	185978	353181
24421	37761	121	applied	\N	\N	\N	\N	185979	185979	353182
24421	37770	122	applied	\N	\N	\N	\N	185980	185980	353183
24421	37738	123	applied	\N	\N	\N	\N	185981	185981	353184
24421	37740	124	applied	\N	\N	\N	\N	185982	185982	353185
24421	37748	125	applied	\N	\N	\N	\N	185983	185983	353186
24424	38008	0	applied	\N	\N	\N	\N	185998	185998	353201
24424	38009	1	applied	\N	\N	\N	\N	185999	185999	353202
24424	38010	2	applied	\N	\N	\N	\N	186000	186000	353203
24424	38011	3	applied	\N	\N	\N	\N	186001	186001	353204
24424	38012	4	applied	\N	\N	\N	\N	186002	186002	353205
24424	38013	5	applied	\N	\N	\N	\N	186003	186003	353206
24424	38014	6	applied	\N	\N	\N	\N	186004	186004	353207
24429	38018	1	applied	\N	\N	\N	\N	186015	186015	353218
24429	38019	2	applied	\N	\N	\N	\N	186016	186016	353219
24433	38020	0	applied	\N	\N	\N	\N	186026	186026	353229
24433	38021	1	applied	\N	\N	\N	\N	186027	186027	353230
24438	38029	0	applied	\N	\N	\N	\N	186042	186042	353245
24438	38030	1	applied	\N	\N	\N	\N	186043	186043	353246
24446	37906	0	applied	\N	\N	\N	\N	186068	186068	353271
24446	37911	1	applied	\N	\N	\N	\N	186069	186069	353272
24446	37919	2	applied	\N	\N	\N	\N	186070	186070	353273
24446	37932	3	applied	\N	\N	\N	\N	186071	186071	353274
24446	38031	4	applied	\N	\N	\N	\N	186072	186072	353275
24446	37974	5	applied	\N	\N	\N	\N	186073	186073	353276
24446	37975	6	applied	\N	\N	\N	\N	186074	186074	353277
24446	37976	7	applied	\N	\N	\N	\N	186075	186075	353278
24446	37977	8	applied	\N	\N	\N	\N	186076	186076	353279
24447	38041	0	applied	\N	\N	\N	\N	186077	186077	353280
24447	38043	2	applied	\N	\N	\N	\N	186079	186079	353282
24449	38044	0	applied	\N	\N	\N	\N	186084	186084	353287
24449	38045	1	applied	\N	\N	\N	\N	186085	186085	353288
24449	38046	2	applied	\N	\N	\N	\N	186086	186086	353289
24449	38047	3	applied	\N	\N	\N	\N	186087	186087	353290
24451	38044	0	applied	\N	\N	\N	\N	186092	186092	353295
24451	38045	1	applied	\N	\N	\N	\N	186093	186093	353296
24451	38046	2	applied	\N	\N	\N	\N	186094	186094	353297
24451	38047	3	applied	\N	\N	\N	\N	186095	186095	353298
24452	38048	0	applied	\N	\N	\N	\N	186096	186096	353299
24452	38049	1	applied	\N	\N	\N	\N	186097	186097	353300
24452	38050	2	applied	\N	\N	\N	\N	186098	186098	353301
24453	38048	0	applied	\N	\N	\N	\N	186099	186099	353302
24453	38049	1	applied	\N	\N	\N	\N	186100	186100	353303
24453	38050	2	applied	\N	\N	\N	\N	186101	186101	353304
24456	38054	0	applied	\N	\N	\N	\N	186108	186108	353311
24456	38056	2	applied	\N	\N	\N	\N	186110	186110	353313
24457	38057	0	applied	\N	\N	\N	\N	186111	186111	353314
24457	38058	1	applied	\N	\N	\N	\N	186112	186112	353315
24457	38059	2	applied	\N	\N	\N	\N	186113	186113	353316
24457	38060	3	applied	\N	\N	\N	\N	186114	186114	353317
24459	38057	0	applied	\N	\N	\N	\N	186119	186119	353322
24459	38058	1	applied	\N	\N	\N	\N	186120	186120	353323
24459	38059	2	applied	\N	\N	\N	\N	186121	186121	353324
24459	38060	3	applied	\N	\N	\N	\N	186122	186122	353325
24461	38061	0	applied	\N	\N	\N	\N	186125	186125	353328
24465	38073	0	applied	\N	\N	\N	\N	186137	186137	353340
24465	38074	1	applied	\N	\N	\N	\N	186138	186138	353341
24465	38075	2	applied	\N	\N	\N	\N	186139	186139	353342
24465	38076	3	applied	\N	\N	\N	\N	186140	186140	353343
24465	38077	4	applied	\N	\N	\N	\N	186141	186141	353344
24465	38078	5	applied	\N	\N	\N	\N	186142	186142	353345
24465	38080	7	applied	\N	\N	\N	\N	186144	186144	353347
24468	38081	0	applied	\N	\N	\N	\N	186151	186151	353354
24468	38082	1	applied	\N	\N	\N	\N	186152	186152	353355
24468	38083	2	applied	\N	\N	\N	\N	186153	186153	353356
24421	37920	70	applied	\N	\N	\N	\N	185929	185929	353133
24421	37921	71	applied	\N	\N	\N	\N	185930	185930	353134
24445	38039	0	applied	\N	\N	\N	\N	186066	186066	353269
24445	38040	1	applied	\N	\N	\N	\N	186067	186067	353270
24450	38044	0	applied	\N	\N	\N	\N	186088	186088	353291
24450	38045	1	applied	\N	\N	\N	\N	186089	186089	353292
24450	38046	2	applied	\N	\N	\N	\N	186090	186090	353293
24450	38047	3	applied	\N	\N	\N	\N	186091	186091	353294
24455	38054	0	applied	\N	\N	\N	\N	186105	186105	353308
24455	38055	1	applied	\N	\N	\N	\N	186106	186106	353309
24455	38056	2	applied	\N	\N	\N	\N	186107	186107	353310
24458	38057	0	applied	\N	\N	\N	\N	186115	186115	353318
24458	38058	1	applied	\N	\N	\N	\N	186116	186116	353319
24458	38059	2	applied	\N	\N	\N	\N	186117	186117	353320
24458	38060	3	applied	\N	\N	\N	\N	186118	186118	353321
24460	38061	0	applied	\N	\N	\N	\N	186123	186123	353326
24460	38062	1	applied	\N	\N	\N	\N	186124	186124	353327
24461	38062	1	applied	\N	\N	\N	\N	186126	186126	353329
24466	38082	1	applied	\N	\N	\N	\N	186146	186146	353349
24466	38083	2	applied	\N	\N	\N	\N	186147	186147	353350
24469	38081	0	applied	\N	\N	\N	\N	186154	186154	353357
24469	38082	1	applied	\N	\N	\N	\N	186155	186155	353358
24470	38084	0	applied	\N	\N	\N	\N	186156	186156	353359
24470	38085	1	applied	\N	\N	\N	\N	186157	186157	353360
24471	38084	0	applied	\N	\N	\N	\N	186158	186158	353361
24471	38085	1	applied	\N	\N	\N	\N	186159	186159	353362
24473	38086	0	applied	\N	\N	\N	\N	186164	186164	353367
24473	38087	1	applied	\N	\N	\N	\N	186165	186165	353368
24477	38090	0	applied	\N	\N	\N	\N	186174	186174	353377
24477	38091	1	applied	\N	\N	\N	\N	186175	186175	353378
24477	38092	2	applied	\N	\N	\N	\N	186176	186176	353379
24479	38093	0	applied	\N	\N	\N	\N	186179	186179	353382
24479	38094	1	applied	\N	\N	\N	\N	186180	186180	353383
24484	38100	0	applied	\N	\N	\N	\N	186186	186186	353389
24485	38102	0	applied	\N	\N	\N	\N	186188	186188	353391
24485	38103	2	applied	\N	\N	\N	\N	186189	186189	353392
24488	38113	0	applied	\N	\N	\N	\N	186199	186199	353402
24488	38114	1	applied	\N	\N	\N	\N	186200	186200	353403
24488	38115	2	applied	\N	\N	\N	\N	186201	186201	353404
24491	38120	0	applied	\N	\N	\N	\N	186210	186210	353413
24491	38121	1	applied	\N	\N	\N	\N	186211	186211	353414
24493	38123	0	applied	\N	\N	\N	\N	186215	186215	353418
24493	38122	1	applied	\N	\N	\N	\N	186216	186216	353419
24493	38124	2	applied	\N	\N	\N	\N	186217	186217	353420
24495	38125	0	applied	\N	\N	\N	\N	186221	186221	353424
24496	38125	0	applied	\N	\N	\N	\N	186222	186222	353425
24496	38126	1	applied	\N	\N	\N	\N	186223	186223	353426
24498	38127	0	applied	\N	\N	\N	\N	186230	186230	353433
24498	38128	1	applied	\N	\N	\N	\N	186231	186231	353434
24498	38126	2	applied	\N	\N	\N	\N	186232	186232	353435
24498	38130	4	applied	\N	\N	\N	\N	186234	186234	353437
24498	38131	5	applied	\N	\N	\N	\N	186235	186235	353438
24500	38134	0	applied	\N	\N	\N	\N	186238	186238	353441
24500	38135	1	applied	\N	\N	\N	\N	186239	186239	353442
24503	38139	0	applied	\N	\N	\N	\N	186368	186368	353571
24503	38140	1	applied	\N	\N	\N	\N	186369	186369	353572
24507	38143	0	applied	\N	\N	\N	\N	186374	186374	353577
24507	38144	1	applied	\N	\N	\N	\N	186375	186375	353578
24507	38145	2	applied	\N	\N	\N	\N	186376	186376	353579
24507	38146	3	applied	\N	\N	\N	\N	186377	186377	353580
24507	38147	4	applied	\N	\N	\N	\N	186378	186378	353581
24508	38148	0	applied	\N	\N	\N	\N	186379	186379	353582
24508	38149	1	applied	\N	\N	\N	\N	186380	186380	353583
24511	38148	0	applied	\N	\N	\N	\N	186385	186385	353588
24511	38149	1	applied	\N	\N	\N	\N	186386	186386	353589
24512	38150	0	applied	\N	\N	\N	\N	186387	186387	353590
24512	38152	2	applied	\N	\N	\N	\N	186389	186389	353592
24512	38153	3	applied	\N	\N	\N	\N	186390	186390	353593
24512	38154	4	applied	\N	\N	\N	\N	186391	186391	353594
24513	38150	0	applied	\N	\N	\N	\N	186392	186392	353595
24513	38151	1	applied	\N	\N	\N	\N	186393	186393	353596
24515	38155	0	applied	\N	\N	\N	\N	186522	186522	353725
24515	38156	1	applied	\N	\N	\N	\N	186523	186523	353726
24515	38157	2	applied	\N	\N	\N	\N	186524	186524	353727
24515	38158	3	applied	\N	\N	\N	\N	186525	186525	353728
24515	38159	4	applied	\N	\N	\N	\N	186526	186526	353729
24515	38160	5	applied	\N	\N	\N	\N	186527	186527	353730
24515	38161	6	applied	\N	\N	\N	\N	186528	186528	353731
24521	38162	0	applied	\N	\N	\N	\N	186572	186572	353774
24521	38163	1	applied	\N	\N	\N	\N	186573	186573	353775
24524	38162	0	applied	\N	\N	\N	\N	186578	186578	353780
24524	38163	1	applied	\N	\N	\N	\N	186579	186579	353781
24534	38179	1	applied	\N	\N	\N	\N	186803	186803	354005
24534	38180	2	applied	\N	\N	\N	\N	186804	186804	354006
24534	38181	3	applied	\N	\N	\N	\N	186805	186805	354007
24539	38182	0	applied	\N	\N	\N	\N	186832	186832	354034
24539	38183	1	applied	\N	\N	\N	\N	186833	186833	354035
24539	38184	2	applied	\N	\N	\N	\N	186834	186834	354036
24539	38185	3	applied	\N	\N	\N	\N	186835	186835	354037
24539	38186	4	applied	\N	\N	\N	\N	186836	186836	354038
24539	38187	5	applied	\N	\N	\N	\N	186837	186837	354039
24542	38191	0	applied	\N	\N	\N	\N	186851	186851	354053
24542	38192	1	applied	\N	\N	\N	\N	186852	186852	354054
24542	38193	2	applied	\N	\N	\N	\N	186853	186853	354055
24542	38194	3	applied	\N	\N	\N	\N	186854	186854	354056
24548	38200	0	applied	\N	\N	\N	\N	186860	186860	354062
24548	38201	1	applied	\N	\N	\N	\N	186861	186861	354063
24555	38204	0	applied	\N	\N	\N	\N	186872	186872	354074
24555	38206	2	applied	\N	\N	\N	\N	186874	186874	354076
24555	38207	3	applied	\N	\N	\N	\N	186875	186875	354077
24555	38208	4	applied	\N	\N	\N	\N	186876	186876	354078
24557	37865	0	applied	\N	\N	\N	\N	186882	186882	354084
24557	37867	1	applied	\N	\N	\N	\N	186883	186883	354085
24557	37870	2	applied	\N	\N	\N	\N	186884	186884	354086
24557	37873	3	applied	\N	\N	\N	\N	186885	186885	354087
24557	37876	4	applied	\N	\N	\N	\N	186886	186886	354088
24557	37877	5	applied	\N	\N	\N	\N	186887	186887	354089
24557	37883	6	applied	\N	\N	\N	\N	186888	186888	354090
24557	37886	7	applied	\N	\N	\N	\N	186889	186889	354091
24557	37887	8	applied	\N	\N	\N	\N	186890	186890	354092
24557	37892	9	applied	\N	\N	\N	\N	186891	186891	354093
24557	37894	10	applied	\N	\N	\N	\N	186892	186892	354094
24437	38028	6	applied	\N	\N	\N	\N	186041	186041	353244
24440	38035	0	applied	\N	\N	\N	\N	186048	186048	353251
24448	38047	3	applied	\N	\N	\N	\N	186083	186083	353286
24454	38051	0	applied	\N	\N	\N	\N	186102	186102	353305
24454	38052	1	applied	\N	\N	\N	\N	186103	186103	353306
24454	38053	2	applied	\N	\N	\N	\N	186104	186104	353307
24463	38063	0	applied	\N	\N	\N	\N	186127	186127	353330
24463	38064	1	applied	\N	\N	\N	\N	186128	186128	353331
24463	38065	2	applied	\N	\N	\N	\N	186129	186129	353332
24464	38066	0	applied	\N	\N	\N	\N	186130	186130	353333
24464	38067	1	applied	\N	\N	\N	\N	186131	186131	353334
24464	38068	2	applied	\N	\N	\N	\N	186132	186132	353335
24464	38069	3	applied	\N	\N	\N	\N	186133	186133	353336
24464	38070	4	applied	\N	\N	\N	\N	186134	186134	353337
24464	38071	5	applied	\N	\N	\N	\N	186135	186135	353338
24464	38072	6	applied	\N	\N	\N	\N	186136	186136	353339
24467	38081	0	applied	\N	\N	\N	\N	186148	186148	353351
24467	38082	1	applied	\N	\N	\N	\N	186149	186149	353352
24475	38086	0	applied	\N	\N	\N	\N	186166	186166	353369
24475	38087	1	applied	\N	\N	\N	\N	186167	186167	353370
24475	38088	2	applied	\N	\N	\N	\N	186168	186168	353371
24475	38089	3	applied	\N	\N	\N	\N	186169	186169	353372
24478	38093	0	applied	\N	\N	\N	\N	186177	186177	353380
24478	38094	1	applied	\N	\N	\N	\N	186178	186178	353381
24486	38104	0	applied	\N	\N	\N	\N	186190	186190	353393
24486	38105	1	applied	\N	\N	\N	\N	186191	186191	353394
24486	38106	2	applied	\N	\N	\N	\N	186192	186192	353395
24486	38107	3	applied	\N	\N	\N	\N	186193	186193	353396
24486	38108	4	applied	\N	\N	\N	\N	186194	186194	353397
24489	38116	0	applied	\N	\N	\N	\N	186202	186202	353405
24489	38117	1	applied	\N	\N	\N	\N	186203	186203	353406
24489	38118	2	applied	\N	\N	\N	\N	186204	186204	353407
24489	38119	3	applied	\N	\N	\N	\N	186205	186205	353408
24492	38120	0	applied	\N	\N	\N	\N	186212	186212	353415
24492	38122	2	applied	\N	\N	\N	\N	186214	186214	353417
24501	38136	0	applied	\N	\N	\N	\N	186240	186240	353443
24501	38137	1	applied	\N	\N	\N	\N	186241	186241	353444
24501	38138	2	applied	\N	\N	\N	\N	186242	186242	353445
24506	38141	0	applied	\N	\N	\N	\N	186372	186372	353575
24506	38142	1	applied	\N	\N	\N	\N	186373	186373	353576
24509	38148	0	applied	\N	\N	\N	\N	186381	186381	353584
24509	38149	1	applied	\N	\N	\N	\N	186382	186382	353585
24519	38162	0	applied	\N	\N	\N	\N	186568	186568	353770
24519	38163	1	applied	\N	\N	\N	\N	186569	186569	353771
24522	38162	0	applied	\N	\N	\N	\N	186574	186574	353776
24522	38163	1	applied	\N	\N	\N	\N	186575	186575	353777
24526	38162	0	applied	\N	\N	\N	\N	186705	186705	353907
24526	38163	1	applied	\N	\N	\N	\N	186706	186706	353908
24532	38171	0	applied	\N	\N	\N	\N	186795	186795	353997
24532	38172	1	applied	\N	\N	\N	\N	186796	186796	353998
24538	38183	1	applied	\N	\N	\N	\N	186827	186827	354029
24538	38184	2	applied	\N	\N	\N	\N	186828	186828	354030
24538	38185	3	applied	\N	\N	\N	\N	186829	186829	354031
24538	38186	4	applied	\N	\N	\N	\N	186830	186830	354032
24538	38187	5	applied	\N	\N	\N	\N	186831	186831	354033
24540	38182	0	applied	\N	\N	\N	\N	186838	186838	354040
24540	38183	1	applied	\N	\N	\N	\N	186839	186839	354041
24540	38184	2	applied	\N	\N	\N	\N	186840	186840	354042
24540	38188	3	applied	\N	\N	\N	\N	186841	186841	354043
24540	38185	4	applied	\N	\N	\N	\N	186842	186842	354044
24540	38189	5	applied	\N	\N	\N	\N	186843	186843	354045
24540	38186	6	applied	\N	\N	\N	\N	186844	186844	354046
24540	38187	7	applied	\N	\N	\N	\N	186845	186845	354047
24540	38190	8	applied	\N	\N	\N	\N	186846	186846	354048
24547	38195	0	applied	\N	\N	\N	\N	186855	186855	354057
24547	38196	1	applied	\N	\N	\N	\N	186856	186856	354058
24547	38198	3	applied	\N	\N	\N	\N	186858	186858	354060
24547	38199	4	applied	\N	\N	\N	\N	186859	186859	354061
24550	38200	0	applied	\N	\N	\N	\N	186864	186864	354066
24550	38201	1	applied	\N	\N	\N	\N	186865	186865	354067
24554	38202	0	applied	\N	\N	\N	\N	186870	186870	354072
24554	38203	1	applied	\N	\N	\N	\N	186871	186871	354073
24557	37896	11	applied	\N	\N	\N	\N	186893	186893	354095
24557	37899	12	applied	\N	\N	\N	\N	186894	186894	354096
24557	37901	13	applied	\N	\N	\N	\N	186895	186895	354097
24557	37903	14	applied	\N	\N	\N	\N	186896	186896	354098
24557	37907	15	applied	\N	\N	\N	\N	186897	186897	354099
24557	37908	16	applied	\N	\N	\N	\N	186898	186898	354100
24557	37912	17	applied	\N	\N	\N	\N	186899	186899	354101
24557	37913	18	applied	\N	\N	\N	\N	186900	186900	354102
24557	37917	19	applied	\N	\N	\N	\N	186901	186901	354103
24557	37920	20	applied	\N	\N	\N	\N	186902	186902	354104
24557	37922	22	applied	\N	\N	\N	\N	186904	186904	354106
24557	37927	23	applied	\N	\N	\N	\N	186905	186905	354107
24557	37929	24	applied	\N	\N	\N	\N	186906	186906	354108
24557	37933	25	applied	\N	\N	\N	\N	186907	186907	354109
24557	37935	26	applied	\N	\N	\N	\N	186908	186908	354110
24557	37936	27	applied	\N	\N	\N	\N	186909	186909	354111
24557	37939	28	applied	\N	\N	\N	\N	186910	186910	354112
24557	37940	29	applied	\N	\N	\N	\N	186911	186911	354113
24557	37943	30	applied	\N	\N	\N	\N	186912	186912	354114
24557	37944	31	applied	\N	\N	\N	\N	186913	186913	354115
24557	37945	32	applied	\N	\N	\N	\N	186914	186914	354116
24557	37950	33	applied	\N	\N	\N	\N	186915	186915	354117
24557	37952	34	applied	\N	\N	\N	\N	186916	186916	354118
24557	37955	35	applied	\N	\N	\N	\N	186917	186917	354119
24557	37957	36	applied	\N	\N	\N	\N	186918	186918	354120
24557	37959	37	applied	\N	\N	\N	\N	186919	186919	354121
24557	37963	39	applied	\N	\N	\N	\N	186921	186921	354123
24557	37965	40	applied	\N	\N	\N	\N	186922	186922	354124
24557	37967	41	applied	\N	\N	\N	\N	186923	186923	354125
24558	38209	0	applied	\N	\N	\N	\N	187007	187007	354209
24558	38210	1	applied	\N	\N	\N	\N	187008	187008	354210
24561	38214	0	applied	\N	\N	\N	\N	187013	187013	354215
24561	38215	1	applied	\N	\N	\N	\N	187014	187014	354216
24563	38218	0	applied	\N	\N	\N	\N	187017	187017	354219
24563	38219	1	applied	\N	\N	\N	\N	187018	187018	354220
24563	38220	2	applied	\N	\N	\N	\N	187019	187019	354221
24566	38223	0	applied	\N	\N	\N	\N	187024	187024	354226
24566	38224	1	applied	\N	\N	\N	\N	187025	187025	354227
24566	38225	2	applied	\N	\N	\N	\N	187026	187026	354228
24566	38226	3	applied	\N	\N	\N	\N	187027	187027	354229
24448	38044	0	applied	\N	\N	\N	\N	186080	186080	353283
24448	38045	1	applied	\N	\N	\N	\N	186081	186081	353284
24476	38086	0	applied	\N	\N	\N	\N	186170	186170	353373
24476	38087	1	applied	\N	\N	\N	\N	186171	186171	353374
24476	38088	2	applied	\N	\N	\N	\N	186172	186172	353375
24476	38089	3	applied	\N	\N	\N	\N	186173	186173	353376
24481	38095	0	applied	\N	\N	\N	\N	186181	186181	353384
24481	38096	1	applied	\N	\N	\N	\N	186182	186182	353385
24481	38097	2	applied	\N	\N	\N	\N	186183	186183	353386
24481	38098	3	applied	\N	\N	\N	\N	186184	186184	353387
24481	38099	4	applied	\N	\N	\N	\N	186185	186185	353388
24487	38109	0	applied	\N	\N	\N	\N	186195	186195	353398
24487	38110	1	applied	\N	\N	\N	\N	186196	186196	353399
24487	38111	2	applied	\N	\N	\N	\N	186197	186197	353400
24487	38112	3	applied	\N	\N	\N	\N	186198	186198	353401
24490	38116	0	applied	\N	\N	\N	\N	186206	186206	353409
24490	38118	2	applied	\N	\N	\N	\N	186208	186208	353411
24490	38119	3	applied	\N	\N	\N	\N	186209	186209	353412
24494	38123	0	applied	\N	\N	\N	\N	186218	186218	353421
24494	38122	1	applied	\N	\N	\N	\N	186219	186219	353422
24494	38124	2	applied	\N	\N	\N	\N	186220	186220	353423
24497	38127	0	applied	\N	\N	\N	\N	186224	186224	353427
24497	38128	1	applied	\N	\N	\N	\N	186225	186225	353428
24497	38126	2	applied	\N	\N	\N	\N	186226	186226	353429
24497	38129	3	applied	\N	\N	\N	\N	186227	186227	353430
24497	38130	4	applied	\N	\N	\N	\N	186228	186228	353431
24497	38131	5	applied	\N	\N	\N	\N	186229	186229	353432
24499	38132	0	applied	\N	\N	\N	\N	186236	186236	353439
24499	38133	1	applied	\N	\N	\N	\N	186237	186237	353440
24502	37906	0	applied	\N	\N	\N	\N	186243	186243	353446
24502	37911	1	applied	\N	\N	\N	\N	186244	186244	353447
24502	37919	2	applied	\N	\N	\N	\N	186245	186245	353448
24502	38073	4	applied	\N	\N	\N	\N	186247	186247	353450
24502	38031	5	applied	\N	\N	\N	\N	186248	186248	353451
24502	37695	6	applied	\N	\N	1000000000	\N	186249	186249	353452
24502	37721	7	applied	\N	\N	\N	\N	186250	186250	353453
24502	37848	8	applied	\N	\N	\N	\N	186251	186251	353454
24502	38074	9	applied	\N	\N	\N	\N	186252	186252	353455
24502	38075	10	applied	\N	\N	\N	\N	186253	186253	353456
24502	38076	11	applied	\N	\N	\N	\N	186254	186254	353457
24502	37512	12	applied	\N	\N	\N	\N	186255	186255	353458
24502	37514	13	applied	\N	\N	\N	\N	186256	186256	353459
24502	37515	14	applied	\N	\N	\N	\N	186257	186257	353460
24502	37520	15	applied	\N	\N	\N	\N	186258	186258	353461
24502	37522	16	applied	\N	\N	\N	\N	186259	186259	353462
24502	37523	17	applied	\N	\N	\N	\N	186260	186260	353463
24502	37668	18	applied	\N	\N	\N	\N	186261	186261	353464
24502	37669	19	applied	\N	\N	\N	\N	186262	186262	353465
24502	37671	21	applied	\N	\N	\N	\N	186264	186264	353467
24502	37672	22	applied	\N	\N	\N	\N	186265	186265	353468
24502	37527	23	applied	\N	\N	\N	\N	186266	186266	353469
24502	37528	24	applied	\N	\N	\N	\N	186267	186267	353470
24502	37529	25	applied	\N	\N	\N	\N	186268	186268	353471
24502	37535	26	applied	\N	\N	\N	\N	186269	186269	353472
24502	37537	27	applied	\N	\N	\N	\N	186270	186270	353473
24502	37539	28	applied	\N	\N	\N	\N	186271	186271	353474
24502	37540	29	applied	\N	\N	\N	\N	186272	186272	353475
24502	37541	30	applied	\N	\N	\N	\N	186273	186273	353476
24502	37546	31	applied	\N	\N	\N	\N	186274	186274	353477
24502	37548	32	applied	\N	\N	\N	\N	186275	186275	353478
24502	37551	33	applied	\N	\N	\N	\N	186276	186276	353479
24502	37553	34	applied	\N	\N	\N	\N	186277	186277	353480
24502	37555	35	applied	\N	\N	\N	\N	186278	186278	353481
24502	37558	36	applied	\N	\N	\N	\N	186279	186279	353482
24502	37563	38	applied	\N	\N	\N	\N	186281	186281	353484
24502	37567	39	applied	\N	\N	\N	\N	186282	186282	353485
24502	37568	40	applied	\N	\N	\N	\N	186283	186283	353486
24502	37573	41	applied	\N	\N	\N	\N	186284	186284	353487
24502	37576	42	applied	\N	\N	\N	\N	186285	186285	353488
24502	37580	43	applied	\N	\N	\N	\N	186286	186286	353489
24502	37583	44	applied	\N	\N	\N	\N	186287	186287	353490
24502	37584	45	applied	\N	\N	\N	\N	186288	186288	353491
24502	37589	46	applied	\N	\N	\N	\N	186289	186289	353492
24502	37592	47	applied	\N	\N	\N	\N	186290	186290	353493
24502	37593	48	applied	\N	\N	\N	\N	186291	186291	353494
24502	37599	49	applied	\N	\N	\N	\N	186292	186292	353495
24502	37602	50	applied	\N	\N	\N	\N	186293	186293	353496
24502	37605	51	applied	\N	\N	\N	\N	186294	186294	353497
24502	37608	52	applied	\N	\N	\N	\N	186295	186295	353498
24502	37612	53	applied	\N	\N	\N	\N	186296	186296	353499
24502	37618	55	applied	\N	\N	\N	\N	186298	186298	353501
24502	37622	56	applied	\N	\N	\N	\N	186299	186299	353502
24570	38223	0	applied	\N	\N	\N	\N	187040	187040	354242
24570	38224	1	applied	\N	\N	\N	\N	187041	187041	354243
24570	38225	2	applied	\N	\N	\N	\N	187042	187042	354244
24570	38226	3	applied	\N	\N	\N	\N	187043	187043	354245
24578	38244	0	applied	\N	\N	\N	\N	187075	187075	354277
24578	38245	1	applied	\N	\N	\N	\N	187076	187076	354278
24582	38261	0	applied	\N	\N	\N	\N	187092	187092	354294
24582	38262	1	applied	\N	\N	\N	\N	187093	187093	354295
24582	38263	2	applied	\N	\N	\N	\N	187094	187094	354296
24582	38264	3	applied	\N	\N	\N	\N	187095	187095	354297
24582	38265	4	applied	\N	\N	\N	\N	187096	187096	354298
24582	38266	6	applied	\N	\N	\N	\N	187097	187097	354299
24582	38267	7	applied	\N	\N	\N	\N	187098	187098	354300
24593	38276	0	applied	\N	\N	\N	\N	187151	187151	354353
24593	38278	2	applied	\N	\N	\N	\N	187153	187153	354355
24593	38279	3	applied	\N	\N	\N	\N	187154	187154	354356
24593	38280	4	applied	\N	\N	\N	\N	187155	187155	354357
24593	38281	5	applied	\N	\N	\N	\N	187156	187156	354358
24593	38282	6	applied	\N	\N	\N	\N	187157	187157	354359
24595	38283	0	applied	\N	\N	\N	\N	187165	187165	354367
24595	38284	1	applied	\N	\N	\N	\N	187166	187166	354368
24597	38285	0	applied	\N	\N	\N	\N	187169	187169	354371
24597	38286	1	applied	\N	\N	\N	\N	187170	187170	354372
24602	38290	0	applied	\N	\N	\N	\N	187180	187180	354382
24602	38291	1	applied	\N	\N	\N	\N	187181	187181	354383
24602	38292	2	applied	\N	\N	\N	\N	187182	187182	354384
24604	38293	0	applied	\N	\N	\N	\N	187186	187186	354388
24604	38294	1	applied	\N	\N	\N	\N	187187	187187	354389
24607	38302	0	applied	\N	\N	\N	\N	187197	187197	354399
24607	38303	1	applied	\N	\N	\N	\N	187198	187198	354400
24472	38089	3	applied	\N	\N	\N	\N	186163	186163	353366
24502	37637	61	applied	\N	\N	\N	\N	186304	186304	353507
24502	37640	62	applied	\N	\N	\N	\N	186305	186305	353508
24502	37644	63	applied	\N	\N	\N	\N	186306	186306	353509
24502	37647	64	applied	\N	\N	\N	\N	186307	186307	353510
24502	37648	65	applied	\N	\N	\N	\N	186308	186308	353511
24502	37649	66	applied	\N	\N	\N	\N	186309	186309	353512
24502	37650	67	applied	\N	\N	\N	\N	186310	186310	353513
24502	37660	68	applied	\N	\N	\N	\N	186311	186311	353514
24502	37661	69	applied	\N	\N	\N	\N	186312	186312	353515
24502	37667	70	applied	\N	\N	\N	\N	186313	186313	353516
24502	37675	71	applied	\N	\N	\N	\N	186314	186314	353517
24502	37676	72	applied	\N	\N	\N	\N	186315	186315	353518
24502	37677	73	applied	\N	\N	\N	\N	186316	186316	353519
24502	37678	74	applied	\N	\N	\N	\N	186317	186317	353520
24502	37688	75	applied	\N	\N	\N	\N	186318	186318	353521
24502	37692	76	applied	\N	\N	\N	\N	186319	186319	353522
24502	37698	78	applied	\N	\N	\N	\N	186321	186321	353524
24502	37699	79	applied	\N	\N	\N	\N	186322	186322	353525
24502	37700	80	applied	\N	\N	\N	\N	186323	186323	353526
24502	37710	81	applied	\N	\N	\N	\N	186324	186324	353527
24502	37713	82	applied	\N	\N	\N	\N	186325	186325	353528
24502	37717	83	applied	\N	\N	\N	\N	186326	186326	353529
24502	37722	84	applied	\N	\N	\N	\N	186327	186327	353530
24502	37725	85	applied	\N	\N	\N	\N	186328	186328	353531
24502	37729	86	applied	\N	\N	\N	\N	186329	186329	353532
24502	37732	87	applied	\N	\N	\N	\N	186330	186330	353533
24502	37735	88	applied	\N	\N	\N	\N	186331	186331	353534
24502	37739	89	applied	\N	\N	\N	\N	186332	186332	353535
24502	37742	90	applied	\N	\N	\N	\N	186333	186333	353536
24502	37743	91	applied	\N	\N	\N	\N	186334	186334	353537
24502	37744	92	applied	\N	\N	\N	\N	186335	186335	353538
24502	37752	93	applied	\N	\N	\N	\N	186336	186336	353539
24502	37758	95	applied	\N	\N	\N	\N	186338	186338	353541
24502	37762	96	applied	\N	\N	\N	\N	186339	186339	353542
24502	37765	97	applied	\N	\N	\N	\N	186340	186340	353543
24502	37766	98	applied	\N	\N	\N	\N	186341	186341	353544
24502	37772	99	applied	\N	\N	\N	\N	186342	186342	353545
24502	37775	100	applied	\N	\N	\N	\N	186343	186343	353546
24502	37778	101	applied	\N	\N	\N	\N	186344	186344	353547
24502	37779	102	applied	\N	\N	\N	\N	186345	186345	353548
24502	37780	103	applied	\N	\N	\N	\N	186346	186346	353549
24502	37787	104	applied	\N	\N	\N	\N	186347	186347	353550
24502	37788	105	applied	\N	\N	\N	\N	186348	186348	353551
24502	37794	106	applied	\N	\N	\N	\N	186349	186349	353552
24502	37797	107	applied	\N	\N	\N	\N	186350	186350	353553
24502	37798	108	applied	\N	\N	\N	\N	186351	186351	353554
24502	37804	109	applied	\N	\N	\N	\N	186352	186352	353555
24502	37805	110	applied	\N	\N	\N	\N	186353	186353	353556
24502	37811	112	applied	\N	\N	\N	\N	186355	186355	353558
24502	37812	113	applied	\N	\N	\N	\N	186356	186356	353559
24502	37813	114	applied	\N	\N	\N	\N	186357	186357	353560
24502	37823	115	applied	\N	\N	\N	\N	186358	186358	353561
24502	37827	116	applied	\N	\N	\N	\N	186359	186359	353562
24502	37828	118	applied	\N	\N	\N	\N	186360	186360	353563
24502	37841	119	applied	\N	\N	\N	\N	186361	186361	353564
24502	37844	120	applied	\N	\N	\N	\N	186362	186362	353565
24502	37849	121	applied	\N	\N	\N	\N	186363	186363	353566
24502	37850	122	applied	\N	\N	\N	\N	186364	186364	353567
24502	37851	123	applied	\N	\N	\N	\N	186365	186365	353568
24502	37859	124	applied	\N	\N	\N	\N	186366	186366	353569
24502	37862	125	applied	\N	\N	\N	\N	186367	186367	353570
24504	38141	0	applied	\N	\N	\N	\N	186370	186370	353573
24504	38142	1	applied	\N	\N	\N	\N	186371	186371	353574
24510	38148	0	applied	\N	\N	\N	\N	186383	186383	353586
24514	37906	0	applied	\N	\N	\N	\N	186397	186397	353600
24514	37911	1	applied	\N	\N	\N	\N	186398	186398	353601
24514	37919	2	applied	\N	\N	\N	\N	186399	186399	353602
24514	37932	3	applied	\N	\N	\N	\N	186400	186400	353603
24514	38073	4	applied	\N	\N	\N	\N	186401	186401	353604
24514	38031	5	applied	\N	\N	\N	\N	186402	186402	353605
24514	37823	6	applied	\N	\N	\N	\N	186403	186403	353606
24514	37848	7	applied	\N	\N	\N	\N	186404	186404	353607
24514	38074	8	applied	\N	\N	\N	\N	186405	186405	353608
24514	38075	9	applied	\N	\N	\N	\N	186406	186406	353609
24514	38076	10	applied	\N	\N	\N	\N	186407	186407	353610
24514	37827	11	applied	\N	\N	\N	\N	186408	186408	353611
24514	37828	12	applied	\N	\N	\N	\N	186409	186409	353612
24514	37841	13	applied	\N	\N	\N	\N	186410	186410	353613
24514	37844	14	applied	\N	\N	\N	\N	186411	186411	353614
24514	37849	15	applied	\N	\N	\N	\N	186412	186412	353615
24514	37851	17	applied	\N	\N	\N	\N	186414	186414	353617
24514	37859	18	applied	\N	\N	\N	\N	186415	186415	353618
24514	37862	19	applied	\N	\N	\N	\N	186416	186416	353619
24514	37865	20	applied	\N	\N	\N	\N	186417	186417	353620
24514	37867	21	applied	\N	\N	\N	\N	186418	186418	353621
24514	37870	22	applied	\N	\N	\N	\N	186419	186419	353622
24514	37873	23	applied	\N	\N	\N	\N	186420	186420	353623
24514	37876	24	applied	\N	\N	\N	\N	186421	186421	353624
24514	37877	25	applied	\N	\N	\N	\N	186422	186422	353625
24514	37883	26	applied	\N	\N	\N	\N	186423	186423	353626
24514	37886	27	applied	\N	\N	\N	\N	186424	186424	353627
24514	37887	28	applied	\N	\N	\N	\N	186425	186425	353628
24514	37892	29	applied	\N	\N	\N	\N	186426	186426	353629
24514	37894	30	applied	\N	\N	\N	\N	186427	186427	353630
24514	37896	31	applied	\N	\N	\N	\N	186428	186428	353631
24514	37899	32	applied	\N	\N	\N	\N	186429	186429	353632
24514	37903	34	applied	\N	\N	\N	\N	186431	186431	353634
24514	37907	35	applied	\N	\N	\N	\N	186432	186432	353635
24514	37908	36	applied	\N	\N	\N	\N	186433	186433	353636
24514	37912	37	applied	\N	\N	\N	\N	186434	186434	353637
24514	37913	38	applied	\N	\N	\N	\N	186435	186435	353638
24514	37917	39	applied	\N	\N	\N	\N	186436	186436	353639
24514	37920	40	applied	\N	\N	\N	\N	186437	186437	353640
24514	37921	41	applied	\N	\N	\N	\N	186438	186438	353641
24514	37922	42	applied	\N	\N	\N	\N	186439	186439	353642
24514	37927	43	applied	\N	\N	\N	\N	186440	186440	353643
24514	37929	44	applied	\N	\N	\N	\N	186441	186441	353644
24514	37933	45	applied	\N	\N	\N	\N	186442	186442	353645
24514	37935	46	applied	\N	\N	\N	\N	186443	186443	353646
24514	37936	47	applied	\N	\N	\N	\N	186444	186444	353647
24502	37628	58	applied	\N	\N	\N	\N	186301	186301	353504
24502	37632	59	applied	\N	\N	\N	\N	186302	186302	353505
24514	37940	49	applied	\N	\N	\N	\N	186446	186446	353649
24514	37943	50	applied	\N	\N	\N	\N	186447	186447	353650
24514	37944	51	applied	\N	\N	\N	\N	186448	186448	353651
24514	37945	52	applied	\N	\N	\N	\N	186449	186449	353652
24514	37950	53	applied	\N	\N	\N	\N	186450	186450	353653
24514	37952	55	applied	\N	\N	\N	\N	186451	186451	353654
24514	37955	56	applied	\N	\N	\N	\N	186452	186452	353655
24514	37957	57	applied	\N	\N	\N	\N	186453	186453	353656
24514	37959	58	applied	\N	\N	\N	\N	186454	186454	353657
24514	37962	59	applied	\N	\N	\N	\N	186455	186455	353658
24514	37963	60	applied	\N	\N	\N	\N	186456	186456	353659
24514	37965	61	applied	\N	\N	\N	\N	186457	186457	353660
24514	37967	62	applied	\N	\N	\N	\N	186458	186458	353661
24514	37970	63	applied	\N	\N	\N	\N	186459	186459	353662
24514	37972	64	applied	\N	\N	\N	\N	186460	186460	353663
24514	37978	65	applied	\N	\N	\N	\N	186461	186461	353664
24514	37983	67	applied	\N	\N	\N	\N	186463	186463	353666
24514	37985	68	applied	\N	\N	\N	\N	186464	186464	353667
24514	37988	69	applied	\N	\N	\N	\N	186465	186465	353668
24514	37990	70	applied	\N	\N	\N	\N	186466	186466	353669
24514	37992	71	applied	\N	\N	\N	\N	186467	186467	353670
24514	37993	72	applied	\N	\N	\N	\N	186468	186468	353671
24514	37994	73	applied	\N	\N	\N	\N	186469	186469	353672
24514	37999	74	applied	\N	\N	\N	\N	186470	186470	353673
24514	38001	75	applied	\N	\N	\N	\N	186471	186471	353674
24514	38004	76	applied	\N	\N	\N	\N	186472	186472	353675
24514	38005	77	applied	\N	\N	\N	\N	186473	186473	353676
24514	38008	78	applied	\N	\N	\N	\N	186474	186474	353677
24514	38009	79	applied	\N	\N	\N	\N	186475	186475	353678
24518	38162	0	applied	\N	\N	\N	\N	186566	186566	353768
24518	38163	1	applied	\N	\N	\N	\N	186567	186567	353769
24525	37906	0	applied	\N	\N	\N	\N	186580	186580	353782
24525	37919	2	applied	\N	\N	\N	\N	186582	186582	353784
24525	37932	3	applied	\N	\N	\N	\N	186583	186583	353785
24525	38073	4	applied	\N	\N	\N	\N	186584	186584	353786
24525	38031	5	applied	\N	\N	\N	\N	186585	186585	353787
24525	37848	6	applied	\N	\N	\N	\N	186586	186586	353788
24525	38074	7	applied	\N	\N	\N	\N	186587	186587	353789
24525	38075	8	applied	\N	\N	\N	\N	186588	186588	353790
24525	38076	9	applied	\N	\N	\N	\N	186589	186589	353791
24525	37739	10	applied	\N	\N	\N	\N	186590	186590	353792
24525	37742	11	applied	\N	\N	\N	\N	186591	186591	353793
24525	37743	12	applied	\N	\N	\N	\N	186592	186592	353794
24525	37744	13	applied	\N	\N	\N	\N	186593	186593	353795
24525	37752	14	applied	\N	\N	\N	\N	186594	186594	353796
24525	37753	15	applied	\N	\N	\N	\N	186595	186595	353797
24525	37758	16	applied	\N	\N	\N	\N	186596	186596	353798
24525	37762	17	applied	\N	\N	\N	\N	186597	186597	353799
24525	37766	19	applied	\N	\N	\N	\N	186599	186599	353801
24525	37772	20	applied	\N	\N	\N	\N	186600	186600	353802
24525	37775	21	applied	\N	\N	\N	\N	186601	186601	353803
24525	37778	22	applied	\N	\N	\N	\N	186602	186602	353804
24525	37779	23	applied	\N	\N	\N	\N	186603	186603	353805
24525	37780	24	applied	\N	\N	\N	\N	186604	186604	353806
24525	37787	25	applied	\N	\N	\N	\N	186605	186605	353807
24525	37788	26	applied	\N	\N	\N	\N	186606	186606	353808
24525	37794	27	applied	\N	\N	\N	\N	186607	186607	353809
24525	37797	28	applied	\N	\N	\N	\N	186608	186608	353810
24525	37798	29	applied	\N	\N	\N	\N	186609	186609	353811
24525	37804	30	applied	\N	\N	\N	\N	186610	186610	353812
24525	37805	31	applied	\N	\N	\N	\N	186611	186611	353813
24525	37810	32	applied	\N	\N	\N	\N	186612	186612	353814
24525	37811	33	applied	\N	\N	\N	\N	186613	186613	353815
24525	37812	34	applied	\N	\N	\N	\N	186614	186614	353816
24525	37823	36	applied	\N	\N	\N	\N	186616	186616	353818
24525	37827	37	applied	\N	\N	\N	\N	186617	186617	353819
24525	37828	38	applied	\N	\N	\N	\N	186618	186618	353820
24525	37841	40	applied	\N	\N	\N	\N	186619	186619	353821
24525	37844	41	applied	\N	\N	\N	\N	186620	186620	353822
24525	37849	42	applied	\N	\N	\N	\N	186621	186621	353823
24525	37850	43	applied	\N	\N	\N	\N	186622	186622	353824
24525	37851	44	applied	\N	\N	\N	\N	186623	186623	353825
24525	37859	45	applied	\N	\N	\N	\N	186624	186624	353826
24525	37862	46	applied	\N	\N	\N	\N	186625	186625	353827
24525	37865	47	applied	\N	\N	\N	\N	186626	186626	353828
24525	37867	48	applied	\N	\N	\N	\N	186627	186627	353829
24525	37870	49	applied	\N	\N	\N	\N	186628	186628	353830
24525	37873	50	applied	\N	\N	\N	\N	186629	186629	353831
24525	37876	51	applied	\N	\N	\N	\N	186630	186630	353832
24525	37877	52	applied	\N	\N	\N	\N	186631	186631	353833
24525	37886	54	applied	\N	\N	\N	\N	186633	186633	353835
24525	37887	55	applied	\N	\N	\N	\N	186634	186634	353836
24525	37892	56	applied	\N	\N	\N	\N	186635	186635	353837
24525	37894	57	applied	\N	\N	\N	\N	186636	186636	353838
24525	37896	58	applied	\N	\N	\N	\N	186637	186637	353839
24525	37899	59	applied	\N	\N	\N	\N	186638	186638	353840
24525	37901	60	applied	\N	\N	\N	\N	186639	186639	353841
24525	37903	61	applied	\N	\N	\N	\N	186640	186640	353842
24525	37907	62	applied	\N	\N	\N	\N	186641	186641	353843
24525	37908	63	applied	\N	\N	\N	\N	186642	186642	353844
24525	37912	64	applied	\N	\N	\N	\N	186643	186643	353845
24525	37913	65	applied	\N	\N	\N	\N	186644	186644	353846
24525	37917	66	applied	\N	\N	\N	\N	186645	186645	353847
24525	37920	67	applied	\N	\N	\N	\N	186646	186646	353848
24525	37921	68	applied	\N	\N	\N	\N	186647	186647	353849
24525	37922	69	applied	\N	\N	\N	\N	186648	186648	353850
24525	37929	71	applied	\N	\N	\N	\N	186650	186650	353852
24525	37933	72	applied	\N	\N	\N	\N	186651	186651	353853
24525	37935	73	applied	\N	\N	\N	\N	186652	186652	353854
24525	37936	74	applied	\N	\N	\N	\N	186653	186653	353855
24525	37939	75	applied	\N	\N	\N	\N	186654	186654	353856
24525	37940	76	applied	\N	\N	\N	\N	186655	186655	353857
24525	37943	77	applied	\N	\N	\N	\N	186656	186656	353858
24525	37944	78	applied	\N	\N	\N	\N	186657	186657	353859
24525	37945	79	applied	\N	\N	\N	\N	186658	186658	353860
24525	37950	80	applied	\N	\N	\N	\N	186659	186659	353861
24525	37952	81	applied	\N	\N	\N	\N	186660	186660	353862
24525	37955	82	applied	\N	\N	\N	\N	186661	186661	353863
24525	37957	83	applied	\N	\N	\N	\N	186662	186662	353864
24525	37959	84	applied	\N	\N	\N	\N	186663	186663	353865
24513	38153	3	applied	\N	\N	\N	\N	186395	186395	353598
24513	38154	4	applied	\N	\N	\N	\N	186396	186396	353599
24514	38020	83	applied	\N	\N	\N	\N	186479	186479	353682
24514	38022	84	applied	\N	\N	\N	\N	186480	186480	353683
24514	38023	85	applied	\N	\N	\N	\N	186481	186481	353684
24514	38024	86	applied	\N	\N	\N	\N	186482	186482	353685
24514	38029	87	applied	\N	\N	\N	\N	186483	186483	353686
24514	38032	88	applied	\N	\N	\N	\N	186484	186484	353687
24514	38035	89	applied	\N	\N	\N	\N	186485	186485	353688
24514	38039	91	applied	\N	\N	\N	\N	186487	186487	353690
24514	38041	92	applied	\N	\N	\N	\N	186488	186488	353691
24514	38044	93	applied	\N	\N	\N	\N	186489	186489	353692
24514	38045	94	applied	\N	\N	\N	\N	186490	186490	353693
24514	38048	95	applied	\N	\N	\N	\N	186491	186491	353694
24514	38051	96	applied	\N	\N	\N	\N	186492	186492	353695
24514	38052	97	applied	\N	\N	\N	\N	186493	186493	353696
24514	38054	98	applied	\N	\N	\N	\N	186494	186494	353697
24514	38057	99	applied	\N	\N	\N	\N	186495	186495	353698
24514	38058	100	applied	\N	\N	\N	\N	186496	186496	353699
24514	38061	101	applied	\N	\N	\N	\N	186497	186497	353700
24514	38063	102	applied	\N	\N	\N	\N	186498	186498	353701
24514	38066	103	applied	\N	\N	\N	\N	186499	186499	353702
24514	38067	104	applied	\N	\N	\N	\N	186500	186500	353703
24514	38068	105	applied	\N	\N	\N	\N	186501	186501	353704
24514	38077	106	applied	\N	\N	\N	\N	186502	186502	353705
24514	38081	108	applied	\N	\N	\N	\N	186504	186504	353707
24514	38084	109	applied	\N	\N	\N	\N	186505	186505	353708
24514	38086	110	applied	\N	\N	\N	\N	186506	186506	353709
24514	38087	111	applied	\N	\N	\N	\N	186507	186507	353710
24514	38090	112	applied	\N	\N	\N	\N	186508	186508	353711
24514	38093	113	applied	\N	\N	\N	\N	186509	186509	353712
24514	38095	114	applied	\N	\N	\N	\N	186510	186510	353713
24514	38096	115	applied	\N	\N	\N	\N	186511	186511	353714
24514	38100	116	applied	\N	\N	\N	\N	186512	186512	353715
24514	38102	117	applied	\N	\N	\N	\N	186513	186513	353716
24514	38104	118	applied	\N	\N	\N	\N	186514	186514	353717
24514	38105	119	applied	\N	\N	\N	\N	186515	186515	353718
24514	38109	120	applied	\N	\N	\N	\N	186516	186516	353719
24514	38110	121	applied	\N	\N	\N	\N	186517	186517	353720
24514	38113	122	applied	\N	\N	\N	\N	186518	186518	353721
24514	38116	123	applied	\N	\N	\N	\N	186519	186519	353722
24514	38120	125	applied	\N	\N	\N	\N	186521	186521	353724
24516	38155	0	applied	\N	\N	\N	\N	186529	186529	353732
24516	38156	1	applied	\N	\N	\N	\N	186530	186530	353733
24516	38157	2	applied	\N	\N	\N	\N	186531	186531	353734
24516	38158	3	applied	\N	\N	\N	\N	186532	186532	353735
24516	38159	4	applied	\N	\N	\N	\N	186533	186533	353736
24516	38160	5	applied	\N	\N	\N	\N	186534	186534	353737
24516	38161	6	applied	\N	\N	\N	\N	186535	186535	353738
24517	37906	0	applied	\N	\N	\N	\N	186536	186536	353739
24517	37911	1	applied	\N	\N	\N	\N	186537	186537	353740
24517	37919	2	applied	\N	\N	\N	\N	186538	186538	353741
24517	37932	3	applied	\N	\N	\N	\N	186539	186539	353742
24517	38073	4	applied	\N	\N	\N	\N	186540	186540	353743
24517	38031	5	applied	\N	\N	\N	\N	186541	186541	353744
24517	37721	7	applied	\N	\N	\N	\N	186543	186543	353746
24517	37848	8	applied	\N	\N	\N	\N	186544	186544	353747
24517	38074	9	applied	\N	\N	\N	\N	186545	186545	353748
24517	38075	10	applied	\N	\N	\N	\N	186546	186546	353749
24517	38076	11	applied	\N	\N	\N	\N	186547	186547	353750
24517	37668	12	applied	\N	\N	\N	\N	186548	186548	353751
24517	37669	13	applied	\N	\N	\N	\N	186549	186549	353752
24517	37670	14	applied	\N	\N	\N	\N	186550	186550	353753
24517	37671	15	applied	\N	\N	\N	\N	186551	186551	353754
24517	37672	16	applied	\N	\N	\N	\N	186552	186552	353755
24517	37696	18	applied	\N	\N	\N	\N	186554	186554	353756
24517	37829	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	186553	186553	\N
24517	37974	19	applied	\N	\N	\N	\N	186555	186555	353757
24517	37975	20	applied	\N	\N	\N	\N	186556	186556	353758
24517	37976	21	applied	\N	\N	\N	\N	186557	186557	353759
24517	37977	22	applied	\N	\N	\N	\N	186558	186558	353760
24517	37654	23	applied	\N	\N	\N	\N	186559	186559	353761
24517	37664	24	applied	\N	\N	\N	\N	186560	186560	353762
24517	37679	25	applied	\N	\N	\N	\N	186561	186561	353763
24517	37691	26	applied	\N	\N	\N	\N	186562	186562	353764
24517	37715	28	applied	\N	\N	\N	\N	186564	186564	353766
24517	37728	29	applied	\N	\N	\N	\N	186565	186565	353767
24520	38162	0	applied	\N	\N	\N	\N	186570	186570	353772
24520	38163	1	applied	\N	\N	\N	\N	186571	186571	353773
24523	38162	0	applied	\N	\N	\N	\N	186576	186576	353778
24523	38163	1	applied	\N	\N	\N	\N	186577	186577	353779
24525	37962	85	applied	\N	\N	\N	\N	186664	186664	353866
24525	37963	86	applied	\N	\N	\N	\N	186665	186665	353867
24525	37965	87	applied	\N	\N	\N	\N	186666	186666	353868
24525	37967	88	applied	\N	\N	\N	\N	186667	186667	353869
24525	37970	89	applied	\N	\N	\N	\N	186668	186668	353870
24525	37972	90	applied	\N	\N	\N	\N	186669	186669	353871
24525	37978	91	applied	\N	\N	\N	\N	186670	186670	353872
24525	37982	92	applied	\N	\N	\N	\N	186671	186671	353873
24525	37983	93	applied	\N	\N	\N	\N	186672	186672	353874
24525	37985	94	applied	\N	\N	\N	\N	186673	186673	353875
24525	37990	96	applied	\N	\N	\N	\N	186675	186675	353877
24525	37992	97	applied	\N	\N	\N	\N	186676	186676	353878
24525	37993	98	applied	\N	\N	\N	\N	186677	186677	353879
24525	37994	99	applied	\N	\N	\N	\N	186678	186678	353880
24525	37999	100	applied	\N	\N	\N	\N	186679	186679	353881
24525	38001	101	applied	\N	\N	\N	\N	186680	186680	353882
24525	38004	102	applied	\N	\N	\N	\N	186681	186681	353883
24525	38005	103	applied	\N	\N	\N	\N	186682	186682	353884
24525	38008	104	applied	\N	\N	\N	\N	186683	186683	353885
24525	38009	105	applied	\N	\N	\N	\N	186684	186684	353886
24525	38010	106	applied	\N	\N	\N	\N	186685	186685	353887
24525	38015	107	applied	\N	\N	\N	\N	186686	186686	353888
24525	38017	108	applied	\N	\N	\N	\N	186687	186687	353889
24525	38020	109	applied	\N	\N	\N	\N	186688	186688	353890
24525	38022	110	applied	\N	\N	\N	\N	186689	186689	353891
24525	38023	111	applied	\N	\N	\N	\N	186690	186690	353892
24525	38029	113	applied	\N	\N	\N	\N	186692	186692	353894
24525	38032	114	applied	\N	\N	\N	\N	186693	186693	353895
24525	38035	115	applied	\N	\N	\N	\N	186694	186694	353896
24527	38073	0	applied	\N	\N	\N	\N	186707	186707	353909
24514	38015	81	applied	\N	\N	\N	\N	186477	186477	353680
24514	38017	82	applied	\N	\N	\N	\N	186478	186478	353681
24525	38045	120	applied	\N	\N	\N	\N	186699	186699	353901
24525	38048	121	applied	\N	\N	\N	\N	186700	186700	353902
24525	38051	122	applied	\N	\N	\N	\N	186701	186701	353903
24525	38052	123	applied	\N	\N	\N	\N	186702	186702	353904
24525	38054	124	applied	\N	\N	\N	\N	186703	186703	353905
24525	38057	125	applied	\N	\N	\N	\N	186704	186704	353906
24527	38074	1	applied	\N	\N	\N	\N	186708	186708	353910
24527	38075	2	applied	\N	\N	\N	\N	186709	186709	353911
24527	38076	3	applied	\N	\N	\N	\N	186710	186710	353912
24527	38037	4	applied	\N	\N	\N	\N	186711	186711	353913
24527	38039	5	applied	\N	\N	\N	\N	186712	186712	353914
24527	38041	6	applied	\N	\N	\N	\N	186713	186713	353915
24527	38044	7	applied	\N	\N	\N	\N	186714	186714	353916
24527	38045	8	applied	\N	\N	\N	\N	186715	186715	353917
24527	38048	9	applied	\N	\N	\N	\N	186716	186716	353918
24527	38043	10	applied	\N	\N	\N	\N	186717	186717	353919
24527	38055	12	applied	\N	\N	\N	\N	186719	186719	353921
24527	38064	13	applied	\N	\N	\N	\N	186720	186720	353922
24527	38038	14	applied	\N	\N	\N	\N	186721	186721	353923
24527	38040	15	applied	\N	\N	\N	\N	186722	186722	353924
24527	38042	16	applied	\N	\N	\N	\N	186723	186723	353925
24527	38046	17	applied	\N	\N	\N	\N	186724	186724	353926
24527	38072	18	applied	\N	\N	\N	\N	186725	186725	353927
24527	38082	19	applied	\N	\N	\N	\N	186726	186726	353928
24527	38092	20	applied	\N	\N	\N	\N	186727	186727	353929
24527	38097	21	applied	\N	\N	\N	\N	186728	186728	353930
24527	38106	22	applied	\N	\N	\N	\N	186729	186729	353931
24527	38114	23	applied	\N	\N	\N	\N	186730	186730	353932
24527	38121	24	applied	\N	\N	\N	\N	186731	186731	353933
24527	38131	25	applied	\N	\N	\N	\N	186732	186732	353934
24527	38138	26	applied	\N	\N	\N	\N	186733	186733	353935
24527	38146	27	applied	\N	\N	\N	\N	186734	186734	353936
24527	38158	29	applied	\N	\N	\N	\N	186736	186736	353938
24527	38047	30	applied	\N	\N	\N	\N	186737	186737	353939
24527	38049	31	applied	\N	\N	\N	\N	186738	186738	353940
24528	38162	0	applied	\N	\N	\N	\N	186786	186786	353988
24528	38163	1	applied	\N	\N	\N	\N	186787	186787	353989
24529	38164	0	applied	\N	\N	\N	\N	186788	186788	353990
24529	38165	1	applied	\N	\N	\N	\N	186789	186789	353991
24529	38166	2	applied	\N	\N	\N	\N	186790	186790	353992
24529	38167	3	applied	\N	\N	\N	\N	186791	186791	353993
24529	38168	4	applied	\N	\N	\N	\N	186792	186792	353994
24531	38169	0	applied	\N	\N	\N	\N	186793	186793	353995
24531	38170	1	applied	\N	\N	\N	\N	186794	186794	353996
24535	38162	0	applied	\N	\N	\N	\N	186806	186806	354008
24535	38164	1	applied	\N	\N	\N	\N	186807	186807	354009
24535	38165	2	applied	\N	\N	\N	\N	186808	186808	354010
24535	38169	3	applied	\N	\N	\N	\N	186809	186809	354011
24535	38173	5	applied	\N	\N	\N	\N	186811	186811	354013
24535	38174	6	applied	\N	\N	\N	\N	186812	186812	354014
24535	38178	7	applied	\N	\N	\N	\N	186813	186813	354015
24535	38179	8	applied	\N	\N	\N	\N	186814	186814	354016
24535	38163	9	applied	\N	\N	\N	\N	186815	186815	354017
24535	38166	10	applied	\N	\N	\N	\N	186816	186816	354018
24535	38176	11	applied	\N	\N	\N	\N	186817	186817	354019
24535	38167	12	applied	\N	\N	\N	\N	186818	186818	354020
24535	38168	13	applied	\N	\N	\N	\N	186819	186819	354021
24535	38170	14	applied	\N	\N	\N	\N	186820	186820	354022
24535	38172	15	applied	\N	\N	\N	\N	186821	186821	354023
24535	38175	16	applied	\N	\N	\N	\N	186822	186822	354024
24535	38177	17	applied	\N	\N	\N	\N	186823	186823	354025
24535	38180	18	applied	\N	\N	\N	\N	186824	186824	354026
24535	38181	19	applied	\N	\N	\N	\N	186825	186825	354027
24549	38200	0	applied	\N	\N	\N	\N	186862	186862	354064
24553	38202	0	applied	\N	\N	\N	\N	186868	186868	354070
24553	38203	1	applied	\N	\N	\N	\N	186869	186869	354071
24556	38204	0	applied	\N	\N	\N	\N	186877	186877	354079
24556	38205	1	applied	\N	\N	\N	\N	186878	186878	354080
24556	38206	2	applied	\N	\N	\N	\N	186879	186879	354081
24556	38207	3	applied	\N	\N	\N	\N	186880	186880	354082
24556	38208	4	applied	\N	\N	\N	\N	186881	186881	354083
24560	38214	0	applied	\N	\N	\N	\N	187012	187012	354214
24565	38221	0	applied	\N	\N	\N	\N	187022	187022	354224
24565	38222	1	applied	\N	\N	\N	\N	187023	187023	354225
24569	38223	0	applied	\N	\N	\N	\N	187036	187036	354238
24569	38224	1	applied	\N	\N	\N	\N	187037	187037	354239
24569	38225	2	applied	\N	\N	\N	\N	187038	187038	354240
24569	38226	3	applied	\N	\N	\N	\N	187039	187039	354241
24573	38230	0	applied	\N	\N	\N	\N	187056	187056	354258
24573	38231	1	applied	\N	\N	\N	\N	187057	187057	354259
24573	38233	3	applied	\N	\N	\N	\N	187059	187059	354261
24573	38234	4	applied	\N	\N	\N	\N	187060	187060	354262
24573	38235	5	applied	\N	\N	\N	\N	187061	187061	354263
24573	38236	6	applied	\N	\N	\N	\N	187062	187062	354264
24573	38237	7	applied	\N	\N	\N	\N	187063	187063	354265
24573	38238	8	applied	\N	\N	\N	\N	187064	187064	354266
24581	38256	0	applied	\N	\N	\N	\N	187087	187087	354289
24581	38257	1	applied	\N	\N	\N	\N	187088	187088	354290
24581	38258	2	applied	\N	\N	\N	\N	187089	187089	354291
24581	38259	3	applied	\N	\N	\N	\N	187090	187090	354292
24581	38260	4	applied	\N	\N	\N	\N	187091	187091	354293
24585	38261	0	applied	\N	\N	\N	\N	187113	187113	354315
24585	38262	1	applied	\N	\N	\N	\N	187114	187114	354316
24585	38263	2	applied	\N	\N	\N	\N	187115	187115	354317
24585	38264	3	applied	\N	\N	\N	\N	187116	187116	354318
24585	38265	4	applied	\N	\N	\N	\N	187117	187117	354319
24585	38267	7	applied	\N	\N	\N	\N	187119	187119	354321
24587	38261	0	applied	\N	\N	\N	\N	187127	187127	354329
24587	38262	1	applied	\N	\N	\N	\N	187128	187128	354330
24587	38263	2	applied	\N	\N	\N	\N	187129	187129	354331
24587	38264	3	applied	\N	\N	\N	\N	187130	187130	354332
24587	38265	4	applied	\N	\N	\N	\N	187131	187131	354333
24587	38266	6	applied	\N	\N	\N	\N	187132	187132	354334
24587	38267	7	applied	\N	\N	\N	\N	187133	187133	354335
24592	38276	0	applied	\N	\N	\N	\N	187144	187144	354346
24592	38277	1	applied	\N	\N	\N	\N	187145	187145	354347
24592	38278	2	applied	\N	\N	\N	\N	187146	187146	354348
24592	38279	3	applied	\N	\N	\N	\N	187147	187147	354349
24592	38280	4	applied	\N	\N	\N	\N	187148	187148	354350
24592	38281	5	applied	\N	\N	\N	\N	187149	187149	354351
24525	38039	117	applied	\N	\N	\N	\N	186696	186696	353898
24525	38041	118	applied	\N	\N	\N	\N	186697	186697	353899
24527	38062	36	applied	\N	\N	\N	\N	186743	186743	353945
24527	38065	37	applied	\N	\N	\N	\N	186744	186744	353946
24527	38069	38	applied	\N	\N	\N	\N	186745	186745	353947
24527	38070	39	applied	\N	\N	\N	\N	186746	186746	353948
24527	38071	40	applied	\N	\N	\N	\N	186747	186747	353949
24527	38079	41	applied	\N	\N	\N	\N	186748	186748	353950
24527	38080	42	applied	\N	\N	\N	\N	186749	186749	353951
24527	38083	43	applied	\N	\N	\N	\N	186750	186750	353952
24527	38085	44	applied	\N	\N	\N	\N	186751	186751	353953
24527	38088	45	applied	\N	\N	\N	\N	186752	186752	353954
24527	38089	46	applied	\N	\N	\N	\N	186753	186753	353955
24527	38091	47	applied	\N	\N	\N	\N	186754	186754	353956
24527	38094	48	applied	\N	\N	\N	\N	186755	186755	353957
24527	38098	49	applied	\N	\N	\N	\N	186756	186756	353958
24527	38099	50	applied	\N	\N	\N	\N	186757	186757	353959
24527	38101	51	applied	\N	\N	\N	\N	186758	186758	353960
24527	38107	53	applied	\N	\N	\N	\N	186760	186760	353962
24527	38108	54	applied	\N	\N	\N	\N	186761	186761	353963
24527	38111	55	applied	\N	\N	\N	\N	186762	186762	353964
24527	38112	56	applied	\N	\N	\N	\N	186763	186763	353965
24527	38115	57	applied	\N	\N	\N	\N	186764	186764	353966
24527	38118	58	applied	\N	\N	\N	\N	186765	186765	353967
24527	38119	59	applied	\N	\N	\N	\N	186766	186766	353968
24527	38122	60	applied	\N	\N	\N	\N	186767	186767	353969
24527	38124	61	applied	\N	\N	\N	\N	186768	186768	353970
24527	38126	62	applied	\N	\N	\N	\N	186769	186769	353971
24527	38129	63	applied	\N	\N	\N	\N	186770	186770	353972
24527	38130	64	applied	\N	\N	\N	\N	186771	186771	353973
24527	38133	65	applied	\N	\N	\N	\N	186772	186772	353974
24527	38135	66	applied	\N	\N	\N	\N	186773	186773	353975
24527	38137	67	applied	\N	\N	\N	\N	186774	186774	353976
24527	38140	68	applied	\N	\N	\N	\N	186775	186775	353977
24527	38145	70	applied	\N	\N	\N	\N	186777	186777	353979
24527	38147	71	applied	\N	\N	\N	\N	186778	186778	353980
24527	38149	72	applied	\N	\N	\N	\N	186779	186779	353981
24527	38153	73	applied	\N	\N	\N	\N	186780	186780	353982
24527	38154	74	applied	\N	\N	\N	\N	186781	186781	353983
24527	38159	75	applied	\N	\N	\N	\N	186782	186782	353984
24527	38160	76	applied	\N	\N	\N	\N	186783	186783	353985
24527	38161	77	applied	\N	\N	\N	\N	186784	186784	353986
24527	38163	78	applied	\N	\N	\N	\N	186785	186785	353987
24533	38173	0	applied	\N	\N	\N	\N	186797	186797	353999
24533	38174	1	applied	\N	\N	\N	\N	186798	186798	354000
24533	38175	2	applied	\N	\N	\N	\N	186799	186799	354001
24533	38176	3	applied	\N	\N	\N	\N	186800	186800	354002
24533	38177	4	applied	\N	\N	\N	\N	186801	186801	354003
24541	38191	0	applied	\N	\N	\N	\N	186847	186847	354049
24541	38192	1	applied	\N	\N	\N	\N	186848	186848	354050
24541	38194	3	applied	\N	\N	\N	\N	186850	186850	354052
24551	38200	0	applied	\N	\N	\N	\N	186866	186866	354068
24551	38201	1	applied	\N	\N	\N	\N	186867	186867	354069
24559	38211	0	applied	\N	\N	\N	\N	187009	187009	354211
24559	38212	1	applied	\N	\N	\N	\N	187010	187010	354212
24559	38213	2	applied	\N	\N	\N	\N	187011	187011	354213
24564	38221	0	applied	\N	\N	\N	\N	187020	187020	354222
24564	38222	1	applied	\N	\N	\N	\N	187021	187021	354223
24567	38223	0	applied	\N	\N	\N	\N	187028	187028	354230
24567	38224	1	applied	\N	\N	\N	\N	187029	187029	354231
24567	38225	2	applied	\N	\N	\N	\N	187030	187030	354232
24567	38226	3	applied	\N	\N	\N	\N	187031	187031	354233
24574	38239	0	applied	\N	\N	\N	\N	187065	187065	354267
24574	38240	1	applied	\N	\N	\N	\N	187066	187066	354268
24576	38241	0	applied	\N	\N	\N	\N	187069	187069	354271
24576	38242	1	applied	\N	\N	\N	\N	187070	187070	354272
24583	38261	0	applied	\N	\N	\N	\N	187099	187099	354301
24583	38262	1	applied	\N	\N	\N	\N	187100	187100	354302
24583	38263	2	applied	\N	\N	\N	\N	187101	187101	354303
24583	38264	3	applied	\N	\N	\N	\N	187102	187102	354304
24583	38265	4	applied	\N	\N	\N	\N	187103	187103	354305
24583	38266	6	applied	\N	\N	\N	\N	187104	187104	354306
24583	38267	7	applied	\N	\N	\N	\N	187105	187105	354307
24588	38268	0	applied	\N	\N	\N	\N	187134	187134	354336
24588	38269	1	applied	\N	\N	\N	\N	187135	187135	354337
24590	38270	0	applied	\N	\N	\N	\N	187138	187138	354340
24590	38271	1	applied	\N	\N	\N	\N	187139	187139	354341
24590	38272	2	applied	\N	\N	\N	\N	187140	187140	354342
24590	38273	3	applied	\N	\N	\N	\N	187141	187141	354343
24590	38274	4	applied	\N	\N	\N	\N	187142	187142	354344
24590	38275	5	applied	\N	\N	\N	\N	187143	187143	354345
24592	38282	6	applied	\N	\N	\N	\N	187150	187150	354352
24600	38287	0	applied	\N	\N	\N	\N	187174	187174	354376
24600	38288	1	applied	\N	\N	\N	\N	187175	187175	354377
24606	38295	0	applied	\N	\N	\N	\N	187190	187190	354392
24606	38296	1	applied	\N	\N	\N	\N	187191	187191	354393
24606	38297	2	applied	\N	\N	\N	\N	187192	187192	354394
24606	38298	3	applied	\N	\N	\N	\N	187193	187193	354395
24606	38299	4	applied	\N	\N	\N	\N	187194	187194	354396
24606	38300	5	applied	\N	\N	\N	\N	187195	187195	354397
24606	38301	6	applied	\N	\N	\N	\N	187196	187196	354398
24611	38302	0	applied	\N	\N	\N	\N	187209	187209	354411
24611	38303	1	applied	\N	\N	\N	\N	187210	187210	354412
24611	38304	2	applied	\N	\N	\N	\N	187211	187211	354413
24615	38305	0	applied	\N	\N	\N	\N	187221	187221	354423
24615	38306	1	applied	\N	\N	\N	\N	187222	187222	354424
24615	38307	2	applied	\N	\N	\N	\N	187223	187223	354425
24621	38328	0	applied	\N	\N	\N	\N	187266	187266	354468
24621	38330	2	applied	\N	\N	\N	\N	187268	187268	354470
24626	38328	0	applied	\N	\N	\N	\N	187283	187283	354485
24626	38329	1	applied	\N	\N	\N	\N	187284	187284	354486
24626	38330	2	applied	\N	\N	\N	\N	187285	187285	354487
24628	38335	0	applied	\N	\N	\N	\N	187290	187290	354492
24628	38336	1	applied	\N	\N	\N	\N	187291	187291	354493
24628	38337	2	applied	\N	\N	\N	\N	187292	187292	354494
24628	38338	3	applied	\N	\N	\N	\N	187293	187293	354495
24628	38339	4	applied	\N	\N	\N	\N	187294	187294	354496
24628	38340	5	applied	\N	\N	\N	\N	187295	187295	354497
24628	38341	6	applied	\N	\N	\N	\N	187296	187296	354498
24628	38342	7	applied	\N	\N	\N	\N	187297	187297	354499
24628	38343	8	applied	\N	\N	\N	\N	187298	187298	354500
24628	38344	9	applied	\N	\N	\N	\N	187299	187299	354501
24527	38056	33	applied	\N	\N	\N	\N	186740	186740	353942
24527	38059	34	applied	\N	\N	\N	\N	186741	186741	353943
24557	37983	46	applied	\N	\N	\N	\N	186928	186928	354130
24557	37985	47	applied	\N	\N	\N	\N	186929	186929	354131
24557	37988	48	applied	\N	\N	\N	\N	186930	186930	354132
24557	37990	49	applied	\N	\N	\N	\N	186931	186931	354133
24557	37992	50	applied	\N	\N	\N	\N	186932	186932	354134
24557	37993	51	applied	\N	\N	\N	\N	186933	186933	354135
24557	37994	52	applied	\N	\N	\N	\N	186934	186934	354136
24557	37999	53	applied	\N	\N	\N	\N	186935	186935	354137
24557	38001	54	applied	\N	\N	\N	\N	186936	186936	354138
24557	38004	55	applied	\N	\N	\N	\N	186937	186937	354139
24557	38005	56	applied	\N	\N	\N	\N	186938	186938	354140
24557	38008	57	applied	\N	\N	\N	\N	186939	186939	354141
24557	38009	58	applied	\N	\N	\N	\N	186940	186940	354142
24557	38010	59	applied	\N	\N	\N	\N	186941	186941	354143
24557	38015	60	applied	\N	\N	\N	\N	186942	186942	354144
24557	38017	61	applied	\N	\N	\N	\N	186943	186943	354145
24557	38022	63	applied	\N	\N	\N	\N	186945	186945	354147
24557	38023	64	applied	\N	\N	\N	\N	186946	186946	354148
24557	38024	65	applied	\N	\N	\N	\N	186947	186947	354149
24557	38029	66	applied	\N	\N	\N	\N	186948	186948	354150
24557	38032	67	applied	\N	\N	\N	\N	186949	186949	354151
24557	38035	68	applied	\N	\N	\N	\N	186950	186950	354152
24557	38037	69	applied	\N	\N	\N	\N	186951	186951	354153
24557	38039	70	applied	\N	\N	\N	\N	186952	186952	354154
24557	38041	71	applied	\N	\N	\N	\N	186953	186953	354155
24557	38044	72	applied	\N	\N	\N	\N	186954	186954	354156
24557	38045	73	applied	\N	\N	\N	\N	186955	186955	354157
24557	38048	74	applied	\N	\N	\N	\N	186956	186956	354158
24557	38051	75	applied	\N	\N	\N	\N	186957	186957	354159
24557	38052	76	applied	\N	\N	\N	\N	186958	186958	354160
24557	38054	77	applied	\N	\N	\N	\N	186959	186959	354161
24557	38057	78	applied	\N	\N	\N	\N	186960	186960	354162
24557	38061	80	applied	\N	\N	\N	\N	186962	186962	354164
24557	38063	81	applied	\N	\N	\N	\N	186963	186963	354165
24557	38066	82	applied	\N	\N	\N	\N	186964	186964	354166
24557	38067	83	applied	\N	\N	\N	\N	186965	186965	354167
24557	38068	84	applied	\N	\N	\N	\N	186966	186966	354168
24557	38077	85	applied	\N	\N	\N	\N	186967	186967	354169
24557	38078	86	applied	\N	\N	\N	\N	186968	186968	354170
24557	38081	87	applied	\N	\N	\N	\N	186969	186969	354171
24557	38084	88	applied	\N	\N	\N	\N	186970	186970	354172
24557	38086	89	applied	\N	\N	\N	\N	186971	186971	354173
24557	38087	90	applied	\N	\N	\N	\N	186972	186972	354174
24557	38090	91	applied	\N	\N	\N	\N	186973	186973	354175
24557	38093	92	applied	\N	\N	\N	\N	186974	186974	354176
24557	38095	93	applied	\N	\N	\N	\N	186975	186975	354177
24557	38096	94	applied	\N	\N	\N	\N	186976	186976	354178
24557	38100	95	applied	\N	\N	\N	\N	186977	186977	354179
24557	38104	97	applied	\N	\N	\N	\N	186979	186979	354181
24557	38105	98	applied	\N	\N	\N	\N	186980	186980	354182
24557	38109	99	applied	\N	\N	\N	\N	186981	186981	354183
24557	38110	100	applied	\N	\N	\N	\N	186982	186982	354184
24557	38113	101	applied	\N	\N	\N	\N	186983	186983	354185
24557	38116	102	applied	\N	\N	\N	\N	186984	186984	354186
24557	38117	103	applied	\N	\N	\N	\N	186985	186985	354187
24557	38120	104	applied	\N	\N	\N	\N	186986	186986	354188
24557	38123	105	applied	\N	\N	\N	\N	186987	186987	354189
24557	38125	106	applied	\N	\N	\N	\N	186988	186988	354190
24557	38127	107	applied	\N	\N	\N	\N	186989	186989	354191
24557	38128	108	applied	\N	\N	\N	\N	186990	186990	354192
24557	38132	109	applied	\N	\N	\N	\N	186991	186991	354193
24557	38134	110	applied	\N	\N	\N	\N	186992	186992	354194
24557	38136	111	applied	\N	\N	\N	\N	186993	186993	354195
24557	38139	112	applied	\N	\N	\N	\N	186994	186994	354196
24557	38143	114	applied	\N	\N	\N	\N	186996	186996	354198
24557	38144	115	applied	\N	\N	\N	\N	186997	186997	354199
24557	38148	116	applied	\N	\N	\N	\N	186998	186998	354200
24557	38150	118	applied	\N	\N	\N	\N	186999	186999	354201
24557	38151	119	applied	\N	\N	\N	\N	187000	187000	354202
24557	38155	120	applied	\N	\N	\N	\N	187001	187001	354203
24557	38156	121	applied	\N	\N	\N	\N	187002	187002	354204
24557	38157	122	applied	\N	\N	\N	\N	187003	187003	354205
24557	38162	123	applied	\N	\N	\N	\N	187004	187004	354206
24557	38164	124	applied	\N	\N	\N	\N	187005	187005	354207
24557	38165	125	applied	\N	\N	\N	\N	187006	187006	354208
24562	38216	0	applied	\N	\N	\N	\N	187015	187015	354217
24562	38217	1	applied	\N	\N	\N	\N	187016	187016	354218
24568	38223	0	applied	\N	\N	\N	\N	187032	187032	354234
24568	38224	1	applied	\N	\N	\N	\N	187033	187033	354235
24568	38225	2	applied	\N	\N	\N	\N	187034	187034	354236
24600	38289	2	applied	\N	\N	\N	\N	187176	187176	354378
24603	38290	0	applied	\N	\N	\N	\N	187183	187183	354385
24603	38291	1	applied	\N	\N	\N	\N	187184	187184	354386
24603	38292	2	applied	\N	\N	\N	\N	187185	187185	354387
24605	38293	0	applied	\N	\N	\N	\N	187188	187188	354390
24605	38294	1	applied	\N	\N	\N	\N	187189	187189	354391
24608	38302	0	applied	\N	\N	\N	\N	187200	187200	354402
24608	38303	1	applied	\N	\N	\N	\N	187201	187201	354403
24608	38304	2	applied	\N	\N	\N	\N	187202	187202	354404
24610	38302	0	applied	\N	\N	\N	\N	187206	187206	354408
24610	38303	1	applied	\N	\N	\N	\N	187207	187207	354409
24610	38304	2	applied	\N	\N	\N	\N	187208	187208	354410
24612	38302	0	applied	\N	\N	\N	\N	187212	187212	354414
24612	38303	1	applied	\N	\N	\N	\N	187213	187213	354415
24612	38304	2	applied	\N	\N	\N	\N	187214	187214	354416
24614	38305	0	applied	\N	\N	\N	\N	187218	187218	354420
24614	38307	2	applied	\N	\N	\N	\N	187220	187220	354422
24616	38306	0	applied	\N	\N	\N	\N	187224	187224	354426
24616	38307	1	applied	\N	\N	\N	\N	187225	187225	354427
24618	38308	0	applied	\N	\N	\N	\N	187243	187243	354445
24618	38309	1	applied	\N	\N	\N	\N	187244	187244	354446
24618	38310	2	applied	\N	\N	\N	\N	187245	187245	354447
24618	38311	3	applied	\N	\N	\N	\N	187246	187246	354448
24618	38312	4	applied	\N	\N	\N	\N	187247	187247	354449
24618	38313	5	applied	\N	\N	\N	\N	187248	187248	354450
24618	38314	6	applied	\N	\N	\N	\N	187249	187249	354451
24618	38315	7	applied	\N	\N	\N	\N	187250	187250	354452
24618	38316	8	applied	\N	\N	\N	\N	187251	187251	354453
24618	38317	9	applied	\N	\N	\N	\N	187252	187252	354454
24618	38318	10	applied	\N	\N	\N	\N	187253	187253	354455
24557	37972	43	applied	\N	\N	\N	\N	186925	186925	354127
24557	37978	44	applied	\N	\N	\N	\N	186926	186926	354128
24572	38231	1	applied	\N	\N	\N	\N	187048	187048	354250
24572	38232	2	applied	\N	\N	\N	\N	187049	187049	354251
24572	38233	3	applied	\N	\N	\N	\N	187050	187050	354252
24572	38234	4	applied	\N	\N	\N	\N	187051	187051	354253
24572	38235	5	applied	\N	\N	\N	\N	187052	187052	354254
24572	38236	6	applied	\N	\N	\N	\N	187053	187053	354255
24572	38237	7	applied	\N	\N	\N	\N	187054	187054	354256
24572	38238	8	applied	\N	\N	\N	\N	187055	187055	354257
24575	38239	0	applied	\N	\N	\N	\N	187067	187067	354269
24575	38240	1	applied	\N	\N	\N	\N	187068	187068	354270
24577	38241	0	applied	\N	\N	\N	\N	187072	187072	354274
24577	38242	1	applied	\N	\N	\N	\N	187073	187073	354275
24577	38243	2	applied	\N	\N	\N	\N	187074	187074	354276
24579	38246	0	applied	\N	\N	\N	\N	187077	187077	354279
24579	38247	1	applied	\N	\N	\N	\N	187078	187078	354280
24580	38248	0	applied	\N	\N	\N	\N	187079	187079	354281
24580	38250	2	applied	\N	\N	\N	\N	187081	187081	354283
24580	38251	3	applied	\N	\N	\N	\N	187082	187082	354284
24580	38252	4	applied	\N	\N	\N	\N	187083	187083	354285
24580	38253	5	applied	\N	\N	\N	\N	187084	187084	354286
24580	38254	6	applied	\N	\N	\N	\N	187085	187085	354287
24580	38255	7	applied	\N	\N	\N	\N	187086	187086	354288
24584	38261	0	applied	\N	\N	\N	\N	187106	187106	354308
24584	38262	1	applied	\N	\N	\N	\N	187107	187107	354309
24584	38263	2	applied	\N	\N	\N	\N	187108	187108	354310
24584	38264	3	applied	\N	\N	\N	\N	187109	187109	354311
24584	38265	4	applied	\N	\N	\N	\N	187110	187110	354312
24584	38266	6	applied	\N	\N	\N	\N	187111	187111	354313
24584	38267	7	applied	\N	\N	\N	\N	187112	187112	354314
24586	38261	0	applied	\N	\N	\N	\N	187120	187120	354322
24586	38262	1	applied	\N	\N	\N	\N	187121	187121	354323
24586	38263	2	applied	\N	\N	\N	\N	187122	187122	354324
24586	38265	4	applied	\N	\N	\N	\N	187124	187124	354326
24586	38266	6	applied	\N	\N	\N	\N	187125	187125	354327
24586	38267	7	applied	\N	\N	\N	\N	187126	187126	354328
24589	38268	0	applied	\N	\N	\N	\N	187136	187136	354338
24589	38269	1	applied	\N	\N	\N	\N	187137	187137	354339
24594	38276	0	applied	\N	\N	\N	\N	187158	187158	354360
24594	38277	1	applied	\N	\N	\N	\N	187159	187159	354361
24594	38278	2	applied	\N	\N	\N	\N	187160	187160	354362
24594	38279	3	applied	\N	\N	\N	\N	187161	187161	354363
24594	38280	4	applied	\N	\N	\N	\N	187162	187162	354364
24594	38281	5	applied	\N	\N	\N	\N	187163	187163	354365
24594	38282	6	applied	\N	\N	\N	\N	187164	187164	354366
24596	38283	0	applied	\N	\N	\N	\N	187167	187167	354369
24596	38284	1	applied	\N	\N	\N	\N	187168	187168	354370
24598	38285	0	applied	\N	\N	\N	\N	187171	187171	354373
24598	38286	1	applied	\N	\N	\N	\N	187172	187172	354374
24601	38288	1	applied	\N	\N	\N	\N	187178	187178	354380
24601	38289	2	applied	\N	\N	\N	\N	187179	187179	354381
24609	38302	0	applied	\N	\N	\N	\N	187203	187203	354405
24609	38303	1	applied	\N	\N	\N	\N	187204	187204	354406
24609	38304	2	applied	\N	\N	\N	\N	187205	187205	354407
24623	38328	0	applied	\N	\N	\N	\N	187275	187275	354477
24623	38329	1	applied	\N	\N	\N	\N	187276	187276	354478
24623	38330	2	applied	\N	\N	\N	\N	187277	187277	354479
24630	38345	0	applied	\N	\N	\N	\N	187303	187303	354505
24630	38346	1	applied	\N	\N	\N	\N	187304	187304	354506
24630	38347	2	applied	\N	\N	\N	\N	187305	187305	354507
24635	38354	0	applied	\N	\N	\N	\N	187322	187322	354524
24635	38355	2	applied	\N	\N	\N	\N	187323	187323	354525
24635	38356	3	applied	\N	\N	\N	\N	187324	187324	354526
24635	38357	4	applied	\N	\N	\N	\N	187325	187325	354527
24641	38358	0	applied	\N	\N	\N	\N	187354	187354	354554
24641	38360	2	applied	\N	\N	\N	\N	187356	187356	354556
24641	38361	3	applied	\N	\N	\N	\N	187357	187357	354557
24641	38362	4	applied	\N	\N	\N	\N	187358	187358	354558
24641	38363	5	applied	\N	\N	\N	\N	187359	187359	187359
24641	38364	6	applied	\N	\N	\N	\N	187360	187360	354559
24641	38365	7	applied	\N	\N	\N	\N	187361	187361	354560
24646	38366	0	applied	\N	\N	\N	\N	187503	187503	354701
24646	38367	1	applied	\N	\N	\N	\N	187504	187504	354702
24646	38368	2	applied	\N	\N	\N	\N	187505	187505	354703
24646	38369	3	applied	\N	\N	\N	\N	187506	187506	354704
24648	38370	0	applied	\N	\N	\N	\N	187511	187511	354709
24648	38371	1	applied	\N	\N	\N	\N	187512	187512	354710
24648	38372	2	applied	\N	\N	\N	\N	187513	187513	354711
24648	38373	3	applied	\N	\N	\N	\N	187514	187514	354712
24653	38374	0	applied	\N	\N	\N	\N	187531	187531	354729
24653	38375	1	applied	\N	\N	\N	\N	187532	187532	354730
24653	38377	3	applied	\N	\N	\N	\N	187534	187534	354732
24662	38396	0	applied	\N	\N	\N	\N	187567	187567	354765
24662	38397	1	applied	\N	\N	\N	\N	187568	187568	354766
24662	38398	2	applied	\N	\N	\N	\N	187569	187569	354767
24662	38399	3	applied	\N	\N	\N	\N	187570	187570	354768
24667	38401	0	applied	\N	\N	\N	\N	187582	187582	354780
24667	38400	1	applied	\N	\N	\N	\N	187583	187583	354781
24672	38405	0	applied	\N	\N	\N	\N	187598	187598	354796
24672	38406	1	applied	\N	\N	\N	\N	187599	187599	354797
24672	38407	2	applied	\N	\N	\N	\N	187600	187600	354798
24672	38408	3	applied	\N	\N	\N	\N	187601	187601	354799
24677	38424	0	applied	\N	\N	\N	\N	187621	187621	354819
24677	38425	1	applied	\N	\N	\N	\N	187622	187622	354820
24677	38426	2	applied	\N	\N	\N	\N	187623	187623	354821
24677	38427	3	applied	\N	\N	\N	\N	187624	187624	354822
24679	38431	0	applied	\N	\N	\N	\N	187628	187628	354826
24679	38433	2	applied	\N	\N	\N	\N	187630	187630	354828
24679	38434	3	applied	\N	\N	\N	\N	187631	187631	354829
24679	38435	4	applied	\N	\N	\N	\N	187632	187632	354830
24686	38453	0	applied	\N	\N	\N	\N	187681	187681	354879
24686	38454	1	applied	\N	\N	\N	\N	187682	187682	354880
24686	38455	2	applied	\N	\N	\N	\N	187683	187683	354881
24686	38456	3	applied	\N	\N	\N	\N	187684	187684	354882
24686	38457	4	applied	\N	\N	\N	\N	187685	187685	354883
24686	38458	5	applied	\N	\N	\N	\N	187686	187686	354884
24686	38459	6	applied	\N	\N	\N	\N	187687	187687	354885
24686	38460	7	applied	\N	\N	\N	\N	187688	187688	354886
24686	38461	8	applied	\N	\N	\N	\N	187689	187689	354887
24686	38462	9	applied	\N	\N	\N	\N	187690	187690	354888
24688	38412	0	applied	\N	\N	\N	\N	187695	187695	354893
24571	38228	1	applied	\N	\N	\N	\N	187045	187045	354247
24571	38229	2	applied	\N	\N	\N	\N	187046	187046	354248
24617	38308	0	applied	\N	\N	\N	\N	187226	187226	354428
24617	38309	1	applied	\N	\N	\N	\N	187227	187227	354429
24617	38310	2	applied	\N	\N	\N	\N	187228	187228	354430
24617	38311	3	applied	\N	\N	\N	\N	187229	187229	354431
24617	38312	4	applied	\N	\N	\N	\N	187230	187230	354432
24617	38313	5	applied	\N	\N	\N	\N	187231	187231	354433
24617	38314	6	applied	\N	\N	\N	\N	187232	187232	354434
24617	38315	7	applied	\N	\N	\N	\N	187233	187233	354435
24617	38316	8	applied	\N	\N	\N	\N	187234	187234	354436
24617	38317	9	applied	\N	\N	\N	\N	187235	187235	354437
24617	38318	10	applied	\N	\N	\N	\N	187236	187236	354438
24617	38319	11	applied	\N	\N	\N	\N	187237	187237	354439
24617	38320	12	applied	\N	\N	\N	\N	187238	187238	354440
24617	38321	13	applied	\N	\N	\N	\N	187239	187239	354441
24617	38322	14	applied	\N	\N	\N	\N	187240	187240	354442
24617	38323	15	applied	\N	\N	\N	\N	187241	187241	354443
24619	38325	0	applied	\N	\N	\N	\N	187260	187260	354462
24619	38326	1	applied	\N	\N	\N	\N	187261	187261	354463
24619	38327	2	applied	\N	\N	\N	\N	187262	187262	354464
24622	38248	0	applied	\N	\N	\N	\N	187269	187269	354471
24622	38073	1	applied	\N	\N	\N	\N	187270	187270	354472
24622	38074	2	applied	\N	\N	\N	\N	187271	187271	354473
24622	38075	3	applied	\N	\N	\N	\N	187272	187272	354474
24622	38076	4	applied	\N	\N	\N	\N	187273	187273	354475
24622	38291	5	applied	\N	\N	\N	\N	187274	187274	354476
24624	38328	0	applied	\N	\N	\N	\N	187278	187278	354480
24624	38329	1	applied	\N	\N	\N	\N	187279	187279	354481
24637	38354	0	applied	\N	\N	\N	\N	187330	187330	354532
24637	38355	2	applied	\N	\N	\N	\N	187331	187331	354533
24637	38356	3	applied	\N	\N	\N	\N	187332	187332	354534
24637	38357	4	applied	\N	\N	\N	\N	187333	187333	354535
24640	38358	0	applied	\N	\N	\N	\N	187346	187346	354547
24640	38360	2	applied	\N	\N	\N	\N	187348	187348	354549
24640	38361	3	applied	\N	\N	\N	\N	187349	187349	354550
24640	38362	4	applied	\N	\N	\N	\N	187350	187350	354551
24640	38363	5	applied	\N	\N	\N	\N	187351	187351	187351
24640	38364	6	applied	\N	\N	\N	\N	187352	187352	354552
24640	38365	7	applied	\N	\N	\N	\N	187353	187353	354553
24644	38366	0	applied	\N	\N	\N	\N	187495	187495	354693
24644	38367	1	applied	\N	\N	\N	\N	187496	187496	354694
24644	38368	2	applied	\N	\N	\N	\N	187497	187497	354695
24644	38369	3	applied	\N	\N	\N	\N	187498	187498	354696
24649	38370	0	applied	\N	\N	\N	\N	187515	187515	354713
24649	38371	1	applied	\N	\N	\N	\N	187516	187516	354714
24649	38372	2	applied	\N	\N	\N	\N	187517	187517	354715
24649	38373	3	applied	\N	\N	\N	\N	187518	187518	354716
24651	38374	0	applied	\N	\N	\N	\N	187523	187523	354721
24651	38375	1	applied	\N	\N	\N	\N	187524	187524	354722
24651	38377	3	applied	\N	\N	\N	\N	187526	187526	354724
24658	38390	0	applied	\N	\N	\N	\N	187554	187554	354752
24658	38391	1	applied	\N	\N	\N	\N	187555	187555	354753
24658	38392	2	applied	\N	\N	\N	\N	187556	187556	354754
24660	38393	0	applied	\N	\N	\N	\N	187560	187560	354758
24660	38394	1	applied	\N	\N	\N	\N	187561	187561	354759
24660	38395	2	applied	\N	\N	\N	\N	187562	187562	354760
24663	38396	0	applied	\N	\N	\N	\N	187571	187571	354769
24663	38397	1	applied	\N	\N	\N	\N	187572	187572	354770
24663	38398	2	applied	\N	\N	\N	\N	187573	187573	354771
24663	38399	3	applied	\N	\N	\N	\N	187574	187574	354772
24666	38401	0	applied	\N	\N	\N	\N	187580	187580	354778
24666	38400	1	applied	\N	\N	\N	\N	187581	187581	354779
24668	38402	0	applied	\N	\N	\N	\N	187584	187584	354782
24668	38403	1	applied	\N	\N	\N	\N	187585	187585	354783
24668	38404	2	applied	\N	\N	\N	\N	187586	187586	354784
24670	38406	1	applied	\N	\N	\N	\N	187591	187591	354789
24670	38407	2	applied	\N	\N	\N	\N	187592	187592	354790
24670	38408	3	applied	\N	\N	\N	\N	187593	187593	354791
24673	38409	0	applied	\N	\N	\N	\N	187602	187602	354800
24673	38410	1	applied	\N	\N	\N	\N	187603	187603	354801
24673	38411	2	applied	\N	\N	\N	\N	187604	187604	354802
24673	38412	3	applied	\N	\N	\N	\N	187605	187605	354803
24673	38413	4	applied	\N	\N	\N	\N	187606	187606	354804
24673	38414	5	applied	\N	\N	\N	\N	187607	187607	354805
24673	38415	6	applied	\N	\N	\N	\N	187608	187608	354806
24673	38416	7	applied	\N	\N	\N	\N	187609	187609	354807
24673	38417	8	applied	\N	\N	\N	\N	187610	187610	354808
24673	38418	9	applied	\N	\N	\N	\N	187611	187611	354809
24673	38419	10	applied	\N	\N	\N	\N	187612	187612	354810
24673	38420	11	applied	\N	\N	\N	\N	187613	187613	354811
24675	38421	0	applied	\N	\N	\N	\N	187614	187614	354812
24688	38414	1	applied	\N	\N	\N	\N	187696	187696	354894
24688	38427	2	applied	\N	\N	\N	\N	187697	187697	354895
24693	38471	0	applied	\N	\N	\N	\N	187716	187716	354914
24693	38472	1	applied	\N	\N	\N	\N	187717	187717	354915
24693	38473	2	applied	\N	\N	\N	\N	187718	187718	354916
24693	38474	3	applied	\N	\N	\N	\N	187719	187719	354917
24693	38475	4	applied	\N	\N	\N	\N	187720	187720	354918
24693	38476	5	applied	\N	\N	\N	\N	187721	187721	354919
24695	38477	0	applied	\N	\N	\N	\N	187727	187727	354925
24695	38478	1	applied	\N	\N	\N	\N	187728	187728	354926
24695	38479	2	applied	\N	\N	\N	\N	187729	187729	354927
24695	38480	3	applied	\N	\N	\N	\N	187730	187730	354928
24695	38481	4	applied	\N	\N	\N	\N	187731	187731	354929
24699	38477	0	applied	\N	\N	\N	\N	187747	187747	354945
24699	38478	1	applied	\N	\N	\N	\N	187748	187748	354946
24699	38479	2	applied	\N	\N	\N	\N	187749	187749	354947
24699	38481	4	applied	\N	\N	\N	\N	187751	187751	354949
24707	38531	0	applied	\N	\N	\N	\N	187882	187882	355080
24707	38532	1	applied	\N	\N	\N	\N	187883	187883	355081
24707	38533	2	applied	\N	\N	\N	\N	187884	187884	355082
24707	38534	3	applied	\N	\N	\N	\N	187885	187885	355083
24707	38535	4	applied	\N	\N	\N	\N	187886	187886	355084
24707	38536	5	applied	\N	\N	\N	\N	187887	187887	355085
24707	38537	6	applied	\N	\N	\N	\N	187888	187888	355086
24707	38538	7	applied	\N	\N	\N	\N	187889	187889	355087
24707	38539	8	applied	\N	\N	\N	\N	187890	187890	355088
24707	38540	9	applied	\N	\N	\N	\N	187891	187891	355089
24712	38549	0	applied	\N	\N	\N	\N	187918	187918	355116
24712	38550	1	applied	\N	\N	\N	\N	187919	187919	355117
24712	38551	2	applied	\N	\N	\N	\N	187920	187920	355118
24613	38305	0	applied	\N	\N	\N	\N	187215	187215	354417
24613	38306	1	applied	\N	\N	\N	\N	187216	187216	354418
24618	38323	15	applied	\N	\N	\N	\N	187258	187258	354460
24618	38324	16	applied	\N	\N	\N	\N	187259	187259	354461
24620	38325	0	applied	\N	\N	\N	\N	187263	187263	354465
24620	38326	1	applied	\N	\N	\N	\N	187264	187264	354466
24620	38327	2	applied	\N	\N	\N	\N	187265	187265	354467
24625	38328	0	applied	\N	\N	\N	\N	187280	187280	354482
24625	38329	1	applied	\N	\N	\N	\N	187281	187281	354483
24625	38330	2	applied	\N	\N	\N	\N	187282	187282	354484
24627	38331	0	applied	\N	\N	\N	\N	187286	187286	354488
24627	38332	1	applied	\N	\N	\N	\N	187287	187287	354489
24627	38333	2	applied	\N	\N	\N	\N	187288	187288	354490
24627	38334	3	applied	\N	\N	\N	\N	187289	187289	354491
24629	38345	0	applied	\N	\N	\N	\N	187300	187300	354502
24629	38346	1	applied	\N	\N	\N	\N	187301	187301	354503
24629	38347	2	applied	\N	\N	\N	\N	187302	187302	354504
24632	38345	0	applied	\N	\N	\N	\N	187309	187309	354511
24632	38347	2	applied	\N	\N	\N	\N	187311	187311	354513
24634	38354	0	applied	\N	\N	\N	\N	187318	187318	354520
24634	38355	2	applied	\N	\N	\N	\N	187319	187319	354521
24634	38356	3	applied	\N	\N	\N	\N	187320	187320	354522
24634	38357	4	applied	\N	\N	\N	\N	187321	187321	354523
24638	38354	0	applied	\N	\N	\N	\N	187334	187334	354536
24638	38355	2	applied	\N	\N	\N	\N	187335	187335	354537
24638	38356	3	applied	\N	\N	\N	\N	187336	187336	354538
24638	38357	4	applied	\N	\N	\N	\N	187337	187337	354539
24645	38366	0	applied	\N	\N	\N	\N	187499	187499	354697
24645	38367	1	applied	\N	\N	\N	\N	187500	187500	354698
24645	38368	2	applied	\N	\N	\N	\N	187501	187501	354699
24645	38369	3	applied	\N	\N	\N	\N	187502	187502	354700
24647	38370	0	applied	\N	\N	\N	\N	187507	187507	354705
24647	38371	1	applied	\N	\N	\N	\N	187508	187508	354706
24647	38372	2	applied	\N	\N	\N	\N	187509	187509	354707
24650	38370	0	applied	\N	\N	\N	\N	187519	187519	354717
24650	38371	1	applied	\N	\N	\N	\N	187520	187520	354718
24650	38372	2	applied	\N	\N	\N	\N	187521	187521	354719
24650	38373	3	applied	\N	\N	\N	\N	187522	187522	354720
24652	38374	0	applied	\N	\N	\N	\N	187527	187527	354725
24652	38375	1	applied	\N	\N	\N	\N	187528	187528	354726
24652	38376	2	applied	\N	\N	\N	\N	187529	187529	354727
24652	38377	3	applied	\N	\N	\N	\N	187530	187530	354728
24656	38387	0	applied	\N	\N	\N	\N	187548	187548	354746
24656	38388	1	applied	\N	\N	\N	\N	187549	187549	354747
24656	38389	2	applied	\N	\N	\N	\N	187550	187550	354748
24659	38390	0	applied	\N	\N	\N	\N	187557	187557	354755
24659	38391	1	applied	\N	\N	\N	\N	187558	187558	354756
24659	38392	2	applied	\N	\N	\N	\N	187559	187559	354757
24661	38396	0	applied	\N	\N	\N	\N	187563	187563	354761
24661	38397	1	applied	\N	\N	\N	\N	187564	187564	354762
24661	38399	3	applied	\N	\N	\N	\N	187566	187566	354764
24664	38396	0	applied	\N	\N	\N	\N	187575	187575	354773
24664	38397	1	applied	\N	\N	\N	\N	187576	187576	354774
24664	38398	2	applied	\N	\N	\N	\N	187577	187577	354775
24664	38399	3	applied	\N	\N	\N	\N	187578	187578	354776
24669	38402	0	applied	\N	\N	\N	\N	187587	187587	354785
24669	38403	1	applied	\N	\N	\N	\N	187588	187588	354786
24669	38404	2	applied	\N	\N	\N	\N	187589	187589	354787
24671	38405	0	applied	\N	\N	\N	\N	187594	187594	354792
24671	38406	1	applied	\N	\N	\N	\N	187595	187595	354793
24671	38407	2	applied	\N	\N	\N	\N	187596	187596	354794
24671	38408	3	applied	\N	\N	\N	\N	187597	187597	354795
24675	38423	2	applied	\N	\N	\N	\N	187616	187616	354814
24676	38424	0	applied	\N	\N	\N	\N	187617	187617	354815
24676	38425	1	applied	\N	\N	\N	\N	187618	187618	354816
24676	38426	2	applied	\N	\N	\N	\N	187619	187619	354817
24678	38428	0	applied	\N	\N	\N	\N	187625	187625	354823
24678	38429	1	applied	\N	\N	\N	\N	187626	187626	354824
24678	38430	2	applied	\N	\N	\N	\N	187627	187627	354825
24680	38436	0	applied	\N	\N	\N	\N	187633	187633	354831
24680	38437	1	applied	\N	\N	\N	\N	187634	187634	354832
24680	38438	2	applied	\N	\N	\N	\N	187635	187635	354833
24681	38439	0	applied	\N	\N	\N	\N	187636	187636	354834
24681	38440	1	applied	\N	\N	\N	\N	187637	187637	354835
24681	38441	2	applied	\N	\N	\N	\N	187638	187638	354836
24681	38442	3	applied	\N	\N	\N	\N	187639	187639	354837
24681	38443	4	applied	\N	\N	\N	\N	187640	187640	354838
24681	38444	6	applied	\N	\N	\N	\N	187641	187641	354839
24681	38445	7	applied	\N	\N	\N	\N	187642	187642	354840
24681	38446	8	applied	\N	\N	\N	\N	187643	187643	354841
24681	38447	9	applied	\N	\N	\N	\N	187644	187644	354842
24681	38448	10	applied	\N	\N	\N	\N	187645	187645	354843
24682	38439	0	applied	\N	\N	\N	\N	187647	187647	354845
24682	38440	1	applied	\N	\N	\N	\N	187648	187648	354846
24682	38441	2	applied	\N	\N	\N	\N	187649	187649	354847
24682	38442	3	applied	\N	\N	\N	\N	187650	187650	354848
24682	38443	4	applied	\N	\N	\N	\N	187651	187651	354849
24682	38444	6	applied	\N	\N	\N	\N	187652	187652	354850
24682	38445	7	applied	\N	\N	\N	\N	187653	187653	354851
24682	38446	8	applied	\N	\N	\N	\N	187654	187654	354852
24682	38447	9	applied	\N	\N	\N	\N	187655	187655	354853
24682	38448	10	applied	\N	\N	\N	\N	187656	187656	354854
24682	38449	11	applied	\N	\N	\N	\N	187657	187657	354855
24685	38453	0	applied	\N	\N	\N	\N	187671	187671	354869
24685	38454	1	applied	\N	\N	\N	\N	187672	187672	354870
24685	38455	2	applied	\N	\N	\N	\N	187673	187673	354871
24685	38456	3	applied	\N	\N	\N	\N	187674	187674	354872
24685	38457	4	applied	\N	\N	\N	\N	187675	187675	354873
24685	38459	6	applied	\N	\N	\N	\N	187677	187677	354875
24685	38460	7	applied	\N	\N	\N	\N	187678	187678	354876
24685	38461	8	applied	\N	\N	\N	\N	187679	187679	354877
24685	38462	9	applied	\N	\N	\N	\N	187680	187680	354878
24687	38463	0	applied	\N	\N	\N	\N	187691	187691	354889
24687	38464	1	applied	\N	\N	\N	\N	187692	187692	354890
24687	38465	2	applied	\N	\N	\N	\N	187693	187693	354891
24687	38466	3	applied	\N	\N	\N	\N	187694	187694	354892
24689	38463	0	applied	\N	\N	\N	\N	187698	187698	354896
24689	38464	1	applied	\N	\N	\N	\N	187699	187699	354897
24689	38465	2	applied	\N	\N	\N	\N	187700	187700	354898
24689	38466	3	applied	\N	\N	\N	\N	187701	187701	354899
24692	38471	0	applied	\N	\N	\N	\N	187710	187710	354908
24692	38472	1	applied	\N	\N	\N	\N	187711	187711	354909
24618	38320	12	applied	\N	\N	\N	\N	187255	187255	354457
24618	38321	13	applied	\N	\N	\N	\N	187256	187256	354458
24633	38349	1	applied	\N	\N	\N	\N	187313	187313	354515
24633	38350	2	applied	\N	\N	\N	\N	187314	187314	354516
24633	38351	3	applied	\N	\N	\N	\N	187315	187315	354517
24633	38352	4	applied	\N	\N	\N	\N	187316	187316	354518
24633	38353	5	applied	\N	\N	\N	\N	187317	187317	354519
24636	38354	0	applied	\N	\N	\N	\N	187326	187326	354528
24636	38355	2	applied	\N	\N	\N	\N	187327	187327	354529
24636	38356	3	applied	\N	\N	\N	\N	187328	187328	354530
24636	38357	4	applied	\N	\N	\N	\N	187329	187329	354531
24639	38358	0	applied	\N	\N	\N	\N	187338	187338	354540
24639	38359	1	applied	\N	\N	\N	\N	187339	187339	354541
24639	38360	2	applied	\N	\N	\N	\N	187340	187340	354542
24639	38361	3	applied	\N	\N	\N	\N	187341	187341	354543
24639	38362	4	applied	\N	\N	\N	\N	187342	187342	354544
24639	38363	5	applied	\N	\N	\N	\N	187343	187343	187343
24639	38364	6	applied	\N	\N	\N	\N	187344	187344	354545
24642	38358	0	applied	\N	\N	\N	\N	187362	187362	354561
24642	38359	1	applied	\N	\N	\N	\N	187363	187363	354562
24642	38360	2	applied	\N	\N	\N	\N	187364	187364	354563
24642	38361	3	applied	\N	\N	\N	\N	187365	187365	354564
24642	38362	4	applied	\N	\N	\N	\N	187366	187366	354565
24642	38363	5	applied	\N	\N	\N	\N	187367	187367	187367
24642	38364	6	applied	\N	\N	\N	\N	187368	187368	354566
24642	38365	7	applied	\N	\N	\N	\N	187369	187369	354567
24643	37906	0	applied	\N	\N	\N	\N	187370	187370	354568
24643	38248	1	applied	\N	\N	\N	\N	187371	187371	354569
24643	38335	2	applied	\N	\N	\N	\N	187372	187372	354570
24643	38348	3	applied	\N	\N	\N	\N	187373	187373	354571
24643	37911	4	applied	\N	\N	\N	\N	187374	187374	354572
24643	37919	5	applied	\N	\N	\N	\N	187375	187375	354573
24643	37932	6	applied	\N	\N	\N	\N	187376	187376	354574
24643	38073	7	applied	\N	\N	\N	\N	187377	187377	354575
24643	38359	9	applied	\N	\N	\N	\N	187379	187379	354577
24643	38031	10	applied	\N	\N	\N	\N	187380	187380	354578
24643	38074	11	applied	\N	\N	\N	\N	187381	187381	354579
24643	38075	12	applied	\N	\N	\N	\N	187382	187382	354580
24643	38076	13	applied	\N	\N	\N	\N	187383	187383	354581
24643	38291	14	applied	\N	\N	\N	\N	187384	187384	354582
24643	37901	15	applied	\N	\N	\N	\N	187385	187385	354583
24643	38361	16	applied	\N	\N	\N	\N	187386	187386	354584
24643	38362	17	applied	\N	\N	\N	\N	187387	187387	354585
24643	37903	18	applied	\N	\N	\N	\N	187388	187388	354586
24643	37907	19	applied	\N	\N	\N	\N	187389	187389	354587
24643	37908	20	applied	\N	\N	\N	\N	187390	187390	354588
24643	37912	21	applied	\N	\N	\N	\N	187391	187391	354589
24643	37913	22	applied	\N	\N	\N	\N	187392	187392	354590
24643	37917	23	applied	\N	\N	\N	\N	187393	187393	354591
24643	37920	24	applied	\N	\N	\N	\N	187394	187394	354592
24643	37922	26	applied	\N	\N	\N	\N	187396	187396	354594
24643	37927	27	applied	\N	\N	\N	\N	187397	187397	354595
24643	37929	28	applied	\N	\N	\N	\N	187398	187398	354596
24643	37933	29	applied	\N	\N	\N	\N	187399	187399	354597
24643	37935	30	applied	\N	\N	\N	\N	187400	187400	354598
24643	37936	31	applied	\N	\N	\N	\N	187401	187401	354599
24643	37939	32	applied	\N	\N	\N	\N	187402	187402	354600
24643	37940	33	applied	\N	\N	\N	\N	187403	187403	354601
24643	37943	34	applied	\N	\N	\N	\N	187404	187404	354602
24643	37944	35	applied	\N	\N	\N	\N	187405	187405	354603
24643	37945	36	applied	\N	\N	\N	\N	187406	187406	354604
24643	37950	37	applied	\N	\N	\N	\N	187407	187407	354605
24643	37952	38	applied	\N	\N	\N	\N	187408	187408	354606
24643	37955	39	applied	\N	\N	\N	\N	187409	187409	354607
24643	37957	40	applied	\N	\N	\N	\N	187410	187410	354608
24643	37959	41	applied	\N	\N	\N	\N	187411	187411	354609
24643	37963	43	applied	\N	\N	\N	\N	187413	187413	354611
24643	37965	44	applied	\N	\N	\N	\N	187414	187414	354612
24643	37967	45	applied	\N	\N	\N	\N	187415	187415	354613
24643	37970	46	applied	\N	\N	\N	\N	187416	187416	354614
24643	37972	47	applied	\N	\N	\N	\N	187417	187417	354615
24643	37978	48	applied	\N	\N	\N	\N	187418	187418	354616
24643	37982	49	applied	\N	\N	\N	\N	187419	187419	354617
24643	37983	50	applied	\N	\N	\N	\N	187420	187420	354618
24643	37985	51	applied	\N	\N	\N	\N	187421	187421	354619
24643	37988	52	applied	\N	\N	\N	\N	187422	187422	354620
24643	37990	53	applied	\N	\N	\N	\N	187423	187423	354621
24643	37992	54	applied	\N	\N	\N	\N	187424	187424	354622
24643	37993	55	applied	\N	\N	\N	\N	187425	187425	354623
24643	37994	56	applied	\N	\N	\N	\N	187426	187426	354624
24643	37999	57	applied	\N	\N	\N	\N	187427	187427	354625
24643	38001	58	applied	\N	\N	\N	\N	187428	187428	354626
24690	38463	0	applied	\N	\N	\N	\N	187702	187702	354900
24690	38464	1	applied	\N	\N	\N	\N	187703	187703	354901
24690	38465	2	applied	\N	\N	\N	\N	187704	187704	354902
24690	38466	3	applied	\N	\N	\N	\N	187705	187705	354903
24698	38477	0	applied	\N	\N	\N	\N	187742	187742	354940
24698	38478	1	applied	\N	\N	\N	\N	187743	187743	354941
24698	38479	2	applied	\N	\N	\N	\N	187744	187744	354942
24698	38480	3	applied	\N	\N	\N	\N	187745	187745	354943
24698	38481	4	applied	\N	\N	\N	\N	187746	187746	354944
24701	38490	0	applied	\N	\N	\N	\N	187760	187760	354958
24701	38491	1	applied	\N	\N	\N	\N	187761	187761	354959
24701	38492	2	applied	\N	\N	\N	\N	187762	187762	354960
24701	38493	3	applied	\N	\N	\N	\N	187763	187763	354961
24701	38494	4	applied	\N	\N	\N	\N	187764	187764	354962
24701	38495	5	applied	\N	\N	\N	\N	187765	187765	354963
24701	38496	6	applied	\N	\N	\N	\N	187766	187766	354964
24702	38498	1	applied	\N	\N	\N	\N	187768	187768	354966
24702	38499	2	applied	\N	\N	\N	\N	187769	187769	354967
24702	38500	3	applied	\N	\N	\N	\N	187770	187770	354968
24702	38501	4	applied	\N	\N	\N	\N	187771	187771	354969
24702	38502	5	applied	\N	\N	\N	\N	187772	187772	354970
24702	38503	6	applied	\N	\N	\N	\N	187773	187773	354971
24702	38504	7	applied	\N	\N	\N	\N	187774	187774	354972
24702	38505	8	applied	\N	\N	\N	\N	187775	187775	354973
24702	38506	9	applied	\N	\N	\N	\N	187776	187776	354974
24702	38507	10	applied	\N	\N	\N	\N	187777	187777	354975
24702	38508	11	applied	\N	\N	\N	\N	187778	187778	354976
24702	38509	12	applied	\N	\N	\N	\N	187779	187779	354977
24702	38510	13	applied	\N	\N	\N	\N	187780	187780	354978
24702	38511	14	applied	\N	\N	\N	\N	187781	187781	354979
24631	38346	1	applied	\N	\N	\N	\N	187307	187307	354509
24631	38347	2	applied	\N	\N	\N	\N	187308	187308	354510
24643	38015	64	applied	\N	\N	\N	\N	187434	187434	354632
24643	38017	66	applied	\N	\N	\N	\N	187435	187435	354633
24643	38020	67	applied	\N	\N	\N	\N	187436	187436	354634
24643	38022	68	applied	\N	\N	\N	\N	187437	187437	354635
24643	38023	69	applied	\N	\N	\N	\N	187438	187438	354636
24643	38024	70	applied	\N	\N	\N	\N	187439	187439	354637
24643	38029	71	applied	\N	\N	\N	\N	187440	187440	354638
24643	38032	72	applied	\N	\N	\N	\N	187441	187441	354639
24643	38035	73	applied	\N	\N	\N	\N	187442	187442	354640
24643	38037	74	applied	\N	\N	\N	\N	187443	187443	354641
24643	38039	75	applied	\N	\N	\N	\N	187444	187444	354642
24643	38041	76	applied	\N	\N	\N	\N	187445	187445	354643
24643	38044	77	applied	\N	\N	\N	\N	187446	187446	354644
24643	38045	78	applied	\N	\N	\N	\N	187447	187447	354645
24643	38048	79	applied	\N	\N	\N	\N	187448	187448	354646
24643	38051	80	applied	\N	\N	\N	\N	187449	187449	354647
24643	38054	82	applied	\N	\N	\N	\N	187451	187451	354649
24643	38057	83	applied	\N	\N	\N	\N	187452	187452	354650
24643	38058	84	applied	\N	\N	\N	\N	187453	187453	354651
24643	38061	85	applied	\N	\N	\N	\N	187454	187454	354652
24643	38063	86	applied	\N	\N	\N	\N	187455	187455	354653
24643	38066	87	applied	\N	\N	\N	\N	187456	187456	354654
24643	38067	88	applied	\N	\N	\N	\N	187457	187457	354655
24643	38068	89	applied	\N	\N	\N	\N	187458	187458	354656
24643	38077	90	applied	\N	\N	\N	\N	187459	187459	354657
24643	38078	91	applied	\N	\N	\N	\N	187460	187460	354658
24643	38081	92	applied	\N	\N	\N	\N	187461	187461	354659
24643	38084	93	applied	\N	\N	\N	\N	187462	187462	354660
24643	38086	94	applied	\N	\N	\N	\N	187463	187463	354661
24643	38087	95	applied	\N	\N	\N	\N	187464	187464	354662
24643	38090	96	applied	\N	\N	\N	\N	187465	187465	354663
24643	38093	97	applied	\N	\N	\N	\N	187466	187466	354664
24643	38096	99	applied	\N	\N	\N	\N	187468	187468	354666
24643	38100	100	applied	\N	\N	\N	\N	187469	187469	354667
24643	38102	101	applied	\N	\N	\N	\N	187470	187470	354668
24643	38104	102	applied	\N	\N	\N	\N	187471	187471	354669
24643	38105	103	applied	\N	\N	\N	\N	187472	187472	354670
24643	38109	104	applied	\N	\N	\N	\N	187473	187473	354671
24643	38110	105	applied	\N	\N	\N	\N	187474	187474	354672
24643	38113	106	applied	\N	\N	\N	\N	187475	187475	354673
24643	38116	107	applied	\N	\N	\N	\N	187476	187476	354674
24643	38117	108	applied	\N	\N	\N	\N	187477	187477	354675
24643	38120	109	applied	\N	\N	\N	\N	187478	187478	354676
24643	38123	110	applied	\N	\N	\N	\N	187479	187479	354677
24643	38125	111	applied	\N	\N	\N	\N	187480	187480	354678
24643	38127	112	applied	\N	\N	\N	\N	187481	187481	354679
24643	38128	113	applied	\N	\N	\N	\N	187482	187482	354680
24643	38132	114	applied	\N	\N	\N	\N	187483	187483	354681
24643	38136	116	applied	\N	\N	\N	\N	187485	187485	354683
24643	38139	117	applied	\N	\N	\N	\N	187486	187486	354684
24643	38141	118	applied	\N	\N	\N	\N	187487	187487	354685
24643	38143	119	applied	\N	\N	\N	\N	187488	187488	354686
24643	38144	120	applied	\N	\N	\N	\N	187489	187489	354687
24643	38148	121	applied	\N	\N	\N	\N	187490	187490	354688
24643	38150	122	applied	\N	\N	\N	\N	187491	187491	354689
24643	38151	123	applied	\N	\N	\N	\N	187492	187492	354690
24643	38155	124	applied	\N	\N	\N	\N	187493	187493	354691
24643	38156	125	applied	\N	\N	\N	\N	187494	187494	354692
24654	38374	0	applied	\N	\N	\N	\N	187535	187535	354733
24654	38375	1	applied	\N	\N	\N	\N	187536	187536	354734
24654	38376	2	applied	\N	\N	\N	\N	187537	187537	354735
24654	38377	3	applied	\N	\N	\N	\N	187538	187538	354736
24655	38378	0	applied	\N	\N	\N	\N	187539	187539	354737
24655	38379	1	applied	\N	\N	\N	\N	187540	187540	354738
24655	38381	3	applied	\N	\N	\N	\N	187542	187542	354740
24655	38382	4	applied	\N	\N	\N	\N	187543	187543	354741
24655	38383	5	applied	\N	\N	\N	\N	187544	187544	354742
24655	38384	6	applied	\N	\N	\N	\N	187545	187545	354743
24655	38385	7	applied	\N	\N	\N	\N	187546	187546	354744
24655	38386	8	applied	\N	\N	\N	\N	187547	187547	354745
24657	38387	0	applied	\N	\N	\N	\N	187551	187551	354749
24657	38388	1	applied	\N	\N	\N	\N	187552	187552	354750
24657	38389	2	applied	\N	\N	\N	\N	187553	187553	354751
24665	38400	0	applied	\N	\N	\N	\N	187579	187579	354777
24683	38450	0	applied	\N	\N	\N	\N	187658	187658	354856
24683	38451	1	applied	\N	\N	\N	\N	187659	187659	354857
24683	38452	2	applied	\N	\N	\N	\N	187660	187660	354858
24684	38453	0	applied	\N	\N	\N	\N	187661	187661	354859
24684	38454	1	applied	\N	\N	\N	\N	187662	187662	354860
24684	38455	2	applied	\N	\N	\N	\N	187663	187663	354861
24684	38457	4	applied	\N	\N	\N	\N	187665	187665	354863
24684	38458	5	applied	\N	\N	\N	\N	187666	187666	354864
24684	38459	6	applied	\N	\N	\N	\N	187667	187667	354865
24684	38460	7	applied	\N	\N	\N	\N	187668	187668	354866
24684	38461	8	applied	\N	\N	\N	\N	187669	187669	354867
24684	38462	9	applied	\N	\N	\N	\N	187670	187670	354868
24691	38467	0	applied	\N	\N	\N	\N	187706	187706	354904
24691	38468	1	applied	\N	\N	\N	\N	187707	187707	354905
24691	38469	2	applied	\N	\N	\N	\N	187708	187708	354906
24691	38470	3	applied	\N	\N	\N	\N	187709	187709	354907
24696	38477	0	applied	\N	\N	\N	\N	187732	187732	354930
24696	38478	1	applied	\N	\N	\N	\N	187733	187733	354931
24696	38479	2	applied	\N	\N	\N	\N	187734	187734	354932
24696	38480	3	applied	\N	\N	\N	\N	187735	187735	354933
24696	38481	4	applied	\N	\N	\N	\N	187736	187736	354934
24700	38482	0	applied	\N	\N	\N	\N	187752	187752	354950
24700	38484	2	applied	\N	\N	\N	\N	187754	187754	354952
24700	38485	3	applied	\N	\N	\N	\N	187755	187755	354953
24700	38486	4	applied	\N	\N	\N	\N	187756	187756	354954
24700	38487	5	applied	\N	\N	\N	\N	187757	187757	354955
24700	38488	6	applied	\N	\N	\N	\N	187758	187758	354956
24700	38489	7	applied	\N	\N	\N	\N	187759	187759	354957
24703	38497	0	applied	\N	\N	\N	\N	187794	187794	354992
24703	38498	1	applied	\N	\N	\N	\N	187795	187795	354993
24703	38499	2	applied	\N	\N	\N	\N	187796	187796	354994
24703	38500	3	applied	\N	\N	\N	\N	187797	187797	354995
24703	38501	4	applied	\N	\N	\N	\N	187798	187798	354996
24703	38502	5	applied	\N	\N	\N	\N	187799	187799	354997
24703	38503	6	applied	\N	\N	\N	\N	187800	187800	354998
24703	38504	7	applied	\N	\N	\N	\N	187801	187801	354999
24643	38008	61	applied	\N	\N	\N	\N	187431	187431	354629
24643	38009	62	applied	\N	\N	\N	\N	187432	187432	354630
24694	38477	0	applied	\N	\N	\N	\N	187722	187722	354920
24694	38478	1	applied	\N	\N	\N	\N	187723	187723	354921
24694	38479	2	applied	\N	\N	\N	\N	187724	187724	354922
24694	38480	3	applied	\N	\N	\N	\N	187725	187725	354923
24694	38481	4	applied	\N	\N	\N	\N	187726	187726	354924
24697	38477	0	applied	\N	\N	\N	\N	187737	187737	354935
24697	38478	1	applied	\N	\N	\N	\N	187738	187738	354936
24697	38479	2	applied	\N	\N	\N	\N	187739	187739	354937
24697	38480	3	applied	\N	\N	\N	\N	187740	187740	354938
24697	38481	4	applied	\N	\N	\N	\N	187741	187741	354939
24703	38505	8	applied	\N	\N	\N	\N	187802	187802	355000
24703	38506	9	applied	\N	\N	\N	\N	187803	187803	355001
24703	38507	10	applied	\N	\N	\N	\N	187804	187804	355002
24703	38508	11	applied	\N	\N	\N	\N	187805	187805	355003
24703	38509	12	applied	\N	\N	\N	\N	187806	187806	355004
24703	38510	13	applied	\N	\N	\N	\N	187807	187807	355005
24703	38512	15	applied	\N	\N	\N	\N	187809	187809	355007
24703	38513	16	applied	\N	\N	\N	\N	187810	187810	355008
24703	38514	17	applied	\N	\N	\N	\N	187811	187811	355009
24703	38515	18	applied	\N	\N	\N	\N	187812	187812	355010
24703	38516	19	applied	\N	\N	\N	\N	187813	187813	355011
24703	38517	20	applied	\N	\N	\N	\N	187814	187814	355012
24703	38518	21	applied	\N	\N	\N	\N	187815	187815	355013
24703	38519	22	applied	\N	\N	\N	\N	187816	187816	355014
24703	38520	23	applied	\N	\N	\N	\N	187817	187817	355015
24703	38521	24	applied	\N	\N	\N	\N	187818	187818	355016
24703	38522	25	applied	\N	\N	\N	\N	187819	187819	355017
24703	38523	26	applied	\N	\N	\N	\N	187820	187820	355018
24704	38497	0	applied	\N	\N	\N	\N	187821	187821	355019
24704	38498	1	applied	\N	\N	\N	\N	187822	187822	355020
24704	38499	2	applied	\N	\N	\N	\N	187823	187823	355021
24704	38500	3	applied	\N	\N	\N	\N	187824	187824	355022
24704	38502	5	applied	\N	\N	\N	\N	187826	187826	355024
24704	38503	6	applied	\N	\N	\N	\N	187827	187827	355025
24704	38504	7	applied	\N	\N	\N	\N	187828	187828	355026
24704	38505	8	applied	\N	\N	\N	\N	187829	187829	355027
24704	38506	9	applied	\N	\N	\N	\N	187830	187830	355028
24704	38507	10	applied	\N	\N	\N	\N	187831	187831	355029
24704	38508	11	applied	\N	\N	\N	\N	187832	187832	355030
24704	38509	12	applied	\N	\N	\N	\N	187833	187833	355031
24704	38510	13	applied	\N	\N	\N	\N	187834	187834	355032
24704	38511	14	applied	\N	\N	\N	\N	187835	187835	355033
24704	38512	15	applied	\N	\N	\N	\N	187836	187836	355034
24704	38513	16	applied	\N	\N	\N	\N	187837	187837	355035
24704	38514	17	applied	\N	\N	\N	\N	187838	187838	355036
24704	38515	18	applied	\N	\N	\N	\N	187839	187839	355037
24704	38516	19	applied	\N	\N	\N	\N	187840	187840	355038
24704	38517	20	applied	\N	\N	\N	\N	187841	187841	355039
24704	38519	22	applied	\N	\N	\N	\N	187843	187843	355041
24704	38520	23	applied	\N	\N	\N	\N	187844	187844	355042
24704	38521	24	applied	\N	\N	\N	\N	187845	187845	355043
24704	38522	25	applied	\N	\N	\N	\N	187846	187846	355044
24704	38523	26	applied	\N	\N	\N	\N	187847	187847	355045
24708	38541	0	applied	\N	\N	\N	\N	187892	187892	355090
24708	38542	1	applied	\N	\N	\N	\N	187893	187893	355091
24708	38543	2	applied	\N	\N	\N	\N	187894	187894	355092
24708	38544	3	applied	\N	\N	\N	\N	187895	187895	355093
24708	38545	4	applied	\N	\N	\N	\N	187896	187896	355094
24708	38546	5	applied	\N	\N	\N	\N	187897	187897	355095
24708	38547	7	applied	\N	\N	\N	\N	187898	187898	355096
24708	38548	8	applied	\N	\N	\N	\N	187899	187899	355097
24710	38541	0	applied	\N	\N	\N	\N	187903	187903	355101
24710	38542	1	applied	\N	\N	\N	\N	187904	187904	355102
24710	38543	2	applied	\N	\N	\N	\N	187905	187905	355103
24710	38545	4	applied	\N	\N	\N	\N	187907	187907	355105
24710	38546	5	applied	\N	\N	\N	\N	187908	187908	355106
24710	38547	7	applied	\N	\N	\N	\N	187909	187909	355107
24710	38548	8	applied	\N	\N	\N	\N	187910	187910	355108
24713	38549	0	applied	\N	\N	\N	\N	187925	187925	355123
24713	38550	1	applied	\N	\N	\N	\N	187926	187926	355124
24713	38551	2	applied	\N	\N	\N	\N	187927	187927	355125
24713	38552	3	applied	\N	\N	\N	\N	187928	187928	355126
24713	38553	4	applied	\N	\N	\N	\N	187929	187929	355127
24713	38554	5	applied	\N	\N	\N	\N	187930	187930	355128
24713	38555	6	applied	\N	\N	\N	\N	187931	187931	355129
24716	38563	0	applied	\N	\N	\N	\N	187942	187942	355140
24716	38556	1	applied	\N	\N	\N	\N	187943	187943	355141
24716	38558	2	applied	\N	\N	\N	\N	187944	187944	355142
24716	38559	3	applied	\N	\N	\N	\N	187945	187945	355143
24716	38560	4	applied	\N	\N	\N	\N	187946	187946	355144
24716	38565	6	applied	\N	\N	\N	\N	187948	187948	355146
24718	38566	0	applied	\N	\N	\N	\N	187955	187955	355153
24718	38567	1	applied	\N	\N	\N	\N	187956	187956	355154
24718	38568	2	applied	\N	\N	\N	\N	187957	187957	355155
24718	38565	3	applied	\N	\N	\N	\N	187958	187958	355156
24718	38569	4	applied	\N	\N	\N	\N	187959	187959	355157
24718	38570	5	applied	\N	\N	\N	\N	187960	187960	355158
24718	38571	6	applied	\N	\N	\N	\N	187961	187961	355159
24718	38572	7	applied	\N	\N	\N	\N	187962	187962	355160
24720	38573	0	applied	\N	\N	\N	\N	187971	187971	355169
24720	38574	1	applied	\N	\N	\N	\N	187972	187972	355170
24720	38575	2	applied	\N	\N	\N	\N	187973	187973	355171
24720	38576	3	applied	\N	\N	\N	\N	187974	187974	355172
24721	38573	0	applied	\N	\N	\N	\N	187979	187979	355177
24721	38574	1	applied	\N	\N	\N	\N	187980	187980	355178
24721	38575	2	applied	\N	\N	\N	\N	187981	187981	355179
24721	38577	4	applied	\N	\N	\N	\N	187983	187983	355181
24721	38578	5	applied	\N	\N	\N	\N	187984	187984	355182
24721	38579	6	applied	\N	\N	\N	\N	187985	187985	355183
24721	38580	7	applied	\N	\N	\N	\N	187986	187986	355184
24723	38573	0	applied	\N	\N	\N	\N	187987	187987	355185
24723	38581	1	applied	\N	\N	\N	\N	187988	187988	355186
24723	38582	2	applied	\N	\N	\N	\N	187989	187989	355187
24723	38583	3	applied	\N	\N	\N	\N	187990	187990	355188
24723	38584	4	applied	\N	\N	\N	\N	187991	187991	355189
24723	38574	5	applied	\N	\N	\N	\N	187992	187992	355190
24723	38575	6	applied	\N	\N	\N	\N	187993	187993	355191
24723	38576	7	applied	\N	\N	\N	\N	187994	187994	355192
24723	38577	8	applied	\N	\N	\N	\N	187995	187995	355193
24723	38578	9	applied	\N	\N	\N	\N	187996	187996	355194
24692	38474	3	applied	\N	\N	\N	\N	187713	187713	354911
24692	38475	4	applied	\N	\N	\N	\N	187714	187714	354912
24702	38516	19	applied	\N	\N	\N	\N	187786	187786	354984
24702	38517	20	applied	\N	\N	\N	\N	187787	187787	354985
24702	38518	21	applied	\N	\N	\N	\N	187788	187788	354986
24702	38519	22	applied	\N	\N	\N	\N	187789	187789	354987
24702	38520	23	applied	\N	\N	\N	\N	187790	187790	354988
24702	38521	24	applied	\N	\N	\N	\N	187791	187791	354989
24702	38522	25	applied	\N	\N	\N	\N	187792	187792	354990
24702	38523	26	applied	\N	\N	\N	\N	187793	187793	354991
24705	38497	0	applied	\N	\N	\N	\N	187848	187848	355046
24705	38498	1	applied	\N	\N	\N	\N	187849	187849	355047
24705	38499	2	applied	\N	\N	\N	\N	187850	187850	355048
24705	38500	3	applied	\N	\N	\N	\N	187851	187851	355049
24705	38501	4	applied	\N	\N	\N	\N	187852	187852	355050
24705	38502	5	applied	\N	\N	\N	\N	187853	187853	355051
24705	38503	6	applied	\N	\N	\N	\N	187854	187854	355052
24705	38504	7	applied	\N	\N	\N	\N	187855	187855	355053
24705	38506	9	applied	\N	\N	\N	\N	187857	187857	355055
24705	38507	10	applied	\N	\N	\N	\N	187858	187858	355056
24705	38508	11	applied	\N	\N	\N	\N	187859	187859	355057
24705	38509	12	applied	\N	\N	\N	\N	187860	187860	355058
24705	38510	13	applied	\N	\N	\N	\N	187861	187861	355059
24705	38511	14	applied	\N	\N	\N	\N	187862	187862	355060
24705	38512	15	applied	\N	\N	\N	\N	187863	187863	355061
24705	38513	16	applied	\N	\N	\N	\N	187864	187864	355062
24705	38514	17	applied	\N	\N	\N	\N	187865	187865	355063
24705	38515	18	applied	\N	\N	\N	\N	187866	187866	355064
24705	38516	19	applied	\N	\N	\N	\N	187867	187867	355065
24705	38517	20	applied	\N	\N	\N	\N	187868	187868	355066
24705	38518	21	applied	\N	\N	\N	\N	187869	187869	355067
24705	38519	22	applied	\N	\N	\N	\N	187870	187870	355068
24705	38520	23	applied	\N	\N	\N	\N	187871	187871	355069
24705	38521	24	applied	\N	\N	\N	\N	187872	187872	355070
24705	38523	26	applied	\N	\N	\N	\N	187874	187874	355072
24706	38524	0	applied	\N	\N	\N	\N	187875	187875	355073
24706	38525	1	applied	\N	\N	\N	\N	187876	187876	355074
24706	38526	2	applied	\N	\N	\N	\N	187877	187877	355075
24706	38527	3	applied	\N	\N	\N	\N	187878	187878	355076
24706	38528	4	applied	\N	\N	\N	\N	187879	187879	355077
24706	38529	5	applied	\N	\N	\N	\N	187880	187880	355078
24706	38530	6	applied	\N	\N	\N	\N	187881	187881	355079
24709	38544	0	applied	\N	\N	\N	\N	187900	187900	355098
24709	38547	1	applied	\N	\N	\N	\N	187901	187901	355099
24709	38548	2	applied	\N	\N	\N	\N	187902	187902	355100
24711	38549	0	applied	\N	\N	\N	\N	187911	187911	355109
24711	38550	1	applied	\N	\N	\N	\N	187912	187912	355110
24711	38551	2	applied	\N	\N	\N	\N	187913	187913	355111
24711	38552	3	applied	\N	\N	\N	\N	187914	187914	355112
24711	38553	4	applied	\N	\N	\N	\N	187915	187915	355113
24711	38555	6	applied	\N	\N	\N	\N	187917	187917	355115
24714	38556	0	applied	\N	\N	\N	\N	187932	187932	355130
24714	38557	1	applied	\N	\N	\N	\N	187933	187933	355131
24714	38558	2	applied	\N	\N	\N	\N	187934	187934	355132
24714	38559	3	applied	\N	\N	\N	\N	187935	187935	355133
24714	38560	4	applied	\N	\N	\N	\N	187936	187936	355134
24714	38561	5	applied	\N	\N	\N	\N	187937	187937	355135
24714	38562	6	applied	\N	\N	\N	\N	187938	187938	355136
24723	38585	10	applied	\N	\N	\N	\N	187997	187997	355195
24723	38586	11	applied	\N	\N	\N	\N	187998	187998	355196
24723	38587	12	applied	\N	\N	\N	\N	187999	187999	355197
24723	38588	13	applied	\N	\N	\N	\N	188000	188000	355198
24723	38589	14	applied	\N	\N	\N	\N	188001	188001	355199
24723	38590	15	applied	\N	\N	\N	\N	188002	188002	355200
24723	38591	16	applied	\N	\N	\N	\N	188003	188003	355201
24723	38592	17	applied	\N	\N	\N	\N	188004	188004	355202
24723	38594	19	applied	\N	\N	\N	\N	188006	188006	355204
24723	38595	20	applied	\N	\N	\N	\N	188007	188007	355205
24723	38596	21	applied	\N	\N	\N	\N	188008	188008	355206
24723	38597	22	applied	\N	\N	\N	\N	188009	188009	355207
24723	38598	23	applied	\N	\N	\N	\N	188010	188010	355208
24723	38599	24	applied	\N	\N	\N	\N	188011	188011	355209
24723	38600	25	applied	\N	\N	\N	\N	188012	188012	355210
24723	38601	26	applied	\N	\N	\N	\N	188013	188013	355211
24723	38602	27	applied	\N	\N	\N	\N	188014	188014	355212
24723	38603	28	applied	\N	\N	\N	\N	188015	188015	355213
24723	38604	29	applied	\N	\N	\N	\N	188016	188016	355214
24723	38605	30	applied	\N	\N	\N	\N	188017	188017	355215
24723	38606	31	applied	\N	\N	\N	\N	188018	188018	355216
24723	38607	32	applied	\N	\N	\N	\N	188019	188019	355217
24723	38579	33	applied	\N	\N	\N	\N	188020	188020	355218
24723	38580	34	applied	\N	\N	\N	\N	188021	188021	355219
24723	38609	36	applied	\N	\N	\N	\N	188023	188023	355221
24723	38610	37	applied	\N	\N	\N	\N	188024	188024	355222
24723	38611	38	applied	\N	\N	\N	\N	188025	188025	355223
24723	38612	39	applied	\N	\N	\N	\N	188026	188026	355224
24723	38613	40	applied	\N	\N	\N	\N	188027	188027	355225
24724	38573	0	applied	\N	\N	\N	\N	188031	188031	355229
24724	38581	1	applied	\N	\N	\N	\N	188032	188032	355230
24724	38582	2	applied	\N	\N	\N	\N	188033	188033	355231
24724	38583	3	applied	\N	\N	\N	\N	188034	188034	355232
24724	38584	4	applied	\N	\N	\N	\N	188035	188035	355233
24724	38574	5	applied	\N	\N	\N	\N	188036	188036	355234
24724	38575	6	applied	\N	\N	\N	\N	188037	188037	355235
24724	38576	7	applied	\N	\N	\N	\N	188038	188038	355236
24724	38577	8	applied	\N	\N	\N	\N	188039	188039	355237
24724	38578	9	applied	\N	\N	\N	\N	188040	188040	355238
24724	38585	10	applied	\N	\N	\N	\N	188041	188041	355239
24724	38587	12	applied	\N	\N	\N	\N	188043	188043	355241
24724	38588	13	applied	\N	\N	\N	\N	188044	188044	355242
24724	38589	14	applied	\N	\N	\N	\N	188045	188045	355243
24724	38590	15	applied	\N	\N	\N	\N	188046	188046	355244
24724	38591	16	applied	\N	\N	\N	\N	188047	188047	355245
24724	38592	17	applied	\N	\N	\N	\N	188048	188048	355246
24724	38593	18	applied	\N	\N	\N	\N	188049	188049	355247
24724	38594	19	applied	\N	\N	\N	\N	188050	188050	355248
24724	38595	20	applied	\N	\N	\N	\N	188051	188051	355249
24724	38596	21	applied	\N	\N	\N	\N	188052	188052	355250
24724	38597	22	applied	\N	\N	\N	\N	188053	188053	355251
24724	38598	23	applied	\N	\N	\N	\N	188054	188054	355252
24724	38599	24	applied	\N	\N	\N	\N	188055	188055	355253
24724	38600	25	applied	\N	\N	\N	\N	188056	188056	355254
24702	38513	16	applied	\N	\N	\N	\N	187783	187783	354981
24702	38514	17	applied	\N	\N	\N	\N	187784	187784	354982
24715	38557	0	applied	\N	\N	\N	\N	187939	187939	355137
24715	38561	1	applied	\N	\N	\N	\N	187940	187940	355138
24715	38562	2	applied	\N	\N	\N	\N	187941	187941	355139
24717	38563	0	applied	\N	\N	\N	\N	187949	187949	355147
24717	38556	1	applied	\N	\N	\N	\N	187950	187950	355148
24717	38558	2	applied	\N	\N	\N	\N	187951	187951	355149
24717	38559	3	applied	\N	\N	\N	\N	187952	187952	355150
24717	38560	4	applied	\N	\N	\N	\N	187953	187953	355151
24717	38564	5	applied	\N	\N	\N	\N	187954	187954	355152
24719	38573	0	applied	\N	\N	\N	\N	187963	187963	355161
24719	38574	1	applied	\N	\N	\N	\N	187964	187964	355162
24719	38575	2	applied	\N	\N	\N	\N	187965	187965	355163
24719	38576	3	applied	\N	\N	\N	\N	187966	187966	355164
24719	38577	4	applied	\N	\N	\N	\N	187967	187967	355165
24719	38578	5	applied	\N	\N	\N	\N	187968	187968	355166
24719	38579	6	applied	\N	\N	\N	\N	187969	187969	355167
24724	38601	26	applied	\N	\N	\N	\N	188057	188057	355255
24724	38602	27	applied	\N	\N	\N	\N	188058	188058	355256
24724	38603	28	applied	\N	\N	\N	\N	188059	188059	355257
24724	38604	29	applied	\N	\N	\N	\N	188060	188060	355258
24724	38605	30	applied	\N	\N	\N	\N	188061	188061	355259
24724	38606	31	applied	\N	\N	\N	\N	188062	188062	355260
24724	38607	32	applied	\N	\N	\N	\N	188063	188063	355261
24724	38579	33	applied	\N	\N	\N	\N	188064	188064	355262
24724	38580	34	applied	\N	\N	\N	\N	188065	188065	355263
24724	38608	35	applied	\N	\N	\N	\N	188066	188066	355264
24724	38609	36	applied	\N	\N	\N	\N	188067	188067	355265
24724	38610	37	applied	\N	\N	\N	\N	188068	188068	355266
24724	38611	38	applied	\N	\N	\N	\N	188069	188069	355267
24724	38612	39	applied	\N	\N	\N	\N	188070	188070	355268
24724	38613	40	applied	\N	\N	\N	\N	188071	188071	355269
24724	38614	41	applied	\N	\N	\N	\N	188072	188072	355270
24724	38616	43	applied	\N	\N	\N	\N	188074	188074	355272
24725	38573	0	applied	\N	\N	\N	\N	188075	188075	355273
24725	38581	1	applied	\N	\N	\N	\N	188076	188076	355274
24725	38582	2	applied	\N	\N	\N	\N	188077	188077	355275
24725	38583	3	applied	\N	\N	\N	\N	188078	188078	355276
24725	38584	4	applied	\N	\N	\N	\N	188079	188079	355277
24725	38574	5	applied	\N	\N	\N	\N	188080	188080	355278
24725	38575	6	applied	\N	\N	\N	\N	188081	188081	355279
24725	38576	7	applied	\N	\N	\N	\N	188082	188082	355280
24725	38577	8	applied	\N	\N	\N	\N	188083	188083	355281
24725	38578	9	applied	\N	\N	\N	\N	188084	188084	355282
24725	38585	10	applied	\N	\N	\N	\N	188085	188085	355283
24725	38586	11	applied	\N	\N	\N	\N	188086	188086	355284
24725	38587	12	applied	\N	\N	\N	\N	188087	188087	355285
24725	38588	13	applied	\N	\N	\N	\N	188088	188088	355286
24725	38589	14	applied	\N	\N	\N	\N	188089	188089	355287
24725	38591	16	applied	\N	\N	\N	\N	188091	188091	355289
24725	38592	17	applied	\N	\N	\N	\N	188092	188092	355290
24725	38593	18	applied	\N	\N	\N	\N	188093	188093	355291
24725	38594	19	applied	\N	\N	\N	\N	188094	188094	355292
24725	38595	20	applied	\N	\N	\N	\N	188095	188095	355293
24725	38596	21	applied	\N	\N	\N	\N	188096	188096	355294
24725	38597	22	applied	\N	\N	\N	\N	188097	188097	355295
24725	38598	23	applied	\N	\N	\N	\N	188098	188098	355296
24725	38599	24	applied	\N	\N	\N	\N	188099	188099	355297
24725	38600	25	applied	\N	\N	\N	\N	188100	188100	355298
24725	38601	26	applied	\N	\N	\N	\N	188101	188101	355299
24725	38602	27	applied	\N	\N	\N	\N	188102	188102	355300
24725	38603	28	applied	\N	\N	\N	\N	188103	188103	355301
24725	38604	29	applied	\N	\N	\N	\N	188104	188104	355302
24725	38605	30	applied	\N	\N	\N	\N	188105	188105	355303
24725	38606	31	applied	\N	\N	\N	\N	188106	188106	355304
24725	38579	33	applied	\N	\N	\N	\N	188108	188108	355306
24725	38580	34	applied	\N	\N	\N	\N	188109	188109	355307
24725	38608	35	applied	\N	\N	\N	\N	188110	188110	355308
24725	38609	36	applied	\N	\N	\N	\N	188111	188111	355309
24725	38610	37	applied	\N	\N	\N	\N	188112	188112	355310
24725	38611	38	applied	\N	\N	\N	\N	188113	188113	355311
24725	38612	39	applied	\N	\N	\N	\N	188114	188114	355312
24725	38613	40	applied	\N	\N	\N	\N	188115	188115	355313
24725	38614	41	applied	\N	\N	\N	\N	188116	188116	355314
24725	38615	42	applied	\N	\N	\N	\N	188117	188117	355315
24725	38616	43	applied	\N	\N	\N	\N	188118	188118	355316
24726	38617	0	applied	\N	\N	\N	\N	188119	188119	355317
24726	38618	1	applied	\N	\N	\N	\N	188120	188120	355318
24726	38619	2	applied	\N	\N	\N	\N	188121	188121	355319
24726	38620	3	applied	\N	\N	\N	\N	188122	188122	355320
24726	38621	4	applied	\N	\N	\N	\N	188123	188123	355321
24726	38623	6	applied	\N	\N	\N	\N	188125	188125	355323
24726	38624	7	applied	\N	\N	\N	\N	188126	188126	355324
24726	38625	8	applied	\N	\N	\N	\N	188127	188127	355325
24726	38626	9	applied	\N	\N	\N	\N	188128	188128	355326
24726	38627	10	applied	\N	\N	\N	\N	188129	188129	355327
24726	38628	11	applied	\N	\N	\N	\N	188130	188130	355328
24726	38629	12	applied	\N	\N	\N	\N	188131	188131	355329
24727	38634	0	applied	\N	\N	\N	\N	188136	188136	355334
24727	38635	1	applied	\N	\N	\N	\N	188137	188137	355335
24727	38636	2	applied	\N	\N	\N	\N	188138	188138	355336
24727	38637	3	applied	\N	\N	\N	\N	188139	188139	355337
24727	38638	4	applied	\N	\N	\N	\N	188140	188140	355338
24727	38639	5	applied	\N	\N	\N	\N	188141	188141	355339
24729	38640	0	applied	\N	\N	\N	\N	188145	188145	355343
24729	38641	1	applied	\N	\N	\N	\N	188146	188146	355344
24729	38642	2	applied	\N	\N	\N	\N	188147	188147	355345
24734	38651	1	applied	\N	\N	\N	\N	188156	188156	355354
24734	38652	2	applied	\N	\N	\N	\N	188157	188157	355355
24734	38653	4	applied	\N	\N	\N	\N	188158	188158	355356
24734	38654	5	applied	\N	\N	\N	\N	188159	188159	355357
24734	38655	6	applied	\N	\N	\N	\N	188160	188160	355358
24734	38656	7	applied	\N	\N	\N	\N	188161	188161	355359
24734	38657	8	applied	\N	\N	\N	\N	188162	188162	355360
24736	38650	0	applied	\N	\N	\N	\N	188170	188170	355368
24736	38651	1	applied	\N	\N	\N	\N	188171	188171	355369
24736	38653	2	applied	\N	\N	\N	\N	188172	188172	355370
24736	38654	4	applied	\N	\N	\N	\N	188173	188173	355371
24736	38655	5	applied	\N	\N	\N	\N	188174	188174	355372
24736	38656	6	applied	\N	\N	\N	\N	188175	188175	355373
24736	38657	7	applied	\N	\N	\N	\N	188176	188176	355374
24712	38553	4	applied	\N	\N	\N	\N	187922	187922	355120
24712	38554	5	applied	\N	\N	\N	\N	187923	187923	355121
24732	38643	0	applied	\N	\N	\N	\N	188148	188148	355346
24732	38644	1	applied	\N	\N	\N	\N	188149	188149	355347
24732	38645	2	applied	\N	\N	\N	\N	188150	188150	355348
24732	38646	3	applied	\N	\N	\N	\N	188151	188151	355349
24732	38647	4	applied	\N	\N	\N	\N	188152	188152	355350
24732	38648	5	applied	\N	\N	\N	\N	188153	188153	355351
24732	38649	6	applied	\N	\N	\N	\N	188154	188154	355352
24735	38650	0	applied	\N	\N	\N	\N	188163	188163	355361
24735	38651	1	applied	\N	\N	\N	\N	188164	188164	355362
24735	38653	2	applied	\N	\N	\N	\N	188165	188165	355363
24735	38654	4	applied	\N	\N	\N	\N	188166	188166	355364
24735	38655	5	applied	\N	\N	\N	\N	188167	188167	355365
24735	38656	6	applied	\N	\N	\N	\N	188168	188168	355366
24735	38657	7	applied	\N	\N	\N	\N	188169	188169	355367
24737	38658	0	applied	\N	\N	\N	\N	188177	188177	355375
24737	38652	1	applied	\N	\N	\N	\N	188178	188178	355376
24737	38660	3	applied	\N	\N	\N	\N	188180	188180	355378
24737	38661	4	applied	\N	\N	\N	\N	188181	188181	355379
24737	38662	5	applied	\N	\N	\N	\N	188182	188182	355380
24737	38663	6	applied	\N	\N	\N	\N	188183	188183	355381
24737	38664	7	applied	\N	\N	\N	\N	188184	188184	355382
24739	38665	0	applied	\N	\N	\N	\N	188193	188193	355391
24739	38666	1	applied	\N	\N	\N	\N	188194	188194	355392
24739	38667	2	applied	\N	\N	\N	\N	188195	188195	355393
24739	38668	3	applied	\N	\N	\N	\N	188196	188196	355394
24739	38669	4	applied	\N	\N	\N	\N	188197	188197	355395
24739	38670	5	applied	\N	\N	\N	\N	188198	188198	355396
24739	38671	6	applied	\N	\N	\N	\N	188199	188199	355397
24744	38690	0	applied	\N	\N	\N	\N	188262	188262	355460
24744	38691	1	applied	\N	\N	\N	\N	188263	188263	355461
24744	38692	2	applied	\N	\N	\N	\N	188264	188264	355462
24744	38693	3	applied	\N	\N	\N	\N	188265	188265	355463
24744	38695	5	applied	\N	\N	\N	\N	188267	188267	355465
24744	38696	6	applied	\N	\N	\N	\N	188268	188268	355466
24744	38697	7	applied	\N	\N	\N	\N	188269	188269	355467
24746	38698	0	applied	\N	\N	\N	\N	188278	188278	355476
24746	38699	1	applied	\N	\N	\N	\N	188279	188279	355477
24746	38700	2	applied	\N	\N	\N	\N	188280	188280	355478
24746	38701	3	applied	\N	\N	\N	\N	188281	188281	355479
24746	38702	4	applied	\N	\N	\N	\N	188282	188282	355480
24746	38703	5	applied	\N	\N	\N	\N	188283	188283	355481
24746	38704	6	applied	\N	\N	\N	\N	188284	188284	355482
24746	38705	7	applied	\N	\N	\N	\N	188285	188285	355483
24747	38698	0	applied	\N	\N	\N	\N	188286	188286	355484
24747	38699	1	applied	\N	\N	\N	\N	188287	188287	355485
24747	38700	2	applied	\N	\N	\N	\N	188288	188288	355486
24747	38701	3	applied	\N	\N	\N	\N	188289	188289	355487
24747	38702	4	applied	\N	\N	\N	\N	188290	188290	355488
24747	38704	6	applied	\N	\N	\N	\N	188292	188292	355490
24747	38705	7	applied	\N	\N	\N	\N	188293	188293	355491
24749	38710	0	applied	\N	\N	\N	\N	188298	188298	355496
24749	38711	1	applied	\N	\N	\N	\N	188299	188299	355497
24749	38712	2	applied	\N	\N	\N	\N	188300	188300	355498
24749	38713	3	applied	\N	\N	\N	\N	188301	188301	355499
24749	38714	4	applied	\N	\N	\N	\N	188302	188302	355500
24749	38715	5	applied	\N	\N	\N	\N	188303	188303	355501
24749	38716	6	applied	\N	\N	\N	\N	188304	188304	355502
24749	38717	7	applied	\N	\N	\N	\N	188305	188305	355503
24752	38726	0	applied	\N	\N	\N	\N	188322	188322	355520
24752	38727	1	applied	\N	\N	\N	\N	188323	188323	355521
24752	38728	2	applied	\N	\N	\N	\N	188324	188324	355522
24752	38729	3	applied	\N	\N	\N	\N	188325	188325	355523
24753	38726	0	applied	\N	\N	\N	\N	188326	188326	355524
24753	38727	1	applied	\N	\N	\N	\N	188327	188327	355525
24753	38729	3	applied	\N	\N	\N	\N	188329	188329	355527
24754	38730	0	applied	\N	\N	\N	\N	188330	188330	355528
24754	38731	1	applied	\N	\N	\N	\N	188331	188331	355529
24754	38732	2	applied	\N	\N	\N	\N	188332	188332	355530
24755	38730	0	applied	\N	\N	\N	\N	188333	188333	355531
24755	38731	1	applied	\N	\N	\N	\N	188334	188334	355532
24755	38732	2	applied	\N	\N	\N	\N	188335	188335	355533
24758	38730	0	applied	\N	\N	\N	\N	188341	188341	355539
24758	38731	1	applied	\N	\N	\N	\N	188342	188342	355540
24758	38732	2	applied	\N	\N	\N	\N	188343	188343	355541
24759	38733	0	applied	\N	\N	\N	\N	188344	188344	355542
24759	38734	1	applied	\N	\N	\N	\N	188345	188345	355543
24759	38735	2	applied	\N	\N	\N	\N	188346	188346	355544
24759	38736	3	applied	\N	\N	\N	\N	188347	188347	355545
24759	38737	4	applied	\N	\N	\N	\N	188348	188348	355546
24759	38738	5	applied	\N	\N	\N	\N	188349	188349	355547
24761	38733	0	applied	\N	\N	\N	\N	188356	188356	355554
24761	38734	1	applied	\N	\N	\N	\N	188357	188357	355555
24761	38735	2	applied	\N	\N	\N	\N	188358	188358	355556
24761	38736	3	applied	\N	\N	\N	\N	188359	188359	355557
24761	38737	4	applied	\N	\N	\N	\N	188360	188360	355558
24762	38733	0	applied	\N	\N	\N	\N	188363	188363	355561
24762	38734	1	applied	\N	\N	\N	\N	188364	188364	355562
24762	38735	2	applied	\N	\N	\N	\N	188365	188365	355563
24762	38736	3	applied	\N	\N	\N	\N	188366	188366	355564
24762	38737	4	applied	\N	\N	\N	\N	188367	188367	355565
24762	38738	5	applied	\N	\N	\N	\N	188368	188368	355566
24762	38739	6	applied	\N	\N	\N	\N	188369	188369	355567
24765	38750	0	applied	\N	\N	\N	\N	188387	188387	355585
24765	38751	1	applied	\N	\N	\N	\N	188388	188388	355586
24765	38752	2	applied	\N	\N	\N	\N	188389	188389	355587
24765	38753	3	applied	\N	\N	\N	\N	188390	188390	355588
24765	38755	6	applied	\N	\N	\N	\N	188392	188392	355590
24765	38756	7	applied	\N	\N	\N	\N	188393	188393	355591
24768	38757	0	applied	\N	\N	\N	\N	188400	188400	355598
24768	38758	1	applied	\N	\N	\N	\N	188401	188401	355599
24769	38760	0	applied	\N	\N	\N	\N	188402	188402	355600
24769	38761	1	applied	\N	\N	\N	\N	188403	188403	355601
24769	38762	2	applied	\N	\N	\N	\N	188404	188404	355602
24775	38770	0	applied	\N	\N	\N	\N	188421	188421	355619
24775	38771	1	applied	\N	\N	\N	\N	188422	188422	355620
24777	38772	0	applied	\N	\N	\N	\N	188427	188427	355625
24777	38773	1	applied	\N	\N	\N	\N	188428	188428	355626
24777	38774	2	applied	\N	\N	\N	\N	188429	188429	355627
24777	38775	3	applied	\N	\N	\N	\N	188430	188430	355628
24780	38782	0	applied	\N	\N	\N	\N	188443	188443	355641
24720	38578	5	applied	\N	\N	\N	\N	187976	187976	355174
24720	38579	6	applied	\N	\N	\N	\N	187977	187977	355175
24728	38641	1	applied	\N	\N	\N	\N	188143	188143	355341
24728	38642	2	applied	\N	\N	\N	\N	188144	188144	355342
24738	38658	0	applied	\N	\N	\N	\N	188185	188185	355383
24738	38652	1	applied	\N	\N	\N	\N	188186	188186	355384
24738	38659	2	applied	\N	\N	\N	\N	188187	188187	355385
24738	38660	3	applied	\N	\N	\N	\N	188188	188188	355386
24738	38661	4	applied	\N	\N	\N	\N	188189	188189	355387
24738	38662	5	applied	\N	\N	\N	\N	188190	188190	355388
24738	38663	6	applied	\N	\N	\N	\N	188191	188191	355389
24738	38664	7	applied	\N	\N	\N	\N	188192	188192	355390
24740	38672	0	applied	\N	\N	\N	\N	188200	188200	355398
24740	38673	1	applied	\N	\N	\N	\N	188201	188201	355399
24740	38674	2	applied	\N	\N	\N	\N	188202	188202	355400
24740	38675	3	applied	\N	\N	\N	\N	188203	188203	355401
24740	38677	5	applied	\N	\N	\N	\N	188205	188205	355403
24740	38678	6	applied	\N	\N	\N	\N	188206	188206	355404
24740	38679	7	applied	\N	\N	\N	\N	188207	188207	355405
24740	38680	8	applied	\N	\N	\N	\N	188208	188208	355406
24740	38681	9	applied	\N	\N	\N	\N	188209	188209	355407
24740	38682	10	applied	\N	\N	\N	\N	188210	188210	355408
24740	38683	11	applied	\N	\N	\N	\N	188211	188211	355409
24740	38684	12	applied	\N	\N	\N	\N	188212	188212	355410
24740	38685	13	applied	\N	\N	\N	\N	188213	188213	355411
24740	38686	14	applied	\N	\N	\N	\N	188214	188214	355412
24740	38687	15	applied	\N	\N	\N	\N	188215	188215	355413
24740	38688	16	applied	\N	\N	\N	\N	188216	188216	355414
24740	38689	17	applied	\N	\N	\N	\N	188217	188217	355415
24742	38672	0	applied	\N	\N	\N	\N	188236	188236	355434
24742	38673	1	applied	\N	\N	\N	\N	188237	188237	355435
24742	38674	2	applied	\N	\N	\N	\N	188238	188238	355436
24742	38676	4	applied	\N	\N	\N	\N	188240	188240	355438
24742	38677	5	applied	\N	\N	\N	\N	188241	188241	355439
24742	38678	6	applied	\N	\N	\N	\N	188242	188242	355440
24742	38679	7	applied	\N	\N	\N	\N	188243	188243	355441
24742	38680	8	applied	\N	\N	\N	\N	188244	188244	355442
24742	38681	9	applied	\N	\N	\N	\N	188245	188245	355443
24742	38682	10	applied	\N	\N	\N	\N	188246	188246	355444
24742	38683	11	applied	\N	\N	\N	\N	188247	188247	355445
24742	38684	12	applied	\N	\N	\N	\N	188248	188248	355446
24742	38685	13	applied	\N	\N	\N	\N	188249	188249	355447
24742	38686	14	applied	\N	\N	\N	\N	188250	188250	355448
24742	38687	15	applied	\N	\N	\N	\N	188251	188251	355449
24742	38688	16	applied	\N	\N	\N	\N	188252	188252	355450
24742	38689	17	applied	\N	\N	\N	\N	188253	188253	355451
24745	38690	0	applied	\N	\N	\N	\N	188270	188270	355468
24745	38691	1	applied	\N	\N	\N	\N	188271	188271	355469
24745	38693	3	applied	\N	\N	\N	\N	188273	188273	355471
24745	38694	4	applied	\N	\N	\N	\N	188274	188274	355472
24745	38695	5	applied	\N	\N	\N	\N	188275	188275	355473
24745	38696	6	applied	\N	\N	\N	\N	188276	188276	355474
24745	38697	7	applied	\N	\N	\N	\N	188277	188277	355475
24750	38710	0	applied	\N	\N	\N	\N	188306	188306	355504
24750	38711	1	applied	\N	\N	\N	\N	188307	188307	355505
24750	38712	2	applied	\N	\N	\N	\N	188308	188308	355506
24750	38713	3	applied	\N	\N	\N	\N	188309	188309	355507
24750	38714	4	applied	\N	\N	\N	\N	188310	188310	355508
24750	38715	5	applied	\N	\N	\N	\N	188311	188311	355509
24750	38716	6	applied	\N	\N	\N	\N	188312	188312	355510
24750	38717	7	applied	\N	\N	\N	\N	188313	188313	355511
24756	38730	0	applied	\N	\N	\N	\N	188336	188336	355534
24756	38731	1	applied	\N	\N	\N	\N	188337	188337	355535
24756	38732	2	applied	\N	\N	\N	\N	188338	188338	355536
24763	38741	1	applied	\N	\N	\N	\N	188371	188371	355569
24763	38742	2	applied	\N	\N	\N	\N	188372	188372	355570
24763	38743	3	applied	\N	\N	\N	\N	188373	188373	355571
24763	38744	4	applied	\N	\N	\N	\N	188374	188374	355572
24763	38745	5	applied	\N	\N	\N	\N	188375	188375	355573
24763	38746	6	applied	\N	\N	\N	\N	188376	188376	355574
24763	38747	7	applied	\N	\N	\N	\N	188377	188377	355575
24763	38748	8	applied	\N	\N	\N	\N	188378	188378	355576
24763	38749	9	applied	\N	\N	\N	\N	188379	188379	355577
24770	38763	0	applied	\N	\N	\N	\N	188405	188405	355603
24770	38764	1	applied	\N	\N	\N	\N	188406	188406	355604
24770	38765	2	applied	\N	\N	\N	\N	188407	188407	355605
24770	38766	3	applied	\N	\N	\N	\N	188408	188408	355606
24772	38767	0	applied	\N	\N	\N	\N	188413	188413	355611
24772	38768	1	applied	\N	\N	\N	\N	188414	188414	355612
24772	38769	2	applied	\N	\N	\N	\N	188415	188415	355613
24778	38777	1	applied	\N	\N	\N	\N	188432	188432	355630
24778	38778	2	applied	\N	\N	\N	\N	188433	188433	355631
24780	38783	1	applied	\N	\N	\N	\N	188444	188444	355642
24780	38784	2	applied	\N	\N	\N	\N	188445	188445	355643
24780	38785	3	applied	\N	\N	\N	\N	188446	188446	355644
24785	38806	0	applied	\N	\N	\N	\N	188522	188522	355719
24785	38807	1	applied	\N	\N	\N	\N	188523	188523	355720
24785	38808	2	applied	\N	\N	\N	\N	188524	188524	355721
24785	38809	3	applied	\N	\N	\N	\N	188525	188525	355722
24793	38824	0	applied	\N	\N	\N	\N	188550	188550	355747
24793	38825	1	applied	\N	\N	\N	\N	188551	188551	355748
24793	38826	2	applied	\N	\N	\N	\N	188552	188552	355749
24793	38829	3	applied	\N	\N	\N	\N	188553	188553	355750
24795	38830	0	applied	\N	\N	\N	\N	188564	188564	355761
24795	38831	1	applied	\N	\N	\N	\N	188565	188565	355762
24795	38832	2	applied	\N	\N	\N	\N	188566	188566	355763
24795	38834	4	applied	\N	\N	\N	\N	188568	188568	355765
24795	38835	5	applied	\N	\N	\N	\N	188569	188569	355766
24795	38836	6	applied	\N	\N	\N	\N	188570	188570	355767
24800	38847	0	applied	\N	\N	1000000000	\N	188585	188585	355782
24800	38848	1	applied	\N	\N	\N	\N	188586	188586	355783
24800	38849	2	applied	\N	\N	\N	\N	188587	188587	355784
24800	38850	3	applied	\N	\N	\N	\N	188588	188588	355785
24803	38859	0	applied	\N	\N	\N	\N	188597	188597	355794
24803	38860	1	applied	\N	\N	\N	\N	188598	188598	355795
24803	38861	2	applied	\N	\N	\N	\N	188599	188599	355796
24803	38862	3	applied	\N	\N	\N	\N	188600	188600	355797
24803	38863	4	applied	\N	\N	\N	\N	188601	188601	355798
24803	38864	5	applied	\N	\N	\N	\N	188602	188602	355799
24805	38865	0	applied	\N	\N	\N	\N	188609	188609	355806
24805	38866	1	applied	\N	\N	\N	\N	188610	188610	355807
24805	38867	2	applied	\N	\N	\N	\N	188611	188611	355808
24728	38640	0	applied	\N	\N	\N	\N	188142	188142	355340
24741	38672	0	applied	\N	\N	\N	\N	188218	188218	355416
24741	38673	1	applied	\N	\N	\N	\N	188219	188219	355417
24741	38674	2	applied	\N	\N	\N	\N	188220	188220	355418
24741	38675	3	applied	\N	\N	\N	\N	188221	188221	355419
24741	38676	4	applied	\N	\N	\N	\N	188222	188222	355420
24741	38677	5	applied	\N	\N	\N	\N	188223	188223	355421
24741	38678	6	applied	\N	\N	\N	\N	188224	188224	355422
24741	38679	7	applied	\N	\N	\N	\N	188225	188225	355423
24741	38680	8	applied	\N	\N	\N	\N	188226	188226	355424
24741	38681	9	applied	\N	\N	\N	\N	188227	188227	355425
24741	38682	10	applied	\N	\N	\N	\N	188228	188228	355426
24741	38683	11	applied	\N	\N	\N	\N	188229	188229	355427
24741	38684	12	applied	\N	\N	\N	\N	188230	188230	355428
24741	38685	13	applied	\N	\N	\N	\N	188231	188231	355429
24741	38686	14	applied	\N	\N	\N	\N	188232	188232	355430
24741	38687	15	applied	\N	\N	\N	\N	188233	188233	355431
24741	38689	17	applied	\N	\N	\N	\N	188235	188235	355433
24743	38690	0	applied	\N	\N	\N	\N	188254	188254	355452
24743	38691	1	applied	\N	\N	\N	\N	188255	188255	355453
24743	38692	2	applied	\N	\N	\N	\N	188256	188256	355454
24743	38693	3	applied	\N	\N	\N	\N	188257	188257	355455
24743	38694	4	applied	\N	\N	\N	\N	188258	188258	355456
24743	38695	5	applied	\N	\N	\N	\N	188259	188259	355457
24743	38696	6	applied	\N	\N	\N	\N	188260	188260	355458
24743	38697	7	applied	\N	\N	\N	\N	188261	188261	355459
24748	38706	0	applied	\N	\N	\N	\N	188294	188294	355492
24748	38707	1	applied	\N	\N	\N	\N	188295	188295	355493
24748	38708	2	applied	\N	\N	\N	\N	188296	188296	355494
24748	38709	3	applied	\N	\N	\N	\N	188297	188297	355495
24751	38718	0	applied	\N	\N	\N	\N	188314	188314	355512
24751	38719	1	applied	\N	\N	\N	\N	188315	188315	355513
24751	38720	2	applied	\N	\N	\N	\N	188316	188316	355514
24751	38722	4	applied	\N	\N	\N	\N	188318	188318	355516
24751	38723	5	applied	\N	\N	\N	\N	188319	188319	355517
24751	38724	6	applied	\N	\N	\N	\N	188320	188320	355518
24751	38725	7	applied	\N	\N	\N	\N	188321	188321	355519
24757	38730	0	applied	\N	\N	\N	\N	188339	188339	355537
24757	38731	1	applied	\N	\N	\N	\N	188340	188340	355538
24760	38733	0	applied	\N	\N	\N	\N	188351	188351	355549
24760	38734	1	applied	\N	\N	\N	\N	188352	188352	355550
24760	38735	2	applied	\N	\N	\N	\N	188353	188353	355551
24760	38738	3	applied	\N	\N	\N	\N	188354	188354	355552
24760	38739	4	applied	\N	\N	\N	\N	188355	188355	355553
24766	38757	0	applied	\N	\N	\N	\N	188394	188394	355592
24766	38758	1	applied	\N	\N	\N	\N	188395	188395	355593
24766	38759	2	applied	\N	\N	\N	\N	188396	188396	355594
24771	38763	0	applied	\N	\N	\N	\N	188409	188409	355607
24771	38764	1	applied	\N	\N	\N	\N	188410	188410	355608
24771	38766	3	applied	\N	\N	\N	\N	188412	188412	355610
24773	38767	0	applied	\N	\N	\N	\N	188416	188416	355614
24773	38768	1	applied	\N	\N	\N	\N	188417	188417	355615
24773	38769	2	applied	\N	\N	\N	\N	188418	188418	355616
24776	38772	0	applied	\N	\N	\N	\N	188423	188423	355621
24776	38773	1	applied	\N	\N	\N	\N	188424	188424	355622
24776	38774	2	applied	\N	\N	\N	\N	188425	188425	355623
24776	38775	3	applied	\N	\N	\N	\N	188426	188426	355624
24778	38779	3	applied	\N	\N	\N	\N	188434	188434	355632
24778	38780	4	applied	\N	\N	\N	\N	188435	188435	355633
24778	38781	5	applied	\N	\N	\N	\N	188436	188436	355634
24779	38776	0	applied	\N	\N	\N	\N	188437	188437	355635
24779	38777	1	applied	\N	\N	\N	\N	188438	188438	355636
24779	38778	2	applied	\N	\N	\N	\N	188439	188439	355637
24779	38779	3	applied	\N	\N	\N	\N	188440	188440	355638
24779	38780	4	applied	\N	\N	\N	\N	188441	188441	355639
24781	38248	0	applied	\N	\N	\N	\N	188447	188447	355645
24781	38335	1	applied	\N	\N	\N	\N	188448	188448	355646
24781	38348	2	applied	\N	\N	\N	\N	188449	188449	355647
24781	38366	3	applied	\N	\N	\N	\N	188450	188450	355648
24781	38374	4	applied	\N	\N	\N	\N	188451	188451	355649
24781	38378	5	applied	\N	\N	\N	\N	188452	188452	355650
24781	38379	6	applied	\N	\N	\N	\N	188453	188453	355651
24781	38477	7	applied	\N	\N	\N	\N	188454	188454	355652
24781	38358	8	applied	\N	\N	\N	\N	188455	188455	355653
24781	38359	9	applied	\N	\N	\N	\N	188456	188456	355654
24781	38291	10	applied	\N	\N	\N	\N	188457	188457	355655
24781	38740	11	applied	\N	\N	\N	\N	188458	188458	355656
24781	38361	12	applied	\N	\N	\N	\N	188459	188459	355657
24781	38362	13	applied	\N	\N	\N	\N	188460	188460	355658
24781	38363	14	applied	\N	\N	\N	\N	188461	188461	188461
24781	38743	15	applied	\N	\N	\N	\N	188462	188462	355659
24781	38479	17	applied	\N	\N	\N	\N	188464	188464	355661
24781	38483	18	applied	\N	\N	\N	\N	188465	188465	355662
24781	38484	19	applied	\N	\N	\N	\N	188466	188466	355663
24781	38485	20	applied	\N	\N	\N	\N	188467	188467	355664
24781	38486	21	applied	\N	\N	\N	\N	188468	188468	355665
24781	38487	22	applied	\N	\N	\N	\N	188469	188469	355666
24781	38491	24	applied	\N	\N	\N	\N	188470	188470	355667
24781	38492	25	applied	\N	\N	\N	\N	188471	188471	355668
24781	38493	26	applied	\N	\N	\N	\N	188472	188472	355669
24781	38494	27	applied	\N	\N	\N	\N	188473	188473	355670
24781	38497	28	applied	\N	\N	\N	\N	188474	188474	355671
24784	38789	0	applied	\N	\N	\N	\N	188505	188505	355702
24784	38790	1	applied	\N	\N	\N	\N	188506	188506	355703
24784	38791	2	applied	\N	\N	\N	\N	188507	188507	355704
24784	38792	3	applied	\N	\N	\N	\N	188508	188508	355705
24784	38793	4	applied	\N	\N	\N	\N	188509	188509	355706
24784	38795	6	applied	\N	\N	\N	\N	188511	188511	355708
24784	38796	7	applied	\N	\N	\N	\N	188512	188512	355709
24784	38797	8	applied	\N	\N	\N	\N	188513	188513	355710
24784	38798	9	applied	\N	\N	\N	\N	188514	188514	355711
24784	38799	10	applied	\N	\N	\N	\N	188515	188515	355712
24784	38800	11	applied	\N	\N	\N	\N	188516	188516	355713
24784	38801	12	applied	\N	\N	\N	\N	188517	188517	355714
24784	38802	13	applied	\N	\N	\N	\N	188518	188518	355715
24784	38803	14	applied	\N	\N	\N	\N	188519	188519	355716
24784	38804	15	applied	\N	\N	\N	\N	188520	188520	355717
24784	38805	16	applied	\N	\N	\N	\N	188521	188521	355718
24789	38816	0	applied	\N	\N	\N	\N	188532	188532	355729
24789	38817	1	applied	\N	\N	\N	\N	188533	188533	355730
24789	38818	2	applied	\N	\N	\N	\N	188534	188534	355731
24726	38631	14	applied	\N	\N	\N	\N	188133	188133	355331
24726	38632	15	applied	\N	\N	\N	\N	188134	188134	355332
24764	38751	1	applied	\N	\N	\N	\N	188381	188381	355579
24764	38752	2	applied	\N	\N	\N	\N	188382	188382	355580
24764	38753	3	applied	\N	\N	\N	\N	188383	188383	355581
24764	38754	5	applied	\N	\N	\N	\N	188384	188384	355582
24764	38755	6	applied	\N	\N	\N	\N	188385	188385	355583
24764	38756	7	applied	\N	\N	\N	\N	188386	188386	355584
24767	38757	0	applied	\N	\N	\N	\N	188397	188397	355595
24767	38759	2	applied	\N	\N	\N	\N	188399	188399	355597
24774	38770	0	applied	\N	\N	\N	\N	188419	188419	355617
24774	38771	1	applied	\N	\N	\N	\N	188420	188420	355618
24789	38819	3	applied	\N	\N	\N	\N	188535	188535	355732
24790	38816	0	applied	\N	\N	\N	\N	188536	188536	355733
24790	38817	1	applied	\N	\N	\N	\N	188537	188537	355734
24790	38818	2	applied	\N	\N	\N	\N	188538	188538	355735
24790	38819	3	applied	\N	\N	\N	\N	188539	188539	355736
24792	38820	0	applied	\N	\N	\N	\N	188540	188540	355737
24792	38821	1	applied	\N	\N	\N	\N	188541	188541	355738
24792	38822	2	applied	\N	\N	\N	\N	188542	188542	355739
24792	38823	3	applied	\N	\N	\N	\N	188543	188543	355740
24792	38824	4	applied	\N	\N	\N	\N	188544	188544	355741
24792	38825	5	applied	\N	\N	\N	\N	188545	188545	355742
24792	38826	6	applied	\N	\N	\N	\N	188546	188546	355743
24792	38827	7	applied	\N	\N	\N	\N	188547	188547	355744
24792	38829	9	applied	\N	\N	\N	\N	188549	188549	355746
24794	38820	0	applied	\N	\N	\N	\N	188554	188554	355751
24794	38821	1	applied	\N	\N	\N	\N	188555	188555	355752
24794	38822	2	applied	\N	\N	\N	\N	188556	188556	355753
24794	38823	3	applied	\N	\N	\N	\N	188557	188557	355754
24794	38824	4	applied	\N	\N	\N	\N	188558	188558	355755
24794	38825	5	applied	\N	\N	\N	\N	188559	188559	355756
24794	38826	6	applied	\N	\N	\N	\N	188560	188560	355757
24794	38827	7	applied	\N	\N	\N	\N	188561	188561	355758
24794	38828	8	applied	\N	\N	\N	\N	188562	188562	355759
24794	38829	9	applied	\N	\N	\N	\N	188563	188563	355760
24797	38840	0	applied	\N	\N	\N	\N	188574	188574	355771
24797	38841	1	applied	\N	\N	\N	\N	188575	188575	355772
24797	38842	2	applied	\N	\N	\N	\N	188576	188576	355773
24797	38843	3	applied	\N	\N	\N	\N	188577	188577	355774
24799	38844	0	applied	\N	\N	\N	\N	188582	188582	355779
24799	38846	3	applied	\N	\N	\N	\N	188584	188584	355781
24802	38856	0	applied	\N	\N	\N	\N	188594	188594	355791
24802	38857	1	applied	\N	\N	\N	\N	188595	188595	355792
24802	38858	2	applied	\N	\N	\N	\N	188596	188596	355793
24809	38871	0	applied	\N	\N	\N	\N	188624	188624	355821
24809	38872	1	applied	\N	\N	\N	\N	188625	188625	355822
24812	38869	0	applied	\N	\N	\N	\N	188742	188742	355939
24812	38873	1	applied	\N	\N	\N	\N	188743	188743	355940
24812	38870	2	applied	\N	\N	\N	\N	188744	188744	355941
24812	38874	3	applied	\N	\N	\N	\N	188745	188745	355942
24812	38875	4	applied	\N	\N	\N	\N	188746	188746	355943
24814	38869	0	applied	\N	\N	\N	\N	188752	188752	355949
24814	38873	1	applied	\N	\N	\N	\N	188753	188753	355950
24814	38870	2	applied	\N	\N	\N	\N	188754	188754	355951
24814	38874	3	applied	\N	\N	\N	\N	188755	188755	355952
24814	38875	4	applied	\N	\N	\N	\N	188756	188756	355953
24815	38847	1	applied	\N	\N	1000000000	\N	188758	188758	355955
24815	38851	2	applied	\N	\N	\N	\N	188759	188759	355956
24815	38860	3	applied	\N	\N	\N	\N	188760	188760	355957
24815	38861	4	applied	\N	\N	\N	\N	188761	188761	355958
24815	38866	5	applied	\N	\N	\N	\N	188762	188762	355959
24815	38862	6	applied	\N	\N	\N	\N	188763	188763	355960
24815	38690	7	applied	\N	\N	\N	\N	188764	188764	355961
24815	38691	8	applied	\N	\N	\N	\N	188765	188765	355962
24815	38692	9	applied	\N	\N	\N	\N	188766	188766	355963
24815	38693	10	applied	\N	\N	\N	\N	188767	188767	355964
24815	38694	11	applied	\N	\N	\N	\N	188768	188768	355965
24815	38699	12	applied	\N	\N	\N	\N	188769	188769	355966
24815	38700	13	applied	\N	\N	\N	\N	188770	188770	355967
24815	38701	14	applied	\N	\N	\N	\N	188771	188771	355968
24815	38702	15	applied	\N	\N	\N	\N	188772	188772	355969
24815	38711	16	applied	\N	\N	\N	\N	188773	188773	355970
24815	38695	18	applied	\N	\N	\N	\N	188775	188775	355972
24815	38698	19	applied	\N	\N	\N	\N	188776	188776	355973
24815	38706	20	applied	\N	\N	\N	\N	188777	188777	355974
24815	38707	21	applied	\N	\N	\N	\N	188778	188778	355975
24815	38710	22	applied	\N	\N	\N	\N	188779	188779	355976
24815	38718	23	applied	\N	\N	\N	\N	188780	188780	355977
24815	38719	24	applied	\N	\N	\N	\N	188781	188781	355978
24815	38720	25	applied	\N	\N	\N	\N	188782	188782	355979
24815	38726	26	applied	\N	\N	\N	\N	188783	188783	355980
24815	38730	27	applied	\N	\N	\N	\N	188784	188784	355981
24815	38733	28	applied	\N	\N	\N	\N	188785	188785	355982
24815	38734	29	applied	\N	\N	\N	\N	188786	188786	355983
24815	38741	30	applied	\N	\N	\N	\N	188787	188787	355984
24815	38742	31	applied	\N	\N	\N	\N	188788	188788	355985
24815	38751	32	applied	\N	\N	\N	\N	188789	188789	355986
24815	38757	33	applied	\N	\N	\N	\N	188790	188790	355987
24815	38744	35	applied	\N	\N	\N	\N	188792	188792	355989
24815	38745	36	applied	\N	\N	\N	\N	188793	188793	355990
24815	38750	37	applied	\N	\N	\N	\N	188794	188794	355991
24815	38760	38	applied	\N	\N	\N	\N	188795	188795	355992
24818	38879	0	applied	\N	\N	\N	\N	188890	188890	356087
24818	38880	1	applied	\N	\N	\N	\N	188891	188891	356088
24818	38881	2	applied	\N	\N	\N	\N	188892	188892	356089
24818	38882	3	applied	\N	\N	\N	\N	188893	188893	356090
24818	38883	4	applied	\N	\N	\N	\N	188894	188894	356091
24821	38887	0	applied	\N	\N	\N	\N	188911	188911	356107
24821	38888	1	applied	\N	\N	\N	\N	188912	188912	356108
24821	38889	2	applied	\N	\N	\N	\N	188913	188913	356109
24821	38891	4	applied	\N	\N	\N	\N	188915	188915	356110
24821	38892	5	applied	\N	\N	\N	\N	188916	188916	356111
24821	38893	6	applied	\N	\N	\N	\N	188917	188917	356112
24821	38894	7	applied	\N	\N	\N	\N	188918	188918	356113
24821	38895	8	applied	\N	\N	\N	\N	188919	188919	356114
24821	38896	9	applied	\N	\N	\N	\N	188920	188920	356115
24821	38897	10	applied	\N	\N	\N	\N	188921	188921	356116
24821	38898	11	applied	\N	\N	\N	\N	188922	188922	356117
24821	38899	12	applied	\N	\N	\N	\N	188923	188923	356118
24823	38900	0	applied	\N	\N	\N	\N	188927	188927	356122
24761	38739	6	applied	\N	\N	\N	\N	188362	188362	355560
24764	38750	0	applied	\N	\N	\N	\N	188380	188380	355578
24781	38504	32	applied	\N	\N	\N	\N	188478	188478	355675
24781	38505	33	applied	\N	\N	\N	\N	188479	188479	355676
24781	38506	34	applied	\N	\N	\N	\N	188480	188480	355677
24781	38507	35	applied	\N	\N	\N	\N	188481	188481	355678
24781	38508	36	applied	\N	\N	\N	\N	188482	188482	355679
24781	38509	37	applied	\N	\N	\N	\N	188483	188483	355680
24781	38510	38	applied	\N	\N	\N	\N	188484	188484	355681
24781	38511	39	applied	\N	\N	\N	\N	188485	188485	355682
24781	38512	40	applied	\N	\N	\N	\N	188486	188486	355683
24781	38514	42	applied	\N	\N	\N	\N	188488	188488	355685
24781	38515	43	applied	\N	\N	\N	\N	188489	188489	355686
24781	38516	44	applied	\N	\N	\N	\N	188490	188490	355687
24781	38524	45	applied	\N	\N	\N	\N	188491	188491	355688
24781	38525	46	applied	\N	\N	\N	\N	188492	188492	355689
24781	38527	47	applied	\N	\N	\N	\N	188493	188493	355690
24781	38528	48	applied	\N	\N	\N	\N	188494	188494	355691
24781	38532	49	applied	\N	\N	\N	\N	188495	188495	355692
24781	38533	50	applied	\N	\N	\N	\N	188496	188496	355693
24781	38534	51	applied	\N	\N	\N	\N	188497	188497	355694
24781	38535	52	applied	\N	\N	\N	\N	188498	188498	355695
24781	38536	53	applied	\N	\N	\N	\N	188499	188499	355696
24781	38537	54	applied	\N	\N	\N	\N	188500	188500	355697
24781	38541	55	applied	\N	\N	\N	\N	188501	188501	355698
24782	38786	0	applied	\N	\N	\N	\N	188502	188502	355699
24782	38787	1	applied	\N	\N	\N	\N	188503	188503	355700
24786	38810	0	applied	\N	\N	\N	\N	188526	188526	355723
24786	38811	1	applied	\N	\N	\N	\N	188527	188527	355724
24786	38812	2	applied	\N	\N	\N	\N	188528	188528	355725
24786	38813	3	applied	\N	\N	\N	\N	188529	188529	355726
24786	38814	4	applied	\N	\N	\N	\N	188530	188530	355727
24786	38815	5	applied	\N	\N	\N	\N	188531	188531	355728
24796	38837	0	applied	\N	\N	\N	\N	188571	188571	355768
24796	38838	1	applied	\N	\N	\N	\N	188572	188572	355769
24796	38839	2	applied	\N	\N	\N	\N	188573	188573	355770
24798	38840	0	applied	\N	\N	\N	\N	188578	188578	355775
24798	38841	1	applied	\N	\N	\N	\N	188579	188579	355776
24798	38842	2	applied	\N	\N	\N	\N	188580	188580	355777
24798	38843	3	applied	\N	\N	\N	\N	188581	188581	355778
24801	38851	0	applied	\N	\N	\N	\N	188589	188589	355786
24801	38852	1	applied	\N	\N	\N	\N	188590	188590	355787
24801	38853	2	applied	\N	\N	\N	\N	188591	188591	355788
24801	38855	4	applied	\N	\N	\N	\N	188593	188593	355790
24804	38859	0	applied	\N	\N	\N	\N	188603	188603	355800
24804	38860	1	applied	\N	\N	\N	\N	188604	188604	355801
24804	38861	2	applied	\N	\N	\N	\N	188605	188605	355802
24804	38862	3	applied	\N	\N	\N	\N	188606	188606	355803
24804	38863	4	applied	\N	\N	\N	\N	188607	188607	355804
24804	38864	5	applied	\N	\N	\N	\N	188608	188608	355805
24806	38865	0	applied	\N	\N	\N	\N	188613	188613	355810
24806	38866	1	applied	\N	\N	\N	\N	188614	188614	355811
24806	38867	2	applied	\N	\N	\N	\N	188615	188615	355812
24806	38868	3	applied	\N	\N	\N	\N	188616	188616	355813
24808	38869	0	applied	\N	\N	\N	\N	188620	188620	355817
24808	38870	1	applied	\N	\N	\N	\N	188621	188621	355818
24808	38871	2	applied	\N	\N	\N	\N	188622	188622	355819
24808	38872	3	applied	\N	\N	\N	\N	188623	188623	355820
24811	38869	0	applied	\N	\N	\N	\N	188738	188738	355935
24811	38871	2	applied	\N	\N	\N	\N	188740	188740	355937
24811	38872	3	applied	\N	\N	\N	\N	188741	188741	355938
24813	38869	0	applied	\N	\N	\N	\N	188747	188747	355944
24813	38873	1	applied	\N	\N	\N	\N	188748	188748	355945
24813	38870	2	applied	\N	\N	\N	\N	188749	188749	355946
24813	38874	3	applied	\N	\N	\N	\N	188750	188750	355947
24813	38875	4	applied	\N	\N	\N	\N	188751	188751	355948
24815	38763	39	applied	\N	\N	\N	\N	188796	188796	355993
24815	38767	40	applied	\N	\N	\N	\N	188797	188797	355994
24815	38770	41	applied	\N	\N	\N	\N	188798	188798	355995
24815	38772	42	applied	\N	\N	\N	\N	188799	188799	355996
24815	38776	43	applied	\N	\N	\N	\N	188800	188800	355997
24815	38777	44	applied	\N	\N	\N	\N	188801	188801	355998
24815	38782	45	applied	\N	\N	\N	\N	188802	188802	355999
24815	38786	46	applied	\N	\N	\N	\N	188803	188803	356000
24815	38789	47	applied	\N	\N	\N	\N	188804	188804	356001
24815	38791	49	applied	\N	\N	\N	\N	188806	188806	356003
24815	38792	50	applied	\N	\N	\N	\N	188807	188807	356004
24815	38793	51	applied	\N	\N	\N	\N	188808	188808	356005
24815	38806	52	applied	\N	\N	\N	\N	188809	188809	356006
24815	38810	53	applied	\N	\N	\N	\N	188810	188810	356007
24815	38811	54	applied	\N	\N	\N	\N	188811	188811	356008
24815	38816	55	applied	\N	\N	\N	\N	188812	188812	356009
24815	38820	56	applied	\N	\N	\N	\N	188813	188813	356010
24815	38821	57	applied	\N	\N	\N	\N	188814	188814	356011
24815	38822	58	applied	\N	\N	\N	\N	188815	188815	356012
24815	38830	59	applied	\N	\N	\N	\N	188816	188816	356013
24815	38831	60	applied	\N	\N	\N	\N	188817	188817	356014
24815	38837	61	applied	\N	\N	\N	\N	188818	188818	356015
24815	38840	62	applied	\N	\N	\N	\N	188819	188819	356016
24815	38844	63	applied	\N	\N	\N	\N	188820	188820	356017
24815	38848	64	applied	\N	\N	\N	\N	188821	188821	356018
24815	38856	66	applied	\N	\N	\N	\N	188823	188823	356020
24815	38859	67	applied	\N	\N	\N	\N	188824	188824	356021
24815	38865	68	applied	\N	\N	\N	\N	188825	188825	356022
24815	38869	69	applied	\N	\N	\N	\N	188826	188826	356023
24817	38879	0	applied	\N	\N	\N	\N	188885	188885	356082
24817	38880	1	applied	\N	\N	\N	\N	188886	188886	356083
24817	38881	2	applied	\N	\N	\N	\N	188887	188887	356084
24817	38882	3	applied	\N	\N	\N	\N	188888	188888	356085
24817	38883	4	applied	\N	\N	\N	\N	188889	188889	356086
24820	38887	0	applied	\N	\N	\N	\N	188898	188898	356095
24820	38888	1	applied	\N	\N	\N	\N	188899	188899	356096
24820	38889	2	applied	\N	\N	\N	\N	188900	188900	356097
24820	38891	4	applied	\N	\N	\N	\N	188902	188902	356098
24820	38892	5	applied	\N	\N	\N	\N	188903	188903	356099
24820	38893	6	applied	\N	\N	\N	\N	188904	188904	356100
24820	38894	7	applied	\N	\N	\N	\N	188905	188905	356101
24820	38895	8	applied	\N	\N	\N	\N	188906	188906	356102
24820	38896	9	applied	\N	\N	\N	\N	188907	188907	356103
24820	38897	10	applied	\N	\N	\N	\N	188908	188908	356104
24820	38898	11	applied	\N	\N	\N	\N	188909	188909	356105
24781	38502	30	applied	\N	\N	\N	\N	188476	188476	355673
24781	38503	31	applied	\N	\N	\N	\N	188477	188477	355674
24810	38477	0	applied	\N	\N	\N	\N	188626	188626	355823
24810	38740	1	applied	\N	\N	\N	\N	188627	188627	355824
24810	38847	2	applied	\N	\N	1000000000	\N	188628	188628	355825
24810	38851	3	applied	\N	\N	\N	\N	188629	188629	355826
24810	38743	4	applied	\N	\N	\N	\N	188630	188630	355827
24810	38744	5	applied	\N	\N	\N	\N	188631	188631	355828
24810	38479	6	applied	\N	\N	\N	\N	188632	188632	355829
24810	38483	7	applied	\N	\N	\N	\N	188633	188633	355830
24810	38484	8	applied	\N	\N	\N	\N	188634	188634	355831
24810	38485	9	applied	\N	\N	\N	\N	188635	188635	355832
24810	38486	10	applied	\N	\N	\N	\N	188636	188636	355833
24810	38487	11	applied	\N	\N	\N	\N	188637	188637	355834
24810	38491	12	applied	\N	\N	\N	\N	188638	188638	355835
24810	38492	13	applied	\N	\N	\N	\N	188639	188639	355836
24810	38494	15	applied	\N	\N	\N	\N	188641	188641	355838
24810	38497	16	applied	\N	\N	\N	\N	188642	188642	355839
24810	38501	17	applied	\N	\N	\N	\N	188643	188643	355840
24810	38502	18	applied	\N	\N	\N	\N	188644	188644	355841
24810	38503	19	applied	\N	\N	\N	\N	188645	188645	355842
24810	38504	20	applied	\N	\N	\N	\N	188646	188646	355843
24810	38505	21	applied	\N	\N	\N	\N	188647	188647	355844
24810	38506	22	applied	\N	\N	\N	\N	188648	188648	355845
24810	38507	23	applied	\N	\N	\N	\N	188649	188649	355846
24810	38508	24	applied	\N	\N	\N	\N	188650	188650	355847
24810	38509	25	applied	\N	\N	\N	\N	188651	188651	355848
24810	38510	26	applied	\N	\N	\N	\N	188652	188652	355849
24810	38511	27	applied	\N	\N	\N	\N	188653	188653	355850
24810	38512	28	applied	\N	\N	\N	\N	188654	188654	355851
24810	38513	29	applied	\N	\N	\N	\N	188655	188655	355852
24810	38514	30	applied	\N	\N	\N	\N	188656	188656	355853
24810	38516	32	applied	\N	\N	\N	\N	188658	188658	355855
24810	38524	33	applied	\N	\N	\N	\N	188659	188659	355856
24810	38525	34	applied	\N	\N	\N	\N	188660	188660	355857
24810	38527	35	applied	\N	\N	\N	\N	188661	188661	355858
24810	38528	36	applied	\N	\N	\N	\N	188662	188662	355859
24810	38532	37	applied	\N	\N	\N	\N	188663	188663	355860
24810	38533	38	applied	\N	\N	\N	\N	188664	188664	355861
24810	38534	39	applied	\N	\N	\N	\N	188665	188665	355862
24810	38535	40	applied	\N	\N	\N	\N	188666	188666	355863
24810	38536	41	applied	\N	\N	\N	\N	188667	188667	355864
24810	38537	42	applied	\N	\N	\N	\N	188668	188668	355865
24810	38541	43	applied	\N	\N	\N	\N	188669	188669	355866
24810	38542	44	applied	\N	\N	\N	\N	188670	188670	355867
24810	38543	45	applied	\N	\N	\N	\N	188671	188671	355868
24810	38545	46	applied	\N	\N	\N	\N	188672	188672	355869
24810	38546	47	applied	\N	\N	\N	\N	188673	188673	355870
24810	38550	49	applied	\N	\N	\N	\N	188675	188675	355872
24810	38552	50	applied	\N	\N	\N	\N	188676	188676	355873
24810	38553	51	applied	\N	\N	\N	\N	188677	188677	355874
24810	38556	52	applied	\N	\N	\N	\N	188678	188678	355875
24810	38558	53	applied	\N	\N	\N	\N	188679	188679	355876
24810	38559	54	applied	\N	\N	\N	\N	188680	188680	355877
24810	38560	55	applied	\N	\N	\N	\N	188681	188681	355878
24810	38568	56	applied	\N	\N	\N	\N	188682	188682	355879
24810	38574	57	applied	\N	\N	\N	\N	188683	188683	355880
24810	38575	58	applied	\N	\N	\N	\N	188684	188684	355881
24810	38576	59	applied	\N	\N	\N	\N	188685	188685	355882
24810	38577	60	applied	\N	\N	\N	\N	188686	188686	355883
24810	38578	61	applied	\N	\N	\N	\N	188687	188687	355884
24810	38745	62	applied	\N	\N	\N	\N	188688	188688	355885
24810	38750	63	applied	\N	\N	\N	\N	188689	188689	355886
24810	38585	64	applied	\N	\N	\N	\N	188690	188690	355887
24810	38587	66	applied	\N	\N	\N	\N	188692	188692	355889
24810	38588	67	applied	\N	\N	\N	\N	188693	188693	355890
24810	38589	68	applied	\N	\N	\N	\N	188694	188694	355891
24810	38590	69	applied	\N	\N	\N	\N	188695	188695	355892
24810	38591	70	applied	\N	\N	\N	\N	188696	188696	355893
24810	38592	71	applied	\N	\N	\N	\N	188697	188697	355894
24810	38593	72	applied	\N	\N	\N	\N	188698	188698	355895
24810	38594	73	applied	\N	\N	\N	\N	188699	188699	355896
24810	38595	74	applied	\N	\N	\N	\N	188700	188700	355897
24810	38596	75	applied	\N	\N	\N	\N	188701	188701	355898
24810	38597	76	applied	\N	\N	\N	\N	188702	188702	355899
24810	38598	77	applied	\N	\N	\N	\N	188703	188703	355900
24810	38599	78	applied	\N	\N	\N	\N	188704	188704	355901
24810	38600	79	applied	\N	\N	\N	\N	188705	188705	355902
24810	38601	80	applied	\N	\N	\N	\N	188706	188706	355903
24810	38602	81	applied	\N	\N	\N	\N	188707	188707	355904
24810	38604	83	applied	\N	\N	\N	\N	188709	188709	355906
24810	38605	84	applied	\N	\N	\N	\N	188710	188710	355907
24820	38899	12	applied	\N	\N	\N	\N	188910	188910	356106
24825	38903	0	applied	\N	\N	\N	\N	188933	188933	356128
24825	38904	1	applied	\N	\N	\N	\N	188934	188934	356129
24825	38905	2	applied	\N	\N	\N	\N	188935	188935	356130
24825	38906	3	applied	\N	\N	\N	\N	188936	188936	356131
24825	38907	4	applied	\N	\N	\N	\N	188937	188937	356132
24825	38908	5	applied	\N	\N	\N	\N	188938	188938	356133
24825	38909	6	applied	\N	\N	\N	\N	188939	188939	356134
24825	38910	7	applied	\N	\N	\N	\N	188940	188940	356135
24830	38911	0	applied	\N	\N	\N	\N	188963	188963	356158
24830	38912	1	applied	\N	\N	\N	\N	188964	188964	356159
24830	38913	2	applied	\N	\N	\N	\N	188965	188965	356160
24834	38917	0	applied	\N	\N	\N	\N	188974	188974	356169
24834	38918	1	applied	\N	\N	\N	\N	188975	188975	356170
24834	38920	3	applied	\N	\N	\N	\N	188977	188977	356172
24834	38921	4	applied	\N	\N	\N	\N	188978	188978	356173
24834	38922	5	applied	\N	\N	\N	\N	188979	188979	356174
24834	38923	6	applied	\N	\N	\N	\N	188980	188980	356175
24837	38927	0	applied	\N	\N	\N	\N	188994	188994	356189
24837	38928	1	applied	\N	\N	\N	\N	188995	188995	356190
24837	38929	2	applied	\N	\N	\N	\N	188996	188996	356191
24837	38930	3	applied	\N	\N	\N	\N	188997	188997	356192
24837	38931	4	applied	\N	\N	\N	\N	188998	188998	356193
24837	38932	5	applied	\N	\N	\N	\N	188999	188999	356194
24837	38933	6	applied	\N	\N	\N	\N	189000	189000	356195
24837	38934	7	applied	\N	\N	\N	\N	189001	189001	356196
24837	38935	8	applied	\N	\N	\N	\N	189002	189002	356197
24837	38936	10	applied	\N	\N	\N	\N	189003	189003	356198
24840	38937	0	applied	\N	\N	\N	\N	189018	189018	356213
24840	38938	1	applied	\N	\N	\N	\N	189019	189019	356214
24807	38867	2	applied	\N	\N	\N	\N	188619	188619	355816
24810	38619	89	applied	\N	\N	\N	\N	188715	188715	355912
24810	38620	90	applied	\N	\N	\N	\N	188716	188716	355913
24810	38621	91	applied	\N	\N	\N	\N	188717	188717	355914
24810	38622	92	applied	\N	\N	\N	\N	188718	188718	355915
24810	38623	93	applied	\N	\N	\N	\N	188719	188719	355916
24810	38624	94	applied	\N	\N	\N	\N	188720	188720	355917
24810	38625	95	applied	\N	\N	\N	\N	188721	188721	355918
24810	38626	96	applied	\N	\N	\N	\N	188722	188722	355919
24810	38635	97	applied	\N	\N	\N	\N	188723	188723	355920
24810	38636	98	applied	\N	\N	\N	\N	188724	188724	355921
24810	38637	99	applied	\N	\N	\N	\N	188725	188725	355922
24810	38643	100	applied	\N	\N	\N	\N	188726	188726	355923
24810	38645	101	applied	\N	\N	\N	\N	188727	188727	355924
24810	38646	102	applied	\N	\N	\N	\N	188728	188728	355925
24810	38650	103	applied	\N	\N	\N	\N	188729	188729	355926
24810	38651	104	applied	\N	\N	\N	\N	188730	188730	355927
24810	38654	106	applied	\N	\N	\N	\N	188732	188732	355929
24810	38655	107	applied	\N	\N	\N	\N	188733	188733	355930
24810	38658	108	applied	\N	\N	\N	\N	188734	188734	355931
24810	38660	109	applied	\N	\N	\N	\N	188735	188735	355932
24810	38661	110	applied	\N	\N	\N	\N	188736	188736	355933
24810	38662	111	applied	\N	\N	\N	\N	188737	188737	355934
24815	38696	70	applied	\N	\N	\N	\N	188827	188827	356024
24815	38703	71	applied	\N	\N	\N	\N	188828	188828	356025
24815	38796	72	applied	\N	\N	\N	\N	188829	188829	356026
24815	38704	73	applied	\N	\N	\N	\N	188830	188830	356027
24815	38708	74	applied	\N	\N	\N	\N	188831	188831	356028
24815	38709	75	applied	\N	\N	\N	\N	188832	188832	356029
24815	38716	76	applied	\N	\N	\N	\N	188833	188833	356030
24815	38721	77	applied	\N	\N	\N	\N	188834	188834	356031
24815	38722	78	applied	\N	\N	\N	\N	188835	188835	356032
24815	38717	79	applied	\N	\N	\N	\N	188836	188836	356033
24815	38735	81	applied	\N	\N	\N	\N	188838	188838	356035
24815	38754	83	applied	\N	\N	\N	\N	188839	188839	356036
24815	38766	84	applied	\N	\N	\N	\N	188840	188840	356037
24815	38774	85	applied	\N	\N	\N	\N	188841	188841	356038
24815	38785	86	applied	\N	\N	\N	\N	188842	188842	356039
24815	38803	87	applied	\N	\N	\N	\N	188843	188843	356040
24815	38808	88	applied	\N	\N	\N	\N	188844	188844	356041
24815	38817	89	applied	\N	\N	\N	\N	188845	188845	356042
24815	38832	90	applied	\N	\N	\N	\N	188846	188846	356043
24815	38842	91	applied	\N	\N	\N	\N	188847	188847	356044
24815	38854	92	applied	\N	\N	\N	\N	188848	188848	356045
24815	38697	93	applied	\N	\N	\N	\N	188849	188849	356046
24815	38705	94	applied	\N	\N	\N	\N	188850	188850	356047
24815	38713	95	applied	\N	\N	\N	\N	188851	188851	356048
24815	38714	96	applied	\N	\N	\N	\N	188852	188852	356049
24815	38715	97	applied	\N	\N	\N	\N	188853	188853	356050
24815	38724	99	applied	\N	\N	\N	\N	188855	188855	356052
24815	38725	100	applied	\N	\N	\N	\N	188856	188856	356053
24815	38727	101	applied	\N	\N	\N	\N	188857	188857	356054
24815	38732	102	applied	\N	\N	\N	\N	188858	188858	356055
24815	38736	103	applied	\N	\N	\N	\N	188859	188859	356056
24815	38737	104	applied	\N	\N	\N	\N	188860	188860	356057
24815	38746	105	applied	\N	\N	\N	\N	188861	188861	356058
24815	38749	106	applied	\N	\N	\N	\N	188862	188862	356059
24815	38752	107	applied	\N	\N	\N	\N	188863	188863	356060
24815	38753	108	applied	\N	\N	\N	\N	188864	188864	356061
24815	38759	109	applied	\N	\N	\N	\N	188865	188865	356062
24815	38761	110	applied	\N	\N	\N	\N	188866	188866	356063
24815	38765	111	applied	\N	\N	\N	\N	188867	188867	356064
24815	38769	112	applied	\N	\N	\N	\N	188868	188868	356065
24815	38771	113	applied	\N	\N	\N	\N	188869	188869	356066
24815	38775	114	applied	\N	\N	\N	\N	188870	188870	356067
24815	38731	116	applied	\N	\N	\N	\N	188872	188872	356069
24815	38738	117	applied	\N	\N	\N	\N	188873	188873	356070
24815	38739	118	applied	\N	\N	\N	\N	188874	188874	356071
24815	38747	119	applied	\N	\N	\N	\N	188875	188875	356072
24815	38748	120	applied	\N	\N	\N	\N	188876	188876	356073
24815	38755	121	applied	\N	\N	\N	\N	188877	188877	356074
24815	38756	122	applied	\N	\N	\N	\N	188878	188878	356075
24815	38758	123	applied	\N	\N	\N	\N	188879	188879	356076
24815	38762	124	applied	\N	\N	\N	\N	188880	188880	356077
24815	38764	125	applied	\N	\N	\N	\N	188881	188881	356078
24816	38876	0	applied	\N	\N	\N	\N	188882	188882	356079
24816	38877	1	applied	\N	\N	\N	\N	188883	188883	356080
24816	38878	2	applied	\N	\N	\N	\N	188884	188884	356081
24819	38884	0	applied	\N	\N	\N	\N	188895	188895	356092
24819	38885	1	applied	\N	\N	\N	\N	188896	188896	356093
24819	38886	2	applied	\N	\N	\N	\N	188897	188897	356094
24824	38900	0	applied	\N	\N	\N	\N	188930	188930	356125
24824	38901	1	applied	\N	\N	\N	\N	188931	188931	356126
24824	38902	2	applied	\N	\N	\N	\N	188932	188932	356127
24828	38911	0	applied	\N	\N	\N	\N	188957	188957	356152
24828	38912	1	applied	\N	\N	\N	\N	188958	188958	356153
24828	38913	2	applied	\N	\N	\N	\N	188959	188959	356154
24833	38914	0	applied	\N	\N	\N	\N	188971	188971	356166
24833	38915	1	applied	\N	\N	\N	\N	188972	188972	356167
24833	38916	2	applied	\N	\N	\N	\N	188973	188973	356168
24835	38924	0	applied	\N	\N	\N	\N	188981	188981	356176
24835	38925	1	applied	\N	\N	\N	\N	188982	188982	356177
24835	38926	2	applied	\N	\N	\N	\N	188983	188983	356178
24836	38927	0	applied	\N	\N	\N	\N	188984	188984	356179
24836	38928	1	applied	\N	\N	\N	\N	188985	188985	356180
24836	38929	2	applied	\N	\N	\N	\N	188986	188986	356181
24836	38930	3	applied	\N	\N	\N	\N	188987	188987	356182
24836	38932	5	applied	\N	\N	\N	\N	188989	188989	356184
24836	38933	6	applied	\N	\N	\N	\N	188990	188990	356185
24836	38934	7	applied	\N	\N	\N	\N	188991	188991	356186
24836	38935	8	applied	\N	\N	\N	\N	188992	188992	356187
24836	38936	10	applied	\N	\N	\N	\N	188993	188993	356188
24839	38937	0	applied	\N	\N	\N	\N	189011	189011	356206
24839	38938	1	applied	\N	\N	\N	\N	189012	189012	356207
24839	38939	2	applied	\N	\N	\N	\N	189013	189013	356208
24839	38940	3	applied	\N	\N	\N	\N	189014	189014	356209
24839	38941	4	applied	\N	\N	\N	\N	189015	189015	356210
24839	38942	5	applied	\N	\N	\N	\N	189016	189016	356211
24839	38943	6	applied	\N	\N	\N	\N	189017	189017	356212
24843	38944	0	applied	\N	\N	\N	\N	189031	189031	356226
24843	38945	1	applied	\N	\N	\N	\N	189032	189032	356227
24810	38607	86	applied	\N	\N	\N	\N	188712	188712	355909
24810	38617	87	applied	\N	\N	\N	\N	188713	188713	355910
24826	38903	0	applied	\N	\N	\N	\N	188941	188941	356136
24826	38904	1	applied	\N	\N	\N	\N	188942	188942	356137
24826	38905	2	applied	\N	\N	\N	\N	188943	188943	356138
24826	38906	3	applied	\N	\N	\N	\N	188944	188944	356139
24826	38907	4	applied	\N	\N	\N	\N	188945	188945	356140
24826	38908	5	applied	\N	\N	\N	\N	188946	188946	356141
24826	38909	6	applied	\N	\N	\N	\N	188947	188947	356142
24827	38903	0	applied	\N	\N	\N	\N	188949	188949	356144
24827	38904	1	applied	\N	\N	\N	\N	188950	188950	356145
24827	38905	2	applied	\N	\N	\N	\N	188951	188951	356146
24827	38906	3	applied	\N	\N	\N	\N	188952	188952	356147
24827	38907	4	applied	\N	\N	\N	\N	188953	188953	356148
24827	38908	5	applied	\N	\N	\N	\N	188954	188954	356149
24827	38909	6	applied	\N	\N	\N	\N	188955	188955	356150
24827	38910	7	applied	\N	\N	\N	\N	188956	188956	356151
24829	38911	0	applied	\N	\N	\N	\N	188960	188960	356155
24829	38913	2	applied	\N	\N	\N	\N	188962	188962	356157
24841	38944	0	applied	\N	\N	\N	\N	189025	189025	356220
24841	38945	1	applied	\N	\N	\N	\N	189026	189026	356221
24841	38946	2	applied	\N	\N	\N	\N	189027	189027	356222
24843	38946	2	applied	\N	\N	\N	\N	189033	189033	356228
24846	38947	0	applied	\N	\N	\N	\N	189037	189037	356232
24846	38949	1	applied	\N	\N	\N	\N	189038	189038	356233
24848	38950	0	applied	\N	\N	\N	\N	189043	189043	356238
24848	38951	1	applied	\N	\N	\N	\N	189044	189044	356239
24848	38952	2	applied	\N	\N	\N	\N	189045	189045	356240
24848	38953	3	applied	\N	\N	\N	\N	189046	189046	356241
24851	38971	0	applied	\N	\N	\N	\N	189064	189064	356259
24851	38972	1	applied	\N	\N	\N	\N	189065	189065	356260
24851	38973	2	applied	\N	\N	\N	\N	189066	189066	356261
24851	38974	3	applied	\N	\N	\N	\N	189067	189067	356262
24851	38975	4	applied	\N	\N	\N	\N	189068	189068	356263
24851	38977	6	applied	\N	\N	\N	\N	189070	189070	356265
24854	38982	0	applied	\N	\N	\N	\N	189078	189078	356273
24854	38983	1	applied	\N	\N	\N	\N	189079	189079	356274
24854	38984	2	applied	\N	\N	\N	\N	189080	189080	356275
24857	38985	0	applied	\N	\N	\N	\N	189095	189095	356290
24857	38986	1	applied	\N	\N	\N	\N	189096	189096	356291
24857	38987	2	applied	\N	\N	\N	\N	189097	189097	356292
24857	38988	3	applied	\N	\N	\N	\N	189098	189098	356293
24857	38989	4	applied	\N	\N	\N	\N	189099	189099	356294
24857	38990	5	applied	\N	\N	\N	\N	189100	189100	356295
24857	38991	6	applied	\N	\N	\N	\N	189101	189101	356296
24858	38992	0	applied	\N	\N	\N	\N	189102	189102	356297
24858	38993	1	applied	\N	\N	\N	\N	189103	189103	356298
24858	38994	2	applied	\N	\N	\N	\N	189104	189104	356299
24859	38995	0	applied	\N	\N	\N	\N	189105	189105	356300
24859	38996	1	applied	\N	\N	\N	\N	189106	189106	356301
24859	38998	3	applied	\N	\N	\N	\N	189108	189108	356303
24859	38999	4	applied	\N	\N	\N	\N	189109	189109	356304
24859	39000	5	applied	\N	\N	\N	\N	189110	189110	356305
24859	39001	6	applied	\N	\N	\N	\N	189111	189111	189111
24859	39002	7	applied	\N	\N	\N	\N	189112	189112	356306
24861	38995	0	applied	\N	\N	\N	\N	189121	189121	356314
24861	38996	1	applied	\N	\N	\N	\N	189122	189122	356315
24861	38997	2	applied	\N	\N	\N	\N	189123	189123	356316
24861	38998	3	applied	\N	\N	\N	\N	189124	189124	356317
24861	38999	4	applied	\N	\N	\N	\N	189125	189125	356318
24861	39000	5	applied	\N	\N	\N	\N	189126	189126	356319
24861	39001	6	applied	\N	\N	\N	\N	189127	189127	189127
24861	39002	7	applied	\N	\N	\N	\N	189128	189128	356320
24862	39003	0	applied	\N	\N	\N	\N	189129	189129	356321
24862	39004	1	applied	\N	\N	\N	\N	189130	189130	356322
24862	39005	2	applied	\N	\N	\N	\N	189131	189131	356323
24862	39007	4	applied	\N	\N	\N	\N	189133	189133	356325
24862	39008	5	applied	\N	\N	\N	\N	189134	189134	356326
24862	39009	6	applied	\N	\N	\N	\N	189135	189135	356327
24864	39015	0	applied	\N	\N	\N	\N	189141	189141	356332
24865	39015	0	applied	\N	\N	\N	\N	189144	189144	356335
24865	39016	1	applied	\N	\N	\N	\N	189145	189145	356336
24865	39017	2	applied	\N	\N	\N	\N	189146	189146	356337
24870	39016	0	applied	\N	\N	\N	\N	189156	189156	356347
24873	39035	0	applied	\N	\N	\N	\N	189176	189176	356367
24873	39036	1	applied	\N	\N	\N	\N	189177	189177	356368
24873	39037	2	applied	\N	\N	\N	\N	189178	189178	356369
24873	39038	3	applied	\N	\N	\N	\N	189179	189179	356370
24876	39039	0	applied	\N	\N	\N	\N	189187	189187	356378
24876	39040	1	applied	\N	\N	\N	\N	189188	189188	356379
24876	39041	2	applied	\N	\N	\N	\N	189189	189189	356380
24880	39045	0	applied	\N	\N	\N	\N	189199	189199	356390
24880	39047	2	applied	\N	\N	\N	\N	189201	189201	356392
24880	39048	3	applied	\N	\N	\N	\N	189202	189202	356393
24882	39049	0	applied	\N	\N	\N	\N	189207	189207	356398
24882	39050	1	applied	\N	\N	\N	\N	189208	189208	356399
24882	39051	2	applied	\N	\N	\N	\N	189209	189209	356400
24887	39058	0	applied	\N	\N	\N	\N	189222	189222	356413
24887	39059	1	applied	\N	\N	\N	\N	189223	189223	356414
24887	39060	2	applied	\N	\N	\N	\N	189224	189224	356415
24891	39062	0	applied	\N	\N	\N	\N	189234	189234	356425
24891	39063	1	applied	\N	\N	\N	\N	189235	189235	356426
24894	39072	0	applied	\N	\N	\N	\N	189254	189254	356443
24894	39073	1	applied	\N	\N	\N	\N	189255	189255	356444
24894	39074	2	applied	\N	\N	\N	\N	189256	189256	356445
24897	39078	0	applied	\N	\N	\N	\N	189263	189263	356452
24897	39079	1	applied	\N	\N	\N	\N	189264	189264	356453
24897	39080	2	applied	\N	\N	\N	\N	189265	189265	356454
24900	39088	0	applied	\N	\N	\N	\N	189277	189277	356466
24900	39089	1	applied	\N	\N	\N	\N	189278	189278	356467
24900	39090	2	applied	\N	\N	\N	\N	189279	189279	356468
24900	39091	3	applied	\N	\N	\N	\N	189280	189280	356469
24902	39092	0	applied	\N	\N	\N	\N	189285	189285	356474
24902	39093	1	applied	\N	\N	\N	\N	189286	189286	356475
24902	39094	2	applied	\N	\N	\N	\N	189287	189287	356476
24902	39095	3	applied	\N	\N	\N	\N	189288	189288	356477
24902	39096	4	applied	\N	\N	\N	\N	189289	189289	356478
24902	39097	5	applied	\N	\N	\N	\N	189290	189290	356479
24907	39101	0	applied	\N	\N	\N	\N	189307	189307	356496
24907	39102	1	applied	\N	\N	\N	\N	189308	189308	356497
24907	39103	2	applied	\N	\N	\N	\N	189309	189309	356498
24907	39104	3	applied	\N	\N	\N	\N	189310	189310	356499
24822	38902	2	applied	\N	\N	\N	\N	188926	188926	356121
24823	38901	1	applied	\N	\N	\N	\N	188928	188928	356123
24832	38915	1	applied	\N	\N	\N	\N	188969	188969	356164
24832	38916	2	applied	\N	\N	\N	\N	188970	188970	356165
24838	38937	0	applied	\N	\N	\N	\N	189004	189004	356199
24838	38938	1	applied	\N	\N	\N	\N	189005	189005	356200
24838	38939	2	applied	\N	\N	\N	\N	189006	189006	356201
24838	38940	3	applied	\N	\N	\N	\N	189007	189007	356202
24838	38941	4	applied	\N	\N	\N	\N	189008	189008	356203
24838	38942	5	applied	\N	\N	\N	\N	189009	189009	356204
24838	38943	6	applied	\N	\N	\N	\N	189010	189010	356205
24840	38939	2	applied	\N	\N	\N	\N	189020	189020	356215
24840	38940	3	applied	\N	\N	\N	\N	189021	189021	356216
24840	38941	4	applied	\N	\N	\N	\N	189022	189022	356217
24840	38942	5	applied	\N	\N	\N	\N	189023	189023	356218
24840	38943	6	applied	\N	\N	\N	\N	189024	189024	356219
24842	38945	1	applied	\N	\N	\N	\N	189029	189029	356224
24842	38946	2	applied	\N	\N	\N	\N	189030	189030	356225
24845	38947	0	applied	\N	\N	\N	\N	189034	189034	356229
24845	38948	1	applied	\N	\N	\N	\N	189035	189035	356230
24845	38949	2	applied	\N	\N	\N	\N	189036	189036	356231
24847	38950	0	applied	\N	\N	\N	\N	189039	189039	356234
24847	38951	1	applied	\N	\N	\N	\N	189040	189040	356235
24847	38952	2	applied	\N	\N	\N	\N	189041	189041	356236
24847	38953	3	applied	\N	\N	\N	\N	189042	189042	356237
24849	38954	0	applied	\N	\N	\N	\N	189047	189047	356242
24849	38955	1	applied	\N	\N	\N	\N	189048	189048	356243
24849	38956	2	applied	\N	\N	\N	\N	189049	189049	356244
24849	38957	3	applied	\N	\N	\N	\N	189050	189050	356245
24849	38958	4	applied	\N	\N	\N	\N	189051	189051	356246
24849	38959	5	applied	\N	\N	\N	\N	189052	189052	356247
24849	38960	6	applied	\N	\N	\N	\N	189053	189053	356248
24849	38962	8	applied	\N	\N	\N	\N	189055	189055	356250
24849	38963	9	applied	\N	\N	\N	\N	189056	189056	356251
24850	38964	0	applied	\N	\N	\N	\N	189057	189057	356252
24850	38965	1	applied	\N	\N	\N	\N	189058	189058	356253
24850	38966	2	applied	\N	\N	\N	\N	189059	189059	356254
24850	38967	3	applied	\N	\N	\N	\N	189060	189060	356255
24850	38968	4	applied	\N	\N	\N	\N	189061	189061	356256
24850	38969	5	applied	\N	\N	\N	\N	189062	189062	356257
24850	38970	6	applied	\N	\N	\N	\N	189063	189063	356258
24852	38978	0	applied	\N	\N	\N	\N	189071	189071	356266
24852	38979	1	applied	\N	\N	\N	\N	189072	189072	356267
24852	38980	2	applied	\N	\N	\N	\N	189073	189073	356268
24852	38981	3	applied	\N	\N	\N	\N	189074	189074	356269
24853	38982	0	applied	\N	\N	\N	\N	189075	189075	356270
24853	38983	1	applied	\N	\N	\N	\N	189076	189076	356271
24853	38984	2	applied	\N	\N	\N	\N	189077	189077	356272
24855	38986	1	applied	\N	\N	\N	\N	189082	189082	356277
24855	38987	2	applied	\N	\N	\N	\N	189083	189083	356278
24855	38988	3	applied	\N	\N	\N	\N	189084	189084	356279
24855	38989	4	applied	\N	\N	\N	\N	189085	189085	356280
24855	38990	5	applied	\N	\N	\N	\N	189086	189086	356281
24855	38991	6	applied	\N	\N	\N	\N	189087	189087	356282
24856	38985	0	applied	\N	\N	\N	\N	189088	189088	356283
24856	38986	1	applied	\N	\N	\N	\N	189089	189089	356284
24856	38987	2	applied	\N	\N	\N	\N	189090	189090	356285
24856	38988	3	applied	\N	\N	\N	\N	189091	189091	356286
24856	38989	4	applied	\N	\N	\N	\N	189092	189092	356287
24856	38990	5	applied	\N	\N	\N	\N	189093	189093	356288
24856	38991	6	applied	\N	\N	\N	\N	189094	189094	356289
24860	38995	0	applied	\N	\N	\N	\N	189113	189113	356307
24860	38996	1	applied	\N	\N	\N	\N	189114	189114	356308
24860	38997	2	applied	\N	\N	\N	\N	189115	189115	356309
24860	38999	4	applied	\N	\N	\N	\N	189117	189117	356311
24860	39000	5	applied	\N	\N	\N	\N	189118	189118	356312
24860	39001	6	applied	\N	\N	\N	\N	189119	189119	189119
24860	39002	7	applied	\N	\N	\N	\N	189120	189120	356313
24863	39010	0	applied	\N	\N	\N	\N	189136	189136	356328
24863	39011	1	applied	\N	\N	\N	\N	189137	189137	356329
24863	39012	2	applied	\N	\N	\N	\N	189138	189138	189138
24863	39013	3	applied	\N	\N	\N	\N	189139	189139	356330
24863	39014	4	applied	\N	\N	\N	\N	189140	189140	356331
24867	39015	0	applied	\N	\N	\N	\N	189149	189149	356340
24867	39016	1	applied	\N	\N	\N	\N	189150	189150	356341
24867	39017	2	applied	\N	\N	\N	\N	189151	189151	356342
24868	39016	0	applied	\N	\N	\N	\N	189152	189152	356343
24871	39015	0	applied	\N	\N	\N	\N	189157	189157	356348
24871	39018	1	applied	\N	\N	\N	\N	189158	189158	356349
24871	39020	3	applied	\N	\N	\N	\N	189160	189160	356351
24871	39021	4	applied	\N	\N	\N	\N	189161	189161	356352
24871	39022	5	applied	\N	\N	\N	\N	189162	189162	356353
24871	39023	6	applied	\N	\N	\N	\N	189163	189163	356354
24871	39024	7	applied	\N	\N	\N	\N	189164	189164	356355
24871	39017	8	applied	\N	\N	\N	\N	189165	189165	356356
24871	39025	9	applied	\N	\N	\N	\N	189166	189166	356357
24871	39026	10	applied	\N	\N	\N	\N	189167	189167	356358
24871	39027	11	applied	\N	\N	\N	\N	189168	189168	356359
24871	39028	12	applied	\N	\N	\N	\N	189169	189169	356360
24872	39032	0	applied	\N	\N	\N	\N	189173	189173	356364
24872	39033	1	applied	\N	\N	\N	\N	189174	189174	356365
24872	39034	2	applied	\N	\N	\N	\N	189175	189175	356366
24878	39039	0	applied	\N	\N	\N	\N	189193	189193	356384
24878	39040	1	applied	\N	\N	\N	\N	189194	189194	356385
24878	39041	2	applied	\N	\N	\N	\N	189195	189195	356386
24883	39049	0	applied	\N	\N	\N	\N	189210	189210	356401
24883	39050	1	applied	\N	\N	\N	\N	189211	189211	356402
24883	39051	2	applied	\N	\N	\N	\N	189212	189212	356403
24889	39059	1	applied	\N	\N	\N	\N	189229	189229	356420
24889	39060	2	applied	\N	\N	\N	\N	189230	189230	356421
24890	39061	0	applied	\N	\N	\N	\N	189231	189231	356422
24890	39062	1	applied	\N	\N	\N	\N	189232	189232	356423
24890	39063	2	applied	\N	\N	\N	\N	189233	189233	356424
24893	39061	0	applied	\N	\N	\N	\N	189245	189245	356435
24893	39064	1	applied	\N	\N	\N	\N	189246	189246	356436
24893	39065	2	applied	\N	\N	\N	\N	189247	189247	356437
24893	39066	3	applied	\N	\N	\N	\N	189248	189248	356438
24893	39067	4	applied	\N	\N	\N	\N	189249	189249	356439
24893	39068	5	applied	\N	\N	\N	\N	189250	189250	356440
24893	39069	6	applied	\N	\N	\N	\N	189251	189251	189251
24893	39070	7	applied	\N	\N	\N	\N	189252	189252	356441
24893	39071	8	applied	\N	\N	\N	\N	189253	189253	356442
24831	38913	1	applied	\N	\N	\N	\N	188967	188967	356162
24832	38914	0	applied	\N	\N	\N	\N	188968	188968	356163
24869	39015	0	applied	\N	\N	\N	\N	189153	189153	356344
24869	39016	1	applied	\N	\N	\N	\N	189154	189154	356345
24869	39017	2	applied	\N	\N	\N	\N	189155	189155	356346
24871	39029	13	applied	\N	\N	\N	\N	189170	189170	356361
24871	39030	14	applied	\N	\N	\N	\N	189171	189171	356362
24871	39031	16	applied	\N	\N	\N	\N	189172	189172	356363
24874	39035	0	applied	\N	\N	\N	\N	189180	189180	356371
24874	39036	1	applied	\N	\N	\N	\N	189181	189181	356372
24874	39037	2	applied	\N	\N	\N	\N	189182	189182	356373
24874	39038	3	applied	\N	\N	\N	\N	189183	189183	356374
24875	39039	0	applied	\N	\N	\N	\N	189184	189184	356375
24875	39040	1	applied	\N	\N	\N	\N	189185	189185	356376
24875	39041	2	applied	\N	\N	\N	\N	189186	189186	356377
24877	39039	0	applied	\N	\N	\N	\N	189190	189190	356381
24877	39040	1	applied	\N	\N	\N	\N	189191	189191	356382
24877	39041	2	applied	\N	\N	\N	\N	189192	189192	356383
24879	39043	1	applied	\N	\N	\N	\N	189197	189197	356388
24879	39044	2	applied	\N	\N	\N	\N	189198	189198	356389
24881	39045	0	applied	\N	\N	\N	\N	189203	189203	356394
24881	39046	1	applied	\N	\N	\N	\N	189204	189204	356395
24881	39047	2	applied	\N	\N	\N	\N	189205	189205	356396
24881	39048	3	applied	\N	\N	\N	\N	189206	189206	356397
24884	39052	0	applied	\N	\N	\N	\N	189213	189213	356404
24884	39053	1	applied	\N	\N	\N	\N	189214	189214	356405
24884	39054	2	applied	\N	\N	\N	\N	189215	189215	356406
24885	39052	0	applied	\N	\N	\N	\N	189216	189216	356407
24885	39053	1	applied	\N	\N	\N	\N	189217	189217	356408
24885	39054	2	applied	\N	\N	\N	\N	189218	189218	356409
24886	39055	0	applied	\N	\N	\N	\N	189219	189219	356410
24886	39056	1	applied	\N	\N	\N	\N	189220	189220	356411
24886	39057	2	applied	\N	\N	\N	\N	189221	189221	356412
24888	39058	0	applied	\N	\N	\N	\N	189225	189225	356416
24888	39060	2	applied	\N	\N	\N	\N	189227	189227	356418
24892	39061	0	applied	\N	\N	\N	\N	189236	189236	356427
24892	39064	1	applied	\N	\N	\N	\N	189237	189237	356428
24892	39065	2	applied	\N	\N	\N	\N	189238	189238	356429
24892	39066	3	applied	\N	\N	\N	\N	189239	189239	356430
24892	39067	4	applied	\N	\N	\N	\N	189240	189240	356431
24892	39068	5	applied	\N	\N	\N	\N	189241	189241	356432
24892	39069	6	applied	\N	\N	\N	\N	189242	189242	189242
24892	39070	7	applied	\N	\N	\N	\N	189243	189243	356433
24892	39071	8	applied	\N	\N	\N	\N	189244	189244	356434
24895	39072	0	applied	\N	\N	\N	\N	189257	189257	356446
24895	39073	1	applied	\N	\N	\N	\N	189258	189258	356447
24895	39074	2	applied	\N	\N	\N	\N	189259	189259	356448
24896	39075	0	applied	\N	\N	\N	\N	189260	189260	356449
24896	39076	1	applied	\N	\N	\N	\N	189261	189261	356450
24896	39077	2	applied	\N	\N	\N	\N	189262	189262	356451
24898	39083	1	applied	\N	\N	\N	\N	189268	189268	356457
24898	39084	2	applied	\N	\N	\N	\N	189269	189269	356458
24898	39085	3	applied	\N	\N	\N	\N	189270	189270	356459
24898	39086	4	applied	\N	\N	\N	\N	189271	189271	356460
24898	39087	5	applied	\N	\N	\N	\N	189272	189272	356461
24899	39088	0	applied	\N	\N	\N	\N	189273	189273	356462
24899	39089	1	applied	\N	\N	\N	\N	189274	189274	356463
24899	39090	2	applied	\N	\N	\N	\N	189275	189275	356464
24899	39091	3	applied	\N	\N	\N	\N	189276	189276	356465
24901	39088	0	applied	\N	\N	\N	\N	189281	189281	356470
24901	39089	1	applied	\N	\N	\N	\N	189282	189282	356471
24901	39090	2	applied	\N	\N	\N	\N	189283	189283	356472
24901	39091	3	applied	\N	\N	\N	\N	189284	189284	356473
24903	39092	0	applied	\N	\N	\N	\N	189291	189291	356480
24903	39093	1	applied	\N	\N	\N	\N	189292	189292	356481
24903	39094	2	applied	\N	\N	\N	\N	189293	189293	356482
24903	39096	4	applied	\N	\N	\N	\N	189295	189295	356484
24903	39097	5	applied	\N	\N	\N	\N	189296	189296	356485
24904	39098	0	applied	\N	\N	\N	\N	189297	189297	356486
24904	39099	1	applied	\N	\N	\N	\N	189298	189298	356487
24904	39100	2	applied	\N	\N	\N	\N	189299	189299	356488
24905	39098	0	applied	\N	\N	\N	\N	189300	189300	356489
24905	39099	1	applied	\N	\N	\N	\N	189301	189301	356490
24905	39100	2	applied	\N	\N	\N	\N	189302	189302	356491
24906	39101	0	applied	\N	\N	\N	\N	189303	189303	356492
24906	39102	1	applied	\N	\N	\N	\N	189304	189304	356493
24906	39103	2	applied	\N	\N	\N	\N	189305	189305	356494
24906	39104	3	applied	\N	\N	\N	\N	189306	189306	356495
24908	39101	0	applied	\N	\N	\N	\N	189311	189311	356500
24908	39102	1	applied	\N	\N	\N	\N	189312	189312	356501
24908	39103	2	applied	\N	\N	\N	\N	189313	189313	356502
24908	39104	3	applied	\N	\N	\N	\N	189314	189314	356503
24909	39106	1	applied	\N	\N	\N	\N	189316	189316	356505
24909	39107	2	applied	\N	\N	\N	\N	189317	189317	356506
24910	39105	0	applied	\N	\N	\N	\N	189318	189318	356507
24910	39106	1	applied	\N	\N	\N	\N	189319	189319	356508
24910	39107	2	applied	\N	\N	\N	\N	189320	189320	356509
24911	39105	0	applied	\N	\N	\N	\N	189321	189321	356510
24911	39106	1	applied	\N	\N	\N	\N	189322	189322	356511
24911	39107	2	applied	\N	\N	\N	\N	189323	189323	356512
24912	39108	0	applied	\N	\N	\N	\N	189324	189324	356513
24912	39109	1	applied	\N	\N	\N	\N	189325	189325	356514
24912	39110	2	applied	\N	\N	\N	\N	189326	189326	356515
24913	39108	0	applied	\N	\N	\N	\N	189327	189327	356516
24913	39109	1	applied	\N	\N	\N	\N	189328	189328	356517
24913	39110	2	applied	\N	\N	\N	\N	189329	189329	356518
24914	39108	0	applied	\N	\N	\N	\N	189330	189330	356519
24914	39109	1	applied	\N	\N	\N	\N	189331	189331	356520
24915	39108	0	applied	\N	\N	\N	\N	189333	189333	356522
24915	39109	1	applied	\N	\N	\N	\N	189334	189334	356523
24915	39110	2	applied	\N	\N	\N	\N	189335	189335	356524
24916	39108	0	applied	\N	\N	\N	\N	189336	189336	356525
24916	39109	1	applied	\N	\N	\N	\N	189337	189337	356526
24916	39110	2	applied	\N	\N	\N	\N	189338	189338	356527
24917	39111	0	applied	\N	\N	\N	\N	189339	189339	356528
24917	39112	1	applied	\N	\N	\N	\N	189340	189340	356529
24917	39113	2	applied	\N	\N	\N	\N	189341	189341	356530
24917	39114	4	applied	\N	\N	\N	\N	189342	189342	356531
24918	39111	0	applied	\N	\N	\N	\N	189343	189343	356532
24918	39112	1	applied	\N	\N	\N	\N	189344	189344	356533
24918	39113	2	applied	\N	\N	\N	\N	189345	189345	356534
24918	39114	4	applied	\N	\N	\N	\N	189346	189346	356535
24864	39017	2	applied	\N	\N	\N	\N	189143	189143	356334
24866	39015	0	applied	\N	\N	\N	\N	189147	189147	356338
24920	39119	1	applied	\N	\N	\N	\N	189351	189351	356540
24920	39120	2	applied	\N	\N	\N	\N	189352	189352	356541
24921	39121	0	applied	\N	\N	\N	\N	189353	189353	356542
24921	39122	1	applied	\N	\N	\N	\N	189354	189354	356543
24921	39123	2	applied	\N	\N	\N	\N	189355	189355	356544
24921	39124	3	applied	\N	\N	\N	\N	189356	189356	356545
24922	39125	0	applied	\N	\N	\N	\N	189357	189357	356546
24922	39126	1	applied	\N	\N	\N	\N	189358	189358	356547
24922	39127	2	applied	\N	\N	\N	\N	189359	189359	356548
24923	39121	0	applied	\N	\N	\N	\N	189360	189360	356549
24923	39125	1	applied	\N	\N	\N	\N	189361	189361	356550
24923	39122	2	applied	\N	\N	\N	\N	189362	189362	356551
24923	39123	3	applied	\N	\N	\N	\N	189363	189363	356552
24923	39126	4	applied	\N	\N	\N	\N	189364	189364	356553
24923	39127	5	applied	\N	\N	\N	\N	189365	189365	356554
24923	39124	6	applied	\N	\N	\N	\N	189366	189366	356555
24924	39127	1	applied	\N	\N	\N	\N	189368	189368	356557
24925	39125	0	applied	\N	\N	\N	\N	189369	189369	356558
24925	39128	1	applied	\N	\N	\N	\N	189370	189370	356559
24925	39129	2	applied	\N	\N	\N	\N	189371	189371	356560
24925	39130	3	applied	\N	\N	\N	\N	189372	189372	356561
24925	39131	4	applied	\N	\N	\N	\N	189373	189373	356562
24925	39132	5	applied	\N	\N	\N	\N	189374	189374	356563
24925	39133	6	applied	\N	\N	\N	\N	189375	189375	356564
24926	39125	0	applied	\N	\N	\N	\N	189376	189376	356565
24926	39128	1	applied	\N	\N	\N	\N	189377	189377	356566
24926	39129	2	applied	\N	\N	\N	\N	189378	189378	356567
24926	39130	3	applied	\N	\N	\N	\N	189379	189379	356568
24926	39131	4	applied	\N	\N	\N	\N	189380	189380	356569
24926	39132	5	applied	\N	\N	\N	\N	189381	189381	356570
24926	39133	6	applied	\N	\N	\N	\N	189382	189382	356571
24927	39125	0	applied	\N	\N	\N	\N	189383	189383	356572
24927	39129	2	applied	\N	\N	\N	\N	189385	189385	356574
24927	39130	3	applied	\N	\N	\N	\N	189386	189386	356575
24927	39131	4	applied	\N	\N	\N	\N	189387	189387	356576
24927	39132	5	applied	\N	\N	\N	\N	189388	189388	356577
24927	39133	6	applied	\N	\N	\N	\N	189389	189389	356578
24928	39125	0	applied	\N	\N	\N	\N	189390	189390	356579
24928	39128	1	applied	\N	\N	\N	\N	189391	189391	356580
24928	39129	2	applied	\N	\N	\N	\N	189392	189392	356581
24928	39130	3	applied	\N	\N	\N	\N	189393	189393	356582
24928	39131	4	applied	\N	\N	\N	\N	189394	189394	356583
24928	39132	5	applied	\N	\N	\N	\N	189395	189395	356584
24928	39133	6	applied	\N	\N	\N	\N	189396	189396	356585
24929	39130	0	applied	\N	\N	\N	\N	189397	189397	356586
24929	39131	1	applied	\N	\N	\N	\N	189398	189398	356587
24929	39132	2	applied	\N	\N	\N	\N	189399	189399	356588
24929	39133	3	applied	\N	\N	\N	\N	189400	189400	356589
24934	39139	1	applied	\N	\N	\N	\N	189534	189534	356722
24934	39140	2	applied	\N	\N	\N	\N	189535	189535	356723
24936	39108	0	applied	\N	\N	\N	\N	189539	189539	356727
24936	39111	1	applied	\N	\N	\N	\N	189540	189540	356728
24936	39115	2	applied	\N	\N	\N	\N	189541	189541	356729
24936	39118	3	applied	\N	\N	\N	\N	189542	189542	356730
24936	39121	4	applied	\N	\N	\N	\N	189543	189543	356731
24936	39125	5	applied	\N	\N	\N	\N	189544	189544	356732
24936	39128	6	applied	\N	\N	\N	\N	189545	189545	356733
24936	39129	7	applied	\N	\N	\N	\N	189546	189546	356734
24936	39134	9	applied	\N	\N	\N	\N	189547	189547	356735
24936	39109	10	applied	\N	\N	\N	\N	189548	189548	356736
24936	39113	11	applied	\N	\N	\N	\N	189549	189549	356737
24936	39110	12	applied	\N	\N	\N	\N	189550	189550	356738
24936	39112	13	applied	\N	\N	\N	\N	189551	189551	356739
24936	39116	14	applied	\N	\N	\N	\N	189552	189552	356740
24936	39124	16	applied	\N	\N	\N	\N	189554	189554	356742
24936	39120	17	applied	\N	\N	\N	\N	189555	189555	356743
24936	39122	18	applied	\N	\N	\N	\N	189556	189556	356744
24936	39127	19	applied	\N	\N	\N	\N	189557	189557	356745
24936	39132	20	applied	\N	\N	\N	\N	189558	189558	356746
24936	39133	21	applied	\N	\N	\N	\N	189559	189559	356747
24936	39117	22	applied	\N	\N	\N	\N	189560	189560	356748
24936	39119	23	applied	\N	\N	\N	\N	189561	189561	356749
24936	39123	24	applied	\N	\N	\N	\N	189562	189562	356750
24936	39126	25	applied	\N	\N	\N	\N	189563	189563	356751
24936	39130	26	applied	\N	\N	\N	\N	189564	189564	356752
24936	39131	27	applied	\N	\N	\N	\N	189565	189565	356753
24936	39135	28	applied	\N	\N	\N	\N	189566	189566	356754
24936	39136	29	applied	\N	\N	\N	\N	189567	189567	356755
24936	39137	30	applied	\N	\N	\N	\N	189568	189568	356756
24938	39144	0	applied	\N	\N	\N	\N	189572	189572	356760
24938	39146	2	applied	\N	\N	\N	\N	189574	189574	356762
24938	39147	3	applied	\N	\N	\N	\N	189575	189575	356763
24941	39148	0	applied	\N	\N	\N	\N	189582	189582	356770
24941	39149	1	applied	\N	\N	\N	\N	189583	189583	356771
24941	39150	2	applied	\N	\N	\N	\N	189584	189584	356772
24941	39151	3	applied	\N	\N	\N	\N	189585	189585	356773
24941	39152	4	applied	\N	\N	\N	\N	189586	189586	356774
24941	39153	5	applied	\N	\N	\N	\N	189587	189587	356775
24947	39157	0	applied	\N	\N	\N	\N	189591	189591	356779
24947	39158	1	applied	\N	\N	\N	\N	189592	189592	356780
24947	39159	2	applied	\N	\N	\N	\N	189593	189593	356781
24947	39160	3	applied	\N	\N	\N	\N	189594	189594	356782
24958	39171	0	applied	\N	\N	\N	\N	189641	189641	356829
24958	39172	1	applied	\N	\N	\N	\N	189642	189642	356830
24958	39173	2	applied	\N	\N	\N	\N	189643	189643	356831
24963	39174	0	applied	\N	\N	\N	\N	189660	189660	356848
24963	39176	2	applied	\N	\N	\N	\N	189662	189662	356850
24963	39177	3	applied	\N	\N	\N	\N	189663	189663	356851
24963	39178	4	applied	\N	\N	\N	\N	189664	189664	356852
24963	39179	5	applied	\N	\N	\N	\N	189665	189665	356853
24963	39180	6	applied	\N	\N	\N	\N	189666	189666	356854
24963	39181	7	applied	\N	\N	\N	\N	189667	189667	356855
24965	39185	0	applied	\N	\N	\N	\N	189671	189671	356859
24965	39186	1	applied	\N	\N	\N	\N	189672	189672	356860
24965	39187	2	applied	\N	\N	\N	\N	189673	189673	356861
24971	39205	0	applied	\N	\N	\N	\N	189696	189696	356884
24971	39207	1	applied	\N	\N	\N	\N	189697	189697	356885
24971	39206	2	applied	\N	\N	\N	\N	189698	189698	356886
24973	39208	0	applied	\N	\N	\N	\N	189700	189700	356888
24973	39209	1	applied	\N	\N	\N	\N	189701	189701	356889
24919	39116	1	applied	\N	\N	\N	\N	189348	189348	356537
24919	39117	2	applied	\N	\N	\N	\N	189349	189349	356538
24930	38851	3	applied	\N	\N	\N	\N	189404	189404	356593
24930	39019	4	applied	\N	\N	1000000000	\N	189405	189405	356594
24930	39045	5	applied	\N	\N	\N	\N	189406	189406	356595
24930	38860	6	applied	\N	\N	\N	\N	189407	189407	356596
24930	38861	7	applied	\N	\N	\N	\N	189408	189408	356597
24930	38862	9	applied	\N	\N	\N	\N	189410	189410	356599
24930	38760	10	applied	\N	\N	\N	\N	189411	189411	356600
24930	38763	11	applied	\N	\N	\N	\N	189412	189412	356601
24930	38767	12	applied	\N	\N	\N	\N	189413	189413	356602
24930	38770	13	applied	\N	\N	\N	\N	189414	189414	356603
24930	38772	14	applied	\N	\N	\N	\N	189415	189415	356604
24930	38776	15	applied	\N	\N	\N	\N	189416	189416	356605
24930	38777	16	applied	\N	\N	\N	\N	189417	189417	356606
24930	38782	17	applied	\N	\N	\N	\N	189418	189418	356607
24930	38786	18	applied	\N	\N	\N	\N	189419	189419	356608
24930	38789	19	applied	\N	\N	\N	\N	189420	189420	356609
24930	38790	20	applied	\N	\N	\N	\N	189421	189421	356610
24930	38791	21	applied	\N	\N	\N	\N	189422	189422	356611
24930	38792	22	applied	\N	\N	\N	\N	189423	189423	356612
24930	38793	23	applied	\N	\N	\N	\N	189424	189424	356613
24930	38806	24	applied	\N	\N	\N	\N	189425	189425	356614
24930	38811	26	applied	\N	\N	\N	\N	189427	189427	356616
24930	38816	27	applied	\N	\N	\N	\N	189428	189428	356617
24930	38820	28	applied	\N	\N	\N	\N	189429	189429	356618
24930	38821	29	applied	\N	\N	\N	\N	189430	189430	356619
24930	38822	30	applied	\N	\N	\N	\N	189431	189431	356620
24930	38830	31	applied	\N	\N	\N	\N	189432	189432	356621
24930	38831	32	applied	\N	\N	\N	\N	189433	189433	356622
24930	38837	33	applied	\N	\N	\N	\N	189434	189434	356623
24930	38840	34	applied	\N	\N	\N	\N	189435	189435	356624
24930	38844	35	applied	\N	\N	\N	\N	189436	189436	356625
24930	38848	36	applied	\N	\N	\N	\N	189437	189437	356626
24930	38852	37	applied	\N	\N	\N	\N	189438	189438	356627
24930	38856	38	applied	\N	\N	\N	\N	189439	189439	356628
24930	38859	39	applied	\N	\N	\N	\N	189440	189440	356629
24930	38865	40	applied	\N	\N	\N	\N	189441	189441	356630
24930	38869	41	applied	\N	\N	\N	\N	189442	189442	356631
24930	38876	43	applied	\N	\N	\N	\N	189444	189444	356633
24930	38880	44	applied	\N	\N	\N	\N	189445	189445	356634
24930	38884	45	applied	\N	\N	\N	\N	189446	189446	356635
24930	38887	46	applied	\N	\N	\N	\N	189447	189447	356636
24930	38888	47	applied	\N	\N	\N	\N	189448	189448	356637
24930	38889	48	applied	\N	\N	\N	\N	189449	189449	356638
24930	38900	49	applied	\N	\N	\N	\N	189450	189450	356639
24930	38903	50	applied	\N	\N	\N	\N	189451	189451	356640
24930	38904	51	applied	\N	\N	\N	\N	189452	189452	356641
24930	38911	52	applied	\N	\N	\N	\N	189453	189453	356642
24930	38914	53	applied	\N	\N	\N	\N	189454	189454	356643
24930	38917	54	applied	\N	\N	\N	\N	189455	189455	356644
24930	38918	55	applied	\N	\N	\N	\N	189456	189456	356645
24930	38924	56	applied	\N	\N	\N	\N	189457	189457	356646
24930	38927	57	applied	\N	\N	\N	\N	189458	189458	356647
24930	38928	58	applied	\N	\N	\N	\N	189459	189459	356648
24930	38937	60	applied	\N	\N	\N	\N	189461	189461	356650
24930	38938	61	applied	\N	\N	\N	\N	189462	189462	356651
24930	38944	62	applied	\N	\N	\N	\N	189463	189463	356652
24930	38947	63	applied	\N	\N	\N	\N	189464	189464	356653
24930	38950	64	applied	\N	\N	\N	\N	189465	189465	356654
24930	38954	65	applied	\N	\N	\N	\N	189466	189466	356655
24930	38955	66	applied	\N	\N	\N	\N	189467	189467	356656
24930	38956	67	applied	\N	\N	\N	\N	189468	189468	356657
24930	38964	68	applied	\N	\N	\N	\N	189469	189469	356658
24973	39207	2	applied	\N	\N	\N	\N	189702	189702	356890
24973	39210	3	applied	\N	\N	\N	\N	189703	189703	356891
24973	39211	4	applied	\N	\N	\N	\N	189704	189704	356892
24973	39212	5	applied	\N	\N	\N	\N	189705	189705	356893
24973	39213	6	applied	\N	\N	\N	\N	189706	189706	356894
24973	39214	7	applied	\N	\N	\N	\N	189707	189707	356895
24980	39221	0	applied	\N	\N	\N	\N	189736	189736	356924
24980	39223	2	applied	\N	\N	\N	\N	189738	189738	356926
24982	39224	0	applied	\N	\N	\N	\N	189741	189741	356929
24982	39225	1	applied	\N	\N	\N	\N	189742	189742	356930
24982	39226	2	applied	\N	\N	\N	\N	189743	189743	356931
24982	39223	3	applied	\N	\N	\N	\N	189744	189744	356932
24982	39227	4	applied	\N	\N	\N	\N	189745	189745	356933
24987	39228	0	applied	\N	\N	\N	\N	189770	189770	356958
24987	39229	1	applied	\N	\N	\N	\N	189771	189771	356959
24987	39230	2	applied	\N	\N	1000000000	\N	189772	189772	356960
24987	39231	3	applied	\N	\N	\N	\N	189773	189773	356961
24987	39232	4	applied	\N	\N	\N	\N	189774	189774	356962
24987	39233	5	applied	\N	\N	\N	\N	189775	189775	356963
24987	39234	6	applied	\N	\N	\N	\N	189776	189776	356964
24987	39235	7	applied	\N	\N	\N	\N	189777	189777	356965
24987	39236	8	applied	\N	\N	\N	\N	189778	189778	356966
24987	39237	9	applied	\N	\N	\N	\N	189779	189779	356967
24997	39253	0	applied	\N	\N	\N	\N	189966	189966	357153
24997	39254	1	applied	\N	\N	\N	\N	189967	189967	357154
24997	39252	3	applied	\N	\N	\N	\N	189969	189969	357155
24997	39258	4	applied	\N	\N	\N	\N	189970	189970	357156
24997	39256	5	applied	\N	\N	\N	\N	189971	189971	357157
24997	39257	6	applied	\N	\N	\N	\N	189972	189972	357158
25001	39259	0	applied	\N	\N	\N	\N	189993	189993	357178
25001	39260	1	applied	\N	\N	\N	\N	189994	189994	357179
25001	39261	2	applied	\N	\N	\N	\N	189995	189995	357180
25001	39262	3	applied	\N	\N	\N	\N	189996	189996	357181
25001	39263	4	applied	\N	\N	\N	\N	189997	189997	357182
25001	39264	5	applied	\N	\N	\N	\N	189998	189998	357183
25001	39265	6	applied	\N	\N	\N	\N	189999	189999	357184
25001	39266	7	applied	\N	\N	\N	\N	190000	190000	357185
25002	39267	0	applied	\N	\N	\N	\N	190001	190001	357186
25002	39269	2	applied	\N	\N	\N	\N	190003	190003	357188
25007	39277	0	applied	\N	\N	\N	\N	190024	190024	357207
25007	39278	1	applied	\N	\N	\N	\N	190025	190025	357208
25007	39279	2	applied	\N	\N	\N	\N	190026	190026	357209
25009	39280	0	applied	\N	\N	\N	\N	190030	190030	357213
25009	39281	1	applied	\N	\N	\N	\N	190031	190031	357214
25013	39289	0	applied	\N	\N	\N	\N	190039	190039	357222
25013	39290	1	applied	\N	\N	\N	\N	190040	190040	357223
24930	38847	1	applied	\N	\N	\N	\N	189402	189402	356591
24930	38879	2	applied	\N	\N	\N	\N	189403	189403	356592
24930	38979	72	applied	\N	\N	\N	\N	189473	189473	356662
24930	38982	73	applied	\N	\N	\N	\N	189474	189474	356663
24930	38985	74	applied	\N	\N	\N	\N	189475	189475	356664
24930	38986	75	applied	\N	\N	\N	\N	189476	189476	356665
24930	38992	76	applied	\N	\N	\N	\N	189477	189477	356666
24930	38995	77	applied	\N	\N	\N	\N	189478	189478	356667
24930	38996	78	applied	\N	\N	\N	\N	189479	189479	356668
24930	39004	80	applied	\N	\N	\N	\N	189481	189481	356670
24930	39010	81	applied	\N	\N	\N	\N	189482	189482	356671
24930	39015	82	applied	\N	\N	\N	\N	189483	189483	356672
24930	39018	83	applied	\N	\N	\N	\N	189484	189484	356673
24930	39020	84	applied	\N	\N	\N	\N	189485	189485	356674
24930	39021	85	applied	\N	\N	\N	\N	189486	189486	356675
24930	39032	86	applied	\N	\N	\N	\N	189487	189487	356676
24930	39035	87	applied	\N	\N	\N	\N	189488	189488	356677
24930	39039	88	applied	\N	\N	\N	\N	189489	189489	356678
24930	39042	89	applied	\N	\N	\N	\N	189490	189490	356679
24930	39046	90	applied	\N	\N	\N	\N	189491	189491	356680
24930	39049	91	applied	\N	\N	\N	\N	189492	189492	356681
24930	39052	92	applied	\N	\N	\N	\N	189493	189493	356682
24930	39055	93	applied	\N	\N	\N	\N	189494	189494	356683
24930	39058	94	applied	\N	\N	\N	\N	189495	189495	356684
24930	39061	95	applied	\N	\N	\N	\N	189496	189496	356685
24930	39065	97	applied	\N	\N	\N	\N	189498	189498	356687
24930	39072	98	applied	\N	\N	\N	\N	189499	189499	356688
24930	39075	99	applied	\N	\N	\N	\N	189500	189500	356689
24930	39078	100	applied	\N	\N	\N	\N	189501	189501	356690
24930	39082	101	applied	\N	\N	\N	\N	189502	189502	356691
24930	39083	102	applied	\N	\N	\N	\N	189503	189503	356692
24930	39088	103	applied	\N	\N	\N	\N	189504	189504	356693
24930	39092	104	applied	\N	\N	\N	\N	189505	189505	356694
24930	39093	105	applied	\N	\N	\N	\N	189506	189506	356695
24930	39098	106	applied	\N	\N	\N	\N	189507	189507	356696
24930	39101	107	applied	\N	\N	\N	\N	189508	189508	356697
24930	39105	108	applied	\N	\N	\N	\N	189509	189509	356698
24930	39108	109	applied	\N	\N	\N	\N	189510	189510	356699
24930	39111	110	applied	\N	\N	\N	\N	189511	189511	356700
24930	39115	111	applied	\N	\N	\N	\N	189512	189512	356701
24930	39118	112	applied	\N	\N	\N	\N	189513	189513	356702
24930	39125	114	applied	\N	\N	\N	\N	189515	189515	356704
24930	39128	115	applied	\N	\N	\N	\N	189516	189516	356705
24930	39129	116	applied	\N	\N	\N	\N	189517	189517	356706
24930	38761	119	applied	\N	\N	\N	\N	189519	189519	356707
24930	38890	118	failed	Amount_insufficient_to_create_account	\N	\N	\N	189518	189518	\N
24930	38796	120	applied	\N	\N	\N	\N	189520	189520	356708
24930	38762	121	applied	\N	\N	\N	\N	189521	189521	356709
24930	38764	122	applied	\N	\N	\N	\N	189522	189522	356710
24930	38768	123	applied	\N	\N	\N	\N	189523	189523	356711
24930	38773	124	applied	\N	\N	\N	\N	189524	189524	356712
24930	38778	125	applied	\N	\N	\N	\N	189525	189525	356713
24945	39154	0	applied	\N	\N	\N	\N	189588	189588	356776
24945	39155	1	applied	\N	\N	\N	\N	189589	189589	356777
24945	39156	2	applied	\N	\N	\N	\N	189590	189590	356778
24948	39158	0	applied	\N	\N	\N	\N	189595	189595	356783
24948	39159	1	applied	\N	\N	\N	\N	189596	189596	356784
24954	39164	0	applied	\N	\N	\N	\N	189627	189627	356815
24954	39165	1	applied	\N	\N	\N	\N	189628	189628	356816
24954	39166	2	applied	\N	\N	\N	\N	189629	189629	356817
24956	39167	0	applied	\N	\N	\N	\N	189633	189633	356821
24956	39168	1	applied	\N	\N	\N	\N	189634	189634	356822
24956	39169	2	applied	\N	\N	\N	\N	189635	189635	356823
24956	39170	3	applied	\N	\N	\N	\N	189636	189636	356824
24959	39171	0	applied	\N	\N	\N	\N	189644	189644	356832
24959	39173	1	applied	\N	\N	\N	\N	189645	189645	356833
24966	39188	0	applied	\N	\N	\N	\N	189674	189674	356862
24966	39189	1	applied	\N	\N	\N	\N	189675	189675	356863
24966	39190	2	applied	\N	\N	\N	\N	189676	189676	356864
24966	39191	3	applied	\N	\N	\N	\N	189677	189677	356865
24966	39192	4	applied	\N	\N	\N	\N	189678	189678	356866
24966	39193	5	applied	\N	\N	\N	\N	189679	189679	356867
24966	39194	6	applied	\N	\N	\N	\N	189680	189680	356868
24966	39196	8	applied	\N	\N	\N	\N	189682	189682	356870
24966	39197	9	applied	\N	\N	\N	\N	189683	189683	356871
24972	39205	0	applied	\N	\N	\N	\N	189699	189699	356887
24974	39208	0	applied	\N	\N	\N	\N	189708	189708	356896
24974	39209	1	applied	\N	\N	\N	\N	189709	189709	356897
24974	39207	2	applied	\N	\N	\N	\N	189710	189710	356898
24974	39210	3	applied	\N	\N	\N	\N	189711	189711	356899
24974	39211	4	applied	\N	\N	\N	\N	189712	189712	356900
24974	39212	5	applied	\N	\N	\N	\N	189713	189713	356901
24974	39213	6	applied	\N	\N	\N	\N	189714	189714	356902
24974	39214	7	applied	\N	\N	\N	\N	189715	189715	356903
24978	39218	0	applied	\N	\N	\N	\N	189730	189730	356918
24978	39219	1	applied	\N	\N	\N	\N	189731	189731	356919
24978	39220	2	applied	\N	\N	\N	\N	189732	189732	356920
24983	39224	0	applied	\N	\N	\N	\N	189746	189746	356934
24983	39225	1	applied	\N	\N	\N	\N	189747	189747	356935
24983	39223	3	applied	\N	\N	\N	\N	189749	189749	356937
24983	39227	4	applied	\N	\N	\N	\N	189750	189750	356938
24988	39230	0	applied	\N	\N	1000000000	\N	189781	189781	356969
24988	39176	1	applied	\N	\N	\N	\N	189782	189782	356970
24988	39072	2	applied	\N	\N	\N	\N	189783	189783	356971
24988	39075	3	applied	\N	\N	\N	\N	189784	189784	356972
24988	39078	4	applied	\N	\N	\N	\N	189785	189785	356973
24988	39082	5	applied	\N	\N	\N	\N	189786	189786	356974
24988	39083	6	applied	\N	\N	\N	\N	189787	189787	356975
24988	39088	7	applied	\N	\N	\N	\N	189788	189788	356976
24988	39092	8	applied	\N	\N	\N	\N	189789	189789	356977
24988	39093	9	applied	\N	\N	\N	\N	189790	189790	356978
24988	39098	10	applied	\N	\N	\N	\N	189791	189791	356979
24988	39101	11	applied	\N	\N	\N	\N	189792	189792	356980
24988	39105	12	applied	\N	\N	\N	\N	189793	189793	356981
24988	39108	13	applied	\N	\N	\N	\N	189794	189794	356982
24988	39115	15	applied	\N	\N	\N	\N	189796	189796	356984
24988	39118	16	applied	\N	\N	\N	\N	189797	189797	356985
24988	39121	17	applied	\N	\N	\N	\N	189798	189798	356986
24988	39125	18	applied	\N	\N	\N	\N	189799	189799	356987
24988	39128	19	applied	\N	\N	\N	\N	189800	189800	356988
24988	39129	20	applied	\N	\N	\N	\N	189801	189801	356989
24930	38971	70	applied	\N	\N	\N	\N	189471	189471	356660
24930	38972	71	applied	\N	\N	\N	\N	189472	189472	356661
24952	39161	0	applied	\N	\N	\N	\N	189598	189598	356786
24952	39162	1	applied	\N	\N	\N	\N	189599	189599	356787
24952	39163	2	applied	\N	\N	\N	\N	189600	189600	356788
24955	39164	0	applied	\N	\N	\N	\N	189630	189630	356818
24955	39165	1	applied	\N	\N	\N	\N	189631	189631	356819
24955	39166	2	applied	\N	\N	\N	\N	189632	189632	356820
24957	39167	0	applied	\N	\N	\N	\N	189637	189637	356825
24957	39168	1	applied	\N	\N	\N	\N	189638	189638	356826
24957	39169	2	applied	\N	\N	\N	\N	189639	189639	356827
24957	39170	3	applied	\N	\N	\N	\N	189640	189640	356828
24960	39171	0	applied	\N	\N	\N	\N	189646	189646	356834
24960	39172	1	applied	\N	\N	\N	\N	189647	189647	356835
24960	39173	2	applied	\N	\N	\N	\N	189648	189648	356836
24967	39198	0	applied	\N	\N	\N	\N	189684	189684	356872
24967	39200	3	applied	\N	\N	\N	\N	189686	189686	356874
24969	39201	0	applied	\N	\N	\N	\N	189690	189690	356878
24969	39202	1	applied	\N	\N	\N	\N	189691	189691	356879
24969	39203	2	applied	\N	\N	\N	\N	189692	189692	356880
24969	39204	3	applied	\N	\N	\N	\N	189693	189693	356881
24975	39208	0	applied	\N	\N	\N	\N	189716	189716	356904
24975	39209	1	applied	\N	\N	\N	\N	189717	189717	356905
24975	39207	2	applied	\N	\N	\N	\N	189718	189718	356906
24975	39210	3	applied	\N	\N	\N	\N	189719	189719	356907
24975	39211	4	applied	\N	\N	\N	\N	189720	189720	356908
24975	39212	5	applied	\N	\N	\N	\N	189721	189721	356909
24975	39213	6	applied	\N	\N	\N	\N	189722	189722	356910
24975	39214	7	applied	\N	\N	\N	\N	189723	189723	356911
24976	39215	0	applied	\N	\N	\N	\N	189724	189724	356912
24976	39216	1	applied	\N	\N	\N	\N	189725	189725	356913
24976	39217	2	applied	\N	\N	\N	\N	189726	189726	356914
24984	39225	1	applied	\N	\N	\N	\N	189752	189752	356940
24984	39226	2	applied	\N	\N	\N	\N	189753	189753	356941
24984	39223	3	applied	\N	\N	\N	\N	189754	189754	356942
24984	39227	4	applied	\N	\N	\N	\N	189755	189755	356943
24988	39134	21	applied	\N	\N	\N	\N	189802	189802	356990
24988	39138	22	applied	\N	\N	\N	\N	189803	189803	356991
24988	39141	23	applied	\N	\N	\N	\N	189804	189804	356992
24988	39144	24	applied	\N	\N	\N	\N	189805	189805	356993
24988	39148	25	applied	\N	\N	\N	\N	189806	189806	356994
24988	39149	26	applied	\N	\N	\N	\N	189807	189807	356995
24988	39154	27	applied	\N	\N	\N	\N	189808	189808	356996
24988	39157	28	applied	\N	\N	\N	\N	189809	189809	356997
24988	39161	29	applied	\N	\N	\N	\N	189810	189810	356998
24988	39164	30	applied	\N	\N	\N	\N	189811	189811	356999
24988	39167	31	applied	\N	\N	\N	\N	189812	189812	357000
24988	39171	32	applied	\N	\N	\N	\N	189813	189813	357001
24988	39175	34	applied	\N	\N	\N	\N	189815	189815	357003
24988	39182	35	applied	\N	\N	\N	\N	189816	189816	357004
24988	39185	36	applied	\N	\N	\N	\N	189817	189817	357005
24988	39188	37	applied	\N	\N	\N	\N	189818	189818	357006
24988	39189	38	applied	\N	\N	\N	\N	189819	189819	357007
24988	39190	39	applied	\N	\N	\N	\N	189820	189820	357008
24988	39198	40	applied	\N	\N	\N	\N	189821	189821	357009
24988	39201	41	applied	\N	\N	\N	\N	189822	189822	357010
24988	39205	42	applied	\N	\N	\N	\N	189823	189823	357011
24988	39208	43	applied	\N	\N	\N	\N	189824	189824	357012
24988	39209	44	applied	\N	\N	\N	\N	189825	189825	357013
24988	39215	45	applied	\N	\N	\N	\N	189826	189826	357014
24988	39218	46	applied	\N	\N	\N	\N	189827	189827	357015
24988	39221	47	applied	\N	\N	\N	\N	189828	189828	357016
24988	39224	48	applied	\N	\N	\N	\N	189829	189829	357017
24988	39228	49	applied	\N	\N	\N	\N	189830	189830	357018
24988	39231	51	applied	\N	\N	\N	\N	189832	189832	357020
24988	39073	52	applied	\N	\N	\N	\N	189833	189833	357021
24988	39076	53	applied	\N	\N	\N	\N	189834	189834	357022
24988	39079	54	applied	\N	\N	\N	\N	189835	189835	357023
24988	39086	55	applied	\N	\N	\N	\N	189836	189836	357024
24988	39087	56	applied	\N	\N	\N	\N	189837	189837	357025
24988	39089	57	applied	\N	\N	\N	\N	189838	189838	357026
24988	39094	58	applied	\N	\N	\N	\N	189839	189839	357027
24988	39095	59	applied	\N	\N	\N	\N	189840	189840	357028
24988	39074	60	applied	\N	\N	\N	\N	189841	189841	357029
24988	39077	61	applied	\N	\N	\N	\N	189842	189842	357030
24988	39080	63	applied	\N	\N	\N	\N	189843	189843	357031
24988	39084	64	applied	\N	\N	\N	\N	189844	189844	357032
24988	39085	65	applied	\N	\N	\N	\N	189845	189845	357033
24988	39081	66	applied	\N	\N	\N	\N	189846	189846	357034
24988	39090	67	applied	\N	\N	\N	\N	189847	189847	357035
24988	39113	69	applied	\N	\N	\N	\N	189849	189849	357037
24988	39124	70	applied	\N	\N	\N	\N	189850	189850	357038
24988	39137	71	applied	\N	\N	\N	\N	189851	189851	357039
24988	39147	72	applied	\N	\N	\N	\N	189852	189852	357040
24990	39239	0	applied	\N	\N	\N	\N	189916	189916	357104
24990	39240	1	applied	\N	\N	\N	\N	189917	189917	357105
24990	39241	2	applied	\N	\N	\N	\N	189918	189918	357106
24990	39242	3	applied	\N	\N	\N	\N	189919	189919	357107
24990	39243	4	applied	\N	\N	\N	\N	189920	189920	357108
24990	39244	5	applied	\N	\N	\N	\N	189921	189921	357109
24990	39245	6	applied	\N	\N	\N	\N	189922	189922	357110
24990	39246	7	applied	\N	\N	\N	\N	189923	189923	357111
24990	39247	8	applied	\N	\N	\N	\N	189924	189924	357112
24990	39248	9	applied	\N	\N	\N	\N	189925	189925	357113
24995	39228	0	applied	\N	\N	\N	\N	189936	189936	357124
24995	39229	1	applied	\N	\N	\N	\N	189937	189937	357125
24995	39231	3	applied	\N	\N	\N	\N	189939	189939	357127
24995	39239	4	applied	\N	\N	\N	\N	189940	189940	357128
24995	39240	5	applied	\N	\N	\N	\N	189941	189941	357129
24995	39241	6	applied	\N	\N	\N	\N	189942	189942	357130
24995	39249	7	applied	\N	\N	\N	\N	189943	189943	357131
24995	39232	8	applied	\N	\N	\N	\N	189944	189944	357132
24995	39233	9	applied	\N	\N	\N	\N	189945	189945	357133
24995	39234	10	applied	\N	\N	\N	\N	189946	189946	357134
24995	39242	11	applied	\N	\N	\N	\N	189947	189947	357135
24995	39235	12	applied	\N	\N	\N	\N	189948	189948	357136
24995	39236	13	applied	\N	\N	\N	\N	189949	189949	357137
24995	39237	14	applied	\N	\N	\N	\N	189950	189950	357138
24995	39238	15	applied	\N	\N	\N	\N	189951	189951	357139
24995	39243	16	applied	\N	\N	\N	\N	189952	189952	357140
24995	39244	17	applied	\N	\N	\N	\N	189953	189953	357141
24995	39245	18	applied	\N	\N	\N	\N	189954	189954	357142
24932	39136	2	applied	\N	\N	\N	\N	189528	189528	356716
24932	39137	3	applied	\N	\N	\N	\N	189529	189529	356717
24935	39138	0	applied	\N	\N	\N	\N	189536	189536	356724
24935	39139	1	applied	\N	\N	\N	\N	189537	189537	356725
24935	39140	2	applied	\N	\N	\N	\N	189538	189538	356726
24937	39141	0	applied	\N	\N	\N	\N	189569	189569	356757
24937	39142	1	applied	\N	\N	\N	\N	189570	189570	356758
24940	39148	0	applied	\N	\N	\N	\N	189576	189576	356764
24940	39149	1	applied	\N	\N	\N	\N	189577	189577	356765
24940	39150	2	applied	\N	\N	\N	\N	189578	189578	356766
24940	39151	3	applied	\N	\N	\N	\N	189579	189579	356767
24940	39152	4	applied	\N	\N	\N	\N	189580	189580	356768
24940	39153	5	applied	\N	\N	\N	\N	189581	189581	356769
24953	39138	0	applied	\N	\N	\N	\N	189601	189601	356789
24953	39141	1	applied	\N	\N	\N	\N	189602	189602	356790
24953	39144	2	applied	\N	\N	\N	\N	189603	189603	356791
24953	39148	3	applied	\N	\N	\N	\N	189604	189604	356792
24953	39149	4	applied	\N	\N	\N	\N	189605	189605	356793
24953	39154	5	applied	\N	\N	\N	\N	189606	189606	356794
24953	39157	6	applied	\N	\N	\N	\N	189607	189607	356795
24953	39161	7	applied	\N	\N	\N	\N	189608	189608	356796
24953	39147	8	applied	\N	\N	\N	\N	189609	189609	356797
24953	39158	9	applied	\N	\N	\N	\N	189610	189610	356798
24953	39143	11	applied	\N	\N	\N	\N	189612	189612	356800
24953	39146	12	applied	\N	\N	\N	\N	189613	189613	356801
24953	39152	13	applied	\N	\N	\N	\N	189614	189614	356802
24953	39153	14	applied	\N	\N	\N	\N	189615	189615	356803
24953	39155	15	applied	\N	\N	\N	\N	189616	189616	356804
24953	39160	16	applied	\N	\N	\N	\N	189617	189617	356805
24953	39163	17	applied	\N	\N	\N	\N	189618	189618	356806
24953	39140	18	applied	\N	\N	\N	\N	189619	189619	356807
24953	39142	19	applied	\N	\N	\N	\N	189620	189620	356808
24953	39145	20	applied	\N	\N	\N	\N	189621	189621	356809
24953	39150	21	applied	\N	\N	\N	\N	189622	189622	356810
24953	39151	22	applied	\N	\N	\N	\N	189623	189623	356811
24953	39156	23	applied	\N	\N	\N	\N	189624	189624	356812
24953	39159	24	applied	\N	\N	\N	\N	189625	189625	356813
24953	39162	25	applied	\N	\N	\N	\N	189626	189626	356814
24961	39171	0	applied	\N	\N	\N	\N	189649	189649	356837
24961	39173	2	applied	\N	\N	\N	\N	189651	189651	356839
24962	39174	0	applied	\N	\N	\N	\N	189652	189652	356840
24962	39175	1	applied	\N	\N	\N	\N	189653	189653	356841
24962	39176	2	applied	\N	\N	\N	\N	189654	189654	356842
24962	39177	3	applied	\N	\N	\N	\N	189655	189655	356843
24962	39178	4	applied	\N	\N	\N	\N	189656	189656	356844
24962	39179	5	applied	\N	\N	\N	\N	189657	189657	356845
24962	39180	6	applied	\N	\N	\N	\N	189658	189658	356846
24962	39181	7	applied	\N	\N	\N	\N	189659	189659	356847
24964	39182	0	applied	\N	\N	\N	\N	189668	189668	356856
24964	39183	1	applied	\N	\N	\N	\N	189669	189669	356857
24964	39184	2	applied	\N	\N	\N	\N	189670	189670	356858
24968	39198	0	applied	\N	\N	\N	\N	189687	189687	356875
24968	39199	2	applied	\N	\N	\N	\N	189688	189688	356876
24968	39200	3	applied	\N	\N	\N	\N	189689	189689	356877
24970	39205	0	applied	\N	\N	\N	\N	189694	189694	356882
24977	39215	0	applied	\N	\N	\N	\N	189727	189727	356915
24977	39216	1	applied	\N	\N	\N	\N	189728	189728	356916
24977	39217	2	applied	\N	\N	\N	\N	189729	189729	356917
24979	39221	0	applied	\N	\N	\N	\N	189733	189733	356921
24979	39222	1	applied	\N	\N	\N	\N	189734	189734	356922
24979	39223	2	applied	\N	\N	\N	\N	189735	189735	356923
24981	39221	0	applied	\N	\N	\N	\N	189739	189739	356927
24981	39222	1	applied	\N	\N	\N	\N	189740	189740	356928
24985	39224	0	applied	\N	\N	\N	\N	189756	189756	356944
24995	39250	19	applied	\N	\N	\N	\N	189955	189955	357143
24995	39246	20	applied	\N	\N	\N	\N	189956	189956	357144
24995	39247	21	applied	\N	\N	\N	\N	189957	189957	357145
24995	39248	22	applied	\N	\N	\N	\N	189958	189958	357146
24995	39251	23	applied	\N	\N	\N	\N	189959	189959	357147
24995	39252	24	applied	\N	\N	\N	\N	189960	189960	357148
25000	39259	0	applied	\N	\N	\N	\N	189986	189986	357171
25000	39261	2	applied	\N	\N	\N	\N	189988	189988	357173
25000	39262	3	applied	\N	\N	\N	\N	189989	189989	357174
25000	39263	4	applied	\N	\N	\N	\N	189990	189990	357175
25000	39264	5	applied	\N	\N	\N	\N	189991	189991	357176
25000	39265	6	applied	\N	\N	\N	\N	189992	189992	357177
25006	39270	0	applied	\N	\N	\N	\N	190017	190017	357201
25006	39271	1	applied	\N	\N	\N	\N	190018	190018	357202
25006	39273	3	applied	\N	\N	1000000000	\N	190020	190020	357203
25006	39274	4	applied	\N	\N	\N	\N	190021	190021	357204
25006	39275	5	applied	\N	\N	1000000000	\N	190022	190022	357205
25006	39276	6	applied	\N	\N	\N	\N	190023	190023	357206
25011	39284	0	applied	\N	\N	\N	\N	190034	190034	357217
25011	39285	1	applied	\N	\N	\N	\N	190035	190035	357218
25012	39286	0	applied	\N	\N	\N	\N	190036	190036	357219
25012	39287	2	applied	\N	\N	\N	\N	190037	190037	357220
25016	39291	0	applied	\N	\N	\N	\N	190045	190045	357228
25016	39292	1	applied	\N	\N	\N	\N	190046	190046	357229
25019	39291	0	applied	\N	\N	\N	\N	190047	190047	357230
25019	39293	1	applied	\N	\N	\N	\N	190048	190048	357231
25019	39294	2	applied	\N	\N	\N	\N	190049	190049	357232
25019	39295	3	applied	\N	\N	\N	\N	190050	190050	357233
25019	39296	4	applied	\N	\N	\N	\N	190051	190051	357234
25019	39292	5	applied	\N	\N	\N	\N	190052	190052	357235
25019	39297	6	applied	\N	\N	\N	\N	190053	190053	357236
25019	39298	7	applied	\N	\N	\N	\N	190054	190054	357237
25019	39299	8	applied	\N	\N	\N	\N	190055	190055	357238
25022	39300	0	applied	\N	\N	\N	\N	190072	190072	357255
25022	39301	1	applied	\N	\N	\N	\N	190073	190073	357256
25022	39302	2	applied	\N	\N	\N	\N	190074	190074	357257
25022	39303	3	applied	\N	\N	\N	\N	190075	190075	357258
25024	39304	0	applied	\N	\N	\N	\N	190080	190080	357263
25030	39310	1	applied	\N	\N	\N	\N	190094	190094	357277
25030	39311	2	applied	\N	\N	\N	\N	190095	190095	357278
25030	39312	3	applied	\N	\N	\N	\N	190096	190096	357279
25030	39313	4	applied	\N	\N	\N	\N	190097	190097	357280
25031	39314	0	applied	\N	\N	\N	\N	190098	190098	357281
25031	39315	1	applied	\N	\N	\N	\N	190099	190099	357282
25036	39321	0	applied	\N	\N	\N	\N	190110	190110	357293
25036	39322	1	applied	\N	\N	\N	\N	190111	190111	357294
24933	39139	1	applied	\N	\N	\N	\N	189531	189531	356719
24933	39140	2	applied	\N	\N	\N	\N	189532	189532	356720
24986	39230	2	applied	\N	\N	1000000000	\N	189761	189761	356949
24986	39231	3	applied	\N	\N	\N	\N	189762	189762	356950
24986	39232	4	applied	\N	\N	\N	\N	189763	189763	356951
24986	39233	5	applied	\N	\N	\N	\N	189764	189764	356952
24986	39234	6	applied	\N	\N	\N	\N	189765	189765	356953
24986	39235	7	applied	\N	\N	\N	\N	189766	189766	356954
24986	39237	9	applied	\N	\N	\N	\N	189768	189768	356956
24986	39238	10	applied	\N	\N	\N	\N	189769	189769	356957
24988	39158	73	applied	\N	\N	\N	\N	189853	189853	357041
24988	39169	74	applied	\N	\N	\N	\N	189854	189854	357042
24988	39179	75	applied	\N	\N	\N	\N	189855	189855	357043
24988	39192	76	applied	\N	\N	\N	\N	189856	189856	357044
24988	39203	77	applied	\N	\N	\N	\N	189857	189857	357045
24988	39214	78	applied	\N	\N	\N	\N	189858	189858	357046
24988	39226	79	applied	\N	\N	\N	\N	189859	189859	357047
24988	39234	80	applied	\N	\N	\N	\N	189860	189860	357048
24988	39091	81	applied	\N	\N	\N	\N	189861	189861	357049
24988	39096	82	applied	\N	\N	\N	\N	189862	189862	357050
24988	39097	83	applied	\N	\N	\N	\N	189863	189863	357051
24988	39099	84	applied	\N	\N	\N	\N	189864	189864	357052
24988	39103	85	applied	\N	\N	\N	\N	189865	189865	357053
24988	39106	86	applied	\N	\N	\N	\N	189866	189866	357054
24988	39112	88	applied	\N	\N	\N	\N	189868	189868	357056
24988	39116	89	applied	\N	\N	\N	\N	189869	189869	357057
24988	39120	90	applied	\N	\N	\N	\N	189870	189870	357058
24988	39122	91	applied	\N	\N	\N	\N	189871	189871	357059
24988	39127	92	applied	\N	\N	\N	\N	189872	189872	357060
24988	39132	93	applied	\N	\N	\N	\N	189873	189873	357061
24988	39133	94	applied	\N	\N	\N	\N	189874	189874	357062
24988	39136	95	applied	\N	\N	\N	\N	189875	189875	357063
24988	39139	96	applied	\N	\N	\N	\N	189876	189876	357064
24988	39143	97	applied	\N	\N	\N	\N	189877	189877	357065
24988	39146	98	applied	\N	\N	\N	\N	189878	189878	357066
24988	39152	99	applied	\N	\N	\N	\N	189879	189879	357067
24988	39153	100	applied	\N	\N	\N	\N	189880	189880	357068
24988	39155	101	applied	\N	\N	\N	\N	189881	189881	357069
24988	39160	102	applied	\N	\N	\N	\N	189882	189882	357070
24988	39163	103	applied	\N	\N	\N	\N	189883	189883	357071
24988	39170	105	applied	\N	\N	\N	\N	189885	189885	357073
24988	39172	106	applied	\N	\N	\N	\N	189886	189886	357074
24988	39180	107	applied	\N	\N	\N	\N	189887	189887	357075
24988	39181	108	applied	\N	\N	\N	\N	189888	189888	357076
24988	39183	109	applied	\N	\N	\N	\N	189889	189889	357077
24988	39187	110	applied	\N	\N	\N	\N	189890	189890	357078
24988	39191	111	applied	\N	\N	\N	\N	189891	189891	357079
24988	39193	112	applied	\N	\N	\N	\N	189892	189892	357080
24988	39194	113	applied	\N	\N	\N	\N	189893	189893	357081
24988	39199	114	applied	\N	\N	\N	\N	189894	189894	357082
24988	39202	115	applied	\N	\N	\N	\N	189895	189895	357083
24988	39206	116	applied	\N	\N	\N	\N	189896	189896	357084
24988	39212	117	applied	\N	\N	\N	\N	189897	189897	357085
24988	39213	118	applied	\N	\N	\N	\N	189898	189898	357086
24988	39217	119	applied	\N	\N	\N	\N	189899	189899	357087
24988	39220	120	applied	\N	\N	\N	\N	189900	189900	357088
24988	39225	122	applied	\N	\N	\N	\N	189902	189902	357090
24988	39232	123	applied	\N	\N	\N	\N	189903	189903	357091
24988	39233	124	applied	\N	\N	\N	\N	189904	189904	357092
24988	39235	125	applied	\N	\N	\N	\N	189905	189905	357093
24989	39239	0	applied	\N	\N	\N	\N	189906	189906	357094
24989	39240	1	applied	\N	\N	\N	\N	189907	189907	357095
24989	39241	2	applied	\N	\N	\N	\N	189908	189908	357096
24989	39242	3	applied	\N	\N	\N	\N	189909	189909	357097
24989	39243	4	applied	\N	\N	\N	\N	189910	189910	357098
24989	39244	5	applied	\N	\N	\N	\N	189911	189911	357099
24989	39245	6	applied	\N	\N	\N	\N	189912	189912	357100
24989	39246	7	applied	\N	\N	\N	\N	189913	189913	357101
24989	39247	8	applied	\N	\N	\N	\N	189914	189914	357102
24989	39248	9	applied	\N	\N	\N	\N	189915	189915	357103
24991	39249	0	applied	\N	\N	\N	\N	189926	189926	357114
24991	39250	1	applied	\N	\N	\N	\N	189927	189927	357115
24992	39249	0	applied	\N	\N	\N	\N	189929	189929	357117
24992	39250	1	applied	\N	\N	\N	\N	189930	189930	357118
24993	39249	0	applied	\N	\N	\N	\N	189931	189931	357119
24993	39250	1	applied	\N	\N	\N	\N	189932	189932	357120
24993	39251	2	applied	\N	\N	\N	\N	189933	189933	357121
24994	38978	0	applied	\N	\N	\N	\N	189934	189934	357122
24994	38879	1	applied	\N	\N	\N	\N	189935	189935	357123
24996	39253	0	applied	\N	\N	\N	\N	189961	189961	357149
24996	39254	1	applied	\N	\N	\N	\N	189962	189962	357150
24996	39256	3	applied	\N	\N	\N	\N	189964	189964	357151
24996	39257	4	applied	\N	\N	\N	\N	189965	189965	357152
24999	39259	0	applied	\N	\N	\N	\N	189978	189978	357163
24999	39260	1	applied	\N	\N	\N	\N	189979	189979	357164
24999	39261	2	applied	\N	\N	\N	\N	189980	189980	357165
24999	39262	3	applied	\N	\N	\N	\N	189981	189981	357166
24999	39263	4	applied	\N	\N	\N	\N	189982	189982	357167
24999	39264	5	applied	\N	\N	\N	\N	189983	189983	357168
24999	39265	6	applied	\N	\N	\N	\N	189984	189984	357169
24999	39266	7	applied	\N	\N	\N	\N	189985	189985	357170
25004	39267	0	applied	\N	\N	\N	\N	190007	190007	357192
25004	39268	1	applied	\N	\N	\N	\N	190008	190008	357193
25004	39269	2	applied	\N	\N	\N	\N	190009	190009	357194
25008	39277	0	applied	\N	\N	\N	\N	190027	190027	357210
25008	39278	1	applied	\N	\N	\N	\N	190028	190028	357211
25008	39279	2	applied	\N	\N	\N	\N	190029	190029	357212
25015	39291	0	applied	\N	\N	\N	\N	190043	190043	357226
25015	39292	1	applied	\N	\N	\N	\N	190044	190044	357227
25020	39291	0	applied	\N	\N	\N	\N	190056	190056	357239
25020	39293	1	applied	\N	\N	\N	\N	190057	190057	357240
25020	39294	2	applied	\N	\N	\N	\N	190058	190058	357241
25020	39295	3	applied	\N	\N	\N	\N	190059	190059	357242
25020	39296	4	applied	\N	\N	\N	\N	190060	190060	357243
25020	39292	5	applied	\N	\N	\N	\N	190061	190061	357244
25020	39297	6	applied	\N	\N	\N	\N	190062	190062	357245
25020	39298	7	applied	\N	\N	\N	\N	190063	190063	357246
25020	39299	8	applied	\N	\N	\N	\N	190064	190064	357247
25028	39307	0	applied	\N	\N	\N	\N	190086	190086	357269
25028	39308	1	applied	\N	\N	\N	\N	190087	190087	357270
25029	39309	0	applied	\N	\N	\N	\N	190088	190088	357271
24985	39226	2	applied	\N	\N	\N	\N	189758	189758	356946
24986	39229	1	applied	\N	\N	\N	\N	189760	189760	356948
24998	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	189975	189975	\N
24998	39257	4	applied	\N	\N	\N	\N	189977	189977	357162
25003	39267	0	applied	\N	\N	\N	\N	190004	190004	357189
25003	39268	1	applied	\N	\N	\N	\N	190005	190005	357190
25003	39269	2	applied	\N	\N	\N	\N	190006	190006	357191
25005	39270	0	applied	\N	\N	\N	\N	190010	190010	357195
25005	39271	1	applied	\N	\N	\N	\N	190011	190011	357196
25005	39273	3	applied	\N	\N	1000000000	\N	190013	190013	357197
25005	39274	4	applied	\N	\N	\N	\N	190014	190014	357198
25005	39275	5	applied	\N	\N	1000000000	\N	190015	190015	357199
25005	39276	6	applied	\N	\N	\N	\N	190016	190016	357200
25010	39282	0	applied	\N	\N	\N	\N	190032	190032	357215
25010	39283	1	applied	\N	\N	\N	\N	190033	190033	357216
25014	39289	0	applied	\N	\N	\N	\N	190041	190041	357224
25014	39290	1	applied	\N	\N	\N	\N	190042	190042	357225
25021	39293	0	applied	\N	\N	\N	\N	190065	190065	357248
25021	39294	1	applied	\N	\N	\N	\N	190066	190066	357249
25021	39295	2	applied	\N	\N	\N	\N	190067	190067	357250
25021	39296	3	applied	\N	\N	\N	\N	190068	190068	357251
25021	39297	4	applied	\N	\N	\N	\N	190069	190069	357252
25021	39298	5	applied	\N	\N	\N	\N	190070	190070	357253
25021	39299	6	applied	\N	\N	\N	\N	190071	190071	357254
25023	39300	0	applied	\N	\N	\N	\N	190076	190076	357259
25023	39301	1	applied	\N	\N	\N	\N	190077	190077	357260
25023	39302	2	applied	\N	\N	\N	\N	190078	190078	357261
25023	39303	3	applied	\N	\N	\N	\N	190079	190079	357262
25025	39304	0	applied	\N	\N	\N	\N	190081	190081	357264
25026	39305	0	applied	\N	\N	\N	\N	190082	190082	357265
25026	39306	1	applied	\N	\N	\N	\N	190083	190083	357266
25027	39305	0	applied	\N	\N	\N	\N	190084	190084	357267
25027	39306	1	applied	\N	\N	\N	\N	190085	190085	357268
25032	39314	0	applied	\N	\N	\N	\N	190100	190100	357283
25032	39315	1	applied	\N	\N	\N	\N	190101	190101	357284
25033	39317	1	applied	\N	\N	\N	\N	190103	190103	357286
25034	39318	0	applied	\N	\N	\N	\N	190104	190104	357287
25034	39319	1	applied	\N	\N	\N	\N	190105	190105	357288
25034	39320	2	applied	\N	\N	\N	\N	190106	190106	357289
25037	39321	0	applied	\N	\N	\N	\N	190112	190112	357295
25037	39322	1	applied	\N	\N	\N	\N	190113	190113	357296
25038	39230	0	applied	\N	\N	1000000000	\N	190114	190114	357297
25038	39176	1	applied	\N	\N	\N	\N	190115	190115	357298
25038	39273	4	applied	\N	\N	1000000000	\N	190118	190118	357299
25038	39272	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	190117	190117	\N
25038	39275	5	applied	\N	\N	1000000000	\N	190119	190119	357300
25038	39100	6	applied	\N	\N	\N	\N	190120	190120	357301
25038	39102	7	applied	\N	\N	\N	\N	190121	190121	357302
25038	39107	8	applied	\N	\N	\N	\N	190122	190122	357303
25038	39109	9	applied	\N	\N	\N	\N	190123	190123	357304
25038	39114	10	applied	\N	\N	\N	\N	190124	190124	357305
25041	39322	0	applied	\N	\N	\N	\N	190149	190149	357330
25050	39344	0	applied	\N	\N	\N	\N	190173	190173	357354
25050	39345	1	applied	\N	\N	\N	\N	190174	190174	357355
25052	39348	0	applied	\N	\N	\N	\N	190178	190178	357359
25052	39349	1	applied	\N	\N	\N	\N	190179	190179	357360
25057	39362	0	applied	\N	\N	\N	\N	190196	190196	357377
25057	39363	1	applied	\N	\N	\N	\N	190197	190197	357378
25057	39364	2	applied	\N	\N	\N	\N	190198	190198	357379
25060	39369	0	applied	\N	\N	\N	\N	190207	190207	357388
25060	39370	1	applied	\N	\N	\N	\N	190208	190208	357389
25060	39371	2	applied	\N	\N	\N	\N	190209	190209	357390
25062	39372	0	applied	\N	\N	\N	\N	190213	190213	357394
25062	39373	1	applied	\N	\N	\N	\N	190214	190214	357395
25062	39374	2	applied	\N	\N	\N	\N	190215	190215	357396
25067	39385	0	applied	\N	\N	\N	\N	190229	190229	357410
25067	39386	1	applied	\N	\N	\N	\N	190230	190230	357411
25067	39387	2	applied	\N	\N	\N	\N	190231	190231	357412
25070	39398	0	applied	\N	\N	\N	\N	190242	190242	357423
25070	39399	1	applied	\N	\N	\N	\N	190243	190243	357424
25070	39400	2	applied	\N	\N	\N	\N	190244	190244	357425
25070	39401	3	applied	\N	\N	\N	\N	190245	190245	357426
25070	39402	4	applied	\N	\N	\N	\N	190246	190246	357427
25070	39403	5	applied	\N	\N	\N	\N	190247	190247	357428
25070	39404	6	applied	\N	\N	\N	\N	190248	190248	357429
25071	39401	1	applied	\N	\N	\N	\N	190250	190250	357431
25071	39402	2	applied	\N	\N	\N	\N	190251	190251	357432
25073	39398	0	applied	\N	\N	\N	\N	190259	190259	357440
25073	39399	1	applied	\N	\N	\N	\N	190260	190260	357441
25073	39405	2	applied	\N	\N	\N	\N	190261	190261	357442
25073	39406	3	applied	\N	\N	\N	\N	190262	190262	357443
25073	39403	4	applied	\N	\N	\N	\N	190263	190263	357444
25073	39404	5	applied	\N	\N	\N	\N	190264	190264	357445
25073	39407	6	applied	\N	\N	\N	\N	190265	190265	357446
25085	39431	0	applied	\N	\N	\N	\N	190320	190320	357501
25085	39432	1	applied	\N	\N	\N	\N	190321	190321	357502
25085	39433	2	applied	\N	\N	\N	\N	190322	190322	357503
25085	39434	3	applied	\N	\N	\N	\N	190323	190323	357504
25085	39435	4	applied	\N	\N	\N	\N	190324	190324	357505
25085	39436	5	applied	\N	\N	\N	\N	190325	190325	357506
25085	39437	6	applied	\N	\N	\N	\N	190326	190326	357507
25085	39439	8	applied	\N	\N	\N	\N	190328	190328	357509
25085	39440	9	applied	\N	\N	\N	\N	190329	190329	357510
25085	39441	10	applied	\N	\N	\N	\N	190330	190330	357511
25085	39442	11	applied	\N	\N	\N	\N	190331	190331	357512
25085	39443	12	applied	\N	\N	\N	\N	190332	190332	357513
25088	39448	0	applied	\N	\N	\N	\N	190343	190343	357524
25088	39449	1	applied	\N	\N	\N	\N	190344	190344	357525
25088	39450	2	applied	\N	\N	\N	\N	190345	190345	357526
25088	39451	3	applied	\N	\N	\N	\N	190346	190346	357527
25088	39452	4	applied	\N	\N	\N	\N	190347	190347	357528
25088	39453	5	applied	\N	\N	\N	\N	190348	190348	357529
25094	39458	0	applied	\N	\N	\N	\N	190370	190370	357551
25094	39459	1	applied	\N	\N	\N	\N	190371	190371	357552
25094	39460	2	applied	\N	\N	\N	\N	190372	190372	357553
25096	39458	0	applied	\N	\N	\N	\N	190376	190376	357557
25096	39459	1	applied	\N	\N	\N	\N	190377	190377	357558
25099	39461	0	applied	\N	\N	\N	\N	190385	190385	357566
25099	39462	1	applied	\N	\N	\N	\N	190386	190386	357567
25099	39463	2	applied	\N	\N	\N	\N	190387	190387	357568
24998	39254	1	applied	\N	\N	\N	\N	189974	189974	357160
24998	39256	3	applied	\N	\N	\N	\N	189976	189976	357161
25035	39318	0	applied	\N	\N	\N	\N	190107	190107	357290
25035	39319	1	applied	\N	\N	\N	\N	190108	190108	357291
25035	39320	2	applied	\N	\N	\N	\N	190109	190109	357292
25039	39321	0	applied	\N	\N	\N	\N	190145	190145	357326
25039	39322	1	applied	\N	\N	\N	\N	190146	190146	357327
25043	39329	0	applied	\N	\N	\N	\N	190156	190156	357337
25043	39330	1	applied	\N	\N	\N	\N	190157	190157	357338
25043	39331	2	applied	\N	\N	1000000000	\N	190158	190158	357339
25043	39332	3	applied	\N	\N	\N	\N	190159	190159	357340
25043	39333	4	applied	\N	\N	\N	\N	190160	190160	357341
25046	39339	0	applied	\N	\N	\N	\N	190166	190166	357347
25048	39341	0	applied	\N	\N	\N	\N	190169	190169	357350
25048	39342	1	applied	\N	\N	\N	\N	190170	190170	357351
25048	39343	2	applied	\N	\N	\N	\N	190171	190171	357352
25056	39355	1	applied	\N	\N	\N	\N	190189	190189	357370
25056	39356	2	applied	\N	\N	\N	\N	190190	190190	357371
25056	39357	3	applied	\N	\N	\N	\N	190191	190191	357372
25056	39358	4	applied	\N	\N	\N	\N	190192	190192	357373
25056	39359	5	applied	\N	\N	\N	\N	190193	190193	357374
25056	39360	6	applied	\N	\N	\N	\N	190194	190194	357375
25056	39361	7	applied	\N	\N	\N	\N	190195	190195	357376
25059	39365	0	applied	\N	\N	\N	\N	190203	190203	357384
25059	39366	1	applied	\N	\N	\N	\N	190204	190204	357385
25059	39367	2	applied	\N	\N	\N	\N	190205	190205	357386
25059	39368	3	applied	\N	\N	\N	\N	190206	190206	357387
25061	39369	0	applied	\N	\N	\N	\N	190210	190210	357391
25061	39370	1	applied	\N	\N	\N	\N	190211	190211	357392
25061	39371	2	applied	\N	\N	\N	\N	190212	190212	357393
25063	39372	0	applied	\N	\N	\N	\N	190216	190216	357397
25063	39373	1	applied	\N	\N	\N	\N	190217	190217	357398
25066	39382	0	applied	\N	\N	\N	\N	190226	190226	357407
25066	39383	1	applied	\N	\N	\N	\N	190227	190227	357408
25066	39384	2	applied	\N	\N	\N	\N	190228	190228	357409
25069	39395	0	applied	\N	\N	\N	\N	190239	190239	357420
25069	39396	1	applied	\N	\N	\N	\N	190240	190240	357421
25069	39397	2	applied	\N	\N	\N	\N	190241	190241	357422
25074	39408	0	applied	\N	\N	\N	\N	190266	190266	357447
25074	39409	1	applied	\N	\N	\N	\N	190267	190267	357448
25074	39410	2	applied	\N	\N	\N	\N	190268	190268	357449
25076	39411	0	applied	\N	\N	\N	\N	190272	190272	357453
25076	39412	1	applied	\N	\N	\N	\N	190273	190273	357454
25076	39413	2	applied	\N	\N	\N	\N	190274	190274	357455
25076	39414	3	applied	\N	\N	\N	\N	190275	190275	357456
25079	39415	0	applied	\N	\N	\N	\N	190282	190282	357463
25079	39416	1	applied	\N	\N	\N	\N	190283	190283	357464
25079	39417	2	applied	\N	\N	\N	\N	190284	190284	357465
25082	39426	1	applied	\N	\N	\N	\N	190302	190302	357483
25082	39427	2	applied	\N	\N	\N	\N	190303	190303	357484
25083	39428	0	applied	\N	\N	\N	\N	190304	190304	357485
25083	39429	1	applied	\N	\N	\N	\N	190305	190305	357486
25083	39430	2	applied	\N	\N	\N	\N	190306	190306	357487
25086	39444	0	applied	\N	\N	\N	\N	190333	190333	357514
25086	39445	1	applied	\N	\N	\N	\N	190334	190334	357515
25086	39446	2	applied	\N	\N	\N	\N	190335	190335	357516
25086	39447	3	applied	\N	\N	\N	\N	190336	190336	357517
25091	39454	0	applied	\N	\N	\N	\N	190358	190358	357539
25091	39457	1	applied	\N	\N	\N	\N	190359	190359	357540
25091	39455	2	applied	\N	\N	\N	\N	190360	190360	357541
25091	39456	3	applied	\N	\N	\N	\N	190361	190361	357542
25093	39454	0	applied	\N	\N	\N	\N	190366	190366	357547
25093	39457	1	applied	\N	\N	\N	\N	190367	190367	357548
25093	39455	2	applied	\N	\N	\N	\N	190368	190368	357549
25107	39466	1	applied	\N	\N	\N	\N	190453	190453	357634
25107	39467	2	applied	\N	\N	\N	\N	190454	190454	357635
25107	39468	3	applied	\N	\N	\N	\N	190455	190455	357636
25107	39469	4	applied	\N	\N	\N	\N	190456	190456	357637
25107	39470	5	applied	\N	\N	\N	\N	190457	190457	357638
25107	39464	6	applied	\N	\N	\N	\N	190458	190458	357639
25107	39471	7	applied	\N	\N	\N	\N	190459	190459	357640
25107	39472	8	applied	\N	\N	\N	\N	190460	190460	357641
25107	39473	9	applied	\N	\N	\N	\N	190461	190461	357642
25109	39461	0	applied	\N	\N	\N	\N	190468	190468	357649
25109	39465	1	applied	\N	\N	\N	\N	190469	190469	357650
25109	39466	2	applied	\N	\N	\N	\N	190470	190470	357651
25109	39467	4	applied	\N	\N	\N	\N	190471	190471	357652
25109	39468	5	applied	\N	\N	\N	\N	190472	190472	357653
25109	39462	6	applied	\N	\N	\N	\N	190473	190473	357654
25109	39469	7	applied	\N	\N	\N	\N	190474	190474	357655
25109	39463	9	applied	\N	\N	\N	\N	190476	190476	357657
25109	39464	10	applied	\N	\N	\N	\N	190477	190477	357658
25109	39471	11	applied	\N	\N	\N	\N	190478	190478	357659
25109	39472	12	applied	\N	\N	\N	\N	190479	190479	357660
25109	39473	13	applied	\N	\N	\N	\N	190480	190480	357661
25112	39481	0	applied	\N	\N	\N	\N	190488	190488	357669
25112	39482	1	applied	\N	\N	\N	\N	190489	190489	357670
25112	39483	2	applied	\N	\N	\N	\N	190490	190490	357671
25114	39484	0	applied	\N	\N	\N	\N	190494	190494	357675
25114	39485	1	applied	\N	\N	\N	\N	190495	190495	357676
25114	39486	2	applied	\N	\N	\N	\N	190496	190496	357677
25119	39490	0	applied	\N	\N	\N	\N	190518	190518	357699
25119	39491	1	applied	\N	\N	\N	\N	190519	190519	357700
25119	39492	2	applied	\N	\N	\N	\N	190520	190520	357701
25119	39493	3	applied	\N	\N	\N	\N	190521	190521	357702
25119	39494	4	applied	\N	\N	\N	\N	190522	190522	357703
25122	39496	0	applied	\N	\N	\N	\N	190651	190651	357832
25122	39497	1	applied	\N	\N	\N	\N	190652	190652	357833
25122	39498	2	applied	\N	\N	\N	\N	190653	190653	357834
25127	39506	0	applied	\N	\N	\N	\N	190668	190668	357849
25127	39507	1	applied	\N	\N	\N	\N	190669	190669	357850
25127	39508	2	applied	\N	\N	\N	\N	190670	190670	357851
25130	39513	0	applied	\N	\N	\N	\N	190678	190678	357859
25130	39514	1	applied	\N	\N	\N	\N	190679	190679	357860
25130	39515	2	applied	\N	\N	\N	\N	190680	190680	357861
25132	39516	0	applied	\N	\N	\N	\N	190688	190688	357869
25132	39517	1	applied	\N	\N	\N	\N	190689	190689	357870
25132	39518	2	applied	\N	\N	\N	\N	190690	190690	357871
25132	39519	3	applied	\N	\N	\N	\N	190691	190691	357872
25132	39520	4	applied	\N	\N	\N	\N	190692	190692	357873
25132	39521	5	applied	\N	\N	\N	\N	190693	190693	357874
25132	39522	6	applied	\N	\N	\N	\N	190694	190694	357875
25029	39313	4	applied	\N	\N	\N	\N	190092	190092	357275
25038	39130	15	applied	\N	\N	\N	\N	190129	190129	357310
25038	39131	16	applied	\N	\N	\N	\N	190130	190130	357311
25038	39135	17	applied	\N	\N	\N	\N	190131	190131	357312
25038	39140	18	applied	\N	\N	\N	\N	190132	190132	357313
25038	39142	19	applied	\N	\N	\N	\N	190133	190133	357314
25038	39145	20	applied	\N	\N	\N	\N	190134	190134	357315
25038	39150	21	applied	\N	\N	\N	\N	190135	190135	357316
25038	39151	22	applied	\N	\N	\N	\N	190136	190136	357317
25038	39156	23	applied	\N	\N	\N	\N	190137	190137	357318
25038	39159	25	applied	\N	\N	\N	\N	190138	190138	357319
25038	39162	26	applied	\N	\N	\N	\N	190139	190139	357320
25038	39166	27	applied	\N	\N	\N	\N	190140	190140	357321
25038	39168	28	applied	\N	\N	\N	\N	190141	190141	357322
25038	39173	29	applied	\N	\N	\N	\N	190142	190142	357323
25038	39177	30	applied	\N	\N	\N	\N	190143	190143	357324
25038	39178	31	applied	\N	\N	\N	\N	190144	190144	357325
25042	39324	1	applied	\N	\N	\N	\N	190151	190151	357332
25042	39325	2	applied	\N	\N	\N	\N	190152	190152	357333
25042	39326	3	applied	\N	\N	\N	\N	190153	190153	357334
25042	39327	4	applied	\N	\N	\N	\N	190154	190154	357335
25042	39328	5	applied	\N	\N	\N	\N	190155	190155	357336
25045	39337	0	applied	\N	\N	\N	\N	190164	190164	357345
25045	39338	1	applied	\N	\N	\N	\N	190165	190165	357346
25053	39348	0	applied	\N	\N	\N	\N	190180	190180	357361
25053	39349	1	applied	\N	\N	\N	\N	190181	190181	357362
25055	39350	0	applied	\N	\N	\N	\N	190184	190184	357365
25055	39351	1	applied	\N	\N	\N	\N	190185	190185	357366
25055	39352	2	applied	\N	\N	\N	\N	190186	190186	357367
25055	39353	3	applied	\N	\N	\N	\N	190187	190187	357368
25058	39365	0	applied	\N	\N	\N	\N	190199	190199	357380
25058	39366	1	applied	\N	\N	\N	\N	190200	190200	357381
25058	39367	2	applied	\N	\N	\N	\N	190201	190201	357382
25065	39378	0	applied	\N	\N	\N	\N	190222	190222	357403
25065	39379	1	applied	\N	\N	\N	\N	190223	190223	357404
25065	39380	2	applied	\N	\N	\N	\N	190224	190224	357405
25065	39381	3	applied	\N	\N	\N	\N	190225	190225	357406
25068	39388	0	applied	\N	\N	\N	\N	190232	190232	357413
25068	39389	1	applied	\N	\N	\N	\N	190233	190233	357414
25068	39390	2	applied	\N	\N	\N	\N	190234	190234	357415
25068	39391	3	applied	\N	\N	\N	\N	190235	190235	357416
25068	39392	4	applied	\N	\N	\N	\N	190236	190236	357417
25068	39393	5	applied	\N	\N	\N	\N	190237	190237	357418
25068	39394	6	applied	\N	\N	\N	\N	190238	190238	357419
25078	39415	0	applied	\N	\N	\N	\N	190280	190280	357461
25078	39416	1	applied	\N	\N	\N	\N	190281	190281	357462
25090	39454	0	applied	\N	\N	\N	\N	190355	190355	357536
25090	39455	1	applied	\N	\N	\N	\N	190356	190356	357537
25090	39456	2	applied	\N	\N	\N	\N	190357	190357	357538
25095	39458	0	applied	\N	\N	\N	\N	190373	190373	357554
25095	39459	1	applied	\N	\N	\N	\N	190374	190374	357555
25095	39460	2	applied	\N	\N	\N	\N	190375	190375	357556
25097	39458	0	applied	\N	\N	\N	\N	190379	190379	357560
25097	39459	1	applied	\N	\N	\N	\N	190380	190380	357561
25097	39460	2	applied	\N	\N	\N	\N	190381	190381	357562
25100	39461	0	applied	\N	\N	\N	\N	190388	190388	357569
25100	39462	1	applied	\N	\N	\N	\N	190389	190389	357570
25100	39463	2	applied	\N	\N	\N	\N	190390	190390	357571
25101	39461	0	applied	\N	\N	\N	\N	190391	190391	357572
25101	39462	1	applied	\N	\N	\N	\N	190392	190392	357573
25101	39463	2	applied	\N	\N	\N	\N	190393	190393	357574
25103	39461	0	applied	\N	\N	\N	\N	190396	190396	357577
25103	39462	1	applied	\N	\N	\N	\N	190397	190397	357578
25103	39463	2	applied	\N	\N	\N	\N	190398	190398	357579
25105	39461	0	applied	\N	\N	\N	\N	190445	190445	357626
25105	39463	2	applied	\N	\N	\N	\N	190447	190447	357628
25108	39465	0	applied	\N	\N	\N	\N	190462	190462	357643
25108	39466	1	applied	\N	\N	\N	\N	190463	190463	357644
25108	39467	2	applied	\N	\N	\N	\N	190464	190464	357645
25108	39468	3	applied	\N	\N	\N	\N	190465	190465	357646
25108	39471	4	applied	\N	\N	\N	\N	190466	190466	357647
25108	39472	5	applied	\N	\N	\N	\N	190467	190467	357648
25110	39474	0	applied	\N	\N	\N	\N	190481	190481	357662
25110	39475	1	applied	\N	\N	\N	\N	190482	190482	357663
25110	39476	2	applied	\N	\N	\N	\N	190483	190483	357664
25113	39484	0	applied	\N	\N	\N	\N	190491	190491	357672
25113	39485	1	applied	\N	\N	\N	\N	190492	190492	357673
25113	39486	2	applied	\N	\N	\N	\N	190493	190493	357674
25115	39487	0	applied	\N	\N	\N	\N	190497	190497	357678
25115	39488	1	applied	\N	\N	\N	\N	190498	190498	357679
25115	39489	2	applied	\N	\N	\N	\N	190499	190499	357680
25116	39491	1	applied	\N	\N	\N	\N	190501	190501	357682
25116	39492	2	applied	\N	\N	\N	\N	190502	190502	357683
25116	39493	3	applied	\N	\N	\N	\N	190503	190503	357684
25116	39494	4	applied	\N	\N	\N	\N	190504	190504	357685
25116	39495	5	applied	\N	\N	\N	\N	190505	190505	357686
25118	39490	0	applied	\N	\N	\N	\N	190512	190512	357693
25118	39491	1	applied	\N	\N	\N	\N	190513	190513	357694
25118	39492	2	applied	\N	\N	\N	\N	190514	190514	357695
25118	39493	3	applied	\N	\N	\N	\N	190515	190515	357696
25118	39494	4	applied	\N	\N	\N	\N	190516	190516	357697
25118	39495	5	applied	\N	\N	\N	\N	190517	190517	357698
25121	39496	0	applied	\N	\N	\N	\N	190648	190648	357829
25121	39497	1	applied	\N	\N	\N	\N	190649	190649	357830
25121	39498	2	applied	\N	\N	\N	\N	190650	190650	357831
25128	39509	0	applied	\N	\N	\N	\N	190671	190671	357852
25128	39510	1	applied	\N	\N	\N	\N	190672	190672	357853
25128	39512	3	applied	\N	\N	\N	\N	190674	190674	357855
25133	39516	0	applied	\N	\N	\N	\N	190695	190695	357876
25133	39517	1	applied	\N	\N	\N	\N	190696	190696	357877
25133	39518	2	applied	\N	\N	\N	\N	190697	190697	357878
25133	39519	3	applied	\N	\N	\N	\N	190698	190698	357879
25133	39520	4	applied	\N	\N	\N	\N	190699	190699	357880
25133	39521	5	applied	\N	\N	\N	\N	190700	190700	357881
25133	39522	6	applied	\N	\N	\N	\N	190701	190701	357882
25135	39516	0	applied	\N	\N	\N	\N	190709	190709	357890
25135	39517	1	applied	\N	\N	\N	\N	190710	190710	357891
25135	39518	2	applied	\N	\N	\N	\N	190711	190711	357892
25135	39519	3	applied	\N	\N	\N	\N	190712	190712	357893
25135	39520	4	applied	\N	\N	\N	\N	190713	190713	357894
25135	39521	5	applied	\N	\N	\N	\N	190714	190714	357895
25038	39119	12	applied	\N	\N	\N	\N	190126	190126	357307
25038	39123	13	applied	\N	\N	\N	\N	190127	190127	357308
25064	39376	1	applied	\N	\N	\N	\N	190220	190220	357401
25064	39377	2	applied	\N	\N	\N	\N	190221	190221	357402
25072	39398	0	applied	\N	\N	\N	\N	190252	190252	357433
25072	39399	1	applied	\N	\N	\N	\N	190253	190253	357434
25072	39406	3	applied	\N	\N	\N	\N	190255	190255	357436
25075	39409	1	applied	\N	\N	\N	\N	190270	190270	357451
25075	39410	2	applied	\N	\N	\N	\N	190271	190271	357452
25077	39411	0	applied	\N	\N	\N	\N	190276	190276	357457
25077	39412	1	applied	\N	\N	\N	\N	190277	190277	357458
25077	39413	2	applied	\N	\N	\N	\N	190278	190278	357459
25077	39414	3	applied	\N	\N	\N	\N	190279	190279	357460
25080	39418	0	applied	\N	\N	\N	\N	190285	190285	357466
25080	39421	3	applied	\N	\N	\N	\N	190288	190288	357469
25080	39422	4	applied	\N	\N	\N	\N	190289	190289	357470
25080	39423	6	applied	\N	\N	\N	\N	190291	190291	357472
25080	39424	7	applied	\N	\N	\N	\N	190292	190292	357473
25081	39418	0	applied	\N	\N	\N	\N	190293	190293	357474
25081	39419	1	applied	\N	\N	\N	\N	190294	190294	357475
25081	39420	2	applied	\N	\N	\N	\N	190295	190295	357476
25081	39421	3	applied	\N	\N	\N	\N	190296	190296	357477
25081	39422	4	applied	\N	\N	\N	\N	190297	190297	357478
25081	39417	5	applied	\N	\N	\N	\N	190298	190298	357479
25081	39423	6	applied	\N	\N	\N	\N	190299	190299	357480
25081	39424	7	applied	\N	\N	\N	\N	190300	190300	357481
25084	39431	0	applied	\N	\N	\N	\N	190307	190307	357488
25084	39432	1	applied	\N	\N	\N	\N	190308	190308	357489
25084	39433	2	applied	\N	\N	\N	\N	190309	190309	357490
25084	39434	3	applied	\N	\N	\N	\N	190310	190310	357491
25084	39435	4	applied	\N	\N	\N	\N	190311	190311	357492
25084	39436	5	applied	\N	\N	\N	\N	190312	190312	357493
25084	39438	7	applied	\N	\N	\N	\N	190314	190314	357495
25084	39439	8	applied	\N	\N	\N	\N	190315	190315	357496
25084	39440	9	applied	\N	\N	\N	\N	190316	190316	357497
25084	39441	10	applied	\N	\N	\N	\N	190317	190317	357498
25084	39442	11	applied	\N	\N	\N	\N	190318	190318	357499
25084	39443	12	applied	\N	\N	\N	\N	190319	190319	357500
25087	39448	0	applied	\N	\N	\N	\N	190337	190337	357518
25087	39449	1	applied	\N	\N	\N	\N	190338	190338	357519
25087	39450	2	applied	\N	\N	\N	\N	190339	190339	357520
25087	39451	3	applied	\N	\N	\N	\N	190340	190340	357521
25087	39452	4	applied	\N	\N	\N	\N	190341	190341	357522
25087	39453	5	applied	\N	\N	\N	\N	190342	190342	357523
25089	39448	0	applied	\N	\N	\N	\N	190349	190349	357530
25089	39449	1	applied	\N	\N	\N	\N	190350	190350	357531
25089	39450	2	applied	\N	\N	\N	\N	190351	190351	357532
25089	39451	3	applied	\N	\N	\N	\N	190352	190352	357533
25123	39497	1	applied	\N	\N	\N	\N	190655	190655	357836
25123	39498	2	applied	\N	\N	\N	\N	190656	190656	357837
25125	39499	0	applied	\N	\N	\N	\N	190661	190661	357842
25125	39500	1	applied	\N	\N	\N	\N	190662	190662	357843
25125	39501	2	applied	\N	\N	\N	\N	190663	190663	357844
25125	39502	3	applied	\N	\N	\N	\N	190664	190664	357845
25141	39526	0	applied	\N	\N	\N	\N	190731	190731	357912
25141	39527	1	applied	\N	\N	\N	\N	190732	190732	357913
25141	39528	2	applied	\N	\N	\N	\N	190733	190733	357914
25143	39529	0	applied	\N	\N	\N	\N	190737	190737	357918
25150	39506	0	applied	\N	\N	\N	\N	190762	190762	357943
25150	39509	1	applied	\N	\N	\N	\N	190763	190763	357944
25150	39513	2	applied	\N	\N	\N	\N	190764	190764	357945
25150	39538	23	applied	\N	\N	\N	\N	190785	190785	357966
25150	39541	24	applied	\N	\N	\N	\N	190786	190786	357967
25150	39544	25	applied	\N	\N	\N	\N	190787	190787	357968
25150	39546	26	applied	\N	\N	\N	\N	190788	190788	357969
25150	39511	27	applied	\N	\N	\N	\N	190789	190789	357970
25150	39514	28	applied	\N	\N	\N	\N	190790	190790	357971
25150	39518	29	applied	\N	\N	\N	\N	190791	190791	357972
25150	39520	30	applied	\N	\N	\N	\N	190792	190792	357973
25150	39524	31	applied	\N	\N	\N	\N	190793	190793	357974
25150	39528	32	applied	\N	\N	\N	\N	190794	190794	357975
25150	39530	33	applied	\N	\N	\N	\N	190795	190795	357976
25150	39536	34	applied	\N	\N	\N	\N	190796	190796	357977
25150	39539	35	applied	\N	\N	\N	\N	190797	190797	357978
25150	39542	36	applied	\N	\N	\N	\N	190798	190798	357979
25150	39512	37	applied	\N	\N	\N	\N	190799	190799	357980
25044	39334	0	applied	\N	\N	\N	\N	190161	190161	357342
25044	39335	1	applied	\N	\N	\N	\N	190162	190162	357343
25044	39336	2	applied	\N	\N	\N	\N	190163	190163	357344
25047	39339	0	applied	\N	\N	\N	\N	190167	190167	357348
25047	39340	1	applied	\N	\N	\N	\N	190168	190168	357349
25049	39344	0	applied	\N	\N	\N	\N	190172	190172	357353
25051	39346	0	applied	\N	\N	\N	\N	190175	190175	357356
25051	39345	1	applied	\N	\N	\N	\N	190176	190176	357357
25051	39347	2	applied	\N	\N	\N	\N	190177	190177	357358
25054	39348	0	applied	\N	\N	\N	\N	190182	190182	357363
25054	39349	1	applied	\N	\N	\N	\N	190183	190183	357364
25064	39375	0	applied	\N	\N	\N	\N	190219	190219	357400
25072	39403	4	applied	\N	\N	\N	\N	190256	190256	357437
25072	39404	5	applied	\N	\N	\N	\N	190257	190257	357438
25072	39407	6	applied	\N	\N	\N	\N	190258	190258	357439
25075	39408	0	applied	\N	\N	\N	\N	190269	190269	357450
25080	39419	1	applied	\N	\N	\N	\N	190286	190286	357467
25080	39420	2	applied	\N	\N	\N	\N	190287	190287	357468
25092	39457	1	applied	\N	\N	\N	\N	190363	190363	357544
25092	39455	2	applied	\N	\N	\N	\N	190364	190364	357545
25092	39456	3	applied	\N	\N	\N	\N	190365	190365	357546
25098	39461	0	applied	\N	\N	\N	\N	190382	190382	357563
25098	39462	1	applied	\N	\N	\N	\N	190383	190383	357564
25098	39463	2	applied	\N	\N	\N	\N	190384	190384	357565
25102	39462	0	applied	\N	\N	\N	\N	190394	190394	357575
25102	39463	1	applied	\N	\N	\N	\N	190395	190395	357576
25104	39415	0	applied	\N	\N	\N	\N	190399	190399	357580
25104	39418	1	applied	\N	\N	\N	\N	190400	190400	357581
25104	39419	2	applied	\N	\N	\N	\N	190401	190401	357582
25104	39425	3	applied	\N	\N	\N	\N	190402	190402	357583
25104	39428	4	applied	\N	\N	\N	\N	190403	190403	357584
25104	39432	6	applied	\N	\N	\N	\N	190405	190405	357586
25104	39433	7	applied	\N	\N	\N	\N	190406	190406	357587
25104	39434	8	applied	\N	\N	\N	\N	190407	190407	357588
25104	39444	9	applied	\N	\N	\N	\N	190408	190408	357589
25104	39448	10	applied	\N	\N	\N	\N	190409	190409	357590
25104	39449	11	applied	\N	\N	\N	\N	190410	190410	357591
25104	39454	12	applied	\N	\N	\N	\N	190411	190411	357592
25104	39458	13	applied	\N	\N	\N	\N	190412	190412	357593
25104	39416	14	applied	\N	\N	\N	\N	190413	190413	357594
25104	39420	15	applied	\N	\N	\N	\N	190414	190414	357595
25104	39421	16	applied	\N	\N	\N	\N	190415	190415	357596
25104	39426	17	applied	\N	\N	\N	\N	190416	190416	357597
25104	39429	18	applied	\N	\N	\N	\N	190417	190417	357598
25104	39422	19	applied	\N	\N	\N	\N	190418	190418	357599
25104	39439	20	applied	\N	\N	\N	\N	190419	190419	357600
25104	39446	21	applied	\N	\N	\N	\N	190420	190420	357601
25104	39417	23	applied	\N	\N	\N	\N	190422	190422	357603
25104	39423	24	applied	\N	\N	\N	\N	190423	190423	357604
25104	39424	25	applied	\N	\N	\N	\N	190424	190424	357605
25104	39427	26	applied	\N	\N	\N	\N	190425	190425	357606
25104	39430	27	applied	\N	\N	\N	\N	190426	190426	357607
25104	39435	28	applied	\N	\N	\N	\N	190427	190427	357608
25104	39436	29	applied	\N	\N	\N	\N	190428	190428	357609
25104	39437	30	applied	\N	\N	\N	\N	190429	190429	357610
25104	39438	31	applied	\N	\N	\N	\N	190430	190430	357611
25104	39447	32	applied	\N	\N	\N	\N	190431	190431	357612
25104	39451	33	applied	\N	\N	\N	\N	190432	190432	357613
25104	39452	34	applied	\N	\N	\N	\N	190433	190433	357614
25104	39457	35	applied	\N	\N	\N	\N	190434	190434	357615
25104	39460	36	applied	\N	\N	\N	\N	190435	190435	357616
25104	39440	37	applied	\N	\N	\N	\N	190436	190436	357617
25104	39441	38	applied	\N	\N	\N	\N	190437	190437	357618
25104	39443	40	applied	\N	\N	\N	\N	190439	190439	357620
25104	39445	41	applied	\N	\N	\N	\N	190440	190440	357621
25104	39450	42	applied	\N	\N	\N	\N	190441	190441	357622
25104	39453	43	applied	\N	\N	\N	\N	190442	190442	357623
25104	39455	44	applied	\N	\N	\N	\N	190443	190443	357624
25104	39459	45	applied	\N	\N	\N	\N	190444	190444	357625
25106	39461	0	applied	\N	\N	\N	\N	190448	190448	357629
25106	39462	1	applied	\N	\N	\N	\N	190449	190449	357630
25106	39463	2	applied	\N	\N	\N	\N	190450	190450	357631
25106	39464	3	applied	\N	\N	\N	\N	190451	190451	357632
25111	39477	0	applied	\N	\N	\N	\N	190484	190484	357665
25111	39478	1	applied	\N	\N	\N	\N	190485	190485	357666
25111	39479	2	applied	\N	\N	\N	\N	190486	190486	357667
25111	39480	3	applied	\N	\N	\N	\N	190487	190487	357668
25117	39490	0	applied	\N	\N	\N	\N	190506	190506	357687
25117	39491	1	applied	\N	\N	\N	\N	190507	190507	357688
25117	39493	3	applied	\N	\N	\N	\N	190509	190509	357690
25117	39494	4	applied	\N	\N	\N	\N	190510	190510	357691
25117	39495	5	applied	\N	\N	\N	\N	190511	190511	357692
25120	38978	0	applied	\N	\N	\N	\N	190524	190524	357705
25120	38879	1	applied	\N	\N	\N	\N	190525	190525	357706
25120	38873	2	applied	\N	\N	\N	\N	190526	190526	357707
25120	38876	3	applied	\N	\N	\N	\N	190527	190527	357708
25120	39019	4	applied	\N	\N	1000000000	\N	190528	190528	357709
25120	39045	5	applied	\N	\N	\N	\N	190529	190529	357710
25120	39230	6	applied	\N	\N	1000000000	\N	190530	190530	357711
25120	38880	7	applied	\N	\N	\N	\N	190531	190531	357712
25120	38884	8	applied	\N	\N	\N	\N	190532	190532	357713
25120	38887	9	applied	\N	\N	\N	\N	190533	190533	357714
25120	38888	10	applied	\N	\N	\N	\N	190534	190534	357715
25120	38889	11	applied	\N	\N	\N	\N	190535	190535	357716
25120	38900	12	applied	\N	\N	\N	\N	190536	190536	357717
25120	38904	14	applied	\N	\N	\N	\N	190538	190538	357719
25120	38911	15	applied	\N	\N	\N	\N	190539	190539	357720
25120	38914	16	applied	\N	\N	\N	\N	190540	190540	357721
25120	38917	17	applied	\N	\N	\N	\N	190541	190541	357722
25120	38918	18	applied	\N	\N	\N	\N	190542	190542	357723
25120	38924	19	applied	\N	\N	\N	\N	190543	190543	357724
25120	38927	20	applied	\N	\N	\N	\N	190544	190544	357725
25120	38928	21	applied	\N	\N	\N	\N	190545	190545	357726
25120	38929	22	applied	\N	\N	\N	\N	190546	190546	357727
25120	38937	23	applied	\N	\N	\N	\N	190547	190547	357728
25120	38938	24	applied	\N	\N	\N	\N	190548	190548	357729
25120	38944	25	applied	\N	\N	\N	\N	190549	190549	357730
25120	38947	26	applied	\N	\N	\N	\N	190550	190550	357731
25120	38950	27	applied	\N	\N	\N	\N	190551	190551	357732
25120	38954	28	applied	\N	\N	\N	\N	190552	190552	357733
25120	38955	29	applied	\N	\N	\N	\N	190553	190553	357734
25120	38964	31	applied	\N	\N	\N	\N	190555	190555	357736
25120	38965	32	applied	\N	\N	\N	\N	190556	190556	357737
25120	38971	33	applied	\N	\N	\N	\N	190557	190557	357738
25120	38972	34	applied	\N	\N	\N	\N	190558	190558	357739
25120	38979	35	applied	\N	\N	\N	\N	190559	190559	357740
25120	38982	36	applied	\N	\N	\N	\N	190560	190560	357741
25120	38985	37	applied	\N	\N	\N	\N	190561	190561	357742
25120	38986	38	applied	\N	\N	\N	\N	190562	190562	357743
25120	38992	39	applied	\N	\N	\N	\N	190563	190563	357744
25120	38995	40	applied	\N	\N	\N	\N	190564	190564	357745
25120	38996	41	applied	\N	\N	\N	\N	190565	190565	357746
25120	39003	42	applied	\N	\N	\N	\N	190566	190566	357747
25120	39004	43	applied	\N	\N	\N	\N	190567	190567	357748
25120	39010	44	applied	\N	\N	\N	\N	190568	190568	357749
25120	39015	45	applied	\N	\N	\N	\N	190569	190569	357750
25120	39018	46	applied	\N	\N	\N	\N	190570	190570	357751
25089	39453	5	applied	\N	\N	\N	\N	190354	190354	357535
25092	39454	0	applied	\N	\N	\N	\N	190362	190362	357543
25120	39042	52	applied	\N	\N	\N	\N	190576	190576	357757
25120	39046	53	applied	\N	\N	\N	\N	190577	190577	357758
25120	39049	54	applied	\N	\N	\N	\N	190578	190578	357759
25120	39052	55	applied	\N	\N	\N	\N	190579	190579	357760
25120	39055	56	applied	\N	\N	\N	\N	190580	190580	357761
25120	39058	57	applied	\N	\N	\N	\N	190581	190581	357762
25120	39061	58	applied	\N	\N	\N	\N	190582	190582	357763
25120	39064	59	applied	\N	\N	\N	\N	190583	190583	357764
25120	39065	60	applied	\N	\N	\N	\N	190584	190584	357765
25120	39072	61	applied	\N	\N	\N	\N	190585	190585	357766
25120	39075	62	applied	\N	\N	\N	\N	190586	190586	357767
25120	39078	63	applied	\N	\N	\N	\N	190587	190587	357768
25120	39082	64	applied	\N	\N	\N	\N	190588	190588	357769
25120	39083	65	applied	\N	\N	\N	\N	190589	190589	357770
25120	39088	66	applied	\N	\N	\N	\N	190590	190590	357771
25120	39092	67	applied	\N	\N	\N	\N	190591	190591	357772
25120	39098	69	applied	\N	\N	\N	\N	190593	190593	357774
25120	39101	70	applied	\N	\N	\N	\N	190594	190594	357775
25120	39105	71	applied	\N	\N	\N	\N	190595	190595	357776
25120	39108	72	applied	\N	\N	\N	\N	190596	190596	357777
25120	39111	73	applied	\N	\N	\N	\N	190597	190597	357778
25120	39115	74	applied	\N	\N	\N	\N	190598	190598	357779
25120	39118	75	applied	\N	\N	\N	\N	190599	190599	357780
25120	39121	76	applied	\N	\N	\N	\N	190600	190600	357781
25120	39125	77	applied	\N	\N	\N	\N	190601	190601	357782
25120	39128	78	applied	\N	\N	\N	\N	190602	190602	357783
25120	39129	79	applied	\N	\N	\N	\N	190603	190603	357784
25120	39134	80	applied	\N	\N	\N	\N	190604	190604	357785
25120	39138	81	applied	\N	\N	\N	\N	190605	190605	357786
25120	39141	83	applied	\N	\N	\N	\N	190606	190606	357787
25120	39144	84	applied	\N	\N	\N	\N	190607	190607	357788
25120	39148	85	applied	\N	\N	\N	\N	190608	190608	357789
25120	39154	87	applied	\N	\N	\N	\N	190610	190610	357791
25120	39157	88	applied	\N	\N	\N	\N	190611	190611	357792
25120	39161	89	applied	\N	\N	\N	\N	190612	190612	357793
25120	39164	90	applied	\N	\N	\N	\N	190613	190613	357794
25120	39167	91	applied	\N	\N	\N	\N	190614	190614	357795
25120	39171	92	applied	\N	\N	\N	\N	190615	190615	357796
25120	39174	93	applied	\N	\N	\N	\N	190616	190616	357797
25120	39175	94	applied	\N	\N	\N	\N	190617	190617	357798
25120	39182	95	applied	\N	\N	\N	\N	190618	190618	357799
25120	39185	96	applied	\N	\N	\N	\N	190619	190619	357800
25120	39188	97	applied	\N	\N	\N	\N	190620	190620	357801
25120	39189	98	applied	\N	\N	\N	\N	190621	190621	357802
25120	39190	99	applied	\N	\N	\N	\N	190622	190622	357803
25120	39198	100	applied	\N	\N	\N	\N	190623	190623	357804
25120	39201	101	applied	\N	\N	\N	\N	190624	190624	357805
25120	39205	102	applied	\N	\N	\N	\N	190625	190625	357806
25120	39209	104	applied	\N	\N	\N	\N	190627	190627	357808
25120	39215	105	applied	\N	\N	\N	\N	190628	190628	357809
25120	39218	106	applied	\N	\N	\N	\N	190629	190629	357810
25120	39221	107	applied	\N	\N	\N	\N	190630	190630	357811
25120	39224	108	applied	\N	\N	\N	\N	190631	190631	357812
25120	39228	109	applied	\N	\N	\N	\N	190632	190632	357813
25120	39229	110	applied	\N	\N	\N	\N	190633	190633	357814
25120	39231	111	applied	\N	\N	\N	\N	190634	190634	357815
25120	39239	112	applied	\N	\N	\N	\N	190635	190635	357816
25120	39240	113	applied	\N	\N	\N	\N	190636	190636	357817
25120	39241	114	applied	\N	\N	\N	\N	190637	190637	357818
25120	39249	115	applied	\N	\N	\N	\N	190638	190638	357819
25120	39253	116	applied	\N	\N	\N	\N	190639	190639	357820
25120	39254	117	applied	\N	\N	\N	\N	190640	190640	357821
25120	39259	118	applied	\N	\N	\N	\N	190641	190641	357822
25120	39260	119	applied	\N	\N	\N	\N	190642	190642	357823
25120	39267	121	applied	\N	\N	\N	\N	190644	190644	357825
25120	39270	122	applied	\N	\N	\N	\N	190645	190645	357826
25120	39271	123	applied	\N	\N	\N	\N	190646	190646	357827
25120	39277	124	applied	\N	\N	\N	\N	190647	190647	357828
25124	39499	0	applied	\N	\N	\N	\N	190657	190657	357838
25124	39500	1	applied	\N	\N	\N	\N	190658	190658	357839
25124	39501	2	applied	\N	\N	\N	\N	190659	190659	357840
25124	39502	3	applied	\N	\N	\N	\N	190660	190660	357841
25126	39503	0	applied	\N	\N	\N	\N	190665	190665	357846
25126	39504	1	applied	\N	\N	\N	\N	190666	190666	357847
25126	39505	2	applied	\N	\N	\N	\N	190667	190667	357848
25129	39513	0	applied	\N	\N	\N	\N	190675	190675	357856
25129	39514	1	applied	\N	\N	\N	\N	190676	190676	357857
25129	39515	2	applied	\N	\N	\N	\N	190677	190677	357858
25131	39516	0	applied	\N	\N	\N	\N	190681	190681	357862
25131	39517	1	applied	\N	\N	\N	\N	190682	190682	357863
25131	39519	3	applied	\N	\N	\N	\N	190684	190684	357865
25131	39520	4	applied	\N	\N	\N	\N	190685	190685	357866
25131	39521	5	applied	\N	\N	\N	\N	190686	190686	357867
25131	39522	6	applied	\N	\N	\N	\N	190687	190687	357868
25138	39523	0	applied	\N	\N	\N	\N	190722	190722	357903
25138	39524	1	applied	\N	\N	\N	\N	190723	190723	357904
25138	39525	2	applied	\N	\N	\N	\N	190724	190724	357905
25140	39526	0	applied	\N	\N	\N	\N	190728	190728	357909
25140	39527	1	applied	\N	\N	\N	\N	190729	190729	357910
25140	39528	2	applied	\N	\N	\N	\N	190730	190730	357911
25142	39529	0	applied	\N	\N	\N	\N	190734	190734	357915
25142	39530	1	applied	\N	\N	\N	\N	190735	190735	357916
25142	39531	2	applied	\N	\N	\N	\N	190736	190736	357917
25147	39540	0	applied	\N	\N	\N	\N	190751	190751	357932
25151	39548	0	applied	\N	\N	\N	\N	190804	190804	357985
25151	39549	1	applied	\N	\N	\N	\N	190805	190805	357986
25151	39550	2	applied	\N	\N	\N	\N	190806	190806	357987
25156	39556	0	applied	\N	\N	\N	\N	190825	190825	358006
25156	39557	1	applied	\N	\N	\N	\N	190826	190826	358007
25156	39558	2	applied	\N	\N	\N	\N	190827	190827	358008
25156	39559	3	applied	\N	\N	\N	\N	190828	190828	358009
25156	39560	4	applied	\N	\N	\N	\N	190829	190829	358010
25156	39561	5	applied	\N	\N	\N	\N	190830	190830	358011
25158	39556	0	applied	\N	\N	\N	\N	190837	190837	358018
25120	39032	49	applied	\N	\N	\N	\N	190573	190573	357754
25120	39035	50	applied	\N	\N	\N	\N	190574	190574	357755
25134	39520	4	applied	\N	\N	\N	\N	190706	190706	357887
25134	39521	5	applied	\N	\N	\N	\N	190707	190707	357888
25134	39522	6	applied	\N	\N	\N	\N	190708	190708	357889
25136	39523	0	applied	\N	\N	\N	\N	190716	190716	357897
25136	39524	1	applied	\N	\N	\N	\N	190717	190717	357898
25136	39525	2	applied	\N	\N	\N	\N	190718	190718	357899
25145	39537	0	applied	\N	\N	\N	\N	190745	190745	357926
25152	39551	0	applied	\N	\N	\N	\N	190807	190807	357988
25152	39548	1	applied	\N	\N	\N	\N	190808	190808	357989
25152	39549	2	applied	\N	\N	\N	\N	190809	190809	357990
25152	39550	3	applied	\N	\N	\N	\N	190810	190810	357991
25154	39552	0	applied	\N	\N	\N	\N	190815	190815	357996
25154	39553	1	applied	\N	\N	\N	\N	190816	190816	357997
25154	39554	2	applied	\N	\N	\N	\N	190817	190817	357998
25154	39555	3	applied	\N	\N	\N	\N	190818	190818	357999
25158	39557	1	applied	\N	\N	\N	\N	190838	190838	358019
25158	39558	2	applied	\N	\N	\N	\N	190839	190839	358020
25158	39559	3	applied	\N	\N	\N	\N	190840	190840	358021
25158	39560	4	applied	\N	\N	\N	\N	190841	190841	358022
25158	39561	5	applied	\N	\N	\N	\N	190842	190842	358023
25160	39551	0	applied	\N	\N	\N	\N	190846	190846	358027
25160	39552	1	applied	\N	\N	\N	\N	190847	190847	358028
25160	39557	2	applied	\N	\N	\N	\N	190848	190848	358029
25160	39562	3	applied	\N	\N	\N	\N	190849	190849	358030
25160	39548	5	applied	\N	\N	\N	\N	190850	190850	358031
25160	39556	6	applied	\N	\N	\N	\N	190851	190851	358032
25160	39559	7	applied	\N	\N	\N	\N	190852	190852	358033
25160	39549	8	applied	\N	\N	\N	\N	190853	190853	358034
25160	39550	9	applied	\N	\N	\N	\N	190854	190854	358035
25160	39561	10	applied	\N	\N	\N	\N	190855	190855	358036
25160	39554	11	applied	\N	\N	\N	\N	190856	190856	358037
25160	39560	12	applied	\N	\N	\N	\N	190857	190857	358038
25160	39555	13	applied	\N	\N	\N	\N	190858	190858	358039
25160	39558	14	applied	\N	\N	\N	\N	190859	190859	358040
25163	39569	0	applied	\N	\N	\N	\N	190868	190868	358049
25163	39570	1	applied	\N	\N	\N	\N	190869	190869	358050
25163	39571	2	applied	\N	\N	\N	\N	190870	190870	358051
25165	39569	0	applied	\N	\N	\N	\N	190874	190874	358055
25165	39570	1	applied	\N	\N	\N	\N	190875	190875	358056
25165	39571	2	applied	\N	\N	\N	\N	190876	190876	358057
25167	39572	0	applied	\N	\N	\N	\N	190885	190885	358066
25167	39573	1	applied	\N	\N	\N	\N	190886	190886	358067
25167	39574	2	applied	\N	\N	\N	\N	190887	190887	358068
25167	39575	3	applied	\N	\N	\N	\N	190888	190888	358069
25168	39572	0	applied	\N	\N	\N	\N	190889	190889	358070
25168	39573	1	applied	\N	\N	\N	\N	190890	190890	358071
25168	39574	2	applied	\N	\N	\N	\N	190891	190891	358072
25168	39575	3	applied	\N	\N	\N	\N	190892	190892	358073
25169	39576	0	applied	\N	\N	\N	\N	190893	190893	358074
25169	39577	1	applied	\N	\N	\N	\N	190894	190894	358075
25169	39578	2	applied	\N	\N	\N	\N	190895	190895	358076
25171	39577	0	applied	\N	\N	\N	\N	190899	190899	358080
25171	39578	1	applied	\N	\N	\N	\N	190900	190900	358081
25172	39576	0	applied	\N	\N	\N	\N	190901	190901	358082
25172	39579	1	applied	\N	\N	\N	\N	190902	190902	358083
25172	39580	2	applied	\N	\N	\N	\N	190903	190903	358084
25172	39581	3	applied	\N	\N	\N	\N	190904	190904	358085
25174	39586	0	applied	\N	\N	\N	\N	190909	190909	358090
25174	39587	1	applied	\N	\N	\N	\N	190910	190910	358091
25174	39588	2	applied	\N	\N	\N	\N	190911	190911	358092
25177	39596	0	applied	\N	\N	\N	\N	190919	190919	358100
25177	39597	1	applied	\N	\N	\N	\N	190920	190920	358101
25177	39598	2	applied	\N	\N	\N	\N	190921	190921	358102
25179	39602	0	applied	\N	\N	\N	\N	190925	190925	358106
25179	39603	1	applied	\N	\N	\N	\N	190926	190926	358107
25179	39604	2	applied	\N	\N	\N	\N	190927	190927	358108
25184	39605	0	applied	\N	\N	\N	\N	190958	190958	358139
25184	39606	1	applied	\N	\N	\N	\N	190959	190959	358140
25184	39607	2	applied	\N	\N	\N	\N	190960	190960	358141
25184	39613	3	applied	\N	\N	\N	\N	190961	190961	358142
25184	39614	4	applied	\N	\N	\N	\N	190962	190962	358143
25184	39615	5	applied	\N	\N	\N	\N	190963	190963	358144
25184	39608	6	applied	\N	\N	\N	\N	190964	190964	358145
25184	39609	7	applied	\N	\N	\N	\N	190965	190965	358146
25184	39610	8	applied	\N	\N	\N	\N	190966	190966	358147
25184	39611	9	applied	\N	\N	\N	\N	190967	190967	358148
25184	39612	10	applied	\N	\N	\N	\N	190968	190968	358149
25185	39605	0	applied	\N	\N	\N	\N	190969	190969	358150
25185	39606	1	applied	\N	\N	\N	\N	190970	190970	358151
25185	39607	2	applied	\N	\N	\N	\N	190971	190971	358152
25185	39613	3	applied	\N	\N	\N	\N	190972	190972	358153
25185	39614	4	applied	\N	\N	\N	\N	190973	190973	358154
25185	39615	5	applied	\N	\N	\N	\N	190974	190974	358155
25185	39608	6	applied	\N	\N	\N	\N	190975	190975	358156
25185	39609	7	applied	\N	\N	\N	\N	190976	190976	358157
25185	39610	8	applied	\N	\N	\N	\N	190977	190977	358158
25185	39611	9	applied	\N	\N	\N	\N	190978	190978	358159
25185	39612	10	applied	\N	\N	\N	\N	190979	190979	358160
25186	39605	0	applied	\N	\N	\N	\N	190980	190980	358161
25186	39606	1	applied	\N	\N	\N	\N	190981	190981	358162
25186	39607	2	applied	\N	\N	\N	\N	190982	190982	358163
25186	39613	3	applied	\N	\N	\N	\N	190983	190983	358164
25186	39614	4	applied	\N	\N	\N	\N	190984	190984	358165
25186	39615	5	applied	\N	\N	\N	\N	190985	190985	358166
25191	39622	0	applied	\N	\N	\N	\N	191022	191022	358203
25191	39623	2	applied	\N	\N	\N	\N	191023	191023	358204
25191	39625	4	applied	\N	\N	\N	\N	191025	191025	358206
25195	39626	0	applied	\N	\N	\N	\N	191038	191038	358219
25195	39627	1	applied	\N	\N	\N	\N	191039	191039	358220
25195	39628	2	applied	\N	\N	\N	\N	191040	191040	358221
25195	39629	3	applied	\N	\N	\N	\N	191041	191041	358222
25197	39638	0	applied	\N	\N	\N	\N	191050	191050	358231
25197	39639	1	applied	\N	\N	\N	\N	191051	191051	358232
25197	39640	2	applied	\N	\N	\N	\N	191052	191052	358233
25202	39641	0	applied	\N	\N	\N	\N	191192	191192	358373
25202	39642	1	applied	\N	\N	\N	\N	191193	191193	358374
25202	39643	2	applied	\N	\N	\N	\N	191194	191194	358375
25202	39644	3	applied	\N	\N	\N	\N	191195	191195	358376
25202	39645	4	applied	\N	\N	\N	\N	191196	191196	358377
25202	39646	5	applied	\N	\N	\N	\N	191197	191197	358378
25134	39517	1	applied	\N	\N	\N	\N	190703	190703	357884
25134	39518	2	applied	\N	\N	\N	\N	190704	190704	357885
25139	39526	0	applied	\N	\N	\N	\N	190725	190725	357906
25139	39527	1	applied	\N	\N	\N	\N	190726	190726	357907
25139	39528	2	applied	\N	\N	\N	\N	190727	190727	357908
25144	39532	0	applied	\N	\N	\N	\N	190740	190740	357921
25144	39535	3	applied	\N	\N	\N	\N	190743	190743	357924
25144	39536	4	applied	\N	\N	\N	\N	190744	190744	357925
25146	39540	0	applied	\N	\N	\N	\N	190748	190748	357929
25162	39565	0	applied	\N	\N	\N	\N	190864	190864	358045
25162	39566	1	applied	\N	\N	\N	\N	190865	190865	358046
25162	39567	2	applied	\N	\N	\N	\N	190866	190866	358047
25162	39568	3	applied	\N	\N	\N	\N	190867	190867	358048
25164	39569	0	applied	\N	\N	\N	\N	190871	190871	358052
25164	39570	1	applied	\N	\N	\N	\N	190872	190872	358053
25164	39571	2	applied	\N	\N	\N	\N	190873	190873	358054
25166	39565	0	applied	\N	\N	\N	\N	190877	190877	358058
25166	39569	1	applied	\N	\N	\N	\N	190878	190878	358059
25166	39563	2	applied	\N	\N	\N	\N	190879	190879	358060
25166	39564	3	applied	\N	\N	\N	\N	190880	190880	358061
25166	39567	4	applied	\N	\N	\N	\N	190881	190881	358062
25166	39571	5	applied	\N	\N	\N	\N	190882	190882	358063
25166	39568	6	applied	\N	\N	\N	\N	190883	190883	358064
25166	39570	7	applied	\N	\N	\N	\N	190884	190884	358065
25173	39582	0	applied	\N	\N	\N	\N	190905	190905	358086
25173	39583	1	applied	\N	\N	\N	\N	190906	190906	358087
25173	39584	2	applied	\N	\N	\N	\N	190907	190907	358088
25173	39585	3	applied	\N	\N	\N	\N	190908	190908	358089
25176	39592	0	applied	\N	\N	\N	\N	190915	190915	358096
25176	39593	1	applied	\N	\N	\N	\N	190916	190916	358097
25176	39594	2	applied	\N	\N	\N	\N	190917	190917	358098
25176	39595	3	applied	\N	\N	\N	\N	190918	190918	358099
25192	39622	0	applied	\N	\N	\N	\N	191026	191026	358207
25192	39623	2	applied	\N	\N	\N	\N	191027	191027	358208
25192	39624	3	applied	\N	\N	\N	\N	191028	191028	358209
25192	39625	4	applied	\N	\N	\N	\N	191029	191029	358210
25194	39626	0	applied	\N	\N	\N	\N	191034	191034	358215
25194	39627	1	applied	\N	\N	\N	\N	191035	191035	358216
25194	39628	2	applied	\N	\N	\N	\N	191036	191036	358217
25194	39629	3	applied	\N	\N	\N	\N	191037	191037	358218
25198	39638	0	applied	\N	\N	\N	\N	191053	191053	358234
25198	39639	1	applied	\N	\N	\N	\N	191054	191054	358235
25198	39640	2	applied	\N	\N	\N	\N	191055	191055	358236
25200	39626	0	applied	\N	\N	\N	\N	191059	191059	358240
25200	39454	1	applied	\N	\N	\N	\N	191060	191060	358241
25200	39458	2	applied	\N	\N	\N	\N	191061	191061	358242
25200	39461	3	applied	\N	\N	\N	\N	191062	191062	358243
25200	39465	4	applied	\N	\N	\N	\N	191063	191063	358244
25200	39466	5	applied	\N	\N	\N	\N	191064	191064	358245
25200	39467	6	applied	\N	\N	\N	\N	191065	191065	358246
25200	39474	7	applied	\N	\N	\N	\N	191066	191066	358247
25200	39477	8	applied	\N	\N	\N	\N	191067	191067	358248
25200	39481	9	applied	\N	\N	\N	\N	191068	191068	358249
25200	39484	10	applied	\N	\N	\N	\N	191069	191069	358250
25200	39490	11	applied	\N	\N	\N	\N	191070	191070	358251
25200	39491	12	applied	\N	\N	\N	\N	191071	191071	358252
25200	39496	13	applied	\N	\N	\N	\N	191072	191072	358253
25200	39499	14	applied	\N	\N	\N	\N	191073	191073	358254
25200	39503	15	applied	\N	\N	\N	\N	191074	191074	358255
25200	39506	16	applied	\N	\N	\N	\N	191075	191075	358256
25200	39509	17	applied	\N	\N	\N	\N	191076	191076	358257
25200	39513	18	applied	\N	\N	\N	\N	191077	191077	358258
25200	39516	19	applied	\N	\N	\N	\N	191078	191078	358259
25202	39647	6	applied	\N	\N	\N	\N	191198	191198	358379
25206	39651	0	applied	\N	\N	\N	\N	191209	191209	358390
25206	39652	1	applied	\N	\N	\N	\N	191210	191210	358391
25206	39653	2	applied	\N	\N	\N	\N	191211	191211	358392
25206	39654	3	applied	\N	\N	\N	\N	191212	191212	358393
25206	39655	4	applied	\N	\N	\N	\N	191213	191213	358394
25206	39656	5	applied	\N	\N	\N	\N	191214	191214	358395
25206	39657	6	applied	\N	\N	\N	\N	191215	191215	358396
25213	39668	0	applied	\N	\N	\N	\N	191238	191238	358418
25213	39669	1	applied	\N	\N	\N	\N	191239	191239	358419
25213	39670	2	applied	\N	\N	\N	\N	191240	191240	358420
25213	39671	3	applied	\N	\N	\N	\N	191241	191241	358421
25216	39678	0	applied	\N	\N	\N	\N	191248	191248	358428
25216	39679	1	applied	\N	\N	\N	\N	191249	191249	358429
25216	39680	2	applied	\N	\N	\N	\N	191250	191250	358430
25216	39681	3	applied	\N	\N	\N	\N	191251	191251	358431
25216	39682	4	applied	\N	\N	\N	\N	191252	191252	358432
25216	39683	5	applied	\N	\N	\N	\N	191253	191253	358433
25223	39695	0	applied	\N	\N	\N	\N	191276	191276	358456
25223	39697	2	applied	\N	\N	\N	\N	191278	191278	358458
25225	39695	0	applied	\N	\N	\N	\N	191282	191282	358462
25227	39698	0	applied	\N	\N	\N	\N	191288	191288	358468
25227	39696	1	applied	\N	\N	\N	\N	191289	191289	358469
25227	39697	2	applied	\N	\N	\N	\N	191290	191290	358470
25227	39699	3	applied	\N	\N	\N	\N	191291	191291	358471
25227	39700	4	applied	\N	\N	\N	\N	191292	191292	358472
25229	39698	0	applied	\N	\N	\N	\N	191298	191298	358478
25229	39696	1	applied	\N	\N	\N	\N	191299	191299	358479
25229	39697	2	applied	\N	\N	\N	\N	191300	191300	358480
25229	39699	3	applied	\N	\N	\N	\N	191301	191301	358481
25229	39700	4	applied	\N	\N	\N	\N	191302	191302	358482
25231	39698	0	applied	\N	\N	\N	\N	191307	191307	358487
25231	39699	1	applied	\N	\N	\N	\N	191308	191308	358488
25231	39700	2	applied	\N	\N	\N	\N	191309	191309	358489
25240	39711	0	applied	\N	\N	\N	\N	191343	191343	358523
25240	39713	2	applied	\N	\N	\N	\N	191345	191345	358525
25240	39714	3	applied	\N	\N	\N	\N	191346	191346	358526
25240	39715	4	applied	\N	\N	\N	\N	191347	191347	358527
25240	39716	5	applied	\N	\N	\N	\N	191348	191348	358528
25240	39717	6	applied	\N	\N	\N	\N	191349	191349	358529
25240	39718	7	applied	\N	\N	\N	\N	191350	191350	358530
25243	39626	0	applied	\N	\N	\N	\N	191358	191358	358538
25243	39572	1	applied	\N	\N	\N	\N	191359	191359	358539
25243	39576	2	applied	\N	\N	\N	\N	191360	191360	358540
25243	39579	3	applied	\N	\N	\N	\N	191361	191361	358541
25243	39582	4	applied	\N	\N	\N	\N	191362	191362	358542
25243	39586	5	applied	\N	\N	\N	\N	191363	191363	358543
25243	39589	6	applied	\N	\N	\N	\N	191364	191364	358544
25243	39592	7	applied	\N	\N	\N	\N	191365	191365	358545
25137	39524	1	applied	\N	\N	\N	\N	190720	190720	357901
25137	39525	2	applied	\N	\N	\N	\N	190721	190721	357902
25153	39551	0	applied	\N	\N	\N	\N	190811	190811	357992
25153	39548	1	applied	\N	\N	\N	\N	190812	190812	357993
25153	39549	2	applied	\N	\N	\N	\N	190813	190813	357994
25153	39550	3	applied	\N	\N	\N	\N	190814	190814	357995
25155	39556	0	applied	\N	\N	\N	\N	190819	190819	358000
25155	39557	1	applied	\N	\N	\N	\N	190820	190820	358001
25155	39558	2	applied	\N	\N	\N	\N	190821	190821	358002
25155	39559	3	applied	\N	\N	\N	\N	190822	190822	358003
25155	39560	4	applied	\N	\N	\N	\N	190823	190823	358004
25155	39561	5	applied	\N	\N	\N	\N	190824	190824	358005
25157	39556	0	applied	\N	\N	\N	\N	190831	190831	358012
25157	39557	1	applied	\N	\N	\N	\N	190832	190832	358013
25157	39558	2	applied	\N	\N	\N	\N	190833	190833	358014
25157	39559	3	applied	\N	\N	\N	\N	190834	190834	358015
25157	39561	5	applied	\N	\N	\N	\N	190836	190836	358017
25159	39562	0	applied	\N	\N	\N	\N	190843	190843	358024
25159	39563	1	applied	\N	\N	\N	\N	190844	190844	358025
25159	39564	2	applied	\N	\N	\N	\N	190845	190845	358026
25161	39565	0	applied	\N	\N	\N	\N	190860	190860	358041
25161	39566	1	applied	\N	\N	\N	\N	190861	190861	358042
25161	39567	2	applied	\N	\N	\N	\N	190862	190862	358043
25161	39568	3	applied	\N	\N	\N	\N	190863	190863	358044
25170	39576	0	applied	\N	\N	\N	\N	190896	190896	358077
25170	39577	1	applied	\N	\N	\N	\N	190897	190897	358078
25170	39578	2	applied	\N	\N	\N	\N	190898	190898	358079
25175	39589	0	applied	\N	\N	\N	\N	190912	190912	358093
25175	39590	1	applied	\N	\N	\N	\N	190913	190913	358094
25175	39591	2	applied	\N	\N	\N	\N	190914	190914	358095
25178	39599	0	applied	\N	\N	\N	\N	190922	190922	358103
25178	39600	1	applied	\N	\N	\N	\N	190923	190923	358104
25183	39586	0	applied	\N	\N	\N	\N	190928	190928	358109
25183	39589	1	applied	\N	\N	\N	\N	190929	190929	358110
25183	39592	2	applied	\N	\N	\N	\N	190930	190930	358111
25183	39596	3	applied	\N	\N	\N	\N	190931	190931	358112
25183	39599	4	applied	\N	\N	\N	\N	190932	190932	358113
25183	39602	5	applied	\N	\N	\N	\N	190933	190933	358114
25183	39605	6	applied	\N	\N	\N	\N	190934	190934	358115
25183	39606	7	applied	\N	\N	\N	\N	190935	190935	358116
25183	39607	8	applied	\N	\N	\N	\N	190936	190936	358117
25183	39587	9	applied	\N	\N	\N	\N	190937	190937	358118
25183	39588	10	applied	\N	\N	\N	\N	190938	190938	358119
25183	39594	11	applied	\N	\N	\N	\N	190939	190939	358120
25183	39608	12	applied	\N	\N	\N	\N	190940	190940	358121
25183	39590	13	applied	\N	\N	\N	\N	190941	190941	358122
25183	39593	14	applied	\N	\N	\N	\N	190942	190942	358123
25183	39598	15	applied	\N	\N	\N	\N	190943	190943	358124
25183	39603	17	applied	\N	\N	\N	\N	190945	190945	358126
25183	39609	18	applied	\N	\N	\N	\N	190946	190946	358127
25183	39610	19	applied	\N	\N	\N	\N	190947	190947	358128
25183	39611	20	applied	\N	\N	\N	\N	190948	190948	358129
25183	39612	21	applied	\N	\N	\N	\N	190949	190949	358130
25183	39591	22	applied	\N	\N	\N	\N	190950	190950	358131
25183	39595	23	applied	\N	\N	\N	\N	190951	190951	358132
25183	39597	24	applied	\N	\N	\N	\N	190952	190952	358133
25183	39600	25	applied	\N	\N	\N	\N	190953	190953	358134
25183	39604	26	applied	\N	\N	\N	\N	190954	190954	358135
25183	39613	27	applied	\N	\N	\N	\N	190955	190955	358136
25183	39614	28	applied	\N	\N	\N	\N	190956	190956	358137
25183	39615	29	applied	\N	\N	\N	\N	190957	190957	358138
25187	39605	0	applied	\N	\N	\N	\N	190991	190991	358172
25187	39606	1	applied	\N	\N	\N	\N	190992	190992	358173
25187	39607	2	applied	\N	\N	\N	\N	190993	190993	358174
25200	39517	20	applied	\N	\N	\N	\N	191079	191079	358260
25200	39523	21	applied	\N	\N	\N	\N	191080	191080	358261
25200	39526	22	applied	\N	\N	\N	\N	191081	191081	358262
25200	39529	23	applied	\N	\N	\N	\N	191082	191082	358263
25200	39532	24	applied	\N	\N	\N	\N	191083	191083	358264
25200	39537	25	applied	\N	\N	\N	\N	191084	191084	358265
25200	39540	26	applied	\N	\N	\N	\N	191085	191085	358266
25200	39543	27	applied	\N	\N	\N	\N	191086	191086	358267
25200	39551	28	applied	\N	\N	\N	\N	191087	191087	358268
25200	39552	29	applied	\N	\N	\N	\N	191088	191088	358269
25200	39557	30	applied	\N	\N	\N	\N	191089	191089	358270
25200	39562	31	applied	\N	\N	\N	\N	191090	191090	358271
25200	39565	32	applied	\N	\N	\N	\N	191091	191091	358272
25200	39569	33	applied	\N	\N	\N	\N	191092	191092	358273
25200	39572	34	applied	\N	\N	\N	\N	191093	191093	358274
25200	39576	35	applied	\N	\N	\N	\N	191094	191094	358275
25200	39582	37	applied	\N	\N	\N	\N	191096	191096	358277
25200	39586	38	applied	\N	\N	\N	\N	191097	191097	358278
25200	39589	39	applied	\N	\N	\N	\N	191098	191098	358279
25200	39592	40	applied	\N	\N	\N	\N	191099	191099	358280
25200	39596	41	applied	\N	\N	\N	\N	191100	191100	358281
25200	39599	42	applied	\N	\N	\N	\N	191101	191101	358282
25200	39602	43	applied	\N	\N	\N	\N	191102	191102	358283
25200	39605	44	applied	\N	\N	\N	\N	191103	191103	358284
25200	39606	45	applied	\N	\N	\N	\N	191104	191104	358285
25200	39607	46	applied	\N	\N	\N	\N	191105	191105	358286
25200	39616	47	applied	\N	\N	\N	\N	191106	191106	358287
25200	39622	48	applied	\N	\N	\N	\N	191107	191107	358288
25200	39627	49	applied	\N	\N	\N	\N	191108	191108	358289
25200	39630	50	applied	\N	\N	\N	\N	191109	191109	358290
25200	39631	51	applied	\N	\N	\N	\N	191110	191110	358291
25200	39638	52	applied	\N	\N	\N	\N	191111	191111	358292
25200	39455	54	applied	\N	\N	\N	\N	191113	191113	358294
25200	39459	55	applied	\N	\N	\N	\N	191114	191114	358295
25200	39534	56	applied	\N	\N	1000000000	\N	191115	191115	358296
25200	39548	57	applied	\N	\N	\N	\N	191116	191116	358297
25200	39556	58	applied	\N	\N	\N	\N	191117	191117	358298
25200	39463	59	applied	\N	\N	\N	\N	191118	191118	358299
25200	39464	60	applied	\N	\N	\N	\N	191119	191119	358300
25200	39471	61	applied	\N	\N	\N	\N	191120	191120	358301
25200	39472	62	applied	\N	\N	\N	\N	191121	191121	358302
25200	39475	63	applied	\N	\N	\N	\N	191122	191122	358303
25200	39479	64	applied	\N	\N	\N	\N	191123	191123	358304
25200	39482	65	applied	\N	\N	\N	\N	191124	191124	358305
25200	39486	66	applied	\N	\N	\N	\N	191125	191125	358306
25200	39489	67	applied	\N	\N	\N	\N	191126	191126	358307
25200	39492	68	applied	\N	\N	\N	\N	191127	191127	358308
25200	39495	69	applied	\N	\N	\N	\N	191128	191128	358309
25150	39547	41	applied	\N	\N	\N	\N	190803	190803	357984
25186	39612	10	applied	\N	\N	\N	\N	190990	190990	358171
25187	39614	4	applied	\N	\N	\N	\N	190995	190995	358176
25187	39615	5	applied	\N	\N	\N	\N	190996	190996	358177
25187	39608	6	applied	\N	\N	\N	\N	190997	190997	358178
25187	39609	7	applied	\N	\N	\N	\N	190998	190998	358179
25187	39610	8	applied	\N	\N	\N	\N	190999	190999	358180
25187	39611	9	applied	\N	\N	\N	\N	191000	191000	358181
25187	39612	10	applied	\N	\N	\N	\N	191001	191001	358182
25188	39613	0	applied	\N	\N	\N	\N	191002	191002	358183
25188	39614	1	applied	\N	\N	\N	\N	191003	191003	358184
25188	39615	2	applied	\N	\N	\N	\N	191004	191004	358185
25188	39608	3	applied	\N	\N	\N	\N	191005	191005	358186
25188	39609	4	applied	\N	\N	\N	\N	191006	191006	358187
25188	39610	5	applied	\N	\N	\N	\N	191007	191007	358188
25188	39611	6	applied	\N	\N	\N	\N	191008	191008	358189
25188	39612	7	applied	\N	\N	\N	\N	191009	191009	358190
25189	39617	1	applied	\N	\N	\N	\N	191011	191011	358192
25189	39618	2	applied	\N	\N	\N	\N	191012	191012	358193
25189	39619	3	applied	\N	\N	\N	\N	191013	191013	358194
25189	39620	4	applied	\N	\N	\N	\N	191014	191014	358195
25189	39621	5	applied	\N	\N	\N	\N	191015	191015	358196
25190	39616	0	applied	\N	\N	\N	\N	191016	191016	358197
25190	39617	1	applied	\N	\N	\N	\N	191017	191017	358198
25190	39618	2	applied	\N	\N	\N	\N	191018	191018	358199
25190	39619	3	applied	\N	\N	\N	\N	191019	191019	358200
25190	39620	4	applied	\N	\N	\N	\N	191020	191020	358201
25190	39621	5	applied	\N	\N	\N	\N	191021	191021	358202
25193	39622	0	applied	\N	\N	\N	\N	191030	191030	358211
25193	39623	2	applied	\N	\N	\N	\N	191031	191031	358212
25193	39624	3	applied	\N	\N	\N	\N	191032	191032	358213
25193	39625	4	applied	\N	\N	\N	\N	191033	191033	358214
25196	39630	0	applied	\N	\N	\N	\N	191042	191042	358223
25196	39632	2	applied	\N	\N	\N	\N	191044	191044	358225
25196	39633	3	applied	\N	\N	\N	\N	191045	191045	358226
25196	39634	4	applied	\N	\N	\N	\N	191046	191046	358227
25196	39635	5	applied	\N	\N	\N	\N	191047	191047	358228
25196	39636	6	applied	\N	\N	\N	\N	191048	191048	358229
25196	39637	7	applied	\N	\N	\N	\N	191049	191049	358230
25199	39638	0	applied	\N	\N	\N	\N	191056	191056	358237
25199	39639	1	applied	\N	\N	\N	\N	191057	191057	358238
25199	39640	2	applied	\N	\N	\N	\N	191058	191058	358239
25201	39641	0	applied	\N	\N	\N	\N	191185	191185	358366
25201	39642	1	applied	\N	\N	\N	\N	191186	191186	358367
25201	39643	2	applied	\N	\N	\N	\N	191187	191187	358368
25201	39644	3	applied	\N	\N	\N	\N	191188	191188	358369
25201	39645	4	applied	\N	\N	\N	\N	191189	191189	358370
25201	39646	5	applied	\N	\N	\N	\N	191190	191190	358371
25201	39647	6	applied	\N	\N	\N	\N	191191	191191	358372
25203	39642	1	applied	\N	\N	\N	\N	191200	191200	358381
25203	39643	2	applied	\N	\N	\N	\N	191201	191201	358382
25203	39644	3	applied	\N	\N	\N	\N	191202	191202	358383
25203	39645	4	applied	\N	\N	\N	\N	191203	191203	358384
25203	39646	5	applied	\N	\N	\N	\N	191204	191204	358385
25203	39647	6	applied	\N	\N	\N	\N	191205	191205	358386
25204	39648	0	applied	\N	\N	\N	\N	191206	191206	358387
25204	39649	1	applied	\N	\N	\N	\N	191207	191207	358388
25204	39650	2	applied	\N	\N	\N	\N	191208	191208	358389
25207	39658	0	applied	\N	\N	\N	\N	191216	191216	358397
25207	39659	1	applied	\N	\N	\N	\N	191217	191217	358398
25207	39660	2	applied	\N	\N	\N	\N	191218	191218	358399
25207	39661	3	applied	\N	\N	\N	\N	191219	191219	191219
25207	39662	4	applied	\N	\N	\N	\N	191220	191220	358400
25207	39663	5	applied	\N	\N	\N	\N	191221	191221	358401
25207	39664	6	applied	\N	\N	\N	\N	191222	191222	358402
25209	39666	1	applied	\N	\N	\N	\N	191227	191227	358407
25209	39667	2	applied	\N	\N	\N	\N	191228	191228	358408
25211	39665	0	applied	\N	\N	\N	\N	191232	191232	358412
25211	39666	1	applied	\N	\N	\N	\N	191233	191233	358413
25211	39667	2	applied	\N	\N	\N	\N	191234	191234	358414
25215	39675	0	applied	\N	\N	\N	\N	191245	191245	358425
25215	39676	1	applied	\N	\N	\N	\N	191246	191246	358426
25215	39677	2	applied	\N	\N	\N	\N	191247	191247	358427
25218	39684	0	applied	\N	\N	\N	\N	191258	191258	358438
25218	39685	1	applied	\N	\N	\N	\N	191259	191259	358439
25218	39686	2	applied	\N	\N	\N	\N	191260	191260	358440
25219	39688	0	applied	\N	\N	\N	\N	191262	191262	358442
25219	39689	1	applied	\N	\N	\N	\N	191263	191263	358443
25219	39690	2	applied	\N	\N	\N	\N	191264	191264	358444
25221	39691	0	applied	\N	\N	\N	\N	191268	191268	358448
25221	39692	1	applied	\N	\N	\N	\N	191269	191269	358449
25221	39694	3	applied	\N	\N	\N	\N	191271	191271	358451
25224	39695	0	applied	\N	\N	\N	\N	191279	191279	358459
25224	39696	1	applied	\N	\N	\N	\N	191280	191280	358460
25224	39697	2	applied	\N	\N	\N	\N	191281	191281	358461
25228	39698	0	applied	\N	\N	\N	\N	191293	191293	358473
25228	39696	1	applied	\N	\N	\N	\N	191294	191294	358474
25228	39697	2	applied	\N	\N	\N	\N	191295	191295	358475
25228	39699	3	applied	\N	\N	\N	\N	191296	191296	358476
25228	39700	4	applied	\N	\N	\N	\N	191297	191297	358477
25232	39701	0	applied	\N	\N	\N	\N	191310	191310	358490
25232	39702	1	applied	\N	\N	\N	\N	191311	191311	358491
25232	39703	2	applied	\N	\N	\N	\N	191312	191312	358492
25232	39704	3	applied	\N	\N	\N	\N	191313	191313	358493
25232	39705	4	applied	\N	\N	\N	\N	191314	191314	358494
25234	39706	0	applied	\N	\N	\N	\N	191320	191320	358500
25234	39707	1	applied	\N	\N	\N	\N	191321	191321	358501
25234	39709	3	applied	\N	\N	\N	\N	191323	191323	358503
25234	39710	4	applied	\N	\N	\N	\N	191324	191324	358504
25236	39706	0	applied	\N	\N	\N	\N	191330	191330	358510
25236	39707	1	applied	\N	\N	\N	\N	191331	191331	358511
25236	39708	2	applied	\N	\N	\N	\N	191332	191332	358512
25236	39709	3	applied	\N	\N	\N	\N	191333	191333	358513
25236	39710	4	applied	\N	\N	\N	\N	191334	191334	358514
25241	39719	0	applied	\N	\N	\N	\N	191351	191351	358531
25241	39720	1	applied	\N	\N	\N	\N	191352	191352	358532
25241	39721	2	applied	\N	\N	\N	\N	191353	191353	358533
25241	39722	3	applied	\N	\N	\N	\N	191354	191354	358534
25248	39733	0	applied	\N	\N	\N	\N	191511	191511	358690
25248	39734	1	applied	\N	\N	\N	\N	191512	191512	358691
25248	39735	2	applied	\N	\N	\N	\N	191513	191513	358692
25186	39609	7	applied	\N	\N	\N	\N	190987	190987	358168
25186	39610	8	applied	\N	\N	\N	\N	190988	190988	358169
25200	39470	74	applied	\N	\N	\N	\N	191133	191133	358314
25200	39619	75	applied	\N	\N	\N	\N	191134	191134	358315
25200	39620	76	applied	\N	\N	\N	\N	191135	191135	358316
25200	39623	77	applied	\N	\N	\N	\N	191136	191136	358317
25200	39473	78	applied	\N	\N	\N	\N	191137	191137	358318
25200	39561	79	applied	\N	\N	\N	\N	191138	191138	358319
25200	39636	80	applied	\N	\N	\N	\N	191139	191139	358320
25200	39456	81	applied	\N	\N	\N	\N	191140	191140	358321
25200	39468	82	applied	\N	\N	\N	\N	191141	191141	358322
25200	39480	83	applied	\N	\N	\N	\N	191142	191142	358323
25200	39488	84	applied	\N	\N	\N	\N	191143	191143	358324
25200	39500	85	applied	\N	\N	\N	\N	191144	191144	358325
25200	39546	86	applied	\N	\N	\N	\N	191145	191145	358326
25200	39512	87	applied	\N	\N	\N	\N	191146	191146	358327
25200	39519	88	applied	\N	\N	\N	\N	191147	191147	358328
25200	39535	89	applied	\N	\N	\N	\N	191148	191148	358329
25200	39559	91	applied	\N	\N	\N	\N	191150	191150	358331
25200	39574	92	applied	\N	\N	\N	\N	191151	191151	358332
25200	39585	93	applied	\N	\N	\N	\N	191152	191152	358333
25200	39594	94	applied	\N	\N	\N	\N	191153	191153	358334
25200	39612	95	applied	\N	\N	\N	\N	191154	191154	358335
25200	39618	96	applied	\N	\N	\N	\N	191155	191155	358336
25200	39637	97	applied	\N	\N	\N	\N	191156	191156	358337
25200	39498	98	applied	\N	\N	\N	\N	191157	191157	358338
25200	39501	99	applied	\N	\N	\N	\N	191158	191158	358339
25200	39504	100	applied	\N	\N	\N	\N	191159	191159	358340
25200	39507	101	applied	\N	\N	\N	\N	191160	191160	358341
25200	39510	102	applied	\N	\N	\N	\N	191161	191161	358342
25200	39515	103	applied	\N	\N	\N	\N	191162	191162	358343
25200	39521	104	applied	\N	\N	\N	\N	191163	191163	358344
25200	39522	105	applied	\N	\N	\N	\N	191164	191164	358345
25200	39525	106	applied	\N	\N	\N	\N	191165	191165	358346
25200	39531	108	applied	\N	\N	\N	\N	191167	191167	358348
25200	39533	109	applied	\N	\N	\N	\N	191168	191168	358349
25200	39538	110	applied	\N	\N	\N	\N	191169	191169	358350
25200	39541	111	applied	\N	\N	\N	\N	191170	191170	358351
25200	39544	112	applied	\N	\N	\N	\N	191171	191171	358352
25200	39550	113	applied	\N	\N	\N	\N	191172	191172	358353
25200	39554	114	applied	\N	\N	\N	\N	191173	191173	358354
25200	39560	115	applied	\N	\N	\N	\N	191174	191174	358355
25200	39564	116	applied	\N	\N	\N	\N	191175	191175	358356
25200	39568	117	applied	\N	\N	\N	\N	191176	191176	358357
25200	39570	118	applied	\N	\N	\N	\N	191177	191177	358358
25200	39575	119	applied	\N	\N	\N	\N	191178	191178	358359
25200	39577	120	applied	\N	\N	\N	\N	191179	191179	358360
25200	39581	121	applied	\N	\N	\N	\N	191180	191180	358361
25200	39583	122	applied	\N	\N	\N	\N	191181	191181	358362
25200	39588	123	applied	\N	\N	\N	\N	191182	191182	358363
25200	39595	125	applied	\N	\N	\N	\N	191184	191184	358365
25208	39665	0	applied	\N	\N	\N	\N	191223	191223	358403
25208	39666	1	applied	\N	\N	\N	\N	191224	191224	358404
25208	39667	2	applied	\N	\N	\N	\N	191225	191225	358405
25210	39665	0	applied	\N	\N	\N	\N	191229	191229	358409
25210	39666	1	applied	\N	\N	\N	\N	191230	191230	358410
25210	39667	2	applied	\N	\N	\N	\N	191231	191231	358411
25212	39665	0	applied	\N	\N	\N	\N	191235	191235	358415
25212	39666	1	applied	\N	\N	\N	\N	191236	191236	358416
25212	39667	2	applied	\N	\N	\N	\N	191237	191237	358417
25214	39672	0	applied	\N	\N	\N	\N	191242	191242	358422
25214	39673	1	applied	\N	\N	\N	\N	191243	191243	358423
25214	39674	2	applied	\N	\N	\N	\N	191244	191244	358424
25217	39684	0	applied	\N	\N	\N	\N	191254	191254	358434
25217	39685	1	applied	\N	\N	\N	\N	191255	191255	358435
25251	39749	0	applied	\N	\N	\N	\N	191527	191527	358706
25251	39751	2	applied	\N	\N	\N	\N	191529	191529	358708
25252	39752	0	applied	\N	\N	\N	\N	191530	191530	358709
25252	39753	1	applied	\N	\N	\N	\N	191531	191531	358710
25252	39754	2	applied	\N	\N	\N	\N	191532	191532	358711
25252	39755	3	applied	\N	\N	\N	\N	191533	191533	358712
25252	39756	4	applied	\N	\N	\N	\N	191534	191534	358713
25252	39757	5	applied	\N	\N	\N	\N	191535	191535	358714
25252	39758	6	applied	\N	\N	\N	\N	191536	191536	358715
25252	39759	7	applied	\N	\N	\N	\N	191537	191537	358716
25252	39760	8	applied	\N	\N	\N	\N	191538	191538	358717
25252	39761	9	applied	\N	\N	\N	\N	191539	191539	358718
25254	39762	0	applied	\N	\N	\N	\N	191550	191550	358729
25254	39763	1	applied	\N	\N	\N	\N	191551	191551	358730
25254	39764	2	applied	\N	\N	\N	\N	191552	191552	358731
25254	39765	3	applied	\N	\N	\N	\N	191553	191553	358732
25256	39766	0	applied	\N	\N	\N	\N	191558	191558	358737
25256	39768	2	applied	\N	\N	\N	\N	191560	191560	358739
25259	39775	0	applied	\N	\N	\N	\N	191567	191567	358746
25259	39776	1	applied	\N	\N	\N	\N	191568	191568	358747
25259	39777	2	applied	\N	\N	\N	\N	191569	191569	358748
25259	39778	3	applied	\N	\N	\N	\N	191570	191570	358749
25267	39798	0	applied	\N	\N	\N	\N	191623	191623	358802
25267	39799	1	applied	\N	\N	\N	\N	191624	191624	358803
25267	39800	2	applied	\N	\N	\N	\N	191625	191625	358804
25267	39801	3	applied	\N	\N	\N	\N	191626	191626	358805
25267	39802	4	applied	\N	\N	\N	\N	191627	191627	358806
25267	39803	5	applied	\N	\N	\N	\N	191628	191628	358807
25272	39811	0	applied	\N	\N	\N	\N	191759	191759	358938
25272	39812	1	applied	\N	\N	\N	\N	191760	191760	358939
25272	39813	2	applied	\N	\N	\N	\N	191761	191761	358940
25275	39821	0	applied	\N	\N	\N	\N	191769	191769	358948
25275	39822	1	applied	\N	\N	\N	\N	191770	191770	358949
25275	39824	3	applied	\N	\N	\N	\N	191772	191772	358951
25277	39821	0	applied	\N	\N	\N	\N	191779	191779	358958
25277	39822	1	applied	\N	\N	\N	\N	191780	191780	358959
25277	39823	2	applied	\N	\N	\N	\N	191781	191781	358960
25277	39824	3	applied	\N	\N	\N	\N	191782	191782	358961
25277	39825	4	applied	\N	\N	\N	\N	191783	191783	358962
25277	39826	5	applied	\N	\N	\N	\N	191784	191784	358963
25279	39821	0	applied	\N	\N	\N	\N	191791	191791	358970
25279	39822	1	applied	\N	\N	\N	\N	191792	191792	358971
25279	39823	2	applied	\N	\N	\N	\N	191793	191793	358972
25279	39824	3	applied	\N	\N	\N	\N	191794	191794	358973
25279	39825	4	applied	\N	\N	\N	\N	191795	191795	358974
25279	39826	5	applied	\N	\N	\N	\N	191796	191796	358975
25284	39834	0	applied	\N	\N	\N	\N	191814	191814	358993
25200	39460	71	applied	\N	\N	\N	\N	191130	191130	358311
25200	39462	72	applied	\N	\N	\N	\N	191131	191131	358312
25220	39689	1	applied	\N	\N	\N	\N	191266	191266	358446
25220	39690	2	applied	\N	\N	\N	\N	191267	191267	358447
25222	39691	0	applied	\N	\N	\N	\N	191272	191272	358452
25222	39692	1	applied	\N	\N	\N	\N	191273	191273	358453
25222	39693	2	applied	\N	\N	\N	\N	191274	191274	358454
25222	39694	3	applied	\N	\N	\N	\N	191275	191275	358455
25226	39698	0	applied	\N	\N	\N	\N	191283	191283	358463
25226	39696	1	applied	\N	\N	\N	\N	191284	191284	358464
25226	39697	2	applied	\N	\N	\N	\N	191285	191285	358465
25226	39699	3	applied	\N	\N	\N	\N	191286	191286	358466
25226	39700	4	applied	\N	\N	\N	\N	191287	191287	358467
25230	39698	0	applied	\N	\N	\N	\N	191303	191303	358483
25230	39696	1	applied	\N	\N	\N	\N	191304	191304	358484
25230	39697	2	applied	\N	\N	\N	\N	191305	191305	358485
25230	39700	3	applied	\N	\N	\N	\N	191306	191306	358486
25233	39706	0	applied	\N	\N	\N	\N	191315	191315	358495
25233	39708	2	applied	\N	\N	\N	\N	191317	191317	358497
25233	39709	3	applied	\N	\N	\N	\N	191318	191318	358498
25233	39710	4	applied	\N	\N	\N	\N	191319	191319	358499
25235	39706	0	applied	\N	\N	\N	\N	191325	191325	358505
25235	39707	1	applied	\N	\N	\N	\N	191326	191326	358506
25235	39708	2	applied	\N	\N	\N	\N	191327	191327	358507
25235	39709	3	applied	\N	\N	\N	\N	191328	191328	358508
25235	39710	4	applied	\N	\N	\N	\N	191329	191329	358509
25239	39711	0	applied	\N	\N	\N	\N	191335	191335	358515
25239	39712	1	applied	\N	\N	\N	\N	191336	191336	358516
25239	39713	2	applied	\N	\N	\N	\N	191337	191337	358517
25239	39714	3	applied	\N	\N	\N	\N	191338	191338	358518
25239	39715	4	applied	\N	\N	\N	\N	191339	191339	358519
25239	39716	5	applied	\N	\N	\N	\N	191340	191340	358520
25239	39717	6	applied	\N	\N	\N	\N	191341	191341	358521
25239	39718	7	applied	\N	\N	\N	\N	191342	191342	358522
25242	39724	1	applied	\N	\N	\N	\N	191356	191356	358536
25242	39725	2	applied	\N	\N	\N	\N	191357	191357	358537
25244	39726	0	applied	\N	\N	\N	\N	191483	191483	358662
25244	39727	1	applied	\N	\N	\N	\N	191484	191484	358663
25244	39728	2	applied	\N	\N	\N	\N	191485	191485	358664
25244	39729	3	applied	\N	\N	\N	\N	191486	191486	358665
25244	39730	4	applied	\N	\N	\N	\N	191487	191487	358666
25244	39731	5	applied	\N	\N	\N	\N	191488	191488	358667
25244	39732	6	applied	\N	\N	\N	\N	191489	191489	358668
25246	39726	0	applied	\N	\N	\N	\N	191497	191497	358676
25246	39727	1	applied	\N	\N	\N	\N	191498	191498	358677
25246	39728	2	applied	\N	\N	\N	\N	191499	191499	358678
25246	39729	3	applied	\N	\N	\N	\N	191500	191500	358679
25246	39730	4	applied	\N	\N	\N	\N	191501	191501	358680
25246	39731	5	applied	\N	\N	\N	\N	191502	191502	358681
25246	39732	6	applied	\N	\N	\N	\N	191503	191503	358682
25249	39737	1	applied	\N	\N	\N	\N	191515	191515	358694
25249	39738	2	applied	\N	\N	\N	\N	191516	191516	358695
25249	39739	3	applied	\N	\N	\N	\N	191517	191517	358696
25249	39740	4	applied	\N	\N	\N	\N	191518	191518	358697
25249	39741	5	applied	\N	\N	\N	\N	191519	191519	358698
25250	39742	0	applied	\N	\N	\N	\N	191520	191520	358699
25250	39743	1	applied	\N	\N	\N	\N	191521	191521	358700
25250	39744	2	applied	\N	\N	\N	\N	191522	191522	358701
25250	39745	3	applied	\N	\N	\N	\N	191523	191523	358702
25250	39746	4	applied	\N	\N	\N	\N	191524	191524	358703
25250	39747	5	applied	\N	\N	\N	\N	191525	191525	358704
25250	39748	6	applied	\N	\N	\N	\N	191526	191526	358705
25253	39752	0	applied	\N	\N	\N	\N	191540	191540	358719
25253	39753	1	applied	\N	\N	\N	\N	191541	191541	358720
25253	39754	2	applied	\N	\N	\N	\N	191542	191542	358721
25253	39755	3	applied	\N	\N	\N	\N	191543	191543	358722
25253	39757	5	applied	\N	\N	\N	\N	191545	191545	358724
25253	39758	6	applied	\N	\N	\N	\N	191546	191546	358725
25253	39759	7	applied	\N	\N	\N	\N	191547	191547	358726
25253	39760	8	applied	\N	\N	\N	\N	191548	191548	358727
25253	39761	9	applied	\N	\N	\N	\N	191549	191549	358728
25255	39762	0	applied	\N	\N	\N	\N	191554	191554	358733
25258	39772	0	applied	\N	\N	\N	\N	191564	191564	358743
25258	39773	1	applied	\N	\N	\N	\N	191565	191565	358744
25258	39774	2	applied	\N	\N	\N	\N	191566	191566	358745
25260	39775	0	applied	\N	\N	\N	\N	191571	191571	358750
25260	39776	1	applied	\N	\N	\N	\N	191572	191572	358751
25260	39777	2	applied	\N	\N	\N	\N	191573	191573	358752
25260	39778	3	applied	\N	\N	\N	\N	191574	191574	358753
25262	39775	0	applied	\N	\N	\N	\N	191579	191579	358758
25262	39776	1	applied	\N	\N	\N	\N	191580	191580	358759
25262	39777	2	applied	\N	\N	\N	\N	191581	191581	358760
25269	39804	0	applied	\N	\N	\N	\N	191636	191636	358815
25269	39805	1	applied	\N	\N	\N	\N	191637	191637	358816
25269	39806	2	applied	\N	\N	\N	\N	191638	191638	358817
25269	39807	3	applied	\N	\N	\N	\N	191639	191639	358818
25269	39808	4	applied	\N	\N	\N	\N	191640	191640	358819
25269	39809	5	applied	\N	\N	\N	\N	191641	191641	358820
25269	39810	6	applied	\N	\N	\N	\N	191642	191642	358821
25271	39701	0	applied	\N	\N	\N	\N	191650	191650	358829
25271	39706	1	applied	\N	\N	\N	\N	191651	191651	358830
25271	39711	2	applied	\N	\N	\N	\N	191652	191652	358831
25271	39712	3	applied	\N	\N	\N	\N	191653	191653	358832
25271	39719	4	applied	\N	\N	\N	\N	191654	191654	358833
25271	39723	5	applied	\N	\N	\N	\N	191655	191655	358834
25271	39726	6	applied	\N	\N	\N	\N	191656	191656	358835
25271	39727	7	applied	\N	\N	\N	\N	191657	191657	358836
25271	39733	8	applied	\N	\N	\N	\N	191658	191658	358837
25271	39737	10	applied	\N	\N	\N	\N	191660	191660	358839
25271	39742	11	applied	\N	\N	\N	\N	191661	191661	358840
25271	39743	12	applied	\N	\N	\N	\N	191662	191662	358841
25271	39749	14	applied	\N	\N	\N	\N	191663	191663	358842
25271	39752	15	applied	\N	\N	\N	\N	191664	191664	358843
25271	39753	16	applied	\N	\N	\N	\N	191665	191665	358844
25271	39754	17	applied	\N	\N	\N	\N	191666	191666	358845
25271	39762	18	applied	\N	\N	\N	\N	191667	191667	358846
25271	39766	19	applied	\N	\N	\N	\N	191668	191668	358847
25271	39769	20	applied	\N	\N	\N	\N	191669	191669	358848
25271	39772	21	applied	\N	\N	\N	\N	191670	191670	358849
25271	39775	22	applied	\N	\N	\N	\N	191671	191671	358850
25271	39779	23	applied	\N	\N	\N	\N	191672	191672	358851
25271	39781	24	applied	\N	\N	\N	\N	191673	191673	358852
25217	39687	3	applied	\N	\N	\N	\N	191257	191257	358437
25218	39687	3	applied	\N	\N	\N	\N	191261	191261	358441
25243	39606	12	applied	\N	\N	\N	\N	191370	191370	358550
25243	39607	13	applied	\N	\N	\N	\N	191371	191371	358551
25243	39616	14	applied	\N	\N	\N	\N	191372	191372	358552
25243	39622	15	applied	\N	\N	\N	\N	191373	191373	358553
25243	39627	16	applied	\N	\N	\N	\N	191374	191374	358554
25243	39630	17	applied	\N	\N	\N	\N	191375	191375	358555
25243	39631	18	applied	\N	\N	\N	\N	191376	191376	358556
25243	39638	19	applied	\N	\N	\N	\N	191377	191377	358557
25243	39641	20	applied	\N	\N	\N	\N	191378	191378	358558
25243	39642	21	applied	\N	\N	\N	\N	191379	191379	358559
25243	39648	22	applied	\N	\N	\N	\N	191380	191380	358560
25243	39651	23	applied	\N	\N	\N	\N	191381	191381	358561
25243	39652	24	applied	\N	\N	\N	\N	191382	191382	358562
25243	39658	25	applied	\N	\N	\N	\N	191383	191383	358563
25243	39659	26	applied	\N	\N	\N	\N	191384	191384	358564
25243	39665	27	applied	\N	\N	\N	\N	191385	191385	358565
25243	39672	29	applied	\N	\N	\N	\N	191387	191387	358567
25243	39675	30	applied	\N	\N	\N	\N	191388	191388	358568
25243	39678	31	applied	\N	\N	\N	\N	191389	191389	358569
25243	39684	32	applied	\N	\N	\N	\N	191390	191390	358570
25243	39688	33	applied	\N	\N	\N	\N	191391	191391	358571
25243	39691	34	applied	\N	\N	\N	\N	191392	191392	358572
25243	39695	35	applied	\N	\N	\N	\N	191393	191393	358573
25243	39698	36	applied	\N	\N	\N	\N	191394	191394	358574
25243	39701	37	applied	\N	\N	\N	\N	191395	191395	358575
25243	39706	38	applied	\N	\N	\N	\N	191396	191396	358576
25243	39711	39	applied	\N	\N	\N	\N	191397	191397	358577
25243	39712	40	applied	\N	\N	\N	\N	191398	191398	358578
25243	39719	41	applied	\N	\N	\N	\N	191399	191399	358579
25243	39723	42	applied	\N	\N	\N	\N	191400	191400	358580
25243	39726	43	applied	\N	\N	\N	\N	191401	191401	358581
25243	39573	44	applied	\N	\N	\N	\N	191402	191402	358582
25243	39661	46	applied	\N	\N	\N	\N	191404	191404	191404
25243	39574	47	applied	\N	\N	\N	\N	191405	191405	358584
25243	39575	48	applied	\N	\N	\N	\N	191406	191406	358585
25243	39577	49	applied	\N	\N	\N	\N	191407	191407	358586
25243	39581	50	applied	\N	\N	\N	\N	191408	191408	358587
25243	39583	51	applied	\N	\N	\N	\N	191409	191409	358588
25243	39588	52	applied	\N	\N	\N	\N	191410	191410	358589
25243	39585	53	applied	\N	\N	\N	\N	191411	191411	358590
25243	39594	54	applied	\N	\N	\N	\N	191412	191412	358591
25243	39608	55	applied	\N	\N	\N	\N	191413	191413	358592
25243	39619	56	applied	\N	\N	\N	\N	191414	191414	358593
25243	39620	57	applied	\N	\N	\N	\N	191415	191415	358594
25243	39623	58	applied	\N	\N	\N	\N	191416	191416	358595
25243	39636	59	applied	\N	\N	\N	\N	191417	191417	358596
25243	39682	60	applied	\N	\N	\N	\N	191418	191418	358597
25243	39705	61	applied	\N	\N	\N	\N	191419	191419	358598
25243	39618	63	applied	\N	\N	\N	\N	191421	191421	358600
25243	39591	64	applied	\N	\N	\N	\N	191422	191422	358601
25243	39595	65	applied	\N	\N	\N	\N	191423	191423	358602
25243	39597	66	applied	\N	\N	\N	\N	191424	191424	358603
25243	39600	67	applied	\N	\N	\N	\N	191425	191425	358604
25243	39604	68	applied	\N	\N	\N	\N	191426	191426	358605
25243	39613	69	applied	\N	\N	\N	\N	191427	191427	358606
25243	39614	70	applied	\N	\N	\N	\N	191428	191428	358607
25243	39615	71	applied	\N	\N	\N	\N	191429	191429	358608
25243	39617	72	applied	\N	\N	\N	\N	191430	191430	358609
25243	39625	73	applied	\N	\N	\N	\N	191431	191431	358610
25243	39637	74	applied	\N	\N	\N	\N	191432	191432	358611
25243	39644	75	applied	\N	\N	\N	\N	191433	191433	358612
25243	39655	76	applied	\N	\N	\N	\N	191434	191434	358613
25243	39669	77	applied	\N	\N	\N	\N	191435	191435	358614
25271	39782	25	applied	\N	\N	\N	\N	191674	191674	358853
25271	39784	27	applied	\N	\N	\N	\N	191676	191676	358855
25271	39785	28	applied	\N	\N	\N	\N	191677	191677	358856
25271	39798	29	applied	\N	\N	\N	\N	191678	191678	358857
25271	39799	30	applied	\N	\N	\N	\N	191679	191679	358858
25271	39804	31	applied	\N	\N	\N	\N	191680	191680	358859
25271	39805	32	applied	\N	\N	\N	\N	191681	191681	358860
25271	39702	33	applied	\N	\N	\N	\N	191682	191682	358861
25271	39703	34	applied	\N	\N	\N	\N	191683	191683	358862
25271	39708	35	applied	\N	\N	\N	\N	191684	191684	358863
25271	39721	36	applied	\N	\N	\N	\N	191685	191685	358864
25271	39704	37	applied	\N	\N	\N	\N	191686	191686	358865
25271	39707	38	applied	\N	\N	\N	\N	191687	191687	358866
25271	39713	39	applied	\N	\N	\N	\N	191688	191688	358867
25271	39714	40	applied	\N	\N	\N	\N	191689	191689	358868
25271	39722	41	applied	\N	\N	\N	\N	191690	191690	358869
25271	39725	42	applied	\N	\N	\N	\N	191691	191691	358870
25271	39715	44	applied	\N	\N	\N	\N	191693	191693	358872
25271	39716	45	applied	\N	\N	\N	\N	191694	191694	358873
25271	39720	46	applied	\N	\N	\N	\N	191695	191695	358874
25271	39724	47	applied	\N	\N	\N	\N	191696	191696	358875
25271	39728	48	applied	\N	\N	\N	\N	191697	191697	358876
25271	39746	49	applied	\N	\N	\N	\N	191698	191698	358877
25271	39755	50	applied	\N	\N	\N	\N	191699	191699	358878
25271	39763	51	applied	\N	\N	\N	\N	191700	191700	358879
25271	39778	52	applied	\N	\N	\N	\N	191701	191701	358880
25271	39786	53	applied	\N	\N	\N	\N	191702	191702	358881
25271	39788	54	applied	\N	\N	\N	\N	191703	191703	358882
25271	39806	55	applied	\N	\N	\N	\N	191704	191704	358883
25271	39729	56	applied	\N	\N	\N	\N	191705	191705	358884
25271	39730	57	applied	\N	\N	\N	\N	191706	191706	358885
25271	39735	58	applied	\N	\N	\N	\N	191707	191707	358886
25271	39738	59	applied	\N	\N	\N	\N	191708	191708	358887
25271	39744	61	applied	\N	\N	\N	\N	191710	191710	358889
25271	39745	62	applied	\N	\N	\N	\N	191711	191711	358890
25271	39705	63	applied	\N	\N	\N	\N	191712	191712	358891
25271	39751	64	applied	\N	\N	\N	\N	191713	191713	358892
25271	39756	65	applied	\N	\N	\N	\N	191714	191714	358893
25271	39757	66	applied	\N	\N	\N	\N	191715	191715	358894
25271	39758	67	applied	\N	\N	\N	\N	191716	191716	358895
25271	39710	68	applied	\N	\N	\N	\N	191717	191717	358896
25271	39717	69	applied	\N	\N	\N	\N	191718	191718	358897
25271	39765	70	applied	\N	\N	\N	\N	191719	191719	358898
25271	39767	71	applied	\N	\N	\N	\N	191720	191720	358899
25271	39771	72	applied	\N	\N	\N	\N	191721	191721	358900
25271	39774	73	applied	\N	\N	\N	\N	191722	191722	358901
25271	39777	74	applied	\N	\N	\N	\N	191723	191723	358902
25243	39599	9	applied	\N	\N	\N	\N	191367	191367	358547
25243	39602	10	applied	\N	\N	\N	\N	191368	191368	358548
25243	39683	82	applied	\N	\N	\N	\N	191440	191440	358619
25243	39687	83	applied	\N	\N	\N	\N	191441	191441	358620
25243	39578	84	applied	\N	\N	\N	\N	191442	191442	358621
25243	39580	85	applied	\N	\N	\N	\N	191443	191443	358622
25243	39584	86	applied	\N	\N	\N	\N	191444	191444	358623
25243	39587	87	applied	\N	\N	\N	\N	191445	191445	358624
25243	39590	88	applied	\N	\N	\N	\N	191446	191446	358625
25243	39593	89	applied	\N	\N	\N	\N	191447	191447	358626
25243	39598	90	applied	\N	\N	\N	\N	191448	191448	358627
25243	39601	91	applied	\N	\N	\N	\N	191449	191449	358628
25243	39603	92	applied	\N	\N	\N	\N	191450	191450	358629
25243	39609	93	applied	\N	\N	\N	\N	191451	191451	358630
25243	39610	94	applied	\N	\N	\N	\N	191452	191452	358631
25243	39611	95	applied	\N	\N	\N	\N	191453	191453	358632
25243	39710	96	applied	\N	\N	\N	\N	191454	191454	358633
25243	39717	97	applied	\N	\N	\N	\N	191455	191455	358634
25243	39624	99	applied	\N	\N	\N	\N	191457	191457	358636
25243	39628	100	applied	\N	\N	\N	\N	191458	191458	358637
25243	39633	101	applied	\N	\N	\N	\N	191459	191459	358638
25243	39634	102	applied	\N	\N	\N	\N	191460	191460	358639
25243	39639	103	applied	\N	\N	\N	\N	191461	191461	358640
25243	39645	104	applied	\N	\N	\N	\N	191462	191462	358641
25243	39647	106	applied	\N	\N	\N	\N	191463	191463	358642
25243	39650	107	applied	\N	\N	\N	\N	191464	191464	358643
25243	39653	108	applied	\N	\N	\N	\N	191465	191465	358644
25243	39654	109	applied	\N	\N	\N	\N	191466	191466	358645
25243	39662	110	applied	\N	\N	\N	\N	191467	191467	358646
25243	39663	111	applied	\N	\N	\N	\N	191468	191468	358647
25243	39667	112	applied	\N	\N	\N	\N	191469	191469	358648
25243	39670	113	applied	\N	\N	\N	\N	191470	191470	358649
25243	39674	114	applied	\N	\N	\N	\N	191471	191471	358650
25243	39676	115	applied	\N	\N	\N	\N	191472	191472	358651
25243	39686	117	applied	\N	\N	\N	\N	191474	191474	358653
25243	39690	118	applied	\N	\N	\N	\N	191475	191475	358654
25243	39694	119	applied	\N	\N	\N	\N	191476	191476	358655
25243	39696	120	applied	\N	\N	\N	\N	191477	191477	358656
25243	39700	121	applied	\N	\N	\N	\N	191478	191478	358657
25243	39703	122	applied	\N	\N	\N	\N	191479	191479	358658
25243	39709	123	applied	\N	\N	\N	\N	191480	191480	358659
25243	39715	124	applied	\N	\N	\N	\N	191481	191481	358660
25243	39716	125	applied	\N	\N	\N	\N	191482	191482	358661
25245	39726	0	applied	\N	\N	\N	\N	191490	191490	358669
25245	39727	1	applied	\N	\N	\N	\N	191491	191491	358670
25245	39728	2	applied	\N	\N	\N	\N	191492	191492	358671
25245	39729	3	applied	\N	\N	\N	\N	191493	191493	358672
25245	39730	4	applied	\N	\N	\N	\N	191494	191494	358673
25245	39731	5	applied	\N	\N	\N	\N	191495	191495	358674
25245	39732	6	applied	\N	\N	\N	\N	191496	191496	358675
25247	39727	1	applied	\N	\N	\N	\N	191505	191505	358684
25247	39728	2	applied	\N	\N	\N	\N	191506	191506	358685
25247	39729	3	applied	\N	\N	\N	\N	191507	191507	358686
25247	39730	4	applied	\N	\N	\N	\N	191508	191508	358687
25247	39731	5	applied	\N	\N	\N	\N	191509	191509	358688
25247	39732	6	applied	\N	\N	\N	\N	191510	191510	358689
25261	39775	0	applied	\N	\N	\N	\N	191575	191575	358754
25261	39776	1	applied	\N	\N	\N	\N	191576	191576	358755
25261	39777	2	applied	\N	\N	\N	\N	191577	191577	358756
25261	39778	3	applied	\N	\N	\N	\N	191578	191578	358757
25263	39775	0	applied	\N	\N	\N	\N	191583	191583	358762
25263	39776	1	applied	\N	\N	\N	\N	191584	191584	358763
25263	39777	2	applied	\N	\N	\N	\N	191585	191585	358764
25263	39778	3	applied	\N	\N	\N	\N	191586	191586	358765
25266	39781	0	applied	\N	\N	\N	\N	191606	191606	358785
25266	39782	1	applied	\N	\N	\N	\N	191607	191607	358786
25266	39784	3	applied	\N	\N	\N	\N	191609	191609	358788
25266	39785	4	applied	\N	\N	\N	\N	191610	191610	358789
25266	39786	5	applied	\N	\N	\N	\N	191611	191611	358790
25266	39787	6	applied	\N	\N	\N	\N	191612	191612	358791
25266	39788	7	applied	\N	\N	\N	\N	191613	191613	358792
25266	39789	8	applied	\N	\N	\N	\N	191614	191614	358793
25266	39790	9	applied	\N	\N	\N	\N	191615	191615	358794
25266	39791	10	applied	\N	\N	\N	\N	191616	191616	358795
25266	39792	11	applied	\N	\N	\N	\N	191617	191617	358796
25266	39793	12	applied	\N	\N	\N	\N	191618	191618	358797
25266	39794	13	applied	\N	\N	\N	\N	191619	191619	358798
25266	39795	14	applied	\N	\N	\N	\N	191620	191620	358799
25266	39796	15	applied	\N	\N	\N	\N	191621	191621	358800
25266	39797	16	applied	\N	\N	\N	\N	191622	191622	358801
25270	39804	0	applied	\N	\N	\N	\N	191643	191643	358822
25270	39805	1	applied	\N	\N	\N	\N	191644	191644	358823
25270	39807	3	applied	\N	\N	\N	\N	191646	191646	358825
25270	39808	4	applied	\N	\N	\N	\N	191647	191647	358826
25270	39809	5	applied	\N	\N	\N	\N	191648	191648	358827
25270	39810	6	applied	\N	\N	\N	\N	191649	191649	358828
25274	39817	0	applied	\N	\N	\N	\N	191765	191765	358944
25274	39818	1	applied	\N	\N	\N	\N	191766	191766	358945
25274	39819	2	applied	\N	\N	\N	\N	191767	191767	358946
25274	39820	3	applied	\N	\N	\N	\N	191768	191768	358947
25281	39827	0	applied	\N	\N	\N	\N	191801	191801	358980
25281	39828	1	applied	\N	\N	\N	\N	191802	191802	358981
25281	39829	2	applied	\N	\N	\N	\N	191803	191803	358982
25281	39830	3	applied	\N	\N	\N	\N	191804	191804	358983
25283	39834	0	applied	\N	\N	\N	\N	191808	191808	358987
25283	39835	1	applied	\N	\N	\N	\N	191809	191809	358988
25283	39836	2	applied	\N	\N	\N	\N	191810	191810	358989
25283	39837	3	applied	\N	\N	\N	\N	191811	191811	358990
25283	39839	5	applied	\N	\N	\N	\N	191813	191813	358992
25290	39847	0	applied	\N	\N	\N	\N	191838	191838	359017
25290	39848	1	applied	\N	\N	\N	\N	191839	191839	359018
25295	39859	0	applied	\N	\N	\N	\N	191975	191975	359154
25295	39860	1	applied	\N	\N	\N	\N	191976	191976	359155
25295	39861	2	applied	\N	\N	\N	\N	191977	191977	359156
25295	39862	3	applied	\N	\N	\N	\N	191978	191978	359157
25304	39876	0	applied	\N	\N	\N	\N	192018	192018	359196
25304	39877	1	applied	\N	\N	\N	\N	192019	192019	359197
25304	39878	2	applied	\N	\N	\N	\N	192020	192020	359198
25306	39882	0	applied	\N	\N	\N	\N	192024	192024	359202
25306	39883	1	applied	\N	\N	\N	\N	192025	192025	359203
25313	39889	0	applied	\N	\N	\N	\N	192034	192034	359212
25313	39890	1	applied	\N	\N	\N	\N	192035	192035	359213
25243	39692	79	applied	\N	\N	\N	\N	191437	191437	358616
25243	39708	80	applied	\N	\N	\N	\N	191438	191438	358617
25257	39769	0	applied	\N	\N	\N	\N	191561	191561	358740
25257	39770	1	applied	\N	\N	\N	\N	191562	191562	358741
25257	39771	2	applied	\N	\N	\N	\N	191563	191563	358742
25264	39779	0	applied	\N	\N	\N	\N	191587	191587	358766
25264	39780	1	applied	\N	\N	\N	\N	191588	191588	358767
25265	39781	0	applied	\N	\N	\N	\N	191589	191589	358768
25265	39782	1	applied	\N	\N	\N	\N	191590	191590	358769
25265	39783	2	applied	\N	\N	\N	\N	191591	191591	358770
25265	39784	3	applied	\N	\N	\N	\N	191592	191592	358771
25265	39785	4	applied	\N	\N	\N	\N	191593	191593	358772
25265	39786	5	applied	\N	\N	\N	\N	191594	191594	358773
25265	39787	6	applied	\N	\N	\N	\N	191595	191595	358774
25265	39788	7	applied	\N	\N	\N	\N	191596	191596	358775
25265	39790	9	applied	\N	\N	\N	\N	191598	191598	358777
25265	39791	10	applied	\N	\N	\N	\N	191599	191599	358778
25265	39792	11	applied	\N	\N	\N	\N	191600	191600	358779
25265	39793	12	applied	\N	\N	\N	\N	191601	191601	358780
25265	39794	13	applied	\N	\N	\N	\N	191602	191602	358781
25265	39795	14	applied	\N	\N	\N	\N	191603	191603	358782
25265	39796	15	applied	\N	\N	\N	\N	191604	191604	358783
25265	39797	16	applied	\N	\N	\N	\N	191605	191605	358784
25268	39804	0	applied	\N	\N	\N	\N	191629	191629	358808
25268	39805	1	applied	\N	\N	\N	\N	191630	191630	358809
25268	39806	2	applied	\N	\N	\N	\N	191631	191631	358810
25268	39807	3	applied	\N	\N	\N	\N	191632	191632	358811
25268	39808	4	applied	\N	\N	\N	\N	191633	191633	358812
25268	39809	5	applied	\N	\N	\N	\N	191634	191634	358813
25268	39810	6	applied	\N	\N	\N	\N	191635	191635	358814
25276	39821	0	applied	\N	\N	\N	\N	191773	191773	358952
25276	39823	2	applied	\N	\N	\N	\N	191775	191775	358954
25276	39824	3	applied	\N	\N	\N	\N	191776	191776	358955
25276	39825	4	applied	\N	\N	\N	\N	191777	191777	358956
25276	39826	5	applied	\N	\N	\N	\N	191778	191778	358957
25278	39821	0	applied	\N	\N	\N	\N	191785	191785	358964
25278	39822	1	applied	\N	\N	\N	\N	191786	191786	358965
25278	39823	2	applied	\N	\N	\N	\N	191787	191787	358966
25278	39824	3	applied	\N	\N	\N	\N	191788	191788	358967
25278	39825	4	applied	\N	\N	\N	\N	191789	191789	358968
25278	39826	5	applied	\N	\N	\N	\N	191790	191790	358969
25282	39831	0	applied	\N	\N	\N	\N	191805	191805	358984
25282	39832	1	applied	\N	\N	\N	\N	191806	191806	358985
25282	39833	2	applied	\N	\N	\N	\N	191807	191807	358986
25285	39834	0	applied	\N	\N	\N	\N	191820	191820	358999
25285	39835	1	applied	\N	\N	\N	\N	191821	191821	359000
25285	39836	2	applied	\N	\N	\N	\N	191822	191822	359001
25285	39838	4	applied	\N	\N	\N	\N	191824	191824	359003
25285	39839	5	applied	\N	\N	\N	\N	191825	191825	359004
25287	39844	0	applied	\N	\N	\N	\N	191830	191830	359009
25287	39845	1	applied	\N	\N	\N	\N	191831	191831	359010
25287	39846	2	applied	\N	\N	\N	\N	191832	191832	359011
25289	39847	0	applied	\N	\N	\N	\N	191836	191836	359015
25289	39848	1	applied	\N	\N	\N	\N	191837	191837	359016
25291	39727	0	applied	\N	\N	\N	\N	191840	191840	359019
25291	39733	1	applied	\N	\N	\N	\N	191841	191841	359020
25291	39736	2	applied	\N	\N	\N	\N	191842	191842	359021
25291	39737	3	applied	\N	\N	\N	\N	191843	191843	359022
25291	39742	4	applied	\N	\N	\N	\N	191844	191844	359023
25291	39743	5	applied	\N	\N	\N	\N	191845	191845	359024
25291	39749	6	applied	\N	\N	\N	\N	191846	191846	359025
25291	39752	7	applied	\N	\N	\N	\N	191847	191847	359026
25291	39753	8	applied	\N	\N	\N	\N	191848	191848	359027
25291	39762	10	applied	\N	\N	\N	\N	191850	191850	359029
25291	39766	11	applied	\N	\N	\N	\N	191851	191851	359030
25313	39887	2	applied	\N	\N	\N	\N	192036	192036	359214
25313	39888	3	applied	\N	\N	\N	\N	192037	192037	359215
25313	39891	4	applied	\N	\N	\N	\N	192038	192038	359216
25315	39889	0	applied	\N	\N	\N	\N	192044	192044	359222
25315	39890	1	applied	\N	\N	\N	\N	192045	192045	359223
25315	39887	2	applied	\N	\N	\N	\N	192046	192046	359224
25315	39888	3	applied	\N	\N	\N	\N	192047	192047	359225
25315	39891	4	applied	\N	\N	\N	\N	192048	192048	359226
25317	39889	0	applied	\N	\N	\N	\N	192054	192054	359232
25317	39890	1	applied	\N	\N	\N	\N	192055	192055	359233
25317	39887	2	applied	\N	\N	\N	\N	192056	192056	359234
25317	39888	3	applied	\N	\N	\N	\N	192057	192057	359235
25317	39891	4	applied	\N	\N	\N	\N	192058	192058	359236
25319	39892	0	applied	\N	\N	\N	\N	192064	192064	359242
25319	39894	2	applied	\N	\N	\N	\N	192066	192066	359244
25319	39895	3	applied	\N	\N	\N	\N	192067	192067	359245
25321	39892	0	applied	\N	\N	\N	\N	192072	192072	359250
25321	39894	1	applied	\N	\N	\N	\N	192073	192073	359251
25327	39918	0	applied	\N	\N	1000000000	\N	192108	192108	359286
25327	39919	1	applied	\N	\N	\N	\N	192109	192109	359287
25327	39920	2	applied	\N	\N	\N	\N	192110	192110	359288
25327	39921	3	applied	\N	\N	\N	\N	192111	192111	359289
25329	39918	0	applied	\N	\N	1000000000	\N	192116	192116	359294
25329	39919	1	applied	\N	\N	\N	\N	192117	192117	359295
25329	39920	2	applied	\N	\N	\N	\N	192118	192118	359296
25329	39921	3	applied	\N	\N	\N	\N	192119	192119	359297
25334	39925	0	applied	\N	\N	\N	\N	192133	192133	359311
25334	39929	1	applied	\N	\N	\N	\N	192134	192134	359312
25334	39930	2	applied	\N	\N	\N	\N	192135	192135	359313
25334	39926	3	applied	\N	\N	\N	\N	192136	192136	359314
25334	39928	5	applied	\N	\N	\N	\N	192138	192138	359316
25336	39925	0	applied	\N	\N	\N	\N	192147	192147	359325
25336	39929	1	applied	\N	\N	\N	\N	192148	192148	359326
25336	39930	2	applied	\N	\N	\N	\N	192149	192149	359327
25336	39926	3	applied	\N	\N	\N	\N	192150	192150	359328
25336	39927	4	applied	\N	\N	\N	\N	192151	192151	359329
25336	39931	5	applied	\N	\N	\N	\N	192152	192152	359330
25336	39932	6	applied	\N	\N	\N	\N	192153	192153	359331
25336	39928	7	applied	\N	\N	\N	\N	192154	192154	359332
25341	39933	0	applied	\N	\N	\N	\N	192167	192167	359345
25341	39934	1	applied	\N	\N	\N	\N	192168	192168	359346
25347	39947	0	applied	\N	\N	\N	\N	192189	192189	359367
25347	39945	1	applied	\N	\N	\N	\N	192190	192190	359368
25347	39948	2	applied	\N	\N	\N	\N	192191	192191	359369
25347	39946	3	applied	\N	\N	\N	\N	192192	192192	359370
25347	39949	4	applied	\N	\N	\N	\N	192193	192193	359371
25255	39764	2	applied	\N	\N	\N	\N	191556	191556	358735
25255	39765	3	applied	\N	\N	\N	\N	191557	191557	358736
25271	39795	79	applied	\N	\N	\N	\N	191728	191728	358907
25271	39796	80	applied	\N	\N	\N	\N	191729	191729	358908
25271	39800	81	applied	\N	\N	\N	\N	191730	191730	358909
25271	39802	82	applied	\N	\N	\N	\N	191731	191731	358910
25271	39807	83	applied	\N	\N	\N	\N	191732	191732	358911
25271	39809	84	applied	\N	\N	\N	\N	191733	191733	358912
25271	39731	85	applied	\N	\N	\N	\N	191734	191734	358913
25271	39732	86	applied	\N	\N	\N	\N	191735	191735	358914
25271	39734	87	applied	\N	\N	\N	\N	191736	191736	358915
25271	39739	88	applied	\N	\N	\N	\N	191737	191737	358916
25271	39740	89	applied	\N	\N	\N	\N	191738	191738	358917
25271	39747	90	applied	\N	\N	\N	\N	191739	191739	358918
25271	39748	91	applied	\N	\N	\N	\N	191740	191740	358919
25271	39750	92	applied	\N	\N	\N	\N	191741	191741	358920
25271	39759	93	applied	\N	\N	\N	\N	191742	191742	358921
25271	39760	94	applied	\N	\N	\N	\N	191743	191743	358922
25271	39764	96	applied	\N	\N	\N	\N	191745	191745	358924
25271	39768	97	applied	\N	\N	\N	\N	191746	191746	358925
25271	39770	98	applied	\N	\N	\N	\N	191747	191747	358926
25271	39773	99	applied	\N	\N	\N	\N	191748	191748	358927
25271	39776	100	applied	\N	\N	\N	\N	191749	191749	358928
25271	39787	101	applied	\N	\N	\N	\N	191750	191750	358929
25271	39789	102	applied	\N	\N	\N	\N	191751	191751	358930
25271	39790	103	applied	\N	\N	\N	\N	191752	191752	358931
25271	39791	104	applied	\N	\N	\N	\N	191753	191753	358932
25271	39797	105	applied	\N	\N	\N	\N	191754	191754	358933
25271	39801	106	applied	\N	\N	\N	\N	191755	191755	358934
25271	39803	107	applied	\N	\N	\N	\N	191756	191756	358935
25271	39808	108	applied	\N	\N	\N	\N	191757	191757	358936
25271	39810	109	applied	\N	\N	\N	\N	191758	191758	358937
25273	39814	0	applied	\N	\N	\N	\N	191762	191762	358941
25273	39815	1	applied	\N	\N	\N	\N	191763	191763	358942
25280	39827	0	applied	\N	\N	\N	\N	191797	191797	358976
25280	39828	1	applied	\N	\N	\N	\N	191798	191798	358977
25280	39829	2	applied	\N	\N	\N	\N	191799	191799	358978
25280	39830	3	applied	\N	\N	\N	\N	191800	191800	358979
25288	39844	0	applied	\N	\N	\N	\N	191833	191833	359012
25288	39845	1	applied	\N	\N	\N	\N	191834	191834	359013
25288	39846	2	applied	\N	\N	\N	\N	191835	191835	359014
25291	39769	12	applied	\N	\N	\N	\N	191852	191852	359031
25291	39772	13	applied	\N	\N	\N	\N	191853	191853	359032
25291	39775	14	applied	\N	\N	\N	\N	191854	191854	359033
25291	39779	15	applied	\N	\N	\N	\N	191855	191855	359034
25291	39781	16	applied	\N	\N	\N	\N	191856	191856	359035
25291	39782	17	applied	\N	\N	\N	\N	191857	191857	359036
25291	39783	18	applied	\N	\N	\N	\N	191858	191858	359037
25291	39784	19	applied	\N	\N	\N	\N	191859	191859	359038
25291	39785	20	applied	\N	\N	\N	\N	191860	191860	359039
25291	39799	22	applied	\N	\N	\N	\N	191862	191862	359041
25291	39804	23	applied	\N	\N	\N	\N	191863	191863	359042
25291	39805	24	applied	\N	\N	\N	\N	191864	191864	359043
25291	39811	25	applied	\N	\N	\N	\N	191865	191865	359044
25291	39814	26	applied	\N	\N	\N	\N	191866	191866	359045
25291	39817	27	applied	\N	\N	\N	\N	191867	191867	359046
25291	39821	28	applied	\N	\N	\N	\N	191868	191868	359047
25291	39822	29	applied	\N	\N	\N	\N	191869	191869	359048
25291	39827	30	applied	\N	\N	\N	\N	191870	191870	359049
25291	39831	31	applied	\N	\N	\N	\N	191871	191871	359050
25291	39834	32	applied	\N	\N	\N	\N	191872	191872	359051
25291	39835	33	applied	\N	\N	\N	\N	191873	191873	359052
25291	39840	34	applied	\N	\N	\N	\N	191874	191874	359053
25291	39844	35	applied	\N	\N	\N	\N	191875	191875	359054
25291	39720	36	applied	\N	\N	\N	\N	191876	191876	359055
25291	39724	37	applied	\N	\N	\N	\N	191877	191877	359056
25291	39746	39	applied	\N	\N	\N	\N	191879	191879	359058
25291	39755	40	applied	\N	\N	\N	\N	191880	191880	359059
25291	39763	41	applied	\N	\N	\N	\N	191881	191881	359060
25291	39778	42	applied	\N	\N	\N	\N	191882	191882	359061
25291	39786	43	applied	\N	\N	\N	\N	191883	191883	359062
25291	39788	44	applied	\N	\N	\N	\N	191884	191884	359063
25291	39806	45	applied	\N	\N	\N	\N	191885	191885	359064
25291	39820	46	applied	\N	\N	\N	\N	191886	191886	359065
25291	39729	47	applied	\N	\N	\N	\N	191887	191887	359066
25291	39730	48	applied	\N	\N	\N	\N	191888	191888	359067
25291	39830	49	applied	\N	\N	\N	\N	191889	191889	359068
25291	39841	50	applied	\N	\N	\N	\N	191890	191890	359069
25291	39735	51	applied	\N	\N	\N	\N	191891	191891	359070
25291	39738	52	applied	\N	\N	\N	\N	191892	191892	359071
25291	39741	53	applied	\N	\N	\N	\N	191893	191893	359072
25291	39744	54	applied	\N	\N	\N	\N	191894	191894	359073
25291	39751	56	applied	\N	\N	\N	\N	191896	191896	359075
25291	39756	57	applied	\N	\N	\N	\N	191897	191897	359076
25291	39757	58	applied	\N	\N	\N	\N	191898	191898	359077
25291	39758	59	applied	\N	\N	\N	\N	191899	191899	359078
25291	39765	60	applied	\N	\N	\N	\N	191900	191900	359079
25291	39767	61	applied	\N	\N	\N	\N	191901	191901	359080
25292	39849	0	applied	\N	\N	\N	\N	191965	191965	359144
25292	39850	1	applied	\N	\N	\N	\N	191966	191966	359145
25292	39851	2	applied	\N	\N	\N	\N	191967	191967	359146
25292	39852	3	applied	\N	\N	\N	\N	191968	191968	359147
25297	39863	0	applied	\N	\N	\N	\N	191997	191997	359175
25297	39864	1	applied	\N	\N	\N	\N	191998	191998	359176
25299	39863	0	applied	\N	\N	\N	\N	192002	192002	359180
25299	39864	1	applied	\N	\N	\N	\N	192003	192003	359181
25299	39865	2	applied	\N	\N	\N	\N	192004	192004	359182
25302	39869	0	applied	\N	\N	\N	\N	192011	192011	359189
25302	39871	2	applied	\N	\N	\N	\N	192013	192013	359191
25314	39889	0	applied	\N	\N	\N	\N	192039	192039	359217
25314	39890	1	applied	\N	\N	\N	\N	192040	192040	359218
25314	39887	2	applied	\N	\N	\N	\N	192041	192041	359219
25314	39888	3	applied	\N	\N	\N	\N	192042	192042	359220
25314	39891	4	applied	\N	\N	\N	\N	192043	192043	359221
25325	39905	0	applied	\N	\N	\N	\N	192095	192095	359273
25325	39906	1	applied	\N	\N	\N	\N	192096	192096	359274
25325	39907	2	applied	\N	\N	\N	\N	192097	192097	359275
25325	39908	3	applied	\N	\N	\N	\N	192098	192098	359276
25325	39909	4	applied	\N	\N	\N	\N	192099	192099	359277
25325	39910	5	applied	\N	\N	\N	\N	192100	192100	359278
25325	39911	6	applied	\N	\N	\N	\N	192101	192101	359279
25325	39912	7	applied	\N	\N	\N	\N	192102	192102	359280
25271	39792	76	applied	\N	\N	\N	\N	191725	191725	358904
25271	39793	77	applied	\N	\N	\N	\N	191726	191726	358905
25284	39838	4	applied	\N	\N	\N	\N	191818	191818	358997
25284	39839	5	applied	\N	\N	\N	\N	191819	191819	358998
25286	39840	0	applied	\N	\N	\N	\N	191826	191826	359005
25286	39841	1	applied	\N	\N	\N	\N	191827	191827	359006
25286	39842	2	applied	\N	\N	\N	\N	191828	191828	359007
25286	39843	3	applied	\N	\N	\N	\N	191829	191829	359008
25293	39853	0	applied	\N	\N	\N	\N	191969	191969	359148
25293	39854	1	applied	\N	\N	\N	\N	191970	191970	359149
25293	39855	2	applied	\N	\N	\N	\N	191971	191971	359150
25296	39626	0	applied	\N	\N	\N	\N	191979	191979	359158
25296	39702	1	applied	\N	\N	\N	\N	191980	191980	359159
25296	39548	3	applied	\N	\N	\N	\N	191982	191982	359161
25296	39556	4	applied	\N	\N	\N	\N	191983	191983	359162
25296	39661	5	applied	\N	\N	\N	\N	191984	191984	191984
25296	39608	6	applied	\N	\N	\N	\N	191985	191985	359163
25296	39619	7	applied	\N	\N	\N	\N	191986	191986	359164
25296	39620	8	applied	\N	\N	\N	\N	191987	191987	359165
25296	39623	9	applied	\N	\N	\N	\N	191988	191988	359166
25296	39561	10	applied	\N	\N	\N	\N	191989	191989	359167
25296	39636	11	applied	\N	\N	\N	\N	191990	191990	359168
25296	39682	12	applied	\N	\N	\N	\N	191991	191991	359169
25296	39705	13	applied	\N	\N	\N	\N	191992	191992	359170
25296	39683	14	applied	\N	\N	\N	\N	191993	191993	359171
25296	39687	15	applied	\N	\N	\N	\N	191994	191994	359172
25296	39546	16	applied	\N	\N	\N	\N	191995	191995	359173
25296	39710	17	applied	\N	\N	\N	\N	191996	191996	359174
25298	39863	0	applied	\N	\N	\N	\N	191999	191999	359177
25298	39864	1	applied	\N	\N	\N	\N	192000	192000	359178
25298	39865	2	applied	\N	\N	\N	\N	192001	192001	359179
25300	39866	0	applied	\N	\N	\N	\N	192005	192005	359183
25300	39867	1	applied	\N	\N	\N	\N	192006	192006	359184
25305	39879	0	applied	\N	\N	\N	\N	192021	192021	359199
25305	39880	1	applied	\N	\N	\N	\N	192022	192022	359200
25305	39881	2	applied	\N	\N	\N	\N	192023	192023	359201
25316	39889	0	applied	\N	\N	\N	\N	192049	192049	359227
25316	39890	1	applied	\N	\N	\N	\N	192050	192050	359228
25316	39887	2	applied	\N	\N	\N	\N	192051	192051	359229
25316	39888	3	applied	\N	\N	\N	\N	192052	192052	359230
25316	39891	4	applied	\N	\N	\N	\N	192053	192053	359231
25318	39889	0	applied	\N	\N	\N	\N	192059	192059	359237
25318	39890	1	applied	\N	\N	\N	\N	192060	192060	359238
25318	39887	2	applied	\N	\N	\N	\N	192061	192061	359239
25318	39888	3	applied	\N	\N	\N	\N	192062	192062	359240
25318	39891	4	applied	\N	\N	\N	\N	192063	192063	359241
25320	39892	0	applied	\N	\N	\N	\N	192068	192068	359246
25320	39893	1	applied	\N	\N	\N	\N	192069	192069	359247
25320	39894	2	applied	\N	\N	\N	\N	192070	192070	359248
25322	39892	0	applied	\N	\N	\N	\N	192074	192074	359252
25322	39894	1	applied	\N	\N	\N	\N	192075	192075	359253
25323	39896	0	applied	\N	\N	\N	\N	192076	192076	359254
25323	39897	1	applied	\N	\N	\N	\N	192077	192077	359255
25323	39898	2	applied	\N	\N	\N	\N	192078	192078	359256
25323	39899	3	applied	\N	\N	\N	\N	192079	192079	359257
25323	39900	4	applied	\N	\N	\N	\N	192080	192080	359258
25323	39901	5	applied	\N	\N	\N	\N	192081	192081	359259
25323	39902	6	applied	\N	\N	\N	\N	192082	192082	359260
25323	39903	7	applied	\N	\N	\N	\N	192083	192083	359261
25323	39904	8	applied	\N	\N	\N	\N	192084	192084	359262
25325	39913	8	applied	\N	\N	\N	\N	192103	192103	359281
25325	39914	9	applied	\N	\N	\N	\N	192104	192104	359282
25326	39915	0	applied	\N	\N	\N	\N	192105	192105	359283
25326	39916	1	applied	\N	\N	\N	\N	192106	192106	359284
25326	39917	2	applied	\N	\N	\N	\N	192107	192107	359285
25328	39919	1	applied	\N	\N	\N	\N	192113	192113	359291
25330	39922	0	applied	\N	\N	\N	\N	192120	192120	359298
25330	39923	1	applied	\N	\N	\N	\N	192121	192121	359299
25330	39924	2	applied	\N	\N	\N	\N	192122	192122	359300
25332	39922	0	applied	\N	\N	\N	\N	192126	192126	359304
25332	39923	1	applied	\N	\N	\N	\N	192127	192127	359305
25332	39924	2	applied	\N	\N	\N	\N	192128	192128	359306
25339	39933	0	applied	\N	\N	\N	\N	192161	192161	359339
25339	39934	1	applied	\N	\N	\N	\N	192162	192162	359340
25339	39935	2	applied	\N	\N	\N	\N	192163	192163	359341
25345	39944	0	applied	\N	\N	\N	\N	192185	192185	359363
25348	39947	0	applied	\N	\N	\N	\N	192195	192195	359373
25348	39945	1	applied	\N	\N	\N	\N	192196	192196	359374
25348	39948	2	applied	\N	\N	\N	\N	192197	192197	359375
25348	39946	3	applied	\N	\N	\N	\N	192198	192198	359376
25348	39949	4	applied	\N	\N	\N	\N	192199	192199	359377
25348	39950	5	applied	\N	\N	\N	\N	192200	192200	359378
25352	39953	0	applied	\N	\N	\N	\N	192210	192210	359388
25354	39951	1	applied	\N	\N	\N	\N	192216	192216	359394
25354	39956	2	applied	\N	\N	\N	\N	192217	192217	359395
25354	39952	3	applied	\N	\N	\N	\N	192218	192218	359396
25354	39957	4	applied	\N	\N	\N	\N	192219	192219	359397
25354	39954	5	applied	\N	\N	\N	\N	192220	192220	359398
25354	39958	6	applied	\N	\N	\N	\N	192221	192221	359399
25364	39980	0	applied	\N	\N	\N	\N	192261	192261	359439
25364	39981	1	applied	\N	\N	\N	\N	192262	192262	359440
25364	39982	2	applied	\N	\N	\N	\N	192263	192263	359441
25364	39983	3	applied	\N	\N	\N	\N	192264	192264	359442
25364	39984	4	applied	\N	\N	\N	\N	192265	192265	359443
25364	39985	5	applied	\N	\N	\N	\N	192266	192266	359444
25371	39994	0	applied	\N	\N	\N	\N	192288	192288	359466
25371	39995	1	applied	\N	\N	\N	\N	192289	192289	359467
25371	39996	2	applied	\N	\N	\N	\N	192290	192290	359468
25373	39997	0	applied	\N	\N	\N	\N	192294	192294	359472
25373	39999	2	applied	\N	\N	\N	\N	192296	192296	359474
25378	40005	0	applied	\N	\N	\N	\N	192320	192320	359498
25378	40006	1	applied	\N	\N	\N	\N	192321	192321	359499
25378	40007	2	applied	\N	\N	\N	\N	192322	192322	359500
25382	40008	0	applied	\N	\N	\N	\N	192332	192332	359510
25382	40009	1	applied	\N	\N	\N	\N	192333	192333	359511
25382	40010	2	applied	\N	\N	\N	\N	192334	192334	359512
25384	40011	0	applied	\N	\N	\N	\N	192338	192338	359516
25384	40012	1	applied	\N	\N	\N	\N	192339	192339	359517
25384	40013	2	applied	\N	\N	\N	\N	192340	192340	359518
25384	40014	3	applied	\N	\N	\N	\N	192341	192341	359519
25389	40015	0	applied	\N	\N	\N	\N	192351	192351	359529
25389	40016	1	applied	\N	\N	\N	\N	192352	192352	359530
25284	39836	2	applied	\N	\N	\N	\N	191816	191816	358995
25284	39837	3	applied	\N	\N	\N	\N	191817	191817	358996
25291	39792	66	applied	\N	\N	\N	\N	191906	191906	359085
25291	39793	67	applied	\N	\N	\N	\N	191907	191907	359086
25291	39794	68	applied	\N	\N	\N	\N	191908	191908	359087
25291	39795	69	applied	\N	\N	\N	\N	191909	191909	359088
25291	39796	70	applied	\N	\N	\N	\N	191910	191910	359089
25291	39800	71	applied	\N	\N	\N	\N	191911	191911	359090
25291	39802	72	applied	\N	\N	\N	\N	191912	191912	359091
25291	39807	73	applied	\N	\N	\N	\N	191913	191913	359092
25291	39809	74	applied	\N	\N	\N	\N	191914	191914	359093
25291	39812	75	applied	\N	\N	\N	\N	191915	191915	359094
25291	39815	76	applied	\N	\N	\N	\N	191916	191916	359095
25291	39819	77	applied	\N	\N	\N	\N	191917	191917	359096
25291	39823	78	applied	\N	\N	\N	\N	191918	191918	359097
25291	39824	79	applied	\N	\N	\N	\N	191919	191919	359098
25291	39829	80	applied	\N	\N	\N	\N	191920	191920	359099
25291	39833	81	applied	\N	\N	\N	\N	191921	191921	359100
25291	39839	83	applied	\N	\N	\N	\N	191923	191923	359102
25291	39843	84	applied	\N	\N	\N	\N	191924	191924	359103
25291	39846	85	applied	\N	\N	\N	\N	191925	191925	359104
25291	39848	86	applied	\N	\N	\N	\N	191926	191926	359105
25291	39629	87	applied	\N	\N	\N	\N	191927	191927	359106
25291	39632	88	applied	\N	\N	\N	\N	191928	191928	359107
25291	39635	89	applied	\N	\N	\N	\N	191929	191929	359108
25291	39640	90	applied	\N	\N	\N	\N	191930	191930	359109
25291	39643	91	applied	\N	\N	\N	\N	191931	191931	359110
25291	39646	92	applied	\N	\N	\N	\N	191932	191932	359111
25291	39649	93	applied	\N	\N	\N	\N	191933	191933	359112
25291	39656	94	applied	\N	\N	\N	\N	191934	191934	359113
25291	39657	95	applied	\N	\N	\N	\N	191935	191935	359114
25291	39660	96	applied	\N	\N	\N	\N	191936	191936	359115
25291	39664	97	applied	\N	\N	\N	\N	191937	191937	359116
25291	39666	98	applied	\N	\N	\N	\N	191938	191938	359117
25291	39673	100	applied	\N	\N	\N	\N	191940	191940	359119
25291	39677	101	applied	\N	\N	\N	\N	191941	191941	359120
25291	39681	102	applied	\N	\N	\N	\N	191942	191942	359121
25291	39685	103	applied	\N	\N	\N	\N	191943	191943	359122
25291	39689	104	applied	\N	\N	\N	\N	191944	191944	359123
25291	39693	106	applied	\N	\N	\N	\N	191945	191945	359124
25291	39697	107	applied	\N	\N	\N	\N	191946	191946	359125
25291	39699	108	applied	\N	\N	\N	\N	191947	191947	359126
25291	39704	109	applied	\N	\N	\N	\N	191948	191948	359127
25291	39707	110	applied	\N	\N	\N	\N	191949	191949	359128
25291	39713	111	applied	\N	\N	\N	\N	191950	191950	359129
25291	39714	112	applied	\N	\N	\N	\N	191951	191951	359130
25291	39722	113	applied	\N	\N	\N	\N	191952	191952	359131
25291	39725	114	applied	\N	\N	\N	\N	191953	191953	359132
25291	39731	115	applied	\N	\N	\N	\N	191954	191954	359133
25291	39732	116	applied	\N	\N	\N	\N	191955	191955	359134
25291	39739	118	applied	\N	\N	\N	\N	191957	191957	359136
25291	39740	119	applied	\N	\N	\N	\N	191958	191958	359137
25291	39747	120	applied	\N	\N	\N	\N	191959	191959	359138
25291	39748	121	applied	\N	\N	\N	\N	191960	191960	359139
25291	39750	122	applied	\N	\N	\N	\N	191961	191961	359140
25291	39759	123	applied	\N	\N	\N	\N	191962	191962	359141
25291	39760	124	applied	\N	\N	\N	\N	191963	191963	359142
25291	39761	125	applied	\N	\N	\N	\N	191964	191964	359143
25294	39856	0	applied	\N	\N	\N	\N	191972	191972	359151
25294	39857	1	applied	\N	\N	\N	\N	191973	191973	359152
25294	39858	2	applied	\N	\N	\N	\N	191974	191974	359153
25301	39869	0	applied	\N	\N	\N	\N	192008	192008	359186
25301	39870	1	applied	\N	\N	\N	\N	192009	192009	359187
25301	39871	2	applied	\N	\N	\N	\N	192010	192010	359188
25303	39872	0	applied	\N	\N	\N	\N	192014	192014	359192
25328	39920	2	applied	\N	\N	\N	\N	192114	192114	359292
25335	39925	0	applied	\N	\N	\N	\N	192139	192139	359317
25335	39929	1	applied	\N	\N	\N	\N	192140	192140	359318
25335	39930	2	applied	\N	\N	\N	\N	192141	192141	359319
25335	39926	3	applied	\N	\N	\N	\N	192142	192142	359320
25335	39927	4	applied	\N	\N	\N	\N	192143	192143	359321
25335	39931	5	applied	\N	\N	\N	\N	192144	192144	359322
25335	39932	6	applied	\N	\N	\N	\N	192145	192145	359323
25335	39928	7	applied	\N	\N	\N	\N	192146	192146	359324
25337	39933	0	applied	\N	\N	\N	\N	192155	192155	359333
25337	39934	1	applied	\N	\N	\N	\N	192156	192156	359334
25337	39935	2	applied	\N	\N	\N	\N	192157	192157	359335
25340	39933	0	applied	\N	\N	\N	\N	192164	192164	359342
25340	39934	1	applied	\N	\N	\N	\N	192165	192165	359343
25340	39935	2	applied	\N	\N	\N	\N	192166	192166	359344
25342	39933	0	applied	\N	\N	\N	\N	192169	192169	359347
25342	39934	1	applied	\N	\N	\N	\N	192170	192170	359348
25343	39933	0	applied	\N	\N	\N	\N	192172	192172	359350
25343	39934	1	applied	\N	\N	\N	\N	192173	192173	359351
25343	39931	2	applied	\N	\N	\N	\N	192174	192174	359352
25343	39932	3	applied	\N	\N	\N	\N	192175	192175	359353
25343	39935	4	applied	\N	\N	\N	\N	192176	192176	359354
25346	39945	0	applied	\N	\N	\N	\N	192186	192186	359364
25346	39944	1	applied	\N	\N	\N	\N	192187	192187	359365
25346	39946	2	applied	\N	\N	\N	\N	192188	192188	359366
25351	39925	0	applied	\N	\N	\N	\N	192209	192209	359387
25355	39959	0	applied	\N	\N	\N	\N	192222	192222	359400
25355	39960	1	applied	\N	\N	\N	\N	192223	192223	359401
25355	39961	2	applied	\N	\N	\N	\N	192224	192224	359402
25359	39962	0	applied	\N	\N	\N	\N	192233	192233	359411
25359	39963	1	applied	\N	\N	\N	\N	192234	192234	359412
25359	39964	2	applied	\N	\N	\N	\N	192235	192235	359413
25359	39965	3	applied	\N	\N	\N	\N	192236	192236	359414
25360	39967	1	applied	\N	\N	\N	\N	192238	192238	359416
25360	39968	2	applied	\N	\N	\N	\N	192239	192239	359417
25360	39969	3	applied	\N	\N	\N	\N	192240	192240	359418
25360	39970	4	applied	\N	\N	\N	\N	192241	192241	359419
25360	39971	5	applied	\N	\N	\N	\N	192242	192242	359420
25360	39972	6	applied	\N	\N	\N	\N	192243	192243	359421
25360	39973	7	applied	\N	\N	\N	\N	192244	192244	359422
25360	39974	8	applied	\N	\N	\N	\N	192245	192245	359423
25360	39975	9	applied	\N	\N	\N	\N	192246	192246	359424
25362	39976	0	applied	\N	\N	\N	\N	192251	192251	359429
25362	39977	1	applied	\N	\N	\N	\N	192252	192252	359430
25362	39978	2	applied	\N	\N	\N	\N	192253	192253	359431
25362	39979	4	applied	\N	\N	\N	\N	192254	192254	359432
25369	39990	0	applied	\N	\N	\N	\N	192281	192281	359459
25291	39774	63	applied	\N	\N	\N	\N	191903	191903	359082
25291	39777	64	applied	\N	\N	\N	\N	191904	191904	359083
25308	39884	0	applied	\N	\N	\N	\N	192026	192026	359204
25308	39885	1	applied	\N	\N	\N	\N	192027	192027	359205
25308	39886	2	applied	\N	\N	\N	\N	192028	192028	359206
25310	39884	0	applied	\N	\N	\N	\N	192029	192029	359207
25310	39885	1	applied	\N	\N	\N	\N	192030	192030	359208
25310	39886	2	applied	\N	\N	\N	\N	192031	192031	359209
25310	39887	4	applied	\N	\N	\N	\N	192032	192032	359210
25324	39905	0	applied	\N	\N	\N	\N	192085	192085	359263
25324	39906	1	applied	\N	\N	\N	\N	192086	192086	359264
25324	39907	2	applied	\N	\N	\N	\N	192087	192087	359265
25324	39908	3	applied	\N	\N	\N	\N	192088	192088	359266
25324	39909	4	applied	\N	\N	\N	\N	192089	192089	359267
25324	39910	5	applied	\N	\N	\N	\N	192090	192090	359268
25324	39911	6	applied	\N	\N	\N	\N	192091	192091	359269
25324	39912	7	applied	\N	\N	\N	\N	192092	192092	359270
25324	39913	8	applied	\N	\N	\N	\N	192093	192093	359271
25324	39914	9	applied	\N	\N	\N	\N	192094	192094	359272
25331	39922	0	applied	\N	\N	\N	\N	192123	192123	359301
25331	39923	1	applied	\N	\N	\N	\N	192124	192124	359302
25331	39924	2	applied	\N	\N	\N	\N	192125	192125	359303
25333	39925	0	applied	\N	\N	\N	\N	192129	192129	359307
25333	39926	1	applied	\N	\N	\N	\N	192130	192130	359308
25333	39927	2	applied	\N	\N	\N	\N	192131	192131	359309
25338	39933	0	applied	\N	\N	\N	\N	192158	192158	359336
25338	39934	1	applied	\N	\N	\N	\N	192159	192159	359337
25338	39935	2	applied	\N	\N	\N	\N	192160	192160	359338
25344	39936	0	applied	\N	\N	\N	\N	192177	192177	359355
25344	39937	1	applied	\N	\N	\N	\N	192178	192178	359356
25344	39938	2	applied	\N	\N	\N	\N	192179	192179	359357
25344	39939	3	applied	\N	\N	\N	\N	192180	192180	359358
25344	39940	4	applied	\N	\N	\N	\N	192181	192181	359359
25344	39941	5	applied	\N	\N	\N	\N	192182	192182	359360
25344	39942	6	applied	\N	\N	\N	\N	192183	192183	359361
25344	39943	7	applied	\N	\N	\N	\N	192184	192184	359362
25349	39951	0	applied	\N	\N	\N	\N	192201	192201	359379
25349	39952	1	applied	\N	\N	\N	\N	192202	192202	359380
25349	39953	2	applied	\N	\N	\N	\N	192203	192203	359381
25349	39954	3	applied	\N	\N	\N	\N	192204	192204	359382
25350	39951	0	applied	\N	\N	\N	\N	192205	192205	359383
25350	39953	2	applied	\N	\N	\N	\N	192207	192207	359385
25350	39954	3	applied	\N	\N	\N	\N	192208	192208	359386
25353	39951	0	applied	\N	\N	\N	\N	192211	192211	359389
25353	39952	1	applied	\N	\N	\N	\N	192212	192212	359390
25353	39953	2	applied	\N	\N	\N	\N	192213	192213	359391
25353	39954	3	applied	\N	\N	\N	\N	192214	192214	359392
25356	39959	0	applied	\N	\N	\N	\N	192225	192225	359403
25356	39961	1	applied	\N	\N	\N	\N	192226	192226	359404
25357	39959	0	applied	\N	\N	\N	\N	192227	192227	359405
25357	39960	1	applied	\N	\N	\N	\N	192228	192228	359406
25357	39961	2	applied	\N	\N	\N	\N	192229	192229	359407
25358	39959	0	applied	\N	\N	\N	\N	192230	192230	359408
25358	39960	1	applied	\N	\N	\N	\N	192231	192231	359409
25358	39961	2	applied	\N	\N	\N	\N	192232	192232	359410
25361	39976	0	applied	\N	\N	\N	\N	192247	192247	359425
25361	39977	1	applied	\N	\N	\N	\N	192248	192248	359426
25361	39979	4	applied	\N	\N	\N	\N	192250	192250	359428
25363	39980	0	applied	\N	\N	\N	\N	192255	192255	359433
25367	39988	0	applied	\N	\N	\N	\N	192273	192273	359451
25367	39986	1	applied	\N	\N	\N	\N	192274	192274	359452
25367	39989	2	applied	\N	\N	\N	\N	192275	192275	359453
25367	39987	3	applied	\N	\N	\N	\N	192276	192276	359454
25368	39988	0	applied	\N	\N	\N	\N	192277	192277	359455
25368	39986	1	applied	\N	\N	\N	\N	192278	192278	359456
25368	39989	2	applied	\N	\N	\N	\N	192279	192279	359457
25368	39987	3	applied	\N	\N	\N	\N	192280	192280	359458
25375	39918	0	applied	\N	\N	1000000000	\N	192302	192302	359480
25375	39925	1	applied	\N	\N	\N	\N	192303	192303	359481
25375	39936	2	applied	\N	\N	\N	\N	192304	192304	359482
25375	39947	3	applied	\N	\N	\N	\N	192305	192305	359483
25375	39955	4	applied	\N	\N	\N	\N	192306	192306	359484
25375	39962	5	applied	\N	\N	\N	\N	192307	192307	359485
25375	40000	7	applied	\N	\N	\N	\N	192309	192309	359487
25375	39849	8	applied	\N	\N	\N	\N	192310	192310	359488
25375	39853	9	applied	\N	\N	\N	\N	192311	192311	359489
25375	39856	10	applied	\N	\N	\N	\N	192312	192312	359490
25375	39859	11	applied	\N	\N	\N	\N	192313	192313	359491
25375	39863	12	applied	\N	\N	\N	\N	192314	192314	359492
25380	40005	0	applied	\N	\N	\N	\N	192326	192326	359504
25380	40006	1	applied	\N	\N	\N	\N	192327	192327	359505
25380	40007	2	applied	\N	\N	\N	\N	192328	192328	359506
25387	40015	0	applied	\N	\N	\N	\N	192345	192345	359523
25387	40016	1	applied	\N	\N	\N	\N	192346	192346	359524
25387	40017	2	applied	\N	\N	\N	\N	192347	192347	359525
25392	40015	0	applied	\N	\N	\N	\N	192360	192360	359538
25392	40016	1	applied	\N	\N	\N	\N	192361	192361	359539
25392	40017	2	applied	\N	\N	\N	\N	192362	192362	359540
25399	40028	0	applied	\N	\N	\N	\N	192390	192390	359568
25399	40030	2	applied	\N	\N	\N	\N	192392	192392	359570
25399	40031	3	applied	\N	\N	1000000000	\N	192393	192393	359571
25399	40032	4	applied	\N	\N	1000000000	\N	192394	192394	359572
25399	40033	5	applied	\N	\N	\N	\N	192395	192395	359573
25401	40028	0	applied	\N	\N	\N	\N	192404	192404	359582
25401	40029	1	applied	\N	\N	\N	\N	192405	192405	359583
25401	40034	2	applied	\N	\N	\N	\N	192406	192406	359584
25401	40030	3	applied	\N	\N	\N	\N	192407	192407	359585
25401	40031	4	applied	\N	\N	1000000000	\N	192408	192408	359586
25401	40032	5	applied	\N	\N	1000000000	\N	192409	192409	359587
25401	40033	6	applied	\N	\N	\N	\N	192410	192410	359588
25401	40035	7	applied	\N	\N	\N	\N	192411	192411	359589
25406	40041	0	applied	\N	\N	\N	\N	192444	192444	359622
25406	40042	1	applied	\N	\N	\N	\N	192445	192445	359623
25406	40043	2	applied	\N	\N	\N	\N	192446	192446	359624
25406	40044	3	applied	\N	\N	\N	\N	192447	192447	359625
25406	40046	5	applied	\N	\N	\N	\N	192449	192449	359627
25406	40047	6	applied	\N	\N	\N	\N	192450	192450	359628
25406	40048	7	applied	\N	\N	\N	\N	192451	192451	359629
25406	40049	8	applied	\N	\N	\N	\N	192452	192452	359630
25406	40050	9	applied	\N	\N	\N	\N	192453	192453	359631
25406	40051	10	applied	\N	\N	\N	\N	192454	192454	359632
25303	39874	2	applied	\N	\N	\N	\N	192016	192016	359194
25303	39875	3	applied	\N	\N	\N	\N	192017	192017	359195
25363	39984	4	applied	\N	\N	\N	\N	192259	192259	359437
25363	39985	5	applied	\N	\N	\N	\N	192260	192260	359438
25365	39986	0	applied	\N	\N	\N	\N	192267	192267	359445
25365	39987	1	applied	\N	\N	\N	\N	192268	192268	359446
25366	39988	0	applied	\N	\N	\N	\N	192269	192269	359447
25366	39986	1	applied	\N	\N	\N	\N	192270	192270	359448
25366	39989	2	applied	\N	\N	\N	\N	192271	192271	359449
25366	39987	3	applied	\N	\N	\N	\N	192272	192272	359450
25370	39994	0	applied	\N	\N	\N	\N	192285	192285	359463
25370	39995	1	applied	\N	\N	\N	\N	192286	192286	359464
25370	39996	2	applied	\N	\N	\N	\N	192287	192287	359465
25372	39998	1	applied	\N	\N	\N	\N	192292	192292	359470
25372	39999	2	applied	\N	\N	\N	\N	192293	192293	359471
25377	40005	0	applied	\N	\N	\N	\N	192318	192318	359496
25377	40007	1	applied	\N	\N	\N	\N	192319	192319	359497
25379	40005	0	applied	\N	\N	\N	\N	192323	192323	359501
25379	40006	1	applied	\N	\N	\N	\N	192324	192324	359502
25379	40007	2	applied	\N	\N	\N	\N	192325	192325	359503
25381	40008	0	applied	\N	\N	\N	\N	192329	192329	359507
25381	40009	1	applied	\N	\N	\N	\N	192330	192330	359508
25381	40010	2	applied	\N	\N	\N	\N	192331	192331	359509
25383	40008	0	applied	\N	\N	\N	\N	192335	192335	359513
25383	40009	1	applied	\N	\N	\N	\N	192336	192336	359514
25383	40010	2	applied	\N	\N	\N	\N	192337	192337	359515
25386	40015	0	applied	\N	\N	\N	\N	192342	192342	359520
25386	40016	1	applied	\N	\N	\N	\N	192343	192343	359521
25386	40017	2	applied	\N	\N	\N	\N	192344	192344	359522
25388	40016	1	applied	\N	\N	\N	\N	192349	192349	359527
25388	40017	2	applied	\N	\N	\N	\N	192350	192350	359528
25394	40021	0	applied	\N	\N	\N	\N	192366	192366	359544
25394	40022	1	applied	\N	\N	\N	\N	192367	192367	359545
25394	40018	2	applied	\N	\N	\N	\N	192368	192368	359546
25394	40023	3	applied	\N	\N	\N	\N	192369	192369	359547
25394	40024	4	applied	\N	\N	\N	\N	192370	192370	359548
25394	40019	5	applied	\N	\N	\N	\N	192371	192371	359549
25394	40020	6	applied	\N	\N	\N	\N	192372	192372	359550
25396	40021	0	applied	\N	\N	\N	\N	192380	192380	359558
25396	40022	1	applied	\N	\N	\N	\N	192381	192381	359559
25396	40025	2	applied	\N	\N	\N	\N	192382	192382	359560
25396	40023	3	applied	\N	\N	\N	\N	192383	192383	359561
25396	40024	4	applied	\N	\N	\N	\N	192384	192384	359562
25396	40026	5	applied	\N	\N	\N	\N	192385	192385	359563
25396	40027	6	applied	\N	\N	\N	\N	192386	192386	359564
25398	40026	1	applied	\N	\N	\N	\N	192388	192388	359566
25398	40027	2	applied	\N	\N	\N	\N	192389	192389	359567
25403	40036	0	applied	\N	\N	\N	\N	192419	192419	359597
25403	40037	1	applied	\N	\N	\N	\N	192420	192420	359598
25403	40034	2	applied	\N	\N	\N	\N	192421	192421	359599
25403	40038	3	applied	\N	\N	\N	\N	192422	192422	359600
25403	40039	4	applied	\N	\N	\N	\N	192423	192423	359601
25403	40035	5	applied	\N	\N	\N	\N	192424	192424	359602
25403	40040	6	applied	\N	\N	\N	\N	192425	192425	359603
25405	39918	0	applied	\N	\N	1000000000	\N	192433	192433	359611
25405	39925	1	applied	\N	\N	\N	\N	192434	192434	359612
25405	39936	2	applied	\N	\N	\N	\N	192435	192435	359613
25405	39947	3	applied	\N	\N	\N	\N	192436	192436	359614
25405	39955	4	applied	\N	\N	\N	\N	192437	192437	359615
25405	39962	5	applied	\N	\N	\N	\N	192438	192438	359616
25405	39990	6	applied	\N	\N	\N	\N	192439	192439	359617
25405	40036	8	applied	\N	\N	\N	\N	192441	192441	359619
25405	40031	9	applied	\N	\N	1000000000	\N	192442	192442	359620
25405	40032	10	applied	\N	\N	1000000000	\N	192443	192443	359621
25409	40058	0	applied	\N	\N	\N	\N	192461	192461	359639
25409	40059	1	applied	\N	\N	\N	\N	192462	192462	359640
25409	40060	2	applied	\N	\N	\N	\N	192463	192463	359641
25409	40061	3	applied	\N	\N	\N	\N	192464	192464	359642
25412	40058	0	applied	\N	\N	\N	\N	192473	192473	359651
25412	40059	1	applied	\N	\N	\N	\N	192474	192474	359652
25412	40060	2	applied	\N	\N	\N	\N	192475	192475	359653
25412	40061	3	applied	\N	\N	\N	\N	192476	192476	359654
25413	40062	0	applied	\N	\N	\N	\N	192477	192477	359655
25422	40071	0	applied	\N	\N	\N	\N	192508	192508	359686
25422	40072	1	applied	\N	\N	\N	\N	192509	192509	359687
25422	40073	2	applied	\N	\N	\N	\N	192510	192510	359688
25422	40074	3	applied	\N	\N	\N	\N	192511	192511	359689
25424	40077	1	applied	\N	\N	\N	\N	192515	192515	359693
25424	40076	2	applied	\N	\N	\N	\N	192516	192516	359694
25427	40087	0	applied	\N	\N	\N	\N	192530	192530	359708
25429	40081	0	applied	\N	\N	\N	\N	192535	192535	359713
25429	40082	1	applied	\N	\N	\N	\N	192536	192536	359714
25429	40083	2	applied	\N	\N	\N	\N	192537	192537	359715
25429	40084	3	applied	\N	\N	\N	\N	192538	192538	359716
25429	40085	4	applied	\N	\N	\N	\N	192539	192539	359717
25429	40086	5	applied	\N	\N	\N	\N	192540	192540	359718
25429	40087	6	applied	\N	\N	\N	\N	192541	192541	359719
25431	40078	0	applied	\N	\N	\N	\N	192549	192549	359727
25431	40081	1	applied	\N	\N	\N	\N	192550	192550	359728
25431	40082	2	applied	\N	\N	\N	\N	192551	192551	359729
25431	40080	3	applied	\N	\N	\N	\N	192552	192552	359730
25431	40085	4	applied	\N	\N	\N	\N	192553	192553	359731
25431	40086	5	applied	\N	\N	\N	\N	192554	192554	359732
25438	40098	0	applied	\N	\N	\N	\N	192572	192572	359750
25438	40099	1	applied	\N	\N	\N	\N	192573	192573	359751
25438	40100	2	applied	\N	\N	\N	\N	192574	192574	359752
25440	40098	0	applied	\N	\N	\N	\N	192578	192578	359756
25440	40099	1	applied	\N	\N	\N	\N	192579	192579	359757
25440	40100	2	applied	\N	\N	\N	\N	192580	192580	359758
25444	40101	0	applied	\N	\N	\N	\N	192590	192590	359768
25444	40102	1	applied	\N	\N	\N	\N	192591	192591	359769
25447	40104	0	applied	\N	\N	\N	\N	192600	192600	359778
25447	40105	1	applied	\N	\N	\N	\N	192601	192601	359779
25447	40106	2	applied	\N	\N	\N	\N	192602	192602	359780
25447	40103	3	applied	\N	\N	\N	\N	192603	192603	359781
25447	40107	4	applied	\N	\N	\N	\N	192604	192604	359782
25451	40115	0	applied	\N	\N	\N	\N	192620	192620	359798
25451	40116	1	applied	\N	\N	\N	\N	192621	192621	359799
25451	40118	2	applied	\N	\N	\N	\N	192622	192622	359800
25454	40119	0	applied	\N	\N	\N	\N	192630	192630	359808
25454	40120	1	applied	\N	\N	\N	\N	192631	192631	359809
25363	39982	2	applied	\N	\N	\N	\N	192257	192257	359435
25363	39983	3	applied	\N	\N	\N	\N	192258	192258	359436
25374	40000	0	applied	\N	\N	\N	\N	192297	192297	359475
25374	40001	1	applied	\N	\N	\N	\N	192298	192298	359476
25374	40002	2	applied	\N	\N	\N	\N	192299	192299	359477
25374	40003	3	applied	\N	\N	\N	\N	192300	192300	359478
25374	40004	4	applied	\N	\N	\N	\N	192301	192301	359479
25376	40005	0	applied	\N	\N	\N	\N	192315	192315	359493
25376	40006	1	applied	\N	\N	\N	\N	192316	192316	359494
25376	40007	2	applied	\N	\N	\N	\N	192317	192317	359495
25390	40015	0	applied	\N	\N	\N	\N	192354	192354	359532
25390	40017	2	applied	\N	\N	\N	\N	192356	192356	359534
25391	40015	0	applied	\N	\N	\N	\N	192357	192357	359535
25391	40016	1	applied	\N	\N	\N	\N	192358	192358	359536
25391	40017	2	applied	\N	\N	\N	\N	192359	192359	359537
25393	40018	0	applied	\N	\N	\N	\N	192363	192363	359541
25393	40019	1	applied	\N	\N	\N	\N	192364	192364	359542
25393	40020	2	applied	\N	\N	\N	\N	192365	192365	359543
25400	40028	0	applied	\N	\N	\N	\N	192396	192396	359574
25400	40029	1	applied	\N	\N	\N	\N	192397	192397	359575
25400	40034	2	applied	\N	\N	\N	\N	192398	192398	359576
25400	40030	3	applied	\N	\N	\N	\N	192399	192399	359577
25400	40031	4	applied	\N	\N	1000000000	\N	192400	192400	359578
25400	40032	5	applied	\N	\N	1000000000	\N	192401	192401	359579
25400	40033	6	applied	\N	\N	\N	\N	192402	192402	359580
25400	40035	7	applied	\N	\N	\N	\N	192403	192403	359581
25408	40055	0	applied	\N	\N	\N	\N	192458	192458	359636
25408	40057	2	applied	\N	\N	\N	\N	192460	192460	359638
25411	40058	0	applied	\N	\N	\N	\N	192469	192469	359647
25411	40059	1	applied	\N	\N	\N	\N	192470	192470	359648
25411	40060	2	applied	\N	\N	\N	\N	192471	192471	359649
25411	40061	3	applied	\N	\N	\N	\N	192472	192472	359650
25415	40062	0	applied	\N	\N	\N	\N	192481	192481	359659
25417	40063	0	applied	\N	\N	\N	\N	192485	192485	359663
25417	40065	1	applied	\N	\N	\N	\N	192486	192486	359664
25417	40066	2	applied	\N	\N	\N	\N	192487	192487	359665
25417	40064	4	applied	\N	\N	\N	\N	192488	192488	359666
25417	40067	5	applied	\N	\N	\N	\N	192489	192489	359667
25419	40068	0	applied	\N	\N	\N	\N	192495	192495	359673
25419	40069	1	applied	\N	\N	\N	\N	192496	192496	359674
25419	40064	2	applied	\N	\N	\N	\N	192497	192497	359675
25419	40067	3	applied	\N	\N	\N	\N	192498	192498	359676
25419	40070	4	applied	\N	\N	\N	\N	192499	192499	359677
25421	40069	1	applied	\N	\N	\N	\N	192506	192506	359684
25421	40064	2	applied	\N	\N	\N	\N	192507	192507	359685
25423	40075	0	applied	\N	\N	\N	\N	192512	192512	359690
25423	40076	1	applied	\N	\N	\N	\N	192513	192513	359691
25426	40078	0	applied	\N	\N	\N	\N	192520	192520	359698
25426	40081	1	applied	\N	\N	\N	\N	192521	192521	359699
25426	40082	2	applied	\N	\N	\N	\N	192522	192522	359700
25426	40079	3	applied	\N	\N	\N	\N	192523	192523	359701
25426	40080	4	applied	\N	\N	\N	\N	192524	192524	359702
25426	40083	5	applied	\N	\N	\N	\N	192525	192525	359703
25426	40084	6	applied	\N	\N	\N	\N	192526	192526	359704
25426	40085	7	applied	\N	\N	\N	\N	192527	192527	359705
25426	40086	8	applied	\N	\N	\N	\N	192528	192528	359706
25426	40087	9	applied	\N	\N	\N	\N	192529	192529	359707
25428	40036	0	applied	\N	\N	\N	\N	192531	192531	359709
25428	40041	1	applied	\N	\N	\N	\N	192532	192532	359710
25428	40032	3	applied	\N	\N	1000000000	\N	192534	192534	359712
25430	40081	0	applied	\N	\N	\N	\N	192542	192542	359720
25430	40082	1	applied	\N	\N	\N	\N	192543	192543	359721
25430	40083	2	applied	\N	\N	\N	\N	192544	192544	359722
25430	40084	3	applied	\N	\N	\N	\N	192545	192545	359723
25430	40085	4	applied	\N	\N	\N	\N	192546	192546	359724
25430	40086	5	applied	\N	\N	\N	\N	192547	192547	359725
25430	40087	6	applied	\N	\N	\N	\N	192548	192548	359726
25432	40088	0	applied	\N	\N	\N	\N	192556	192556	359734
25432	40089	1	applied	\N	\N	\N	\N	192557	192557	359735
25432	40090	2	applied	\N	\N	\N	\N	192558	192558	359736
25433	40091	0	applied	\N	\N	\N	\N	192559	192559	359737
25433	40092	1	applied	\N	\N	\N	\N	192560	192560	359738
25433	40093	2	applied	\N	\N	\N	\N	192561	192561	359739
25433	40094	3	applied	\N	\N	\N	\N	192562	192562	359740
25435	40095	0	applied	\N	\N	\N	\N	192566	192566	359744
25435	40096	1	applied	\N	\N	\N	\N	192567	192567	359745
25435	40097	2	applied	\N	\N	\N	\N	192568	192568	359746
25436	40096	1	applied	\N	\N	\N	\N	192570	192570	359748
25436	40097	2	applied	\N	\N	\N	\N	192571	192571	359749
25439	40098	0	applied	\N	\N	\N	\N	192575	192575	359753
25439	40099	1	applied	\N	\N	\N	\N	192576	192576	359754
25439	40100	2	applied	\N	\N	\N	\N	192577	192577	359755
25441	40098	0	applied	\N	\N	\N	\N	192581	192581	359759
25441	40099	1	applied	\N	\N	\N	\N	192582	192582	359760
25441	40100	2	applied	\N	\N	\N	\N	192583	192583	359761
25442	40098	0	applied	\N	\N	\N	\N	192584	192584	359762
25442	40099	1	applied	\N	\N	\N	\N	192585	192585	359763
25442	40100	2	applied	\N	\N	\N	\N	192586	192586	359764
25443	40101	0	applied	\N	\N	\N	\N	192587	192587	359765
25443	40102	1	applied	\N	\N	\N	\N	192588	192588	359766
25443	40103	2	applied	\N	\N	\N	\N	192589	192589	359767
25446	40104	0	applied	\N	\N	\N	\N	192595	192595	359773
25446	40105	1	applied	\N	\N	\N	\N	192596	192596	359774
25446	40103	3	applied	\N	\N	\N	\N	192598	192598	359776
25446	40107	4	applied	\N	\N	\N	\N	192599	192599	359777
25448	40104	0	applied	\N	\N	\N	\N	192605	192605	359783
25448	40105	1	applied	\N	\N	\N	\N	192606	192606	359784
25448	40106	2	applied	\N	\N	\N	\N	192607	192607	359785
25448	40103	3	applied	\N	\N	\N	\N	192608	192608	359786
25448	40107	4	applied	\N	\N	\N	\N	192609	192609	359787
25450	40115	0	applied	\N	\N	\N	\N	192617	192617	359795
25450	40116	1	applied	\N	\N	\N	\N	192618	192618	359796
25450	40117	2	applied	\N	\N	\N	\N	192619	192619	359797
25453	40119	0	applied	\N	\N	\N	\N	192627	192627	359805
25453	40120	1	applied	\N	\N	\N	\N	192628	192628	359806
25453	40121	2	applied	\N	\N	\N	\N	192629	192629	359807
25455	40119	0	applied	\N	\N	\N	\N	192633	192633	359811
25455	40121	1	applied	\N	\N	\N	\N	192634	192634	359812
25457	40122	0	applied	\N	\N	\N	\N	192638	192638	359816
25461	40126	0	applied	\N	\N	\N	\N	192646	192646	359824
25461	40127	1	applied	\N	\N	\N	\N	192647	192647	359825
25369	39992	2	applied	\N	\N	\N	\N	192283	192283	359461
25369	39993	3	applied	\N	\N	\N	\N	192284	192284	359462
25395	40023	3	applied	\N	\N	\N	\N	192376	192376	359554
25395	40024	4	applied	\N	\N	\N	\N	192377	192377	359555
25395	40026	5	applied	\N	\N	\N	\N	192378	192378	359556
25395	40027	6	applied	\N	\N	\N	\N	192379	192379	359557
25402	40036	0	applied	\N	\N	\N	\N	192412	192412	359590
25402	40037	1	applied	\N	\N	\N	\N	192413	192413	359591
25402	40034	2	applied	\N	\N	\N	\N	192414	192414	359592
25402	40038	3	applied	\N	\N	\N	\N	192415	192415	359593
25402	40039	4	applied	\N	\N	\N	\N	192416	192416	359594
25402	40035	5	applied	\N	\N	\N	\N	192417	192417	359595
25402	40040	6	applied	\N	\N	\N	\N	192418	192418	359596
25404	40036	0	applied	\N	\N	\N	\N	192426	192426	359604
25404	40037	1	applied	\N	\N	\N	\N	192427	192427	359605
25404	40034	2	applied	\N	\N	\N	\N	192428	192428	359606
25404	40038	3	applied	\N	\N	\N	\N	192429	192429	359607
25404	40039	4	applied	\N	\N	\N	\N	192430	192430	359608
25404	40040	6	applied	\N	\N	\N	\N	192432	192432	359610
25407	40052	0	applied	\N	\N	\N	\N	192455	192455	359633
25407	40053	1	applied	\N	\N	\N	\N	192456	192456	359634
25407	40054	2	applied	\N	\N	\N	\N	192457	192457	359635
25410	40058	0	applied	\N	\N	\N	\N	192465	192465	359643
25410	40059	1	applied	\N	\N	\N	\N	192466	192466	359644
25410	40060	2	applied	\N	\N	\N	\N	192467	192467	359645
25410	40061	3	applied	\N	\N	\N	\N	192468	192468	359646
25414	40063	0	applied	\N	\N	\N	\N	192478	192478	359656
25414	40062	1	applied	\N	\N	\N	\N	192479	192479	359657
25414	40064	2	applied	\N	\N	\N	\N	192480	192480	359658
25416	40063	0	applied	\N	\N	\N	\N	192482	192482	359660
25416	40065	1	applied	\N	\N	\N	\N	192483	192483	359661
25416	40066	2	applied	\N	\N	\N	\N	192484	192484	359662
25418	40068	0	applied	\N	\N	\N	\N	192490	192490	359668
25418	40069	1	applied	\N	\N	\N	\N	192491	192491	359669
25418	40067	3	applied	\N	\N	\N	\N	192493	192493	359671
25418	40070	4	applied	\N	\N	\N	\N	192494	192494	359672
25420	40068	0	applied	\N	\N	\N	\N	192500	192500	359678
25420	40069	1	applied	\N	\N	\N	\N	192501	192501	359679
25420	40064	2	applied	\N	\N	\N	\N	192502	192502	359680
25420	40067	3	applied	\N	\N	\N	\N	192503	192503	359681
25420	40070	4	applied	\N	\N	\N	\N	192504	192504	359682
25425	40078	0	applied	\N	\N	\N	\N	192517	192517	359695
25425	40079	1	applied	\N	\N	\N	\N	192518	192518	359696
25425	40080	2	applied	\N	\N	\N	\N	192519	192519	359697
25434	40095	0	applied	\N	\N	\N	\N	192563	192563	359741
25434	40096	1	applied	\N	\N	\N	\N	192564	192564	359742
25434	40097	2	applied	\N	\N	\N	\N	192565	192565	359743
25445	40101	0	applied	\N	\N	\N	\N	192592	192592	359770
25445	40102	1	applied	\N	\N	\N	\N	192593	192593	359771
25445	40103	2	applied	\N	\N	\N	\N	192594	192594	359772
25449	40109	1	applied	\N	\N	\N	\N	192611	192611	359789
25449	40110	2	applied	\N	\N	\N	\N	192612	192612	359790
25449	40111	3	applied	\N	\N	\N	\N	192613	192613	359791
25449	40112	4	applied	\N	\N	\N	\N	192614	192614	359792
25449	40113	5	applied	\N	\N	\N	\N	192615	192615	359793
25449	40114	6	applied	\N	\N	\N	\N	192616	192616	359794
25452	40119	0	applied	\N	\N	\N	\N	192624	192624	359802
25452	40120	1	applied	\N	\N	\N	\N	192625	192625	359803
25452	40121	2	applied	\N	\N	\N	\N	192626	192626	359804
25456	40119	0	applied	\N	\N	\N	\N	192635	192635	359813
25456	40120	1	applied	\N	\N	\N	\N	192636	192636	359814
25456	40121	2	applied	\N	\N	\N	\N	192637	192637	359815
25461	40128	2	applied	\N	\N	\N	\N	192648	192648	359826
25461	40129	3	applied	\N	\N	\N	\N	192649	192649	359827
25463	40130	0	applied	\N	\N	\N	\N	192654	192654	359832
25463	40131	1	applied	\N	\N	\N	\N	192655	192655	359833
25466	40139	0	applied	\N	\N	\N	\N	192666	192666	359844
25466	40140	1	applied	\N	\N	\N	\N	192667	192667	359845
25466	40141	2	applied	\N	\N	\N	\N	192668	192668	359846
25466	40142	3	applied	\N	\N	\N	\N	192669	192669	359847
25475	40149	0	applied	\N	\N	\N	\N	192695	192695	359873
25475	40150	2	applied	\N	\N	\N	\N	192696	192696	359874
25475	40151	3	applied	\N	\N	\N	\N	192697	192697	359875
25475	40152	4	applied	\N	\N	\N	\N	192698	192698	359876
25479	40156	0	applied	\N	\N	\N	\N	192710	192710	359888
25479	40157	1	applied	\N	\N	\N	\N	192711	192711	359889
25479	40158	2	applied	\N	\N	\N	\N	192712	192712	359890
25481	40159	0	applied	\N	\N	\N	\N	192716	192716	359894
25481	40160	1	applied	\N	\N	\N	\N	192717	192717	359895
25481	40161	2	applied	\N	\N	\N	\N	192718	192718	359896
25482	40036	0	applied	\N	\N	\N	\N	192719	192719	359897
25486	40165	0	applied	\N	\N	\N	\N	192729	192729	359907
25486	40167	2	applied	\N	\N	\N	\N	192731	192731	359909
25488	40168	0	applied	\N	\N	\N	\N	192735	192735	359913
25488	40169	1	applied	\N	\N	\N	\N	192736	192736	359914
25488	40170	2	applied	\N	\N	\N	\N	192737	192737	359915
25493	40174	0	applied	\N	\N	\N	\N	192748	192748	359926
25493	40175	1	applied	\N	\N	\N	\N	192749	192749	359927
25493	40176	2	applied	\N	\N	\N	\N	192750	192750	359928
25493	40177	3	applied	\N	\N	\N	\N	192751	192751	359929
25493	40178	4	applied	\N	\N	\N	\N	192752	192752	359930
25493	40179	5	applied	\N	\N	\N	\N	192753	192753	359931
25495	40180	0	applied	\N	\N	\N	\N	192760	192760	359938
25495	40181	1	applied	\N	\N	\N	\N	192761	192761	359939
25495	40182	2	applied	\N	\N	\N	\N	192762	192762	359940
25498	40180	0	applied	\N	\N	\N	\N	192769	192769	359947
25498	40181	1	applied	\N	\N	\N	\N	192770	192770	359948
25498	40182	2	applied	\N	\N	\N	\N	192771	192771	359949
25502	40190	1	applied	\N	\N	\N	\N	192782	192782	359960
25502	40191	2	applied	\N	\N	\N	\N	192783	192783	359961
25504	40192	0	applied	\N	\N	\N	\N	192787	192787	359965
25504	40193	1	applied	\N	\N	\N	\N	192788	192788	359966
25504	40194	2	applied	\N	\N	\N	\N	192789	192789	359967
25509	40198	0	applied	\N	\N	\N	\N	192802	192802	359980
25509	40199	1	applied	\N	\N	\N	\N	192803	192803	359981
25509	40200	2	applied	\N	\N	\N	\N	192804	192804	359982
25511	40201	0	applied	\N	\N	\N	\N	192808	192808	359986
25511	40202	1	applied	\N	\N	\N	\N	192809	192809	359987
25511	40203	2	applied	\N	\N	\N	\N	192810	192810	359988
25514	40201	0	applied	\N	\N	\N	\N	192817	192817	359995
25514	40202	1	applied	\N	\N	\N	\N	192818	192818	359996
25514	40203	2	applied	\N	\N	\N	\N	192819	192819	359997
25395	40021	0	applied	\N	\N	\N	\N	192373	192373	359551
25395	40022	1	applied	\N	\N	\N	\N	192374	192374	359552
25458	40112	2	applied	\N	\N	\N	\N	192644	192644	359822
25458	40122	3	applied	\N	\N	\N	\N	192645	192645	359823
25462	40126	0	applied	\N	\N	\N	\N	192650	192650	359828
25462	40127	1	applied	\N	\N	\N	\N	192651	192651	359829
25462	40128	2	applied	\N	\N	\N	\N	192652	192652	359830
25462	40129	3	applied	\N	\N	\N	\N	192653	192653	359831
25463	40133	3	applied	\N	\N	\N	\N	192657	192657	359835
25463	40134	4	applied	\N	\N	\N	\N	192658	192658	359836
25463	40135	5	applied	\N	\N	\N	\N	192659	192659	359837
25465	40136	0	applied	\N	\N	\N	\N	192663	192663	359841
25465	40137	1	applied	\N	\N	\N	\N	192664	192664	359842
25465	40138	2	applied	\N	\N	\N	\N	192665	192665	359843
25467	40143	0	applied	\N	\N	\N	\N	192670	192670	359848
25467	40145	2	applied	\N	\N	\N	\N	192672	192672	359850
25468	40143	0	applied	\N	\N	\N	\N	192673	192673	359851
25468	40144	1	applied	\N	\N	\N	\N	192674	192674	359852
25468	40145	2	applied	\N	\N	\N	\N	192675	192675	359853
25470	40143	0	applied	\N	\N	\N	\N	192679	192679	359857
25470	40144	1	applied	\N	\N	\N	\N	192680	192680	359858
25470	40145	2	applied	\N	\N	\N	\N	192681	192681	359859
25471	40144	0	applied	\N	\N	\N	\N	192682	192682	359860
25471	40145	1	applied	\N	\N	\N	\N	192683	192683	359861
25472	40146	0	applied	\N	\N	\N	\N	192684	192684	359862
25472	40147	1	applied	\N	\N	\N	\N	192685	192685	359863
25472	40148	2	applied	\N	\N	\N	\N	192686	192686	359864
25474	40149	0	applied	\N	\N	\N	\N	192691	192691	359869
25474	40150	2	applied	\N	\N	\N	\N	192692	192692	359870
25474	40151	3	applied	\N	\N	\N	\N	192693	192693	359871
25474	40152	4	applied	\N	\N	\N	\N	192694	192694	359872
25476	40150	2	applied	\N	\N	\N	\N	192700	192700	359878
25476	40151	3	applied	\N	\N	\N	\N	192701	192701	359879
25476	40152	4	applied	\N	\N	\N	\N	192702	192702	359880
25478	40153	0	applied	\N	\N	\N	\N	192707	192707	359885
25478	40154	1	applied	\N	\N	\N	\N	192708	192708	359886
25478	40155	2	applied	\N	\N	\N	\N	192709	192709	359887
25480	40156	0	applied	\N	\N	\N	\N	192713	192713	359891
25480	40157	1	applied	\N	\N	\N	\N	192714	192714	359892
25480	40158	2	applied	\N	\N	\N	\N	192715	192715	359893
25483	40159	0	applied	\N	\N	\N	\N	192720	192720	359898
25483	40160	1	applied	\N	\N	\N	\N	192721	192721	359899
25483	40161	2	applied	\N	\N	\N	\N	192722	192722	359900
25485	40165	0	applied	\N	\N	\N	\N	192726	192726	359904
25485	40166	1	applied	\N	\N	\N	\N	192727	192727	359905
25485	40167	2	applied	\N	\N	\N	\N	192728	192728	359906
25487	40168	0	applied	\N	\N	\N	\N	192732	192732	359910
25487	40170	2	applied	\N	\N	\N	\N	192734	192734	359912
25489	40170	0	applied	\N	\N	\N	\N	192738	192738	359916
25490	40171	0	applied	\N	\N	\N	\N	192739	192739	359917
25490	40172	1	applied	\N	\N	\N	\N	192740	192740	359918
25490	40173	2	applied	\N	\N	\N	\N	192741	192741	359919
25492	40174	0	applied	\N	\N	\N	\N	192742	192742	359920
25492	40175	1	applied	\N	\N	\N	\N	192743	192743	359921
25492	40176	2	applied	\N	\N	\N	\N	192744	192744	359922
25492	40177	3	applied	\N	\N	\N	\N	192745	192745	359923
25492	40178	4	applied	\N	\N	\N	\N	192746	192746	359924
25492	40179	5	applied	\N	\N	\N	\N	192747	192747	359925
25494	40174	0	applied	\N	\N	\N	\N	192754	192754	359932
25494	40175	1	applied	\N	\N	\N	\N	192755	192755	359933
25494	40176	2	applied	\N	\N	\N	\N	192756	192756	359934
25494	40177	3	applied	\N	\N	\N	\N	192757	192757	359935
25494	40178	4	applied	\N	\N	\N	\N	192758	192758	359936
25496	40180	0	applied	\N	\N	\N	\N	192763	192763	359941
25496	40181	1	applied	\N	\N	\N	\N	192764	192764	359942
25496	40182	2	applied	\N	\N	\N	\N	192765	192765	359943
25497	40180	0	applied	\N	\N	\N	\N	192766	192766	359944
25497	40181	1	applied	\N	\N	\N	\N	192767	192767	359945
25497	40182	2	applied	\N	\N	\N	\N	192768	192768	359946
25501	40186	0	applied	\N	\N	\N	\N	192778	192778	359956
25501	40187	1	applied	\N	\N	\N	\N	192779	192779	359957
25501	40188	2	applied	\N	\N	\N	\N	192780	192780	359958
25503	40192	0	applied	\N	\N	\N	\N	192784	192784	359962
25503	40193	1	applied	\N	\N	\N	\N	192785	192785	359963
25503	40194	2	applied	\N	\N	\N	\N	192786	192786	359964
25505	40195	0	applied	\N	\N	\N	\N	192790	192790	359968
25505	40196	1	applied	\N	\N	\N	\N	192791	192791	359969
25505	40197	2	applied	\N	\N	\N	\N	192792	192792	359970
25506	40195	0	applied	\N	\N	\N	\N	192793	192793	359971
25506	40197	2	applied	\N	\N	\N	\N	192795	192795	359973
25508	40198	0	applied	\N	\N	\N	\N	192799	192799	359977
25508	40199	1	applied	\N	\N	\N	\N	192800	192800	359978
25508	40200	2	applied	\N	\N	\N	\N	192801	192801	359979
25510	40201	0	applied	\N	\N	\N	\N	192805	192805	359983
25510	40202	1	applied	\N	\N	\N	\N	192806	192806	359984
25510	40203	2	applied	\N	\N	\N	\N	192807	192807	359985
25512	40201	0	applied	\N	\N	\N	\N	192811	192811	359989
25512	40202	1	applied	\N	\N	\N	\N	192812	192812	359990
25512	40203	2	applied	\N	\N	\N	\N	192813	192813	359991
25513	40201	0	applied	\N	\N	\N	\N	192814	192814	359992
25513	40202	1	applied	\N	\N	\N	\N	192815	192815	359993
25513	40203	2	applied	\N	\N	\N	\N	192816	192816	359994
25516	40204	0	applied	\N	\N	\N	\N	192823	192823	360001
25516	40205	1	applied	\N	\N	\N	\N	192824	192824	360002
25516	40206	2	applied	\N	\N	\N	\N	192825	192825	360003
25517	40205	1	applied	\N	\N	\N	\N	192827	192827	360005
25517	40206	2	applied	\N	\N	\N	\N	192828	192828	360006
25518	40204	0	applied	\N	\N	\N	\N	192829	192829	360007
25518	40205	1	applied	\N	\N	\N	\N	192830	192830	360008
25518	40206	2	applied	\N	\N	\N	\N	192831	192831	360009
25523	40207	0	applied	\N	\N	\N	\N	192842	192842	360020
25523	40210	1	applied	\N	\N	\N	\N	192843	192843	360021
25523	40211	2	applied	\N	\N	\N	\N	192844	192844	360022
25523	40212	3	applied	\N	\N	\N	\N	192845	192845	360023
25523	40208	4	applied	\N	\N	\N	\N	192846	192846	360024
25523	40213	5	applied	\N	\N	\N	\N	192847	192847	360025
25523	40214	6	applied	\N	\N	\N	\N	192848	192848	360026
25527	40215	0	applied	\N	\N	\N	\N	192858	192858	360036
25527	40216	1	applied	\N	\N	\N	\N	192859	192859	360037
25527	40217	2	applied	\N	\N	\N	\N	192860	192860	360038
25530	40218	0	applied	\N	\N	\N	\N	192870	192870	360048
25458	40031	0	applied	\N	\N	1000000000	\N	192642	192642	359820
25458	40032	1	applied	\N	\N	1000000000	\N	192643	192643	359821
25464	40138	2	applied	\N	\N	\N	\N	192662	192662	359840
25469	40143	0	applied	\N	\N	\N	\N	192676	192676	359854
25469	40144	1	applied	\N	\N	\N	\N	192677	192677	359855
25469	40145	2	applied	\N	\N	\N	\N	192678	192678	359856
25473	40149	0	applied	\N	\N	\N	\N	192687	192687	359865
25473	40150	2	applied	\N	\N	\N	\N	192688	192688	359866
25473	40151	3	applied	\N	\N	\N	\N	192689	192689	359867
25473	40152	4	applied	\N	\N	\N	\N	192690	192690	359868
25477	40149	0	applied	\N	\N	\N	\N	192703	192703	359881
25477	40150	2	applied	\N	\N	\N	\N	192704	192704	359882
25477	40151	3	applied	\N	\N	\N	\N	192705	192705	359883
25477	40152	4	applied	\N	\N	\N	\N	192706	192706	359884
25484	40162	0	applied	\N	\N	\N	\N	192723	192723	359901
25484	40163	1	applied	\N	\N	\N	\N	192724	192724	359902
25484	40164	2	applied	\N	\N	\N	\N	192725	192725	359903
25499	40180	0	applied	\N	\N	\N	\N	192772	192772	359950
25499	40182	2	applied	\N	\N	\N	\N	192774	192774	359952
25500	40183	0	applied	\N	\N	\N	\N	192775	192775	359953
25500	40184	1	applied	\N	\N	\N	\N	192776	192776	359954
25500	40185	2	applied	\N	\N	\N	\N	192777	192777	359955
25507	40195	0	applied	\N	\N	\N	\N	192796	192796	359974
25507	40196	1	applied	\N	\N	\N	\N	192797	192797	359975
25507	40197	2	applied	\N	\N	\N	\N	192798	192798	359976
25521	40207	0	applied	\N	\N	\N	\N	192838	192838	360016
25521	40208	1	applied	\N	\N	\N	\N	192839	192839	360017
25521	40209	2	applied	\N	\N	\N	\N	192840	192840	360018
25522	40209	0	applied	\N	\N	\N	\N	192841	192841	360019
25525	40215	0	applied	\N	\N	\N	\N	192852	192852	360030
25525	40216	1	applied	\N	\N	\N	\N	192853	192853	360031
25525	40217	2	applied	\N	\N	\N	\N	192854	192854	360032
25530	40220	2	applied	\N	\N	\N	\N	192872	192872	360050
25530	40221	3	applied	\N	\N	\N	\N	192873	192873	360051
25530	40223	5	applied	\N	\N	\N	\N	192875	192875	360053
25530	40224	6	applied	\N	\N	\N	\N	192876	192876	360054
25530	40225	7	applied	\N	\N	\N	\N	192877	192877	360055
25530	40226	8	applied	\N	\N	\N	\N	192878	192878	360056
25532	40230	0	applied	\N	\N	\N	\N	192882	192882	360060
25532	40231	2	applied	\N	\N	\N	\N	192883	192883	360061
25532	40232	3	applied	\N	\N	\N	\N	192884	192884	360062
25533	40230	0	applied	\N	\N	\N	\N	192885	192885	360063
25533	40231	2	applied	\N	\N	\N	\N	192886	192886	360064
25533	40232	3	applied	\N	\N	\N	\N	192887	192887	360065
25534	40233	0	applied	\N	\N	\N	\N	192888	192888	360066
25534	40234	1	applied	\N	\N	\N	\N	192889	192889	360067
25534	40235	2	applied	\N	\N	\N	\N	192890	192890	360068
25535	40236	0	applied	\N	\N	\N	\N	192891	192891	360069
25535	40237	1	applied	\N	\N	\N	\N	192892	192892	360070
25535	40238	2	applied	\N	\N	\N	\N	192893	192893	360071
25537	40240	1	applied	\N	\N	\N	\N	192898	192898	360076
25537	40241	2	applied	\N	\N	\N	\N	192899	192899	360077
25537	40242	3	applied	\N	\N	\N	\N	192900	192900	360078
25537	40243	4	applied	\N	\N	\N	\N	192901	192901	360079
25537	40244	5	applied	\N	\N	\N	\N	192902	192902	360080
25539	40245	0	applied	\N	\N	\N	\N	192905	192905	360083
25539	40246	1	applied	\N	\N	\N	\N	192906	192906	360084
25542	40151	0	applied	\N	\N	\N	\N	192914	192914	360092
25544	40252	0	applied	\N	\N	\N	\N	192916	192916	360094
25544	40253	1	applied	\N	\N	\N	\N	192917	192917	360095
25544	40254	2	applied	\N	\N	\N	\N	192918	192918	360096
25544	40255	3	applied	\N	\N	\N	\N	192919	192919	360097
25544	40256	4	applied	\N	\N	\N	\N	192920	192920	360098
25544	40257	5	applied	\N	\N	\N	\N	192921	192921	360099
25545	40258	0	applied	\N	\N	\N	\N	192922	192922	360100
25545	40259	1	applied	\N	\N	\N	\N	192923	192923	360101
25550	40273	0	applied	\N	\N	\N	\N	192937	192937	360115
25550	40274	1	applied	\N	\N	\N	\N	192938	192938	360116
25550	40275	2	applied	\N	\N	\N	\N	192939	192939	360117
25552	40276	0	applied	\N	\N	\N	\N	193018	193018	360196
25552	40277	1	applied	\N	\N	\N	\N	193019	193019	360197
25552	40278	2	applied	\N	\N	\N	\N	193020	193020	360198
25555	40279	0	applied	\N	\N	\N	\N	193027	193027	360205
25555	40280	1	applied	\N	\N	\N	\N	193028	193028	360206
25555	40281	2	applied	\N	\N	\N	\N	193029	193029	360207
25555	40282	3	applied	\N	\N	\N	\N	193030	193030	360208
25555	40283	4	applied	\N	\N	\N	\N	193031	193031	360209
25555	40284	5	applied	\N	\N	\N	\N	193032	193032	360210
25557	40285	0	applied	\N	\N	\N	\N	193158	193158	360336
25557	40286	1	applied	\N	\N	\N	\N	193159	193159	360337
25557	40287	2	applied	\N	\N	\N	\N	193160	193160	360338
25560	40294	0	applied	\N	\N	\N	\N	193167	193167	360345
25560	40296	2	applied	\N	\N	\N	\N	193169	193169	360347
25562	40294	0	applied	\N	\N	\N	\N	193173	193173	360351
25562	40295	1	applied	\N	\N	\N	\N	193174	193174	360352
25562	40296	2	applied	\N	\N	\N	\N	193175	193175	360353
25564	40294	0	applied	\N	\N	\N	\N	193179	193179	360357
25564	40295	1	applied	\N	\N	\N	\N	193180	193180	360358
25564	40296	2	applied	\N	\N	\N	\N	193181	193181	360359
25567	40297	0	applied	\N	\N	\N	\N	193200	193200	360378
25567	40298	1	applied	\N	\N	\N	\N	193201	193201	360379
25567	40299	2	applied	\N	\N	\N	\N	193202	193202	360380
25567	40300	3	applied	\N	\N	\N	\N	193203	193203	360381
25567	40301	4	applied	\N	\N	\N	\N	193204	193204	360382
25567	40302	5	applied	\N	\N	\N	\N	193205	193205	360383
25567	40303	6	applied	\N	\N	\N	\N	193206	193206	360384
25567	40304	7	applied	\N	\N	\N	\N	193207	193207	360385
25567	40305	8	applied	\N	\N	\N	\N	193208	193208	360386
25569	40313	1	applied	\N	\N	\N	\N	193216	193216	360394
25569	40314	2	applied	\N	\N	\N	\N	193217	193217	360395
25570	40315	0	applied	\N	\N	\N	\N	193218	193218	360396
25570	40316	1	applied	\N	\N	\N	\N	193219	193219	360397
25570	40317	2	applied	\N	\N	\N	\N	193220	193220	360398
25572	40315	0	applied	\N	\N	\N	\N	193224	193224	360402
25572	40316	1	applied	\N	\N	\N	\N	193225	193225	360403
25572	40317	2	applied	\N	\N	\N	\N	193226	193226	360404
25572	40318	4	applied	\N	\N	\N	\N	193227	193227	360405
25572	40319	5	applied	\N	\N	\N	\N	193228	193228	360406
25572	40320	6	applied	\N	\N	\N	\N	193229	193229	360407
25572	40321	7	applied	\N	\N	\N	\N	193230	193230	360408
25572	40322	8	applied	\N	\N	\N	\N	193231	193231	360409
25574	40315	0	applied	\N	\N	\N	\N	193242	193242	360420
25457	40125	3	applied	\N	\N	\N	\N	192641	192641	359819
25464	40136	0	applied	\N	\N	\N	\N	192660	192660	359838
25520	40208	1	applied	\N	\N	\N	\N	192836	192836	360014
25520	40209	2	applied	\N	\N	\N	\N	192837	192837	360015
25524	40215	0	applied	\N	\N	\N	\N	192849	192849	360027
25524	40216	1	applied	\N	\N	\N	\N	192850	192850	360028
25524	40217	2	applied	\N	\N	\N	\N	192851	192851	360029
25526	40215	0	applied	\N	\N	\N	\N	192855	192855	360033
25526	40216	1	applied	\N	\N	\N	\N	192856	192856	360034
25526	40217	2	applied	\N	\N	\N	\N	192857	192857	360035
25529	40218	0	applied	\N	\N	\N	\N	192861	192861	360039
25529	40219	1	applied	\N	\N	\N	\N	192862	192862	360040
25529	40220	2	applied	\N	\N	\N	\N	192863	192863	360041
25529	40221	3	applied	\N	\N	\N	\N	192864	192864	360042
25529	40222	4	applied	\N	\N	\N	\N	192865	192865	360043
25529	40223	5	applied	\N	\N	\N	\N	192866	192866	360044
25529	40224	6	applied	\N	\N	\N	\N	192867	192867	360045
25529	40225	7	applied	\N	\N	\N	\N	192868	192868	360046
25531	40227	0	applied	\N	\N	\N	\N	192879	192879	360057
25531	40228	1	applied	\N	\N	\N	\N	192880	192880	360058
25531	40229	2	applied	\N	\N	\N	\N	192881	192881	360059
25536	40236	0	applied	\N	\N	\N	\N	192894	192894	360072
25536	40237	1	applied	\N	\N	\N	\N	192895	192895	360073
25536	40238	2	applied	\N	\N	\N	\N	192896	192896	360074
25541	40247	0	applied	\N	\N	\N	\N	192909	192909	360087
25541	40248	1	applied	\N	\N	\N	\N	192910	192910	360088
25541	40249	2	applied	\N	\N	\N	\N	192911	192911	360089
25541	40250	3	applied	\N	\N	\N	\N	192912	192912	360090
25541	40251	4	applied	\N	\N	\N	\N	192913	192913	360091
25546	40261	0	applied	\N	\N	\N	\N	192925	192925	360103
25546	40262	1	applied	\N	\N	\N	\N	192926	192926	360104
25546	40263	2	applied	\N	\N	\N	\N	192927	192927	360105
25549	40272	0	applied	\N	\N	\N	\N	192936	192936	360114
25551	40198	0	applied	\N	\N	\N	\N	192940	192940	360118
25551	40204	2	applied	\N	\N	\N	\N	192942	192942	360120
25551	40207	3	applied	\N	\N	\N	\N	192943	192943	360121
25551	40210	4	applied	\N	\N	\N	\N	192944	192944	360122
25551	40211	5	applied	\N	\N	\N	\N	192945	192945	360123
25551	40215	6	applied	\N	\N	\N	\N	192946	192946	360124
25551	40218	7	applied	\N	\N	\N	\N	192947	192947	360125
25551	40219	8	applied	\N	\N	\N	\N	192948	192948	360126
25551	40220	9	applied	\N	\N	\N	\N	192949	192949	360127
25551	40227	10	applied	\N	\N	\N	\N	192950	192950	360128
25551	40230	11	applied	\N	\N	\N	\N	192951	192951	360129
25551	40233	12	applied	\N	\N	\N	\N	192952	192952	360130
25551	40236	13	applied	\N	\N	\N	\N	192953	192953	360131
25551	40239	14	applied	\N	\N	\N	\N	192954	192954	360132
25551	40240	15	applied	\N	\N	\N	\N	192955	192955	360133
25551	40245	16	applied	\N	\N	\N	\N	192956	192956	360134
25551	40247	17	applied	\N	\N	\N	\N	192957	192957	360135
25551	40253	19	applied	\N	\N	\N	\N	192959	192959	360137
25551	40258	20	applied	\N	\N	\N	\N	192960	192960	360138
25551	40261	21	applied	\N	\N	\N	\N	192961	192961	360139
25551	40264	22	applied	\N	\N	\N	\N	192962	192962	360140
25551	40265	23	applied	\N	\N	\N	\N	192963	192963	360141
25551	40266	24	applied	\N	\N	\N	\N	192964	192964	360142
25551	40273	25	applied	\N	\N	\N	\N	192965	192965	360143
25551	40199	26	applied	\N	\N	\N	\N	192966	192966	360144
25551	40203	27	applied	\N	\N	\N	\N	192967	192967	360145
25551	40205	28	applied	\N	\N	\N	\N	192968	192968	360146
25551	40208	29	applied	\N	\N	\N	\N	192969	192969	360147
25551	40213	30	applied	\N	\N	\N	\N	192970	192970	360148
25551	40216	31	applied	\N	\N	\N	\N	192971	192971	360149
25551	40221	32	applied	\N	\N	\N	\N	192972	192972	360150
25551	40222	33	applied	\N	\N	\N	\N	192973	192973	360151
25572	40323	9	applied	\N	\N	\N	\N	193232	193232	360410
25581	40337	1	applied	\N	\N	\N	\N	193285	193285	360463
25581	40338	2	applied	\N	\N	\N	\N	193286	193286	360464
25588	40339	0	applied	\N	\N	\N	\N	193305	193305	360483
25588	40340	1	applied	\N	\N	\N	\N	193306	193306	360484
25588	40341	2	applied	\N	\N	\N	\N	193307	193307	360485
25588	40342	3	applied	\N	\N	\N	\N	193308	193308	360486
25588	40343	4	applied	\N	\N	\N	\N	193309	193309	360487
25588	40344	5	applied	\N	\N	\N	\N	193310	193310	360488
25588	40345	6	applied	\N	\N	\N	\N	193311	193311	360489
25588	40346	7	applied	\N	\N	\N	\N	193312	193312	360490
25588	40347	8	applied	\N	\N	\N	\N	193313	193313	360491
25588	40348	9	applied	\N	\N	\N	\N	193314	193314	360492
25588	40349	10	applied	\N	\N	\N	\N	193315	193315	360493
25588	40350	11	applied	\N	\N	\N	\N	193316	193316	360494
25590	40351	0	applied	\N	\N	\N	\N	193320	193320	360498
25590	40352	1	applied	\N	\N	\N	\N	193321	193321	360499
25593	40360	0	applied	\N	\N	\N	\N	193329	193329	360507
25593	40361	1	applied	\N	\N	\N	\N	193330	193330	360508
25602	40372	0	applied	\N	\N	\N	\N	193351	193351	360529
25602	40373	1	applied	\N	\N	\N	\N	193352	193352	360530
25602	40374	2	applied	\N	\N	\N	\N	193353	193353	360531
25602	40375	3	applied	\N	\N	\N	\N	193354	193354	360532
25602	40376	4	applied	\N	\N	\N	\N	193355	193355	360533
25602	40377	5	applied	\N	\N	\N	\N	193356	193356	360534
25614	40396	0	applied	\N	\N	\N	\N	193404	193404	360582
25614	40397	1	applied	\N	\N	\N	\N	193405	193405	360583
25614	40398	2	applied	\N	\N	\N	\N	193406	193406	360584
25621	40409	0	applied	\N	\N	\N	\N	193426	193426	360604
25621	40410	1	applied	\N	\N	\N	\N	193427	193427	360605
25621	40411	2	applied	\N	\N	\N	\N	193428	193428	360606
25621	40412	3	applied	\N	\N	\N	\N	193429	193429	360607
25621	40413	4	applied	\N	\N	\N	\N	193430	193430	360608
25624	40417	0	applied	\N	\N	\N	\N	193440	193440	360618
25624	40418	1	applied	\N	\N	\N	\N	193441	193441	360619
25624	40421	2	applied	\N	\N	\N	\N	193442	193442	360620
25624	40422	3	applied	\N	\N	\N	\N	193443	193443	360621
25624	40423	4	applied	\N	\N	\N	\N	193444	193444	360622
25624	40424	5	applied	\N	\N	\N	\N	193445	193445	360623
25624	40419	6	applied	\N	\N	\N	\N	193446	193446	360624
25624	40420	7	applied	\N	\N	\N	\N	193447	193447	360625
25624	40425	8	applied	\N	\N	\N	\N	193448	193448	360626
25624	40426	9	applied	\N	\N	\N	\N	193449	193449	360627
25626	40417	0	applied	\N	\N	\N	\N	193460	193460	360638
25626	40418	1	applied	\N	\N	\N	\N	193461	193461	360639
25626	40421	2	applied	\N	\N	\N	\N	193462	193462	360640
25626	40422	3	applied	\N	\N	\N	\N	193463	193463	360641
25515	40205	1	applied	\N	\N	\N	\N	192821	192821	359999
25515	40206	2	applied	\N	\N	\N	\N	192822	192822	360000
25538	40246	1	applied	\N	\N	\N	\N	192904	192904	360082
25540	40245	0	applied	\N	\N	\N	\N	192907	192907	360085
25540	40246	1	applied	\N	\N	\N	\N	192908	192908	360086
25543	40151	0	applied	\N	\N	\N	\N	192915	192915	360093
25548	40264	0	applied	\N	\N	\N	\N	192928	192928	360106
25548	40265	1	applied	\N	\N	\N	\N	192929	192929	360107
25548	40266	2	applied	\N	\N	\N	\N	192930	192930	360108
25548	40267	3	applied	\N	\N	\N	\N	192931	192931	360109
25548	40268	4	applied	\N	\N	\N	\N	192932	192932	360110
25548	40269	5	applied	\N	\N	\N	\N	192933	192933	360111
25548	40270	6	applied	\N	\N	\N	\N	192934	192934	360112
25548	40271	7	applied	\N	\N	\N	\N	192935	192935	360113
25551	40223	34	applied	\N	\N	\N	\N	192974	192974	360152
25551	40228	35	applied	\N	\N	\N	\N	192975	192975	360153
25551	40232	36	applied	\N	\N	\N	\N	192976	192976	360154
25551	40234	37	applied	\N	\N	\N	\N	192977	192977	360155
25551	40242	39	applied	\N	\N	\N	\N	192979	192979	360157
25551	40243	40	applied	\N	\N	\N	\N	192980	192980	360158
25551	40246	41	applied	\N	\N	\N	\N	192981	192981	360159
25551	40250	42	applied	\N	\N	\N	\N	192982	192982	360160
25551	40251	43	applied	\N	\N	\N	\N	192983	192983	360161
25551	40256	44	applied	\N	\N	\N	\N	192984	192984	360162
25551	40200	45	applied	\N	\N	\N	\N	192985	192985	360163
25551	40202	46	applied	\N	\N	\N	\N	192986	192986	360164
25551	40206	47	applied	\N	\N	\N	\N	192987	192987	360165
25551	40209	48	applied	\N	\N	\N	\N	192988	192988	360166
25551	40212	50	applied	\N	\N	\N	\N	192989	192989	360167
25551	40257	51	applied	\N	\N	\N	\N	192990	192990	360168
25551	40259	52	applied	\N	\N	\N	\N	192991	192991	360169
25551	40262	53	applied	\N	\N	\N	\N	192992	192992	360170
25551	40267	54	applied	\N	\N	\N	\N	192993	192993	360171
25551	40268	55	applied	\N	\N	\N	\N	192994	192994	360172
25551	40275	57	applied	\N	\N	\N	\N	192996	192996	360174
25551	40214	58	applied	\N	\N	\N	\N	192997	192997	360175
25551	40217	59	applied	\N	\N	\N	\N	192998	192998	360176
25551	40224	60	applied	\N	\N	\N	\N	192999	192999	360177
25551	40225	61	applied	\N	\N	\N	\N	193000	193000	360178
25551	40226	62	applied	\N	\N	\N	\N	193001	193001	360179
25551	40229	63	applied	\N	\N	\N	\N	193002	193002	360180
25551	40231	64	applied	\N	\N	\N	\N	193003	193003	360181
25551	40235	65	applied	\N	\N	\N	\N	193004	193004	360182
25551	40237	66	applied	\N	\N	\N	\N	193005	193005	360183
25551	40241	67	applied	\N	\N	\N	\N	193006	193006	360184
25551	40244	68	applied	\N	\N	\N	\N	193007	193007	360185
25551	40248	69	applied	\N	\N	\N	\N	193008	193008	360186
25551	40249	70	applied	\N	\N	\N	\N	193009	193009	360187
25551	40254	71	applied	\N	\N	\N	\N	193010	193010	360188
25551	40255	72	applied	\N	\N	\N	\N	193011	193011	360189
25551	40263	74	applied	\N	\N	\N	\N	193013	193013	360191
25551	40269	75	applied	\N	\N	\N	\N	193014	193014	360192
25551	40270	76	applied	\N	\N	\N	\N	193015	193015	360193
25551	40271	77	applied	\N	\N	\N	\N	193016	193016	360194
25551	40274	78	applied	\N	\N	\N	\N	193017	193017	360195
25554	40279	0	applied	\N	\N	\N	\N	193021	193021	360199
25554	40280	1	applied	\N	\N	\N	\N	193022	193022	360200
25554	40281	2	applied	\N	\N	\N	\N	193023	193023	360201
25554	40282	3	applied	\N	\N	\N	\N	193024	193024	360202
25554	40283	4	applied	\N	\N	\N	\N	193025	193025	360203
25554	40284	5	applied	\N	\N	\N	\N	193026	193026	360204
25558	40288	0	applied	\N	\N	\N	\N	193161	193161	360339
25558	40289	1	applied	\N	\N	\N	\N	193162	193162	360340
25558	40290	2	applied	\N	\N	\N	\N	193163	193163	360341
25558	40291	3	applied	\N	\N	\N	\N	193164	193164	360342
25558	40292	4	applied	\N	\N	\N	\N	193165	193165	360343
25561	40294	0	applied	\N	\N	\N	\N	193170	193170	360348
25561	40295	1	applied	\N	\N	\N	\N	193171	193171	360349
25561	40296	2	applied	\N	\N	\N	\N	193172	193172	360350
25565	40297	0	applied	\N	\N	\N	\N	193182	193182	360360
25565	40298	1	applied	\N	\N	\N	\N	193183	193183	360361
25565	40299	2	applied	\N	\N	\N	\N	193184	193184	360362
25565	40300	3	applied	\N	\N	\N	\N	193185	193185	360363
25565	40301	4	applied	\N	\N	\N	\N	193186	193186	360364
25565	40302	5	applied	\N	\N	\N	\N	193187	193187	360365
25565	40303	6	applied	\N	\N	\N	\N	193188	193188	360366
25565	40304	7	applied	\N	\N	\N	\N	193189	193189	360367
25565	40305	8	applied	\N	\N	\N	\N	193190	193190	360368
25571	40315	0	applied	\N	\N	\N	\N	193221	193221	360399
25571	40316	1	applied	\N	\N	\N	\N	193222	193222	360400
25571	40317	2	applied	\N	\N	\N	\N	193223	193223	360401
25587	40339	0	applied	\N	\N	\N	\N	193293	193293	360471
25587	40341	2	applied	\N	\N	\N	\N	193295	193295	360473
25587	40342	3	applied	\N	\N	\N	\N	193296	193296	360474
25587	40343	4	applied	\N	\N	\N	\N	193297	193297	360475
25587	40344	5	applied	\N	\N	\N	\N	193298	193298	360476
25587	40345	6	applied	\N	\N	\N	\N	193299	193299	360477
25587	40346	7	applied	\N	\N	\N	\N	193300	193300	360478
25587	40347	8	applied	\N	\N	\N	\N	193301	193301	360479
25587	40348	9	applied	\N	\N	\N	\N	193302	193302	360480
25587	40349	10	applied	\N	\N	\N	\N	193303	193303	360481
25587	40350	11	applied	\N	\N	\N	\N	193304	193304	360482
25589	40351	0	applied	\N	\N	\N	\N	193317	193317	360495
25589	40352	1	applied	\N	\N	\N	\N	193318	193318	360496
25589	40353	2	applied	\N	\N	\N	\N	193319	193319	360497
25594	40360	0	applied	\N	\N	\N	\N	193331	193331	360509
25594	40362	1	applied	\N	\N	\N	\N	193332	193332	360510
25594	40361	2	applied	\N	\N	\N	\N	193333	193333	360511
25596	40364	1	applied	\N	\N	\N	\N	193335	193335	360513
25601	40366	0	applied	\N	\N	\N	\N	193345	193345	360523
25601	40367	1	applied	\N	\N	\N	\N	193346	193346	360524
25601	40368	2	applied	\N	\N	\N	\N	193347	193347	360525
25601	40369	3	applied	\N	\N	\N	\N	193348	193348	360526
25601	40370	4	applied	\N	\N	\N	\N	193349	193349	360527
25601	40371	5	applied	\N	\N	\N	\N	193350	193350	360528
25604	40378	0	applied	\N	\N	\N	\N	193363	193363	360541
25604	40379	1	applied	\N	\N	\N	\N	193364	193364	360542
25604	40380	2	applied	\N	\N	\N	\N	193365	193365	360543
25604	40381	3	applied	\N	\N	\N	\N	193366	193366	360544
25604	40382	4	applied	\N	\N	\N	\N	193367	193367	360545
25604	40383	5	applied	\N	\N	\N	\N	193368	193368	360546
25606	40384	0	applied	\N	\N	\N	\N	193375	193375	360553
25519	40208	1	applied	\N	\N	\N	\N	192833	192833	360011
25519	40209	2	applied	\N	\N	\N	\N	192834	192834	360012
25556	40101	4	applied	\N	\N	\N	\N	193037	193037	360215
25556	40104	5	applied	\N	\N	\N	\N	193038	193038	360216
25556	40108	6	applied	\N	\N	\N	\N	193039	193039	360217
25556	40109	7	applied	\N	\N	\N	\N	193040	193040	360218
25556	40115	8	applied	\N	\N	\N	\N	193041	193041	360219
25556	40119	9	applied	\N	\N	\N	\N	193042	193042	360220
25556	40123	10	applied	\N	\N	\N	\N	193043	193043	360221
25556	40126	11	applied	\N	\N	\N	\N	193044	193044	360222
25556	40130	12	applied	\N	\N	\N	\N	193045	193045	360223
25556	40131	13	applied	\N	\N	\N	\N	193046	193046	360224
25556	40136	14	applied	\N	\N	\N	\N	193047	193047	360225
25556	40139	15	applied	\N	\N	\N	\N	193048	193048	360226
25556	40143	16	applied	\N	\N	\N	\N	193049	193049	360227
25556	40146	17	applied	\N	\N	\N	\N	193050	193050	360228
25556	40149	18	applied	\N	\N	\N	\N	193051	193051	360229
25556	40153	19	applied	\N	\N	\N	\N	193052	193052	360230
25556	40159	21	applied	\N	\N	\N	\N	193054	193054	360232
25556	40162	22	applied	\N	\N	\N	\N	193055	193055	360233
25556	40165	23	applied	\N	\N	\N	\N	193056	193056	360234
25556	40168	24	applied	\N	\N	\N	\N	193057	193057	360235
25556	40171	25	applied	\N	\N	\N	\N	193058	193058	360236
25556	40174	26	applied	\N	\N	\N	\N	193059	193059	360237
25556	40175	27	applied	\N	\N	\N	\N	193060	193060	360238
25556	40180	28	applied	\N	\N	\N	\N	193061	193061	360239
25556	40183	29	applied	\N	\N	\N	\N	193062	193062	360240
25556	40186	30	applied	\N	\N	\N	\N	193063	193063	360241
25556	40189	31	applied	\N	\N	\N	\N	193064	193064	360242
25556	40192	32	applied	\N	\N	\N	\N	193065	193065	360243
25556	40195	33	applied	\N	\N	\N	\N	193066	193066	360244
25556	40198	34	applied	\N	\N	\N	\N	193067	193067	360245
25556	40201	35	applied	\N	\N	\N	\N	193068	193068	360246
25556	40204	36	applied	\N	\N	\N	\N	193069	193069	360247
25556	40210	38	applied	\N	\N	\N	\N	193071	193071	360249
25556	40211	39	applied	\N	\N	\N	\N	193072	193072	360250
25556	40215	40	applied	\N	\N	\N	\N	193073	193073	360251
25556	40218	41	applied	\N	\N	\N	\N	193074	193074	360252
25556	40219	42	applied	\N	\N	\N	\N	193075	193075	360253
25556	40220	43	applied	\N	\N	\N	\N	193076	193076	360254
25556	40227	44	applied	\N	\N	\N	\N	193077	193077	360255
25556	40230	45	applied	\N	\N	\N	\N	193078	193078	360256
25556	40233	46	applied	\N	\N	\N	\N	193079	193079	360257
25556	40236	47	applied	\N	\N	\N	\N	193080	193080	360258
25556	40239	48	applied	\N	\N	\N	\N	193081	193081	360259
25556	40240	49	applied	\N	\N	\N	\N	193082	193082	360260
25556	40245	50	applied	\N	\N	\N	\N	193083	193083	360261
25556	40247	51	applied	\N	\N	\N	\N	193084	193084	360262
25556	40252	52	applied	\N	\N	\N	\N	193085	193085	360263
25556	40253	53	applied	\N	\N	\N	\N	193086	193086	360264
25556	40261	55	applied	\N	\N	\N	\N	193088	193088	360266
25556	40264	56	applied	\N	\N	\N	\N	193089	193089	360267
25556	40265	57	applied	\N	\N	\N	\N	193090	193090	360268
25556	40266	58	applied	\N	\N	\N	\N	193091	193091	360269
25556	40273	59	applied	\N	\N	\N	\N	193092	193092	360270
25556	40276	60	applied	\N	\N	\N	\N	193093	193093	360271
25556	40279	61	applied	\N	\N	\N	\N	193094	193094	360272
25556	40280	62	applied	\N	\N	\N	\N	193095	193095	360273
25556	40151	63	applied	\N	\N	\N	\N	193096	193096	360274
25556	40089	64	applied	\N	\N	\N	\N	193097	193097	360275
25556	40090	65	applied	\N	\N	\N	\N	193098	193098	360276
25556	40112	66	applied	\N	\N	\N	\N	193099	193099	360277
25556	40122	67	applied	\N	\N	\N	\N	193100	193100	360278
25556	40092	68	applied	\N	\N	\N	\N	193101	193101	360279
25556	40093	69	applied	\N	\N	\N	\N	193102	193102	360280
25606	40385	1	applied	\N	\N	\N	\N	193376	193376	360554
25609	40387	0	applied	\N	\N	\N	\N	193382	193382	360560
25609	40388	1	applied	\N	\N	\N	\N	193383	193383	360561
25609	40389	2	applied	\N	\N	\N	\N	193384	193384	360562
25609	40390	3	applied	\N	\N	\N	\N	193385	193385	360563
25609	40391	4	applied	\N	\N	\N	\N	193386	193386	360564
25609	40392	5	applied	\N	\N	\N	\N	193387	193387	360565
25615	40399	0	applied	\N	\N	\N	\N	193407	193407	360585
25615	40400	1	applied	\N	\N	\N	\N	193408	193408	360586
25615	40401	2	applied	\N	\N	\N	\N	193409	193409	360587
25625	40417	0	applied	\N	\N	\N	\N	193450	193450	360628
25625	40418	1	applied	\N	\N	\N	\N	193451	193451	360629
25625	40421	2	applied	\N	\N	\N	\N	193452	193452	360630
25625	40422	3	applied	\N	\N	\N	\N	193453	193453	360631
25625	40423	4	applied	\N	\N	\N	\N	193454	193454	360632
25625	40424	5	applied	\N	\N	\N	\N	193455	193455	360633
25625	40419	6	applied	\N	\N	\N	\N	193456	193456	360634
25625	40425	8	applied	\N	\N	\N	\N	193458	193458	360636
25625	40426	9	applied	\N	\N	\N	\N	193459	193459	360637
25627	40417	0	applied	\N	\N	\N	\N	193470	193470	360648
25627	40418	1	applied	\N	\N	\N	\N	193471	193471	360649
25627	40421	2	applied	\N	\N	\N	\N	193472	193472	360650
25627	40422	3	applied	\N	\N	\N	\N	193473	193473	360651
25627	40423	4	applied	\N	\N	\N	\N	193474	193474	360652
25627	40424	5	applied	\N	\N	\N	\N	193475	193475	360653
25627	40419	6	applied	\N	\N	\N	\N	193476	193476	360654
25627	40420	7	applied	\N	\N	\N	\N	193477	193477	360655
25627	40425	8	applied	\N	\N	\N	\N	193478	193478	360656
25627	40426	9	applied	\N	\N	\N	\N	193479	193479	360657
25631	40441	0	applied	\N	\N	\N	\N	193494	193494	360672
25631	40442	1	applied	\N	\N	\N	\N	193495	193495	360673
25631	40443	2	applied	\N	\N	\N	\N	193496	193496	360674
25631	40444	3	applied	\N	\N	\N	\N	193497	193497	360675
25631	40446	5	applied	\N	\N	\N	\N	193499	193499	360677
25639	40468	0	applied	\N	\N	\N	\N	193545	193545	360723
25639	40469	1	applied	\N	\N	\N	\N	193546	193546	360724
25639	40470	2	applied	\N	\N	\N	\N	193547	193547	360725
25641	40471	0	applied	\N	\N	\N	\N	193551	193551	360729
25641	40472	1	applied	\N	\N	\N	\N	193552	193552	360730
25641	40473	2	applied	\N	\N	\N	\N	193553	193553	360731
25643	40276	0	applied	\N	\N	\N	\N	193557	193557	360735
25643	40279	1	applied	\N	\N	\N	\N	193558	193558	360736
25643	40280	2	applied	\N	\N	\N	\N	193559	193559	360737
25643	40285	3	applied	\N	\N	\N	\N	193560	193560	360738
25643	40288	4	applied	\N	\N	\N	\N	193561	193561	360739
25643	40289	5	applied	\N	\N	\N	\N	193562	193562	360740
25643	40294	6	applied	\N	\N	\N	\N	193563	193563	360741
25556	40091	1	applied	\N	\N	\N	\N	193034	193034	360212
25556	40095	2	applied	\N	\N	\N	\N	193035	193035	360213
25556	40127	74	applied	\N	\N	\N	\N	193107	193107	360285
25556	40097	75	applied	\N	\N	\N	\N	193108	193108	360286
25556	40099	76	applied	\N	\N	\N	\N	193109	193109	360287
25556	40103	77	applied	\N	\N	\N	\N	193110	193110	360288
25556	40107	78	applied	\N	\N	\N	\N	193111	193111	360289
25556	40110	79	applied	\N	\N	\N	\N	193112	193112	360290
25556	40114	80	applied	\N	\N	\N	\N	193113	193113	360291
25556	40118	81	applied	\N	\N	\N	\N	193114	193114	360292
25556	40120	82	applied	\N	\N	\N	\N	193115	193115	360293
25556	40124	83	applied	\N	\N	\N	\N	193116	193116	360294
25556	40129	84	applied	\N	\N	\N	\N	193117	193117	360295
25556	40132	85	applied	\N	\N	\N	\N	193118	193118	360296
25556	40133	86	applied	\N	\N	\N	\N	193119	193119	360297
25556	40138	87	applied	\N	\N	\N	\N	193120	193120	360298
25556	40140	88	applied	\N	\N	\N	\N	193121	193121	360299
25556	40100	89	applied	\N	\N	\N	\N	193122	193122	360300
25556	40106	91	applied	\N	\N	\N	\N	193124	193124	360302
25556	40111	92	applied	\N	\N	\N	\N	193125	193125	360303
25556	40113	93	applied	\N	\N	\N	\N	193126	193126	360304
25556	40117	95	applied	\N	\N	\N	\N	193127	193127	360305
25556	40121	96	applied	\N	\N	\N	\N	193128	193128	360306
25556	40125	97	applied	\N	\N	\N	\N	193129	193129	360307
25556	40128	98	applied	\N	\N	\N	\N	193130	193130	360308
25556	40134	99	applied	\N	\N	\N	\N	193131	193131	360309
25556	40135	100	applied	\N	\N	\N	\N	193132	193132	360310
25556	40137	101	applied	\N	\N	\N	\N	193133	193133	360311
25556	40141	102	applied	\N	\N	\N	\N	193134	193134	360312
25556	40144	103	applied	\N	\N	\N	\N	193135	193135	360313
25556	40147	104	applied	\N	\N	\N	\N	193136	193136	360314
25556	40152	105	applied	\N	\N	\N	\N	193137	193137	360315
25556	40154	106	applied	\N	\N	\N	\N	193138	193138	360316
25556	40157	107	applied	\N	\N	\N	\N	193139	193139	360317
25556	40163	109	applied	\N	\N	\N	\N	193141	193141	360319
25556	40166	110	applied	\N	\N	\N	\N	193142	193142	360320
25556	40169	111	applied	\N	\N	\N	\N	193143	193143	360321
25556	40172	112	applied	\N	\N	\N	\N	193144	193144	360322
25556	40177	113	applied	\N	\N	\N	\N	193145	193145	360323
25556	40178	114	applied	\N	\N	\N	\N	193146	193146	360324
25556	40181	115	applied	\N	\N	\N	\N	193147	193147	360325
25556	40184	116	applied	\N	\N	\N	\N	193148	193148	360326
25556	40188	117	applied	\N	\N	\N	\N	193149	193149	360327
25556	40190	118	applied	\N	\N	\N	\N	193150	193150	360328
25556	40194	119	applied	\N	\N	\N	\N	193151	193151	360329
25556	40197	120	applied	\N	\N	\N	\N	193152	193152	360330
25556	40199	121	applied	\N	\N	\N	\N	193153	193153	360331
25556	40203	122	applied	\N	\N	\N	\N	193154	193154	360332
25556	40205	123	applied	\N	\N	\N	\N	193155	193155	360333
25556	40208	124	applied	\N	\N	\N	\N	193156	193156	360334
25563	40294	0	applied	\N	\N	\N	\N	193176	193176	360354
25563	40295	1	applied	\N	\N	\N	\N	193177	193177	360355
25563	40296	2	applied	\N	\N	\N	\N	193178	193178	360356
25566	40297	0	applied	\N	\N	\N	\N	193191	193191	360369
25566	40298	1	applied	\N	\N	\N	\N	193192	193192	360370
25566	40299	2	applied	\N	\N	\N	\N	193193	193193	360371
25566	40300	3	applied	\N	\N	\N	\N	193194	193194	360372
25566	40301	4	applied	\N	\N	\N	\N	193195	193195	360373
25566	40302	5	applied	\N	\N	\N	\N	193196	193196	360374
25566	40303	6	applied	\N	\N	\N	\N	193197	193197	360375
25566	40304	7	applied	\N	\N	\N	\N	193198	193198	360376
25566	40305	8	applied	\N	\N	\N	\N	193199	193199	360377
25568	40306	0	applied	\N	\N	\N	\N	193209	193209	360387
25568	40307	1	applied	\N	\N	\N	\N	193210	193210	360388
25568	40308	2	applied	\N	\N	\N	\N	193211	193211	360389
25568	40309	3	applied	\N	\N	\N	\N	193212	193212	360390
25568	40311	5	applied	\N	\N	\N	\N	193214	193214	360392
25573	40315	0	applied	\N	\N	\N	\N	193233	193233	360411
25573	40316	1	applied	\N	\N	\N	\N	193234	193234	360412
25573	40317	2	applied	\N	\N	\N	\N	193235	193235	360413
25573	40318	4	applied	\N	\N	\N	\N	193236	193236	360414
25573	40319	5	applied	\N	\N	\N	\N	193237	193237	360415
25573	40320	6	applied	\N	\N	\N	\N	193238	193238	360416
25573	40321	7	applied	\N	\N	\N	\N	193239	193239	360417
25573	40322	8	applied	\N	\N	\N	\N	193240	193240	360418
25573	40323	9	applied	\N	\N	\N	\N	193241	193241	360419
25575	40315	0	applied	\N	\N	\N	\N	193251	193251	360429
25575	40316	1	applied	\N	\N	\N	\N	193252	193252	360430
25575	40317	2	applied	\N	\N	\N	\N	193253	193253	360431
25575	40318	4	applied	\N	\N	\N	\N	193254	193254	360432
25575	40319	5	applied	\N	\N	\N	\N	193255	193255	360433
25575	40320	6	applied	\N	\N	\N	\N	193256	193256	360434
25575	40322	8	applied	\N	\N	\N	\N	193258	193258	360436
25575	40323	9	applied	\N	\N	\N	\N	193259	193259	360437
25576	40324	0	applied	\N	\N	\N	\N	193260	193260	360438
25576	40325	1	applied	\N	\N	\N	\N	193261	193261	360439
25576	40326	2	applied	\N	\N	\N	\N	193262	193262	360440
25576	40318	3	applied	\N	\N	\N	\N	193263	193263	360441
25576	40319	4	applied	\N	\N	\N	\N	193264	193264	360442
25576	40320	5	applied	\N	\N	\N	\N	193265	193265	360443
25576	40321	6	applied	\N	\N	\N	\N	193266	193266	360444
25576	40322	7	applied	\N	\N	\N	\N	193267	193267	360445
25576	40323	8	applied	\N	\N	\N	\N	193268	193268	360446
25576	40327	9	applied	\N	\N	\N	\N	193269	193269	360447
25576	40328	10	applied	\N	\N	\N	\N	193270	193270	360448
25576	40329	11	applied	\N	\N	\N	\N	193271	193271	360449
25576	40330	12	applied	\N	\N	\N	\N	193272	193272	360450
25576	40331	13	applied	\N	\N	\N	\N	193273	193273	360451
25578	40333	0	applied	\N	\N	\N	\N	193278	193278	360456
25578	40334	1	applied	\N	\N	\N	\N	193279	193279	360457
25578	40335	2	applied	\N	\N	\N	\N	193280	193280	360458
25583	40336	0	applied	\N	\N	\N	\N	193287	193287	360465
25583	40337	1	applied	\N	\N	\N	\N	193288	193288	360466
25583	40338	2	applied	\N	\N	\N	\N	193289	193289	360467
25592	40356	0	applied	\N	\N	\N	\N	193325	193325	360503
25592	40357	1	applied	\N	\N	\N	\N	193326	193326	360504
25592	40358	2	applied	\N	\N	\N	\N	193327	193327	360505
25592	40359	3	applied	\N	\N	\N	\N	193328	193328	360506
25599	40363	0	applied	\N	\N	\N	\N	193336	193336	360514
25599	40364	1	applied	\N	\N	\N	\N	193337	193337	360515
25599	40365	2	applied	\N	\N	\N	\N	193338	193338	360516
25605	40378	0	applied	\N	\N	\N	\N	193369	193369	360547
25556	40094	71	applied	\N	\N	\N	\N	193104	193104	360282
25556	40105	72	applied	\N	\N	\N	\N	193105	193105	360283
25574	40320	6	applied	\N	\N	\N	\N	193247	193247	360425
25574	40321	7	applied	\N	\N	\N	\N	193248	193248	360426
25574	40322	8	applied	\N	\N	\N	\N	193249	193249	360427
25574	40323	9	applied	\N	\N	\N	\N	193250	193250	360428
25577	40333	0	applied	\N	\N	\N	\N	193275	193275	360453
25577	40334	1	applied	\N	\N	\N	\N	193276	193276	360454
25577	40335	2	applied	\N	\N	\N	\N	193277	193277	360455
25579	40333	0	applied	\N	\N	\N	\N	193281	193281	360459
25579	40334	1	applied	\N	\N	\N	\N	193282	193282	360460
25579	40335	2	applied	\N	\N	\N	\N	193283	193283	360461
25586	40151	0	applied	\N	\N	\N	\N	193290	193290	360468
25586	40112	1	applied	\N	\N	\N	\N	193291	193291	360469
25586	40122	2	applied	\N	\N	\N	\N	193292	193292	360470
25591	40354	0	applied	\N	\N	\N	\N	193323	193323	360501
25591	40355	1	applied	\N	\N	\N	\N	193324	193324	360502
25600	40366	0	applied	\N	\N	\N	\N	193339	193339	360517
25600	40368	2	applied	\N	\N	\N	\N	193341	193341	360519
25600	40369	3	applied	\N	\N	\N	\N	193342	193342	360520
25600	40370	4	applied	\N	\N	\N	\N	193343	193343	360521
25600	40371	5	applied	\N	\N	\N	\N	193344	193344	360522
25603	40378	0	applied	\N	\N	\N	\N	193357	193357	360535
25603	40379	1	applied	\N	\N	\N	\N	193358	193358	360536
25603	40380	2	applied	\N	\N	\N	\N	193359	193359	360537
25603	40381	3	applied	\N	\N	\N	\N	193360	193360	360538
25603	40382	4	applied	\N	\N	\N	\N	193361	193361	360539
25603	40383	5	applied	\N	\N	\N	\N	193362	193362	360540
25605	40379	1	applied	\N	\N	\N	\N	193370	193370	360548
25605	40380	2	applied	\N	\N	\N	\N	193371	193371	360549
25605	40381	3	applied	\N	\N	\N	\N	193372	193372	360550
25605	40382	4	applied	\N	\N	\N	\N	193373	193373	360551
25605	40383	5	applied	\N	\N	\N	\N	193374	193374	360552
25608	40387	0	applied	\N	\N	\N	\N	193378	193378	360556
25608	40389	2	applied	\N	\N	\N	\N	193380	193380	360558
25608	40390	3	applied	\N	\N	\N	\N	193381	193381	360559
25610	40393	0	applied	\N	\N	\N	\N	193388	193388	360566
25610	40394	1	applied	\N	\N	\N	\N	193389	193389	360567
25610	40391	2	applied	\N	\N	\N	\N	193390	193390	360568
25610	40392	3	applied	\N	\N	\N	\N	193391	193391	360569
25610	40395	4	applied	\N	\N	\N	\N	193392	193392	360570
25611	40393	0	applied	\N	\N	\N	\N	193393	193393	360571
25611	40394	1	applied	\N	\N	\N	\N	193394	193394	360572
25611	40391	2	applied	\N	\N	\N	\N	193395	193395	360573
25611	40392	3	applied	\N	\N	\N	\N	193396	193396	360574
25611	40395	4	applied	\N	\N	\N	\N	193397	193397	360575
25612	40396	0	applied	\N	\N	\N	\N	193398	193398	360576
25612	40397	1	applied	\N	\N	\N	\N	193399	193399	360577
25612	40398	2	applied	\N	\N	\N	\N	193400	193400	360578
25613	40396	0	applied	\N	\N	\N	\N	193401	193401	360579
25613	40398	2	applied	\N	\N	\N	\N	193403	193403	360581
25616	40399	0	applied	\N	\N	\N	\N	193410	193410	360588
25616	40400	1	applied	\N	\N	\N	\N	193411	193411	360589
25616	40401	2	applied	\N	\N	\N	\N	193412	193412	360590
25617	40399	0	applied	\N	\N	\N	\N	193413	193413	360591
25617	40400	1	applied	\N	\N	\N	\N	193414	193414	360592
25617	40401	2	applied	\N	\N	\N	\N	193415	193415	360593
25618	40399	0	applied	\N	\N	\N	\N	193416	193416	360594
25618	40400	1	applied	\N	\N	\N	\N	193417	193417	360595
25618	40401	2	applied	\N	\N	\N	\N	193418	193418	360596
25619	40402	0	applied	\N	\N	\N	\N	193419	193419	360597
25619	40403	1	applied	\N	\N	\N	\N	193420	193420	360598
25619	40404	2	applied	\N	\N	\N	\N	193421	193421	360599
25619	40405	3	applied	\N	\N	\N	\N	193422	193422	360600
25619	40406	4	applied	\N	\N	\N	\N	193423	193423	360601
25619	40407	5	applied	\N	\N	\N	\N	193424	193424	360602
25622	40415	0	applied	\N	\N	\N	\N	193432	193432	360610
25622	40416	1	applied	\N	\N	\N	\N	193433	193433	360611
25623	40417	0	applied	\N	\N	\N	\N	193434	193434	360612
25623	40418	1	applied	\N	\N	\N	\N	193435	193435	360613
25623	40415	2	applied	\N	\N	\N	\N	193436	193436	360614
25623	40419	3	applied	\N	\N	\N	\N	193437	193437	360615
25623	40420	4	applied	\N	\N	\N	\N	193438	193438	360616
25623	40416	5	applied	\N	\N	\N	\N	193439	193439	360617
25628	40427	0	applied	\N	\N	\N	\N	193480	193480	360658
25628	40428	1	applied	\N	\N	\N	\N	193481	193481	360659
25628	40429	2	applied	\N	\N	\N	\N	193482	193482	360660
25628	40430	3	applied	\N	\N	\N	\N	193483	193483	360661
25628	40431	4	applied	\N	\N	\N	\N	193484	193484	360662
25628	40432	5	applied	\N	\N	\N	\N	193485	193485	360663
25630	40438	0	applied	\N	\N	\N	\N	193491	193491	360669
25630	40439	1	applied	\N	\N	\N	\N	193492	193492	360670
25633	40447	0	applied	\N	\N	\N	\N	193506	193506	360684
25633	40448	1	applied	\N	\N	\N	\N	193507	193507	360685
25633	40449	2	applied	\N	\N	\N	\N	193508	193508	360686
25633	40450	3	applied	\N	\N	\N	\N	193509	193509	360687
25633	40451	4	applied	\N	\N	\N	\N	193510	193510	360688
25633	40452	5	applied	\N	\N	\N	\N	193511	193511	360689
25634	40453	0	applied	\N	\N	\N	\N	193512	193512	360690
25634	40454	1	applied	\N	\N	\N	\N	193513	193513	360691
25634	40455	2	applied	\N	\N	\N	\N	193514	193514	360692
25635	40453	0	applied	\N	\N	\N	\N	193524	193524	360702
25635	40454	1	applied	\N	\N	\N	\N	193525	193525	360703
25635	40455	2	applied	\N	\N	\N	\N	193526	193526	360704
25635	40456	3	applied	\N	\N	\N	\N	193527	193527	360705
25635	40457	4	applied	\N	\N	\N	\N	193528	193528	360706
25635	40458	5	applied	\N	\N	\N	\N	193529	193529	360707
25635	40459	6	applied	\N	\N	\N	\N	193530	193530	360708
25635	40461	8	applied	\N	\N	\N	\N	193532	193532	360710
25635	40462	9	applied	\N	\N	\N	\N	193533	193533	360711
25635	40463	10	applied	\N	\N	\N	\N	193534	193534	360712
25635	40464	11	applied	\N	\N	\N	\N	193535	193535	360713
25637	40465	0	applied	\N	\N	\N	\N	193539	193539	360717
25637	40466	1	applied	\N	\N	\N	\N	193540	193540	360718
25637	40467	2	applied	\N	\N	\N	\N	193541	193541	360719
25644	40474	0	applied	\N	\N	\N	\N	193679	193679	360857
25644	40475	1	applied	\N	\N	\N	\N	193680	193680	360858
25644	40476	2	applied	\N	\N	\N	\N	193681	193681	360859
25644	40477	3	applied	\N	\N	\N	\N	193682	193682	360860
25644	40478	4	applied	\N	\N	\N	\N	193683	193683	360861
25644	40479	5	applied	\N	\N	\N	\N	193684	193684	360862
25647	40486	0	applied	\N	\N	\N	\N	193697	193697	360875
25574	40317	2	applied	\N	\N	\N	\N	193244	193244	360422
25574	40318	4	applied	\N	\N	\N	\N	193245	193245	360423
25626	40425	8	applied	\N	\N	\N	\N	193468	193468	360646
25626	40426	9	applied	\N	\N	\N	\N	193469	193469	360647
25629	40433	0	applied	\N	\N	\N	\N	193486	193486	360664
25629	40434	1	applied	\N	\N	\N	\N	193487	193487	360665
25629	40435	2	applied	\N	\N	\N	\N	193488	193488	360666
25629	40436	3	applied	\N	\N	\N	\N	193489	193489	360667
25629	40437	4	applied	\N	\N	\N	\N	193490	193490	360668
25632	40441	0	applied	\N	\N	\N	\N	193500	193500	360678
25632	40442	1	applied	\N	\N	\N	\N	193501	193501	360679
25632	40443	2	applied	\N	\N	\N	\N	193502	193502	360680
25632	40444	3	applied	\N	\N	\N	\N	193503	193503	360681
25632	40445	4	applied	\N	\N	\N	\N	193504	193504	360682
25634	40456	3	applied	\N	\N	\N	\N	193515	193515	360693
25634	40457	4	applied	\N	\N	\N	\N	193516	193516	360694
25634	40458	5	applied	\N	\N	\N	\N	193517	193517	360695
25634	40459	6	applied	\N	\N	\N	\N	193518	193518	360696
25634	40460	7	applied	\N	\N	\N	\N	193519	193519	360697
25634	40461	8	applied	\N	\N	\N	\N	193520	193520	360698
25634	40462	9	applied	\N	\N	\N	\N	193521	193521	360699
25634	40463	10	applied	\N	\N	\N	\N	193522	193522	360700
25634	40464	11	applied	\N	\N	\N	\N	193523	193523	360701
25636	40465	0	applied	\N	\N	\N	\N	193536	193536	360714
25636	40466	1	applied	\N	\N	\N	\N	193537	193537	360715
25636	40467	2	applied	\N	\N	\N	\N	193538	193538	360716
25638	40465	0	applied	\N	\N	\N	\N	193542	193542	360720
25638	40466	1	applied	\N	\N	\N	\N	193543	193543	360721
25638	40467	2	applied	\N	\N	\N	\N	193544	193544	360722
25640	40471	0	applied	\N	\N	\N	\N	193548	193548	360726
25640	40473	2	applied	\N	\N	\N	\N	193550	193550	360728
25642	40471	0	applied	\N	\N	\N	\N	193554	193554	360732
25642	40472	1	applied	\N	\N	\N	\N	193555	193555	360733
25642	40473	2	applied	\N	\N	\N	\N	193556	193556	360734
25645	40474	0	applied	\N	\N	\N	\N	193685	193685	360863
25645	40475	1	applied	\N	\N	\N	\N	193686	193686	360864
25645	40476	2	applied	\N	\N	\N	\N	193687	193687	360865
25645	40477	3	applied	\N	\N	\N	\N	193688	193688	360866
25645	40478	4	applied	\N	\N	\N	\N	193689	193689	360867
25645	40479	5	applied	\N	\N	\N	\N	193690	193690	360868
25648	40486	0	applied	\N	\N	\N	\N	193700	193700	360878
25648	40487	1	applied	\N	\N	\N	\N	193701	193701	360879
25648	40488	2	applied	\N	\N	\N	\N	193702	193702	360880
25650	40489	0	applied	\N	\N	\N	\N	193706	193706	360884
25650	40490	1	applied	\N	\N	\N	\N	193707	193707	360885
25650	40492	3	applied	\N	\N	\N	\N	193709	193709	360887
25652	40489	0	applied	\N	\N	\N	\N	193713	193713	360891
25652	40490	1	applied	\N	\N	\N	\N	193714	193714	360892
25652	40491	2	applied	\N	\N	1000000000	\N	193715	193715	360893
25652	40492	3	applied	\N	\N	\N	\N	193716	193716	360894
25654	40493	0	applied	\N	\N	\N	\N	193718	193718	360896
25654	40494	1	applied	\N	\N	\N	\N	193719	193719	360897
25657	40498	0	applied	\N	\N	\N	\N	193729	193729	360907
25657	40499	1	applied	\N	\N	\N	\N	193730	193730	360908
25657	40500	3	applied	\N	\N	\N	\N	193731	193731	360909
25657	40501	4	applied	\N	\N	\N	\N	193732	193732	360910
25657	40502	5	applied	\N	\N	\N	\N	193733	193733	360911
25657	40503	6	applied	\N	\N	\N	\N	193734	193734	360912
25659	40504	0	applied	\N	\N	\N	\N	193741	193741	360919
25659	40505	1	applied	\N	\N	\N	\N	193742	193742	360920
25659	40506	2	applied	\N	\N	\N	\N	193743	193743	360921
25659	40507	3	applied	\N	\N	\N	\N	193744	193744	360922
25659	40508	4	applied	\N	\N	\N	\N	193745	193745	360923
25659	40509	5	applied	\N	\N	\N	\N	193746	193746	360924
25660	40511	0	applied	\N	\N	\N	\N	193748	193748	360926
25660	40512	1	applied	\N	\N	\N	\N	193749	193749	360927
25660	40513	2	applied	\N	\N	\N	\N	193750	193750	360928
25660	40514	3	applied	\N	\N	\N	\N	193751	193751	360929
25660	40515	4	applied	\N	\N	\N	\N	193752	193752	360930
25660	40516	5	applied	\N	\N	\N	\N	193753	193753	360931
25660	40517	6	applied	\N	\N	\N	\N	193754	193754	360932
25660	40518	7	applied	\N	\N	\N	\N	193755	193755	360933
25660	40519	8	applied	\N	\N	\N	\N	193756	193756	360934
25660	40520	9	applied	\N	\N	\N	\N	193757	193757	360935
25660	40521	10	applied	\N	\N	\N	\N	193758	193758	360936
25660	40522	11	applied	\N	\N	\N	\N	193759	193759	360937
25661	40523	0	applied	\N	\N	\N	\N	193760	193760	360938
25661	40524	1	applied	\N	\N	\N	\N	193761	193761	360939
25661	40525	2	applied	\N	\N	\N	\N	193762	193762	360940
25661	40526	3	applied	\N	\N	\N	\N	193763	193763	360941
25661	40528	5	applied	\N	\N	\N	\N	193765	193765	360943
25663	40529	0	applied	\N	\N	\N	\N	193769	193769	360947
25663	40530	1	applied	\N	\N	\N	\N	193770	193770	360948
25665	40532	0	applied	\N	\N	\N	\N	193774	193774	360952
25665	40533	1	applied	\N	\N	\N	\N	193775	193775	360953
25668	40535	0	applied	\N	\N	\N	\N	193782	193782	360960
25668	40536	1	applied	\N	\N	\N	\N	193783	193783	360961
25668	40537	2	applied	\N	\N	\N	\N	193784	193784	360962
25670	40538	0	applied	\N	\N	\N	\N	193788	193788	360966
25670	40539	1	applied	\N	\N	\N	\N	193789	193789	360967
25670	40540	2	applied	\N	\N	\N	\N	193790	193790	360968
25672	40541	0	applied	\N	\N	\N	\N	193794	193794	360972
25672	40542	1	applied	\N	\N	\N	\N	193795	193795	360973
25674	40544	0	applied	\N	\N	\N	\N	193799	193799	360977
25674	40545	1	applied	\N	\N	\N	\N	193800	193800	360978
25674	40546	2	applied	\N	\N	\N	\N	193801	193801	360979
25675	40545	1	applied	\N	\N	\N	\N	193803	193803	360981
25675	40546	2	applied	\N	\N	\N	\N	193804	193804	360982
25678	40544	0	applied	\N	\N	\N	\N	193810	193810	360988
25678	40545	1	applied	\N	\N	\N	\N	193811	193811	360989
25678	40543	2	applied	\N	\N	\N	\N	193812	193812	360990
25678	40546	3	applied	\N	\N	\N	\N	193813	193813	360991
25679	40547	0	applied	\N	\N	\N	\N	193814	193814	360992
25679	40548	1	applied	\N	\N	\N	\N	193815	193815	360993
25679	40549	2	applied	\N	\N	\N	\N	193816	193816	360994
25679	40550	3	applied	\N	\N	\N	\N	193817	193817	360995
25679	40551	4	applied	\N	\N	\N	\N	193818	193818	360996
25679	40552	5	applied	\N	\N	\N	\N	193819	193819	360997
25680	40547	0	applied	\N	\N	\N	\N	193820	193820	360998
25680	40548	1	applied	\N	\N	\N	\N	193821	193821	360999
25682	40547	0	applied	\N	\N	\N	\N	193836	193836	361014
25626	40424	5	applied	\N	\N	\N	\N	193465	193465	360643
25626	40420	7	applied	\N	\N	\N	\N	193467	193467	360645
25643	40307	11	applied	\N	\N	\N	\N	193568	193568	360746
25643	40312	12	applied	\N	\N	\N	\N	193569	193569	360747
25643	40315	13	applied	\N	\N	\N	\N	193570	193570	360748
25643	40316	14	applied	\N	\N	\N	\N	193571	193571	360749
25643	40317	15	applied	\N	\N	\N	\N	193572	193572	360750
25643	40324	16	applied	\N	\N	\N	\N	193573	193573	360751
25643	40325	17	applied	\N	\N	\N	\N	193574	193574	360752
25643	40326	18	applied	\N	\N	\N	\N	193575	193575	360753
25643	40333	19	applied	\N	\N	\N	\N	193576	193576	360754
25643	40336	20	applied	\N	\N	\N	\N	193577	193577	360755
25643	40339	21	applied	\N	\N	\N	\N	193578	193578	360756
25643	40340	22	applied	\N	\N	\N	\N	193579	193579	360757
25643	40341	23	applied	\N	\N	\N	\N	193580	193580	360758
25643	40342	24	applied	\N	\N	\N	\N	193581	193581	360759
25643	40351	25	applied	\N	\N	\N	\N	193582	193582	360760
25643	40354	26	applied	\N	\N	\N	\N	193583	193583	360761
25643	40360	28	applied	\N	\N	\N	\N	193585	193585	360763
25643	40363	29	applied	\N	\N	\N	\N	193586	193586	360764
25643	40366	30	applied	\N	\N	\N	\N	193587	193587	360765
25643	40367	31	applied	\N	\N	\N	\N	193588	193588	360766
25643	40372	32	applied	\N	\N	\N	\N	193589	193589	360767
25643	40373	33	applied	\N	\N	\N	\N	193590	193590	360768
25643	40378	34	applied	\N	\N	\N	\N	193591	193591	360769
25643	40379	35	applied	\N	\N	\N	\N	193592	193592	360770
25643	40384	36	applied	\N	\N	\N	\N	193593	193593	360771
25643	40387	37	applied	\N	\N	\N	\N	193594	193594	360772
25643	40388	38	applied	\N	\N	\N	\N	193595	193595	360773
25643	40393	39	applied	\N	\N	\N	\N	193596	193596	360774
25643	40396	40	applied	\N	\N	\N	\N	193597	193597	360775
25643	40399	41	applied	\N	\N	\N	\N	193598	193598	360776
25643	40402	42	applied	\N	\N	\N	\N	193599	193599	360777
25643	40403	43	applied	\N	\N	\N	\N	193600	193600	360778
25643	40410	45	applied	\N	\N	\N	\N	193602	193602	360780
25643	40417	46	applied	\N	\N	\N	\N	193603	193603	360781
25643	40418	47	applied	\N	\N	\N	\N	193604	193604	360782
25643	40421	48	applied	\N	\N	\N	\N	193605	193605	360783
25643	40422	49	applied	\N	\N	\N	\N	193606	193606	360784
25643	40427	50	applied	\N	\N	\N	\N	193607	193607	360785
25643	40428	51	applied	\N	\N	\N	\N	193608	193608	360786
25643	40433	52	applied	\N	\N	\N	\N	193609	193609	360787
25643	40434	53	applied	\N	\N	\N	\N	193610	193610	360788
25643	40438	54	applied	\N	\N	\N	\N	193611	193611	360789
25643	40441	55	applied	\N	\N	\N	\N	193612	193612	360790
25643	40442	56	applied	\N	\N	\N	\N	193613	193613	360791
25643	40447	57	applied	\N	\N	\N	\N	193614	193614	360792
25643	40448	58	applied	\N	\N	\N	\N	193615	193615	360793
25643	40453	59	applied	\N	\N	\N	\N	193616	193616	360794
25643	40454	60	applied	\N	\N	\N	\N	193617	193617	360795
25643	40456	62	applied	\N	\N	\N	\N	193619	193619	360797
25643	40465	63	applied	\N	\N	\N	\N	193620	193620	360798
25643	40468	64	applied	\N	\N	\N	\N	193621	193621	360799
25643	40471	65	applied	\N	\N	\N	\N	193622	193622	360800
25643	40404	66	applied	\N	\N	\N	\N	193623	193623	360801
25643	40277	67	applied	\N	\N	\N	\N	193624	193624	360802
25643	40282	68	applied	\N	\N	\N	\N	193625	193625	360803
25643	40283	69	applied	\N	\N	\N	\N	193626	193626	360804
25643	40286	70	applied	\N	\N	\N	\N	193627	193627	360805
25643	40290	71	applied	\N	\N	\N	\N	193628	193628	360806
25643	40291	72	applied	\N	\N	\N	\N	193629	193629	360807
25643	40278	73	applied	\N	\N	\N	\N	193630	193630	360808
25643	40281	74	applied	\N	\N	\N	\N	193631	193631	360809
25643	40296	75	applied	\N	\N	\N	\N	193632	193632	360810
25643	40303	76	applied	\N	\N	\N	\N	193633	193633	360811
25682	40548	1	applied	\N	\N	\N	\N	193837	193837	361015
25682	40546	3	applied	\N	\N	\N	\N	193839	193839	361017
25682	40553	4	applied	\N	\N	\N	\N	193840	193840	361018
25682	40554	5	applied	\N	\N	\N	\N	193841	193841	361019
25682	40555	6	applied	\N	\N	\N	\N	193842	193842	361020
25682	40550	7	applied	\N	\N	\N	\N	193843	193843	361021
25682	40551	8	applied	\N	\N	\N	\N	193844	193844	361022
25682	40552	9	applied	\N	\N	\N	\N	193845	193845	361023
25683	40547	0	applied	\N	\N	\N	\N	193846	193846	361024
25683	40548	1	applied	\N	\N	\N	\N	193847	193847	361025
25683	40549	2	applied	\N	\N	\N	\N	193848	193848	361026
25683	40546	3	applied	\N	\N	\N	\N	193849	193849	361027
25683	40553	4	applied	\N	\N	\N	\N	193850	193850	361028
25683	40554	5	applied	\N	\N	\N	\N	193851	193851	361029
25683	40555	6	applied	\N	\N	\N	\N	193852	193852	361030
25683	40550	7	applied	\N	\N	\N	\N	193853	193853	361031
25683	40551	8	applied	\N	\N	\N	\N	193854	193854	361032
25688	40565	0	applied	\N	\N	\N	\N	193877	193877	361055
25688	40566	1	applied	\N	\N	\N	\N	193878	193878	361056
25696	40036	0	applied	\N	\N	\N	\N	193910	193910	361088
25698	40589	0	applied	\N	\N	\N	\N	193914	193914	361092
25698	40590	2	applied	\N	\N	\N	\N	193915	193915	361093
25698	40591	3	applied	\N	\N	\N	\N	193916	193916	361094
25700	40592	0	applied	\N	\N	\N	\N	193920	193920	361098
25700	40593	1	applied	\N	\N	\N	\N	193921	193921	361099
25700	40594	2	applied	\N	\N	\N	\N	193922	193922	361100
25703	40404	0	applied	\N	\N	\N	\N	193929	193929	361107
25703	40583	1	applied	\N	\N	\N	\N	193930	193930	361108
25712	40608	0	applied	\N	\N	\N	\N	193968	193968	361146
25712	40609	1	applied	\N	\N	\N	\N	193969	193969	361147
25712	40610	2	applied	\N	\N	\N	\N	193970	193970	361148
25712	40611	3	applied	\N	\N	\N	\N	193971	193971	361149
25712	40612	4	applied	\N	\N	\N	\N	193972	193972	361150
25714	40608	0	applied	\N	\N	\N	\N	193983	193983	361161
25714	40609	1	applied	\N	\N	\N	\N	193984	193984	361162
25714	40610	2	applied	\N	\N	\N	\N	193985	193985	361163
25714	40611	3	applied	\N	\N	\N	\N	193986	193986	361164
25714	40614	4	applied	\N	\N	\N	\N	193987	193987	361165
25714	40615	5	applied	\N	\N	\N	\N	193988	193988	361166
25714	40616	6	applied	\N	\N	\N	\N	193989	193989	361167
25714	40612	7	applied	\N	\N	\N	\N	193990	193990	361168
25714	40613	8	applied	\N	\N	\N	\N	193991	193991	361169
25721	40626	0	applied	\N	\N	\N	\N	194016	194016	361194
25721	40627	1	applied	\N	\N	\N	\N	194017	194017	361195
25721	40628	2	applied	\N	\N	\N	\N	194018	194018	361196
25724	40635	0	applied	\N	\N	\N	\N	194031	194031	361209
25724	40636	1	applied	\N	\N	\N	\N	194032	194032	361210
25643	40298	8	applied	\N	\N	\N	\N	193565	193565	360743
25643	40299	9	applied	\N	\N	\N	\N	193566	193566	360744
25643	40293	81	applied	\N	\N	\N	\N	193638	193638	360816
25643	40295	82	applied	\N	\N	\N	\N	193639	193639	360817
25643	40300	83	applied	\N	\N	\N	\N	193640	193640	360818
25643	40301	84	applied	\N	\N	\N	\N	193641	193641	360819
25643	40302	85	applied	\N	\N	\N	\N	193642	193642	360820
25643	40310	86	applied	\N	\N	\N	\N	193643	193643	360821
25643	40305	87	applied	\N	\N	\N	\N	193644	193644	360822
25643	40308	88	applied	\N	\N	\N	\N	193645	193645	360823
25643	40309	89	applied	\N	\N	\N	\N	193646	193646	360824
25643	40313	90	applied	\N	\N	\N	\N	193647	193647	360825
25643	40318	91	applied	\N	\N	\N	\N	193648	193648	360826
25643	40319	92	applied	\N	\N	\N	\N	193649	193649	360827
25643	40322	93	applied	\N	\N	\N	\N	193650	193650	360828
25643	40311	94	applied	\N	\N	\N	\N	193651	193651	360829
25643	40314	95	applied	\N	\N	\N	\N	193652	193652	360830
25643	40320	97	applied	\N	\N	\N	\N	193653	193653	360831
25643	40323	99	applied	\N	\N	\N	\N	193655	193655	360833
25643	40327	100	applied	\N	\N	\N	\N	193656	193656	360834
25643	40328	101	applied	\N	\N	\N	\N	193657	193657	360835
25643	40329	102	applied	\N	\N	\N	\N	193658	193658	360836
25643	40334	103	applied	\N	\N	\N	\N	193659	193659	360837
25643	40338	104	applied	\N	\N	\N	\N	193660	193660	360838
25643	40345	105	applied	\N	\N	\N	\N	193661	193661	360839
25643	40348	106	applied	\N	\N	\N	\N	193662	193662	360840
25643	40349	107	applied	\N	\N	\N	\N	193663	193663	360841
25643	40350	108	applied	\N	\N	\N	\N	193664	193664	360842
25643	40352	109	applied	\N	\N	\N	\N	193665	193665	360843
25643	40357	110	applied	\N	\N	\N	\N	193666	193666	360844
25643	40359	111	applied	\N	\N	\N	\N	193667	193667	360845
25643	40362	112	applied	\N	\N	\N	\N	193668	193668	360846
25643	40365	113	applied	\N	\N	\N	\N	193669	193669	360847
25643	40369	114	applied	\N	\N	\N	\N	193670	193670	360848
25643	40374	116	applied	\N	\N	\N	\N	193672	193672	360850
25643	40377	117	applied	\N	\N	\N	\N	193673	193673	360851
25643	40382	118	applied	\N	\N	\N	\N	193674	193674	360852
25643	40383	119	applied	\N	\N	\N	\N	193675	193675	360853
25643	40386	120	applied	\N	\N	\N	\N	193676	193676	360854
25643	40391	121	applied	\N	\N	\N	\N	193677	193677	360855
25643	40392	122	applied	\N	\N	\N	\N	193678	193678	360856
25646	40480	0	applied	\N	\N	\N	\N	193691	193691	360869
25646	40481	1	applied	\N	\N	\N	\N	193692	193692	360870
25646	40482	2	applied	\N	\N	\N	\N	193693	193693	360871
25646	40483	3	applied	\N	\N	\N	\N	193694	193694	360872
25646	40484	4	applied	\N	\N	\N	\N	193695	193695	360873
25646	40485	5	applied	\N	\N	\N	\N	193696	193696	360874
25653	40493	0	applied	\N	\N	\N	\N	193717	193717	360895
25655	40495	0	applied	\N	\N	\N	\N	193720	193720	360898
25655	40496	1	applied	\N	\N	\N	\N	193721	193721	360899
25658	40498	0	applied	\N	\N	\N	\N	193735	193735	360913
25658	40499	1	applied	\N	\N	\N	\N	193736	193736	360914
25658	40500	3	applied	\N	\N	\N	\N	193737	193737	360915
25658	40501	4	applied	\N	\N	\N	\N	193738	193738	360916
25658	40502	5	applied	\N	\N	\N	\N	193739	193739	360917
25658	40503	6	applied	\N	\N	\N	\N	193740	193740	360918
25662	40529	0	applied	\N	\N	\N	\N	193766	193766	360944
25662	40530	1	applied	\N	\N	\N	\N	193767	193767	360945
25662	40531	2	applied	\N	\N	\N	\N	193768	193768	360946
25664	40529	0	applied	\N	\N	\N	\N	193771	193771	360949
25664	40530	1	applied	\N	\N	\N	\N	193772	193772	360950
25664	40531	2	applied	\N	\N	\N	\N	193773	193773	360951
25666	40532	0	applied	\N	\N	\N	\N	193776	193776	360954
25666	40534	1	applied	\N	\N	\N	\N	193777	193777	360955
25666	40533	2	applied	\N	\N	\N	\N	193778	193778	360956
25671	40541	0	applied	\N	\N	\N	\N	193791	193791	360969
25671	40543	2	applied	\N	\N	\N	\N	193793	193793	360971
25673	40541	0	applied	\N	\N	\N	\N	193796	193796	360974
25673	40542	1	applied	\N	\N	\N	\N	193797	193797	360975
25673	40543	2	applied	\N	\N	\N	\N	193798	193798	360976
25676	40544	0	applied	\N	\N	\N	\N	193805	193805	360983
25676	40545	1	applied	\N	\N	\N	\N	193806	193806	360984
25684	40556	0	applied	\N	\N	\N	\N	193856	193856	361034
25684	40557	1	applied	\N	\N	\N	\N	193857	193857	361035
25684	40558	2	applied	\N	\N	\N	\N	193858	193858	361036
25689	40567	0	applied	\N	\N	\N	\N	193879	193879	361057
25689	40568	1	applied	\N	\N	\N	\N	193880	193880	361058
25689	40569	2	applied	\N	\N	\N	\N	193881	193881	361059
25697	40589	0	applied	\N	\N	\N	\N	193911	193911	361089
25697	40590	2	applied	\N	\N	\N	\N	193912	193912	361090
25697	40591	3	applied	\N	\N	\N	\N	193913	193913	361091
25699	40592	0	applied	\N	\N	\N	\N	193917	193917	361095
25699	40594	2	applied	\N	\N	\N	\N	193919	193919	361097
25701	40592	0	applied	\N	\N	\N	\N	193923	193923	361101
25701	40594	1	applied	\N	\N	\N	\N	193924	193924	361102
25706	40598	0	applied	\N	\N	\N	\N	193938	193938	361116
25706	40599	1	applied	\N	\N	\N	\N	193939	193939	361117
25706	40600	2	applied	\N	\N	\N	\N	193940	193940	361118
25708	40598	0	applied	\N	\N	\N	\N	193944	193944	361122
25708	40599	1	applied	\N	\N	\N	\N	193945	193945	361123
25708	40600	2	applied	\N	\N	\N	\N	193946	193946	361124
25713	40608	0	applied	\N	\N	\N	\N	193974	193974	361152
25713	40609	1	applied	\N	\N	\N	\N	193975	193975	361153
25713	40610	2	applied	\N	\N	\N	\N	193976	193976	361154
25713	40611	3	applied	\N	\N	\N	\N	193977	193977	361155
25713	40614	4	applied	\N	\N	\N	\N	193978	193978	361156
25713	40615	5	applied	\N	\N	\N	\N	193979	193979	361157
25713	40616	6	applied	\N	\N	\N	\N	193980	193980	361158
25713	40613	8	applied	\N	\N	\N	\N	193982	193982	361160
25715	40608	0	applied	\N	\N	\N	\N	193992	193992	361170
25715	40609	1	applied	\N	\N	\N	\N	193993	193993	361171
25715	40610	2	applied	\N	\N	\N	\N	193994	193994	361172
25715	40611	3	applied	\N	\N	\N	\N	193995	193995	361173
25715	40614	4	applied	\N	\N	\N	\N	193996	193996	361174
25715	40615	5	applied	\N	\N	\N	\N	193997	193997	361175
25715	40616	6	applied	\N	\N	\N	\N	193998	193998	361176
25715	40612	7	applied	\N	\N	\N	\N	193999	193999	361177
25715	40613	8	applied	\N	\N	\N	\N	194000	194000	361178
25720	40623	0	applied	\N	\N	\N	\N	194013	194013	361191
25720	40624	1	applied	\N	\N	\N	\N	194014	194014	361192
25720	40625	2	applied	\N	\N	\N	\N	194015	194015	361193
25725	40638	0	applied	\N	\N	\N	\N	194034	194034	361212
25643	40284	78	applied	\N	\N	\N	\N	193635	193635	360813
25643	40287	79	applied	\N	\N	\N	\N	193636	193636	360814
25649	40487	1	applied	\N	\N	\N	\N	193704	193704	360882
25649	40488	2	applied	\N	\N	\N	\N	193705	193705	360883
25651	40489	0	applied	\N	\N	\N	\N	193710	193710	360888
25651	40491	1	applied	\N	\N	1000000000	\N	193711	193711	360889
25651	40492	2	applied	\N	\N	\N	\N	193712	193712	360890
25656	40498	0	applied	\N	\N	\N	\N	193723	193723	360901
25656	40499	1	applied	\N	\N	\N	\N	193724	193724	360902
25656	40500	3	applied	\N	\N	\N	\N	193725	193725	360903
25656	40501	4	applied	\N	\N	\N	\N	193726	193726	360904
25656	40502	5	applied	\N	\N	\N	\N	193727	193727	360905
25656	40503	6	applied	\N	\N	\N	\N	193728	193728	360906
25667	40535	0	applied	\N	\N	\N	\N	193779	193779	360957
25667	40536	1	applied	\N	\N	\N	\N	193780	193780	360958
25669	40535	0	applied	\N	\N	\N	\N	193785	193785	360963
25669	40536	1	applied	\N	\N	\N	\N	193786	193786	360964
25669	40537	2	applied	\N	\N	\N	\N	193787	193787	360965
25677	40544	0	applied	\N	\N	\N	\N	193807	193807	360985
25677	40545	1	applied	\N	\N	\N	\N	193808	193808	360986
25677	40546	2	applied	\N	\N	\N	\N	193809	193809	360987
25681	40547	0	applied	\N	\N	\N	\N	193826	193826	361004
25681	40548	1	applied	\N	\N	\N	\N	193827	193827	361005
25681	40549	2	applied	\N	\N	\N	\N	193828	193828	361006
25681	40546	3	applied	\N	\N	\N	\N	193829	193829	361007
25681	40553	4	applied	\N	\N	\N	\N	193830	193830	361008
25681	40554	5	applied	\N	\N	\N	\N	193831	193831	361009
25681	40555	6	applied	\N	\N	\N	\N	193832	193832	361010
25681	40550	7	applied	\N	\N	\N	\N	193833	193833	361011
25681	40551	8	applied	\N	\N	\N	\N	193834	193834	361012
25681	40552	9	applied	\N	\N	\N	\N	193835	193835	361013
25685	40560	1	applied	\N	\N	\N	\N	193860	193860	361038
25685	40561	2	applied	\N	\N	\N	\N	193861	193861	361039
25685	40562	3	applied	\N	\N	\N	\N	193862	193862	361040
25685	40563	4	applied	\N	\N	\N	\N	193863	193863	361041
25685	40564	5	applied	\N	\N	\N	\N	193864	193864	361042
25687	40559	0	applied	\N	\N	\N	\N	193871	193871	361049
25687	40560	1	applied	\N	\N	\N	\N	193872	193872	361050
25687	40561	2	applied	\N	\N	\N	\N	193873	193873	361051
25687	40562	3	applied	\N	\N	\N	\N	193874	193874	361052
25687	40563	4	applied	\N	\N	\N	\N	193875	193875	361053
25687	40564	5	applied	\N	\N	\N	\N	193876	193876	361054
25690	40567	0	applied	\N	\N	\N	\N	193882	193882	361060
25690	40568	1	applied	\N	\N	\N	\N	193883	193883	361061
25690	40569	2	applied	\N	\N	\N	\N	193884	193884	361062
25693	40586	0	applied	\N	\N	\N	\N	193901	193901	361079
25693	40587	1	applied	\N	\N	\N	\N	193902	193902	361080
25695	40586	0	applied	\N	\N	\N	\N	193907	193907	361085
25695	40587	1	applied	\N	\N	\N	\N	193908	193908	361086
25695	40588	2	applied	\N	\N	\N	\N	193909	193909	361087
25702	40595	0	applied	\N	\N	\N	\N	193925	193925	361103
25702	40593	1	applied	\N	\N	\N	\N	193926	193926	361104
25702	40596	2	applied	\N	\N	\N	\N	193927	193927	361105
25702	40597	3	applied	\N	\N	\N	\N	193928	193928	361106
25704	40595	0	applied	\N	\N	\N	\N	193931	193931	361109
25704	40593	1	applied	\N	\N	\N	\N	193932	193932	361110
25704	40596	2	applied	\N	\N	\N	\N	193933	193933	361111
25704	40597	3	applied	\N	\N	\N	\N	193934	193934	361112
25707	40598	0	applied	\N	\N	\N	\N	193941	193941	361119
25707	40599	1	applied	\N	\N	\N	\N	193942	193942	361120
25707	40600	2	applied	\N	\N	\N	\N	193943	193943	361121
25709	40601	0	applied	\N	\N	\N	\N	193947	193947	361125
25709	40602	1	applied	\N	\N	\N	\N	193948	193948	361126
25709	40604	3	applied	\N	\N	\N	\N	193950	193950	361128
25725	40639	1	applied	\N	\N	\N	\N	194035	194035	361213
25725	40640	2	applied	\N	\N	\N	\N	194036	194036	361214
25728	40647	0	applied	\N	\N	\N	\N	194046	194046	361224
25728	40648	1	applied	\N	\N	\N	\N	194047	194047	361225
25728	40649	2	applied	\N	\N	\N	\N	194048	194048	361226
25731	40659	0	applied	\N	\N	\N	\N	194061	194061	361239
25731	40660	1	applied	\N	\N	\N	\N	194062	194062	361240
25731	40661	2	applied	\N	\N	\N	\N	194063	194063	361241
25733	40662	0	applied	\N	\N	\N	\N	194067	194067	361245
25733	40663	1	applied	\N	\N	\N	\N	194068	194068	361246
25733	40664	2	applied	\N	\N	\N	\N	194069	194069	361247
25738	40671	0	applied	\N	\N	\N	\N	194093	194093	361270
25738	40672	1	applied	\N	\N	\N	\N	194094	194094	361271
25738	40673	2	applied	\N	\N	\N	\N	194095	194095	361272
25738	40674	3	applied	\N	\N	\N	\N	194096	194096	361273
25742	40404	0	applied	\N	\N	\N	\N	194111	194111	361284
25742	40674	1	applied	\N	\N	\N	\N	194112	194112	361285
25742	40675	2	applied	\N	\N	\N	\N	194113	194113	194113
25742	40583	3	applied	\N	\N	\N	\N	194114	194114	361286
25751	40684	0	applied	\N	\N	\N	\N	194142	194142	361313
25751	40685	1	applied	\N	\N	\N	\N	194143	194143	361314
25751	40686	2	applied	\N	\N	\N	\N	194144	194144	361315
25751	40687	3	applied	\N	\N	\N	\N	194145	194145	361316
25763	40697	0	applied	\N	\N	\N	\N	194182	194182	361353
25763	40698	1	applied	\N	\N	\N	\N	194183	194183	361354
25763	40699	2	applied	\N	\N	\N	\N	194184	194184	361355
25764	40700	0	applied	\N	\N	\N	\N	194185	194185	361356
25764	40701	1	applied	\N	\N	\N	\N	194186	194186	361357
25764	40702	2	applied	\N	\N	\N	\N	194187	194187	361358
25773	40709	0	applied	\N	\N	\N	\N	194214	194214	361385
25773	40710	1	applied	\N	\N	\N	\N	194215	194215	361386
25778	40721	0	applied	\N	\N	\N	\N	194237	194237	361407
25778	40722	1	applied	\N	\N	\N	\N	194238	194238	361408
25778	40723	2	applied	\N	\N	\N	\N	194239	194239	361409
25780	40724	0	applied	\N	\N	\N	\N	194243	194243	361413
25780	40725	1	applied	\N	\N	\N	\N	194244	194244	361414
25780	40726	2	applied	\N	\N	\N	\N	194245	194245	361415
25783	40733	0	applied	\N	\N	\N	\N	194258	194258	361428
25783	40734	1	applied	\N	\N	\N	\N	194259	194259	361429
25783	40735	2	applied	\N	\N	\N	\N	194260	194260	361430
25783	40736	3	applied	\N	\N	\N	\N	194261	194261	361431
25783	40737	4	applied	\N	\N	\N	\N	194262	194262	361432
25783	40738	5	applied	\N	\N	\N	\N	194263	194263	361433
25790	40742	0	applied	\N	\N	\N	\N	194289	194289	361459
25790	40743	1	applied	\N	\N	\N	\N	194290	194290	361460
25790	40745	3	applied	\N	\N	\N	\N	194292	194292	361462
25795	40749	0	applied	\N	\N	\N	\N	194320	194320	361490
25647	40488	2	applied	\N	\N	\N	\N	193699	193699	360877
25649	40486	0	applied	\N	\N	\N	\N	193703	193703	360881
25686	40559	0	applied	\N	\N	\N	\N	193865	193865	361043
25686	40560	1	applied	\N	\N	\N	\N	193866	193866	361044
25686	40561	2	applied	\N	\N	\N	\N	193867	193867	361045
25686	40562	3	applied	\N	\N	\N	\N	193868	193868	361046
25686	40563	4	applied	\N	\N	\N	\N	193869	193869	361047
25686	40564	5	applied	\N	\N	\N	\N	193870	193870	361048
25691	40570	0	applied	\N	\N	\N	\N	193885	193885	361063
25691	40571	1	applied	\N	\N	\N	\N	193886	193886	361064
25691	40572	2	applied	\N	\N	\N	\N	193887	193887	361065
25691	40573	3	applied	\N	\N	\N	\N	193888	193888	361066
25691	40574	4	applied	\N	\N	\N	\N	193889	193889	361067
25691	40575	5	applied	\N	\N	\N	\N	193890	193890	361068
25692	40576	0	applied	\N	\N	\N	\N	193891	193891	361069
25692	40577	1	applied	\N	\N	\N	\N	193892	193892	361070
25692	40578	2	applied	\N	\N	\N	\N	193893	193893	361071
25692	40579	3	applied	\N	\N	\N	\N	193894	193894	361072
25692	40581	5	applied	\N	\N	\N	\N	193896	193896	361074
25692	40582	6	applied	\N	\N	\N	\N	193897	193897	361075
25692	40583	7	applied	\N	\N	\N	\N	193898	193898	361076
25692	40584	8	applied	\N	\N	\N	\N	193899	193899	361077
25692	40585	9	applied	\N	\N	\N	\N	193900	193900	361078
25694	40586	0	applied	\N	\N	\N	\N	193904	193904	361082
25694	40587	1	applied	\N	\N	\N	\N	193905	193905	361083
25694	40588	2	applied	\N	\N	\N	\N	193906	193906	361084
25705	40598	0	applied	\N	\N	\N	\N	193935	193935	361113
25705	40599	1	applied	\N	\N	\N	\N	193936	193936	361114
25705	40600	2	applied	\N	\N	\N	\N	193937	193937	361115
25709	40605	4	applied	\N	\N	\N	\N	193951	193951	361129
25709	40606	5	applied	\N	\N	\N	\N	193952	193952	361130
25709	40607	6	applied	\N	\N	\N	\N	193953	193953	361131
25710	40601	0	applied	\N	\N	\N	\N	193954	193954	361132
25710	40602	1	applied	\N	\N	\N	\N	193955	193955	361133
25710	40604	3	applied	\N	\N	\N	\N	193957	193957	361135
25710	40605	4	applied	\N	\N	\N	\N	193958	193958	361136
25710	40606	5	applied	\N	\N	\N	\N	193959	193959	361137
25710	40607	6	applied	\N	\N	\N	\N	193960	193960	361138
25711	40601	0	applied	\N	\N	\N	\N	193961	193961	361139
25711	40602	1	applied	\N	\N	\N	\N	193962	193962	361140
25711	40603	2	applied	\N	\N	\N	\N	193963	193963	361141
25711	40604	3	applied	\N	\N	\N	\N	193964	193964	361142
25711	40605	4	applied	\N	\N	\N	\N	193965	193965	361143
25711	40606	5	applied	\N	\N	\N	\N	193966	193966	361144
25711	40607	6	applied	\N	\N	\N	\N	193967	193967	361145
25716	40617	0	applied	\N	\N	\N	\N	194001	194001	361179
25716	40618	1	applied	\N	\N	\N	\N	194002	194002	361180
25716	40619	2	applied	\N	\N	\N	\N	194003	194003	361181
25717	40617	0	applied	\N	\N	\N	\N	194004	194004	361182
25717	40618	1	applied	\N	\N	\N	\N	194005	194005	361183
25718	40620	0	applied	\N	\N	\N	\N	194007	194007	361185
25718	40621	1	applied	\N	\N	\N	\N	194008	194008	361186
25718	40622	2	applied	\N	\N	\N	\N	194009	194009	361187
25719	40620	0	applied	\N	\N	\N	\N	194010	194010	361188
25719	40621	1	applied	\N	\N	\N	\N	194011	194011	361189
25719	40622	2	applied	\N	\N	\N	\N	194012	194012	361190
25722	40629	0	applied	\N	\N	\N	\N	194019	194019	361197
25722	40630	1	applied	\N	\N	\N	\N	194020	194020	361198
25722	40631	2	applied	\N	\N	\N	\N	194021	194021	361199
25722	40632	3	applied	\N	\N	\N	\N	194022	194022	361200
25722	40633	4	applied	\N	\N	\N	\N	194023	194023	361201
25722	40634	5	applied	\N	\N	\N	\N	194024	194024	361202
25723	40629	0	applied	\N	\N	\N	\N	194025	194025	361203
25723	40630	1	applied	\N	\N	\N	\N	194026	194026	361204
25723	40631	2	applied	\N	\N	\N	\N	194027	194027	361205
25723	40632	3	applied	\N	\N	\N	\N	194028	194028	361206
25723	40634	5	applied	\N	\N	\N	\N	194030	194030	361208
25726	40641	0	applied	\N	\N	\N	\N	194037	194037	361215
25726	40642	1	applied	\N	\N	\N	\N	194038	194038	361216
25726	40643	2	applied	\N	\N	\N	\N	194039	194039	361217
25726	40644	3	applied	\N	\N	\N	\N	194040	194040	361218
25726	40645	4	applied	\N	\N	\N	\N	194041	194041	361219
25726	40646	5	applied	\N	\N	\N	\N	194042	194042	361220
25729	40650	0	applied	\N	\N	\N	\N	194049	194049	361227
25729	40651	1	applied	\N	\N	\N	\N	194050	194050	361228
25729	40652	2	applied	\N	\N	\N	\N	194051	194051	361229
25729	40653	3	applied	\N	\N	\N	\N	194052	194052	361230
25729	40654	4	applied	\N	\N	\N	\N	194053	194053	361231
25729	40655	5	applied	\N	\N	\N	\N	194054	194054	361232
25729	40656	6	applied	\N	\N	\N	\N	194055	194055	361233
25729	40657	7	applied	\N	\N	\N	\N	194056	194056	361234
25729	40658	8	applied	\N	\N	\N	\N	194057	194057	361235
25734	40666	1	applied	\N	\N	\N	\N	194071	194071	361249
25734	40667	2	applied	\N	\N	\N	\N	194072	194072	361250
25734	40668	3	applied	\N	\N	\N	\N	194073	194073	361251
25734	40669	4	applied	\N	\N	\N	\N	194074	194074	361252
25734	40670	5	applied	\N	\N	\N	\N	194075	194075	361253
25735	40665	0	applied	\N	\N	\N	\N	194076	194076	361254
25735	40666	1	applied	\N	\N	\N	\N	194077	194077	361255
25735	40667	2	applied	\N	\N	\N	\N	194078	194078	361256
25735	40668	3	applied	\N	\N	\N	\N	194079	194079	361257
25735	40669	4	applied	\N	\N	\N	\N	194080	194080	361258
25735	40670	5	applied	\N	\N	\N	\N	194081	194081	361259
25736	40665	0	applied	\N	\N	\N	\N	194082	194082	361260
25736	40666	1	applied	\N	\N	\N	\N	194083	194083	361261
25736	40667	2	applied	\N	\N	\N	\N	194084	194084	361262
25736	40668	3	applied	\N	\N	\N	\N	194085	194085	361263
25736	40669	4	applied	\N	\N	\N	\N	194086	194086	361264
25740	40671	0	applied	\N	\N	\N	\N	194101	194101	361276
25740	40672	1	applied	\N	\N	\N	\N	194102	194102	361277
25740	40673	2	applied	\N	\N	\N	\N	194103	194103	361278
25740	40674	3	applied	\N	\N	\N	\N	194104	194104	361279
25740	40675	4	applied	\N	\N	\N	\N	194105	194105	194105
25744	40677	0	applied	\N	\N	\N	\N	194116	194116	361288
25744	40678	2	applied	\N	\N	\N	\N	194117	194117	361289
25744	40676	3	applied	\N	\N	\N	\N	194118	194118	361290
25745	40677	0	applied	\N	\N	\N	\N	194119	194119	361291
25745	40678	2	applied	\N	\N	\N	\N	194120	194120	361292
25746	40404	0	applied	\N	\N	\N	\N	194122	194122	361294
25746	40674	1	applied	\N	\N	\N	\N	194123	194123	361295
25746	40675	2	applied	\N	\N	\N	\N	194124	194124	194124
25746	40583	3	applied	\N	\N	\N	\N	194125	194125	361296
25680	40550	3	applied	\N	\N	\N	\N	193823	193823	361001
25680	40551	4	applied	\N	\N	\N	\N	193824	193824	361002
25730	40659	0	applied	\N	\N	\N	\N	194058	194058	361236
25730	40660	1	applied	\N	\N	\N	\N	194059	194059	361237
25730	40661	2	applied	\N	\N	\N	\N	194060	194060	361238
25732	40659	0	applied	\N	\N	\N	\N	194064	194064	361242
25732	40660	1	applied	\N	\N	\N	\N	194065	194065	361243
25732	40661	2	applied	\N	\N	\N	\N	194066	194066	361244
25737	40671	0	applied	\N	\N	\N	\N	194088	194088	361266
25737	40672	1	applied	\N	\N	\N	\N	194089	194089	361267
25737	40673	2	applied	\N	\N	\N	\N	194090	194090	361268
25737	40674	3	applied	\N	\N	\N	\N	194091	194091	361269
25737	40675	4	applied	\N	\N	\N	\N	194092	194092	194092
25739	40672	0	applied	\N	\N	\N	\N	194098	194098	361274
25739	40674	1	applied	\N	\N	\N	\N	194099	194099	361275
25739	40675	2	applied	\N	\N	\N	\N	194100	194100	194100
25741	40672	1	applied	\N	\N	\N	\N	194107	194107	361281
25741	40673	2	applied	\N	\N	\N	\N	194108	194108	361282
25741	40674	3	applied	\N	\N	\N	\N	194109	194109	361283
25741	40675	4	applied	\N	\N	\N	\N	194110	194110	194110
25743	40676	0	applied	\N	\N	\N	\N	194115	194115	361287
25748	40677	0	applied	\N	\N	\N	\N	194131	194131	361302
25748	40679	1	applied	\N	\N	\N	\N	194132	194132	361303
25748	40678	2	applied	\N	\N	\N	\N	194133	194133	361304
25748	40680	3	applied	\N	\N	\N	\N	194134	194134	361305
25748	40681	4	applied	\N	\N	\N	\N	194135	194135	361306
25750	40684	0	applied	\N	\N	\N	\N	194138	194138	361309
25750	40685	1	applied	\N	\N	\N	\N	194139	194139	361310
25750	40686	2	applied	\N	\N	\N	\N	194140	194140	361311
25750	40687	3	applied	\N	\N	\N	\N	194141	194141	361312
25752	40688	0	applied	\N	\N	\N	\N	194146	194146	361317
25752	40689	1	applied	\N	\N	\N	\N	194147	194147	361318
25753	40688	0	applied	\N	\N	\N	\N	194149	194149	361320
25753	40689	1	applied	\N	\N	\N	\N	194150	194150	361321
25753	40690	2	applied	\N	\N	\N	\N	194151	194151	361322
25754	40688	0	applied	\N	\N	\N	\N	194152	194152	361323
25754	40689	1	applied	\N	\N	\N	\N	194153	194153	361324
25754	40690	2	applied	\N	\N	\N	\N	194154	194154	361325
25755	40691	0	applied	\N	\N	\N	\N	194155	194155	361326
25755	40692	1	applied	\N	\N	\N	\N	194156	194156	361327
25755	40693	2	applied	\N	\N	\N	\N	194157	194157	361328
25757	40691	0	applied	\N	\N	\N	\N	194161	194161	361332
25757	40694	1	applied	\N	\N	\N	\N	194162	194162	361333
25757	40692	2	applied	\N	\N	\N	\N	194163	194163	361334
25757	40696	3	applied	\N	\N	\N	\N	194164	194164	361335
25757	40693	4	applied	\N	\N	\N	\N	194165	194165	361336
25757	40695	5	applied	\N	\N	\N	\N	194166	194166	361337
25759	40694	0	applied	\N	\N	\N	\N	194170	194170	361341
25759	40695	2	applied	\N	\N	\N	\N	194172	194172	361343
25761	40697	0	applied	\N	\N	\N	\N	194176	194176	361347
25761	40698	1	applied	\N	\N	\N	\N	194177	194177	361348
25761	40699	2	applied	\N	\N	\N	\N	194178	194178	361349
25762	40697	0	applied	\N	\N	\N	\N	194179	194179	361350
25762	40698	1	applied	\N	\N	\N	\N	194180	194180	361351
25762	40699	2	applied	\N	\N	\N	\N	194181	194181	361352
25766	40703	0	applied	\N	\N	\N	\N	194189	194189	361360
25766	40704	1	applied	\N	\N	\N	\N	194190	194190	361361
25766	40705	2	applied	\N	\N	\N	\N	194191	194191	361362
25768	40686	0	applied	\N	\N	\N	\N	194195	194195	361366
25770	40706	0	applied	\N	\N	\N	\N	194199	194199	361370
25770	40707	1	applied	\N	\N	\N	\N	194200	194200	361371
25770	40708	2	applied	\N	\N	\N	\N	194201	194201	361372
25772	40709	0	applied	\N	\N	\N	\N	194211	194211	361382
25772	40710	1	applied	\N	\N	\N	\N	194212	194212	361383
25774	40712	0	applied	\N	\N	\N	\N	194217	194217	361388
25774	40713	1	applied	\N	\N	\N	\N	194218	194218	361389
25774	40714	2	applied	\N	\N	\N	\N	194219	194219	361390
25775	40715	0	applied	\N	\N	\N	\N	194220	194220	361391
25775	40716	1	applied	\N	\N	\N	\N	194221	194221	361392
25775	40717	2	applied	\N	\N	\N	\N	194222	194222	361393
25775	40718	3	applied	\N	\N	\N	\N	194223	194223	361394
25775	40719	4	applied	\N	\N	\N	\N	194224	194224	361395
25775	40720	5	applied	\N	\N	\N	\N	194225	194225	361396
25777	40404	0	applied	\N	\N	\N	\N	194232	194232	361403
25777	40674	1	applied	\N	\N	\N	\N	194233	194233	361404
25777	40675	2	applied	\N	\N	\N	\N	194234	194234	194234
25777	40686	3	applied	\N	\N	\N	\N	194235	194235	361405
25777	40583	4	applied	\N	\N	\N	\N	194236	194236	361406
25779	40721	0	applied	\N	\N	\N	\N	194240	194240	361410
25779	40722	1	applied	\N	\N	\N	\N	194241	194241	361411
25782	40733	0	applied	\N	\N	\N	\N	194252	194252	361422
25782	40734	1	applied	\N	\N	\N	\N	194253	194253	361423
25782	40735	2	applied	\N	\N	\N	\N	194254	194254	361424
25782	40736	3	applied	\N	\N	\N	\N	194255	194255	361425
25782	40737	4	applied	\N	\N	\N	\N	194256	194256	361426
25782	40738	5	applied	\N	\N	\N	\N	194257	194257	361427
25785	40733	0	applied	\N	\N	\N	\N	194270	194270	361440
25785	40734	1	applied	\N	\N	\N	\N	194271	194271	361441
25785	40735	2	applied	\N	\N	\N	\N	194272	194272	361442
25785	40736	3	applied	\N	\N	\N	\N	194273	194273	361443
25785	40737	4	applied	\N	\N	\N	\N	194274	194274	361444
25785	40738	5	applied	\N	\N	\N	\N	194275	194275	361445
25787	40739	0	applied	\N	\N	\N	\N	194279	194279	361449
25787	40740	1	applied	\N	\N	\N	\N	194280	194280	361450
25787	40741	2	applied	\N	\N	\N	\N	194281	194281	361451
25792	40742	0	applied	\N	\N	\N	\N	194295	194295	361465
25792	40744	2	applied	\N	\N	1000000000	\N	194297	194297	361467
25792	40745	3	applied	\N	\N	\N	\N	194298	194298	361468
25800	40766	0	applied	\N	\N	\N	\N	194345	194345	361515
25800	40767	1	applied	\N	\N	\N	\N	194346	194346	361516
25801	40768	0	applied	\N	\N	\N	\N	194347	194347	361517
25801	40769	1	applied	\N	\N	\N	\N	194348	194348	361518
25801	40770	2	applied	\N	\N	\N	\N	194349	194349	361519
25808	40780	0	applied	\N	\N	\N	\N	194374	194374	361544
25808	40781	1	applied	\N	\N	\N	\N	194375	194375	361545
25808	40782	2	applied	\N	\N	\N	\N	194376	194376	361546
25808	40783	3	applied	\N	\N	\N	\N	194377	194377	361547
25811	40784	0	applied	\N	\N	\N	\N	194385	194385	361555
25811	40785	1	applied	\N	\N	\N	\N	194386	194386	361556
25811	40786	2	applied	\N	\N	\N	\N	194387	194387	361557
25816	40793	0	applied	\N	\N	\N	\N	194403	194403	361573
25816	40794	1	applied	\N	\N	\N	\N	194404	194404	361574
25727	40649	2	applied	\N	\N	\N	\N	194045	194045	361223
25747	40678	2	applied	\N	\N	\N	\N	194128	194128	361299
25747	40680	3	applied	\N	\N	\N	\N	194129	194129	361300
25747	40681	4	applied	\N	\N	\N	\N	194130	194130	361301
25749	40682	0	applied	\N	\N	\N	\N	194136	194136	361307
25749	40683	1	applied	\N	\N	\N	\N	194137	194137	361308
25756	40694	0	applied	\N	\N	\N	\N	194158	194158	361329
25756	40695	1	applied	\N	\N	\N	\N	194159	194159	361330
25756	40696	2	applied	\N	\N	\N	\N	194160	194160	361331
25758	40694	0	applied	\N	\N	\N	\N	194167	194167	361338
25758	40695	1	applied	\N	\N	\N	\N	194168	194168	361339
25758	40696	2	applied	\N	\N	\N	\N	194169	194169	361340
25760	40695	1	applied	\N	\N	\N	\N	194174	194174	361345
25760	40696	2	applied	\N	\N	\N	\N	194175	194175	361346
25765	40686	0	applied	\N	\N	\N	\N	194188	194188	361359
25767	40703	0	applied	\N	\N	\N	\N	194192	194192	361363
25767	40704	1	applied	\N	\N	\N	\N	194193	194193	361364
25767	40705	2	applied	\N	\N	\N	\N	194194	194194	361365
25769	40703	0	applied	\N	\N	\N	\N	194196	194196	361367
25769	40704	1	applied	\N	\N	\N	\N	194197	194197	361368
25769	40705	2	applied	\N	\N	\N	\N	194198	194198	361369
25771	40700	0	applied	\N	\N	\N	\N	194202	194202	361373
25771	40703	1	applied	\N	\N	\N	\N	194203	194203	361374
25771	40706	2	applied	\N	\N	\N	\N	194204	194204	361375
25771	40701	3	applied	\N	\N	\N	\N	194205	194205	361376
25771	40702	4	applied	\N	\N	\N	\N	194206	194206	361377
25771	40704	5	applied	\N	\N	\N	\N	194207	194207	361378
25771	40708	6	applied	\N	\N	\N	\N	194208	194208	361379
25771	40707	8	applied	\N	\N	\N	\N	194210	194210	361381
25776	40715	0	applied	\N	\N	\N	\N	194226	194226	361397
25776	40716	1	applied	\N	\N	\N	\N	194227	194227	361398
25776	40717	2	applied	\N	\N	\N	\N	194228	194228	361399
25776	40718	3	applied	\N	\N	\N	\N	194229	194229	361400
25776	40719	4	applied	\N	\N	\N	\N	194230	194230	361401
25776	40720	5	applied	\N	\N	\N	\N	194231	194231	361402
25781	40727	0	applied	\N	\N	\N	\N	194246	194246	361416
25781	40728	1	applied	\N	\N	\N	\N	194247	194247	361417
25781	40729	2	applied	\N	\N	\N	\N	194248	194248	361418
25781	40730	3	applied	\N	\N	\N	\N	194249	194249	361419
25781	40731	4	applied	\N	\N	\N	\N	194250	194250	361420
25781	40732	5	applied	\N	\N	\N	\N	194251	194251	361421
25784	40733	0	applied	\N	\N	\N	\N	194264	194264	361434
25784	40734	1	applied	\N	\N	\N	\N	194265	194265	361435
25784	40735	2	applied	\N	\N	\N	\N	194266	194266	361436
25784	40737	4	applied	\N	\N	\N	\N	194268	194268	361438
25784	40738	5	applied	\N	\N	\N	\N	194269	194269	361439
25786	40739	0	applied	\N	\N	\N	\N	194276	194276	361446
25786	40740	1	applied	\N	\N	\N	\N	194277	194277	361447
25786	40741	2	applied	\N	\N	\N	\N	194278	194278	361448
25788	40742	0	applied	\N	\N	\N	\N	194282	194282	361452
25788	40743	1	applied	\N	\N	\N	\N	194283	194283	361453
25788	40744	2	applied	\N	\N	1000000000	\N	194284	194284	361454
25789	40742	0	applied	\N	\N	\N	\N	194285	194285	361455
25789	40743	1	applied	\N	\N	\N	\N	194286	194286	361456
25789	40744	2	applied	\N	\N	1000000000	\N	194287	194287	361457
25789	40745	3	applied	\N	\N	\N	\N	194288	194288	361458
25791	40743	0	applied	\N	\N	\N	\N	194293	194293	361463
25791	40744	1	applied	\N	\N	1000000000	\N	194294	194294	361464
25793	40746	0	applied	\N	\N	\N	\N	194299	194299	361469
25793	40747	1	applied	\N	\N	\N	\N	194300	194300	361470
25793	40748	3	applied	\N	\N	\N	\N	194302	194302	361472
25794	40749	0	applied	\N	\N	\N	\N	194303	194303	361473
25794	40750	1	applied	\N	\N	\N	\N	194304	194304	361474
25794	40751	2	applied	\N	\N	\N	\N	194305	194305	361475
25794	40752	3	applied	\N	\N	\N	\N	194306	194306	361476
25794	40753	4	applied	\N	\N	\N	\N	194307	194307	361477
25794	40754	5	applied	\N	\N	\N	\N	194308	194308	361478
25794	40755	6	applied	\N	\N	\N	\N	194309	194309	361479
25794	40756	7	applied	\N	\N	\N	\N	194310	194310	361480
25794	40757	8	applied	\N	\N	\N	\N	194311	194311	361481
25794	40758	9	applied	\N	\N	\N	\N	194312	194312	361482
25794	40759	10	applied	\N	\N	\N	\N	194313	194313	361483
25794	40760	11	applied	\N	\N	\N	\N	194314	194314	361484
25794	40761	12	applied	\N	\N	\N	\N	194315	194315	361485
25794	40762	13	applied	\N	\N	\N	\N	194316	194316	361486
25794	40763	15	applied	\N	\N	\N	\N	194317	194317	361487
25794	40765	17	applied	\N	\N	\N	\N	194319	194319	361489
25796	40766	0	applied	\N	\N	\N	\N	194337	194337	361507
25796	40767	1	applied	\N	\N	\N	\N	194338	194338	361508
25797	40766	0	applied	\N	\N	\N	\N	194339	194339	361509
25797	40767	1	applied	\N	\N	\N	\N	194340	194340	361510
25799	40766	0	applied	\N	\N	\N	\N	194343	194343	361513
25799	40767	1	applied	\N	\N	\N	\N	194344	194344	361514
25803	40771	0	applied	\N	\N	\N	\N	194353	194353	361523
25803	40772	1	applied	\N	\N	\N	\N	194354	194354	361524
25803	40773	2	applied	\N	\N	\N	\N	194355	194355	361525
25805	40771	0	applied	\N	\N	\N	\N	194359	194359	361529
25805	40772	1	applied	\N	\N	\N	\N	194360	194360	361530
25805	40773	2	applied	\N	\N	\N	\N	194361	194361	361531
25810	40784	0	applied	\N	\N	\N	\N	194382	194382	361552
25810	40785	1	applied	\N	\N	\N	\N	194383	194383	361553
25810	40786	2	applied	\N	\N	\N	\N	194384	194384	361554
25812	40788	1	applied	\N	\N	\N	\N	194389	194389	361559
25812	40789	2	applied	\N	\N	\N	\N	194390	194390	361560
25814	40790	0	applied	\N	\N	\N	\N	194394	194394	361564
25814	40791	1	applied	\N	\N	\N	\N	194395	194395	361565
25814	40792	2	applied	\N	\N	\N	\N	194396	194396	361566
25815	40793	0	applied	\N	\N	\N	\N	194397	194397	361567
25815	40794	1	applied	\N	\N	\N	\N	194398	194398	361568
25815	40795	2	applied	\N	\N	\N	\N	194399	194399	361569
25815	40796	3	applied	\N	\N	\N	\N	194400	194400	361570
25819	40793	0	applied	\N	\N	\N	\N	194421	194421	361591
25819	40794	1	applied	\N	\N	\N	\N	194422	194422	361592
25819	40799	2	applied	\N	\N	\N	\N	194423	194423	361593
25819	40800	3	applied	\N	\N	\N	\N	194424	194424	361594
25819	40795	4	applied	\N	\N	\N	\N	194425	194425	361595
25819	40796	5	applied	\N	\N	\N	\N	194426	194426	361596
25819	40801	6	applied	\N	\N	\N	\N	194427	194427	361597
25819	40797	8	applied	\N	\N	\N	\N	194429	194429	361599
25819	40798	9	applied	\N	\N	\N	\N	194430	194430	361600
25747	40677	0	applied	\N	\N	\N	\N	194126	194126	361297
25747	40679	1	applied	\N	\N	\N	\N	194127	194127	361298
25795	40754	5	applied	\N	\N	\N	\N	194325	194325	361495
25795	40755	6	applied	\N	\N	\N	\N	194326	194326	361496
25795	40756	7	applied	\N	\N	\N	\N	194327	194327	361497
25795	40757	8	applied	\N	\N	\N	\N	194328	194328	361498
25795	40758	9	applied	\N	\N	\N	\N	194329	194329	361499
25795	40759	10	applied	\N	\N	\N	\N	194330	194330	361500
25795	40760	11	applied	\N	\N	\N	\N	194331	194331	361501
25795	40761	12	applied	\N	\N	\N	\N	194332	194332	361502
25795	40762	13	applied	\N	\N	\N	\N	194333	194333	361503
25795	40763	15	applied	\N	\N	\N	\N	194334	194334	361504
25795	40764	16	applied	\N	\N	\N	\N	194335	194335	361505
25795	40765	17	applied	\N	\N	\N	\N	194336	194336	361506
25798	40766	0	applied	\N	\N	\N	\N	194341	194341	361511
25798	40767	1	applied	\N	\N	\N	\N	194342	194342	361512
25802	40772	1	applied	\N	\N	\N	\N	194351	194351	361521
25802	40773	2	applied	\N	\N	\N	\N	194352	194352	361522
25804	40771	0	applied	\N	\N	\N	\N	194356	194356	361526
25804	40772	1	applied	\N	\N	\N	\N	194357	194357	361527
25804	40773	2	applied	\N	\N	\N	\N	194358	194358	361528
25806	40774	0	applied	\N	\N	\N	\N	194362	194362	361532
25806	40775	1	applied	\N	\N	\N	\N	194363	194363	361533
25806	40776	2	applied	\N	\N	\N	\N	194364	194364	361534
25806	40777	3	applied	\N	\N	\N	\N	194365	194365	361535
25806	40778	4	applied	\N	\N	\N	\N	194366	194366	361536
25806	40779	5	applied	\N	\N	\N	\N	194367	194367	361537
25807	40774	0	applied	\N	\N	\N	\N	194368	194368	361538
25807	40775	1	applied	\N	\N	\N	\N	194369	194369	361539
25807	40776	2	applied	\N	\N	\N	\N	194370	194370	361540
25807	40777	3	applied	\N	\N	\N	\N	194371	194371	361541
25807	40778	4	applied	\N	\N	\N	\N	194372	194372	361542
25809	40780	0	applied	\N	\N	\N	\N	194378	194378	361548
25809	40781	1	applied	\N	\N	\N	\N	194379	194379	361549
25809	40782	2	applied	\N	\N	\N	\N	194380	194380	361550
25809	40783	3	applied	\N	\N	\N	\N	194381	194381	361551
25813	40787	0	applied	\N	\N	\N	\N	194391	194391	361561
25813	40788	1	applied	\N	\N	\N	\N	194392	194392	361562
25813	40789	2	applied	\N	\N	\N	\N	194393	194393	361563
25819	40803	10	applied	\N	\N	\N	\N	194431	194431	361601
25819	40804	11	applied	\N	\N	\N	\N	194432	194432	361602
25821	40807	0	applied	\N	\N	\N	\N	194435	194435	361605
25821	40808	1	applied	\N	\N	\N	\N	194436	194436	361606
25821	40809	2	applied	\N	\N	\N	\N	194437	194437	361607
25821	40810	3	applied	\N	\N	\N	\N	194438	194438	361608
25821	40811	4	applied	\N	\N	\N	\N	194439	194439	361609
25821	40812	5	applied	\N	\N	\N	\N	194440	194440	361610
25821	40813	6	applied	\N	\N	\N	\N	194441	194441	361611
25824	40815	1	applied	\N	\N	\N	\N	194459	194459	361629
25824	40816	2	applied	\N	\N	\N	\N	194460	194460	361630
25824	40817	3	applied	\N	\N	\N	\N	194461	194461	361631
25824	40818	4	applied	\N	\N	\N	\N	194462	194462	361632
25824	40819	5	applied	\N	\N	\N	\N	194463	194463	361633
25824	40820	6	applied	\N	\N	\N	\N	194464	194464	361634
25824	40821	7	applied	\N	\N	\N	\N	194465	194465	361635
25824	40822	8	applied	\N	\N	\N	\N	194466	194466	361636
25826	40823	0	applied	\N	\N	\N	\N	194470	194470	361640
25826	40824	1	applied	\N	\N	\N	\N	194471	194471	361641
25826	40825	2	applied	\N	\N	\N	\N	194472	194472	361642
25827	40826	0	applied	\N	\N	\N	\N	194473	194473	361643
25827	40827	1	applied	\N	\N	\N	\N	194474	194474	361644
25827	40828	2	applied	\N	\N	\N	\N	194475	194475	361645
25829	40829	0	applied	\N	\N	\N	\N	194483	194483	361653
25829	40830	1	applied	\N	\N	\N	\N	194484	194484	361654
25829	40832	3	applied	\N	\N	\N	\N	194486	194486	361656
25829	40833	4	applied	\N	\N	\N	\N	194487	194487	361657
25829	40834	5	applied	\N	\N	\N	\N	194488	194488	361658
25829	40835	6	applied	\N	\N	\N	\N	194489	194489	361659
25832	40839	0	applied	\N	\N	\N	\N	194496	194496	361666
25832	40840	1	applied	\N	\N	\N	\N	194497	194497	361667
25832	40841	2	applied	\N	\N	\N	\N	194498	194498	361668
25832	40842	3	applied	\N	\N	\N	\N	194499	194499	361669
25834	40839	0	applied	\N	\N	\N	\N	194504	194504	361674
25834	40840	1	applied	\N	\N	\N	\N	194505	194505	361675
25834	40841	2	applied	\N	\N	\N	\N	194506	194506	361676
25834	40842	3	applied	\N	\N	\N	\N	194507	194507	361677
25836	40843	0	applied	\N	\N	\N	\N	194516	194516	361685
25836	40844	1	applied	\N	\N	\N	\N	194517	194517	361686
25836	40845	2	applied	\N	\N	\N	\N	194518	194518	361687
25845	40854	0	applied	\N	\N	\N	\N	194548	194548	361717
25845	40855	1	applied	\N	\N	\N	\N	194549	194549	361718
25848	40854	0	applied	\N	\N	\N	\N	194554	194554	361723
25850	40862	0	applied	\N	\N	\N	\N	194562	194562	361731
25850	40863	1	applied	\N	\N	\N	\N	194563	194563	361732
25850	40864	2	applied	\N	\N	\N	\N	194564	194564	361733
25850	40865	3	applied	\N	\N	\N	\N	194565	194565	361734
25850	40866	4	applied	\N	\N	\N	\N	194566	194566	361735
25850	40867	5	applied	\N	\N	\N	\N	194567	194567	194567
25850	40868	6	applied	\N	\N	\N	\N	194568	194568	361736
25850	40869	7	applied	\N	\N	\N	\N	194569	194569	361737
25850	40870	8	applied	\N	\N	\N	\N	194570	194570	361738
25850	40871	9	applied	\N	\N	\N	\N	194571	194571	361739
25853	40878	0	applied	\N	\N	\N	\N	194581	194581	361749
25853	40879	1	applied	\N	\N	\N	\N	194582	194582	361750
25853	40880	2	applied	\N	\N	\N	\N	194583	194583	361751
25856	40881	0	applied	\N	\N	\N	\N	194590	194590	361758
25856	40882	1	applied	\N	\N	\N	\N	194591	194591	361759
25856	40883	2	applied	\N	\N	\N	\N	194592	194592	361760
25860	40887	1	applied	\N	\N	\N	\N	194601	194601	361769
25860	40888	2	applied	\N	\N	\N	\N	194602	194602	361770
25860	40885	3	applied	\N	\N	\N	\N	194603	194603	361771
25860	40889	4	applied	\N	\N	\N	\N	194604	194604	361772
25860	40890	5	applied	\N	\N	\N	\N	194605	194605	361773
25860	40891	6	applied	\N	\N	\N	\N	194606	194606	361774
25860	40892	7	applied	\N	\N	\N	\N	194607	194607	361775
25862	40884	0	applied	\N	\N	\N	\N	194616	194616	361784
25862	40887	1	applied	\N	\N	\N	\N	194617	194617	361785
25862	40888	2	applied	\N	\N	\N	\N	194618	194618	361786
25862	40885	3	applied	\N	\N	\N	\N	194619	194619	361787
25862	40889	4	applied	\N	\N	\N	\N	194620	194620	361788
25862	40890	5	applied	\N	\N	\N	\N	194621	194621	361789
25862	40891	6	applied	\N	\N	\N	\N	194622	194622	361790
25795	40752	3	applied	\N	\N	\N	\N	194323	194323	361493
25795	40753	4	applied	\N	\N	\N	\N	194324	194324	361494
25822	40809	2	applied	\N	\N	\N	\N	194444	194444	361614
25822	40810	3	applied	\N	\N	\N	\N	194445	194445	361615
25822	40811	4	applied	\N	\N	\N	\N	194446	194446	361616
25822	40812	5	applied	\N	\N	\N	\N	194447	194447	361617
25822	40813	6	applied	\N	\N	\N	\N	194448	194448	361618
25823	40814	0	applied	\N	\N	\N	\N	194449	194449	361619
25823	40815	1	applied	\N	\N	\N	\N	194450	194450	361620
25823	40816	2	applied	\N	\N	\N	\N	194451	194451	361621
25823	40817	3	applied	\N	\N	\N	\N	194452	194452	361622
25823	40818	4	applied	\N	\N	\N	\N	194453	194453	361623
25823	40819	5	applied	\N	\N	\N	\N	194454	194454	361624
25823	40820	6	applied	\N	\N	\N	\N	194455	194455	361625
25823	40821	7	applied	\N	\N	\N	\N	194456	194456	361626
25823	40822	8	applied	\N	\N	\N	\N	194457	194457	361627
25825	40824	1	applied	\N	\N	\N	\N	194468	194468	361638
25825	40825	2	applied	\N	\N	\N	\N	194469	194469	361639
25828	40829	0	applied	\N	\N	\N	\N	194476	194476	361646
25828	40830	1	applied	\N	\N	\N	\N	194477	194477	361647
25828	40831	2	applied	\N	\N	1000000000	\N	194478	194478	361648
25828	40832	3	applied	\N	\N	\N	\N	194479	194479	361649
25828	40833	4	applied	\N	\N	\N	\N	194480	194480	361650
25828	40834	5	applied	\N	\N	\N	\N	194481	194481	361651
25828	40835	6	applied	\N	\N	\N	\N	194482	194482	361652
25830	40836	0	applied	\N	\N	\N	\N	194490	194490	361660
25830	40837	1	applied	\N	\N	\N	\N	194491	194491	361661
25830	40838	2	applied	\N	\N	\N	\N	194492	194492	361662
25831	40836	0	applied	\N	\N	\N	\N	194493	194493	361663
25831	40837	1	applied	\N	\N	\N	\N	194494	194494	361664
25831	40838	2	applied	\N	\N	\N	\N	194495	194495	361665
25837	40843	0	applied	\N	\N	\N	\N	194519	194519	361688
25837	40845	2	applied	\N	\N	\N	\N	194521	194521	361690
25838	40843	0	applied	\N	\N	\N	\N	194522	194522	361691
25838	40844	1	applied	\N	\N	\N	\N	194523	194523	361692
25838	40845	2	applied	\N	\N	\N	\N	194524	194524	361693
25840	40846	0	applied	\N	\N	\N	\N	194528	194528	361697
25840	40847	1	applied	\N	\N	\N	\N	194529	194529	361698
25840	40848	2	applied	\N	\N	\N	\N	194530	194530	361699
25840	40849	3	applied	\N	\N	\N	\N	194531	194531	361700
25841	40846	0	applied	\N	\N	\N	\N	194532	194532	361701
25841	40847	1	applied	\N	\N	\N	\N	194533	194533	361702
25841	40848	2	applied	\N	\N	\N	\N	194534	194534	361703
25841	40849	3	applied	\N	\N	\N	\N	194535	194535	361704
25843	40850	0	applied	\N	\N	\N	\N	194540	194540	361709
25843	40851	1	applied	\N	\N	\N	\N	194541	194541	361710
25843	40852	2	applied	\N	\N	\N	\N	194542	194542	361711
25843	40853	3	applied	\N	\N	\N	\N	194543	194543	361712
25846	40855	1	applied	\N	\N	\N	\N	194551	194551	361720
25847	40854	0	applied	\N	\N	\N	\N	194552	194552	361721
25847	40855	1	applied	\N	\N	\N	\N	194553	194553	361722
25849	40856	0	applied	\N	\N	\N	\N	194556	194556	361725
25849	40857	1	applied	\N	\N	\N	\N	194557	194557	361726
25849	40858	2	applied	\N	\N	\N	\N	194558	194558	361727
25849	40859	3	applied	\N	\N	\N	\N	194559	194559	361728
25849	40860	4	applied	\N	\N	\N	\N	194560	194560	361729
25849	40861	5	applied	\N	\N	\N	\N	194561	194561	361730
25851	40872	0	applied	\N	\N	\N	\N	194572	194572	361740
25851	40873	1	applied	\N	\N	\N	\N	194573	194573	361741
25851	40874	2	applied	\N	\N	\N	\N	194574	194574	361742
25851	40875	3	applied	\N	\N	\N	\N	194575	194575	361743
25851	40876	4	applied	\N	\N	\N	\N	194576	194576	361744
25851	40877	5	applied	\N	\N	\N	\N	194577	194577	361745
25855	40881	0	applied	\N	\N	\N	\N	194587	194587	361755
25855	40883	2	applied	\N	\N	\N	\N	194589	194589	361757
25858	40884	0	applied	\N	\N	\N	\N	194596	194596	361764
25858	40885	1	applied	\N	\N	\N	\N	194597	194597	361765
25858	40886	2	applied	\N	\N	\N	\N	194598	194598	361766
25859	40886	0	applied	\N	\N	\N	\N	194599	194599	361767
25861	40884	0	applied	\N	\N	\N	\N	194608	194608	361776
25861	40887	1	applied	\N	\N	\N	\N	194609	194609	361777
25861	40888	2	applied	\N	\N	\N	\N	194610	194610	361778
25861	40885	3	applied	\N	\N	\N	\N	194611	194611	361779
25861	40889	4	applied	\N	\N	\N	\N	194612	194612	361780
25861	40890	5	applied	\N	\N	\N	\N	194613	194613	361781
25861	40891	6	applied	\N	\N	\N	\N	194614	194614	361782
25861	40892	7	applied	\N	\N	\N	\N	194615	194615	361783
25865	40706	0	applied	\N	\N	\N	\N	194635	194635	361803
25865	40709	1	applied	\N	\N	\N	\N	194636	194636	361804
25865	40712	2	applied	\N	\N	\N	\N	194637	194637	361805
25865	40716	4	applied	\N	\N	\N	\N	194639	194639	361807
25865	40721	5	applied	\N	\N	\N	\N	194640	194640	361808
25865	40724	6	applied	\N	\N	\N	\N	194641	194641	361809
25865	40727	7	applied	\N	\N	\N	\N	194642	194642	361810
25866	40896	0	applied	\N	\N	\N	\N	194760	194760	361927
25866	40897	1	applied	\N	\N	\N	\N	194761	194761	361928
25866	40898	2	applied	\N	\N	\N	\N	194762	194762	361929
25866	40899	3	applied	\N	\N	\N	\N	194763	194763	361930
25866	40900	4	applied	\N	\N	\N	\N	194764	194764	361931
25866	40901	5	applied	\N	\N	\N	\N	194765	194765	361932
25871	40902	0	applied	\N	\N	\N	\N	194778	194778	361945
25871	40903	1	applied	\N	\N	\N	\N	194779	194779	361946
25871	40904	2	applied	\N	\N	\N	\N	194780	194780	361947
25873	40905	0	applied	\N	\N	\N	\N	194782	194782	361949
25873	40906	1	applied	\N	\N	\N	\N	194783	194783	361950
25873	40907	2	applied	\N	\N	\N	\N	194784	194784	361951
25873	40909	4	applied	\N	\N	\N	\N	194786	194786	361953
25873	40910	5	applied	\N	\N	\N	\N	194787	194787	361954
25880	40917	0	applied	\N	\N	\N	\N	194824	194824	361991
25880	40918	1	applied	\N	\N	\N	\N	194825	194825	361992
25882	40919	0	applied	\N	\N	\N	\N	194828	194828	361995
25882	40920	1	applied	\N	\N	\N	\N	194829	194829	361996
25887	40925	0	applied	\N	\N	\N	\N	194838	194838	362005
25887	40926	1	applied	\N	\N	\N	\N	194839	194839	362006
25887	40927	2	applied	\N	\N	\N	\N	194840	194840	362007
25887	40928	3	applied	\N	\N	\N	\N	194841	194841	362008
25889	40925	0	applied	\N	\N	\N	\N	194846	194846	362013
25889	40926	1	applied	\N	\N	\N	\N	194847	194847	362014
25889	40927	2	applied	\N	\N	\N	\N	194848	194848	362015
25889	40928	3	applied	\N	\N	\N	\N	194849	194849	362016
25894	40933	0	applied	\N	\N	\N	\N	194858	194858	362025
25894	40934	1	applied	\N	\N	\N	\N	194859	194859	362026
25822	40808	1	applied	\N	\N	\N	\N	194443	194443	361613
25816	40798	5	applied	\N	\N	\N	\N	194408	194408	361578
25818	40793	0	applied	\N	\N	\N	\N	194409	194409	361579
25818	40794	1	applied	\N	\N	\N	\N	194410	194410	361580
25818	40799	2	applied	\N	\N	\N	\N	194411	194411	361581
25818	40800	3	applied	\N	\N	\N	\N	194412	194412	361582
25818	40795	4	applied	\N	\N	\N	\N	194413	194413	361583
25818	40796	5	applied	\N	\N	\N	\N	194414	194414	361584
25818	40801	6	applied	\N	\N	\N	\N	194415	194415	361585
25818	40802	7	applied	\N	\N	\N	\N	194416	194416	361586
25818	40797	8	applied	\N	\N	\N	\N	194417	194417	361587
25818	40798	9	applied	\N	\N	\N	\N	194418	194418	361588
25818	40803	10	applied	\N	\N	\N	\N	194419	194419	361589
25818	40804	11	applied	\N	\N	\N	\N	194420	194420	361590
25820	40806	1	applied	\N	\N	\N	\N	194434	194434	361604
25833	40839	0	applied	\N	\N	\N	\N	194500	194500	361670
25833	40840	1	applied	\N	\N	\N	\N	194501	194501	361671
25833	40841	2	applied	\N	\N	\N	\N	194502	194502	361672
25833	40842	3	applied	\N	\N	\N	\N	194503	194503	361673
25835	40831	0	applied	\N	\N	1000000000	\N	194508	194508	361678
25835	40744	1	applied	\N	\N	1000000000	\N	194509	194509	361679
25835	40842	2	applied	\N	\N	\N	\N	194510	194510	361680
25835	40755	3	applied	\N	\N	\N	\N	194511	194511	361681
25835	40674	4	applied	\N	\N	\N	\N	194512	194512	361682
25835	40675	5	applied	\N	\N	\N	\N	194513	194513	194513
25835	40686	6	applied	\N	\N	\N	\N	194514	194514	361683
25835	40763	7	applied	\N	\N	\N	\N	194515	194515	361684
25839	40843	0	applied	\N	\N	\N	\N	194525	194525	361694
25839	40844	1	applied	\N	\N	\N	\N	194526	194526	361695
25839	40845	2	applied	\N	\N	\N	\N	194527	194527	361696
25842	40847	1	applied	\N	\N	\N	\N	194537	194537	361706
25842	40848	2	applied	\N	\N	\N	\N	194538	194538	361707
25842	40849	3	applied	\N	\N	\N	\N	194539	194539	361708
25844	40850	0	applied	\N	\N	\N	\N	194544	194544	361713
25844	40851	1	applied	\N	\N	\N	\N	194545	194545	361714
25844	40852	2	applied	\N	\N	\N	\N	194546	194546	361715
25844	40853	3	applied	\N	\N	\N	\N	194547	194547	361716
25852	40878	0	applied	\N	\N	\N	\N	194578	194578	361746
25852	40879	1	applied	\N	\N	\N	\N	194579	194579	361747
25852	40880	2	applied	\N	\N	\N	\N	194580	194580	361748
25854	40881	0	applied	\N	\N	\N	\N	194584	194584	361752
25854	40882	1	applied	\N	\N	\N	\N	194585	194585	361753
25854	40883	2	applied	\N	\N	\N	\N	194586	194586	361754
25857	40881	0	applied	\N	\N	\N	\N	194593	194593	361761
25857	40882	1	applied	\N	\N	\N	\N	194594	194594	361762
25857	40883	2	applied	\N	\N	\N	\N	194595	194595	361763
25863	40887	1	applied	\N	\N	\N	\N	194625	194625	361793
25863	40888	2	applied	\N	\N	\N	\N	194626	194626	361794
25863	40885	3	applied	\N	\N	\N	\N	194627	194627	361795
25863	40889	4	applied	\N	\N	\N	\N	194628	194628	361796
25863	40890	5	applied	\N	\N	\N	\N	194629	194629	361797
25863	40891	6	applied	\N	\N	\N	\N	194630	194630	361798
25863	40892	7	applied	\N	\N	\N	\N	194631	194631	361799
25865	40728	8	applied	\N	\N	\N	\N	194643	194643	361811
25865	40733	9	applied	\N	\N	\N	\N	194644	194644	361812
25865	40734	10	applied	\N	\N	\N	\N	194645	194645	361813
25865	40739	11	applied	\N	\N	\N	\N	194646	194646	361814
25865	40742	12	applied	\N	\N	\N	\N	194647	194647	361815
25865	40746	13	applied	\N	\N	\N	\N	194648	194648	361816
25865	40749	14	applied	\N	\N	\N	\N	194649	194649	361817
25865	40750	15	applied	\N	\N	\N	\N	194650	194650	361818
25865	40751	16	applied	\N	\N	\N	\N	194651	194651	361819
25865	40753	18	applied	\N	\N	\N	\N	194653	194653	361821
25865	40766	19	applied	\N	\N	\N	\N	194654	194654	361822
25865	40768	20	applied	\N	\N	\N	\N	194655	194655	361823
25865	40771	21	applied	\N	\N	\N	\N	194656	194656	361824
25865	40774	22	applied	\N	\N	\N	\N	194657	194657	361825
25865	40775	23	applied	\N	\N	\N	\N	194658	194658	361826
25865	40780	24	applied	\N	\N	\N	\N	194659	194659	361827
25865	40784	25	applied	\N	\N	\N	\N	194660	194660	361828
25865	40787	26	applied	\N	\N	\N	\N	194661	194661	361829
25865	40790	27	applied	\N	\N	\N	\N	194662	194662	361830
25865	40793	28	applied	\N	\N	\N	\N	194663	194663	361831
25865	40794	29	applied	\N	\N	\N	\N	194664	194664	361832
25865	40799	30	applied	\N	\N	\N	\N	194665	194665	361833
25865	40800	31	applied	\N	\N	\N	\N	194666	194666	361834
25865	40805	32	applied	\N	\N	\N	\N	194667	194667	361835
25865	40807	33	applied	\N	\N	\N	\N	194668	194668	361836
25865	40814	35	applied	\N	\N	\N	\N	194670	194670	361838
25865	40815	36	applied	\N	\N	\N	\N	194671	194671	361839
25865	40816	37	applied	\N	\N	\N	\N	194672	194672	361840
25865	40823	38	applied	\N	\N	\N	\N	194673	194673	361841
25865	40826	39	applied	\N	\N	\N	\N	194674	194674	361842
25865	40829	40	applied	\N	\N	\N	\N	194675	194675	361843
25865	40830	41	applied	\N	\N	\N	\N	194676	194676	361844
25865	40836	42	applied	\N	\N	\N	\N	194677	194677	361845
25865	40839	43	applied	\N	\N	\N	\N	194678	194678	361846
25865	40843	44	applied	\N	\N	\N	\N	194679	194679	361847
25865	40846	45	applied	\N	\N	\N	\N	194680	194680	361848
25865	40850	46	applied	\N	\N	\N	\N	194681	194681	361849
25865	40854	47	applied	\N	\N	\N	\N	194682	194682	361850
25865	40856	48	applied	\N	\N	\N	\N	194683	194683	361851
25865	40857	49	applied	\N	\N	\N	\N	194684	194684	361852
25865	40862	50	applied	\N	\N	\N	\N	194685	194685	361853
25865	40864	52	applied	\N	\N	\N	\N	194687	194687	361855
25865	40872	53	applied	\N	\N	\N	\N	194688	194688	361856
25865	40873	54	applied	\N	\N	\N	\N	194689	194689	361857
25865	40878	55	applied	\N	\N	\N	\N	194690	194690	361858
25865	40881	56	applied	\N	\N	\N	\N	194691	194691	361859
25865	40884	57	applied	\N	\N	\N	\N	194692	194692	361860
25865	40887	58	applied	\N	\N	\N	\N	194693	194693	361861
25868	40902	0	applied	\N	\N	\N	\N	194769	194769	361936
25868	40903	1	applied	\N	\N	\N	\N	194770	194770	361937
25868	40904	2	applied	\N	\N	\N	\N	194771	194771	361938
25872	40903	0	applied	\N	\N	\N	\N	194781	194781	361948
25876	40905	0	applied	\N	\N	\N	\N	194800	194800	361967
25876	40906	1	applied	\N	\N	\N	\N	194801	194801	361968
25876	40907	2	applied	\N	\N	\N	\N	194802	194802	361969
25876	40908	3	applied	\N	\N	\N	\N	194803	194803	361970
25876	40909	4	applied	\N	\N	\N	\N	194804	194804	361971
25816	40796	3	applied	\N	\N	\N	\N	194406	194406	361576
25816	40797	4	applied	\N	\N	\N	\N	194407	194407	361577
25864	40895	2	applied	\N	\N	\N	\N	194634	194634	361802
25867	40902	0	applied	\N	\N	\N	\N	194766	194766	361933
25867	40903	1	applied	\N	\N	\N	\N	194767	194767	361934
25867	40904	2	applied	\N	\N	\N	\N	194768	194768	361935
25869	40902	0	applied	\N	\N	\N	\N	194772	194772	361939
25869	40903	1	applied	\N	\N	\N	\N	194773	194773	361940
25869	40904	2	applied	\N	\N	\N	\N	194774	194774	361941
25874	40905	0	applied	\N	\N	\N	\N	194788	194788	361955
25874	40906	1	applied	\N	\N	\N	\N	194789	194789	361956
25874	40907	2	applied	\N	\N	\N	\N	194790	194790	361957
25874	40908	3	applied	\N	\N	\N	\N	194791	194791	361958
25874	40909	4	applied	\N	\N	\N	\N	194792	194792	361959
25874	40910	5	applied	\N	\N	\N	\N	194793	194793	361960
25877	40906	1	applied	\N	\N	\N	\N	194807	194807	361974
25877	40907	2	applied	\N	\N	\N	\N	194808	194808	361975
25877	40908	3	applied	\N	\N	\N	\N	194809	194809	361976
25877	40909	4	applied	\N	\N	\N	\N	194810	194810	361977
25877	40910	5	applied	\N	\N	\N	\N	194811	194811	361978
25878	40911	0	applied	\N	\N	\N	\N	194812	194812	361979
25878	40912	1	applied	\N	\N	\N	\N	194813	194813	361980
25878	40913	2	applied	\N	\N	\N	\N	194814	194814	361981
25878	40914	3	applied	\N	\N	\N	\N	194815	194815	361982
25878	40915	4	applied	\N	\N	\N	\N	194816	194816	361983
25878	40916	5	applied	\N	\N	\N	\N	194817	194817	361984
25879	40911	0	applied	\N	\N	\N	\N	194818	194818	361985
25879	40912	1	applied	\N	\N	\N	\N	194819	194819	361986
25879	40913	2	applied	\N	\N	\N	\N	194820	194820	361987
25879	40914	3	applied	\N	\N	\N	\N	194821	194821	361988
25879	40915	4	applied	\N	\N	\N	\N	194822	194822	361989
25883	40919	0	applied	\N	\N	\N	\N	194830	194830	361997
25883	40920	1	applied	\N	\N	\N	\N	194831	194831	361998
25884	40921	0	applied	\N	\N	\N	\N	194832	194832	361999
25884	40922	1	applied	\N	\N	\N	\N	194833	194833	362000
25885	40921	0	applied	\N	\N	\N	\N	194834	194834	362001
25885	40922	1	applied	\N	\N	\N	\N	194835	194835	362002
25886	40923	0	applied	\N	\N	\N	\N	194836	194836	362003
25886	40924	1	applied	\N	\N	\N	\N	194837	194837	362004
25890	40929	0	applied	\N	\N	\N	\N	194850	194850	362017
25890	40930	1	applied	\N	\N	\N	\N	194851	194851	362018
25891	40929	0	applied	\N	\N	\N	\N	194852	194852	362019
25891	40930	1	applied	\N	\N	\N	\N	194853	194853	362020
25892	40931	0	applied	\N	\N	\N	\N	194854	194854	362021
25892	40932	1	applied	\N	\N	\N	\N	194855	194855	362022
25893	40931	0	applied	\N	\N	\N	\N	194856	194856	362023
25893	40932	1	applied	\N	\N	\N	\N	194857	194857	362024
25895	40936	1	applied	\N	\N	\N	\N	194861	194861	362028
25895	40937	2	applied	\N	\N	\N	\N	194862	194862	362029
25895	40938	3	applied	\N	\N	\N	\N	194863	194863	362030
25895	40939	4	applied	\N	\N	\N	\N	194864	194864	362031
25895	40940	5	applied	\N	\N	\N	\N	194865	194865	362032
25895	40941	6	applied	\N	\N	\N	\N	194866	194866	362033
25895	40942	7	applied	\N	\N	\N	\N	194867	194867	362034
25895	40943	8	applied	\N	\N	\N	\N	194868	194868	362035
25895	40944	9	applied	\N	\N	\N	\N	194869	194869	362036
25895	40945	10	applied	\N	\N	\N	\N	194870	194870	362037
25896	40935	0	applied	\N	\N	\N	\N	194871	194871	362038
25896	40936	1	applied	\N	\N	\N	\N	194872	194872	362039
25896	40937	2	applied	\N	\N	\N	\N	194873	194873	362040
25896	40938	3	applied	\N	\N	\N	\N	194874	194874	362041
25896	40939	4	applied	\N	\N	\N	\N	194875	194875	362042
25896	40940	5	applied	\N	\N	\N	\N	194876	194876	362043
25896	40942	7	applied	\N	\N	\N	\N	194878	194878	362045
25896	40943	8	applied	\N	\N	\N	\N	194879	194879	362046
25896	40944	9	applied	\N	\N	\N	\N	194880	194880	362047
25896	40945	10	applied	\N	\N	\N	\N	194881	194881	362048
25897	40946	0	applied	\N	\N	\N	\N	194882	194882	362049
25897	40947	1	applied	\N	\N	\N	\N	194883	194883	362050
25899	40948	0	applied	\N	\N	1000000000	\N	194887	194887	362054
25899	40949	1	applied	\N	\N	\N	\N	194888	194888	362055
25899	40950	2	applied	\N	\N	\N	\N	194889	194889	362056
25900	40948	0	applied	\N	\N	1000000000	\N	194890	194890	362057
25900	40949	1	applied	\N	\N	\N	\N	194891	194891	362058
25900	40950	2	applied	\N	\N	\N	\N	194892	194892	362059
25904	40953	0	applied	\N	\N	\N	\N	194897	194897	362064
25904	40954	1	applied	\N	\N	\N	\N	194898	194898	362065
25905	40953	0	applied	\N	\N	\N	\N	194899	194899	362066
25905	40954	1	applied	\N	\N	\N	\N	194900	194900	362067
25907	40956	1	applied	\N	\N	\N	\N	194909	194909	362076
25907	40957	2	applied	\N	\N	\N	\N	194910	194910	362077
25907	40958	3	applied	\N	\N	\N	\N	194911	194911	362078
25907	40959	4	applied	\N	\N	\N	\N	194912	194912	362079
25907	40960	5	applied	\N	\N	\N	\N	194913	194913	362080
25907	40961	6	applied	\N	\N	\N	\N	194914	194914	362081
25909	40962	0	applied	\N	\N	\N	\N	194922	194922	362089
25909	40963	1	applied	\N	\N	\N	\N	194923	194923	362090
25910	40962	0	applied	\N	\N	\N	\N	194924	194924	362091
25910	40963	1	applied	\N	\N	\N	\N	194925	194925	362092
25911	40962	0	applied	\N	\N	\N	\N	194926	194926	362093
25911	40963	1	applied	\N	\N	\N	\N	194927	194927	362094
25912	40964	0	applied	\N	\N	\N	\N	194928	194928	362095
25912	40965	1	applied	\N	\N	\N	\N	194929	194929	362096
25914	40964	0	applied	\N	\N	\N	\N	194932	194932	362099
25917	40970	0	applied	\N	\N	\N	\N	194941	194941	362108
25918	40970	0	applied	\N	\N	\N	\N	194943	194943	362110
25918	40971	1	applied	\N	\N	\N	\N	194944	194944	362111
25919	40970	0	applied	\N	\N	\N	\N	194945	194945	362112
25919	40971	1	applied	\N	\N	\N	\N	194946	194946	362113
25920	40972	0	applied	\N	\N	\N	\N	194947	194947	362114
25920	40973	1	applied	\N	\N	\N	\N	194948	194948	362115
25921	40972	0	applied	\N	\N	\N	\N	194949	194949	362116
25921	40973	1	applied	\N	\N	\N	\N	194950	194950	362117
25922	40972	0	applied	\N	\N	\N	\N	194951	194951	362118
25922	40973	1	applied	\N	\N	\N	\N	194952	194952	362119
25923	40972	0	applied	\N	\N	\N	\N	194953	194953	362120
25923	40973	1	applied	\N	\N	\N	\N	194954	194954	362121
25925	40976	0	applied	\N	\N	\N	\N	194957	194957	362124
25925	40977	1	applied	\N	\N	\N	\N	194958	194958	362125
25929	40988	0	applied	\N	\N	\N	\N	194971	194971	362138
25929	40989	1	applied	\N	\N	\N	\N	194972	194972	362139
25864	40893	0	applied	\N	\N	\N	\N	194632	194632	361800
25864	40894	1	applied	\N	\N	\N	\N	194633	194633	361801
25865	40897	62	applied	\N	\N	\N	\N	194697	194697	361865
25865	40867	63	applied	\N	\N	\N	\N	194698	194698	194698
25865	40707	64	applied	\N	\N	\N	\N	194699	194699	361866
25865	40710	65	applied	\N	\N	\N	\N	194700	194700	361867
25865	40714	66	applied	\N	\N	\N	\N	194701	194701	361868
25865	40831	67	applied	\N	\N	1000000000	\N	194702	194702	361869
25865	40744	68	applied	\N	\N	1000000000	\N	194703	194703	361870
25865	40842	69	applied	\N	\N	\N	\N	194704	194704	361871
25865	40755	70	applied	\N	\N	\N	\N	194705	194705	361872
25865	40708	71	applied	\N	\N	\N	\N	194706	194706	361873
25865	40711	72	applied	\N	\N	\N	\N	194707	194707	361874
25865	40717	74	applied	\N	\N	\N	\N	194709	194709	361876
25865	40718	75	applied	\N	\N	\N	\N	194710	194710	361877
25865	40722	76	applied	\N	\N	\N	\N	194711	194711	361878
25865	40725	77	applied	\N	\N	\N	\N	194712	194712	361879
25865	40729	78	applied	\N	\N	\N	\N	194713	194713	361880
25865	40847	80	applied	\N	\N	\N	\N	194714	194714	361881
25865	40719	81	applied	\N	\N	\N	\N	194715	194715	361882
25865	40720	82	applied	\N	\N	\N	\N	194716	194716	361883
25865	40723	83	applied	\N	\N	\N	\N	194717	194717	361884
25865	40726	84	applied	\N	\N	\N	\N	194718	194718	361885
25865	40730	85	applied	\N	\N	\N	\N	194719	194719	361886
25865	40731	86	applied	\N	\N	\N	\N	194720	194720	361887
25865	40737	87	applied	\N	\N	\N	\N	194721	194721	361888
25865	40738	88	applied	\N	\N	\N	\N	194722	194722	361889
25865	40741	89	applied	\N	\N	\N	\N	194723	194723	361890
25865	40763	90	applied	\N	\N	\N	\N	194724	194724	361891
25865	40748	92	applied	\N	\N	\N	\N	194726	194726	361893
25865	40760	93	applied	\N	\N	\N	\N	194727	194727	361894
25865	40761	94	applied	\N	\N	\N	\N	194728	194728	361895
25865	40762	95	applied	\N	\N	\N	\N	194729	194729	361896
25865	40764	96	applied	\N	\N	\N	\N	194730	194730	361897
25865	40765	97	applied	\N	\N	\N	\N	194731	194731	361898
25865	40767	98	applied	\N	\N	\N	\N	194732	194732	361899
25865	40770	99	applied	\N	\N	\N	\N	194733	194733	361900
25865	40772	100	applied	\N	\N	\N	\N	194734	194734	361901
25865	40776	101	applied	\N	\N	\N	\N	194735	194735	361902
25865	40779	102	applied	\N	\N	\N	\N	194736	194736	361903
25865	40783	103	applied	\N	\N	\N	\N	194737	194737	361904
25865	40786	104	applied	\N	\N	\N	\N	194738	194738	361905
25865	40789	105	applied	\N	\N	\N	\N	194739	194739	361906
25865	40791	106	applied	\N	\N	\N	\N	194740	194740	361907
25865	40797	107	applied	\N	\N	\N	\N	194741	194741	361908
25865	40803	109	applied	\N	\N	\N	\N	194743	194743	361910
25865	40804	110	applied	\N	\N	\N	\N	194744	194744	361911
25865	40806	111	applied	\N	\N	\N	\N	194745	194745	361912
25865	40809	112	applied	\N	\N	\N	\N	194746	194746	361913
25865	40810	113	applied	\N	\N	\N	\N	194747	194747	361914
25865	40819	114	applied	\N	\N	\N	\N	194748	194748	361915
25865	40820	115	applied	\N	\N	\N	\N	194749	194749	361916
25865	40821	116	applied	\N	\N	\N	\N	194750	194750	361917
25865	40824	117	applied	\N	\N	\N	\N	194751	194751	361918
25865	40828	118	applied	\N	\N	\N	\N	194752	194752	361919
25865	40832	119	applied	\N	\N	\N	\N	194753	194753	361920
25865	40833	120	applied	\N	\N	\N	\N	194754	194754	361921
25865	40837	121	applied	\N	\N	\N	\N	194755	194755	361922
25865	40841	122	applied	\N	\N	\N	\N	194756	194756	361923
25865	40844	123	applied	\N	\N	\N	\N	194757	194757	361924
25865	40848	124	applied	\N	\N	\N	\N	194758	194758	361925
25870	40902	0	applied	\N	\N	\N	\N	194775	194775	361942
25870	40903	1	applied	\N	\N	\N	\N	194776	194776	361943
25932	40996	1	applied	\N	\N	\N	\N	194981	194981	362148
25932	40997	2	applied	\N	\N	\N	\N	194982	194982	362149
25932	40998	3	applied	\N	\N	\N	\N	194983	194983	362150
25939	41010	0	applied	\N	\N	\N	\N	195006	195006	362173
25939	41011	1	applied	\N	\N	\N	\N	195007	195007	362174
25939	41012	2	applied	\N	\N	\N	\N	195008	195008	362175
25939	41013	3	applied	\N	\N	\N	\N	195009	195009	362176
25939	41014	4	applied	\N	\N	\N	\N	195010	195010	362177
25939	41015	5	applied	\N	\N	\N	\N	195011	195011	362178
25939	41016	6	applied	\N	\N	\N	\N	195012	195012	362179
25939	41017	8	applied	\N	\N	\N	\N	195013	195013	362180
25939	41018	9	applied	\N	\N	\N	\N	195014	195014	362181
25943	41019	0	applied	\N	\N	\N	\N	195042	195042	362209
25946	41019	0	applied	\N	\N	\N	\N	195048	195048	362215
25946	41021	2	applied	\N	\N	\N	\N	195050	195050	362217
25946	41022	3	applied	\N	\N	\N	\N	195051	195051	362218
25946	41023	4	applied	\N	\N	\N	\N	195052	195052	362219
25952	41024	0	applied	\N	\N	\N	\N	195061	195061	362228
25952	41025	1	applied	\N	\N	\N	\N	195062	195062	362229
25952	41026	2	applied	\N	\N	\N	\N	195063	195063	362230
25952	41027	3	applied	\N	\N	\N	\N	195064	195064	362231
25954	40992	0	applied	\N	\N	\N	\N	195067	195067	362234
25954	41030	1	applied	\N	\N	\N	\N	195068	195068	362235
25954	40961	2	applied	\N	\N	\N	\N	195069	195069	362236
25957	41033	0	applied	\N	\N	\N	\N	195076	195076	362243
25957	41034	1	applied	\N	\N	\N	\N	195077	195077	362244
25957	41035	2	applied	\N	\N	\N	\N	195078	195078	362245
25957	41036	3	applied	\N	\N	\N	\N	195079	195079	362246
25959	41033	0	applied	\N	\N	\N	\N	195084	195084	362251
25959	41034	1	applied	\N	\N	\N	\N	195085	195085	362252
25959	41036	3	applied	\N	\N	\N	\N	195087	195087	362254
25961	41037	0	applied	\N	\N	\N	\N	195090	195090	362257
25961	41038	1	applied	\N	\N	\N	\N	195091	195091	362258
25969	41044	0	applied	\N	\N	\N	\N	195125	195125	362292
25969	41045	1	applied	\N	\N	\N	\N	195126	195126	362293
25969	41046	2	applied	\N	\N	\N	\N	195127	195127	362294
25969	41047	3	applied	\N	\N	\N	\N	195128	195128	362295
25973	41052	0	applied	\N	\N	\N	\N	195135	195135	362302
25973	41053	1	applied	\N	\N	\N	\N	195136	195136	362303
25975	41042	0	applied	\N	\N	1000000000	\N	195139	195139	362306
25978	41058	0	applied	\N	\N	\N	\N	195144	195144	362311
25978	41059	1	applied	\N	\N	\N	\N	195145	195145	362312
25978	41060	2	applied	\N	\N	\N	\N	195146	195146	362313
25978	41061	3	applied	\N	\N	\N	\N	195147	195147	362314
25983	41068	0	applied	\N	\N	\N	\N	195156	195156	362323
25983	41069	1	applied	\N	\N	\N	\N	195157	195157	362324
25986	41077	1	applied	\N	\N	\N	\N	195167	195167	362334
25988	41078	0	applied	\N	\N	\N	\N	195170	195170	362337
25865	40893	60	applied	\N	\N	\N	\N	194695	194695	361863
25865	40896	61	applied	\N	\N	\N	\N	194696	194696	361864
25875	40907	2	applied	\N	\N	\N	\N	194796	194796	361963
25875	40908	3	applied	\N	\N	\N	\N	194797	194797	361964
25875	40909	4	applied	\N	\N	\N	\N	194798	194798	361965
25875	40910	5	applied	\N	\N	\N	\N	194799	194799	361966
25881	40917	0	applied	\N	\N	\N	\N	194826	194826	361993
25881	40918	1	applied	\N	\N	\N	\N	194827	194827	361994
25888	40925	0	applied	\N	\N	\N	\N	194842	194842	362009
25888	40926	1	applied	\N	\N	\N	\N	194843	194843	362010
25888	40927	2	applied	\N	\N	\N	\N	194844	194844	362011
25888	40928	3	applied	\N	\N	\N	\N	194845	194845	362012
25898	40948	0	applied	\N	\N	1000000000	\N	194884	194884	362051
25898	40949	1	applied	\N	\N	\N	\N	194885	194885	362052
25898	40950	2	applied	\N	\N	\N	\N	194886	194886	362053
25901	40952	1	applied	\N	\N	\N	\N	194894	194894	362061
25902	40951	0	applied	\N	\N	\N	\N	194895	194895	362062
25902	40952	1	applied	\N	\N	\N	\N	194896	194896	362063
25906	40955	0	applied	\N	\N	\N	\N	194901	194901	362068
25906	40956	1	applied	\N	\N	\N	\N	194902	194902	362069
25906	40957	2	applied	\N	\N	\N	\N	194903	194903	362070
25906	40958	3	applied	\N	\N	\N	\N	194904	194904	362071
25906	40959	4	applied	\N	\N	\N	\N	194905	194905	362072
25906	40960	5	applied	\N	\N	\N	\N	194906	194906	362073
25906	40961	6	applied	\N	\N	\N	\N	194907	194907	362074
25908	40955	0	applied	\N	\N	\N	\N	194915	194915	362082
25908	40956	1	applied	\N	\N	\N	\N	194916	194916	362083
25908	40957	2	applied	\N	\N	\N	\N	194917	194917	362084
25908	40958	3	applied	\N	\N	\N	\N	194918	194918	362085
25908	40959	4	applied	\N	\N	\N	\N	194919	194919	362086
25908	40960	5	applied	\N	\N	\N	\N	194920	194920	362087
25913	40964	0	applied	\N	\N	\N	\N	194930	194930	362097
25913	40965	1	applied	\N	\N	\N	\N	194931	194931	362098
25915	40966	0	applied	\N	\N	\N	\N	194933	194933	362100
25915	40967	1	applied	\N	\N	\N	\N	194934	194934	362101
25915	40968	2	applied	\N	\N	\N	\N	194935	194935	362102
25915	40969	3	applied	\N	\N	\N	\N	194936	194936	362103
25916	40966	0	applied	\N	\N	\N	\N	194937	194937	362104
25916	40967	1	applied	\N	\N	\N	\N	194938	194938	362105
25916	40968	2	applied	\N	\N	\N	\N	194939	194939	362106
25916	40969	3	applied	\N	\N	\N	\N	194940	194940	362107
25924	40974	0	applied	\N	\N	\N	\N	194955	194955	362122
25924	40975	1	applied	\N	\N	\N	\N	194956	194956	362123
25926	40982	0	applied	\N	\N	\N	\N	194963	194963	362130
25926	40983	1	applied	\N	\N	\N	\N	194964	194964	362131
25927	40982	0	applied	\N	\N	\N	\N	194965	194965	362132
25927	40983	1	applied	\N	\N	\N	\N	194966	194966	362133
25931	40991	1	applied	\N	\N	\N	\N	194976	194976	362143
25931	40992	2	applied	\N	\N	\N	\N	194977	194977	362144
25931	40993	3	applied	\N	\N	\N	\N	194978	194978	362145
25931	40994	4	applied	\N	\N	\N	\N	194979	194979	362146
25934	40999	0	applied	\N	\N	\N	\N	194988	194988	362155
25934	41000	1	applied	\N	\N	\N	\N	194989	194989	362156
25935	41001	0	applied	\N	\N	\N	\N	194990	194990	362157
25935	41002	1	applied	\N	\N	\N	\N	194991	194991	362158
25936	41003	0	applied	\N	\N	\N	\N	194992	194992	362159
25936	41004	1	applied	\N	\N	\N	\N	194993	194993	362160
25936	41005	2	applied	\N	\N	\N	\N	194994	194994	362161
25936	41006	3	applied	\N	\N	\N	\N	194995	194995	362162
25936	41007	4	applied	\N	\N	\N	\N	194996	194996	362163
25936	41008	5	applied	\N	\N	\N	\N	194997	194997	362164
25937	41009	0	applied	\N	\N	\N	\N	194998	194998	362165
25938	41010	0	applied	\N	\N	\N	\N	194999	194999	362166
25938	41012	2	applied	\N	\N	\N	\N	195001	195001	362168
25938	41013	3	applied	\N	\N	\N	\N	195002	195002	362169
25938	41014	4	applied	\N	\N	\N	\N	195003	195003	362170
25938	41015	5	applied	\N	\N	\N	\N	195004	195004	362171
25938	41016	6	applied	\N	\N	\N	\N	195005	195005	362172
25940	41010	0	applied	\N	\N	\N	\N	195015	195015	362182
25940	41011	1	applied	\N	\N	\N	\N	195016	195016	362183
25940	41012	2	applied	\N	\N	\N	\N	195017	195017	362184
25940	41013	3	applied	\N	\N	\N	\N	195018	195018	362185
25940	41014	4	applied	\N	\N	\N	\N	195019	195019	362186
25940	41015	5	applied	\N	\N	\N	\N	195020	195020	362187
25940	41016	6	applied	\N	\N	\N	\N	195021	195021	362188
25940	41017	8	applied	\N	\N	\N	\N	195022	195022	362189
25940	41018	9	applied	\N	\N	\N	\N	195023	195023	362190
25942	41010	0	applied	\N	\N	\N	\N	195033	195033	362200
25942	41011	1	applied	\N	\N	\N	\N	195034	195034	362201
25942	41013	3	applied	\N	\N	\N	\N	195036	195036	362203
25942	41014	4	applied	\N	\N	\N	\N	195037	195037	362204
25942	41015	5	applied	\N	\N	\N	\N	195038	195038	362205
25942	41016	6	applied	\N	\N	\N	\N	195039	195039	362206
25942	41017	8	applied	\N	\N	\N	\N	195040	195040	362207
25942	41018	9	applied	\N	\N	\N	\N	195041	195041	362208
25948	41020	0	applied	\N	\N	\N	\N	195053	195053	362220
25948	41021	1	applied	\N	\N	\N	\N	195054	195054	362221
25948	41022	2	applied	\N	\N	\N	\N	195055	195055	362222
25948	41023	3	applied	\N	\N	\N	\N	195056	195056	362223
25955	41030	0	applied	\N	\N	\N	\N	195070	195070	362237
25955	41031	1	applied	\N	\N	\N	\N	195071	195071	362238
25956	41030	0	applied	\N	\N	\N	\N	195073	195073	362240
25956	41031	1	applied	\N	\N	\N	\N	195074	195074	362241
25956	41032	2	applied	\N	\N	\N	\N	195075	195075	362242
25964	41039	0	applied	\N	\N	\N	\N	195102	195102	362269
25964	41041	2	applied	\N	\N	\N	\N	195104	195104	362271
25964	41042	3	applied	\N	\N	1000000000	\N	195105	195105	362272
25964	41043	4	applied	\N	\N	\N	\N	195106	195106	362273
25968	41044	0	applied	\N	\N	\N	\N	195121	195121	362288
25968	41045	1	applied	\N	\N	\N	\N	195122	195122	362289
25968	41046	2	applied	\N	\N	\N	\N	195123	195123	362290
25968	41047	3	applied	\N	\N	\N	\N	195124	195124	362291
25970	41048	0	applied	\N	\N	\N	\N	195129	195129	362296
25970	41049	1	applied	\N	\N	\N	\N	195130	195130	362297
25972	41050	0	applied	\N	\N	\N	\N	195133	195133	362300
25972	41051	1	applied	\N	\N	\N	\N	195134	195134	362301
25980	41064	0	applied	\N	\N	\N	\N	195150	195150	362317
25980	41065	1	applied	\N	\N	\N	\N	195151	195151	362318
25985	41070	0	applied	\N	\N	\N	\N	195160	195160	362327
25985	41071	1	applied	\N	\N	\N	\N	195161	195161	362328
25985	41072	2	applied	\N	\N	\N	\N	195162	195162	362329
25875	40905	0	applied	\N	\N	\N	\N	194794	194794	361961
25875	40906	1	applied	\N	\N	\N	\N	194795	194795	361962
25928	40984	0	applied	\N	\N	\N	\N	194967	194967	362134
25928	40985	1	applied	\N	\N	\N	\N	194968	194968	362135
25928	40986	2	applied	\N	\N	\N	\N	194969	194969	362136
25928	40987	3	applied	\N	\N	\N	\N	194970	194970	362137
25930	40988	0	applied	\N	\N	\N	\N	194973	194973	362140
25930	40989	1	applied	\N	\N	\N	\N	194974	194974	362141
25933	40995	0	applied	\N	\N	\N	\N	194984	194984	362151
25933	40996	1	applied	\N	\N	\N	\N	194985	194985	362152
25933	40997	2	applied	\N	\N	\N	\N	194986	194986	362153
25933	40998	3	applied	\N	\N	\N	\N	194987	194987	362154
25941	41010	0	applied	\N	\N	\N	\N	195024	195024	362191
25941	41011	1	applied	\N	\N	\N	\N	195025	195025	362192
25941	41013	3	applied	\N	\N	\N	\N	195027	195027	362194
25941	41014	4	applied	\N	\N	\N	\N	195028	195028	362195
25941	41015	5	applied	\N	\N	\N	\N	195029	195029	362196
25941	41016	6	applied	\N	\N	\N	\N	195030	195030	362197
25941	41017	8	applied	\N	\N	\N	\N	195031	195031	362198
25941	41018	9	applied	\N	\N	\N	\N	195032	195032	362199
25945	41019	0	applied	\N	\N	\N	\N	195043	195043	362210
25945	41020	1	applied	\N	\N	\N	\N	195044	195044	362211
25945	41021	2	applied	\N	\N	\N	\N	195045	195045	362212
25945	41022	3	applied	\N	\N	\N	\N	195046	195046	362213
25945	41023	4	applied	\N	\N	\N	\N	195047	195047	362214
25951	41024	0	applied	\N	\N	\N	\N	195057	195057	362224
25951	41025	1	applied	\N	\N	\N	\N	195058	195058	362225
25951	41026	2	applied	\N	\N	\N	\N	195059	195059	362226
25951	41027	3	applied	\N	\N	\N	\N	195060	195060	362227
25953	41028	0	applied	\N	\N	\N	\N	195065	195065	362232
25958	41033	0	applied	\N	\N	\N	\N	195080	195080	362247
25958	41034	1	applied	\N	\N	\N	\N	195081	195081	362248
25958	41035	2	applied	\N	\N	\N	\N	195082	195082	362249
25958	41036	3	applied	\N	\N	\N	\N	195083	195083	362250
25960	41037	0	applied	\N	\N	\N	\N	195088	195088	362255
25960	41038	1	applied	\N	\N	\N	\N	195089	195089	362256
25963	41039	0	applied	\N	\N	\N	\N	195097	195097	362264
25963	41040	1	applied	\N	\N	\N	\N	195098	195098	362265
25963	41041	2	applied	\N	\N	\N	\N	195099	195099	362266
25963	41042	3	applied	\N	\N	1000000000	\N	195100	195100	362267
25963	41043	4	applied	\N	\N	\N	\N	195101	195101	362268
25967	41044	0	applied	\N	\N	\N	\N	195117	195117	362284
25967	41045	1	applied	\N	\N	\N	\N	195118	195118	362285
25967	41046	2	applied	\N	\N	\N	\N	195119	195119	362286
25967	41047	3	applied	\N	\N	\N	\N	195120	195120	362287
25974	41054	0	applied	\N	\N	\N	\N	195137	195137	362304
25977	41056	0	applied	\N	\N	\N	\N	195142	195142	362309
25977	41057	1	applied	\N	\N	\N	\N	195143	195143	362310
25979	41062	0	applied	\N	\N	\N	\N	195148	195148	362315
25979	41063	1	applied	\N	\N	\N	\N	195149	195149	362316
25982	41068	0	applied	\N	\N	\N	\N	195154	195154	362321
25982	41069	1	applied	\N	\N	\N	\N	195155	195155	362322
25984	41068	0	applied	\N	\N	\N	\N	195158	195158	362325
25984	41069	1	applied	\N	\N	\N	\N	195159	195159	362326
25985	41074	4	applied	\N	\N	\N	\N	195164	195164	362331
25985	41075	5	applied	\N	\N	\N	\N	195165	195165	362332
25987	41078	0	applied	\N	\N	\N	\N	195168	195168	362335
25987	41079	1	applied	\N	\N	\N	\N	195169	195169	362336
25990	41080	0	applied	\N	\N	\N	\N	195174	195174	362341
25990	41081	1	applied	\N	\N	\N	\N	195175	195175	362342
25992	41084	0	applied	\N	\N	\N	\N	195178	195178	362345
25992	41085	1	applied	\N	\N	\N	\N	195179	195179	362346
25995	41087	1	applied	\N	\N	\N	\N	195187	195187	362354
25995	41088	2	applied	\N	\N	\N	\N	195188	195188	362355
25995	41089	3	applied	\N	\N	\N	\N	195189	195189	362356
25999	41090	0	applied	\N	\N	\N	\N	195190	195190	362357
25999	41091	1	applied	\N	\N	\N	\N	195191	195191	362358
25999	41092	2	applied	\N	\N	\N	\N	195192	195192	362359
25999	41093	3	applied	\N	\N	\N	\N	195193	195193	362360
25999	41094	4	applied	\N	\N	\N	\N	195194	195194	362361
26004	41097	0	applied	\N	\N	\N	\N	195222	195222	362388
26012	41120	0	applied	\N	\N	\N	\N	195250	195250	362416
26012	41121	1	applied	\N	\N	\N	\N	195251	195251	362417
26012	41122	2	applied	\N	\N	\N	\N	195252	195252	362418
26012	41123	3	applied	\N	\N	\N	\N	195253	195253	362419
26014	40351	0	applied	\N	\N	\N	\N	195258	195258	362424
26014	40354	1	applied	\N	\N	\N	\N	195259	195259	362425
26014	40356	2	applied	\N	\N	\N	\N	195260	195260	362426
26014	40360	4	applied	\N	\N	\N	\N	195262	195262	362428
26014	40992	5	applied	\N	\N	\N	\N	195263	195263	362429
26014	41030	6	applied	\N	\N	\N	\N	195264	195264	362430
26014	40363	7	applied	\N	\N	\N	\N	195265	195265	362431
26014	40366	8	applied	\N	\N	\N	\N	195266	195266	362432
26014	40367	9	applied	\N	\N	\N	\N	195267	195267	362433
26014	40372	10	applied	\N	\N	\N	\N	195268	195268	362434
26014	40373	11	applied	\N	\N	\N	\N	195269	195269	362435
26014	40378	12	applied	\N	\N	\N	\N	195270	195270	362436
26014	40379	13	applied	\N	\N	\N	\N	195271	195271	362437
26014	40384	14	applied	\N	\N	\N	\N	195272	195272	362438
26014	40387	15	applied	\N	\N	\N	\N	195273	195273	362439
26014	40388	16	applied	\N	\N	\N	\N	195274	195274	362440
26014	40393	17	applied	\N	\N	\N	\N	195275	195275	362441
26014	40396	18	applied	\N	\N	\N	\N	195276	195276	362442
26014	40399	19	applied	\N	\N	\N	\N	195277	195277	362443
26014	40402	20	applied	\N	\N	\N	\N	195278	195278	362444
26014	40403	21	applied	\N	\N	\N	\N	195279	195279	362445
26014	40410	23	applied	\N	\N	\N	\N	195281	195281	362447
26014	40417	24	applied	\N	\N	\N	\N	195282	195282	362448
26014	40418	25	applied	\N	\N	\N	\N	195283	195283	362449
26014	40421	26	applied	\N	\N	\N	\N	195284	195284	362450
26014	40422	27	applied	\N	\N	\N	\N	195285	195285	362451
26014	40427	28	applied	\N	\N	\N	\N	195286	195286	362452
26014	40428	29	applied	\N	\N	\N	\N	195287	195287	362453
26014	40433	30	applied	\N	\N	\N	\N	195288	195288	362454
26014	40434	31	applied	\N	\N	\N	\N	195289	195289	362455
26014	40438	32	applied	\N	\N	\N	\N	195290	195290	362456
26014	40441	33	applied	\N	\N	\N	\N	195291	195291	362457
26014	40442	34	applied	\N	\N	\N	\N	195292	195292	362458
26014	40447	35	applied	\N	\N	\N	\N	195293	195293	362459
26014	40448	36	applied	\N	\N	\N	\N	195294	195294	362460
26014	40453	37	applied	\N	\N	\N	\N	195295	195295	362461
25925	40979	3	applied	\N	\N	\N	\N	194960	194960	362127
25925	40981	5	applied	\N	\N	\N	\N	194962	194962	362129
25962	41041	2	applied	\N	\N	\N	\N	195094	195094	362261
25962	41042	3	applied	\N	\N	1000000000	\N	195095	195095	362262
25962	41043	4	applied	\N	\N	\N	\N	195096	195096	362263
25965	41039	0	applied	\N	\N	\N	\N	195107	195107	362274
25965	41040	1	applied	\N	\N	\N	\N	195108	195108	362275
25965	41041	2	applied	\N	\N	\N	\N	195109	195109	362276
25965	41042	3	applied	\N	\N	1000000000	\N	195110	195110	362277
25965	41043	4	applied	\N	\N	\N	\N	195111	195111	362278
25966	41039	0	applied	\N	\N	\N	\N	195112	195112	362279
25966	41041	2	applied	\N	\N	\N	\N	195114	195114	362281
25966	41042	3	applied	\N	\N	1000000000	\N	195115	195115	362282
25966	41043	4	applied	\N	\N	\N	\N	195116	195116	362283
25971	41048	0	applied	\N	\N	\N	\N	195131	195131	362298
25971	41049	1	applied	\N	\N	\N	\N	195132	195132	362299
25976	41056	0	applied	\N	\N	\N	\N	195140	195140	362307
25976	41057	1	applied	\N	\N	\N	\N	195141	195141	362308
25981	41066	0	applied	\N	\N	\N	\N	195152	195152	362319
25981	41067	1	applied	\N	\N	\N	\N	195153	195153	362320
25989	41080	0	applied	\N	\N	\N	\N	195172	195172	362339
25989	41081	1	applied	\N	\N	\N	\N	195173	195173	362340
25991	41082	0	applied	\N	\N	\N	\N	195176	195176	362343
25991	41083	1	applied	\N	\N	\N	\N	195177	195177	362344
25994	41086	0	applied	\N	\N	\N	\N	195182	195182	362349
25994	41087	1	applied	\N	\N	\N	\N	195183	195183	362350
25994	41088	2	applied	\N	\N	\N	\N	195184	195184	362351
26001	41090	0	applied	\N	\N	\N	\N	195202	195202	362369
26001	41091	1	applied	\N	\N	\N	\N	195203	195203	362370
26001	41095	2	applied	\N	\N	\N	\N	195204	195204	362371
26001	41092	3	applied	\N	\N	\N	\N	195205	195205	362372
26001	41093	4	applied	\N	\N	\N	\N	195206	195206	362373
26001	41096	5	applied	\N	\N	\N	\N	195207	195207	362374
26001	41094	6	applied	\N	\N	\N	\N	195208	195208	362375
26003	40992	0	applied	\N	\N	\N	\N	195218	195218	362384
26003	41030	1	applied	\N	\N	\N	\N	195219	195219	362385
26003	41042	2	applied	\N	\N	1000000000	\N	195220	195220	362386
26003	41094	3	applied	\N	\N	\N	\N	195221	195221	362387
26006	41099	0	applied	\N	\N	\N	\N	195225	195225	362391
26006	41100	1	applied	\N	\N	\N	\N	195226	195226	362392
26006	41101	2	applied	\N	\N	\N	\N	195227	195227	362393
26006	41102	3	applied	\N	\N	\N	\N	195228	195228	362394
26006	41098	4	applied	\N	\N	\N	\N	195229	195229	362395
26006	41104	6	applied	\N	\N	\N	\N	195231	195231	362397
26008	41108	0	applied	\N	\N	\N	\N	195235	195235	362401
26008	41109	1	applied	\N	\N	\N	\N	195236	195236	362402
26008	41110	2	applied	\N	\N	\N	\N	195237	195237	362403
26008	41111	3	applied	\N	\N	\N	\N	195238	195238	362404
26008	41112	4	applied	\N	\N	\N	\N	195239	195239	362405
26008	41113	5	applied	\N	\N	\N	\N	195240	195240	362406
26009	41114	0	applied	\N	\N	\N	\N	195241	195241	362407
26009	41115	1	applied	\N	\N	\N	\N	195242	195242	362408
26009	41116	2	applied	\N	\N	\N	\N	195243	195243	362409
26011	41117	0	applied	\N	\N	\N	\N	195247	195247	362413
26011	41118	1	applied	\N	\N	\N	\N	195248	195248	362414
26011	41119	2	applied	\N	\N	\N	\N	195249	195249	362415
26013	41120	0	applied	\N	\N	\N	\N	195254	195254	362420
26013	41121	1	applied	\N	\N	\N	\N	195255	195255	362421
26013	41122	2	applied	\N	\N	\N	\N	195256	195256	362422
26015	41124	0	applied	\N	\N	\N	\N	195383	195383	362549
26015	41125	1	applied	\N	\N	\N	\N	195384	195384	362550
26015	41126	2	applied	\N	\N	\N	\N	195385	195385	362551
26016	41124	0	applied	\N	\N	\N	\N	195386	195386	362552
26016	41125	1	applied	\N	\N	\N	\N	195387	195387	362553
26016	41126	2	applied	\N	\N	\N	\N	195388	195388	362554
26018	41127	0	applied	\N	\N	\N	\N	195389	195389	362555
26018	41128	1	applied	\N	\N	\N	\N	195390	195390	362556
26018	41129	2	applied	\N	\N	\N	\N	195391	195391	362557
26020	41127	0	applied	\N	\N	\N	\N	195393	195393	362559
26020	41128	1	applied	\N	\N	\N	\N	195394	195394	362560
26020	41129	2	applied	\N	\N	\N	\N	195395	195395	362561
26022	41132	0	applied	\N	\N	\N	\N	195398	195398	362564
26022	41133	1	applied	\N	\N	\N	\N	195399	195399	362565
26024	41134	0	applied	\N	\N	\N	\N	195402	195402	362568
26024	41135	1	applied	\N	\N	\N	\N	195403	195403	362569
26025	41135	1	applied	\N	\N	\N	\N	195405	195405	362571
26031	41138	0	applied	\N	\N	\N	\N	195414	195414	362580
26031	41139	1	applied	\N	\N	\N	\N	195415	195415	362581
26038	41142	0	applied	\N	\N	\N	\N	195547	195547	362713
26038	41143	1	applied	\N	\N	\N	\N	195548	195548	362714
26038	41144	2	applied	\N	\N	\N	\N	195549	195549	362715
26038	41145	3	applied	\N	\N	\N	\N	195550	195550	362716
26040	41146	0	applied	\N	\N	\N	\N	195555	195555	362721
26040	41147	1	applied	\N	\N	\N	\N	195556	195556	362722
26042	41148	0	applied	\N	\N	\N	\N	195559	195559	362725
26042	41149	1	applied	\N	\N	\N	\N	195560	195560	362726
26044	41148	0	applied	\N	\N	\N	\N	195563	195563	362729
26044	41149	1	applied	\N	\N	\N	\N	195564	195564	362730
26047	41156	0	applied	\N	\N	\N	\N	195571	195571	362737
26047	41157	1	applied	\N	\N	\N	\N	195572	195572	362738
26050	41169	0	applied	\N	\N	\N	\N	195586	195586	362752
26051	41180	1	applied	\N	\N	\N	\N	195597	195597	362763
26051	41181	2	applied	\N	\N	\N	\N	195598	195598	362764
26051	41182	3	applied	\N	\N	\N	\N	195599	195599	362765
26051	41183	4	applied	\N	\N	\N	\N	195600	195600	362766
26051	41184	5	applied	\N	\N	\N	\N	195601	195601	362767
26051	41185	6	applied	\N	\N	\N	\N	195602	195602	362768
26051	41186	7	applied	\N	\N	\N	\N	195603	195603	362769
26051	41187	8	applied	\N	\N	\N	\N	195604	195604	362770
26051	41188	9	applied	\N	\N	\N	\N	195605	195605	362771
26053	41179	0	applied	\N	\N	\N	\N	195608	195608	362774
26053	41180	1	applied	\N	\N	\N	\N	195609	195609	362775
26053	41181	2	applied	\N	\N	\N	\N	195610	195610	362776
26053	41182	3	applied	\N	\N	\N	\N	195611	195611	362777
26053	41183	4	applied	\N	\N	\N	\N	195612	195612	362778
26053	41184	5	applied	\N	\N	\N	\N	195613	195613	362779
26053	41185	6	applied	\N	\N	\N	\N	195614	195614	362780
26053	41189	8	applied	\N	\N	\N	\N	195616	195616	362782
26053	41190	9	applied	\N	\N	\N	\N	195617	195617	362783
26056	41191	0	applied	\N	\N	\N	\N	195628	195628	362794
26056	41192	1	applied	\N	\N	\N	\N	195629	195629	362795
25962	41039	0	applied	\N	\N	\N	\N	195092	195092	362259
25962	41040	1	applied	\N	\N	\N	\N	195093	195093	362260
26000	41090	0	applied	\N	\N	\N	\N	195195	195195	362362
26000	41091	1	applied	\N	\N	\N	\N	195196	195196	362363
26000	41095	2	applied	\N	\N	\N	\N	195197	195197	362364
26000	41092	3	applied	\N	\N	\N	\N	195198	195198	362365
26000	41093	4	applied	\N	\N	\N	\N	195199	195199	362366
26000	41096	5	applied	\N	\N	\N	\N	195200	195200	362367
26000	41094	6	applied	\N	\N	\N	\N	195201	195201	362368
26002	40948	0	applied	\N	\N	1000000000	\N	195209	195209	362376
26002	40867	1	applied	\N	\N	\N	\N	195210	195210	195210
26002	40744	3	applied	\N	\N	1000000000	\N	195212	195212	362378
26002	40842	4	applied	\N	\N	\N	\N	195213	195213	362379
26002	40755	5	applied	\N	\N	\N	\N	195214	195214	362380
26002	40961	6	applied	\N	\N	\N	\N	195215	195215	362381
26002	40847	7	applied	\N	\N	\N	\N	195216	195216	362382
26002	40763	8	applied	\N	\N	\N	\N	195217	195217	362383
26005	41097	0	applied	\N	\N	\N	\N	195223	195223	362389
26005	41098	1	applied	\N	\N	\N	\N	195224	195224	362390
26007	41105	0	applied	\N	\N	\N	\N	195232	195232	362398
26007	41106	1	applied	\N	\N	\N	\N	195233	195233	362399
26007	41107	2	applied	\N	\N	\N	\N	195234	195234	362400
26010	41117	0	applied	\N	\N	\N	\N	195244	195244	362410
26010	41118	1	applied	\N	\N	\N	\N	195245	195245	362411
26010	41119	2	applied	\N	\N	\N	\N	195246	195246	362412
26019	41129	0	applied	\N	\N	\N	\N	195392	195392	362558
26026	41136	0	applied	\N	\N	\N	\N	195406	195406	362572
26026	41137	1	applied	\N	\N	\N	\N	195407	195407	362573
26029	41138	0	applied	\N	\N	\N	\N	195410	195410	362576
26029	41139	1	applied	\N	\N	\N	\N	195411	195411	362577
26037	41142	0	applied	\N	\N	\N	\N	195543	195543	362709
26037	41144	2	applied	\N	\N	\N	\N	195545	195545	362711
26037	41145	3	applied	\N	\N	\N	\N	195546	195546	362712
26046	41152	0	applied	\N	\N	\N	\N	195567	195567	362733
26046	41153	1	applied	\N	\N	\N	\N	195568	195568	362734
26046	41154	2	applied	\N	\N	\N	\N	195569	195569	362735
26046	41155	3	applied	\N	\N	\N	\N	195570	195570	362736
26050	41170	2	applied	\N	\N	\N	\N	195587	195587	362753
26050	41171	3	applied	\N	\N	\N	\N	195588	195588	362754
26050	41172	4	applied	\N	\N	\N	\N	195589	195589	362755
26050	41173	5	applied	\N	\N	\N	\N	195590	195590	362756
26050	41174	6	applied	\N	\N	\N	\N	195591	195591	362757
26050	41175	7	applied	\N	\N	\N	\N	195592	195592	362758
26050	41176	8	applied	\N	\N	\N	\N	195593	195593	362759
26050	41177	9	applied	\N	\N	\N	\N	195594	195594	362760
26050	41178	10	applied	\N	\N	\N	\N	195595	195595	362761
26052	41187	0	applied	\N	\N	\N	\N	195606	195606	362772
26057	41191	0	applied	\N	\N	\N	\N	195630	195630	362796
26057	41192	1	applied	\N	\N	\N	\N	195631	195631	362797
26059	41195	0	applied	\N	\N	\N	\N	195634	195634	362800
26059	41196	1	applied	\N	\N	\N	\N	195635	195635	362801
26059	41197	2	applied	\N	\N	\N	\N	195636	195636	362802
26059	41198	3	applied	\N	\N	\N	\N	195637	195637	362803
26059	41199	4	applied	\N	\N	\N	\N	195638	195638	362804
26059	41200	5	applied	\N	\N	\N	\N	195639	195639	362805
26061	41201	0	applied	\N	\N	\N	\N	195703	195703	362869
26061	41202	1	applied	\N	\N	\N	\N	195704	195704	362870
26061	41203	2	applied	\N	\N	\N	\N	195705	195705	362871
26061	41204	3	applied	\N	\N	\N	\N	195706	195706	362872
26061	41205	4	applied	\N	\N	\N	\N	195707	195707	362873
26061	41206	5	applied	\N	\N	\N	\N	195708	195708	362874
26061	41207	6	applied	\N	\N	\N	\N	195709	195709	362875
26061	41208	7	applied	\N	\N	\N	\N	195710	195710	362876
26061	41210	9	applied	\N	\N	\N	\N	195712	195712	362878
26061	41211	10	applied	\N	\N	\N	\N	195713	195713	362879
26062	41212	0	applied	\N	\N	\N	\N	195714	195714	362880
26062	41213	1	applied	\N	\N	\N	\N	195715	195715	362881
26062	41214	2	applied	\N	\N	\N	\N	195716	195716	362882
26062	41215	3	applied	\N	\N	\N	\N	195717	195717	362883
26066	41231	0	applied	\N	\N	\N	\N	195746	195746	362912
26066	41232	1	applied	\N	\N	\N	\N	195747	195747	362913
26066	41233	2	applied	\N	\N	\N	\N	195748	195748	362914
26066	41234	3	applied	\N	\N	\N	\N	195749	195749	362915
26066	41235	4	applied	\N	\N	\N	\N	195750	195750	362916
26066	41236	5	applied	\N	\N	\N	\N	195751	195751	362917
26066	41237	6	applied	\N	\N	\N	\N	195752	195752	362918
26066	41238	7	applied	\N	\N	\N	\N	195753	195753	362919
26066	41239	8	applied	\N	\N	\N	\N	195754	195754	362920
26069	41246	0	applied	\N	\N	\N	\N	195767	195767	362933
26069	41248	2	applied	\N	\N	\N	\N	195769	195769	362935
26069	41249	3	applied	\N	\N	\N	\N	195770	195770	362936
26069	41250	4	applied	\N	\N	\N	\N	195771	195771	362937
26069	41251	5	applied	\N	\N	\N	\N	195772	195772	362938
26069	41252	6	applied	\N	\N	\N	\N	195773	195773	362939
26069	41253	7	applied	\N	\N	\N	\N	195774	195774	362940
26074	41258	0	applied	\N	\N	\N	\N	195791	195791	362957
26074	41259	1	applied	\N	\N	\N	\N	195792	195792	362958
26077	41260	0	applied	\N	\N	\N	\N	195797	195797	362963
26077	41261	1	applied	\N	\N	\N	\N	195798	195798	362964
26081	41264	0	applied	\N	\N	\N	\N	195805	195805	362971
26081	41265	2	applied	\N	\N	\N	\N	195806	195806	362972
26083	41264	0	applied	\N	\N	\N	\N	195809	195809	362975
26083	41265	2	applied	\N	\N	\N	\N	195810	195810	362976
26084	41266	0	applied	\N	\N	\N	\N	195811	195811	362977
26084	41267	1	applied	\N	\N	\N	\N	195812	195812	362978
26084	41269	3	applied	\N	\N	\N	\N	195814	195814	362980
26084	41270	4	applied	\N	\N	\N	\N	195815	195815	362981
26084	41271	5	applied	\N	\N	\N	\N	195816	195816	362982
26084	41272	6	applied	\N	\N	\N	\N	195817	195817	362983
26084	41273	7	applied	\N	\N	\N	\N	195818	195818	362984
26089	41278	0	applied	\N	\N	\N	\N	195827	195827	362993
26089	41279	1	applied	\N	\N	\N	\N	195828	195828	362994
26091	41280	0	applied	\N	\N	\N	\N	195831	195831	362997
26091	41281	1	applied	\N	\N	\N	\N	195832	195832	362998
26093	41282	0	applied	\N	\N	\N	\N	195835	195835	363001
26093	41283	1	applied	\N	\N	\N	\N	195836	195836	363002
26098	41291	0	applied	\N	\N	\N	\N	195968	195968	363134
26098	41292	1	applied	\N	\N	\N	\N	195969	195969	363135
26101	41298	0	applied	\N	\N	\N	\N	195975	195975	363141
26101	41299	1	applied	\N	\N	\N	\N	195976	195976	363142
26101	41300	2	applied	\N	\N	\N	\N	195977	195977	363143
25993	41084	0	applied	\N	\N	\N	\N	195180	195180	362347
25993	41085	1	applied	\N	\N	\N	\N	195181	195181	362348
26014	40468	42	applied	\N	\N	\N	\N	195300	195300	362466
26014	40471	43	applied	\N	\N	\N	\N	195301	195301	362467
26014	40474	44	applied	\N	\N	\N	\N	195302	195302	362468
26014	40475	45	applied	\N	\N	\N	\N	195303	195303	362469
26014	40480	46	applied	\N	\N	\N	\N	195304	195304	362470
26014	40481	47	applied	\N	\N	\N	\N	195305	195305	362471
26014	40486	48	applied	\N	\N	\N	\N	195306	195306	362472
26014	40489	49	applied	\N	\N	\N	\N	195307	195307	362473
26014	40495	50	applied	\N	\N	\N	\N	195308	195308	362474
26014	40498	51	applied	\N	\N	\N	\N	195309	195309	362475
26014	40499	52	applied	\N	\N	\N	\N	195310	195310	362476
26014	40504	53	applied	\N	\N	\N	\N	195311	195311	362477
26014	40505	54	applied	\N	\N	\N	\N	195312	195312	362478
26014	40511	55	applied	\N	\N	\N	\N	195313	195313	362479
26014	40513	57	applied	\N	\N	\N	\N	195315	195315	362481
26014	40514	58	applied	\N	\N	\N	\N	195316	195316	362482
26014	40523	59	applied	\N	\N	\N	\N	195317	195317	362483
26014	40524	60	applied	\N	\N	\N	\N	195318	195318	362484
26014	40529	61	applied	\N	\N	\N	\N	195319	195319	362485
26014	40532	62	applied	\N	\N	\N	\N	195320	195320	362486
26014	40535	63	applied	\N	\N	\N	\N	195321	195321	362487
26014	40538	64	applied	\N	\N	\N	\N	195322	195322	362488
26014	40541	65	applied	\N	\N	\N	\N	195323	195323	362489
26014	40544	66	applied	\N	\N	\N	\N	195324	195324	362490
26014	40547	67	applied	\N	\N	\N	\N	195325	195325	362491
26014	40548	68	applied	\N	\N	\N	\N	195326	195326	362492
26014	40549	69	applied	\N	\N	\N	\N	195327	195327	362493
26014	40556	70	applied	\N	\N	\N	\N	195328	195328	362494
26014	40559	71	applied	\N	\N	\N	\N	195329	195329	362495
26014	40560	72	applied	\N	\N	\N	\N	195330	195330	362496
26014	40567	74	applied	\N	\N	\N	\N	195332	195332	362498
26014	40570	75	applied	\N	\N	\N	\N	195333	195333	362499
26014	40571	76	applied	\N	\N	\N	\N	195334	195334	362500
26014	40576	77	applied	\N	\N	\N	\N	195335	195335	362501
26014	40577	78	applied	\N	\N	\N	\N	195336	195336	362502
26014	40578	79	applied	\N	\N	\N	\N	195337	195337	362503
26014	40586	80	applied	\N	\N	\N	\N	195338	195338	362504
26014	40589	81	applied	\N	\N	\N	\N	195339	195339	362505
26014	40592	82	applied	\N	\N	\N	\N	195340	195340	362506
26014	40595	83	applied	\N	\N	\N	\N	195341	195341	362507
26014	40598	84	applied	\N	\N	\N	\N	195342	195342	362508
26014	40601	86	applied	\N	\N	\N	\N	195343	195343	362509
26014	40602	87	applied	\N	\N	\N	\N	195344	195344	362510
26014	40608	88	applied	\N	\N	\N	\N	195345	195345	362511
26014	40609	89	applied	\N	\N	\N	\N	195346	195346	362512
26014	40610	90	applied	\N	\N	\N	\N	195347	195347	362513
26014	40620	92	applied	\N	\N	\N	\N	195349	195349	362515
26014	40623	93	applied	\N	\N	\N	\N	195350	195350	362516
26014	40626	94	applied	\N	\N	\N	\N	195351	195351	362517
26014	40629	95	applied	\N	\N	\N	\N	195352	195352	362518
26014	40630	96	applied	\N	\N	\N	\N	195353	195353	362519
26014	40635	97	applied	\N	\N	\N	\N	195354	195354	362520
26014	40638	98	applied	\N	\N	\N	\N	195355	195355	362521
26014	40641	99	applied	\N	\N	\N	\N	195356	195356	362522
26014	40642	100	applied	\N	\N	\N	\N	195357	195357	362523
26014	40647	101	applied	\N	\N	\N	\N	195358	195358	362524
26014	40650	102	applied	\N	\N	\N	\N	195359	195359	362525
26014	40651	103	applied	\N	\N	\N	\N	195360	195360	362526
26014	40652	104	applied	\N	\N	\N	\N	195361	195361	362527
26014	40659	105	applied	\N	\N	\N	\N	195362	195362	362528
26014	40662	106	applied	\N	\N	\N	\N	195363	195363	362529
26072	41254	0	applied	\N	\N	\N	\N	195785	195785	362951
26072	41256	2	applied	\N	\N	\N	\N	195787	195787	362953
26072	41257	3	applied	\N	\N	\N	\N	195788	195788	362954
26078	41262	0	applied	\N	\N	\N	\N	195799	195799	362965
26078	41263	1	applied	\N	\N	\N	\N	195800	195800	362966
26086	41276	0	applied	\N	\N	\N	\N	195821	195821	362987
26086	41277	1	applied	\N	\N	\N	\N	195822	195822	362988
26088	41278	0	applied	\N	\N	\N	\N	195825	195825	362991
26088	41279	1	applied	\N	\N	\N	\N	195826	195826	362992
26095	41286	0	applied	\N	\N	\N	\N	195839	195839	363005
26095	41287	1	applied	\N	\N	\N	\N	195840	195840	363006
26100	41296	0	applied	\N	\N	\N	\N	195973	195973	363139
26100	41297	1	applied	\N	\N	\N	\N	195974	195974	363140
26103	41298	0	applied	\N	\N	\N	\N	195983	195983	363149
26103	41299	1	applied	\N	\N	\N	\N	195984	195984	363150
26103	41300	2	applied	\N	\N	\N	\N	195985	195985	363151
26103	41301	3	applied	\N	\N	\N	\N	195986	195986	363152
26107	41195	1	applied	\N	\N	\N	\N	195996	195996	363162
26107	41158	2	applied	\N	\N	\N	\N	195997	195997	363163
26107	41161	3	applied	\N	\N	\N	\N	195998	195998	363164
26107	41162	4	applied	\N	\N	\N	\N	195999	195999	363165
26107	41163	5	applied	\N	\N	\N	\N	196000	196000	363166
26107	41169	6	applied	\N	\N	\N	\N	196001	196001	363167
26107	41171	7	applied	\N	\N	\N	\N	196002	196002	363168
26107	41196	8	applied	\N	\N	\N	\N	196003	196003	363169
26107	41197	9	applied	\N	\N	\N	\N	196004	196004	363170
26107	41198	10	applied	\N	\N	\N	\N	196005	196005	363171
26107	41201	11	applied	\N	\N	\N	\N	196006	196006	363172
26107	41203	12	applied	\N	\N	\N	\N	196007	196007	363173
26107	40992	13	applied	\N	\N	\N	\N	196008	196008	363174
26107	41204	14	applied	\N	\N	\N	\N	196009	196009	363175
26107	41205	15	applied	\N	\N	\N	\N	196010	196010	363176
26107	41206	16	applied	\N	\N	\N	\N	196011	196011	363177
26107	41207	17	applied	\N	\N	\N	\N	196012	196012	363178
26107	41208	18	applied	\N	\N	\N	\N	196013	196013	363179
26107	41210	20	applied	\N	\N	\N	\N	196015	196015	363181
26107	41288	21	applied	\N	\N	\N	\N	196016	196016	363182
26107	41289	22	applied	\N	\N	\N	\N	196017	196017	363183
26107	41290	23	applied	\N	\N	\N	\N	196018	196018	363184
26107	41219	24	applied	\N	\N	\N	\N	196019	196019	363185
26107	41220	25	applied	\N	\N	\N	\N	196020	196020	363186
26107	41221	26	applied	\N	\N	\N	\N	196021	196021	363187
26107	41222	27	applied	\N	\N	\N	\N	196022	196022	363188
26107	41223	28	applied	\N	\N	\N	\N	196023	196023	363189
26107	41030	29	applied	\N	\N	\N	\N	196024	196024	363190
26107	41172	30	applied	\N	\N	\N	\N	196025	196025	363191
26107	41173	31	applied	\N	\N	\N	\N	196026	196026	363192
26107	41174	32	applied	\N	\N	\N	\N	196027	196027	363193
26107	41175	33	applied	\N	\N	\N	\N	196028	196028	363194
26014	40456	40	applied	\N	\N	\N	\N	195298	195298	362464
26014	40465	41	applied	\N	\N	\N	\N	195299	195299	362465
26014	40679	111	applied	\N	\N	\N	\N	195368	195368	362534
26014	40682	112	applied	\N	\N	\N	\N	195369	195369	362535
26014	40684	113	applied	\N	\N	\N	\N	195370	195370	362536
26014	40688	114	applied	\N	\N	\N	\N	195371	195371	362537
26014	40691	115	applied	\N	\N	\N	\N	195372	195372	362538
26014	40694	116	applied	\N	\N	\N	\N	195373	195373	362539
26014	40697	117	applied	\N	\N	\N	\N	195374	195374	362540
26014	40700	118	applied	\N	\N	\N	\N	195375	195375	362541
26014	40703	119	applied	\N	\N	\N	\N	195376	195376	362542
26014	40706	120	applied	\N	\N	\N	\N	195377	195377	362543
26014	40709	121	applied	\N	\N	\N	\N	195378	195378	362544
26014	40712	122	applied	\N	\N	\N	\N	195379	195379	362545
26014	40715	123	applied	\N	\N	\N	\N	195380	195380	362546
26014	40716	124	applied	\N	\N	\N	\N	195381	195381	362547
26021	41130	0	applied	\N	\N	\N	\N	195396	195396	362562
26021	41131	1	applied	\N	\N	\N	\N	195397	195397	362563
26023	41132	0	applied	\N	\N	\N	\N	195400	195400	362566
26023	41133	1	applied	\N	\N	\N	\N	195401	195401	362567
26028	41138	0	applied	\N	\N	\N	\N	195408	195408	362574
26028	41139	1	applied	\N	\N	\N	\N	195409	195409	362575
26030	41138	0	applied	\N	\N	\N	\N	195412	195412	362578
26030	41139	1	applied	\N	\N	\N	\N	195413	195413	362579
26033	40948	0	applied	\N	\N	1000000000	\N	195416	195416	362582
26033	40715	1	applied	\N	\N	\N	\N	195417	195417	362583
26033	40992	2	applied	\N	\N	\N	\N	195418	195418	362584
26033	41030	3	applied	\N	\N	\N	\N	195419	195419	362585
26033	40716	4	applied	\N	\N	\N	\N	195420	195420	362586
26033	40721	5	applied	\N	\N	\N	\N	195421	195421	362587
26033	40724	6	applied	\N	\N	\N	\N	195422	195422	362588
26033	40727	7	applied	\N	\N	\N	\N	195423	195423	362589
26033	40733	9	applied	\N	\N	\N	\N	195425	195425	362591
26033	40734	10	applied	\N	\N	\N	\N	195426	195426	362592
26033	40739	11	applied	\N	\N	\N	\N	195427	195427	362593
26033	40742	12	applied	\N	\N	\N	\N	195428	195428	362594
26033	40746	13	applied	\N	\N	\N	\N	195429	195429	362595
26033	40749	14	applied	\N	\N	\N	\N	195430	195430	362596
26033	40750	15	applied	\N	\N	\N	\N	195431	195431	362597
26033	40751	16	applied	\N	\N	\N	\N	195432	195432	362598
26033	40752	17	applied	\N	\N	\N	\N	195433	195433	362599
26033	40753	18	applied	\N	\N	\N	\N	195434	195434	362600
26033	40766	19	applied	\N	\N	\N	\N	195435	195435	362601
26033	40768	20	applied	\N	\N	\N	\N	195436	195436	362602
26033	40771	21	applied	\N	\N	\N	\N	195437	195437	362603
26033	40774	22	applied	\N	\N	\N	\N	195438	195438	362604
26033	40775	23	applied	\N	\N	\N	\N	195439	195439	362605
26033	40780	24	applied	\N	\N	\N	\N	195440	195440	362606
26033	40787	26	applied	\N	\N	\N	\N	195442	195442	362608
26033	40790	27	applied	\N	\N	\N	\N	195443	195443	362609
26033	40793	28	applied	\N	\N	\N	\N	195444	195444	362610
26033	40794	29	applied	\N	\N	\N	\N	195445	195445	362611
26033	40799	30	applied	\N	\N	\N	\N	195446	195446	362612
26033	40800	31	applied	\N	\N	\N	\N	195447	195447	362613
26033	40805	32	applied	\N	\N	\N	\N	195448	195448	362614
26033	40807	33	applied	\N	\N	\N	\N	195449	195449	362615
26033	40808	34	applied	\N	\N	\N	\N	195450	195450	362616
26033	40814	35	applied	\N	\N	\N	\N	195451	195451	362617
26033	40815	36	applied	\N	\N	\N	\N	195452	195452	362618
26033	40816	37	applied	\N	\N	\N	\N	195453	195453	362619
26033	40823	38	applied	\N	\N	\N	\N	195454	195454	362620
26033	40826	39	applied	\N	\N	\N	\N	195455	195455	362621
26033	40829	40	applied	\N	\N	\N	\N	195456	195456	362622
26033	40830	41	applied	\N	\N	\N	\N	195457	195457	362623
26033	40839	43	applied	\N	\N	\N	\N	195459	195459	362625
26033	40843	44	applied	\N	\N	\N	\N	195460	195460	362626
26033	40846	45	applied	\N	\N	\N	\N	195461	195461	362627
26033	40850	46	applied	\N	\N	\N	\N	195462	195462	362628
26033	40854	47	applied	\N	\N	\N	\N	195463	195463	362629
26033	40856	48	applied	\N	\N	\N	\N	195464	195464	362630
26033	40857	49	applied	\N	\N	\N	\N	195465	195465	362631
26033	40862	50	applied	\N	\N	\N	\N	195466	195466	362632
26033	40863	51	applied	\N	\N	\N	\N	195467	195467	362633
26033	40864	52	applied	\N	\N	\N	\N	195468	195468	362634
26033	40872	53	applied	\N	\N	\N	\N	195469	195469	362635
26033	40873	54	applied	\N	\N	\N	\N	195470	195470	362636
26033	40878	55	applied	\N	\N	\N	\N	195471	195471	362637
26033	40881	56	applied	\N	\N	\N	\N	195472	195472	362638
26033	40884	57	applied	\N	\N	\N	\N	195473	195473	362639
26033	40887	58	applied	\N	\N	\N	\N	195474	195474	362640
26033	40893	60	applied	\N	\N	\N	\N	195476	195476	362642
26033	40896	61	applied	\N	\N	\N	\N	195477	195477	362643
26033	40897	62	applied	\N	\N	\N	\N	195478	195478	362644
26033	40902	63	applied	\N	\N	\N	\N	195479	195479	362645
26033	40905	65	applied	\N	\N	\N	\N	195480	195480	362646
26033	40906	66	applied	\N	\N	\N	\N	195481	195481	362647
26033	40911	67	applied	\N	\N	\N	\N	195482	195482	362648
26033	40912	68	applied	\N	\N	\N	\N	195483	195483	362649
26033	40913	69	applied	\N	\N	\N	\N	195484	195484	362650
26033	40917	70	applied	\N	\N	\N	\N	195485	195485	362651
26033	40919	71	applied	\N	\N	\N	\N	195486	195486	362652
26033	40921	72	applied	\N	\N	\N	\N	195487	195487	362653
26033	40923	73	applied	\N	\N	\N	\N	195488	195488	362654
26033	40925	74	applied	\N	\N	\N	\N	195489	195489	362655
26033	40926	75	applied	\N	\N	\N	\N	195490	195490	362656
26033	40929	76	applied	\N	\N	\N	\N	195491	195491	362657
26033	40933	78	applied	\N	\N	\N	\N	195493	195493	362659
26033	40935	79	applied	\N	\N	\N	\N	195494	195494	362660
26033	40936	80	applied	\N	\N	\N	\N	195495	195495	362661
26033	40937	81	applied	\N	\N	\N	\N	195496	195496	362662
26033	40938	82	applied	\N	\N	\N	\N	195497	195497	362663
26033	40939	83	applied	\N	\N	\N	\N	195498	195498	362664
26033	40946	84	applied	\N	\N	\N	\N	195499	195499	362665
26033	40949	85	applied	\N	\N	\N	\N	195500	195500	362666
26033	40951	86	applied	\N	\N	\N	\N	195501	195501	362667
26033	40953	87	applied	\N	\N	\N	\N	195502	195502	362668
26033	40955	88	applied	\N	\N	\N	\N	195503	195503	362669
26033	40956	89	applied	\N	\N	\N	\N	195504	195504	362670
26033	40957	90	applied	\N	\N	\N	\N	195505	195505	362671
26033	40962	91	applied	\N	\N	\N	\N	195506	195506	362672
26033	40964	92	applied	\N	\N	\N	\N	195507	195507	362673
26033	40966	93	applied	\N	\N	\N	\N	195508	195508	362674
26014	40677	110	applied	\N	\N	\N	\N	195367	195367	362533
26033	40976	98	applied	\N	\N	\N	\N	195513	195513	362679
26033	40977	99	applied	\N	\N	\N	\N	195514	195514	362680
26033	40978	100	applied	\N	\N	\N	\N	195515	195515	362681
26033	40982	101	applied	\N	\N	\N	\N	195516	195516	362682
26033	40984	102	applied	\N	\N	\N	\N	195517	195517	362683
26033	40985	103	applied	\N	\N	\N	\N	195518	195518	362684
26033	40988	104	applied	\N	\N	\N	\N	195519	195519	362685
26033	40990	105	applied	\N	\N	\N	\N	195520	195520	362686
26033	40991	106	applied	\N	\N	\N	\N	195521	195521	362687
26033	40995	107	applied	\N	\N	\N	\N	195522	195522	362688
26033	40996	108	applied	\N	\N	\N	\N	195523	195523	362689
26033	40999	109	applied	\N	\N	\N	\N	195524	195524	362690
26033	41001	110	applied	\N	\N	\N	\N	195525	195525	362691
26033	41003	111	applied	\N	\N	\N	\N	195526	195526	362692
26033	41004	112	applied	\N	\N	\N	\N	195527	195527	362693
26033	41005	113	applied	\N	\N	\N	\N	195528	195528	362694
26033	41010	115	applied	\N	\N	\N	\N	195530	195530	362696
26033	41011	116	applied	\N	\N	\N	\N	195531	195531	362697
26033	41012	117	applied	\N	\N	\N	\N	195532	195532	362698
26033	41013	118	applied	\N	\N	\N	\N	195533	195533	362699
26033	41019	119	applied	\N	\N	\N	\N	195534	195534	362700
26033	41020	120	applied	\N	\N	\N	\N	195535	195535	362701
26033	41021	121	applied	\N	\N	\N	\N	195536	195536	362702
26033	41024	122	applied	\N	\N	\N	\N	195537	195537	362703
26033	41025	123	applied	\N	\N	\N	\N	195538	195538	362704
26033	41028	124	applied	\N	\N	\N	\N	195539	195539	362705
26033	41031	125	applied	\N	\N	\N	\N	195540	195540	362706
26036	41140	0	applied	\N	\N	\N	\N	195541	195541	362707
26036	41141	1	applied	\N	\N	\N	\N	195542	195542	362708
26039	41142	0	applied	\N	\N	\N	\N	195551	195551	362717
26039	41143	1	applied	\N	\N	\N	\N	195552	195552	362718
26039	41144	2	applied	\N	\N	\N	\N	195553	195553	362719
26041	41148	0	applied	\N	\N	\N	\N	195557	195557	362723
26041	41149	1	applied	\N	\N	\N	\N	195558	195558	362724
26043	41148	0	applied	\N	\N	\N	\N	195561	195561	362727
26043	41149	1	applied	\N	\N	\N	\N	195562	195562	362728
26045	41150	0	applied	\N	\N	\N	\N	195565	195565	362731
26045	41151	1	applied	\N	\N	\N	\N	195566	195566	362732
26048	41156	0	applied	\N	\N	\N	\N	195573	195573	362739
26048	41157	1	applied	\N	\N	\N	\N	195574	195574	362740
26049	41158	0	applied	\N	\N	\N	\N	195575	195575	362741
26049	41159	1	applied	\N	\N	\N	\N	195576	195576	362742
26049	41160	2	applied	\N	\N	\N	\N	195577	195577	362743
26049	41161	3	applied	\N	\N	\N	\N	195578	195578	362744
26049	41162	4	applied	\N	\N	\N	\N	195579	195579	362745
26049	41163	5	applied	\N	\N	\N	\N	195580	195580	362746
26049	41164	6	applied	\N	\N	\N	\N	195581	195581	362747
26049	41165	7	applied	\N	\N	\N	\N	195582	195582	362748
26049	41167	9	applied	\N	\N	\N	\N	195584	195584	362750
26049	41168	10	applied	\N	\N	\N	\N	195585	195585	362751
26054	41179	0	applied	\N	\N	\N	\N	195618	195618	362784
26054	41180	1	applied	\N	\N	\N	\N	195619	195619	362785
26054	41181	2	applied	\N	\N	\N	\N	195620	195620	362786
26054	41182	3	applied	\N	\N	\N	\N	195621	195621	362787
26054	41183	4	applied	\N	\N	\N	\N	195622	195622	362788
26054	41184	5	applied	\N	\N	\N	\N	195623	195623	362789
26054	41185	6	applied	\N	\N	\N	\N	195624	195624	362790
26054	41186	7	applied	\N	\N	\N	\N	195625	195625	362791
26054	41189	8	applied	\N	\N	\N	\N	195626	195626	362792
26054	41190	9	applied	\N	\N	\N	\N	195627	195627	362793
26058	41193	0	applied	\N	\N	\N	\N	195632	195632	362798
26058	41194	1	applied	\N	\N	\N	\N	195633	195633	362799
26064	41216	0	applied	\N	\N	\N	\N	195722	195722	362888
26064	41217	1	applied	\N	\N	\N	\N	195723	195723	362889
26064	41219	3	applied	\N	\N	\N	\N	195725	195725	362891
26064	41220	4	applied	\N	\N	\N	\N	195726	195726	362892
26064	41221	5	applied	\N	\N	\N	\N	195727	195727	362893
26064	41222	6	applied	\N	\N	\N	\N	195728	195728	362894
26064	41223	7	applied	\N	\N	\N	\N	195729	195729	362895
26064	41224	8	applied	\N	\N	\N	\N	195730	195730	362896
26064	41225	9	applied	\N	\N	\N	\N	195731	195731	362897
26064	41226	10	applied	\N	\N	\N	\N	195732	195732	362898
26064	41227	11	applied	\N	\N	\N	\N	195733	195733	362899
26064	41228	12	applied	\N	\N	\N	\N	195734	195734	362900
26064	41229	13	applied	\N	\N	\N	\N	195735	195735	362901
26064	41230	14	applied	\N	\N	\N	\N	195736	195736	362902
26065	41231	0	applied	\N	\N	\N	\N	195737	195737	362903
26065	41232	1	applied	\N	\N	\N	\N	195738	195738	362904
26065	41233	2	applied	\N	\N	\N	\N	195739	195739	362905
26065	41234	3	applied	\N	\N	\N	\N	195740	195740	362906
26065	41236	5	applied	\N	\N	\N	\N	195742	195742	362908
26065	41237	6	applied	\N	\N	\N	\N	195743	195743	362909
26065	41238	7	applied	\N	\N	\N	\N	195744	195744	362910
26065	41239	8	applied	\N	\N	\N	\N	195745	195745	362911
26068	41240	0	applied	\N	\N	\N	\N	195761	195761	362927
26068	41241	1	applied	\N	\N	\N	\N	195762	195762	362928
26068	41242	2	applied	\N	\N	\N	\N	195763	195763	362929
26068	41243	3	applied	\N	\N	\N	\N	195764	195764	362930
26068	41244	4	applied	\N	\N	\N	\N	195765	195765	362931
26068	41245	5	applied	\N	\N	\N	\N	195766	195766	362932
26071	41254	0	applied	\N	\N	\N	\N	195781	195781	362947
26071	41255	1	applied	\N	\N	\N	\N	195782	195782	362948
26071	41256	2	applied	\N	\N	\N	\N	195783	195783	362949
26071	41257	3	applied	\N	\N	\N	\N	195784	195784	362950
26073	41258	0	applied	\N	\N	\N	\N	195789	195789	362955
26073	41259	1	applied	\N	\N	\N	\N	195790	195790	362956
26076	41261	1	applied	\N	\N	\N	\N	195796	195796	362962
26080	41264	0	applied	\N	\N	\N	\N	195803	195803	362969
26080	41265	2	applied	\N	\N	\N	\N	195804	195804	362970
26082	41264	0	applied	\N	\N	\N	\N	195807	195807	362973
26082	41265	2	applied	\N	\N	\N	\N	195808	195808	362974
26085	41274	0	applied	\N	\N	\N	\N	195819	195819	362985
26085	41275	1	applied	\N	\N	\N	\N	195820	195820	362986
26090	41280	0	applied	\N	\N	\N	\N	195829	195829	362995
26090	41281	1	applied	\N	\N	\N	\N	195830	195830	362996
26092	41280	0	applied	\N	\N	\N	\N	195833	195833	362999
26092	41281	1	applied	\N	\N	\N	\N	195834	195834	363000
26097	41291	0	applied	\N	\N	\N	\N	195966	195966	363132
26097	41292	1	applied	\N	\N	\N	\N	195967	195967	363133
26099	41293	0	applied	\N	\N	\N	\N	195970	195970	363136
26033	40970	95	applied	\N	\N	\N	\N	195510	195510	362676
26033	40972	96	applied	\N	\N	\N	\N	195511	195511	362677
26060	41163	3	applied	\N	\N	\N	\N	195643	195643	362809
26060	41169	4	applied	\N	\N	\N	\N	195644	195644	362810
26060	41171	5	applied	\N	\N	\N	\N	195645	195645	362811
26060	41172	6	applied	\N	\N	\N	\N	195646	195646	362812
26060	41173	7	applied	\N	\N	\N	\N	195647	195647	362813
26060	41174	8	applied	\N	\N	\N	\N	195648	195648	362814
26060	41175	9	applied	\N	\N	\N	\N	195649	195649	362815
26060	41176	10	applied	\N	\N	\N	\N	195650	195650	362816
26060	41177	11	applied	\N	\N	\N	\N	195651	195651	362817
26060	41180	13	applied	\N	\N	\N	\N	195653	195653	362819
26060	41181	14	applied	\N	\N	\N	\N	195654	195654	362820
26060	41182	15	applied	\N	\N	\N	\N	195655	195655	362821
26060	41183	16	applied	\N	\N	\N	\N	195656	195656	362822
26060	41184	17	applied	\N	\N	\N	\N	195657	195657	362823
26060	41185	18	applied	\N	\N	\N	\N	195658	195658	362824
26060	41186	19	applied	\N	\N	\N	\N	195659	195659	362825
26060	41134	20	applied	\N	\N	\N	\N	195660	195660	362826
26060	41136	21	applied	\N	\N	\N	\N	195661	195661	362827
26060	41138	22	applied	\N	\N	\N	\N	195662	195662	362828
26060	41140	23	applied	\N	\N	\N	\N	195663	195663	362829
26060	41142	24	applied	\N	\N	\N	\N	195664	195664	362830
26060	41143	25	applied	\N	\N	\N	\N	195665	195665	362831
26060	41146	26	applied	\N	\N	\N	\N	195666	195666	362832
26060	41148	27	applied	\N	\N	\N	\N	195667	195667	362833
26060	41150	28	applied	\N	\N	\N	\N	195668	195668	362834
26060	41153	30	applied	\N	\N	\N	\N	195670	195670	362836
26060	41156	31	applied	\N	\N	\N	\N	195671	195671	362837
26060	41157	32	applied	\N	\N	\N	\N	195672	195672	362838
26060	41159	33	applied	\N	\N	\N	\N	195673	195673	362839
26060	41160	34	applied	\N	\N	\N	\N	195674	195674	362840
26060	41170	35	applied	\N	\N	\N	\N	195675	195675	362841
26060	41187	36	applied	\N	\N	\N	\N	195676	195676	362842
26060	41189	37	applied	\N	\N	\N	\N	195677	195677	362843
26060	41191	38	applied	\N	\N	\N	\N	195678	195678	362844
26060	41193	39	applied	\N	\N	\N	\N	195679	195679	362845
26060	41199	40	applied	\N	\N	\N	\N	195680	195680	362846
26060	41135	41	applied	\N	\N	\N	\N	195681	195681	362847
26060	41137	42	applied	\N	\N	\N	\N	195682	195682	362848
26060	41139	43	applied	\N	\N	\N	\N	195683	195683	362849
26060	41141	44	applied	\N	\N	\N	\N	195684	195684	362850
26060	41144	45	applied	\N	\N	\N	\N	195685	195685	362851
26060	41147	47	applied	\N	\N	\N	\N	195687	195687	362853
26060	41149	48	applied	\N	\N	\N	\N	195688	195688	362854
26060	41151	49	applied	\N	\N	\N	\N	195689	195689	362855
26060	41154	50	applied	\N	\N	\N	\N	195690	195690	362856
26060	41155	51	applied	\N	\N	\N	\N	195691	195691	362857
26060	41164	52	applied	\N	\N	\N	\N	195692	195692	362858
26060	41165	53	applied	\N	\N	\N	\N	195693	195693	362859
26060	41166	54	applied	\N	\N	\N	\N	195694	195694	362860
26060	41167	55	applied	\N	\N	\N	\N	195695	195695	362861
26060	41168	56	applied	\N	\N	\N	\N	195696	195696	362862
26060	41178	57	applied	\N	\N	\N	\N	195697	195697	362863
26060	41188	59	applied	\N	\N	\N	\N	195698	195698	362864
26060	41190	60	applied	\N	\N	\N	\N	195699	195699	362865
26060	41192	61	applied	\N	\N	\N	\N	195700	195700	362866
26060	41194	62	applied	\N	\N	\N	\N	195701	195701	362867
26060	41200	63	applied	\N	\N	\N	\N	195702	195702	362868
26063	41213	1	applied	\N	\N	\N	\N	195719	195719	362885
26063	41214	2	applied	\N	\N	\N	\N	195720	195720	362886
26063	41215	3	applied	\N	\N	\N	\N	195721	195721	362887
26067	41240	0	applied	\N	\N	\N	\N	195755	195755	362921
26099	41294	1	applied	\N	\N	\N	\N	195971	195971	363137
26099	41295	2	applied	\N	\N	\N	\N	195972	195972	363138
26102	41298	0	applied	\N	\N	\N	\N	195979	195979	363145
26102	41299	1	applied	\N	\N	\N	\N	195980	195980	363146
26102	41300	2	applied	\N	\N	\N	\N	195981	195981	363147
26102	41301	3	applied	\N	\N	\N	\N	195982	195982	363148
26104	41302	0	applied	\N	\N	\N	\N	195987	195987	363153
26104	41303	1	applied	\N	\N	\N	\N	195988	195988	363154
26112	41308	0	applied	\N	\N	\N	\N	196061	196061	363226
26112	41309	1	applied	\N	\N	\N	\N	196062	196062	363227
26113	41310	0	applied	\N	\N	\N	\N	196063	196063	363228
26113	41311	1	applied	\N	\N	\N	\N	196064	196064	363229
26116	41317	1	applied	\N	\N	\N	\N	196070	196070	363235
26122	41332	0	applied	\N	\N	\N	\N	196087	196087	363252
26122	41333	1	applied	\N	\N	\N	\N	196088	196088	363253
26122	41334	2	applied	\N	\N	\N	\N	196089	196089	363254
26122	41335	3	applied	\N	\N	\N	\N	196090	196090	363255
26127	41342	0	applied	\N	\N	\N	\N	196099	196099	363264
26127	41343	1	applied	\N	\N	\N	\N	196100	196100	363265
26131	41342	0	applied	\N	\N	\N	\N	196107	196107	363272
26131	41343	1	applied	\N	\N	\N	\N	196108	196108	363273
26134	41344	0	applied	\N	\N	\N	\N	196113	196113	363278
26134	41345	1	applied	\N	\N	\N	\N	196114	196114	363279
26145	41358	0	applied	\N	\N	\N	\N	196137	196137	363302
26145	41359	1	applied	\N	\N	\N	\N	196138	196138	363303
26148	41369	0	applied	\N	\N	\N	\N	196148	196148	363313
26148	41370	1	applied	\N	\N	\N	\N	196149	196149	363314
26148	41371	2	applied	\N	\N	\N	\N	196150	196150	363315
26153	41373	1	applied	\N	\N	\N	\N	196200	196200	363365
26153	41374	2	applied	\N	\N	\N	\N	196201	196201	363366
26153	41375	3	applied	\N	\N	\N	\N	196202	196202	363367
26153	41376	4	applied	\N	\N	\N	\N	196203	196203	363368
26153	41377	5	applied	\N	\N	\N	\N	196204	196204	363369
26155	41378	0	applied	\N	\N	\N	\N	196211	196211	363376
26155	41379	1	applied	\N	\N	\N	\N	196212	196212	363377
26155	41380	2	applied	\N	\N	1000000000	\N	196213	196213	363378
26155	41381	3	applied	\N	\N	\N	\N	196214	196214	363379
26155	41382	4	applied	\N	\N	1000000000	\N	196215	196215	363380
26158	41378	0	applied	\N	\N	\N	\N	196226	196226	363391
26158	41379	1	applied	\N	\N	\N	\N	196227	196227	363392
26158	41380	2	applied	\N	\N	1000000000	\N	196228	196228	363393
26158	41381	3	applied	\N	\N	\N	\N	196229	196229	363394
26162	41397	0	applied	\N	\N	\N	\N	196253	196253	363418
26162	41398	1	applied	\N	\N	\N	\N	196254	196254	363419
26162	41399	2	applied	\N	\N	\N	\N	196255	196255	363420
26167	41409	0	applied	\N	\N	\N	\N	196271	196271	363436
26167	41410	1	applied	\N	\N	\N	\N	196272	196272	363437
26167	41411	2	applied	\N	\N	\N	\N	196273	196273	363438
26060	41161	1	applied	\N	\N	\N	\N	195641	195641	362807
26060	41162	2	applied	\N	\N	\N	\N	195642	195642	362808
26067	41245	5	applied	\N	\N	\N	\N	195760	195760	362926
26070	41246	0	applied	\N	\N	\N	\N	195775	195775	362941
26070	41247	1	applied	\N	\N	\N	\N	195776	195776	362942
26070	41248	2	applied	\N	\N	\N	\N	195777	195777	362943
26070	41250	3	applied	\N	\N	\N	\N	195778	195778	362944
26070	41251	4	applied	\N	\N	\N	\N	195779	195779	362945
26070	41252	5	applied	\N	\N	\N	\N	195780	195780	362946
26075	41260	0	applied	\N	\N	\N	\N	195793	195793	362959
26075	41261	1	applied	\N	\N	\N	\N	195794	195794	362960
26079	41262	0	applied	\N	\N	\N	\N	195801	195801	362967
26079	41263	1	applied	\N	\N	\N	\N	195802	195802	362968
26087	41276	0	applied	\N	\N	\N	\N	195823	195823	362989
26087	41277	1	applied	\N	\N	\N	\N	195824	195824	362990
26094	41284	0	applied	\N	\N	\N	\N	195837	195837	363003
26094	41285	1	applied	\N	\N	\N	\N	195838	195838	363004
26096	41195	0	applied	\N	\N	\N	\N	195841	195841	363007
26096	41114	2	applied	\N	\N	\N	\N	195843	195843	363009
26096	41117	3	applied	\N	\N	\N	\N	195844	195844	363010
26096	41120	4	applied	\N	\N	\N	\N	195845	195845	363011
26096	41161	5	applied	\N	\N	\N	\N	195846	195846	363012
26096	41162	6	applied	\N	\N	\N	\N	195847	195847	363013
26096	41163	7	applied	\N	\N	\N	\N	195848	195848	363014
26096	41169	8	applied	\N	\N	\N	\N	195849	195849	363015
26096	41171	9	applied	\N	\N	\N	\N	195850	195850	363016
26096	41124	10	applied	\N	\N	\N	\N	195851	195851	363017
26096	41127	11	applied	\N	\N	\N	\N	195852	195852	363018
26096	41130	12	applied	\N	\N	\N	\N	195853	195853	363019
26096	41132	13	applied	\N	\N	\N	\N	195854	195854	363020
26096	41196	14	applied	\N	\N	\N	\N	195855	195855	363021
26096	41197	15	applied	\N	\N	\N	\N	195856	195856	363022
26096	41198	16	applied	\N	\N	\N	\N	195857	195857	363023
26096	41201	17	applied	\N	\N	\N	\N	195858	195858	363024
26096	41204	19	applied	\N	\N	\N	\N	195860	195860	363026
26096	41205	20	applied	\N	\N	\N	\N	195861	195861	363027
26096	41206	21	applied	\N	\N	\N	\N	195862	195862	363028
26096	41207	22	applied	\N	\N	\N	\N	195863	195863	363029
26096	41208	23	applied	\N	\N	\N	\N	195864	195864	363030
26096	41209	24	applied	\N	\N	\N	\N	195865	195865	363031
26096	41210	25	applied	\N	\N	\N	\N	195866	195866	363032
26096	41288	26	applied	\N	\N	\N	\N	195867	195867	363033
26096	41289	27	applied	\N	\N	\N	\N	195868	195868	363034
26096	41290	28	applied	\N	\N	\N	\N	195869	195869	363035
26096	41219	29	applied	\N	\N	\N	\N	195870	195870	363036
26096	41220	30	applied	\N	\N	\N	\N	195871	195871	363037
26096	41221	31	applied	\N	\N	\N	\N	195872	195872	363038
26096	41222	32	applied	\N	\N	\N	\N	195873	195873	363039
26096	41223	33	applied	\N	\N	\N	\N	195874	195874	363040
26096	41172	34	applied	\N	\N	\N	\N	195875	195875	363041
26096	41174	36	applied	\N	\N	\N	\N	195877	195877	363043
26096	41175	37	applied	\N	\N	\N	\N	195878	195878	363044
26096	41176	38	applied	\N	\N	\N	\N	195879	195879	363045
26096	41177	39	applied	\N	\N	\N	\N	195880	195880	363046
26096	41179	40	applied	\N	\N	\N	\N	195881	195881	363047
26096	41180	41	applied	\N	\N	\N	\N	195882	195882	363048
26096	41181	42	applied	\N	\N	\N	\N	195883	195883	363049
26096	41182	43	applied	\N	\N	\N	\N	195884	195884	363050
26096	41183	44	applied	\N	\N	\N	\N	195885	195885	363051
26096	41184	45	applied	\N	\N	\N	\N	195886	195886	363052
26096	41185	46	applied	\N	\N	\N	\N	195887	195887	363053
26096	41186	47	applied	\N	\N	\N	\N	195888	195888	363054
26096	41224	48	applied	\N	\N	\N	\N	195889	195889	363055
26096	41233	49	applied	\N	\N	\N	\N	195890	195890	363056
26096	41241	50	applied	\N	\N	\N	\N	195891	195891	363057
26096	41243	51	applied	\N	\N	\N	\N	195892	195892	363058
26096	41136	53	applied	\N	\N	\N	\N	195894	195894	363060
26096	41138	54	applied	\N	\N	\N	\N	195895	195895	363061
26096	41140	55	applied	\N	\N	\N	\N	195896	195896	363062
26096	41142	56	applied	\N	\N	\N	\N	195897	195897	363063
26096	41143	57	applied	\N	\N	\N	\N	195898	195898	363064
26096	41146	58	applied	\N	\N	\N	\N	195899	195899	363065
26096	41148	59	applied	\N	\N	\N	\N	195900	195900	363066
26096	41150	60	applied	\N	\N	\N	\N	195901	195901	363067
26096	41152	61	applied	\N	\N	\N	\N	195902	195902	363068
26096	41153	62	applied	\N	\N	\N	\N	195903	195903	363069
26096	41156	63	applied	\N	\N	\N	\N	195904	195904	363070
26096	41157	64	applied	\N	\N	\N	\N	195905	195905	363071
26096	41159	65	applied	\N	\N	\N	\N	195906	195906	363072
26096	41160	66	applied	\N	\N	\N	\N	195907	195907	363073
26096	41170	67	applied	\N	\N	\N	\N	195908	195908	363074
26096	41187	68	applied	\N	\N	\N	\N	195909	195909	363075
26096	41191	70	applied	\N	\N	\N	\N	195911	195911	363077
26096	41193	71	applied	\N	\N	\N	\N	195912	195912	363078
26096	41199	72	applied	\N	\N	\N	\N	195913	195913	363079
26096	41202	73	applied	\N	\N	\N	\N	195914	195914	363080
26096	41212	74	applied	\N	\N	\N	\N	195915	195915	363081
26096	41213	75	applied	\N	\N	\N	\N	195916	195916	363082
26096	41225	76	applied	\N	\N	\N	\N	195917	195917	363083
26096	41226	77	applied	\N	\N	\N	\N	195918	195918	363084
26096	41227	78	applied	\N	\N	\N	\N	195919	195919	363085
26096	41231	79	applied	\N	\N	\N	\N	195920	195920	363086
26096	41232	80	applied	\N	\N	\N	\N	195921	195921	363087
26096	41234	81	applied	\N	\N	\N	\N	195922	195922	363088
26096	41235	82	applied	\N	\N	\N	\N	195923	195923	363089
26096	41240	83	applied	\N	\N	\N	\N	195924	195924	363090
26096	41242	84	applied	\N	\N	\N	\N	195925	195925	363091
26096	41246	85	applied	\N	\N	\N	\N	195926	195926	363092
26096	41248	87	applied	\N	\N	\N	\N	195928	195928	363094
26096	41249	88	applied	\N	\N	\N	\N	195929	195929	363095
26096	41254	89	applied	\N	\N	\N	\N	195930	195930	363096
26096	41255	90	applied	\N	\N	\N	\N	195931	195931	363097
26096	41258	91	applied	\N	\N	\N	\N	195932	195932	363098
26096	41260	93	applied	\N	\N	\N	\N	195933	195933	363099
26096	41262	94	applied	\N	\N	\N	\N	195934	195934	363100
26096	41264	95	applied	\N	\N	\N	\N	195935	195935	363101
26096	41266	96	applied	\N	\N	\N	\N	195936	195936	363102
26096	41267	97	applied	\N	\N	\N	\N	195937	195937	363103
26096	41268	98	applied	\N	\N	\N	\N	195938	195938	363104
26096	41269	99	applied	\N	\N	\N	\N	195939	195939	363105
26096	41274	100	applied	\N	\N	\N	\N	195940	195940	363106
26096	41276	101	applied	\N	\N	\N	\N	195941	195941	363107
26067	41242	2	applied	\N	\N	\N	\N	195757	195757	362923
26067	41243	3	applied	\N	\N	\N	\N	195758	195758	362924
26096	41286	106	applied	\N	\N	\N	\N	195946	195946	363112
26096	41121	107	applied	\N	\N	\N	\N	195947	195947	363113
26096	41115	108	applied	\N	\N	\N	\N	195948	195948	363114
26096	41116	109	applied	\N	\N	\N	\N	195949	195949	363115
26096	41118	110	applied	\N	\N	\N	\N	195950	195950	363116
26096	41123	111	applied	\N	\N	\N	\N	195951	195951	363117
26096	41125	112	applied	\N	\N	\N	\N	195952	195952	363118
26096	41129	113	applied	\N	\N	\N	\N	195953	195953	363119
26096	41119	114	applied	\N	\N	\N	\N	195954	195954	363120
26096	41122	115	applied	\N	\N	\N	\N	195955	195955	363121
26096	41126	116	applied	\N	\N	\N	\N	195956	195956	363122
26096	41128	117	applied	\N	\N	\N	\N	195957	195957	363123
26096	41131	118	applied	\N	\N	\N	\N	195958	195958	363124
26096	41133	119	applied	\N	\N	\N	\N	195959	195959	363125
26096	41135	120	applied	\N	\N	\N	\N	195960	195960	363126
26096	41137	121	applied	\N	\N	\N	\N	195961	195961	363127
26096	41141	123	applied	\N	\N	\N	\N	195963	195963	363129
26096	41144	124	applied	\N	\N	\N	\N	195964	195964	363130
26096	41145	125	applied	\N	\N	\N	\N	195965	195965	363131
26105	41302	0	applied	\N	\N	\N	\N	195989	195989	363155
26105	41303	1	applied	\N	\N	\N	\N	195990	195990	363156
26106	41304	0	applied	\N	\N	\N	\N	195991	195991	363157
26106	41305	1	applied	\N	\N	\N	\N	195992	195992	363158
26106	41306	2	applied	\N	\N	\N	\N	195993	195993	363159
26106	41307	3	applied	\N	\N	\N	\N	195994	195994	363160
26108	41308	0	applied	\N	\N	\N	\N	196053	196053	363218
26108	41309	1	applied	\N	\N	\N	\N	196054	196054	363219
26109	41308	0	applied	\N	\N	\N	\N	196055	196055	363220
26109	41309	1	applied	\N	\N	\N	\N	196056	196056	363221
26111	41308	0	applied	\N	\N	\N	\N	196059	196059	363224
26111	41309	1	applied	\N	\N	\N	\N	196060	196060	363225
26115	41314	0	applied	\N	\N	\N	\N	196067	196067	363232
26118	41322	0	applied	\N	\N	\N	\N	196075	196075	363240
26118	41323	1	applied	\N	\N	\N	\N	196076	196076	363241
26118	41324	2	applied	\N	\N	\N	\N	196077	196077	363242
26118	41325	3	applied	\N	\N	\N	\N	196078	196078	363243
26119	41326	0	applied	\N	\N	\N	\N	196079	196079	363244
26119	41327	1	applied	\N	\N	\N	\N	196080	196080	363245
26119	41328	2	applied	\N	\N	\N	\N	196081	196081	363246
26119	41329	3	applied	\N	\N	\N	\N	196082	196082	363247
26121	41330	0	applied	\N	\N	\N	\N	196085	196085	363250
26121	41331	1	applied	\N	\N	\N	\N	196086	196086	363251
26124	41336	0	applied	\N	\N	\N	\N	196093	196093	363258
26124	41337	1	applied	\N	\N	\N	\N	196094	196094	363259
26126	41340	0	applied	\N	\N	\N	\N	196097	196097	363262
26126	41341	2	applied	\N	\N	\N	\N	196098	196098	363263
26128	41342	0	applied	\N	\N	\N	\N	196101	196101	363266
26128	41343	1	applied	\N	\N	\N	\N	196102	196102	363267
26129	41343	1	applied	\N	\N	\N	\N	196104	196104	363269
26130	41342	0	applied	\N	\N	\N	\N	196105	196105	363270
26130	41343	1	applied	\N	\N	\N	\N	196106	196106	363271
26133	41344	0	applied	\N	\N	\N	\N	196111	196111	363276
26133	41345	1	applied	\N	\N	\N	\N	196112	196112	363277
26135	41346	0	applied	\N	\N	\N	\N	196115	196115	363280
26135	41347	1	applied	\N	\N	\N	\N	196116	196116	363281
26137	41348	0	applied	\N	\N	\N	\N	196119	196119	363284
26137	41349	1	applied	\N	\N	\N	\N	196120	196120	363285
26137	41350	2	applied	\N	\N	\N	\N	196121	196121	363286
26137	41351	3	applied	\N	\N	\N	\N	196122	196122	363287
26138	41352	0	applied	\N	\N	\N	\N	196123	196123	363288
26138	41353	1	applied	\N	\N	\N	\N	196124	196124	363289
26140	41352	0	applied	\N	\N	\N	\N	196127	196127	363292
26140	41353	1	applied	\N	\N	\N	\N	196128	196128	363293
26142	41356	0	applied	\N	\N	\N	\N	196131	196131	363296
26143	41356	0	applied	\N	\N	\N	\N	196133	196133	363298
26143	41357	1	applied	\N	\N	\N	\N	196134	196134	363299
26147	41363	0	applied	\N	\N	\N	\N	196142	196142	363307
26147	41364	1	applied	\N	\N	\N	\N	196143	196143	363308
26147	41365	2	applied	\N	\N	\N	\N	196144	196144	363309
26147	41366	3	applied	\N	\N	\N	\N	196145	196145	363310
26147	41367	4	applied	\N	\N	\N	\N	196146	196146	363311
26147	41368	5	applied	\N	\N	\N	\N	196147	196147	363312
26149	41342	0	applied	\N	\N	\N	\N	196151	196151	363316
26149	41344	1	applied	\N	\N	\N	\N	196152	196152	363317
26149	41346	2	applied	\N	\N	\N	\N	196153	196153	363318
26149	41348	3	applied	\N	\N	\N	\N	196154	196154	363319
26149	41349	4	applied	\N	\N	\N	\N	196155	196155	363320
26149	41352	5	applied	\N	\N	\N	\N	196156	196156	363321
26149	41354	6	applied	\N	\N	\N	\N	196157	196157	363322
26149	41356	7	applied	\N	\N	\N	\N	196158	196158	363323
26149	41360	9	applied	\N	\N	\N	\N	196160	196160	363325
26149	41363	10	applied	\N	\N	\N	\N	196161	196161	363326
26149	41364	11	applied	\N	\N	\N	\N	196162	196162	363327
26149	41369	12	applied	\N	\N	\N	\N	196163	196163	363328
26149	41361	13	applied	\N	\N	\N	\N	196164	196164	363329
26149	41365	14	applied	\N	\N	\N	\N	196165	196165	363330
26149	41343	15	applied	\N	\N	\N	\N	196166	196166	363331
26149	41345	16	applied	\N	\N	\N	\N	196167	196167	363332
26149	41366	17	applied	\N	\N	\N	\N	196168	196168	363333
26149	41370	18	applied	\N	\N	\N	\N	196169	196169	363334
26149	41347	19	applied	\N	\N	\N	\N	196170	196170	363335
26149	41350	20	applied	\N	\N	\N	\N	196171	196171	363336
26149	41351	21	applied	\N	\N	\N	\N	196172	196172	363337
26149	41353	22	applied	\N	\N	\N	\N	196173	196173	363338
26149	41355	23	applied	\N	\N	\N	\N	196174	196174	363339
26149	41357	24	applied	\N	\N	\N	\N	196175	196175	363340
26149	41362	26	applied	\N	\N	\N	\N	196177	196177	363342
26149	41367	27	applied	\N	\N	\N	\N	196178	196178	363343
26149	41368	28	applied	\N	\N	\N	\N	196179	196179	363344
26149	41371	29	applied	\N	\N	\N	\N	196180	196180	363345
26150	41372	0	applied	\N	\N	\N	\N	196181	196181	363346
26150	41373	1	applied	\N	\N	\N	\N	196182	196182	363347
26154	41372	0	applied	\N	\N	\N	\N	196205	196205	363370
26154	41373	1	applied	\N	\N	\N	\N	196206	196206	363371
26154	41374	2	applied	\N	\N	\N	\N	196207	196207	363372
26154	41375	3	applied	\N	\N	\N	\N	196208	196208	363373
26154	41376	4	applied	\N	\N	\N	\N	196209	196209	363374
26154	41377	5	applied	\N	\N	\N	\N	196210	196210	363375
26163	41397	0	applied	\N	\N	\N	\N	196256	196256	363421
26163	41398	1	applied	\N	\N	\N	\N	196257	196257	363422
26096	41280	103	applied	\N	\N	\N	\N	195943	195943	363109
26096	41282	104	applied	\N	\N	\N	\N	195944	195944	363110
26107	41180	37	applied	\N	\N	\N	\N	196032	196032	363198
26107	41181	38	applied	\N	\N	\N	\N	196033	196033	363199
26107	41182	39	applied	\N	\N	\N	\N	196034	196034	363200
26107	41184	41	applied	\N	\N	\N	\N	196036	196036	363202
26107	41185	42	applied	\N	\N	\N	\N	196037	196037	363203
26107	41186	43	applied	\N	\N	\N	\N	196038	196038	363204
26107	41224	44	applied	\N	\N	\N	\N	196039	196039	363205
26107	41233	45	applied	\N	\N	\N	\N	196040	196040	363206
26107	41241	46	applied	\N	\N	\N	\N	196041	196041	363207
26107	41121	47	applied	\N	\N	\N	\N	196042	196042	363208
26107	41294	48	applied	\N	\N	\N	\N	196043	196043	363209
26107	40867	49	applied	\N	\N	\N	\N	196044	196044	196044
26107	40831	50	applied	\N	\N	1000000000	\N	196045	196045	363210
26107	40744	51	applied	\N	\N	1000000000	\N	196046	196046	363211
26107	40842	52	applied	\N	\N	\N	\N	196047	196047	363212
26107	41042	53	applied	\N	\N	1000000000	\N	196048	196048	363213
26107	40755	54	applied	\N	\N	\N	\N	196049	196049	363214
26107	40961	55	applied	\N	\N	\N	\N	196050	196050	363215
26107	40847	56	applied	\N	\N	\N	\N	196051	196051	363216
26110	41308	0	applied	\N	\N	\N	\N	196057	196057	363222
26110	41309	1	applied	\N	\N	\N	\N	196058	196058	363223
26114	41312	0	applied	\N	\N	\N	\N	196065	196065	363230
26114	41313	1	applied	\N	\N	\N	\N	196066	196066	363231
26117	41318	0	applied	\N	\N	\N	\N	196071	196071	363236
26117	41319	1	applied	\N	\N	\N	\N	196072	196072	363237
26117	41320	2	applied	\N	\N	\N	\N	196073	196073	363238
26117	41321	3	applied	\N	\N	\N	\N	196074	196074	363239
26120	41330	0	applied	\N	\N	\N	\N	196083	196083	363248
26120	41331	1	applied	\N	\N	\N	\N	196084	196084	363249
26123	41336	0	applied	\N	\N	\N	\N	196091	196091	363256
26123	41337	1	applied	\N	\N	\N	\N	196092	196092	363257
26125	41338	0	applied	\N	\N	\N	\N	196095	196095	363260
26125	41339	1	applied	\N	\N	\N	\N	196096	196096	363261
26132	41344	0	applied	\N	\N	\N	\N	196109	196109	363274
26132	41345	1	applied	\N	\N	\N	\N	196110	196110	363275
26136	41347	1	applied	\N	\N	\N	\N	196118	196118	363283
26139	41352	0	applied	\N	\N	\N	\N	196125	196125	363290
26139	41353	1	applied	\N	\N	\N	\N	196126	196126	363291
26141	41354	0	applied	\N	\N	\N	\N	196129	196129	363294
26141	41355	1	applied	\N	\N	\N	\N	196130	196130	363295
26144	41356	0	applied	\N	\N	\N	\N	196135	196135	363300
26144	41357	1	applied	\N	\N	\N	\N	196136	196136	363301
26146	41360	0	applied	\N	\N	\N	\N	196139	196139	363304
26146	41361	1	applied	\N	\N	\N	\N	196140	196140	363305
26146	41362	2	applied	\N	\N	\N	\N	196141	196141	363306
26151	41372	0	applied	\N	\N	\N	\N	196187	196187	363352
26151	41373	1	applied	\N	\N	\N	\N	196188	196188	363353
26151	41374	2	applied	\N	\N	\N	\N	196189	196189	363354
26151	41375	3	applied	\N	\N	\N	\N	196190	196190	363355
26151	41376	4	applied	\N	\N	\N	\N	196191	196191	363356
26151	41377	5	applied	\N	\N	\N	\N	196192	196192	363357
26156	41379	1	applied	\N	\N	\N	\N	196217	196217	363382
26156	41380	2	applied	\N	\N	1000000000	\N	196218	196218	363383
26156	41381	3	applied	\N	\N	\N	\N	196219	196219	363384
26156	41382	4	applied	\N	\N	1000000000	\N	196220	196220	363385
26160	41383	0	applied	\N	\N	\N	\N	196239	196239	363404
26160	41384	1	applied	\N	\N	\N	\N	196240	196240	363405
26160	41385	2	applied	\N	\N	\N	\N	196241	196241	363406
26160	41386	3	applied	\N	\N	\N	\N	196242	196242	363407
26160	41387	4	applied	\N	\N	1000000000	\N	196243	196243	363408
26163	41399	2	applied	\N	\N	\N	\N	196258	196258	363423
26176	41437	0	applied	\N	\N	\N	\N	196313	196313	363478
26176	41438	1	applied	\N	\N	\N	\N	196314	196314	363479
26176	41439	2	applied	\N	\N	\N	\N	196315	196315	363480
26176	41440	3	applied	\N	\N	\N	\N	196316	196316	363481
26176	41441	4	applied	\N	\N	\N	\N	196317	196317	363482
26176	41442	5	applied	\N	\N	\N	\N	196318	196318	363483
26178	41437	0	applied	\N	\N	\N	\N	196327	196327	363492
26178	41438	1	applied	\N	\N	\N	\N	196328	196328	363493
26178	41439	2	applied	\N	\N	\N	\N	196329	196329	363494
26178	41440	3	applied	\N	\N	\N	\N	196330	196330	363495
26178	41441	4	applied	\N	\N	\N	\N	196331	196331	363496
26178	41442	5	applied	\N	\N	\N	\N	196332	196332	363497
26178	41443	6	applied	\N	\N	\N	\N	196333	196333	363498
26181	41451	0	applied	\N	\N	\N	\N	196341	196341	363506
26181	41452	1	applied	\N	\N	\N	\N	196342	196342	363507
26181	41453	2	applied	\N	\N	\N	\N	196343	196343	363508
26185	41372	0	applied	\N	\N	\N	\N	196353	196353	363518
26185	41373	1	applied	\N	\N	\N	\N	196354	196354	363519
26185	41378	2	applied	\N	\N	\N	\N	196355	196355	363520
26185	41383	3	applied	\N	\N	\N	\N	196356	196356	363521
26185	41384	4	applied	\N	\N	\N	\N	196357	196357	363522
26185	41391	5	applied	\N	\N	\N	\N	196358	196358	363523
26185	41400	7	applied	\N	\N	\N	\N	196360	196360	363525
26185	41401	8	applied	\N	\N	\N	\N	196361	196361	363526
26185	41406	9	applied	\N	\N	\N	\N	196362	196362	363527
26185	41409	10	applied	\N	\N	\N	\N	196363	196363	363528
26185	41410	11	applied	\N	\N	\N	\N	196364	196364	363529
26185	41417	12	applied	\N	\N	\N	\N	196365	196365	363530
26185	41423	13	applied	\N	\N	\N	\N	196366	196366	363531
26185	41424	14	applied	\N	\N	\N	\N	196367	196367	363532
26185	41425	15	applied	\N	\N	\N	\N	196368	196368	363533
26185	41426	16	applied	\N	\N	\N	\N	196369	196369	363534
26185	41437	17	applied	\N	\N	\N	\N	196370	196370	363535
26185	41438	18	applied	\N	\N	\N	\N	196371	196371	363536
26185	41444	19	applied	\N	\N	\N	\N	196372	196372	363537
26185	41446	20	applied	\N	\N	\N	\N	196373	196373	363538
26185	41451	21	applied	\N	\N	\N	\N	196374	196374	363539
26185	41374	23	applied	\N	\N	\N	\N	196376	196376	363541
26185	41375	24	applied	\N	\N	\N	\N	196377	196377	363542
26185	41376	25	applied	\N	\N	\N	\N	196378	196378	363543
26185	41377	26	applied	\N	\N	\N	\N	196379	196379	363544
26185	41379	27	applied	\N	\N	\N	\N	196380	196380	363545
26185	41385	28	applied	\N	\N	\N	\N	196381	196381	363546
26185	41381	29	applied	\N	\N	\N	\N	196382	196382	363547
26185	41386	30	applied	\N	\N	\N	\N	196383	196383	363548
26185	41429	31	applied	\N	\N	\N	\N	196384	196384	363549
26185	41430	32	applied	\N	\N	\N	\N	196385	196385	363550
26185	41439	33	applied	\N	\N	\N	\N	196386	196386	363551
26107	41177	35	applied	\N	\N	\N	\N	196030	196030	363196
26107	41179	36	applied	\N	\N	\N	\N	196031	196031	363197
26150	41377	5	applied	\N	\N	\N	\N	196186	196186	363351
26152	41372	0	applied	\N	\N	\N	\N	196193	196193	363358
26152	41373	1	applied	\N	\N	\N	\N	196194	196194	363359
26152	41374	2	applied	\N	\N	\N	\N	196195	196195	363360
26152	41375	3	applied	\N	\N	\N	\N	196196	196196	363361
26152	41376	4	applied	\N	\N	\N	\N	196197	196197	363362
26152	41377	5	applied	\N	\N	\N	\N	196198	196198	363363
26157	41378	0	applied	\N	\N	\N	\N	196221	196221	363386
26157	41379	1	applied	\N	\N	\N	\N	196222	196222	363387
26157	41381	3	applied	\N	\N	\N	\N	196224	196224	363389
26159	41383	0	applied	\N	\N	\N	\N	196231	196231	363396
26159	41384	1	applied	\N	\N	\N	\N	196232	196232	363397
26159	41385	2	applied	\N	\N	\N	\N	196233	196233	363398
26159	41386	3	applied	\N	\N	\N	\N	196234	196234	363399
26159	41387	4	applied	\N	\N	1000000000	\N	196235	196235	363400
26159	41388	5	applied	\N	\N	1000000000	\N	196236	196236	363401
26159	41389	6	applied	\N	\N	\N	\N	196237	196237	363402
26159	41390	7	applied	\N	\N	\N	\N	196238	196238	363403
26160	41388	5	applied	\N	\N	1000000000	\N	196244	196244	363409
26160	41389	6	applied	\N	\N	\N	\N	196245	196245	363410
26160	41390	7	applied	\N	\N	\N	\N	196246	196246	363411
26161	41391	0	applied	\N	\N	\N	\N	196247	196247	363412
26161	41392	1	applied	\N	\N	\N	\N	196248	196248	363413
26161	41393	2	applied	\N	\N	1000000000	\N	196249	196249	363414
26161	41394	3	applied	\N	\N	1000000000	\N	196250	196250	363415
26161	41395	4	applied	\N	\N	1000000000	\N	196251	196251	363416
26161	41396	5	applied	\N	\N	\N	\N	196252	196252	363417
26164	41400	0	applied	\N	\N	\N	\N	196259	196259	363424
26164	41401	1	applied	\N	\N	\N	\N	196260	196260	363425
26164	41403	3	applied	\N	\N	\N	\N	196262	196262	363427
26164	41404	4	applied	\N	\N	\N	\N	196263	196263	363428
26164	41405	5	applied	\N	\N	\N	\N	196264	196264	363429
26165	41406	0	applied	\N	\N	\N	\N	196265	196265	363430
26165	41407	1	applied	\N	\N	\N	\N	196266	196266	363431
26165	41408	2	applied	\N	\N	\N	\N	196267	196267	363432
26166	41406	0	applied	\N	\N	\N	\N	196268	196268	363433
26166	41407	1	applied	\N	\N	\N	\N	196269	196269	363434
26166	41408	2	applied	\N	\N	\N	\N	196270	196270	363435
26168	41417	0	applied	\N	\N	\N	\N	196279	196279	363444
26168	41418	1	applied	\N	\N	\N	\N	196280	196280	363445
26168	41419	2	applied	\N	\N	\N	\N	196281	196281	363446
26169	41420	0	applied	\N	\N	1000000000	\N	196282	196282	363447
26169	41421	1	applied	\N	\N	\N	\N	196283	196283	363448
26169	41422	2	applied	\N	\N	\N	\N	196284	196284	363449
26174	41423	0	applied	\N	\N	\N	\N	196285	196285	363450
26174	41425	2	applied	\N	\N	\N	\N	196287	196287	363452
26174	41426	3	applied	\N	\N	\N	\N	196288	196288	363453
26174	41427	4	applied	\N	\N	\N	\N	196289	196289	363454
26174	41428	5	applied	\N	\N	\N	\N	196290	196290	363455
26174	41429	6	applied	\N	\N	\N	\N	196291	196291	363456
26174	41430	7	applied	\N	\N	\N	\N	196292	196292	363457
26174	41431	8	applied	\N	\N	\N	\N	196293	196293	363458
26174	41432	9	applied	\N	\N	\N	\N	196294	196294	363459
26174	41433	10	applied	\N	\N	\N	\N	196295	196295	363460
26174	41434	11	applied	\N	\N	\N	\N	196296	196296	363461
26174	41435	12	applied	\N	\N	\N	\N	196297	196297	363462
26174	41436	13	applied	\N	\N	\N	\N	196298	196298	363463
26175	41423	0	applied	\N	\N	\N	\N	196299	196299	363464
26175	41424	1	applied	\N	\N	\N	\N	196300	196300	363465
26175	41425	2	applied	\N	\N	\N	\N	196301	196301	363466
26175	41426	3	applied	\N	\N	\N	\N	196302	196302	363467
26175	41428	5	applied	\N	\N	\N	\N	196304	196304	363469
26175	41429	6	applied	\N	\N	\N	\N	196305	196305	363470
26175	41430	7	applied	\N	\N	\N	\N	196306	196306	363471
26175	41431	8	applied	\N	\N	\N	\N	196307	196307	363472
26175	41432	9	applied	\N	\N	\N	\N	196308	196308	363473
26175	41433	10	applied	\N	\N	\N	\N	196309	196309	363474
26175	41434	11	applied	\N	\N	\N	\N	196310	196310	363475
26175	41435	12	applied	\N	\N	\N	\N	196311	196311	363476
26175	41436	13	applied	\N	\N	\N	\N	196312	196312	363477
26179	41444	0	applied	\N	\N	\N	\N	196334	196334	363499
26179	41445	1	applied	\N	\N	\N	\N	196335	196335	363500
26180	41446	0	applied	\N	\N	\N	\N	196336	196336	363501
26180	41447	1	applied	\N	\N	\N	\N	196337	196337	363502
26180	41448	2	applied	\N	\N	\N	\N	196338	196338	363503
26180	41449	3	applied	\N	\N	\N	\N	196339	196339	363504
26180	41450	4	applied	\N	\N	\N	\N	196340	196340	363505
26182	41452	1	applied	\N	\N	\N	\N	196345	196345	363510
26182	41453	2	applied	\N	\N	\N	\N	196346	196346	363511
26184	41451	0	applied	\N	\N	\N	\N	196350	196350	363515
26184	41452	1	applied	\N	\N	\N	\N	196351	196351	363516
26184	41453	2	applied	\N	\N	\N	\N	196352	196352	363517
26188	41458	0	applied	\N	\N	\N	\N	196443	196443	363608
26188	41459	1	applied	\N	\N	\N	\N	196444	196444	363609
26188	41460	2	applied	\N	\N	\N	\N	196445	196445	363610
26189	41458	0	applied	\N	\N	\N	\N	196447	196447	363612
26189	41459	1	applied	\N	\N	\N	\N	196448	196448	363613
26189	41460	2	applied	\N	\N	\N	\N	196449	196449	363614
26189	41461	3	applied	\N	\N	\N	\N	196450	196450	363615
26192	41473	0	applied	\N	\N	\N	\N	196587	196587	363752
26192	41474	1	applied	\N	\N	\N	\N	196588	196588	363753
26192	41475	2	applied	\N	\N	\N	\N	196589	196589	363754
26192	41476	3	applied	\N	\N	\N	\N	196590	196590	363755
26197	41484	0	applied	\N	\N	\N	\N	196734	196734	363899
26197	41485	1	applied	\N	\N	1000000000	\N	196735	196735	363900
26197	41486	2	applied	\N	\N	\N	\N	196736	196736	363901
26197	41487	3	applied	\N	\N	\N	\N	196737	196737	363902
26197	41488	4	applied	\N	\N	\N	\N	196738	196738	363903
26201	41495	0	applied	\N	\N	\N	\N	196750	196750	363915
26201	41496	1	applied	\N	\N	\N	\N	196751	196751	363916
26206	41514	0	applied	\N	\N	\N	\N	196775	196775	363940
26206	41515	1	applied	\N	\N	\N	\N	196776	196776	363941
26206	41516	2	applied	\N	\N	\N	\N	196777	196777	363942
26209	41517	0	applied	\N	\N	\N	\N	196786	196786	363951
26209	41518	1	applied	\N	\N	\N	\N	196787	196787	363952
26209	41519	2	applied	\N	\N	\N	\N	196788	196788	363953
26209	41520	3	applied	\N	\N	\N	\N	196789	196789	363954
26211	41521	0	applied	\N	\N	\N	\N	196794	196794	363959
26150	41375	3	applied	\N	\N	\N	\N	196184	196184	363349
26150	41376	4	applied	\N	\N	\N	\N	196185	196185	363350
26167	41415	6	applied	\N	\N	1000000000	\N	196277	196277	363442
26167	41416	7	applied	\N	\N	1000000000	\N	196278	196278	363443
26177	41437	0	applied	\N	\N	\N	\N	196320	196320	363485
26177	41438	1	applied	\N	\N	\N	\N	196321	196321	363486
26177	41439	2	applied	\N	\N	\N	\N	196322	196322	363487
26177	41440	3	applied	\N	\N	\N	\N	196323	196323	363488
26177	41441	4	applied	\N	\N	\N	\N	196324	196324	363489
26177	41442	5	applied	\N	\N	\N	\N	196325	196325	363490
26177	41443	6	applied	\N	\N	\N	\N	196326	196326	363491
26183	41452	1	applied	\N	\N	\N	\N	196348	196348	363513
26183	41453	2	applied	\N	\N	\N	\N	196349	196349	363514
26186	41454	0	applied	\N	\N	\N	\N	196435	196435	363600
26186	41455	1	applied	\N	\N	\N	\N	196436	196436	363601
26186	41456	2	applied	\N	\N	\N	\N	196437	196437	363602
26186	41457	3	applied	\N	\N	1000000000	\N	196438	196438	363603
26188	41461	3	applied	\N	\N	\N	\N	196446	196446	363611
26190	41097	0	applied	\N	\N	\N	\N	196451	196451	363616
26190	41195	1	applied	\N	\N	\N	\N	196452	196452	363617
26190	41158	2	applied	\N	\N	\N	\N	196453	196453	363618
26190	41161	3	applied	\N	\N	\N	\N	196454	196454	363619
26190	41162	4	applied	\N	\N	\N	\N	196455	196455	363620
26190	41163	5	applied	\N	\N	\N	\N	196456	196456	363621
26190	41169	6	applied	\N	\N	\N	\N	196457	196457	363622
26190	41171	7	applied	\N	\N	\N	\N	196458	196458	363623
26190	41196	8	applied	\N	\N	\N	\N	196459	196459	363624
26190	41198	10	applied	\N	\N	\N	\N	196461	196461	363626
26190	41201	11	applied	\N	\N	\N	\N	196462	196462	363627
26190	41203	12	applied	\N	\N	\N	\N	196463	196463	363628
26190	41204	13	applied	\N	\N	\N	\N	196464	196464	363629
26190	41205	14	applied	\N	\N	\N	\N	196465	196465	363630
26190	41206	15	applied	\N	\N	\N	\N	196466	196466	363631
26190	41207	16	applied	\N	\N	\N	\N	196467	196467	363632
26190	41208	17	applied	\N	\N	\N	\N	196468	196468	363633
26190	41209	18	applied	\N	\N	\N	\N	196469	196469	363634
26190	41210	19	applied	\N	\N	\N	\N	196470	196470	363635
26190	41288	20	applied	\N	\N	\N	\N	196471	196471	363636
26190	41289	21	applied	\N	\N	\N	\N	196472	196472	363637
26190	41290	22	applied	\N	\N	\N	\N	196473	196473	363638
26190	41219	23	applied	\N	\N	\N	\N	196474	196474	363639
26190	41220	24	applied	\N	\N	\N	\N	196475	196475	363640
26190	41221	25	applied	\N	\N	\N	\N	196476	196476	363641
26190	41223	27	applied	\N	\N	\N	\N	196478	196478	363643
26190	41172	28	applied	\N	\N	\N	\N	196479	196479	363644
26190	41173	29	applied	\N	\N	\N	\N	196480	196480	363645
26190	41174	30	applied	\N	\N	\N	\N	196481	196481	363646
26190	41175	31	applied	\N	\N	\N	\N	196482	196482	363647
26190	41176	32	applied	\N	\N	\N	\N	196483	196483	363648
26190	41177	33	applied	\N	\N	\N	\N	196484	196484	363649
26190	41179	34	applied	\N	\N	\N	\N	196485	196485	363650
26190	41180	35	applied	\N	\N	\N	\N	196486	196486	363651
26190	41181	36	applied	\N	\N	\N	\N	196487	196487	363652
26190	41182	37	applied	\N	\N	\N	\N	196488	196488	363653
26190	41183	38	applied	\N	\N	\N	\N	196489	196489	363654
26190	41184	39	applied	\N	\N	\N	\N	196490	196490	363655
26190	41185	40	applied	\N	\N	\N	\N	196491	196491	363656
26190	41186	41	applied	\N	\N	\N	\N	196492	196492	363657
26190	41224	42	applied	\N	\N	\N	\N	196493	196493	363658
26190	41241	44	applied	\N	\N	\N	\N	196495	196495	363660
26190	41243	45	applied	\N	\N	\N	\N	196496	196496	363661
26190	41099	46	applied	\N	\N	\N	\N	196497	196497	363662
26190	41100	47	applied	\N	\N	\N	\N	196498	196498	363663
26190	41105	48	applied	\N	\N	\N	\N	196499	196499	363664
26190	41108	49	applied	\N	\N	\N	\N	196500	196500	363665
26190	41109	50	applied	\N	\N	\N	\N	196501	196501	363666
26190	41114	51	applied	\N	\N	\N	\N	196502	196502	363667
26191	41462	0	applied	\N	\N	\N	\N	196576	196576	363741
26191	41463	1	applied	\N	\N	\N	\N	196577	196577	363742
26191	41464	2	applied	\N	\N	\N	\N	196578	196578	363743
26191	41465	3	applied	\N	\N	\N	\N	196579	196579	363744
26191	41466	4	applied	\N	\N	\N	\N	196580	196580	363745
26191	41467	5	applied	\N	\N	\N	\N	196581	196581	363746
26191	41468	6	applied	\N	\N	\N	\N	196582	196582	363747
26191	41469	7	applied	\N	\N	\N	\N	196583	196583	363748
26191	41471	9	applied	\N	\N	\N	\N	196585	196585	363750
26191	41472	10	applied	\N	\N	\N	\N	196586	196586	363751
26196	41484	0	applied	\N	\N	\N	\N	196729	196729	363894
26196	41485	1	applied	\N	\N	1000000000	\N	196730	196730	363895
26196	41486	2	applied	\N	\N	\N	\N	196731	196731	363896
26196	41487	3	applied	\N	\N	\N	\N	196732	196732	363897
26196	41488	4	applied	\N	\N	\N	\N	196733	196733	363898
26200	41492	0	applied	\N	\N	\N	\N	196747	196747	363912
26200	41493	1	applied	\N	\N	\N	\N	196748	196748	363913
26200	41494	2	applied	\N	\N	\N	\N	196749	196749	363914
26202	41495	0	applied	\N	\N	\N	\N	196752	196752	363917
26202	41496	1	applied	\N	\N	\N	\N	196753	196753	363918
26203	41497	0	applied	\N	\N	\N	\N	196754	196754	363919
26203	41498	1	applied	\N	\N	\N	\N	196755	196755	363920
26203	41499	2	applied	\N	\N	\N	\N	196756	196756	363921
26203	41500	3	applied	\N	\N	\N	\N	196757	196757	363922
26208	41518	1	applied	\N	\N	\N	\N	196783	196783	363948
26208	41519	2	applied	\N	\N	\N	\N	196784	196784	363949
26208	41520	3	applied	\N	\N	\N	\N	196785	196785	363950
26230	41584	0	applied	\N	\N	\N	\N	197032	197032	364197
26230	41585	1	applied	\N	\N	\N	\N	197033	197033	364198
26230	41586	2	applied	\N	\N	\N	\N	197034	197034	364199
26230	41587	3	applied	\N	\N	\N	\N	197035	197035	364200
26230	41588	4	applied	\N	\N	\N	\N	197036	197036	364201
26230	41589	5	applied	\N	\N	\N	\N	197037	197037	364202
26230	41590	6	applied	\N	\N	\N	\N	197038	197038	364203
26231	41584	0	applied	\N	\N	\N	\N	197039	197039	364204
26231	41585	1	applied	\N	\N	\N	\N	197040	197040	364205
26231	41586	2	applied	\N	\N	\N	\N	197041	197041	364206
26231	41587	3	applied	\N	\N	\N	\N	197042	197042	364207
26231	41588	4	applied	\N	\N	\N	\N	197043	197043	364208
26231	41589	5	applied	\N	\N	\N	\N	197044	197044	364209
26233	41594	0	applied	\N	\N	\N	\N	197049	197049	364214
26233	41595	1	applied	\N	\N	\N	\N	197050	197050	364215
26233	41596	2	applied	\N	\N	\N	\N	197051	197051	364216
26233	41597	3	applied	\N	\N	\N	\N	197052	197052	364217
26167	41413	4	applied	\N	\N	\N	\N	196275	196275	363440
26167	41414	5	applied	\N	\N	\N	\N	196276	196276	363441
26185	41450	37	applied	\N	\N	\N	\N	196390	196390	363555
26185	41404	38	applied	\N	\N	\N	\N	196391	196391	363556
26185	41405	39	applied	\N	\N	\N	\N	196392	196392	363557
26185	41408	40	applied	\N	\N	\N	\N	196393	196393	363558
26185	41411	41	applied	\N	\N	\N	\N	196394	196394	363559
26185	41412	42	applied	\N	\N	\N	\N	196395	196395	363560
26185	41419	43	applied	\N	\N	\N	\N	196396	196396	363561
26185	41421	44	applied	\N	\N	\N	\N	196397	196397	363562
26185	41428	45	applied	\N	\N	\N	\N	196398	196398	363563
26185	41390	46	applied	\N	\N	\N	\N	196399	196399	363564
26185	41382	47	applied	\N	\N	1000000000	\N	196400	196400	363565
26185	41387	48	applied	\N	\N	1000000000	\N	196401	196401	363566
26185	41393	50	applied	\N	\N	1000000000	\N	196403	196403	363568
26185	41394	51	applied	\N	\N	1000000000	\N	196404	196404	363569
26185	41395	52	applied	\N	\N	1000000000	\N	196405	196405	363570
26185	41431	53	applied	\N	\N	\N	\N	196406	196406	363571
26185	41432	54	applied	\N	\N	\N	\N	196407	196407	363572
26185	41433	55	applied	\N	\N	\N	\N	196408	196408	363573
26185	41440	56	applied	\N	\N	\N	\N	196409	196409	363574
26185	41443	57	applied	\N	\N	\N	\N	196410	196410	363575
26185	41445	58	applied	\N	\N	\N	\N	196411	196411	363576
26185	41447	59	applied	\N	\N	\N	\N	196412	196412	363577
26185	41453	60	applied	\N	\N	\N	\N	196413	196413	363578
26185	41396	61	applied	\N	\N	\N	\N	196414	196414	363579
26185	41399	62	applied	\N	\N	\N	\N	196415	196415	363580
26185	41402	63	applied	\N	\N	\N	\N	196416	196416	363581
26185	41403	64	applied	\N	\N	\N	\N	196417	196417	363582
26185	41407	65	applied	\N	\N	\N	\N	196418	196418	363583
26185	41413	66	applied	\N	\N	\N	\N	196419	196419	363584
26185	41414	67	applied	\N	\N	\N	\N	196420	196420	363585
26185	41418	68	applied	\N	\N	\N	\N	196421	196421	363586
26185	41422	69	applied	\N	\N	\N	\N	196422	196422	363587
26185	41434	71	applied	\N	\N	\N	\N	196424	196424	363589
26185	41435	72	applied	\N	\N	\N	\N	196425	196425	363590
26185	41436	73	applied	\N	\N	\N	\N	196426	196426	363591
26185	41441	74	applied	\N	\N	\N	\N	196427	196427	363592
26185	41442	75	applied	\N	\N	\N	\N	196428	196428	363593
26185	41448	76	applied	\N	\N	\N	\N	196429	196429	363594
26185	41449	77	applied	\N	\N	\N	\N	196430	196430	363595
26185	41452	78	applied	\N	\N	\N	\N	196431	196431	363596
26185	41415	79	applied	\N	\N	1000000000	\N	196432	196432	363597
26185	41416	80	applied	\N	\N	1000000000	\N	196433	196433	363598
26185	41420	81	applied	\N	\N	1000000000	\N	196434	196434	363599
26187	41454	0	applied	\N	\N	\N	\N	196439	196439	363604
26187	41455	1	applied	\N	\N	\N	\N	196440	196440	363605
26187	41456	2	applied	\N	\N	\N	\N	196441	196441	363606
26193	41195	0	applied	\N	\N	\N	\N	196592	196592	363757
26193	41202	1	applied	\N	\N	\N	\N	196593	196593	363758
26193	41196	2	applied	\N	\N	\N	\N	196594	196594	363759
26193	41197	3	applied	\N	\N	\N	\N	196595	196595	363760
26193	41198	4	applied	\N	\N	\N	\N	196596	196596	363761
26193	41201	5	applied	\N	\N	\N	\N	196597	196597	363762
26193	41203	6	applied	\N	\N	\N	\N	196598	196598	363763
26193	41212	7	applied	\N	\N	\N	\N	196599	196599	363764
26193	41204	8	applied	\N	\N	\N	\N	196600	196600	363765
26193	41205	9	applied	\N	\N	\N	\N	196601	196601	363766
26193	41206	10	applied	\N	\N	\N	\N	196602	196602	363767
26193	41207	11	applied	\N	\N	\N	\N	196603	196603	363768
26193	41208	12	applied	\N	\N	\N	\N	196604	196604	363769
26233	41598	4	applied	\N	\N	\N	\N	197053	197053	364218
26233	41599	5	applied	\N	\N	\N	\N	197054	197054	364219
26233	41600	6	applied	\N	\N	\N	\N	197055	197055	364220
26246	41624	0	applied	\N	\N	\N	\N	197098	197098	364263
26246	41625	1	applied	\N	\N	\N	\N	197099	197099	364264
26246	41626	2	applied	\N	\N	\N	\N	197100	197100	364265
26249	41630	0	applied	\N	\N	\N	\N	197107	197107	364272
26249	41632	2	applied	\N	\N	\N	\N	197109	197109	364274
26253	41653	0	applied	\N	\N	\N	\N	197130	197130	364295
26253	41654	1	applied	\N	\N	\N	\N	197131	197131	364296
26253	41655	2	applied	\N	\N	\N	\N	197132	197132	364297
26253	41656	3	applied	\N	\N	\N	\N	197133	197133	364298
26256	41660	0	applied	\N	\N	\N	\N	197140	197140	364305
26256	41661	1	applied	\N	\N	\N	\N	197141	197141	364306
26256	41662	2	applied	\N	\N	\N	\N	197142	197142	364307
26266	41689	0	applied	\N	\N	\N	\N	197185	197185	364350
26266	41690	1	applied	\N	\N	\N	\N	197186	197186	364351
26266	41691	2	applied	\N	\N	\N	\N	197187	197187	364352
26268	41692	0	applied	\N	\N	\N	\N	197191	197191	364356
26268	41693	1	applied	\N	\N	\N	\N	197192	197192	364357
26268	41694	2	applied	\N	\N	\N	\N	197193	197193	364358
26273	41704	0	applied	\N	\N	\N	\N	197206	197206	364371
26273	41705	1	applied	\N	\N	\N	\N	197207	197207	364372
26278	41717	0	applied	\N	\N	\N	\N	197227	197227	364392
26278	41718	1	applied	\N	\N	\N	\N	197228	197228	364393
26278	41719	2	applied	\N	\N	\N	\N	197229	197229	364394
26278	41720	3	applied	\N	\N	\N	\N	197230	197230	364395
26281	41724	0	applied	\N	\N	\N	\N	197359	197359	364524
26281	41725	1	applied	\N	\N	\N	\N	197360	197360	364525
26281	41726	2	applied	\N	\N	\N	\N	197361	197361	364526
26281	41727	3	applied	\N	\N	\N	\N	197362	197362	364527
26281	41728	4	applied	\N	\N	\N	\N	197363	197363	364528
26281	41729	5	applied	\N	\N	\N	\N	197364	197364	364529
26281	41730	6	applied	\N	\N	\N	\N	197365	197365	364530
26291	41747	0	applied	\N	\N	\N	\N	197405	197405	364570
26291	41748	1	applied	\N	\N	\N	\N	197406	197406	364571
26295	41751	0	applied	\N	\N	\N	\N	197422	197422	364587
26295	41752	1	applied	\N	\N	\N	\N	197423	197423	364588
26295	41753	2	applied	\N	\N	\N	\N	197424	197424	364589
26295	41755	4	applied	\N	\N	\N	\N	197426	197426	364591
26295	41756	5	applied	\N	\N	\N	\N	197427	197427	364592
26295	41757	6	applied	\N	\N	\N	\N	197428	197428	364593
26295	41758	7	applied	\N	\N	\N	\N	197429	197429	364594
26295	41759	8	applied	\N	\N	\N	\N	197430	197430	364595
26295	41760	9	applied	\N	\N	\N	\N	197431	197431	364596
26295	41761	10	applied	\N	\N	\N	\N	197432	197432	364597
26299	41764	0	applied	\N	\N	\N	\N	197448	197448	364613
26299	41765	1	applied	\N	\N	\N	\N	197449	197449	364614
26299	41766	2	applied	\N	\N	\N	\N	197450	197450	364615
26299	41767	3	applied	\N	\N	\N	\N	197451	197451	364616
26185	41392	35	applied	\N	\N	\N	\N	196388	196388	363553
26185	41398	36	applied	\N	\N	\N	\N	196389	196389	363554
26190	41130	56	applied	\N	\N	\N	\N	196507	196507	363672
26190	41132	57	applied	\N	\N	\N	\N	196508	196508	363673
26190	41134	58	applied	\N	\N	\N	\N	196509	196509	363674
26190	41136	59	applied	\N	\N	\N	\N	196510	196510	363675
26190	41138	60	applied	\N	\N	\N	\N	196511	196511	363676
26190	41140	61	applied	\N	\N	\N	\N	196512	196512	363677
26190	41142	62	applied	\N	\N	\N	\N	196513	196513	363678
26190	41143	63	applied	\N	\N	\N	\N	196514	196514	363679
26190	41146	64	applied	\N	\N	\N	\N	196515	196515	363680
26190	41148	65	applied	\N	\N	\N	\N	196516	196516	363681
26190	41150	66	applied	\N	\N	\N	\N	196517	196517	363682
26190	41152	67	applied	\N	\N	\N	\N	196518	196518	363683
26190	41153	68	applied	\N	\N	\N	\N	196519	196519	363684
26190	41156	69	applied	\N	\N	\N	\N	196520	196520	363685
26190	41157	70	applied	\N	\N	\N	\N	196521	196521	363686
26190	41159	71	applied	\N	\N	\N	\N	196522	196522	363687
26190	41170	73	applied	\N	\N	\N	\N	196524	196524	363689
26190	41187	74	applied	\N	\N	\N	\N	196525	196525	363690
26190	41189	75	applied	\N	\N	\N	\N	196526	196526	363691
26190	41191	76	applied	\N	\N	\N	\N	196527	196527	363692
26190	41193	77	applied	\N	\N	\N	\N	196528	196528	363693
26190	41199	78	applied	\N	\N	\N	\N	196529	196529	363694
26190	41202	79	applied	\N	\N	\N	\N	196530	196530	363695
26190	41212	80	applied	\N	\N	\N	\N	196531	196531	363696
26190	41213	81	applied	\N	\N	\N	\N	196532	196532	363697
26190	41225	82	applied	\N	\N	\N	\N	196533	196533	363698
26190	41226	83	applied	\N	\N	\N	\N	196534	196534	363699
26190	41227	84	applied	\N	\N	\N	\N	196535	196535	363700
26190	41231	85	applied	\N	\N	\N	\N	196536	196536	363701
26190	41232	86	applied	\N	\N	\N	\N	196537	196537	363702
26190	41234	87	applied	\N	\N	\N	\N	196538	196538	363703
26190	41235	88	applied	\N	\N	\N	\N	196539	196539	363704
26190	41242	90	applied	\N	\N	\N	\N	196541	196541	363706
26190	41246	91	applied	\N	\N	\N	\N	196542	196542	363707
26190	41247	92	applied	\N	\N	\N	\N	196543	196543	363708
26190	41248	93	applied	\N	\N	\N	\N	196544	196544	363709
26190	41249	94	applied	\N	\N	\N	\N	196545	196545	363710
26190	41254	95	applied	\N	\N	\N	\N	196546	196546	363711
26190	41255	96	applied	\N	\N	\N	\N	196547	196547	363712
26190	41258	97	applied	\N	\N	\N	\N	196548	196548	363713
26190	41260	98	applied	\N	\N	\N	\N	196549	196549	363714
26190	41262	99	applied	\N	\N	\N	\N	196550	196550	363715
26190	41264	100	applied	\N	\N	\N	\N	196551	196551	363716
26190	41266	101	applied	\N	\N	\N	\N	196552	196552	363717
26190	41267	102	applied	\N	\N	\N	\N	196553	196553	363718
26190	41268	103	applied	\N	\N	\N	\N	196554	196554	363719
26190	41269	104	applied	\N	\N	\N	\N	196555	196555	363720
26190	41274	105	applied	\N	\N	\N	\N	196556	196556	363721
26190	41278	107	applied	\N	\N	\N	\N	196558	196558	363723
26190	41280	108	applied	\N	\N	\N	\N	196559	196559	363724
26190	41282	109	applied	\N	\N	\N	\N	196560	196560	363725
26190	41284	110	applied	\N	\N	\N	\N	196561	196561	363726
26190	41286	111	applied	\N	\N	\N	\N	196562	196562	363727
26190	41291	112	applied	\N	\N	\N	\N	196563	196563	363728
26190	41293	113	applied	\N	\N	\N	\N	196564	196564	363729
26190	41296	114	applied	\N	\N	\N	\N	196565	196565	363730
26190	41298	115	applied	\N	\N	\N	\N	196566	196566	363731
26190	41299	116	applied	\N	\N	\N	\N	196567	196567	363732
26190	41302	118	applied	\N	\N	\N	\N	196568	196568	363733
26190	41304	119	applied	\N	\N	\N	\N	196569	196569	363734
26193	41209	13	applied	\N	\N	\N	\N	196605	196605	363770
26193	41210	14	applied	\N	\N	\N	\N	196606	196606	363771
26193	41288	15	applied	\N	\N	\N	\N	196607	196607	363772
26193	41289	16	applied	\N	\N	\N	\N	196608	196608	363773
26193	41219	18	applied	\N	\N	\N	\N	196610	196610	363775
26193	41220	19	applied	\N	\N	\N	\N	196611	196611	363776
26193	41221	20	applied	\N	\N	\N	\N	196612	196612	363777
26193	41222	21	applied	\N	\N	\N	\N	196613	196613	363778
26193	41223	22	applied	\N	\N	\N	\N	196614	196614	363779
26193	41224	23	applied	\N	\N	\N	\N	196615	196615	363780
26193	41233	24	applied	\N	\N	\N	\N	196616	196616	363781
26193	41241	25	applied	\N	\N	\N	\N	196617	196617	363782
26193	41243	26	applied	\N	\N	\N	\N	196618	196618	363783
26193	41213	27	applied	\N	\N	\N	\N	196619	196619	363784
26193	41225	28	applied	\N	\N	\N	\N	196620	196620	363785
26193	41226	29	applied	\N	\N	\N	\N	196621	196621	363786
26193	41227	30	applied	\N	\N	\N	\N	196622	196622	363787
26193	41231	31	applied	\N	\N	\N	\N	196623	196623	363788
26193	41232	32	applied	\N	\N	\N	\N	196624	196624	363789
26193	41234	33	applied	\N	\N	\N	\N	196625	196625	363790
26193	41240	35	applied	\N	\N	\N	\N	196627	196627	363792
26193	41242	36	applied	\N	\N	\N	\N	196628	196628	363793
26193	41246	37	applied	\N	\N	\N	\N	196629	196629	363794
26193	41247	38	applied	\N	\N	\N	\N	196630	196630	363795
26193	41248	39	applied	\N	\N	\N	\N	196631	196631	363796
26193	41249	40	applied	\N	\N	\N	\N	196632	196632	363797
26193	41254	41	applied	\N	\N	\N	\N	196633	196633	363798
26193	41255	42	applied	\N	\N	\N	\N	196634	196634	363799
26193	41258	43	applied	\N	\N	\N	\N	196635	196635	363800
26193	41260	44	applied	\N	\N	\N	\N	196636	196636	363801
26193	41262	45	applied	\N	\N	\N	\N	196637	196637	363802
26193	41264	46	applied	\N	\N	\N	\N	196638	196638	363803
26193	41266	47	applied	\N	\N	\N	\N	196639	196639	363804
26193	41267	48	applied	\N	\N	\N	\N	196640	196640	363805
26193	41268	49	applied	\N	\N	\N	\N	196641	196641	363806
26193	41269	50	applied	\N	\N	\N	\N	196642	196642	363807
26193	41276	52	applied	\N	\N	\N	\N	196644	196644	363809
26193	41278	53	applied	\N	\N	\N	\N	196645	196645	363810
26193	41280	54	applied	\N	\N	\N	\N	196646	196646	363811
26193	41282	55	applied	\N	\N	\N	\N	196647	196647	363812
26193	41284	56	applied	\N	\N	\N	\N	196648	196648	363813
26193	41286	57	applied	\N	\N	\N	\N	196649	196649	363814
26193	41291	58	applied	\N	\N	\N	\N	196650	196650	363815
26193	41293	59	applied	\N	\N	\N	\N	196651	196651	363816
26193	41296	60	applied	\N	\N	\N	\N	196652	196652	363817
26193	41298	61	applied	\N	\N	\N	\N	196653	196653	363818
26193	41299	62	applied	\N	\N	\N	\N	196654	196654	363819
26193	41302	63	applied	\N	\N	\N	\N	196655	196655	363820
26193	41304	64	applied	\N	\N	\N	\N	196656	196656	363821
26193	41305	65	applied	\N	\N	\N	\N	196657	196657	363822
26190	41120	53	applied	\N	\N	\N	\N	196504	196504	363669
26190	41124	54	applied	\N	\N	\N	\N	196505	196505	363670
26190	41314	124	applied	\N	\N	\N	\N	196574	196574	363739
26190	41316	125	applied	\N	\N	\N	\N	196575	196575	363740
26193	41308	66	applied	\N	\N	\N	\N	196658	196658	363823
26193	41310	67	applied	\N	\N	\N	\N	196659	196659	363824
26193	41312	68	applied	\N	\N	\N	\N	196660	196660	363825
26193	41314	69	applied	\N	\N	\N	\N	196661	196661	363826
26193	41316	70	applied	\N	\N	\N	\N	196662	196662	363827
26193	41318	71	applied	\N	\N	\N	\N	196663	196663	363828
26193	41319	72	applied	\N	\N	\N	\N	196664	196664	363829
26193	41322	73	applied	\N	\N	\N	\N	196665	196665	363830
26193	41323	74	applied	\N	\N	\N	\N	196666	196666	363831
26193	41326	75	applied	\N	\N	\N	\N	196667	196667	363832
26193	41327	76	applied	\N	\N	\N	\N	196668	196668	363833
26193	41330	77	applied	\N	\N	\N	\N	196669	196669	363834
26193	41333	79	applied	\N	\N	\N	\N	196671	196671	363836
26193	41336	80	applied	\N	\N	\N	\N	196672	196672	363837
26193	41338	81	applied	\N	\N	\N	\N	196673	196673	363838
26193	41340	82	applied	\N	\N	\N	\N	196674	196674	363839
26193	41342	83	applied	\N	\N	\N	\N	196675	196675	363840
26193	41344	84	applied	\N	\N	\N	\N	196676	196676	363841
26193	41346	85	applied	\N	\N	\N	\N	196677	196677	363842
26193	41348	86	applied	\N	\N	\N	\N	196678	196678	363843
26193	41349	87	applied	\N	\N	\N	\N	196679	196679	363844
26193	41352	88	applied	\N	\N	\N	\N	196680	196680	363845
26193	41354	89	applied	\N	\N	\N	\N	196681	196681	363846
26193	41356	90	applied	\N	\N	\N	\N	196682	196682	363847
26193	41358	91	applied	\N	\N	\N	\N	196683	196683	363848
26193	41360	92	applied	\N	\N	\N	\N	196684	196684	363849
26193	41363	93	applied	\N	\N	\N	\N	196685	196685	363850
26193	41364	94	applied	\N	\N	\N	\N	196686	196686	363851
26193	41372	96	applied	\N	\N	\N	\N	196688	196688	363853
26193	41373	97	applied	\N	\N	\N	\N	196689	196689	363854
26193	41378	98	applied	\N	\N	\N	\N	196690	196690	363855
26193	41383	99	applied	\N	\N	\N	\N	196691	196691	363856
26193	41384	100	applied	\N	\N	\N	\N	196692	196692	363857
26193	41391	101	applied	\N	\N	\N	\N	196693	196693	363858
26193	41397	102	applied	\N	\N	\N	\N	196694	196694	363859
26193	41400	103	applied	\N	\N	\N	\N	196695	196695	363860
26193	41401	104	applied	\N	\N	\N	\N	196696	196696	363861
26193	41406	105	applied	\N	\N	\N	\N	196697	196697	363862
26193	41409	106	applied	\N	\N	\N	\N	196698	196698	363863
26193	41410	107	applied	\N	\N	\N	\N	196699	196699	363864
26193	41417	108	applied	\N	\N	\N	\N	196700	196700	363865
26193	41423	109	applied	\N	\N	\N	\N	196701	196701	363866
26193	41424	110	applied	\N	\N	\N	\N	196702	196702	363867
26193	41425	111	applied	\N	\N	\N	\N	196703	196703	363868
26193	41437	113	applied	\N	\N	\N	\N	196705	196705	363870
26193	41438	114	applied	\N	\N	\N	\N	196706	196706	363871
26193	41444	115	applied	\N	\N	\N	\N	196707	196707	363872
26193	41446	116	applied	\N	\N	\N	\N	196708	196708	363873
26193	41451	117	applied	\N	\N	\N	\N	196709	196709	363874
26193	41454	118	applied	\N	\N	\N	\N	196710	196710	363875
26193	41458	119	applied	\N	\N	\N	\N	196711	196711	363876
26193	41462	121	applied	\N	\N	\N	\N	196712	196712	363877
26193	41463	122	applied	\N	\N	\N	\N	196713	196713	363878
26193	41464	123	applied	\N	\N	\N	\N	196714	196714	363879
26193	41473	124	applied	\N	\N	\N	\N	196715	196715	363880
26193	41361	125	applied	\N	\N	\N	\N	196716	196716	363881
26194	41478	0	applied	\N	\N	\N	\N	196717	196717	363882
26194	41479	1	applied	\N	\N	\N	\N	196718	196718	363883
26194	41480	2	applied	\N	\N	\N	\N	196719	196719	363884
26194	41481	3	applied	\N	\N	\N	\N	196720	196720	363885
26194	41483	5	applied	\N	\N	\N	\N	196722	196722	363887
26195	41478	0	applied	\N	\N	\N	\N	196723	196723	363888
26195	41479	1	applied	\N	\N	\N	\N	196724	196724	363889
26195	41480	2	applied	\N	\N	\N	\N	196725	196725	363890
26195	41481	3	applied	\N	\N	\N	\N	196726	196726	363891
26195	41482	4	applied	\N	\N	\N	\N	196727	196727	363892
26195	41483	5	applied	\N	\N	\N	\N	196728	196728	363893
26198	41484	0	applied	\N	\N	\N	\N	196739	196739	363904
26198	41485	1	applied	\N	\N	1000000000	\N	196740	196740	363905
26204	41497	0	applied	\N	\N	\N	\N	196758	196758	363923
26204	41498	1	applied	\N	\N	\N	\N	196759	196759	363924
26204	41499	2	applied	\N	\N	\N	\N	196760	196760	363925
26204	41500	3	applied	\N	\N	\N	\N	196761	196761	363926
26205	41501	0	applied	\N	\N	\N	\N	196762	196762	363927
26205	41502	1	applied	\N	\N	\N	\N	196763	196763	363928
26205	41503	2	applied	\N	\N	\N	\N	196764	196764	363929
26205	41505	4	applied	\N	\N	\N	\N	196766	196766	363931
26205	41506	5	applied	\N	\N	\N	\N	196767	196767	363932
26205	41507	6	applied	\N	\N	\N	\N	196768	196768	363933
26205	41508	7	applied	\N	\N	\N	\N	196769	196769	363934
26205	41509	8	applied	\N	\N	\N	\N	196770	196770	363935
26205	41510	9	applied	\N	\N	\N	\N	196771	196771	363936
26205	41511	10	applied	\N	\N	\N	\N	196772	196772	363937
26205	41512	11	applied	\N	\N	\N	\N	196773	196773	363938
26205	41513	12	applied	\N	\N	\N	\N	196774	196774	363939
26212	41524	0	applied	\N	\N	\N	\N	196797	196797	363962
26212	41525	1	applied	\N	\N	\N	\N	196798	196798	363963
26212	41526	2	applied	\N	\N	\N	\N	196799	196799	363964
26215	41530	0	applied	\N	\N	\N	\N	196807	196807	363972
26215	41531	1	applied	\N	\N	\N	\N	196808	196808	363973
26215	41532	2	applied	\N	\N	\N	\N	196809	196809	363974
26215	41533	3	applied	\N	\N	\N	\N	196810	196810	363975
26217	41531	1	applied	\N	\N	\N	\N	196816	196816	363981
26217	41532	2	applied	\N	\N	\N	\N	196817	196817	363982
26217	41533	3	applied	\N	\N	\N	\N	196818	196818	363983
26220	41540	0	applied	\N	\N	\N	\N	196829	196829	363994
26220	41541	1	applied	\N	\N	\N	\N	196830	196830	363995
26220	41542	2	applied	\N	\N	\N	\N	196831	196831	363996
26220	41543	3	applied	\N	\N	\N	\N	196832	196832	363997
26222	41544	0	applied	\N	\N	\N	\N	196836	196836	364001
26222	41545	1	applied	\N	\N	\N	\N	196837	196837	364002
26222	41546	2	applied	\N	\N	\N	\N	196838	196838	364003
26225	41318	0	applied	\N	\N	\N	\N	196853	196853	364018
26225	41319	1	applied	\N	\N	\N	\N	196854	196854	364019
26225	41322	2	applied	\N	\N	\N	\N	196855	196855	364020
26225	41323	3	applied	\N	\N	\N	\N	196856	196856	364021
26225	41326	4	applied	\N	\N	\N	\N	196857	196857	364022
26225	41327	5	applied	\N	\N	\N	\N	196858	196858	364023
26190	41312	123	applied	\N	\N	\N	\N	196573	196573	363738
26199	41489	0	applied	\N	\N	\N	\N	196744	196744	363909
26199	41490	1	applied	\N	\N	\N	\N	196745	196745	363910
26199	41491	2	applied	\N	\N	\N	\N	196746	196746	363911
26207	41517	0	applied	\N	\N	\N	\N	196778	196778	363943
26207	41518	1	applied	\N	\N	\N	\N	196779	196779	363944
26207	41519	2	applied	\N	\N	\N	\N	196780	196780	363945
26207	41520	3	applied	\N	\N	\N	\N	196781	196781	363946
26210	41517	0	applied	\N	\N	\N	\N	196790	196790	363955
26210	41518	1	applied	\N	\N	\N	\N	196791	196791	363956
26210	41519	2	applied	\N	\N	\N	\N	196792	196792	363957
26210	41520	3	applied	\N	\N	\N	\N	196793	196793	363958
26211	41523	2	applied	\N	\N	\N	\N	196796	196796	363961
26213	41527	0	applied	\N	\N	\N	\N	196800	196800	363965
26213	41528	1	applied	\N	\N	\N	\N	196801	196801	363966
26213	41529	2	applied	\N	\N	\N	\N	196802	196802	363967
26214	41530	0	applied	\N	\N	\N	\N	196803	196803	363968
26214	41531	1	applied	\N	\N	\N	\N	196804	196804	363969
26214	41532	2	applied	\N	\N	\N	\N	196805	196805	363970
26214	41533	3	applied	\N	\N	\N	\N	196806	196806	363971
26216	41530	0	applied	\N	\N	\N	\N	196811	196811	363976
26216	41531	1	applied	\N	\N	\N	\N	196812	196812	363977
26216	41532	2	applied	\N	\N	\N	\N	196813	196813	363978
26216	41533	3	applied	\N	\N	\N	\N	196814	196814	363979
26218	41534	0	applied	\N	\N	\N	\N	196819	196819	363984
26218	41535	1	applied	\N	\N	\N	\N	196820	196820	363985
26218	41536	2	applied	\N	\N	\N	\N	196821	196821	363986
26218	41537	3	applied	\N	\N	\N	\N	196822	196822	363987
26218	41539	5	applied	\N	\N	\N	\N	196824	196824	363989
26219	41540	0	applied	\N	\N	\N	\N	196825	196825	363990
26219	41541	1	applied	\N	\N	\N	\N	196826	196826	363991
26219	41542	2	applied	\N	\N	\N	\N	196827	196827	363992
26219	41543	3	applied	\N	\N	\N	\N	196828	196828	363993
26221	41544	0	applied	\N	\N	\N	\N	196833	196833	363998
26221	41545	1	applied	\N	\N	\N	\N	196834	196834	363999
26221	41546	2	applied	\N	\N	\N	\N	196835	196835	364000
26223	41547	0	applied	\N	\N	\N	\N	196839	196839	364004
26223	41548	1	applied	\N	\N	\N	\N	196840	196840	364005
26223	41549	2	applied	\N	\N	\N	\N	196841	196841	364006
26223	41550	3	applied	\N	\N	\N	\N	196842	196842	364007
26223	41551	4	applied	\N	\N	\N	\N	196843	196843	364008
26223	41552	5	applied	\N	\N	\N	\N	196844	196844	364009
26223	41553	6	applied	\N	\N	\N	\N	196845	196845	364010
26224	41547	0	applied	\N	\N	\N	\N	196846	196846	364011
26224	41549	2	applied	\N	\N	\N	\N	196848	196848	364013
26224	41550	3	applied	\N	\N	\N	\N	196849	196849	364014
26224	41551	4	applied	\N	\N	\N	\N	196850	196850	364015
26224	41552	5	applied	\N	\N	\N	\N	196851	196851	364016
26224	41553	6	applied	\N	\N	\N	\N	196852	196852	364017
26226	41554	0	applied	\N	\N	\N	\N	196978	196978	364143
26226	41555	1	applied	\N	\N	\N	\N	196979	196979	364144
26226	41556	2	applied	\N	\N	\N	\N	196980	196980	364145
26226	41557	3	applied	\N	\N	\N	\N	196981	196981	364146
26226	41558	4	applied	\N	\N	\N	\N	196982	196982	364147
26226	41559	5	applied	\N	\N	\N	\N	196983	196983	364148
26226	41560	6	applied	\N	\N	\N	\N	196984	196984	364149
26226	41561	7	applied	\N	\N	1000000000	\N	196985	196985	364150
26226	41562	8	applied	\N	\N	\N	\N	196986	196986	364151
26226	41563	9	applied	\N	\N	\N	\N	196987	196987	364152
26226	41564	10	applied	\N	\N	\N	\N	196988	196988	364153
26226	41566	12	applied	\N	\N	\N	\N	196990	196990	364155
26226	41567	13	applied	\N	\N	\N	\N	196991	196991	364156
26226	41568	14	applied	\N	\N	\N	\N	196992	196992	364157
26226	41569	15	applied	\N	\N	\N	\N	196993	196993	364158
26226	41570	16	applied	\N	\N	\N	\N	196994	196994	364159
26226	41571	17	applied	\N	\N	\N	\N	196995	196995	364160
26226	41572	18	applied	\N	\N	\N	\N	196996	196996	364161
26226	41573	19	applied	\N	\N	\N	\N	196997	196997	364162
26226	41574	20	applied	\N	\N	\N	\N	196998	196998	364163
26226	41575	21	applied	\N	\N	\N	\N	196999	196999	364164
26226	41576	22	applied	\N	\N	\N	\N	197000	197000	364165
26226	41577	23	applied	\N	\N	\N	\N	197001	197001	364166
26227	41554	0	applied	\N	\N	\N	\N	197002	197002	364167
26227	41555	1	applied	\N	\N	\N	\N	197003	197003	364168
26227	41556	2	applied	\N	\N	\N	\N	197004	197004	364169
26227	41557	3	applied	\N	\N	\N	\N	197005	197005	364170
26227	41559	5	applied	\N	\N	\N	\N	197007	197007	364172
26227	41560	6	applied	\N	\N	\N	\N	197008	197008	364173
26227	41561	7	applied	\N	\N	1000000000	\N	197009	197009	364174
26227	41562	8	applied	\N	\N	\N	\N	197010	197010	364175
26227	41563	9	applied	\N	\N	\N	\N	197011	197011	364176
26227	41564	10	applied	\N	\N	\N	\N	197012	197012	364177
26227	41565	11	applied	\N	\N	\N	\N	197013	197013	364178
26227	41566	12	applied	\N	\N	\N	\N	197014	197014	364179
26227	41567	13	applied	\N	\N	\N	\N	197015	197015	364180
26227	41568	14	applied	\N	\N	\N	\N	197016	197016	364181
26227	41569	15	applied	\N	\N	\N	\N	197017	197017	364182
26227	41570	16	applied	\N	\N	\N	\N	197018	197018	364183
26227	41571	17	applied	\N	\N	\N	\N	197019	197019	364184
26227	41572	18	applied	\N	\N	\N	\N	197020	197020	364185
26227	41573	19	applied	\N	\N	\N	\N	197021	197021	364186
26228	41578	0	applied	\N	\N	\N	\N	197026	197026	364191
26228	41580	2	applied	\N	\N	\N	\N	197028	197028	364193
26234	41594	0	applied	\N	\N	\N	\N	197056	197056	364221
26234	41595	1	applied	\N	\N	\N	\N	197057	197057	364222
26234	41596	2	applied	\N	\N	\N	\N	197058	197058	364223
26234	41597	3	applied	\N	\N	\N	\N	197059	197059	364224
26234	41598	4	applied	\N	\N	\N	\N	197060	197060	364225
26234	41599	5	applied	\N	\N	\N	\N	197061	197061	364226
26234	41600	6	applied	\N	\N	\N	\N	197062	197062	364227
26242	41604	0	applied	\N	\N	\N	\N	197072	197072	364237
26242	41605	1	applied	\N	\N	\N	\N	197073	197073	364238
26242	41606	2	applied	\N	\N	\N	\N	197074	197074	364239
26243	41607	0	applied	\N	\N	\N	\N	197075	197075	364240
26243	41608	1	applied	\N	\N	\N	\N	197076	197076	364241
26243	41609	2	applied	\N	\N	\N	\N	197077	197077	364242
26243	41610	4	applied	\N	\N	\N	\N	197078	197078	364243
26243	41611	5	applied	\N	\N	\N	\N	197079	197079	364244
26243	41613	7	applied	\N	\N	\N	\N	197081	197081	364246
26243	41614	8	applied	\N	\N	\N	\N	197082	197082	364247
26198	41487	3	applied	\N	\N	\N	\N	196742	196742	363907
26198	41488	4	applied	\N	\N	\N	\N	196743	196743	363908
26225	41336	9	applied	\N	\N	\N	\N	196862	196862	364027
26225	41338	10	applied	\N	\N	\N	\N	196863	196863	364028
26225	41340	11	applied	\N	\N	\N	\N	196864	196864	364029
26225	41342	12	applied	\N	\N	\N	\N	196865	196865	364030
26225	41344	13	applied	\N	\N	\N	\N	196866	196866	364031
26225	41346	14	applied	\N	\N	\N	\N	196867	196867	364032
26225	41348	15	applied	\N	\N	\N	\N	196868	196868	364033
26225	41349	16	applied	\N	\N	\N	\N	196869	196869	364034
26225	41352	17	applied	\N	\N	\N	\N	196870	196870	364035
26225	41354	18	applied	\N	\N	\N	\N	196871	196871	364036
26225	41356	19	applied	\N	\N	\N	\N	196872	196872	364037
26225	41358	20	applied	\N	\N	\N	\N	196873	196873	364038
26225	41360	21	applied	\N	\N	\N	\N	196874	196874	364039
26225	41364	23	applied	\N	\N	\N	\N	196876	196876	364041
26225	41369	24	applied	\N	\N	\N	\N	196877	196877	364042
26225	41372	25	applied	\N	\N	\N	\N	196878	196878	364043
26225	41373	26	applied	\N	\N	\N	\N	196879	196879	364044
26225	41378	27	applied	\N	\N	\N	\N	196880	196880	364045
26225	41383	28	applied	\N	\N	\N	\N	196881	196881	364046
26225	41384	29	applied	\N	\N	\N	\N	196882	196882	364047
26225	41391	30	applied	\N	\N	\N	\N	196883	196883	364048
26225	41397	31	applied	\N	\N	\N	\N	196884	196884	364049
26225	41400	32	applied	\N	\N	\N	\N	196885	196885	364050
26225	41401	33	applied	\N	\N	\N	\N	196886	196886	364051
26225	41406	34	applied	\N	\N	\N	\N	196887	196887	364052
26225	41409	35	applied	\N	\N	\N	\N	196888	196888	364053
26225	41410	36	applied	\N	\N	\N	\N	196889	196889	364054
26225	41417	37	applied	\N	\N	\N	\N	196890	196890	364055
26225	41423	38	applied	\N	\N	\N	\N	196891	196891	364056
26225	41425	40	applied	\N	\N	\N	\N	196893	196893	364058
26225	41426	41	applied	\N	\N	\N	\N	196894	196894	364059
26225	41437	42	applied	\N	\N	\N	\N	196895	196895	364060
26225	41438	43	applied	\N	\N	\N	\N	196896	196896	364061
26225	41444	44	applied	\N	\N	\N	\N	196897	196897	364062
26225	41446	45	applied	\N	\N	\N	\N	196898	196898	364063
26225	41451	46	applied	\N	\N	\N	\N	196899	196899	364064
26225	41454	47	applied	\N	\N	\N	\N	196900	196900	364065
26225	41458	48	applied	\N	\N	\N	\N	196901	196901	364066
26225	41462	49	applied	\N	\N	\N	\N	196902	196902	364067
26225	41463	50	applied	\N	\N	\N	\N	196903	196903	364068
26225	41464	51	applied	\N	\N	\N	\N	196904	196904	364069
26225	41473	52	applied	\N	\N	\N	\N	196905	196905	364070
26225	41478	53	applied	\N	\N	\N	\N	196906	196906	364071
26225	41479	54	applied	\N	\N	\N	\N	196907	196907	364072
26225	41484	55	applied	\N	\N	\N	\N	196908	196908	364073
26225	41492	57	applied	\N	\N	\N	\N	196910	196910	364075
26225	41497	58	applied	\N	\N	\N	\N	196911	196911	364076
26225	41501	59	applied	\N	\N	\N	\N	196912	196912	364077
26225	41502	60	applied	\N	\N	\N	\N	196913	196913	364078
26225	41503	61	applied	\N	\N	\N	\N	196914	196914	364079
26225	41504	62	applied	\N	\N	\N	\N	196915	196915	364080
26225	41514	63	applied	\N	\N	\N	\N	196916	196916	364081
26225	41517	64	applied	\N	\N	\N	\N	196917	196917	364082
26225	41521	65	applied	\N	\N	\N	\N	196918	196918	364083
26225	41524	66	applied	\N	\N	\N	\N	196919	196919	364084
26225	41527	67	applied	\N	\N	\N	\N	196920	196920	364085
26225	41530	68	applied	\N	\N	\N	\N	196921	196921	364086
26225	41534	69	applied	\N	\N	\N	\N	196922	196922	364087
26225	41535	70	applied	\N	\N	\N	\N	196923	196923	364088
26225	41540	71	applied	\N	\N	\N	\N	196924	196924	364089
26225	41544	72	applied	\N	\N	\N	\N	196925	196925	364090
26243	41616	10	applied	\N	\N	\N	\N	197084	197084	364249
26243	41617	11	applied	\N	\N	\N	\N	197085	197085	364250
26243	41618	12	applied	\N	\N	1000000000	\N	197086	197086	364251
26243	41619	13	applied	\N	\N	\N	\N	197087	197087	364252
26243	41620	14	applied	\N	\N	1000000000	\N	197088	197088	364253
26243	41621	15	applied	\N	\N	\N	\N	197089	197089	364254
26243	41622	16	applied	\N	\N	\N	\N	197090	197090	364255
26243	41623	17	applied	\N	\N	\N	\N	197091	197091	364256
26250	41633	0	applied	\N	\N	\N	\N	197110	197110	364275
26250	41634	1	applied	\N	\N	\N	\N	197111	197111	364276
26250	41635	2	applied	\N	\N	\N	\N	197112	197112	364277
26250	41636	3	applied	\N	\N	\N	\N	197113	197113	364278
26251	41637	0	applied	\N	\N	\N	\N	197114	197114	364279
26251	41638	1	applied	\N	\N	\N	\N	197115	197115	364280
26251	41639	2	applied	\N	\N	\N	\N	197116	197116	364281
26251	41640	3	applied	\N	\N	\N	\N	197117	197117	364282
26251	41642	5	applied	\N	\N	\N	\N	197119	197119	364284
26251	41643	6	applied	\N	\N	\N	\N	197120	197120	364285
26251	41644	7	applied	\N	\N	\N	\N	197121	197121	364286
26251	41645	8	applied	\N	\N	\N	\N	197122	197122	364287
26251	41646	9	applied	\N	\N	\N	\N	197123	197123	364288
26251	41647	10	applied	\N	\N	\N	\N	197124	197124	364289
26251	41648	11	applied	\N	\N	\N	\N	197125	197125	364290
26251	41649	12	applied	\N	\N	\N	\N	197126	197126	364291
26254	41657	0	applied	\N	\N	\N	\N	197134	197134	364299
26254	41658	1	applied	\N	\N	\N	\N	197135	197135	364300
26254	41659	2	applied	\N	\N	\N	\N	197136	197136	364301
26261	41666	0	applied	\N	\N	\N	\N	197155	197155	364320
26261	41667	1	applied	\N	\N	\N	\N	197156	197156	364321
26261	41668	2	applied	\N	\N	\N	\N	197157	197157	364322
26261	41669	3	applied	\N	\N	\N	\N	197158	197158	364323
26261	41670	4	applied	\N	\N	\N	\N	197159	197159	364324
26269	41695	0	applied	\N	\N	\N	\N	197194	197194	364359
26269	41696	1	applied	\N	\N	\N	\N	197195	197195	364360
26269	41697	2	applied	\N	\N	\N	\N	197196	197196	364361
26271	41698	0	applied	\N	\N	\N	\N	197200	197200	364365
26271	41699	1	applied	\N	\N	\N	\N	197201	197201	364366
26271	41700	3	applied	\N	\N	\N	\N	197202	197202	364367
26271	41701	4	applied	\N	\N	\N	\N	197203	197203	364368
26274	41707	0	applied	\N	\N	\N	\N	197209	197209	364374
26274	41708	1	applied	\N	\N	\N	\N	197210	197210	364375
26274	41709	2	applied	\N	\N	\N	\N	197211	197211	364376
26274	41710	3	applied	\N	\N	\N	\N	197212	197212	364377
26279	41721	0	applied	\N	\N	\N	\N	197231	197231	364396
26279	41722	1	applied	\N	\N	\N	\N	197232	197232	364397
26279	41723	2	applied	\N	\N	\N	\N	197233	197233	364398
26282	41724	0	applied	\N	\N	\N	\N	197366	197366	364531
26282	41725	1	applied	\N	\N	\N	\N	197367	197367	364532
26225	41332	7	applied	\N	\N	\N	\N	196860	196860	364025
26225	41333	8	applied	\N	\N	\N	\N	196861	196861	364026
26225	41556	77	applied	\N	\N	\N	\N	196930	196930	364095
26225	41121	78	applied	\N	\N	\N	\N	196931	196931	364096
26225	41459	79	applied	\N	\N	1000000000	\N	196932	196932	364097
26225	41101	80	applied	\N	\N	\N	\N	196933	196933	364098
26225	41294	81	applied	\N	\N	\N	\N	196934	196934	364099
26225	41102	82	applied	\N	\N	\N	\N	196935	196935	364100
26225	41098	83	applied	\N	\N	\N	\N	196936	196936	364101
26225	41471	84	applied	\N	\N	\N	\N	196937	196937	364102
26225	41103	85	applied	\N	\N	\N	\N	196938	196938	364103
26225	41104	86	applied	\N	\N	\N	\N	196939	196939	364104
26225	41429	87	applied	\N	\N	\N	\N	196940	196940	364105
26225	41430	88	applied	\N	\N	\N	\N	196941	196941	364106
26225	41439	89	applied	\N	\N	\N	\N	196942	196942	364107
26225	41106	90	applied	\N	\N	\N	\N	196943	196943	364108
26225	41450	92	applied	\N	\N	\N	\N	196945	196945	364110
26225	41112	93	applied	\N	\N	\N	\N	196946	196946	364111
26225	41115	94	applied	\N	\N	\N	\N	196947	196947	364112
26225	41118	95	applied	\N	\N	\N	\N	196948	196948	364113
26225	41123	96	applied	\N	\N	\N	\N	196949	196949	364114
26225	41125	97	applied	\N	\N	\N	\N	196950	196950	364115
26225	41129	98	applied	\N	\N	\N	\N	196951	196951	364116
26225	41361	99	applied	\N	\N	\N	\N	196952	196952	364117
26225	41365	100	applied	\N	\N	\N	\N	196953	196953	364118
26225	41366	101	applied	\N	\N	\N	\N	196954	196954	364119
26225	41370	102	applied	\N	\N	\N	\N	196955	196955	364120
26225	41376	103	applied	\N	\N	\N	\N	196956	196956	364121
26225	41377	104	applied	\N	\N	\N	\N	196957	196957	364122
26225	41379	105	applied	\N	\N	\N	\N	196958	196958	364123
26225	41385	106	applied	\N	\N	\N	\N	196959	196959	364124
26225	41389	107	applied	\N	\N	\N	\N	196960	196960	364125
26225	41398	109	applied	\N	\N	\N	\N	196962	196962	364127
26225	41404	110	applied	\N	\N	\N	\N	196963	196963	364128
26225	41405	111	applied	\N	\N	\N	\N	196964	196964	364129
26225	41408	112	applied	\N	\N	\N	\N	196965	196965	364130
26225	41411	113	applied	\N	\N	\N	\N	196966	196966	364131
26225	41412	114	applied	\N	\N	\N	\N	196967	196967	364132
26225	41419	115	applied	\N	\N	\N	\N	196968	196968	364133
26225	41421	116	applied	\N	\N	\N	\N	196969	196969	364134
26225	41428	118	applied	\N	\N	\N	\N	196970	196970	364135
26225	41431	119	applied	\N	\N	\N	\N	196971	196971	364136
26225	41432	120	applied	\N	\N	\N	\N	196972	196972	364137
26225	41433	121	applied	\N	\N	\N	\N	196973	196973	364138
26225	41440	122	applied	\N	\N	\N	\N	196974	196974	364139
26225	41443	123	applied	\N	\N	\N	\N	196975	196975	364140
26225	41445	124	applied	\N	\N	\N	\N	196976	196976	364141
26225	41447	125	applied	\N	\N	\N	\N	196977	196977	364142
26227	41575	21	applied	\N	\N	\N	\N	197023	197023	364188
26227	41576	22	applied	\N	\N	\N	\N	197024	197024	364189
26227	41577	23	applied	\N	\N	\N	\N	197025	197025	364190
26229	41581	0	applied	\N	\N	\N	\N	197029	197029	364194
26229	41582	1	applied	\N	\N	\N	\N	197030	197030	364195
26229	41583	2	applied	\N	\N	\N	\N	197031	197031	364196
26232	41591	0	applied	\N	\N	\N	\N	197046	197046	364211
26236	41601	0	applied	\N	\N	\N	\N	197063	197063	364228
26236	41602	1	applied	\N	\N	\N	\N	197064	197064	364229
26236	41603	2	applied	\N	\N	\N	\N	197065	197065	364230
26237	41601	0	applied	\N	\N	\N	\N	197066	197066	364231
26237	41602	1	applied	\N	\N	\N	\N	197067	197067	364232
26237	41603	2	applied	\N	\N	\N	\N	197068	197068	364233
26244	41624	0	applied	\N	\N	\N	\N	197092	197092	364257
26244	41625	1	applied	\N	\N	\N	\N	197093	197093	364258
26244	41626	2	applied	\N	\N	\N	\N	197094	197094	364259
26247	41625	1	applied	\N	\N	\N	\N	197102	197102	364267
26247	41626	2	applied	\N	\N	\N	\N	197103	197103	364268
26248	41627	0	applied	\N	\N	\N	\N	197104	197104	364269
26248	41628	1	applied	\N	\N	\N	\N	197105	197105	364270
26248	41629	2	applied	\N	\N	\N	\N	197106	197106	364271
26252	41650	0	applied	\N	\N	\N	\N	197127	197127	364292
26252	41651	1	applied	\N	\N	\N	\N	197128	197128	364293
26252	41652	2	applied	\N	\N	\N	\N	197129	197129	364294
26257	41660	0	applied	\N	\N	\N	\N	197143	197143	364308
26257	41661	1	applied	\N	\N	\N	\N	197144	197144	364309
26257	41662	2	applied	\N	\N	\N	\N	197145	197145	364310
26259	41663	0	applied	\N	\N	\N	\N	197149	197149	364314
26259	41664	1	applied	\N	\N	\N	\N	197150	197150	364315
26259	41665	2	applied	\N	\N	\N	\N	197151	197151	364316
26262	41672	0	applied	\N	\N	\N	\N	197161	197161	364326
26262	41673	1	applied	\N	\N	\N	\N	197162	197162	364327
26262	41675	3	applied	\N	\N	\N	\N	197164	197164	364329
26262	41676	4	applied	\N	\N	\N	\N	197165	197165	364330
26262	41677	5	applied	\N	\N	\N	\N	197166	197166	364331
26262	41678	6	applied	\N	\N	\N	\N	197167	197167	364332
26264	41679	0	applied	\N	\N	\N	\N	197175	197175	364340
26264	41680	1	applied	\N	\N	\N	\N	197176	197176	364341
26264	41681	2	applied	\N	\N	\N	\N	197177	197177	364342
26267	41692	0	applied	\N	\N	\N	\N	197188	197188	364353
26267	41693	1	applied	\N	\N	\N	\N	197189	197189	364354
26267	41694	2	applied	\N	\N	\N	\N	197190	197190	364355
26270	41695	0	applied	\N	\N	\N	\N	197197	197197	364362
26270	41696	1	applied	\N	\N	\N	\N	197198	197198	364363
26270	41697	2	applied	\N	\N	\N	\N	197199	197199	364364
26272	41702	0	applied	\N	\N	\N	\N	197204	197204	364369
26272	41703	1	applied	\N	\N	\N	\N	197205	197205	364370
26275	41707	0	applied	\N	\N	\N	\N	197213	197213	364378
26275	41709	2	applied	\N	\N	\N	\N	197215	197215	364380
26275	41710	3	applied	\N	\N	\N	\N	197216	197216	364381
26277	41711	0	applied	\N	\N	\N	\N	197221	197221	364386
26277	41712	1	applied	\N	\N	\N	\N	197222	197222	364387
26277	41713	2	applied	\N	\N	\N	\N	197223	197223	364388
26277	41714	3	applied	\N	\N	\N	\N	197224	197224	364389
26277	41715	4	applied	\N	\N	\N	\N	197225	197225	364390
26277	41716	5	applied	\N	\N	\N	\N	197226	197226	364391
26290	41745	0	applied	\N	\N	\N	\N	197403	197403	364568
26290	41746	1	applied	\N	\N	\N	\N	197404	197404	364569
26298	41762	0	applied	\N	\N	\N	\N	197446	197446	364611
26298	41763	1	applied	\N	\N	\N	\N	197447	197447	364612
26306	41783	0	applied	\N	\N	\N	\N	197479	197479	364644
26313	41782	0	applied	\N	\N	\N	\N	197531	197531	364696
26313	41785	1	applied	\N	\N	\N	\N	197532	197532	364697
26313	41786	2	applied	\N	\N	\N	\N	197533	197533	364698
26225	41555	76	applied	\N	\N	\N	\N	196929	196929	364094
26238	41603	2	applied	\N	\N	\N	\N	197071	197071	364236
26245	41624	0	applied	\N	\N	\N	\N	197095	197095	364260
26245	41625	1	applied	\N	\N	\N	\N	197096	197096	364261
26245	41626	2	applied	\N	\N	\N	\N	197097	197097	364262
26255	41660	0	applied	\N	\N	\N	\N	197137	197137	364302
26255	41661	1	applied	\N	\N	\N	\N	197138	197138	364303
26255	41662	2	applied	\N	\N	\N	\N	197139	197139	364304
26258	41660	0	applied	\N	\N	\N	\N	197146	197146	364311
26258	41661	1	applied	\N	\N	\N	\N	197147	197147	364312
26258	41662	2	applied	\N	\N	\N	\N	197148	197148	364313
26260	41663	0	applied	\N	\N	\N	\N	197152	197152	364317
26260	41664	1	applied	\N	\N	\N	\N	197153	197153	364318
26260	41665	2	applied	\N	\N	\N	\N	197154	197154	364319
26263	41672	0	applied	\N	\N	\N	\N	197168	197168	364333
26263	41673	1	applied	\N	\N	\N	\N	197169	197169	364334
26263	41674	2	applied	\N	\N	\N	\N	197170	197170	364335
26263	41676	4	applied	\N	\N	\N	\N	197172	197172	364337
26263	41677	5	applied	\N	\N	\N	\N	197173	197173	364338
26263	41678	6	applied	\N	\N	\N	\N	197174	197174	364339
26265	41682	0	applied	\N	\N	\N	\N	197178	197178	364343
26265	41683	1	applied	\N	\N	\N	\N	197179	197179	364344
26265	41684	2	applied	\N	\N	\N	\N	197180	197180	364345
26265	41685	3	applied	\N	\N	\N	\N	197181	197181	364346
26265	41686	4	applied	\N	\N	\N	\N	197182	197182	364347
26265	41687	5	applied	\N	\N	\N	\N	197183	197183	364348
26265	41688	6	applied	\N	\N	\N	\N	197184	197184	364349
26276	41707	0	applied	\N	\N	\N	\N	197217	197217	364382
26276	41708	1	applied	\N	\N	\N	\N	197218	197218	364383
26276	41709	2	applied	\N	\N	\N	\N	197219	197219	364384
26276	41710	3	applied	\N	\N	\N	\N	197220	197220	364385
26280	41195	0	applied	\N	\N	\N	\N	197234	197234	364399
26280	41158	1	applied	\N	\N	\N	\N	197235	197235	364400
26280	41162	3	applied	\N	\N	\N	\N	197237	197237	364402
26280	41163	4	applied	\N	\N	\N	\N	197238	197238	364403
26280	41169	5	applied	\N	\N	\N	\N	197239	197239	364404
26280	41171	6	applied	\N	\N	\N	\N	197240	197240	364405
26280	41196	7	applied	\N	\N	\N	\N	197241	197241	364406
26280	41197	8	applied	\N	\N	\N	\N	197242	197242	364407
26280	41198	9	applied	\N	\N	\N	\N	197243	197243	364408
26280	41201	10	applied	\N	\N	\N	\N	197244	197244	364409
26280	41203	11	applied	\N	\N	\N	\N	197245	197245	364410
26280	41204	12	applied	\N	\N	\N	\N	197246	197246	364411
26280	41205	13	applied	\N	\N	\N	\N	197247	197247	364412
26280	41206	14	applied	\N	\N	\N	\N	197248	197248	364413
26280	41207	15	applied	\N	\N	\N	\N	197249	197249	364414
26280	41208	16	applied	\N	\N	\N	\N	197250	197250	364415
26280	41209	17	applied	\N	\N	\N	\N	197251	197251	364416
26280	41210	18	applied	\N	\N	\N	\N	197252	197252	364417
26280	41289	20	applied	\N	\N	\N	\N	197254	197254	364419
26280	41290	21	applied	\N	\N	\N	\N	197255	197255	364420
26280	41219	22	applied	\N	\N	\N	\N	197256	197256	364421
26280	41220	23	applied	\N	\N	\N	\N	197257	197257	364422
26280	41221	24	applied	\N	\N	\N	\N	197258	197258	364423
26280	41222	25	applied	\N	\N	\N	\N	197259	197259	364424
26280	41223	26	applied	\N	\N	\N	\N	197260	197260	364425
26280	41172	27	applied	\N	\N	\N	\N	197261	197261	364426
26280	41173	28	applied	\N	\N	\N	\N	197262	197262	364427
26280	41174	29	applied	\N	\N	\N	\N	197263	197263	364428
26280	41175	30	applied	\N	\N	\N	\N	197264	197264	364429
26280	41176	31	applied	\N	\N	\N	\N	197265	197265	364430
26313	41784	3	applied	\N	\N	\N	\N	197534	197534	364699
26313	41787	4	applied	\N	\N	\N	\N	197535	197535	364700
26313	41788	5	applied	\N	\N	\N	\N	197536	197536	364701
26314	41789	0	applied	\N	\N	\N	\N	197537	197537	364702
26314	41791	2	applied	\N	\N	\N	\N	197539	197539	364704
26325	41801	0	applied	\N	\N	\N	\N	197585	197585	364750
26325	41802	1	applied	\N	\N	\N	\N	197586	197586	364751
26328	41803	0	applied	\N	\N	\N	\N	197590	197590	364755
26328	41804	1	applied	\N	\N	\N	\N	197591	197591	364756
26331	41805	0	applied	\N	\N	\N	\N	197598	197598	364763
26331	41806	1	applied	\N	\N	\N	\N	197599	197599	364764
26331	41807	2	applied	\N	\N	\N	\N	197600	197600	364765
26331	41808	3	applied	\N	\N	\N	\N	197601	197601	364766
26331	41809	4	applied	\N	\N	\N	\N	197602	197602	364767
26338	41819	0	applied	\N	\N	\N	\N	197626	197626	364791
26342	41826	0	applied	\N	\N	\N	\N	197642	197642	364807
26342	41827	1	applied	\N	\N	\N	\N	197643	197643	364808
26345	41828	0	applied	\N	\N	\N	\N	197649	197649	364814
26345	41829	1	applied	\N	\N	\N	\N	197650	197650	364815
26345	41830	2	applied	\N	\N	\N	\N	197651	197651	364816
26347	41830	1	applied	\N	\N	\N	\N	197656	197656	364821
26352	41832	0	applied	\N	\N	\N	\N	197668	197668	364833
26352	41833	1	applied	\N	\N	\N	\N	197669	197669	364834
26352	41834	2	applied	\N	\N	\N	\N	197670	197670	364835
26352	41835	3	applied	\N	\N	\N	\N	197671	197671	364836
26352	41836	4	applied	\N	\N	\N	\N	197672	197672	364837
26352	41837	5	applied	\N	\N	\N	\N	197673	197673	364838
26352	41838	6	applied	\N	\N	\N	\N	197674	197674	364839
26354	41839	0	applied	\N	\N	\N	\N	197677	197677	364842
26354	41840	1	applied	\N	\N	\N	\N	197678	197678	364843
26357	41843	0	applied	\N	\N	\N	\N	197688	197688	364853
26357	41844	1	applied	\N	\N	\N	\N	197689	197689	364854
26357	41845	2	applied	\N	\N	\N	\N	197690	197690	364855
26357	41846	3	applied	\N	\N	\N	\N	197691	197691	364856
26357	41847	4	applied	\N	\N	\N	\N	197692	197692	364857
26357	41848	5	applied	\N	\N	\N	\N	197693	197693	364858
26359	41850	0	applied	\N	\N	\N	\N	197820	197820	364985
26359	41851	1	applied	\N	\N	\N	\N	197821	197821	364986
26359	41852	2	applied	\N	\N	\N	\N	197822	197822	364987
26364	41860	0	applied	\N	\N	\N	\N	197833	197833	364998
26364	41861	1	applied	\N	\N	\N	\N	197834	197834	364999
26367	41869	0	applied	\N	\N	\N	\N	197842	197842	365007
26367	41870	1	applied	\N	\N	\N	\N	197843	197843	365008
26367	41871	2	applied	\N	\N	\N	\N	197844	197844	365009
26367	41872	3	applied	\N	\N	\N	\N	197845	197845	365010
26370	41878	0	applied	\N	\N	\N	\N	197854	197854	365019
26370	41879	1	applied	\N	\N	\N	\N	197855	197855	365020
26370	41876	2	applied	\N	\N	\N	\N	197856	197856	365021
26370	41877	3	applied	\N	\N	\N	\N	197857	197857	365022
26370	41880	4	applied	\N	\N	\N	\N	197858	197858	365023
26232	41593	2	applied	\N	\N	\N	\N	197048	197048	364213
26238	41601	0	applied	\N	\N	\N	\N	197069	197069	364234
26280	41182	36	applied	\N	\N	\N	\N	197270	197270	364435
26280	41183	37	applied	\N	\N	\N	\N	197271	197271	364436
26280	41184	38	applied	\N	\N	\N	\N	197272	197272	364437
26280	41185	39	applied	\N	\N	\N	\N	197273	197273	364438
26280	41186	40	applied	\N	\N	\N	\N	197274	197274	364439
26280	41224	41	applied	\N	\N	\N	\N	197275	197275	364440
26280	41233	42	applied	\N	\N	\N	\N	197276	197276	364441
26280	41241	43	applied	\N	\N	\N	\N	197277	197277	364442
26280	41048	44	applied	\N	\N	\N	\N	197278	197278	364443
26280	41050	45	applied	\N	\N	\N	\N	197279	197279	364444
26280	41052	46	applied	\N	\N	\N	\N	197280	197280	364445
26280	41054	47	applied	\N	\N	\N	\N	197281	197281	364446
26280	41056	48	applied	\N	\N	\N	\N	197282	197282	364447
26280	41058	49	applied	\N	\N	\N	\N	197283	197283	364448
26280	41059	50	applied	\N	\N	\N	\N	197284	197284	364449
26280	41062	51	applied	\N	\N	\N	\N	197285	197285	364450
26280	41243	53	applied	\N	\N	\N	\N	197287	197287	364452
26280	41066	54	applied	\N	\N	\N	\N	197288	197288	364453
26280	41068	55	applied	\N	\N	\N	\N	197289	197289	364454
26280	41070	56	applied	\N	\N	\N	\N	197290	197290	364455
26280	41071	57	applied	\N	\N	\N	\N	197291	197291	364456
26280	41072	58	applied	\N	\N	\N	\N	197292	197292	364457
26280	41076	59	applied	\N	\N	\N	\N	197293	197293	364458
26280	41078	60	applied	\N	\N	\N	\N	197294	197294	364459
26280	41080	61	applied	\N	\N	\N	\N	197295	197295	364460
26280	41082	62	applied	\N	\N	\N	\N	197296	197296	364461
26280	41084	63	applied	\N	\N	\N	\N	197297	197297	364462
26280	41086	64	applied	\N	\N	\N	\N	197298	197298	364463
26280	41087	65	applied	\N	\N	\N	\N	197299	197299	364464
26280	41090	66	applied	\N	\N	\N	\N	197300	197300	364465
26280	41091	67	applied	\N	\N	\N	\N	197301	197301	364466
26280	41095	68	applied	\N	\N	\N	\N	197302	197302	364467
26280	41099	70	applied	\N	\N	\N	\N	197304	197304	364469
26280	41100	71	applied	\N	\N	\N	\N	197305	197305	364470
26280	41105	72	applied	\N	\N	\N	\N	197306	197306	364471
26280	41108	73	applied	\N	\N	\N	\N	197307	197307	364472
26280	41109	74	applied	\N	\N	\N	\N	197308	197308	364473
26280	41114	75	applied	\N	\N	\N	\N	197309	197309	364474
26280	41117	77	applied	\N	\N	\N	\N	197310	197310	364475
26280	41120	78	applied	\N	\N	\N	\N	197311	197311	364476
26280	41124	79	applied	\N	\N	\N	\N	197312	197312	364477
26280	41127	80	applied	\N	\N	\N	\N	197313	197313	364478
26280	41130	81	applied	\N	\N	\N	\N	197314	197314	364479
26280	41132	82	applied	\N	\N	\N	\N	197315	197315	364480
26280	41134	83	applied	\N	\N	\N	\N	197316	197316	364481
26280	41136	84	applied	\N	\N	\N	\N	197317	197317	364482
26280	41138	85	applied	\N	\N	\N	\N	197318	197318	364483
26280	41140	86	applied	\N	\N	\N	\N	197319	197319	364484
26280	41143	88	applied	\N	\N	\N	\N	197321	197321	364486
26280	41146	89	applied	\N	\N	\N	\N	197322	197322	364487
26280	41148	90	applied	\N	\N	\N	\N	197323	197323	364488
26280	41150	91	applied	\N	\N	\N	\N	197324	197324	364489
26280	41152	92	applied	\N	\N	\N	\N	197325	197325	364490
26280	41153	93	applied	\N	\N	\N	\N	197326	197326	364491
26280	41156	94	applied	\N	\N	\N	\N	197327	197327	364492
26280	41157	95	applied	\N	\N	\N	\N	197328	197328	364493
26280	41159	96	applied	\N	\N	\N	\N	197329	197329	364494
26280	41160	97	applied	\N	\N	\N	\N	197330	197330	364495
26280	41170	98	applied	\N	\N	\N	\N	197331	197331	364496
26280	41187	99	applied	\N	\N	\N	\N	197332	197332	364497
26280	41189	100	applied	\N	\N	\N	\N	197333	197333	364498
26280	41191	101	applied	\N	\N	\N	\N	197334	197334	364499
26280	41193	102	applied	\N	\N	\N	\N	197335	197335	364500
26280	41199	103	applied	\N	\N	\N	\N	197336	197336	364501
26280	41212	105	applied	\N	\N	\N	\N	197338	197338	364503
26280	41213	106	applied	\N	\N	\N	\N	197339	197339	364504
26280	41225	107	applied	\N	\N	\N	\N	197340	197340	364505
26280	41226	108	applied	\N	\N	\N	\N	197341	197341	364506
26280	41227	109	applied	\N	\N	\N	\N	197342	197342	364507
26280	41231	110	applied	\N	\N	\N	\N	197343	197343	364508
26280	41232	111	applied	\N	\N	\N	\N	197344	197344	364509
26280	41234	112	applied	\N	\N	\N	\N	197345	197345	364510
26280	41235	113	applied	\N	\N	\N	\N	197346	197346	364511
26280	41240	114	applied	\N	\N	\N	\N	197347	197347	364512
26280	41242	115	applied	\N	\N	\N	\N	197348	197348	364513
26280	41246	116	applied	\N	\N	\N	\N	197349	197349	364514
26280	41247	117	applied	\N	\N	\N	\N	197350	197350	364515
26280	41248	118	applied	\N	\N	\N	\N	197351	197351	364516
26280	41249	119	applied	\N	\N	\N	\N	197352	197352	364517
26280	41254	120	applied	\N	\N	\N	\N	197353	197353	364518
26280	41258	122	applied	\N	\N	\N	\N	197355	197355	364520
26280	41260	123	applied	\N	\N	\N	\N	197356	197356	364521
26280	41262	124	applied	\N	\N	\N	\N	197357	197357	364522
26280	41264	125	applied	\N	\N	\N	\N	197358	197358	364523
26283	41724	0	applied	\N	\N	\N	\N	197373	197373	364538
26283	41725	1	applied	\N	\N	\N	\N	197374	197374	364539
26283	41726	2	applied	\N	\N	\N	\N	197375	197375	364540
26283	41727	3	applied	\N	\N	\N	\N	197376	197376	364541
26283	41728	4	applied	\N	\N	\N	\N	197377	197377	364542
26283	41729	5	applied	\N	\N	\N	\N	197378	197378	364543
26283	41730	6	applied	\N	\N	\N	\N	197379	197379	364544
26285	41731	0	applied	\N	\N	\N	\N	197387	197387	364552
26285	41732	1	applied	\N	\N	\N	\N	197388	197388	364553
26287	41733	0	applied	\N	\N	\N	\N	197391	197391	364556
26287	41734	1	applied	\N	\N	\N	\N	197392	197392	364557
26288	41735	0	applied	\N	\N	\N	\N	197393	197393	364558
26288	41737	2	applied	\N	\N	\N	\N	197395	197395	364560
26288	41738	3	applied	\N	\N	\N	\N	197396	197396	364561
26288	41739	4	applied	\N	\N	\N	\N	197397	197397	364562
26288	41740	5	applied	\N	\N	\N	\N	197398	197398	364563
26288	41741	6	applied	\N	\N	\N	\N	197399	197399	364564
26293	41749	0	applied	\N	\N	\N	\N	197409	197409	364574
26293	41750	1	applied	\N	\N	\N	\N	197410	197410	364575
26294	41751	0	applied	\N	\N	\N	\N	197411	197411	364576
26294	41752	1	applied	\N	\N	\N	\N	197412	197412	364577
26294	41753	2	applied	\N	\N	\N	\N	197413	197413	364578
26294	41754	3	applied	\N	\N	\N	\N	197414	197414	364579
26294	41755	4	applied	\N	\N	\N	\N	197415	197415	364580
26294	41756	5	applied	\N	\N	\N	\N	197416	197416	364581
26294	41757	6	applied	\N	\N	\N	\N	197417	197417	364582
26280	41179	33	applied	\N	\N	\N	\N	197267	197267	364432
26280	41180	34	applied	\N	\N	\N	\N	197268	197268	364433
26284	41724	0	applied	\N	\N	\N	\N	197380	197380	364545
26284	41725	1	applied	\N	\N	\N	\N	197381	197381	364546
26284	41726	2	applied	\N	\N	\N	\N	197382	197382	364547
26284	41727	3	applied	\N	\N	\N	\N	197383	197383	364548
26284	41728	4	applied	\N	\N	\N	\N	197384	197384	364549
26284	41729	5	applied	\N	\N	\N	\N	197385	197385	364550
26284	41730	6	applied	\N	\N	\N	\N	197386	197386	364551
26286	41731	0	applied	\N	\N	\N	\N	197389	197389	364554
26286	41732	1	applied	\N	\N	\N	\N	197390	197390	364555
26289	41742	0	applied	\N	\N	\N	\N	197400	197400	364565
26289	41743	1	applied	\N	\N	\N	\N	197401	197401	364566
26289	41744	2	applied	\N	\N	\N	\N	197402	197402	364567
26292	41747	0	applied	\N	\N	\N	\N	197407	197407	364572
26292	41748	1	applied	\N	\N	\N	\N	197408	197408	364573
26294	41758	7	applied	\N	\N	\N	\N	197418	197418	364583
26294	41759	8	applied	\N	\N	\N	\N	197419	197419	364584
26294	41761	10	applied	\N	\N	\N	\N	197421	197421	364586
26296	41751	0	applied	\N	\N	\N	\N	197433	197433	364598
26296	41752	1	applied	\N	\N	\N	\N	197434	197434	364599
26296	41753	2	applied	\N	\N	\N	\N	197435	197435	364600
26296	41754	3	applied	\N	\N	\N	\N	197436	197436	364601
26296	41755	4	applied	\N	\N	\N	\N	197437	197437	364602
26296	41756	5	applied	\N	\N	\N	\N	197438	197438	364603
26296	41757	6	applied	\N	\N	\N	\N	197439	197439	364604
26296	41758	7	applied	\N	\N	\N	\N	197440	197440	364605
26296	41759	8	applied	\N	\N	\N	\N	197441	197441	364606
26296	41760	9	applied	\N	\N	\N	\N	197442	197442	364607
26296	41761	10	applied	\N	\N	\N	\N	197443	197443	364608
26297	41762	0	applied	\N	\N	\N	\N	197444	197444	364609
26297	41763	1	applied	\N	\N	\N	\N	197445	197445	364610
26300	41764	0	applied	\N	\N	\N	\N	197453	197453	364618
26300	41765	1	applied	\N	\N	\N	\N	197454	197454	364619
26300	41767	3	applied	\N	\N	\N	\N	197456	197456	364621
26300	41768	4	applied	\N	\N	\N	\N	197457	197457	364622
26301	41764	0	applied	\N	\N	\N	\N	197458	197458	364623
26301	41765	1	applied	\N	\N	\N	\N	197459	197459	364624
26301	41766	2	applied	\N	\N	\N	\N	197460	197460	364625
26301	41767	3	applied	\N	\N	\N	\N	197461	197461	364626
26301	41768	4	applied	\N	\N	\N	\N	197462	197462	364627
26303	41775	0	applied	\N	\N	\N	\N	197469	197469	364634
26303	41776	1	applied	\N	\N	\N	\N	197470	197470	364635
26303	41777	2	applied	\N	\N	\N	\N	197471	197471	364636
26303	41778	3	applied	\N	\N	\N	\N	197472	197472	364637
26303	41779	4	applied	\N	\N	\N	\N	197473	197473	364638
26304	41780	0	applied	\N	\N	\N	\N	197474	197474	364639
26304	41781	1	applied	\N	\N	\N	\N	197475	197475	364640
26309	41459	0	applied	\N	\N	\N	\N	197480	197480	364645
26309	41471	1	applied	\N	\N	\N	\N	197481	197481	364646
26309	41430	3	applied	\N	\N	\N	\N	197483	197483	364648
26309	41439	4	applied	\N	\N	\N	\N	197484	197484	364649
26309	41450	5	applied	\N	\N	\N	\N	197485	197485	364650
26309	41761	6	applied	\N	\N	\N	\N	197486	197486	364651
26309	41472	7	applied	\N	\N	\N	\N	197487	197487	364652
26309	41474	8	applied	\N	\N	\N	\N	197488	197488	364653
26309	41486	9	applied	\N	\N	\N	\N	197489	197489	364654
26309	41499	10	applied	\N	\N	\N	\N	197490	197490	364655
26309	41510	11	applied	\N	\N	\N	\N	197491	197491	364656
26309	41519	12	applied	\N	\N	\N	\N	197492	197492	364657
26309	41531	13	applied	\N	\N	\N	\N	197493	197493	364658
26309	41543	14	applied	\N	\N	\N	\N	197494	197494	364659
26309	41549	15	applied	\N	\N	\N	\N	197495	197495	364660
26309	41570	16	applied	\N	\N	\N	\N	197496	197496	364661
26309	41571	17	applied	\N	\N	\N	\N	197497	197497	364662
26309	41590	18	applied	\N	\N	\N	\N	197498	197498	364663
26309	41611	20	applied	\N	\N	\N	\N	197500	197500	364665
26309	41621	21	applied	\N	\N	\N	\N	197501	197501	364666
26309	41636	22	applied	\N	\N	\N	\N	197502	197502	364667
26309	41643	23	applied	\N	\N	\N	\N	197503	197503	364668
26309	41656	24	applied	\N	\N	\N	\N	197504	197504	364669
26309	41671	25	applied	\N	\N	\N	\N	197505	197505	364670
26315	41789	0	applied	\N	\N	\N	\N	197540	197540	364705
26315	41790	1	applied	\N	\N	\N	\N	197541	197541	364706
26315	41791	2	applied	\N	\N	\N	\N	197542	197542	364707
26317	41792	0	applied	\N	\N	\N	\N	197545	197545	364710
26317	41793	1	applied	\N	\N	\N	\N	197546	197546	364711
26317	41790	2	applied	\N	\N	\N	\N	197547	197547	364712
26317	41794	3	applied	\N	\N	\N	\N	197548	197548	364713
26317	41795	4	applied	\N	\N	\N	\N	197549	197549	364714
26320	41792	0	applied	\N	\N	\N	\N	197560	197560	364725
26320	41793	1	applied	\N	\N	\N	\N	197561	197561	364726
26320	41794	3	applied	\N	\N	\N	\N	197563	197563	364728
26320	41795	4	applied	\N	\N	\N	\N	197564	197564	364729
26324	41796	0	applied	\N	\N	\N	\N	197580	197580	364745
26324	41797	1	applied	\N	\N	\N	\N	197581	197581	364746
26324	41798	2	applied	\N	\N	\N	\N	197582	197582	364747
26324	41799	3	applied	\N	\N	\N	\N	197583	197583	364748
26324	41800	4	applied	\N	\N	\N	\N	197584	197584	364749
26326	41803	0	applied	\N	\N	\N	\N	197587	197587	364752
26326	41804	1	applied	\N	\N	\N	\N	197588	197588	364753
26332	41805	0	applied	\N	\N	\N	\N	197603	197603	364768
26332	41806	1	applied	\N	\N	\N	\N	197604	197604	364769
26332	41807	2	applied	\N	\N	\N	\N	197605	197605	364770
26332	41808	3	applied	\N	\N	\N	\N	197606	197606	364771
26332	41809	4	applied	\N	\N	\N	\N	197607	197607	364772
26335	41812	0	applied	\N	\N	\N	\N	197617	197617	364782
26335	41813	1	applied	\N	\N	\N	\N	197618	197618	364783
26343	41826	0	applied	\N	\N	\N	\N	197644	197644	364809
26343	41827	1	applied	\N	\N	\N	\N	197645	197645	364810
26346	41828	0	applied	\N	\N	\N	\N	197652	197652	364817
26346	41829	1	applied	\N	\N	\N	\N	197653	197653	364818
26346	41830	2	applied	\N	\N	\N	\N	197654	197654	364819
26348	41828	0	applied	\N	\N	\N	\N	197657	197657	364822
26348	41829	1	applied	\N	\N	\N	\N	197658	197658	364823
26349	41831	0	applied	\N	\N	\N	\N	197659	197659	364824
26362	41857	0	applied	\N	\N	\N	\N	197827	197827	364992
26362	41858	1	applied	\N	\N	\N	\N	197828	197828	364993
26362	41859	2	applied	\N	\N	\N	\N	197829	197829	364994
26368	41873	0	applied	\N	\N	\N	\N	197846	197846	365011
26368	41874	1	applied	\N	\N	\N	\N	197847	197847	365012
26368	41875	2	applied	\N	\N	\N	\N	197848	197848	365013
26282	41728	4	applied	\N	\N	\N	\N	197370	197370	364535
26282	41729	5	applied	\N	\N	\N	\N	197371	197371	364536
26302	41772	3	applied	\N	\N	\N	\N	197466	197466	364631
26302	41773	4	applied	\N	\N	\N	\N	197467	197467	364632
26302	41774	5	applied	\N	\N	\N	\N	197468	197468	364633
26305	41782	0	applied	\N	\N	\N	\N	197476	197476	364641
26305	41783	1	applied	\N	\N	\N	\N	197477	197477	364642
26305	41784	2	applied	\N	\N	\N	\N	197478	197478	364643
26309	41676	26	applied	\N	\N	\N	\N	197506	197506	364671
26309	41685	27	applied	\N	\N	\N	\N	197507	197507	364672
26309	41699	28	applied	\N	\N	\N	\N	197508	197508	364673
26309	41708	29	applied	\N	\N	\N	\N	197509	197509	364674
26309	41720	30	applied	\N	\N	\N	\N	197510	197510	364675
26309	41730	31	applied	\N	\N	\N	\N	197511	197511	364676
26309	41738	32	applied	\N	\N	\N	\N	197512	197512	364677
26309	41744	33	applied	\N	\N	\N	\N	197513	197513	364678
26309	41756	35	applied	\N	\N	\N	\N	197515	197515	364680
26309	41768	36	applied	\N	\N	\N	\N	197516	197516	364681
26309	41777	37	applied	\N	\N	\N	\N	197517	197517	364682
26309	41783	38	applied	\N	\N	\N	\N	197518	197518	364683
26311	41782	0	applied	\N	\N	\N	\N	197519	197519	364684
26311	41785	1	applied	\N	\N	\N	\N	197520	197520	364685
26311	41786	2	applied	\N	\N	\N	\N	197521	197521	364686
26311	41784	3	applied	\N	\N	\N	\N	197522	197522	364687
26311	41787	4	applied	\N	\N	\N	\N	197523	197523	364688
26311	41788	5	applied	\N	\N	\N	\N	197524	197524	364689
26312	41782	0	applied	\N	\N	\N	\N	197525	197525	364690
26312	41785	1	applied	\N	\N	\N	\N	197526	197526	364691
26312	41786	2	applied	\N	\N	\N	\N	197527	197527	364692
26312	41784	3	applied	\N	\N	\N	\N	197528	197528	364693
26312	41787	4	applied	\N	\N	\N	\N	197529	197529	364694
26312	41788	5	applied	\N	\N	\N	\N	197530	197530	364695
26316	41791	1	applied	\N	\N	\N	\N	197544	197544	364709
26318	41792	0	applied	\N	\N	\N	\N	197550	197550	364715
26318	41793	1	applied	\N	\N	\N	\N	197551	197551	364716
26318	41790	2	applied	\N	\N	\N	\N	197552	197552	364717
26318	41794	3	applied	\N	\N	\N	\N	197553	197553	364718
26318	41795	4	applied	\N	\N	\N	\N	197554	197554	364719
26319	41792	0	applied	\N	\N	\N	\N	197555	197555	364720
26319	41793	1	applied	\N	\N	\N	\N	197556	197556	364721
26319	41790	2	applied	\N	\N	\N	\N	197557	197557	364722
26319	41794	3	applied	\N	\N	\N	\N	197558	197558	364723
26319	41795	4	applied	\N	\N	\N	\N	197559	197559	364724
26321	41792	0	applied	\N	\N	\N	\N	197565	197565	364730
26321	41793	1	applied	\N	\N	\N	\N	197566	197566	364731
26321	41790	2	applied	\N	\N	\N	\N	197567	197567	364732
26321	41794	3	applied	\N	\N	\N	\N	197568	197568	364733
26321	41795	4	applied	\N	\N	\N	\N	197569	197569	364734
26322	41797	1	applied	\N	\N	\N	\N	197571	197571	364736
26322	41798	2	applied	\N	\N	\N	\N	197572	197572	364737
26322	41799	3	applied	\N	\N	\N	\N	197573	197573	364738
26322	41800	4	applied	\N	\N	\N	\N	197574	197574	364739
26323	41796	0	applied	\N	\N	\N	\N	197575	197575	364740
26323	41797	1	applied	\N	\N	\N	\N	197576	197576	364741
26323	41798	2	applied	\N	\N	\N	\N	197577	197577	364742
26323	41799	3	applied	\N	\N	\N	\N	197578	197578	364743
26323	41800	4	applied	\N	\N	\N	\N	197579	197579	364744
26327	41803	0	applied	\N	\N	\N	\N	197589	197589	364754
26329	41805	0	applied	\N	\N	\N	\N	197592	197592	364757
26329	41806	1	applied	\N	\N	\N	\N	197593	197593	364758
26329	41807	2	applied	\N	\N	\N	\N	197594	197594	364759
26330	41805	0	applied	\N	\N	\N	\N	197595	197595	364760
26330	41806	1	applied	\N	\N	\N	\N	197596	197596	364761
26330	41807	2	applied	\N	\N	\N	\N	197597	197597	364762
26333	41806	1	applied	\N	\N	\N	\N	197609	197609	364774
26333	41807	2	applied	\N	\N	\N	\N	197610	197610	364775
26333	41808	3	applied	\N	\N	\N	\N	197611	197611	364776
26333	41809	4	applied	\N	\N	\N	\N	197612	197612	364777
26334	41810	0	applied	\N	\N	\N	\N	197613	197613	364778
26334	41808	1	applied	\N	\N	\N	\N	197614	197614	364779
26334	41809	2	applied	\N	\N	\N	\N	197615	197615	364780
26334	41811	3	applied	\N	\N	\N	\N	197616	197616	364781
26336	41815	0	applied	\N	\N	\N	\N	197620	197620	364785
26336	41816	1	applied	\N	\N	\N	\N	197621	197621	364786
26336	41817	2	applied	\N	\N	\N	\N	197622	197622	364787
26336	41818	3	applied	\N	\N	\N	\N	197623	197623	364788
26337	41819	0	applied	\N	\N	\N	\N	197624	197624	364789
26337	41820	1	applied	\N	\N	\N	\N	197625	197625	364790
26339	41821	0	applied	\N	\N	\N	\N	197627	197627	364792
26339	41822	1	applied	\N	\N	\N	\N	197628	197628	364793
26339	41824	3	applied	\N	\N	\N	\N	197630	197630	364795
26339	41825	4	applied	\N	\N	\N	\N	197631	197631	364796
26340	41821	0	applied	\N	\N	\N	\N	197632	197632	364797
26340	41822	1	applied	\N	\N	\N	\N	197633	197633	364798
26340	41823	2	applied	\N	\N	\N	\N	197634	197634	364799
26340	41824	3	applied	\N	\N	\N	\N	197635	197635	364800
26340	41825	4	applied	\N	\N	\N	\N	197636	197636	364801
26341	41821	0	applied	\N	\N	\N	\N	197637	197637	364802
26341	41822	1	applied	\N	\N	\N	\N	197638	197638	364803
26341	41823	2	applied	\N	\N	\N	\N	197639	197639	364804
26341	41824	3	applied	\N	\N	\N	\N	197640	197640	364805
26341	41825	4	applied	\N	\N	\N	\N	197641	197641	364806
26355	41841	0	applied	\N	\N	\N	\N	197679	197679	364844
26355	41842	1	applied	\N	\N	\N	\N	197680	197680	364845
26358	41540	47	applied	\N	\N	\N	\N	197742	197742	364907
26360	41853	0	applied	\N	\N	\N	\N	197823	197823	364988
26363	41857	0	applied	\N	\N	\N	\N	197830	197830	364995
26363	41858	1	applied	\N	\N	\N	\N	197831	197831	364996
26363	41859	2	applied	\N	\N	\N	\N	197832	197832	364997
26369	41873	0	applied	\N	\N	\N	\N	197849	197849	365014
26369	41874	1	applied	\N	\N	\N	\N	197850	197850	365015
26369	41875	2	applied	\N	\N	\N	\N	197851	197851	365016
26369	41876	3	applied	\N	\N	\N	\N	197852	197852	365017
26369	41877	4	applied	\N	\N	\N	\N	197853	197853	365018
26371	41882	0	applied	\N	\N	\N	\N	197860	197860	365025
26371	41883	1	applied	\N	\N	\N	\N	197861	197861	365026
26371	41884	2	applied	\N	\N	1000000000	\N	197862	197862	365027
26371	41885	3	applied	\N	\N	\N	\N	197863	197863	365028
26371	41886	4	applied	\N	\N	\N	\N	197864	197864	365029
26371	41887	5	applied	\N	\N	\N	\N	197865	197865	365030
26373	41882	0	applied	\N	\N	\N	\N	197872	197872	365037
26373	41883	1	applied	\N	\N	\N	\N	197873	197873	365038
26302	41771	2	applied	\N	\N	\N	\N	197465	197465	364630
26351	41832	0	applied	\N	\N	\N	\N	197661	197661	364826
26351	41833	1	applied	\N	\N	\N	\N	197662	197662	364827
26351	41834	2	applied	\N	\N	\N	\N	197663	197663	364828
26351	41835	3	applied	\N	\N	\N	\N	197664	197664	364829
26351	41836	4	applied	\N	\N	\N	\N	197665	197665	364830
26351	41837	5	applied	\N	\N	\N	\N	197666	197666	364831
26351	41838	6	applied	\N	\N	\N	\N	197667	197667	364832
26353	41839	0	applied	\N	\N	\N	\N	197675	197675	364840
26353	41840	1	applied	\N	\N	\N	\N	197676	197676	364841
26356	41843	0	applied	\N	\N	\N	\N	197681	197681	364846
26356	41844	1	applied	\N	\N	\N	\N	197682	197682	364847
26356	41845	2	applied	\N	\N	\N	\N	197683	197683	364848
26356	41846	3	applied	\N	\N	\N	\N	197684	197684	364849
26356	41847	4	applied	\N	\N	\N	\N	197685	197685	364850
26356	41849	6	applied	\N	\N	\N	\N	197687	197687	364852
26358	41369	0	applied	\N	\N	\N	\N	197695	197695	364860
26358	41372	1	applied	\N	\N	\N	\N	197696	197696	364861
26358	41373	2	applied	\N	\N	\N	\N	197697	197697	364862
26358	41378	3	applied	\N	\N	\N	\N	197698	197698	364863
26358	41383	4	applied	\N	\N	\N	\N	197699	197699	364864
26358	41384	5	applied	\N	\N	\N	\N	197700	197700	364865
26358	41391	6	applied	\N	\N	\N	\N	197701	197701	364866
26358	41397	7	applied	\N	\N	\N	\N	197702	197702	364867
26358	41400	8	applied	\N	\N	\N	\N	197703	197703	364868
26358	41401	9	applied	\N	\N	\N	\N	197704	197704	364869
26358	41406	10	applied	\N	\N	\N	\N	197705	197705	364870
26358	41409	11	applied	\N	\N	\N	\N	197706	197706	364871
26358	41410	12	applied	\N	\N	\N	\N	197707	197707	364872
26358	41417	13	applied	\N	\N	\N	\N	197708	197708	364873
26358	41423	14	applied	\N	\N	\N	\N	197709	197709	364874
26358	41425	16	applied	\N	\N	\N	\N	197711	197711	364876
26358	41426	17	applied	\N	\N	\N	\N	197712	197712	364877
26358	41437	18	applied	\N	\N	\N	\N	197713	197713	364878
26358	41438	19	applied	\N	\N	\N	\N	197714	197714	364879
26358	41444	20	applied	\N	\N	\N	\N	197715	197715	364880
26358	41446	21	applied	\N	\N	\N	\N	197716	197716	364881
26358	41451	22	applied	\N	\N	\N	\N	197717	197717	364882
26358	41454	23	applied	\N	\N	\N	\N	197718	197718	364883
26358	41458	24	applied	\N	\N	\N	\N	197719	197719	364884
26358	41462	25	applied	\N	\N	\N	\N	197720	197720	364885
26358	41463	26	applied	\N	\N	\N	\N	197721	197721	364886
26358	41464	27	applied	\N	\N	\N	\N	197722	197722	364887
26358	41473	28	applied	\N	\N	\N	\N	197723	197723	364888
26358	41478	29	applied	\N	\N	\N	\N	197724	197724	364889
26358	41479	30	applied	\N	\N	\N	\N	197725	197725	364890
26358	41484	31	applied	\N	\N	\N	\N	197726	197726	364891
26358	41492	33	applied	\N	\N	\N	\N	197728	197728	364893
26358	41497	34	applied	\N	\N	\N	\N	197729	197729	364894
26358	41501	35	applied	\N	\N	\N	\N	197730	197730	364895
26358	41502	36	applied	\N	\N	\N	\N	197731	197731	364896
26358	41503	37	applied	\N	\N	\N	\N	197732	197732	364897
26358	41504	38	applied	\N	\N	\N	\N	197733	197733	364898
26358	41514	39	applied	\N	\N	\N	\N	197734	197734	364899
26358	41517	40	applied	\N	\N	\N	\N	197735	197735	364900
26358	41521	41	applied	\N	\N	\N	\N	197736	197736	364901
26358	41524	42	applied	\N	\N	\N	\N	197737	197737	364902
26358	41527	43	applied	\N	\N	\N	\N	197738	197738	364903
26358	41530	44	applied	\N	\N	\N	\N	197739	197739	364904
26358	41534	45	applied	\N	\N	\N	\N	197740	197740	364905
26358	41535	46	applied	\N	\N	\N	\N	197741	197741	364906
26373	41885	3	applied	\N	\N	\N	\N	197875	197875	365040
26373	41886	4	applied	\N	\N	\N	\N	197876	197876	365041
26373	41887	5	applied	\N	\N	\N	\N	197877	197877	365042
26381	41908	0	applied	\N	\N	\N	\N	197912	197912	365077
26381	41909	1	applied	\N	\N	\N	\N	197913	197913	365078
26381	41910	2	applied	\N	\N	\N	\N	197914	197914	365079
26381	41911	3	applied	\N	\N	\N	\N	197915	197915	365080
26385	41908	0	applied	\N	\N	\N	\N	197928	197928	365093
26385	41909	1	applied	\N	\N	\N	\N	197929	197929	365094
26385	41910	2	applied	\N	\N	\N	\N	197930	197930	365095
26385	41911	3	applied	\N	\N	\N	\N	197931	197931	365096
26388	41918	0	applied	\N	\N	\N	\N	197938	197938	365103
26388	41919	1	applied	\N	\N	\N	\N	197939	197939	365104
26388	41920	2	applied	\N	\N	\N	\N	197940	197940	365105
26388	41921	3	applied	\N	\N	\N	\N	197941	197941	365106
26388	41922	4	applied	\N	\N	\N	\N	197942	197942	365107
26388	41923	5	applied	\N	\N	\N	\N	197943	197943	365108
26388	41924	6	applied	\N	\N	\N	\N	197944	197944	365109
26394	41945	0	applied	\N	\N	\N	\N	198087	198087	365252
26394	41946	1	applied	\N	\N	\N	\N	198088	198088	365253
26397	41952	0	applied	\N	\N	\N	\N	198101	198101	365266
26397	41953	2	applied	\N	\N	\N	\N	198102	198102	365267
26397	41954	3	applied	\N	\N	\N	\N	198103	198103	365268
26397	41955	4	applied	\N	\N	\N	\N	198104	198104	365269
26397	41956	5	applied	\N	\N	\N	\N	198105	198105	365270
26397	41957	6	applied	\N	\N	\N	\N	198106	198106	365271
26397	41958	7	applied	\N	\N	\N	\N	198107	198107	365272
26402	41972	0	applied	\N	\N	\N	\N	198121	198121	365286
26402	41973	1	applied	\N	\N	\N	\N	198122	198122	365287
26402	41974	2	applied	\N	\N	\N	\N	198123	198123	365288
26405	41975	0	applied	\N	\N	\N	\N	198131	198131	365296
26405	41976	1	applied	\N	\N	\N	\N	198132	198132	365297
26405	41977	2	applied	\N	\N	\N	\N	198133	198133	365298
26405	41978	3	applied	\N	\N	\N	\N	198134	198134	365299
26407	41979	0	applied	\N	\N	\N	\N	198156	198156	365321
26407	41980	1	applied	\N	\N	\N	\N	198157	198157	365322
26407	41982	3	applied	\N	\N	\N	\N	198159	198159	365324
26407	41983	4	applied	\N	\N	\N	\N	198160	198160	365325
26407	41984	5	applied	\N	\N	\N	\N	198161	198161	365326
26409	41557	0	applied	\N	\N	\N	\N	198168	198168	365333
26409	41558	1	applied	\N	\N	\N	\N	198169	198169	365334
26409	41559	2	applied	\N	\N	\N	\N	198170	198170	365335
26409	41560	3	applied	\N	\N	\N	\N	198171	198171	365336
26409	41578	4	applied	\N	\N	\N	\N	198172	198172	365337
26409	41581	5	applied	\N	\N	\N	\N	198173	198173	365338
26409	41584	6	applied	\N	\N	\N	\N	198174	198174	365339
26409	41585	7	applied	\N	\N	\N	\N	198175	198175	365340
26409	41591	8	applied	\N	\N	\N	\N	198176	198176	365341
26409	41594	9	applied	\N	\N	\N	\N	198177	198177	365342
26409	41595	10	applied	\N	\N	\N	\N	198178	198178	365343
26344	41830	2	applied	\N	\N	\N	\N	197648	197648	364813
26350	41831	0	applied	\N	\N	\N	\N	197660	197660	364825
26358	41554	51	applied	\N	\N	\N	\N	197746	197746	364911
26358	41555	52	applied	\N	\N	\N	\N	197747	197747	364912
26358	41556	53	applied	\N	\N	\N	\N	197748	197748	364913
26358	41557	54	applied	\N	\N	\N	\N	197749	197749	364914
26358	41558	55	applied	\N	\N	\N	\N	197750	197750	364915
26358	41559	56	applied	\N	\N	\N	\N	197751	197751	364916
26358	41560	57	applied	\N	\N	\N	\N	197752	197752	364917
26358	41578	58	applied	\N	\N	\N	\N	197753	197753	364918
26358	41581	59	applied	\N	\N	\N	\N	197754	197754	364919
26358	41584	60	applied	\N	\N	\N	\N	197755	197755	364920
26358	41585	61	applied	\N	\N	\N	\N	197756	197756	364921
26358	41591	62	applied	\N	\N	\N	\N	197757	197757	364922
26358	41594	63	applied	\N	\N	\N	\N	197758	197758	364923
26358	41601	65	applied	\N	\N	\N	\N	197760	197760	364925
26358	41604	66	applied	\N	\N	\N	\N	197761	197761	364926
26358	41607	67	applied	\N	\N	\N	\N	197762	197762	364927
26358	41608	68	applied	\N	\N	\N	\N	197763	197763	364928
26358	41609	69	applied	\N	\N	\N	\N	197764	197764	364929
26358	41610	70	applied	\N	\N	\N	\N	197765	197765	364930
26358	41624	71	applied	\N	\N	\N	\N	197766	197766	364931
26358	41627	72	applied	\N	\N	\N	\N	197767	197767	364932
26358	41630	73	applied	\N	\N	\N	\N	197768	197768	364933
26358	41633	74	applied	\N	\N	\N	\N	197769	197769	364934
26358	41637	75	applied	\N	\N	\N	\N	197770	197770	364935
26358	41638	76	applied	\N	\N	\N	\N	197771	197771	364936
26358	41639	78	applied	\N	\N	\N	\N	197772	197772	364937
26358	41640	79	applied	\N	\N	\N	\N	197773	197773	364938
26358	41650	80	applied	\N	\N	\N	\N	197774	197774	364939
26358	41653	81	applied	\N	\N	\N	\N	197775	197775	364940
26358	41660	83	applied	\N	\N	\N	\N	197777	197777	364942
26358	41663	84	applied	\N	\N	\N	\N	197778	197778	364943
26358	41666	85	applied	\N	\N	\N	\N	197779	197779	364944
26358	41672	86	applied	\N	\N	\N	\N	197780	197780	364945
26358	41673	87	applied	\N	\N	\N	\N	197781	197781	364946
26358	41679	88	applied	\N	\N	\N	\N	197782	197782	364947
26358	41682	89	applied	\N	\N	\N	\N	197783	197783	364948
26358	41683	90	applied	\N	\N	\N	\N	197784	197784	364949
26358	41689	91	applied	\N	\N	\N	\N	197785	197785	364950
26358	41692	92	applied	\N	\N	\N	\N	197786	197786	364951
26358	41695	93	applied	\N	\N	\N	\N	197787	197787	364952
26358	41698	94	applied	\N	\N	\N	\N	197788	197788	364953
26358	41702	95	applied	\N	\N	\N	\N	197789	197789	364954
26358	41704	96	applied	\N	\N	\N	\N	197790	197790	364955
26358	41707	97	applied	\N	\N	\N	\N	197791	197791	364956
26358	41711	98	applied	\N	\N	\N	\N	197792	197792	364957
26358	41717	100	applied	\N	\N	\N	\N	197794	197794	364959
26358	41721	101	applied	\N	\N	\N	\N	197795	197795	364960
26358	41724	102	applied	\N	\N	\N	\N	197796	197796	364961
26358	41725	103	applied	\N	\N	\N	\N	197797	197797	364962
26358	41726	104	applied	\N	\N	\N	\N	197798	197798	364963
26358	41731	105	applied	\N	\N	\N	\N	197799	197799	364964
26358	41733	106	applied	\N	\N	\N	\N	197800	197800	364965
26358	41735	107	applied	\N	\N	\N	\N	197801	197801	364966
26358	41736	108	applied	\N	\N	\N	\N	197802	197802	364967
26358	41737	109	applied	\N	\N	\N	\N	197803	197803	364968
26358	41742	110	applied	\N	\N	\N	\N	197804	197804	364969
26358	41745	111	applied	\N	\N	\N	\N	197805	197805	364970
26358	41747	112	applied	\N	\N	\N	\N	197806	197806	364971
26358	41749	113	applied	\N	\N	\N	\N	197807	197807	364972
26358	41751	114	applied	\N	\N	\N	\N	197808	197808	364973
26358	41752	115	applied	\N	\N	\N	\N	197809	197809	364974
26358	41754	117	applied	\N	\N	\N	\N	197811	197811	364976
26358	41762	118	applied	\N	\N	\N	\N	197812	197812	364977
26358	41764	119	applied	\N	\N	\N	\N	197813	197813	364978
26358	41765	120	applied	\N	\N	\N	\N	197814	197814	364979
26358	41769	121	applied	\N	\N	\N	\N	197815	197815	364980
26358	41770	122	applied	\N	\N	\N	\N	197816	197816	364981
26358	41771	123	applied	\N	\N	\N	\N	197817	197817	364982
26358	41775	124	applied	\N	\N	\N	\N	197818	197818	364983
26358	41776	125	applied	\N	\N	\N	\N	197819	197819	364984
26361	41855	0	applied	\N	\N	\N	\N	197825	197825	364990
26361	41856	1	applied	\N	\N	\N	\N	197826	197826	364991
26366	41862	0	applied	\N	\N	\N	\N	197835	197835	365000
26366	41863	1	applied	\N	\N	\N	\N	197836	197836	365001
26366	41864	2	applied	\N	\N	\N	\N	197837	197837	365002
26366	41865	3	applied	\N	\N	\N	\N	197838	197838	365003
26366	41866	4	applied	\N	\N	\N	\N	197839	197839	365004
26366	41868	6	applied	\N	\N	\N	\N	197841	197841	365006
26372	41882	0	applied	\N	\N	\N	\N	197866	197866	365031
26372	41883	1	applied	\N	\N	\N	\N	197867	197867	365032
26372	41884	2	applied	\N	\N	1000000000	\N	197868	197868	365033
26372	41885	3	applied	\N	\N	\N	\N	197869	197869	365034
26372	41886	4	applied	\N	\N	\N	\N	197870	197870	365035
26372	41887	5	applied	\N	\N	\N	\N	197871	197871	365036
26374	41888	0	applied	\N	\N	\N	\N	197878	197878	365043
26374	41889	1	applied	\N	\N	\N	\N	197879	197879	365044
26374	41890	2	applied	\N	\N	\N	\N	197880	197880	365045
26374	41891	3	applied	\N	\N	\N	\N	197881	197881	365046
26374	41892	4	applied	\N	\N	\N	\N	197882	197882	365047
26374	41893	5	applied	\N	\N	\N	\N	197883	197883	365048
26377	41902	0	applied	\N	\N	\N	\N	197900	197900	365065
26377	41903	1	applied	\N	\N	\N	\N	197901	197901	365066
26377	41904	2	applied	\N	\N	\N	\N	197902	197902	365067
26379	41906	1	applied	\N	\N	\N	\N	197907	197907	365072
26379	41907	2	applied	\N	\N	\N	\N	197908	197908	365073
26382	41908	0	applied	\N	\N	\N	\N	197916	197916	365081
26382	41909	1	applied	\N	\N	\N	\N	197917	197917	365082
26382	41910	2	applied	\N	\N	\N	\N	197918	197918	365083
26382	41911	3	applied	\N	\N	\N	\N	197919	197919	365084
26389	41925	0	applied	\N	\N	\N	\N	197945	197945	365110
26389	41926	1	applied	\N	\N	\N	\N	197946	197946	365111
26389	41927	2	applied	\N	\N	\N	\N	197947	197947	365112
26389	41928	3	applied	\N	\N	\N	\N	197948	197948	365113
26389	41929	4	applied	\N	\N	\N	\N	197949	197949	365114
26389	41930	5	applied	\N	\N	\N	\N	197950	197950	365115
26392	41361	0	applied	\N	\N	\N	\N	197965	197965	365130
26392	41459	1	applied	\N	\N	\N	\N	197966	197966	365131
26392	41365	2	applied	\N	\N	\N	\N	197967	197967	365132
26392	41471	4	applied	\N	\N	\N	\N	197969	197969	365134
26358	41547	49	applied	\N	\N	\N	\N	197744	197744	364909
26358	41548	50	applied	\N	\N	\N	\N	197745	197745	364910
26375	41896	2	applied	\N	\N	1000000000	\N	197886	197886	365051
26375	41897	3	applied	\N	\N	\N	\N	197887	197887	365052
26375	41898	4	applied	\N	\N	\N	\N	197888	197888	365053
26375	41900	6	applied	\N	\N	\N	\N	197890	197890	365055
26375	41901	7	applied	\N	\N	\N	\N	197891	197891	365056
26380	41905	0	applied	\N	\N	\N	\N	197909	197909	365074
26380	41906	1	applied	\N	\N	\N	\N	197910	197910	365075
26380	41907	2	applied	\N	\N	\N	\N	197911	197911	365076
26383	41908	0	applied	\N	\N	\N	\N	197920	197920	365085
26383	41909	1	applied	\N	\N	\N	\N	197921	197921	365086
26383	41910	2	applied	\N	\N	\N	\N	197922	197922	365087
26383	41911	3	applied	\N	\N	\N	\N	197923	197923	365088
26386	41912	0	applied	\N	\N	\N	\N	197932	197932	365097
26386	41913	1	applied	\N	\N	\N	\N	197933	197933	365098
26386	41914	2	applied	\N	\N	\N	\N	197934	197934	365099
26390	41931	0	applied	\N	\N	\N	\N	197951	197951	365116
26390	41932	1	applied	\N	\N	\N	\N	197952	197952	365117
26390	41933	2	applied	\N	\N	\N	\N	197953	197953	365118
26390	41934	3	applied	\N	\N	\N	\N	197954	197954	365119
26390	41936	5	applied	\N	\N	\N	\N	197956	197956	365121
26390	41937	6	applied	\N	\N	\N	\N	197957	197957	365122
26392	41429	5	applied	\N	\N	\N	\N	197970	197970	365135
26392	41430	6	applied	\N	\N	\N	\N	197971	197971	365136
26392	41439	7	applied	\N	\N	\N	\N	197972	197972	365137
26392	41450	8	applied	\N	\N	\N	\N	197973	197973	365138
26392	41382	9	applied	\N	\N	1000000000	\N	197974	197974	365139
26392	41387	10	applied	\N	\N	1000000000	\N	197975	197975	365140
26392	41388	11	applied	\N	\N	1000000000	\N	197976	197976	365141
26392	41393	12	applied	\N	\N	1000000000	\N	197977	197977	365142
26392	41394	13	applied	\N	\N	1000000000	\N	197978	197978	365143
26392	41395	14	applied	\N	\N	1000000000	\N	197979	197979	365144
26392	41366	15	applied	\N	\N	\N	\N	197980	197980	365145
26392	41370	16	applied	\N	\N	\N	\N	197981	197981	365146
26392	41376	17	applied	\N	\N	\N	\N	197982	197982	365147
26392	41377	18	applied	\N	\N	\N	\N	197983	197983	365148
26392	41385	20	applied	\N	\N	\N	\N	197985	197985	365150
26392	41389	21	applied	\N	\N	\N	\N	197986	197986	365151
26392	41392	22	applied	\N	\N	\N	\N	197987	197987	365152
26392	41398	23	applied	\N	\N	\N	\N	197988	197988	365153
26392	41404	24	applied	\N	\N	\N	\N	197989	197989	365154
26392	41405	25	applied	\N	\N	\N	\N	197990	197990	365155
26392	41408	26	applied	\N	\N	\N	\N	197991	197991	365156
26392	41411	27	applied	\N	\N	\N	\N	197992	197992	365157
26392	41412	28	applied	\N	\N	\N	\N	197993	197993	365158
26392	41419	29	applied	\N	\N	\N	\N	197994	197994	365159
26392	41421	30	applied	\N	\N	\N	\N	197995	197995	365160
26392	41428	31	applied	\N	\N	\N	\N	197996	197996	365161
26392	41431	32	applied	\N	\N	\N	\N	197997	197997	365162
26392	41432	33	applied	\N	\N	\N	\N	197998	197998	365163
26392	41433	34	applied	\N	\N	\N	\N	197999	197999	365164
26392	41440	35	applied	\N	\N	\N	\N	198000	198000	365165
26392	41445	37	applied	\N	\N	\N	\N	198002	198002	365167
26392	41447	38	applied	\N	\N	\N	\N	198003	198003	365168
26392	41453	39	applied	\N	\N	\N	\N	198004	198004	365169
26392	41455	40	applied	\N	\N	\N	\N	198005	198005	365170
26392	41460	41	applied	\N	\N	\N	\N	198006	198006	365171
26392	41467	42	applied	\N	\N	\N	\N	198007	198007	365172
26392	41468	43	applied	\N	\N	\N	\N	198008	198008	365173
26392	41469	44	applied	\N	\N	\N	\N	198009	198009	365174
26392	41476	45	applied	\N	\N	\N	\N	198010	198010	365175
26392	41482	46	applied	\N	\N	\N	\N	198011	198011	365176
26392	41483	47	applied	\N	\N	\N	\N	198012	198012	365177
26392	41488	48	applied	\N	\N	\N	\N	198013	198013	365178
26392	41491	49	applied	\N	\N	\N	\N	198014	198014	365179
26392	41494	50	applied	\N	\N	\N	\N	198015	198015	365180
26392	41496	51	applied	\N	\N	\N	\N	198016	198016	365181
26392	41500	52	applied	\N	\N	\N	\N	198017	198017	365182
26392	41511	54	applied	\N	\N	\N	\N	198019	198019	365184
26392	41512	55	applied	\N	\N	\N	\N	198020	198020	365185
26392	41513	56	applied	\N	\N	\N	\N	198021	198021	365186
26393	41938	0	applied	\N	\N	\N	\N	198080	198080	365245
26393	41939	1	applied	\N	\N	\N	\N	198081	198081	365246
26393	41940	2	applied	\N	\N	\N	\N	198082	198082	365247
26393	41941	3	applied	\N	\N	\N	\N	198083	198083	365248
26393	41942	4	applied	\N	\N	\N	\N	198084	198084	365249
26393	41943	5	applied	\N	\N	\N	\N	198085	198085	365250
26393	41944	6	applied	\N	\N	\N	\N	198086	198086	365251
26396	41952	0	applied	\N	\N	\N	\N	198094	198094	365259
26396	41953	2	applied	\N	\N	\N	\N	198095	198095	365260
26396	41954	3	applied	\N	\N	\N	\N	198096	198096	365261
26396	41955	4	applied	\N	\N	\N	\N	198097	198097	365262
26396	41956	5	applied	\N	\N	\N	\N	198098	198098	365263
26396	41957	6	applied	\N	\N	\N	\N	198099	198099	365264
26398	41959	0	applied	\N	\N	\N	\N	198108	198108	365273
26398	41960	1	applied	\N	\N	\N	\N	198109	198109	365274
26401	41969	0	applied	\N	\N	\N	\N	198118	198118	365283
26401	41970	1	applied	\N	\N	\N	\N	198119	198119	365284
26401	41971	2	applied	\N	\N	\N	\N	198120	198120	365285
26408	41979	0	applied	\N	\N	\N	\N	198162	198162	365327
26408	41980	1	applied	\N	\N	\N	\N	198163	198163	365328
26408	41981	2	applied	\N	\N	\N	\N	198164	198164	365329
26408	41982	3	applied	\N	\N	\N	\N	198165	198165	365330
26408	41983	4	applied	\N	\N	\N	\N	198166	198166	365331
26408	41984	5	applied	\N	\N	\N	\N	198167	198167	365332
26410	41985	0	applied	\N	\N	\N	\N	198285	198285	365450
26410	41986	1	applied	\N	\N	\N	\N	198286	198286	365451
26410	41987	2	applied	\N	\N	\N	\N	198287	198287	365452
26410	41988	3	applied	\N	\N	\N	\N	198288	198288	365453
26416	42010	0	applied	\N	\N	\N	\N	198335	198335	365500
26416	42012	2	applied	\N	\N	\N	\N	198337	198337	365502
26416	42013	3	applied	\N	\N	\N	\N	198338	198338	365503
26418	42014	0	applied	\N	\N	\N	\N	198343	198343	365508
26418	42015	1	applied	\N	\N	\N	\N	198344	198344	365509
26418	42016	2	applied	\N	\N	\N	\N	198345	198345	365510
26422	42024	0	applied	\N	\N	\N	\N	198359	198359	365524
26422	42025	1	applied	\N	\N	\N	\N	198360	198360	365525
26422	42026	2	applied	\N	\N	\N	\N	198361	198361	365526
26425	42027	0	applied	\N	\N	\N	\N	198453	198453	365618
26425	42028	1	applied	\N	\N	\N	\N	198454	198454	365619
26375	41894	0	applied	\N	\N	\N	\N	197884	197884	365049
26375	41895	1	applied	\N	\N	\N	\N	197885	197885	365050
26376	41897	3	applied	\N	\N	\N	\N	197895	197895	365060
26376	41898	4	applied	\N	\N	\N	\N	197896	197896	365061
26376	41899	5	applied	\N	\N	\N	\N	197897	197897	365062
26376	41900	6	applied	\N	\N	\N	\N	197898	197898	365063
26376	41901	7	applied	\N	\N	\N	\N	197899	197899	365064
26378	41902	0	applied	\N	\N	\N	\N	197903	197903	365068
26378	41903	1	applied	\N	\N	\N	\N	197904	197904	365069
26378	41904	2	applied	\N	\N	\N	\N	197905	197905	365070
26384	41908	0	applied	\N	\N	\N	\N	197924	197924	365089
26384	41909	1	applied	\N	\N	\N	\N	197925	197925	365090
26384	41910	2	applied	\N	\N	\N	\N	197926	197926	365091
26387	41915	0	applied	\N	\N	\N	\N	197935	197935	365100
26387	41916	1	applied	\N	\N	\N	\N	197936	197936	365101
26387	41917	2	applied	\N	\N	\N	\N	197937	197937	365102
26391	41931	0	applied	\N	\N	\N	\N	197958	197958	365123
26391	41932	1	applied	\N	\N	\N	\N	197959	197959	365124
26391	41933	2	applied	\N	\N	\N	\N	197960	197960	365125
26391	41934	3	applied	\N	\N	\N	\N	197961	197961	365126
26391	41935	4	applied	\N	\N	\N	\N	197962	197962	365127
26391	41936	5	applied	\N	\N	\N	\N	197963	197963	365128
26391	41937	6	applied	\N	\N	\N	\N	197964	197964	365129
26399	41961	0	applied	\N	\N	\N	\N	198110	198110	365275
26399	41962	1	applied	\N	\N	\N	\N	198111	198111	365276
26399	41963	2	applied	\N	\N	\N	\N	198112	198112	365277
26399	41964	3	applied	\N	\N	\N	\N	198113	198113	365278
26404	41975	0	applied	\N	\N	\N	\N	198127	198127	365292
26404	41976	1	applied	\N	\N	\N	\N	198128	198128	365293
26404	41978	3	applied	\N	\N	\N	\N	198130	198130	365295
26406	41959	0	applied	\N	\N	\N	\N	198135	198135	365300
26406	41961	1	applied	\N	\N	\N	\N	198136	198136	365301
26406	41965	2	applied	\N	\N	\N	\N	198137	198137	365302
26406	41969	3	applied	\N	\N	\N	\N	198138	198138	365303
26406	41972	4	applied	\N	\N	\N	\N	198139	198139	365304
26406	41975	5	applied	\N	\N	\N	\N	198140	198140	365305
26406	41979	6	applied	\N	\N	\N	\N	198141	198141	365306
26406	41960	7	applied	\N	\N	\N	\N	198142	198142	365307
26406	41962	8	applied	\N	\N	\N	\N	198143	198143	365308
26406	41963	9	applied	\N	\N	\N	\N	198144	198144	365309
26406	41967	10	applied	\N	\N	\N	\N	198145	198145	365310
26406	41970	11	applied	\N	\N	\N	\N	198146	198146	365311
26406	41974	12	applied	\N	\N	\N	\N	198147	198147	365312
26406	41976	13	applied	\N	\N	\N	\N	198148	198148	365313
26406	41968	14	applied	\N	\N	\N	\N	198149	198149	365314
26406	41964	16	applied	\N	\N	\N	\N	198151	198151	365316
26406	41966	17	applied	\N	\N	\N	\N	198152	198152	365317
26406	41971	18	applied	\N	\N	\N	\N	198153	198153	365318
26406	41973	19	applied	\N	\N	\N	\N	198154	198154	365319
26406	41978	20	applied	\N	\N	\N	\N	198155	198155	365320
26413	41989	0	applied	\N	\N	\N	\N	198296	198296	365461
26413	41990	1	applied	\N	\N	\N	\N	198297	198297	365462
26413	41991	2	applied	\N	\N	\N	\N	198298	198298	365463
26414	41992	0	applied	\N	\N	\N	\N	198299	198299	365464
26414	41993	1	applied	\N	\N	\N	\N	198300	198300	365465
26414	41994	2	applied	\N	\N	\N	\N	198301	198301	365466
26414	41995	3	applied	\N	\N	\N	\N	198302	198302	365467
26414	41996	4	applied	\N	\N	\N	\N	198303	198303	365468
26414	41997	5	applied	\N	\N	\N	\N	198304	198304	365469
26414	41998	6	applied	\N	\N	\N	\N	198305	198305	365470
26414	42000	8	applied	\N	\N	1000000000	\N	198307	198307	365472
26414	42001	9	applied	\N	\N	\N	\N	198308	198308	365473
26425	42029	2	applied	\N	\N	\N	\N	198455	198455	365620
26430	42033	0	applied	\N	\N	\N	\N	198469	198469	365634
26430	42034	1	applied	\N	\N	\N	\N	198470	198470	365635
26430	42035	2	applied	\N	\N	\N	\N	198471	198471	365636
26430	42036	3	applied	\N	\N	\N	\N	198472	198472	365637
26439	42053	0	applied	\N	\N	\N	\N	198520	198520	365685
26439	42054	1	applied	\N	\N	\N	\N	198521	198521	365686
26439	42055	2	applied	\N	\N	\N	\N	198522	198522	365687
26439	42056	3	applied	\N	\N	\N	\N	198523	198523	365688
26442	42060	0	applied	\N	\N	\N	\N	198530	198530	365695
26442	42061	1	applied	\N	\N	\N	\N	198531	198531	365696
26442	42062	2	applied	\N	\N	\N	\N	198532	198532	365697
26442	42063	3	applied	\N	\N	\N	\N	198533	198533	365698
26442	42064	4	applied	\N	\N	\N	\N	198534	198534	365699
26442	42065	5	applied	\N	\N	\N	\N	198535	198535	365700
26446	42066	0	applied	\N	\N	\N	\N	198548	198548	365713
26446	42067	1	applied	\N	\N	\N	\N	198549	198549	365714
26446	42069	3	applied	\N	\N	\N	\N	198551	198551	365716
26457	42079	0	applied	\N	\N	\N	\N	198668	198668	365833
26457	42080	1	applied	\N	\N	\N	\N	198669	198669	365834
26457	42081	2	applied	\N	\N	\N	\N	198670	198670	365835
26460	42089	0	applied	\N	\N	\N	\N	198795	198795	365960
26460	42090	1	applied	\N	\N	\N	\N	198796	198796	365961
26460	42091	2	applied	\N	\N	\N	\N	198797	198797	365962
26463	42092	0	applied	\N	\N	\N	\N	198804	198804	365969
26463	42093	1	applied	\N	\N	\N	\N	198805	198805	365970
26463	42094	2	applied	\N	\N	\N	\N	198806	198806	365971
26463	42095	3	applied	\N	\N	\N	\N	198807	198807	365972
26463	42096	4	applied	\N	\N	\N	\N	198808	198808	365973
26463	42097	5	applied	\N	\N	\N	\N	198809	198809	365974
26465	42101	0	applied	\N	\N	\N	\N	198813	198813	365978
26465	42102	1	applied	\N	\N	\N	\N	198814	198814	365979
26465	42103	2	applied	\N	\N	\N	\N	198815	198815	365980
26467	41989	1	applied	\N	\N	\N	\N	198820	198820	365985
26467	41992	2	applied	\N	\N	\N	\N	198821	198821	365986
26467	41993	3	applied	\N	\N	\N	\N	198822	198822	365987
26467	41994	4	applied	\N	\N	\N	\N	198823	198823	365988
26467	41995	5	applied	\N	\N	\N	\N	198824	198824	365989
26467	41996	6	applied	\N	\N	\N	\N	198825	198825	365990
26467	42010	7	applied	\N	\N	\N	\N	198826	198826	365991
26467	42014	8	applied	\N	\N	\N	\N	198827	198827	365992
26467	42017	9	applied	\N	\N	\N	\N	198828	198828	365993
26467	42018	10	applied	\N	\N	\N	\N	198829	198829	365994
26467	42024	11	applied	\N	\N	\N	\N	198830	198830	365995
26467	42027	12	applied	\N	\N	\N	\N	198831	198831	365996
26467	42030	13	applied	\N	\N	\N	\N	198832	198832	365997
26467	42033	14	applied	\N	\N	\N	\N	198833	198833	365998
26467	42037	15	applied	\N	\N	\N	\N	198834	198834	365999
26467	42040	16	applied	\N	\N	\N	\N	198835	198835	366000
26376	41895	1	applied	\N	\N	\N	\N	197893	197893	365058
26376	41896	2	applied	\N	\N	1000000000	\N	197894	197894	365059
26392	41528	61	applied	\N	\N	\N	\N	198026	198026	365191
26392	41532	62	applied	\N	\N	\N	\N	198027	198027	365192
26392	41537	63	applied	\N	\N	\N	\N	198028	198028	365193
26392	41539	64	applied	\N	\N	\N	\N	198029	198029	365194
26392	41541	65	applied	\N	\N	\N	\N	198030	198030	365195
26392	41546	66	applied	\N	\N	\N	\N	198031	198031	365196
26392	41550	67	applied	\N	\N	\N	\N	198032	198032	365197
26392	41551	68	applied	\N	\N	\N	\N	198033	198033	365198
26392	41563	69	applied	\N	\N	\N	\N	198034	198034	365199
26392	41564	70	applied	\N	\N	\N	\N	198035	198035	365200
26392	41565	71	applied	\N	\N	\N	\N	198036	198036	365201
26392	41566	72	applied	\N	\N	\N	\N	198037	198037	365202
26392	41567	73	applied	\N	\N	\N	\N	198038	198038	365203
26392	41568	74	applied	\N	\N	\N	\N	198039	198039	365204
26392	41569	75	applied	\N	\N	\N	\N	198040	198040	365205
26392	41580	76	applied	\N	\N	\N	\N	198041	198041	365206
26392	41587	79	applied	\N	\N	\N	\N	198043	198043	365208
26392	41588	80	applied	\N	\N	\N	\N	198044	198044	365209
26392	41592	81	applied	\N	\N	\N	\N	198045	198045	365210
26392	41596	82	applied	\N	\N	\N	\N	198046	198046	365211
26392	41597	83	applied	\N	\N	\N	\N	198047	198047	365212
26392	41603	84	applied	\N	\N	\N	\N	198048	198048	365213
26392	41606	85	applied	\N	\N	\N	\N	198049	198049	365214
26392	41613	86	applied	\N	\N	\N	\N	198050	198050	365215
26392	41619	87	applied	\N	\N	\N	\N	198051	198051	365216
26392	41761	88	applied	\N	\N	\N	\N	198052	198052	365217
26392	41472	89	applied	\N	\N	\N	\N	198053	198053	365218
26392	41474	90	applied	\N	\N	\N	\N	198054	198054	365219
26392	41486	91	applied	\N	\N	\N	\N	198055	198055	365220
26392	41499	92	applied	\N	\N	\N	\N	198056	198056	365221
26392	41510	93	applied	\N	\N	\N	\N	198057	198057	365222
26392	41519	94	applied	\N	\N	\N	\N	198058	198058	365223
26392	41543	96	applied	\N	\N	\N	\N	198060	198060	365225
26392	41549	97	applied	\N	\N	\N	\N	198061	198061	365226
26392	41570	98	applied	\N	\N	\N	\N	198062	198062	365227
26392	41571	99	applied	\N	\N	\N	\N	198063	198063	365228
26392	41590	100	applied	\N	\N	\N	\N	198064	198064	365229
26392	41600	101	applied	\N	\N	\N	\N	198065	198065	365230
26392	41611	102	applied	\N	\N	\N	\N	198066	198066	365231
26392	41621	103	applied	\N	\N	\N	\N	198067	198067	365232
26392	41636	104	applied	\N	\N	\N	\N	198068	198068	365233
26392	41643	105	applied	\N	\N	\N	\N	198069	198069	365234
26392	41656	106	applied	\N	\N	\N	\N	198070	198070	365235
26392	41671	107	applied	\N	\N	\N	\N	198071	198071	365236
26392	41676	108	applied	\N	\N	\N	\N	198072	198072	365237
26392	41685	109	applied	\N	\N	\N	\N	198073	198073	365238
26392	41699	110	applied	\N	\N	\N	\N	198074	198074	365239
26392	41708	111	applied	\N	\N	\N	\N	198075	198075	365240
26392	41730	113	applied	\N	\N	\N	\N	198077	198077	365242
26392	41738	114	applied	\N	\N	\N	\N	198078	198078	365243
26392	41744	115	applied	\N	\N	\N	\N	198079	198079	365244
26395	41948	0	applied	\N	\N	\N	\N	198090	198090	365255
26395	41949	1	applied	\N	\N	\N	\N	198091	198091	365256
26395	41950	2	applied	\N	\N	\N	\N	198092	198092	365257
26395	41951	3	applied	\N	\N	\N	\N	198093	198093	365258
26400	41965	0	applied	\N	\N	\N	\N	198114	198114	365279
26400	41966	1	applied	\N	\N	\N	\N	198115	198115	365280
26400	41967	2	applied	\N	\N	\N	\N	198116	198116	365281
26400	41968	3	applied	\N	\N	\N	\N	198117	198117	365282
26403	41972	0	applied	\N	\N	\N	\N	198124	198124	365289
26403	41973	1	applied	\N	\N	\N	\N	198125	198125	365290
26414	42002	10	applied	\N	\N	\N	\N	198309	198309	365474
26414	42003	11	applied	\N	\N	\N	\N	198310	198310	365475
26414	42004	12	applied	\N	\N	\N	\N	198311	198311	365476
26414	42006	14	applied	\N	\N	\N	\N	198313	198313	365478
26414	42007	15	applied	\N	\N	\N	\N	198314	198314	365479
26414	42008	16	applied	\N	\N	\N	\N	198315	198315	365480
26414	42009	17	applied	\N	\N	\N	\N	198316	198316	365481
26417	42010	0	applied	\N	\N	\N	\N	198339	198339	365504
26417	42011	1	applied	\N	\N	\N	\N	198340	198340	365505
26417	42012	2	applied	\N	\N	\N	\N	198341	198341	365506
26417	42013	3	applied	\N	\N	\N	\N	198342	198342	365507
26419	42017	0	applied	\N	\N	\N	\N	198346	198346	365511
26419	42018	1	applied	\N	\N	\N	\N	198347	198347	365512
26419	42019	2	applied	\N	\N	\N	\N	198348	198348	365513
26419	42020	3	applied	\N	\N	\N	\N	198349	198349	365514
26419	42021	4	applied	\N	\N	\N	\N	198350	198350	365515
26419	42022	5	applied	\N	\N	\N	\N	198351	198351	365516
26419	42023	6	applied	\N	\N	\N	\N	198352	198352	365517
26423	42024	0	applied	\N	\N	\N	\N	198362	198362	365527
26423	42026	2	applied	\N	\N	\N	\N	198364	198364	365529
26426	42030	0	applied	\N	\N	\N	\N	198456	198456	365621
26426	42031	1	applied	\N	\N	\N	\N	198457	198457	365622
26426	42032	2	applied	\N	\N	\N	\N	198458	198458	365623
26428	42030	0	applied	\N	\N	\N	\N	198462	198462	365627
26428	42031	1	applied	\N	\N	\N	\N	198463	198463	365628
26428	42032	2	applied	\N	\N	\N	\N	198464	198464	365629
26433	42040	0	applied	\N	\N	\N	\N	198483	198483	365648
26433	42041	1	applied	\N	\N	\N	\N	198484	198484	365649
26433	42042	3	applied	\N	\N	\N	\N	198485	198485	365650
26433	42043	4	applied	\N	\N	\N	\N	198486	198486	365651
26433	42044	5	applied	\N	\N	\N	\N	198487	198487	365652
26433	42045	6	applied	\N	\N	\N	\N	198488	198488	365653
26433	42046	7	applied	\N	\N	\N	\N	198489	198489	365654
26435	42040	0	applied	\N	\N	\N	\N	198497	198497	365662
26435	42041	1	applied	\N	\N	\N	\N	198498	198498	365663
26435	42043	4	applied	\N	\N	\N	\N	198500	198500	365665
26435	42044	5	applied	\N	\N	\N	\N	198501	198501	365666
26435	42045	6	applied	\N	\N	\N	\N	198502	198502	365667
26435	42046	7	applied	\N	\N	\N	\N	198503	198503	365668
26440	42057	0	applied	\N	\N	\N	\N	198524	198524	365689
26440	42058	1	applied	\N	\N	\N	\N	198525	198525	365690
26440	42059	2	applied	\N	\N	\N	\N	198526	198526	365691
26443	42060	0	applied	\N	\N	\N	\N	198536	198536	365701
26443	42061	1	applied	\N	\N	\N	\N	198537	198537	365702
26443	42062	2	applied	\N	\N	\N	\N	198538	198538	365703
26443	42063	3	applied	\N	\N	\N	\N	198539	198539	365704
26443	42064	4	applied	\N	\N	\N	\N	198540	198540	365705
26443	42065	5	applied	\N	\N	\N	\N	198541	198541	365706
26447	42066	0	applied	\N	\N	\N	\N	198552	198552	365717
26392	41518	58	applied	\N	\N	\N	\N	198023	198023	365188
26392	41522	59	applied	\N	\N	\N	\N	198024	198024	365189
26409	41608	14	applied	\N	\N	\N	\N	198182	198182	365347
26409	41609	15	applied	\N	\N	\N	\N	198183	198183	365348
26409	41610	16	applied	\N	\N	\N	\N	198184	198184	365349
26409	41624	17	applied	\N	\N	\N	\N	198185	198185	365350
26409	41627	18	applied	\N	\N	\N	\N	198186	198186	365351
26409	41630	19	applied	\N	\N	\N	\N	198187	198187	365352
26409	41633	20	applied	\N	\N	\N	\N	198188	198188	365353
26409	41637	21	applied	\N	\N	\N	\N	198189	198189	365354
26409	41638	22	applied	\N	\N	\N	\N	198190	198190	365355
26409	41639	23	applied	\N	\N	\N	\N	198191	198191	365356
26409	41640	24	applied	\N	\N	\N	\N	198192	198192	365357
26409	41650	25	applied	\N	\N	\N	\N	198193	198193	365358
26409	41653	26	applied	\N	\N	\N	\N	198194	198194	365359
26409	41657	27	applied	\N	\N	\N	\N	198195	198195	365360
26409	41660	28	applied	\N	\N	\N	\N	198196	198196	365361
26409	41663	29	applied	\N	\N	\N	\N	198197	198197	365362
26409	41672	31	applied	\N	\N	\N	\N	198199	198199	365364
26409	41673	32	applied	\N	\N	\N	\N	198200	198200	365365
26409	41679	33	applied	\N	\N	\N	\N	198201	198201	365366
26409	41682	34	applied	\N	\N	\N	\N	198202	198202	365367
26409	41683	35	applied	\N	\N	\N	\N	198203	198203	365368
26409	41689	36	applied	\N	\N	\N	\N	198204	198204	365369
26409	41692	37	applied	\N	\N	\N	\N	198205	198205	365370
26409	41695	38	applied	\N	\N	\N	\N	198206	198206	365371
26409	41698	39	applied	\N	\N	\N	\N	198207	198207	365372
26409	41702	40	applied	\N	\N	\N	\N	198208	198208	365373
26409	41704	41	applied	\N	\N	\N	\N	198209	198209	365374
26409	41707	42	applied	\N	\N	\N	\N	198210	198210	365375
26409	41711	43	applied	\N	\N	\N	\N	198211	198211	365376
26409	41712	44	applied	\N	\N	\N	\N	198212	198212	365377
26409	41717	45	applied	\N	\N	\N	\N	198213	198213	365378
26409	41721	46	applied	\N	\N	\N	\N	198214	198214	365379
26409	41725	48	applied	\N	\N	\N	\N	198216	198216	365381
26409	41726	49	applied	\N	\N	\N	\N	198217	198217	365382
26409	41731	50	applied	\N	\N	\N	\N	198218	198218	365383
26409	41733	51	applied	\N	\N	\N	\N	198219	198219	365384
26409	41735	52	applied	\N	\N	\N	\N	198220	198220	365385
26409	41736	53	applied	\N	\N	\N	\N	198221	198221	365386
26409	41737	54	applied	\N	\N	\N	\N	198222	198222	365387
26409	41742	55	applied	\N	\N	\N	\N	198223	198223	365388
26409	41745	56	applied	\N	\N	\N	\N	198224	198224	365389
26409	41747	57	applied	\N	\N	\N	\N	198225	198225	365390
26409	41749	58	applied	\N	\N	\N	\N	198226	198226	365391
26409	41751	59	applied	\N	\N	\N	\N	198227	198227	365392
26409	41752	60	applied	\N	\N	\N	\N	198228	198228	365393
26409	41753	61	applied	\N	\N	\N	\N	198229	198229	365394
26409	41754	62	applied	\N	\N	\N	\N	198230	198230	365395
26409	41762	63	applied	\N	\N	\N	\N	198231	198231	365396
26409	41765	65	applied	\N	\N	\N	\N	198233	198233	365398
26409	41769	66	applied	\N	\N	\N	\N	198234	198234	365399
26409	41770	67	applied	\N	\N	\N	\N	198235	198235	365400
26409	41771	68	applied	\N	\N	\N	\N	198236	198236	365401
26409	41775	69	applied	\N	\N	\N	\N	198237	198237	365402
26409	41776	70	applied	\N	\N	\N	\N	198238	198238	365403
26409	41780	71	applied	\N	\N	\N	\N	198239	198239	365404
26409	41782	72	applied	\N	\N	\N	\N	198240	198240	365405
26409	41785	73	applied	\N	\N	\N	\N	198241	198241	365406
26409	41786	74	applied	\N	\N	\N	\N	198242	198242	365407
26409	41789	75	applied	\N	\N	\N	\N	198243	198243	365408
26409	41792	76	applied	\N	\N	\N	\N	198244	198244	365409
26409	41793	77	applied	\N	\N	\N	\N	198245	198245	365410
26409	41796	78	applied	\N	\N	\N	\N	198246	198246	365411
26412	41989	0	applied	\N	\N	\N	\N	198293	198293	365458
26412	41990	1	applied	\N	\N	\N	\N	198294	198294	365459
26421	42024	0	applied	\N	\N	\N	\N	198356	198356	365521
26421	42025	1	applied	\N	\N	\N	\N	198357	198357	365522
26421	42026	2	applied	\N	\N	\N	\N	198358	198358	365523
26429	42033	0	applied	\N	\N	\N	\N	198465	198465	365630
26429	42034	1	applied	\N	\N	\N	\N	198466	198466	365631
26429	42035	2	applied	\N	\N	\N	\N	198467	198467	365632
26429	42036	3	applied	\N	\N	\N	\N	198468	198468	365633
26432	42040	0	applied	\N	\N	\N	\N	198476	198476	365641
26432	42041	1	applied	\N	\N	\N	\N	198477	198477	365642
26432	42042	3	applied	\N	\N	\N	\N	198478	198478	365643
26432	42043	4	applied	\N	\N	\N	\N	198479	198479	365644
26432	42044	5	applied	\N	\N	\N	\N	198480	198480	365645
26432	42045	6	applied	\N	\N	\N	\N	198481	198481	365646
26432	42046	7	applied	\N	\N	\N	\N	198482	198482	365647
26436	42047	0	applied	\N	\N	\N	\N	198504	198504	365669
26436	42048	1	applied	\N	\N	\N	\N	198505	198505	365670
26436	42050	3	applied	\N	\N	\N	\N	198507	198507	365672
26436	42051	4	applied	\N	\N	\N	\N	198508	198508	365673
26436	42052	5	applied	\N	\N	\N	\N	198509	198509	365674
26437	42047	0	applied	\N	\N	\N	\N	198510	198510	365675
26437	42048	1	applied	\N	\N	\N	\N	198511	198511	365676
26437	42049	2	applied	\N	\N	\N	\N	198512	198512	365677
26437	42050	3	applied	\N	\N	\N	\N	198513	198513	365678
26437	42051	4	applied	\N	\N	\N	\N	198514	198514	365679
26437	42052	5	applied	\N	\N	\N	\N	198515	198515	365680
26444	42060	0	applied	\N	\N	\N	\N	198542	198542	365707
26444	42061	1	applied	\N	\N	\N	\N	198543	198543	365708
26444	42062	2	applied	\N	\N	\N	\N	198544	198544	365709
26444	42063	3	applied	\N	\N	\N	\N	198545	198545	365710
26444	42064	4	applied	\N	\N	\N	\N	198546	198546	365711
26444	42065	5	applied	\N	\N	\N	\N	198547	198547	365712
26448	42066	0	applied	\N	\N	\N	\N	198556	198556	365721
26448	42068	2	applied	\N	\N	\N	\N	198558	198558	365723
26448	42069	3	applied	\N	\N	\N	\N	198559	198559	365724
26450	42070	0	applied	\N	\N	\N	\N	198562	198562	365727
26450	42071	1	applied	\N	\N	\N	\N	198563	198563	365728
26450	42072	2	applied	\N	\N	\N	\N	198564	198564	365729
26455	41992	0	applied	\N	\N	\N	\N	198577	198577	365742
26455	41993	1	applied	\N	\N	\N	\N	198578	198578	365743
26455	41994	2	applied	\N	\N	\N	\N	198579	198579	365744
26455	41995	3	applied	\N	\N	\N	\N	198580	198580	365745
26455	41996	4	applied	\N	\N	\N	\N	198581	198581	365746
26455	42010	5	applied	\N	\N	\N	\N	198582	198582	365747
26455	42014	6	applied	\N	\N	\N	\N	198583	198583	365748
26455	42017	7	applied	\N	\N	\N	\N	198584	198584	365749
26455	42018	8	applied	\N	\N	\N	\N	198585	198585	365750
26409	41601	11	applied	\N	\N	\N	\N	198179	198179	365344
26409	41604	12	applied	\N	\N	\N	\N	198180	198180	365345
26409	41806	83	applied	\N	\N	\N	\N	198251	198251	365416
26409	41810	84	applied	\N	\N	\N	\N	198252	198252	365417
26409	41812	85	applied	\N	\N	\N	\N	198253	198253	365418
26409	41815	86	applied	\N	\N	\N	\N	198254	198254	365419
26409	41816	87	applied	\N	\N	\N	\N	198255	198255	365420
26409	41819	88	applied	\N	\N	\N	\N	198256	198256	365421
26409	41821	89	applied	\N	\N	\N	\N	198257	198257	365422
26409	41822	90	applied	\N	\N	\N	\N	198258	198258	365423
26409	41826	91	applied	\N	\N	\N	\N	198259	198259	365424
26409	41828	92	applied	\N	\N	\N	\N	198260	198260	365425
26409	41832	93	applied	\N	\N	\N	\N	198261	198261	365426
26409	41833	94	applied	\N	\N	\N	\N	198262	198262	365427
26409	41839	96	applied	\N	\N	\N	\N	198264	198264	365429
26409	41841	97	applied	\N	\N	\N	\N	198265	198265	365430
26409	41843	98	applied	\N	\N	\N	\N	198266	198266	365431
26409	41844	99	applied	\N	\N	\N	\N	198267	198267	365432
26409	41845	100	applied	\N	\N	\N	\N	198268	198268	365433
26409	41850	101	applied	\N	\N	\N	\N	198269	198269	365434
26409	41853	102	applied	\N	\N	\N	\N	198270	198270	365435
26409	41855	103	applied	\N	\N	\N	\N	198271	198271	365436
26409	41857	104	applied	\N	\N	\N	\N	198272	198272	365437
26409	41860	105	applied	\N	\N	\N	\N	198273	198273	365438
26409	41862	106	applied	\N	\N	\N	\N	198274	198274	365439
26409	41863	107	applied	\N	\N	\N	\N	198275	198275	365440
26409	41864	108	applied	\N	\N	\N	\N	198276	198276	365441
26409	41869	109	applied	\N	\N	\N	\N	198277	198277	365442
26409	41870	110	applied	\N	\N	\N	\N	198278	198278	365443
26409	41873	111	applied	\N	\N	\N	\N	198279	198279	365444
26409	41878	113	applied	\N	\N	\N	\N	198281	198281	365446
26409	41882	114	applied	\N	\N	\N	\N	198282	198282	365447
26409	41888	115	applied	\N	\N	\N	\N	198283	198283	365448
26409	41889	116	applied	\N	\N	\N	\N	198284	198284	365449
26411	41985	0	applied	\N	\N	\N	\N	198289	198289	365454
26411	41986	1	applied	\N	\N	\N	\N	198290	198290	365455
26411	41987	2	applied	\N	\N	\N	\N	198291	198291	365456
26411	41988	3	applied	\N	\N	\N	\N	198292	198292	365457
26415	41992	0	applied	\N	\N	\N	\N	198317	198317	365482
26415	41993	1	applied	\N	\N	\N	\N	198318	198318	365483
26415	41994	2	applied	\N	\N	\N	\N	198319	198319	365484
26415	41995	3	applied	\N	\N	\N	\N	198320	198320	365485
26415	41996	4	applied	\N	\N	\N	\N	198321	198321	365486
26415	41997	5	applied	\N	\N	\N	\N	198322	198322	365487
26415	41998	6	applied	\N	\N	\N	\N	198323	198323	365488
26415	42000	8	applied	\N	\N	1000000000	\N	198325	198325	365490
26415	42001	9	applied	\N	\N	\N	\N	198326	198326	365491
26415	42002	10	applied	\N	\N	\N	\N	198327	198327	365492
26415	42003	11	applied	\N	\N	\N	\N	198328	198328	365493
26415	42004	12	applied	\N	\N	\N	\N	198329	198329	365494
26415	42005	13	applied	\N	\N	\N	\N	198330	198330	365495
26415	42006	14	applied	\N	\N	\N	\N	198331	198331	365496
26415	42007	15	applied	\N	\N	\N	\N	198332	198332	365497
26415	42008	16	applied	\N	\N	\N	\N	198333	198333	365498
26415	42009	17	applied	\N	\N	\N	\N	198334	198334	365499
26420	42024	0	applied	\N	\N	\N	\N	198353	198353	365518
26420	42025	1	applied	\N	\N	\N	\N	198354	198354	365519
26420	42026	2	applied	\N	\N	\N	\N	198355	198355	365520
26424	41780	0	applied	\N	\N	\N	\N	198365	198365	365530
26424	41782	1	applied	\N	\N	\N	\N	198366	198366	365531
26424	41785	2	applied	\N	\N	\N	\N	198367	198367	365532
26424	41786	3	applied	\N	\N	\N	\N	198368	198368	365533
26424	41789	4	applied	\N	\N	\N	\N	198369	198369	365534
26424	41792	5	applied	\N	\N	\N	\N	198370	198370	365535
26424	41796	7	applied	\N	\N	\N	\N	198372	198372	365537
26424	41797	8	applied	\N	\N	\N	\N	198373	198373	365538
26424	41801	9	applied	\N	\N	\N	\N	198374	198374	365539
26424	41803	10	applied	\N	\N	\N	\N	198375	198375	365540
26424	41805	11	applied	\N	\N	\N	\N	198376	198376	365541
26424	41806	12	applied	\N	\N	\N	\N	198377	198377	365542
26424	41810	13	applied	\N	\N	\N	\N	198378	198378	365543
26424	41812	14	applied	\N	\N	\N	\N	198379	198379	365544
26424	41815	15	applied	\N	\N	\N	\N	198380	198380	365545
26424	41816	16	applied	\N	\N	\N	\N	198381	198381	365546
26424	41819	17	applied	\N	\N	\N	\N	198382	198382	365547
26424	41821	18	applied	\N	\N	\N	\N	198383	198383	365548
26424	41822	19	applied	\N	\N	\N	\N	198384	198384	365549
26424	41826	20	applied	\N	\N	\N	\N	198385	198385	365550
26424	41828	21	applied	\N	\N	\N	\N	198386	198386	365551
26424	41832	22	applied	\N	\N	\N	\N	198387	198387	365552
26424	41834	24	applied	\N	\N	\N	\N	198389	198389	365554
26424	41839	25	applied	\N	\N	\N	\N	198390	198390	365555
26424	41841	26	applied	\N	\N	\N	\N	198391	198391	365556
26424	41843	27	applied	\N	\N	\N	\N	198392	198392	365557
26424	41844	28	applied	\N	\N	\N	\N	198393	198393	365558
26424	41845	29	applied	\N	\N	\N	\N	198394	198394	365559
26424	41850	30	applied	\N	\N	\N	\N	198395	198395	365560
26424	41853	31	applied	\N	\N	\N	\N	198396	198396	365561
26424	41855	32	applied	\N	\N	\N	\N	198397	198397	365562
26424	41857	33	applied	\N	\N	\N	\N	198398	198398	365563
26424	41860	34	applied	\N	\N	\N	\N	198399	198399	365564
26424	41862	35	applied	\N	\N	\N	\N	198400	198400	365565
26424	41863	36	applied	\N	\N	\N	\N	198401	198401	365566
26424	41864	37	applied	\N	\N	\N	\N	198402	198402	365567
26424	41869	38	applied	\N	\N	\N	\N	198403	198403	365568
26424	41870	39	applied	\N	\N	\N	\N	198404	198404	365569
26424	41874	41	applied	\N	\N	\N	\N	198406	198406	365571
26424	41878	42	applied	\N	\N	\N	\N	198407	198407	365572
26424	41882	43	applied	\N	\N	\N	\N	198408	198408	365573
26424	41888	44	applied	\N	\N	\N	\N	198409	198409	365574
26424	41889	45	applied	\N	\N	\N	\N	198410	198410	365575
26424	41894	46	applied	\N	\N	\N	\N	198411	198411	365576
26424	41895	47	applied	\N	\N	\N	\N	198412	198412	365577
26424	41902	48	applied	\N	\N	\N	\N	198413	198413	365578
26424	41905	49	applied	\N	\N	\N	\N	198414	198414	365579
26424	41908	50	applied	\N	\N	\N	\N	198415	198415	365580
26424	41912	51	applied	\N	\N	\N	\N	198416	198416	365581
26424	41915	52	applied	\N	\N	\N	\N	198417	198417	365582
26424	41918	53	applied	\N	\N	\N	\N	198418	198418	365583
26424	41919	54	applied	\N	\N	\N	\N	198419	198419	365584
26424	41925	55	applied	\N	\N	\N	\N	198420	198420	365585
26409	41801	80	applied	\N	\N	\N	\N	198248	198248	365413
26409	41805	82	applied	\N	\N	\N	\N	198250	198250	365415
26424	41939	60	applied	\N	\N	\N	\N	198425	198425	365590
26424	41945	61	applied	\N	\N	\N	\N	198426	198426	365591
26424	41948	62	applied	\N	\N	\N	\N	198427	198427	365592
26424	41952	63	applied	\N	\N	\N	\N	198428	198428	365593
26424	41953	64	applied	\N	\N	\N	\N	198429	198429	365594
26424	41959	65	applied	\N	\N	\N	\N	198430	198430	365595
26424	41961	66	applied	\N	\N	\N	\N	198431	198431	365596
26424	41965	67	applied	\N	\N	\N	\N	198432	198432	365597
26424	41969	68	applied	\N	\N	\N	\N	198433	198433	365598
26424	41972	69	applied	\N	\N	\N	\N	198434	198434	365599
26424	41975	70	applied	\N	\N	\N	\N	198435	198435	365600
26424	41979	71	applied	\N	\N	\N	\N	198436	198436	365601
26424	41980	72	applied	\N	\N	\N	\N	198437	198437	365602
26424	41985	73	applied	\N	\N	\N	\N	198438	198438	365603
26424	41992	75	applied	\N	\N	\N	\N	198440	198440	365605
26424	41993	76	applied	\N	\N	\N	\N	198441	198441	365606
26424	41994	78	applied	\N	\N	\N	\N	198442	198442	365607
26424	41995	79	applied	\N	\N	\N	\N	198443	198443	365608
26424	41996	80	applied	\N	\N	\N	\N	198444	198444	365609
26424	42010	81	applied	\N	\N	\N	\N	198445	198445	365610
26424	42014	82	applied	\N	\N	\N	\N	198446	198446	365611
26424	42017	83	applied	\N	\N	\N	\N	198447	198447	365612
26424	42018	84	applied	\N	\N	\N	\N	198448	198448	365613
26424	42024	85	applied	\N	\N	\N	\N	198449	198449	365614
26424	41459	86	applied	\N	\N	\N	\N	198450	198450	365615
26424	41380	87	applied	\N	\N	1000000000	\N	198451	198451	365616
26424	41950	88	applied	\N	\N	\N	\N	198452	198452	365617
26427	42030	0	applied	\N	\N	\N	\N	198459	198459	365624
26427	42031	1	applied	\N	\N	\N	\N	198460	198460	365625
26427	42032	2	applied	\N	\N	\N	\N	198461	198461	365626
26431	42038	1	applied	\N	\N	\N	\N	198474	198474	365639
26431	42039	2	applied	\N	\N	\N	\N	198475	198475	365640
26434	42040	0	applied	\N	\N	\N	\N	198490	198490	365655
26434	42041	1	applied	\N	\N	\N	\N	198491	198491	365656
26434	42042	3	applied	\N	\N	\N	\N	198492	198492	365657
26434	42043	4	applied	\N	\N	\N	\N	198493	198493	365658
26434	42044	5	applied	\N	\N	\N	\N	198494	198494	365659
26434	42045	6	applied	\N	\N	\N	\N	198495	198495	365660
26434	42046	7	applied	\N	\N	\N	\N	198496	198496	365661
26438	42053	0	applied	\N	\N	\N	\N	198516	198516	365681
26438	42054	1	applied	\N	\N	\N	\N	198517	198517	365682
26438	42055	2	applied	\N	\N	\N	\N	198518	198518	365683
26438	42056	3	applied	\N	\N	\N	\N	198519	198519	365684
26441	42057	0	applied	\N	\N	\N	\N	198527	198527	365692
26441	42058	1	applied	\N	\N	\N	\N	198528	198528	365693
26441	42059	2	applied	\N	\N	\N	\N	198529	198529	365694
26447	42068	2	applied	\N	\N	\N	\N	198554	198554	365719
26447	42069	3	applied	\N	\N	\N	\N	198555	198555	365720
26451	42070	0	applied	\N	\N	\N	\N	198565	198565	365730
26451	42071	1	applied	\N	\N	\N	\N	198566	198566	365731
26451	42072	2	applied	\N	\N	\N	\N	198567	198567	365732
26453	42073	0	applied	\N	\N	\N	\N	198571	198571	365736
26453	42074	1	applied	\N	\N	\N	\N	198572	198572	365737
26456	42075	0	applied	\N	\N	\N	\N	198664	198664	365829
26456	42076	1	applied	\N	\N	\N	\N	198665	198665	365830
26456	42077	2	applied	\N	\N	\N	\N	198666	198666	365831
26456	42078	3	applied	\N	\N	\N	\N	198667	198667	365832
26458	42082	0	applied	\N	\N	\N	\N	198671	198671	365836
26458	42083	1	applied	\N	\N	\N	\N	198672	198672	365837
26458	42084	2	applied	\N	\N	\N	\N	198673	198673	365838
26458	42085	3	applied	\N	\N	\N	\N	198674	198674	365839
26458	42086	4	applied	\N	\N	\N	\N	198675	198675	365840
26458	42088	6	applied	\N	\N	\N	\N	198677	198677	365842
26466	42101	0	applied	\N	\N	\N	\N	198816	198816	365981
26466	42102	1	applied	\N	\N	\N	\N	198817	198817	365982
26466	42103	2	applied	\N	\N	\N	\N	198818	198818	365983
26468	41828	0	applied	\N	\N	\N	\N	198938	198938	366103
26468	41832	1	applied	\N	\N	\N	\N	198939	198939	366104
26468	41833	2	applied	\N	\N	\N	\N	198940	198940	366105
26468	41834	3	applied	\N	\N	\N	\N	198941	198941	366106
26468	41839	4	applied	\N	\N	\N	\N	198942	198942	366107
26468	41841	5	applied	\N	\N	\N	\N	198943	198943	366108
26468	41843	6	applied	\N	\N	\N	\N	198944	198944	366109
26468	41844	7	applied	\N	\N	\N	\N	198945	198945	366110
26468	41845	8	applied	\N	\N	\N	\N	198946	198946	366111
26468	41850	9	applied	\N	\N	\N	\N	198947	198947	366112
26468	41853	10	applied	\N	\N	\N	\N	198948	198948	366113
26468	41855	11	applied	\N	\N	\N	\N	198949	198949	366114
26468	41860	13	applied	\N	\N	\N	\N	198951	198951	366116
26468	41862	14	applied	\N	\N	\N	\N	198952	198952	366117
26468	41863	15	applied	\N	\N	\N	\N	198953	198953	366118
26468	41864	16	applied	\N	\N	\N	\N	198954	198954	366119
26468	41869	17	applied	\N	\N	\N	\N	198955	198955	366120
26468	41870	18	applied	\N	\N	\N	\N	198956	198956	366121
26468	41873	19	applied	\N	\N	\N	\N	198957	198957	366122
26468	41874	20	applied	\N	\N	\N	\N	198958	198958	366123
26468	41878	21	applied	\N	\N	\N	\N	198959	198959	366124
26468	41882	22	applied	\N	\N	\N	\N	198960	198960	366125
26468	41888	23	applied	\N	\N	\N	\N	198961	198961	366126
26468	41889	24	applied	\N	\N	\N	\N	198962	198962	366127
26468	41894	25	applied	\N	\N	\N	\N	198963	198963	366128
26468	41895	26	applied	\N	\N	\N	\N	198964	198964	366129
26468	41902	27	applied	\N	\N	\N	\N	198965	198965	366130
26468	41905	28	applied	\N	\N	\N	\N	198966	198966	366131
26468	41912	30	applied	\N	\N	\N	\N	198968	198968	366133
26468	41915	31	applied	\N	\N	\N	\N	198969	198969	366134
26468	41918	32	applied	\N	\N	\N	\N	198970	198970	366135
26468	41919	33	applied	\N	\N	\N	\N	198971	198971	366136
26468	41925	34	applied	\N	\N	\N	\N	198972	198972	366137
26468	41926	35	applied	\N	\N	\N	\N	198973	198973	366138
26468	41931	36	applied	\N	\N	\N	\N	198974	198974	366139
26468	41932	37	applied	\N	\N	\N	\N	198975	198975	366140
26468	41938	38	applied	\N	\N	\N	\N	198976	198976	366141
26468	41939	39	applied	\N	\N	\N	\N	198977	198977	366142
26468	41945	40	applied	\N	\N	\N	\N	198978	198978	366143
26468	41948	41	applied	\N	\N	\N	\N	198979	198979	366144
26468	41952	42	applied	\N	\N	\N	\N	198980	198980	366145
26468	41953	43	applied	\N	\N	\N	\N	198981	198981	366146
26468	41959	44	applied	\N	\N	\N	\N	198982	198982	366147
26468	41961	45	applied	\N	\N	\N	\N	198983	198983	366148
26424	41938	59	applied	\N	\N	\N	\N	198424	198424	365589
26452	42072	2	applied	\N	\N	\N	\N	198570	198570	365735
26454	42075	0	applied	\N	\N	\N	\N	198573	198573	365738
26454	42076	1	applied	\N	\N	\N	\N	198574	198574	365739
26454	42077	2	applied	\N	\N	\N	\N	198575	198575	365740
26454	42078	3	applied	\N	\N	\N	\N	198576	198576	365741
26468	41965	46	applied	\N	\N	\N	\N	198984	198984	366149
26468	41969	47	applied	\N	\N	\N	\N	198985	198985	366150
26468	41972	48	applied	\N	\N	\N	\N	198986	198986	366151
26468	41975	49	applied	\N	\N	\N	\N	198987	198987	366152
26468	41979	50	applied	\N	\N	\N	\N	198988	198988	366153
26468	41980	51	applied	\N	\N	\N	\N	198989	198989	366154
26468	41985	52	applied	\N	\N	\N	\N	198990	198990	366155
26468	41989	53	applied	\N	\N	\N	\N	198991	198991	366156
26468	41992	54	applied	\N	\N	\N	\N	198992	198992	366157
26468	41993	55	applied	\N	\N	\N	\N	198993	198993	366158
26468	41994	57	applied	\N	\N	\N	\N	198994	198994	366159
26468	41996	59	applied	\N	\N	\N	\N	198996	198996	366161
26468	42010	60	applied	\N	\N	\N	\N	198997	198997	366162
26468	42014	61	applied	\N	\N	\N	\N	198998	198998	366163
26468	42017	62	applied	\N	\N	\N	\N	198999	198999	366164
26468	42018	63	applied	\N	\N	\N	\N	199000	199000	366165
26468	42024	64	applied	\N	\N	\N	\N	199001	199001	366166
26468	42027	65	applied	\N	\N	\N	\N	199002	199002	366167
26468	42030	66	applied	\N	\N	\N	\N	199003	199003	366168
26468	42033	67	applied	\N	\N	\N	\N	199004	199004	366169
26468	42037	68	applied	\N	\N	\N	\N	199005	199005	366170
26468	42040	69	applied	\N	\N	\N	\N	199006	199006	366171
26468	42041	70	applied	\N	\N	\N	\N	199007	199007	366172
26468	42047	71	applied	\N	\N	\N	\N	199008	199008	366173
26468	42048	72	applied	\N	\N	\N	\N	199009	199009	366174
26468	42053	73	applied	\N	\N	\N	\N	199010	199010	366175
26468	42057	74	applied	\N	\N	\N	\N	199011	199011	366176
26468	42061	76	applied	\N	\N	\N	\N	199013	199013	366178
26468	42066	77	applied	\N	\N	\N	\N	199014	199014	366179
26468	42070	78	applied	\N	\N	\N	\N	199015	199015	366180
26468	42073	79	applied	\N	\N	\N	\N	199016	199016	366181
26468	42075	80	applied	\N	\N	\N	\N	199017	199017	366182
26468	42079	81	applied	\N	\N	\N	\N	199018	199018	366183
26468	42082	82	applied	\N	\N	\N	\N	199019	199019	366184
26468	42083	83	applied	\N	\N	\N	\N	199020	199020	366185
26468	42089	84	applied	\N	\N	\N	\N	199021	199021	366186
26468	42092	85	applied	\N	\N	\N	\N	199022	199022	366187
26468	42093	86	applied	\N	\N	\N	\N	199023	199023	366188
26468	42101	87	applied	\N	\N	\N	\N	199024	199024	366189
26468	41879	88	applied	\N	\N	\N	\N	199025	199025	366190
26468	41829	89	applied	\N	\N	\N	\N	199026	199026	366191
26468	41836	90	applied	\N	\N	\N	\N	199027	199027	366192
26468	41830	91	applied	\N	\N	\N	\N	199028	199028	366193
26468	41835	93	applied	\N	\N	\N	\N	199030	199030	366195
26468	41837	94	applied	\N	\N	\N	\N	199031	199031	366196
26468	41838	95	applied	\N	\N	\N	\N	199032	199032	366197
26468	41840	96	applied	\N	\N	\N	\N	199033	199033	366198
26468	41950	97	applied	\N	\N	\N	\N	199034	199034	366199
26468	41847	98	applied	\N	\N	\N	\N	199035	199035	366200
26473	42115	0	applied	\N	\N	\N	\N	199085	199085	366249
26473	42116	1	applied	\N	\N	\N	\N	199086	199086	366250
26473	42117	2	applied	\N	\N	\N	\N	199087	199087	366251
26473	42118	3	applied	\N	\N	\N	\N	199088	199088	366252
26473	42119	4	applied	\N	\N	\N	\N	199089	199089	366253
26473	42120	5	applied	\N	\N	\N	\N	199090	199090	366254
26473	42121	6	applied	\N	\N	\N	\N	199091	199091	366255
26478	42132	0	applied	\N	\N	\N	\N	199114	199114	366278
26478	42133	1	applied	\N	\N	\N	\N	199115	199115	366279
26478	42134	2	applied	\N	\N	\N	\N	199116	199116	366280
26480	42136	0	applied	\N	\N	\N	\N	199122	199122	366286
26480	42137	1	applied	\N	\N	\N	\N	199123	199123	366287
26480	42138	2	applied	\N	\N	\N	\N	199124	199124	366288
26480	42139	3	applied	\N	\N	\N	\N	199125	199125	366289
26480	42140	4	applied	\N	\N	\N	\N	199126	199126	366290
26482	42141	0	applied	\N	\N	\N	\N	199132	199132	366296
26482	42142	1	applied	\N	\N	\N	\N	199133	199133	366297
26482	42143	2	applied	\N	\N	\N	\N	199134	199134	366298
26483	42141	0	applied	\N	\N	\N	\N	199135	199135	366299
26483	42142	1	applied	\N	\N	\N	\N	199136	199136	366300
26483	42143	2	applied	\N	\N	\N	\N	199137	199137	366301
26487	42147	0	applied	\N	\N	\N	\N	199147	199147	366311
26487	42148	1	applied	\N	\N	\N	\N	199148	199148	366312
26487	42149	2	applied	\N	\N	\N	\N	199149	199149	366313
26487	42150	3	applied	\N	\N	\N	\N	199150	199150	366314
26490	42154	0	applied	\N	\N	\N	\N	199161	199161	366325
26490	42156	2	applied	\N	\N	\N	\N	199163	199163	366327
26490	42157	3	applied	\N	\N	\N	\N	199164	199164	366328
26490	42158	4	applied	\N	\N	\N	\N	199165	199165	366329
26490	42159	5	applied	\N	\N	\N	\N	199166	199166	366330
26490	42160	6	applied	\N	\N	\N	\N	199167	199167	366331
26492	42164	0	applied	\N	\N	\N	\N	199171	199171	366335
26492	42165	1	applied	\N	\N	\N	\N	199172	199172	366336
26492	42166	2	applied	\N	\N	\N	\N	199173	199173	366337
26495	42167	0	applied	\N	\N	\N	\N	199302	199302	366466
26495	42168	1	applied	\N	\N	\N	\N	199303	199303	366467
26495	42170	2	applied	\N	\N	\N	\N	199304	199304	366468
26495	42169	3	applied	\N	\N	\N	\N	199305	199305	366469
26495	42171	4	applied	\N	\N	\N	\N	199306	199306	366470
26495	42172	5	applied	\N	\N	\N	\N	199307	199307	366471
26495	42173	6	applied	\N	\N	\N	\N	199308	199308	366472
26495	42174	7	applied	\N	\N	\N	\N	199309	199309	366473
26495	42176	9	applied	\N	\N	\N	\N	199311	199311	366475
26497	42177	0	applied	\N	\N	\N	\N	199315	199315	366479
26497	42178	1	applied	\N	\N	\N	\N	199316	199316	366480
26497	42179	2	applied	\N	\N	\N	\N	199317	199317	366481
26500	42187	0	applied	\N	\N	\N	\N	199326	199326	366490
26500	42188	1	applied	\N	\N	\N	\N	199327	199327	366491
26500	42189	2	applied	\N	\N	\N	\N	199328	199328	366492
26505	42200	0	applied	\N	\N	\N	\N	199349	199349	366513
26505	42201	1	applied	\N	\N	\N	\N	199350	199350	366514
26505	42202	2	applied	\N	\N	\N	\N	199351	199351	366515
26511	42213	0	applied	\N	\N	\N	\N	199476	199476	366640
26511	42214	1	applied	\N	\N	\N	\N	199477	199477	366641
26511	42215	2	applied	\N	\N	\N	\N	199478	199478	366642
26511	42216	3	applied	\N	\N	\N	\N	199479	199479	366643
26449	42069	1	applied	\N	\N	\N	\N	198561	198561	365726
26452	42070	0	applied	\N	\N	\N	\N	198568	198568	365733
26455	42033	12	applied	\N	\N	\N	\N	198589	198589	365754
26455	42037	13	applied	\N	\N	\N	\N	198590	198590	365755
26455	42040	14	applied	\N	\N	\N	\N	198591	198591	365756
26455	42041	15	applied	\N	\N	\N	\N	198592	198592	365757
26455	42047	16	applied	\N	\N	\N	\N	198593	198593	365758
26455	42048	17	applied	\N	\N	\N	\N	198594	198594	365759
26455	42053	18	applied	\N	\N	\N	\N	198595	198595	365760
26455	42057	19	applied	\N	\N	\N	\N	198596	198596	365761
26455	42060	20	applied	\N	\N	\N	\N	198597	198597	365762
26455	42061	21	applied	\N	\N	\N	\N	198598	198598	365763
26455	42066	22	applied	\N	\N	\N	\N	198599	198599	365764
26455	42070	23	applied	\N	\N	\N	\N	198600	198600	365765
26455	42073	24	applied	\N	\N	\N	\N	198601	198601	365766
26455	41997	26	applied	\N	\N	\N	\N	198603	198603	365768
26455	41998	27	applied	\N	\N	\N	\N	198604	198604	365769
26455	41999	28	applied	\N	\N	1000000000	\N	198605	198605	365770
26455	42000	29	applied	\N	\N	1000000000	\N	198606	198606	365771
26455	42015	30	applied	\N	\N	\N	\N	198607	198607	365772
26455	42013	31	applied	\N	\N	\N	\N	198608	198608	365773
26455	42021	32	applied	\N	\N	\N	\N	198609	198609	365774
26455	42035	33	applied	\N	\N	\N	\N	198610	198610	365775
26455	42045	34	applied	\N	\N	\N	\N	198611	198611	365776
26455	42055	35	applied	\N	\N	\N	\N	198612	198612	365777
26455	42068	36	applied	\N	\N	\N	\N	198613	198613	365778
26455	42077	37	applied	\N	\N	\N	\N	198614	198614	365779
26455	42001	38	applied	\N	\N	\N	\N	198615	198615	365780
26455	42002	39	applied	\N	\N	\N	\N	198616	198616	365781
26455	42003	40	applied	\N	\N	\N	\N	198617	198617	365782
26455	42004	41	applied	\N	\N	\N	\N	198618	198618	365783
26455	42022	43	applied	\N	\N	\N	\N	198620	198620	365785
26455	42023	44	applied	\N	\N	\N	\N	198621	198621	365786
26455	42026	45	applied	\N	\N	\N	\N	198622	198622	365787
26455	42028	46	applied	\N	\N	\N	\N	198623	198623	365788
26455	42032	47	applied	\N	\N	\N	\N	198624	198624	365789
26455	42036	48	applied	\N	\N	\N	\N	198625	198625	365790
26455	42039	49	applied	\N	\N	\N	\N	198626	198626	365791
26455	42042	50	applied	\N	\N	\N	\N	198627	198627	365792
26455	42043	51	applied	\N	\N	\N	\N	198628	198628	365793
26455	42051	52	applied	\N	\N	\N	\N	198629	198629	365794
26455	42052	53	applied	\N	\N	\N	\N	198630	198630	365795
26455	42054	54	applied	\N	\N	\N	\N	198631	198631	365796
26455	42059	55	applied	\N	\N	\N	\N	198632	198632	365797
26455	42064	56	applied	\N	\N	\N	\N	198633	198633	365798
26455	42065	57	applied	\N	\N	\N	\N	198634	198634	365799
26455	42069	58	applied	\N	\N	\N	\N	198635	198635	365800
26455	42074	60	applied	\N	\N	\N	\N	198637	198637	365802
26455	42076	61	applied	\N	\N	\N	\N	198638	198638	365803
26455	42005	62	applied	\N	\N	\N	\N	198639	198639	365804
26455	42006	63	applied	\N	\N	\N	\N	198640	198640	365805
26455	42007	64	applied	\N	\N	\N	\N	198641	198641	365806
26455	42008	65	applied	\N	\N	\N	\N	198642	198642	365807
26455	42009	66	applied	\N	\N	\N	\N	198643	198643	365808
26455	42011	67	applied	\N	\N	\N	\N	198644	198644	365809
26455	42016	69	applied	\N	\N	\N	\N	198645	198645	365810
26455	42019	70	applied	\N	\N	\N	\N	198646	198646	365811
26455	42020	71	applied	\N	\N	\N	\N	198647	198647	365812
26455	42025	72	applied	\N	\N	\N	\N	198648	198648	365813
26455	42029	73	applied	\N	\N	\N	\N	198649	198649	365814
26455	42031	74	applied	\N	\N	\N	\N	198650	198650	365815
26455	42034	75	applied	\N	\N	\N	\N	198651	198651	365816
26455	42038	76	applied	\N	\N	\N	\N	198652	198652	365817
26511	42218	6	applied	\N	\N	\N	\N	199481	199481	366645
26511	42219	7	applied	\N	\N	\N	\N	199482	199482	366646
26511	42220	8	applied	\N	\N	\N	\N	199483	199483	366647
26511	42221	9	applied	\N	\N	\N	\N	199484	199484	366648
26511	42222	10	applied	\N	\N	\N	\N	199485	199485	366649
26520	42240	0	applied	\N	\N	\N	\N	199516	199516	366680
26520	42241	1	applied	\N	\N	\N	\N	199517	199517	366681
26520	42242	2	applied	\N	\N	\N	\N	199518	199518	366682
26524	42240	0	applied	\N	\N	\N	\N	199527	199527	366691
26524	42241	1	applied	\N	\N	\N	\N	199528	199528	366692
26524	42242	2	applied	\N	\N	\N	\N	199529	199529	366693
26526	42243	0	applied	\N	\N	\N	\N	199533	199533	366697
26526	42244	1	applied	\N	\N	\N	\N	199534	199534	366698
26526	42245	2	applied	\N	\N	\N	\N	199535	199535	366699
26529	42250	0	applied	\N	\N	\N	\N	199543	199543	366707
26529	42251	1	applied	\N	\N	\N	\N	199544	199544	366708
26531	42256	0	applied	\N	\N	\N	\N	199549	199549	366713
26531	42257	1	applied	\N	\N	\N	\N	199550	199550	366714
26531	42258	2	applied	\N	\N	\N	\N	199551	199551	366715
26531	42259	3	applied	\N	\N	\N	\N	199552	199552	366716
26535	42260	0	applied	\N	\N	\N	\N	199571	199571	366735
26535	42261	1	applied	\N	\N	\N	\N	199572	199572	366736
26535	42262	2	applied	\N	\N	\N	\N	199573	199573	366737
26535	42263	3	applied	\N	\N	\N	\N	199574	199574	366738
26535	42264	4	applied	\N	\N	\N	\N	199575	199575	366739
26535	42265	5	applied	\N	\N	\N	\N	199576	199576	366740
26535	42266	6	applied	\N	\N	\N	\N	199577	199577	366741
26535	42267	7	applied	\N	\N	\N	\N	199578	199578	366742
26535	42268	8	applied	\N	\N	\N	\N	199579	199579	366743
26542	42289	0	applied	\N	\N	\N	\N	199621	199621	366782
26542	42290	1	applied	\N	\N	\N	\N	199622	199622	366783
26542	42291	2	applied	\N	\N	\N	\N	199623	199623	366784
26542	42293	4	applied	\N	\N	\N	\N	199625	199625	366786
26542	42294	5	applied	\N	\N	\N	\N	199626	199626	366787
26542	42295	6	applied	\N	\N	\N	\N	199627	199627	366788
26547	42308	0	applied	\N	\N	\N	\N	199644	199644	366805
26547	42309	2	applied	\N	\N	\N	\N	199645	199645	366806
26547	42310	3	applied	\N	\N	\N	\N	199646	199646	366807
26549	42311	0	applied	\N	\N	\N	\N	199650	199650	366811
26549	42312	1	applied	\N	\N	\N	\N	199651	199651	366812
26552	42317	0	applied	\N	\N	\N	\N	199659	199659	366820
26552	42318	1	applied	\N	\N	\N	\N	199660	199660	366821
26552	42319	2	applied	\N	\N	\N	\N	199661	199661	366822
26555	42333	0	applied	\N	\N	\N	\N	199675	199675	366836
26555	42334	1	applied	\N	\N	\N	\N	199676	199676	366837
26555	42335	2	applied	\N	\N	\N	\N	199677	199677	366838
26560	42336	0	applied	\N	\N	\N	\N	199692	199692	366853
26560	42337	1	applied	\N	\N	\N	\N	199693	199693	366854
26455	42027	10	applied	\N	\N	\N	\N	198587	198587	365752
26455	42030	11	applied	\N	\N	\N	\N	198588	198588	365753
26455	42050	80	applied	\N	\N	\N	\N	198656	198656	365821
26455	42056	81	applied	\N	\N	\N	\N	198657	198657	365822
26455	42058	82	applied	\N	\N	\N	\N	198658	198658	365823
26455	42062	83	applied	\N	\N	\N	\N	198659	198659	365824
26455	42063	84	applied	\N	\N	\N	\N	198660	198660	365825
26455	42067	85	applied	\N	\N	\N	\N	198661	198661	365826
26455	42071	86	applied	\N	\N	\N	\N	198662	198662	365827
26455	42078	87	applied	\N	\N	\N	\N	198663	198663	365828
26459	41961	0	applied	\N	\N	\N	\N	198678	198678	365843
26459	41965	1	applied	\N	\N	\N	\N	198679	198679	365844
26459	41969	2	applied	\N	\N	\N	\N	198680	198680	365845
26459	41972	3	applied	\N	\N	\N	\N	198681	198681	365846
26459	41975	4	applied	\N	\N	\N	\N	198682	198682	365847
26459	41980	6	applied	\N	\N	\N	\N	198684	198684	365849
26459	41985	7	applied	\N	\N	\N	\N	198685	198685	365850
26459	41989	8	applied	\N	\N	\N	\N	198686	198686	365851
26459	41992	9	applied	\N	\N	\N	\N	198687	198687	365852
26459	41993	10	applied	\N	\N	\N	\N	198688	198688	365853
26459	41994	11	applied	\N	\N	\N	\N	198689	198689	365854
26459	41995	12	applied	\N	\N	\N	\N	198690	198690	365855
26459	41996	13	applied	\N	\N	\N	\N	198691	198691	365856
26459	42010	14	applied	\N	\N	\N	\N	198692	198692	365857
26459	42014	15	applied	\N	\N	\N	\N	198693	198693	365858
26459	42017	16	applied	\N	\N	\N	\N	198694	198694	365859
26459	42018	17	applied	\N	\N	\N	\N	198695	198695	365860
26459	42024	18	applied	\N	\N	\N	\N	198696	198696	365861
26459	42027	19	applied	\N	\N	\N	\N	198697	198697	365862
26459	42030	20	applied	\N	\N	\N	\N	198698	198698	365863
26459	42033	21	applied	\N	\N	\N	\N	198699	198699	365864
26459	42040	23	applied	\N	\N	\N	\N	198701	198701	365866
26459	42041	24	applied	\N	\N	\N	\N	198702	198702	365867
26459	42047	25	applied	\N	\N	\N	\N	198703	198703	365868
26459	42048	26	applied	\N	\N	\N	\N	198704	198704	365869
26459	42053	27	applied	\N	\N	\N	\N	198705	198705	365870
26459	42057	28	applied	\N	\N	\N	\N	198706	198706	365871
26459	42060	29	applied	\N	\N	\N	\N	198707	198707	365872
26459	42061	30	applied	\N	\N	\N	\N	198708	198708	365873
26459	42066	31	applied	\N	\N	\N	\N	198709	198709	365874
26459	42070	32	applied	\N	\N	\N	\N	198710	198710	365875
26459	42073	33	applied	\N	\N	\N	\N	198711	198711	365876
26459	42075	34	applied	\N	\N	\N	\N	198712	198712	365877
26459	42079	35	applied	\N	\N	\N	\N	198713	198713	365878
26459	42082	36	applied	\N	\N	\N	\N	198714	198714	365879
26459	42083	37	applied	\N	\N	\N	\N	198715	198715	365880
26459	41962	38	applied	\N	\N	\N	\N	198716	198716	365881
26459	41999	40	applied	\N	\N	1000000000	\N	198718	198718	365883
26459	42000	41	applied	\N	\N	1000000000	\N	198719	198719	365884
26459	41967	42	applied	\N	\N	\N	\N	198720	198720	365885
26459	41970	43	applied	\N	\N	\N	\N	198721	198721	365886
26459	41974	44	applied	\N	\N	\N	\N	198722	198722	365887
26459	41976	45	applied	\N	\N	\N	\N	198723	198723	365888
26459	41981	46	applied	\N	\N	\N	\N	198724	198724	365889
26459	41982	47	applied	\N	\N	\N	\N	198725	198725	365890
26459	42015	48	applied	\N	\N	\N	\N	198726	198726	365891
26459	41988	49	applied	\N	\N	\N	\N	198727	198727	365892
26459	41991	50	applied	\N	\N	\N	\N	198728	198728	365893
26459	41998	51	applied	\N	\N	\N	\N	198729	198729	365894
26459	42001	52	applied	\N	\N	\N	\N	198730	198730	365895
26459	42002	53	applied	\N	\N	\N	\N	198731	198731	365896
26459	42003	54	applied	\N	\N	\N	\N	198732	198732	365897
26459	42004	55	applied	\N	\N	\N	\N	198733	198733	365898
26459	42022	57	applied	\N	\N	\N	\N	198735	198735	365900
26459	42023	58	applied	\N	\N	\N	\N	198736	198736	365901
26459	42026	59	applied	\N	\N	\N	\N	198737	198737	365902
26459	42028	60	applied	\N	\N	\N	\N	198738	198738	365903
26459	42032	61	applied	\N	\N	\N	\N	198739	198739	365904
26459	42036	62	applied	\N	\N	\N	\N	198740	198740	365905
26459	42039	63	applied	\N	\N	\N	\N	198741	198741	365906
26459	42042	64	applied	\N	\N	\N	\N	198742	198742	365907
26459	42043	65	applied	\N	\N	\N	\N	198743	198743	365908
26459	42051	66	applied	\N	\N	\N	\N	198744	198744	365909
26459	42052	67	applied	\N	\N	\N	\N	198745	198745	365910
26459	42054	68	applied	\N	\N	\N	\N	198746	198746	365911
26459	42059	69	applied	\N	\N	\N	\N	198747	198747	365912
26459	42064	70	applied	\N	\N	\N	\N	198748	198748	365913
26459	42065	71	applied	\N	\N	\N	\N	198749	198749	365914
26459	42069	72	applied	\N	\N	\N	\N	198750	198750	365915
26459	42074	74	applied	\N	\N	\N	\N	198752	198752	365917
26459	42076	75	applied	\N	\N	\N	\N	198753	198753	365918
26459	42081	76	applied	\N	\N	\N	\N	198754	198754	365919
26459	42086	77	applied	\N	\N	\N	\N	198755	198755	365920
26459	42088	78	applied	\N	\N	\N	\N	198756	198756	365921
26459	41968	79	applied	\N	\N	\N	\N	198757	198757	365922
26459	41977	80	applied	\N	\N	\N	\N	198758	198758	365923
26459	41986	81	applied	\N	\N	\N	\N	198759	198759	365924
26459	41997	82	applied	\N	\N	\N	\N	198760	198760	365925
26459	42013	83	applied	\N	\N	\N	\N	198761	198761	365926
26459	42021	84	applied	\N	\N	\N	\N	198762	198762	365927
26459	42035	85	applied	\N	\N	\N	\N	198763	198763	365928
26459	42045	86	applied	\N	\N	\N	\N	198764	198764	365929
26459	42055	87	applied	\N	\N	\N	\N	198765	198765	365930
26459	42068	88	applied	\N	\N	\N	\N	198766	198766	365931
26459	42077	89	applied	\N	\N	\N	\N	198767	198767	365932
26459	41964	91	applied	\N	\N	\N	\N	198769	198769	365934
26459	41966	92	applied	\N	\N	\N	\N	198770	198770	365935
26459	41971	93	applied	\N	\N	\N	\N	198771	198771	365936
26459	41973	94	applied	\N	\N	\N	\N	198772	198772	365937
26459	41978	95	applied	\N	\N	\N	\N	198773	198773	365938
26459	41983	96	applied	\N	\N	\N	\N	198774	198774	365939
26459	41984	97	applied	\N	\N	\N	\N	198775	198775	365940
26459	41987	98	applied	\N	\N	\N	\N	198776	198776	365941
26459	41990	99	applied	\N	\N	\N	\N	198777	198777	365942
26459	42005	100	applied	\N	\N	\N	\N	198778	198778	365943
26459	42006	101	applied	\N	\N	\N	\N	198779	198779	365944
26459	42007	102	applied	\N	\N	\N	\N	198780	198780	365945
26459	42008	103	applied	\N	\N	\N	\N	198781	198781	365946
26459	42009	104	applied	\N	\N	\N	\N	198782	198782	365947
26459	42011	105	applied	\N	\N	\N	\N	198783	198783	365948
26459	42016	106	applied	\N	\N	\N	\N	198784	198784	365949
26455	42046	78	applied	\N	\N	\N	\N	198654	198654	365819
26455	42049	79	applied	\N	\N	\N	\N	198655	198655	365820
26459	42031	111	applied	\N	\N	\N	\N	198789	198789	365954
26459	42034	112	applied	\N	\N	\N	\N	198790	198790	365955
26459	42038	113	applied	\N	\N	\N	\N	198791	198791	365956
26459	42044	114	applied	\N	\N	\N	\N	198792	198792	365957
26459	42046	116	applied	\N	\N	\N	\N	198793	198793	365958
26459	42049	117	applied	\N	\N	\N	\N	198794	198794	365959
26462	42092	0	applied	\N	\N	\N	\N	198798	198798	365963
26462	42093	1	applied	\N	\N	\N	\N	198799	198799	365964
26462	42094	2	applied	\N	\N	\N	\N	198800	198800	365965
26462	42095	3	applied	\N	\N	\N	\N	198801	198801	365966
26462	42096	4	applied	\N	\N	\N	\N	198802	198802	365967
26462	42097	5	applied	\N	\N	\N	\N	198803	198803	365968
26464	42098	0	applied	\N	\N	\N	\N	198810	198810	365975
26464	42100	2	applied	\N	\N	\N	\N	198812	198812	365977
26467	42047	18	applied	\N	\N	\N	\N	198837	198837	366002
26467	42048	19	applied	\N	\N	\N	\N	198838	198838	366003
26467	42053	20	applied	\N	\N	\N	\N	198839	198839	366004
26467	42057	21	applied	\N	\N	\N	\N	198840	198840	366005
26467	42060	22	applied	\N	\N	\N	\N	198841	198841	366006
26467	42061	23	applied	\N	\N	\N	\N	198842	198842	366007
26467	42066	24	applied	\N	\N	\N	\N	198843	198843	366008
26467	42070	25	applied	\N	\N	\N	\N	198844	198844	366009
26467	42073	26	applied	\N	\N	\N	\N	198845	198845	366010
26467	42075	27	applied	\N	\N	\N	\N	198846	198846	366011
26467	42079	28	applied	\N	\N	\N	\N	198847	198847	366012
26467	42082	29	applied	\N	\N	\N	\N	198848	198848	366013
26467	42083	30	applied	\N	\N	\N	\N	198849	198849	366014
26467	42089	31	applied	\N	\N	\N	\N	198850	198850	366015
26467	42092	32	applied	\N	\N	\N	\N	198851	198851	366016
26467	42101	34	applied	\N	\N	\N	\N	198853	198853	366018
26467	41986	35	applied	\N	\N	\N	\N	198854	198854	366019
26467	41997	36	applied	\N	\N	\N	\N	198855	198855	366020
26467	41999	37	applied	\N	\N	1000000000	\N	198856	198856	366021
26467	42000	38	applied	\N	\N	1000000000	\N	198857	198857	366022
26467	41987	39	applied	\N	\N	\N	\N	198858	198858	366023
26467	41990	40	applied	\N	\N	\N	\N	198859	198859	366024
26467	42015	41	applied	\N	\N	\N	\N	198860	198860	366025
26467	41988	42	applied	\N	\N	\N	\N	198861	198861	366026
26467	42013	43	applied	\N	\N	\N	\N	198862	198862	366027
26467	42021	44	applied	\N	\N	\N	\N	198863	198863	366028
26467	42035	45	applied	\N	\N	\N	\N	198864	198864	366029
26467	42045	46	applied	\N	\N	\N	\N	198865	198865	366030
26467	42055	47	applied	\N	\N	\N	\N	198866	198866	366031
26467	42068	48	applied	\N	\N	\N	\N	198867	198867	366032
26467	42077	49	applied	\N	\N	\N	\N	198868	198868	366033
26467	42099	51	applied	\N	\N	\N	\N	198870	198870	366035
26467	41991	52	applied	\N	\N	\N	\N	198871	198871	366036
26467	41998	53	applied	\N	\N	\N	\N	198872	198872	366037
26467	42001	54	applied	\N	\N	\N	\N	198873	198873	366038
26467	42002	55	applied	\N	\N	\N	\N	198874	198874	366039
26467	42003	56	applied	\N	\N	\N	\N	198875	198875	366040
26467	42004	57	applied	\N	\N	\N	\N	198876	198876	366041
26467	42012	58	applied	\N	\N	\N	\N	198877	198877	366042
26467	42022	59	applied	\N	\N	\N	\N	198878	198878	366043
26467	42023	60	applied	\N	\N	\N	\N	198879	198879	366044
26467	42026	61	applied	\N	\N	\N	\N	198880	198880	366045
26467	42028	62	applied	\N	\N	\N	\N	198881	198881	366046
26467	42032	63	applied	\N	\N	\N	\N	198882	198882	366047
26467	42036	64	applied	\N	\N	\N	\N	198883	198883	366048
26467	42039	65	applied	\N	\N	\N	\N	198884	198884	366049
26467	42042	66	applied	\N	\N	\N	\N	198885	198885	366050
26467	42051	68	applied	\N	\N	\N	\N	198887	198887	366052
26467	42052	69	applied	\N	\N	\N	\N	198888	198888	366053
26467	42054	70	applied	\N	\N	\N	\N	198889	198889	366054
26467	42059	71	applied	\N	\N	\N	\N	198890	198890	366055
26467	42064	72	applied	\N	\N	\N	\N	198891	198891	366056
26467	42065	73	applied	\N	\N	\N	\N	198892	198892	366057
26467	42069	74	applied	\N	\N	\N	\N	198893	198893	366058
26467	42072	75	applied	\N	\N	\N	\N	198894	198894	366059
26467	42074	76	applied	\N	\N	\N	\N	198895	198895	366060
26467	42076	77	applied	\N	\N	\N	\N	198896	198896	366061
26467	42081	78	applied	\N	\N	\N	\N	198897	198897	366062
26467	42086	80	applied	\N	\N	\N	\N	198898	198898	366063
26467	42088	81	applied	\N	\N	\N	\N	198899	198899	366064
26467	42091	82	applied	\N	\N	\N	\N	198900	198900	366065
26467	42094	83	applied	\N	\N	\N	\N	198901	198901	366066
26467	42095	84	applied	\N	\N	\N	\N	198902	198902	366067
26469	42105	1	applied	\N	\N	\N	\N	199064	199064	366228
26469	42106	2	applied	\N	\N	\N	\N	199065	199065	366229
26469	42107	3	applied	\N	\N	\N	\N	199066	199066	366230
26469	42108	4	applied	\N	\N	\N	\N	199067	199067	366231
26469	42109	5	applied	\N	\N	\N	\N	199068	199068	366232
26469	42110	6	applied	\N	\N	\N	\N	199069	199069	366233
26469	42111	7	applied	\N	\N	\N	\N	199070	199070	366234
26471	42112	0	applied	\N	\N	\N	\N	199079	199079	366243
26471	42113	1	applied	\N	\N	\N	\N	199080	199080	366244
26471	42114	2	applied	\N	\N	\N	\N	199081	199081	366245
26479	42132	0	applied	\N	\N	\N	\N	199118	199118	366282
26479	42133	1	applied	\N	\N	\N	\N	199119	199119	366283
26479	42134	2	applied	\N	\N	\N	\N	199120	199120	366284
26479	42135	3	applied	\N	\N	\N	\N	199121	199121	366285
26481	42136	0	applied	\N	\N	\N	\N	199127	199127	366291
26481	42137	1	applied	\N	\N	\N	\N	199128	199128	366292
26481	42139	3	applied	\N	\N	\N	\N	199130	199130	366294
26481	42140	4	applied	\N	\N	\N	\N	199131	199131	366295
26493	42164	0	applied	\N	\N	\N	\N	199174	199174	366338
26493	42165	1	applied	\N	\N	\N	\N	199175	199175	366339
26493	42166	2	applied	\N	\N	\N	\N	199176	199176	366340
26498	42179	0	applied	\N	\N	\N	\N	199318	199318	366482
26501	42190	0	applied	\N	\N	\N	\N	199329	199329	366493
26501	42191	1	applied	\N	\N	\N	\N	199330	199330	366494
26501	42192	2	applied	\N	\N	\N	\N	199331	199331	366495
26501	42193	3	applied	\N	\N	\N	\N	199332	199332	366496
26501	42194	4	applied	\N	\N	\N	\N	199333	199333	366497
26501	42195	5	applied	\N	\N	\N	\N	199334	199334	366498
26501	42196	6	applied	\N	\N	\N	\N	199335	199335	366499
26503	42197	0	applied	\N	\N	\N	\N	199343	199343	366507
26503	42198	1	applied	\N	\N	\N	\N	199344	199344	366508
26503	42199	2	applied	\N	\N	\N	\N	199345	199345	366509
26459	42025	109	applied	\N	\N	\N	\N	198787	198787	365952
26459	42029	110	applied	\N	\N	\N	\N	198788	198788	365953
26467	42006	88	applied	\N	\N	\N	\N	198906	198906	366071
26467	42007	89	applied	\N	\N	\N	\N	198907	198907	366072
26467	42008	90	applied	\N	\N	\N	\N	198908	198908	366073
26467	42009	91	applied	\N	\N	\N	\N	198909	198909	366074
26467	42011	92	applied	\N	\N	\N	\N	198910	198910	366075
26467	42016	93	applied	\N	\N	\N	\N	198911	198911	366076
26467	42020	95	applied	\N	\N	\N	\N	198913	198913	366078
26467	42025	96	applied	\N	\N	\N	\N	198914	198914	366079
26467	42029	97	applied	\N	\N	\N	\N	198915	198915	366080
26467	42031	98	applied	\N	\N	\N	\N	198916	198916	366081
26467	42034	99	applied	\N	\N	\N	\N	198917	198917	366082
26467	42038	100	applied	\N	\N	\N	\N	198918	198918	366083
26467	42044	101	applied	\N	\N	\N	\N	198919	198919	366084
26467	42046	102	applied	\N	\N	\N	\N	198920	198920	366085
26467	42049	103	applied	\N	\N	\N	\N	198921	198921	366086
26467	42050	104	applied	\N	\N	\N	\N	198922	198922	366087
26467	42056	105	applied	\N	\N	\N	\N	198923	198923	366088
26467	42058	106	applied	\N	\N	\N	\N	198924	198924	366089
26467	42062	107	applied	\N	\N	\N	\N	198925	198925	366090
26467	42063	108	applied	\N	\N	\N	\N	198926	198926	366091
26467	42067	109	applied	\N	\N	\N	\N	198927	198927	366092
26467	42071	110	applied	\N	\N	\N	\N	198928	198928	366093
26467	42080	112	applied	\N	\N	\N	\N	198930	198930	366095
26467	42084	113	applied	\N	\N	\N	\N	198931	198931	366096
26467	42085	114	applied	\N	\N	\N	\N	198932	198932	366097
26467	42090	115	applied	\N	\N	\N	\N	198933	198933	366098
26467	42096	116	applied	\N	\N	\N	\N	198934	198934	366099
26467	42097	117	applied	\N	\N	\N	\N	198935	198935	366100
26467	42100	118	applied	\N	\N	\N	\N	198936	198936	366101
26467	42103	119	applied	\N	\N	\N	\N	198937	198937	366102
26468	41842	100	applied	\N	\N	\N	\N	199037	199037	366201
26468	41846	101	applied	\N	\N	\N	\N	199038	199038	366202
26468	42015	102	applied	\N	\N	\N	\N	199039	199039	366203
26468	41852	103	applied	\N	\N	\N	\N	199040	199040	366204
26468	41858	104	applied	\N	\N	\N	\N	199041	199041	366205
26468	41868	105	applied	\N	\N	\N	\N	199042	199042	366206
26468	41875	106	applied	\N	\N	\N	\N	199043	199043	366207
26468	41886	107	applied	\N	\N	\N	\N	199044	199044	366208
26468	41897	108	applied	\N	\N	\N	\N	199045	199045	366209
26468	41909	109	applied	\N	\N	\N	\N	199046	199046	366210
26468	41884	111	applied	\N	\N	1000000000	\N	199048	199048	366212
26468	41896	112	applied	\N	\N	1000000000	\N	199049	199049	366213
26468	41999	113	applied	\N	\N	1000000000	\N	199050	199050	366214
26468	42000	114	applied	\N	\N	1000000000	\N	199051	199051	366215
26468	41922	115	applied	\N	\N	\N	\N	199052	199052	366216
26468	41935	116	applied	\N	\N	\N	\N	199053	199053	366217
26468	41940	117	applied	\N	\N	\N	\N	199054	199054	366218
26468	41958	118	applied	\N	\N	\N	\N	199055	199055	366219
26468	41848	119	applied	\N	\N	\N	\N	199056	199056	366220
26468	41849	120	applied	\N	\N	\N	\N	199057	199057	366221
26468	41851	121	applied	\N	\N	\N	\N	199058	199058	366222
26468	41854	122	applied	\N	\N	\N	\N	199059	199059	366223
26468	41856	123	applied	\N	\N	\N	\N	199060	199060	366224
26468	41859	124	applied	\N	\N	\N	\N	199061	199061	366225
26468	41861	125	applied	\N	\N	\N	\N	199062	199062	366226
26470	42104	0	applied	\N	\N	\N	\N	199071	199071	366235
26470	42105	1	applied	\N	\N	\N	\N	199072	199072	366236
26470	42106	2	applied	\N	\N	\N	\N	199073	199073	366237
26470	42107	3	applied	\N	\N	\N	\N	199074	199074	366238
26470	42108	4	applied	\N	\N	\N	\N	199075	199075	366239
26470	42109	5	applied	\N	\N	\N	\N	199076	199076	366240
26470	42111	7	applied	\N	\N	\N	\N	199078	199078	366242
26472	42112	0	applied	\N	\N	\N	\N	199082	199082	366246
26472	42113	1	applied	\N	\N	\N	\N	199083	199083	366247
26472	42114	2	applied	\N	\N	\N	\N	199084	199084	366248
26474	42122	0	applied	\N	\N	\N	\N	199092	199092	366256
26474	42123	1	applied	\N	\N	1000000000	\N	199093	199093	366257
26474	42124	2	applied	\N	\N	\N	\N	199094	199094	366258
26474	42125	3	applied	\N	\N	\N	\N	199095	199095	366259
26474	42126	4	applied	\N	\N	1000000000	\N	199096	199096	366260
26474	42127	5	applied	\N	\N	\N	\N	199097	199097	366261
26475	42122	0	applied	\N	\N	\N	\N	199098	199098	366262
26476	42122	0	applied	\N	\N	\N	\N	199104	199104	366268
26476	42123	1	applied	\N	\N	1000000000	\N	199105	199105	366269
26476	42124	2	applied	\N	\N	\N	\N	199106	199106	366270
26476	42125	3	applied	\N	\N	\N	\N	199107	199107	366271
26476	42127	5	applied	\N	\N	\N	\N	199109	199109	366273
26477	42128	0	applied	\N	\N	\N	\N	199110	199110	366274
26477	42129	1	applied	\N	\N	\N	\N	199111	199111	366275
26477	42130	2	applied	\N	\N	1000000000	\N	199112	199112	366276
26477	42131	4	applied	\N	\N	\N	\N	199113	199113	366277
26485	42141	0	applied	\N	\N	\N	\N	199141	199141	366305
26485	42142	1	applied	\N	\N	\N	\N	199142	199142	366306
26485	42143	2	applied	\N	\N	\N	\N	199143	199143	366307
26486	42144	0	applied	\N	\N	\N	\N	199144	199144	366308
26486	42145	1	applied	\N	\N	\N	\N	199145	199145	366309
26486	42146	2	applied	\N	\N	\N	\N	199146	199146	366310
26489	42154	0	applied	\N	\N	\N	\N	199154	199154	366318
26489	42155	1	applied	\N	\N	\N	\N	199155	199155	366319
26489	42156	2	applied	\N	\N	\N	\N	199156	199156	366320
26489	42157	3	applied	\N	\N	\N	\N	199157	199157	366321
26489	42158	4	applied	\N	\N	\N	\N	199158	199158	366322
26489	42159	5	applied	\N	\N	\N	\N	199159	199159	366323
26489	42160	6	applied	\N	\N	\N	\N	199160	199160	366324
26494	41980	0	applied	\N	\N	\N	\N	199177	199177	366341
26494	41989	2	applied	\N	\N	\N	\N	199179	199179	366343
26494	41992	3	applied	\N	\N	\N	\N	199180	199180	366344
26494	41993	4	applied	\N	\N	\N	\N	199181	199181	366345
26494	41994	5	applied	\N	\N	\N	\N	199182	199182	366346
26494	41995	6	applied	\N	\N	\N	\N	199183	199183	366347
26494	41996	7	applied	\N	\N	\N	\N	199184	199184	366348
26494	42010	8	applied	\N	\N	\N	\N	199185	199185	366349
26494	42014	9	applied	\N	\N	\N	\N	199186	199186	366350
26494	42017	10	applied	\N	\N	\N	\N	199187	199187	366351
26494	42018	11	applied	\N	\N	\N	\N	199188	199188	366352
26494	42024	12	applied	\N	\N	\N	\N	199189	199189	366353
26494	42027	13	applied	\N	\N	\N	\N	199190	199190	366354
26494	42030	14	applied	\N	\N	\N	\N	199191	199191	366355
26467	42102	86	applied	\N	\N	\N	\N	198904	198904	366069
26467	42005	87	applied	\N	\N	\N	\N	198905	198905	366070
26475	42126	4	applied	\N	\N	1000000000	\N	199102	199102	366266
26475	42127	5	applied	\N	\N	\N	\N	199103	199103	366267
26484	42141	0	applied	\N	\N	\N	\N	199138	199138	366302
26484	42142	1	applied	\N	\N	\N	\N	199139	199139	366303
26484	42143	2	applied	\N	\N	\N	\N	199140	199140	366304
26488	42151	0	applied	\N	\N	\N	\N	199151	199151	366315
26488	42153	2	applied	\N	\N	\N	\N	199153	199153	366317
26491	42161	0	applied	\N	\N	\N	\N	199168	199168	366332
26491	42162	1	applied	\N	\N	\N	\N	199169	199169	366333
26491	42163	2	applied	\N	\N	\N	\N	199170	199170	366334
26494	42033	15	applied	\N	\N	\N	\N	199192	199192	366356
26494	42037	16	applied	\N	\N	\N	\N	199193	199193	366357
26494	42040	17	applied	\N	\N	\N	\N	199194	199194	366358
26494	42041	18	applied	\N	\N	\N	\N	199195	199195	366359
26494	42047	19	applied	\N	\N	\N	\N	199196	199196	366360
26494	42048	20	applied	\N	\N	\N	\N	199197	199197	366361
26494	42053	21	applied	\N	\N	\N	\N	199198	199198	366362
26494	42057	22	applied	\N	\N	\N	\N	199199	199199	366363
26494	42060	23	applied	\N	\N	\N	\N	199200	199200	366364
26494	42061	24	applied	\N	\N	\N	\N	199201	199201	366365
26494	42066	25	applied	\N	\N	\N	\N	199202	199202	366366
26494	42070	26	applied	\N	\N	\N	\N	199203	199203	366367
26494	42075	28	applied	\N	\N	\N	\N	199205	199205	366369
26494	42079	29	applied	\N	\N	\N	\N	199206	199206	366370
26494	42082	30	applied	\N	\N	\N	\N	199207	199207	366371
26494	42083	31	applied	\N	\N	\N	\N	199208	199208	366372
26494	42089	32	applied	\N	\N	\N	\N	199209	199209	366373
26494	42092	33	applied	\N	\N	\N	\N	199210	199210	366374
26494	42093	34	applied	\N	\N	\N	\N	199211	199211	366375
26494	42101	35	applied	\N	\N	\N	\N	199212	199212	366376
26494	42104	36	applied	\N	\N	\N	\N	199213	199213	366377
26494	42105	37	applied	\N	\N	\N	\N	199214	199214	366378
26494	42112	38	applied	\N	\N	\N	\N	199215	199215	366379
26494	42115	39	applied	\N	\N	\N	\N	199216	199216	366380
26494	42116	40	applied	\N	\N	\N	\N	199217	199217	366381
26494	42122	41	applied	\N	\N	\N	\N	199218	199218	366382
26494	42128	42	applied	\N	\N	\N	\N	199219	199219	366383
26494	42132	43	applied	\N	\N	\N	\N	199220	199220	366384
26494	42141	45	applied	\N	\N	\N	\N	199222	199222	366386
26494	42144	46	applied	\N	\N	\N	\N	199223	199223	366387
26494	42147	47	applied	\N	\N	\N	\N	199224	199224	366388
26494	42151	48	applied	\N	\N	\N	\N	199225	199225	366389
26494	42154	49	applied	\N	\N	\N	\N	199226	199226	366390
26494	42155	50	applied	\N	\N	\N	\N	199227	199227	366391
26494	42161	51	applied	\N	\N	\N	\N	199228	199228	366392
26494	42164	52	applied	\N	\N	\N	\N	199229	199229	366393
26494	42167	53	applied	\N	\N	\N	\N	199230	199230	366394
26494	42168	54	applied	\N	\N	\N	\N	199231	199231	366395
26494	41981	55	applied	\N	\N	\N	\N	199232	199232	366396
26494	41982	56	applied	\N	\N	\N	\N	199233	199233	366397
26494	41986	57	applied	\N	\N	\N	\N	199234	199234	366398
26494	41997	58	applied	\N	\N	\N	\N	199235	199235	366399
26494	42000	60	applied	\N	\N	1000000000	\N	199237	199237	366401
26494	42123	61	applied	\N	\N	1000000000	\N	199238	199238	366402
26494	42126	62	applied	\N	\N	1000000000	\N	199239	199239	366403
26494	42130	63	applied	\N	\N	1000000000	\N	199240	199240	366404
26494	41983	64	applied	\N	\N	\N	\N	199241	199241	366405
26494	41984	65	applied	\N	\N	\N	\N	199242	199242	366406
26494	41987	66	applied	\N	\N	\N	\N	199243	199243	366407
26494	41990	67	applied	\N	\N	\N	\N	199244	199244	366408
26496	42177	0	applied	\N	\N	\N	\N	199312	199312	366476
26496	42178	1	applied	\N	\N	\N	\N	199313	199313	366477
26496	42179	2	applied	\N	\N	\N	\N	199314	199314	366478
26504	42200	0	applied	\N	\N	\N	\N	199346	199346	366510
26504	42201	1	applied	\N	\N	\N	\N	199347	199347	366511
26504	42202	2	applied	\N	\N	\N	\N	199348	199348	366512
26506	42203	0	applied	\N	\N	\N	\N	199352	199352	366516
26506	42204	1	applied	\N	\N	\N	\N	199353	199353	366517
26506	42205	2	applied	\N	\N	\N	\N	199354	199354	366518
26506	42206	3	applied	\N	\N	\N	\N	199355	199355	366519
26514	42230	0	applied	\N	\N	\N	\N	199497	199497	366661
26514	42231	1	applied	\N	\N	\N	\N	199498	199498	366662
26517	42233	0	applied	\N	\N	\N	\N	199506	199506	366670
26517	42234	1	applied	\N	\N	\N	\N	199507	199507	366671
26517	42235	2	applied	\N	\N	\N	\N	199508	199508	366672
26522	42240	0	applied	\N	\N	\N	\N	199521	199521	366685
26522	42241	1	applied	\N	\N	\N	\N	199522	199522	366686
26522	42242	2	applied	\N	\N	\N	\N	199523	199523	366687
26525	42240	0	applied	\N	\N	\N	\N	199530	199530	366694
26525	42241	1	applied	\N	\N	\N	\N	199531	199531	366695
26525	42242	2	applied	\N	\N	\N	\N	199532	199532	366696
26530	42253	0	applied	\N	\N	\N	\N	199546	199546	366710
26530	42254	1	applied	\N	\N	\N	\N	199547	199547	366711
26530	42255	2	applied	\N	\N	\N	\N	199548	199548	366712
26533	42260	0	applied	\N	\N	\N	\N	199553	199553	366717
26533	42261	1	applied	\N	\N	\N	\N	199554	199554	366718
26533	42262	2	applied	\N	\N	\N	\N	199555	199555	366719
26533	42263	3	applied	\N	\N	\N	\N	199556	199556	366720
26533	42265	5	applied	\N	\N	\N	\N	199558	199558	366722
26533	42266	6	applied	\N	\N	\N	\N	199559	199559	366723
26533	42267	7	applied	\N	\N	\N	\N	199560	199560	366724
26533	42268	8	applied	\N	\N	\N	\N	199561	199561	366725
26538	42269	0	applied	\N	\N	\N	\N	199594	199594	366758
26538	42270	1	applied	\N	\N	\N	\N	199595	199595	366759
26538	42271	2	applied	\N	\N	\N	\N	199596	199596	366760
26538	42274	3	applied	\N	\N	\N	\N	199597	199597	366761
26538	42275	4	applied	\N	\N	\N	\N	199598	199598	366762
26538	42272	5	applied	\N	\N	\N	\N	199599	199599	366763
26538	42273	6	applied	\N	\N	\N	\N	199600	199600	366764
26540	42280	0	applied	\N	\N	\N	\N	199605	199605	366768
26540	42281	1	applied	\N	\N	\N	\N	199606	199606	366769
26540	42282	2	applied	\N	\N	\N	\N	199607	199607	366770
26540	42283	3	applied	\N	\N	\N	\N	199608	199608	366771
26540	42285	5	applied	\N	\N	\N	\N	199610	199610	366772
26540	42286	6	applied	\N	\N	\N	\N	199611	199611	366773
26540	42288	8	applied	\N	\N	\N	\N	199613	199613	366774
26540	42287	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	199612	199612	\N
26543	42296	0	applied	\N	\N	\N	\N	199628	199628	366789
26475	42124	2	applied	\N	\N	\N	\N	199100	199100	366264
26475	42125	3	applied	\N	\N	\N	\N	199101	199101	366265
26494	42021	71	applied	\N	\N	\N	\N	199248	199248	366412
26494	42035	72	applied	\N	\N	\N	\N	199249	199249	366413
26494	42045	73	applied	\N	\N	\N	\N	199250	199250	366414
26494	42055	74	applied	\N	\N	\N	\N	199251	199251	366415
26494	42068	75	applied	\N	\N	\N	\N	199252	199252	366416
26494	42077	76	applied	\N	\N	\N	\N	199253	199253	366417
26494	42087	77	applied	\N	\N	\N	\N	199254	199254	366418
26494	42099	78	applied	\N	\N	\N	\N	199255	199255	366419
26494	42108	79	applied	\N	\N	\N	\N	199256	199256	366420
26494	42121	80	applied	\N	\N	\N	\N	199257	199257	366421
26494	42137	81	applied	\N	\N	\N	\N	199258	199258	366422
26494	42156	83	applied	\N	\N	\N	\N	199260	199260	366424
26494	42169	84	applied	\N	\N	\N	\N	199261	199261	366425
26494	41991	85	applied	\N	\N	\N	\N	199262	199262	366426
26494	41998	86	applied	\N	\N	\N	\N	199263	199263	366427
26494	42001	87	applied	\N	\N	\N	\N	199264	199264	366428
26494	42002	88	applied	\N	\N	\N	\N	199265	199265	366429
26494	42003	89	applied	\N	\N	\N	\N	199266	199266	366430
26494	42004	90	applied	\N	\N	\N	\N	199267	199267	366431
26494	42012	91	applied	\N	\N	\N	\N	199268	199268	366432
26494	42022	92	applied	\N	\N	\N	\N	199269	199269	366433
26494	42023	93	applied	\N	\N	\N	\N	199270	199270	366434
26494	42026	94	applied	\N	\N	\N	\N	199271	199271	366435
26494	42028	95	applied	\N	\N	\N	\N	199272	199272	366436
26494	42032	97	applied	\N	\N	\N	\N	199273	199273	366437
26494	42036	98	applied	\N	\N	\N	\N	199274	199274	366438
26494	42039	99	applied	\N	\N	\N	\N	199275	199275	366439
26494	42043	101	applied	\N	\N	\N	\N	199277	199277	366441
26494	42051	102	applied	\N	\N	\N	\N	199278	199278	366442
26494	42052	103	applied	\N	\N	\N	\N	199279	199279	366443
26494	42054	104	applied	\N	\N	\N	\N	199280	199280	366444
26494	42059	105	applied	\N	\N	\N	\N	199281	199281	366445
26494	42064	106	applied	\N	\N	\N	\N	199282	199282	366446
26494	42065	107	applied	\N	\N	\N	\N	199283	199283	366447
26494	42069	108	applied	\N	\N	\N	\N	199284	199284	366448
26494	42072	109	applied	\N	\N	\N	\N	199285	199285	366449
26494	42074	110	applied	\N	\N	\N	\N	199286	199286	366450
26494	42076	111	applied	\N	\N	\N	\N	199287	199287	366451
26494	42081	112	applied	\N	\N	\N	\N	199288	199288	366452
26494	42086	113	applied	\N	\N	\N	\N	199289	199289	366453
26494	42088	114	applied	\N	\N	\N	\N	199290	199290	366454
26494	42091	115	applied	\N	\N	\N	\N	199291	199291	366455
26494	42094	116	applied	\N	\N	\N	\N	199292	199292	366456
26494	42098	118	applied	\N	\N	\N	\N	199294	199294	366458
26494	42102	119	applied	\N	\N	\N	\N	199295	199295	366459
26494	42110	120	applied	\N	\N	\N	\N	199296	199296	366460
26494	42111	121	applied	\N	\N	\N	\N	199297	199297	366461
26494	42113	122	applied	\N	\N	\N	\N	199298	199298	366462
26494	42118	123	applied	\N	\N	\N	\N	199299	199299	366463
26494	42120	124	applied	\N	\N	\N	\N	199300	199300	366464
26494	42125	125	applied	\N	\N	\N	\N	199301	199301	366465
26499	42180	0	applied	\N	\N	\N	\N	199319	199319	366483
26499	42181	1	applied	\N	\N	\N	\N	199320	199320	366484
26499	42182	2	applied	\N	\N	\N	\N	199321	199321	366485
26499	42183	3	applied	\N	\N	\N	\N	199322	199322	366486
26499	42184	4	applied	\N	\N	\N	\N	199323	199323	366487
26499	42185	5	applied	\N	\N	\N	\N	199324	199324	366488
26499	42186	6	applied	\N	\N	\N	\N	199325	199325	366489
26502	42190	0	applied	\N	\N	\N	\N	199336	199336	366500
26543	42297	1	applied	\N	\N	\N	\N	199629	199629	366790
26553	42320	0	applied	\N	\N	\N	\N	199662	199662	366823
26553	42321	1	applied	\N	\N	\N	\N	199663	199663	366824
26553	42322	2	applied	\N	\N	\N	\N	199664	199664	366825
26553	42323	3	applied	\N	\N	\N	\N	199665	199665	366826
26553	42324	4	applied	\N	\N	\N	\N	199666	199666	366827
26553	42325	5	applied	\N	\N	\N	\N	199667	199667	366828
26553	42326	6	applied	\N	\N	\N	\N	199668	199668	366829
26558	42336	0	applied	\N	\N	\N	\N	199684	199684	366845
26558	42337	1	applied	\N	\N	\N	\N	199685	199685	366846
26558	42338	2	applied	\N	\N	\N	\N	199686	199686	366847
26558	42339	3	applied	\N	\N	\N	\N	199687	199687	366848
26567	42353	0	applied	\N	\N	\N	\N	199837	199837	366998
26567	42354	1	applied	\N	\N	\N	\N	199838	199838	366999
26567	42355	2	applied	\N	\N	\N	\N	199839	199839	367000
26568	42353	0	applied	\N	\N	\N	\N	199840	199840	367001
26568	42355	2	applied	\N	\N	\N	\N	199842	199842	367003
26570	42356	0	applied	\N	\N	\N	\N	199846	199846	367007
26570	42357	1	applied	\N	\N	\N	\N	199847	199847	367008
26570	42358	2	applied	\N	\N	\N	\N	199848	199848	367009
26570	42359	3	applied	\N	\N	\N	\N	199849	199849	367010
26570	42360	4	applied	\N	\N	\N	\N	199850	199850	367011
26570	42361	5	applied	\N	\N	\N	\N	199851	199851	367012
26570	42362	6	applied	\N	\N	\N	\N	199852	199852	367013
26572	42363	0	applied	\N	\N	\N	\N	199860	199860	367021
26572	42364	1	applied	\N	\N	\N	\N	199861	199861	367022
26572	42365	2	applied	\N	\N	\N	\N	199862	199862	367023
26572	42366	3	applied	\N	\N	\N	\N	199863	199863	367024
26575	42367	0	applied	\N	\N	\N	\N	199868	199868	367029
26575	42368	1	applied	\N	\N	\N	\N	199869	199869	367030
26575	42369	2	applied	\N	\N	\N	\N	199870	199870	367031
26580	42364	0	applied	\N	\N	\N	\N	199905	199905	367066
26580	42373	2	applied	\N	\N	\N	\N	199907	199907	367068
26580	42126	3	applied	\N	\N	1000000000	\N	199908	199908	367069
26580	42130	4	applied	\N	\N	1000000000	\N	199909	199909	367070
26580	42374	5	applied	\N	\N	\N	\N	199910	199910	367071
26583	42392	0	applied	\N	\N	\N	\N	199925	199925	367086
26583	42393	1	applied	\N	\N	\N	\N	199926	199926	367087
26583	42394	2	applied	\N	\N	\N	\N	199927	199927	367088
26583	42395	3	applied	\N	\N	\N	\N	199928	199928	367089
26583	42396	4	applied	\N	\N	\N	\N	199929	199929	367090
26583	42397	5	applied	\N	\N	\N	\N	199930	199930	367091
26583	42398	7	applied	\N	\N	\N	\N	199931	199931	367092
26585	42392	0	applied	\N	\N	\N	\N	199939	199939	367100
26585	42393	1	applied	\N	\N	\N	\N	199940	199940	367101
26585	42394	2	applied	\N	\N	\N	\N	199941	199941	367102
26585	42395	3	applied	\N	\N	\N	\N	199942	199942	367103
26585	42396	4	applied	\N	\N	\N	\N	199943	199943	367104
26585	42397	5	applied	\N	\N	\N	\N	199944	199944	367105
26585	42398	7	applied	\N	\N	\N	\N	199945	199945	367106
26494	41988	69	applied	\N	\N	\N	\N	199246	199246	366410
26494	42013	70	applied	\N	\N	\N	\N	199247	199247	366411
26502	42195	5	applied	\N	\N	\N	\N	199341	199341	366505
26502	42196	6	applied	\N	\N	\N	\N	199342	199342	366506
26507	42207	0	applied	\N	\N	\N	\N	199356	199356	366520
26507	42208	1	applied	\N	\N	\N	\N	199357	199357	366521
26507	42209	2	applied	\N	\N	\N	\N	199358	199358	366522
26508	42211	1	applied	\N	\N	\N	\N	199360	199360	366524
26508	42212	2	applied	\N	\N	\N	\N	199361	199361	366525
26509	42170	0	applied	\N	\N	\N	\N	199362	199362	366526
26509	42177	1	applied	\N	\N	\N	\N	199363	199363	366527
26509	42181	3	applied	\N	\N	\N	\N	199365	199365	366529
26509	42187	4	applied	\N	\N	\N	\N	199366	199366	366530
26509	42190	5	applied	\N	\N	\N	\N	199367	199367	366531
26509	42191	6	applied	\N	\N	\N	\N	199368	199368	366532
26509	42197	7	applied	\N	\N	\N	\N	199369	199369	366533
26509	42200	8	applied	\N	\N	\N	\N	199370	199370	366534
26509	42203	9	applied	\N	\N	\N	\N	199371	199371	366535
26509	42207	10	applied	\N	\N	\N	\N	199372	199372	366536
26509	42210	11	applied	\N	\N	\N	\N	199373	199373	366537
26509	42129	12	applied	\N	\N	\N	\N	199374	199374	366538
26509	42133	13	applied	\N	\N	\N	\N	199375	199375	366539
26509	42139	14	applied	\N	\N	\N	\N	199376	199376	366540
26509	42143	15	applied	\N	\N	\N	\N	199377	199377	366541
26509	42145	16	applied	\N	\N	\N	\N	199378	199378	366542
26509	42186	17	applied	\N	\N	\N	\N	199379	199379	366543
26509	42192	18	applied	\N	\N	\N	\N	199380	199380	366544
26509	42150	20	applied	\N	\N	\N	\N	199382	199382	366546
26509	42153	21	applied	\N	\N	\N	\N	199383	199383	366547
26509	42157	22	applied	\N	\N	\N	\N	199384	199384	366548
26509	42158	23	applied	\N	\N	\N	\N	199385	199385	366549
26509	42163	24	applied	\N	\N	\N	\N	199386	199386	366550
26509	42165	25	applied	\N	\N	\N	\N	199387	199387	366551
26509	42171	26	applied	\N	\N	\N	\N	199388	199388	366552
26509	42172	27	applied	\N	\N	\N	\N	199389	199389	366553
26509	42173	28	applied	\N	\N	\N	\N	199390	199390	366554
26509	42179	29	applied	\N	\N	\N	\N	199391	199391	366555
26509	42182	30	applied	\N	\N	\N	\N	199392	199392	366556
26509	42183	31	applied	\N	\N	\N	\N	199393	199393	366557
26509	42188	32	applied	\N	\N	\N	\N	199394	199394	366558
26509	42193	33	applied	\N	\N	\N	\N	199395	199395	366559
26509	42194	34	applied	\N	\N	\N	\N	199396	199396	366560
26509	42198	35	applied	\N	\N	\N	\N	199397	199397	366561
26509	42206	37	applied	\N	\N	\N	\N	199399	199399	366563
26509	42209	38	applied	\N	\N	\N	\N	199400	199400	366564
26509	42212	39	applied	\N	\N	\N	\N	199401	199401	366565
26509	42005	40	applied	\N	\N	\N	\N	199402	199402	366566
26509	42006	41	applied	\N	\N	\N	\N	199403	199403	366567
26509	42007	42	applied	\N	\N	\N	\N	199404	199404	366568
26509	42008	43	applied	\N	\N	\N	\N	199405	199405	366569
26509	42009	44	applied	\N	\N	\N	\N	199406	199406	366570
26509	42011	45	applied	\N	\N	\N	\N	199407	199407	366571
26513	42223	0	applied	\N	\N	\N	\N	199490	199490	366654
26513	42227	1	applied	\N	\N	\N	\N	199491	199491	366655
26513	42224	2	applied	\N	\N	\N	\N	199492	199492	366656
26513	42225	3	applied	\N	\N	\N	\N	199493	199493	366657
26513	42228	4	applied	\N	\N	\N	\N	199494	199494	366658
26513	42226	5	applied	\N	\N	\N	\N	199495	199495	366659
26513	42229	6	applied	\N	\N	\N	\N	199496	199496	366660
26516	42234	1	applied	\N	\N	\N	\N	199504	199504	366668
26516	42235	2	applied	\N	\N	\N	\N	199505	199505	366669
26521	42240	0	applied	\N	\N	\N	\N	199519	199519	366683
26521	42242	1	applied	\N	\N	\N	\N	199520	199520	366684
26527	42246	0	applied	\N	\N	\N	\N	199536	199536	366700
26527	42247	1	applied	\N	\N	\N	\N	199537	199537	366701
26527	42248	2	applied	\N	\N	\N	\N	199538	199538	366702
26527	42249	3	applied	\N	\N	\N	\N	199539	199539	366703
26536	42260	0	applied	\N	\N	\N	\N	199580	199580	366744
26536	42261	1	applied	\N	\N	\N	\N	199581	199581	366745
26536	42262	2	applied	\N	\N	\N	\N	199582	199582	366746
26536	42263	3	applied	\N	\N	\N	\N	199583	199583	366747
26536	42264	4	applied	\N	\N	\N	\N	199584	199584	366748
26536	42265	5	applied	\N	\N	\N	\N	199585	199585	366749
26536	42266	6	applied	\N	\N	\N	\N	199586	199586	366750
26536	42267	7	applied	\N	\N	\N	\N	199587	199587	366751
26537	42269	0	applied	\N	\N	\N	\N	199589	199589	366753
26537	42270	1	applied	\N	\N	\N	\N	199590	199590	366754
26537	42271	2	applied	\N	\N	\N	\N	199591	199591	366755
26537	42272	3	applied	\N	\N	\N	\N	199592	199592	366756
26537	42273	4	applied	\N	\N	\N	\N	199593	199593	366757
26539	42276	0	applied	\N	\N	\N	\N	199601	199601	366765
26539	42277	1	applied	\N	\N	\N	\N	199602	199602	366766
26539	42278	2	applied	\N	\N	\N	\N	199603	199603	366767
26545	42296	0	applied	\N	\N	\N	\N	199632	199632	366793
26545	42297	1	applied	\N	\N	\N	\N	199633	199633	366794
26548	42308	0	applied	\N	\N	\N	\N	199647	199647	366808
26548	42309	2	applied	\N	\N	\N	\N	199648	199648	366809
26548	42310	3	applied	\N	\N	\N	\N	199649	199649	366810
26550	42313	0	applied	\N	\N	\N	\N	199652	199652	366813
26550	42314	1	applied	\N	\N	\N	\N	199653	199653	366814
26550	42315	2	applied	\N	\N	\N	\N	199654	199654	366815
26550	42316	3	applied	\N	\N	\N	\N	199655	199655	366816
26556	42333	0	applied	\N	\N	\N	\N	199678	199678	366839
26556	42334	1	applied	\N	\N	\N	\N	199679	199679	366840
26556	42335	2	applied	\N	\N	\N	\N	199680	199680	366841
26562	42343	0	applied	\N	\N	\N	\N	199699	199699	366860
26562	42344	1	applied	\N	\N	\N	\N	199700	199700	366861
26562	42345	2	applied	\N	\N	\N	\N	199701	199701	366862
26564	42079	0	applied	\N	\N	\N	\N	199705	199705	366866
26564	42082	1	applied	\N	\N	\N	\N	199706	199706	366867
26564	42083	2	applied	\N	\N	\N	\N	199707	199707	366868
26564	42089	3	applied	\N	\N	\N	\N	199708	199708	366869
26564	42092	4	applied	\N	\N	\N	\N	199709	199709	366870
26564	42093	5	applied	\N	\N	\N	\N	199710	199710	366871
26564	42101	6	applied	\N	\N	\N	\N	199711	199711	366872
26564	42104	7	applied	\N	\N	\N	\N	199712	199712	366873
26564	42105	8	applied	\N	\N	\N	\N	199713	199713	366874
26564	42112	9	applied	\N	\N	\N	\N	199714	199714	366875
26564	42115	10	applied	\N	\N	\N	\N	199715	199715	366876
26564	42116	11	applied	\N	\N	\N	\N	199716	199716	366877
26564	42122	12	applied	\N	\N	\N	\N	199717	199717	366878
26564	42128	13	applied	\N	\N	\N	\N	199718	199718	366879
26502	42193	3	applied	\N	\N	\N	\N	199339	199339	366503
26502	42194	4	applied	\N	\N	\N	\N	199340	199340	366504
26509	42029	50	applied	\N	\N	\N	\N	199412	199412	366576
26509	42031	51	applied	\N	\N	\N	\N	199413	199413	366577
26509	42034	52	applied	\N	\N	\N	\N	199414	199414	366578
26509	42038	53	applied	\N	\N	\N	\N	199415	199415	366579
26509	42044	54	applied	\N	\N	\N	\N	199416	199416	366580
26509	42046	55	applied	\N	\N	\N	\N	199417	199417	366581
26509	42049	56	applied	\N	\N	\N	\N	199418	199418	366582
26509	42050	57	applied	\N	\N	\N	\N	199419	199419	366583
26509	42056	58	applied	\N	\N	\N	\N	199420	199420	366584
26509	42058	59	applied	\N	\N	\N	\N	199421	199421	366585
26509	42062	60	applied	\N	\N	\N	\N	199422	199422	366586
26509	42063	61	applied	\N	\N	\N	\N	199423	199423	366587
26509	42067	62	applied	\N	\N	\N	\N	199424	199424	366588
26509	42071	63	applied	\N	\N	\N	\N	199425	199425	366589
26509	42078	64	applied	\N	\N	\N	\N	199426	199426	366590
26509	42080	65	applied	\N	\N	\N	\N	199427	199427	366591
26509	42085	67	applied	\N	\N	\N	\N	199429	199429	366593
26509	42090	68	applied	\N	\N	\N	\N	199430	199430	366594
26509	42096	69	applied	\N	\N	\N	\N	199431	199431	366595
26509	42097	70	applied	\N	\N	\N	\N	199432	199432	366596
26509	42100	71	applied	\N	\N	\N	\N	199433	199433	366597
26509	42103	72	applied	\N	\N	\N	\N	199434	199434	366598
26509	42106	73	applied	\N	\N	\N	\N	199435	199435	366599
26509	42109	74	applied	\N	\N	\N	\N	199436	199436	366600
26509	42114	75	applied	\N	\N	\N	\N	199437	199437	366601
26509	42117	76	applied	\N	\N	\N	\N	199438	199438	366602
26509	42119	77	applied	\N	\N	\N	\N	199439	199439	366603
26509	42127	78	applied	\N	\N	\N	\N	199440	199440	366604
26509	42131	79	applied	\N	\N	\N	\N	199441	199441	366605
26509	42135	80	applied	\N	\N	\N	\N	199442	199442	366606
26509	42140	81	applied	\N	\N	\N	\N	199443	199443	366607
26509	42142	82	applied	\N	\N	\N	\N	199444	199444	366608
26509	42148	84	applied	\N	\N	\N	\N	199446	199446	366610
26509	42152	85	applied	\N	\N	\N	\N	199447	199447	366611
26509	42159	86	applied	\N	\N	\N	\N	199448	199448	366612
26509	42160	87	applied	\N	\N	\N	\N	199449	199449	366613
26509	42162	88	applied	\N	\N	\N	\N	199450	199450	366614
26509	42166	89	applied	\N	\N	\N	\N	199451	199451	366615
26509	42174	90	applied	\N	\N	\N	\N	199452	199452	366616
26509	42175	91	applied	\N	\N	\N	\N	199453	199453	366617
26509	42176	92	applied	\N	\N	\N	\N	199454	199454	366618
26509	42178	93	applied	\N	\N	\N	\N	199455	199455	366619
26509	42184	94	applied	\N	\N	\N	\N	199456	199456	366620
26509	42185	95	applied	\N	\N	\N	\N	199457	199457	366621
26509	42189	97	applied	\N	\N	\N	\N	199458	199458	366622
26509	42195	98	applied	\N	\N	\N	\N	199459	199459	366623
26509	42196	99	applied	\N	\N	\N	\N	199460	199460	366624
26509	42199	100	applied	\N	\N	\N	\N	199461	199461	366625
26509	42205	102	applied	\N	\N	\N	\N	199463	199463	366627
26509	42208	103	applied	\N	\N	\N	\N	199464	199464	366628
26509	42211	104	applied	\N	\N	\N	\N	199465	199465	366629
26510	42213	0	applied	\N	\N	\N	\N	199466	199466	366630
26510	42214	1	applied	\N	\N	\N	\N	199467	199467	366631
26510	42215	2	applied	\N	\N	\N	\N	199468	199468	366632
26510	42216	3	applied	\N	\N	\N	\N	199469	199469	366633
26510	42217	4	applied	\N	\N	\N	\N	199470	199470	366634
26510	42218	6	applied	\N	\N	\N	\N	199471	199471	366635
26510	42219	7	applied	\N	\N	\N	\N	199472	199472	366636
26510	42220	8	applied	\N	\N	\N	\N	199473	199473	366637
26564	42132	14	applied	\N	\N	\N	\N	199719	199719	366880
26564	42136	15	applied	\N	\N	\N	\N	199720	199720	366881
26564	42141	16	applied	\N	\N	\N	\N	199721	199721	366882
26564	42144	17	applied	\N	\N	\N	\N	199722	199722	366883
26564	42147	18	applied	\N	\N	\N	\N	199723	199723	366884
26564	42154	20	applied	\N	\N	\N	\N	199725	199725	366886
26564	42155	21	applied	\N	\N	\N	\N	199726	199726	366887
26564	42161	22	applied	\N	\N	\N	\N	199727	199727	366888
26564	42164	23	applied	\N	\N	\N	\N	199728	199728	366889
26564	42167	24	applied	\N	\N	\N	\N	199729	199729	366890
26564	42168	25	applied	\N	\N	\N	\N	199730	199730	366891
26564	42170	26	applied	\N	\N	\N	\N	199731	199731	366892
26564	42177	27	applied	\N	\N	\N	\N	199732	199732	366893
26564	42180	28	applied	\N	\N	\N	\N	199733	199733	366894
26564	42181	29	applied	\N	\N	\N	\N	199734	199734	366895
26564	42187	30	applied	\N	\N	\N	\N	199735	199735	366896
26564	42190	31	applied	\N	\N	\N	\N	199736	199736	366897
26564	42191	32	applied	\N	\N	\N	\N	199737	199737	366898
26564	42197	33	applied	\N	\N	\N	\N	199738	199738	366899
26564	42200	34	applied	\N	\N	\N	\N	199739	199739	366900
26564	42203	35	applied	\N	\N	\N	\N	199740	199740	366901
26564	42210	37	applied	\N	\N	\N	\N	199742	199742	366903
26564	42213	38	applied	\N	\N	\N	\N	199743	199743	366904
26564	42214	39	applied	\N	\N	\N	\N	199744	199744	366905
26564	42215	40	applied	\N	\N	\N	\N	199745	199745	366906
26564	42223	41	applied	\N	\N	\N	\N	199746	199746	366907
26564	42227	42	applied	\N	\N	\N	\N	199747	199747	366908
26564	42230	43	applied	\N	\N	\N	\N	199748	199748	366909
26564	42233	44	applied	\N	\N	\N	\N	199749	199749	366910
26564	42236	45	applied	\N	\N	\N	\N	199750	199750	366911
26564	42240	46	applied	\N	\N	\N	\N	199751	199751	366912
26564	42243	47	applied	\N	\N	\N	\N	199752	199752	366913
26564	42246	48	applied	\N	\N	\N	\N	199753	199753	366914
26564	42250	49	applied	\N	\N	\N	\N	199754	199754	366915
26564	42253	50	applied	\N	\N	\N	\N	199755	199755	366916
26564	42256	51	applied	\N	\N	\N	\N	199756	199756	366917
26564	42260	52	applied	\N	\N	\N	\N	199757	199757	366918
26564	42262	54	applied	\N	\N	\N	\N	199759	199759	366920
26564	42269	55	applied	\N	\N	\N	\N	199760	199760	366921
26564	42270	56	applied	\N	\N	\N	\N	199761	199761	366922
26564	42276	57	applied	\N	\N	\N	\N	199762	199762	366923
26564	42280	58	applied	\N	\N	\N	\N	199763	199763	366924
26564	42281	59	applied	\N	\N	\N	\N	199764	199764	366925
26564	42289	60	applied	\N	\N	\N	\N	199765	199765	366926
26564	42290	61	applied	\N	\N	\N	\N	199766	199766	366927
26564	42298	62	applied	\N	\N	\N	\N	199767	199767	366928
26564	42299	63	applied	\N	\N	\N	\N	199768	199768	366929
26564	42300	64	applied	\N	\N	\N	\N	199769	199769	366930
26564	42308	65	applied	\N	\N	\N	\N	199770	199770	366931
26564	42311	66	applied	\N	\N	\N	\N	199771	199771	366932
26564	42313	67	applied	\N	\N	\N	\N	199772	199772	366933
26509	42019	47	applied	\N	\N	\N	\N	199409	199409	366573
26509	42020	48	applied	\N	\N	\N	\N	199410	199410	366574
26512	42225	2	applied	\N	\N	\N	\N	199488	199488	366652
26512	42226	3	applied	\N	\N	\N	\N	199489	199489	366653
26515	42230	0	applied	\N	\N	\N	\N	199500	199500	366664
26515	42231	1	applied	\N	\N	\N	\N	199501	199501	366665
26515	42232	2	applied	\N	\N	\N	\N	199502	199502	366666
26518	42233	0	applied	\N	\N	\N	\N	199509	199509	366673
26518	42234	1	applied	\N	\N	\N	\N	199510	199510	366674
26518	42235	2	applied	\N	\N	\N	\N	199511	199511	366675
26519	42236	0	applied	\N	\N	\N	\N	199512	199512	366676
26519	42237	1	applied	\N	\N	\N	\N	199513	199513	366677
26519	42238	2	applied	\N	\N	\N	\N	199514	199514	366678
26519	42239	3	applied	\N	\N	\N	\N	199515	199515	366679
26523	42240	0	applied	\N	\N	\N	\N	199524	199524	366688
26523	42241	1	applied	\N	\N	\N	\N	199525	199525	366689
26523	42242	2	applied	\N	\N	\N	\N	199526	199526	366690
26528	42250	0	applied	\N	\N	\N	\N	199540	199540	366704
26528	42252	2	applied	\N	\N	\N	\N	199542	199542	366706
26534	42260	0	applied	\N	\N	\N	\N	199562	199562	366726
26534	42261	1	applied	\N	\N	\N	\N	199563	199563	366727
26534	42262	2	applied	\N	\N	\N	\N	199564	199564	366728
26534	42263	3	applied	\N	\N	\N	\N	199565	199565	366729
26534	42264	4	applied	\N	\N	\N	\N	199566	199566	366730
26534	42265	5	applied	\N	\N	\N	\N	199567	199567	366731
26534	42266	6	applied	\N	\N	\N	\N	199568	199568	366732
26534	42267	7	applied	\N	\N	\N	\N	199569	199569	366733
26534	42268	8	applied	\N	\N	\N	\N	199570	199570	366734
26541	42289	0	applied	\N	\N	\N	\N	199614	199614	366775
26541	42290	1	applied	\N	\N	\N	\N	199615	199615	366776
26541	42291	2	applied	\N	\N	\N	\N	199616	199616	366777
26541	42292	3	applied	\N	\N	\N	\N	199617	199617	366778
26541	42293	4	applied	\N	\N	\N	\N	199618	199618	366779
26541	42294	5	applied	\N	\N	\N	\N	199619	199619	366780
26544	42296	0	applied	\N	\N	\N	\N	199630	199630	366791
26544	42297	1	applied	\N	\N	\N	\N	199631	199631	366792
26546	42298	0	applied	\N	\N	\N	\N	199634	199634	366795
26546	42299	1	applied	\N	\N	\N	\N	199635	199635	366796
26546	42300	2	applied	\N	\N	\N	\N	199636	199636	366797
26546	42301	3	applied	\N	\N	\N	\N	199637	199637	366798
26546	42302	4	applied	\N	\N	\N	\N	199638	199638	366799
26546	42303	5	applied	\N	\N	\N	\N	199639	199639	366800
26546	42304	6	applied	\N	\N	\N	\N	199640	199640	366801
26546	42305	7	applied	\N	\N	\N	\N	199641	199641	366802
26546	42306	8	applied	\N	\N	\N	\N	199642	199642	366803
26546	42307	9	applied	\N	\N	\N	\N	199643	199643	366804
26551	42317	0	applied	\N	\N	\N	\N	199656	199656	366817
26551	42318	1	applied	\N	\N	\N	\N	199657	199657	366818
26551	42319	2	applied	\N	\N	\N	\N	199658	199658	366819
26554	42327	0	applied	\N	\N	\N	\N	199669	199669	366830
26554	42329	2	applied	\N	\N	\N	\N	199671	199671	366832
26554	42330	3	applied	\N	\N	\N	\N	199672	199672	366833
26554	42331	4	applied	\N	\N	\N	\N	199673	199673	366834
26554	42332	5	applied	\N	\N	\N	\N	199674	199674	366835
26557	42333	0	applied	\N	\N	\N	\N	199681	199681	366842
26557	42334	1	applied	\N	\N	\N	\N	199682	199682	366843
26557	42335	2	applied	\N	\N	\N	\N	199683	199683	366844
26559	42336	0	applied	\N	\N	\N	\N	199688	199688	366849
26559	42337	1	applied	\N	\N	\N	\N	199689	199689	366850
26559	42338	2	applied	\N	\N	\N	\N	199690	199690	366851
26559	42339	3	applied	\N	\N	\N	\N	199691	199691	366852
26561	42340	0	applied	\N	\N	\N	\N	199696	199696	366857
26561	42341	1	applied	\N	\N	\N	\N	199697	199697	366858
26561	42342	2	applied	\N	\N	\N	\N	199698	199698	366859
26563	42343	0	applied	\N	\N	\N	\N	199702	199702	366863
26563	42344	1	applied	\N	\N	\N	\N	199703	199703	366864
26565	42346	0	applied	\N	\N	\N	\N	199830	199830	366991
26565	42347	1	applied	\N	\N	\N	\N	199831	199831	366992
26565	42348	2	applied	\N	\N	\N	\N	199832	199832	366993
26569	42353	0	applied	\N	\N	\N	\N	199843	199843	367004
26569	42354	1	applied	\N	\N	\N	\N	199844	199844	367005
26569	42355	2	applied	\N	\N	\N	\N	199845	199845	367006
26571	42356	0	applied	\N	\N	\N	\N	199853	199853	367014
26571	42357	1	applied	\N	\N	\N	\N	199854	199854	367015
26571	42358	2	applied	\N	\N	\N	\N	199855	199855	367016
26571	42359	3	applied	\N	\N	\N	\N	199856	199856	367017
26571	42360	4	applied	\N	\N	\N	\N	199857	199857	367018
26571	42361	5	applied	\N	\N	\N	\N	199858	199858	367019
26571	42362	6	applied	\N	\N	\N	\N	199859	199859	367020
26573	42363	0	applied	\N	\N	\N	\N	199864	199864	367025
26573	42364	1	applied	\N	\N	\N	\N	199865	199865	367026
26573	42365	2	applied	\N	\N	\N	\N	199866	199866	367027
26578	42382	0	applied	\N	\N	\N	\N	199895	199895	367056
26578	42383	1	applied	\N	\N	\N	\N	199896	199896	367057
26578	42384	2	applied	\N	\N	\N	\N	199897	199897	367058
26578	42385	3	applied	\N	\N	\N	\N	199898	199898	367059
26581	42392	0	applied	\N	\N	\N	\N	199911	199911	367072
26581	42393	1	applied	\N	\N	\N	\N	199912	199912	367073
26581	42394	2	applied	\N	\N	\N	\N	199913	199913	367074
26581	42395	3	applied	\N	\N	\N	\N	199914	199914	367075
26581	42396	4	applied	\N	\N	\N	\N	199915	199915	367076
26581	42397	5	applied	\N	\N	\N	\N	199916	199916	367077
26581	42398	7	applied	\N	\N	\N	\N	199917	199917	367078
26588	42399	0	applied	\N	\N	\N	\N	199959	199959	367120
26588	42400	1	applied	\N	\N	\N	\N	199960	199960	367121
26588	42401	2	applied	\N	\N	\N	\N	199961	199961	367122
26588	42402	3	applied	\N	\N	\N	\N	199962	199962	367123
26588	42403	4	applied	\N	\N	\N	\N	199963	199963	367124
26593	42419	0	applied	\N	\N	\N	\N	199985	199985	367146
26593	42420	1	applied	\N	\N	\N	\N	199986	199986	367147
26593	42421	2	applied	\N	\N	\N	\N	199987	199987	367148
26593	42422	3	applied	\N	\N	\N	\N	199988	199988	367149
26599	42425	0	applied	\N	\N	\N	\N	200019	200019	367180
26599	42426	1	applied	\N	\N	\N	\N	200020	200020	367181
26599	42427	2	applied	\N	\N	\N	\N	200021	200021	367182
26599	42428	3	applied	\N	\N	\N	\N	200022	200022	367183
26602	42429	0	applied	\N	\N	\N	\N	200032	200032	367193
26602	42430	1	applied	\N	\N	\N	\N	200033	200033	367194
26602	42431	2	applied	\N	\N	\N	\N	200034	200034	367195
26602	42432	3	applied	\N	\N	\N	\N	200035	200035	367196
26602	42433	4	applied	\N	\N	\N	\N	200036	200036	367197
26605	42447	0	applied	\N	\N	\N	\N	200050	200050	367211
26510	42222	10	applied	\N	\N	\N	\N	199475	199475	366639
26512	42223	0	applied	\N	\N	\N	\N	199486	199486	366650
26566	42351	2	applied	\N	\N	\N	\N	199835	199835	366996
26566	42352	3	applied	\N	\N	\N	\N	199836	199836	366997
26576	42370	0	applied	\N	\N	\N	\N	199871	199871	367032
26576	42371	1	applied	\N	\N	\N	\N	199872	199872	367033
26576	42372	2	applied	\N	\N	\N	\N	199873	199873	367034
26576	42374	4	applied	\N	\N	\N	\N	199875	199875	367036
26576	42375	5	applied	\N	\N	\N	\N	199876	199876	367037
26576	42376	6	applied	\N	\N	\N	\N	199877	199877	367038
26576	42377	7	applied	\N	\N	\N	\N	199878	199878	367039
26576	42378	8	applied	\N	\N	\N	\N	199879	199879	367040
26576	42379	9	applied	\N	\N	\N	\N	199880	199880	367041
26576	42380	10	applied	\N	\N	\N	\N	199881	199881	367042
26576	42381	11	applied	\N	\N	\N	\N	199882	199882	367043
26579	42386	0	applied	\N	\N	\N	\N	199899	199899	367060
26579	42387	1	applied	\N	\N	\N	\N	199900	199900	367061
26579	42388	2	applied	\N	\N	\N	\N	199901	199901	367062
26579	42389	3	applied	\N	\N	\N	\N	199902	199902	367063
26579	42390	4	applied	\N	\N	\N	\N	199903	199903	367064
26579	42391	5	applied	\N	\N	\N	\N	199904	199904	367065
26584	42392	0	applied	\N	\N	\N	\N	199932	199932	367093
26584	42393	1	applied	\N	\N	\N	\N	199933	199933	367094
26584	42395	3	applied	\N	\N	\N	\N	199935	199935	367096
26584	42396	4	applied	\N	\N	\N	\N	199936	199936	367097
26584	42397	5	applied	\N	\N	\N	\N	199937	199937	367098
26584	42398	7	applied	\N	\N	\N	\N	199938	199938	367099
26586	42392	0	applied	\N	\N	\N	\N	199946	199946	367107
26586	42393	1	applied	\N	\N	\N	\N	199947	199947	367108
26586	42394	2	applied	\N	\N	\N	\N	199948	199948	367109
26586	42395	3	applied	\N	\N	\N	\N	199949	199949	367110
26586	42396	4	applied	\N	\N	\N	\N	199950	199950	367111
26586	42397	5	applied	\N	\N	\N	\N	199951	199951	367112
26586	42398	7	applied	\N	\N	\N	\N	199952	199952	367113
26590	42405	0	applied	\N	\N	\N	\N	199971	199971	367132
26590	42406	1	applied	\N	\N	\N	\N	199972	199972	367133
26590	42407	2	applied	\N	\N	\N	\N	199973	199973	367134
26590	42408	3	applied	\N	\N	\N	\N	199974	199974	367135
26594	42419	0	applied	\N	\N	\N	\N	199989	199989	367150
26594	42423	2	applied	\N	\N	\N	\N	199991	199991	367152
26594	42421	3	applied	\N	\N	\N	\N	199992	199992	367153
26594	42422	4	applied	\N	\N	\N	\N	199993	199993	367154
26594	42424	5	applied	\N	\N	\N	\N	199994	199994	367155
26597	42419	0	applied	\N	\N	\N	\N	200007	200007	367168
26597	42420	1	applied	\N	\N	\N	\N	200008	200008	367169
26597	42423	2	applied	\N	\N	\N	\N	200009	200009	367170
26597	42421	3	applied	\N	\N	\N	\N	200010	200010	367171
26597	42422	4	applied	\N	\N	\N	\N	200011	200011	367172
26597	42424	5	applied	\N	\N	\N	\N	200012	200012	367173
26600	42425	0	applied	\N	\N	\N	\N	200023	200023	367184
26600	42426	1	applied	\N	\N	\N	\N	200024	200024	367185
26600	42427	2	applied	\N	\N	\N	\N	200025	200025	367186
26600	42428	3	applied	\N	\N	\N	\N	200026	200026	367187
26605	42448	1	applied	\N	\N	\N	\N	200051	200051	367212
26605	42449	2	applied	\N	\N	\N	\N	200052	200052	367213
26607	42451	0	applied	\N	\N	\N	\N	200057	200057	367218
26607	42448	1	applied	\N	\N	\N	\N	200058	200058	367219
26607	42452	2	applied	\N	\N	\N	\N	200059	200059	367220
26608	42453	0	applied	\N	\N	\N	\N	200060	200060	367221
26608	42454	1	applied	\N	\N	\N	\N	200061	200061	367222
26608	42455	2	applied	\N	\N	\N	\N	200062	200062	367223
26611	42453	0	applied	\N	\N	\N	\N	200069	200069	367230
26611	42454	1	applied	\N	\N	\N	\N	200070	200070	367231
26611	42455	2	applied	\N	\N	\N	\N	200071	200071	367232
26612	42456	0	applied	\N	\N	\N	\N	200072	200072	367233
26612	42457	1	applied	\N	\N	\N	\N	200073	200073	367234
26612	42458	2	applied	\N	\N	\N	\N	200074	200074	367235
26612	42459	3	applied	\N	\N	\N	\N	200075	200075	367236
26612	42460	4	applied	\N	\N	\N	\N	200076	200076	367237
26612	42461	5	applied	\N	\N	\N	\N	200077	200077	367238
26616	42464	0	applied	\N	\N	\N	\N	200096	200096	367257
26616	42466	2	applied	\N	\N	\N	\N	200098	200098	367259
26619	42464	0	applied	\N	\N	\N	\N	200120	200120	367281
26619	42465	1	applied	\N	\N	\N	\N	200121	200121	367282
26619	42466	2	applied	\N	\N	\N	\N	200122	200122	367283
26619	42467	3	applied	\N	\N	\N	\N	200123	200123	367284
26619	42468	4	applied	\N	\N	\N	\N	200124	200124	367285
26619	42469	5	applied	\N	\N	\N	\N	200125	200125	367286
26619	42470	6	applied	\N	\N	\N	\N	200126	200126	367287
26619	42471	7	applied	\N	\N	\N	\N	200127	200127	367288
26620	42472	0	applied	\N	\N	\N	\N	200128	200128	367289
26620	42473	1	applied	\N	\N	\N	\N	200129	200129	367290
26620	42474	2	applied	\N	\N	\N	\N	200130	200130	367291
26620	42475	3	applied	\N	\N	\N	\N	200131	200131	367292
26620	42476	4	applied	\N	\N	\N	\N	200132	200132	367293
26620	42477	5	applied	\N	\N	\N	\N	200133	200133	367294
26620	42479	7	applied	\N	\N	\N	\N	200135	200135	367296
26620	42480	8	applied	\N	\N	\N	\N	200136	200136	367297
26620	42481	9	applied	\N	\N	\N	\N	200137	200137	367298
26620	42482	10	applied	\N	\N	\N	\N	200138	200138	367299
26620	42483	11	applied	\N	\N	\N	\N	200139	200139	367300
26620	42484	12	applied	\N	\N	1000000000	\N	200140	200140	367301
26620	42485	13	applied	\N	\N	1000000000	\N	200141	200141	367302
26620	42486	14	applied	\N	\N	1000000000	\N	200142	200142	367303
26620	42487	15	applied	\N	\N	1000000000	\N	200143	200143	367304
26620	42488	16	applied	\N	\N	\N	\N	200144	200144	367305
26620	42489	17	applied	\N	\N	\N	\N	200145	200145	367306
26620	42490	18	applied	\N	\N	\N	\N	200146	200146	367307
26620	42491	19	applied	\N	\N	\N	\N	200147	200147	367308
26620	42492	20	applied	\N	\N	\N	\N	200148	200148	367309
26620	42493	22	applied	\N	\N	\N	\N	200149	200149	367310
26622	42472	0	applied	\N	\N	\N	\N	200172	200172	367333
26622	42473	1	applied	\N	\N	\N	\N	200173	200173	367334
26622	42474	2	applied	\N	\N	\N	\N	200174	200174	367335
26622	42475	3	applied	\N	\N	\N	\N	200175	200175	367336
26622	42477	5	applied	\N	\N	\N	\N	200177	200177	367338
26622	42478	6	applied	\N	\N	1000000000	\N	200178	200178	367339
26622	42479	7	applied	\N	\N	\N	\N	200179	200179	367340
26622	42480	8	applied	\N	\N	\N	\N	200180	200180	367341
26622	42481	9	applied	\N	\N	\N	\N	200181	200181	367342
26622	42482	10	applied	\N	\N	\N	\N	200182	200182	367343
26566	42349	0	applied	\N	\N	\N	\N	199833	199833	366994
26566	42350	1	applied	\N	\N	\N	\N	199834	199834	366995
26564	42328	72	applied	\N	\N	\N	\N	199777	199777	366938
26564	42333	73	applied	\N	\N	\N	\N	199778	199778	366939
26564	42336	74	applied	\N	\N	\N	\N	199779	199779	366940
26564	42340	75	applied	\N	\N	\N	\N	199780	199780	366941
26564	42123	76	applied	\N	\N	1000000000	\N	199781	199781	366942
26564	42126	77	applied	\N	\N	1000000000	\N	199782	199782	366943
26564	42130	78	applied	\N	\N	1000000000	\N	199783	199783	366944
26564	42080	79	applied	\N	\N	\N	\N	199784	199784	366945
26564	42084	80	applied	\N	\N	\N	\N	199785	199785	366946
26564	42085	81	applied	\N	\N	\N	\N	199786	199786	366947
26564	42090	82	applied	\N	\N	\N	\N	199787	199787	366948
26564	42087	83	applied	\N	\N	\N	\N	199788	199788	366949
26564	42099	84	applied	\N	\N	\N	\N	199789	199789	366950
26564	42108	85	applied	\N	\N	\N	\N	199790	199790	366951
26564	42121	86	applied	\N	\N	\N	\N	199791	199791	366952
26564	42149	88	applied	\N	\N	\N	\N	199793	199793	366954
26564	42156	89	applied	\N	\N	\N	\N	199794	199794	366955
26564	42169	90	applied	\N	\N	\N	\N	199795	199795	366956
26564	42186	91	applied	\N	\N	\N	\N	199796	199796	366957
26564	42192	92	applied	\N	\N	\N	\N	199797	199797	366958
26564	42204	93	applied	\N	\N	\N	\N	199798	199798	366959
26564	42219	94	applied	\N	\N	\N	\N	199799	199799	366960
26564	42225	95	applied	\N	\N	\N	\N	199800	199800	366961
26564	42238	96	applied	\N	\N	\N	\N	199801	199801	366962
26564	42247	97	applied	\N	\N	\N	\N	199802	199802	366963
26564	42259	98	applied	\N	\N	\N	\N	199803	199803	366964
26564	42271	99	applied	\N	\N	\N	\N	199804	199804	366965
26564	42288	100	applied	\N	\N	\N	\N	199805	199805	366966
26564	42096	101	applied	\N	\N	\N	\N	199806	199806	366967
26564	42097	102	applied	\N	\N	\N	\N	199807	199807	366968
26564	42100	103	applied	\N	\N	\N	\N	199808	199808	366969
26564	42106	105	applied	\N	\N	\N	\N	199810	199810	366971
26564	42109	107	applied	\N	\N	\N	\N	199811	199811	366972
26564	42114	108	applied	\N	\N	\N	\N	199812	199812	366973
26564	42117	109	applied	\N	\N	\N	\N	199813	199813	366974
26564	42119	110	applied	\N	\N	\N	\N	199814	199814	366975
26564	42127	111	applied	\N	\N	\N	\N	199815	199815	366976
26564	42131	112	applied	\N	\N	\N	\N	199816	199816	366977
26564	42135	113	applied	\N	\N	\N	\N	199817	199817	366978
26564	42140	114	applied	\N	\N	\N	\N	199818	199818	366979
26564	42142	115	applied	\N	\N	\N	\N	199819	199819	366980
26564	42146	116	applied	\N	\N	\N	\N	199820	199820	366981
26564	42148	117	applied	\N	\N	\N	\N	199821	199821	366982
26564	42152	118	applied	\N	\N	\N	\N	199822	199822	366983
26564	42159	119	applied	\N	\N	\N	\N	199823	199823	366984
26564	42160	120	applied	\N	\N	\N	\N	199824	199824	366985
26564	42162	121	applied	\N	\N	\N	\N	199825	199825	366986
26564	42174	123	applied	\N	\N	\N	\N	199827	199827	366988
26564	42175	124	applied	\N	\N	\N	\N	199828	199828	366989
26564	42176	125	applied	\N	\N	\N	\N	199829	199829	366990
26577	42370	0	applied	\N	\N	\N	\N	199883	199883	367044
26577	42371	1	applied	\N	\N	\N	\N	199884	199884	367045
26577	42372	2	applied	\N	\N	\N	\N	199885	199885	367046
26577	42373	3	applied	\N	\N	\N	\N	199886	199886	367047
26577	42374	4	applied	\N	\N	\N	\N	199887	199887	367048
26577	42375	5	applied	\N	\N	\N	\N	199888	199888	367049
26577	42376	6	applied	\N	\N	\N	\N	199889	199889	367050
26577	42377	7	applied	\N	\N	\N	\N	199890	199890	367051
26577	42378	8	applied	\N	\N	\N	\N	199891	199891	367052
26616	42467	3	applied	\N	\N	\N	\N	200099	200099	367260
26616	42468	4	applied	\N	\N	\N	\N	200100	200100	367261
26616	42469	5	applied	\N	\N	\N	\N	200101	200101	367262
26616	42470	6	applied	\N	\N	\N	\N	200102	200102	367263
26621	42472	0	applied	\N	\N	\N	\N	200150	200150	367311
26621	42473	1	applied	\N	\N	\N	\N	200151	200151	367312
26621	42474	2	applied	\N	\N	\N	\N	200152	200152	367313
26621	42475	3	applied	\N	\N	\N	\N	200153	200153	367314
26621	42476	4	applied	\N	\N	\N	\N	200154	200154	367315
26621	42477	5	applied	\N	\N	\N	\N	200155	200155	367316
26621	42478	6	applied	\N	\N	1000000000	\N	200156	200156	367317
26621	42479	7	applied	\N	\N	\N	\N	200157	200157	367318
26621	42480	8	applied	\N	\N	\N	\N	200158	200158	367319
26621	42481	9	applied	\N	\N	\N	\N	200159	200159	367320
26621	42482	10	applied	\N	\N	\N	\N	200160	200160	367321
26621	42483	11	applied	\N	\N	\N	\N	200161	200161	367322
26621	42484	12	applied	\N	\N	1000000000	\N	200162	200162	367323
26621	42485	13	applied	\N	\N	1000000000	\N	200163	200163	367324
26621	42487	15	applied	\N	\N	1000000000	\N	200165	200165	367326
26621	42488	16	applied	\N	\N	\N	\N	200166	200166	367327
26621	42489	17	applied	\N	\N	\N	\N	200167	200167	367328
26621	42490	18	applied	\N	\N	\N	\N	200168	200168	367329
26621	42491	19	applied	\N	\N	\N	\N	200169	200169	367330
26621	42492	20	applied	\N	\N	\N	\N	200170	200170	367331
26621	42493	22	applied	\N	\N	\N	\N	200171	200171	367332
26623	42494	0	applied	\N	\N	\N	\N	200194	200194	367355
26623	42495	1	applied	\N	\N	\N	\N	200195	200195	367356
26623	42496	2	applied	\N	\N	\N	\N	200196	200196	367357
26625	42497	0	applied	\N	\N	\N	\N	200200	200200	367361
26625	42498	1	applied	\N	\N	\N	\N	200201	200201	367362
26625	42499	2	applied	\N	\N	\N	\N	200202	200202	367363
26629	42503	0	applied	\N	\N	\N	\N	200220	200220	367381
26629	42504	1	applied	\N	\N	\N	\N	200221	200221	367382
26629	42505	2	applied	\N	\N	\N	\N	200222	200222	367383
26629	42506	3	applied	\N	\N	\N	\N	200223	200223	367384
26629	42507	4	applied	\N	\N	\N	\N	200224	200224	367385
26629	42508	5	applied	\N	\N	\N	\N	200225	200225	367386
26629	42509	6	applied	\N	\N	\N	\N	200226	200226	367387
26630	42511	1	applied	\N	\N	1000000000	\N	200228	200228	367389
26630	42512	2	applied	\N	\N	\N	\N	200229	200229	367390
26630	42513	3	applied	\N	\N	\N	\N	200230	200230	367391
26635	42523	0	applied	\N	\N	\N	\N	200244	200244	367405
26635	42524	1	applied	\N	\N	\N	\N	200245	200245	367406
26635	42525	2	applied	\N	\N	\N	\N	200246	200246	367407
26635	42526	3	applied	\N	\N	\N	\N	200247	200247	367408
26638	42523	0	applied	\N	\N	\N	\N	200256	200256	367417
26638	42524	1	applied	\N	\N	\N	\N	200257	200257	367418
26638	42525	2	applied	\N	\N	\N	\N	200258	200258	367419
26638	42526	3	applied	\N	\N	\N	\N	200259	200259	367420
26640	42527	0	applied	\N	\N	\N	\N	200269	200269	367430
26564	42320	69	applied	\N	\N	\N	\N	199774	199774	366935
26564	42327	71	applied	\N	\N	\N	\N	199776	199776	366937
26582	42393	1	applied	\N	\N	\N	\N	199919	199919	367080
26582	42394	2	applied	\N	\N	\N	\N	199920	199920	367081
26582	42395	3	applied	\N	\N	\N	\N	199921	199921	367082
26582	42396	4	applied	\N	\N	\N	\N	199922	199922	367083
26582	42397	5	applied	\N	\N	\N	\N	199923	199923	367084
26582	42398	7	applied	\N	\N	\N	\N	199924	199924	367085
26587	42400	1	applied	\N	\N	\N	\N	199954	199954	367115
26587	42401	2	applied	\N	\N	\N	\N	199955	199955	367116
26587	42402	3	applied	\N	\N	\N	\N	199956	199956	367117
26587	42403	4	applied	\N	\N	\N	\N	199957	199957	367118
26587	42404	5	applied	\N	\N	\N	\N	199958	199958	367119
26589	42399	0	applied	\N	\N	\N	\N	199965	199965	367126
26589	42400	1	applied	\N	\N	\N	\N	199966	199966	367127
26589	42401	2	applied	\N	\N	\N	\N	199967	199967	367128
26589	42402	3	applied	\N	\N	\N	\N	199968	199968	367129
26589	42403	4	applied	\N	\N	\N	\N	199969	199969	367130
26591	42409	0	applied	\N	\N	\N	\N	199975	199975	367136
26591	42410	1	applied	\N	\N	\N	\N	199976	199976	367137
26591	42411	2	applied	\N	\N	\N	\N	199977	199977	367138
26591	42412	3	applied	\N	\N	\N	\N	199978	199978	367139
26591	42413	4	applied	\N	\N	\N	\N	199979	199979	367140
26591	42414	5	applied	\N	\N	\N	\N	199980	199980	367141
26592	42415	0	applied	\N	\N	\N	\N	199981	199981	367142
26592	42416	1	applied	\N	\N	\N	\N	199982	199982	367143
26592	42417	2	applied	\N	\N	\N	\N	199983	199983	367144
26592	42418	3	applied	\N	\N	\N	\N	199984	199984	367145
26595	42419	0	applied	\N	\N	\N	\N	199995	199995	367156
26595	42420	1	applied	\N	\N	\N	\N	199996	199996	367157
26595	42423	2	applied	\N	\N	\N	\N	199997	199997	367158
26595	42421	3	applied	\N	\N	\N	\N	199998	199998	367159
26595	42422	4	applied	\N	\N	\N	\N	199999	199999	367160
26595	42424	5	applied	\N	\N	\N	\N	200000	200000	367161
26596	42420	1	applied	\N	\N	\N	\N	200002	200002	367163
26596	42423	2	applied	\N	\N	\N	\N	200003	200003	367164
26596	42421	3	applied	\N	\N	\N	\N	200004	200004	367165
26596	42422	4	applied	\N	\N	\N	\N	200005	200005	367166
26596	42424	5	applied	\N	\N	\N	\N	200006	200006	367167
26598	42419	0	applied	\N	\N	\N	\N	200013	200013	367174
26598	42420	1	applied	\N	\N	\N	\N	200014	200014	367175
26598	42423	2	applied	\N	\N	\N	\N	200015	200015	367176
26598	42421	3	applied	\N	\N	\N	\N	200016	200016	367177
26598	42422	4	applied	\N	\N	\N	\N	200017	200017	367178
26598	42424	5	applied	\N	\N	\N	\N	200018	200018	367179
26601	42429	0	applied	\N	\N	\N	\N	200027	200027	367188
26601	42430	1	applied	\N	\N	\N	\N	200028	200028	367189
26601	42431	2	applied	\N	\N	\N	\N	200029	200029	367190
26601	42432	3	applied	\N	\N	\N	\N	200030	200030	367191
26601	42433	4	applied	\N	\N	\N	\N	200031	200031	367192
26603	42435	1	applied	\N	\N	\N	\N	200038	200038	367199
26603	42436	2	applied	\N	\N	\N	\N	200039	200039	367200
26604	42437	0	applied	\N	\N	\N	\N	200040	200040	367201
26604	42438	1	applied	\N	\N	\N	\N	200041	200041	367202
26604	42439	2	applied	\N	\N	\N	\N	200042	200042	367203
26604	42440	3	applied	\N	\N	\N	\N	200043	200043	367204
26604	42441	4	applied	\N	\N	\N	\N	200044	200044	367205
26604	42442	5	applied	\N	\N	\N	\N	200045	200045	367206
26604	42443	6	applied	\N	\N	\N	\N	200046	200046	367207
26604	42444	7	applied	\N	\N	\N	\N	200047	200047	367208
26604	42445	8	applied	\N	\N	\N	\N	200048	200048	367209
26604	42446	9	applied	\N	\N	\N	\N	200049	200049	367210
26606	42447	0	applied	\N	\N	\N	\N	200054	200054	367215
26606	42449	1	applied	\N	\N	\N	\N	200055	200055	367216
26606	42450	2	applied	\N	\N	\N	\N	200056	200056	367217
26609	42453	0	applied	\N	\N	\N	\N	200063	200063	367224
26609	42455	2	applied	\N	\N	\N	\N	200065	200065	367226
26610	42453	0	applied	\N	\N	\N	\N	200066	200066	367227
26610	42454	1	applied	\N	\N	\N	\N	200067	200067	367228
26610	42455	2	applied	\N	\N	\N	\N	200068	200068	367229
26613	42462	0	applied	\N	\N	\N	\N	200078	200078	367239
26613	42463	1	applied	\N	\N	\N	\N	200079	200079	367240
26614	42464	0	applied	\N	\N	\N	\N	200080	200080	367241
26614	42465	1	applied	\N	\N	\N	\N	200081	200081	367242
26614	42466	2	applied	\N	\N	\N	\N	200082	200082	367243
26614	42467	3	applied	\N	\N	\N	\N	200083	200083	367244
26614	42468	4	applied	\N	\N	\N	\N	200084	200084	367245
26614	42469	5	applied	\N	\N	\N	\N	200085	200085	367246
26614	42470	6	applied	\N	\N	\N	\N	200086	200086	367247
26614	42471	7	applied	\N	\N	\N	\N	200087	200087	367248
26615	42464	0	applied	\N	\N	\N	\N	200088	200088	367249
26615	42465	1	applied	\N	\N	\N	\N	200089	200089	367250
26615	42467	3	applied	\N	\N	\N	\N	200091	200091	367252
26615	42468	4	applied	\N	\N	\N	\N	200092	200092	367253
26615	42469	5	applied	\N	\N	\N	\N	200093	200093	367254
26615	42470	6	applied	\N	\N	\N	\N	200094	200094	367255
26615	42471	7	applied	\N	\N	\N	\N	200095	200095	367256
26617	42464	0	applied	\N	\N	\N	\N	200104	200104	367265
26617	42465	1	applied	\N	\N	\N	\N	200105	200105	367266
26617	42466	2	applied	\N	\N	\N	\N	200106	200106	367267
26617	42467	3	applied	\N	\N	\N	\N	200107	200107	367268
26617	42468	4	applied	\N	\N	\N	\N	200108	200108	367269
26617	42469	5	applied	\N	\N	\N	\N	200109	200109	367270
26618	42464	0	applied	\N	\N	\N	\N	200112	200112	367273
26618	42465	1	applied	\N	\N	\N	\N	200113	200113	367274
26618	42466	2	applied	\N	\N	\N	\N	200114	200114	367275
26618	42467	3	applied	\N	\N	\N	\N	200115	200115	367276
26618	42468	4	applied	\N	\N	\N	\N	200116	200116	367277
26618	42470	6	applied	\N	\N	\N	\N	200118	200118	367279
26618	42471	7	applied	\N	\N	\N	\N	200119	200119	367280
26624	42494	0	applied	\N	\N	\N	\N	200197	200197	367358
26624	42495	1	applied	\N	\N	\N	\N	200198	200198	367359
26624	42496	2	applied	\N	\N	\N	\N	200199	200199	367360
26627	42503	0	applied	\N	\N	\N	\N	200206	200206	367367
26627	42504	1	applied	\N	\N	\N	\N	200207	200207	367368
26627	42505	2	applied	\N	\N	\N	\N	200208	200208	367369
26627	42506	3	applied	\N	\N	\N	\N	200209	200209	367370
26627	42507	4	applied	\N	\N	\N	\N	200210	200210	367371
26627	42508	5	applied	\N	\N	\N	\N	200211	200211	367372
26627	42509	6	applied	\N	\N	\N	\N	200212	200212	367373
26632	42514	0	applied	\N	\N	\N	\N	200235	200235	367396
26632	42515	1	applied	\N	\N	\N	\N	200236	200236	367397
26577	42380	10	applied	\N	\N	\N	\N	199893	199893	367054
26577	42381	11	applied	\N	\N	\N	\N	199894	199894	367055
26626	42502	2	applied	\N	\N	\N	\N	200205	200205	367366
26631	42514	0	applied	\N	\N	\N	\N	200231	200231	367392
26631	42515	1	applied	\N	\N	\N	\N	200232	200232	367393
26631	42516	2	applied	\N	\N	\N	\N	200233	200233	367394
26631	42517	3	applied	\N	\N	\N	\N	200234	200234	367395
26632	42516	2	applied	\N	\N	\N	\N	200237	200237	367398
26632	42517	3	applied	\N	\N	\N	\N	200238	200238	367399
26633	42518	0	applied	\N	\N	\N	\N	200239	200239	367400
26633	42519	1	applied	\N	\N	\N	\N	200240	200240	367401
26633	42520	2	applied	\N	\N	\N	\N	200241	200241	367402
26634	42521	0	applied	\N	\N	\N	\N	200242	200242	367403
26634	42522	1	applied	\N	\N	\N	\N	200243	200243	367404
26636	42523	0	applied	\N	\N	\N	\N	200248	200248	367409
26636	42524	1	applied	\N	\N	\N	\N	200249	200249	367410
26636	42525	2	applied	\N	\N	\N	\N	200250	200250	367411
26636	42526	3	applied	\N	\N	\N	\N	200251	200251	367412
26639	42528	1	applied	\N	\N	\N	\N	200261	200261	367422
26639	42529	2	applied	\N	\N	\N	\N	200262	200262	367423
26639	42530	3	applied	\N	\N	\N	\N	200263	200263	367424
26639	42531	4	applied	\N	\N	\N	\N	200264	200264	367425
26639	42532	5	applied	\N	\N	\N	\N	200265	200265	367426
26639	42533	6	applied	\N	\N	\N	\N	200266	200266	367427
26639	42534	7	applied	\N	\N	\N	\N	200267	200267	367428
26639	42535	8	applied	\N	\N	\N	\N	200268	200268	367429
26641	42527	0	applied	\N	\N	\N	\N	200278	200278	367439
26641	42528	1	applied	\N	\N	\N	\N	200279	200279	367440
26641	42529	2	applied	\N	\N	\N	\N	200280	200280	367441
26641	42530	3	applied	\N	\N	\N	\N	200281	200281	367442
26641	42531	4	applied	\N	\N	\N	\N	200282	200282	367443
26641	42532	5	applied	\N	\N	\N	\N	200283	200283	367444
26641	42533	6	applied	\N	\N	\N	\N	200284	200284	367445
26641	42534	7	applied	\N	\N	\N	\N	200285	200285	367446
26642	42527	0	applied	\N	\N	\N	\N	200287	200287	367448
26642	42528	1	applied	\N	\N	\N	\N	200288	200288	367449
26642	42529	2	applied	\N	\N	\N	\N	200289	200289	367450
26642	42530	3	applied	\N	\N	\N	\N	200290	200290	367451
26642	42531	4	applied	\N	\N	\N	\N	200291	200291	367452
26642	42532	5	applied	\N	\N	\N	\N	200292	200292	367453
26642	42533	6	applied	\N	\N	\N	\N	200293	200293	367454
26642	42534	7	applied	\N	\N	\N	\N	200294	200294	367455
26642	42535	8	applied	\N	\N	\N	\N	200295	200295	367456
26643	42536	0	applied	\N	\N	\N	\N	200296	200296	367457
26643	42537	1	applied	\N	\N	\N	\N	200297	200297	367458
26643	42538	2	applied	\N	\N	\N	\N	200298	200298	367459
26643	42539	3	applied	\N	\N	\N	\N	200299	200299	367460
26646	42542	0	applied	\N	\N	\N	\N	200312	200312	367473
26646	42543	1	applied	\N	\N	\N	\N	200313	200313	367474
26646	42544	2	applied	\N	\N	\N	\N	200314	200314	367475
26648	42546	0	applied	\N	\N	\N	\N	200320	200320	367481
26648	42547	1	applied	\N	\N	\N	\N	200321	200321	367482
26648	42548	2	applied	\N	\N	\N	\N	200322	200322	367483
26648	42549	3	applied	\N	\N	\N	\N	200323	200323	367484
26650	42550	0	applied	\N	\N	\N	\N	200328	200328	367489
26650	42551	1	applied	\N	\N	\N	\N	200329	200329	367490
26650	42552	2	applied	\N	\N	\N	\N	200330	200330	367491
26652	42553	0	applied	\N	\N	\N	\N	200456	200456	367617
26652	42554	1	applied	\N	\N	\N	\N	200457	200457	367618
26652	42555	2	applied	\N	\N	\N	\N	200458	200458	367619
26653	42553	0	applied	\N	\N	\N	\N	200459	200459	367620
26653	42554	1	applied	\N	\N	\N	\N	200460	200460	367621
26653	42555	2	applied	\N	\N	\N	\N	200461	200461	367622
26657	42560	0	applied	\N	\N	\N	\N	200473	200473	367634
26657	42561	1	applied	\N	\N	\N	\N	200474	200474	367635
26657	42562	2	applied	\N	\N	\N	\N	200475	200475	367636
26659	42564	1	applied	\N	\N	\N	\N	200480	200480	367641
26662	42566	0	applied	\N	\N	\N	\N	200497	200497	367658
26662	42567	1	applied	\N	\N	\N	\N	200498	200498	367659
26662	42568	2	applied	\N	\N	\N	\N	200499	200499	367660
26662	42565	3	applied	\N	\N	\N	\N	200500	200500	367661
26662	42569	4	applied	\N	\N	\N	\N	200501	200501	367662
26662	42570	5	applied	\N	\N	\N	\N	200502	200502	367663
26662	42571	6	applied	\N	\N	\N	\N	200503	200503	367664
26662	42572	7	applied	\N	\N	\N	\N	200504	200504	367665
26664	42573	0	applied	\N	\N	\N	\N	200508	200508	367669
26664	42574	1	applied	\N	\N	\N	\N	200509	200509	367670
26664	42575	2	applied	\N	\N	\N	\N	200510	200510	367671
26667	42576	0	applied	\N	\N	\N	\N	200525	200525	367686
26667	42577	1	applied	\N	\N	\N	\N	200526	200526	367687
26667	42578	3	applied	\N	\N	\N	\N	200527	200527	367688
26667	42579	4	applied	\N	\N	\N	\N	200528	200528	367689
26667	42581	6	applied	\N	\N	\N	\N	200530	200530	367691
26667	42582	7	applied	\N	\N	\N	\N	200531	200531	367692
26669	42576	0	applied	\N	\N	\N	\N	200539	200539	367700
26669	42577	1	applied	\N	\N	\N	\N	200540	200540	367701
26669	42578	3	applied	\N	\N	\N	\N	200541	200541	367702
26669	42579	4	applied	\N	\N	\N	\N	200542	200542	367703
26669	42580	5	applied	\N	\N	\N	\N	200543	200543	367704
26669	42581	6	applied	\N	\N	\N	\N	200544	200544	367705
26669	42582	7	applied	\N	\N	\N	\N	200545	200545	367706
26670	42576	0	applied	\N	\N	\N	\N	200546	200546	367707
26670	42577	1	applied	\N	\N	\N	\N	200547	200547	367708
26670	42578	3	applied	\N	\N	\N	\N	200548	200548	367709
26670	42579	4	applied	\N	\N	\N	\N	200549	200549	367710
26677	42596	0	applied	\N	\N	\N	\N	200574	200574	367735
26677	42597	1	applied	\N	\N	\N	\N	200575	200575	367736
26677	42598	2	applied	\N	\N	\N	\N	200576	200576	367737
26680	42603	1	applied	\N	\N	\N	\N	200584	200584	367745
26680	42604	2	applied	\N	\N	\N	\N	200585	200585	367746
26680	42605	3	applied	\N	\N	\N	\N	200586	200586	367747
26680	42606	4	applied	\N	\N	\N	\N	200587	200587	367748
26680	42607	5	applied	\N	\N	\N	\N	200588	200588	367749
26680	42608	6	applied	\N	\N	\N	\N	200589	200589	367750
26683	42609	0	applied	\N	\N	\N	\N	200605	200605	367766
26683	42610	1	applied	\N	\N	\N	\N	200606	200606	367767
26683	42611	2	applied	\N	\N	\N	\N	200607	200607	367768
26683	42612	3	applied	\N	\N	\N	\N	200608	200608	367769
26683	42613	4	applied	\N	\N	\N	\N	200609	200609	367770
26683	42614	5	applied	\N	\N	\N	\N	200610	200610	367771
26683	42615	6	applied	\N	\N	\N	\N	200611	200611	367772
26683	42616	7	applied	\N	\N	\N	\N	200612	200612	367773
26617	42471	7	applied	\N	\N	\N	\N	200111	200111	367272
26626	42500	0	applied	\N	\N	\N	\N	200203	200203	367364
26622	42486	14	applied	\N	\N	1000000000	\N	200186	200186	367347
26622	42487	15	applied	\N	\N	1000000000	\N	200187	200187	367348
26622	42488	16	applied	\N	\N	\N	\N	200188	200188	367349
26622	42489	17	applied	\N	\N	\N	\N	200189	200189	367350
26622	42490	18	applied	\N	\N	\N	\N	200190	200190	367351
26622	42492	20	applied	\N	\N	\N	\N	200192	200192	367353
26622	42493	22	applied	\N	\N	\N	\N	200193	200193	367354
26628	42503	0	applied	\N	\N	\N	\N	200213	200213	367374
26628	42504	1	applied	\N	\N	\N	\N	200214	200214	367375
26628	42505	2	applied	\N	\N	\N	\N	200215	200215	367376
26628	42506	3	applied	\N	\N	\N	\N	200216	200216	367377
26628	42507	4	applied	\N	\N	\N	\N	200217	200217	367378
26628	42508	5	applied	\N	\N	\N	\N	200218	200218	367379
26628	42509	6	applied	\N	\N	\N	\N	200219	200219	367380
26637	42523	0	applied	\N	\N	\N	\N	200252	200252	367413
26637	42524	1	applied	\N	\N	\N	\N	200253	200253	367414
26637	42525	2	applied	\N	\N	\N	\N	200254	200254	367415
26637	42526	3	applied	\N	\N	\N	\N	200255	200255	367416
26644	42540	0	applied	\N	\N	\N	\N	200300	200300	367461
26644	42541	1	applied	\N	\N	\N	\N	200301	200301	367462
26644	42542	2	applied	\N	\N	\N	\N	200302	200302	367463
26644	42544	4	applied	\N	\N	\N	\N	200304	200304	367465
26644	42545	5	applied	\N	\N	\N	\N	200305	200305	367466
26651	42343	0	applied	\N	\N	\N	\N	200331	200331	367492
26651	42346	1	applied	\N	\N	\N	\N	200332	200332	367493
26651	42349	2	applied	\N	\N	\N	\N	200333	200333	367494
26651	42353	3	applied	\N	\N	\N	\N	200334	200334	367495
26651	42356	4	applied	\N	\N	\N	\N	200335	200335	367496
26651	42357	5	applied	\N	\N	\N	\N	200336	200336	367497
26651	42363	6	applied	\N	\N	\N	\N	200337	200337	367498
26651	42367	7	applied	\N	\N	\N	\N	200338	200338	367499
26651	42370	8	applied	\N	\N	\N	\N	200339	200339	367500
26651	42371	9	applied	\N	\N	\N	\N	200340	200340	367501
26651	42372	10	applied	\N	\N	\N	\N	200341	200341	367502
26651	42382	11	applied	\N	\N	\N	\N	200342	200342	367503
26651	42386	12	applied	\N	\N	\N	\N	200343	200343	367504
26651	42387	13	applied	\N	\N	\N	\N	200344	200344	367505
26651	42393	15	applied	\N	\N	\N	\N	200346	200346	367507
26651	42399	16	applied	\N	\N	\N	\N	200347	200347	367508
26651	42400	17	applied	\N	\N	\N	\N	200348	200348	367509
26651	42405	18	applied	\N	\N	\N	\N	200349	200349	367510
26651	42409	19	applied	\N	\N	\N	\N	200350	200350	367511
26651	42410	20	applied	\N	\N	\N	\N	200351	200351	367512
26651	42415	21	applied	\N	\N	\N	\N	200352	200352	367513
26651	42419	22	applied	\N	\N	\N	\N	200353	200353	367514
26651	42420	23	applied	\N	\N	\N	\N	200354	200354	367515
26651	42425	24	applied	\N	\N	\N	\N	200355	200355	367516
26651	42429	25	applied	\N	\N	\N	\N	200356	200356	367517
26651	42434	26	applied	\N	\N	\N	\N	200357	200357	367518
26651	42437	27	applied	\N	\N	\N	\N	200358	200358	367519
26651	42438	28	applied	\N	\N	\N	\N	200359	200359	367520
26651	42439	29	applied	\N	\N	\N	\N	200360	200360	367521
26651	42447	30	applied	\N	\N	\N	\N	200361	200361	367522
26651	42453	32	applied	\N	\N	\N	\N	200363	200363	367524
26651	42456	33	applied	\N	\N	\N	\N	200364	200364	367525
26651	42464	34	applied	\N	\N	\N	\N	200365	200365	367526
26651	42472	35	applied	\N	\N	\N	\N	200366	200366	367527
26651	42473	36	applied	\N	\N	\N	\N	200367	200367	367528
26651	42474	37	applied	\N	\N	\N	\N	200368	200368	367529
26651	42475	38	applied	\N	\N	\N	\N	200369	200369	367530
26683	42617	8	applied	\N	\N	\N	\N	200613	200613	367774
26685	42618	0	applied	\N	\N	\N	\N	200614	200614	367775
26685	42619	1	applied	\N	\N	\N	\N	200615	200615	367776
26685	42620	2	applied	\N	\N	\N	\N	200616	200616	367777
26685	42621	3	applied	\N	\N	\N	\N	200617	200617	367778
26685	42622	4	applied	\N	\N	\N	\N	200618	200618	367779
26685	42623	5	applied	\N	\N	1000000000	\N	200619	200619	367780
26685	42624	6	applied	\N	\N	\N	\N	200620	200620	367781
26685	42625	7	applied	\N	\N	\N	\N	200621	200621	367782
26687	42619	1	applied	\N	\N	\N	\N	200631	200631	367792
26687	42620	2	applied	\N	\N	\N	\N	200632	200632	367793
26687	42621	3	applied	\N	\N	\N	\N	200633	200633	367794
26687	42622	4	applied	\N	\N	\N	\N	200634	200634	367795
26687	42623	5	applied	\N	\N	1000000000	\N	200635	200635	367796
26687	42624	6	applied	\N	\N	\N	\N	200636	200636	367797
26687	42625	7	applied	\N	\N	\N	\N	200637	200637	367798
26690	42629	0	applied	\N	\N	\N	\N	200641	200641	367802
26690	42630	1	applied	\N	\N	\N	\N	200642	200642	367803
26690	42631	2	applied	\N	\N	\N	\N	200643	200643	367804
26690	42632	3	applied	\N	\N	\N	\N	200644	200644	367805
26690	42633	4	applied	\N	\N	\N	\N	200645	200645	367806
26690	42634	5	applied	\N	\N	\N	\N	200646	200646	367807
26690	42635	6	applied	\N	\N	\N	\N	200647	200647	367808
26690	42636	7	applied	\N	\N	\N	\N	200648	200648	367809
26690	42637	8	applied	\N	\N	\N	\N	200649	200649	367810
26705	42669	0	applied	\N	\N	\N	\N	200714	200714	367875
26705	42670	1	applied	\N	\N	\N	\N	200715	200715	367876
26705	42671	2	applied	\N	\N	\N	\N	200716	200716	367877
26705	42672	3	applied	\N	\N	\N	\N	200717	200717	367878
26705	42673	4	applied	\N	\N	\N	\N	200718	200718	367879
26705	42674	5	applied	\N	\N	\N	\N	200719	200719	367880
26705	42675	6	applied	\N	\N	\N	\N	200720	200720	367881
26705	42676	7	applied	\N	\N	\N	\N	200721	200721	367882
26705	42677	8	applied	\N	\N	\N	\N	200722	200722	367883
26705	42678	9	applied	\N	\N	\N	\N	200723	200723	367884
26705	42679	10	applied	\N	\N	\N	\N	200724	200724	367885
26710	42687	0	applied	\N	\N	\N	\N	200993	200993	368154
26710	42688	1	applied	\N	\N	\N	\N	200994	200994	368155
26710	42689	2	applied	\N	\N	\N	\N	200995	200995	368156
26713	42697	0	applied	\N	\N	\N	\N	201006	201006	368167
26713	42698	1	applied	\N	\N	\N	\N	201007	201007	368168
26713	42700	3	applied	\N	\N	\N	\N	201009	201009	368170
26713	42701	4	applied	\N	\N	\N	\N	201010	201010	368171
26713	42702	5	applied	\N	\N	\N	\N	201011	201011	368172
26715	42703	0	applied	\N	\N	\N	\N	201018	201018	368179
26715	42704	1	applied	\N	\N	\N	\N	201019	201019	368180
26715	42705	2	applied	\N	\N	\N	\N	201020	201020	368181
26715	42706	3	applied	\N	\N	\N	\N	201021	201021	368182
26720	42710	0	applied	\N	\N	\N	\N	201035	201035	368196
26622	42484	12	applied	\N	\N	1000000000	\N	200184	200184	367345
26622	42485	13	applied	\N	\N	1000000000	\N	200185	200185	367346
26640	42531	4	applied	\N	\N	\N	\N	200273	200273	367434
26640	42532	5	applied	\N	\N	\N	\N	200274	200274	367435
26640	42533	6	applied	\N	\N	\N	\N	200275	200275	367436
26640	42534	7	applied	\N	\N	\N	\N	200276	200276	367437
26640	42535	8	applied	\N	\N	\N	\N	200277	200277	367438
26645	42541	1	applied	\N	\N	\N	\N	200307	200307	367468
26645	42542	2	applied	\N	\N	\N	\N	200308	200308	367469
26645	42543	3	applied	\N	\N	\N	\N	200309	200309	367470
26645	42544	4	applied	\N	\N	\N	\N	200310	200310	367471
26645	42545	5	applied	\N	\N	\N	\N	200311	200311	367472
26647	42546	0	applied	\N	\N	\N	\N	200316	200316	367477
26647	42547	1	applied	\N	\N	\N	\N	200317	200317	367478
26647	42548	2	applied	\N	\N	\N	\N	200318	200318	367479
26647	42549	3	applied	\N	\N	\N	\N	200319	200319	367480
26649	42546	0	applied	\N	\N	\N	\N	200324	200324	367485
26649	42547	1	applied	\N	\N	\N	\N	200325	200325	367486
26649	42548	2	applied	\N	\N	\N	\N	200326	200326	367487
26649	42549	3	applied	\N	\N	\N	\N	200327	200327	367488
26651	42476	39	applied	\N	\N	\N	\N	200370	200370	367531
26651	42494	40	applied	\N	\N	\N	\N	200371	200371	367532
26651	42497	41	applied	\N	\N	\N	\N	200372	200372	367533
26651	42503	43	applied	\N	\N	\N	\N	200374	200374	367535
26651	42504	44	applied	\N	\N	\N	\N	200375	200375	367536
26651	42510	45	applied	\N	\N	\N	\N	200376	200376	367537
26651	42514	46	applied	\N	\N	\N	\N	200377	200377	367538
26651	42518	47	applied	\N	\N	\N	\N	200378	200378	367539
26651	42523	48	applied	\N	\N	\N	\N	200379	200379	367540
26651	42527	49	applied	\N	\N	\N	\N	200380	200380	367541
26651	42528	50	applied	\N	\N	\N	\N	200381	200381	367542
26651	42529	51	applied	\N	\N	\N	\N	200382	200382	367543
26651	42536	52	applied	\N	\N	\N	\N	200383	200383	367544
26651	42540	53	applied	\N	\N	\N	\N	200384	200384	367545
26651	42541	54	applied	\N	\N	\N	\N	200385	200385	367546
26651	42546	55	applied	\N	\N	\N	\N	200386	200386	367547
26651	42550	56	applied	\N	\N	\N	\N	200387	200387	367548
26651	42537	58	applied	\N	\N	\N	\N	200389	200389	367550
26651	42364	59	applied	\N	\N	\N	\N	200390	200390	367551
26651	42178	60	applied	\N	\N	\N	\N	200391	200391	367552
26651	42478	61	applied	\N	\N	1000000000	\N	200392	200392	367553
26651	42373	62	applied	\N	\N	\N	\N	200393	200393	367554
26651	42484	63	applied	\N	\N	1000000000	\N	200394	200394	367555
26651	42485	64	applied	\N	\N	1000000000	\N	200395	200395	367556
26651	42486	65	applied	\N	\N	1000000000	\N	200396	200396	367557
26651	42374	66	applied	\N	\N	\N	\N	200397	200397	367558
26651	42487	67	applied	\N	\N	1000000000	\N	200398	200398	367559
26651	42184	68	applied	\N	\N	\N	\N	200399	200399	367560
26651	42185	69	applied	\N	\N	\N	\N	200400	200400	367561
26651	42189	70	applied	\N	\N	\N	\N	200401	200401	367562
26651	42195	71	applied	\N	\N	\N	\N	200402	200402	367563
26651	42196	72	applied	\N	\N	\N	\N	200403	200403	367564
26651	42199	73	applied	\N	\N	\N	\N	200404	200404	367565
26651	42201	74	applied	\N	\N	\N	\N	200405	200405	367566
26651	42205	75	applied	\N	\N	\N	\N	200406	200406	367567
26651	42208	76	applied	\N	\N	\N	\N	200407	200407	367568
26651	42211	77	applied	\N	\N	\N	\N	200408	200408	367569
26651	42218	79	applied	\N	\N	\N	\N	200410	200410	367571
26651	42081	80	applied	\N	\N	\N	\N	200411	200411	367572
26651	42086	81	applied	\N	\N	\N	\N	200412	200412	367573
26651	42088	82	applied	\N	\N	\N	\N	200413	200413	367574
26651	42091	83	applied	\N	\N	\N	\N	200414	200414	367575
26651	42094	84	applied	\N	\N	\N	\N	200415	200415	367576
26651	42095	85	applied	\N	\N	\N	\N	200416	200416	367577
26651	42098	86	applied	\N	\N	\N	\N	200417	200417	367578
26651	42102	87	applied	\N	\N	\N	\N	200418	200418	367579
26651	42110	88	applied	\N	\N	\N	\N	200419	200419	367580
26651	42111	89	applied	\N	\N	\N	\N	200420	200420	367581
26654	42553	0	applied	\N	\N	\N	\N	200462	200462	367623
26654	42554	1	applied	\N	\N	\N	\N	200463	200463	367624
26654	42555	2	applied	\N	\N	\N	\N	200464	200464	367625
26656	42556	0	applied	\N	\N	\N	\N	200469	200469	367630
26656	42557	1	applied	\N	\N	\N	\N	200470	200470	367631
26656	42559	3	applied	\N	\N	\N	\N	200472	200472	367633
26658	42563	0	applied	\N	\N	\N	\N	200476	200476	367637
26658	42564	1	applied	\N	\N	\N	\N	200477	200477	367638
26658	42565	2	applied	\N	\N	\N	\N	200478	200478	367639
26661	42566	0	applied	\N	\N	\N	\N	200489	200489	367650
26661	42567	1	applied	\N	\N	\N	\N	200490	200490	367651
26661	42568	2	applied	\N	\N	\N	\N	200491	200491	367652
26661	42565	3	applied	\N	\N	\N	\N	200492	200492	367653
26661	42569	4	applied	\N	\N	\N	\N	200493	200493	367654
26661	42570	5	applied	\N	\N	\N	\N	200494	200494	367655
26661	42571	6	applied	\N	\N	\N	\N	200495	200495	367656
26661	42572	7	applied	\N	\N	\N	\N	200496	200496	367657
26663	42573	0	applied	\N	\N	\N	\N	200505	200505	367666
26663	42574	1	applied	\N	\N	\N	\N	200506	200506	367667
26663	42575	2	applied	\N	\N	\N	\N	200507	200507	367668
26666	42576	0	applied	\N	\N	\N	\N	200518	200518	367679
26666	42578	3	applied	\N	\N	\N	\N	200520	200520	367681
26666	42579	4	applied	\N	\N	\N	\N	200521	200521	367682
26666	42580	5	applied	\N	\N	\N	\N	200522	200522	367683
26666	42581	6	applied	\N	\N	\N	\N	200523	200523	367684
26666	42582	7	applied	\N	\N	\N	\N	200524	200524	367685
26672	42586	0	applied	\N	\N	\N	\N	200556	200556	367717
26672	42587	1	applied	\N	\N	\N	\N	200557	200557	367718
26672	42588	2	applied	\N	\N	\N	\N	200558	200558	367719
26675	42589	0	applied	\N	\N	\N	\N	200567	200567	367728
26675	42590	1	applied	\N	\N	\N	\N	200568	200568	367729
26675	42591	2	applied	\N	\N	\N	\N	200569	200569	367730
26675	42592	3	applied	\N	\N	\N	\N	200570	200570	367731
26682	42609	0	applied	\N	\N	\N	\N	200596	200596	367757
26682	42610	1	applied	\N	\N	\N	\N	200597	200597	367758
26682	42611	2	applied	\N	\N	\N	\N	200598	200598	367759
26682	42612	3	applied	\N	\N	\N	\N	200599	200599	367760
26682	42614	5	applied	\N	\N	\N	\N	200601	200601	367762
26682	42615	6	applied	\N	\N	\N	\N	200602	200602	367763
26682	42616	7	applied	\N	\N	\N	\N	200603	200603	367764
26682	42617	8	applied	\N	\N	\N	\N	200604	200604	367765
26692	42629	0	applied	\N	\N	\N	\N	200661	200661	367822
26692	42630	1	applied	\N	\N	\N	\N	200662	200662	367823
26640	42529	2	applied	\N	\N	\N	\N	200271	200271	367432
26640	42530	3	applied	\N	\N	\N	\N	200272	200272	367433
26651	42129	94	applied	\N	\N	\N	\N	200425	200425	367586
26651	42133	95	applied	\N	\N	\N	\N	200426	200426	367587
26651	42139	96	applied	\N	\N	\N	\N	200427	200427	367588
26651	42143	97	applied	\N	\N	\N	\N	200428	200428	367589
26651	42145	98	applied	\N	\N	\N	\N	200429	200429	367590
26651	42150	99	applied	\N	\N	\N	\N	200430	200430	367591
26651	42153	100	applied	\N	\N	\N	\N	200431	200431	367592
26651	42157	101	applied	\N	\N	\N	\N	200432	200432	367593
26651	42158	102	applied	\N	\N	\N	\N	200433	200433	367594
26651	42163	103	applied	\N	\N	\N	\N	200434	200434	367595
26651	42165	104	applied	\N	\N	\N	\N	200435	200435	367596
26651	42171	105	applied	\N	\N	\N	\N	200436	200436	367597
26651	42172	107	applied	\N	\N	\N	\N	200437	200437	367598
26651	42173	108	applied	\N	\N	\N	\N	200438	200438	367599
26651	42182	110	applied	\N	\N	\N	\N	200440	200440	367601
26651	42183	111	applied	\N	\N	\N	\N	200441	200441	367602
26651	42188	112	applied	\N	\N	\N	\N	200442	200442	367603
26651	42193	113	applied	\N	\N	\N	\N	200443	200443	367604
26651	42194	114	applied	\N	\N	\N	\N	200444	200444	367605
26651	42198	115	applied	\N	\N	\N	\N	200445	200445	367606
26651	42202	116	applied	\N	\N	\N	\N	200446	200446	367607
26651	42206	117	applied	\N	\N	\N	\N	200447	200447	367608
26651	42209	118	applied	\N	\N	\N	\N	200448	200448	367609
26651	42212	119	applied	\N	\N	\N	\N	200449	200449	367610
26651	42216	120	applied	\N	\N	\N	\N	200450	200450	367611
26651	42220	121	applied	\N	\N	\N	\N	200451	200451	367612
26651	42221	122	applied	\N	\N	\N	\N	200452	200452	367613
26651	42226	123	applied	\N	\N	\N	\N	200453	200453	367614
26651	42229	124	applied	\N	\N	\N	\N	200454	200454	367615
26651	42231	125	applied	\N	\N	\N	\N	200455	200455	367616
26655	42557	1	applied	\N	\N	\N	\N	200466	200466	367627
26655	42558	2	applied	\N	\N	\N	\N	200467	200467	367628
26655	42559	3	applied	\N	\N	\N	\N	200468	200468	367629
26660	42566	0	applied	\N	\N	\N	\N	200481	200481	367642
26660	42567	1	applied	\N	\N	\N	\N	200482	200482	367643
26660	42568	2	applied	\N	\N	\N	\N	200483	200483	367644
26660	42565	3	applied	\N	\N	\N	\N	200484	200484	367645
26660	42569	4	applied	\N	\N	\N	\N	200485	200485	367646
26660	42570	5	applied	\N	\N	\N	\N	200486	200486	367647
26660	42571	6	applied	\N	\N	\N	\N	200487	200487	367648
26660	42572	7	applied	\N	\N	\N	\N	200488	200488	367649
26665	42576	0	applied	\N	\N	\N	\N	200511	200511	367672
26665	42577	1	applied	\N	\N	\N	\N	200512	200512	367673
26665	42578	3	applied	\N	\N	\N	\N	200513	200513	367674
26665	42579	4	applied	\N	\N	\N	\N	200514	200514	367675
26665	42580	5	applied	\N	\N	\N	\N	200515	200515	367676
26665	42582	7	applied	\N	\N	\N	\N	200517	200517	367678
26668	42576	0	applied	\N	\N	\N	\N	200532	200532	367693
26668	42577	1	applied	\N	\N	\N	\N	200533	200533	367694
26668	42578	3	applied	\N	\N	\N	\N	200534	200534	367695
26668	42579	4	applied	\N	\N	\N	\N	200535	200535	367696
26668	42580	5	applied	\N	\N	\N	\N	200536	200536	367697
26668	42581	6	applied	\N	\N	\N	\N	200537	200537	367698
26668	42582	7	applied	\N	\N	\N	\N	200538	200538	367699
26674	42589	0	applied	\N	\N	\N	\N	200563	200563	367724
26674	42590	1	applied	\N	\N	\N	\N	200564	200564	367725
26674	42591	2	applied	\N	\N	\N	\N	200565	200565	367726
26674	42592	3	applied	\N	\N	\N	\N	200566	200566	367727
26676	42593	0	applied	\N	\N	\N	\N	200571	200571	367732
26676	42594	1	applied	\N	\N	\N	\N	200572	200572	367733
26676	42595	2	applied	\N	\N	\N	\N	200573	200573	367734
26692	42631	2	applied	\N	\N	\N	\N	200663	200663	367824
26692	42633	4	applied	\N	\N	\N	\N	200665	200665	367826
26692	42634	5	applied	\N	\N	\N	\N	200666	200666	367827
26692	42635	6	applied	\N	\N	\N	\N	200667	200667	367828
26692	42636	7	applied	\N	\N	\N	\N	200668	200668	367829
26692	42637	8	applied	\N	\N	\N	\N	200669	200669	367830
26692	42638	9	applied	\N	\N	\N	\N	200670	200670	367831
26694	42639	0	applied	\N	\N	\N	\N	200671	200671	367832
26694	42640	1	applied	\N	\N	\N	\N	200672	200672	367833
26694	42641	2	applied	\N	\N	\N	\N	200673	200673	367834
26694	42642	3	applied	\N	\N	1000000000	\N	200674	200674	367835
26697	42646	0	applied	\N	\N	\N	\N	200682	200682	367843
26697	42647	1	applied	\N	\N	\N	\N	200683	200683	367844
26697	42648	2	applied	\N	\N	\N	\N	200684	200684	367845
26697	42649	3	applied	\N	\N	\N	\N	200685	200685	367846
26699	42650	0	applied	\N	\N	\N	\N	200689	200689	367850
26699	42651	1	applied	\N	\N	\N	\N	200690	200690	367851
26702	42653	0	applied	\N	\N	\N	\N	200698	200698	367859
26702	42654	1	applied	\N	\N	\N	\N	200699	200699	367860
26702	42655	2	applied	\N	\N	\N	\N	200700	200700	367861
26704	42663	0	applied	\N	\N	\N	\N	200708	200708	367869
26704	42664	1	applied	\N	\N	\N	\N	200709	200709	367870
26704	42665	2	applied	\N	\N	\N	\N	200710	200710	367871
26704	42666	3	applied	\N	\N	\N	\N	200711	200711	367872
26704	42667	4	applied	\N	\N	\N	\N	200712	200712	367873
26704	42668	5	applied	\N	\N	\N	\N	200713	200713	367874
26707	42669	0	applied	\N	\N	\N	\N	200850	200850	368011
26707	42670	1	applied	\N	\N	\N	\N	200851	200851	368012
26707	42671	2	applied	\N	\N	\N	\N	200852	200852	368013
26707	42672	3	applied	\N	\N	\N	\N	200853	200853	368014
26707	42673	4	applied	\N	\N	\N	\N	200854	200854	368015
26707	42674	5	applied	\N	\N	\N	\N	200855	200855	368016
26707	42675	6	applied	\N	\N	\N	\N	200856	200856	368017
26707	42677	8	applied	\N	\N	\N	\N	200858	200858	368019
26707	42678	9	applied	\N	\N	\N	\N	200859	200859	368020
26707	42679	10	applied	\N	\N	\N	\N	200860	200860	368021
26712	42690	0	applied	\N	\N	\N	\N	200999	200999	368160
26712	42691	1	applied	\N	\N	\N	\N	201000	201000	368161
26712	42692	2	applied	\N	\N	\N	\N	201001	201001	368162
26712	42693	3	applied	\N	\N	\N	\N	201002	201002	368163
26712	42694	4	applied	\N	\N	\N	\N	201003	201003	368164
26712	42695	5	applied	\N	\N	\N	\N	201004	201004	368165
26712	42696	6	applied	\N	\N	\N	\N	201005	201005	368166
26717	42707	0	applied	\N	\N	\N	\N	201026	201026	368187
26717	42708	1	applied	\N	\N	\N	\N	201027	201027	368188
26717	42709	2	applied	\N	\N	\N	\N	201028	201028	368189
26719	42710	0	applied	\N	\N	\N	\N	201032	201032	368193
26719	42711	1	applied	\N	\N	\N	\N	201033	201033	368194
26719	42712	2	applied	\N	\N	\N	\N	201034	201034	368195
26651	42125	93	applied	\N	\N	\N	\N	200424	200424	367585
26671	42584	1	applied	\N	\N	\N	\N	200554	200554	367715
26671	42585	2	applied	\N	\N	\N	\N	200555	200555	367716
26673	42589	0	applied	\N	\N	\N	\N	200559	200559	367720
26673	42590	1	applied	\N	\N	\N	\N	200560	200560	367721
26673	42591	2	applied	\N	\N	\N	\N	200561	200561	367722
26673	42592	3	applied	\N	\N	\N	\N	200562	200562	367723
26678	42599	0	applied	\N	\N	\N	\N	200577	200577	367738
26678	42600	1	applied	\N	\N	\N	\N	200578	200578	367739
26678	42601	2	applied	\N	\N	\N	\N	200579	200579	367740
26679	42599	0	applied	\N	\N	\N	\N	200580	200580	367741
26679	42600	1	applied	\N	\N	\N	\N	200581	200581	367742
26679	42601	2	applied	\N	\N	\N	\N	200582	200582	367743
26681	42553	0	applied	\N	\N	\N	\N	200590	200590	367751
26681	42556	1	applied	\N	\N	\N	\N	200591	200591	367752
26681	42563	3	applied	\N	\N	\N	\N	200593	200593	367754
26681	42566	4	applied	\N	\N	\N	\N	200594	200594	367755
26681	42567	5	applied	\N	\N	\N	\N	200595	200595	367756
26686	42618	0	applied	\N	\N	\N	\N	200622	200622	367783
26686	42619	1	applied	\N	\N	\N	\N	200623	200623	367784
26686	42620	2	applied	\N	\N	\N	\N	200624	200624	367785
26686	42621	3	applied	\N	\N	\N	\N	200625	200625	367786
26686	42622	4	applied	\N	\N	\N	\N	200626	200626	367787
26686	42623	5	applied	\N	\N	1000000000	\N	200627	200627	367788
26686	42624	6	applied	\N	\N	\N	\N	200628	200628	367789
26686	42625	7	applied	\N	\N	\N	\N	200629	200629	367790
26688	42626	0	applied	\N	\N	\N	\N	200638	200638	367799
26688	42627	1	applied	\N	\N	\N	\N	200639	200639	367800
26688	42628	2	applied	\N	\N	\N	\N	200640	200640	367801
26691	42629	0	applied	\N	\N	\N	\N	200651	200651	367812
26691	42630	1	applied	\N	\N	\N	\N	200652	200652	367813
26691	42632	3	applied	\N	\N	\N	\N	200654	200654	367815
26691	42633	4	applied	\N	\N	\N	\N	200655	200655	367816
26691	42634	5	applied	\N	\N	\N	\N	200656	200656	367817
26691	42635	6	applied	\N	\N	\N	\N	200657	200657	367818
26691	42636	7	applied	\N	\N	\N	\N	200658	200658	367819
26691	42637	8	applied	\N	\N	\N	\N	200659	200659	367820
26691	42638	9	applied	\N	\N	\N	\N	200660	200660	367821
26695	42643	0	applied	\N	\N	\N	\N	200675	200675	367836
26695	42644	1	applied	\N	\N	\N	\N	200676	200676	367837
26695	42645	2	applied	\N	\N	\N	\N	200677	200677	367838
26696	42646	0	applied	\N	\N	\N	\N	200678	200678	367839
26696	42647	1	applied	\N	\N	\N	\N	200679	200679	367840
26696	42648	2	applied	\N	\N	\N	\N	200680	200680	367841
26696	42649	3	applied	\N	\N	\N	\N	200681	200681	367842
26698	42650	0	applied	\N	\N	\N	\N	200686	200686	367847
26698	42651	1	applied	\N	\N	\N	\N	200687	200687	367848
26700	42653	0	applied	\N	\N	\N	\N	200692	200692	367853
26700	42654	1	applied	\N	\N	\N	\N	200693	200693	367854
26700	42655	2	applied	\N	\N	\N	\N	200694	200694	367855
26701	42653	0	applied	\N	\N	\N	\N	200695	200695	367856
26701	42654	1	applied	\N	\N	\N	\N	200696	200696	367857
26701	42655	2	applied	\N	\N	\N	\N	200697	200697	367858
26703	42656	0	applied	\N	\N	\N	\N	200701	200701	367862
26703	42657	1	applied	\N	\N	\N	\N	200702	200702	367863
26703	42658	2	applied	\N	\N	\N	\N	200703	200703	367864
26703	42659	3	applied	\N	\N	\N	\N	200704	200704	367865
26703	42660	4	applied	\N	\N	\N	\N	200705	200705	367866
26703	42661	5	applied	\N	\N	\N	\N	200706	200706	367867
26703	42662	6	applied	\N	\N	\N	\N	200707	200707	367868
26706	41925	0	applied	\N	\N	\N	\N	200725	200725	367886
26706	41926	1	applied	\N	\N	\N	\N	200726	200726	367887
26706	41931	2	applied	\N	\N	\N	\N	200727	200727	367888
26706	41938	4	applied	\N	\N	\N	\N	200729	200729	367890
26706	41939	5	applied	\N	\N	\N	\N	200730	200730	367891
26706	41945	6	applied	\N	\N	\N	\N	200731	200731	367892
26706	41948	7	applied	\N	\N	\N	\N	200732	200732	367893
26706	41952	8	applied	\N	\N	\N	\N	200733	200733	367894
26706	41953	9	applied	\N	\N	\N	\N	200734	200734	367895
26706	41959	10	applied	\N	\N	\N	\N	200735	200735	367896
26706	41961	11	applied	\N	\N	\N	\N	200736	200736	367897
26706	41965	12	applied	\N	\N	\N	\N	200737	200737	367898
26706	41969	13	applied	\N	\N	\N	\N	200738	200738	367899
26706	41972	14	applied	\N	\N	\N	\N	200739	200739	367900
26706	41975	15	applied	\N	\N	\N	\N	200740	200740	367901
26706	41979	16	applied	\N	\N	\N	\N	200741	200741	367902
26706	41980	17	applied	\N	\N	\N	\N	200742	200742	367903
26706	41985	18	applied	\N	\N	\N	\N	200743	200743	367904
26706	41989	19	applied	\N	\N	\N	\N	200744	200744	367905
26706	41993	21	applied	\N	\N	\N	\N	200746	200746	367907
26706	41994	22	applied	\N	\N	\N	\N	200747	200747	367908
26706	41995	23	applied	\N	\N	\N	\N	200748	200748	367909
26706	41996	24	applied	\N	\N	\N	\N	200749	200749	367910
26706	42010	25	applied	\N	\N	\N	\N	200750	200750	367911
26706	42014	26	applied	\N	\N	\N	\N	200751	200751	367912
26706	42017	27	applied	\N	\N	\N	\N	200752	200752	367913
26709	42447	0	applied	\N	\N	\N	\N	200868	200868	368029
26709	42451	1	applied	\N	\N	\N	\N	200869	200869	368030
26709	42453	2	applied	\N	\N	\N	\N	200870	200870	368031
26709	42456	3	applied	\N	\N	\N	\N	200871	200871	368032
26709	42464	4	applied	\N	\N	\N	\N	200872	200872	368033
26709	42472	5	applied	\N	\N	\N	\N	200873	200873	368034
26709	42473	6	applied	\N	\N	\N	\N	200874	200874	368035
26709	42474	7	applied	\N	\N	\N	\N	200875	200875	368036
26709	42475	8	applied	\N	\N	\N	\N	200876	200876	368037
26709	42494	10	applied	\N	\N	\N	\N	200878	200878	368039
26709	42497	11	applied	\N	\N	\N	\N	200879	200879	368040
26709	42500	12	applied	\N	\N	\N	\N	200880	200880	368041
26709	42503	13	applied	\N	\N	\N	\N	200881	200881	368042
26709	42504	14	applied	\N	\N	\N	\N	200882	200882	368043
26709	42510	15	applied	\N	\N	\N	\N	200883	200883	368044
26709	42514	16	applied	\N	\N	\N	\N	200884	200884	368045
26709	42518	17	applied	\N	\N	\N	\N	200885	200885	368046
26709	42523	18	applied	\N	\N	\N	\N	200886	200886	368047
26709	42527	19	applied	\N	\N	\N	\N	200887	200887	368048
26709	42528	20	applied	\N	\N	\N	\N	200888	200888	368049
26709	42529	21	applied	\N	\N	\N	\N	200889	200889	368050
26709	42536	22	applied	\N	\N	\N	\N	200890	200890	368051
26709	42540	23	applied	\N	\N	\N	\N	200891	200891	368052
26709	42541	24	applied	\N	\N	\N	\N	200892	200892	368053
26709	42546	25	applied	\N	\N	\N	\N	200893	200893	368054
26671	42583	0	applied	\N	\N	\N	\N	200553	200553	367714
26706	42033	32	applied	\N	\N	\N	\N	200757	200757	367918
26706	42037	33	applied	\N	\N	\N	\N	200758	200758	367919
26706	42040	34	applied	\N	\N	\N	\N	200759	200759	367920
26706	42041	35	applied	\N	\N	\N	\N	200760	200760	367921
26706	42047	36	applied	\N	\N	\N	\N	200761	200761	367922
26706	42048	37	applied	\N	\N	\N	\N	200762	200762	367923
26706	42053	39	applied	\N	\N	\N	\N	200763	200763	367924
26706	42057	40	applied	\N	\N	\N	\N	200764	200764	367925
26706	42060	41	applied	\N	\N	\N	\N	200765	200765	367926
26706	42061	42	applied	\N	\N	\N	\N	200766	200766	367927
26706	42066	43	applied	\N	\N	\N	\N	200767	200767	367928
26706	42070	44	applied	\N	\N	\N	\N	200768	200768	367929
26706	42073	45	applied	\N	\N	\N	\N	200769	200769	367930
26706	42075	46	applied	\N	\N	\N	\N	200770	200770	367931
26706	42079	47	applied	\N	\N	\N	\N	200771	200771	367932
26706	42082	48	applied	\N	\N	\N	\N	200772	200772	367933
26706	42089	50	applied	\N	\N	\N	\N	200774	200774	367935
26706	42092	51	applied	\N	\N	\N	\N	200775	200775	367936
26706	42093	52	applied	\N	\N	\N	\N	200776	200776	367937
26706	42101	53	applied	\N	\N	\N	\N	200777	200777	367938
26706	42104	54	applied	\N	\N	\N	\N	200778	200778	367939
26706	42105	55	applied	\N	\N	\N	\N	200779	200779	367940
26706	42112	56	applied	\N	\N	\N	\N	200780	200780	367941
26706	42115	57	applied	\N	\N	\N	\N	200781	200781	367942
26706	42116	58	applied	\N	\N	\N	\N	200782	200782	367943
26706	42122	59	applied	\N	\N	\N	\N	200783	200783	367944
26706	42128	60	applied	\N	\N	\N	\N	200784	200784	367945
26706	42132	61	applied	\N	\N	\N	\N	200785	200785	367946
26706	42136	62	applied	\N	\N	\N	\N	200786	200786	367947
26706	42141	63	applied	\N	\N	\N	\N	200787	200787	367948
26706	42144	64	applied	\N	\N	\N	\N	200788	200788	367949
26706	42147	65	applied	\N	\N	\N	\N	200789	200789	367950
26706	42154	67	applied	\N	\N	\N	\N	200791	200791	367952
26706	42155	68	applied	\N	\N	\N	\N	200792	200792	367953
26706	42161	69	applied	\N	\N	\N	\N	200793	200793	367954
26706	42164	70	applied	\N	\N	\N	\N	200794	200794	367955
26706	42167	71	applied	\N	\N	\N	\N	200795	200795	367956
26706	42168	72	applied	\N	\N	\N	\N	200796	200796	367957
26706	42170	73	applied	\N	\N	\N	\N	200797	200797	367958
26706	42177	74	applied	\N	\N	\N	\N	200798	200798	367959
26706	42180	75	applied	\N	\N	\N	\N	200799	200799	367960
26706	42181	76	applied	\N	\N	\N	\N	200800	200800	367961
26706	42187	77	applied	\N	\N	\N	\N	200801	200801	367962
26706	42190	78	applied	\N	\N	\N	\N	200802	200802	367963
26706	42191	79	applied	\N	\N	\N	\N	200803	200803	367964
26706	42197	80	applied	\N	\N	\N	\N	200804	200804	367965
26706	42200	81	applied	\N	\N	\N	\N	200805	200805	367966
26706	42203	82	applied	\N	\N	\N	\N	200806	200806	367967
26706	42210	84	applied	\N	\N	\N	\N	200808	200808	367969
26706	42213	85	applied	\N	\N	\N	\N	200809	200809	367970
26706	42214	86	applied	\N	\N	\N	\N	200810	200810	367971
26706	42215	87	applied	\N	\N	\N	\N	200811	200811	367972
26706	42223	88	applied	\N	\N	\N	\N	200812	200812	367973
26706	42227	89	applied	\N	\N	\N	\N	200813	200813	367974
26706	42230	90	applied	\N	\N	\N	\N	200814	200814	367975
26706	42233	91	applied	\N	\N	\N	\N	200815	200815	367976
26706	42236	92	applied	\N	\N	\N	\N	200816	200816	367977
26706	42240	93	applied	\N	\N	\N	\N	200817	200817	367978
26706	42243	94	applied	\N	\N	\N	\N	200818	200818	367979
26706	42246	95	applied	\N	\N	\N	\N	200819	200819	367980
26706	42250	96	applied	\N	\N	\N	\N	200820	200820	367981
26706	42253	97	applied	\N	\N	\N	\N	200821	200821	367982
26706	42256	98	applied	\N	\N	\N	\N	200822	200822	367983
26706	42260	99	applied	\N	\N	\N	\N	200823	200823	367984
26706	42262	101	applied	\N	\N	\N	\N	200825	200825	367986
26706	42269	102	applied	\N	\N	\N	\N	200826	200826	367987
26706	42270	103	applied	\N	\N	\N	\N	200827	200827	367988
26706	42276	104	applied	\N	\N	\N	\N	200828	200828	367989
26706	42280	105	applied	\N	\N	\N	\N	200829	200829	367990
26706	42281	106	applied	\N	\N	\N	\N	200830	200830	367991
26706	42289	107	applied	\N	\N	\N	\N	200831	200831	367992
26706	42290	108	applied	\N	\N	\N	\N	200832	200832	367993
26706	42298	109	applied	\N	\N	\N	\N	200833	200833	367994
26706	42299	110	applied	\N	\N	\N	\N	200834	200834	367995
26706	42300	111	applied	\N	\N	\N	\N	200835	200835	367996
26706	42308	112	applied	\N	\N	\N	\N	200836	200836	367997
26706	42311	113	applied	\N	\N	\N	\N	200837	200837	367998
26706	42313	114	applied	\N	\N	\N	\N	200838	200838	367999
26706	42317	115	applied	\N	\N	\N	\N	200839	200839	368000
26706	42320	116	applied	\N	\N	\N	\N	200840	200840	368001
26706	42327	118	applied	\N	\N	\N	\N	200842	200842	368003
26706	42328	119	applied	\N	\N	\N	\N	200843	200843	368004
26706	42333	120	applied	\N	\N	\N	\N	200844	200844	368005
26706	42336	121	applied	\N	\N	\N	\N	200845	200845	368006
26706	42340	122	applied	\N	\N	\N	\N	200846	200846	368007
26706	42343	123	applied	\N	\N	\N	\N	200847	200847	368008
26706	42346	124	applied	\N	\N	\N	\N	200848	200848	368009
26706	42349	125	applied	\N	\N	\N	\N	200849	200849	368010
26708	42680	0	applied	\N	\N	\N	\N	200861	200861	368022
26708	42681	1	applied	\N	\N	\N	\N	200862	200862	368023
26708	42682	2	applied	\N	\N	\N	\N	200863	200863	368024
26708	42683	3	applied	\N	\N	\N	\N	200864	200864	368025
26708	42684	4	applied	\N	\N	\N	\N	200865	200865	368026
26708	42685	5	applied	\N	\N	\N	\N	200866	200866	368027
26708	42686	6	applied	\N	\N	\N	\N	200867	200867	368028
26714	42697	0	applied	\N	\N	\N	\N	201012	201012	368173
26714	42699	2	applied	\N	\N	\N	\N	201014	201014	368175
26714	42700	3	applied	\N	\N	\N	\N	201015	201015	368176
26714	42701	4	applied	\N	\N	\N	\N	201016	201016	368177
26714	42702	5	applied	\N	\N	\N	\N	201017	201017	368178
26718	42707	0	applied	\N	\N	\N	\N	201029	201029	368190
26718	42708	1	applied	\N	\N	\N	\N	201030	201030	368191
26718	42709	2	applied	\N	\N	\N	\N	201031	201031	368192
26726	42729	0	applied	\N	\N	\N	\N	201056	201056	368217
26726	42730	1	applied	\N	\N	\N	\N	201057	201057	368218
26726	42731	2	applied	\N	\N	\N	\N	201058	201058	368219
26730	42739	0	applied	\N	\N	\N	\N	201080	201080	368241
26730	42740	1	applied	\N	\N	\N	\N	201081	201081	368242
26730	42741	2	applied	\N	\N	\N	\N	201082	201082	368243
26735	42747	0	applied	\N	\N	\N	\N	201099	201099	368260
26706	42024	29	applied	\N	\N	\N	\N	200754	200754	367915
26706	42027	30	applied	\N	\N	\N	\N	200755	200755	367916
26709	42560	29	applied	\N	\N	\N	\N	200897	200897	368058
26709	42563	30	applied	\N	\N	\N	\N	200898	200898	368059
26709	42566	31	applied	\N	\N	\N	\N	200899	200899	368060
26709	42567	32	applied	\N	\N	\N	\N	200900	200900	368061
26709	42573	33	applied	\N	\N	\N	\N	200901	200901	368062
26709	42576	34	applied	\N	\N	\N	\N	200902	200902	368063
26709	42577	35	applied	\N	\N	\N	\N	200903	200903	368064
26709	42586	37	applied	\N	\N	\N	\N	200905	200905	368066
26709	42589	38	applied	\N	\N	\N	\N	200906	200906	368067
26709	42593	39	applied	\N	\N	\N	\N	200907	200907	368068
26709	42596	40	applied	\N	\N	\N	\N	200908	200908	368069
26709	42599	41	applied	\N	\N	\N	\N	200909	200909	368070
26709	42602	42	applied	\N	\N	\N	\N	200910	200910	368071
26709	42603	43	applied	\N	\N	\N	\N	200911	200911	368072
26709	42609	44	applied	\N	\N	\N	\N	200912	200912	368073
26709	42610	45	applied	\N	\N	\N	\N	200913	200913	368074
26709	42611	46	applied	\N	\N	\N	\N	200914	200914	368075
26709	42618	47	applied	\N	\N	\N	\N	200915	200915	368076
26709	42619	48	applied	\N	\N	\N	\N	200916	200916	368077
26709	42626	49	applied	\N	\N	\N	\N	200917	200917	368078
26709	42629	50	applied	\N	\N	\N	\N	200918	200918	368079
26709	42630	51	applied	\N	\N	\N	\N	200919	200919	368080
26709	42631	52	applied	\N	\N	\N	\N	200920	200920	368081
26709	42643	54	applied	\N	\N	\N	\N	200922	200922	368083
26709	42646	55	applied	\N	\N	\N	\N	200923	200923	368084
26709	42650	56	applied	\N	\N	\N	\N	200924	200924	368085
26709	42653	57	applied	\N	\N	\N	\N	200925	200925	368086
26709	42656	59	applied	\N	\N	\N	\N	200926	200926	368087
26709	42657	60	applied	\N	\N	\N	\N	200927	200927	368088
26709	42663	61	applied	\N	\N	\N	\N	200928	200928	368089
26709	42664	62	applied	\N	\N	\N	\N	200929	200929	368090
26709	42669	63	applied	\N	\N	\N	\N	200930	200930	368091
26709	42670	64	applied	\N	\N	\N	\N	200931	200931	368092
26709	42671	65	applied	\N	\N	\N	\N	200932	200932	368093
26709	42680	66	applied	\N	\N	\N	\N	200933	200933	368094
26709	42681	67	applied	\N	\N	\N	\N	200934	200934	368095
26709	42511	68	applied	\N	\N	1000000000	\N	200935	200935	368096
26709	42537	69	applied	\N	\N	\N	\N	200936	200936	368097
26709	42448	70	applied	\N	\N	\N	\N	200937	200937	368098
26709	42478	72	applied	\N	\N	1000000000	\N	200939	200939	368100
26709	42452	73	applied	\N	\N	\N	\N	200940	200940	368101
26709	42484	74	applied	\N	\N	1000000000	\N	200941	200941	368102
26709	42485	75	applied	\N	\N	1000000000	\N	200942	200942	368103
26709	42486	76	applied	\N	\N	1000000000	\N	200943	200943	368104
26709	42449	77	applied	\N	\N	\N	\N	200944	200944	368105
26709	42457	78	applied	\N	\N	\N	\N	200945	200945	368106
26709	42465	79	applied	\N	\N	\N	\N	200946	200946	368107
26709	42477	80	applied	\N	\N	\N	\N	200947	200947	368108
26709	42479	81	applied	\N	\N	\N	\N	200948	200948	368109
26709	42487	82	applied	\N	\N	1000000000	\N	200949	200949	368110
26709	42623	83	applied	\N	\N	1000000000	\N	200950	200950	368111
26709	42450	84	applied	\N	\N	\N	\N	200951	200951	368112
26709	42454	85	applied	\N	\N	\N	\N	200952	200952	368113
26709	42458	86	applied	\N	\N	\N	\N	200953	200953	368114
26709	42459	87	applied	\N	\N	\N	\N	200954	200954	368115
26709	42455	89	applied	\N	\N	\N	\N	200956	200956	368117
26709	42460	90	applied	\N	\N	\N	\N	200957	200957	368118
26709	42461	91	applied	\N	\N	\N	\N	200958	200958	368119
26709	42462	92	applied	\N	\N	\N	\N	200959	200959	368120
26709	42466	93	applied	\N	\N	\N	\N	200960	200960	368121
26735	42748	1	applied	\N	\N	\N	\N	201100	201100	368261
26735	42749	2	applied	\N	\N	\N	\N	201101	201101	368262
26735	42750	3	applied	\N	\N	\N	\N	201102	201102	368263
26743	42760	0	applied	\N	\N	\N	\N	201127	201127	368288
26743	42761	1	applied	\N	\N	\N	\N	201128	201128	368289
26743	42762	2	applied	\N	\N	\N	\N	201129	201129	368290
26743	42763	3	applied	\N	\N	\N	\N	201130	201130	368291
26745	42760	0	applied	\N	\N	\N	\N	201138	201138	368299
26745	42764	1	applied	\N	\N	\N	\N	201139	201139	368300
26745	42761	2	applied	\N	\N	\N	\N	201140	201140	368301
26745	42762	3	applied	\N	\N	\N	\N	201141	201141	368302
26745	42766	5	applied	\N	\N	\N	\N	201143	201143	368304
26745	42763	6	applied	\N	\N	\N	\N	201144	201144	368305
26747	42511	0	applied	\N	\N	1000000000	\N	201152	201152	368313
26747	42537	1	applied	\N	\N	\N	\N	201153	201153	368314
26747	42364	2	applied	\N	\N	\N	\N	201154	201154	368315
26747	42672	3	applied	\N	\N	\N	\N	201155	201155	368316
26747	42478	4	applied	\N	\N	1000000000	\N	201156	201156	368317
26747	42373	5	applied	\N	\N	\N	\N	201157	201157	368318
26747	42484	6	applied	\N	\N	1000000000	\N	201158	201158	368319
26747	42485	7	applied	\N	\N	1000000000	\N	201159	201159	368320
26747	42486	8	applied	\N	\N	1000000000	\N	201160	201160	368321
26747	42374	9	applied	\N	\N	\N	\N	201161	201161	368322
26747	42487	10	applied	\N	\N	1000000000	\N	201162	201162	368323
26747	42623	11	applied	\N	\N	1000000000	\N	201163	201163	368324
26747	42743	13	applied	\N	\N	1000000000	\N	201165	201165	368326
26747	42745	14	applied	\N	\N	1000000000	\N	201166	201166	368327
26756	42511	0	applied	\N	\N	1000000000	\N	201218	201218	368376
26747	42279	15	failed	Amount_insufficient_to_create_account	\N	\N	\N	201167	201167	\N
26747	42284	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	201168	201168	\N
26747	42287	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	201169	201169	\N
26756	42537	1	applied	\N	\N	\N	\N	201219	201219	368377
26756	42672	2	applied	\N	\N	\N	\N	201220	201220	368378
26756	42478	3	applied	\N	\N	1000000000	\N	201221	201221	368379
26756	42484	4	applied	\N	\N	1000000000	\N	201222	201222	368380
26756	42485	5	applied	\N	\N	1000000000	\N	201223	201223	368381
26756	42486	6	applied	\N	\N	1000000000	\N	201224	201224	368382
26756	42487	7	applied	\N	\N	1000000000	\N	201225	201225	368383
26756	42623	8	applied	\N	\N	1000000000	\N	201226	201226	368384
26756	42642	9	applied	\N	\N	1000000000	\N	201227	201227	368385
26756	42743	10	applied	\N	\N	1000000000	\N	201228	201228	368386
26756	42745	11	applied	\N	\N	1000000000	\N	201229	201229	368387
26758	42784	0	applied	\N	\N	\N	\N	201235	201235	368393
26758	42785	1	applied	\N	\N	\N	\N	201236	201236	368394
26758	42786	2	applied	\N	\N	\N	\N	201237	201237	368395
26709	42553	27	applied	\N	\N	\N	\N	200895	200895	368056
26709	42556	28	applied	\N	\N	\N	\N	200896	200896	368057
26709	42489	97	applied	\N	\N	\N	\N	200964	200964	368125
26709	42490	98	applied	\N	\N	\N	\N	200965	200965	368126
26709	42491	99	applied	\N	\N	\N	\N	200966	200966	368127
26709	42492	100	applied	\N	\N	\N	\N	200967	200967	368128
26709	42469	101	applied	\N	\N	\N	\N	200968	200968	368129
26709	42493	102	applied	\N	\N	\N	\N	200969	200969	368130
26709	42495	103	applied	\N	\N	\N	\N	200970	200970	368131
26709	42499	104	applied	\N	\N	\N	\N	200971	200971	368132
26709	42516	106	applied	\N	\N	\N	\N	200973	200973	368134
26709	42526	107	applied	\N	\N	\N	\N	200974	200974	368135
26709	42538	108	applied	\N	\N	\N	\N	200975	200975	368136
26709	42547	109	applied	\N	\N	\N	\N	200976	200976	368137
26709	42558	110	applied	\N	\N	\N	\N	200977	200977	368138
26709	42572	111	applied	\N	\N	\N	\N	200978	200978	368139
26709	42582	112	applied	\N	\N	\N	\N	200979	200979	368140
26709	42591	113	applied	\N	\N	\N	\N	200980	200980	368141
26709	42604	114	applied	\N	\N	\N	\N	200981	200981	368142
26709	42613	115	applied	\N	\N	\N	\N	200982	200982	368143
26709	42622	116	applied	\N	\N	\N	\N	200983	200983	368144
26709	42638	117	applied	\N	\N	\N	\N	200984	200984	368145
26709	42648	118	applied	\N	\N	\N	\N	200985	200985	368146
26709	42661	119	applied	\N	\N	\N	\N	200986	200986	368147
26709	42470	120	applied	\N	\N	\N	\N	200987	200987	368148
26709	42471	121	applied	\N	\N	\N	\N	200988	200988	368149
26709	42481	123	applied	\N	\N	\N	\N	200990	200990	368151
26709	42482	124	applied	\N	\N	\N	\N	200991	200991	368152
26709	42483	125	applied	\N	\N	\N	\N	200992	200992	368153
26711	42687	0	applied	\N	\N	\N	\N	200996	200996	368157
26711	42688	1	applied	\N	\N	\N	\N	200997	200997	368158
26711	42689	2	applied	\N	\N	\N	\N	200998	200998	368159
26716	42703	0	applied	\N	\N	\N	\N	201022	201022	368183
26716	42704	1	applied	\N	\N	\N	\N	201023	201023	368184
26716	42705	2	applied	\N	\N	\N	\N	201024	201024	368185
26716	42706	3	applied	\N	\N	\N	\N	201025	201025	368186
26720	42711	1	applied	\N	\N	\N	\N	201036	201036	368197
26720	42712	2	applied	\N	\N	\N	\N	201037	201037	368198
26722	42713	0	applied	\N	\N	\N	\N	201040	201040	368201
26722	42714	1	applied	\N	\N	\N	\N	201041	201041	368202
26722	42715	2	applied	\N	\N	\N	\N	201042	201042	368203
26722	42716	3	applied	\N	\N	\N	\N	201043	201043	368204
26725	42726	1	applied	\N	\N	\N	\N	201053	201053	368214
26725	42727	2	applied	\N	\N	\N	\N	201054	201054	368215
26725	42728	3	applied	\N	\N	\N	\N	201055	201055	368216
26728	42732	0	applied	\N	\N	\N	\N	201066	201066	368227
26728	42733	1	applied	\N	\N	\N	\N	201067	201067	368228
26728	42734	2	applied	\N	\N	\N	\N	201068	201068	368229
26728	42735	3	applied	\N	\N	\N	\N	201069	201069	368230
26728	42736	4	applied	\N	\N	\N	\N	201070	201070	368231
26728	42737	5	applied	\N	\N	\N	\N	201071	201071	368232
26728	42738	6	applied	\N	\N	\N	\N	201072	201072	368233
26729	42732	0	applied	\N	\N	\N	\N	201073	201073	368234
26729	42733	1	applied	\N	\N	\N	\N	201074	201074	368235
26729	42734	2	applied	\N	\N	\N	\N	201075	201075	368236
26729	42735	3	applied	\N	\N	\N	\N	201076	201076	368237
26729	42736	4	applied	\N	\N	\N	\N	201077	201077	368238
26729	42737	5	applied	\N	\N	\N	\N	201078	201078	368239
26731	42740	1	applied	\N	\N	\N	\N	201084	201084	368245
26731	42741	2	applied	\N	\N	\N	\N	201085	201085	368246
26734	42742	0	applied	\N	\N	\N	\N	201094	201094	368255
26734	42743	1	applied	\N	\N	1000000000	\N	201095	201095	368256
26734	42744	2	applied	\N	\N	\N	\N	201096	201096	368257
26734	42745	3	applied	\N	\N	1000000000	\N	201097	201097	368258
26734	42746	4	applied	\N	\N	\N	\N	201098	201098	368259
26736	42751	0	applied	\N	\N	\N	\N	201103	201103	368264
26736	42752	1	applied	\N	\N	\N	\N	201104	201104	368265
26736	42753	2	applied	\N	\N	\N	\N	201105	201105	368266
26736	42754	3	applied	\N	\N	\N	\N	201106	201106	368267
26736	42755	4	applied	\N	\N	\N	\N	201107	201107	368268
26736	42756	5	applied	\N	\N	\N	\N	201108	201108	368269
26739	42760	0	applied	\N	\N	\N	\N	201112	201112	368273
26739	42761	1	applied	\N	\N	\N	\N	201113	201113	368274
26739	42762	2	applied	\N	\N	\N	\N	201114	201114	368275
26741	42760	0	applied	\N	\N	\N	\N	201119	201119	368280
26741	42761	1	applied	\N	\N	\N	\N	201120	201120	368281
26741	42762	2	applied	\N	\N	\N	\N	201121	201121	368282
26741	42763	3	applied	\N	\N	\N	\N	201122	201122	368283
26749	42774	0	applied	\N	\N	\N	\N	201173	201173	368331
26749	42775	1	applied	\N	\N	\N	\N	201174	201174	368332
26749	42776	2	applied	\N	\N	\N	\N	201175	201175	368333
26751	42777	0	applied	\N	\N	\N	\N	201179	201179	368337
26751	42778	1	applied	\N	\N	\N	\N	201180	201180	368338
26751	42779	2	applied	\N	\N	\N	\N	201181	201181	368339
26754	42511	0	applied	\N	\N	1000000000	\N	201199	201199	368357
26754	42537	1	applied	\N	\N	\N	\N	201200	201200	368358
26754	42364	2	applied	\N	\N	\N	\N	201201	201201	368359
26754	42672	3	applied	\N	\N	\N	\N	201202	201202	368360
26754	42373	5	applied	\N	\N	\N	\N	201204	201204	368362
26754	42484	6	applied	\N	\N	1000000000	\N	201205	201205	368363
26754	42485	7	applied	\N	\N	1000000000	\N	201206	201206	368364
26754	42486	8	applied	\N	\N	1000000000	\N	201207	201207	368365
26754	42374	9	applied	\N	\N	\N	\N	201208	201208	368366
26754	42487	10	applied	\N	\N	1000000000	\N	201209	201209	368367
26754	42623	11	applied	\N	\N	1000000000	\N	201210	201210	368368
26754	42642	12	applied	\N	\N	1000000000	\N	201211	201211	368369
26754	42743	13	applied	\N	\N	1000000000	\N	201212	201212	368370
26754	42745	14	applied	\N	\N	1000000000	\N	201213	201213	368371
26765	42797	0	applied	\N	\N	\N	\N	201264	201264	368422
26765	42798	1	applied	\N	\N	\N	\N	201265	201265	368423
26765	42799	2	applied	\N	\N	\N	\N	201266	201266	368424
26765	42800	3	applied	\N	\N	\N	\N	201267	201267	368425
26765	42804	4	applied	\N	\N	\N	\N	201268	201268	368426
26765	42805	5	applied	\N	\N	\N	\N	201269	201269	368427
26765	42806	6	applied	\N	\N	\N	\N	201270	201270	368428
26771	42819	0	applied	\N	\N	\N	\N	201323	201323	368481
26771	42820	1	applied	\N	\N	\N	\N	201324	201324	368482
26771	42821	2	applied	\N	\N	\N	\N	201325	201325	368483
26771	42823	4	applied	\N	\N	\N	\N	201327	201327	368485
26771	42824	5	applied	\N	\N	\N	\N	201328	201328	368486
26709	42468	95	applied	\N	\N	\N	\N	200962	200962	368123
26709	42642	96	applied	\N	\N	1000000000	\N	200963	200963	368124
26724	42718	1	applied	\N	\N	\N	\N	201045	201045	368206
26724	42719	2	applied	\N	\N	\N	\N	201046	201046	368207
26724	42721	4	applied	\N	\N	\N	\N	201048	201048	368209
26724	42722	5	applied	\N	\N	\N	\N	201049	201049	368210
26724	42723	6	applied	\N	\N	\N	\N	201050	201050	368211
26724	42724	7	applied	\N	\N	\N	\N	201051	201051	368212
26727	42732	0	applied	\N	\N	\N	\N	201059	201059	368220
26727	42733	1	applied	\N	\N	\N	\N	201060	201060	368221
26727	42734	2	applied	\N	\N	\N	\N	201061	201061	368222
26727	42735	3	applied	\N	\N	\N	\N	201062	201062	368223
26727	42736	4	applied	\N	\N	\N	\N	201063	201063	368224
26727	42737	5	applied	\N	\N	\N	\N	201064	201064	368225
26727	42738	6	applied	\N	\N	\N	\N	201065	201065	368226
26732	42739	0	applied	\N	\N	\N	\N	201086	201086	368247
26732	42740	1	applied	\N	\N	\N	\N	201087	201087	368248
26732	42741	2	applied	\N	\N	\N	\N	201088	201088	368249
26733	42742	0	applied	\N	\N	\N	\N	201089	201089	368250
26733	42744	2	applied	\N	\N	\N	\N	201091	201091	368252
26733	42745	3	applied	\N	\N	1000000000	\N	201092	201092	368253
26733	42746	4	applied	\N	\N	\N	\N	201093	201093	368254
26744	42760	0	applied	\N	\N	\N	\N	201131	201131	368292
26744	42764	1	applied	\N	\N	\N	\N	201132	201132	368293
26744	42761	2	applied	\N	\N	\N	\N	201133	201133	368294
26744	42762	3	applied	\N	\N	\N	\N	201134	201134	368295
26744	42765	4	applied	\N	\N	\N	\N	201135	201135	368296
26744	42766	5	applied	\N	\N	\N	\N	201136	201136	368297
26744	42763	6	applied	\N	\N	\N	\N	201137	201137	368298
26753	42511	0	applied	\N	\N	1000000000	\N	201184	201184	368342
26753	42537	1	applied	\N	\N	\N	\N	201185	201185	368343
26753	42364	2	applied	\N	\N	\N	\N	201186	201186	368344
26753	42672	3	applied	\N	\N	\N	\N	201187	201187	368345
26753	42478	4	applied	\N	\N	1000000000	\N	201188	201188	368346
26753	42373	5	applied	\N	\N	\N	\N	201189	201189	368347
26753	42484	6	applied	\N	\N	1000000000	\N	201190	201190	368348
26753	42486	8	applied	\N	\N	1000000000	\N	201192	201192	368350
26753	42374	9	applied	\N	\N	\N	\N	201193	201193	368351
26753	42487	10	applied	\N	\N	1000000000	\N	201194	201194	368352
26770	42823	4	applied	\N	\N	\N	\N	201307	201307	368465
26753	42623	11	applied	\N	\N	1000000000	\N	201195	201195	368353
26753	42642	12	applied	\N	\N	1000000000	\N	201196	201196	368354
26753	42743	13	applied	\N	\N	1000000000	\N	201197	201197	368355
26753	42745	14	applied	\N	\N	1000000000	\N	201198	201198	368356
26757	42672	0	applied	\N	\N	\N	\N	201230	201230	368388
26757	42623	1	applied	\N	\N	1000000000	\N	201231	201231	368389
26757	42642	2	applied	\N	\N	1000000000	\N	201232	201232	368390
26757	42743	3	applied	\N	\N	1000000000	\N	201233	201233	368391
26757	42745	4	applied	\N	\N	1000000000	\N	201234	201234	368392
26760	42784	0	applied	\N	\N	\N	\N	201241	201241	368399
26760	42785	1	applied	\N	\N	\N	\N	201242	201242	368400
26760	42786	2	applied	\N	\N	\N	\N	201243	201243	368401
26760	42787	3	applied	\N	\N	\N	\N	201244	201244	368402
26760	42788	4	applied	\N	\N	\N	\N	201245	201245	368403
26760	42789	5	applied	\N	\N	\N	\N	201246	201246	368404
26764	42797	0	applied	\N	\N	\N	\N	201254	201254	368412
26764	42798	1	applied	\N	\N	\N	\N	201255	201255	368413
26764	42800	3	applied	\N	\N	\N	\N	201257	201257	368415
26764	42801	4	applied	\N	\N	\N	\N	201258	201258	368416
26764	42802	5	applied	\N	\N	\N	\N	201259	201259	368417
26764	42803	6	applied	\N	\N	\N	\N	201260	201260	368418
26764	42804	7	applied	\N	\N	\N	\N	201261	201261	368419
26771	42825	6	applied	\N	\N	\N	\N	201329	201329	368487
26771	42826	7	applied	\N	\N	\N	\N	201330	201330	368488
26771	42827	8	applied	\N	\N	\N	\N	201331	201331	368489
26771	42828	9	applied	\N	\N	\N	\N	201332	201332	368490
26771	42829	10	applied	\N	\N	\N	\N	201333	201333	368491
26771	42830	11	applied	\N	\N	\N	\N	201334	201334	368492
26771	42831	12	applied	\N	\N	\N	\N	201335	201335	368493
26771	42832	13	applied	\N	\N	\N	\N	201336	201336	368494
26771	42833	14	applied	\N	\N	\N	\N	201337	201337	368495
26771	42834	15	applied	\N	\N	\N	\N	201338	201338	368496
26771	42835	16	applied	\N	\N	\N	\N	201339	201339	368497
26771	42837	18	applied	\N	\N	\N	\N	201341	201341	368499
26771	42838	19	applied	\N	\N	\N	\N	201342	201342	368500
26774	42839	0	applied	\N	\N	\N	\N	201355	201355	368513
26774	42840	1	applied	\N	\N	\N	\N	201356	201356	368514
26774	42841	2	applied	\N	\N	\N	\N	201357	201357	368515
26774	42842	3	applied	\N	\N	\N	\N	201358	201358	368516
26774	42843	4	applied	\N	\N	\N	\N	201359	201359	368517
26774	42844	5	applied	\N	\N	\N	\N	201360	201360	368518
26785	42867	0	applied	\N	\N	\N	\N	201661	201661	368819
26785	42868	1	applied	\N	\N	\N	\N	201662	201662	368820
26785	42869	2	applied	\N	\N	\N	\N	201663	201663	368821
26790	42874	0	applied	\N	\N	\N	\N	201679	201679	368837
26790	42875	1	applied	\N	\N	\N	\N	201680	201680	368838
26790	42876	2	applied	\N	\N	\N	\N	201681	201681	368839
26792	42877	0	applied	\N	\N	\N	\N	201685	201685	368843
26792	42878	1	applied	\N	\N	\N	\N	201686	201686	368844
26792	42880	3	applied	\N	\N	\N	\N	201688	201688	368846
26792	42881	4	applied	\N	\N	\N	\N	201689	201689	368847
26792	42882	5	applied	\N	\N	\N	\N	201690	201690	368848
26792	42883	6	applied	\N	\N	\N	\N	201691	201691	368849
26792	42884	7	applied	\N	\N	\N	\N	201692	201692	368850
26792	42885	8	applied	\N	\N	\N	\N	201693	201693	368851
26792	42886	9	applied	\N	\N	\N	\N	201694	201694	368852
26799	42892	0	applied	\N	\N	\N	\N	201711	201711	368869
26799	42893	1	applied	\N	\N	\N	\N	201712	201712	368870
26799	42894	2	applied	\N	\N	\N	\N	201713	201713	368871
26799	42895	3	applied	\N	\N	\N	\N	201714	201714	368872
26807	42920	0	applied	\N	\N	\N	\N	201745	201745	368903
26807	42921	1	applied	\N	\N	\N	\N	201746	201746	368904
26807	42922	2	applied	\N	\N	\N	\N	201747	201747	368905
26811	42923	0	applied	\N	\N	\N	\N	201757	201757	368915
26811	42924	1	applied	\N	\N	\N	\N	201758	201758	368916
26815	42946	0	applied	\N	\N	\N	\N	201787	201787	368945
26815	42947	2	applied	\N	\N	\N	\N	201788	201788	368946
26815	42948	3	applied	\N	\N	\N	\N	201789	201789	368947
26815	42949	4	applied	\N	\N	\N	\N	201790	201790	368948
26817	42950	0	applied	\N	\N	\N	\N	201795	201795	368953
26817	42951	1	applied	\N	\N	\N	\N	201796	201796	368954
26721	42711	1	applied	\N	\N	\N	\N	201039	201039	368200
26724	42717	0	applied	\N	\N	\N	\N	201044	201044	368205
26740	42760	0	applied	\N	\N	\N	\N	201116	201116	368277
26740	42762	1	applied	\N	\N	\N	\N	201117	201117	368278
26740	42763	2	applied	\N	\N	\N	\N	201118	201118	368279
26742	42760	0	applied	\N	\N	\N	\N	201123	201123	368284
26742	42761	1	applied	\N	\N	\N	\N	201124	201124	368285
26742	42762	2	applied	\N	\N	\N	\N	201125	201125	368286
26742	42763	3	applied	\N	\N	\N	\N	201126	201126	368287
26746	42767	0	applied	\N	\N	\N	\N	201145	201145	368306
26746	42768	1	applied	\N	\N	\N	\N	201146	201146	368307
26746	42769	2	applied	\N	\N	\N	\N	201147	201147	368308
26746	42770	3	applied	\N	\N	\N	\N	201148	201148	368309
26746	42771	4	applied	\N	\N	\N	\N	201149	201149	368310
26746	42772	5	applied	\N	\N	\N	\N	201150	201150	368311
26746	42773	6	applied	\N	\N	\N	\N	201151	201151	368312
26748	42774	0	applied	\N	\N	\N	\N	201170	201170	368328
26748	42775	1	applied	\N	\N	\N	\N	201171	201171	368329
26750	42777	0	applied	\N	\N	\N	\N	201176	201176	368334
26750	42778	1	applied	\N	\N	\N	\N	201177	201177	368335
26750	42779	2	applied	\N	\N	\N	\N	201178	201178	368336
26752	42778	0	applied	\N	\N	\N	\N	201182	201182	368340
26752	42779	1	applied	\N	\N	\N	\N	201183	201183	368341
26755	42780	0	applied	\N	\N	\N	\N	201214	201214	368372
26755	42781	1	applied	\N	\N	\N	\N	201215	201215	368373
26755	42782	2	applied	\N	\N	\N	\N	201216	201216	368374
26755	42783	3	applied	\N	\N	\N	\N	201217	201217	368375
26763	42793	0	applied	\N	\N	\N	\N	201250	201250	368408
26763	42794	1	applied	\N	\N	\N	\N	201251	201251	368409
26763	42795	2	applied	\N	\N	\N	\N	201252	201252	368410
26763	42796	3	applied	\N	\N	\N	\N	201253	201253	368411
26764	42805	8	applied	\N	\N	\N	\N	201262	201262	368420
26764	42806	9	applied	\N	\N	\N	\N	201263	201263	368421
26768	42807	0	applied	\N	\N	\N	\N	201291	201291	368449
26768	42809	2	applied	\N	\N	\N	\N	201293	201293	368451
26768	42810	3	applied	\N	\N	\N	\N	201294	201294	368452
26768	42811	4	applied	\N	\N	\N	\N	201295	201295	368453
26768	42812	5	applied	\N	\N	\N	\N	201296	201296	368454
26769	42813	0	applied	\N	\N	\N	\N	201297	201297	368455
26769	42814	1	applied	\N	\N	\N	\N	201298	201298	368456
26769	42815	2	applied	\N	\N	\N	\N	201299	201299	368457
26769	42816	3	applied	\N	\N	\N	\N	201300	201300	368458
26769	42817	4	applied	\N	\N	\N	\N	201301	201301	368459
26769	42818	5	applied	\N	\N	\N	\N	201302	201302	368460
26770	42819	0	applied	\N	\N	\N	\N	201303	201303	368461
26770	42820	1	applied	\N	\N	\N	\N	201304	201304	368462
26770	42821	2	applied	\N	\N	\N	\N	201305	201305	368463
26770	42822	3	applied	\N	\N	\N	\N	201306	201306	368464
26770	42824	5	applied	\N	\N	\N	\N	201308	201308	368466
26770	42826	7	applied	\N	\N	\N	\N	201310	201310	368468
26770	42827	8	applied	\N	\N	\N	\N	201311	201311	368469
26770	42828	9	applied	\N	\N	\N	\N	201312	201312	368470
26770	42829	10	applied	\N	\N	\N	\N	201313	201313	368471
26770	42830	11	applied	\N	\N	\N	\N	201314	201314	368472
26770	42831	12	applied	\N	\N	\N	\N	201315	201315	368473
26770	42832	13	applied	\N	\N	\N	\N	201316	201316	368474
26770	42833	14	applied	\N	\N	\N	\N	201317	201317	368475
26770	42834	15	applied	\N	\N	\N	\N	201318	201318	368476
26770	42835	16	applied	\N	\N	\N	\N	201319	201319	368477
26770	42836	17	applied	\N	\N	\N	\N	201320	201320	368478
26770	42837	18	applied	\N	\N	\N	\N	201321	201321	368479
26770	42838	19	applied	\N	\N	\N	\N	201322	201322	368480
26773	42839	0	applied	\N	\N	\N	\N	201349	201349	368507
26773	42840	1	applied	\N	\N	\N	\N	201350	201350	368508
26773	42841	2	applied	\N	\N	\N	\N	201351	201351	368509
26773	42843	4	applied	\N	\N	\N	\N	201353	201353	368511
26773	42844	5	applied	\N	\N	\N	\N	201354	201354	368512
26775	42104	0	applied	\N	\N	\N	\N	201361	201361	368519
26775	42105	1	applied	\N	\N	\N	\N	201362	201362	368520
26775	42112	2	applied	\N	\N	\N	\N	201363	201363	368521
26775	42115	3	applied	\N	\N	\N	\N	201364	201364	368522
26775	42116	4	applied	\N	\N	\N	\N	201365	201365	368523
26775	42122	5	applied	\N	\N	\N	\N	201366	201366	368524
26775	42128	6	applied	\N	\N	\N	\N	201367	201367	368525
26775	42132	7	applied	\N	\N	\N	\N	201368	201368	368526
26775	42136	8	applied	\N	\N	\N	\N	201369	201369	368527
26775	42141	9	applied	\N	\N	\N	\N	201370	201370	368528
26775	42144	10	applied	\N	\N	\N	\N	201371	201371	368529
26775	42147	11	applied	\N	\N	\N	\N	201372	201372	368530
26775	42151	12	applied	\N	\N	\N	\N	201373	201373	368531
26775	42154	13	applied	\N	\N	\N	\N	201374	201374	368532
26775	42161	15	applied	\N	\N	\N	\N	201376	201376	368534
26775	42164	16	applied	\N	\N	\N	\N	201377	201377	368535
26775	42167	17	applied	\N	\N	\N	\N	201378	201378	368536
26775	42168	18	applied	\N	\N	\N	\N	201379	201379	368537
26775	42170	19	applied	\N	\N	\N	\N	201380	201380	368538
26775	42177	20	applied	\N	\N	\N	\N	201381	201381	368539
26775	42180	21	applied	\N	\N	\N	\N	201382	201382	368540
26775	42181	22	applied	\N	\N	\N	\N	201383	201383	368541
26775	42187	23	applied	\N	\N	\N	\N	201384	201384	368542
26775	42190	24	applied	\N	\N	\N	\N	201385	201385	368543
26775	42191	25	applied	\N	\N	\N	\N	201386	201386	368544
26775	42197	26	applied	\N	\N	\N	\N	201387	201387	368545
26775	42200	27	applied	\N	\N	\N	\N	201388	201388	368546
26775	42203	28	applied	\N	\N	\N	\N	201389	201389	368547
26775	42207	29	applied	\N	\N	\N	\N	201390	201390	368548
26775	42210	30	applied	\N	\N	\N	\N	201391	201391	368549
26775	42214	32	applied	\N	\N	\N	\N	201393	201393	368551
26775	42215	33	applied	\N	\N	\N	\N	201394	201394	368552
26775	42223	34	applied	\N	\N	\N	\N	201395	201395	368553
26775	42227	35	applied	\N	\N	\N	\N	201396	201396	368554
26775	42230	36	applied	\N	\N	\N	\N	201397	201397	368555
26775	42233	37	applied	\N	\N	\N	\N	201398	201398	368556
26782	42864	0	applied	\N	\N	\N	\N	201636	201636	368794
26782	42865	1	applied	\N	\N	\N	\N	201637	201637	368795
26782	42866	2	applied	\N	\N	\N	\N	201638	201638	368796
26786	42870	0	applied	\N	\N	\N	\N	201664	201664	368822
26786	42871	1	applied	\N	\N	\N	\N	201665	201665	368823
26786	42872	2	applied	\N	\N	\N	\N	201666	201666	368824
26786	42873	3	applied	\N	\N	\N	\N	201667	201667	368825
26788	42870	0	applied	\N	\N	\N	\N	201672	201672	368830
26737	42757	0	applied	\N	\N	\N	\N	201109	201109	368270
26737	42758	1	applied	\N	\N	\N	\N	201110	201110	368271
26762	42792	2	applied	\N	\N	\N	\N	201249	201249	368407
26766	42797	0	applied	\N	\N	\N	\N	201271	201271	368429
26766	42798	1	applied	\N	\N	\N	\N	201272	201272	368430
26766	42799	2	applied	\N	\N	\N	\N	201273	201273	368431
26766	42800	3	applied	\N	\N	\N	\N	201274	201274	368432
26766	42801	4	applied	\N	\N	\N	\N	201275	201275	368433
26766	42802	5	applied	\N	\N	\N	\N	201276	201276	368434
26766	42803	6	applied	\N	\N	\N	\N	201277	201277	368435
26766	42804	7	applied	\N	\N	\N	\N	201278	201278	368436
26766	42805	8	applied	\N	\N	\N	\N	201279	201279	368437
26766	42806	9	applied	\N	\N	\N	\N	201280	201280	368438
26767	42797	0	applied	\N	\N	\N	\N	201281	201281	368439
26767	42798	1	applied	\N	\N	\N	\N	201282	201282	368440
26767	42799	2	applied	\N	\N	\N	\N	201283	201283	368441
26767	42800	3	applied	\N	\N	\N	\N	201284	201284	368442
26767	42801	4	applied	\N	\N	\N	\N	201285	201285	368443
26767	42803	6	applied	\N	\N	\N	\N	201287	201287	368445
26767	42804	7	applied	\N	\N	\N	\N	201288	201288	368446
26767	42805	8	applied	\N	\N	\N	\N	201289	201289	368447
26767	42806	9	applied	\N	\N	\N	\N	201290	201290	368448
26772	42839	0	applied	\N	\N	\N	\N	201343	201343	368501
26772	42840	1	applied	\N	\N	\N	\N	201344	201344	368502
26772	42841	2	applied	\N	\N	\N	\N	201345	201345	368503
26772	42842	3	applied	\N	\N	\N	\N	201346	201346	368504
26772	42843	4	applied	\N	\N	\N	\N	201347	201347	368505
26772	42844	5	applied	\N	\N	\N	\N	201348	201348	368506
26776	42104	0	applied	\N	\N	\N	\N	201486	201486	368644
26776	42105	1	applied	\N	\N	\N	\N	201487	201487	368645
26776	42112	2	applied	\N	\N	\N	\N	201488	201488	368646
26776	42115	3	applied	\N	\N	\N	\N	201489	201489	368647
26776	42116	4	applied	\N	\N	\N	\N	201490	201490	368648
26776	42122	5	applied	\N	\N	\N	\N	201491	201491	368649
26776	42132	7	applied	\N	\N	\N	\N	201493	201493	368651
26776	42136	8	applied	\N	\N	\N	\N	201494	201494	368652
26776	42141	9	applied	\N	\N	\N	\N	201495	201495	368653
26776	42144	10	applied	\N	\N	\N	\N	201496	201496	368654
26776	42147	11	applied	\N	\N	\N	\N	201497	201497	368655
26776	42151	12	applied	\N	\N	\N	\N	201498	201498	368656
26776	42154	13	applied	\N	\N	\N	\N	201499	201499	368657
26776	42155	14	applied	\N	\N	\N	\N	201500	201500	368658
26776	42161	15	applied	\N	\N	\N	\N	201501	201501	368659
26776	42164	16	applied	\N	\N	\N	\N	201502	201502	368660
26776	42167	17	applied	\N	\N	\N	\N	201503	201503	368661
26776	42168	18	applied	\N	\N	\N	\N	201504	201504	368662
26776	42170	19	applied	\N	\N	\N	\N	201505	201505	368663
26776	42177	20	applied	\N	\N	\N	\N	201506	201506	368664
26776	42180	21	applied	\N	\N	\N	\N	201507	201507	368665
26776	42181	22	applied	\N	\N	\N	\N	201508	201508	368666
26776	42190	24	applied	\N	\N	\N	\N	201510	201510	368668
26776	42191	25	applied	\N	\N	\N	\N	201511	201511	368669
26776	42197	26	applied	\N	\N	\N	\N	201512	201512	368670
26776	42200	27	applied	\N	\N	\N	\N	201513	201513	368671
26776	42203	28	applied	\N	\N	\N	\N	201514	201514	368672
26776	42207	29	applied	\N	\N	\N	\N	201515	201515	368673
26776	42210	30	applied	\N	\N	\N	\N	201516	201516	368674
26776	42213	31	applied	\N	\N	\N	\N	201517	201517	368675
26776	42214	32	applied	\N	\N	\N	\N	201518	201518	368676
26776	42215	33	applied	\N	\N	\N	\N	201519	201519	368677
26776	42223	34	applied	\N	\N	\N	\N	201520	201520	368678
26776	42227	35	applied	\N	\N	\N	\N	201521	201521	368679
26776	42230	36	applied	\N	\N	\N	\N	201522	201522	368680
26788	42871	1	applied	\N	\N	\N	\N	201673	201673	368831
26788	42872	2	applied	\N	\N	\N	\N	201674	201674	368832
26788	42873	3	applied	\N	\N	\N	\N	201675	201675	368833
26793	42888	1	applied	\N	\N	\N	\N	201696	201696	368854
26793	42889	2	applied	\N	\N	\N	\N	201697	201697	368855
26800	42896	0	applied	\N	\N	\N	\N	201715	201715	368873
26800	42897	1	applied	\N	\N	\N	\N	201716	201716	368874
26800	42898	2	applied	\N	\N	\N	\N	201717	201717	368875
26802	42899	0	applied	\N	\N	\N	\N	201721	201721	368879
26802	42900	1	applied	\N	\N	\N	\N	201722	201722	368880
26802	42901	2	applied	\N	\N	\N	\N	201723	201723	368881
26805	42906	0	applied	\N	\N	\N	\N	201731	201731	368889
26805	42907	1	applied	\N	\N	\N	\N	201732	201732	368890
26805	42908	2	applied	\N	\N	\N	\N	201733	201733	368891
26805	42909	3	applied	\N	\N	\N	\N	201734	201734	368892
26808	42923	0	applied	\N	\N	\N	\N	201748	201748	368906
26808	42924	1	applied	\N	\N	\N	\N	201749	201749	368907
26808	42925	2	applied	\N	\N	\N	\N	201750	201750	368908
26813	42926	0	applied	\N	\N	\N	\N	201767	201767	368925
26813	42928	2	applied	\N	\N	\N	\N	201769	201769	368927
26813	42929	3	applied	\N	\N	\N	\N	201770	201770	368928
26813	42930	4	applied	\N	\N	\N	\N	201771	201771	368929
26813	42931	5	applied	\N	\N	\N	\N	201772	201772	368930
26813	42932	6	applied	\N	\N	\N	\N	201773	201773	368931
26825	42960	0	applied	\N	\N	\N	\N	201889	201889	369047
26825	42961	1	applied	\N	\N	\N	\N	201890	201890	369048
26825	42962	2	applied	\N	\N	\N	\N	201891	201891	369049
26825	42963	3	applied	\N	\N	\N	\N	201892	201892	369050
26829	42966	0	applied	\N	\N	\N	\N	201903	201903	369061
26829	42967	1	applied	\N	\N	\N	\N	201904	201904	369062
26829	42968	2	applied	\N	\N	\N	\N	201905	201905	369063
26832	42973	0	applied	\N	\N	\N	\N	201914	201914	369072
26832	42974	1	applied	\N	\N	\N	\N	201915	201915	369073
26832	42975	2	applied	\N	\N	\N	\N	201916	201916	369074
26834	42973	0	applied	\N	\N	\N	\N	201920	201920	369078
26837	42989	0	applied	\N	\N	\N	\N	201935	201935	369093
26837	42990	1	applied	\N	\N	\N	\N	201936	201936	369094
26837	42991	2	applied	\N	\N	\N	\N	201937	201937	369095
26839	42992	0	applied	\N	\N	\N	\N	201941	201941	369099
26839	42993	1	applied	\N	\N	\N	\N	201942	201942	369100
26839	42994	2	applied	\N	\N	\N	\N	201943	201943	369101
26839	42995	3	applied	\N	\N	\N	\N	201944	201944	369102
26844	43002	0	applied	\N	\N	\N	\N	201958	201958	369116
26844	43003	1	applied	\N	\N	\N	\N	201959	201959	369117
26844	43004	2	applied	\N	\N	\N	\N	201960	201960	369118
26844	43005	3	applied	\N	\N	\N	\N	201961	201961	369119
26845	43006	0	applied	\N	\N	\N	\N	201962	201962	369120
26845	43007	1	applied	\N	\N	\N	\N	201963	201963	369121
26845	43008	2	applied	\N	\N	\N	\N	201964	201964	369122
26758	42789	5	applied	\N	\N	\N	\N	201240	201240	368398
26762	42790	0	applied	\N	\N	\N	\N	201247	201247	368405
26775	42250	42	applied	\N	\N	\N	\N	201403	201403	368561
26775	42253	43	applied	\N	\N	\N	\N	201404	201404	368562
26775	42256	44	applied	\N	\N	\N	\N	201405	201405	368563
26775	42260	45	applied	\N	\N	\N	\N	201406	201406	368564
26775	42261	46	applied	\N	\N	\N	\N	201407	201407	368565
26775	42262	47	applied	\N	\N	\N	\N	201408	201408	368566
26775	42269	48	applied	\N	\N	\N	\N	201409	201409	368567
26775	42270	49	applied	\N	\N	\N	\N	201410	201410	368568
26775	42276	50	applied	\N	\N	\N	\N	201411	201411	368569
26775	42280	51	applied	\N	\N	\N	\N	201412	201412	368570
26775	42281	52	applied	\N	\N	\N	\N	201413	201413	368571
26775	42289	53	applied	\N	\N	\N	\N	201414	201414	368572
26775	42290	54	applied	\N	\N	\N	\N	201415	201415	368573
26775	42298	55	applied	\N	\N	\N	\N	201416	201416	368574
26775	42299	56	applied	\N	\N	\N	\N	201417	201417	368575
26775	42300	57	applied	\N	\N	\N	\N	201418	201418	368576
26775	42311	59	applied	\N	\N	\N	\N	201420	201420	368578
26775	42313	60	applied	\N	\N	\N	\N	201421	201421	368579
26775	42317	61	applied	\N	\N	\N	\N	201422	201422	368580
26775	42320	62	applied	\N	\N	\N	\N	201423	201423	368581
26775	42321	63	applied	\N	\N	\N	\N	201424	201424	368582
26775	42327	64	applied	\N	\N	\N	\N	201425	201425	368583
26775	42328	65	applied	\N	\N	\N	\N	201426	201426	368584
26775	42333	66	applied	\N	\N	\N	\N	201427	201427	368585
26775	42336	67	applied	\N	\N	\N	\N	201428	201428	368586
26775	42340	68	applied	\N	\N	\N	\N	201429	201429	368587
26775	42343	69	applied	\N	\N	\N	\N	201430	201430	368588
26775	42346	70	applied	\N	\N	\N	\N	201431	201431	368589
26775	42349	71	applied	\N	\N	\N	\N	201432	201432	368590
26775	42353	72	applied	\N	\N	\N	\N	201433	201433	368591
26775	42356	73	applied	\N	\N	\N	\N	201434	201434	368592
26775	42357	74	applied	\N	\N	\N	\N	201435	201435	368593
26775	42367	76	applied	\N	\N	\N	\N	201437	201437	368595
26775	42370	77	applied	\N	\N	\N	\N	201438	201438	368596
26775	42371	78	applied	\N	\N	\N	\N	201439	201439	368597
26775	42372	79	applied	\N	\N	\N	\N	201440	201440	368598
26775	42382	80	applied	\N	\N	\N	\N	201441	201441	368599
26775	42386	81	applied	\N	\N	\N	\N	201442	201442	368600
26775	42387	82	applied	\N	\N	\N	\N	201443	201443	368601
26775	42392	83	applied	\N	\N	\N	\N	201444	201444	368602
26775	42393	84	applied	\N	\N	\N	\N	201445	201445	368603
26775	42399	86	applied	\N	\N	\N	\N	201446	201446	368604
26775	42400	87	applied	\N	\N	\N	\N	201447	201447	368605
26775	42405	88	applied	\N	\N	\N	\N	201448	201448	368606
26775	42409	89	applied	\N	\N	\N	\N	201449	201449	368607
26775	42410	90	applied	\N	\N	\N	\N	201450	201450	368608
26775	42415	91	applied	\N	\N	\N	\N	201451	201451	368609
26775	42419	92	applied	\N	\N	\N	\N	201452	201452	368610
26775	42425	94	applied	\N	\N	\N	\N	201454	201454	368612
26775	42429	95	applied	\N	\N	\N	\N	201455	201455	368613
26775	42434	96	applied	\N	\N	\N	\N	201456	201456	368614
26775	42437	97	applied	\N	\N	\N	\N	201457	201457	368615
26775	42438	98	applied	\N	\N	\N	\N	201458	201458	368616
26775	42439	99	applied	\N	\N	\N	\N	201459	201459	368617
26775	42447	100	applied	\N	\N	\N	\N	201460	201460	368618
26775	42451	101	applied	\N	\N	\N	\N	201461	201461	368619
26775	42453	102	applied	\N	\N	\N	\N	201462	201462	368620
26775	42456	103	applied	\N	\N	\N	\N	201463	201463	368621
26775	42464	104	applied	\N	\N	\N	\N	201464	201464	368622
26775	42472	105	applied	\N	\N	\N	\N	201465	201465	368623
26775	42473	106	applied	\N	\N	\N	\N	201466	201466	368624
26776	42233	37	applied	\N	\N	\N	\N	201523	201523	368681
26776	42236	38	applied	\N	\N	\N	\N	201524	201524	368682
26776	42240	39	applied	\N	\N	\N	\N	201525	201525	368683
26776	42246	41	applied	\N	\N	\N	\N	201527	201527	368685
26776	42250	42	applied	\N	\N	\N	\N	201528	201528	368686
26776	42253	43	applied	\N	\N	\N	\N	201529	201529	368687
26776	42256	44	applied	\N	\N	\N	\N	201530	201530	368688
26776	42260	45	applied	\N	\N	\N	\N	201531	201531	368689
26776	42261	46	applied	\N	\N	\N	\N	201532	201532	368690
26776	42262	47	applied	\N	\N	\N	\N	201533	201533	368691
26776	42269	48	applied	\N	\N	\N	\N	201534	201534	368692
26776	42270	49	applied	\N	\N	\N	\N	201535	201535	368693
26776	42276	50	applied	\N	\N	\N	\N	201536	201536	368694
26776	42280	51	applied	\N	\N	\N	\N	201537	201537	368695
26776	42281	52	applied	\N	\N	\N	\N	201538	201538	368696
26776	42289	53	applied	\N	\N	\N	\N	201539	201539	368697
26776	42290	54	applied	\N	\N	\N	\N	201540	201540	368698
26776	42298	55	applied	\N	\N	\N	\N	201541	201541	368699
26776	42299	57	applied	\N	\N	\N	\N	201542	201542	368700
26776	42308	59	applied	\N	\N	\N	\N	201544	201544	368702
26776	42311	60	applied	\N	\N	\N	\N	201545	201545	368703
26776	42313	61	applied	\N	\N	\N	\N	201546	201546	368704
26776	42317	62	applied	\N	\N	\N	\N	201547	201547	368705
26776	42320	63	applied	\N	\N	\N	\N	201548	201548	368706
26776	42321	64	applied	\N	\N	\N	\N	201549	201549	368707
26776	42327	65	applied	\N	\N	\N	\N	201550	201550	368708
26776	42328	66	applied	\N	\N	\N	\N	201551	201551	368709
26776	42333	67	applied	\N	\N	\N	\N	201552	201552	368710
26776	42336	68	applied	\N	\N	\N	\N	201553	201553	368711
26776	42340	69	applied	\N	\N	\N	\N	201554	201554	368712
26776	42343	70	applied	\N	\N	\N	\N	201555	201555	368713
26776	42346	71	applied	\N	\N	\N	\N	201556	201556	368714
26776	42349	72	applied	\N	\N	\N	\N	201557	201557	368715
26776	42353	73	applied	\N	\N	\N	\N	201558	201558	368716
26776	42356	74	applied	\N	\N	\N	\N	201559	201559	368717
26776	42363	76	applied	\N	\N	\N	\N	201561	201561	368719
26776	42367	77	applied	\N	\N	\N	\N	201562	201562	368720
26776	42370	78	applied	\N	\N	\N	\N	201563	201563	368721
26776	42371	79	applied	\N	\N	\N	\N	201564	201564	368722
26776	42372	80	applied	\N	\N	\N	\N	201565	201565	368723
26776	42382	81	applied	\N	\N	\N	\N	201566	201566	368724
26776	42386	82	applied	\N	\N	\N	\N	201567	201567	368725
26776	42387	83	applied	\N	\N	\N	\N	201568	201568	368726
26776	42392	84	applied	\N	\N	\N	\N	201569	201569	368727
26776	42393	85	applied	\N	\N	\N	\N	201570	201570	368728
26776	42399	86	applied	\N	\N	\N	\N	201571	201571	368729
26776	42400	87	applied	\N	\N	\N	\N	201572	201572	368730
26776	42405	88	applied	\N	\N	\N	\N	201573	201573	368731
26776	42409	89	applied	\N	\N	\N	\N	201574	201574	368732
26775	42240	39	applied	\N	\N	\N	\N	201400	201400	368558
26775	42243	40	applied	\N	\N	\N	\N	201401	201401	368559
26775	42494	110	applied	\N	\N	\N	\N	201470	201470	368628
26775	42497	111	applied	\N	\N	\N	\N	201471	201471	368629
26775	42500	112	applied	\N	\N	\N	\N	201472	201472	368630
26775	42503	113	applied	\N	\N	\N	\N	201473	201473	368631
26775	42504	114	applied	\N	\N	\N	\N	201474	201474	368632
26775	42510	115	applied	\N	\N	\N	\N	201475	201475	368633
26775	42514	116	applied	\N	\N	\N	\N	201476	201476	368634
26775	42523	118	applied	\N	\N	\N	\N	201478	201478	368636
26775	42527	119	applied	\N	\N	\N	\N	201479	201479	368637
26775	42528	120	applied	\N	\N	\N	\N	201480	201480	368638
26775	42529	121	applied	\N	\N	\N	\N	201481	201481	368639
26775	42536	122	applied	\N	\N	\N	\N	201482	201482	368640
26775	42540	123	applied	\N	\N	\N	\N	201483	201483	368641
26775	42541	124	applied	\N	\N	\N	\N	201484	201484	368642
26775	42546	125	applied	\N	\N	\N	\N	201485	201485	368643
26776	42410	90	applied	\N	\N	\N	\N	201575	201575	368733
26776	42415	91	applied	\N	\N	\N	\N	201576	201576	368734
26776	42419	92	applied	\N	\N	\N	\N	201577	201577	368735
26776	42420	93	applied	\N	\N	\N	\N	201578	201578	368736
26776	42425	94	applied	\N	\N	\N	\N	201579	201579	368737
26776	42429	95	applied	\N	\N	\N	\N	201580	201580	368738
26776	42434	96	applied	\N	\N	\N	\N	201581	201581	368739
26776	42437	97	applied	\N	\N	\N	\N	201582	201582	368740
26776	42439	99	applied	\N	\N	\N	\N	201584	201584	368742
26776	42447	100	applied	\N	\N	\N	\N	201585	201585	368743
26776	42451	101	applied	\N	\N	\N	\N	201586	201586	368744
26776	42453	102	applied	\N	\N	\N	\N	201587	201587	368745
26776	42456	103	applied	\N	\N	\N	\N	201588	201588	368746
26776	42464	104	applied	\N	\N	\N	\N	201589	201589	368747
26776	42472	105	applied	\N	\N	\N	\N	201590	201590	368748
26776	42473	106	applied	\N	\N	\N	\N	201591	201591	368749
26776	42474	107	applied	\N	\N	\N	\N	201592	201592	368750
26776	42475	108	applied	\N	\N	\N	\N	201593	201593	368751
26776	42476	109	applied	\N	\N	\N	\N	201594	201594	368752
26776	42494	110	applied	\N	\N	\N	\N	201595	201595	368753
26776	42497	111	applied	\N	\N	\N	\N	201596	201596	368754
26776	42500	112	applied	\N	\N	\N	\N	201597	201597	368755
26776	42503	113	applied	\N	\N	\N	\N	201598	201598	368756
26776	42504	114	applied	\N	\N	\N	\N	201599	201599	368757
26776	42514	116	applied	\N	\N	\N	\N	201601	201601	368759
26776	42518	117	applied	\N	\N	\N	\N	201602	201602	368760
26776	42523	118	applied	\N	\N	\N	\N	201603	201603	368761
26776	42527	119	applied	\N	\N	\N	\N	201604	201604	368762
26776	42528	120	applied	\N	\N	\N	\N	201605	201605	368763
26776	42529	121	applied	\N	\N	\N	\N	201606	201606	368764
26776	42536	122	applied	\N	\N	\N	\N	201607	201607	368765
26776	42540	123	applied	\N	\N	\N	\N	201608	201608	368766
26776	42541	124	applied	\N	\N	\N	\N	201609	201609	368767
26776	42546	125	applied	\N	\N	\N	\N	201610	201610	368768
26777	42845	0	applied	\N	\N	\N	\N	201611	201611	368769
26777	42846	1	applied	\N	\N	\N	\N	201612	201612	368770
26777	42847	2	applied	\N	\N	\N	\N	201613	201613	368771
26777	42848	3	applied	\N	\N	\N	\N	201614	201614	368772
26778	42849	0	applied	\N	\N	\N	\N	201615	201615	368773
26778	42850	1	applied	\N	\N	\N	\N	201616	201616	368774
26779	42852	0	applied	\N	\N	\N	\N	201618	201618	368776
26779	42853	1	applied	\N	\N	\N	\N	201619	201619	368777
26779	42854	2	applied	\N	\N	\N	\N	201620	201620	368778
26779	42855	3	applied	\N	\N	\N	\N	201621	201621	368779
26779	42856	5	applied	\N	\N	\N	\N	201622	201622	368780
26779	42857	6	applied	\N	\N	1000000000	\N	201623	201623	368781
26779	42858	7	applied	\N	\N	1000000000	\N	201624	201624	368782
26779	42859	8	applied	\N	\N	\N	\N	201625	201625	368783
26779	42860	9	applied	\N	\N	\N	\N	201626	201626	368784
26779	42861	10	applied	\N	\N	\N	\N	201627	201627	368785
26779	42862	11	applied	\N	\N	\N	\N	201628	201628	368786
26779	42863	12	applied	\N	\N	\N	\N	201629	201629	368787
26780	42857	0	applied	\N	\N	1000000000	\N	201630	201630	368788
26780	42858	1	applied	\N	\N	1000000000	\N	201631	201631	368789
26780	42863	2	applied	\N	\N	\N	\N	201632	201632	368790
26781	42864	0	applied	\N	\N	\N	\N	201633	201633	368791
26781	42866	2	applied	\N	\N	\N	\N	201635	201635	368793
26783	42867	0	applied	\N	\N	\N	\N	201639	201639	368797
26783	42868	1	applied	\N	\N	\N	\N	201640	201640	368798
26783	42869	2	applied	\N	\N	\N	\N	201641	201641	368799
26784	42511	0	applied	\N	\N	1000000000	\N	201642	201642	368800
26784	42537	1	applied	\N	\N	\N	\N	201643	201643	368801
26784	42672	2	applied	\N	\N	\N	\N	201644	201644	368802
26784	42373	3	applied	\N	\N	\N	\N	201645	201645	368803
26784	42374	4	applied	\N	\N	\N	\N	201646	201646	368804
26784	42121	5	applied	\N	\N	\N	\N	201647	201647	368805
26784	42137	6	applied	\N	\N	\N	\N	201648	201648	368806
26784	42149	7	applied	\N	\N	\N	\N	201649	201649	368807
26784	42156	8	applied	\N	\N	\N	\N	201650	201650	368808
26784	42169	9	applied	\N	\N	\N	\N	201651	201651	368809
26784	42186	10	applied	\N	\N	\N	\N	201652	201652	368810
26787	42870	0	applied	\N	\N	\N	\N	201668	201668	368826
26787	42872	2	applied	\N	\N	\N	\N	201670	201670	368828
26787	42873	3	applied	\N	\N	\N	\N	201671	201671	368829
26789	42874	0	applied	\N	\N	\N	\N	201676	201676	368834
26789	42875	1	applied	\N	\N	\N	\N	201677	201677	368835
26789	42876	2	applied	\N	\N	\N	\N	201678	201678	368836
26794	42887	0	applied	\N	\N	\N	\N	201698	201698	368856
26794	42888	1	applied	\N	\N	\N	\N	201699	201699	368857
26794	42889	2	applied	\N	\N	\N	\N	201700	201700	368858
26798	42890	0	applied	\N	\N	\N	\N	201709	201709	368867
26798	42891	1	applied	\N	\N	\N	\N	201710	201710	368868
26801	42896	0	applied	\N	\N	\N	\N	201718	201718	368876
26801	42897	1	applied	\N	\N	\N	\N	201719	201719	368877
26801	42898	2	applied	\N	\N	\N	\N	201720	201720	368878
26803	42899	0	applied	\N	\N	\N	\N	201724	201724	368882
26803	42900	1	applied	\N	\N	\N	\N	201725	201725	368883
26803	42901	2	applied	\N	\N	\N	\N	201726	201726	368884
26806	42911	1	applied	\N	\N	\N	\N	201736	201736	368894
26806	42912	2	applied	\N	\N	\N	\N	201737	201737	368895
26806	42913	3	applied	\N	\N	\N	\N	201738	201738	368896
26806	42914	4	applied	\N	\N	\N	\N	201739	201739	368897
26806	42915	5	applied	\N	\N	\N	\N	201740	201740	368898
26806	42916	6	applied	\N	\N	\N	\N	201741	201741	368899
26775	42475	108	applied	\N	\N	\N	\N	201468	201468	368626
26775	42476	109	applied	\N	\N	\N	\N	201469	201469	368627
26784	42238	15	applied	\N	\N	\N	\N	201657	201657	368815
26784	42247	16	applied	\N	\N	\N	\N	201658	201658	368816
26784	42259	17	applied	\N	\N	\N	\N	201659	201659	368817
26784	42271	18	applied	\N	\N	\N	\N	201660	201660	368818
26791	42874	0	applied	\N	\N	\N	\N	201682	201682	368840
26791	42875	1	applied	\N	\N	\N	\N	201683	201683	368841
26791	42876	2	applied	\N	\N	\N	\N	201684	201684	368842
26795	42887	0	applied	\N	\N	\N	\N	201701	201701	368859
26795	42888	1	applied	\N	\N	\N	\N	201702	201702	368860
26795	42889	2	applied	\N	\N	\N	\N	201703	201703	368861
26796	42887	0	applied	\N	\N	\N	\N	201704	201704	368862
26796	42888	1	applied	\N	\N	\N	\N	201705	201705	368863
26796	42889	2	applied	\N	\N	\N	\N	201706	201706	368864
26797	42890	0	applied	\N	\N	\N	\N	201707	201707	368865
26797	42891	1	applied	\N	\N	\N	\N	201708	201708	368866
26804	42902	0	applied	\N	\N	\N	\N	201727	201727	368885
26804	42904	2	applied	\N	\N	\N	\N	201729	201729	368887
26804	42905	3	applied	\N	\N	\N	\N	201730	201730	368888
26806	42917	7	applied	\N	\N	\N	\N	201742	201742	368900
26806	42918	8	applied	\N	\N	\N	\N	201743	201743	368901
26806	42919	9	applied	\N	\N	\N	\N	201744	201744	368902
26809	42923	0	applied	\N	\N	\N	\N	201751	201751	368909
26809	42924	1	applied	\N	\N	\N	\N	201752	201752	368910
26809	42925	2	applied	\N	\N	\N	\N	201753	201753	368911
26810	42923	0	applied	\N	\N	\N	\N	201754	201754	368912
26810	42924	1	applied	\N	\N	\N	\N	201755	201755	368913
26810	42925	2	applied	\N	\N	\N	\N	201756	201756	368914
26812	42926	0	applied	\N	\N	\N	\N	201760	201760	368918
26812	42927	1	applied	\N	\N	\N	\N	201761	201761	368919
26812	42928	2	applied	\N	\N	\N	\N	201762	201762	368920
26812	42929	3	applied	\N	\N	\N	\N	201763	201763	368921
26812	42930	4	applied	\N	\N	\N	\N	201764	201764	368922
26812	42932	6	applied	\N	\N	\N	\N	201766	201766	368924
26814	42933	0	applied	\N	\N	\N	\N	201774	201774	368932
26814	42934	1	applied	\N	\N	\N	\N	201775	201775	368933
26814	42935	2	applied	\N	\N	\N	\N	201776	201776	368934
26814	42936	3	applied	\N	\N	\N	\N	201777	201777	368935
26814	42937	4	applied	\N	\N	\N	\N	201778	201778	368936
26814	42938	5	applied	\N	\N	\N	\N	201779	201779	368937
26814	42939	6	applied	\N	\N	\N	\N	201780	201780	368938
26814	42940	7	applied	\N	\N	\N	\N	201781	201781	368939
26814	42941	8	applied	\N	\N	\N	\N	201782	201782	368940
26814	42942	9	applied	\N	\N	\N	\N	201783	201783	368941
26814	42943	10	applied	\N	\N	\N	\N	201784	201784	368942
26814	42944	11	applied	\N	\N	\N	\N	201785	201785	368943
26814	42945	12	applied	\N	\N	\N	\N	201786	201786	368944
26816	42946	0	applied	\N	\N	\N	\N	201791	201791	368949
26816	42947	2	applied	\N	\N	\N	\N	201792	201792	368950
26816	42949	4	applied	\N	\N	\N	\N	201794	201794	368952
26818	42950	0	applied	\N	\N	\N	\N	201798	201798	368956
26818	42953	1	applied	\N	\N	\N	\N	201799	201799	368957
26818	42951	2	applied	\N	\N	\N	\N	201800	201800	368958
26818	42952	3	applied	\N	\N	\N	\N	201801	201801	368959
26820	42953	0	applied	\N	\N	\N	\N	201806	201806	368964
26820	42954	1	applied	\N	\N	\N	\N	201807	201807	368965
26820	42955	2	applied	\N	\N	\N	\N	201808	201808	368966
26820	42956	3	applied	\N	\N	\N	\N	201809	201809	368967
26821	42346	0	applied	\N	\N	\N	\N	201810	201810	368968
26821	42349	1	applied	\N	\N	\N	\N	201811	201811	368969
26821	42353	2	applied	\N	\N	\N	\N	201812	201812	368970
26821	42356	3	applied	\N	\N	\N	\N	201813	201813	368971
26821	42357	4	applied	\N	\N	\N	\N	201814	201814	368972
26821	42363	5	applied	\N	\N	\N	\N	201815	201815	368973
26821	42367	6	applied	\N	\N	\N	\N	201816	201816	368974
26821	42371	8	applied	\N	\N	\N	\N	201818	201818	368976
26821	42372	9	applied	\N	\N	\N	\N	201819	201819	368977
26821	42382	10	applied	\N	\N	\N	\N	201820	201820	368978
26821	42386	11	applied	\N	\N	\N	\N	201821	201821	368979
26821	42387	12	applied	\N	\N	\N	\N	201822	201822	368980
26821	42392	13	applied	\N	\N	\N	\N	201823	201823	368981
26821	42393	14	applied	\N	\N	\N	\N	201824	201824	368982
26821	42399	15	applied	\N	\N	\N	\N	201825	201825	368983
26821	42400	16	applied	\N	\N	\N	\N	201826	201826	368984
26821	42405	17	applied	\N	\N	\N	\N	201827	201827	368985
26821	42409	18	applied	\N	\N	\N	\N	201828	201828	368986
26821	42410	19	applied	\N	\N	\N	\N	201829	201829	368987
26821	42415	20	applied	\N	\N	\N	\N	201830	201830	368988
26821	42419	21	applied	\N	\N	\N	\N	201831	201831	368989
26821	42420	22	applied	\N	\N	\N	\N	201832	201832	368990
26821	42425	23	applied	\N	\N	\N	\N	201833	201833	368991
26821	42434	25	applied	\N	\N	\N	\N	201835	201835	368993
26821	42437	26	applied	\N	\N	\N	\N	201836	201836	368994
26821	42438	27	applied	\N	\N	\N	\N	201837	201837	368995
26821	42439	28	applied	\N	\N	\N	\N	201838	201838	368996
26821	42447	29	applied	\N	\N	\N	\N	201839	201839	368997
26821	42451	30	applied	\N	\N	\N	\N	201840	201840	368998
26821	42453	31	applied	\N	\N	\N	\N	201841	201841	368999
26821	42456	32	applied	\N	\N	\N	\N	201842	201842	369000
26821	42464	33	applied	\N	\N	\N	\N	201843	201843	369001
26821	42472	34	applied	\N	\N	\N	\N	201844	201844	369002
26821	42473	35	applied	\N	\N	\N	\N	201845	201845	369003
26821	42474	36	applied	\N	\N	\N	\N	201846	201846	369004
26821	42475	37	applied	\N	\N	\N	\N	201847	201847	369005
26821	42476	38	applied	\N	\N	\N	\N	201848	201848	369006
26821	42494	39	applied	\N	\N	\N	\N	201849	201849	369007
26821	42497	40	applied	\N	\N	\N	\N	201850	201850	369008
26821	42503	42	applied	\N	\N	\N	\N	201852	201852	369010
26821	42504	43	applied	\N	\N	\N	\N	201853	201853	369011
26821	42510	44	applied	\N	\N	\N	\N	201854	201854	369012
26821	42514	45	applied	\N	\N	\N	\N	201855	201855	369013
26821	42518	46	applied	\N	\N	\N	\N	201856	201856	369014
26821	42523	47	applied	\N	\N	\N	\N	201857	201857	369015
26821	42527	48	applied	\N	\N	\N	\N	201858	201858	369016
26821	42528	49	applied	\N	\N	\N	\N	201859	201859	369017
26822	42957	0	applied	\N	\N	\N	\N	201879	201879	369037
26822	42958	1	applied	\N	\N	\N	\N	201880	201880	369038
26822	42959	2	applied	\N	\N	\N	\N	201881	201881	369039
26824	42960	0	applied	\N	\N	\N	\N	201885	201885	369043
26824	42961	1	applied	\N	\N	\N	\N	201886	201886	369044
26824	42962	2	applied	\N	\N	\N	\N	201887	201887	369045
26784	42204	12	applied	\N	\N	\N	\N	201654	201654	368812
26784	42219	13	applied	\N	\N	\N	\N	201655	201655	368813
26819	42955	2	applied	\N	\N	\N	\N	201804	201804	368962
26819	42956	3	applied	\N	\N	\N	\N	201805	201805	368963
26821	42529	50	applied	\N	\N	\N	\N	201860	201860	369018
26821	42536	51	applied	\N	\N	\N	\N	201861	201861	369019
26821	42540	52	applied	\N	\N	\N	\N	201862	201862	369020
26821	42541	53	applied	\N	\N	\N	\N	201863	201863	369021
26821	42546	54	applied	\N	\N	\N	\N	201864	201864	369022
26821	42550	55	applied	\N	\N	\N	\N	201865	201865	369023
26821	42553	56	applied	\N	\N	\N	\N	201866	201866	369024
26821	42556	57	applied	\N	\N	\N	\N	201867	201867	369025
26821	42560	58	applied	\N	\N	\N	\N	201868	201868	369026
26821	42563	59	applied	\N	\N	\N	\N	201869	201869	369027
26821	42566	60	applied	\N	\N	\N	\N	201870	201870	369028
26821	42573	62	applied	\N	\N	\N	\N	201872	201872	369030
26821	42576	63	applied	\N	\N	\N	\N	201873	201873	369031
26821	42577	64	applied	\N	\N	\N	\N	201874	201874	369032
26821	42583	65	applied	\N	\N	\N	\N	201875	201875	369033
26821	42586	66	applied	\N	\N	\N	\N	201876	201876	369034
26821	42589	67	applied	\N	\N	\N	\N	201877	201877	369035
26821	42593	68	applied	\N	\N	\N	\N	201878	201878	369036
26823	42906	0	applied	\N	\N	\N	\N	201882	201882	369040
26823	42857	1	applied	\N	\N	1000000000	\N	201883	201883	369041
26823	42858	2	applied	\N	\N	1000000000	\N	201884	201884	369042
26826	42960	0	applied	\N	\N	\N	\N	201893	201893	369051
26826	42961	1	applied	\N	\N	\N	\N	201894	201894	369052
26826	42962	2	applied	\N	\N	\N	\N	201895	201895	369053
26826	42963	3	applied	\N	\N	\N	\N	201896	201896	369054
26827	42960	0	applied	\N	\N	\N	\N	201897	201897	369055
26827	42961	1	applied	\N	\N	\N	\N	201898	201898	369056
26827	42963	3	applied	\N	\N	\N	\N	201900	201900	369058
26828	42964	0	applied	\N	\N	\N	\N	201901	201901	369059
26828	42965	1	applied	\N	\N	\N	\N	201902	201902	369060
26830	42969	0	applied	\N	\N	\N	\N	201906	201906	369064
26830	42970	1	applied	\N	\N	\N	\N	201907	201907	369065
26830	42971	2	applied	\N	\N	\N	\N	201908	201908	369066
26830	42972	3	applied	\N	\N	\N	\N	201909	201909	369067
26831	42969	0	applied	\N	\N	\N	\N	201910	201910	369068
26831	42970	1	applied	\N	\N	\N	\N	201911	201911	369069
26831	42971	2	applied	\N	\N	\N	\N	201912	201912	369070
26831	42972	3	applied	\N	\N	\N	\N	201913	201913	369071
26833	42973	0	applied	\N	\N	\N	\N	201917	201917	369075
26833	42974	1	applied	\N	\N	\N	\N	201918	201918	369076
26833	42975	2	applied	\N	\N	\N	\N	201919	201919	369077
26835	42976	0	applied	\N	\N	\N	\N	201922	201922	369080
26835	42977	1	applied	\N	\N	\N	\N	201923	201923	369081
26835	42979	3	applied	\N	\N	\N	\N	201925	201925	369083
26835	42980	4	applied	\N	\N	\N	\N	201926	201926	369084
26835	42981	5	applied	\N	\N	\N	\N	201927	201927	369085
26835	42982	6	applied	\N	\N	\N	\N	201928	201928	369086
26835	42983	7	applied	\N	\N	\N	\N	201929	201929	369087
26835	42984	8	applied	\N	\N	\N	\N	201930	201930	369088
26835	42985	9	applied	\N	\N	\N	\N	201931	201931	369089
26836	42986	0	applied	\N	\N	\N	\N	201932	201932	369090
26836	42987	1	applied	\N	\N	\N	\N	201933	201933	369091
26836	42988	2	applied	\N	\N	\N	\N	201934	201934	369092
26838	42989	0	applied	\N	\N	\N	\N	201938	201938	369096
26838	42990	1	applied	\N	\N	\N	\N	201939	201939	369097
26838	42991	2	applied	\N	\N	\N	\N	201940	201940	369098
26840	42992	0	applied	\N	\N	\N	\N	201945	201945	369103
26840	42993	1	applied	\N	\N	\N	\N	201946	201946	369104
26840	42994	2	applied	\N	\N	\N	\N	201947	201947	369105
26843	42999	0	applied	\N	\N	\N	\N	201955	201955	369113
26843	43000	1	applied	\N	\N	\N	\N	201956	201956	369114
26843	43001	2	applied	\N	\N	\N	\N	201957	201957	369115
26847	43021	0	applied	\N	\N	\N	\N	201977	201977	369135
26847	43022	1	applied	\N	\N	\N	\N	201978	201978	369136
26847	43023	2	applied	\N	\N	\N	\N	201979	201979	369137
26847	43024	3	applied	\N	\N	\N	\N	201980	201980	369138
26847	43025	4	applied	\N	\N	\N	\N	201981	201981	369139
26847	43026	5	applied	\N	\N	\N	\N	201982	201982	369140
26847	43027	6	applied	\N	\N	\N	\N	201983	201983	369141
26849	43028	0	applied	\N	\N	\N	\N	201987	201987	369145
26849	43029	1	applied	\N	\N	\N	\N	201988	201988	369146
26849	43030	2	applied	\N	\N	\N	\N	201989	201989	369147
26854	43041	0	applied	\N	\N	\N	\N	202006	202006	369164
26854	43042	1	applied	\N	\N	\N	\N	202007	202007	369165
26854	43043	2	applied	\N	\N	\N	\N	202008	202008	369166
26856	42867	1	applied	\N	\N	\N	\N	202013	202013	369171
26856	42870	2	applied	\N	\N	\N	\N	202014	202014	369172
26856	42874	3	applied	\N	\N	\N	\N	202015	202015	369173
26856	42877	4	applied	\N	\N	\N	\N	202016	202016	369174
26856	42878	5	applied	\N	\N	\N	\N	202017	202017	369175
26856	42879	6	applied	\N	\N	\N	\N	202018	202018	369176
26856	42887	7	applied	\N	\N	\N	\N	202019	202019	369177
26856	42890	8	applied	\N	\N	\N	\N	202020	202020	369178
26856	42892	9	applied	\N	\N	\N	\N	202021	202021	369179
26856	42896	10	applied	\N	\N	\N	\N	202022	202022	369180
26856	42899	11	applied	\N	\N	\N	\N	202023	202023	369181
26856	42902	12	applied	\N	\N	\N	\N	202024	202024	369182
26856	42907	13	applied	\N	\N	\N	\N	202025	202025	369183
26856	42910	14	applied	\N	\N	\N	\N	202026	202026	369184
26856	42911	15	applied	\N	\N	\N	\N	202027	202027	369185
26856	42912	16	applied	\N	\N	\N	\N	202028	202028	369186
26856	42923	18	applied	\N	\N	\N	\N	202030	202030	369188
26856	42926	19	applied	\N	\N	\N	\N	202031	202031	369189
26856	42927	20	applied	\N	\N	\N	\N	202032	202032	369190
26856	42933	21	applied	\N	\N	\N	\N	202033	202033	369191
26856	42934	22	applied	\N	\N	\N	\N	202034	202034	369192
26856	42935	23	applied	\N	\N	\N	\N	202035	202035	369193
26856	42936	24	applied	\N	\N	\N	\N	202036	202036	369194
26856	42946	25	applied	\N	\N	\N	\N	202037	202037	369195
26856	42953	26	applied	\N	\N	\N	\N	202038	202038	369196
26856	42954	27	applied	\N	\N	\N	\N	202039	202039	369197
26856	42957	28	applied	\N	\N	\N	\N	202040	202040	369198
26856	42960	29	applied	\N	\N	\N	\N	202041	202041	369199
26856	42964	30	applied	\N	\N	\N	\N	202042	202042	369200
26856	42966	31	applied	\N	\N	\N	\N	202043	202043	369201
26856	42969	32	applied	\N	\N	\N	\N	202044	202044	369202
26856	42973	33	applied	\N	\N	\N	\N	202045	202045	369203
26819	42953	0	applied	\N	\N	\N	\N	201802	201802	368960
26819	42954	1	applied	\N	\N	\N	\N	201803	201803	368961
26842	42999	0	applied	\N	\N	\N	\N	201952	201952	369110
26842	43000	1	applied	\N	\N	\N	\N	201953	201953	369111
26842	43001	2	applied	\N	\N	\N	\N	201954	201954	369112
26845	43009	3	applied	\N	\N	\N	\N	201965	201965	369123
26845	43010	4	applied	\N	\N	\N	\N	201966	201966	369124
26845	43011	5	applied	\N	\N	\N	\N	201967	201967	369125
26845	43012	6	applied	\N	\N	\N	\N	201968	201968	369126
26845	43013	7	applied	\N	\N	\N	\N	201969	201969	369127
26845	43014	8	applied	\N	\N	\N	\N	201970	201970	369128
26845	43015	9	applied	\N	\N	\N	\N	201971	201971	369129
26845	43016	10	applied	\N	\N	\N	\N	201972	201972	369130
26845	43017	11	applied	\N	\N	\N	\N	201973	201973	369131
26845	43018	12	applied	\N	\N	\N	\N	201974	201974	369132
26846	43019	0	applied	\N	\N	\N	\N	201975	201975	369133
26846	43020	1	applied	\N	\N	\N	\N	201976	201976	369134
26848	43028	0	applied	\N	\N	\N	\N	201984	201984	369142
26848	43030	2	applied	\N	\N	\N	\N	201986	201986	369144
26850	43031	0	applied	\N	\N	\N	\N	201990	201990	369148
26850	43032	1	applied	\N	\N	\N	\N	201991	201991	369149
26850	43033	2	applied	\N	\N	\N	\N	201992	201992	369150
26851	43034	0	applied	\N	\N	\N	\N	201993	201993	369151
26851	43035	1	applied	\N	\N	\N	\N	201994	201994	369152
26851	43036	2	applied	\N	\N	\N	\N	201995	201995	369153
26851	43037	3	applied	\N	\N	\N	\N	201996	201996	369154
26851	43038	4	applied	\N	\N	\N	\N	201997	201997	369155
26851	43039	5	applied	\N	\N	\N	\N	201998	201998	369156
26851	43040	6	applied	\N	\N	\N	\N	201999	201999	369157
26852	43041	0	applied	\N	\N	\N	\N	202000	202000	369158
26852	43042	1	applied	\N	\N	\N	\N	202001	202001	369159
26852	43043	2	applied	\N	\N	\N	\N	202002	202002	369160
26853	43041	0	applied	\N	\N	\N	\N	202003	202003	369161
26853	43042	1	applied	\N	\N	\N	\N	202004	202004	369162
26855	43041	0	applied	\N	\N	\N	\N	202009	202009	369167
26855	43042	1	applied	\N	\N	\N	\N	202010	202010	369168
26855	43043	2	applied	\N	\N	\N	\N	202011	202011	369169
26856	42977	35	applied	\N	\N	\N	\N	202047	202047	369205
26856	42978	36	applied	\N	\N	\N	\N	202048	202048	369206
26856	42986	37	applied	\N	\N	\N	\N	202049	202049	369207
26856	42989	38	applied	\N	\N	\N	\N	202050	202050	369208
26856	42992	39	applied	\N	\N	\N	\N	202051	202051	369209
26856	42996	40	applied	\N	\N	\N	\N	202052	202052	369210
26856	42999	41	applied	\N	\N	\N	\N	202053	202053	369211
26856	43002	42	applied	\N	\N	\N	\N	202054	202054	369212
26856	43006	43	applied	\N	\N	\N	\N	202055	202055	369213
26856	43007	44	applied	\N	\N	\N	\N	202056	202056	369214
26856	43008	45	applied	\N	\N	\N	\N	202057	202057	369215
26856	43009	46	applied	\N	\N	\N	\N	202058	202058	369216
26856	43019	47	applied	\N	\N	\N	\N	202059	202059	369217
26856	43022	49	applied	\N	\N	\N	\N	202061	202061	369219
26856	43028	50	applied	\N	\N	\N	\N	202062	202062	369220
26856	43031	51	applied	\N	\N	\N	\N	202063	202063	369221
26856	43034	52	applied	\N	\N	\N	\N	202064	202064	369222
26856	43035	53	applied	\N	\N	\N	\N	202065	202065	369223
26856	43041	54	applied	\N	\N	\N	\N	202066	202066	369224
26856	42868	55	applied	\N	\N	\N	\N	202067	202067	369225
26856	42871	56	applied	\N	\N	\N	\N	202068	202068	369226
26856	42875	57	applied	\N	\N	\N	\N	202069	202069	369227
26856	42881	58	applied	\N	\N	\N	\N	202070	202070	369228
26856	42882	59	applied	\N	\N	\N	\N	202071	202071	369229
26856	42883	60	applied	\N	\N	\N	\N	202072	202072	369230
26856	42869	61	applied	\N	\N	\N	\N	202073	202073	369231
26856	42889	62	applied	\N	\N	\N	\N	202074	202074	369232
26856	42891	63	applied	\N	\N	\N	\N	202075	202075	369233
26856	42895	64	applied	\N	\N	\N	\N	202076	202076	369234
26856	42900	66	applied	\N	\N	\N	\N	202078	202078	369236
26856	42904	67	applied	\N	\N	\N	\N	202079	202079	369237
26856	42908	68	applied	\N	\N	\N	\N	202080	202080	369238
26856	42914	69	applied	\N	\N	\N	\N	202081	202081	369239
26856	42915	70	applied	\N	\N	\N	\N	202082	202082	369240
26856	42872	71	applied	\N	\N	\N	\N	202083	202083	369241
26856	42880	72	applied	\N	\N	\N	\N	202084	202084	369242
26856	42893	73	applied	\N	\N	\N	\N	202085	202085	369243
26856	42905	74	applied	\N	\N	\N	\N	202086	202086	369244
26856	42913	75	applied	\N	\N	\N	\N	202087	202087	369245
26856	42928	76	applied	\N	\N	\N	\N	202088	202088	369246
26856	42937	77	applied	\N	\N	\N	\N	202089	202089	369247
26856	42948	78	applied	\N	\N	\N	\N	202090	202090	369248
26856	42961	79	applied	\N	\N	\N	\N	202091	202091	369249
26856	42970	80	applied	\N	\N	\N	\N	202092	202092	369250
26856	42983	81	applied	\N	\N	\N	\N	202093	202093	369251
26856	43005	83	applied	\N	\N	\N	\N	202095	202095	369253
26856	43015	84	applied	\N	\N	\N	\N	202096	202096	369254
26856	42919	85	applied	\N	\N	\N	\N	202097	202097	369255
26856	42922	86	applied	\N	\N	\N	\N	202098	202098	369256
26856	42924	87	applied	\N	\N	\N	\N	202099	202099	369257
26856	42929	88	applied	\N	\N	\N	\N	202100	202100	369258
26856	42930	89	applied	\N	\N	\N	\N	202101	202101	369259
26856	42942	90	applied	\N	\N	\N	\N	202102	202102	369260
26856	42943	91	applied	\N	\N	\N	\N	202103	202103	369261
26856	42944	92	applied	\N	\N	\N	\N	202104	202104	369262
26856	42945	93	applied	\N	\N	\N	\N	202105	202105	369263
26856	42949	94	applied	\N	\N	\N	\N	202106	202106	369264
26857	43044	0	applied	\N	\N	\N	\N	202137	202137	369295
26857	43045	1	applied	\N	\N	\N	\N	202138	202138	369296
26857	43046	2	applied	\N	\N	\N	\N	202139	202139	369297
26857	43047	3	applied	\N	\N	\N	\N	202140	202140	369298
26857	43049	5	applied	\N	\N	\N	\N	202142	202142	369300
26857	43050	6	applied	\N	\N	\N	\N	202143	202143	369301
26857	43051	7	applied	\N	\N	\N	\N	202144	202144	369302
26857	43052	8	applied	\N	\N	\N	\N	202145	202145	369303
26857	43053	9	applied	\N	\N	\N	\N	202146	202146	369304
26859	43054	0	applied	\N	\N	\N	\N	202150	202150	369308
26859	43055	1	applied	\N	\N	\N	\N	202151	202151	369309
26859	43056	2	applied	\N	\N	\N	\N	202152	202152	369310
26860	43054	0	applied	\N	\N	\N	\N	202153	202153	369311
26860	43055	1	applied	\N	\N	\N	\N	202154	202154	369312
26860	43056	2	applied	\N	\N	\N	\N	202155	202155	369313
26862	43054	0	applied	\N	\N	\N	\N	202281	202281	369439
26862	43055	1	applied	\N	\N	\N	\N	202282	202282	369440
26862	43056	2	applied	\N	\N	\N	\N	202283	202283	369441
26841	42996	0	applied	\N	\N	\N	\N	201949	201949	369107
26841	42997	1	applied	\N	\N	\N	\N	201950	201950	369108
26856	43027	99	applied	\N	\N	\N	\N	202111	202111	369269
26856	43039	100	applied	\N	\N	\N	\N	202112	202112	369270
26856	42873	101	applied	\N	\N	\N	\N	202113	202113	369271
26856	42876	102	applied	\N	\N	\N	\N	202114	202114	369272
26856	42884	103	applied	\N	\N	\N	\N	202115	202115	369273
26856	42885	104	applied	\N	\N	\N	\N	202116	202116	369274
26856	42886	105	applied	\N	\N	\N	\N	202117	202117	369275
26856	42888	106	applied	\N	\N	\N	\N	202118	202118	369276
26856	42894	107	applied	\N	\N	\N	\N	202119	202119	369277
26856	42898	108	applied	\N	\N	\N	\N	202120	202120	369278
26856	42965	109	applied	\N	\N	\N	\N	202121	202121	369279
26856	42967	110	applied	\N	\N	\N	\N	202122	202122	369280
26856	42971	111	applied	\N	\N	\N	\N	202123	202123	369281
26856	42975	113	applied	\N	\N	\N	\N	202124	202124	369282
26856	42979	114	applied	\N	\N	\N	\N	202125	202125	369283
26856	42984	115	applied	\N	\N	\N	\N	202126	202126	369284
26856	42987	117	applied	\N	\N	\N	\N	202128	202128	369286
26856	42990	118	applied	\N	\N	\N	\N	202129	202129	369287
26856	42995	119	applied	\N	\N	\N	\N	202130	202130	369288
26856	42997	120	applied	\N	\N	\N	\N	202131	202131	369289
26856	43001	121	applied	\N	\N	\N	\N	202132	202132	369290
26856	43003	122	applied	\N	\N	\N	\N	202133	202133	369291
26856	43010	123	applied	\N	\N	\N	\N	202134	202134	369292
26856	43012	124	applied	\N	\N	\N	\N	202135	202135	369293
26856	43013	125	applied	\N	\N	\N	\N	202136	202136	369294
26858	43054	0	applied	\N	\N	\N	\N	202147	202147	369305
26858	43055	1	applied	\N	\N	\N	\N	202148	202148	369306
26858	43056	2	applied	\N	\N	\N	\N	202149	202149	369307
26861	42890	0	applied	\N	\N	\N	\N	202156	202156	369314
26861	42906	1	applied	\N	\N	\N	\N	202157	202157	369315
26861	42892	2	applied	\N	\N	\N	\N	202158	202158	369316
26861	42896	3	applied	\N	\N	\N	\N	202159	202159	369317
26861	42902	5	applied	\N	\N	\N	\N	202161	202161	369319
26861	42907	6	applied	\N	\N	\N	\N	202162	202162	369320
26861	42910	7	applied	\N	\N	\N	\N	202163	202163	369321
26861	42911	8	applied	\N	\N	\N	\N	202164	202164	369322
26861	42912	9	applied	\N	\N	\N	\N	202165	202165	369323
26861	42920	10	applied	\N	\N	\N	\N	202166	202166	369324
26861	42923	11	applied	\N	\N	\N	\N	202167	202167	369325
26861	42926	12	applied	\N	\N	\N	\N	202168	202168	369326
26861	42927	13	applied	\N	\N	\N	\N	202169	202169	369327
26861	42933	14	applied	\N	\N	\N	\N	202170	202170	369328
26861	42934	15	applied	\N	\N	\N	\N	202171	202171	369329
26861	42935	16	applied	\N	\N	\N	\N	202172	202172	369330
26861	42936	17	applied	\N	\N	\N	\N	202173	202173	369331
26861	42946	18	applied	\N	\N	\N	\N	202174	202174	369332
26861	42953	19	applied	\N	\N	\N	\N	202175	202175	369333
26861	42954	20	applied	\N	\N	\N	\N	202176	202176	369334
26861	42960	22	applied	\N	\N	\N	\N	202178	202178	369336
26861	42964	23	applied	\N	\N	\N	\N	202179	202179	369337
26861	42966	24	applied	\N	\N	\N	\N	202180	202180	369338
26861	42969	25	applied	\N	\N	\N	\N	202181	202181	369339
26861	42973	26	applied	\N	\N	\N	\N	202182	202182	369340
26861	42976	27	applied	\N	\N	\N	\N	202183	202183	369341
26861	42977	28	applied	\N	\N	\N	\N	202184	202184	369342
26861	42978	29	applied	\N	\N	\N	\N	202185	202185	369343
26861	42986	30	applied	\N	\N	\N	\N	202186	202186	369344
26861	42989	31	applied	\N	\N	\N	\N	202187	202187	369345
26861	42992	32	applied	\N	\N	\N	\N	202188	202188	369346
26861	42996	33	applied	\N	\N	\N	\N	202189	202189	369347
26861	42999	34	applied	\N	\N	\N	\N	202190	202190	369348
26861	43002	35	applied	\N	\N	\N	\N	202191	202191	369349
26861	43006	36	applied	\N	\N	\N	\N	202192	202192	369350
26861	43007	37	applied	\N	\N	\N	\N	202193	202193	369351
26861	43009	39	applied	\N	\N	\N	\N	202195	202195	369353
26861	43019	40	applied	\N	\N	\N	\N	202196	202196	369354
26861	43021	41	applied	\N	\N	\N	\N	202197	202197	369355
26861	43022	42	applied	\N	\N	\N	\N	202198	202198	369356
26861	43028	43	applied	\N	\N	\N	\N	202199	202199	369357
26861	43031	44	applied	\N	\N	\N	\N	202200	202200	369358
26861	43034	45	applied	\N	\N	\N	\N	202201	202201	369359
26861	43035	46	applied	\N	\N	\N	\N	202202	202202	369360
26861	43041	47	applied	\N	\N	\N	\N	202203	202203	369361
26861	43044	48	applied	\N	\N	\N	\N	202204	202204	369362
26861	43045	49	applied	\N	\N	\N	\N	202205	202205	369363
26861	43046	50	applied	\N	\N	\N	\N	202206	202206	369364
26861	43054	51	applied	\N	\N	\N	\N	202207	202207	369365
26861	42893	52	applied	\N	\N	\N	\N	202208	202208	369366
26861	42891	53	applied	\N	\N	\N	\N	202209	202209	369367
26861	42894	54	applied	\N	\N	\N	\N	202210	202210	369368
26861	42913	56	applied	\N	\N	\N	\N	202212	202212	369370
26861	42928	57	applied	\N	\N	\N	\N	202213	202213	369371
26861	42937	58	applied	\N	\N	\N	\N	202214	202214	369372
26861	42948	59	applied	\N	\N	\N	\N	202215	202215	369373
26861	42961	60	applied	\N	\N	\N	\N	202216	202216	369374
26861	42970	61	applied	\N	\N	\N	\N	202217	202217	369375
26861	42983	62	applied	\N	\N	\N	\N	202218	202218	369376
26861	42994	63	applied	\N	\N	\N	\N	202219	202219	369377
26861	43005	64	applied	\N	\N	\N	\N	202220	202220	369378
26861	42895	65	applied	\N	\N	\N	\N	202221	202221	369379
26861	42897	66	applied	\N	\N	\N	\N	202222	202222	369380
26861	42900	67	applied	\N	\N	\N	\N	202223	202223	369381
26861	42904	68	applied	\N	\N	\N	\N	202224	202224	369382
26861	42908	69	applied	\N	\N	\N	\N	202225	202225	369383
26861	42914	70	applied	\N	\N	\N	\N	202226	202226	369384
26861	42915	71	applied	\N	\N	\N	\N	202227	202227	369385
26861	43015	73	applied	\N	\N	\N	\N	202229	202229	369387
26861	42919	74	applied	\N	\N	\N	\N	202230	202230	369388
26861	42922	75	applied	\N	\N	\N	\N	202231	202231	369389
26861	42924	76	applied	\N	\N	\N	\N	202232	202232	369390
26861	42929	77	applied	\N	\N	\N	\N	202233	202233	369391
26861	42930	78	applied	\N	\N	\N	\N	202234	202234	369392
26861	42942	80	applied	\N	\N	\N	\N	202235	202235	369393
26861	42943	81	applied	\N	\N	\N	\N	202236	202236	369394
26861	42944	82	applied	\N	\N	\N	\N	202237	202237	369395
26861	42945	83	applied	\N	\N	\N	\N	202238	202238	369396
26861	42949	84	applied	\N	\N	\N	\N	202239	202239	369397
26861	42952	85	applied	\N	\N	\N	\N	202240	202240	369398
26861	42956	86	applied	\N	\N	\N	\N	202241	202241	369399
26861	42958	87	applied	\N	\N	\N	\N	202242	202242	369400
26856	42956	96	applied	\N	\N	\N	\N	202108	202108	369266
26856	42958	97	applied	\N	\N	\N	\N	202109	202109	369267
26861	42965	92	applied	\N	\N	\N	\N	202247	202247	369405
26861	42967	93	applied	\N	\N	\N	\N	202248	202248	369406
26861	42971	94	applied	\N	\N	\N	\N	202249	202249	369407
26861	42975	95	applied	\N	\N	\N	\N	202250	202250	369408
26861	42979	96	applied	\N	\N	\N	\N	202251	202251	369409
26861	42984	97	applied	\N	\N	\N	\N	202252	202252	369410
26861	42985	98	applied	\N	\N	\N	\N	202253	202253	369411
26861	42987	99	applied	\N	\N	\N	\N	202254	202254	369412
26861	42990	100	applied	\N	\N	\N	\N	202255	202255	369413
26861	42995	101	applied	\N	\N	\N	\N	202256	202256	369414
26861	42997	102	applied	\N	\N	\N	\N	202257	202257	369415
26861	43001	103	applied	\N	\N	\N	\N	202258	202258	369416
26861	43003	104	applied	\N	\N	\N	\N	202259	202259	369417
26861	43010	105	applied	\N	\N	\N	\N	202260	202260	369418
26861	43012	106	applied	\N	\N	\N	\N	202261	202261	369419
26861	43013	107	applied	\N	\N	\N	\N	202262	202262	369420
26861	43020	109	applied	\N	\N	\N	\N	202264	202264	369422
26861	43024	110	applied	\N	\N	\N	\N	202265	202265	369423
26861	43026	111	applied	\N	\N	\N	\N	202266	202266	369424
26861	43029	112	applied	\N	\N	\N	\N	202267	202267	369425
26861	43033	113	applied	\N	\N	\N	\N	202268	202268	369426
26861	43036	114	applied	\N	\N	\N	\N	202269	202269	369427
26861	43038	115	applied	\N	\N	\N	\N	202270	202270	369428
26861	43043	116	applied	\N	\N	\N	\N	202271	202271	369429
26861	43051	117	applied	\N	\N	\N	\N	202272	202272	369430
26861	43052	118	applied	\N	\N	\N	\N	202273	202273	369431
26861	43053	119	applied	\N	\N	\N	\N	202274	202274	369432
26861	43055	120	applied	\N	\N	\N	\N	202275	202275	369433
26861	42901	121	applied	\N	\N	\N	\N	202276	202276	369434
26861	42903	122	applied	\N	\N	\N	\N	202277	202277	369435
26861	42909	123	applied	\N	\N	\N	\N	202278	202278	369436
26861	42916	124	applied	\N	\N	\N	\N	202279	202279	369437
26863	43057	0	applied	\N	\N	\N	\N	202284	202284	369442
26863	43058	1	applied	\N	\N	\N	\N	202285	202285	369443
26863	43059	2	applied	\N	\N	\N	\N	202286	202286	369444
26863	43060	3	applied	\N	\N	\N	\N	202287	202287	369445
26863	43061	4	applied	\N	\N	\N	\N	202288	202288	369446
26863	43062	5	applied	\N	\N	\N	\N	202289	202289	369447
26863	43063	6	applied	\N	\N	\N	\N	202290	202290	369448
26864	43057	0	applied	\N	\N	\N	\N	202291	202291	369449
26864	43058	1	applied	\N	\N	\N	\N	202292	202292	369450
26864	43059	2	applied	\N	\N	\N	\N	202293	202293	369451
26864	43060	3	applied	\N	\N	\N	\N	202294	202294	369452
26864	43061	4	applied	\N	\N	\N	\N	202295	202295	369453
26864	43062	5	applied	\N	\N	\N	\N	202296	202296	369454
26864	43063	6	applied	\N	\N	\N	\N	202297	202297	369455
26865	43057	0	applied	\N	\N	\N	\N	202298	202298	369456
26865	43058	1	applied	\N	\N	\N	\N	202299	202299	369457
26865	43060	3	applied	\N	\N	\N	\N	202301	202301	369459
26865	43061	4	applied	\N	\N	\N	\N	202302	202302	369460
26865	43062	5	applied	\N	\N	\N	\N	202303	202303	369461
26865	43063	6	applied	\N	\N	\N	\N	202304	202304	369462
26866	43064	0	applied	\N	\N	\N	\N	202305	202305	369463
26866	43065	1	applied	\N	\N	\N	\N	202306	202306	369464
26866	43066	2	applied	\N	\N	\N	\N	202307	202307	369465
26867	43067	0	applied	\N	\N	\N	\N	202308	202308	369466
26867	43068	1	applied	\N	\N	\N	\N	202309	202309	369467
26867	43069	2	applied	\N	\N	\N	\N	202310	202310	369468
26867	43070	3	applied	\N	\N	\N	\N	202311	202311	369469
26868	43071	0	applied	\N	\N	\N	\N	202312	202312	369470
26868	43072	1	applied	\N	\N	\N	\N	202313	202313	369471
26868	43073	2	applied	\N	\N	\N	\N	202314	202314	369472
26869	43071	0	applied	\N	\N	\N	\N	202315	202315	369473
26869	43072	1	applied	\N	\N	\N	\N	202316	202316	369474
26870	43074	0	applied	\N	\N	\N	\N	202318	202318	369476
26870	43075	1	applied	\N	\N	\N	\N	202319	202319	369477
26870	43076	2	applied	\N	\N	\N	\N	202320	202320	369478
26871	43074	0	applied	\N	\N	\N	\N	202321	202321	369479
26871	43075	1	applied	\N	\N	\N	\N	202322	202322	369480
26871	43076	2	applied	\N	\N	\N	\N	202323	202323	369481
26872	43074	0	applied	\N	\N	\N	\N	202324	202324	369482
26872	43075	1	applied	\N	\N	\N	\N	202325	202325	369483
26872	43076	2	applied	\N	\N	\N	\N	202326	202326	369484
26873	43074	0	applied	\N	\N	\N	\N	202327	202327	369485
26873	43075	1	applied	\N	\N	\N	\N	202328	202328	369486
26873	43076	2	applied	\N	\N	\N	\N	202329	202329	369487
26874	43077	0	applied	\N	\N	\N	\N	202330	202330	369488
26874	43078	1	applied	\N	\N	\N	\N	202331	202331	369489
26874	43079	2	applied	\N	\N	\N	\N	202332	202332	369490
26874	43080	3	applied	\N	\N	\N	\N	202333	202333	369491
26875	43082	0	applied	\N	\N	\N	\N	202335	202335	369493
26875	43083	1	applied	\N	\N	\N	\N	202336	202336	369494
26875	43084	2	applied	\N	\N	\N	\N	202337	202337	369495
26876	43082	0	applied	\N	\N	\N	\N	202338	202338	369496
26876	43083	1	applied	\N	\N	\N	\N	202339	202339	369497
26876	43084	2	applied	\N	\N	\N	\N	202340	202340	369498
26877	43085	0	applied	\N	\N	\N	\N	202341	202341	369499
26877	43086	1	applied	\N	\N	\N	\N	202342	202342	369500
26877	43087	2	applied	\N	\N	\N	\N	202343	202343	369501
26878	43085	0	applied	\N	\N	\N	\N	202344	202344	369502
26878	43086	1	applied	\N	\N	\N	\N	202345	202345	369503
26878	43087	2	applied	\N	\N	\N	\N	202346	202346	369504
26879	43085	0	applied	\N	\N	\N	\N	202347	202347	369505
26879	43086	1	applied	\N	\N	\N	\N	202348	202348	369506
26879	43087	2	applied	\N	\N	\N	\N	202349	202349	369507
26880	43085	0	applied	\N	\N	\N	\N	202350	202350	369508
26880	43087	2	applied	\N	\N	\N	\N	202352	202352	369510
26881	43085	0	applied	\N	\N	\N	\N	202353	202353	369511
26881	43086	1	applied	\N	\N	\N	\N	202354	202354	369512
26881	43087	2	applied	\N	\N	\N	\N	202355	202355	369513
26882	43044	0	applied	\N	\N	\N	\N	202356	202356	369514
26882	43045	1	applied	\N	\N	\N	\N	202357	202357	369515
26882	43046	2	applied	\N	\N	\N	\N	202358	202358	369516
26882	43054	3	applied	\N	\N	\N	\N	202359	202359	369517
26882	43057	4	applied	\N	\N	\N	\N	202360	202360	369518
26882	43058	5	applied	\N	\N	\N	\N	202361	202361	369519
26882	43064	6	applied	\N	\N	\N	\N	202362	202362	369520
26882	43067	7	applied	\N	\N	\N	\N	202363	202363	369521
26882	43071	8	applied	\N	\N	\N	\N	202364	202364	369522
26882	43074	9	applied	\N	\N	\N	\N	202365	202365	369523
26861	43027	89	applied	\N	\N	\N	\N	202244	202244	369402
26861	43039	90	applied	\N	\N	\N	\N	202245	202245	369403
26882	43014	14	applied	\N	\N	\N	\N	202370	202370	369528
26882	43020	15	applied	\N	\N	\N	\N	202371	202371	369529
26882	43024	16	applied	\N	\N	\N	\N	202372	202372	369530
26882	43026	17	applied	\N	\N	\N	\N	202373	202373	369531
26882	43029	18	applied	\N	\N	\N	\N	202374	202374	369532
26882	43033	19	applied	\N	\N	\N	\N	202375	202375	369533
26882	43036	20	applied	\N	\N	\N	\N	202376	202376	369534
26882	43038	21	applied	\N	\N	\N	\N	202377	202377	369535
26882	43043	22	applied	\N	\N	\N	\N	202378	202378	369536
26882	43051	23	applied	\N	\N	\N	\N	202379	202379	369537
26882	43052	24	applied	\N	\N	\N	\N	202380	202380	369538
26882	43053	25	applied	\N	\N	\N	\N	202381	202381	369539
26882	43055	26	applied	\N	\N	\N	\N	202382	202382	369540
26882	43060	27	applied	\N	\N	\N	\N	202383	202383	369541
26882	43061	28	applied	\N	\N	\N	\N	202384	202384	369542
26882	43066	29	applied	\N	\N	\N	\N	202385	202385	369543
26882	43073	31	applied	\N	\N	\N	\N	202387	202387	369545
26882	43075	32	applied	\N	\N	\N	\N	202388	202388	369546
26882	43078	33	applied	\N	\N	\N	\N	202389	202389	369547
26882	43084	34	applied	\N	\N	\N	\N	202390	202390	369548
26882	43087	35	applied	\N	\N	\N	\N	202391	202391	369549
26882	43063	36	applied	\N	\N	\N	\N	202392	202392	369550
26882	43070	37	applied	\N	\N	\N	\N	202393	202393	369551
26882	43081	38	applied	\N	\N	\N	\N	202394	202394	369552
26882	42901	39	applied	\N	\N	\N	\N	202395	202395	369553
26882	42903	40	applied	\N	\N	\N	\N	202396	202396	369554
26882	42909	41	applied	\N	\N	\N	\N	202397	202397	369555
26882	42916	42	applied	\N	\N	\N	\N	202398	202398	369556
26882	42917	43	applied	\N	\N	\N	\N	202399	202399	369557
26882	42918	44	applied	\N	\N	\N	\N	202400	202400	369558
26882	42921	45	applied	\N	\N	\N	\N	202401	202401	369559
26882	42925	46	applied	\N	\N	\N	\N	202402	202402	369560
26882	42932	48	applied	\N	\N	\N	\N	202404	202404	369562
26882	42938	49	applied	\N	\N	\N	\N	202405	202405	369563
26882	42939	50	applied	\N	\N	\N	\N	202406	202406	369564
26882	42940	51	applied	\N	\N	\N	\N	202407	202407	369565
26882	42941	52	applied	\N	\N	\N	\N	202408	202408	369566
26882	42947	53	applied	\N	\N	\N	\N	202409	202409	369567
26882	42951	54	applied	\N	\N	\N	\N	202410	202410	369568
26882	42955	55	applied	\N	\N	\N	\N	202411	202411	369569
26882	42959	56	applied	\N	\N	\N	\N	202412	202412	369570
26882	42962	57	applied	\N	\N	\N	\N	202413	202413	369571
26882	42968	58	applied	\N	\N	\N	\N	202414	202414	369572
26882	42972	59	applied	\N	\N	\N	\N	202415	202415	369573
26882	42974	60	applied	\N	\N	\N	\N	202416	202416	369574
26882	42980	61	applied	\N	\N	\N	\N	202417	202417	369575
26882	42981	62	applied	\N	\N	\N	\N	202418	202418	369576
26882	42982	63	applied	\N	\N	\N	\N	202419	202419	369577
26882	42991	65	applied	\N	\N	\N	\N	202421	202421	369579
26882	42993	66	applied	\N	\N	\N	\N	202422	202422	369580
26882	42998	67	applied	\N	\N	\N	\N	202423	202423	369581
26882	43000	68	applied	\N	\N	\N	\N	202424	202424	369582
26882	43004	69	applied	\N	\N	\N	\N	202425	202425	369583
26882	43011	70	applied	\N	\N	\N	\N	202426	202426	369584
26882	43016	71	applied	\N	\N	\N	\N	202427	202427	369585
26882	43017	72	applied	\N	\N	\N	\N	202428	202428	369586
26882	43018	73	applied	\N	\N	\N	\N	202429	202429	369587
26882	43023	74	applied	\N	\N	\N	\N	202430	202430	369588
26882	43025	75	applied	\N	\N	\N	\N	202431	202431	369589
26882	43030	76	applied	\N	\N	\N	\N	202432	202432	369590
26882	43032	77	applied	\N	\N	\N	\N	202433	202433	369591
26882	43037	78	applied	\N	\N	\N	\N	202434	202434	369592
26882	43040	79	applied	\N	\N	\N	\N	202435	202435	369593
26882	43042	80	applied	\N	\N	\N	\N	202436	202436	369594
26882	43049	82	applied	\N	\N	\N	\N	202438	202438	369596
26882	43050	83	applied	\N	\N	\N	\N	202439	202439	369597
26882	43056	84	applied	\N	\N	\N	\N	202440	202440	369598
26882	43059	85	applied	\N	\N	\N	\N	202441	202441	369599
26882	43062	86	applied	\N	\N	\N	\N	202442	202442	369600
26882	43065	87	applied	\N	\N	\N	\N	202443	202443	369601
26882	43069	88	applied	\N	\N	\N	\N	202444	202444	369602
26882	43072	89	applied	\N	\N	\N	\N	202445	202445	369603
26882	43076	90	applied	\N	\N	\N	\N	202446	202446	369604
26882	43079	91	applied	\N	\N	\N	\N	202447	202447	369605
26882	43083	92	applied	\N	\N	\N	\N	202448	202448	369606
26882	43086	93	applied	\N	\N	\N	\N	202449	202449	369607
26883	43088	0	applied	\N	\N	\N	\N	202450	202450	369608
26883	43089	1	applied	\N	\N	\N	\N	202451	202451	369609
26883	43090	2	applied	\N	\N	\N	\N	202452	202452	369610
26883	43091	3	applied	\N	\N	\N	\N	202453	202453	369611
26883	43093	5	applied	\N	\N	\N	\N	202455	202455	369613
26883	43094	6	applied	\N	\N	\N	\N	202456	202456	369614
26883	43095	7	applied	\N	\N	\N	\N	202457	202457	369615
26883	43096	8	applied	\N	\N	\N	\N	202458	202458	369616
26885	43098	0	applied	\N	\N	\N	\N	202463	202463	369621
26885	43099	1	applied	\N	\N	\N	\N	202464	202464	369622
26885	43100	2	applied	\N	\N	\N	\N	202465	202465	369623
26888	43101	0	applied	\N	\N	\N	\N	202474	202474	369632
26888	43102	1	applied	\N	\N	\N	\N	202475	202475	369633
26888	43103	2	applied	\N	\N	\N	\N	202476	202476	369634
26888	43104	3	applied	\N	\N	\N	\N	202477	202477	369635
26889	43105	0	applied	\N	\N	\N	\N	202478	202478	369636
26889	43106	1	applied	\N	\N	\N	\N	202479	202479	369637
26889	43107	2	applied	\N	\N	\N	\N	202480	202480	369638
26893	43111	0	applied	\N	\N	\N	\N	202491	202491	369649
26893	43112	1	applied	\N	\N	\N	\N	202492	202492	369650
26893	43114	3	applied	\N	\N	\N	\N	202494	202494	369652
26899	43131	0	applied	\N	\N	\N	\N	202561	202561	369719
26899	43132	1	applied	\N	\N	\N	\N	202562	202562	369720
26899	43133	2	applied	\N	\N	\N	\N	202563	202563	369721
26899	43134	3	applied	\N	\N	\N	\N	202564	202564	369722
26899	43135	4	applied	\N	\N	\N	\N	202565	202565	369723
26899	43136	5	applied	\N	\N	\N	\N	202566	202566	369724
26899	43137	6	applied	\N	\N	\N	\N	202567	202567	369725
26899	43138	7	applied	\N	\N	\N	\N	202568	202568	369726
26899	43139	8	applied	\N	\N	\N	\N	202569	202569	369727
26899	43140	9	applied	\N	\N	\N	\N	202570	202570	369728
26899	43141	10	applied	\N	\N	\N	\N	202571	202571	369729
26906	43157	0	applied	\N	\N	\N	\N	202601	202601	369759
26906	43158	1	applied	\N	\N	\N	\N	202602	202602	369760
26882	43082	11	applied	\N	\N	\N	\N	202367	202367	369525
26882	43085	12	applied	\N	\N	\N	\N	202368	202368	369526
26887	43101	0	applied	\N	\N	\N	\N	202470	202470	369628
26887	43102	1	applied	\N	\N	\N	\N	202471	202471	369629
26887	43103	2	applied	\N	\N	\N	\N	202472	202472	369630
26887	43104	3	applied	\N	\N	\N	\N	202473	202473	369631
26890	43105	0	applied	\N	\N	\N	\N	202481	202481	369639
26890	43106	1	applied	\N	\N	\N	\N	202482	202482	369640
26890	43107	2	applied	\N	\N	\N	\N	202483	202483	369641
26892	43111	0	applied	\N	\N	\N	\N	202487	202487	369645
26892	43112	1	applied	\N	\N	\N	\N	202488	202488	369646
26894	43088	0	applied	\N	\N	\N	\N	202495	202495	369653
26894	43089	1	applied	\N	\N	\N	\N	202496	202496	369654
26894	43090	2	applied	\N	\N	\N	\N	202497	202497	369655
26894	43098	3	applied	\N	\N	\N	\N	202498	202498	369656
26894	43101	4	applied	\N	\N	\N	\N	202499	202499	369657
26894	43105	5	applied	\N	\N	\N	\N	202500	202500	369658
26894	43108	6	applied	\N	\N	\N	\N	202501	202501	369659
26894	43115	8	applied	\N	\N	\N	\N	202503	202503	369661
26894	43091	9	applied	\N	\N	\N	\N	202504	202504	369662
26894	43092	10	applied	\N	\N	\N	\N	202505	202505	369663
26894	43093	11	applied	\N	\N	\N	\N	202506	202506	369664
26894	43094	12	applied	\N	\N	\N	\N	202507	202507	369665
26894	43095	13	applied	\N	\N	\N	\N	202508	202508	369666
26894	43096	14	applied	\N	\N	\N	\N	202509	202509	369667
26894	43103	15	applied	\N	\N	\N	\N	202510	202510	369668
26894	43112	17	applied	\N	\N	\N	\N	202511	202511	369669
26894	43097	18	applied	\N	\N	\N	\N	202512	202512	369670
26894	43099	19	applied	\N	\N	\N	\N	202513	202513	369671
26894	43102	20	applied	\N	\N	\N	\N	202514	202514	369672
26894	43107	21	applied	\N	\N	\N	\N	202515	202515	369673
26894	43110	22	applied	\N	\N	\N	\N	202516	202516	369674
26894	43114	23	applied	\N	\N	\N	\N	202517	202517	369675
26894	43116	24	applied	\N	\N	\N	\N	202518	202518	369676
26894	43104	26	applied	\N	\N	\N	\N	202520	202520	369678
26894	43106	27	applied	\N	\N	\N	\N	202521	202521	369679
26894	43109	28	applied	\N	\N	\N	\N	202522	202522	369680
26894	43113	29	applied	\N	\N	\N	\N	202523	202523	369681
26894	43117	30	applied	\N	\N	\N	\N	202524	202524	369682
26897	43124	0	applied	\N	\N	\N	\N	202543	202543	369701
26897	43125	1	applied	\N	\N	\N	\N	202544	202544	369702
26897	43126	2	applied	\N	\N	\N	\N	202545	202545	369703
26897	43127	3	applied	\N	\N	\N	\N	202546	202546	369704
26897	43128	4	applied	\N	\N	\N	\N	202547	202547	369705
26897	43129	5	applied	\N	\N	\N	\N	202548	202548	369706
26897	43130	6	applied	\N	\N	\N	\N	202549	202549	369707
26900	43131	0	applied	\N	\N	\N	\N	202572	202572	369730
26900	43132	1	applied	\N	\N	\N	\N	202573	202573	369731
26900	43133	2	applied	\N	\N	\N	\N	202574	202574	369732
26900	43134	3	applied	\N	\N	\N	\N	202575	202575	369733
26900	43136	5	applied	\N	\N	\N	\N	202577	202577	369735
26900	43137	6	applied	\N	\N	\N	\N	202578	202578	369736
26900	43138	7	applied	\N	\N	\N	\N	202579	202579	369737
26900	43139	8	applied	\N	\N	\N	\N	202580	202580	369738
26900	43140	9	applied	\N	\N	\N	\N	202581	202581	369739
26900	43141	10	applied	\N	\N	\N	\N	202582	202582	369740
26901	43142	0	applied	\N	\N	\N	\N	202583	202583	369741
26901	43143	1	applied	\N	\N	\N	\N	202584	202584	369742
26901	43144	2	applied	\N	\N	\N	\N	202585	202585	369743
26901	43145	3	applied	\N	\N	\N	\N	202586	202586	369744
26901	43146	4	applied	\N	\N	\N	\N	202587	202587	369745
26901	43147	5	applied	\N	\N	\N	\N	202588	202588	369746
26902	43148	0	applied	\N	\N	\N	\N	202589	202589	369747
26902	43149	1	applied	\N	\N	\N	\N	202590	202590	369748
26902	43150	2	applied	\N	\N	\N	\N	202591	202591	369749
26907	43157	0	applied	\N	\N	\N	\N	202607	202607	369765
26907	43159	2	applied	\N	\N	\N	\N	202609	202609	369767
26907	43160	3	applied	\N	\N	\N	\N	202610	202610	369768
26907	43161	4	applied	\N	\N	\N	\N	202611	202611	369769
26907	43162	5	applied	\N	\N	\N	\N	202612	202612	369770
26911	43163	0	applied	\N	\N	\N	\N	202622	202622	369780
26911	43164	1	applied	\N	\N	\N	\N	202623	202623	369781
26911	43165	2	applied	\N	\N	\N	\N	202624	202624	369782
26920	43118	0	applied	\N	\N	\N	\N	202654	202654	369812
26920	43119	1	applied	\N	\N	\N	\N	202655	202655	369813
26920	43124	2	applied	\N	\N	\N	\N	202656	202656	369814
26920	43125	3	applied	\N	\N	\N	\N	202657	202657	369815
26920	43131	4	applied	\N	\N	\N	\N	202658	202658	369816
26920	43132	5	applied	\N	\N	\N	\N	202659	202659	369817
26920	43133	6	applied	\N	\N	\N	\N	202660	202660	369818
26920	43134	7	applied	\N	\N	\N	\N	202661	202661	369819
26920	43142	8	applied	\N	\N	\N	\N	202662	202662	369820
26920	43148	10	applied	\N	\N	\N	\N	202664	202664	369822
26920	43151	11	applied	\N	\N	\N	\N	202665	202665	369823
26920	43154	12	applied	\N	\N	\N	\N	202666	202666	369824
26920	43157	13	applied	\N	\N	\N	\N	202667	202667	369825
26920	43158	14	applied	\N	\N	\N	\N	202668	202668	369826
26920	43163	15	applied	\N	\N	\N	\N	202669	202669	369827
26920	43166	16	applied	\N	\N	\N	\N	202670	202670	369828
26920	43169	17	applied	\N	\N	\N	\N	202671	202671	369829
26920	43172	18	applied	\N	\N	\N	\N	202672	202672	369830
26920	43174	19	applied	\N	\N	\N	\N	202673	202673	369831
26920	43177	20	applied	\N	\N	\N	\N	202674	202674	369832
26920	43178	21	applied	\N	\N	\N	\N	202675	202675	369833
26920	43183	22	applied	\N	\N	\N	\N	202676	202676	369834
26920	43184	23	applied	\N	\N	\N	\N	202677	202677	369835
26920	43122	24	applied	\N	\N	\N	\N	202678	202678	369836
26920	43123	25	applied	\N	\N	\N	\N	202679	202679	369837
26920	43127	27	applied	\N	\N	\N	\N	202681	202681	369839
26920	43120	28	applied	\N	\N	\N	\N	202682	202682	369840
26920	43121	29	applied	\N	\N	\N	\N	202683	202683	369841
26920	43128	30	applied	\N	\N	\N	\N	202684	202684	369842
26920	43129	31	applied	\N	\N	\N	\N	202685	202685	369843
26920	43136	32	applied	\N	\N	\N	\N	202686	202686	369844
26920	43137	33	applied	\N	\N	\N	\N	202687	202687	369845
26920	43130	34	applied	\N	\N	\N	\N	202688	202688	369846
26920	43135	35	applied	\N	\N	\N	\N	202689	202689	369847
26920	43138	36	applied	\N	\N	\N	\N	202690	202690	369848
26920	43139	37	applied	\N	\N	\N	\N	202691	202691	369849
26920	43144	38	applied	\N	\N	\N	\N	202692	202692	369850
26920	43145	39	applied	\N	\N	\N	\N	202693	202693	369851
26920	43150	40	applied	\N	\N	\N	\N	202694	202694	369852
26884	43098	0	applied	\N	\N	\N	\N	202460	202460	369618
26884	43099	1	applied	\N	\N	\N	\N	202461	202461	369619
26891	43108	0	applied	\N	\N	\N	\N	202484	202484	369642
26891	43109	1	applied	\N	\N	\N	\N	202485	202485	369643
26891	43110	2	applied	\N	\N	\N	\N	202486	202486	369644
26892	43113	2	applied	\N	\N	\N	\N	202489	202489	369647
26892	43114	3	applied	\N	\N	\N	\N	202490	202490	369648
26895	43115	0	applied	\N	\N	\N	\N	202525	202525	369683
26895	43118	1	applied	\N	\N	\N	\N	202526	202526	369684
26895	43119	2	applied	\N	\N	\N	\N	202527	202527	369685
26895	43117	3	applied	\N	\N	\N	\N	202528	202528	369686
26895	43120	4	applied	\N	\N	\N	\N	202529	202529	369687
26895	43121	5	applied	\N	\N	\N	\N	202530	202530	369688
26895	43116	6	applied	\N	\N	\N	\N	202531	202531	369689
26895	43122	7	applied	\N	\N	\N	\N	202532	202532	369690
26895	43123	8	applied	\N	\N	\N	\N	202533	202533	369691
26896	43115	0	applied	\N	\N	\N	\N	202534	202534	369692
26896	43118	1	applied	\N	\N	\N	\N	202535	202535	369693
26896	43117	3	applied	\N	\N	\N	\N	202537	202537	369695
26896	43120	4	applied	\N	\N	\N	\N	202538	202538	369696
26896	43121	5	applied	\N	\N	\N	\N	202539	202539	369697
26896	43116	6	applied	\N	\N	\N	\N	202540	202540	369698
26896	43122	7	applied	\N	\N	\N	\N	202541	202541	369699
26896	43123	8	applied	\N	\N	\N	\N	202542	202542	369700
26898	43131	0	applied	\N	\N	\N	\N	202550	202550	369708
26898	43132	1	applied	\N	\N	\N	\N	202551	202551	369709
26898	43133	2	applied	\N	\N	\N	\N	202552	202552	369710
26898	43134	3	applied	\N	\N	\N	\N	202553	202553	369711
26898	43135	4	applied	\N	\N	\N	\N	202554	202554	369712
26898	43136	5	applied	\N	\N	\N	\N	202555	202555	369713
26898	43137	6	applied	\N	\N	\N	\N	202556	202556	369714
26898	43138	7	applied	\N	\N	\N	\N	202557	202557	369715
26898	43139	8	applied	\N	\N	\N	\N	202558	202558	369716
26898	43140	9	applied	\N	\N	\N	\N	202559	202559	369717
26903	43148	0	applied	\N	\N	\N	\N	202592	202592	369750
26903	43149	1	applied	\N	\N	\N	\N	202593	202593	369751
26904	43151	0	applied	\N	\N	\N	\N	202595	202595	369753
26904	43152	1	applied	\N	\N	\N	\N	202596	202596	369754
26904	43153	2	applied	\N	\N	\N	\N	202597	202597	369755
26905	43154	0	applied	\N	\N	\N	\N	202598	202598	369756
26905	43155	1	applied	\N	\N	\N	\N	202599	202599	369757
26905	43156	2	applied	\N	\N	\N	\N	202600	202600	369758
26909	43163	0	applied	\N	\N	\N	\N	202616	202616	369774
26909	43164	1	applied	\N	\N	\N	\N	202617	202617	369775
26909	43165	2	applied	\N	\N	\N	\N	202618	202618	369776
26913	43169	0	applied	\N	\N	\N	\N	202628	202628	369786
26913	43170	1	applied	\N	\N	\N	\N	202629	202629	369787
26913	43171	2	applied	\N	\N	\N	\N	202630	202630	369788
26915	43172	0	applied	\N	\N	\N	\N	202634	202634	369792
26915	43173	1	applied	\N	\N	\N	\N	202635	202635	369793
26918	43178	1	applied	\N	\N	\N	\N	202643	202643	369801
26918	43179	2	applied	\N	\N	\N	\N	202644	202644	369802
26918	43180	3	applied	\N	\N	\N	\N	202645	202645	369803
26918	43181	4	applied	\N	\N	\N	\N	202646	202646	369804
26918	43182	5	applied	\N	\N	\N	\N	202647	202647	369805
26923	43192	0	applied	\N	\N	\N	\N	202731	202731	369889
26923	43193	1	applied	\N	\N	\N	\N	202732	202732	369890
26923	43194	2	applied	\N	\N	\N	\N	202733	202733	369891
26931	43213	0	applied	\N	\N	\N	\N	202767	202767	369925
26931	43214	1	applied	\N	\N	\N	\N	202768	202768	369926
26931	43215	2	applied	\N	\N	\N	\N	202769	202769	369927
26931	43216	3	applied	\N	\N	\N	\N	202770	202770	369928
26931	43217	4	applied	\N	\N	\N	\N	202771	202771	369929
26931	43218	5	applied	\N	\N	\N	\N	202772	202772	369930
26938	43225	0	applied	\N	\N	\N	\N	202800	202800	369958
26938	43226	1	applied	\N	\N	\N	\N	202801	202801	369959
26944	43253	0	applied	\N	\N	\N	\N	202840	202840	369997
26944	43254	1	applied	\N	\N	\N	\N	202841	202841	369998
26944	43255	2	applied	\N	\N	\N	\N	202842	202842	369999
26946	43253	0	applied	\N	\N	\N	\N	202846	202846	370003
26946	43254	1	applied	\N	\N	\N	\N	202847	202847	370004
26946	43255	2	applied	\N	\N	\N	\N	202848	202848	370005
26949	43259	0	applied	\N	\N	\N	\N	202855	202855	370012
26949	43260	1	applied	\N	\N	\N	\N	202856	202856	370013
26949	43261	2	applied	\N	\N	\N	\N	202857	202857	370014
26951	43262	0	applied	\N	\N	\N	\N	202861	202861	370018
26951	43263	1	applied	\N	\N	\N	\N	202862	202862	370019
26951	43264	2	applied	\N	\N	\N	\N	202863	202863	370020
26952	43262	0	applied	\N	\N	\N	\N	202864	202864	370021
26952	43263	1	applied	\N	\N	\N	\N	202865	202865	370022
26952	43264	2	applied	\N	\N	\N	\N	202866	202866	370023
26953	43265	0	applied	\N	\N	\N	\N	202867	202867	370024
26953	43267	2	applied	\N	\N	\N	\N	202869	202869	370026
26953	43268	3	applied	\N	\N	\N	\N	202870	202870	370027
26962	43279	0	applied	\N	\N	\N	\N	202919	202919	370074
26962	43280	1	applied	\N	\N	\N	\N	202920	202920	370075
26962	43281	2	applied	\N	\N	\N	\N	202921	202921	370076
26962	43282	3	applied	\N	\N	\N	\N	202922	202922	370077
26962	43283	4	applied	\N	\N	\N	\N	202923	202923	370078
26965	43287	0	applied	\N	\N	\N	\N	202932	202932	370087
26965	43288	1	applied	\N	\N	\N	\N	202933	202933	370088
26965	43289	2	applied	\N	\N	\N	\N	202934	202934	370089
26968	43290	0	applied	\N	\N	\N	\N	202941	202941	370096
26968	43291	1	applied	\N	\N	\N	\N	202942	202942	370097
26968	43292	2	applied	\N	\N	\N	\N	202943	202943	370098
26969	43290	0	applied	\N	\N	\N	\N	202944	202944	370099
26969	43291	1	applied	\N	\N	\N	\N	202945	202945	370100
26969	43292	2	applied	\N	\N	\N	\N	202946	202946	370101
26973	43294	1	applied	\N	\N	\N	\N	203079	203079	370232
26973	43295	2	applied	\N	\N	\N	\N	203080	203080	370233
26975	43296	0	applied	\N	\N	\N	\N	203084	203084	370237
26975	43297	1	applied	\N	\N	\N	\N	203085	203085	370238
26975	43298	2	applied	\N	\N	\N	\N	203086	203086	370239
26983	43317	0	applied	\N	\N	\N	\N	203117	203117	370270
26983	43318	1	applied	\N	\N	\N	\N	203118	203118	370271
26983	43319	2	applied	\N	\N	\N	\N	203119	203119	370272
26983	43320	3	applied	\N	\N	\N	\N	203120	203120	370273
26983	43321	4	applied	\N	\N	\N	\N	203121	203121	370274
26983	43322	5	applied	\N	\N	\N	\N	203122	203122	370275
26988	43331	0	applied	\N	\N	\N	\N	203133	203133	370286
26988	43332	1	applied	\N	\N	\N	\N	203134	203134	370287
26988	43333	2	applied	\N	\N	\N	\N	203135	203135	370288
26886	43102	1	applied	\N	\N	\N	\N	202467	202467	369625
26886	43103	2	applied	\N	\N	\N	\N	202468	202468	369626
26906	43161	4	applied	\N	\N	\N	\N	202605	202605	369763
26908	43163	0	applied	\N	\N	\N	\N	202613	202613	369771
26908	43164	1	applied	\N	\N	\N	\N	202614	202614	369772
26908	43165	2	applied	\N	\N	\N	\N	202615	202615	369773
26910	43163	0	applied	\N	\N	\N	\N	202619	202619	369777
26910	43164	1	applied	\N	\N	\N	\N	202620	202620	369778
26910	43165	2	applied	\N	\N	\N	\N	202621	202621	369779
26912	43166	0	applied	\N	\N	\N	\N	202625	202625	369783
26912	43167	1	applied	\N	\N	\N	\N	202626	202626	369784
26912	43168	2	applied	\N	\N	\N	\N	202627	202627	369785
26914	43169	0	applied	\N	\N	\N	\N	202631	202631	369789
26914	43170	1	applied	\N	\N	\N	\N	202632	202632	369790
26917	43174	0	applied	\N	\N	\N	\N	202639	202639	369797
26917	43175	1	applied	\N	\N	\N	\N	202640	202640	369798
26917	43176	2	applied	\N	\N	\N	\N	202641	202641	369799
26925	43195	0	applied	\N	\N	\N	\N	202737	202737	369895
26925	43196	1	applied	\N	\N	\N	\N	202738	202738	369896
26930	43204	0	applied	\N	\N	\N	\N	202758	202758	369916
26930	43205	1	applied	\N	\N	\N	\N	202759	202759	369917
26930	43206	2	applied	\N	\N	\N	\N	202760	202760	369918
26930	43207	3	applied	\N	\N	\N	\N	202761	202761	369919
26930	43208	4	applied	\N	\N	\N	\N	202762	202762	369920
26930	43209	5	applied	\N	\N	\N	\N	202763	202763	369921
26930	43210	6	applied	\N	\N	\N	\N	202764	202764	369922
26930	43211	7	applied	\N	\N	\N	\N	202765	202765	369923
26930	43212	9	applied	\N	\N	\N	\N	202766	202766	369924
26933	43213	0	applied	\N	\N	\N	\N	202779	202779	369937
26933	43214	1	applied	\N	\N	\N	\N	202780	202780	369938
26933	43215	2	applied	\N	\N	\N	\N	202781	202781	369939
26933	43216	3	applied	\N	\N	\N	\N	202782	202782	369940
26933	43217	4	applied	\N	\N	\N	\N	202783	202783	369941
26933	43218	5	applied	\N	\N	\N	\N	202784	202784	369942
26935	43219	0	applied	\N	\N	\N	\N	202791	202791	369949
26935	43221	2	applied	\N	\N	\N	\N	202793	202793	369951
26940	43228	0	applied	\N	\N	\N	\N	202806	202806	369964
26940	43229	1	applied	\N	\N	\N	\N	202807	202807	369965
26940	43230	2	applied	\N	\N	\N	\N	202808	202808	369966
26948	43259	0	applied	\N	\N	\N	\N	202852	202852	370009
26948	43260	1	applied	\N	\N	\N	\N	202853	202853	370010
26948	43261	2	applied	\N	\N	\N	\N	202854	202854	370011
26950	43262	0	applied	\N	\N	\N	\N	202858	202858	370015
26950	43263	1	applied	\N	\N	\N	\N	202859	202859	370016
26950	43264	2	applied	\N	\N	\N	\N	202860	202860	370017
26956	43265	0	applied	\N	\N	\N	\N	202879	202879	370036
26956	43266	1	applied	\N	\N	\N	\N	202880	202880	370037
26956	43267	2	applied	\N	\N	\N	\N	202881	202881	370038
26956	43268	3	applied	\N	\N	\N	\N	202882	202882	370039
26957	43266	0	applied	\N	\N	\N	\N	202883	202883	370040
26957	43267	1	applied	\N	\N	\N	\N	202884	202884	370041
26959	43253	0	applied	\N	\N	\N	\N	202889	202889	370046
26959	43256	1	applied	\N	\N	\N	\N	202890	202890	370047
26959	43259	2	applied	\N	\N	\N	\N	202891	202891	370048
26959	43262	3	applied	\N	\N	\N	\N	202892	202892	370049
26959	43265	4	applied	\N	\N	\N	\N	202893	202893	370050
26959	43254	5	applied	\N	\N	\N	\N	202894	202894	370051
26959	43257	6	applied	\N	\N	\N	\N	202895	202895	370052
26959	43266	7	applied	\N	\N	\N	\N	202896	202896	370053
26959	43261	8	applied	\N	\N	\N	\N	202897	202897	370054
26959	43263	9	applied	\N	\N	\N	\N	202898	202898	370055
26959	43255	10	applied	\N	\N	\N	\N	202899	202899	370056
26959	43258	11	applied	\N	\N	\N	\N	202900	202900	370057
26959	43260	12	applied	\N	\N	\N	\N	202901	202901	370058
26959	43264	13	applied	\N	\N	\N	\N	202902	202902	370059
26959	43267	14	applied	\N	\N	\N	\N	202903	202903	370060
26959	43268	15	applied	\N	\N	\N	\N	202904	202904	370061
26964	43285	1	applied	\N	\N	\N	\N	202930	202930	370085
26964	43286	2	applied	\N	\N	\N	\N	202931	202931	370086
26967	43290	0	applied	\N	\N	\N	\N	202938	202938	370093
26967	43291	1	applied	\N	\N	\N	\N	202939	202939	370094
26967	43292	2	applied	\N	\N	\N	\N	202940	202940	370095
26970	42906	0	applied	\N	\N	\N	\N	202947	202947	370102
26970	42880	2	applied	\N	\N	\N	\N	202949	202949	370103
26970	43274	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	202948	202948	\N
26970	42893	4	applied	\N	\N	\N	\N	202951	202951	370104
26970	43266	5	applied	\N	\N	\N	\N	202952	202952	370105
26970	42875	6	applied	\N	\N	\N	\N	202953	202953	370106
26970	42881	7	applied	\N	\N	\N	\N	202954	202954	370107
26970	42882	8	applied	\N	\N	\N	\N	202955	202955	370108
26970	42883	9	applied	\N	\N	\N	\N	202956	202956	370109
26970	42905	10	applied	\N	\N	\N	\N	202957	202957	370110
26970	42913	11	applied	\N	\N	\N	\N	202958	202958	370111
26970	42928	12	applied	\N	\N	\N	\N	202959	202959	370112
26970	42937	13	applied	\N	\N	\N	\N	202960	202960	370113
26970	42948	14	applied	\N	\N	\N	\N	202961	202961	370114
26970	42961	15	applied	\N	\N	\N	\N	202962	202962	370115
26970	42970	16	applied	\N	\N	\N	\N	202963	202963	370116
26970	42983	17	applied	\N	\N	\N	\N	202964	202964	370117
26970	42994	18	applied	\N	\N	\N	\N	202965	202965	370118
26970	43005	19	applied	\N	\N	\N	\N	202966	202966	370119
26970	42889	20	applied	\N	\N	\N	\N	202967	202967	370120
26970	42891	21	applied	\N	\N	\N	\N	202968	202968	370121
26970	42895	22	applied	\N	\N	\N	\N	202969	202969	370122
26970	42897	23	applied	\N	\N	\N	\N	202970	202970	370123
26970	42900	24	applied	\N	\N	\N	\N	202971	202971	370124
26970	42904	25	applied	\N	\N	\N	\N	202972	202972	370125
26970	42908	26	applied	\N	\N	\N	\N	202973	202973	370126
26970	42876	27	applied	\N	\N	\N	\N	202974	202974	370127
26970	42884	28	applied	\N	\N	\N	\N	202975	202975	370128
26970	42885	29	applied	\N	\N	\N	\N	202976	202976	370129
26970	42886	30	applied	\N	\N	\N	\N	202977	202977	370130
26970	42888	31	applied	\N	\N	\N	\N	202978	202978	370131
26970	42894	32	applied	\N	\N	\N	\N	202979	202979	370132
26970	42914	33	applied	\N	\N	\N	\N	202980	202980	370133
26970	42915	34	applied	\N	\N	\N	\N	202981	202981	370134
26970	42898	35	applied	\N	\N	\N	\N	202982	202982	370135
26970	42919	37	applied	\N	\N	\N	\N	202984	202984	370137
26970	42922	38	applied	\N	\N	\N	\N	202985	202985	370138
26970	42924	39	applied	\N	\N	\N	\N	202986	202986	370139
26970	42929	40	applied	\N	\N	\N	\N	202987	202987	370140
26906	43159	2	applied	\N	\N	\N	\N	202603	202603	369761
26906	43160	3	applied	\N	\N	\N	\N	202604	202604	369762
26916	43176	2	applied	\N	\N	\N	\N	202638	202638	369796
26919	43183	0	applied	\N	\N	\N	\N	202648	202648	369806
26919	43184	1	applied	\N	\N	\N	\N	202649	202649	369807
26919	43185	2	applied	\N	\N	\N	\N	202650	202650	369808
26919	43186	3	applied	\N	\N	\N	\N	202651	202651	369809
26919	43187	4	applied	\N	\N	\N	\N	202652	202652	369810
26919	43188	5	applied	\N	\N	\N	\N	202653	202653	369811
26920	43152	41	applied	\N	\N	\N	\N	202695	202695	369853
26920	43156	42	applied	\N	\N	\N	\N	202696	202696	369854
26920	43140	44	applied	\N	\N	\N	\N	202698	202698	369856
26920	43141	45	applied	\N	\N	\N	\N	202699	202699	369857
26920	43146	46	applied	\N	\N	\N	\N	202700	202700	369858
26920	43147	47	applied	\N	\N	\N	\N	202701	202701	369859
26920	43149	48	applied	\N	\N	\N	\N	202702	202702	369860
26920	43153	49	applied	\N	\N	\N	\N	202703	202703	369861
26921	43189	0	applied	\N	\N	\N	\N	202725	202725	369883
26921	43190	1	applied	\N	\N	\N	\N	202726	202726	369884
26921	43191	2	applied	\N	\N	\N	\N	202727	202727	369885
26922	43189	0	applied	\N	\N	\N	\N	202728	202728	369886
26922	43190	1	applied	\N	\N	\N	\N	202729	202729	369887
26922	43191	2	applied	\N	\N	\N	\N	202730	202730	369888
26926	43198	0	applied	\N	\N	\N	\N	202740	202740	369898
26926	43199	1	applied	\N	\N	\N	\N	202741	202741	369899
26926	43200	2	applied	\N	\N	\N	\N	202742	202742	369900
26928	43201	0	applied	\N	\N	\N	\N	202746	202746	369904
26928	43203	2	applied	\N	\N	\N	\N	202748	202748	369906
26929	43204	0	applied	\N	\N	\N	\N	202749	202749	369907
26929	43205	1	applied	\N	\N	\N	\N	202750	202750	369908
26929	43206	2	applied	\N	\N	\N	\N	202751	202751	369909
26929	43207	3	applied	\N	\N	\N	\N	202752	202752	369910
26929	43208	4	applied	\N	\N	\N	\N	202753	202753	369911
26929	43209	5	applied	\N	\N	\N	\N	202754	202754	369912
26929	43210	6	applied	\N	\N	\N	\N	202755	202755	369913
26929	43211	7	applied	\N	\N	\N	\N	202756	202756	369914
26929	43212	9	applied	\N	\N	\N	\N	202757	202757	369915
26936	43222	0	applied	\N	\N	\N	\N	202794	202794	369952
26936	43223	1	applied	\N	\N	\N	\N	202795	202795	369953
26936	43224	2	applied	\N	\N	\N	\N	202796	202796	369954
26941	43231	0	applied	\N	\N	\N	\N	202809	202809	369967
26941	43232	1	applied	\N	\N	\N	\N	202810	202810	369968
26941	43233	2	applied	\N	\N	\N	\N	202811	202811	369969
26941	43235	4	applied	\N	\N	\N	\N	202813	202813	369971
26941	43236	5	applied	\N	\N	\N	\N	202814	202814	369972
26941	43237	6	applied	\N	\N	\N	\N	202815	202815	369973
26941	43238	7	applied	\N	\N	\N	\N	202816	202816	369974
26941	43239	8	applied	\N	\N	\N	\N	202817	202817	369975
26942	43231	0	applied	\N	\N	\N	\N	202818	202818	369976
26942	43232	1	applied	\N	\N	\N	\N	202819	202819	369977
26942	43233	2	applied	\N	\N	\N	\N	202820	202820	369978
26942	43234	3	applied	\N	\N	\N	\N	202821	202821	369979
26942	43235	4	applied	\N	\N	\N	\N	202822	202822	369980
26942	43236	5	applied	\N	\N	\N	\N	202823	202823	369981
26942	43237	6	applied	\N	\N	\N	\N	202824	202824	369982
26942	43238	7	applied	\N	\N	\N	\N	202825	202825	369983
26942	43239	8	applied	\N	\N	\N	\N	202826	202826	369984
26954	43265	0	applied	\N	\N	\N	\N	202871	202871	370028
26954	43266	1	applied	\N	\N	\N	\N	202872	202872	370029
26954	43268	3	applied	\N	\N	\N	\N	202874	202874	370031
26960	43272	0	applied	\N	\N	\N	\N	202905	202905	370062
26960	43273	1	applied	\N	\N	\N	\N	202906	202906	370063
26960	43275	3	applied	\N	\N	\N	\N	202908	202908	370064
26960	43274	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	202907	202907	\N
26960	43276	4	applied	\N	\N	\N	\N	202909	202909	370065
26960	43277	5	applied	\N	\N	\N	\N	202910	202910	370066
26960	43278	6	applied	\N	\N	\N	\N	202911	202911	370067
26963	43279	0	applied	\N	\N	\N	\N	202924	202924	370079
26963	43280	1	applied	\N	\N	\N	\N	202925	202925	370080
26963	43281	2	applied	\N	\N	\N	\N	202926	202926	370081
26963	43282	3	applied	\N	\N	\N	\N	202927	202927	370082
26963	43283	4	applied	\N	\N	\N	\N	202928	202928	370083
26971	43293	0	applied	\N	\N	\N	\N	203072	203072	370225
26971	43294	1	applied	\N	\N	\N	\N	203073	203073	370226
26971	43295	2	applied	\N	\N	\N	\N	203074	203074	370227
26976	43297	1	applied	\N	\N	\N	\N	203088	203088	370241
26976	43298	2	applied	\N	\N	\N	\N	203089	203089	370242
26978	43296	0	applied	\N	\N	\N	\N	203093	203093	370246
26978	43297	1	applied	\N	\N	\N	\N	203094	203094	370247
26978	43298	2	applied	\N	\N	\N	\N	203095	203095	370248
26980	43299	0	applied	\N	\N	\N	\N	203099	203099	370252
26980	43300	1	applied	\N	\N	\N	\N	203100	203100	370253
26986	43326	0	applied	\N	\N	\N	\N	203128	203128	370281
26986	43327	1	applied	\N	\N	\N	\N	203129	203129	370282
26986	43328	2	applied	\N	\N	\N	\N	203130	203130	370283
26989	43334	0	applied	\N	\N	\N	\N	203136	203136	370289
26989	43335	1	applied	\N	\N	\N	\N	203137	203137	370290
26989	43336	2	applied	\N	\N	\N	\N	203138	203138	370291
26989	43337	3	applied	\N	\N	\N	\N	203139	203139	370292
26989	43338	4	applied	\N	\N	\N	\N	203140	203140	370293
26989	43339	5	applied	\N	\N	\N	\N	203141	203141	370294
26992	43341	1	applied	\N	\N	\N	\N	203149	203149	370302
26992	43342	2	applied	\N	\N	\N	\N	203150	203150	370303
26994	43343	0	applied	\N	\N	\N	\N	203154	203154	370307
26994	43344	1	applied	\N	\N	\N	\N	203155	203155	370308
26994	43345	2	applied	\N	\N	\N	\N	203156	203156	370309
26997	43349	0	applied	\N	\N	\N	\N	203168	203168	370321
26997	43350	1	applied	\N	\N	\N	\N	203169	203169	370322
26997	43351	2	applied	\N	\N	\N	\N	203170	203170	370323
26997	43352	3	applied	\N	\N	\N	\N	203171	203171	370324
26997	43353	4	applied	\N	\N	\N	\N	203172	203172	370325
26997	43354	5	applied	\N	\N	\N	\N	203173	203173	370326
26997	43355	6	applied	\N	\N	\N	\N	203174	203174	370327
26997	43356	7	applied	\N	\N	\N	\N	203175	203175	370328
26999	43357	0	applied	\N	\N	\N	\N	203179	203179	370332
26999	43358	1	applied	\N	\N	\N	\N	203180	203180	370333
26999	43359	2	applied	\N	\N	\N	\N	203181	203181	370334
27001	43361	1	applied	\N	\N	\N	\N	203185	203185	370338
27004	43366	0	applied	\N	\N	\N	\N	203193	203193	370346
27004	43367	1	applied	\N	\N	\N	\N	203194	203194	370347
27004	43368	2	applied	\N	\N	\N	\N	203195	203195	370348
26916	43174	0	applied	\N	\N	\N	\N	202636	202636	369794
26916	43175	1	applied	\N	\N	\N	\N	202637	202637	369795
26920	43165	53	applied	\N	\N	\N	\N	202707	202707	369865
26920	43170	55	applied	\N	\N	\N	\N	202709	202709	369867
26920	43176	56	applied	\N	\N	\N	\N	202710	202710	369868
26920	43181	57	applied	\N	\N	\N	\N	202711	202711	369869
26920	43182	58	applied	\N	\N	\N	\N	202712	202712	369870
26920	43186	59	applied	\N	\N	\N	\N	202713	202713	369871
26920	43187	60	applied	\N	\N	\N	\N	202714	202714	369872
26920	43162	61	applied	\N	\N	\N	\N	202715	202715	369873
26920	43164	62	applied	\N	\N	\N	\N	202716	202716	369874
26920	43167	63	applied	\N	\N	\N	\N	202717	202717	369875
26920	43171	64	applied	\N	\N	\N	\N	202718	202718	369876
26920	43173	65	applied	\N	\N	\N	\N	202719	202719	369877
26920	43175	66	applied	\N	\N	\N	\N	202720	202720	369878
26920	43179	67	applied	\N	\N	\N	\N	202721	202721	369879
26920	43180	68	applied	\N	\N	\N	\N	202722	202722	369880
26920	43185	69	applied	\N	\N	\N	\N	202723	202723	369881
26920	43188	70	applied	\N	\N	\N	\N	202724	202724	369882
26924	43196	1	applied	\N	\N	\N	\N	202735	202735	369893
26924	43197	2	applied	\N	\N	\N	\N	202736	202736	369894
26927	43198	0	applied	\N	\N	\N	\N	202743	202743	369901
26927	43199	1	applied	\N	\N	\N	\N	202744	202744	369902
26927	43200	2	applied	\N	\N	\N	\N	202745	202745	369903
26932	43213	0	applied	\N	\N	\N	\N	202773	202773	369931
26932	43214	1	applied	\N	\N	\N	\N	202774	202774	369932
26932	43215	2	applied	\N	\N	\N	\N	202775	202775	369933
26932	43216	3	applied	\N	\N	\N	\N	202776	202776	369934
26932	43217	4	applied	\N	\N	\N	\N	202777	202777	369935
26932	43218	5	applied	\N	\N	\N	\N	202778	202778	369936
26934	43213	0	applied	\N	\N	\N	\N	202785	202785	369943
26934	43214	1	applied	\N	\N	\N	\N	202786	202786	369944
26934	43215	2	applied	\N	\N	\N	\N	202787	202787	369945
26934	43216	3	applied	\N	\N	\N	\N	202788	202788	369946
26934	43217	4	applied	\N	\N	\N	\N	202789	202789	369947
26937	43225	0	applied	\N	\N	\N	\N	202797	202797	369955
26937	43226	1	applied	\N	\N	\N	\N	202798	202798	369956
26937	43227	2	applied	\N	\N	\N	\N	202799	202799	369957
26939	43228	0	applied	\N	\N	\N	\N	202803	202803	369961
26939	43229	1	applied	\N	\N	\N	\N	202804	202804	369962
26939	43230	2	applied	\N	\N	\N	\N	202805	202805	369963
26943	43240	0	applied	\N	\N	\N	\N	202827	202827	369985
26943	43241	1	applied	\N	\N	\N	\N	202828	202828	369986
26943	43242	2	applied	\N	\N	\N	\N	202829	202829	369987
26943	43243	3	applied	\N	\N	\N	\N	202830	202830	369988
26943	43245	5	applied	\N	\N	\N	\N	202832	202832	369989
26943	43246	6	applied	\N	\N	\N	\N	202833	202833	369990
26943	43247	7	applied	\N	\N	\N	\N	202834	202834	369991
26943	43248	8	applied	\N	\N	\N	\N	202835	202835	369992
26943	43249	9	applied	\N	\N	\N	\N	202836	202836	369993
26943	43250	10	applied	\N	\N	\N	\N	202837	202837	369994
26943	43251	11	applied	\N	\N	\N	\N	202838	202838	369995
26943	43252	12	applied	\N	\N	\N	\N	202839	202839	369996
26945	43253	0	applied	\N	\N	\N	\N	202843	202843	370000
26945	43254	1	applied	\N	\N	\N	\N	202844	202844	370001
26945	43255	2	applied	\N	\N	\N	\N	202845	202845	370002
26947	43256	0	applied	\N	\N	\N	\N	202849	202849	370006
26947	43257	1	applied	\N	\N	\N	\N	202850	202850	370007
26947	43258	2	applied	\N	\N	\N	\N	202851	202851	370008
26955	43265	0	applied	\N	\N	\N	\N	202875	202875	370032
26955	43266	1	applied	\N	\N	\N	\N	202876	202876	370033
26955	43267	2	applied	\N	\N	\N	\N	202877	202877	370034
26955	43268	3	applied	\N	\N	\N	\N	202878	202878	370035
26958	43269	0	applied	\N	\N	\N	\N	202886	202886	370043
26958	43270	1	applied	\N	\N	\N	\N	202887	202887	370044
26958	43271	2	applied	\N	\N	\N	\N	202888	202888	370045
26961	43272	0	applied	\N	\N	\N	\N	202912	202912	370068
26961	43273	1	applied	\N	\N	\N	\N	202913	202913	370069
26961	43275	3	applied	\N	\N	\N	\N	202915	202915	370070
26961	43276	4	applied	\N	\N	\N	\N	202916	202916	370071
26961	43277	5	applied	\N	\N	\N	\N	202917	202917	370072
26961	43278	6	applied	\N	\N	\N	\N	202918	202918	370073
26966	43290	0	applied	\N	\N	\N	\N	202935	202935	370090
26966	43291	1	applied	\N	\N	\N	\N	202936	202936	370091
26966	43292	2	applied	\N	\N	\N	\N	202937	202937	370092
26970	42930	41	applied	\N	\N	\N	\N	202988	202988	370141
26970	42942	42	applied	\N	\N	\N	\N	202989	202989	370142
26970	42943	43	applied	\N	\N	\N	\N	202990	202990	370143
26970	42944	44	applied	\N	\N	\N	\N	202991	202991	370144
26970	42945	45	applied	\N	\N	\N	\N	202992	202992	370145
26970	42949	46	applied	\N	\N	\N	\N	202993	202993	370146
26970	42952	47	applied	\N	\N	\N	\N	202994	202994	370147
26970	42956	48	applied	\N	\N	\N	\N	202995	202995	370148
26970	42958	49	applied	\N	\N	\N	\N	202996	202996	370149
26972	43293	0	applied	\N	\N	\N	\N	203075	203075	370228
26972	43294	1	applied	\N	\N	\N	\N	203076	203076	370229
26972	43295	2	applied	\N	\N	\N	\N	203077	203077	370230
26974	43296	0	applied	\N	\N	\N	\N	203081	203081	370234
26974	43297	1	applied	\N	\N	\N	\N	203082	203082	370235
26974	43298	2	applied	\N	\N	\N	\N	203083	203083	370236
26977	43296	0	applied	\N	\N	\N	\N	203090	203090	370243
26977	43297	1	applied	\N	\N	\N	\N	203091	203091	370244
26977	43298	2	applied	\N	\N	\N	\N	203092	203092	370245
26981	43301	0	applied	\N	\N	\N	\N	203101	203101	370254
26981	43302	1	applied	\N	\N	\N	\N	203102	203102	370255
26981	43303	2	applied	\N	\N	\N	\N	203103	203103	370256
26981	43304	3	applied	\N	\N	\N	\N	203104	203104	370257
26981	43305	4	applied	\N	\N	\N	\N	203105	203105	370258
26981	43306	5	applied	\N	\N	\N	\N	203106	203106	370259
26984	43323	0	applied	\N	\N	\N	\N	203123	203123	370276
26984	43324	1	applied	\N	\N	\N	\N	203124	203124	370277
26984	43325	2	applied	\N	\N	\N	\N	203125	203125	370278
26985	43324	0	applied	\N	\N	\N	\N	203126	203126	370279
26985	43325	1	applied	\N	\N	\N	\N	203127	203127	370280
27008	43369	0	applied	\N	\N	\N	\N	203214	203214	370367
27008	43370	1	applied	\N	\N	\N	\N	203215	203215	370368
27008	43371	2	applied	\N	\N	\N	\N	203216	203216	370369
27008	43372	3	applied	\N	\N	\N	\N	203217	203217	370370
27008	43373	4	applied	\N	\N	\N	\N	203218	203218	370371
27008	43374	5	applied	\N	\N	\N	\N	203219	203219	370372
27011	43375	0	applied	\N	\N	\N	\N	203224	203224	370377
27011	43376	1	applied	\N	\N	\N	\N	203225	203225	370378
26920	43160	51	applied	\N	\N	\N	\N	202705	202705	369863
26920	43161	52	applied	\N	\N	\N	\N	202706	202706	369864
26970	43063	54	applied	\N	\N	\N	\N	203001	203001	370154
26970	43070	55	applied	\N	\N	\N	\N	203002	203002	370155
26970	43081	56	applied	\N	\N	\N	\N	203003	203003	370156
26970	43093	57	applied	\N	\N	\N	\N	203004	203004	370157
26970	43103	58	applied	\N	\N	\N	\N	203005	203005	370158
26970	43112	59	applied	\N	\N	\N	\N	203006	203006	370159
26970	43129	60	applied	\N	\N	\N	\N	203007	203007	370160
26970	42965	61	applied	\N	\N	\N	\N	203008	203008	370161
26970	42967	62	applied	\N	\N	\N	\N	203009	203009	370162
26970	42971	63	applied	\N	\N	\N	\N	203010	203010	370163
26970	42975	64	applied	\N	\N	\N	\N	203011	203011	370164
26970	42979	65	applied	\N	\N	\N	\N	203012	203012	370165
26970	42984	66	applied	\N	\N	\N	\N	203013	203013	370166
26970	42985	67	applied	\N	\N	\N	\N	203014	203014	370167
26970	42987	68	applied	\N	\N	\N	\N	203015	203015	370168
26970	42990	69	applied	\N	\N	\N	\N	203016	203016	370169
26970	42997	71	applied	\N	\N	\N	\N	203018	203018	370171
26970	43001	72	applied	\N	\N	\N	\N	203019	203019	370172
26970	43003	73	applied	\N	\N	\N	\N	203020	203020	370173
26970	43010	74	applied	\N	\N	\N	\N	203021	203021	370174
26970	43012	75	applied	\N	\N	\N	\N	203022	203022	370175
26970	43013	76	applied	\N	\N	\N	\N	203023	203023	370176
26970	43014	77	applied	\N	\N	\N	\N	203024	203024	370177
26970	43020	78	applied	\N	\N	\N	\N	203025	203025	370178
26970	43024	79	applied	\N	\N	\N	\N	203026	203026	370179
26970	43026	80	applied	\N	\N	\N	\N	203027	203027	370180
26970	43029	81	applied	\N	\N	\N	\N	203028	203028	370181
26970	43033	82	applied	\N	\N	\N	\N	203029	203029	370182
26970	43036	83	applied	\N	\N	\N	\N	203030	203030	370183
26970	43038	84	applied	\N	\N	\N	\N	203031	203031	370184
26970	43043	85	applied	\N	\N	\N	\N	203032	203032	370185
26970	43051	86	applied	\N	\N	\N	\N	203033	203033	370186
26970	43053	88	applied	\N	\N	\N	\N	203035	203035	370188
26970	43055	89	applied	\N	\N	\N	\N	203036	203036	370189
26970	43060	90	applied	\N	\N	\N	\N	203037	203037	370190
26970	43061	91	applied	\N	\N	\N	\N	203038	203038	370191
26970	43066	92	applied	\N	\N	\N	\N	203039	203039	370192
26970	43068	93	applied	\N	\N	\N	\N	203040	203040	370193
26970	43073	94	applied	\N	\N	\N	\N	203041	203041	370194
26970	43075	95	applied	\N	\N	\N	\N	203042	203042	370195
26970	43078	96	applied	\N	\N	\N	\N	203043	203043	370196
26970	43084	97	applied	\N	\N	\N	\N	203044	203044	370197
26970	43087	98	applied	\N	\N	\N	\N	203045	203045	370198
26970	43091	99	applied	\N	\N	\N	\N	203046	203046	370199
26970	43092	100	applied	\N	\N	\N	\N	203047	203047	370200
26970	43097	102	applied	\N	\N	\N	\N	203048	203048	370201
26970	43099	103	applied	\N	\N	\N	\N	203049	203049	370202
26970	43102	104	applied	\N	\N	\N	\N	203050	203050	370203
26970	43110	106	applied	\N	\N	\N	\N	203052	203052	370205
26970	43114	107	applied	\N	\N	\N	\N	203053	203053	370206
26970	43116	108	applied	\N	\N	\N	\N	203054	203054	370207
26970	43122	109	applied	\N	\N	\N	\N	203055	203055	370208
26970	43123	110	applied	\N	\N	\N	\N	203056	203056	370209
26970	43126	111	applied	\N	\N	\N	\N	203057	203057	370210
26970	43127	112	applied	\N	\N	\N	\N	203058	203058	370211
26970	43136	113	applied	\N	\N	\N	\N	203059	203059	370212
26970	43137	114	applied	\N	\N	\N	\N	203060	203060	370213
26970	43139	115	applied	\N	\N	\N	\N	203061	203061	370214
26970	43144	116	applied	\N	\N	\N	\N	203062	203062	370215
26970	43145	117	applied	\N	\N	\N	\N	203063	203063	370216
26970	43150	118	applied	\N	\N	\N	\N	203064	203064	370217
26970	43152	119	applied	\N	\N	\N	\N	203065	203065	370218
26970	43156	120	applied	\N	\N	\N	\N	203066	203066	370219
26970	43159	121	applied	\N	\N	\N	\N	203067	203067	370220
26970	43164	123	applied	\N	\N	\N	\N	203069	203069	370222
26970	43167	124	applied	\N	\N	\N	\N	203070	203070	370223
26970	43171	125	applied	\N	\N	\N	\N	203071	203071	370224
26979	43296	0	applied	\N	\N	\N	\N	203096	203096	370249
26979	43297	1	applied	\N	\N	\N	\N	203097	203097	370250
26979	43298	2	applied	\N	\N	\N	\N	203098	203098	370251
26982	43308	0	applied	\N	\N	\N	\N	203108	203108	370261
26982	43309	1	applied	\N	\N	\N	\N	203109	203109	370262
26982	43310	2	applied	\N	\N	\N	\N	203110	203110	370263
26982	43311	3	applied	\N	\N	\N	\N	203111	203111	370264
26982	43312	4	applied	\N	\N	\N	\N	203112	203112	370265
26982	43313	5	applied	\N	\N	\N	\N	203113	203113	370266
26982	43314	6	applied	\N	\N	\N	\N	203114	203114	370267
26982	43315	7	applied	\N	\N	\N	\N	203115	203115	370268
26982	43316	8	applied	\N	\N	\N	\N	203116	203116	370269
26987	43329	0	applied	\N	\N	\N	\N	203131	203131	370284
26990	43340	0	applied	\N	\N	\N	\N	203142	203142	370295
26990	43341	1	applied	\N	\N	\N	\N	203143	203143	370296
26990	43342	2	applied	\N	\N	\N	\N	203144	203144	370297
26991	43340	0	applied	\N	\N	\N	\N	203145	203145	370298
26991	43341	1	applied	\N	\N	\N	\N	203146	203146	370299
26991	43342	2	applied	\N	\N	\N	\N	203147	203147	370300
26993	43343	0	applied	\N	\N	\N	\N	203151	203151	370304
26993	43344	1	applied	\N	\N	\N	\N	203152	203152	370305
26993	43345	2	applied	\N	\N	\N	\N	203153	203153	370306
26995	43346	0	applied	\N	\N	\N	\N	203157	203157	370310
26995	43347	1	applied	\N	\N	\N	\N	203158	203158	370311
26995	43348	2	applied	\N	\N	\N	\N	203159	203159	370312
27000	43360	0	applied	\N	\N	\N	\N	203182	203182	370335
27000	43361	1	applied	\N	\N	\N	\N	203183	203183	370336
27002	43362	0	applied	\N	\N	\N	\N	203186	203186	370339
27002	43363	1	applied	\N	\N	\N	\N	203187	203187	370340
27002	43365	3	applied	\N	\N	\N	\N	203189	203189	370342
27005	43369	0	applied	\N	\N	\N	\N	203196	203196	370349
27005	43370	1	applied	\N	\N	\N	\N	203197	203197	370350
27005	43371	2	applied	\N	\N	\N	\N	203198	203198	370351
27005	43372	3	applied	\N	\N	\N	\N	203199	203199	370352
27005	43373	4	applied	\N	\N	\N	\N	203200	203200	370353
27005	43374	5	applied	\N	\N	\N	\N	203201	203201	370354
27009	43375	0	applied	\N	\N	\N	\N	203220	203220	370373
27009	43376	1	applied	\N	\N	\N	\N	203221	203221	370374
27009	43377	2	applied	\N	\N	\N	\N	203222	203222	370375
27016	43384	0	applied	\N	\N	\N	\N	203242	203242	370395
27016	43385	2	applied	\N	\N	\N	\N	203243	203243	370396
27016	43386	3	applied	\N	\N	\N	\N	203244	203244	370397
27023	43395	0	applied	\N	\N	\N	\N	203261	203261	370414
26970	43027	51	applied	\N	\N	\N	\N	202998	202998	370151
26970	43039	52	applied	\N	\N	\N	\N	202999	202999	370152
26996	43353	4	applied	\N	\N	\N	\N	203164	203164	370317
26996	43354	5	applied	\N	\N	\N	\N	203165	203165	370318
26996	43355	6	applied	\N	\N	\N	\N	203166	203166	370319
26996	43356	7	applied	\N	\N	\N	\N	203167	203167	370320
26998	43357	0	applied	\N	\N	\N	\N	203176	203176	370329
26998	43358	1	applied	\N	\N	\N	\N	203177	203177	370330
26998	43359	2	applied	\N	\N	\N	\N	203178	203178	370331
27003	43366	0	applied	\N	\N	\N	\N	203190	203190	370343
27003	43367	1	applied	\N	\N	\N	\N	203191	203191	370344
27003	43368	2	applied	\N	\N	\N	\N	203192	203192	370345
27006	43369	0	applied	\N	\N	\N	\N	203202	203202	370355
27006	43371	2	applied	\N	\N	\N	\N	203204	203204	370357
27006	43372	3	applied	\N	\N	\N	\N	203205	203205	370358
27006	43373	4	applied	\N	\N	\N	\N	203206	203206	370359
27006	43374	5	applied	\N	\N	\N	\N	203207	203207	370360
27007	43369	0	applied	\N	\N	\N	\N	203208	203208	370361
27007	43370	1	applied	\N	\N	\N	\N	203209	203209	370362
27007	43371	2	applied	\N	\N	\N	\N	203210	203210	370363
27007	43372	3	applied	\N	\N	\N	\N	203211	203211	370364
27007	43373	4	applied	\N	\N	\N	\N	203212	203212	370365
27007	43374	5	applied	\N	\N	\N	\N	203213	203213	370366
27010	43377	0	applied	\N	\N	\N	\N	203223	203223	370376
27012	43378	0	applied	\N	\N	\N	\N	203227	203227	370380
27012	43379	1	applied	\N	\N	\N	\N	203228	203228	370381
27012	43380	2	applied	\N	\N	\N	\N	203229	203229	370382
27012	43381	3	applied	\N	\N	\N	\N	203230	203230	370383
27012	43382	4	applied	\N	\N	\N	\N	203231	203231	370384
27013	43384	0	applied	\N	\N	\N	\N	203233	203233	370386
27013	43385	2	applied	\N	\N	\N	\N	203234	203234	370387
27013	43386	3	applied	\N	\N	\N	\N	203235	203235	370388
27015	43384	0	applied	\N	\N	\N	\N	203239	203239	370392
27015	43385	2	applied	\N	\N	\N	\N	203240	203240	370393
27015	43386	3	applied	\N	\N	\N	\N	203241	203241	370394
27017	43387	0	applied	\N	\N	\N	\N	203245	203245	370398
27017	43388	1	applied	\N	\N	\N	\N	203246	203246	370399
27019	43389	0	applied	\N	\N	\N	\N	203250	203250	370403
27019	43390	1	applied	\N	\N	\N	\N	203251	203251	370404
27024	43395	0	applied	\N	\N	\N	\N	203264	203264	370417
27024	43396	1	applied	\N	\N	\N	\N	203265	203265	370418
27024	43397	2	applied	\N	\N	\N	\N	203266	203266	370419
27026	43399	0	applied	\N	\N	\N	\N	203270	203270	370423
27026	43400	1	applied	\N	\N	\N	\N	203271	203271	370424
27028	43398	0	applied	\N	\N	\N	\N	203397	203397	370548
27028	43402	2	applied	\N	\N	\N	\N	203399	203399	370550
27028	43403	3	applied	\N	\N	\N	\N	203400	203400	370551
27030	43362	0	applied	\N	\N	\N	\N	203405	203405	370556
27030	43366	1	applied	\N	\N	\N	\N	203406	203406	370557
27030	43369	2	applied	\N	\N	\N	\N	203407	203407	370558
27030	43370	3	applied	\N	\N	\N	\N	203408	203408	370559
27030	43375	4	applied	\N	\N	\N	\N	203409	203409	370560
27030	43378	5	applied	\N	\N	\N	\N	203410	203410	370561
27030	43379	6	applied	\N	\N	\N	\N	203411	203411	370562
27030	43384	7	applied	\N	\N	\N	\N	203412	203412	370563
27030	43387	8	applied	\N	\N	\N	\N	203413	203413	370564
27030	43389	9	applied	\N	\N	\N	\N	203414	203414	370565
27030	43392	10	applied	\N	\N	\N	\N	203415	203415	370566
27030	43395	11	applied	\N	\N	\N	\N	203416	203416	370567
27030	43398	12	applied	\N	\N	\N	\N	203417	203417	370568
27030	43401	13	applied	\N	\N	\N	\N	203418	203418	370569
27030	43363	15	applied	\N	\N	\N	\N	203420	203420	370571
27030	43364	16	applied	\N	\N	\N	\N	203421	203421	370572
27030	43368	17	applied	\N	\N	\N	\N	203422	203422	370573
27030	43371	18	applied	\N	\N	\N	\N	203423	203423	370574
27030	43365	19	applied	\N	\N	\N	\N	203424	203424	370575
27030	43367	20	applied	\N	\N	\N	\N	203425	203425	370576
27030	43372	21	applied	\N	\N	\N	\N	203426	203426	370577
27030	43377	22	applied	\N	\N	\N	\N	203427	203427	370578
27030	43380	23	applied	\N	\N	\N	\N	203428	203428	370579
27030	43381	24	applied	\N	\N	\N	\N	203429	203429	370580
27030	43385	25	applied	\N	\N	\N	\N	203430	203430	370581
27030	43390	26	applied	\N	\N	\N	\N	203431	203431	370582
27030	43394	27	applied	\N	\N	\N	\N	203432	203432	370583
27030	43397	28	applied	\N	\N	\N	\N	203433	203433	370584
27030	43400	29	applied	\N	\N	\N	\N	203434	203434	370585
27030	43403	30	applied	\N	\N	\N	\N	203435	203435	370586
27030	43373	32	applied	\N	\N	\N	\N	203437	203437	370588
27033	43404	0	applied	\N	\N	\N	\N	203444	203444	370595
27033	43406	1	applied	\N	\N	\N	\N	203445	203445	370596
27033	43405	2	applied	\N	\N	\N	\N	203446	203446	370597
27034	43404	0	applied	\N	\N	\N	\N	203447	203447	370598
27034	43405	1	applied	\N	\N	\N	\N	203448	203448	370599
27036	43407	0	applied	\N	\N	\N	\N	203453	203453	370604
27036	43408	1	applied	\N	\N	\N	\N	203454	203454	370605
27036	43409	2	applied	\N	\N	\N	\N	203455	203455	370606
27036	43410	3	applied	\N	\N	1000000000	\N	203456	203456	370607
27038	43411	0	applied	\N	\N	\N	\N	203460	203460	370611
27038	43412	1	applied	\N	\N	\N	\N	203461	203461	370612
27038	43413	2	applied	\N	\N	1000000000	\N	203462	203462	370613
27038	43414	3	applied	\N	\N	1000000000	\N	203463	203463	370614
27039	43410	0	applied	\N	\N	1000000000	\N	203465	203465	370616
27039	43413	1	applied	\N	\N	1000000000	\N	203466	203466	370617
27039	43414	2	applied	\N	\N	1000000000	\N	203467	203467	370618
27039	43415	3	applied	\N	\N	1000000000	\N	203468	203468	370619
27043	43411	0	applied	\N	\N	\N	\N	203519	203519	370670
27043	43412	1	applied	\N	\N	\N	\N	203520	203520	370671
27043	43413	2	applied	\N	\N	1000000000	\N	203521	203521	370672
27043	43414	3	applied	\N	\N	1000000000	\N	203522	203522	370673
27043	43415	4	applied	\N	\N	1000000000	\N	203523	203523	370674
27056	43440	0	applied	\N	\N	\N	\N	203605	203605	370754
27056	43441	1	applied	\N	\N	\N	\N	203606	203606	370755
27056	43442	2	applied	\N	\N	\N	\N	203607	203607	370756
27056	43443	3	applied	\N	\N	\N	\N	203608	203608	370757
27056	43444	4	applied	\N	\N	\N	\N	203609	203609	370758
27056	43445	5	applied	\N	\N	\N	\N	203610	203610	370759
27059	43446	0	applied	\N	\N	\N	\N	203620	203620	370769
27059	43447	1	applied	\N	\N	\N	\N	203621	203621	370770
27059	43448	2	applied	\N	\N	\N	\N	203622	203622	370771
27084	43514	0	applied	\N	\N	\N	\N	203884	203884	371031
26996	43350	1	applied	\N	\N	\N	\N	203161	203161	370314
26996	43352	3	applied	\N	\N	\N	\N	203163	203163	370316
27014	43386	3	applied	\N	\N	\N	\N	203238	203238	370391
27018	43389	0	applied	\N	\N	\N	\N	203247	203247	370400
27018	43390	1	applied	\N	\N	\N	\N	203248	203248	370401
27020	43389	0	applied	\N	\N	\N	\N	203252	203252	370405
27020	43390	1	applied	\N	\N	\N	\N	203253	203253	370406
27020	43391	2	applied	\N	\N	\N	\N	203254	203254	370407
27021	43389	0	applied	\N	\N	\N	\N	203255	203255	370408
27021	43390	1	applied	\N	\N	\N	\N	203256	203256	370409
27022	43392	0	applied	\N	\N	\N	\N	203258	203258	370411
27022	43393	1	applied	\N	\N	\N	\N	203259	203259	370412
27022	43394	2	applied	\N	\N	\N	\N	203260	203260	370413
27040	43411	0	applied	\N	\N	\N	\N	203469	203469	370620
27040	43412	1	applied	\N	\N	\N	\N	203470	203470	370621
27040	43413	2	applied	\N	\N	1000000000	\N	203471	203471	370622
27040	43414	3	applied	\N	\N	1000000000	\N	203472	203472	370623
27040	43415	4	applied	\N	\N	1000000000	\N	203473	203473	370624
27047	43419	0	applied	\N	\N	\N	\N	203547	203547	370696
27047	43420	1	applied	\N	\N	\N	\N	203548	203548	370697
27047	43421	2	applied	\N	\N	\N	\N	203549	203549	370698
27047	43423	4	applied	\N	\N	\N	\N	203551	203551	370700
27047	43424	5	applied	\N	\N	\N	\N	203552	203552	370701
27052	43432	0	applied	\N	\N	\N	\N	203571	203571	370720
27054	43431	0	applied	\N	\N	\N	\N	203589	203589	370738
27054	43434	1	applied	\N	\N	\N	\N	203590	203590	370739
27054	43435	2	applied	\N	\N	\N	\N	203591	203591	370740
27054	43436	3	applied	\N	\N	\N	\N	203592	203592	370741
27054	43437	4	applied	\N	\N	\N	\N	203593	203593	370742
27054	43433	5	applied	\N	\N	\N	\N	203594	203594	370743
27054	43438	6	applied	\N	\N	\N	\N	203595	203595	370744
27054	43439	7	applied	\N	\N	\N	\N	203596	203596	370745
27055	43431	0	applied	\N	\N	\N	\N	203597	203597	370746
27055	43434	1	applied	\N	\N	\N	\N	203598	203598	370747
27055	43435	2	applied	\N	\N	\N	\N	203599	203599	370748
27055	43436	3	applied	\N	\N	\N	\N	203600	203600	370749
27055	43437	4	applied	\N	\N	\N	\N	203601	203601	370750
27055	43438	6	applied	\N	\N	\N	\N	203603	203603	370752
27055	43439	7	applied	\N	\N	\N	\N	203604	203604	370753
27057	43440	0	applied	\N	\N	\N	\N	203611	203611	370760
27057	43441	1	applied	\N	\N	\N	\N	203612	203612	370761
27057	43442	2	applied	\N	\N	\N	\N	203613	203613	370762
27057	43443	3	applied	\N	\N	\N	\N	203614	203614	370763
27057	43444	4	applied	\N	\N	\N	\N	203615	203615	370764
27057	43445	5	applied	\N	\N	\N	\N	203616	203616	370765
27062	43458	0	applied	\N	\N	\N	\N	203632	203632	370781
27062	43459	1	applied	\N	\N	\N	\N	203633	203633	370782
27062	43460	2	applied	\N	\N	\N	\N	203634	203634	370783
27062	43461	3	applied	\N	\N	\N	\N	203635	203635	370784
27062	43462	4	applied	\N	\N	\N	\N	203636	203636	370785
27062	43463	5	applied	\N	\N	\N	\N	203637	203637	370786
27062	43464	6	applied	\N	\N	\N	\N	203638	203638	203638
27062	43465	7	applied	\N	\N	\N	\N	203639	203639	370787
27067	43470	2	applied	\N	\N	\N	\N	203651	203651	370799
27067	43471	3	applied	\N	\N	\N	\N	203652	203652	370800
27067	43472	4	applied	\N	\N	\N	\N	203653	203653	370801
27067	43473	5	applied	\N	\N	\N	\N	203654	203654	370802
27067	43474	6	applied	\N	\N	\N	\N	203655	203655	370803
27069	43173	0	applied	\N	\N	\N	\N	203662	203662	370810
27069	43175	1	applied	\N	\N	\N	\N	203663	203663	370811
27069	43179	2	applied	\N	\N	\N	\N	203664	203664	370812
27069	43180	3	applied	\N	\N	\N	\N	203665	203665	370813
27069	43185	4	applied	\N	\N	\N	\N	203666	203666	370814
27069	43188	5	applied	\N	\N	\N	\N	203667	203667	370815
27069	43191	6	applied	\N	\N	\N	\N	203668	203668	370816
27069	43460	7	applied	\N	\N	\N	\N	203669	203669	370817
27069	43461	8	applied	\N	\N	\N	\N	203670	203670	370818
27069	43462	9	applied	\N	\N	\N	\N	203671	203671	370819
27069	43463	10	applied	\N	\N	\N	\N	203672	203672	370820
27069	43194	12	applied	\N	\N	\N	\N	203674	203674	370821
27069	43197	13	applied	\N	\N	\N	\N	203675	203675	370822
27069	43200	14	applied	\N	\N	\N	\N	203676	203676	370823
27069	43203	15	applied	\N	\N	\N	\N	203677	203677	370824
27069	43207	16	applied	\N	\N	\N	\N	203678	203678	370825
27069	43208	17	applied	\N	\N	\N	\N	203679	203679	370826
27069	43209	18	applied	\N	\N	\N	\N	203680	203680	370827
27069	43215	19	applied	\N	\N	\N	\N	203681	203681	370828
27069	43217	20	applied	\N	\N	\N	\N	203682	203682	370829
27069	43221	21	applied	\N	\N	\N	\N	203683	203683	370830
27069	43223	22	applied	\N	\N	\N	\N	203684	203684	370831
27069	43226	23	applied	\N	\N	\N	\N	203685	203685	370832
27069	43229	24	applied	\N	\N	\N	\N	203686	203686	370833
27069	43237	25	applied	\N	\N	\N	\N	203687	203687	370834
27069	43238	26	applied	\N	\N	\N	\N	203688	203688	370835
27069	43239	27	applied	\N	\N	\N	\N	203689	203689	370836
27069	43247	29	applied	\N	\N	\N	\N	203691	203691	370838
27069	43248	30	applied	\N	\N	\N	\N	203692	203692	370839
27069	43249	31	applied	\N	\N	\N	\N	203693	203693	370840
27069	43254	32	applied	\N	\N	\N	\N	203694	203694	370841
27069	43257	33	applied	\N	\N	\N	\N	203695	203695	370842
27069	43261	34	applied	\N	\N	\N	\N	203696	203696	370843
27069	43263	35	applied	\N	\N	\N	\N	203697	203697	370844
27069	43410	36	applied	\N	\N	1000000000	\N	203698	203698	370845
27069	43413	37	applied	\N	\N	1000000000	\N	203699	203699	370846
27069	43414	38	applied	\N	\N	1000000000	\N	203700	203700	370847
27069	43415	39	applied	\N	\N	1000000000	\N	203701	203701	370848
27069	43268	40	applied	\N	\N	\N	\N	203702	203702	370849
27069	43271	41	applied	\N	\N	\N	\N	203703	203703	370850
27069	43276	42	applied	\N	\N	\N	\N	203704	203704	370851
27069	43278	43	applied	\N	\N	\N	\N	203705	203705	370852
27069	43281	44	applied	\N	\N	\N	\N	203706	203706	370853
27069	43286	46	applied	\N	\N	\N	\N	203708	203708	370855
27069	43289	47	applied	\N	\N	\N	\N	203709	203709	370856
27069	43292	48	applied	\N	\N	\N	\N	203710	203710	370857
27069	43294	49	applied	\N	\N	\N	\N	203711	203711	370858
27069	43297	50	applied	\N	\N	\N	\N	203712	203712	370859
27069	43299	51	applied	\N	\N	\N	\N	203713	203713	370860
27069	43306	52	applied	\N	\N	\N	\N	203714	203714	370861
27069	43307	53	applied	\N	\N	\N	\N	203715	203715	370862
27069	43311	54	applied	\N	\N	\N	\N	203716	203716	370863
27069	43312	55	applied	\N	\N	\N	\N	203717	203717	370864
27014	43384	0	applied	\N	\N	\N	\N	203236	203236	370389
27014	43385	2	applied	\N	\N	\N	\N	203237	203237	370390
27025	43398	0	applied	\N	\N	\N	\N	203267	203267	370420
27025	43400	2	applied	\N	\N	\N	\N	203269	203269	370422
27027	43172	0	applied	\N	\N	\N	\N	203272	203272	370425
27027	43174	1	applied	\N	\N	\N	\N	203273	203273	370426
27027	43177	2	applied	\N	\N	\N	\N	203274	203274	370427
27027	43178	3	applied	\N	\N	\N	\N	203275	203275	370428
27027	43183	4	applied	\N	\N	\N	\N	203276	203276	370429
27027	43184	5	applied	\N	\N	\N	\N	203277	203277	370430
27027	43189	6	applied	\N	\N	\N	\N	203278	203278	370431
27027	43192	7	applied	\N	\N	\N	\N	203279	203279	370432
27027	43195	8	applied	\N	\N	\N	\N	203280	203280	370433
27027	43198	9	applied	\N	\N	\N	\N	203281	203281	370434
27027	43201	10	applied	\N	\N	\N	\N	203282	203282	370435
27027	43204	11	applied	\N	\N	\N	\N	203283	203283	370436
27027	43205	12	applied	\N	\N	\N	\N	203284	203284	370437
27027	43206	13	applied	\N	\N	\N	\N	203285	203285	370438
27027	43213	14	applied	\N	\N	\N	\N	203286	203286	370439
27027	43219	16	applied	\N	\N	\N	\N	203288	203288	370441
27027	43222	17	applied	\N	\N	\N	\N	203289	203289	370442
27027	43225	18	applied	\N	\N	\N	\N	203290	203290	370443
27027	43228	19	applied	\N	\N	\N	\N	203291	203291	370444
27027	43231	20	applied	\N	\N	\N	\N	203292	203292	370445
27027	43232	21	applied	\N	\N	\N	\N	203293	203293	370446
27027	43233	22	applied	\N	\N	\N	\N	203294	203294	370447
27027	43240	23	applied	\N	\N	\N	\N	203295	203295	370448
27027	43241	24	applied	\N	\N	\N	\N	203296	203296	370449
27027	43242	25	applied	\N	\N	\N	\N	203297	203297	370450
27027	43243	26	applied	\N	\N	\N	\N	203298	203298	370451
27027	43253	27	applied	\N	\N	\N	\N	203299	203299	370452
27027	43256	28	applied	\N	\N	\N	\N	203300	203300	370453
27027	43259	29	applied	\N	\N	\N	\N	203301	203301	370454
27027	43262	30	applied	\N	\N	\N	\N	203302	203302	370455
27027	43265	31	applied	\N	\N	\N	\N	203303	203303	370456
27027	43272	33	applied	\N	\N	\N	\N	203305	203305	370458
27027	43273	34	applied	\N	\N	\N	\N	203306	203306	370459
27027	43279	35	applied	\N	\N	\N	\N	203307	203307	370460
27027	43280	36	applied	\N	\N	\N	\N	203308	203308	370461
27027	43284	37	applied	\N	\N	\N	\N	203309	203309	370462
27027	43287	38	applied	\N	\N	\N	\N	203310	203310	370463
27027	43290	39	applied	\N	\N	\N	\N	203311	203311	370464
27027	43293	40	applied	\N	\N	\N	\N	203312	203312	370465
27027	43296	41	applied	\N	\N	\N	\N	203313	203313	370466
27027	43301	42	applied	\N	\N	\N	\N	203314	203314	370467
27027	43302	43	applied	\N	\N	\N	\N	203315	203315	370468
27027	43303	44	applied	\N	\N	\N	\N	203316	203316	370469
27027	43308	45	applied	\N	\N	\N	\N	203317	203317	370470
27027	43309	46	applied	\N	\N	\N	\N	203318	203318	370471
27027	43310	47	applied	\N	\N	\N	\N	203319	203319	370472
27027	43317	48	applied	\N	\N	\N	\N	203320	203320	370473
27027	43323	50	applied	\N	\N	\N	\N	203322	203322	370475
27027	43326	51	applied	\N	\N	\N	\N	203323	203323	370476
27027	43331	52	applied	\N	\N	\N	\N	203324	203324	370477
27027	43334	53	applied	\N	\N	\N	\N	203325	203325	370478
27027	43335	54	applied	\N	\N	\N	\N	203326	203326	370479
27027	43340	55	applied	\N	\N	\N	\N	203327	203327	370480
27027	43343	56	applied	\N	\N	\N	\N	203328	203328	370481
27027	43346	57	applied	\N	\N	\N	\N	203329	203329	370482
27027	43349	59	applied	\N	\N	\N	\N	203330	203330	370483
27027	43350	60	applied	\N	\N	\N	\N	203331	203331	370484
27027	43351	61	applied	\N	\N	\N	\N	203332	203332	370485
27027	43357	62	applied	\N	\N	\N	\N	203333	203333	370486
27027	43360	63	applied	\N	\N	\N	\N	203334	203334	370487
27027	43362	64	applied	\N	\N	\N	\N	203335	203335	370488
27027	43366	65	applied	\N	\N	\N	\N	203336	203336	370489
27027	43369	66	applied	\N	\N	\N	\N	203337	203337	370490
27027	43375	68	applied	\N	\N	\N	\N	203339	203339	370492
27027	43378	69	applied	\N	\N	\N	\N	203340	203340	370493
27027	43379	70	applied	\N	\N	\N	\N	203341	203341	370494
27027	43384	71	applied	\N	\N	\N	\N	203342	203342	370495
27027	43387	72	applied	\N	\N	\N	\N	203343	203343	370496
27027	43389	73	applied	\N	\N	\N	\N	203344	203344	370497
27027	43392	74	applied	\N	\N	\N	\N	203345	203345	370498
27027	43395	75	applied	\N	\N	\N	\N	203346	203346	370499
27027	43398	76	applied	\N	\N	\N	\N	203347	203347	370500
27027	43266	79	applied	\N	\N	\N	\N	203350	203350	370501
27027	43244	78	failed	Amount_insufficient_to_create_account	\N	\N	\N	203349	203349	\N
27027	43173	80	applied	\N	\N	\N	\N	203351	203351	370502
27027	43175	81	applied	\N	\N	\N	\N	203352	203352	370503
27027	43179	82	applied	\N	\N	\N	\N	203353	203353	370504
27027	43180	83	applied	\N	\N	\N	\N	203354	203354	370505
27027	43185	84	applied	\N	\N	\N	\N	203355	203355	370506
27027	43188	85	applied	\N	\N	\N	\N	203356	203356	370507
27027	43191	86	applied	\N	\N	\N	\N	203357	203357	370508
27027	43176	87	applied	\N	\N	\N	\N	203358	203358	370509
27027	43181	88	applied	\N	\N	\N	\N	203359	203359	370510
27027	43194	89	applied	\N	\N	\N	\N	203360	203360	370511
27027	43197	90	applied	\N	\N	\N	\N	203361	203361	370512
27027	43200	91	applied	\N	\N	\N	\N	203362	203362	370513
27027	43203	92	applied	\N	\N	\N	\N	203363	203363	370514
27027	43207	93	applied	\N	\N	\N	\N	203364	203364	370515
27027	43208	94	applied	\N	\N	\N	\N	203365	203365	370516
27027	43209	95	applied	\N	\N	\N	\N	203366	203366	370517
27027	43215	96	applied	\N	\N	\N	\N	203367	203367	370518
27027	43217	97	applied	\N	\N	\N	\N	203368	203368	370519
27027	43221	98	applied	\N	\N	\N	\N	203369	203369	370520
27027	43223	99	applied	\N	\N	\N	\N	203370	203370	370521
27027	43226	100	applied	\N	\N	\N	\N	203371	203371	370522
27027	43229	101	applied	\N	\N	\N	\N	203372	203372	370523
27027	43237	102	applied	\N	\N	\N	\N	203373	203373	370524
27027	43238	103	applied	\N	\N	\N	\N	203374	203374	370525
27027	43239	104	applied	\N	\N	\N	\N	203375	203375	370526
27027	43246	105	applied	\N	\N	\N	\N	203376	203376	370527
27027	43247	106	applied	\N	\N	\N	\N	203377	203377	370528
27032	43404	0	applied	\N	\N	\N	\N	203441	203441	370592
27032	43406	1	applied	\N	\N	\N	\N	203442	203442	370593
27041	43189	0	applied	\N	\N	\N	\N	203474	203474	370625
27041	43192	1	applied	\N	\N	\N	\N	203475	203475	370626
27041	43195	2	applied	\N	\N	\N	\N	203476	203476	370627
27041	43198	3	applied	\N	\N	\N	\N	203477	203477	370628
27023	43396	1	applied	\N	\N	\N	\N	203262	203262	370415
27023	43397	2	applied	\N	\N	\N	\N	203263	203263	370416
27027	43261	111	applied	\N	\N	\N	\N	203382	203382	370533
27027	43263	112	applied	\N	\N	\N	\N	203383	203383	370534
27027	43268	113	applied	\N	\N	\N	\N	203384	203384	370535
27027	43271	114	applied	\N	\N	\N	\N	203385	203385	370536
27027	43276	115	applied	\N	\N	\N	\N	203386	203386	370537
27041	43201	4	applied	\N	\N	\N	\N	203478	203478	370629
27041	43204	5	applied	\N	\N	\N	\N	203479	203479	370630
27041	43205	6	applied	\N	\N	\N	\N	203480	203480	370631
27041	43206	7	applied	\N	\N	\N	\N	203481	203481	370632
27041	43213	8	applied	\N	\N	\N	\N	203482	203482	370633
27041	43214	9	applied	\N	\N	\N	\N	203483	203483	370634
27041	43219	10	applied	\N	\N	\N	\N	203484	203484	370635
27041	43222	11	applied	\N	\N	\N	\N	203485	203485	370636
27041	43225	12	applied	\N	\N	\N	\N	203486	203486	370637
27041	43228	13	applied	\N	\N	\N	\N	203487	203487	370638
27041	43231	14	applied	\N	\N	\N	\N	203488	203488	370639
27041	43233	16	applied	\N	\N	\N	\N	203490	203490	370641
27041	43240	17	applied	\N	\N	\N	\N	203491	203491	370642
27041	43241	18	applied	\N	\N	\N	\N	203492	203492	370643
27041	43242	19	applied	\N	\N	\N	\N	203493	203493	370644
27041	43243	20	applied	\N	\N	\N	\N	203494	203494	370645
27041	43253	21	applied	\N	\N	\N	\N	203495	203495	370646
27041	43256	22	applied	\N	\N	\N	\N	203496	203496	370647
27041	43259	23	applied	\N	\N	\N	\N	203497	203497	370648
27041	43262	24	applied	\N	\N	\N	\N	203498	203498	370649
27041	43265	25	applied	\N	\N	\N	\N	203499	203499	370650
27041	43269	26	applied	\N	\N	\N	\N	203500	203500	370651
27041	43272	27	applied	\N	\N	\N	\N	203501	203501	370652
27041	43273	28	applied	\N	\N	\N	\N	203502	203502	370653
27041	43279	29	applied	\N	\N	\N	\N	203503	203503	370654
27041	43280	30	applied	\N	\N	\N	\N	203504	203504	370655
27041	43284	31	applied	\N	\N	\N	\N	203505	203505	370656
27041	43290	33	applied	\N	\N	\N	\N	203507	203507	370658
27041	43293	34	applied	\N	\N	\N	\N	203508	203508	370659
27041	43296	35	applied	\N	\N	\N	\N	203509	203509	370660
27041	43301	36	applied	\N	\N	\N	\N	203510	203510	370661
27041	43302	37	applied	\N	\N	\N	\N	203511	203511	370662
27041	43303	39	applied	\N	\N	\N	\N	203512	203512	370663
27041	43308	40	applied	\N	\N	\N	\N	203513	203513	370664
27042	43411	0	applied	\N	\N	\N	\N	203514	203514	370665
27042	43412	1	applied	\N	\N	\N	\N	203515	203515	370666
27042	43413	2	applied	\N	\N	1000000000	\N	203516	203516	370667
27042	43414	3	applied	\N	\N	1000000000	\N	203517	203517	370668
27042	43415	4	applied	\N	\N	1000000000	\N	203518	203518	370669
27044	42780	0	applied	\N	\N	\N	\N	203524	203524	370675
27044	42906	1	applied	\N	\N	\N	\N	203525	203525	370676
27044	42781	3	applied	\N	\N	\N	\N	203527	203527	370677
27044	42782	4	applied	\N	\N	\N	\N	203528	203528	370678
27044	43266	6	applied	\N	\N	\N	\N	203530	203530	370679
27044	43244	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	203529	203529	\N
27044	42783	7	applied	\N	\N	\N	\N	203531	203531	370680
27044	42857	8	applied	\N	\N	1000000000	\N	203532	203532	370681
27044	42858	9	applied	\N	\N	1000000000	\N	203533	203533	370682
27044	43410	10	applied	\N	\N	1000000000	\N	203534	203534	370683
27044	43413	11	applied	\N	\N	1000000000	\N	203535	203535	370684
27044	43414	12	applied	\N	\N	1000000000	\N	203536	203536	370685
27044	43415	13	applied	\N	\N	1000000000	\N	203537	203537	370686
27046	43419	0	applied	\N	\N	\N	\N	203541	203541	370690
27046	43420	1	applied	\N	\N	\N	\N	203542	203542	370691
27046	43421	2	applied	\N	\N	\N	\N	203543	203543	370692
27046	43422	3	applied	\N	\N	\N	\N	203544	203544	370693
27046	43423	4	applied	\N	\N	\N	\N	203545	203545	370694
27046	43424	5	applied	\N	\N	\N	\N	203546	203546	370695
27049	43425	0	applied	\N	\N	\N	\N	203559	203559	370708
27049	43426	1	applied	\N	\N	\N	\N	203560	203560	370709
27049	43427	2	applied	\N	\N	\N	\N	203561	203561	370710
27049	43428	3	applied	\N	\N	\N	\N	203562	203562	370711
27049	43429	4	applied	\N	\N	\N	\N	203563	203563	370712
27049	43430	5	applied	\N	\N	\N	\N	203564	203564	370713
27051	43431	0	applied	\N	\N	\N	\N	203568	203568	370717
27051	43432	1	applied	\N	\N	\N	\N	203569	203569	370718
27051	43433	2	applied	\N	\N	\N	\N	203570	203570	370719
27053	43201	1	applied	\N	\N	\N	\N	203573	203573	370722
27053	43204	2	applied	\N	\N	\N	\N	203574	203574	370723
27053	43205	3	applied	\N	\N	\N	\N	203575	203575	370724
27053	43206	4	applied	\N	\N	\N	\N	203576	203576	370725
27053	43213	5	applied	\N	\N	\N	\N	203577	203577	370726
27053	43214	6	applied	\N	\N	\N	\N	203578	203578	370727
27053	43219	7	applied	\N	\N	\N	\N	203579	203579	370728
27053	43222	8	applied	\N	\N	\N	\N	203580	203580	370729
27053	43225	9	applied	\N	\N	\N	\N	203581	203581	370730
27053	43228	10	applied	\N	\N	\N	\N	203582	203582	370731
27053	43231	11	applied	\N	\N	\N	\N	203583	203583	370732
27053	43232	12	applied	\N	\N	\N	\N	203584	203584	370733
27053	43233	13	applied	\N	\N	\N	\N	203585	203585	370734
27053	43240	14	applied	\N	\N	\N	\N	203586	203586	370735
27053	43241	15	applied	\N	\N	\N	\N	203587	203587	370736
27053	43242	16	applied	\N	\N	\N	\N	203588	203588	370737
27058	43447	1	applied	\N	\N	\N	\N	203618	203618	370767
27058	43448	2	applied	\N	\N	\N	\N	203619	203619	370768
27061	43452	0	applied	\N	\N	\N	\N	203626	203626	370775
27061	43453	1	applied	\N	\N	\N	\N	203627	203627	370776
27061	43454	2	applied	\N	\N	\N	\N	203628	203628	370777
27061	43455	3	applied	\N	\N	\N	\N	203629	203629	370778
27061	43456	4	applied	\N	\N	\N	\N	203630	203630	370779
27061	43457	5	applied	\N	\N	\N	\N	203631	203631	370780
27063	43466	0	applied	\N	\N	\N	\N	203640	203640	370788
27063	43467	1	applied	\N	\N	\N	\N	203641	203641	370789
27063	43468	2	applied	\N	\N	\N	\N	203642	203642	370790
27068	43469	0	applied	\N	\N	\N	\N	203656	203656	370804
27068	43470	2	applied	\N	\N	\N	\N	203657	203657	370805
27068	43471	3	applied	\N	\N	\N	\N	203658	203658	370806
27068	43472	4	applied	\N	\N	\N	\N	203659	203659	370807
27068	43473	5	applied	\N	\N	\N	\N	203660	203660	370808
27071	43475	0	applied	\N	\N	\N	\N	203793	203793	370940
27071	43476	1	applied	\N	\N	\N	\N	203794	203794	370941
27071	43477	2	applied	\N	\N	\N	\N	203795	203795	370942
27071	43478	3	applied	\N	\N	\N	\N	203796	203796	370943
27027	43249	108	applied	\N	\N	\N	\N	203379	203379	370530
27027	43254	109	applied	\N	\N	\N	\N	203380	203380	370531
27027	43286	119	applied	\N	\N	\N	\N	203390	203390	370541
27027	43289	120	applied	\N	\N	\N	\N	203391	203391	370542
27027	43292	121	applied	\N	\N	\N	\N	203392	203392	370543
27027	43294	122	applied	\N	\N	\N	\N	203393	203393	370544
27027	43297	123	applied	\N	\N	\N	\N	203394	203394	370545
27027	43299	124	applied	\N	\N	\N	\N	203395	203395	370546
27027	43306	125	applied	\N	\N	\N	\N	203396	203396	370547
27029	43398	0	applied	\N	\N	\N	\N	203401	203401	370552
27029	43401	1	applied	\N	\N	\N	\N	203402	203402	370553
27029	43402	2	applied	\N	\N	\N	\N	203403	203403	370554
27029	43403	3	applied	\N	\N	\N	\N	203404	203404	370555
27031	43404	0	applied	\N	\N	\N	\N	203438	203438	370589
27031	43406	1	applied	\N	\N	\N	\N	203439	203439	370590
27035	43407	0	applied	\N	\N	\N	\N	203449	203449	370600
27035	43408	1	applied	\N	\N	\N	\N	203450	203450	370601
27035	43409	2	applied	\N	\N	\N	\N	203451	203451	370602
27035	43410	3	applied	\N	\N	1000000000	\N	203452	203452	370603
27037	43407	0	applied	\N	\N	\N	\N	203457	203457	370608
27037	43409	1	applied	\N	\N	\N	\N	203458	203458	370609
27037	43410	2	applied	\N	\N	1000000000	\N	203459	203459	370610
27045	43416	0	applied	\N	\N	\N	\N	203538	203538	370687
27045	43417	1	applied	\N	\N	\N	\N	203539	203539	370688
27045	43418	2	applied	\N	\N	\N	\N	203540	203540	370689
27048	43425	0	applied	\N	\N	\N	\N	203553	203553	370702
27048	43426	1	applied	\N	\N	\N	\N	203554	203554	370703
27048	43427	2	applied	\N	\N	\N	\N	203555	203555	370704
27048	43428	3	applied	\N	\N	\N	\N	203556	203556	370705
27048	43429	4	applied	\N	\N	\N	\N	203557	203557	370706
27048	43430	5	applied	\N	\N	\N	\N	203558	203558	370707
27050	43432	1	applied	\N	\N	\N	\N	203566	203566	370715
27050	43433	2	applied	\N	\N	\N	\N	203567	203567	370716
27060	43449	0	applied	\N	\N	\N	\N	203623	203623	370772
27060	43450	1	applied	\N	\N	\N	\N	203624	203624	370773
27060	43451	2	applied	\N	\N	\N	\N	203625	203625	370774
27065	43469	0	applied	\N	\N	\N	\N	203643	203643	370791
27066	43469	0	applied	\N	\N	\N	\N	203644	203644	370792
27066	43470	2	applied	\N	\N	\N	\N	203645	203645	370793
27066	43471	3	applied	\N	\N	\N	\N	203646	203646	370794
27066	43472	4	applied	\N	\N	\N	\N	203647	203647	370795
27066	43473	5	applied	\N	\N	\N	\N	203648	203648	370796
27066	43474	6	applied	\N	\N	\N	\N	203649	203649	370797
27069	43313	56	applied	\N	\N	\N	\N	203718	203718	370865
27069	43319	57	applied	\N	\N	\N	\N	203719	203719	370866
27069	43320	58	applied	\N	\N	\N	\N	203720	203720	370867
27069	43325	59	applied	\N	\N	\N	\N	203721	203721	370868
27069	43329	61	applied	\N	\N	\N	\N	203723	203723	370870
27069	43332	62	applied	\N	\N	\N	\N	203724	203724	370871
27069	43338	63	applied	\N	\N	\N	\N	203725	203725	370872
27069	43339	64	applied	\N	\N	\N	\N	203726	203726	370873
27070	43475	0	applied	\N	\N	\N	\N	203787	203787	370934
27070	43476	1	applied	\N	\N	\N	\N	203788	203788	370935
27070	43477	2	applied	\N	\N	\N	\N	203789	203789	370936
27070	43478	3	applied	\N	\N	\N	\N	203790	203790	370937
27070	43479	4	applied	\N	\N	\N	\N	203791	203791	370938
27070	43480	5	applied	\N	\N	\N	\N	203792	203792	370939
27072	43481	0	applied	\N	\N	\N	\N	203799	203799	370946
27072	43482	1	applied	\N	\N	\N	\N	203800	203800	370947
27075	43484	0	applied	\N	\N	\N	\N	203807	203807	370954
27075	43485	1	applied	\N	\N	\N	\N	203808	203808	370955
27075	43486	2	applied	\N	\N	\N	\N	203809	203809	370956
27077	43492	0	applied	\N	\N	\N	\N	203815	203815	370962
27077	43494	2	applied	\N	\N	\N	\N	203817	203817	370964
27086	43514	0	applied	\N	\N	\N	\N	203896	203896	371043
27086	43515	1	applied	\N	\N	\N	\N	203897	203897	371044
27086	43516	2	applied	\N	\N	\N	\N	203898	203898	371045
27086	43517	3	applied	\N	\N	\N	\N	203899	203899	371046
27086	43518	4	applied	\N	\N	\N	\N	203900	203900	371047
27086	43519	5	applied	\N	\N	\N	\N	203901	203901	371048
27089	43520	0	applied	\N	\N	\N	\N	203914	203914	371061
27089	43521	1	applied	\N	\N	\N	\N	203915	203915	371062
27089	43522	2	applied	\N	\N	\N	\N	203916	203916	371063
27095	43535	0	applied	\N	\N	\N	\N	203935	203935	371082
27095	43536	1	applied	\N	\N	\N	\N	203936	203936	371083
27095	43537	2	applied	\N	\N	\N	\N	203937	203937	371084
27102	43544	0	applied	\N	\N	\N	\N	203953	203953	371100
27102	43545	1	applied	\N	\N	\N	\N	203954	203954	371101
27102	43546	2	applied	\N	\N	\N	\N	203955	203955	371102
27102	43548	4	applied	\N	\N	\N	\N	203957	203957	371104
27102	43549	5	applied	\N	\N	\N	\N	203958	203958	371105
27107	43556	0	applied	\N	\N	\N	\N	203971	203971	371118
27107	43557	1	applied	\N	\N	\N	\N	203972	203972	371119
27107	43558	2	applied	\N	\N	\N	\N	203973	203973	371120
27111	43565	0	applied	\N	\N	\N	\N	204105	204105	371251
27111	43566	1	applied	\N	\N	\N	\N	204106	204106	371252
27113	43567	0	applied	\N	\N	\N	\N	204109	204109	371255
27113	43568	1	applied	\N	\N	\N	\N	204110	204110	371256
27113	43569	2	applied	\N	\N	\N	\N	204111	204111	371257
27118	43576	0	applied	\N	\N	\N	\N	204124	204124	371270
27118	43577	1	applied	\N	\N	\N	\N	204125	204125	371271
27118	43578	2	applied	\N	\N	\N	\N	204126	204126	371272
27126	43599	0	applied	\N	\N	\N	\N	204155	204155	371301
27126	43600	1	applied	\N	\N	\N	\N	204156	204156	371302
27126	43601	2	applied	\N	\N	\N	\N	204157	204157	371303
27129	43606	1	applied	\N	\N	\N	\N	204165	204165	371311
27129	43607	2	applied	\N	\N	\N	\N	204166	204166	371312
27136	43620	0	applied	\N	\N	\N	\N	204196	204196	371342
27136	43621	1	applied	\N	\N	\N	\N	204197	204197	371343
27136	43622	2	applied	\N	\N	\N	\N	204198	204198	371344
27148	43637	0	applied	\N	\N	\N	\N	204239	204239	371385
27148	43638	1	applied	\N	\N	\N	\N	204240	204240	371386
27148	43639	2	applied	\N	\N	\N	\N	204241	204241	371387
27157	43655	0	applied	\N	\N	\N	\N	204406	204406	371552
27157	43656	1	applied	\N	\N	\N	\N	204407	204407	371553
27157	43657	2	applied	\N	\N	\N	\N	204408	204408	371554
27157	43658	3	applied	\N	\N	\N	\N	204409	204409	371555
27157	43659	4	applied	\N	\N	\N	\N	204410	204410	371556
27157	43660	5	applied	\N	\N	\N	\N	204411	204411	371557
27160	43664	0	applied	\N	\N	\N	\N	204421	204421	371567
27160	43665	1	applied	\N	\N	\N	\N	204422	204422	371568
27027	43281	117	applied	\N	\N	\N	\N	203388	203388	370539
27027	43283	118	applied	\N	\N	\N	\N	203389	203389	370540
27069	43355	69	applied	\N	\N	\N	\N	203731	203731	370878
27069	43356	70	applied	\N	\N	\N	\N	203732	203732	370879
27069	43359	71	applied	\N	\N	\N	\N	203733	203733	370880
27069	43363	72	applied	\N	\N	\N	\N	203734	203734	370881
27069	43364	73	applied	\N	\N	\N	\N	203735	203735	370882
27069	43368	74	applied	\N	\N	\N	\N	203736	203736	370883
27069	43371	75	applied	\N	\N	\N	\N	203737	203737	370884
27069	43372	76	applied	\N	\N	\N	\N	203738	203738	370885
27069	43377	77	applied	\N	\N	\N	\N	203739	203739	370886
27069	43380	78	applied	\N	\N	\N	\N	203740	203740	370887
27069	43381	79	applied	\N	\N	\N	\N	203741	203741	370888
27069	43385	80	applied	\N	\N	\N	\N	203742	203742	370889
27069	43390	81	applied	\N	\N	\N	\N	203743	203743	370890
27069	43394	82	applied	\N	\N	\N	\N	203744	203744	370891
27069	43397	83	applied	\N	\N	\N	\N	203745	203745	370892
27069	43400	84	applied	\N	\N	\N	\N	203746	203746	370893
27069	43405	86	applied	\N	\N	\N	\N	203748	203748	370895
27069	43409	87	applied	\N	\N	\N	\N	203749	203749	370896
27069	43412	88	applied	\N	\N	\N	\N	203750	203750	370897
27069	43417	89	applied	\N	\N	\N	\N	203751	203751	370898
27069	43421	90	applied	\N	\N	\N	\N	203752	203752	370899
27069	43424	91	applied	\N	\N	\N	\N	203753	203753	370900
27069	43429	92	applied	\N	\N	\N	\N	203754	203754	370901
27069	42901	93	applied	\N	\N	\N	\N	203755	203755	370902
27069	42903	94	applied	\N	\N	\N	\N	203756	203756	370903
27069	42909	95	applied	\N	\N	\N	\N	203757	203757	370904
27069	42916	96	applied	\N	\N	\N	\N	203758	203758	370905
27069	42917	97	applied	\N	\N	\N	\N	203759	203759	370906
27069	42918	98	applied	\N	\N	\N	\N	203760	203760	370907
27069	42921	99	applied	\N	\N	\N	\N	203761	203761	370908
27069	42925	100	applied	\N	\N	\N	\N	203762	203762	370909
27069	42931	102	applied	\N	\N	\N	\N	203763	203763	370910
27069	42938	104	applied	\N	\N	\N	\N	203765	203765	370912
27069	42939	105	applied	\N	\N	\N	\N	203766	203766	370913
27069	42940	106	applied	\N	\N	\N	\N	203767	203767	370914
27069	42941	107	applied	\N	\N	\N	\N	203768	203768	370915
27069	42947	108	applied	\N	\N	\N	\N	203769	203769	370916
27069	42951	109	applied	\N	\N	\N	\N	203770	203770	370917
27069	42955	110	applied	\N	\N	\N	\N	203771	203771	370918
27069	42959	111	applied	\N	\N	\N	\N	203772	203772	370919
27069	42962	112	applied	\N	\N	\N	\N	203773	203773	370920
27069	42968	113	applied	\N	\N	\N	\N	203774	203774	370921
27069	42972	114	applied	\N	\N	\N	\N	203775	203775	370922
27069	42974	115	applied	\N	\N	\N	\N	203776	203776	370923
27069	42980	116	applied	\N	\N	\N	\N	203777	203777	370924
27069	42981	117	applied	\N	\N	\N	\N	203778	203778	370925
27069	42982	118	applied	\N	\N	\N	\N	203779	203779	370926
27069	42988	119	applied	\N	\N	\N	\N	203780	203780	370927
27069	42993	121	applied	\N	\N	\N	\N	203782	203782	370929
27069	42998	122	applied	\N	\N	\N	\N	203783	203783	370930
27069	43000	123	applied	\N	\N	\N	\N	203784	203784	370931
27069	43004	124	applied	\N	\N	\N	\N	203785	203785	370932
27069	43011	125	applied	\N	\N	\N	\N	203786	203786	370933
27071	43479	4	applied	\N	\N	\N	\N	203797	203797	370944
27071	43480	5	applied	\N	\N	\N	\N	203798	203798	370945
27073	43481	0	applied	\N	\N	\N	\N	203801	203801	370948
27073	43482	1	applied	\N	\N	\N	\N	203802	203802	370949
27073	43483	2	applied	\N	\N	\N	\N	203803	203803	370950
27074	43484	0	applied	\N	\N	\N	\N	203804	203804	370951
27074	43485	1	applied	\N	\N	\N	\N	203805	203805	370952
27074	43486	2	applied	\N	\N	\N	\N	203806	203806	370953
27076	43487	0	applied	\N	\N	\N	\N	203810	203810	370957
27076	43488	1	applied	\N	\N	\N	\N	203811	203811	370958
27076	43489	2	applied	\N	\N	\N	\N	203812	203812	370959
27076	43491	4	applied	\N	\N	\N	\N	203814	203814	370961
27078	43492	0	applied	\N	\N	\N	\N	203818	203818	370965
27078	43493	1	applied	\N	\N	\N	\N	203819	203819	370966
27078	43494	2	applied	\N	\N	\N	\N	203820	203820	370967
27079	43495	0	applied	\N	\N	\N	\N	203821	203821	370968
27079	43496	1	applied	\N	\N	\N	\N	203822	203822	370969
27079	43497	2	applied	\N	\N	\N	\N	203823	203823	370970
27080	43293	0	applied	\N	\N	\N	\N	203824	203824	370971
27081	43498	0	applied	\N	\N	\N	\N	203868	203868	371015
27081	43499	1	applied	\N	\N	\N	\N	203869	203869	371016
27081	43500	2	applied	\N	\N	\N	\N	203870	203870	371017
27085	43514	0	applied	\N	\N	\N	\N	203890	203890	371037
27085	43515	1	applied	\N	\N	\N	\N	203891	203891	371038
27085	43516	2	applied	\N	\N	\N	\N	203892	203892	371039
27085	43517	3	applied	\N	\N	\N	\N	203893	203893	371040
27085	43518	4	applied	\N	\N	\N	\N	203894	203894	371041
27091	43523	0	applied	\N	\N	\N	\N	203920	203920	371067
27091	43524	1	applied	\N	\N	\N	\N	203921	203921	371068
27091	43525	2	applied	\N	\N	\N	\N	203922	203922	371069
27094	43535	0	applied	\N	\N	\N	\N	203932	203932	371079
27094	43536	1	applied	\N	\N	\N	\N	203933	203933	371080
27094	43537	2	applied	\N	\N	\N	\N	203934	203934	371081
27101	43544	0	applied	\N	\N	\N	\N	203947	203947	371094
27101	43545	1	applied	\N	\N	\N	\N	203948	203948	371095
27101	43546	2	applied	\N	\N	\N	\N	203949	203949	371096
27101	43547	3	applied	\N	\N	\N	\N	203950	203950	371097
27101	43548	4	applied	\N	\N	\N	\N	203951	203951	371098
27101	43549	5	applied	\N	\N	\N	\N	203952	203952	371099
27104	43556	0	applied	\N	\N	\N	\N	203965	203965	371112
27104	43557	1	applied	\N	\N	\N	\N	203966	203966	371113
27104	43558	2	applied	\N	\N	\N	\N	203967	203967	371114
27106	43556	0	applied	\N	\N	\N	\N	203968	203968	371115
27106	43558	2	applied	\N	\N	\N	\N	203970	203970	371117
27108	43559	0	applied	\N	\N	\N	\N	203974	203974	371121
27108	43560	1	applied	\N	\N	\N	\N	203975	203975	371122
27108	43561	2	applied	\N	\N	\N	\N	203976	203976	371123
27115	43567	0	applied	\N	\N	\N	\N	204114	204114	371260
27115	43570	1	applied	\N	\N	\N	\N	204115	204115	371261
27115	43571	2	applied	\N	\N	\N	\N	204116	204116	371262
27115	43572	3	applied	\N	\N	\N	\N	204117	204117	371263
27123	43588	0	applied	\N	\N	\N	\N	204144	204144	371290
27123	43589	1	applied	\N	\N	\N	\N	204145	204145	371291
27123	43590	2	applied	\N	\N	\N	\N	204146	204146	371292
27123	43591	3	applied	\N	\N	\N	\N	204147	204147	371293
27123	43592	4	applied	\N	\N	\N	\N	204148	204148	371294
27128	43605	0	applied	\N	\N	\N	\N	204161	204161	371307
27069	43345	66	applied	\N	\N	\N	\N	203728	203728	370875
27069	43347	67	applied	\N	\N	\N	\N	203729	203729	370876
27080	43308	5	applied	\N	\N	\N	\N	203829	203829	370976
27080	43309	6	applied	\N	\N	\N	\N	203830	203830	370977
27080	43310	7	applied	\N	\N	\N	\N	203831	203831	370978
27080	43317	9	applied	\N	\N	\N	\N	203832	203832	370979
27080	43318	10	applied	\N	\N	\N	\N	203833	203833	370980
27080	43323	11	applied	\N	\N	\N	\N	203834	203834	370981
27080	43326	12	applied	\N	\N	\N	\N	203835	203835	370982
27080	43331	13	applied	\N	\N	\N	\N	203836	203836	370983
27080	43334	14	applied	\N	\N	\N	\N	203837	203837	370984
27080	43335	15	applied	\N	\N	\N	\N	203838	203838	370985
27080	43340	16	applied	\N	\N	\N	\N	203839	203839	370986
27080	43343	17	applied	\N	\N	\N	\N	203840	203840	370987
27080	43346	18	applied	\N	\N	\N	\N	203841	203841	370988
27080	43349	19	applied	\N	\N	\N	\N	203842	203842	370989
27080	43350	20	applied	\N	\N	\N	\N	203843	203843	370990
27080	43351	21	applied	\N	\N	\N	\N	203844	203844	370991
27080	43360	23	applied	\N	\N	\N	\N	203846	203846	370993
27080	43362	24	applied	\N	\N	\N	\N	203847	203847	370994
27080	43366	25	applied	\N	\N	\N	\N	203848	203848	370995
27080	43369	26	applied	\N	\N	\N	\N	203849	203849	370996
27080	43370	27	applied	\N	\N	\N	\N	203850	203850	370997
27080	43375	28	applied	\N	\N	\N	\N	203851	203851	370998
27080	43378	29	applied	\N	\N	\N	\N	203852	203852	370999
27080	43379	30	applied	\N	\N	\N	\N	203853	203853	371000
27080	43384	31	applied	\N	\N	\N	\N	203854	203854	371001
27080	43387	32	applied	\N	\N	\N	\N	203855	203855	371002
27080	43389	33	applied	\N	\N	\N	\N	203856	203856	371003
27080	43392	34	applied	\N	\N	\N	\N	203857	203857	371004
27080	43395	35	applied	\N	\N	\N	\N	203858	203858	371005
27080	43398	36	applied	\N	\N	\N	\N	203859	203859	371006
27080	43401	37	applied	\N	\N	\N	\N	203860	203860	371007
27080	43404	38	applied	\N	\N	\N	\N	203861	203861	371008
27080	43411	40	applied	\N	\N	\N	\N	203863	203863	371010
27080	43416	41	applied	\N	\N	\N	\N	203864	203864	371011
27080	43419	42	applied	\N	\N	\N	\N	203865	203865	371012
27080	43420	43	applied	\N	\N	\N	\N	203866	203866	371013
27080	43425	44	applied	\N	\N	\N	\N	203867	203867	371014
27082	43501	0	applied	\N	\N	\N	\N	203871	203871	371018
27082	43502	1	applied	\N	\N	\N	\N	203872	203872	371019
27082	43503	2	applied	\N	\N	\N	\N	203873	203873	371020
27083	43504	0	applied	\N	\N	\N	\N	203874	203874	371021
27083	43505	1	applied	\N	\N	\N	\N	203875	203875	371022
27083	43506	2	applied	\N	\N	\N	\N	203876	203876	371023
27083	43507	3	applied	\N	\N	\N	\N	203877	203877	371024
27083	43508	4	applied	\N	\N	\N	\N	203878	203878	371025
27083	43509	5	applied	\N	\N	\N	\N	203879	203879	371026
27083	43510	6	applied	\N	\N	\N	\N	203880	203880	371027
27083	43511	7	applied	\N	\N	\N	\N	203881	203881	371028
27083	43513	9	applied	\N	\N	\N	\N	203883	203883	371030
27084	43515	1	applied	\N	\N	\N	\N	203885	203885	371032
27084	43516	2	applied	\N	\N	\N	\N	203886	203886	371033
27084	43517	3	applied	\N	\N	\N	\N	203887	203887	371034
27084	43518	4	applied	\N	\N	\N	\N	203888	203888	371035
27084	43519	5	applied	\N	\N	\N	\N	203889	203889	371036
27087	43514	0	applied	\N	\N	\N	\N	203902	203902	371049
27087	43515	1	applied	\N	\N	\N	\N	203903	203903	371050
27087	43516	2	applied	\N	\N	\N	\N	203904	203904	371051
27087	43517	3	applied	\N	\N	\N	\N	203905	203905	371052
27087	43518	4	applied	\N	\N	\N	\N	203906	203906	371053
27087	43519	5	applied	\N	\N	\N	\N	203907	203907	371054
27088	43514	0	applied	\N	\N	\N	\N	203908	203908	371055
27088	43515	1	applied	\N	\N	\N	\N	203909	203909	371056
27088	43516	2	applied	\N	\N	\N	\N	203910	203910	371057
27088	43517	3	applied	\N	\N	\N	\N	203911	203911	371058
27090	43521	1	applied	\N	\N	\N	\N	203918	203918	371065
27090	43522	2	applied	\N	\N	\N	\N	203919	203919	371066
27092	43526	0	applied	\N	\N	\N	\N	203923	203923	371070
27092	43527	1	applied	\N	\N	\N	\N	203924	203924	371071
27092	43528	2	applied	\N	\N	\N	\N	203925	203925	371072
27093	43529	0	applied	\N	\N	\N	\N	203926	203926	371073
27093	43530	1	applied	\N	\N	\N	\N	203927	203927	371074
27093	43531	2	applied	\N	\N	\N	\N	203928	203928	371075
27093	43532	3	applied	\N	\N	\N	\N	203929	203929	371076
27093	43533	4	applied	\N	\N	\N	\N	203930	203930	371077
27093	43534	5	applied	\N	\N	\N	\N	203931	203931	371078
27096	43535	0	applied	\N	\N	\N	\N	203938	203938	371085
27096	43536	1	applied	\N	\N	\N	\N	203939	203939	371086
27096	43537	2	applied	\N	\N	\N	\N	203940	203940	371087
27109	43562	0	applied	\N	\N	\N	\N	203977	203977	371124
27109	43563	1	applied	\N	\N	\N	\N	203978	203978	371125
27114	43568	0	applied	\N	\N	\N	\N	204112	204112	371258
27114	43569	1	applied	\N	\N	\N	\N	204113	204113	371259
27116	43567	0	applied	\N	\N	\N	\N	204118	204118	371264
27116	43571	1	applied	\N	\N	\N	\N	204119	204119	371265
27116	43572	2	applied	\N	\N	\N	\N	204120	204120	371266
27121	43582	0	applied	\N	\N	\N	\N	204133	204133	371279
27121	43583	1	applied	\N	\N	\N	\N	204134	204134	371280
27121	43584	2	applied	\N	\N	\N	\N	204135	204135	371281
27121	43585	3	applied	\N	\N	\N	\N	204136	204136	371282
27121	43586	4	applied	\N	\N	\N	\N	204137	204137	371283
27121	43587	5	applied	\N	\N	\N	\N	204138	204138	371284
27124	43593	0	applied	\N	\N	\N	\N	204149	204149	371295
27124	43594	1	applied	\N	\N	\N	\N	204150	204150	371296
27124	43595	2	applied	\N	\N	\N	\N	204151	204151	371297
27132	43617	0	applied	\N	\N	\N	\N	204185	204185	371331
27132	43618	1	applied	\N	\N	\N	\N	204186	204186	371332
27137	43620	0	applied	\N	\N	\N	\N	204199	204199	371345
27137	43621	1	applied	\N	\N	\N	\N	204200	204200	371346
27137	43622	2	applied	\N	\N	\N	\N	204201	204201	371347
27141	43626	0	applied	\N	\N	\N	\N	204208	204208	371354
27141	43627	1	applied	\N	\N	\N	\N	204209	204209	371355
27141	43628	2	applied	\N	\N	\N	\N	204210	204210	371356
27143	43626	0	applied	\N	\N	\N	\N	204214	204214	371360
27143	43627	1	applied	\N	\N	\N	\N	204215	204215	371361
27143	43628	2	applied	\N	\N	\N	\N	204216	204216	371362
27151	43644	0	applied	\N	\N	\N	\N	204371	204371	371517
27151	43645	1	applied	\N	\N	\N	\N	204372	204372	371518
27154	43646	0	applied	\N	\N	\N	\N	204397	204397	371543
27154	43647	1	applied	\N	\N	\N	\N	204398	204398	371544
27154	43648	2	applied	\N	\N	\N	\N	204399	204399	371545
27080	43301	2	applied	\N	\N	\N	\N	203826	203826	370973
27080	43302	3	applied	\N	\N	\N	\N	203827	203827	370974
27100	43539	1	applied	\N	\N	\N	\N	203942	203942	371089
27100	43540	2	applied	\N	\N	\N	\N	203943	203943	371090
27100	43541	3	applied	\N	\N	\N	\N	203944	203944	371091
27100	43542	4	applied	\N	\N	\N	\N	203945	203945	371092
27100	43543	5	applied	\N	\N	\N	\N	203946	203946	371093
27103	43550	0	applied	\N	\N	\N	\N	203959	203959	371106
27103	43551	1	applied	\N	\N	\N	\N	203960	203960	371107
27103	43552	2	applied	\N	\N	\N	\N	203961	203961	371108
27103	43553	3	applied	\N	\N	\N	\N	203962	203962	371109
27103	43555	5	applied	\N	\N	\N	\N	203964	203964	371111
27110	43401	0	applied	\N	\N	\N	\N	203980	203980	371127
27110	43404	1	applied	\N	\N	\N	\N	203981	203981	371128
27110	43407	2	applied	\N	\N	\N	\N	203982	203982	371129
27110	43411	3	applied	\N	\N	\N	\N	203983	203983	371130
27110	43416	4	applied	\N	\N	\N	\N	203984	203984	371131
27110	43419	5	applied	\N	\N	\N	\N	203985	203985	371132
27110	43420	6	applied	\N	\N	\N	\N	203986	203986	371133
27110	43425	7	applied	\N	\N	\N	\N	203987	203987	371134
27110	43426	8	applied	\N	\N	\N	\N	203988	203988	371135
27110	43431	9	applied	\N	\N	\N	\N	203989	203989	371136
27110	43434	10	applied	\N	\N	\N	\N	203990	203990	371137
27110	43435	11	applied	\N	\N	\N	\N	203991	203991	371138
27110	43440	12	applied	\N	\N	\N	\N	203992	203992	371139
27110	43441	13	applied	\N	\N	\N	\N	203993	203993	371140
27110	43446	14	applied	\N	\N	\N	\N	203994	203994	371141
27110	43452	16	applied	\N	\N	\N	\N	203996	203996	371143
27110	43453	17	applied	\N	\N	\N	\N	203997	203997	371144
27110	43458	18	applied	\N	\N	\N	\N	203998	203998	371145
27110	43466	19	applied	\N	\N	\N	\N	203999	203999	371146
27110	43469	20	applied	\N	\N	\N	\N	204000	204000	371147
27110	43470	21	applied	\N	\N	\N	\N	204001	204001	371148
27110	43475	22	applied	\N	\N	\N	\N	204002	204002	371149
27110	43476	23	applied	\N	\N	\N	\N	204003	204003	371150
27110	43481	24	applied	\N	\N	\N	\N	204004	204004	371151
27110	43484	25	applied	\N	\N	\N	\N	204005	204005	371152
27110	43487	26	applied	\N	\N	\N	\N	204006	204006	371153
27110	43488	27	applied	\N	\N	\N	\N	204007	204007	371154
27110	43492	28	applied	\N	\N	\N	\N	204008	204008	371155
27110	43495	29	applied	\N	\N	\N	\N	204009	204009	371156
27110	43498	30	applied	\N	\N	\N	\N	204010	204010	371157
27110	43501	31	applied	\N	\N	\N	\N	204011	204011	371158
27110	43505	33	applied	\N	\N	\N	\N	204013	204013	371160
27110	43506	34	applied	\N	\N	\N	\N	204014	204014	371161
27110	43514	35	applied	\N	\N	\N	\N	204015	204015	371162
27110	43515	36	applied	\N	\N	\N	\N	204016	204016	371163
27110	43520	37	applied	\N	\N	\N	\N	204017	204017	371164
27110	43523	38	applied	\N	\N	\N	\N	204018	204018	371165
27110	43526	39	applied	\N	\N	\N	\N	204019	204019	371166
27110	43529	40	applied	\N	\N	\N	\N	204020	204020	371167
27110	43530	41	applied	\N	\N	\N	\N	204021	204021	371168
27110	43535	42	applied	\N	\N	\N	\N	204022	204022	371169
27110	43538	43	applied	\N	\N	\N	\N	204023	204023	371170
27110	43539	44	applied	\N	\N	\N	\N	204024	204024	371171
27110	43544	45	applied	\N	\N	\N	\N	204025	204025	371172
27110	43545	46	applied	\N	\N	\N	\N	204026	204026	371173
27110	43550	47	applied	\N	\N	\N	\N	204027	204027	371174
27110	43551	48	applied	\N	\N	\N	\N	204028	204028	371175
27110	43559	50	applied	\N	\N	\N	\N	204030	204030	371177
27110	43307	51	applied	\N	\N	\N	\N	204031	204031	371178
27110	43311	52	applied	\N	\N	\N	\N	204032	204032	371179
27110	43510	53	applied	\N	\N	\N	\N	204033	204033	371180
27110	43312	54	applied	\N	\N	\N	\N	204034	204034	371181
27110	43313	55	applied	\N	\N	\N	\N	204035	204035	371182
27110	43319	56	applied	\N	\N	\N	\N	204036	204036	371183
27110	43320	57	applied	\N	\N	\N	\N	204037	204037	371184
27110	43325	59	applied	\N	\N	\N	\N	204038	204038	371185
27110	43327	60	applied	\N	\N	\N	\N	204039	204039	371186
27110	43329	61	applied	\N	\N	\N	\N	204040	204040	371187
27110	43332	62	applied	\N	\N	\N	\N	204041	204041	371188
27110	43338	63	applied	\N	\N	\N	\N	204042	204042	371189
27110	43339	64	applied	\N	\N	\N	\N	204043	204043	371190
27110	43341	65	applied	\N	\N	\N	\N	204044	204044	371191
27110	43345	66	applied	\N	\N	\N	\N	204045	204045	371192
27110	43354	68	applied	\N	\N	\N	\N	204047	204047	371194
27110	43460	69	applied	\N	\N	\N	\N	204048	204048	371195
27110	43461	70	applied	\N	\N	\N	\N	204049	204049	371196
27110	43462	71	applied	\N	\N	\N	\N	204050	204050	371197
27110	43463	72	applied	\N	\N	\N	\N	204051	204051	371198
27110	43464	73	applied	\N	\N	\N	\N	204052	204052	204052
27110	43355	74	applied	\N	\N	\N	\N	204053	204053	371199
27110	43356	75	applied	\N	\N	\N	\N	204054	204054	371200
27110	43359	76	applied	\N	\N	\N	\N	204055	204055	371201
27110	43363	77	applied	\N	\N	\N	\N	204056	204056	371202
27110	43364	78	applied	\N	\N	\N	\N	204057	204057	371203
27110	43368	79	applied	\N	\N	\N	\N	204058	204058	371204
27110	43371	80	applied	\N	\N	\N	\N	204059	204059	371205
27110	43372	81	applied	\N	\N	\N	\N	204060	204060	371206
27110	43377	82	applied	\N	\N	\N	\N	204061	204061	371207
27110	43380	83	applied	\N	\N	\N	\N	204062	204062	371208
27110	43385	85	applied	\N	\N	\N	\N	204064	204064	371210
27110	43390	86	applied	\N	\N	\N	\N	204065	204065	371211
27110	43394	87	applied	\N	\N	\N	\N	204066	204066	371212
27110	43397	88	applied	\N	\N	\N	\N	204067	204067	371213
27110	43400	89	applied	\N	\N	\N	\N	204068	204068	371214
27110	43403	90	applied	\N	\N	\N	\N	204069	204069	371215
27110	43405	91	applied	\N	\N	\N	\N	204070	204070	371216
27110	43409	92	applied	\N	\N	\N	\N	204071	204071	371217
27110	43412	93	applied	\N	\N	\N	\N	204072	204072	371218
27110	43417	94	applied	\N	\N	\N	\N	204073	204073	371219
27110	43421	95	applied	\N	\N	\N	\N	204074	204074	371220
27110	43424	96	applied	\N	\N	\N	\N	204075	204075	371221
27110	43410	97	applied	\N	\N	1000000000	\N	204076	204076	371222
27110	43413	98	applied	\N	\N	1000000000	\N	204077	204077	371223
27110	43415	100	applied	\N	\N	1000000000	\N	204079	204079	371225
27110	43429	101	applied	\N	\N	\N	\N	204080	204080	371226
27110	43182	102	applied	\N	\N	\N	\N	204081	204081	371227
27110	43186	103	applied	\N	\N	\N	\N	204082	204082	371228
27110	43187	104	applied	\N	\N	\N	\N	204083	204083	371229
27110	43190	105	applied	\N	\N	\N	\N	204084	204084	371230
27088	43519	5	applied	\N	\N	\N	\N	203913	203913	371060
27100	43538	0	applied	\N	\N	\N	\N	203941	203941	371088
27110	43202	109	applied	\N	\N	\N	\N	204088	204088	371234
27110	43210	110	applied	\N	\N	\N	\N	204089	204089	371235
27110	43211	111	applied	\N	\N	\N	\N	204090	204090	371236
27110	43212	112	applied	\N	\N	\N	\N	204091	204091	371237
27110	43216	113	applied	\N	\N	\N	\N	204092	204092	371238
27110	43218	114	applied	\N	\N	\N	\N	204093	204093	371239
27110	43220	115	applied	\N	\N	\N	\N	204094	204094	371240
27110	43224	116	applied	\N	\N	\N	\N	204095	204095	371241
27110	43227	117	applied	\N	\N	\N	\N	204096	204096	371242
27110	43234	119	applied	\N	\N	\N	\N	204098	204098	371244
27110	43235	120	applied	\N	\N	\N	\N	204099	204099	371245
27110	43236	121	applied	\N	\N	\N	\N	204100	204100	371246
27110	43245	122	applied	\N	\N	\N	\N	204101	204101	371247
27110	43250	123	applied	\N	\N	\N	\N	204102	204102	371248
27110	43251	124	applied	\N	\N	\N	\N	204103	204103	371249
27110	43252	125	applied	\N	\N	\N	\N	204104	204104	371250
27112	43565	0	applied	\N	\N	\N	\N	204107	204107	371253
27112	43566	1	applied	\N	\N	\N	\N	204108	204108	371254
27117	43573	0	applied	\N	\N	\N	\N	204121	204121	371267
27117	43574	1	applied	\N	\N	\N	\N	204122	204122	371268
27117	43575	2	applied	\N	\N	\N	\N	204123	204123	371269
27119	43579	0	applied	\N	\N	\N	\N	204127	204127	371273
27119	43580	1	applied	\N	\N	\N	\N	204128	204128	371274
27119	43581	2	applied	\N	\N	\N	\N	204129	204129	371275
27120	43579	0	applied	\N	\N	\N	\N	204130	204130	371276
27120	43581	2	applied	\N	\N	\N	\N	204132	204132	371278
27122	43588	0	applied	\N	\N	\N	\N	204139	204139	371285
27122	43589	1	applied	\N	\N	\N	\N	204140	204140	371286
27122	43590	2	applied	\N	\N	\N	\N	204141	204141	371287
27122	43591	3	applied	\N	\N	\N	\N	204142	204142	371288
27122	43592	4	applied	\N	\N	\N	\N	204143	204143	371289
27125	43596	0	applied	\N	\N	\N	\N	204152	204152	371298
27125	43597	1	applied	\N	\N	\N	\N	204153	204153	371299
27125	43598	2	applied	\N	\N	\N	\N	204154	204154	371300
27127	43602	0	applied	\N	\N	\N	\N	204158	204158	371304
27127	43603	1	applied	\N	\N	\N	\N	204159	204159	371305
27127	43604	2	applied	\N	\N	\N	\N	204160	204160	371306
27128	43606	1	applied	\N	\N	\N	\N	204162	204162	371308
27128	43607	2	applied	\N	\N	\N	\N	204163	204163	371309
27130	43608	0	applied	\N	\N	\N	\N	204167	204167	371313
27130	43609	1	applied	\N	\N	\N	\N	204168	204168	371314
27130	43611	3	applied	\N	\N	\N	\N	204170	204170	371316
27130	43612	4	applied	\N	\N	\N	\N	204171	204171	371317
27130	43613	5	applied	\N	\N	\N	\N	204172	204172	371318
27130	43614	6	applied	\N	\N	\N	\N	204173	204173	371319
27130	43615	7	applied	\N	\N	\N	\N	204174	204174	371320
27130	43616	8	applied	\N	\N	\N	\N	204175	204175	371321
27131	43608	0	applied	\N	\N	\N	\N	204176	204176	371322
27131	43609	1	applied	\N	\N	\N	\N	204177	204177	371323
27131	43610	2	applied	\N	\N	\N	\N	204178	204178	371324
27131	43611	3	applied	\N	\N	\N	\N	204179	204179	371325
27131	43612	4	applied	\N	\N	\N	\N	204180	204180	371326
27131	43613	5	applied	\N	\N	\N	\N	204181	204181	371327
27133	43617	0	applied	\N	\N	\N	\N	204188	204188	371334
27133	43618	1	applied	\N	\N	\N	\N	204189	204189	371335
27133	43619	2	applied	\N	\N	\N	\N	204190	204190	371336
27139	43623	0	applied	\N	\N	\N	\N	204202	204202	371348
27139	43625	2	applied	\N	\N	\N	\N	204204	204204	371350
27142	43626	0	applied	\N	\N	\N	\N	204211	204211	371357
27142	43627	1	applied	\N	\N	\N	\N	204212	204212	371358
27142	43628	2	applied	\N	\N	\N	\N	204213	204213	371359
27144	43629	0	applied	\N	\N	\N	\N	204217	204217	371363
27144	43630	1	applied	\N	\N	\N	\N	204218	204218	371364
27144	43631	2	applied	\N	\N	\N	\N	204219	204219	371365
27144	43632	3	applied	\N	\N	\N	\N	204220	204220	371366
27144	43633	4	applied	\N	\N	\N	\N	204221	204221	371367
27144	43634	5	applied	\N	\N	\N	\N	204222	204222	371368
27144	43635	6	applied	\N	\N	\N	\N	204223	204223	371369
27144	43636	7	applied	\N	\N	\N	\N	204224	204224	371370
27146	43637	0	applied	\N	\N	\N	\N	204233	204233	371379
27146	43638	1	applied	\N	\N	\N	\N	204234	204234	371380
27146	43639	2	applied	\N	\N	\N	\N	204235	204235	371381
27149	43640	0	applied	\N	\N	\N	\N	204242	204242	371388
27149	43642	3	applied	\N	\N	\N	\N	204244	204244	371390
27149	43643	4	applied	\N	\N	\N	\N	204245	204245	371391
27161	43673	0	applied	\N	\N	\N	\N	204430	204430	371576
27161	43674	1	applied	\N	\N	\N	\N	204431	204431	371577
27161	43675	2	applied	\N	\N	\N	\N	204432	204432	371578
27162	43673	0	applied	\N	\N	\N	\N	204433	204433	371579
27162	43674	1	applied	\N	\N	\N	\N	204434	204434	371580
27162	43675	2	applied	\N	\N	\N	\N	204435	204435	371581
27166	43682	0	applied	\N	\N	\N	\N	204448	204448	371593
27166	43683	1	applied	\N	\N	\N	\N	204449	204449	371594
27166	43684	2	applied	\N	\N	\N	\N	204450	204450	371595
27168	43682	0	applied	\N	\N	\N	\N	204454	204454	371599
27168	43683	1	applied	\N	\N	\N	\N	204455	204455	371600
27168	43684	2	applied	\N	\N	\N	\N	204456	204456	371601
27176	43705	0	applied	\N	\N	\N	\N	204482	204482	371627
27176	43706	1	applied	\N	\N	\N	\N	204483	204483	371628
27182	43723	0	applied	\N	\N	\N	\N	204631	204631	371776
27182	43724	2	applied	\N	\N	\N	\N	204632	204632	371777
27182	43725	3	applied	\N	\N	\N	\N	204633	204633	371778
27182	43726	4	applied	\N	\N	\N	\N	204634	204634	371779
27182	43727	5	applied	\N	\N	\N	\N	204635	204635	371780
27182	43728	6	applied	\N	\N	\N	\N	204636	204636	371781
27186	43732	0	applied	\N	\N	\N	\N	204652	204652	371797
27186	43733	1	applied	\N	\N	\N	\N	204653	204653	371798
27194	43744	0	applied	\N	\N	\N	\N	204677	204677	371822
27194	43745	1	applied	\N	\N	\N	\N	204678	204678	371823
27198	43755	0	applied	\N	\N	\N	\N	204813	204813	371958
27198	43756	1	applied	\N	\N	\N	\N	204814	204814	371959
27198	43757	2	applied	\N	\N	1000000000	\N	204815	204815	371960
27198	43758	3	applied	\N	\N	\N	\N	204816	204816	371961
27200	43755	0	applied	\N	\N	\N	\N	204823	204823	371968
27200	43756	1	applied	\N	\N	\N	\N	204824	204824	371969
27200	43757	2	applied	\N	\N	1000000000	\N	204825	204825	371970
27200	43758	3	applied	\N	\N	\N	\N	204826	204826	371971
27200	43759	4	applied	\N	\N	1000000000	\N	204827	204827	371972
27202	43760	0	applied	\N	\N	\N	\N	204830	204830	371975
27110	43196	107	applied	\N	\N	\N	\N	204086	204086	371232
27110	43199	108	applied	\N	\N	\N	\N	204087	204087	371233
27134	43619	1	applied	\N	\N	\N	\N	204192	204192	371338
27135	43617	0	applied	\N	\N	\N	\N	204193	204193	371339
27135	43618	1	applied	\N	\N	\N	\N	204194	204194	371340
27135	43619	2	applied	\N	\N	\N	\N	204195	204195	371341
27140	43623	0	applied	\N	\N	\N	\N	204205	204205	371351
27140	43624	1	applied	\N	\N	\N	\N	204206	204206	371352
27140	43625	2	applied	\N	\N	\N	\N	204207	204207	371353
27145	43629	0	applied	\N	\N	\N	\N	204225	204225	371371
27145	43630	1	applied	\N	\N	\N	\N	204226	204226	371372
27145	43631	2	applied	\N	\N	\N	\N	204227	204227	371373
27145	43632	3	applied	\N	\N	\N	\N	204228	204228	371374
27145	43633	4	applied	\N	\N	\N	\N	204229	204229	371375
27145	43634	5	applied	\N	\N	\N	\N	204230	204230	371376
27145	43635	6	applied	\N	\N	\N	\N	204231	204231	371377
27145	43636	7	applied	\N	\N	\N	\N	204232	204232	371378
27147	43637	0	applied	\N	\N	\N	\N	204236	204236	371382
27147	43639	2	applied	\N	\N	\N	\N	204238	204238	371384
27150	42536	0	applied	\N	\N	\N	\N	204246	204246	371392
27150	42540	1	applied	\N	\N	\N	\N	204247	204247	371393
27150	42541	2	applied	\N	\N	\N	\N	204248	204248	371394
27150	42546	3	applied	\N	\N	\N	\N	204249	204249	371395
27150	42906	4	applied	\N	\N	\N	\N	204250	204250	371396
27150	42550	5	applied	\N	\N	\N	\N	204251	204251	371397
27150	42553	6	applied	\N	\N	\N	\N	204252	204252	371398
27150	42556	7	applied	\N	\N	\N	\N	204253	204253	371399
27150	42560	8	applied	\N	\N	\N	\N	204254	204254	371400
27150	42563	9	applied	\N	\N	\N	\N	204255	204255	371401
27150	42566	10	applied	\N	\N	\N	\N	204256	204256	371402
27150	42567	11	applied	\N	\N	\N	\N	204257	204257	371403
27150	42573	12	applied	\N	\N	\N	\N	204258	204258	371404
27150	42576	13	applied	\N	\N	\N	\N	204259	204259	371405
27150	42577	14	applied	\N	\N	\N	\N	204260	204260	371406
27150	42586	16	applied	\N	\N	\N	\N	204262	204262	371408
27150	42589	17	applied	\N	\N	\N	\N	204263	204263	371409
27150	42593	18	applied	\N	\N	\N	\N	204264	204264	371410
27150	42596	19	applied	\N	\N	\N	\N	204265	204265	371411
27150	42599	20	applied	\N	\N	\N	\N	204266	204266	371412
27150	42602	21	applied	\N	\N	\N	\N	204267	204267	371413
27150	42603	22	applied	\N	\N	\N	\N	204268	204268	371414
27150	42609	23	applied	\N	\N	\N	\N	204269	204269	371415
27150	42610	24	applied	\N	\N	\N	\N	204270	204270	371416
27150	42611	25	applied	\N	\N	\N	\N	204271	204271	371417
27150	42618	26	applied	\N	\N	\N	\N	204272	204272	371418
27150	42619	27	applied	\N	\N	\N	\N	204273	204273	371419
27150	42626	28	applied	\N	\N	\N	\N	204274	204274	371420
27150	42629	29	applied	\N	\N	\N	\N	204275	204275	371421
27150	42630	30	applied	\N	\N	\N	\N	204276	204276	371422
27150	42631	31	applied	\N	\N	\N	\N	204277	204277	371423
27150	42643	33	applied	\N	\N	\N	\N	204279	204279	371425
27150	42646	34	applied	\N	\N	\N	\N	204280	204280	371426
27150	42650	35	applied	\N	\N	\N	\N	204281	204281	371427
27150	42653	36	applied	\N	\N	\N	\N	204282	204282	371428
27150	42656	37	applied	\N	\N	\N	\N	204283	204283	371429
27150	42657	38	applied	\N	\N	\N	\N	204284	204284	371430
27150	42663	39	applied	\N	\N	\N	\N	204285	204285	371431
27150	42664	40	applied	\N	\N	\N	\N	204286	204286	371432
27150	42669	41	applied	\N	\N	\N	\N	204287	204287	371433
27150	42670	42	applied	\N	\N	\N	\N	204288	204288	371434
27150	42671	43	applied	\N	\N	\N	\N	204289	204289	371435
27150	42680	44	applied	\N	\N	\N	\N	204290	204290	371436
27150	42681	45	applied	\N	\N	\N	\N	204291	204291	371437
27150	42687	46	applied	\N	\N	\N	\N	204292	204292	371438
27150	42690	47	applied	\N	\N	\N	\N	204293	204293	371439
27150	42691	48	applied	\N	\N	\N	\N	204294	204294	371440
27150	42698	50	applied	\N	\N	\N	\N	204296	204296	371442
27150	42703	51	applied	\N	\N	\N	\N	204297	204297	371443
27150	42707	52	applied	\N	\N	\N	\N	204298	204298	371444
27150	42710	53	applied	\N	\N	\N	\N	204299	204299	371445
27150	42713	54	applied	\N	\N	\N	\N	204300	204300	371446
27150	42717	55	applied	\N	\N	\N	\N	204301	204301	371447
27150	42718	56	applied	\N	\N	\N	\N	204302	204302	371448
27150	42719	57	applied	\N	\N	\N	\N	204303	204303	371449
27150	42725	58	applied	\N	\N	\N	\N	204304	204304	371450
27150	42729	59	applied	\N	\N	\N	\N	204305	204305	371451
27150	42732	60	applied	\N	\N	\N	\N	204306	204306	371452
27150	42733	61	applied	\N	\N	\N	\N	204307	204307	371453
27150	42739	63	applied	\N	\N	\N	\N	204308	204308	371454
27150	42742	64	applied	\N	\N	\N	\N	204309	204309	371455
27150	42747	65	applied	\N	\N	\N	\N	204310	204310	371456
27150	42751	66	applied	\N	\N	\N	\N	204311	204311	371457
27150	42757	68	applied	\N	\N	\N	\N	204313	204313	371459
27150	42760	69	applied	\N	\N	\N	\N	204314	204314	371460
27150	42764	70	applied	\N	\N	\N	\N	204315	204315	371461
27150	42767	71	applied	\N	\N	\N	\N	204316	204316	371462
27150	42768	72	applied	\N	\N	\N	\N	204317	204317	371463
27150	42774	73	applied	\N	\N	\N	\N	204318	204318	371464
27150	42777	74	applied	\N	\N	\N	\N	204319	204319	371465
27150	42780	75	applied	\N	\N	\N	\N	204320	204320	371466
27150	42784	76	applied	\N	\N	\N	\N	204321	204321	371467
27150	42785	77	applied	\N	\N	\N	\N	204322	204322	371468
27150	42790	78	applied	\N	\N	\N	\N	204323	204323	371469
27150	42793	79	applied	\N	\N	\N	\N	204324	204324	371470
27150	42797	80	applied	\N	\N	\N	\N	204325	204325	371471
27150	42798	81	applied	\N	\N	\N	\N	204326	204326	371472
27150	42799	82	applied	\N	\N	\N	\N	204327	204327	371473
27150	42807	83	applied	\N	\N	\N	\N	204328	204328	371474
27150	42813	85	applied	\N	\N	\N	\N	204330	204330	371476
27150	42814	86	applied	\N	\N	\N	\N	204331	204331	371477
27150	42819	87	applied	\N	\N	\N	\N	204332	204332	371478
27150	42820	88	applied	\N	\N	\N	\N	204333	204333	371479
27150	42821	89	applied	\N	\N	\N	\N	204334	204334	371480
27150	42822	90	applied	\N	\N	\N	\N	204335	204335	371481
27150	42823	91	applied	\N	\N	\N	\N	204336	204336	371482
27150	42824	92	applied	\N	\N	\N	\N	204337	204337	371483
27150	42839	93	applied	\N	\N	\N	\N	204338	204338	371484
27150	42840	94	applied	\N	\N	\N	\N	204339	204339	371485
27150	42845	95	applied	\N	\N	\N	\N	204340	204340	371486
27150	42849	96	applied	\N	\N	\N	\N	204341	204341	371487
27150	42852	97	applied	\N	\N	\N	\N	204342	204342	371488
27150	42853	98	applied	\N	\N	\N	\N	204343	204343	371489
27131	43615	7	applied	\N	\N	\N	\N	204183	204183	371329
27131	43616	8	applied	\N	\N	\N	\N	204184	204184	371330
27150	42874	103	applied	\N	\N	\N	\N	204348	204348	371494
27150	42877	104	applied	\N	\N	\N	\N	204349	204349	371495
27150	42878	105	applied	\N	\N	\N	\N	204350	204350	371496
27150	42879	106	applied	\N	\N	\N	\N	204351	204351	371497
27150	42887	107	applied	\N	\N	\N	\N	204352	204352	371498
27150	42890	108	applied	\N	\N	\N	\N	204353	204353	371499
27150	42892	109	applied	\N	\N	\N	\N	204354	204354	371500
27150	42896	110	applied	\N	\N	\N	\N	204355	204355	371501
27150	42899	111	applied	\N	\N	\N	\N	204356	204356	371502
27150	42902	112	applied	\N	\N	\N	\N	204357	204357	371503
27150	42907	113	applied	\N	\N	\N	\N	204358	204358	371504
27150	42910	114	applied	\N	\N	\N	\N	204359	204359	371505
27150	42911	115	applied	\N	\N	\N	\N	204360	204360	371506
27150	42912	116	applied	\N	\N	\N	\N	204361	204361	371507
27150	42923	118	applied	\N	\N	\N	\N	204363	204363	371509
27150	42926	119	applied	\N	\N	\N	\N	204364	204364	371510
27150	42927	120	applied	\N	\N	\N	\N	204365	204365	371511
27150	42933	121	applied	\N	\N	\N	\N	204366	204366	371512
27150	42934	122	applied	\N	\N	\N	\N	204367	204367	371513
27150	42935	123	applied	\N	\N	\N	\N	204368	204368	371514
27150	42936	124	applied	\N	\N	\N	\N	204369	204369	371515
27150	42946	125	applied	\N	\N	\N	\N	204370	204370	371516
27152	43646	0	applied	\N	\N	\N	\N	204373	204373	371519
27152	43647	2	applied	\N	\N	\N	\N	204374	204374	371520
27152	43648	3	applied	\N	\N	\N	\N	204375	204375	371521
27152	43649	4	applied	\N	\N	\N	\N	204376	204376	371522
27152	43640	5	applied	\N	\N	\N	\N	204377	204377	371523
27152	43641	6	applied	\N	\N	\N	\N	204378	204378	371524
27152	43645	7	applied	\N	\N	\N	\N	204379	204379	371525
27152	43650	8	applied	\N	\N	\N	\N	204380	204380	371526
27152	43643	10	applied	\N	\N	\N	\N	204382	204382	371528
27152	43644	11	applied	\N	\N	\N	\N	204383	204383	371529
27152	43651	12	applied	\N	\N	\N	\N	204384	204384	371530
27153	43646	0	applied	\N	\N	\N	\N	204385	204385	371531
27153	43647	2	applied	\N	\N	\N	\N	204386	204386	371532
27153	43648	3	applied	\N	\N	\N	\N	204387	204387	371533
27153	43649	4	applied	\N	\N	\N	\N	204388	204388	371534
27153	43640	5	applied	\N	\N	\N	\N	204389	204389	371535
27153	43641	6	applied	\N	\N	\N	\N	204390	204390	371536
27153	43645	7	applied	\N	\N	\N	\N	204391	204391	371537
27153	43650	8	applied	\N	\N	\N	\N	204392	204392	371538
27153	43642	9	applied	\N	\N	\N	\N	204393	204393	371539
27153	43643	10	applied	\N	\N	\N	\N	204394	204394	371540
27153	43644	11	applied	\N	\N	\N	\N	204395	204395	371541
27153	43651	12	applied	\N	\N	\N	\N	204396	204396	371542
27154	43649	3	applied	\N	\N	\N	\N	204400	204400	371546
27154	43650	5	applied	\N	\N	\N	\N	204402	204402	371548
27155	43652	0	applied	\N	\N	\N	\N	204403	204403	371549
27155	43653	1	applied	\N	\N	\N	\N	204404	204404	371550
27155	43654	2	applied	\N	\N	\N	\N	204405	204405	371551
27158	43655	0	applied	\N	\N	\N	\N	204412	204412	371558
27158	43656	1	applied	\N	\N	\N	\N	204413	204413	371559
27159	43661	0	applied	\N	\N	\N	\N	204418	204418	371564
27159	43662	1	applied	\N	\N	\N	\N	204419	204419	371565
27159	43663	2	applied	\N	\N	\N	\N	204420	204420	371566
27164	43510	0	applied	\N	\N	\N	\N	204439	204439	371585
27164	43460	1	applied	\N	\N	\N	\N	204440	204440	371586
27164	43461	2	applied	\N	\N	\N	\N	204441	204441	371587
27164	43462	3	applied	\N	\N	\N	\N	204442	204442	371588
27164	43463	4	applied	\N	\N	\N	\N	204443	204443	371589
27164	43464	5	applied	\N	\N	\N	\N	204444	204444	204444
27167	43682	0	applied	\N	\N	\N	\N	204451	204451	371596
27167	43684	2	applied	\N	\N	\N	\N	204453	204453	371598
27169	43685	0	applied	\N	\N	\N	\N	204457	204457	371602
27169	43686	1	applied	\N	\N	\N	\N	204458	204458	371603
27169	43687	2	applied	\N	\N	\N	\N	204459	204459	371604
27169	43688	3	applied	\N	\N	\N	\N	204460	204460	371605
27169	43689	4	applied	\N	\N	\N	\N	204461	204461	371606
27171	43690	0	applied	\N	\N	\N	\N	204467	204467	371612
27171	43691	1	applied	\N	\N	\N	\N	204468	204468	371613
27171	43692	2	applied	\N	\N	\N	\N	204469	204469	371614
27174	43699	0	applied	\N	\N	\N	\N	204476	204476	371621
27174	43700	1	applied	\N	\N	\N	\N	204477	204477	371622
27174	43701	2	applied	\N	\N	\N	\N	204478	204478	371623
27177	43708	0	applied	\N	\N	\N	\N	204485	204485	371630
27177	43709	1	applied	\N	\N	\N	\N	204486	204486	371631
27177	43710	2	applied	\N	\N	\N	\N	204487	204487	371632
27177	43711	3	applied	\N	\N	\N	\N	204488	204488	371633
27177	43713	5	applied	\N	\N	\N	\N	204490	204490	371635
27183	43723	0	applied	\N	\N	\N	\N	204637	204637	371782
27183	43724	2	applied	\N	\N	\N	\N	204638	204638	371783
27183	43725	3	applied	\N	\N	\N	\N	204639	204639	371784
27183	43726	4	applied	\N	\N	\N	\N	204640	204640	371785
27183	43727	5	applied	\N	\N	\N	\N	204641	204641	371786
27183	43728	6	applied	\N	\N	\N	\N	204642	204642	371787
27187	43732	0	applied	\N	\N	\N	\N	204654	204654	371799
27187	43733	1	applied	\N	\N	\N	\N	204655	204655	371800
27187	43734	2	applied	\N	\N	\N	\N	204656	204656	371801
27188	43732	0	applied	\N	\N	\N	\N	204657	204657	371802
27188	43733	1	applied	\N	\N	\N	\N	204658	204658	371803
27188	43734	2	applied	\N	\N	\N	\N	204659	204659	371804
27189	43733	0	applied	\N	\N	\N	\N	204660	204660	371805
27189	43734	1	applied	\N	\N	\N	\N	204661	204661	371806
27191	43735	0	applied	\N	\N	\N	\N	204665	204665	371810
27191	43737	2	applied	\N	\N	\N	\N	204667	204667	371812
27203	43763	0	applied	\N	\N	\N	\N	204833	204833	371978
27203	43764	1	applied	\N	\N	\N	\N	204834	204834	371979
27203	43765	2	applied	\N	\N	\N	\N	204835	204835	371980
27203	43766	3	applied	\N	\N	1000000000	\N	204836	204836	371981
27203	43767	4	applied	\N	\N	\N	\N	204837	204837	371982
27203	43768	5	applied	\N	\N	\N	\N	204838	204838	371983
27203	43769	6	applied	\N	\N	\N	\N	204839	204839	371984
27206	43770	0	applied	\N	\N	\N	\N	204850	204850	371995
27206	43771	1	applied	\N	\N	\N	\N	204851	204851	371996
27206	43772	2	applied	\N	\N	\N	\N	204852	204852	371997
27211	43778	0	applied	\N	\N	\N	\N	204864	204864	372009
27211	43779	1	applied	\N	\N	\N	\N	204865	204865	372010
27211	43780	2	applied	\N	\N	\N	\N	204866	204866	372011
27212	43781	0	applied	\N	\N	\N	\N	204867	204867	372012
27212	43782	1	applied	\N	\N	\N	\N	204868	204868	372013
27150	42870	102	applied	\N	\N	\N	\N	204347	204347	371493
27160	43667	3	applied	\N	\N	\N	\N	204424	204424	371570
27160	43668	4	applied	\N	\N	\N	\N	204425	204425	371571
27160	43669	5	applied	\N	\N	\N	\N	204426	204426	371572
27160	43670	6	applied	\N	\N	\N	\N	204427	204427	371573
27160	43671	7	applied	\N	\N	\N	\N	204428	204428	371574
27160	43672	8	applied	\N	\N	\N	\N	204429	204429	371575
27163	43676	0	applied	\N	\N	\N	\N	204436	204436	371582
27163	43677	1	applied	\N	\N	\N	\N	204437	204437	371583
27163	43678	2	applied	\N	\N	\N	\N	204438	204438	371584
27165	43679	0	applied	\N	\N	\N	\N	204445	204445	371590
27165	43680	1	applied	\N	\N	\N	\N	204446	204446	371591
27173	43696	0	applied	\N	\N	\N	\N	204473	204473	371618
27173	43697	1	applied	\N	\N	\N	\N	204474	204474	371619
27173	43698	2	applied	\N	\N	\N	\N	204475	204475	371620
27179	43714	0	applied	\N	\N	\N	\N	204497	204497	371642
27179	43715	1	applied	\N	\N	\N	\N	204498	204498	371643
27179	43717	3	applied	\N	\N	\N	\N	204500	204500	371645
27179	43718	4	applied	\N	\N	\N	\N	204501	204501	371646
27179	43719	5	applied	\N	\N	\N	\N	204502	204502	371647
27181	43720	0	applied	\N	\N	\N	\N	204628	204628	371773
27181	43721	1	applied	\N	\N	\N	\N	204629	204629	371774
27181	43722	2	applied	\N	\N	\N	\N	204630	204630	371775
27190	43732	0	applied	\N	\N	\N	\N	204662	204662	371807
27190	43733	1	applied	\N	\N	\N	\N	204663	204663	371808
27190	43734	2	applied	\N	\N	\N	\N	204664	204664	371809
27195	43617	0	applied	\N	\N	\N	\N	204679	204679	371824
27195	43620	1	applied	\N	\N	\N	\N	204680	204680	371825
27195	43623	2	applied	\N	\N	\N	\N	204681	204681	371826
27195	43626	3	applied	\N	\N	\N	\N	204682	204682	371827
27195	43629	4	applied	\N	\N	\N	\N	204683	204683	371828
27195	43630	5	applied	\N	\N	\N	\N	204684	204684	371829
27195	43631	6	applied	\N	\N	\N	\N	204685	204685	371830
27195	43646	8	applied	\N	\N	\N	\N	204687	204687	371832
27195	43647	9	applied	\N	\N	\N	\N	204688	204688	371833
27195	43648	10	applied	\N	\N	\N	\N	204689	204689	371834
27195	43649	11	applied	\N	\N	\N	\N	204690	204690	371835
27195	43652	12	applied	\N	\N	\N	\N	204691	204691	371836
27195	43655	13	applied	\N	\N	\N	\N	204692	204692	371837
27195	43656	14	applied	\N	\N	\N	\N	204693	204693	371838
27195	43661	15	applied	\N	\N	\N	\N	204694	204694	371839
27195	43664	16	applied	\N	\N	\N	\N	204695	204695	371840
27195	43665	17	applied	\N	\N	\N	\N	204696	204696	371841
27195	43666	18	applied	\N	\N	\N	\N	204697	204697	371842
27195	43673	19	applied	\N	\N	\N	\N	204698	204698	371843
27195	43676	20	applied	\N	\N	\N	\N	204699	204699	371844
27195	43679	21	applied	\N	\N	\N	\N	204700	204700	371845
27195	43682	22	applied	\N	\N	\N	\N	204701	204701	371846
27195	43685	23	applied	\N	\N	\N	\N	204702	204702	371847
27195	43690	25	applied	\N	\N	\N	\N	204704	204704	371849
27195	43693	26	applied	\N	\N	\N	\N	204705	204705	371850
27195	43696	27	applied	\N	\N	\N	\N	204706	204706	371851
27195	43699	28	applied	\N	\N	\N	\N	204707	204707	371852
27195	43702	29	applied	\N	\N	\N	\N	204708	204708	371853
27195	43705	30	applied	\N	\N	\N	\N	204709	204709	371854
27195	43708	31	applied	\N	\N	\N	\N	204710	204710	371855
27195	43709	32	applied	\N	\N	\N	\N	204711	204711	371856
27195	43714	33	applied	\N	\N	\N	\N	204712	204712	371857
27195	43715	34	applied	\N	\N	\N	\N	204713	204713	371858
27195	43720	35	applied	\N	\N	\N	\N	204714	204714	371859
27195	43723	37	applied	\N	\N	\N	\N	204715	204715	371860
27195	43724	38	applied	\N	\N	\N	\N	204716	204716	371861
27195	43729	39	applied	\N	\N	\N	\N	204717	204717	371862
27195	43732	40	applied	\N	\N	\N	\N	204718	204718	371863
27195	43735	41	applied	\N	\N	\N	\N	204719	204719	371864
27195	43739	43	applied	\N	\N	\N	\N	204721	204721	371866
27195	43744	44	applied	\N	\N	\N	\N	204722	204722	371867
27195	43746	45	applied	\N	\N	\N	\N	204723	204723	371868
27195	43618	46	applied	\N	\N	\N	\N	204724	204724	371869
27195	43622	47	applied	\N	\N	\N	\N	204725	204725	371870
27195	43625	48	applied	\N	\N	\N	\N	204726	204726	371871
27195	43627	49	applied	\N	\N	\N	\N	204727	204727	371872
27195	43632	50	applied	\N	\N	\N	\N	204728	204728	371873
27195	43633	51	applied	\N	\N	\N	\N	204729	204729	371874
27195	43636	52	applied	\N	\N	\N	\N	204730	204730	371875
27195	43639	53	applied	\N	\N	\N	\N	204731	204731	371876
27195	43619	54	applied	\N	\N	\N	\N	204732	204732	371877
27195	43621	55	applied	\N	\N	\N	\N	204733	204733	371878
27195	43624	56	applied	\N	\N	\N	\N	204734	204734	371879
27195	43628	57	applied	\N	\N	\N	\N	204735	204735	371880
27195	43634	58	applied	\N	\N	\N	\N	204736	204736	371881
27195	43638	60	applied	\N	\N	\N	\N	204738	204738	371883
27195	43640	61	applied	\N	\N	\N	\N	204739	204739	371884
27195	43641	62	applied	\N	\N	\N	\N	204740	204740	371885
27195	43645	63	applied	\N	\N	\N	\N	204741	204741	371886
27195	43650	64	applied	\N	\N	\N	\N	204742	204742	371887
27195	43653	65	applied	\N	\N	\N	\N	204743	204743	371888
27195	43659	66	applied	\N	\N	\N	\N	204744	204744	371889
27195	43660	67	applied	\N	\N	\N	\N	204745	204745	371890
27195	43662	68	applied	\N	\N	\N	\N	204746	204746	371891
27195	43669	69	applied	\N	\N	\N	\N	204747	204747	371892
27195	43670	70	applied	\N	\N	\N	\N	204748	204748	371893
27195	43671	71	applied	\N	\N	\N	\N	204749	204749	371894
27195	43674	72	applied	\N	\N	\N	\N	204750	204750	371895
27195	43678	73	applied	\N	\N	\N	\N	204751	204751	371896
27195	43680	74	applied	\N	\N	\N	\N	204752	204752	371897
27195	43684	75	applied	\N	\N	\N	\N	204753	204753	371898
27195	43691	77	applied	\N	\N	\N	\N	204755	204755	371900
27195	43694	78	applied	\N	\N	\N	\N	204756	204756	371901
27195	43698	79	applied	\N	\N	\N	\N	204757	204757	371902
27195	43701	80	applied	\N	\N	\N	\N	204758	204758	371903
27195	43703	81	applied	\N	\N	\N	\N	204759	204759	371904
27195	43707	82	applied	\N	\N	\N	\N	204760	204760	371905
27195	43710	83	applied	\N	\N	\N	\N	204761	204761	371906
27195	43711	84	applied	\N	\N	\N	\N	204762	204762	371907
27195	43716	85	applied	\N	\N	\N	\N	204763	204763	371908
27195	43719	86	applied	\N	\N	\N	\N	204764	204764	371909
27195	43722	87	applied	\N	\N	\N	\N	204765	204765	371910
27195	43726	88	applied	\N	\N	\N	\N	204766	204766	371911
27195	43727	89	applied	\N	\N	\N	\N	204767	204767	371912
27195	43730	90	applied	\N	\N	\N	\N	204768	204768	371913
27158	43658	3	applied	\N	\N	\N	\N	204415	204415	371561
27158	43659	4	applied	\N	\N	\N	\N	204416	204416	371562
27170	43688	3	applied	\N	\N	\N	\N	204465	204465	371610
27170	43689	4	applied	\N	\N	\N	\N	204466	204466	371611
27172	43693	0	applied	\N	\N	\N	\N	204470	204470	371615
27172	43694	1	applied	\N	\N	\N	\N	204471	204471	371616
27172	43695	2	applied	\N	\N	\N	\N	204472	204472	371617
27175	43702	0	applied	\N	\N	\N	\N	204479	204479	371624
27175	43703	1	applied	\N	\N	\N	\N	204480	204480	371625
27175	43704	2	applied	\N	\N	\N	\N	204481	204481	371626
27178	43714	0	applied	\N	\N	\N	\N	204491	204491	371636
27178	43715	1	applied	\N	\N	\N	\N	204492	204492	371637
27178	43716	2	applied	\N	\N	\N	\N	204493	204493	371638
27178	43717	3	applied	\N	\N	\N	\N	204494	204494	371639
27178	43718	4	applied	\N	\N	\N	\N	204495	204495	371640
27178	43719	5	applied	\N	\N	\N	\N	204496	204496	371641
27180	42953	0	applied	\N	\N	\N	\N	204503	204503	371648
27180	42954	1	applied	\N	\N	\N	\N	204504	204504	371649
27180	42960	3	applied	\N	\N	\N	\N	204506	204506	371651
27180	42964	4	applied	\N	\N	\N	\N	204507	204507	371652
27180	42966	5	applied	\N	\N	\N	\N	204508	204508	371653
27180	42969	6	applied	\N	\N	\N	\N	204509	204509	371654
27180	42973	7	applied	\N	\N	\N	\N	204510	204510	371655
27180	42976	8	applied	\N	\N	\N	\N	204511	204511	371656
27180	42977	9	applied	\N	\N	\N	\N	204512	204512	371657
27180	42978	10	applied	\N	\N	\N	\N	204513	204513	371658
27180	42986	11	applied	\N	\N	\N	\N	204514	204514	371659
27180	42989	12	applied	\N	\N	\N	\N	204515	204515	371660
27180	42992	13	applied	\N	\N	\N	\N	204516	204516	371661
27180	42996	14	applied	\N	\N	\N	\N	204517	204517	371662
27180	42999	15	applied	\N	\N	\N	\N	204518	204518	371663
27180	43002	16	applied	\N	\N	\N	\N	204519	204519	371664
27180	43006	17	applied	\N	\N	\N	\N	204520	204520	371665
27180	43007	18	applied	\N	\N	\N	\N	204521	204521	371666
27180	43009	20	applied	\N	\N	\N	\N	204523	204523	371668
27180	43019	21	applied	\N	\N	\N	\N	204524	204524	371669
27180	43021	22	applied	\N	\N	\N	\N	204525	204525	371670
27180	43022	23	applied	\N	\N	\N	\N	204526	204526	371671
27180	43028	24	applied	\N	\N	\N	\N	204527	204527	371672
27180	43031	25	applied	\N	\N	\N	\N	204528	204528	371673
27180	43034	26	applied	\N	\N	\N	\N	204529	204529	371674
27180	43035	27	applied	\N	\N	\N	\N	204530	204530	371675
27180	43041	28	applied	\N	\N	\N	\N	204531	204531	371676
27180	43044	29	applied	\N	\N	\N	\N	204532	204532	371677
27180	43045	30	applied	\N	\N	\N	\N	204533	204533	371678
27180	43046	31	applied	\N	\N	\N	\N	204534	204534	371679
27180	43054	32	applied	\N	\N	\N	\N	204535	204535	371680
27180	43057	33	applied	\N	\N	\N	\N	204536	204536	371681
27180	43058	34	applied	\N	\N	\N	\N	204537	204537	371682
27180	43064	35	applied	\N	\N	\N	\N	204538	204538	371683
27180	43071	37	applied	\N	\N	\N	\N	204540	204540	371685
27180	43074	38	applied	\N	\N	\N	\N	204541	204541	371686
27180	43077	39	applied	\N	\N	\N	\N	204542	204542	371687
27180	43082	40	applied	\N	\N	\N	\N	204543	204543	371688
27180	43085	41	applied	\N	\N	\N	\N	204544	204544	371689
27180	43088	42	applied	\N	\N	\N	\N	204545	204545	371690
27180	43089	43	applied	\N	\N	\N	\N	204546	204546	371691
27180	43090	44	applied	\N	\N	\N	\N	204547	204547	371692
27180	43098	45	applied	\N	\N	\N	\N	204548	204548	371693
27180	43101	46	applied	\N	\N	\N	\N	204549	204549	371694
27180	43105	47	applied	\N	\N	\N	\N	204550	204550	371695
27180	43108	48	applied	\N	\N	\N	\N	204551	204551	371696
27180	43111	49	applied	\N	\N	\N	\N	204552	204552	371697
27180	43115	50	applied	\N	\N	\N	\N	204553	204553	371698
27180	43118	51	applied	\N	\N	\N	\N	204554	204554	371699
27180	43119	52	applied	\N	\N	\N	\N	204555	204555	371700
27180	43125	54	applied	\N	\N	\N	\N	204557	204557	371702
27180	43131	55	applied	\N	\N	\N	\N	204558	204558	371703
27180	43132	56	applied	\N	\N	\N	\N	204559	204559	371704
27180	43133	57	applied	\N	\N	\N	\N	204560	204560	371705
27180	43134	58	applied	\N	\N	\N	\N	204561	204561	371706
27180	43142	59	applied	\N	\N	\N	\N	204562	204562	371707
27180	43143	60	applied	\N	\N	\N	\N	204563	204563	371708
27180	43148	61	applied	\N	\N	\N	\N	204564	204564	371709
27180	43151	63	applied	\N	\N	\N	\N	204565	204565	371710
27180	43154	64	applied	\N	\N	\N	\N	204566	204566	371711
27180	43157	65	applied	\N	\N	\N	\N	204567	204567	371712
27180	43158	66	applied	\N	\N	\N	\N	204568	204568	371713
27180	43163	67	applied	\N	\N	\N	\N	204569	204569	371714
27180	43166	68	applied	\N	\N	\N	\N	204570	204570	371715
27180	43169	69	applied	\N	\N	\N	\N	204571	204571	371716
27180	43172	70	applied	\N	\N	\N	\N	204572	204572	371717
27180	43177	72	applied	\N	\N	\N	\N	204574	204574	371719
27180	43178	73	applied	\N	\N	\N	\N	204575	204575	371720
27180	43183	74	applied	\N	\N	\N	\N	204576	204576	371721
27180	43184	75	applied	\N	\N	\N	\N	204577	204577	371722
27180	43189	76	applied	\N	\N	\N	\N	204578	204578	371723
27180	43192	77	applied	\N	\N	\N	\N	204579	204579	371724
27180	43195	78	applied	\N	\N	\N	\N	204580	204580	371725
27180	43198	79	applied	\N	\N	\N	\N	204581	204581	371726
27180	43201	80	applied	\N	\N	\N	\N	204582	204582	371727
27180	43204	81	applied	\N	\N	\N	\N	204583	204583	371728
27180	43205	82	applied	\N	\N	\N	\N	204584	204584	371729
27180	43206	83	applied	\N	\N	\N	\N	204585	204585	371730
27180	43213	84	applied	\N	\N	\N	\N	204586	204586	371731
27180	43214	85	applied	\N	\N	\N	\N	204587	204587	371732
27180	43219	86	applied	\N	\N	\N	\N	204588	204588	371733
27180	43222	87	applied	\N	\N	\N	\N	204589	204589	371734
27180	43228	89	applied	\N	\N	\N	\N	204591	204591	371736
27180	43231	90	applied	\N	\N	\N	\N	204592	204592	371737
27180	43232	91	applied	\N	\N	\N	\N	204593	204593	371738
27180	43233	92	applied	\N	\N	\N	\N	204594	204594	371739
27180	43240	93	applied	\N	\N	\N	\N	204595	204595	371740
27180	43241	94	applied	\N	\N	\N	\N	204596	204596	371741
27180	43242	95	applied	\N	\N	\N	\N	204597	204597	371742
27180	43243	96	applied	\N	\N	\N	\N	204598	204598	371743
27180	43253	97	applied	\N	\N	\N	\N	204599	204599	371744
27180	43256	98	applied	\N	\N	\N	\N	204600	204600	371745
27180	43259	99	applied	\N	\N	\N	\N	204601	204601	371746
27180	43262	100	applied	\N	\N	\N	\N	204602	204602	371747
27180	43265	101	applied	\N	\N	\N	\N	204603	204603	371748
27180	43269	102	applied	\N	\N	\N	\N	204604	204604	371749
27170	43685	0	applied	\N	\N	\N	\N	204462	204462	371607
27170	43686	1	applied	\N	\N	\N	\N	204463	204463	371608
27180	43280	106	applied	\N	\N	\N	\N	204608	204608	371753
27180	43287	108	applied	\N	\N	\N	\N	204610	204610	371755
27180	43290	109	applied	\N	\N	\N	\N	204611	204611	371756
27180	43293	110	applied	\N	\N	\N	\N	204612	204612	371757
27180	43296	111	applied	\N	\N	\N	\N	204613	204613	371758
27180	43301	112	applied	\N	\N	\N	\N	204614	204614	371759
27180	43302	113	applied	\N	\N	\N	\N	204615	204615	371760
27180	43303	114	applied	\N	\N	\N	\N	204616	204616	371761
27180	43308	115	applied	\N	\N	\N	\N	204617	204617	371762
27180	43309	116	applied	\N	\N	\N	\N	204618	204618	371763
27180	43310	117	applied	\N	\N	\N	\N	204619	204619	371764
27180	43317	118	applied	\N	\N	\N	\N	204620	204620	371765
27180	43318	119	applied	\N	\N	\N	\N	204621	204621	371766
27180	43323	120	applied	\N	\N	\N	\N	204622	204622	371767
27180	43326	121	applied	\N	\N	\N	\N	204623	204623	371768
27180	43331	122	applied	\N	\N	\N	\N	204624	204624	371769
27180	43334	123	applied	\N	\N	\N	\N	204625	204625	371770
27180	43340	125	applied	\N	\N	\N	\N	204627	204627	371772
27184	43723	0	applied	\N	\N	\N	\N	204643	204643	371788
27184	43724	2	applied	\N	\N	\N	\N	204644	204644	371789
27184	43725	3	applied	\N	\N	\N	\N	204645	204645	371790
27184	43726	4	applied	\N	\N	\N	\N	204646	204646	371791
27184	43727	5	applied	\N	\N	\N	\N	204647	204647	371792
27184	43728	6	applied	\N	\N	\N	\N	204648	204648	371793
27185	43729	0	applied	\N	\N	\N	\N	204649	204649	371794
27185	43730	1	applied	\N	\N	\N	\N	204650	204650	371795
27185	43731	2	applied	\N	\N	\N	\N	204651	204651	371796
27192	43735	0	applied	\N	\N	\N	\N	204668	204668	371813
27192	43736	1	applied	\N	\N	\N	\N	204669	204669	371814
27192	43737	2	applied	\N	\N	\N	\N	204670	204670	371815
27193	43738	0	applied	\N	\N	\N	\N	204671	204671	371816
27193	43739	1	applied	\N	\N	\N	\N	204672	204672	371817
27193	43740	2	applied	\N	\N	\N	\N	204673	204673	371818
27193	43742	4	applied	\N	\N	\N	\N	204675	204675	371820
27193	43743	5	applied	\N	\N	\N	\N	204676	204676	371821
27195	43734	91	applied	\N	\N	\N	\N	204769	204769	371914
27195	43736	92	applied	\N	\N	\N	\N	204770	204770	371915
27195	43742	93	applied	\N	\N	\N	\N	204771	204771	371916
27195	43743	94	applied	\N	\N	\N	\N	204772	204772	371917
27195	43745	95	applied	\N	\N	\N	\N	204773	204773	371918
27195	43747	96	applied	\N	\N	\N	\N	204774	204774	371919
27195	43642	97	applied	\N	\N	\N	\N	204775	204775	371920
27195	43643	98	applied	\N	\N	\N	\N	204776	204776	371921
27196	43746	0	applied	\N	\N	\N	\N	204804	204804	371949
27196	43748	1	applied	\N	\N	\N	\N	204805	204805	371950
27196	43747	2	applied	\N	\N	\N	\N	204806	204806	371951
27196	43749	3	applied	\N	\N	\N	\N	204807	204807	371952
27196	43750	4	applied	\N	\N	\N	\N	204808	204808	371953
27196	43751	5	applied	\N	\N	\N	\N	204809	204809	371954
27197	43753	1	applied	\N	\N	\N	\N	204811	204811	371956
27197	43754	2	applied	\N	\N	\N	\N	204812	204812	371957
27199	43755	0	applied	\N	\N	\N	\N	204818	204818	371963
27199	43756	1	applied	\N	\N	\N	\N	204819	204819	371964
27199	43757	2	applied	\N	\N	1000000000	\N	204820	204820	371965
27199	43758	3	applied	\N	\N	\N	\N	204821	204821	371966
27199	43759	4	applied	\N	\N	1000000000	\N	204822	204822	371967
27201	43757	0	applied	\N	\N	1000000000	\N	204828	204828	371973
27201	43759	1	applied	\N	\N	1000000000	\N	204829	204829	371974
27204	43763	0	applied	\N	\N	\N	\N	204840	204840	371985
27204	43764	1	applied	\N	\N	\N	\N	204841	204841	371986
27204	43765	2	applied	\N	\N	\N	\N	204842	204842	371987
27204	43766	3	applied	\N	\N	1000000000	\N	204843	204843	371988
27204	43767	4	applied	\N	\N	\N	\N	204844	204844	371989
27204	43768	5	applied	\N	\N	\N	\N	204845	204845	371990
27204	43769	6	applied	\N	\N	\N	\N	204846	204846	371991
27216	43752	1	applied	\N	\N	\N	\N	205002	205002	372147
27216	43755	2	applied	\N	\N	\N	\N	205003	205003	372148
27216	43760	3	applied	\N	\N	\N	\N	205004	205004	372149
27216	43763	4	applied	\N	\N	\N	\N	205005	205005	372150
27216	43764	5	applied	\N	\N	\N	\N	205006	205006	372151
27216	43770	6	applied	\N	\N	\N	\N	205007	205007	372152
27216	43773	7	applied	\N	\N	\N	\N	205008	205008	372153
27216	43774	8	applied	\N	\N	\N	\N	205009	205009	372154
27216	43778	9	applied	\N	\N	\N	\N	205010	205010	372155
27216	43781	10	applied	\N	\N	\N	\N	205011	205011	372156
27216	43784	11	applied	\N	\N	\N	\N	205012	205012	372157
27216	43785	12	applied	\N	\N	\N	\N	205013	205013	372158
27216	43786	13	applied	\N	\N	\N	\N	205014	205014	372159
27216	43787	14	applied	\N	\N	\N	\N	205015	205015	372160
27216	43788	15	applied	\N	\N	\N	\N	205016	205016	372161
27216	43789	16	applied	\N	\N	\N	\N	205017	205017	372162
27216	43805	18	applied	\N	\N	\N	\N	205019	205019	372164
27216	43806	19	applied	\N	\N	\N	\N	205020	205020	372165
27216	43757	20	applied	\N	\N	1000000000	\N	205021	205021	372166
27216	43759	21	applied	\N	\N	1000000000	\N	205022	205022	372167
27216	43766	22	applied	\N	\N	1000000000	\N	205023	205023	372168
27216	43751	23	applied	\N	\N	\N	\N	205024	205024	372169
27216	43754	24	applied	\N	\N	\N	\N	205025	205025	372170
27216	43756	25	applied	\N	\N	\N	\N	205026	205026	372171
27216	43762	26	applied	\N	\N	\N	\N	205027	205027	372172
27216	43765	27	applied	\N	\N	\N	\N	205028	205028	372173
27216	43769	28	applied	\N	\N	\N	\N	205029	205029	372174
27216	43772	29	applied	\N	\N	\N	\N	205030	205030	372175
27216	43775	30	applied	\N	\N	\N	\N	205031	205031	372176
27216	43728	31	applied	\N	\N	\N	\N	205032	205032	372177
27216	43731	32	applied	\N	\N	\N	\N	205033	205033	372178
27216	43733	33	applied	\N	\N	\N	\N	205034	205034	372179
27216	43740	35	applied	\N	\N	\N	\N	205036	205036	372181
27216	43741	37	applied	\N	\N	\N	\N	205037	205037	372182
27216	43749	38	applied	\N	\N	\N	\N	205038	205038	372183
27216	43750	39	applied	\N	\N	\N	\N	205039	205039	372184
27216	43753	40	applied	\N	\N	\N	\N	205040	205040	372185
27216	43758	41	applied	\N	\N	\N	\N	205041	205041	372186
27216	43761	42	applied	\N	\N	\N	\N	205042	205042	372187
27216	43767	43	applied	\N	\N	\N	\N	205043	205043	372188
27216	43768	44	applied	\N	\N	\N	\N	205044	205044	372189
27216	43771	45	applied	\N	\N	\N	\N	205045	205045	372190
27216	43776	46	applied	\N	\N	\N	\N	205046	205046	372191
27216	43777	47	applied	\N	\N	\N	\N	205047	205047	372192
27180	43273	104	applied	\N	\N	\N	\N	204606	204606	371751
27180	43279	105	applied	\N	\N	\N	\N	204607	204607	371752
27195	43658	103	applied	\N	\N	\N	\N	204781	204781	371926
27195	43663	104	applied	\N	\N	\N	\N	204782	204782	371927
27195	43667	105	applied	\N	\N	\N	\N	204783	204783	371928
27195	43668	106	applied	\N	\N	\N	\N	204784	204784	371929
27195	43672	107	applied	\N	\N	\N	\N	204785	204785	371930
27195	43675	108	applied	\N	\N	\N	\N	204786	204786	371931
27195	43677	109	applied	\N	\N	\N	\N	204787	204787	371932
27195	43681	110	applied	\N	\N	\N	\N	204788	204788	371933
27195	43683	111	applied	\N	\N	\N	\N	204789	204789	371934
27195	43688	112	applied	\N	\N	\N	\N	204790	204790	371935
27195	43689	113	applied	\N	\N	\N	\N	204791	204791	371936
27195	43692	114	applied	\N	\N	\N	\N	204792	204792	371937
27195	43695	115	applied	\N	\N	\N	\N	204793	204793	371938
27195	43697	116	applied	\N	\N	\N	\N	204794	204794	371939
27195	43704	118	applied	\N	\N	\N	\N	204796	204796	371941
27195	43706	119	applied	\N	\N	\N	\N	204797	204797	371942
27195	43712	120	applied	\N	\N	\N	\N	204798	204798	371943
27195	43713	121	applied	\N	\N	\N	\N	204799	204799	371944
27195	43717	122	applied	\N	\N	\N	\N	204800	204800	371945
27195	43718	123	applied	\N	\N	\N	\N	204801	204801	371946
27195	43721	124	applied	\N	\N	\N	\N	204802	204802	371947
27195	43725	125	applied	\N	\N	\N	\N	204803	204803	371948
27202	43761	1	applied	\N	\N	\N	\N	204831	204831	371976
27202	43762	2	applied	\N	\N	\N	\N	204832	204832	371977
27205	43770	0	applied	\N	\N	\N	\N	204847	204847	371992
27205	43771	1	applied	\N	\N	\N	\N	204848	204848	371993
27205	43772	2	applied	\N	\N	\N	\N	204849	204849	371994
27207	43773	0	applied	\N	\N	\N	\N	204853	204853	371998
27207	43774	1	applied	\N	\N	\N	\N	204854	204854	371999
27207	43775	2	applied	\N	\N	\N	\N	204855	204855	372000
27209	43779	1	applied	\N	\N	\N	\N	204859	204859	372004
27209	43780	2	applied	\N	\N	\N	\N	204860	204860	372005
27214	43784	0	applied	\N	\N	\N	\N	204959	204959	372104
27214	43785	1	applied	\N	\N	\N	\N	204960	204960	372105
27214	43786	2	applied	\N	\N	\N	\N	204961	204961	372106
27214	43787	3	applied	\N	\N	\N	\N	204962	204962	372107
27214	43788	4	applied	\N	\N	\N	\N	204963	204963	372108
27214	43789	5	applied	\N	\N	\N	\N	204964	204964	372109
27214	43790	6	applied	\N	\N	\N	\N	204965	204965	372110
27214	43791	7	applied	\N	\N	\N	\N	204966	204966	372111
27214	43792	8	applied	\N	\N	\N	\N	204967	204967	372112
27214	43793	9	applied	\N	\N	\N	\N	204968	204968	372113
27214	43794	10	applied	\N	\N	\N	\N	204969	204969	372114
27214	43795	11	applied	\N	\N	\N	\N	204970	204970	372115
27214	43796	12	applied	\N	\N	\N	\N	204971	204971	372116
27214	43797	13	applied	\N	\N	\N	\N	204972	204972	372117
27214	43799	15	applied	\N	\N	\N	\N	204974	204974	372119
27214	43800	16	applied	\N	\N	\N	\N	204975	204975	372120
27214	43801	17	applied	\N	\N	\N	\N	204976	204976	372121
27214	43802	18	applied	\N	\N	\N	\N	204977	204977	372122
27214	43803	19	applied	\N	\N	\N	\N	204978	204978	372123
27214	43804	20	applied	\N	\N	\N	\N	204979	204979	372124
27219	43805	0	applied	\N	\N	\N	\N	205088	205088	372233
27219	43806	1	applied	\N	\N	\N	\N	205089	205089	372234
27219	43811	2	applied	\N	\N	\N	\N	205090	205090	372235
27219	43807	3	applied	\N	\N	\N	\N	205091	205091	372236
27219	43808	4	applied	\N	\N	\N	\N	205092	205092	372237
27219	43812	5	applied	\N	\N	\N	\N	205093	205093	372238
27219	43809	6	applied	\N	\N	\N	\N	205094	205094	372239
27219	43810	7	applied	\N	\N	\N	\N	205095	205095	372240
27219	43813	8	applied	\N	\N	\N	\N	205096	205096	372241
27223	43817	0	applied	\N	\N	\N	\N	205106	205106	372251
27223	43819	2	applied	\N	\N	\N	\N	205108	205108	372253
27230	43826	0	applied	\N	\N	\N	\N	205133	205133	372278
27230	43827	1	applied	\N	\N	\N	\N	205134	205134	372279
27230	43828	2	applied	\N	\N	\N	\N	205135	205135	372280
27237	43832	0	applied	\N	\N	\N	\N	205152	205152	372297
27237	43834	1	applied	\N	\N	\N	\N	205153	205153	372298
27246	43757	0	applied	\N	\N	1000000000	\N	205182	205182	372327
27249	43855	0	applied	\N	\N	\N	\N	205189	205189	372334
27249	43856	1	applied	\N	\N	\N	\N	205190	205190	372335
27249	43857	2	applied	\N	\N	\N	\N	205191	205191	372336
27253	43858	0	applied	\N	\N	\N	\N	205323	205323	372468
27253	43859	1	applied	\N	\N	\N	\N	205324	205324	372469
27253	43860	2	applied	\N	\N	\N	\N	205325	205325	372470
27255	43864	0	applied	\N	\N	\N	\N	205329	205329	372474
27255	43865	1	applied	\N	\N	\N	\N	205330	205330	372475
27255	43866	2	applied	\N	\N	\N	\N	205331	205331	372476
27263	43871	1	applied	\N	\N	\N	\N	205342	205342	372487
27268	43873	0	applied	\N	\N	\N	\N	205352	205352	372497
27268	43874	1	applied	\N	\N	\N	\N	205353	205353	372498
27268	43875	2	applied	\N	\N	\N	\N	205354	205354	372499
27273	43876	0	applied	\N	\N	\N	\N	205460	205460	372605
27273	43877	1	applied	\N	\N	\N	\N	205461	205461	372606
27273	43878	2	applied	\N	\N	\N	\N	205462	205462	372607
27273	43879	3	applied	\N	\N	\N	\N	205463	205463	372608
27273	43880	4	applied	\N	\N	\N	\N	205464	205464	372609
27273	43881	5	applied	\N	\N	\N	\N	205465	205465	372610
27276	43882	0	applied	\N	\N	\N	\N	205475	205475	372620
27276	43883	1	applied	\N	\N	\N	\N	205476	205476	372621
27276	43884	2	applied	\N	\N	\N	\N	205477	205477	372622
27278	43885	0	applied	\N	\N	\N	\N	205481	205481	372626
27278	43886	1	applied	\N	\N	\N	\N	205482	205482	372627
27278	43887	2	applied	\N	\N	\N	\N	205483	205483	372628
27283	43878	1	applied	\N	\N	\N	\N	205499	205499	372644
27283	43879	2	applied	\N	\N	\N	\N	205500	205500	372645
27283	43883	3	applied	\N	\N	\N	\N	205501	205501	372646
27283	43886	4	applied	\N	\N	\N	\N	205502	205502	372647
27283	43890	5	applied	\N	\N	\N	\N	205503	205503	372648
27283	43896	6	applied	\N	\N	\N	\N	205504	205504	372649
27283	43898	7	applied	\N	\N	\N	\N	205505	205505	372650
27283	43899	8	applied	\N	\N	\N	\N	205506	205506	372651
27283	43900	9	applied	\N	\N	\N	\N	205507	205507	372652
27286	43907	0	applied	\N	\N	\N	\N	205637	205637	372782
27286	43908	1	applied	\N	\N	\N	\N	205638	205638	372783
27290	43909	0	applied	\N	\N	\N	\N	205644	205644	372789
27290	43910	1	applied	\N	\N	\N	\N	205645	205645	372790
27291	43909	0	applied	\N	\N	\N	\N	205646	205646	372791
27291	43910	1	applied	\N	\N	\N	\N	205647	205647	372792
27293	43911	0	applied	\N	\N	\N	\N	205650	205650	372795
27195	43657	102	applied	\N	\N	\N	\N	204780	204780	371925
27210	43779	1	applied	\N	\N	\N	\N	204862	204862	372007
27210	43780	2	applied	\N	\N	\N	\N	204863	204863	372008
27212	43783	2	applied	\N	\N	\N	\N	204869	204869	372014
27213	43562	0	applied	\N	\N	\N	\N	204870	204870	372015
27213	43565	1	applied	\N	\N	\N	\N	204871	204871	372016
27213	43567	2	applied	\N	\N	\N	\N	204872	204872	372017
27213	43570	3	applied	\N	\N	\N	\N	204873	204873	372018
27213	43573	4	applied	\N	\N	\N	\N	204874	204874	372019
27213	43576	5	applied	\N	\N	\N	\N	204875	204875	372020
27213	43579	6	applied	\N	\N	\N	\N	204876	204876	372021
27213	43582	7	applied	\N	\N	\N	\N	204877	204877	372022
27213	43588	9	applied	\N	\N	\N	\N	204879	204879	372024
27213	43593	10	applied	\N	\N	\N	\N	204880	204880	372025
27213	43596	11	applied	\N	\N	\N	\N	204881	204881	372026
27213	43599	12	applied	\N	\N	\N	\N	204882	204882	372027
27213	43602	13	applied	\N	\N	\N	\N	204883	204883	372028
27213	43605	14	applied	\N	\N	\N	\N	204884	204884	372029
27213	43608	15	applied	\N	\N	\N	\N	204885	204885	372030
27213	43609	16	applied	\N	\N	\N	\N	204886	204886	372031
27213	43610	17	applied	\N	\N	\N	\N	204887	204887	372032
27213	43617	18	applied	\N	\N	\N	\N	204888	204888	372033
27213	43620	19	applied	\N	\N	\N	\N	204889	204889	372034
27213	43623	20	applied	\N	\N	\N	\N	204890	204890	372035
27213	43626	21	applied	\N	\N	\N	\N	204891	204891	372036
27213	43629	22	applied	\N	\N	\N	\N	204892	204892	372037
27213	43630	23	applied	\N	\N	\N	\N	204893	204893	372038
27213	43631	24	applied	\N	\N	\N	\N	204894	204894	372039
27213	43646	26	applied	\N	\N	\N	\N	204896	204896	372041
27213	43647	27	applied	\N	\N	\N	\N	204897	204897	372042
27213	43648	28	applied	\N	\N	\N	\N	204898	204898	372043
27213	43649	29	applied	\N	\N	\N	\N	204899	204899	372044
27213	43652	30	applied	\N	\N	\N	\N	204900	204900	372045
27213	43655	31	applied	\N	\N	\N	\N	204901	204901	372046
27213	43656	32	applied	\N	\N	\N	\N	204902	204902	372047
27213	43661	33	applied	\N	\N	\N	\N	204903	204903	372048
27213	43664	34	applied	\N	\N	\N	\N	204904	204904	372049
27213	43665	35	applied	\N	\N	\N	\N	204905	204905	372050
27213	43666	36	applied	\N	\N	\N	\N	204906	204906	372051
27213	43673	37	applied	\N	\N	\N	\N	204907	204907	372052
27213	43676	38	applied	\N	\N	\N	\N	204908	204908	372053
27213	43679	39	applied	\N	\N	\N	\N	204909	204909	372054
27213	43682	40	applied	\N	\N	\N	\N	204910	204910	372055
27213	43685	41	applied	\N	\N	\N	\N	204911	204911	372056
27213	43690	43	applied	\N	\N	\N	\N	204913	204913	372058
27213	43693	44	applied	\N	\N	\N	\N	204914	204914	372059
27213	43696	45	applied	\N	\N	\N	\N	204915	204915	372060
27213	43699	46	applied	\N	\N	\N	\N	204916	204916	372061
27213	43702	47	applied	\N	\N	\N	\N	204917	204917	372062
27213	43705	48	applied	\N	\N	\N	\N	204918	204918	372063
27213	43708	49	applied	\N	\N	\N	\N	204919	204919	372064
27213	43709	50	applied	\N	\N	\N	\N	204920	204920	372065
27213	43714	51	applied	\N	\N	\N	\N	204921	204921	372066
27213	43715	52	applied	\N	\N	\N	\N	204922	204922	372067
27213	43720	53	applied	\N	\N	\N	\N	204923	204923	372068
27213	43723	54	applied	\N	\N	\N	\N	204924	204924	372069
27213	43724	55	applied	\N	\N	\N	\N	204925	204925	372070
27213	43729	56	applied	\N	\N	\N	\N	204926	204926	372071
27213	43732	57	applied	\N	\N	\N	\N	204927	204927	372072
27213	43735	59	applied	\N	\N	\N	\N	204928	204928	372073
27213	43739	61	applied	\N	\N	\N	\N	204930	204930	372075
27213	43744	62	applied	\N	\N	\N	\N	204931	204931	372076
27213	43746	63	applied	\N	\N	\N	\N	204932	204932	372077
27213	43748	64	applied	\N	\N	\N	\N	204933	204933	372078
27213	43752	65	applied	\N	\N	\N	\N	204934	204934	372079
27213	43755	66	applied	\N	\N	\N	\N	204935	204935	372080
27213	43760	67	applied	\N	\N	\N	\N	204936	204936	372081
27213	43763	68	applied	\N	\N	\N	\N	204937	204937	372082
27213	43764	69	applied	\N	\N	\N	\N	204938	204938	372083
27213	43770	70	applied	\N	\N	\N	\N	204939	204939	372084
27213	43773	71	applied	\N	\N	\N	\N	204940	204940	372085
27213	43774	72	applied	\N	\N	\N	\N	204941	204941	372086
27213	43778	73	applied	\N	\N	\N	\N	204942	204942	372087
27213	43781	74	applied	\N	\N	\N	\N	204943	204943	372088
27213	43784	75	applied	\N	\N	\N	\N	204944	204944	372089
27213	43785	76	applied	\N	\N	\N	\N	204945	204945	372090
27213	43787	78	applied	\N	\N	\N	\N	204947	204947	372092
27213	43788	79	applied	\N	\N	\N	\N	204948	204948	372093
27213	43757	80	applied	\N	\N	1000000000	\N	204949	204949	372094
27213	43759	81	applied	\N	\N	1000000000	\N	204950	204950	372095
27213	43766	82	applied	\N	\N	1000000000	\N	204951	204951	372096
27213	43255	83	applied	\N	\N	\N	\N	204952	204952	372097
27213	43258	84	applied	\N	\N	\N	\N	204953	204953	372098
27213	43260	85	applied	\N	\N	\N	\N	204954	204954	372099
27213	43264	86	applied	\N	\N	\N	\N	204955	204955	372100
27213	43267	87	applied	\N	\N	\N	\N	204956	204956	372101
27213	43270	88	applied	\N	\N	\N	\N	204957	204957	372102
27213	43275	89	applied	\N	\N	\N	\N	204958	204958	372103
27215	43784	0	applied	\N	\N	\N	\N	204980	204980	372125
27215	43785	1	applied	\N	\N	\N	\N	204981	204981	372126
27215	43786	2	applied	\N	\N	\N	\N	204982	204982	372127
27215	43787	3	applied	\N	\N	\N	\N	204983	204983	372128
27215	43789	5	applied	\N	\N	\N	\N	204985	204985	372130
27215	43790	6	applied	\N	\N	\N	\N	204986	204986	372131
27215	43791	7	applied	\N	\N	\N	\N	204987	204987	372132
27215	43792	8	applied	\N	\N	\N	\N	204988	204988	372133
27215	43793	9	applied	\N	\N	\N	\N	204989	204989	372134
27215	43794	10	applied	\N	\N	\N	\N	204990	204990	372135
27215	43795	11	applied	\N	\N	\N	\N	204991	204991	372136
27215	43796	12	applied	\N	\N	\N	\N	204992	204992	372137
27215	43797	13	applied	\N	\N	\N	\N	204993	204993	372138
27215	43798	14	applied	\N	\N	\N	\N	204994	204994	372139
27215	43799	15	applied	\N	\N	\N	\N	204995	204995	372140
27215	43800	16	applied	\N	\N	\N	\N	204996	204996	372141
27218	43805	0	applied	\N	\N	\N	\N	205079	205079	372224
27218	43806	1	applied	\N	\N	\N	\N	205080	205080	372225
27218	43811	2	applied	\N	\N	\N	\N	205081	205081	372226
27218	43807	3	applied	\N	\N	\N	\N	205082	205082	372227
27218	43812	5	applied	\N	\N	\N	\N	205084	205084	372229
27218	43809	6	applied	\N	\N	\N	\N	205085	205085	372230
27207	43777	4	applied	\N	\N	\N	\N	204857	204857	372002
27210	43778	0	applied	\N	\N	\N	\N	204861	204861	372006
27217	43805	0	applied	\N	\N	\N	\N	205070	205070	372215
27217	43806	1	applied	\N	\N	\N	\N	205071	205071	372216
27217	43811	2	applied	\N	\N	\N	\N	205072	205072	372217
27217	43807	3	applied	\N	\N	\N	\N	205073	205073	372218
27218	43810	7	applied	\N	\N	\N	\N	205086	205086	372231
27218	43813	8	applied	\N	\N	\N	\N	205087	205087	372232
27220	43814	0	applied	\N	\N	\N	\N	205097	205097	372242
27220	43815	1	applied	\N	\N	\N	\N	205098	205098	372243
27220	43816	2	applied	\N	\N	\N	\N	205099	205099	372244
27225	43817	0	applied	\N	\N	\N	\N	205112	205112	372257
27225	43818	1	applied	\N	\N	\N	\N	205113	205113	372258
27225	43819	2	applied	\N	\N	\N	\N	205114	205114	372259
27226	43817	0	applied	\N	\N	\N	\N	205115	205115	372260
27226	43818	1	applied	\N	\N	\N	\N	205116	205116	372261
27231	43829	0	applied	\N	\N	\N	\N	205136	205136	372281
27231	43830	1	applied	\N	\N	\N	\N	205137	205137	372282
27231	43831	2	applied	\N	\N	\N	\N	205138	205138	372283
27240	43844	0	applied	\N	\N	\N	\N	205163	205163	372308
27240	43845	1	applied	\N	\N	\N	\N	205164	205164	372309
27243	43848	0	applied	\N	\N	\N	\N	205171	205171	372316
27243	43849	1	applied	\N	\N	\N	\N	205172	205172	372317
27243	43850	2	applied	\N	\N	\N	\N	205173	205173	372318
27243	43851	3	applied	\N	\N	1000000000	\N	205174	205174	372319
27245	43852	0	applied	\N	\N	\N	\N	205179	205179	372324
27245	43853	1	applied	\N	\N	\N	\N	205180	205180	372325
27245	43854	2	applied	\N	\N	\N	\N	205181	205181	372326
27247	43855	0	applied	\N	\N	\N	\N	205183	205183	372328
27247	43856	1	applied	\N	\N	\N	\N	205184	205184	372329
27247	43857	2	applied	\N	\N	\N	\N	205185	205185	372330
27250	43855	0	applied	\N	\N	\N	\N	205192	205192	372337
27250	43857	2	applied	\N	\N	\N	\N	205194	205194	372339
27251	43588	0	applied	\N	\N	\N	\N	205195	205195	372340
27251	43593	1	applied	\N	\N	\N	\N	205196	205196	372341
27251	43596	2	applied	\N	\N	\N	\N	205197	205197	372342
27251	43599	3	applied	\N	\N	\N	\N	205198	205198	372343
27251	43602	4	applied	\N	\N	\N	\N	205199	205199	372344
27251	43605	5	applied	\N	\N	\N	\N	205200	205200	372345
27251	43608	6	applied	\N	\N	\N	\N	205201	205201	372346
27251	43609	7	applied	\N	\N	\N	\N	205202	205202	372347
27251	43610	8	applied	\N	\N	\N	\N	205203	205203	372348
27251	43617	9	applied	\N	\N	\N	\N	205204	205204	372349
27251	43620	10	applied	\N	\N	\N	\N	205205	205205	372350
27251	43623	11	applied	\N	\N	\N	\N	205206	205206	372351
27251	43626	12	applied	\N	\N	\N	\N	205207	205207	372352
27251	43629	13	applied	\N	\N	\N	\N	205208	205208	372353
27251	43630	14	applied	\N	\N	\N	\N	205209	205209	372354
27251	43637	16	applied	\N	\N	\N	\N	205211	205211	372356
27251	43646	17	applied	\N	\N	\N	\N	205212	205212	372357
27251	43647	18	applied	\N	\N	\N	\N	205213	205213	372358
27251	43648	19	applied	\N	\N	\N	\N	205214	205214	372359
27251	43649	20	applied	\N	\N	\N	\N	205215	205215	372360
27251	43652	21	applied	\N	\N	\N	\N	205216	205216	372361
27251	43655	22	applied	\N	\N	\N	\N	205217	205217	372362
27251	43656	23	applied	\N	\N	\N	\N	205218	205218	372363
27251	43661	24	applied	\N	\N	\N	\N	205219	205219	372364
27251	43664	25	applied	\N	\N	\N	\N	205220	205220	372365
27251	43665	26	applied	\N	\N	\N	\N	205221	205221	372366
27251	43666	27	applied	\N	\N	\N	\N	205222	205222	372367
27251	43673	28	applied	\N	\N	\N	\N	205223	205223	372368
27251	43676	29	applied	\N	\N	\N	\N	205224	205224	372369
27251	43679	30	applied	\N	\N	\N	\N	205225	205225	372370
27251	43682	31	applied	\N	\N	\N	\N	205226	205226	372371
27251	43686	33	applied	\N	\N	\N	\N	205228	205228	372373
27251	43690	34	applied	\N	\N	\N	\N	205229	205229	372374
27251	43693	35	applied	\N	\N	\N	\N	205230	205230	372375
27251	43696	36	applied	\N	\N	\N	\N	205231	205231	372376
27251	43699	37	applied	\N	\N	\N	\N	205232	205232	372377
27251	43702	38	applied	\N	\N	\N	\N	205233	205233	372378
27251	43705	39	applied	\N	\N	\N	\N	205234	205234	372379
27251	43708	40	applied	\N	\N	\N	\N	205235	205235	372380
27251	43709	41	applied	\N	\N	\N	\N	205236	205236	372381
27251	43714	42	applied	\N	\N	\N	\N	205237	205237	372382
27251	43715	43	applied	\N	\N	\N	\N	205238	205238	372383
27251	43720	44	applied	\N	\N	\N	\N	205239	205239	372384
27251	43723	45	applied	\N	\N	\N	\N	205240	205240	372385
27251	43724	46	applied	\N	\N	\N	\N	205241	205241	372386
27251	43729	47	applied	\N	\N	\N	\N	205242	205242	372387
27251	43732	48	applied	\N	\N	\N	\N	205243	205243	372388
27251	43738	50	applied	\N	\N	\N	\N	205245	205245	372390
27251	43739	51	applied	\N	\N	\N	\N	205246	205246	372391
27251	43744	52	applied	\N	\N	\N	\N	205247	205247	372392
27251	43746	53	applied	\N	\N	\N	\N	205248	205248	372393
27251	43748	54	applied	\N	\N	\N	\N	205249	205249	372394
27251	43752	55	applied	\N	\N	\N	\N	205250	205250	372395
27251	43755	56	applied	\N	\N	\N	\N	205251	205251	372396
27251	43760	57	applied	\N	\N	\N	\N	205252	205252	372397
27251	43763	58	applied	\N	\N	\N	\N	205253	205253	372398
27251	43764	59	applied	\N	\N	\N	\N	205254	205254	372399
27251	43770	60	applied	\N	\N	\N	\N	205255	205255	372400
27251	43773	61	applied	\N	\N	\N	\N	205256	205256	372401
27251	43774	62	applied	\N	\N	\N	\N	205257	205257	372402
27251	43778	63	applied	\N	\N	\N	\N	205258	205258	372403
27251	43781	64	applied	\N	\N	\N	\N	205259	205259	372404
27251	43784	65	applied	\N	\N	\N	\N	205260	205260	372405
27251	43786	67	applied	\N	\N	\N	\N	205262	205262	372407
27251	43787	68	applied	\N	\N	\N	\N	205263	205263	372408
27251	43788	69	applied	\N	\N	\N	\N	205264	205264	372409
27251	43789	70	applied	\N	\N	\N	\N	205265	205265	372410
27251	43790	71	applied	\N	\N	\N	\N	205266	205266	372411
27251	43805	72	applied	\N	\N	\N	\N	205267	205267	372412
27251	43806	73	applied	\N	\N	\N	\N	205268	205268	372413
27251	43811	74	applied	\N	\N	\N	\N	205269	205269	372414
27251	43814	75	applied	\N	\N	\N	\N	205270	205270	372415
27251	43817	76	applied	\N	\N	\N	\N	205271	205271	372416
27251	43820	77	applied	\N	\N	\N	\N	205272	205272	372417
27251	43821	78	applied	\N	\N	\N	\N	205273	205273	372418
27251	43826	80	applied	\N	\N	\N	\N	205274	205274	372419
27251	43829	81	applied	\N	\N	\N	\N	205275	205275	372420
27251	43832	82	applied	\N	\N	\N	\N	205276	205276	372421
27251	43835	83	applied	\N	\N	\N	\N	205277	205277	372422
27215	43804	20	applied	\N	\N	\N	\N	205000	205000	372145
27216	43780	51	applied	\N	\N	\N	\N	205051	205051	372196
27216	43782	52	applied	\N	\N	\N	\N	205052	205052	372197
27216	43792	53	applied	\N	\N	\N	\N	205053	205053	372198
27216	43793	54	applied	\N	\N	\N	\N	205054	205054	372199
27216	43794	55	applied	\N	\N	\N	\N	205055	205055	372200
27217	43808	4	applied	\N	\N	\N	\N	205074	205074	372219
27217	43812	5	applied	\N	\N	\N	\N	205075	205075	372220
27217	43809	6	applied	\N	\N	\N	\N	205076	205076	372221
27217	43810	7	applied	\N	\N	\N	\N	205077	205077	372222
27217	43813	8	applied	\N	\N	\N	\N	205078	205078	372223
27222	43814	0	applied	\N	\N	\N	\N	205103	205103	372248
27222	43816	2	applied	\N	\N	\N	\N	205105	205105	372250
27224	43817	0	applied	\N	\N	\N	\N	205109	205109	372254
27224	43818	1	applied	\N	\N	\N	\N	205110	205110	372255
27224	43819	2	applied	\N	\N	\N	\N	205111	205111	372256
27228	43820	0	applied	\N	\N	\N	\N	205121	205121	372266
27228	43821	1	applied	\N	\N	\N	\N	205122	205122	372267
27228	43822	2	applied	\N	\N	\N	\N	205123	205123	372268
27228	43823	3	applied	\N	\N	\N	\N	205124	205124	372269
27228	43824	4	applied	\N	\N	\N	\N	205125	205125	372270
27228	43825	5	applied	\N	\N	\N	\N	205126	205126	372271
27229	43820	0	applied	\N	\N	\N	\N	205127	205127	372272
27229	43821	1	applied	\N	\N	\N	\N	205128	205128	372273
27229	43822	2	applied	\N	\N	\N	\N	205129	205129	372274
27229	43823	3	applied	\N	\N	\N	\N	205130	205130	372275
27229	43824	4	applied	\N	\N	\N	\N	205131	205131	372276
27229	43825	5	applied	\N	\N	\N	\N	205132	205132	372277
27233	43830	1	applied	\N	\N	\N	\N	205143	205143	372288
27233	43831	2	applied	\N	\N	\N	\N	205144	205144	372289
27235	43829	0	applied	\N	\N	\N	\N	205148	205148	372293
27239	43835	0	applied	\N	\N	\N	\N	205154	205154	372299
27239	43836	1	applied	\N	\N	\N	\N	205155	205155	372300
27239	43837	2	applied	\N	\N	\N	\N	205156	205156	372301
27239	43838	3	applied	\N	\N	\N	\N	205157	205157	372302
27239	43839	4	applied	\N	\N	1000000000	\N	205158	205158	372303
27239	43840	5	applied	\N	\N	1000000000	\N	205159	205159	372304
27239	43841	6	applied	\N	\N	\N	\N	205160	205160	372305
27239	43842	7	applied	\N	\N	\N	\N	205161	205161	372306
27239	43843	8	applied	\N	\N	\N	\N	205162	205162	372307
27242	43848	0	applied	\N	\N	\N	\N	205167	205167	372312
27242	43849	1	applied	\N	\N	\N	\N	205168	205168	372313
27242	43850	2	applied	\N	\N	\N	\N	205169	205169	372314
27256	43864	0	applied	\N	\N	\N	\N	205332	205332	372477
27256	43865	1	applied	\N	\N	\N	\N	205333	205333	372478
27256	43866	2	applied	\N	\N	\N	\N	205334	205334	372479
27264	43870	0	applied	\N	\N	\N	\N	205343	205343	372488
27264	43871	1	applied	\N	\N	\N	\N	205344	205344	372489
27264	43872	2	applied	\N	\N	\N	\N	205345	205345	372490
27269	43664	0	applied	\N	\N	\N	\N	205355	205355	372500
27269	43665	1	applied	\N	\N	\N	\N	205356	205356	372501
27269	43666	2	applied	\N	\N	\N	\N	205357	205357	372502
27269	43667	3	applied	\N	\N	\N	\N	205358	205358	372503
27269	43668	4	applied	\N	\N	\N	\N	205359	205359	372504
27269	43669	5	applied	\N	\N	\N	\N	205360	205360	372505
27269	43670	6	applied	\N	\N	\N	\N	205361	205361	372506
27269	43671	7	applied	\N	\N	\N	\N	205362	205362	372507
27269	43674	8	applied	\N	\N	\N	\N	205363	205363	372508
27269	43678	9	applied	\N	\N	\N	\N	205364	205364	372509
27269	43680	10	applied	\N	\N	\N	\N	205365	205365	372510
27269	43684	11	applied	\N	\N	\N	\N	205366	205366	372511
27269	43687	12	applied	\N	\N	\N	\N	205367	205367	372512
27269	43694	14	applied	\N	\N	\N	\N	205369	205369	372514
27269	43698	15	applied	\N	\N	\N	\N	205370	205370	372515
27269	43701	16	applied	\N	\N	\N	\N	205371	205371	372516
27269	43703	17	applied	\N	\N	\N	\N	205372	205372	372517
27269	43707	18	applied	\N	\N	\N	\N	205373	205373	372518
27269	43710	19	applied	\N	\N	\N	\N	205374	205374	372519
27269	43711	20	applied	\N	\N	\N	\N	205375	205375	372520
27269	43716	21	applied	\N	\N	\N	\N	205376	205376	372521
27269	43719	22	applied	\N	\N	\N	\N	205377	205377	372522
27269	43722	23	applied	\N	\N	\N	\N	205378	205378	372523
27269	43726	24	applied	\N	\N	\N	\N	205379	205379	372524
27269	43727	25	applied	\N	\N	\N	\N	205380	205380	372525
27269	43730	26	applied	\N	\N	\N	\N	205381	205381	372526
27269	43734	27	applied	\N	\N	\N	\N	205382	205382	372527
27269	43736	28	applied	\N	\N	\N	\N	205383	205383	372528
27269	43742	29	applied	\N	\N	\N	\N	205384	205384	372529
27269	43745	31	applied	\N	\N	\N	\N	205386	205386	372531
27269	43747	32	applied	\N	\N	\N	\N	205387	205387	372532
27269	43751	33	applied	\N	\N	\N	\N	205388	205388	372533
27269	43754	34	applied	\N	\N	\N	\N	205389	205389	372534
27269	43672	35	applied	\N	\N	\N	\N	205390	205390	372535
27269	43675	36	applied	\N	\N	\N	\N	205391	205391	372536
27269	43677	37	applied	\N	\N	\N	\N	205392	205392	372537
27269	43681	38	applied	\N	\N	\N	\N	205393	205393	372538
27269	43683	39	applied	\N	\N	\N	\N	205394	205394	372539
27269	43688	40	applied	\N	\N	\N	\N	205395	205395	372540
27269	43689	41	applied	\N	\N	\N	\N	205396	205396	372541
27269	43692	42	applied	\N	\N	\N	\N	205397	205397	372542
27269	43695	43	applied	\N	\N	\N	\N	205398	205398	372543
27269	43697	44	applied	\N	\N	\N	\N	205399	205399	372544
27269	43700	45	applied	\N	\N	\N	\N	205400	205400	372545
27269	43704	46	applied	\N	\N	\N	\N	205401	205401	372546
27269	43712	48	applied	\N	\N	\N	\N	205403	205403	372548
27269	43713	49	applied	\N	\N	\N	\N	205404	205404	372549
27269	43717	50	applied	\N	\N	\N	\N	205405	205405	372550
27269	43718	51	applied	\N	\N	\N	\N	205406	205406	372551
27269	43721	52	applied	\N	\N	\N	\N	205407	205407	372552
27269	43725	53	applied	\N	\N	\N	\N	205408	205408	372553
27269	43728	54	applied	\N	\N	\N	\N	205409	205409	372554
27269	43731	55	applied	\N	\N	\N	\N	205410	205410	372555
27269	43733	56	applied	\N	\N	\N	\N	205411	205411	372556
27269	43737	57	applied	\N	\N	\N	\N	205412	205412	372557
27269	43740	58	applied	\N	\N	\N	\N	205413	205413	372558
27269	43741	59	applied	\N	\N	\N	\N	205414	205414	372559
27269	43749	60	applied	\N	\N	\N	\N	205415	205415	372560
27269	43750	61	applied	\N	\N	\N	\N	205416	205416	372561
27269	43753	62	applied	\N	\N	\N	\N	205417	205417	372562
27281	43891	0	applied	\N	\N	\N	\N	205487	205487	372632
27216	43783	49	applied	\N	\N	\N	\N	205049	205049	372194
27216	43791	50	applied	\N	\N	\N	\N	205050	205050	372195
27216	43807	60	applied	\N	\N	\N	\N	205060	205060	372205
27216	43808	61	applied	\N	\N	\N	\N	205061	205061	372206
27216	43799	62	applied	\N	\N	\N	\N	205062	205062	372207
27216	43800	63	applied	\N	\N	\N	\N	205063	205063	372208
27216	43801	64	applied	\N	\N	\N	\N	205064	205064	372209
27216	43802	65	applied	\N	\N	\N	\N	205065	205065	372210
27216	43803	66	applied	\N	\N	\N	\N	205066	205066	372211
27216	43804	67	applied	\N	\N	\N	\N	205067	205067	372212
27216	43809	68	applied	\N	\N	\N	\N	205068	205068	372213
27216	43810	69	applied	\N	\N	\N	\N	205069	205069	372214
27221	43814	0	applied	\N	\N	\N	\N	205100	205100	372245
27221	43815	1	applied	\N	\N	\N	\N	205101	205101	372246
27221	43816	2	applied	\N	\N	\N	\N	205102	205102	372247
27227	43817	0	applied	\N	\N	\N	\N	205118	205118	372263
27227	43819	2	applied	\N	\N	\N	\N	205120	205120	372265
27232	43829	0	applied	\N	\N	\N	\N	205139	205139	372284
27232	43830	1	applied	\N	\N	\N	\N	205140	205140	372285
27232	43831	2	applied	\N	\N	\N	\N	205141	205141	372286
27234	43829	0	applied	\N	\N	\N	\N	205145	205145	372290
27234	43830	1	applied	\N	\N	\N	\N	205146	205146	372291
27234	43831	2	applied	\N	\N	\N	\N	205147	205147	372292
27236	43832	0	applied	\N	\N	\N	\N	205149	205149	372294
27236	43833	1	applied	\N	\N	\N	\N	205150	205150	372295
27236	43834	2	applied	\N	\N	\N	\N	205151	205151	372296
27241	43846	0	applied	\N	\N	\N	\N	205165	205165	372310
27241	43847	1	applied	\N	\N	\N	\N	205166	205166	372311
27244	43848	0	applied	\N	\N	\N	\N	205175	205175	372320
27244	43849	1	applied	\N	\N	\N	\N	205176	205176	372321
27244	43850	2	applied	\N	\N	\N	\N	205177	205177	372322
27248	43855	0	applied	\N	\N	\N	\N	205186	205186	372331
27248	43856	1	applied	\N	\N	\N	\N	205187	205187	372332
27248	43857	2	applied	\N	\N	\N	\N	205188	205188	372333
27251	43836	84	applied	\N	\N	\N	\N	205278	205278	372423
27251	43837	85	applied	\N	\N	\N	\N	205279	205279	372424
27251	43844	86	applied	\N	\N	\N	\N	205280	205280	372425
27251	43846	87	applied	\N	\N	\N	\N	205281	205281	372426
27251	43848	88	applied	\N	\N	\N	\N	205282	205282	372427
27251	43852	89	applied	\N	\N	\N	\N	205283	205283	372428
27251	43855	90	applied	\N	\N	\N	\N	205284	205284	372429
27252	43858	0	applied	\N	\N	\N	\N	205320	205320	372465
27252	43859	1	applied	\N	\N	\N	\N	205321	205321	372466
27252	43860	2	applied	\N	\N	\N	\N	205322	205322	372467
27254	43861	0	applied	\N	\N	\N	\N	205326	205326	372471
27254	43862	1	applied	\N	\N	\N	\N	205327	205327	372472
27254	43863	2	applied	\N	\N	\N	\N	205328	205328	372473
27258	43867	0	applied	\N	\N	\N	\N	205335	205335	372480
27258	43868	1	applied	\N	\N	\N	\N	205336	205336	372481
27258	43869	2	applied	\N	\N	\N	\N	205337	205337	372482
27265	43871	1	applied	\N	\N	\N	\N	205347	205347	372492
27265	43872	2	applied	\N	\N	\N	\N	205348	205348	372493
27266	43870	0	applied	\N	\N	\N	\N	205349	205349	372494
27266	43871	1	applied	\N	\N	\N	\N	205350	205350	372495
27266	43872	2	applied	\N	\N	\N	\N	205351	205351	372496
27270	43758	0	applied	\N	\N	\N	\N	205418	205418	372563
27270	43761	1	applied	\N	\N	\N	\N	205419	205419	372564
27270	43767	2	applied	\N	\N	\N	\N	205420	205420	372565
27270	43768	3	applied	\N	\N	\N	\N	205421	205421	372566
27270	43771	4	applied	\N	\N	\N	\N	205422	205422	372567
27270	43776	5	applied	\N	\N	\N	\N	205423	205423	372568
27270	43777	6	applied	\N	\N	\N	\N	205424	205424	372569
27270	43779	7	applied	\N	\N	\N	\N	205425	205425	372570
27270	43783	8	applied	\N	\N	\N	\N	205426	205426	372571
27270	43791	9	applied	\N	\N	\N	\N	205427	205427	372572
27270	43799	10	applied	\N	\N	\N	\N	205428	205428	372573
27270	43801	12	applied	\N	\N	\N	\N	205430	205430	372575
27270	43802	13	applied	\N	\N	\N	\N	205431	205431	372576
27270	43803	14	applied	\N	\N	\N	\N	205432	205432	372577
27270	43804	15	applied	\N	\N	\N	\N	205433	205433	372578
27270	43809	16	applied	\N	\N	\N	\N	205434	205434	372579
27270	43810	17	applied	\N	\N	\N	\N	205435	205435	372580
27270	43813	18	applied	\N	\N	\N	\N	205436	205436	372581
27270	43816	19	applied	\N	\N	\N	\N	205437	205437	372582
27270	43819	20	applied	\N	\N	\N	\N	205438	205438	372583
27270	43822	21	applied	\N	\N	\N	\N	205439	205439	372584
27270	43823	22	applied	\N	\N	\N	\N	205440	205440	372585
27270	43828	23	applied	\N	\N	\N	\N	205441	205441	372586
27270	43830	25	applied	\N	\N	\N	\N	205442	205442	372587
27270	43833	26	applied	\N	\N	\N	\N	205443	205443	372588
27270	43841	27	applied	\N	\N	\N	\N	205444	205444	372589
27270	43842	28	applied	\N	\N	\N	\N	205445	205445	372590
27270	43845	30	applied	\N	\N	\N	\N	205447	205447	372592
27270	43847	31	applied	\N	\N	\N	\N	205448	205448	372593
27270	43849	32	applied	\N	\N	\N	\N	205449	205449	372594
27270	43854	33	applied	\N	\N	\N	\N	205450	205450	372595
27270	43857	34	applied	\N	\N	\N	\N	205451	205451	372596
27270	43860	35	applied	\N	\N	\N	\N	205452	205452	372597
27270	43863	36	applied	\N	\N	\N	\N	205453	205453	372598
27270	43865	37	applied	\N	\N	\N	\N	205454	205454	372599
27270	43868	38	applied	\N	\N	\N	\N	205455	205455	372600
27270	43872	39	applied	\N	\N	\N	\N	205456	205456	372601
27274	43876	0	applied	\N	\N	\N	\N	205466	205466	372611
27274	43877	1	applied	\N	\N	\N	\N	205467	205467	372612
27274	43878	2	applied	\N	\N	\N	\N	205468	205468	372613
27274	43879	3	applied	\N	\N	\N	\N	205469	205469	372614
27274	43880	4	applied	\N	\N	\N	\N	205470	205470	372615
27274	43881	5	applied	\N	\N	\N	\N	205471	205471	372616
27279	43889	1	applied	\N	\N	\N	\N	205485	205485	372630
27279	43890	2	applied	\N	\N	\N	\N	205486	205486	372631
27282	43900	0	applied	\N	\N	\N	\N	205496	205496	372641
27282	43901	1	applied	\N	\N	\N	\N	205497	205497	372642
27284	43576	0	applied	\N	\N	\N	\N	205508	205508	372653
27285	43902	0	applied	\N	\N	\N	\N	205632	205632	372777
27285	43903	1	applied	\N	\N	\N	\N	205633	205633	372778
27285	43904	2	applied	\N	\N	\N	\N	205634	205634	372779
27285	43905	3	applied	\N	\N	\N	\N	205635	205635	372780
27285	43906	4	applied	\N	\N	\N	\N	205636	205636	372781
27288	43907	0	applied	\N	\N	\N	\N	205641	205641	372786
27288	43908	1	applied	\N	\N	\N	\N	205642	205642	372787
27289	43906	0	applied	\N	\N	\N	\N	205643	205643	372788
27294	43913	0	applied	\N	\N	\N	\N	205652	205652	372797
27216	43797	58	applied	\N	\N	\N	\N	205058	205058	372203
27216	43798	59	applied	\N	\N	\N	\N	205059	205059	372204
27251	43591	94	applied	\N	\N	\N	\N	205288	205288	372433
27251	43759	95	applied	\N	\N	1000000000	\N	205289	205289	372434
27251	43595	96	applied	\N	\N	\N	\N	205290	205290	372435
27251	43598	97	applied	\N	\N	\N	\N	205291	205291	372436
27251	43600	98	applied	\N	\N	\N	\N	205292	205292	372437
27251	43603	99	applied	\N	\N	\N	\N	205293	205293	372438
27251	43839	101	applied	\N	\N	1000000000	\N	205295	205295	372440
27251	43840	102	applied	\N	\N	1000000000	\N	205296	205296	372441
27251	43606	103	applied	\N	\N	\N	\N	205297	205297	372442
27251	43851	104	applied	\N	\N	1000000000	\N	205298	205298	372443
27251	43612	105	applied	\N	\N	\N	\N	205299	205299	372444
27251	43613	106	applied	\N	\N	\N	\N	205300	205300	372445
27251	43614	107	applied	\N	\N	\N	\N	205301	205301	372446
27251	43592	108	applied	\N	\N	\N	\N	205302	205302	372447
27251	43594	109	applied	\N	\N	\N	\N	205303	205303	372448
27251	43597	110	applied	\N	\N	\N	\N	205304	205304	372449
27251	43601	111	applied	\N	\N	\N	\N	205305	205305	372450
27251	43604	112	applied	\N	\N	\N	\N	205306	205306	372451
27251	43607	113	applied	\N	\N	\N	\N	205307	205307	372452
27251	43611	114	applied	\N	\N	\N	\N	205308	205308	372453
27251	43615	115	applied	\N	\N	\N	\N	205309	205309	372454
27251	43616	116	applied	\N	\N	\N	\N	205310	205310	372455
27251	43618	117	applied	\N	\N	\N	\N	205311	205311	372456
27251	43622	118	applied	\N	\N	\N	\N	205312	205312	372457
27251	43625	119	applied	\N	\N	\N	\N	205313	205313	372458
27251	43632	121	applied	\N	\N	\N	\N	205315	205315	372460
27251	43633	122	applied	\N	\N	\N	\N	205316	205316	372461
27251	43636	123	applied	\N	\N	\N	\N	205317	205317	372462
27251	43639	124	applied	\N	\N	\N	\N	205318	205318	372463
27251	43619	125	applied	\N	\N	\N	\N	205319	205319	372464
27259	43867	0	applied	\N	\N	\N	\N	205338	205338	372483
27259	43868	1	applied	\N	\N	\N	\N	205339	205339	372484
27259	43869	2	applied	\N	\N	\N	\N	205340	205340	372485
27271	43873	0	applied	\N	\N	\N	\N	205457	205457	372602
27271	43874	1	applied	\N	\N	\N	\N	205458	205458	372603
27271	43875	2	applied	\N	\N	\N	\N	205459	205459	372604
27275	43882	0	applied	\N	\N	\N	\N	205472	205472	372617
27275	43883	1	applied	\N	\N	\N	\N	205473	205473	372618
27275	43884	2	applied	\N	\N	\N	\N	205474	205474	372619
27277	43885	0	applied	\N	\N	\N	\N	205478	205478	372623
27277	43886	1	applied	\N	\N	\N	\N	205479	205479	372624
27281	43893	2	applied	\N	\N	\N	\N	205489	205489	372634
27281	43894	3	applied	\N	\N	\N	\N	205490	205490	372635
27281	43895	4	applied	\N	\N	\N	\N	205491	205491	372636
27281	43896	5	applied	\N	\N	\N	\N	205492	205492	372637
27281	43897	6	applied	\N	\N	\N	\N	205493	205493	372638
27281	43898	7	applied	\N	\N	\N	\N	205494	205494	372639
27281	43899	8	applied	\N	\N	\N	\N	205495	205495	372640
27292	43911	0	applied	\N	\N	\N	\N	205648	205648	372793
27292	43912	1	applied	\N	\N	\N	\N	205649	205649	372794
27295	43917	0	applied	\N	\N	\N	\N	205656	205656	372801
27297	43920	0	applied	\N	\N	\N	\N	205660	205660	372805
27297	43921	1	applied	\N	\N	\N	\N	205661	205661	372806
27297	43922	2	applied	\N	\N	\N	\N	205662	205662	372807
27297	43923	3	applied	\N	\N	\N	\N	205663	205663	372808
27297	43924	4	applied	\N	\N	\N	\N	205664	205664	372809
27297	43925	5	applied	\N	\N	\N	\N	205665	205665	372810
27298	43921	1	applied	\N	\N	\N	\N	205667	205667	372812
27298	43922	2	applied	\N	\N	\N	\N	205668	205668	372813
27298	43923	3	applied	\N	\N	\N	\N	205669	205669	372814
27298	43924	4	applied	\N	\N	\N	\N	205670	205670	372815
27298	43925	5	applied	\N	\N	\N	\N	205671	205671	372816
27305	43941	0	applied	\N	\N	\N	\N	205693	205693	372838
27305	43942	1	applied	\N	\N	\N	\N	205694	205694	372839
27305	43943	2	applied	\N	\N	\N	\N	205695	205695	372840
27308	43944	0	applied	\N	\N	\N	\N	205702	205702	372847
27308	43945	1	applied	\N	\N	\N	\N	205703	205703	372848
27308	43946	2	applied	\N	\N	\N	\N	205704	205704	372849
27309	43944	0	applied	\N	\N	\N	\N	205705	205705	372850
27309	43945	1	applied	\N	\N	\N	\N	205706	205706	372851
27309	43946	2	applied	\N	\N	\N	\N	205707	205707	372852
27314	43956	0	applied	\N	\N	\N	\N	205717	205717	372862
27314	43957	1	applied	\N	\N	\N	\N	205718	205718	372863
27314	43959	3	applied	\N	\N	\N	\N	205720	205720	372865
27314	43960	4	applied	\N	\N	\N	\N	205721	205721	372866
27314	43961	5	applied	\N	\N	\N	\N	205722	205722	372867
27317	43965	0	applied	\N	\N	\N	\N	205729	205729	372874
27317	43966	1	applied	\N	\N	\N	\N	205730	205730	372875
27317	43967	2	applied	\N	\N	\N	\N	205731	205731	372876
27325	43983	0	applied	\N	\N	\N	\N	205765	205765	372910
27325	43984	1	applied	\N	\N	\N	\N	205766	205766	372911
27325	43985	2	applied	\N	\N	\N	\N	205767	205767	372912
27329	43983	0	applied	\N	\N	\N	\N	205777	205777	372922
27329	43984	1	applied	\N	\N	\N	\N	205778	205778	372923
27329	43985	2	applied	\N	\N	\N	\N	205779	205779	372924
27333	43992	0	applied	\N	\N	\N	\N	205789	205789	372934
27333	43993	1	applied	\N	\N	\N	\N	205790	205790	372935
27333	43994	2	applied	\N	\N	\N	\N	205791	205791	372936
27333	43995	3	applied	\N	\N	\N	\N	205792	205792	372937
27336	44000	1	applied	\N	\N	\N	\N	205800	205800	372945
27336	44001	2	applied	\N	\N	\N	\N	205801	205801	372946
27336	44002	3	applied	\N	\N	\N	\N	205802	205802	372947
27336	44003	4	applied	\N	\N	\N	\N	205803	205803	372948
27336	44004	5	applied	\N	\N	\N	\N	205804	205804	372949
27336	44005	6	applied	\N	\N	\N	\N	205805	205805	372950
27336	44006	7	applied	\N	\N	\N	\N	205806	205806	372951
27336	44007	8	applied	\N	\N	\N	\N	205807	205807	372952
27346	44032	0	applied	\N	\N	\N	\N	205838	205838	372983
27346	44033	1	applied	\N	\N	\N	\N	205839	205839	372984
27346	44034	2	applied	\N	\N	\N	\N	205840	205840	372985
27347	44032	0	applied	\N	\N	\N	\N	205841	205841	372986
27347	44033	1	applied	\N	\N	\N	\N	205842	205842	372987
27347	44034	2	applied	\N	\N	\N	\N	205843	205843	372988
27358	44053	0	applied	\N	\N	\N	\N	205901	205901	373046
27358	44054	1	applied	\N	\N	\N	\N	205902	205902	373047
27358	44056	3	applied	\N	\N	\N	\N	205904	205904	373049
27358	44057	4	applied	\N	\N	\N	\N	205905	205905	373050
27358	44058	5	applied	\N	\N	\N	\N	205906	205906	373051
27358	44059	6	applied	\N	\N	\N	\N	205907	205907	373052
27251	43589	92	applied	\N	\N	\N	\N	205286	205286	372431
27251	43590	93	applied	\N	\N	\N	\N	205287	205287	372432
27284	43588	4	applied	\N	\N	\N	\N	205512	205512	372657
27284	43593	5	applied	\N	\N	\N	\N	205513	205513	372658
27284	43596	6	applied	\N	\N	\N	\N	205514	205514	372659
27284	43599	7	applied	\N	\N	\N	\N	205515	205515	372660
27284	43602	8	applied	\N	\N	\N	\N	205516	205516	372661
27284	43608	10	applied	\N	\N	\N	\N	205518	205518	372663
27284	43609	11	applied	\N	\N	\N	\N	205519	205519	372664
27284	43610	12	applied	\N	\N	\N	\N	205520	205520	372665
27284	43617	13	applied	\N	\N	\N	\N	205521	205521	372666
27284	43620	14	applied	\N	\N	\N	\N	205522	205522	372667
27284	43623	15	applied	\N	\N	\N	\N	205523	205523	372668
27284	43626	16	applied	\N	\N	\N	\N	205524	205524	372669
27284	43629	17	applied	\N	\N	\N	\N	205525	205525	372670
27284	43630	18	applied	\N	\N	\N	\N	205526	205526	372671
27284	43631	19	applied	\N	\N	\N	\N	205527	205527	372672
27284	43637	20	applied	\N	\N	\N	\N	205528	205528	372673
27284	43646	21	applied	\N	\N	\N	\N	205529	205529	372674
27284	43647	22	applied	\N	\N	\N	\N	205530	205530	372675
27284	43648	23	applied	\N	\N	\N	\N	205531	205531	372676
27284	43649	24	applied	\N	\N	\N	\N	205532	205532	372677
27284	43652	25	applied	\N	\N	\N	\N	205533	205533	372678
27284	43656	27	applied	\N	\N	\N	\N	205535	205535	372680
27284	43661	28	applied	\N	\N	\N	\N	205536	205536	372681
27284	43664	29	applied	\N	\N	\N	\N	205537	205537	372682
27284	43665	30	applied	\N	\N	\N	\N	205538	205538	372683
27284	43666	31	applied	\N	\N	\N	\N	205539	205539	372684
27284	43673	32	applied	\N	\N	\N	\N	205540	205540	372685
27284	43676	33	applied	\N	\N	\N	\N	205541	205541	372686
27284	43679	34	applied	\N	\N	\N	\N	205542	205542	372687
27284	43682	35	applied	\N	\N	\N	\N	205543	205543	372688
27284	43685	36	applied	\N	\N	\N	\N	205544	205544	372689
27284	43686	37	applied	\N	\N	\N	\N	205545	205545	372690
27284	43690	38	applied	\N	\N	\N	\N	205546	205546	372691
27284	43693	39	applied	\N	\N	\N	\N	205547	205547	372692
27284	43696	40	applied	\N	\N	\N	\N	205548	205548	372693
27284	43699	41	applied	\N	\N	\N	\N	205549	205549	372694
27284	43702	42	applied	\N	\N	\N	\N	205550	205550	372695
27284	43708	44	applied	\N	\N	\N	\N	205552	205552	372697
27284	43709	45	applied	\N	\N	\N	\N	205553	205553	372698
27284	43714	46	applied	\N	\N	\N	\N	205554	205554	372699
27284	43715	47	applied	\N	\N	\N	\N	205555	205555	372700
27284	43720	48	applied	\N	\N	\N	\N	205556	205556	372701
27284	43723	49	applied	\N	\N	\N	\N	205557	205557	372702
27284	43724	50	applied	\N	\N	\N	\N	205558	205558	372703
27284	43729	51	applied	\N	\N	\N	\N	205559	205559	372704
27284	43732	52	applied	\N	\N	\N	\N	205560	205560	372705
27284	43735	53	applied	\N	\N	\N	\N	205561	205561	372706
27284	43738	54	applied	\N	\N	\N	\N	205562	205562	372707
27284	43739	55	applied	\N	\N	\N	\N	205563	205563	372708
27284	43744	56	applied	\N	\N	\N	\N	205564	205564	372709
27284	43746	57	applied	\N	\N	\N	\N	205565	205565	372710
27284	43748	58	applied	\N	\N	\N	\N	205566	205566	372711
27284	43752	59	applied	\N	\N	\N	\N	205567	205567	372712
27284	43760	61	applied	\N	\N	\N	\N	205569	205569	372714
27284	43763	62	applied	\N	\N	\N	\N	205570	205570	372715
27284	43764	63	applied	\N	\N	\N	\N	205571	205571	372716
27284	43770	64	applied	\N	\N	\N	\N	205572	205572	372717
27284	43773	65	applied	\N	\N	\N	\N	205573	205573	372718
27284	43774	66	applied	\N	\N	\N	\N	205574	205574	372719
27284	43778	67	applied	\N	\N	\N	\N	205575	205575	372720
27284	43781	68	applied	\N	\N	\N	\N	205576	205576	372721
27284	43784	69	applied	\N	\N	\N	\N	205577	205577	372722
27284	43785	70	applied	\N	\N	\N	\N	205578	205578	372723
27284	43786	71	applied	\N	\N	\N	\N	205579	205579	372724
27284	43787	72	applied	\N	\N	\N	\N	205580	205580	372725
27284	43788	73	applied	\N	\N	\N	\N	205581	205581	372726
27284	43789	74	applied	\N	\N	\N	\N	205582	205582	372727
27284	43790	75	applied	\N	\N	\N	\N	205583	205583	372728
27284	43805	76	applied	\N	\N	\N	\N	205584	205584	372729
27284	43811	78	applied	\N	\N	\N	\N	205586	205586	372731
27284	43814	79	applied	\N	\N	\N	\N	205587	205587	372732
27284	43817	80	applied	\N	\N	\N	\N	205588	205588	372733
27284	43820	81	applied	\N	\N	\N	\N	205589	205589	372734
27284	43821	82	applied	\N	\N	\N	\N	205590	205590	372735
27284	43826	83	applied	\N	\N	\N	\N	205591	205591	372736
27284	43829	84	applied	\N	\N	\N	\N	205592	205592	372737
27284	43832	85	applied	\N	\N	\N	\N	205593	205593	372738
27284	43835	86	applied	\N	\N	\N	\N	205594	205594	372739
27284	43836	87	applied	\N	\N	\N	\N	205595	205595	372740
27284	43837	88	applied	\N	\N	\N	\N	205596	205596	372741
27284	43844	89	applied	\N	\N	\N	\N	205597	205597	372742
27284	43846	90	applied	\N	\N	\N	\N	205598	205598	372743
27284	43848	91	applied	\N	\N	\N	\N	205599	205599	372744
27284	43852	92	applied	\N	\N	\N	\N	205600	205600	372745
27284	43855	93	applied	\N	\N	\N	\N	205601	205601	372746
27284	43861	95	applied	\N	\N	\N	\N	205603	205603	372748
27284	43864	96	applied	\N	\N	\N	\N	205604	205604	372749
27284	43867	98	applied	\N	\N	\N	\N	205605	205605	372750
27284	43870	99	applied	\N	\N	\N	\N	205606	205606	372751
27284	43873	100	applied	\N	\N	\N	\N	205607	205607	372752
27284	43876	101	applied	\N	\N	\N	\N	205608	205608	372753
27284	43877	102	applied	\N	\N	\N	\N	205609	205609	372754
27284	43882	103	applied	\N	\N	\N	\N	205610	205610	372755
27284	43885	104	applied	\N	\N	\N	\N	205611	205611	372756
27284	43888	105	applied	\N	\N	\N	\N	205612	205612	372757
27284	43891	106	applied	\N	\N	\N	\N	205613	205613	372758
27284	43892	107	applied	\N	\N	\N	\N	205614	205614	372759
27284	43893	108	applied	\N	\N	\N	\N	205615	205615	372760
27284	43902	109	applied	\N	\N	\N	\N	205616	205616	372761
27284	43759	111	applied	\N	\N	1000000000	\N	205618	205618	372763
27284	43766	112	applied	\N	\N	1000000000	\N	205619	205619	372764
27284	43839	113	applied	\N	\N	1000000000	\N	205620	205620	372765
27284	43840	114	applied	\N	\N	1000000000	\N	205621	205621	372766
27284	43577	115	applied	\N	\N	\N	\N	205622	205622	372767
27284	43580	116	applied	\N	\N	\N	\N	205623	205623	372768
27284	43585	117	applied	\N	\N	\N	\N	205624	205624	372769
27284	43851	118	applied	\N	\N	1000000000	\N	205625	205625	372770
27284	43587	119	applied	\N	\N	\N	\N	205626	205626	372771
27284	43590	120	applied	\N	\N	\N	\N	205627	205627	372772
27284	43582	2	applied	\N	\N	\N	\N	205510	205510	372655
27284	43583	3	applied	\N	\N	\N	\N	205511	205511	372656
27287	43907	0	applied	\N	\N	\N	\N	205639	205639	372784
27287	43908	1	applied	\N	\N	\N	\N	205640	205640	372785
27293	43912	1	applied	\N	\N	\N	\N	205651	205651	372796
27296	43918	0	applied	\N	\N	\N	\N	205657	205657	372802
27296	43917	1	applied	\N	\N	\N	\N	205658	205658	372803
27296	43919	2	applied	\N	\N	\N	\N	205659	205659	372804
27300	43929	0	applied	\N	\N	\N	\N	205675	205675	372820
27300	43930	1	applied	\N	\N	\N	\N	205676	205676	372821
27300	43931	2	applied	\N	\N	\N	\N	205677	205677	372822
27301	43929	0	applied	\N	\N	\N	\N	205678	205678	372823
27301	43930	1	applied	\N	\N	\N	\N	205679	205679	372824
27301	43931	2	applied	\N	\N	\N	\N	205680	205680	372825
27303	43938	0	applied	\N	\N	\N	\N	205687	205687	372832
27303	43939	1	applied	\N	\N	\N	\N	205688	205688	372833
27306	43944	0	applied	\N	\N	\N	\N	205696	205696	372841
27306	43945	1	applied	\N	\N	\N	\N	205697	205697	372842
27318	43968	0	applied	\N	\N	\N	\N	205732	205732	372877
27318	43969	1	applied	\N	\N	\N	\N	205733	205733	372878
27318	43970	2	applied	\N	\N	\N	\N	205734	205734	372879
27318	43971	3	applied	\N	\N	\N	\N	205735	205735	372880
27318	43972	4	applied	\N	\N	\N	\N	205736	205736	372881
27318	43973	5	applied	\N	\N	\N	\N	205737	205737	372882
27321	43977	0	applied	\N	\N	\N	\N	205747	205747	372892
27321	43978	1	applied	\N	\N	\N	\N	205748	205748	372893
27321	43979	2	applied	\N	\N	\N	\N	205749	205749	372894
27321	43980	3	applied	\N	\N	\N	\N	205750	205750	372895
27321	43981	4	applied	\N	\N	\N	\N	205751	205751	372896
27321	43982	5	applied	\N	\N	\N	\N	205752	205752	372897
27323	43983	0	applied	\N	\N	\N	\N	205759	205759	372904
27323	43984	1	applied	\N	\N	\N	\N	205760	205760	372905
27323	43985	2	applied	\N	\N	\N	\N	205761	205761	372906
27324	43983	0	applied	\N	\N	\N	\N	205762	205762	372907
27324	43985	2	applied	\N	\N	\N	\N	205764	205764	372909
27327	43983	0	applied	\N	\N	\N	\N	205771	205771	372916
27327	43984	1	applied	\N	\N	\N	\N	205772	205772	372917
27327	43985	2	applied	\N	\N	\N	\N	205773	205773	372918
27332	43989	0	applied	\N	\N	\N	\N	205786	205786	372931
27332	43990	1	applied	\N	\N	\N	\N	205787	205787	372932
27332	43991	2	applied	\N	\N	\N	\N	205788	205788	372933
27337	44008	0	applied	\N	\N	\N	\N	205808	205808	372953
27337	44009	1	applied	\N	\N	\N	\N	205809	205809	372954
27337	44010	2	applied	\N	\N	\N	\N	205810	205810	372955
27341	44014	0	applied	\N	\N	\N	\N	205820	205820	372965
27341	44015	1	applied	\N	\N	\N	\N	205821	205821	372966
27341	44016	2	applied	\N	\N	\N	\N	205822	205822	372967
27345	44029	0	applied	\N	\N	\N	\N	205835	205835	372980
27345	44030	1	applied	\N	\N	\N	\N	205836	205836	372981
27345	44031	2	applied	\N	\N	\N	\N	205837	205837	372982
27352	44039	1	applied	\N	\N	\N	\N	205854	205854	372999
27352	44040	2	applied	\N	\N	\N	\N	205855	205855	373000
27352	44041	3	applied	\N	\N	\N	\N	205856	205856	373001
27352	44042	4	applied	\N	\N	\N	\N	205857	205857	373002
27352	44043	5	applied	\N	\N	\N	\N	205858	205858	373003
27352	44044	6	applied	\N	\N	\N	\N	205859	205859	373004
27352	44045	7	applied	\N	\N	\N	\N	205860	205860	373005
27352	44046	8	applied	\N	\N	\N	\N	205861	205861	373006
27356	44053	0	applied	\N	\N	\N	\N	205883	205883	373028
27356	44054	1	applied	\N	\N	\N	\N	205884	205884	373029
27356	44055	2	applied	\N	\N	\N	\N	205885	205885	373030
27356	44056	3	applied	\N	\N	\N	\N	205886	205886	373031
27356	44057	4	applied	\N	\N	\N	\N	205887	205887	373032
27356	44058	5	applied	\N	\N	\N	\N	205888	205888	373033
27356	44059	6	applied	\N	\N	\N	\N	205889	205889	373034
27356	44060	7	applied	\N	\N	\N	\N	205890	205890	373035
27361	44074	0	applied	\N	\N	\N	\N	205934	205934	373079
27361	44075	1	applied	\N	\N	\N	\N	205935	205935	373080
27361	44076	2	applied	\N	\N	\N	\N	205936	205936	373081
27361	44077	3	applied	\N	\N	\N	\N	205937	205937	373082
27361	44078	4	applied	\N	\N	\N	\N	205938	205938	373083
27361	44079	5	applied	\N	\N	\N	\N	205939	205939	373084
27361	44080	6	applied	\N	\N	\N	\N	205940	205940	373085
27361	44081	7	applied	\N	\N	\N	\N	205941	205941	373086
27361	44082	8	applied	\N	\N	\N	\N	205942	205942	373087
27368	44096	0	applied	\N	\N	\N	\N	206021	206021	373166
27368	44097	1	applied	\N	\N	\N	\N	206022	206022	373167
27368	44098	2	applied	\N	\N	\N	\N	206023	206023	373168
27371	44102	0	applied	\N	\N	\N	\N	206030	206030	373175
27371	44103	1	applied	\N	\N	\N	\N	206031	206031	373176
27371	44104	2	applied	\N	\N	\N	\N	206032	206032	373177
27373	44105	0	applied	\N	\N	\N	\N	206036	206036	373181
27373	44107	2	applied	\N	\N	\N	\N	206038	206038	373183
27374	44108	0	applied	\N	\N	\N	\N	206039	206039	373184
27374	44109	1	applied	\N	\N	\N	\N	206040	206040	373185
27374	44110	2	applied	\N	\N	\N	\N	206041	206041	373186
27374	44111	3	applied	\N	\N	\N	\N	206042	206042	373187
27374	44112	4	applied	\N	\N	\N	\N	206043	206043	373188
27374	44113	5	applied	\N	\N	\N	\N	206044	206044	373189
27374	44114	6	applied	\N	\N	\N	\N	206045	206045	373190
27374	44115	7	applied	\N	\N	\N	\N	206046	206046	373191
27374	44116	8	applied	\N	\N	\N	\N	206047	206047	373192
27374	44117	9	applied	\N	\N	\N	\N	206048	206048	373193
27374	44118	10	applied	\N	\N	\N	\N	206049	206049	373194
27374	44119	11	applied	\N	\N	\N	\N	206050	206050	373195
27374	44120	12	applied	\N	\N	\N	\N	206051	206051	373196
27374	44121	13	applied	\N	\N	\N	\N	206052	206052	373197
27374	44122	14	applied	\N	\N	\N	\N	206053	206053	373198
27379	44133	1	applied	\N	\N	\N	\N	206085	206085	373230
27379	44134	2	applied	\N	\N	\N	\N	206086	206086	373231
27382	44135	0	applied	\N	\N	\N	\N	206099	206099	373244
27382	44136	1	applied	\N	\N	\N	\N	206100	206100	373245
27382	44137	2	applied	\N	\N	\N	\N	206101	206101	373246
27382	44138	3	applied	\N	\N	\N	\N	206102	206102	373247
27382	44139	4	applied	\N	\N	\N	\N	206103	206103	373248
27382	44140	5	applied	\N	\N	\N	\N	206104	206104	373249
27382	44141	6	applied	\N	\N	\N	\N	206105	206105	373250
27382	44142	7	applied	\N	\N	\N	\N	206106	206106	373251
27382	44143	8	applied	\N	\N	\N	\N	206107	206107	373252
27385	44144	0	applied	\N	\N	\N	\N	206114	206114	373259
27385	44145	1	applied	\N	\N	\N	\N	206115	206115	373260
27385	44146	2	applied	\N	\N	\N	\N	206116	206116	373261
27284	43595	122	applied	\N	\N	\N	\N	205629	205629	372774
27284	43598	123	applied	\N	\N	\N	\N	205630	205630	372775
27299	43927	1	applied	\N	\N	\N	\N	205673	205673	372818
27299	43928	2	applied	\N	\N	\N	\N	205674	205674	372819
27302	43932	0	applied	\N	\N	\N	\N	205681	205681	372826
27302	43933	1	applied	\N	\N	\N	\N	205682	205682	372827
27302	43934	2	applied	\N	\N	\N	\N	205683	205683	372828
27303	43940	2	applied	\N	\N	\N	\N	205689	205689	372834
27310	43947	0	applied	\N	\N	\N	\N	205708	205708	372853
27310	43948	1	applied	\N	\N	\N	\N	205709	205709	372854
27310	43949	2	applied	\N	\N	\N	\N	205710	205710	372855
27312	43953	0	applied	\N	\N	\N	\N	205714	205714	372859
27312	43954	1	applied	\N	\N	\N	\N	205715	205715	372860
27312	43955	2	applied	\N	\N	\N	\N	205716	205716	372861
27315	43962	0	applied	\N	\N	\N	\N	205723	205723	372868
27315	43963	1	applied	\N	\N	\N	\N	205724	205724	372869
27315	43964	2	applied	\N	\N	\N	\N	205725	205725	372870
27320	43974	0	applied	\N	\N	\N	\N	205744	205744	372889
27320	43976	2	applied	\N	\N	\N	\N	205746	205746	372891
27326	43983	0	applied	\N	\N	\N	\N	205768	205768	372913
27326	43984	1	applied	\N	\N	\N	\N	205769	205769	372914
27326	43985	2	applied	\N	\N	\N	\N	205770	205770	372915
27331	43986	0	applied	\N	\N	\N	\N	205783	205783	372928
27331	43987	1	applied	\N	\N	\N	\N	205784	205784	372929
27331	43988	2	applied	\N	\N	\N	\N	205785	205785	372930
27334	43996	0	applied	\N	\N	\N	\N	205793	205793	372938
27334	43997	1	applied	\N	\N	\N	\N	205794	205794	372939
27334	43998	2	applied	\N	\N	\N	\N	205795	205795	372940
27339	44014	0	applied	\N	\N	\N	\N	205814	205814	372959
27339	44015	1	applied	\N	\N	\N	\N	205815	205815	372960
27339	44016	2	applied	\N	\N	\N	\N	205816	205816	372961
27340	44014	0	applied	\N	\N	\N	\N	205817	205817	372962
27340	44015	1	applied	\N	\N	\N	\N	205818	205818	372963
27340	44016	2	applied	\N	\N	\N	\N	205819	205819	372964
27342	44018	1	applied	\N	\N	\N	\N	205824	205824	372969
27342	44019	2	applied	\N	\N	\N	\N	205825	205825	372970
27342	44020	3	applied	\N	\N	\N	\N	205826	205826	372971
27342	44021	4	applied	\N	\N	\N	\N	205827	205827	372972
27342	44022	5	applied	\N	\N	\N	\N	205828	205828	372973
27344	44026	0	applied	\N	\N	\N	\N	205832	205832	372977
27344	44027	1	applied	\N	\N	\N	\N	205833	205833	372978
27344	44028	2	applied	\N	\N	\N	\N	205834	205834	372979
27349	44035	0	applied	\N	\N	\N	\N	205847	205847	372992
27349	44036	1	applied	\N	\N	\N	\N	205848	205848	372993
27349	44037	2	applied	\N	\N	\N	\N	205849	205849	372994
27355	44053	0	applied	\N	\N	\N	\N	205874	205874	373019
27355	44054	1	applied	\N	\N	\N	\N	205875	205875	373020
27355	44055	2	applied	\N	\N	\N	\N	205876	205876	373021
27355	44056	3	applied	\N	\N	\N	\N	205877	205877	373022
27355	44057	4	applied	\N	\N	\N	\N	205878	205878	373023
27355	44059	6	applied	\N	\N	\N	\N	205880	205880	373025
27355	44060	7	applied	\N	\N	\N	\N	205881	205881	373026
27355	44061	8	applied	\N	\N	\N	\N	205882	205882	373027
27363	44086	0	applied	\N	\N	\N	\N	205946	205946	373091
27363	44087	1	applied	\N	\N	\N	\N	205947	205947	373092
27363	44088	2	applied	\N	\N	\N	\N	205948	205948	373093
27366	44093	0	applied	\N	\N	\N	\N	205956	205956	373101
27366	44094	1	applied	\N	\N	\N	\N	205957	205957	373102
27366	44095	2	applied	\N	\N	\N	\N	205958	205958	373103
27377	44123	0	applied	\N	\N	\N	\N	206075	206075	373220
27377	44124	1	applied	\N	\N	\N	\N	206076	206076	373221
27377	44125	2	applied	\N	\N	\N	\N	206077	206077	373222
27377	44126	3	applied	\N	\N	\N	\N	206078	206078	373223
27377	44127	4	applied	\N	\N	\N	\N	206079	206079	373224
27377	44128	5	applied	\N	\N	\N	\N	206080	206080	373225
27384	44144	0	applied	\N	\N	\N	\N	206111	206111	373256
27384	44146	2	applied	\N	\N	\N	\N	206113	206113	373258
27391	44159	0	applied	\N	\N	\N	\N	206144	206144	373289
27391	44160	1	applied	\N	\N	\N	\N	206145	206145	373290
27391	44161	2	applied	\N	\N	\N	\N	206146	206146	373291
27397	44183	0	applied	\N	\N	\N	\N	206171	206171	373316
27397	44184	1	applied	\N	\N	\N	\N	206172	206172	373317
27397	44185	2	applied	\N	\N	\N	\N	206173	206173	373318
27402	44189	0	applied	\N	\N	\N	\N	206186	206186	373331
27402	44190	1	applied	\N	\N	\N	\N	206187	206187	373332
27402	44191	2	applied	\N	\N	\N	\N	206188	206188	373333
27404	44192	0	applied	\N	\N	\N	\N	206192	206192	373337
27404	44193	1	applied	\N	\N	\N	\N	206193	206193	373338
27404	44194	2	applied	\N	\N	\N	\N	206194	206194	373339
27407	44198	0	applied	\N	\N	\N	\N	206201	206201	373346
27407	44199	1	applied	\N	\N	\N	\N	206202	206202	373347
27407	44200	2	applied	\N	\N	\N	\N	206203	206203	373348
27409	44202	1	applied	\N	\N	\N	\N	206208	206208	373353
27409	44203	2	applied	\N	\N	\N	\N	206209	206209	373354
27416	44207	0	applied	\N	\N	\N	\N	206228	206228	373373
27416	44208	1	applied	\N	\N	\N	\N	206229	206229	373374
27416	44209	2	applied	\N	\N	\N	\N	206230	206230	373375
27420	44210	0	applied	\N	\N	\N	\N	206240	206240	373385
27420	44211	1	applied	\N	\N	\N	\N	206241	206241	373386
27420	44212	2	applied	\N	\N	\N	\N	206242	206242	373387
27420	44213	3	applied	\N	\N	\N	\N	206243	206243	373388
27420	44214	4	applied	\N	\N	\N	\N	206244	206244	373389
27420	44215	5	applied	\N	\N	\N	\N	206245	206245	373390
27420	44216	6	applied	\N	\N	\N	\N	206246	206246	373391
27420	44217	7	applied	\N	\N	\N	\N	206247	206247	373392
27420	44218	8	applied	\N	\N	\N	\N	206248	206248	373393
27431	44231	0	applied	\N	\N	\N	\N	206341	206341	373486
27431	44232	1	applied	\N	\N	\N	\N	206342	206342	373487
27435	44237	0	applied	\N	\N	\N	\N	206353	206353	373498
27435	44238	1	applied	\N	\N	\N	\N	206354	206354	373499
27435	44239	2	applied	\N	\N	\N	\N	206355	206355	373500
27439	44244	0	applied	\N	\N	\N	\N	206363	206363	373508
27439	44245	1	applied	\N	\N	\N	\N	206364	206364	373509
27439	44246	2	applied	\N	\N	\N	\N	206365	206365	373510
27439	44247	3	applied	\N	\N	\N	\N	206366	206366	373511
27439	44248	4	applied	\N	\N	\N	\N	206367	206367	373512
27439	44249	5	applied	\N	\N	\N	\N	206368	206368	373513
27439	44243	6	applied	\N	\N	\N	\N	206369	206369	373514
27445	44250	0	applied	\N	\N	\N	\N	206387	206387	373532
27445	44251	2	applied	\N	\N	\N	\N	206388	206388	373533
27445	44252	3	applied	\N	\N	\N	\N	206389	206389	373534
27449	44253	0	applied	\N	\N	\N	\N	206408	206408	373553
27294	43915	2	applied	\N	\N	\N	\N	205654	205654	372799
27294	43916	3	applied	\N	\N	\N	\N	205655	205655	372800
27304	43942	1	applied	\N	\N	\N	\N	205691	205691	372836
27304	43943	2	applied	\N	\N	\N	\N	205692	205692	372837
27307	43944	0	applied	\N	\N	\N	\N	205699	205699	372844
27307	43945	1	applied	\N	\N	\N	\N	205700	205700	372845
27307	43946	2	applied	\N	\N	\N	\N	205701	205701	372846
27311	43950	0	applied	\N	\N	\N	\N	205711	205711	372856
27311	43951	1	applied	\N	\N	\N	\N	205712	205712	372857
27311	43952	2	applied	\N	\N	\N	\N	205713	205713	372858
27316	43965	0	applied	\N	\N	\N	\N	205726	205726	372871
27316	43966	1	applied	\N	\N	\N	\N	205727	205727	372872
27316	43967	2	applied	\N	\N	\N	\N	205728	205728	372873
27319	43968	0	applied	\N	\N	\N	\N	205738	205738	372883
27319	43969	1	applied	\N	\N	\N	\N	205739	205739	372884
27319	43970	2	applied	\N	\N	\N	\N	205740	205740	372885
27319	43972	4	applied	\N	\N	\N	\N	205742	205742	372887
27319	43973	5	applied	\N	\N	\N	\N	205743	205743	372888
27322	43977	0	applied	\N	\N	\N	\N	205753	205753	372898
27322	43978	1	applied	\N	\N	\N	\N	205754	205754	372899
27322	43979	2	applied	\N	\N	\N	\N	205755	205755	372900
27322	43980	3	applied	\N	\N	\N	\N	205756	205756	372901
27322	43981	4	applied	\N	\N	\N	\N	205757	205757	372902
27322	43982	5	applied	\N	\N	\N	\N	205758	205758	372903
27328	43983	0	applied	\N	\N	\N	\N	205774	205774	372919
27328	43984	1	applied	\N	\N	\N	\N	205775	205775	372920
27328	43985	2	applied	\N	\N	\N	\N	205776	205776	372921
27330	43986	0	applied	\N	\N	\N	\N	205780	205780	372925
27330	43987	1	applied	\N	\N	\N	\N	205781	205781	372926
27330	43988	2	applied	\N	\N	\N	\N	205782	205782	372927
27335	43996	0	applied	\N	\N	\N	\N	205796	205796	372941
27335	43997	1	applied	\N	\N	\N	\N	205797	205797	372942
27338	44011	0	applied	\N	\N	\N	\N	205811	205811	372956
27338	44012	1	applied	\N	\N	\N	\N	205812	205812	372957
27338	44013	2	applied	\N	\N	\N	\N	205813	205813	372958
27343	44023	0	applied	\N	\N	\N	\N	205829	205829	372974
27343	44024	1	applied	\N	\N	\N	\N	205830	205830	372975
27343	44025	2	applied	\N	\N	\N	\N	205831	205831	372976
27348	44032	0	applied	\N	\N	\N	\N	205844	205844	372989
27348	44033	1	applied	\N	\N	\N	\N	205845	205845	372990
27348	44034	2	applied	\N	\N	\N	\N	205846	205846	372991
27350	44035	0	applied	\N	\N	\N	\N	205850	205850	372995
27350	44036	1	applied	\N	\N	\N	\N	205851	205851	372996
27350	44037	2	applied	\N	\N	\N	\N	205852	205852	372997
27353	44047	0	applied	\N	\N	\N	\N	205862	205862	373007
27353	44048	1	applied	\N	\N	\N	\N	205863	205863	373008
27353	44049	2	applied	\N	\N	\N	\N	205864	205864	373009
27353	44050	3	applied	\N	\N	\N	\N	205865	205865	373010
27353	44052	5	applied	\N	\N	\N	\N	205867	205867	373012
27354	44047	0	applied	\N	\N	\N	\N	205868	205868	373013
27354	44048	1	applied	\N	\N	\N	\N	205869	205869	373014
27354	44049	2	applied	\N	\N	\N	\N	205870	205870	373015
27354	44050	3	applied	\N	\N	\N	\N	205871	205871	373016
27354	44051	4	applied	\N	\N	\N	\N	205872	205872	373017
27354	44052	5	applied	\N	\N	\N	\N	205873	205873	373018
27357	44053	0	applied	\N	\N	\N	\N	205892	205892	373037
27357	44054	1	applied	\N	\N	\N	\N	205893	205893	373038
27357	44055	2	applied	\N	\N	\N	\N	205894	205894	373039
27357	44056	3	applied	\N	\N	\N	\N	205895	205895	373040
27357	44057	4	applied	\N	\N	\N	\N	205896	205896	373041
27357	44058	5	applied	\N	\N	\N	\N	205897	205897	373042
27357	44059	6	applied	\N	\N	\N	\N	205898	205898	373043
27357	44060	7	applied	\N	\N	\N	\N	205899	205899	373044
27357	44061	8	applied	\N	\N	\N	\N	205900	205900	373045
27358	44061	8	applied	\N	\N	\N	\N	205909	205909	373054
27359	44062	0	applied	\N	\N	\N	\N	205910	205910	373055
27359	44063	1	applied	\N	\N	\N	\N	205911	205911	373056
27359	44064	2	applied	\N	\N	\N	\N	205912	205912	373057
27359	44065	3	applied	\N	\N	\N	\N	205913	205913	373058
27359	44066	4	applied	\N	\N	\N	\N	205914	205914	373059
27359	44067	5	applied	\N	\N	\N	\N	205915	205915	373060
27359	44068	6	applied	\N	\N	\N	\N	205916	205916	373061
27359	44069	7	applied	\N	\N	\N	\N	205917	205917	373062
27359	44070	8	applied	\N	\N	\N	\N	205918	205918	373063
27359	44071	9	applied	\N	\N	\N	\N	205919	205919	373064
27359	44072	10	applied	\N	\N	\N	\N	205920	205920	373065
27359	44073	12	applied	\N	\N	\N	\N	205921	205921	373066
27360	44062	0	applied	\N	\N	\N	\N	205922	205922	373067
27360	44063	1	applied	\N	\N	\N	\N	205923	205923	373068
27360	44064	2	applied	\N	\N	\N	\N	205924	205924	373069
27360	44066	4	applied	\N	\N	\N	\N	205926	205926	373071
27360	44067	5	applied	\N	\N	\N	\N	205927	205927	373072
27360	44068	6	applied	\N	\N	\N	\N	205928	205928	373073
27362	44083	0	applied	\N	\N	\N	\N	205943	205943	373088
27362	44084	1	applied	\N	\N	\N	\N	205944	205944	373089
27362	44085	2	applied	\N	\N	\N	\N	205945	205945	373090
27364	44089	0	applied	\N	\N	\N	\N	205949	205949	373094
27364	44090	1	applied	\N	\N	\N	\N	205950	205950	373095
27364	44091	2	applied	\N	\N	\N	\N	205951	205951	373096
27364	44092	3	applied	\N	\N	1000000000	\N	205952	205952	373097
27369	44099	0	applied	\N	\N	\N	\N	206024	206024	373169
27369	44100	1	applied	\N	\N	\N	\N	206025	206025	373170
27369	44101	2	applied	\N	\N	\N	\N	206026	206026	373171
27372	44102	0	applied	\N	\N	\N	\N	206033	206033	373178
27372	44103	1	applied	\N	\N	\N	\N	206034	206034	373179
27372	44104	2	applied	\N	\N	\N	\N	206035	206035	373180
27375	44109	1	applied	\N	\N	\N	\N	206055	206055	373200
27375	44110	2	applied	\N	\N	\N	\N	206056	206056	373201
27375	44111	3	applied	\N	\N	\N	\N	206057	206057	373202
27375	44112	4	applied	\N	\N	\N	\N	206058	206058	373203
27375	44113	5	applied	\N	\N	\N	\N	206059	206059	373204
27375	44114	6	applied	\N	\N	\N	\N	206060	206060	373205
27375	44115	7	applied	\N	\N	\N	\N	206061	206061	373206
27375	44116	8	applied	\N	\N	\N	\N	206062	206062	373207
27375	44117	9	applied	\N	\N	\N	\N	206063	206063	373208
27375	44118	10	applied	\N	\N	\N	\N	206064	206064	373209
27375	44119	11	applied	\N	\N	\N	\N	206065	206065	373210
27375	44120	12	applied	\N	\N	\N	\N	206066	206066	373211
27375	44121	13	applied	\N	\N	\N	\N	206067	206067	373212
27375	44122	14	applied	\N	\N	\N	\N	206068	206068	373213
27380	44132	0	applied	\N	\N	\N	\N	206087	206087	373232
27380	44133	1	applied	\N	\N	\N	\N	206088	206088	373233
27304	43941	0	applied	\N	\N	\N	\N	205690	205690	372835
27360	44073	12	applied	\N	\N	\N	\N	205933	205933	373078
27365	44093	0	applied	\N	\N	\N	\N	205953	205953	373098
27365	44094	1	applied	\N	\N	\N	\N	205954	205954	373099
27365	44095	2	applied	\N	\N	\N	\N	205955	205955	373100
27367	43993	0	applied	\N	\N	\N	\N	205959	205959	373104
27367	44071	1	applied	\N	\N	\N	\N	205960	205960	373105
27367	44072	2	applied	\N	\N	\N	\N	205961	205961	373106
27367	44073	3	applied	\N	\N	\N	\N	205962	205962	373107
27367	43917	4	applied	\N	\N	\N	\N	205963	205963	373108
27367	43922	5	applied	\N	\N	\N	\N	205964	205964	373109
27367	43924	6	applied	\N	\N	\N	\N	205965	205965	373110
27367	43928	7	applied	\N	\N	\N	\N	205966	205966	373111
27367	43931	8	applied	\N	\N	\N	\N	205967	205967	373112
27367	43935	9	applied	\N	\N	\N	\N	205968	205968	373113
27367	43936	10	applied	\N	\N	\N	\N	205969	205969	373114
27367	43940	11	applied	\N	\N	\N	\N	205970	205970	373115
27367	43946	13	applied	\N	\N	\N	\N	205972	205972	373117
27367	43949	14	applied	\N	\N	\N	\N	205973	205973	373118
27367	43951	15	applied	\N	\N	\N	\N	205974	205974	373119
27367	43955	16	applied	\N	\N	\N	\N	205975	205975	373120
27367	43960	17	applied	\N	\N	\N	\N	205976	205976	373121
27367	43961	18	applied	\N	\N	\N	\N	205977	205977	373122
27367	43964	19	applied	\N	\N	\N	\N	205978	205978	373123
27367	43967	20	applied	\N	\N	\N	\N	205979	205979	373124
27367	43970	21	applied	\N	\N	\N	\N	205980	205980	373125
27367	43971	22	applied	\N	\N	\N	\N	205981	205981	373126
27367	43976	23	applied	\N	\N	\N	\N	205982	205982	373127
27367	43979	24	applied	\N	\N	\N	\N	205983	205983	373128
27367	43980	25	applied	\N	\N	\N	\N	205984	205984	373129
27367	43984	26	applied	\N	\N	\N	\N	205985	205985	373130
27367	43987	27	applied	\N	\N	\N	\N	205986	205986	373131
27367	43991	28	applied	\N	\N	\N	\N	205987	205987	373132
27367	43998	30	applied	\N	\N	\N	\N	205989	205989	373134
27367	44003	31	applied	\N	\N	\N	\N	205990	205990	373135
27367	44004	32	applied	\N	\N	\N	\N	205991	205991	373136
27367	44005	33	applied	\N	\N	\N	\N	205992	205992	373137
27367	44010	34	applied	\N	\N	\N	\N	205993	205993	373138
27367	44012	35	applied	\N	\N	\N	\N	205994	205994	373139
27367	44015	36	applied	\N	\N	\N	\N	205995	205995	373140
27367	44019	37	applied	\N	\N	\N	\N	205996	205996	373141
27367	44022	38	applied	\N	\N	\N	\N	205997	205997	373142
27367	44024	39	applied	\N	\N	\N	\N	205998	205998	373143
27367	44028	40	applied	\N	\N	\N	\N	205999	205999	373144
27367	44031	41	applied	\N	\N	\N	\N	206000	206000	373145
27367	44034	42	applied	\N	\N	\N	\N	206001	206001	373146
27367	44037	43	applied	\N	\N	\N	\N	206002	206002	373147
27367	44041	44	applied	\N	\N	\N	\N	206003	206003	373148
27367	44042	45	applied	\N	\N	\N	\N	206004	206004	373149
27367	44049	47	applied	\N	\N	\N	\N	206006	206006	373151
27367	44050	48	applied	\N	\N	\N	\N	206007	206007	373152
27367	44059	49	applied	\N	\N	\N	\N	206008	206008	373153
27367	44060	50	applied	\N	\N	\N	\N	206009	206009	373154
27367	44061	51	applied	\N	\N	\N	\N	206010	206010	373155
27367	44065	52	applied	\N	\N	\N	\N	206011	206011	373156
27367	44066	53	applied	\N	\N	\N	\N	206012	206012	373157
27367	44067	54	applied	\N	\N	\N	\N	206013	206013	373158
27367	44077	55	applied	\N	\N	\N	\N	206014	206014	373159
27367	44078	56	applied	\N	\N	\N	\N	206015	206015	373160
27367	44079	57	applied	\N	\N	\N	\N	206016	206016	373161
27367	44085	58	applied	\N	\N	\N	\N	206017	206017	373162
27367	44087	59	applied	\N	\N	\N	\N	206018	206018	373163
27367	44091	60	applied	\N	\N	\N	\N	206019	206019	373164
27367	44095	61	applied	\N	\N	\N	\N	206020	206020	373165
27370	44099	0	applied	\N	\N	\N	\N	206027	206027	373172
27370	44101	2	applied	\N	\N	\N	\N	206029	206029	373174
27376	44123	0	applied	\N	\N	\N	\N	206069	206069	373214
27376	44124	1	applied	\N	\N	\N	\N	206070	206070	373215
27376	44125	2	applied	\N	\N	\N	\N	206071	206071	373216
27376	44126	3	applied	\N	\N	\N	\N	206072	206072	373217
27376	44127	4	applied	\N	\N	\N	\N	206073	206073	373218
27376	44128	5	applied	\N	\N	\N	\N	206074	206074	373219
27378	44129	0	applied	\N	\N	\N	\N	206081	206081	373226
27378	44130	1	applied	\N	\N	\N	\N	206082	206082	373227
27378	44131	2	applied	\N	\N	\N	\N	206083	206083	373228
27380	44134	2	applied	\N	\N	\N	\N	206089	206089	373234
27381	44135	0	applied	\N	\N	\N	\N	206090	206090	373235
27381	44136	1	applied	\N	\N	\N	\N	206091	206091	373236
27381	44137	2	applied	\N	\N	\N	\N	206092	206092	373237
27381	44138	3	applied	\N	\N	\N	\N	206093	206093	373238
27381	44139	4	applied	\N	\N	\N	\N	206094	206094	373239
27381	44141	6	applied	\N	\N	\N	\N	206096	206096	373241
27381	44142	7	applied	\N	\N	\N	\N	206097	206097	373242
27381	44143	8	applied	\N	\N	\N	\N	206098	206098	373243
27383	44144	0	applied	\N	\N	\N	\N	206108	206108	373253
27383	44145	1	applied	\N	\N	\N	\N	206109	206109	373254
27383	44146	2	applied	\N	\N	\N	\N	206110	206110	373255
27386	44144	0	applied	\N	\N	\N	\N	206117	206117	373262
27386	44145	1	applied	\N	\N	\N	\N	206118	206118	373263
27386	44146	2	applied	\N	\N	\N	\N	206119	206119	373264
27387	44147	0	applied	\N	\N	\N	\N	206120	206120	373265
27387	44148	1	applied	\N	\N	\N	\N	206121	206121	373266
27387	44149	2	applied	\N	\N	\N	\N	206122	206122	373267
27387	44150	3	applied	\N	\N	\N	\N	206123	206123	373268
27387	44151	4	applied	\N	\N	\N	\N	206124	206124	373269
27387	44152	5	applied	\N	\N	\N	\N	206125	206125	373270
27388	44147	0	applied	\N	\N	\N	\N	206126	206126	373271
27388	44149	2	applied	\N	\N	\N	\N	206128	206128	373273
27388	44150	3	applied	\N	\N	\N	\N	206129	206129	373274
27388	44151	4	applied	\N	\N	\N	\N	206130	206130	373275
27388	44152	5	applied	\N	\N	\N	\N	206131	206131	373276
27389	44147	0	applied	\N	\N	\N	\N	206132	206132	373277
27389	44148	1	applied	\N	\N	\N	\N	206133	206133	373278
27389	44149	2	applied	\N	\N	\N	\N	206134	206134	373279
27389	44150	3	applied	\N	\N	\N	\N	206135	206135	373280
27389	44151	4	applied	\N	\N	\N	\N	206136	206136	373281
27389	44152	5	applied	\N	\N	\N	\N	206137	206137	373282
27390	44153	0	applied	\N	\N	\N	\N	206138	206138	373283
27390	44154	1	applied	\N	\N	\N	\N	206139	206139	373284
27396	44177	0	applied	\N	\N	\N	\N	206165	206165	373310
27396	44178	1	applied	\N	\N	\N	\N	206166	206166	373311
27360	44070	8	applied	\N	\N	\N	\N	205930	205930	373075
27360	44071	9	applied	\N	\N	\N	\N	205931	205931	373076
27396	44179	2	applied	\N	\N	\N	\N	206167	206167	373312
27396	44180	3	applied	\N	\N	\N	\N	206168	206168	373313
27396	44181	4	applied	\N	\N	\N	\N	206169	206169	373314
27396	44182	5	applied	\N	\N	\N	\N	206170	206170	373315
27399	44183	0	applied	\N	\N	\N	\N	206177	206177	373322
27399	44184	1	applied	\N	\N	\N	\N	206178	206178	373323
27399	44185	2	applied	\N	\N	\N	\N	206179	206179	373324
27400	44186	0	applied	\N	\N	\N	\N	206180	206180	373325
27400	44187	1	applied	\N	\N	\N	\N	206181	206181	373326
27400	44188	2	applied	\N	\N	\N	\N	206182	206182	373327
27401	44189	0	applied	\N	\N	\N	\N	206183	206183	373328
27401	44190	1	applied	\N	\N	\N	\N	206184	206184	373329
27401	44191	2	applied	\N	\N	\N	\N	206185	206185	373330
27406	44195	0	applied	\N	\N	\N	\N	206198	206198	373343
27406	44196	1	applied	\N	\N	\N	\N	206199	206199	373344
27411	44201	0	applied	\N	\N	\N	\N	206213	206213	373358
27411	44203	2	applied	\N	\N	\N	\N	206215	206215	373360
27412	44204	0	applied	\N	\N	\N	\N	206216	206216	373361
27412	44205	1	applied	\N	\N	\N	\N	206217	206217	373362
27412	44206	2	applied	\N	\N	\N	\N	206218	206218	373363
27418	44207	0	applied	\N	\N	\N	\N	206234	206234	373379
27418	44208	1	applied	\N	\N	\N	\N	206235	206235	373380
27418	44209	2	applied	\N	\N	\N	\N	206236	206236	373381
27424	44219	0	applied	\N	\N	\N	\N	206308	206308	373453
27424	44220	1	applied	\N	\N	\N	\N	206309	206309	373454
27424	44221	2	applied	\N	\N	\N	\N	206310	206310	373455
27424	44222	3	applied	\N	\N	\N	\N	206311	206311	373456
27424	44223	4	applied	\N	\N	\N	\N	206312	206312	373457
27424	44224	5	applied	\N	\N	\N	\N	206313	206313	373458
27424	44225	6	applied	\N	\N	\N	\N	206314	206314	373459
27424	44226	7	applied	\N	\N	\N	\N	206315	206315	373460
27424	44227	8	applied	\N	\N	\N	\N	206316	206316	373461
27426	44229	1	applied	\N	\N	\N	\N	206327	206327	373472
27426	44230	2	applied	\N	\N	\N	\N	206328	206328	373473
27429	44231	0	applied	\N	\N	\N	\N	206335	206335	373480
27429	44232	1	applied	\N	\N	\N	\N	206336	206336	373481
27429	44233	2	applied	\N	\N	\N	\N	206337	206337	373482
27433	44237	0	applied	\N	\N	\N	\N	206347	206347	373492
27433	44238	1	applied	\N	\N	\N	\N	206348	206348	373493
27433	44239	2	applied	\N	\N	\N	\N	206349	206349	373494
27441	44243	0	applied	\N	\N	\N	\N	206377	206377	373522
27447	44253	0	applied	\N	\N	\N	\N	206396	206396	373541
27447	44254	1	applied	\N	\N	\N	\N	206397	206397	373542
27447	44255	2	applied	\N	\N	\N	\N	206398	206398	373543
27447	44256	3	applied	\N	\N	\N	\N	206399	206399	373544
27447	44257	4	applied	\N	\N	\N	\N	206400	206400	373545
27447	44258	5	applied	\N	\N	\N	\N	206401	206401	373546
27451	44259	0	applied	\N	\N	\N	\N	206420	206420	373565
27451	44261	2	applied	\N	\N	\N	\N	206422	206422	373567
27453	44262	0	applied	\N	\N	\N	\N	206426	206426	373571
27453	44263	1	applied	\N	\N	\N	\N	206427	206427	373572
27453	44264	2	applied	\N	\N	\N	\N	206428	206428	373573
27458	44271	0	applied	\N	\N	\N	\N	206441	206441	373586
27458	44272	1	applied	\N	\N	\N	\N	206442	206442	373587
27458	44273	2	applied	\N	\N	\N	\N	206443	206443	373588
27458	44274	3	applied	\N	\N	\N	\N	206444	206444	373589
27458	44275	4	applied	\N	\N	\N	\N	206445	206445	373590
27458	44276	5	applied	\N	\N	\N	\N	206446	206446	373591
27458	44277	6	applied	\N	\N	\N	\N	206447	206447	373592
27458	44278	7	applied	\N	\N	\N	\N	206448	206448	373593
27458	44279	8	applied	\N	\N	\N	\N	206449	206449	373594
27458	44280	9	applied	\N	\N	\N	\N	206450	206450	373595
27458	44281	10	applied	\N	\N	\N	\N	206451	206451	373596
27458	44282	11	applied	\N	\N	\N	\N	206452	206452	373597
27458	44284	13	applied	\N	\N	\N	\N	206454	206454	373599
27464	44295	0	applied	\N	\N	\N	\N	206497	206497	373642
27464	44297	1	applied	\N	\N	\N	\N	206498	206498	373643
27464	44298	2	applied	\N	\N	\N	\N	206499	206499	373644
27464	44299	3	applied	\N	\N	\N	\N	206500	206500	373645
27464	44300	4	applied	\N	\N	\N	\N	206501	206501	373646
27478	44350	0	applied	\N	\N	\N	\N	206621	206621	373766
27478	44351	1	applied	\N	\N	\N	\N	206622	206622	373767
27478	44352	2	applied	\N	\N	\N	\N	206623	206623	373768
27478	44353	3	applied	\N	\N	\N	\N	206624	206624	373769
27478	44354	4	applied	\N	\N	\N	\N	206625	206625	373770
27478	44355	5	applied	\N	\N	\N	\N	206626	206626	373771
27478	44356	6	applied	\N	\N	\N	\N	206627	206627	373772
27478	44357	7	applied	\N	\N	\N	\N	206628	206628	373773
27478	44358	8	applied	\N	\N	\N	\N	206629	206629	373774
27478	44359	9	applied	\N	\N	\N	\N	206630	206630	373775
27478	44361	11	applied	\N	\N	\N	\N	206632	206632	373777
27478	44362	12	applied	\N	\N	\N	\N	206633	206633	373778
27478	44363	13	applied	\N	\N	\N	\N	206634	206634	373779
27478	44364	14	applied	\N	\N	\N	\N	206635	206635	373780
27478	44365	15	applied	\N	\N	\N	\N	206636	206636	373781
27478	44366	16	applied	\N	\N	\N	\N	206637	206637	373782
27478	44367	17	applied	\N	\N	\N	\N	206638	206638	373783
27478	44368	18	applied	\N	\N	\N	\N	206639	206639	373784
27478	44369	19	applied	\N	\N	\N	\N	206640	206640	373785
27478	44370	20	applied	\N	\N	\N	\N	206641	206641	373786
27478	44371	21	applied	\N	\N	\N	\N	206642	206642	373787
27478	44372	22	applied	\N	\N	\N	\N	206643	206643	373788
27478	44373	23	applied	\N	\N	\N	\N	206644	206644	373789
27478	44374	24	applied	\N	\N	\N	\N	206645	206645	373790
27478	44375	25	applied	\N	\N	\N	\N	206646	206646	373791
27480	44384	0	applied	\N	\N	\N	\N	206655	206655	373800
27480	44386	2	applied	\N	\N	\N	\N	206657	206657	373802
27480	44387	3	applied	\N	\N	\N	\N	206658	206658	373803
27480	44388	4	applied	\N	\N	\N	\N	206659	206659	373804
27480	44389	5	applied	\N	\N	\N	\N	206660	206660	373805
27480	44390	6	applied	\N	\N	\N	\N	206661	206661	373806
27480	44391	7	applied	\N	\N	\N	\N	206662	206662	373807
27480	44392	8	applied	\N	\N	\N	\N	206663	206663	373808
27480	44393	9	applied	\N	\N	\N	\N	206664	206664	373809
27480	44394	10	applied	\N	\N	\N	\N	206665	206665	373810
27480	44395	11	applied	\N	\N	\N	\N	206666	206666	373811
27480	44396	12	applied	\N	\N	\N	\N	206667	206667	373812
27480	44397	13	applied	\N	\N	\N	\N	206668	206668	373813
27480	44398	14	applied	\N	\N	\N	\N	206669	206669	373814
27480	44399	15	applied	\N	\N	\N	\N	206670	206670	373815
27390	44156	3	applied	\N	\N	\N	\N	206141	206141	373286
27390	44157	4	applied	\N	\N	\N	\N	206142	206142	373287
27395	44163	1	applied	\N	\N	\N	\N	206151	206151	373296
27395	44164	2	applied	\N	\N	\N	\N	206152	206152	373297
27395	44165	3	applied	\N	\N	\N	\N	206153	206153	373298
27395	44166	4	applied	\N	\N	\N	\N	206154	206154	373299
27395	44167	5	applied	\N	\N	\N	\N	206155	206155	373300
27406	44197	2	applied	\N	\N	\N	\N	206200	206200	373345
27413	44204	0	applied	\N	\N	\N	\N	206219	206219	373364
27413	44205	1	applied	\N	\N	\N	\N	206220	206220	373365
27413	44206	2	applied	\N	\N	\N	\N	206221	206221	373366
27414	44204	0	applied	\N	\N	\N	\N	206222	206222	373367
27414	44205	1	applied	\N	\N	\N	\N	206223	206223	373368
27414	44206	2	applied	\N	\N	\N	\N	206224	206224	373369
27415	44207	0	applied	\N	\N	\N	\N	206225	206225	373370
27415	44208	1	applied	\N	\N	\N	\N	206226	206226	373371
27415	44209	2	applied	\N	\N	\N	\N	206227	206227	373372
27419	44207	0	applied	\N	\N	\N	\N	206237	206237	373382
27419	44209	2	applied	\N	\N	\N	\N	206239	206239	373384
27425	44219	0	applied	\N	\N	\N	\N	206317	206317	373462
27425	44220	1	applied	\N	\N	\N	\N	206318	206318	373463
27425	44221	2	applied	\N	\N	\N	\N	206319	206319	373464
27425	44222	3	applied	\N	\N	\N	\N	206320	206320	373465
27425	44223	4	applied	\N	\N	\N	\N	206321	206321	373466
27425	44224	5	applied	\N	\N	\N	\N	206322	206322	373467
27425	44225	6	applied	\N	\N	\N	\N	206323	206323	373468
27425	44226	7	applied	\N	\N	\N	\N	206324	206324	373469
27425	44227	8	applied	\N	\N	\N	\N	206325	206325	373470
27427	44228	0	applied	\N	\N	\N	\N	206329	206329	373474
27427	44229	1	applied	\N	\N	\N	\N	206330	206330	373475
27427	44230	2	applied	\N	\N	\N	\N	206331	206331	373476
27430	44231	0	applied	\N	\N	\N	\N	206338	206338	373483
27430	44232	1	applied	\N	\N	\N	\N	206339	206339	373484
27430	44233	2	applied	\N	\N	\N	\N	206340	206340	373485
27434	44238	1	applied	\N	\N	\N	\N	206351	206351	373496
27434	44239	2	applied	\N	\N	\N	\N	206352	206352	373497
27438	44243	0	applied	\N	\N	\N	\N	206362	206362	373507
27442	44244	0	applied	\N	\N	\N	\N	206378	206378	373523
27442	44245	1	applied	\N	\N	\N	\N	206379	206379	373524
27442	44246	2	applied	\N	\N	\N	\N	206380	206380	373525
27442	44247	3	applied	\N	\N	\N	\N	206381	206381	373526
27442	44248	4	applied	\N	\N	\N	\N	206382	206382	373527
27442	44249	5	applied	\N	\N	\N	\N	206383	206383	373528
27442	44243	6	applied	\N	\N	\N	\N	206384	206384	373529
27444	44243	0	applied	\N	\N	\N	\N	206386	206386	373531
27448	44253	0	applied	\N	\N	\N	\N	206402	206402	373547
27448	44254	1	applied	\N	\N	\N	\N	206403	206403	373548
27448	44255	2	applied	\N	\N	\N	\N	206404	206404	373549
27448	44256	3	applied	\N	\N	\N	\N	206405	206405	373550
27448	44257	4	applied	\N	\N	\N	\N	206406	206406	373551
27452	44259	0	applied	\N	\N	\N	\N	206423	206423	373568
27452	44260	1	applied	\N	\N	\N	\N	206424	206424	373569
27452	44261	2	applied	\N	\N	\N	\N	206425	206425	373570
27456	44268	0	applied	\N	\N	\N	\N	206435	206435	373580
27456	44269	1	applied	\N	\N	\N	\N	206436	206436	373581
27456	44270	2	applied	\N	\N	\N	\N	206437	206437	373582
27459	44285	0	applied	\N	\N	\N	\N	206455	206455	373600
27459	44286	1	applied	\N	\N	\N	\N	206456	206456	373601
27459	44287	2	applied	\N	\N	\N	\N	206457	206457	373602
27459	44288	3	applied	\N	\N	\N	\N	206458	206458	373603
27459	44289	4	applied	\N	\N	\N	\N	206459	206459	373604
27459	44290	5	applied	\N	\N	\N	\N	206460	206460	373605
27459	44291	6	applied	\N	\N	\N	\N	206461	206461	373606
27459	44292	7	applied	\N	\N	\N	\N	206462	206462	373607
27459	44293	8	applied	\N	\N	\N	\N	206463	206463	373608
27461	44294	0	applied	\N	\N	\N	\N	206473	206473	373618
27461	44296	2	applied	\N	\N	\N	\N	206475	206475	373620
27461	44297	3	applied	\N	\N	\N	\N	206476	206476	373621
27461	44298	4	applied	\N	\N	\N	\N	206477	206477	373622
27461	44299	5	applied	\N	\N	\N	\N	206478	206478	373623
27461	44300	6	applied	\N	\N	\N	\N	206479	206479	373624
27461	44301	7	applied	\N	\N	\N	\N	206480	206480	373625
27461	44302	8	applied	\N	\N	\N	\N	206481	206481	373626
27465	44303	0	applied	\N	\N	\N	\N	206502	206502	373647
27465	44304	1	applied	\N	\N	\N	\N	206503	206503	373648
27465	44305	2	applied	\N	\N	\N	\N	206504	206504	373649
27465	44306	3	applied	\N	\N	\N	\N	206505	206505	373650
27465	44307	4	applied	\N	\N	\N	\N	206506	206506	373651
27465	44308	5	applied	\N	\N	\N	\N	206507	206507	373652
27465	44309	6	applied	\N	\N	\N	\N	206508	206508	373653
27465	44310	7	applied	\N	\N	\N	\N	206509	206509	373654
27469	44335	0	applied	\N	\N	\N	\N	206566	206566	373711
27469	44337	2	applied	\N	\N	\N	\N	206568	206568	373713
27469	44338	3	applied	\N	\N	\N	\N	206569	206569	373714
27469	44339	4	applied	\N	\N	\N	\N	206570	206570	373715
27469	44340	5	applied	\N	\N	\N	\N	206571	206571	373716
27469	44341	6	applied	\N	\N	\N	\N	206572	206572	373717
27469	44342	7	applied	\N	\N	\N	\N	206573	206573	373718
27471	44343	0	applied	\N	\N	\N	\N	206574	206574	373719
27471	44344	1	applied	\N	\N	\N	\N	206575	206575	373720
27471	44345	2	applied	\N	\N	\N	\N	206576	206576	373721
27471	44346	3	applied	\N	\N	\N	\N	206577	206577	373722
27471	44347	4	applied	\N	\N	\N	\N	206578	206578	373723
27471	44348	5	applied	\N	\N	\N	\N	206579	206579	373724
27471	44349	6	applied	\N	\N	\N	\N	206580	206580	373725
27484	44417	0	applied	\N	\N	\N	\N	206706	206706	373851
27484	44418	1	applied	\N	\N	\N	\N	206707	206707	373852
27484	44419	2	applied	\N	\N	\N	\N	206708	206708	373853
27484	44421	4	applied	\N	\N	\N	\N	206710	206710	373855
27484	44422	5	applied	\N	\N	\N	\N	206711	206711	373856
27484	44423	6	applied	\N	\N	\N	\N	206712	206712	373857
27484	44424	7	applied	\N	\N	\N	\N	206713	206713	373858
27484	44425	8	applied	\N	\N	\N	\N	206714	206714	373859
27484	44426	9	applied	\N	\N	\N	\N	206715	206715	373860
27484	44427	10	applied	\N	\N	\N	\N	206716	206716	373861
27484	44428	11	applied	\N	\N	\N	\N	206717	206717	373862
27484	44429	12	applied	\N	\N	\N	\N	206718	206718	373863
27484	44430	13	applied	\N	\N	\N	\N	206719	206719	373864
27484	44431	14	applied	\N	\N	\N	\N	206720	206720	373865
27484	44432	15	applied	\N	\N	\N	\N	206721	206721	373866
27484	44433	16	applied	\N	\N	\N	\N	206722	206722	373867
27484	44434	17	applied	\N	\N	\N	\N	206723	206723	373868
27392	44160	1	applied	\N	\N	\N	\N	206148	206148	373293
27392	44161	2	applied	\N	\N	\N	\N	206149	206149	373294
27395	44172	10	applied	\N	\N	\N	\N	206160	206160	373305
27395	44173	11	applied	\N	\N	\N	\N	206161	206161	373306
27395	44174	12	applied	\N	\N	\N	\N	206162	206162	373307
27395	44175	13	applied	\N	\N	\N	\N	206163	206163	373308
27395	44176	14	applied	\N	\N	\N	\N	206164	206164	373309
27398	44183	0	applied	\N	\N	\N	\N	206174	206174	373319
27398	44184	1	applied	\N	\N	\N	\N	206175	206175	373320
27398	44185	2	applied	\N	\N	\N	\N	206176	206176	373321
27403	44189	0	applied	\N	\N	\N	\N	206189	206189	373334
27403	44190	1	applied	\N	\N	\N	\N	206190	206190	373335
27403	44191	2	applied	\N	\N	\N	\N	206191	206191	373336
27405	44192	0	applied	\N	\N	\N	\N	206195	206195	373340
27405	44193	1	applied	\N	\N	\N	\N	206196	206196	373341
27405	44194	2	applied	\N	\N	\N	\N	206197	206197	373342
27408	44198	0	applied	\N	\N	\N	\N	206204	206204	373349
27408	44199	1	applied	\N	\N	\N	\N	206205	206205	373350
27410	44201	0	applied	\N	\N	\N	\N	206210	206210	373355
27410	44202	1	applied	\N	\N	\N	\N	206211	206211	373356
27410	44203	2	applied	\N	\N	\N	\N	206212	206212	373357
27417	44207	0	applied	\N	\N	\N	\N	206231	206231	373376
27417	44208	1	applied	\N	\N	\N	\N	206232	206232	373377
27417	44209	2	applied	\N	\N	\N	\N	206233	206233	373378
27421	44210	0	applied	\N	\N	\N	\N	206249	206249	373394
27421	44211	1	applied	\N	\N	\N	\N	206250	206250	373395
27421	44212	2	applied	\N	\N	\N	\N	206251	206251	373396
27421	44213	3	applied	\N	\N	\N	\N	206252	206252	373397
27421	44214	4	applied	\N	\N	\N	\N	206253	206253	373398
27421	44215	5	applied	\N	\N	\N	\N	206254	206254	373399
27421	44216	6	applied	\N	\N	\N	\N	206255	206255	373400
27421	44217	7	applied	\N	\N	\N	\N	206256	206256	373401
27421	44218	8	applied	\N	\N	\N	\N	206257	206257	373402
27422	44210	0	applied	\N	\N	\N	\N	206258	206258	373403
27422	44212	2	applied	\N	\N	\N	\N	206260	206260	373405
27422	44213	3	applied	\N	\N	\N	\N	206261	206261	373406
27422	44214	4	applied	\N	\N	\N	\N	206262	206262	373407
27422	44215	5	applied	\N	\N	\N	\N	206263	206263	373408
27422	44216	6	applied	\N	\N	\N	\N	206264	206264	373409
27422	44217	7	applied	\N	\N	\N	\N	206265	206265	373410
27422	44218	8	applied	\N	\N	\N	\N	206266	206266	373411
27423	44098	0	applied	\N	\N	\N	\N	206267	206267	373412
27423	44100	1	applied	\N	\N	\N	\N	206268	206268	373413
27423	44104	2	applied	\N	\N	\N	\N	206269	206269	373414
27423	44107	3	applied	\N	\N	\N	\N	206270	206270	373415
27423	44113	4	applied	\N	\N	\N	\N	206271	206271	373416
27423	44114	5	applied	\N	\N	\N	\N	206272	206272	373417
27423	44120	6	applied	\N	\N	\N	\N	206273	206273	373418
27423	44121	7	applied	\N	\N	\N	\N	206274	206274	373419
27423	44122	8	applied	\N	\N	\N	\N	206275	206275	373420
27423	44127	10	applied	\N	\N	\N	\N	206277	206277	373422
27423	44131	11	applied	\N	\N	\N	\N	206278	206278	373423
27423	44133	12	applied	\N	\N	\N	\N	206279	206279	373424
27423	44139	13	applied	\N	\N	\N	\N	206280	206280	373425
27423	44142	14	applied	\N	\N	\N	\N	206281	206281	373426
27423	44143	15	applied	\N	\N	\N	\N	206282	206282	373427
27423	44145	16	applied	\N	\N	\N	\N	206283	206283	373428
27423	44149	17	applied	\N	\N	\N	\N	206284	206284	373429
27423	44150	18	applied	\N	\N	\N	\N	206285	206285	373430
27423	44156	19	applied	\N	\N	\N	\N	206286	206286	373431
27423	44158	20	applied	\N	\N	\N	\N	206287	206287	373432
27423	44161	21	applied	\N	\N	\N	\N	206288	206288	373433
27423	44172	22	applied	\N	\N	\N	\N	206289	206289	373434
27423	44173	23	applied	\N	\N	\N	\N	206290	206290	373435
27423	44174	24	applied	\N	\N	\N	\N	206291	206291	373436
27423	44175	25	applied	\N	\N	\N	\N	206292	206292	373437
27423	44180	27	applied	\N	\N	\N	\N	206294	206294	373439
27423	44182	28	applied	\N	\N	\N	\N	206295	206295	373440
27423	44185	30	applied	\N	\N	\N	\N	206296	206296	373441
27423	44188	31	applied	\N	\N	\N	\N	206297	206297	373442
27423	44191	32	applied	\N	\N	\N	\N	206298	206298	373443
27423	44193	33	applied	\N	\N	\N	\N	206299	206299	373444
27423	44197	34	applied	\N	\N	\N	\N	206300	206300	373445
27423	44200	35	applied	\N	\N	\N	\N	206301	206301	373446
27423	44203	36	applied	\N	\N	\N	\N	206302	206302	373447
27423	44206	37	applied	\N	\N	\N	\N	206303	206303	373448
27423	44209	38	applied	\N	\N	\N	\N	206304	206304	373449
27423	44214	39	applied	\N	\N	\N	\N	206305	206305	373450
27423	44215	40	applied	\N	\N	\N	\N	206306	206306	373451
27423	44218	41	applied	\N	\N	\N	\N	206307	206307	373452
27428	44231	0	applied	\N	\N	\N	\N	206332	206332	373477
27428	44232	1	applied	\N	\N	\N	\N	206333	206333	373478
27432	44234	0	applied	\N	\N	\N	\N	206344	206344	373489
27432	44235	1	applied	\N	\N	\N	\N	206345	206345	373490
27432	44236	2	applied	\N	\N	\N	\N	206346	206346	373491
27436	44237	0	applied	\N	\N	\N	\N	206356	206356	373501
27436	44238	1	applied	\N	\N	\N	\N	206357	206357	373502
27436	44239	2	applied	\N	\N	\N	\N	206358	206358	373503
27437	44240	0	applied	\N	\N	\N	\N	206359	206359	373504
27437	44241	1	applied	\N	\N	\N	\N	206360	206360	373505
27437	44242	2	applied	\N	\N	\N	\N	206361	206361	373506
27440	44244	0	applied	\N	\N	\N	\N	206370	206370	373515
27440	44245	1	applied	\N	\N	\N	\N	206371	206371	373516
27440	44246	2	applied	\N	\N	\N	\N	206372	206372	373517
27440	44247	3	applied	\N	\N	\N	\N	206373	206373	373518
27440	44248	4	applied	\N	\N	\N	\N	206374	206374	373519
27440	44249	5	applied	\N	\N	\N	\N	206375	206375	373520
27440	44243	6	applied	\N	\N	\N	\N	206376	206376	373521
27446	44253	0	applied	\N	\N	\N	\N	206390	206390	373535
27446	44254	1	applied	\N	\N	\N	\N	206391	206391	373536
27446	44255	2	applied	\N	\N	\N	\N	206392	206392	373537
27446	44256	3	applied	\N	\N	\N	\N	206393	206393	373538
27446	44257	4	applied	\N	\N	\N	\N	206394	206394	373539
27446	44258	5	applied	\N	\N	\N	\N	206395	206395	373540
27450	44253	0	applied	\N	\N	\N	\N	206414	206414	373559
27450	44254	1	applied	\N	\N	\N	\N	206415	206415	373560
27450	44255	2	applied	\N	\N	\N	\N	206416	206416	373561
27450	44256	3	applied	\N	\N	\N	\N	206417	206417	373562
27450	44257	4	applied	\N	\N	\N	\N	206418	206418	373563
27450	44258	5	applied	\N	\N	\N	\N	206419	206419	373564
27455	44265	0	applied	\N	\N	\N	\N	206432	206432	373577
27455	44266	1	applied	\N	\N	\N	\N	206433	206433	373578
27395	44169	7	applied	\N	\N	\N	\N	206157	206157	373302
27395	44170	8	applied	\N	\N	\N	\N	206158	206158	373303
27449	44258	5	applied	\N	\N	\N	\N	206413	206413	373558
27454	44265	0	applied	\N	\N	\N	\N	206429	206429	373574
27454	44266	1	applied	\N	\N	\N	\N	206430	206430	373575
27454	44267	2	applied	\N	\N	\N	\N	206431	206431	373576
27455	44267	2	applied	\N	\N	\N	\N	206434	206434	373579
27457	44268	0	applied	\N	\N	\N	\N	206438	206438	373583
27457	44269	1	applied	\N	\N	\N	\N	206439	206439	373584
27457	44270	2	applied	\N	\N	\N	\N	206440	206440	373585
27460	44294	0	applied	\N	\N	\N	\N	206464	206464	373609
27460	44295	1	applied	\N	\N	\N	\N	206465	206465	373610
27460	44296	2	applied	\N	\N	\N	\N	206466	206466	373611
27460	44297	3	applied	\N	\N	\N	\N	206467	206467	373612
27460	44298	4	applied	\N	\N	\N	\N	206468	206468	373613
27460	44299	5	applied	\N	\N	\N	\N	206469	206469	373614
27460	44300	6	applied	\N	\N	\N	\N	206470	206470	373615
27460	44301	7	applied	\N	\N	\N	\N	206471	206471	373616
27462	44294	0	applied	\N	\N	\N	\N	206482	206482	373627
27463	44295	0	applied	\N	\N	\N	\N	206491	206491	373636
27463	44297	1	applied	\N	\N	\N	\N	206492	206492	373637
27463	44298	2	applied	\N	\N	\N	\N	206493	206493	373638
27463	44299	3	applied	\N	\N	\N	\N	206494	206494	373639
27463	44300	4	applied	\N	\N	\N	\N	206495	206495	373640
27463	44301	5	applied	\N	\N	\N	\N	206496	206496	373641
27467	44311	0	applied	\N	\N	\N	\N	206518	206518	373663
27467	44312	1	applied	\N	\N	\N	\N	206519	206519	373664
27467	44313	2	applied	\N	\N	\N	\N	206520	206520	373665
27467	44314	3	applied	\N	\N	\N	\N	206521	206521	373666
27467	44315	4	applied	\N	\N	\N	\N	206522	206522	373667
27467	44316	5	applied	\N	\N	\N	\N	206523	206523	373668
27467	44317	6	applied	\N	\N	\N	\N	206524	206524	373669
27467	44318	7	applied	\N	\N	\N	\N	206525	206525	373670
27467	44319	8	applied	\N	\N	\N	\N	206526	206526	373671
27467	44321	10	applied	\N	\N	\N	\N	206528	206528	373673
27467	44322	11	applied	\N	\N	\N	\N	206529	206529	373674
27467	44323	12	applied	\N	\N	\N	\N	206530	206530	373675
27467	44324	13	applied	\N	\N	\N	\N	206531	206531	373676
27467	44325	14	applied	\N	\N	\N	\N	206532	206532	373677
27467	44326	15	applied	\N	\N	\N	\N	206533	206533	373678
27467	44327	16	applied	\N	\N	\N	\N	206534	206534	373679
27467	44328	17	applied	\N	\N	\N	\N	206535	206535	373680
27467	44329	18	applied	\N	\N	\N	\N	206536	206536	373681
27467	44330	19	applied	\N	\N	\N	\N	206537	206537	373682
27467	44331	20	applied	\N	\N	\N	\N	206538	206538	373683
27467	44332	21	applied	\N	\N	\N	\N	206539	206539	373684
27467	44333	22	applied	\N	\N	\N	\N	206540	206540	373685
27467	44334	23	applied	\N	\N	\N	\N	206541	206541	373686
27472	44343	0	applied	\N	\N	\N	\N	206581	206581	373726
27472	44344	1	applied	\N	\N	\N	\N	206582	206582	373727
27472	44346	3	applied	\N	\N	\N	\N	206584	206584	373729
27472	44347	4	applied	\N	\N	\N	\N	206585	206585	373730
27472	44348	5	applied	\N	\N	\N	\N	206586	206586	373731
27472	44349	6	applied	\N	\N	\N	\N	206587	206587	373732
27473	44343	0	applied	\N	\N	\N	\N	206588	206588	373733
27473	44344	1	applied	\N	\N	\N	\N	206589	206589	373734
27473	44345	2	applied	\N	\N	\N	\N	206590	206590	373735
27473	44346	3	applied	\N	\N	\N	\N	206591	206591	373736
27473	44347	4	applied	\N	\N	\N	\N	206592	206592	373737
27473	44348	5	applied	\N	\N	\N	\N	206593	206593	373738
27473	44349	6	applied	\N	\N	\N	\N	206594	206594	373739
27485	44441	0	applied	\N	\N	\N	\N	206730	206730	373875
27485	44442	1	applied	\N	\N	\N	\N	206731	206731	373876
27485	44443	2	applied	\N	\N	\N	\N	206732	206732	373877
27485	44444	3	applied	\N	\N	\N	\N	206733	206733	373878
27485	44445	4	applied	\N	\N	\N	\N	206734	206734	373879
27485	44447	6	applied	\N	\N	\N	\N	206736	206736	373881
27485	44448	7	applied	\N	\N	\N	\N	206737	206737	373882
27490	44476	0	applied	\N	\N	\N	\N	206846	206846	373991
27490	44477	1	applied	\N	\N	\N	\N	206847	206847	373992
27490	44478	2	applied	\N	\N	\N	\N	206848	206848	373993
27490	44479	3	applied	\N	\N	\N	\N	206849	206849	373994
27490	44480	4	applied	\N	\N	\N	\N	206850	206850	373995
27490	44481	5	applied	\N	\N	\N	\N	206851	206851	373996
27490	44482	6	applied	\N	\N	\N	\N	206852	206852	373997
27490	44483	7	applied	\N	\N	\N	\N	206853	206853	373998
27490	44484	8	applied	\N	\N	\N	\N	206854	206854	373999
27490	44485	9	applied	\N	\N	\N	\N	206855	206855	374000
27493	44489	0	applied	\N	\N	\N	\N	206863	206863	374008
27493	44490	1	applied	\N	\N	\N	\N	206864	206864	374009
27493	44491	2	applied	\N	\N	\N	\N	206865	206865	374010
27493	44492	3	applied	\N	\N	\N	\N	206866	206866	374011
27500	44510	1	applied	\N	\N	\N	\N	206891	206891	374036
27500	44511	2	applied	\N	\N	\N	\N	206892	206892	374037
27502	44509	0	applied	\N	\N	\N	\N	206896	206896	374041
27502	44510	1	applied	\N	\N	\N	\N	206897	206897	374042
27502	44511	2	applied	\N	\N	\N	\N	206898	206898	374043
27505	44521	0	applied	\N	\N	\N	\N	206908	206908	374053
27505	44522	1	applied	\N	\N	\N	\N	206909	206909	374054
27505	44523	2	applied	\N	\N	\N	\N	206910	206910	374055
27505	44524	3	applied	\N	\N	\N	\N	206911	206911	374056
27505	44525	4	applied	\N	\N	\N	\N	206912	206912	374057
27505	44526	5	applied	\N	\N	\N	\N	206913	206913	374058
27507	44530	0	applied	\N	\N	\N	\N	206917	206917	374062
27507	44531	1	applied	\N	\N	\N	\N	206918	206918	374063
27507	44532	2	applied	\N	\N	\N	\N	206919	206919	374064
27507	44533	3	applied	\N	\N	\N	\N	206920	206920	374065
27507	44534	4	applied	\N	\N	\N	\N	206921	206921	374066
27507	44536	6	applied	\N	\N	\N	\N	206923	206923	374068
27507	44537	7	applied	\N	\N	\N	\N	206924	206924	374069
27507	44538	8	applied	\N	\N	\N	\N	206925	206925	374070
27507	44539	9	applied	\N	\N	\N	\N	206926	206926	374071
27507	44540	10	applied	\N	\N	\N	\N	206927	206927	374072
27507	44541	11	applied	\N	\N	\N	\N	206928	206928	374073
27507	44542	12	applied	\N	\N	\N	\N	206929	206929	374074
27507	44543	13	applied	\N	\N	\N	\N	206930	206930	374075
27507	44544	14	applied	\N	\N	\N	\N	206931	206931	374076
27508	44530	0	applied	\N	\N	\N	\N	206932	206932	374077
27508	44531	1	applied	\N	\N	\N	\N	206933	206933	374078
27508	44532	2	applied	\N	\N	\N	\N	206934	206934	374079
27508	44533	3	applied	\N	\N	\N	\N	206935	206935	374080
27508	44534	4	applied	\N	\N	\N	\N	206936	206936	374081
27449	44255	2	applied	\N	\N	\N	\N	206410	206410	373555
27449	44256	3	applied	\N	\N	\N	\N	206411	206411	373556
27462	44299	5	applied	\N	\N	\N	\N	206487	206487	373632
27462	44300	6	applied	\N	\N	\N	\N	206488	206488	373633
27462	44301	7	applied	\N	\N	\N	\N	206489	206489	373634
27462	44302	8	applied	\N	\N	\N	\N	206490	206490	373635
27466	44303	0	applied	\N	\N	\N	\N	206510	206510	373655
27466	44304	1	applied	\N	\N	\N	\N	206511	206511	373656
27466	44305	2	applied	\N	\N	\N	\N	206512	206512	373657
27466	44306	3	applied	\N	\N	\N	\N	206513	206513	373658
27466	44307	4	applied	\N	\N	\N	\N	206514	206514	373659
27466	44308	5	applied	\N	\N	\N	\N	206515	206515	373660
27466	44309	6	applied	\N	\N	\N	\N	206516	206516	373661
27466	44310	7	applied	\N	\N	\N	\N	206517	206517	373662
27468	44311	0	applied	\N	\N	\N	\N	206542	206542	373687
27468	44312	1	applied	\N	\N	\N	\N	206543	206543	373688
27468	44313	2	applied	\N	\N	\N	\N	206544	206544	373689
27468	44314	3	applied	\N	\N	\N	\N	206545	206545	373690
27468	44316	5	applied	\N	\N	\N	\N	206547	206547	373692
27468	44317	6	applied	\N	\N	\N	\N	206548	206548	373693
27468	44318	7	applied	\N	\N	\N	\N	206549	206549	373694
27468	44319	8	applied	\N	\N	\N	\N	206550	206550	373695
27468	44320	9	applied	\N	\N	\N	\N	206551	206551	373696
27468	44321	10	applied	\N	\N	\N	\N	206552	206552	373697
27468	44322	11	applied	\N	\N	\N	\N	206553	206553	373698
27468	44323	12	applied	\N	\N	\N	\N	206554	206554	373699
27468	44324	13	applied	\N	\N	\N	\N	206555	206555	373700
27468	44325	14	applied	\N	\N	\N	\N	206556	206556	373701
27468	44326	15	applied	\N	\N	\N	\N	206557	206557	373702
27468	44327	16	applied	\N	\N	\N	\N	206558	206558	373703
27468	44328	17	applied	\N	\N	\N	\N	206559	206559	373704
27468	44329	18	applied	\N	\N	\N	\N	206560	206560	373705
27468	44330	19	applied	\N	\N	\N	\N	206561	206561	373706
27468	44331	20	applied	\N	\N	\N	\N	206562	206562	373707
27468	44333	22	applied	\N	\N	\N	\N	206564	206564	373709
27468	44334	23	applied	\N	\N	\N	\N	206565	206565	373710
27477	44350	0	applied	\N	\N	\N	\N	206595	206595	373740
27477	44351	1	applied	\N	\N	\N	\N	206596	206596	373741
27477	44352	2	applied	\N	\N	\N	\N	206597	206597	373742
27477	44353	3	applied	\N	\N	\N	\N	206598	206598	373743
27477	44354	4	applied	\N	\N	\N	\N	206599	206599	373744
27477	44355	5	applied	\N	\N	\N	\N	206600	206600	373745
27477	44356	6	applied	\N	\N	\N	\N	206601	206601	373746
27477	44357	7	applied	\N	\N	\N	\N	206602	206602	373747
27477	44358	8	applied	\N	\N	\N	\N	206603	206603	373748
27477	44359	9	applied	\N	\N	\N	\N	206604	206604	373749
27477	44360	10	applied	\N	\N	\N	\N	206605	206605	373750
27477	44361	11	applied	\N	\N	\N	\N	206606	206606	373751
27477	44362	12	applied	\N	\N	\N	\N	206607	206607	373752
27477	44363	13	applied	\N	\N	\N	\N	206608	206608	373753
27477	44365	15	applied	\N	\N	\N	\N	206610	206610	373755
27477	44366	16	applied	\N	\N	\N	\N	206611	206611	373756
27477	44367	17	applied	\N	\N	\N	\N	206612	206612	373757
27477	44368	18	applied	\N	\N	\N	\N	206613	206613	373758
27477	44369	19	applied	\N	\N	\N	\N	206614	206614	373759
27477	44370	20	applied	\N	\N	\N	\N	206615	206615	373760
27477	44371	21	applied	\N	\N	\N	\N	206616	206616	373761
27477	44372	22	applied	\N	\N	\N	\N	206617	206617	373762
27477	44373	23	applied	\N	\N	\N	\N	206618	206618	373763
27477	44374	24	applied	\N	\N	\N	\N	206619	206619	373764
27477	44375	25	applied	\N	\N	\N	\N	206620	206620	373765
27479	44376	0	applied	\N	\N	\N	\N	206647	206647	373792
27479	44377	1	applied	\N	\N	\N	\N	206648	206648	373793
27479	44378	2	applied	\N	\N	\N	\N	206649	206649	373794
27479	44379	3	applied	\N	\N	\N	\N	206650	206650	373795
27479	44380	4	applied	\N	\N	\N	\N	206651	206651	373796
27479	44382	6	applied	\N	\N	\N	\N	206653	206653	373798
27479	44383	7	applied	\N	\N	\N	\N	206654	206654	373799
27480	44400	16	applied	\N	\N	\N	\N	206671	206671	373816
27480	44401	17	applied	\N	\N	\N	\N	206672	206672	373817
27481	44384	0	applied	\N	\N	\N	\N	206673	206673	373818
27481	44385	1	applied	\N	\N	\N	\N	206674	206674	373819
27481	44386	2	applied	\N	\N	\N	\N	206675	206675	373820
27481	44387	3	applied	\N	\N	\N	\N	206676	206676	373821
27481	44388	4	applied	\N	\N	\N	\N	206677	206677	373822
27481	44389	5	applied	\N	\N	\N	\N	206678	206678	373823
27481	44390	6	applied	\N	\N	\N	\N	206679	206679	373824
27482	44402	0	applied	\N	\N	\N	\N	206691	206691	373836
27482	44403	1	applied	\N	\N	\N	\N	206692	206692	373837
27482	44404	2	applied	\N	\N	\N	\N	206693	206693	373838
27482	44405	3	applied	\N	\N	\N	\N	206694	206694	373839
27482	44406	4	applied	\N	\N	\N	\N	206695	206695	373840
27482	44408	6	applied	\N	\N	\N	\N	206697	206697	373842
27482	44409	7	applied	\N	\N	\N	\N	206698	206698	373843
27482	44410	8	applied	\N	\N	\N	\N	206699	206699	373844
27486	44449	0	applied	\N	\N	\N	\N	206738	206738	373883
27486	44450	1	applied	\N	\N	\N	\N	206739	206739	373884
27486	44451	2	applied	\N	\N	\N	\N	206740	206740	373885
27486	44452	3	applied	\N	\N	\N	\N	206741	206741	373886
27486	44453	4	applied	\N	\N	\N	\N	206742	206742	373887
27486	44454	5	applied	\N	\N	\N	\N	206743	206743	373888
27486	44455	6	applied	\N	\N	\N	\N	206744	206744	373889
27486	44456	7	applied	\N	\N	\N	\N	206745	206745	373890
27486	44457	8	applied	\N	\N	\N	\N	206746	206746	373891
27486	44458	9	applied	\N	\N	\N	\N	206747	206747	373892
27486	44459	10	applied	\N	\N	\N	\N	206748	206748	373893
27486	44460	11	applied	\N	\N	\N	\N	206749	206749	373894
27486	44461	12	applied	\N	\N	\N	\N	206750	206750	373895
27486	44463	15	applied	\N	\N	\N	\N	206752	206752	373897
27486	44464	16	applied	\N	\N	\N	\N	206753	206753	373898
27486	44465	17	applied	\N	\N	\N	\N	206754	206754	373899
27486	44466	18	applied	\N	\N	\N	\N	206755	206755	373900
27486	44467	19	applied	\N	\N	\N	\N	206756	206756	373901
27486	44468	20	applied	\N	\N	\N	\N	206757	206757	373902
27486	44469	21	applied	\N	\N	\N	\N	206758	206758	373903
27486	44470	22	applied	\N	\N	\N	\N	206759	206759	373904
27486	44471	23	applied	\N	\N	\N	\N	206760	206760	373905
27486	44472	24	applied	\N	\N	\N	\N	206761	206761	373906
27486	44473	25	applied	\N	\N	\N	\N	206762	206762	373907
27486	44474	26	applied	\N	\N	\N	\N	206763	206763	373908
27486	44475	27	applied	\N	\N	\N	\N	206764	206764	373909
27496	44502	0	applied	\N	\N	\N	\N	206876	206876	374021
27462	44296	2	applied	\N	\N	\N	\N	206484	206484	373629
27462	44297	3	applied	\N	\N	\N	\N	206485	206485	373630
27481	44395	11	applied	\N	\N	\N	\N	206684	206684	373829
27481	44396	12	applied	\N	\N	\N	\N	206685	206685	373830
27481	44397	13	applied	\N	\N	\N	\N	206686	206686	373831
27481	44398	14	applied	\N	\N	\N	\N	206687	206687	373832
27481	44399	15	applied	\N	\N	\N	\N	206688	206688	373833
27481	44400	16	applied	\N	\N	\N	\N	206689	206689	373834
27481	44401	17	applied	\N	\N	\N	\N	206690	206690	373835
27483	44411	0	applied	\N	\N	\N	\N	206700	206700	373845
27483	44412	1	applied	\N	\N	\N	\N	206701	206701	373846
27483	44413	2	applied	\N	\N	\N	\N	206702	206702	373847
27483	44414	3	applied	\N	\N	\N	\N	206703	206703	373848
27483	44415	4	applied	\N	\N	\N	\N	206704	206704	373849
27483	44416	5	applied	\N	\N	\N	\N	206705	206705	373850
27484	44435	18	applied	\N	\N	\N	\N	206724	206724	373869
27484	44436	19	applied	\N	\N	\N	\N	206725	206725	373870
27484	44437	20	applied	\N	\N	\N	\N	206726	206726	373871
27484	44439	22	applied	\N	\N	\N	\N	206728	206728	373873
27484	44440	23	applied	\N	\N	\N	\N	206729	206729	373874
27487	44449	0	applied	\N	\N	\N	\N	206765	206765	373910
27487	44450	1	applied	\N	\N	\N	\N	206766	206766	373911
27487	44451	2	applied	\N	\N	\N	\N	206767	206767	373912
27487	44452	3	applied	\N	\N	\N	\N	206768	206768	373913
27487	44453	4	applied	\N	\N	\N	\N	206769	206769	373914
27487	44454	5	applied	\N	\N	\N	\N	206770	206770	373915
27487	44455	6	applied	\N	\N	\N	\N	206771	206771	373916
27487	44456	7	applied	\N	\N	\N	\N	206772	206772	373917
27487	44457	8	applied	\N	\N	\N	\N	206773	206773	373918
27487	44458	9	applied	\N	\N	\N	\N	206774	206774	373919
27487	44459	10	applied	\N	\N	\N	\N	206775	206775	373920
27487	44460	11	applied	\N	\N	\N	\N	206776	206776	373921
27487	44461	12	applied	\N	\N	\N	\N	206777	206777	373922
27487	44462	13	applied	\N	\N	\N	\N	206778	206778	373923
27487	44464	16	applied	\N	\N	\N	\N	206780	206780	373925
27487	44465	17	applied	\N	\N	\N	\N	206781	206781	373926
27487	44466	18	applied	\N	\N	\N	\N	206782	206782	373927
27487	44467	19	applied	\N	\N	\N	\N	206783	206783	373928
27487	44468	20	applied	\N	\N	\N	\N	206784	206784	373929
27487	44469	21	applied	\N	\N	\N	\N	206785	206785	373930
27487	44470	22	applied	\N	\N	\N	\N	206786	206786	373931
27487	44471	23	applied	\N	\N	\N	\N	206787	206787	373932
27487	44472	24	applied	\N	\N	\N	\N	206788	206788	373933
27487	44473	25	applied	\N	\N	\N	\N	206789	206789	373934
27487	44474	26	applied	\N	\N	\N	\N	206790	206790	373935
27487	44475	27	applied	\N	\N	\N	\N	206791	206791	373936
27488	44449	0	applied	\N	\N	\N	\N	206792	206792	373937
27488	44450	1	applied	\N	\N	\N	\N	206793	206793	373938
27488	44451	2	applied	\N	\N	\N	\N	206794	206794	373939
27489	44449	0	applied	\N	\N	\N	\N	206819	206819	373964
27489	44451	2	applied	\N	\N	\N	\N	206821	206821	373966
27489	44452	3	applied	\N	\N	\N	\N	206822	206822	373967
27489	44453	4	applied	\N	\N	\N	\N	206823	206823	373968
27489	44454	5	applied	\N	\N	\N	\N	206824	206824	373969
27489	44455	6	applied	\N	\N	\N	\N	206825	206825	373970
27489	44456	7	applied	\N	\N	\N	\N	206826	206826	373971
27489	44457	8	applied	\N	\N	\N	\N	206827	206827	373972
27489	44458	9	applied	\N	\N	\N	\N	206828	206828	373973
27489	44459	10	applied	\N	\N	\N	\N	206829	206829	373974
27489	44460	11	applied	\N	\N	\N	\N	206830	206830	373975
27489	44461	12	applied	\N	\N	\N	\N	206831	206831	373976
27489	44462	13	applied	\N	\N	\N	\N	206832	206832	373977
27489	44463	15	applied	\N	\N	\N	\N	206833	206833	373978
27489	44464	16	applied	\N	\N	\N	\N	206834	206834	373979
27489	44465	17	applied	\N	\N	\N	\N	206835	206835	373980
27489	44466	18	applied	\N	\N	\N	\N	206836	206836	373981
27489	44468	20	applied	\N	\N	\N	\N	206838	206838	373983
27489	44469	21	applied	\N	\N	\N	\N	206839	206839	373984
27489	44470	22	applied	\N	\N	\N	\N	206840	206840	373985
27489	44471	23	applied	\N	\N	\N	\N	206841	206841	373986
27489	44472	24	applied	\N	\N	\N	\N	206842	206842	373987
27489	44473	25	applied	\N	\N	\N	\N	206843	206843	373988
27489	44474	26	applied	\N	\N	\N	\N	206844	206844	373989
27489	44475	27	applied	\N	\N	\N	\N	206845	206845	373990
27491	44486	0	applied	\N	\N	\N	\N	206856	206856	374001
27491	44487	1	applied	\N	\N	\N	\N	206857	206857	374002
27491	44488	2	applied	\N	\N	\N	\N	206858	206858	374003
27494	44493	0	applied	\N	\N	\N	\N	206867	206867	374012
27494	44494	1	applied	\N	\N	\N	\N	206868	206868	374013
27494	44495	2	applied	\N	\N	\N	\N	206869	206869	374014
27494	44496	3	applied	\N	\N	\N	\N	206870	206870	374015
27494	44497	4	applied	\N	\N	\N	\N	206871	206871	374016
27504	44518	0	applied	\N	\N	\N	\N	206905	206905	374050
27504	44519	1	applied	\N	\N	\N	\N	206906	206906	374051
27504	44520	2	applied	\N	\N	\N	\N	206907	206907	374052
27509	44545	0	applied	\N	\N	\N	\N	206947	206947	374092
27509	44546	1	applied	\N	\N	\N	\N	206948	206948	374093
27509	44547	2	applied	\N	\N	\N	\N	206949	206949	374094
27509	44548	3	applied	\N	\N	\N	\N	206950	206950	374095
27509	44549	4	applied	\N	\N	\N	\N	206951	206951	374096
27509	44550	5	applied	\N	\N	\N	\N	206952	206952	374097
27509	44551	6	applied	\N	\N	\N	\N	206953	206953	374098
27509	44552	7	applied	\N	\N	\N	\N	206954	206954	374099
27509	44553	8	applied	\N	\N	\N	\N	206955	206955	374100
27518	44560	0	applied	\N	\N	\N	\N	206978	206978	374123
27518	44561	1	applied	\N	\N	\N	\N	206979	206979	374124
27521	44582	0	applied	\N	\N	\N	\N	207000	207000	374145
27521	44583	1	applied	\N	\N	\N	\N	207001	207001	374146
27521	44585	3	applied	\N	\N	\N	\N	207003	207003	374148
27524	44596	0	applied	\N	\N	\N	\N	207014	207014	374159
27524	44597	1	applied	\N	\N	\N	\N	207015	207015	374160
27524	44598	2	applied	\N	\N	\N	\N	207016	207016	374161
27531	44605	0	applied	\N	\N	\N	\N	207125	207125	374270
27531	44606	1	applied	\N	\N	\N	\N	207126	207126	374271
27533	44607	0	applied	\N	\N	\N	\N	207130	207130	374275
27533	44608	1	applied	\N	\N	\N	\N	207131	207131	374276
27533	44609	2	applied	\N	\N	\N	\N	207132	207132	374277
27535	44610	0	applied	\N	\N	\N	\N	207207	207207	374352
27535	44611	1	applied	\N	\N	\N	\N	207208	207208	374353
27535	44612	2	applied	\N	\N	\N	\N	207209	207209	374354
27535	44613	3	applied	\N	\N	\N	\N	207210	207210	374355
27535	44614	4	applied	\N	\N	\N	\N	207211	207211	374356
27481	44392	8	applied	\N	\N	\N	\N	206681	206681	373826
27481	44393	9	applied	\N	\N	\N	\N	206682	206682	373827
27488	44456	7	applied	\N	\N	\N	\N	206799	206799	373944
27488	44457	8	applied	\N	\N	\N	\N	206800	206800	373945
27488	44458	9	applied	\N	\N	\N	\N	206801	206801	373946
27488	44459	10	applied	\N	\N	\N	\N	206802	206802	373947
27488	44460	11	applied	\N	\N	\N	\N	206803	206803	373948
27488	44461	12	applied	\N	\N	\N	\N	206804	206804	373949
27488	44462	13	applied	\N	\N	\N	\N	206805	206805	373950
27488	44463	15	applied	\N	\N	\N	\N	206806	206806	373951
27488	44464	16	applied	\N	\N	\N	\N	206807	206807	373952
27488	44465	17	applied	\N	\N	\N	\N	206808	206808	373953
27488	44466	18	applied	\N	\N	\N	\N	206809	206809	373954
27488	44467	19	applied	\N	\N	\N	\N	206810	206810	373955
27488	44468	20	applied	\N	\N	\N	\N	206811	206811	373956
27488	44469	21	applied	\N	\N	\N	\N	206812	206812	373957
27488	44470	22	applied	\N	\N	\N	\N	206813	206813	373958
27488	44471	23	applied	\N	\N	\N	\N	206814	206814	373959
27488	44473	25	applied	\N	\N	\N	\N	206816	206816	373961
27488	44474	26	applied	\N	\N	\N	\N	206817	206817	373962
27488	44475	27	applied	\N	\N	\N	\N	206818	206818	373963
27492	44489	0	applied	\N	\N	\N	\N	206859	206859	374004
27492	44490	1	applied	\N	\N	\N	\N	206860	206860	374005
27492	44491	2	applied	\N	\N	\N	\N	206861	206861	374006
27492	44492	3	applied	\N	\N	\N	\N	206862	206862	374007
27495	44499	0	applied	\N	\N	\N	\N	206873	206873	374018
27495	44500	1	applied	\N	\N	\N	\N	206874	206874	374019
27495	44501	2	applied	\N	\N	\N	\N	206875	206875	374020
27496	44503	1	applied	\N	\N	\N	\N	206877	206877	374022
27496	44504	2	applied	\N	\N	\N	\N	206878	206878	374023
27497	44502	0	applied	\N	\N	\N	\N	206879	206879	374024
27497	44503	1	applied	\N	\N	\N	\N	206880	206880	374025
27497	44504	2	applied	\N	\N	\N	\N	206881	206881	374026
27498	44505	0	applied	\N	\N	\N	\N	206882	206882	374027
27498	44507	2	applied	\N	\N	\N	\N	206884	206884	374029
27498	44508	3	applied	\N	\N	\N	\N	206885	206885	374030
27499	44505	0	applied	\N	\N	\N	\N	206886	206886	374031
27499	44506	1	applied	\N	\N	\N	\N	206887	206887	374032
27499	44507	2	applied	\N	\N	\N	\N	206888	206888	374033
27506	44527	0	applied	\N	\N	\N	\N	206914	206914	374059
27506	44528	1	applied	\N	\N	\N	\N	206915	206915	374060
27506	44529	2	applied	\N	\N	\N	\N	206916	206916	374061
27510	44554	0	applied	\N	\N	\N	\N	206956	206956	374101
27510	44555	1	applied	\N	\N	\N	\N	206957	206957	374102
27510	44556	2	applied	\N	\N	\N	\N	206958	206958	374103
27512	44554	0	applied	\N	\N	\N	\N	206962	206962	374107
27512	44556	1	applied	\N	\N	\N	\N	206963	206963	374108
27514	44557	0	applied	\N	\N	\N	\N	206966	206966	374111
27514	44558	2	applied	\N	\N	\N	\N	206967	206967	374112
27514	44559	3	applied	\N	\N	\N	\N	206968	206968	374113
27516	44558	2	applied	\N	\N	\N	\N	206973	206973	374118
27516	44559	3	applied	\N	\N	\N	\N	206974	206974	374119
27522	44586	0	applied	\N	\N	\N	\N	207004	207004	374149
27522	44587	1	applied	\N	\N	\N	\N	207005	207005	374150
27522	44588	2	applied	\N	\N	\N	\N	207006	207006	374151
27525	44596	0	applied	\N	\N	\N	\N	207017	207017	374162
27525	44597	1	applied	\N	\N	\N	\N	207018	207018	374163
27525	44598	2	applied	\N	\N	\N	\N	207019	207019	374164
27529	44599	0	applied	\N	\N	\N	\N	207113	207113	374258
27529	44600	1	applied	\N	\N	\N	\N	207114	207114	374259
27529	44601	2	applied	\N	\N	\N	\N	207115	207115	374260
27529	44602	3	applied	\N	\N	\N	\N	207116	207116	374261
27529	44603	4	applied	\N	\N	\N	\N	207117	207117	374262
27529	44604	5	applied	\N	\N	\N	\N	207118	207118	374263
27536	44610	0	applied	\N	\N	\N	\N	207214	207214	374359
27536	44611	1	applied	\N	\N	\N	\N	207215	207215	374360
27536	44613	3	applied	\N	\N	\N	\N	207217	207217	374362
27536	44614	4	applied	\N	\N	\N	\N	207218	207218	374363
27536	44615	5	applied	\N	\N	\N	\N	207219	207219	374364
27536	44616	6	applied	\N	\N	\N	\N	207220	207220	374365
27540	44617	0	applied	\N	\N	\N	\N	207234	207234	374379
27540	44618	1	applied	\N	\N	\N	\N	207235	207235	374380
27540	44619	2	applied	\N	\N	\N	\N	207236	207236	374381
27545	44624	0	applied	\N	\N	\N	\N	207252	207252	374397
27545	44625	1	applied	\N	\N	\N	\N	207253	207253	374398
27545	44626	2	applied	\N	\N	\N	\N	207254	207254	374399
27545	44627	3	applied	\N	\N	\N	\N	207255	207255	374400
27545	44628	4	applied	\N	\N	\N	\N	207256	207256	374401
27545	44629	5	applied	\N	\N	\N	\N	207257	207257	374402
27545	44630	6	applied	\N	\N	\N	\N	207258	207258	374403
27545	44631	7	applied	\N	\N	\N	\N	207259	207259	374404
27545	44632	8	applied	\N	\N	\N	\N	207260	207260	374405
27552	44645	1	applied	\N	\N	\N	\N	207294	207294	374439
27552	44646	2	applied	\N	\N	\N	\N	207295	207295	374440
27552	44647	3	applied	\N	\N	\N	\N	207296	207296	374441
27556	44648	0	applied	\N	\N	\N	\N	207309	207309	374454
27556	44649	1	applied	\N	\N	\N	\N	207310	207310	374455
27556	44650	2	applied	\N	\N	\N	\N	207311	207311	374456
27563	44657	0	applied	\N	\N	\N	\N	207332	207332	374477
27563	44658	1	applied	\N	\N	\N	\N	207333	207333	374478
27563	44659	2	applied	\N	\N	\N	\N	207334	207334	374479
27565	44657	0	applied	\N	\N	\N	\N	207338	207338	374483
27565	44658	1	applied	\N	\N	\N	\N	207339	207339	374484
27565	44659	2	applied	\N	\N	\N	\N	207340	207340	374485
27577	44563	0	applied	\N	\N	\N	\N	207377	207377	374522
27577	44565	1	applied	\N	\N	\N	\N	207378	207378	374523
27577	44571	2	applied	\N	\N	\N	\N	207379	207379	374524
27577	44506	3	applied	\N	\N	\N	\N	207380	207380	374525
27577	44583	5	applied	\N	\N	\N	\N	207382	207382	374527
27577	44387	6	applied	\N	\N	\N	\N	207383	207383	374528
27577	44222	7	applied	\N	\N	\N	\N	207384	207384	374529
27577	44223	8	applied	\N	\N	\N	\N	207385	207385	374530
27577	44224	9	applied	\N	\N	\N	\N	207386	207386	374531
27577	44274	10	applied	\N	\N	\N	\N	207387	207387	374532
27577	44229	11	applied	\N	\N	\N	\N	207388	207388	374533
27577	44275	12	applied	\N	\N	\N	\N	207389	207389	374534
27577	44233	13	applied	\N	\N	\N	\N	207390	207390	374535
27577	44235	14	applied	\N	\N	\N	\N	207391	207391	374536
27577	44239	15	applied	\N	\N	\N	\N	207392	207392	374537
27577	44276	16	applied	\N	\N	\N	\N	207393	207393	374538
27577	44277	17	applied	\N	\N	\N	\N	207394	207394	374539
27577	44278	18	applied	\N	\N	\N	\N	207395	207395	374540
27488	44453	4	applied	\N	\N	\N	\N	206796	206796	373941
27488	44454	5	applied	\N	\N	\N	\N	206797	206797	373942
27501	44511	2	applied	\N	\N	\N	\N	206895	206895	374040
27503	44512	0	applied	\N	\N	\N	\N	206899	206899	374044
27503	44513	1	applied	\N	\N	\N	\N	206900	206900	374045
27503	44514	2	applied	\N	\N	\N	\N	206901	206901	374046
27503	44515	3	applied	\N	\N	\N	\N	206902	206902	374047
27503	44517	5	applied	\N	\N	\N	\N	206904	206904	374049
27508	44535	5	applied	\N	\N	\N	\N	206937	206937	374082
27508	44536	6	applied	\N	\N	\N	\N	206938	206938	374083
27508	44537	7	applied	\N	\N	\N	\N	206939	206939	374084
27508	44538	8	applied	\N	\N	\N	\N	206940	206940	374085
27508	44539	9	applied	\N	\N	\N	\N	206941	206941	374086
27508	44540	10	applied	\N	\N	\N	\N	206942	206942	374087
27508	44541	11	applied	\N	\N	\N	\N	206943	206943	374088
27508	44542	12	applied	\N	\N	\N	\N	206944	206944	374089
27508	44543	13	applied	\N	\N	\N	\N	206945	206945	374090
27511	44554	0	applied	\N	\N	\N	\N	206959	206959	374104
27511	44555	1	applied	\N	\N	\N	\N	206960	206960	374105
27511	44556	2	applied	\N	\N	\N	\N	206961	206961	374106
27513	44557	0	applied	\N	\N	\N	\N	206964	206964	374109
27513	44558	2	applied	\N	\N	\N	\N	206965	206965	374110
27517	44560	0	applied	\N	\N	\N	\N	206975	206975	374120
27517	44562	2	applied	\N	\N	\N	\N	206977	206977	374122
27520	44568	0	applied	\N	\N	\N	\N	206986	206986	374131
27520	44569	1	applied	\N	\N	\N	\N	206987	206987	374132
27520	44570	2	applied	\N	\N	\N	\N	206988	206988	374133
27520	44571	3	applied	\N	\N	\N	\N	206989	206989	374134
27520	44572	4	applied	\N	\N	\N	\N	206990	206990	374135
27520	44573	5	applied	\N	\N	\N	\N	206991	206991	374136
27520	44574	6	applied	\N	\N	\N	\N	206992	206992	374137
27520	44575	7	applied	\N	\N	1000000000	\N	206993	206993	374138
27520	44576	8	applied	\N	\N	\N	\N	206994	206994	374139
27520	44577	9	applied	\N	\N	\N	\N	206995	206995	374140
27520	44578	10	applied	\N	\N	1000000000	\N	206996	206996	374141
27520	44579	11	applied	\N	\N	\N	\N	206997	206997	374142
27520	44580	12	applied	\N	\N	1000000000	\N	206998	206998	374143
27520	44581	13	applied	\N	\N	\N	\N	206999	206999	374144
27523	44589	0	applied	\N	\N	\N	\N	207007	207007	374152
27523	44591	2	applied	\N	\N	\N	\N	207009	207009	374154
27523	44592	3	applied	\N	\N	\N	\N	207010	207010	374155
27523	44593	4	applied	\N	\N	\N	\N	207011	207011	374156
27523	44594	5	applied	\N	\N	\N	\N	207012	207012	374157
27523	44595	6	applied	\N	\N	\N	\N	207013	207013	374158
27528	44563	0	applied	\N	\N	\N	\N	207025	207025	374170
27528	44565	1	applied	\N	\N	\N	\N	207026	207026	374171
27528	44571	2	applied	\N	\N	\N	\N	207027	207027	374172
27528	44506	3	applied	\N	\N	\N	\N	207028	207028	374173
27528	44273	4	applied	\N	\N	\N	\N	207029	207029	374174
27528	44583	5	applied	\N	\N	\N	\N	207030	207030	374175
27528	44387	6	applied	\N	\N	\N	\N	207031	207031	374176
27528	44274	7	applied	\N	\N	\N	\N	207032	207032	374177
27528	44575	8	applied	\N	\N	1000000000	\N	207033	207033	374178
27528	44275	9	applied	\N	\N	\N	\N	207034	207034	374179
27528	44579	11	applied	\N	\N	\N	\N	207036	207036	374181
27528	44580	12	applied	\N	\N	1000000000	\N	207037	207037	374182
27528	44276	13	applied	\N	\N	\N	\N	207038	207038	374183
27528	44277	14	applied	\N	\N	\N	\N	207039	207039	374184
27528	44278	15	applied	\N	\N	\N	\N	207040	207040	374185
27528	44279	16	applied	\N	\N	\N	\N	207041	207041	374186
27528	44280	17	applied	\N	\N	\N	\N	207042	207042	374187
27528	44286	18	applied	\N	\N	\N	\N	207043	207043	374188
27528	44287	19	applied	\N	\N	\N	\N	207044	207044	374189
27528	44290	20	applied	\N	\N	\N	\N	207045	207045	374190
27528	44291	21	applied	\N	\N	\N	\N	207046	207046	374191
27528	44292	22	applied	\N	\N	\N	\N	207047	207047	374192
27528	44293	23	applied	\N	\N	\N	\N	207048	207048	374193
27528	44297	24	applied	\N	\N	\N	\N	207049	207049	374194
27528	44298	25	applied	\N	\N	\N	\N	207050	207050	374195
27528	44299	26	applied	\N	\N	\N	\N	207051	207051	374196
27528	44300	27	applied	\N	\N	\N	\N	207052	207052	374197
27528	44301	28	applied	\N	\N	\N	\N	207053	207053	374198
27528	44302	29	applied	\N	\N	\N	\N	207054	207054	374199
27528	44305	31	applied	\N	\N	\N	\N	207056	207056	374201
27528	44306	32	applied	\N	\N	\N	\N	207057	207057	374202
27528	44307	33	applied	\N	\N	\N	\N	207058	207058	374203
27528	44308	34	applied	\N	\N	\N	\N	207059	207059	374204
27528	44314	35	applied	\N	\N	\N	\N	207060	207060	374205
27528	44315	36	applied	\N	\N	\N	\N	207061	207061	374206
27528	44316	37	applied	\N	\N	\N	\N	207062	207062	374207
27528	44317	38	applied	\N	\N	\N	\N	207063	207063	374208
27528	44318	39	applied	\N	\N	\N	\N	207064	207064	374209
27528	44319	40	applied	\N	\N	\N	\N	207065	207065	374210
27528	44320	41	applied	\N	\N	\N	\N	207066	207066	374211
27528	44321	42	applied	\N	\N	\N	\N	207067	207067	374212
27528	44322	43	applied	\N	\N	\N	\N	207068	207068	374213
27528	44326	44	applied	\N	\N	\N	\N	207069	207069	374214
27528	44327	45	applied	\N	\N	\N	\N	207070	207070	374215
27528	44328	46	applied	\N	\N	\N	\N	207071	207071	374216
27528	44330	48	applied	\N	\N	\N	\N	207073	207073	374218
27528	44595	49	applied	\N	\N	\N	\N	207074	207074	374219
27528	44331	50	applied	\N	\N	\N	\N	207075	207075	374220
27528	44338	51	applied	\N	\N	\N	\N	207076	207076	374221
27528	44339	52	applied	\N	\N	\N	\N	207077	207077	374222
27528	44344	53	applied	\N	\N	\N	\N	207078	207078	374223
27528	44346	54	applied	\N	\N	\N	\N	207079	207079	374224
27528	44347	55	applied	\N	\N	\N	\N	207080	207080	374225
27528	44348	56	applied	\N	\N	\N	\N	207081	207081	374226
27528	44349	57	applied	\N	\N	\N	\N	207082	207082	374227
27528	44356	58	applied	\N	\N	\N	\N	207083	207083	374228
27528	44243	59	applied	\N	\N	\N	\N	207084	207084	374229
27528	44358	60	applied	\N	\N	\N	\N	207085	207085	374230
27528	44359	61	applied	\N	\N	\N	\N	207086	207086	374231
27528	44360	62	applied	\N	\N	\N	\N	207087	207087	374232
27528	44361	63	applied	\N	\N	\N	\N	207088	207088	374233
27528	44363	65	applied	\N	\N	\N	\N	207090	207090	374235
27528	44364	66	applied	\N	\N	\N	\N	207091	207091	374236
27528	44365	67	applied	\N	\N	\N	\N	207092	207092	374237
27528	44366	68	applied	\N	\N	\N	\N	207093	207093	374238
27528	44367	69	applied	\N	\N	\N	\N	207094	207094	374239
27528	44368	70	applied	\N	\N	\N	\N	207095	207095	374240
27501	44509	0	applied	\N	\N	\N	\N	206893	206893	374038
27501	44510	1	applied	\N	\N	\N	\N	206894	206894	374039
27519	44563	0	applied	\N	\N	\N	\N	206980	206980	374125
27519	44564	1	applied	\N	\N	\N	\N	206981	206981	374126
27519	44565	2	applied	\N	\N	\N	\N	206982	206982	374127
27519	44566	3	applied	\N	\N	\N	\N	206983	206983	374128
27519	44562	4	applied	\N	\N	\N	\N	206984	206984	374129
27519	44567	5	applied	\N	\N	\N	\N	206985	206985	374130
27526	44596	0	applied	\N	\N	\N	\N	207020	207020	374165
27526	44597	1	applied	\N	\N	\N	\N	207021	207021	374166
27526	44598	2	applied	\N	\N	\N	\N	207022	207022	374167
27527	44596	0	applied	\N	\N	\N	\N	207023	207023	374168
27527	44597	1	applied	\N	\N	\N	\N	207024	207024	374169
27528	44369	71	applied	\N	\N	\N	\N	207096	207096	374241
27528	44370	72	applied	\N	\N	\N	\N	207097	207097	374242
27528	44371	73	applied	\N	\N	\N	\N	207098	207098	374243
27528	44372	74	applied	\N	\N	\N	\N	207099	207099	374244
27528	44373	75	applied	\N	\N	\N	\N	207100	207100	374245
27528	44378	77	applied	\N	\N	\N	\N	207102	207102	374247
27528	44379	78	applied	\N	\N	\N	\N	207103	207103	374248
27528	44380	79	applied	\N	\N	\N	\N	207104	207104	374249
27530	44599	0	applied	\N	\N	\N	\N	207119	207119	374264
27530	44600	1	applied	\N	\N	\N	\N	207120	207120	374265
27530	44601	2	applied	\N	\N	\N	\N	207121	207121	374266
27530	44602	3	applied	\N	\N	\N	\N	207122	207122	374267
27530	44603	4	applied	\N	\N	\N	\N	207123	207123	374268
27530	44604	5	applied	\N	\N	\N	\N	207124	207124	374269
27532	44607	0	applied	\N	\N	\N	\N	207127	207127	374272
27532	44608	1	applied	\N	\N	\N	\N	207128	207128	374273
27532	44609	2	applied	\N	\N	\N	\N	207129	207129	374274
27534	43858	0	applied	\N	\N	\N	\N	207133	207133	374278
27534	43861	1	applied	\N	\N	\N	\N	207134	207134	374279
27534	43864	2	applied	\N	\N	\N	\N	207135	207135	374280
27534	43867	3	applied	\N	\N	\N	\N	207136	207136	374281
27534	43870	5	applied	\N	\N	\N	\N	207138	207138	374283
27534	43873	6	applied	\N	\N	\N	\N	207139	207139	374284
27534	43876	7	applied	\N	\N	\N	\N	207140	207140	374285
27534	43877	8	applied	\N	\N	\N	\N	207141	207141	374286
27534	43882	9	applied	\N	\N	\N	\N	207142	207142	374287
27534	43885	10	applied	\N	\N	\N	\N	207143	207143	374288
27534	43888	11	applied	\N	\N	\N	\N	207144	207144	374289
27534	43891	12	applied	\N	\N	\N	\N	207145	207145	374290
27534	43892	13	applied	\N	\N	\N	\N	207146	207146	374291
27534	43893	14	applied	\N	\N	\N	\N	207147	207147	374292
27534	43902	15	applied	\N	\N	\N	\N	207148	207148	374293
27534	43903	16	applied	\N	\N	\N	\N	207149	207149	374294
27534	43907	17	applied	\N	\N	\N	\N	207150	207150	374295
27534	43909	18	applied	\N	\N	\N	\N	207151	207151	374296
27534	43911	19	applied	\N	\N	\N	\N	207152	207152	374297
27534	43913	20	applied	\N	\N	\N	\N	207153	207153	374298
27534	43918	22	applied	\N	\N	\N	\N	207155	207155	374300
27534	43920	23	applied	\N	\N	\N	\N	207156	207156	374301
27534	43921	24	applied	\N	\N	\N	\N	207157	207157	374302
27534	43926	25	applied	\N	\N	\N	\N	207158	207158	374303
27534	43929	26	applied	\N	\N	\N	\N	207159	207159	374304
27534	43932	27	applied	\N	\N	\N	\N	207160	207160	374305
27534	43933	28	applied	\N	\N	\N	\N	207161	207161	374306
27534	43938	29	applied	\N	\N	\N	\N	207162	207162	374307
27534	43941	30	applied	\N	\N	\N	\N	207163	207163	374308
27534	43944	31	applied	\N	\N	\N	\N	207164	207164	374309
27534	43947	32	applied	\N	\N	\N	\N	207165	207165	374310
27534	43950	33	applied	\N	\N	\N	\N	207166	207166	374311
27534	43953	34	applied	\N	\N	\N	\N	207167	207167	374312
27534	43956	35	applied	\N	\N	\N	\N	207168	207168	374313
27534	43957	36	applied	\N	\N	\N	\N	207169	207169	374314
27534	43962	37	applied	\N	\N	\N	\N	207170	207170	374315
27534	43968	39	applied	\N	\N	\N	\N	207172	207172	374317
27534	43969	40	applied	\N	\N	\N	\N	207173	207173	374318
27534	43974	41	applied	\N	\N	\N	\N	207174	207174	374319
27534	43977	42	applied	\N	\N	\N	\N	207175	207175	374320
27534	43978	43	applied	\N	\N	\N	\N	207176	207176	374321
27534	43983	44	applied	\N	\N	\N	\N	207177	207177	374322
27534	43986	45	applied	\N	\N	\N	\N	207178	207178	374323
27534	43989	46	applied	\N	\N	\N	\N	207179	207179	374324
27534	43992	47	applied	\N	\N	\N	\N	207180	207180	374325
27534	43996	48	applied	\N	\N	\N	\N	207181	207181	374326
27534	43999	49	applied	\N	\N	\N	\N	207182	207182	374327
27534	44000	50	applied	\N	\N	\N	\N	207183	207183	374328
27534	44001	51	applied	\N	\N	\N	\N	207184	207184	374329
27534	44008	52	applied	\N	\N	\N	\N	207185	207185	374330
27534	44011	53	applied	\N	\N	\N	\N	207186	207186	374331
27534	44014	54	applied	\N	\N	\N	\N	207187	207187	374332
27534	44018	56	applied	\N	\N	\N	\N	207189	207189	374334
27534	44023	57	applied	\N	\N	\N	\N	207190	207190	374335
27534	44026	58	applied	\N	\N	\N	\N	207191	207191	374336
27534	44029	59	applied	\N	\N	\N	\N	207192	207192	374337
27534	44032	60	applied	\N	\N	\N	\N	207193	207193	374338
27534	44035	61	applied	\N	\N	\N	\N	207194	207194	374339
27534	44038	62	applied	\N	\N	\N	\N	207195	207195	374340
27534	44039	63	applied	\N	\N	\N	\N	207196	207196	374341
27534	44040	64	applied	\N	\N	\N	\N	207197	207197	374342
27534	44047	65	applied	\N	\N	\N	\N	207198	207198	374343
27534	44048	66	applied	\N	\N	\N	\N	207199	207199	374344
27534	44053	67	applied	\N	\N	\N	\N	207200	207200	374345
27534	44054	68	applied	\N	\N	\N	\N	207201	207201	374346
27534	44055	69	applied	\N	\N	\N	\N	207202	207202	374347
27534	44062	70	applied	\N	\N	\N	\N	207203	207203	374348
27534	44063	71	applied	\N	\N	\N	\N	207204	207204	374349
27534	44074	73	applied	\N	\N	\N	\N	207206	207206	374351
27537	44610	0	applied	\N	\N	\N	\N	207221	207221	374366
27537	44611	1	applied	\N	\N	\N	\N	207222	207222	374367
27537	44612	2	applied	\N	\N	\N	\N	207223	207223	374368
27537	44613	3	applied	\N	\N	\N	\N	207224	207224	374369
27537	44614	4	applied	\N	\N	\N	\N	207225	207225	374370
27537	44615	5	applied	\N	\N	\N	\N	207226	207226	374371
27537	44616	6	applied	\N	\N	\N	\N	207227	207227	374372
27538	44617	0	applied	\N	\N	\N	\N	207228	207228	374373
27538	44618	1	applied	\N	\N	\N	\N	207229	207229	374374
27538	44619	2	applied	\N	\N	\N	\N	207230	207230	374375
27543	44620	0	applied	\N	\N	\N	\N	207244	207244	374389
27543	44621	1	applied	\N	\N	\N	\N	207245	207245	374390
27543	44623	2	applied	\N	\N	\N	\N	207246	207246	374391
27515	44557	0	applied	\N	\N	\N	\N	206969	206969	374114
27515	44558	2	applied	\N	\N	\N	\N	206970	206970	374115
27528	44390	84	applied	\N	\N	\N	\N	207109	207109	374254
27528	44391	85	applied	\N	\N	\N	\N	207110	207110	374255
27528	44395	86	applied	\N	\N	\N	\N	207111	207111	374256
27528	44396	88	applied	\N	\N	\N	\N	207112	207112	374257
27535	44615	5	applied	\N	\N	\N	\N	207212	207212	374357
27535	44616	6	applied	\N	\N	\N	\N	207213	207213	374358
27539	44617	0	applied	\N	\N	\N	\N	207231	207231	374376
27539	44618	1	applied	\N	\N	\N	\N	207232	207232	374377
27539	44619	2	applied	\N	\N	\N	\N	207233	207233	374378
27541	44620	0	applied	\N	\N	\N	\N	207237	207237	374382
27541	44621	1	applied	\N	\N	\N	\N	207238	207238	374383
27541	44622	2	applied	\N	\N	\N	\N	207239	207239	374384
27542	44620	0	applied	\N	\N	\N	\N	207240	207240	374385
27542	44621	1	applied	\N	\N	\N	\N	207241	207241	374386
27542	44623	2	applied	\N	\N	\N	\N	207242	207242	374387
27542	44622	3	applied	\N	\N	\N	\N	207243	207243	374388
27544	44621	1	applied	\N	\N	\N	\N	207249	207249	374394
27544	44623	2	applied	\N	\N	\N	\N	207250	207250	374395
27544	44622	3	applied	\N	\N	\N	\N	207251	207251	374396
27547	44624	0	applied	\N	\N	\N	\N	207270	207270	374415
27547	44625	1	applied	\N	\N	\N	\N	207271	207271	374416
27547	44626	2	applied	\N	\N	\N	\N	207272	207272	374417
27547	44627	3	applied	\N	\N	\N	\N	207273	207273	374418
27547	44628	4	applied	\N	\N	\N	\N	207274	207274	374419
27547	44629	5	applied	\N	\N	\N	\N	207275	207275	374420
27547	44630	6	applied	\N	\N	\N	\N	207276	207276	374421
27547	44631	7	applied	\N	\N	\N	\N	207277	207277	374422
27547	44632	8	applied	\N	\N	\N	\N	207278	207278	374423
27548	44633	0	applied	\N	\N	\N	\N	207279	207279	374424
27548	44634	1	applied	\N	\N	\N	\N	207280	207280	374425
27548	44635	2	applied	\N	\N	\N	\N	207281	207281	374426
27548	44636	3	applied	\N	\N	\N	\N	207282	207282	374427
27548	44638	5	applied	\N	\N	\N	\N	207284	207284	374429
27549	44639	0	applied	\N	\N	\N	\N	207285	207285	374430
27549	44640	1	applied	\N	\N	\N	\N	207286	207286	374431
27549	44641	2	applied	\N	\N	\N	\N	207287	207287	374432
27560	44653	0	applied	\N	\N	\N	\N	207320	207320	374465
27560	44654	1	applied	\N	\N	\N	\N	207321	207321	374466
27560	44655	2	applied	\N	\N	\N	\N	207322	207322	374467
27560	44656	3	applied	\N	\N	\N	\N	207323	207323	374468
27562	44653	0	applied	\N	\N	\N	\N	207328	207328	374473
27562	44654	1	applied	\N	\N	\N	\N	207329	207329	374474
27562	44655	2	applied	\N	\N	\N	\N	207330	207330	374475
27562	44656	3	applied	\N	\N	\N	\N	207331	207331	374476
27566	44660	0	applied	\N	\N	\N	\N	207341	207341	374486
27566	44661	1	applied	\N	\N	\N	\N	207342	207342	374487
27566	44662	2	applied	\N	\N	\N	\N	207343	207343	374488
27569	44669	0	applied	\N	\N	\N	\N	207353	207353	374498
27569	44671	2	applied	\N	\N	\N	\N	207355	207355	374500
27571	44669	0	applied	\N	\N	\N	\N	207359	207359	374504
27571	44670	1	applied	\N	\N	\N	\N	207360	207360	374505
27571	44671	2	applied	\N	\N	\N	\N	207361	207361	374506
27574	44678	0	applied	\N	\N	\N	\N	207368	207368	374513
27574	44679	1	applied	\N	\N	\N	\N	207369	207369	374514
27574	44680	2	applied	\N	\N	\N	\N	207370	207370	374515
27575	44678	0	applied	\N	\N	\N	\N	207371	207371	374516
27575	44679	1	applied	\N	\N	\N	\N	207372	207372	374517
27575	44680	2	applied	\N	\N	\N	\N	207373	207373	374518
27587	44706	0	applied	\N	\N	\N	\N	207436	207436	374581
27587	44707	1	applied	\N	\N	\N	\N	207437	207437	374582
27587	44708	2	applied	\N	\N	\N	\N	207438	207438	374583
27587	44709	3	applied	\N	\N	\N	\N	207439	207439	374584
27594	44718	0	applied	\N	\N	\N	\N	207468	207468	374613
27594	44719	1	applied	\N	\N	\N	\N	207469	207469	374614
27597	44730	0	applied	\N	\N	\N	\N	207489	207489	374632
27597	44731	1	applied	\N	\N	\N	\N	207490	207490	374633
27597	44732	2	applied	\N	\N	\N	\N	207491	207491	374634
27597	44733	3	applied	\N	\N	\N	\N	207492	207492	374635
27597	44734	4	applied	\N	\N	\N	\N	207493	207493	374636
27597	44735	5	applied	\N	\N	\N	\N	207494	207494	374637
27597	44736	6	applied	\N	\N	\N	\N	207495	207495	374638
27599	44737	0	applied	\N	\N	\N	\N	207503	207503	374646
27599	44738	1	applied	\N	\N	\N	\N	207504	207504	374647
27599	44739	2	applied	\N	\N	\N	\N	207505	207505	374648
27599	44740	3	applied	\N	\N	\N	\N	207506	207506	374649
27599	44741	4	applied	\N	\N	\N	\N	207507	207507	374650
27599	44742	5	applied	\N	\N	\N	\N	207508	207508	374651
27606	44752	0	applied	\N	\N	\N	\N	207533	207533	374675
27606	44753	1	applied	\N	\N	\N	\N	207534	207534	374676
27606	44754	2	applied	\N	\N	\N	\N	207535	207535	374677
27610	44722	1	applied	\N	\N	\N	\N	207552	207552	374694
27610	44563	2	applied	\N	\N	\N	\N	207553	207553	374695
27610	44699	3	applied	\N	\N	\N	\N	207554	207554	374696
27610	44303	4	applied	\N	\N	\N	\N	207555	207555	374697
27610	44311	5	applied	\N	\N	\N	\N	207556	207556	374698
27610	44312	6	applied	\N	\N	\N	\N	207557	207557	374699
27610	44313	7	applied	\N	\N	\N	\N	207558	207558	374700
27610	44335	8	applied	\N	\N	\N	\N	207559	207559	374701
27610	44336	9	applied	\N	\N	\N	\N	207560	207560	374702
27610	44350	10	applied	\N	\N	\N	\N	207561	207561	374703
27610	44351	11	applied	\N	\N	\N	\N	207562	207562	374704
27610	44723	12	applied	\N	\N	\N	\N	207563	207563	374705
27610	44724	13	applied	\N	\N	\N	\N	207564	207564	374706
27610	44725	14	applied	\N	\N	\N	\N	207565	207565	374707
27610	44726	15	applied	\N	\N	\N	\N	207566	207566	207566
27610	44744	16	applied	\N	\N	\N	\N	207567	207567	374708
27610	44746	18	applied	\N	\N	\N	\N	207569	207569	374710
27610	44747	19	applied	\N	\N	\N	\N	207570	207570	374711
27610	44748	20	applied	\N	\N	\N	\N	207571	207571	374712
27610	44749	21	applied	\N	\N	\N	\N	207572	207572	207572
27610	44352	22	applied	\N	\N	\N	\N	207573	207573	374713
27610	44376	23	applied	\N	\N	\N	\N	207574	207574	374714
27610	44384	24	applied	\N	\N	\N	\N	207575	207575	374715
27610	44385	25	applied	\N	\N	\N	\N	207576	207576	374716
27610	44402	26	applied	\N	\N	\N	\N	207577	207577	374717
27610	44411	27	applied	\N	\N	\N	\N	207578	207578	374718
27610	44417	28	applied	\N	\N	\N	\N	207579	207579	374719
27610	44418	29	applied	\N	\N	\N	\N	207580	207580	374720
27610	44419	30	applied	\N	\N	\N	\N	207581	207581	374721
27610	44441	31	applied	\N	\N	\N	\N	207582	207582	374722
27528	44382	81	applied	\N	\N	\N	\N	207106	207106	374251
27528	44386	82	applied	\N	\N	\N	\N	207107	207107	374252
27546	44627	3	applied	\N	\N	\N	\N	207264	207264	374409
27546	44628	4	applied	\N	\N	\N	\N	207265	207265	374410
27546	44629	5	applied	\N	\N	\N	\N	207266	207266	374411
27546	44630	6	applied	\N	\N	\N	\N	207267	207267	374412
27546	44631	7	applied	\N	\N	\N	\N	207268	207268	374413
27551	44642	0	applied	\N	\N	\N	\N	207291	207291	374436
27551	44643	1	applied	\N	\N	\N	\N	207292	207292	374437
27554	44644	0	applied	\N	\N	\N	\N	207301	207301	374446
27554	44645	1	applied	\N	\N	\N	\N	207302	207302	374447
27554	44646	2	applied	\N	\N	\N	\N	207303	207303	374448
27554	44647	3	applied	\N	\N	\N	\N	207304	207304	374449
27558	44651	0	applied	\N	\N	\N	\N	207314	207314	374459
27558	44652	1	applied	\N	\N	\N	\N	207315	207315	374460
27561	44653	0	applied	\N	\N	\N	\N	207324	207324	374469
27561	44654	1	applied	\N	\N	\N	\N	207325	207325	374470
27561	44655	2	applied	\N	\N	\N	\N	207326	207326	374471
27567	44660	0	applied	\N	\N	\N	\N	207344	207344	374489
27567	44661	1	applied	\N	\N	\N	\N	207345	207345	374490
27567	44662	2	applied	\N	\N	\N	\N	207346	207346	374491
27570	44669	0	applied	\N	\N	\N	\N	207356	207356	374501
27570	44670	1	applied	\N	\N	\N	\N	207357	207357	374502
27570	44671	2	applied	\N	\N	\N	\N	207358	207358	374503
27572	44672	0	applied	\N	\N	\N	\N	207362	207362	374507
27572	44673	1	applied	\N	\N	\N	\N	207363	207363	374508
27572	44674	2	applied	\N	\N	\N	\N	207364	207364	374509
27572	44675	3	applied	\N	\N	\N	\N	207365	207365	374510
27572	44676	4	applied	\N	\N	\N	\N	207366	207366	374511
27572	44677	5	applied	\N	\N	\N	\N	207367	207367	374512
27576	44678	0	applied	\N	\N	\N	\N	207374	207374	374519
27576	44679	1	applied	\N	\N	\N	\N	207375	207375	374520
27576	44680	2	applied	\N	\N	\N	\N	207376	207376	374521
27579	44681	0	applied	\N	\N	\N	\N	207401	207401	374546
27579	44683	2	applied	\N	\N	\N	\N	207403	207403	374548
27579	44684	3	applied	\N	\N	\N	\N	207404	207404	374549
27579	44685	4	applied	\N	\N	\N	\N	207405	207405	374550
27579	44686	5	applied	\N	\N	\N	\N	207406	207406	374551
27581	44687	0	applied	\N	\N	\N	\N	207413	207413	374558
27581	44688	1	applied	\N	\N	\N	\N	207414	207414	374559
27581	44689	2	applied	\N	\N	\N	\N	207415	207415	374560
27581	44690	3	applied	\N	\N	\N	\N	207416	207416	374561
27581	44691	4	applied	\N	\N	\N	\N	207417	207417	374562
27581	44692	5	applied	\N	\N	\N	\N	207418	207418	374563
27584	44699	0	applied	\N	\N	\N	\N	207425	207425	374570
27584	44700	1	applied	\N	\N	\N	\N	207426	207426	374571
27584	44701	2	applied	\N	\N	\N	\N	207427	207427	374572
27584	44702	3	applied	\N	\N	\N	\N	207428	207428	374573
27585	44699	0	applied	\N	\N	\N	\N	207429	207429	374574
27585	44700	1	applied	\N	\N	\N	\N	207430	207430	374575
27585	44702	3	applied	\N	\N	\N	\N	207432	207432	374577
27590	44712	0	applied	\N	\N	\N	\N	207448	207448	374593
27590	44710	1	applied	\N	\N	\N	\N	207449	207449	374594
27590	44713	2	applied	\N	\N	\N	\N	207450	207450	374595
27590	44711	3	applied	\N	\N	\N	\N	207451	207451	374596
27590	44714	4	applied	\N	\N	\N	\N	207452	207452	374597
27600	44737	0	applied	\N	\N	\N	\N	207509	207509	374652
27600	44738	1	applied	\N	\N	\N	\N	207510	207510	374653
27600	44739	2	applied	\N	\N	\N	\N	207511	207511	374654
27600	44740	3	applied	\N	\N	\N	\N	207512	207512	374655
27600	44741	4	applied	\N	\N	\N	\N	207513	207513	374656
27600	44742	5	applied	\N	\N	\N	\N	207514	207514	374657
27609	44767	0	applied	\N	\N	\N	\N	207548	207548	374690
27609	44768	1	applied	\N	\N	\N	\N	207549	207549	374691
27609	44769	2	applied	\N	\N	\N	\N	207550	207550	374692
27612	44770	0	applied	\N	\N	\N	\N	207755	207755	374893
27612	44772	2	applied	\N	\N	\N	\N	207757	207757	374895
27613	44770	0	applied	\N	\N	\N	\N	207758	207758	374896
27613	44771	1	applied	\N	\N	\N	\N	207759	207759	374897
27613	44772	2	applied	\N	\N	\N	\N	207760	207760	374898
27615	44773	0	applied	\N	\N	\N	\N	207764	207764	374902
27615	44774	1	applied	\N	\N	\N	\N	207765	207765	374903
27615	44775	2	applied	\N	\N	\N	\N	207766	207766	374904
27615	44776	3	applied	\N	\N	\N	\N	207767	207767	374905
27618	44794	0	applied	\N	\N	\N	\N	207797	207797	374935
27618	44795	1	applied	\N	\N	\N	\N	207798	207798	374936
27618	44796	2	applied	\N	\N	\N	\N	207799	207799	374937
27635	44825	0	applied	\N	\N	\N	\N	207860	207860	374998
27635	44826	1	applied	\N	\N	\N	\N	207861	207861	374999
27635	44827	2	applied	\N	\N	\N	\N	207862	207862	375000
27655	44869	0	applied	\N	\N	\N	\N	208094	208094	375230
27655	44870	1	applied	\N	\N	\N	\N	208095	208095	375231
27657	44872	0	applied	\N	\N	\N	\N	208100	208100	375236
27657	44873	1	applied	\N	\N	\N	\N	208101	208101	375237
27657	44874	2	applied	\N	\N	\N	\N	208102	208102	375238
27660	44878	0	applied	\N	\N	\N	\N	208109	208109	375245
27660	44879	1	applied	\N	\N	\N	\N	208110	208110	375246
27660	44880	2	applied	\N	\N	\N	\N	208111	208111	375247
27663	44884	0	applied	\N	\N	\N	\N	208123	208123	375259
27663	44885	1	applied	\N	\N	\N	\N	208124	208124	375260
27663	44886	2	applied	\N	\N	\N	\N	208125	208125	375261
27663	44887	3	applied	\N	\N	\N	\N	208126	208126	375262
27663	44888	4	applied	\N	\N	\N	\N	208127	208127	375263
27663	44889	5	applied	\N	\N	\N	\N	208128	208128	375264
27663	44890	6	applied	\N	\N	\N	\N	208129	208129	375265
27663	44891	7	applied	\N	\N	\N	\N	208130	208130	375266
27665	44895	0	applied	\N	\N	\N	\N	208134	208134	375270
27665	44896	1	applied	\N	\N	\N	\N	208135	208135	375271
27667	44895	0	applied	\N	\N	\N	\N	208140	208140	375276
27667	44896	1	applied	\N	\N	\N	\N	208141	208141	375277
27667	44897	2	applied	\N	\N	\N	\N	208142	208142	375278
27670	44898	0	applied	\N	\N	\N	\N	208149	208149	375285
27670	44899	1	applied	\N	\N	\N	\N	208150	208150	375286
27670	44900	2	applied	\N	\N	\N	\N	208151	208151	375287
27674	44901	0	applied	\N	\N	\N	\N	208160	208160	375296
27674	44902	1	applied	\N	\N	\N	\N	208161	208161	375297
27674	44903	2	applied	\N	\N	\N	\N	208162	208162	375298
27680	44907	0	applied	\N	\N	\N	\N	208178	208178	375314
27680	44908	1	applied	\N	\N	\N	\N	208179	208179	375315
27685	44915	0	applied	\N	\N	\N	\N	208263	208263	375399
27685	44916	1	applied	\N	\N	\N	\N	208264	208264	375400
27685	44917	2	applied	\N	\N	\N	\N	208265	208265	375401
27546	44624	0	applied	\N	\N	\N	\N	207261	207261	374406
27546	44625	1	applied	\N	\N	\N	\N	207262	207262	374407
27553	44644	0	applied	\N	\N	\N	\N	207297	207297	374442
27553	44645	1	applied	\N	\N	\N	\N	207298	207298	374443
27553	44646	2	applied	\N	\N	\N	\N	207299	207299	374444
27553	44647	3	applied	\N	\N	\N	\N	207300	207300	374445
27555	44644	0	applied	\N	\N	\N	\N	207305	207305	374450
27555	44645	1	applied	\N	\N	\N	\N	207306	207306	374451
27555	44646	2	applied	\N	\N	\N	\N	207307	207307	374452
27555	44647	3	applied	\N	\N	\N	\N	207308	207308	374453
27557	44651	0	applied	\N	\N	\N	\N	207312	207312	374457
27557	44652	1	applied	\N	\N	\N	\N	207313	207313	374458
27559	44653	0	applied	\N	\N	\N	\N	207316	207316	374461
27559	44654	1	applied	\N	\N	\N	\N	207317	207317	374462
27559	44655	2	applied	\N	\N	\N	\N	207318	207318	374463
27559	44656	3	applied	\N	\N	\N	\N	207319	207319	374464
27564	44657	0	applied	\N	\N	\N	\N	207335	207335	374480
27564	44658	1	applied	\N	\N	\N	\N	207336	207336	374481
27568	44663	0	applied	\N	\N	\N	\N	207347	207347	374492
27568	44664	1	applied	\N	\N	\N	\N	207348	207348	374493
27568	44665	2	applied	\N	\N	\N	\N	207349	207349	374494
27568	44666	3	applied	\N	\N	\N	\N	207350	207350	374495
27568	44667	4	applied	\N	\N	\N	\N	207351	207351	374496
27568	44668	5	applied	\N	\N	\N	\N	207352	207352	374497
27577	44279	19	applied	\N	\N	\N	\N	207396	207396	374541
27577	44280	20	applied	\N	\N	\N	\N	207397	207397	374542
27577	44286	21	applied	\N	\N	\N	\N	207398	207398	374543
27577	44287	22	applied	\N	\N	\N	\N	207399	207399	374544
27578	44655	0	applied	\N	\N	\N	\N	207400	207400	374545
27580	44681	0	applied	\N	\N	\N	\N	207407	207407	374552
27580	44682	1	applied	\N	\N	\N	\N	207408	207408	374553
27580	44683	2	applied	\N	\N	\N	\N	207409	207409	374554
27580	44684	3	applied	\N	\N	\N	\N	207410	207410	374555
27580	44685	4	applied	\N	\N	\N	\N	207411	207411	374556
27583	44693	0	applied	\N	\N	\N	\N	207419	207419	374564
27583	44694	1	applied	\N	\N	\N	\N	207420	207420	374565
27583	44695	2	applied	\N	\N	\N	\N	207421	207421	374566
27583	44696	3	applied	\N	\N	\N	\N	207422	207422	374567
27583	44697	4	applied	\N	\N	\N	\N	207423	207423	374568
27583	44698	5	applied	\N	\N	\N	\N	207424	207424	374569
27586	44703	0	applied	\N	\N	\N	\N	207433	207433	374578
27586	44704	1	applied	\N	\N	\N	\N	207434	207434	374579
27586	44705	2	applied	\N	\N	\N	\N	207435	207435	374580
27588	44706	0	applied	\N	\N	\N	\N	207440	207440	374585
27588	44707	1	applied	\N	\N	\N	\N	207441	207441	374586
27589	44712	0	applied	\N	\N	\N	\N	207446	207446	374591
27589	44713	1	applied	\N	\N	\N	\N	207447	207447	374592
27591	44715	0	applied	\N	\N	\N	\N	207453	207453	374598
27591	44710	1	applied	\N	\N	\N	\N	207454	207454	374599
27591	44716	2	applied	\N	\N	\N	\N	207455	207455	374600
27591	44714	4	applied	\N	\N	\N	\N	207457	207457	374602
27591	44717	5	applied	\N	\N	\N	\N	207458	207458	374603
27592	44715	0	applied	\N	\N	\N	\N	207459	207459	374604
27592	44710	1	applied	\N	\N	\N	\N	207460	207460	374605
27592	44716	2	applied	\N	\N	\N	\N	207461	207461	374606
27592	44711	3	applied	\N	\N	\N	\N	207462	207462	374607
27592	44714	4	applied	\N	\N	\N	\N	207463	207463	374608
27592	44717	5	applied	\N	\N	\N	\N	207464	207464	374609
27596	44721	0	applied	\N	\N	\N	\N	207480	207480	374624
27596	44722	1	applied	\N	\N	\N	\N	207481	207481	374625
27596	44723	2	applied	\N	\N	\N	\N	207482	207482	374626
27596	44724	3	applied	\N	\N	\N	\N	207483	207483	374627
27596	44725	4	applied	\N	\N	\N	\N	207484	207484	374628
27596	44726	5	applied	\N	\N	\N	\N	207485	207485	207485
27596	44727	6	applied	\N	\N	\N	\N	207486	207486	374629
27596	44728	7	applied	\N	\N	\N	\N	207487	207487	374630
27602	44737	0	applied	\N	\N	\N	\N	207515	207515	374658
27602	44738	1	applied	\N	\N	\N	\N	207516	207516	374659
27602	44739	2	applied	\N	\N	\N	\N	207517	207517	374660
27602	44740	3	applied	\N	\N	\N	\N	207518	207518	374661
27602	44741	4	applied	\N	\N	\N	\N	207519	207519	374662
27602	44742	5	applied	\N	\N	\N	\N	207520	207520	374663
27603	44743	0	applied	\N	\N	\N	\N	207521	207521	374664
27603	44744	1	applied	\N	\N	\N	\N	207522	207522	374665
27603	44745	2	applied	\N	\N	\N	\N	207523	207523	374666
27603	44746	3	applied	\N	\N	\N	\N	207524	207524	374667
27603	44747	4	applied	\N	\N	\N	\N	207525	207525	374668
27603	44748	5	applied	\N	\N	\N	\N	207526	207526	374669
27603	44749	6	applied	\N	\N	\N	\N	207527	207527	207527
27603	44750	7	applied	\N	\N	\N	\N	207528	207528	374670
27603	44751	8	applied	\N	\N	\N	\N	207529	207529	374671
27605	44752	0	applied	\N	\N	\N	\N	207530	207530	374672
27605	44754	2	applied	\N	\N	\N	\N	207532	207532	374674
27608	44755	0	applied	\N	\N	\N	\N	207536	207536	374678
27608	44756	1	applied	\N	\N	\N	\N	207537	207537	374679
27608	44757	2	applied	\N	\N	\N	\N	207538	207538	374680
27608	44758	3	applied	\N	\N	\N	\N	207539	207539	374681
27608	44759	4	applied	\N	\N	\N	\N	207540	207540	374682
27608	44760	5	applied	\N	\N	\N	\N	207541	207541	374683
27608	44761	6	applied	\N	\N	\N	\N	207542	207542	374684
27608	44762	7	applied	\N	\N	\N	\N	207543	207543	374685
27608	44763	8	applied	\N	\N	\N	\N	207544	207544	374686
27608	44764	9	applied	\N	\N	\N	\N	207545	207545	374687
27608	44765	10	applied	\N	\N	\N	\N	207546	207546	374688
27608	44766	11	applied	\N	\N	\N	\N	207547	207547	374689
27619	44797	0	applied	\N	\N	\N	\N	207800	207800	374938
27619	44798	1	applied	\N	\N	\N	\N	207801	207801	374939
27619	44799	2	applied	\N	\N	\N	\N	207802	207802	374940
27623	44800	0	applied	\N	\N	\N	\N	207810	207810	374948
27623	44801	1	applied	\N	\N	\N	\N	207811	207811	374949
27623	44802	2	applied	\N	\N	\N	\N	207812	207812	374950
27626	44803	0	applied	\N	\N	\N	\N	207825	207825	374963
27626	44804	1	applied	\N	\N	\N	\N	207826	207826	374964
27626	44805	2	applied	\N	\N	\N	\N	207827	207827	374965
27626	44806	3	applied	\N	\N	\N	\N	207828	207828	374966
27626	44807	4	applied	\N	\N	\N	\N	207829	207829	374967
27626	44808	5	applied	\N	\N	\N	\N	207830	207830	374968
27628	44809	0	applied	\N	\N	\N	\N	207835	207835	374973
27628	44810	1	applied	\N	\N	\N	\N	207836	207836	374974
27628	44811	2	applied	\N	\N	\N	\N	207837	207837	374975
27628	44812	3	applied	\N	\N	\N	\N	207838	207838	374976
27631	44822	0	applied	\N	\N	\N	\N	207848	207848	374986
27550	44639	0	applied	\N	\N	\N	\N	207288	207288	374433
27550	44640	1	applied	\N	\N	\N	\N	207289	207289	374434
27593	44718	0	applied	\N	\N	\N	\N	207465	207465	374610
27593	44719	1	applied	\N	\N	\N	\N	207466	207466	374611
27593	44720	2	applied	\N	\N	\N	\N	207467	207467	374612
27595	44721	0	applied	\N	\N	\N	\N	207471	207471	374616
27595	44722	1	applied	\N	\N	\N	\N	207472	207472	374617
27595	44723	2	applied	\N	\N	\N	\N	207473	207473	374618
27595	44724	3	applied	\N	\N	\N	\N	207474	207474	374619
27595	44725	4	applied	\N	\N	\N	\N	207475	207475	374620
27595	44726	5	applied	\N	\N	\N	\N	207476	207476	207476
27595	44727	6	applied	\N	\N	\N	\N	207477	207477	374621
27595	44728	7	applied	\N	\N	\N	\N	207478	207478	374622
27595	44729	8	applied	\N	\N	\N	\N	207479	207479	374623
27598	44730	0	applied	\N	\N	\N	\N	207496	207496	374639
27598	44731	1	applied	\N	\N	\N	\N	207497	207497	374640
27598	44732	2	applied	\N	\N	\N	\N	207498	207498	374641
27598	44733	3	applied	\N	\N	\N	\N	207499	207499	374642
27598	44735	5	applied	\N	\N	\N	\N	207501	207501	374644
27598	44736	6	applied	\N	\N	\N	\N	207502	207502	374645
27610	44449	32	applied	\N	\N	\N	\N	207583	207583	374723
27610	44450	33	applied	\N	\N	\N	\N	207584	207584	374724
27610	44451	34	applied	\N	\N	\N	\N	207585	207585	374725
27610	44476	35	applied	\N	\N	\N	\N	207586	207586	374726
27610	44477	36	applied	\N	\N	\N	\N	207587	207587	374727
27610	44486	37	applied	\N	\N	\N	\N	207588	207588	374728
27610	44490	38	applied	\N	\N	\N	\N	207589	207589	374729
27610	44493	39	applied	\N	\N	\N	\N	207590	207590	374730
27610	44494	40	applied	\N	\N	\N	\N	207591	207591	374731
27611	44721	0	applied	\N	\N	\N	\N	207676	207676	374816
27611	44722	1	applied	\N	\N	\N	\N	207677	207677	374817
27611	44563	2	applied	\N	\N	\N	\N	207678	207678	374818
27611	44699	3	applied	\N	\N	\N	\N	207679	207679	374819
27611	44335	4	applied	\N	\N	\N	\N	207680	207680	374820
27611	44350	6	applied	\N	\N	\N	\N	207682	207682	374822
27611	44351	7	applied	\N	\N	\N	\N	207683	207683	374823
27611	44723	8	applied	\N	\N	\N	\N	207684	207684	374824
27611	44724	9	applied	\N	\N	\N	\N	207685	207685	374825
27611	44725	10	applied	\N	\N	\N	\N	207686	207686	374826
27611	44726	11	applied	\N	\N	\N	\N	207687	207687	207687
27611	44744	12	applied	\N	\N	\N	\N	207688	207688	374827
27611	44745	13	applied	\N	\N	\N	\N	207689	207689	374828
27611	44746	14	applied	\N	\N	\N	\N	207690	207690	374829
27611	44747	15	applied	\N	\N	\N	\N	207691	207691	374830
27611	44748	16	applied	\N	\N	\N	\N	207692	207692	374831
27611	44749	17	applied	\N	\N	\N	\N	207693	207693	207693
27611	44352	18	applied	\N	\N	\N	\N	207694	207694	374832
27611	44376	20	applied	\N	\N	\N	\N	207695	207695	374833
27611	44384	21	applied	\N	\N	\N	\N	207696	207696	374834
27611	44385	22	applied	\N	\N	\N	\N	207697	207697	374835
27611	44411	24	applied	\N	\N	\N	\N	207699	207699	374837
27611	44417	25	applied	\N	\N	\N	\N	207700	207700	374838
27611	44418	26	applied	\N	\N	\N	\N	207701	207701	374839
27611	44419	27	applied	\N	\N	\N	\N	207702	207702	374840
27611	44441	28	applied	\N	\N	\N	\N	207703	207703	374841
27611	44449	29	applied	\N	\N	\N	\N	207704	207704	374842
27611	44450	30	applied	\N	\N	\N	\N	207705	207705	374843
27611	44451	31	applied	\N	\N	\N	\N	207706	207706	374844
27611	44476	32	applied	\N	\N	\N	\N	207707	207707	374845
27611	44477	33	applied	\N	\N	\N	\N	207708	207708	374846
27611	44486	34	applied	\N	\N	\N	\N	207709	207709	374847
27611	44490	35	applied	\N	\N	\N	\N	207710	207710	374848
27611	44493	36	applied	\N	\N	\N	\N	207711	207711	374849
27611	44494	37	applied	\N	\N	\N	\N	207712	207712	374850
27611	44499	38	applied	\N	\N	\N	\N	207713	207713	374851
27611	44502	39	applied	\N	\N	\N	\N	207714	207714	374852
27611	44509	41	applied	\N	\N	\N	\N	207716	207716	374854
27611	44512	42	applied	\N	\N	\N	\N	207717	207717	374855
27611	44513	43	applied	\N	\N	\N	\N	207718	207718	374856
27611	44518	44	applied	\N	\N	\N	\N	207719	207719	374857
27611	44521	45	applied	\N	\N	\N	\N	207720	207720	374858
27611	44522	46	applied	\N	\N	\N	\N	207721	207721	374859
27611	44527	47	applied	\N	\N	\N	\N	207722	207722	374860
27611	44530	48	applied	\N	\N	\N	\N	207723	207723	374861
27611	44531	49	applied	\N	\N	\N	\N	207724	207724	374862
27611	44532	50	applied	\N	\N	\N	\N	207725	207725	374863
27611	44533	51	applied	\N	\N	\N	\N	207726	207726	374864
27611	44534	52	applied	\N	\N	\N	\N	207727	207727	374865
27611	44545	53	applied	\N	\N	\N	\N	207728	207728	374866
27611	44546	54	applied	\N	\N	\N	\N	207729	207729	374867
27611	44547	55	applied	\N	\N	\N	\N	207730	207730	374868
27611	44554	56	applied	\N	\N	\N	\N	207731	207731	374869
27611	44560	58	applied	\N	\N	\N	\N	207733	207733	374871
27611	44564	59	applied	\N	\N	\N	\N	207734	207734	374872
27611	44568	60	applied	\N	\N	\N	\N	207735	207735	374873
27611	44569	61	applied	\N	\N	\N	\N	207736	207736	374874
27611	44570	62	applied	\N	\N	\N	\N	207737	207737	374875
27611	44582	63	applied	\N	\N	\N	\N	207738	207738	374876
27611	44586	64	applied	\N	\N	\N	\N	207739	207739	374877
27611	44589	65	applied	\N	\N	\N	\N	207740	207740	374878
27611	44590	66	applied	\N	\N	\N	\N	207741	207741	374879
27611	44596	67	applied	\N	\N	\N	\N	207742	207742	374880
27611	44599	68	applied	\N	\N	\N	\N	207743	207743	374881
27611	44600	69	applied	\N	\N	\N	\N	207744	207744	374882
27611	44605	70	applied	\N	\N	\N	\N	207745	207745	374883
27611	44607	71	applied	\N	\N	\N	\N	207746	207746	374884
27611	44611	72	applied	\N	\N	\N	\N	207747	207747	374885
27611	44612	73	applied	\N	\N	\N	\N	207748	207748	374886
27611	44620	75	applied	\N	\N	\N	\N	207750	207750	374888
27611	44624	76	applied	\N	\N	\N	\N	207751	207751	374889
27611	44625	77	applied	\N	\N	\N	\N	207752	207752	374890
27611	44626	78	applied	\N	\N	\N	\N	207753	207753	374891
27611	44633	79	applied	\N	\N	\N	\N	207754	207754	374892
27616	44773	0	applied	\N	\N	\N	\N	207768	207768	374906
27616	44774	1	applied	\N	\N	\N	\N	207769	207769	374907
27616	44775	2	applied	\N	\N	\N	\N	207770	207770	374908
27616	44776	3	applied	\N	\N	\N	\N	207771	207771	374909
27616	44777	4	applied	\N	\N	\N	\N	207772	207772	374910
27616	44778	5	applied	\N	\N	\N	\N	207773	207773	374911
27616	44779	6	applied	\N	\N	\N	\N	207774	207774	374912
27616	44780	7	applied	\N	\N	\N	\N	207775	207775	374913
27616	44781	8	applied	\N	\N	\N	\N	207776	207776	374914
27588	44711	3	applied	\N	\N	\N	\N	207443	207443	374588
27588	44708	4	applied	\N	\N	\N	\N	207444	207444	374589
27610	44512	45	applied	\N	\N	\N	\N	207596	207596	374736
27610	44513	46	applied	\N	\N	\N	\N	207597	207597	374737
27610	44518	47	applied	\N	\N	\N	\N	207598	207598	374738
27610	44521	48	applied	\N	\N	\N	\N	207599	207599	374739
27610	44522	49	applied	\N	\N	\N	\N	207600	207600	374740
27610	44527	50	applied	\N	\N	\N	\N	207601	207601	374741
27610	44530	51	applied	\N	\N	\N	\N	207602	207602	374742
27610	44531	52	applied	\N	\N	\N	\N	207603	207603	374743
27610	44532	53	applied	\N	\N	\N	\N	207604	207604	374744
27610	44533	54	applied	\N	\N	\N	\N	207605	207605	374745
27610	44534	56	applied	\N	\N	\N	\N	207606	207606	374746
27610	44545	57	applied	\N	\N	\N	\N	207607	207607	374747
27610	44546	58	applied	\N	\N	\N	\N	207608	207608	374748
27610	44547	59	applied	\N	\N	\N	\N	207609	207609	374749
27610	44554	60	applied	\N	\N	\N	\N	207610	207610	374750
27610	44557	61	applied	\N	\N	\N	\N	207611	207611	374751
27610	44564	63	applied	\N	\N	\N	\N	207613	207613	374753
27610	44568	64	applied	\N	\N	\N	\N	207614	207614	374754
27610	44569	65	applied	\N	\N	\N	\N	207615	207615	374755
27610	44570	66	applied	\N	\N	\N	\N	207616	207616	374756
27610	44582	67	applied	\N	\N	\N	\N	207617	207617	374757
27610	44586	68	applied	\N	\N	\N	\N	207618	207618	374758
27610	44589	69	applied	\N	\N	\N	\N	207619	207619	374759
27610	44590	70	applied	\N	\N	\N	\N	207620	207620	374760
27610	44596	71	applied	\N	\N	\N	\N	207621	207621	374761
27610	44599	72	applied	\N	\N	\N	\N	207622	207622	374762
27610	44600	73	applied	\N	\N	\N	\N	207623	207623	374763
27610	44605	74	applied	\N	\N	\N	\N	207624	207624	374764
27610	44607	75	applied	\N	\N	\N	\N	207625	207625	374765
27610	44611	76	applied	\N	\N	\N	\N	207626	207626	374766
27610	44612	77	applied	\N	\N	\N	\N	207627	207627	374767
27610	44617	78	applied	\N	\N	\N	\N	207628	207628	374768
27610	44624	80	applied	\N	\N	\N	\N	207630	207630	374770
27610	44625	81	applied	\N	\N	\N	\N	207631	207631	374771
27610	44626	82	applied	\N	\N	\N	\N	207632	207632	374772
27610	44633	83	applied	\N	\N	\N	\N	207633	207633	374773
27610	44634	84	applied	\N	\N	\N	\N	207634	207634	374774
27610	44639	85	applied	\N	\N	\N	\N	207635	207635	374775
27610	44642	86	applied	\N	\N	\N	\N	207636	207636	374776
27610	44644	87	applied	\N	\N	\N	\N	207637	207637	374777
27610	44648	88	applied	\N	\N	\N	\N	207638	207638	374778
27610	44653	89	applied	\N	\N	\N	\N	207639	207639	374779
27610	44657	90	applied	\N	\N	\N	\N	207640	207640	374780
27610	44660	91	applied	\N	\N	\N	\N	207641	207641	374781
27610	44663	92	applied	\N	\N	\N	\N	207642	207642	374782
27610	44664	93	applied	\N	\N	\N	\N	207643	207643	374783
27610	44669	94	applied	\N	\N	\N	\N	207644	207644	374784
27610	44672	95	applied	\N	\N	\N	\N	207645	207645	374785
27610	44678	97	applied	\N	\N	\N	\N	207647	207647	374787
27610	44681	98	applied	\N	\N	\N	\N	207648	207648	374788
27610	44682	99	applied	\N	\N	\N	\N	207649	207649	374789
27610	44687	100	applied	\N	\N	\N	\N	207650	207650	374790
27610	44688	101	applied	\N	\N	\N	\N	207651	207651	374791
27610	44693	102	applied	\N	\N	\N	\N	207652	207652	374792
27610	44694	103	applied	\N	\N	\N	\N	207653	207653	374793
27610	44700	104	applied	\N	\N	\N	\N	207654	207654	374794
27610	44703	105	applied	\N	\N	\N	\N	207655	207655	374795
27610	44706	106	applied	\N	\N	\N	\N	207656	207656	374796
27610	44707	107	applied	\N	\N	\N	\N	207657	207657	374797
27610	44712	108	applied	\N	\N	\N	\N	207658	207658	374798
27610	44715	109	applied	\N	\N	\N	\N	207659	207659	374799
27610	44718	110	applied	\N	\N	\N	\N	207660	207660	374800
27610	44727	111	applied	\N	\N	\N	\N	207661	207661	374801
27610	44730	112	applied	\N	\N	\N	\N	207662	207662	374802
27610	44737	114	applied	\N	\N	\N	\N	207664	207664	374804
27610	44738	115	applied	\N	\N	\N	\N	207665	207665	374805
27610	44743	116	applied	\N	\N	\N	\N	207666	207666	374806
27610	44752	117	applied	\N	\N	\N	\N	207667	207667	374807
27610	44755	118	applied	\N	\N	\N	\N	207668	207668	374808
27610	44756	119	applied	\N	\N	\N	\N	207669	207669	374809
27610	44757	120	applied	\N	\N	\N	\N	207670	207670	374810
27610	44758	121	applied	\N	\N	\N	\N	207671	207671	374811
27610	44767	122	applied	\N	\N	\N	\N	207672	207672	374812
27610	44304	123	applied	\N	\N	\N	\N	207673	207673	374813
27610	44565	124	applied	\N	\N	\N	\N	207674	207674	374814
27610	44571	125	applied	\N	\N	\N	\N	207675	207675	374815
27614	44770	0	applied	\N	\N	\N	\N	207761	207761	374899
27614	44771	1	applied	\N	\N	\N	\N	207762	207762	374900
27614	44772	2	applied	\N	\N	\N	\N	207763	207763	374901
27616	44782	9	applied	\N	\N	\N	\N	207777	207777	374915
27616	44784	11	applied	\N	\N	\N	\N	207779	207779	374917
27617	44785	0	applied	\N	\N	\N	\N	207780	207780	374918
27617	44786	1	applied	\N	\N	\N	\N	207781	207781	374919
27617	44787	2	applied	\N	\N	\N	\N	207782	207782	374920
27617	44777	3	applied	\N	\N	\N	\N	207783	207783	374921
27617	44778	4	applied	\N	\N	\N	\N	207784	207784	374922
27617	44779	5	applied	\N	\N	\N	\N	207785	207785	374923
27620	44797	0	applied	\N	\N	\N	\N	207803	207803	374941
27620	44798	1	applied	\N	\N	\N	\N	207804	207804	374942
27620	44799	2	applied	\N	\N	\N	\N	207805	207805	374943
27622	44797	0	applied	\N	\N	\N	\N	207807	207807	374945
27622	44798	1	applied	\N	\N	\N	\N	207808	207808	374946
27622	44799	2	applied	\N	\N	\N	\N	207809	207809	374947
27625	44803	0	applied	\N	\N	\N	\N	207819	207819	374957
27625	44804	1	applied	\N	\N	\N	\N	207820	207820	374958
27625	44805	2	applied	\N	\N	\N	\N	207821	207821	374959
27625	44807	4	applied	\N	\N	\N	\N	207823	207823	374961
27625	44808	5	applied	\N	\N	\N	\N	207824	207824	374962
27627	44809	0	applied	\N	\N	\N	\N	207831	207831	374969
27627	44810	1	applied	\N	\N	\N	\N	207832	207832	374970
27627	44811	2	applied	\N	\N	\N	\N	207833	207833	374971
27627	44812	3	applied	\N	\N	\N	\N	207834	207834	374972
27630	44819	0	applied	\N	\N	\N	\N	207845	207845	374983
27630	44820	1	applied	\N	\N	\N	\N	207846	207846	374984
27630	44821	2	applied	\N	\N	\N	\N	207847	207847	374985
27632	44822	0	applied	\N	\N	\N	\N	207851	207851	374989
27632	44823	1	applied	\N	\N	\N	\N	207852	207852	374990
27632	44824	2	applied	\N	\N	\N	\N	207853	207853	374991
27634	44825	0	applied	\N	\N	\N	\N	207857	207857	374995
27634	44826	1	applied	\N	\N	\N	\N	207858	207858	374996
27610	44502	42	applied	\N	\N	\N	\N	207593	207593	374733
27610	44505	43	applied	\N	\N	\N	\N	207594	207594	374734
27617	44783	10	applied	\N	\N	\N	\N	207790	207790	374928
27617	44789	11	applied	\N	\N	\N	\N	207791	207791	374929
27617	44790	12	applied	\N	\N	\N	\N	207792	207792	374930
27617	44784	13	applied	\N	\N	\N	\N	207793	207793	374931
27617	44791	14	applied	\N	\N	\N	\N	207794	207794	374932
27617	44792	15	applied	\N	\N	\N	\N	207795	207795	374933
27617	44793	16	applied	\N	\N	\N	\N	207796	207796	374934
27624	44803	0	applied	\N	\N	\N	\N	207813	207813	374951
27624	44804	1	applied	\N	\N	\N	\N	207814	207814	374952
27624	44805	2	applied	\N	\N	\N	\N	207815	207815	374953
27624	44806	3	applied	\N	\N	\N	\N	207816	207816	374954
27624	44807	4	applied	\N	\N	\N	\N	207817	207817	374955
27624	44808	5	applied	\N	\N	\N	\N	207818	207818	374956
27629	44813	0	applied	\N	\N	\N	\N	207839	207839	374977
27629	44814	1	applied	\N	\N	\N	\N	207840	207840	374978
27629	44815	2	applied	\N	\N	\N	\N	207841	207841	374979
27629	44817	4	applied	\N	\N	\N	\N	207843	207843	374981
27629	44818	5	applied	\N	\N	\N	\N	207844	207844	374982
27631	44823	1	applied	\N	\N	\N	\N	207849	207849	374987
27631	44824	2	applied	\N	\N	\N	\N	207850	207850	374988
27633	44825	0	applied	\N	\N	\N	\N	207854	207854	374992
27633	44826	1	applied	\N	\N	\N	\N	207855	207855	374993
27633	44827	2	applied	\N	\N	\N	\N	207856	207856	374994
27640	44828	0	applied	\N	\N	\N	\N	207863	207863	375001
27640	44829	1	applied	\N	\N	\N	\N	207864	207864	375002
27640	44830	2	applied	\N	\N	\N	\N	207865	207865	375003
27640	44831	3	applied	\N	\N	\N	\N	207866	207866	375004
27641	44828	0	applied	\N	\N	\N	\N	207875	207875	375013
27641	44829	1	applied	\N	\N	\N	\N	207876	207876	375014
27641	44830	2	applied	\N	\N	\N	\N	207877	207877	375015
27641	44831	3	applied	\N	\N	\N	\N	207878	207878	375016
27641	44832	4	applied	\N	\N	\N	\N	207879	207879	375017
27641	44834	6	applied	\N	\N	\N	\N	207881	207881	375019
27641	44835	7	applied	\N	\N	\N	\N	207882	207882	375020
27641	44836	8	applied	\N	\N	\N	\N	207883	207883	375021
27641	44837	9	applied	\N	\N	\N	\N	207884	207884	375022
27641	44838	10	applied	\N	\N	\N	\N	207885	207885	375023
27641	44839	11	applied	\N	\N	\N	\N	207886	207886	375024
27644	44828	0	applied	\N	\N	\N	\N	207911	207911	375049
27644	44829	1	applied	\N	\N	\N	\N	207912	207912	375050
27644	44830	2	applied	\N	\N	\N	\N	207913	207913	375051
27644	44831	3	applied	\N	\N	\N	\N	207914	207914	375052
27644	44832	4	applied	\N	\N	\N	\N	207915	207915	375053
27644	44833	5	applied	\N	\N	\N	\N	207916	207916	375054
27644	44834	6	applied	\N	\N	\N	\N	207917	207917	375055
27644	44835	7	applied	\N	\N	\N	\N	207918	207918	375056
27644	44836	8	applied	\N	\N	\N	\N	207919	207919	375057
27644	44837	9	applied	\N	\N	\N	\N	207920	207920	375058
27644	44839	11	applied	\N	\N	\N	\N	207922	207922	375060
27645	44840	0	applied	\N	\N	\N	\N	207923	207923	375061
27645	44841	1	applied	\N	\N	\N	\N	207924	207924	375062
27645	44842	2	applied	\N	\N	\N	\N	207925	207925	375063
27645	44843	3	applied	\N	\N	\N	\N	207926	207926	375064
27648	44850	0	applied	\N	\N	\N	\N	207937	207937	375075
27648	44851	1	applied	\N	\N	\N	\N	207938	207938	375076
27648	44852	2	applied	\N	\N	\N	\N	207939	207939	375077
27648	44853	3	applied	\N	\N	\N	\N	207940	207940	375078
27648	44854	4	applied	\N	\N	\N	\N	207941	207941	375079
27648	44855	5	applied	\N	\N	\N	\N	207942	207942	375080
27654	44869	0	applied	\N	\N	\N	\N	208091	208091	375227
27654	44870	1	applied	\N	\N	\N	\N	208092	208092	375228
27654	44871	2	applied	\N	\N	\N	\N	208093	208093	375229
27656	44872	0	applied	\N	\N	\N	\N	208097	208097	375233
27656	44873	1	applied	\N	\N	\N	\N	208098	208098	375234
27659	44875	0	applied	\N	\N	\N	\N	208106	208106	375242
27659	44876	1	applied	\N	\N	\N	\N	208107	208107	375243
27659	44877	2	applied	\N	\N	\N	\N	208108	208108	375244
27661	44881	0	applied	\N	\N	\N	\N	208112	208112	375248
27661	44882	1	applied	\N	\N	\N	\N	208113	208113	375249
27661	44883	2	applied	\N	\N	\N	\N	208114	208114	375250
27666	44895	0	applied	\N	\N	\N	\N	208137	208137	375273
27666	44896	1	applied	\N	\N	\N	\N	208138	208138	375274
27666	44897	2	applied	\N	\N	\N	\N	208139	208139	375275
27668	44898	0	applied	\N	\N	\N	\N	208143	208143	375279
27668	44899	1	applied	\N	\N	\N	\N	208144	208144	375280
27668	44900	2	applied	\N	\N	\N	\N	208145	208145	375281
27673	44901	0	applied	\N	\N	\N	\N	208157	208157	375293
27673	44902	1	applied	\N	\N	\N	\N	208158	208158	375294
27673	44903	2	applied	\N	\N	\N	\N	208159	208159	375295
27675	44901	0	applied	\N	\N	\N	\N	208163	208163	375299
27675	44903	2	applied	\N	\N	\N	\N	208165	208165	375301
27679	44907	0	applied	\N	\N	\N	\N	208176	208176	375312
27679	44908	1	applied	\N	\N	\N	\N	208177	208177	375313
27681	44909	0	applied	\N	\N	\N	\N	208180	208180	375316
27681	44910	1	applied	\N	\N	\N	\N	208181	208181	375317
27681	44911	2	applied	\N	\N	\N	\N	208182	208182	375318
27691	44928	0	applied	\N	\N	\N	\N	208295	208295	375431
27691	44929	1	applied	\N	\N	\N	\N	208296	208296	375432
27691	44930	2	applied	\N	\N	\N	\N	208297	208297	375433
27693	44931	0	applied	\N	\N	\N	\N	208301	208301	375437
27693	44932	1	applied	\N	\N	\N	\N	208302	208302	375438
27693	44933	2	applied	\N	\N	\N	\N	208303	208303	375439
27703	44944	0	applied	\N	\N	\N	\N	208435	208435	375569
27703	44945	1	applied	\N	\N	\N	\N	208436	208436	375570
27703	44946	2	applied	\N	\N	\N	\N	208437	208437	375571
27703	44947	3	applied	\N	\N	\N	\N	208438	208438	375572
27703	44949	5	applied	\N	\N	\N	\N	208440	208440	375574
27703	44950	6	applied	\N	\N	\N	\N	208441	208441	375575
27703	44951	7	applied	\N	\N	\N	\N	208442	208442	375576
27704	44952	0	applied	\N	\N	\N	\N	208443	208443	375577
27704	44953	1	applied	\N	\N	\N	\N	208444	208444	375578
27704	44954	2	applied	\N	\N	\N	\N	208445	208445	375579
27704	44955	3	applied	\N	\N	\N	\N	208446	208446	375580
27704	44956	4	applied	\N	\N	\N	\N	208447	208447	375581
27704	44957	5	applied	\N	\N	\N	\N	208448	208448	375582
27704	44958	6	applied	\N	\N	\N	\N	208449	208449	375583
27704	44959	7	applied	\N	\N	\N	\N	208450	208450	375584
27704	44960	8	applied	\N	\N	\N	\N	208451	208451	375585
27704	44961	9	applied	\N	\N	\N	\N	208452	208452	375586
27706	44952	0	applied	\N	\N	\N	\N	208463	208463	375597
27617	44781	7	applied	\N	\N	\N	\N	207787	207787	374925
27617	44788	8	applied	\N	\N	\N	\N	207788	207788	374926
27640	44835	7	applied	\N	\N	\N	\N	207870	207870	375008
27640	44836	8	applied	\N	\N	\N	\N	207871	207871	375009
27640	44837	9	applied	\N	\N	\N	\N	207872	207872	375010
27640	44838	10	applied	\N	\N	\N	\N	207873	207873	375011
27640	44839	11	applied	\N	\N	\N	\N	207874	207874	375012
27642	44828	0	applied	\N	\N	\N	\N	207887	207887	375025
27642	44829	1	applied	\N	\N	\N	\N	207888	207888	375026
27642	44830	2	applied	\N	\N	\N	\N	207889	207889	375027
27642	44831	3	applied	\N	\N	\N	\N	207890	207890	375028
27642	44832	4	applied	\N	\N	\N	\N	207891	207891	375029
27642	44833	5	applied	\N	\N	\N	\N	207892	207892	375030
27642	44834	6	applied	\N	\N	\N	\N	207893	207893	375031
27642	44835	7	applied	\N	\N	\N	\N	207894	207894	375032
27643	44828	0	applied	\N	\N	\N	\N	207899	207899	375037
27643	44829	1	applied	\N	\N	\N	\N	207900	207900	375038
27643	44830	2	applied	\N	\N	\N	\N	207901	207901	375039
27643	44832	4	applied	\N	\N	\N	\N	207903	207903	375041
27643	44833	5	applied	\N	\N	\N	\N	207904	207904	375042
27643	44834	6	applied	\N	\N	\N	\N	207905	207905	375043
27643	44835	7	applied	\N	\N	\N	\N	207906	207906	375044
27643	44836	8	applied	\N	\N	\N	\N	207907	207907	375045
27643	44837	9	applied	\N	\N	\N	\N	207908	207908	375046
27643	44838	10	applied	\N	\N	\N	\N	207909	207909	375047
27643	44839	11	applied	\N	\N	\N	\N	207910	207910	375048
27647	44844	0	applied	\N	\N	\N	\N	207931	207931	375069
27647	44845	1	applied	\N	\N	\N	\N	207932	207932	375070
27647	44846	2	applied	\N	\N	\N	\N	207933	207933	375071
27647	44847	3	applied	\N	\N	\N	\N	207934	207934	375072
27647	44848	4	applied	\N	\N	\N	\N	207935	207935	375073
27647	44849	5	applied	\N	\N	\N	\N	207936	207936	375074
27651	44856	0	applied	\N	\N	\N	\N	207953	207953	375091
27651	44857	1	applied	\N	\N	\N	\N	207954	207954	375092
27651	44722	3	applied	\N	\N	\N	\N	207956	207956	375094
27651	44699	4	applied	\N	\N	\N	\N	207957	207957	375095
27651	44700	5	applied	\N	\N	\N	\N	207958	207958	375096
27651	44703	6	applied	\N	\N	\N	\N	207959	207959	375097
27651	44706	7	applied	\N	\N	\N	\N	207960	207960	375098
27651	44707	8	applied	\N	\N	\N	\N	207961	207961	375099
27651	44712	9	applied	\N	\N	\N	\N	207962	207962	375100
27651	44715	10	applied	\N	\N	\N	\N	207963	207963	375101
27651	44860	11	applied	\N	\N	\N	\N	207964	207964	375102
27651	44718	12	applied	\N	\N	\N	\N	207965	207965	375103
27651	44723	13	applied	\N	\N	\N	\N	207966	207966	375104
27651	44724	14	applied	\N	\N	\N	\N	207967	207967	375105
27651	44725	15	applied	\N	\N	\N	\N	207968	207968	375106
27651	44726	16	applied	\N	\N	\N	\N	207969	207969	207969
27651	44744	17	applied	\N	\N	\N	\N	207970	207970	375107
27651	44745	18	applied	\N	\N	\N	\N	207971	207971	375108
27651	44747	20	applied	\N	\N	\N	\N	207973	207973	375110
27651	44748	21	applied	\N	\N	\N	\N	207974	207974	375111
27651	44749	22	applied	\N	\N	\N	\N	207975	207975	207975
27651	44727	23	applied	\N	\N	\N	\N	207976	207976	375112
27651	44730	24	applied	\N	\N	\N	\N	207977	207977	375113
27651	44731	25	applied	\N	\N	\N	\N	207978	207978	375114
27651	44737	26	applied	\N	\N	\N	\N	207979	207979	375115
27651	44738	27	applied	\N	\N	\N	\N	207980	207980	375116
27651	44743	28	applied	\N	\N	\N	\N	207981	207981	375117
27651	44752	29	applied	\N	\N	\N	\N	207982	207982	375118
27651	44755	30	applied	\N	\N	\N	\N	207983	207983	375119
27651	44756	31	applied	\N	\N	\N	\N	207984	207984	375120
27651	44757	32	applied	\N	\N	\N	\N	207985	207985	375121
27651	44758	33	applied	\N	\N	\N	\N	207986	207986	375122
27651	44767	34	applied	\N	\N	\N	\N	207987	207987	375123
27651	44770	35	applied	\N	\N	\N	\N	207988	207988	375124
27651	44774	37	applied	\N	\N	\N	\N	207990	207990	375126
27651	44775	38	applied	\N	\N	\N	\N	207991	207991	375127
27651	44776	39	applied	\N	\N	\N	\N	207992	207992	375128
27651	44785	40	applied	\N	\N	\N	\N	207993	207993	375129
27651	44786	41	applied	\N	\N	\N	\N	207994	207994	375130
27651	44787	42	applied	\N	\N	\N	\N	207995	207995	375131
27651	44794	43	applied	\N	\N	\N	\N	207996	207996	375132
27651	44797	44	applied	\N	\N	\N	\N	207997	207997	375133
27651	44800	45	applied	\N	\N	\N	\N	207998	207998	375134
27651	44803	46	applied	\N	\N	\N	\N	207999	207999	375135
27651	44804	47	applied	\N	\N	\N	\N	208000	208000	375136
27651	44809	48	applied	\N	\N	\N	\N	208001	208001	375137
27651	44813	49	applied	\N	\N	\N	\N	208002	208002	375138
27651	44814	50	applied	\N	\N	\N	\N	208003	208003	375139
27651	44819	51	applied	\N	\N	\N	\N	208004	208004	375140
27651	44822	53	applied	\N	\N	\N	\N	208005	208005	375141
27651	44828	55	applied	\N	\N	\N	\N	208007	208007	375143
27651	44861	56	applied	\N	\N	\N	\N	208008	208008	375144
27651	44829	57	applied	\N	\N	\N	\N	208009	208009	375145
27651	44830	58	applied	\N	\N	\N	\N	208010	208010	375146
27651	44831	59	applied	\N	\N	\N	\N	208011	208011	375147
27651	44840	60	applied	\N	\N	\N	\N	208012	208012	375148
27651	44844	61	applied	\N	\N	\N	\N	208013	208013	375149
27651	44845	62	applied	\N	\N	\N	\N	208014	208014	375150
27651	44850	63	applied	\N	\N	\N	\N	208015	208015	375151
27651	44851	64	applied	\N	\N	\N	\N	208016	208016	375152
27651	44858	65	applied	\N	\N	\N	\N	208017	208017	375153
27651	44859	66	applied	\N	\N	\N	\N	208018	208018	375154
27651	44841	67	applied	\N	\N	\N	\N	208019	208019	375155
27651	44811	68	applied	\N	\N	\N	\N	208020	208020	375156
27651	44701	69	applied	\N	\N	\N	\N	208021	208021	375157
27651	44704	70	applied	\N	\N	\N	\N	208022	208022	375158
27651	44702	72	applied	\N	\N	\N	\N	208024	208024	375160
27651	44705	73	applied	\N	\N	\N	\N	208025	208025	375161
27651	44711	74	applied	\N	\N	\N	\N	208026	208026	375162
27651	44714	75	applied	\N	\N	\N	\N	208027	208027	375163
27651	44717	76	applied	\N	\N	\N	\N	208028	208028	375164
27651	44720	77	applied	\N	\N	\N	\N	208029	208029	375165
27651	44728	78	applied	\N	\N	\N	\N	208030	208030	375166
27651	44733	79	applied	\N	\N	\N	\N	208031	208031	375167
27651	44736	80	applied	\N	\N	\N	\N	208032	208032	375168
27651	44739	81	applied	\N	\N	\N	\N	208033	208033	375169
27651	44740	82	applied	\N	\N	\N	\N	208034	208034	375170
27651	44751	83	applied	\N	\N	\N	\N	208035	208035	375171
27651	44754	84	applied	\N	\N	\N	\N	208036	208036	375172
27651	44759	85	applied	\N	\N	\N	\N	208037	208037	375173
27640	44832	4	applied	\N	\N	\N	\N	207867	207867	375005
27640	44833	5	applied	\N	\N	\N	\N	207868	207868	375006
27646	44840	0	applied	\N	\N	\N	\N	207927	207927	375065
27646	44841	1	applied	\N	\N	\N	\N	207928	207928	375066
27646	44842	2	applied	\N	\N	\N	\N	207929	207929	375067
27646	44843	3	applied	\N	\N	\N	\N	207930	207930	375068
27650	44856	0	applied	\N	\N	\N	\N	207943	207943	375081
27650	44857	1	applied	\N	\N	\N	\N	207944	207944	375082
27650	44858	2	applied	\N	\N	\N	\N	207945	207945	375083
27650	44859	3	applied	\N	\N	\N	\N	207946	207946	375084
27650	44860	4	applied	\N	\N	\N	\N	207947	207947	375085
27650	44861	5	applied	\N	\N	\N	\N	207948	207948	375086
27650	44862	6	applied	\N	\N	\N	\N	207949	207949	375087
27650	44863	7	applied	\N	\N	\N	\N	207950	207950	375088
27650	44864	8	applied	\N	\N	\N	\N	207951	207951	375089
27650	44865	9	applied	\N	\N	\N	\N	207952	207952	375090
27651	44760	86	applied	\N	\N	\N	\N	208038	208038	375174
27651	44763	87	applied	\N	\N	\N	\N	208039	208039	375175
27651	44768	89	applied	\N	\N	\N	\N	208041	208041	375177
27651	44771	90	applied	\N	\N	\N	\N	208042	208042	375178
27651	44778	91	applied	\N	\N	\N	\N	208043	208043	375179
27651	44779	92	applied	\N	\N	\N	\N	208044	208044	375180
27651	44780	93	applied	\N	\N	\N	\N	208045	208045	375181
27651	44781	94	applied	\N	\N	\N	\N	208046	208046	375182
27652	44856	0	applied	\N	\N	\N	\N	208078	208078	375214
27652	44857	1	applied	\N	\N	\N	\N	208079	208079	375215
27652	44858	2	applied	\N	\N	\N	\N	208080	208080	375216
27652	44859	3	applied	\N	\N	\N	\N	208081	208081	375217
27652	44860	4	applied	\N	\N	\N	\N	208082	208082	375218
27652	44861	5	applied	\N	\N	\N	\N	208083	208083	375219
27652	44862	6	applied	\N	\N	\N	\N	208084	208084	375220
27652	44863	7	applied	\N	\N	\N	\N	208085	208085	375221
27652	44864	8	applied	\N	\N	\N	\N	208086	208086	375222
27652	44865	9	applied	\N	\N	\N	\N	208087	208087	375223
27662	44885	1	applied	\N	\N	\N	\N	208116	208116	375252
27662	44886	2	applied	\N	\N	\N	\N	208117	208117	375253
27662	44887	3	applied	\N	\N	\N	\N	208118	208118	375254
27662	44888	4	applied	\N	\N	\N	\N	208119	208119	375255
27662	44889	5	applied	\N	\N	\N	\N	208120	208120	375256
27662	44890	6	applied	\N	\N	\N	\N	208121	208121	375257
27662	44891	7	applied	\N	\N	\N	\N	208122	208122	375258
27664	44892	0	applied	\N	\N	\N	\N	208131	208131	375267
27664	44893	1	applied	\N	\N	\N	\N	208132	208132	375268
27664	44894	2	applied	\N	\N	\N	\N	208133	208133	375269
27669	44898	0	applied	\N	\N	\N	\N	208146	208146	375282
27669	44899	1	applied	\N	\N	\N	\N	208147	208147	375283
27669	44900	2	applied	\N	\N	\N	\N	208148	208148	375284
27671	44901	0	applied	\N	\N	\N	\N	208152	208152	375288
27671	44902	1	applied	\N	\N	\N	\N	208153	208153	375289
27671	44903	2	applied	\N	\N	\N	\N	208154	208154	375290
27677	44902	1	applied	\N	\N	\N	\N	208171	208171	375307
27677	44903	2	applied	\N	\N	\N	\N	208172	208172	375308
27682	44912	0	applied	\N	\N	\N	\N	208183	208183	375319
27682	44913	1	applied	\N	\N	\N	\N	208184	208184	375320
27682	44914	2	applied	\N	\N	\N	\N	208185	208185	375321
27687	44922	0	applied	\N	\N	\N	\N	208277	208277	375413
27687	44923	1	applied	\N	\N	\N	\N	208278	208278	375414
27687	44924	2	applied	\N	\N	\N	\N	208279	208279	375415
27687	44925	3	applied	\N	\N	\N	\N	208280	208280	375416
27687	44926	4	applied	\N	\N	\N	\N	208281	208281	375417
27687	44927	5	applied	\N	\N	\N	\N	208282	208282	375418
27689	44928	0	applied	\N	\N	\N	\N	208289	208289	375425
27689	44929	1	applied	\N	\N	\N	\N	208290	208290	375426
27689	44930	2	applied	\N	\N	\N	\N	208291	208291	375427
27696	44936	0	applied	\N	\N	\N	\N	208308	208308	375444
27696	44937	1	applied	\N	\N	\N	\N	208309	208309	375445
27698	44721	1	applied	\N	\N	\N	\N	208313	208313	375449
27698	44722	2	applied	\N	\N	\N	\N	208314	208314	375450
27698	44563	3	applied	\N	\N	\N	\N	208315	208315	375451
27698	44699	4	applied	\N	\N	\N	\N	208316	208316	375452
27698	44723	5	applied	\N	\N	\N	\N	208317	208317	375453
27698	44724	6	applied	\N	\N	\N	\N	208318	208318	375454
27698	44725	7	applied	\N	\N	\N	\N	208319	208319	375455
27698	44726	8	applied	\N	\N	\N	\N	208320	208320	208320
27698	44744	9	applied	\N	\N	\N	\N	208321	208321	375456
27698	44745	10	applied	\N	\N	\N	\N	208322	208322	375457
27698	44746	11	applied	\N	\N	\N	\N	208323	208323	375458
27698	44747	12	applied	\N	\N	\N	\N	208324	208324	375459
27698	44748	13	applied	\N	\N	\N	\N	208325	208325	375460
27698	44749	14	applied	\N	\N	\N	\N	208326	208326	208326
27698	44565	15	applied	\N	\N	\N	\N	208327	208327	375461
27698	44571	16	applied	\N	\N	\N	\N	208328	208328	375462
27698	44273	18	applied	\N	\N	\N	\N	208330	208330	375464
27698	44583	19	applied	\N	\N	\N	\N	208331	208331	375465
27698	44387	20	applied	\N	\N	\N	\N	208332	208332	375466
27698	44886	21	applied	\N	\N	\N	\N	208333	208333	375467
27698	44274	22	applied	\N	\N	\N	\N	208334	208334	375468
27698	44811	23	applied	\N	\N	\N	\N	208335	208335	375469
27698	44275	24	applied	\N	\N	\N	\N	208336	208336	375470
27698	44276	25	applied	\N	\N	\N	\N	208337	208337	375471
27698	44277	26	applied	\N	\N	\N	\N	208338	208338	375472
27698	44278	27	applied	\N	\N	\N	\N	208339	208339	375473
27698	44279	28	applied	\N	\N	\N	\N	208340	208340	375474
27698	44280	29	applied	\N	\N	\N	\N	208341	208341	375475
27698	44286	30	applied	\N	\N	\N	\N	208342	208342	375476
27698	44287	31	applied	\N	\N	\N	\N	208343	208343	375477
27698	44290	32	applied	\N	\N	\N	\N	208344	208344	375478
27698	44291	33	applied	\N	\N	\N	\N	208345	208345	375479
27698	44293	35	applied	\N	\N	\N	\N	208347	208347	375481
27698	44889	36	applied	\N	\N	\N	\N	208348	208348	375482
27698	44297	37	applied	\N	\N	\N	\N	208349	208349	375483
27698	44298	38	applied	\N	\N	\N	\N	208350	208350	375484
27698	44299	39	applied	\N	\N	\N	\N	208351	208351	375485
27698	44300	40	applied	\N	\N	\N	\N	208352	208352	375486
27698	44301	41	applied	\N	\N	\N	\N	208353	208353	375487
27698	44302	42	applied	\N	\N	\N	\N	208354	208354	375488
27698	44304	43	applied	\N	\N	\N	\N	208355	208355	375489
27698	44305	44	applied	\N	\N	\N	\N	208356	208356	375490
27698	44306	45	applied	\N	\N	\N	\N	208357	208357	375491
27698	44307	46	applied	\N	\N	\N	\N	208358	208358	375492
27698	44308	47	applied	\N	\N	\N	\N	208359	208359	375493
27698	44314	48	applied	\N	\N	\N	\N	208360	208360	375494
27642	44837	9	applied	\N	\N	\N	\N	207896	207896	375034
27642	44838	10	applied	\N	\N	\N	\N	207897	207897	375035
27651	44799	99	applied	\N	\N	\N	\N	208051	208051	375187
27651	44801	100	applied	\N	\N	\N	\N	208052	208052	375188
27651	44805	101	applied	\N	\N	\N	\N	208053	208053	375189
27651	44806	102	applied	\N	\N	\N	\N	208054	208054	375190
27651	44812	103	applied	\N	\N	\N	\N	208055	208055	375191
27651	44817	104	applied	\N	\N	\N	\N	208056	208056	375192
27651	44818	105	applied	\N	\N	\N	\N	208057	208057	375193
27651	44820	106	applied	\N	\N	\N	\N	208058	208058	375194
27651	44824	107	applied	\N	\N	\N	\N	208059	208059	375195
27651	44827	108	applied	\N	\N	\N	\N	208060	208060	375196
27651	44832	109	applied	\N	\N	\N	\N	208061	208061	375197
27651	44837	110	applied	\N	\N	\N	\N	208062	208062	375198
27651	44838	111	applied	\N	\N	\N	\N	208063	208063	375199
27651	44839	112	applied	\N	\N	\N	\N	208064	208064	375200
27651	44843	113	applied	\N	\N	\N	\N	208065	208065	375201
27651	44846	114	applied	\N	\N	\N	\N	208066	208066	375202
27651	44852	116	applied	\N	\N	\N	\N	208068	208068	375204
27651	44853	117	applied	\N	\N	\N	\N	208069	208069	375205
27651	44862	118	applied	\N	\N	\N	\N	208070	208070	375206
27651	44863	119	applied	\N	\N	\N	\N	208071	208071	375207
27651	44708	120	applied	\N	\N	\N	\N	208072	208072	375208
27651	44709	121	applied	\N	\N	\N	\N	208073	208073	375209
27651	44713	122	applied	\N	\N	\N	\N	208074	208074	375210
27651	44716	123	applied	\N	\N	\N	\N	208075	208075	375211
27651	44719	124	applied	\N	\N	\N	\N	208076	208076	375212
27651	44729	125	applied	\N	\N	\N	\N	208077	208077	375213
27653	44866	0	applied	\N	\N	\N	\N	208088	208088	375224
27653	44867	1	applied	\N	\N	\N	\N	208089	208089	375225
27653	44868	2	applied	\N	\N	\N	\N	208090	208090	375226
27658	44875	0	applied	\N	\N	\N	\N	208103	208103	375239
27658	44876	1	applied	\N	\N	\N	\N	208104	208104	375240
27658	44877	2	applied	\N	\N	\N	\N	208105	208105	375241
27672	44903	1	applied	\N	\N	\N	\N	208156	208156	375292
27676	44898	0	applied	\N	\N	\N	\N	208166	208166	375302
27676	44901	1	applied	\N	\N	\N	\N	208167	208167	375303
27676	44899	2	applied	\N	\N	\N	\N	208168	208168	375304
27676	44900	3	applied	\N	\N	\N	\N	208169	208169	375305
27678	44904	0	applied	\N	\N	\N	\N	208173	208173	375309
27678	44905	1	applied	\N	\N	\N	\N	208174	208174	375310
27678	44906	2	applied	\N	\N	\N	\N	208175	208175	375311
27683	44866	0	applied	\N	\N	\N	\N	208186	208186	375322
27683	44869	1	applied	\N	\N	\N	\N	208187	208187	375323
27683	44872	2	applied	\N	\N	\N	\N	208188	208188	375324
27683	44875	3	applied	\N	\N	\N	\N	208189	208189	375325
27683	44878	4	applied	\N	\N	\N	\N	208190	208190	375326
27683	44881	5	applied	\N	\N	\N	\N	208191	208191	375327
27683	44884	6	applied	\N	\N	\N	\N	208192	208192	375328
27683	44885	7	applied	\N	\N	\N	\N	208193	208193	375329
27683	44895	9	applied	\N	\N	\N	\N	208195	208195	375331
27683	44898	10	applied	\N	\N	\N	\N	208196	208196	375332
27683	44901	11	applied	\N	\N	\N	\N	208197	208197	375333
27683	44904	12	applied	\N	\N	\N	\N	208198	208198	375334
27683	44907	13	applied	\N	\N	\N	\N	208199	208199	375335
27683	44909	14	applied	\N	\N	\N	\N	208200	208200	375336
27683	44912	15	applied	\N	\N	\N	\N	208201	208201	375337
27683	44867	16	applied	\N	\N	\N	\N	208202	208202	375338
27683	44870	17	applied	\N	\N	\N	\N	208203	208203	375339
27683	44886	18	applied	\N	\N	\N	\N	208204	208204	375340
27683	44889	19	applied	\N	\N	\N	\N	208205	208205	375341
27683	44734	20	applied	\N	\N	\N	\N	208206	208206	375342
27683	44735	21	applied	\N	\N	\N	\N	208207	208207	375343
27683	44741	22	applied	\N	\N	\N	\N	208208	208208	375344
27683	44742	23	applied	\N	\N	\N	\N	208209	208209	375345
27683	44750	24	applied	\N	\N	\N	\N	208210	208210	375346
27683	44761	26	applied	\N	\N	\N	\N	208212	208212	375348
27683	44762	27	applied	\N	\N	\N	\N	208213	208213	375349
27683	44765	28	applied	\N	\N	\N	\N	208214	208214	375350
27683	44766	29	applied	\N	\N	\N	\N	208215	208215	375351
27683	44769	30	applied	\N	\N	\N	\N	208216	208216	375352
27683	44772	31	applied	\N	\N	\N	\N	208217	208217	375353
27683	44777	32	applied	\N	\N	\N	\N	208218	208218	375354
27683	44782	33	applied	\N	\N	\N	\N	208219	208219	375355
27683	44783	34	applied	\N	\N	\N	\N	208220	208220	375356
27683	44874	35	applied	\N	\N	\N	\N	208221	208221	375357
27683	44876	36	applied	\N	\N	\N	\N	208222	208222	375358
27683	44879	37	applied	\N	\N	\N	\N	208223	208223	375359
27683	44882	38	applied	\N	\N	\N	\N	208224	208224	375360
27683	44887	39	applied	\N	\N	\N	\N	208225	208225	375361
27683	44888	40	applied	\N	\N	\N	\N	208226	208226	375362
27683	44894	41	applied	\N	\N	\N	\N	208227	208227	375363
27683	44784	43	applied	\N	\N	\N	\N	208229	208229	375365
27683	44791	44	applied	\N	\N	\N	\N	208230	208230	375366
27683	44792	45	applied	\N	\N	\N	\N	208231	208231	375367
27683	44793	46	applied	\N	\N	\N	\N	208232	208232	375368
27683	44795	47	applied	\N	\N	\N	\N	208233	208233	375369
27683	44798	48	applied	\N	\N	\N	\N	208234	208234	375370
27683	44802	49	applied	\N	\N	\N	\N	208235	208235	375371
27683	44807	50	applied	\N	\N	\N	\N	208236	208236	375372
27683	44808	51	applied	\N	\N	\N	\N	208237	208237	375373
27683	44810	53	applied	\N	\N	\N	\N	208238	208238	375374
27683	44815	54	applied	\N	\N	\N	\N	208239	208239	375375
27683	44816	55	applied	\N	\N	\N	\N	208240	208240	375376
27683	44821	56	applied	\N	\N	\N	\N	208241	208241	375377
27683	44823	57	applied	\N	\N	\N	\N	208242	208242	375378
27683	44826	58	applied	\N	\N	\N	\N	208243	208243	375379
27683	44833	59	applied	\N	\N	\N	\N	208244	208244	375380
27683	44835	61	applied	\N	\N	\N	\N	208246	208246	375382
27683	44836	62	applied	\N	\N	\N	\N	208247	208247	375383
27683	44842	63	applied	\N	\N	\N	\N	208248	208248	375384
27683	44848	64	applied	\N	\N	\N	\N	208249	208249	375385
27683	44849	65	applied	\N	\N	\N	\N	208250	208250	375386
27683	44854	66	applied	\N	\N	\N	\N	208251	208251	375387
27683	44855	67	applied	\N	\N	\N	\N	208252	208252	375388
27683	44864	68	applied	\N	\N	\N	\N	208253	208253	375389
27683	44865	69	applied	\N	\N	\N	\N	208254	208254	375390
27683	44868	70	applied	\N	\N	\N	\N	208255	208255	375391
27683	44871	71	applied	\N	\N	\N	\N	208256	208256	375392
27683	44873	72	applied	\N	\N	\N	\N	208257	208257	375393
27683	44877	73	applied	\N	\N	\N	\N	208258	208258	375394
27683	44880	74	applied	\N	\N	\N	\N	208259	208259	375395
27651	44789	96	applied	\N	\N	\N	\N	208048	208048	375184
27651	44790	97	applied	\N	\N	\N	\N	208049	208049	375185
27685	44919	4	applied	\N	\N	\N	\N	208267	208267	375403
27685	44920	5	applied	\N	\N	\N	\N	208268	208268	375404
27685	44921	6	applied	\N	\N	\N	\N	208269	208269	375405
27686	44915	0	applied	\N	\N	\N	\N	208270	208270	375406
27686	44916	1	applied	\N	\N	\N	\N	208271	208271	375407
27686	44917	2	applied	\N	\N	\N	\N	208272	208272	375408
27686	44918	3	applied	\N	\N	\N	\N	208273	208273	375409
27686	44919	4	applied	\N	\N	\N	\N	208274	208274	375410
27686	44920	5	applied	\N	\N	\N	\N	208275	208275	375411
27686	44921	6	applied	\N	\N	\N	\N	208276	208276	375412
27688	44922	0	applied	\N	\N	\N	\N	208283	208283	375419
27688	44923	1	applied	\N	\N	\N	\N	208284	208284	375420
27688	44924	2	applied	\N	\N	\N	\N	208285	208285	375421
27688	44925	3	applied	\N	\N	\N	\N	208286	208286	375422
27688	44926	4	applied	\N	\N	\N	\N	208287	208287	375423
27688	44927	5	applied	\N	\N	\N	\N	208288	208288	375424
27690	44929	1	applied	\N	\N	\N	\N	208293	208293	375429
27690	44930	2	applied	\N	\N	\N	\N	208294	208294	375430
27692	44928	0	applied	\N	\N	\N	\N	208298	208298	375434
27692	44929	1	applied	\N	\N	\N	\N	208299	208299	375435
27695	44934	0	applied	\N	\N	\N	\N	208306	208306	375442
27695	44935	1	applied	\N	\N	\N	\N	208307	208307	375443
27697	44936	0	applied	\N	\N	\N	\N	208310	208310	375446
27697	44937	1	applied	\N	\N	\N	\N	208311	208311	375447
27700	44938	0	applied	\N	\N	\N	\N	208417	208417	375551
27700	44939	1	applied	\N	\N	\N	\N	208418	208418	375552
27700	44940	2	applied	\N	\N	\N	\N	208419	208419	375553
27700	44941	3	applied	\N	\N	\N	\N	208420	208420	375554
27700	44942	4	applied	\N	\N	\N	\N	208421	208421	375555
27700	44943	5	applied	\N	\N	\N	\N	208422	208422	375556
27702	44938	0	applied	\N	\N	\N	\N	208429	208429	375563
27702	44939	1	applied	\N	\N	\N	\N	208430	208430	375564
27702	44941	3	applied	\N	\N	\N	\N	208432	208432	375566
27702	44942	4	applied	\N	\N	\N	\N	208433	208433	375567
27702	44943	5	applied	\N	\N	\N	\N	208434	208434	375568
27709	44972	0	applied	\N	\N	\N	\N	208483	208483	375617
27709	44973	1	applied	\N	\N	\N	\N	208484	208484	375618
27711	44972	0	applied	\N	\N	\N	\N	208487	208487	375621
27711	44973	1	applied	\N	\N	\N	\N	208488	208488	375622
27716	44978	0	applied	\N	\N	\N	\N	208501	208501	375635
27716	44979	1	applied	\N	\N	\N	\N	208502	208502	375636
27718	44980	0	applied	\N	\N	\N	\N	208505	208505	375639
27718	44981	1	applied	\N	\N	\N	\N	208506	208506	375640
27720	44856	0	applied	\N	\N	\N	\N	208509	208509	375643
27720	44857	1	applied	\N	\N	\N	\N	208510	208510	375644
27720	44915	2	applied	\N	\N	\N	\N	208511	208511	375645
27720	44954	3	applied	\N	\N	\N	\N	208512	208512	375646
27720	44721	4	applied	\N	\N	\N	\N	208513	208513	375647
27720	44955	6	applied	\N	\N	\N	\N	208515	208515	375649
27720	44699	7	applied	\N	\N	\N	\N	208516	208516	375650
27720	44599	8	applied	\N	\N	\N	\N	208517	208517	375651
27720	44600	9	applied	\N	\N	\N	\N	208518	208518	375652
27720	44957	10	applied	\N	\N	\N	\N	208519	208519	375653
27720	44860	11	applied	\N	\N	\N	\N	208520	208520	375654
27720	44610	12	applied	\N	\N	\N	\N	208521	208521	375655
27720	44621	13	applied	\N	\N	\N	\N	208522	208522	375656
27720	44958	14	applied	\N	\N	\N	\N	208523	208523	375657
27720	44723	15	applied	\N	\N	\N	\N	208524	208524	375658
27720	44724	16	applied	\N	\N	\N	\N	208525	208525	375659
27720	44725	17	applied	\N	\N	\N	\N	208526	208526	375660
27720	44726	18	applied	\N	\N	\N	\N	208527	208527	208527
27720	44744	19	applied	\N	\N	\N	\N	208528	208528	375661
27720	44745	20	applied	\N	\N	\N	\N	208529	208529	375662
27720	44746	21	applied	\N	\N	\N	\N	208530	208530	375663
27720	44748	23	applied	\N	\N	\N	\N	208532	208532	375665
27720	44749	24	applied	\N	\N	\N	\N	208533	208533	208533
27720	44605	25	applied	\N	\N	\N	\N	208534	208534	375666
27720	44607	26	applied	\N	\N	\N	\N	208535	208535	375667
27720	44611	27	applied	\N	\N	\N	\N	208536	208536	375668
27720	44612	28	applied	\N	\N	\N	\N	208537	208537	375669
27720	44617	29	applied	\N	\N	\N	\N	208538	208538	375670
27720	44620	30	applied	\N	\N	\N	\N	208539	208539	375671
27720	44624	31	applied	\N	\N	\N	\N	208540	208540	375672
27720	44625	32	applied	\N	\N	\N	\N	208541	208541	375673
27720	44626	33	applied	\N	\N	\N	\N	208542	208542	375674
27720	44633	34	applied	\N	\N	\N	\N	208543	208543	375675
27720	44634	35	applied	\N	\N	\N	\N	208544	208544	375676
27720	44639	36	applied	\N	\N	\N	\N	208545	208545	375677
27720	44642	37	applied	\N	\N	\N	\N	208546	208546	375678
27720	44644	38	applied	\N	\N	\N	\N	208547	208547	375679
27720	44653	40	applied	\N	\N	\N	\N	208549	208549	375681
27720	44657	41	applied	\N	\N	\N	\N	208550	208550	375682
27720	44660	42	applied	\N	\N	\N	\N	208551	208551	375683
27720	44663	43	applied	\N	\N	\N	\N	208552	208552	375684
27720	44664	44	applied	\N	\N	\N	\N	208553	208553	375685
27720	44669	45	applied	\N	\N	\N	\N	208554	208554	375686
27720	44672	46	applied	\N	\N	\N	\N	208555	208555	375687
27720	44673	47	applied	\N	\N	\N	\N	208556	208556	375688
27720	44678	48	applied	\N	\N	\N	\N	208557	208557	375689
27720	44681	49	applied	\N	\N	\N	\N	208558	208558	375690
27720	44682	50	applied	\N	\N	\N	\N	208559	208559	375691
27720	44687	51	applied	\N	\N	\N	\N	208560	208560	375692
27720	44688	52	applied	\N	\N	\N	\N	208561	208561	375693
27720	44693	53	applied	\N	\N	\N	\N	208562	208562	375694
27720	44694	54	applied	\N	\N	\N	\N	208563	208563	375695
27720	44700	55	applied	\N	\N	\N	\N	208564	208564	375696
27720	44706	57	applied	\N	\N	\N	\N	208566	208566	375698
27720	44707	58	applied	\N	\N	\N	\N	208567	208567	375699
27720	44712	59	applied	\N	\N	\N	\N	208568	208568	375700
27720	44715	60	applied	\N	\N	\N	\N	208569	208569	375701
27720	44718	61	applied	\N	\N	\N	\N	208570	208570	375702
27720	44727	62	applied	\N	\N	\N	\N	208571	208571	375703
27720	44730	63	applied	\N	\N	\N	\N	208572	208572	375704
27720	44731	64	applied	\N	\N	\N	\N	208573	208573	375705
27720	44737	65	applied	\N	\N	\N	\N	208574	208574	375706
27720	44738	66	applied	\N	\N	\N	\N	208575	208575	375707
27720	44743	67	applied	\N	\N	\N	\N	208576	208576	375708
27720	44752	68	applied	\N	\N	\N	\N	208577	208577	375709
27720	44755	69	applied	\N	\N	\N	\N	208578	208578	375710
27720	44756	71	applied	\N	\N	\N	\N	208579	208579	375711
27683	44890	76	applied	\N	\N	\N	\N	208261	208261	375397
27683	44891	77	applied	\N	\N	\N	\N	208262	208262	375398
27698	44316	50	applied	\N	\N	\N	\N	208362	208362	375496
27698	44317	51	applied	\N	\N	\N	\N	208363	208363	375497
27698	44318	52	applied	\N	\N	\N	\N	208364	208364	375498
27698	44319	53	applied	\N	\N	\N	\N	208365	208365	375499
27698	44320	54	applied	\N	\N	\N	\N	208366	208366	375500
27698	44321	55	applied	\N	\N	\N	\N	208367	208367	375501
27698	44322	56	applied	\N	\N	\N	\N	208368	208368	375502
27698	44326	57	applied	\N	\N	\N	\N	208369	208369	375503
27698	44327	58	applied	\N	\N	\N	\N	208370	208370	375504
27698	44328	59	applied	\N	\N	\N	\N	208371	208371	375505
27698	44329	60	applied	\N	\N	\N	\N	208372	208372	375506
27698	44330	61	applied	\N	\N	\N	\N	208373	208373	375507
27698	44595	62	applied	\N	\N	\N	\N	208374	208374	375508
27698	44331	63	applied	\N	\N	\N	\N	208375	208375	375509
27698	44338	64	applied	\N	\N	\N	\N	208376	208376	375510
27698	44339	65	applied	\N	\N	\N	\N	208377	208377	375511
27698	44346	67	applied	\N	\N	\N	\N	208379	208379	375513
27698	44347	68	applied	\N	\N	\N	\N	208380	208380	375514
27698	44348	69	applied	\N	\N	\N	\N	208381	208381	375515
27698	44349	70	applied	\N	\N	\N	\N	208382	208382	375516
27698	44356	71	applied	\N	\N	\N	\N	208383	208383	375517
27698	44243	72	applied	\N	\N	\N	\N	208384	208384	375518
27698	44358	73	applied	\N	\N	\N	\N	208385	208385	375519
27698	44359	74	applied	\N	\N	\N	\N	208386	208386	375520
27698	44360	75	applied	\N	\N	\N	\N	208387	208387	375521
27698	44361	76	applied	\N	\N	\N	\N	208388	208388	375522
27698	44362	77	applied	\N	\N	\N	\N	208389	208389	375523
27698	44363	78	applied	\N	\N	\N	\N	208390	208390	375524
27698	44364	79	applied	\N	\N	\N	\N	208391	208391	375525
27698	44365	80	applied	\N	\N	\N	\N	208392	208392	375526
27698	44366	81	applied	\N	\N	\N	\N	208393	208393	375527
27698	44367	82	applied	\N	\N	\N	\N	208394	208394	375528
27698	44369	84	applied	\N	\N	\N	\N	208396	208396	375530
27698	44370	85	applied	\N	\N	\N	\N	208397	208397	375531
27698	44371	86	applied	\N	\N	\N	\N	208398	208398	375532
27698	44372	87	applied	\N	\N	\N	\N	208399	208399	375533
27698	44373	88	applied	\N	\N	\N	\N	208400	208400	375534
27698	44377	89	applied	\N	\N	\N	\N	208401	208401	375535
27698	44378	90	applied	\N	\N	\N	\N	208402	208402	375536
27698	44379	91	applied	\N	\N	\N	\N	208403	208403	375537
27698	44380	92	applied	\N	\N	\N	\N	208404	208404	375538
27698	44381	93	applied	\N	\N	\N	\N	208405	208405	375539
27698	44382	94	applied	\N	\N	\N	\N	208406	208406	375540
27698	44386	95	applied	\N	\N	\N	\N	208407	208407	375541
27698	44389	96	applied	\N	\N	\N	\N	208408	208408	375542
27698	44390	97	applied	\N	\N	\N	\N	208409	208409	375543
27698	44391	98	applied	\N	\N	\N	\N	208410	208410	375544
27699	44938	0	applied	\N	\N	\N	\N	208411	208411	375545
27699	44940	2	applied	\N	\N	\N	\N	208413	208413	375547
27699	44941	3	applied	\N	\N	\N	\N	208414	208414	375548
27699	44942	4	applied	\N	\N	\N	\N	208415	208415	375549
27699	44943	5	applied	\N	\N	\N	\N	208416	208416	375550
27701	44938	0	applied	\N	\N	\N	\N	208423	208423	375557
27701	44939	1	applied	\N	\N	\N	\N	208424	208424	375558
27701	44940	2	applied	\N	\N	\N	\N	208425	208425	375559
27701	44941	3	applied	\N	\N	\N	\N	208426	208426	375560
27701	44942	4	applied	\N	\N	\N	\N	208427	208427	375561
27701	44943	5	applied	\N	\N	\N	\N	208428	208428	375562
27705	44952	0	applied	\N	\N	\N	\N	208453	208453	375587
27705	44953	1	applied	\N	\N	\N	\N	208454	208454	375588
27705	44954	2	applied	\N	\N	\N	\N	208455	208455	375589
27705	44955	3	applied	\N	\N	\N	\N	208456	208456	375590
27705	44956	4	applied	\N	\N	\N	\N	208457	208457	375591
27705	44957	5	applied	\N	\N	\N	\N	208458	208458	375592
27705	44959	7	applied	\N	\N	\N	\N	208460	208460	375594
27705	44960	8	applied	\N	\N	\N	\N	208461	208461	375595
27705	44961	9	applied	\N	\N	\N	\N	208462	208462	375596
27707	44962	0	applied	\N	\N	\N	\N	208473	208473	375607
27707	44963	1	applied	\N	\N	\N	\N	208474	208474	375608
27707	44964	2	applied	\N	\N	\N	\N	208475	208475	375609
27707	44965	3	applied	\N	\N	\N	\N	208476	208476	375610
27708	44966	0	applied	\N	\N	\N	\N	208477	208477	375611
27708	44967	1	applied	\N	\N	\N	\N	208478	208478	375612
27708	44968	2	applied	\N	\N	\N	\N	208479	208479	375613
27708	44969	3	applied	\N	\N	\N	\N	208480	208480	375614
27708	44970	4	applied	\N	\N	\N	\N	208481	208481	375615
27708	44971	5	applied	\N	\N	\N	\N	208482	208482	375616
27710	44972	0	applied	\N	\N	\N	\N	208485	208485	375619
27710	44973	1	applied	\N	\N	\N	\N	208486	208486	375620
27712	44974	0	applied	\N	\N	\N	\N	208489	208489	375623
27717	44981	1	applied	\N	\N	\N	\N	208504	208504	375638
27719	44980	0	applied	\N	\N	\N	\N	208507	208507	375641
27719	44981	1	applied	\N	\N	\N	\N	208508	208508	375642
27721	44982	0	applied	\N	\N	\N	\N	208634	208634	375766
27721	44983	1	applied	\N	\N	\N	\N	208635	208635	375767
27727	44987	0	applied	\N	\N	\N	\N	208647	208647	375779
27727	44988	1	applied	\N	\N	\N	\N	208648	208648	375780
27727	44989	2	applied	\N	\N	\N	\N	208649	208649	375781
27727	44990	3	applied	\N	\N	\N	\N	208650	208650	375782
27728	44987	0	applied	\N	\N	\N	\N	208651	208651	375783
27728	44988	1	applied	\N	\N	\N	\N	208652	208652	375784
27728	44989	2	applied	\N	\N	\N	\N	208653	208653	375785
27728	44990	3	applied	\N	\N	\N	\N	208654	208654	375786
27730	44991	0	applied	\N	\N	\N	\N	208659	208659	375791
27730	44992	1	applied	\N	\N	\N	\N	208660	208660	375792
27736	45003	0	applied	\N	\N	\N	\N	208675	208675	375807
27740	45005	0	applied	\N	\N	\N	\N	208683	208683	375815
27740	45006	1	applied	\N	\N	\N	\N	208684	208684	375816
27742	45021	0	applied	\N	\N	\N	\N	208699	208699	375831
27742	45022	1	applied	\N	\N	\N	\N	208700	208700	375832
27747	45023	0	applied	\N	\N	\N	\N	208711	208711	375843
27747	45024	1	applied	\N	\N	\N	\N	208712	208712	375844
27747	45025	2	applied	\N	\N	\N	\N	208713	208713	375845
27747	45026	3	applied	\N	\N	\N	\N	208714	208714	375846
27749	45029	0	applied	\N	\N	\N	\N	208717	208717	375849
27749	45030	1	applied	\N	\N	\N	\N	208718	208718	375850
27753	45031	0	applied	\N	\N	\N	\N	208725	208725	375857
27753	45032	1	applied	\N	\N	\N	\N	208726	208726	375858
27758	45035	0	applied	\N	\N	\N	\N	208734	208734	375866
27758	45036	1	applied	\N	\N	\N	\N	208735	208735	375867
27694	44934	0	applied	\N	\N	\N	\N	208304	208304	375440
27694	44935	1	applied	\N	\N	\N	\N	208305	208305	375441
27706	44957	5	applied	\N	\N	\N	\N	208468	208468	375602
27706	44958	6	applied	\N	\N	\N	\N	208469	208469	375603
27706	44959	7	applied	\N	\N	\N	\N	208470	208470	375604
27706	44960	8	applied	\N	\N	\N	\N	208471	208471	375605
27706	44961	9	applied	\N	\N	\N	\N	208472	208472	375606
27712	44975	1	applied	\N	\N	\N	\N	208490	208490	375624
27712	44976	2	applied	\N	\N	\N	\N	208491	208491	375625
27712	44977	3	applied	\N	\N	\N	\N	208492	208492	375626
27713	44974	0	applied	\N	\N	\N	\N	208493	208493	375627
27713	44975	1	applied	\N	\N	\N	\N	208494	208494	375628
27713	44976	2	applied	\N	\N	\N	\N	208495	208495	375629
27713	44977	3	applied	\N	\N	\N	\N	208496	208496	375630
27714	44978	0	applied	\N	\N	\N	\N	208497	208497	375631
27714	44979	1	applied	\N	\N	\N	\N	208498	208498	375632
27715	44978	0	applied	\N	\N	\N	\N	208499	208499	375633
27715	44979	1	applied	\N	\N	\N	\N	208500	208500	375634
27720	44758	73	applied	\N	\N	\N	\N	208581	208581	375713
27720	44767	74	applied	\N	\N	\N	\N	208582	208582	375714
27720	44770	75	applied	\N	\N	\N	\N	208583	208583	375715
27720	44773	76	applied	\N	\N	\N	\N	208584	208584	375716
27720	44774	77	applied	\N	\N	\N	\N	208585	208585	375717
27720	44775	78	applied	\N	\N	\N	\N	208586	208586	375718
27720	44776	79	applied	\N	\N	\N	\N	208587	208587	375719
27720	44785	80	applied	\N	\N	\N	\N	208588	208588	375720
27720	44786	81	applied	\N	\N	\N	\N	208589	208589	375721
27720	44787	82	applied	\N	\N	\N	\N	208590	208590	375722
27720	44794	83	applied	\N	\N	\N	\N	208591	208591	375723
27720	44797	84	applied	\N	\N	\N	\N	208592	208592	375724
27720	44800	85	applied	\N	\N	\N	\N	208593	208593	375725
27720	44803	86	applied	\N	\N	\N	\N	208594	208594	375726
27720	44804	87	applied	\N	\N	\N	\N	208595	208595	375727
27720	44809	88	applied	\N	\N	\N	\N	208596	208596	375728
27720	44814	90	applied	\N	\N	\N	\N	208598	208598	375730
27720	44819	91	applied	\N	\N	\N	\N	208599	208599	375731
27720	44822	92	applied	\N	\N	\N	\N	208600	208600	375732
27720	44825	93	applied	\N	\N	\N	\N	208601	208601	375733
27720	44828	94	applied	\N	\N	\N	\N	208602	208602	375734
27720	44861	95	applied	\N	\N	\N	\N	208603	208603	375735
27720	44829	96	applied	\N	\N	\N	\N	208604	208604	375736
27720	44830	97	applied	\N	\N	\N	\N	208605	208605	375737
27720	44831	98	applied	\N	\N	\N	\N	208606	208606	375738
27720	44840	99	applied	\N	\N	\N	\N	208607	208607	375739
27720	44844	100	applied	\N	\N	\N	\N	208608	208608	375740
27720	44845	101	applied	\N	\N	\N	\N	208609	208609	375741
27720	44850	102	applied	\N	\N	\N	\N	208610	208610	375742
27720	44851	103	applied	\N	\N	\N	\N	208611	208611	375743
27720	44858	104	applied	\N	\N	\N	\N	208612	208612	375744
27720	44859	105	applied	\N	\N	\N	\N	208613	208613	375745
27720	44869	107	applied	\N	\N	\N	\N	208615	208615	375747
27720	44872	108	applied	\N	\N	\N	\N	208616	208616	375748
27720	44875	109	applied	\N	\N	\N	\N	208617	208617	375749
27720	44878	110	applied	\N	\N	\N	\N	208618	208618	375750
27720	44881	111	applied	\N	\N	\N	\N	208619	208619	375751
27720	44884	112	applied	\N	\N	\N	\N	208620	208620	375752
27720	44885	113	applied	\N	\N	\N	\N	208621	208621	375753
27720	44892	114	applied	\N	\N	\N	\N	208622	208622	375754
27720	44895	115	applied	\N	\N	\N	\N	208623	208623	375755
27720	44898	116	applied	\N	\N	\N	\N	208624	208624	375756
27720	44901	117	applied	\N	\N	\N	\N	208625	208625	375757
27720	44904	118	applied	\N	\N	\N	\N	208626	208626	375758
27720	44907	119	applied	\N	\N	\N	\N	208627	208627	375759
27722	44982	0	applied	\N	\N	\N	\N	208636	208636	375768
27722	44983	1	applied	\N	\N	\N	\N	208637	208637	375769
27723	44982	0	applied	\N	\N	\N	\N	208638	208638	375770
27724	44984	0	applied	\N	\N	\N	\N	208640	208640	375772
27724	44985	1	applied	\N	\N	\N	\N	208641	208641	375773
27724	44986	2	applied	\N	\N	\N	\N	208642	208642	375774
27731	44991	0	applied	\N	\N	\N	\N	208661	208661	375793
27731	44992	1	applied	\N	\N	\N	\N	208662	208662	375794
27732	44993	0	applied	\N	\N	\N	\N	208663	208663	375795
27732	44994	1	applied	\N	\N	\N	\N	208664	208664	375796
27733	44993	0	applied	\N	\N	\N	\N	208665	208665	375797
27733	44994	1	applied	\N	\N	\N	\N	208666	208666	375798
27735	45001	0	applied	\N	\N	\N	\N	208673	208673	375805
27735	45002	1	applied	\N	\N	\N	\N	208674	208674	375806
27738	45003	0	applied	\N	\N	\N	\N	208679	208679	375811
27738	45004	1	applied	\N	\N	\N	\N	208680	208680	375812
27741	45007	0	applied	\N	\N	\N	\N	208685	208685	375817
27741	45008	1	applied	\N	\N	\N	\N	208686	208686	375818
27741	45009	2	applied	\N	\N	\N	\N	208687	208687	375819
27741	45011	4	applied	\N	\N	\N	\N	208689	208689	375821
27741	45012	5	applied	\N	\N	\N	\N	208690	208690	375822
27741	45013	6	applied	\N	\N	\N	\N	208691	208691	375823
27741	45014	7	applied	\N	\N	\N	\N	208692	208692	375824
27741	45015	8	applied	\N	\N	\N	\N	208693	208693	375825
27741	45016	9	applied	\N	\N	\N	\N	208694	208694	375826
27741	45017	10	applied	\N	\N	\N	\N	208695	208695	375827
27741	45018	11	applied	\N	\N	\N	\N	208696	208696	375828
27741	45019	12	applied	\N	\N	\N	\N	208697	208697	375829
27741	45020	13	applied	\N	\N	\N	\N	208698	208698	375830
27743	45021	0	applied	\N	\N	\N	\N	208701	208701	375833
27743	45022	1	applied	\N	\N	\N	\N	208702	208702	375834
27744	45021	0	applied	\N	\N	\N	\N	208703	208703	375835
27744	45022	1	applied	\N	\N	\N	\N	208704	208704	375836
27745	45021	0	applied	\N	\N	\N	\N	208705	208705	375837
27745	45022	1	applied	\N	\N	\N	\N	208706	208706	375838
27746	45024	1	applied	\N	\N	\N	\N	208708	208708	375840
27746	45025	2	applied	\N	\N	\N	\N	208709	208709	375841
27746	45026	3	applied	\N	\N	\N	\N	208710	208710	375842
27748	45027	0	applied	\N	\N	\N	\N	208715	208715	375847
27748	45028	1	applied	\N	\N	\N	\N	208716	208716	375848
27750	45029	0	applied	\N	\N	\N	\N	208719	208719	375851
27750	45030	1	applied	\N	\N	\N	\N	208720	208720	375852
27754	45031	0	applied	\N	\N	\N	\N	208727	208727	375859
27754	45032	1	applied	\N	\N	\N	\N	208728	208728	375860
27755	45032	0	applied	\N	\N	\N	\N	208729	208729	375861
27756	45033	0	applied	\N	\N	\N	\N	208730	208730	375862
27756	45034	1	applied	\N	\N	\N	\N	208731	208731	375863
27757	45035	0	applied	\N	\N	\N	\N	208732	208732	375864
27757	45036	1	applied	\N	\N	\N	\N	208733	208733	375865
27706	44954	2	applied	\N	\N	\N	\N	208465	208465	375599
27706	44955	3	applied	\N	\N	\N	\N	208466	208466	375600
27720	44922	124	applied	\N	\N	\N	\N	208632	208632	375764
27720	44923	125	applied	\N	\N	\N	\N	208633	208633	375765
27725	44987	0	applied	\N	\N	\N	\N	208643	208643	375775
27725	44988	1	applied	\N	\N	\N	\N	208644	208644	375776
27725	44989	2	applied	\N	\N	\N	\N	208645	208645	375777
27725	44990	3	applied	\N	\N	\N	\N	208646	208646	375778
27729	44987	0	applied	\N	\N	\N	\N	208655	208655	375787
27729	44988	1	applied	\N	\N	\N	\N	208656	208656	375788
27729	44989	2	applied	\N	\N	\N	\N	208657	208657	375789
27729	44990	3	applied	\N	\N	\N	\N	208658	208658	375790
27734	44995	0	applied	\N	\N	\N	\N	208667	208667	375799
27734	44996	1	applied	\N	\N	\N	\N	208668	208668	375800
27734	44997	2	applied	\N	\N	\N	\N	208669	208669	375801
27734	44998	3	applied	\N	\N	\N	\N	208670	208670	375802
27734	45000	5	applied	\N	\N	\N	\N	208672	208672	375804
27737	45003	0	applied	\N	\N	\N	\N	208677	208677	375809
27737	45004	1	applied	\N	\N	\N	\N	208678	208678	375810
27739	45005	0	applied	\N	\N	\N	\N	208681	208681	375813
27739	45006	1	applied	\N	\N	\N	\N	208682	208682	375814
27751	45029	0	applied	\N	\N	\N	\N	208721	208721	375853
27751	45030	1	applied	\N	\N	\N	\N	208722	208722	375854
27752	45029	0	applied	\N	\N	\N	\N	208723	208723	375855
27752	45030	1	applied	\N	\N	\N	\N	208724	208724	375856
27759	45037	0	applied	\N	\N	\N	\N	208736	208736	375868
27759	45038	1	applied	\N	\N	\N	\N	208737	208737	375869
27759	45039	2	applied	\N	\N	\N	\N	208738	208738	375870
27759	45040	3	applied	\N	\N	\N	\N	208739	208739	375871
27759	45041	4	applied	\N	\N	\N	\N	208740	208740	375872
27759	45042	5	applied	\N	\N	\N	\N	208741	208741	375873
27759	45043	6	applied	\N	\N	\N	\N	208742	208742	375874
27759	45045	8	applied	\N	\N	\N	\N	208744	208744	375876
27759	45046	9	applied	\N	\N	\N	\N	208745	208745	375877
27760	45037	0	applied	\N	\N	\N	\N	208746	208746	375878
27760	45038	1	applied	\N	\N	\N	\N	208747	208747	375879
27760	45039	2	applied	\N	\N	\N	\N	208748	208748	375880
27760	45040	3	applied	\N	\N	\N	\N	208749	208749	375881
27760	45041	4	applied	\N	\N	\N	\N	208750	208750	375882
27760	45042	5	applied	\N	\N	\N	\N	208751	208751	375883
27760	45043	6	applied	\N	\N	\N	\N	208752	208752	375884
27760	45044	7	applied	\N	\N	\N	\N	208753	208753	375885
27760	45045	8	applied	\N	\N	\N	\N	208754	208754	375886
27760	45046	9	applied	\N	\N	\N	\N	208755	208755	375887
27761	45047	0	applied	\N	\N	\N	\N	208756	208756	375888
27761	45048	1	applied	\N	\N	\N	\N	208757	208757	375889
27762	45049	0	applied	\N	\N	\N	\N	208758	208758	375890
27762	45050	1	applied	\N	\N	\N	\N	208759	208759	375891
27763	45050	1	applied	\N	\N	\N	\N	208761	208761	375893
27764	45051	0	applied	\N	\N	\N	\N	208762	208762	375894
27764	45052	1	applied	\N	\N	\N	\N	208763	208763	375895
27765	45053	0	applied	\N	\N	\N	\N	208764	208764	375896
27765	45054	1	applied	\N	\N	\N	\N	208765	208765	375897
27766	45055	0	applied	\N	\N	\N	\N	208766	208766	375898
27766	45056	1	applied	\N	\N	\N	\N	208767	208767	375899
27767	45055	0	applied	\N	\N	\N	\N	208768	208768	375900
27767	45056	1	applied	\N	\N	\N	\N	208769	208769	375901
27768	45055	0	applied	\N	\N	\N	\N	208770	208770	375902
27768	45056	1	applied	\N	\N	\N	\N	208771	208771	375903
27769	45055	0	applied	\N	\N	\N	\N	208772	208772	375904
27769	45056	1	applied	\N	\N	\N	\N	208773	208773	375905
27770	45057	0	applied	\N	\N	\N	\N	208774	208774	375906
27770	45058	1	applied	\N	\N	\N	\N	208775	208775	375907
27772	45059	0	applied	\N	\N	\N	\N	208776	208776	375908
27772	45061	2	applied	\N	\N	\N	\N	208778	208778	375910
27772	45062	3	applied	\N	\N	\N	\N	208779	208779	375911
27773	45063	0	applied	\N	\N	\N	\N	208780	208780	375912
27773	45064	1	applied	\N	\N	\N	\N	208781	208781	375913
27773	45065	2	applied	\N	\N	\N	\N	208782	208782	375914
27773	45066	3	applied	\N	\N	\N	\N	208783	208783	375915
27773	45067	4	applied	\N	\N	\N	\N	208784	208784	375916
27773	45068	5	applied	\N	\N	\N	\N	208785	208785	375917
27773	45069	6	applied	\N	\N	\N	\N	208786	208786	375918
27775	45070	0	applied	\N	\N	\N	\N	208789	208789	375921
27775	45071	1	applied	\N	\N	\N	\N	208790	208790	375922
27776	45072	0	applied	\N	\N	\N	\N	208791	208791	375923
27776	45073	1	applied	\N	\N	\N	\N	208792	208792	375924
27776	45074	2	applied	\N	\N	\N	\N	208793	208793	375925
27776	45075	3	applied	\N	\N	\N	\N	208794	208794	375926
27778	45076	0	applied	\N	\N	\N	\N	208797	208797	375929
27779	45076	0	applied	\N	\N	\N	\N	208799	208799	375931
27779	45077	1	applied	\N	\N	\N	\N	208800	208800	375932
27785	45093	0	applied	\N	\N	\N	\N	208824	208824	375956
27785	45094	1	applied	\N	\N	\N	\N	208825	208825	375957
27785	45095	2	applied	\N	\N	\N	\N	208826	208826	375958
27785	45096	3	applied	\N	\N	\N	\N	208827	208827	375959
27788	45099	0	applied	\N	\N	\N	\N	208835	208835	375967
27788	45100	1	applied	\N	\N	\N	\N	208836	208836	375968
27788	45101	2	applied	\N	\N	\N	\N	208837	208837	375969
27788	45102	3	applied	\N	\N	\N	\N	208838	208838	375970
27788	45103	4	applied	\N	\N	1000000000	\N	208839	208839	375971
27794	45112	0	applied	\N	\N	\N	\N	208854	208854	375986
27794	45113	1	applied	\N	\N	\N	\N	208855	208855	375987
27794	45114	2	applied	\N	\N	\N	\N	208856	208856	375988
27794	45115	3	applied	\N	\N	\N	\N	208857	208857	375989
27794	45116	4	applied	\N	\N	\N	\N	208858	208858	375990
27796	45118	0	applied	\N	\N	\N	\N	208863	208863	375995
27796	45119	1	applied	\N	\N	\N	\N	208864	208864	375996
27796	45120	2	applied	\N	\N	\N	\N	208865	208865	375997
27799	45121	0	applied	\N	\N	\N	\N	208873	208873	376005
27799	45122	1	applied	\N	\N	\N	\N	208874	208874	376006
27799	45123	2	applied	\N	\N	\N	\N	208875	208875	376007
27799	45124	3	applied	\N	\N	\N	\N	208876	208876	376008
27803	45125	0	applied	\N	\N	\N	\N	208888	208888	376020
27803	45126	1	applied	\N	\N	\N	\N	208889	208889	376021
27803	45127	2	applied	\N	\N	\N	\N	208890	208890	376022
27805	45128	0	applied	\N	\N	\N	\N	208897	208897	376029
27805	45129	1	applied	\N	\N	\N	\N	208898	208898	376030
27805	45130	2	applied	\N	\N	\N	\N	208899	208899	376031
27805	45131	3	applied	\N	\N	\N	\N	208900	208900	376032
27805	45132	4	applied	\N	\N	\N	\N	208901	208901	376033
27805	45133	5	applied	\N	\N	\N	\N	208902	208902	376034
27720	44917	123	applied	\N	\N	\N	\N	208631	208631	375763
27780	45078	0	applied	\N	\N	\N	\N	208801	208801	375933
27780	45079	1	applied	\N	\N	\N	\N	208802	208802	375934
27780	45080	2	applied	\N	\N	\N	\N	208803	208803	375935
27780	45081	4	applied	\N	\N	\N	\N	208804	208804	375936
27782	45078	0	applied	\N	\N	\N	\N	208809	208809	375941
27782	45079	1	applied	\N	\N	\N	\N	208810	208810	375942
27782	45080	2	applied	\N	\N	\N	\N	208811	208811	375943
27782	45081	4	applied	\N	\N	\N	\N	208812	208812	375944
27783	45082	0	applied	\N	\N	\N	\N	208813	208813	375945
27783	45083	1	applied	\N	\N	\N	\N	208814	208814	375946
27783	45084	2	applied	\N	\N	\N	\N	208815	208815	375947
27783	45085	3	applied	\N	\N	\N	\N	208816	208816	375948
27783	45086	4	applied	\N	\N	\N	\N	208817	208817	375949
27783	45087	5	applied	\N	\N	\N	\N	208818	208818	375950
27783	45088	6	applied	\N	\N	\N	\N	208819	208819	375951
27786	45097	0	applied	\N	\N	\N	\N	208828	208828	375960
27789	45104	0	applied	\N	\N	\N	\N	208840	208840	375972
27789	45105	1	applied	\N	\N	\N	\N	208841	208841	375973
27791	45106	0	applied	\N	\N	\N	\N	208845	208845	375977
27791	45107	1	applied	\N	\N	\N	\N	208846	208846	375978
27791	45108	2	applied	\N	\N	\N	\N	208847	208847	375979
27792	45106	0	applied	\N	\N	\N	\N	208848	208848	375980
27792	45107	1	applied	\N	\N	\N	\N	208849	208849	375981
27792	45108	2	applied	\N	\N	\N	\N	208850	208850	375982
27795	45118	0	applied	\N	\N	\N	\N	208860	208860	375992
27795	45119	1	applied	\N	\N	\N	\N	208861	208861	375993
27795	45120	2	applied	\N	\N	\N	\N	208862	208862	375994
27798	45121	0	applied	\N	\N	\N	\N	208869	208869	376001
27798	45122	1	applied	\N	\N	\N	\N	208870	208870	376002
27798	45123	2	applied	\N	\N	\N	\N	208871	208871	376003
27798	45124	3	applied	\N	\N	\N	\N	208872	208872	376004
27800	45121	0	applied	\N	\N	\N	\N	208877	208877	376009
27800	45123	2	applied	\N	\N	\N	\N	208879	208879	376011
27800	45124	3	applied	\N	\N	\N	\N	208880	208880	376012
27801	45121	0	applied	\N	\N	\N	\N	208881	208881	376013
27801	45122	1	applied	\N	\N	\N	\N	208882	208882	376014
27801	45123	2	applied	\N	\N	\N	\N	208883	208883	376015
27801	45124	3	applied	\N	\N	\N	\N	208884	208884	376016
27804	45128	0	applied	\N	\N	\N	\N	208891	208891	376023
27804	45129	1	applied	\N	\N	\N	\N	208892	208892	376024
27804	45130	2	applied	\N	\N	\N	\N	208893	208893	376025
27804	45131	3	applied	\N	\N	\N	\N	208894	208894	376026
27806	45134	0	applied	\N	\N	\N	\N	208903	208903	376035
27806	45135	1	applied	\N	\N	\N	\N	208904	208904	376036
27806	45136	2	applied	\N	\N	\N	\N	208905	208905	376037
27806	45137	3	applied	\N	\N	\N	\N	208906	208906	376038
27806	45138	4	applied	\N	\N	\N	\N	208907	208907	376039
27806	45139	5	applied	\N	\N	\N	\N	208908	208908	376040
27809	45135	1	applied	\N	\N	\N	\N	208922	208922	376054
27809	45136	2	applied	\N	\N	\N	\N	208923	208923	376055
27809	45137	3	applied	\N	\N	\N	\N	208924	208924	376056
27809	45138	4	applied	\N	\N	\N	\N	208925	208925	376057
27809	45139	5	applied	\N	\N	\N	\N	208926	208926	376058
27812	45149	0	applied	\N	\N	\N	\N	208936	208936	376068
27812	45150	1	applied	\N	\N	\N	\N	208937	208937	376069
27812	45151	2	applied	\N	\N	\N	\N	208938	208938	376070
27812	45152	3	applied	\N	\N	\N	\N	208939	208939	376071
27812	45153	4	applied	\N	\N	\N	\N	208940	208940	376072
27812	45154	5	applied	\N	\N	\N	\N	208941	208941	376073
27818	45170	0	applied	\N	\N	\N	\N	208963	208963	376095
27818	45171	1	applied	\N	\N	\N	\N	208964	208964	376096
27818	45172	2	applied	\N	\N	\N	\N	208965	208965	376097
27821	45176	0	applied	\N	\N	\N	\N	208972	208972	376104
27821	45177	1	applied	\N	\N	\N	\N	208973	208973	376105
27824	45179	0	applied	\N	\N	\N	\N	208981	208981	376113
27824	45180	1	applied	\N	\N	\N	\N	208982	208982	376114
27824	45181	2	applied	\N	\N	\N	\N	208983	208983	376115
27827	45185	0	applied	\N	\N	\N	\N	208990	208990	376122
27827	45186	1	applied	\N	\N	\N	\N	208991	208991	376123
27827	45187	2	applied	\N	\N	\N	\N	208992	208992	376124
27834	45203	0	applied	\N	\N	\N	\N	209038	209038	376170
27834	45204	1	applied	\N	\N	\N	\N	209039	209039	376171
27834	45205	2	applied	\N	\N	\N	\N	209040	209040	376172
27836	45209	0	applied	\N	\N	\N	\N	209044	209044	376176
27836	45210	1	applied	\N	\N	\N	\N	209045	209045	376177
27836	45211	2	applied	\N	\N	\N	\N	209046	209046	376178
27839	45221	0	applied	\N	\N	\N	\N	209056	209056	376188
27839	45222	1	applied	\N	\N	\N	\N	209057	209057	376189
27839	45223	2	applied	\N	\N	\N	\N	209058	209058	376190
27841	45221	0	applied	\N	\N	\N	\N	209062	209062	376194
27841	45223	2	applied	\N	\N	\N	\N	209064	209064	376196
27842	45224	0	applied	\N	\N	\N	\N	209065	209065	376197
27842	45225	1	applied	\N	\N	\N	\N	209066	209066	376198
27842	45226	2	applied	\N	\N	\N	\N	209067	209067	376199
27842	45227	3	applied	\N	\N	\N	\N	209068	209068	376200
27842	45228	4	applied	\N	\N	\N	\N	209069	209069	376201
27842	45229	5	applied	\N	\N	\N	\N	209070	209070	376202
27842	45230	6	applied	\N	\N	\N	\N	209071	209071	376203
27842	45231	7	applied	\N	\N	\N	\N	209072	209072	376204
27842	45232	8	applied	\N	\N	\N	\N	209073	209073	376205
27845	45239	0	applied	\N	\N	\N	\N	209089	209089	376221
27845	45240	1	applied	\N	\N	\N	\N	209090	209090	376222
27845	45241	2	applied	\N	\N	\N	\N	209091	209091	376223
27847	45242	0	applied	\N	\N	\N	\N	209095	209095	376227
27847	45243	1	applied	\N	\N	\N	\N	209096	209096	376228
27847	45244	2	applied	\N	\N	\N	\N	209097	209097	376229
27848	45243	1	applied	\N	\N	\N	\N	209099	209099	376231
27848	45244	2	applied	\N	\N	\N	\N	209100	209100	376232
27850	45245	0	applied	\N	\N	\N	\N	209104	209104	376236
27850	45246	1	applied	\N	\N	\N	\N	209105	209105	376237
27850	45247	2	applied	\N	\N	\N	\N	209106	209106	376238
27851	45245	0	applied	\N	\N	\N	\N	209107	209107	376239
27851	45246	1	applied	\N	\N	\N	\N	209108	209108	376240
27851	45247	2	applied	\N	\N	\N	\N	209109	209109	376241
27854	45251	0	applied	\N	\N	\N	\N	209116	209116	376248
27854	45252	2	applied	\N	\N	\N	\N	209117	209117	376249
27854	45253	3	applied	\N	\N	\N	\N	209118	209118	376250
27857	45260	0	applied	\N	\N	\N	\N	209131	209131	376263
27857	45261	1	applied	\N	\N	\N	\N	209132	209132	376264
27857	45262	2	applied	\N	\N	\N	\N	209133	209133	376265
27774	45071	1	applied	\N	\N	\N	\N	208788	208788	375920
27777	45076	0	applied	\N	\N	\N	\N	208795	208795	375927
27784	45089	0	applied	\N	\N	\N	\N	208820	208820	375952
27784	45090	1	applied	\N	\N	\N	\N	208821	208821	375953
27784	45091	2	applied	\N	\N	\N	\N	208822	208822	375954
27784	45092	3	applied	\N	\N	\N	\N	208823	208823	375955
27787	45099	0	applied	\N	\N	\N	\N	208830	208830	375962
27787	45100	1	applied	\N	\N	\N	\N	208831	208831	375963
27787	45101	2	applied	\N	\N	\N	\N	208832	208832	375964
27787	45102	3	applied	\N	\N	\N	\N	208833	208833	375965
27787	45103	4	applied	\N	\N	1000000000	\N	208834	208834	375966
27790	45106	0	applied	\N	\N	\N	\N	208842	208842	375974
27790	45107	1	applied	\N	\N	\N	\N	208843	208843	375975
27790	45108	2	applied	\N	\N	\N	\N	208844	208844	375976
27793	45109	0	applied	\N	\N	\N	\N	208851	208851	375983
27793	45110	1	applied	\N	\N	\N	\N	208852	208852	375984
27797	45118	0	applied	\N	\N	\N	\N	208866	208866	375998
27797	45119	1	applied	\N	\N	\N	\N	208867	208867	375999
27797	45120	2	applied	\N	\N	\N	\N	208868	208868	376000
27802	45125	0	applied	\N	\N	\N	\N	208885	208885	376017
27802	45126	1	applied	\N	\N	\N	\N	208886	208886	376018
27802	45127	2	applied	\N	\N	\N	\N	208887	208887	376019
27804	45132	4	applied	\N	\N	\N	\N	208895	208895	376027
27804	45133	5	applied	\N	\N	\N	\N	208896	208896	376028
27807	45134	0	applied	\N	\N	\N	\N	208909	208909	376041
27807	45135	1	applied	\N	\N	\N	\N	208910	208910	376042
27807	45136	2	applied	\N	\N	\N	\N	208911	208911	376043
27807	45137	3	applied	\N	\N	\N	\N	208912	208912	376044
27807	45138	4	applied	\N	\N	\N	\N	208913	208913	376045
27807	45139	5	applied	\N	\N	\N	\N	208914	208914	376046
27808	45134	0	applied	\N	\N	\N	\N	208915	208915	376047
27808	45135	1	applied	\N	\N	\N	\N	208916	208916	376048
27808	45137	3	applied	\N	\N	\N	\N	208918	208918	376050
27808	45138	4	applied	\N	\N	\N	\N	208919	208919	376051
27808	45139	5	applied	\N	\N	\N	\N	208920	208920	376052
27810	45140	0	applied	\N	\N	\N	\N	208927	208927	376059
27810	45141	1	applied	\N	\N	\N	\N	208928	208928	376060
27810	45142	2	applied	\N	\N	\N	\N	208929	208929	376061
27810	45143	3	applied	\N	\N	\N	\N	208930	208930	376062
27810	45144	4	applied	\N	\N	\N	\N	208931	208931	376063
27810	45145	5	applied	\N	\N	\N	\N	208932	208932	376064
27811	45146	0	applied	\N	\N	\N	\N	208933	208933	376065
27811	45147	1	applied	\N	\N	\N	\N	208934	208934	376066
27811	45148	2	applied	\N	\N	\N	\N	208935	208935	376067
27813	45155	0	applied	\N	\N	\N	\N	208942	208942	376074
27813	45156	1	applied	\N	\N	\N	\N	208943	208943	376075
27813	45157	2	applied	\N	\N	\N	\N	208944	208944	376076
27814	45158	0	applied	\N	\N	\N	\N	208945	208945	376077
27814	45160	2	applied	\N	\N	\N	\N	208947	208947	376079
27814	45161	3	applied	\N	\N	\N	\N	208948	208948	376080
27814	45162	4	applied	\N	\N	\N	\N	208949	208949	376081
27814	45163	5	applied	\N	\N	\N	\N	208950	208950	376082
27815	45158	0	applied	\N	\N	\N	\N	208951	208951	376083
27815	45159	1	applied	\N	\N	\N	\N	208952	208952	376084
27815	45160	2	applied	\N	\N	\N	\N	208953	208953	376085
27815	45161	3	applied	\N	\N	\N	\N	208954	208954	376086
27815	45162	4	applied	\N	\N	\N	\N	208955	208955	376087
27815	45163	5	applied	\N	\N	\N	\N	208956	208956	376088
27816	45164	0	applied	\N	\N	\N	\N	208957	208957	376089
27816	45165	1	applied	\N	\N	\N	\N	208958	208958	376090
27816	45166	2	applied	\N	\N	\N	\N	208959	208959	376091
27817	45167	0	applied	\N	\N	\N	\N	208960	208960	376092
27817	45168	1	applied	\N	\N	\N	\N	208961	208961	376093
27817	45169	2	applied	\N	\N	\N	\N	208962	208962	376094
27819	45171	1	applied	\N	\N	\N	\N	208967	208967	376099
27819	45172	2	applied	\N	\N	\N	\N	208968	208968	376100
27820	45173	0	applied	\N	\N	\N	\N	208969	208969	376101
27820	45174	1	applied	\N	\N	\N	\N	208970	208970	376102
27820	45175	2	applied	\N	\N	\N	\N	208971	208971	376103
27822	45176	0	applied	\N	\N	\N	\N	208975	208975	376107
27822	45177	1	applied	\N	\N	\N	\N	208976	208976	376108
27822	45178	2	applied	\N	\N	\N	\N	208977	208977	376109
27823	45179	0	applied	\N	\N	\N	\N	208978	208978	376110
27823	45180	1	applied	\N	\N	\N	\N	208979	208979	376111
27825	45182	0	applied	\N	\N	\N	\N	208984	208984	376116
27825	45183	1	applied	\N	\N	\N	\N	208985	208985	376117
27825	45184	2	applied	\N	\N	\N	\N	208986	208986	376118
27828	45188	0	applied	\N	\N	\N	\N	208993	208993	376125
27828	45189	1	applied	\N	\N	\N	\N	208994	208994	376126
27828	45190	2	applied	\N	\N	\N	\N	208995	208995	376127
27830	45192	1	applied	\N	\N	\N	\N	209009	209009	376141
27830	45193	2	applied	\N	\N	\N	\N	209010	209010	376142
27830	45194	3	applied	\N	\N	\N	\N	209011	209011	376143
27830	45195	4	applied	\N	\N	\N	\N	209012	209012	376144
27830	45196	5	applied	\N	\N	\N	\N	209013	209013	376145
27830	45197	6	applied	\N	\N	\N	\N	209014	209014	376146
27830	45198	7	applied	\N	\N	\N	\N	209015	209015	376147
27830	45199	8	applied	\N	\N	\N	\N	209016	209016	376148
27830	45200	9	applied	\N	\N	\N	\N	209017	209017	376149
27830	45201	10	applied	\N	\N	\N	\N	209018	209018	376150
27830	45202	11	applied	\N	\N	\N	\N	209019	209019	376151
27833	45203	0	applied	\N	\N	\N	\N	209035	209035	376167
27833	45204	1	applied	\N	\N	\N	\N	209036	209036	376168
27833	45205	2	applied	\N	\N	\N	\N	209037	209037	376169
27837	45212	0	applied	\N	\N	\N	\N	209047	209047	376179
27837	45213	1	applied	\N	\N	\N	\N	209048	209048	376180
27843	45224	0	applied	\N	\N	\N	\N	209074	209074	376206
27843	45225	1	applied	\N	\N	\N	\N	209075	209075	376207
27843	45226	2	applied	\N	\N	\N	\N	209076	209076	376208
27843	45227	3	applied	\N	\N	\N	\N	209077	209077	376209
27843	45228	4	applied	\N	\N	\N	\N	209078	209078	376210
27843	45229	5	applied	\N	\N	\N	\N	209079	209079	376211
27843	45230	6	applied	\N	\N	\N	\N	209080	209080	376212
27843	45231	7	applied	\N	\N	\N	\N	209081	209081	376213
27843	45232	8	applied	\N	\N	\N	\N	209082	209082	376214
27846	45242	0	applied	\N	\N	\N	\N	209092	209092	376224
27846	45243	1	applied	\N	\N	\N	\N	209093	209093	376225
27846	45244	2	applied	\N	\N	\N	\N	209094	209094	376226
27849	45245	0	applied	\N	\N	\N	\N	209101	209101	376233
27849	45246	1	applied	\N	\N	\N	\N	209102	209102	376234
27849	45247	2	applied	\N	\N	\N	\N	209103	209103	376235
27852	45248	0	applied	\N	\N	\N	\N	209110	209110	376242
27781	45081	4	applied	\N	\N	\N	\N	208808	208808	375940
27829	45191	0	applied	\N	\N	\N	\N	208996	208996	376128
27829	45192	1	applied	\N	\N	\N	\N	208997	208997	376129
27829	45193	2	applied	\N	\N	\N	\N	208998	208998	376130
27829	45194	3	applied	\N	\N	\N	\N	208999	208999	376131
27829	45195	4	applied	\N	\N	\N	\N	209000	209000	376132
27829	45196	5	applied	\N	\N	\N	\N	209001	209001	376133
27829	45197	6	applied	\N	\N	\N	\N	209002	209002	376134
27829	45198	7	applied	\N	\N	\N	\N	209003	209003	376135
27829	45199	8	applied	\N	\N	\N	\N	209004	209004	376136
27829	45200	9	applied	\N	\N	\N	\N	209005	209005	376137
27829	45201	10	applied	\N	\N	\N	\N	209006	209006	376138
27829	45202	11	applied	\N	\N	\N	\N	209007	209007	376139
27831	45191	0	applied	\N	\N	\N	\N	209020	209020	376152
27831	45192	1	applied	\N	\N	\N	\N	209021	209021	376153
27831	45194	3	applied	\N	\N	\N	\N	209023	209023	376155
27831	45195	4	applied	\N	\N	\N	\N	209024	209024	376156
27831	45196	5	applied	\N	\N	\N	\N	209025	209025	376157
27831	45197	6	applied	\N	\N	\N	\N	209026	209026	376158
27831	45198	7	applied	\N	\N	\N	\N	209027	209027	376159
27831	45199	8	applied	\N	\N	\N	\N	209028	209028	376160
27831	45200	9	applied	\N	\N	\N	\N	209029	209029	376161
27831	45201	10	applied	\N	\N	\N	\N	209030	209030	376162
27831	45202	11	applied	\N	\N	\N	\N	209031	209031	376163
27832	45203	0	applied	\N	\N	\N	\N	209032	209032	376164
27832	45204	1	applied	\N	\N	\N	\N	209033	209033	376165
27832	45205	2	applied	\N	\N	\N	\N	209034	209034	376166
27835	45206	0	applied	\N	\N	\N	\N	209041	209041	376173
27835	45207	1	applied	\N	\N	\N	\N	209042	209042	376174
27835	45208	2	applied	\N	\N	\N	\N	209043	209043	376175
27838	45215	0	applied	\N	\N	\N	\N	209050	209050	376182
27838	45217	2	applied	\N	\N	\N	\N	209052	209052	376184
27838	45218	3	applied	\N	\N	\N	\N	209053	209053	376185
27838	45219	4	applied	\N	\N	\N	\N	209054	209054	376186
27838	45220	5	applied	\N	\N	\N	\N	209055	209055	376187
27840	45221	0	applied	\N	\N	\N	\N	209059	209059	376191
27840	45222	1	applied	\N	\N	\N	\N	209060	209060	376192
27840	45223	2	applied	\N	\N	\N	\N	209061	209061	376193
27844	45233	0	applied	\N	\N	\N	\N	209083	209083	376215
27844	45234	1	applied	\N	\N	\N	\N	209084	209084	376216
27844	45235	2	applied	\N	\N	\N	\N	209085	209085	376217
27844	45236	3	applied	\N	\N	\N	\N	209086	209086	376218
27844	45237	4	applied	\N	\N	\N	\N	209087	209087	376219
27844	45238	5	applied	\N	\N	\N	\N	209088	209088	376220
27852	45249	1	applied	\N	\N	\N	\N	209111	209111	376243
27852	45250	2	applied	\N	\N	\N	\N	209112	209112	376244
27853	45251	0	applied	\N	\N	\N	\N	209113	209113	376245
27853	45253	3	applied	\N	\N	\N	\N	209115	209115	376247
27855	45254	0	applied	\N	\N	\N	\N	209119	209119	376251
27855	45255	1	applied	\N	\N	\N	\N	209120	209120	376252
27855	45256	2	applied	\N	\N	\N	\N	209121	209121	376253
27855	45257	3	applied	\N	\N	\N	\N	209122	209122	376254
27855	45258	4	applied	\N	\N	\N	\N	209123	209123	376255
27855	45259	5	applied	\N	\N	\N	\N	209124	209124	376256
27856	45254	0	applied	\N	\N	\N	\N	209125	209125	376257
27856	45255	1	applied	\N	\N	\N	\N	209126	209126	376258
27856	45256	2	applied	\N	\N	\N	\N	209127	209127	376259
27856	45257	3	applied	\N	\N	\N	\N	209128	209128	376260
27856	45258	4	applied	\N	\N	\N	\N	209129	209129	376261
27856	45259	5	applied	\N	\N	\N	\N	209130	209130	376262
27858	45260	0	applied	\N	\N	\N	\N	209134	209134	376266
27858	45261	1	applied	\N	\N	\N	\N	209135	209135	376267
27858	45262	2	applied	\N	\N	\N	\N	209136	209136	376268
27859	45264	1	applied	\N	\N	\N	\N	209138	209138	376270
27859	45265	2	applied	\N	\N	\N	\N	209139	209139	376271
27859	45266	3	applied	\N	\N	\N	\N	209140	209140	376272
27859	45267	4	applied	\N	\N	\N	\N	209141	209141	376273
27859	45268	5	applied	\N	\N	\N	\N	209142	209142	376274
27861	45272	0	applied	\N	\N	\N	\N	209146	209146	376278
27861	45273	1	applied	\N	\N	\N	\N	209147	209147	376279
27861	45274	2	applied	\N	\N	\N	\N	209148	209148	376280
27864	45278	0	applied	\N	\N	\N	\N	209155	209155	376287
27864	45279	1	applied	\N	\N	\N	\N	209156	209156	376288
27864	45280	2	applied	\N	\N	\N	\N	209157	209157	376289
27865	45281	0	applied	\N	\N	\N	\N	209158	209158	376290
27865	45282	1	applied	\N	\N	\N	\N	209159	209159	376291
27865	45283	2	applied	\N	\N	1000000000	\N	209160	209160	376292
27865	45284	3	applied	\N	\N	\N	\N	209161	209161	376293
27867	45292	0	applied	\N	\N	\N	\N	209169	209169	376300
27867	45294	2	applied	\N	\N	\N	\N	209171	209171	376302
27868	45295	0	applied	\N	\N	\N	\N	209172	209172	376303
27868	45296	1	applied	\N	\N	\N	\N	209173	209173	376304
27868	45297	2	applied	\N	\N	\N	\N	209174	209174	376305
27870	45295	0	applied	\N	\N	\N	\N	209178	209178	376309
27870	45296	1	applied	\N	\N	\N	\N	209179	209179	376310
27870	45297	2	applied	\N	\N	\N	\N	209180	209180	376311
27876	45304	0	applied	\N	\N	\N	\N	209318	209318	376448
27876	45305	1	applied	\N	\N	\N	\N	209319	209319	376449
27876	45306	2	applied	\N	\N	\N	\N	209320	209320	376450
27878	45307	0	applied	\N	\N	\N	\N	209324	209324	376454
27878	45308	1	applied	\N	\N	\N	\N	209325	209325	376455
27878	45309	2	applied	\N	\N	\N	\N	209326	209326	376456
27882	44856	0	applied	\N	\N	\N	\N	209346	209346	376476
27882	44857	1	applied	\N	\N	\N	\N	209347	209347	376477
27882	44915	2	applied	\N	\N	\N	\N	209348	209348	376478
27882	44721	4	applied	\N	\N	\N	\N	209350	209350	376480
27882	45082	5	applied	\N	\N	\N	\N	209351	209351	376481
27882	44722	6	applied	\N	\N	\N	\N	209352	209352	376482
27882	44955	7	applied	\N	\N	\N	\N	209353	209353	376483
27882	44699	8	applied	\N	\N	\N	\N	209354	209354	376484
27882	44957	9	applied	\N	\N	\N	\N	209355	209355	376485
27882	44860	10	applied	\N	\N	\N	\N	209356	209356	376486
27882	44958	11	applied	\N	\N	\N	\N	209357	209357	376487
27882	44723	12	applied	\N	\N	\N	\N	209358	209358	376488
27882	44724	13	applied	\N	\N	\N	\N	209359	209359	376489
27882	44725	14	applied	\N	\N	\N	\N	209360	209360	376490
27882	44726	15	applied	\N	\N	\N	\N	209361	209361	209361
27882	44744	16	applied	\N	\N	\N	\N	209362	209362	376491
27882	44745	17	applied	\N	\N	\N	\N	209363	209363	376492
27882	44746	18	applied	\N	\N	\N	\N	209364	209364	376493
27882	44747	19	applied	\N	\N	\N	\N	209365	209365	376494
27826	45184	2	applied	\N	\N	\N	\N	208989	208989	376121
27862	45272	0	applied	\N	\N	\N	\N	209149	209149	376281
27862	45273	1	applied	\N	\N	\N	\N	209150	209150	376282
27862	45274	2	applied	\N	\N	\N	\N	209151	209151	376283
27863	45275	0	applied	\N	\N	\N	\N	209152	209152	376284
27863	45276	1	applied	\N	\N	\N	\N	209153	209153	376285
27863	45277	2	applied	\N	\N	\N	\N	209154	209154	376286
27866	45285	0	applied	\N	\N	\N	\N	209162	209162	376294
27866	45286	1	applied	\N	\N	\N	\N	209163	209163	376295
27866	45288	3	applied	\N	\N	\N	\N	209165	209165	376296
27866	45289	4	applied	\N	\N	\N	\N	209166	209166	376297
27866	45290	5	applied	\N	\N	\N	\N	209167	209167	376298
27866	45291	6	applied	\N	\N	\N	\N	209168	209168	376299
27869	45295	0	applied	\N	\N	\N	\N	209175	209175	376306
27869	45296	1	applied	\N	\N	\N	\N	209176	209176	376307
27869	45297	2	applied	\N	\N	\N	\N	209177	209177	376308
27872	45298	0	applied	\N	\N	\N	\N	209306	209306	376436
27872	45299	1	applied	\N	\N	\N	\N	209307	209307	376437
27872	45300	2	applied	\N	\N	\N	\N	209308	209308	376438
27875	45301	0	applied	\N	\N	\N	\N	209315	209315	376445
27875	45302	1	applied	\N	\N	\N	\N	209316	209316	376446
27875	45303	2	applied	\N	\N	\N	\N	209317	209317	376447
27879	45307	0	applied	\N	\N	\N	\N	209327	209327	376457
27879	45308	1	applied	\N	\N	\N	\N	209328	209328	376458
27879	45309	2	applied	\N	\N	\N	\N	209329	209329	376459
27881	45310	0	applied	\N	\N	\N	\N	209338	209338	376468
27881	45311	1	applied	\N	\N	\N	\N	209339	209339	376469
27881	45312	2	applied	\N	\N	\N	\N	209340	209340	376470
27881	45313	3	applied	\N	\N	\N	\N	209341	209341	376471
27881	45314	4	applied	\N	\N	\N	\N	209342	209342	376472
27881	45315	5	applied	\N	\N	\N	\N	209343	209343	376473
27881	45316	6	applied	\N	\N	\N	\N	209344	209344	376474
27881	45317	7	applied	\N	\N	\N	\N	209345	209345	376475
27882	44748	20	applied	\N	\N	\N	\N	209366	209366	376495
27882	44749	21	applied	\N	\N	\N	\N	209367	209367	209367
27882	44861	22	applied	\N	\N	\N	\N	209368	209368	376496
27882	44841	23	applied	\N	\N	\N	\N	209369	209369	376497
27882	44886	25	applied	\N	\N	\N	\N	209371	209371	376498
27882	44811	26	applied	\N	\N	\N	\N	209372	209372	376499
27882	45283	27	applied	\N	\N	1000000000	\N	209373	209373	376500
27882	45069	28	applied	\N	\N	\N	\N	209374	209374	376501
27882	45103	29	applied	\N	\N	1000000000	\N	209375	209375	376502
27882	44889	30	applied	\N	\N	\N	\N	209376	209376	376503
27883	45318	0	applied	\N	\N	\N	\N	209377	209377	376504
27883	45319	1	applied	\N	\N	\N	\N	209378	209378	376505
27883	45320	2	applied	\N	\N	\N	\N	209379	209379	376506
27885	45330	0	applied	\N	\N	\N	\N	209389	209389	376516
27885	45331	1	applied	\N	\N	\N	\N	209390	209390	376517
27885	45332	2	applied	\N	\N	\N	\N	209391	209391	376518
27886	45333	0	applied	\N	\N	\N	\N	209392	209392	376519
27886	45334	1	applied	\N	\N	\N	\N	209393	209393	376520
27886	45335	2	applied	\N	\N	\N	\N	209394	209394	376521
27886	45336	3	applied	\N	\N	\N	\N	209395	209395	376522
27886	45337	4	applied	\N	\N	\N	\N	209396	209396	376523
27886	45338	5	applied	\N	\N	\N	\N	209397	209397	376524
27886	45339	7	applied	\N	\N	\N	\N	209398	209398	376525
27886	45340	8	applied	\N	\N	\N	\N	209399	209399	376526
27886	45341	9	applied	\N	\N	\N	\N	209400	209400	376527
27888	45342	0	applied	\N	\N	\N	\N	209404	209404	376531
27888	45343	1	applied	\N	\N	\N	\N	209405	209405	376532
27888	45344	2	applied	\N	\N	\N	\N	209406	209406	376533
27889	45342	0	applied	\N	\N	\N	\N	209407	209407	376534
27889	45343	1	applied	\N	\N	\N	\N	209408	209408	376535
27891	45348	0	applied	\N	\N	\N	\N	209413	209413	376540
27891	45349	1	applied	\N	\N	\N	\N	209414	209414	376541
27891	45350	2	applied	\N	\N	\N	\N	209415	209415	376542
27892	45351	0	applied	\N	\N	\N	\N	209416	209416	376543
27892	45352	1	applied	\N	\N	\N	\N	209417	209417	376544
27892	45353	2	applied	\N	\N	\N	\N	209418	209418	376545
27893	45351	0	applied	\N	\N	\N	\N	209419	209419	376546
27893	45352	1	applied	\N	\N	\N	\N	209420	209420	376547
27893	45353	2	applied	\N	\N	\N	\N	209421	209421	376548
27894	45351	0	applied	\N	\N	\N	\N	209422	209422	376549
27894	45352	1	applied	\N	\N	\N	\N	209423	209423	376550
27894	45353	2	applied	\N	\N	\N	\N	209424	209424	376551
27895	45354	0	applied	\N	\N	\N	\N	209425	209425	376552
27895	45355	1	applied	\N	\N	\N	\N	209426	209426	376553
27895	45356	2	applied	\N	\N	\N	\N	209427	209427	376554
27895	45357	3	applied	\N	\N	\N	\N	209428	209428	376555
27895	45359	5	applied	\N	\N	\N	\N	209430	209430	376557
27895	45360	6	applied	\N	\N	\N	\N	209431	209431	376558
27898	45361	0	applied	\N	\N	\N	\N	209446	209446	376573
27898	45362	1	applied	\N	\N	\N	\N	209447	209447	376574
27898	45363	2	applied	\N	\N	\N	\N	209448	209448	376575
27901	45367	0	applied	\N	\N	\N	\N	209455	209455	376582
27901	45368	1	applied	\N	\N	\N	\N	209456	209456	376583
27901	45369	2	applied	\N	\N	\N	\N	209457	209457	376584
27901	45370	3	applied	\N	\N	\N	\N	209458	209458	376585
27901	45371	4	applied	\N	\N	\N	\N	209459	209459	376586
27901	45372	5	applied	\N	\N	\N	\N	209460	209460	376587
27904	45379	0	applied	\N	\N	\N	\N	209467	209467	376594
27904	45380	1	applied	\N	\N	\N	\N	209468	209468	376595
27904	45381	2	applied	\N	\N	\N	\N	209469	209469	376596
27907	45404	0	applied	\N	\N	\N	\N	209492	209492	376619
27907	45405	1	applied	\N	\N	\N	\N	209493	209493	376620
27907	45407	3	applied	\N	\N	\N	\N	209495	209495	376622
27907	45408	4	applied	\N	\N	\N	\N	209496	209496	376623
27907	45409	5	applied	\N	\N	\N	\N	209497	209497	376624
27909	45410	0	applied	\N	\N	\N	\N	209501	209501	376628
27909	45411	1	applied	\N	\N	\N	\N	209502	209502	376629
27909	45412	2	applied	\N	\N	\N	\N	209503	209503	376630
27910	45410	0	applied	\N	\N	\N	\N	209504	209504	376631
27910	45411	1	applied	\N	\N	\N	\N	209505	209505	376632
27910	45412	2	applied	\N	\N	\N	\N	209506	209506	376633
27913	45419	0	applied	\N	\N	\N	\N	209519	209519	376646
27913	45420	1	applied	\N	\N	\N	\N	209520	209520	376647
27913	45421	2	applied	\N	\N	\N	\N	209521	209521	376648
27916	45431	0	applied	\N	\N	\N	\N	209531	209531	376658
27916	45432	1	applied	\N	\N	\N	\N	209532	209532	376659
27916	45433	2	applied	\N	\N	\N	\N	209533	209533	376660
27918	45425	0	applied	\N	\N	\N	\N	209537	209537	376664
27860	45271	2	applied	\N	\N	\N	\N	209145	209145	376277
27871	45146	4	applied	\N	\N	\N	\N	209185	209185	376316
27871	45149	5	applied	\N	\N	\N	\N	209186	209186	376317
27871	45150	6	applied	\N	\N	\N	\N	209187	209187	376318
27871	45155	7	applied	\N	\N	\N	\N	209188	209188	376319
27871	45158	8	applied	\N	\N	\N	\N	209189	209189	376320
27871	45159	9	applied	\N	\N	\N	\N	209190	209190	376321
27871	45164	10	applied	\N	\N	\N	\N	209191	209191	376322
27871	45167	11	applied	\N	\N	\N	\N	209192	209192	376323
27871	45170	12	applied	\N	\N	\N	\N	209193	209193	376324
27871	45173	13	applied	\N	\N	\N	\N	209194	209194	376325
27871	45176	14	applied	\N	\N	\N	\N	209195	209195	376326
27871	45179	15	applied	\N	\N	\N	\N	209196	209196	376327
27871	45182	16	applied	\N	\N	\N	\N	209197	209197	376328
27871	45185	17	applied	\N	\N	\N	\N	209198	209198	376329
27871	45188	18	applied	\N	\N	\N	\N	209199	209199	376330
27871	45191	19	applied	\N	\N	\N	\N	209200	209200	376331
27871	45193	21	applied	\N	\N	\N	\N	209202	209202	376333
27871	45194	22	applied	\N	\N	\N	\N	209203	209203	376334
27871	45203	23	applied	\N	\N	\N	\N	209204	209204	376335
27871	45206	24	applied	\N	\N	\N	\N	209205	209205	376336
27871	45209	25	applied	\N	\N	\N	\N	209206	209206	376337
27871	45212	26	applied	\N	\N	\N	\N	209207	209207	376338
27871	45215	27	applied	\N	\N	\N	\N	209208	209208	376339
27871	45216	28	applied	\N	\N	\N	\N	209209	209209	376340
27871	45221	29	applied	\N	\N	\N	\N	209210	209210	376341
27871	45224	30	applied	\N	\N	\N	\N	209211	209211	376342
27871	45225	31	applied	\N	\N	\N	\N	209212	209212	376343
27871	45226	32	applied	\N	\N	\N	\N	209213	209213	376344
27871	45233	33	applied	\N	\N	\N	\N	209214	209214	376345
27871	45234	34	applied	\N	\N	\N	\N	209215	209215	376346
27871	45239	35	applied	\N	\N	\N	\N	209216	209216	376347
27871	45242	36	applied	\N	\N	\N	\N	209217	209217	376348
27871	45248	38	applied	\N	\N	\N	\N	209219	209219	376350
27871	45251	39	applied	\N	\N	\N	\N	209220	209220	376351
27871	45254	40	applied	\N	\N	\N	\N	209221	209221	376352
27871	45255	41	applied	\N	\N	\N	\N	209222	209222	376353
27871	45260	42	applied	\N	\N	\N	\N	209223	209223	376354
27871	45263	43	applied	\N	\N	\N	\N	209224	209224	376355
27871	45264	44	applied	\N	\N	\N	\N	209225	209225	376356
27871	45269	45	applied	\N	\N	\N	\N	209226	209226	376357
27871	45272	47	applied	\N	\N	\N	\N	209227	209227	376358
27871	45275	48	applied	\N	\N	\N	\N	209228	209228	376359
27871	45278	49	applied	\N	\N	\N	\N	209229	209229	376360
27896	45354	0	applied	\N	\N	\N	\N	209432	209432	376559
27896	45355	1	applied	\N	\N	\N	\N	209433	209433	376560
27896	45356	2	applied	\N	\N	\N	\N	209434	209434	376561
27896	45357	3	applied	\N	\N	\N	\N	209435	209435	376562
27896	45358	4	applied	\N	\N	\N	\N	209436	209436	376563
27896	45360	6	applied	\N	\N	\N	\N	209438	209438	376565
27900	45364	0	applied	\N	\N	\N	\N	209452	209452	376579
27900	45365	1	applied	\N	\N	\N	\N	209453	209453	376580
27900	45366	2	applied	\N	\N	\N	\N	209454	209454	376581
27903	45376	0	applied	\N	\N	\N	\N	209464	209464	376591
27903	45377	1	applied	\N	\N	\N	\N	209465	209465	376592
27903	45378	2	applied	\N	\N	\N	\N	209466	209466	376593
27906	45401	0	applied	\N	\N	\N	\N	209489	209489	376616
27906	45402	1	applied	\N	\N	\N	\N	209490	209490	376617
27906	45403	2	applied	\N	\N	\N	\N	209491	209491	376618
27912	45413	0	applied	\N	\N	\N	\N	209513	209513	376640
27912	45414	1	applied	\N	\N	\N	\N	209514	209514	376641
27912	45415	2	applied	\N	\N	\N	\N	209515	209515	376642
27912	45416	3	applied	\N	\N	\N	\N	209516	209516	376643
27912	45417	4	applied	\N	\N	\N	\N	209517	209517	376644
27912	45418	5	applied	\N	\N	\N	\N	209518	209518	376645
27915	45426	1	applied	\N	\N	\N	\N	209526	209526	376653
27915	45427	2	applied	\N	\N	\N	\N	209527	209527	376654
27915	45428	4	applied	\N	\N	\N	\N	209528	209528	376655
27915	45429	5	applied	\N	\N	\N	\N	209529	209529	376656
27915	45430	6	applied	\N	\N	\N	\N	209530	209530	376657
27917	45431	0	applied	\N	\N	\N	\N	209534	209534	376661
27917	45432	1	applied	\N	\N	\N	\N	209535	209535	376662
27917	45433	2	applied	\N	\N	\N	\N	209536	209536	376663
27920	45434	0	applied	\N	\N	\N	\N	209549	209549	376676
27920	45435	1	applied	\N	\N	\N	\N	209550	209550	376677
27920	45436	2	applied	\N	\N	\N	\N	209551	209551	376678
27921	45437	0	applied	\N	\N	\N	\N	209552	209552	376679
27921	45438	1	applied	\N	\N	\N	\N	209553	209553	376680
27921	45439	2	applied	\N	\N	\N	\N	209554	209554	376681
27924	45443	0	applied	\N	\N	\N	\N	209560	209560	376687
27924	45444	1	applied	\N	\N	\N	\N	209561	209561	376688
27927	45450	0	applied	\N	\N	\N	\N	209571	209571	376698
27927	45451	1	applied	\N	\N	\N	\N	209572	209572	376699
27927	45452	2	applied	\N	\N	\N	\N	209573	209573	376700
27930	45453	0	applied	\N	\N	\N	\N	209580	209580	376707
27930	45454	1	applied	\N	\N	\N	\N	209581	209581	376708
27930	45455	2	applied	\N	\N	\N	\N	209582	209582	376709
27933	45465	0	applied	\N	\N	\N	\N	209595	209595	376722
27933	45466	1	applied	\N	\N	\N	\N	209596	209596	376723
27933	45467	2	applied	\N	\N	\N	\N	209597	209597	376724
27936	45475	0	applied	\N	\N	\N	\N	209612	209612	376739
27936	45476	1	applied	\N	\N	\N	\N	209613	209613	376740
27936	45477	2	applied	\N	\N	\N	\N	209614	209614	376741
27936	45478	3	applied	\N	\N	\N	\N	209615	209615	376742
27936	45479	4	applied	\N	\N	\N	\N	209616	209616	376743
27936	45480	5	applied	\N	\N	\N	\N	209617	209617	376744
27938	45481	0	applied	\N	\N	\N	\N	209621	209621	376748
27938	45483	2	applied	\N	\N	\N	\N	209623	209623	376750
27942	45491	0	applied	\N	\N	\N	\N	209634	209634	376761
27942	45492	1	applied	\N	\N	\N	\N	209635	209635	376762
27942	45493	2	applied	\N	\N	\N	\N	209636	209636	376763
27942	45494	3	applied	\N	\N	\N	\N	209637	209637	376764
27942	45495	4	applied	\N	\N	\N	\N	209638	209638	376765
27942	45496	5	applied	\N	\N	\N	\N	209639	209639	376766
27945	45506	0	applied	\N	\N	\N	\N	209652	209652	376779
27945	45507	1	applied	\N	\N	\N	\N	209653	209653	376780
27945	45508	2	applied	\N	\N	\N	\N	209654	209654	376781
27948	45509	0	applied	\N	\N	\N	\N	209664	209664	376791
27948	45510	1	applied	\N	\N	\N	\N	209665	209665	376792
27948	45511	2	applied	\N	\N	\N	\N	209666	209666	376793
27948	45512	3	applied	\N	\N	\N	\N	209667	209667	376794
27871	45135	1	applied	\N	\N	\N	\N	209182	209182	376313
27871	45140	2	applied	\N	\N	\N	\N	209183	209183	376314
27871	45295	54	applied	\N	\N	\N	\N	209234	209234	376365
27871	45136	56	applied	\N	\N	\N	\N	209236	209236	376366
27871	45283	57	applied	\N	\N	1000000000	\N	209237	209237	376367
27871	45137	58	applied	\N	\N	\N	\N	209238	209238	376368
27871	45138	59	applied	\N	\N	\N	\N	209239	209239	376369
27871	45142	60	applied	\N	\N	\N	\N	209240	209240	376370
27871	45143	61	applied	\N	\N	\N	\N	209241	209241	376371
27871	45147	62	applied	\N	\N	\N	\N	209242	209242	376372
27871	45151	63	applied	\N	\N	\N	\N	209243	209243	376373
27871	45152	64	applied	\N	\N	\N	\N	209244	209244	376374
27871	45156	65	applied	\N	\N	\N	\N	209245	209245	376375
27871	45161	66	applied	\N	\N	\N	\N	209246	209246	376376
27871	45162	67	applied	\N	\N	\N	\N	209247	209247	376377
27871	45166	68	applied	\N	\N	\N	\N	209248	209248	376378
27871	45168	69	applied	\N	\N	\N	\N	209249	209249	376379
27871	45171	70	applied	\N	\N	\N	\N	209250	209250	376380
27871	45174	71	applied	\N	\N	\N	\N	209251	209251	376381
27871	45178	72	applied	\N	\N	\N	\N	209252	209252	376382
27871	45181	73	applied	\N	\N	\N	\N	209253	209253	376383
27871	45183	74	applied	\N	\N	\N	\N	209254	209254	376384
27871	45187	75	applied	\N	\N	\N	\N	209255	209255	376385
27871	45189	76	applied	\N	\N	\N	\N	209256	209256	376386
27871	45195	77	applied	\N	\N	\N	\N	209257	209257	376387
27871	45139	78	applied	\N	\N	\N	\N	209258	209258	376388
27871	45144	79	applied	\N	\N	\N	\N	209259	209259	376389
27871	45145	80	applied	\N	\N	\N	\N	209260	209260	376390
27871	45148	81	applied	\N	\N	\N	\N	209261	209261	376391
27871	45153	82	applied	\N	\N	\N	\N	209262	209262	376392
27871	45154	83	applied	\N	\N	\N	\N	209263	209263	376393
27871	45157	84	applied	\N	\N	\N	\N	209264	209264	376394
27871	45163	86	applied	\N	\N	\N	\N	209266	209266	376396
27871	45165	87	applied	\N	\N	\N	\N	209267	209267	376397
27871	45169	88	applied	\N	\N	\N	\N	209268	209268	376398
27871	45172	89	applied	\N	\N	\N	\N	209269	209269	376399
27871	45175	90	applied	\N	\N	\N	\N	209270	209270	376400
27871	45177	91	applied	\N	\N	\N	\N	209271	209271	376401
27871	45180	92	applied	\N	\N	\N	\N	209272	209272	376402
27871	45184	93	applied	\N	\N	\N	\N	209273	209273	376403
27871	45186	94	applied	\N	\N	\N	\N	209274	209274	376404
27871	45190	95	applied	\N	\N	\N	\N	209275	209275	376405
27871	45196	96	applied	\N	\N	\N	\N	209276	209276	376406
27871	45197	97	applied	\N	\N	\N	\N	209277	209277	376407
27871	45198	98	applied	\N	\N	\N	\N	209278	209278	376408
27871	45199	99	applied	\N	\N	\N	\N	209279	209279	376409
27871	45205	100	applied	\N	\N	\N	\N	209280	209280	376410
27871	45207	101	applied	\N	\N	\N	\N	209281	209281	376411
27871	45214	103	applied	\N	\N	\N	\N	209283	209283	376413
27871	45218	104	applied	\N	\N	\N	\N	209284	209284	376414
27871	45219	105	applied	\N	\N	\N	\N	209285	209285	376415
27871	45223	106	applied	\N	\N	\N	\N	209286	209286	376416
27871	45227	107	applied	\N	\N	\N	\N	209287	209287	376417
27871	45231	108	applied	\N	\N	\N	\N	209288	209288	376418
27871	45232	109	applied	\N	\N	\N	\N	209289	209289	376419
27871	45236	110	applied	\N	\N	\N	\N	209290	209290	376420
27871	45237	111	applied	\N	\N	\N	\N	209291	209291	376421
27871	45240	112	applied	\N	\N	\N	\N	209292	209292	376422
27871	45243	113	applied	\N	\N	\N	\N	209293	209293	376423
27871	45246	114	applied	\N	\N	\N	\N	209294	209294	376424
27871	45249	115	applied	\N	\N	\N	\N	209295	209295	376425
27871	45253	116	applied	\N	\N	\N	\N	209296	209296	376426
27871	45258	117	applied	\N	\N	\N	\N	209297	209297	376427
27871	45259	118	applied	\N	\N	\N	\N	209298	209298	376428
27871	45266	120	applied	\N	\N	\N	\N	209300	209300	376430
27871	45267	121	applied	\N	\N	\N	\N	209301	209301	376431
27871	45271	122	applied	\N	\N	\N	\N	209302	209302	376432
27871	45274	123	applied	\N	\N	\N	\N	209303	209303	376433
27871	45277	124	applied	\N	\N	\N	\N	209304	209304	376434
27871	45280	125	applied	\N	\N	\N	\N	209305	209305	376435
27873	45298	0	applied	\N	\N	\N	\N	209309	209309	376439
27873	45299	1	applied	\N	\N	\N	\N	209310	209310	376440
27873	45300	2	applied	\N	\N	\N	\N	209311	209311	376441
27874	45301	0	applied	\N	\N	\N	\N	209312	209312	376442
27874	45302	1	applied	\N	\N	\N	\N	209313	209313	376443
27874	45303	2	applied	\N	\N	\N	\N	209314	209314	376444
27877	45307	0	applied	\N	\N	\N	\N	209321	209321	376451
27877	45308	1	applied	\N	\N	\N	\N	209322	209322	376452
27877	45309	2	applied	\N	\N	\N	\N	209323	209323	376453
27880	45310	0	applied	\N	\N	\N	\N	209330	209330	376460
27880	45312	2	applied	\N	\N	\N	\N	209332	209332	376462
27880	45313	3	applied	\N	\N	\N	\N	209333	209333	376463
27880	45314	4	applied	\N	\N	\N	\N	209334	209334	376464
27880	45315	5	applied	\N	\N	\N	\N	209335	209335	376465
27880	45316	6	applied	\N	\N	\N	\N	209336	209336	376466
27880	45317	7	applied	\N	\N	\N	\N	209337	209337	376467
27884	45321	0	applied	\N	\N	\N	\N	209380	209380	376507
27884	45322	1	applied	\N	\N	\N	\N	209381	209381	376508
27884	45323	2	applied	\N	\N	\N	\N	209382	209382	376509
27884	45324	3	applied	\N	\N	\N	\N	209383	209383	376510
27884	45325	4	applied	\N	\N	\N	\N	209384	209384	376511
27884	45326	5	applied	\N	\N	\N	\N	209385	209385	376512
27884	45327	6	applied	\N	\N	\N	\N	209386	209386	376513
27884	45328	7	applied	\N	\N	\N	\N	209387	209387	376514
27884	45329	8	applied	\N	\N	\N	\N	209388	209388	376515
27887	45342	0	applied	\N	\N	\N	\N	209401	209401	376528
27887	45344	2	applied	\N	\N	\N	\N	209403	209403	376530
27890	45345	0	applied	\N	\N	\N	\N	209410	209410	376537
27890	45346	1	applied	\N	\N	\N	\N	209411	209411	376538
27890	45347	2	applied	\N	\N	\N	\N	209412	209412	376539
27897	45354	0	applied	\N	\N	\N	\N	209439	209439	376566
27897	45355	1	applied	\N	\N	\N	\N	209440	209440	376567
27897	45356	2	applied	\N	\N	\N	\N	209441	209441	376568
27897	45357	3	applied	\N	\N	\N	\N	209442	209442	376569
27897	45358	4	applied	\N	\N	\N	\N	209443	209443	376570
27897	45359	5	applied	\N	\N	\N	\N	209444	209444	376571
27897	45360	6	applied	\N	\N	\N	\N	209445	209445	376572
27899	45361	0	applied	\N	\N	\N	\N	209449	209449	376576
27899	45362	1	applied	\N	\N	\N	\N	209450	209450	376577
27899	45363	2	applied	\N	\N	\N	\N	209451	209451	376578
27902	45373	0	applied	\N	\N	\N	\N	209461	209461	376588
27871	45285	51	applied	\N	\N	\N	\N	209231	209231	376362
27871	45292	53	applied	\N	\N	\N	\N	209233	209233	376364
27905	45383	1	applied	\N	\N	\N	\N	209471	209471	376598
27905	45384	2	applied	\N	\N	\N	\N	209472	209472	376599
27905	45385	3	applied	\N	\N	\N	\N	209473	209473	376600
27905	45386	4	applied	\N	\N	\N	\N	209474	209474	376601
27905	45387	5	applied	\N	\N	\N	\N	209475	209475	376602
27905	45388	6	applied	\N	\N	\N	\N	209476	209476	376603
27905	45389	7	applied	\N	\N	\N	\N	209477	209477	376604
27953	45524	3	applied	\N	\N	\N	\N	209691	209691	376818
27905	45391	9	applied	\N	\N	1000000000	\N	209479	209479	376606
27905	45392	10	applied	\N	\N	1000000000	\N	209480	209480	376607
27905	45393	11	applied	\N	\N	1000000000	\N	209481	209481	376608
27905	45394	12	applied	\N	\N	\N	\N	209482	209482	376609
27905	45395	13	applied	\N	\N	\N	\N	209483	209483	376610
27905	45396	14	applied	\N	\N	\N	\N	209484	209484	376611
27905	45397	15	applied	\N	\N	\N	\N	209485	209485	376612
27905	45398	16	applied	\N	\N	\N	\N	209486	209486	376613
27905	45399	17	applied	\N	\N	\N	\N	209487	209487	376614
27905	45400	18	applied	\N	\N	\N	\N	209488	209488	376615
27908	45410	0	applied	\N	\N	\N	\N	209498	209498	376625
27908	45411	1	applied	\N	\N	\N	\N	209499	209499	376626
27908	45412	2	applied	\N	\N	\N	\N	209500	209500	376627
27911	45413	0	applied	\N	\N	\N	\N	209507	209507	376634
27911	45414	1	applied	\N	\N	\N	\N	209508	209508	376635
27911	45415	2	applied	\N	\N	\N	\N	209509	209509	376636
27911	45417	4	applied	\N	\N	\N	\N	209511	209511	376638
27911	45418	5	applied	\N	\N	\N	\N	209512	209512	376639
27914	45422	0	applied	\N	\N	\N	\N	209522	209522	376649
27914	45423	1	applied	\N	\N	\N	\N	209523	209523	376650
27914	45424	2	applied	\N	\N	\N	\N	209524	209524	376651
27918	45426	1	applied	\N	\N	\N	\N	209538	209538	376665
27918	45431	2	applied	\N	\N	\N	\N	209539	209539	376666
27918	45427	4	applied	\N	\N	\N	\N	209540	209540	376667
27918	45428	5	applied	\N	\N	\N	\N	209541	209541	376668
27918	45429	6	applied	\N	\N	\N	\N	209542	209542	376669
27918	45433	7	applied	\N	\N	\N	\N	209543	209543	376670
27918	45430	8	applied	\N	\N	\N	\N	209544	209544	376671
27918	45432	9	applied	\N	\N	\N	\N	209545	209545	376672
27919	45434	0	applied	\N	\N	\N	\N	209546	209546	376673
27919	45435	1	applied	\N	\N	\N	\N	209547	209547	376674
27919	45436	2	applied	\N	\N	\N	\N	209548	209548	376675
27922	45441	1	applied	\N	\N	\N	\N	209556	209556	376683
27922	45442	2	applied	\N	\N	\N	\N	209557	209557	376684
27923	45440	0	applied	\N	\N	\N	\N	209558	209558	376685
27923	45441	1	applied	\N	\N	\N	\N	209559	209559	376686
27925	45446	0	applied	\N	\N	\N	\N	209563	209563	376690
27925	45447	1	applied	\N	\N	\N	\N	209564	209564	376691
27925	45448	2	applied	\N	\N	\N	\N	209565	209565	376692
27925	45449	3	applied	\N	\N	\N	\N	209566	209566	376693
27926	45446	0	applied	\N	\N	\N	\N	209567	209567	376694
27926	45447	1	applied	\N	\N	\N	\N	209568	209568	376695
27926	45448	2	applied	\N	\N	\N	\N	209569	209569	376696
27926	45449	3	applied	\N	\N	\N	\N	209570	209570	376697
27928	45453	0	applied	\N	\N	\N	\N	209574	209574	376701
27928	45454	1	applied	\N	\N	\N	\N	209575	209575	376702
27928	45455	2	applied	\N	\N	\N	\N	209576	209576	376703
27929	45453	0	applied	\N	\N	\N	\N	209577	209577	376704
27929	45455	2	applied	\N	\N	\N	\N	209579	209579	376706
27931	45456	0	applied	\N	\N	\N	\N	209583	209583	376710
27931	45457	1	applied	\N	\N	\N	\N	209584	209584	376711
27931	45458	2	applied	\N	\N	\N	\N	209585	209585	376712
27931	45459	3	applied	\N	\N	1000000000	\N	209586	209586	376713
27931	45460	4	applied	\N	\N	\N	\N	209587	209587	376714
27931	45461	5	applied	\N	\N	\N	\N	209588	209588	376715
27931	45462	6	applied	\N	\N	\N	\N	209589	209589	376716
27931	45463	7	applied	\N	\N	\N	\N	209590	209590	376717
27931	45464	8	applied	\N	\N	\N	\N	209591	209591	376718
27932	45465	0	applied	\N	\N	\N	\N	209592	209592	376719
27932	45466	1	applied	\N	\N	\N	\N	209593	209593	376720
27932	45467	2	applied	\N	\N	\N	\N	209594	209594	376721
27934	45468	0	applied	\N	\N	\N	\N	209598	209598	376725
27934	45469	1	applied	\N	\N	\N	\N	209599	209599	376726
27934	45470	2	applied	\N	\N	\N	\N	209600	209600	376727
27934	45472	4	applied	\N	\N	\N	\N	209602	209602	376729
27934	45473	5	applied	\N	\N	\N	\N	209603	209603	376730
27934	45474	6	applied	\N	\N	\N	\N	209604	209604	376731
27935	45468	0	applied	\N	\N	\N	\N	209605	209605	376732
27935	45469	1	applied	\N	\N	\N	\N	209606	209606	376733
27935	45470	2	applied	\N	\N	\N	\N	209607	209607	376734
27935	45471	3	applied	\N	\N	\N	\N	209608	209608	376735
27935	45472	4	applied	\N	\N	\N	\N	209609	209609	376736
27935	45473	5	applied	\N	\N	\N	\N	209610	209610	376737
27935	45474	6	applied	\N	\N	\N	\N	209611	209611	376738
27937	45481	0	applied	\N	\N	\N	\N	209618	209618	376745
27937	45482	1	applied	\N	\N	\N	\N	209619	209619	376746
27937	45483	2	applied	\N	\N	\N	\N	209620	209620	376747
27939	45481	0	applied	\N	\N	\N	\N	209624	209624	376751
27939	45482	1	applied	\N	\N	\N	\N	209625	209625	376752
27939	45483	2	applied	\N	\N	\N	\N	209626	209626	376753
27940	45485	1	applied	\N	\N	\N	\N	209628	209628	376755
27940	45486	2	applied	\N	\N	\N	\N	209629	209629	376756
27941	45487	0	applied	\N	\N	\N	\N	209630	209630	376757
27941	45488	1	applied	\N	\N	\N	\N	209631	209631	376758
27941	45489	2	applied	\N	\N	\N	\N	209632	209632	376759
27941	45490	3	applied	\N	\N	1000000000	\N	209633	209633	376760
27943	45497	0	applied	\N	\N	\N	\N	209640	209640	376767
27943	45498	1	applied	\N	\N	\N	\N	209641	209641	376768
27943	45499	2	applied	\N	\N	\N	\N	209642	209642	376769
27943	45500	3	applied	\N	\N	\N	\N	209643	209643	376770
27943	45501	4	applied	\N	\N	\N	\N	209644	209644	376771
27943	45502	5	applied	\N	\N	\N	\N	209645	209645	376772
27943	45503	6	applied	\N	\N	\N	\N	209646	209646	376773
27943	45504	7	applied	\N	\N	\N	\N	209647	209647	376774
27943	45505	8	applied	\N	\N	\N	\N	209648	209648	376775
27944	45506	0	applied	\N	\N	\N	\N	209649	209649	376776
27944	45508	2	applied	\N	\N	\N	\N	209651	209651	376778
27946	45506	0	applied	\N	\N	\N	\N	209655	209655	376782
27946	45507	1	applied	\N	\N	\N	\N	209656	209656	376783
27947	45509	0	applied	\N	\N	\N	\N	209658	209658	376785
27947	45510	1	applied	\N	\N	\N	\N	209659	209659	376786
27947	45511	2	applied	\N	\N	\N	\N	209660	209660	376787
27902	45375	2	applied	\N	\N	\N	\N	209463	209463	376590
27905	45382	0	applied	\N	\N	\N	\N	209470	209470	376597
27949	45509	0	applied	\N	\N	\N	\N	209670	209670	376797
27949	45510	1	applied	\N	\N	\N	\N	209671	209671	376798
27949	45511	2	applied	\N	\N	\N	\N	209672	209672	376799
27949	45512	3	applied	\N	\N	\N	\N	209673	209673	376800
27949	45513	4	applied	\N	\N	\N	\N	209674	209674	376801
27949	45514	5	applied	\N	\N	\N	\N	209675	209675	376802
27952	45515	0	applied	\N	\N	\N	\N	209682	209682	376809
27952	45516	1	applied	\N	\N	\N	\N	209683	209683	376810
27952	45517	2	applied	\N	\N	\N	\N	209684	209684	376811
27952	45518	3	applied	\N	\N	\N	\N	209685	209685	376812
27952	45519	4	applied	\N	\N	\N	\N	209686	209686	376813
27952	45520	5	applied	\N	\N	\N	\N	209687	209687	376814
27953	45521	0	applied	\N	\N	\N	\N	209688	209688	376815
27953	45522	1	applied	\N	\N	\N	\N	209689	209689	376816
27953	45523	2	applied	\N	\N	\N	\N	209690	209690	376817
27953	45526	5	applied	\N	\N	\N	\N	209693	209693	376820
27955	45527	0	applied	\N	\N	\N	\N	209700	209700	376827
27955	45528	1	applied	\N	\N	\N	\N	209701	209701	376828
27955	45529	2	applied	\N	\N	\N	\N	209702	209702	376829
27955	45530	3	applied	\N	\N	\N	\N	209703	209703	376830
27955	45531	4	applied	\N	\N	\N	\N	209704	209704	376831
27955	45532	5	applied	\N	\N	\N	\N	209705	209705	376832
27956	45527	0	applied	\N	\N	\N	\N	209706	209706	376833
27956	45528	1	applied	\N	\N	\N	\N	209707	209707	376834
27956	45529	2	applied	\N	\N	\N	\N	209708	209708	376835
27956	45530	3	applied	\N	\N	\N	\N	209709	209709	376836
27956	45531	4	applied	\N	\N	\N	\N	209710	209710	376837
27956	45532	5	applied	\N	\N	\N	\N	209711	209711	376838
27958	45534	0	applied	\N	\N	\N	\N	209715	209715	376842
27958	45535	1	applied	\N	\N	\N	\N	209716	209716	376843
27959	45533	0	applied	\N	\N	\N	\N	209717	209717	376844
27959	45537	2	applied	\N	\N	\N	\N	209719	209719	376846
27959	45538	3	applied	\N	\N	\N	\N	209720	209720	376847
27959	45539	4	applied	\N	\N	\N	\N	209721	209721	376848
27961	45533	0	applied	\N	\N	\N	\N	209727	209727	376854
27961	45536	1	applied	\N	\N	\N	\N	209728	209728	376855
27961	45537	2	applied	\N	\N	\N	\N	209729	209729	376856
27961	45540	3	applied	\N	\N	\N	\N	209730	209730	376857
27961	45538	4	applied	\N	\N	\N	\N	209731	209731	376858
27961	45539	5	applied	\N	\N	\N	\N	209732	209732	376859
27961	45541	6	applied	\N	\N	\N	\N	209733	209733	376860
27962	45533	0	applied	\N	\N	\N	\N	209734	209734	376861
27962	45536	1	applied	\N	\N	\N	\N	209735	209735	376862
27962	45537	2	applied	\N	\N	\N	\N	209736	209736	376863
27962	45540	3	applied	\N	\N	\N	\N	209737	209737	376864
27962	45538	4	applied	\N	\N	\N	\N	209738	209738	376865
27962	45539	5	applied	\N	\N	\N	\N	209739	209739	376866
27965	45542	0	applied	\N	\N	\N	\N	209748	209748	376875
27965	45543	1	applied	\N	\N	\N	\N	209749	209749	376876
27965	45544	2	applied	\N	\N	\N	\N	209750	209750	376877
27965	45545	3	applied	\N	\N	\N	\N	209751	209751	376878
27965	45540	4	applied	\N	\N	\N	\N	209752	209752	376879
27965	45541	5	applied	\N	\N	\N	\N	209753	209753	376880
27965	45546	6	applied	\N	\N	\N	\N	209754	209754	376881
27965	45547	7	applied	\N	\N	\N	\N	209755	209755	376882
27965	45548	8	applied	\N	\N	\N	\N	209756	209756	376883
27965	45549	9	applied	\N	\N	\N	\N	209757	209757	376884
27965	45550	10	applied	\N	\N	\N	\N	209758	209758	376885
27967	45555	0	applied	\N	\N	\N	\N	209763	209763	376890
27967	45556	1	applied	\N	\N	\N	\N	209764	209764	376891
27967	45557	2	applied	\N	\N	\N	\N	209765	209765	376892
27967	45558	3	applied	\N	\N	\N	\N	209766	209766	376893
27967	45559	4	applied	\N	\N	\N	\N	209767	209767	376894
27967	45561	6	applied	\N	\N	\N	\N	209769	209769	376896
27967	45562	7	applied	\N	\N	\N	\N	209770	209770	376897
27967	45563	8	applied	\N	\N	\N	\N	209771	209771	376898
27967	45564	9	applied	\N	\N	\N	\N	209772	209772	376899
27967	45565	10	applied	\N	\N	\N	\N	209773	209773	376900
27968	45555	0	applied	\N	\N	\N	\N	209774	209774	376901
27968	45556	1	applied	\N	\N	\N	\N	209775	209775	376902
27968	45557	2	applied	\N	\N	\N	\N	209776	209776	376903
27968	45558	3	applied	\N	\N	\N	\N	209777	209777	376904
27968	45559	4	applied	\N	\N	\N	\N	209778	209778	376905
27968	45560	5	applied	\N	\N	\N	\N	209779	209779	376906
27968	45561	6	applied	\N	\N	\N	\N	209780	209780	376907
27968	45562	7	applied	\N	\N	\N	\N	209781	209781	376908
27968	45563	8	applied	\N	\N	\N	\N	209782	209782	376909
27968	45564	9	applied	\N	\N	\N	\N	209783	209783	376910
27968	45565	10	applied	\N	\N	\N	\N	209784	209784	376911
27970	45556	1	applied	\N	\N	\N	\N	209797	209797	376924
27970	45557	2	applied	\N	\N	\N	\N	209798	209798	376925
27970	45558	3	applied	\N	\N	\N	\N	209799	209799	376926
27970	45561	4	applied	\N	\N	\N	\N	209800	209800	376927
27970	45562	5	applied	\N	\N	\N	\N	209801	209801	376928
27971	45555	0	applied	\N	\N	\N	\N	209802	209802	376929
27971	45556	1	applied	\N	\N	\N	\N	209803	209803	376930
27971	45557	2	applied	\N	\N	\N	\N	209804	209804	376931
27971	45558	3	applied	\N	\N	\N	\N	209805	209805	376932
27971	45559	4	applied	\N	\N	\N	\N	209806	209806	376933
27971	45560	5	applied	\N	\N	\N	\N	209807	209807	376934
27971	45561	6	applied	\N	\N	\N	\N	209808	209808	376935
27971	45562	7	applied	\N	\N	\N	\N	209809	209809	376936
27971	45563	8	applied	\N	\N	\N	\N	209810	209810	376937
27971	45564	9	applied	\N	\N	\N	\N	209811	209811	376938
27971	45565	10	applied	\N	\N	\N	\N	209812	209812	376939
27973	45556	1	applied	\N	\N	\N	\N	209825	209825	376952
27973	45557	2	applied	\N	\N	\N	\N	209826	209826	376953
27973	45558	3	applied	\N	\N	\N	\N	209827	209827	376954
27974	45566	0	applied	\N	\N	\N	\N	209835	209835	376962
27974	45567	1	applied	\N	\N	\N	\N	209836	209836	376963
27974	45568	2	applied	\N	\N	\N	\N	209837	209837	376964
27977	45298	0	applied	\N	\N	\N	\N	209844	209844	376971
27977	45301	1	applied	\N	\N	\N	\N	209845	209845	376972
27977	45304	2	applied	\N	\N	\N	\N	209846	209846	376973
27977	45307	3	applied	\N	\N	\N	\N	209847	209847	376974
27977	45423	4	applied	\N	\N	\N	\N	209848	209848	376975
27977	45447	5	applied	\N	\N	\N	\N	209849	209849	376976
27977	45310	6	applied	\N	\N	\N	\N	209850	209850	376977
27977	45311	7	applied	\N	\N	\N	\N	209851	209851	376978
27947	45512	3	applied	\N	\N	\N	\N	209661	209661	376788
27947	45513	4	applied	\N	\N	\N	\N	209662	209662	376789
27951	45517	2	applied	\N	\N	\N	\N	209678	209678	376805
27951	45518	3	applied	\N	\N	\N	\N	209679	209679	376806
27951	45519	4	applied	\N	\N	\N	\N	209680	209680	376807
27951	45520	5	applied	\N	\N	\N	\N	209681	209681	376808
27954	45521	0	applied	\N	\N	\N	\N	209694	209694	376821
27954	45522	1	applied	\N	\N	\N	\N	209695	209695	376822
27954	45523	2	applied	\N	\N	\N	\N	209696	209696	376823
27954	45524	3	applied	\N	\N	\N	\N	209697	209697	376824
27954	45525	4	applied	\N	\N	\N	\N	209698	209698	376825
27954	45526	5	applied	\N	\N	\N	\N	209699	209699	376826
27957	45533	0	applied	\N	\N	\N	\N	209712	209712	376839
27957	45534	1	applied	\N	\N	\N	\N	209713	209713	376840
27957	45535	2	applied	\N	\N	\N	\N	209714	209714	376841
27960	45533	0	applied	\N	\N	\N	\N	209722	209722	376849
27960	45536	1	applied	\N	\N	\N	\N	209723	209723	376850
27960	45537	2	applied	\N	\N	\N	\N	209724	209724	376851
27960	45539	4	applied	\N	\N	\N	\N	209726	209726	376853
27963	45533	0	applied	\N	\N	\N	\N	209741	209741	376868
27963	45536	1	applied	\N	\N	\N	\N	209742	209742	376869
27963	45537	2	applied	\N	\N	\N	\N	209743	209743	376870
27963	45540	3	applied	\N	\N	\N	\N	209744	209744	376871
27963	45538	4	applied	\N	\N	\N	\N	209745	209745	376872
27963	45539	5	applied	\N	\N	\N	\N	209746	209746	376873
27963	45541	6	applied	\N	\N	\N	\N	209747	209747	376874
27966	45551	0	applied	\N	\N	\N	\N	209759	209759	376886
27966	45552	1	applied	\N	\N	\N	\N	209760	209760	376887
27966	45553	2	applied	\N	\N	\N	\N	209761	209761	376888
27966	45554	3	applied	\N	\N	\N	\N	209762	209762	376889
27969	45555	0	applied	\N	\N	\N	\N	209785	209785	376912
27969	45556	1	applied	\N	\N	\N	\N	209786	209786	376913
27969	45557	2	applied	\N	\N	\N	\N	209787	209787	376914
27969	45558	3	applied	\N	\N	\N	\N	209788	209788	376915
27969	45560	5	applied	\N	\N	\N	\N	209790	209790	376917
27969	45561	6	applied	\N	\N	\N	\N	209791	209791	376918
27969	45562	7	applied	\N	\N	\N	\N	209792	209792	376919
27969	45563	8	applied	\N	\N	\N	\N	209793	209793	376920
27969	45564	9	applied	\N	\N	\N	\N	209794	209794	376921
27969	45565	10	applied	\N	\N	\N	\N	209795	209795	376922
27972	45555	0	applied	\N	\N	\N	\N	209813	209813	376940
27972	45556	1	applied	\N	\N	\N	\N	209814	209814	376941
27972	45557	2	applied	\N	\N	\N	\N	209815	209815	376942
27972	45558	3	applied	\N	\N	\N	\N	209816	209816	376943
27972	45559	4	applied	\N	\N	\N	\N	209817	209817	376944
27973	45559	4	applied	\N	\N	\N	\N	209828	209828	376955
27973	45560	5	applied	\N	\N	\N	\N	209829	209829	376956
27973	45561	6	applied	\N	\N	\N	\N	209830	209830	376957
27973	45562	7	applied	\N	\N	\N	\N	209831	209831	376958
27973	45563	8	applied	\N	\N	\N	\N	209832	209832	376959
27973	45565	10	applied	\N	\N	\N	\N	209834	209834	376961
27976	45569	0	applied	\N	\N	\N	\N	209841	209841	376968
27976	45570	1	applied	\N	\N	\N	\N	209842	209842	376969
27976	45571	2	applied	\N	\N	\N	\N	209843	209843	376970
27979	45580	0	applied	\N	\N	\N	\N	209977	209977	377104
27979	45581	1	applied	\N	\N	\N	\N	209978	209978	377105
27979	45582	2	applied	\N	\N	\N	\N	209979	209979	377106
27982	45583	0	applied	\N	\N	\N	\N	209986	209986	377113
27982	45584	1	applied	\N	\N	\N	\N	209987	209987	377114
27982	45585	2	applied	\N	\N	\N	\N	209988	209988	377115
27985	45592	0	applied	\N	\N	\N	\N	210001	210001	377128
27985	45593	1	applied	\N	\N	\N	\N	210002	210002	377129
27985	45594	2	applied	\N	\N	\N	\N	210003	210003	377130
27988	45601	0	applied	\N	\N	\N	\N	210019	210019	377146
27988	45602	1	applied	\N	\N	\N	\N	210020	210020	377147
27988	45603	2	applied	\N	\N	\N	\N	210021	210021	377148
27988	45605	4	applied	\N	\N	\N	\N	210023	210023	377150
27988	45606	5	applied	\N	\N	\N	\N	210024	210024	377151
27988	45607	6	applied	\N	\N	\N	\N	210025	210025	377152
27988	45608	7	applied	\N	\N	\N	\N	210026	210026	377153
27988	45609	8	applied	\N	\N	\N	\N	210027	210027	377154
27991	45610	0	applied	\N	\N	\N	\N	210046	210046	377173
27991	45611	1	applied	\N	\N	\N	\N	210047	210047	377174
27991	45612	2	applied	\N	\N	\N	\N	210048	210048	377175
27994	45610	0	applied	\N	\N	\N	\N	210055	210055	377182
27994	45611	1	applied	\N	\N	\N	\N	210056	210056	377183
27994	45612	2	applied	\N	\N	\N	\N	210057	210057	377184
27997	45613	0	applied	\N	\N	\N	\N	210064	210064	377191
27997	45614	1	applied	\N	\N	\N	\N	210065	210065	377192
27997	45615	2	applied	\N	\N	\N	\N	210066	210066	377193
28000	45616	0	applied	\N	\N	\N	\N	210070	210070	377197
28000	45617	1	applied	\N	\N	\N	\N	210071	210071	377198
28003	45622	0	applied	\N	\N	\N	\N	210076	210076	377203
28006	45622	0	applied	\N	\N	\N	\N	210088	210088	377215
28006	45623	1	applied	\N	\N	\N	\N	210089	210089	377216
28006	45624	2	applied	\N	\N	\N	\N	210090	210090	377217
28006	45625	3	applied	\N	\N	\N	\N	210091	210091	377218
28006	45626	4	applied	\N	\N	\N	\N	210092	210092	377219
28006	45627	5	applied	\N	\N	\N	\N	210093	210093	377220
28009	45566	0	applied	\N	\N	\N	\N	210100	210100	377227
28009	45569	1	applied	\N	\N	\N	\N	210101	210101	377228
28009	45572	2	applied	\N	\N	\N	\N	210102	210102	377229
28009	45573	3	applied	\N	\N	\N	\N	210103	210103	377230
28009	45580	4	applied	\N	\N	\N	\N	210104	210104	377231
28009	45583	5	applied	\N	\N	\N	\N	210105	210105	377232
28009	45586	6	applied	\N	\N	\N	\N	210106	210106	377233
28009	45587	7	applied	\N	\N	\N	\N	210107	210107	377234
28009	45592	8	applied	\N	\N	\N	\N	210108	210108	377235
28009	45596	10	applied	\N	\N	\N	\N	210110	210110	377237
28009	45601	11	applied	\N	\N	\N	\N	210111	210111	377238
28009	45602	12	applied	\N	\N	\N	\N	210112	210112	377239
28009	45603	13	applied	\N	\N	\N	\N	210113	210113	377240
28009	45610	14	applied	\N	\N	\N	\N	210114	210114	377241
28009	45613	15	applied	\N	\N	\N	\N	210115	210115	377242
28009	45616	16	applied	\N	\N	\N	\N	210116	210116	377243
28009	45619	17	applied	\N	\N	\N	\N	210117	210117	377244
28009	45622	18	applied	\N	\N	\N	\N	210118	210118	377245
28009	45623	19	applied	\N	\N	\N	\N	210119	210119	377246
28009	45628	20	applied	\N	\N	\N	\N	210120	210120	377247
28009	45377	21	applied	\N	\N	\N	\N	210121	210121	377248
28009	45381	22	applied	\N	\N	\N	\N	210122	210122	377249
28009	45387	23	applied	\N	\N	\N	\N	210123	210123	377250
27948	45514	5	applied	\N	\N	\N	\N	209669	209669	376796
27951	45515	0	applied	\N	\N	\N	\N	209676	209676	376803
27972	45564	9	applied	\N	\N	\N	\N	209822	209822	376949
27972	45565	10	applied	\N	\N	\N	\N	209823	209823	376950
27975	45569	0	applied	\N	\N	\N	\N	209838	209838	376965
27975	45570	1	applied	\N	\N	\N	\N	209839	209839	376966
27975	45571	2	applied	\N	\N	\N	\N	209840	209840	376967
27977	45318	8	applied	\N	\N	\N	\N	209852	209852	376979
27977	45321	9	applied	\N	\N	\N	\N	209853	209853	376980
27977	45322	10	applied	\N	\N	\N	\N	209854	209854	376981
27977	45323	11	applied	\N	\N	\N	\N	209855	209855	376982
27977	45330	12	applied	\N	\N	\N	\N	209856	209856	376983
27977	45333	13	applied	\N	\N	\N	\N	209857	209857	376984
27977	45334	14	applied	\N	\N	\N	\N	209858	209858	376985
27977	45335	15	applied	\N	\N	\N	\N	209859	209859	376986
27977	45342	16	applied	\N	\N	\N	\N	209860	209860	376987
27977	45345	17	applied	\N	\N	\N	\N	209861	209861	376988
27977	45348	18	applied	\N	\N	\N	\N	209862	209862	376989
27977	45354	20	applied	\N	\N	\N	\N	209864	209864	376991
27977	45355	21	applied	\N	\N	\N	\N	209865	209865	376992
27977	45361	22	applied	\N	\N	\N	\N	209866	209866	376993
27977	45364	23	applied	\N	\N	\N	\N	209867	209867	376994
27977	45367	24	applied	\N	\N	\N	\N	209868	209868	376995
27977	45368	25	applied	\N	\N	\N	\N	209869	209869	376996
27977	45373	26	applied	\N	\N	\N	\N	209870	209870	376997
27977	45376	27	applied	\N	\N	\N	\N	209871	209871	376998
27977	45379	28	applied	\N	\N	\N	\N	209872	209872	376999
27977	45382	29	applied	\N	\N	\N	\N	209873	209873	377000
27977	45383	30	applied	\N	\N	\N	\N	209874	209874	377001
27977	45384	31	applied	\N	\N	\N	\N	209875	209875	377002
27977	45385	32	applied	\N	\N	\N	\N	209876	209876	377003
27977	45386	33	applied	\N	\N	\N	\N	209877	209877	377004
27977	45401	34	applied	\N	\N	\N	\N	209878	209878	377005
27977	45404	35	applied	\N	\N	\N	\N	209879	209879	377006
27977	45410	37	applied	\N	\N	\N	\N	209881	209881	377008
27977	45413	38	applied	\N	\N	\N	\N	209882	209882	377009
27977	45414	39	applied	\N	\N	\N	\N	209883	209883	377010
27977	45419	40	applied	\N	\N	\N	\N	209884	209884	377011
27977	45422	41	applied	\N	\N	\N	\N	209885	209885	377012
27977	45425	42	applied	\N	\N	\N	\N	209886	209886	377013
27977	45426	43	applied	\N	\N	\N	\N	209887	209887	377014
27977	45431	44	applied	\N	\N	\N	\N	209888	209888	377015
27977	45434	45	applied	\N	\N	\N	\N	209889	209889	377016
27977	45437	47	applied	\N	\N	\N	\N	209890	209890	377017
27977	45440	48	applied	\N	\N	\N	\N	209891	209891	377018
27977	45443	49	applied	\N	\N	\N	\N	209892	209892	377019
27977	45446	50	applied	\N	\N	\N	\N	209893	209893	377020
27977	45450	51	applied	\N	\N	\N	\N	209894	209894	377021
27977	45453	52	applied	\N	\N	\N	\N	209895	209895	377022
27977	45456	53	applied	\N	\N	\N	\N	209896	209896	377023
27977	45458	55	applied	\N	\N	\N	\N	209898	209898	377025
27977	45465	56	applied	\N	\N	\N	\N	209899	209899	377026
27977	45468	57	applied	\N	\N	\N	\N	209900	209900	377027
27978	45572	0	applied	\N	\N	\N	\N	209969	209969	377096
27978	45573	1	applied	\N	\N	\N	\N	209970	209970	377097
27978	45574	2	applied	\N	\N	\N	\N	209971	209971	377098
27978	45575	3	applied	\N	\N	\N	\N	209972	209972	377099
27978	45576	4	applied	\N	\N	\N	\N	209973	209973	377100
27978	45577	5	applied	\N	\N	\N	\N	209974	209974	377101
27978	45578	6	applied	\N	\N	\N	\N	209975	209975	377102
27978	45579	7	applied	\N	\N	\N	\N	209976	209976	377103
27981	45583	0	applied	\N	\N	\N	\N	209983	209983	377110
27981	45584	1	applied	\N	\N	\N	\N	209984	209984	377111
27981	45585	2	applied	\N	\N	\N	\N	209985	209985	377112
27984	45586	0	applied	\N	\N	\N	\N	209995	209995	377122
27984	45587	1	applied	\N	\N	\N	\N	209996	209996	377123
27984	45589	3	applied	\N	\N	\N	\N	209998	209998	377125
27984	45590	4	applied	\N	\N	\N	\N	209999	209999	377126
27984	45591	5	applied	\N	\N	\N	\N	210000	210000	377127
27987	45601	0	applied	\N	\N	\N	\N	210010	210010	377137
27987	45602	1	applied	\N	\N	\N	\N	210011	210011	377138
27987	45603	2	applied	\N	\N	\N	\N	210012	210012	377139
27987	45604	3	applied	\N	\N	\N	\N	210013	210013	377140
27987	45605	4	applied	\N	\N	\N	\N	210014	210014	377141
27987	45606	5	applied	\N	\N	\N	\N	210015	210015	377142
27987	45607	6	applied	\N	\N	\N	\N	210016	210016	377143
27987	45608	7	applied	\N	\N	\N	\N	210017	210017	377144
27987	45609	8	applied	\N	\N	\N	\N	210018	210018	377145
27990	45601	0	applied	\N	\N	\N	\N	210037	210037	377164
27990	45602	1	applied	\N	\N	\N	\N	210038	210038	377165
27990	45603	2	applied	\N	\N	\N	\N	210039	210039	377166
27990	45604	3	applied	\N	\N	\N	\N	210040	210040	377167
27990	45606	5	applied	\N	\N	\N	\N	210042	210042	377169
27990	45607	6	applied	\N	\N	\N	\N	210043	210043	377170
27990	45608	7	applied	\N	\N	\N	\N	210044	210044	377171
27990	45609	8	applied	\N	\N	\N	\N	210045	210045	377172
27993	45610	0	applied	\N	\N	\N	\N	210052	210052	377179
27993	45611	1	applied	\N	\N	\N	\N	210053	210053	377180
27993	45612	2	applied	\N	\N	\N	\N	210054	210054	377181
27996	45613	0	applied	\N	\N	\N	\N	210061	210061	377188
27996	45614	1	applied	\N	\N	\N	\N	210062	210062	377189
27996	45615	2	applied	\N	\N	\N	\N	210063	210063	377190
28002	45619	0	applied	\N	\N	\N	\N	210073	210073	377200
28002	45620	1	applied	\N	\N	\N	\N	210074	210074	377201
28002	45621	2	applied	\N	\N	\N	\N	210075	210075	377202
28005	45622	0	applied	\N	\N	\N	\N	210082	210082	377209
28005	45623	1	applied	\N	\N	\N	\N	210083	210083	377210
28005	45624	2	applied	\N	\N	\N	\N	210084	210084	377211
28005	45626	4	applied	\N	\N	\N	\N	210086	210086	377213
28005	45627	5	applied	\N	\N	\N	\N	210087	210087	377214
28008	45628	0	applied	\N	\N	\N	\N	210097	210097	377224
28008	45629	1	applied	\N	\N	\N	\N	210098	210098	377225
28008	45630	2	applied	\N	\N	\N	\N	210099	210099	377226
28011	45631	0	applied	\N	\N	\N	\N	210187	210187	377314
28011	45632	1	applied	\N	\N	\N	\N	210188	210188	377315
28014	45642	0	applied	\N	\N	\N	\N	210198	210198	377325
28014	45643	1	applied	\N	\N	\N	\N	210199	210199	377326
28014	45644	2	applied	\N	\N	\N	\N	210200	210200	377327
28017	45648	0	applied	\N	\N	\N	\N	210207	210207	377334
28017	45649	1	applied	\N	\N	\N	\N	210208	210208	377335
28017	45650	2	applied	\N	\N	\N	\N	210209	210209	377336
28020	45660	0	applied	\N	\N	\N	\N	210220	210220	377347
27972	45561	6	applied	\N	\N	\N	\N	209819	209819	376946
27972	45562	7	applied	\N	\N	\N	\N	209820	209820	376947
27977	45481	61	applied	\N	\N	\N	\N	209904	209904	377031
27977	45484	62	applied	\N	\N	\N	\N	209905	209905	377032
27977	45487	63	applied	\N	\N	\N	\N	209906	209906	377033
27977	45491	64	applied	\N	\N	\N	\N	209907	209907	377034
27977	45492	65	applied	\N	\N	\N	\N	209908	209908	377035
27977	45497	66	applied	\N	\N	\N	\N	209909	209909	377036
27977	45498	67	applied	\N	\N	\N	\N	209910	209910	377037
27977	45499	68	applied	\N	\N	\N	\N	209911	209911	377038
27977	45506	69	applied	\N	\N	\N	\N	209912	209912	377039
27977	45510	71	applied	\N	\N	\N	\N	209914	209914	377041
27977	45515	72	applied	\N	\N	\N	\N	209915	209915	377042
27977	45516	73	applied	\N	\N	\N	\N	209916	209916	377043
27977	45521	74	applied	\N	\N	\N	\N	209917	209917	377044
27977	45522	75	applied	\N	\N	\N	\N	209918	209918	377045
27977	45527	76	applied	\N	\N	\N	\N	209919	209919	377046
27977	45528	77	applied	\N	\N	\N	\N	209920	209920	377047
27977	45533	78	applied	\N	\N	\N	\N	209921	209921	377048
27977	45536	79	applied	\N	\N	\N	\N	209922	209922	377049
27977	45537	80	applied	\N	\N	\N	\N	209923	209923	377050
27977	45542	81	applied	\N	\N	\N	\N	209924	209924	377051
27977	45543	82	applied	\N	\N	\N	\N	209925	209925	377052
27977	45544	83	applied	\N	\N	\N	\N	209926	209926	377053
27977	45551	84	applied	\N	\N	\N	\N	209927	209927	377054
27977	45552	85	applied	\N	\N	\N	\N	209928	209928	377055
27977	45555	86	applied	\N	\N	\N	\N	209929	209929	377056
27977	45557	88	applied	\N	\N	\N	\N	209931	209931	377058
27977	45388	89	applied	\N	\N	\N	\N	209932	209932	377059
27977	45391	90	applied	\N	\N	1000000000	\N	209933	209933	377060
27977	45472	91	applied	\N	\N	\N	\N	209934	209934	377061
27977	45392	92	applied	\N	\N	1000000000	\N	209935	209935	377062
27977	45393	93	applied	\N	\N	1000000000	\N	209936	209936	377063
27977	45284	94	applied	\N	\N	\N	\N	209937	209937	377064
27977	45288	95	applied	\N	\N	\N	\N	209938	209938	377065
27977	45289	96	applied	\N	\N	\N	\N	209939	209939	377066
27977	45490	97	applied	\N	\N	1000000000	\N	209940	209940	377067
27977	45294	98	applied	\N	\N	\N	\N	209941	209941	377068
27977	45297	99	applied	\N	\N	\N	\N	209942	209942	377069
27977	45299	100	applied	\N	\N	\N	\N	209943	209943	377070
27977	45302	101	applied	\N	\N	\N	\N	209944	209944	377071
27977	45306	102	applied	\N	\N	\N	\N	209945	209945	377072
27977	45309	103	applied	\N	\N	\N	\N	209946	209946	377073
27977	45316	105	applied	\N	\N	\N	\N	209948	209948	377075
27977	45317	106	applied	\N	\N	\N	\N	209949	209949	377076
27977	45320	107	applied	\N	\N	\N	\N	209950	209950	377077
27977	45325	108	applied	\N	\N	\N	\N	209951	209951	377078
27977	45326	109	applied	\N	\N	\N	\N	209952	209952	377079
27977	45327	110	applied	\N	\N	\N	\N	209953	209953	377080
27977	45332	111	applied	\N	\N	\N	\N	209954	209954	377081
27977	45339	112	applied	\N	\N	\N	\N	209955	209955	377082
27977	45340	113	applied	\N	\N	\N	\N	209956	209956	377083
27977	45341	114	applied	\N	\N	\N	\N	209957	209957	377084
27977	45344	115	applied	\N	\N	\N	\N	209958	209958	377085
27977	45346	116	applied	\N	\N	\N	\N	209959	209959	377086
27977	45349	117	applied	\N	\N	\N	\N	209960	209960	377087
27977	45353	118	applied	\N	\N	\N	\N	209961	209961	377088
27977	45357	119	applied	\N	\N	\N	\N	209962	209962	377089
27977	45358	120	applied	\N	\N	\N	\N	209963	209963	377090
27977	45366	122	applied	\N	\N	\N	\N	209965	209965	377092
27977	45371	123	applied	\N	\N	\N	\N	209966	209966	377093
27977	45372	124	applied	\N	\N	\N	\N	209967	209967	377094
27977	45374	125	applied	\N	\N	\N	\N	209968	209968	377095
27980	45583	0	applied	\N	\N	\N	\N	209980	209980	377107
27980	45584	1	applied	\N	\N	\N	\N	209981	209981	377108
27980	45585	2	applied	\N	\N	\N	\N	209982	209982	377109
27983	45586	0	applied	\N	\N	\N	\N	209989	209989	377116
27983	45587	1	applied	\N	\N	\N	\N	209990	209990	377117
27983	45588	2	applied	\N	\N	\N	\N	209991	209991	377118
27983	45589	3	applied	\N	\N	\N	\N	209992	209992	377119
27983	45590	4	applied	\N	\N	\N	\N	209993	209993	377120
27983	45591	5	applied	\N	\N	\N	\N	209994	209994	377121
27986	45595	0	applied	\N	\N	\N	\N	210004	210004	377131
27986	45596	1	applied	\N	\N	\N	\N	210005	210005	377132
27986	45597	2	applied	\N	\N	\N	\N	210006	210006	377133
27986	45599	4	applied	\N	\N	\N	\N	210008	210008	377135
27986	45600	5	applied	\N	\N	\N	\N	210009	210009	377136
27989	45601	0	applied	\N	\N	\N	\N	210028	210028	377155
27989	45602	1	applied	\N	\N	\N	\N	210029	210029	377156
27989	45603	2	applied	\N	\N	\N	\N	210030	210030	377157
27989	45604	3	applied	\N	\N	\N	\N	210031	210031	377158
27989	45605	4	applied	\N	\N	\N	\N	210032	210032	377159
27989	45606	5	applied	\N	\N	\N	\N	210033	210033	377160
27989	45607	6	applied	\N	\N	\N	\N	210034	210034	377161
27989	45608	7	applied	\N	\N	\N	\N	210035	210035	377162
27989	45609	8	applied	\N	\N	\N	\N	210036	210036	377163
27992	45610	0	applied	\N	\N	\N	\N	210049	210049	377176
27992	45611	1	applied	\N	\N	\N	\N	210050	210050	377177
27992	45612	2	applied	\N	\N	\N	\N	210051	210051	377178
27995	45613	0	applied	\N	\N	\N	\N	210058	210058	377185
27995	45614	1	applied	\N	\N	\N	\N	210059	210059	377186
27998	45616	0	applied	\N	\N	\N	\N	210067	210067	377194
27998	45617	1	applied	\N	\N	\N	\N	210068	210068	377195
27998	45618	2	applied	\N	\N	\N	\N	210069	210069	377196
28004	45623	0	applied	\N	\N	\N	\N	210077	210077	377204
28004	45624	1	applied	\N	\N	\N	\N	210078	210078	377205
28004	45625	2	applied	\N	\N	\N	\N	210079	210079	377206
28004	45626	3	applied	\N	\N	\N	\N	210080	210080	377207
28004	45627	4	applied	\N	\N	\N	\N	210081	210081	377208
28007	45628	0	applied	\N	\N	\N	\N	210094	210094	377221
28007	45629	1	applied	\N	\N	\N	\N	210095	210095	377222
28007	45630	2	applied	\N	\N	\N	\N	210096	210096	377223
28010	45628	0	applied	\N	\N	\N	\N	210184	210184	377311
28010	45629	1	applied	\N	\N	\N	\N	210185	210185	377312
28010	45630	2	applied	\N	\N	\N	\N	210186	210186	377313
28013	45636	0	applied	\N	\N	\N	\N	210192	210192	377319
28013	45637	1	applied	\N	\N	\N	\N	210193	210193	377320
28013	45639	3	applied	\N	\N	\N	\N	210195	210195	377322
28013	45640	4	applied	\N	\N	\N	\N	210196	210196	377323
28013	45641	5	applied	\N	\N	\N	\N	210197	210197	377324
28016	45645	0	applied	\N	\N	\N	\N	210204	210204	377331
27977	45475	59	applied	\N	\N	\N	\N	209902	209902	377029
27977	45476	60	applied	\N	\N	\N	\N	209903	209903	377030
28009	45403	28	applied	\N	\N	\N	\N	210128	210128	377255
28009	45406	29	applied	\N	\N	\N	\N	210129	210129	377256
28009	45409	30	applied	\N	\N	\N	\N	210130	210130	377257
28009	45411	31	applied	\N	\N	\N	\N	210131	210131	377258
28009	45415	32	applied	\N	\N	\N	\N	210132	210132	377259
28009	45416	33	applied	\N	\N	\N	\N	210133	210133	377260
28009	45421	34	applied	\N	\N	\N	\N	210134	210134	377261
28009	45424	35	applied	\N	\N	\N	\N	210135	210135	377262
28009	45429	36	applied	\N	\N	\N	\N	210136	210136	377263
28009	45430	37	applied	\N	\N	\N	\N	210137	210137	377264
28009	45432	38	applied	\N	\N	\N	\N	210138	210138	377265
28009	45435	39	applied	\N	\N	\N	\N	210139	210139	377266
28009	45439	40	applied	\N	\N	\N	\N	210140	210140	377267
28009	45442	41	applied	\N	\N	\N	\N	210141	210141	377268
28009	45445	42	applied	\N	\N	\N	\N	210142	210142	377269
28009	45449	43	applied	\N	\N	\N	\N	210143	210143	377270
28009	45455	45	applied	\N	\N	\N	\N	210145	210145	377272
28009	45460	47	applied	\N	\N	\N	\N	210146	210146	377273
28009	45461	48	applied	\N	\N	\N	\N	210147	210147	377274
28009	45466	49	applied	\N	\N	\N	\N	210148	210148	377275
28009	45470	50	applied	\N	\N	\N	\N	210149	210149	377276
28009	45471	51	applied	\N	\N	\N	\N	210150	210150	377277
28009	45477	52	applied	\N	\N	\N	\N	210151	210151	377278
28009	45478	53	applied	\N	\N	\N	\N	210152	210152	377279
28009	45482	54	applied	\N	\N	\N	\N	210153	210153	377280
28009	45486	55	applied	\N	\N	\N	\N	210154	210154	377281
28009	45489	56	applied	\N	\N	\N	\N	210155	210155	377282
28009	45494	57	applied	\N	\N	\N	\N	210156	210156	377283
28009	45495	58	applied	\N	\N	\N	\N	210157	210157	377284
28009	45500	59	applied	\N	\N	\N	\N	210158	210158	377285
28009	45501	60	applied	\N	\N	\N	\N	210159	210159	377286
28009	45502	61	applied	\N	\N	\N	\N	210160	210160	377287
28009	45513	63	applied	\N	\N	\N	\N	210162	210162	377289
28009	45514	64	applied	\N	\N	\N	\N	210163	210163	377290
28009	45517	65	applied	\N	\N	\N	\N	210164	210164	377291
28009	45518	66	applied	\N	\N	\N	\N	210165	210165	377292
28009	45524	67	applied	\N	\N	\N	\N	210166	210166	377293
28009	45526	68	applied	\N	\N	\N	\N	210167	210167	377294
28009	45531	69	applied	\N	\N	\N	\N	210168	210168	377295
28009	45532	70	applied	\N	\N	\N	\N	210169	210169	377296
28009	45535	71	applied	\N	\N	\N	\N	210170	210170	377297
28009	45540	72	applied	\N	\N	\N	\N	210171	210171	377298
28009	45541	73	applied	\N	\N	\N	\N	210172	210172	377299
28016	45646	1	applied	\N	\N	\N	\N	210205	210205	377332
28016	45647	2	applied	\N	\N	\N	\N	210206	210206	377333
28019	45660	0	applied	\N	\N	\N	\N	210219	210219	377346
28022	45662	0	applied	\N	\N	\N	\N	210224	210224	377351
28022	45663	1	applied	\N	\N	\N	\N	210225	210225	377352
28025	45665	0	applied	\N	\N	\N	\N	210236	210236	377363
28025	45666	1	applied	\N	\N	\N	\N	210237	210237	377364
28025	45667	2	applied	\N	\N	\N	\N	210238	210238	377365
28025	45668	3	applied	\N	\N	\N	\N	210239	210239	377366
28025	45669	4	applied	\N	\N	\N	\N	210240	210240	377367
28025	45670	5	applied	\N	\N	\N	\N	210241	210241	377368
28028	45671	0	applied	\N	\N	\N	\N	210245	210245	377372
28028	45672	1	applied	\N	\N	\N	\N	210246	210246	377373
28028	45673	2	applied	\N	\N	\N	\N	210247	210247	377374
28034	45678	0	applied	\N	\N	\N	\N	210267	210267	377394
28034	45679	1	applied	\N	\N	\N	\N	210268	210268	377395
28034	45680	2	applied	\N	\N	\N	\N	210269	210269	377396
28034	45681	3	applied	\N	\N	\N	\N	210270	210270	377397
28034	45682	4	applied	\N	\N	\N	\N	210271	210271	377398
28034	45683	5	applied	\N	\N	\N	\N	210272	210272	377399
28034	45684	6	applied	\N	\N	\N	\N	210273	210273	377400
28034	45686	8	applied	\N	\N	\N	\N	210275	210275	377402
28034	45687	9	applied	\N	\N	\N	\N	210276	210276	377403
28034	45688	10	applied	\N	\N	\N	\N	210277	210277	377404
28034	45689	11	applied	\N	\N	\N	\N	210278	210278	377405
28034	45690	12	applied	\N	\N	\N	\N	210279	210279	377406
28034	45691	13	applied	\N	\N	\N	\N	210280	210280	377407
28034	45692	14	applied	\N	\N	\N	\N	210281	210281	377408
28037	45696	0	applied	\N	\N	\N	\N	210410	210410	377535
28037	45697	1	applied	\N	\N	\N	\N	210411	210411	377536
28037	45698	2	applied	\N	\N	\N	\N	210412	210412	377537
28040	45699	0	applied	\N	\N	\N	\N	210418	210418	377543
28040	45700	1	applied	\N	\N	\N	\N	210419	210419	377544
28040	45701	2	applied	\N	\N	\N	\N	210420	210420	377545
28043	45705	0	applied	\N	\N	\N	\N	210426	210426	377551
28043	45706	1	applied	\N	\N	\N	\N	210427	210427	377552
28049	45713	0	applied	\N	\N	\N	\N	210440	210440	377565
28049	45715	2	applied	\N	\N	\N	\N	210442	210442	377567
28052	45716	0	applied	\N	\N	\N	\N	210452	210452	377577
28052	45717	1	applied	\N	\N	\N	\N	210453	210453	377578
28052	45718	2	applied	\N	\N	\N	\N	210454	210454	377579
28055	45716	0	applied	\N	\N	\N	\N	210460	210460	377585
28055	45717	1	applied	\N	\N	\N	\N	210461	210461	377586
28055	45718	2	applied	\N	\N	\N	\N	210462	210462	377587
28058	45722	0	applied	\N	\N	\N	\N	210469	210469	377594
28058	45723	1	applied	\N	\N	\N	\N	210470	210470	377595
28058	45724	2	applied	\N	\N	\N	\N	210471	210471	377596
28061	45725	0	applied	\N	\N	\N	\N	210478	210478	377603
28061	45726	1	applied	\N	\N	\N	\N	210479	210479	377604
28061	45727	2	applied	\N	\N	\N	\N	210480	210480	377605
28064	45728	0	applied	\N	\N	\N	\N	210487	210487	377612
28064	45729	1	applied	\N	\N	\N	\N	210488	210488	377613
28064	45730	2	applied	\N	\N	\N	\N	210489	210489	377614
28067	45741	1	applied	\N	\N	\N	\N	210506	210506	377631
28067	45742	2	applied	\N	\N	\N	\N	210507	210507	377632
28067	45743	3	applied	\N	\N	\N	\N	210508	210508	377633
28067	45744	4	applied	\N	\N	\N	\N	210509	210509	377634
28067	45745	5	applied	\N	\N	\N	\N	210510	210510	377635
28070	45750	0	applied	\N	\N	\N	\N	210519	210519	377644
28070	45751	1	applied	\N	\N	\N	\N	210520	210520	377645
28070	45752	2	applied	\N	\N	\N	\N	210521	210521	377646
28070	45753	3	applied	\N	\N	\N	\N	210522	210522	377647
28073	45007	0	applied	\N	\N	\N	\N	210535	210535	377660
28073	45008	1	applied	\N	\N	\N	\N	210536	210536	377661
28073	45009	2	applied	\N	\N	\N	\N	210537	210537	377662
28073	45010	3	applied	\N	\N	\N	\N	210538	210538	377663
28073	45011	4	applied	\N	\N	\N	\N	210539	210539	377664
28009	45390	25	applied	\N	\N	\N	\N	210125	210125	377252
28009	45399	26	applied	\N	\N	\N	\N	210126	210126	377253
28009	45559	77	applied	\N	\N	\N	\N	210176	210176	377303
28009	45560	78	applied	\N	\N	\N	\N	210177	210177	377304
28009	45563	79	applied	\N	\N	\N	\N	210178	210178	377305
28009	45564	80	applied	\N	\N	\N	\N	210179	210179	377306
28009	45565	81	applied	\N	\N	\N	\N	210180	210180	377307
28009	45567	82	applied	\N	\N	\N	\N	210181	210181	377308
28009	45570	83	applied	\N	\N	\N	\N	210182	210182	377309
28009	45574	84	applied	\N	\N	\N	\N	210183	210183	377310
28012	45633	0	applied	\N	\N	\N	\N	210189	210189	377316
28012	45635	2	applied	\N	\N	\N	\N	210191	210191	377318
28015	45642	0	applied	\N	\N	\N	\N	210201	210201	377328
28015	45643	1	applied	\N	\N	\N	\N	210202	210202	377329
28015	45644	2	applied	\N	\N	\N	\N	210203	210203	377330
28018	45651	0	applied	\N	\N	\N	\N	210210	210210	377337
28018	45652	1	applied	\N	\N	\N	\N	210211	210211	377338
28018	45653	2	applied	\N	\N	\N	\N	210212	210212	377339
28018	45654	3	applied	\N	\N	\N	\N	210213	210213	377340
28018	45655	4	applied	\N	\N	\N	\N	210214	210214	377341
28018	45656	5	applied	\N	\N	\N	\N	210215	210215	377342
28018	45657	6	applied	\N	\N	\N	\N	210216	210216	377343
28018	45658	7	applied	\N	\N	\N	\N	210217	210217	377344
28018	45659	8	applied	\N	\N	\N	\N	210218	210218	377345
28020	45661	1	applied	\N	\N	\N	\N	210221	210221	377348
28021	45660	0	applied	\N	\N	\N	\N	210222	210222	377349
28021	45661	1	applied	\N	\N	\N	\N	210223	210223	377350
28023	45663	1	applied	\N	\N	\N	\N	210228	210228	377355
28023	45664	2	applied	\N	\N	\N	\N	210229	210229	377356
28024	45665	0	applied	\N	\N	\N	\N	210230	210230	377357
28024	45666	1	applied	\N	\N	\N	\N	210231	210231	377358
28024	45667	2	applied	\N	\N	\N	\N	210232	210232	377359
28024	45668	3	applied	\N	\N	\N	\N	210233	210233	377360
28024	45669	4	applied	\N	\N	\N	\N	210234	210234	377361
28024	45670	5	applied	\N	\N	\N	\N	210235	210235	377362
28027	45671	0	applied	\N	\N	\N	\N	210242	210242	377369
28027	45672	1	applied	\N	\N	\N	\N	210243	210243	377370
28027	45673	2	applied	\N	\N	\N	\N	210244	210244	377371
28032	45674	0	applied	\N	\N	\N	\N	210248	210248	377375
28032	45675	1	applied	\N	\N	\N	\N	210249	210249	377376
28032	45676	2	applied	\N	\N	\N	\N	210250	210250	377377
28032	45677	3	applied	\N	\N	\N	\N	210251	210251	377378
28033	45678	0	applied	\N	\N	\N	\N	210252	210252	377379
28033	45680	2	applied	\N	\N	\N	\N	210254	210254	377381
28033	45681	3	applied	\N	\N	\N	\N	210255	210255	377382
28033	45682	4	applied	\N	\N	\N	\N	210256	210256	377383
28033	45683	5	applied	\N	\N	\N	\N	210257	210257	377384
28033	45684	6	applied	\N	\N	\N	\N	210258	210258	377385
28033	45685	7	applied	\N	\N	\N	\N	210259	210259	377386
28033	45686	8	applied	\N	\N	\N	\N	210260	210260	377387
28033	45687	9	applied	\N	\N	\N	\N	210261	210261	377388
28033	45688	10	applied	\N	\N	\N	\N	210262	210262	377389
28033	45689	11	applied	\N	\N	\N	\N	210263	210263	377390
28033	45690	12	applied	\N	\N	\N	\N	210264	210264	377391
28033	45691	13	applied	\N	\N	\N	\N	210265	210265	377392
28033	45692	14	applied	\N	\N	\N	\N	210266	210266	377393
28035	45693	0	applied	\N	\N	\N	\N	210282	210282	377409
28035	45694	1	applied	\N	\N	\N	\N	210283	210283	377410
28035	45695	2	applied	\N	\N	\N	\N	210284	210284	377411
28036	44857	1	applied	\N	\N	\N	\N	210286	210286	377413
28036	44915	2	applied	\N	\N	\N	\N	210287	210287	377414
28036	44954	3	applied	\N	\N	\N	\N	210288	210288	377415
28036	44721	4	applied	\N	\N	\N	\N	210289	210289	377416
28036	45423	5	applied	\N	\N	\N	\N	210290	210290	377417
28036	45082	6	applied	\N	\N	\N	\N	210291	210291	377418
28036	44722	7	applied	\N	\N	\N	\N	210292	210292	377419
28036	44955	8	applied	\N	\N	\N	\N	210293	210293	377420
28036	45447	9	applied	\N	\N	\N	\N	210294	210294	377421
28036	44957	10	applied	\N	\N	\N	\N	210295	210295	377422
28036	44860	11	applied	\N	\N	\N	\N	210296	210296	377423
28036	44958	12	applied	\N	\N	\N	\N	210297	210297	377424
28036	44718	13	applied	\N	\N	\N	\N	210298	210298	377425
28036	44723	14	applied	\N	\N	\N	\N	210299	210299	377426
28036	44724	15	applied	\N	\N	\N	\N	210300	210300	377427
28036	44725	16	applied	\N	\N	\N	\N	210301	210301	377428
28036	44744	18	applied	\N	\N	\N	\N	210303	210303	377429
28038	45696	0	applied	\N	\N	\N	\N	210413	210413	377538
28038	45697	1	applied	\N	\N	\N	\N	210414	210414	377539
28038	45698	2	applied	\N	\N	\N	\N	210415	210415	377540
28041	45702	0	applied	\N	\N	\N	\N	210421	210421	377546
28041	45703	1	applied	\N	\N	\N	\N	210422	210422	377547
28041	45704	2	applied	\N	\N	\N	\N	210423	210423	377548
28044	45707	0	applied	\N	\N	\N	\N	210428	210428	377553
28044	45708	1	applied	\N	\N	\N	\N	210429	210429	377554
28044	45709	2	applied	\N	\N	\N	\N	210430	210430	377555
28044	45710	3	applied	\N	\N	\N	\N	210431	210431	377556
28044	45711	4	applied	\N	\N	\N	\N	210432	210432	377557
28044	45712	5	applied	\N	\N	\N	\N	210433	210433	377558
28047	45713	0	applied	\N	\N	\N	\N	210434	210434	377559
28047	45714	1	applied	\N	\N	\N	\N	210435	210435	377560
28047	45715	2	applied	\N	\N	\N	\N	210436	210436	377561
28050	45447	1	applied	\N	\N	\N	\N	210444	210444	377569
28050	45388	2	applied	\N	\N	\N	\N	210445	210445	377570
28050	45391	3	applied	\N	\N	1000000000	\N	210446	210446	377571
28050	45472	4	applied	\N	\N	\N	\N	210447	210447	377572
28050	45392	5	applied	\N	\N	1000000000	\N	210448	210448	377573
28050	45393	6	applied	\N	\N	1000000000	\N	210449	210449	377574
28050	45490	7	applied	\N	\N	1000000000	\N	210450	210450	377575
28053	45716	0	applied	\N	\N	\N	\N	210455	210455	377580
28053	45717	1	applied	\N	\N	\N	\N	210456	210456	377581
28056	45719	0	applied	\N	\N	\N	\N	210463	210463	377588
28056	45720	1	applied	\N	\N	\N	\N	210464	210464	377589
28056	45721	2	applied	\N	\N	\N	\N	210465	210465	377590
28059	45722	0	applied	\N	\N	\N	\N	210472	210472	377597
28059	45723	1	applied	\N	\N	\N	\N	210473	210473	377598
28059	45724	2	applied	\N	\N	\N	\N	210474	210474	377599
28062	45728	0	applied	\N	\N	\N	\N	210481	210481	377606
28062	45730	2	applied	\N	\N	\N	\N	210483	210483	377608
28065	45731	0	applied	\N	\N	\N	\N	210490	210490	377615
28065	45732	1	applied	\N	\N	\N	\N	210491	210491	377616
28065	45733	2	applied	\N	\N	\N	\N	210492	210492	377617
28009	45547	75	applied	\N	\N	\N	\N	210174	210174	377301
28009	45548	76	applied	\N	\N	\N	\N	210175	210175	377302
28036	44749	24	applied	\N	\N	\N	\N	210308	210308	210308
28036	44727	25	applied	\N	\N	\N	\N	210309	210309	377434
28036	44730	26	applied	\N	\N	\N	\N	210310	210310	377435
28036	44731	27	applied	\N	\N	\N	\N	210311	210311	377436
28036	44737	28	applied	\N	\N	\N	\N	210312	210312	377437
28036	44738	29	applied	\N	\N	\N	\N	210313	210313	377438
28036	44743	30	applied	\N	\N	\N	\N	210314	210314	377439
28036	44752	31	applied	\N	\N	\N	\N	210315	210315	377440
28036	44755	32	applied	\N	\N	\N	\N	210316	210316	377441
28036	44756	33	applied	\N	\N	\N	\N	210317	210317	377442
28036	44757	34	applied	\N	\N	\N	\N	210318	210318	377443
28036	44758	35	applied	\N	\N	\N	\N	210319	210319	377444
28036	44767	36	applied	\N	\N	\N	\N	210320	210320	377445
28036	44770	37	applied	\N	\N	\N	\N	210321	210321	377446
28036	44774	39	applied	\N	\N	\N	\N	210323	210323	377448
28036	44775	40	applied	\N	\N	\N	\N	210324	210324	377449
28036	44776	41	applied	\N	\N	\N	\N	210325	210325	377450
28036	44785	42	applied	\N	\N	\N	\N	210326	210326	377451
28036	44786	43	applied	\N	\N	\N	\N	210327	210327	377452
28036	44787	44	applied	\N	\N	\N	\N	210328	210328	377453
28036	44794	45	applied	\N	\N	\N	\N	210329	210329	377454
28036	44797	46	applied	\N	\N	\N	\N	210330	210330	377455
28036	44800	47	applied	\N	\N	\N	\N	210331	210331	377456
28036	44803	48	applied	\N	\N	\N	\N	210332	210332	377457
28036	44804	49	applied	\N	\N	\N	\N	210333	210333	377458
28036	44809	50	applied	\N	\N	\N	\N	210334	210334	377459
28036	44813	51	applied	\N	\N	\N	\N	210335	210335	377460
28036	44814	52	applied	\N	\N	\N	\N	210336	210336	377461
28036	44819	53	applied	\N	\N	\N	\N	210337	210337	377462
28036	44822	54	applied	\N	\N	\N	\N	210338	210338	377463
28036	44828	56	applied	\N	\N	\N	\N	210340	210340	377465
28036	44861	57	applied	\N	\N	\N	\N	210341	210341	377466
28036	44829	58	applied	\N	\N	\N	\N	210342	210342	377467
28036	44830	59	applied	\N	\N	\N	\N	210343	210343	377468
28036	44831	60	applied	\N	\N	\N	\N	210344	210344	377469
28036	44840	61	applied	\N	\N	\N	\N	210345	210345	377470
28036	44844	62	applied	\N	\N	\N	\N	210346	210346	377471
28036	44845	63	applied	\N	\N	\N	\N	210347	210347	377472
28036	44850	64	applied	\N	\N	\N	\N	210348	210348	377473
28036	44851	65	applied	\N	\N	\N	\N	210349	210349	377474
28036	44858	66	applied	\N	\N	\N	\N	210350	210350	377475
28036	44859	67	applied	\N	\N	\N	\N	210351	210351	377476
28036	44866	68	applied	\N	\N	\N	\N	210352	210352	377477
28065	45734	3	applied	\N	\N	\N	\N	210493	210493	377618
28065	45735	4	applied	\N	\N	\N	\N	210494	210494	377619
28065	45736	5	applied	\N	\N	\N	\N	210495	210495	377620
28065	45738	7	applied	\N	\N	\N	\N	210497	210497	377622
28065	45739	8	applied	\N	\N	\N	\N	210498	210498	377623
28068	45746	0	applied	\N	\N	\N	\N	210511	210511	377636
28068	45747	1	applied	\N	\N	\N	\N	210512	210512	377637
28068	45748	2	applied	\N	\N	\N	\N	210513	210513	377638
28068	45749	3	applied	\N	\N	1000000000	\N	210514	210514	377639
28071	45750	0	applied	\N	\N	\N	\N	210523	210523	377648
28071	45751	1	applied	\N	\N	\N	\N	210524	210524	377649
28071	45754	2	applied	\N	\N	\N	\N	210525	210525	377650
28071	45755	3	applied	\N	\N	\N	\N	210526	210526	377651
28071	45752	4	applied	\N	\N	\N	\N	210527	210527	377652
28071	45753	5	applied	\N	\N	\N	\N	210528	210528	377653
28074	45756	0	applied	\N	\N	\N	\N	210660	210660	377785
28074	45757	1	applied	\N	\N	\N	\N	210661	210661	377786
28074	45758	2	applied	\N	\N	\N	\N	210662	210662	377787
28074	45759	3	applied	\N	\N	\N	\N	210663	210663	377788
28074	45761	5	applied	\N	\N	\N	\N	210665	210665	377790
28074	45762	6	applied	\N	\N	\N	\N	210666	210666	377791
28074	45763	7	applied	\N	\N	\N	\N	210667	210667	377792
28074	45764	8	applied	\N	\N	\N	\N	210668	210668	377793
28074	45765	9	applied	\N	\N	\N	\N	210669	210669	377794
28074	45766	10	applied	\N	\N	\N	\N	210670	210670	377795
28074	45767	11	applied	\N	\N	\N	\N	210671	210671	377796
28074	45768	12	applied	\N	\N	\N	\N	210672	210672	377797
28074	45769	13	applied	\N	\N	\N	\N	210673	210673	377798
28074	45770	14	applied	\N	\N	\N	\N	210674	210674	377799
28075	45756	0	applied	\N	\N	\N	\N	210675	210675	377800
28075	45757	1	applied	\N	\N	\N	\N	210676	210676	377801
28075	45758	2	applied	\N	\N	\N	\N	210677	210677	377802
28075	45759	3	applied	\N	\N	\N	\N	210678	210678	377803
28075	45760	4	applied	\N	\N	\N	\N	210679	210679	377804
28075	45761	5	applied	\N	\N	\N	\N	210680	210680	377805
28075	45763	7	applied	\N	\N	\N	\N	210682	210682	377807
28075	45764	8	applied	\N	\N	\N	\N	210683	210683	377808
28075	45765	9	applied	\N	\N	\N	\N	210684	210684	377809
28077	45761	0	applied	\N	\N	\N	\N	210700	210700	377825
28077	45762	1	applied	\N	\N	\N	\N	210701	210701	377826
28077	45763	2	applied	\N	\N	\N	\N	210702	210702	377827
28077	45764	3	applied	\N	\N	\N	\N	210703	210703	377828
28077	45765	4	applied	\N	\N	\N	\N	210704	210704	377829
28080	45756	0	applied	\N	\N	\N	\N	210725	210725	377850
28080	45757	1	applied	\N	\N	\N	\N	210726	210726	377851
28080	45758	2	applied	\N	\N	\N	\N	210727	210727	377852
28080	45759	3	applied	\N	\N	\N	\N	210728	210728	377853
28080	45760	4	applied	\N	\N	\N	\N	210729	210729	377854
28080	45771	5	applied	\N	\N	\N	\N	210730	210730	377855
28080	45772	6	applied	\N	\N	\N	\N	210731	210731	377856
28080	45773	7	applied	\N	\N	\N	\N	210732	210732	377857
28080	45775	9	applied	\N	\N	\N	\N	210734	210734	377859
28080	45776	10	applied	\N	\N	\N	\N	210735	210735	377860
28080	45766	11	applied	\N	\N	\N	\N	210736	210736	377861
28080	45767	12	applied	\N	\N	\N	\N	210737	210737	377862
28080	45768	13	applied	\N	\N	\N	\N	210738	210738	377863
28080	45769	14	applied	\N	\N	\N	\N	210739	210739	377864
28080	45770	15	applied	\N	\N	\N	\N	210740	210740	377865
28080	45777	16	applied	\N	\N	\N	\N	210741	210741	377866
28080	45778	17	applied	\N	\N	\N	\N	210742	210742	377867
28080	45779	18	applied	\N	\N	\N	\N	210743	210743	377868
28083	45783	0	applied	\N	\N	\N	\N	210766	210766	377891
28083	45784	1	applied	\N	\N	\N	\N	210767	210767	377892
28083	45785	2	applied	\N	\N	\N	\N	210768	210768	377893
28083	45786	4	applied	\N	\N	\N	\N	210769	210769	377894
28083	45787	5	applied	\N	\N	\N	\N	210770	210770	377895
28083	45788	6	applied	\N	\N	\N	\N	210771	210771	377896
28036	44748	22	applied	\N	\N	\N	\N	210307	210307	377433
28036	44878	72	applied	\N	\N	\N	\N	210356	210356	377481
28036	44881	73	applied	\N	\N	\N	\N	210357	210357	377482
28036	44884	74	applied	\N	\N	\N	\N	210358	210358	377483
28036	44885	75	applied	\N	\N	\N	\N	210359	210359	377484
28036	44892	76	applied	\N	\N	\N	\N	210360	210360	377485
28036	44895	77	applied	\N	\N	\N	\N	210361	210361	377486
28036	44898	78	applied	\N	\N	\N	\N	210362	210362	377487
28036	44901	79	applied	\N	\N	\N	\N	210363	210363	377488
28036	44904	80	applied	\N	\N	\N	\N	210364	210364	377489
28036	44907	81	applied	\N	\N	\N	\N	210365	210365	377490
28036	44909	82	applied	\N	\N	\N	\N	210366	210366	377491
28036	44912	83	applied	\N	\N	\N	\N	210367	210367	377492
28036	44916	84	applied	\N	\N	\N	\N	210368	210368	377493
28036	44922	86	applied	\N	\N	\N	\N	210370	210370	377495
28036	44923	87	applied	\N	\N	\N	\N	210371	210371	377496
28036	44928	88	applied	\N	\N	\N	\N	210372	210372	377497
28036	44931	89	applied	\N	\N	\N	\N	210373	210373	377498
28036	44934	90	applied	\N	\N	\N	\N	210374	210374	377499
28036	44936	91	applied	\N	\N	\N	\N	210375	210375	377500
28036	44938	92	applied	\N	\N	\N	\N	210376	210376	377501
28036	44939	93	applied	\N	\N	\N	\N	210377	210377	377502
28036	44940	94	applied	\N	\N	\N	\N	210378	210378	377503
28036	44944	95	applied	\N	\N	\N	\N	210379	210379	377504
28036	44841	96	applied	\N	\N	\N	\N	210380	210380	377505
28036	44732	97	applied	\N	\N	\N	\N	210381	210381	377506
28036	44945	98	applied	\N	\N	\N	\N	210382	210382	377507
28036	44946	99	applied	\N	\N	\N	\N	210383	210383	377508
28036	44947	100	applied	\N	\N	\N	\N	210384	210384	377509
28036	44952	101	applied	\N	\N	\N	\N	210385	210385	377510
28036	44956	103	applied	\N	\N	\N	\N	210387	210387	377512
28036	44962	104	applied	\N	\N	\N	\N	210388	210388	377513
28036	44963	105	applied	\N	\N	\N	\N	210389	210389	377514
28036	44966	106	applied	\N	\N	\N	\N	210390	210390	377515
28036	44967	107	applied	\N	\N	\N	\N	210391	210391	377516
28036	44968	108	applied	\N	\N	\N	\N	210392	210392	377517
28036	44972	109	applied	\N	\N	\N	\N	210393	210393	377518
28036	44974	110	applied	\N	\N	\N	\N	210394	210394	377519
28036	44975	111	applied	\N	\N	\N	\N	210395	210395	377520
28036	44978	112	applied	\N	\N	\N	\N	210396	210396	377521
28036	44980	113	applied	\N	\N	\N	\N	210397	210397	377522
28036	44982	114	applied	\N	\N	\N	\N	210398	210398	377523
28036	44984	115	applied	\N	\N	\N	\N	210399	210399	377524
28036	44987	116	applied	\N	\N	\N	\N	210400	210400	377525
28036	44988	117	applied	\N	\N	\N	\N	210401	210401	377526
28036	44991	118	applied	\N	\N	\N	\N	210402	210402	377527
28036	44995	120	applied	\N	\N	\N	\N	210404	210404	377529
28036	44996	121	applied	\N	\N	\N	\N	210405	210405	377530
28036	44997	122	applied	\N	\N	\N	\N	210406	210406	377531
28036	45001	123	applied	\N	\N	\N	\N	210407	210407	377532
28036	45003	124	applied	\N	\N	\N	\N	210408	210408	377533
28036	45005	125	applied	\N	\N	\N	\N	210409	210409	377534
28039	45699	0	applied	\N	\N	\N	\N	210416	210416	377541
28039	45700	1	applied	\N	\N	\N	\N	210417	210417	377542
28042	45703	0	applied	\N	\N	\N	\N	210424	210424	377549
28042	45704	1	applied	\N	\N	\N	\N	210425	210425	377550
28048	45713	0	applied	\N	\N	\N	\N	210437	210437	377562
28048	45714	1	applied	\N	\N	\N	\N	210438	210438	377563
28048	45715	2	applied	\N	\N	\N	\N	210439	210439	377564
28051	45716	0	applied	\N	\N	\N	\N	210451	210451	377576
28054	45716	0	applied	\N	\N	\N	\N	210457	210457	377582
28054	45717	1	applied	\N	\N	\N	\N	210458	210458	377583
28057	45722	0	applied	\N	\N	\N	\N	210466	210466	377591
28057	45723	1	applied	\N	\N	\N	\N	210467	210467	377592
28057	45724	2	applied	\N	\N	\N	\N	210468	210468	377593
28060	45722	0	applied	\N	\N	\N	\N	210475	210475	377600
28060	45723	1	applied	\N	\N	\N	\N	210476	210476	377601
28060	45724	2	applied	\N	\N	\N	\N	210477	210477	377602
28063	45728	0	applied	\N	\N	\N	\N	210484	210484	377609
28063	45729	1	applied	\N	\N	\N	\N	210485	210485	377610
28063	45730	2	applied	\N	\N	\N	\N	210486	210486	377611
28066	45740	0	applied	\N	\N	\N	\N	210499	210499	377624
28066	45741	1	applied	\N	\N	\N	\N	210500	210500	377625
28066	45742	2	applied	\N	\N	\N	\N	210501	210501	377626
28066	45743	3	applied	\N	\N	\N	\N	210502	210502	377627
28066	45744	4	applied	\N	\N	\N	\N	210503	210503	377628
28066	45745	5	applied	\N	\N	\N	\N	210504	210504	377629
28069	45746	0	applied	\N	\N	\N	\N	210515	210515	377640
28069	45748	2	applied	\N	\N	\N	\N	210517	210517	377642
28069	45749	3	applied	\N	\N	1000000000	\N	210518	210518	377643
28072	45750	0	applied	\N	\N	\N	\N	210529	210529	377654
28072	45751	1	applied	\N	\N	\N	\N	210530	210530	377655
28072	45754	2	applied	\N	\N	\N	\N	210531	210531	377656
28072	45755	3	applied	\N	\N	\N	\N	210532	210532	377657
28072	45752	4	applied	\N	\N	\N	\N	210533	210533	377658
28072	45753	5	applied	\N	\N	\N	\N	210534	210534	377659
28078	45749	0	applied	\N	\N	1000000000	\N	210705	210705	377830
28081	45756	0	applied	\N	\N	\N	\N	210744	210744	377869
28081	45757	1	applied	\N	\N	\N	\N	210745	210745	377870
28081	45758	2	applied	\N	\N	\N	\N	210746	210746	377871
28081	45759	3	applied	\N	\N	\N	\N	210747	210747	377872
28081	45760	4	applied	\N	\N	\N	\N	210748	210748	377873
28081	45771	5	applied	\N	\N	\N	\N	210749	210749	377874
28081	45772	6	applied	\N	\N	\N	\N	210750	210750	377875
28081	45774	8	applied	\N	\N	\N	\N	210752	210752	377877
28081	45775	9	applied	\N	\N	\N	\N	210753	210753	377878
28081	45776	10	applied	\N	\N	\N	\N	210754	210754	377879
28081	45766	11	applied	\N	\N	\N	\N	210755	210755	377880
28081	45767	12	applied	\N	\N	\N	\N	210756	210756	377881
28081	45768	13	applied	\N	\N	\N	\N	210757	210757	377882
28081	45769	14	applied	\N	\N	\N	\N	210758	210758	377883
28081	45770	15	applied	\N	\N	\N	\N	210759	210759	377884
28081	45777	16	applied	\N	\N	\N	\N	210760	210760	377885
28081	45778	17	applied	\N	\N	\N	\N	210761	210761	377886
28081	45779	18	applied	\N	\N	\N	\N	210762	210762	377887
28084	45793	0	applied	\N	\N	\N	\N	210776	210776	377901
28084	45794	1	applied	\N	\N	\N	\N	210777	210777	377902
28084	45795	2	applied	\N	\N	\N	\N	210778	210778	377903
28084	45796	3	applied	\N	\N	\N	\N	210779	210779	377904
28084	45797	4	applied	\N	\N	\N	\N	210780	210780	377905
28036	44872	70	applied	\N	\N	\N	\N	210354	210354	377479
28036	44875	71	applied	\N	\N	\N	\N	210355	210355	377480
28073	45024	9	applied	\N	\N	\N	\N	210544	210544	377669
28073	45027	10	applied	\N	\N	\N	\N	210545	210545	377670
28073	45029	11	applied	\N	\N	\N	\N	210546	210546	377671
28073	45031	12	applied	\N	\N	\N	\N	210547	210547	377672
28073	45033	13	applied	\N	\N	\N	\N	210548	210548	377673
28073	45035	14	applied	\N	\N	\N	\N	210549	210549	377674
28073	45037	15	applied	\N	\N	\N	\N	210550	210550	377675
28073	45038	16	applied	\N	\N	\N	\N	210551	210551	377676
28073	45039	17	applied	\N	\N	\N	\N	210552	210552	377677
28073	45040	18	applied	\N	\N	\N	\N	210553	210553	377678
28073	45041	19	applied	\N	\N	\N	\N	210554	210554	377679
28073	45047	20	applied	\N	\N	\N	\N	210555	210555	377680
28073	45049	21	applied	\N	\N	\N	\N	210556	210556	377681
28073	45051	22	applied	\N	\N	\N	\N	210557	210557	377682
28073	45053	24	applied	\N	\N	\N	\N	210558	210558	377683
28073	45055	25	applied	\N	\N	\N	\N	210559	210559	377684
28073	45059	27	applied	\N	\N	\N	\N	210561	210561	377686
28073	45060	28	applied	\N	\N	\N	\N	210562	210562	377687
28073	45063	29	applied	\N	\N	\N	\N	210563	210563	377688
28073	45064	30	applied	\N	\N	\N	\N	210564	210564	377689
28073	45065	31	applied	\N	\N	\N	\N	210565	210565	377690
28073	45070	32	applied	\N	\N	\N	\N	210566	210566	377691
28073	45072	33	applied	\N	\N	\N	\N	210567	210567	377692
28073	45073	34	applied	\N	\N	\N	\N	210568	210568	377693
28073	45076	35	applied	\N	\N	\N	\N	210569	210569	377694
28073	45078	36	applied	\N	\N	\N	\N	210570	210570	377695
28073	45079	37	applied	\N	\N	\N	\N	210571	210571	377696
28073	45083	38	applied	\N	\N	\N	\N	210572	210572	377697
28073	45084	39	applied	\N	\N	\N	\N	210573	210573	377698
28073	45085	40	applied	\N	\N	\N	\N	210574	210574	377699
28073	45089	41	applied	\N	\N	\N	\N	210575	210575	377700
28073	45090	42	applied	\N	\N	\N	\N	210576	210576	377701
28073	45094	44	applied	\N	\N	\N	\N	210578	210578	377703
28073	45097	45	applied	\N	\N	\N	\N	210579	210579	377704
28073	45099	46	applied	\N	\N	\N	\N	210580	210580	377705
28073	45100	47	applied	\N	\N	\N	\N	210581	210581	377706
28073	45104	48	applied	\N	\N	\N	\N	210582	210582	377707
28073	45106	49	applied	\N	\N	\N	\N	210583	210583	377708
28073	45109	50	applied	\N	\N	\N	\N	210584	210584	377709
28073	45112	51	applied	\N	\N	\N	\N	210585	210585	377710
28073	45113	52	applied	\N	\N	\N	\N	210586	210586	377711
28073	45118	53	applied	\N	\N	\N	\N	210587	210587	377712
28073	45121	54	applied	\N	\N	\N	\N	210588	210588	377713
28087	45793	0	applied	\N	\N	\N	\N	210794	210794	377919
28087	45794	1	applied	\N	\N	\N	\N	210795	210795	377920
28087	45795	2	applied	\N	\N	\N	\N	210796	210796	377921
28087	45796	3	applied	\N	\N	\N	\N	210797	210797	377922
28087	45797	4	applied	\N	\N	\N	\N	210798	210798	377923
28090	45799	0	applied	\N	\N	\N	\N	210808	210808	377933
28090	45800	1	applied	\N	\N	\N	\N	210809	210809	377934
28090	45801	2	applied	\N	\N	\N	\N	210810	210810	377935
28090	45802	3	applied	\N	\N	\N	\N	210811	210811	377936
28093	45803	0	applied	\N	\N	\N	\N	210818	210818	377943
28093	45804	1	applied	\N	\N	\N	\N	210819	210819	377944
28093	45805	2	applied	\N	\N	\N	\N	210820	210820	377945
28094	45803	0	applied	\N	\N	\N	\N	210821	210821	377946
28094	45804	1	applied	\N	\N	\N	\N	210822	210822	377947
28094	45805	2	applied	\N	\N	\N	\N	210823	210823	377948
28095	45806	0	applied	\N	\N	\N	\N	210824	210824	377949
28095	45807	1	applied	\N	\N	\N	\N	210825	210825	377950
28095	45808	2	applied	\N	\N	\N	\N	210826	210826	377951
28097	45809	0	applied	\N	\N	\N	\N	210831	210831	377956
28097	45810	1	applied	\N	\N	\N	\N	210832	210832	377957
28097	45811	2	applied	\N	\N	\N	\N	210833	210833	377958
28098	45813	0	applied	\N	\N	\N	\N	210835	210835	377960
28098	45814	1	applied	\N	\N	\N	\N	210836	210836	377961
28098	45815	2	applied	\N	\N	\N	\N	210837	210837	377962
28098	45816	3	applied	\N	\N	\N	\N	210838	210838	377963
28098	45817	4	applied	\N	\N	\N	\N	210839	210839	377964
28098	45818	5	applied	\N	\N	\N	\N	210840	210840	377965
28098	45819	6	applied	\N	\N	\N	\N	210841	210841	377966
28098	45820	7	applied	\N	\N	\N	\N	210842	210842	377967
28098	45821	8	applied	\N	\N	\N	\N	210843	210843	377968
28098	45822	9	applied	\N	\N	\N	\N	210844	210844	377969
28100	45813	0	applied	\N	\N	\N	\N	210855	210855	377980
28100	45814	1	applied	\N	\N	\N	\N	210856	210856	377981
28100	45815	2	applied	\N	\N	\N	\N	210857	210857	377982
28100	45816	3	applied	\N	\N	\N	\N	210858	210858	377983
28100	45817	4	applied	\N	\N	\N	\N	210859	210859	377984
28100	45818	5	applied	\N	\N	\N	\N	210860	210860	377985
28100	45820	7	applied	\N	\N	\N	\N	210862	210862	377987
28100	45821	8	applied	\N	\N	\N	\N	210863	210863	377988
28100	45822	9	applied	\N	\N	\N	\N	210864	210864	377989
28101	45823	0	applied	\N	\N	\N	\N	210865	210865	377990
28101	45824	1	applied	\N	\N	\N	\N	210866	210866	377991
28101	45825	2	applied	\N	\N	\N	\N	210867	210867	377992
28104	45423	0	applied	\N	\N	\N	\N	210874	210874	377999
28104	45447	1	applied	\N	\N	\N	\N	210875	210875	378000
28104	45209	2	applied	\N	\N	\N	\N	210876	210876	378001
28104	45212	3	applied	\N	\N	\N	\N	210877	210877	378002
28104	45215	4	applied	\N	\N	\N	\N	210878	210878	378003
28104	45216	5	applied	\N	\N	\N	\N	210879	210879	378004
28104	45221	6	applied	\N	\N	\N	\N	210880	210880	378005
28104	45224	7	applied	\N	\N	\N	\N	210881	210881	378006
28104	45225	8	applied	\N	\N	\N	\N	210882	210882	378007
28104	45226	9	applied	\N	\N	\N	\N	210883	210883	378008
28104	45234	11	applied	\N	\N	\N	\N	210885	210885	378010
28104	45239	12	applied	\N	\N	\N	\N	210886	210886	378011
28104	45242	13	applied	\N	\N	\N	\N	210887	210887	378012
28104	45245	14	applied	\N	\N	\N	\N	210888	210888	378013
28104	45248	15	applied	\N	\N	\N	\N	210889	210889	378014
28104	45251	16	applied	\N	\N	\N	\N	210890	210890	378015
28104	45254	17	applied	\N	\N	\N	\N	210891	210891	378016
28104	45255	18	applied	\N	\N	\N	\N	210892	210892	378017
28104	45260	19	applied	\N	\N	\N	\N	210893	210893	378018
28104	45263	20	applied	\N	\N	\N	\N	210894	210894	378019
28104	45264	21	applied	\N	\N	\N	\N	210895	210895	378020
28104	45269	22	applied	\N	\N	\N	\N	210896	210896	378021
28104	45272	23	applied	\N	\N	\N	\N	210897	210897	378022
28104	45275	24	applied	\N	\N	\N	\N	210898	210898	378023
28073	45013	6	applied	\N	\N	\N	\N	210541	210541	377666
28073	45021	7	applied	\N	\N	\N	\N	210542	210542	377667
28073	45135	59	applied	\N	\N	\N	\N	210593	210593	377718
28073	45140	60	applied	\N	\N	\N	\N	210594	210594	377719
28073	45141	61	applied	\N	\N	\N	\N	210595	210595	377720
28073	45146	62	applied	\N	\N	\N	\N	210596	210596	377721
28073	45149	63	applied	\N	\N	\N	\N	210597	210597	377722
28073	45150	64	applied	\N	\N	\N	\N	210598	210598	377723
28073	45155	65	applied	\N	\N	\N	\N	210599	210599	377724
28073	45158	66	applied	\N	\N	\N	\N	210600	210600	377725
28073	45159	67	applied	\N	\N	\N	\N	210601	210601	377726
28073	45164	68	applied	\N	\N	\N	\N	210602	210602	377727
28073	45167	69	applied	\N	\N	\N	\N	210603	210603	377728
28073	45170	70	applied	\N	\N	\N	\N	210604	210604	377729
28073	45173	71	applied	\N	\N	\N	\N	210605	210605	377730
28073	45176	72	applied	\N	\N	\N	\N	210606	210606	377731
28073	45179	73	applied	\N	\N	\N	\N	210607	210607	377732
28073	45182	74	applied	\N	\N	\N	\N	210608	210608	377733
28073	45188	76	applied	\N	\N	\N	\N	210610	210610	377735
28073	45191	77	applied	\N	\N	\N	\N	210611	210611	377736
28073	45192	78	applied	\N	\N	\N	\N	210612	210612	377737
28073	45193	79	applied	\N	\N	\N	\N	210613	210613	377738
28073	45194	80	applied	\N	\N	\N	\N	210614	210614	377739
28073	45203	81	applied	\N	\N	\N	\N	210615	210615	377740
28073	45206	82	applied	\N	\N	\N	\N	210616	210616	377741
28073	45209	83	applied	\N	\N	\N	\N	210617	210617	377742
28073	45212	84	applied	\N	\N	\N	\N	210618	210618	377743
28073	45215	85	applied	\N	\N	\N	\N	210619	210619	377744
28073	45216	86	applied	\N	\N	\N	\N	210620	210620	377745
28073	45221	87	applied	\N	\N	\N	\N	210621	210621	377746
28073	45224	88	applied	\N	\N	\N	\N	210622	210622	377747
28073	45225	89	applied	\N	\N	\N	\N	210623	210623	377748
28073	45226	90	applied	\N	\N	\N	\N	210624	210624	377749
28073	45233	91	applied	\N	\N	\N	\N	210625	210625	377750
28073	45239	93	applied	\N	\N	\N	\N	210627	210627	377752
28073	45242	94	applied	\N	\N	\N	\N	210628	210628	377753
28073	45245	95	applied	\N	\N	\N	\N	210629	210629	377754
28073	45248	96	applied	\N	\N	\N	\N	210630	210630	377755
28073	45251	97	applied	\N	\N	\N	\N	210631	210631	377756
28073	45254	98	applied	\N	\N	\N	\N	210632	210632	377757
28073	45255	99	applied	\N	\N	\N	\N	210633	210633	377758
28073	45260	100	applied	\N	\N	\N	\N	210634	210634	377759
28073	45263	101	applied	\N	\N	\N	\N	210635	210635	377760
28073	45264	102	applied	\N	\N	\N	\N	210636	210636	377761
28073	45269	103	applied	\N	\N	\N	\N	210637	210637	377762
28073	45272	104	applied	\N	\N	\N	\N	210638	210638	377763
28073	45275	105	applied	\N	\N	\N	\N	210639	210639	377764
28073	45278	106	applied	\N	\N	\N	\N	210640	210640	377765
28073	45281	107	applied	\N	\N	\N	\N	210641	210641	377766
28073	45285	108	applied	\N	\N	\N	\N	210642	210642	377767
28073	45292	110	applied	\N	\N	\N	\N	210644	210644	377769
28073	45295	111	applied	\N	\N	\N	\N	210645	210645	377770
28073	45298	112	applied	\N	\N	\N	\N	210646	210646	377771
28073	45301	113	applied	\N	\N	\N	\N	210647	210647	377772
28073	45304	114	applied	\N	\N	\N	\N	210648	210648	377773
28073	45307	115	applied	\N	\N	\N	\N	210649	210649	377774
28073	45310	116	applied	\N	\N	\N	\N	210650	210650	377775
28073	45311	117	applied	\N	\N	\N	\N	210651	210651	377776
28073	45318	118	applied	\N	\N	\N	\N	210652	210652	377777
28073	45321	119	applied	\N	\N	\N	\N	210653	210653	377778
28073	45322	120	applied	\N	\N	\N	\N	210654	210654	377779
28073	45323	121	applied	\N	\N	\N	\N	210655	210655	377780
28073	45330	122	applied	\N	\N	\N	\N	210656	210656	377781
28073	45333	123	applied	\N	\N	\N	\N	210657	210657	377782
28073	45334	124	applied	\N	\N	\N	\N	210658	210658	377783
28073	45335	125	applied	\N	\N	\N	\N	210659	210659	377784
28076	45757	1	applied	\N	\N	\N	\N	210686	210686	377811
28076	45758	2	applied	\N	\N	\N	\N	210687	210687	377812
28076	45759	3	applied	\N	\N	\N	\N	210688	210688	377813
28076	45760	4	applied	\N	\N	\N	\N	210689	210689	377814
28076	45761	5	applied	\N	\N	\N	\N	210690	210690	377815
28076	45762	6	applied	\N	\N	\N	\N	210691	210691	377816
28076	45763	7	applied	\N	\N	\N	\N	210692	210692	377817
28076	45764	8	applied	\N	\N	\N	\N	210693	210693	377818
28076	45765	9	applied	\N	\N	\N	\N	210694	210694	377819
28076	45766	10	applied	\N	\N	\N	\N	210695	210695	377820
28076	45767	11	applied	\N	\N	\N	\N	210696	210696	377821
28076	45768	12	applied	\N	\N	\N	\N	210697	210697	377822
28076	45769	13	applied	\N	\N	\N	\N	210698	210698	377823
28076	45770	14	applied	\N	\N	\N	\N	210699	210699	377824
28079	45756	0	applied	\N	\N	\N	\N	210706	210706	377831
28079	45757	1	applied	\N	\N	\N	\N	210707	210707	377832
28079	45759	3	applied	\N	\N	\N	\N	210709	210709	377834
28079	45760	4	applied	\N	\N	\N	\N	210710	210710	377835
28079	45771	5	applied	\N	\N	\N	\N	210711	210711	377836
28079	45772	6	applied	\N	\N	\N	\N	210712	210712	377837
28079	45773	7	applied	\N	\N	\N	\N	210713	210713	377838
28079	45774	8	applied	\N	\N	\N	\N	210714	210714	377839
28079	45775	9	applied	\N	\N	\N	\N	210715	210715	377840
28079	45776	10	applied	\N	\N	\N	\N	210716	210716	377841
28079	45766	11	applied	\N	\N	\N	\N	210717	210717	377842
28079	45767	12	applied	\N	\N	\N	\N	210718	210718	377843
28079	45768	13	applied	\N	\N	\N	\N	210719	210719	377844
28079	45769	14	applied	\N	\N	\N	\N	210720	210720	377845
28079	45770	15	applied	\N	\N	\N	\N	210721	210721	377846
28079	45777	16	applied	\N	\N	\N	\N	210722	210722	377847
28079	45778	17	applied	\N	\N	\N	\N	210723	210723	377848
28079	45779	18	applied	\N	\N	\N	\N	210724	210724	377849
28082	45781	1	applied	\N	\N	\N	\N	210764	210764	377889
28082	45782	2	applied	\N	\N	\N	\N	210765	210765	377890
28085	45793	0	applied	\N	\N	\N	\N	210782	210782	377907
28085	45794	1	applied	\N	\N	\N	\N	210783	210783	377908
28085	45795	2	applied	\N	\N	\N	\N	210784	210784	377909
28085	45796	3	applied	\N	\N	\N	\N	210785	210785	377910
28085	45797	4	applied	\N	\N	\N	\N	210786	210786	377911
28085	45798	5	applied	\N	\N	\N	\N	210787	210787	377912
28088	45799	0	applied	\N	\N	\N	\N	210800	210800	377925
28088	45800	1	applied	\N	\N	\N	\N	210801	210801	377926
28088	45801	2	applied	\N	\N	\N	\N	210802	210802	377927
28088	45802	3	applied	\N	\N	\N	\N	210803	210803	377928
28091	45803	0	applied	\N	\N	\N	\N	210812	210812	377937
28091	45804	1	applied	\N	\N	\N	\N	210813	210813	377938
28073	45128	56	applied	\N	\N	\N	\N	210590	210590	377715
28073	45129	57	applied	\N	\N	\N	\N	210591	210591	377716
28083	45792	10	applied	\N	\N	\N	\N	210775	210775	377900
28086	45793	0	applied	\N	\N	\N	\N	210788	210788	377913
28086	45794	1	applied	\N	\N	\N	\N	210789	210789	377914
28086	45795	2	applied	\N	\N	\N	\N	210790	210790	377915
28086	45796	3	applied	\N	\N	\N	\N	210791	210791	377916
28086	45798	5	applied	\N	\N	\N	\N	210793	210793	377918
28089	45799	0	applied	\N	\N	\N	\N	210804	210804	377929
28089	45800	1	applied	\N	\N	\N	\N	210805	210805	377930
28089	45801	2	applied	\N	\N	\N	\N	210806	210806	377931
28089	45802	3	applied	\N	\N	\N	\N	210807	210807	377932
28091	45805	2	applied	\N	\N	\N	\N	210814	210814	377939
28092	45803	0	applied	\N	\N	\N	\N	210815	210815	377940
28092	45804	1	applied	\N	\N	\N	\N	210816	210816	377941
28092	45805	2	applied	\N	\N	\N	\N	210817	210817	377942
28096	45809	0	applied	\N	\N	\N	\N	210827	210827	377952
28096	45810	1	applied	\N	\N	\N	\N	210828	210828	377953
28096	45811	2	applied	\N	\N	\N	\N	210829	210829	377954
28096	45812	3	applied	\N	\N	\N	\N	210830	210830	377955
28099	45813	0	applied	\N	\N	\N	\N	210845	210845	377970
28099	45814	1	applied	\N	\N	\N	\N	210846	210846	377971
28099	45815	2	applied	\N	\N	\N	\N	210847	210847	377972
28099	45817	4	applied	\N	\N	\N	\N	210849	210849	377974
28099	45818	5	applied	\N	\N	\N	\N	210850	210850	377975
28099	45819	6	applied	\N	\N	\N	\N	210851	210851	377976
28099	45820	7	applied	\N	\N	\N	\N	210852	210852	377977
28099	45821	8	applied	\N	\N	\N	\N	210853	210853	377978
28099	45822	9	applied	\N	\N	\N	\N	210854	210854	377979
28102	45823	0	applied	\N	\N	\N	\N	210868	210868	377993
28102	45824	1	applied	\N	\N	\N	\N	210869	210869	377994
28102	45825	2	applied	\N	\N	\N	\N	210870	210870	377995
28103	45826	0	applied	\N	\N	\N	\N	210871	210871	377996
28103	45827	1	applied	\N	\N	\N	\N	210872	210872	377997
28103	45828	2	applied	\N	\N	\N	\N	210873	210873	377998
28105	45829	0	applied	\N	\N	\N	\N	210999	210999	378124
28105	45830	1	applied	\N	\N	\N	\N	211000	211000	378125
28105	45831	2	applied	\N	\N	\N	\N	211001	211001	378126
28105	45832	3	applied	\N	\N	\N	\N	211002	211002	378127
28105	45834	5	applied	\N	\N	\N	\N	211004	211004	378129
28105	45835	6	applied	\N	\N	\N	\N	211005	211005	378130
28108	45836	0	applied	\N	\N	\N	\N	211016	211016	378141
28108	45837	1	applied	\N	\N	\N	\N	211017	211017	378142
28108	45838	2	applied	\N	\N	\N	\N	211018	211018	378143
28109	45836	0	applied	\N	\N	\N	\N	211019	211019	378144
28109	45837	1	applied	\N	\N	\N	\N	211020	211020	378145
28109	45838	2	applied	\N	\N	\N	\N	211021	211021	378146
28111	45839	0	applied	\N	\N	\N	\N	211029	211029	378154
28111	45840	1	applied	\N	\N	\N	\N	211030	211030	378155
28111	45841	2	applied	\N	\N	\N	\N	211031	211031	378156
28111	45842	3	applied	\N	\N	\N	\N	211032	211032	378157
28111	45843	4	applied	\N	\N	\N	\N	211033	211033	378158
28111	45844	5	applied	\N	\N	\N	\N	211034	211034	378159
28111	45845	6	applied	\N	\N	\N	\N	211035	211035	378160
28112	45846	0	applied	\N	\N	\N	\N	211036	211036	378161
28112	45848	2	applied	\N	\N	\N	\N	211038	211038	378163
28112	45849	3	applied	\N	\N	\N	\N	211039	211039	378164
28114	45850	0	applied	\N	\N	\N	\N	211047	211047	378172
28114	45851	1	applied	\N	\N	\N	\N	211048	211048	378173
28114	45852	2	applied	\N	\N	\N	\N	211049	211049	378174
28114	45853	3	applied	\N	\N	\N	\N	211050	211050	378175
28114	45854	4	applied	\N	\N	\N	\N	211051	211051	378176
28114	45855	5	applied	\N	\N	\N	\N	211052	211052	378177
28114	45856	6	applied	\N	\N	\N	\N	211053	211053	378178
28115	45857	0	applied	\N	\N	\N	\N	211054	211054	378179
28115	45858	1	applied	\N	\N	\N	\N	211055	211055	378180
28115	45859	2	applied	\N	\N	\N	\N	211056	211056	378181
28115	45860	3	applied	\N	\N	\N	\N	211057	211057	378182
28115	45861	4	applied	\N	\N	\N	\N	211058	211058	378183
28115	45862	5	applied	\N	\N	\N	\N	211059	211059	378184
28117	45863	0	applied	\N	\N	\N	\N	211063	211063	378188
28117	45864	1	applied	\N	\N	\N	\N	211064	211064	378189
28117	45865	2	applied	\N	\N	\N	\N	211065	211065	378190
28118	45867	1	applied	\N	\N	\N	\N	211067	211067	378192
28118	45868	2	applied	\N	\N	\N	\N	211068	211068	378193
28118	45869	3	applied	\N	\N	\N	\N	211069	211069	378194
28120	45873	0	applied	\N	\N	\N	\N	211073	211073	378198
28120	45874	1	applied	\N	\N	\N	\N	211074	211074	378199
28120	45875	2	applied	\N	\N	\N	\N	211075	211075	378200
28120	45876	3	applied	\N	\N	\N	\N	211076	211076	378201
28120	45877	5	applied	\N	\N	\N	\N	211077	211077	378202
28121	45878	0	applied	\N	\N	\N	\N	211078	211078	378203
28121	45879	1	applied	\N	\N	\N	\N	211079	211079	378204
28122	45878	0	applied	\N	\N	\N	\N	211080	211080	378205
28122	45879	1	applied	\N	\N	\N	\N	211081	211081	378206
28123	45878	0	applied	\N	\N	\N	\N	211082	211082	378207
28123	45879	1	applied	\N	\N	\N	\N	211083	211083	378208
28124	45878	0	applied	\N	\N	\N	\N	211084	211084	378209
28124	45879	1	applied	\N	\N	\N	\N	211085	211085	378210
28125	45879	1	applied	\N	\N	\N	\N	211087	211087	378212
28126	45878	0	applied	\N	\N	\N	\N	211088	211088	378213
28126	45879	1	applied	\N	\N	\N	\N	211089	211089	378214
28127	45880	0	applied	\N	\N	\N	\N	211090	211090	378215
28127	45881	1	applied	\N	\N	\N	\N	211091	211091	378216
28129	45880	0	applied	\N	\N	\N	\N	211093	211093	378218
28130	45880	0	applied	\N	\N	\N	\N	211094	211094	378219
28132	45883	0	applied	\N	\N	\N	\N	211097	211097	378222
28132	45881	1	applied	\N	\N	\N	\N	211098	211098	378223
28132	45882	2	applied	\N	\N	\N	\N	211099	211099	378224
28133	45884	0	applied	\N	\N	\N	\N	211100	211100	378225
28133	45885	1	applied	\N	\N	1000000000	\N	211101	211101	378226
28133	45886	2	applied	\N	\N	\N	\N	211102	211102	378227
28134	45884	0	applied	\N	\N	\N	\N	211103	211103	378228
28134	45886	2	applied	\N	\N	\N	\N	211105	211105	378230
28135	45884	0	applied	\N	\N	\N	\N	211106	211106	378231
28135	45885	1	applied	\N	\N	1000000000	\N	211107	211107	378232
28135	45886	2	applied	\N	\N	\N	\N	211108	211108	378233
28136	45887	0	applied	\N	\N	\N	\N	211109	211109	378234
28136	45888	1	applied	\N	\N	\N	\N	211110	211110	378235
28136	45889	2	applied	\N	\N	1000000000	\N	211111	211111	378236
28136	45890	3	applied	\N	\N	1000000000	\N	211112	211112	378237
28083	45790	8	applied	\N	\N	\N	\N	210773	210773	377898
28083	45791	9	applied	\N	\N	\N	\N	210774	210774	377899
28104	45292	29	applied	\N	\N	\N	\N	210903	210903	378028
28104	45295	30	applied	\N	\N	\N	\N	210904	210904	378029
28104	45298	31	applied	\N	\N	\N	\N	210905	210905	378030
28104	45301	32	applied	\N	\N	\N	\N	210906	210906	378031
28104	45304	33	applied	\N	\N	\N	\N	210907	210907	378032
28104	45307	34	applied	\N	\N	\N	\N	210908	210908	378033
28104	45310	35	applied	\N	\N	\N	\N	210909	210909	378034
28104	45311	36	applied	\N	\N	\N	\N	210910	210910	378035
28104	45318	37	applied	\N	\N	\N	\N	210911	210911	378036
28104	45321	38	applied	\N	\N	\N	\N	210912	210912	378037
28104	45322	39	applied	\N	\N	\N	\N	210913	210913	378038
28104	45323	40	applied	\N	\N	\N	\N	210914	210914	378039
28104	45330	41	applied	\N	\N	\N	\N	210915	210915	378040
28104	45333	42	applied	\N	\N	\N	\N	210916	210916	378041
28104	45334	43	applied	\N	\N	\N	\N	210917	210917	378042
28104	45335	44	applied	\N	\N	\N	\N	210918	210918	378043
28104	45345	46	applied	\N	\N	\N	\N	210920	210920	378045
28104	45348	47	applied	\N	\N	\N	\N	210921	210921	378046
28104	45351	48	applied	\N	\N	\N	\N	210922	210922	378047
28104	45354	49	applied	\N	\N	\N	\N	210923	210923	378048
28104	45355	50	applied	\N	\N	\N	\N	210924	210924	378049
28104	45361	51	applied	\N	\N	\N	\N	210925	210925	378050
28104	45364	52	applied	\N	\N	\N	\N	210926	210926	378051
28104	45367	53	applied	\N	\N	\N	\N	210927	210927	378052
28104	45368	54	applied	\N	\N	\N	\N	210928	210928	378053
28104	45373	55	applied	\N	\N	\N	\N	210929	210929	378054
28104	45376	56	applied	\N	\N	\N	\N	210930	210930	378055
28104	45379	57	applied	\N	\N	\N	\N	210931	210931	378056
28104	45382	58	applied	\N	\N	\N	\N	210932	210932	378057
28104	45383	59	applied	\N	\N	\N	\N	210933	210933	378058
28104	45384	60	applied	\N	\N	\N	\N	210934	210934	378059
28104	45385	61	applied	\N	\N	\N	\N	210935	210935	378060
28104	45401	64	applied	\N	\N	\N	\N	210937	210937	378062
28104	45404	65	applied	\N	\N	\N	\N	210938	210938	378063
28104	45405	66	applied	\N	\N	\N	\N	210939	210939	378064
28104	45410	67	applied	\N	\N	\N	\N	210940	210940	378065
28104	45413	68	applied	\N	\N	\N	\N	210941	210941	378066
28104	45414	69	applied	\N	\N	\N	\N	210942	210942	378067
28104	45419	70	applied	\N	\N	\N	\N	210943	210943	378068
28104	45422	71	applied	\N	\N	\N	\N	210944	210944	378069
28104	45425	72	applied	\N	\N	\N	\N	210945	210945	378070
28104	45426	73	applied	\N	\N	\N	\N	210946	210946	378071
28104	45431	74	applied	\N	\N	\N	\N	210947	210947	378072
28104	45434	75	applied	\N	\N	\N	\N	210948	210948	378073
28138	45893	0	applied	\N	\N	\N	\N	211115	211115	378240
28138	45894	1	applied	\N	\N	\N	\N	211116	211116	378241
28138	45895	2	applied	\N	\N	\N	\N	211117	211117	378242
28142	45898	0	applied	\N	\N	\N	\N	211124	211124	378249
28144	45906	0	applied	\N	\N	\N	\N	211132	211132	378257
28144	45907	1	applied	\N	\N	\N	\N	211133	211133	378258
28149	45915	0	applied	\N	\N	\N	\N	211159	211159	378284
28149	45916	1	applied	\N	\N	\N	\N	211160	211160	378285
28152	45924	0	applied	\N	\N	\N	\N	211168	211168	378293
28152	45925	1	applied	\N	\N	\N	\N	211169	211169	378294
28152	45926	2	applied	\N	\N	\N	\N	211170	211170	378295
28152	45927	3	applied	\N	\N	\N	\N	211171	211171	378296
28152	45928	4	applied	\N	\N	\N	\N	211172	211172	378297
28155	45932	0	applied	\N	\N	\N	\N	211178	211178	378303
28155	45933	1	applied	\N	\N	\N	\N	211179	211179	378304
28155	45931	2	applied	\N	\N	\N	\N	211180	211180	378305
28158	45948	0	applied	\N	\N	\N	\N	211195	211195	378320
28158	45949	1	applied	\N	\N	\N	\N	211196	211196	378321
28158	45950	2	applied	\N	\N	\N	\N	211197	211197	378322
28158	45951	3	applied	\N	\N	\N	\N	211198	211198	378323
28158	45953	5	applied	\N	\N	\N	\N	211200	211200	378325
28158	45954	6	applied	\N	\N	\N	\N	211201	211201	378326
28160	45948	0	applied	\N	\N	\N	\N	211209	211209	378334
28160	45949	1	applied	\N	\N	\N	\N	211210	211210	378335
28160	45950	2	applied	\N	\N	\N	\N	211211	211211	378336
28160	45951	3	applied	\N	\N	\N	\N	211212	211212	378337
28160	45952	4	applied	\N	\N	\N	\N	211213	211213	378338
28160	45953	5	applied	\N	\N	\N	\N	211214	211214	378339
28160	45954	6	applied	\N	\N	\N	\N	211215	211215	378340
28163	45948	0	applied	\N	\N	\N	\N	211230	211230	378355
28163	45949	1	applied	\N	\N	\N	\N	211231	211231	378356
28163	45950	2	applied	\N	\N	\N	\N	211232	211232	378357
28163	45951	3	applied	\N	\N	\N	\N	211233	211233	378358
28163	45952	4	applied	\N	\N	\N	\N	211234	211234	378359
28163	45953	5	applied	\N	\N	\N	\N	211235	211235	378360
28163	45954	6	applied	\N	\N	\N	\N	211236	211236	378361
28164	45956	2	applied	\N	\N	\N	\N	211238	211238	378363
28164	45957	3	applied	\N	\N	\N	\N	211239	211239	378364
28166	45958	0	applied	\N	\N	\N	\N	211242	211242	378367
28166	45959	1	applied	\N	\N	\N	\N	211243	211243	378368
28172	45960	0	applied	\N	\N	\N	\N	211279	211279	378404
28172	45961	1	applied	\N	\N	\N	\N	211280	211280	378405
28172	45962	2	applied	\N	\N	\N	\N	211281	211281	378406
28172	45963	3	applied	\N	\N	\N	\N	211282	211282	378407
28172	45964	4	applied	\N	\N	\N	\N	211283	211283	378408
28172	45965	5	applied	\N	\N	\N	\N	211284	211284	378409
28172	45966	6	applied	\N	\N	\N	\N	211285	211285	378410
28174	45967	0	applied	\N	\N	\N	\N	211293	211293	378418
28174	45968	1	applied	\N	\N	\N	\N	211294	211294	378419
28177	45967	0	applied	\N	\N	\N	\N	211299	211299	378424
28177	45968	1	applied	\N	\N	\N	\N	211300	211300	378425
28179	45967	0	applied	\N	\N	\N	\N	211303	211303	378428
28181	45975	0	applied	\N	\N	\N	\N	211311	211311	378436
28181	45976	1	applied	\N	\N	\N	\N	211312	211312	378437
28185	45977	0	applied	\N	\N	\N	\N	211322	211322	378447
28185	45978	1	applied	\N	\N	\N	\N	211323	211323	378448
28185	45979	2	applied	\N	\N	\N	\N	211324	211324	378449
28188	45982	0	applied	\N	\N	\N	\N	211330	211330	378455
28188	45983	1	applied	\N	\N	\N	\N	211331	211331	378456
28195	45993	0	applied	\N	\N	\N	\N	211350	211350	378475
28195	45994	1	applied	\N	\N	\N	\N	211351	211351	378476
28195	45995	2	applied	\N	\N	\N	\N	211352	211352	378477
28198	46000	0	applied	\N	\N	\N	\N	211357	211357	378482
28198	46001	1	applied	\N	\N	\N	\N	211358	211358	378483
28198	46002	2	applied	\N	\N	\N	\N	211359	211359	378484
28200	46003	0	applied	\N	\N	\N	\N	211363	211363	378488
28104	45281	26	applied	\N	\N	\N	\N	210900	210900	378025
28104	45285	27	applied	\N	\N	\N	\N	210901	210901	378026
28104	45450	80	applied	\N	\N	\N	\N	210953	210953	378078
28104	45453	81	applied	\N	\N	\N	\N	210954	210954	378079
28104	45456	82	applied	\N	\N	\N	\N	210955	210955	378080
28104	45457	83	applied	\N	\N	\N	\N	210956	210956	378081
28104	45458	84	applied	\N	\N	\N	\N	210957	210957	378082
28104	45465	85	applied	\N	\N	\N	\N	210958	210958	378083
28104	45468	86	applied	\N	\N	\N	\N	210959	210959	378084
28104	45469	87	applied	\N	\N	\N	\N	210960	210960	378085
28104	45475	88	applied	\N	\N	\N	\N	210961	210961	378086
28104	45476	89	applied	\N	\N	\N	\N	210962	210962	378087
28104	45481	90	applied	\N	\N	\N	\N	210963	210963	378088
28104	45484	91	applied	\N	\N	\N	\N	210964	210964	378089
28104	45487	92	applied	\N	\N	\N	\N	210965	210965	378090
28104	45491	93	applied	\N	\N	\N	\N	210966	210966	378091
28104	45492	94	applied	\N	\N	\N	\N	210967	210967	378092
28104	45497	95	applied	\N	\N	\N	\N	210968	210968	378093
28104	45499	97	applied	\N	\N	\N	\N	210970	210970	378095
28104	45506	98	applied	\N	\N	\N	\N	210971	210971	378096
28104	45509	99	applied	\N	\N	\N	\N	210972	210972	378097
28104	45510	100	applied	\N	\N	\N	\N	210973	210973	378098
28104	45515	101	applied	\N	\N	\N	\N	210974	210974	378099
28104	45516	102	applied	\N	\N	\N	\N	210975	210975	378100
28104	45521	103	applied	\N	\N	\N	\N	210976	210976	378101
28104	45522	104	applied	\N	\N	\N	\N	210977	210977	378102
28104	45527	105	applied	\N	\N	\N	\N	210978	210978	378103
28104	45528	106	applied	\N	\N	\N	\N	210979	210979	378104
28104	45533	107	applied	\N	\N	\N	\N	210980	210980	378105
28104	45536	108	applied	\N	\N	\N	\N	210981	210981	378106
28104	45537	109	applied	\N	\N	\N	\N	210982	210982	378107
28104	45542	110	applied	\N	\N	\N	\N	210983	210983	378108
28104	45543	111	applied	\N	\N	\N	\N	210984	210984	378109
28104	45544	112	applied	\N	\N	\N	\N	210985	210985	378110
28104	45552	114	applied	\N	\N	\N	\N	210987	210987	378112
28104	45555	115	applied	\N	\N	\N	\N	210988	210988	378113
28104	45556	116	applied	\N	\N	\N	\N	210989	210989	378114
28104	45557	117	applied	\N	\N	\N	\N	210990	210990	378115
28104	45566	118	applied	\N	\N	\N	\N	210991	210991	378116
28104	45569	119	applied	\N	\N	\N	\N	210992	210992	378117
28104	45572	120	applied	\N	\N	\N	\N	210993	210993	378118
28104	45573	121	applied	\N	\N	\N	\N	210994	210994	378119
28104	45580	122	applied	\N	\N	\N	\N	210995	210995	378120
28104	45583	123	applied	\N	\N	\N	\N	210996	210996	378121
28104	45586	124	applied	\N	\N	\N	\N	210997	210997	378122
28104	45587	125	applied	\N	\N	\N	\N	210998	210998	378123
28106	45829	0	applied	\N	\N	\N	\N	211006	211006	378131
28106	45830	1	applied	\N	\N	\N	\N	211007	211007	378132
28106	45831	2	applied	\N	\N	\N	\N	211008	211008	378133
28106	45832	3	applied	\N	\N	\N	\N	211009	211009	378134
28106	45834	5	applied	\N	\N	\N	\N	211011	211011	378136
28106	45835	6	applied	\N	\N	\N	\N	211012	211012	378137
28107	45836	0	applied	\N	\N	\N	\N	211013	211013	378138
28107	45837	1	applied	\N	\N	\N	\N	211014	211014	378139
28107	45838	2	applied	\N	\N	\N	\N	211015	211015	378140
28110	45839	0	applied	\N	\N	\N	\N	211022	211022	378147
28110	45840	1	applied	\N	\N	\N	\N	211023	211023	378148
28110	45841	2	applied	\N	\N	\N	\N	211024	211024	378149
28110	45842	3	applied	\N	\N	\N	\N	211025	211025	378150
28110	45843	4	applied	\N	\N	\N	\N	211026	211026	378151
28110	45844	5	applied	\N	\N	\N	\N	211027	211027	378152
28110	45845	6	applied	\N	\N	\N	\N	211028	211028	378153
28113	45850	0	applied	\N	\N	\N	\N	211040	211040	378165
28113	45851	1	applied	\N	\N	\N	\N	211041	211041	378166
28113	45852	2	applied	\N	\N	\N	\N	211042	211042	378167
28113	45853	3	applied	\N	\N	\N	\N	211043	211043	378168
28113	45855	5	applied	\N	\N	\N	\N	211045	211045	378170
28113	45856	6	applied	\N	\N	\N	\N	211046	211046	378171
28116	45863	0	applied	\N	\N	\N	\N	211060	211060	378185
28116	45864	1	applied	\N	\N	\N	\N	211061	211061	378186
28116	45865	2	applied	\N	\N	\N	\N	211062	211062	378187
28119	45870	0	applied	\N	\N	\N	\N	211070	211070	378195
28119	45871	1	applied	\N	\N	\N	\N	211071	211071	378196
28119	45872	2	applied	\N	\N	\N	\N	211072	211072	378197
28128	45880	0	applied	\N	\N	\N	\N	211092	211092	378217
28131	45881	0	applied	\N	\N	\N	\N	211095	211095	378220
28131	45882	1	applied	\N	\N	\N	\N	211096	211096	378221
28137	45891	0	applied	\N	\N	\N	\N	211113	211113	378238
28137	45892	1	applied	\N	\N	\N	\N	211114	211114	378239
28140	45898	0	applied	\N	\N	\N	\N	211120	211120	378245
28140	45899	1	applied	\N	\N	\N	\N	211121	211121	378246
28143	45900	0	applied	\N	\N	\N	\N	211126	211126	378251
28143	45902	2	applied	\N	\N	\N	\N	211128	211128	378253
28143	45903	3	applied	\N	\N	\N	\N	211129	211129	378254
28143	45904	4	applied	\N	\N	\N	\N	211130	211130	378255
28143	45905	5	applied	\N	\N	\N	\N	211131	211131	378256
28148	45913	0	applied	\N	\N	\N	\N	211157	211157	378282
28148	45914	1	applied	\N	\N	\N	\N	211158	211158	378283
28151	45922	0	applied	\N	\N	\N	\N	211166	211166	378291
28151	45923	1	applied	\N	\N	\N	\N	211167	211167	378292
28154	45919	0	applied	\N	\N	\N	\N	211175	211175	378300
28154	45927	1	applied	\N	\N	\N	\N	211176	211176	378301
28154	45931	2	applied	\N	\N	\N	\N	211177	211177	378302
28157	45944	0	applied	\N	\N	\N	\N	211191	211191	378316
28157	45945	1	applied	\N	\N	\N	\N	211192	211192	378317
28157	45946	2	applied	\N	\N	\N	\N	211193	211193	378318
28157	45947	3	applied	\N	\N	\N	\N	211194	211194	378319
28159	45948	0	applied	\N	\N	\N	\N	211202	211202	378327
28159	45950	2	applied	\N	\N	\N	\N	211204	211204	378329
28159	45951	3	applied	\N	\N	\N	\N	211205	211205	378330
28159	45952	4	applied	\N	\N	\N	\N	211206	211206	378331
28159	45953	5	applied	\N	\N	\N	\N	211207	211207	378332
28159	45954	6	applied	\N	\N	\N	\N	211208	211208	378333
28161	45948	0	applied	\N	\N	\N	\N	211216	211216	378341
28161	45949	1	applied	\N	\N	\N	\N	211217	211217	378342
28161	45950	2	applied	\N	\N	\N	\N	211218	211218	378343
28161	45951	3	applied	\N	\N	\N	\N	211219	211219	378344
28161	45952	4	applied	\N	\N	\N	\N	211220	211220	378345
28161	45953	5	applied	\N	\N	\N	\N	211221	211221	378346
28161	45954	6	applied	\N	\N	\N	\N	211222	211222	378347
28162	45948	0	applied	\N	\N	\N	\N	211223	211223	378348
28162	45949	1	applied	\N	\N	\N	\N	211224	211224	378349
28104	45440	77	applied	\N	\N	\N	\N	210950	210950	378075
28104	45443	78	applied	\N	\N	\N	\N	210951	210951	378076
28141	45899	1	applied	\N	\N	\N	\N	211123	211123	378248
28145	45908	0	applied	\N	\N	\N	\N	211134	211134	378259
28145	45909	1	applied	\N	\N	\N	\N	211135	211135	378260
28145	45910	2	applied	\N	\N	\N	\N	211136	211136	378261
28146	45885	0	applied	\N	\N	1000000000	\N	211137	211137	378262
28146	45847	1	applied	\N	\N	1000000000	\N	211138	211138	378263
28146	45871	2	applied	\N	\N	\N	\N	211139	211139	378264
28146	45890	4	applied	\N	\N	1000000000	\N	211141	211141	378266
28146	45790	5	applied	\N	\N	\N	\N	211142	211142	378267
28146	45801	6	applied	\N	\N	\N	\N	211143	211143	378268
28146	45811	7	applied	\N	\N	\N	\N	211144	211144	378269
28146	45818	8	applied	\N	\N	\N	\N	211145	211145	378270
28146	45832	9	applied	\N	\N	\N	\N	211146	211146	378271
28146	45844	10	applied	\N	\N	\N	\N	211147	211147	378272
28146	45853	11	applied	\N	\N	\N	\N	211148	211148	378273
28146	45868	12	applied	\N	\N	\N	\N	211149	211149	378274
28146	45875	13	applied	\N	\N	\N	\N	211150	211150	378275
28146	45882	14	applied	\N	\N	\N	\N	211151	211151	378276
28146	45895	15	applied	\N	\N	\N	\N	211152	211152	378277
28146	45903	16	applied	\N	\N	\N	\N	211153	211153	378278
28146	45909	17	applied	\N	\N	\N	\N	211154	211154	378279
28147	45911	0	applied	\N	\N	\N	\N	211155	211155	378280
28147	45912	1	applied	\N	\N	\N	\N	211156	211156	378281
28150	45917	0	applied	\N	\N	\N	\N	211161	211161	378286
28150	45918	1	applied	\N	\N	\N	\N	211162	211162	378287
28150	45919	2	applied	\N	\N	\N	\N	211163	211163	378288
28150	45921	4	applied	\N	\N	\N	\N	211165	211165	378290
28153	45929	0	applied	\N	\N	\N	\N	211173	211173	378298
28153	45930	1	applied	\N	\N	\N	\N	211174	211174	378299
28156	45934	0	applied	\N	\N	\N	\N	211181	211181	378306
28156	45935	1	applied	\N	\N	\N	\N	211182	211182	378307
28156	45936	2	applied	\N	\N	\N	\N	211183	211183	378308
28156	45937	3	applied	\N	\N	\N	\N	211184	211184	378309
28156	45938	4	applied	\N	\N	\N	\N	211185	211185	378310
28156	45939	5	applied	\N	\N	\N	\N	211186	211186	378311
28156	45940	6	applied	\N	\N	\N	\N	211187	211187	378312
28156	45941	7	applied	\N	\N	\N	\N	211188	211188	378313
28156	45942	8	applied	\N	\N	\N	\N	211189	211189	378314
28156	45943	9	applied	\N	\N	\N	\N	211190	211190	378315
28162	45950	2	applied	\N	\N	\N	\N	211225	211225	378350
28162	45951	3	applied	\N	\N	\N	\N	211226	211226	378351
28162	45952	4	applied	\N	\N	\N	\N	211227	211227	378352
28162	45954	6	applied	\N	\N	\N	\N	211229	211229	378354
28165	45958	0	applied	\N	\N	\N	\N	211240	211240	378365
28165	45959	1	applied	\N	\N	\N	\N	211241	211241	378366
28167	45958	0	applied	\N	\N	\N	\N	211244	211244	378369
28167	45959	1	applied	\N	\N	\N	\N	211245	211245	378370
28169	45885	0	applied	\N	\N	1000000000	\N	211246	211246	378371
28170	45958	0	applied	\N	\N	\N	\N	211273	211273	378398
28170	45959	1	applied	\N	\N	\N	\N	211274	211274	378399
28173	45960	0	applied	\N	\N	\N	\N	211286	211286	378411
28173	45961	1	applied	\N	\N	\N	\N	211287	211287	378412
28173	45962	2	applied	\N	\N	\N	\N	211288	211288	378413
28173	45963	3	applied	\N	\N	\N	\N	211289	211289	378414
28173	45964	4	applied	\N	\N	\N	\N	211290	211290	378415
28173	45965	5	applied	\N	\N	\N	\N	211291	211291	378416
28173	45966	6	applied	\N	\N	\N	\N	211292	211292	378417
28175	45967	0	applied	\N	\N	\N	\N	211295	211295	378420
28178	45967	0	applied	\N	\N	\N	\N	211301	211301	378426
28178	45968	1	applied	\N	\N	\N	\N	211302	211302	378427
28182	45977	0	applied	\N	\N	\N	\N	211313	211313	378438
28182	45978	1	applied	\N	\N	\N	\N	211314	211314	378439
28182	45979	2	applied	\N	\N	\N	\N	211315	211315	378440
28189	45984	0	applied	\N	\N	\N	\N	211332	211332	378457
28189	45985	1	applied	\N	\N	\N	\N	211333	211333	378458
28189	45986	2	applied	\N	\N	\N	\N	211334	211334	378459
28189	45987	3	applied	\N	\N	\N	\N	211335	211335	378460
28189	45988	4	applied	\N	\N	\N	\N	211336	211336	378461
28191	45966	0	applied	\N	\N	\N	\N	211342	211342	378467
28191	45971	1	applied	\N	\N	\N	\N	211343	211343	378468
28191	45978	2	applied	\N	\N	\N	\N	211344	211344	378469
28191	45988	3	applied	\N	\N	\N	\N	211345	211345	378470
28196	45996	0	applied	\N	\N	\N	\N	211353	211353	378478
28196	45997	1	applied	\N	\N	\N	\N	211354	211354	378479
28203	46006	0	applied	\N	\N	\N	\N	211367	211367	378492
28206	46012	0	applied	\N	\N	\N	\N	211375	211375	378500
28206	46013	1	applied	\N	\N	\N	\N	211376	211376	378501
28208	46014	0	applied	\N	\N	\N	\N	211379	211379	378504
28208	46015	1	applied	\N	\N	\N	\N	211380	211380	378505
28215	46026	0	applied	\N	\N	\N	\N	211396	211396	378521
28215	46027	1	applied	\N	\N	\N	\N	211397	211397	378522
28215	46028	2	applied	\N	\N	\N	\N	211398	211398	378523
28218	46029	0	applied	\N	\N	\N	\N	211405	211405	378530
28218	46030	1	applied	\N	\N	\N	\N	211406	211406	378531
28218	46031	3	applied	\N	\N	\N	\N	211407	211407	378532
28220	46032	0	applied	\N	\N	\N	\N	211410	211410	378535
28220	46033	1	applied	\N	\N	\N	\N	211411	211411	378536
28222	46032	0	applied	\N	\N	\N	\N	211414	211414	378539
28222	46033	1	applied	\N	\N	\N	\N	211415	211415	378540
28224	46034	0	applied	\N	\N	\N	\N	211416	211416	378541
28224	46036	2	applied	\N	\N	\N	\N	211418	211418	378543
28227	46039	0	applied	\N	\N	\N	\N	211423	211423	378548
28227	46040	1	applied	\N	\N	\N	\N	211424	211424	378549
28229	46041	0	applied	\N	\N	\N	\N	211427	211427	378552
28229	46042	1	applied	\N	\N	\N	\N	211428	211428	378553
28229	46043	2	applied	\N	\N	\N	\N	211429	211429	378554
28232	46044	0	applied	\N	\N	\N	\N	211442	211442	378563
28232	46045	1	applied	\N	\N	\N	\N	211443	211443	378564
28232	46046	2	applied	\N	\N	\N	\N	211444	211444	378565
28232	46048	4	applied	\N	\N	\N	\N	211446	211446	378566
28234	46050	0	applied	\N	\N	\N	\N	211454	211454	378571
28232	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	211447	211447	\N
28234	46051	1	applied	\N	\N	\N	\N	211455	211455	378572
28234	46052	2	applied	\N	\N	\N	\N	211456	211456	378573
28237	46055	0	applied	\N	\N	\N	\N	211461	211461	378578
28237	46056	1	applied	\N	\N	\N	\N	211462	211462	378579
28241	46057	0	applied	\N	\N	\N	\N	211471	211471	378586
28241	46058	1	applied	\N	\N	\N	\N	211472	211472	378587
28139	45897	1	applied	\N	\N	\N	\N	211119	211119	378244
28141	45898	0	applied	\N	\N	\N	\N	211122	211122	378247
28169	45889	4	applied	\N	\N	1000000000	\N	211250	211250	378375
28169	45890	5	applied	\N	\N	1000000000	\N	211251	211251	378376
28169	45677	6	applied	\N	\N	\N	\N	211252	211252	378377
28169	45941	7	applied	\N	\N	\N	\N	211253	211253	378378
28169	45790	8	applied	\N	\N	\N	\N	211254	211254	378379
28169	45801	9	applied	\N	\N	\N	\N	211255	211255	378380
28169	45811	10	applied	\N	\N	\N	\N	211256	211256	378381
28169	45818	11	applied	\N	\N	\N	\N	211257	211257	378382
28169	45832	12	applied	\N	\N	\N	\N	211258	211258	378383
28169	45853	14	applied	\N	\N	\N	\N	211260	211260	378385
28169	45868	15	applied	\N	\N	\N	\N	211261	211261	378386
28169	45875	16	applied	\N	\N	\N	\N	211262	211262	378387
28169	45882	17	applied	\N	\N	\N	\N	211263	211263	378388
28169	45895	18	applied	\N	\N	\N	\N	211264	211264	378389
28169	45903	19	applied	\N	\N	\N	\N	211265	211265	378390
28169	45909	20	applied	\N	\N	\N	\N	211266	211266	378391
28169	45919	21	applied	\N	\N	\N	\N	211267	211267	378392
28169	45927	22	applied	\N	\N	\N	\N	211268	211268	378393
28169	45931	23	applied	\N	\N	\N	\N	211269	211269	378394
28169	45938	24	applied	\N	\N	\N	\N	211270	211270	378395
28169	45954	25	applied	\N	\N	\N	\N	211271	211271	378396
28169	45957	26	applied	\N	\N	\N	\N	211272	211272	378397
28171	45938	0	applied	\N	\N	\N	\N	211275	211275	378400
28171	45954	1	applied	\N	\N	\N	\N	211276	211276	378401
28171	45941	2	applied	\N	\N	\N	\N	211277	211277	378402
28176	45967	0	applied	\N	\N	\N	\N	211297	211297	378422
28176	45968	1	applied	\N	\N	\N	\N	211298	211298	378423
28180	45969	0	applied	\N	\N	\N	\N	211305	211305	378430
28180	45970	1	applied	\N	\N	\N	\N	211306	211306	378431
28180	45971	2	applied	\N	\N	\N	\N	211307	211307	378432
28180	45972	3	applied	\N	\N	\N	\N	211308	211308	378433
28180	45973	4	applied	\N	\N	\N	\N	211309	211309	378434
28180	45974	5	applied	\N	\N	\N	\N	211310	211310	378435
28183	45977	0	applied	\N	\N	\N	\N	211316	211316	378441
28183	45978	1	applied	\N	\N	\N	\N	211317	211317	378442
28183	45979	2	applied	\N	\N	\N	\N	211318	211318	378443
28184	45977	0	applied	\N	\N	\N	\N	211319	211319	378444
28184	45978	1	applied	\N	\N	\N	\N	211320	211320	378445
28184	45979	2	applied	\N	\N	\N	\N	211321	211321	378446
28186	45977	0	applied	\N	\N	\N	\N	211325	211325	378450
28186	45978	1	applied	\N	\N	\N	\N	211326	211326	378451
28187	45980	0	applied	\N	\N	\N	\N	211328	211328	378453
28187	45981	1	applied	\N	\N	\N	\N	211329	211329	378454
28190	45984	0	applied	\N	\N	\N	\N	211337	211337	378462
28190	45985	1	applied	\N	\N	\N	\N	211338	211338	378463
28190	45986	2	applied	\N	\N	\N	\N	211339	211339	378464
28190	45987	3	applied	\N	\N	\N	\N	211340	211340	378465
28190	45988	4	applied	\N	\N	\N	\N	211341	211341	378466
28192	45989	0	applied	\N	\N	\N	\N	211346	211346	378471
28192	45990	1	applied	\N	\N	\N	\N	211347	211347	378472
28194	45991	0	applied	\N	\N	\N	\N	211348	211348	378473
28194	45992	1	applied	\N	\N	\N	\N	211349	211349	378474
28197	45998	0	applied	\N	\N	\N	\N	211355	211355	378480
28197	45999	1	applied	\N	\N	\N	\N	211356	211356	378481
28199	46003	0	applied	\N	\N	\N	\N	211360	211360	378485
28199	46004	1	applied	\N	\N	\N	\N	211361	211361	378486
28199	46005	2	applied	\N	\N	\N	\N	211362	211362	378487
28202	46006	0	applied	\N	\N	\N	\N	211366	211366	378491
28204	46007	0	applied	\N	\N	\N	\N	211368	211368	378493
28204	46008	1	applied	\N	\N	\N	\N	211369	211369	378494
28204	46009	2	applied	\N	\N	\N	\N	211370	211370	378495
28204	46010	3	applied	\N	\N	\N	\N	211371	211371	378496
28204	46011	4	applied	\N	\N	\N	\N	211372	211372	378497
28205	46012	0	applied	\N	\N	\N	\N	211373	211373	378498
28205	46013	1	applied	\N	\N	\N	\N	211374	211374	378499
28207	46012	0	applied	\N	\N	\N	\N	211377	211377	378502
28210	46016	0	applied	\N	\N	\N	\N	211384	211384	378509
28210	46017	1	applied	\N	\N	\N	\N	211385	211385	378510
28210	46018	2	applied	\N	\N	\N	\N	211386	211386	378511
28212	46021	0	applied	\N	\N	\N	\N	211389	211389	378514
28212	46022	1	applied	\N	\N	\N	\N	211390	211390	378515
28219	46032	0	applied	\N	\N	\N	\N	211408	211408	378533
28219	46033	1	applied	\N	\N	\N	\N	211409	211409	378534
28226	46038	1	applied	\N	\N	\N	\N	211422	211422	378547
28236	46055	0	applied	\N	\N	\N	\N	211459	211459	378576
28236	46056	1	applied	\N	\N	\N	\N	211460	211460	378577
28239	46055	0	applied	\N	\N	\N	\N	211467	211467	378582
28239	46056	1	applied	\N	\N	\N	\N	211468	211468	378583
28240	46057	0	applied	\N	\N	\N	\N	211469	211469	378584
28240	46058	1	applied	\N	\N	\N	\N	211470	211470	378585
28245	46064	0	applied	\N	\N	\N	\N	211480	211480	378595
28245	46065	1	applied	\N	\N	\N	\N	211481	211481	378596
28248	46069	0	applied	\N	\N	\N	\N	211488	211488	378602
28248	46070	1	applied	\N	\N	\N	\N	211489	211489	211489
28248	46071	2	applied	\N	\N	\N	\N	211490	211490	378603
28252	46072	0	applied	\N	\N	\N	\N	211553	211553	378661
28252	46073	1	applied	\N	\N	\N	\N	211554	211554	378662
28252	46074	2	applied	\N	\N	\N	\N	211555	211555	378663
28252	46075	3	applied	\N	\N	\N	\N	211556	211556	378664
28252	46077	5	applied	\N	\N	\N	\N	211558	211558	378666
28258	46082	0	applied	\N	\N	\N	\N	211569	211569	378677
28258	46083	1	applied	\N	\N	\N	\N	211570	211570	378678
28260	46084	0	applied	\N	\N	\N	\N	211573	211573	378681
28260	46085	1	applied	\N	\N	\N	\N	211574	211574	378682
28260	46086	2	applied	\N	\N	\N	\N	211575	211575	378683
28262	46084	0	applied	\N	\N	\N	\N	211579	211579	378687
28262	46085	1	applied	\N	\N	\N	\N	211580	211580	378688
28262	46086	2	applied	\N	\N	\N	\N	211581	211581	378689
28265	46089	0	applied	\N	\N	\N	\N	211586	211586	378694
28265	46090	1	applied	\N	\N	\N	\N	211587	211587	378695
28274	46101	0	applied	\N	\N	\N	\N	211621	211621	378726
28274	46102	1	applied	\N	\N	\N	\N	211622	211622	378727
28278	46103	0	applied	\N	\N	\N	\N	211629	211629	378734
28278	46104	1	applied	\N	\N	\N	\N	211630	211630	378735
28280	46103	0	applied	\N	\N	\N	\N	211633	211633	378738
28280	46104	1	applied	\N	\N	\N	\N	211634	211634	378739
28283	46108	0	applied	\N	\N	\N	\N	211641	211641	378745
28283	46110	2	applied	\N	\N	\N	\N	211643	211643	378747
28285	46113	0	applied	\N	\N	\N	\N	211646	211646	378750
28169	45871	2	applied	\N	\N	\N	\N	211248	211248	378373
28169	45749	3	applied	\N	\N	1000000000	\N	211249	211249	378374
28214	46023	0	applied	\N	\N	\N	\N	211393	211393	378518
28214	46024	1	applied	\N	\N	\N	\N	211394	211394	378519
28214	46025	2	applied	\N	\N	\N	\N	211395	211395	378520
28217	46029	0	applied	\N	\N	\N	\N	211402	211402	378527
28217	46030	1	applied	\N	\N	\N	\N	211403	211403	378528
28217	46031	3	applied	\N	\N	\N	\N	211404	211404	378529
28221	46032	0	applied	\N	\N	\N	\N	211412	211412	378537
28221	46033	1	applied	\N	\N	\N	\N	211413	211413	378538
28228	46039	0	applied	\N	\N	\N	\N	211425	211425	378550
28228	46040	1	applied	\N	\N	\N	\N	211426	211426	378551
28231	46044	0	applied	\N	\N	\N	\N	211436	211436	378559
28231	46045	1	applied	\N	\N	\N	\N	211437	211437	378560
28231	46046	2	applied	\N	\N	\N	\N	211438	211438	378561
28231	46048	4	applied	\N	\N	\N	\N	211440	211440	378562
28238	46026	0	applied	\N	\N	\N	\N	211463	211463	378580
28231	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	211441	211441	\N
28238	46030	1	applied	\N	\N	\N	\N	211464	211464	378581
28242	46059	0	applied	\N	\N	\N	\N	211473	211473	378588
28238	46047	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	211465	211465	\N
28238	46049	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	211466	211466	\N
28242	46060	1	applied	\N	\N	\N	\N	211474	211474	378589
28242	46061	2	applied	\N	\N	\N	\N	211475	211475	378590
28247	46069	0	applied	\N	\N	\N	\N	211485	211485	378600
28247	46070	1	applied	\N	\N	\N	\N	211486	211486	211486
28247	46071	2	applied	\N	\N	\N	\N	211487	211487	378601
28249	46069	0	applied	\N	\N	\N	\N	211491	211491	378604
28249	46070	1	applied	\N	\N	\N	\N	211492	211492	211492
28249	46071	2	applied	\N	\N	\N	\N	211493	211493	378605
28254	46080	0	applied	\N	\N	\N	\N	211561	211561	378669
28254	46081	1	applied	\N	\N	\N	\N	211562	211562	378670
28256	46082	0	applied	\N	\N	\N	\N	211565	211565	378673
28256	46083	1	applied	\N	\N	\N	\N	211566	211566	378674
28259	46082	0	applied	\N	\N	\N	\N	211571	211571	378679
28259	46083	1	applied	\N	\N	\N	\N	211572	211572	378680
28261	46084	0	applied	\N	\N	\N	\N	211576	211576	378684
28261	46085	1	applied	\N	\N	\N	\N	211577	211577	378685
28261	46086	2	applied	\N	\N	\N	\N	211578	211578	378686
28267	46091	0	applied	\N	\N	\N	\N	211590	211590	378698
28267	46093	2	applied	\N	\N	\N	\N	211592	211592	378700
28272	46098	0	applied	\N	\N	\N	\N	211616	211616	378721
28272	46099	1	applied	\N	\N	\N	\N	211617	211617	378722
28272	46100	2	applied	\N	\N	\N	\N	211618	211618	378723
28285	46114	1	applied	\N	\N	\N	\N	211647	211647	378751
28291	46115	0	applied	\N	\N	\N	\N	211659	211659	378763
28291	46116	1	applied	\N	\N	\N	\N	211660	211660	378764
28291	46117	2	applied	\N	\N	\N	\N	211661	211661	378765
28294	46118	0	applied	\N	\N	\N	\N	211664	211664	378768
28294	46119	1	applied	\N	\N	\N	\N	211665	211665	378769
28296	46120	0	applied	\N	\N	\N	\N	211668	211668	378772
28296	46121	1	applied	\N	\N	\N	\N	211669	211669	378773
28296	46122	2	applied	\N	\N	\N	\N	211670	211670	378774
28296	46123	3	applied	\N	\N	\N	\N	211671	211671	378775
28296	46124	4	applied	\N	\N	\N	\N	211672	211672	378776
28301	46132	0	applied	\N	\N	\N	\N	211687	211687	378790
28301	46134	2	applied	\N	\N	\N	\N	211689	211689	378792
28301	46135	3	applied	\N	\N	\N	\N	211690	211690	378793
28301	46136	4	applied	\N	\N	\N	\N	211691	211691	378794
28301	46137	5	applied	\N	\N	\N	\N	211692	211692	378795
28310	46160	0	applied	\N	\N	\N	\N	211728	211728	378831
28310	46161	1	applied	\N	\N	\N	\N	211729	211729	378832
28310	46162	2	applied	\N	\N	\N	\N	211730	211730	378833
28310	46163	3	applied	\N	\N	\N	\N	211731	211731	378834
28310	46164	4	applied	\N	\N	\N	\N	211732	211732	378835
28315	46167	0	applied	\N	\N	\N	\N	211793	211793	378895
28315	46168	1	applied	\N	\N	\N	\N	211794	211794	378896
28317	46169	0	applied	\N	\N	\N	\N	211800	211800	378902
28317	46170	1	applied	\N	\N	\N	\N	211801	211801	378903
28317	46171	2	applied	\N	\N	\N	\N	211802	211802	378904
28317	46172	3	applied	\N	\N	\N	\N	211803	211803	378905
28317	46173	4	applied	\N	\N	\N	\N	211804	211804	378906
28320	46136	1	applied	\N	\N	\N	\N	211810	211810	378911
28320	46127	2	applied	\N	\N	\N	\N	211811	211811	211811
28325	46187	0	applied	\N	\N	\N	\N	211828	211828	378925
28325	46188	1	applied	\N	\N	\N	\N	211829	211829	378926
28330	46191	0	applied	\N	\N	\N	\N	211838	211838	378935
28330	46192	1	applied	\N	\N	\N	\N	211839	211839	378936
28330	46193	2	applied	\N	\N	\N	\N	211840	211840	378937
28330	46194	3	applied	\N	\N	\N	\N	211841	211841	378938
28330	46195	4	applied	\N	\N	\N	\N	211842	211842	378939
28330	46196	5	applied	\N	\N	\N	\N	211843	211843	378940
28332	46191	0	applied	\N	\N	\N	\N	211850	211850	378947
28332	46192	1	applied	\N	\N	\N	\N	211851	211851	378948
28332	46193	2	applied	\N	\N	\N	\N	211852	211852	378949
28332	46194	3	applied	\N	\N	\N	\N	211853	211853	378950
28332	46195	4	applied	\N	\N	\N	\N	211854	211854	378951
28332	46196	5	applied	\N	\N	\N	\N	211855	211855	378952
28335	46198	1	applied	\N	\N	\N	\N	211861	211861	378958
28337	46199	0	applied	\N	\N	\N	\N	211870	211870	378967
28337	46200	1	applied	\N	\N	\N	\N	211871	211871	378968
28337	46201	2	applied	\N	\N	\N	\N	211872	211872	378969
28337	46202	3	applied	\N	\N	\N	\N	211873	211873	378970
28337	46203	4	applied	\N	\N	\N	\N	211874	211874	378971
28337	46204	5	applied	\N	\N	\N	\N	211875	211875	378972
28337	46205	6	applied	\N	\N	\N	\N	211876	211876	378973
28337	46206	7	applied	\N	\N	\N	\N	211877	211877	378974
28348	46223	0	applied	\N	\N	1000000000	\N	211928	211928	379025
28348	46106	1	applied	\N	\N	\N	\N	211929	211929	211929
28348	46183	2	applied	\N	\N	\N	\N	211930	211930	379026
28348	46224	3	applied	\N	\N	1000000000	\N	211931	211931	379027
28348	46136	4	applied	\N	\N	\N	\N	211932	211932	379028
28348	46127	5	applied	\N	\N	\N	\N	211933	211933	211933
28348	46100	6	applied	\N	\N	\N	\N	211934	211934	379029
28348	46116	8	applied	\N	\N	\N	\N	211936	211936	379031
28348	46123	9	applied	\N	\N	\N	\N	211937	211937	379032
28348	46135	10	applied	\N	\N	\N	\N	211938	211938	379033
28348	46141	11	applied	\N	\N	\N	\N	211939	211939	379034
28348	46148	12	applied	\N	\N	\N	\N	211940	211940	379035
28348	46155	13	applied	\N	\N	\N	\N	211941	211941	379036
28209	46017	1	applied	\N	\N	\N	\N	211382	211382	378507
28209	46018	2	applied	\N	\N	\N	\N	211383	211383	378508
28213	46022	1	applied	\N	\N	\N	\N	211392	211392	378517
28216	46029	0	applied	\N	\N	\N	\N	211399	211399	378524
28216	46030	1	applied	\N	\N	\N	\N	211400	211400	378525
28216	46031	3	applied	\N	\N	\N	\N	211401	211401	378526
28225	46026	0	applied	\N	\N	\N	\N	211419	211419	378544
28225	46030	1	applied	\N	\N	\N	\N	211420	211420	378545
28230	46044	0	applied	\N	\N	\N	\N	211430	211430	378555
28230	46045	1	applied	\N	\N	\N	\N	211431	211431	378556
28230	46046	2	applied	\N	\N	\N	\N	211432	211432	378557
28230	46048	4	applied	\N	\N	\N	\N	211434	211434	378558
28233	46044	0	applied	\N	\N	\N	\N	211448	211448	378567
28233	46045	1	applied	\N	\N	\N	\N	211449	211449	378568
28233	46046	2	applied	\N	\N	\N	\N	211450	211450	378569
28233	46048	4	applied	\N	\N	\N	\N	211452	211452	378570
28233	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	211451	211451	\N
28235	46053	0	applied	\N	\N	\N	\N	211457	211457	378574
28233	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	211453	211453	\N
28235	46054	1	applied	\N	\N	\N	\N	211458	211458	378575
28244	46062	0	applied	\N	\N	\N	\N	211478	211478	378593
28244	46063	1	applied	\N	\N	\N	\N	211479	211479	378594
28246	46066	0	applied	\N	\N	\N	\N	211482	211482	378597
28246	46067	1	applied	\N	\N	\N	\N	211483	211483	378598
28246	46068	2	applied	\N	\N	\N	\N	211484	211484	378599
28251	46072	0	applied	\N	\N	\N	\N	211547	211547	378655
28251	46073	1	applied	\N	\N	\N	\N	211548	211548	378656
28251	46074	2	applied	\N	\N	\N	\N	211549	211549	378657
28251	46075	3	applied	\N	\N	\N	\N	211550	211550	378658
28251	46076	4	applied	\N	\N	1000000000	\N	211551	211551	378659
28251	46077	5	applied	\N	\N	\N	\N	211552	211552	378660
28253	46078	0	applied	\N	\N	\N	\N	211559	211559	378667
28253	46079	1	applied	\N	\N	\N	\N	211560	211560	378668
28255	46080	0	applied	\N	\N	\N	\N	211563	211563	378671
28255	46081	1	applied	\N	\N	\N	\N	211564	211564	378672
28257	46082	0	applied	\N	\N	\N	\N	211567	211567	378675
28257	46083	1	applied	\N	\N	\N	\N	211568	211568	378676
28264	46089	0	applied	\N	\N	\N	\N	211584	211584	378692
28269	46094	0	applied	\N	\N	\N	\N	211610	211610	378715
28269	46095	1	applied	\N	\N	\N	\N	211611	211611	378716
28271	46096	0	applied	\N	\N	\N	\N	211614	211614	378719
28271	46097	1	applied	\N	\N	\N	\N	211615	211615	378720
28273	46101	0	applied	\N	\N	\N	\N	211619	211619	378724
28279	46103	0	applied	\N	\N	\N	\N	211631	211631	378736
28279	46104	1	applied	\N	\N	\N	\N	211632	211632	378737
28286	46113	0	applied	\N	\N	\N	\N	211648	211648	378752
28286	46114	1	applied	\N	\N	\N	\N	211649	211649	378753
28288	46113	0	applied	\N	\N	\N	\N	211652	211652	378756
28288	46114	1	applied	\N	\N	\N	\N	211653	211653	378757
28292	46118	0	applied	\N	\N	\N	\N	211662	211662	378766
28292	46119	1	applied	\N	\N	\N	\N	211663	211663	378767
28297	46120	0	applied	\N	\N	\N	\N	211673	211673	378777
28297	46121	1	applied	\N	\N	\N	\N	211674	211674	378778
28297	46122	2	applied	\N	\N	\N	\N	211675	211675	378779
28297	46124	4	applied	\N	\N	\N	\N	211677	211677	378781
28299	46130	0	applied	\N	\N	\N	\N	211683	211683	378786
28299	46131	1	applied	\N	\N	\N	\N	211684	211684	378787
28304	46140	0	applied	\N	\N	\N	\N	211701	211701	378804
28304	46141	1	applied	\N	\N	\N	\N	211702	211702	378805
28304	46142	2	applied	\N	\N	\N	\N	211703	211703	378806
28305	46143	0	applied	\N	\N	\N	\N	211704	211704	378807
28305	46144	1	applied	\N	\N	\N	\N	211705	211705	378808
28305	46145	2	applied	\N	\N	\N	\N	211706	211706	378809
28305	46146	3	applied	\N	\N	\N	\N	211707	211707	378810
28307	46147	0	applied	\N	\N	\N	\N	211712	211712	378815
28307	46148	1	applied	\N	\N	\N	\N	211713	211713	378816
28307	46149	2	applied	\N	\N	\N	\N	211714	211714	378817
28311	46165	0	applied	\N	\N	\N	\N	211733	211733	378836
28311	46166	1	applied	\N	\N	\N	\N	211734	211734	378837
28313	46167	0	applied	\N	\N	\N	\N	211737	211737	378840
28318	46174	0	applied	\N	\N	\N	\N	211805	211805	378907
28318	46175	1	applied	\N	\N	\N	\N	211806	211806	378908
28323	46180	0	applied	\N	\N	\N	\N	211819	211819	378916
28323	46181	1	applied	\N	\N	\N	\N	211820	211820	378917
28323	46182	2	applied	\N	\N	\N	\N	211821	211821	378918
28323	46183	3	applied	\N	\N	\N	\N	211822	211822	378919
28323	46184	5	applied	\N	\N	\N	\N	211823	211823	378920
28323	46185	6	applied	\N	\N	\N	\N	211824	211824	378921
28323	46186	7	applied	\N	\N	\N	\N	211825	211825	378922
28326	46187	0	applied	\N	\N	\N	\N	211830	211830	378927
28326	46188	1	applied	\N	\N	\N	\N	211831	211831	378928
28331	46191	0	applied	\N	\N	\N	\N	211844	211844	378941
28331	46192	1	applied	\N	\N	\N	\N	211845	211845	378942
28331	46193	2	applied	\N	\N	\N	\N	211846	211846	378943
28331	46194	3	applied	\N	\N	\N	\N	211847	211847	378944
28331	46195	4	applied	\N	\N	\N	\N	211848	211848	378945
28338	46207	0	applied	\N	\N	\N	\N	211878	211878	378975
28338	46208	1	applied	\N	\N	\N	\N	211879	211879	378976
28340	46209	0	applied	\N	\N	\N	\N	211882	211882	378979
28340	46210	1	applied	\N	\N	\N	\N	211883	211883	378980
28341	46211	0	applied	\N	\N	\N	\N	211884	211884	378981
28341	46212	1	applied	\N	\N	\N	\N	211885	211885	378982
28341	46213	2	applied	\N	\N	\N	\N	211886	211886	378983
28341	46214	3	applied	\N	\N	\N	\N	211887	211887	378984
28341	46215	4	applied	\N	\N	\N	\N	211888	211888	378985
28341	46216	5	applied	\N	\N	\N	\N	211889	211889	378986
28341	46217	6	applied	\N	\N	\N	\N	211890	211890	378987
28341	46218	7	applied	\N	\N	\N	\N	211891	211891	378988
28343	46211	0	applied	\N	\N	\N	\N	211900	211900	378997
28343	46212	1	applied	\N	\N	\N	\N	211901	211901	378998
28343	46213	2	applied	\N	\N	\N	\N	211902	211902	378999
28343	46214	3	applied	\N	\N	\N	\N	211903	211903	379000
28343	46216	5	applied	\N	\N	\N	\N	211905	211905	379002
28343	46217	6	applied	\N	\N	\N	\N	211906	211906	379003
28343	46218	7	applied	\N	\N	\N	\N	211907	211907	379004
28346	46221	0	applied	\N	\N	\N	\N	211912	211912	379009
28346	46222	1	applied	\N	\N	\N	\N	211913	211913	379010
28346	46223	2	applied	\N	\N	1000000000	\N	211914	211914	379011
28346	46224	3	applied	\N	\N	1000000000	\N	211915	211915	379012
28211	46020	1	applied	\N	\N	\N	\N	211388	211388	378513
28213	46021	0	applied	\N	\N	\N	\N	211391	211391	378516
28250	45885	2	applied	\N	\N	1000000000	\N	211496	211496	378608
28250	45847	3	applied	\N	\N	1000000000	\N	211497	211497	378609
28250	45871	4	applied	\N	\N	\N	\N	211498	211498	378610
28250	45472	6	applied	\N	\N	\N	\N	211500	211500	378611
28250	45283	8	applied	\N	\N	1000000000	\N	211502	211502	378612
28250	46047	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	211501	211501	\N
28250	45388	9	applied	\N	\N	\N	\N	211503	211503	378613
28250	45391	10	applied	\N	\N	1000000000	\N	211504	211504	378614
28250	45392	11	applied	\N	\N	1000000000	\N	211505	211505	378615
28250	45393	12	applied	\N	\N	1000000000	\N	211506	211506	378616
28250	45941	13	applied	\N	\N	\N	\N	211507	211507	378617
28250	46070	14	applied	\N	\N	\N	\N	211508	211508	211508
28250	45749	16	applied	\N	\N	1000000000	\N	211510	211510	378619
28250	45889	17	applied	\N	\N	1000000000	\N	211511	211511	378620
28250	45890	18	applied	\N	\N	1000000000	\N	211512	211512	378621
28250	45790	19	applied	\N	\N	\N	\N	211513	211513	378622
28250	45801	20	applied	\N	\N	\N	\N	211514	211514	378623
28250	45811	21	applied	\N	\N	\N	\N	211515	211515	378624
28250	45818	22	applied	\N	\N	\N	\N	211516	211516	378625
28250	45832	23	applied	\N	\N	\N	\N	211517	211517	378626
28250	45844	24	applied	\N	\N	\N	\N	211518	211518	378627
28250	45853	25	applied	\N	\N	\N	\N	211519	211519	378628
28250	45868	26	applied	\N	\N	\N	\N	211520	211520	378629
28250	45875	27	applied	\N	\N	\N	\N	211521	211521	378630
28250	45882	28	applied	\N	\N	\N	\N	211522	211522	378631
28250	45895	29	applied	\N	\N	\N	\N	211523	211523	378632
28250	45903	30	applied	\N	\N	\N	\N	211524	211524	378633
28250	45909	31	applied	\N	\N	\N	\N	211525	211525	378634
28250	45919	32	applied	\N	\N	\N	\N	211526	211526	378635
28250	45927	33	applied	\N	\N	\N	\N	211527	211527	378636
28250	45931	34	applied	\N	\N	\N	\N	211528	211528	378637
28250	45954	36	applied	\N	\N	\N	\N	211530	211530	378639
28250	45957	37	applied	\N	\N	\N	\N	211531	211531	378640
28250	45966	38	applied	\N	\N	\N	\N	211532	211532	378641
28250	45971	39	applied	\N	\N	\N	\N	211533	211533	378642
28250	45978	40	applied	\N	\N	\N	\N	211534	211534	378643
28250	45988	41	applied	\N	\N	\N	\N	211535	211535	378644
28250	45994	42	applied	\N	\N	\N	\N	211536	211536	378645
28250	46001	43	applied	\N	\N	\N	\N	211537	211537	378646
28250	46011	44	applied	\N	\N	\N	\N	211538	211538	378647
28273	46102	1	applied	\N	\N	\N	\N	211620	211620	378725
28276	46101	0	applied	\N	\N	\N	\N	211625	211625	378730
28276	46102	1	applied	\N	\N	\N	\N	211626	211626	378731
28282	46108	0	applied	\N	\N	\N	\N	211638	211638	378742
28282	46109	1	applied	\N	\N	\N	\N	211639	211639	378743
28282	46110	2	applied	\N	\N	\N	\N	211640	211640	378744
28284	46111	0	applied	\N	\N	\N	\N	211644	211644	378748
28287	46113	0	applied	\N	\N	\N	\N	211650	211650	378754
28287	46114	1	applied	\N	\N	\N	\N	211651	211651	378755
28295	46118	0	applied	\N	\N	\N	\N	211666	211666	378770
28295	46119	1	applied	\N	\N	\N	\N	211667	211667	378771
28298	46125	0	applied	\N	\N	\N	\N	211678	211678	378782
28298	46126	1	applied	\N	\N	\N	\N	211679	211679	378783
28298	46127	2	applied	\N	\N	\N	\N	211680	211680	211680
28298	46128	3	applied	\N	\N	\N	\N	211681	211681	378784
28298	46129	4	applied	\N	\N	\N	\N	211682	211682	378785
28300	46130	0	applied	\N	\N	\N	\N	211685	211685	378788
28300	46131	1	applied	\N	\N	\N	\N	211686	211686	378789
28303	46138	0	applied	\N	\N	\N	\N	211699	211699	378802
28303	46139	1	applied	\N	\N	\N	\N	211700	211700	378803
28308	46147	0	applied	\N	\N	\N	\N	211715	211715	378818
28308	46148	1	applied	\N	\N	\N	\N	211716	211716	378819
28309	46150	0	applied	\N	\N	\N	\N	211717	211717	378820
28309	46152	2	applied	\N	\N	\N	\N	211719	211719	378822
28309	46153	3	applied	\N	\N	\N	\N	211720	211720	378823
28309	46154	4	applied	\N	\N	\N	\N	211721	211721	378824
28309	46149	5	applied	\N	\N	\N	\N	211722	211722	378825
28309	46155	6	applied	\N	\N	\N	\N	211723	211723	378826
28309	46156	7	applied	\N	\N	\N	\N	211724	211724	378827
28309	46157	8	applied	\N	\N	\N	\N	211725	211725	378828
28309	46158	9	applied	\N	\N	\N	\N	211726	211726	378829
28309	46159	10	applied	\N	\N	\N	\N	211727	211727	378830
28314	46115	0	applied	\N	\N	\N	\N	211739	211739	378842
28314	46118	1	applied	\N	\N	\N	\N	211740	211740	378843
28314	46120	2	applied	\N	\N	\N	\N	211741	211741	378844
28314	46121	3	applied	\N	\N	\N	\N	211742	211742	378845
28314	46125	4	applied	\N	\N	\N	\N	211743	211743	378846
28314	46126	5	applied	\N	\N	\N	\N	211744	211744	378847
28314	46130	6	applied	\N	\N	\N	\N	211745	211745	378848
28314	46133	8	applied	\N	\N	\N	\N	211747	211747	378850
28314	46138	9	applied	\N	\N	\N	\N	211748	211748	378851
28314	46140	10	applied	\N	\N	\N	\N	211749	211749	378852
28314	46143	11	applied	\N	\N	\N	\N	211750	211750	378853
28314	46144	12	applied	\N	\N	\N	\N	211751	211751	378854
28314	46147	13	applied	\N	\N	\N	\N	211752	211752	378855
28314	46150	14	applied	\N	\N	\N	\N	211753	211753	378856
28314	46151	15	applied	\N	\N	\N	\N	211754	211754	378857
28314	46152	16	applied	\N	\N	\N	\N	211755	211755	378858
28314	46153	17	applied	\N	\N	\N	\N	211756	211756	378859
28314	46154	18	applied	\N	\N	\N	\N	211757	211757	378860
28314	46160	19	applied	\N	\N	\N	\N	211758	211758	378861
28314	46161	20	applied	\N	\N	\N	\N	211759	211759	378862
28314	46165	21	applied	\N	\N	\N	\N	211760	211760	378863
28314	46167	22	applied	\N	\N	\N	\N	211761	211761	378864
28314	46116	23	applied	\N	\N	\N	\N	211762	211762	378865
28314	46135	25	applied	\N	\N	\N	\N	211764	211764	378867
28314	46136	26	applied	\N	\N	\N	\N	211765	211765	378868
28314	46127	27	applied	\N	\N	\N	\N	211766	211766	211766
28314	46117	28	applied	\N	\N	\N	\N	211767	211767	378869
28314	46119	29	applied	\N	\N	\N	\N	211768	211768	378870
28314	46122	30	applied	\N	\N	\N	\N	211769	211769	378871
28314	46124	31	applied	\N	\N	\N	\N	211770	211770	378872
28314	46141	32	applied	\N	\N	\N	\N	211771	211771	378873
28314	46148	33	applied	\N	\N	\N	\N	211772	211772	378874
28314	46155	34	applied	\N	\N	\N	\N	211773	211773	378875
28314	46162	35	applied	\N	\N	\N	\N	211774	211774	378876
28314	46128	36	applied	\N	\N	\N	\N	211775	211775	378877
28250	45423	0	applied	\N	\N	\N	\N	211494	211494	378606
28250	45447	1	applied	\N	\N	\N	\N	211495	211495	378607
28250	46043	48	applied	\N	\N	\N	\N	211542	211542	378651
28250	46051	49	applied	\N	\N	\N	\N	211543	211543	378652
28250	46061	50	applied	\N	\N	\N	\N	211544	211544	378653
28250	46067	51	applied	\N	\N	\N	\N	211545	211545	378654
28263	46087	0	applied	\N	\N	\N	\N	211582	211582	378690
28263	46088	1	applied	\N	\N	\N	\N	211583	211583	378691
28266	46089	0	applied	\N	\N	\N	\N	211588	211588	378696
28266	46090	1	applied	\N	\N	\N	\N	211589	211589	378697
28268	45994	0	applied	\N	\N	\N	\N	211593	211593	378701
28268	46001	1	applied	\N	\N	\N	\N	211594	211594	378702
28268	46011	3	applied	\N	\N	\N	\N	211596	211596	378703
28268	46017	4	applied	\N	\N	\N	\N	211597	211597	378704
28268	46024	5	applied	\N	\N	\N	\N	211598	211598	378705
28268	46036	6	applied	\N	\N	\N	\N	211599	211599	378706
28268	46043	7	applied	\N	\N	\N	\N	211600	211600	378707
28268	46051	8	applied	\N	\N	\N	\N	211601	211601	378708
28268	46061	9	applied	\N	\N	\N	\N	211602	211602	378709
28268	46067	10	applied	\N	\N	\N	\N	211603	211603	378710
28268	46070	11	applied	\N	\N	\N	\N	211604	211604	211604
28268	46076	12	applied	\N	\N	1000000000	\N	211605	211605	378711
28268	46077	13	applied	\N	\N	\N	\N	211606	211606	378712
28268	46086	14	applied	\N	\N	\N	\N	211607	211607	378713
28268	46093	15	applied	\N	\N	\N	\N	211608	211608	378714
28270	46096	0	applied	\N	\N	\N	\N	211612	211612	378717
28270	46097	1	applied	\N	\N	\N	\N	211613	211613	378718
28275	46101	0	applied	\N	\N	\N	\N	211623	211623	378728
28275	46102	1	applied	\N	\N	\N	\N	211624	211624	378729
28277	46101	0	applied	\N	\N	\N	\N	211627	211627	378732
28277	46102	1	applied	\N	\N	\N	\N	211628	211628	378733
28281	46105	0	applied	\N	\N	\N	\N	211635	211635	378740
28281	46106	1	applied	\N	\N	\N	\N	211636	211636	211636
28281	46107	2	applied	\N	\N	\N	\N	211637	211637	378741
28289	46113	0	applied	\N	\N	\N	\N	211654	211654	378758
28289	46114	1	applied	\N	\N	\N	\N	211655	211655	378759
28290	46115	0	applied	\N	\N	\N	\N	211656	211656	378760
28290	46116	1	applied	\N	\N	\N	\N	211657	211657	378761
28290	46117	2	applied	\N	\N	\N	\N	211658	211658	378762
28302	46132	0	applied	\N	\N	\N	\N	211693	211693	378796
28302	46133	1	applied	\N	\N	\N	\N	211694	211694	378797
28302	46134	2	applied	\N	\N	\N	\N	211695	211695	378798
28302	46135	3	applied	\N	\N	\N	\N	211696	211696	378799
28302	46136	4	applied	\N	\N	\N	\N	211697	211697	378800
28302	46137	5	applied	\N	\N	\N	\N	211698	211698	378801
28306	46143	0	applied	\N	\N	\N	\N	211708	211708	378811
28306	46144	1	applied	\N	\N	\N	\N	211709	211709	378812
28306	46145	2	applied	\N	\N	\N	\N	211710	211710	378813
28306	46146	3	applied	\N	\N	\N	\N	211711	211711	378814
28312	46165	0	applied	\N	\N	\N	\N	211735	211735	378838
28312	46166	1	applied	\N	\N	\N	\N	211736	211736	378839
28314	46129	37	applied	\N	\N	\N	\N	211776	211776	378878
28314	46131	38	applied	\N	\N	\N	\N	211777	211777	378879
28314	46134	39	applied	\N	\N	\N	\N	211778	211778	378880
28314	46137	40	applied	\N	\N	\N	\N	211779	211779	378881
28314	46142	42	applied	\N	\N	\N	\N	211781	211781	378883
28314	46145	43	applied	\N	\N	\N	\N	211782	211782	378884
28314	46146	44	applied	\N	\N	\N	\N	211783	211783	378885
28314	46149	45	applied	\N	\N	\N	\N	211784	211784	378886
28314	46156	46	applied	\N	\N	\N	\N	211785	211785	378887
28314	46157	47	applied	\N	\N	\N	\N	211786	211786	378888
28314	46158	48	applied	\N	\N	\N	\N	211787	211787	378889
28314	46159	49	applied	\N	\N	\N	\N	211788	211788	378890
28314	46163	50	applied	\N	\N	\N	\N	211789	211789	378891
28314	46164	51	applied	\N	\N	\N	\N	211790	211790	378892
28314	46166	52	applied	\N	\N	\N	\N	211791	211791	378893
28314	46168	53	applied	\N	\N	\N	\N	211792	211792	378894
28316	46169	0	applied	\N	\N	\N	\N	211795	211795	378897
28316	46170	1	applied	\N	\N	\N	\N	211796	211796	378898
28316	46171	2	applied	\N	\N	\N	\N	211797	211797	378899
28316	46172	3	applied	\N	\N	\N	\N	211798	211798	378900
28319	46176	0	applied	\N	\N	\N	\N	211807	211807	378909
28319	46177	1	applied	\N	\N	\N	\N	211808	211808	378910
28321	46178	0	applied	\N	\N	\N	\N	211812	211812	378912
28321	46179	1	applied	\N	\N	\N	\N	211813	211813	378913
28322	46070	0	applied	\N	\N	\N	\N	211814	211814	211814
28322	46106	1	applied	\N	\N	\N	\N	211815	211815	211815
28322	46136	2	applied	\N	\N	\N	\N	211816	211816	378914
28322	46127	3	applied	\N	\N	\N	\N	211817	211817	211817
28322	46076	4	applied	\N	\N	1000000000	\N	211818	211818	378915
28324	46187	0	applied	\N	\N	\N	\N	211826	211826	378923
28324	46188	1	applied	\N	\N	\N	\N	211827	211827	378924
28327	46187	0	applied	\N	\N	\N	\N	211832	211832	378929
28327	46188	1	applied	\N	\N	\N	\N	211833	211833	378930
28328	46189	0	applied	\N	\N	\N	\N	211834	211834	378931
28328	46190	1	applied	\N	\N	\N	\N	211835	211835	378932
28329	46189	0	applied	\N	\N	\N	\N	211836	211836	378933
28333	46197	0	applied	\N	\N	\N	\N	211856	211856	378953
28333	46198	1	applied	\N	\N	\N	\N	211857	211857	378954
28334	46197	0	applied	\N	\N	\N	\N	211858	211858	378955
28334	46198	1	applied	\N	\N	\N	\N	211859	211859	378956
28336	46199	0	applied	\N	\N	\N	\N	211862	211862	378959
28339	46207	0	applied	\N	\N	\N	\N	211880	211880	378977
28339	46208	1	applied	\N	\N	\N	\N	211881	211881	378978
28345	46219	0	applied	\N	\N	\N	\N	211910	211910	379007
28345	46220	1	applied	\N	\N	\N	\N	211911	211911	379008
28350	46233	0	applied	\N	\N	\N	\N	211948	211948	379043
28350	46234	1	applied	\N	\N	\N	\N	211949	211949	379044
28354	46235	0	applied	\N	\N	\N	\N	211954	211954	379049
28354	46236	1	applied	\N	\N	\N	\N	211955	211955	379050
28357	46244	0	applied	\N	\N	\N	\N	211963	211963	379058
28357	46245	1	applied	\N	\N	\N	\N	211964	211964	379059
28364	46248	0	applied	\N	\N	\N	\N	211979	211979	379074
28364	46251	2	applied	\N	\N	\N	\N	211981	211981	379076
28364	46249	3	applied	\N	\N	\N	\N	211982	211982	379077
28364	46252	4	applied	\N	\N	\N	\N	211983	211983	379078
28364	46253	5	applied	\N	\N	\N	\N	211984	211984	379079
28367	46256	0	applied	\N	\N	\N	\N	211989	211989	379084
28367	46257	1	applied	\N	\N	\N	\N	211990	211990	379085
28370	46258	0	applied	\N	\N	\N	\N	211995	211995	379090
28250	46024	46	applied	\N	\N	\N	\N	211540	211540	378649
28250	46036	47	applied	\N	\N	\N	\N	211541	211541	378650
28336	46204	5	applied	\N	\N	\N	\N	211867	211867	378964
28336	46205	6	applied	\N	\N	\N	\N	211868	211868	378965
28336	46206	7	applied	\N	\N	\N	\N	211869	211869	378966
28342	46211	0	applied	\N	\N	\N	\N	211892	211892	378989
28342	46212	1	applied	\N	\N	\N	\N	211893	211893	378990
28342	46213	2	applied	\N	\N	\N	\N	211894	211894	378991
28342	46214	3	applied	\N	\N	\N	\N	211895	211895	378992
28342	46215	4	applied	\N	\N	\N	\N	211896	211896	378993
28342	46216	5	applied	\N	\N	\N	\N	211897	211897	378994
28342	46217	6	applied	\N	\N	\N	\N	211898	211898	378995
28342	46218	7	applied	\N	\N	\N	\N	211899	211899	378996
28344	46219	0	applied	\N	\N	\N	\N	211908	211908	379005
28344	46220	1	applied	\N	\N	\N	\N	211909	211909	379006
28347	46221	0	applied	\N	\N	\N	\N	211920	211920	379017
28347	46223	2	applied	\N	\N	1000000000	\N	211922	211922	379019
28347	46224	3	applied	\N	\N	1000000000	\N	211923	211923	379020
28347	46225	4	applied	\N	\N	\N	\N	211924	211924	379021
28347	46226	5	applied	\N	\N	\N	\N	211925	211925	379022
28347	46227	6	applied	\N	\N	\N	\N	211926	211926	379023
28347	46228	7	applied	\N	\N	\N	\N	211927	211927	379024
28352	46233	0	applied	\N	\N	\N	\N	211952	211952	379047
28352	46234	1	applied	\N	\N	\N	\N	211953	211953	379048
28359	46244	0	applied	\N	\N	\N	\N	211967	211967	379062
28359	46245	1	applied	\N	\N	\N	\N	211968	211968	379063
28366	46256	0	applied	\N	\N	\N	\N	211987	211987	379082
28366	46257	1	applied	\N	\N	\N	\N	211988	211988	379083
28369	46258	0	applied	\N	\N	\N	\N	211993	211993	379088
28369	46259	1	applied	\N	\N	\N	\N	211994	211994	379089
28370	46259	1	applied	\N	\N	\N	\N	211996	211996	379091
28371	46258	0	applied	\N	\N	\N	\N	211997	211997	379092
28373	46260	0	applied	\N	\N	\N	\N	212001	212001	379096
28373	46261	1	applied	\N	\N	\N	\N	212002	212002	379097
28376	46262	0	applied	\N	\N	\N	\N	212007	212007	379102
28376	46263	2	applied	\N	\N	\N	\N	212008	212008	379103
28377	46223	0	applied	\N	\N	1000000000	\N	212009	212009	379104
28377	46237	1	applied	\N	\N	1000000000	\N	212010	212010	379105
28377	45885	2	applied	\N	\N	1000000000	\N	212011	212011	379106
28377	45847	3	applied	\N	\N	1000000000	\N	212012	212012	379107
28377	45871	4	applied	\N	\N	\N	\N	212013	212013	379108
28377	45749	5	applied	\N	\N	1000000000	\N	212014	212014	379109
28377	46224	7	applied	\N	\N	1000000000	\N	212016	212016	379110
28377	45889	8	applied	\N	\N	1000000000	\N	212017	212017	379111
28377	45890	9	applied	\N	\N	1000000000	\N	212018	212018	379112
28377	45677	10	applied	\N	\N	\N	\N	212019	212019	379113
28384	46273	0	applied	\N	\N	\N	\N	212046	212046	379137
28384	46274	1	applied	\N	\N	\N	\N	212047	212047	379138
28387	46273	0	applied	\N	\N	\N	\N	212052	212052	379143
28387	46274	1	applied	\N	\N	\N	\N	212053	212053	379144
28389	46270	0	applied	\N	\N	1000000000	\N	212057	212057	379148
28389	46275	1	applied	\N	\N	\N	\N	212058	212058	379149
28389	46223	2	applied	\N	\N	1000000000	\N	212059	212059	379150
28389	46237	3	applied	\N	\N	\N	\N	212060	212060	379151
28389	46183	4	applied	\N	\N	\N	\N	212061	212061	379152
28389	46224	5	applied	\N	\N	1000000000	\N	212062	212062	379153
28389	46136	6	applied	\N	\N	\N	\N	212063	212063	379154
28391	46275	0	applied	\N	\N	\N	\N	212067	212067	379158
28391	46276	1	applied	\N	\N	\N	\N	212068	212068	379159
28391	46277	2	applied	\N	\N	\N	\N	212069	212069	379160
28395	46280	0	applied	\N	\N	\N	\N	212078	212078	379169
28395	46281	1	applied	\N	\N	\N	\N	212079	212079	379170
28400	46284	0	applied	\N	\N	\N	\N	212088	212088	379179
28400	46285	1	applied	\N	\N	\N	\N	212089	212089	379180
28400	46286	2	applied	\N	\N	\N	\N	212090	212090	379181
28402	46287	0	applied	\N	\N	\N	\N	212095	212095	379186
28402	46288	1	applied	\N	\N	\N	\N	212096	212096	379187
28402	46289	2	applied	\N	\N	\N	\N	212097	212097	379188
28402	46290	3	applied	\N	\N	\N	\N	212098	212098	379189
28405	46291	0	applied	\N	\N	\N	\N	212103	212103	379194
28405	46292	1	applied	\N	\N	\N	\N	212104	212104	379195
28409	46293	0	applied	\N	\N	\N	\N	212112	212112	379203
28409	46295	2	applied	\N	\N	\N	\N	212114	212114	379205
28415	46296	0	applied	\N	\N	\N	\N	212165	212165	379256
28415	46298	1	applied	\N	\N	\N	\N	212166	212166	379257
28415	46299	2	applied	\N	\N	\N	\N	212167	212167	379258
28415	46300	3	applied	\N	\N	\N	\N	212168	212168	379259
28415	46301	4	applied	\N	\N	\N	\N	212169	212169	379260
28418	46306	0	applied	\N	\N	\N	\N	212174	212174	379265
28418	46307	1	applied	\N	\N	\N	\N	212175	212175	379266
28418	46308	2	applied	\N	\N	\N	\N	212176	212176	379267
28418	46309	3	applied	\N	\N	\N	\N	212177	212177	379268
28418	46310	4	applied	\N	\N	\N	\N	212178	212178	379269
28421	46315	0	applied	\N	\N	\N	\N	212187	212187	379278
28421	46316	1	applied	\N	\N	\N	\N	212188	212188	379279
28425	46331	0	applied	\N	\N	\N	\N	212210	212210	379301
28425	46332	1	applied	\N	\N	\N	\N	212211	212211	379302
28432	46339	0	applied	\N	\N	\N	\N	212261	212261	379352
28432	46340	2	applied	\N	\N	\N	\N	212262	212262	379353
28435	46348	0	applied	\N	\N	\N	\N	212272	212272	379363
28437	46348	0	applied	\N	\N	\N	\N	212315	212315	379401
28437	46349	1	applied	\N	\N	\N	\N	212316	212316	379402
28439	46348	0	applied	\N	\N	\N	\N	212319	212319	379405
28439	46349	1	applied	\N	\N	\N	\N	212320	212320	379406
28444	46357	0	applied	\N	\N	\N	\N	212330	212330	379416
28444	46358	1	applied	\N	\N	\N	\N	212331	212331	379417
28444	46359	2	applied	\N	\N	\N	\N	212332	212332	379418
28444	46360	3	applied	\N	\N	\N	\N	212333	212333	379419
28444	46361	4	applied	\N	\N	\N	\N	212334	212334	379420
28447	46362	0	applied	\N	\N	\N	\N	212344	212344	379430
28447	46363	1	applied	\N	\N	\N	\N	212345	212345	379431
28447	46364	2	applied	\N	\N	\N	\N	212346	212346	379432
28447	46365	3	applied	\N	\N	\N	\N	212347	212347	379433
28449	46362	0	applied	\N	\N	\N	\N	212352	212352	379438
28449	46363	1	applied	\N	\N	\N	\N	212353	212353	379439
28449	46364	2	applied	\N	\N	\N	\N	212354	212354	379440
28454	46374	0	applied	\N	\N	\N	\N	212368	212368	379454
28454	46375	1	applied	\N	\N	\N	\N	212369	212369	379455
28458	46376	0	applied	\N	\N	\N	\N	212376	212376	379462
28458	46377	1	applied	\N	\N	\N	\N	212377	212377	379463
28336	46202	3	applied	\N	\N	\N	\N	211865	211865	378962
28336	46203	4	applied	\N	\N	\N	\N	211866	211866	378963
28346	46228	7	applied	\N	\N	\N	\N	211919	211919	379016
28349	46229	0	applied	\N	\N	\N	\N	211944	211944	379039
28349	46230	1	applied	\N	\N	\N	\N	211945	211945	379040
28349	46231	2	applied	\N	\N	\N	\N	211946	211946	379041
28349	46232	3	applied	\N	\N	\N	\N	211947	211947	379042
28356	46242	0	applied	\N	\N	\N	\N	211961	211961	379056
28356	46243	1	applied	\N	\N	\N	\N	211962	211962	379057
28358	46244	0	applied	\N	\N	\N	\N	211965	211965	379060
28358	46245	1	applied	\N	\N	\N	\N	211966	211966	379061
28361	46247	1	applied	\N	\N	\N	\N	211972	211972	379067
28363	46250	0	applied	\N	\N	\N	\N	211975	211975	379070
28363	46251	1	applied	\N	\N	\N	\N	211976	211976	379071
28363	46252	2	applied	\N	\N	\N	\N	211977	211977	379072
28363	46253	3	applied	\N	\N	\N	\N	211978	211978	379073
28368	46258	0	applied	\N	\N	\N	\N	211991	211991	379086
28368	46259	1	applied	\N	\N	\N	\N	211992	211992	379087
28372	46260	0	applied	\N	\N	\N	\N	211999	211999	379094
28372	46261	1	applied	\N	\N	\N	\N	212000	212000	379095
28375	46262	0	applied	\N	\N	\N	\N	212005	212005	379100
28375	46263	2	applied	\N	\N	\N	\N	212006	212006	379101
28377	45941	11	applied	\N	\N	\N	\N	212020	212020	379114
28377	46070	12	applied	\N	\N	\N	\N	212021	212021	212021
28377	46106	13	applied	\N	\N	\N	\N	212022	212022	212022
28377	46136	14	applied	\N	\N	\N	\N	212023	212023	379115
28377	46127	15	applied	\N	\N	\N	\N	212024	212024	212024
28377	45790	17	applied	\N	\N	\N	\N	212026	212026	379117
28377	45801	18	applied	\N	\N	\N	\N	212027	212027	379118
28377	45811	19	applied	\N	\N	\N	\N	212028	212028	379119
28377	45818	20	applied	\N	\N	\N	\N	212029	212029	379120
28377	45832	21	applied	\N	\N	\N	\N	212030	212030	379121
28377	45844	22	applied	\N	\N	\N	\N	212031	212031	379122
28377	45853	23	applied	\N	\N	\N	\N	212032	212032	379123
28379	46264	0	applied	\N	\N	\N	\N	212035	212035	379126
28379	46265	1	applied	\N	\N	\N	\N	212036	212036	379127
28381	46266	0	applied	\N	\N	\N	\N	212039	212039	379130
28381	46267	1	applied	\N	\N	\N	\N	212040	212040	379131
28383	46270	0	applied	\N	\N	\N	\N	212043	212043	379134
28383	46271	1	applied	\N	\N	\N	\N	212044	212044	379135
28383	46272	2	applied	\N	\N	\N	\N	212045	212045	379136
28386	46273	0	applied	\N	\N	\N	\N	212050	212050	379141
28386	46274	1	applied	\N	\N	\N	\N	212051	212051	379142
28388	46275	0	applied	\N	\N	\N	\N	212054	212054	379145
28388	46276	1	applied	\N	\N	\N	\N	212055	212055	379146
28390	46275	0	applied	\N	\N	\N	\N	212064	212064	379155
28390	46276	1	applied	\N	\N	\N	\N	212065	212065	379156
28390	46277	2	applied	\N	\N	\N	\N	212066	212066	379157
28392	46275	0	applied	\N	\N	\N	\N	212070	212070	379161
28392	46276	1	applied	\N	\N	\N	\N	212071	212071	379162
28392	46277	2	applied	\N	\N	\N	\N	212072	212072	379163
28394	46278	0	applied	\N	\N	\N	\N	212076	212076	379167
28394	46279	1	applied	\N	\N	\N	\N	212077	212077	379168
28397	46281	0	applied	\N	\N	\N	\N	212082	212082	379173
28398	46282	0	applied	\N	\N	\N	\N	212083	212083	379174
28398	46283	1	applied	\N	\N	\N	\N	212084	212084	379175
28399	46284	0	applied	\N	\N	\N	\N	212085	212085	379176
28399	46285	1	applied	\N	\N	\N	\N	212086	212086	379177
28399	46286	2	applied	\N	\N	\N	\N	212087	212087	379178
28401	46287	0	applied	\N	\N	\N	\N	212091	212091	379182
28401	46288	1	applied	\N	\N	\N	\N	212092	212092	379183
28401	46290	3	applied	\N	\N	\N	\N	212094	212094	379185
28403	46291	0	applied	\N	\N	\N	\N	212099	212099	379190
28403	46292	1	applied	\N	\N	\N	\N	212100	212100	379191
28404	46291	0	applied	\N	\N	\N	\N	212101	212101	379192
28404	46292	1	applied	\N	\N	\N	\N	212102	212102	379193
28406	46291	0	applied	\N	\N	\N	\N	212105	212105	379196
28406	46292	1	applied	\N	\N	\N	\N	212106	212106	379197
28408	46293	0	applied	\N	\N	\N	\N	212109	212109	379200
28408	46294	1	applied	\N	\N	1000000000	\N	212110	212110	379201
28408	46295	2	applied	\N	\N	\N	\N	212111	212111	379202
28411	46293	0	applied	\N	\N	\N	\N	212118	212118	379209
28411	46294	1	applied	\N	\N	1000000000	\N	212119	212119	379210
28411	46295	2	applied	\N	\N	\N	\N	212120	212120	379211
28412	46296	0	applied	\N	\N	\N	\N	212121	212121	379212
28412	46297	1	applied	\N	\N	\N	\N	212122	212122	379213
28414	46270	0	applied	\N	\N	\N	\N	212124	212124	379215
28417	46304	0	applied	\N	\N	\N	\N	212172	212172	379263
28417	46305	1	applied	\N	\N	\N	\N	212173	212173	379264
28420	46311	0	applied	\N	\N	\N	\N	212183	212183	379274
28420	46312	1	applied	\N	\N	\N	\N	212184	212184	379275
28420	46313	2	applied	\N	\N	\N	\N	212185	212185	379276
28420	46314	3	applied	\N	\N	\N	\N	212186	212186	379277
28424	46317	0	applied	\N	\N	\N	\N	212196	212196	379287
28424	46318	1	applied	\N	\N	\N	\N	212197	212197	379288
28424	46319	2	applied	\N	\N	\N	\N	212198	212198	379289
28424	46320	3	applied	\N	\N	\N	\N	212199	212199	379290
28424	46321	4	applied	\N	\N	\N	\N	212200	212200	379291
28424	46322	5	applied	\N	\N	\N	\N	212201	212201	379292
28424	46323	6	applied	\N	\N	\N	\N	212202	212202	379293
28424	46324	7	applied	\N	\N	\N	\N	212203	212203	379294
28424	46325	8	applied	\N	\N	\N	\N	212204	212204	379295
28424	46326	9	applied	\N	\N	\N	\N	212205	212205	379296
28424	46328	11	applied	\N	\N	\N	\N	212207	212207	379298
28424	46329	12	applied	\N	\N	\N	\N	212208	212208	379299
28424	46330	13	applied	\N	\N	\N	\N	212209	212209	379300
28429	46333	0	applied	\N	\N	\N	\N	212253	212253	379344
28429	46334	1	applied	\N	\N	\N	\N	212254	212254	379345
28429	46335	2	applied	\N	\N	\N	\N	212255	212255	379346
28429	46336	3	applied	\N	\N	\N	\N	212256	212256	379347
28434	46341	0	applied	\N	\N	\N	\N	212265	212265	379356
28434	46342	1	applied	\N	\N	\N	\N	212266	212266	379357
28434	46343	2	applied	\N	\N	\N	\N	212267	212267	379358
28434	46344	3	applied	\N	\N	1000000000	\N	212268	212268	379359
28434	46345	4	applied	\N	\N	\N	\N	212269	212269	379360
28434	46346	5	applied	\N	\N	\N	\N	212270	212270	379361
28434	46347	6	applied	\N	\N	\N	\N	212271	212271	379362
28441	46352	0	applied	\N	\N	\N	\N	212323	212323	379409
28441	46353	1	applied	\N	\N	\N	\N	212324	212324	379410
28446	46362	0	applied	\N	\N	\N	\N	212340	212340	379426
28446	46363	1	applied	\N	\N	\N	\N	212341	212341	379427
28346	46226	5	applied	\N	\N	\N	\N	211917	211917	379014
28346	46227	6	applied	\N	\N	\N	\N	211918	211918	379015
28351	46234	1	applied	\N	\N	\N	\N	211951	211951	379046
28355	46237	0	applied	\N	\N	1000000000	\N	211956	211956	379051
28355	46238	1	applied	\N	\N	\N	\N	211957	211957	379052
28355	46239	2	applied	\N	\N	\N	\N	211958	211958	379053
28355	46240	3	applied	\N	\N	\N	\N	211959	211959	379054
28355	46241	4	applied	\N	\N	\N	\N	211960	211960	379055
28360	46246	0	applied	\N	\N	\N	\N	211969	211969	379064
28362	46248	0	applied	\N	\N	\N	\N	211973	211973	379068
28362	46249	1	applied	\N	\N	\N	\N	211974	211974	379069
28365	46254	0	applied	\N	\N	\N	\N	211985	211985	379080
28365	46255	1	applied	\N	\N	\N	\N	211986	211986	379081
28374	46262	0	applied	\N	\N	\N	\N	212003	212003	379098
28374	46263	2	applied	\N	\N	\N	\N	212004	212004	379099
28378	46264	0	applied	\N	\N	\N	\N	212033	212033	379124
28378	46265	1	applied	\N	\N	\N	\N	212034	212034	379125
28380	46266	0	applied	\N	\N	\N	\N	212037	212037	379128
28380	46267	1	applied	\N	\N	\N	\N	212038	212038	379129
28382	46268	0	applied	\N	\N	\N	\N	212041	212041	379132
28382	46269	1	applied	\N	\N	\N	\N	212042	212042	379133
28385	46273	0	applied	\N	\N	\N	\N	212048	212048	379139
28385	46274	1	applied	\N	\N	\N	\N	212049	212049	379140
28393	46275	0	applied	\N	\N	\N	\N	212073	212073	379164
28393	46276	1	applied	\N	\N	\N	\N	212074	212074	379165
28396	46280	0	applied	\N	\N	\N	\N	212080	212080	379171
28396	46281	1	applied	\N	\N	\N	\N	212081	212081	379172
28407	46291	0	applied	\N	\N	\N	\N	212107	212107	379198
28407	46292	1	applied	\N	\N	\N	\N	212108	212108	379199
28410	46293	0	applied	\N	\N	\N	\N	212115	212115	379206
28410	46294	1	applied	\N	\N	1000000000	\N	212116	212116	379207
28410	46295	2	applied	\N	\N	\N	\N	212117	212117	379208
28413	46297	0	applied	\N	\N	\N	\N	212123	212123	379214
28414	46294	2	applied	\N	\N	1000000000	\N	212126	212126	379217
28414	46254	3	applied	\N	\N	\N	\N	212127	212127	379218
28414	46256	4	applied	\N	\N	\N	\N	212128	212128	379219
28414	46258	5	applied	\N	\N	\N	\N	212129	212129	379220
28414	46260	6	applied	\N	\N	\N	\N	212130	212130	379221
28414	46262	7	applied	\N	\N	\N	\N	212131	212131	379222
28414	46264	8	applied	\N	\N	\N	\N	212132	212132	379223
28414	46266	9	applied	\N	\N	\N	\N	212133	212133	379224
28414	46271	11	applied	\N	\N	\N	\N	212135	212135	379226
28414	46273	12	applied	\N	\N	\N	\N	212136	212136	379227
28414	46276	13	applied	\N	\N	\N	\N	212137	212137	379228
28414	46278	14	applied	\N	\N	\N	\N	212138	212138	379229
28414	46280	15	applied	\N	\N	\N	\N	212139	212139	379230
28414	46282	16	applied	\N	\N	\N	\N	212140	212140	379231
28414	46284	17	applied	\N	\N	\N	\N	212141	212141	379232
28414	46287	18	applied	\N	\N	\N	\N	212142	212142	379233
28414	46288	20	applied	\N	\N	\N	\N	212143	212143	379234
28414	46291	21	applied	\N	\N	\N	\N	212144	212144	379235
28414	46293	22	applied	\N	\N	\N	\N	212145	212145	379236
28414	46285	23	applied	\N	\N	\N	\N	212146	212146	379237
28414	46255	24	applied	\N	\N	\N	\N	212147	212147	379238
28414	46257	25	applied	\N	\N	\N	\N	212148	212148	379239
28414	46259	26	applied	\N	\N	\N	\N	212149	212149	379240
28414	46261	27	applied	\N	\N	\N	\N	212150	212150	379241
28414	46265	29	applied	\N	\N	\N	\N	212152	212152	379243
28414	46267	30	applied	\N	\N	\N	\N	212153	212153	379244
28414	46269	31	applied	\N	\N	\N	\N	212154	212154	379245
28414	46272	32	applied	\N	\N	\N	\N	212155	212155	379246
28414	46274	33	applied	\N	\N	\N	\N	212156	212156	379247
28414	46277	34	applied	\N	\N	\N	\N	212157	212157	379248
28414	46279	35	applied	\N	\N	\N	\N	212158	212158	379249
28414	46281	36	applied	\N	\N	\N	\N	212159	212159	379250
28414	46283	37	applied	\N	\N	\N	\N	212160	212160	379251
28414	46286	38	applied	\N	\N	\N	\N	212161	212161	379252
28414	46289	39	applied	\N	\N	\N	\N	212162	212162	379253
28414	46290	40	applied	\N	\N	\N	\N	212163	212163	379254
28414	46292	41	applied	\N	\N	\N	\N	212164	212164	379255
28416	46302	0	applied	\N	\N	\N	\N	212170	212170	379261
28416	46303	1	applied	\N	\N	\N	\N	212171	212171	379262
28419	46311	0	applied	\N	\N	\N	\N	212179	212179	379270
28419	46313	2	applied	\N	\N	\N	\N	212181	212181	379272
28419	46314	3	applied	\N	\N	\N	\N	212182	212182	379273
28422	46315	0	applied	\N	\N	\N	\N	212189	212189	379280
28422	46316	1	applied	\N	\N	\N	\N	212190	212190	379281
28423	46270	0	applied	\N	\N	1000000000	\N	212191	212191	379282
28423	46237	1	applied	\N	\N	\N	\N	212192	212192	379283
28423	46275	2	applied	\N	\N	\N	\N	212193	212193	379284
28423	46294	3	applied	\N	\N	1000000000	\N	212194	212194	379285
28423	46285	4	applied	\N	\N	\N	\N	212195	212195	379286
28426	46331	0	applied	\N	\N	\N	\N	212212	212212	379303
28426	46332	1	applied	\N	\N	\N	\N	212213	212213	379304
28427	46331	0	applied	\N	\N	\N	\N	212214	212214	379305
28427	46332	1	applied	\N	\N	\N	\N	212215	212215	379306
28428	46296	0	applied	\N	\N	\N	\N	212216	212216	379307
28428	46298	1	applied	\N	\N	\N	\N	212217	212217	379308
28428	46299	2	applied	\N	\N	\N	\N	212218	212218	379309
28428	46304	4	applied	\N	\N	\N	\N	212220	212220	379311
28428	46306	5	applied	\N	\N	\N	\N	212221	212221	379312
28428	46307	6	applied	\N	\N	\N	\N	212222	212222	379313
28428	46311	7	applied	\N	\N	\N	\N	212223	212223	379314
28428	46312	8	applied	\N	\N	\N	\N	212224	212224	379315
28428	46315	9	applied	\N	\N	\N	\N	212225	212225	379316
28428	46317	10	applied	\N	\N	\N	\N	212226	212226	379317
28428	46318	11	applied	\N	\N	\N	\N	212227	212227	379318
28428	46319	12	applied	\N	\N	\N	\N	212228	212228	379319
28428	46320	13	applied	\N	\N	\N	\N	212229	212229	379320
28428	46321	14	applied	\N	\N	\N	\N	212230	212230	379321
28428	46322	15	applied	\N	\N	\N	\N	212231	212231	379322
28428	46323	16	applied	\N	\N	\N	\N	212232	212232	379323
28428	46331	17	applied	\N	\N	\N	\N	212233	212233	379324
28428	46308	18	applied	\N	\N	\N	\N	212234	212234	379325
28428	46297	19	applied	\N	\N	\N	\N	212235	212235	379326
28428	46301	21	applied	\N	\N	\N	\N	212237	212237	379328
28430	46337	0	applied	\N	\N	\N	\N	212257	212257	379348
28430	46338	1	applied	\N	\N	\N	\N	212258	212258	379349
28442	46355	0	applied	\N	\N	\N	\N	212326	212326	379412
28442	46356	1	applied	\N	\N	\N	\N	212327	212327	379413
28455	46374	0	applied	\N	\N	\N	\N	212370	212370	379456
28348	46171	15	applied	\N	\N	\N	\N	211943	211943	379038
28351	46233	0	applied	\N	\N	\N	\N	211950	211950	379045
28428	46310	25	applied	\N	\N	\N	\N	212241	212241	379332
28428	46313	26	applied	\N	\N	\N	\N	212242	212242	379333
28428	46314	27	applied	\N	\N	\N	\N	212243	212243	379334
28428	46316	28	applied	\N	\N	\N	\N	212244	212244	379335
28428	46324	29	applied	\N	\N	\N	\N	212245	212245	379336
28428	46325	30	applied	\N	\N	\N	\N	212246	212246	379337
28428	46326	31	applied	\N	\N	\N	\N	212247	212247	379338
28428	46327	32	applied	\N	\N	\N	\N	212248	212248	379339
28428	46328	33	applied	\N	\N	\N	\N	212249	212249	379340
28428	46329	34	applied	\N	\N	\N	\N	212250	212250	379341
28428	46332	36	applied	\N	\N	\N	\N	212252	212252	379343
28431	46337	0	applied	\N	\N	\N	\N	212259	212259	379350
28431	46338	1	applied	\N	\N	\N	\N	212260	212260	379351
28433	46339	0	applied	\N	\N	\N	\N	212263	212263	379354
28433	46340	2	applied	\N	\N	\N	\N	212264	212264	379355
28436	46270	0	applied	\N	\N	1000000000	\N	212274	212274	379365
28436	46275	1	applied	\N	\N	\N	\N	212275	212275	379366
28436	46223	2	applied	\N	\N	1000000000	\N	212276	212276	379367
28436	46237	3	applied	\N	\N	\N	\N	212277	212277	379368
28436	46294	4	applied	\N	\N	1000000000	\N	212278	212278	379369
28436	46344	5	applied	\N	\N	1000000000	\N	212279	212279	379370
28436	46224	7	applied	\N	\N	1000000000	\N	212281	212281	379371
28436	46070	8	applied	\N	\N	\N	\N	212282	212282	212282
28436	46106	9	applied	\N	\N	\N	\N	212283	212283	212283
28436	46136	10	applied	\N	\N	\N	\N	212284	212284	379372
28436	45966	11	applied	\N	\N	\N	\N	212285	212285	379373
28436	45971	12	applied	\N	\N	\N	\N	212286	212286	379374
28436	46127	13	applied	\N	\N	\N	\N	212287	212287	212287
28436	46076	14	applied	\N	\N	1000000000	\N	212288	212288	379375
28436	45978	15	applied	\N	\N	\N	\N	212289	212289	379376
28436	45988	16	applied	\N	\N	\N	\N	212290	212290	379377
28436	45994	17	applied	\N	\N	\N	\N	212291	212291	379378
28436	46001	18	applied	\N	\N	\N	\N	212292	212292	379379
28436	46011	19	applied	\N	\N	\N	\N	212293	212293	379380
28436	46017	20	applied	\N	\N	\N	\N	212294	212294	379381
28436	46024	21	applied	\N	\N	\N	\N	212295	212295	379382
28436	46036	22	applied	\N	\N	\N	\N	212296	212296	379383
28436	46043	23	applied	\N	\N	\N	\N	212297	212297	379384
28436	46051	24	applied	\N	\N	\N	\N	212298	212298	379385
28436	46061	25	applied	\N	\N	\N	\N	212299	212299	379386
28436	46067	26	applied	\N	\N	\N	\N	212300	212300	379387
28436	46077	27	applied	\N	\N	\N	\N	212301	212301	379388
28436	46086	28	applied	\N	\N	\N	\N	212302	212302	379389
28455	46375	1	applied	\N	\N	\N	\N	212371	212371	379457
28460	46378	0	applied	\N	\N	\N	\N	212380	212380	379466
28460	46379	1	applied	\N	\N	\N	\N	212381	212381	379467
28466	46382	0	applied	\N	\N	\N	\N	212392	212392	379478
28466	46383	1	applied	\N	\N	\N	\N	212393	212393	379479
28472	46394	0	applied	\N	\N	\N	\N	212410	212410	379496
28472	46395	1	applied	\N	\N	\N	\N	212411	212411	379497
28477	46404	1	applied	\N	\N	\N	\N	212422	212422	379508
28482	46407	0	applied	\N	\N	\N	\N	212431	212431	379517
28482	46408	1	applied	\N	\N	\N	\N	212432	212432	379518
28484	46407	0	applied	\N	\N	\N	\N	212435	212435	379521
28484	46408	1	applied	\N	\N	\N	\N	212436	212436	379522
28488	46411	0	applied	\N	\N	\N	\N	212443	212443	379529
28488	46412	1	applied	\N	\N	\N	\N	212444	212444	379530
28488	46413	2	applied	\N	\N	\N	\N	212445	212445	379531
28491	46416	0	applied	\N	\N	\N	\N	212455	212455	379541
28491	46417	1	applied	\N	\N	\N	\N	212456	212456	379542
28491	46418	2	applied	\N	\N	\N	\N	212457	212457	379543
28491	46419	3	applied	\N	\N	\N	\N	212458	212458	379544
28491	46420	4	applied	\N	\N	\N	\N	212459	212459	379545
28491	46421	5	applied	\N	\N	\N	\N	212460	212460	379546
28491	46422	6	applied	\N	\N	\N	\N	212461	212461	379547
28493	46423	0	applied	\N	\N	\N	\N	212469	212469	379555
28498	46427	0	applied	\N	\N	\N	\N	212479	212479	379565
28498	46428	1	applied	\N	\N	\N	\N	212480	212480	379566
28498	46429	2	applied	\N	\N	\N	\N	212481	212481	379567
28498	46430	3	applied	\N	\N	\N	\N	212482	212482	379568
28498	46431	4	applied	\N	\N	\N	\N	212483	212483	379569
28498	46432	5	applied	\N	\N	\N	\N	212484	212484	379570
28498	46433	6	applied	\N	\N	\N	\N	212485	212485	379571
28503	46439	0	applied	\N	\N	\N	\N	212497	212497	379583
28503	46440	1	applied	\N	\N	\N	\N	212498	212498	379584
28503	46441	2	applied	\N	\N	\N	\N	212499	212499	379585
28507	46442	0	applied	\N	\N	\N	\N	212509	212509	379595
28507	46443	1	applied	\N	\N	\N	\N	212510	212510	379596
28509	46444	0	applied	\N	\N	\N	\N	212532	212532	379613
28509	46445	1	applied	\N	\N	\N	\N	212533	212533	379614
28509	46446	2	applied	\N	\N	\N	\N	212534	212534	379615
28513	46447	0	applied	\N	\N	\N	\N	212546	212546	379627
28513	46449	2	applied	\N	\N	1000000000	\N	212548	212548	379629
28513	46450	3	applied	\N	\N	\N	\N	212549	212549	379630
28513	46451	4	applied	\N	\N	\N	\N	212550	212550	379631
28516	46452	0	applied	\N	\N	\N	\N	212560	212560	379641
28516	46453	1	applied	\N	\N	\N	\N	212561	212561	379642
28516	46454	2	applied	\N	\N	\N	\N	212562	212562	379643
28516	46455	3	applied	\N	\N	\N	\N	212563	212563	379644
28520	46459	0	applied	\N	\N	\N	\N	212573	212573	379654
28520	46460	1	applied	\N	\N	\N	\N	212574	212574	379655
28520	46461	2	applied	\N	\N	\N	\N	212575	212575	379656
28522	46459	0	applied	\N	\N	\N	\N	212579	212579	379660
28522	46460	1	applied	\N	\N	\N	\N	212580	212580	379661
28522	46461	2	applied	\N	\N	\N	\N	212581	212581	379662
28524	46462	0	applied	\N	\N	\N	\N	212587	212587	379668
28524	46463	1	applied	\N	\N	\N	\N	212588	212588	379669
28524	46464	2	applied	\N	\N	\N	\N	212589	212589	379670
28524	46466	4	applied	\N	\N	\N	\N	212591	212591	379672
28529	46473	0	applied	\N	\N	\N	\N	212611	212611	379692
28529	46474	1	applied	\N	\N	\N	\N	212612	212612	379693
28529	46475	2	applied	\N	\N	\N	\N	212613	212613	379694
28529	46476	3	applied	\N	\N	\N	\N	212614	212614	379695
28534	46488	0	applied	\N	\N	\N	\N	212630	212630	379711
28534	46489	1	applied	\N	\N	\N	\N	212631	212631	379712
28536	46490	0	applied	\N	\N	\N	\N	212634	212634	379715
28536	46491	1	applied	\N	\N	1000000000	\N	212635	212635	379716
28536	46492	2	applied	\N	\N	\N	\N	212636	212636	379717
28536	46493	3	applied	\N	\N	\N	\N	212637	212637	379718
28428	46305	23	applied	\N	\N	\N	\N	212239	212239	379330
28428	46309	24	applied	\N	\N	\N	\N	212240	212240	379331
28436	46116	32	applied	\N	\N	\N	\N	212306	212306	379393
28436	46123	33	applied	\N	\N	\N	\N	212307	212307	379394
28436	46135	34	applied	\N	\N	\N	\N	212308	212308	379395
28436	46141	36	applied	\N	\N	\N	\N	212310	212310	379396
28436	46049	35	failed	Amount_insufficient_to_create_account	\N	\N	\N	212309	212309	\N
28436	46148	37	applied	\N	\N	\N	\N	212311	212311	379397
28436	46155	38	applied	\N	\N	\N	\N	212312	212312	379398
28436	46162	39	applied	\N	\N	\N	\N	212313	212313	379399
28436	46171	40	applied	\N	\N	\N	\N	212314	212314	379400
28438	46348	0	applied	\N	\N	\N	\N	212317	212317	379403
28438	46349	1	applied	\N	\N	\N	\N	212318	212318	379404
28440	46350	0	applied	\N	\N	\N	\N	212321	212321	379407
28440	46351	1	applied	\N	\N	\N	\N	212322	212322	379408
28443	46356	1	applied	\N	\N	\N	\N	212329	212329	379415
28445	46357	0	applied	\N	\N	\N	\N	212335	212335	379421
28445	46358	1	applied	\N	\N	\N	\N	212336	212336	379422
28445	46359	2	applied	\N	\N	\N	\N	212337	212337	379423
28445	46360	3	applied	\N	\N	\N	\N	212338	212338	379424
28445	46361	4	applied	\N	\N	\N	\N	212339	212339	379425
28446	46364	2	applied	\N	\N	\N	\N	212342	212342	379428
28446	46365	3	applied	\N	\N	\N	\N	212343	212343	379429
28448	46362	0	applied	\N	\N	\N	\N	212348	212348	379434
28448	46363	1	applied	\N	\N	\N	\N	212349	212349	379435
28448	46364	2	applied	\N	\N	\N	\N	212350	212350	379436
28448	46365	3	applied	\N	\N	\N	\N	212351	212351	379437
28450	46366	0	applied	\N	\N	\N	\N	212356	212356	379442
28450	46367	1	applied	\N	\N	\N	\N	212357	212357	379443
28451	46366	0	applied	\N	\N	\N	\N	212358	212358	379444
28451	46367	1	applied	\N	\N	\N	\N	212359	212359	379445
28452	46369	1	applied	\N	\N	\N	\N	212361	212361	379447
28452	46370	2	applied	\N	\N	\N	\N	212362	212362	379448
28452	46371	3	applied	\N	\N	\N	\N	212363	212363	379449
28452	46372	4	applied	\N	\N	\N	\N	212364	212364	379450
28452	46373	5	applied	\N	\N	\N	\N	212365	212365	379451
28453	46374	0	applied	\N	\N	\N	\N	212366	212366	379452
28453	46375	1	applied	\N	\N	\N	\N	212367	212367	379453
28456	46374	0	applied	\N	\N	\N	\N	212372	212372	379458
28456	46375	1	applied	\N	\N	\N	\N	212373	212373	379459
28457	46376	0	applied	\N	\N	\N	\N	212374	212374	379460
28457	46377	1	applied	\N	\N	\N	\N	212375	212375	379461
28461	46378	0	applied	\N	\N	\N	\N	212382	212382	379468
28461	46379	1	applied	\N	\N	\N	\N	212383	212383	379469
28464	46382	0	applied	\N	\N	\N	\N	212388	212388	379474
28464	46383	1	applied	\N	\N	\N	\N	212389	212389	379475
28465	46382	0	applied	\N	\N	\N	\N	212390	212390	379476
28468	46344	0	applied	\N	\N	1000000000	\N	212396	212396	379482
28468	46354	1	applied	\N	\N	\N	\N	212397	212397	379483
28470	46386	0	applied	\N	\N	\N	\N	212402	212402	379488
28470	46387	1	applied	\N	\N	\N	\N	212403	212403	379489
28470	46388	2	applied	\N	\N	\N	\N	212404	212404	379490
28470	46389	3	applied	\N	\N	\N	\N	212405	212405	379491
28473	46396	0	applied	\N	\N	\N	\N	212412	212412	379498
28473	46397	1	applied	\N	\N	\N	\N	212413	212413	379499
28473	46398	2	applied	\N	\N	\N	\N	212414	212414	379500
28475	46401	0	applied	\N	\N	\N	\N	212417	212417	379503
28475	46402	1	applied	\N	\N	\N	\N	212418	212418	379504
28476	46403	0	applied	\N	\N	\N	\N	212419	212419	379505
28476	46404	1	applied	\N	\N	\N	\N	212420	212420	379506
28478	46405	0	applied	\N	\N	\N	\N	212423	212423	379509
28478	46406	1	applied	\N	\N	\N	\N	212424	212424	379510
28480	46405	0	applied	\N	\N	\N	\N	212427	212427	379513
28486	46409	0	applied	\N	\N	\N	\N	212439	212439	379525
28486	46410	1	applied	\N	\N	\N	\N	212440	212440	379526
28487	46409	0	applied	\N	\N	\N	\N	212441	212441	379527
28487	46410	1	applied	\N	\N	\N	\N	212442	212442	379528
28489	46414	0	applied	\N	\N	\N	\N	212446	212446	379532
28489	46415	1	applied	\N	\N	\N	\N	212447	212447	379533
28490	46416	0	applied	\N	\N	\N	\N	212448	212448	379534
28490	46417	1	applied	\N	\N	\N	\N	212449	212449	379535
28490	46418	2	applied	\N	\N	\N	\N	212450	212450	379536
28490	46419	3	applied	\N	\N	\N	\N	212451	212451	379537
28490	46420	4	applied	\N	\N	\N	\N	212452	212452	379538
28490	46421	5	applied	\N	\N	\N	\N	212453	212453	379539
28490	46422	6	applied	\N	\N	\N	\N	212454	212454	379540
28492	46416	0	applied	\N	\N	\N	\N	212462	212462	379548
28492	46417	1	applied	\N	\N	\N	\N	212463	212463	379549
28492	46418	2	applied	\N	\N	\N	\N	212464	212464	379550
28492	46420	4	applied	\N	\N	\N	\N	212466	212466	379552
28496	46425	0	applied	\N	\N	\N	\N	212475	212475	379561
28496	46426	1	applied	\N	\N	\N	\N	212476	212476	379562
28499	46434	0	applied	\N	\N	\N	\N	212486	212486	379572
28499	46435	1	applied	\N	\N	\N	\N	212487	212487	379573
28501	46436	0	applied	\N	\N	\N	\N	212491	212491	379577
28501	46437	1	applied	\N	\N	\N	\N	212492	212492	379578
28501	46438	2	applied	\N	\N	\N	\N	212493	212493	379579
28504	46439	0	applied	\N	\N	\N	\N	212500	212500	379586
28504	46440	1	applied	\N	\N	\N	\N	212501	212501	379587
28504	46441	2	applied	\N	\N	\N	\N	212502	212502	379588
28506	46439	0	applied	\N	\N	\N	\N	212506	212506	379592
28506	46440	1	applied	\N	\N	\N	\N	212507	212507	379593
28506	46441	2	applied	\N	\N	\N	\N	212508	212508	379594
28508	46275	1	applied	\N	\N	\N	\N	212512	212512	379598
28508	46223	2	applied	\N	\N	1000000000	\N	212513	212513	379599
28508	46237	3	applied	\N	\N	\N	\N	212514	212514	379600
28508	46294	4	applied	\N	\N	1000000000	\N	212515	212515	379601
28508	46412	5	applied	\N	\N	\N	\N	212516	212516	379602
28508	46419	6	applied	\N	\N	\N	\N	212517	212517	379603
28508	46344	7	applied	\N	\N	1000000000	\N	212518	212518	379604
28508	46224	9	applied	\N	\N	1000000000	\N	212520	212520	379605
28508	46047	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	212519	212519	\N
28508	46070	10	applied	\N	\N	\N	\N	212521	212521	212521
28508	46106	11	applied	\N	\N	\N	\N	212522	212522	212522
28508	46431	12	applied	\N	\N	\N	\N	212523	212523	379606
28508	46136	13	applied	\N	\N	\N	\N	212524	212524	379607
28508	46127	14	applied	\N	\N	\N	\N	212525	212525	212525
28508	46076	15	applied	\N	\N	1000000000	\N	212526	212526	379608
28508	46354	16	applied	\N	\N	\N	\N	212527	212527	379609
28436	46100	30	applied	\N	\N	\N	\N	212304	212304	379391
28436	46109	31	applied	\N	\N	\N	\N	212305	212305	379392
28462	46381	1	applied	\N	\N	\N	\N	212385	212385	379471
28463	46380	0	applied	\N	\N	\N	\N	212386	212386	379472
28463	46381	1	applied	\N	\N	\N	\N	212387	212387	379473
28467	46384	0	applied	\N	\N	\N	\N	212394	212394	379480
28467	46385	1	applied	\N	\N	\N	\N	212395	212395	379481
28469	46386	0	applied	\N	\N	\N	\N	212398	212398	379484
28469	46387	1	applied	\N	\N	\N	\N	212399	212399	379485
28469	46389	3	applied	\N	\N	\N	\N	212401	212401	379487
28471	46390	0	applied	\N	\N	\N	\N	212406	212406	379492
28471	46391	1	applied	\N	\N	\N	\N	212407	212407	379493
28471	46392	2	applied	\N	\N	\N	\N	212408	212408	379494
28471	46393	3	applied	\N	\N	\N	\N	212409	212409	379495
28474	46399	0	applied	\N	\N	\N	\N	212415	212415	379501
28474	46400	1	applied	\N	\N	\N	\N	212416	212416	379502
28479	46405	0	applied	\N	\N	\N	\N	212425	212425	379511
28479	46406	1	applied	\N	\N	\N	\N	212426	212426	379512
28481	46407	0	applied	\N	\N	\N	\N	212429	212429	379515
28481	46408	1	applied	\N	\N	\N	\N	212430	212430	379516
28483	46407	0	applied	\N	\N	\N	\N	212433	212433	379519
28483	46408	1	applied	\N	\N	\N	\N	212434	212434	379520
28485	46409	0	applied	\N	\N	\N	\N	212437	212437	379523
28485	46410	1	applied	\N	\N	\N	\N	212438	212438	379524
28492	46421	5	applied	\N	\N	\N	\N	212467	212467	379553
28494	46423	0	applied	\N	\N	\N	\N	212471	212471	379557
28494	46424	1	applied	\N	\N	\N	\N	212472	212472	379558
28495	46425	0	applied	\N	\N	\N	\N	212473	212473	379559
28495	46426	1	applied	\N	\N	\N	\N	212474	212474	379560
28497	46425	0	applied	\N	\N	\N	\N	212477	212477	379563
28497	46426	1	applied	\N	\N	\N	\N	212478	212478	379564
28500	46436	0	applied	\N	\N	\N	\N	212488	212488	379574
28500	46437	1	applied	\N	\N	\N	\N	212489	212489	379575
28500	46438	2	applied	\N	\N	\N	\N	212490	212490	379576
28502	46436	0	applied	\N	\N	\N	\N	212494	212494	379580
28502	46437	1	applied	\N	\N	\N	\N	212495	212495	379581
28502	46438	2	applied	\N	\N	\N	\N	212496	212496	379582
28505	46439	0	applied	\N	\N	\N	\N	212503	212503	379589
28505	46440	1	applied	\N	\N	\N	\N	212504	212504	379590
28505	46441	2	applied	\N	\N	\N	\N	212505	212505	379591
28510	46444	0	applied	\N	\N	\N	\N	212535	212535	379616
28510	46446	2	applied	\N	\N	\N	\N	212537	212537	379618
28511	46444	0	applied	\N	\N	\N	\N	212538	212538	379619
28511	46445	1	applied	\N	\N	\N	\N	212539	212539	379620
28511	46446	2	applied	\N	\N	\N	\N	212540	212540	379621
28512	46447	0	applied	\N	\N	\N	\N	212541	212541	379622
28512	46448	1	applied	\N	\N	\N	\N	212542	212542	379623
28512	46449	2	applied	\N	\N	1000000000	\N	212543	212543	379624
28512	46450	3	applied	\N	\N	\N	\N	212544	212544	379625
28512	46451	4	applied	\N	\N	\N	\N	212545	212545	379626
28514	46447	0	applied	\N	\N	\N	\N	212551	212551	379632
28514	46448	1	applied	\N	\N	\N	\N	212552	212552	379633
28514	46449	2	applied	\N	\N	1000000000	\N	212553	212553	379634
28514	46450	3	applied	\N	\N	\N	\N	212554	212554	379635
28514	46451	4	applied	\N	\N	\N	\N	212555	212555	379636
28515	46452	0	applied	\N	\N	\N	\N	212556	212556	379637
28515	46453	1	applied	\N	\N	\N	\N	212557	212557	379638
28515	46455	3	applied	\N	\N	\N	\N	212559	212559	379640
28517	46449	0	applied	\N	\N	1000000000	\N	212564	212564	379645
28517	46450	1	applied	\N	\N	\N	\N	212565	212565	379646
28519	46456	0	applied	\N	\N	\N	\N	212570	212570	379651
28519	46457	1	applied	\N	\N	\N	\N	212571	212571	379652
28519	46458	2	applied	\N	\N	\N	\N	212572	212572	379653
28521	46459	0	applied	\N	\N	\N	\N	212576	212576	379657
28521	46460	1	applied	\N	\N	\N	\N	212577	212577	379658
28521	46461	2	applied	\N	\N	\N	\N	212578	212578	379659
28523	46462	0	applied	\N	\N	\N	\N	212582	212582	379663
28523	46463	1	applied	\N	\N	\N	\N	212583	212583	379664
28523	46464	2	applied	\N	\N	\N	\N	212584	212584	379665
28523	46465	3	applied	\N	\N	\N	\N	212585	212585	379666
28523	46466	4	applied	\N	\N	\N	\N	212586	212586	379667
28526	46467	0	applied	\N	\N	\N	\N	212597	212597	379678
28526	46468	1	applied	\N	\N	\N	\N	212598	212598	379679
28526	46470	3	applied	\N	\N	\N	\N	212600	212600	379681
28526	46471	4	applied	\N	\N	\N	\N	212601	212601	379682
28528	46473	0	applied	\N	\N	\N	\N	212607	212607	379688
28528	46474	1	applied	\N	\N	\N	\N	212608	212608	379689
28528	46475	2	applied	\N	\N	\N	\N	212609	212609	379690
28528	46476	3	applied	\N	\N	\N	\N	212610	212610	379691
28530	46477	0	applied	\N	\N	\N	\N	212615	212615	379696
28530	46478	1	applied	\N	\N	\N	\N	212616	212616	379697
28530	46479	2	applied	\N	\N	\N	\N	212617	212617	379698
28533	46488	0	applied	\N	\N	\N	\N	212628	212628	379709
28533	46489	1	applied	\N	\N	\N	\N	212629	212629	379710
28537	46494	0	applied	\N	\N	\N	\N	212638	212638	379719
28537	46495	1	applied	\N	\N	\N	\N	212639	212639	379720
28540	46494	0	applied	\N	\N	\N	\N	212644	212644	379725
28540	46495	1	applied	\N	\N	\N	\N	212645	212645	379726
28542	46397	0	applied	\N	\N	\N	\N	212648	212648	379729
28542	46359	2	applied	\N	\N	\N	\N	212650	212650	379731
28542	46419	3	applied	\N	\N	\N	\N	212651	212651	379732
28542	46468	4	applied	\N	\N	\N	\N	212652	212652	379733
28542	46454	5	applied	\N	\N	\N	\N	212653	212653	379734
28542	46465	6	applied	\N	\N	\N	\N	212654	212654	379735
28542	46449	7	applied	\N	\N	1000000000	\N	212655	212655	379736
28542	46450	8	applied	\N	\N	\N	\N	212656	212656	379737
28542	46354	9	applied	\N	\N	\N	\N	212657	212657	379738
28542	46471	10	applied	\N	\N	\N	\N	212658	212658	379739
28542	46475	11	applied	\N	\N	\N	\N	212659	212659	379740
28542	46487	12	applied	\N	\N	\N	\N	212660	212660	379741
28542	46492	13	applied	\N	\N	\N	\N	212661	212661	379742
28542	46498	14	applied	\N	\N	\N	\N	212662	212662	379743
28542	46472	15	applied	\N	\N	\N	\N	212663	212663	379744
28544	46503	0	applied	\N	\N	\N	\N	212670	212670	379751
28544	46504	1	applied	\N	\N	\N	\N	212671	212671	379752
28544	46505	2	applied	\N	\N	\N	\N	212672	212672	379753
28550	46506	0	applied	\N	\N	\N	\N	212684	212684	379765
28550	46507	1	applied	\N	\N	\N	\N	212685	212685	379766
28557	46512	0	applied	\N	\N	\N	\N	212702	212702	379783
28557	46513	1	applied	\N	\N	\N	\N	212703	212703	379784
28557	46514	2	applied	\N	\N	\N	\N	212704	212704	379785
28459	46379	1	applied	\N	\N	\N	\N	212379	212379	379465
28462	46380	0	applied	\N	\N	\N	\N	212384	212384	379470
28518	46453	1	applied	\N	\N	\N	\N	212567	212567	379648
28518	46454	2	applied	\N	\N	\N	\N	212568	212568	379649
28518	46455	3	applied	\N	\N	\N	\N	212569	212569	379650
28525	46462	0	applied	\N	\N	\N	\N	212592	212592	379673
28525	46463	1	applied	\N	\N	\N	\N	212593	212593	379674
28525	46464	2	applied	\N	\N	\N	\N	212594	212594	379675
28525	46465	3	applied	\N	\N	\N	\N	212595	212595	379676
28525	46466	4	applied	\N	\N	\N	\N	212596	212596	379677
28526	46472	5	applied	\N	\N	\N	\N	212602	212602	379683
28527	46473	0	applied	\N	\N	\N	\N	212603	212603	379684
28527	46474	1	applied	\N	\N	\N	\N	212604	212604	379685
28527	46475	2	applied	\N	\N	\N	\N	212605	212605	379686
28531	46480	0	applied	\N	\N	\N	\N	212618	212618	379699
28531	46481	1	applied	\N	\N	\N	\N	212619	212619	379700
28531	46482	2	applied	\N	\N	\N	\N	212620	212620	379701
28531	46483	3	applied	\N	\N	\N	\N	212621	212621	379702
28531	46484	4	applied	\N	\N	\N	\N	212622	212622	379703
28531	46485	5	applied	\N	\N	\N	\N	212623	212623	379704
28531	46486	6	applied	\N	\N	\N	\N	212624	212624	379705
28531	46487	7	applied	\N	\N	\N	\N	212625	212625	379706
28532	46488	0	applied	\N	\N	\N	\N	212626	212626	379707
28532	46489	1	applied	\N	\N	\N	\N	212627	212627	379708
28535	46488	0	applied	\N	\N	\N	\N	212632	212632	379713
28535	46489	1	applied	\N	\N	\N	\N	212633	212633	379714
28538	46494	0	applied	\N	\N	\N	\N	212640	212640	379721
28538	46495	1	applied	\N	\N	\N	\N	212641	212641	379722
28539	46494	0	applied	\N	\N	\N	\N	212642	212642	379723
28539	46495	1	applied	\N	\N	\N	\N	212643	212643	379724
28541	46497	2	applied	\N	\N	\N	\N	212647	212647	379728
28545	46503	0	applied	\N	\N	\N	\N	212673	212673	379754
28545	46504	1	applied	\N	\N	\N	\N	212674	212674	379755
28545	46505	2	applied	\N	\N	\N	\N	212675	212675	379756
28546	46503	0	applied	\N	\N	\N	\N	212676	212676	379757
28546	46505	1	applied	\N	\N	\N	\N	212677	212677	379758
28547	46506	0	applied	\N	\N	\N	\N	212678	212678	379759
28547	46507	1	applied	\N	\N	\N	\N	212679	212679	379760
28549	46506	0	applied	\N	\N	\N	\N	212682	212682	379763
28549	46507	1	applied	\N	\N	\N	\N	212683	212683	379764
28551	46506	0	applied	\N	\N	\N	\N	212686	212686	379767
28551	46507	1	applied	\N	\N	\N	\N	212687	212687	379768
28553	46508	0	applied	\N	\N	\N	\N	212690	212690	379771
28553	46509	1	applied	\N	\N	\N	\N	212691	212691	379772
28553	46510	2	applied	\N	\N	\N	\N	212692	212692	379773
28553	46511	3	applied	\N	\N	\N	\N	212693	212693	379774
28555	46509	1	applied	\N	\N	\N	\N	212699	212699	379780
28555	46510	2	applied	\N	\N	\N	\N	212700	212700	379781
28555	46511	3	applied	\N	\N	\N	\N	212701	212701	379782
28558	46515	0	applied	\N	\N	\N	\N	212705	212705	379786
28558	46516	1	applied	\N	\N	\N	\N	212706	212706	379787
28558	46517	2	applied	\N	\N	1000000000	\N	212707	212707	379788
28558	46518	3	applied	\N	\N	\N	\N	212708	212708	379789
28558	46519	4	applied	\N	\N	\N	\N	212709	212709	379790
28558	46520	5	applied	\N	\N	\N	\N	212710	212710	379791
28558	46521	6	applied	\N	\N	\N	\N	212711	212711	379792
28559	46512	0	applied	\N	\N	\N	\N	212712	212712	379793
28559	46515	1	applied	\N	\N	\N	\N	212713	212713	379794
28559	46516	2	applied	\N	\N	\N	\N	212714	212714	379795
28559	46522	3	applied	\N	\N	\N	\N	212715	212715	379796
28559	46521	5	applied	\N	\N	\N	\N	212717	212717	379798
28559	46513	6	applied	\N	\N	\N	\N	212718	212718	379799
28559	46518	7	applied	\N	\N	\N	\N	212719	212719	379800
28559	46523	8	applied	\N	\N	\N	\N	212720	212720	379801
28559	46514	9	applied	\N	\N	\N	\N	212721	212721	379802
28559	46519	10	applied	\N	\N	\N	\N	212722	212722	379803
28559	46520	11	applied	\N	\N	\N	\N	212723	212723	379804
28559	46524	12	applied	\N	\N	\N	\N	212724	212724	379805
28561	46525	0	applied	\N	\N	\N	\N	212728	212728	379809
28561	46526	1	applied	\N	\N	\N	\N	212729	212729	379810
28561	46527	2	applied	\N	\N	\N	\N	212730	212730	379811
28561	46528	3	applied	\N	\N	\N	\N	212731	212731	379812
28561	46529	4	applied	\N	\N	\N	\N	212732	212732	379813
28561	46530	5	applied	\N	\N	\N	\N	212733	212733	379814
28561	46531	6	applied	\N	\N	\N	\N	212734	212734	379815
28561	46532	7	applied	\N	\N	\N	\N	212735	212735	379816
28561	46533	8	applied	\N	\N	\N	\N	212736	212736	379817
28563	46534	0	applied	\N	\N	\N	\N	212746	212746	379827
28563	46535	1	applied	\N	\N	\N	\N	212747	212747	379828
28563	46536	2	applied	\N	\N	\N	\N	212748	212748	379829
28567	46545	1	applied	\N	\N	\N	\N	212771	212771	379852
28567	46546	2	applied	\N	\N	\N	\N	212772	212772	379853
28567	46547	3	applied	\N	\N	\N	\N	212773	212773	379854
28567	46548	4	applied	\N	\N	\N	\N	212774	212774	379855
28567	46549	5	applied	\N	\N	\N	\N	212775	212775	379856
28567	46550	6	applied	\N	\N	\N	\N	212776	212776	379857
28571	46553	0	applied	\N	\N	\N	\N	212818	212818	379899
28571	46554	1	applied	\N	\N	\N	\N	212819	212819	379900
28571	46555	2	applied	\N	\N	\N	\N	212820	212820	379901
28571	46556	3	applied	\N	\N	\N	\N	212821	212821	379902
28571	46557	4	applied	\N	\N	\N	\N	212822	212822	379903
28571	46558	5	applied	\N	\N	\N	\N	212823	212823	379904
28573	46462	0	applied	\N	\N	\N	\N	212830	212830	379911
28573	46463	1	applied	\N	\N	\N	\N	212831	212831	379912
28573	46467	2	applied	\N	\N	\N	\N	212832	212832	379913
28573	46473	3	applied	\N	\N	\N	\N	212833	212833	379914
28573	46480	5	applied	\N	\N	\N	\N	212835	212835	379916
28573	46481	6	applied	\N	\N	\N	\N	212836	212836	379917
28573	46488	7	applied	\N	\N	\N	\N	212837	212837	379918
28573	46490	8	applied	\N	\N	\N	\N	212838	212838	379919
28573	46494	9	applied	\N	\N	\N	\N	212839	212839	379920
28573	46496	10	applied	\N	\N	\N	\N	212840	212840	379921
28573	46499	11	applied	\N	\N	\N	\N	212841	212841	379922
28573	46503	12	applied	\N	\N	\N	\N	212842	212842	379923
28573	46506	13	applied	\N	\N	\N	\N	212843	212843	379924
28573	46508	14	applied	\N	\N	\N	\N	212844	212844	379925
28573	46512	15	applied	\N	\N	\N	\N	212845	212845	379926
28573	46515	16	applied	\N	\N	\N	\N	212846	212846	379927
28573	46516	17	applied	\N	\N	\N	\N	212847	212847	379928
28573	46522	18	applied	\N	\N	\N	\N	212848	212848	379929
28573	46525	19	applied	\N	\N	\N	\N	212849	212849	379930
28508	46441	19	applied	\N	\N	\N	\N	212530	212530	379611
28518	46452	0	applied	\N	\N	\N	\N	212566	212566	379647
28543	46502	3	applied	\N	\N	\N	\N	212668	212668	379749
28543	46498	4	applied	\N	\N	\N	\N	212669	212669	379750
28548	46506	0	applied	\N	\N	\N	\N	212680	212680	379761
28548	46507	1	applied	\N	\N	\N	\N	212681	212681	379762
28552	46506	0	applied	\N	\N	\N	\N	212688	212688	379769
28552	46507	1	applied	\N	\N	\N	\N	212689	212689	379770
28554	46508	0	applied	\N	\N	\N	\N	212694	212694	379775
28554	46509	1	applied	\N	\N	\N	\N	212695	212695	379776
28554	46510	2	applied	\N	\N	\N	\N	212696	212696	379777
28554	46511	3	applied	\N	\N	\N	\N	212697	212697	379778
28562	46525	0	applied	\N	\N	\N	\N	212737	212737	379818
28562	46527	2	applied	\N	\N	\N	\N	212739	212739	379820
28562	46528	3	applied	\N	\N	\N	\N	212740	212740	379821
28562	46529	4	applied	\N	\N	\N	\N	212741	212741	379822
28562	46530	5	applied	\N	\N	\N	\N	212742	212742	379823
28562	46531	6	applied	\N	\N	\N	\N	212743	212743	379824
28562	46532	7	applied	\N	\N	\N	\N	212744	212744	379825
28562	46533	8	applied	\N	\N	\N	\N	212745	212745	379826
28564	46537	0	applied	\N	\N	\N	\N	212749	212749	379830
28564	46538	1	applied	\N	\N	\N	\N	212750	212750	379831
28564	46539	2	applied	\N	\N	\N	\N	212751	212751	379832
28564	46540	3	applied	\N	\N	\N	\N	212752	212752	379833
28564	46541	4	applied	\N	\N	\N	\N	212753	212753	379834
28564	46542	5	applied	\N	\N	\N	\N	212754	212754	379835
28564	46543	6	applied	\N	\N	\N	\N	212755	212755	379836
28566	46537	0	applied	\N	\N	\N	\N	212763	212763	379844
28566	46538	1	applied	\N	\N	\N	\N	212764	212764	379845
28566	46540	3	applied	\N	\N	\N	\N	212766	212766	379847
28566	46541	4	applied	\N	\N	\N	\N	212767	212767	379848
28566	46542	5	applied	\N	\N	\N	\N	212768	212768	379849
28566	46543	6	applied	\N	\N	\N	\N	212769	212769	379850
28567	46551	7	applied	\N	\N	\N	\N	212777	212777	379858
28567	46552	8	applied	\N	\N	\N	\N	212778	212778	379859
28569	46397	0	applied	\N	\N	\N	\N	212788	212788	379869
28569	46412	1	applied	\N	\N	\N	\N	212789	212789	379870
28569	46419	2	applied	\N	\N	\N	\N	212790	212790	379871
28569	46468	3	applied	\N	\N	\N	\N	212791	212791	379872
28569	46454	4	applied	\N	\N	\N	\N	212792	212792	379873
28569	46465	6	applied	\N	\N	\N	\N	212793	212793	379874
28569	46449	7	applied	\N	\N	1000000000	\N	212794	212794	379875
28569	46450	8	applied	\N	\N	\N	\N	212795	212795	379876
28569	46471	9	applied	\N	\N	\N	\N	212796	212796	379877
28569	46475	10	applied	\N	\N	\N	\N	212797	212797	379878
28569	46492	12	applied	\N	\N	\N	\N	212799	212799	379880
28569	46498	13	applied	\N	\N	\N	\N	212800	212800	379881
28569	46509	14	applied	\N	\N	\N	\N	212801	212801	379882
28569	46521	15	applied	\N	\N	\N	\N	212802	212802	379883
28569	46533	16	applied	\N	\N	\N	\N	212803	212803	379884
28569	46540	17	applied	\N	\N	\N	\N	212804	212804	379885
28569	46549	18	applied	\N	\N	\N	\N	212805	212805	379886
28569	46472	19	applied	\N	\N	\N	\N	212806	212806	379887
28569	46491	20	applied	\N	\N	1000000000	\N	212807	212807	379888
28569	46517	21	applied	\N	\N	1000000000	\N	212808	212808	379889
28572	46553	0	applied	\N	\N	\N	\N	212824	212824	379905
28572	46554	1	applied	\N	\N	\N	\N	212825	212825	379906
28572	46555	2	applied	\N	\N	\N	\N	212826	212826	379907
28572	46556	3	applied	\N	\N	\N	\N	212827	212827	379908
28572	46557	4	applied	\N	\N	\N	\N	212828	212828	379909
28572	46558	5	applied	\N	\N	\N	\N	212829	212829	379910
28574	46554	1	applied	\N	\N	\N	\N	212928	212928	380009
28574	46555	2	applied	\N	\N	\N	\N	212929	212929	380010
28574	46556	3	applied	\N	\N	\N	\N	212930	212930	380011
28574	46557	4	applied	\N	\N	\N	\N	212931	212931	380012
28574	46558	5	applied	\N	\N	\N	\N	212932	212932	380013
28576	46560	0	applied	\N	\N	\N	\N	212939	212939	380020
28576	46561	1	applied	\N	\N	\N	\N	212940	212940	380021
28576	46562	2	applied	\N	\N	\N	\N	212941	212941	380022
28576	46563	3	applied	\N	\N	\N	\N	212942	212942	380023
28576	46564	4	applied	\N	\N	\N	\N	212943	212943	380024
28576	46565	5	applied	\N	\N	\N	\N	212944	212944	380025
28582	46567	0	applied	\N	\N	\N	\N	212972	212972	380053
28582	46568	1	applied	\N	\N	\N	\N	212973	212973	380054
28582	46569	2	applied	\N	\N	\N	\N	212974	212974	380055
28582	46570	3	applied	\N	\N	\N	\N	212975	212975	380056
28582	46571	4	applied	\N	\N	\N	\N	212976	212976	380057
28583	46573	1	applied	\N	\N	\N	\N	212978	212978	380059
28583	46574	2	applied	\N	\N	\N	\N	212979	212979	380060
28583	46575	3	applied	\N	\N	\N	\N	212980	212980	380061
28586	46585	0	applied	\N	\N	\N	\N	212994	212994	380075
28586	46586	1	applied	\N	\N	\N	\N	212995	212995	380076
28586	46587	2	applied	\N	\N	\N	\N	212996	212996	380077
28589	46588	0	applied	\N	\N	\N	\N	213000	213000	380081
28589	46589	2	applied	\N	\N	\N	\N	213001	213001	380082
28589	46590	3	applied	\N	\N	\N	\N	213002	213002	380083
28593	46595	0	applied	\N	\N	\N	\N	213013	213013	380094
28593	46596	1	applied	\N	\N	\N	\N	213014	213014	380095
28593	46597	2	applied	\N	\N	\N	\N	213015	213015	380096
28593	46598	3	applied	\N	\N	\N	\N	213016	213016	380097
28593	46599	4	applied	\N	\N	\N	\N	213017	213017	380098
28593	46600	5	applied	\N	\N	\N	\N	213018	213018	380099
28593	46601	6	applied	\N	\N	\N	\N	213019	213019	380100
28593	46603	8	applied	\N	\N	\N	\N	213021	213021	380102
28595	46595	0	applied	\N	\N	\N	\N	213031	213031	380112
28595	46596	1	applied	\N	\N	\N	\N	213032	213032	380113
28595	46597	2	applied	\N	\N	\N	\N	213033	213033	380114
28595	46598	3	applied	\N	\N	\N	\N	213034	213034	380115
28595	46599	4	applied	\N	\N	\N	\N	213035	213035	380116
28595	46600	5	applied	\N	\N	\N	\N	213036	213036	380117
28595	46601	6	applied	\N	\N	\N	\N	213037	213037	380118
28595	46602	7	applied	\N	\N	\N	\N	213038	213038	380119
28595	46603	8	applied	\N	\N	\N	\N	213039	213039	380120
28597	46604	0	applied	\N	\N	\N	\N	213049	213049	380130
28597	46605	1	applied	\N	\N	\N	\N	213050	213050	380131
28597	46606	2	applied	\N	\N	\N	\N	213051	213051	380132
28599	46607	0	applied	\N	\N	\N	\N	213055	213055	380136
28599	46608	1	applied	\N	\N	\N	\N	213056	213056	380137
28599	46609	2	applied	\N	\N	\N	\N	213057	213057	380138
28602	46611	1	applied	\N	\N	\N	\N	213065	213065	380146
28602	46612	2	applied	\N	\N	\N	\N	213066	213066	380147
28543	46500	1	applied	\N	\N	\N	\N	212666	212666	379747
28543	46501	2	applied	\N	\N	\N	\N	212667	212667	379748
28565	46537	0	applied	\N	\N	\N	\N	212756	212756	379837
28565	46538	1	applied	\N	\N	\N	\N	212757	212757	379838
28565	46539	2	applied	\N	\N	\N	\N	212758	212758	379839
28565	46540	3	applied	\N	\N	\N	\N	212759	212759	379840
28565	46541	4	applied	\N	\N	\N	\N	212760	212760	379841
28565	46542	5	applied	\N	\N	\N	\N	212761	212761	379842
28565	46543	6	applied	\N	\N	\N	\N	212762	212762	379843
28568	46545	1	applied	\N	\N	\N	\N	212780	212780	379861
28568	46546	2	applied	\N	\N	\N	\N	212781	212781	379862
28568	46547	3	applied	\N	\N	\N	\N	212782	212782	379863
28568	46548	4	applied	\N	\N	\N	\N	212783	212783	379864
28568	46549	5	applied	\N	\N	\N	\N	212784	212784	379865
28568	46550	6	applied	\N	\N	\N	\N	212785	212785	379866
28568	46551	7	applied	\N	\N	\N	\N	212786	212786	379867
28568	46552	8	applied	\N	\N	\N	\N	212787	212787	379868
28570	46544	0	applied	\N	\N	\N	\N	212809	212809	379890
28570	46545	1	applied	\N	\N	\N	\N	212810	212810	379891
28570	46546	2	applied	\N	\N	\N	\N	212811	212811	379892
28570	46547	3	applied	\N	\N	\N	\N	212812	212812	379893
28570	46548	4	applied	\N	\N	\N	\N	212813	212813	379894
28570	46549	5	applied	\N	\N	\N	\N	212814	212814	379895
28570	46550	6	applied	\N	\N	\N	\N	212815	212815	379896
28570	46551	7	applied	\N	\N	\N	\N	212816	212816	379897
28576	46566	6	applied	\N	\N	\N	\N	212945	212945	380026
28577	46560	0	applied	\N	\N	\N	\N	212946	212946	380027
28577	46561	1	applied	\N	\N	\N	\N	212947	212947	380028
28577	46562	2	applied	\N	\N	\N	\N	212948	212948	380029
28577	46563	3	applied	\N	\N	\N	\N	212949	212949	380030
28577	46564	4	applied	\N	\N	\N	\N	212950	212950	380031
28577	46565	5	applied	\N	\N	\N	\N	212951	212951	380032
28577	46566	6	applied	\N	\N	\N	\N	212952	212952	380033
28579	46556	0	applied	\N	\N	\N	\N	212960	212960	380041
28579	46565	1	applied	\N	\N	\N	\N	212961	212961	380042
28581	46567	0	applied	\N	\N	\N	\N	212967	212967	380048
28581	46568	1	applied	\N	\N	\N	\N	212968	212968	380049
28581	46569	2	applied	\N	\N	\N	\N	212969	212969	380050
28581	46570	3	applied	\N	\N	\N	\N	212970	212970	380051
28581	46571	4	applied	\N	\N	\N	\N	212971	212971	380052
28590	46588	0	applied	\N	\N	\N	\N	213003	213003	380084
28590	46590	3	applied	\N	\N	\N	\N	213005	213005	380086
28591	46588	0	applied	\N	\N	\N	\N	213006	213006	380087
28591	46589	2	applied	\N	\N	\N	\N	213007	213007	380088
28591	46590	3	applied	\N	\N	\N	\N	213008	213008	380089
28592	46591	0	applied	\N	\N	\N	\N	213009	213009	380090
28592	46592	1	applied	\N	\N	\N	\N	213010	213010	380091
28592	46593	2	applied	\N	\N	1000000000	\N	213011	213011	380092
28592	46594	3	applied	\N	\N	\N	\N	213012	213012	380093
28594	46595	0	applied	\N	\N	\N	\N	213022	213022	380103
28594	46596	1	applied	\N	\N	\N	\N	213023	213023	380104
28594	46597	2	applied	\N	\N	\N	\N	213024	213024	380105
28594	46598	3	applied	\N	\N	\N	\N	213025	213025	380106
28594	46599	4	applied	\N	\N	\N	\N	213026	213026	380107
28594	46600	5	applied	\N	\N	\N	\N	213027	213027	380108
28594	46601	6	applied	\N	\N	\N	\N	213028	213028	380109
28594	46602	7	applied	\N	\N	\N	\N	213029	213029	380110
28603	46614	1	applied	\N	\N	\N	\N	213068	213068	380149
28603	46615	2	applied	\N	\N	\N	\N	213069	213069	380150
28608	46620	0	applied	\N	\N	\N	\N	213086	213086	380167
28608	46621	1	applied	\N	\N	\N	\N	213087	213087	380168
28610	46620	0	applied	\N	\N	\N	\N	213090	213090	380171
28610	46621	1	applied	\N	\N	\N	\N	213091	213091	380172
28617	46634	0	applied	\N	\N	\N	\N	213108	213108	380189
28617	46635	1	applied	\N	\N	\N	\N	213109	213109	380190
28617	46636	2	applied	\N	\N	\N	\N	213110	213110	380191
28619	46637	0	applied	\N	\N	\N	\N	213115	213115	380196
28619	46638	1	applied	\N	\N	\N	\N	213116	213116	380197
28619	46639	2	applied	\N	\N	\N	\N	213117	213117	380198
28619	46640	3	applied	\N	\N	\N	\N	213118	213118	380199
28621	46637	0	applied	\N	\N	\N	\N	213123	213123	380204
28621	46638	1	applied	\N	\N	\N	\N	213124	213124	380205
28621	46639	2	applied	\N	\N	\N	\N	213125	213125	380206
28628	46649	0	applied	\N	\N	\N	\N	213178	213178	380259
28628	46650	1	applied	\N	\N	\N	\N	213179	213179	380260
28628	46651	2	applied	\N	\N	\N	\N	213180	213180	380261
28629	46652	0	applied	\N	\N	\N	\N	213181	213181	380262
28629	46653	1	applied	\N	\N	\N	\N	213182	213182	380263
28629	46654	2	applied	\N	\N	\N	\N	213183	213183	380264
28629	46655	3	applied	\N	\N	\N	\N	213184	213184	380265
28629	46656	4	applied	\N	\N	\N	\N	213185	213185	380266
28629	46657	5	applied	\N	\N	\N	\N	213186	213186	380267
28629	46658	6	applied	\N	\N	\N	\N	213187	213187	380268
28629	46659	7	applied	\N	\N	\N	\N	213188	213188	380269
28629	46660	8	applied	\N	\N	\N	\N	213189	213189	380270
28629	46661	9	applied	\N	\N	\N	\N	213190	213190	380271
28629	46662	10	applied	\N	\N	\N	\N	213191	213191	380272
28629	46663	11	applied	\N	\N	\N	\N	213192	213192	380273
28634	46666	0	applied	\N	\N	\N	\N	213200	213200	380281
28634	46668	2	applied	\N	\N	\N	\N	213202	213202	380283
28634	46669	3	applied	\N	\N	\N	\N	213203	213203	380284
28634	46670	4	applied	\N	\N	\N	\N	213204	213204	380285
28634	46671	5	applied	\N	\N	\N	\N	213205	213205	380286
28636	46672	0	applied	\N	\N	\N	\N	213212	213212	380293
28636	46673	1	applied	\N	\N	\N	\N	213213	213213	380294
28639	46595	0	applied	\N	\N	\N	\N	213218	213218	380299
28639	46597	1	applied	\N	\N	\N	\N	213219	213219	380300
28639	46598	2	applied	\N	\N	\N	\N	213220	213220	380301
28639	46599	3	applied	\N	\N	\N	\N	213221	213221	380302
28639	46468	4	applied	\N	\N	\N	\N	213222	213222	380303
28639	46556	5	applied	\N	\N	\N	\N	213223	213223	380304
28639	46465	6	applied	\N	\N	\N	\N	213224	213224	380305
28639	46449	7	applied	\N	\N	1000000000	\N	213225	213225	380306
28639	46450	8	applied	\N	\N	\N	\N	213226	213226	380307
28639	46445	9	applied	\N	\N	\N	\N	213227	213227	380308
28639	46455	11	applied	\N	\N	\N	\N	213229	213229	380310
28639	46457	12	applied	\N	\N	\N	\N	213230	213230	380311
28639	46472	13	applied	\N	\N	\N	\N	213231	213231	380312
28639	46491	14	applied	\N	\N	1000000000	\N	213232	213232	380313
28639	46517	15	applied	\N	\N	1000000000	\N	213233	213233	380314
28639	46593	16	applied	\N	\N	1000000000	\N	213234	213234	380315
28560	46524	1	applied	\N	\N	\N	\N	212726	212726	379807
28560	46523	2	applied	\N	\N	\N	\N	212727	212727	379808
28573	46537	23	applied	\N	\N	\N	\N	212853	212853	379934
28573	46538	24	applied	\N	\N	\N	\N	212854	212854	379935
28573	46544	25	applied	\N	\N	\N	\N	212855	212855	379936
28573	46545	26	applied	\N	\N	\N	\N	212856	212856	379937
28573	46546	27	applied	\N	\N	\N	\N	212857	212857	379938
28573	46553	28	applied	\N	\N	\N	\N	212858	212858	379939
28573	46554	29	applied	\N	\N	\N	\N	212859	212859	379940
28573	46468	30	applied	\N	\N	\N	\N	212860	212860	379941
28573	46464	31	applied	\N	\N	\N	\N	212861	212861	379942
28573	46556	32	applied	\N	\N	\N	\N	212862	212862	379943
28573	46465	33	applied	\N	\N	\N	\N	212863	212863	379944
28573	46470	34	applied	\N	\N	\N	\N	212864	212864	379945
28573	46476	35	applied	\N	\N	\N	\N	212865	212865	379946
28573	46475	37	applied	\N	\N	\N	\N	212867	212867	379948
28573	46487	38	applied	\N	\N	\N	\N	212868	212868	379949
28573	46492	39	applied	\N	\N	\N	\N	212869	212869	379950
28573	46498	40	applied	\N	\N	\N	\N	212870	212870	379951
28573	46509	41	applied	\N	\N	\N	\N	212871	212871	379952
28573	46521	42	applied	\N	\N	\N	\N	212872	212872	379953
28573	46533	43	applied	\N	\N	\N	\N	212873	212873	379954
28573	46540	44	applied	\N	\N	\N	\N	212874	212874	379955
28573	46549	45	applied	\N	\N	\N	\N	212875	212875	379956
28573	46472	46	applied	\N	\N	\N	\N	212876	212876	379957
28573	46491	47	applied	\N	\N	1000000000	\N	212877	212877	379958
28573	46517	48	applied	\N	\N	1000000000	\N	212878	212878	379959
28573	46466	49	applied	\N	\N	\N	\N	212879	212879	379960
28573	46469	50	applied	\N	\N	\N	\N	212880	212880	379961
28573	46474	52	applied	\N	\N	\N	\N	212881	212881	379962
28573	46478	53	applied	\N	\N	\N	\N	212882	212882	379963
28573	46483	55	applied	\N	\N	\N	\N	212884	212884	379965
28573	46489	56	applied	\N	\N	\N	\N	212885	212885	379966
28573	46493	57	applied	\N	\N	\N	\N	212886	212886	379967
28573	46495	58	applied	\N	\N	\N	\N	212887	212887	379968
28573	46497	59	applied	\N	\N	\N	\N	212888	212888	379969
28573	46500	60	applied	\N	\N	\N	\N	212889	212889	379970
28573	46502	61	applied	\N	\N	\N	\N	212890	212890	379971
28573	46504	62	applied	\N	\N	\N	\N	212891	212891	379972
28573	46507	63	applied	\N	\N	\N	\N	212892	212892	379973
28573	46510	64	applied	\N	\N	\N	\N	212893	212893	379974
28573	46514	65	applied	\N	\N	\N	\N	212894	212894	379975
28573	46519	66	applied	\N	\N	\N	\N	212895	212895	379976
28573	46520	67	applied	\N	\N	\N	\N	212896	212896	379977
28594	46603	8	applied	\N	\N	\N	\N	213030	213030	380111
28600	46610	0	applied	\N	\N	\N	\N	213058	213058	380139
28600	46611	1	applied	\N	\N	\N	\N	213059	213059	380140
28611	46620	0	applied	\N	\N	\N	\N	213092	213092	380173
28611	46621	1	applied	\N	\N	\N	\N	213093	213093	380174
28616	46632	0	applied	\N	\N	\N	\N	213106	213106	380187
28616	46633	1	applied	\N	\N	\N	\N	213107	213107	380188
28618	46637	0	applied	\N	\N	\N	\N	213111	213111	380192
28618	46638	1	applied	\N	\N	\N	\N	213112	213112	380193
28618	46639	2	applied	\N	\N	\N	\N	213113	213113	380194
28618	46640	3	applied	\N	\N	\N	\N	213114	213114	380195
28620	46637	0	applied	\N	\N	\N	\N	213119	213119	380200
28620	46638	1	applied	\N	\N	\N	\N	213120	213120	380201
28620	46639	2	applied	\N	\N	\N	\N	213121	213121	380202
28620	46640	3	applied	\N	\N	\N	\N	213122	213122	380203
28625	46645	0	applied	\N	\N	\N	\N	213157	213157	380238
28625	46646	1	applied	\N	\N	\N	\N	213158	213158	380239
28625	46647	2	applied	\N	\N	\N	\N	213159	213159	380240
28625	46648	3	applied	\N	\N	\N	\N	213160	213160	380241
28633	46665	1	applied	\N	\N	\N	\N	213199	213199	380280
28637	46672	0	applied	\N	\N	\N	\N	213214	213214	380295
28637	46673	1	applied	\N	\N	\N	\N	213215	213215	380296
28641	46674	0	applied	\N	\N	\N	\N	213303	213303	380384
28641	46675	1	applied	\N	\N	\N	\N	213304	213304	380385
28646	46682	0	applied	\N	\N	\N	\N	213319	213319	380400
28646	46680	1	applied	\N	\N	\N	\N	213320	213320	380401
28646	46681	2	applied	\N	\N	\N	\N	213321	213321	380402
28648	46682	0	applied	\N	\N	\N	\N	213325	213325	380406
28648	46680	1	applied	\N	\N	\N	\N	213326	213326	380407
28648	46681	2	applied	\N	\N	\N	\N	213327	213327	380408
28650	46683	0	applied	\N	\N	\N	\N	213329	213329	380410
28655	46700	0	applied	\N	\N	\N	\N	213352	213352	380433
28655	46701	1	applied	\N	\N	\N	\N	213353	213353	380434
28655	46702	2	applied	\N	\N	\N	\N	213354	213354	380435
28655	46703	3	applied	\N	\N	\N	\N	213355	213355	380436
28655	46705	5	applied	\N	\N	\N	\N	213357	213357	380438
28657	46700	0	applied	\N	\N	\N	\N	213364	213364	380445
28657	46701	1	applied	\N	\N	\N	\N	213365	213365	380446
28657	46702	2	applied	\N	\N	\N	\N	213366	213366	380447
28657	46703	3	applied	\N	\N	\N	\N	213367	213367	380448
28657	46704	4	applied	\N	\N	\N	\N	213368	213368	380449
28657	46705	5	applied	\N	\N	\N	\N	213369	213369	380450
28661	46708	0	applied	\N	\N	\N	\N	213377	213377	380458
28663	46709	0	applied	\N	\N	\N	\N	213379	213379	380460
28663	46710	1	applied	\N	\N	\N	\N	213380	213380	380461
28663	46711	2	applied	\N	\N	\N	\N	213381	213381	380462
28667	46714	0	applied	\N	\N	\N	\N	213453	213453	380534
28667	46715	1	applied	\N	\N	\N	\N	213454	213454	380535
28681	46735	0	applied	\N	\N	\N	\N	213625	213625	380706
28681	46736	1	applied	\N	\N	\N	\N	213626	213626	380707
28683	46737	0	applied	\N	\N	\N	\N	213628	213628	380709
28683	46739	2	applied	\N	\N	\N	\N	213630	213630	380711
28686	46740	0	applied	\N	\N	\N	\N	213635	213635	380716
28686	46741	1	applied	\N	\N	\N	\N	213636	213636	380717
28686	46742	2	applied	\N	\N	\N	\N	213637	213637	380718
28686	46743	3	applied	\N	\N	\N	\N	213638	213638	380719
28690	46749	0	applied	\N	\N	\N	\N	213648	213648	380729
28690	46750	1	applied	\N	\N	\N	\N	213649	213649	380730
28690	46751	2	applied	\N	\N	\N	\N	213650	213650	380731
28690	46752	3	applied	\N	\N	\N	\N	213651	213651	380732
28697	46758	0	applied	\N	\N	\N	\N	213668	213668	380749
28697	46759	1	applied	\N	\N	\N	\N	213669	213669	380750
28697	46760	2	applied	\N	\N	\N	\N	213670	213670	380751
28699	46761	0	applied	\N	\N	\N	\N	213674	213674	380755
28699	46762	1	applied	\N	\N	\N	\N	213675	213675	380756
28699	46763	2	applied	\N	\N	\N	\N	213676	213676	380757
28699	46764	3	applied	\N	\N	\N	\N	213677	213677	380758
28573	46527	21	applied	\N	\N	\N	\N	212851	212851	379932
28573	46534	22	applied	\N	\N	\N	\N	212852	212852	379933
28573	46536	72	applied	\N	\N	\N	\N	212901	212901	379982
28573	46541	73	applied	\N	\N	\N	\N	212902	212902	379983
28573	46542	74	applied	\N	\N	\N	\N	212903	212903	379984
28573	46550	75	applied	\N	\N	\N	\N	212904	212904	379985
28573	46551	76	applied	\N	\N	\N	\N	212905	212905	379986
28573	46552	77	applied	\N	\N	\N	\N	212906	212906	379987
28573	46557	78	applied	\N	\N	\N	\N	212907	212907	379988
28573	46558	79	applied	\N	\N	\N	\N	212908	212908	379989
28573	46479	80	applied	\N	\N	\N	\N	212909	212909	379990
28573	46484	81	applied	\N	\N	\N	\N	212910	212910	379991
28573	46485	82	applied	\N	\N	\N	\N	212911	212911	379992
28573	46486	83	applied	\N	\N	\N	\N	212912	212912	379993
28573	46559	84	applied	\N	\N	\N	\N	212913	212913	379994
28573	46505	85	applied	\N	\N	\N	\N	212914	212914	379995
28573	46513	87	applied	\N	\N	\N	\N	212916	212916	379997
28573	46518	88	applied	\N	\N	\N	\N	212917	212917	379998
28573	46523	89	applied	\N	\N	\N	\N	212918	212918	379999
28573	46528	90	applied	\N	\N	\N	\N	212919	212919	380000
28573	46529	91	applied	\N	\N	\N	\N	212920	212920	380001
28573	46535	92	applied	\N	\N	\N	\N	212921	212921	380002
28573	46539	93	applied	\N	\N	\N	\N	212922	212922	380003
28573	46543	94	applied	\N	\N	\N	\N	212923	212923	380004
28573	46547	95	applied	\N	\N	\N	\N	212924	212924	380005
28573	46548	96	applied	\N	\N	\N	\N	212925	212925	380006
28573	46555	97	applied	\N	\N	\N	\N	212926	212926	380007
28575	46553	0	applied	\N	\N	\N	\N	212933	212933	380014
28575	46554	1	applied	\N	\N	\N	\N	212934	212934	380015
28575	46555	2	applied	\N	\N	\N	\N	212935	212935	380016
28575	46556	3	applied	\N	\N	\N	\N	212936	212936	380017
28575	46557	4	applied	\N	\N	\N	\N	212937	212937	380018
28578	46560	0	applied	\N	\N	\N	\N	212953	212953	380034
28578	46561	1	applied	\N	\N	\N	\N	212954	212954	380035
28578	46562	2	applied	\N	\N	\N	\N	212955	212955	380036
28578	46563	3	applied	\N	\N	\N	\N	212956	212956	380037
28578	46564	4	applied	\N	\N	\N	\N	212957	212957	380038
28578	46565	5	applied	\N	\N	\N	\N	212958	212958	380039
28578	46566	6	applied	\N	\N	\N	\N	212959	212959	380040
28580	46567	0	applied	\N	\N	\N	\N	212962	212962	380043
28580	46568	1	applied	\N	\N	\N	\N	212963	212963	380044
28580	46569	2	applied	\N	\N	\N	\N	212964	212964	380045
28580	46570	3	applied	\N	\N	\N	\N	212965	212965	380046
28580	46571	4	applied	\N	\N	\N	\N	212966	212966	380047
28584	46572	0	applied	\N	\N	\N	\N	212981	212981	380062
28584	46573	1	applied	\N	\N	\N	\N	212982	212982	380063
28584	46574	2	applied	\N	\N	\N	\N	212983	212983	380064
28584	46575	3	applied	\N	\N	\N	\N	212984	212984	380065
28585	46577	1	applied	\N	\N	\N	\N	212986	212986	380067
28585	46578	2	applied	\N	\N	\N	\N	212987	212987	380068
28585	46579	3	applied	\N	\N	\N	\N	212988	212988	380069
28585	46580	4	applied	\N	\N	\N	\N	212989	212989	380070
28585	46581	5	applied	\N	\N	\N	\N	212990	212990	380071
28585	46582	6	applied	\N	\N	\N	\N	212991	212991	380072
28585	46583	7	applied	\N	\N	\N	\N	212992	212992	380073
28585	46584	8	applied	\N	\N	\N	\N	212993	212993	380074
28587	46585	0	applied	\N	\N	\N	\N	212997	212997	380078
28587	46586	1	applied	\N	\N	\N	\N	212998	212998	380079
28587	46587	2	applied	\N	\N	\N	\N	212999	212999	380080
28596	46595	0	applied	\N	\N	\N	\N	213040	213040	380121
28596	46596	1	applied	\N	\N	\N	\N	213041	213041	380122
28596	46597	2	applied	\N	\N	\N	\N	213042	213042	380123
28596	46598	3	applied	\N	\N	\N	\N	213043	213043	380124
28596	46599	4	applied	\N	\N	\N	\N	213044	213044	380125
28596	46601	6	applied	\N	\N	\N	\N	213046	213046	380127
28596	46602	7	applied	\N	\N	\N	\N	213047	213047	380128
28596	46603	8	applied	\N	\N	\N	\N	213048	213048	380129
28598	46604	0	applied	\N	\N	\N	\N	213052	213052	380133
28598	46605	1	applied	\N	\N	\N	\N	213053	213053	380134
28598	46606	2	applied	\N	\N	\N	\N	213054	213054	380135
28601	46610	0	applied	\N	\N	\N	\N	213061	213061	380142
28601	46611	1	applied	\N	\N	\N	\N	213062	213062	380143
28601	46612	2	applied	\N	\N	\N	\N	213063	213063	380144
28605	46616	0	applied	\N	\N	\N	\N	213073	213073	380154
28605	46617	1	applied	\N	\N	\N	\N	213074	213074	380155
28605	46618	2	applied	\N	\N	\N	\N	213075	213075	380156
28605	46619	3	applied	\N	\N	\N	\N	213076	213076	380157
28607	46595	0	applied	\N	\N	\N	\N	213081	213081	380162
28607	46597	1	applied	\N	\N	\N	\N	213082	213082	380163
28607	46598	2	applied	\N	\N	\N	\N	213083	213083	380164
28607	46593	4	applied	\N	\N	1000000000	\N	213085	213085	380166
28614	46625	0	applied	\N	\N	\N	\N	213097	213097	380178
28614	46626	1	applied	\N	\N	\N	\N	213098	213098	380179
28614	46627	2	applied	\N	\N	\N	\N	213099	213099	380180
28614	46628	3	applied	\N	\N	\N	\N	213100	213100	380181
28614	46629	4	applied	\N	\N	\N	\N	213101	213101	380182
28614	46630	5	applied	\N	\N	\N	\N	213102	213102	380183
28614	46631	6	applied	\N	\N	\N	\N	213103	213103	380184
28623	46595	0	applied	\N	\N	\N	\N	213130	213130	380211
28623	46597	1	applied	\N	\N	\N	\N	213131	213131	380212
28623	46598	2	applied	\N	\N	\N	\N	213132	213132	380213
28623	46599	3	applied	\N	\N	\N	\N	213133	213133	380214
28623	46468	4	applied	\N	\N	\N	\N	213134	213134	380215
28623	46556	5	applied	\N	\N	\N	\N	213135	213135	380216
28623	46454	6	applied	\N	\N	\N	\N	213136	213136	380217
28623	46465	7	applied	\N	\N	\N	\N	213137	213137	380218
28623	46475	9	applied	\N	\N	\N	\N	213139	213139	380220
28623	46487	10	applied	\N	\N	\N	\N	213140	213140	380221
28623	46492	11	applied	\N	\N	\N	\N	213141	213141	380222
28623	46498	12	applied	\N	\N	\N	\N	213142	213142	380223
28623	46509	13	applied	\N	\N	\N	\N	213143	213143	380224
28623	46521	14	applied	\N	\N	\N	\N	213144	213144	380225
28623	46533	15	applied	\N	\N	\N	\N	213145	213145	380226
28623	46540	16	applied	\N	\N	\N	\N	213146	213146	380227
28623	46549	17	applied	\N	\N	\N	\N	213147	213147	380228
28623	46565	18	applied	\N	\N	\N	\N	213148	213148	380229
28623	46574	19	applied	\N	\N	\N	\N	213149	213149	380230
28623	46580	20	applied	\N	\N	\N	\N	213150	213150	380231
28623	46594	21	applied	\N	\N	\N	\N	213151	213151	380232
28623	46609	22	applied	\N	\N	\N	\N	213152	213152	380233
28623	46619	23	applied	\N	\N	\N	\N	213153	213153	380234
28623	46631	24	applied	\N	\N	\N	\N	213154	213154	380235
28573	46532	71	applied	\N	\N	\N	\N	212900	212900	379981
28606	46617	1	applied	\N	\N	\N	\N	213078	213078	380159
28606	46618	2	applied	\N	\N	\N	\N	213079	213079	380160
28606	46619	3	applied	\N	\N	\N	\N	213080	213080	380161
28609	46620	0	applied	\N	\N	\N	\N	213088	213088	380169
28609	46621	1	applied	\N	\N	\N	\N	213089	213089	380170
28613	46622	0	applied	\N	\N	\N	\N	213094	213094	380175
28613	46623	1	applied	\N	\N	\N	\N	213095	213095	380176
28613	46624	2	applied	\N	\N	\N	\N	213096	213096	380177
28615	46632	0	applied	\N	\N	\N	\N	213104	213104	380185
28615	46633	1	applied	\N	\N	\N	\N	213105	213105	380186
28622	46641	0	applied	\N	\N	\N	\N	213127	213127	380208
28622	46642	1	applied	\N	\N	\N	\N	213128	213128	380209
28622	46643	2	applied	\N	\N	\N	\N	213129	213129	380210
28623	46638	25	applied	\N	\N	\N	\N	213155	213155	380236
28626	46595	0	applied	\N	\N	\N	\N	213161	213161	380242
28626	46597	1	applied	\N	\N	\N	\N	213162	213162	380243
28626	46598	2	applied	\N	\N	\N	\N	213163	213163	380244
28626	46599	3	applied	\N	\N	\N	\N	213164	213164	380245
28626	46574	4	applied	\N	\N	\N	\N	213165	213165	380246
28626	46580	5	applied	\N	\N	\N	\N	213166	213166	380247
28626	46593	6	applied	\N	\N	1000000000	\N	213167	213167	380248
28626	46594	7	applied	\N	\N	\N	\N	213168	213168	380249
28626	46609	8	applied	\N	\N	\N	\N	213169	213169	380250
28626	46619	9	applied	\N	\N	\N	\N	213170	213170	380251
28626	46631	10	applied	\N	\N	\N	\N	213171	213171	380252
28626	46638	11	applied	\N	\N	\N	\N	213172	213172	380253
28626	46648	12	applied	\N	\N	\N	\N	213173	213173	380254
28627	46645	0	applied	\N	\N	\N	\N	213174	213174	380255
28627	46646	1	applied	\N	\N	\N	\N	213175	213175	380256
28627	46647	2	applied	\N	\N	\N	\N	213176	213176	380257
28630	46658	0	applied	\N	\N	\N	\N	213193	213193	380274
28631	46664	0	applied	\N	\N	\N	\N	213194	213194	380275
28631	46665	1	applied	\N	\N	\N	\N	213195	213195	380276
28632	46664	0	applied	\N	\N	\N	\N	213196	213196	380277
28632	46665	1	applied	\N	\N	\N	\N	213197	213197	380278
28635	46666	0	applied	\N	\N	\N	\N	213206	213206	380287
28635	46667	1	applied	\N	\N	\N	\N	213207	213207	380288
28635	46668	2	applied	\N	\N	\N	\N	213208	213208	380289
28635	46669	3	applied	\N	\N	\N	\N	213209	213209	380290
28635	46670	4	applied	\N	\N	\N	\N	213210	213210	380291
28635	46671	5	applied	\N	\N	\N	\N	213211	213211	380292
28638	46674	0	applied	\N	\N	\N	\N	213216	213216	380297
28638	46675	1	applied	\N	\N	\N	\N	213217	213217	380298
28640	46674	0	applied	\N	\N	\N	\N	213301	213301	380382
28640	46675	1	applied	\N	\N	\N	\N	213302	213302	380383
28642	46676	0	applied	\N	\N	\N	\N	213305	213305	380386
28642	46678	2	applied	\N	\N	\N	\N	213307	213307	380388
28642	46679	3	applied	\N	\N	\N	\N	213308	213308	380389
28644	46676	0	applied	\N	\N	\N	\N	213313	213313	380394
28644	46677	1	applied	\N	\N	\N	\N	213314	213314	380395
28644	46678	2	applied	\N	\N	\N	\N	213315	213315	380396
28644	46679	3	applied	\N	\N	\N	\N	213316	213316	380397
28649	46683	0	applied	\N	\N	\N	\N	213328	213328	380409
28651	46684	0	applied	\N	\N	\N	\N	213330	213330	380411
28651	46685	1	applied	\N	\N	\N	\N	213331	213331	380412
28651	46686	2	applied	\N	\N	\N	\N	213332	213332	380413
28651	46687	3	applied	\N	\N	\N	\N	213333	213333	380414
28652	46688	0	applied	\N	\N	\N	\N	213334	213334	380415
28652	46689	1	applied	\N	\N	\N	\N	213335	213335	380416
28652	46690	2	applied	\N	\N	\N	\N	213336	213336	380417
28652	46691	3	applied	\N	\N	\N	\N	213337	213337	380418
28652	46692	4	applied	\N	\N	\N	\N	213338	213338	380419
28656	46701	1	applied	\N	\N	\N	\N	213359	213359	380440
28656	46702	2	applied	\N	\N	\N	\N	213360	213360	380441
28656	46703	3	applied	\N	\N	\N	\N	213361	213361	380442
28656	46704	4	applied	\N	\N	\N	\N	213362	213362	380443
28656	46705	5	applied	\N	\N	\N	\N	213363	213363	380444
28668	46716	0	applied	\N	\N	\N	\N	213455	213455	380536
28668	46717	1	applied	\N	\N	\N	\N	213456	213456	380537
28668	46718	2	applied	\N	\N	\N	\N	213457	213457	380538
28668	46719	3	applied	\N	\N	\N	\N	213458	213458	380539
28671	46720	0	applied	\N	\N	\N	\N	213465	213465	380546
28671	46721	1	applied	\N	\N	\N	\N	213466	213466	380547
28671	46722	2	applied	\N	\N	\N	\N	213467	213467	380548
28673	46723	0	applied	\N	\N	\N	\N	213586	213586	380667
28673	46724	1	applied	\N	\N	\N	\N	213587	213587	380668
28673	46725	2	applied	\N	\N	\N	\N	213588	213588	380669
28673	46726	3	applied	\N	\N	\N	\N	213589	213589	380670
28676	46724	1	applied	\N	\N	\N	\N	213599	213599	380680
28676	46725	2	applied	\N	\N	\N	\N	213600	213600	380681
28676	46726	3	applied	\N	\N	\N	\N	213601	213601	380682
28678	46727	0	applied	\N	\N	\N	\N	213613	213613	380694
28678	46728	1	applied	\N	\N	\N	\N	213614	213614	380695
28678	46729	2	applied	\N	\N	\N	\N	213615	213615	380696
28678	46730	3	applied	\N	\N	\N	\N	213616	213616	380697
28680	46731	0	applied	\N	\N	\N	\N	213621	213621	380702
28680	46732	1	applied	\N	\N	\N	\N	213622	213622	380703
28680	46733	2	applied	\N	\N	\N	\N	213623	213623	380704
28680	46734	3	applied	\N	\N	\N	\N	213624	213624	380705
28682	46733	0	applied	\N	\N	\N	\N	213627	213627	380708
28687	46740	0	applied	\N	\N	\N	\N	213639	213639	380720
28687	46741	1	applied	\N	\N	\N	\N	213640	213640	380721
28687	46742	2	applied	\N	\N	\N	\N	213641	213641	380722
28687	46743	3	applied	\N	\N	\N	\N	213642	213642	380723
28689	46748	1	applied	\N	\N	\N	\N	213647	213647	380728
28692	46753	0	applied	\N	\N	\N	\N	213655	213655	380736
28692	46754	1	applied	\N	\N	\N	\N	213656	213656	380737
28692	46755	2	applied	\N	\N	\N	\N	213657	213657	380738
28696	46758	0	applied	\N	\N	\N	\N	213665	213665	380746
28696	46759	1	applied	\N	\N	\N	\N	213666	213666	380747
28696	46760	2	applied	\N	\N	\N	\N	213667	213667	380748
28698	46758	0	applied	\N	\N	\N	\N	213671	213671	380752
28698	46759	1	applied	\N	\N	\N	\N	213672	213672	380753
28698	46760	2	applied	\N	\N	\N	\N	213673	213673	380754
28703	46770	0	applied	\N	\N	\N	\N	213683	213683	380764
28703	46771	1	applied	\N	\N	\N	\N	213684	213684	380765
28703	46772	2	applied	\N	\N	\N	\N	213685	213685	380766
28703	46773	3	applied	\N	\N	\N	\N	213686	213686	380767
28714	46777	0	applied	\N	\N	\N	\N	213700	213700	380781
28720	46778	0	applied	\N	\N	\N	\N	213705	213705	380786
28606	46616	0	applied	\N	\N	\N	\N	213077	213077	380158
28639	46474	21	applied	\N	\N	\N	\N	213239	213239	380320
28639	46478	22	applied	\N	\N	\N	\N	213240	213240	380321
28639	46482	23	applied	\N	\N	\N	\N	213241	213241	380322
28639	46483	24	applied	\N	\N	\N	\N	213242	213242	380323
28639	46489	25	applied	\N	\N	\N	\N	213243	213243	380324
28639	46493	26	applied	\N	\N	\N	\N	213244	213244	380325
28639	46495	27	applied	\N	\N	\N	\N	213245	213245	380326
28639	46497	28	applied	\N	\N	\N	\N	213246	213246	380327
28639	46500	29	applied	\N	\N	\N	\N	213247	213247	380328
28639	46502	30	applied	\N	\N	\N	\N	213248	213248	380329
28639	46504	31	applied	\N	\N	\N	\N	213249	213249	380330
28639	46507	32	applied	\N	\N	\N	\N	213250	213250	380331
28639	46510	33	applied	\N	\N	\N	\N	213251	213251	380332
28639	46514	34	applied	\N	\N	\N	\N	213252	213252	380333
28639	46519	35	applied	\N	\N	\N	\N	213253	213253	380334
28639	46524	37	applied	\N	\N	\N	\N	213255	213255	380336
28639	46530	38	applied	\N	\N	\N	\N	213256	213256	380337
28639	46531	39	applied	\N	\N	\N	\N	213257	213257	380338
28639	46532	40	applied	\N	\N	\N	\N	213258	213258	380339
28639	46536	41	applied	\N	\N	\N	\N	213259	213259	380340
28639	46541	42	applied	\N	\N	\N	\N	213260	213260	380341
28639	46542	43	applied	\N	\N	\N	\N	213261	213261	380342
28639	46550	44	applied	\N	\N	\N	\N	213262	213262	380343
28639	46551	45	applied	\N	\N	\N	\N	213263	213263	380344
28639	46552	46	applied	\N	\N	\N	\N	213264	213264	380345
28639	46557	47	applied	\N	\N	\N	\N	213265	213265	380346
28639	46558	48	applied	\N	\N	\N	\N	213266	213266	380347
28639	46562	49	applied	\N	\N	\N	\N	213267	213267	380348
28639	46563	50	applied	\N	\N	\N	\N	213268	213268	380349
28639	46570	51	applied	\N	\N	\N	\N	213269	213269	380350
28639	46571	52	applied	\N	\N	\N	\N	213270	213270	380351
28639	46579	54	applied	\N	\N	\N	\N	213272	213272	380353
28639	46581	55	applied	\N	\N	\N	\N	213273	213273	380354
28639	46582	56	applied	\N	\N	\N	\N	213274	213274	380355
28639	46586	57	applied	\N	\N	\N	\N	213275	213275	380356
28639	46589	58	applied	\N	\N	\N	\N	213276	213276	380357
28639	46592	59	applied	\N	\N	\N	\N	213277	213277	380358
28639	46602	60	applied	\N	\N	\N	\N	213278	213278	380359
28639	46603	61	applied	\N	\N	\N	\N	213279	213279	380360
28639	46606	62	applied	\N	\N	\N	\N	213280	213280	380361
28639	46608	63	applied	\N	\N	\N	\N	213281	213281	380362
28639	46611	64	applied	\N	\N	\N	\N	213282	213282	380363
28639	46615	65	applied	\N	\N	\N	\N	213283	213283	380364
28659	46706	0	applied	\N	\N	\N	\N	213375	213375	380456
28659	46707	1	applied	\N	\N	\N	\N	213376	213376	380457
28662	46708	0	applied	\N	\N	\N	\N	213378	213378	380459
28664	46712	0	applied	\N	\N	\N	\N	213382	213382	380463
28665	46595	0	applied	\N	\N	\N	\N	213384	213384	380465
28665	46270	1	applied	\N	\N	1000000000	\N	213385	213385	380466
28665	46275	2	applied	\N	\N	\N	\N	213386	213386	380467
28665	46223	3	applied	\N	\N	1000000000	\N	213387	213387	380468
28665	46237	4	applied	\N	\N	\N	\N	213388	213388	380469
28665	46294	5	applied	\N	\N	1000000000	\N	213389	213389	380470
28665	46597	6	applied	\N	\N	\N	\N	213390	213390	380471
28665	46598	7	applied	\N	\N	\N	\N	213391	213391	380472
28665	46599	8	applied	\N	\N	\N	\N	213392	213392	380473
28665	46412	9	applied	\N	\N	\N	\N	213393	213393	380474
28665	46419	10	applied	\N	\N	\N	\N	213394	213394	380475
28665	46690	11	applied	\N	\N	\N	\N	213395	213395	380476
28665	46468	12	applied	\N	\N	\N	\N	213396	213396	380477
28665	46556	13	applied	\N	\N	\N	\N	213397	213397	380478
28665	46465	15	applied	\N	\N	\N	\N	213399	213399	380480
28665	46224	16	applied	\N	\N	1000000000	\N	213400	213400	380481
28665	46449	17	applied	\N	\N	1000000000	\N	213401	213401	380482
28665	46450	18	applied	\N	\N	\N	\N	213402	213402	380483
28665	46431	19	applied	\N	\N	\N	\N	213403	213403	380484
28665	46354	20	applied	\N	\N	\N	\N	213404	213404	380485
28665	46472	21	applied	\N	\N	\N	\N	213405	213405	380486
28665	46491	22	applied	\N	\N	1000000000	\N	213406	213406	380487
28665	46517	23	applied	\N	\N	1000000000	\N	213407	213407	380488
28665	46593	24	applied	\N	\N	1000000000	\N	213408	213408	380489
28665	46438	25	applied	\N	\N	\N	\N	213409	213409	380490
28665	46441	26	applied	\N	\N	\N	\N	213410	213410	380491
28665	46443	27	applied	\N	\N	\N	\N	213411	213411	380492
28665	46445	28	applied	\N	\N	\N	\N	213412	213412	380493
28665	46451	29	applied	\N	\N	\N	\N	213413	213413	380494
28665	46455	31	applied	\N	\N	\N	\N	213414	213414	380495
28665	46457	32	applied	\N	\N	\N	\N	213415	213415	380496
28665	46461	33	applied	\N	\N	\N	\N	213416	213416	380497
28665	46462	34	applied	\N	\N	\N	\N	213417	213417	380498
28665	46466	35	applied	\N	\N	\N	\N	213418	213418	380499
28665	46474	37	applied	\N	\N	\N	\N	213420	213420	380501
28665	46478	38	applied	\N	\N	\N	\N	213421	213421	380502
28665	46482	39	applied	\N	\N	\N	\N	213422	213422	380503
28665	46483	40	applied	\N	\N	\N	\N	213423	213423	380504
28665	46489	41	applied	\N	\N	\N	\N	213424	213424	380505
28665	46493	42	applied	\N	\N	\N	\N	213425	213425	380506
28665	46495	43	applied	\N	\N	\N	\N	213426	213426	380507
28665	46497	44	applied	\N	\N	\N	\N	213427	213427	380508
28665	46500	45	applied	\N	\N	\N	\N	213428	213428	380509
28665	46502	46	applied	\N	\N	\N	\N	213429	213429	380510
28665	46504	47	applied	\N	\N	\N	\N	213430	213430	380511
28665	46507	48	applied	\N	\N	\N	\N	213431	213431	380512
28665	46510	49	applied	\N	\N	\N	\N	213432	213432	380513
28665	46514	50	applied	\N	\N	\N	\N	213433	213433	380514
28665	46519	51	applied	\N	\N	\N	\N	213434	213434	380515
28665	46520	52	applied	\N	\N	\N	\N	213435	213435	380516
28665	46530	54	applied	\N	\N	\N	\N	213437	213437	380518
28665	46531	55	applied	\N	\N	\N	\N	213438	213438	380519
28665	46532	56	applied	\N	\N	\N	\N	213439	213439	380520
28665	46536	57	applied	\N	\N	\N	\N	213440	213440	380521
28665	46541	58	applied	\N	\N	\N	\N	213441	213441	380522
28665	46542	59	applied	\N	\N	\N	\N	213442	213442	380523
28665	46550	60	applied	\N	\N	\N	\N	213443	213443	380524
28665	46551	61	applied	\N	\N	\N	\N	213444	213444	380525
28665	46552	62	applied	\N	\N	\N	\N	213445	213445	380526
28665	46557	63	applied	\N	\N	\N	\N	213446	213446	380527
28665	46558	64	applied	\N	\N	\N	\N	213447	213447	380528
28665	46562	65	applied	\N	\N	\N	\N	213448	213448	380529
28639	46462	18	applied	\N	\N	\N	\N	213236	213236	380317
28639	46469	20	applied	\N	\N	\N	\N	213238	213238	380319
28639	46630	71	applied	\N	\N	\N	\N	213288	213288	380369
28639	46633	72	applied	\N	\N	\N	\N	213289	213289	380370
28639	46635	73	applied	\N	\N	\N	\N	213290	213290	380371
28639	46639	74	applied	\N	\N	\N	\N	213291	213291	380372
28639	46642	75	applied	\N	\N	\N	\N	213292	213292	380373
28639	46646	76	applied	\N	\N	\N	\N	213293	213293	380374
28639	46651	77	applied	\N	\N	\N	\N	213294	213294	380375
28639	46656	78	applied	\N	\N	\N	\N	213295	213295	380376
28639	46661	79	applied	\N	\N	\N	\N	213296	213296	380377
28639	46662	80	applied	\N	\N	\N	\N	213297	213297	380378
28639	46663	81	applied	\N	\N	\N	\N	213298	213298	380379
28639	46665	82	applied	\N	\N	\N	\N	213299	213299	380380
28639	46669	83	applied	\N	\N	\N	\N	213300	213300	380381
28643	46648	0	applied	\N	\N	\N	\N	213309	213309	380390
28643	46658	1	applied	\N	\N	\N	\N	213310	213310	380391
28643	46668	2	applied	\N	\N	\N	\N	213311	213311	380392
28645	46680	0	applied	\N	\N	\N	\N	213317	213317	380398
28645	46681	1	applied	\N	\N	\N	\N	213318	213318	380399
28647	46682	0	applied	\N	\N	\N	\N	213322	213322	380403
28647	46680	1	applied	\N	\N	\N	\N	213323	213323	380404
28647	46681	2	applied	\N	\N	\N	\N	213324	213324	380405
28653	46693	0	applied	\N	\N	\N	\N	213339	213339	380420
28653	46694	1	applied	\N	\N	\N	\N	213340	213340	380421
28653	46695	2	applied	\N	\N	\N	\N	213341	213341	380422
28653	46696	3	applied	\N	\N	\N	\N	213342	213342	380423
28653	46697	4	applied	\N	\N	\N	\N	213343	213343	380424
28653	46698	5	applied	\N	\N	\N	\N	213344	213344	380425
28653	46699	6	applied	\N	\N	\N	\N	213345	213345	380426
28654	46700	0	applied	\N	\N	\N	\N	213346	213346	380427
28654	46701	1	applied	\N	\N	\N	\N	213347	213347	380428
28654	46702	2	applied	\N	\N	\N	\N	213348	213348	380429
28654	46703	3	applied	\N	\N	\N	\N	213349	213349	380430
28654	46705	5	applied	\N	\N	\N	\N	213351	213351	380432
28658	46690	0	applied	\N	\N	\N	\N	213370	213370	380451
28658	46681	1	applied	\N	\N	\N	\N	213371	213371	380452
28658	46691	2	applied	\N	\N	\N	\N	213372	213372	380453
28658	46696	3	applied	\N	\N	\N	\N	213373	213373	380454
28658	46705	4	applied	\N	\N	\N	\N	213374	213374	380455
28665	46563	66	applied	\N	\N	\N	\N	213449	213449	380530
28665	46570	67	applied	\N	\N	\N	\N	213450	213450	380531
28666	46714	0	applied	\N	\N	\N	\N	213451	213451	380532
28666	46715	1	applied	\N	\N	\N	\N	213452	213452	380533
28669	46720	0	applied	\N	\N	\N	\N	213459	213459	380540
28669	46721	1	applied	\N	\N	\N	\N	213460	213460	380541
28669	46722	2	applied	\N	\N	\N	\N	213461	213461	380542
28670	46720	0	applied	\N	\N	\N	\N	213462	213462	380543
28670	46721	1	applied	\N	\N	\N	\N	213463	213463	380544
28670	46722	2	applied	\N	\N	\N	\N	213464	213464	380545
28672	46597	1	applied	\N	\N	\N	\N	213469	213469	380550
28672	46598	2	applied	\N	\N	\N	\N	213470	213470	380551
28672	46599	3	applied	\N	\N	\N	\N	213471	213471	380552
28672	46560	4	applied	\N	\N	\N	\N	213472	213472	380553
28672	46561	5	applied	\N	\N	\N	\N	213473	213473	380554
28672	46567	6	applied	\N	\N	\N	\N	213474	213474	380555
28672	46568	7	applied	\N	\N	\N	\N	213475	213475	380556
28672	46572	8	applied	\N	\N	\N	\N	213476	213476	380557
28672	46576	9	applied	\N	\N	\N	\N	213477	213477	380558
28672	46577	10	applied	\N	\N	\N	\N	213478	213478	380559
28672	46578	11	applied	\N	\N	\N	\N	213479	213479	380560
28672	46585	12	applied	\N	\N	\N	\N	213480	213480	380561
28672	46588	13	applied	\N	\N	\N	\N	213481	213481	380562
28672	46591	14	applied	\N	\N	\N	\N	213482	213482	380563
28672	46596	15	applied	\N	\N	\N	\N	213483	213483	380564
28672	46604	16	applied	\N	\N	\N	\N	213484	213484	380565
28672	46610	18	applied	\N	\N	\N	\N	213486	213486	380567
28672	46613	19	applied	\N	\N	\N	\N	213487	213487	380568
28672	46616	20	applied	\N	\N	\N	\N	213488	213488	380569
28672	46620	21	applied	\N	\N	\N	\N	213489	213489	380570
28672	46622	22	applied	\N	\N	\N	\N	213490	213490	380571
28672	46625	23	applied	\N	\N	\N	\N	213491	213491	380572
28672	46626	24	applied	\N	\N	\N	\N	213492	213492	380573
28672	46632	25	applied	\N	\N	\N	\N	213493	213493	380574
28672	46634	26	applied	\N	\N	\N	\N	213494	213494	380575
28672	46637	27	applied	\N	\N	\N	\N	213495	213495	380576
28672	46641	28	applied	\N	\N	\N	\N	213496	213496	380577
28672	46644	29	applied	\N	\N	\N	\N	213497	213497	380578
28672	46645	30	applied	\N	\N	\N	\N	213498	213498	380579
28672	46649	31	applied	\N	\N	\N	\N	213499	213499	380580
28672	46652	32	applied	\N	\N	\N	\N	213500	213500	380581
28672	46653	33	applied	\N	\N	\N	\N	213501	213501	380582
28672	46655	35	applied	\N	\N	\N	\N	213503	213503	380584
28672	46664	36	applied	\N	\N	\N	\N	213504	213504	380585
28672	46666	37	applied	\N	\N	\N	\N	213505	213505	380586
28672	46667	38	applied	\N	\N	\N	\N	213506	213506	380587
28672	46672	39	applied	\N	\N	\N	\N	213507	213507	380588
28672	46674	40	applied	\N	\N	\N	\N	213508	213508	380589
28672	46676	41	applied	\N	\N	\N	\N	213509	213509	380590
28672	46677	42	applied	\N	\N	\N	\N	213510	213510	380591
28672	46682	43	applied	\N	\N	\N	\N	213511	213511	380592
28674	46723	0	applied	\N	\N	\N	\N	213590	213590	380671
28674	46724	1	applied	\N	\N	\N	\N	213591	213591	380672
28674	46725	2	applied	\N	\N	\N	\N	213592	213592	380673
28674	46726	3	applied	\N	\N	\N	\N	213593	213593	380674
28685	46740	0	applied	\N	\N	\N	\N	213631	213631	380712
28685	46741	1	applied	\N	\N	\N	\N	213632	213632	380713
28685	46742	2	applied	\N	\N	\N	\N	213633	213633	380714
28694	46756	0	applied	\N	\N	\N	\N	213661	213661	380742
28694	46757	1	applied	\N	\N	\N	\N	213662	213662	380743
28706	46775	0	applied	\N	\N	\N	\N	213693	213693	380774
28706	46776	1	applied	\N	\N	\N	\N	213694	213694	380775
28712	46777	0	applied	\N	\N	\N	\N	213698	213698	380779
28716	46777	0	applied	\N	\N	\N	\N	213701	213701	380782
28725	46788	0	applied	\N	\N	\N	\N	213734	213734	380815
28725	46789	1	applied	\N	\N	\N	\N	213735	213735	380816
28731	46790	0	applied	\N	\N	\N	\N	213742	213742	380823
28731	46791	1	applied	\N	\N	\N	\N	213743	213743	380824
28731	46792	2	applied	\N	\N	\N	\N	213744	213744	380825
28731	46793	3	applied	\N	\N	\N	\N	213745	213745	380826
28736	46801	0	applied	\N	\N	\N	\N	213761	213761	380842
28736	46802	1	applied	\N	\N	\N	\N	213762	213762	380843
28639	46621	68	applied	\N	\N	\N	\N	213285	213285	380366
28639	46623	69	applied	\N	\N	\N	\N	213286	213286	380367
28672	46689	48	applied	\N	\N	\N	\N	213516	213516	380597
28672	46693	49	applied	\N	\N	\N	\N	213517	213517	380598
28672	46694	50	applied	\N	\N	\N	\N	213518	213518	380599
28672	46695	51	applied	\N	\N	\N	\N	213519	213519	380600
28672	46700	52	applied	\N	\N	\N	\N	213520	213520	380601
28672	46701	53	applied	\N	\N	\N	\N	213521	213521	380602
28672	46702	54	applied	\N	\N	\N	\N	213522	213522	380603
28672	46706	55	applied	\N	\N	\N	\N	213523	213523	380604
28672	46708	56	applied	\N	\N	\N	\N	213524	213524	380605
28672	46709	57	applied	\N	\N	\N	\N	213525	213525	380606
28672	46712	58	applied	\N	\N	\N	\N	213526	213526	380607
28672	46714	59	applied	\N	\N	\N	\N	213527	213527	380608
28672	46716	60	applied	\N	\N	\N	\N	213528	213528	380609
28672	46717	61	applied	\N	\N	\N	\N	213529	213529	380610
28672	46690	63	applied	\N	\N	\N	\N	213531	213531	380612
28672	46562	64	applied	\N	\N	\N	\N	213532	213532	380613
28672	46563	65	applied	\N	\N	\N	\N	213533	213533	380614
28672	46593	66	applied	\N	\N	1000000000	\N	213534	213534	380615
28672	46570	67	applied	\N	\N	\N	\N	213535	213535	380616
28672	46721	68	applied	\N	\N	\N	\N	213536	213536	380617
28672	46565	69	applied	\N	\N	\N	\N	213537	213537	380618
28672	46574	70	applied	\N	\N	\N	\N	213538	213538	380619
28672	46580	71	applied	\N	\N	\N	\N	213539	213539	380620
28672	46594	72	applied	\N	\N	\N	\N	213540	213540	380621
28672	46609	73	applied	\N	\N	\N	\N	213541	213541	380622
28672	46619	74	applied	\N	\N	\N	\N	213542	213542	380623
28672	46571	75	applied	\N	\N	\N	\N	213543	213543	380624
28672	46573	76	applied	\N	\N	\N	\N	213544	213544	380625
28672	46579	77	applied	\N	\N	\N	\N	213545	213545	380626
28672	46581	78	applied	\N	\N	\N	\N	213546	213546	380627
28672	46586	81	applied	\N	\N	\N	\N	213548	213548	380629
28672	46589	82	applied	\N	\N	\N	\N	213549	213549	380630
28672	46592	83	applied	\N	\N	\N	\N	213550	213550	380631
28672	46631	84	applied	\N	\N	\N	\N	213551	213551	380632
28672	46638	85	applied	\N	\N	\N	\N	213552	213552	380633
28672	46648	86	applied	\N	\N	\N	\N	213553	213553	380634
28672	46658	87	applied	\N	\N	\N	\N	213554	213554	380635
28672	46668	88	applied	\N	\N	\N	\N	213555	213555	380636
28672	46675	89	applied	\N	\N	\N	\N	213556	213556	380637
28672	46681	90	applied	\N	\N	\N	\N	213557	213557	380638
28672	46691	91	applied	\N	\N	\N	\N	213558	213558	380639
28672	46696	92	applied	\N	\N	\N	\N	213559	213559	380640
28672	46705	93	applied	\N	\N	\N	\N	213560	213560	380641
28672	46710	94	applied	\N	\N	\N	\N	213561	213561	380642
28672	46718	95	applied	\N	\N	\N	\N	213562	213562	380643
28672	46602	96	applied	\N	\N	\N	\N	213563	213563	380644
28672	46606	98	applied	\N	\N	\N	\N	213565	213565	380646
28672	46608	99	applied	\N	\N	\N	\N	213566	213566	380647
28672	46611	100	applied	\N	\N	\N	\N	213567	213567	380648
28672	46615	101	applied	\N	\N	\N	\N	213568	213568	380649
28672	46617	102	applied	\N	\N	\N	\N	213569	213569	380650
28672	46621	103	applied	\N	\N	\N	\N	213570	213570	380651
28672	46623	104	applied	\N	\N	\N	\N	213571	213571	380652
28672	46629	105	applied	\N	\N	\N	\N	213572	213572	380653
28672	46630	106	applied	\N	\N	\N	\N	213573	213573	380654
28672	46633	107	applied	\N	\N	\N	\N	213574	213574	380655
28672	46635	108	applied	\N	\N	\N	\N	213575	213575	380656
28672	46639	109	applied	\N	\N	\N	\N	213576	213576	380657
28672	46642	110	applied	\N	\N	\N	\N	213577	213577	380658
28672	46646	111	applied	\N	\N	\N	\N	213578	213578	380659
28672	46651	112	applied	\N	\N	\N	\N	213579	213579	380660
28672	46656	113	applied	\N	\N	\N	\N	213580	213580	380661
28672	46662	115	applied	\N	\N	\N	\N	213582	213582	380663
28672	46663	116	applied	\N	\N	\N	\N	213583	213583	380664
28672	46665	117	applied	\N	\N	\N	\N	213584	213584	380665
28672	46669	118	applied	\N	\N	\N	\N	213585	213585	380666
28675	46723	0	applied	\N	\N	\N	\N	213594	213594	380675
28675	46724	1	applied	\N	\N	\N	\N	213595	213595	380676
28675	46725	2	applied	\N	\N	\N	\N	213596	213596	380677
28675	46726	3	applied	\N	\N	\N	\N	213597	213597	380678
28677	46690	0	applied	\N	\N	\N	\N	213602	213602	380683
28677	46668	1	applied	\N	\N	\N	\N	213603	213603	380684
28677	46721	2	applied	\N	\N	\N	\N	213604	213604	380685
28677	46675	3	applied	\N	\N	\N	\N	213605	213605	380686
28677	46681	4	applied	\N	\N	\N	\N	213606	213606	380687
28677	46691	5	applied	\N	\N	\N	\N	213607	213607	380688
28677	46696	6	applied	\N	\N	\N	\N	213608	213608	380689
28677	46705	7	applied	\N	\N	\N	\N	213609	213609	380690
28677	46718	9	applied	\N	\N	\N	\N	213611	213611	380692
28677	46725	10	applied	\N	\N	\N	\N	213612	213612	380693
28679	46731	0	applied	\N	\N	\N	\N	213617	213617	380698
28679	46732	1	applied	\N	\N	\N	\N	213618	213618	380699
28679	46733	2	applied	\N	\N	\N	\N	213619	213619	380700
28679	46734	3	applied	\N	\N	\N	\N	213620	213620	380701
28688	46744	0	applied	\N	\N	\N	\N	213643	213643	380724
28688	46745	1	applied	\N	\N	\N	\N	213644	213644	380725
28688	46746	2	applied	\N	\N	\N	\N	213645	213645	380726
28691	46753	0	applied	\N	\N	\N	\N	213652	213652	380733
28691	46754	1	applied	\N	\N	\N	\N	213653	213653	380734
28691	46755	2	applied	\N	\N	\N	\N	213654	213654	380735
28693	46753	0	applied	\N	\N	\N	\N	213658	213658	380739
28693	46754	1	applied	\N	\N	\N	\N	213659	213659	380740
28693	46755	2	applied	\N	\N	\N	\N	213660	213660	380741
28695	46756	0	applied	\N	\N	\N	\N	213663	213663	380744
28700	46765	0	applied	\N	\N	\N	\N	213678	213678	380759
28700	46766	1	applied	\N	\N	\N	\N	213679	213679	380760
28700	46767	2	applied	\N	\N	\N	\N	213680	213680	380761
28702	46768	0	applied	\N	\N	\N	\N	213681	213681	380762
28702	46769	1	applied	\N	\N	\N	\N	213682	213682	380763
28705	46774	0	applied	\N	\N	\N	\N	213690	213690	380771
28705	46775	1	applied	\N	\N	\N	\N	213691	213691	380772
28705	46776	2	applied	\N	\N	\N	\N	213692	213692	380773
28707	46777	0	applied	\N	\N	\N	\N	213695	213695	380776
28711	46777	0	applied	\N	\N	\N	\N	213697	213697	380778
28719	46778	0	applied	\N	\N	\N	\N	213702	213702	380783
28719	46779	1	applied	\N	\N	\N	\N	213703	213703	380784
28719	46780	2	applied	\N	\N	\N	\N	213704	213704	380785
28724	46782	0	applied	\N	\N	\N	\N	213727	213727	380808
28724	46783	1	applied	\N	\N	\N	\N	213728	213728	380809
28724	46784	2	applied	\N	\N	\N	\N	213729	213729	380810
28672	46688	47	applied	\N	\N	\N	\N	213515	213515	380596
28721	46778	0	applied	\N	\N	\N	\N	213709	213709	380790
28721	46779	1	applied	\N	\N	\N	\N	213710	213710	380791
28721	46780	2	applied	\N	\N	\N	\N	213711	213711	380792
28721	46781	3	applied	\N	\N	\N	\N	213712	213712	380793
28723	46782	0	applied	\N	\N	\N	\N	213720	213720	380801
28723	46783	1	applied	\N	\N	\N	\N	213721	213721	380802
28723	46784	2	applied	\N	\N	\N	\N	213722	213722	380803
28723	46785	3	applied	\N	\N	\N	\N	213723	213723	380804
28723	46781	4	applied	\N	\N	\N	\N	213724	213724	380805
28723	46786	5	applied	\N	\N	\N	\N	213725	213725	380806
28723	46787	6	applied	\N	\N	\N	\N	213726	213726	380807
28724	46785	3	applied	\N	\N	\N	\N	213730	213730	380811
28724	46781	4	applied	\N	\N	\N	\N	213731	213731	380812
28724	46786	5	applied	\N	\N	\N	\N	213732	213732	380813
28724	46787	6	applied	\N	\N	\N	\N	213733	213733	380814
28726	46788	0	applied	\N	\N	\N	\N	213736	213736	380817
28730	46790	0	applied	\N	\N	\N	\N	213738	213738	380819
28730	46791	1	applied	\N	\N	\N	\N	213739	213739	380820
28730	46792	2	applied	\N	\N	\N	\N	213740	213740	380821
28730	46793	3	applied	\N	\N	\N	\N	213741	213741	380822
28732	46794	0	applied	\N	\N	\N	\N	213746	213746	380827
28732	46795	1	applied	\N	\N	\N	\N	213747	213747	380828
28732	46796	2	applied	\N	\N	\N	\N	213748	213748	380829
28734	46797	0	applied	\N	\N	\N	\N	213752	213752	380833
28734	46790	1	applied	\N	\N	\N	\N	213753	213753	380834
28734	46794	2	applied	\N	\N	\N	\N	213754	213754	380835
28734	46798	3	applied	\N	\N	\N	\N	213755	213755	380836
28734	46791	4	applied	\N	\N	\N	\N	213756	213756	380837
28737	46801	0	applied	\N	\N	\N	\N	213763	213763	380844
28737	46802	1	applied	\N	\N	\N	\N	213764	213764	380845
28739	46803	0	applied	\N	\N	\N	\N	213767	213767	380848
28739	46804	1	applied	\N	\N	\N	\N	213768	213768	380849
28741	46595	1	applied	\N	\N	\N	\N	213772	213772	380853
28741	46304	2	applied	\N	\N	\N	\N	213773	213773	380854
28741	46306	3	applied	\N	\N	\N	\N	213774	213774	380855
28741	46307	4	applied	\N	\N	\N	\N	213775	213775	380856
28741	46311	5	applied	\N	\N	\N	\N	213776	213776	380857
28741	46312	6	applied	\N	\N	\N	\N	213777	213777	380858
28741	46315	7	applied	\N	\N	\N	\N	213778	213778	380859
28741	46597	8	applied	\N	\N	\N	\N	213779	213779	380860
28741	46598	9	applied	\N	\N	\N	\N	213780	213780	380861
28741	46599	10	applied	\N	\N	\N	\N	213781	213781	380862
28741	46317	11	applied	\N	\N	\N	\N	213782	213782	380863
28741	46318	12	applied	\N	\N	\N	\N	213783	213783	380864
28741	46319	13	applied	\N	\N	\N	\N	213784	213784	380865
28741	46320	14	applied	\N	\N	\N	\N	213785	213785	380866
28741	46321	15	applied	\N	\N	\N	\N	213786	213786	380867
28741	46322	16	applied	\N	\N	\N	\N	213787	213787	380868
28741	46331	18	applied	\N	\N	\N	\N	213789	213789	380870
28741	46333	19	applied	\N	\N	\N	\N	213790	213790	380871
28741	46334	20	applied	\N	\N	\N	\N	213791	213791	380872
28741	46337	21	applied	\N	\N	\N	\N	213792	213792	380873
28741	46339	22	applied	\N	\N	\N	\N	213793	213793	380874
28741	46341	23	applied	\N	\N	\N	\N	213794	213794	380875
28744	46805	0	applied	\N	\N	\N	\N	213900	213900	380981
28744	46806	1	applied	\N	\N	\N	\N	213901	213901	380982
28748	46807	0	applied	\N	\N	\N	\N	213905	213905	380986
28748	46808	1	applied	\N	\N	\N	\N	213906	213906	380987
28748	46809	2	applied	\N	\N	\N	\N	213907	213907	380988
28750	46807	0	applied	\N	\N	\N	\N	213911	213911	380992
28750	46808	1	applied	\N	\N	\N	\N	213912	213912	380993
28750	46809	2	applied	\N	\N	\N	\N	213913	213913	380994
28759	46818	0	applied	\N	\N	\N	\N	213931	213931	381012
28759	46819	1	applied	\N	\N	\N	\N	213932	213932	381013
28766	46829	2	applied	\N	\N	\N	\N	213948	213948	381029
28766	46830	3	applied	\N	\N	\N	\N	213949	213949	381030
28766	46831	4	applied	\N	\N	\N	\N	213950	213950	381031
28766	46832	5	applied	\N	\N	\N	\N	213951	213951	381032
28766	46833	6	applied	\N	\N	\N	\N	213952	213952	381033
28766	46834	7	applied	\N	\N	\N	\N	213953	213953	381034
28766	46835	8	applied	\N	\N	\N	\N	213954	213954	381035
28771	46843	0	applied	\N	\N	\N	\N	213981	213981	381062
28771	46844	1	applied	\N	\N	\N	\N	213982	213982	381063
28771	46845	2	applied	\N	\N	\N	\N	213983	213983	381064
28778	46851	0	applied	\N	\N	\N	\N	214004	214004	381085
28778	46853	1	applied	\N	\N	\N	\N	214005	214005	381086
28778	46854	2	applied	\N	\N	\N	\N	214006	214006	381087
28778	46852	3	applied	\N	\N	\N	\N	214007	214007	381088
28778	46855	4	applied	\N	\N	\N	\N	214008	214008	381089
28778	46856	5	applied	\N	\N	\N	\N	214009	214009	381090
28778	46858	7	applied	\N	\N	\N	\N	214011	214011	381092
28788	46881	0	applied	\N	\N	\N	\N	214055	214055	381136
28788	46882	1	applied	\N	\N	\N	\N	214056	214056	381137
28791	46895	0	applied	\N	\N	\N	\N	214069	214069	381150
28791	46896	1	applied	\N	\N	\N	\N	214070	214070	381151
28791	46897	2	applied	\N	\N	\N	\N	214071	214071	381152
28791	46898	3	applied	\N	\N	\N	\N	214072	214072	381153
28798	46907	0	applied	\N	\N	\N	\N	214097	214097	381178
28798	46908	1	applied	\N	\N	\N	\N	214098	214098	381179
28798	46909	2	applied	\N	\N	\N	\N	214099	214099	381180
28805	46913	0	applied	\N	\N	\N	\N	214106	214106	381187
28805	46914	1	applied	\N	\N	\N	\N	214107	214107	381188
28805	46915	2	applied	\N	\N	\N	\N	214108	214108	381189
28805	46916	3	applied	\N	\N	\N	\N	214109	214109	381190
28805	46917	4	applied	\N	\N	\N	\N	214110	214110	381191
28805	46918	6	applied	\N	\N	\N	\N	214111	214111	381192
28807	46920	1	applied	\N	\N	\N	\N	214119	214119	381200
28807	46921	2	applied	\N	\N	\N	\N	214120	214120	381201
28818	46931	0	applied	\N	\N	\N	\N	214148	214148	381229
28818	46932	1	applied	\N	\N	\N	\N	214149	214149	381230
28818	46933	2	applied	\N	\N	\N	\N	214150	214150	381231
28828	46952	0	applied	\N	\N	\N	\N	214202	214202	381283
28828	46953	1	applied	\N	\N	\N	\N	214203	214203	381284
28828	46954	2	applied	\N	\N	\N	\N	214204	214204	381285
28828	46955	3	applied	\N	\N	\N	\N	214205	214205	381286
28828	46956	4	applied	\N	\N	\N	\N	214206	214206	381287
28828	46957	5	applied	\N	\N	\N	\N	214207	214207	381288
28828	46958	6	applied	\N	\N	\N	\N	214208	214208	381289
28830	46952	0	applied	\N	\N	\N	\N	214216	214216	381297
28830	46953	1	applied	\N	\N	\N	\N	214217	214217	381298
28704	46776	2	applied	\N	\N	\N	\N	213689	213689	380770
28709	46777	0	applied	\N	\N	\N	\N	213696	213696	380777
28722	46783	1	applied	\N	\N	\N	\N	213714	213714	380795
28722	46784	2	applied	\N	\N	\N	\N	213715	213715	380796
28722	46785	3	applied	\N	\N	\N	\N	213716	213716	380797
28722	46781	4	applied	\N	\N	\N	\N	213717	213717	380798
28722	46786	5	applied	\N	\N	\N	\N	213718	213718	380799
28722	46787	6	applied	\N	\N	\N	\N	213719	213719	380800
28733	46794	0	applied	\N	\N	\N	\N	213749	213749	380830
28733	46795	1	applied	\N	\N	\N	\N	213750	213750	380831
28733	46796	2	applied	\N	\N	\N	\N	213751	213751	380832
28735	46797	0	applied	\N	\N	\N	\N	213757	213757	380838
28735	46798	1	applied	\N	\N	\N	\N	213758	213758	380839
28735	46799	2	applied	\N	\N	\N	\N	213759	213759	380840
28735	46800	3	applied	\N	\N	\N	\N	213760	213760	380841
28740	46803	0	applied	\N	\N	\N	\N	213769	213769	380850
28741	46342	24	applied	\N	\N	\N	\N	213795	213795	380876
28741	46343	25	applied	\N	\N	\N	\N	213796	213796	380877
28741	46348	26	applied	\N	\N	\N	\N	213797	213797	380878
28741	46350	27	applied	\N	\N	\N	\N	213798	213798	380879
28741	46352	28	applied	\N	\N	\N	\N	213799	213799	380880
28741	46355	29	applied	\N	\N	\N	\N	213800	213800	380881
28741	46357	30	applied	\N	\N	\N	\N	213801	213801	380882
28741	46358	31	applied	\N	\N	\N	\N	213802	213802	380883
28741	46362	32	applied	\N	\N	\N	\N	213803	213803	380884
28741	46363	33	applied	\N	\N	\N	\N	213804	213804	380885
28741	46366	34	applied	\N	\N	\N	\N	213805	213805	380886
28741	46368	35	applied	\N	\N	\N	\N	213806	213806	380887
28741	46369	36	applied	\N	\N	\N	\N	213807	213807	380888
28741	46370	37	applied	\N	\N	\N	\N	213808	213808	380889
28741	46374	38	applied	\N	\N	\N	\N	213809	213809	380890
28741	46376	39	applied	\N	\N	\N	\N	213810	213810	380891
28741	46380	41	applied	\N	\N	\N	\N	213812	213812	380893
28741	46382	42	applied	\N	\N	\N	\N	213813	213813	380894
28741	46384	43	applied	\N	\N	\N	\N	213814	213814	380895
28741	46386	44	applied	\N	\N	\N	\N	213815	213815	380896
28741	46387	45	applied	\N	\N	\N	\N	213816	213816	380897
28741	46390	46	applied	\N	\N	\N	\N	213817	213817	380898
28741	46391	47	applied	\N	\N	\N	\N	213818	213818	380899
28741	46394	48	applied	\N	\N	\N	\N	213819	213819	380900
28741	46396	49	applied	\N	\N	\N	\N	213820	213820	380901
28741	46399	50	applied	\N	\N	\N	\N	213821	213821	380902
28741	46401	51	applied	\N	\N	\N	\N	213822	213822	380903
28741	46403	53	applied	\N	\N	\N	\N	213823	213823	380904
28741	46405	54	applied	\N	\N	\N	\N	213824	213824	380905
28741	46407	55	applied	\N	\N	\N	\N	213825	213825	380906
28741	46409	56	applied	\N	\N	\N	\N	213826	213826	380907
28741	46411	57	applied	\N	\N	\N	\N	213827	213827	380908
28741	46416	59	applied	\N	\N	\N	\N	213829	213829	380910
28741	46417	60	applied	\N	\N	\N	\N	213830	213830	380911
28741	46418	61	applied	\N	\N	\N	\N	213831	213831	380912
28741	46423	62	applied	\N	\N	\N	\N	213832	213832	380913
28741	46425	63	applied	\N	\N	\N	\N	213833	213833	380914
28741	46427	64	applied	\N	\N	\N	\N	213834	213834	380915
28741	46428	65	applied	\N	\N	\N	\N	213835	213835	380916
28741	46429	66	applied	\N	\N	\N	\N	213836	213836	380917
28741	46434	67	applied	\N	\N	\N	\N	213837	213837	380918
28741	46436	68	applied	\N	\N	\N	\N	213838	213838	380919
28741	46439	69	applied	\N	\N	\N	\N	213839	213839	380920
28741	46442	70	applied	\N	\N	\N	\N	213840	213840	380921
28741	46444	71	applied	\N	\N	\N	\N	213841	213841	380922
28741	46447	72	applied	\N	\N	\N	\N	213842	213842	380923
28741	46452	73	applied	\N	\N	\N	\N	213843	213843	380924
28741	46456	74	applied	\N	\N	\N	\N	213844	213844	380925
28741	46463	76	applied	\N	\N	\N	\N	213846	213846	380927
28741	46467	77	applied	\N	\N	\N	\N	213847	213847	380928
28741	46473	78	applied	\N	\N	\N	\N	213848	213848	380929
28741	46477	79	applied	\N	\N	\N	\N	213849	213849	380930
28741	46480	80	applied	\N	\N	\N	\N	213850	213850	380931
28741	46481	81	applied	\N	\N	\N	\N	213851	213851	380932
28741	46488	82	applied	\N	\N	\N	\N	213852	213852	380933
28741	46490	83	applied	\N	\N	\N	\N	213853	213853	380934
28741	46494	84	applied	\N	\N	\N	\N	213854	213854	380935
28741	46496	85	applied	\N	\N	\N	\N	213855	213855	380936
28741	46499	86	applied	\N	\N	\N	\N	213856	213856	380937
28741	46503	87	applied	\N	\N	\N	\N	213857	213857	380938
28741	46506	88	applied	\N	\N	\N	\N	213858	213858	380939
28741	46508	89	applied	\N	\N	\N	\N	213859	213859	380940
28741	46512	90	applied	\N	\N	\N	\N	213860	213860	380941
28741	46515	91	applied	\N	\N	\N	\N	213861	213861	380942
28741	46522	93	applied	\N	\N	\N	\N	213863	213863	380944
28741	46525	94	applied	\N	\N	\N	\N	213864	213864	380945
28741	46526	95	applied	\N	\N	\N	\N	213865	213865	380946
28742	46805	0	applied	\N	\N	\N	\N	213896	213896	380977
28742	46806	1	applied	\N	\N	\N	\N	213897	213897	380978
28745	46805	0	applied	\N	\N	\N	\N	213902	213902	380983
28745	46806	1	applied	\N	\N	\N	\N	213903	213903	380984
28753	46797	0	applied	\N	\N	\N	\N	213917	213917	380998
28755	46812	0	applied	\N	\N	\N	\N	213919	213919	381000
28755	46813	1	applied	\N	\N	\N	\N	213920	213920	381001
28757	46814	0	applied	\N	\N	\N	\N	213923	213923	381004
28757	46815	1	applied	\N	\N	\N	\N	213924	213924	381005
28757	46816	2	applied	\N	\N	\N	\N	213925	213925	381006
28757	46817	3	applied	\N	\N	\N	\N	213926	213926	381007
28760	46818	0	applied	\N	\N	\N	\N	213933	213933	381014
28760	46819	1	applied	\N	\N	\N	\N	213934	213934	381015
28762	46821	1	applied	\N	\N	\N	\N	213938	213938	381019
28762	46822	2	applied	\N	\N	\N	\N	213939	213939	381020
28762	46823	3	applied	\N	\N	\N	\N	213940	213940	381021
28764	46824	0	applied	\N	\N	\N	\N	213943	213943	381024
28764	46826	1	applied	\N	\N	\N	\N	213944	213944	381025
28764	46827	2	applied	\N	\N	\N	\N	213945	213945	381026
28764	46825	3	applied	\N	\N	\N	\N	213946	213946	381027
28767	46828	0	applied	\N	\N	\N	\N	213955	213955	381036
28767	46829	2	applied	\N	\N	\N	\N	213956	213956	381037
28767	46830	3	applied	\N	\N	\N	\N	213957	213957	381038
28767	46831	4	applied	\N	\N	\N	\N	213958	213958	381039
28767	46832	5	applied	\N	\N	\N	\N	213959	213959	381040
28767	46833	6	applied	\N	\N	\N	\N	213960	213960	381041
28767	46834	7	applied	\N	\N	\N	\N	213961	213961	381042
28767	46835	8	applied	\N	\N	\N	\N	213962	213962	381043
28769	46836	0	applied	\N	\N	\N	\N	213971	213971	381052
28720	46781	3	applied	\N	\N	\N	\N	213708	213708	380789
28722	46782	0	applied	\N	\N	\N	\N	213713	213713	380794
28749	46808	1	applied	\N	\N	\N	\N	213909	213909	380990
28749	46809	2	applied	\N	\N	\N	\N	213910	213910	380991
28751	46810	0	applied	\N	\N	\N	\N	213914	213914	380995
28751	46811	1	applied	\N	\N	\N	\N	213915	213915	380996
28761	46818	0	applied	\N	\N	\N	\N	213935	213935	381016
28761	46819	1	applied	\N	\N	\N	\N	213936	213936	381017
28768	46828	0	applied	\N	\N	\N	\N	213963	213963	381044
28768	46829	2	applied	\N	\N	\N	\N	213964	213964	381045
28768	46830	3	applied	\N	\N	\N	\N	213965	213965	381046
28768	46831	4	applied	\N	\N	\N	\N	213966	213966	381047
28768	46832	5	applied	\N	\N	\N	\N	213967	213967	381048
28768	46833	6	applied	\N	\N	\N	\N	213968	213968	381049
28768	46834	7	applied	\N	\N	\N	\N	213969	213969	381050
28768	46835	8	applied	\N	\N	\N	\N	213970	213970	381051
28769	46838	2	applied	\N	\N	\N	\N	213973	213973	381054
28769	46839	3	applied	\N	\N	\N	\N	213974	213974	381055
28769	46840	4	applied	\N	\N	\N	\N	213975	213975	381056
28769	46841	5	applied	\N	\N	1000000000	\N	213976	213976	381057
28769	46842	6	applied	\N	\N	\N	\N	213977	213977	381058
28770	46843	0	applied	\N	\N	\N	\N	213978	213978	381059
28770	46844	1	applied	\N	\N	\N	\N	213979	213979	381060
28770	46845	2	applied	\N	\N	\N	\N	213980	213980	381061
28772	46846	0	applied	\N	\N	\N	\N	213984	213984	381065
28772	46847	1	applied	\N	\N	\N	\N	213985	213985	381066
28772	46848	2	applied	\N	\N	\N	\N	213986	213986	381067
28772	46849	3	applied	\N	\N	\N	\N	213987	213987	381068
28774	46851	0	applied	\N	\N	\N	\N	213989	213989	381070
28774	46850	1	applied	\N	\N	\N	\N	213990	213990	381071
28774	46852	2	applied	\N	\N	\N	\N	213991	213991	381072
28776	46850	0	applied	\N	\N	\N	\N	213995	213995	381076
28777	46853	1	applied	\N	\N	\N	\N	213997	213997	381078
28777	46854	2	applied	\N	\N	\N	\N	213998	213998	381079
28777	46852	3	applied	\N	\N	\N	\N	213999	213999	381080
28777	46855	4	applied	\N	\N	\N	\N	214000	214000	381081
28777	46856	5	applied	\N	\N	\N	\N	214001	214001	381082
28777	46857	6	applied	\N	\N	\N	\N	214002	214002	381083
28777	46858	7	applied	\N	\N	\N	\N	214003	214003	381084
28779	46859	0	applied	\N	\N	\N	\N	214012	214012	381093
28779	46860	1	applied	\N	\N	\N	\N	214013	214013	381094
28779	46861	2	applied	\N	\N	\N	\N	214014	214014	381095
28779	46862	3	applied	\N	\N	\N	\N	214015	214015	381096
28779	46863	4	applied	\N	\N	\N	\N	214016	214016	381097
28779	46864	5	applied	\N	\N	\N	\N	214017	214017	381098
28780	46859	0	applied	\N	\N	\N	\N	214018	214018	381099
28780	46860	1	applied	\N	\N	\N	\N	214019	214019	381100
28780	46861	2	applied	\N	\N	\N	\N	214020	214020	381101
28780	46863	4	applied	\N	\N	\N	\N	214022	214022	381103
28780	46864	5	applied	\N	\N	\N	\N	214023	214023	381104
28782	46859	0	applied	\N	\N	\N	\N	214030	214030	381111
28782	46860	1	applied	\N	\N	\N	\N	214031	214031	381112
28782	46861	2	applied	\N	\N	\N	\N	214032	214032	381113
28782	46862	3	applied	\N	\N	\N	\N	214033	214033	381114
28782	46863	4	applied	\N	\N	\N	\N	214034	214034	381115
28782	46864	5	applied	\N	\N	\N	\N	214035	214035	381116
28783	46865	0	applied	\N	\N	\N	\N	214036	214036	381117
28783	46866	1	applied	\N	\N	\N	\N	214037	214037	381118
28783	46867	2	applied	\N	\N	\N	\N	214038	214038	381119
28783	46868	3	applied	\N	\N	\N	\N	214039	214039	381120
28784	46869	0	applied	\N	\N	\N	\N	214040	214040	381121
28784	46870	1	applied	\N	\N	\N	\N	214041	214041	381122
28784	46871	2	applied	\N	\N	\N	\N	214042	214042	381123
28784	46872	3	applied	\N	\N	\N	\N	214043	214043	381124
28786	46874	0	applied	\N	\N	\N	\N	214048	214048	381129
28786	46875	1	applied	\N	\N	\N	\N	214049	214049	381130
28786	46876	2	applied	\N	\N	\N	\N	214050	214050	381131
28787	46877	0	applied	\N	\N	\N	\N	214051	214051	381132
28787	46878	1	applied	\N	\N	\N	\N	214052	214052	381133
28787	46879	2	applied	\N	\N	\N	\N	214053	214053	381134
28787	46880	3	applied	\N	\N	\N	\N	214054	214054	381135
28789	46883	0	applied	\N	\N	\N	\N	214057	214057	381138
28789	46884	1	applied	\N	\N	\N	\N	214058	214058	381139
28789	46885	2	applied	\N	\N	\N	\N	214059	214059	381140
28789	46886	3	applied	\N	\N	\N	\N	214060	214060	381141
28789	46887	4	applied	\N	\N	\N	\N	214061	214061	381142
28789	46888	5	applied	\N	\N	\N	\N	214062	214062	381143
28789	46889	6	applied	\N	\N	\N	\N	214063	214063	381144
28789	46890	7	applied	\N	\N	\N	\N	214064	214064	381145
28789	46891	8	applied	\N	\N	\N	\N	214065	214065	381146
28790	46893	0	applied	\N	\N	\N	\N	214067	214067	381148
28790	46894	1	applied	\N	\N	\N	\N	214068	214068	381149
28792	46899	0	applied	\N	\N	\N	\N	214073	214073	381154
28792	46900	1	applied	\N	\N	\N	\N	214074	214074	381155
28792	46901	2	applied	\N	\N	\N	\N	214075	214075	381156
28792	46902	3	applied	\N	\N	\N	\N	214076	214076	381157
28792	46903	4	applied	\N	\N	\N	\N	214077	214077	381158
28794	46899	0	applied	\N	\N	\N	\N	214083	214083	381164
28794	46900	1	applied	\N	\N	\N	\N	214084	214084	381165
28794	46901	2	applied	\N	\N	\N	\N	214085	214085	381166
28794	46902	3	applied	\N	\N	\N	\N	214086	214086	381167
28794	46903	4	applied	\N	\N	\N	\N	214087	214087	381168
28799	46907	0	applied	\N	\N	\N	\N	214100	214100	381181
28799	46908	1	applied	\N	\N	\N	\N	214101	214101	381182
28806	46913	0	applied	\N	\N	\N	\N	214112	214112	381193
28806	46914	1	applied	\N	\N	\N	\N	214113	214113	381194
28806	46916	3	applied	\N	\N	\N	\N	214115	214115	381196
28806	46917	4	applied	\N	\N	\N	\N	214116	214116	381197
28806	46918	6	applied	\N	\N	\N	\N	214117	214117	381198
28810	46919	0	applied	\N	\N	\N	\N	214127	214127	381208
28810	46920	1	applied	\N	\N	\N	\N	214128	214128	381209
28810	46921	2	applied	\N	\N	\N	\N	214129	214129	381210
28812	46922	0	applied	\N	\N	\N	\N	214133	214133	381214
28812	46924	1	applied	\N	\N	\N	\N	214134	214134	381215
28814	46926	0	applied	\N	\N	\N	\N	214138	214138	381219
28816	46925	0	applied	\N	\N	\N	\N	214142	214142	381223
28816	46926	1	applied	\N	\N	\N	\N	214143	214143	381224
28816	46927	2	applied	\N	\N	\N	\N	214144	214144	381225
28821	46936	0	applied	\N	\N	\N	\N	214156	214156	381237
28821	46937	1	applied	\N	\N	\N	\N	214157	214157	381238
28821	46938	2	applied	\N	\N	\N	\N	214158	214158	381239
28824	46941	0	applied	\N	\N	\N	\N	214175	214175	381256
28749	46807	0	applied	\N	\N	\N	\N	213908	213908	380989
28741	46544	100	applied	\N	\N	\N	\N	213870	213870	380951
28741	46545	101	applied	\N	\N	\N	\N	213871	213871	380952
28741	46546	102	applied	\N	\N	\N	\N	213872	213872	380953
28741	46553	103	applied	\N	\N	\N	\N	213873	213873	380954
28741	46554	104	applied	\N	\N	\N	\N	213874	213874	380955
28741	46560	105	applied	\N	\N	\N	\N	213875	213875	380956
28741	46561	106	applied	\N	\N	\N	\N	213876	213876	380957
28741	46567	107	applied	\N	\N	\N	\N	213877	213877	380958
28741	46568	108	applied	\N	\N	\N	\N	213878	213878	380959
28741	46572	109	applied	\N	\N	\N	\N	213879	213879	380960
28741	46576	110	applied	\N	\N	\N	\N	213880	213880	380961
28741	46577	111	applied	\N	\N	\N	\N	213881	213881	380962
28741	46578	112	applied	\N	\N	\N	\N	213882	213882	380963
28741	46585	113	applied	\N	\N	\N	\N	213883	213883	380964
28741	46588	114	applied	\N	\N	\N	\N	213884	213884	380965
28741	46591	115	applied	\N	\N	\N	\N	213885	213885	380966
28741	46604	117	applied	\N	\N	\N	\N	213887	213887	380968
28741	46607	118	applied	\N	\N	\N	\N	213888	213888	380969
28741	46610	119	applied	\N	\N	\N	\N	213889	213889	380970
28741	46613	120	applied	\N	\N	\N	\N	213890	213890	380971
28741	46616	121	applied	\N	\N	\N	\N	213891	213891	380972
28741	46620	122	applied	\N	\N	\N	\N	213892	213892	380973
28741	46622	123	applied	\N	\N	\N	\N	213893	213893	380974
28741	46625	124	applied	\N	\N	\N	\N	213894	213894	380975
28741	46626	125	applied	\N	\N	\N	\N	213895	213895	380976
28743	46805	0	applied	\N	\N	\N	\N	213898	213898	380979
28743	46806	1	applied	\N	\N	\N	\N	213899	213899	380980
28752	46797	0	applied	\N	\N	\N	\N	213916	213916	380997
28754	46797	0	applied	\N	\N	\N	\N	213918	213918	380999
28756	46812	0	applied	\N	\N	\N	\N	213921	213921	381002
28756	46813	1	applied	\N	\N	\N	\N	213922	213922	381003
28758	46814	0	applied	\N	\N	\N	\N	213927	213927	381008
28758	46816	2	applied	\N	\N	\N	\N	213929	213929	381010
28758	46817	3	applied	\N	\N	\N	\N	213930	213930	381011
28763	46824	0	applied	\N	\N	\N	\N	213941	213941	381022
28763	46825	1	applied	\N	\N	\N	\N	213942	213942	381023
28773	46850	0	applied	\N	\N	\N	\N	213988	213988	381069
28775	46851	0	applied	\N	\N	\N	\N	213992	213992	381073
28775	46850	1	applied	\N	\N	\N	\N	213993	213993	381074
28775	46852	2	applied	\N	\N	\N	\N	213994	213994	381075
28781	46859	0	applied	\N	\N	\N	\N	214024	214024	381105
28781	46860	1	applied	\N	\N	\N	\N	214025	214025	381106
28781	46861	2	applied	\N	\N	\N	\N	214026	214026	381107
28781	46862	3	applied	\N	\N	\N	\N	214027	214027	381108
28793	46899	0	applied	\N	\N	\N	\N	214078	214078	381159
28793	46900	1	applied	\N	\N	\N	\N	214079	214079	381160
28793	46901	2	applied	\N	\N	\N	\N	214080	214080	381161
28793	46902	3	applied	\N	\N	\N	\N	214081	214081	381162
28795	46904	0	applied	\N	\N	\N	\N	214088	214088	381169
28795	46905	1	applied	\N	\N	\N	\N	214089	214089	381170
28795	46906	2	applied	\N	\N	\N	\N	214090	214090	381171
28797	46904	0	applied	\N	\N	\N	\N	214094	214094	381175
28797	46905	1	applied	\N	\N	\N	\N	214095	214095	381176
28797	46906	2	applied	\N	\N	\N	\N	214096	214096	381177
28808	46919	0	applied	\N	\N	\N	\N	214121	214121	381202
28808	46920	1	applied	\N	\N	\N	\N	214122	214122	381203
28808	46921	2	applied	\N	\N	\N	\N	214123	214123	381204
28815	46925	0	applied	\N	\N	\N	\N	214139	214139	381220
28815	46926	1	applied	\N	\N	\N	\N	214140	214140	381221
28815	46927	2	applied	\N	\N	\N	\N	214141	214141	381222
28817	46928	0	applied	\N	\N	\N	\N	214145	214145	381226
28817	46929	1	applied	\N	\N	\N	\N	214146	214146	381227
28817	46930	2	applied	\N	\N	\N	\N	214147	214147	381228
28819	46931	0	applied	\N	\N	\N	\N	214151	214151	381232
28819	46933	2	applied	\N	\N	\N	\N	214153	214153	381234
28822	46939	0	applied	\N	\N	\N	\N	214159	214159	381240
28822	46940	1	applied	\N	\N	\N	\N	214160	214160	381241
28827	46949	0	applied	\N	\N	\N	\N	214199	214199	381280
28827	46950	1	applied	\N	\N	\N	\N	214200	214200	381281
28827	46951	2	applied	\N	\N	\N	\N	214201	214201	381282
28829	46952	0	applied	\N	\N	\N	\N	214209	214209	381290
28829	46953	1	applied	\N	\N	\N	\N	214210	214210	381291
28829	46954	2	applied	\N	\N	\N	\N	214211	214211	381292
28829	46955	3	applied	\N	\N	\N	\N	214212	214212	381293
28829	46956	4	applied	\N	\N	\N	\N	214213	214213	381294
28829	46957	5	applied	\N	\N	\N	\N	214214	214214	381295
28829	46958	6	applied	\N	\N	\N	\N	214215	214215	381296
28832	46952	0	applied	\N	\N	\N	\N	214230	214230	381311
28832	46953	1	applied	\N	\N	\N	\N	214231	214231	381312
28832	46954	2	applied	\N	\N	\N	\N	214232	214232	381313
28832	46956	4	applied	\N	\N	\N	\N	214234	214234	381315
28832	46957	5	applied	\N	\N	\N	\N	214235	214235	381316
28832	46958	6	applied	\N	\N	\N	\N	214236	214236	381317
28834	46960	0	applied	\N	\N	\N	\N	214238	214238	381319
28834	46961	1	applied	\N	\N	\N	\N	214239	214239	381320
28834	46962	2	applied	\N	\N	\N	\N	214240	214240	381321
28834	46963	3	applied	\N	\N	\N	\N	214241	214241	381322
28834	46964	4	applied	\N	\N	\N	\N	214242	214242	381323
28834	46965	5	applied	\N	\N	\N	\N	214243	214243	381324
28839	46972	0	applied	\N	\N	\N	\N	214259	214259	381340
28839	46973	1	applied	\N	\N	\N	\N	214260	214260	381341
28839	46974	2	applied	\N	\N	\N	\N	214261	214261	381342
28842	46975	0	applied	\N	\N	\N	\N	214276	214276	381357
28842	46976	1	applied	\N	\N	\N	\N	214277	214277	381358
28842	46977	2	applied	\N	\N	\N	\N	214278	214278	381359
28842	46978	3	applied	\N	\N	\N	\N	214279	214279	381360
28842	46980	5	applied	\N	\N	\N	\N	214281	214281	381362
28842	46981	6	applied	\N	\N	\N	\N	214282	214282	381363
28850	46988	0	applied	\N	\N	\N	\N	214297	214297	381378
28850	46989	1	applied	\N	\N	\N	\N	214298	214298	381379
28850	46990	2	applied	\N	\N	\N	\N	214299	214299	381380
28850	46991	3	applied	\N	\N	\N	\N	214300	214300	381381
28850	46992	4	applied	\N	\N	\N	\N	214301	214301	381382
28850	46993	5	applied	\N	\N	\N	\N	214302	214302	381383
28853	47003	0	applied	\N	\N	\N	\N	214312	214312	381393
28853	47004	1	applied	\N	\N	\N	\N	214313	214313	381394
28853	47005	2	applied	\N	\N	\N	\N	214314	214314	381395
28853	47006	3	applied	\N	\N	\N	\N	214315	214315	381396
28853	47007	4	applied	\N	\N	\N	\N	214316	214316	381397
28853	47008	5	applied	\N	\N	\N	\N	214317	214317	381398
28741	46534	97	applied	\N	\N	\N	\N	213867	213867	380948
28741	46537	98	applied	\N	\N	\N	\N	213868	213868	380949
28785	46875	1	applied	\N	\N	\N	\N	214046	214046	381127
28785	46876	2	applied	\N	\N	\N	\N	214047	214047	381128
28796	46904	0	applied	\N	\N	\N	\N	214091	214091	381172
28796	46905	1	applied	\N	\N	\N	\N	214092	214092	381173
28796	46906	2	applied	\N	\N	\N	\N	214093	214093	381174
28802	46910	0	applied	\N	\N	\N	\N	214102	214102	381183
28802	46911	1	applied	\N	\N	\N	\N	214103	214103	381184
28802	46909	2	applied	\N	\N	\N	\N	214104	214104	381185
28802	46912	3	applied	\N	\N	\N	\N	214105	214105	381186
28809	46919	0	applied	\N	\N	\N	\N	214124	214124	381205
28809	46920	1	applied	\N	\N	\N	\N	214125	214125	381206
28809	46921	2	applied	\N	\N	\N	\N	214126	214126	381207
28811	46922	0	applied	\N	\N	\N	\N	214130	214130	381211
28811	46924	2	applied	\N	\N	\N	\N	214132	214132	381213
28813	46925	0	applied	\N	\N	\N	\N	214135	214135	381216
28813	46926	1	applied	\N	\N	\N	\N	214136	214136	381217
28813	46927	2	applied	\N	\N	\N	\N	214137	214137	381218
28820	46934	0	applied	\N	\N	\N	\N	214154	214154	381235
28820	46935	1	applied	\N	\N	\N	\N	214155	214155	381236
28823	46820	0	applied	\N	\N	1000000000	\N	214161	214161	381242
28823	46797	1	applied	\N	\N	\N	\N	214162	214162	381243
28823	46841	2	applied	\N	\N	1000000000	\N	214163	214163	381244
28823	46751	3	applied	\N	\N	\N	\N	214164	214164	381245
28823	46762	4	applied	\N	\N	\N	\N	214165	214165	381246
28823	46773	5	applied	\N	\N	\N	\N	214166	214166	381247
28823	46780	6	applied	\N	\N	\N	\N	214167	214167	381248
28823	46791	7	applied	\N	\N	\N	\N	214168	214168	381249
28823	46802	8	applied	\N	\N	\N	\N	214169	214169	381250
28823	46808	9	applied	\N	\N	\N	\N	214170	214170	381251
28823	46825	11	applied	\N	\N	\N	\N	214172	214172	381253
28823	46833	12	applied	\N	\N	\N	\N	214173	214173	381254
28823	46847	13	applied	\N	\N	\N	\N	214174	214174	381255
28824	46942	1	applied	\N	\N	\N	\N	214176	214176	381257
28824	46943	2	applied	\N	\N	\N	\N	214177	214177	381258
28824	46944	3	applied	\N	\N	\N	\N	214178	214178	381259
28824	46945	4	applied	\N	\N	\N	\N	214179	214179	381260
28824	46946	5	applied	\N	\N	\N	\N	214180	214180	381261
28824	46947	6	applied	\N	\N	\N	\N	214181	214181	381262
28824	46948	7	applied	\N	\N	\N	\N	214182	214182	381263
28825	46941	0	applied	\N	\N	\N	\N	214183	214183	381264
28825	46942	1	applied	\N	\N	\N	\N	214184	214184	381265
28825	46943	2	applied	\N	\N	\N	\N	214185	214185	381266
28825	46944	3	applied	\N	\N	\N	\N	214186	214186	381267
28825	46945	4	applied	\N	\N	\N	\N	214187	214187	381268
28825	46946	5	applied	\N	\N	\N	\N	214188	214188	381269
28825	46948	7	applied	\N	\N	\N	\N	214190	214190	381271
28826	46941	0	applied	\N	\N	\N	\N	214191	214191	381272
28826	46942	1	applied	\N	\N	\N	\N	214192	214192	381273
28826	46943	2	applied	\N	\N	\N	\N	214193	214193	381274
28826	46944	3	applied	\N	\N	\N	\N	214194	214194	381275
28826	46945	4	applied	\N	\N	\N	\N	214195	214195	381276
28826	46946	5	applied	\N	\N	\N	\N	214196	214196	381277
28826	46947	6	applied	\N	\N	\N	\N	214197	214197	381278
28826	46948	7	applied	\N	\N	\N	\N	214198	214198	381279
28831	46952	0	applied	\N	\N	\N	\N	214223	214223	381304
28831	46953	1	applied	\N	\N	\N	\N	214224	214224	381305
28831	46954	2	applied	\N	\N	\N	\N	214225	214225	381306
28831	46955	3	applied	\N	\N	\N	\N	214226	214226	381307
28831	46956	4	applied	\N	\N	\N	\N	214227	214227	381308
28831	46957	5	applied	\N	\N	\N	\N	214228	214228	381309
28831	46958	6	applied	\N	\N	\N	\N	214229	214229	381310
28835	46966	0	applied	\N	\N	\N	\N	214244	214244	381325
28835	46967	1	applied	\N	\N	\N	\N	214245	214245	381326
28835	46968	2	applied	\N	\N	\N	\N	214246	214246	381327
28835	46969	3	applied	\N	\N	\N	\N	214247	214247	381328
28835	46970	4	applied	\N	\N	\N	\N	214248	214248	381329
28835	46971	5	applied	\N	\N	\N	\N	214249	214249	381330
28836	46972	0	applied	\N	\N	\N	\N	214250	214250	381331
28836	46973	1	applied	\N	\N	\N	\N	214251	214251	381332
28836	46974	2	applied	\N	\N	\N	\N	214252	214252	381333
28837	46972	0	applied	\N	\N	\N	\N	214253	214253	381334
28837	46973	1	applied	\N	\N	\N	\N	214254	214254	381335
28837	46974	2	applied	\N	\N	\N	\N	214255	214255	381336
28838	46972	0	applied	\N	\N	\N	\N	214256	214256	381337
28838	46973	1	applied	\N	\N	\N	\N	214257	214257	381338
28838	46974	2	applied	\N	\N	\N	\N	214258	214258	381339
28843	46982	0	applied	\N	\N	\N	\N	214283	214283	381364
28845	46984	0	applied	\N	\N	\N	\N	214285	214285	381366
28845	46985	1	applied	\N	\N	\N	\N	214286	214286	381367
28845	46986	2	applied	\N	\N	\N	\N	214287	214287	381368
28845	46987	3	applied	\N	\N	\N	\N	214288	214288	381369
28846	46984	0	applied	\N	\N	\N	\N	214289	214289	381370
28846	46985	1	applied	\N	\N	\N	\N	214290	214290	381371
28846	46986	2	applied	\N	\N	\N	\N	214291	214291	381372
28846	46987	3	applied	\N	\N	\N	\N	214292	214292	381373
28851	46994	0	applied	\N	\N	\N	\N	214303	214303	381384
28851	46995	1	applied	\N	\N	\N	\N	214304	214304	381385
28851	46996	2	applied	\N	\N	\N	\N	214305	214305	381386
28851	46997	3	applied	\N	\N	\N	\N	214306	214306	381387
28851	46998	4	applied	\N	\N	\N	\N	214307	214307	381388
28851	46999	5	applied	\N	\N	\N	\N	214308	214308	381389
28855	47009	0	applied	\N	\N	\N	\N	214324	214324	381405
28855	47010	1	applied	\N	\N	\N	\N	214325	214325	381406
28855	47012	3	applied	\N	\N	\N	\N	214327	214327	381408
28855	47013	4	applied	\N	\N	\N	\N	214328	214328	381409
28857	47019	0	applied	\N	\N	\N	\N	214351	214351	381432
28857	47020	1	applied	\N	\N	\N	\N	214352	214352	381433
28857	47021	2	applied	\N	\N	\N	\N	214353	214353	381434
28857	47022	3	applied	\N	\N	\N	\N	214354	214354	381435
28857	47023	4	applied	\N	\N	\N	\N	214355	214355	381436
28857	47024	5	applied	\N	\N	\N	\N	214356	214356	381437
28857	47025	6	applied	\N	\N	\N	\N	214357	214357	381438
28857	47026	7	applied	\N	\N	\N	\N	214358	214358	381439
28857	47027	8	applied	\N	\N	\N	\N	214359	214359	381440
28857	47028	9	applied	\N	\N	\N	\N	214360	214360	381441
28857	47029	10	applied	\N	\N	\N	\N	214361	214361	381442
28857	47030	11	applied	\N	\N	\N	\N	214362	214362	381443
28857	47031	12	applied	\N	\N	\N	\N	214363	214363	381444
28857	47032	13	applied	\N	\N	\N	\N	214364	214364	381445
28781	46864	5	applied	\N	\N	\N	\N	214029	214029	381110
28785	46874	0	applied	\N	\N	\N	\N	214045	214045	381126
28830	46957	5	applied	\N	\N	\N	\N	214221	214221	381302
28830	46958	6	applied	\N	\N	\N	\N	214222	214222	381303
28840	46975	0	applied	\N	\N	\N	\N	214262	214262	381343
28840	46976	1	applied	\N	\N	\N	\N	214263	214263	381344
28840	46977	2	applied	\N	\N	\N	\N	214264	214264	381345
28840	46978	3	applied	\N	\N	\N	\N	214265	214265	381346
28840	46979	4	applied	\N	\N	\N	\N	214266	214266	381347
28840	46980	5	applied	\N	\N	\N	\N	214267	214267	381348
28840	46981	6	applied	\N	\N	\N	\N	214268	214268	381349
28841	46975	0	applied	\N	\N	\N	\N	214269	214269	381350
28841	46976	1	applied	\N	\N	\N	\N	214270	214270	381351
28841	46978	3	applied	\N	\N	\N	\N	214272	214272	381353
28841	46979	4	applied	\N	\N	\N	\N	214273	214273	381354
28841	46980	5	applied	\N	\N	\N	\N	214274	214274	381355
28841	46981	6	applied	\N	\N	\N	\N	214275	214275	381356
28847	46984	0	applied	\N	\N	\N	\N	214293	214293	381374
28847	46985	1	applied	\N	\N	\N	\N	214294	214294	381375
28847	46986	2	applied	\N	\N	\N	\N	214295	214295	381376
28847	46987	3	applied	\N	\N	\N	\N	214296	214296	381377
28852	47000	0	applied	\N	\N	\N	\N	214309	214309	381390
28852	47001	1	applied	\N	\N	\N	\N	214310	214310	381391
28852	47002	2	applied	\N	\N	\N	\N	214311	214311	381392
28854	47003	0	applied	\N	\N	\N	\N	214318	214318	381399
28854	47004	1	applied	\N	\N	\N	\N	214319	214319	381400
28854	47005	2	applied	\N	\N	\N	\N	214320	214320	381401
28854	47006	3	applied	\N	\N	\N	\N	214321	214321	381402
28854	47007	4	applied	\N	\N	\N	\N	214322	214322	381403
28857	47034	15	applied	\N	\N	\N	\N	214366	214366	381447
28857	47035	16	applied	\N	\N	\N	\N	214367	214367	381448
28858	47019	0	applied	\N	\N	\N	\N	214368	214368	381449
28858	47020	1	applied	\N	\N	\N	\N	214369	214369	381450
28858	47021	2	applied	\N	\N	\N	\N	214370	214370	381451
28858	47022	3	applied	\N	\N	\N	\N	214371	214371	381452
28858	47023	4	applied	\N	\N	\N	\N	214372	214372	381453
28858	47024	5	applied	\N	\N	\N	\N	214373	214373	381454
28858	47025	6	applied	\N	\N	\N	\N	214374	214374	381455
28858	47026	7	applied	\N	\N	\N	\N	214375	214375	381456
28858	47027	8	applied	\N	\N	\N	\N	214376	214376	381457
28858	47028	9	applied	\N	\N	\N	\N	214377	214377	381458
28858	47029	10	applied	\N	\N	\N	\N	214378	214378	381459
28858	47030	11	applied	\N	\N	\N	\N	214379	214379	381460
28858	47031	12	applied	\N	\N	\N	\N	214380	214380	381461
28858	47032	13	applied	\N	\N	\N	\N	214381	214381	381462
28858	47034	15	applied	\N	\N	\N	\N	214383	214383	381464
28858	47035	16	applied	\N	\N	\N	\N	214384	214384	381465
28861	47036	0	applied	\N	\N	\N	\N	214391	214391	381472
28861	47037	1	applied	\N	\N	\N	\N	214392	214392	381473
28861	47038	2	applied	\N	\N	\N	\N	214393	214393	381474
28862	47036	0	applied	\N	\N	\N	\N	214394	214394	381475
28863	47039	0	applied	\N	\N	\N	\N	214397	214397	381478
28863	47040	1	applied	\N	\N	\N	\N	214398	214398	381479
28863	47041	2	applied	\N	\N	\N	\N	214399	214399	381480
28863	47042	3	applied	\N	\N	\N	\N	214400	214400	381481
28868	47054	0	applied	\N	\N	\N	\N	214415	214415	381494
28868	47055	1	applied	\N	\N	\N	\N	214416	214416	381495
28870	47056	0	applied	\N	\N	\N	\N	214420	214420	381499
28870	47057	1	applied	\N	\N	\N	\N	214421	214421	381500
28870	47058	2	applied	\N	\N	\N	\N	214422	214422	381501
28872	47063	0	applied	\N	\N	\N	\N	214427	214427	381506
28872	47065	2	applied	\N	\N	\N	\N	214429	214429	381508
28872	47066	3	applied	\N	\N	\N	\N	214430	214430	381509
28872	47067	4	applied	\N	\N	\N	\N	214431	214431	381510
28874	47068	0	applied	\N	\N	\N	\N	214437	214437	381516
28881	47077	0	applied	\N	\N	\N	\N	214460	214460	381539
28881	47078	1	applied	\N	\N	\N	\N	214461	214461	381540
28881	47079	2	applied	\N	\N	\N	\N	214462	214462	381541
28886	47088	0	applied	\N	\N	\N	\N	214481	214481	381560
28886	47089	1	applied	\N	\N	\N	\N	214482	214482	381561
28886	47090	2	applied	\N	\N	\N	\N	214483	214483	381562
28886	47091	3	applied	\N	\N	\N	\N	214484	214484	381563
28886	47092	4	applied	\N	\N	\N	\N	214485	214485	381564
28886	47093	6	applied	\N	\N	\N	\N	214486	214486	381565
28886	47094	7	applied	\N	\N	1000000000	\N	214487	214487	381566
28893	47107	0	applied	\N	\N	\N	\N	214512	214512	381591
28893	47108	1	applied	\N	\N	\N	\N	214513	214513	381592
28893	47110	3	applied	\N	\N	\N	\N	214515	214515	381594
28895	47107	0	applied	\N	\N	\N	\N	214520	214520	381599
28895	47109	1	applied	\N	\N	\N	\N	214521	214521	381600
28895	47110	2	applied	\N	\N	\N	\N	214522	214522	381601
28897	47111	0	applied	\N	\N	\N	\N	214527	214527	381606
28897	47108	1	applied	\N	\N	\N	\N	214528	214528	381607
28897	47112	2	applied	\N	\N	\N	\N	214529	214529	381608
28897	47113	3	applied	\N	\N	\N	\N	214530	214530	381609
28905	47063	0	applied	\N	\N	\N	\N	214614	214614	381693
28905	47083	1	applied	\N	\N	\N	\N	214615	214615	381694
28905	47072	2	applied	\N	\N	\N	\N	214616	214616	381695
28905	47064	3	applied	\N	\N	\N	\N	214617	214617	381696
28905	47069	4	applied	\N	\N	\N	\N	214618	214618	381697
28905	47073	5	applied	\N	\N	\N	\N	214619	214619	381698
28905	47077	6	applied	\N	\N	\N	\N	214620	214620	381699
28905	47080	7	applied	\N	\N	\N	\N	214621	214621	381700
28905	47088	9	applied	\N	\N	\N	\N	214623	214623	381702
28905	47089	10	applied	\N	\N	\N	\N	214624	214624	381703
28905	47095	11	applied	\N	\N	\N	\N	214625	214625	381704
28905	47097	12	applied	\N	\N	\N	\N	214626	214626	381705
28905	47101	13	applied	\N	\N	\N	\N	214627	214627	381706
28905	47102	14	applied	\N	\N	\N	\N	214628	214628	381707
28905	47107	15	applied	\N	\N	\N	\N	214629	214629	381708
28905	47111	16	applied	\N	\N	\N	\N	214630	214630	381709
28905	47114	17	applied	\N	\N	\N	\N	214631	214631	381710
28905	47117	18	applied	\N	\N	\N	\N	214632	214632	381711
28905	47118	19	applied	\N	\N	\N	\N	214633	214633	381712
28905	47123	20	applied	\N	\N	\N	\N	214634	214634	381713
28905	47065	21	applied	\N	\N	\N	\N	214635	214635	381714
28905	47081	22	applied	\N	\N	1000000000	\N	214636	214636	381715
28905	47070	23	applied	\N	\N	\N	\N	214637	214637	381716
28905	47074	24	applied	\N	\N	\N	\N	214638	214638	381717
28905	47104	26	applied	\N	\N	1000000000	\N	214640	214640	381719
28905	47066	27	applied	\N	\N	\N	\N	214641	214641	381720
28830	46955	3	applied	\N	\N	\N	\N	214219	214219	381300
28830	46956	4	applied	\N	\N	\N	\N	214220	214220	381301
28855	47017	8	applied	\N	\N	\N	\N	214332	214332	381413
28855	47018	9	applied	\N	\N	1000000000	\N	214333	214333	381414
28859	47036	0	applied	\N	\N	\N	\N	214385	214385	381466
28859	47037	1	applied	\N	\N	\N	\N	214386	214386	381467
28859	47038	2	applied	\N	\N	\N	\N	214387	214387	381468
28862	47037	1	applied	\N	\N	\N	\N	214395	214395	381476
28862	47038	2	applied	\N	\N	\N	\N	214396	214396	381477
28864	47044	1	applied	\N	\N	\N	\N	214402	214402	381482
28864	47045	2	applied	\N	\N	\N	\N	214403	214403	381483
28866	47046	0	applied	\N	\N	\N	\N	214407	214407	381486
28866	47047	1	applied	\N	\N	\N	\N	214408	214408	381487
28866	47048	2	applied	\N	\N	\N	\N	214409	214409	381488
28869	47056	0	applied	\N	\N	\N	\N	214417	214417	381496
28869	47057	1	applied	\N	\N	\N	\N	214418	214418	381497
28869	47058	2	applied	\N	\N	\N	\N	214419	214419	381498
28871	47059	0	applied	\N	\N	\N	\N	214423	214423	381502
28871	47060	1	applied	\N	\N	\N	\N	214424	214424	381503
28871	47061	2	applied	\N	\N	\N	\N	214425	214425	381504
28871	47062	3	applied	\N	\N	\N	\N	214426	214426	381505
28876	47069	0	applied	\N	\N	\N	\N	214441	214441	381520
28876	47070	1	applied	\N	\N	\N	\N	214442	214442	381521
28876	47071	2	applied	\N	\N	\N	\N	214443	214443	381522
28877	47069	0	applied	\N	\N	\N	\N	214444	214444	381523
28877	47070	1	applied	\N	\N	\N	\N	214445	214445	381524
28877	47071	2	applied	\N	\N	\N	\N	214446	214446	381525
28878	47072	0	applied	\N	\N	\N	\N	214447	214447	381526
28878	47073	1	applied	\N	\N	\N	\N	214448	214448	381527
28878	47074	2	applied	\N	\N	\N	\N	214449	214449	381528
28878	47075	3	applied	\N	\N	\N	\N	214450	214450	381529
28878	47076	4	applied	\N	\N	\N	\N	214451	214451	381530
28880	47077	0	applied	\N	\N	\N	\N	214457	214457	381536
28880	47078	1	applied	\N	\N	\N	\N	214458	214458	381537
28880	47079	2	applied	\N	\N	\N	\N	214459	214459	381538
28882	47077	0	applied	\N	\N	\N	\N	214463	214463	381542
28882	47078	1	applied	\N	\N	\N	\N	214464	214464	381543
28882	47079	2	applied	\N	\N	\N	\N	214465	214465	381544
28884	47083	0	applied	\N	\N	\N	\N	214469	214469	381548
28884	47084	1	applied	\N	\N	\N	\N	214470	214470	381549
28884	47086	3	applied	\N	\N	\N	\N	214472	214472	381551
28884	47087	4	applied	\N	\N	\N	\N	214473	214473	381552
28885	47088	0	applied	\N	\N	\N	\N	214474	214474	381553
28885	47089	1	applied	\N	\N	\N	\N	214475	214475	381554
28885	47090	2	applied	\N	\N	\N	\N	214476	214476	381555
28885	47091	3	applied	\N	\N	\N	\N	214477	214477	381556
28885	47092	4	applied	\N	\N	\N	\N	214478	214478	381557
28885	47093	6	applied	\N	\N	\N	\N	214479	214479	381558
28885	47094	7	applied	\N	\N	1000000000	\N	214480	214480	381559
28887	47095	0	applied	\N	\N	\N	\N	214488	214488	381567
28887	47096	1	applied	\N	\N	\N	\N	214489	214489	381568
28888	47097	0	applied	\N	\N	\N	\N	214490	214490	381569
28888	47098	1	applied	\N	\N	\N	\N	214491	214491	381570
28888	47099	2	applied	\N	\N	\N	\N	214492	214492	381571
28888	47100	3	applied	\N	\N	\N	\N	214493	214493	381572
28890	47101	0	applied	\N	\N	\N	\N	214494	214494	381573
28890	47103	2	applied	\N	\N	\N	\N	214496	214496	381575
28890	47104	3	applied	\N	\N	1000000000	\N	214497	214497	381576
28890	47105	4	applied	\N	\N	\N	\N	214498	214498	381577
28890	47106	5	applied	\N	\N	\N	\N	214499	214499	381578
28891	47101	0	applied	\N	\N	\N	\N	214500	214500	381579
28891	47102	1	applied	\N	\N	\N	\N	214501	214501	381580
28891	47103	2	applied	\N	\N	\N	\N	214502	214502	381581
28891	47104	3	applied	\N	\N	1000000000	\N	214503	214503	381582
28891	47105	4	applied	\N	\N	\N	\N	214504	214504	381583
28891	47106	5	applied	\N	\N	\N	\N	214505	214505	381584
28892	47101	0	applied	\N	\N	\N	\N	214506	214506	381585
28892	47102	1	applied	\N	\N	\N	\N	214507	214507	381586
28892	47103	2	applied	\N	\N	\N	\N	214508	214508	381587
28892	47104	3	applied	\N	\N	1000000000	\N	214509	214509	381588
28892	47105	4	applied	\N	\N	\N	\N	214510	214510	381589
28892	47106	5	applied	\N	\N	\N	\N	214511	214511	381590
28896	47108	1	applied	\N	\N	\N	\N	214524	214524	381603
28896	47109	2	applied	\N	\N	\N	\N	214525	214525	381604
28896	47110	3	applied	\N	\N	\N	\N	214526	214526	381605
28898	47111	0	applied	\N	\N	\N	\N	214531	214531	381610
28898	47108	1	applied	\N	\N	\N	\N	214532	214532	381611
28898	47113	2	applied	\N	\N	\N	\N	214533	214533	381612
28899	47114	0	applied	\N	\N	\N	\N	214534	214534	381613
28899	47115	1	applied	\N	\N	\N	\N	214535	214535	381614
28899	47116	2	applied	\N	\N	\N	\N	214536	214536	381615
28900	47114	0	applied	\N	\N	\N	\N	214537	214537	381616
28900	47115	1	applied	\N	\N	\N	\N	214538	214538	381617
28902	47117	0	applied	\N	\N	\N	\N	214590	214590	381669
28902	47118	1	applied	\N	\N	\N	\N	214591	214591	381670
28902	47123	2	applied	\N	\N	\N	\N	214592	214592	381671
28902	47119	3	applied	\N	\N	\N	\N	214593	214593	381672
28902	47124	4	applied	\N	\N	\N	\N	214594	214594	381673
28902	47121	6	applied	\N	\N	\N	\N	214596	214596	381675
28902	47122	7	applied	\N	\N	\N	\N	214597	214597	381676
28902	47125	8	applied	\N	\N	\N	\N	214598	214598	381677
28904	47117	0	applied	\N	\N	\N	\N	214608	214608	381687
28904	47118	1	applied	\N	\N	\N	\N	214609	214609	381688
28904	47123	2	applied	\N	\N	\N	\N	214610	214610	381689
28904	47119	3	applied	\N	\N	\N	\N	214611	214611	381690
28904	47124	4	applied	\N	\N	\N	\N	214612	214612	381691
28904	47120	5	applied	\N	\N	\N	\N	214613	214613	381692
28906	47126	0	applied	\N	\N	\N	\N	214677	214677	381756
28906	47127	1	applied	\N	\N	1000000000	\N	214678	214678	381757
28906	47121	2	applied	\N	\N	\N	\N	214679	214679	381758
28906	47122	3	applied	\N	\N	\N	\N	214680	214680	381759
28906	47125	4	applied	\N	\N	\N	\N	214681	214681	381760
28906	47128	5	applied	\N	\N	\N	\N	214682	214682	381761
28909	47132	0	applied	\N	\N	\N	\N	214689	214689	381768
28909	47134	2	applied	\N	\N	\N	\N	214691	214691	381770
28911	47135	0	applied	\N	\N	\N	\N	214695	214695	381774
28911	47136	1	applied	\N	\N	\N	\N	214696	214696	381775
28913	47141	0	applied	\N	\N	\N	\N	214701	214701	381780
28913	47142	1	applied	\N	\N	\N	\N	214702	214702	381781
28915	47141	0	applied	\N	\N	\N	\N	214704	214704	381783
28915	47142	1	applied	\N	\N	\N	\N	214705	214705	381784
28855	47015	6	applied	\N	\N	\N	\N	214330	214330	381411
28855	47016	7	applied	\N	\N	\N	\N	214331	214331	381412
28856	47022	3	applied	\N	\N	\N	\N	214337	214337	381418
28856	47023	4	applied	\N	\N	\N	\N	214338	214338	381419
28856	47024	5	applied	\N	\N	\N	\N	214339	214339	381420
28856	47026	7	applied	\N	\N	\N	\N	214341	214341	381422
28856	47027	8	applied	\N	\N	\N	\N	214342	214342	381423
28856	47028	9	applied	\N	\N	\N	\N	214343	214343	381424
28856	47029	10	applied	\N	\N	\N	\N	214344	214344	381425
28856	47030	11	applied	\N	\N	\N	\N	214345	214345	381426
28856	47031	12	applied	\N	\N	\N	\N	214346	214346	381427
28856	47032	13	applied	\N	\N	\N	\N	214347	214347	381428
28856	47033	14	applied	\N	\N	\N	\N	214348	214348	381429
28856	47034	15	applied	\N	\N	\N	\N	214349	214349	381430
28856	47035	16	applied	\N	\N	\N	\N	214350	214350	381431
28860	47036	0	applied	\N	\N	\N	\N	214388	214388	381469
28860	47037	1	applied	\N	\N	\N	\N	214389	214389	381470
28860	47038	2	applied	\N	\N	\N	\N	214390	214390	381471
28865	47044	1	applied	\N	\N	\N	\N	214405	214405	381484
28865	47045	2	applied	\N	\N	\N	\N	214406	214406	381485
28867	47049	0	applied	\N	\N	\N	\N	214410	214410	381489
28867	47050	1	applied	\N	\N	1000000000	\N	214411	214411	381490
28867	47051	2	applied	\N	\N	\N	\N	214412	214412	381491
28867	47052	3	applied	\N	\N	\N	\N	214413	214413	381492
28867	47053	4	applied	\N	\N	\N	\N	214414	214414	381493
28873	47063	0	applied	\N	\N	\N	\N	214432	214432	381511
28873	47064	1	applied	\N	\N	\N	\N	214433	214433	381512
28873	47065	2	applied	\N	\N	\N	\N	214434	214434	381513
28873	47066	3	applied	\N	\N	\N	\N	214435	214435	381514
28873	47067	4	applied	\N	\N	\N	\N	214436	214436	381515
28875	47069	0	applied	\N	\N	\N	\N	214438	214438	381517
28875	47070	1	applied	\N	\N	\N	\N	214439	214439	381518
28875	47071	2	applied	\N	\N	\N	\N	214440	214440	381519
28879	47072	0	applied	\N	\N	\N	\N	214452	214452	381531
28879	47073	1	applied	\N	\N	\N	\N	214453	214453	381532
28879	47074	2	applied	\N	\N	\N	\N	214454	214454	381533
28879	47075	3	applied	\N	\N	\N	\N	214455	214455	381534
28879	47076	4	applied	\N	\N	\N	\N	214456	214456	381535
28883	47080	0	applied	\N	\N	\N	\N	214466	214466	381545
28883	47081	1	applied	\N	\N	1000000000	\N	214467	214467	381546
28883	47082	2	applied	\N	\N	\N	\N	214468	214468	381547
28894	47107	0	applied	\N	\N	\N	\N	214516	214516	381595
28894	47108	1	applied	\N	\N	\N	\N	214517	214517	381596
28894	47109	2	applied	\N	\N	\N	\N	214518	214518	381597
28894	47110	3	applied	\N	\N	\N	\N	214519	214519	381598
28918	47141	0	applied	\N	\N	\N	\N	214710	214710	381789
28918	47142	1	applied	\N	\N	\N	\N	214711	214711	381790
28928	47158	0	applied	\N	\N	\N	\N	214755	214755	381834
28928	47159	1	applied	\N	\N	1000000000	\N	214756	214756	381835
28928	47160	2	applied	\N	\N	\N	\N	214757	214757	381836
28928	47161	3	applied	\N	\N	\N	\N	214758	214758	381837
28930	47164	0	applied	\N	\N	\N	\N	214761	214761	381840
28930	47165	1	applied	\N	\N	\N	\N	214762	214762	381841
28930	47166	2	applied	\N	\N	\N	\N	214763	214763	381842
28930	47167	3	applied	\N	\N	\N	\N	214764	214764	381843
28930	47168	4	applied	\N	\N	\N	\N	214765	214765	381844
28930	47169	5	applied	\N	\N	\N	\N	214766	214766	381845
28930	47170	6	applied	\N	\N	\N	\N	214767	214767	381846
28940	47183	0	applied	\N	\N	\N	\N	214799	214799	381878
28940	47184	1	applied	\N	\N	\N	\N	214800	214800	381879
28940	47185	2	applied	\N	\N	\N	\N	214801	214801	381880
28942	47185	1	applied	\N	\N	\N	\N	214805	214805	381884
28944	47186	0	applied	\N	\N	\N	\N	214809	214809	381888
28944	47187	1	applied	\N	\N	\N	\N	214810	214810	381889
28944	47188	2	applied	\N	\N	\N	\N	214811	214811	381890
28954	47211	0	applied	\N	\N	\N	\N	214849	214849	381928
28954	47212	1	applied	\N	\N	\N	\N	214850	214850	381929
28954	47213	2	applied	\N	\N	\N	\N	214851	214851	381930
28956	47214	0	applied	\N	\N	\N	\N	214855	214855	381934
28956	47215	1	applied	\N	\N	\N	\N	214856	214856	381935
28956	47216	2	applied	\N	\N	\N	\N	214857	214857	381936
28960	47224	0	applied	\N	\N	\N	\N	214879	214879	381958
28960	47225	1	applied	\N	\N	\N	\N	214880	214880	381959
28960	47226	2	applied	\N	\N	\N	\N	214881	214881	381960
28965	47232	0	applied	\N	\N	\N	\N	214893	214893	381972
28965	47233	1	applied	\N	\N	\N	\N	214894	214894	381973
28965	47234	2	applied	\N	\N	\N	\N	214895	214895	381974
28965	47235	4	applied	\N	\N	\N	\N	214897	214897	381976
28976	47246	0	applied	\N	\N	\N	\N	214939	214939	382018
28976	47247	1	applied	\N	\N	\N	\N	214940	214940	382019
28976	47248	2	applied	\N	\N	\N	\N	214941	214941	382020
28976	47249	3	applied	\N	\N	\N	\N	214942	214942	382021
28976	47250	4	applied	\N	\N	\N	\N	214943	214943	382022
28976	47251	5	applied	\N	\N	\N	\N	214944	214944	382023
28978	47252	0	applied	\N	\N	\N	\N	214948	214948	382027
28978	47253	1	applied	\N	\N	\N	\N	214949	214949	382028
28978	47254	2	applied	\N	\N	\N	\N	214950	214950	382029
28980	47255	0	applied	\N	\N	\N	\N	214954	214954	382033
28980	47256	1	applied	\N	\N	\N	\N	214955	214955	382034
28980	47257	2	applied	\N	\N	\N	\N	214956	214956	382035
28983	47258	0	applied	\N	\N	\N	\N	214968	214968	214968
28983	47259	1	applied	\N	\N	\N	\N	214969	214969	382046
28983	47260	2	applied	\N	\N	\N	\N	214970	214970	382047
28983	47262	5	applied	\N	\N	\N	\N	214972	214972	382049
28983	47263	6	applied	\N	\N	\N	\N	214973	214973	382050
28983	47264	7	applied	\N	\N	\N	\N	214974	214974	382051
28983	47265	8	applied	\N	\N	\N	\N	214975	214975	382052
28985	47266	0	applied	\N	\N	\N	\N	215036	215036	382112
28985	47267	1	applied	\N	\N	\N	\N	215037	215037	382113
28985	47268	2	applied	\N	\N	\N	\N	215038	215038	382114
28991	47269	0	applied	\N	\N	\N	\N	215051	215051	382124
28991	47270	1	applied	\N	\N	\N	\N	215052	215052	382125
28991	47271	2	applied	\N	\N	\N	\N	215053	215053	382126
28998	47278	0	applied	\N	\N	\N	\N	215072	215072	382145
28998	47279	1	applied	\N	\N	\N	\N	215073	215073	382146
28998	47280	2	applied	\N	\N	\N	\N	215074	215074	382147
29000	47281	0	applied	\N	\N	\N	\N	215078	215078	382151
29000	47282	1	applied	\N	\N	\N	\N	215079	215079	382152
29000	47283	2	applied	\N	\N	\N	\N	215080	215080	382153
29006	47304	1	applied	\N	\N	\N	\N	215108	215108	382181
29006	47305	2	applied	\N	\N	\N	\N	215109	215109	382182
28856	47020	1	applied	\N	\N	\N	\N	214335	214335	381416
28856	47021	2	applied	\N	\N	\N	\N	214336	214336	381417
28901	47080	4	applied	\N	\N	\N	\N	214543	214543	381622
28901	47084	5	applied	\N	\N	\N	\N	214544	214544	381623
28901	47088	6	applied	\N	\N	\N	\N	214545	214545	381624
28901	47089	7	applied	\N	\N	\N	\N	214546	214546	381625
28901	47095	8	applied	\N	\N	\N	\N	214547	214547	381626
28901	47097	9	applied	\N	\N	\N	\N	214548	214548	381627
28901	47101	10	applied	\N	\N	\N	\N	214549	214549	381628
28901	47102	11	applied	\N	\N	\N	\N	214550	214550	381629
28901	47107	12	applied	\N	\N	\N	\N	214551	214551	381630
28901	47114	14	applied	\N	\N	\N	\N	214553	214553	381632
28901	47117	15	applied	\N	\N	\N	\N	214554	214554	381633
28901	47118	16	applied	\N	\N	\N	\N	214555	214555	381634
28901	47081	17	applied	\N	\N	1000000000	\N	214556	214556	381635
28901	47074	18	applied	\N	\N	\N	\N	214557	214557	381636
28901	47078	19	applied	\N	\N	\N	\N	214558	214558	381637
28901	47075	20	applied	\N	\N	\N	\N	214559	214559	381638
28901	47076	21	applied	\N	\N	\N	\N	214560	214560	381639
28901	47104	22	applied	\N	\N	1000000000	\N	214561	214561	381640
28901	47086	23	applied	\N	\N	\N	\N	214562	214562	381641
28901	47091	24	applied	\N	\N	\N	\N	214563	214563	381642
28901	47092	25	applied	\N	\N	\N	\N	214564	214564	381643
28901	47100	26	applied	\N	\N	\N	\N	214565	214565	381644
28901	47103	27	applied	\N	\N	\N	\N	214566	214566	381645
28901	47109	28	applied	\N	\N	\N	\N	214567	214567	381646
28901	47113	30	applied	\N	\N	\N	\N	214568	214568	381647
28901	47119	32	applied	\N	\N	\N	\N	214570	214570	381649
28901	47087	33	applied	\N	\N	\N	\N	214571	214571	381650
28901	47098	34	applied	\N	\N	\N	\N	214572	214572	381651
28901	47110	35	applied	\N	\N	\N	\N	214573	214573	381652
28901	47120	36	applied	\N	\N	\N	\N	214574	214574	381653
28901	47079	37	applied	\N	\N	\N	\N	214575	214575	381654
28901	47094	38	applied	\N	\N	1000000000	\N	214576	214576	381655
28901	47082	39	applied	\N	\N	\N	\N	214577	214577	381656
28901	47085	40	applied	\N	\N	\N	\N	214578	214578	381657
28901	47090	41	applied	\N	\N	\N	\N	214579	214579	381658
28901	47093	42	applied	\N	\N	\N	\N	214580	214580	381659
28901	47096	43	applied	\N	\N	\N	\N	214581	214581	381660
28901	47099	44	applied	\N	\N	\N	\N	214582	214582	381661
28901	47105	45	applied	\N	\N	\N	\N	214583	214583	381662
28901	47106	46	applied	\N	\N	\N	\N	214584	214584	381663
28901	47108	47	applied	\N	\N	\N	\N	214585	214585	381664
28901	47116	49	applied	\N	\N	\N	\N	214587	214587	381666
28901	47121	50	applied	\N	\N	\N	\N	214588	214588	381667
28901	47122	51	applied	\N	\N	\N	\N	214589	214589	381668
28903	47117	0	applied	\N	\N	\N	\N	214599	214599	381678
28903	47118	1	applied	\N	\N	\N	\N	214600	214600	381679
28903	47123	2	applied	\N	\N	\N	\N	214601	214601	381680
28903	47119	3	applied	\N	\N	\N	\N	214602	214602	381681
28903	47124	4	applied	\N	\N	\N	\N	214603	214603	381682
28903	47120	5	applied	\N	\N	\N	\N	214604	214604	381683
28903	47121	6	applied	\N	\N	\N	\N	214605	214605	381684
28903	47122	7	applied	\N	\N	\N	\N	214606	214606	381685
28903	47125	8	applied	\N	\N	\N	\N	214607	214607	381686
28905	47068	28	applied	\N	\N	\N	\N	214642	214642	381721
28905	47071	29	applied	\N	\N	\N	\N	214643	214643	381722
28905	47076	30	applied	\N	\N	\N	\N	214644	214644	381723
28905	47086	31	applied	\N	\N	\N	\N	214645	214645	381724
28905	47092	33	applied	\N	\N	\N	\N	214647	214647	381726
28905	47100	34	applied	\N	\N	\N	\N	214648	214648	381727
28905	47103	35	applied	\N	\N	\N	\N	214649	214649	381728
28905	47109	36	applied	\N	\N	\N	\N	214650	214650	381729
28905	47113	37	applied	\N	\N	\N	\N	214651	214651	381730
28905	47115	38	applied	\N	\N	\N	\N	214652	214652	381731
28905	47119	39	applied	\N	\N	\N	\N	214653	214653	381732
28905	47124	40	applied	\N	\N	\N	\N	214654	214654	381733
28905	47079	41	applied	\N	\N	\N	\N	214655	214655	381734
28905	47067	42	applied	\N	\N	\N	\N	214656	214656	381735
28905	47075	43	applied	\N	\N	\N	\N	214657	214657	381736
28905	47087	45	applied	\N	\N	\N	\N	214658	214658	381737
28905	47098	46	applied	\N	\N	\N	\N	214659	214659	381738
28905	47110	47	applied	\N	\N	\N	\N	214660	214660	381739
28905	47120	48	applied	\N	\N	\N	\N	214661	214661	381740
28905	47082	50	applied	\N	\N	\N	\N	214663	214663	381742
28905	47085	51	applied	\N	\N	\N	\N	214664	214664	381743
28905	47090	52	applied	\N	\N	\N	\N	214665	214665	381744
28905	47093	53	applied	\N	\N	\N	\N	214666	214666	381745
28905	47096	54	applied	\N	\N	\N	\N	214667	214667	381746
28905	47099	55	applied	\N	\N	\N	\N	214668	214668	381747
28905	47105	56	applied	\N	\N	\N	\N	214669	214669	381748
28905	47106	57	applied	\N	\N	\N	\N	214670	214670	381749
28905	47108	58	applied	\N	\N	\N	\N	214671	214671	381750
28905	47112	59	applied	\N	\N	\N	\N	214672	214672	381751
28905	47116	60	applied	\N	\N	\N	\N	214673	214673	381752
28905	47121	61	applied	\N	\N	\N	\N	214674	214674	381753
28905	47122	62	applied	\N	\N	\N	\N	214675	214675	381754
28905	47125	63	applied	\N	\N	\N	\N	214676	214676	381755
28907	47129	0	applied	\N	\N	\N	\N	214683	214683	381762
28907	47130	1	applied	\N	\N	\N	\N	214684	214684	381763
28907	47131	2	applied	\N	\N	\N	\N	214685	214685	381764
28908	47132	0	applied	\N	\N	\N	\N	214686	214686	381765
28908	47133	1	applied	\N	\N	\N	\N	214687	214687	381766
28910	47132	0	applied	\N	\N	\N	\N	214692	214692	381771
28910	47133	1	applied	\N	\N	\N	\N	214693	214693	381772
28910	47134	2	applied	\N	\N	\N	\N	214694	214694	381773
28912	47140	0	applied	\N	\N	\N	\N	214700	214700	381779
28914	47142	0	applied	\N	\N	\N	\N	214703	214703	381782
28917	47141	0	applied	\N	\N	\N	\N	214708	214708	381787
28917	47142	1	applied	\N	\N	\N	\N	214709	214709	381788
28921	47146	0	applied	\N	\N	\N	\N	214715	214715	381794
28921	47147	1	applied	\N	\N	\N	\N	214716	214716	381795
28921	47148	2	applied	\N	\N	\N	\N	214717	214717	381796
28921	47149	3	applied	\N	\N	\N	\N	214718	214718	381797
28922	47146	0	applied	\N	\N	\N	\N	214720	214720	381799
28922	47147	1	applied	\N	\N	\N	\N	214721	214721	381800
28922	47148	2	applied	\N	\N	\N	\N	214722	214722	381801
28922	47149	3	applied	\N	\N	\N	\N	214723	214723	381802
28922	47150	4	applied	\N	\N	\N	\N	214724	214724	381803
28924	47152	1	applied	\N	\N	\N	\N	214731	214731	381810
28924	47153	2	applied	\N	\N	\N	\N	214732	214732	381811
28901	47073	2	applied	\N	\N	\N	\N	214541	214541	381620
28901	47077	3	applied	\N	\N	\N	\N	214542	214542	381621
28916	47141	0	applied	\N	\N	\N	\N	214706	214706	381785
28916	47142	1	applied	\N	\N	\N	\N	214707	214707	381786
28920	47143	0	applied	\N	\N	\N	\N	214712	214712	381791
28920	47144	1	applied	\N	\N	\N	\N	214713	214713	381792
28920	47145	2	applied	\N	\N	\N	\N	214714	214714	381793
28924	47154	3	applied	\N	\N	\N	\N	214733	214733	381812
28924	47155	4	applied	\N	\N	\N	\N	214734	214734	381813
28924	47156	5	applied	\N	\N	\N	\N	214735	214735	381814
28924	47157	6	applied	\N	\N	\N	\N	214736	214736	381815
28925	47151	0	applied	\N	\N	\N	\N	214737	214737	381816
28925	47152	1	applied	\N	\N	\N	\N	214738	214738	381817
28925	47153	2	applied	\N	\N	\N	\N	214739	214739	381818
28925	47154	3	applied	\N	\N	\N	\N	214740	214740	381819
28925	47156	5	applied	\N	\N	\N	\N	214742	214742	381821
28925	47157	6	applied	\N	\N	\N	\N	214743	214743	381822
28926	47151	0	applied	\N	\N	\N	\N	214744	214744	381823
28926	47152	1	applied	\N	\N	\N	\N	214745	214745	381824
28926	47153	2	applied	\N	\N	\N	\N	214746	214746	381825
28926	47154	3	applied	\N	\N	\N	\N	214747	214747	381826
28926	47155	4	applied	\N	\N	\N	\N	214748	214748	381827
28926	47156	5	applied	\N	\N	\N	\N	214749	214749	381828
28926	47157	6	applied	\N	\N	\N	\N	214750	214750	381829
28927	47158	0	applied	\N	\N	\N	\N	214751	214751	381830
28927	47159	1	applied	\N	\N	1000000000	\N	214752	214752	381831
28927	47160	2	applied	\N	\N	\N	\N	214753	214753	381832
28927	47161	3	applied	\N	\N	\N	\N	214754	214754	381833
28929	47162	0	applied	\N	\N	\N	\N	214759	214759	381838
28929	47163	1	applied	\N	\N	\N	\N	214760	214760	381839
28931	47164	0	applied	\N	\N	\N	\N	214768	214768	381847
28931	47166	2	applied	\N	\N	\N	\N	214770	214770	381849
28931	47167	3	applied	\N	\N	\N	\N	214771	214771	381850
28931	47168	4	applied	\N	\N	\N	\N	214772	214772	381851
28931	47169	5	applied	\N	\N	\N	\N	214773	214773	381852
28931	47170	6	applied	\N	\N	\N	\N	214774	214774	381853
28933	47171	0	applied	\N	\N	\N	\N	214778	214778	381857
28933	47172	1	applied	\N	\N	\N	\N	214779	214779	381858
28933	47173	2	applied	\N	\N	\N	\N	214780	214780	381859
28935	47174	0	applied	\N	\N	\N	\N	214783	214783	381862
28935	47172	1	applied	\N	\N	\N	\N	214784	214784	381863
28935	47175	2	applied	\N	\N	\N	\N	214785	214785	381864
28935	47176	3	applied	\N	\N	\N	\N	214786	214786	381865
28936	47177	0	applied	\N	\N	\N	\N	214787	214787	381866
28936	47178	1	applied	\N	\N	\N	\N	214788	214788	381867
28936	47179	2	applied	\N	\N	\N	\N	214789	214789	381868
28937	47180	0	applied	\N	\N	\N	\N	214790	214790	381869
28937	47182	2	applied	\N	\N	\N	\N	214792	214792	381871
28938	47180	0	applied	\N	\N	\N	\N	214793	214793	381872
28938	47181	1	applied	\N	\N	\N	\N	214794	214794	381873
28938	47182	2	applied	\N	\N	\N	\N	214795	214795	381874
28945	47186	0	applied	\N	\N	\N	\N	214812	214812	381891
28945	47187	1	applied	\N	\N	\N	\N	214813	214813	381892
28945	47188	2	applied	\N	\N	\N	\N	214814	214814	381893
28946	47189	0	applied	\N	\N	\N	\N	214815	214815	381894
28946	47190	1	applied	\N	\N	\N	\N	214816	214816	381895
28946	47191	2	applied	\N	\N	\N	\N	214817	214817	381896
28946	47192	3	applied	\N	\N	\N	\N	214818	214818	381897
28946	47193	4	applied	\N	\N	\N	\N	214819	214819	381898
28946	47194	5	applied	\N	\N	\N	\N	214820	214820	381899
28946	47195	6	applied	\N	\N	\N	\N	214821	214821	381900
28946	47196	7	applied	\N	\N	\N	\N	214822	214822	381901
28946	47197	8	applied	\N	\N	\N	\N	214823	214823	381902
28947	47189	0	applied	\N	\N	\N	\N	214825	214825	381904
28947	47190	1	applied	\N	\N	\N	\N	214826	214826	381905
28947	47191	2	applied	\N	\N	\N	\N	214827	214827	381906
28947	47192	3	applied	\N	\N	\N	\N	214828	214828	381907
28947	47193	4	applied	\N	\N	\N	\N	214829	214829	381908
28947	47194	5	applied	\N	\N	\N	\N	214830	214830	381909
28947	47195	6	applied	\N	\N	\N	\N	214831	214831	381910
28947	47196	7	applied	\N	\N	\N	\N	214832	214832	381911
28947	47197	8	applied	\N	\N	\N	\N	214833	214833	381912
28947	47198	9	applied	\N	\N	\N	\N	214834	214834	381913
28949	47199	0	applied	\N	\N	\N	\N	214835	214835	381914
28949	47200	1	applied	\N	\N	\N	\N	214836	214836	381915
28950	47199	0	applied	\N	\N	\N	\N	214837	214837	381916
28951	47201	0	applied	\N	\N	\N	\N	214838	214838	381917
28951	47202	1	applied	\N	\N	\N	\N	214839	214839	381918
28951	47203	2	applied	\N	\N	\N	\N	214840	214840	381919
28951	47204	4	applied	\N	\N	\N	\N	214842	214842	381921
28953	47209	0	applied	\N	\N	\N	\N	214847	214847	381926
28955	47214	0	applied	\N	\N	\N	\N	214852	214852	381931
28955	47215	1	applied	\N	\N	\N	\N	214853	214853	381932
28955	47216	2	applied	\N	\N	\N	\N	214854	214854	381933
28958	47217	0	applied	\N	\N	\N	\N	214865	214865	381944
28958	47218	1	applied	\N	\N	\N	\N	214866	214866	381945
28958	47219	2	applied	\N	\N	\N	\N	214867	214867	381946
28958	47220	3	applied	\N	\N	\N	\N	214868	214868	381947
28958	47221	4	applied	\N	\N	\N	\N	214869	214869	381948
28958	47222	5	applied	\N	\N	\N	\N	214870	214870	381949
28958	47223	6	applied	\N	\N	1000000000	\N	214871	214871	381950
28962	47224	0	applied	\N	\N	\N	\N	214885	214885	381964
28962	47225	1	applied	\N	\N	\N	\N	214886	214886	381965
28962	47226	2	applied	\N	\N	\N	\N	214887	214887	381966
28966	47232	0	applied	\N	\N	\N	\N	214898	214898	381977
28966	47234	2	applied	\N	\N	\N	\N	214900	214900	381979
28966	47231	3	applied	\N	\N	\N	\N	214901	214901	381980
28966	47235	4	applied	\N	\N	\N	\N	214902	214902	381981
28968	47236	0	applied	\N	\N	\N	\N	214908	214908	381987
28968	47237	1	applied	\N	\N	\N	\N	214909	214909	381988
28968	47238	2	applied	\N	\N	\N	\N	214910	214910	381989
28970	47240	0	applied	\N	\N	\N	\N	214915	214915	381994
28970	47241	1	applied	\N	\N	\N	\N	214916	214916	381995
28970	47242	2	applied	\N	\N	\N	\N	214917	214917	381996
28970	47239	3	applied	\N	\N	\N	\N	214918	214918	381997
28972	47240	0	applied	\N	\N	\N	\N	214922	214922	382001
28972	47241	1	applied	\N	\N	\N	\N	214923	214923	382002
28972	47242	2	applied	\N	\N	\N	\N	214924	214924	382003
28972	47239	3	applied	\N	\N	\N	\N	214925	214925	382004
28974	47243	0	applied	\N	\N	\N	\N	214930	214930	382009
28974	47244	1	applied	\N	\N	\N	\N	214931	214931	382010
28911	47138	3	applied	\N	\N	\N	\N	214698	214698	381777
28911	47139	4	applied	\N	\N	\N	\N	214699	214699	381778
28923	47148	2	applied	\N	\N	\N	\N	214727	214727	381806
28923	47149	3	applied	\N	\N	\N	\N	214728	214728	381807
28923	47150	4	applied	\N	\N	\N	\N	214729	214729	381808
28932	47171	0	applied	\N	\N	\N	\N	214775	214775	381854
28932	47172	1	applied	\N	\N	\N	\N	214776	214776	381855
28932	47173	2	applied	\N	\N	\N	\N	214777	214777	381856
28934	47171	0	applied	\N	\N	\N	\N	214781	214781	381860
28934	47173	1	applied	\N	\N	\N	\N	214782	214782	381861
28939	47180	0	applied	\N	\N	\N	\N	214796	214796	381875
28939	47181	1	applied	\N	\N	\N	\N	214797	214797	381876
28939	47182	2	applied	\N	\N	\N	\N	214798	214798	381877
28941	47183	0	applied	\N	\N	\N	\N	214802	214802	381881
28941	47185	1	applied	\N	\N	\N	\N	214803	214803	381882
28943	47184	1	applied	\N	\N	\N	\N	214807	214807	381886
28943	47185	2	applied	\N	\N	\N	\N	214808	214808	381887
28952	47205	0	applied	\N	\N	\N	\N	214843	214843	381922
28952	47206	1	applied	\N	\N	\N	\N	214844	214844	381923
28952	47207	2	applied	\N	\N	\N	\N	214845	214845	381924
28952	47208	3	applied	\N	\N	\N	\N	214846	214846	381925
28953	47210	1	applied	\N	\N	\N	\N	214848	214848	381927
28957	47217	0	applied	\N	\N	\N	\N	214858	214858	381937
28957	47218	1	applied	\N	\N	\N	\N	214859	214859	381938
28957	47219	2	applied	\N	\N	\N	\N	214860	214860	381939
28957	47220	3	applied	\N	\N	\N	\N	214861	214861	381940
28957	47221	4	applied	\N	\N	\N	\N	214862	214862	381941
28957	47222	5	applied	\N	\N	\N	\N	214863	214863	381942
28957	47223	6	applied	\N	\N	1000000000	\N	214864	214864	381943
28959	47217	0	applied	\N	\N	\N	\N	214872	214872	381951
28959	47218	1	applied	\N	\N	\N	\N	214873	214873	381952
28959	47220	3	applied	\N	\N	\N	\N	214875	214875	381954
28959	47221	4	applied	\N	\N	\N	\N	214876	214876	381955
28959	47222	5	applied	\N	\N	\N	\N	214877	214877	381956
28959	47223	6	applied	\N	\N	1000000000	\N	214878	214878	381957
28961	47224	0	applied	\N	\N	\N	\N	214882	214882	381961
28961	47225	1	applied	\N	\N	\N	\N	214883	214883	381962
28961	47226	2	applied	\N	\N	\N	\N	214884	214884	381963
28963	47227	0	applied	\N	\N	\N	\N	214888	214888	381967
28963	47228	1	applied	\N	\N	\N	\N	214889	214889	381968
28963	47229	2	applied	\N	\N	\N	\N	214890	214890	381969
28963	47230	3	applied	\N	\N	\N	\N	214891	214891	381970
28964	47231	0	applied	\N	\N	\N	\N	214892	214892	381971
28967	47232	0	applied	\N	\N	\N	\N	214903	214903	381982
28967	47233	1	applied	\N	\N	\N	\N	214904	214904	381983
28967	47234	2	applied	\N	\N	\N	\N	214905	214905	381984
28967	47231	3	applied	\N	\N	\N	\N	214906	214906	381985
28969	47236	0	applied	\N	\N	\N	\N	214911	214911	381990
28969	47237	1	applied	\N	\N	\N	\N	214912	214912	381991
28969	47239	2	applied	\N	\N	\N	\N	214913	214913	381992
28969	47238	3	applied	\N	\N	\N	\N	214914	214914	381993
28971	47240	0	applied	\N	\N	\N	\N	214919	214919	381998
28971	47241	1	applied	\N	\N	\N	\N	214920	214920	381999
28971	47242	2	applied	\N	\N	\N	\N	214921	214921	382000
28973	47240	0	applied	\N	\N	\N	\N	214926	214926	382005
28973	47241	1	applied	\N	\N	\N	\N	214927	214927	382006
28973	47242	2	applied	\N	\N	\N	\N	214928	214928	382007
28973	47239	3	applied	\N	\N	\N	\N	214929	214929	382008
28975	47246	0	applied	\N	\N	\N	\N	214933	214933	382012
28975	47247	1	applied	\N	\N	\N	\N	214934	214934	382013
28975	47248	2	applied	\N	\N	\N	\N	214935	214935	382014
28975	47249	3	applied	\N	\N	\N	\N	214936	214936	382015
28975	47250	4	applied	\N	\N	\N	\N	214937	214937	382016
28979	47252	0	applied	\N	\N	\N	\N	214951	214951	382030
28979	47253	1	applied	\N	\N	\N	\N	214952	214952	382031
28979	47254	2	applied	\N	\N	\N	\N	214953	214953	382032
28981	47255	0	applied	\N	\N	\N	\N	214957	214957	382036
28981	47256	1	applied	\N	\N	\N	\N	214958	214958	382037
28981	47257	2	applied	\N	\N	\N	\N	214959	214959	382038
28982	47258	0	applied	\N	\N	\N	\N	214960	214960	214960
28986	47266	0	applied	\N	\N	\N	\N	215039	215039	382115
28986	47267	1	applied	\N	\N	\N	\N	215040	215040	382116
28986	47268	2	applied	\N	\N	\N	\N	215041	215041	382117
28994	47272	0	applied	\N	\N	\N	\N	215060	215060	382133
28994	47273	1	applied	\N	\N	\N	\N	215061	215061	382134
28994	47274	2	applied	\N	\N	\N	\N	215062	215062	382135
28996	47275	0	applied	\N	\N	\N	\N	215066	215066	382139
28996	47276	1	applied	\N	\N	\N	\N	215067	215067	382140
28996	47277	2	applied	\N	\N	\N	\N	215068	215068	382141
28999	47282	1	applied	\N	\N	\N	\N	215076	215076	382149
28999	47283	2	applied	\N	\N	\N	\N	215077	215077	382150
29001	47284	0	applied	\N	\N	\N	\N	215081	215081	382154
29001	47285	1	applied	\N	\N	\N	\N	215082	215082	382155
29001	47286	2	applied	\N	\N	\N	\N	215083	215083	382156
29001	47287	3	applied	\N	\N	\N	\N	215084	215084	382157
29001	47288	4	applied	\N	\N	\N	\N	215085	215085	382158
29001	47289	5	applied	\N	\N	\N	\N	215086	215086	382159
29003	47294	0	applied	\N	\N	\N	\N	215091	215091	382164
29003	47295	1	applied	\N	\N	\N	\N	215092	215092	382165
29010	47311	0	applied	\N	\N	\N	\N	215124	215124	382197
29010	47312	1	applied	\N	\N	\N	\N	215125	215125	382198
29010	47313	2	applied	\N	\N	\N	\N	215126	215126	382199
29010	47314	3	applied	\N	\N	\N	\N	215127	215127	382200
29012	47315	0	applied	\N	\N	\N	\N	215132	215132	382205
29012	47316	1	applied	\N	\N	\N	\N	215133	215133	382206
29017	47327	0	applied	\N	\N	\N	\N	215153	215153	382226
29017	47328	1	applied	\N	\N	\N	\N	215154	215154	382227
29017	47329	2	applied	\N	\N	\N	\N	215155	215155	382228
29017	47330	3	applied	\N	\N	\N	\N	215156	215156	382229
29017	47331	4	applied	\N	\N	\N	\N	215157	215157	382230
29017	47332	5	applied	\N	\N	\N	\N	215158	215158	382231
29017	47333	6	applied	\N	\N	\N	\N	215159	215159	382232
29019	47337	0	applied	\N	\N	\N	\N	215163	215163	382236
29019	47338	1	applied	\N	\N	\N	\N	215164	215164	382237
29019	47339	2	applied	\N	\N	\N	\N	215165	215165	382238
29026	47346	0	applied	\N	\N	\N	\N	215188	215188	382261
29026	47347	1	applied	\N	\N	\N	\N	215189	215189	382262
29026	47348	2	applied	\N	\N	\N	\N	215190	215190	382263
29026	47349	3	applied	\N	\N	\N	\N	215191	215191	382264
29026	47350	4	applied	\N	\N	\N	\N	215192	215192	382265
29030	47358	0	applied	\N	\N	\N	\N	215211	215211	382284
28923	47146	0	applied	\N	\N	\N	\N	214725	214725	381804
28923	47147	1	applied	\N	\N	\N	\N	214726	214726	381805
28982	47259	1	applied	\N	\N	\N	\N	214961	214961	382039
28982	47260	2	applied	\N	\N	\N	\N	214962	214962	382040
28982	47261	3	applied	\N	\N	\N	\N	214963	214963	382041
28982	47262	5	applied	\N	\N	\N	\N	214964	214964	382042
28982	47263	6	applied	\N	\N	\N	\N	214965	214965	382043
28982	47264	7	applied	\N	\N	\N	\N	214966	214966	382044
28982	47265	8	applied	\N	\N	\N	\N	214967	214967	382045
28984	47258	0	applied	\N	\N	\N	\N	214976	214976	214976
28984	47129	1	applied	\N	\N	\N	\N	214977	214977	382053
28984	47132	2	applied	\N	\N	\N	\N	214978	214978	382054
28984	47146	3	applied	\N	\N	\N	\N	214979	214979	382055
28984	47147	4	applied	\N	\N	\N	\N	214980	214980	382056
28984	47151	5	applied	\N	\N	\N	\N	214981	214981	382057
28984	47158	7	applied	\N	\N	\N	\N	214983	214983	382059
28984	47162	8	applied	\N	\N	\N	\N	214984	214984	382060
28984	47164	9	applied	\N	\N	\N	\N	214985	214985	382061
28984	47165	10	applied	\N	\N	\N	\N	214986	214986	382062
28984	47171	11	applied	\N	\N	\N	\N	214987	214987	382063
28984	47174	12	applied	\N	\N	\N	\N	214988	214988	382064
28984	47177	13	applied	\N	\N	\N	\N	214989	214989	382065
28984	47180	14	applied	\N	\N	\N	\N	214990	214990	382066
28984	47183	15	applied	\N	\N	\N	\N	214991	214991	382067
28984	47186	16	applied	\N	\N	\N	\N	214992	214992	382068
28984	47189	17	applied	\N	\N	\N	\N	214993	214993	382069
28984	47190	18	applied	\N	\N	\N	\N	214994	214994	382070
28984	47191	19	applied	\N	\N	\N	\N	214995	214995	382071
28984	47199	20	applied	\N	\N	\N	\N	214996	214996	382072
28984	47201	21	applied	\N	\N	\N	\N	214997	214997	382073
28984	47205	22	applied	\N	\N	\N	\N	214998	214998	382074
28984	47211	24	applied	\N	\N	\N	\N	215000	215000	382076
28984	47214	25	applied	\N	\N	\N	\N	215001	215001	382077
28984	47217	26	applied	\N	\N	\N	\N	215002	215002	382078
28984	47218	27	applied	\N	\N	\N	\N	215003	215003	382079
28984	47224	28	applied	\N	\N	\N	\N	215004	215004	382080
28984	47227	29	applied	\N	\N	\N	\N	215005	215005	382081
28984	47232	30	applied	\N	\N	\N	\N	215006	215006	382082
28984	47233	31	applied	\N	\N	\N	\N	215007	215007	382083
28984	47236	32	applied	\N	\N	\N	\N	215008	215008	382084
28984	47240	33	applied	\N	\N	\N	\N	215009	215009	382085
28984	47243	34	applied	\N	\N	\N	\N	215010	215010	382086
28984	47246	35	applied	\N	\N	\N	\N	215011	215011	382087
28984	47247	36	applied	\N	\N	\N	\N	215012	215012	382088
28984	47252	37	applied	\N	\N	\N	\N	215013	215013	382089
28984	47255	38	applied	\N	\N	\N	\N	215014	215014	382090
28984	47259	39	applied	\N	\N	\N	\N	215015	215015	382091
28984	47266	41	applied	\N	\N	\N	\N	215017	215017	382093
28984	47261	42	applied	\N	\N	\N	\N	215018	215018	382094
28984	47128	43	applied	\N	\N	\N	\N	215019	215019	382095
28984	47130	44	applied	\N	\N	\N	\N	215020	215020	382096
28984	47133	45	applied	\N	\N	\N	\N	215021	215021	382097
28984	47135	46	applied	\N	\N	\N	\N	215022	215022	382098
28984	47136	47	applied	\N	\N	\N	\N	215023	215023	382099
28984	47131	48	applied	\N	\N	\N	\N	215024	215024	382100
28984	47137	49	applied	\N	\N	\N	\N	215025	215025	382101
28984	47144	50	applied	\N	\N	\N	\N	215026	215026	382102
28984	47127	51	applied	\N	\N	1000000000	\N	215027	215027	382103
28984	47159	52	applied	\N	\N	1000000000	\N	215028	215028	382104
28984	47140	53	applied	\N	\N	\N	\N	215029	215029	382105
28984	47141	54	applied	\N	\N	\N	\N	215030	215030	382106
28984	47143	55	applied	\N	\N	\N	\N	215031	215031	382107
28984	47149	56	applied	\N	\N	\N	\N	215032	215032	382108
28984	47153	58	applied	\N	\N	\N	\N	215034	215034	382110
28984	47154	59	applied	\N	\N	\N	\N	215035	215035	382111
28987	47266	0	applied	\N	\N	\N	\N	215042	215042	382118
28987	47267	1	applied	\N	\N	\N	\N	215043	215043	382119
28987	47268	2	applied	\N	\N	\N	\N	215044	215044	382120
28988	47258	0	applied	\N	\N	\N	\N	215045	215045	215045
28988	47261	1	applied	\N	\N	\N	\N	215046	215046	382121
28989	47258	0	applied	\N	\N	\N	\N	215047	215047	215047
28989	47261	1	applied	\N	\N	\N	\N	215048	215048	382122
28990	47258	0	applied	\N	\N	\N	\N	215049	215049	215049
28993	47269	0	applied	\N	\N	\N	\N	215057	215057	382130
28993	47270	1	applied	\N	\N	\N	\N	215058	215058	382131
28993	47271	2	applied	\N	\N	\N	\N	215059	215059	382132
28997	47275	0	applied	\N	\N	\N	\N	215069	215069	382142
28997	47276	1	applied	\N	\N	\N	\N	215070	215070	382143
28997	47277	2	applied	\N	\N	\N	\N	215071	215071	382144
29002	47291	1	applied	\N	\N	\N	\N	215088	215088	382161
29002	47292	2	applied	\N	\N	\N	\N	215089	215089	382162
29002	47293	3	applied	\N	\N	\N	\N	215090	215090	382163
29005	47296	0	applied	\N	\N	\N	\N	215100	215100	382173
29005	47297	1	applied	\N	\N	\N	\N	215101	215101	382174
29005	47298	2	applied	\N	\N	\N	\N	215102	215102	382175
29005	47299	3	applied	\N	\N	\N	\N	215103	215103	382176
29005	47300	4	applied	\N	\N	\N	\N	215104	215104	382177
29005	47301	5	applied	\N	\N	\N	\N	215105	215105	382178
29005	47302	6	applied	\N	\N	\N	\N	215106	215106	382179
29011	47311	0	applied	\N	\N	\N	\N	215128	215128	382201
29011	47312	1	applied	\N	\N	\N	\N	215129	215129	382202
29011	47313	2	applied	\N	\N	\N	\N	215130	215130	382203
29011	47314	3	applied	\N	\N	\N	\N	215131	215131	382204
29014	47318	0	applied	\N	\N	\N	\N	215138	215138	382211
29014	47319	1	applied	\N	\N	\N	\N	215139	215139	382212
29014	47321	3	applied	\N	\N	\N	\N	215141	215141	382214
29014	47322	4	applied	\N	\N	\N	\N	215142	215142	382215
29014	47323	5	applied	\N	\N	\N	\N	215143	215143	382216
29016	47324	0	applied	\N	\N	\N	\N	215150	215150	382223
29016	47325	1	applied	\N	\N	\N	\N	215151	215151	382224
29016	47326	2	applied	\N	\N	\N	\N	215152	215152	382225
29020	47340	0	applied	\N	\N	\N	\N	215166	215166	382239
29020	47341	1	applied	\N	\N	\N	\N	215167	215167	382240
29022	47342	0	applied	\N	\N	\N	\N	215170	215170	382243
29022	47343	1	applied	\N	\N	\N	\N	215171	215171	382244
29022	47344	2	applied	\N	\N	\N	\N	215172	215172	382245
29022	47345	3	applied	\N	\N	\N	\N	215173	215173	382246
29025	47346	0	applied	\N	\N	\N	\N	215183	215183	382256
29025	47347	1	applied	\N	\N	\N	\N	215184	215184	382257
29025	47348	2	applied	\N	\N	\N	\N	215185	215185	382258
29025	47349	3	applied	\N	\N	\N	\N	215186	215186	382259
28977	47253	1	applied	\N	\N	\N	\N	214946	214946	382025
28977	47254	2	applied	\N	\N	\N	\N	214947	214947	382026
28995	47272	0	applied	\N	\N	\N	\N	215063	215063	382136
28995	47273	1	applied	\N	\N	\N	\N	215064	215064	382137
28995	47274	2	applied	\N	\N	\N	\N	215065	215065	382138
29004	47296	0	applied	\N	\N	\N	\N	215093	215093	382166
29004	47297	1	applied	\N	\N	\N	\N	215094	215094	382167
29004	47298	2	applied	\N	\N	\N	\N	215095	215095	382168
29004	47299	3	applied	\N	\N	\N	\N	215096	215096	382169
29004	47300	4	applied	\N	\N	\N	\N	215097	215097	382170
29004	47301	5	applied	\N	\N	\N	\N	215098	215098	382171
29004	47302	6	applied	\N	\N	\N	\N	215099	215099	382172
29007	47306	0	applied	\N	\N	\N	\N	215110	215110	382183
29007	47307	1	applied	\N	\N	\N	\N	215111	215111	382184
29007	47308	2	applied	\N	\N	\N	\N	215112	215112	382185
29007	47309	3	applied	\N	\N	\N	\N	215113	215113	382186
29007	47310	4	applied	\N	\N	\N	\N	215114	215114	382187
29009	47311	0	applied	\N	\N	\N	\N	215120	215120	382193
29009	47313	2	applied	\N	\N	\N	\N	215122	215122	382195
29009	47314	3	applied	\N	\N	\N	\N	215123	215123	382196
29015	47318	0	applied	\N	\N	\N	\N	215144	215144	382217
29015	47319	1	applied	\N	\N	\N	\N	215145	215145	382218
29015	47320	2	applied	\N	\N	\N	\N	215146	215146	382219
29015	47321	3	applied	\N	\N	\N	\N	215147	215147	382220
29015	47322	4	applied	\N	\N	\N	\N	215148	215148	382221
29015	47323	5	applied	\N	\N	\N	\N	215149	215149	382222
29018	47334	0	applied	\N	\N	\N	\N	215160	215160	382233
29018	47335	1	applied	\N	\N	\N	\N	215161	215161	382234
29018	47336	2	applied	\N	\N	\N	\N	215162	215162	382235
29021	47340	0	applied	\N	\N	\N	\N	215168	215168	382241
29021	47341	1	applied	\N	\N	\N	\N	215169	215169	382242
29023	47342	0	applied	\N	\N	\N	\N	215174	215174	382247
29023	47343	1	applied	\N	\N	\N	\N	215175	215175	382248
29023	47344	2	applied	\N	\N	\N	\N	215176	215176	382249
29027	47346	0	applied	\N	\N	\N	\N	215193	215193	382266
29027	47347	1	applied	\N	\N	\N	\N	215194	215194	382267
29027	47348	2	applied	\N	\N	\N	\N	215195	215195	382268
29027	47349	3	applied	\N	\N	\N	\N	215196	215196	382269
29027	47350	4	applied	\N	\N	\N	\N	215197	215197	382270
29028	47351	0	applied	\N	\N	\N	\N	215198	215198	382271
29028	47352	1	applied	\N	\N	\N	\N	215199	215199	382272
29028	47353	2	applied	\N	\N	\N	\N	215200	215200	382273
29028	47354	3	applied	\N	\N	\N	\N	215201	215201	382274
29028	47355	4	applied	\N	\N	\N	\N	215202	215202	382275
29028	47356	5	applied	\N	\N	\N	\N	215203	215203	382276
29028	47357	6	applied	\N	\N	\N	\N	215204	215204	382277
29029	47358	0	applied	\N	\N	\N	\N	215205	215205	382278
29029	47359	1	applied	\N	\N	\N	\N	215206	215206	382279
29029	47360	2	applied	\N	\N	\N	\N	215207	215207	382280
29029	47361	3	applied	\N	\N	\N	\N	215208	215208	382281
29029	47363	5	applied	\N	\N	\N	\N	215210	215210	382283
29031	47364	0	applied	\N	\N	\N	\N	215217	215217	382290
29031	47365	1	applied	\N	\N	\N	\N	215218	215218	382291
29031	47366	2	applied	\N	\N	\N	\N	215219	215219	382292
29032	47364	0	applied	\N	\N	\N	\N	215220	215220	382293
29032	47365	1	applied	\N	\N	\N	\N	215221	215221	382294
29032	47366	2	applied	\N	\N	\N	\N	215222	215222	382295
29033	47364	0	applied	\N	\N	\N	\N	215223	215223	382296
29034	47367	0	applied	\N	\N	\N	\N	215226	215226	215226
29034	47368	1	applied	\N	\N	\N	\N	215227	215227	382299
29034	47369	2	applied	\N	\N	\N	\N	215228	215228	382300
29034	47370	3	applied	\N	\N	\N	\N	215229	215229	382301
29037	47371	0	applied	\N	\N	\N	\N	215235	215235	382306
29037	47372	1	applied	\N	\N	\N	\N	215236	215236	382307
29041	47380	0	applied	\N	\N	\N	\N	215248	215248	382319
29041	47381	1	applied	\N	\N	\N	\N	215249	215249	382320
29043	47383	0	applied	\N	\N	\N	\N	215257	215257	382328
29043	47384	1	applied	\N	\N	\N	\N	215258	215258	382329
29043	47385	2	applied	\N	\N	\N	\N	215259	215259	382330
29043	47386	3	applied	\N	\N	\N	\N	215260	215260	382331
29043	47387	4	applied	\N	\N	\N	\N	215261	215261	382332
29043	47388	5	applied	\N	\N	\N	\N	215262	215262	382333
29045	47389	0	applied	\N	\N	\N	\N	215266	215266	382337
29045	47390	1	applied	\N	\N	\N	\N	215267	215267	382338
29045	47391	2	applied	\N	\N	\N	\N	215268	215268	382339
29048	47392	0	applied	\N	\N	\N	\N	215281	215281	382352
29048	47393	1	applied	\N	\N	\N	\N	215282	215282	382353
29048	47394	2	applied	\N	\N	\N	\N	215283	215283	382354
29048	47395	3	applied	\N	\N	\N	\N	215284	215284	382355
29048	47396	4	applied	\N	\N	\N	\N	215285	215285	382356
29048	47397	5	applied	\N	\N	\N	\N	215286	215286	382357
29049	47398	0	applied	\N	\N	\N	\N	215287	215287	382358
29049	47400	2	applied	\N	\N	\N	\N	215289	215289	382360
29068	47422	0	applied	\N	\N	\N	\N	215389	215389	382460
29068	47423	1	applied	\N	\N	\N	\N	215390	215390	382461
29068	47424	2	applied	\N	\N	\N	\N	215391	215391	382462
29068	47425	3	applied	\N	\N	\N	\N	215392	215392	382463
29069	47426	0	applied	\N	\N	\N	\N	215393	215393	382464
29069	47427	1	applied	\N	\N	\N	\N	215394	215394	382465
29072	47431	0	applied	\N	\N	\N	\N	215399	215399	382470
29072	47432	1	applied	\N	\N	\N	\N	215400	215400	382471
29072	47433	3	applied	\N	\N	\N	\N	215401	215401	382472
29076	47434	0	applied	\N	\N	\N	\N	215411	215411	382482
29076	47435	1	applied	\N	\N	\N	\N	215412	215412	382483
29076	47436	2	applied	\N	\N	\N	\N	215413	215413	382484
29076	47437	3	applied	\N	\N	\N	\N	215414	215414	382485
29081	47438	0	applied	\N	\N	\N	\N	215429	215429	382500
29081	47439	1	applied	\N	\N	\N	\N	215430	215430	382501
29084	47441	1	applied	\N	\N	\N	\N	215438	215438	382509
29084	47442	2	applied	\N	\N	\N	\N	215439	215439	382510
29088	47449	0	applied	\N	\N	\N	\N	215450	215450	382521
29088	47450	1	applied	\N	\N	\N	\N	215451	215451	382522
29088	47451	2	applied	\N	\N	\N	\N	215452	215452	382523
29090	47456	0	applied	\N	\N	\N	\N	215457	215457	382528
29090	47457	1	applied	\N	\N	\N	\N	215458	215458	382529
29090	47458	2	applied	\N	\N	\N	\N	215459	215459	382530
29090	47459	3	applied	\N	\N	\N	\N	215460	215460	382531
29090	47460	4	applied	\N	\N	\N	\N	215461	215461	382532
29090	47461	5	applied	\N	\N	\N	\N	215462	215462	382533
29092	47462	0	applied	\N	\N	\N	\N	215469	215469	382540
29092	47463	1	applied	\N	\N	\N	\N	215470	215470	382541
29092	47464	2	applied	\N	\N	\N	\N	215471	215471	382542
28992	47269	0	applied	\N	\N	\N	\N	215054	215054	382127
28992	47270	1	applied	\N	\N	\N	\N	215055	215055	382128
29008	47310	4	applied	\N	\N	\N	\N	215119	215119	382192
29013	47315	0	applied	\N	\N	\N	\N	215135	215135	382208
29013	47316	1	applied	\N	\N	\N	\N	215136	215136	382209
29013	47317	2	applied	\N	\N	\N	\N	215137	215137	382210
29024	47346	0	applied	\N	\N	\N	\N	215178	215178	382251
29024	47347	1	applied	\N	\N	\N	\N	215179	215179	382252
29024	47348	2	applied	\N	\N	\N	\N	215180	215180	382253
29024	47349	3	applied	\N	\N	\N	\N	215181	215181	382254
29024	47350	4	applied	\N	\N	\N	\N	215182	215182	382255
29033	47365	1	applied	\N	\N	\N	\N	215224	215224	382297
29033	47366	2	applied	\N	\N	\N	\N	215225	215225	382298
29035	47367	0	applied	\N	\N	\N	\N	215230	215230	215230
29035	47368	1	applied	\N	\N	\N	\N	215231	215231	382302
29035	47369	2	applied	\N	\N	\N	\N	215232	215232	382303
29035	47370	3	applied	\N	\N	\N	\N	215233	215233	382304
29036	47351	0	applied	\N	\N	\N	\N	215234	215234	382305
29038	47374	1	applied	\N	\N	\N	\N	215238	215238	382309
29038	47375	2	applied	\N	\N	\N	\N	215239	215239	382310
29038	47376	3	applied	\N	\N	\N	\N	215240	215240	382311
29040	47377	0	applied	\N	\N	\N	\N	215245	215245	382316
29040	47378	1	applied	\N	\N	\N	\N	215246	215246	382317
29040	47379	2	applied	\N	\N	\N	\N	215247	215247	382318
29044	47389	0	applied	\N	\N	\N	\N	215263	215263	382334
29044	47390	1	applied	\N	\N	\N	\N	215264	215264	382335
29044	47391	2	applied	\N	\N	\N	\N	215265	215265	382336
29046	47392	0	applied	\N	\N	\N	\N	215269	215269	382340
29046	47393	1	applied	\N	\N	\N	\N	215270	215270	382341
29046	47394	2	applied	\N	\N	\N	\N	215271	215271	382342
29046	47395	3	applied	\N	\N	\N	\N	215272	215272	382343
29046	47396	4	applied	\N	\N	\N	\N	215273	215273	382344
29046	47397	5	applied	\N	\N	\N	\N	215274	215274	382345
29047	47392	0	applied	\N	\N	\N	\N	215275	215275	382346
29047	47394	2	applied	\N	\N	\N	\N	215277	215277	382348
29047	47395	3	applied	\N	\N	\N	\N	215278	215278	382349
29047	47396	4	applied	\N	\N	\N	\N	215279	215279	382350
29047	47397	5	applied	\N	\N	\N	\N	215280	215280	382351
29051	47398	0	applied	\N	\N	\N	\N	215293	215293	382364
29051	47399	1	applied	\N	\N	\N	\N	215294	215294	382365
29051	47400	2	applied	\N	\N	\N	\N	215295	215295	382366
29052	47398	0	applied	\N	\N	\N	\N	215296	215296	382367
29052	47399	1	applied	\N	\N	\N	\N	215297	215297	382368
29052	47400	2	applied	\N	\N	\N	\N	215298	215298	382369
29053	47401	0	applied	\N	\N	\N	\N	215299	215299	382370
29053	47402	1	applied	\N	\N	\N	\N	215300	215300	382371
29053	47403	2	applied	\N	\N	\N	\N	215301	215301	382372
29055	47404	0	applied	\N	\N	\N	\N	215305	215305	382376
29055	47405	1	applied	\N	\N	\N	\N	215306	215306	382377
29055	47406	2	applied	\N	\N	\N	\N	215307	215307	382378
29055	47408	4	applied	\N	\N	\N	\N	215309	215309	382380
29055	47409	5	applied	\N	\N	\N	\N	215310	215310	382381
29057	47410	0	applied	\N	\N	\N	\N	215317	215317	382388
29057	47411	1	applied	\N	\N	\N	\N	215318	215318	382389
29057	47412	2	applied	\N	\N	\N	\N	215319	215319	382390
29058	47410	0	applied	\N	\N	\N	\N	215320	215320	382391
29058	47411	1	applied	\N	\N	\N	\N	215321	215321	382392
29058	47412	2	applied	\N	\N	\N	\N	215322	215322	382393
29060	47413	0	applied	\N	\N	\N	\N	215332	215332	382403
29060	47414	1	applied	\N	\N	\N	\N	215333	215333	382404
29060	47415	2	applied	\N	\N	\N	\N	215334	215334	382405
29060	47416	3	applied	\N	\N	\N	\N	215335	215335	382406
29060	47417	4	applied	\N	\N	\N	\N	215336	215336	382407
29060	47418	5	applied	\N	\N	\N	\N	215337	215337	382408
29060	47419	6	applied	\N	\N	\N	\N	215338	215338	382409
29060	47420	7	applied	\N	\N	\N	\N	215339	215339	382410
29061	47413	0	applied	\N	\N	\N	\N	215341	215341	382412
29061	47414	1	applied	\N	\N	\N	\N	215342	215342	382413
29061	47415	2	applied	\N	\N	\N	\N	215343	215343	382414
29061	47416	3	applied	\N	\N	\N	\N	215344	215344	382415
29061	47417	4	applied	\N	\N	\N	\N	215345	215345	382416
29061	47418	5	applied	\N	\N	\N	\N	215346	215346	382417
29061	47419	6	applied	\N	\N	\N	\N	215347	215347	382418
29061	47420	7	applied	\N	\N	\N	\N	215348	215348	382419
29061	47421	8	applied	\N	\N	\N	\N	215349	215349	382420
29062	47413	0	applied	\N	\N	\N	\N	215350	215350	382421
29062	47414	1	applied	\N	\N	\N	\N	215351	215351	382422
29062	47415	2	applied	\N	\N	\N	\N	215352	215352	382423
29062	47416	3	applied	\N	\N	\N	\N	215353	215353	382424
29064	47413	0	applied	\N	\N	\N	\N	215368	215368	382439
29064	47414	1	applied	\N	\N	\N	\N	215369	215369	382440
29064	47415	2	applied	\N	\N	\N	\N	215370	215370	382441
29064	47417	4	applied	\N	\N	\N	\N	215372	215372	382443
29064	47418	5	applied	\N	\N	\N	\N	215373	215373	382444
29064	47419	6	applied	\N	\N	\N	\N	215374	215374	382445
29064	47420	7	applied	\N	\N	\N	\N	215375	215375	382446
29064	47421	8	applied	\N	\N	\N	\N	215376	215376	382447
29066	47422	0	applied	\N	\N	\N	\N	215381	215381	382452
29066	47423	1	applied	\N	\N	\N	\N	215382	215382	382453
29066	47424	2	applied	\N	\N	\N	\N	215383	215383	382454
29066	47425	3	applied	\N	\N	\N	\N	215384	215384	382455
29071	47431	0	applied	\N	\N	\N	\N	215398	215398	382469
29073	47431	0	applied	\N	\N	\N	\N	215402	215402	382473
29073	47432	1	applied	\N	\N	\N	\N	215403	215403	382474
29073	47433	3	applied	\N	\N	\N	\N	215404	215404	382475
29079	47434	0	applied	\N	\N	\N	\N	215423	215423	382494
29079	47435	1	applied	\N	\N	\N	\N	215424	215424	382495
29079	47436	2	applied	\N	\N	\N	\N	215425	215425	382496
29091	47457	1	applied	\N	\N	\N	\N	215464	215464	382535
29091	47458	2	applied	\N	\N	\N	\N	215465	215465	382536
29091	47459	3	applied	\N	\N	\N	\N	215466	215466	382537
29091	47460	4	applied	\N	\N	\N	\N	215467	215467	382538
29091	47461	5	applied	\N	\N	\N	\N	215468	215468	382539
29095	47465	0	applied	\N	\N	\N	\N	215479	215479	382550
29095	47466	1	applied	\N	\N	\N	\N	215480	215480	382551
29095	47467	2	applied	\N	\N	\N	\N	215481	215481	382552
29095	47468	3	applied	\N	\N	\N	\N	215482	215482	382553
29100	47469	0	applied	\N	\N	\N	\N	215505	215505	382574
29100	47470	1	applied	\N	\N	\N	\N	215506	215506	382575
29109	47490	0	applied	\N	\N	\N	\N	215666	215666	382734
29109	47491	1	applied	\N	\N	\N	\N	215667	215667	382735
29109	47492	2	applied	\N	\N	\N	\N	215668	215668	382736
29008	47307	1	applied	\N	\N	\N	\N	215116	215116	382189
29008	47308	2	applied	\N	\N	\N	\N	215117	215117	382190
29039	47373	0	applied	\N	\N	\N	\N	215241	215241	382312
29039	47374	1	applied	\N	\N	\N	\N	215242	215242	382313
29039	47375	2	applied	\N	\N	\N	\N	215243	215243	382314
29039	47376	3	applied	\N	\N	\N	\N	215244	215244	382315
29042	47383	0	applied	\N	\N	\N	\N	215251	215251	382322
29042	47384	1	applied	\N	\N	\N	\N	215252	215252	382323
29042	47385	2	applied	\N	\N	\N	\N	215253	215253	382324
29042	47386	3	applied	\N	\N	\N	\N	215254	215254	382325
29042	47387	4	applied	\N	\N	\N	\N	215255	215255	382326
29042	47388	5	applied	\N	\N	\N	\N	215256	215256	382327
29050	47398	0	applied	\N	\N	\N	\N	215290	215290	382361
29050	47399	1	applied	\N	\N	\N	\N	215291	215291	382362
29050	47400	2	applied	\N	\N	\N	\N	215292	215292	382363
29054	47401	0	applied	\N	\N	\N	\N	215302	215302	382373
29054	47402	1	applied	\N	\N	\N	\N	215303	215303	382374
29054	47403	2	applied	\N	\N	\N	\N	215304	215304	382375
29056	47405	1	applied	\N	\N	\N	\N	215312	215312	382383
29056	47406	2	applied	\N	\N	\N	\N	215313	215313	382384
29056	47407	3	applied	\N	\N	\N	\N	215314	215314	382385
29056	47408	4	applied	\N	\N	\N	\N	215315	215315	382386
29056	47409	5	applied	\N	\N	\N	\N	215316	215316	382387
29059	47413	0	applied	\N	\N	\N	\N	215323	215323	382394
29059	47414	1	applied	\N	\N	\N	\N	215324	215324	382395
29059	47415	2	applied	\N	\N	\N	\N	215325	215325	382396
29059	47416	3	applied	\N	\N	\N	\N	215326	215326	382397
29059	47417	4	applied	\N	\N	\N	\N	215327	215327	382398
29059	47418	5	applied	\N	\N	\N	\N	215328	215328	382399
29059	47419	6	applied	\N	\N	\N	\N	215329	215329	382400
29059	47420	7	applied	\N	\N	\N	\N	215330	215330	382401
29059	47421	8	applied	\N	\N	\N	\N	215331	215331	382402
29062	47417	4	applied	\N	\N	\N	\N	215354	215354	382425
29062	47418	5	applied	\N	\N	\N	\N	215355	215355	382426
29062	47420	7	applied	\N	\N	\N	\N	215357	215357	382428
29062	47421	8	applied	\N	\N	\N	\N	215358	215358	382429
29063	47413	0	applied	\N	\N	\N	\N	215359	215359	382430
29063	47414	1	applied	\N	\N	\N	\N	215360	215360	382431
29063	47415	2	applied	\N	\N	\N	\N	215361	215361	382432
29063	47416	3	applied	\N	\N	\N	\N	215362	215362	382433
29063	47417	4	applied	\N	\N	\N	\N	215363	215363	382434
29063	47418	5	applied	\N	\N	\N	\N	215364	215364	382435
29063	47419	6	applied	\N	\N	\N	\N	215365	215365	382436
29063	47420	7	applied	\N	\N	\N	\N	215366	215366	382437
29063	47421	8	applied	\N	\N	\N	\N	215367	215367	382438
29065	47422	0	applied	\N	\N	\N	\N	215377	215377	382448
29065	47423	1	applied	\N	\N	\N	\N	215378	215378	382449
29065	47424	2	applied	\N	\N	\N	\N	215379	215379	382450
29065	47425	3	applied	\N	\N	\N	\N	215380	215380	382451
29067	47422	0	applied	\N	\N	\N	\N	215385	215385	382456
29067	47424	2	applied	\N	\N	\N	\N	215387	215387	382458
29067	47425	3	applied	\N	\N	\N	\N	215388	215388	382459
29070	47428	0	applied	\N	\N	\N	\N	215395	215395	382466
29070	47429	1	applied	\N	\N	\N	\N	215396	215396	382467
29070	47430	2	applied	\N	\N	\N	\N	215397	215397	382468
29074	47431	0	applied	\N	\N	\N	\N	215405	215405	382476
29075	47431	0	applied	\N	\N	\N	\N	215408	215408	382479
29075	47432	1	applied	\N	\N	\N	\N	215409	215409	382480
29075	47433	3	applied	\N	\N	\N	\N	215410	215410	382481
29077	47434	0	applied	\N	\N	\N	\N	215415	215415	382486
29077	47435	1	applied	\N	\N	\N	\N	215416	215416	382487
29077	47436	2	applied	\N	\N	\N	\N	215417	215417	382488
29077	47437	3	applied	\N	\N	\N	\N	215418	215418	382489
29083	47440	0	applied	\N	\N	\N	\N	215434	215434	382505
29083	47441	1	applied	\N	\N	\N	\N	215435	215435	382506
29083	47442	2	applied	\N	\N	\N	\N	215436	215436	382507
29085	47444	1	applied	\N	\N	\N	\N	215441	215441	382512
29085	47445	2	applied	\N	\N	\N	\N	215442	215442	382513
29085	47446	3	applied	\N	\N	\N	\N	215443	215443	382514
29087	47447	0	applied	\N	\N	\N	\N	215448	215448	382519
29087	47448	1	applied	\N	\N	\N	\N	215449	215449	382520
29093	47462	0	applied	\N	\N	\N	\N	215472	215472	382543
29093	47463	1	applied	\N	\N	\N	\N	215473	215473	382544
29093	47464	2	applied	\N	\N	\N	\N	215474	215474	382545
29097	47465	0	applied	\N	\N	\N	\N	215487	215487	382558
29097	47466	1	applied	\N	\N	\N	\N	215488	215488	382559
29097	47467	2	applied	\N	\N	\N	\N	215489	215489	382560
29097	47468	3	applied	\N	\N	\N	\N	215490	215490	382561
29099	47469	0	applied	\N	\N	\N	\N	215503	215503	382572
29099	47470	1	applied	\N	\N	\N	\N	215504	215504	382573
29102	47471	0	applied	\N	\N	\N	\N	215517	215517	382586
29102	47472	1	applied	\N	\N	\N	\N	215518	215518	382587
29102	47474	3	applied	\N	\N	\N	\N	215520	215520	382589
29102	47475	4	applied	\N	\N	\N	\N	215521	215521	382590
29102	47476	5	applied	\N	\N	\N	\N	215522	215522	382591
29102	47477	6	applied	\N	\N	\N	\N	215523	215523	382592
29102	47478	7	applied	\N	\N	\N	\N	215524	215524	382593
29102	47479	8	applied	\N	\N	\N	\N	215525	215525	382594
29102	47480	9	applied	\N	\N	\N	\N	215526	215526	382595
29104	47481	0	applied	\N	\N	\N	\N	215529	215529	382598
29104	47482	1	applied	\N	\N	\N	\N	215530	215530	382599
29106	47483	0	applied	\N	\N	\N	\N	215656	215656	382724
29106	47484	1	applied	\N	\N	\N	\N	215657	215657	382725
29106	47485	2	applied	\N	\N	\N	\N	215658	215658	382726
29106	47486	3	applied	\N	\N	\N	\N	215659	215659	382727
29110	47495	0	applied	\N	\N	\N	\N	215671	215671	382739
29110	47496	1	applied	\N	\N	\N	\N	215672	215672	382740
29110	47497	2	applied	\N	\N	\N	\N	215673	215673	382741
29114	47508	0	applied	\N	\N	\N	\N	215688	215688	382756
29114	47509	1	applied	\N	\N	\N	\N	215689	215689	382757
29114	47510	2	applied	\N	\N	\N	\N	215690	215690	382758
29114	47511	3	applied	\N	\N	\N	\N	215691	215691	382759
29114	47512	4	applied	\N	\N	\N	\N	215692	215692	382760
29114	47513	5	applied	\N	\N	\N	\N	215693	215693	382761
29114	47514	6	applied	\N	\N	\N	\N	215694	215694	382762
29114	47515	7	applied	\N	\N	\N	\N	215695	215695	382763
29115	47508	0	applied	\N	\N	\N	\N	215696	215696	382764
29115	47509	1	applied	\N	\N	\N	\N	215697	215697	382765
29115	47510	2	applied	\N	\N	\N	\N	215698	215698	382766
29115	47511	3	applied	\N	\N	\N	\N	215699	215699	382767
29115	47512	4	applied	\N	\N	\N	\N	215700	215700	382768
29115	47513	5	applied	\N	\N	\N	\N	215701	215701	382769
29030	47361	3	applied	\N	\N	\N	\N	215214	215214	382287
29030	47362	4	applied	\N	\N	\N	\N	215215	215215	382288
29078	47435	1	applied	\N	\N	\N	\N	215420	215420	382491
29078	47436	2	applied	\N	\N	\N	\N	215421	215421	382492
29078	47437	3	applied	\N	\N	\N	\N	215422	215422	382493
29080	47435	1	applied	\N	\N	\N	\N	215427	215427	382498
29080	47436	2	applied	\N	\N	\N	\N	215428	215428	382499
29082	47440	0	applied	\N	\N	\N	\N	215431	215431	382502
29082	47441	1	applied	\N	\N	\N	\N	215432	215432	382503
29082	47442	2	applied	\N	\N	\N	\N	215433	215433	382504
29086	47443	0	applied	\N	\N	\N	\N	215444	215444	382515
29086	47444	1	applied	\N	\N	\N	\N	215445	215445	382516
29086	47445	2	applied	\N	\N	\N	\N	215446	215446	382517
29086	47446	3	applied	\N	\N	\N	\N	215447	215447	382518
29089	47452	0	applied	\N	\N	\N	\N	215453	215453	382524
29089	47453	1	applied	\N	\N	\N	\N	215454	215454	382525
29089	47454	2	applied	\N	\N	\N	\N	215455	215455	382526
29089	47455	3	applied	\N	\N	\N	\N	215456	215456	382527
29094	47465	0	applied	\N	\N	\N	\N	215475	215475	382546
29094	47466	1	applied	\N	\N	\N	\N	215476	215476	382547
29094	47467	2	applied	\N	\N	\N	\N	215477	215477	382548
29096	47465	0	applied	\N	\N	\N	\N	215483	215483	382554
29096	47466	1	applied	\N	\N	\N	\N	215484	215484	382555
29096	47467	2	applied	\N	\N	\N	\N	215485	215485	382556
29096	47468	3	applied	\N	\N	\N	\N	215486	215486	382557
29098	47258	0	applied	\N	\N	\N	\N	215491	215491	215491
29098	47457	2	applied	\N	\N	\N	\N	215492	215492	382562
29098	47351	4	applied	\N	\N	\N	\N	215494	215494	382563
29098	47050	5	applied	\N	\N	1000000000	\N	215495	215495	382564
29098	47060	6	applied	\N	\N	\N	\N	215496	215496	382565
29098	47072	7	applied	\N	\N	\N	\N	215497	215497	382566
29098	47261	8	applied	\N	\N	\N	\N	215498	215498	382567
29098	47024	9	applied	\N	\N	\N	\N	215499	215499	382568
29098	47025	10	applied	\N	\N	\N	\N	215500	215500	382569
29098	47094	12	applied	\N	\N	1000000000	\N	215502	215502	382571
29101	47471	0	applied	\N	\N	\N	\N	215507	215507	382576
29101	47472	1	applied	\N	\N	\N	\N	215508	215508	382577
29101	47473	2	applied	\N	\N	\N	\N	215509	215509	382578
29101	47474	3	applied	\N	\N	\N	\N	215510	215510	382579
29101	47475	4	applied	\N	\N	\N	\N	215511	215511	382580
29101	47476	5	applied	\N	\N	\N	\N	215512	215512	382581
29101	47477	6	applied	\N	\N	\N	\N	215513	215513	382582
29101	47478	7	applied	\N	\N	\N	\N	215514	215514	382583
29101	47479	8	applied	\N	\N	\N	\N	215515	215515	382584
29101	47480	9	applied	\N	\N	\N	\N	215516	215516	382585
29103	47481	0	applied	\N	\N	\N	\N	215527	215527	382596
29103	47482	1	applied	\N	\N	\N	\N	215528	215528	382597
29105	47327	0	applied	\N	\N	\N	\N	215531	215531	382600
29105	47296	1	applied	\N	\N	\N	\N	215532	215532	382601
29105	47297	2	applied	\N	\N	\N	\N	215533	215533	382602
29105	47367	3	applied	\N	\N	\N	\N	215534	215534	215534
29105	47457	4	applied	\N	\N	\N	\N	215535	215535	382603
29105	47351	5	applied	\N	\N	\N	\N	215536	215536	382604
29105	47303	6	applied	\N	\N	\N	\N	215537	215537	382605
29105	47307	8	applied	\N	\N	\N	\N	215539	215539	382607
29105	47311	9	applied	\N	\N	\N	\N	215540	215540	382608
29105	47315	10	applied	\N	\N	\N	\N	215541	215541	382609
29105	47318	11	applied	\N	\N	\N	\N	215542	215542	382610
29105	47319	12	applied	\N	\N	\N	\N	215543	215543	382611
29105	47324	13	applied	\N	\N	\N	\N	215544	215544	382612
29105	47328	14	applied	\N	\N	\N	\N	215545	215545	382613
29105	47329	15	applied	\N	\N	\N	\N	215546	215546	382614
29105	47334	16	applied	\N	\N	\N	\N	215547	215547	382615
29105	47337	17	applied	\N	\N	\N	\N	215548	215548	382616
29105	47340	18	applied	\N	\N	\N	\N	215549	215549	382617
29105	47342	19	applied	\N	\N	\N	\N	215550	215550	382618
29105	47346	20	applied	\N	\N	\N	\N	215551	215551	382619
29105	47347	21	applied	\N	\N	\N	\N	215552	215552	382620
29105	47352	22	applied	\N	\N	\N	\N	215553	215553	382621
29105	47353	23	applied	\N	\N	\N	\N	215554	215554	382622
29105	47359	25	applied	\N	\N	\N	\N	215556	215556	382624
29105	47364	26	applied	\N	\N	\N	\N	215557	215557	382625
29105	47368	27	applied	\N	\N	\N	\N	215558	215558	382626
29105	47371	28	applied	\N	\N	\N	\N	215559	215559	382627
29105	47373	29	applied	\N	\N	\N	\N	215560	215560	382628
29105	47377	30	applied	\N	\N	\N	\N	215561	215561	382629
29105	47380	31	applied	\N	\N	\N	\N	215562	215562	382630
29105	47383	32	applied	\N	\N	\N	\N	215563	215563	382631
29107	47487	0	applied	\N	\N	\N	\N	215660	215660	382728
29107	47488	1	applied	\N	\N	\N	\N	215661	215661	382729
29107	47489	2	applied	\N	\N	\N	\N	215662	215662	382730
29112	47499	0	applied	\N	\N	\N	\N	215679	215679	382747
29112	47500	1	applied	\N	\N	\N	\N	215680	215680	382748
29112	47501	2	applied	\N	\N	\N	\N	215681	215681	382749
29116	47508	0	applied	\N	\N	\N	\N	215704	215704	382772
29116	47509	1	applied	\N	\N	\N	\N	215705	215705	382773
29116	47511	3	applied	\N	\N	\N	\N	215707	215707	382775
29116	47512	4	applied	\N	\N	\N	\N	215708	215708	382776
29116	47513	5	applied	\N	\N	\N	\N	215709	215709	382777
29116	47514	6	applied	\N	\N	\N	\N	215710	215710	382778
29116	47515	7	applied	\N	\N	\N	\N	215711	215711	382779
29121	47525	0	applied	\N	\N	\N	\N	215854	215854	382921
29121	47526	1	applied	\N	\N	\N	\N	215855	215855	382922
29121	47527	2	applied	\N	\N	\N	\N	215856	215856	382923
29121	47528	3	applied	\N	\N	\N	\N	215857	215857	382924
29125	47532	0	applied	\N	\N	\N	\N	215869	215869	382936
29125	47533	1	applied	\N	\N	\N	\N	215870	215870	382937
29125	47534	2	applied	\N	\N	\N	\N	215871	215871	382938
29125	47535	3	applied	\N	\N	\N	\N	215872	215872	382939
29125	47536	4	applied	\N	\N	\N	\N	215873	215873	382940
29125	47537	5	applied	\N	\N	\N	\N	215874	215874	382941
29131	47554	0	applied	\N	\N	\N	\N	216087	216087	383150
29131	47556	2	applied	\N	\N	\N	\N	216089	216089	383152
29131	47557	3	applied	\N	\N	\N	\N	216090	216090	383153
29131	47558	4	applied	\N	\N	\N	\N	216091	216091	383154
29131	47559	5	applied	\N	\N	\N	\N	216092	216092	383155
29131	47560	6	applied	\N	\N	\N	\N	216093	216093	383156
29131	47561	7	applied	\N	\N	\N	\N	216094	216094	383157
29134	47572	0	applied	\N	\N	\N	\N	216107	216107	383170
29134	47573	1	applied	\N	\N	\N	\N	216108	216108	383171
29074	47433	3	applied	\N	\N	\N	\N	215407	215407	382478
29078	47434	0	applied	\N	\N	\N	\N	215419	215419	382490
29105	47398	37	applied	\N	\N	\N	\N	215568	215568	382636
29105	47401	38	applied	\N	\N	\N	\N	215569	215569	382637
29105	47404	39	applied	\N	\N	\N	\N	215570	215570	382638
29105	47405	40	applied	\N	\N	\N	\N	215571	215571	382639
29105	47410	41	applied	\N	\N	\N	\N	215572	215572	382640
29105	47413	42	applied	\N	\N	\N	\N	215573	215573	382641
29105	47414	43	applied	\N	\N	\N	\N	215574	215574	382642
29105	47415	44	applied	\N	\N	\N	\N	215575	215575	382643
29105	47422	45	applied	\N	\N	\N	\N	215576	215576	382644
29105	47426	46	applied	\N	\N	\N	\N	215577	215577	382645
29105	47428	47	applied	\N	\N	\N	\N	215578	215578	382646
29105	47431	48	applied	\N	\N	\N	\N	215579	215579	382647
29105	47434	49	applied	\N	\N	\N	\N	215580	215580	382648
29105	47438	50	applied	\N	\N	\N	\N	215581	215581	382649
29105	47440	51	applied	\N	\N	\N	\N	215582	215582	382650
29105	47443	52	applied	\N	\N	\N	\N	215583	215583	382651
29105	47449	54	applied	\N	\N	\N	\N	215585	215585	382653
29105	47452	55	applied	\N	\N	\N	\N	215586	215586	382654
29105	47456	56	applied	\N	\N	\N	\N	215587	215587	382655
29105	47458	57	applied	\N	\N	\N	\N	215588	215588	382656
29105	47462	58	applied	\N	\N	\N	\N	215589	215589	382657
29105	47465	59	applied	\N	\N	\N	\N	215590	215590	382658
29105	47469	60	applied	\N	\N	\N	\N	215591	215591	382659
29105	47471	61	applied	\N	\N	\N	\N	215592	215592	382660
29105	47472	62	applied	\N	\N	\N	\N	215593	215593	382661
29105	47473	63	applied	\N	\N	\N	\N	215594	215594	382662
29105	47481	64	applied	\N	\N	\N	\N	215595	215595	382663
29105	47298	65	applied	\N	\N	\N	\N	215596	215596	382664
29105	47299	66	applied	\N	\N	\N	\N	215597	215597	382665
29105	47300	67	applied	\N	\N	\N	\N	215598	215598	382666
29105	47304	68	applied	\N	\N	\N	\N	215599	215599	382667
29105	47309	69	applied	\N	\N	\N	\N	215600	215600	382668
29105	47313	71	applied	\N	\N	\N	\N	215602	215602	382670
29105	47301	72	applied	\N	\N	\N	\N	215603	215603	382671
29105	47305	74	applied	\N	\N	\N	\N	215604	215604	382672
29105	47308	75	applied	\N	\N	\N	\N	215605	215605	382673
29105	47314	76	applied	\N	\N	\N	\N	215606	215606	382674
29105	47316	77	applied	\N	\N	\N	\N	215607	215607	382675
29105	47321	78	applied	\N	\N	\N	\N	215608	215608	382676
29105	47325	79	applied	\N	\N	\N	\N	215609	215609	382677
29105	47333	80	applied	\N	\N	\N	\N	215610	215610	382678
29105	47336	81	applied	\N	\N	\N	\N	215611	215611	382679
29105	47339	82	applied	\N	\N	\N	\N	215612	215612	382680
29105	47344	83	applied	\N	\N	\N	\N	215613	215613	382681
29105	47349	84	applied	\N	\N	\N	\N	215614	215614	382682
29105	47354	85	applied	\N	\N	\N	\N	215615	215615	382683
29105	47355	86	applied	\N	\N	\N	\N	215616	215616	382684
29105	47361	87	applied	\N	\N	\N	\N	215617	215617	382685
29105	47302	89	applied	\N	\N	\N	\N	215619	215619	382687
29105	47312	90	applied	\N	\N	\N	\N	215620	215620	382688
29105	47320	91	applied	\N	\N	\N	\N	215621	215621	382689
29105	47331	92	applied	\N	\N	\N	\N	215622	215622	382690
29105	47345	93	applied	\N	\N	\N	\N	215623	215623	382691
29105	47357	94	applied	\N	\N	\N	\N	215624	215624	382692
29105	47362	95	applied	\N	\N	\N	\N	215625	215625	382693
29105	47375	96	applied	\N	\N	\N	\N	215626	215626	382694
29105	47388	97	applied	\N	\N	\N	\N	215627	215627	382695
29105	47395	98	applied	\N	\N	\N	\N	215628	215628	382696
29105	47409	99	applied	\N	\N	\N	\N	215629	215629	382697
29105	47416	100	applied	\N	\N	\N	\N	215630	215630	382698
29105	47424	101	applied	\N	\N	\N	\N	215631	215631	382699
29105	47435	102	applied	\N	\N	\N	\N	215632	215632	382700
29105	47444	103	applied	\N	\N	\N	\N	215633	215633	382701
29105	47454	104	applied	\N	\N	\N	\N	215634	215634	382702
29105	47480	106	applied	\N	\N	\N	\N	215636	215636	382704
29105	47370	107	applied	\N	\N	\N	\N	215637	215637	382705
29105	47374	108	applied	\N	\N	\N	\N	215638	215638	382706
29105	47379	109	applied	\N	\N	\N	\N	215639	215639	382707
29105	47381	110	applied	\N	\N	\N	\N	215640	215640	382708
29105	47387	111	applied	\N	\N	\N	\N	215641	215641	382709
29105	47391	112	applied	\N	\N	\N	\N	215642	215642	382710
29105	47394	113	applied	\N	\N	\N	\N	215643	215643	382711
29105	47400	114	applied	\N	\N	\N	\N	215644	215644	382712
29105	47403	115	applied	\N	\N	\N	\N	215645	215645	382713
29105	47408	116	applied	\N	\N	\N	\N	215646	215646	382714
29105	47411	117	applied	\N	\N	\N	\N	215647	215647	382715
29105	47417	118	applied	\N	\N	\N	\N	215648	215648	382716
29105	47421	119	applied	\N	\N	\N	\N	215649	215649	382717
29105	47423	120	applied	\N	\N	\N	\N	215650	215650	382718
29105	47429	121	applied	\N	\N	\N	\N	215651	215651	382719
29105	47437	123	applied	\N	\N	\N	\N	215653	215653	382721
29105	47442	124	applied	\N	\N	\N	\N	215654	215654	382722
29105	47446	125	applied	\N	\N	\N	\N	215655	215655	382723
29108	47487	0	applied	\N	\N	\N	\N	215663	215663	382731
29108	47488	1	applied	\N	\N	\N	\N	215664	215664	382732
29108	47489	2	applied	\N	\N	\N	\N	215665	215665	382733
29111	47495	0	applied	\N	\N	\N	\N	215675	215675	382743
29111	47496	1	applied	\N	\N	\N	\N	215676	215676	382744
29111	47497	2	applied	\N	\N	\N	\N	215677	215677	382745
29111	47498	3	applied	\N	\N	\N	\N	215678	215678	382746
29113	47502	0	applied	\N	\N	\N	\N	215682	215682	382750
29113	47503	1	applied	\N	\N	\N	\N	215683	215683	382751
29113	47504	2	applied	\N	\N	\N	\N	215684	215684	382752
29113	47505	3	applied	\N	\N	\N	\N	215685	215685	382753
29113	47506	4	applied	\N	\N	\N	\N	215686	215686	382754
29113	47507	5	applied	\N	\N	\N	\N	215687	215687	382755
29117	47509	1	applied	\N	\N	\N	\N	215713	215713	382781
29117	47510	2	applied	\N	\N	\N	\N	215714	215714	382782
29117	47511	3	applied	\N	\N	\N	\N	215715	215715	382783
29117	47512	4	applied	\N	\N	\N	\N	215716	215716	382784
29117	47513	5	applied	\N	\N	\N	\N	215717	215717	382785
29117	47514	6	applied	\N	\N	\N	\N	215718	215718	382786
29117	47515	7	applied	\N	\N	\N	\N	215719	215719	382787
29124	47529	0	applied	\N	\N	\N	\N	215866	215866	382933
29124	47530	1	applied	\N	\N	\N	\N	215867	215867	382934
29124	47531	2	applied	\N	\N	\N	\N	215868	215868	382935
29128	47258	0	applied	\N	\N	\N	\N	215950	215950	215950
29128	47367	1	applied	\N	\N	\N	\N	215951	215951	215951
29128	47457	2	applied	\N	\N	\N	\N	215952	215952	383015
29128	47123	3	applied	\N	\N	\N	\N	215953	215953	383016
29105	47389	34	applied	\N	\N	\N	\N	215565	215565	382633
29105	47392	35	applied	\N	\N	\N	\N	215566	215566	382634
29118	47457	2	applied	\N	\N	\N	\N	215722	215722	382789
29118	47269	3	applied	\N	\N	\N	\N	215723	215723	382790
29118	47272	4	applied	\N	\N	\N	\N	215724	215724	382791
29118	47351	5	applied	\N	\N	\N	\N	215725	215725	382792
29118	47275	6	applied	\N	\N	\N	\N	215726	215726	382793
29118	47278	7	applied	\N	\N	\N	\N	215727	215727	382794
29118	47281	8	applied	\N	\N	\N	\N	215728	215728	382795
29118	47284	9	applied	\N	\N	\N	\N	215729	215729	382796
29118	47285	10	applied	\N	\N	\N	\N	215730	215730	382797
29118	47290	11	applied	\N	\N	\N	\N	215731	215731	382798
29118	47294	12	applied	\N	\N	\N	\N	215732	215732	382799
29118	47296	13	applied	\N	\N	\N	\N	215733	215733	382800
29118	47297	14	applied	\N	\N	\N	\N	215734	215734	382801
29118	47303	15	applied	\N	\N	\N	\N	215735	215735	382802
29118	47306	16	applied	\N	\N	\N	\N	215736	215736	382803
29118	47307	17	applied	\N	\N	\N	\N	215737	215737	382804
29118	47315	19	applied	\N	\N	\N	\N	215739	215739	382806
29118	47318	20	applied	\N	\N	\N	\N	215740	215740	382807
29118	47319	21	applied	\N	\N	\N	\N	215741	215741	382808
29118	47324	22	applied	\N	\N	\N	\N	215742	215742	382809
29118	47328	23	applied	\N	\N	\N	\N	215743	215743	382810
29118	47329	24	applied	\N	\N	\N	\N	215744	215744	382811
29118	47334	25	applied	\N	\N	\N	\N	215745	215745	382812
29118	47337	26	applied	\N	\N	\N	\N	215746	215746	382813
29118	47340	27	applied	\N	\N	\N	\N	215747	215747	382814
29118	47342	28	applied	\N	\N	\N	\N	215748	215748	382815
29118	47346	29	applied	\N	\N	\N	\N	215749	215749	382816
29118	47347	30	applied	\N	\N	\N	\N	215750	215750	382817
29118	47352	31	applied	\N	\N	\N	\N	215751	215751	382818
29118	47353	32	applied	\N	\N	\N	\N	215752	215752	382819
29118	47358	33	applied	\N	\N	\N	\N	215753	215753	382820
29118	47359	34	applied	\N	\N	\N	\N	215754	215754	382821
29118	47368	36	applied	\N	\N	\N	\N	215756	215756	382823
29118	47371	37	applied	\N	\N	\N	\N	215757	215757	382824
29118	47373	38	applied	\N	\N	\N	\N	215758	215758	382825
29118	47377	39	applied	\N	\N	\N	\N	215759	215759	382826
29118	47380	40	applied	\N	\N	\N	\N	215760	215760	382827
29118	47383	41	applied	\N	\N	\N	\N	215761	215761	382828
29118	47384	42	applied	\N	\N	\N	\N	215762	215762	382829
29118	47389	43	applied	\N	\N	\N	\N	215763	215763	382830
29118	47392	44	applied	\N	\N	\N	\N	215764	215764	382831
29118	47393	45	applied	\N	\N	\N	\N	215765	215765	382832
29118	47398	46	applied	\N	\N	\N	\N	215766	215766	382833
29128	47129	4	applied	\N	\N	\N	\N	215954	215954	383017
29128	47351	5	applied	\N	\N	\N	\N	215955	215955	383018
29128	47132	6	applied	\N	\N	\N	\N	215956	215956	383019
29128	47146	7	applied	\N	\N	\N	\N	215957	215957	383020
29128	47147	8	applied	\N	\N	\N	\N	215958	215958	383021
29128	47152	10	applied	\N	\N	\N	\N	215960	215960	383023
29128	47158	11	applied	\N	\N	\N	\N	215961	215961	383024
29128	47162	12	applied	\N	\N	\N	\N	215962	215962	383025
29128	47164	13	applied	\N	\N	\N	\N	215963	215963	383026
29128	47165	14	applied	\N	\N	\N	\N	215964	215964	383027
29128	47171	15	applied	\N	\N	\N	\N	215965	215965	383028
29128	47174	16	applied	\N	\N	\N	\N	215966	215966	383029
29128	47177	17	applied	\N	\N	\N	\N	215967	215967	383030
29128	47180	18	applied	\N	\N	\N	\N	215968	215968	383031
29128	47183	19	applied	\N	\N	\N	\N	215969	215969	383032
29128	47186	20	applied	\N	\N	\N	\N	215970	215970	383033
29128	47189	21	applied	\N	\N	\N	\N	215971	215971	383034
29128	47190	22	applied	\N	\N	\N	\N	215972	215972	383035
29128	47191	23	applied	\N	\N	\N	\N	215973	215973	383036
29128	47199	24	applied	\N	\N	\N	\N	215974	215974	383037
29128	47201	25	applied	\N	\N	\N	\N	215975	215975	383038
29128	47209	27	applied	\N	\N	\N	\N	215977	215977	383040
29128	47211	28	applied	\N	\N	\N	\N	215978	215978	383041
29128	47214	29	applied	\N	\N	\N	\N	215979	215979	383042
29128	47217	30	applied	\N	\N	\N	\N	215980	215980	383043
29128	47218	31	applied	\N	\N	\N	\N	215981	215981	383044
29128	47224	32	applied	\N	\N	\N	\N	215982	215982	383045
29128	47227	33	applied	\N	\N	\N	\N	215983	215983	383046
29128	47232	34	applied	\N	\N	\N	\N	215984	215984	383047
29128	47233	35	applied	\N	\N	\N	\N	215985	215985	383048
29128	47236	36	applied	\N	\N	\N	\N	215986	215986	383049
29128	47240	37	applied	\N	\N	\N	\N	215987	215987	383050
29128	47243	38	applied	\N	\N	\N	\N	215988	215988	383051
29128	47246	39	applied	\N	\N	\N	\N	215989	215989	383052
29128	47247	40	applied	\N	\N	\N	\N	215990	215990	383053
29128	47252	41	applied	\N	\N	\N	\N	215991	215991	383054
29128	47255	42	applied	\N	\N	\N	\N	215992	215992	383055
29128	47260	44	applied	\N	\N	\N	\N	215994	215994	383057
29128	47266	45	applied	\N	\N	\N	\N	215995	215995	383058
29128	47269	46	applied	\N	\N	\N	\N	215996	215996	383059
29128	47272	47	applied	\N	\N	\N	\N	215997	215997	383060
29128	47275	48	applied	\N	\N	\N	\N	215998	215998	383061
29128	47278	49	applied	\N	\N	\N	\N	215999	215999	383062
29128	47281	50	applied	\N	\N	\N	\N	216000	216000	383063
29128	47284	51	applied	\N	\N	\N	\N	216001	216001	383064
29128	47285	52	applied	\N	\N	\N	\N	216002	216002	383065
29128	47290	53	applied	\N	\N	\N	\N	216003	216003	383066
29128	47294	54	applied	\N	\N	\N	\N	216004	216004	383067
29128	47296	55	applied	\N	\N	\N	\N	216005	216005	383068
29128	47297	56	applied	\N	\N	\N	\N	216006	216006	383069
29128	47303	57	applied	\N	\N	\N	\N	216007	216007	383070
29128	47306	58	applied	\N	\N	\N	\N	216008	216008	383071
29128	47307	59	applied	\N	\N	\N	\N	216009	216009	383072
29128	47315	61	applied	\N	\N	\N	\N	216011	216011	383074
29128	47318	62	applied	\N	\N	\N	\N	216012	216012	383075
29128	47319	63	applied	\N	\N	\N	\N	216013	216013	383076
29128	47324	64	applied	\N	\N	\N	\N	216014	216014	383077
29128	47328	65	applied	\N	\N	\N	\N	216015	216015	383078
29128	47329	66	applied	\N	\N	\N	\N	216016	216016	383079
29128	47334	67	applied	\N	\N	\N	\N	216017	216017	383080
29128	47337	68	applied	\N	\N	\N	\N	216018	216018	383081
29128	47340	69	applied	\N	\N	\N	\N	216019	216019	383082
29128	47342	70	applied	\N	\N	\N	\N	216020	216020	383083
29128	47346	71	applied	\N	\N	\N	\N	216021	216021	383084
29128	47347	72	applied	\N	\N	\N	\N	216022	216022	383085
29128	47352	73	applied	\N	\N	\N	\N	216023	216023	383086
29128	47353	74	applied	\N	\N	\N	\N	216024	216024	383087
29109	47494	4	applied	\N	\N	\N	\N	215670	215670	382738
29118	47327	0	applied	\N	\N	\N	\N	215720	215720	382788
29118	47405	49	applied	\N	\N	\N	\N	215769	215769	382836
29118	47410	50	applied	\N	\N	\N	\N	215770	215770	382837
29118	47413	51	applied	\N	\N	\N	\N	215771	215771	382838
29118	47414	52	applied	\N	\N	\N	\N	215772	215772	382839
29118	47415	53	applied	\N	\N	\N	\N	215773	215773	382840
29118	47422	54	applied	\N	\N	\N	\N	215774	215774	382841
29118	47426	55	applied	\N	\N	\N	\N	215775	215775	382842
29118	47428	56	applied	\N	\N	\N	\N	215776	215776	382843
29118	47431	57	applied	\N	\N	\N	\N	215777	215777	382844
29118	47434	58	applied	\N	\N	\N	\N	215778	215778	382845
29118	47438	59	applied	\N	\N	\N	\N	215779	215779	382846
29118	47440	60	applied	\N	\N	\N	\N	215780	215780	382847
29118	47443	61	applied	\N	\N	\N	\N	215781	215781	382848
29118	47447	62	applied	\N	\N	\N	\N	215782	215782	382849
29118	47449	63	applied	\N	\N	\N	\N	215783	215783	382850
29118	47452	64	applied	\N	\N	\N	\N	215784	215784	382851
29118	47458	66	applied	\N	\N	\N	\N	215786	215786	382853
29118	47462	67	applied	\N	\N	\N	\N	215787	215787	382854
29118	47465	68	applied	\N	\N	\N	\N	215788	215788	382855
29118	47469	69	applied	\N	\N	\N	\N	215789	215789	382856
29118	47471	70	applied	\N	\N	\N	\N	215790	215790	382857
29118	47472	71	applied	\N	\N	\N	\N	215791	215791	382858
29118	47473	72	applied	\N	\N	\N	\N	215792	215792	382859
29118	47481	73	applied	\N	\N	\N	\N	215793	215793	382860
29118	47483	74	applied	\N	\N	\N	\N	215794	215794	382861
29118	47487	75	applied	\N	\N	\N	\N	215795	215795	382862
29118	47490	76	applied	\N	\N	\N	\N	215796	215796	382863
29118	47491	77	applied	\N	\N	\N	\N	215797	215797	382864
29118	47495	78	applied	\N	\N	\N	\N	215798	215798	382865
29118	47499	79	applied	\N	\N	\N	\N	215799	215799	382866
29118	47502	80	applied	\N	\N	\N	\N	215800	215800	382867
29118	47503	81	applied	\N	\N	\N	\N	215801	215801	382868
29118	47509	83	applied	\N	\N	\N	\N	215803	215803	382870
29118	47510	84	applied	\N	\N	\N	\N	215804	215804	382871
29118	47270	85	applied	\N	\N	\N	\N	215805	215805	382872
29118	47273	86	applied	\N	\N	\N	\N	215806	215806	382873
29118	47277	87	applied	\N	\N	\N	\N	215807	215807	382874
29118	47271	88	applied	\N	\N	\N	\N	215808	215808	382875
29118	47282	89	applied	\N	\N	\N	\N	215809	215809	382876
29118	47292	90	applied	\N	\N	\N	\N	215810	215810	382877
29118	47279	91	applied	\N	\N	\N	\N	215811	215811	382878
29118	47283	92	applied	\N	\N	\N	\N	215812	215812	382879
29118	47286	93	applied	\N	\N	\N	\N	215813	215813	382880
29118	47274	94	applied	\N	\N	\N	\N	215814	215814	382881
29118	47276	95	applied	\N	\N	\N	\N	215815	215815	382882
29118	47288	96	applied	\N	\N	\N	\N	215816	215816	382883
29118	47280	97	applied	\N	\N	\N	\N	215817	215817	382884
29118	47287	98	applied	\N	\N	\N	\N	215818	215818	382885
29118	47312	100	applied	\N	\N	\N	\N	215820	215820	382887
29118	47320	101	applied	\N	\N	\N	\N	215821	215821	382888
29118	47331	102	applied	\N	\N	\N	\N	215822	215822	382889
29118	47345	103	applied	\N	\N	\N	\N	215823	215823	382890
29118	47357	104	applied	\N	\N	\N	\N	215824	215824	382891
29118	47362	105	applied	\N	\N	\N	\N	215825	215825	382892
29118	47375	106	applied	\N	\N	\N	\N	215826	215826	382893
29118	47388	107	applied	\N	\N	\N	\N	215827	215827	382894
29118	47395	108	applied	\N	\N	\N	\N	215828	215828	382895
29118	47409	109	applied	\N	\N	\N	\N	215829	215829	382896
29118	47416	110	applied	\N	\N	\N	\N	215830	215830	382897
29118	47424	111	applied	\N	\N	\N	\N	215831	215831	382898
29118	47435	112	applied	\N	\N	\N	\N	215832	215832	382899
29118	47444	113	applied	\N	\N	\N	\N	215833	215833	382900
29118	47454	114	applied	\N	\N	\N	\N	215834	215834	382901
29118	47467	115	applied	\N	\N	\N	\N	215835	215835	382902
29118	47291	118	applied	\N	\N	\N	\N	215837	215837	382904
29119	47516	0	applied	\N	\N	\N	\N	215845	215845	382912
29119	47517	1	applied	\N	\N	\N	\N	215846	215846	382913
29119	47518	3	applied	\N	\N	\N	\N	215847	215847	382914
29119	47519	4	applied	\N	\N	\N	\N	215848	215848	382915
29120	47520	0	applied	\N	\N	\N	\N	215849	215849	382916
29120	47521	1	applied	\N	\N	\N	\N	215850	215850	382917
29120	47522	2	applied	\N	\N	\N	\N	215851	215851	382918
29120	47523	3	applied	\N	\N	\N	\N	215852	215852	382919
29120	47524	4	applied	\N	\N	\N	\N	215853	215853	382920
29127	47538	0	applied	\N	\N	\N	\N	215938	215938	383003
29127	47539	1	applied	\N	\N	\N	\N	215939	215939	383004
29127	47540	2	applied	\N	\N	\N	\N	215940	215940	383005
29127	47541	3	applied	\N	\N	\N	\N	215941	215941	383006
29127	47542	4	applied	\N	\N	\N	\N	215942	215942	383007
29127	47543	5	applied	\N	\N	\N	\N	215943	215943	383008
29127	47545	7	applied	\N	\N	\N	\N	215945	215945	383010
29127	47546	8	applied	\N	\N	\N	\N	215946	215946	383011
29127	47547	9	applied	\N	\N	\N	\N	215947	215947	383012
29127	47548	10	applied	\N	\N	\N	\N	215948	215948	383013
29127	47549	11	applied	\N	\N	\N	\N	215949	215949	383014
29132	47562	0	applied	\N	\N	\N	\N	216095	216095	383158
29132	47563	1	applied	\N	\N	\N	\N	216096	216096	383159
29132	47564	2	applied	\N	\N	\N	\N	216097	216097	383160
29132	47565	3	applied	\N	\N	\N	\N	216098	216098	383161
29132	47566	4	applied	\N	\N	\N	\N	216099	216099	383162
29132	47567	5	applied	\N	\N	\N	\N	216100	216100	383163
29132	47568	6	applied	\N	\N	\N	\N	216101	216101	383164
29132	47569	7	applied	\N	\N	\N	\N	216102	216102	383165
29132	47570	8	applied	\N	\N	\N	\N	216103	216103	383166
29132	47571	9	applied	\N	\N	\N	\N	216104	216104	383167
29135	47574	0	applied	\N	\N	\N	\N	216109	216109	383172
29135	47576	2	applied	\N	\N	\N	\N	216111	216111	383174
29135	47577	3	applied	\N	\N	\N	\N	216112	216112	383175
29135	47578	4	applied	\N	\N	\N	\N	216113	216113	383176
29135	47579	5	applied	\N	\N	\N	\N	216114	216114	383177
29135	47580	6	applied	\N	\N	\N	\N	216115	216115	383178
29138	47583	0	applied	\N	\N	\N	\N	216124	216124	383187
29138	47584	1	applied	\N	\N	\N	\N	216125	216125	383188
29138	47585	2	applied	\N	\N	\N	\N	216126	216126	383189
29138	47586	3	applied	\N	\N	\N	\N	216127	216127	383190
29138	47587	4	applied	\N	\N	\N	\N	216128	216128	383191
29138	47588	5	applied	\N	\N	\N	\N	216129	216129	383192
29141	47589	0	applied	\N	\N	\N	\N	216136	216136	383199
29141	47590	1	applied	\N	\N	\N	\N	216137	216137	383200
29141	47591	2	applied	\N	\N	\N	\N	216138	216138	383201
29115	47515	7	applied	\N	\N	\N	\N	215703	215703	382771
29118	47401	47	applied	\N	\N	\N	\N	215767	215767	382834
29118	47308	122	applied	\N	\N	\N	\N	215841	215841	382908
29118	47314	123	applied	\N	\N	\N	\N	215842	215842	382909
29118	47316	124	applied	\N	\N	\N	\N	215843	215843	382910
29118	47321	125	applied	\N	\N	\N	\N	215844	215844	382911
29122	47525	0	applied	\N	\N	\N	\N	215858	215858	382925
29122	47526	1	applied	\N	\N	\N	\N	215859	215859	382926
29122	47527	2	applied	\N	\N	\N	\N	215860	215860	382927
29122	47528	3	applied	\N	\N	\N	\N	215861	215861	382928
29123	47525	0	applied	\N	\N	\N	\N	215862	215862	382929
29123	47526	1	applied	\N	\N	\N	\N	215863	215863	382930
29123	47527	2	applied	\N	\N	\N	\N	215864	215864	382931
29123	47528	3	applied	\N	\N	\N	\N	215865	215865	382932
29126	47457	1	applied	\N	\N	\N	\N	215876	215876	382942
29126	47351	3	applied	\N	\N	\N	\N	215878	215878	382943
29126	47043	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	215877	215877	\N
29126	47050	4	applied	\N	\N	1000000000	\N	215879	215879	382944
29126	47060	5	applied	\N	\N	\N	\N	215880	215880	382945
29126	47072	6	applied	\N	\N	\N	\N	215881	215881	382946
29126	47261	7	applied	\N	\N	\N	\N	215882	215882	382947
29126	47081	8	applied	\N	\N	1000000000	\N	215883	215883	382948
29126	47041	9	applied	\N	\N	\N	\N	215884	215884	382949
29126	47104	10	applied	\N	\N	1000000000	\N	215885	215885	382950
29126	47127	11	applied	\N	\N	1000000000	\N	215886	215886	382951
29126	47159	12	applied	\N	\N	1000000000	\N	215887	215887	382952
29126	47053	13	applied	\N	\N	\N	\N	215888	215888	382953
29126	47067	14	applied	\N	\N	\N	\N	215889	215889	382954
29126	47075	15	applied	\N	\N	\N	\N	215890	215890	382955
29126	47087	16	applied	\N	\N	\N	\N	215891	215891	382956
29126	47110	18	applied	\N	\N	\N	\N	215893	215893	382958
29126	47120	19	applied	\N	\N	\N	\N	215894	215894	382959
29126	47131	20	applied	\N	\N	\N	\N	215895	215895	382960
29126	47137	21	applied	\N	\N	\N	\N	215896	215896	382961
29126	47144	22	applied	\N	\N	\N	\N	215897	215897	382962
29126	47157	23	applied	\N	\N	\N	\N	215898	215898	382963
29126	47166	24	applied	\N	\N	\N	\N	215899	215899	382964
29126	47094	25	applied	\N	\N	1000000000	\N	215900	215900	382965
29126	47223	26	applied	\N	\N	1000000000	\N	215901	215901	382966
29126	47176	27	applied	\N	\N	\N	\N	215902	215902	382967
29126	47188	28	applied	\N	\N	\N	\N	215903	215903	382968
29126	47192	29	applied	\N	\N	\N	\N	215904	215904	382969
29126	47208	30	applied	\N	\N	\N	\N	215905	215905	382970
29126	47220	31	applied	\N	\N	\N	\N	215906	215906	382971
29126	47229	32	applied	\N	\N	\N	\N	215907	215907	382972
29126	47239	33	applied	\N	\N	\N	\N	215908	215908	382973
29126	47262	35	applied	\N	\N	\N	\N	215910	215910	382975
29126	47271	36	applied	\N	\N	\N	\N	215911	215911	382976
29126	47282	37	applied	\N	\N	\N	\N	215912	215912	382977
29126	47292	38	applied	\N	\N	\N	\N	215913	215913	382978
29126	47302	39	applied	\N	\N	\N	\N	215914	215914	382979
29126	47312	40	applied	\N	\N	\N	\N	215915	215915	382980
29126	47320	41	applied	\N	\N	\N	\N	215916	215916	382981
29126	47331	42	applied	\N	\N	\N	\N	215917	215917	382982
29126	47345	43	applied	\N	\N	\N	\N	215918	215918	382983
29126	47357	44	applied	\N	\N	\N	\N	215919	215919	382984
29126	47362	45	applied	\N	\N	\N	\N	215920	215920	382985
29126	47375	46	applied	\N	\N	\N	\N	215921	215921	382986
29126	47388	47	applied	\N	\N	\N	\N	215922	215922	382987
29126	47395	48	applied	\N	\N	\N	\N	215923	215923	382988
29126	47409	49	applied	\N	\N	\N	\N	215924	215924	382989
29126	47416	50	applied	\N	\N	\N	\N	215925	215925	382990
29126	47435	52	applied	\N	\N	\N	\N	215927	215927	382992
29126	47444	53	applied	\N	\N	\N	\N	215928	215928	382993
29126	47454	54	applied	\N	\N	\N	\N	215929	215929	382994
29126	47467	55	applied	\N	\N	\N	\N	215930	215930	382995
29126	47480	56	applied	\N	\N	\N	\N	215931	215931	382996
29126	47485	57	applied	\N	\N	\N	\N	215932	215932	382997
29126	47498	58	applied	\N	\N	\N	\N	215933	215933	382998
29126	47504	59	applied	\N	\N	\N	\N	215934	215934	382999
29126	47519	60	applied	\N	\N	\N	\N	215935	215935	383000
29126	47526	61	applied	\N	\N	\N	\N	215936	215936	383001
29126	47535	62	applied	\N	\N	\N	\N	215937	215937	383002
29130	47554	0	applied	\N	\N	\N	\N	216079	216079	383142
29130	47555	1	applied	\N	\N	\N	\N	216080	216080	383143
29130	47556	2	applied	\N	\N	\N	\N	216081	216081	383144
29130	47557	3	applied	\N	\N	\N	\N	216082	216082	383145
29130	47558	4	applied	\N	\N	\N	\N	216083	216083	383146
29130	47560	6	applied	\N	\N	\N	\N	216085	216085	383148
29130	47561	7	applied	\N	\N	\N	\N	216086	216086	383149
29133	47572	0	applied	\N	\N	\N	\N	216105	216105	383168
29133	47573	1	applied	\N	\N	\N	\N	216106	216106	383169
29139	47589	0	applied	\N	\N	\N	\N	216130	216130	383193
29139	47590	1	applied	\N	\N	\N	\N	216131	216131	383194
29139	47591	2	applied	\N	\N	\N	\N	216132	216132	383195
29143	47592	0	applied	\N	\N	\N	\N	216148	216148	383211
29143	47593	1	applied	\N	\N	\N	\N	216149	216149	383212
29143	47594	2	applied	\N	\N	\N	\N	216150	216150	383213
29143	47595	3	applied	\N	\N	\N	\N	216151	216151	383214
29143	47596	4	applied	\N	\N	\N	\N	216152	216152	383215
29143	47597	5	applied	\N	\N	\N	\N	216153	216153	383216
29143	47598	6	applied	\N	\N	\N	\N	216154	216154	383217
29143	47599	7	applied	\N	\N	\N	\N	216155	216155	383218
29143	47600	8	applied	\N	\N	\N	\N	216156	216156	383219
29144	47602	1	applied	\N	\N	\N	\N	216158	216158	383221
29144	47603	2	applied	\N	\N	\N	\N	216159	216159	383222
29146	47604	0	applied	\N	\N	\N	\N	216162	216162	383225
29146	47605	1	applied	\N	\N	\N	\N	216163	216163	383226
29149	47610	0	applied	\N	\N	\N	\N	216172	216172	383235
29149	47611	1	applied	\N	\N	\N	\N	216173	216173	383236
29149	47612	2	applied	\N	\N	\N	\N	216174	216174	383237
29149	47613	3	applied	\N	\N	\N	\N	216175	216175	383238
29149	47614	4	applied	\N	\N	\N	\N	216176	216176	383239
29149	47615	5	applied	\N	\N	\N	\N	216177	216177	383240
29154	47624	0	applied	\N	\N	\N	\N	216191	216191	383254
29154	47625	1	applied	\N	\N	\N	\N	216192	216192	383255
29154	47626	2	applied	\N	\N	\N	\N	216193	216193	383256
29163	47639	0	applied	\N	\N	\N	\N	216390	216390	383451
29163	47640	1	applied	\N	\N	\N	\N	216391	216391	383452
29167	47639	0	applied	\N	\N	\N	\N	216396	216396	383457
29118	47301	120	applied	\N	\N	\N	\N	215839	215839	382906
29118	47305	121	applied	\N	\N	\N	\N	215840	215840	382907
29128	47368	78	applied	\N	\N	\N	\N	216028	216028	383091
29128	47371	79	applied	\N	\N	\N	\N	216029	216029	383092
29128	47373	80	applied	\N	\N	\N	\N	216030	216030	383093
29128	47377	81	applied	\N	\N	\N	\N	216031	216031	383094
29128	47380	82	applied	\N	\N	\N	\N	216032	216032	383095
29128	47383	83	applied	\N	\N	\N	\N	216033	216033	383096
29128	47384	84	applied	\N	\N	\N	\N	216034	216034	383097
29128	47392	86	applied	\N	\N	\N	\N	216036	216036	383099
29128	47393	87	applied	\N	\N	\N	\N	216037	216037	383100
29128	47398	88	applied	\N	\N	\N	\N	216038	216038	383101
29128	47401	89	applied	\N	\N	\N	\N	216039	216039	383102
29128	47404	90	applied	\N	\N	\N	\N	216040	216040	383103
29128	47405	91	applied	\N	\N	\N	\N	216041	216041	383104
29128	47410	92	applied	\N	\N	\N	\N	216042	216042	383105
29128	47413	93	applied	\N	\N	\N	\N	216043	216043	383106
29128	47414	94	applied	\N	\N	\N	\N	216044	216044	383107
29128	47415	95	applied	\N	\N	\N	\N	216045	216045	383108
29128	47422	96	applied	\N	\N	\N	\N	216046	216046	383109
29128	47426	97	applied	\N	\N	\N	\N	216047	216047	383110
29128	47428	98	applied	\N	\N	\N	\N	216048	216048	383111
29128	47431	99	applied	\N	\N	\N	\N	216049	216049	383112
29128	47434	100	applied	\N	\N	\N	\N	216050	216050	383113
29128	47438	101	applied	\N	\N	\N	\N	216051	216051	383114
29128	47443	104	applied	\N	\N	\N	\N	216053	216053	383116
29128	47447	105	applied	\N	\N	\N	\N	216054	216054	383117
29128	47449	106	applied	\N	\N	\N	\N	216055	216055	383118
29128	47452	107	applied	\N	\N	\N	\N	216056	216056	383119
29128	47456	108	applied	\N	\N	\N	\N	216057	216057	383120
29128	47458	109	applied	\N	\N	\N	\N	216058	216058	383121
29128	47462	110	applied	\N	\N	\N	\N	216059	216059	383122
29128	47465	111	applied	\N	\N	\N	\N	216060	216060	383123
29128	47469	112	applied	\N	\N	\N	\N	216061	216061	383124
29128	47471	113	applied	\N	\N	\N	\N	216062	216062	383125
29128	47472	114	applied	\N	\N	\N	\N	216063	216063	383126
29128	47473	115	applied	\N	\N	\N	\N	216064	216064	383127
29128	47481	116	applied	\N	\N	\N	\N	216065	216065	383128
29128	47483	117	applied	\N	\N	\N	\N	216066	216066	383129
29128	47487	118	applied	\N	\N	\N	\N	216067	216067	383130
29128	47490	119	applied	\N	\N	\N	\N	216068	216068	383131
29128	47495	121	applied	\N	\N	\N	\N	216070	216070	383133
29128	47499	122	applied	\N	\N	\N	\N	216071	216071	383134
29128	47502	123	applied	\N	\N	\N	\N	216072	216072	383135
29128	47503	124	applied	\N	\N	\N	\N	216073	216073	383136
29128	47508	125	applied	\N	\N	\N	\N	216074	216074	383137
29129	47550	0	applied	\N	\N	\N	\N	216075	216075	383138
29129	47551	1	applied	\N	\N	\N	\N	216076	216076	383139
29129	47552	2	applied	\N	\N	\N	\N	216077	216077	383140
29129	47553	3	applied	\N	\N	\N	\N	216078	216078	383141
29137	47583	0	applied	\N	\N	\N	\N	216118	216118	383181
29137	47584	1	applied	\N	\N	\N	\N	216119	216119	383182
29137	47585	2	applied	\N	\N	\N	\N	216120	216120	383183
29137	47586	3	applied	\N	\N	\N	\N	216121	216121	383184
29137	47587	4	applied	\N	\N	\N	\N	216122	216122	383185
29137	47588	5	applied	\N	\N	\N	\N	216123	216123	383186
29140	47589	0	applied	\N	\N	\N	\N	216133	216133	383196
29140	47591	2	applied	\N	\N	\N	\N	216135	216135	383198
29142	47592	0	applied	\N	\N	\N	\N	216139	216139	383202
29142	47593	1	applied	\N	\N	\N	\N	216140	216140	383203
29142	47594	2	applied	\N	\N	\N	\N	216141	216141	383204
29142	47595	3	applied	\N	\N	\N	\N	216142	216142	383205
29142	47596	4	applied	\N	\N	\N	\N	216143	216143	383206
29142	47597	5	applied	\N	\N	\N	\N	216144	216144	383207
29142	47598	6	applied	\N	\N	\N	\N	216145	216145	383208
29142	47599	7	applied	\N	\N	\N	\N	216146	216146	383209
29142	47600	8	applied	\N	\N	\N	\N	216147	216147	383210
29145	47604	0	applied	\N	\N	\N	\N	216160	216160	383223
29145	47605	1	applied	\N	\N	\N	\N	216161	216161	383224
29148	47606	0	applied	\N	\N	\N	\N	216168	216168	383231
29148	47607	1	applied	\N	\N	\N	\N	216169	216169	383232
29148	47608	2	applied	\N	\N	\N	\N	216170	216170	383233
29148	47609	3	applied	\N	\N	\N	\N	216171	216171	383234
29151	47622	1	applied	\N	\N	\N	\N	216184	216184	383247
29151	47623	2	applied	\N	\N	\N	\N	216185	216185	383248
29152	47624	0	applied	\N	\N	\N	\N	216186	216186	383249
29152	47625	1	applied	\N	\N	\N	\N	216187	216187	383250
29152	47626	2	applied	\N	\N	\N	\N	216188	216188	383251
29156	47627	0	applied	\N	\N	\N	\N	216203	216203	383266
29156	47628	1	applied	\N	\N	\N	\N	216204	216204	383267
29156	47629	2	applied	\N	\N	\N	\N	216205	216205	383268
29156	47630	3	applied	\N	\N	\N	\N	216206	216206	383269
29156	47626	4	applied	\N	\N	\N	\N	216207	216207	383270
29156	47631	5	applied	\N	\N	\N	\N	216208	216208	383271
29156	47632	6	applied	\N	\N	\N	\N	216209	216209	383272
29156	47633	7	applied	\N	\N	\N	\N	216210	216210	383273
29156	47634	8	applied	\N	\N	\N	\N	216211	216211	383274
29157	47635	0	applied	\N	\N	\N	\N	216212	216212	383275
29157	47636	1	applied	\N	\N	\N	\N	216213	216213	383276
29159	46820	1	applied	\N	\N	1000000000	\N	216217	216217	383279
29159	46797	2	applied	\N	\N	\N	\N	216218	216218	383280
29159	47457	3	applied	\N	\N	\N	\N	216219	216219	383281
29162	47509	0	applied	\N	\N	\N	\N	216265	216265	383326
29159	47043	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	216220	216220	\N
29162	47510	1	applied	\N	\N	\N	\N	216266	216266	383327
29162	47516	2	applied	\N	\N	\N	\N	216267	216267	383328
29162	47520	3	applied	\N	\N	\N	\N	216268	216268	383329
29162	47521	4	applied	\N	\N	\N	\N	216269	216269	383330
29162	47525	5	applied	\N	\N	\N	\N	216270	216270	383331
29162	47529	6	applied	\N	\N	\N	\N	216271	216271	383332
29162	47532	7	applied	\N	\N	\N	\N	216272	216272	383333
29162	47533	8	applied	\N	\N	\N	\N	216273	216273	383334
29162	47538	9	applied	\N	\N	\N	\N	216274	216274	383335
29162	47539	10	applied	\N	\N	\N	\N	216275	216275	383336
29162	47540	11	applied	\N	\N	\N	\N	216276	216276	383337
29162	47550	13	applied	\N	\N	\N	\N	216278	216278	383339
29162	47551	14	applied	\N	\N	\N	\N	216279	216279	383340
29162	47554	15	applied	\N	\N	\N	\N	216280	216280	383341
29162	47555	16	applied	\N	\N	\N	\N	216281	216281	383342
29162	47562	17	applied	\N	\N	\N	\N	216282	216282	383343
29162	47563	18	applied	\N	\N	\N	\N	216283	216283	383344
29128	47359	76	applied	\N	\N	\N	\N	216026	216026	383089
29128	47364	77	applied	\N	\N	\N	\N	216027	216027	383090
29147	47607	1	applied	\N	\N	\N	\N	216165	216165	383228
29147	47608	2	applied	\N	\N	\N	\N	216166	216166	383229
29147	47609	3	applied	\N	\N	\N	\N	216167	216167	383230
29150	47616	0	applied	\N	\N	\N	\N	216178	216178	383241
29150	47617	1	applied	\N	\N	\N	\N	216179	216179	383242
29150	47618	2	applied	\N	\N	\N	\N	216180	216180	383243
29150	47619	3	applied	\N	\N	\N	\N	216181	216181	383244
29150	47620	4	applied	\N	\N	\N	\N	216182	216182	383245
29153	47624	0	applied	\N	\N	\N	\N	216189	216189	383252
29153	47625	1	applied	\N	\N	\N	\N	216190	216190	383253
29155	47627	0	applied	\N	\N	\N	\N	216194	216194	383257
29155	47629	2	applied	\N	\N	\N	\N	216196	216196	383259
29155	47630	3	applied	\N	\N	\N	\N	216197	216197	383260
29155	47626	4	applied	\N	\N	\N	\N	216198	216198	383261
29155	47631	5	applied	\N	\N	\N	\N	216199	216199	383262
29155	47632	6	applied	\N	\N	\N	\N	216200	216200	383263
29155	47633	7	applied	\N	\N	\N	\N	216201	216201	383264
29155	47634	8	applied	\N	\N	\N	\N	216202	216202	383265
29158	47635	0	applied	\N	\N	\N	\N	216214	216214	383277
29158	47636	1	applied	\N	\N	\N	\N	216215	216215	383278
29159	47351	5	applied	\N	\N	\N	\N	216221	216221	383282
29159	47050	6	applied	\N	\N	1000000000	\N	216222	216222	383283
29159	47060	7	applied	\N	\N	\N	\N	216223	216223	383284
29159	47072	8	applied	\N	\N	\N	\N	216224	216224	383285
29159	47261	9	applied	\N	\N	\N	\N	216225	216225	383286
29159	46710	11	applied	\N	\N	\N	\N	216227	216227	383288
29159	46718	12	applied	\N	\N	\N	\N	216228	216228	383289
29159	46725	13	applied	\N	\N	\N	\N	216229	216229	383290
29159	46733	14	applied	\N	\N	\N	\N	216230	216230	383291
29159	46721	15	applied	\N	\N	\N	\N	216231	216231	383292
29159	46742	16	applied	\N	\N	\N	\N	216232	216232	383293
29159	46751	17	applied	\N	\N	\N	\N	216233	216233	383294
29159	46762	18	applied	\N	\N	\N	\N	216234	216234	383295
29159	47094	19	applied	\N	\N	1000000000	\N	216235	216235	383296
29159	46773	20	applied	\N	\N	\N	\N	216236	216236	383297
29159	46780	21	applied	\N	\N	\N	\N	216237	216237	383298
29159	46791	22	applied	\N	\N	\N	\N	216238	216238	383299
29159	46802	23	applied	\N	\N	\N	\N	216239	216239	383300
29159	46808	24	applied	\N	\N	\N	\N	216240	216240	383301
29159	46816	25	applied	\N	\N	\N	\N	216241	216241	383302
29159	46825	26	applied	\N	\N	\N	\N	216242	216242	383303
29159	46833	27	applied	\N	\N	\N	\N	216243	216243	383304
29159	46847	28	applied	\N	\N	\N	\N	216244	216244	383305
29159	46856	29	applied	\N	\N	\N	\N	216245	216245	383306
29159	46866	30	applied	\N	\N	\N	\N	216246	216246	383307
29159	46886	33	applied	\N	\N	\N	\N	216248	216248	383309
29159	46897	34	applied	\N	\N	\N	\N	216249	216249	383310
29159	46907	35	applied	\N	\N	\N	\N	216250	216250	383311
29159	46916	36	applied	\N	\N	\N	\N	216251	216251	383312
29159	46926	37	applied	\N	\N	\N	\N	216252	216252	383313
29159	46938	38	applied	\N	\N	\N	\N	216253	216253	383314
29159	46944	39	applied	\N	\N	\N	\N	216254	216254	383315
29159	46954	40	applied	\N	\N	\N	\N	216255	216255	383316
29159	46971	41	applied	\N	\N	\N	\N	216256	216256	383317
29159	46977	42	applied	\N	\N	\N	\N	216257	216257	383318
29159	46985	43	applied	\N	\N	\N	\N	216258	216258	383319
29159	46996	44	applied	\N	\N	\N	\N	216259	216259	383320
29159	47005	45	applied	\N	\N	\N	\N	216260	216260	383321
29160	47635	0	applied	\N	\N	\N	\N	216261	216261	383322
29160	47636	1	applied	\N	\N	\N	\N	216262	216262	383323
29161	47637	0	applied	\N	\N	\N	\N	216263	216263	383324
29162	47564	19	applied	\N	\N	\N	\N	216284	216284	383345
29162	47572	20	applied	\N	\N	\N	\N	216285	216285	383346
29162	47574	21	applied	\N	\N	\N	\N	216286	216286	383347
29162	47575	22	applied	\N	\N	\N	\N	216287	216287	383348
29162	47581	23	applied	\N	\N	\N	\N	216288	216288	383349
29162	47583	24	applied	\N	\N	\N	\N	216289	216289	383350
29162	47584	25	applied	\N	\N	\N	\N	216290	216290	383351
29162	47589	26	applied	\N	\N	\N	\N	216291	216291	383352
29162	47592	27	applied	\N	\N	\N	\N	216292	216292	383353
29162	47593	28	applied	\N	\N	\N	\N	216293	216293	383354
29162	47594	29	applied	\N	\N	\N	\N	216294	216294	383355
29162	47601	30	applied	\N	\N	\N	\N	216295	216295	383356
29162	47604	31	applied	\N	\N	\N	\N	216296	216296	383357
29162	47606	32	applied	\N	\N	\N	\N	216297	216297	383358
29162	47610	33	applied	\N	\N	\N	\N	216298	216298	383359
29162	47611	34	applied	\N	\N	\N	\N	216299	216299	383360
29162	47617	36	applied	\N	\N	\N	\N	216301	216301	383362
29162	47621	37	applied	\N	\N	\N	\N	216302	216302	383363
29162	47624	38	applied	\N	\N	\N	\N	216303	216303	383364
29162	47627	39	applied	\N	\N	\N	\N	216304	216304	383365
29162	47628	40	applied	\N	\N	\N	\N	216305	216305	383366
29162	47629	41	applied	\N	\N	\N	\N	216306	216306	383367
29162	47635	42	applied	\N	\N	\N	\N	216307	216307	383368
29162	47261	43	applied	\N	\N	\N	\N	216308	216308	383369
29162	47124	44	applied	\N	\N	\N	\N	216309	216309	383370
29162	47125	45	applied	\N	\N	\N	\N	216310	216310	383371
29162	47128	46	applied	\N	\N	\N	\N	216311	216311	383372
29162	47130	47	applied	\N	\N	\N	\N	216312	216312	383373
29162	47133	48	applied	\N	\N	\N	\N	216313	216313	383374
29162	47135	49	applied	\N	\N	\N	\N	216314	216314	383375
29164	47639	0	applied	\N	\N	\N	\N	216392	216392	383453
29164	47640	1	applied	\N	\N	\N	\N	216393	216393	383454
29168	47642	1	applied	\N	\N	\N	\N	216399	216399	383460
29168	47643	2	applied	\N	\N	\N	\N	216400	216400	383461
29168	47644	3	applied	\N	\N	\N	\N	216401	216401	383462
29168	47645	4	applied	\N	\N	\N	\N	216402	216402	383463
29170	47641	0	applied	\N	\N	\N	\N	216411	216411	383472
29170	47642	1	applied	\N	\N	\N	\N	216412	216412	383473
29170	47643	2	applied	\N	\N	\N	\N	216413	216413	383474
29170	47644	3	applied	\N	\N	\N	\N	216414	216414	383475
29170	47645	4	applied	\N	\N	\N	\N	216415	216415	383476
29172	47641	0	applied	\N	\N	\N	\N	216419	216419	383480
29172	47642	1	applied	\N	\N	\N	\N	216420	216420	383481
29172	47643	2	applied	\N	\N	\N	\N	216421	216421	383482
29172	47644	3	applied	\N	\N	\N	\N	216422	216422	383483
29172	47645	4	applied	\N	\N	\N	\N	216423	216423	383484
29172	47646	5	applied	\N	\N	\N	\N	216424	216424	383485
29172	47647	6	applied	\N	\N	\N	\N	216425	216425	383486
29136	47582	1	applied	\N	\N	\N	\N	216117	216117	383180
29147	47606	0	applied	\N	\N	\N	\N	216164	216164	383227
29162	47144	53	applied	\N	\N	\N	\N	216318	216318	383379
29162	47126	54	applied	\N	\N	\N	\N	216319	216319	383380
29162	47127	55	applied	\N	\N	1000000000	\N	216320	216320	383381
29162	47159	56	applied	\N	\N	1000000000	\N	216321	216321	383382
29162	47140	57	applied	\N	\N	\N	\N	216322	216322	383383
29162	47141	58	applied	\N	\N	\N	\N	216323	216323	383384
29162	47143	59	applied	\N	\N	\N	\N	216324	216324	383385
29162	47149	60	applied	\N	\N	\N	\N	216325	216325	383386
29162	47134	61	applied	\N	\N	\N	\N	216326	216326	383387
29162	47139	63	applied	\N	\N	\N	\N	216328	216328	383389
29162	47142	64	applied	\N	\N	\N	\N	216329	216329	383390
29162	47145	65	applied	\N	\N	\N	\N	216330	216330	383391
29162	47148	66	applied	\N	\N	\N	\N	216331	216331	383392
29162	47155	67	applied	\N	\N	\N	\N	216332	216332	383393
29162	47156	68	applied	\N	\N	\N	\N	216333	216333	383394
29162	47161	69	applied	\N	\N	\N	\N	216334	216334	383395
29162	47150	70	applied	\N	\N	\N	\N	216335	216335	383396
29162	47153	71	applied	\N	\N	\N	\N	216336	216336	383397
29162	47154	72	applied	\N	\N	\N	\N	216337	216337	383398
29162	47160	73	applied	\N	\N	\N	\N	216338	216338	383399
29162	47163	74	applied	\N	\N	\N	\N	216339	216339	383400
29162	47167	75	applied	\N	\N	\N	\N	216340	216340	383401
29162	47168	76	applied	\N	\N	\N	\N	216341	216341	383402
29162	47172	77	applied	\N	\N	\N	\N	216342	216342	383403
29162	47179	78	applied	\N	\N	\N	\N	216343	216343	383404
29162	47185	80	applied	\N	\N	\N	\N	216345	216345	383406
29162	47196	81	applied	\N	\N	\N	\N	216346	216346	383407
29162	47197	82	applied	\N	\N	\N	\N	216347	216347	383408
29162	47157	83	applied	\N	\N	\N	\N	216348	216348	383409
29162	47166	84	applied	\N	\N	\N	\N	216349	216349	383410
29162	47223	85	applied	\N	\N	1000000000	\N	216350	216350	383411
29162	47176	86	applied	\N	\N	\N	\N	216351	216351	383412
29162	47188	87	applied	\N	\N	\N	\N	216352	216352	383413
29162	47192	88	applied	\N	\N	\N	\N	216353	216353	383414
29162	47208	89	applied	\N	\N	\N	\N	216354	216354	383415
29162	47220	90	applied	\N	\N	\N	\N	216355	216355	383416
29162	47229	91	applied	\N	\N	\N	\N	216356	216356	383417
29162	47239	92	applied	\N	\N	\N	\N	216357	216357	383418
29162	47250	93	applied	\N	\N	\N	\N	216358	216358	383419
29162	47262	94	applied	\N	\N	\N	\N	216359	216359	383420
29162	47271	95	applied	\N	\N	\N	\N	216360	216360	383421
29162	47292	97	applied	\N	\N	\N	\N	216362	216362	383423
29162	47302	98	applied	\N	\N	\N	\N	216363	216363	383424
29162	47312	99	applied	\N	\N	\N	\N	216364	216364	383425
29162	47320	100	applied	\N	\N	\N	\N	216365	216365	383426
29162	47331	101	applied	\N	\N	\N	\N	216366	216366	383427
29162	47345	102	applied	\N	\N	\N	\N	216367	216367	383428
29162	47357	104	applied	\N	\N	\N	\N	216368	216368	383429
29162	47362	105	applied	\N	\N	\N	\N	216369	216369	383430
29162	47375	106	applied	\N	\N	\N	\N	216370	216370	383431
29162	47388	107	applied	\N	\N	\N	\N	216371	216371	383432
29162	47395	108	applied	\N	\N	\N	\N	216372	216372	383433
29162	47409	109	applied	\N	\N	\N	\N	216373	216373	383434
29162	47416	110	applied	\N	\N	\N	\N	216374	216374	383435
29162	47424	111	applied	\N	\N	\N	\N	216375	216375	383436
29162	47435	112	applied	\N	\N	\N	\N	216376	216376	383437
29162	47444	113	applied	\N	\N	\N	\N	216377	216377	383438
29162	47467	115	applied	\N	\N	\N	\N	216379	216379	383440
29162	47169	116	applied	\N	\N	\N	\N	216380	216380	383441
29162	47170	117	applied	\N	\N	\N	\N	216381	216381	383442
29162	47173	118	applied	\N	\N	\N	\N	216382	216382	383443
29162	47175	119	applied	\N	\N	\N	\N	216383	216383	383444
29162	47178	120	applied	\N	\N	\N	\N	216384	216384	383445
29162	47182	121	applied	\N	\N	\N	\N	216385	216385	383446
29162	47184	122	applied	\N	\N	\N	\N	216386	216386	383447
29162	47187	123	applied	\N	\N	\N	\N	216387	216387	383448
29162	47193	124	applied	\N	\N	\N	\N	216388	216388	383449
29162	47194	125	applied	\N	\N	\N	\N	216389	216389	383450
29165	47639	0	applied	\N	\N	\N	\N	216394	216394	383455
29165	47640	1	applied	\N	\N	\N	\N	216395	216395	383456
29169	47641	0	applied	\N	\N	\N	\N	216403	216403	383464
29169	47642	1	applied	\N	\N	\N	\N	216404	216404	383465
29169	47643	2	applied	\N	\N	\N	\N	216405	216405	383466
29169	47645	4	applied	\N	\N	\N	\N	216407	216407	383468
29169	47646	5	applied	\N	\N	\N	\N	216408	216408	383469
29169	47647	6	applied	\N	\N	\N	\N	216409	216409	383470
29169	47648	7	applied	\N	\N	\N	\N	216410	216410	383471
29171	47641	0	applied	\N	\N	\N	\N	216416	216416	383477
29171	47642	1	applied	\N	\N	\N	\N	216417	216417	383478
29171	47643	2	applied	\N	\N	\N	\N	216418	216418	383479
29173	47649	0	applied	\N	\N	\N	\N	216427	216427	383488
29173	47650	1	applied	\N	\N	\N	\N	216428	216428	383489
29173	47651	2	applied	\N	\N	\N	\N	216429	216429	383490
29174	47649	0	applied	\N	\N	\N	\N	216430	216430	383491
29174	47650	1	applied	\N	\N	\N	\N	216431	216431	383492
29174	47651	2	applied	\N	\N	\N	\N	216432	216432	383493
29175	47652	0	applied	\N	\N	\N	\N	216433	216433	383494
29175	47653	1	applied	\N	\N	\N	\N	216434	216434	383495
29175	47654	2	applied	\N	\N	\N	\N	216435	216435	383496
29176	47656	1	applied	\N	\N	\N	\N	216437	216437	383498
29177	47657	0	applied	\N	\N	\N	\N	216438	216438	383499
29177	47658	1	applied	\N	\N	\N	\N	216439	216439	383500
29177	47659	2	applied	\N	\N	\N	\N	216440	216440	383501
29182	47258	0	applied	\N	\N	\N	\N	216453	216453	216453
29182	47367	1	applied	\N	\N	\N	\N	216454	216454	216454
29182	47457	2	applied	\N	\N	\N	\N	216455	216455	383514
29182	47351	3	applied	\N	\N	\N	\N	216456	216456	383515
29182	47261	4	applied	\N	\N	\N	\N	216457	216457	383516
29182	47223	5	applied	\N	\N	1000000000	\N	216458	216458	383517
29195	47680	0	applied	\N	\N	\N	\N	216555	216555	383614
29195	47681	1	applied	\N	\N	\N	\N	216556	216556	383615
29195	47682	2	applied	\N	\N	\N	\N	216557	216557	383616
29195	47683	3	applied	\N	\N	\N	\N	216558	216558	383617
29195	47684	4	applied	\N	\N	\N	\N	216559	216559	383618
29198	47689	0	applied	\N	\N	\N	\N	216567	216567	383626
29198	47691	2	applied	\N	\N	\N	\N	216569	216569	383628
29198	47692	3	applied	\N	\N	\N	\N	216570	216570	383629
29198	47693	4	applied	\N	\N	\N	\N	216571	216571	383630
29198	47694	5	applied	\N	\N	\N	\N	216572	216572	383631
29162	47131	51	applied	\N	\N	\N	\N	216316	216316	383377
29162	47137	52	applied	\N	\N	\N	\N	216317	216317	383378
29181	47661	1	applied	\N	\N	\N	\N	216451	216451	383512
29181	47662	2	applied	\N	\N	\N	\N	216452	216452	383513
29184	47610	0	applied	\N	\N	\N	\N	216461	216461	383520
29184	47611	1	applied	\N	\N	\N	\N	216462	216462	383521
29184	47616	2	applied	\N	\N	\N	\N	216463	216463	383522
29184	47617	3	applied	\N	\N	\N	\N	216464	216464	383523
29184	47621	4	applied	\N	\N	\N	\N	216465	216465	383524
29184	47624	5	applied	\N	\N	\N	\N	216466	216466	383525
29184	47627	6	applied	\N	\N	\N	\N	216467	216467	383526
29184	47628	7	applied	\N	\N	\N	\N	216468	216468	383527
29184	47629	8	applied	\N	\N	\N	\N	216469	216469	383528
29184	47635	9	applied	\N	\N	\N	\N	216470	216470	383529
29184	47641	10	applied	\N	\N	\N	\N	216471	216471	383530
29184	47642	11	applied	\N	\N	\N	\N	216472	216472	383531
29184	47643	12	applied	\N	\N	\N	\N	216473	216473	383532
29184	47649	13	applied	\N	\N	\N	\N	216474	216474	383533
29198	47696	8	applied	\N	\N	\N	\N	216574	216574	383633
29201	47689	0	applied	\N	\N	\N	\N	216591	216591	383650
29201	47690	1	applied	\N	\N	\N	\N	216592	216592	383651
29201	47691	2	applied	\N	\N	\N	\N	216593	216593	383652
29201	47692	3	applied	\N	\N	\N	\N	216594	216594	383653
29201	47693	4	applied	\N	\N	\N	\N	216595	216595	383654
29201	47694	5	applied	\N	\N	\N	\N	216596	216596	383655
29201	47695	7	applied	\N	\N	\N	\N	216597	216597	383656
29201	47696	8	applied	\N	\N	\N	\N	216598	216598	383657
29204	47689	0	applied	\N	\N	\N	\N	216613	216613	383672
29204	47690	1	applied	\N	\N	\N	\N	216614	216614	383673
29204	47691	2	applied	\N	\N	\N	\N	216615	216615	383674
29204	47692	3	applied	\N	\N	\N	\N	216616	216616	383675
29204	47693	4	applied	\N	\N	\N	\N	216617	216617	383676
29204	47694	5	applied	\N	\N	\N	\N	216618	216618	383677
29204	47695	7	applied	\N	\N	\N	\N	216619	216619	383678
29218	47711	0	applied	\N	\N	\N	\N	216792	216792	383851
29218	47712	1	applied	\N	\N	\N	\N	216793	216793	383852
29220	47713	0	applied	\N	\N	\N	\N	216796	216796	383855
29220	47715	1	applied	\N	\N	\N	\N	216797	216797	383856
29220	47714	2	applied	\N	\N	\N	\N	216798	216798	383857
29222	47716	0	applied	\N	\N	\N	\N	216802	216802	383861
29222	47717	1	applied	\N	\N	\N	\N	216803	216803	383862
29224	47716	0	applied	\N	\N	\N	\N	216807	216807	383866
29224	47717	1	applied	\N	\N	\N	\N	216808	216808	383867
29224	47718	2	applied	\N	\N	\N	\N	216809	216809	383868
29226	47719	0	applied	\N	\N	\N	\N	216813	216813	383872
29226	47720	1	applied	\N	\N	\N	\N	216814	216814	383873
29226	47721	2	applied	\N	\N	\N	\N	216815	216815	383874
29233	47734	0	applied	\N	\N	\N	\N	216840	216840	383899
29233	47735	1	applied	\N	\N	\N	\N	216841	216841	383900
29233	47736	2	applied	\N	\N	\N	\N	216842	216842	383901
29233	47738	4	applied	\N	\N	\N	\N	216844	216844	383903
29233	47739	5	applied	\N	\N	\N	\N	216845	216845	383904
29235	47747	0	applied	\N	\N	\N	\N	216853	216853	383912
29235	47748	1	applied	\N	\N	\N	\N	216854	216854	383913
29235	47749	2	applied	\N	\N	\N	\N	216855	216855	383914
29235	47750	3	applied	\N	\N	\N	\N	216856	216856	383915
29242	47756	0	applied	\N	\N	\N	\N	216878	216878	383937
29242	47757	1	applied	\N	\N	\N	\N	216879	216879	383938
29242	47758	2	applied	\N	\N	\N	\N	216880	216880	383939
29248	47768	0	applied	\N	\N	\N	\N	216900	216900	383959
29248	47769	1	applied	\N	\N	\N	\N	216901	216901	383960
29248	47770	2	applied	\N	\N	\N	\N	216902	216902	383961
29248	47771	3	applied	\N	\N	\N	\N	216903	216903	383962
29252	47774	0	applied	\N	\N	\N	\N	216911	216911	383970
29252	47775	1	applied	\N	\N	\N	\N	216912	216912	383971
29252	47776	2	applied	\N	\N	\N	\N	216913	216913	383972
29255	47783	1	applied	\N	\N	\N	\N	216922	216922	383981
29257	47784	0	applied	\N	\N	\N	\N	216926	216926	383985
29257	47782	1	applied	\N	\N	\N	\N	216927	216927	383986
29257	47785	2	applied	\N	\N	\N	\N	216928	216928	383987
29261	47792	0	applied	\N	\N	\N	\N	216938	216938	383997
29261	47793	1	applied	\N	\N	\N	\N	216939	216939	383998
29261	47794	2	applied	\N	\N	\N	\N	216940	216940	383999
29261	47795	3	applied	\N	\N	\N	\N	216941	216941	384000
29265	47808	0	applied	\N	\N	\N	\N	216978	216978	384037
29265	47809	1	applied	\N	\N	\N	\N	216979	216979	384038
29265	47810	2	applied	\N	\N	\N	\N	216980	216980	384039
29265	47811	3	applied	\N	\N	\N	\N	216981	216981	384040
29267	47812	0	applied	\N	\N	\N	\N	216987	216987	384045
29267	47813	1	applied	\N	\N	\N	\N	216988	216988	384046
29267	47814	2	applied	\N	\N	\N	\N	216989	216989	384047
29267	47815	3	applied	\N	\N	\N	\N	216990	216990	384048
29267	47817	5	applied	\N	\N	\N	\N	216992	216992	384050
29270	47818	0	applied	\N	\N	\N	\N	217003	217003	384061
29270	47819	1	applied	\N	\N	\N	\N	217004	217004	384062
29270	47820	2	applied	\N	\N	\N	\N	217005	217005	384063
29270	47821	3	applied	\N	\N	\N	\N	217006	217006	384064
29270	47822	4	applied	\N	\N	\N	\N	217007	217007	384065
29270	47823	5	applied	\N	\N	\N	\N	217008	217008	384066
29270	47824	6	applied	\N	\N	\N	\N	217009	217009	384067
29270	47825	7	applied	\N	\N	\N	\N	217010	217010	384068
29270	47826	8	applied	\N	\N	\N	\N	217011	217011	384069
29270	47827	9	applied	\N	\N	\N	\N	217012	217012	384070
29270	47828	10	applied	\N	\N	\N	\N	217013	217013	384071
29270	47829	11	applied	\N	\N	\N	\N	217014	217014	384072
29272	47818	0	applied	\N	\N	\N	\N	217035	217035	384093
29272	47819	1	applied	\N	\N	\N	\N	217036	217036	384094
29272	47820	2	applied	\N	\N	\N	\N	217037	217037	384095
29272	47822	4	applied	\N	\N	\N	\N	217039	217039	384097
29272	47823	5	applied	\N	\N	\N	\N	217040	217040	384098
29272	47824	6	applied	\N	\N	\N	\N	217041	217041	384099
29272	47825	7	applied	\N	\N	\N	\N	217042	217042	384100
29272	47826	8	applied	\N	\N	\N	\N	217043	217043	384101
29272	47827	9	applied	\N	\N	\N	\N	217044	217044	384102
29272	47828	10	applied	\N	\N	\N	\N	217045	217045	384103
29272	47829	11	applied	\N	\N	\N	\N	217046	217046	384104
29274	47327	0	applied	\N	\N	\N	\N	217053	217053	384111
29274	47367	1	applied	\N	\N	\N	\N	217054	217054	217054
29274	47457	2	applied	\N	\N	\N	\N	217055	217055	384112
29274	47793	3	applied	\N	\N	\N	\N	217056	217056	384113
29274	47351	4	applied	\N	\N	\N	\N	217057	217057	384114
29274	47303	5	applied	\N	\N	\N	\N	217058	217058	384115
29178	47658	1	applied	\N	\N	\N	\N	216442	216442	383503
29178	47659	2	applied	\N	\N	\N	\N	216443	216443	383504
29184	47655	15	applied	\N	\N	\N	\N	216476	216476	383535
29184	47657	16	applied	\N	\N	\N	\N	216477	216477	383536
29184	47660	17	applied	\N	\N	\N	\N	216478	216478	383537
29184	47612	18	applied	\N	\N	\N	\N	216479	216479	383538
29184	47613	19	applied	\N	\N	\N	\N	216480	216480	383539
29184	47614	20	applied	\N	\N	\N	\N	216481	216481	383540
29184	47620	21	applied	\N	\N	\N	\N	216482	216482	383541
29184	47623	22	applied	\N	\N	\N	\N	216483	216483	383542
29184	47625	23	applied	\N	\N	\N	\N	216484	216484	383543
29184	47630	24	applied	\N	\N	\N	\N	216485	216485	383544
29184	47632	25	applied	\N	\N	\N	\N	216486	216486	383545
29184	47638	26	applied	\N	\N	\N	\N	216487	216487	383546
29184	47639	27	applied	\N	\N	\N	\N	216488	216488	383547
29184	47644	28	applied	\N	\N	\N	\N	216489	216489	383548
29184	47645	29	applied	\N	\N	\N	\N	216490	216490	383549
29184	47615	30	applied	\N	\N	\N	\N	216491	216491	383550
29184	47619	32	applied	\N	\N	\N	\N	216493	216493	383552
29184	47622	33	applied	\N	\N	\N	\N	216494	216494	383553
29184	47626	34	applied	\N	\N	\N	\N	216495	216495	383554
29184	47631	35	applied	\N	\N	\N	\N	216496	216496	383555
29184	47633	36	applied	\N	\N	\N	\N	216497	216497	383556
29184	47634	37	applied	\N	\N	\N	\N	216498	216498	383557
29184	47651	38	applied	\N	\N	\N	\N	216499	216499	383558
29184	47636	39	applied	\N	\N	\N	\N	216500	216500	383559
29184	47637	40	applied	\N	\N	\N	\N	216501	216501	383560
29184	47640	41	applied	\N	\N	\N	\N	216502	216502	383561
29184	47646	42	applied	\N	\N	\N	\N	216503	216503	383562
29184	47647	43	applied	\N	\N	\N	\N	216504	216504	383563
29184	47648	44	applied	\N	\N	\N	\N	216505	216505	383564
29184	47650	45	applied	\N	\N	\N	\N	216506	216506	383565
29184	47653	46	applied	\N	\N	\N	\N	216507	216507	383566
29184	47658	47	applied	\N	\N	\N	\N	216508	216508	383567
29184	47654	49	applied	\N	\N	\N	\N	216510	216510	383569
29184	47656	50	applied	\N	\N	\N	\N	216511	216511	383570
29184	47659	51	applied	\N	\N	\N	\N	216512	216512	383571
29184	47661	52	applied	\N	\N	\N	\N	216513	216513	383572
29184	47664	53	applied	\N	\N	\N	\N	216514	216514	383573
29186	47665	0	applied	\N	\N	\N	\N	216521	216521	383580
29186	47666	1	applied	\N	\N	\N	\N	216522	216522	383581
29186	47667	2	applied	\N	\N	\N	\N	216523	216523	383582
29186	47668	3	applied	\N	\N	\N	\N	216524	216524	383583
29186	47669	4	applied	\N	\N	\N	\N	216525	216525	383584
29186	47670	5	applied	\N	\N	\N	\N	216526	216526	383585
29187	47665	0	applied	\N	\N	\N	\N	216527	216527	383586
29187	47666	1	applied	\N	\N	\N	\N	216528	216528	383587
29187	47667	2	applied	\N	\N	\N	\N	216529	216529	383588
29187	47668	3	applied	\N	\N	\N	\N	216530	216530	383589
29187	47669	4	applied	\N	\N	\N	\N	216531	216531	383590
29188	47671	0	applied	\N	\N	\N	\N	216533	216533	383592
29188	47672	1	applied	\N	\N	\N	\N	216534	216534	383593
29188	47673	2	applied	\N	\N	\N	\N	216535	216535	383594
29189	47674	0	applied	\N	\N	\N	\N	216536	216536	383595
29189	47675	1	applied	\N	\N	\N	\N	216537	216537	383596
29191	47676	0	applied	\N	\N	\N	\N	216542	216542	383601
29191	47677	1	applied	\N	\N	\N	\N	216543	216543	383602
29191	47678	2	applied	\N	\N	\N	\N	216544	216544	383603
29191	47679	3	applied	\N	\N	\N	\N	216545	216545	383604
29194	47680	0	applied	\N	\N	\N	\N	216550	216550	383609
29194	47681	1	applied	\N	\N	\N	\N	216551	216551	383610
29194	47682	2	applied	\N	\N	\N	\N	216552	216552	383611
29194	47683	3	applied	\N	\N	\N	\N	216553	216553	383612
29194	47684	4	applied	\N	\N	\N	\N	216554	216554	383613
29197	47685	0	applied	\N	\N	\N	\N	216563	216563	383622
29197	47686	1	applied	\N	\N	\N	\N	216564	216564	383623
29197	47688	3	applied	\N	\N	\N	\N	216566	216566	383625
29200	47689	0	applied	\N	\N	\N	\N	216583	216583	383642
29200	47690	1	applied	\N	\N	\N	\N	216584	216584	383643
29200	47691	2	applied	\N	\N	\N	\N	216585	216585	383644
29200	47692	3	applied	\N	\N	\N	\N	216586	216586	383645
29200	47693	4	applied	\N	\N	\N	\N	216587	216587	383646
29200	47694	5	applied	\N	\N	\N	\N	216588	216588	383647
29200	47695	7	applied	\N	\N	\N	\N	216589	216589	383648
29200	47696	8	applied	\N	\N	\N	\N	216590	216590	383649
29202	47689	0	applied	\N	\N	\N	\N	216599	216599	383658
29202	47690	1	applied	\N	\N	\N	\N	216600	216600	383659
29202	47691	2	applied	\N	\N	\N	\N	216601	216601	383660
29202	47692	3	applied	\N	\N	\N	\N	216602	216602	383661
29202	47693	4	applied	\N	\N	\N	\N	216603	216603	383662
29202	47694	5	applied	\N	\N	\N	\N	216604	216604	383663
29202	47695	7	applied	\N	\N	\N	\N	216605	216605	383664
29203	47689	0	applied	\N	\N	\N	\N	216607	216607	383666
29203	47690	1	applied	\N	\N	\N	\N	216608	216608	383667
29203	47691	2	applied	\N	\N	\N	\N	216609	216609	383668
29203	47692	3	applied	\N	\N	\N	\N	216610	216610	383669
29205	47697	0	applied	\N	\N	\N	\N	216621	216621	383680
29205	47698	1	applied	\N	\N	\N	\N	216622	216622	383681
29205	47699	2	applied	\N	\N	\N	\N	216623	216623	383682
29205	47695	3	applied	\N	\N	\N	\N	216624	216624	383683
29205	47696	4	applied	\N	\N	\N	\N	216625	216625	383684
29205	47700	5	applied	\N	\N	\N	\N	216626	216626	383685
29210	47701	0	applied	\N	\N	\N	\N	216767	216767	383826
29210	47702	1	applied	\N	\N	\N	\N	216768	216768	383827
29210	47703	2	applied	\N	\N	\N	\N	216769	216769	383828
29212	47704	0	applied	\N	\N	\N	\N	216773	216773	383832
29212	47705	1	applied	\N	\N	\N	\N	216774	216774	383833
29212	47706	2	applied	\N	\N	\N	\N	216775	216775	383834
29214	47708	1	applied	\N	\N	\N	\N	216779	216779	383838
29214	47709	2	applied	\N	\N	\N	\N	216780	216780	383839
29214	47705	3	applied	\N	\N	\N	\N	216781	216781	383840
29216	47710	0	applied	\N	\N	\N	\N	216786	216786	383845
29216	47711	1	applied	\N	\N	\N	\N	216787	216787	383846
29216	47712	2	applied	\N	\N	\N	\N	216788	216788	383847
29219	47713	0	applied	\N	\N	\N	\N	216794	216794	383853
29219	47714	1	applied	\N	\N	\N	\N	216795	216795	383854
29221	47713	0	applied	\N	\N	\N	\N	216799	216799	383858
29221	47715	1	applied	\N	\N	\N	\N	216800	216800	383859
29221	47714	2	applied	\N	\N	\N	\N	216801	216801	383860
29228	47722	0	applied	\N	\N	\N	\N	216819	216819	383878
29228	47723	1	applied	\N	\N	\N	\N	216820	216820	383879
29228	47724	2	applied	\N	\N	\N	\N	216821	216821	383880
29179	47661	1	applied	\N	\N	\N	\N	216445	216445	383506
29179	47662	2	applied	\N	\N	\N	\N	216446	216446	383507
29183	47664	1	applied	\N	\N	\N	\N	216460	216460	383519
29185	47665	0	applied	\N	\N	\N	\N	216515	216515	383574
29185	47666	1	applied	\N	\N	\N	\N	216516	216516	383575
29185	47667	2	applied	\N	\N	\N	\N	216517	216517	383576
29185	47668	3	applied	\N	\N	\N	\N	216518	216518	383577
29185	47669	4	applied	\N	\N	\N	\N	216519	216519	383578
29185	47670	5	applied	\N	\N	\N	\N	216520	216520	383579
29190	47676	0	applied	\N	\N	\N	\N	216538	216538	383597
29190	47677	1	applied	\N	\N	\N	\N	216539	216539	383598
29190	47678	2	applied	\N	\N	\N	\N	216540	216540	383599
29190	47679	3	applied	\N	\N	\N	\N	216541	216541	383600
29192	47676	0	applied	\N	\N	\N	\N	216546	216546	383605
29192	47677	1	applied	\N	\N	\N	\N	216547	216547	383606
29192	47678	2	applied	\N	\N	\N	\N	216548	216548	383607
29192	47679	3	applied	\N	\N	\N	\N	216549	216549	383608
29196	47680	0	applied	\N	\N	\N	\N	216560	216560	383619
29203	47694	5	applied	\N	\N	\N	\N	216612	216612	383671
29206	47697	0	applied	\N	\N	\N	\N	216627	216627	383686
29208	47550	0	applied	\N	\N	\N	\N	216639	216639	383698
29208	47551	1	applied	\N	\N	\N	\N	216640	216640	383699
29208	47554	2	applied	\N	\N	\N	\N	216641	216641	383700
29208	47555	3	applied	\N	\N	\N	\N	216642	216642	383701
29208	47562	4	applied	\N	\N	\N	\N	216643	216643	383702
29208	47563	5	applied	\N	\N	\N	\N	216644	216644	383703
29208	47597	58	applied	\N	\N	\N	\N	216697	216697	383756
29208	47607	59	applied	\N	\N	\N	\N	216698	216698	383757
29208	47687	61	applied	\N	\N	\N	\N	216700	216700	383759
29208	47699	62	applied	\N	\N	\N	\N	216701	216701	383760
29208	47569	63	applied	\N	\N	\N	\N	216702	216702	383761
29208	47570	64	applied	\N	\N	\N	\N	216703	216703	383762
29208	47571	65	applied	\N	\N	\N	\N	216704	216704	383763
29208	47579	66	applied	\N	\N	\N	\N	216705	216705	383764
29208	47580	67	applied	\N	\N	\N	\N	216706	216706	383765
29208	47587	68	applied	\N	\N	\N	\N	216707	216707	383766
29208	47588	69	applied	\N	\N	\N	\N	216708	216708	383767
29208	47591	70	applied	\N	\N	\N	\N	216709	216709	383768
29208	47598	71	applied	\N	\N	\N	\N	216710	216710	383769
29208	47599	72	applied	\N	\N	\N	\N	216711	216711	383770
29208	47603	73	applied	\N	\N	\N	\N	216712	216712	383771
29208	47608	74	applied	\N	\N	\N	\N	216713	216713	383772
29208	47612	75	applied	\N	\N	\N	\N	216714	216714	383773
29208	47613	76	applied	\N	\N	\N	\N	216715	216715	383774
29208	47623	78	applied	\N	\N	\N	\N	216717	216717	383776
29208	47625	79	applied	\N	\N	\N	\N	216718	216718	383777
29208	47630	80	applied	\N	\N	\N	\N	216719	216719	383778
29208	47632	81	applied	\N	\N	\N	\N	216720	216720	383779
29208	47638	82	applied	\N	\N	\N	\N	216721	216721	383780
29208	47639	84	applied	\N	\N	\N	\N	216722	216722	383781
29208	47644	85	applied	\N	\N	\N	\N	216723	216723	383782
29208	47645	86	applied	\N	\N	\N	\N	216724	216724	383783
29208	47651	87	applied	\N	\N	\N	\N	216725	216725	383784
29208	47552	88	applied	\N	\N	\N	\N	216726	216726	383785
29208	47553	89	applied	\N	\N	\N	\N	216727	216727	383786
29208	47560	90	applied	\N	\N	\N	\N	216728	216728	383787
29208	47561	91	applied	\N	\N	\N	\N	216729	216729	383788
29208	47565	92	applied	\N	\N	\N	\N	216730	216730	383789
29180	47661	1	applied	\N	\N	\N	\N	216448	216448	383509
29180	47662	2	applied	\N	\N	\N	\N	216449	216449	383510
29199	47691	2	applied	\N	\N	\N	\N	216577	216577	383636
29199	47692	3	applied	\N	\N	\N	\N	216578	216578	383637
29199	47693	4	applied	\N	\N	\N	\N	216579	216579	383638
29199	47694	5	applied	\N	\N	\N	\N	216580	216580	383639
29199	47695	7	applied	\N	\N	\N	\N	216581	216581	383640
29199	47696	8	applied	\N	\N	\N	\N	216582	216582	383641
29207	47697	0	applied	\N	\N	\N	\N	216633	216633	383692
29208	47567	93	applied	\N	\N	\N	\N	216731	216731	383790
29208	47568	94	applied	\N	\N	\N	\N	216732	216732	383791
29208	47573	95	applied	\N	\N	\N	\N	216733	216733	383792
29208	47577	96	applied	\N	\N	\N	\N	216734	216734	383793
29208	47582	98	applied	\N	\N	\N	\N	216736	216736	383795
29208	47585	99	applied	\N	\N	\N	\N	216737	216737	383796
29208	47590	100	applied	\N	\N	\N	\N	216738	216738	383797
29208	47595	101	applied	\N	\N	\N	\N	216739	216739	383798
29208	47596	102	applied	\N	\N	\N	\N	216740	216740	383799
29208	47600	103	applied	\N	\N	\N	\N	216741	216741	383800
29208	47602	104	applied	\N	\N	\N	\N	216742	216742	383801
29208	47605	105	applied	\N	\N	\N	\N	216743	216743	383802
29208	47609	106	applied	\N	\N	\N	\N	216744	216744	383803
29208	47614	107	applied	\N	\N	\N	\N	216745	216745	383804
29208	47615	108	applied	\N	\N	\N	\N	216746	216746	383805
29208	47618	109	applied	\N	\N	\N	\N	216747	216747	383806
29208	47619	110	applied	\N	\N	\N	\N	216748	216748	383807
29208	47622	111	applied	\N	\N	\N	\N	216749	216749	383808
29208	47626	112	applied	\N	\N	\N	\N	216750	216750	383809
29209	47701	0	applied	\N	\N	\N	\N	216764	216764	383823
29209	47703	2	applied	\N	\N	\N	\N	216766	216766	383825
29213	47704	0	applied	\N	\N	\N	\N	216776	216776	383835
29213	47706	1	applied	\N	\N	\N	\N	216777	216777	383836
29215	47707	0	applied	\N	\N	\N	\N	216782	216782	383841
29215	47708	1	applied	\N	\N	\N	\N	216783	216783	383842
29215	47709	2	applied	\N	\N	\N	\N	216784	216784	383843
29215	47705	3	applied	\N	\N	\N	\N	216785	216785	383844
29217	47710	0	applied	\N	\N	\N	\N	216789	216789	383848
29217	47711	1	applied	\N	\N	\N	\N	216790	216790	383849
29217	47712	2	applied	\N	\N	\N	\N	216791	216791	383850
29229	47722	0	applied	\N	\N	\N	\N	216824	216824	383883
29229	47723	1	applied	\N	\N	\N	\N	216825	216825	383884
29229	47724	2	applied	\N	\N	\N	\N	216826	216826	383885
29229	47725	3	applied	\N	\N	\N	\N	216827	216827	383886
29229	47726	4	applied	\N	\N	\N	\N	216828	216828	383887
29231	47727	0	applied	\N	\N	\N	\N	216833	216833	383892
29231	47729	2	applied	\N	\N	\N	\N	216835	216835	383894
29231	47730	3	applied	\N	\N	\N	\N	216836	216836	383895
29236	47747	0	applied	\N	\N	\N	\N	216857	216857	383916
29236	47748	1	applied	\N	\N	\N	\N	216858	216858	383917
29236	47749	2	applied	\N	\N	\N	\N	216859	216859	383918
29236	47750	3	applied	\N	\N	\N	\N	216860	216860	383919
29240	47751	0	applied	\N	\N	\N	\N	216873	216873	383932
29240	47752	1	applied	\N	\N	\N	\N	216874	216874	383933
29243	47756	0	applied	\N	\N	\N	\N	216881	216881	383940
29243	47757	1	applied	\N	\N	\N	\N	216882	216882	383941
29243	47758	2	applied	\N	\N	\N	\N	216883	216883	383942
29245	47759	0	applied	\N	\N	\N	\N	216887	216887	383946
29245	47760	1	applied	\N	\N	\N	\N	216888	216888	383947
29245	47761	2	applied	\N	\N	\N	\N	216889	216889	383948
29259	47786	0	applied	\N	\N	\N	\N	216932	216932	383991
29259	47787	1	applied	\N	\N	\N	\N	216933	216933	383992
29263	47796	0	applied	\N	\N	\N	\N	216954	216954	384013
29263	47797	1	applied	\N	\N	\N	\N	216955	216955	384014
29263	47798	2	applied	\N	\N	\N	\N	216956	216956	384015
29263	47799	3	applied	\N	\N	\N	\N	216957	216957	384016
29263	47800	4	applied	\N	\N	\N	\N	216958	216958	384017
29263	47801	5	applied	\N	\N	\N	\N	216959	216959	384018
29263	47802	6	applied	\N	\N	\N	\N	216960	216960	384019
29263	47803	7	applied	\N	\N	\N	\N	216961	216961	384020
29263	47804	8	applied	\N	\N	\N	\N	216962	216962	384021
29263	47805	9	applied	\N	\N	\N	\N	216963	216963	384022
29263	47806	10	applied	\N	\N	\N	\N	216964	216964	384023
29263	47807	11	applied	\N	\N	\N	\N	216965	216965	384024
29268	47812	0	applied	\N	\N	\N	\N	216993	216993	384051
29268	47813	1	applied	\N	\N	\N	\N	216994	216994	384052
29268	47814	2	applied	\N	\N	\N	\N	216995	216995	384053
29268	47815	3	applied	\N	\N	\N	\N	216996	216996	384054
29273	47831	1	applied	\N	\N	\N	\N	217048	217048	384106
29273	47832	2	applied	\N	\N	\N	\N	217049	217049	384107
29273	47833	3	applied	\N	\N	\N	\N	217050	217050	384108
29273	47834	4	applied	\N	\N	\N	\N	217051	217051	384109
29273	47835	5	applied	\N	\N	\N	\N	217052	217052	384110
29276	47836	0	applied	\N	\N	\N	\N	217181	217181	384238
29276	47837	1	applied	\N	\N	\N	\N	217182	217182	384239
29276	47838	2	applied	\N	\N	\N	\N	217183	217183	384240
29282	47852	0	applied	\N	\N	\N	\N	217311	217311	384368
29282	47853	1	applied	\N	\N	\N	\N	217312	217312	384369
29282	47854	2	applied	\N	\N	\N	\N	217313	217313	384370
29286	47855	0	applied	\N	\N	\N	\N	217323	217323	384380
29286	47856	1	applied	\N	\N	\N	\N	217324	217324	384381
29286	47857	2	applied	\N	\N	\N	\N	217325	217325	384382
29288	47855	0	applied	\N	\N	\N	\N	217329	217329	384386
29288	47856	1	applied	\N	\N	\N	\N	217330	217330	384387
29290	47865	0	applied	\N	\N	\N	\N	217339	217339	384396
29290	47866	1	applied	\N	\N	\N	\N	217340	217340	384397
29292	47867	0	applied	\N	\N	\N	\N	217343	217343	384400
29292	47868	2	applied	\N	\N	\N	\N	217344	217344	384401
29292	47869	3	applied	\N	\N	\N	\N	217345	217345	384402
29294	47867	0	applied	\N	\N	\N	\N	217349	217349	384406
29294	47868	2	applied	\N	\N	\N	\N	217350	217350	384407
29294	47869	3	applied	\N	\N	\N	\N	217351	217351	384408
29296	47870	0	applied	\N	\N	\N	\N	217355	217355	384412
29296	47871	1	applied	\N	\N	\N	\N	217356	217356	384413
29296	47872	2	applied	\N	\N	\N	\N	217357	217357	384414
29296	47873	3	applied	\N	\N	\N	\N	217358	217358	384415
29299	47877	0	applied	\N	\N	\N	\N	217367	217367	384424
29299	47878	1	applied	\N	\N	\N	\N	217368	217368	384425
29196	47684	2	applied	\N	\N	\N	\N	216562	216562	383621
29199	47689	0	applied	\N	\N	\N	\N	216575	216575	383634
29208	47637	117	applied	\N	\N	\N	\N	216755	216755	383814
29208	47640	118	applied	\N	\N	\N	\N	216756	216756	383815
29208	47646	119	applied	\N	\N	\N	\N	216757	216757	383816
29208	47647	120	applied	\N	\N	\N	\N	216758	216758	383817
29208	47648	121	applied	\N	\N	\N	\N	216759	216759	383818
29208	47650	122	applied	\N	\N	\N	\N	216760	216760	383819
29208	47653	123	applied	\N	\N	\N	\N	216761	216761	383820
29208	47658	124	applied	\N	\N	\N	\N	216762	216762	383821
29208	47662	125	applied	\N	\N	\N	\N	216763	216763	383822
29211	47701	0	applied	\N	\N	\N	\N	216770	216770	383829
29211	47702	1	applied	\N	\N	\N	\N	216771	216771	383830
29211	47703	2	applied	\N	\N	\N	\N	216772	216772	383831
29223	47716	0	applied	\N	\N	\N	\N	216804	216804	383863
29223	47717	1	applied	\N	\N	\N	\N	216805	216805	383864
29225	47719	0	applied	\N	\N	\N	\N	216810	216810	383869
29225	47720	1	applied	\N	\N	\N	\N	216811	216811	383870
29225	47721	2	applied	\N	\N	\N	\N	216812	216812	383871
29227	47719	0	applied	\N	\N	\N	\N	216816	216816	383875
29227	47720	1	applied	\N	\N	\N	\N	216817	216817	383876
29227	47721	2	applied	\N	\N	\N	\N	216818	216818	383877
29228	47725	3	applied	\N	\N	\N	\N	216822	216822	383881
29228	47726	4	applied	\N	\N	\N	\N	216823	216823	383882
29230	47727	0	applied	\N	\N	\N	\N	216829	216829	383888
29230	47728	1	applied	\N	\N	\N	\N	216830	216830	383889
29230	47729	2	applied	\N	\N	\N	\N	216831	216831	383890
29230	47730	3	applied	\N	\N	\N	\N	216832	216832	383891
29232	47731	0	applied	\N	\N	\N	\N	216837	216837	383896
29232	47732	1	applied	\N	\N	\N	\N	216838	216838	383897
29232	47733	2	applied	\N	\N	\N	\N	216839	216839	383898
29234	47740	0	applied	\N	\N	\N	\N	216846	216846	383905
29234	47742	2	applied	\N	\N	\N	\N	216848	216848	383907
29234	47743	3	applied	\N	\N	\N	\N	216849	216849	383908
29234	47744	4	applied	\N	\N	\N	\N	216850	216850	383909
29234	47745	5	applied	\N	\N	\N	\N	216851	216851	383910
29234	47746	6	applied	\N	\N	\N	\N	216852	216852	383911
29237	47747	0	applied	\N	\N	\N	\N	216861	216861	383920
29237	47748	1	applied	\N	\N	\N	\N	216862	216862	383921
29237	47749	2	applied	\N	\N	\N	\N	216863	216863	383922
29237	47750	3	applied	\N	\N	\N	\N	216864	216864	383923
29238	47747	0	applied	\N	\N	\N	\N	216865	216865	383924
29238	47748	1	applied	\N	\N	\N	\N	216866	216866	383925
29238	47749	2	applied	\N	\N	\N	\N	216867	216867	383926
29238	47750	3	applied	\N	\N	\N	\N	216868	216868	383927
29239	47747	0	applied	\N	\N	\N	\N	216869	216869	383928
29239	47748	1	applied	\N	\N	\N	\N	216870	216870	383929
29239	47749	2	applied	\N	\N	\N	\N	216871	216871	383930
29244	47757	1	applied	\N	\N	\N	\N	216885	216885	383944
29244	47758	2	applied	\N	\N	\N	\N	216886	216886	383945
29247	47768	0	applied	\N	\N	\N	\N	216896	216896	383955
29247	47769	1	applied	\N	\N	\N	\N	216897	216897	383956
29247	47770	2	applied	\N	\N	\N	\N	216898	216898	383957
29247	47771	3	applied	\N	\N	\N	\N	216899	216899	383958
29249	47768	0	applied	\N	\N	\N	\N	216904	216904	383963
29249	47770	1	applied	\N	\N	\N	\N	216905	216905	383964
29249	47771	2	applied	\N	\N	\N	\N	216906	216906	383965
29251	47772	0	applied	\N	\N	\N	\N	216909	216909	383968
29251	47773	1	applied	\N	\N	\N	\N	216910	216910	383969
29254	47781	0	applied	\N	\N	\N	\N	216918	216918	383977
29254	47782	1	applied	\N	\N	\N	\N	216919	216919	383978
29254	47783	2	applied	\N	\N	\N	\N	216920	216920	383979
29256	47784	0	applied	\N	\N	\N	\N	216923	216923	383982
29256	47782	1	applied	\N	\N	\N	\N	216924	216924	383983
29258	47786	0	applied	\N	\N	\N	\N	216929	216929	383988
29258	47787	1	applied	\N	\N	\N	\N	216930	216930	383989
29258	47788	2	applied	\N	\N	\N	\N	216931	216931	383990
29262	47796	0	applied	\N	\N	\N	\N	216942	216942	384001
29262	47797	1	applied	\N	\N	\N	\N	216943	216943	384002
29262	47798	2	applied	\N	\N	\N	\N	216944	216944	384003
29262	47799	3	applied	\N	\N	\N	\N	216945	216945	384004
29262	47800	4	applied	\N	\N	\N	\N	216946	216946	384005
29262	47801	5	applied	\N	\N	\N	\N	216947	216947	384006
29262	47802	6	applied	\N	\N	\N	\N	216948	216948	384007
29262	47803	7	applied	\N	\N	\N	\N	216949	216949	384008
29262	47804	8	applied	\N	\N	\N	\N	216950	216950	384009
29262	47805	9	applied	\N	\N	\N	\N	216951	216951	384010
29262	47806	10	applied	\N	\N	\N	\N	216952	216952	384011
29262	47807	11	applied	\N	\N	\N	\N	216953	216953	384012
29271	47793	0	applied	\N	\N	\N	\N	217015	217015	384073
29271	47642	2	applied	\N	\N	\N	\N	217017	217017	384075
29271	47643	3	applied	\N	\N	\N	\N	217018	217018	384076
29271	47649	4	applied	\N	\N	\N	\N	217019	217019	384077
29271	47652	5	applied	\N	\N	\N	\N	217020	217020	384078
29271	47655	6	applied	\N	\N	\N	\N	217021	217021	384079
29271	47657	7	applied	\N	\N	\N	\N	217022	217022	384080
29271	47660	8	applied	\N	\N	\N	\N	217023	217023	384081
29271	47663	9	applied	\N	\N	\N	\N	217024	217024	384082
29271	47665	10	applied	\N	\N	\N	\N	217025	217025	384083
29271	47666	11	applied	\N	\N	\N	\N	217026	217026	384084
29271	47671	12	applied	\N	\N	\N	\N	217027	217027	384085
29271	47674	13	applied	\N	\N	\N	\N	217028	217028	384086
29271	47676	14	applied	\N	\N	\N	\N	217029	217029	384087
29271	47680	15	applied	\N	\N	\N	\N	217030	217030	384088
29271	47681	16	applied	\N	\N	\N	\N	217031	217031	384089
29271	47685	17	applied	\N	\N	\N	\N	217032	217032	384090
29271	47690	19	applied	\N	\N	\N	\N	217034	217034	384092
29275	47836	0	applied	\N	\N	\N	\N	217178	217178	384235
29275	47837	1	applied	\N	\N	\N	\N	217179	217179	384236
29275	47838	2	applied	\N	\N	\N	\N	217180	217180	384237
29280	47845	0	applied	\N	\N	\N	\N	217301	217301	384358
29280	47846	1	applied	\N	\N	\N	\N	217302	217302	384359
29280	47847	2	applied	\N	\N	1000000000	\N	217303	217303	384360
29280	47848	3	applied	\N	\N	\N	\N	217304	217304	384361
29280	47849	4	applied	\N	\N	\N	\N	217305	217305	384362
29280	47850	5	applied	\N	\N	\N	\N	217306	217306	384363
29280	47851	6	applied	\N	\N	\N	\N	217307	217307	384364
29283	47852	0	applied	\N	\N	\N	\N	217314	217314	384371
29283	47853	1	applied	\N	\N	\N	\N	217315	217315	384372
29283	47854	2	applied	\N	\N	\N	\N	217316	217316	384373
29285	47852	0	applied	\N	\N	\N	\N	217320	217320	384377
29285	47853	1	applied	\N	\N	\N	\N	217321	217321	384378
29208	47636	116	applied	\N	\N	\N	\N	216754	216754	383813
29241	47755	2	applied	\N	\N	\N	\N	216877	216877	383936
29246	47762	0	applied	\N	\N	\N	\N	216890	216890	383949
29246	47763	1	applied	\N	\N	\N	\N	216891	216891	383950
29246	47764	2	applied	\N	\N	\N	\N	216892	216892	383951
29246	47765	3	applied	\N	\N	\N	\N	216893	216893	383952
29246	47766	4	applied	\N	\N	\N	\N	216894	216894	383953
29246	47767	5	applied	\N	\N	\N	\N	216895	216895	383954
29250	47772	0	applied	\N	\N	\N	\N	216907	216907	383966
29250	47773	1	applied	\N	\N	\N	\N	216908	216908	383967
29253	47777	0	applied	\N	\N	\N	\N	216914	216914	383973
29253	47778	1	applied	\N	\N	\N	\N	216915	216915	383974
29253	47779	2	applied	\N	\N	\N	\N	216916	216916	383975
29253	47780	3	applied	\N	\N	\N	\N	216917	216917	383976
29260	47790	1	applied	\N	\N	\N	\N	216936	216936	383995
29260	47791	2	applied	\N	\N	\N	\N	216937	216937	383996
29264	47796	0	applied	\N	\N	\N	\N	216966	216966	384025
29264	47797	1	applied	\N	\N	\N	\N	216967	216967	384026
29264	47798	2	applied	\N	\N	\N	\N	216968	216968	384027
29264	47799	3	applied	\N	\N	\N	\N	216969	216969	384028
29264	47800	4	applied	\N	\N	\N	\N	216970	216970	384029
29264	47801	5	applied	\N	\N	\N	\N	216971	216971	384030
29264	47802	6	applied	\N	\N	\N	\N	216972	216972	384031
29264	47803	7	applied	\N	\N	\N	\N	216973	216973	384032
29264	47804	8	applied	\N	\N	\N	\N	216974	216974	384033
29264	47805	9	applied	\N	\N	\N	\N	216975	216975	384034
29264	47806	10	applied	\N	\N	\N	\N	216976	216976	384035
29264	47807	11	applied	\N	\N	\N	\N	216977	216977	384036
29266	47367	0	applied	\N	\N	\N	\N	216982	216982	216982
29266	47457	1	applied	\N	\N	\N	\N	216983	216983	384041
29266	47351	3	applied	\N	\N	\N	\N	216985	216985	384043
29266	47742	4	applied	\N	\N	\N	\N	216986	216986	384044
29269	47812	0	applied	\N	\N	\N	\N	216997	216997	384055
29269	47813	1	applied	\N	\N	\N	\N	216998	216998	384056
29269	47814	2	applied	\N	\N	\N	\N	216999	216999	384057
29269	47815	3	applied	\N	\N	\N	\N	217000	217000	384058
29269	47816	4	applied	\N	\N	\N	\N	217001	217001	384059
29269	47817	5	applied	\N	\N	\N	\N	217002	217002	384060
29274	47306	6	applied	\N	\N	\N	\N	217059	217059	384116
29274	47307	7	applied	\N	\N	\N	\N	217060	217060	384117
29274	47311	8	applied	\N	\N	\N	\N	217061	217061	384118
29274	47315	9	applied	\N	\N	\N	\N	217062	217062	384119
29274	47318	10	applied	\N	\N	\N	\N	217063	217063	384120
29274	47319	11	applied	\N	\N	\N	\N	217064	217064	384121
29274	47324	12	applied	\N	\N	\N	\N	217065	217065	384122
29274	47328	13	applied	\N	\N	\N	\N	217066	217066	384123
29274	47334	15	applied	\N	\N	\N	\N	217068	217068	384125
29274	47337	16	applied	\N	\N	\N	\N	217069	217069	384126
29274	47340	17	applied	\N	\N	\N	\N	217070	217070	384127
29274	47342	18	applied	\N	\N	\N	\N	217071	217071	384128
29274	47346	19	applied	\N	\N	\N	\N	217072	217072	384129
29274	47347	20	applied	\N	\N	\N	\N	217073	217073	384130
29274	47352	21	applied	\N	\N	\N	\N	217074	217074	384131
29274	47353	22	applied	\N	\N	\N	\N	217075	217075	384132
29274	47358	23	applied	\N	\N	\N	\N	217076	217076	384133
29274	47359	24	applied	\N	\N	\N	\N	217077	217077	384134
29274	47364	25	applied	\N	\N	\N	\N	217078	217078	384135
29279	47839	0	applied	\N	\N	\N	\N	217295	217295	384352
29279	47840	1	applied	\N	\N	\N	\N	217296	217296	384353
29279	47841	2	applied	\N	\N	\N	\N	217297	217297	384354
29279	47842	3	applied	\N	\N	\N	\N	217298	217298	384355
29279	47843	4	applied	\N	\N	\N	\N	217299	217299	384356
29281	47852	0	applied	\N	\N	\N	\N	217308	217308	384365
29281	47853	1	applied	\N	\N	\N	\N	217309	217309	384366
29281	47854	2	applied	\N	\N	\N	\N	217310	217310	384367
29287	47855	0	applied	\N	\N	\N	\N	217326	217326	384383
29287	47856	1	applied	\N	\N	\N	\N	217327	217327	384384
29287	47857	2	applied	\N	\N	\N	\N	217328	217328	384385
29293	47867	0	applied	\N	\N	\N	\N	217346	217346	384403
29293	47868	2	applied	\N	\N	\N	\N	217347	217347	384404
29293	47869	3	applied	\N	\N	\N	\N	217348	217348	384405
29295	47867	0	applied	\N	\N	\N	\N	217352	217352	384409
29295	47868	2	applied	\N	\N	\N	\N	217353	217353	384410
29295	47869	3	applied	\N	\N	\N	\N	217354	217354	384411
29297	47874	0	applied	\N	\N	\N	\N	217359	217359	384416
29297	47875	1	applied	\N	\N	\N	\N	217360	217360	384417
29297	47876	2	applied	\N	\N	\N	\N	217361	217361	384418
29300	47877	0	applied	\N	\N	\N	\N	217372	217372	384429
29300	47879	2	applied	\N	\N	\N	\N	217374	217374	384431
29300	47880	3	applied	\N	\N	\N	\N	217375	217375	384432
29300	47881	4	applied	\N	\N	\N	\N	217376	217376	384433
29303	47882	0	applied	\N	\N	\N	\N	217387	217387	384444
29303	47883	1	applied	\N	\N	\N	\N	217388	217388	384445
29303	47884	2	applied	\N	\N	\N	\N	217389	217389	384446
29303	47885	3	applied	\N	\N	\N	\N	217390	217390	384447
29310	47896	0	applied	\N	\N	\N	\N	217409	217409	384466
29310	47897	1	applied	\N	\N	\N	\N	217410	217410	384467
29310	47898	2	applied	\N	\N	\N	\N	217411	217411	384468
29317	47911	0	applied	\N	\N	\N	\N	217427	217427	384484
29317	47912	1	applied	\N	\N	\N	\N	217428	217428	384485
29317	47913	2	applied	\N	\N	\N	\N	217429	217429	384486
29317	47914	3	applied	\N	\N	\N	\N	217430	217430	384487
29321	47918	0	applied	\N	\N	\N	\N	217439	217439	384496
29321	47917	1	applied	\N	\N	\N	\N	217440	217440	384497
29324	47924	0	applied	\N	\N	\N	\N	217449	217449	384506
29324	47925	1	applied	\N	\N	\N	\N	217450	217450	384507
29324	47926	2	applied	\N	\N	\N	\N	217451	217451	384508
29326	47927	0	applied	\N	\N	\N	\N	217455	217455	384512
29326	47928	1	applied	\N	\N	\N	\N	217456	217456	384513
29330	47936	0	applied	\N	\N	\N	\N	217468	217468	384525
29330	47937	1	applied	\N	\N	\N	\N	217469	217469	384526
29330	47938	2	applied	\N	\N	1000000000	\N	217470	217470	384527
29330	47939	3	applied	\N	\N	1000000000	\N	217471	217471	384528
29330	47940	4	applied	\N	\N	\N	\N	217472	217472	384529
29333	47941	0	applied	\N	\N	\N	\N	217601	217601	384658
29333	47942	1	applied	\N	\N	\N	\N	217602	217602	384659
29333	47943	2	applied	\N	\N	\N	\N	217603	217603	384660
29337	47948	0	applied	\N	\N	\N	\N	217615	217615	384672
29337	47949	1	applied	\N	\N	\N	\N	217616	217616	384673
29337	47950	2	applied	\N	\N	\N	\N	217617	217617	384674
29241	47753	0	applied	\N	\N	\N	\N	216875	216875	383934
29241	47754	1	applied	\N	\N	\N	\N	216876	216876	383935
29274	47380	30	applied	\N	\N	\N	\N	217083	217083	384140
29274	47383	31	applied	\N	\N	\N	\N	217084	217084	384141
29274	47384	32	applied	\N	\N	\N	\N	217085	217085	384142
29274	47389	33	applied	\N	\N	\N	\N	217086	217086	384143
29274	47392	34	applied	\N	\N	\N	\N	217087	217087	384144
29274	47393	35	applied	\N	\N	\N	\N	217088	217088	384145
29274	47398	36	applied	\N	\N	\N	\N	217089	217089	384146
29274	47401	37	applied	\N	\N	\N	\N	217090	217090	384147
29274	47404	38	applied	\N	\N	\N	\N	217091	217091	384148
29274	47405	39	applied	\N	\N	\N	\N	217092	217092	384149
29274	47410	40	applied	\N	\N	\N	\N	217093	217093	384150
29274	47413	41	applied	\N	\N	\N	\N	217094	217094	384151
29274	47414	42	applied	\N	\N	\N	\N	217095	217095	384152
29274	47415	43	applied	\N	\N	\N	\N	217096	217096	384153
29274	47422	44	applied	\N	\N	\N	\N	217097	217097	384154
29274	47426	45	applied	\N	\N	\N	\N	217098	217098	384155
29274	47431	47	applied	\N	\N	\N	\N	217100	217100	384157
29274	47434	48	applied	\N	\N	\N	\N	217101	217101	384158
29274	47438	49	applied	\N	\N	\N	\N	217102	217102	384159
29274	47440	50	applied	\N	\N	\N	\N	217103	217103	384160
29274	47443	51	applied	\N	\N	\N	\N	217104	217104	384161
29274	47447	52	applied	\N	\N	\N	\N	217105	217105	384162
29274	47449	53	applied	\N	\N	\N	\N	217106	217106	384163
29274	47452	54	applied	\N	\N	\N	\N	217107	217107	384164
29274	47456	55	applied	\N	\N	\N	\N	217108	217108	384165
29274	47458	56	applied	\N	\N	\N	\N	217109	217109	384166
29274	47462	57	applied	\N	\N	\N	\N	217110	217110	384167
29274	47465	58	applied	\N	\N	\N	\N	217111	217111	384168
29274	47469	59	applied	\N	\N	\N	\N	217112	217112	384169
29274	47471	60	applied	\N	\N	\N	\N	217113	217113	384170
29274	47472	61	applied	\N	\N	\N	\N	217114	217114	384171
29274	47473	62	applied	\N	\N	\N	\N	217115	217115	384172
29274	47483	65	applied	\N	\N	\N	\N	217117	217117	384174
29274	47487	66	applied	\N	\N	\N	\N	217118	217118	384175
29274	47490	67	applied	\N	\N	\N	\N	217119	217119	384176
29274	47491	68	applied	\N	\N	\N	\N	217120	217120	384177
29274	47495	69	applied	\N	\N	\N	\N	217121	217121	384178
29274	47499	70	applied	\N	\N	\N	\N	217122	217122	384179
29274	47502	71	applied	\N	\N	\N	\N	217123	217123	384180
29274	47503	72	applied	\N	\N	\N	\N	217124	217124	384181
29274	47508	73	applied	\N	\N	\N	\N	217125	217125	384182
29274	47509	74	applied	\N	\N	\N	\N	217126	217126	384183
29274	47510	75	applied	\N	\N	\N	\N	217127	217127	384184
29274	47516	76	applied	\N	\N	\N	\N	217128	217128	384185
29274	47520	77	applied	\N	\N	\N	\N	217129	217129	384186
29274	47521	78	applied	\N	\N	\N	\N	217130	217130	384187
29274	47525	79	applied	\N	\N	\N	\N	217131	217131	384188
29274	47529	80	applied	\N	\N	\N	\N	217132	217132	384189
29274	47533	82	applied	\N	\N	\N	\N	217134	217134	384191
29274	47538	83	applied	\N	\N	\N	\N	217135	217135	384192
29274	47539	84	applied	\N	\N	\N	\N	217136	217136	384193
29274	47540	85	applied	\N	\N	\N	\N	217137	217137	384194
29274	47541	86	applied	\N	\N	\N	\N	217138	217138	384195
29274	47550	87	applied	\N	\N	\N	\N	217139	217139	384196
29274	47551	88	applied	\N	\N	\N	\N	217140	217140	384197
29274	47554	89	applied	\N	\N	\N	\N	217141	217141	384198
29274	47555	90	applied	\N	\N	\N	\N	217142	217142	384199
29274	47562	91	applied	\N	\N	\N	\N	217143	217143	384200
29274	47563	92	applied	\N	\N	\N	\N	217144	217144	384201
29274	47564	93	applied	\N	\N	\N	\N	217145	217145	384202
29274	47572	94	applied	\N	\N	\N	\N	217146	217146	384203
29274	47574	95	applied	\N	\N	\N	\N	217147	217147	384204
29274	47575	96	applied	\N	\N	\N	\N	217148	217148	384205
29274	47581	97	applied	\N	\N	\N	\N	217149	217149	384206
29274	47584	99	applied	\N	\N	\N	\N	217151	217151	384208
29274	47589	100	applied	\N	\N	\N	\N	217152	217152	384209
29274	47592	101	applied	\N	\N	\N	\N	217153	217153	384210
29274	47593	102	applied	\N	\N	\N	\N	217154	217154	384211
29274	47594	103	applied	\N	\N	\N	\N	217155	217155	384212
29274	47601	104	applied	\N	\N	\N	\N	217156	217156	384213
29274	47604	105	applied	\N	\N	\N	\N	217157	217157	384214
29274	47606	106	applied	\N	\N	\N	\N	217158	217158	384215
29274	47610	107	applied	\N	\N	\N	\N	217159	217159	384216
29274	47611	108	applied	\N	\N	\N	\N	217160	217160	384217
29274	47616	109	applied	\N	\N	\N	\N	217161	217161	384218
29274	47617	110	applied	\N	\N	\N	\N	217162	217162	384219
29274	47621	111	applied	\N	\N	\N	\N	217163	217163	384220
29274	47624	112	applied	\N	\N	\N	\N	217164	217164	384221
29274	47627	113	applied	\N	\N	\N	\N	217165	217165	384222
29274	47628	114	applied	\N	\N	\N	\N	217166	217166	384223
29274	47635	116	applied	\N	\N	\N	\N	217168	217168	384225
29274	47641	117	applied	\N	\N	\N	\N	217169	217169	384226
29274	47642	118	applied	\N	\N	\N	\N	217170	217170	384227
29274	47643	119	applied	\N	\N	\N	\N	217171	217171	384228
29274	47649	120	applied	\N	\N	\N	\N	217172	217172	384229
29274	47652	121	applied	\N	\N	\N	\N	217173	217173	384230
29274	47655	122	applied	\N	\N	\N	\N	217174	217174	384231
29274	47657	123	applied	\N	\N	\N	\N	217175	217175	384232
29274	47660	124	applied	\N	\N	\N	\N	217176	217176	384233
29274	47663	125	applied	\N	\N	\N	\N	217177	217177	384234
29277	47836	0	applied	\N	\N	\N	\N	217184	217184	384241
29277	47837	1	applied	\N	\N	\N	\N	217185	217185	384242
29277	47838	2	applied	\N	\N	\N	\N	217186	217186	384243
29278	47731	0	applied	\N	\N	\N	\N	217187	217187	384244
29278	47793	1	applied	\N	\N	\N	\N	217188	217188	384245
29278	47734	2	applied	\N	\N	\N	\N	217189	217189	384246
29278	47740	4	applied	\N	\N	\N	\N	217191	217191	384248
29278	47741	5	applied	\N	\N	\N	\N	217192	217192	384249
29278	47747	6	applied	\N	\N	\N	\N	217193	217193	384250
29278	47751	7	applied	\N	\N	\N	\N	217194	217194	384251
29278	47753	8	applied	\N	\N	\N	\N	217195	217195	384252
29278	47756	9	applied	\N	\N	\N	\N	217196	217196	384253
29278	47759	10	applied	\N	\N	\N	\N	217197	217197	384254
29278	47762	11	applied	\N	\N	\N	\N	217198	217198	384255
29278	47763	12	applied	\N	\N	\N	\N	217199	217199	384256
29278	47768	13	applied	\N	\N	\N	\N	217200	217200	384257
29278	47772	14	applied	\N	\N	\N	\N	217201	217201	384258
29278	47774	15	applied	\N	\N	\N	\N	217202	217202	384259
29278	47777	16	applied	\N	\N	\N	\N	217203	217203	384260
29278	47781	17	applied	\N	\N	\N	\N	217204	217204	384261
29274	47371	27	applied	\N	\N	\N	\N	217080	217080	384137
29274	47373	28	applied	\N	\N	\N	\N	217081	217081	384138
29278	47796	22	applied	\N	\N	\N	\N	217209	217209	384266
29278	47797	23	applied	\N	\N	\N	\N	217210	217210	384267
29278	47798	24	applied	\N	\N	\N	\N	217211	217211	384268
29278	47799	25	applied	\N	\N	\N	\N	217212	217212	384269
29278	47808	26	applied	\N	\N	\N	\N	217213	217213	384270
29278	47812	27	applied	\N	\N	\N	\N	217214	217214	384271
29278	47813	28	applied	\N	\N	\N	\N	217215	217215	384272
29278	47818	29	applied	\N	\N	\N	\N	217216	217216	384273
29278	47819	30	applied	\N	\N	\N	\N	217217	217217	384274
29278	47820	31	applied	\N	\N	\N	\N	217218	217218	384275
29278	47821	32	applied	\N	\N	\N	\N	217219	217219	384276
29278	47830	33	applied	\N	\N	\N	\N	217220	217220	384277
29278	47831	34	applied	\N	\N	\N	\N	217221	217221	384278
29278	47836	35	applied	\N	\N	\N	\N	217222	217222	384279
29278	47732	36	applied	\N	\N	\N	\N	217223	217223	384280
29278	47736	37	applied	\N	\N	\N	\N	217224	217224	384281
29278	47733	39	applied	\N	\N	\N	\N	217226	217226	384283
29278	47737	40	applied	\N	\N	\N	\N	217227	217227	384284
29278	47738	41	applied	\N	\N	\N	\N	217228	217228	384285
29278	47742	42	applied	\N	\N	\N	\N	217229	217229	384286
29278	47739	43	applied	\N	\N	\N	\N	217230	217230	384287
29278	47743	44	applied	\N	\N	\N	\N	217231	217231	384288
29278	47744	45	applied	\N	\N	\N	\N	217232	217232	384289
29278	47749	46	applied	\N	\N	\N	\N	217233	217233	384290
29278	47752	47	applied	\N	\N	\N	\N	217234	217234	384291
29278	47754	48	applied	\N	\N	\N	\N	217235	217235	384292
29278	47757	49	applied	\N	\N	\N	\N	217236	217236	384293
29278	47760	50	applied	\N	\N	\N	\N	217237	217237	384294
29278	47745	51	applied	\N	\N	\N	\N	217238	217238	384295
29278	47746	52	applied	\N	\N	\N	\N	217239	217239	384296
29278	47750	53	applied	\N	\N	\N	\N	217240	217240	384297
29278	47755	54	applied	\N	\N	\N	\N	217241	217241	384298
29278	47764	56	applied	\N	\N	\N	\N	217243	217243	384300
29278	47765	57	applied	\N	\N	\N	\N	217244	217244	384301
29278	47771	58	applied	\N	\N	\N	\N	217245	217245	384302
29278	47766	59	applied	\N	\N	\N	\N	217246	217246	384303
29278	47767	60	applied	\N	\N	\N	\N	217247	217247	384304
29278	47769	61	applied	\N	\N	\N	\N	217248	217248	384305
29278	47773	62	applied	\N	\N	\N	\N	217249	217249	384306
29278	47775	63	applied	\N	\N	\N	\N	217250	217250	384307
29278	47779	64	applied	\N	\N	\N	\N	217251	217251	384308
29278	47782	65	applied	\N	\N	\N	\N	217252	217252	384309
29278	47785	66	applied	\N	\N	\N	\N	217253	217253	384310
29278	47787	67	applied	\N	\N	\N	\N	217254	217254	384311
29278	47790	68	applied	\N	\N	\N	\N	217255	217255	384312
29278	47795	70	applied	\N	\N	\N	\N	217256	217256	384313
29278	47803	71	applied	\N	\N	\N	\N	217257	217257	384314
29278	47804	72	applied	\N	\N	\N	\N	217258	217258	384315
29278	47806	74	applied	\N	\N	\N	\N	217260	217260	384317
29278	47761	75	applied	\N	\N	\N	\N	217261	217261	384318
29278	47770	76	applied	\N	\N	\N	\N	217262	217262	384319
29278	47780	77	applied	\N	\N	\N	\N	217263	217263	384320
29278	47791	78	applied	\N	\N	\N	\N	217264	217264	384321
29278	47807	79	applied	\N	\N	\N	\N	217265	217265	384322
29278	47809	80	applied	\N	\N	\N	\N	217266	217266	384323
29278	47823	81	applied	\N	\N	\N	\N	217267	217267	384324
29278	47833	82	applied	\N	\N	\N	\N	217268	217268	384325
29278	47776	83	applied	\N	\N	\N	\N	217269	217269	384326
29278	47778	84	applied	\N	\N	\N	\N	217270	217270	384327
29278	47783	85	applied	\N	\N	\N	\N	217271	217271	384328
29278	47788	86	applied	\N	\N	\N	\N	217272	217272	384329
29278	47789	87	applied	\N	\N	\N	\N	217273	217273	384330
29278	47800	88	applied	\N	\N	\N	\N	217274	217274	384331
29278	47801	89	applied	\N	\N	\N	\N	217275	217275	384332
29278	47810	91	applied	\N	\N	\N	\N	217277	217277	384334
29278	47814	92	applied	\N	\N	\N	\N	217278	217278	384335
29278	47815	93	applied	\N	\N	\N	\N	217279	217279	384336
29278	47827	94	applied	\N	\N	\N	\N	217280	217280	384337
29278	47828	95	applied	\N	\N	\N	\N	217281	217281	384338
29278	47829	96	applied	\N	\N	\N	\N	217282	217282	384339
29278	47834	97	applied	\N	\N	\N	\N	217283	217283	384340
29278	47837	98	applied	\N	\N	\N	\N	217284	217284	384341
29278	47811	99	applied	\N	\N	\N	\N	217285	217285	384342
29278	47816	100	applied	\N	\N	\N	\N	217286	217286	384343
29278	47817	101	applied	\N	\N	\N	\N	217287	217287	384344
29278	47822	102	applied	\N	\N	\N	\N	217288	217288	384345
29278	47824	103	applied	\N	\N	\N	\N	217289	217289	384346
29278	47825	104	applied	\N	\N	\N	\N	217290	217290	384347
29278	47826	105	applied	\N	\N	\N	\N	217291	217291	384348
29278	47832	106	applied	\N	\N	\N	\N	217292	217292	384349
29278	47838	108	applied	\N	\N	\N	\N	217294	217294	384351
29284	47852	0	applied	\N	\N	\N	\N	217317	217317	384374
29284	47853	1	applied	\N	\N	\N	\N	217318	217318	384375
29284	47854	2	applied	\N	\N	\N	\N	217319	217319	384376
29285	47854	2	applied	\N	\N	\N	\N	217322	217322	384379
29289	47858	0	applied	\N	\N	\N	\N	217332	217332	384389
29289	47859	1	applied	\N	\N	\N	\N	217333	217333	384390
29289	47860	2	applied	\N	\N	\N	\N	217334	217334	384391
29289	47861	3	applied	\N	\N	\N	\N	217335	217335	384392
29289	47862	4	applied	\N	\N	\N	\N	217336	217336	384393
29289	47863	5	applied	\N	\N	\N	\N	217337	217337	384394
29289	47864	6	applied	\N	\N	\N	\N	217338	217338	384395
29291	47865	0	applied	\N	\N	\N	\N	217341	217341	384398
29291	47866	1	applied	\N	\N	\N	\N	217342	217342	384399
29298	47877	0	applied	\N	\N	\N	\N	217362	217362	384419
29298	47878	1	applied	\N	\N	\N	\N	217363	217363	384420
29298	47880	3	applied	\N	\N	\N	\N	217365	217365	384422
29298	47881	4	applied	\N	\N	\N	\N	217366	217366	384423
29304	47886	0	applied	\N	\N	\N	\N	217391	217391	384448
29304	47887	1	applied	\N	\N	\N	\N	217392	217392	384449
29304	47888	2	applied	\N	\N	\N	\N	217393	217393	384450
29304	47889	3	applied	\N	\N	\N	\N	217394	217394	384451
29304	47890	4	applied	\N	\N	\N	\N	217395	217395	384452
29306	47891	0	applied	\N	\N	\N	\N	217400	217400	384457
29306	47892	1	applied	\N	\N	\N	\N	217401	217401	384458
29306	47893	2	applied	\N	\N	\N	\N	217402	217402	384459
29306	47894	3	applied	\N	\N	\N	\N	217403	217403	384460
29311	47899	0	applied	\N	\N	\N	\N	217412	217412	384469
29311	47900	1	applied	\N	\N	\N	\N	217413	217413	384470
29311	47901	2	applied	\N	\N	\N	\N	217414	217414	384471
29278	47786	19	applied	\N	\N	\N	\N	217206	217206	384263
29278	47792	20	applied	\N	\N	\N	\N	217207	217207	384264
29302	47878	1	applied	\N	\N	\N	\N	217383	217383	384440
29302	47879	2	applied	\N	\N	\N	\N	217384	217384	384441
29302	47880	3	applied	\N	\N	\N	\N	217385	217385	384442
29302	47881	4	applied	\N	\N	\N	\N	217386	217386	384443
29305	47891	0	applied	\N	\N	\N	\N	217396	217396	384453
29305	47892	1	applied	\N	\N	\N	\N	217397	217397	384454
29305	47893	2	applied	\N	\N	\N	\N	217398	217398	384455
29305	47894	3	applied	\N	\N	\N	\N	217399	217399	384456
29307	47895	0	applied	\N	\N	\N	\N	217404	217404	384461
29309	47896	0	applied	\N	\N	\N	\N	217406	217406	384463
29309	47897	1	applied	\N	\N	\N	\N	217407	217407	384464
29309	47898	2	applied	\N	\N	\N	\N	217408	217408	384465
29311	47902	3	applied	\N	\N	\N	\N	217415	217415	384472
29311	47903	4	applied	\N	\N	\N	\N	217416	217416	384473
29311	47904	5	applied	\N	\N	\N	\N	217417	217417	384474
29311	47905	6	applied	\N	\N	\N	\N	217418	217418	384475
29315	47909	1	applied	\N	\N	\N	\N	217422	217422	384479
29315	47910	2	applied	\N	\N	\N	\N	217423	217423	384480
29318	47915	0	applied	\N	\N	\N	\N	217431	217431	384488
29318	47916	1	applied	\N	\N	\N	\N	217432	217432	384489
29320	47918	0	applied	\N	\N	\N	\N	217436	217436	384493
29320	47917	1	applied	\N	\N	\N	\N	217437	217437	384494
29320	47919	2	applied	\N	\N	\N	\N	217438	217438	384495
29322	47920	0	applied	\N	\N	\N	\N	217442	217442	384499
29323	47924	0	applied	\N	\N	\N	\N	217446	217446	384503
29323	47925	1	applied	\N	\N	\N	\N	217447	217447	384504
29323	47926	2	applied	\N	\N	\N	\N	217448	217448	384505
29325	47924	0	applied	\N	\N	\N	\N	217452	217452	384509
29325	47925	1	applied	\N	\N	\N	\N	217453	217453	384510
29325	47926	2	applied	\N	\N	\N	\N	217454	217454	384511
29336	47944	0	applied	\N	\N	\N	\N	217611	217611	384668
29336	47945	1	applied	\N	\N	\N	\N	217612	217612	384669
29336	47947	3	applied	\N	\N	\N	\N	217614	217614	384671
29339	47954	0	applied	\N	\N	\N	\N	217625	217625	384682
29339	47955	1	applied	\N	\N	\N	\N	217626	217626	384683
29339	47956	2	applied	\N	\N	\N	\N	217627	217627	384684
29339	47957	3	applied	\N	\N	\N	\N	217628	217628	384685
29341	47961	0	applied	\N	\N	\N	\N	217632	217632	384689
29341	47962	1	applied	\N	\N	\N	\N	217633	217633	384690
29341	47963	2	applied	\N	\N	\N	\N	217634	217634	384691
29344	47964	0	applied	\N	\N	\N	\N	217647	217647	384704
29344	47965	1	applied	\N	\N	\N	\N	217648	217648	384705
29344	47966	2	applied	\N	\N	\N	\N	217649	217649	384706
29344	47967	3	applied	\N	\N	\N	\N	217650	217650	384707
29344	47968	4	applied	\N	\N	\N	\N	217651	217651	384708
29344	47969	5	applied	\N	\N	\N	\N	217652	217652	384709
29345	47970	0	applied	\N	\N	\N	\N	217653	217653	384710
29345	47971	1	applied	\N	\N	\N	\N	217654	217654	384711
29347	47973	0	applied	\N	\N	\N	\N	217659	217659	384716
29347	47974	1	applied	\N	\N	\N	\N	217660	217660	384717
29347	47975	2	applied	\N	\N	\N	\N	217661	217661	384718
29353	47991	0	applied	\N	\N	\N	\N	217689	217689	384746
29353	47992	1	applied	\N	\N	\N	\N	217690	217690	384747
29353	47993	2	applied	\N	\N	\N	\N	217691	217691	384748
29355	47994	0	applied	\N	\N	\N	\N	217695	217695	384752
29355	47995	1	applied	\N	\N	\N	\N	217696	217696	384753
29355	47996	2	applied	\N	\N	\N	\N	217697	217697	384754
29355	47997	3	applied	\N	\N	\N	\N	217698	217698	384755
29358	47998	0	applied	\N	\N	\N	\N	217707	217707	384764
29358	47999	1	applied	\N	\N	\N	\N	217708	217708	384765
29364	48006	0	applied	\N	\N	\N	\N	217720	217720	384777
29364	48007	1	applied	\N	\N	\N	\N	217721	217721	384778
29364	48008	2	applied	\N	\N	\N	\N	217722	217722	384779
29367	48012	0	applied	\N	\N	\N	\N	217729	217729	384786
29367	48014	2	applied	\N	\N	\N	\N	217731	217731	384788
29377	48032	0	applied	\N	\N	\N	\N	217764	217764	384821
29377	48033	1	applied	\N	\N	\N	\N	217765	217765	384822
29377	48034	2	applied	\N	\N	\N	\N	217766	217766	384823
29377	48035	3	applied	\N	\N	\N	\N	217767	217767	384824
29377	48036	4	applied	\N	\N	\N	\N	217768	217768	384825
29377	48037	5	applied	\N	\N	\N	\N	217769	217769	384826
29377	48038	6	applied	\N	\N	\N	\N	217770	217770	384827
29377	48039	7	applied	\N	\N	\N	\N	217771	217771	384828
29377	48040	8	applied	\N	\N	\N	\N	217772	217772	384829
29379	48041	0	applied	\N	\N	\N	\N	217782	217782	384839
29379	48042	1	applied	\N	\N	\N	\N	217783	217783	384840
29379	48043	2	applied	\N	\N	\N	\N	217784	217784	384841
29382	48050	0	applied	\N	\N	\N	\N	217791	217791	384848
29382	48051	1	applied	\N	\N	\N	\N	217792	217792	384849
29382	48052	2	applied	\N	\N	\N	\N	217793	217793	384850
29389	48075	1	applied	\N	\N	\N	\N	217839	217839	384896
29389	48076	2	applied	\N	\N	\N	\N	217840	217840	384897
29389	48077	3	applied	\N	\N	\N	\N	217841	217841	384898
29393	48082	0	applied	\N	\N	\N	\N	217973	217973	385030
29393	48083	1	applied	\N	\N	\N	\N	217974	217974	385031
29395	48084	0	applied	\N	\N	\N	\N	217980	217980	385037
29395	48085	1	applied	\N	\N	\N	\N	217981	217981	385038
29395	48086	2	applied	\N	\N	\N	\N	217982	217982	385039
29395	48087	3	applied	\N	\N	\N	\N	217983	217983	385040
29395	48088	4	applied	\N	\N	\N	\N	217984	217984	385041
29400	48095	0	applied	\N	\N	\N	\N	217997	217997	385054
29400	48096	1	applied	\N	\N	\N	\N	217998	217998	385055
29400	48097	2	applied	\N	\N	\N	\N	217999	217999	385056
29400	48098	3	applied	\N	\N	\N	\N	218000	218000	385057
29400	48099	4	applied	\N	\N	\N	\N	218001	218001	385058
29400	48100	5	applied	\N	\N	\N	\N	218002	218002	385059
29402	48106	1	applied	\N	\N	\N	\N	218008	218008	385065
29404	48105	0	applied	\N	\N	\N	\N	218010	218010	385067
29404	48107	1	applied	\N	\N	\N	\N	218011	218011	385068
29404	48108	2	applied	\N	\N	\N	\N	218012	218012	385069
29404	48109	3	applied	\N	\N	\N	\N	218013	218013	385070
29404	48110	4	applied	\N	\N	\N	\N	218014	218014	385071
29406	48105	0	applied	\N	\N	\N	\N	218048	218048	385105
29406	48107	1	applied	\N	\N	\N	\N	218049	218049	385106
29406	48108	2	applied	\N	\N	\N	\N	218050	218050	385107
29406	48109	3	applied	\N	\N	\N	\N	218051	218051	385108
29406	48110	4	applied	\N	\N	\N	\N	218052	218052	385109
29415	48127	0	applied	\N	\N	\N	\N	218102	218102	385159
29415	48128	1	applied	\N	\N	\N	\N	218103	218103	385160
29415	48129	2	applied	\N	\N	\N	\N	218104	218104	385161
29299	47880	3	applied	\N	\N	\N	\N	217370	217370	384427
29299	47881	4	applied	\N	\N	\N	\N	217371	217371	384428
29301	47881	4	applied	\N	\N	\N	\N	217381	217381	384438
29308	47895	0	applied	\N	\N	\N	\N	217405	217405	384462
29312	47906	0	applied	\N	\N	\N	\N	217419	217419	384476
29312	47907	1	applied	\N	\N	\N	\N	217420	217420	384477
29316	47908	0	applied	\N	\N	\N	\N	217424	217424	384481
29316	47909	1	applied	\N	\N	\N	\N	217425	217425	384482
29316	47910	2	applied	\N	\N	\N	\N	217426	217426	384483
29319	47915	0	applied	\N	\N	\N	\N	217433	217433	384490
29319	47916	1	applied	\N	\N	\N	\N	217434	217434	384491
29319	47917	2	applied	\N	\N	\N	\N	217435	217435	384492
29322	47921	1	applied	\N	\N	\N	\N	217443	217443	384500
29322	47922	2	applied	\N	\N	\N	\N	217444	217444	384501
29322	47923	3	applied	\N	\N	\N	\N	217445	217445	384502
29327	47927	0	applied	\N	\N	\N	\N	217457	217457	384514
29327	47928	1	applied	\N	\N	\N	\N	217458	217458	384515
29328	47927	0	applied	\N	\N	\N	\N	217459	217459	384516
29329	47929	0	applied	\N	\N	\N	\N	217461	217461	384518
29329	47930	1	applied	\N	\N	\N	\N	217462	217462	384519
29329	47931	2	applied	\N	\N	\N	\N	217463	217463	384520
29329	47932	3	applied	\N	\N	\N	\N	217464	217464	384521
29329	47933	4	applied	\N	\N	\N	\N	217465	217465	384522
29329	47934	5	applied	\N	\N	\N	\N	217466	217466	384523
29329	47935	6	applied	\N	\N	\N	\N	217467	217467	384524
29331	47665	0	applied	\N	\N	\N	\N	217473	217473	384530
29331	47666	1	applied	\N	\N	\N	\N	217474	217474	384531
29331	47671	2	applied	\N	\N	\N	\N	217475	217475	384532
29331	47674	3	applied	\N	\N	\N	\N	217476	217476	384533
29331	47676	4	applied	\N	\N	\N	\N	217477	217477	384534
29331	47680	5	applied	\N	\N	\N	\N	217478	217478	384535
29331	47681	6	applied	\N	\N	\N	\N	217479	217479	384536
29331	47685	7	applied	\N	\N	\N	\N	217480	217480	384537
29331	47689	8	applied	\N	\N	\N	\N	217481	217481	384538
29331	47691	10	applied	\N	\N	\N	\N	217483	217483	384540
29331	47697	11	applied	\N	\N	\N	\N	217484	217484	384541
29331	47701	12	applied	\N	\N	\N	\N	217485	217485	384542
29331	47704	13	applied	\N	\N	\N	\N	217486	217486	384543
29331	47707	14	applied	\N	\N	\N	\N	217487	217487	384544
29331	47710	15	applied	\N	\N	\N	\N	217488	217488	384545
29331	47713	16	applied	\N	\N	\N	\N	217489	217489	384546
29331	47716	17	applied	\N	\N	\N	\N	217490	217490	384547
29331	47719	18	applied	\N	\N	\N	\N	217491	217491	384548
29331	47722	19	applied	\N	\N	\N	\N	217492	217492	384549
29331	47723	20	applied	\N	\N	\N	\N	217493	217493	384550
29331	47727	21	applied	\N	\N	\N	\N	217494	217494	384551
29331	47731	22	applied	\N	\N	\N	\N	217495	217495	384552
29331	47734	23	applied	\N	\N	\N	\N	217496	217496	384553
29331	47735	24	applied	\N	\N	\N	\N	217497	217497	384554
29331	47740	25	applied	\N	\N	\N	\N	217498	217498	384555
29331	47747	27	applied	\N	\N	\N	\N	217500	217500	384557
29331	47751	28	applied	\N	\N	\N	\N	217501	217501	384558
29331	47753	29	applied	\N	\N	\N	\N	217502	217502	384559
29331	47756	30	applied	\N	\N	\N	\N	217503	217503	384560
29331	47759	31	applied	\N	\N	\N	\N	217504	217504	384561
29331	47762	32	applied	\N	\N	\N	\N	217505	217505	384562
29331	47763	33	applied	\N	\N	\N	\N	217506	217506	384563
29331	47768	34	applied	\N	\N	\N	\N	217507	217507	384564
29331	47772	35	applied	\N	\N	\N	\N	217508	217508	384565
29331	47774	36	applied	\N	\N	\N	\N	217509	217509	384566
29331	47777	37	applied	\N	\N	\N	\N	217510	217510	384567
29331	47781	38	applied	\N	\N	\N	\N	217511	217511	384568
29331	47784	39	applied	\N	\N	\N	\N	217512	217512	384569
29331	47786	40	applied	\N	\N	\N	\N	217513	217513	384570
29331	47792	41	applied	\N	\N	\N	\N	217514	217514	384571
29331	47794	42	applied	\N	\N	\N	\N	217515	217515	384572
29331	47797	44	applied	\N	\N	\N	\N	217517	217517	384574
29331	47798	45	applied	\N	\N	\N	\N	217518	217518	384575
29331	47799	46	applied	\N	\N	\N	\N	217519	217519	384576
29331	47808	47	applied	\N	\N	\N	\N	217520	217520	384577
29331	47812	48	applied	\N	\N	\N	\N	217521	217521	384578
29331	47813	49	applied	\N	\N	\N	\N	217522	217522	384579
29331	47818	50	applied	\N	\N	\N	\N	217523	217523	384580
29331	47819	51	applied	\N	\N	\N	\N	217524	217524	384581
29331	47820	52	applied	\N	\N	\N	\N	217525	217525	384582
29331	47821	53	applied	\N	\N	\N	\N	217526	217526	384583
29331	47830	54	applied	\N	\N	\N	\N	217527	217527	384584
29331	47831	55	applied	\N	\N	\N	\N	217528	217528	384585
29331	47836	56	applied	\N	\N	\N	\N	217529	217529	384586
29331	47839	57	applied	\N	\N	\N	\N	217530	217530	384587
29331	47840	58	applied	\N	\N	\N	\N	217531	217531	384588
29331	47845	59	applied	\N	\N	\N	\N	217532	217532	384589
29331	47852	61	applied	\N	\N	\N	\N	217534	217534	384591
29331	47855	62	applied	\N	\N	\N	\N	217535	217535	384592
29331	47858	63	applied	\N	\N	\N	\N	217536	217536	384593
29331	47859	65	applied	\N	\N	\N	\N	217537	217537	384594
29331	47865	66	applied	\N	\N	\N	\N	217538	217538	384595
29331	47867	67	applied	\N	\N	\N	\N	217539	217539	384596
29331	47870	68	applied	\N	\N	\N	\N	217540	217540	384597
29331	47874	69	applied	\N	\N	\N	\N	217541	217541	384598
29331	47877	70	applied	\N	\N	\N	\N	217542	217542	384599
29331	47878	71	applied	\N	\N	\N	\N	217543	217543	384600
29331	47882	72	applied	\N	\N	\N	\N	217544	217544	384601
29331	47886	73	applied	\N	\N	\N	\N	217545	217545	384602
29331	47887	74	applied	\N	\N	\N	\N	217546	217546	384603
29331	47891	75	applied	\N	\N	\N	\N	217547	217547	384604
29331	47895	76	applied	\N	\N	\N	\N	217548	217548	384605
29331	47896	77	applied	\N	\N	\N	\N	217549	217549	384606
29331	47900	79	applied	\N	\N	\N	\N	217551	217551	384608
29331	47906	80	applied	\N	\N	\N	\N	217552	217552	384609
29331	47908	81	applied	\N	\N	\N	\N	217553	217553	384610
29331	47911	82	applied	\N	\N	\N	\N	217554	217554	384611
29331	47915	83	applied	\N	\N	\N	\N	217555	217555	384612
29331	47918	84	applied	\N	\N	\N	\N	217556	217556	384613
29331	47920	85	applied	\N	\N	\N	\N	217557	217557	384614
29331	47924	86	applied	\N	\N	\N	\N	217558	217558	384615
29331	47927	87	applied	\N	\N	\N	\N	217559	217559	384616
29331	47929	88	applied	\N	\N	\N	\N	217560	217560	384617
29332	47941	0	applied	\N	\N	\N	\N	217598	217598	384655
29332	47942	1	applied	\N	\N	\N	\N	217599	217599	384656
29332	47943	2	applied	\N	\N	\N	\N	217600	217600	384657
29342	47964	0	applied	\N	\N	\N	\N	217635	217635	384692
29301	47878	1	applied	\N	\N	\N	\N	217378	217378	384435
29301	47879	2	applied	\N	\N	\N	\N	217379	217379	384436
29331	47309	93	applied	\N	\N	\N	\N	217565	217565	384622
29331	47310	94	applied	\N	\N	\N	\N	217566	217566	384623
29331	47312	95	applied	\N	\N	\N	\N	217567	217567	384624
29331	47320	96	applied	\N	\N	\N	\N	217568	217568	384625
29331	47313	97	applied	\N	\N	\N	\N	217569	217569	384626
29331	47331	98	applied	\N	\N	\N	\N	217570	217570	384627
29331	47742	99	applied	\N	\N	\N	\N	217571	217571	384628
29331	47938	100	applied	\N	\N	1000000000	\N	217572	217572	384629
29331	47939	101	applied	\N	\N	1000000000	\N	217573	217573	384630
29331	47345	102	applied	\N	\N	\N	\N	217574	217574	384631
29331	47305	103	applied	\N	\N	\N	\N	217575	217575	384632
29331	47308	104	applied	\N	\N	\N	\N	217576	217576	384633
29331	47314	105	applied	\N	\N	\N	\N	217577	217577	384634
29331	47316	106	applied	\N	\N	\N	\N	217578	217578	384635
29331	47321	107	applied	\N	\N	\N	\N	217579	217579	384636
29331	47325	108	applied	\N	\N	\N	\N	217580	217580	384637
29342	47965	1	applied	\N	\N	\N	\N	217636	217636	384693
29342	47967	3	applied	\N	\N	\N	\N	217638	217638	384695
29342	47968	4	applied	\N	\N	\N	\N	217639	217639	384696
29342	47969	5	applied	\N	\N	\N	\N	217640	217640	384697
29349	47979	0	applied	\N	\N	\N	\N	217665	217665	384722
29349	47980	1	applied	\N	\N	\N	\N	217666	217666	384723
29349	47981	2	applied	\N	\N	\N	\N	217667	217667	384724
29349	47982	3	applied	\N	\N	\N	\N	217668	217668	384725
29349	47983	4	applied	\N	\N	\N	\N	217669	217669	384726
29349	47984	5	applied	\N	\N	\N	\N	217670	217670	384727
29354	47991	0	applied	\N	\N	\N	\N	217692	217692	384749
29354	47992	1	applied	\N	\N	\N	\N	217693	217693	384750
29354	47993	2	applied	\N	\N	\N	\N	217694	217694	384751
29362	48000	0	applied	\N	\N	\N	\N	217714	217714	384771
29362	48001	1	applied	\N	\N	\N	\N	217715	217715	384772
29362	48002	2	applied	\N	\N	\N	\N	217716	217716	384773
29365	48009	0	applied	\N	\N	\N	\N	217723	217723	384780
29365	48011	2	applied	\N	\N	\N	\N	217725	217725	384782
29370	48018	0	applied	\N	\N	\N	\N	217738	217738	384795
29370	48019	1	applied	\N	\N	\N	\N	217739	217739	384796
29370	48020	2	applied	\N	\N	\N	\N	217740	217740	384797
29374	48027	0	applied	\N	\N	\N	\N	217750	217750	384807
29374	48028	1	applied	\N	\N	\N	\N	217751	217751	384808
29374	48029	2	applied	\N	\N	\N	\N	217752	217752	384809
29374	48030	3	applied	\N	\N	\N	\N	217753	217753	384810
29374	48031	4	applied	\N	\N	\N	\N	217754	217754	384811
29381	48048	0	applied	\N	\N	\N	\N	217789	217789	384846
29381	48049	1	applied	\N	\N	\N	\N	217790	217790	384847
29386	48062	0	applied	\N	\N	\N	\N	217806	217806	384863
29386	48063	1	applied	\N	\N	\N	\N	217807	217807	384864
29386	48064	2	applied	\N	\N	\N	\N	217808	217808	384865
29386	48065	3	applied	\N	\N	\N	\N	217809	217809	384866
29386	48066	4	applied	\N	\N	\N	\N	217810	217810	384867
29386	48068	6	applied	\N	\N	\N	\N	217812	217812	384869
29386	48069	7	applied	\N	\N	\N	\N	217813	217813	384870
29386	48070	8	applied	\N	\N	\N	\N	217814	217814	384871
29386	48071	9	applied	\N	\N	\N	\N	217815	217815	384872
29386	48072	10	applied	\N	\N	\N	\N	217816	217816	384873
29386	48073	11	applied	\N	\N	\N	\N	217817	217817	384874
29388	48062	0	applied	\N	\N	\N	\N	217830	217830	384887
29388	48063	1	applied	\N	\N	\N	\N	217831	217831	384888
29388	48064	2	applied	\N	\N	\N	\N	217832	217832	384889
29388	48065	3	applied	\N	\N	\N	\N	217833	217833	384890
29388	48066	4	applied	\N	\N	\N	\N	217834	217834	384891
29388	48067	5	applied	\N	\N	\N	\N	217835	217835	384892
29388	48072	6	applied	\N	\N	\N	\N	217836	217836	384893
29388	48073	7	applied	\N	\N	\N	\N	217837	217837	384894
29390	48078	0	applied	\N	\N	\N	\N	217842	217842	384899
29390	48079	1	applied	\N	\N	\N	\N	217843	217843	384900
29390	48081	3	applied	\N	\N	\N	\N	217845	217845	384902
29396	48089	0	applied	\N	\N	\N	\N	217985	217985	385042
29396	48090	1	applied	\N	\N	\N	\N	217986	217986	385043
29396	48091	2	applied	\N	\N	\N	\N	217987	217987	385044
29398	48092	0	applied	\N	\N	\N	\N	217991	217991	385048
29398	48093	1	applied	\N	\N	\N	\N	217992	217992	385049
29398	48094	2	applied	\N	\N	\N	\N	217993	217993	385050
29401	48101	0	applied	\N	\N	\N	\N	218003	218003	385060
29401	48102	1	applied	\N	\N	\N	\N	218004	218004	385061
29401	48103	2	applied	\N	\N	1000000000	\N	218005	218005	385062
29401	48104	3	applied	\N	\N	\N	\N	218006	218006	385063
29408	48114	0	applied	\N	\N	\N	\N	218056	218056	385113
29408	48115	1	applied	\N	\N	\N	\N	218057	218057	385114
29408	48116	2	applied	\N	\N	\N	\N	218058	218058	385115
29408	48117	3	applied	\N	\N	\N	\N	218059	218059	385116
29411	48118	0	applied	\N	\N	\N	\N	218073	218073	385130
29411	48120	3	applied	\N	\N	\N	\N	218075	218075	385132
29411	48121	4	applied	\N	\N	\N	\N	218076	218076	385133
29411	48122	5	applied	\N	\N	\N	\N	218077	218077	385134
29411	48123	6	applied	\N	\N	\N	\N	218078	218078	385135
29411	48124	7	applied	\N	\N	\N	\N	218079	218079	385136
29411	48125	8	applied	\N	\N	\N	\N	218080	218080	385137
29411	48126	9	applied	\N	\N	\N	\N	218081	218081	385138
29413	48127	0	applied	\N	\N	\N	\N	218082	218082	385139
29413	47847	1	applied	\N	\N	1000000000	\N	218083	218083	385140
29413	47950	2	applied	\N	\N	\N	\N	218084	218084	385141
29413	48087	3	applied	\N	\N	\N	\N	218085	218085	385142
29413	48103	4	applied	\N	\N	1000000000	\N	218086	218086	385143
29413	48116	5	applied	\N	\N	\N	\N	218087	218087	385144
29413	48067	6	applied	\N	\N	\N	\N	218088	218088	385145
29413	47939	8	applied	\N	\N	1000000000	\N	218090	218090	385147
29417	48138	0	applied	\N	\N	\N	\N	218116	218116	385173
29421	48143	0	applied	\N	\N	\N	\N	218129	218129	385186
29421	48144	1	applied	\N	\N	\N	\N	218130	218130	385187
29421	48145	2	applied	\N	\N	\N	\N	218131	218131	385188
29423	48146	0	applied	\N	\N	1000000000	\N	218136	218136	385193
29423	48147	1	applied	\N	\N	\N	\N	218137	218137	385194
29423	48148	2	applied	\N	\N	\N	\N	218138	218138	385195
29423	48149	3	applied	\N	\N	\N	\N	218139	218139	385196
29425	48150	0	applied	\N	\N	\N	\N	218144	218144	385201
29425	48151	1	applied	\N	\N	\N	\N	218145	218145	385202
29425	48152	2	applied	\N	\N	\N	\N	218146	218146	385203
29425	48153	3	applied	\N	\N	\N	\N	218147	218147	385204
29425	48154	4	applied	\N	\N	\N	\N	218148	218148	385205
29331	47936	90	applied	\N	\N	\N	\N	217562	217562	384619
29331	47304	92	applied	\N	\N	\N	\N	217564	217564	384621
29331	47349	113	applied	\N	\N	\N	\N	217585	217585	384642
29331	47354	114	applied	\N	\N	\N	\N	217586	217586	384643
29331	47355	115	applied	\N	\N	\N	\N	217587	217587	384644
29331	47361	116	applied	\N	\N	\N	\N	217588	217588	384645
29331	47365	117	applied	\N	\N	\N	\N	217589	217589	384646
29331	47357	118	applied	\N	\N	\N	\N	217590	217590	384647
29331	47362	119	applied	\N	\N	\N	\N	217591	217591	384648
29331	47375	120	applied	\N	\N	\N	\N	217592	217592	384649
29331	47388	121	applied	\N	\N	\N	\N	217593	217593	384650
29331	47395	122	applied	\N	\N	\N	\N	217594	217594	384651
29331	47409	123	applied	\N	\N	\N	\N	217595	217595	384652
29331	47416	124	applied	\N	\N	\N	\N	217596	217596	384653
29331	47424	125	applied	\N	\N	\N	\N	217597	217597	384654
29334	47941	0	applied	\N	\N	\N	\N	217604	217604	384661
29334	47942	1	applied	\N	\N	\N	\N	217605	217605	384662
29334	47943	2	applied	\N	\N	\N	\N	217606	217606	384663
29335	47945	1	applied	\N	\N	\N	\N	217608	217608	384665
29335	47946	2	applied	\N	\N	\N	\N	217609	217609	384666
29335	47947	3	applied	\N	\N	\N	\N	217610	217610	384667
29337	47952	5	applied	\N	\N	\N	\N	217619	217619	384676
29337	47953	6	applied	\N	\N	\N	\N	217620	217620	384677
29338	47954	0	applied	\N	\N	\N	\N	217621	217621	384678
29338	47955	1	applied	\N	\N	\N	\N	217622	217622	384679
29338	47956	2	applied	\N	\N	\N	\N	217623	217623	384680
29338	47957	3	applied	\N	\N	\N	\N	217624	217624	384681
29340	47958	0	applied	\N	\N	\N	\N	217629	217629	384686
29340	47959	1	applied	\N	\N	\N	\N	217630	217630	384687
29340	47960	2	applied	\N	\N	\N	\N	217631	217631	384688
29343	47964	0	applied	\N	\N	\N	\N	217641	217641	384698
29343	47965	1	applied	\N	\N	\N	\N	217642	217642	384699
29343	47966	2	applied	\N	\N	\N	\N	217643	217643	384700
29343	47967	3	applied	\N	\N	\N	\N	217644	217644	384701
29343	47969	5	applied	\N	\N	\N	\N	217646	217646	384703
29346	47973	0	applied	\N	\N	\N	\N	217656	217656	384713
29346	47974	1	applied	\N	\N	\N	\N	217657	217657	384714
29346	47975	2	applied	\N	\N	\N	\N	217658	217658	384715
29348	47976	0	applied	\N	\N	\N	\N	217662	217662	384719
29348	47977	1	applied	\N	\N	\N	\N	217663	217663	384720
29348	47978	2	applied	\N	\N	\N	\N	217664	217664	384721
29350	47979	0	applied	\N	\N	\N	\N	217671	217671	384728
29350	47980	1	applied	\N	\N	\N	\N	217672	217672	384729
29350	47981	2	applied	\N	\N	\N	\N	217673	217673	384730
29350	47982	3	applied	\N	\N	\N	\N	217674	217674	384731
29350	47983	4	applied	\N	\N	\N	\N	217675	217675	384732
29350	47984	5	applied	\N	\N	\N	\N	217676	217676	384733
29351	47985	0	applied	\N	\N	\N	\N	217677	217677	384734
29351	47986	1	applied	\N	\N	\N	\N	217678	217678	384735
29351	47987	2	applied	\N	\N	\N	\N	217679	217679	384736
29351	47989	4	applied	\N	\N	\N	\N	217681	217681	384738
29351	47990	5	applied	\N	\N	\N	\N	217682	217682	384739
29352	47985	0	applied	\N	\N	\N	\N	217683	217683	384740
29352	47986	1	applied	\N	\N	\N	\N	217684	217684	384741
29352	47987	2	applied	\N	\N	\N	\N	217685	217685	384742
29352	47988	3	applied	\N	\N	\N	\N	217686	217686	384743
29352	47989	4	applied	\N	\N	\N	\N	217687	217687	384744
29352	47990	5	applied	\N	\N	\N	\N	217688	217688	384745
29356	47994	0	applied	\N	\N	\N	\N	217699	217699	384756
29356	47995	1	applied	\N	\N	\N	\N	217700	217700	384757
29356	47996	2	applied	\N	\N	\N	\N	217701	217701	384758
29356	47997	3	applied	\N	\N	\N	\N	217702	217702	384759
29357	47994	0	applied	\N	\N	\N	\N	217703	217703	384760
29357	47995	1	applied	\N	\N	\N	\N	217704	217704	384761
29357	47996	2	applied	\N	\N	\N	\N	217705	217705	384762
29357	47997	3	applied	\N	\N	\N	\N	217706	217706	384763
29363	48003	0	applied	\N	\N	\N	\N	217717	217717	384774
29363	48004	1	applied	\N	\N	\N	\N	217718	217718	384775
29363	48005	2	applied	\N	\N	\N	\N	217719	217719	384776
29366	48009	0	applied	\N	\N	\N	\N	217726	217726	384783
29366	48010	1	applied	\N	\N	\N	\N	217727	217727	384784
29366	48011	2	applied	\N	\N	\N	\N	217728	217728	384785
29368	48015	0	applied	\N	\N	\N	\N	217732	217732	384789
29368	48016	1	applied	\N	\N	\N	\N	217733	217733	384790
29368	48017	2	applied	\N	\N	\N	\N	217734	217734	384791
29369	48015	0	applied	\N	\N	\N	\N	217735	217735	384792
29369	48016	1	applied	\N	\N	\N	\N	217736	217736	384793
29369	48017	2	applied	\N	\N	\N	\N	217737	217737	384794
29371	48018	0	applied	\N	\N	\N	\N	217741	217741	384798
29371	48019	1	applied	\N	\N	\N	\N	217742	217742	384799
29371	48020	2	applied	\N	\N	\N	\N	217743	217743	384800
29372	48021	0	applied	\N	\N	\N	\N	217744	217744	384801
29372	48023	2	applied	\N	\N	\N	\N	217746	217746	384803
29373	48024	0	applied	\N	\N	\N	\N	217747	217747	384804
29373	48025	1	applied	\N	\N	\N	\N	217748	217748	384805
29373	48026	2	applied	\N	\N	\N	\N	217749	217749	384806
29376	48032	0	applied	\N	\N	\N	\N	217755	217755	384812
29376	48033	1	applied	\N	\N	\N	\N	217756	217756	384813
29376	48034	2	applied	\N	\N	\N	\N	217757	217757	384814
29376	48035	3	applied	\N	\N	\N	\N	217758	217758	384815
29376	48036	4	applied	\N	\N	\N	\N	217759	217759	384816
29376	48037	5	applied	\N	\N	\N	\N	217760	217760	384817
29376	48038	6	applied	\N	\N	\N	\N	217761	217761	384818
29376	48039	7	applied	\N	\N	\N	\N	217762	217762	384819
29376	48040	8	applied	\N	\N	\N	\N	217763	217763	384820
29378	48032	0	applied	\N	\N	\N	\N	217773	217773	384830
29378	48033	1	applied	\N	\N	\N	\N	217774	217774	384831
29378	48034	2	applied	\N	\N	\N	\N	217775	217775	384832
29378	48036	4	applied	\N	\N	\N	\N	217777	217777	384834
29378	48037	5	applied	\N	\N	\N	\N	217778	217778	384835
29378	48038	6	applied	\N	\N	\N	\N	217779	217779	384836
29378	48039	7	applied	\N	\N	\N	\N	217780	217780	384837
29378	48040	8	applied	\N	\N	\N	\N	217781	217781	384838
29384	48053	0	applied	\N	\N	\N	\N	217797	217797	384854
29384	48054	1	applied	\N	\N	\N	\N	217798	217798	384855
29384	48055	2	applied	\N	\N	\N	\N	217799	217799	384856
29384	48056	3	applied	\N	\N	\N	\N	217800	217800	384857
29384	48057	4	applied	\N	\N	\N	\N	217801	217801	384858
29384	48058	5	applied	\N	\N	\N	\N	217802	217802	384859
29384	48059	6	applied	\N	\N	\N	\N	217803	217803	384860
29391	47839	0	applied	\N	\N	\N	\N	217846	217846	384903
29391	47840	1	applied	\N	\N	\N	\N	217847	217847	384904
29331	47336	110	applied	\N	\N	\N	\N	217582	217582	384639
29331	47339	111	applied	\N	\N	\N	\N	217583	217583	384640
29380	48044	0	applied	\N	\N	\N	\N	217785	217785	384842
29380	48045	1	applied	\N	\N	\N	\N	217786	217786	384843
29380	48046	2	applied	\N	\N	\N	\N	217787	217787	384844
29380	48047	3	applied	\N	\N	\N	\N	217788	217788	384845
29383	48050	0	applied	\N	\N	\N	\N	217794	217794	384851
29383	48051	1	applied	\N	\N	\N	\N	217795	217795	384852
29383	48052	2	applied	\N	\N	\N	\N	217796	217796	384853
29385	48060	0	applied	\N	\N	\N	\N	217804	217804	384861
29385	48061	1	applied	\N	\N	\N	\N	217805	217805	384862
29387	48062	0	applied	\N	\N	\N	\N	217818	217818	384875
29387	48063	1	applied	\N	\N	\N	\N	217819	217819	384876
29387	48064	2	applied	\N	\N	\N	\N	217820	217820	384877
29387	48066	4	applied	\N	\N	\N	\N	217822	217822	384879
29387	48067	5	applied	\N	\N	\N	\N	217823	217823	384880
29387	48068	6	applied	\N	\N	\N	\N	217824	217824	384881
29387	48069	7	applied	\N	\N	\N	\N	217825	217825	384882
29387	48070	8	applied	\N	\N	\N	\N	217826	217826	384883
29387	48071	9	applied	\N	\N	\N	\N	217827	217827	384884
29387	48072	10	applied	\N	\N	\N	\N	217828	217828	384885
29387	48073	11	applied	\N	\N	\N	\N	217829	217829	384886
29391	47845	2	applied	\N	\N	\N	\N	217848	217848	384905
29391	47846	3	applied	\N	\N	\N	\N	217849	217849	384906
29391	47852	4	applied	\N	\N	\N	\N	217850	217850	384907
29391	47855	5	applied	\N	\N	\N	\N	217851	217851	384908
29391	47858	6	applied	\N	\N	\N	\N	217852	217852	384909
29391	47859	7	applied	\N	\N	\N	\N	217853	217853	384910
29391	47865	8	applied	\N	\N	\N	\N	217854	217854	384911
29391	47867	9	applied	\N	\N	\N	\N	217855	217855	384912
29391	47874	11	applied	\N	\N	\N	\N	217857	217857	384914
29391	47877	12	applied	\N	\N	\N	\N	217858	217858	384915
29391	47878	13	applied	\N	\N	\N	\N	217859	217859	384916
29391	47882	14	applied	\N	\N	\N	\N	217860	217860	384917
29391	47886	15	applied	\N	\N	\N	\N	217861	217861	384918
29391	47887	16	applied	\N	\N	\N	\N	217862	217862	384919
29391	47891	17	applied	\N	\N	\N	\N	217863	217863	384920
29391	47895	18	applied	\N	\N	\N	\N	217864	217864	384921
29391	47896	19	applied	\N	\N	\N	\N	217865	217865	384922
29391	47899	20	applied	\N	\N	\N	\N	217866	217866	384923
29391	47900	21	applied	\N	\N	\N	\N	217867	217867	384924
29391	47906	22	applied	\N	\N	\N	\N	217868	217868	384925
29392	48082	0	applied	\N	\N	\N	\N	217971	217971	385028
29392	48083	1	applied	\N	\N	\N	\N	217972	217972	385029
29394	48084	0	applied	\N	\N	\N	\N	217975	217975	385032
29394	48085	1	applied	\N	\N	\N	\N	217976	217976	385033
29394	48087	3	applied	\N	\N	\N	\N	217978	217978	385035
29394	48088	4	applied	\N	\N	\N	\N	217979	217979	385036
29403	48106	0	applied	\N	\N	\N	\N	218009	218009	385066
29405	48078	0	applied	\N	\N	\N	\N	218015	218015	385072
29405	48082	1	applied	\N	\N	\N	\N	218016	218016	385073
29405	48084	2	applied	\N	\N	\N	\N	218017	218017	385074
29405	48089	3	applied	\N	\N	\N	\N	218018	218018	385075
29405	48092	4	applied	\N	\N	\N	\N	218019	218019	385076
29405	48095	5	applied	\N	\N	\N	\N	218020	218020	385077
29405	48096	6	applied	\N	\N	\N	\N	218021	218021	385078
29405	48101	7	applied	\N	\N	\N	\N	218022	218022	385079
29405	48105	8	applied	\N	\N	\N	\N	218023	218023	385080
29405	48107	9	applied	\N	\N	\N	\N	218024	218024	385081
29405	48085	10	applied	\N	\N	\N	\N	218025	218025	385082
29405	48087	11	applied	\N	\N	\N	\N	218026	218026	385083
29405	48100	13	applied	\N	\N	\N	\N	218028	218028	385085
29405	48109	14	applied	\N	\N	\N	\N	218029	218029	385086
29405	48079	15	applied	\N	\N	\N	\N	218030	218030	385087
29405	48080	16	applied	\N	\N	\N	\N	218031	218031	385088
29405	48088	17	applied	\N	\N	\N	\N	218032	218032	385089
29405	48090	18	applied	\N	\N	\N	\N	218033	218033	385090
29405	48093	19	applied	\N	\N	\N	\N	218034	218034	385091
29405	48099	20	applied	\N	\N	\N	\N	218035	218035	385092
29405	48102	21	applied	\N	\N	\N	\N	218036	218036	385093
29405	48108	22	applied	\N	\N	\N	\N	218037	218037	385094
29405	48081	23	applied	\N	\N	\N	\N	218038	218038	385095
29405	48083	24	applied	\N	\N	\N	\N	218039	218039	385096
29405	48086	25	applied	\N	\N	\N	\N	218040	218040	385097
29405	48091	26	applied	\N	\N	\N	\N	218041	218041	385098
29405	48094	27	applied	\N	\N	\N	\N	218042	218042	385099
29405	48097	28	applied	\N	\N	\N	\N	218043	218043	385100
29405	48098	29	applied	\N	\N	\N	\N	218044	218044	385101
29405	48104	30	applied	\N	\N	\N	\N	218045	218045	385102
29405	48106	31	applied	\N	\N	\N	\N	218046	218046	385103
29407	48111	0	applied	\N	\N	\N	\N	218053	218053	385110
29407	48112	1	applied	\N	\N	\N	\N	218054	218054	385111
29407	48113	2	applied	\N	\N	\N	\N	218055	218055	385112
29410	48118	0	applied	\N	\N	\N	\N	218064	218064	385121
29410	48119	2	applied	\N	\N	\N	\N	218065	218065	385122
29410	48120	3	applied	\N	\N	\N	\N	218066	218066	385123
29410	48121	4	applied	\N	\N	\N	\N	218067	218067	385124
29410	48122	5	applied	\N	\N	\N	\N	218068	218068	385125
29410	48123	6	applied	\N	\N	\N	\N	218069	218069	385126
29410	48124	7	applied	\N	\N	\N	\N	218070	218070	385127
29410	48125	8	applied	\N	\N	\N	\N	218071	218071	385128
29410	48126	9	applied	\N	\N	\N	\N	218072	218072	385129
29414	48127	0	applied	\N	\N	\N	\N	218091	218091	385148
29414	48128	1	applied	\N	\N	\N	\N	218092	218092	385149
29414	48129	2	applied	\N	\N	\N	\N	218093	218093	385150
29414	48130	3	applied	\N	\N	\N	\N	218094	218094	385151
29414	48132	5	applied	\N	\N	\N	\N	218096	218096	385153
29414	48133	6	applied	\N	\N	\N	\N	218097	218097	385154
29414	48134	7	applied	\N	\N	\N	\N	218098	218098	385155
29414	48135	8	applied	\N	\N	1000000000	\N	218099	218099	385156
29414	48136	9	applied	\N	\N	\N	\N	218100	218100	385157
29414	48137	10	applied	\N	\N	\N	\N	218101	218101	385158
29416	48138	0	applied	\N	\N	\N	\N	218113	218113	385170
29416	48139	1	applied	\N	\N	\N	\N	218114	218114	385171
29416	48140	2	applied	\N	\N	\N	\N	218115	218115	385172
29419	48141	0	applied	\N	\N	\N	\N	218121	218121	385178
29419	48139	1	applied	\N	\N	\N	\N	218122	218122	385179
29419	48140	2	applied	\N	\N	\N	\N	218123	218123	385180
29419	48142	3	applied	\N	\N	\N	\N	218124	218124	385181
29426	48155	0	applied	\N	\N	\N	\N	218149	218149	385206
29426	48156	1	applied	\N	\N	\N	\N	218150	218150	385207
29361	48000	0	applied	\N	\N	\N	\N	217711	217711	384768
29361	48002	2	applied	\N	\N	\N	\N	217713	217713	384770
29391	47918	26	applied	\N	\N	\N	\N	217872	217872	384929
29391	47920	27	applied	\N	\N	\N	\N	217873	217873	384930
29391	47924	28	applied	\N	\N	\N	\N	217874	217874	384931
29391	47927	29	applied	\N	\N	\N	\N	217875	217875	384932
29391	47929	30	applied	\N	\N	\N	\N	217876	217876	384933
29391	47930	31	applied	\N	\N	\N	\N	217877	217877	384934
29391	47936	32	applied	\N	\N	\N	\N	217878	217878	384935
29391	47941	33	applied	\N	\N	\N	\N	217879	217879	384936
29391	47944	34	applied	\N	\N	\N	\N	217880	217880	384937
29391	47948	35	applied	\N	\N	\N	\N	217881	217881	384938
29391	47949	36	applied	\N	\N	\N	\N	217882	217882	384939
29391	47958	38	applied	\N	\N	\N	\N	217884	217884	384941
29391	47961	39	applied	\N	\N	\N	\N	217885	217885	384942
29391	47964	40	applied	\N	\N	\N	\N	217886	217886	384943
29391	47965	41	applied	\N	\N	\N	\N	217887	217887	384944
29391	47970	42	applied	\N	\N	\N	\N	217888	217888	384945
29391	47973	43	applied	\N	\N	\N	\N	217889	217889	384946
29391	47976	44	applied	\N	\N	\N	\N	217890	217890	384947
29391	47979	45	applied	\N	\N	\N	\N	217891	217891	384948
29391	47980	46	applied	\N	\N	\N	\N	217892	217892	384949
29391	47985	47	applied	\N	\N	\N	\N	217893	217893	384950
29391	47986	48	applied	\N	\N	\N	\N	217894	217894	384951
29391	47991	49	applied	\N	\N	\N	\N	217895	217895	384952
29391	47994	50	applied	\N	\N	\N	\N	217896	217896	384953
29391	47998	51	applied	\N	\N	\N	\N	217897	217897	384954
29391	48000	52	applied	\N	\N	\N	\N	217898	217898	384955
29391	48003	53	applied	\N	\N	\N	\N	217899	217899	384956
29391	48009	55	applied	\N	\N	\N	\N	217901	217901	384958
29391	48012	56	applied	\N	\N	\N	\N	217902	217902	384959
29391	48015	57	applied	\N	\N	\N	\N	217903	217903	384960
29391	48018	58	applied	\N	\N	\N	\N	217904	217904	384961
29391	48021	59	applied	\N	\N	\N	\N	217905	217905	384962
29391	48024	60	applied	\N	\N	\N	\N	217906	217906	384963
29391	48027	61	applied	\N	\N	\N	\N	217907	217907	384964
29391	48028	62	applied	\N	\N	\N	\N	217908	217908	384965
29391	48032	63	applied	\N	\N	\N	\N	217909	217909	384966
29391	48033	64	applied	\N	\N	\N	\N	217910	217910	384967
29391	48034	65	applied	\N	\N	\N	\N	217911	217911	384968
29391	48041	66	applied	\N	\N	\N	\N	217912	217912	384969
29391	48044	67	applied	\N	\N	\N	\N	217913	217913	384970
29391	48048	68	applied	\N	\N	\N	\N	217914	217914	384971
29391	48050	69	applied	\N	\N	\N	\N	217915	217915	384972
29391	48053	70	applied	\N	\N	\N	\N	217916	217916	384973
29391	48060	72	applied	\N	\N	\N	\N	217918	217918	384975
29391	48062	73	applied	\N	\N	\N	\N	217919	217919	384976
29391	48063	74	applied	\N	\N	\N	\N	217920	217920	384977
29391	48064	75	applied	\N	\N	\N	\N	217921	217921	384978
29391	48074	76	applied	\N	\N	\N	\N	217922	217922	384979
29391	48078	77	applied	\N	\N	\N	\N	217923	217923	384980
29391	47847	78	applied	\N	\N	1000000000	\N	217924	217924	384981
29391	47950	79	applied	\N	\N	\N	\N	217925	217925	384982
29391	47841	80	applied	\N	\N	\N	\N	217926	217926	384983
29391	47942	81	applied	\N	\N	\N	\N	217927	217927	384984
29391	47842	82	applied	\N	\N	\N	\N	217928	217928	384985
29391	47853	83	applied	\N	\N	\N	\N	217929	217929	384986
29391	48067	84	applied	\N	\N	\N	\N	217930	217930	384987
29391	47843	85	applied	\N	\N	\N	\N	217931	217931	384988
29391	47848	87	applied	\N	\N	\N	\N	217932	217932	384989
29391	47860	88	applied	\N	\N	\N	\N	217933	217933	384990
29391	47885	90	applied	\N	\N	\N	\N	217935	217935	384992
29391	47893	91	applied	\N	\N	\N	\N	217936	217936	384993
29391	47938	92	applied	\N	\N	1000000000	\N	217937	217937	384994
29391	47939	93	applied	\N	\N	1000000000	\N	217938	217938	384995
29391	47902	94	applied	\N	\N	\N	\N	217939	217939	384996
29391	47844	95	applied	\N	\N	\N	\N	217940	217940	384997
29391	47849	96	applied	\N	\N	\N	\N	217941	217941	384998
29391	47850	97	applied	\N	\N	\N	\N	217942	217942	384999
29391	47914	98	applied	\N	\N	\N	\N	217943	217943	385000
29391	47921	99	applied	\N	\N	\N	\N	217944	217944	385001
29391	47935	100	applied	\N	\N	\N	\N	217945	217945	385002
29391	47945	101	applied	\N	\N	\N	\N	217946	217946	385003
29391	47957	102	applied	\N	\N	\N	\N	217947	217947	385004
29391	47969	103	applied	\N	\N	\N	\N	217948	217948	385005
29391	47978	104	applied	\N	\N	\N	\N	217949	217949	385006
29391	47987	105	applied	\N	\N	\N	\N	217950	217950	385007
29391	48007	107	applied	\N	\N	\N	\N	217952	217952	385009
29391	48016	108	applied	\N	\N	\N	\N	217953	217953	385010
29391	48026	109	applied	\N	\N	\N	\N	217954	217954	385011
29391	48037	110	applied	\N	\N	\N	\N	217955	217955	385012
29391	48047	111	applied	\N	\N	\N	\N	217956	217956	385013
29391	48055	112	applied	\N	\N	\N	\N	217957	217957	385014
29391	48065	113	applied	\N	\N	\N	\N	217958	217958	385015
29391	48075	114	applied	\N	\N	\N	\N	217959	217959	385016
29391	47857	115	applied	\N	\N	\N	\N	217960	217960	385017
29391	47861	116	applied	\N	\N	\N	\N	217961	217961	385018
29391	47862	117	applied	\N	\N	\N	\N	217962	217962	385019
29391	47869	118	applied	\N	\N	\N	\N	217963	217963	385020
29391	47873	119	applied	\N	\N	\N	\N	217964	217964	385021
29391	47876	120	applied	\N	\N	\N	\N	217965	217965	385022
29391	47880	121	applied	\N	\N	\N	\N	217966	217966	385023
29391	47884	122	applied	\N	\N	\N	\N	217967	217967	385024
29391	47894	124	applied	\N	\N	\N	\N	217969	217969	385026
29391	47897	125	applied	\N	\N	\N	\N	217970	217970	385027
29397	48092	0	applied	\N	\N	\N	\N	217988	217988	385045
29397	48093	1	applied	\N	\N	\N	\N	217989	217989	385046
29397	48094	2	applied	\N	\N	\N	\N	217990	217990	385047
29399	48092	0	applied	\N	\N	\N	\N	217994	217994	385051
29399	48093	1	applied	\N	\N	\N	\N	217995	217995	385052
29399	48094	2	applied	\N	\N	\N	\N	217996	217996	385053
29409	48114	0	applied	\N	\N	\N	\N	218060	218060	385117
29409	48115	1	applied	\N	\N	\N	\N	218061	218061	385118
29409	48116	2	applied	\N	\N	\N	\N	218062	218062	385119
29409	48117	3	applied	\N	\N	\N	\N	218063	218063	385120
29418	48141	0	applied	\N	\N	\N	\N	218117	218117	385174
29418	48139	1	applied	\N	\N	\N	\N	218118	218118	385175
29418	48140	2	applied	\N	\N	\N	\N	218119	218119	385176
29418	48142	3	applied	\N	\N	\N	\N	218120	218120	385177
29428	48161	1	applied	\N	\N	\N	\N	218159	218159	385216
29428	48162	2	applied	\N	\N	\N	\N	218160	218160	385217
29391	47911	24	applied	\N	\N	\N	\N	217870	217870	384927
29391	47915	25	applied	\N	\N	\N	\N	217871	217871	384928
29415	48133	6	applied	\N	\N	\N	\N	218108	218108	385165
29415	48134	7	applied	\N	\N	\N	\N	218109	218109	385166
29415	48135	8	applied	\N	\N	1000000000	\N	218110	218110	385167
29415	48136	9	applied	\N	\N	\N	\N	218111	218111	385168
29415	48137	10	applied	\N	\N	\N	\N	218112	218112	385169
29420	48141	0	applied	\N	\N	\N	\N	218125	218125	385182
29420	48139	1	applied	\N	\N	\N	\N	218126	218126	385183
29420	48140	2	applied	\N	\N	\N	\N	218127	218127	385184
29420	48142	3	applied	\N	\N	\N	\N	218128	218128	385185
29422	48147	1	applied	\N	\N	\N	\N	218133	218133	385190
29422	48148	2	applied	\N	\N	\N	\N	218134	218134	385191
29422	48149	3	applied	\N	\N	\N	\N	218135	218135	385192
29424	48146	0	applied	\N	\N	1000000000	\N	218140	218140	385197
29424	48147	1	applied	\N	\N	\N	\N	218141	218141	385198
29424	48148	2	applied	\N	\N	\N	\N	218142	218142	385199
29424	48149	3	applied	\N	\N	\N	\N	218143	218143	385200
29428	48163	3	applied	\N	\N	\N	\N	218161	218161	385218
29430	48164	0	applied	\N	\N	\N	\N	218165	218165	385222
29430	48165	1	applied	\N	\N	\N	\N	218166	218166	385223
29430	48166	2	applied	\N	\N	\N	\N	218167	218167	385224
29432	48164	0	applied	\N	\N	\N	\N	218171	218171	385228
29432	48165	1	applied	\N	\N	\N	\N	218172	218172	385229
29432	48166	2	applied	\N	\N	\N	\N	218173	218173	385230
29434	48164	0	applied	\N	\N	\N	\N	218177	218177	385234
29434	48165	1	applied	\N	\N	\N	\N	218178	218178	385235
29434	48166	2	applied	\N	\N	\N	\N	218179	218179	385236
29443	48198	0	applied	\N	\N	\N	\N	218239	218239	385296
29445	48198	0	applied	\N	\N	\N	\N	218243	218243	385300
29445	48199	1	applied	\N	\N	\N	\N	218244	218244	385301
29448	48209	0	applied	\N	\N	\N	\N	218254	218254	385309
29448	48210	1	applied	\N	\N	\N	\N	218255	218255	385310
29448	48211	2	applied	\N	\N	\N	\N	218256	218256	385311
29448	48212	3	applied	\N	\N	\N	\N	218257	218257	385312
29448	48213	4	applied	\N	\N	\N	\N	218258	218258	385313
29448	48214	5	applied	\N	\N	\N	\N	218259	218259	385314
29448	48215	6	applied	\N	\N	\N	\N	218260	218260	385315
29448	48216	7	applied	\N	\N	\N	\N	218261	218261	385316
29448	48217	8	applied	\N	\N	\N	\N	218262	218262	385317
29450	48218	0	applied	\N	\N	\N	\N	218265	218265	385320
29450	48219	1	applied	\N	\N	\N	\N	218266	218266	385321
29450	48220	2	applied	\N	\N	\N	\N	218267	218267	385322
29452	48227	0	applied	\N	\N	\N	\N	218275	218275	385330
29452	48228	1	applied	\N	\N	\N	\N	218276	218276	385331
29452	48230	3	applied	\N	\N	\N	\N	218278	218278	385333
29463	48250	0	applied	\N	\N	\N	\N	218326	218326	385381
29463	48251	1	applied	\N	\N	\N	\N	218327	218327	385382
29463	48252	2	applied	\N	\N	\N	\N	218328	218328	385383
29466	48253	0	applied	\N	\N	\N	\N	218340	218340	385395
29466	48254	1	applied	\N	\N	\N	\N	218341	218341	385396
29466	48255	2	applied	\N	\N	\N	\N	218342	218342	385397
29466	48256	3	applied	\N	\N	\N	\N	218343	218343	385398
29466	48257	4	applied	\N	\N	\N	\N	218344	218344	385399
29466	48258	5	applied	\N	\N	\N	\N	218345	218345	385400
29466	48259	6	applied	\N	\N	\N	\N	218346	218346	385401
29466	48260	7	applied	\N	\N	\N	\N	218347	218347	385402
29468	48265	0	applied	\N	\N	\N	\N	218352	218352	385407
29468	48266	1	applied	\N	\N	\N	\N	218353	218353	385408
29468	48267	2	applied	\N	\N	\N	\N	218354	218354	385409
29468	48269	4	applied	\N	\N	\N	\N	218356	218356	385411
29468	48270	5	applied	\N	\N	\N	\N	218357	218357	385412
29468	48271	6	applied	\N	\N	\N	\N	218358	218358	385413
29468	48272	7	applied	\N	\N	\N	\N	218359	218359	385414
29473	48280	0	applied	\N	\N	\N	\N	218378	218378	385433
29473	48281	1	applied	\N	\N	\N	\N	218379	218379	385434
29473	48282	2	applied	\N	\N	\N	\N	218380	218380	385435
29473	48283	3	applied	\N	\N	\N	\N	218381	218381	385436
29477	48291	0	applied	\N	\N	\N	\N	218407	218407	218407
29477	48292	1	applied	\N	\N	\N	\N	218408	218408	385461
29477	48293	2	applied	\N	\N	\N	\N	218409	218409	385462
29477	48294	3	applied	\N	\N	\N	\N	218410	218410	385463
29477	48295	4	applied	\N	\N	\N	\N	218411	218411	385464
29477	48296	5	applied	\N	\N	\N	\N	218412	218412	385465
29477	48297	6	applied	\N	\N	\N	\N	218413	218413	385466
29477	48298	7	applied	\N	\N	\N	\N	218414	218414	385467
29477	48299	8	applied	\N	\N	\N	\N	218415	218415	385468
29477	48300	9	applied	\N	\N	\N	\N	218416	218416	385469
29477	48301	10	applied	\N	\N	\N	\N	218417	218417	385470
29479	48292	1	applied	\N	\N	\N	\N	218430	218430	385481
29479	48293	2	applied	\N	\N	\N	\N	218431	218431	385482
29479	48294	3	applied	\N	\N	\N	\N	218432	218432	385483
29479	48295	4	applied	\N	\N	\N	\N	218433	218433	385484
29479	48296	5	applied	\N	\N	\N	\N	218434	218434	385485
29479	48297	6	applied	\N	\N	\N	\N	218435	218435	385486
29479	48298	7	applied	\N	\N	\N	\N	218436	218436	385487
29479	48299	8	applied	\N	\N	\N	\N	218437	218437	385488
29479	48300	9	applied	\N	\N	\N	\N	218438	218438	385489
29479	48301	10	applied	\N	\N	\N	\N	218439	218439	385490
29481	48291	0	applied	\N	\N	\N	\N	218451	218451	218451
29481	48292	1	applied	\N	\N	\N	\N	218452	218452	385501
29481	48293	2	applied	\N	\N	\N	\N	218453	218453	385502
29481	48294	3	applied	\N	\N	\N	\N	218454	218454	385503
29481	48295	4	applied	\N	\N	\N	\N	218455	218455	385504
29481	48296	5	applied	\N	\N	\N	\N	218456	218456	385505
29481	48298	7	applied	\N	\N	\N	\N	218458	218458	385507
29481	48299	8	applied	\N	\N	\N	\N	218459	218459	385508
29481	48300	9	applied	\N	\N	\N	\N	218460	218460	385509
29481	48301	10	applied	\N	\N	\N	\N	218461	218461	385510
29483	48302	0	applied	\N	\N	\N	\N	218473	218473	385521
29483	48303	1	applied	\N	\N	\N	\N	218474	218474	385522
29483	48304	2	applied	\N	\N	\N	\N	218475	218475	385523
29485	48302	0	applied	\N	\N	\N	\N	218479	218479	385527
29485	48303	1	applied	\N	\N	\N	\N	218480	218480	385528
29485	48304	2	applied	\N	\N	\N	\N	218481	218481	385529
29486	48305	0	applied	\N	\N	\N	\N	218482	218482	385530
29486	48306	1	applied	\N	\N	\N	\N	218483	218483	385531
29486	48307	2	applied	\N	\N	\N	\N	218484	218484	385532
29486	48308	3	applied	\N	\N	\N	\N	218485	218485	385533
29486	48309	4	applied	\N	\N	\N	\N	218486	218486	385534
29486	48310	5	applied	\N	\N	\N	\N	218487	218487	385535
29415	48131	4	applied	\N	\N	\N	\N	218106	218106	385163
29415	48132	5	applied	\N	\N	\N	\N	218107	218107	385164
29431	48164	0	applied	\N	\N	\N	\N	218168	218168	385225
29431	48165	1	applied	\N	\N	\N	\N	218169	218169	385226
29431	48166	2	applied	\N	\N	\N	\N	218170	218170	385227
29433	48164	0	applied	\N	\N	\N	\N	218174	218174	385231
29433	48165	1	applied	\N	\N	\N	\N	218175	218175	385232
29433	48166	2	applied	\N	\N	\N	\N	218176	218176	385233
29436	48170	0	applied	\N	\N	\N	\N	218183	218183	385240
29436	48171	1	applied	\N	\N	\N	\N	218184	218184	385241
29436	48172	2	applied	\N	\N	\N	\N	218185	218185	385242
29438	48178	0	applied	\N	\N	\N	\N	218191	218191	385248
29438	48179	1	applied	\N	\N	\N	\N	218192	218192	385249
29438	48180	2	applied	\N	\N	\N	\N	218193	218193	385250
29440	48184	0	applied	\N	\N	\N	\N	218197	218197	385254
29440	48185	1	applied	\N	\N	\N	\N	218198	218198	385255
29440	48186	2	applied	\N	\N	\N	\N	218199	218199	385256
29440	48187	3	applied	\N	\N	\N	\N	218200	218200	385257
29440	48188	4	applied	\N	\N	\N	\N	218201	218201	385258
29440	48189	5	applied	\N	\N	\N	\N	218202	218202	385259
29440	48190	6	applied	\N	\N	\N	\N	218203	218203	385260
29440	48191	7	applied	\N	\N	1000000000	\N	218204	218204	385261
29440	48192	8	applied	\N	\N	1000000000	\N	218205	218205	385262
29440	48193	9	applied	\N	\N	\N	\N	218206	218206	385263
29440	48194	10	applied	\N	\N	\N	\N	218207	218207	385264
29440	48195	11	applied	\N	\N	\N	\N	218208	218208	385265
29440	48196	12	applied	\N	\N	\N	\N	218209	218209	385266
29442	48184	0	applied	\N	\N	\N	\N	218225	218225	385282
29442	48185	1	applied	\N	\N	\N	\N	218226	218226	385283
29442	48186	2	applied	\N	\N	\N	\N	218227	218227	385284
29442	48187	3	applied	\N	\N	\N	\N	218228	218228	385285
29442	48188	4	applied	\N	\N	\N	\N	218229	218229	385286
29442	48189	5	applied	\N	\N	\N	\N	218230	218230	385287
29442	48190	6	applied	\N	\N	\N	\N	218231	218231	385288
29442	48191	7	applied	\N	\N	1000000000	\N	218232	218232	385289
29442	48192	8	applied	\N	\N	1000000000	\N	218233	218233	385290
29442	48193	9	applied	\N	\N	\N	\N	218234	218234	385291
29442	48194	10	applied	\N	\N	\N	\N	218235	218235	385292
29442	48195	11	applied	\N	\N	\N	\N	218236	218236	385293
29442	48196	12	applied	\N	\N	\N	\N	218237	218237	385294
29442	48197	13	applied	\N	\N	\N	\N	218238	218238	385295
29444	48198	0	applied	\N	\N	\N	\N	218241	218241	385298
29444	48199	1	applied	\N	\N	\N	\N	218242	218242	385299
29446	48201	1	applied	\N	\N	\N	\N	218246	218246	218246
29446	48202	2	applied	\N	\N	\N	\N	218247	218247	385302
29446	48203	3	applied	\N	\N	\N	\N	218248	218248	385303
29446	48204	4	applied	\N	\N	\N	\N	218249	218249	385304
29446	48205	5	applied	\N	\N	\N	\N	218250	218250	385305
29447	48206	0	applied	\N	\N	\N	\N	218251	218251	385306
29447	48207	1	applied	\N	\N	\N	\N	218252	218252	385307
29447	48208	2	applied	\N	\N	\N	\N	218253	218253	385308
29449	48218	0	applied	\N	\N	\N	\N	218263	218263	385318
29449	48219	1	applied	\N	\N	\N	\N	218264	218264	385319
29454	48231	0	applied	\N	\N	\N	\N	218283	218283	385338
29454	48232	1	applied	\N	\N	\N	\N	218284	218284	385339
29456	48237	0	applied	\N	\N	\N	\N	218289	218289	385344
29456	48238	1	applied	\N	\N	\N	\N	218290	218290	385345
29456	48239	2	applied	\N	\N	\N	\N	218291	218291	385346
29457	48240	0	applied	\N	\N	\N	\N	218292	218292	385347
29457	48242	2	applied	\N	\N	\N	\N	218294	218294	385349
29457	48243	3	applied	\N	\N	\N	\N	218295	218295	385350
29457	48244	4	applied	\N	\N	\N	\N	218296	218296	385351
29457	48245	5	applied	\N	\N	\N	\N	218297	218297	385352
29457	48246	6	applied	\N	\N	\N	\N	218298	218298	385353
29458	48240	0	applied	\N	\N	\N	\N	218299	218299	385354
29458	48241	1	applied	\N	\N	\N	\N	218300	218300	385355
29459	48240	0	applied	\N	\N	\N	\N	218306	218306	385361
29459	48241	1	applied	\N	\N	\N	\N	218307	218307	385362
29459	48242	2	applied	\N	\N	\N	\N	218308	218308	385363
29459	48243	3	applied	\N	\N	\N	\N	218309	218309	385364
29459	48244	4	applied	\N	\N	\N	\N	218310	218310	385365
29459	48245	5	applied	\N	\N	\N	\N	218311	218311	385366
29459	48246	6	applied	\N	\N	\N	\N	218312	218312	385367
29461	48247	0	applied	\N	\N	\N	\N	218320	218320	385375
29461	48248	1	applied	\N	\N	\N	\N	218321	218321	385376
29470	48273	0	applied	\N	\N	\N	\N	218368	218368	385423
29470	48274	1	applied	\N	\N	\N	\N	218369	218369	385424
29470	48275	2	applied	\N	\N	\N	\N	218370	218370	385425
29470	48276	3	applied	\N	\N	\N	\N	218371	218371	385426
29472	48277	0	applied	\N	\N	\N	\N	218375	218375	385430
29472	48278	1	applied	\N	\N	\N	\N	218376	218376	385431
29472	48279	2	applied	\N	\N	\N	\N	218377	218377	385432
29475	48284	0	applied	\N	\N	\N	\N	218389	218389	385444
29475	48285	1	applied	\N	\N	\N	\N	218390	218390	385445
29475	48286	2	applied	\N	\N	\N	\N	218391	218391	385446
29475	48287	3	applied	\N	\N	\N	\N	218392	218392	385447
29475	48288	4	applied	\N	\N	\N	\N	218393	218393	385448
29475	48289	5	applied	\N	\N	\N	\N	218394	218394	385449
29475	48290	6	applied	\N	\N	\N	\N	218395	218395	385450
29482	48291	0	applied	\N	\N	\N	\N	218462	218462	218462
29482	48292	1	applied	\N	\N	\N	\N	218463	218463	385511
29482	48294	3	applied	\N	\N	\N	\N	218465	218465	385513
29482	48295	4	applied	\N	\N	\N	\N	218466	218466	385514
29482	48296	5	applied	\N	\N	\N	\N	218467	218467	385515
29482	48297	6	applied	\N	\N	\N	\N	218468	218468	385516
29482	48298	7	applied	\N	\N	\N	\N	218469	218469	385517
29482	48299	8	applied	\N	\N	\N	\N	218470	218470	385518
29482	48300	9	applied	\N	\N	\N	\N	218471	218471	385519
29482	48301	10	applied	\N	\N	\N	\N	218472	218472	385520
29490	48320	0	applied	\N	\N	\N	\N	218511	218511	385559
29490	48321	1	applied	\N	\N	\N	\N	218512	218512	385560
29490	48322	2	applied	\N	\N	\N	\N	218513	218513	385561
29490	48323	3	applied	\N	\N	\N	\N	218514	218514	385562
29490	48324	4	applied	\N	\N	\N	\N	218515	218515	385563
29490	48325	5	applied	\N	\N	\N	\N	218516	218516	385564
29490	48326	6	applied	\N	\N	\N	\N	218517	218517	385565
29491	48327	0	applied	\N	\N	\N	\N	218518	218518	385566
29491	48329	2	applied	\N	\N	\N	\N	218520	218520	385568
29491	48330	3	applied	\N	\N	\N	\N	218521	218521	385569
29491	48331	4	applied	\N	\N	\N	\N	218522	218522	385570
29491	48332	5	applied	\N	\N	\N	\N	218523	218523	385571
29426	48158	3	applied	\N	\N	\N	\N	218152	218152	385209
29426	48159	4	applied	\N	\N	\N	\N	218153	218153	385210
29429	48164	0	applied	\N	\N	\N	\N	218162	218162	385219
29429	48165	1	applied	\N	\N	\N	\N	218163	218163	385220
29429	48166	2	applied	\N	\N	\N	\N	218164	218164	385221
29435	48167	0	applied	\N	\N	\N	\N	218180	218180	385237
29435	48168	1	applied	\N	\N	\N	\N	218181	218181	385238
29435	48169	2	applied	\N	\N	\N	\N	218182	218182	385239
29437	48174	0	applied	\N	\N	\N	\N	218187	218187	385244
29437	48175	1	applied	\N	\N	\N	\N	218188	218188	385245
29437	48176	2	applied	\N	\N	\N	\N	218189	218189	385246
29437	48177	3	applied	\N	\N	\N	\N	218190	218190	385247
29439	48181	0	applied	\N	\N	\N	\N	218194	218194	385251
29439	48182	1	applied	\N	\N	\N	\N	218195	218195	385252
29439	48183	2	applied	\N	\N	\N	\N	218196	218196	385253
29441	48184	0	applied	\N	\N	\N	\N	218211	218211	385268
29441	48186	2	applied	\N	\N	\N	\N	218213	218213	385270
29458	48242	2	applied	\N	\N	\N	\N	218301	218301	385356
29458	48243	3	applied	\N	\N	\N	\N	218302	218302	385357
29458	48244	4	applied	\N	\N	\N	\N	218303	218303	385358
29458	48245	5	applied	\N	\N	\N	\N	218304	218304	385359
29458	48246	6	applied	\N	\N	\N	\N	218305	218305	385360
29460	48240	0	applied	\N	\N	\N	\N	218313	218313	385368
29460	48241	1	applied	\N	\N	\N	\N	218314	218314	385369
29460	48242	2	applied	\N	\N	\N	\N	218315	218315	385370
29460	48243	3	applied	\N	\N	\N	\N	218316	218316	385371
29460	48244	4	applied	\N	\N	\N	\N	218317	218317	385372
29460	48245	5	applied	\N	\N	\N	\N	218318	218318	385373
29460	48246	6	applied	\N	\N	\N	\N	218319	218319	385374
29465	48253	0	applied	\N	\N	\N	\N	218332	218332	385387
29465	48254	1	applied	\N	\N	\N	\N	218333	218333	385388
29465	48255	2	applied	\N	\N	\N	\N	218334	218334	385389
29465	48257	4	applied	\N	\N	\N	\N	218336	218336	385391
29465	48258	5	applied	\N	\N	\N	\N	218337	218337	385392
29465	48259	6	applied	\N	\N	\N	\N	218338	218338	385393
29465	48260	7	applied	\N	\N	\N	\N	218339	218339	385394
29467	48261	0	applied	\N	\N	\N	\N	218348	218348	385403
29467	48262	1	applied	\N	\N	\N	\N	218349	218349	385404
29467	48263	2	applied	\N	\N	\N	\N	218350	218350	385405
29467	48264	3	applied	\N	\N	\N	\N	218351	218351	385406
29469	48265	0	applied	\N	\N	\N	\N	218360	218360	385415
29469	48266	1	applied	\N	\N	\N	\N	218361	218361	385416
29469	48267	2	applied	\N	\N	\N	\N	218362	218362	385417
29469	48268	3	applied	\N	\N	1000000000	\N	218363	218363	385418
29469	48269	4	applied	\N	\N	\N	\N	218364	218364	385419
29469	48270	5	applied	\N	\N	\N	\N	218365	218365	385420
29469	48271	6	applied	\N	\N	\N	\N	218366	218366	385421
29469	48272	7	applied	\N	\N	\N	\N	218367	218367	385422
29471	48278	1	applied	\N	\N	\N	\N	218373	218373	385428
29471	48279	2	applied	\N	\N	\N	\N	218374	218374	385429
29474	48284	0	applied	\N	\N	\N	\N	218382	218382	385437
29474	48285	1	applied	\N	\N	\N	\N	218383	218383	385438
29474	48286	2	applied	\N	\N	\N	\N	218384	218384	385439
29474	48287	3	applied	\N	\N	\N	\N	218385	218385	385440
29474	48288	4	applied	\N	\N	\N	\N	218386	218386	385441
29474	48289	5	applied	\N	\N	\N	\N	218387	218387	385442
29474	48290	6	applied	\N	\N	\N	\N	218388	218388	385443
29478	48291	0	applied	\N	\N	\N	\N	218418	218418	218418
29478	48292	1	applied	\N	\N	\N	\N	218419	218419	385471
29478	48293	2	applied	\N	\N	\N	\N	218420	218420	385472
29478	48294	3	applied	\N	\N	\N	\N	218421	218421	385473
29478	48295	4	applied	\N	\N	\N	\N	218422	218422	385474
29478	48296	5	applied	\N	\N	\N	\N	218423	218423	385475
29478	48297	6	applied	\N	\N	\N	\N	218424	218424	385476
29478	48299	8	applied	\N	\N	\N	\N	218426	218426	385478
29478	48300	9	applied	\N	\N	\N	\N	218427	218427	385479
29478	48301	10	applied	\N	\N	\N	\N	218428	218428	385480
29480	48291	0	applied	\N	\N	\N	\N	218440	218440	218440
29480	48292	1	applied	\N	\N	\N	\N	218441	218441	385491
29480	48293	2	applied	\N	\N	\N	\N	218442	218442	385492
29480	48294	3	applied	\N	\N	\N	\N	218443	218443	385493
29480	48295	4	applied	\N	\N	\N	\N	218444	218444	385494
29480	48296	5	applied	\N	\N	\N	\N	218445	218445	385495
29480	48297	6	applied	\N	\N	\N	\N	218446	218446	385496
29480	48298	7	applied	\N	\N	\N	\N	218447	218447	385497
29480	48299	8	applied	\N	\N	\N	\N	218448	218448	385498
29480	48300	9	applied	\N	\N	\N	\N	218449	218449	385499
29480	48301	10	applied	\N	\N	\N	\N	218450	218450	385500
29484	48302	0	applied	\N	\N	\N	\N	218476	218476	385524
29484	48303	1	applied	\N	\N	\N	\N	218477	218477	385525
29488	48320	0	applied	\N	\N	\N	\N	218497	218497	385545
29488	48321	1	applied	\N	\N	\N	\N	218498	218498	385546
29488	48322	2	applied	\N	\N	\N	\N	218499	218499	385547
29488	48323	3	applied	\N	\N	\N	\N	218500	218500	385548
29488	48324	4	applied	\N	\N	\N	\N	218501	218501	385549
29488	48325	5	applied	\N	\N	\N	\N	218502	218502	385550
29488	48326	6	applied	\N	\N	\N	\N	218503	218503	385551
29497	48341	0	applied	\N	\N	\N	\N	218543	218543	385591
29497	48342	1	applied	\N	\N	\N	\N	218544	218544	385592
29497	48343	2	applied	\N	\N	\N	\N	218545	218545	385593
29499	48348	0	applied	\N	\N	\N	\N	218550	218550	385598
29499	48349	1	applied	\N	\N	\N	\N	218551	218551	385599
29501	48350	0	applied	\N	\N	\N	\N	218554	218554	385602
29501	48351	1	applied	\N	\N	\N	\N	218555	218555	385603
29507	48369	0	applied	\N	\N	\N	\N	218573	218573	385621
29507	48370	1	applied	\N	\N	\N	\N	218574	218574	385622
29509	48372	0	applied	\N	\N	\N	\N	218579	218579	385627
29509	48373	1	applied	\N	\N	\N	\N	218580	218580	218580
29509	48374	2	applied	\N	\N	\N	\N	218581	218581	385628
29509	48375	3	applied	\N	\N	\N	\N	218582	218582	385629
29515	48387	0	applied	\N	\N	\N	\N	218612	218612	385656
29515	48388	1	applied	\N	\N	\N	\N	218613	218613	385657
29515	48389	2	applied	\N	\N	\N	\N	218614	218614	385658
29515	48390	4	applied	\N	\N	\N	\N	218615	218615	385659
29515	48391	5	applied	\N	\N	\N	\N	218616	218616	385660
29515	48392	6	applied	\N	\N	\N	\N	218617	218617	385661
29515	48393	7	applied	\N	\N	\N	\N	218618	218618	385662
29520	48405	0	applied	\N	\N	\N	\N	218646	218646	385690
29520	48406	1	applied	\N	\N	\N	\N	218647	218647	385691
29522	48405	0	applied	\N	\N	\N	\N	218650	218650	385694
29522	48406	1	applied	\N	\N	\N	\N	218651	218651	385695
29524	48407	0	applied	\N	\N	\N	\N	218654	218654	385698
29427	48163	3	applied	\N	\N	\N	\N	218157	218157	385214
29441	48190	6	applied	\N	\N	\N	\N	218217	218217	385274
29441	48191	7	applied	\N	\N	1000000000	\N	218218	218218	385275
29441	48192	8	applied	\N	\N	1000000000	\N	218219	218219	385276
29441	48193	9	applied	\N	\N	\N	\N	218220	218220	385277
29441	48194	10	applied	\N	\N	\N	\N	218221	218221	385278
29441	48195	11	applied	\N	\N	\N	\N	218222	218222	385279
29441	48196	12	applied	\N	\N	\N	\N	218223	218223	385280
29441	48197	13	applied	\N	\N	\N	\N	218224	218224	385281
29451	48221	0	applied	\N	\N	\N	\N	218268	218268	385323
29451	48222	1	applied	\N	\N	\N	\N	218269	218269	385324
29451	48223	2	applied	\N	\N	\N	\N	218270	218270	385325
29451	48224	3	applied	\N	\N	\N	\N	218271	218271	385326
29451	48220	4	applied	\N	\N	\N	\N	218272	218272	385327
29451	48226	6	applied	\N	\N	\N	\N	218274	218274	385329
29453	48227	0	applied	\N	\N	\N	\N	218279	218279	385334
29453	48228	1	applied	\N	\N	\N	\N	218280	218280	385335
29453	48229	2	applied	\N	\N	\N	\N	218281	218281	385336
29453	48230	3	applied	\N	\N	\N	\N	218282	218282	385337
29455	48233	0	applied	\N	\N	\N	\N	218285	218285	385340
29455	48234	1	applied	\N	\N	\N	\N	218286	218286	385341
29455	48235	2	applied	\N	\N	\N	\N	218287	218287	385342
29455	48236	3	applied	\N	\N	\N	\N	218288	218288	385343
29462	48247	0	applied	\N	\N	\N	\N	218323	218323	385378
29462	48248	1	applied	\N	\N	\N	\N	218324	218324	385379
29462	48249	2	applied	\N	\N	\N	\N	218325	218325	385380
29464	48250	0	applied	\N	\N	\N	\N	218329	218329	385384
29464	48251	1	applied	\N	\N	\N	\N	218330	218330	385385
29464	48252	2	applied	\N	\N	\N	\N	218331	218331	385386
29476	48291	0	applied	\N	\N	\N	\N	218396	218396	218396
29476	48293	2	applied	\N	\N	\N	\N	218398	218398	385452
29476	48294	3	applied	\N	\N	\N	\N	218399	218399	385453
29476	48295	4	applied	\N	\N	\N	\N	218400	218400	385454
29476	48296	5	applied	\N	\N	\N	\N	218401	218401	385455
29476	48297	6	applied	\N	\N	\N	\N	218402	218402	385456
29476	48298	7	applied	\N	\N	\N	\N	218403	218403	385457
29476	48299	8	applied	\N	\N	\N	\N	218404	218404	385458
29476	48300	9	applied	\N	\N	\N	\N	218405	218405	385459
29476	48301	10	applied	\N	\N	\N	\N	218406	218406	385460
29486	48312	7	applied	\N	\N	\N	\N	218489	218489	385537
29486	48313	8	applied	\N	\N	\N	\N	218490	218490	385538
29487	48314	0	applied	\N	\N	\N	\N	218491	218491	385539
29487	48315	1	applied	\N	\N	\N	\N	218492	218492	385540
29487	48316	2	applied	\N	\N	\N	\N	218493	218493	385541
29487	48317	3	applied	\N	\N	\N	\N	218494	218494	385542
29487	48318	4	applied	\N	\N	\N	\N	218495	218495	385543
29489	48320	0	applied	\N	\N	\N	\N	218504	218504	385552
29489	48321	1	applied	\N	\N	\N	\N	218505	218505	385553
29489	48322	2	applied	\N	\N	\N	\N	218506	218506	385554
29489	48323	3	applied	\N	\N	\N	\N	218507	218507	385555
29489	48324	4	applied	\N	\N	\N	\N	218508	218508	385556
29489	48325	5	applied	\N	\N	\N	\N	218509	218509	385557
29489	48326	6	applied	\N	\N	\N	\N	218510	218510	385558
29492	48339	0	applied	\N	\N	\N	\N	218530	218530	385578
29492	48340	1	applied	\N	\N	\N	\N	218531	218531	385579
29494	48341	0	applied	\N	\N	\N	\N	218534	218534	385582
29494	48342	1	applied	\N	\N	\N	\N	218535	218535	385583
29494	48343	2	applied	\N	\N	\N	\N	218536	218536	385584
29496	48341	0	applied	\N	\N	\N	\N	218540	218540	385588
29496	48342	1	applied	\N	\N	\N	\N	218541	218541	385589
29496	48343	2	applied	\N	\N	\N	\N	218542	218542	385590
29500	48350	0	applied	\N	\N	\N	\N	218552	218552	385600
29502	48352	0	applied	\N	\N	\N	\N	218556	218556	385604
29502	48353	1	applied	\N	\N	\N	\N	218557	218557	385605
29502	48354	2	applied	\N	\N	\N	\N	218558	218558	385606
29502	48355	3	applied	\N	\N	\N	\N	218559	218559	385607
29504	48358	0	applied	\N	\N	\N	\N	218562	218562	385610
29504	48359	1	applied	\N	\N	\N	\N	218563	218563	385611
29504	48360	2	applied	\N	\N	\N	\N	218564	218564	385612
29505	48361	0	applied	\N	\N	\N	\N	218565	218565	385613
29505	48362	1	applied	\N	\N	\N	\N	218566	218566	385614
29505	48363	2	applied	\N	\N	\N	\N	218567	218567	385615
29506	48364	0	applied	\N	\N	\N	\N	218568	218568	385616
29506	48365	1	applied	\N	\N	\N	\N	218569	218569	385617
29506	48366	2	applied	\N	\N	\N	\N	218570	218570	385618
29506	48367	3	applied	\N	\N	\N	\N	218571	218571	385619
29506	48368	4	applied	\N	\N	\N	\N	218572	218572	385620
29508	48369	0	applied	\N	\N	\N	\N	218576	218576	385624
29508	48371	2	applied	\N	\N	\N	\N	218578	218578	385626
29510	48376	0	applied	\N	\N	\N	\N	218583	218583	385630
29510	48377	1	applied	\N	\N	\N	\N	218584	218584	385631
29510	48378	2	applied	\N	\N	\N	\N	218585	218585	218585
29510	48379	3	applied	\N	\N	\N	\N	218586	218586	385632
29510	48380	4	applied	\N	\N	\N	\N	218587	218587	385633
29510	48381	5	applied	\N	\N	\N	\N	218588	218588	385634
29510	48382	6	applied	\N	\N	\N	\N	218589	218589	385635
29513	48383	0	applied	\N	\N	\N	\N	218604	218604	385648
29513	48384	1	applied	\N	\N	\N	\N	218605	218605	385649
29513	48385	2	applied	\N	\N	\N	\N	218606	218606	385650
29513	48386	3	applied	\N	\N	\N	\N	218607	218607	385651
29516	48387	0	applied	\N	\N	\N	\N	218619	218619	385663
29516	48388	1	applied	\N	\N	\N	\N	218620	218620	385664
29516	48389	2	applied	\N	\N	\N	\N	218621	218621	385665
29516	48390	4	applied	\N	\N	\N	\N	218622	218622	385666
29516	48392	6	applied	\N	\N	\N	\N	218624	218624	385668
29516	48393	7	applied	\N	\N	\N	\N	218625	218625	385669
29518	48394	0	applied	\N	\N	\N	\N	218633	218633	385677
29518	48395	1	applied	\N	\N	\N	\N	218634	218634	385678
29518	48396	2	applied	\N	\N	\N	\N	218635	218635	385679
29518	48397	3	applied	\N	\N	\N	\N	218636	218636	385680
29518	48398	4	applied	\N	\N	\N	\N	218637	218637	385681
29518	48399	5	applied	\N	\N	\N	\N	218638	218638	385682
29518	48400	6	applied	\N	\N	\N	\N	218639	218639	385683
29518	48401	7	applied	\N	\N	\N	\N	218640	218640	385684
29518	48402	8	applied	\N	\N	\N	\N	218641	218641	385685
29518	48403	9	applied	\N	\N	\N	\N	218642	218642	385686
29518	48404	10	applied	\N	\N	\N	\N	218643	218643	385687
29523	48405	0	applied	\N	\N	\N	\N	218652	218652	385696
29523	48406	1	applied	\N	\N	\N	\N	218653	218653	385697
29525	48407	0	applied	\N	\N	\N	\N	218660	218660	385704
29441	48188	4	applied	\N	\N	\N	\N	218215	218215	385272
29441	48189	5	applied	\N	\N	\N	\N	218216	218216	385273
29491	48337	10	applied	\N	\N	\N	\N	218528	218528	385576
29491	48338	11	applied	\N	\N	\N	\N	218529	218529	385577
29493	48339	0	applied	\N	\N	\N	\N	218532	218532	385580
29493	48340	1	applied	\N	\N	\N	\N	218533	218533	385581
29495	48341	0	applied	\N	\N	\N	\N	218537	218537	385585
29495	48342	1	applied	\N	\N	\N	\N	218538	218538	385586
29495	48343	2	applied	\N	\N	\N	\N	218539	218539	385587
29498	48344	0	applied	\N	\N	\N	\N	218546	218546	385594
29498	48345	1	applied	\N	\N	\N	\N	218547	218547	385595
29498	48346	2	applied	\N	\N	\N	\N	218548	218548	385596
29498	48347	3	applied	\N	\N	\N	\N	218549	218549	385597
29503	48356	0	applied	\N	\N	\N	\N	218560	218560	385608
29503	48357	1	applied	\N	\N	\N	\N	218561	218561	385609
29511	48376	0	applied	\N	\N	\N	\N	218590	218590	385636
29511	48377	1	applied	\N	\N	\N	\N	218591	218591	385637
29511	48378	2	applied	\N	\N	\N	\N	218592	218592	218592
29512	48377	1	applied	\N	\N	\N	\N	218598	218598	385643
29512	48378	2	applied	\N	\N	\N	\N	218599	218599	218599
29512	48379	3	applied	\N	\N	\N	\N	218600	218600	385644
29512	48380	4	applied	\N	\N	\N	\N	218601	218601	385645
29512	48381	5	applied	\N	\N	\N	\N	218602	218602	385646
29512	48382	6	applied	\N	\N	\N	\N	218603	218603	385647
29514	48383	0	applied	\N	\N	\N	\N	218608	218608	385652
29514	48384	1	applied	\N	\N	\N	\N	218609	218609	385653
29514	48385	2	applied	\N	\N	\N	\N	218610	218610	385654
29514	48386	3	applied	\N	\N	\N	\N	218611	218611	385655
29517	48387	0	applied	\N	\N	\N	\N	218626	218626	385670
29517	48388	1	applied	\N	\N	\N	\N	218627	218627	385671
29517	48389	2	applied	\N	\N	\N	\N	218628	218628	385672
29517	48390	4	applied	\N	\N	\N	\N	218629	218629	385673
29517	48391	5	applied	\N	\N	\N	\N	218630	218630	385674
29517	48392	6	applied	\N	\N	\N	\N	218631	218631	385675
29521	48405	0	applied	\N	\N	\N	\N	218648	218648	385692
29521	48406	1	applied	\N	\N	\N	\N	218649	218649	385693
29526	48413	0	applied	\N	\N	\N	\N	218666	218666	385710
29526	48414	1	applied	\N	\N	\N	\N	218667	218667	385711
29526	48415	2	applied	\N	\N	\N	\N	218668	218668	385712
29526	48416	3	applied	\N	\N	\N	\N	218669	218669	385713
29528	48417	0	applied	\N	\N	\N	\N	218674	218674	385718
29528	48418	1	applied	\N	\N	\N	\N	218675	218675	385719
29530	48419	0	applied	\N	\N	\N	\N	218773	218773	385814
29530	48420	1	applied	\N	\N	\N	\N	218774	218774	385815
29530	48421	2	applied	\N	\N	\N	\N	218775	218775	385816
29530	48422	3	applied	\N	\N	\N	\N	218776	218776	385817
29532	48419	0	applied	\N	\N	\N	\N	218781	218781	385822
29532	48420	1	applied	\N	\N	\N	\N	218782	218782	385823
29532	48421	2	applied	\N	\N	\N	\N	218783	218783	385824
29532	48422	3	applied	\N	\N	\N	\N	218784	218784	385825
29534	48420	1	applied	\N	\N	\N	\N	218790	218790	385831
29534	48421	2	applied	\N	\N	\N	\N	218791	218791	385832
29534	48422	3	applied	\N	\N	\N	\N	218792	218792	385833
29536	48423	0	applied	\N	\N	\N	\N	218793	218793	385834
29536	48424	1	applied	\N	\N	\N	\N	218794	218794	385835
29536	48425	2	applied	\N	\N	\N	\N	218795	218795	385836
29538	48423	0	applied	\N	\N	\N	\N	218799	218799	385840
29538	48424	1	applied	\N	\N	\N	\N	218800	218800	385841
29538	48425	2	applied	\N	\N	\N	\N	218801	218801	385842
29548	48442	0	applied	\N	\N	\N	\N	218844	218844	385884
29548	48443	1	applied	\N	\N	\N	\N	218845	218845	385885
29548	48444	2	applied	\N	\N	\N	\N	218846	218846	385886
29548	48445	3	applied	\N	\N	\N	\N	218847	218847	385887
29548	48446	4	applied	\N	\N	\N	\N	218848	218848	385888
29548	48447	5	applied	\N	\N	\N	\N	218849	218849	385889
29548	48448	6	applied	\N	\N	\N	\N	218850	218850	385890
29550	48450	1	applied	\N	\N	\N	\N	218859	218859	385899
29552	48451	0	applied	\N	\N	\N	\N	218868	218868	385908
29552	48452	1	applied	\N	\N	\N	\N	218869	218869	385909
29552	48453	2	applied	\N	\N	\N	\N	218870	218870	385910
29552	48454	3	applied	\N	\N	\N	\N	218871	218871	385911
29552	48456	4	applied	\N	\N	\N	\N	218872	218872	385912
29552	48458	5	applied	\N	\N	\N	\N	218873	218873	385913
29554	48451	0	applied	\N	\N	\N	\N	218882	218882	385922
29554	48452	1	applied	\N	\N	\N	\N	218883	218883	385923
29554	48453	2	applied	\N	\N	\N	\N	218884	218884	385924
29554	48454	3	applied	\N	\N	\N	\N	218885	218885	385925
29554	48455	4	applied	\N	\N	\N	\N	218886	218886	385926
29554	48456	5	applied	\N	\N	\N	\N	218887	218887	385927
29554	48457	6	applied	\N	\N	\N	\N	218888	218888	385928
29554	48458	7	applied	\N	\N	\N	\N	218889	218889	385929
29558	48462	0	applied	\N	\N	\N	\N	219021	219021	386058
29558	48464	2	applied	\N	\N	\N	\N	219023	219023	386060
29560	48358	0	applied	\N	\N	\N	\N	219028	219028	386065
29560	48361	1	applied	\N	\N	\N	\N	219029	219029	386066
29560	48364	2	applied	\N	\N	\N	\N	219030	219030	386067
29560	48365	3	applied	\N	\N	\N	\N	219031	219031	386068
29560	48369	4	applied	\N	\N	\N	\N	219032	219032	386069
29560	48372	5	applied	\N	\N	\N	\N	219033	219033	386070
29560	48376	6	applied	\N	\N	\N	\N	219034	219034	386071
29560	48377	7	applied	\N	\N	\N	\N	219035	219035	386072
29560	48383	8	applied	\N	\N	\N	\N	219036	219036	386073
29560	48387	9	applied	\N	\N	\N	\N	219037	219037	386074
29560	48388	10	applied	\N	\N	\N	\N	219038	219038	386075
29560	48394	11	applied	\N	\N	\N	\N	219039	219039	386076
29560	48395	12	applied	\N	\N	\N	\N	219040	219040	386077
29560	48396	13	applied	\N	\N	\N	\N	219041	219041	386078
29560	48407	14	applied	\N	\N	\N	\N	219042	219042	386079
29560	48413	16	applied	\N	\N	\N	\N	219044	219044	386081
29560	48417	17	applied	\N	\N	\N	\N	219045	219045	386082
29560	48419	18	applied	\N	\N	\N	\N	219046	219046	386083
29560	48423	19	applied	\N	\N	\N	\N	219047	219047	386084
29560	48426	20	applied	\N	\N	\N	\N	219048	219048	386085
29560	48427	21	applied	\N	\N	\N	\N	219049	219049	386086
29560	48433	22	applied	\N	\N	\N	\N	219050	219050	386087
29560	48434	23	applied	\N	\N	\N	\N	219051	219051	386088
29560	48439	24	applied	\N	\N	\N	\N	219052	219052	386089
29560	48442	25	applied	\N	\N	\N	\N	219053	219053	386090
29560	48443	26	applied	\N	\N	\N	\N	219054	219054	386091
29560	48449	27	applied	\N	\N	\N	\N	219055	219055	386092
29560	48451	28	applied	\N	\N	\N	\N	219056	219056	386093
29560	48452	29	applied	\N	\N	\N	\N	219057	219057	386094
29491	48334	7	applied	\N	\N	\N	\N	218525	218525	385573
29491	48335	8	applied	\N	\N	\N	\N	218526	218526	385574
29519	48405	0	applied	\N	\N	\N	\N	218644	218644	385688
29519	48406	1	applied	\N	\N	\N	\N	218645	218645	385689
29524	48408	1	applied	\N	\N	\N	\N	218655	218655	385699
29524	48409	2	applied	\N	\N	\N	\N	218656	218656	385700
29524	48410	3	applied	\N	\N	\N	\N	218657	218657	385701
29524	48411	4	applied	\N	\N	\N	\N	218658	218658	385702
29524	48412	5	applied	\N	\N	\N	\N	218659	218659	385703
29527	48413	0	applied	\N	\N	\N	\N	218670	218670	385714
29527	48414	1	applied	\N	\N	\N	\N	218671	218671	385715
29527	48415	2	applied	\N	\N	\N	\N	218672	218672	385716
29527	48416	3	applied	\N	\N	\N	\N	218673	218673	385717
29529	48227	0	applied	\N	\N	\N	\N	218676	218676	385720
29529	48200	1	applied	\N	\N	\N	\N	218677	218677	218677
29529	48127	2	applied	\N	\N	\N	\N	218678	218678	385721
29529	48146	4	applied	\N	\N	1000000000	\N	218680	218680	385722
29529	47457	5	applied	\N	\N	\N	\N	218681	218681	385723
29529	48150	6	applied	\N	\N	\N	\N	218682	218682	385724
29529	47452	7	applied	\N	\N	\N	\N	218683	218683	385725
29529	47456	8	applied	\N	\N	\N	\N	218684	218684	385726
29529	47793	9	applied	\N	\N	\N	\N	218685	218685	385727
29529	47458	10	applied	\N	\N	\N	\N	218686	218686	385728
29529	48291	11	applied	\N	\N	\N	\N	218687	218687	218687
29529	47462	12	applied	\N	\N	\N	\N	218688	218688	385729
29529	48255	13	applied	\N	\N	\N	\N	218689	218689	385730
29529	48265	14	applied	\N	\N	\N	\N	218690	218690	385731
29529	47465	15	applied	\N	\N	\N	\N	218691	218691	385732
29529	47469	16	applied	\N	\N	\N	\N	218692	218692	385733
29529	47471	17	applied	\N	\N	\N	\N	218693	218693	385734
29529	47472	18	applied	\N	\N	\N	\N	218694	218694	385735
29529	48152	19	applied	\N	\N	\N	\N	218695	218695	385736
29529	47473	21	applied	\N	\N	\N	\N	218697	218697	385738
29529	47481	22	applied	\N	\N	\N	\N	218698	218698	385739
29529	47483	23	applied	\N	\N	\N	\N	218699	218699	385740
29529	47487	24	applied	\N	\N	\N	\N	218700	218700	385741
29529	47490	25	applied	\N	\N	\N	\N	218701	218701	385742
29529	47491	26	applied	\N	\N	\N	\N	218702	218702	385743
29529	47495	27	applied	\N	\N	\N	\N	218703	218703	385744
29529	47499	28	applied	\N	\N	\N	\N	218704	218704	385745
29529	47502	29	applied	\N	\N	\N	\N	218705	218705	385746
29529	47503	30	applied	\N	\N	\N	\N	218706	218706	385747
29529	47508	31	applied	\N	\N	\N	\N	218707	218707	385748
29529	47509	32	applied	\N	\N	\N	\N	218708	218708	385749
29529	47510	33	applied	\N	\N	\N	\N	218709	218709	385750
29529	47516	34	applied	\N	\N	\N	\N	218710	218710	385751
29529	47520	35	applied	\N	\N	\N	\N	218711	218711	385752
29529	47521	36	applied	\N	\N	\N	\N	218712	218712	385753
29529	47529	38	applied	\N	\N	\N	\N	218714	218714	385755
29529	47532	39	applied	\N	\N	\N	\N	218715	218715	385756
29529	47533	40	applied	\N	\N	\N	\N	218716	218716	385757
29529	47538	41	applied	\N	\N	\N	\N	218717	218717	385758
29529	47539	42	applied	\N	\N	\N	\N	218718	218718	385759
29529	47540	43	applied	\N	\N	\N	\N	218719	218719	385760
29529	47541	44	applied	\N	\N	\N	\N	218720	218720	385761
29529	47550	45	applied	\N	\N	\N	\N	218721	218721	385762
29529	47551	46	applied	\N	\N	\N	\N	218722	218722	385763
29529	47554	47	applied	\N	\N	\N	\N	218723	218723	385764
29529	47555	48	applied	\N	\N	\N	\N	218724	218724	385765
29529	47562	49	applied	\N	\N	\N	\N	218725	218725	385766
29529	47563	50	applied	\N	\N	\N	\N	218726	218726	385767
29529	47564	51	applied	\N	\N	\N	\N	218727	218727	385768
29529	47572	52	applied	\N	\N	\N	\N	218728	218728	385769
29529	47574	53	applied	\N	\N	\N	\N	218729	218729	385770
29529	47581	55	applied	\N	\N	\N	\N	218731	218731	385772
29529	47583	56	applied	\N	\N	\N	\N	218732	218732	385773
29529	47584	57	applied	\N	\N	\N	\N	218733	218733	385774
29529	47589	58	applied	\N	\N	\N	\N	218734	218734	385775
29529	47592	59	applied	\N	\N	\N	\N	218735	218735	385776
29529	47593	60	applied	\N	\N	\N	\N	218736	218736	385777
29529	47594	61	applied	\N	\N	\N	\N	218737	218737	385778
29529	47601	62	applied	\N	\N	\N	\N	218738	218738	385779
29529	47604	63	applied	\N	\N	\N	\N	218739	218739	385780
29529	47606	64	applied	\N	\N	\N	\N	218740	218740	385781
29529	47610	65	applied	\N	\N	\N	\N	218741	218741	385782
29529	47611	66	applied	\N	\N	\N	\N	218742	218742	385783
29529	47616	67	applied	\N	\N	\N	\N	218743	218743	385784
29529	47617	68	applied	\N	\N	\N	\N	218744	218744	385785
29529	47621	69	applied	\N	\N	\N	\N	218745	218745	385786
29529	47624	70	applied	\N	\N	\N	\N	218746	218746	385787
29529	47628	72	applied	\N	\N	\N	\N	218748	218748	385789
29529	47629	73	applied	\N	\N	\N	\N	218749	218749	385790
29529	47635	74	applied	\N	\N	\N	\N	218750	218750	385791
29529	47641	75	applied	\N	\N	\N	\N	218751	218751	385792
29529	47642	76	applied	\N	\N	\N	\N	218752	218752	385793
29529	47643	77	applied	\N	\N	\N	\N	218753	218753	385794
29529	47649	78	applied	\N	\N	\N	\N	218754	218754	385795
29529	47652	79	applied	\N	\N	\N	\N	218755	218755	385796
29529	47655	80	applied	\N	\N	\N	\N	218756	218756	385797
29529	47657	81	applied	\N	\N	\N	\N	218757	218757	385798
29529	47660	82	applied	\N	\N	\N	\N	218758	218758	385799
29529	47663	83	applied	\N	\N	\N	\N	218759	218759	385800
29529	47665	84	applied	\N	\N	\N	\N	218760	218760	385801
29529	47666	85	applied	\N	\N	\N	\N	218761	218761	385802
29529	47671	86	applied	\N	\N	\N	\N	218762	218762	385803
29529	47674	87	applied	\N	\N	\N	\N	218763	218763	385804
29529	47680	89	applied	\N	\N	\N	\N	218765	218765	385806
29531	48419	0	applied	\N	\N	\N	\N	218777	218777	385818
29531	48420	1	applied	\N	\N	\N	\N	218778	218778	385819
29531	48421	2	applied	\N	\N	\N	\N	218779	218779	385820
29531	48422	3	applied	\N	\N	\N	\N	218780	218780	385821
29533	48419	0	applied	\N	\N	\N	\N	218785	218785	385826
29533	48420	1	applied	\N	\N	\N	\N	218786	218786	385827
29533	48421	2	applied	\N	\N	\N	\N	218787	218787	385828
29533	48422	3	applied	\N	\N	\N	\N	218788	218788	385829
29542	48433	0	applied	\N	\N	\N	\N	218809	218809	385849
29542	48434	1	applied	\N	\N	\N	\N	218810	218810	385850
29542	48435	2	applied	\N	\N	\N	\N	218811	218811	385851
29542	48436	3	applied	\N	\N	\N	\N	218812	218812	385852
29542	48437	4	applied	\N	\N	\N	\N	218813	218813	385853
29542	48438	5	applied	\N	\N	\N	\N	218814	218814	385854
29544	48433	0	applied	\N	\N	\N	\N	218821	218821	385861
29511	48382	6	applied	\N	\N	\N	\N	218596	218596	385641
29537	48423	0	applied	\N	\N	\N	\N	218796	218796	385837
29537	48424	1	applied	\N	\N	\N	\N	218797	218797	385838
29537	48425	2	applied	\N	\N	\N	\N	218798	218798	385839
29541	48426	0	applied	\N	\N	\N	\N	218802	218802	385843
29541	48427	1	applied	\N	\N	\N	\N	218803	218803	385844
29541	48428	2	applied	\N	\N	\N	\N	218804	218804	385845
29541	48429	3	applied	\N	\N	\N	\N	218805	218805	385846
29541	48430	4	applied	\N	\N	\N	\N	218806	218806	218806
29541	48431	5	applied	\N	\N	\N	\N	218807	218807	385847
29541	48432	6	applied	\N	\N	\N	\N	218808	218808	385848
29543	48433	0	applied	\N	\N	\N	\N	218815	218815	385855
29543	48434	1	applied	\N	\N	\N	\N	218816	218816	385856
29543	48435	2	applied	\N	\N	\N	\N	218817	218817	385857
29543	48436	3	applied	\N	\N	\N	\N	218818	218818	385858
29543	48438	5	applied	\N	\N	\N	\N	218820	218820	385860
29544	48434	1	applied	\N	\N	\N	\N	218822	218822	385862
29544	48435	2	applied	\N	\N	\N	\N	218823	218823	385863
29544	48436	3	applied	\N	\N	\N	\N	218824	218824	385864
29544	48437	4	applied	\N	\N	\N	\N	218825	218825	385865
29544	48438	5	applied	\N	\N	\N	\N	218826	218826	385866
29547	48442	0	applied	\N	\N	\N	\N	218837	218837	385877
29547	48443	1	applied	\N	\N	\N	\N	218838	218838	385878
29547	48444	2	applied	\N	\N	\N	\N	218839	218839	385879
29547	48445	3	applied	\N	\N	\N	\N	218840	218840	385880
29547	48446	4	applied	\N	\N	\N	\N	218841	218841	385881
29547	48447	5	applied	\N	\N	\N	\N	218842	218842	385882
29547	48448	6	applied	\N	\N	\N	\N	218843	218843	385883
29553	48451	0	applied	\N	\N	\N	\N	218874	218874	385914
29553	48452	1	applied	\N	\N	\N	\N	218875	218875	385915
29553	48453	2	applied	\N	\N	\N	\N	218876	218876	385916
29553	48455	4	applied	\N	\N	\N	\N	218878	218878	385918
29553	48456	5	applied	\N	\N	\N	\N	218879	218879	385919
29553	48457	6	applied	\N	\N	\N	\N	218880	218880	385920
29553	48458	7	applied	\N	\N	\N	\N	218881	218881	385921
29556	48459	0	applied	\N	\N	\N	\N	219015	219015	386052
29556	48460	1	applied	\N	\N	\N	\N	219016	219016	386053
29556	48461	2	applied	\N	\N	\N	\N	219017	219017	386054
29561	48469	0	applied	\N	\N	\N	\N	219137	219137	386172
29561	48470	1	applied	\N	\N	\N	\N	219138	219138	386173
29566	48487	0	applied	\N	\N	\N	\N	219157	219157	386192
29566	48488	1	applied	\N	\N	\N	\N	219158	219158	386193
29566	48489	2	applied	\N	\N	\N	\N	219159	219159	386194
29566	48490	3	applied	\N	\N	\N	\N	219160	219160	386195
29566	48491	4	applied	\N	\N	\N	\N	219161	219161	386196
29566	48492	5	applied	\N	\N	\N	\N	219162	219162	386197
29577	48513	0	applied	\N	\N	\N	\N	219207	219207	386242
29579	48515	0	applied	\N	\N	\N	\N	219211	219211	386246
29579	48516	1	applied	\N	\N	\N	\N	219212	219212	386247
29579	48517	2	applied	\N	\N	\N	\N	219213	219213	386248
29579	48518	3	applied	\N	\N	\N	\N	219214	219214	386249
29581	48519	0	applied	\N	\N	\N	\N	219218	219218	386253
29581	48520	1	applied	\N	\N	\N	\N	219219	219219	386254
29581	48521	2	applied	\N	\N	\N	\N	219220	219220	386255
29587	48536	0	applied	\N	\N	\N	\N	219244	219244	386279
29587	48537	1	applied	\N	\N	\N	\N	219245	219245	386280
29587	48538	2	applied	\N	\N	\N	\N	219246	219246	386281
29587	48539	3	applied	\N	\N	\N	\N	219247	219247	386282
29587	48540	4	applied	\N	\N	\N	\N	219248	219248	386283
29587	48541	5	applied	\N	\N	1000000000	\N	219249	219249	386284
29587	48542	6	applied	\N	\N	\N	\N	219250	219250	386285
29587	48543	7	applied	\N	\N	\N	\N	219251	219251	386286
29589	48508	0	applied	\N	\N	\N	\N	219260	219260	386295
29589	48509	2	applied	\N	\N	\N	\N	219262	219262	386297
29589	48522	3	applied	\N	\N	\N	\N	219263	219263	386298
29589	48523	4	applied	\N	\N	\N	\N	219264	219264	386299
29589	48050	5	applied	\N	\N	\N	\N	219265	219265	386300
29589	48053	6	applied	\N	\N	\N	\N	219266	219266	386301
29589	48054	7	applied	\N	\N	\N	\N	219267	219267	386302
29589	48060	8	applied	\N	\N	\N	\N	219268	219268	386303
29589	48062	9	applied	\N	\N	\N	\N	219269	219269	386304
29589	48063	10	applied	\N	\N	\N	\N	219270	219270	386305
29589	48064	11	applied	\N	\N	\N	\N	219271	219271	386306
29589	48074	12	applied	\N	\N	\N	\N	219272	219272	386307
29589	48078	13	applied	\N	\N	\N	\N	219273	219273	386308
29589	48082	14	applied	\N	\N	\N	\N	219274	219274	386309
29589	48084	15	applied	\N	\N	\N	\N	219275	219275	386310
29589	48089	16	applied	\N	\N	\N	\N	219276	219276	386311
29589	48092	17	applied	\N	\N	\N	\N	219277	219277	386312
29589	48096	19	applied	\N	\N	\N	\N	219279	219279	386314
29589	48101	20	applied	\N	\N	\N	\N	219280	219280	386315
29589	48105	21	applied	\N	\N	\N	\N	219281	219281	386316
29589	48107	22	applied	\N	\N	\N	\N	219282	219282	386317
29589	48111	23	applied	\N	\N	\N	\N	219283	219283	386318
29589	48114	24	applied	\N	\N	\N	\N	219284	219284	386319
29589	48118	25	applied	\N	\N	\N	\N	219285	219285	386320
29589	48119	26	applied	\N	\N	\N	\N	219286	219286	386321
29589	48120	27	applied	\N	\N	\N	\N	219287	219287	386322
29589	48128	28	applied	\N	\N	\N	\N	219288	219288	386323
29589	48129	29	applied	\N	\N	\N	\N	219289	219289	386324
29589	48130	30	applied	\N	\N	\N	\N	219290	219290	386325
29589	48138	31	applied	\N	\N	\N	\N	219291	219291	386326
29589	48141	32	applied	\N	\N	\N	\N	219292	219292	386327
29589	48143	33	applied	\N	\N	\N	\N	219293	219293	386328
29589	48147	34	applied	\N	\N	\N	\N	219294	219294	386329
29589	48156	36	applied	\N	\N	\N	\N	219296	219296	386331
29589	48160	37	applied	\N	\N	\N	\N	219297	219297	386332
29589	48164	38	applied	\N	\N	\N	\N	219298	219298	386333
29589	48167	39	applied	\N	\N	\N	\N	219299	219299	386334
29589	48170	40	applied	\N	\N	\N	\N	219300	219300	386335
29589	48174	41	applied	\N	\N	\N	\N	219301	219301	386336
29589	48178	42	applied	\N	\N	\N	\N	219302	219302	386337
29589	48181	43	applied	\N	\N	\N	\N	219303	219303	386338
29589	48184	44	applied	\N	\N	\N	\N	219304	219304	386339
29589	48185	45	applied	\N	\N	\N	\N	219305	219305	386340
29589	48186	46	applied	\N	\N	\N	\N	219306	219306	386341
29589	48187	47	applied	\N	\N	\N	\N	219307	219307	386342
29589	48198	48	applied	\N	\N	\N	\N	219308	219308	386343
29589	48202	49	applied	\N	\N	\N	\N	219309	219309	386344
29589	48206	50	applied	\N	\N	\N	\N	219310	219310	386345
29589	48209	51	applied	\N	\N	\N	\N	219311	219311	386346
29525	48412	5	applied	\N	\N	\N	\N	218665	218665	385709
29529	47691	95	applied	\N	\N	\N	\N	218770	218770	385811
29529	47697	96	applied	\N	\N	\N	\N	218771	218771	385812
29529	47701	97	applied	\N	\N	\N	\N	218772	218772	385813
29545	48439	0	applied	\N	\N	\N	\N	218827	218827	385867
29545	48440	1	applied	\N	\N	\N	\N	218828	218828	385868
29545	48441	2	applied	\N	\N	\N	\N	218829	218829	385869
29546	48442	0	applied	\N	\N	\N	\N	218830	218830	385870
29546	48443	1	applied	\N	\N	\N	\N	218831	218831	385871
29546	48444	2	applied	\N	\N	\N	\N	218832	218832	385872
29546	48445	3	applied	\N	\N	\N	\N	218833	218833	385873
29546	48446	4	applied	\N	\N	\N	\N	218834	218834	385874
29546	48447	5	applied	\N	\N	\N	\N	218835	218835	385875
29546	48448	6	applied	\N	\N	\N	\N	218836	218836	385876
29549	48442	0	applied	\N	\N	\N	\N	218851	218851	385891
29549	48443	1	applied	\N	\N	\N	\N	218852	218852	385892
29549	48444	2	applied	\N	\N	\N	\N	218853	218853	385893
29549	48446	4	applied	\N	\N	\N	\N	218855	218855	385895
29549	48447	5	applied	\N	\N	\N	\N	218856	218856	385896
29549	48448	6	applied	\N	\N	\N	\N	218857	218857	385897
29551	48451	0	applied	\N	\N	\N	\N	218860	218860	385900
29551	48452	1	applied	\N	\N	\N	\N	218861	218861	385901
29551	48453	2	applied	\N	\N	\N	\N	218862	218862	385902
29551	48454	3	applied	\N	\N	\N	\N	218863	218863	385903
29551	48455	4	applied	\N	\N	\N	\N	218864	218864	385904
29551	48456	5	applied	\N	\N	\N	\N	218865	218865	385905
29559	48465	0	applied	\N	\N	\N	\N	219024	219024	386061
29559	48466	1	applied	\N	\N	\N	\N	219025	219025	386062
29559	48467	2	applied	\N	\N	\N	\N	219026	219026	386063
29559	48468	3	applied	\N	\N	\N	\N	219027	219027	386064
29562	48471	0	applied	\N	\N	\N	\N	219139	219139	386174
29562	48472	1	applied	\N	\N	\N	\N	219140	219140	386175
29562	48473	2	applied	\N	\N	\N	\N	219141	219141	386176
29562	48475	4	applied	\N	\N	\N	\N	219143	219143	386178
29562	48476	5	applied	\N	\N	\N	\N	219144	219144	386179
29562	48477	6	applied	\N	\N	\N	\N	219145	219145	386180
29562	48478	7	applied	\N	\N	\N	\N	219146	219146	386181
29562	48479	8	applied	\N	\N	\N	\N	219147	219147	386182
29562	48480	9	applied	\N	\N	\N	\N	219148	219148	386183
29564	48481	0	applied	\N	\N	\N	\N	219151	219151	386186
29564	48482	1	applied	\N	\N	\N	\N	219152	219152	386187
29569	48487	0	applied	\N	\N	\N	\N	219175	219175	386210
29569	48488	1	applied	\N	\N	\N	\N	219176	219176	386211
29569	48489	2	applied	\N	\N	\N	\N	219177	219177	386212
29569	48490	3	applied	\N	\N	\N	\N	219178	219178	386213
29569	48491	4	applied	\N	\N	\N	\N	219179	219179	386214
29569	48492	5	applied	\N	\N	\N	\N	219180	219180	386215
29571	48499	0	applied	\N	\N	\N	\N	219187	219187	386222
29571	48500	1	applied	\N	\N	\N	\N	219188	219188	386223
29573	48499	0	applied	\N	\N	\N	\N	219193	219193	386228
29573	48501	1	applied	\N	\N	\N	\N	219194	219194	386229
29580	48519	0	applied	\N	\N	\N	\N	219215	219215	386250
29580	48520	1	applied	\N	\N	\N	\N	219216	219216	386251
29580	48521	2	applied	\N	\N	\N	\N	219217	219217	386252
29583	48533	0	applied	\N	\N	\N	\N	219232	219232	386267
29583	48534	1	applied	\N	\N	\N	\N	219233	219233	386268
29583	48535	2	applied	\N	\N	\N	\N	219234	219234	386269
29586	48533	0	applied	\N	\N	\N	\N	219241	219241	386276
29586	48534	1	applied	\N	\N	\N	\N	219242	219242	386277
29586	48535	2	applied	\N	\N	\N	\N	219243	219243	386278
29592	48549	0	applied	\N	\N	\N	\N	219366	219366	386401
29592	48550	1	applied	\N	\N	\N	\N	219367	219367	386402
29592	48551	2	applied	\N	\N	\N	\N	219368	219368	386403
29592	48552	3	applied	\N	\N	\N	\N	219369	219369	386404
29592	48553	4	applied	\N	\N	\N	\N	219370	219370	386405
29594	48555	0	applied	\N	\N	\N	\N	219378	219378	386413
29594	48556	1	applied	\N	\N	\N	\N	219379	219379	386414
29594	48557	2	applied	\N	\N	\N	\N	219380	219380	386415
29596	48558	0	applied	\N	\N	\N	\N	219393	219393	386428
29596	48559	1	applied	\N	\N	\N	\N	219394	219394	386429
29596	48560	2	applied	\N	\N	\N	\N	219395	219395	386430
29596	48561	3	applied	\N	\N	\N	\N	219396	219396	386431
29596	48562	4	applied	\N	\N	\N	\N	219397	219397	386432
29596	48563	5	applied	\N	\N	\N	\N	219398	219398	386433
29596	48564	6	applied	\N	\N	\N	\N	219399	219399	386434
29596	48565	7	applied	\N	\N	\N	\N	219400	219400	386435
29596	48566	8	applied	\N	\N	\N	\N	219401	219401	386436
29596	48567	9	applied	\N	\N	\N	\N	219402	219402	386437
29596	48568	10	applied	\N	\N	\N	\N	219403	219403	386438
29596	48569	11	applied	\N	\N	\N	\N	219404	219404	386439
29600	48578	0	applied	\N	\N	\N	\N	219417	219417	386452
29600	48581	2	applied	\N	\N	\N	\N	219419	219419	386454
29608	48595	0	applied	\N	\N	\N	\N	219562	219562	386597
29608	48596	1	applied	\N	\N	\N	\N	219563	219563	386598
29608	48597	2	applied	\N	\N	\N	\N	219564	219564	386599
29610	48598	0	applied	\N	\N	\N	\N	219568	219568	386603
29610	48599	1	applied	\N	\N	\N	\N	219569	219569	386604
29610	48600	2	applied	\N	\N	\N	\N	219570	219570	386605
29612	48614	0	applied	\N	\N	\N	\N	219584	219584	386619
29612	48615	1	applied	\N	\N	\N	\N	219585	219585	386620
29612	48616	2	applied	\N	\N	\N	\N	219586	219586	386621
29612	48617	3	applied	\N	\N	\N	\N	219587	219587	386622
29612	48618	4	applied	\N	\N	\N	\N	219588	219588	386623
29612	48619	5	applied	\N	\N	\N	\N	219589	219589	386624
29612	48620	6	applied	\N	\N	\N	\N	219590	219590	386625
29620	48634	0	applied	\N	\N	\N	\N	219632	219632	386667
29620	48635	1	applied	\N	\N	\N	\N	219633	219633	386668
29620	48637	3	applied	\N	\N	\N	\N	219635	219635	386670
29620	48638	4	applied	\N	\N	\N	\N	219636	219636	386671
29620	48639	5	applied	\N	\N	\N	\N	219637	219637	386672
29622	48634	0	applied	\N	\N	\N	\N	219644	219644	386679
29622	48635	1	applied	\N	\N	\N	\N	219645	219645	386680
29622	48636	2	applied	\N	\N	\N	\N	219646	219646	386681
29622	48637	3	applied	\N	\N	\N	\N	219647	219647	386682
29622	48638	4	applied	\N	\N	\N	\N	219648	219648	386683
29622	48639	5	applied	\N	\N	\N	\N	219649	219649	386684
29625	48646	0	applied	\N	\N	\N	\N	219662	219662	386697
29625	48647	1	applied	\N	\N	\N	\N	219663	219663	386698
29625	48648	2	applied	\N	\N	\N	\N	219664	219664	386699
29625	48649	3	applied	\N	\N	\N	\N	219665	219665	386700
29625	48650	4	applied	\N	\N	\N	\N	219666	219666	386701
29529	47685	91	applied	\N	\N	\N	\N	218767	218767	385808
29529	47689	92	applied	\N	\N	\N	\N	218768	218768	385809
29555	48127	2	applied	\N	\N	\N	\N	218892	218892	385931
29555	48201	3	applied	\N	\N	\N	\N	218893	218893	218893
29555	48146	4	applied	\N	\N	1000000000	\N	218894	218894	385932
29555	48150	5	applied	\N	\N	\N	\N	218895	218895	385933
29555	47793	6	applied	\N	\N	\N	\N	218896	218896	385934
29555	47701	7	applied	\N	\N	\N	\N	218897	218897	385935
29555	47704	8	applied	\N	\N	\N	\N	218898	218898	385936
29555	48291	9	applied	\N	\N	\N	\N	218899	218899	218899
29555	48255	10	applied	\N	\N	\N	\N	218900	218900	385937
29555	48265	11	applied	\N	\N	\N	\N	218901	218901	385938
29555	47707	12	applied	\N	\N	\N	\N	218902	218902	385939
29555	47710	13	applied	\N	\N	\N	\N	218903	218903	385940
29555	47713	14	applied	\N	\N	\N	\N	218904	218904	385941
29555	47716	15	applied	\N	\N	\N	\N	218905	218905	385942
29555	47722	17	applied	\N	\N	\N	\N	218907	218907	385944
29555	47723	18	applied	\N	\N	\N	\N	218908	218908	385945
29555	47727	19	applied	\N	\N	\N	\N	218909	218909	385946
29555	47731	20	applied	\N	\N	\N	\N	218910	218910	385947
29555	47734	21	applied	\N	\N	\N	\N	218911	218911	385948
29555	47735	22	applied	\N	\N	\N	\N	218912	218912	385949
29555	47740	23	applied	\N	\N	\N	\N	218913	218913	385950
29555	48152	24	applied	\N	\N	\N	\N	218914	218914	385951
29555	48155	25	applied	\N	\N	\N	\N	218915	218915	385952
29555	47741	26	applied	\N	\N	\N	\N	218916	218916	385953
29555	47747	27	applied	\N	\N	\N	\N	218917	218917	385954
29555	47751	28	applied	\N	\N	\N	\N	218918	218918	385955
29555	47753	29	applied	\N	\N	\N	\N	218919	218919	385956
29555	47756	30	applied	\N	\N	\N	\N	218920	218920	385957
29555	47759	31	applied	\N	\N	\N	\N	218921	218921	385958
29555	47762	32	applied	\N	\N	\N	\N	218922	218922	385959
29555	47768	34	applied	\N	\N	\N	\N	218924	218924	385961
29555	47772	35	applied	\N	\N	\N	\N	218925	218925	385962
29555	47774	36	applied	\N	\N	\N	\N	218926	218926	385963
29555	47777	37	applied	\N	\N	\N	\N	218927	218927	385964
29555	47781	38	applied	\N	\N	\N	\N	218928	218928	385965
29555	47784	39	applied	\N	\N	\N	\N	218929	218929	385966
29555	47786	40	applied	\N	\N	\N	\N	218930	218930	385967
29555	47792	41	applied	\N	\N	\N	\N	218931	218931	385968
29555	47794	42	applied	\N	\N	\N	\N	218932	218932	385969
29555	47796	43	applied	\N	\N	\N	\N	218933	218933	385970
29555	47797	44	applied	\N	\N	\N	\N	218934	218934	385971
29555	47798	45	applied	\N	\N	\N	\N	218935	218935	385972
29555	47799	46	applied	\N	\N	\N	\N	218936	218936	385973
29555	47808	47	applied	\N	\N	\N	\N	218937	218937	385974
29555	47812	48	applied	\N	\N	\N	\N	218938	218938	385975
29555	47813	49	applied	\N	\N	\N	\N	218939	218939	385976
29555	47819	51	applied	\N	\N	\N	\N	218941	218941	385978
29555	47820	52	applied	\N	\N	\N	\N	218942	218942	385979
29555	47821	53	applied	\N	\N	\N	\N	218943	218943	385980
29555	47830	54	applied	\N	\N	\N	\N	218944	218944	385981
29555	47831	55	applied	\N	\N	\N	\N	218945	218945	385982
29555	47836	56	applied	\N	\N	\N	\N	218946	218946	385983
29555	47839	57	applied	\N	\N	\N	\N	218947	218947	385984
29555	47840	58	applied	\N	\N	\N	\N	218948	218948	385985
29555	47845	59	applied	\N	\N	\N	\N	218949	218949	385986
29555	47846	60	applied	\N	\N	\N	\N	218950	218950	385987
29555	47852	61	applied	\N	\N	\N	\N	218951	218951	385988
29555	47855	62	applied	\N	\N	\N	\N	218952	218952	385989
29555	47858	63	applied	\N	\N	\N	\N	218953	218953	385990
29555	47859	64	applied	\N	\N	\N	\N	218954	218954	385991
29555	47865	65	applied	\N	\N	\N	\N	218955	218955	385992
29555	47867	66	applied	\N	\N	\N	\N	218956	218956	385993
29555	47874	68	applied	\N	\N	\N	\N	218958	218958	385995
29555	47877	69	applied	\N	\N	\N	\N	218959	218959	385996
29555	47878	70	applied	\N	\N	\N	\N	218960	218960	385997
29555	47882	71	applied	\N	\N	\N	\N	218961	218961	385998
29555	47886	72	applied	\N	\N	\N	\N	218962	218962	385999
29555	47887	73	applied	\N	\N	\N	\N	218963	218963	386000
29555	47891	74	applied	\N	\N	\N	\N	218964	218964	386001
29555	47895	75	applied	\N	\N	\N	\N	218965	218965	386002
29555	47896	76	applied	\N	\N	\N	\N	218966	218966	386003
29555	47899	77	applied	\N	\N	\N	\N	218967	218967	386004
29555	47900	78	applied	\N	\N	\N	\N	218968	218968	386005
29555	47906	79	applied	\N	\N	\N	\N	218969	218969	386006
29555	47908	80	applied	\N	\N	\N	\N	218970	218970	386007
29555	47911	81	applied	\N	\N	\N	\N	218971	218971	386008
29555	47915	82	applied	\N	\N	\N	\N	218972	218972	386009
29555	47918	84	applied	\N	\N	\N	\N	218973	218973	386010
29555	47924	86	applied	\N	\N	\N	\N	218975	218975	386012
29555	47927	87	applied	\N	\N	\N	\N	218976	218976	386013
29555	47929	88	applied	\N	\N	\N	\N	218977	218977	386014
29555	47930	89	applied	\N	\N	\N	\N	218978	218978	386015
29555	47936	90	applied	\N	\N	\N	\N	218979	218979	386016
29555	47941	91	applied	\N	\N	\N	\N	218980	218980	386017
29555	47944	92	applied	\N	\N	\N	\N	218981	218981	386018
29555	47948	93	applied	\N	\N	\N	\N	218982	218982	386019
29555	47949	94	applied	\N	\N	\N	\N	218983	218983	386020
29555	47954	95	applied	\N	\N	\N	\N	218984	218984	386021
29555	47958	96	applied	\N	\N	\N	\N	218985	218985	386022
29555	47961	97	applied	\N	\N	\N	\N	218986	218986	386023
29555	47964	98	applied	\N	\N	\N	\N	218987	218987	386024
29555	47965	99	applied	\N	\N	\N	\N	218988	218988	386025
29555	47970	100	applied	\N	\N	\N	\N	218989	218989	386026
29555	47973	101	applied	\N	\N	\N	\N	218990	218990	386027
29555	47979	103	applied	\N	\N	\N	\N	218992	218992	386029
29555	47980	104	applied	\N	\N	\N	\N	218993	218993	386030
29555	47985	105	applied	\N	\N	\N	\N	218994	218994	386031
29555	47986	106	applied	\N	\N	\N	\N	218995	218995	386032
29555	47991	107	applied	\N	\N	\N	\N	218996	218996	386033
29555	47994	108	applied	\N	\N	\N	\N	218997	218997	386034
29555	47998	109	applied	\N	\N	\N	\N	218998	218998	386035
29555	48000	110	applied	\N	\N	\N	\N	218999	218999	386036
29555	48003	111	applied	\N	\N	\N	\N	219000	219000	386037
29555	48006	112	applied	\N	\N	\N	\N	219001	219001	386038
29555	48009	113	applied	\N	\N	\N	\N	219002	219002	386039
29555	48012	114	applied	\N	\N	\N	\N	219003	219003	386040
29555	48015	115	applied	\N	\N	\N	\N	219004	219004	386041
29555	48018	116	applied	\N	\N	\N	\N	219005	219005	386042
29555	48021	117	applied	\N	\N	\N	\N	219006	219006	386043
29555	48024	118	applied	\N	\N	\N	\N	219007	219007	386044
29555	48200	1	applied	\N	\N	\N	\N	218891	218891	218891
29555	48034	123	applied	\N	\N	\N	\N	219012	219012	386049
29555	48041	124	applied	\N	\N	\N	\N	219013	219013	386050
29555	48044	125	applied	\N	\N	\N	\N	219014	219014	386051
29557	48459	0	applied	\N	\N	\N	\N	219018	219018	386055
29557	48460	1	applied	\N	\N	\N	\N	219019	219019	386056
29557	48461	2	applied	\N	\N	\N	\N	219020	219020	386057
29560	48459	30	applied	\N	\N	\N	\N	219058	219058	386095
29560	48462	31	applied	\N	\N	\N	\N	219059	219059	386096
29560	48465	32	applied	\N	\N	\N	\N	219060	219060	386097
29560	48460	33	applied	\N	\N	\N	\N	219061	219061	386098
29560	48378	34	applied	\N	\N	\N	\N	219062	219062	219062
29560	48359	35	applied	\N	\N	\N	\N	219063	219063	386099
29560	48371	36	applied	\N	\N	\N	\N	219064	219064	386100
29560	48414	37	applied	\N	\N	\N	\N	219065	219065	386101
29560	48402	39	applied	\N	\N	\N	\N	219067	219067	386103
29560	48403	40	applied	\N	\N	\N	\N	219068	219068	386104
29560	48373	41	applied	\N	\N	\N	\N	219069	219069	219069
29560	48386	42	applied	\N	\N	\N	\N	219070	219070	386105
29560	48431	43	applied	\N	\N	\N	\N	219071	219071	386106
29560	48360	44	applied	\N	\N	\N	\N	219072	219072	386107
29560	48362	45	applied	\N	\N	\N	\N	219073	219073	386108
29560	48366	47	applied	\N	\N	\N	\N	219074	219074	386109
29560	48370	48	applied	\N	\N	\N	\N	219075	219075	386110
29560	48374	49	applied	\N	\N	\N	\N	219076	219076	386111
29560	48367	50	applied	\N	\N	\N	\N	219077	219077	386112
29568	48487	0	applied	\N	\N	\N	\N	219169	219169	386204
29568	48488	1	applied	\N	\N	\N	\N	219170	219170	386205
29568	48489	2	applied	\N	\N	\N	\N	219171	219171	386206
29568	48490	3	applied	\N	\N	\N	\N	219172	219172	386207
29568	48491	4	applied	\N	\N	\N	\N	219173	219173	386208
29570	48493	0	applied	\N	\N	\N	\N	219181	219181	386216
29570	48494	1	applied	\N	\N	\N	\N	219182	219182	386217
29570	48495	2	applied	\N	\N	\N	\N	219183	219183	386218
29570	48496	3	applied	\N	\N	\N	\N	219184	219184	386219
29570	48497	4	applied	\N	\N	\N	\N	219185	219185	386220
29570	48498	5	applied	\N	\N	\N	\N	219186	219186	386221
29572	48499	0	applied	\N	\N	\N	\N	219190	219190	386225
29572	48500	1	applied	\N	\N	\N	\N	219191	219191	386226
29572	48501	2	applied	\N	\N	\N	\N	219192	219192	386227
29574	48502	0	applied	\N	\N	\N	\N	219195	219195	386230
29574	48500	1	applied	\N	\N	\N	\N	219196	219196	386231
29574	48503	2	applied	\N	\N	\N	\N	219197	219197	386232
29576	48508	0	applied	\N	\N	\N	\N	219202	219202	386237
29576	48509	1	applied	\N	\N	\N	\N	219203	219203	386238
29576	48510	2	applied	\N	\N	\N	\N	219204	219204	386239
29576	48511	3	applied	\N	\N	\N	\N	219205	219205	386240
29582	48522	0	applied	\N	\N	\N	\N	219221	219221	386256
29582	48523	1	applied	\N	\N	\N	\N	219222	219222	386257
29582	48524	2	applied	\N	\N	\N	\N	219223	219223	386258
29582	48525	3	applied	\N	\N	\N	\N	219224	219224	386259
29582	48526	4	applied	\N	\N	\N	\N	219225	219225	386260
29582	48527	5	applied	\N	\N	\N	\N	219226	219226	386261
29582	48528	6	applied	\N	\N	\N	\N	219227	219227	386262
29582	48529	7	applied	\N	\N	\N	\N	219228	219228	386263
29582	48530	8	applied	\N	\N	\N	\N	219229	219229	386264
29582	48531	9	applied	\N	\N	\N	\N	219230	219230	386265
29582	48532	10	applied	\N	\N	\N	\N	219231	219231	386266
29585	48533	0	applied	\N	\N	\N	\N	219238	219238	386273
29585	48534	1	applied	\N	\N	\N	\N	219239	219239	386274
29585	48535	2	applied	\N	\N	\N	\N	219240	219240	386275
29588	48536	0	applied	\N	\N	\N	\N	219252	219252	386287
29588	48537	1	applied	\N	\N	\N	\N	219253	219253	386288
29588	48539	3	applied	\N	\N	\N	\N	219255	219255	386290
29588	48540	4	applied	\N	\N	\N	\N	219256	219256	386291
29588	48541	5	applied	\N	\N	1000000000	\N	219257	219257	386292
29588	48542	6	applied	\N	\N	\N	\N	219258	219258	386293
29588	48543	7	applied	\N	\N	\N	\N	219259	219259	386294
29591	48544	0	applied	\N	\N	\N	\N	219361	219361	386396
29591	48545	1	applied	\N	\N	\N	\N	219362	219362	386397
29591	48546	2	applied	\N	\N	\N	\N	219363	219363	386398
29591	48547	3	applied	\N	\N	\N	\N	219364	219364	386399
29591	48548	4	applied	\N	\N	\N	\N	219365	219365	386400
29595	48558	0	applied	\N	\N	\N	\N	219381	219381	386416
29595	48559	1	applied	\N	\N	\N	\N	219382	219382	386417
29595	48560	2	applied	\N	\N	\N	\N	219383	219383	386418
29595	48561	3	applied	\N	\N	\N	\N	219384	219384	386419
29595	48562	4	applied	\N	\N	\N	\N	219385	219385	386420
29595	48563	5	applied	\N	\N	\N	\N	219386	219386	386421
29595	48565	7	applied	\N	\N	\N	\N	219388	219388	386423
29595	48566	8	applied	\N	\N	\N	\N	219389	219389	386424
29595	48567	9	applied	\N	\N	\N	\N	219390	219390	386425
29595	48568	10	applied	\N	\N	\N	\N	219391	219391	386426
29595	48569	11	applied	\N	\N	\N	\N	219392	219392	386427
29602	48586	0	applied	\N	\N	\N	\N	219425	219425	386460
29602	48587	1	applied	\N	\N	\N	\N	219426	219426	386461
29602	48588	2	applied	\N	\N	\N	\N	219427	219427	386462
29616	48626	0	applied	\N	\N	\N	\N	219604	219604	386639
29618	48624	0	applied	\N	\N	\N	\N	219614	219614	386649
29618	48627	1	applied	\N	\N	\N	\N	219615	219615	386650
29618	48628	2	applied	\N	\N	\N	\N	219616	219616	386651
29618	48629	3	applied	\N	\N	\N	\N	219617	219617	386652
29618	48630	4	applied	\N	\N	\N	\N	219618	219618	386653
29618	48625	5	applied	\N	\N	\N	\N	219619	219619	386654
29618	48631	6	applied	\N	\N	\N	\N	219620	219620	386655
29618	48633	8	applied	\N	\N	\N	\N	219622	219622	386657
29624	48640	0	applied	\N	\N	\N	\N	219656	219656	386691
29624	48641	1	applied	\N	\N	\N	\N	219657	219657	386692
29624	48642	2	applied	\N	\N	\N	\N	219658	219658	386693
29624	48643	3	applied	\N	\N	\N	\N	219659	219659	386694
29624	48644	4	applied	\N	\N	\N	\N	219660	219660	386695
29624	48645	5	applied	\N	\N	\N	\N	219661	219661	386696
29629	48659	0	applied	\N	\N	\N	\N	219693	219693	386728
29629	48660	1	applied	\N	\N	\N	\N	219694	219694	386729
29629	48661	2	applied	\N	\N	\N	\N	219695	219695	386730
29633	48662	0	applied	\N	\N	\N	\N	219707	219707	386742
29633	48663	1	applied	\N	\N	\N	\N	219708	219708	386743
29633	48664	2	applied	\N	\N	\N	\N	219709	219709	386744
29633	48665	3	applied	\N	\N	\N	\N	219710	219710	386745
29633	48666	4	applied	\N	\N	\N	\N	219711	219711	386746
29648	48703	5	applied	\N	\N	\N	\N	219767	219767	386799
29555	48033	122	applied	\N	\N	\N	\N	219011	219011	386048
29560	48421	55	applied	\N	\N	\N	\N	219082	219082	386117
29560	48436	56	applied	\N	\N	\N	\N	219083	219083	386118
29560	48447	57	applied	\N	\N	\N	\N	219084	219084	386119
29560	48453	58	applied	\N	\N	\N	\N	219085	219085	386120
29560	48468	59	applied	\N	\N	\N	\N	219086	219086	386121
29560	48381	60	applied	\N	\N	\N	\N	219087	219087	386122
29560	48382	61	applied	\N	\N	\N	\N	219088	219088	386123
29560	48384	62	applied	\N	\N	\N	\N	219089	219089	386124
29560	48392	63	applied	\N	\N	\N	\N	219090	219090	386125
29560	48393	64	applied	\N	\N	\N	\N	219091	219091	386126
29560	48398	65	applied	\N	\N	\N	\N	219092	219092	386127
29560	48399	66	applied	\N	\N	\N	\N	219093	219093	386128
29560	48404	67	applied	\N	\N	\N	\N	219094	219094	386129
29560	48406	68	applied	\N	\N	\N	\N	219095	219095	386130
29560	48409	69	applied	\N	\N	\N	\N	219096	219096	386131
29560	48411	70	applied	\N	\N	\N	\N	219097	219097	386132
29560	48418	72	applied	\N	\N	\N	\N	219099	219099	386134
29560	48420	73	applied	\N	\N	\N	\N	219100	219100	386135
29560	48424	74	applied	\N	\N	\N	\N	219101	219101	386136
29560	48428	75	applied	\N	\N	\N	\N	219102	219102	386137
29560	48432	76	applied	\N	\N	\N	\N	219103	219103	386138
29560	48437	77	applied	\N	\N	\N	\N	219104	219104	386139
29560	48438	78	applied	\N	\N	\N	\N	219105	219105	386140
29560	48440	79	applied	\N	\N	\N	\N	219106	219106	386141
29560	48445	80	applied	\N	\N	\N	\N	219107	219107	386142
29560	48446	81	applied	\N	\N	\N	\N	219108	219108	386143
29560	48450	82	applied	\N	\N	\N	\N	219109	219109	386144
29560	48455	83	applied	\N	\N	\N	\N	219110	219110	386145
29560	48457	84	applied	\N	\N	\N	\N	219111	219111	386146
29560	48461	85	applied	\N	\N	\N	\N	219112	219112	386147
29560	48464	86	applied	\N	\N	\N	\N	219113	219113	386148
29560	48466	87	applied	\N	\N	\N	\N	219114	219114	386149
29560	48375	89	applied	\N	\N	\N	\N	219116	219116	386151
29560	48380	90	applied	\N	\N	\N	\N	219117	219117	386152
29560	48385	91	applied	\N	\N	\N	\N	219118	219118	386153
29560	48390	92	applied	\N	\N	\N	\N	219119	219119	386154
29560	48391	93	applied	\N	\N	\N	\N	219120	219120	386155
29560	48400	94	applied	\N	\N	\N	\N	219121	219121	386156
29560	48401	95	applied	\N	\N	\N	\N	219122	219122	386157
29560	48405	96	applied	\N	\N	\N	\N	219123	219123	386158
29560	48412	97	applied	\N	\N	\N	\N	219124	219124	386159
29560	48416	98	applied	\N	\N	\N	\N	219125	219125	386160
29560	48422	99	applied	\N	\N	\N	\N	219126	219126	386161
29560	48425	100	applied	\N	\N	\N	\N	219127	219127	386162
29560	48429	101	applied	\N	\N	\N	\N	219128	219128	386163
29560	48435	102	applied	\N	\N	\N	\N	219129	219129	386164
29560	48441	103	applied	\N	\N	\N	\N	219130	219130	386165
29560	48444	104	applied	\N	\N	\N	\N	219131	219131	386166
29560	48454	106	applied	\N	\N	\N	\N	219133	219133	386168
29560	48458	107	applied	\N	\N	\N	\N	219134	219134	386169
29560	48463	108	applied	\N	\N	\N	\N	219135	219135	386170
29560	48467	109	applied	\N	\N	\N	\N	219136	219136	386171
29563	48481	0	applied	\N	\N	\N	\N	219149	219149	386184
29563	48482	1	applied	\N	\N	\N	\N	219150	219150	386185
29565	48483	0	applied	\N	\N	\N	\N	219153	219153	386188
29565	48484	1	applied	\N	\N	\N	\N	219154	219154	386189
29565	48485	2	applied	\N	\N	\N	\N	219155	219155	386190
29565	48486	3	applied	\N	\N	\N	\N	219156	219156	386191
29567	48487	0	applied	\N	\N	\N	\N	219163	219163	386198
29567	48488	1	applied	\N	\N	\N	\N	219164	219164	386199
29567	48489	2	applied	\N	\N	\N	\N	219165	219165	386200
29567	48490	3	applied	\N	\N	\N	\N	219166	219166	386201
29567	48491	4	applied	\N	\N	\N	\N	219167	219167	386202
29567	48492	5	applied	\N	\N	\N	\N	219168	219168	386203
29575	48505	1	applied	\N	\N	\N	\N	219199	219199	386234
29575	48506	2	applied	\N	\N	\N	\N	219200	219200	386235
29575	48507	3	applied	\N	\N	\N	\N	219201	219201	386236
29578	48513	0	applied	\N	\N	\N	\N	219209	219209	386244
29578	48514	1	applied	\N	\N	\N	\N	219210	219210	386245
29584	48533	0	applied	\N	\N	\N	\N	219235	219235	386270
29584	48534	1	applied	\N	\N	\N	\N	219236	219236	386271
29584	48535	2	applied	\N	\N	\N	\N	219237	219237	386272
29589	48210	52	applied	\N	\N	\N	\N	219312	219312	386347
29589	48211	53	applied	\N	\N	\N	\N	219313	219313	386348
29589	48218	54	applied	\N	\N	\N	\N	219314	219314	386349
29589	48221	55	applied	\N	\N	\N	\N	219315	219315	386350
29589	48222	56	applied	\N	\N	\N	\N	219316	219316	386351
29589	48228	57	applied	\N	\N	\N	\N	219317	219317	386352
29589	48231	58	applied	\N	\N	\N	\N	219318	219318	386353
29589	48233	59	applied	\N	\N	\N	\N	219319	219319	386354
29589	48240	61	applied	\N	\N	\N	\N	219321	219321	386356
29589	48241	62	applied	\N	\N	\N	\N	219322	219322	386357
29589	48247	63	applied	\N	\N	\N	\N	219323	219323	386358
29589	48250	64	applied	\N	\N	\N	\N	219324	219324	386359
29589	48254	65	applied	\N	\N	\N	\N	219325	219325	386360
29589	48256	66	applied	\N	\N	\N	\N	219326	219326	386361
29589	48261	67	applied	\N	\N	\N	\N	219327	219327	386362
29589	48266	68	applied	\N	\N	\N	\N	219328	219328	386363
29589	48267	69	applied	\N	\N	\N	\N	219329	219329	386364
29589	48274	70	applied	\N	\N	\N	\N	219330	219330	386365
29589	48277	71	applied	\N	\N	\N	\N	219331	219331	386366
29590	48544	0	applied	\N	\N	\N	\N	219356	219356	386391
29590	48545	1	applied	\N	\N	\N	\N	219357	219357	386392
29590	48546	2	applied	\N	\N	\N	\N	219358	219358	386393
29590	48547	3	applied	\N	\N	\N	\N	219359	219359	386394
29590	48548	4	applied	\N	\N	\N	\N	219360	219360	386395
29598	48577	1	applied	\N	\N	\N	\N	219412	219412	386447
29604	48589	0	applied	\N	\N	\N	\N	219550	219550	386585
29604	48590	1	applied	\N	\N	\N	\N	219551	219551	386586
29606	48595	0	applied	\N	\N	\N	\N	219556	219556	386591
29606	48596	1	applied	\N	\N	\N	\N	219557	219557	386592
29606	48597	2	applied	\N	\N	\N	\N	219558	219558	386593
29614	48621	0	applied	\N	\N	\N	\N	219598	219598	386633
29614	48622	1	applied	\N	\N	\N	\N	219599	219599	386634
29614	48623	2	applied	\N	\N	\N	\N	219600	219600	386635
29619	48624	0	applied	\N	\N	\N	\N	219623	219623	386658
29619	48627	1	applied	\N	\N	\N	\N	219624	219624	386659
29619	48628	2	applied	\N	\N	\N	\N	219625	219625	386660
29619	48629	3	applied	\N	\N	\N	\N	219626	219626	386661
29619	48630	4	applied	\N	\N	\N	\N	219627	219627	386662
29560	48389	52	applied	\N	\N	\N	\N	219079	219079	386114
29560	48397	53	applied	\N	\N	\N	\N	219080	219080	386115
29589	48292	75	applied	\N	\N	\N	\N	219335	219335	386370
29589	48293	76	applied	\N	\N	\N	\N	219336	219336	386371
29589	48294	77	applied	\N	\N	\N	\N	219337	219337	386372
29589	48302	78	applied	\N	\N	\N	\N	219338	219338	386373
29589	48305	79	applied	\N	\N	\N	\N	219339	219339	386374
29589	48306	80	applied	\N	\N	\N	\N	219340	219340	386375
29589	48307	81	applied	\N	\N	\N	\N	219341	219341	386376
29589	48314	82	applied	\N	\N	\N	\N	219342	219342	386377
29589	48315	84	applied	\N	\N	\N	\N	219343	219343	386378
29589	48320	85	applied	\N	\N	\N	\N	219344	219344	386379
29589	48321	86	applied	\N	\N	\N	\N	219345	219345	386380
29589	48328	88	applied	\N	\N	\N	\N	219347	219347	386382
29589	48329	89	applied	\N	\N	\N	\N	219348	219348	386383
29589	48330	90	applied	\N	\N	\N	\N	219349	219349	386384
29589	48339	91	applied	\N	\N	\N	\N	219350	219350	386385
29589	48341	92	applied	\N	\N	\N	\N	219351	219351	386386
29589	48344	93	applied	\N	\N	\N	\N	219352	219352	386387
29589	48348	94	applied	\N	\N	\N	\N	219353	219353	386388
29589	48350	95	applied	\N	\N	\N	\N	219354	219354	386389
29589	48352	96	applied	\N	\N	\N	\N	219355	219355	386390
29593	48549	0	applied	\N	\N	\N	\N	219372	219372	386407
29593	48550	1	applied	\N	\N	\N	\N	219373	219373	386408
29593	48551	2	applied	\N	\N	\N	\N	219374	219374	386409
29593	48552	3	applied	\N	\N	\N	\N	219375	219375	386410
29593	48553	4	applied	\N	\N	\N	\N	219376	219376	386411
29593	48554	5	applied	\N	\N	\N	\N	219377	219377	386412
29597	48570	0	applied	\N	\N	\N	\N	219405	219405	386440
29597	48572	3	applied	\N	\N	\N	\N	219407	219407	386442
29597	48573	4	applied	\N	\N	\N	\N	219408	219408	386443
29597	48574	5	applied	\N	\N	\N	\N	219409	219409	386444
29597	48575	6	applied	\N	\N	\N	\N	219410	219410	386445
29599	48578	0	applied	\N	\N	\N	\N	219413	219413	386448
29599	48579	1	applied	\N	\N	\N	\N	219414	219414	386449
29599	48580	2	applied	\N	\N	\N	\N	219415	219415	386450
29599	48581	3	applied	\N	\N	\N	\N	219416	219416	386451
29601	48582	0	applied	\N	\N	\N	\N	219420	219420	386455
29601	48583	1	applied	\N	\N	\N	\N	219421	219421	386456
29601	48579	2	applied	\N	\N	\N	\N	219422	219422	386457
29601	48584	3	applied	\N	\N	1000000000	\N	219423	219423	386458
29601	48585	4	applied	\N	\N	\N	\N	219424	219424	386459
29603	48508	0	applied	\N	\N	\N	\N	219428	219428	386463
29603	48509	1	applied	\N	\N	\N	\N	219429	219429	386464
29603	48522	2	applied	\N	\N	\N	\N	219430	219430	386465
29603	48471	4	applied	\N	\N	\N	\N	219432	219432	386467
29603	48523	5	applied	\N	\N	\N	\N	219433	219433	386468
29603	48472	6	applied	\N	\N	\N	\N	219434	219434	386469
29603	48473	7	applied	\N	\N	\N	\N	219435	219435	386470
29603	48481	8	applied	\N	\N	\N	\N	219436	219436	386471
29603	48483	9	applied	\N	\N	\N	\N	219437	219437	386472
29603	48487	10	applied	\N	\N	\N	\N	219438	219438	386473
29603	48488	11	applied	\N	\N	\N	\N	219439	219439	386474
29603	48493	12	applied	\N	\N	\N	\N	219440	219440	386475
29603	48494	13	applied	\N	\N	\N	\N	219441	219441	386476
29603	48499	14	applied	\N	\N	\N	\N	219442	219442	386477
29603	48502	15	applied	\N	\N	\N	\N	219443	219443	386478
29603	48504	16	applied	\N	\N	\N	\N	219444	219444	386479
29603	48510	17	applied	\N	\N	\N	\N	219445	219445	386480
29603	48513	18	applied	\N	\N	\N	\N	219446	219446	386481
29603	48515	19	applied	\N	\N	\N	\N	219447	219447	386482
29603	48524	21	applied	\N	\N	\N	\N	219449	219449	386484
29603	48525	22	applied	\N	\N	\N	\N	219450	219450	386485
29603	48526	23	applied	\N	\N	\N	\N	219451	219451	386486
29603	48533	24	applied	\N	\N	\N	\N	219452	219452	386487
29603	48536	25	applied	\N	\N	\N	\N	219453	219453	386488
29603	48537	26	applied	\N	\N	\N	\N	219454	219454	386489
29603	48544	27	applied	\N	\N	\N	\N	219455	219455	386490
29603	48545	28	applied	\N	\N	\N	\N	219456	219456	386491
29603	48549	29	applied	\N	\N	\N	\N	219457	219457	386492
29603	48550	30	applied	\N	\N	\N	\N	219458	219458	386493
29603	48555	31	applied	\N	\N	\N	\N	219459	219459	386494
29603	48558	32	applied	\N	\N	\N	\N	219460	219460	386495
29603	48559	33	applied	\N	\N	\N	\N	219461	219461	386496
29603	48560	34	applied	\N	\N	\N	\N	219462	219462	386497
29603	48561	35	applied	\N	\N	\N	\N	219463	219463	386498
29603	48570	36	applied	\N	\N	\N	\N	219464	219464	386499
29603	48576	38	applied	\N	\N	\N	\N	219466	219466	386501
29603	48578	39	applied	\N	\N	\N	\N	219467	219467	386502
29603	48582	40	applied	\N	\N	\N	\N	219468	219468	386503
29603	48586	41	applied	\N	\N	\N	\N	219469	219469	386504
29603	48589	42	applied	\N	\N	\N	\N	219470	219470	386505
29603	48540	43	applied	\N	\N	\N	\N	219471	219471	386506
29603	48541	44	applied	\N	\N	1000000000	\N	219472	219472	386507
29603	48584	45	applied	\N	\N	1000000000	\N	219473	219473	386508
29603	48475	46	applied	\N	\N	\N	\N	219474	219474	386509
29603	48476	47	applied	\N	\N	\N	\N	219475	219475	386510
29603	48477	48	applied	\N	\N	\N	\N	219476	219476	386511
29603	48486	49	applied	\N	\N	\N	\N	219477	219477	386512
29603	48489	50	applied	\N	\N	\N	\N	219478	219478	386513
29603	48490	51	applied	\N	\N	\N	\N	219479	219479	386514
29603	48478	52	applied	\N	\N	\N	\N	219480	219480	386515
29603	48484	53	applied	\N	\N	\N	\N	219481	219481	386516
29603	48506	55	applied	\N	\N	\N	\N	219483	219483	386518
29603	48516	56	applied	\N	\N	\N	\N	219484	219484	386519
29603	48498	57	applied	\N	\N	\N	\N	219485	219485	386520
29603	48501	58	applied	\N	\N	\N	\N	219486	219486	386521
29603	48507	59	applied	\N	\N	\N	\N	219487	219487	386522
29603	48511	60	applied	\N	\N	\N	\N	219488	219488	386523
29603	48518	61	applied	\N	\N	\N	\N	219489	219489	386524
29603	48520	63	applied	\N	\N	\N	\N	219490	219490	386525
29603	48527	64	applied	\N	\N	\N	\N	219491	219491	386526
29603	48528	65	applied	\N	\N	\N	\N	219492	219492	386527
29603	48534	66	applied	\N	\N	\N	\N	219493	219493	386528
29603	48538	67	applied	\N	\N	\N	\N	219494	219494	386529
29603	48546	68	applied	\N	\N	\N	\N	219495	219495	386530
29603	48470	69	applied	\N	\N	\N	\N	219496	219496	386531
29603	48474	70	applied	\N	\N	\N	\N	219497	219497	386532
29603	48479	71	applied	\N	\N	\N	\N	219498	219498	386533
29603	48482	73	applied	\N	\N	\N	\N	219500	219500	386535
29603	48485	74	applied	\N	\N	\N	\N	219501	219501	386536
29589	48284	73	applied	\N	\N	\N	\N	219333	219333	386368
29589	48286	74	applied	\N	\N	\N	\N	219334	219334	386369
29603	48500	79	applied	\N	\N	\N	\N	219506	219506	386541
29603	48503	80	applied	\N	\N	\N	\N	219507	219507	386542
29603	48505	81	applied	\N	\N	\N	\N	219508	219508	386543
29603	48512	82	applied	\N	\N	\N	\N	219509	219509	386544
29603	48514	83	applied	\N	\N	\N	\N	219510	219510	386545
29603	48517	84	applied	\N	\N	\N	\N	219511	219511	386546
29603	48521	85	applied	\N	\N	\N	\N	219512	219512	386547
29603	48529	86	applied	\N	\N	\N	\N	219513	219513	386548
29603	48530	87	applied	\N	\N	\N	\N	219514	219514	386549
29603	48531	88	applied	\N	\N	\N	\N	219515	219515	386550
29603	48535	89	applied	\N	\N	\N	\N	219516	219516	386551
29603	48542	90	applied	\N	\N	\N	\N	219517	219517	386552
29603	48543	91	applied	\N	\N	\N	\N	219518	219518	386553
29603	48547	92	applied	\N	\N	\N	\N	219519	219519	386554
29603	48552	93	applied	\N	\N	\N	\N	219520	219520	386555
29603	48553	94	applied	\N	\N	\N	\N	219521	219521	386556
29603	48564	96	applied	\N	\N	\N	\N	219523	219523	386558
29603	48565	97	applied	\N	\N	\N	\N	219524	219524	386559
29603	48567	98	applied	\N	\N	\N	\N	219525	219525	386560
29603	48568	99	applied	\N	\N	\N	\N	219526	219526	386561
29603	48572	100	applied	\N	\N	\N	\N	219527	219527	386562
29603	48574	101	applied	\N	\N	\N	\N	219528	219528	386563
29603	48577	102	applied	\N	\N	\N	\N	219529	219529	386564
29603	48581	103	applied	\N	\N	\N	\N	219530	219530	386565
29603	48585	104	applied	\N	\N	\N	\N	219531	219531	386566
29603	48587	105	applied	\N	\N	\N	\N	219532	219532	386567
29603	48590	106	applied	\N	\N	\N	\N	219533	219533	386568
29603	48532	107	applied	\N	\N	\N	\N	219534	219534	386569
29603	48539	108	applied	\N	\N	\N	\N	219535	219535	386570
29603	48554	109	applied	\N	\N	\N	\N	219536	219536	386571
29603	48569	110	applied	\N	\N	\N	\N	219537	219537	386572
29603	48573	111	applied	\N	\N	\N	\N	219538	219538	386573
29603	48548	113	applied	\N	\N	\N	\N	219540	219540	386575
29603	48551	114	applied	\N	\N	\N	\N	219541	219541	386576
29603	48556	115	applied	\N	\N	\N	\N	219542	219542	386577
29603	48562	116	applied	\N	\N	\N	\N	219543	219543	386578
29603	48563	117	applied	\N	\N	\N	\N	219544	219544	386579
29603	48566	118	applied	\N	\N	\N	\N	219545	219545	386580
29603	48575	119	applied	\N	\N	\N	\N	219546	219546	386581
29603	48580	120	applied	\N	\N	\N	\N	219547	219547	386582
29603	48583	121	applied	\N	\N	\N	\N	219548	219548	386583
29603	48588	122	applied	\N	\N	\N	\N	219549	219549	386584
29605	48591	0	applied	\N	\N	\N	\N	219552	219552	386587
29605	48592	1	applied	\N	\N	\N	\N	219553	219553	386588
29605	48593	2	applied	\N	\N	\N	\N	219554	219554	386589
29605	48594	3	applied	\N	\N	\N	\N	219555	219555	386590
29607	48595	0	applied	\N	\N	\N	\N	219559	219559	386594
29607	48596	1	applied	\N	\N	\N	\N	219560	219560	386595
29609	48598	0	applied	\N	\N	\N	\N	219565	219565	386600
29609	48599	1	applied	\N	\N	\N	\N	219566	219566	386601
29609	48600	2	applied	\N	\N	\N	\N	219567	219567	386602
29611	48601	0	applied	\N	\N	\N	\N	219571	219571	386606
29611	48602	1	applied	\N	\N	\N	\N	219572	219572	386607
29611	48603	2	applied	\N	\N	\N	\N	219573	219573	386608
29611	48604	3	applied	\N	\N	\N	\N	219574	219574	386609
29611	48605	4	applied	\N	\N	\N	\N	219575	219575	386610
29611	48606	5	applied	\N	\N	\N	\N	219576	219576	386611
29611	48607	6	applied	\N	\N	\N	\N	219577	219577	386612
29611	48608	7	applied	\N	\N	\N	\N	219578	219578	386613
29611	48609	8	applied	\N	\N	\N	\N	219579	219579	386614
29611	48610	9	applied	\N	\N	\N	\N	219580	219580	386615
29611	48611	10	applied	\N	\N	\N	\N	219581	219581	386616
29611	48612	11	applied	\N	\N	\N	\N	219582	219582	386617
29611	48613	12	applied	\N	\N	\N	\N	219583	219583	386618
29613	48615	1	applied	\N	\N	\N	\N	219592	219592	386627
29613	48616	2	applied	\N	\N	\N	\N	219593	219593	386628
29613	48617	3	applied	\N	\N	\N	\N	219594	219594	386629
29613	48618	4	applied	\N	\N	\N	\N	219595	219595	386630
29613	48619	5	applied	\N	\N	\N	\N	219596	219596	386631
29613	48620	6	applied	\N	\N	\N	\N	219597	219597	386632
29615	48624	0	applied	\N	\N	\N	\N	219601	219601	386636
29615	48625	1	applied	\N	\N	\N	\N	219602	219602	386637
29615	48626	2	applied	\N	\N	\N	\N	219603	219603	386638
29617	48624	0	applied	\N	\N	\N	\N	219605	219605	386640
29617	48627	1	applied	\N	\N	\N	\N	219606	219606	386641
29617	48628	2	applied	\N	\N	\N	\N	219607	219607	386642
29617	48629	3	applied	\N	\N	\N	\N	219608	219608	386643
29617	48630	4	applied	\N	\N	\N	\N	219609	219609	386644
29617	48625	5	applied	\N	\N	\N	\N	219610	219610	386645
29617	48631	6	applied	\N	\N	\N	\N	219611	219611	386646
29617	48633	8	applied	\N	\N	\N	\N	219613	219613	386648
29619	48625	5	applied	\N	\N	\N	\N	219628	219628	386663
29619	48631	6	applied	\N	\N	\N	\N	219629	219629	386664
29619	48632	7	applied	\N	\N	\N	\N	219630	219630	386665
29619	48633	8	applied	\N	\N	\N	\N	219631	219631	386666
29621	48634	0	applied	\N	\N	\N	\N	219638	219638	386673
29621	48635	1	applied	\N	\N	\N	\N	219639	219639	386674
29621	48636	2	applied	\N	\N	\N	\N	219640	219640	386675
29621	48637	3	applied	\N	\N	\N	\N	219641	219641	386676
29621	48638	4	applied	\N	\N	\N	\N	219642	219642	386677
29621	48639	5	applied	\N	\N	\N	\N	219643	219643	386678
29623	48640	0	applied	\N	\N	\N	\N	219650	219650	386685
29623	48641	1	applied	\N	\N	\N	\N	219651	219651	386686
29623	48642	2	applied	\N	\N	\N	\N	219652	219652	386687
29623	48643	3	applied	\N	\N	\N	\N	219653	219653	386688
29623	48644	4	applied	\N	\N	\N	\N	219654	219654	386689
29626	48646	0	applied	\N	\N	\N	\N	219675	219675	386710
29626	48647	1	applied	\N	\N	\N	\N	219676	219676	386711
29626	48648	2	applied	\N	\N	\N	\N	219677	219677	386712
29626	48649	3	applied	\N	\N	\N	\N	219678	219678	386713
29646	48693	0	applied	\N	\N	\N	\N	219752	219752	386784
29646	48694	1	applied	\N	\N	\N	\N	219753	219753	386785
29646	48695	2	applied	\N	\N	\N	\N	219754	219754	386786
29646	48696	3	applied	\N	\N	\N	\N	219755	219755	386787
29646	48697	4	applied	\N	\N	\N	\N	219756	219756	386788
29648	48698	0	applied	\N	\N	\N	\N	219762	219762	386794
29648	48699	1	applied	\N	\N	\N	\N	219763	219763	386795
29648	48700	2	applied	\N	\N	\N	\N	219764	219764	386796
29648	48701	3	applied	\N	\N	\N	\N	219765	219765	386797
29648	48702	4	applied	\N	\N	\N	\N	219766	219766	386798
29603	48492	76	applied	\N	\N	\N	\N	219503	219503	386538
29603	48495	77	applied	\N	\N	\N	\N	219504	219504	386539
29625	48655	9	applied	\N	\N	\N	\N	219671	219671	386706
29625	48656	10	applied	\N	\N	\N	\N	219672	219672	386707
29625	48657	11	applied	\N	\N	\N	\N	219673	219673	386708
29625	48658	12	applied	\N	\N	\N	\N	219674	219674	386709
29626	48650	4	applied	\N	\N	\N	\N	219679	219679	386714
29626	48651	5	applied	\N	\N	\N	\N	219680	219680	386715
29626	48652	6	applied	\N	\N	\N	\N	219681	219681	386716
29626	48653	7	applied	\N	\N	\N	\N	219682	219682	386717
29626	48654	8	applied	\N	\N	\N	\N	219683	219683	386718
29626	48655	9	applied	\N	\N	\N	\N	219684	219684	386719
29626	48656	10	applied	\N	\N	\N	\N	219685	219685	386720
29626	48657	11	applied	\N	\N	\N	\N	219686	219686	386721
29626	48658	12	applied	\N	\N	\N	\N	219687	219687	386722
29627	48659	0	applied	\N	\N	\N	\N	219688	219688	386723
29627	48661	2	applied	\N	\N	\N	\N	219690	219690	386725
29628	48660	0	applied	\N	\N	\N	\N	219691	219691	386726
29628	48661	1	applied	\N	\N	\N	\N	219692	219692	386727
29632	48662	0	applied	\N	\N	\N	\N	219696	219696	386731
29632	48663	1	applied	\N	\N	\N	\N	219697	219697	386732
29632	48664	2	applied	\N	\N	\N	\N	219698	219698	386733
29632	48665	3	applied	\N	\N	\N	\N	219699	219699	386734
29632	48666	4	applied	\N	\N	\N	\N	219700	219700	386735
29632	48667	5	applied	\N	\N	1000000000	\N	219701	219701	386736
29632	48668	6	applied	\N	\N	\N	\N	219702	219702	386737
29632	48669	7	applied	\N	\N	\N	\N	219703	219703	386738
29632	48670	8	applied	\N	\N	\N	\N	219704	219704	386739
29634	48673	0	applied	\N	\N	\N	\N	219718	219718	386753
29634	48674	1	applied	\N	\N	\N	\N	219719	219719	386754
29634	48675	2	applied	\N	\N	\N	\N	219720	219720	386755
29639	48679	0	applied	\N	\N	\N	\N	219729	219729	386761
29639	48681	2	applied	\N	\N	\N	\N	219731	219731	386763
29639	48682	3	applied	\N	\N	\N	\N	219732	219732	386764
29639	48683	4	applied	\N	\N	\N	\N	219733	219733	386765
29641	48684	0	applied	\N	\N	\N	\N	219737	219737	386769
29641	48685	1	applied	\N	\N	\N	\N	219738	219738	386770
29641	48686	2	applied	\N	\N	\N	\N	219739	219739	386771
29645	48690	0	applied	\N	\N	\N	\N	219748	219748	386780
29645	48691	1	applied	\N	\N	\N	\N	219749	219749	386781
29645	48689	2	applied	\N	\N	\N	\N	219750	219750	386782
29645	48692	3	applied	\N	\N	\N	\N	219751	219751	386783
29649	48698	0	applied	\N	\N	\N	\N	219768	219768	386800
29649	48699	1	applied	\N	\N	\N	\N	219769	219769	386801
29649	48704	2	applied	\N	\N	\N	\N	219770	219770	386802
29649	48700	3	applied	\N	\N	\N	\N	219771	219771	386803
29649	48705	4	applied	\N	\N	\N	\N	219772	219772	386804
29649	48706	5	applied	\N	\N	\N	\N	219773	219773	386805
29649	48702	7	applied	\N	\N	\N	\N	219775	219775	386807
29649	48703	8	applied	\N	\N	\N	\N	219776	219776	386808
29652	48726	0	applied	\N	\N	\N	\N	219803	219803	386835
29652	48727	1	applied	\N	\N	\N	\N	219804	219804	386836
29652	48728	2	applied	\N	\N	\N	\N	219805	219805	386837
29652	48729	3	applied	\N	\N	\N	\N	219806	219806	386838
29652	48730	4	applied	\N	\N	\N	\N	219807	219807	386839
29652	48731	5	applied	\N	\N	\N	\N	219808	219808	386840
29652	48732	6	applied	\N	\N	\N	\N	219809	219809	386841
29654	48733	0	applied	\N	\N	\N	\N	219817	219817	219817
29654	48734	1	applied	\N	\N	\N	\N	219818	219818	386849
29654	48735	2	applied	\N	\N	\N	\N	219819	219819	386850
29654	48736	3	applied	\N	\N	\N	\N	219820	219820	386851
29654	48737	4	applied	\N	\N	\N	\N	219821	219821	386852
29654	48738	5	applied	\N	\N	\N	\N	219822	219822	386853
29654	48739	6	applied	\N	\N	\N	\N	219823	219823	386854
29654	48741	8	applied	\N	\N	\N	\N	219825	219825	386856
29654	48742	9	applied	\N	\N	\N	\N	219826	219826	386857
29654	48743	10	applied	\N	\N	\N	\N	219827	219827	386858
29654	48744	11	applied	\N	\N	\N	\N	219828	219828	386859
29654	48745	12	applied	\N	\N	\N	\N	219829	219829	386860
29654	48746	13	applied	\N	\N	\N	\N	219830	219830	386861
29654	48747	14	applied	\N	\N	\N	\N	219831	219831	386862
29654	48748	15	applied	\N	\N	\N	\N	219832	219832	386863
29654	48749	16	applied	\N	\N	\N	\N	219833	219833	386864
29654	48750	17	applied	\N	\N	\N	\N	219834	219834	386865
29654	48751	18	applied	\N	\N	\N	\N	219835	219835	386866
29654	48752	19	applied	\N	\N	\N	\N	219836	219836	386867
29656	48783	0	applied	\N	\N	\N	\N	219867	219867	386898
29656	48784	1	applied	\N	\N	\N	\N	219868	219868	386899
29656	48785	2	applied	\N	\N	\N	\N	219869	219869	386900
29656	48786	3	applied	\N	\N	\N	\N	219870	219870	386901
29656	48788	5	applied	\N	\N	\N	\N	219872	219872	386903
29656	48789	6	applied	\N	\N	\N	\N	219873	219873	386904
29656	48790	7	applied	\N	\N	\N	\N	219874	219874	386905
29656	48791	8	applied	\N	\N	\N	\N	219875	219875	219875
29662	48829	0	applied	\N	\N	\N	\N	219941	219941	386970
29662	48830	1	applied	\N	\N	\N	\N	219942	219942	386971
29662	48831	2	applied	\N	\N	\N	\N	219943	219943	386972
29662	48832	3	applied	\N	\N	\N	\N	219944	219944	386973
29662	48833	4	applied	\N	\N	\N	\N	219945	219945	386974
29662	48834	5	applied	\N	\N	\N	\N	219946	219946	386975
29662	48835	6	applied	\N	\N	\N	\N	219947	219947	386976
29662	48836	7	applied	\N	\N	\N	\N	219948	219948	386977
29662	48837	8	applied	\N	\N	\N	\N	219949	219949	386978
29664	48838	0	applied	\N	\N	\N	\N	219959	219959	386988
29664	48839	1	applied	\N	\N	\N	\N	219960	219960	386989
29664	48840	2	applied	\N	\N	\N	\N	219961	219961	386990
29664	48842	4	applied	\N	\N	\N	\N	219963	219963	386992
29664	48843	5	applied	\N	\N	\N	\N	219964	219964	386993
29664	48844	6	applied	\N	\N	\N	\N	219965	219965	386994
29669	48892	0	applied	\N	\N	\N	\N	220040	220040	387069
29669	48893	1	applied	\N	\N	\N	\N	220041	220041	387070
29669	48894	2	applied	\N	\N	\N	\N	220042	220042	387071
29669	48895	3	applied	\N	\N	\N	\N	220043	220043	387072
29669	48896	4	applied	\N	\N	\N	\N	220044	220044	387073
29669	48897	5	applied	\N	\N	\N	\N	220045	220045	387074
29669	48898	6	applied	\N	\N	\N	\N	220046	220046	387075
29669	48899	7	applied	\N	\N	\N	\N	220047	220047	387076
29669	48900	8	applied	\N	\N	\N	\N	220048	220048	387077
29674	48919	0	applied	\N	\N	\N	\N	220112	220112	387141
29674	48920	1	applied	\N	\N	\N	\N	220113	220113	387142
29674	48921	2	applied	\N	\N	\N	\N	220114	220114	387143
29674	48922	3	applied	\N	\N	\N	\N	220115	220115	387144
29625	48654	8	applied	\N	\N	\N	\N	219670	219670	386705
29633	48668	6	applied	\N	\N	\N	\N	219713	219713	386748
29633	48669	7	applied	\N	\N	\N	\N	219714	219714	386749
29633	48670	8	applied	\N	\N	\N	\N	219715	219715	386750
29633	48671	9	applied	\N	\N	\N	\N	219716	219716	386751
29633	48672	10	applied	\N	\N	\N	\N	219717	219717	386752
29635	48676	0	applied	\N	\N	\N	\N	219721	219721	386756
29635	48677	1	applied	\N	\N	\N	\N	219722	219722	219722
29635	48678	2	applied	\N	\N	\N	\N	219723	219723	386757
29636	48676	0	applied	\N	\N	\N	\N	219724	219724	386758
29636	48677	1	applied	\N	\N	\N	\N	219725	219725	219725
29636	48678	2	applied	\N	\N	\N	\N	219726	219726	386759
29637	48676	0	applied	\N	\N	\N	\N	219727	219727	386760
29637	48677	1	applied	\N	\N	\N	\N	219728	219728	219728
29640	48685	1	applied	\N	\N	\N	\N	219735	219735	386767
29640	48686	2	applied	\N	\N	\N	\N	219736	219736	386768
29642	48687	0	applied	\N	\N	\N	\N	219740	219740	386772
29642	48688	1	applied	\N	\N	\N	\N	219741	219741	386773
29643	48687	0	applied	\N	\N	\N	\N	219742	219742	386774
29643	48688	1	applied	\N	\N	\N	\N	219743	219743	386775
29643	48689	2	applied	\N	\N	\N	\N	219744	219744	386776
29644	48687	0	applied	\N	\N	\N	\N	219745	219745	386777
29644	48688	1	applied	\N	\N	\N	\N	219746	219746	386778
29644	48689	2	applied	\N	\N	\N	\N	219747	219747	386779
29647	48693	0	applied	\N	\N	\N	\N	219757	219757	386789
29647	48694	1	applied	\N	\N	\N	\N	219758	219758	386790
29647	48695	2	applied	\N	\N	\N	\N	219759	219759	386791
29647	48696	3	applied	\N	\N	\N	\N	219760	219760	386792
29650	48707	0	applied	\N	\N	\N	\N	219777	219777	386809
29650	48708	1	applied	\N	\N	\N	\N	219778	219778	386810
29650	48710	3	applied	\N	\N	\N	\N	219780	219780	386812
29650	48711	4	applied	\N	\N	\N	\N	219781	219781	386813
29650	48712	5	applied	\N	\N	\N	\N	219782	219782	386814
29650	48713	6	applied	\N	\N	\N	\N	219783	219783	386815
29650	48714	7	applied	\N	\N	\N	\N	219784	219784	386816
29650	48715	8	applied	\N	\N	\N	\N	219785	219785	386817
29650	48716	9	applied	\N	\N	\N	\N	219786	219786	386818
29650	48717	10	applied	\N	\N	\N	\N	219787	219787	386819
29650	48718	11	applied	\N	\N	\N	\N	219788	219788	386820
29650	48719	12	applied	\N	\N	\N	\N	219789	219789	386821
29650	48720	13	applied	\N	\N	\N	\N	219790	219790	386822
29650	48721	14	applied	\N	\N	\N	\N	219791	219791	386823
29650	48722	15	applied	\N	\N	\N	\N	219792	219792	386824
29650	48723	16	applied	\N	\N	\N	\N	219793	219793	386825
29650	48724	17	applied	\N	\N	\N	\N	219794	219794	386826
29650	48725	18	applied	\N	\N	\N	\N	219795	219795	386827
29655	48754	1	applied	\N	\N	1000000000	\N	219838	219838	386869
29655	48755	2	applied	\N	\N	\N	\N	219839	219839	386870
29655	48756	3	applied	\N	\N	\N	\N	219840	219840	386871
29655	48757	4	applied	\N	\N	\N	\N	219841	219841	386872
29655	48758	5	applied	\N	\N	\N	\N	219842	219842	386873
29655	48759	6	applied	\N	\N	\N	\N	219843	219843	386874
29655	48760	7	applied	\N	\N	\N	\N	219844	219844	386875
29655	48761	8	applied	\N	\N	\N	\N	219845	219845	386876
29655	48762	9	applied	\N	\N	\N	\N	219846	219846	386877
29655	48763	10	applied	\N	\N	\N	\N	219847	219847	386878
29655	48764	11	applied	\N	\N	\N	\N	219848	219848	386879
29655	48765	13	applied	\N	\N	\N	\N	219849	219849	386880
29655	48766	14	applied	\N	\N	\N	\N	219850	219850	386881
29655	48767	15	applied	\N	\N	\N	\N	219851	219851	386882
29655	48768	16	applied	\N	\N	\N	\N	219852	219852	386883
29655	48769	17	applied	\N	\N	\N	\N	219853	219853	386884
29655	48771	19	applied	\N	\N	\N	\N	219855	219855	386886
29655	48772	20	applied	\N	\N	\N	\N	219856	219856	386887
29655	48773	21	applied	\N	\N	\N	\N	219857	219857	386888
29655	48774	22	applied	\N	\N	\N	\N	219858	219858	386889
29655	48775	23	applied	\N	\N	\N	\N	219859	219859	386890
29655	48776	24	applied	\N	\N	\N	\N	219860	219860	386891
29655	48777	25	applied	\N	\N	\N	\N	219861	219861	386892
29655	48778	26	applied	\N	\N	\N	\N	219862	219862	386893
29655	48779	27	applied	\N	\N	\N	\N	219863	219863	386894
29655	48780	28	applied	\N	\N	\N	\N	219864	219864	386895
29655	48781	29	applied	\N	\N	\N	\N	219865	219865	386896
29655	48782	30	applied	\N	\N	\N	\N	219866	219866	386897
29657	48792	0	applied	\N	\N	\N	\N	219876	219876	386906
29657	48793	1	applied	\N	\N	\N	\N	219877	219877	386907
29657	48783	2	applied	\N	\N	\N	\N	219878	219878	386908
29657	48784	3	applied	\N	\N	\N	\N	219879	219879	386909
29657	48794	5	applied	\N	\N	\N	\N	219881	219881	386911
29657	48786	6	applied	\N	\N	\N	\N	219882	219882	386912
29657	48787	7	applied	\N	\N	\N	\N	219883	219883	386913
29657	48788	8	applied	\N	\N	\N	\N	219884	219884	386914
29657	48795	9	applied	\N	\N	\N	\N	219885	219885	386915
29657	48789	10	applied	\N	\N	\N	\N	219886	219886	386916
29657	48790	11	applied	\N	\N	\N	\N	219887	219887	386917
29657	48796	12	applied	\N	\N	\N	\N	219888	219888	386918
29657	48797	13	applied	\N	\N	\N	\N	219889	219889	386919
29657	48798	14	applied	\N	\N	\N	\N	219890	219890	386920
29657	48799	15	applied	\N	\N	\N	\N	219891	219891	386921
29657	48800	16	applied	\N	\N	\N	\N	219892	219892	386922
29657	48791	17	applied	\N	\N	\N	\N	219893	219893	219893
29657	48801	18	applied	\N	\N	\N	\N	219894	219894	386923
29657	48802	19	applied	\N	\N	\N	\N	219895	219895	386924
29657	48803	20	applied	\N	\N	\N	\N	219896	219896	386925
29659	48806	0	applied	\N	\N	\N	\N	219912	219912	386941
29659	48807	1	applied	\N	\N	\N	\N	219913	219913	386942
29659	48808	2	applied	\N	\N	\N	\N	219914	219914	386943
29659	48809	3	applied	\N	\N	\N	\N	219915	219915	386944
29659	48810	4	applied	\N	\N	\N	\N	219916	219916	386945
29659	48811	5	applied	\N	\N	\N	\N	219917	219917	386946
29659	48812	6	applied	\N	\N	\N	\N	219918	219918	386947
29659	48813	7	applied	\N	\N	\N	\N	219919	219919	386948
29659	48814	8	applied	\N	\N	\N	\N	219920	219920	386949
29659	48815	9	applied	\N	\N	\N	\N	219921	219921	386950
29659	48816	10	applied	\N	\N	\N	\N	219922	219922	386951
29659	48817	11	applied	\N	\N	\N	\N	219923	219923	386952
29659	48818	12	applied	\N	\N	\N	\N	219924	219924	386953
29659	48819	13	applied	\N	\N	\N	\N	219925	219925	386954
29659	48820	14	applied	\N	\N	\N	\N	219926	219926	386955
29661	48829	0	applied	\N	\N	\N	\N	219935	219935	386964
29632	48672	10	applied	\N	\N	\N	\N	219706	219706	386741
29633	48667	5	applied	\N	\N	1000000000	\N	219712	219712	386747
29651	48729	3	applied	\N	\N	\N	\N	219799	219799	386831
29651	48730	4	applied	\N	\N	\N	\N	219800	219800	386832
29651	48731	5	applied	\N	\N	\N	\N	219801	219801	386833
29651	48732	6	applied	\N	\N	\N	\N	219802	219802	386834
29653	48726	0	applied	\N	\N	\N	\N	219810	219810	386842
29653	48727	1	applied	\N	\N	\N	\N	219811	219811	386843
29653	48728	2	applied	\N	\N	\N	\N	219812	219812	386844
29653	48729	3	applied	\N	\N	\N	\N	219813	219813	386845
29653	48730	4	applied	\N	\N	\N	\N	219814	219814	386846
29653	48731	5	applied	\N	\N	\N	\N	219815	219815	386847
29653	48732	6	applied	\N	\N	\N	\N	219816	219816	386848
29658	48792	0	applied	\N	\N	\N	\N	219898	219898	386927
29658	48793	1	applied	\N	\N	\N	\N	219899	219899	386928
29658	48794	2	applied	\N	\N	\N	\N	219900	219900	386929
29658	48796	4	applied	\N	\N	\N	\N	219902	219902	386931
29658	48797	5	applied	\N	\N	\N	\N	219903	219903	386932
29658	48798	6	applied	\N	\N	\N	\N	219904	219904	386933
29658	48799	7	applied	\N	\N	\N	\N	219905	219905	386934
29658	48800	8	applied	\N	\N	\N	\N	219906	219906	386935
29658	48795	9	applied	\N	\N	\N	\N	219907	219907	386936
29658	48801	10	applied	\N	\N	\N	\N	219908	219908	386937
29658	48802	11	applied	\N	\N	\N	\N	219909	219909	386938
29658	48803	12	applied	\N	\N	\N	\N	219910	219910	386939
29658	48804	13	applied	\N	\N	\N	\N	219911	219911	386940
29660	48821	0	applied	\N	\N	\N	\N	219927	219927	386956
29660	48822	1	applied	\N	\N	\N	\N	219928	219928	386957
29660	48823	2	applied	\N	\N	\N	\N	219929	219929	386958
29660	48824	3	applied	\N	\N	\N	\N	219930	219930	386959
29660	48825	4	applied	\N	\N	\N	\N	219931	219931	386960
29660	48826	5	applied	\N	\N	\N	\N	219932	219932	386961
29677	48961	0	applied	\N	\N	\N	\N	220154	220154	387182
29677	48962	1	applied	\N	\N	\N	\N	220155	220155	387183
29677	48963	2	applied	\N	\N	\N	\N	220156	220156	387184
29677	48964	3	applied	\N	\N	\N	\N	220157	220157	387185
29677	48965	4	applied	\N	\N	\N	\N	220158	220158	387186
29677	48966	5	applied	\N	\N	\N	\N	220159	220159	387187
29677	48967	6	applied	\N	\N	\N	\N	220160	220160	387188
29677	48968	7	applied	\N	\N	\N	\N	220161	220161	387189
29677	48969	8	applied	\N	\N	\N	\N	220162	220162	387190
29677	48970	9	applied	\N	\N	\N	\N	220163	220163	387191
29677	48971	10	applied	\N	\N	\N	\N	220164	220164	387192
29677	48972	11	applied	\N	\N	\N	\N	220165	220165	387193
29679	48961	0	applied	\N	\N	\N	\N	220175	220175	387203
29679	48962	1	applied	\N	\N	\N	\N	220176	220176	387204
29679	48963	2	applied	\N	\N	\N	\N	220177	220177	387205
29679	48964	3	applied	\N	\N	\N	\N	220178	220178	387206
29679	48966	5	applied	\N	\N	\N	\N	220180	220180	387208
29679	48967	6	applied	\N	\N	\N	\N	220181	220181	387209
29679	48968	7	applied	\N	\N	\N	\N	220182	220182	387210
29679	48969	8	applied	\N	\N	\N	\N	220183	220183	387211
29679	48970	9	applied	\N	\N	\N	\N	220184	220184	387212
29679	48971	10	applied	\N	\N	\N	\N	220185	220185	387213
29679	48972	11	applied	\N	\N	\N	\N	220186	220186	387214
29683	48982	0	applied	\N	\N	\N	\N	220233	220233	387261
29683	48983	1	applied	\N	\N	\N	\N	220234	220234	387262
29683	48984	2	applied	\N	\N	\N	\N	220235	220235	387263
29683	48985	3	applied	\N	\N	\N	\N	220236	220236	387264
29683	48986	4	applied	\N	\N	\N	\N	220237	220237	387265
29683	48987	6	applied	\N	\N	\N	\N	220238	220238	387266
29683	48988	7	applied	\N	\N	\N	\N	220239	220239	387267
29683	48989	8	applied	\N	\N	\N	\N	220240	220240	387268
29683	48990	9	applied	\N	\N	\N	\N	220241	220241	387269
29683	48992	11	applied	\N	\N	\N	\N	220243	220243	387271
29683	48993	12	applied	\N	\N	\N	\N	220244	220244	387272
29683	48994	13	applied	\N	\N	\N	\N	220245	220245	387273
29683	48995	14	applied	\N	\N	\N	\N	220246	220246	387274
29683	48996	15	applied	\N	\N	\N	\N	220247	220247	387275
29683	48997	16	applied	\N	\N	\N	\N	220248	220248	387276
29683	48998	17	applied	\N	\N	\N	\N	220249	220249	387277
29690	49023	0	applied	\N	\N	\N	\N	220310	220310	387338
29690	49024	1	applied	\N	\N	\N	\N	220311	220311	387339
29690	49025	2	applied	\N	\N	\N	\N	220312	220312	387340
29690	49026	3	applied	\N	\N	\N	\N	220313	220313	387341
29690	49027	4	applied	\N	\N	\N	\N	220314	220314	387342
29690	49028	5	applied	\N	\N	\N	\N	220315	220315	387343
29690	49029	6	applied	\N	\N	\N	\N	220316	220316	387344
29692	49035	0	applied	\N	\N	\N	\N	220327	220327	387355
29692	49037	2	applied	\N	\N	\N	\N	220329	220329	387357
29698	49040	0	applied	\N	\N	\N	\N	220348	220348	387376
29698	49041	1	applied	\N	\N	\N	\N	220349	220349	387377
29698	49042	2	applied	\N	\N	\N	\N	220350	220350	387378
29698	49043	3	applied	\N	\N	\N	\N	220351	220351	387379
29698	49044	4	applied	\N	\N	\N	\N	220352	220352	387380
29698	49045	5	applied	\N	\N	\N	\N	220353	220353	387381
29703	49046	0	applied	\N	\N	\N	\N	220369	220369	387397
29703	49047	1	applied	\N	\N	\N	\N	220370	220370	387398
29703	49048	2	applied	\N	\N	\N	\N	220371	220371	387399
29703	49049	3	applied	\N	\N	\N	\N	220372	220372	387400
29703	49050	4	applied	\N	\N	\N	\N	220373	220373	387401
29703	49051	5	applied	\N	\N	\N	\N	220374	220374	387402
29703	49052	6	applied	\N	\N	\N	\N	220375	220375	387403
29703	49053	7	applied	\N	\N	\N	\N	220376	220376	387404
29703	49054	8	applied	\N	\N	\N	\N	220377	220377	387405
29707	49055	0	applied	\N	\N	\N	\N	220400	220400	387428
29707	49056	1	applied	\N	\N	\N	\N	220401	220401	387429
29707	49057	2	applied	\N	\N	\N	\N	220402	220402	387430
29707	49059	4	applied	\N	\N	\N	\N	220404	220404	387432
29707	49060	5	applied	\N	\N	\N	\N	220405	220405	387433
29707	49061	6	applied	\N	\N	\N	\N	220406	220406	387434
29715	49092	0	applied	\N	\N	\N	\N	220680	220680	387697
29715	49093	1	applied	\N	\N	\N	\N	220681	220681	387698
29715	49094	3	applied	\N	\N	\N	\N	220682	220682	387699
29715	49095	4	applied	\N	\N	\N	\N	220683	220683	387700
29715	49096	5	applied	\N	\N	\N	\N	220684	220684	387701
29715	49097	6	applied	\N	\N	\N	\N	220685	220685	387702
29715	49098	7	applied	\N	\N	\N	\N	220686	220686	387703
29715	49099	8	applied	\N	\N	\N	\N	220687	220687	387704
29715	49100	9	applied	\N	\N	\N	\N	220688	220688	387705
29715	49101	10	applied	\N	\N	\N	\N	220689	220689	387706
29715	49102	11	applied	\N	\N	\N	\N	220690	220690	387707
29651	48727	1	applied	\N	\N	\N	\N	219797	219797	386829
29651	48728	2	applied	\N	\N	\N	\N	219798	219798	386830
29661	48834	5	applied	\N	\N	\N	\N	219940	219940	386969
29663	48829	0	applied	\N	\N	\N	\N	219950	219950	386979
29663	48830	1	applied	\N	\N	\N	\N	219951	219951	386980
29663	48831	2	applied	\N	\N	\N	\N	219952	219952	386981
29663	48832	3	applied	\N	\N	\N	\N	219953	219953	386982
29663	48833	4	applied	\N	\N	\N	\N	219954	219954	386983
29663	48834	5	applied	\N	\N	\N	\N	219955	219955	386984
29663	48835	6	applied	\N	\N	\N	\N	219956	219956	386985
29663	48836	7	applied	\N	\N	\N	\N	219957	219957	386986
29663	48837	8	applied	\N	\N	\N	\N	219958	219958	386987
29665	48845	0	applied	\N	\N	\N	\N	219966	219966	386995
29665	48846	1	applied	\N	\N	1000000000	\N	219967	219967	386996
29665	48847	2	applied	\N	\N	\N	\N	219968	219968	386997
29665	48848	3	applied	\N	\N	\N	\N	219969	219969	386998
29665	48850	5	applied	\N	\N	\N	\N	219971	219971	387000
29665	48851	6	applied	\N	\N	\N	\N	219972	219972	387001
29665	48852	7	applied	\N	\N	\N	\N	219973	219973	387002
29665	48853	8	applied	\N	\N	\N	\N	219974	219974	387003
29665	48854	9	applied	\N	\N	\N	\N	219975	219975	387004
29665	48855	10	applied	\N	\N	\N	\N	219976	219976	387005
29665	48856	11	applied	\N	\N	\N	\N	219977	219977	387006
29665	48857	12	applied	\N	\N	\N	\N	219978	219978	387007
29665	48858	13	applied	\N	\N	\N	\N	219979	219979	387008
29665	48859	14	applied	\N	\N	\N	\N	219980	219980	387009
29665	48860	15	applied	\N	\N	\N	\N	219981	219981	387010
29665	48861	16	applied	\N	\N	\N	\N	219982	219982	387011
29665	48862	17	applied	\N	\N	\N	\N	219983	219983	387012
29665	48863	18	applied	\N	\N	\N	\N	219984	219984	387013
29665	48864	19	applied	\N	\N	\N	\N	219985	219985	387014
29665	48865	20	applied	\N	\N	\N	\N	219986	219986	387015
29665	48867	22	applied	\N	\N	\N	\N	219988	219988	387017
29665	48868	23	applied	\N	\N	\N	\N	219989	219989	387018
29665	48869	24	applied	\N	\N	\N	\N	219990	219990	387019
29665	48870	25	applied	\N	\N	\N	\N	219991	219991	387020
29665	48871	26	applied	\N	\N	\N	\N	219992	219992	387021
29665	48872	27	applied	\N	\N	\N	\N	219993	219993	387022
29665	48873	28	applied	\N	\N	\N	\N	219994	219994	387023
29666	48874	0	applied	\N	\N	\N	\N	219995	219995	387024
29666	48875	1	applied	\N	\N	\N	\N	219996	219996	387025
29666	48876	3	applied	\N	\N	\N	\N	219997	219997	387026
29666	48877	4	applied	\N	\N	\N	\N	219998	219998	387027
29666	48878	5	applied	\N	\N	\N	\N	219999	219999	387028
29666	48879	6	applied	\N	\N	\N	\N	220000	220000	387029
29666	48880	7	applied	\N	\N	\N	\N	220001	220001	387030
29666	48881	8	applied	\N	\N	\N	\N	220002	220002	387031
29668	48892	0	applied	\N	\N	\N	\N	220031	220031	387060
29668	48894	2	applied	\N	\N	\N	\N	220033	220033	387062
29668	48895	3	applied	\N	\N	\N	\N	220034	220034	387063
29668	48896	4	applied	\N	\N	\N	\N	220035	220035	387064
29668	48897	5	applied	\N	\N	\N	\N	220036	220036	387065
29668	48898	6	applied	\N	\N	\N	\N	220037	220037	387066
29668	48899	7	applied	\N	\N	\N	\N	220038	220038	387067
29668	48900	8	applied	\N	\N	\N	\N	220039	220039	387068
29670	48892	0	applied	\N	\N	\N	\N	220049	220049	387078
29670	48893	1	applied	\N	\N	\N	\N	220050	220050	387079
29670	48894	2	applied	\N	\N	\N	\N	220051	220051	387080
29670	48895	3	applied	\N	\N	\N	\N	220052	220052	387081
29670	48896	4	applied	\N	\N	\N	\N	220053	220053	387082
29670	48897	5	applied	\N	\N	\N	\N	220054	220054	387083
29670	48898	6	applied	\N	\N	\N	\N	220055	220055	387084
29670	48899	7	applied	\N	\N	\N	\N	220056	220056	387085
29670	48900	8	applied	\N	\N	\N	\N	220057	220057	387086
29672	48902	1	applied	\N	\N	\N	\N	220077	220077	387106
29672	48903	2	applied	\N	\N	\N	\N	220078	220078	387107
29672	48904	3	applied	\N	\N	\N	\N	220079	220079	387108
29672	48905	4	applied	\N	\N	\N	\N	220080	220080	387109
29672	48906	5	applied	\N	\N	\N	\N	220081	220081	387110
29672	48907	6	applied	\N	\N	\N	\N	220082	220082	387111
29672	48908	7	applied	\N	\N	\N	\N	220083	220083	387112
29672	48909	8	applied	\N	\N	\N	\N	220084	220084	387113
29672	48910	9	applied	\N	\N	\N	\N	220085	220085	387114
29672	48911	10	applied	\N	\N	\N	\N	220086	220086	387115
29672	48912	11	applied	\N	\N	\N	\N	220087	220087	387116
29672	48913	12	applied	\N	\N	\N	\N	220088	220088	387117
29672	48914	13	applied	\N	\N	\N	\N	220089	220089	387118
29672	48915	14	applied	\N	\N	\N	\N	220090	220090	387119
29672	48916	15	applied	\N	\N	\N	\N	220091	220091	387120
29672	48917	16	applied	\N	\N	\N	\N	220092	220092	387121
29675	48934	0	applied	\N	\N	\N	\N	220127	220127	387156
29675	48935	1	applied	\N	\N	\N	\N	220128	220128	220128
29675	48936	2	applied	\N	\N	\N	\N	220129	220129	387157
29675	48937	3	applied	\N	\N	\N	\N	220130	220130	387158
29675	48938	4	applied	\N	\N	\N	\N	220131	220131	387159
29675	48939	5	applied	\N	\N	\N	\N	220132	220132	387160
29675	48940	6	applied	\N	\N	\N	\N	220133	220133	387161
29675	48941	7	applied	\N	\N	\N	\N	220134	220134	387162
29675	48942	8	applied	\N	\N	\N	\N	220135	220135	387163
29675	48943	9	applied	\N	\N	\N	\N	220136	220136	387164
29675	48944	10	applied	\N	\N	\N	\N	220137	220137	387165
29675	48945	11	applied	\N	\N	\N	\N	220138	220138	387166
29675	48946	12	applied	\N	\N	\N	\N	220139	220139	387167
29675	48947	13	applied	\N	\N	\N	\N	220140	220140	387168
29675	48948	14	applied	\N	\N	\N	\N	220141	220141	387169
29675	48949	15	applied	\N	\N	\N	\N	220142	220142	387170
29675	48951	17	applied	\N	\N	\N	\N	220144	220144	387172
29681	48982	0	applied	\N	\N	\N	\N	220199	220199	387227
29681	48983	1	applied	\N	\N	\N	\N	220200	220200	387228
29681	48984	2	applied	\N	\N	\N	\N	220201	220201	387229
29681	48985	3	applied	\N	\N	\N	\N	220202	220202	387230
29681	48986	4	applied	\N	\N	\N	\N	220203	220203	387231
29681	48987	6	applied	\N	\N	\N	\N	220204	220204	387232
29681	48988	7	applied	\N	\N	\N	\N	220205	220205	387233
29681	48989	8	applied	\N	\N	\N	\N	220206	220206	387234
29681	48990	9	applied	\N	\N	\N	\N	220207	220207	387235
29681	48991	10	applied	\N	\N	\N	\N	220208	220208	387236
29681	48992	11	applied	\N	\N	\N	\N	220209	220209	387237
29681	48993	12	applied	\N	\N	\N	\N	220210	220210	387238
29681	48994	13	applied	\N	\N	\N	\N	220211	220211	387239
29681	48995	14	applied	\N	\N	\N	\N	220212	220212	387240
29681	48996	15	applied	\N	\N	\N	\N	220213	220213	387241
29661	48833	4	applied	\N	\N	\N	\N	219939	219939	386968
29666	48886	13	applied	\N	\N	\N	\N	220007	220007	387036
29666	48887	14	applied	\N	\N	\N	\N	220008	220008	387037
29666	48888	15	applied	\N	\N	\N	\N	220009	220009	387038
29666	48889	16	applied	\N	\N	\N	\N	220010	220010	387039
29666	48890	17	applied	\N	\N	\N	\N	220011	220011	387040
29666	48891	18	applied	\N	\N	\N	\N	220012	220012	387041
29667	48874	0	applied	\N	\N	\N	\N	220013	220013	387042
29667	48875	1	applied	\N	\N	\N	\N	220014	220014	387043
29667	48876	3	applied	\N	\N	\N	\N	220015	220015	387044
29667	48877	4	applied	\N	\N	\N	\N	220016	220016	387045
29667	48878	5	applied	\N	\N	\N	\N	220017	220017	387046
29667	48879	6	applied	\N	\N	\N	\N	220018	220018	387047
29667	48880	7	applied	\N	\N	\N	\N	220019	220019	387048
29667	48881	8	applied	\N	\N	\N	\N	220020	220020	387049
29667	48882	9	applied	\N	\N	\N	\N	220021	220021	387050
29667	48883	10	applied	\N	\N	\N	\N	220022	220022	387051
29667	48885	12	applied	\N	\N	\N	\N	220024	220024	387053
29667	48886	13	applied	\N	\N	\N	\N	220025	220025	387054
29667	48887	14	applied	\N	\N	\N	\N	220026	220026	387055
29667	48888	15	applied	\N	\N	\N	\N	220027	220027	387056
29667	48889	16	applied	\N	\N	\N	\N	220028	220028	387057
29667	48890	17	applied	\N	\N	\N	\N	220029	220029	387058
29667	48891	18	applied	\N	\N	\N	\N	220030	220030	387059
29671	48901	0	applied	\N	\N	\N	\N	220058	220058	387087
29671	48902	1	applied	\N	\N	\N	\N	220059	220059	387088
29671	48903	2	applied	\N	\N	\N	\N	220060	220060	387089
29671	48904	3	applied	\N	\N	\N	\N	220061	220061	387090
29671	48905	4	applied	\N	\N	\N	\N	220062	220062	387091
29671	48906	5	applied	\N	\N	\N	\N	220063	220063	387092
29671	48907	6	applied	\N	\N	\N	\N	220064	220064	387093
29671	48908	7	applied	\N	\N	\N	\N	220065	220065	387094
29671	48909	8	applied	\N	\N	\N	\N	220066	220066	387095
29671	48911	10	applied	\N	\N	\N	\N	220068	220068	387097
29671	48912	11	applied	\N	\N	\N	\N	220069	220069	387098
29671	48913	12	applied	\N	\N	\N	\N	220070	220070	387099
29671	48914	13	applied	\N	\N	\N	\N	220071	220071	387100
29671	48915	14	applied	\N	\N	\N	\N	220072	220072	387101
29671	48916	15	applied	\N	\N	\N	\N	220073	220073	387102
29671	48917	16	applied	\N	\N	\N	\N	220074	220074	387103
29671	48918	17	applied	\N	\N	\N	\N	220075	220075	387104
29673	48901	0	applied	\N	\N	\N	\N	220094	220094	387123
29673	48902	1	applied	\N	\N	\N	\N	220095	220095	387124
29673	48903	2	applied	\N	\N	\N	\N	220096	220096	387125
29673	48904	3	applied	\N	\N	\N	\N	220097	220097	387126
29673	48905	4	applied	\N	\N	\N	\N	220098	220098	387127
29673	48906	5	applied	\N	\N	\N	\N	220099	220099	387128
29673	48907	6	applied	\N	\N	\N	\N	220100	220100	387129
29673	48908	7	applied	\N	\N	\N	\N	220101	220101	387130
29673	48910	9	applied	\N	\N	\N	\N	220103	220103	387132
29673	48911	10	applied	\N	\N	\N	\N	220104	220104	387133
29673	48912	11	applied	\N	\N	\N	\N	220105	220105	387134
29673	48913	12	applied	\N	\N	\N	\N	220106	220106	387135
29673	48914	13	applied	\N	\N	\N	\N	220107	220107	387136
29673	48915	14	applied	\N	\N	\N	\N	220108	220108	387137
29673	48916	15	applied	\N	\N	\N	\N	220109	220109	387138
29673	48917	16	applied	\N	\N	\N	\N	220110	220110	387139
29673	48918	17	applied	\N	\N	\N	\N	220111	220111	387140
29674	48923	4	applied	\N	\N	\N	\N	220116	220116	387145
29674	48924	5	applied	\N	\N	\N	\N	220117	220117	387146
29674	48925	6	applied	\N	\N	\N	\N	220118	220118	387147
29674	48926	7	applied	\N	\N	\N	\N	220119	220119	387148
29674	48927	8	applied	\N	\N	\N	\N	220120	220120	387149
29674	48928	9	applied	\N	\N	\N	\N	220121	220121	387150
29674	48929	10	applied	\N	\N	\N	\N	220122	220122	387151
29674	48931	12	applied	\N	\N	\N	\N	220124	220124	387153
29674	48932	13	applied	\N	\N	\N	\N	220125	220125	387154
29674	48933	14	applied	\N	\N	\N	\N	220126	220126	387155
29676	48952	0	applied	\N	\N	\N	\N	220145	220145	387173
29676	48953	1	applied	\N	\N	\N	\N	220146	220146	387174
29676	48954	2	applied	\N	\N	\N	\N	220147	220147	387175
29676	48955	3	applied	\N	\N	\N	\N	220148	220148	387176
29676	48956	4	applied	\N	\N	\N	\N	220149	220149	387177
29676	48957	5	applied	\N	\N	\N	\N	220150	220150	387178
29676	48958	6	applied	\N	\N	\N	\N	220151	220151	387179
29676	48959	7	applied	\N	\N	\N	\N	220152	220152	387180
29676	48960	8	applied	\N	\N	\N	\N	220153	220153	387181
29678	48961	0	applied	\N	\N	\N	\N	220166	220166	387194
29682	48982	0	applied	\N	\N	\N	\N	220216	220216	387244
29682	48983	1	applied	\N	\N	\N	\N	220217	220217	387245
29682	48984	2	applied	\N	\N	\N	\N	220218	220218	387246
29682	48986	4	applied	\N	\N	\N	\N	220220	220220	387248
29682	48987	6	applied	\N	\N	\N	\N	220221	220221	387249
29682	48988	7	applied	\N	\N	\N	\N	220222	220222	387250
29682	48989	8	applied	\N	\N	\N	\N	220223	220223	387251
29682	48990	9	applied	\N	\N	\N	\N	220224	220224	387252
29682	48991	10	applied	\N	\N	\N	\N	220225	220225	387253
29682	48992	11	applied	\N	\N	\N	\N	220226	220226	387254
29682	48993	12	applied	\N	\N	\N	\N	220227	220227	387255
29682	48994	13	applied	\N	\N	\N	\N	220228	220228	387256
29682	48995	14	applied	\N	\N	\N	\N	220229	220229	387257
29682	48996	15	applied	\N	\N	\N	\N	220230	220230	387258
29682	48997	16	applied	\N	\N	\N	\N	220231	220231	387259
29682	48998	17	applied	\N	\N	\N	\N	220232	220232	387260
29688	49009	0	applied	\N	\N	\N	\N	220296	220296	387324
29688	49010	1	applied	\N	\N	\N	\N	220297	220297	387325
29688	49011	2	applied	\N	\N	\N	\N	220298	220298	387326
29688	49013	4	applied	\N	\N	\N	\N	220300	220300	387328
29688	49014	5	applied	\N	\N	\N	\N	220301	220301	387329
29699	49040	0	applied	\N	\N	\N	\N	220354	220354	387382
29699	49041	1	applied	\N	\N	\N	\N	220355	220355	387383
29699	49042	2	applied	\N	\N	\N	\N	220356	220356	387384
29699	49043	3	applied	\N	\N	\N	\N	220357	220357	387385
29699	49044	4	applied	\N	\N	\N	\N	220358	220358	387386
29699	49045	5	applied	\N	\N	\N	\N	220359	220359	387387
29702	49046	0	applied	\N	\N	\N	\N	220360	220360	387388
29702	49047	1	applied	\N	\N	\N	\N	220361	220361	387389
29702	49048	2	applied	\N	\N	\N	\N	220362	220362	387390
29702	49049	3	applied	\N	\N	\N	\N	220363	220363	387391
29702	49050	4	applied	\N	\N	\N	\N	220364	220364	387392
29702	49051	5	applied	\N	\N	\N	\N	220365	220365	387393
29666	48883	10	applied	\N	\N	\N	\N	220004	220004	387033
29666	48884	11	applied	\N	\N	\N	\N	220005	220005	387034
29678	48969	5	applied	\N	\N	\N	\N	220171	220171	387199
29678	48970	6	applied	\N	\N	\N	\N	220172	220172	387200
29678	48971	7	applied	\N	\N	\N	\N	220173	220173	387201
29678	48972	8	applied	\N	\N	\N	\N	220174	220174	387202
29680	48973	0	applied	\N	\N	\N	\N	220187	220187	387215
29680	48974	1	applied	\N	\N	\N	\N	220188	220188	387216
29680	48975	2	applied	\N	\N	\N	\N	220189	220189	387217
29680	48965	3	applied	\N	\N	\N	\N	220190	220190	387218
29680	48966	4	applied	\N	\N	\N	\N	220191	220191	387219
29680	48968	5	applied	\N	\N	\N	\N	220192	220192	387220
29680	48976	6	applied	\N	\N	\N	\N	220193	220193	387221
29680	48977	7	applied	\N	\N	\N	\N	220194	220194	387222
29680	48978	8	applied	\N	\N	\N	\N	220195	220195	387223
29680	48979	9	applied	\N	\N	\N	\N	220196	220196	387224
29680	48980	10	applied	\N	\N	\N	\N	220197	220197	387225
29680	48981	11	applied	\N	\N	\N	\N	220198	220198	387226
29681	48998	17	applied	\N	\N	\N	\N	220215	220215	387243
29684	48982	0	applied	\N	\N	\N	\N	220250	220250	387278
29684	48983	1	applied	\N	\N	\N	\N	220251	220251	387279
29684	48984	2	applied	\N	\N	\N	\N	220252	220252	387280
29684	48985	3	applied	\N	\N	\N	\N	220253	220253	387281
29684	48986	4	applied	\N	\N	\N	\N	220254	220254	387282
29684	48987	6	applied	\N	\N	\N	\N	220255	220255	387283
29684	48988	7	applied	\N	\N	\N	\N	220256	220256	387284
29684	48989	8	applied	\N	\N	\N	\N	220257	220257	387285
29684	48990	9	applied	\N	\N	\N	\N	220258	220258	387286
29684	48991	10	applied	\N	\N	\N	\N	220259	220259	387287
29684	48992	11	applied	\N	\N	\N	\N	220260	220260	387288
29684	48993	12	applied	\N	\N	\N	\N	220261	220261	387289
29684	48994	13	applied	\N	\N	\N	\N	220262	220262	387290
29684	48995	14	applied	\N	\N	\N	\N	220263	220263	387291
29684	48996	15	applied	\N	\N	\N	\N	220264	220264	387292
29684	48998	17	applied	\N	\N	\N	\N	220266	220266	387294
29685	48999	0	applied	\N	\N	\N	\N	220267	220267	387295
29685	49000	1	applied	\N	\N	\N	\N	220268	220268	387296
29685	49001	2	applied	\N	\N	\N	\N	220269	220269	387297
29685	49002	3	applied	\N	\N	\N	\N	220270	220270	387298
29685	49003	4	applied	\N	\N	\N	\N	220271	220271	387299
29685	49004	5	applied	\N	\N	\N	\N	220272	220272	387300
29685	49005	6	applied	\N	\N	\N	\N	220273	220273	387301
29685	49006	7	applied	\N	\N	\N	\N	220274	220274	387302
29685	49007	8	applied	\N	\N	\N	\N	220275	220275	387303
29685	49008	9	applied	\N	\N	\N	\N	220276	220276	387304
29686	48999	0	applied	\N	\N	\N	\N	220277	220277	387305
29686	49000	1	applied	\N	\N	\N	\N	220278	220278	387306
29686	49001	2	applied	\N	\N	\N	\N	220279	220279	387307
29686	49002	3	applied	\N	\N	\N	\N	220280	220280	387308
29686	49003	4	applied	\N	\N	\N	\N	220281	220281	387309
29686	49005	6	applied	\N	\N	\N	\N	220283	220283	387311
29686	49006	7	applied	\N	\N	\N	\N	220284	220284	387312
29686	49007	8	applied	\N	\N	\N	\N	220285	220285	387313
29686	49008	9	applied	\N	\N	\N	\N	220286	220286	387314
29687	48999	0	applied	\N	\N	\N	\N	220287	220287	387315
29687	49000	1	applied	\N	\N	\N	\N	220288	220288	387316
29687	49001	2	applied	\N	\N	\N	\N	220289	220289	387317
29687	49002	3	applied	\N	\N	\N	\N	220290	220290	387318
29687	49003	4	applied	\N	\N	\N	\N	220291	220291	387319
29687	49004	5	applied	\N	\N	\N	\N	220292	220292	387320
29687	49005	6	applied	\N	\N	\N	\N	220293	220293	387321
29687	49006	7	applied	\N	\N	\N	\N	220294	220294	387322
29687	49007	8	applied	\N	\N	\N	\N	220295	220295	387323
29694	49040	0	applied	\N	\N	\N	\N	220330	220330	387358
29694	49041	1	applied	\N	\N	\N	\N	220331	220331	387359
29694	49042	2	applied	\N	\N	\N	\N	220332	220332	387360
29694	49044	4	applied	\N	\N	\N	\N	220334	220334	387362
29694	49045	5	applied	\N	\N	\N	\N	220335	220335	387363
29697	49040	0	applied	\N	\N	\N	\N	220342	220342	387370
29697	49041	1	applied	\N	\N	\N	\N	220343	220343	387371
29697	49042	2	applied	\N	\N	\N	\N	220344	220344	387372
29697	49043	3	applied	\N	\N	\N	\N	220345	220345	387373
29697	49044	4	applied	\N	\N	\N	\N	220346	220346	387374
29697	49045	5	applied	\N	\N	\N	\N	220347	220347	387375
29705	49046	0	applied	\N	\N	\N	\N	220384	220384	387412
29705	49047	1	applied	\N	\N	\N	\N	220385	220385	387413
29705	49048	2	applied	\N	\N	\N	\N	220386	220386	387414
29705	49049	3	applied	\N	\N	\N	\N	220387	220387	387415
29705	49050	4	applied	\N	\N	\N	\N	220388	220388	387416
29705	49051	5	applied	\N	\N	\N	\N	220389	220389	387417
29705	49052	6	applied	\N	\N	\N	\N	220390	220390	387418
29705	49053	7	applied	\N	\N	\N	\N	220391	220391	387419
29710	49062	0	applied	\N	\N	\N	\N	220443	220443	387469
29710	49063	1	applied	\N	\N	\N	\N	220444	220444	387470
29710	49064	2	applied	\N	\N	\N	\N	220445	220445	387471
29710	49065	3	applied	\N	\N	\N	\N	220446	220446	387472
29710	49066	4	applied	\N	\N	\N	\N	220447	220447	220447
29710	49067	5	applied	\N	\N	\N	\N	220448	220448	387473
29710	49068	6	applied	\N	\N	\N	\N	220449	220449	387474
29710	49069	7	applied	\N	\N	\N	\N	220450	220450	387475
29710	49070	8	applied	\N	\N	\N	\N	220451	220451	387476
29710	49071	9	applied	\N	\N	\N	\N	220452	220452	387477
29710	49080	10	applied	\N	\N	\N	\N	220453	220453	220453
29710	49081	11	applied	\N	\N	\N	\N	220454	220454	387478
29710	49082	12	applied	\N	\N	\N	\N	220455	220455	387479
29710	49083	13	applied	\N	\N	\N	\N	220456	220456	387480
29710	49084	14	applied	\N	\N	\N	\N	220457	220457	387481
29710	49085	15	applied	\N	\N	\N	\N	220458	220458	387482
29710	49087	17	applied	\N	\N	\N	\N	220460	220460	387484
29710	49088	18	applied	\N	\N	\N	\N	220461	220461	387485
29710	49089	19	applied	\N	\N	\N	\N	220462	220462	387486
29710	49090	20	applied	\N	\N	\N	\N	220463	220463	387487
29710	49091	21	applied	\N	\N	\N	\N	220464	220464	387488
29713	49062	0	applied	\N	\N	\N	\N	220525	220525	387545
29713	49063	1	applied	\N	\N	\N	\N	220526	220526	387546
29713	49064	2	applied	\N	\N	\N	\N	220527	220527	387547
29713	49065	3	applied	\N	\N	\N	\N	220528	220528	387548
29713	49066	4	applied	\N	\N	\N	\N	220529	220529	220529
29713	49067	5	applied	\N	\N	\N	\N	220530	220530	387549
29713	49068	6	applied	\N	\N	\N	\N	220531	220531	387550
29713	49069	7	applied	\N	\N	\N	\N	220532	220532	387551
29713	49070	8	applied	\N	\N	\N	\N	220533	220533	387552
29678	48963	2	applied	\N	\N	\N	\N	220168	220168	387196
29678	48964	3	applied	\N	\N	\N	\N	220169	220169	387197
29689	49019	4	applied	\N	\N	\N	\N	220306	220306	387334
29689	49020	5	applied	\N	\N	\N	\N	220307	220307	387335
29689	49021	6	applied	\N	\N	\N	\N	220308	220308	387336
29689	49022	7	applied	\N	\N	\N	\N	220309	220309	387337
29691	49030	0	applied	\N	\N	\N	\N	220317	220317	387345
29691	49031	1	applied	\N	\N	\N	\N	220318	220318	387346
29691	49032	2	applied	\N	\N	\N	\N	220319	220319	387347
29691	49033	3	applied	\N	\N	\N	\N	220320	220320	387348
29691	49034	4	applied	\N	\N	\N	\N	220321	220321	387349
29691	49035	5	applied	\N	\N	\N	\N	220322	220322	387350
29691	49037	7	applied	\N	\N	\N	\N	220324	220324	387352
29691	49038	8	applied	\N	\N	\N	\N	220325	220325	387353
29691	49039	9	applied	\N	\N	\N	\N	220326	220326	387354
29696	49040	0	applied	\N	\N	\N	\N	220336	220336	387364
29696	49041	1	applied	\N	\N	\N	\N	220337	220337	387365
29696	49042	2	applied	\N	\N	\N	\N	220338	220338	387366
29696	49043	3	applied	\N	\N	\N	\N	220339	220339	387367
29696	49044	4	applied	\N	\N	\N	\N	220340	220340	387368
29696	49045	5	applied	\N	\N	\N	\N	220341	220341	387369
29702	49052	6	applied	\N	\N	\N	\N	220366	220366	387394
29702	49053	7	applied	\N	\N	\N	\N	220367	220367	387395
29702	49054	8	applied	\N	\N	\N	\N	220368	220368	387396
29704	49046	0	applied	\N	\N	\N	\N	220378	220378	387406
29704	49047	1	applied	\N	\N	\N	\N	220379	220379	387407
29704	49048	2	applied	\N	\N	\N	\N	220380	220380	387408
29704	49049	3	applied	\N	\N	\N	\N	220381	220381	387409
29704	49052	4	applied	\N	\N	\N	\N	220382	220382	387410
29704	49053	5	applied	\N	\N	\N	\N	220383	220383	387411
29706	49055	0	applied	\N	\N	\N	\N	220393	220393	387421
29706	49056	1	applied	\N	\N	\N	\N	220394	220394	387422
29706	49058	3	applied	\N	\N	\N	\N	220396	220396	387424
29706	49059	4	applied	\N	\N	\N	\N	220397	220397	387425
29706	49060	5	applied	\N	\N	\N	\N	220398	220398	387426
29706	49061	6	applied	\N	\N	\N	\N	220399	220399	387427
29708	49056	0	applied	\N	\N	\N	\N	220407	220407	387435
29708	49057	1	applied	\N	\N	\N	\N	220408	220408	387436
29708	49058	2	applied	\N	\N	\N	\N	220409	220409	387437
29708	49059	3	applied	\N	\N	\N	\N	220410	220410	387438
29708	49060	4	applied	\N	\N	\N	\N	220411	220411	387439
29708	49061	5	applied	\N	\N	\N	\N	220412	220412	387440
29709	49062	0	applied	\N	\N	\N	\N	220413	220413	387441
29709	49063	1	applied	\N	\N	\N	\N	220414	220414	387442
29709	49064	2	applied	\N	\N	\N	\N	220415	220415	387443
29709	49065	3	applied	\N	\N	\N	\N	220416	220416	387444
29709	49066	4	applied	\N	\N	\N	\N	220417	220417	220417
29709	49067	5	applied	\N	\N	\N	\N	220418	220418	387445
29709	49069	7	applied	\N	\N	\N	\N	220420	220420	387447
29709	49070	8	applied	\N	\N	\N	\N	220421	220421	387448
29709	49071	9	applied	\N	\N	\N	\N	220422	220422	387449
29709	49072	10	applied	\N	\N	\N	\N	220423	220423	387450
29709	49073	11	applied	\N	\N	\N	\N	220424	220424	387451
29709	49074	12	applied	\N	\N	\N	\N	220425	220425	387452
29709	49075	13	applied	\N	\N	\N	\N	220426	220426	387453
29709	49076	14	applied	\N	\N	\N	\N	220427	220427	387454
29709	49077	15	applied	\N	\N	\N	\N	220428	220428	387455
29709	49078	16	applied	\N	\N	\N	\N	220429	220429	387456
29709	49079	17	applied	\N	\N	\N	\N	220430	220430	387457
29709	49080	18	applied	\N	\N	\N	\N	220431	220431	220431
29709	49081	19	applied	\N	\N	\N	\N	220432	220432	387458
29709	49082	20	applied	\N	\N	\N	\N	220433	220433	387459
29709	49083	21	applied	\N	\N	\N	\N	220434	220434	387460
29709	49084	22	applied	\N	\N	\N	\N	220435	220435	387461
29709	49086	24	applied	\N	\N	\N	\N	220437	220437	387463
29709	49087	25	applied	\N	\N	\N	\N	220438	220438	387464
29709	49088	26	applied	\N	\N	\N	\N	220439	220439	387465
29709	49089	27	applied	\N	\N	\N	\N	220440	220440	387466
29709	49090	28	applied	\N	\N	\N	\N	220441	220441	387467
29709	49091	29	applied	\N	\N	\N	\N	220442	220442	387468
29711	49062	0	applied	\N	\N	\N	\N	220465	220465	387489
29711	49063	1	applied	\N	\N	\N	\N	220466	220466	387490
29711	49064	2	applied	\N	\N	\N	\N	220467	220467	387491
29711	49065	3	applied	\N	\N	\N	\N	220468	220468	387492
29711	49066	4	applied	\N	\N	\N	\N	220469	220469	220469
29712	49062	0	applied	\N	\N	\N	\N	220495	220495	387517
29712	49063	1	applied	\N	\N	\N	\N	220496	220496	387518
29712	49064	2	applied	\N	\N	\N	\N	220497	220497	387519
29712	49065	3	applied	\N	\N	\N	\N	220498	220498	387520
29712	49066	4	applied	\N	\N	\N	\N	220499	220499	220499
29712	49068	6	applied	\N	\N	\N	\N	220501	220501	387522
29712	49069	7	applied	\N	\N	\N	\N	220502	220502	387523
29712	49070	8	applied	\N	\N	\N	\N	220503	220503	387524
29712	49071	9	applied	\N	\N	\N	\N	220504	220504	387525
29712	49072	10	applied	\N	\N	\N	\N	220505	220505	387526
29712	49073	11	applied	\N	\N	\N	\N	220506	220506	387527
29712	49074	12	applied	\N	\N	\N	\N	220507	220507	387528
29712	49075	13	applied	\N	\N	\N	\N	220508	220508	387529
29712	49076	14	applied	\N	\N	\N	\N	220509	220509	387530
29712	49077	15	applied	\N	\N	\N	\N	220510	220510	387531
29712	49078	16	applied	\N	\N	\N	\N	220511	220511	387532
29712	49079	17	applied	\N	\N	\N	\N	220512	220512	387533
29712	49080	18	applied	\N	\N	\N	\N	220513	220513	220513
29712	49081	19	applied	\N	\N	\N	\N	220514	220514	387534
29712	49082	20	applied	\N	\N	\N	\N	220515	220515	387535
29712	49083	21	applied	\N	\N	\N	\N	220516	220516	387536
29712	49085	23	applied	\N	\N	\N	\N	220518	220518	387538
29712	49086	24	applied	\N	\N	\N	\N	220519	220519	387539
29712	49087	25	applied	\N	\N	\N	\N	220520	220520	387540
29712	49088	26	applied	\N	\N	\N	\N	220521	220521	387541
29712	49089	27	applied	\N	\N	\N	\N	220522	220522	387542
29712	49090	28	applied	\N	\N	\N	\N	220523	220523	387543
29712	49091	29	applied	\N	\N	\N	\N	220524	220524	387544
29714	48846	0	applied	\N	\N	1000000000	\N	220555	220555	387573
29714	48733	1	applied	\N	\N	\N	\N	220556	220556	220556
29714	48707	2	applied	\N	\N	\N	\N	220557	220557	387574
29714	48961	3	applied	\N	\N	\N	\N	220558	220558	387575
29714	48734	4	applied	\N	\N	\N	\N	220559	220559	387576
29714	48508	5	applied	\N	\N	\N	\N	220560	220560	387577
29714	48753	6	applied	\N	\N	\N	\N	220561	220561	387578
29714	48598	7	applied	\N	\N	\N	\N	220562	220562	387579
29689	49016	1	applied	\N	\N	\N	\N	220303	220303	387331
29689	49018	3	applied	\N	\N	\N	\N	220305	220305	387333
29711	49071	9	applied	\N	\N	\N	\N	220474	220474	387497
29711	49072	10	applied	\N	\N	\N	\N	220475	220475	387498
29711	49073	11	applied	\N	\N	\N	\N	220476	220476	387499
29711	49074	12	applied	\N	\N	\N	\N	220477	220477	387500
29711	49075	13	applied	\N	\N	\N	\N	220478	220478	387501
29711	49076	14	applied	\N	\N	\N	\N	220479	220479	387502
29711	49077	15	applied	\N	\N	\N	\N	220480	220480	387503
29711	49078	16	applied	\N	\N	\N	\N	220481	220481	387504
29711	49079	17	applied	\N	\N	\N	\N	220482	220482	387505
29711	49080	18	applied	\N	\N	\N	\N	220483	220483	220483
29711	49081	19	applied	\N	\N	\N	\N	220484	220484	387506
29711	49082	20	applied	\N	\N	\N	\N	220485	220485	387507
29711	49083	21	applied	\N	\N	\N	\N	220486	220486	387508
29711	49084	22	applied	\N	\N	\N	\N	220487	220487	387509
29711	49085	23	applied	\N	\N	\N	\N	220488	220488	387510
29711	49086	24	applied	\N	\N	\N	\N	220489	220489	387511
29711	49088	26	applied	\N	\N	\N	\N	220491	220491	387513
29711	49089	27	applied	\N	\N	\N	\N	220492	220492	387514
29711	49090	28	applied	\N	\N	\N	\N	220493	220493	387515
29711	49091	29	applied	\N	\N	\N	\N	220494	220494	387516
29713	49071	9	applied	\N	\N	\N	\N	220534	220534	387553
29713	49072	10	applied	\N	\N	\N	\N	220535	220535	387554
29713	49073	11	applied	\N	\N	\N	\N	220536	220536	387555
29713	49074	12	applied	\N	\N	\N	\N	220537	220537	387556
29713	49075	13	applied	\N	\N	\N	\N	220538	220538	387557
29713	49076	14	applied	\N	\N	\N	\N	220539	220539	387558
29713	49077	15	applied	\N	\N	\N	\N	220540	220540	387559
29713	49078	16	applied	\N	\N	\N	\N	220541	220541	387560
29713	49079	17	applied	\N	\N	\N	\N	220542	220542	387561
29713	49080	18	applied	\N	\N	\N	\N	220543	220543	220543
29713	49081	19	applied	\N	\N	\N	\N	220544	220544	387562
29713	49082	20	applied	\N	\N	\N	\N	220545	220545	387563
29713	49084	22	applied	\N	\N	\N	\N	220547	220547	387565
29713	49085	23	applied	\N	\N	\N	\N	220548	220548	387566
29713	49086	24	applied	\N	\N	\N	\N	220549	220549	387567
29713	49087	25	applied	\N	\N	\N	\N	220550	220550	387568
29713	49088	26	applied	\N	\N	\N	\N	220551	220551	387569
29713	49089	27	applied	\N	\N	\N	\N	220552	220552	387570
29713	49090	28	applied	\N	\N	\N	\N	220553	220553	387571
29713	49091	29	applied	\N	\N	\N	\N	220554	220554	387572
29716	49092	0	applied	\N	\N	\N	\N	220700	220700	387717
29716	49093	1	applied	\N	\N	\N	\N	220701	220701	387718
29716	49094	3	applied	\N	\N	\N	\N	220702	220702	387719
29716	49095	4	applied	\N	\N	\N	\N	220703	220703	387720
29716	49096	5	applied	\N	\N	\N	\N	220704	220704	387721
29716	49097	6	applied	\N	\N	\N	\N	220705	220705	387722
29716	49098	7	applied	\N	\N	\N	\N	220706	220706	387723
29716	49099	8	applied	\N	\N	\N	\N	220707	220707	387724
29716	49101	10	applied	\N	\N	\N	\N	220709	220709	387726
29716	49102	11	applied	\N	\N	\N	\N	220710	220710	387727
29716	49103	12	applied	\N	\N	\N	\N	220711	220711	387728
29716	49104	13	applied	\N	\N	\N	\N	220712	220712	387729
29716	49105	14	applied	\N	\N	\N	\N	220713	220713	387730
29716	49106	15	applied	\N	\N	\N	\N	220714	220714	387731
29716	49107	16	applied	\N	\N	\N	\N	220715	220715	387732
29716	49108	17	applied	\N	\N	\N	\N	220716	220716	387733
29716	49110	18	applied	\N	\N	\N	\N	220717	220717	387734
29716	49111	19	applied	\N	\N	\N	\N	220718	220718	387735
29718	49112	0	applied	\N	\N	\N	\N	220734	220734	387751
29718	49114	1	applied	\N	\N	\N	\N	220735	220735	387752
29718	49115	2	applied	\N	\N	\N	\N	220736	220736	387753
29718	49116	3	applied	\N	\N	\N	\N	220737	220737	387754
29718	49109	4	applied	\N	\N	\N	\N	220738	220738	387755
29718	49113	5	applied	\N	\N	\N	\N	220739	220739	387756
29718	49118	7	applied	\N	\N	\N	\N	220741	220741	387758
29718	49119	8	applied	\N	\N	\N	\N	220742	220742	387759
29718	49120	9	applied	\N	\N	\N	\N	220743	220743	387760
29718	49121	10	applied	\N	\N	\N	\N	220744	220744	387761
29718	49122	11	applied	\N	\N	\N	\N	220745	220745	387762
29718	49123	12	applied	\N	\N	\N	\N	220746	220746	387763
29718	49124	13	applied	\N	\N	\N	\N	220747	220747	387764
29718	49125	14	applied	\N	\N	\N	\N	220748	220748	387765
29718	49126	15	applied	\N	\N	\N	\N	220749	220749	387766
29718	49127	16	applied	\N	\N	\N	\N	220750	220750	387767
29718	49128	17	applied	\N	\N	\N	\N	220751	220751	387768
29718	49129	18	applied	\N	\N	\N	\N	220752	220752	387769
29718	49130	19	applied	\N	\N	\N	\N	220753	220753	387770
29718	49131	20	applied	\N	\N	\N	\N	220754	220754	387771
29718	49132	21	applied	\N	\N	\N	\N	220755	220755	387772
29718	49133	22	applied	\N	\N	\N	\N	220756	220756	387773
29718	49135	24	applied	\N	\N	\N	\N	220758	220758	387775
29718	49136	25	applied	\N	\N	\N	\N	220759	220759	387776
29718	49137	26	applied	\N	\N	\N	\N	220760	220760	387777
29721	49148	0	applied	\N	\N	\N	\N	220907	220907	387920
29721	49149	1	applied	\N	\N	\N	\N	220908	220908	387921
29721	49150	2	applied	\N	\N	\N	\N	220909	220909	387922
29721	49151	3	applied	\N	\N	\N	\N	220910	220910	387923
29721	49152	4	applied	\N	\N	\N	\N	220911	220911	387924
29721	49153	5	applied	\N	\N	\N	\N	220912	220912	387925
29721	49154	6	applied	\N	\N	\N	\N	220913	220913	387926
29721	49155	7	applied	\N	\N	\N	\N	220914	220914	387927
29721	49156	8	applied	\N	\N	\N	\N	220915	220915	387928
29726	49157	0	applied	\N	\N	\N	\N	220949	220949	387962
29726	49158	1	applied	\N	\N	\N	\N	220950	220950	387963
29726	49159	2	applied	\N	\N	\N	\N	220951	220951	387964
29726	49160	3	applied	\N	\N	\N	\N	220952	220952	387965
29726	49162	5	applied	\N	\N	\N	\N	220954	220954	387967
29726	49163	6	applied	\N	\N	\N	\N	220955	220955	387968
29726	49164	7	applied	\N	\N	\N	\N	220956	220956	387969
29726	49165	8	applied	\N	\N	\N	\N	220957	220957	387970
29726	49166	9	applied	\N	\N	\N	\N	220958	220958	387971
29726	49167	10	applied	\N	\N	\N	\N	220959	220959	387972
29726	49168	11	applied	\N	\N	\N	\N	220960	220960	387973
29726	49169	12	applied	\N	\N	\N	\N	220961	220961	387974
29726	49170	13	applied	\N	\N	\N	\N	220962	220962	387975
29726	49171	14	applied	\N	\N	\N	\N	220963	220963	387976
29726	49172	15	applied	\N	\N	\N	\N	220964	220964	387977
29726	49173	16	applied	\N	\N	\N	\N	220965	220965	387978
29733	49183	0	applied	\N	\N	\N	\N	221011	221011	388024
29733	49184	1	applied	\N	\N	\N	\N	221012	221012	388025
29711	49068	6	applied	\N	\N	\N	\N	220471	220471	387494
29711	49069	7	applied	\N	\N	\N	\N	220472	220472	387495
29714	48469	12	applied	\N	\N	\N	\N	220567	220567	387584
29714	48471	13	applied	\N	\N	\N	\N	220568	220568	387585
29714	48754	14	applied	\N	\N	1000000000	\N	220569	220569	387586
29714	48627	15	applied	\N	\N	\N	\N	220570	220570	387587
29714	48523	16	applied	\N	\N	\N	\N	220571	220571	387588
29714	48472	17	applied	\N	\N	\N	\N	220572	220572	387589
29714	48473	18	applied	\N	\N	\N	\N	220573	220573	387590
29714	48481	19	applied	\N	\N	\N	\N	220574	220574	387591
29714	48483	20	applied	\N	\N	\N	\N	220575	220575	387592
29714	48487	21	applied	\N	\N	\N	\N	220576	220576	387593
29714	48488	22	applied	\N	\N	\N	\N	220577	220577	387594
29714	48493	23	applied	\N	\N	\N	\N	220578	220578	387595
29714	48494	24	applied	\N	\N	\N	\N	220579	220579	387596
29714	48499	26	applied	\N	\N	\N	\N	220580	220580	387597
29714	48504	28	applied	\N	\N	\N	\N	220582	220582	387599
29714	48510	29	applied	\N	\N	\N	\N	220583	220583	387600
29723	49148	0	applied	\N	\N	\N	\N	220925	220925	387938
29723	49149	1	applied	\N	\N	\N	\N	220926	220926	387939
29723	49150	2	applied	\N	\N	\N	\N	220927	220927	387940
29723	49151	3	applied	\N	\N	\N	\N	220928	220928	387941
29723	49152	4	applied	\N	\N	\N	\N	220929	220929	387942
29723	49153	5	applied	\N	\N	\N	\N	220930	220930	387943
29723	49154	6	applied	\N	\N	\N	\N	220931	220931	387944
29723	49155	7	applied	\N	\N	\N	\N	220932	220932	387945
29723	49156	8	applied	\N	\N	\N	\N	220933	220933	387946
29725	49148	0	applied	\N	\N	\N	\N	220940	220940	387953
29725	49149	1	applied	\N	\N	\N	\N	220941	220941	387954
29725	49150	2	applied	\N	\N	\N	\N	220942	220942	387955
29725	49151	3	applied	\N	\N	\N	\N	220943	220943	387956
29725	49152	4	applied	\N	\N	\N	\N	220944	220944	387957
29725	49154	6	applied	\N	\N	\N	\N	220946	220946	387959
29725	49155	7	applied	\N	\N	\N	\N	220947	220947	387960
29725	49156	8	applied	\N	\N	\N	\N	220948	220948	387961
29727	49174	0	applied	\N	\N	\N	\N	220966	220966	387979
29727	49175	1	applied	\N	\N	\N	\N	220967	220967	387980
29727	49176	2	applied	\N	\N	\N	\N	220968	220968	387981
29727	49177	3	applied	\N	\N	\N	\N	220969	220969	387982
29727	49178	4	applied	\N	\N	\N	\N	220970	220970	387983
29727	49179	5	applied	\N	\N	\N	\N	220971	220971	387984
29727	49180	6	applied	\N	\N	\N	\N	220972	220972	387985
29727	49181	7	applied	\N	\N	\N	\N	220973	220973	387986
29727	49182	8	applied	\N	\N	\N	\N	220974	220974	387987
29729	49174	0	applied	\N	\N	\N	\N	220981	220981	387994
29729	49175	1	applied	\N	\N	\N	\N	220982	220982	387995
29729	49176	2	applied	\N	\N	\N	\N	220983	220983	387996
29729	49177	3	applied	\N	\N	\N	\N	220984	220984	387997
29729	49179	5	applied	\N	\N	\N	\N	220986	220986	387999
29729	49180	6	applied	\N	\N	\N	\N	220987	220987	388000
29729	49181	7	applied	\N	\N	\N	\N	220988	220988	388001
29729	49182	8	applied	\N	\N	\N	\N	220989	220989	388002
29731	49183	0	applied	\N	\N	\N	\N	220997	220997	388010
29731	49184	1	applied	\N	\N	\N	\N	220998	220998	388011
29731	49185	2	applied	\N	\N	\N	\N	220999	220999	388012
29731	49186	3	applied	\N	\N	\N	\N	221000	221000	388013
29731	49187	4	applied	\N	\N	\N	\N	221001	221001	388014
29731	49188	5	applied	\N	\N	\N	\N	221002	221002	388015
29731	49189	6	applied	\N	\N	\N	\N	221003	221003	388016
29735	49183	0	applied	\N	\N	\N	\N	221025	221025	388038
29735	49179	1	applied	\N	\N	\N	\N	221026	221026	388039
29735	49181	2	applied	\N	\N	\N	\N	221027	221027	388040
29735	49186	3	applied	\N	\N	\N	\N	221028	221028	388041
29735	49182	4	applied	\N	\N	\N	\N	221029	221029	388042
29735	49185	6	applied	\N	\N	\N	\N	221031	221031	388044
29735	49187	7	applied	\N	\N	\N	\N	221032	221032	388045
29735	49188	8	applied	\N	\N	\N	\N	221033	221033	388046
29737	49183	0	applied	\N	\N	\N	\N	221039	221039	388052
29737	49184	1	applied	\N	\N	\N	\N	221040	221040	388053
29737	49185	2	applied	\N	\N	\N	\N	221041	221041	388054
29737	49186	3	applied	\N	\N	\N	\N	221042	221042	388055
29737	49187	4	applied	\N	\N	\N	\N	221043	221043	388056
29737	49188	5	applied	\N	\N	\N	\N	221044	221044	388057
29742	49243	0	applied	\N	\N	\N	\N	221107	221107	388120
29742	49244	1	applied	\N	\N	\N	\N	221108	221108	388121
29742	49245	2	applied	\N	\N	\N	\N	221109	221109	388122
29742	49246	3	applied	\N	\N	\N	\N	221110	221110	388123
29742	49247	4	applied	\N	\N	\N	\N	221111	221111	388124
29742	49248	5	applied	\N	\N	\N	\N	221112	221112	388125
29742	49249	6	applied	\N	\N	\N	\N	221113	221113	388126
29742	49251	8	applied	\N	\N	\N	\N	221115	221115	388128
29742	49252	9	applied	\N	\N	\N	\N	221116	221116	388129
29742	49253	10	applied	\N	\N	\N	\N	221117	221117	388130
29742	49254	11	applied	\N	\N	\N	\N	221118	221118	388131
29742	49255	12	applied	\N	\N	\N	\N	221119	221119	388132
29742	49256	13	applied	\N	\N	\N	\N	221120	221120	388133
29742	49257	14	applied	\N	\N	\N	\N	221121	221121	388134
29742	49258	15	applied	\N	\N	\N	\N	221122	221122	388135
29744	49259	0	applied	\N	\N	\N	\N	221135	221135	388148
29744	49260	1	applied	\N	\N	\N	\N	221136	221136	388149
29744	49261	2	applied	\N	\N	\N	\N	221137	221137	388150
29744	49262	3	applied	\N	\N	\N	\N	221138	221138	388151
29744	49271	4	applied	\N	\N	\N	\N	221139	221139	388152
29744	49272	5	applied	\N	\N	\N	\N	221140	221140	388153
29744	49273	6	applied	\N	\N	\N	\N	221141	221141	388154
29744	49274	7	applied	\N	\N	\N	\N	221142	221142	388155
29744	49263	9	applied	\N	\N	\N	\N	221144	221144	388157
29744	49264	10	applied	\N	\N	\N	\N	221145	221145	388158
29744	49276	11	applied	\N	\N	\N	\N	221146	221146	388159
29744	49265	12	applied	\N	\N	\N	\N	221147	221147	388160
29744	49266	13	applied	\N	\N	\N	\N	221148	221148	388161
29744	49267	14	applied	\N	\N	\N	\N	221149	221149	388162
29744	49268	15	applied	\N	\N	\N	\N	221150	221150	388163
29744	49269	16	applied	\N	\N	\N	\N	221151	221151	388164
29744	49270	17	applied	\N	\N	\N	\N	221152	221152	388165
29748	49277	0	applied	\N	\N	\N	\N	221205	221205	388218
29748	49278	1	applied	\N	\N	\N	\N	221206	221206	388219
29748	49279	2	applied	\N	\N	\N	\N	221207	221207	388220
29748	49280	3	applied	\N	\N	\N	\N	221208	221208	388221
29748	49281	4	applied	\N	\N	\N	\N	221209	221209	388222
29748	49282	5	applied	\N	\N	\N	\N	221210	221210	388223
29748	49293	6	applied	\N	\N	\N	\N	221211	221211	388224
29714	48465	11	applied	\N	\N	\N	\N	220566	220566	387583
29714	48525	34	applied	\N	\N	\N	\N	220588	220588	387605
29714	48526	35	applied	\N	\N	\N	\N	220589	220589	387606
29714	48533	36	applied	\N	\N	\N	\N	220590	220590	387607
29714	48536	37	applied	\N	\N	\N	\N	220591	220591	387608
29714	48537	38	applied	\N	\N	\N	\N	220592	220592	387609
29714	48544	39	applied	\N	\N	\N	\N	220593	220593	387610
29714	48545	40	applied	\N	\N	\N	\N	220594	220594	387611
29714	48549	41	applied	\N	\N	\N	\N	220595	220595	387612
29714	48550	42	applied	\N	\N	\N	\N	220596	220596	387613
29714	48555	43	applied	\N	\N	\N	\N	220597	220597	387614
29714	48558	44	applied	\N	\N	\N	\N	220598	220598	387615
29714	48559	45	applied	\N	\N	\N	\N	220599	220599	387616
29714	48560	46	applied	\N	\N	\N	\N	220600	220600	387617
29714	48561	47	applied	\N	\N	\N	\N	220601	220601	387618
29714	48571	49	applied	\N	\N	\N	\N	220603	220603	387620
29714	48576	50	applied	\N	\N	\N	\N	220604	220604	387621
29714	48578	51	applied	\N	\N	\N	\N	220605	220605	387622
29714	48582	52	applied	\N	\N	\N	\N	220606	220606	387623
29714	48586	53	applied	\N	\N	\N	\N	220607	220607	387624
29714	48589	54	applied	\N	\N	\N	\N	220608	220608	387625
29714	48591	55	applied	\N	\N	\N	\N	220609	220609	387626
29714	48595	56	applied	\N	\N	\N	\N	220610	220610	387627
29714	48599	57	applied	\N	\N	\N	\N	220611	220611	387628
29714	48601	58	applied	\N	\N	\N	\N	220612	220612	387629
29714	48602	59	applied	\N	\N	\N	\N	220613	220613	387630
29714	48603	60	applied	\N	\N	\N	\N	220614	220614	387631
29714	48604	61	applied	\N	\N	\N	\N	220615	220615	387632
29714	48614	62	applied	\N	\N	\N	\N	220616	220616	387633
29714	48615	63	applied	\N	\N	\N	\N	220617	220617	387634
29714	48621	64	applied	\N	\N	\N	\N	220618	220618	387635
29714	48628	66	applied	\N	\N	\N	\N	220620	220620	387637
29714	48629	67	applied	\N	\N	\N	\N	220621	220621	387638
29714	48634	68	applied	\N	\N	\N	\N	220622	220622	387639
29714	48635	69	applied	\N	\N	\N	\N	220623	220623	387640
29714	48640	70	applied	\N	\N	\N	\N	220624	220624	387641
29714	48641	71	applied	\N	\N	\N	\N	220625	220625	387642
29714	48646	72	applied	\N	\N	\N	\N	220626	220626	387643
29714	48647	73	applied	\N	\N	\N	\N	220627	220627	387644
29714	48648	74	applied	\N	\N	\N	\N	220628	220628	387645
29714	48649	75	applied	\N	\N	\N	\N	220629	220629	387646
29714	48659	76	applied	\N	\N	\N	\N	220630	220630	387647
29714	48662	77	applied	\N	\N	\N	\N	220631	220631	387648
29714	48663	78	applied	\N	\N	\N	\N	220632	220632	387649
29714	48664	79	applied	\N	\N	\N	\N	220633	220633	387650
29714	48673	80	applied	\N	\N	\N	\N	220634	220634	387651
29714	48676	81	applied	\N	\N	\N	\N	220635	220635	387652
29714	48684	83	applied	\N	\N	\N	\N	220637	220637	387654
29714	48687	84	applied	\N	\N	\N	\N	220638	220638	387655
29714	48690	85	applied	\N	\N	\N	\N	220639	220639	387656
29714	48693	86	applied	\N	\N	\N	\N	220640	220640	387657
29714	48698	87	applied	\N	\N	\N	\N	220641	220641	387658
29714	48708	88	applied	\N	\N	\N	\N	220642	220642	387659
29714	48709	89	applied	\N	\N	\N	\N	220643	220643	387660
29714	48726	90	applied	\N	\N	\N	\N	220644	220644	387661
29714	48735	91	applied	\N	\N	\N	\N	220645	220645	387662
29714	48736	92	applied	\N	\N	\N	\N	220646	220646	387663
29714	48755	93	applied	\N	\N	\N	\N	220647	220647	387664
29714	48756	94	applied	\N	\N	\N	\N	220648	220648	387665
29714	48757	95	applied	\N	\N	\N	\N	220649	220649	387666
29714	48792	96	applied	\N	\N	\N	\N	220650	220650	387667
29714	48793	97	applied	\N	\N	\N	\N	220651	220651	387668
29714	48806	98	applied	\N	\N	\N	\N	220652	220652	387669
29714	48821	100	applied	\N	\N	\N	\N	220654	220654	387671
29714	48829	101	applied	\N	\N	\N	\N	220655	220655	387672
29714	48838	102	applied	\N	\N	\N	\N	220656	220656	387673
29714	48847	103	applied	\N	\N	\N	\N	220657	220657	387674
29714	48848	104	applied	\N	\N	\N	\N	220658	220658	387675
29714	48849	105	applied	\N	\N	\N	\N	220659	220659	387676
29714	48874	106	applied	\N	\N	\N	\N	220660	220660	387677
29714	48875	107	applied	\N	\N	\N	\N	220661	220661	387678
29714	48892	108	applied	\N	\N	\N	\N	220662	220662	387679
29714	48902	109	applied	\N	\N	\N	\N	220663	220663	387680
29714	48903	110	applied	\N	\N	\N	\N	220664	220664	387681
29714	48919	111	applied	\N	\N	\N	\N	220665	220665	387682
29714	48920	112	applied	\N	\N	\N	\N	220666	220666	387683
29714	48934	113	applied	\N	\N	\N	\N	220667	220667	387684
29714	48952	114	applied	\N	\N	\N	\N	220668	220668	387685
29714	48962	115	applied	\N	\N	\N	\N	220669	220669	387686
29714	48982	117	applied	\N	\N	\N	\N	220671	220671	387688
29714	48983	118	applied	\N	\N	\N	\N	220672	220672	387689
29714	48999	119	applied	\N	\N	\N	\N	220673	220673	387690
29714	49009	120	applied	\N	\N	\N	\N	220674	220674	387691
29714	49015	121	applied	\N	\N	\N	\N	220675	220675	387692
29714	49023	122	applied	\N	\N	\N	\N	220676	220676	387693
29714	49030	123	applied	\N	\N	\N	\N	220677	220677	387694
29714	49040	124	applied	\N	\N	\N	\N	220678	220678	387695
29714	49046	125	applied	\N	\N	\N	\N	220679	220679	387696
29715	49103	12	applied	\N	\N	\N	\N	220691	220691	387708
29715	49104	13	applied	\N	\N	\N	\N	220692	220692	387709
29715	49105	14	applied	\N	\N	\N	\N	220693	220693	387710
29715	49106	15	applied	\N	\N	\N	\N	220694	220694	387711
29715	49107	16	applied	\N	\N	\N	\N	220695	220695	387712
29715	49108	17	applied	\N	\N	\N	\N	220696	220696	387713
29715	49109	18	applied	\N	\N	\N	\N	220697	220697	387714
29715	49111	20	applied	\N	\N	\N	\N	220699	220699	387716
29717	49112	0	applied	\N	\N	\N	\N	220719	220719	387736
29717	49113	1	applied	\N	\N	\N	\N	220720	220720	387737
29717	49114	2	applied	\N	\N	\N	\N	220721	220721	387738
29717	49115	3	applied	\N	\N	\N	\N	220722	220722	387739
29717	49116	4	applied	\N	\N	\N	\N	220723	220723	387740
29717	49117	5	applied	\N	\N	\N	\N	220724	220724	387741
29717	49118	6	applied	\N	\N	\N	\N	220725	220725	387742
29717	49119	7	applied	\N	\N	\N	\N	220726	220726	387743
29717	49120	8	applied	\N	\N	\N	\N	220727	220727	387744
29717	49121	9	applied	\N	\N	\N	\N	220728	220728	387745
29717	49122	10	applied	\N	\N	\N	\N	220729	220729	387746
29717	49123	11	applied	\N	\N	\N	\N	220730	220730	387747
29717	49124	12	applied	\N	\N	\N	\N	220731	220731	387748
29720	48227	0	applied	\N	\N	\N	\N	220782	220782	387799
29714	48519	32	applied	\N	\N	\N	\N	220586	220586	387603
29714	48524	33	applied	\N	\N	\N	\N	220587	220587	387604
29719	49127	2	applied	\N	\N	\N	\N	220763	220763	387780
29719	49140	3	applied	\N	\N	\N	\N	220764	220764	387781
29719	49141	4	applied	\N	\N	\N	\N	220765	220765	387782
29719	49128	5	applied	\N	\N	\N	\N	220766	220766	387783
29719	49142	6	applied	\N	\N	\N	\N	220767	220767	387784
29719	49143	7	applied	\N	\N	\N	\N	220768	220768	387785
29719	49144	8	applied	\N	\N	\N	\N	220769	220769	387786
29719	49145	9	applied	\N	\N	\N	\N	220770	220770	387787
29719	49146	10	applied	\N	\N	\N	\N	220771	220771	387788
29719	49147	11	applied	\N	\N	\N	\N	220772	220772	387789
29719	49129	12	applied	\N	\N	\N	\N	220773	220773	387790
29719	49130	13	applied	\N	\N	\N	\N	220774	220774	387791
29719	49132	15	applied	\N	\N	\N	\N	220776	220776	387793
29719	49133	16	applied	\N	\N	\N	\N	220777	220777	387794
29719	49134	17	applied	\N	\N	\N	\N	220778	220778	387795
29719	49135	18	applied	\N	\N	\N	\N	220779	220779	387796
29719	49136	19	applied	\N	\N	\N	\N	220780	220780	387797
29719	49137	20	applied	\N	\N	\N	\N	220781	220781	387798
29720	48733	2	applied	\N	\N	\N	\N	220784	220784	220784
29720	48200	3	applied	\N	\N	\N	\N	220785	220785	220785
29720	48707	4	applied	\N	\N	\N	\N	220786	220786	387801
29720	48127	5	applied	\N	\N	\N	\N	220787	220787	387802
29720	48961	6	applied	\N	\N	\N	\N	220788	220788	387803
29720	48734	7	applied	\N	\N	\N	\N	220789	220789	387804
29720	48508	8	applied	\N	\N	\N	\N	220790	220790	387805
29720	48753	9	applied	\N	\N	\N	\N	220791	220791	387806
29720	48201	10	applied	\N	\N	\N	\N	220792	220792	220792
29720	48598	11	applied	\N	\N	\N	\N	220793	220793	387807
29720	47908	13	applied	\N	\N	\N	\N	220795	220795	387809
29720	48509	14	applied	\N	\N	\N	\N	220796	220796	387810
29720	48522	15	applied	\N	\N	\N	\N	220797	220797	387811
29720	48150	16	applied	\N	\N	\N	\N	220798	220798	387812
29720	48754	17	applied	\N	\N	1000000000	\N	220799	220799	387813
29720	47911	18	applied	\N	\N	\N	\N	220800	220800	387814
29720	47915	19	applied	\N	\N	\N	\N	220801	220801	387815
29720	47918	20	applied	\N	\N	\N	\N	220802	220802	387816
29720	48291	21	applied	\N	\N	\N	\N	220803	220803	220803
29720	48523	22	applied	\N	\N	\N	\N	220804	220804	387817
29724	49148	0	applied	\N	\N	\N	\N	220934	220934	387947
29724	49149	1	applied	\N	\N	\N	\N	220935	220935	387948
29724	49153	2	applied	\N	\N	\N	\N	220936	220936	387949
29724	49154	3	applied	\N	\N	\N	\N	220937	220937	387950
29724	49155	4	applied	\N	\N	\N	\N	220938	220938	387951
29724	49156	5	applied	\N	\N	\N	\N	220939	220939	387952
29738	49190	0	applied	\N	\N	\N	\N	221045	221045	388058
29738	49191	1	applied	\N	\N	\N	\N	221046	221046	388059
29738	49193	3	applied	\N	\N	\N	\N	221048	221048	388061
29738	49194	4	applied	\N	\N	\N	\N	221049	221049	388062
29738	49195	5	applied	\N	\N	\N	\N	221050	221050	388063
29738	49196	6	applied	\N	\N	\N	\N	221051	221051	388064
29740	49234	0	applied	\N	\N	\N	\N	221089	221089	388102
29740	49235	1	applied	\N	\N	\N	\N	221090	221090	388103
29740	49236	2	applied	\N	\N	\N	\N	221091	221091	388104
29740	49237	3	applied	\N	\N	\N	\N	221092	221092	388105
29740	49238	4	applied	\N	\N	\N	\N	221093	221093	388106
29740	49239	5	applied	\N	\N	\N	\N	221094	221094	388107
29740	49240	6	applied	\N	\N	\N	\N	221095	221095	388108
29740	49241	7	applied	\N	\N	\N	\N	221096	221096	388109
29740	49242	8	applied	\N	\N	\N	\N	221097	221097	388110
29747	49277	0	applied	\N	\N	\N	\N	221189	221189	388202
29747	49278	1	applied	\N	\N	\N	\N	221190	221190	388203
29747	49279	2	applied	\N	\N	\N	\N	221191	221191	388204
29747	49281	4	applied	\N	\N	\N	\N	221193	221193	388206
29747	49282	5	applied	\N	\N	\N	\N	221194	221194	388207
29747	49283	6	applied	\N	\N	\N	\N	221195	221195	388208
29747	49284	7	applied	\N	\N	\N	\N	221196	221196	388209
29747	49285	8	applied	\N	\N	\N	\N	221197	221197	388210
29747	49286	9	applied	\N	\N	\N	\N	221198	221198	388211
29747	49287	10	applied	\N	\N	\N	\N	221199	221199	388212
29747	49288	11	applied	\N	\N	\N	\N	221200	221200	388213
29747	49289	12	applied	\N	\N	\N	\N	221201	221201	388214
29747	49290	13	applied	\N	\N	\N	\N	221202	221202	388215
29747	49291	14	applied	\N	\N	\N	\N	221203	221203	388216
29747	49292	15	applied	\N	\N	\N	\N	221204	221204	388217
29749	49277	0	applied	\N	\N	\N	\N	221229	221229	388242
29749	49278	1	applied	\N	\N	\N	\N	221230	221230	388243
29749	49279	2	applied	\N	\N	\N	\N	221231	221231	388244
29749	49280	3	applied	\N	\N	\N	\N	221232	221232	388245
29749	49282	5	applied	\N	\N	\N	\N	221234	221234	388247
29749	49293	6	applied	\N	\N	\N	\N	221235	221235	388248
29749	49294	7	applied	\N	\N	\N	\N	221236	221236	388249
29749	49295	8	applied	\N	\N	\N	\N	221237	221237	388250
29749	49296	9	applied	\N	\N	\N	\N	221238	221238	388251
29749	49297	10	applied	\N	\N	\N	\N	221239	221239	388252
29749	49298	11	applied	\N	\N	\N	\N	221240	221240	388253
29749	49299	12	applied	\N	\N	\N	\N	221241	221241	388254
29749	49300	13	applied	\N	\N	\N	\N	221242	221242	388255
29749	49283	14	applied	\N	\N	\N	\N	221243	221243	388256
29749	49284	15	applied	\N	\N	\N	\N	221244	221244	388257
29749	49285	16	applied	\N	\N	\N	\N	221245	221245	388258
29749	49286	17	applied	\N	\N	\N	\N	221246	221246	388259
29749	49287	18	applied	\N	\N	\N	\N	221247	221247	388260
29749	49288	19	applied	\N	\N	\N	\N	221248	221248	388261
29749	49289	20	applied	\N	\N	\N	\N	221249	221249	388262
29749	49291	22	applied	\N	\N	\N	\N	221251	221251	388264
29749	49292	23	applied	\N	\N	\N	\N	221252	221252	388265
29751	49301	0	applied	\N	\N	\N	\N	221258	221258	388271
29751	49302	1	applied	\N	\N	\N	\N	221259	221259	388272
29753	49309	0	applied	\N	\N	\N	\N	221268	221268	388281
29753	49310	1	applied	\N	\N	\N	\N	221269	221269	388282
29753	49311	2	applied	\N	\N	\N	\N	221270	221270	388283
29755	49309	0	applied	\N	\N	\N	\N	221279	221279	388292
29755	49310	1	applied	\N	\N	\N	\N	221280	221280	388293
29755	49311	2	applied	\N	\N	\N	\N	221281	221281	388294
29755	49315	3	applied	\N	\N	\N	\N	221282	221282	388295
29755	49316	4	applied	\N	\N	\N	\N	221283	221283	388296
29760	49355	0	applied	\N	\N	\N	\N	221367	221367	388380
29760	49356	1	applied	\N	\N	\N	\N	221368	221368	388381
29760	49357	2	applied	\N	\N	\N	\N	221369	221369	388382
29717	49126	14	applied	\N	\N	\N	\N	220733	220733	387750
29719	49139	1	applied	\N	\N	\N	\N	220762	220762	387779
29720	47920	27	applied	\N	\N	\N	\N	220809	220809	387822
29720	47924	28	applied	\N	\N	\N	\N	220810	220810	387823
29720	47927	29	applied	\N	\N	\N	\N	220811	220811	387824
29720	47929	30	applied	\N	\N	\N	\N	220812	220812	387825
29720	47930	31	applied	\N	\N	\N	\N	220813	220813	387826
29720	47936	32	applied	\N	\N	\N	\N	220814	220814	387827
29720	47941	33	applied	\N	\N	\N	\N	220815	220815	387828
29720	47944	34	applied	\N	\N	\N	\N	220816	220816	387829
29720	47948	35	applied	\N	\N	\N	\N	220817	220817	387830
29720	47949	36	applied	\N	\N	\N	\N	220818	220818	387831
29720	47954	37	applied	\N	\N	\N	\N	220819	220819	387832
29720	47958	38	applied	\N	\N	\N	\N	220820	220820	387833
29720	47961	39	applied	\N	\N	\N	\N	220821	220821	387834
29720	47964	40	applied	\N	\N	\N	\N	220822	220822	387835
29720	47965	41	applied	\N	\N	\N	\N	220823	220823	387836
29720	47970	42	applied	\N	\N	\N	\N	220824	220824	387837
29720	47976	44	applied	\N	\N	\N	\N	220826	220826	387839
29720	47979	45	applied	\N	\N	\N	\N	220827	220827	387840
29720	47980	46	applied	\N	\N	\N	\N	220828	220828	387841
29720	47985	47	applied	\N	\N	\N	\N	220829	220829	387842
29720	47986	48	applied	\N	\N	\N	\N	220830	220830	387843
29720	47991	49	applied	\N	\N	\N	\N	220831	220831	387844
29720	47994	50	applied	\N	\N	\N	\N	220832	220832	387845
29720	47998	51	applied	\N	\N	\N	\N	220833	220833	387846
29720	48000	52	applied	\N	\N	\N	\N	220834	220834	387847
29720	48003	53	applied	\N	\N	\N	\N	220835	220835	387848
29720	48006	54	applied	\N	\N	\N	\N	220836	220836	387849
29720	48009	55	applied	\N	\N	\N	\N	220837	220837	387850
29720	48012	56	applied	\N	\N	\N	\N	220838	220838	387851
29720	48015	57	applied	\N	\N	\N	\N	220839	220839	387852
29720	48018	58	applied	\N	\N	\N	\N	220840	220840	387853
29720	48021	59	applied	\N	\N	\N	\N	220841	220841	387854
29720	48027	61	applied	\N	\N	\N	\N	220843	220843	387856
29720	48028	62	applied	\N	\N	\N	\N	220844	220844	387857
29720	48032	63	applied	\N	\N	\N	\N	220845	220845	387858
29720	48033	64	applied	\N	\N	\N	\N	220846	220846	387859
29720	48034	66	applied	\N	\N	\N	\N	220847	220847	387860
29720	48041	67	applied	\N	\N	\N	\N	220848	220848	387861
29720	48044	68	applied	\N	\N	\N	\N	220849	220849	387862
29720	48048	69	applied	\N	\N	\N	\N	220850	220850	387863
29720	48050	70	applied	\N	\N	\N	\N	220851	220851	387864
29720	48053	71	applied	\N	\N	\N	\N	220852	220852	387865
29720	48054	72	applied	\N	\N	\N	\N	220853	220853	387866
29720	48060	73	applied	\N	\N	\N	\N	220854	220854	387867
29720	48062	74	applied	\N	\N	\N	\N	220855	220855	387868
29720	48063	75	applied	\N	\N	\N	\N	220856	220856	387869
29720	48064	76	applied	\N	\N	\N	\N	220857	220857	387870
29720	48074	77	applied	\N	\N	\N	\N	220858	220858	387871
29720	48082	79	applied	\N	\N	\N	\N	220860	220860	387873
29720	48084	80	applied	\N	\N	\N	\N	220861	220861	387874
29720	48089	81	applied	\N	\N	\N	\N	220862	220862	387875
29720	48092	82	applied	\N	\N	\N	\N	220863	220863	387876
29720	48095	83	applied	\N	\N	\N	\N	220864	220864	387877
29720	48096	84	applied	\N	\N	\N	\N	220865	220865	387878
29720	48101	85	applied	\N	\N	\N	\N	220866	220866	387879
29720	48105	86	applied	\N	\N	\N	\N	220867	220867	387880
29720	48107	87	applied	\N	\N	\N	\N	220868	220868	387881
29720	48111	88	applied	\N	\N	\N	\N	220869	220869	387882
29720	48114	89	applied	\N	\N	\N	\N	220870	220870	387883
29720	48118	90	applied	\N	\N	\N	\N	220871	220871	387884
29720	48119	91	applied	\N	\N	\N	\N	220872	220872	387885
29720	48120	92	applied	\N	\N	\N	\N	220873	220873	387886
29720	48128	93	applied	\N	\N	\N	\N	220874	220874	387887
29720	48129	94	applied	\N	\N	\N	\N	220875	220875	387888
29720	48138	96	applied	\N	\N	\N	\N	220877	220877	387890
29720	48141	97	applied	\N	\N	\N	\N	220878	220878	387891
29720	48143	98	applied	\N	\N	\N	\N	220879	220879	387892
29720	48147	99	applied	\N	\N	\N	\N	220880	220880	387893
29720	48151	100	applied	\N	\N	\N	\N	220881	220881	387894
29720	48156	101	applied	\N	\N	\N	\N	220882	220882	387895
29720	48160	102	applied	\N	\N	\N	\N	220883	220883	387896
29720	48164	103	applied	\N	\N	\N	\N	220884	220884	387897
29720	48167	104	applied	\N	\N	\N	\N	220885	220885	387898
29720	48170	105	applied	\N	\N	\N	\N	220886	220886	387899
29720	48174	106	applied	\N	\N	\N	\N	220887	220887	387900
29720	48178	107	applied	\N	\N	\N	\N	220888	220888	387901
29720	48181	108	applied	\N	\N	\N	\N	220889	220889	387902
29720	48184	109	applied	\N	\N	\N	\N	220890	220890	387903
29720	48185	110	applied	\N	\N	\N	\N	220891	220891	387904
29720	48186	111	applied	\N	\N	\N	\N	220892	220892	387905
29720	48198	113	applied	\N	\N	\N	\N	220894	220894	387907
29720	48202	114	applied	\N	\N	\N	\N	220895	220895	387908
29720	48206	115	applied	\N	\N	\N	\N	220896	220896	387909
29720	48209	116	applied	\N	\N	\N	\N	220897	220897	387910
29720	48210	117	applied	\N	\N	\N	\N	220898	220898	387911
29720	48211	118	applied	\N	\N	\N	\N	220899	220899	387912
29720	48218	119	applied	\N	\N	\N	\N	220900	220900	387913
29720	48221	120	applied	\N	\N	\N	\N	220901	220901	387914
29720	48222	121	applied	\N	\N	\N	\N	220902	220902	387915
29720	48228	122	applied	\N	\N	\N	\N	220903	220903	387916
29720	48231	123	applied	\N	\N	\N	\N	220904	220904	387917
29720	48233	124	applied	\N	\N	\N	\N	220905	220905	387918
29720	48237	125	applied	\N	\N	\N	\N	220906	220906	387919
29722	49148	0	applied	\N	\N	\N	\N	220916	220916	387929
29722	49149	1	applied	\N	\N	\N	\N	220917	220917	387930
29722	49150	2	applied	\N	\N	\N	\N	220918	220918	387931
29722	49152	4	applied	\N	\N	\N	\N	220920	220920	387933
29722	49153	5	applied	\N	\N	\N	\N	220921	220921	387934
29722	49154	6	applied	\N	\N	\N	\N	220922	220922	387935
29722	49155	7	applied	\N	\N	\N	\N	220923	220923	387936
29722	49156	8	applied	\N	\N	\N	\N	220924	220924	387937
29728	49174	0	applied	\N	\N	\N	\N	220975	220975	387988
29728	49175	1	applied	\N	\N	\N	\N	220976	220976	387989
29728	49176	2	applied	\N	\N	\N	\N	220977	220977	387990
29728	49177	3	applied	\N	\N	\N	\N	220978	220978	387991
29728	49178	4	applied	\N	\N	\N	\N	220979	220979	387992
29728	49180	5	applied	\N	\N	\N	\N	220980	220980	387993
29730	49183	0	applied	\N	\N	\N	\N	220990	220990	388003
29730	49184	1	applied	\N	\N	\N	\N	220991	220991	388004
29730	49185	2	applied	\N	\N	\N	\N	220992	220992	388005
29720	48265	24	applied	\N	\N	\N	\N	220806	220806	387819
29720	48152	25	applied	\N	\N	\N	\N	220807	220807	387820
29732	49183	0	applied	\N	\N	\N	\N	221004	221004	388017
29732	49184	1	applied	\N	\N	\N	\N	221005	221005	388018
29732	49185	2	applied	\N	\N	\N	\N	221006	221006	388019
29732	49186	3	applied	\N	\N	\N	\N	221007	221007	388020
29732	49187	4	applied	\N	\N	\N	\N	221008	221008	388021
29732	49188	5	applied	\N	\N	\N	\N	221009	221009	388022
29732	49189	6	applied	\N	\N	\N	\N	221010	221010	388023
29733	49185	2	applied	\N	\N	\N	\N	221013	221013	388026
29733	49186	3	applied	\N	\N	\N	\N	221014	221014	388027
29733	49187	4	applied	\N	\N	\N	\N	221015	221015	388028
29733	49188	5	applied	\N	\N	\N	\N	221016	221016	388029
29733	49189	6	applied	\N	\N	\N	\N	221017	221017	388030
29734	49183	0	applied	\N	\N	\N	\N	221018	221018	388031
29734	49184	1	applied	\N	\N	\N	\N	221019	221019	388032
29734	49185	2	applied	\N	\N	\N	\N	221020	221020	388033
29734	49186	3	applied	\N	\N	\N	\N	221021	221021	388034
29734	49188	5	applied	\N	\N	\N	\N	221023	221023	388036
29734	49189	6	applied	\N	\N	\N	\N	221024	221024	388037
29736	49183	0	applied	\N	\N	\N	\N	221034	221034	388047
29736	49184	1	applied	\N	\N	\N	\N	221035	221035	388048
29736	49186	2	applied	\N	\N	\N	\N	221036	221036	388049
29736	49187	3	applied	\N	\N	\N	\N	221037	221037	388050
29736	49188	4	applied	\N	\N	\N	\N	221038	221038	388051
29739	49197	0	applied	\N	\N	\N	\N	221052	221052	388065
29739	49198	1	applied	\N	\N	\N	\N	221053	221053	388066
29739	49199	2	applied	\N	\N	\N	\N	221054	221054	388067
29739	49200	3	applied	\N	\N	\N	\N	221055	221055	388068
29739	49201	4	applied	\N	\N	\N	\N	221056	221056	388069
29739	49202	5	applied	\N	\N	\N	\N	221057	221057	388070
29739	49203	6	applied	\N	\N	\N	\N	221058	221058	388071
29739	49204	7	applied	\N	\N	\N	\N	221059	221059	388072
29739	49205	9	applied	\N	\N	\N	\N	221060	221060	388073
29739	49207	11	applied	\N	\N	\N	\N	221062	221062	388075
29739	49208	12	applied	\N	\N	\N	\N	221063	221063	388076
29739	49209	13	applied	\N	\N	\N	\N	221064	221064	388077
29739	49210	14	applied	\N	\N	\N	\N	221065	221065	388078
29739	49211	15	applied	\N	\N	\N	\N	221066	221066	388079
29739	49212	16	applied	\N	\N	\N	\N	221067	221067	388080
29739	49213	17	applied	\N	\N	\N	\N	221068	221068	388081
29739	49214	18	applied	\N	\N	\N	\N	221069	221069	388082
29739	49215	19	applied	\N	\N	\N	\N	221070	221070	388083
29739	49216	20	applied	\N	\N	\N	\N	221071	221071	388084
29739	49217	21	applied	\N	\N	\N	\N	221072	221072	388085
29739	49218	22	applied	\N	\N	\N	\N	221073	221073	388086
29739	49219	23	applied	\N	\N	\N	\N	221074	221074	388087
29739	49220	24	applied	\N	\N	\N	\N	221075	221075	388088
29739	49221	25	applied	\N	\N	\N	\N	221076	221076	388089
29739	49222	26	applied	\N	\N	\N	\N	221077	221077	388090
29739	49224	28	applied	\N	\N	\N	\N	221079	221079	388092
29739	49225	29	applied	\N	\N	\N	\N	221080	221080	388093
29739	49226	30	applied	\N	\N	\N	\N	221081	221081	388094
29739	49227	31	applied	\N	\N	\N	\N	221082	221082	388095
29739	49228	32	applied	\N	\N	\N	\N	221083	221083	388096
29739	49229	33	applied	\N	\N	\N	\N	221084	221084	388097
29739	49230	34	applied	\N	\N	\N	\N	221085	221085	388098
29739	49231	35	applied	\N	\N	\N	\N	221086	221086	388099
29739	49232	36	applied	\N	\N	\N	\N	221087	221087	388100
29739	49233	37	applied	\N	\N	\N	\N	221088	221088	388101
29741	49234	0	applied	\N	\N	\N	\N	221098	221098	388111
29741	49235	1	applied	\N	\N	\N	\N	221099	221099	388112
29741	49236	2	applied	\N	\N	\N	\N	221100	221100	388113
29741	49237	3	applied	\N	\N	\N	\N	221101	221101	388114
29741	49238	4	applied	\N	\N	\N	\N	221102	221102	388115
29741	49239	5	applied	\N	\N	\N	\N	221103	221103	388116
29741	49241	7	applied	\N	\N	\N	\N	221105	221105	388118
29741	49242	8	applied	\N	\N	\N	\N	221106	221106	388119
29743	49259	0	applied	\N	\N	\N	\N	221123	221123	388136
29743	49260	1	applied	\N	\N	\N	\N	221124	221124	388137
29743	49261	2	applied	\N	\N	\N	\N	221125	221125	388138
29743	49262	3	applied	\N	\N	\N	\N	221126	221126	388139
29743	49263	4	applied	\N	\N	\N	\N	221127	221127	388140
29743	49264	5	applied	\N	\N	\N	\N	221128	221128	388141
29743	49265	6	applied	\N	\N	\N	\N	221129	221129	388142
29743	49266	7	applied	\N	\N	\N	\N	221130	221130	388143
29745	49259	0	applied	\N	\N	\N	\N	221153	221153	388166
29745	49260	1	applied	\N	\N	\N	\N	221154	221154	388167
29745	49261	2	applied	\N	\N	\N	\N	221155	221155	388168
29745	49262	3	applied	\N	\N	\N	\N	221156	221156	388169
29745	49271	4	applied	\N	\N	\N	\N	221157	221157	388170
29745	49272	5	applied	\N	\N	\N	\N	221158	221158	388171
29745	49274	7	applied	\N	\N	\N	\N	221160	221160	388173
29745	49275	8	applied	\N	\N	\N	\N	221161	221161	388174
29745	49263	9	applied	\N	\N	\N	\N	221162	221162	388175
29745	49264	10	applied	\N	\N	\N	\N	221163	221163	388176
29745	49276	11	applied	\N	\N	\N	\N	221164	221164	388177
29745	49265	12	applied	\N	\N	\N	\N	221165	221165	388178
29745	49266	13	applied	\N	\N	\N	\N	221166	221166	388179
29745	49267	14	applied	\N	\N	\N	\N	221167	221167	388180
29745	49268	15	applied	\N	\N	\N	\N	221168	221168	388181
29745	49269	16	applied	\N	\N	\N	\N	221169	221169	388182
29745	49270	17	applied	\N	\N	\N	\N	221170	221170	388183
29752	49301	0	applied	\N	\N	\N	\N	221260	221260	388273
29752	49303	1	applied	\N	\N	\N	\N	221261	221261	388274
29752	49304	2	applied	\N	\N	\N	\N	221262	221262	388275
29752	49302	3	applied	\N	\N	\N	\N	221263	221263	388276
29752	49305	4	applied	\N	\N	\N	\N	221264	221264	388277
29752	49307	6	applied	\N	\N	\N	\N	221266	221266	388279
29752	49308	7	applied	\N	\N	\N	\N	221267	221267	388280
29754	49309	0	applied	\N	\N	\N	\N	221271	221271	388284
29754	49312	1	applied	\N	\N	\N	\N	221272	221272	388285
29754	49313	2	applied	\N	\N	\N	\N	221273	221273	388286
29754	49314	3	applied	\N	\N	\N	\N	221274	221274	388287
29754	49310	4	applied	\N	\N	\N	\N	221275	221275	388288
29754	49311	5	applied	\N	\N	\N	\N	221276	221276	388289
29754	49315	6	applied	\N	\N	\N	\N	221277	221277	388290
29754	49316	7	applied	\N	\N	\N	\N	221278	221278	388291
29757	49317	0	applied	\N	\N	\N	\N	221302	221302	388315
29757	49318	1	applied	\N	\N	\N	\N	221303	221303	388316
29757	49319	2	applied	\N	\N	\N	\N	221304	221304	388317
29757	49312	3	applied	\N	\N	\N	\N	221305	221305	388318
29730	49187	4	applied	\N	\N	\N	\N	220994	220994	388007
29730	49188	5	applied	\N	\N	\N	\N	220995	220995	388008
29746	49259	0	applied	\N	\N	\N	\N	221171	221171	388184
29746	49260	1	applied	\N	\N	\N	\N	221172	221172	388185
29746	49261	2	applied	\N	\N	\N	\N	221173	221173	388186
29746	49262	3	applied	\N	\N	\N	\N	221174	221174	388187
29746	49271	4	applied	\N	\N	\N	\N	221175	221175	388188
29746	49272	5	applied	\N	\N	\N	\N	221176	221176	388189
29746	49273	6	applied	\N	\N	\N	\N	221177	221177	388190
29746	49274	7	applied	\N	\N	\N	\N	221178	221178	388191
29746	49275	8	applied	\N	\N	\N	\N	221179	221179	388192
29746	49263	9	applied	\N	\N	\N	\N	221180	221180	388193
29746	49264	10	applied	\N	\N	\N	\N	221181	221181	388194
29746	49276	11	applied	\N	\N	\N	\N	221182	221182	388195
29746	49265	12	applied	\N	\N	\N	\N	221183	221183	388196
29746	49266	13	applied	\N	\N	\N	\N	221184	221184	388197
29746	49267	14	applied	\N	\N	\N	\N	221185	221185	388198
29746	49268	15	applied	\N	\N	\N	\N	221186	221186	388199
29746	49270	17	applied	\N	\N	\N	\N	221188	221188	388201
29748	49294	7	applied	\N	\N	\N	\N	221212	221212	388225
29748	49295	8	applied	\N	\N	\N	\N	221213	221213	388226
29748	49296	9	applied	\N	\N	\N	\N	221214	221214	388227
29748	49297	10	applied	\N	\N	\N	\N	221215	221215	388228
29748	49298	11	applied	\N	\N	\N	\N	221216	221216	388229
29748	49299	12	applied	\N	\N	\N	\N	221217	221217	388230
29748	49300	13	applied	\N	\N	\N	\N	221218	221218	388231
29748	49283	14	applied	\N	\N	\N	\N	221219	221219	388232
29748	49284	15	applied	\N	\N	\N	\N	221220	221220	388233
29748	49285	16	applied	\N	\N	\N	\N	221221	221221	388234
29748	49286	17	applied	\N	\N	\N	\N	221222	221222	388235
29748	49287	18	applied	\N	\N	\N	\N	221223	221223	388236
29748	49288	19	applied	\N	\N	\N	\N	221224	221224	388237
29748	49289	20	applied	\N	\N	\N	\N	221225	221225	388238
29748	49290	21	applied	\N	\N	\N	\N	221226	221226	388239
29748	49292	23	applied	\N	\N	\N	\N	221228	221228	388241
29750	49277	0	applied	\N	\N	\N	\N	221253	221253	388266
29750	49278	1	applied	\N	\N	\N	\N	221254	221254	388267
29750	49279	2	applied	\N	\N	\N	\N	221255	221255	388268
29750	49280	3	applied	\N	\N	\N	\N	221256	221256	388269
29750	49281	4	applied	\N	\N	\N	\N	221257	221257	388270
29756	49317	0	applied	\N	\N	\N	\N	221284	221284	388297
29756	49318	1	applied	\N	\N	\N	\N	221285	221285	388298
29756	49319	2	applied	\N	\N	\N	\N	221286	221286	388299
29756	49312	3	applied	\N	\N	\N	\N	221287	221287	388300
29756	49320	5	applied	\N	\N	\N	\N	221288	221288	388301
29756	49321	6	applied	\N	\N	\N	\N	221289	221289	388302
29756	49322	7	applied	\N	\N	\N	\N	221290	221290	388303
29756	49323	8	applied	\N	\N	\N	\N	221291	221291	388304
29756	49324	9	applied	\N	\N	\N	\N	221292	221292	388305
29756	49325	10	applied	\N	\N	\N	\N	221293	221293	388306
29756	49327	12	applied	\N	\N	\N	\N	221295	221295	388308
29756	49328	13	applied	\N	\N	\N	\N	221296	221296	388309
29756	49329	14	applied	\N	\N	\N	\N	221297	221297	388310
29756	49330	15	applied	\N	\N	\N	\N	221298	221298	388311
29756	49331	16	applied	\N	\N	\N	\N	221299	221299	388312
29756	49313	17	applied	\N	\N	\N	\N	221300	221300	388313
29756	49314	18	applied	\N	\N	\N	\N	221301	221301	388314
29758	49317	0	applied	\N	\N	\N	\N	221320	221320	388333
29758	49318	2	applied	\N	\N	\N	\N	221321	221321	388334
29758	49319	3	applied	\N	\N	\N	\N	221322	221322	388335
29758	49332	4	applied	\N	\N	\N	\N	221323	221323	388336
29758	49333	5	applied	\N	\N	\N	\N	221324	221324	388337
29758	49334	6	applied	\N	\N	\N	\N	221325	221325	388338
29758	49335	7	applied	\N	\N	\N	\N	221326	221326	388339
29758	49320	8	applied	\N	\N	\N	\N	221327	221327	388340
29758	49321	9	applied	\N	\N	\N	\N	221328	221328	388341
29758	49323	11	applied	\N	\N	\N	\N	221330	221330	388343
29758	49324	12	applied	\N	\N	\N	\N	221331	221331	388344
29758	49325	13	applied	\N	\N	\N	\N	221332	221332	388345
29758	49326	14	applied	\N	\N	\N	\N	221333	221333	388346
29758	49327	15	applied	\N	\N	\N	\N	221334	221334	388347
29758	49328	16	applied	\N	\N	\N	\N	221335	221335	388348
29758	49329	17	applied	\N	\N	\N	\N	221336	221336	388349
29758	49330	18	applied	\N	\N	\N	\N	221337	221337	388350
29758	49331	19	applied	\N	\N	\N	\N	221338	221338	388351
29758	49336	20	applied	\N	\N	\N	\N	221339	221339	388352
29758	49337	21	applied	\N	\N	\N	\N	221340	221340	388353
29758	49338	22	applied	\N	\N	\N	\N	221341	221341	388354
29758	49339	23	applied	\N	\N	\N	\N	221342	221342	388355
29758	49340	24	applied	\N	\N	\N	\N	221343	221343	388356
29767	49405	0	applied	\N	\N	\N	\N	221454	221454	388467
29767	49406	1	applied	\N	\N	\N	\N	221455	221455	388468
29767	49408	3	applied	\N	\N	\N	\N	221457	221457	388470
29767	49409	4	applied	\N	\N	\N	\N	221458	221458	388471
29767	49410	5	applied	\N	\N	\N	\N	221459	221459	388472
29767	49411	6	applied	\N	\N	\N	\N	221460	221460	388473
29767	49412	7	applied	\N	\N	\N	\N	221461	221461	388474
29767	49413	8	applied	\N	\N	\N	\N	221462	221462	388475
29767	49414	9	applied	\N	\N	\N	\N	221463	221463	388476
29767	49415	10	applied	\N	\N	\N	\N	221464	221464	388477
29767	49416	11	applied	\N	\N	\N	\N	221465	221465	388478
29767	49417	12	applied	\N	\N	\N	\N	221466	221466	388479
29767	49418	13	applied	\N	\N	\N	\N	221467	221467	388480
29767	49419	14	applied	\N	\N	\N	\N	221468	221468	388481
29767	49420	15	applied	\N	\N	\N	\N	221469	221469	388482
29767	49421	16	applied	\N	\N	\N	\N	221470	221470	388483
29767	49422	17	applied	\N	\N	\N	\N	221471	221471	388484
29767	49423	18	applied	\N	\N	\N	\N	221472	221472	388485
29769	49406	1	applied	\N	\N	\N	\N	221493	221493	388506
29769	49407	2	applied	\N	\N	\N	\N	221494	221494	388507
29769	49408	3	applied	\N	\N	\N	\N	221495	221495	388508
29769	49411	4	applied	\N	\N	\N	\N	221496	221496	388509
29769	49412	5	applied	\N	\N	\N	\N	221497	221497	388510
29769	49413	6	applied	\N	\N	\N	\N	221498	221498	388511
29769	49414	7	applied	\N	\N	\N	\N	221499	221499	388512
29769	49415	8	applied	\N	\N	\N	\N	221500	221500	388513
29769	49416	9	applied	\N	\N	\N	\N	221501	221501	388514
29769	49417	10	applied	\N	\N	\N	\N	221502	221502	388515
29769	49418	11	applied	\N	\N	\N	\N	221503	221503	388516
29769	49419	12	applied	\N	\N	\N	\N	221504	221504	388517
29769	49420	13	applied	\N	\N	\N	\N	221505	221505	388518
29769	49421	14	applied	\N	\N	\N	\N	221506	221506	388519
29743	49268	9	applied	\N	\N	\N	\N	221132	221132	388145
29743	49269	10	applied	\N	\N	\N	\N	221133	221133	388146
29757	49324	9	applied	\N	\N	\N	\N	221310	221310	388323
29757	49325	10	applied	\N	\N	\N	\N	221311	221311	388324
29757	49326	11	applied	\N	\N	\N	\N	221312	221312	388325
29757	49327	12	applied	\N	\N	\N	\N	221313	221313	388326
29757	49328	13	applied	\N	\N	\N	\N	221314	221314	388327
29757	49329	14	applied	\N	\N	\N	\N	221315	221315	388328
29757	49330	15	applied	\N	\N	\N	\N	221316	221316	388329
29757	49331	16	applied	\N	\N	\N	\N	221317	221317	388330
29757	49313	17	applied	\N	\N	\N	\N	221318	221318	388331
29757	49314	18	applied	\N	\N	\N	\N	221319	221319	388332
29759	49341	0	applied	\N	\N	\N	\N	221344	221344	388357
29759	49342	1	applied	\N	\N	\N	\N	221345	221345	388358
29759	49343	2	applied	\N	\N	\N	\N	221346	221346	388359
29759	49344	3	applied	\N	\N	\N	\N	221347	221347	388360
29759	49345	4	applied	\N	\N	\N	\N	221348	221348	388361
29759	49346	5	applied	\N	\N	\N	\N	221349	221349	388362
29759	49332	7	applied	\N	\N	\N	\N	221351	221351	388364
29765	49380	0	applied	\N	\N	\N	\N	221429	221429	388442
29765	49381	1	applied	\N	\N	\N	\N	221430	221430	388443
29765	49382	2	applied	\N	\N	\N	\N	221431	221431	388444
29765	49383	3	applied	\N	\N	\N	\N	221432	221432	388445
29765	49384	4	applied	\N	\N	\N	\N	221433	221433	388446
29765	49385	5	applied	\N	\N	\N	\N	221434	221434	388447
29765	49386	6	applied	\N	\N	\N	\N	221435	221435	388448
29765	49387	7	applied	\N	\N	\N	\N	221436	221436	388449
29765	49388	8	applied	\N	\N	\N	\N	221437	221437	388450
29765	49389	9	applied	\N	\N	\N	\N	221438	221438	388451
29765	49390	10	applied	\N	\N	\N	\N	221439	221439	388452
29765	49391	11	applied	\N	\N	\N	\N	221440	221440	388453
29768	49405	0	applied	\N	\N	\N	\N	221473	221473	388486
29768	49406	1	applied	\N	\N	\N	\N	221474	221474	388487
29768	49407	2	applied	\N	\N	\N	\N	221475	221475	388488
29768	49409	4	applied	\N	\N	\N	\N	221477	221477	388490
29768	49410	5	applied	\N	\N	\N	\N	221478	221478	388491
29768	49411	6	applied	\N	\N	\N	\N	221479	221479	388492
29768	49412	7	applied	\N	\N	\N	\N	221480	221480	388493
29768	49413	8	applied	\N	\N	\N	\N	221481	221481	388494
29768	49414	9	applied	\N	\N	\N	\N	221482	221482	388495
29768	49415	10	applied	\N	\N	\N	\N	221483	221483	388496
29768	49416	11	applied	\N	\N	\N	\N	221484	221484	388497
29768	49417	12	applied	\N	\N	\N	\N	221485	221485	388498
29768	49418	13	applied	\N	\N	\N	\N	221486	221486	388499
29768	49419	14	applied	\N	\N	\N	\N	221487	221487	388500
29768	49420	15	applied	\N	\N	\N	\N	221488	221488	388501
29768	49421	16	applied	\N	\N	\N	\N	221489	221489	388502
29768	49422	17	applied	\N	\N	\N	\N	221490	221490	388503
29768	49423	18	applied	\N	\N	\N	\N	221491	221491	388504
29773	49449	0	applied	\N	\N	\N	\N	221582	221582	388595
29773	49451	2	applied	\N	\N	\N	\N	221584	221584	388597
29773	49452	3	applied	\N	\N	\N	\N	221585	221585	388598
29773	49453	4	applied	\N	\N	\N	\N	221586	221586	388599
29773	49454	5	applied	\N	\N	\N	\N	221587	221587	388600
29773	49455	6	applied	\N	\N	\N	\N	221588	221588	388601
29773	49456	7	applied	\N	\N	\N	\N	221589	221589	388602
29773	49457	8	applied	\N	\N	\N	\N	221590	221590	388603
29773	49458	9	applied	\N	\N	\N	\N	221591	221591	388604
29773	49459	10	applied	\N	\N	\N	\N	221592	221592	388605
29773	49460	11	applied	\N	\N	\N	\N	221593	221593	388606
29773	49461	12	applied	\N	\N	\N	\N	221594	221594	388607
29773	49462	13	applied	\N	\N	\N	\N	221595	221595	388608
29773	49463	14	applied	\N	\N	\N	\N	221596	221596	388609
29773	49464	15	applied	\N	\N	\N	\N	221597	221597	388610
29773	49465	16	applied	\N	\N	\N	\N	221598	221598	388611
29773	49466	17	applied	\N	\N	\N	\N	221599	221599	388612
29773	49468	19	applied	\N	\N	\N	\N	221601	221601	388614
29773	49469	20	applied	\N	\N	\N	\N	221602	221602	388615
29773	49470	21	applied	\N	\N	\N	\N	221603	221603	388616
29773	49471	22	applied	\N	\N	\N	\N	221604	221604	388617
29773	49472	23	applied	\N	\N	\N	\N	221605	221605	388618
29773	49473	24	applied	\N	\N	\N	\N	221606	221606	388619
29773	49474	25	applied	\N	\N	\N	\N	221607	221607	388620
29773	49475	26	applied	\N	\N	\N	\N	221608	221608	388621
29773	49476	27	applied	\N	\N	\N	\N	221609	221609	388622
29773	49477	28	applied	\N	\N	\N	\N	221610	221610	388623
29773	49478	29	applied	\N	\N	\N	\N	221611	221611	388624
29773	49479	30	applied	\N	\N	\N	\N	221612	221612	388625
29775	49480	0	applied	\N	\N	\N	\N	221644	221644	388657
29775	49481	1	applied	\N	\N	\N	\N	221645	221645	388658
29775	49482	2	applied	\N	\N	\N	\N	221646	221646	388659
29775	49483	3	applied	\N	\N	\N	\N	221647	221647	388660
29775	49485	5	applied	\N	\N	\N	\N	221649	221649	388662
29775	49486	6	applied	\N	\N	\N	\N	221650	221650	388663
29775	49487	7	applied	\N	\N	\N	\N	221651	221651	388664
29775	49488	8	applied	\N	\N	\N	\N	221652	221652	388665
29775	49489	9	applied	\N	\N	\N	\N	221653	221653	388666
29775	49490	10	applied	\N	\N	\N	\N	221654	221654	388667
29775	49491	11	applied	\N	\N	\N	\N	221655	221655	388668
29775	49492	12	applied	\N	\N	\N	\N	221656	221656	388669
29775	49493	13	applied	\N	\N	\N	\N	221657	221657	388670
29775	49494	14	applied	\N	\N	\N	\N	221658	221658	388671
29775	49495	15	applied	\N	\N	\N	\N	221659	221659	388672
29775	49496	16	applied	\N	\N	\N	\N	221660	221660	388673
29775	49497	17	applied	\N	\N	\N	\N	221661	221661	388674
29775	49498	18	applied	\N	\N	\N	\N	221662	221662	388675
29775	49499	19	applied	\N	\N	\N	\N	221663	221663	388676
29775	49500	20	applied	\N	\N	\N	\N	221664	221664	388677
29775	49502	22	applied	\N	\N	\N	\N	221666	221666	388679
29775	49503	23	applied	\N	\N	\N	\N	221667	221667	388680
29775	49504	24	applied	\N	\N	\N	\N	221668	221668	388681
29775	49505	25	applied	\N	\N	\N	\N	221669	221669	388682
29775	49506	26	applied	\N	\N	\N	\N	221670	221670	388683
29775	49507	27	applied	\N	\N	\N	\N	221671	221671	388684
29778	49508	0	applied	\N	\N	\N	\N	221701	221701	388714
29778	49509	1	applied	\N	\N	\N	\N	221702	221702	388715
29778	49510	2	applied	\N	\N	\N	\N	221703	221703	388716
29778	49511	3	applied	\N	\N	\N	\N	221704	221704	388717
29778	49512	4	applied	\N	\N	\N	\N	221705	221705	388718
29778	49513	5	applied	\N	\N	\N	\N	221706	221706	388719
29778	49514	6	applied	\N	\N	\N	\N	221707	221707	388720
29778	49515	7	applied	\N	\N	\N	\N	221708	221708	388721
29757	49321	6	applied	\N	\N	\N	\N	221307	221307	388320
29757	49322	7	applied	\N	\N	\N	\N	221308	221308	388321
29759	49349	12	applied	\N	\N	\N	\N	221356	221356	388369
29759	49336	13	applied	\N	\N	\N	\N	221357	221357	388370
29759	49337	14	applied	\N	\N	\N	\N	221358	221358	388371
29759	49338	15	applied	\N	\N	\N	\N	221359	221359	388372
29759	49339	16	applied	\N	\N	\N	\N	221360	221360	388373
29759	49340	17	applied	\N	\N	\N	\N	221361	221361	388374
29759	49350	18	applied	\N	\N	\N	\N	221362	221362	388375
29759	49351	19	applied	\N	\N	\N	\N	221363	221363	388376
29759	49352	20	applied	\N	\N	\N	\N	221364	221364	388377
29759	49353	21	applied	\N	\N	\N	\N	221365	221365	388378
29759	49354	22	applied	\N	\N	\N	\N	221366	221366	388379
29760	49358	3	applied	\N	\N	\N	\N	221370	221370	388383
29760	49359	4	applied	\N	\N	\N	\N	221371	221371	388384
29760	49360	5	applied	\N	\N	\N	\N	221372	221372	388385
29760	49361	6	applied	\N	\N	\N	\N	221373	221373	388386
29760	49362	7	applied	\N	\N	\N	\N	221374	221374	388387
29760	49364	9	applied	\N	\N	\N	\N	221376	221376	388389
29760	49365	10	applied	\N	\N	\N	\N	221377	221377	388390
29760	49366	11	applied	\N	\N	\N	\N	221378	221378	388391
29760	49367	12	applied	\N	\N	\N	\N	221379	221379	388392
29760	49368	13	applied	\N	\N	\N	\N	221380	221380	388393
29761	49356	0	applied	\N	\N	\N	\N	221381	221381	388394
29761	49357	1	applied	\N	\N	\N	\N	221382	221382	388395
29761	49358	2	applied	\N	\N	\N	\N	221383	221383	388396
29761	49359	3	applied	\N	\N	\N	\N	221384	221384	388397
29761	49360	4	applied	\N	\N	\N	\N	221385	221385	388398
29761	49361	5	applied	\N	\N	\N	\N	221386	221386	388399
29761	49362	6	applied	\N	\N	\N	\N	221387	221387	388400
29761	49363	7	applied	\N	\N	\N	\N	221388	221388	388401
29761	49364	8	applied	\N	\N	\N	\N	221389	221389	388402
29761	49365	9	applied	\N	\N	\N	\N	221390	221390	388403
29761	49366	10	applied	\N	\N	\N	\N	221391	221391	388404
29762	49355	0	applied	\N	\N	\N	\N	221393	221393	388406
29762	49356	1	applied	\N	\N	\N	\N	221394	221394	388407
29762	49357	2	applied	\N	\N	\N	\N	221395	221395	388408
29762	49358	3	applied	\N	\N	\N	\N	221396	221396	388409
29762	49359	4	applied	\N	\N	\N	\N	221397	221397	388410
29762	49360	5	applied	\N	\N	\N	\N	221398	221398	388411
29762	49361	6	applied	\N	\N	\N	\N	221399	221399	388412
29762	49362	7	applied	\N	\N	\N	\N	221400	221400	388413
29762	49363	8	applied	\N	\N	\N	\N	221401	221401	388414
29762	49364	9	applied	\N	\N	\N	\N	221402	221402	388415
29762	49365	10	applied	\N	\N	\N	\N	221403	221403	388416
29763	49355	0	applied	\N	\N	\N	\N	221407	221407	388420
29763	49356	1	applied	\N	\N	\N	\N	221408	221408	388421
29763	49357	2	applied	\N	\N	\N	\N	221409	221409	388422
29763	49358	3	applied	\N	\N	\N	\N	221410	221410	388423
29763	49359	4	applied	\N	\N	\N	\N	221411	221411	388424
29763	49364	6	applied	\N	\N	\N	\N	221413	221413	388426
29763	49365	7	applied	\N	\N	\N	\N	221414	221414	388427
29763	49366	8	applied	\N	\N	\N	\N	221415	221415	388428
29763	49367	9	applied	\N	\N	\N	\N	221416	221416	388429
29763	49368	10	applied	\N	\N	\N	\N	221417	221417	388430
29770	49424	0	applied	\N	\N	\N	\N	221509	221509	388522
29770	49425	1	applied	\N	\N	\N	\N	221510	221510	388523
29770	49426	2	applied	\N	\N	\N	\N	221511	221511	388524
29770	49427	3	applied	\N	\N	\N	\N	221512	221512	388525
29770	49428	4	applied	\N	\N	\N	\N	221513	221513	388526
29770	49429	5	applied	\N	\N	\N	\N	221514	221514	388527
29770	49430	7	applied	\N	\N	\N	\N	221515	221515	388528
29770	49431	8	applied	\N	\N	\N	\N	221516	221516	388529
29770	49409	9	applied	\N	\N	\N	\N	221517	221517	388530
29770	49410	10	applied	\N	\N	\N	\N	221518	221518	388531
29770	49432	11	applied	\N	\N	\N	\N	221519	221519	388532
29770	49434	13	applied	\N	\N	\N	\N	221521	221521	388534
29770	49435	14	applied	\N	\N	\N	\N	221522	221522	388535
29770	49436	15	applied	\N	\N	\N	\N	221523	221523	388536
29770	49437	16	applied	\N	\N	\N	\N	221524	221524	388537
29770	49438	17	applied	\N	\N	\N	\N	221525	221525	388538
29770	49439	18	applied	\N	\N	\N	\N	221526	221526	388539
29770	49440	19	applied	\N	\N	\N	\N	221527	221527	388540
29770	49441	20	applied	\N	\N	\N	\N	221528	221528	388541
29770	49442	21	applied	\N	\N	\N	\N	221529	221529	388542
29770	49443	22	applied	\N	\N	\N	\N	221530	221530	388543
29770	49444	23	applied	\N	\N	\N	\N	221531	221531	388544
29770	49445	24	applied	\N	\N	\N	\N	221532	221532	388545
29770	49446	25	applied	\N	\N	\N	\N	221533	221533	388546
29770	49447	26	applied	\N	\N	\N	\N	221534	221534	388547
29770	49448	27	applied	\N	\N	\N	\N	221535	221535	388548
29772	49449	0	applied	\N	\N	\N	\N	221551	221551	388564
29772	49451	2	applied	\N	\N	\N	\N	221553	221553	388566
29772	49452	3	applied	\N	\N	\N	\N	221554	221554	388567
29772	49453	4	applied	\N	\N	\N	\N	221555	221555	388568
29772	49454	5	applied	\N	\N	\N	\N	221556	221556	388569
29772	49455	6	applied	\N	\N	\N	\N	221557	221557	388570
29772	49456	7	applied	\N	\N	\N	\N	221558	221558	388571
29772	49457	8	applied	\N	\N	\N	\N	221559	221559	388572
29772	49458	9	applied	\N	\N	\N	\N	221560	221560	388573
29772	49459	10	applied	\N	\N	\N	\N	221561	221561	388574
29772	49460	11	applied	\N	\N	\N	\N	221562	221562	388575
29772	49461	12	applied	\N	\N	\N	\N	221563	221563	388576
29772	49462	13	applied	\N	\N	\N	\N	221564	221564	388577
29772	49463	14	applied	\N	\N	\N	\N	221565	221565	388578
29772	49464	15	applied	\N	\N	\N	\N	221566	221566	388579
29772	49465	16	applied	\N	\N	\N	\N	221567	221567	388580
29772	49466	17	applied	\N	\N	\N	\N	221568	221568	388581
29772	49468	19	applied	\N	\N	\N	\N	221570	221570	388583
29772	49469	20	applied	\N	\N	\N	\N	221571	221571	388584
29772	49470	21	applied	\N	\N	\N	\N	221572	221572	388585
29772	49471	22	applied	\N	\N	\N	\N	221573	221573	388586
29772	49472	23	applied	\N	\N	\N	\N	221574	221574	388587
29772	49473	24	applied	\N	\N	\N	\N	221575	221575	388588
29772	49474	25	applied	\N	\N	\N	\N	221576	221576	388589
29772	49475	26	applied	\N	\N	\N	\N	221577	221577	388590
29772	49476	27	applied	\N	\N	\N	\N	221578	221578	388591
29772	49477	28	applied	\N	\N	\N	\N	221579	221579	388592
29772	49478	29	applied	\N	\N	\N	\N	221580	221580	388593
29772	49479	30	applied	\N	\N	\N	\N	221581	221581	388594
29780	49508	0	applied	\N	\N	\N	\N	221729	221729	388742
29780	49509	1	applied	\N	\N	\N	\N	221730	221730	388743
29759	49334	9	applied	\N	\N	\N	\N	221353	221353	388366
29759	49335	10	applied	\N	\N	\N	\N	221354	221354	388367
29764	49370	1	applied	\N	\N	\N	\N	221419	221419	388432
29764	49371	2	applied	\N	\N	\N	\N	221420	221420	388433
29764	49372	3	applied	\N	\N	\N	\N	221421	221421	388434
29764	49373	4	applied	\N	\N	\N	\N	221422	221422	388435
29764	49374	5	applied	\N	\N	\N	\N	221423	221423	388436
29764	49375	6	applied	\N	\N	\N	\N	221424	221424	388437
29764	49376	7	applied	\N	\N	\N	\N	221425	221425	388438
29764	49377	8	applied	\N	\N	\N	\N	221426	221426	388439
29764	49378	9	applied	\N	\N	\N	\N	221427	221427	388440
29764	49379	10	applied	\N	\N	\N	\N	221428	221428	388441
29766	49392	0	applied	\N	\N	\N	\N	221441	221441	388454
29766	49393	1	applied	\N	\N	\N	\N	221442	221442	388455
29766	49394	2	applied	\N	\N	\N	\N	221443	221443	388456
29766	49395	3	applied	\N	\N	\N	\N	221444	221444	388457
29766	49396	4	applied	\N	\N	\N	\N	221445	221445	388458
29766	49397	5	applied	\N	\N	\N	\N	221446	221446	388459
29766	49399	7	applied	\N	\N	\N	\N	221448	221448	388461
29766	49400	8	applied	\N	\N	\N	\N	221449	221449	388462
29766	49401	9	applied	\N	\N	\N	\N	221450	221450	388463
29766	49402	10	applied	\N	\N	\N	\N	221451	221451	388464
29766	49403	11	applied	\N	\N	\N	\N	221452	221452	388465
29766	49404	12	applied	\N	\N	\N	\N	221453	221453	388466
29769	49422	15	applied	\N	\N	\N	\N	221507	221507	388520
29769	49423	16	applied	\N	\N	\N	\N	221508	221508	388521
29771	49424	0	applied	\N	\N	\N	\N	221536	221536	388549
29771	49425	1	applied	\N	\N	\N	\N	221537	221537	388550
29771	49409	2	applied	\N	\N	\N	\N	221538	221538	388551
29771	49410	3	applied	\N	\N	\N	\N	221539	221539	388552
29771	49435	4	applied	\N	\N	\N	\N	221540	221540	388553
29771	49439	5	applied	\N	\N	\N	\N	221541	221541	388554
29771	49440	7	applied	\N	\N	\N	\N	221542	221542	388555
29771	49441	8	applied	\N	\N	\N	\N	221543	221543	388556
29771	49443	10	applied	\N	\N	\N	\N	221545	221545	388558
29771	49444	11	applied	\N	\N	\N	\N	221546	221546	388559
29771	49445	12	applied	\N	\N	\N	\N	221547	221547	388560
29771	49446	13	applied	\N	\N	\N	\N	221548	221548	388561
29771	49447	14	applied	\N	\N	\N	\N	221549	221549	388562
29771	49448	15	applied	\N	\N	\N	\N	221550	221550	388563
29774	49449	0	applied	\N	\N	\N	\N	221613	221613	388626
29774	49450	1	applied	\N	\N	\N	\N	221614	221614	388627
29774	49451	2	applied	\N	\N	\N	\N	221615	221615	388628
29774	49452	3	applied	\N	\N	\N	\N	221616	221616	388629
29774	49453	4	applied	\N	\N	\N	\N	221617	221617	388630
29774	49454	5	applied	\N	\N	\N	\N	221618	221618	388631
29774	49455	6	applied	\N	\N	\N	\N	221619	221619	388632
29774	49456	7	applied	\N	\N	\N	\N	221620	221620	388633
29774	49457	8	applied	\N	\N	\N	\N	221621	221621	388634
29774	49458	9	applied	\N	\N	\N	\N	221622	221622	388635
29774	49460	11	applied	\N	\N	\N	\N	221624	221624	388637
29774	49461	12	applied	\N	\N	\N	\N	221625	221625	388638
29774	49462	13	applied	\N	\N	\N	\N	221626	221626	388639
29774	49463	14	applied	\N	\N	\N	\N	221627	221627	388640
29774	49464	15	applied	\N	\N	\N	\N	221628	221628	388641
29774	49465	16	applied	\N	\N	\N	\N	221629	221629	388642
29774	49466	17	applied	\N	\N	\N	\N	221630	221630	388643
29774	49467	18	applied	\N	\N	\N	\N	221631	221631	388644
29774	49468	19	applied	\N	\N	\N	\N	221632	221632	388645
29774	49469	20	applied	\N	\N	\N	\N	221633	221633	388646
29774	49470	21	applied	\N	\N	\N	\N	221634	221634	388647
29774	49471	22	applied	\N	\N	\N	\N	221635	221635	388648
29774	49472	23	applied	\N	\N	\N	\N	221636	221636	388649
29774	49473	24	applied	\N	\N	\N	\N	221637	221637	388650
29774	49474	25	applied	\N	\N	\N	\N	221638	221638	388651
29774	49475	26	applied	\N	\N	\N	\N	221639	221639	388652
29774	49477	28	applied	\N	\N	\N	\N	221641	221641	388654
29774	49478	29	applied	\N	\N	\N	\N	221642	221642	388655
29774	49479	30	applied	\N	\N	\N	\N	221643	221643	388656
29776	49508	0	applied	\N	\N	\N	\N	221672	221672	388685
29776	49509	1	applied	\N	\N	\N	\N	221673	221673	388686
29776	49510	2	applied	\N	\N	\N	\N	221674	221674	388687
29776	49511	3	applied	\N	\N	\N	\N	221675	221675	388688
29776	49512	4	applied	\N	\N	\N	\N	221676	221676	388689
29776	49513	5	applied	\N	\N	\N	\N	221677	221677	388690
29776	49514	6	applied	\N	\N	\N	\N	221678	221678	388691
29776	49515	7	applied	\N	\N	\N	\N	221679	221679	388692
29776	49516	8	applied	\N	\N	\N	\N	221680	221680	388693
29776	49517	9	applied	\N	\N	\N	\N	221681	221681	388694
29776	49518	10	applied	\N	\N	\N	\N	221682	221682	388695
29776	49519	11	applied	\N	\N	\N	\N	221683	221683	388696
29776	49520	12	applied	\N	\N	\N	\N	221684	221684	388697
29777	49508	0	applied	\N	\N	\N	\N	221686	221686	388699
29777	49509	1	applied	\N	\N	\N	\N	221687	221687	388700
29777	49510	2	applied	\N	\N	\N	\N	221688	221688	388701
29777	49511	3	applied	\N	\N	\N	\N	221689	221689	388702
29777	49512	4	applied	\N	\N	\N	\N	221690	221690	388703
29782	49541	0	applied	\N	\N	\N	\N	221764	221764	388777
29782	49542	1	applied	\N	\N	\N	\N	221765	221765	388778
29782	49543	3	applied	\N	\N	\N	\N	221766	221766	388779
29782	49544	4	applied	\N	\N	\N	\N	221767	221767	388780
29782	49545	5	applied	\N	\N	\N	\N	221768	221768	388781
29782	49546	6	applied	\N	\N	\N	\N	221769	221769	388782
29782	49547	7	applied	\N	\N	\N	\N	221770	221770	388783
29782	49548	8	applied	\N	\N	\N	\N	221771	221771	388784
29782	49549	9	applied	\N	\N	\N	\N	221772	221772	388785
29782	49550	10	applied	\N	\N	\N	\N	221773	221773	388786
29782	49551	11	applied	\N	\N	\N	\N	221774	221774	388787
29784	49541	0	applied	\N	\N	\N	\N	221849	221849	388862
29784	49542	1	applied	\N	\N	\N	\N	221850	221850	388863
29784	49543	3	applied	\N	\N	\N	\N	221851	221851	388864
29784	49544	4	applied	\N	\N	\N	\N	221852	221852	388865
29784	49545	5	applied	\N	\N	\N	\N	221853	221853	388866
29784	49546	6	applied	\N	\N	\N	\N	221854	221854	388867
29784	49547	7	applied	\N	\N	\N	\N	221855	221855	388868
29784	49548	8	applied	\N	\N	\N	\N	221856	221856	388869
29784	49549	9	applied	\N	\N	\N	\N	221857	221857	388870
29784	49550	10	applied	\N	\N	\N	\N	221858	221858	388871
29784	49551	11	applied	\N	\N	\N	\N	221859	221859	388872
29784	49552	12	applied	\N	\N	\N	\N	221860	221860	388873
29793	49595	0	applied	\N	\N	\N	\N	222011	222011	389024
29793	49596	1	applied	\N	\N	\N	\N	222012	222012	389025
29762	49367	12	applied	\N	\N	\N	\N	221405	221405	388418
29762	49368	13	applied	\N	\N	\N	\N	221406	221406	388419
29777	49517	9	applied	\N	\N	\N	\N	221695	221695	388708
29777	49518	10	applied	\N	\N	\N	\N	221696	221696	388709
29777	49519	11	applied	\N	\N	\N	\N	221697	221697	388710
29777	49520	12	applied	\N	\N	\N	\N	221698	221698	388711
29777	49521	13	applied	\N	\N	\N	\N	221699	221699	388712
29777	49522	14	applied	\N	\N	\N	\N	221700	221700	388713
29778	49516	8	applied	\N	\N	\N	\N	221709	221709	388722
29778	49517	9	applied	\N	\N	\N	\N	221710	221710	388723
29778	49518	10	applied	\N	\N	\N	\N	221711	221711	388724
29778	49519	11	applied	\N	\N	\N	\N	221712	221712	388725
29778	49520	12	applied	\N	\N	\N	\N	221713	221713	388726
29778	49521	13	applied	\N	\N	\N	\N	221714	221714	388727
29778	49522	14	applied	\N	\N	\N	\N	221715	221715	388728
29779	49508	0	applied	\N	\N	\N	\N	221716	221716	388729
29779	49509	1	applied	\N	\N	\N	\N	221717	221717	388730
29779	49510	2	applied	\N	\N	\N	\N	221718	221718	388731
29779	49512	4	applied	\N	\N	\N	\N	221720	221720	388733
29779	49513	5	applied	\N	\N	\N	\N	221721	221721	388734
29779	49514	6	applied	\N	\N	\N	\N	221722	221722	388735
29779	49515	7	applied	\N	\N	\N	\N	221723	221723	388736
29779	49516	8	applied	\N	\N	\N	\N	221724	221724	388737
29779	49517	9	applied	\N	\N	\N	\N	221725	221725	388738
29779	49518	10	applied	\N	\N	\N	\N	221726	221726	388739
29779	49519	11	applied	\N	\N	\N	\N	221727	221727	388740
29779	49521	12	applied	\N	\N	\N	\N	221728	221728	388741
29781	49523	0	applied	\N	\N	\N	\N	221744	221744	388757
29781	49524	1	applied	\N	\N	\N	\N	221745	221745	388758
29781	49525	2	applied	\N	\N	\N	\N	221746	221746	388759
29781	49520	3	applied	\N	\N	\N	\N	221747	221747	388760
29781	49526	4	applied	\N	\N	\N	\N	221748	221748	388761
29781	49527	5	applied	\N	\N	\N	\N	221749	221749	388762
29781	49522	6	applied	\N	\N	\N	\N	221750	221750	388763
29781	49529	8	applied	\N	\N	\N	\N	221752	221752	388765
29781	49530	9	applied	\N	\N	\N	\N	221753	221753	388766
29781	49531	10	applied	\N	\N	\N	\N	221754	221754	388767
29781	49532	11	applied	\N	\N	\N	\N	221755	221755	388768
29781	49533	12	applied	\N	\N	\N	\N	221756	221756	388769
29781	49534	13	applied	\N	\N	\N	\N	221757	221757	388770
29781	49535	14	applied	\N	\N	\N	\N	221758	221758	388771
29781	49536	15	applied	\N	\N	\N	\N	221759	221759	388772
29781	49537	16	applied	\N	\N	\N	\N	221760	221760	388773
29781	49538	17	applied	\N	\N	\N	\N	221761	221761	388774
29781	49539	18	applied	\N	\N	\N	\N	221762	221762	388775
29781	49540	19	applied	\N	\N	\N	\N	221763	221763	388776
29783	49317	0	applied	\N	\N	\N	\N	221776	221776	388789
29783	49318	2	applied	\N	\N	\N	\N	221777	221777	388790
29783	49341	3	applied	\N	\N	\N	\N	221778	221778	388791
29783	49355	4	applied	\N	\N	\N	\N	221779	221779	388792
29783	49392	6	applied	\N	\N	\N	\N	221781	221781	388794
29783	49405	7	applied	\N	\N	\N	\N	221782	221782	388795
29783	49406	8	applied	\N	\N	\N	\N	221783	221783	388796
29783	49424	9	applied	\N	\N	\N	\N	221784	221784	388797
29783	49425	10	applied	\N	\N	\N	\N	221785	221785	388798
29783	49449	11	applied	\N	\N	\N	\N	221786	221786	388799
29783	49450	12	applied	\N	\N	\N	\N	221787	221787	388800
29783	49480	13	applied	\N	\N	\N	\N	221788	221788	388801
29783	49481	14	applied	\N	\N	\N	\N	221789	221789	388802
29783	49508	15	applied	\N	\N	\N	\N	221790	221790	388803
29783	49523	16	applied	\N	\N	\N	\N	221791	221791	388804
29783	49524	17	applied	\N	\N	\N	\N	221792	221792	388805
29783	49541	18	applied	\N	\N	\N	\N	221793	221793	388806
29783	49319	19	applied	\N	\N	\N	\N	221794	221794	388807
29783	49332	20	applied	\N	\N	\N	\N	221795	221795	388808
29783	49320	21	applied	\N	\N	\N	\N	221796	221796	388809
29783	49329	23	applied	\N	\N	\N	\N	221798	221798	388811
29783	49336	24	applied	\N	\N	\N	\N	221799	221799	388812
29783	49337	25	applied	\N	\N	\N	\N	221800	221800	388813
29783	49338	26	applied	\N	\N	\N	\N	221801	221801	388814
29783	49339	27	applied	\N	\N	\N	\N	221802	221802	388815
29783	49340	28	applied	\N	\N	\N	\N	221803	221803	388816
29783	49350	29	applied	\N	\N	\N	\N	221804	221804	388817
29783	49351	30	applied	\N	\N	\N	\N	221805	221805	388818
29783	49352	31	applied	\N	\N	\N	\N	221806	221806	388819
29783	49360	32	applied	\N	\N	\N	\N	221807	221807	388820
29783	49361	33	applied	\N	\N	\N	\N	221808	221808	388821
29783	49362	34	applied	\N	\N	\N	\N	221809	221809	388822
29783	49372	35	applied	\N	\N	\N	\N	221810	221810	388823
29783	49374	36	applied	\N	\N	\N	\N	221811	221811	388824
29783	49390	37	applied	\N	\N	\N	\N	221812	221812	388825
29783	49391	38	applied	\N	\N	\N	\N	221813	221813	388826
29783	49398	40	applied	\N	\N	\N	\N	221815	221815	388828
29783	49399	41	applied	\N	\N	\N	\N	221816	221816	388829
29783	49408	42	applied	\N	\N	\N	\N	221817	221817	388830
29783	49414	43	applied	\N	\N	\N	\N	221818	221818	388831
29783	49415	44	applied	\N	\N	\N	\N	221819	221819	388832
29783	49422	45	applied	\N	\N	\N	\N	221820	221820	388833
29783	49423	46	applied	\N	\N	\N	\N	221821	221821	388834
29783	49426	47	applied	\N	\N	\N	\N	221822	221822	388835
29783	49430	48	applied	\N	\N	\N	\N	221823	221823	388836
29783	49431	49	applied	\N	\N	\N	\N	221824	221824	388837
29783	49432	50	applied	\N	\N	\N	\N	221825	221825	388838
29783	49433	51	applied	\N	\N	\N	\N	221826	221826	388839
29783	49434	52	applied	\N	\N	\N	\N	221827	221827	388840
29783	49459	53	applied	\N	\N	\N	\N	221828	221828	388841
29783	49470	54	applied	\N	\N	\N	\N	221829	221829	388842
29783	49471	55	applied	\N	\N	\N	\N	221830	221830	388843
29783	49475	57	applied	\N	\N	\N	\N	221832	221832	388845
29783	49476	58	applied	\N	\N	\N	\N	221833	221833	388846
29783	49493	59	applied	\N	\N	\N	\N	221834	221834	388847
29783	49494	60	applied	\N	\N	\N	\N	221835	221835	388848
29783	49495	61	applied	\N	\N	\N	\N	221836	221836	388849
29783	49496	62	applied	\N	\N	\N	\N	221837	221837	388850
29783	49497	63	applied	\N	\N	\N	\N	221838	221838	388851
29783	49509	64	applied	\N	\N	\N	\N	221839	221839	388852
29783	49510	65	applied	\N	\N	\N	\N	221840	221840	388853
29783	49525	66	applied	\N	\N	\N	\N	221841	221841	388854
29783	49535	67	applied	\N	\N	\N	\N	221842	221842	388855
29783	49536	68	applied	\N	\N	\N	\N	221843	221843	388856
29787	49553	0	applied	\N	\N	\N	\N	221919	221919	388932
29787	49554	1	applied	\N	\N	\N	\N	221920	221920	388933
29777	49514	6	applied	\N	\N	\N	\N	221692	221692	388705
29777	49515	7	applied	\N	\N	\N	\N	221693	221693	388706
29780	49514	6	applied	\N	\N	\N	\N	221735	221735	388748
29780	49515	7	applied	\N	\N	\N	\N	221736	221736	388749
29780	49516	8	applied	\N	\N	\N	\N	221737	221737	388750
29780	49517	9	applied	\N	\N	\N	\N	221738	221738	388751
29780	49518	10	applied	\N	\N	\N	\N	221739	221739	388752
29780	49519	11	applied	\N	\N	\N	\N	221740	221740	388753
29780	49520	12	applied	\N	\N	\N	\N	221741	221741	388754
29780	49521	13	applied	\N	\N	\N	\N	221742	221742	388755
29780	49522	14	applied	\N	\N	\N	\N	221743	221743	388756
29786	49553	0	applied	\N	\N	\N	\N	221890	221890	388903
29786	49554	1	applied	\N	\N	\N	\N	221891	221891	388904
29786	49555	2	applied	\N	\N	\N	\N	221892	221892	388905
29786	49556	3	applied	\N	\N	\N	\N	221893	221893	388906
29786	49557	4	applied	\N	\N	\N	\N	221894	221894	388907
29786	49558	5	applied	\N	\N	\N	\N	221895	221895	388908
29786	49559	6	applied	\N	\N	\N	\N	221896	221896	388909
29786	49561	8	applied	\N	\N	\N	\N	221898	221898	388911
29787	49555	2	applied	\N	\N	\N	\N	221921	221921	388934
29787	49556	3	applied	\N	\N	\N	\N	221922	221922	388935
29787	49557	4	applied	\N	\N	\N	\N	221923	221923	388936
29787	49558	5	applied	\N	\N	\N	\N	221924	221924	388937
29787	49559	6	applied	\N	\N	\N	\N	221925	221925	388938
29787	49560	7	applied	\N	\N	\N	\N	221926	221926	388939
29787	49561	8	applied	\N	\N	\N	\N	221927	221927	388940
29787	49562	9	applied	\N	\N	\N	\N	221928	221928	388941
29787	49563	10	applied	\N	\N	\N	\N	221929	221929	388942
29787	49564	11	applied	\N	\N	\N	\N	221930	221930	388943
29787	49565	12	applied	\N	\N	\N	\N	221931	221931	388944
29787	49566	13	applied	\N	\N	\N	\N	221932	221932	388945
29787	49567	14	applied	\N	\N	\N	\N	221933	221933	388946
29787	49568	15	applied	\N	\N	\N	\N	221934	221934	388947
29787	49569	16	applied	\N	\N	\N	\N	221935	221935	388948
29787	49571	18	applied	\N	\N	\N	\N	221937	221937	388950
29787	49572	19	applied	\N	\N	\N	\N	221938	221938	388951
29787	49573	20	applied	\N	\N	\N	\N	221939	221939	388952
29787	49574	21	applied	\N	\N	\N	\N	221940	221940	388953
29787	49575	22	applied	\N	\N	\N	\N	221941	221941	388954
29787	49576	23	applied	\N	\N	\N	\N	221942	221942	388955
29787	49577	24	applied	\N	\N	\N	\N	221943	221943	388956
29787	49578	25	applied	\N	\N	\N	\N	221944	221944	388957
29787	49579	26	applied	\N	\N	\N	\N	221945	221945	388958
29787	49580	27	applied	\N	\N	\N	\N	221946	221946	388959
29787	49581	28	applied	\N	\N	\N	\N	221947	221947	388960
29791	49582	0	applied	\N	\N	\N	\N	221985	221985	388998
29791	49583	1	applied	\N	\N	\N	\N	221986	221986	388999
29791	49584	2	applied	\N	\N	\N	\N	221987	221987	389000
29791	49585	3	applied	\N	\N	\N	\N	221988	221988	389001
29791	49586	4	applied	\N	\N	\N	\N	221989	221989	389002
29791	49588	6	applied	\N	\N	\N	\N	221991	221991	389004
29791	49589	7	applied	\N	\N	\N	\N	221992	221992	389005
29791	49590	8	applied	\N	\N	\N	\N	221993	221993	389006
29791	49591	9	applied	\N	\N	\N	\N	221994	221994	389007
29791	49592	10	applied	\N	\N	\N	\N	221995	221995	389008
29791	49593	11	applied	\N	\N	\N	\N	221996	221996	389009
29791	49594	12	applied	\N	\N	\N	\N	221997	221997	389010
29796	49595	0	applied	\N	\N	\N	\N	222047	222047	389060
29796	49596	1	applied	\N	\N	\N	\N	222048	222048	389061
29796	49597	2	applied	\N	\N	\N	\N	222049	222049	389062
29796	49598	3	applied	\N	\N	\N	\N	222050	222050	389063
29796	49599	4	applied	\N	\N	\N	\N	222051	222051	389064
29796	49602	5	applied	\N	\N	\N	\N	222052	222052	389065
29796	49603	6	applied	\N	\N	\N	\N	222053	222053	389066
29796	49604	7	applied	\N	\N	\N	\N	222054	222054	389067
29796	49605	8	applied	\N	\N	\N	\N	222055	222055	389068
29798	49668	1	applied	\N	\N	\N	\N	222117	222117	389130
29798	49669	2	applied	\N	\N	\N	\N	222118	222118	389131
29798	49670	3	applied	\N	\N	\N	\N	222119	222119	389132
29798	49671	4	applied	\N	\N	\N	\N	222120	222120	389133
29798	49672	5	applied	\N	\N	\N	\N	222121	222121	389134
29798	49673	6	applied	\N	\N	\N	\N	222122	222122	389135
29798	49674	7	applied	\N	\N	\N	\N	222123	222123	389136
29798	49675	8	applied	\N	\N	\N	\N	222124	222124	389137
29808	49720	0	applied	\N	\N	\N	\N	222298	222298	389311
29808	49721	1	applied	\N	\N	\N	\N	222299	222299	389312
29808	49722	2	applied	\N	\N	\N	\N	222300	222300	389313
29808	49723	3	applied	\N	\N	\N	\N	222301	222301	389314
29808	49724	4	applied	\N	\N	\N	\N	222302	222302	389315
29814	49725	0	applied	\N	\N	\N	\N	222441	222441	389454
29814	49726	1	applied	\N	\N	\N	\N	222442	222442	389455
29814	49727	2	applied	\N	\N	\N	\N	222443	222443	389456
29814	49729	4	applied	\N	\N	\N	\N	222445	222445	389458
29814	49730	5	applied	\N	\N	\N	\N	222446	222446	389459
29814	49731	6	applied	\N	\N	\N	\N	222447	222447	389460
29814	49732	7	applied	\N	\N	\N	\N	222448	222448	389461
29814	49733	8	applied	\N	\N	\N	\N	222449	222449	389462
29814	49734	9	applied	\N	\N	\N	\N	222450	222450	389463
29814	49735	10	applied	\N	\N	\N	\N	222451	222451	389464
29816	49725	0	applied	\N	\N	\N	\N	222470	222470	389483
29816	49726	1	applied	\N	\N	\N	\N	222471	222471	389484
29816	49736	2	applied	\N	\N	\N	\N	222472	222472	389485
29816	49727	3	applied	\N	\N	\N	\N	222473	222473	389486
29816	49737	4	applied	\N	\N	\N	\N	222474	222474	389487
29816	49740	5	applied	\N	\N	\N	\N	222475	222475	389488
29816	49741	6	applied	\N	\N	\N	\N	222476	222476	389489
29816	49728	7	applied	\N	\N	\N	\N	222477	222477	389490
29816	49729	8	applied	\N	\N	\N	\N	222478	222478	389491
29816	49731	10	applied	\N	\N	\N	\N	222480	222480	389493
29816	49732	11	applied	\N	\N	\N	\N	222481	222481	389494
29816	49733	12	applied	\N	\N	\N	\N	222482	222482	389495
29816	49742	13	applied	\N	\N	\N	\N	222483	222483	389496
29816	49743	14	applied	\N	\N	\N	\N	222484	222484	389497
29816	49744	15	applied	\N	\N	\N	\N	222485	222485	389498
29816	49745	16	applied	\N	\N	\N	\N	222486	222486	389499
29816	49746	17	applied	\N	\N	\N	\N	222487	222487	389500
29816	49747	18	applied	\N	\N	\N	\N	222488	222488	389501
29816	49748	19	applied	\N	\N	\N	\N	222489	222489	389502
29816	49749	20	applied	\N	\N	\N	\N	222490	222490	389503
29816	49750	21	applied	\N	\N	\N	\N	222491	222491	389504
29816	49751	22	applied	\N	\N	\N	\N	222492	222492	389505
29816	49734	23	applied	\N	\N	\N	\N	222493	222493	389506
29780	49511	3	applied	\N	\N	\N	\N	221732	221732	388745
29780	49512	4	applied	\N	\N	\N	\N	221733	221733	388746
29783	49549	73	applied	\N	\N	\N	\N	221848	221848	388861
29785	49553	0	applied	\N	\N	\N	\N	221861	221861	388874
29785	49554	1	applied	\N	\N	\N	\N	221862	221862	388875
29785	49555	2	applied	\N	\N	\N	\N	221863	221863	388876
29785	49556	3	applied	\N	\N	\N	\N	221864	221864	388877
29785	49557	4	applied	\N	\N	\N	\N	221865	221865	388878
29785	49558	5	applied	\N	\N	\N	\N	221866	221866	388879
29785	49559	6	applied	\N	\N	\N	\N	221867	221867	388880
29785	49560	7	applied	\N	\N	\N	\N	221868	221868	388881
29785	49561	8	applied	\N	\N	\N	\N	221869	221869	388882
29785	49562	9	applied	\N	\N	\N	\N	221870	221870	388883
29785	49563	10	applied	\N	\N	\N	\N	221871	221871	388884
29785	49564	11	applied	\N	\N	\N	\N	221872	221872	388885
29785	49565	12	applied	\N	\N	\N	\N	221873	221873	388886
29785	49566	13	applied	\N	\N	\N	\N	221874	221874	388887
29785	49567	14	applied	\N	\N	\N	\N	221875	221875	388888
29785	49569	16	applied	\N	\N	\N	\N	221877	221877	388890
29786	49562	9	applied	\N	\N	\N	\N	221899	221899	388912
29786	49563	10	applied	\N	\N	\N	\N	221900	221900	388913
29786	49564	11	applied	\N	\N	\N	\N	221901	221901	388914
29786	49565	12	applied	\N	\N	\N	\N	221902	221902	388915
29786	49566	13	applied	\N	\N	\N	\N	221903	221903	388916
29786	49567	14	applied	\N	\N	\N	\N	221904	221904	388917
29786	49568	15	applied	\N	\N	\N	\N	221905	221905	388918
29786	49569	16	applied	\N	\N	\N	\N	221906	221906	388919
29786	49570	17	applied	\N	\N	\N	\N	221907	221907	388920
29786	49571	18	applied	\N	\N	\N	\N	221908	221908	388921
29786	49572	19	applied	\N	\N	\N	\N	221909	221909	388922
29786	49573	20	applied	\N	\N	\N	\N	221910	221910	388923
29786	49574	21	applied	\N	\N	\N	\N	221911	221911	388924
29786	49575	22	applied	\N	\N	\N	\N	221912	221912	388925
29786	49576	23	applied	\N	\N	\N	\N	221913	221913	388926
29786	49578	25	applied	\N	\N	\N	\N	221915	221915	388928
29786	49579	26	applied	\N	\N	\N	\N	221916	221916	388929
29786	49580	27	applied	\N	\N	\N	\N	221917	221917	388930
29786	49581	28	applied	\N	\N	\N	\N	221918	221918	388931
29789	49553	0	applied	\N	\N	\N	\N	221956	221956	388969
29789	49554	1	applied	\N	\N	\N	\N	221957	221957	388970
29789	49555	2	applied	\N	\N	\N	\N	221958	221958	388971
29789	49556	3	applied	\N	\N	\N	\N	221959	221959	388972
29789	49557	4	applied	\N	\N	\N	\N	221960	221960	388973
29789	49558	5	applied	\N	\N	\N	\N	221961	221961	388974
29789	49559	6	applied	\N	\N	\N	\N	221962	221962	388975
29789	49560	7	applied	\N	\N	\N	\N	221963	221963	388976
29789	49561	8	applied	\N	\N	\N	\N	221964	221964	388977
29789	49562	9	applied	\N	\N	\N	\N	221965	221965	388978
29789	49563	10	applied	\N	\N	\N	\N	221966	221966	388979
29789	49564	11	applied	\N	\N	\N	\N	221967	221967	388980
29789	49566	13	applied	\N	\N	\N	\N	221969	221969	388982
29789	49567	14	applied	\N	\N	\N	\N	221970	221970	388983
29789	49568	15	applied	\N	\N	\N	\N	221971	221971	388984
29789	49569	16	applied	\N	\N	\N	\N	221972	221972	388985
29789	49570	17	applied	\N	\N	\N	\N	221973	221973	388986
29789	49571	18	applied	\N	\N	\N	\N	221974	221974	388987
29789	49572	19	applied	\N	\N	\N	\N	221975	221975	388988
29789	49573	20	applied	\N	\N	\N	\N	221976	221976	388989
29789	49574	21	applied	\N	\N	\N	\N	221977	221977	388990
29789	49575	22	applied	\N	\N	\N	\N	221978	221978	388991
29789	49576	23	applied	\N	\N	\N	\N	221979	221979	388992
29789	49577	24	applied	\N	\N	\N	\N	221980	221980	388993
29789	49578	25	applied	\N	\N	\N	\N	221981	221981	388994
29789	49579	26	applied	\N	\N	\N	\N	221982	221982	388995
29789	49580	27	applied	\N	\N	\N	\N	221983	221983	388996
29789	49581	28	applied	\N	\N	\N	\N	221984	221984	388997
29792	49583	1	applied	\N	\N	\N	\N	221999	221999	389012
29792	49584	2	applied	\N	\N	\N	\N	222000	222000	389013
29792	49585	3	applied	\N	\N	\N	\N	222001	222001	389014
29792	49586	4	applied	\N	\N	\N	\N	222002	222002	389015
29792	49587	5	applied	\N	\N	\N	\N	222003	222003	389016
29792	49588	6	applied	\N	\N	\N	\N	222004	222004	389017
29792	49589	7	applied	\N	\N	\N	\N	222005	222005	389018
29792	49590	8	applied	\N	\N	\N	\N	222006	222006	389019
29792	49591	9	applied	\N	\N	\N	\N	222007	222007	389020
29792	49592	10	applied	\N	\N	\N	\N	222008	222008	389021
29792	49593	11	applied	\N	\N	\N	\N	222009	222009	389022
29792	49594	12	applied	\N	\N	\N	\N	222010	222010	389023
29799	49667	0	applied	\N	\N	\N	\N	222125	222125	389138
29799	49668	1	applied	\N	\N	\N	\N	222126	222126	389139
29799	49669	2	applied	\N	\N	\N	\N	222127	222127	389140
29799	49670	3	applied	\N	\N	\N	\N	222128	222128	389141
29799	49672	5	applied	\N	\N	\N	\N	222130	222130	389143
29799	49673	6	applied	\N	\N	\N	\N	222131	222131	389144
29799	49674	7	applied	\N	\N	\N	\N	222132	222132	389145
29804	49705	0	applied	\N	\N	\N	\N	222276	222276	389289
29804	49706	1	applied	\N	\N	\N	\N	222277	222277	389290
29804	49707	2	applied	\N	\N	\N	\N	222278	222278	389291
29804	49708	3	applied	\N	\N	\N	\N	222279	222279	389292
29804	49709	4	applied	\N	\N	\N	\N	222280	222280	389293
29804	49710	5	applied	\N	\N	\N	\N	222281	222281	389294
29806	49714	0	applied	\N	\N	\N	\N	222291	222291	389304
29806	49715	1	applied	\N	\N	\N	\N	222292	222292	389305
29806	49716	2	applied	\N	\N	\N	\N	222293	222293	389306
29806	49717	3	applied	\N	\N	\N	\N	222294	222294	389307
29806	49718	4	applied	\N	\N	\N	\N	222295	222295	389308
29806	49719	5	applied	\N	\N	\N	\N	222296	222296	389309
29809	49720	0	applied	\N	\N	\N	\N	222303	222303	389316
29809	49722	2	applied	\N	\N	\N	\N	222305	222305	389318
29809	49723	3	applied	\N	\N	\N	\N	222306	222306	389319
29809	49724	4	applied	\N	\N	\N	\N	222307	222307	389320
29813	49607	0	applied	\N	\N	\N	\N	222318	222318	389331
29813	49317	1	applied	\N	\N	\N	\N	222319	222319	389332
29813	49318	2	applied	\N	\N	\N	\N	222320	222320	389333
29813	49341	3	applied	\N	\N	\N	\N	222321	222321	389334
29813	49355	5	applied	\N	\N	\N	\N	222322	222322	389335
29813	49380	6	applied	\N	\N	\N	\N	222323	222323	389336
29813	49392	7	applied	\N	\N	\N	\N	222324	222324	389337
29813	49405	8	applied	\N	\N	\N	\N	222325	222325	389338
29813	49406	9	applied	\N	\N	\N	\N	222326	222326	389339
29813	49424	10	applied	\N	\N	\N	\N	222327	222327	389340
29813	49425	11	applied	\N	\N	\N	\N	222328	222328	389341
29783	49539	70	applied	\N	\N	\N	\N	221845	221845	388858
29783	49540	71	applied	\N	\N	\N	\N	221846	221846	388859
29785	49574	21	applied	\N	\N	\N	\N	221882	221882	388895
29785	49575	22	applied	\N	\N	\N	\N	221883	221883	388896
29785	49576	23	applied	\N	\N	\N	\N	221884	221884	388897
29785	49577	24	applied	\N	\N	\N	\N	221885	221885	388898
29785	49578	25	applied	\N	\N	\N	\N	221886	221886	388899
29785	49579	26	applied	\N	\N	\N	\N	221887	221887	388900
29785	49580	27	applied	\N	\N	\N	\N	221888	221888	388901
29785	49581	28	applied	\N	\N	\N	\N	221889	221889	388902
29788	49553	0	applied	\N	\N	\N	\N	221948	221948	388961
29788	49554	1	applied	\N	\N	\N	\N	221949	221949	388962
29788	49555	2	applied	\N	\N	\N	\N	221950	221950	388963
29788	49556	3	applied	\N	\N	\N	\N	221951	221951	388964
29788	49558	4	applied	\N	\N	\N	\N	221952	221952	388965
29788	49559	5	applied	\N	\N	\N	\N	221953	221953	388966
29788	49560	6	applied	\N	\N	\N	\N	221954	221954	388967
29788	49561	7	applied	\N	\N	\N	\N	221955	221955	388968
29793	49598	3	applied	\N	\N	\N	\N	222014	222014	389027
29793	49599	4	applied	\N	\N	\N	\N	222015	222015	389028
29793	49600	5	applied	\N	\N	\N	\N	222016	222016	389029
29793	49601	6	applied	\N	\N	\N	\N	222017	222017	389030
29793	49602	7	applied	\N	\N	\N	\N	222018	222018	389031
29793	49603	8	applied	\N	\N	\N	\N	222019	222019	389032
29793	49604	9	applied	\N	\N	\N	\N	222020	222020	389033
29793	49605	10	applied	\N	\N	\N	\N	222021	222021	389034
29793	49606	11	applied	\N	\N	\N	\N	222022	222022	389035
29794	49595	0	applied	\N	\N	\N	\N	222023	222023	389036
29794	49596	1	applied	\N	\N	\N	\N	222024	222024	389037
29794	49597	2	applied	\N	\N	\N	\N	222025	222025	389038
29794	49598	3	applied	\N	\N	\N	\N	222026	222026	389039
29794	49599	4	applied	\N	\N	\N	\N	222027	222027	389040
29794	49600	5	applied	\N	\N	\N	\N	222028	222028	389041
29794	49601	6	applied	\N	\N	\N	\N	222029	222029	389042
29794	49603	8	applied	\N	\N	\N	\N	222031	222031	389044
29794	49604	9	applied	\N	\N	\N	\N	222032	222032	389045
29794	49605	10	applied	\N	\N	\N	\N	222033	222033	389046
29794	49606	11	applied	\N	\N	\N	\N	222034	222034	389047
29795	49595	0	applied	\N	\N	\N	\N	222035	222035	389048
29795	49596	1	applied	\N	\N	\N	\N	222036	222036	389049
29795	49597	2	applied	\N	\N	\N	\N	222037	222037	389050
29795	49598	3	applied	\N	\N	\N	\N	222038	222038	389051
29795	49599	4	applied	\N	\N	\N	\N	222039	222039	389052
29795	49600	5	applied	\N	\N	\N	\N	222040	222040	389053
29795	49601	6	applied	\N	\N	\N	\N	222041	222041	389054
29795	49602	7	applied	\N	\N	\N	\N	222042	222042	389055
29795	49603	8	applied	\N	\N	\N	\N	222043	222043	389056
29795	49604	9	applied	\N	\N	\N	\N	222044	222044	389057
29795	49605	10	applied	\N	\N	\N	\N	222045	222045	389058
29795	49606	11	applied	\N	\N	\N	\N	222046	222046	389059
29800	49341	1	applied	\N	\N	\N	\N	222134	222134	389147
29800	49355	2	applied	\N	\N	\N	\N	222135	222135	389148
29800	49380	3	applied	\N	\N	\N	\N	222136	222136	389149
29800	49392	4	applied	\N	\N	\N	\N	222137	222137	389150
29800	49405	5	applied	\N	\N	\N	\N	222138	222138	389151
29800	49406	6	applied	\N	\N	\N	\N	222139	222139	389152
29800	49424	7	applied	\N	\N	\N	\N	222140	222140	389153
29800	49425	8	applied	\N	\N	\N	\N	222141	222141	389154
29800	49449	9	applied	\N	\N	\N	\N	222142	222142	389155
29800	49450	10	applied	\N	\N	\N	\N	222143	222143	389156
29800	49480	11	applied	\N	\N	\N	\N	222144	222144	389157
29800	49481	12	applied	\N	\N	\N	\N	222145	222145	389158
29800	49508	13	applied	\N	\N	\N	\N	222146	222146	389159
29800	49523	14	applied	\N	\N	\N	\N	222147	222147	389160
29800	49524	15	applied	\N	\N	\N	\N	222148	222148	389161
29800	49541	16	applied	\N	\N	\N	\N	222149	222149	389162
29800	49554	18	applied	\N	\N	\N	\N	222151	222151	389164
29800	49582	19	applied	\N	\N	\N	\N	222152	222152	389165
29800	49595	20	applied	\N	\N	\N	\N	222153	222153	389166
29800	49608	21	applied	\N	\N	\N	\N	222154	222154	389167
29800	49609	22	applied	\N	\N	\N	\N	222155	222155	389168
29800	49610	23	applied	\N	\N	\N	\N	222156	222156	389169
29800	49611	24	applied	\N	\N	\N	\N	222157	222157	389170
29800	49667	25	applied	\N	\N	\N	\N	222158	222158	389171
29800	49342	26	applied	\N	\N	\N	\N	222159	222159	389172
29800	49343	27	applied	\N	\N	\N	\N	222160	222160	389173
29800	49344	28	applied	\N	\N	\N	\N	222161	222161	389174
29800	49345	29	applied	\N	\N	\N	\N	222162	222162	389175
29800	49346	30	applied	\N	\N	\N	\N	222163	222163	389176
29800	49347	31	applied	\N	\N	\N	\N	222164	222164	389177
29800	49348	32	applied	\N	\N	\N	\N	222165	222165	389178
29800	49336	33	applied	\N	\N	\N	\N	222166	222166	389179
29800	49338	35	applied	\N	\N	\N	\N	222168	222168	389181
29800	49339	36	applied	\N	\N	\N	\N	222169	222169	389182
29800	49358	37	applied	\N	\N	\N	\N	222170	222170	389183
29800	49359	38	applied	\N	\N	\N	\N	222171	222171	389184
29800	49373	39	applied	\N	\N	\N	\N	222172	222172	389185
29800	49381	40	applied	\N	\N	\N	\N	222173	222173	389186
29800	49384	41	applied	\N	\N	\N	\N	222174	222174	389187
29800	49340	42	applied	\N	\N	\N	\N	222175	222175	389188
29800	49350	43	applied	\N	\N	\N	\N	222176	222176	389189
29800	49351	44	applied	\N	\N	\N	\N	222177	222177	389190
29800	49352	45	applied	\N	\N	\N	\N	222178	222178	389191
29800	49396	46	applied	\N	\N	\N	\N	222179	222179	389192
29800	49407	47	applied	\N	\N	\N	\N	222180	222180	389193
29800	49411	48	applied	\N	\N	\N	\N	222181	222181	389194
29800	49416	49	applied	\N	\N	\N	\N	222182	222182	389195
29800	49435	50	applied	\N	\N	\N	\N	222183	222183	389196
29800	49443	52	applied	\N	\N	\N	\N	222185	222185	389198
29800	49451	53	applied	\N	\N	\N	\N	222186	222186	389199
29800	49452	54	applied	\N	\N	\N	\N	222187	222187	389200
29800	49454	55	applied	\N	\N	\N	\N	222188	222188	389201
29800	49482	56	applied	\N	\N	\N	\N	222189	222189	389202
29800	49483	57	applied	\N	\N	\N	\N	222190	222190	389203
29800	49484	58	applied	\N	\N	\N	\N	222191	222191	389204
29800	49521	59	applied	\N	\N	\N	\N	222192	222192	389205
29800	49522	60	applied	\N	\N	\N	\N	222193	222193	389206
29800	49528	61	applied	\N	\N	\N	\N	222194	222194	389207
29800	49529	62	applied	\N	\N	\N	\N	222195	222195	389208
29800	49530	63	applied	\N	\N	\N	\N	222196	222196	389209
29800	49542	64	applied	\N	\N	\N	\N	222197	222197	389210
29800	49557	65	applied	\N	\N	\N	\N	222198	222198	389211
29785	49571	18	applied	\N	\N	\N	\N	221879	221879	388892
29785	49572	19	applied	\N	\N	\N	\N	221880	221880	388893
29797	49611	4	applied	\N	\N	\N	\N	222060	222060	389073
29797	49612	5	applied	\N	\N	\N	\N	222061	222061	389074
29797	49613	6	applied	\N	\N	\N	\N	222062	222062	389075
29797	49614	7	applied	\N	\N	\N	\N	222063	222063	389076
29797	49615	8	applied	\N	\N	\N	\N	222064	222064	389077
29797	49616	9	applied	\N	\N	\N	\N	222065	222065	389078
29797	49617	10	applied	\N	\N	\N	\N	222066	222066	389079
29797	49618	11	applied	\N	\N	\N	\N	222067	222067	389080
29797	49619	12	applied	\N	\N	\N	\N	222068	222068	389081
29797	49620	13	applied	\N	\N	\N	\N	222069	222069	389082
29797	49621	14	applied	\N	\N	\N	\N	222070	222070	389083
29797	49622	15	applied	\N	\N	\N	\N	222071	222071	389084
29797	49623	16	applied	\N	\N	\N	\N	222072	222072	389085
29797	49624	17	applied	\N	\N	\N	\N	222073	222073	389086
29797	49625	18	applied	\N	\N	\N	\N	222074	222074	389087
29797	49626	19	applied	\N	\N	\N	\N	222075	222075	389088
29797	49628	21	applied	\N	\N	\N	\N	222077	222077	389090
29797	49629	22	applied	\N	\N	\N	\N	222078	222078	389091
29797	49630	23	applied	\N	\N	\N	\N	222079	222079	389092
29797	49631	24	applied	\N	\N	\N	\N	222080	222080	389093
29797	49632	25	applied	\N	\N	\N	\N	222081	222081	389094
29797	49633	26	applied	\N	\N	\N	\N	222082	222082	389095
29797	49634	27	applied	\N	\N	\N	\N	222083	222083	389096
29797	49635	28	applied	\N	\N	\N	\N	222084	222084	389097
29797	49636	29	applied	\N	\N	\N	\N	222085	222085	389098
29797	49637	30	applied	\N	\N	\N	\N	222086	222086	389099
29797	49638	31	applied	\N	\N	\N	\N	222087	222087	389100
29797	49639	32	applied	\N	\N	\N	\N	222088	222088	389101
29797	49640	33	applied	\N	\N	\N	\N	222089	222089	389102
29797	49641	34	applied	\N	\N	\N	\N	222090	222090	389103
29797	49642	35	applied	\N	\N	\N	\N	222091	222091	389104
29797	49643	36	applied	\N	\N	\N	\N	222092	222092	389105
29797	49645	38	applied	\N	\N	\N	\N	222094	222094	389107
29797	49646	39	applied	\N	\N	\N	\N	222095	222095	389108
29797	49647	40	applied	\N	\N	\N	\N	222096	222096	389109
29797	49648	41	applied	\N	\N	\N	\N	222097	222097	389110
29797	49649	42	applied	\N	\N	\N	\N	222098	222098	389111
29797	49650	43	applied	\N	\N	\N	\N	222099	222099	389112
29797	49651	44	applied	\N	\N	\N	\N	222100	222100	389113
29797	49652	45	applied	\N	\N	\N	\N	222101	222101	389114
29797	49653	46	applied	\N	\N	\N	\N	222102	222102	389115
29797	49654	47	applied	\N	\N	\N	\N	222103	222103	389116
29797	49655	48	applied	\N	\N	\N	\N	222104	222104	389117
29797	49656	49	applied	\N	\N	\N	\N	222105	222105	389118
29797	49657	51	applied	\N	\N	\N	\N	222106	222106	389119
29797	49658	52	applied	\N	\N	\N	\N	222107	222107	389120
29797	49659	53	applied	\N	\N	\N	\N	222108	222108	389121
29797	49660	54	applied	\N	\N	\N	\N	222109	222109	389122
29797	49662	56	applied	\N	\N	\N	\N	222111	222111	389124
29797	49663	57	applied	\N	\N	\N	\N	222112	222112	389125
29797	49664	58	applied	\N	\N	\N	\N	222113	222113	389126
29797	49665	59	applied	\N	\N	\N	\N	222114	222114	389127
29797	49666	60	applied	\N	\N	\N	\N	222115	222115	389128
29800	49570	66	applied	\N	\N	\N	\N	222199	222199	389212
29800	49571	67	applied	\N	\N	\N	\N	222200	222200	389213
29800	49585	68	applied	\N	\N	\N	\N	222201	222201	389214
29800	49597	69	applied	\N	\N	\N	\N	222202	222202	389215
29800	49598	70	applied	\N	\N	\N	\N	222203	222203	389216
29800	49615	71	applied	\N	\N	\N	\N	222204	222204	389217
29800	49620	72	applied	\N	\N	\N	\N	222205	222205	389218
29800	49621	73	applied	\N	\N	\N	\N	222206	222206	389219
29800	49622	74	applied	\N	\N	\N	\N	222207	222207	389220
29800	49623	75	applied	\N	\N	\N	\N	222208	222208	389221
29800	49624	76	applied	\N	\N	\N	\N	222209	222209	389222
29800	49360	78	applied	\N	\N	\N	\N	222211	222211	389224
29800	49361	79	applied	\N	\N	\N	\N	222212	222212	389225
29800	49362	80	applied	\N	\N	\N	\N	222213	222213	389226
29800	49363	81	applied	\N	\N	\N	\N	222214	222214	389227
29800	49364	82	applied	\N	\N	\N	\N	222215	222215	389228
29800	49365	83	applied	\N	\N	\N	\N	222216	222216	389229
29800	49366	84	applied	\N	\N	\N	\N	222217	222217	389230
29800	49367	85	applied	\N	\N	\N	\N	222218	222218	389231
29800	49368	86	applied	\N	\N	\N	\N	222219	222219	389232
29800	49375	87	applied	\N	\N	\N	\N	222220	222220	389233
29801	49676	0	applied	\N	\N	\N	\N	222235	222235	389248
29801	49675	1	applied	\N	\N	\N	\N	222236	222236	389249
29801	49677	2	applied	\N	\N	\N	\N	222237	222237	389250
29801	49678	3	applied	\N	\N	\N	\N	222238	222238	389251
29801	49679	4	applied	\N	\N	\N	\N	222239	222239	389252
29801	49680	5	applied	\N	\N	\N	\N	222240	222240	389253
29801	49682	7	applied	\N	\N	\N	\N	222242	222242	389255
29801	49683	8	applied	\N	\N	\N	\N	222243	222243	389256
29801	49684	9	applied	\N	\N	\N	\N	222244	222244	389257
29801	49685	10	applied	\N	\N	\N	\N	222245	222245	389258
29803	49686	0	applied	\N	\N	\N	\N	222257	222257	389270
29803	49687	1	applied	\N	\N	\N	\N	222258	222258	389271
29803	49688	2	applied	\N	\N	\N	\N	222259	222259	389272
29803	49689	3	applied	\N	\N	\N	\N	222260	222260	389273
29803	49690	4	applied	\N	\N	\N	\N	222261	222261	389274
29803	49691	5	applied	\N	\N	\N	\N	222262	222262	389275
29803	49692	6	applied	\N	\N	\N	\N	222263	222263	389276
29803	49693	7	applied	\N	\N	\N	\N	222264	222264	389277
29803	49694	8	applied	\N	\N	\N	\N	222265	222265	389278
29803	49695	9	applied	\N	\N	\N	\N	222266	222266	389279
29803	49696	10	applied	\N	\N	\N	\N	222267	222267	389280
29803	49697	11	applied	\N	\N	\N	\N	222268	222268	389281
29803	49699	13	applied	\N	\N	\N	\N	222270	222270	389283
29803	49700	14	applied	\N	\N	\N	\N	222271	222271	389284
29803	49701	15	applied	\N	\N	\N	\N	222272	222272	389285
29803	49702	16	applied	\N	\N	\N	\N	222273	222273	389286
29803	49703	17	applied	\N	\N	\N	\N	222274	222274	389287
29803	49704	18	applied	\N	\N	\N	\N	222275	222275	389288
29805	49705	0	applied	\N	\N	\N	\N	222282	222282	389295
29805	49706	1	applied	\N	\N	\N	\N	222283	222283	389296
29805	49707	2	applied	\N	\N	\N	\N	222284	222284	389297
29805	49708	3	applied	\N	\N	\N	\N	222285	222285	389298
29805	49709	4	applied	\N	\N	\N	\N	222286	222286	389299
29805	49710	5	applied	\N	\N	\N	\N	222287	222287	389300
29805	49711	6	applied	\N	\N	\N	\N	222288	222288	389301
29805	49712	7	applied	\N	\N	\N	\N	222289	222289	389302
29797	49608	1	applied	\N	\N	\N	\N	222057	222057	389070
29797	49609	2	applied	\N	\N	\N	\N	222058	222058	389071
29800	49382	92	applied	\N	\N	\N	\N	222225	222225	389238
29800	49383	93	applied	\N	\N	\N	\N	222226	222226	389239
29800	49385	94	applied	\N	\N	\N	\N	222227	222227	389240
29800	49386	95	applied	\N	\N	\N	\N	222228	222228	389241
29800	49387	96	applied	\N	\N	\N	\N	222229	222229	389242
29800	49393	97	applied	\N	\N	\N	\N	222230	222230	389243
29800	49400	98	applied	\N	\N	\N	\N	222231	222231	389244
29800	49401	99	applied	\N	\N	\N	\N	222232	222232	389245
29800	49402	100	applied	\N	\N	\N	\N	222233	222233	389246
29800	49403	101	applied	\N	\N	\N	\N	222234	222234	389247
29802	49676	0	applied	\N	\N	\N	\N	222246	222246	389259
29802	49675	1	applied	\N	\N	\N	\N	222247	222247	389260
29802	49677	2	applied	\N	\N	\N	\N	222248	222248	389261
29802	49678	3	applied	\N	\N	\N	\N	222249	222249	389262
29802	49679	4	applied	\N	\N	\N	\N	222250	222250	389263
29802	49680	5	applied	\N	\N	\N	\N	222251	222251	389264
29802	49682	7	applied	\N	\N	\N	\N	222253	222253	389266
29802	49683	8	applied	\N	\N	\N	\N	222254	222254	389267
29802	49684	9	applied	\N	\N	\N	\N	222255	222255	389268
29802	49685	10	applied	\N	\N	\N	\N	222256	222256	389269
29805	49713	8	applied	\N	\N	\N	\N	222290	222290	389303
29807	49714	0	applied	\N	\N	\N	\N	222297	222297	389310
29810	49720	0	applied	\N	\N	\N	\N	222308	222308	389321
29810	49721	1	applied	\N	\N	\N	\N	222309	222309	389322
29810	49722	2	applied	\N	\N	\N	\N	222310	222310	389323
29810	49723	3	applied	\N	\N	\N	\N	222311	222311	389324
29810	49724	4	applied	\N	\N	\N	\N	222312	222312	389325
29811	49720	0	applied	\N	\N	\N	\N	222313	222313	389326
29811	49721	1	applied	\N	\N	\N	\N	222314	222314	389327
29811	49722	2	applied	\N	\N	\N	\N	222315	222315	389328
29811	49723	3	applied	\N	\N	\N	\N	222316	222316	389329
29811	49724	4	applied	\N	\N	\N	\N	222317	222317	389330
29817	49755	1	applied	\N	\N	\N	\N	222500	222500	389513
29817	49756	2	applied	\N	\N	\N	\N	222501	222501	389514
29817	49757	3	applied	\N	\N	\N	\N	222502	222502	389515
29819	49768	0	applied	\N	\N	\N	\N	222513	222513	389526
29819	49769	1	applied	\N	\N	\N	\N	222514	222514	389527
29819	49770	2	applied	\N	\N	\N	\N	222515	222515	389528
29819	49771	3	applied	\N	\N	\N	\N	222516	222516	389529
29819	49772	4	applied	\N	\N	\N	\N	222517	222517	389530
29819	49773	5	applied	\N	\N	\N	\N	222518	222518	389531
29819	49774	6	applied	\N	\N	\N	\N	222519	222519	389532
29819	49775	7	applied	\N	\N	\N	\N	222520	222520	389533
29819	49776	8	applied	\N	\N	\N	\N	222521	222521	389534
29819	49777	9	applied	\N	\N	\N	\N	222522	222522	389535
29819	49778	10	applied	\N	\N	\N	\N	222523	222523	389536
29819	49779	11	applied	\N	\N	\N	\N	222524	222524	389537
29819	49780	12	applied	\N	\N	\N	\N	222525	222525	389538
29819	49782	14	applied	\N	\N	\N	\N	222527	222527	389540
29819	49783	15	applied	\N	\N	\N	\N	222528	222528	389541
29819	49784	16	applied	\N	\N	\N	\N	222529	222529	389542
29819	49785	17	applied	\N	\N	\N	\N	222530	222530	389543
29819	49786	18	applied	\N	\N	\N	\N	222531	222531	389544
29820	49768	0	applied	\N	\N	\N	\N	222532	222532	389545
29820	49769	1	applied	\N	\N	\N	\N	222533	222533	389546
29820	49770	2	applied	\N	\N	\N	\N	222534	222534	389547
29820	49771	3	applied	\N	\N	\N	\N	222535	222535	389548
29820	49772	4	applied	\N	\N	\N	\N	222536	222536	389549
29820	49773	5	applied	\N	\N	\N	\N	222537	222537	389550
29820	49774	6	applied	\N	\N	\N	\N	222538	222538	389551
29820	49775	7	applied	\N	\N	\N	\N	222539	222539	389552
29820	49776	8	applied	\N	\N	\N	\N	222540	222540	389553
29820	49777	9	applied	\N	\N	\N	\N	222541	222541	389554
29820	49778	10	applied	\N	\N	\N	\N	222542	222542	389555
29820	49780	12	applied	\N	\N	\N	\N	222544	222544	389557
29820	49781	13	applied	\N	\N	\N	\N	222545	222545	389558
29820	49782	14	applied	\N	\N	\N	\N	222546	222546	389559
29824	49806	0	applied	\N	\N	\N	\N	222579	222579	389592
29824	49807	1	applied	\N	\N	\N	\N	222580	222580	389593
29824	49808	2	applied	\N	\N	\N	\N	222581	222581	389594
29824	49809	3	applied	\N	\N	\N	\N	222582	222582	389595
29824	49810	4	applied	\N	\N	\N	\N	222583	222583	389596
29824	49811	5	applied	\N	\N	\N	\N	222584	222584	389597
29824	49812	6	applied	\N	\N	\N	\N	222585	222585	389598
29824	49813	7	applied	\N	\N	\N	\N	222586	222586	389599
29824	49814	8	applied	\N	\N	\N	\N	222587	222587	389600
29824	49815	9	applied	\N	\N	\N	\N	222588	222588	389601
29824	49816	10	applied	\N	\N	\N	\N	222589	222589	389602
29826	49806	0	applied	\N	\N	\N	\N	222601	222601	389614
29826	49807	1	applied	\N	\N	\N	\N	222602	222602	389615
29826	49813	3	applied	\N	\N	\N	\N	222604	222604	389617
29826	49814	4	applied	\N	\N	\N	\N	222605	222605	389618
29826	49815	5	applied	\N	\N	\N	\N	222606	222606	389619
29828	49817	0	applied	\N	\N	\N	\N	222616	222616	389629
29828	49818	1	applied	\N	\N	\N	\N	222617	222617	389630
29828	49819	2	applied	\N	\N	\N	\N	222618	222618	389631
29828	49820	3	applied	\N	\N	\N	\N	222619	222619	389632
29828	49821	4	applied	\N	\N	\N	\N	222620	222620	389633
29828	49822	5	applied	\N	\N	\N	\N	222621	222621	389634
29828	49823	6	applied	\N	\N	\N	\N	222622	222622	389635
29828	49824	7	applied	\N	\N	\N	\N	222623	222623	389636
29828	49825	8	applied	\N	\N	\N	\N	222624	222624	389637
29835	49849	0	applied	\N	\N	\N	\N	222663	222663	389676
29835	49850	1	applied	\N	\N	\N	\N	222664	222664	389677
29835	49851	2	applied	\N	\N	\N	\N	222665	222665	389678
29835	49852	3	applied	\N	\N	\N	\N	222666	222666	389679
29843	49947	0	applied	\N	\N	\N	\N	222784	222784	389797
29843	49948	1	applied	\N	\N	\N	\N	222785	222785	389798
29843	49949	2	applied	\N	\N	\N	\N	222786	222786	389799
29843	49950	3	applied	\N	\N	\N	\N	222787	222787	389800
29843	49951	4	applied	\N	\N	\N	\N	222788	222788	389801
29843	49952	5	applied	\N	\N	\N	\N	222789	222789	389802
29854	50042	0	applied	\N	\N	\N	\N	222945	222945	389958
29854	50043	1	applied	\N	\N	\N	\N	222946	222946	389959
29854	50044	2	applied	\N	\N	\N	\N	222947	222947	389960
29854	50045	3	applied	\N	\N	\N	\N	222948	222948	389961
29854	50046	4	applied	\N	\N	\N	\N	222949	222949	389962
29854	50047	5	applied	\N	\N	\N	\N	222950	222950	389963
29854	50048	6	applied	\N	\N	\N	\N	222951	222951	389964
29854	50049	7	applied	\N	\N	\N	\N	222952	222952	389965
29800	49377	89	applied	\N	\N	\N	\N	222222	222222	389235
29800	49378	90	applied	\N	\N	\N	\N	222223	222223	389236
29813	49508	16	applied	\N	\N	\N	\N	222333	222333	389346
29813	49523	17	applied	\N	\N	\N	\N	222334	222334	389347
29813	49524	18	applied	\N	\N	\N	\N	222335	222335	389348
29813	49541	19	applied	\N	\N	\N	\N	222336	222336	389349
29813	49553	20	applied	\N	\N	\N	\N	222337	222337	389350
29813	49554	21	applied	\N	\N	\N	\N	222338	222338	389351
29813	49582	22	applied	\N	\N	\N	\N	222339	222339	389352
29813	49595	23	applied	\N	\N	\N	\N	222340	222340	389353
29813	49608	24	applied	\N	\N	\N	\N	222341	222341	389354
29813	49609	25	applied	\N	\N	\N	\N	222342	222342	389355
29813	49610	26	applied	\N	\N	\N	\N	222343	222343	389356
29813	49611	27	applied	\N	\N	\N	\N	222344	222344	389357
29813	49667	28	applied	\N	\N	\N	\N	222345	222345	389358
29813	49676	29	applied	\N	\N	\N	\N	222346	222346	389359
29813	49686	30	applied	\N	\N	\N	\N	222347	222347	389360
29813	49687	31	applied	\N	\N	\N	\N	222348	222348	389361
29813	49714	33	applied	\N	\N	\N	\N	222350	222350	389363
29820	49783	15	applied	\N	\N	\N	\N	222547	222547	389560
29820	49784	16	applied	\N	\N	\N	\N	222548	222548	389561
29820	49785	17	applied	\N	\N	\N	\N	222549	222549	389562
29820	49786	18	applied	\N	\N	\N	\N	222550	222550	389563
29837	49859	0	applied	\N	\N	\N	\N	222673	222673	389686
29837	49860	1	applied	\N	\N	\N	\N	222674	222674	389687
29837	49861	2	applied	\N	\N	\N	\N	222675	222675	389688
29837	49862	3	applied	\N	\N	\N	\N	222676	222676	389689
29837	49863	4	applied	\N	\N	\N	\N	222677	222677	389690
29837	49864	5	applied	\N	\N	\N	\N	222678	222678	389691
29837	49865	6	applied	\N	\N	\N	\N	222679	222679	389692
29837	49866	7	applied	\N	\N	\N	\N	222680	222680	389693
29840	49890	0	applied	\N	\N	\N	\N	222727	222727	389740
29840	49891	1	applied	\N	\N	\N	\N	222728	222728	389741
29840	49892	2	applied	\N	\N	\N	\N	222729	222729	389742
29840	49894	4	applied	\N	\N	\N	\N	222731	222731	389744
29840	49895	5	applied	\N	\N	\N	\N	222732	222732	389745
29840	49896	6	applied	\N	\N	\N	\N	222733	222733	389746
29840	49897	7	applied	\N	\N	\N	\N	222734	222734	389747
29840	49898	8	applied	\N	\N	\N	\N	222735	222735	389748
29840	49899	9	applied	\N	\N	\N	\N	222736	222736	389749
29840	49900	10	applied	\N	\N	\N	\N	222737	222737	389750
29840	49901	11	applied	\N	\N	\N	\N	222738	222738	389751
29840	49902	12	applied	\N	\N	\N	\N	222739	222739	389752
29840	49903	13	applied	\N	\N	\N	\N	222740	222740	389753
29840	49904	14	applied	\N	\N	\N	\N	222741	222741	389754
29840	49905	15	applied	\N	\N	\N	\N	222742	222742	389755
29840	49906	16	applied	\N	\N	\N	\N	222743	222743	389756
29840	49907	17	applied	\N	\N	\N	\N	222744	222744	389757
29840	49908	18	applied	\N	\N	\N	\N	222745	222745	389758
29840	49909	19	applied	\N	\N	\N	\N	222746	222746	389759
29840	49911	21	applied	\N	\N	\N	\N	222748	222748	389761
29840	49912	22	applied	\N	\N	\N	\N	222749	222749	389762
29840	49913	23	applied	\N	\N	\N	\N	222750	222750	389763
29840	49914	24	applied	\N	\N	\N	\N	222751	222751	389764
29840	49915	25	applied	\N	\N	\N	\N	222752	222752	389765
29840	49916	26	applied	\N	\N	\N	\N	222753	222753	389766
29845	49953	0	applied	\N	\N	\N	\N	222795	222795	389808
29845	49954	1	applied	\N	\N	\N	\N	222796	222796	389809
29845	49955	2	applied	\N	\N	\N	\N	222797	222797	389810
29845	49956	3	applied	\N	\N	\N	\N	222798	222798	389811
29845	49957	4	applied	\N	\N	\N	\N	222799	222799	389812
29850	50000	0	applied	\N	\N	\N	\N	222888	222888	389901
29850	50001	1	applied	\N	\N	\N	\N	222889	222889	389902
29850	50002	2	applied	\N	\N	\N	\N	222890	222890	389903
29850	50003	3	applied	\N	\N	\N	\N	222891	222891	389904
29850	50004	4	applied	\N	\N	\N	\N	222892	222892	389905
29850	50006	6	applied	\N	\N	\N	\N	222894	222894	389907
29850	50007	7	applied	\N	\N	\N	\N	222895	222895	389908
29850	50008	8	applied	\N	\N	\N	\N	222896	222896	389909
29852	50009	0	applied	\N	\N	\N	\N	222911	222911	389924
29852	50010	1	applied	\N	\N	\N	\N	222912	222912	389925
29852	50011	2	applied	\N	\N	\N	\N	222913	222913	389926
29852	50012	3	applied	\N	\N	\N	\N	222914	222914	389927
29852	50013	4	applied	\N	\N	\N	\N	222915	222915	389928
29852	50014	5	applied	\N	\N	\N	\N	222916	222916	389929
29852	50015	6	applied	\N	\N	\N	\N	222917	222917	389930
29852	50016	7	applied	\N	\N	\N	\N	222918	222918	389931
29852	50017	8	applied	\N	\N	\N	\N	222919	222919	389932
29852	50018	9	applied	\N	\N	\N	\N	222920	222920	389933
29852	50019	10	applied	\N	\N	\N	\N	222921	222921	389934
29852	50020	11	applied	\N	\N	\N	\N	222922	222922	389935
29852	50021	12	applied	\N	\N	\N	\N	222923	222923	389936
29852	50022	14	applied	\N	\N	\N	\N	222925	222925	389938
29857	50051	0	applied	\N	\N	\N	\N	222974	222974	389987
29857	50055	1	applied	\N	\N	\N	\N	222975	222975	389988
29857	50056	2	applied	\N	\N	\N	\N	222976	222976	389989
29857	50057	3	applied	\N	\N	\N	\N	222977	222977	389990
29857	50058	4	applied	\N	\N	\N	\N	222978	222978	389991
29857	50059	5	applied	\N	\N	\N	\N	222979	222979	389992
29857	50060	6	applied	\N	\N	\N	\N	222980	222980	389993
29859	50070	0	applied	\N	\N	\N	\N	222990	222990	390003
29859	50071	1	applied	\N	\N	\N	\N	222991	222991	390004
29859	50072	2	applied	\N	\N	\N	\N	222992	222992	390005
29859	50073	3	applied	\N	\N	\N	\N	222993	222993	390006
29859	50074	4	applied	\N	\N	\N	\N	222994	222994	390007
29859	50075	6	applied	\N	\N	\N	\N	222995	222995	390008
29859	50076	7	applied	\N	\N	\N	\N	222996	222996	390009
29859	50077	8	applied	\N	\N	\N	\N	222997	222997	390010
29859	50079	10	applied	\N	\N	\N	\N	222999	222999	390012
29863	50109	0	applied	\N	\N	\N	\N	223039	223039	390052
29863	50110	1	applied	\N	\N	\N	\N	223040	223040	390053
29863	50111	2	applied	\N	\N	\N	\N	223041	223041	390054
29863	50112	3	applied	\N	\N	\N	\N	223042	223042	390055
29863	50113	4	applied	\N	\N	\N	\N	223043	223043	390056
29863	50114	5	applied	\N	\N	\N	\N	223044	223044	390057
29863	50115	6	applied	\N	\N	\N	\N	223045	223045	390058
29863	50116	7	applied	\N	\N	\N	\N	223046	223046	390059
29863	50117	8	applied	\N	\N	\N	\N	223047	223047	390060
29868	50118	0	applied	\N	\N	\N	\N	223086	223086	390099
29868	50119	1	applied	\N	\N	\N	\N	223087	223087	390100
29868	50120	2	applied	\N	\N	\N	\N	223088	223088	390101
29868	50121	3	applied	\N	\N	\N	\N	223089	223089	390102
29813	49450	13	applied	\N	\N	\N	\N	222330	222330	389343
29813	49480	14	applied	\N	\N	\N	\N	222331	222331	389344
29813	49333	38	applied	\N	\N	\N	\N	222355	222355	389368
29813	49334	39	applied	\N	\N	\N	\N	222356	222356	389369
29813	49335	40	applied	\N	\N	\N	\N	222357	222357	389370
29813	49320	41	applied	\N	\N	\N	\N	222358	222358	389371
29813	49321	42	applied	\N	\N	\N	\N	222359	222359	389372
29813	49322	43	applied	\N	\N	\N	\N	222360	222360	389373
29813	49323	44	applied	\N	\N	\N	\N	222361	222361	389374
29813	49324	45	applied	\N	\N	\N	\N	222362	222362	389375
29813	49325	46	applied	\N	\N	\N	\N	222363	222363	389376
29813	49326	47	applied	\N	\N	\N	\N	222364	222364	389377
29813	49327	48	applied	\N	\N	\N	\N	222365	222365	389378
29813	49328	49	applied	\N	\N	\N	\N	222366	222366	389379
29813	49342	50	applied	\N	\N	\N	\N	222367	222367	389380
29813	49343	51	applied	\N	\N	\N	\N	222368	222368	389381
29813	49344	52	applied	\N	\N	\N	\N	222369	222369	389382
29813	49345	53	applied	\N	\N	\N	\N	222370	222370	389383
29813	49347	55	applied	\N	\N	\N	\N	222372	222372	389385
29813	49349	56	applied	\N	\N	\N	\N	222373	222373	389386
29813	49329	57	applied	\N	\N	\N	\N	222374	222374	389387
29813	49330	58	applied	\N	\N	\N	\N	222375	222375	389388
29813	49331	59	applied	\N	\N	\N	\N	222376	222376	389389
29813	49348	60	applied	\N	\N	\N	\N	222377	222377	389390
29813	49313	61	applied	\N	\N	\N	\N	222378	222378	389391
29813	49314	62	applied	\N	\N	\N	\N	222379	222379	389392
29813	49336	63	applied	\N	\N	\N	\N	222380	222380	389393
29813	49337	64	applied	\N	\N	\N	\N	222381	222381	389394
29813	49338	65	applied	\N	\N	\N	\N	222382	222382	389395
29813	49339	66	applied	\N	\N	\N	\N	222383	222383	389396
29813	49358	67	applied	\N	\N	\N	\N	222384	222384	389397
29813	49359	68	applied	\N	\N	\N	\N	222385	222385	389398
29813	49373	69	applied	\N	\N	\N	\N	222386	222386	389399
29813	49381	70	applied	\N	\N	\N	\N	222387	222387	389400
29813	49340	72	applied	\N	\N	\N	\N	222389	222389	389402
29813	49350	73	applied	\N	\N	\N	\N	222390	222390	389403
29813	49351	74	applied	\N	\N	\N	\N	222391	222391	389404
29813	49352	75	applied	\N	\N	\N	\N	222392	222392	389405
29813	49396	76	applied	\N	\N	\N	\N	222393	222393	389406
29813	49407	77	applied	\N	\N	\N	\N	222394	222394	389407
29813	49411	78	applied	\N	\N	\N	\N	222395	222395	389408
29813	49353	79	applied	\N	\N	\N	\N	222396	222396	389409
29813	49354	80	applied	\N	\N	\N	\N	222397	222397	389410
29813	49356	81	applied	\N	\N	\N	\N	222398	222398	389411
29813	49357	82	applied	\N	\N	\N	\N	222399	222399	389412
29813	49369	83	applied	\N	\N	\N	\N	222400	222400	389413
29813	49370	84	applied	\N	\N	\N	\N	222401	222401	389414
29813	49371	85	applied	\N	\N	\N	\N	222402	222402	389415
29813	49416	86	applied	\N	\N	\N	\N	222403	222403	389416
29813	49435	87	applied	\N	\N	\N	\N	222404	222404	389417
29813	49443	89	applied	\N	\N	\N	\N	222406	222406	389419
29813	49451	90	applied	\N	\N	\N	\N	222407	222407	389420
29813	49452	91	applied	\N	\N	\N	\N	222408	222408	389421
29813	49454	92	applied	\N	\N	\N	\N	222409	222409	389422
29813	49482	93	applied	\N	\N	\N	\N	222410	222410	389423
29813	49483	94	applied	\N	\N	\N	\N	222411	222411	389424
29813	49484	95	applied	\N	\N	\N	\N	222412	222412	389425
29813	49521	96	applied	\N	\N	\N	\N	222413	222413	389426
29813	49522	97	applied	\N	\N	\N	\N	222414	222414	389427
29813	49528	98	applied	\N	\N	\N	\N	222415	222415	389428
29813	49529	99	applied	\N	\N	\N	\N	222416	222416	389429
29813	49530	100	applied	\N	\N	\N	\N	222417	222417	389430
29813	49542	101	applied	\N	\N	\N	\N	222418	222418	389431
29813	49557	102	applied	\N	\N	\N	\N	222419	222419	389432
29813	49570	103	applied	\N	\N	\N	\N	222420	222420	389433
29813	49571	104	applied	\N	\N	\N	\N	222421	222421	389434
29813	49597	106	applied	\N	\N	\N	\N	222423	222423	389436
29813	49598	107	applied	\N	\N	\N	\N	222424	222424	389437
29813	49615	108	applied	\N	\N	\N	\N	222425	222425	389438
29813	49620	109	applied	\N	\N	\N	\N	222426	222426	389439
29813	49621	110	applied	\N	\N	\N	\N	222427	222427	389440
29813	49622	111	applied	\N	\N	\N	\N	222428	222428	389441
29813	49623	112	applied	\N	\N	\N	\N	222429	222429	389442
29813	49624	113	applied	\N	\N	\N	\N	222430	222430	389443
29813	49669	114	applied	\N	\N	\N	\N	222431	222431	389444
29813	49678	115	applied	\N	\N	\N	\N	222432	222432	389445
29813	49679	116	applied	\N	\N	\N	\N	222433	222433	389446
29813	49688	117	applied	\N	\N	\N	\N	222434	222434	389447
29813	49691	118	applied	\N	\N	\N	\N	222435	222435	389448
29813	49692	119	applied	\N	\N	\N	\N	222436	222436	389449
29813	49708	120	applied	\N	\N	\N	\N	222437	222437	389450
29813	49717	121	applied	\N	\N	\N	\N	222438	222438	389451
29813	49723	123	applied	\N	\N	\N	\N	222440	222440	389453
29815	49736	0	applied	\N	\N	\N	\N	222452	222452	389465
29815	49737	1	applied	\N	\N	\N	\N	222453	222453	389466
29815	49738	2	applied	\N	\N	\N	\N	222454	222454	389467
29815	49739	3	applied	\N	\N	\N	\N	222455	222455	389468
29815	49740	4	applied	\N	\N	\N	\N	222456	222456	389469
29815	49741	5	applied	\N	\N	\N	\N	222457	222457	389470
29815	49742	6	applied	\N	\N	\N	\N	222458	222458	389471
29815	49743	7	applied	\N	\N	\N	\N	222459	222459	389472
29815	49744	8	applied	\N	\N	\N	\N	222460	222460	389473
29815	49745	9	applied	\N	\N	\N	\N	222461	222461	389474
29815	49746	10	applied	\N	\N	\N	\N	222462	222462	389475
29815	49747	11	applied	\N	\N	\N	\N	222463	222463	389476
29815	49748	12	applied	\N	\N	\N	\N	222464	222464	389477
29815	49749	13	applied	\N	\N	\N	\N	222465	222465	389478
29815	49750	14	applied	\N	\N	\N	\N	222466	222466	389479
29815	49752	16	applied	\N	\N	\N	\N	222468	222468	389481
29815	49753	17	applied	\N	\N	\N	\N	222469	222469	389482
29818	49758	0	applied	\N	\N	\N	\N	222503	222503	389516
29818	49759	1	applied	\N	\N	\N	\N	222504	222504	389517
29818	49760	2	applied	\N	\N	\N	\N	222505	222505	389518
29818	49761	3	applied	\N	\N	\N	\N	222506	222506	389519
29818	49762	4	applied	\N	\N	\N	\N	222507	222507	389520
29818	49763	5	applied	\N	\N	\N	\N	222508	222508	389521
29818	49764	6	applied	\N	\N	\N	\N	222509	222509	389522
29818	49765	7	applied	\N	\N	\N	\N	222510	222510	389523
29818	49766	8	applied	\N	\N	\N	\N	222511	222511	389524
29818	49767	9	applied	\N	\N	\N	\N	222512	222512	389525
29822	49797	0	applied	\N	\N	\N	\N	222561	222561	389574
29822	49798	1	applied	\N	\N	\N	\N	222562	222562	389575
29813	49319	35	applied	\N	\N	\N	\N	222352	222352	389365
29813	49312	36	applied	\N	\N	\N	\N	222353	222353	389366
29816	49753	28	applied	\N	\N	\N	\N	222498	222498	389511
29821	49787	0	applied	\N	\N	\N	\N	222551	222551	389564
29821	49788	1	applied	\N	\N	\N	\N	222552	222552	389565
29821	49789	2	applied	\N	\N	\N	\N	222553	222553	389566
29821	49790	3	applied	\N	\N	\N	\N	222554	222554	389567
29821	49791	4	applied	\N	\N	\N	\N	222555	222555	389568
29821	49792	5	applied	\N	\N	\N	\N	222556	222556	389569
29821	49793	6	applied	\N	\N	\N	\N	222557	222557	389570
29821	49794	7	applied	\N	\N	\N	\N	222558	222558	389571
29821	49795	8	applied	\N	\N	\N	\N	222559	222559	389572
29821	49796	9	applied	\N	\N	\N	\N	222560	222560	389573
29822	49799	2	applied	\N	\N	\N	\N	222563	222563	389576
29822	49800	3	applied	\N	\N	\N	\N	222564	222564	389577
29822	49801	4	applied	\N	\N	\N	\N	222565	222565	389578
29822	49802	5	applied	\N	\N	\N	\N	222566	222566	389579
29822	49803	6	applied	\N	\N	\N	\N	222567	222567	389580
29822	49805	8	applied	\N	\N	\N	\N	222569	222569	389582
29823	49797	0	applied	\N	\N	\N	\N	222570	222570	389583
29823	49798	1	applied	\N	\N	\N	\N	222571	222571	389584
29823	49799	2	applied	\N	\N	\N	\N	222572	222572	389585
29823	49800	3	applied	\N	\N	\N	\N	222573	222573	389586
29823	49801	4	applied	\N	\N	\N	\N	222574	222574	389587
29823	49802	5	applied	\N	\N	\N	\N	222575	222575	389588
29823	49803	6	applied	\N	\N	\N	\N	222576	222576	389589
29829	49826	0	applied	\N	\N	\N	\N	222625	222625	389638
29829	49827	1	applied	\N	\N	\N	\N	222626	222626	389639
29829	49828	2	applied	\N	\N	\N	\N	222627	222627	389640
29829	49829	3	applied	\N	\N	\N	\N	222628	222628	389641
29829	49830	4	applied	\N	\N	\N	\N	222629	222629	389642
29829	49831	5	applied	\N	\N	\N	\N	222630	222630	389643
29831	49826	0	applied	\N	\N	\N	\N	222631	222631	389644
29831	49827	1	applied	\N	\N	\N	\N	222632	222632	389645
29831	49830	3	applied	\N	\N	\N	\N	222634	222634	389647
29833	49843	0	applied	\N	\N	\N	\N	222652	222652	389665
29833	49844	1	applied	\N	\N	\N	\N	222653	222653	389666
29833	49845	2	applied	\N	\N	\N	\N	222654	222654	389667
29833	49846	3	applied	\N	\N	\N	\N	222655	222655	389668
29833	49847	4	applied	\N	\N	\N	\N	222656	222656	389669
29833	49848	5	applied	\N	\N	\N	\N	222657	222657	389670
29839	49867	0	applied	\N	\N	\N	\N	222704	222704	389717
29839	49868	1	applied	\N	\N	\N	\N	222705	222705	389718
29839	49869	2	applied	\N	\N	\N	\N	222706	222706	389719
29839	49870	3	applied	\N	\N	\N	\N	222707	222707	389720
29839	49871	4	applied	\N	\N	\N	\N	222708	222708	389721
29839	49872	5	applied	\N	\N	\N	\N	222709	222709	389722
29839	49873	6	applied	\N	\N	\N	\N	222710	222710	389723
29839	49874	7	applied	\N	\N	\N	\N	222711	222711	389724
29839	49875	8	applied	\N	\N	\N	\N	222712	222712	389725
29839	49877	10	applied	\N	\N	\N	\N	222714	222714	389727
29839	49878	11	applied	\N	\N	\N	\N	222715	222715	389728
29839	49879	12	applied	\N	\N	\N	\N	222716	222716	389729
29839	49880	13	applied	\N	\N	\N	\N	222717	222717	389730
29839	49881	14	applied	\N	\N	\N	\N	222718	222718	389731
29839	49882	15	applied	\N	\N	\N	\N	222719	222719	389732
29839	49883	16	applied	\N	\N	\N	\N	222720	222720	389733
29839	49884	17	applied	\N	\N	\N	\N	222721	222721	389734
29839	49885	18	applied	\N	\N	\N	\N	222722	222722	389735
29839	49886	19	applied	\N	\N	\N	\N	222723	222723	389736
29839	49887	20	applied	\N	\N	\N	\N	222724	222724	389737
29839	49888	21	applied	\N	\N	\N	\N	222725	222725	389738
29839	49889	22	applied	\N	\N	\N	\N	222726	222726	389739
29841	49917	0	applied	\N	\N	\N	\N	222754	222754	389767
29841	49918	1	applied	\N	\N	\N	\N	222755	222755	389768
29841	49919	2	applied	\N	\N	\N	\N	222756	222756	389769
29841	49921	4	applied	\N	\N	\N	\N	222758	222758	389771
29841	49922	5	applied	\N	\N	\N	\N	222759	222759	389772
29841	49923	6	applied	\N	\N	\N	\N	222760	222760	389773
29841	49924	7	applied	\N	\N	\N	\N	222761	222761	389774
29841	49925	8	applied	\N	\N	\N	\N	222762	222762	389775
29847	49958	0	applied	\N	\N	\N	\N	222800	222800	389813
29847	49959	1	applied	\N	\N	\N	\N	222801	222801	389814
29847	49960	2	applied	\N	\N	\N	\N	222802	222802	389815
29847	49961	3	applied	\N	\N	\N	\N	222803	222803	389816
29847	49962	4	applied	\N	\N	\N	\N	222804	222804	389817
29847	49963	5	applied	\N	\N	\N	\N	222805	222805	389818
29847	49964	6	applied	\N	\N	\N	\N	222806	222806	389819
29847	49965	7	applied	\N	\N	\N	\N	222807	222807	389820
29847	49966	8	applied	\N	\N	\N	\N	222808	222808	389821
29847	49967	10	applied	\N	\N	\N	\N	222809	222809	389822
29847	49968	11	applied	\N	\N	\N	\N	222810	222810	389823
29847	49970	13	applied	\N	\N	\N	\N	222812	222812	389825
29847	49971	14	applied	\N	\N	\N	\N	222813	222813	389826
29847	49972	15	applied	\N	\N	\N	\N	222814	222814	389827
29847	49973	16	applied	\N	\N	\N	\N	222815	222815	389828
29847	49974	17	applied	\N	\N	\N	\N	222816	222816	389829
29847	49975	18	applied	\N	\N	\N	\N	222817	222817	389830
29847	49976	19	applied	\N	\N	\N	\N	222818	222818	389831
29847	49977	20	applied	\N	\N	\N	\N	222819	222819	389832
29847	49978	21	applied	\N	\N	\N	\N	222820	222820	389833
29847	49979	22	applied	\N	\N	\N	\N	222821	222821	389834
29847	49980	23	applied	\N	\N	\N	\N	222822	222822	389835
29847	49981	24	applied	\N	\N	\N	\N	222823	222823	389836
29847	49982	25	applied	\N	\N	\N	\N	222824	222824	389837
29847	49983	26	applied	\N	\N	\N	\N	222825	222825	389838
29847	49984	27	applied	\N	\N	\N	\N	222826	222826	389839
29847	49985	28	applied	\N	\N	\N	\N	222827	222827	389840
29847	49987	30	applied	\N	\N	\N	\N	222829	222829	389842
29847	49988	31	applied	\N	\N	\N	\N	222830	222830	389843
29847	49989	32	applied	\N	\N	\N	\N	222831	222831	389844
29847	49990	33	applied	\N	\N	\N	\N	222832	222832	389845
29847	49991	34	applied	\N	\N	\N	\N	222833	222833	389846
29847	49992	35	applied	\N	\N	\N	\N	222834	222834	389847
29847	49993	36	applied	\N	\N	\N	\N	222835	222835	389848
29847	49994	37	applied	\N	\N	\N	\N	222836	222836	389849
29847	49995	38	applied	\N	\N	\N	\N	222837	222837	389850
29847	49996	39	applied	\N	\N	\N	\N	222838	222838	389851
29847	49997	40	applied	\N	\N	\N	\N	222839	222839	389852
29847	49998	41	applied	\N	\N	\N	\N	222840	222840	389853
29847	49999	42	applied	\N	\N	\N	\N	222841	222841	389854
29849	50000	0	applied	\N	\N	\N	\N	222879	222879	389892
29816	49738	25	applied	\N	\N	\N	\N	222495	222495	389508
29816	49739	26	applied	\N	\N	\N	\N	222496	222496	389509
29825	49808	2	applied	\N	\N	\N	\N	222592	222592	389605
29825	49809	3	applied	\N	\N	\N	\N	222593	222593	389606
29825	49810	4	applied	\N	\N	\N	\N	222594	222594	389607
29825	49811	5	applied	\N	\N	\N	\N	222595	222595	389608
29825	49812	6	applied	\N	\N	\N	\N	222596	222596	389609
29825	49813	7	applied	\N	\N	\N	\N	222597	222597	389610
29825	49814	8	applied	\N	\N	\N	\N	222598	222598	389611
29825	49815	9	applied	\N	\N	\N	\N	222599	222599	389612
29825	49816	10	applied	\N	\N	\N	\N	222600	222600	389613
29827	49817	0	applied	\N	\N	\N	\N	222607	222607	389620
29827	49818	1	applied	\N	\N	\N	\N	222608	222608	389621
29827	49819	2	applied	\N	\N	\N	\N	222609	222609	389622
29827	49820	3	applied	\N	\N	\N	\N	222610	222610	389623
29827	49821	4	applied	\N	\N	\N	\N	222611	222611	389624
29827	49822	5	applied	\N	\N	\N	\N	222612	222612	389625
29827	49823	6	applied	\N	\N	\N	\N	222613	222613	389626
29827	49825	8	applied	\N	\N	\N	\N	222615	222615	389628
29832	49826	0	applied	\N	\N	\N	\N	222635	222635	389648
29832	49832	1	applied	\N	\N	\N	\N	222636	222636	389649
29832	49827	2	applied	\N	\N	\N	\N	222637	222637	389650
29832	49828	3	applied	\N	\N	\N	\N	222638	222638	389651
29832	49829	4	applied	\N	\N	\N	\N	222639	222639	389652
29832	49833	5	applied	\N	\N	\N	\N	222640	222640	389653
29832	49830	6	applied	\N	\N	\N	\N	222641	222641	389654
29832	49834	7	applied	\N	\N	\N	\N	222642	222642	389655
29832	49835	8	applied	\N	\N	\N	\N	222643	222643	389656
29832	49836	9	applied	\N	\N	\N	\N	222644	222644	389657
29832	49837	10	applied	\N	\N	\N	\N	222645	222645	389658
29832	49838	11	applied	\N	\N	\N	\N	222646	222646	389659
29832	49839	12	applied	\N	\N	\N	\N	222647	222647	389660
29832	49831	13	applied	\N	\N	\N	\N	222648	222648	389661
29832	49840	14	applied	\N	\N	\N	\N	222649	222649	389662
29832	49842	16	applied	\N	\N	\N	\N	222651	222651	389664
29834	49849	0	applied	\N	\N	\N	\N	222658	222658	389671
29834	49850	1	applied	\N	\N	\N	\N	222659	222659	389672
29834	49851	2	applied	\N	\N	\N	\N	222660	222660	389673
29834	49852	3	applied	\N	\N	\N	\N	222661	222661	389674
29834	49853	4	applied	\N	\N	\N	\N	222662	222662	389675
29836	49854	0	applied	\N	\N	\N	\N	222668	222668	389681
29836	49855	1	applied	\N	\N	\N	\N	222669	222669	389682
29836	49856	2	applied	\N	\N	\N	\N	222670	222670	389683
29836	49857	3	applied	\N	\N	\N	\N	222671	222671	389684
29836	49858	4	applied	\N	\N	\N	\N	222672	222672	389685
29838	49867	0	applied	\N	\N	\N	\N	222681	222681	389694
29838	49868	1	applied	\N	\N	\N	\N	222682	222682	389695
29838	49869	2	applied	\N	\N	\N	\N	222683	222683	389696
29838	49870	3	applied	\N	\N	\N	\N	222684	222684	389697
29838	49871	4	applied	\N	\N	\N	\N	222685	222685	389698
29838	49873	6	applied	\N	\N	\N	\N	222687	222687	389700
29838	49874	7	applied	\N	\N	\N	\N	222688	222688	389701
29838	49875	8	applied	\N	\N	\N	\N	222689	222689	389702
29838	49876	9	applied	\N	\N	\N	\N	222690	222690	389703
29838	49877	10	applied	\N	\N	\N	\N	222691	222691	389704
29838	49878	11	applied	\N	\N	\N	\N	222692	222692	389705
29838	49879	12	applied	\N	\N	\N	\N	222693	222693	389706
29838	49880	13	applied	\N	\N	\N	\N	222694	222694	389707
29838	49881	14	applied	\N	\N	\N	\N	222695	222695	389708
29838	49882	15	applied	\N	\N	\N	\N	222696	222696	389709
29838	49883	16	applied	\N	\N	\N	\N	222697	222697	389710
29838	49884	17	applied	\N	\N	\N	\N	222698	222698	389711
29838	49885	18	applied	\N	\N	\N	\N	222699	222699	389712
29838	49886	19	applied	\N	\N	\N	\N	222700	222700	389713
29838	49887	20	applied	\N	\N	\N	\N	222701	222701	389714
29838	49888	21	applied	\N	\N	\N	\N	222702	222702	389715
29842	49926	0	applied	\N	\N	\N	\N	222763	222763	389776
29842	49927	1	applied	\N	\N	\N	\N	222764	222764	389777
29842	49928	2	applied	\N	\N	\N	\N	222765	222765	389778
29842	49929	3	applied	\N	\N	\N	\N	222766	222766	389779
29842	49930	4	applied	\N	\N	\N	\N	222767	222767	389780
29842	49931	5	applied	\N	\N	\N	\N	222768	222768	389781
29842	49932	6	applied	\N	\N	\N	\N	222769	222769	389782
29842	49933	7	applied	\N	\N	\N	\N	222770	222770	389783
29842	49934	8	applied	\N	\N	\N	\N	222771	222771	389784
29842	49935	9	applied	\N	\N	\N	\N	222772	222772	389785
29842	49936	10	applied	\N	\N	\N	\N	222773	222773	389786
29842	49937	11	applied	\N	\N	\N	\N	222774	222774	389787
29842	49938	12	applied	\N	\N	\N	\N	222775	222775	389788
29842	49939	13	applied	\N	\N	\N	\N	222776	222776	389789
29842	49940	14	applied	\N	\N	\N	\N	222777	222777	389790
29842	49941	15	applied	\N	\N	\N	\N	222778	222778	389791
29842	49943	17	applied	\N	\N	\N	\N	222780	222780	389793
29842	49944	18	applied	\N	\N	\N	\N	222781	222781	389794
29842	49945	19	applied	\N	\N	\N	\N	222782	222782	389795
29842	49946	20	applied	\N	\N	\N	\N	222783	222783	389796
29844	49953	0	applied	\N	\N	\N	\N	222790	222790	389803
29844	49954	1	applied	\N	\N	\N	\N	222791	222791	389804
29844	49955	2	applied	\N	\N	\N	\N	222792	222792	389805
29844	49956	3	applied	\N	\N	\N	\N	222793	222793	389806
29844	49957	4	applied	\N	\N	\N	\N	222794	222794	389807
29848	49958	0	applied	\N	\N	\N	\N	222842	222842	389855
29848	49959	1	applied	\N	\N	\N	\N	222843	222843	389856
29848	49960	2	applied	\N	\N	\N	\N	222844	222844	389857
29848	49961	3	applied	\N	\N	\N	\N	222845	222845	389858
29848	49962	4	applied	\N	\N	\N	\N	222846	222846	389859
29848	49967	5	applied	\N	\N	\N	\N	222847	222847	389860
29848	49968	6	applied	\N	\N	\N	\N	222848	222848	389861
29848	49970	8	applied	\N	\N	\N	\N	222850	222850	389863
29848	49971	10	applied	\N	\N	\N	\N	222851	222851	389864
29848	49972	11	applied	\N	\N	\N	\N	222852	222852	389865
29848	49973	12	applied	\N	\N	\N	\N	222853	222853	389866
29848	49974	13	applied	\N	\N	\N	\N	222854	222854	389867
29848	49975	14	applied	\N	\N	\N	\N	222855	222855	389868
29848	49976	15	applied	\N	\N	\N	\N	222856	222856	389869
29848	49977	16	applied	\N	\N	\N	\N	222857	222857	389870
29848	49978	17	applied	\N	\N	\N	\N	222858	222858	389871
29848	49979	18	applied	\N	\N	\N	\N	222859	222859	389872
29848	49980	19	applied	\N	\N	\N	\N	222860	222860	389873
29848	49981	20	applied	\N	\N	\N	\N	222861	222861	389874
29848	49982	21	applied	\N	\N	\N	\N	222862	222862	389875
29848	49983	22	applied	\N	\N	\N	\N	222863	222863	389876
29823	49805	8	applied	\N	\N	\N	\N	222578	222578	389591
29825	49806	0	applied	\N	\N	\N	\N	222590	222590	389603
29848	49988	26	applied	\N	\N	\N	\N	222867	222867	389880
29848	49989	27	applied	\N	\N	\N	\N	222868	222868	389881
29848	49990	28	applied	\N	\N	\N	\N	222869	222869	389882
29848	49991	29	applied	\N	\N	\N	\N	222870	222870	389883
29848	49992	30	applied	\N	\N	\N	\N	222871	222871	389884
29848	49993	31	applied	\N	\N	\N	\N	222872	222872	389885
29848	49994	32	applied	\N	\N	\N	\N	222873	222873	389886
29848	49995	33	applied	\N	\N	\N	\N	222874	222874	389887
29848	49996	34	applied	\N	\N	\N	\N	222875	222875	389888
29848	49997	35	applied	\N	\N	\N	\N	222876	222876	389889
29848	49998	36	applied	\N	\N	\N	\N	222877	222877	389890
29848	49999	37	applied	\N	\N	\N	\N	222878	222878	389891
29849	50001	1	applied	\N	\N	\N	\N	222880	222880	389893
29849	50003	3	applied	\N	\N	\N	\N	222882	222882	389895
29849	50004	4	applied	\N	\N	\N	\N	222883	222883	389896
29849	50005	5	applied	\N	\N	\N	\N	222884	222884	389897
29849	50006	6	applied	\N	\N	\N	\N	222885	222885	389898
29849	50007	7	applied	\N	\N	\N	\N	222886	222886	389899
29849	50008	8	applied	\N	\N	\N	\N	222887	222887	389900
29851	50009	0	applied	\N	\N	\N	\N	222897	222897	389910
29851	50010	1	applied	\N	\N	\N	\N	222898	222898	389911
29851	50011	2	applied	\N	\N	\N	\N	222899	222899	389912
29851	50012	3	applied	\N	\N	\N	\N	222900	222900	389913
29851	50013	4	applied	\N	\N	\N	\N	222901	222901	389914
29851	50014	5	applied	\N	\N	\N	\N	222902	222902	389915
29851	50015	6	applied	\N	\N	\N	\N	222903	222903	389916
29851	50016	7	applied	\N	\N	\N	\N	222904	222904	389917
29851	50017	8	applied	\N	\N	\N	\N	222905	222905	389918
29851	50018	9	applied	\N	\N	\N	\N	222906	222906	389919
29851	50020	11	applied	\N	\N	\N	\N	222908	222908	389921
29851	50021	12	applied	\N	\N	\N	\N	222909	222909	389922
29851	50022	13	applied	\N	\N	\N	\N	222910	222910	389923
29860	50080	0	applied	\N	\N	\N	\N	223000	223000	390013
29860	50081	1	applied	\N	\N	\N	\N	223001	223001	390014
29860	50082	2	applied	\N	\N	\N	\N	223002	223002	390015
29860	50083	3	applied	\N	\N	\N	\N	223003	223003	390016
29860	50084	4	applied	\N	\N	\N	\N	223004	223004	390017
29860	50085	5	applied	\N	\N	\N	\N	223005	223005	390018
29860	50086	6	applied	\N	\N	\N	\N	223006	223006	390019
29860	50087	7	applied	\N	\N	\N	\N	223007	223007	390020
29860	50088	8	applied	\N	\N	\N	\N	223008	223008	390021
29860	50089	9	applied	\N	\N	\N	\N	223009	223009	390022
29865	50109	0	applied	\N	\N	\N	\N	223057	223057	390070
29865	50110	1	applied	\N	\N	\N	\N	223058	223058	390071
29865	50111	2	applied	\N	\N	\N	\N	223059	223059	390072
29865	50113	4	applied	\N	\N	\N	\N	223061	223061	390074
29865	50114	5	applied	\N	\N	\N	\N	223062	223062	390075
29865	50115	6	applied	\N	\N	\N	\N	223063	223063	390076
29865	50116	7	applied	\N	\N	\N	\N	223064	223064	390077
29865	50117	8	applied	\N	\N	\N	\N	223065	223065	390078
29869	50118	0	applied	\N	\N	\N	\N	223096	223096	390109
29869	50119	1	applied	\N	\N	\N	\N	223097	223097	390110
29869	50120	2	applied	\N	\N	\N	\N	223098	223098	390111
29869	50121	3	applied	\N	\N	\N	\N	223099	223099	390112
29869	50122	4	applied	\N	\N	\N	\N	223100	223100	390113
29869	50123	5	applied	\N	\N	\N	\N	223101	223101	390114
29869	50124	6	applied	\N	\N	\N	\N	223102	223102	390115
29869	50125	7	applied	\N	\N	\N	\N	223103	223103	390116
29869	50126	8	applied	\N	\N	\N	\N	223104	223104	390117
29869	50127	9	applied	\N	\N	\N	\N	223105	223105	390118
29872	50128	0	applied	\N	\N	\N	\N	223146	223146	390159
29872	50130	2	applied	\N	\N	\N	\N	223148	223148	390161
29872	50132	3	applied	\N	\N	\N	\N	223149	223149	390162
29872	50133	4	applied	\N	\N	\N	\N	223150	223150	390163
29872	50134	5	applied	\N	\N	\N	\N	223151	223151	390164
29872	50135	6	applied	\N	\N	\N	\N	223152	223152	390165
29872	50137	7	applied	\N	\N	\N	\N	223153	223153	390166
29872	50138	8	applied	\N	\N	\N	\N	223154	223154	390167
29872	50139	9	applied	\N	\N	\N	\N	223155	223155	390168
29872	50140	10	applied	\N	\N	\N	\N	223156	223156	390169
29872	50145	11	applied	\N	\N	\N	\N	223157	223157	390170
29872	50146	12	applied	\N	\N	\N	\N	223158	223158	390171
29872	50147	13	applied	\N	\N	\N	\N	223159	223159	390172
29878	48846	0	applied	\N	\N	1000000000	\N	223322	223322	390335
29878	48733	1	applied	\N	\N	\N	\N	223323	223323	223323
29878	48707	2	applied	\N	\N	\N	\N	223324	223324	390336
29878	48961	3	applied	\N	\N	\N	\N	223325	223325	390337
29878	48734	5	applied	\N	\N	\N	\N	223327	223327	390339
29878	48753	6	applied	\N	\N	\N	\N	223328	223328	390340
29878	48598	7	applied	\N	\N	\N	\N	223329	223329	390341
29878	49148	8	applied	\N	\N	\N	\N	223330	223330	390342
29878	49157	9	applied	\N	\N	\N	\N	223331	223331	390343
29878	49607	10	applied	\N	\N	\N	\N	223332	223332	390344
29878	48973	11	applied	\N	\N	\N	\N	223333	223333	390345
29878	48754	12	applied	\N	\N	1000000000	\N	223334	223334	390346
29878	48627	13	applied	\N	\N	\N	\N	223335	223335	390347
29878	48963	14	applied	\N	\N	\N	\N	223336	223336	390348
29878	49138	15	applied	\N	\N	\N	\N	223337	223337	390349
29878	48642	16	applied	\N	\N	\N	\N	223338	223338	390350
29878	48935	17	applied	\N	\N	\N	\N	223339	223339	223339
29878	49093	18	applied	\N	\N	\N	\N	223340	223340	390351
29878	49094	19	applied	\N	\N	\N	\N	223341	223341	390352
29883	50207	0	applied	\N	\N	\N	\N	223402	223402	390413
29883	50209	2	applied	\N	\N	\N	\N	223404	223404	390415
29883	50210	3	applied	\N	\N	\N	\N	223405	223405	390416
29883	50211	4	applied	\N	\N	\N	\N	223406	223406	390417
29883	50212	5	applied	\N	\N	\N	\N	223407	223407	390418
29883	50213	6	applied	\N	\N	\N	\N	223408	223408	390419
29883	50214	7	applied	\N	\N	\N	\N	223409	223409	390420
29883	50215	8	applied	\N	\N	\N	\N	223410	223410	390421
29883	50216	9	applied	\N	\N	\N	\N	223411	223411	390422
29883	50217	10	applied	\N	\N	\N	\N	223412	223412	390423
29883	50218	11	applied	\N	\N	\N	\N	223413	223413	390424
29883	50219	12	applied	\N	\N	\N	\N	223414	223414	390425
29883	50220	13	applied	\N	\N	\N	\N	223415	223415	390426
29883	50221	14	applied	\N	\N	\N	\N	223416	223416	390427
29883	50222	15	applied	\N	\N	\N	\N	223417	223417	390428
29883	50223	16	applied	\N	\N	\N	\N	223418	223418	390429
29883	50224	17	applied	\N	\N	\N	\N	223419	223419	390430
29848	49985	24	applied	\N	\N	\N	\N	222865	222865	389878
29848	49987	25	applied	\N	\N	\N	\N	222866	222866	389879
29853	50028	4	applied	\N	\N	\N	\N	222930	222930	389943
29853	50023	5	applied	\N	\N	\N	\N	222931	222931	389944
29853	50029	6	applied	\N	\N	\N	\N	222932	222932	389945
29853	50030	7	applied	\N	\N	\N	\N	222933	222933	389946
29853	50031	8	applied	\N	\N	\N	\N	222934	222934	389947
29853	50032	9	applied	\N	\N	\N	\N	222935	222935	389948
29853	50033	10	applied	\N	\N	\N	\N	222936	222936	389949
29853	50034	11	applied	\N	\N	\N	\N	222937	222937	389950
29853	50035	12	applied	\N	\N	\N	\N	222938	222938	389951
29853	50036	13	applied	\N	\N	\N	\N	222939	222939	389952
29853	50037	14	applied	\N	\N	\N	\N	222940	222940	389953
29853	50038	15	applied	\N	\N	\N	\N	222941	222941	389954
29853	50039	16	applied	\N	\N	\N	\N	222942	222942	389955
29853	50040	17	applied	\N	\N	\N	\N	222943	222943	389956
29853	50041	18	applied	\N	\N	\N	\N	222944	222944	389957
29854	50050	8	applied	\N	\N	\N	\N	222953	222953	389966
29855	50052	1	applied	\N	\N	\N	\N	222955	222955	389968
29855	50053	2	applied	\N	\N	\N	\N	222956	222956	389969
29855	50054	3	applied	\N	\N	\N	\N	222957	222957	389970
29855	50055	4	applied	\N	\N	\N	\N	222958	222958	389971
29855	50056	5	applied	\N	\N	\N	\N	222959	222959	389972
29855	50057	6	applied	\N	\N	\N	\N	222960	222960	389973
29855	50058	7	applied	\N	\N	\N	\N	222961	222961	389974
29855	50059	8	applied	\N	\N	\N	\N	222962	222962	389975
29855	50060	9	applied	\N	\N	\N	\N	222963	222963	389976
29856	50051	0	applied	\N	\N	\N	\N	222964	222964	389977
29856	50052	1	applied	\N	\N	\N	\N	222965	222965	389978
29856	50053	2	applied	\N	\N	\N	\N	222966	222966	389979
29856	50054	3	applied	\N	\N	\N	\N	222967	222967	389980
29856	50055	4	applied	\N	\N	\N	\N	222968	222968	389981
29856	50056	5	applied	\N	\N	\N	\N	222969	222969	389982
29856	50057	6	applied	\N	\N	\N	\N	222970	222970	389983
29856	50059	8	applied	\N	\N	\N	\N	222972	222972	389985
29856	50060	9	applied	\N	\N	\N	\N	222973	222973	389986
29858	50061	0	applied	\N	\N	\N	\N	222981	222981	389994
29858	50062	1	applied	\N	\N	\N	\N	222982	222982	389995
29858	50063	2	applied	\N	\N	\N	\N	222983	222983	389996
29858	50064	3	applied	\N	\N	\N	\N	222984	222984	389997
29858	50065	4	applied	\N	\N	\N	\N	222985	222985	389998
29858	50066	5	applied	\N	\N	\N	\N	222986	222986	389999
29858	50067	6	applied	\N	\N	\N	\N	222987	222987	390000
29858	50068	7	applied	\N	\N	\N	\N	222988	222988	390001
29858	50069	8	applied	\N	\N	\N	\N	222989	222989	390002
29861	50080	0	applied	\N	\N	\N	\N	223010	223010	390023
29861	50081	1	applied	\N	\N	\N	\N	223011	223011	390024
29861	50082	2	applied	\N	\N	\N	\N	223012	223012	390025
29861	50083	3	applied	\N	\N	\N	\N	223013	223013	390026
29861	50084	4	applied	\N	\N	\N	\N	223014	223014	390027
29861	50086	6	applied	\N	\N	\N	\N	223016	223016	390029
29861	50087	7	applied	\N	\N	\N	\N	223017	223017	390030
29861	50088	8	applied	\N	\N	\N	\N	223018	223018	390031
29861	50089	9	applied	\N	\N	\N	\N	223019	223019	390032
29862	50090	0	applied	\N	\N	\N	\N	223020	223020	390033
29862	50091	1	applied	\N	\N	\N	\N	223021	223021	390034
29862	50092	2	applied	\N	\N	\N	\N	223022	223022	390035
29862	50093	3	applied	\N	\N	\N	\N	223023	223023	390036
29862	50094	4	applied	\N	\N	\N	\N	223024	223024	390037
29862	50095	5	applied	\N	\N	\N	\N	223025	223025	390038
29862	50096	6	applied	\N	\N	\N	\N	223026	223026	390039
29862	50097	7	applied	\N	\N	\N	\N	223027	223027	390040
29862	50098	8	applied	\N	\N	\N	\N	223028	223028	390041
29862	50099	9	applied	\N	\N	\N	\N	223029	223029	390042
29862	50100	10	applied	\N	\N	\N	\N	223030	223030	390043
29864	50109	0	applied	\N	\N	\N	\N	223048	223048	390061
29864	50111	2	applied	\N	\N	\N	\N	223050	223050	390063
29864	50112	3	applied	\N	\N	\N	\N	223051	223051	390064
29864	50113	4	applied	\N	\N	\N	\N	223052	223052	390065
29864	50114	5	applied	\N	\N	\N	\N	223053	223053	390066
29864	50115	6	applied	\N	\N	\N	\N	223054	223054	390067
29864	50116	7	applied	\N	\N	\N	\N	223055	223055	390068
29864	50117	8	applied	\N	\N	\N	\N	223056	223056	390069
29866	50118	0	applied	\N	\N	\N	\N	223066	223066	390079
29866	50119	1	applied	\N	\N	\N	\N	223067	223067	390080
29866	50120	2	applied	\N	\N	\N	\N	223068	223068	390081
29866	50121	3	applied	\N	\N	\N	\N	223069	223069	390082
29866	50122	4	applied	\N	\N	\N	\N	223070	223070	390083
29866	50123	5	applied	\N	\N	\N	\N	223071	223071	390084
29866	50124	6	applied	\N	\N	\N	\N	223072	223072	390085
29866	50125	7	applied	\N	\N	\N	\N	223073	223073	390086
29866	50126	8	applied	\N	\N	\N	\N	223074	223074	390087
29871	50128	0	applied	\N	\N	\N	\N	223126	223126	390139
29871	50129	1	applied	\N	\N	\N	\N	223127	223127	390140
29871	50130	2	applied	\N	\N	\N	\N	223128	223128	390141
29871	50131	3	applied	\N	\N	\N	\N	223129	223129	390142
29871	50132	4	applied	\N	\N	\N	\N	223130	223130	390143
29871	50133	5	applied	\N	\N	\N	\N	223131	223131	390144
29871	50134	6	applied	\N	\N	\N	\N	223132	223132	390145
29871	50135	7	applied	\N	\N	\N	\N	223133	223133	390146
29871	50136	8	applied	\N	\N	\N	\N	223134	223134	390147
29871	50137	9	applied	\N	\N	\N	\N	223135	223135	390148
29871	50138	10	applied	\N	\N	\N	\N	223136	223136	390149
29871	50139	11	applied	\N	\N	\N	\N	223137	223137	390150
29871	50140	12	applied	\N	\N	\N	\N	223138	223138	390151
29871	50141	13	applied	\N	\N	\N	\N	223139	223139	390152
29871	50142	14	applied	\N	\N	\N	\N	223140	223140	390153
29871	50143	15	applied	\N	\N	\N	\N	223141	223141	390154
29871	50145	17	applied	\N	\N	\N	\N	223143	223143	390156
29871	50146	18	applied	\N	\N	\N	\N	223144	223144	390157
29871	50147	19	applied	\N	\N	\N	\N	223145	223145	390158
29875	50148	0	applied	\N	\N	\N	\N	223177	223177	390190
29875	50155	1	applied	\N	\N	\N	\N	223178	223178	390191
29875	50156	2	applied	\N	\N	\N	\N	223179	223179	390192
29875	50149	3	applied	\N	\N	\N	\N	223180	223180	390193
29875	50150	4	applied	\N	\N	\N	\N	223181	223181	390194
29875	50157	5	applied	\N	\N	\N	\N	223182	223182	390195
29877	50158	0	applied	\N	\N	\N	\N	223303	223303	390316
29877	50159	1	applied	\N	\N	\N	\N	223304	223304	390317
29877	50160	2	applied	\N	\N	\N	\N	223305	223305	390318
29877	50161	3	applied	\N	\N	\N	\N	223306	223306	390319
29877	50162	4	applied	\N	\N	\N	\N	223307	223307	390320
29853	50025	1	applied	\N	\N	\N	\N	222927	222927	389940
29853	50026	2	applied	\N	\N	\N	\N	222928	222928	389941
29862	50105	15	applied	\N	\N	\N	\N	223035	223035	390048
29862	50106	16	applied	\N	\N	\N	\N	223036	223036	390049
29862	50107	17	applied	\N	\N	\N	\N	223037	223037	390050
29862	50108	18	applied	\N	\N	\N	\N	223038	223038	390051
29867	50118	0	applied	\N	\N	\N	\N	223076	223076	390089
29867	50119	1	applied	\N	\N	\N	\N	223077	223077	390090
29867	50120	2	applied	\N	\N	\N	\N	223078	223078	390091
29867	50121	3	applied	\N	\N	\N	\N	223079	223079	390092
29867	50122	4	applied	\N	\N	\N	\N	223080	223080	390093
29867	50123	5	applied	\N	\N	\N	\N	223081	223081	390094
29867	50124	6	applied	\N	\N	\N	\N	223082	223082	390095
29867	50125	7	applied	\N	\N	\N	\N	223083	223083	390096
29867	50126	8	applied	\N	\N	\N	\N	223084	223084	390097
29867	50127	9	applied	\N	\N	\N	\N	223085	223085	390098
29868	50122	4	applied	\N	\N	\N	\N	223090	223090	390103
29868	50123	5	applied	\N	\N	\N	\N	223091	223091	390104
29868	50125	7	applied	\N	\N	\N	\N	223093	223093	390106
29868	50126	8	applied	\N	\N	\N	\N	223094	223094	390107
29868	50127	9	applied	\N	\N	\N	\N	223095	223095	390108
29870	50128	0	applied	\N	\N	\N	\N	223106	223106	390119
29870	50129	1	applied	\N	\N	\N	\N	223107	223107	390120
29870	50130	2	applied	\N	\N	\N	\N	223108	223108	390121
29870	50131	3	applied	\N	\N	\N	\N	223109	223109	390122
29870	50132	4	applied	\N	\N	\N	\N	223110	223110	390123
29870	50133	5	applied	\N	\N	\N	\N	223111	223111	390124
29870	50134	6	applied	\N	\N	\N	\N	223112	223112	390125
29870	50135	7	applied	\N	\N	\N	\N	223113	223113	390126
29870	50136	8	applied	\N	\N	\N	\N	223114	223114	390127
29870	50137	9	applied	\N	\N	\N	\N	223115	223115	390128
29870	50138	10	applied	\N	\N	\N	\N	223116	223116	390129
29870	50139	11	applied	\N	\N	\N	\N	223117	223117	390130
29870	50140	12	applied	\N	\N	\N	\N	223118	223118	390131
29870	50142	14	applied	\N	\N	\N	\N	223120	223120	390133
29870	50143	15	applied	\N	\N	\N	\N	223121	223121	390134
29873	50148	0	applied	\N	\N	\N	\N	223160	223160	390173
29873	50149	1	applied	\N	\N	\N	\N	223161	223161	390174
29873	50150	2	applied	\N	\N	\N	\N	223162	223162	390175
29873	50151	3	applied	\N	\N	\N	\N	223163	223163	390176
29873	50152	4	applied	\N	\N	\N	\N	223164	223164	390177
29873	50153	5	applied	\N	\N	\N	\N	223165	223165	390178
29873	50154	6	applied	\N	\N	\N	\N	223166	223166	390179
29876	50009	0	applied	\N	\N	\N	\N	223183	223183	390196
29876	49806	1	applied	\N	\N	\N	\N	223184	223184	390197
29876	50010	2	applied	\N	\N	\N	\N	223185	223185	390198
29876	49754	3	applied	\N	\N	\N	\N	223186	223186	390199
29876	50011	4	applied	\N	\N	\N	\N	223187	223187	390200
29876	49758	5	applied	\N	\N	\N	\N	223188	223188	390201
29876	49768	7	applied	\N	\N	\N	\N	223189	223189	390202
29876	49797	9	applied	\N	\N	\N	\N	223191	223191	390204
29876	49807	10	applied	\N	\N	\N	\N	223192	223192	390205
29876	49817	11	applied	\N	\N	\N	\N	223193	223193	390206
29876	49826	12	applied	\N	\N	\N	\N	223194	223194	390207
29876	49832	13	applied	\N	\N	\N	\N	223195	223195	390208
29876	49843	14	applied	\N	\N	\N	\N	223196	223196	390209
29876	49849	15	applied	\N	\N	\N	\N	223197	223197	390210
29876	49854	16	applied	\N	\N	\N	\N	223198	223198	390211
29876	49859	17	applied	\N	\N	\N	\N	223199	223199	390212
29876	49867	18	applied	\N	\N	\N	\N	223200	223200	390213
29876	50013	19	applied	\N	\N	\N	\N	223201	223201	390214
29876	49868	20	applied	\N	\N	\N	\N	223202	223202	390215
29876	49890	21	applied	\N	\N	\N	\N	223203	223203	390216
29876	49947	22	applied	\N	\N	\N	\N	223204	223204	390217
29876	49953	23	applied	\N	\N	\N	\N	223205	223205	390218
29876	49958	24	applied	\N	\N	\N	\N	223206	223206	390219
29876	50000	26	applied	\N	\N	\N	\N	223208	223208	390221
29876	50012	27	applied	\N	\N	\N	\N	223209	223209	390222
29876	50024	28	applied	\N	\N	\N	\N	223210	223210	390223
29876	50025	29	applied	\N	\N	\N	\N	223211	223211	390224
29876	50042	30	applied	\N	\N	\N	\N	223212	223212	390225
29876	50051	31	applied	\N	\N	\N	\N	223213	223213	390226
29876	50061	32	applied	\N	\N	\N	\N	223214	223214	390227
29876	50070	33	applied	\N	\N	\N	\N	223215	223215	390228
29876	50080	34	applied	\N	\N	\N	\N	223216	223216	390229
29876	50090	35	applied	\N	\N	\N	\N	223217	223217	390230
29876	50091	36	applied	\N	\N	\N	\N	223218	223218	390231
29876	50109	37	applied	\N	\N	\N	\N	223219	223219	390232
29876	50119	38	applied	\N	\N	\N	\N	223220	223220	390233
29876	50128	39	applied	\N	\N	\N	\N	223221	223221	390234
29876	50129	40	applied	\N	\N	\N	\N	223222	223222	390235
29876	50148	41	applied	\N	\N	\N	\N	223223	223223	390236
29876	49755	43	applied	\N	\N	\N	\N	223225	223225	390238
29876	49760	44	applied	\N	\N	\N	\N	223226	223226	390239
29876	49769	45	applied	\N	\N	\N	\N	223227	223227	390240
29876	49770	46	applied	\N	\N	\N	\N	223228	223228	390241
29876	49771	47	applied	\N	\N	\N	\N	223229	223229	390242
29876	49756	48	applied	\N	\N	\N	\N	223230	223230	390243
29876	49757	49	applied	\N	\N	\N	\N	223231	223231	390244
29876	49759	50	applied	\N	\N	\N	\N	223232	223232	390245
29876	49762	51	applied	\N	\N	\N	\N	223233	223233	390246
29876	49763	52	applied	\N	\N	\N	\N	223234	223234	390247
29876	49794	53	applied	\N	\N	\N	\N	223235	223235	390248
29876	49795	54	applied	\N	\N	\N	\N	223236	223236	390249
29876	49801	55	applied	\N	\N	\N	\N	223237	223237	390250
29876	49808	56	applied	\N	\N	\N	\N	223238	223238	390251
29876	49815	57	applied	\N	\N	\N	\N	223239	223239	390252
29876	49821	58	applied	\N	\N	\N	\N	223240	223240	390253
29876	49828	60	applied	\N	\N	\N	\N	223242	223242	390255
29876	49833	61	applied	\N	\N	\N	\N	223243	223243	390256
29876	49844	62	applied	\N	\N	\N	\N	223244	223244	390257
29876	49848	63	applied	\N	\N	\N	\N	223245	223245	390258
29876	49851	64	applied	\N	\N	\N	\N	223246	223246	390259
29876	49855	65	applied	\N	\N	\N	\N	223247	223247	390260
29876	49856	66	applied	\N	\N	\N	\N	223248	223248	390261
29876	49862	67	applied	\N	\N	\N	\N	223249	223249	390262
29876	49869	68	applied	\N	\N	\N	\N	223250	223250	390263
29876	49870	69	applied	\N	\N	\N	\N	223251	223251	390264
29876	49871	70	applied	\N	\N	\N	\N	223252	223252	390265
29876	49892	71	applied	\N	\N	\N	\N	223253	223253	390266
29876	49893	72	applied	\N	\N	\N	\N	223254	223254	390267
29876	49894	73	applied	\N	\N	\N	\N	223255	223255	390268
29862	50102	12	applied	\N	\N	\N	\N	223032	223032	390045
29862	50103	13	applied	\N	\N	\N	\N	223033	223033	390046
29874	50148	0	applied	\N	\N	\N	\N	223167	223167	390180
29874	50155	1	applied	\N	\N	\N	\N	223168	223168	390181
29874	50156	2	applied	\N	\N	\N	\N	223169	223169	390182
29874	50149	3	applied	\N	\N	\N	\N	223170	223170	390183
29874	50150	4	applied	\N	\N	\N	\N	223171	223171	390184
29874	50151	5	applied	\N	\N	\N	\N	223172	223172	390185
29874	50152	6	applied	\N	\N	\N	\N	223173	223173	390186
29874	50153	7	applied	\N	\N	\N	\N	223174	223174	390187
29874	50154	8	applied	\N	\N	\N	\N	223175	223175	390188
29874	50157	9	applied	\N	\N	\N	\N	223176	223176	390189
29876	49895	74	applied	\N	\N	\N	\N	223256	223256	390269
29876	49896	75	applied	\N	\N	\N	\N	223257	223257	390270
29876	49919	76	applied	\N	\N	\N	\N	223258	223258	390271
29876	49926	77	applied	\N	\N	\N	\N	223259	223259	390272
29876	49931	78	applied	\N	\N	\N	\N	223260	223260	390273
29876	49935	79	applied	\N	\N	\N	\N	223261	223261	390274
29876	49937	81	applied	\N	\N	\N	\N	223263	223263	390276
29876	49938	82	applied	\N	\N	\N	\N	223264	223264	390277
29876	49949	83	applied	\N	\N	\N	\N	223265	223265	390278
29876	49950	84	applied	\N	\N	\N	\N	223266	223266	390279
29876	49955	85	applied	\N	\N	\N	\N	223267	223267	390280
29876	49960	86	applied	\N	\N	\N	\N	223268	223268	390281
29876	49961	87	applied	\N	\N	\N	\N	223269	223269	390282
29876	49962	88	applied	\N	\N	\N	\N	223270	223270	390283
29876	50005	89	applied	\N	\N	\N	\N	223271	223271	390284
29876	50019	90	applied	\N	\N	\N	\N	223272	223272	390285
29876	50022	91	applied	\N	\N	\N	\N	223273	223273	390286
29876	50026	92	applied	\N	\N	\N	\N	223274	223274	390287
29876	50027	93	applied	\N	\N	\N	\N	223275	223275	390288
29876	50028	94	applied	\N	\N	\N	\N	223276	223276	390289
29876	50050	95	applied	\N	\N	\N	\N	223277	223277	390290
29880	50177	0	applied	\N	\N	\N	\N	223352	223352	390363
29880	50179	3	applied	\N	\N	\N	\N	223354	223354	390365
29880	50180	4	applied	\N	\N	\N	\N	223355	223355	390366
29880	50181	5	applied	\N	\N	\N	\N	223356	223356	390367
29880	50182	6	applied	\N	\N	\N	\N	223357	223357	390368
29880	50183	7	applied	\N	\N	\N	\N	223358	223358	390369
29880	50184	8	applied	\N	\N	\N	\N	223359	223359	390370
29880	50185	9	applied	\N	\N	\N	\N	223360	223360	390371
29880	50186	10	applied	\N	\N	\N	\N	223361	223361	390372
29884	50207	0	applied	\N	\N	\N	\N	223422	223422	390433
29884	50208	1	applied	\N	\N	\N	\N	223423	223423	390434
29884	50209	2	applied	\N	\N	\N	\N	223424	223424	390435
29884	50210	3	applied	\N	\N	\N	\N	223425	223425	390436
29884	50211	4	applied	\N	\N	\N	\N	223426	223426	390437
29884	50212	5	applied	\N	\N	\N	\N	223427	223427	390438
29884	50213	6	applied	\N	\N	\N	\N	223428	223428	390439
29884	50214	7	applied	\N	\N	\N	\N	223429	223429	390440
29884	50216	9	applied	\N	\N	\N	\N	223431	223431	390442
29884	50217	10	applied	\N	\N	\N	\N	223432	223432	390443
29884	50218	11	applied	\N	\N	\N	\N	223433	223433	390444
29884	50219	12	applied	\N	\N	\N	\N	223434	223434	390445
29884	50220	13	applied	\N	\N	\N	\N	223435	223435	390446
29884	50221	14	applied	\N	\N	\N	\N	223436	223436	390447
29884	50222	15	applied	\N	\N	\N	\N	223437	223437	390448
29884	50223	16	applied	\N	\N	\N	\N	223438	223438	390449
29884	50224	17	applied	\N	\N	\N	\N	223439	223439	390450
29884	50225	18	applied	\N	\N	\N	\N	223440	223440	390451
29884	50226	19	applied	\N	\N	\N	\N	223441	223441	390452
29886	50227	0	applied	\N	\N	\N	\N	223451	223451	390462
29886	50228	1	applied	\N	\N	\N	\N	223452	223452	390463
29886	50229	2	applied	\N	\N	\N	\N	223453	223453	390464
29886	50230	3	applied	\N	\N	\N	\N	223454	223454	390465
29886	50231	4	applied	\N	\N	\N	\N	223455	223455	390466
29886	50233	6	applied	\N	\N	\N	\N	223457	223457	390468
29886	50234	7	applied	\N	\N	\N	\N	223458	223458	390469
29886	50235	8	applied	\N	\N	\N	\N	223459	223459	390470
29895	50255	0	applied	\N	\N	\N	\N	223532	223532	390543
29895	50256	1	applied	\N	\N	\N	\N	223533	223533	390544
29895	50257	2	applied	\N	\N	\N	\N	223534	223534	390545
29895	50258	3	applied	\N	\N	\N	\N	223535	223535	390546
29895	50259	4	applied	\N	\N	\N	\N	223536	223536	390547
29895	50260	5	applied	\N	\N	\N	\N	223537	223537	390548
29895	50261	6	applied	\N	\N	\N	\N	223538	223538	390549
29895	50262	7	applied	\N	\N	\N	\N	223539	223539	390550
29895	50263	8	applied	\N	\N	\N	\N	223540	223540	390551
29895	50264	9	applied	\N	\N	\N	\N	223541	223541	390552
29897	50255	0	applied	\N	\N	\N	\N	223552	223552	390563
29897	50256	1	applied	\N	\N	\N	\N	223553	223553	390564
29897	50257	2	applied	\N	\N	\N	\N	223554	223554	390565
29897	50259	4	applied	\N	\N	\N	\N	223556	223556	390567
29897	50260	5	applied	\N	\N	\N	\N	223557	223557	390568
29897	50261	6	applied	\N	\N	\N	\N	223558	223558	390569
29897	50262	7	applied	\N	\N	\N	\N	223559	223559	390570
29897	50263	8	applied	\N	\N	\N	\N	223560	223560	390571
29897	50264	9	applied	\N	\N	\N	\N	223561	223561	390572
29911	50315	0	applied	\N	\N	\N	\N	223675	223675	390678
29911	50316	1	applied	\N	\N	\N	\N	223676	223676	390679
29911	50317	2	applied	\N	\N	\N	\N	223677	223677	390680
29911	50318	3	applied	\N	\N	\N	\N	223678	223678	390681
29911	50319	4	applied	\N	\N	\N	\N	223679	223679	390682
29911	50320	5	applied	\N	\N	\N	\N	223680	223680	390683
29911	50321	6	applied	\N	\N	\N	\N	223681	223681	390684
29911	50322	7	applied	\N	\N	\N	\N	223682	223682	390685
29911	50323	8	applied	\N	\N	\N	\N	223683	223683	390686
29911	50324	9	applied	\N	\N	\N	\N	223684	223684	390687
29920	50286	1	applied	\N	\N	\N	\N	223752	223752	390752
29920	50295	2	applied	\N	\N	\N	\N	223753	223753	390753
29920	50310	3	applied	\N	\N	\N	\N	223754	223754	390754
29920	50315	4	applied	\N	\N	\N	\N	223755	223755	390755
29920	50325	5	applied	\N	\N	\N	\N	223756	223756	390756
29920	50333	6	applied	\N	\N	\N	\N	223757	223757	390757
29920	50343	7	applied	\N	\N	\N	\N	223758	223758	390758
29920	50276	8	applied	\N	\N	\N	\N	223759	223759	390759
29920	50277	9	applied	\N	\N	\N	\N	223760	223760	223760
29920	50278	10	applied	\N	\N	\N	\N	223761	223761	390760
29920	50279	12	applied	\N	\N	\N	\N	223762	223762	390761
29920	50280	13	applied	\N	\N	\N	\N	223763	223763	390762
29920	50281	14	applied	\N	\N	\N	\N	223764	223764	390763
29920	50282	15	applied	\N	\N	\N	\N	223765	223765	390764
29870	50145	17	applied	\N	\N	\N	\N	223123	223123	390136
29870	50146	18	applied	\N	\N	\N	\N	223124	223124	390137
29876	50076	100	applied	\N	\N	\N	\N	223282	223282	390295
29876	50088	101	applied	\N	\N	\N	\N	223283	223283	390296
29876	50095	102	applied	\N	\N	\N	\N	223284	223284	390297
29876	50096	103	applied	\N	\N	\N	\N	223285	223285	390298
29876	50097	104	applied	\N	\N	\N	\N	223286	223286	390299
29876	50112	105	applied	\N	\N	\N	\N	223287	223287	390300
29876	50113	106	applied	\N	\N	\N	\N	223288	223288	390301
29876	50122	107	applied	\N	\N	\N	\N	223289	223289	390302
29876	50130	108	applied	\N	\N	\N	\N	223290	223290	390303
29876	50132	109	applied	\N	\N	\N	\N	223291	223291	390304
29876	50133	110	applied	\N	\N	\N	\N	223292	223292	390305
29876	50149	111	applied	\N	\N	\N	\N	223293	223293	390306
29876	50150	112	applied	\N	\N	\N	\N	223294	223294	390307
29876	49781	113	applied	\N	\N	\N	\N	223295	223295	390308
29876	49782	114	applied	\N	\N	\N	\N	223296	223296	390309
29876	49783	115	applied	\N	\N	\N	\N	223297	223297	390310
29876	49785	117	applied	\N	\N	\N	\N	223299	223299	390312
29876	49786	118	applied	\N	\N	\N	\N	223300	223300	390313
29876	49791	119	applied	\N	\N	\N	\N	223301	223301	390314
29876	49796	120	applied	\N	\N	\N	\N	223302	223302	390315
29877	50163	5	applied	\N	\N	\N	\N	223308	223308	390321
29877	50164	6	applied	\N	\N	\N	\N	223309	223309	390322
29877	50165	7	applied	\N	\N	\N	\N	223310	223310	390323
29877	50166	8	applied	\N	\N	\N	\N	223311	223311	390324
29877	50167	9	applied	\N	\N	\N	\N	223312	223312	390325
29877	50168	10	applied	\N	\N	\N	\N	223313	223313	390326
29877	50169	11	applied	\N	\N	\N	\N	223314	223314	390327
29877	50170	12	applied	\N	\N	\N	\N	223315	223315	390328
29877	50171	13	applied	\N	\N	\N	\N	223316	223316	390329
29877	50172	14	applied	\N	\N	\N	\N	223317	223317	390330
29877	50173	15	applied	\N	\N	\N	\N	223318	223318	390331
29877	50174	16	applied	\N	\N	\N	\N	223319	223319	390332
29877	50176	18	applied	\N	\N	\N	\N	223321	223321	390334
29879	50177	0	applied	\N	\N	\N	\N	223342	223342	390353
29879	50178	1	applied	\N	\N	\N	\N	223343	223343	390354
29879	50179	3	applied	\N	\N	\N	\N	223344	223344	390355
29879	50180	4	applied	\N	\N	\N	\N	223345	223345	390356
29879	50181	5	applied	\N	\N	\N	\N	223346	223346	390357
29879	50182	6	applied	\N	\N	\N	\N	223347	223347	390358
29879	50183	7	applied	\N	\N	\N	\N	223348	223348	390359
29879	50184	8	applied	\N	\N	\N	\N	223349	223349	390360
29881	50187	0	applied	\N	\N	\N	\N	223362	223362	390373
29881	50188	1	applied	\N	\N	\N	\N	223363	223363	390374
29881	50189	2	applied	\N	\N	\N	\N	223364	223364	390375
29881	50190	3	applied	\N	\N	\N	\N	223365	223365	390376
29881	50191	4	applied	\N	\N	\N	\N	223366	223366	390377
29881	50192	5	applied	\N	\N	\N	\N	223367	223367	390378
29881	50193	6	applied	\N	\N	\N	\N	223368	223368	390379
29881	50195	8	applied	\N	\N	\N	\N	223370	223370	390381
29881	50196	9	applied	\N	\N	\N	\N	223371	223371	390382
29881	50197	10	applied	\N	\N	\N	\N	223372	223372	390383
29881	50198	11	applied	\N	\N	\N	\N	223373	223373	390384
29881	50199	12	applied	\N	\N	\N	\N	223374	223374	390385
29881	50200	13	applied	\N	\N	\N	\N	223375	223375	390386
29881	50201	14	applied	\N	\N	\N	\N	223376	223376	390387
29881	50202	15	applied	\N	\N	\N	\N	223377	223377	390388
29881	50203	16	applied	\N	\N	\N	\N	223378	223378	390389
29881	50204	17	applied	\N	\N	\N	\N	223379	223379	390390
29881	50205	18	applied	\N	\N	\N	\N	223380	223380	390391
29881	50206	19	applied	\N	\N	\N	\N	223381	223381	390392
29885	50227	0	applied	\N	\N	\N	\N	223442	223442	390453
29885	50228	1	applied	\N	\N	\N	\N	223443	223443	390454
29885	50229	2	applied	\N	\N	\N	\N	223444	223444	390455
29885	50230	3	applied	\N	\N	\N	\N	223445	223445	390456
29885	50232	5	applied	\N	\N	\N	\N	223447	223447	390458
29885	50233	6	applied	\N	\N	\N	\N	223448	223448	390459
29885	50234	7	applied	\N	\N	\N	\N	223449	223449	390460
29885	50235	8	applied	\N	\N	\N	\N	223450	223450	390461
29892	50246	0	applied	\N	\N	\N	\N	223504	223504	390515
29892	50247	1	applied	\N	\N	\N	\N	223505	223505	390516
29892	50248	2	applied	\N	\N	\N	\N	223506	223506	390517
29892	50249	3	applied	\N	\N	\N	\N	223507	223507	390518
29892	50250	4	applied	\N	\N	\N	\N	223508	223508	390519
29892	50251	5	applied	\N	\N	\N	\N	223509	223509	390520
29892	50252	6	applied	\N	\N	\N	\N	223510	223510	390521
29892	50253	7	applied	\N	\N	\N	\N	223511	223511	390522
29894	50255	0	applied	\N	\N	\N	\N	223522	223522	390533
29894	50256	1	applied	\N	\N	\N	\N	223523	223523	390534
29894	50257	2	applied	\N	\N	\N	\N	223524	223524	390535
29894	50258	3	applied	\N	\N	\N	\N	223525	223525	390536
29894	50260	5	applied	\N	\N	\N	\N	223527	223527	390538
29894	50261	6	applied	\N	\N	\N	\N	223528	223528	390539
29894	50262	7	applied	\N	\N	\N	\N	223529	223529	390540
29894	50263	8	applied	\N	\N	\N	\N	223530	223530	390541
29894	50264	9	applied	\N	\N	\N	\N	223531	223531	390542
29898	50265	0	applied	\N	\N	\N	\N	223562	223562	390573
29898	50266	1	applied	\N	\N	\N	\N	223563	223563	390574
29898	50267	2	applied	\N	\N	\N	\N	223564	223564	390575
29898	50268	3	applied	\N	\N	\N	\N	223565	223565	390576
29898	50269	4	applied	\N	\N	\N	\N	223566	223566	390577
29898	50270	5	applied	\N	\N	\N	\N	223567	223567	390578
29898	50271	6	applied	\N	\N	\N	\N	223568	223568	390579
29898	50272	7	applied	\N	\N	\N	\N	223569	223569	390580
29898	50273	8	applied	\N	\N	\N	\N	223570	223570	223570
29898	50274	9	applied	\N	\N	\N	\N	223571	223571	390581
29901	50265	0	applied	\N	\N	\N	\N	223592	223592	390600
29901	50267	2	applied	\N	\N	\N	\N	223594	223594	390602
29901	50268	3	applied	\N	\N	\N	\N	223595	223595	390603
29901	50269	4	applied	\N	\N	\N	\N	223596	223596	390604
29901	50270	5	applied	\N	\N	\N	\N	223597	223597	390605
29901	50271	6	applied	\N	\N	\N	\N	223598	223598	390606
29901	50272	7	applied	\N	\N	\N	\N	223599	223599	390607
29901	50273	8	applied	\N	\N	\N	\N	223600	223600	223600
29901	50274	9	applied	\N	\N	\N	\N	223601	223601	390608
29905	50286	0	applied	\N	\N	\N	\N	223630	223630	390635
29905	50287	1	applied	\N	\N	\N	\N	223631	223631	390636
29905	50288	2	applied	\N	\N	\N	\N	223632	223632	390637
29905	50289	3	applied	\N	\N	\N	\N	223633	223633	390638
29905	50290	4	applied	\N	\N	\N	\N	223634	223634	390639
29905	50291	5	applied	\N	\N	\N	\N	223635	223635	390640
29876	50056	97	applied	\N	\N	\N	\N	223279	223279	390292
29876	50065	98	applied	\N	\N	\N	\N	223280	223280	390293
29882	50209	2	applied	\N	\N	\N	\N	223384	223384	390395
29882	50210	3	applied	\N	\N	\N	\N	223385	223385	390396
29882	50211	4	applied	\N	\N	\N	\N	223386	223386	390397
29882	50212	5	applied	\N	\N	\N	\N	223387	223387	390398
29882	50213	6	applied	\N	\N	\N	\N	223388	223388	390399
29882	50214	7	applied	\N	\N	\N	\N	223389	223389	390400
29882	50215	8	applied	\N	\N	\N	\N	223390	223390	390401
29882	50216	9	applied	\N	\N	\N	\N	223391	223391	390402
29882	50217	10	applied	\N	\N	\N	\N	223392	223392	390403
29882	50218	11	applied	\N	\N	\N	\N	223393	223393	390404
29882	50219	12	applied	\N	\N	\N	\N	223394	223394	390405
29882	50220	13	applied	\N	\N	\N	\N	223395	223395	390406
29882	50221	14	applied	\N	\N	\N	\N	223396	223396	390407
29882	50222	15	applied	\N	\N	\N	\N	223397	223397	390408
29882	50223	16	applied	\N	\N	\N	\N	223398	223398	390409
29882	50224	17	applied	\N	\N	\N	\N	223399	223399	390410
29882	50226	19	applied	\N	\N	\N	\N	223401	223401	390412
29883	50226	19	applied	\N	\N	\N	\N	223421	223421	390432
29887	50227	0	applied	\N	\N	\N	\N	223460	223460	390471
29887	50228	1	applied	\N	\N	\N	\N	223461	223461	390472
29887	50229	2	applied	\N	\N	\N	\N	223462	223462	390473
29887	50230	3	applied	\N	\N	\N	\N	223463	223463	390474
29887	50231	4	applied	\N	\N	\N	\N	223464	223464	390475
29887	50232	5	applied	\N	\N	\N	\N	223465	223465	390476
29887	50233	6	applied	\N	\N	\N	\N	223466	223466	390477
29887	50234	7	applied	\N	\N	\N	\N	223467	223467	390478
29887	50235	8	applied	\N	\N	\N	\N	223468	223468	390479
29888	50236	0	applied	\N	\N	\N	\N	223469	223469	390480
29888	50237	1	applied	\N	\N	\N	\N	223470	223470	390481
29888	50238	2	applied	\N	\N	\N	\N	223471	223471	390482
29888	50239	3	applied	\N	\N	\N	\N	223472	223472	390483
29888	50240	4	applied	\N	\N	\N	\N	223473	223473	390484
29888	50242	6	applied	\N	\N	\N	\N	223475	223475	390486
29888	50243	7	applied	\N	\N	\N	\N	223476	223476	390487
29888	50244	8	applied	\N	\N	\N	\N	223477	223477	390488
29888	50245	9	applied	\N	\N	\N	\N	223478	223478	390489
29889	50236	0	applied	\N	\N	\N	\N	223479	223479	390490
29889	50237	1	applied	\N	\N	\N	\N	223480	223480	390491
29889	50238	2	applied	\N	\N	\N	\N	223481	223481	390492
29889	50239	3	applied	\N	\N	\N	\N	223482	223482	390493
29889	50240	4	applied	\N	\N	\N	\N	223483	223483	390494
29889	50241	5	applied	\N	\N	\N	\N	223484	223484	390495
29889	50242	6	applied	\N	\N	\N	\N	223485	223485	390496
29889	50243	7	applied	\N	\N	\N	\N	223486	223486	390497
29889	50244	8	applied	\N	\N	\N	\N	223487	223487	390498
29889	50245	9	applied	\N	\N	\N	\N	223488	223488	390499
29890	50236	0	applied	\N	\N	\N	\N	223489	223489	390500
29890	50237	1	applied	\N	\N	\N	\N	223490	223490	390501
29890	50242	3	applied	\N	\N	\N	\N	223492	223492	390503
29890	50243	4	applied	\N	\N	\N	\N	223493	223493	390504
29890	50244	5	applied	\N	\N	\N	\N	223494	223494	390505
29891	50246	0	applied	\N	\N	\N	\N	223495	223495	390506
29891	50247	1	applied	\N	\N	\N	\N	223496	223496	390507
29893	50255	0	applied	\N	\N	\N	\N	223512	223512	390523
29893	50256	1	applied	\N	\N	\N	\N	223513	223513	390524
29893	50257	2	applied	\N	\N	\N	\N	223514	223514	390525
29893	50258	3	applied	\N	\N	\N	\N	223515	223515	390526
29893	50259	4	applied	\N	\N	\N	\N	223516	223516	390527
29893	50260	5	applied	\N	\N	\N	\N	223517	223517	390528
29893	50261	6	applied	\N	\N	\N	\N	223518	223518	390529
29893	50262	7	applied	\N	\N	\N	\N	223519	223519	390530
29893	50263	8	applied	\N	\N	\N	\N	223520	223520	390531
29893	50264	9	applied	\N	\N	\N	\N	223521	223521	390532
29899	50265	0	applied	\N	\N	\N	\N	223572	223572	390582
29899	50267	2	applied	\N	\N	\N	\N	223574	223574	390584
29899	50268	3	applied	\N	\N	\N	\N	223575	223575	390585
29899	50269	4	applied	\N	\N	\N	\N	223576	223576	390586
29899	50270	5	applied	\N	\N	\N	\N	223577	223577	390587
29899	50271	6	applied	\N	\N	\N	\N	223578	223578	390588
29899	50272	7	applied	\N	\N	\N	\N	223579	223579	390589
29899	50273	8	applied	\N	\N	\N	\N	223580	223580	223580
29899	50274	9	applied	\N	\N	\N	\N	223581	223581	390590
29903	50275	0	applied	\N	\N	\N	\N	223610	223610	390616
29903	50276	1	applied	\N	\N	\N	\N	223611	223611	390617
29903	50277	2	applied	\N	\N	\N	\N	223612	223612	223612
29903	50278	3	applied	\N	\N	\N	\N	223613	223613	390618
29903	50279	4	applied	\N	\N	\N	\N	223614	223614	390619
29903	50280	5	applied	\N	\N	\N	\N	223615	223615	390620
29903	50281	6	applied	\N	\N	\N	\N	223616	223616	390621
29903	50282	7	applied	\N	\N	\N	\N	223617	223617	390622
29903	50284	9	applied	\N	\N	\N	\N	223619	223619	390624
29903	50285	10	applied	\N	\N	\N	\N	223620	223620	390625
29910	50310	0	applied	\N	\N	\N	\N	223666	223666	390669
29910	50307	1	applied	\N	\N	\N	\N	223667	223667	390670
29910	50311	2	applied	\N	\N	\N	\N	223668	223668	390671
29910	50312	3	applied	\N	\N	\N	\N	223669	223669	390672
29910	50313	4	applied	\N	\N	\N	\N	223670	223670	390673
29910	50306	5	applied	\N	\N	\N	\N	223671	223671	390674
29910	50314	6	applied	\N	\N	\N	\N	223672	223672	390675
29910	50308	7	applied	\N	\N	\N	\N	223673	223673	390676
29910	50309	8	applied	\N	\N	\N	\N	223674	223674	390677
29913	50315	0	applied	\N	\N	\N	\N	223693	223693	390696
29913	50316	1	applied	\N	\N	\N	\N	223694	223694	390697
29913	50317	2	applied	\N	\N	\N	\N	223695	223695	390698
29913	50318	3	applied	\N	\N	\N	\N	223696	223696	390699
29913	50319	4	applied	\N	\N	\N	\N	223697	223697	390700
29913	50321	6	applied	\N	\N	\N	\N	223699	223699	390702
29913	50322	7	applied	\N	\N	\N	\N	223700	223700	390703
29913	50323	8	applied	\N	\N	\N	\N	223701	223701	390704
29913	50324	9	applied	\N	\N	\N	\N	223702	223702	390705
29916	50325	0	applied	\N	\N	\N	\N	223718	223718	390718
29916	50319	1	applied	\N	\N	\N	\N	223719	223719	390719
29916	50326	2	applied	\N	\N	\N	\N	223720	223720	390720
29916	50327	3	applied	\N	\N	\N	\N	223721	223721	390721
29916	50328	4	applied	\N	\N	\N	\N	223722	223722	390722
29916	50324	5	applied	\N	\N	\N	\N	223723	223723	390723
29916	50329	6	applied	\N	\N	\N	\N	223724	223724	390724
29916	50330	7	applied	\N	\N	\N	\N	223725	223725	390725
29916	50331	8	applied	\N	\N	\N	\N	223726	223726	390726
29916	50332	9	applied	\N	\N	\N	\N	223727	223727	390727
29879	50186	10	applied	\N	\N	\N	\N	223351	223351	390362
29882	50207	0	applied	\N	\N	\N	\N	223382	223382	390393
29891	50252	6	applied	\N	\N	\N	\N	223501	223501	390512
29891	50253	7	applied	\N	\N	\N	\N	223502	223502	390513
29891	50254	8	applied	\N	\N	\N	\N	223503	223503	390514
29896	50255	0	applied	\N	\N	\N	\N	223542	223542	390553
29896	50256	1	applied	\N	\N	\N	\N	223543	223543	390554
29896	50257	2	applied	\N	\N	\N	\N	223544	223544	390555
29896	50258	3	applied	\N	\N	\N	\N	223545	223545	390556
29896	50259	4	applied	\N	\N	\N	\N	223546	223546	390557
29896	50260	5	applied	\N	\N	\N	\N	223547	223547	390558
29896	50261	6	applied	\N	\N	\N	\N	223548	223548	390559
29896	50262	7	applied	\N	\N	\N	\N	223549	223549	390560
29896	50263	8	applied	\N	\N	\N	\N	223550	223550	390561
29896	50264	9	applied	\N	\N	\N	\N	223551	223551	390562
29900	50265	0	applied	\N	\N	\N	\N	223582	223582	390591
29900	50266	1	applied	\N	\N	\N	\N	223583	223583	390592
29900	50267	2	applied	\N	\N	\N	\N	223584	223584	390593
29900	50269	4	applied	\N	\N	\N	\N	223586	223586	390595
29900	50270	5	applied	\N	\N	\N	\N	223587	223587	390596
29900	50271	6	applied	\N	\N	\N	\N	223588	223588	390597
29900	50272	7	applied	\N	\N	\N	\N	223589	223589	390598
29900	50273	8	applied	\N	\N	\N	\N	223590	223590	223590
29900	50274	9	applied	\N	\N	\N	\N	223591	223591	390599
29902	50265	0	applied	\N	\N	\N	\N	223602	223602	390609
29902	50266	1	applied	\N	\N	\N	\N	223603	223603	390610
29902	50267	2	applied	\N	\N	\N	\N	223604	223604	390611
29902	50269	3	applied	\N	\N	\N	\N	223605	223605	390612
29902	50270	4	applied	\N	\N	\N	\N	223606	223606	390613
29902	50271	5	applied	\N	\N	\N	\N	223607	223607	390614
29902	50272	6	applied	\N	\N	\N	\N	223608	223608	390615
29902	50273	7	applied	\N	\N	\N	\N	223609	223609	223609
29904	50286	0	applied	\N	\N	\N	\N	223621	223621	390626
29904	50287	1	applied	\N	\N	\N	\N	223622	223622	390627
29904	50289	3	applied	\N	\N	\N	\N	223624	223624	390629
29904	50290	4	applied	\N	\N	\N	\N	223625	223625	390630
29904	50291	5	applied	\N	\N	\N	\N	223626	223626	390631
29904	50292	6	applied	\N	\N	\N	\N	223627	223627	390632
29904	50293	7	applied	\N	\N	\N	\N	223628	223628	390633
29904	50294	8	applied	\N	\N	\N	\N	223629	223629	390634
29905	50292	6	applied	\N	\N	\N	\N	223636	223636	390641
29905	50293	7	applied	\N	\N	\N	\N	223637	223637	390642
29905	50294	8	applied	\N	\N	\N	\N	223638	223638	390643
29906	50295	0	applied	\N	\N	\N	\N	223639	223639	390644
29906	50296	1	applied	\N	\N	\N	\N	223640	223640	390645
29906	50297	2	applied	\N	\N	\N	\N	223641	223641	390646
29906	50298	3	applied	\N	\N	\N	\N	223642	223642	390647
29906	50299	4	applied	\N	\N	\N	\N	223643	223643	223643
29906	50300	5	applied	\N	\N	\N	\N	223644	223644	390648
29906	50301	6	applied	\N	\N	\N	\N	223645	223645	390649
29906	50303	8	applied	\N	\N	\N	\N	223647	223647	390651
29906	50304	9	applied	\N	\N	\N	\N	223648	223648	390652
29906	50305	10	applied	\N	\N	\N	\N	223649	223649	390653
29907	50295	0	applied	\N	\N	\N	\N	223650	223650	390654
29907	50296	1	applied	\N	\N	\N	\N	223651	223651	390655
29907	50297	2	applied	\N	\N	\N	\N	223652	223652	390656
29907	50298	3	applied	\N	\N	\N	\N	223653	223653	390657
29907	50299	4	applied	\N	\N	\N	\N	223654	223654	223654
29907	50300	5	applied	\N	\N	\N	\N	223655	223655	390658
29907	50301	6	applied	\N	\N	\N	\N	223656	223656	390659
29907	50302	7	applied	\N	\N	\N	\N	223657	223657	390660
29907	50303	8	applied	\N	\N	\N	\N	223658	223658	390661
29907	50304	9	applied	\N	\N	\N	\N	223659	223659	390662
29907	50305	10	applied	\N	\N	\N	\N	223660	223660	390663
29908	50306	0	applied	\N	\N	\N	\N	223661	223661	390664
29909	50307	0	applied	\N	\N	\N	\N	223662	223662	390665
29909	50308	2	applied	\N	\N	\N	\N	223664	223664	390667
29909	50309	3	applied	\N	\N	\N	\N	223665	223665	390668
29912	50315	0	applied	\N	\N	\N	\N	223685	223685	390688
29912	50316	1	applied	\N	\N	\N	\N	223686	223686	390689
29912	50317	2	applied	\N	\N	\N	\N	223687	223687	390690
29912	50318	3	applied	\N	\N	\N	\N	223688	223688	390691
29915	50325	0	applied	\N	\N	\N	\N	223711	223711	390711
29915	50326	1	applied	\N	\N	\N	\N	223712	223712	390712
29915	50327	2	applied	\N	\N	\N	\N	223713	223713	390713
29915	50328	3	applied	\N	\N	\N	\N	223714	223714	390714
29915	50329	4	applied	\N	\N	\N	\N	223715	223715	390715
29915	50330	5	applied	\N	\N	\N	\N	223716	223716	390716
29915	50331	6	applied	\N	\N	\N	\N	223717	223717	390717
29917	50333	0	applied	\N	\N	\N	\N	223728	223728	390728
29917	50334	1	applied	\N	\N	\N	\N	223729	223729	390729
29917	50335	2	applied	\N	\N	\N	\N	223730	223730	390730
29917	50337	4	applied	\N	\N	\N	\N	223732	223732	390732
29917	50338	5	applied	\N	\N	\N	\N	223733	223733	390733
29917	50339	6	applied	\N	\N	\N	\N	223734	223734	390734
29917	50340	7	applied	\N	\N	\N	\N	223735	223735	390735
29917	50341	8	applied	\N	\N	\N	\N	223736	223736	390736
29917	50342	9	applied	\N	\N	\N	\N	223737	223737	390737
29919	50343	0	applied	\N	\N	\N	\N	223742	223742	390742
29919	50344	1	applied	\N	\N	\N	\N	223743	223743	390743
29919	50345	2	applied	\N	\N	\N	\N	223744	223744	390744
29919	50347	3	applied	\N	\N	\N	\N	223745	223745	390745
29919	50348	4	applied	\N	\N	\N	\N	223746	223746	390746
29919	50346	5	applied	\N	\N	\N	\N	223747	223747	390747
29919	50349	6	applied	\N	\N	\N	\N	223748	223748	390748
29919	50350	7	applied	\N	\N	\N	\N	223749	223749	390749
29919	50351	8	applied	\N	\N	\N	\N	223750	223750	390750
29921	50343	0	applied	\N	\N	\N	\N	223828	223828	390826
29921	50345	2	applied	\N	\N	\N	\N	223830	223830	390828
29921	50347	3	applied	\N	\N	\N	\N	223831	223831	390829
29921	50348	4	applied	\N	\N	\N	\N	223832	223832	390830
29921	50346	5	applied	\N	\N	\N	\N	223833	223833	390831
29921	50349	6	applied	\N	\N	\N	\N	223834	223834	390832
29921	50350	7	applied	\N	\N	\N	\N	223835	223835	390833
29921	50351	8	applied	\N	\N	\N	\N	223836	223836	390834
29923	50352	0	applied	\N	\N	\N	\N	223845	223845	390843
29923	50353	1	applied	\N	\N	\N	\N	223846	223846	390844
29923	50354	2	applied	\N	\N	\N	\N	223847	223847	390845
29923	50355	3	applied	\N	\N	\N	\N	223848	223848	390846
29923	50356	4	applied	\N	\N	\N	\N	223849	223849	390847
29923	50357	5	applied	\N	\N	\N	\N	223850	223850	390848
29923	50358	6	applied	\N	\N	\N	\N	223851	223851	390849
29891	50249	3	applied	\N	\N	\N	\N	223498	223498	390509
29891	50250	4	applied	\N	\N	\N	\N	223499	223499	390510
29912	50323	7	applied	\N	\N	\N	\N	223692	223692	390695
29914	50265	0	applied	\N	\N	\N	\N	223703	223703	390706
29914	50158	1	applied	\N	\N	\N	\N	223704	223704	390707
29914	49582	2	applied	\N	\N	\N	\N	223705	223705	390708
29914	49583	3	applied	\N	\N	\N	\N	223706	223706	390709
29914	50273	4	applied	\N	\N	\N	\N	223707	223707	223707
29914	50277	5	applied	\N	\N	\N	\N	223708	223708	223708
29914	50299	6	applied	\N	\N	\N	\N	223709	223709	223709
29914	49593	7	applied	\N	\N	\N	\N	223710	223710	390710
29918	50343	0	applied	\N	\N	\N	\N	223738	223738	390738
29918	50344	1	applied	\N	\N	\N	\N	223739	223739	390739
29918	50345	2	applied	\N	\N	\N	\N	223740	223740	390740
29918	50346	3	applied	\N	\N	\N	\N	223741	223741	390741
29924	50353	1	applied	\N	\N	\N	\N	223854	223854	390852
29924	50354	2	applied	\N	\N	\N	\N	223855	223855	390853
29924	50355	3	applied	\N	\N	\N	\N	223856	223856	390854
29924	50356	4	applied	\N	\N	\N	\N	223857	223857	390855
29924	50357	5	applied	\N	\N	\N	\N	223858	223858	390856
29924	50358	6	applied	\N	\N	\N	\N	223859	223859	390857
29924	50359	7	applied	\N	\N	\N	\N	223860	223860	390858
29925	50360	0	applied	\N	\N	\N	\N	223861	223861	390859
29925	50361	1	applied	\N	\N	\N	\N	223862	223862	390860
29925	50362	2	applied	\N	\N	\N	\N	223863	223863	390861
29925	50363	3	applied	\N	\N	\N	\N	223864	223864	390862
29925	50364	4	applied	\N	\N	\N	\N	223865	223865	390863
29927	50360	0	applied	\N	\N	\N	\N	223885	223885	390883
29927	50361	1	applied	\N	\N	\N	\N	223886	223886	390884
29927	50365	2	applied	\N	\N	\N	\N	223887	223887	390885
29927	50366	3	applied	\N	\N	\N	\N	223888	223888	390886
29927	50368	5	applied	\N	\N	\N	\N	223890	223890	390888
29927	50362	6	applied	\N	\N	\N	\N	223891	223891	390889
29927	50363	7	applied	\N	\N	\N	\N	223892	223892	390890
29927	50364	8	applied	\N	\N	\N	\N	223893	223893	390891
29927	50369	9	applied	\N	\N	\N	\N	223894	223894	390892
29927	50370	10	applied	\N	\N	\N	\N	223895	223895	390893
29927	50371	11	applied	\N	\N	\N	\N	223896	223896	390894
29927	50372	12	applied	\N	\N	\N	\N	223897	223897	390895
29927	50373	13	applied	\N	\N	\N	\N	223898	223898	390896
29927	50374	14	applied	\N	\N	\N	\N	223899	223899	390897
29927	50375	15	applied	\N	\N	\N	\N	223900	223900	390898
29927	50376	16	applied	\N	\N	\N	\N	223901	223901	390899
29927	50377	17	applied	\N	\N	\N	\N	223902	223902	390900
29927	50378	18	applied	\N	\N	\N	\N	223903	223903	390901
29929	50379	0	applied	\N	\N	\N	\N	223923	223923	390921
29929	50380	1	applied	\N	\N	\N	\N	223924	223924	390922
29929	50366	3	applied	\N	\N	\N	\N	223926	223926	390924
29929	50367	4	applied	\N	\N	\N	\N	223927	223927	390925
29929	50368	5	applied	\N	\N	\N	\N	223928	223928	390926
29929	50369	6	applied	\N	\N	\N	\N	223929	223929	390927
29929	50370	7	applied	\N	\N	\N	\N	223930	223930	390928
29929	50381	8	applied	\N	\N	\N	\N	223931	223931	390929
29929	50382	9	applied	\N	\N	\N	\N	223932	223932	390930
29929	50371	10	applied	\N	\N	\N	\N	223933	223933	390931
29929	50372	11	applied	\N	\N	\N	\N	223934	223934	390932
29929	50373	12	applied	\N	\N	\N	\N	223935	223935	390933
29929	50374	13	applied	\N	\N	\N	\N	223936	223936	390934
29929	50375	14	applied	\N	\N	\N	\N	223937	223937	390935
29929	50376	15	applied	\N	\N	\N	\N	223938	223938	390936
29929	50377	16	applied	\N	\N	\N	\N	223939	223939	390937
29929	50378	17	applied	\N	\N	\N	\N	223940	223940	390938
29929	50383	18	applied	\N	\N	\N	\N	223941	223941	390939
29929	50385	20	applied	\N	\N	\N	\N	223943	223943	390941
29929	50386	21	applied	\N	\N	\N	\N	223944	223944	390942
29929	50387	22	applied	\N	\N	\N	\N	223945	223945	390943
29929	50388	23	applied	\N	\N	\N	\N	223946	223946	390944
29932	50389	0	applied	\N	\N	\N	\N	224042	224042	391037
29932	50390	1	applied	\N	\N	\N	\N	224043	224043	391038
29932	50391	2	applied	\N	\N	\N	\N	224044	224044	391039
29932	50392	3	applied	\N	\N	\N	\N	224045	224045	391040
29932	50393	4	applied	\N	\N	\N	\N	224046	224046	391041
29932	50394	5	applied	\N	\N	\N	\N	224047	224047	391042
29932	50395	6	applied	\N	\N	\N	\N	224048	224048	391043
29932	50396	7	applied	\N	\N	1000000000	\N	224049	224049	391044
29932	50397	8	applied	\N	\N	1000000000	\N	224050	224050	391045
29932	50398	9	applied	\N	\N	\N	\N	224051	224051	391046
29932	50399	10	applied	\N	\N	\N	\N	224052	224052	391047
29932	50400	11	applied	\N	\N	\N	\N	224053	224053	391048
29935	50405	1	applied	\N	\N	\N	\N	224083	224083	391078
29935	50406	2	applied	\N	\N	\N	\N	224084	224084	391079
29935	50407	3	applied	\N	\N	\N	\N	224085	224085	391080
29935	50408	4	applied	\N	\N	\N	\N	224086	224086	391081
29935	50409	5	applied	\N	\N	\N	\N	224087	224087	391082
29935	50410	6	applied	\N	\N	\N	\N	224088	224088	391083
29935	50411	7	applied	\N	\N	\N	\N	224089	224089	391084
29935	50412	8	applied	\N	\N	\N	\N	224090	224090	391085
29935	50413	9	applied	\N	\N	\N	\N	224091	224091	391086
29937	50404	0	applied	\N	\N	\N	\N	224102	224102	391097
29937	50405	1	applied	\N	\N	\N	\N	224103	224103	391098
29937	50406	2	applied	\N	\N	\N	\N	224104	224104	391099
29937	50407	3	applied	\N	\N	\N	\N	224105	224105	391100
29937	50408	4	applied	\N	\N	\N	\N	224106	224106	391101
29937	50409	5	applied	\N	\N	\N	\N	224107	224107	391102
29937	50410	6	applied	\N	\N	\N	\N	224108	224108	391103
29937	50412	8	applied	\N	\N	\N	\N	224110	224110	391105
29937	50413	9	applied	\N	\N	\N	\N	224111	224111	391106
29939	50414	0	applied	\N	\N	\N	\N	224166	224166	391161
29939	50415	1	applied	\N	\N	\N	\N	224167	224167	391162
29939	50416	2	applied	\N	\N	\N	\N	224168	224168	391163
29939	50417	3	applied	\N	\N	\N	\N	224169	224169	391164
29939	50418	4	applied	\N	\N	\N	\N	224170	224170	391165
29954	50480	0	applied	\N	\N	\N	\N	224261	224261	391256
29954	50481	1	applied	\N	\N	\N	\N	224262	224262	391257
29954	50482	2	applied	\N	\N	\N	\N	224263	224263	391258
29954	50483	3	applied	\N	\N	\N	\N	224264	224264	391259
29954	50484	4	applied	\N	\N	\N	\N	224265	224265	391260
29954	50485	5	applied	\N	\N	\N	\N	224266	224266	391261
29954	50486	6	applied	\N	\N	\N	\N	224267	224267	391262
29954	50487	7	applied	\N	\N	\N	\N	224268	224268	391263
29954	50488	8	applied	\N	\N	\N	\N	224269	224269	391264
29912	50321	5	applied	\N	\N	\N	\N	223690	223690	390693
29912	50322	6	applied	\N	\N	\N	\N	223691	223691	390694
29920	50291	20	applied	\N	\N	\N	\N	223770	223770	390769
29920	50299	21	applied	\N	\N	\N	\N	223771	223771	223771
29920	50292	22	applied	\N	\N	\N	\N	223772	223772	390770
29920	50296	23	applied	\N	\N	\N	\N	223773	223773	390771
29920	50300	24	applied	\N	\N	\N	\N	223774	223774	390772
29920	50306	25	applied	\N	\N	\N	\N	223775	223775	390773
29920	50318	26	applied	\N	\N	\N	\N	223776	223776	390774
29920	50319	27	applied	\N	\N	\N	\N	223777	223777	390775
29920	50328	28	applied	\N	\N	\N	\N	223778	223778	390776
29920	50336	29	applied	\N	\N	\N	\N	223779	223779	390777
29920	50337	30	applied	\N	\N	\N	\N	223780	223780	390778
29920	50345	31	applied	\N	\N	\N	\N	223781	223781	390779
29920	50284	32	applied	\N	\N	\N	\N	223782	223782	390780
29920	50285	33	applied	\N	\N	\N	\N	223783	223783	390781
29920	50288	34	applied	\N	\N	\N	\N	223784	223784	390782
29920	50301	35	applied	\N	\N	\N	\N	223785	223785	390783
29920	50303	37	applied	\N	\N	\N	\N	223787	223787	390785
29932	50401	12	applied	\N	\N	\N	\N	224054	224054	391049
29932	50402	13	applied	\N	\N	\N	\N	224055	224055	391050
29932	50403	14	applied	\N	\N	\N	\N	224056	224056	391051
29934	50404	0	applied	\N	\N	\N	\N	224072	224072	391067
29934	50405	1	applied	\N	\N	\N	\N	224073	224073	391068
29934	50406	2	applied	\N	\N	\N	\N	224074	224074	391069
29934	50407	3	applied	\N	\N	\N	\N	224075	224075	391070
29934	50408	4	applied	\N	\N	\N	\N	224076	224076	391071
29934	50409	5	applied	\N	\N	\N	\N	224077	224077	391072
29934	50410	6	applied	\N	\N	\N	\N	224078	224078	391073
29934	50411	7	applied	\N	\N	\N	\N	224079	224079	391074
29934	50412	8	applied	\N	\N	\N	\N	224080	224080	391075
29934	50413	9	applied	\N	\N	\N	\N	224081	224081	391076
29936	50404	0	applied	\N	\N	\N	\N	224092	224092	391087
29936	50405	1	applied	\N	\N	\N	\N	224093	224093	391088
29936	50407	3	applied	\N	\N	\N	\N	224095	224095	391090
29936	50408	4	applied	\N	\N	\N	\N	224096	224096	391091
29936	50409	5	applied	\N	\N	\N	\N	224097	224097	391092
29936	50410	6	applied	\N	\N	\N	\N	224098	224098	391093
29936	50411	7	applied	\N	\N	\N	\N	224099	224099	391094
29936	50412	8	applied	\N	\N	\N	\N	224100	224100	391095
29936	50413	9	applied	\N	\N	\N	\N	224101	224101	391096
29950	50452	0	applied	\N	\N	\N	\N	224233	224233	391228
29950	50453	1	applied	\N	\N	\N	\N	224234	224234	391229
29950	50454	2	applied	\N	\N	\N	\N	224235	224235	391230
29950	50455	3	applied	\N	\N	\N	\N	224236	224236	391231
29950	50456	4	applied	\N	\N	\N	\N	224237	224237	391232
29950	50457	5	applied	\N	\N	\N	\N	224238	224238	391233
29950	50458	6	applied	\N	\N	\N	\N	224239	224239	391234
29950	50459	7	applied	\N	\N	\N	\N	224240	224240	391235
29950	50460	8	applied	\N	\N	\N	\N	224241	224241	391236
29950	50462	10	applied	\N	\N	\N	\N	224243	224243	391238
29950	50463	11	applied	\N	\N	\N	\N	224244	224244	391239
29950	50464	12	applied	\N	\N	\N	\N	224245	224245	391240
29950	50465	13	applied	\N	\N	\N	\N	224246	224246	391241
29950	50466	14	applied	\N	\N	\N	\N	224247	224247	391242
29950	50467	15	applied	\N	\N	\N	\N	224248	224248	391243
29950	50468	16	applied	\N	\N	\N	\N	224249	224249	391244
29950	50469	17	applied	\N	\N	\N	\N	224250	224250	391245
29950	50470	18	applied	\N	\N	\N	\N	224251	224251	391246
29963	50511	0	applied	\N	\N	\N	\N	224328	224328	391323
29963	50512	1	applied	\N	\N	\N	\N	224329	224329	391324
29963	50513	2	applied	\N	\N	\N	\N	224330	224330	391325
29963	50514	3	applied	\N	\N	\N	\N	224331	224331	391326
29963	50515	4	applied	\N	\N	\N	\N	224332	224332	391327
29967	50535	0	applied	\N	\N	\N	\N	224374	224374	391369
29967	50533	1	applied	\N	\N	\N	\N	224375	224375	391370
29967	50536	3	applied	\N	\N	\N	\N	224377	224377	391372
29967	50537	4	applied	\N	\N	\N	\N	224378	224378	391373
29967	50538	5	applied	\N	\N	\N	\N	224379	224379	391374
29967	50539	6	applied	\N	\N	\N	\N	224380	224380	391375
29967	50540	7	applied	\N	\N	\N	\N	224381	224381	391376
29967	50541	8	applied	\N	\N	\N	\N	224382	224382	391377
29967	50542	9	applied	\N	\N	\N	\N	224383	224383	391378
29967	50543	10	applied	\N	\N	\N	\N	224384	224384	391379
29967	50544	11	applied	\N	\N	\N	\N	224385	224385	391380
29967	50545	12	applied	\N	\N	\N	\N	224386	224386	391381
29969	50546	0	applied	\N	\N	\N	\N	224400	224400	391395
29969	50547	1	applied	\N	\N	\N	\N	224401	224401	391396
29969	50548	2	applied	\N	\N	\N	\N	224402	224402	391397
29969	50549	3	applied	\N	\N	\N	\N	224403	224403	391398
29969	50550	4	applied	\N	\N	\N	\N	224404	224404	391399
29969	50551	5	applied	\N	\N	\N	\N	224405	224405	391400
29969	50553	7	applied	\N	\N	\N	\N	224407	224407	391402
29969	50554	8	applied	\N	\N	\N	\N	224408	224408	391403
29976	50555	0	applied	\N	\N	\N	\N	224477	224477	391472
29976	50556	1	applied	\N	\N	\N	\N	224478	224478	391473
29976	50557	2	applied	\N	\N	\N	\N	224479	224479	391474
29976	50558	3	applied	\N	\N	\N	\N	224480	224480	391475
29976	50559	4	applied	\N	\N	\N	\N	224481	224481	391476
29976	50564	5	applied	\N	\N	\N	\N	224482	224482	391477
29976	50565	6	applied	\N	\N	\N	\N	224483	224483	391478
29976	50566	7	applied	\N	\N	\N	\N	224484	224484	391479
29976	50572	8	applied	\N	\N	\N	\N	224485	224485	391480
29980	50612	0	applied	\N	\N	\N	\N	224545	224545	391540
29980	50613	1	applied	\N	\N	\N	\N	224546	224546	391541
29980	50614	2	applied	\N	\N	\N	\N	224547	224547	391542
29980	50615	3	applied	\N	\N	\N	\N	224548	224548	391543
29980	50616	4	applied	\N	\N	\N	\N	224549	224549	391544
29980	50618	6	applied	\N	\N	\N	\N	224551	224551	391546
29980	50619	7	applied	\N	\N	\N	\N	224552	224552	391547
29980	50620	8	applied	\N	\N	\N	\N	224553	224553	391548
29980	50621	9	applied	\N	\N	\N	\N	224554	224554	391549
29982	50612	0	applied	\N	\N	\N	\N	224564	224564	391559
29982	50613	1	applied	\N	\N	\N	\N	224565	224565	391560
29982	50614	2	applied	\N	\N	\N	\N	224566	224566	391561
29982	50615	3	applied	\N	\N	\N	\N	224567	224567	391562
29982	50616	4	applied	\N	\N	\N	\N	224568	224568	391563
29982	50617	5	applied	\N	\N	\N	\N	224569	224569	391564
29982	50618	6	applied	\N	\N	\N	\N	224570	224570	391565
29982	50619	7	applied	\N	\N	\N	\N	224571	224571	391566
29982	50620	8	applied	\N	\N	\N	\N	224572	224572	391567
29982	50621	9	applied	\N	\N	\N	\N	224573	224573	391568
29920	50287	17	applied	\N	\N	\N	\N	223767	223767	390766
29920	50289	18	applied	\N	\N	\N	\N	223768	223768	390767
29920	50313	42	applied	\N	\N	\N	\N	223792	223792	390790
29920	50314	43	applied	\N	\N	\N	\N	223793	223793	390791
29920	50317	44	applied	\N	\N	\N	\N	223794	223794	390792
29920	50321	45	applied	\N	\N	\N	\N	223795	223795	390793
29920	50322	46	applied	\N	\N	\N	\N	223796	223796	390794
29920	50323	47	applied	\N	\N	\N	\N	223797	223797	390795
29920	50324	48	applied	\N	\N	\N	\N	223798	223798	390796
29920	50329	49	applied	\N	\N	\N	\N	223799	223799	390797
29920	50330	50	applied	\N	\N	\N	\N	223800	223800	390798
29920	50331	51	applied	\N	\N	\N	\N	223801	223801	390799
29920	50332	52	applied	\N	\N	\N	\N	223802	223802	390800
29920	50334	53	applied	\N	\N	\N	\N	223803	223803	390801
29920	50335	54	applied	\N	\N	\N	\N	223804	223804	390802
29920	50293	55	applied	\N	\N	\N	\N	223805	223805	390803
29920	50294	56	applied	\N	\N	\N	\N	223806	223806	390804
29920	50297	57	applied	\N	\N	\N	\N	223807	223807	390805
29920	50307	59	applied	\N	\N	\N	\N	223809	223809	390807
29920	50308	60	applied	\N	\N	\N	\N	223810	223810	390808
29920	50309	61	applied	\N	\N	\N	\N	223811	223811	390809
29920	50316	62	applied	\N	\N	\N	\N	223812	223812	390810
29920	50320	63	applied	\N	\N	\N	\N	223813	223813	390811
29920	50326	64	applied	\N	\N	\N	\N	223814	223814	390812
29920	50327	65	applied	\N	\N	\N	\N	223815	223815	390813
29920	50338	66	applied	\N	\N	\N	\N	223816	223816	390814
29920	50339	67	applied	\N	\N	\N	\N	223817	223817	390815
29920	50340	68	applied	\N	\N	\N	\N	223818	223818	390816
29920	50344	69	applied	\N	\N	\N	\N	223819	223819	390817
29920	50346	70	applied	\N	\N	\N	\N	223820	223820	390818
29920	50341	71	applied	\N	\N	\N	\N	223821	223821	390819
29920	50342	72	applied	\N	\N	\N	\N	223822	223822	390820
29920	50347	73	applied	\N	\N	\N	\N	223823	223823	390821
29920	50348	74	applied	\N	\N	\N	\N	223824	223824	390822
29920	50350	76	applied	\N	\N	\N	\N	223826	223826	390824
29920	50351	77	applied	\N	\N	\N	\N	223827	223827	390825
29922	50352	0	applied	\N	\N	\N	\N	223837	223837	390835
29922	50353	1	applied	\N	\N	\N	\N	223838	223838	390836
29922	50354	2	applied	\N	\N	\N	\N	223839	223839	390837
29922	50355	3	applied	\N	\N	\N	\N	223840	223840	390838
29922	50356	4	applied	\N	\N	\N	\N	223841	223841	390839
29922	50357	5	applied	\N	\N	\N	\N	223842	223842	390840
29922	50358	6	applied	\N	\N	\N	\N	223843	223843	390841
29922	50359	7	applied	\N	\N	\N	\N	223844	223844	390842
29923	50359	7	applied	\N	\N	\N	\N	223852	223852	390850
29926	50360	0	applied	\N	\N	\N	\N	223866	223866	390864
29926	50361	1	applied	\N	\N	\N	\N	223867	223867	390865
29926	50365	2	applied	\N	\N	\N	\N	223868	223868	390866
29926	50366	3	applied	\N	\N	\N	\N	223869	223869	390867
29926	50367	4	applied	\N	\N	\N	\N	223870	223870	390868
29926	50362	6	applied	\N	\N	\N	\N	223872	223872	390870
29926	50363	7	applied	\N	\N	\N	\N	223873	223873	390871
29926	50364	8	applied	\N	\N	\N	\N	223874	223874	390872
29926	50369	9	applied	\N	\N	\N	\N	223875	223875	390873
29926	50370	10	applied	\N	\N	\N	\N	223876	223876	390874
29926	50371	11	applied	\N	\N	\N	\N	223877	223877	390875
29926	50372	12	applied	\N	\N	\N	\N	223878	223878	390876
29926	50373	13	applied	\N	\N	\N	\N	223879	223879	390877
29926	50374	14	applied	\N	\N	\N	\N	223880	223880	390878
29926	50375	15	applied	\N	\N	\N	\N	223881	223881	390879
29926	50376	16	applied	\N	\N	\N	\N	223882	223882	390880
29926	50377	17	applied	\N	\N	\N	\N	223883	223883	390881
29926	50378	18	applied	\N	\N	\N	\N	223884	223884	390882
29928	50360	0	applied	\N	\N	\N	\N	223904	223904	390902
29928	50361	1	applied	\N	\N	\N	\N	223905	223905	390903
29928	50365	2	applied	\N	\N	\N	\N	223906	223906	390904
29928	50367	4	applied	\N	\N	\N	\N	223908	223908	390906
29928	50368	5	applied	\N	\N	\N	\N	223909	223909	390907
29928	50362	6	applied	\N	\N	\N	\N	223910	223910	390908
29928	50363	7	applied	\N	\N	\N	\N	223911	223911	390909
29928	50364	8	applied	\N	\N	\N	\N	223912	223912	390910
29928	50369	9	applied	\N	\N	\N	\N	223913	223913	390911
29928	50370	10	applied	\N	\N	\N	\N	223914	223914	390912
29928	50371	11	applied	\N	\N	\N	\N	223915	223915	390913
29928	50372	12	applied	\N	\N	\N	\N	223916	223916	390914
29928	50373	13	applied	\N	\N	\N	\N	223917	223917	390915
29928	50374	14	applied	\N	\N	\N	\N	223918	223918	390916
29928	50375	15	applied	\N	\N	\N	\N	223919	223919	390917
29928	50376	16	applied	\N	\N	\N	\N	223920	223920	390918
29928	50377	17	applied	\N	\N	\N	\N	223921	223921	390919
29928	50378	18	applied	\N	\N	\N	\N	223922	223922	390920
29930	50265	0	applied	\N	\N	\N	\N	223947	223947	390945
29930	50208	2	applied	\N	\N	\N	\N	223949	223949	390947
29930	50227	3	applied	\N	\N	\N	\N	223950	223950	390948
29930	50236	4	applied	\N	\N	\N	\N	223951	223951	390949
29930	50246	5	applied	\N	\N	\N	\N	223952	223952	390950
29930	50255	6	applied	\N	\N	\N	\N	223953	223953	390951
29930	50266	7	applied	\N	\N	\N	\N	223954	223954	390952
29930	50275	8	applied	\N	\N	\N	\N	223955	223955	390953
29930	50286	9	applied	\N	\N	\N	\N	223956	223956	390954
29930	50295	10	applied	\N	\N	\N	\N	223957	223957	390955
29930	50310	11	applied	\N	\N	\N	\N	223958	223958	390956
29938	50360	0	applied	\N	\N	\N	\N	224112	224112	391107
29938	50361	1	applied	\N	\N	\N	\N	224113	224113	391108
29938	50379	2	applied	\N	\N	\N	\N	224114	224114	391109
29938	50389	3	applied	\N	\N	\N	\N	224115	224115	391110
29938	50390	4	applied	\N	\N	\N	\N	224116	224116	391111
29938	50404	5	applied	\N	\N	\N	\N	224117	224117	391112
29938	50365	7	applied	\N	\N	\N	\N	224119	224119	391114
29938	50366	8	applied	\N	\N	\N	\N	224120	224120	391115
29938	50367	9	applied	\N	\N	\N	\N	224121	224121	391116
29938	50368	10	applied	\N	\N	\N	\N	224122	224122	391117
29938	50362	11	applied	\N	\N	\N	\N	224123	224123	391118
29938	50363	12	applied	\N	\N	\N	\N	224124	224124	391119
29938	50364	13	applied	\N	\N	\N	\N	224125	224125	391120
29938	50380	14	applied	\N	\N	\N	\N	224126	224126	391121
29938	50369	15	applied	\N	\N	\N	\N	224127	224127	391122
29938	50370	16	applied	\N	\N	\N	\N	224128	224128	391123
29938	50381	17	applied	\N	\N	\N	\N	224129	224129	391124
29938	50382	18	applied	\N	\N	\N	\N	224130	224130	391125
29938	50371	19	applied	\N	\N	\N	\N	224131	224131	391126
29938	50372	20	applied	\N	\N	\N	\N	224132	224132	391127
29920	50305	39	applied	\N	\N	\N	\N	223789	223789	390787
29920	50311	40	applied	\N	\N	\N	\N	223790	223790	390788
29930	50343	15	applied	\N	\N	\N	\N	223962	223962	390960
29930	50352	16	applied	\N	\N	\N	\N	223963	223963	390961
29930	50360	17	applied	\N	\N	\N	\N	223964	223964	390962
29930	50361	18	applied	\N	\N	\N	\N	223965	223965	390963
29930	50379	19	applied	\N	\N	\N	\N	223966	223966	390964
29930	50209	20	applied	\N	\N	\N	\N	223967	223967	390965
29930	50210	21	applied	\N	\N	\N	\N	223968	223968	390966
29930	50211	22	applied	\N	\N	\N	\N	223969	223969	390967
29930	50212	23	applied	\N	\N	\N	\N	223970	223970	390968
29930	50213	24	applied	\N	\N	\N	\N	223971	223971	390969
29930	50214	25	applied	\N	\N	\N	\N	223972	223972	390970
29930	50273	26	applied	\N	\N	\N	\N	223973	223973	223973
29930	50277	27	applied	\N	\N	\N	\N	223974	223974	223974
29930	50215	29	applied	\N	\N	\N	\N	223976	223976	390971
29930	50228	30	applied	\N	\N	\N	\N	223977	223977	390972
29930	50239	31	applied	\N	\N	\N	\N	223978	223978	390973
29930	50242	32	applied	\N	\N	\N	\N	223979	223979	390974
29930	50216	33	applied	\N	\N	\N	\N	223980	223980	390975
29938	50373	21	applied	\N	\N	\N	\N	224133	224133	391128
29938	50374	22	applied	\N	\N	\N	\N	224134	224134	391129
29938	50375	23	applied	\N	\N	\N	\N	224135	224135	391130
29938	50376	24	applied	\N	\N	\N	\N	224136	224136	391131
29938	50377	25	applied	\N	\N	\N	\N	224137	224137	391132
29938	50378	26	applied	\N	\N	\N	\N	224138	224138	391133
29938	50383	27	applied	\N	\N	\N	\N	224139	224139	391134
29938	50384	28	applied	\N	\N	\N	\N	224140	224140	391135
29938	50385	29	applied	\N	\N	\N	\N	224141	224141	391136
29938	50386	30	applied	\N	\N	\N	\N	224142	224142	391137
29938	50387	31	applied	\N	\N	\N	\N	224143	224143	391138
29938	50393	34	applied	\N	\N	\N	\N	224145	224145	391140
29938	50396	35	applied	\N	\N	1000000000	\N	224146	224146	391141
29938	50397	36	applied	\N	\N	1000000000	\N	224147	224147	391142
29938	50388	37	applied	\N	\N	\N	\N	224148	224148	391143
29938	50391	38	applied	\N	\N	\N	\N	224149	224149	391144
29938	50394	39	applied	\N	\N	\N	\N	224150	224150	391145
29938	50395	40	applied	\N	\N	\N	\N	224151	224151	391146
29938	50406	41	applied	\N	\N	\N	\N	224152	224152	391147
29938	50407	42	applied	\N	\N	\N	\N	224153	224153	391148
29938	50408	43	applied	\N	\N	\N	\N	224154	224154	391149
29938	50398	44	applied	\N	\N	\N	\N	224155	224155	391150
29938	50399	45	applied	\N	\N	\N	\N	224156	224156	391151
29938	50400	46	applied	\N	\N	\N	\N	224157	224157	391152
29938	50401	47	applied	\N	\N	\N	\N	224158	224158	391153
29938	50402	48	applied	\N	\N	\N	\N	224159	224159	391154
29938	50403	49	applied	\N	\N	\N	\N	224160	224160	391155
29938	50410	51	applied	\N	\N	\N	\N	224162	224162	391157
29938	50411	52	applied	\N	\N	\N	\N	224163	224163	391158
29938	50412	53	applied	\N	\N	\N	\N	224164	224164	391159
29938	50413	54	applied	\N	\N	\N	\N	224165	224165	391160
29940	50419	0	applied	\N	\N	\N	\N	224171	224171	391166
29940	50420	1	applied	\N	\N	\N	\N	224172	224172	391167
29940	50421	2	applied	\N	\N	\N	\N	224173	224173	391168
29940	50422	3	applied	\N	\N	\N	\N	224174	224174	391169
29940	50423	4	applied	\N	\N	\N	\N	224175	224175	391170
29940	50424	5	applied	\N	\N	\N	\N	224176	224176	391171
29944	50425	0	applied	\N	\N	\N	\N	224177	224177	391172
29944	50426	1	applied	\N	\N	\N	\N	224178	224178	391173
29944	50427	2	applied	\N	\N	\N	\N	224179	224179	391174
29944	50428	3	applied	\N	\N	\N	\N	224180	224180	391175
29944	50429	4	applied	\N	\N	\N	\N	224181	224181	391176
29944	50430	5	applied	\N	\N	\N	\N	224182	224182	391177
29946	50432	0	applied	\N	\N	\N	\N	224192	224192	391187
29946	50433	1	applied	\N	\N	\N	\N	224193	224193	391188
29946	50434	2	applied	\N	\N	\N	\N	224194	224194	391189
29946	50435	3	applied	\N	\N	\N	\N	224195	224195	391190
29946	50436	4	applied	\N	\N	\N	\N	224196	224196	391191
29946	50437	5	applied	\N	\N	\N	\N	224197	224197	391192
29946	50438	6	applied	\N	\N	\N	\N	224198	224198	391193
29946	50439	7	applied	\N	\N	\N	\N	224199	224199	391194
29946	50440	8	applied	\N	\N	\N	\N	224200	224200	391195
29946	50441	9	applied	\N	\N	\N	\N	224201	224201	391196
29946	50442	10	applied	\N	\N	\N	\N	224202	224202	391197
29948	50432	0	applied	\N	\N	\N	\N	224213	224213	391208
29948	50433	1	applied	\N	\N	\N	\N	224214	224214	391209
29948	50434	2	applied	\N	\N	\N	\N	224215	224215	391210
29948	50435	3	applied	\N	\N	\N	\N	224216	224216	391211
29948	50436	4	applied	\N	\N	\N	\N	224217	224217	391212
29948	50438	6	applied	\N	\N	\N	\N	224219	224219	391214
29948	50439	7	applied	\N	\N	\N	\N	224220	224220	391215
29948	50440	8	applied	\N	\N	\N	\N	224221	224221	391216
29948	50441	9	applied	\N	\N	\N	\N	224222	224222	391217
29948	50442	10	applied	\N	\N	\N	\N	224223	224223	391218
29956	50490	0	applied	\N	\N	\N	\N	224281	224281	391276
29956	50491	1	applied	\N	\N	\N	\N	224282	224282	391277
29956	50492	3	applied	\N	\N	\N	\N	224283	224283	391278
29956	50493	4	applied	\N	\N	\N	\N	224284	224284	391279
29956	50494	5	applied	\N	\N	\N	\N	224285	224285	391280
29956	50495	6	applied	\N	\N	\N	\N	224286	224286	391281
29956	50496	7	applied	\N	\N	\N	\N	224287	224287	391282
29956	50497	8	applied	\N	\N	\N	\N	224288	224288	391283
29956	50498	9	applied	\N	\N	\N	\N	224289	224289	391284
29956	50499	10	applied	\N	\N	\N	\N	224290	224290	391285
29958	50500	0	applied	\N	\N	\N	\N	224301	224301	391296
29958	50502	2	applied	\N	\N	\N	\N	224303	224303	391298
29958	50503	3	applied	\N	\N	\N	\N	224304	224304	391299
29958	50504	4	applied	\N	\N	\N	\N	224305	224305	391300
29958	50505	5	applied	\N	\N	\N	\N	224306	224306	391301
29960	50507	0	applied	\N	\N	\N	\N	224314	224314	391309
29960	50508	1	applied	\N	\N	\N	\N	224315	224315	391310
29960	50509	2	applied	\N	\N	\N	\N	224316	224316	391311
29960	50510	3	applied	\N	\N	\N	\N	224317	224317	391312
29971	50546	0	applied	\N	\N	\N	\N	224418	224418	391413
29971	50547	1	applied	\N	\N	\N	\N	224419	224419	391414
29971	50548	2	applied	\N	\N	\N	\N	224420	224420	391415
29971	50549	3	applied	\N	\N	\N	\N	224421	224421	391416
29971	50550	4	applied	\N	\N	\N	\N	224422	224422	391417
29971	50551	5	applied	\N	\N	\N	\N	224423	224423	391418
29971	50552	6	applied	\N	\N	\N	\N	224424	224424	391419
29971	50553	7	applied	\N	\N	\N	\N	224425	224425	391420
29930	50325	13	applied	\N	\N	\N	\N	223960	223960	390958
29930	50333	14	applied	\N	\N	\N	\N	223961	223961	390959
29930	50261	37	applied	\N	\N	\N	\N	223984	223984	390979
29930	50262	38	applied	\N	\N	\N	\N	223985	223985	390980
29930	50269	39	applied	\N	\N	\N	\N	223986	223986	390981
29930	50276	40	applied	\N	\N	\N	\N	223987	223987	390982
29930	50283	41	applied	\N	\N	\N	\N	223988	223988	390983
29930	50292	42	applied	\N	\N	\N	\N	223989	223989	390984
29930	50296	43	applied	\N	\N	\N	\N	223990	223990	390985
29930	50300	44	applied	\N	\N	\N	\N	223991	223991	390986
29930	50306	45	applied	\N	\N	\N	\N	223992	223992	390987
29930	50318	46	applied	\N	\N	\N	\N	223993	223993	390988
29930	50319	47	applied	\N	\N	\N	\N	223994	223994	390989
29930	50328	48	applied	\N	\N	\N	\N	223995	223995	390990
29930	50336	49	applied	\N	\N	\N	\N	223996	223996	390991
29930	50345	51	applied	\N	\N	\N	\N	223998	223998	390993
29930	50353	52	applied	\N	\N	\N	\N	223999	223999	390994
29930	50362	53	applied	\N	\N	\N	\N	224000	224000	390995
29930	50363	54	applied	\N	\N	\N	\N	224001	224001	390996
29930	50364	55	applied	\N	\N	\N	\N	224002	224002	390997
29930	50380	56	applied	\N	\N	\N	\N	224003	224003	390998
29930	50235	57	applied	\N	\N	\N	\N	224004	224004	390999
29930	50237	58	applied	\N	\N	\N	\N	224005	224005	391000
29930	50243	59	applied	\N	\N	\N	\N	224006	224006	391001
29930	50244	60	applied	\N	\N	\N	\N	224007	224007	391002
29930	50247	61	applied	\N	\N	\N	\N	224008	224008	391003
29930	50248	62	applied	\N	\N	\N	\N	224009	224009	391004
29930	50254	63	applied	\N	\N	\N	\N	224010	224010	391005
29930	50256	64	applied	\N	\N	\N	\N	224011	224011	391006
29930	50260	65	applied	\N	\N	\N	\N	224012	224012	391007
29930	50268	66	applied	\N	\N	\N	\N	224013	224013	391008
29930	50284	68	applied	\N	\N	\N	\N	224015	224015	391010
29930	50285	69	applied	\N	\N	\N	\N	224016	224016	391011
29930	50288	70	applied	\N	\N	\N	\N	224017	224017	391012
29930	50293	71	applied	\N	\N	\N	\N	224018	224018	391013
29930	50294	72	applied	\N	\N	\N	\N	224019	224019	391014
29930	50297	73	applied	\N	\N	\N	\N	224020	224020	391015
29930	50298	74	applied	\N	\N	\N	\N	224021	224021	391016
29930	50307	75	applied	\N	\N	\N	\N	224022	224022	391017
29930	50308	76	applied	\N	\N	\N	\N	224023	224023	391018
29930	50309	77	applied	\N	\N	\N	\N	224024	224024	391019
29930	50316	78	applied	\N	\N	\N	\N	224025	224025	391020
29930	50320	79	applied	\N	\N	\N	\N	224026	224026	391021
29930	50326	80	applied	\N	\N	\N	\N	224027	224027	391022
29930	50327	81	applied	\N	\N	\N	\N	224028	224028	391023
29930	50338	82	applied	\N	\N	\N	\N	224029	224029	391024
29930	50339	83	applied	\N	\N	\N	\N	224030	224030	391025
29930	50344	85	applied	\N	\N	\N	\N	224032	224032	391027
29930	50346	86	applied	\N	\N	\N	\N	224033	224033	391028
29930	50354	87	applied	\N	\N	\N	\N	224034	224034	391029
29930	50355	88	applied	\N	\N	\N	\N	224035	224035	391030
29930	50366	89	applied	\N	\N	\N	\N	224036	224036	391031
29930	50367	90	applied	\N	\N	\N	\N	224037	224037	391032
29930	50368	92	applied	\N	\N	\N	\N	224038	224038	391033
29930	50369	93	applied	\N	\N	\N	\N	224039	224039	391034
29930	50370	94	applied	\N	\N	\N	\N	224040	224040	391035
29930	50381	95	applied	\N	\N	\N	\N	224041	224041	391036
29933	50389	0	applied	\N	\N	\N	\N	224057	224057	391052
29933	50390	1	applied	\N	\N	\N	\N	224058	224058	391053
29933	50391	2	applied	\N	\N	\N	\N	224059	224059	391054
29933	50392	3	applied	\N	\N	\N	\N	224060	224060	391055
29933	50393	4	applied	\N	\N	\N	\N	224061	224061	391056
29933	50394	5	applied	\N	\N	\N	\N	224062	224062	391057
29933	50396	7	applied	\N	\N	1000000000	\N	224064	224064	391059
29933	50397	8	applied	\N	\N	1000000000	\N	224065	224065	391060
29933	50398	9	applied	\N	\N	\N	\N	224066	224066	391061
29933	50399	10	applied	\N	\N	\N	\N	224067	224067	391062
29933	50400	11	applied	\N	\N	\N	\N	224068	224068	391063
29933	50401	12	applied	\N	\N	\N	\N	224069	224069	391064
29933	50402	13	applied	\N	\N	\N	\N	224070	224070	391065
29933	50403	14	applied	\N	\N	\N	\N	224071	224071	391066
29945	50432	0	applied	\N	\N	\N	\N	224184	224184	391179
29945	50425	1	applied	\N	\N	\N	\N	224185	224185	391180
29945	50426	2	applied	\N	\N	\N	\N	224186	224186	391181
29945	50427	3	applied	\N	\N	\N	\N	224187	224187	391182
29945	50428	4	applied	\N	\N	\N	\N	224188	224188	391183
29945	50429	5	applied	\N	\N	\N	\N	224189	224189	391184
29945	50430	6	applied	\N	\N	\N	\N	224190	224190	391185
29945	50431	7	applied	\N	\N	\N	\N	224191	224191	391186
29947	50433	1	applied	\N	\N	\N	\N	224204	224204	391199
29947	50434	2	applied	\N	\N	\N	\N	224205	224205	391200
29947	50435	3	applied	\N	\N	\N	\N	224206	224206	391201
29947	50437	4	applied	\N	\N	\N	\N	224207	224207	391202
29947	50438	5	applied	\N	\N	\N	\N	224208	224208	391203
29947	50439	6	applied	\N	\N	\N	\N	224209	224209	391204
29947	50440	7	applied	\N	\N	\N	\N	224210	224210	391205
29947	50441	8	applied	\N	\N	\N	\N	224211	224211	391206
29947	50442	9	applied	\N	\N	\N	\N	224212	224212	391207
29949	50443	0	applied	\N	\N	\N	\N	224224	224224	391219
29949	50444	1	applied	\N	\N	\N	\N	224225	224225	391220
29949	50445	2	applied	\N	\N	\N	\N	224226	224226	391221
29949	50446	3	applied	\N	\N	\N	\N	224227	224227	391222
29949	50447	4	applied	\N	\N	\N	\N	224228	224228	391223
29949	50448	5	applied	\N	\N	\N	\N	224229	224229	391224
29949	50449	6	applied	\N	\N	\N	\N	224230	224230	391225
29949	50451	8	applied	\N	\N	\N	\N	224232	224232	391227
29951	50471	0	applied	\N	\N	\N	\N	224252	224252	391247
29951	50472	1	applied	\N	\N	\N	\N	224253	224253	391248
29951	50473	2	applied	\N	\N	\N	\N	224254	224254	391249
29951	50474	3	applied	\N	\N	\N	\N	224255	224255	391250
29951	50475	4	applied	\N	\N	\N	\N	224256	224256	391251
29951	50476	5	applied	\N	\N	\N	\N	224257	224257	391252
29951	50477	6	applied	\N	\N	\N	\N	224258	224258	391253
29951	50478	7	applied	\N	\N	\N	\N	224259	224259	391254
29951	50479	8	applied	\N	\N	\N	\N	224260	224260	391255
29955	50480	0	applied	\N	\N	\N	\N	224271	224271	391266
29955	50481	1	applied	\N	\N	\N	\N	224272	224272	391267
29955	50482	2	applied	\N	\N	\N	\N	224273	224273	391268
29955	50483	3	applied	\N	\N	\N	\N	224274	224274	391269
29955	50484	4	applied	\N	\N	\N	\N	224275	224275	391270
29955	50485	5	applied	\N	\N	\N	\N	224276	224276	391271
29930	50229	35	applied	\N	\N	\N	\N	223982	223982	390977
29930	50253	36	applied	\N	\N	\N	\N	223983	223983	390978
29957	50491	1	applied	\N	\N	\N	\N	224292	224292	391287
29957	50492	3	applied	\N	\N	\N	\N	224293	224293	391288
29957	50493	4	applied	\N	\N	\N	\N	224294	224294	391289
29957	50494	5	applied	\N	\N	\N	\N	224295	224295	391290
29957	50495	6	applied	\N	\N	\N	\N	224296	224296	391291
29957	50496	7	applied	\N	\N	\N	\N	224297	224297	391292
29957	50497	8	applied	\N	\N	\N	\N	224298	224298	391293
29957	50498	9	applied	\N	\N	\N	\N	224299	224299	391294
29957	50499	10	applied	\N	\N	\N	\N	224300	224300	391295
29959	50500	0	applied	\N	\N	\N	\N	224307	224307	391302
29959	50501	1	applied	\N	\N	\N	\N	224308	224308	391303
29959	50502	2	applied	\N	\N	\N	\N	224309	224309	391304
29959	50503	3	applied	\N	\N	\N	\N	224310	224310	391305
29959	50504	4	applied	\N	\N	\N	\N	224311	224311	391306
29959	50506	5	applied	\N	\N	\N	\N	224312	224312	391307
29959	50505	6	applied	\N	\N	\N	\N	224313	224313	391308
29961	50512	1	applied	\N	\N	\N	\N	224319	224319	391314
29961	50513	2	applied	\N	\N	\N	\N	224320	224320	391315
29961	50514	3	applied	\N	\N	\N	\N	224321	224321	391316
29961	50515	4	applied	\N	\N	\N	\N	224322	224322	391317
29962	50511	0	applied	\N	\N	\N	\N	224323	224323	391318
29962	50512	1	applied	\N	\N	\N	\N	224324	224324	391319
29962	50513	2	applied	\N	\N	\N	\N	224325	224325	391320
29962	50514	3	applied	\N	\N	\N	\N	224326	224326	391321
29962	50515	4	applied	\N	\N	\N	\N	224327	224327	391322
29964	50511	0	applied	\N	\N	\N	\N	224333	224333	391328
29964	50512	1	applied	\N	\N	\N	\N	224334	224334	391329
29964	50513	2	applied	\N	\N	\N	\N	224335	224335	391330
29964	50514	3	applied	\N	\N	\N	\N	224336	224336	391331
29964	50515	4	applied	\N	\N	\N	\N	224337	224337	391332
29965	50516	0	applied	\N	\N	\N	\N	224338	224338	391333
29965	50517	1	applied	\N	\N	\N	\N	224339	224339	391334
29965	50519	3	applied	\N	\N	\N	\N	224341	224341	391336
29965	50520	4	applied	\N	\N	\N	\N	224342	224342	391337
29965	50521	5	applied	\N	\N	\N	\N	224343	224343	391338
29965	50522	6	applied	\N	\N	\N	\N	224344	224344	391339
29965	50523	7	applied	\N	\N	\N	\N	224345	224345	391340
29965	50524	8	applied	\N	\N	\N	\N	224346	224346	391341
29965	50525	9	applied	\N	\N	\N	\N	224347	224347	391342
29965	50526	10	applied	\N	\N	\N	\N	224348	224348	391343
29965	50527	11	applied	\N	\N	\N	\N	224349	224349	391344
29966	50516	0	applied	\N	\N	\N	\N	224355	224355	391350
29966	50517	1	applied	\N	\N	\N	\N	224356	224356	391351
29966	50518	2	applied	\N	\N	\N	\N	224357	224357	391352
29966	50519	3	applied	\N	\N	\N	\N	224358	224358	391353
29966	50520	4	applied	\N	\N	\N	\N	224359	224359	391354
29966	50521	5	applied	\N	\N	\N	\N	224360	224360	391355
29966	50522	6	applied	\N	\N	\N	\N	224361	224361	391356
29966	50524	8	applied	\N	\N	\N	\N	224363	224363	391358
29966	50525	9	applied	\N	\N	\N	\N	224364	224364	391359
29966	50526	10	applied	\N	\N	\N	\N	224365	224365	391360
29966	50527	11	applied	\N	\N	\N	\N	224366	224366	391361
29966	50528	12	applied	\N	\N	\N	\N	224367	224367	391362
29966	50529	13	applied	\N	\N	\N	\N	224368	224368	391363
29966	50530	14	applied	\N	\N	\N	\N	224369	224369	391364
29966	50531	15	applied	\N	\N	\N	\N	224370	224370	391365
29966	50532	16	applied	\N	\N	\N	\N	224371	224371	391366
29966	50533	17	applied	\N	\N	\N	\N	224372	224372	391367
29966	50534	18	applied	\N	\N	\N	\N	224373	224373	391368
29968	50535	0	applied	\N	\N	\N	\N	224387	224387	391382
29968	50533	1	applied	\N	\N	\N	\N	224388	224388	391383
29968	50534	2	applied	\N	\N	\N	\N	224389	224389	391384
29968	50536	3	applied	\N	\N	\N	\N	224390	224390	391385
29968	50537	4	applied	\N	\N	\N	\N	224391	224391	391386
29968	50539	6	applied	\N	\N	\N	\N	224393	224393	391388
29968	50540	7	applied	\N	\N	\N	\N	224394	224394	391389
29968	50541	8	applied	\N	\N	\N	\N	224395	224395	391390
29968	50542	9	applied	\N	\N	\N	\N	224396	224396	391391
29968	50543	10	applied	\N	\N	\N	\N	224397	224397	391392
29968	50544	11	applied	\N	\N	\N	\N	224398	224398	391393
29968	50545	12	applied	\N	\N	\N	\N	224399	224399	391394
29970	50546	0	applied	\N	\N	\N	\N	224409	224409	391404
29970	50547	1	applied	\N	\N	\N	\N	224410	224410	391405
29970	50548	2	applied	\N	\N	\N	\N	224411	224411	391406
29970	50549	3	applied	\N	\N	\N	\N	224412	224412	391407
29970	50550	4	applied	\N	\N	\N	\N	224413	224413	391408
29970	50551	5	applied	\N	\N	\N	\N	224414	224414	391409
29970	50552	6	applied	\N	\N	\N	\N	224415	224415	391410
29970	50553	7	applied	\N	\N	\N	\N	224416	224416	391411
29970	50554	8	applied	\N	\N	\N	\N	224417	224417	391412
29987	50642	1	applied	\N	\N	\N	\N	224753	224753	391748
29987	50643	2	applied	\N	\N	\N	\N	224754	224754	391749
29987	50644	3	applied	\N	\N	\N	\N	224755	224755	391750
29987	50645	4	applied	\N	\N	\N	\N	224756	224756	391751
29987	50646	5	applied	\N	\N	\N	\N	224757	224757	391752
29987	50647	6	applied	\N	\N	\N	\N	224758	224758	391753
29987	50648	7	applied	\N	\N	\N	\N	224759	224759	391754
29987	50649	8	applied	\N	\N	\N	\N	224760	224760	391755
29987	50650	9	applied	\N	\N	\N	\N	224761	224761	391756
29987	50651	10	applied	\N	\N	\N	\N	224762	224762	391757
29987	50652	11	applied	\N	\N	\N	\N	224763	224763	391758
29987	50653	12	applied	\N	\N	\N	\N	224764	224764	391759
29987	50654	13	applied	\N	\N	\N	\N	224765	224765	391760
29987	50655	14	applied	\N	\N	\N	\N	224766	224766	391761
29987	50656	15	applied	\N	\N	\N	\N	224767	224767	391762
29987	50657	16	applied	\N	\N	\N	\N	224768	224768	391763
29987	50659	18	applied	\N	\N	\N	\N	224770	224770	391765
29989	50641	0	applied	\N	\N	\N	\N	224785	224785	391780
29989	50642	1	applied	\N	\N	\N	\N	224786	224786	391781
29989	50643	2	applied	\N	\N	\N	\N	224787	224787	391782
29989	50644	3	applied	\N	\N	\N	\N	224788	224788	391783
29989	50645	4	applied	\N	\N	\N	\N	224789	224789	391784
29989	50646	5	applied	\N	\N	\N	\N	224790	224790	391785
29989	50647	6	applied	\N	\N	\N	\N	224791	224791	391786
29989	50648	7	applied	\N	\N	\N	\N	224792	224792	391787
29989	50649	8	applied	\N	\N	\N	\N	224793	224793	391788
29989	50650	9	applied	\N	\N	\N	\N	224794	224794	391789
29989	50651	10	applied	\N	\N	\N	\N	224795	224795	391790
29989	50652	11	applied	\N	\N	\N	\N	224796	224796	391791
29989	50653	12	applied	\N	\N	\N	\N	224797	224797	391792
29955	50488	8	applied	\N	\N	\N	\N	224279	224279	391274
29955	50489	9	applied	\N	\N	\N	\N	224280	224280	391275
29965	50532	16	applied	\N	\N	\N	\N	224354	224354	391349
29972	50546	0	applied	\N	\N	\N	\N	224427	224427	391422
29972	50547	1	applied	\N	\N	\N	\N	224428	224428	391423
29972	50548	2	applied	\N	\N	\N	\N	224429	224429	391424
29972	50549	3	applied	\N	\N	\N	\N	224430	224430	391425
29972	50550	4	applied	\N	\N	\N	\N	224431	224431	391426
29972	50551	5	applied	\N	\N	\N	\N	224432	224432	391427
29972	50552	6	applied	\N	\N	\N	\N	224433	224433	391428
29972	50553	7	applied	\N	\N	\N	\N	224434	224434	391429
29972	50554	8	applied	\N	\N	\N	\N	224435	224435	391430
29973	50546	0	applied	\N	\N	\N	\N	224436	224436	391431
29973	50547	1	applied	\N	\N	\N	\N	224437	224437	391432
29973	50549	2	applied	\N	\N	\N	\N	224438	224438	391433
29973	50553	3	applied	\N	\N	\N	\N	224439	224439	391434
29973	50554	4	applied	\N	\N	\N	\N	224440	224440	391435
29974	50555	0	applied	\N	\N	\N	\N	224441	224441	391436
29974	50557	2	applied	\N	\N	\N	\N	224443	224443	391438
29974	50558	3	applied	\N	\N	\N	\N	224444	224444	391439
29974	50559	4	applied	\N	\N	\N	\N	224445	224445	391440
29974	50560	5	applied	\N	\N	\N	\N	224446	224446	391441
29974	50561	6	applied	\N	\N	\N	\N	224447	224447	391442
29974	50562	7	applied	\N	\N	\N	\N	224448	224448	391443
29974	50563	8	applied	\N	\N	\N	\N	224449	224449	391444
29974	50564	9	applied	\N	\N	\N	\N	224450	224450	391445
29974	50565	10	applied	\N	\N	\N	\N	224451	224451	391446
29974	50566	11	applied	\N	\N	\N	\N	224452	224452	391447
29974	50567	12	applied	\N	\N	\N	\N	224453	224453	391448
29974	50568	13	applied	\N	\N	\N	\N	224454	224454	391449
29974	50569	14	applied	\N	\N	\N	\N	224455	224455	391450
29974	50570	15	applied	\N	\N	\N	\N	224456	224456	391451
29974	50571	16	applied	\N	\N	\N	\N	224457	224457	391452
29974	50572	17	applied	\N	\N	\N	\N	224458	224458	391453
29975	50556	1	applied	\N	\N	\N	\N	224460	224460	391455
29975	50557	2	applied	\N	\N	\N	\N	224461	224461	391456
29975	50558	3	applied	\N	\N	\N	\N	224462	224462	391457
29975	50559	4	applied	\N	\N	\N	\N	224463	224463	391458
29975	50560	5	applied	\N	\N	\N	\N	224464	224464	391459
29975	50561	6	applied	\N	\N	\N	\N	224465	224465	391460
29975	50562	7	applied	\N	\N	\N	\N	224466	224466	391461
29975	50563	8	applied	\N	\N	\N	\N	224467	224467	391462
29975	50564	9	applied	\N	\N	\N	\N	224468	224468	391463
29975	50565	10	applied	\N	\N	\N	\N	224469	224469	391464
29975	50566	11	applied	\N	\N	\N	\N	224470	224470	391465
29975	50567	12	applied	\N	\N	\N	\N	224471	224471	391466
29975	50568	13	applied	\N	\N	\N	\N	224472	224472	391467
29975	50569	14	applied	\N	\N	\N	\N	224473	224473	391468
29975	50570	15	applied	\N	\N	\N	\N	224474	224474	391469
29975	50571	16	applied	\N	\N	\N	\N	224475	224475	391470
29977	50574	1	applied	\N	\N	\N	\N	224487	224487	391482
29977	50575	2	applied	\N	\N	\N	\N	224488	224488	391483
29977	50576	3	applied	\N	\N	\N	\N	224489	224489	391484
29977	50577	4	applied	\N	\N	\N	\N	224490	224490	391485
29977	50578	5	applied	\N	\N	\N	\N	224491	224491	391486
29977	50579	6	applied	\N	\N	\N	\N	224492	224492	391487
29977	50580	7	applied	\N	\N	\N	\N	224493	224493	391488
29977	50581	8	applied	\N	\N	\N	\N	224494	224494	391489
29977	50582	9	applied	\N	\N	\N	\N	224495	224495	391490
29977	50583	10	applied	\N	\N	\N	\N	224496	224496	391491
29977	50584	11	applied	\N	\N	\N	\N	224497	224497	391492
29977	50585	12	applied	\N	\N	\N	\N	224498	224498	391493
29977	50586	13	applied	\N	\N	\N	\N	224499	224499	391494
29977	50587	14	applied	\N	\N	\N	\N	224500	224500	391495
29977	50588	15	applied	\N	\N	\N	\N	224501	224501	391496
29977	50589	16	applied	\N	\N	\N	\N	224502	224502	391497
29977	50591	18	applied	\N	\N	\N	\N	224504	224504	391499
29977	50592	19	applied	\N	\N	\N	\N	224505	224505	391500
29983	50622	0	applied	\N	\N	\N	\N	224574	224574	391569
29983	50623	1	applied	\N	\N	\N	\N	224575	224575	391570
29983	50624	2	applied	\N	\N	\N	\N	224576	224576	391571
29983	50625	3	applied	\N	\N	\N	\N	224577	224577	391572
29983	50626	4	applied	\N	\N	\N	\N	224578	224578	391573
29983	50627	5	applied	\N	\N	\N	\N	224579	224579	391574
29983	50628	6	applied	\N	\N	\N	\N	224580	224580	391575
29983	50629	7	applied	\N	\N	\N	\N	224581	224581	391576
29983	50630	8	applied	\N	\N	\N	\N	224582	224582	391577
29983	50631	9	applied	\N	\N	\N	\N	224583	224583	391578
29983	50632	10	applied	\N	\N	\N	\N	224584	224584	391579
29983	50633	11	applied	\N	\N	\N	\N	224585	224585	391580
29983	50634	12	applied	\N	\N	\N	\N	224586	224586	391581
29983	50635	13	applied	\N	\N	\N	\N	224587	224587	391582
29983	50637	15	applied	\N	\N	\N	\N	224589	224589	391584
29983	50638	16	applied	\N	\N	\N	\N	224590	224590	391585
29983	50639	17	applied	\N	\N	\N	\N	224591	224591	391586
29983	50640	18	applied	\N	\N	\N	\N	224592	224592	391587
29985	50622	0	applied	\N	\N	\N	\N	224612	224612	391607
29985	50623	1	applied	\N	\N	\N	\N	224613	224613	391608
29985	50624	2	applied	\N	\N	\N	\N	224614	224614	391609
29985	50625	3	applied	\N	\N	\N	\N	224615	224615	391610
29985	50626	4	applied	\N	\N	\N	\N	224616	224616	391611
29985	50627	5	applied	\N	\N	\N	\N	224617	224617	391612
29985	50628	6	applied	\N	\N	\N	\N	224618	224618	391613
29985	50629	7	applied	\N	\N	\N	\N	224619	224619	391614
29985	50630	8	applied	\N	\N	\N	\N	224620	224620	391615
29985	50631	9	applied	\N	\N	\N	\N	224621	224621	391616
29985	50632	10	applied	\N	\N	\N	\N	224622	224622	391617
29985	50633	11	applied	\N	\N	\N	\N	224623	224623	391618
29985	50635	13	applied	\N	\N	\N	\N	224625	224625	391620
29985	50636	14	applied	\N	\N	\N	\N	224626	224626	391621
29985	50637	15	applied	\N	\N	\N	\N	224627	224627	391622
29985	50638	16	applied	\N	\N	\N	\N	224628	224628	391623
29985	50639	17	applied	\N	\N	\N	\N	224629	224629	391624
29985	50640	18	applied	\N	\N	\N	\N	224630	224630	391625
29988	50641	0	applied	\N	\N	\N	\N	224771	224771	391766
29988	50642	1	applied	\N	\N	\N	\N	224772	224772	391767
29988	50643	2	applied	\N	\N	\N	\N	224773	224773	391768
29988	50644	3	applied	\N	\N	\N	\N	224774	224774	391769
29988	50645	4	applied	\N	\N	\N	\N	224775	224775	391770
29988	50646	5	applied	\N	\N	\N	\N	224776	224776	391771
29988	50647	6	applied	\N	\N	\N	\N	224777	224777	391772
29988	50648	7	applied	\N	\N	\N	\N	224778	224778	391773
29965	50529	13	applied	\N	\N	\N	\N	224351	224351	391346
29965	50530	14	applied	\N	\N	\N	\N	224352	224352	391347
29978	50576	3	applied	\N	\N	\N	\N	224509	224509	391504
29978	50577	4	applied	\N	\N	\N	\N	224510	224510	391505
29978	50578	5	applied	\N	\N	\N	\N	224511	224511	391506
29978	50579	6	applied	\N	\N	\N	\N	224512	224512	391507
29978	50580	7	applied	\N	\N	\N	\N	224513	224513	391508
29978	50581	8	applied	\N	\N	\N	\N	224514	224514	391509
29978	50582	9	applied	\N	\N	\N	\N	224515	224515	391510
29978	50583	10	applied	\N	\N	\N	\N	224516	224516	391511
29978	50584	11	applied	\N	\N	\N	\N	224517	224517	391512
29978	50585	12	applied	\N	\N	\N	\N	224518	224518	391513
29978	50586	13	applied	\N	\N	\N	\N	224519	224519	391514
29978	50587	14	applied	\N	\N	\N	\N	224520	224520	391515
29978	50588	15	applied	\N	\N	\N	\N	224521	224521	391516
29978	50589	16	applied	\N	\N	\N	\N	224522	224522	391517
29978	50590	17	applied	\N	\N	\N	\N	224523	224523	391518
29978	50591	18	applied	\N	\N	\N	\N	224524	224524	391519
29979	50593	0	applied	\N	\N	\N	\N	224526	224526	391521
29979	50594	1	applied	\N	\N	\N	\N	224527	224527	391522
29979	50595	2	applied	\N	\N	\N	\N	224528	224528	391523
29979	50596	4	applied	\N	\N	\N	\N	224529	224529	391524
29979	50597	5	applied	\N	\N	\N	\N	224530	224530	391525
29979	50598	6	applied	\N	\N	\N	\N	224531	224531	391526
29979	50599	7	applied	\N	\N	\N	\N	224532	224532	391527
29979	50600	8	applied	\N	\N	\N	\N	224533	224533	391528
29979	50601	9	applied	\N	\N	\N	\N	224534	224534	391529
29979	50602	10	applied	\N	\N	\N	\N	224535	224535	391530
29979	50603	11	applied	\N	\N	\N	\N	224536	224536	391531
29979	50604	12	applied	\N	\N	\N	\N	224537	224537	391532
29979	50605	13	applied	\N	\N	\N	\N	224538	224538	391533
29979	50606	14	applied	\N	\N	\N	\N	224539	224539	391534
29979	50607	15	applied	\N	\N	\N	\N	224540	224540	391535
29979	50608	16	applied	\N	\N	\N	\N	224541	224541	391536
29979	50610	18	applied	\N	\N	\N	\N	224543	224543	391538
29979	50611	19	applied	\N	\N	\N	\N	224544	224544	391539
29981	50612	0	applied	\N	\N	\N	\N	224555	224555	391550
29981	50613	1	applied	\N	\N	\N	\N	224556	224556	391551
29981	50614	2	applied	\N	\N	\N	\N	224557	224557	391552
29981	50615	3	applied	\N	\N	\N	\N	224558	224558	391553
29981	50617	4	applied	\N	\N	\N	\N	224559	224559	391554
29981	50618	5	applied	\N	\N	\N	\N	224560	224560	391555
29981	50619	6	applied	\N	\N	\N	\N	224561	224561	391556
29981	50620	7	applied	\N	\N	\N	\N	224562	224562	391557
29981	50621	8	applied	\N	\N	\N	\N	224563	224563	391558
29984	50622	0	applied	\N	\N	\N	\N	224593	224593	391588
29984	50623	1	applied	\N	\N	\N	\N	224594	224594	391589
29984	50624	2	applied	\N	\N	\N	\N	224595	224595	391590
29984	50625	3	applied	\N	\N	\N	\N	224596	224596	391591
29984	50626	4	applied	\N	\N	\N	\N	224597	224597	391592
29984	50628	6	applied	\N	\N	\N	\N	224599	224599	391594
29984	50629	7	applied	\N	\N	\N	\N	224600	224600	391595
29984	50630	8	applied	\N	\N	\N	\N	224601	224601	391596
29984	50631	9	applied	\N	\N	\N	\N	224602	224602	391597
29984	50632	10	applied	\N	\N	\N	\N	224603	224603	391598
29984	50633	11	applied	\N	\N	\N	\N	224604	224604	391599
29984	50634	12	applied	\N	\N	\N	\N	224605	224605	391600
29984	50635	13	applied	\N	\N	\N	\N	224606	224606	391601
29984	50636	14	applied	\N	\N	\N	\N	224607	224607	391602
29984	50637	15	applied	\N	\N	\N	\N	224608	224608	391603
29984	50638	16	applied	\N	\N	\N	\N	224609	224609	391604
29984	50639	17	applied	\N	\N	\N	\N	224610	224610	391605
29984	50640	18	applied	\N	\N	\N	\N	224611	224611	391606
29986	50452	0	applied	\N	\N	\N	\N	224631	224631	391626
29986	50453	1	applied	\N	\N	\N	\N	224632	224632	391627
29986	50471	2	applied	\N	\N	\N	\N	224633	224633	391628
29997	50689	1	applied	\N	\N	\N	\N	224873	224873	391868
29997	50690	2	applied	\N	\N	\N	\N	224874	224874	391869
29997	50691	3	applied	\N	\N	\N	\N	224875	224875	391870
29997	50692	4	applied	\N	\N	\N	\N	224876	224876	391871
29997	50693	5	applied	\N	\N	\N	\N	224877	224877	391872
29997	50694	6	applied	\N	\N	\N	\N	224878	224878	391873
29997	50695	7	applied	\N	\N	\N	\N	224879	224879	391874
30005	50743	0	applied	\N	\N	\N	\N	225073	225073	392068
30005	50744	1	applied	\N	\N	\N	\N	225074	225074	392069
30005	50745	2	applied	\N	\N	\N	\N	225075	225075	392070
30005	50746	3	applied	\N	\N	\N	\N	225076	225076	392071
30005	50747	4	applied	\N	\N	\N	\N	225077	225077	392072
30005	50748	5	applied	\N	\N	\N	\N	225078	225078	392073
30005	50749	6	applied	\N	\N	\N	\N	225079	225079	392074
30005	50750	7	applied	\N	\N	\N	\N	225080	225080	392075
30005	50751	8	applied	\N	\N	\N	\N	225081	225081	392076
30005	50753	10	applied	\N	\N	\N	\N	225083	225083	392078
30005	50754	11	applied	\N	\N	\N	\N	225084	225084	392079
30005	50755	12	applied	\N	\N	\N	\N	225085	225085	392080
30005	50756	13	applied	\N	\N	\N	\N	225086	225086	392081
30005	50757	14	applied	\N	\N	\N	\N	225087	225087	392082
30005	50758	15	applied	\N	\N	\N	\N	225088	225088	392083
30005	50759	16	applied	\N	\N	\N	\N	225089	225089	392084
30005	50760	17	applied	\N	\N	\N	\N	225090	225090	392085
30005	50761	18	applied	\N	\N	\N	\N	225091	225091	392086
30005	50762	19	applied	\N	\N	\N	\N	225092	225092	392087
30011	50782	0	applied	\N	\N	\N	\N	225150	225150	392145
30011	50783	1	applied	\N	\N	\N	\N	225151	225151	392146
30011	50784	2	applied	\N	\N	\N	\N	225152	225152	392147
30011	50785	3	applied	\N	\N	\N	\N	225153	225153	392148
30011	50786	4	applied	\N	\N	\N	\N	225154	225154	392149
30011	50787	5	applied	\N	\N	\N	\N	225155	225155	392150
30011	50789	7	applied	\N	\N	\N	\N	225157	225157	392152
30011	50790	8	applied	\N	\N	\N	\N	225158	225158	392153
30011	50791	9	applied	\N	\N	\N	\N	225159	225159	392154
30011	50792	10	applied	\N	\N	\N	\N	225160	225160	392155
30011	50793	11	applied	\N	\N	\N	\N	225161	225161	392156
30011	50794	12	applied	\N	\N	\N	\N	225162	225162	392157
30011	50795	13	applied	\N	\N	\N	\N	225163	225163	392158
30011	50796	14	applied	\N	\N	\N	\N	225164	225164	392159
30011	50797	15	applied	\N	\N	\N	\N	225165	225165	392160
30011	50798	16	applied	\N	\N	\N	\N	225166	225166	392161
30011	50799	17	applied	\N	\N	\N	\N	225167	225167	392162
30011	50800	18	applied	\N	\N	\N	\N	225168	225168	392163
30011	50801	19	applied	\N	\N	\N	\N	225169	225169	392164
30011	50802	20	applied	\N	\N	\N	\N	225170	225170	392165
29978	50573	0	applied	\N	\N	\N	\N	224506	224506	391501
29978	50574	1	applied	\N	\N	\N	\N	224507	224507	391502
29986	50511	7	applied	\N	\N	\N	\N	224638	224638	391633
29986	50516	8	applied	\N	\N	\N	\N	224639	224639	391634
29986	50535	9	applied	\N	\N	\N	\N	224640	224640	391635
29986	50546	10	applied	\N	\N	\N	\N	224641	224641	391636
29986	50555	11	applied	\N	\N	\N	\N	224642	224642	391637
29986	50556	12	applied	\N	\N	\N	\N	224643	224643	391638
29986	50573	13	applied	\N	\N	\N	\N	224644	224644	391639
29986	50574	14	applied	\N	\N	\N	\N	224645	224645	391640
29986	50593	15	applied	\N	\N	\N	\N	224646	224646	391641
29986	50594	16	applied	\N	\N	\N	\N	224647	224647	391642
29986	50612	17	applied	\N	\N	\N	\N	224648	224648	391643
29986	50622	18	applied	\N	\N	\N	\N	224649	224649	391644
29986	50623	19	applied	\N	\N	\N	\N	224650	224650	391645
29986	50454	20	applied	\N	\N	\N	\N	224651	224651	391646
29986	50455	21	applied	\N	\N	\N	\N	224652	224652	391647
29986	50456	22	applied	\N	\N	\N	\N	224653	224653	391648
29986	50473	24	applied	\N	\N	\N	\N	224655	224655	391650
29986	50458	25	applied	\N	\N	\N	\N	224656	224656	391651
29986	50459	26	applied	\N	\N	\N	\N	224657	224657	391652
29986	50460	27	applied	\N	\N	\N	\N	224658	224658	391653
29986	50461	28	applied	\N	\N	\N	\N	224659	224659	391654
29986	50462	29	applied	\N	\N	\N	\N	224660	224660	391655
29986	50463	30	applied	\N	\N	\N	\N	224661	224661	391656
29986	50464	31	applied	\N	\N	\N	\N	224662	224662	391657
29986	50476	32	applied	\N	\N	\N	\N	224663	224663	391658
29986	50477	33	applied	\N	\N	\N	\N	224664	224664	391659
29986	50481	34	applied	\N	\N	\N	\N	224665	224665	391660
29986	50485	35	applied	\N	\N	\N	\N	224666	224666	391661
29986	50487	36	applied	\N	\N	\N	\N	224667	224667	391662
29986	50491	37	applied	\N	\N	\N	\N	224668	224668	391663
29986	50495	38	applied	\N	\N	\N	\N	224669	224669	391664
29986	50496	39	applied	\N	\N	\N	\N	224670	224670	391665
29986	50504	41	applied	\N	\N	\N	\N	224672	224672	391667
29986	50506	42	applied	\N	\N	\N	\N	224673	224673	391668
29986	50508	43	applied	\N	\N	\N	\N	224674	224674	391669
29986	50509	44	applied	\N	\N	\N	\N	224675	224675	391670
29986	50514	45	applied	\N	\N	\N	\N	224676	224676	391671
29986	50515	47	applied	\N	\N	\N	\N	224677	224677	391672
29986	50519	48	applied	\N	\N	\N	\N	224678	224678	391673
29986	50520	49	applied	\N	\N	\N	\N	224679	224679	391674
29986	50537	50	applied	\N	\N	\N	\N	224680	224680	391675
29986	50539	51	applied	\N	\N	\N	\N	224681	224681	391676
29986	50540	52	applied	\N	\N	\N	\N	224682	224682	391677
29986	50547	53	applied	\N	\N	\N	\N	224683	224683	391678
29986	50465	54	applied	\N	\N	\N	\N	224684	224684	391679
29986	50466	55	applied	\N	\N	\N	\N	224685	224685	391680
29986	50467	56	applied	\N	\N	\N	\N	224686	224686	391681
29986	50468	57	applied	\N	\N	\N	\N	224687	224687	391682
29986	50470	59	applied	\N	\N	\N	\N	224689	224689	391684
29986	50472	60	applied	\N	\N	\N	\N	224690	224690	391685
29986	50474	61	applied	\N	\N	\N	\N	224691	224691	391686
29986	50475	62	applied	\N	\N	\N	\N	224692	224692	391687
29986	50478	63	applied	\N	\N	\N	\N	224693	224693	391688
29986	50482	64	applied	\N	\N	\N	\N	224694	224694	391689
29986	50483	65	applied	\N	\N	\N	\N	224695	224695	391690
29986	50484	66	applied	\N	\N	\N	\N	224696	224696	391691
29986	50553	67	applied	\N	\N	\N	\N	224697	224697	391692
29986	50554	68	applied	\N	\N	\N	\N	224698	224698	391693
29986	50557	69	applied	\N	\N	\N	\N	224699	224699	391694
29986	50558	70	applied	\N	\N	\N	\N	224700	224700	391695
29986	50559	71	applied	\N	\N	\N	\N	224701	224701	391696
29986	50572	72	applied	\N	\N	\N	\N	224702	224702	391697
29986	50576	73	applied	\N	\N	\N	\N	224703	224703	391698
29986	50577	74	applied	\N	\N	\N	\N	224704	224704	391699
29986	50580	76	applied	\N	\N	\N	\N	224706	224706	391701
29986	50581	77	applied	\N	\N	\N	\N	224707	224707	391702
29986	50582	78	applied	\N	\N	\N	\N	224708	224708	391703
29986	50595	79	applied	\N	\N	\N	\N	224709	224709	391704
29986	50598	80	applied	\N	\N	\N	\N	224710	224710	391705
29986	50488	81	applied	\N	\N	\N	\N	224711	224711	391706
29986	50489	82	applied	\N	\N	\N	\N	224712	224712	391707
29986	50493	83	applied	\N	\N	\N	\N	224713	224713	391708
29986	50497	84	applied	\N	\N	\N	\N	224714	224714	391709
29986	50498	85	applied	\N	\N	\N	\N	224715	224715	391710
29986	50499	86	applied	\N	\N	\N	\N	224716	224716	391711
29986	50501	87	applied	\N	\N	\N	\N	224717	224717	391712
29986	50502	88	applied	\N	\N	\N	\N	224718	224718	391713
29986	50517	89	applied	\N	\N	\N	\N	224719	224719	391714
29986	50521	90	applied	\N	\N	\N	\N	224720	224720	391715
29986	50522	91	applied	\N	\N	\N	\N	224721	224721	391716
29986	50524	93	applied	\N	\N	\N	\N	224723	224723	391718
29986	50525	94	applied	\N	\N	\N	\N	224724	224724	391719
29986	50526	95	applied	\N	\N	\N	\N	224725	224725	391720
29986	50527	96	applied	\N	\N	\N	\N	224726	224726	391721
29986	50528	97	applied	\N	\N	\N	\N	224727	224727	391722
29986	50529	98	applied	\N	\N	\N	\N	224728	224728	391723
29986	50530	99	applied	\N	\N	\N	\N	224729	224729	391724
29986	50531	100	applied	\N	\N	\N	\N	224730	224730	391725
29986	50532	101	applied	\N	\N	\N	\N	224731	224731	391726
29986	50533	102	applied	\N	\N	\N	\N	224732	224732	391727
29986	50534	103	applied	\N	\N	\N	\N	224733	224733	391728
29986	50536	104	applied	\N	\N	\N	\N	224734	224734	391729
29986	50542	105	applied	\N	\N	\N	\N	224735	224735	391730
29986	50543	106	applied	\N	\N	\N	\N	224736	224736	391731
29986	50544	107	applied	\N	\N	\N	\N	224737	224737	391732
29986	50545	108	applied	\N	\N	\N	\N	224738	224738	391733
29986	50550	110	applied	\N	\N	\N	\N	224740	224740	391735
29986	50551	111	applied	\N	\N	\N	\N	224741	224741	391736
29986	50552	112	applied	\N	\N	\N	\N	224742	224742	391737
29986	50560	113	applied	\N	\N	\N	\N	224743	224743	391738
29986	50561	114	applied	\N	\N	\N	\N	224744	224744	391739
29986	50562	115	applied	\N	\N	\N	\N	224745	224745	391740
29986	50563	116	applied	\N	\N	\N	\N	224746	224746	391741
29986	50567	117	applied	\N	\N	\N	\N	224747	224747	391742
29986	50568	118	applied	\N	\N	\N	\N	224748	224748	391743
29986	50569	119	applied	\N	\N	\N	\N	224749	224749	391744
29986	50570	120	applied	\N	\N	\N	\N	224750	224750	391745
29986	50571	121	applied	\N	\N	\N	\N	224751	224751	391746
29990	50660	0	applied	\N	\N	\N	\N	224804	224804	391799
29990	50661	1	applied	\N	\N	\N	\N	224805	224805	391800
29986	50490	4	applied	\N	\N	\N	\N	224635	224635	391630
29986	50500	5	applied	\N	\N	\N	\N	224636	224636	391631
29988	50658	12	applied	\N	\N	\N	\N	224783	224783	391778
29988	50659	13	applied	\N	\N	\N	\N	224784	224784	391779
29990	50662	2	applied	\N	\N	\N	\N	224806	224806	391801
29990	50663	3	applied	\N	\N	\N	\N	224807	224807	391802
29990	50651	4	applied	\N	\N	\N	\N	224808	224808	391803
29990	50652	5	applied	\N	\N	\N	\N	224809	224809	391804
29990	50653	6	applied	\N	\N	\N	\N	224810	224810	391805
29990	50654	7	applied	\N	\N	\N	\N	224811	224811	391806
29990	50655	8	applied	\N	\N	\N	\N	224812	224812	391807
29990	50664	9	applied	\N	\N	\N	\N	224813	224813	391808
29990	50665	10	applied	\N	\N	\N	\N	224814	224814	391809
29990	50666	11	applied	\N	\N	\N	\N	224815	224815	391810
29990	50667	12	applied	\N	\N	\N	\N	224816	224816	391811
29990	50668	13	applied	\N	\N	\N	\N	224817	224817	391812
29992	50669	0	applied	\N	\N	\N	\N	224832	224832	391827
29992	50670	1	applied	\N	\N	\N	\N	224833	224833	391828
29992	50672	3	applied	\N	\N	\N	\N	224835	224835	391830
29992	50673	4	applied	\N	\N	\N	\N	224836	224836	391831
29992	50674	5	applied	\N	\N	\N	\N	224837	224837	391832
29992	50675	6	applied	\N	\N	\N	\N	224838	224838	391833
29992	50676	7	applied	\N	\N	\N	\N	224839	224839	391834
29992	50677	8	applied	\N	\N	\N	\N	224840	224840	391835
29992	50678	9	applied	\N	\N	\N	\N	224841	224841	391836
29994	50679	0	applied	\N	\N	\N	\N	224849	224849	391844
29994	50680	1	applied	\N	\N	\N	\N	224850	224850	391845
29994	50686	2	applied	\N	\N	\N	\N	224851	224851	391846
29994	50681	3	applied	\N	\N	\N	\N	224852	224852	391847
29994	50687	4	applied	\N	\N	\N	\N	224853	224853	391848
29994	50682	5	applied	\N	\N	\N	\N	224854	224854	391849
29995	50688	0	applied	\N	\N	\N	\N	224858	224858	391853
29995	50689	1	applied	\N	\N	\N	\N	224859	224859	391854
29995	50690	2	applied	\N	\N	\N	\N	224860	224860	391855
29995	50692	4	applied	\N	\N	\N	\N	224862	224862	391857
29995	50693	5	applied	\N	\N	\N	\N	224863	224863	391858
29995	50694	6	applied	\N	\N	\N	\N	224864	224864	391859
29995	50695	7	applied	\N	\N	\N	\N	224865	224865	391860
29999	50696	0	applied	\N	\N	\N	\N	224899	224899	391894
29999	50697	1	applied	\N	\N	\N	\N	224900	224900	391895
29999	50698	2	applied	\N	\N	\N	\N	224901	224901	391896
29999	50699	3	applied	\N	\N	\N	\N	224902	224902	391897
29999	50700	4	applied	\N	\N	\N	\N	224903	224903	391898
29999	50701	5	applied	\N	\N	\N	\N	224904	224904	391899
29999	50702	6	applied	\N	\N	\N	\N	224905	224905	391900
29999	50703	8	applied	\N	\N	\N	\N	224906	224906	391901
29999	50704	9	applied	\N	\N	\N	\N	224907	224907	391902
29999	50705	10	applied	\N	\N	\N	\N	224908	224908	391903
29999	50706	11	applied	\N	\N	\N	\N	224909	224909	391904
29999	50707	12	applied	\N	\N	\N	\N	224910	224910	391905
29999	50709	14	applied	\N	\N	\N	\N	224912	224912	391907
29999	50710	15	applied	\N	\N	\N	\N	224913	224913	391908
29999	50711	16	applied	\N	\N	\N	\N	224914	224914	391909
29999	50712	17	applied	\N	\N	\N	\N	224915	224915	391910
29999	50713	18	applied	\N	\N	\N	\N	224916	224916	391911
29999	50714	19	applied	\N	\N	\N	\N	224917	224917	391912
30009	50773	0	applied	\N	\N	\N	\N	225132	225132	392127
30009	50774	1	applied	\N	\N	\N	\N	225133	225133	392128
30009	50775	2	applied	\N	\N	\N	\N	225134	225134	392129
30009	50776	3	applied	\N	\N	\N	\N	225135	225135	392130
30009	50777	4	applied	\N	\N	\N	\N	225136	225136	392131
30009	50778	5	applied	\N	\N	\N	\N	225137	225137	392132
30009	50779	6	applied	\N	\N	\N	\N	225138	225138	392133
30009	50780	7	applied	\N	\N	\N	\N	225139	225139	392134
30009	50781	8	applied	\N	\N	\N	\N	225140	225140	392135
30017	50838	0	applied	\N	\N	\N	\N	225236	225236	392231
30017	50840	2	applied	\N	\N	\N	\N	225238	225238	392233
30017	50841	3	applied	\N	\N	\N	\N	225239	225239	392234
30017	50842	4	applied	\N	\N	\N	\N	225240	225240	392235
30017	50843	5	applied	\N	\N	\N	\N	225241	225241	392236
30017	50844	6	applied	\N	\N	\N	\N	225242	225242	392237
30017	50845	7	applied	\N	\N	\N	\N	225243	225243	392238
30017	50846	8	applied	\N	\N	\N	\N	225244	225244	392239
30017	50847	9	applied	\N	\N	\N	\N	225245	225245	392240
30017	50848	10	applied	\N	\N	\N	\N	225246	225246	392241
30017	50849	11	applied	\N	\N	\N	\N	225247	225247	392242
30017	50850	12	applied	\N	\N	\N	\N	225248	225248	392243
30017	50851	13	applied	\N	\N	\N	\N	225249	225249	392244
30017	50852	14	applied	\N	\N	\N	\N	225250	225250	392245
30017	50853	15	applied	\N	\N	\N	\N	225251	225251	392246
30017	50854	16	applied	\N	\N	\N	\N	225252	225252	392247
30017	50855	17	applied	\N	\N	\N	\N	225253	225253	392248
30017	50857	19	applied	\N	\N	\N	\N	225255	225255	392250
30017	50858	20	applied	\N	\N	\N	\N	225256	225256	392251
30017	50859	21	applied	\N	\N	\N	\N	225257	225257	392252
30017	50860	22	applied	\N	\N	\N	\N	225258	225258	392253
30017	50861	23	applied	\N	\N	\N	\N	225259	225259	392254
30017	50862	24	applied	\N	\N	\N	\N	225260	225260	392255
30017	50863	25	applied	\N	\N	\N	\N	225261	225261	392256
30017	50864	26	applied	\N	\N	\N	\N	225262	225262	392257
30017	50865	27	applied	\N	\N	\N	\N	225263	225263	392258
30017	50866	28	applied	\N	\N	\N	\N	225264	225264	392259
30017	50867	29	applied	\N	\N	\N	\N	225265	225265	392260
30019	50838	0	applied	\N	\N	\N	\N	225266	225266	392261
30019	50839	1	applied	\N	\N	\N	\N	225267	225267	392262
30019	50840	2	applied	\N	\N	\N	\N	225268	225268	392263
30019	50841	3	applied	\N	\N	\N	\N	225269	225269	392264
30019	50842	4	applied	\N	\N	\N	\N	225270	225270	392265
30019	50844	6	applied	\N	\N	\N	\N	225272	225272	392267
30019	50845	7	applied	\N	\N	\N	\N	225273	225273	392268
30019	50846	8	applied	\N	\N	\N	\N	225274	225274	392269
30019	50847	9	applied	\N	\N	\N	\N	225275	225275	392270
30019	50848	10	applied	\N	\N	\N	\N	225276	225276	392271
30019	50849	11	applied	\N	\N	\N	\N	225277	225277	392272
30019	50850	12	applied	\N	\N	\N	\N	225278	225278	392273
30019	50851	13	applied	\N	\N	\N	\N	225279	225279	392274
30019	50852	14	applied	\N	\N	\N	\N	225280	225280	392275
30019	50853	15	applied	\N	\N	\N	\N	225281	225281	392276
30019	50854	16	applied	\N	\N	\N	\N	225282	225282	392277
30019	50855	17	applied	\N	\N	\N	\N	225283	225283	392278
30019	50856	18	applied	\N	\N	\N	\N	225284	225284	392279
30019	50857	19	applied	\N	\N	\N	\N	225285	225285	392280
29988	50650	9	applied	\N	\N	\N	\N	224780	224780	391775
29988	50656	10	applied	\N	\N	\N	\N	224781	224781	391776
29989	50658	17	applied	\N	\N	\N	\N	224802	224802	391797
29989	50659	18	applied	\N	\N	\N	\N	224803	224803	391798
29991	50660	0	applied	\N	\N	\N	\N	224818	224818	391813
29991	50661	1	applied	\N	\N	\N	\N	224819	224819	391814
29991	50662	2	applied	\N	\N	\N	\N	224820	224820	391815
29991	50663	3	applied	\N	\N	\N	\N	224821	224821	391816
29991	50651	4	applied	\N	\N	\N	\N	224822	224822	391817
29991	50652	5	applied	\N	\N	\N	\N	224823	224823	391818
29991	50653	6	applied	\N	\N	\N	\N	224824	224824	391819
29991	50654	7	applied	\N	\N	\N	\N	224825	224825	391820
29991	50655	8	applied	\N	\N	\N	\N	224826	224826	391821
29991	50664	9	applied	\N	\N	\N	\N	224827	224827	391822
29991	50666	11	applied	\N	\N	\N	\N	224829	224829	391824
29991	50667	12	applied	\N	\N	\N	\N	224830	224830	391825
29991	50668	13	applied	\N	\N	\N	\N	224831	224831	391826
29993	50679	0	applied	\N	\N	\N	\N	224842	224842	391837
29993	50680	1	applied	\N	\N	\N	\N	224843	224843	391838
29994	50683	6	applied	\N	\N	\N	\N	224855	224855	391850
29994	50684	7	applied	\N	\N	\N	\N	224856	224856	391851
29994	50685	8	applied	\N	\N	\N	\N	224857	224857	391852
30001	50352	0	applied	\N	\N	\N	\N	224928	224928	391923
30001	50360	1	applied	\N	\N	\N	\N	224929	224929	391924
30001	50361	2	applied	\N	\N	\N	\N	224930	224930	391925
30001	50379	3	applied	\N	\N	\N	\N	224931	224931	391926
30001	50389	4	applied	\N	\N	\N	\N	224932	224932	391927
30001	50390	5	applied	\N	\N	\N	\N	224933	224933	391928
30001	50404	6	applied	\N	\N	\N	\N	224934	224934	391929
30001	50405	7	applied	\N	\N	\N	\N	224935	224935	391930
30001	50419	9	applied	\N	\N	\N	\N	224937	224937	391932
30001	50432	10	applied	\N	\N	\N	\N	224938	224938	391933
30001	50433	11	applied	\N	\N	\N	\N	224939	224939	391934
30001	50443	12	applied	\N	\N	\N	\N	224940	224940	391935
30001	50452	13	applied	\N	\N	\N	\N	224941	224941	391936
30001	50453	14	applied	\N	\N	\N	\N	224942	224942	391937
30001	50471	15	applied	\N	\N	\N	\N	224943	224943	391938
30001	50480	16	applied	\N	\N	\N	\N	224944	224944	391939
30001	50490	17	applied	\N	\N	\N	\N	224945	224945	391940
30001	50500	18	applied	\N	\N	\N	\N	224946	224946	391941
30001	50507	19	applied	\N	\N	\N	\N	224947	224947	391942
30001	50511	20	applied	\N	\N	\N	\N	224948	224948	391943
30001	50516	21	applied	\N	\N	\N	\N	224949	224949	391944
30001	50535	22	applied	\N	\N	\N	\N	224950	224950	391945
30001	50546	23	applied	\N	\N	\N	\N	224951	224951	391946
30001	50555	24	applied	\N	\N	\N	\N	224952	224952	391947
30001	50573	26	applied	\N	\N	\N	\N	224954	224954	391949
30001	50574	27	applied	\N	\N	\N	\N	224955	224955	391950
30001	50593	28	applied	\N	\N	\N	\N	224956	224956	391951
30001	50594	29	applied	\N	\N	\N	\N	224957	224957	391952
30001	50612	30	applied	\N	\N	\N	\N	224958	224958	391953
30001	50622	31	applied	\N	\N	\N	\N	224959	224959	391954
30001	50623	32	applied	\N	\N	\N	\N	224960	224960	391955
30001	50641	33	applied	\N	\N	\N	\N	224961	224961	391956
30001	50642	34	applied	\N	\N	\N	\N	224962	224962	391957
30001	50660	35	applied	\N	\N	\N	\N	224963	224963	391958
30001	50669	36	applied	\N	\N	\N	\N	224964	224964	391959
30001	50679	37	applied	\N	\N	\N	\N	224965	224965	391960
30001	50688	38	applied	\N	\N	\N	\N	224966	224966	391961
30001	50696	39	applied	\N	\N	\N	\N	224967	224967	391962
30001	50697	40	applied	\N	\N	\N	\N	224968	224968	391963
30001	50715	41	applied	\N	\N	\N	\N	224969	224969	391964
30001	50354	43	applied	\N	\N	\N	\N	224971	224971	391966
30001	50355	44	applied	\N	\N	\N	\N	224972	224972	391967
30001	50366	45	applied	\N	\N	\N	\N	224973	224973	391968
30001	50367	46	applied	\N	\N	\N	\N	224974	224974	391969
30001	50368	47	applied	\N	\N	\N	\N	224975	224975	391970
30001	50356	48	applied	\N	\N	\N	\N	224976	224976	391971
30001	50362	49	applied	\N	\N	\N	\N	224977	224977	391972
30001	50363	50	applied	\N	\N	\N	\N	224978	224978	391973
30001	50364	51	applied	\N	\N	\N	\N	224979	224979	391974
30001	50380	52	applied	\N	\N	\N	\N	224980	224980	391975
30001	50369	53	applied	\N	\N	\N	\N	224981	224981	391976
30001	50370	56	applied	\N	\N	\N	\N	224982	224982	391977
30001	50381	57	applied	\N	\N	\N	\N	224983	224983	391978
30001	50382	58	applied	\N	\N	\N	\N	224984	224984	391979
30001	50397	60	applied	\N	\N	1000000000	\N	224986	224986	391981
30001	50388	61	applied	\N	\N	\N	\N	224987	224987	391982
30001	50391	62	applied	\N	\N	\N	\N	224988	224988	391983
30001	50394	63	applied	\N	\N	\N	\N	224989	224989	391984
30001	50395	64	applied	\N	\N	\N	\N	224990	224990	391985
30001	50406	65	applied	\N	\N	\N	\N	224991	224991	391986
30001	50407	66	applied	\N	\N	\N	\N	224992	224992	391987
30001	50408	67	applied	\N	\N	\N	\N	224993	224993	391988
30001	50417	68	applied	\N	\N	\N	\N	224994	224994	391989
30001	50421	69	applied	\N	\N	\N	\N	224995	224995	391990
30001	50423	70	applied	\N	\N	\N	\N	224996	224996	391991
30001	50425	71	applied	\N	\N	\N	\N	224997	224997	391992
30001	50435	72	applied	\N	\N	\N	\N	224998	224998	391993
30001	50436	73	applied	\N	\N	\N	\N	224999	224999	391994
30001	50446	74	applied	\N	\N	\N	\N	225000	225000	391995
30001	50455	75	applied	\N	\N	\N	\N	225001	225001	391996
30001	50456	76	applied	\N	\N	\N	\N	225002	225002	391997
30001	50457	77	applied	\N	\N	\N	\N	225003	225003	391998
30001	50473	78	applied	\N	\N	\N	\N	225004	225004	391999
30001	50357	79	applied	\N	\N	\N	\N	225005	225005	392000
30001	50359	81	applied	\N	\N	\N	\N	225007	225007	392002
30001	50365	82	applied	\N	\N	\N	\N	225008	225008	392003
30001	50371	83	applied	\N	\N	\N	\N	225009	225009	392004
30001	50372	84	applied	\N	\N	\N	\N	225010	225010	392005
30001	50373	85	applied	\N	\N	\N	\N	225011	225011	392006
30001	50374	86	applied	\N	\N	\N	\N	225012	225012	392007
30001	50375	87	applied	\N	\N	\N	\N	225013	225013	392008
30001	50376	88	applied	\N	\N	\N	\N	225014	225014	392009
30001	50377	89	applied	\N	\N	\N	\N	225015	225015	392010
30001	50378	90	applied	\N	\N	\N	\N	225016	225016	392011
30001	50383	91	applied	\N	\N	\N	\N	225017	225017	392012
30001	50384	92	applied	\N	\N	\N	\N	225018	225018	392013
30001	50385	93	applied	\N	\N	\N	\N	225019	225019	392014
30001	50386	94	applied	\N	\N	\N	\N	225020	225020	392015
30001	50387	95	applied	\N	\N	\N	\N	225021	225021	392016
29989	50655	14	applied	\N	\N	\N	\N	224799	224799	391794
29989	50657	16	applied	\N	\N	\N	\N	224801	224801	391796
29993	50685	6	applied	\N	\N	\N	\N	224848	224848	391843
29996	50688	0	applied	\N	\N	\N	\N	224866	224866	391861
29996	50689	1	applied	\N	\N	\N	\N	224867	224867	391862
29996	50690	2	applied	\N	\N	\N	\N	224868	224868	391863
29996	50693	3	applied	\N	\N	\N	\N	224869	224869	391864
29996	50694	4	applied	\N	\N	\N	\N	224870	224870	391865
29996	50695	5	applied	\N	\N	\N	\N	224871	224871	391866
29998	50696	0	applied	\N	\N	\N	\N	224880	224880	391875
29998	50697	1	applied	\N	\N	\N	\N	224881	224881	391876
29998	50698	2	applied	\N	\N	\N	\N	224882	224882	391877
29998	50699	3	applied	\N	\N	\N	\N	224883	224883	391878
29998	50700	4	applied	\N	\N	\N	\N	224884	224884	391879
29998	50701	5	applied	\N	\N	\N	\N	224885	224885	391880
29998	50702	6	applied	\N	\N	\N	\N	224886	224886	391881
29998	50703	8	applied	\N	\N	\N	\N	224887	224887	391882
29998	50704	9	applied	\N	\N	\N	\N	224888	224888	391883
29998	50706	11	applied	\N	\N	\N	\N	224890	224890	391885
29998	50707	12	applied	\N	\N	\N	\N	224891	224891	391886
29998	50708	13	applied	\N	\N	\N	\N	224892	224892	391887
29998	50709	14	applied	\N	\N	\N	\N	224893	224893	391888
29998	50710	15	applied	\N	\N	\N	\N	224894	224894	391889
29998	50711	16	applied	\N	\N	\N	\N	224895	224895	391890
29998	50712	17	applied	\N	\N	\N	\N	224896	224896	391891
29998	50713	18	applied	\N	\N	\N	\N	224897	224897	391892
29998	50714	19	applied	\N	\N	\N	\N	224898	224898	391893
30000	50715	0	applied	\N	\N	\N	\N	224918	224918	391913
30000	50716	1	applied	\N	\N	\N	\N	224919	224919	391914
30000	50717	2	applied	\N	\N	\N	\N	224920	224920	391915
30000	50718	3	applied	\N	\N	\N	\N	224921	224921	391916
30000	50719	4	applied	\N	\N	\N	\N	224922	224922	391917
30000	50720	5	applied	\N	\N	\N	\N	224923	224923	391918
30000	50721	6	applied	\N	\N	\N	\N	224924	224924	391919
30000	50723	8	applied	\N	\N	\N	\N	224926	224926	391921
30000	50724	9	applied	\N	\N	\N	\N	224927	224927	391922
30001	50392	96	applied	\N	\N	\N	\N	225022	225022	392017
30001	50393	97	applied	\N	\N	\N	\N	225023	225023	392018
30001	50426	98	applied	\N	\N	\N	\N	225024	225024	392019
30001	50427	99	applied	\N	\N	\N	\N	225025	225025	392020
30001	50430	100	applied	\N	\N	\N	\N	225026	225026	392021
30001	50431	101	applied	\N	\N	\N	\N	225027	225027	392022
30001	50434	102	applied	\N	\N	\N	\N	225028	225028	392023
30001	50440	103	applied	\N	\N	\N	\N	225029	225029	392024
30001	50441	104	applied	\N	\N	\N	\N	225030	225030	392025
30001	50442	105	applied	\N	\N	\N	\N	225031	225031	392026
30001	50447	106	applied	\N	\N	\N	\N	225032	225032	392027
30001	50448	107	applied	\N	\N	\N	\N	225033	225033	392028
30001	50449	108	applied	\N	\N	\N	\N	225034	225034	392029
30001	50450	109	applied	\N	\N	\N	\N	225035	225035	392030
30001	50458	111	applied	\N	\N	\N	\N	225037	225037	392032
30001	50460	112	applied	\N	\N	\N	\N	225038	225038	392033
30001	50461	113	applied	\N	\N	\N	\N	225039	225039	392034
30001	50465	114	applied	\N	\N	\N	\N	225040	225040	392035
30001	50466	115	applied	\N	\N	\N	\N	225041	225041	392036
30001	50467	116	applied	\N	\N	\N	\N	225042	225042	392037
30001	50468	117	applied	\N	\N	\N	\N	225043	225043	392038
30002	50725	0	applied	\N	\N	\N	\N	225047	225047	392042
30002	50726	1	applied	\N	\N	\N	\N	225048	225048	392043
30002	50727	2	applied	\N	\N	\N	\N	225049	225049	392044
30002	50728	3	applied	\N	\N	\N	\N	225050	225050	392045
30002	50729	4	applied	\N	\N	\N	\N	225051	225051	392046
30002	50730	5	applied	\N	\N	\N	\N	225052	225052	392047
30002	50731	6	applied	\N	\N	\N	\N	225053	225053	392048
30002	50732	7	applied	\N	\N	\N	\N	225054	225054	392049
30002	50733	8	applied	\N	\N	\N	\N	225055	225055	392050
30004	50735	1	applied	\N	\N	\N	\N	225066	225066	392061
30004	50736	2	applied	\N	\N	\N	\N	225067	225067	392062
30004	50738	3	applied	\N	\N	\N	\N	225068	225068	392063
30004	50739	4	applied	\N	\N	\N	\N	225069	225069	392064
30004	50740	5	applied	\N	\N	\N	\N	225070	225070	392065
30004	50741	6	applied	\N	\N	\N	\N	225071	225071	392066
30004	50742	7	applied	\N	\N	\N	\N	225072	225072	392067
30007	50763	0	applied	\N	\N	\N	\N	225113	225113	392108
30007	50764	1	applied	\N	\N	\N	\N	225114	225114	392109
30007	50765	2	applied	\N	\N	\N	\N	225115	225115	392110
30007	50766	3	applied	\N	\N	\N	\N	225116	225116	392111
30007	50767	4	applied	\N	\N	\N	\N	225117	225117	392112
30007	50768	5	applied	\N	\N	\N	\N	225118	225118	392113
30007	50769	6	applied	\N	\N	\N	\N	225119	225119	392114
30007	50770	7	applied	\N	\N	\N	\N	225120	225120	392115
30007	50771	8	applied	\N	\N	\N	\N	225121	225121	392116
30013	50820	0	applied	\N	\N	\N	\N	225188	225188	392183
30013	50821	1	applied	\N	\N	\N	\N	225189	225189	392184
30013	50822	2	applied	\N	\N	\N	\N	225190	225190	392185
30013	50823	3	applied	\N	\N	\N	\N	225191	225191	392186
30013	50824	4	applied	\N	\N	\N	\N	225192	225192	392187
30013	50825	5	applied	\N	\N	\N	\N	225193	225193	392188
30013	50826	6	applied	\N	\N	\N	\N	225194	225194	392189
30013	50827	7	applied	\N	\N	\N	\N	225195	225195	392190
30013	50828	8	applied	\N	\N	\N	\N	225196	225196	392191
30031	50894	0	applied	\N	\N	\N	\N	225371	225371	392366
30031	50895	1	applied	\N	\N	\N	\N	225372	225372	392367
30031	50896	2	applied	\N	\N	\N	\N	225373	225373	392368
30031	50897	3	applied	\N	\N	\N	\N	225374	225374	392369
30031	50898	4	applied	\N	\N	\N	\N	225375	225375	392370
30031	50899	5	applied	\N	\N	\N	\N	225376	225376	392371
30031	50900	6	applied	\N	\N	\N	\N	225377	225377	392372
30031	50902	8	applied	\N	\N	\N	\N	225379	225379	392374
30031	50903	9	applied	\N	\N	\N	\N	225380	225380	392375
30031	50904	10	applied	\N	\N	\N	\N	225381	225381	392376
30031	50905	11	applied	\N	\N	\N	\N	225382	225382	392377
30031	50906	12	applied	\N	\N	\N	\N	225383	225383	392378
30031	50907	13	applied	\N	\N	\N	\N	225384	225384	392379
30031	50908	14	applied	\N	\N	\N	\N	225385	225385	392380
30031	50909	15	applied	\N	\N	\N	\N	225386	225386	392381
30031	50910	16	applied	\N	\N	\N	\N	225387	225387	392382
30031	50911	17	applied	\N	\N	\N	\N	225388	225388	392383
30031	50912	18	applied	\N	\N	\N	\N	225389	225389	392384
30034	50931	0	applied	\N	\N	\N	\N	225427	225427	392422
30034	50932	1	applied	\N	\N	\N	\N	225428	225428	392423
30034	50933	2	applied	\N	\N	\N	\N	225429	225429	392424
29993	50682	3	applied	\N	\N	\N	\N	224845	224845	391840
29993	50683	4	applied	\N	\N	\N	\N	224846	224846	391841
30003	50735	1	applied	\N	\N	\N	\N	225057	225057	392052
30003	50736	2	applied	\N	\N	\N	\N	225058	225058	392053
30003	50737	3	applied	\N	\N	\N	\N	225059	225059	392054
30003	50738	4	applied	\N	\N	\N	\N	225060	225060	392055
30003	50739	5	applied	\N	\N	\N	\N	225061	225061	392056
30003	50740	6	applied	\N	\N	\N	\N	225062	225062	392057
30003	50741	7	applied	\N	\N	\N	\N	225063	225063	392058
30003	50742	8	applied	\N	\N	\N	\N	225064	225064	392059
30006	50743	0	applied	\N	\N	\N	\N	225093	225093	392088
30006	50744	1	applied	\N	\N	\N	\N	225094	225094	392089
30006	50745	2	applied	\N	\N	\N	\N	225095	225095	392090
30006	50746	3	applied	\N	\N	\N	\N	225096	225096	392091
30006	50747	4	applied	\N	\N	\N	\N	225097	225097	392092
30006	50748	5	applied	\N	\N	\N	\N	225098	225098	392093
30006	50750	7	applied	\N	\N	\N	\N	225100	225100	392095
30006	50751	8	applied	\N	\N	\N	\N	225101	225101	392096
30006	50752	9	applied	\N	\N	\N	\N	225102	225102	392097
30006	50753	10	applied	\N	\N	\N	\N	225103	225103	392098
30006	50754	11	applied	\N	\N	\N	\N	225104	225104	392099
30006	50755	12	applied	\N	\N	\N	\N	225105	225105	392100
30006	50756	13	applied	\N	\N	\N	\N	225106	225106	392101
30006	50757	14	applied	\N	\N	\N	\N	225107	225107	392102
30006	50758	15	applied	\N	\N	\N	\N	225108	225108	392103
30006	50759	16	applied	\N	\N	\N	\N	225109	225109	392104
30006	50760	17	applied	\N	\N	\N	\N	225110	225110	392105
30006	50761	18	applied	\N	\N	\N	\N	225111	225111	392106
30006	50762	19	applied	\N	\N	\N	\N	225112	225112	392107
30008	50773	0	applied	\N	\N	\N	\N	225123	225123	392118
30008	50774	1	applied	\N	\N	\N	\N	225124	225124	392119
30008	50775	2	applied	\N	\N	\N	\N	225125	225125	392120
30008	50777	4	applied	\N	\N	\N	\N	225127	225127	392122
30008	50778	5	applied	\N	\N	\N	\N	225128	225128	392123
30008	50779	6	applied	\N	\N	\N	\N	225129	225129	392124
30008	50780	7	applied	\N	\N	\N	\N	225130	225130	392125
30008	50781	8	applied	\N	\N	\N	\N	225131	225131	392126
30010	50773	0	applied	\N	\N	\N	\N	225141	225141	392136
30010	50774	1	applied	\N	\N	\N	\N	225142	225142	392137
30010	50775	2	applied	\N	\N	\N	\N	225143	225143	392138
30010	50776	3	applied	\N	\N	\N	\N	225144	225144	392139
30010	50777	4	applied	\N	\N	\N	\N	225145	225145	392140
30010	50778	5	applied	\N	\N	\N	\N	225146	225146	392141
30010	50779	6	applied	\N	\N	\N	\N	225147	225147	392142
30010	50780	7	applied	\N	\N	\N	\N	225148	225148	392143
30010	50781	8	applied	\N	\N	\N	\N	225149	225149	392144
30011	50803	21	applied	\N	\N	\N	\N	225171	225171	392166
30011	50804	22	applied	\N	\N	\N	\N	225172	225172	392167
30011	50806	24	applied	\N	\N	\N	\N	225174	225174	392169
30011	50807	25	applied	\N	\N	\N	\N	225175	225175	392170
30011	50808	26	applied	\N	\N	\N	\N	225176	225176	392171
30011	50809	27	applied	\N	\N	\N	\N	225177	225177	392172
30011	50810	28	applied	\N	\N	\N	\N	225178	225178	392173
30012	50811	0	applied	\N	\N	\N	\N	225179	225179	392174
30012	50812	1	applied	\N	\N	\N	\N	225180	225180	392175
30012	50813	2	applied	\N	\N	\N	\N	225181	225181	392176
30012	50814	3	applied	\N	\N	\N	\N	225182	225182	392177
30012	50815	4	applied	\N	\N	\N	\N	225183	225183	392178
30012	50816	5	applied	\N	\N	\N	\N	225184	225184	392179
30012	50817	6	applied	\N	\N	\N	\N	225185	225185	392180
30012	50818	7	applied	\N	\N	\N	\N	225186	225186	392181
30012	50819	8	applied	\N	\N	\N	\N	225187	225187	392182
30014	50829	0	applied	\N	\N	\N	\N	225197	225197	392192
30014	50830	1	applied	\N	\N	\N	\N	225198	225198	392193
30014	50832	3	applied	\N	\N	\N	\N	225200	225200	392195
30014	50833	4	applied	\N	\N	\N	\N	225201	225201	392196
30014	50834	5	applied	\N	\N	\N	\N	225202	225202	392197
30014	50835	6	applied	\N	\N	\N	\N	225203	225203	392198
30014	50836	7	applied	\N	\N	\N	\N	225204	225204	392199
30014	50837	8	applied	\N	\N	\N	\N	225205	225205	392200
30016	50838	0	applied	\N	\N	\N	\N	225206	225206	392201
30016	50839	1	applied	\N	\N	\N	\N	225207	225207	392202
30016	50840	2	applied	\N	\N	\N	\N	225208	225208	392203
30016	50841	3	applied	\N	\N	\N	\N	225209	225209	392204
30016	50842	4	applied	\N	\N	\N	\N	225210	225210	392205
30025	50868	0	applied	\N	\N	\N	\N	225334	225334	392329
30025	50869	1	applied	\N	\N	\N	\N	225335	225335	392330
30025	50870	2	applied	\N	\N	\N	\N	225336	225336	392331
30025	50871	3	applied	\N	\N	\N	\N	225337	225337	392332
30025	50872	4	applied	\N	\N	\N	\N	225338	225338	392333
30025	50875	6	applied	\N	\N	\N	\N	225340	225340	392335
30027	50868	0	applied	\N	\N	\N	\N	225343	225343	392338
30027	50870	1	applied	\N	\N	\N	\N	225344	225344	392339
30027	50874	2	applied	\N	\N	\N	\N	225345	225345	392340
30027	50875	3	applied	\N	\N	\N	\N	225346	225346	392341
30029	50876	0	applied	\N	\N	\N	\N	225353	225353	392348
30029	50877	1	applied	\N	\N	\N	\N	225354	225354	392349
30029	50873	2	applied	\N	\N	\N	\N	225355	225355	392350
30029	50878	3	applied	\N	\N	\N	\N	225356	225356	392351
30029	50879	4	applied	\N	\N	\N	\N	225357	225357	392352
30032	50894	0	applied	\N	\N	\N	\N	225390	225390	392385
30032	50895	1	applied	\N	\N	\N	\N	225391	225391	392386
30032	50896	2	applied	\N	\N	\N	\N	225392	225392	392387
30032	50897	3	applied	\N	\N	\N	\N	225393	225393	392388
30032	50898	4	applied	\N	\N	\N	\N	225394	225394	392389
30032	50899	5	applied	\N	\N	\N	\N	225395	225395	392390
30032	50901	7	applied	\N	\N	\N	\N	225397	225397	392392
30032	50902	8	applied	\N	\N	\N	\N	225398	225398	392393
30032	50903	9	applied	\N	\N	\N	\N	225399	225399	392394
30032	50904	10	applied	\N	\N	\N	\N	225400	225400	392395
30032	50905	11	applied	\N	\N	\N	\N	225401	225401	392396
30032	50906	12	applied	\N	\N	\N	\N	225402	225402	392397
30032	50907	13	applied	\N	\N	\N	\N	225403	225403	392398
30032	50908	14	applied	\N	\N	\N	\N	225404	225404	392399
30032	50909	15	applied	\N	\N	\N	\N	225405	225405	392400
30032	50910	16	applied	\N	\N	\N	\N	225406	225406	392401
30032	50911	17	applied	\N	\N	\N	\N	225407	225407	392402
30032	50912	18	applied	\N	\N	\N	\N	225408	225408	392403
30037	50942	0	applied	\N	\N	\N	\N	225451	225451	392446
30037	50943	1	applied	\N	\N	\N	\N	225452	225452	392447
30037	50944	2	applied	\N	\N	\N	\N	225453	225453	392448
30001	50472	120	applied	\N	\N	\N	\N	225046	225046	392041
30003	50734	0	applied	\N	\N	\N	\N	225056	225056	392051
30016	50847	9	applied	\N	\N	\N	\N	225215	225215	392210
30016	50848	10	applied	\N	\N	\N	\N	225216	225216	392211
30016	50849	11	applied	\N	\N	\N	\N	225217	225217	392212
30016	50850	12	applied	\N	\N	\N	\N	225218	225218	392213
30016	50851	13	applied	\N	\N	\N	\N	225219	225219	392214
30016	50852	14	applied	\N	\N	\N	\N	225220	225220	392215
30016	50853	15	applied	\N	\N	\N	\N	225221	225221	392216
30016	50854	16	applied	\N	\N	\N	\N	225222	225222	392217
30016	50855	17	applied	\N	\N	\N	\N	225223	225223	392218
30016	50856	18	applied	\N	\N	\N	\N	225224	225224	392219
30016	50857	19	applied	\N	\N	\N	\N	225225	225225	392220
30016	50858	20	applied	\N	\N	\N	\N	225226	225226	392221
30016	50859	21	applied	\N	\N	\N	\N	225227	225227	392222
30016	50860	22	applied	\N	\N	\N	\N	225228	225228	392223
30016	50861	23	applied	\N	\N	\N	\N	225229	225229	392224
30016	50862	24	applied	\N	\N	\N	\N	225230	225230	392225
30016	50864	26	applied	\N	\N	\N	\N	225232	225232	392227
30016	50865	27	applied	\N	\N	\N	\N	225233	225233	392228
30016	50866	28	applied	\N	\N	\N	\N	225234	225234	392229
30016	50867	29	applied	\N	\N	\N	\N	225235	225235	392230
30019	50858	20	applied	\N	\N	\N	\N	225286	225286	392281
30019	50859	21	applied	\N	\N	\N	\N	225287	225287	392282
30019	50860	22	applied	\N	\N	\N	\N	225288	225288	392283
30019	50861	23	applied	\N	\N	\N	\N	225289	225289	392284
30019	50862	24	applied	\N	\N	\N	\N	225290	225290	392285
30019	50863	25	applied	\N	\N	\N	\N	225291	225291	392286
30019	50864	26	applied	\N	\N	\N	\N	225292	225292	392287
30019	50865	27	applied	\N	\N	\N	\N	225293	225293	392288
30019	50866	28	applied	\N	\N	\N	\N	225294	225294	392289
30019	50867	29	applied	\N	\N	\N	\N	225295	225295	392290
30020	50838	0	applied	\N	\N	\N	\N	225296	225296	392291
30020	50839	1	applied	\N	\N	\N	\N	225297	225297	392292
30020	50841	3	applied	\N	\N	\N	\N	225299	225299	392294
30020	50842	4	applied	\N	\N	\N	\N	225300	225300	392295
30020	50843	5	applied	\N	\N	\N	\N	225301	225301	392296
30020	50844	6	applied	\N	\N	\N	\N	225302	225302	392297
30020	50845	7	applied	\N	\N	\N	\N	225303	225303	392298
30020	50846	8	applied	\N	\N	\N	\N	225304	225304	392299
30020	50847	9	applied	\N	\N	\N	\N	225305	225305	392300
30020	50848	10	applied	\N	\N	\N	\N	225306	225306	392301
30020	50849	11	applied	\N	\N	\N	\N	225307	225307	392302
30020	50850	12	applied	\N	\N	\N	\N	225308	225308	392303
30020	50851	13	applied	\N	\N	\N	\N	225309	225309	392304
30020	50852	14	applied	\N	\N	\N	\N	225310	225310	392305
30020	50853	15	applied	\N	\N	\N	\N	225311	225311	392306
30020	50854	16	applied	\N	\N	\N	\N	225312	225312	392307
30020	50855	17	applied	\N	\N	\N	\N	225313	225313	392308
30020	50856	18	applied	\N	\N	\N	\N	225314	225314	392309
30020	50858	20	applied	\N	\N	\N	\N	225316	225316	392311
30020	50859	21	applied	\N	\N	\N	\N	225317	225317	392312
30020	50860	22	applied	\N	\N	\N	\N	225318	225318	392313
30020	50861	23	applied	\N	\N	\N	\N	225319	225319	392314
30020	50862	24	applied	\N	\N	\N	\N	225320	225320	392315
30020	50863	25	applied	\N	\N	\N	\N	225321	225321	392316
30020	50864	26	applied	\N	\N	\N	\N	225322	225322	392317
30020	50865	27	applied	\N	\N	\N	\N	225323	225323	392318
30020	50866	28	applied	\N	\N	\N	\N	225324	225324	392319
30020	50867	29	applied	\N	\N	\N	\N	225325	225325	392320
30024	50868	0	applied	\N	\N	\N	\N	225326	225326	392321
30024	50869	1	applied	\N	\N	\N	\N	225327	225327	392322
30024	50870	2	applied	\N	\N	\N	\N	225328	225328	392323
30024	50871	3	applied	\N	\N	\N	\N	225329	225329	392324
30024	50872	4	applied	\N	\N	\N	\N	225330	225330	392325
30024	50873	5	applied	\N	\N	\N	\N	225331	225331	392326
30024	50875	7	applied	\N	\N	\N	\N	225333	225333	392328
30026	50868	0	applied	\N	\N	\N	\N	225341	225341	392336
30026	50875	1	applied	\N	\N	\N	\N	225342	225342	392337
30028	50876	0	applied	\N	\N	\N	\N	225347	225347	392342
30028	50877	1	applied	\N	\N	\N	\N	225348	225348	392343
30028	50873	2	applied	\N	\N	\N	\N	225349	225349	392344
30028	50878	3	applied	\N	\N	\N	\N	225350	225350	392345
30028	50879	4	applied	\N	\N	\N	\N	225351	225351	392346
30028	50880	5	applied	\N	\N	\N	\N	225352	225352	392347
30030	50881	0	applied	\N	\N	\N	\N	225358	225358	392353
30030	50882	1	applied	\N	\N	\N	\N	225359	225359	392354
30030	50883	2	applied	\N	\N	\N	\N	225360	225360	392355
30030	50884	3	applied	\N	\N	\N	\N	225361	225361	392356
30030	50885	4	applied	\N	\N	\N	\N	225362	225362	392357
30030	50886	5	applied	\N	\N	\N	\N	225363	225363	392358
30030	50887	6	applied	\N	\N	\N	\N	225364	225364	392359
30030	50889	8	applied	\N	\N	\N	\N	225366	225366	392361
30030	50890	9	applied	\N	\N	\N	\N	225367	225367	392362
30030	50891	10	applied	\N	\N	\N	\N	225368	225368	392363
30030	50892	11	applied	\N	\N	\N	\N	225369	225369	392364
30030	50893	12	applied	\N	\N	\N	\N	225370	225370	392365
30033	50913	0	applied	\N	\N	\N	\N	225409	225409	392404
30033	50914	1	applied	\N	\N	\N	\N	225410	225410	392405
30033	50915	2	applied	\N	\N	\N	\N	225411	225411	392406
30033	50916	3	applied	\N	\N	\N	\N	225412	225412	392407
30033	50917	5	applied	\N	\N	\N	\N	225413	225413	392408
30033	50918	6	applied	\N	\N	\N	\N	225414	225414	392409
30033	50919	7	applied	\N	\N	\N	\N	225415	225415	392410
30033	50920	8	applied	\N	\N	\N	\N	225416	225416	392411
30033	50921	9	applied	\N	\N	\N	\N	225417	225417	392412
30033	50922	10	applied	\N	\N	\N	\N	225418	225418	392413
30033	50923	11	applied	\N	\N	\N	\N	225419	225419	392414
30033	50925	13	applied	\N	\N	\N	\N	225421	225421	392416
30033	50926	14	applied	\N	\N	\N	\N	225422	225422	392417
30039	50952	0	applied	\N	\N	\N	\N	225471	225471	392466
30039	50953	1	applied	\N	\N	\N	\N	225472	225472	392467
30039	50954	2	applied	\N	\N	\N	\N	225473	225473	392468
30039	50955	3	applied	\N	\N	\N	\N	225474	225474	392469
30039	50956	4	applied	\N	\N	\N	\N	225475	225475	392470
30039	50957	5	applied	\N	\N	\N	\N	225476	225476	392471
30039	50958	6	applied	\N	\N	\N	\N	225477	225477	392472
30039	50959	7	applied	\N	\N	\N	\N	225478	225478	392473
30039	50960	8	applied	\N	\N	\N	\N	225479	225479	392474
30039	50961	9	applied	\N	\N	\N	\N	225480	225480	392475
30039	50962	10	applied	\N	\N	\N	\N	225481	225481	392476
30039	50963	11	applied	\N	\N	\N	\N	225482	225482	392477
30016	50844	6	applied	\N	\N	\N	\N	225212	225212	392207
30016	50845	7	applied	\N	\N	\N	\N	225213	225213	392208
30033	50930	18	applied	\N	\N	\N	\N	225426	225426	392421
30035	50931	0	applied	\N	\N	\N	\N	225438	225438	392433
30035	50932	1	applied	\N	\N	\N	\N	225439	225439	392434
30035	50933	2	applied	\N	\N	\N	\N	225440	225440	392435
30035	50934	3	applied	\N	\N	\N	\N	225441	225441	392436
30035	50935	4	applied	\N	\N	\N	\N	225442	225442	392437
30035	50936	5	applied	\N	\N	\N	\N	225443	225443	392438
30035	50937	6	applied	\N	\N	\N	\N	225444	225444	392439
30035	50938	7	applied	\N	\N	\N	\N	225445	225445	392440
30035	50939	8	applied	\N	\N	\N	\N	225446	225446	392441
30035	50940	9	applied	\N	\N	\N	\N	225447	225447	392442
30035	50941	10	applied	\N	\N	\N	\N	225448	225448	392443
30039	50964	12	applied	\N	\N	\N	\N	225483	225483	392478
30039	50966	14	applied	\N	\N	\N	\N	225485	225485	392480
30039	50967	15	applied	\N	\N	\N	\N	225486	225486	392481
30039	50968	16	applied	\N	\N	\N	\N	225487	225487	392482
30039	50969	17	applied	\N	\N	\N	\N	225488	225488	392483
30039	50970	18	applied	\N	\N	\N	\N	225489	225489	392484
30039	50971	19	applied	\N	\N	\N	\N	225490	225490	392485
30039	50972	20	applied	\N	\N	\N	\N	225491	225491	392486
30039	50973	21	applied	\N	\N	\N	\N	225492	225492	392487
30041	50952	0	applied	\N	\N	\N	\N	225515	225515	392510
30041	50953	1	applied	\N	\N	\N	\N	225516	225516	392511
30041	50954	2	applied	\N	\N	\N	\N	225517	225517	392512
30041	50955	3	applied	\N	\N	\N	\N	225518	225518	392513
30041	50956	4	applied	\N	\N	\N	\N	225519	225519	392514
30041	50957	5	applied	\N	\N	\N	\N	225520	225520	392515
30041	50958	6	applied	\N	\N	\N	\N	225521	225521	392516
30043	50974	0	applied	\N	\N	\N	\N	225558	225558	392552
30043	50976	2	applied	\N	\N	\N	\N	225560	225560	392554
30043	50977	3	applied	\N	\N	\N	\N	225561	225561	392555
30043	50978	4	applied	\N	\N	\N	\N	225562	225562	392556
30043	50979	5	applied	\N	\N	\N	\N	225563	225563	225563
30043	50980	6	applied	\N	\N	1000000000	\N	225564	225564	392557
30043	50981	7	applied	\N	\N	\N	\N	225565	225565	392558
30043	50982	8	applied	\N	\N	\N	\N	225566	225566	392559
30043	50983	9	applied	\N	\N	\N	\N	225567	225567	392560
30043	50984	10	applied	\N	\N	\N	\N	225568	225568	392561
30043	50985	11	applied	\N	\N	\N	\N	225569	225569	392562
30043	50986	12	applied	\N	\N	\N	\N	225570	225570	392563
30043	50987	13	applied	\N	\N	\N	\N	225571	225571	392564
30043	50988	14	applied	\N	\N	\N	\N	225572	225572	392565
30043	50989	15	applied	\N	\N	\N	\N	225573	225573	392566
30043	50990	16	applied	\N	\N	\N	\N	225574	225574	392567
30043	50991	17	applied	\N	\N	\N	\N	225575	225575	392568
30043	50993	19	applied	\N	\N	\N	\N	225577	225577	392570
30043	50994	20	applied	\N	\N	\N	\N	225578	225578	392571
30044	50974	0	applied	\N	\N	\N	\N	225579	225579	392572
30044	50975	1	applied	\N	\N	\N	\N	225580	225580	392573
30044	50976	2	applied	\N	\N	\N	\N	225581	225581	392574
30044	50977	3	applied	\N	\N	\N	\N	225582	225582	392575
30044	50978	4	applied	\N	\N	\N	\N	225583	225583	392576
30044	50979	5	applied	\N	\N	\N	\N	225584	225584	225584
30044	50980	6	applied	\N	\N	1000000000	\N	225585	225585	392577
30044	50981	7	applied	\N	\N	\N	\N	225586	225586	392578
30044	50982	8	applied	\N	\N	\N	\N	225587	225587	392579
30044	50983	9	applied	\N	\N	\N	\N	225588	225588	392580
30044	50984	10	applied	\N	\N	\N	\N	225589	225589	392581
30044	50985	11	applied	\N	\N	\N	\N	225590	225590	392582
30044	50986	12	applied	\N	\N	\N	\N	225591	225591	392583
30044	50987	13	applied	\N	\N	\N	\N	225592	225592	392584
30044	50989	15	applied	\N	\N	\N	\N	225594	225594	392586
30044	50990	16	applied	\N	\N	\N	\N	225595	225595	392587
30044	50991	17	applied	\N	\N	\N	\N	225596	225596	392588
30044	50992	18	applied	\N	\N	\N	\N	225597	225597	392589
30044	50993	19	applied	\N	\N	\N	\N	225598	225598	392590
30044	50994	20	applied	\N	\N	\N	\N	225599	225599	392591
30048	51015	0	applied	\N	\N	\N	\N	225660	225660	392652
30048	51016	1	applied	\N	\N	\N	\N	225661	225661	392653
30048	51017	2	applied	\N	\N	\N	\N	225662	225662	392654
30048	51018	3	applied	\N	\N	\N	\N	225663	225663	392655
30048	51019	4	applied	\N	\N	\N	\N	225664	225664	392656
30048	51020	5	applied	\N	\N	\N	\N	225665	225665	392657
30048	51021	6	applied	\N	\N	\N	\N	225666	225666	392658
30048	51022	7	applied	\N	\N	\N	\N	225667	225667	392659
30048	51023	8	applied	\N	\N	\N	\N	225668	225668	392660
30048	51024	9	applied	\N	\N	\N	\N	225669	225669	392661
30054	51043	1	applied	\N	\N	\N	\N	225725	225725	392717
30054	51044	2	applied	\N	\N	\N	\N	225726	225726	392718
30054	51045	3	applied	\N	\N	\N	\N	225727	225727	392719
30054	51046	4	applied	\N	\N	\N	\N	225728	225728	392720
30054	51047	5	applied	\N	\N	\N	\N	225729	225729	392721
30054	51048	6	applied	\N	\N	\N	\N	225730	225730	392722
30054	51049	7	applied	\N	\N	\N	\N	225731	225731	392723
30054	51050	8	applied	\N	\N	\N	\N	225732	225732	392724
30054	51051	9	applied	\N	\N	\N	\N	225733	225733	392725
30057	51052	0	applied	\N	\N	\N	\N	225774	225774	392766
30057	51053	1	applied	\N	\N	\N	\N	225775	225775	392767
30057	51054	2	applied	\N	\N	\N	\N	225776	225776	392768
30057	51055	3	applied	\N	\N	\N	\N	225777	225777	392769
30057	51056	4	applied	\N	\N	\N	\N	225778	225778	392770
30057	51057	5	applied	\N	\N	\N	\N	225779	225779	392771
30057	51058	6	applied	\N	\N	\N	\N	225780	225780	392772
30057	51060	8	applied	\N	\N	\N	\N	225782	225782	392774
30057	51061	9	applied	\N	\N	\N	\N	225783	225783	392775
30057	51062	10	applied	\N	\N	\N	\N	225784	225784	392776
30057	51063	11	applied	\N	\N	\N	\N	225785	225785	392777
30057	51064	12	applied	\N	\N	\N	\N	225786	225786	392778
30057	51065	13	applied	\N	\N	\N	\N	225787	225787	392779
30057	51066	14	applied	\N	\N	\N	\N	225788	225788	392780
30057	51067	15	applied	\N	\N	\N	\N	225789	225789	392781
30057	51068	16	applied	\N	\N	\N	\N	225790	225790	392782
30057	51069	17	applied	\N	\N	\N	\N	225791	225791	392783
30057	51070	18	applied	\N	\N	\N	\N	225792	225792	392784
30057	51071	19	applied	\N	\N	\N	\N	225793	225793	392785
30063	51131	0	applied	\N	\N	\N	\N	225881	225881	392873
30063	51132	1	applied	\N	\N	\N	\N	225882	225882	392874
30063	51133	2	applied	\N	\N	\N	\N	225883	225883	392875
30063	51134	3	applied	\N	\N	\N	\N	225884	225884	392876
30033	50928	16	applied	\N	\N	\N	\N	225424	225424	392419
30033	50929	17	applied	\N	\N	\N	\N	225425	225425	392420
30034	50937	6	applied	\N	\N	\N	\N	225433	225433	392428
30034	50938	7	applied	\N	\N	\N	\N	225434	225434	392429
30034	50939	8	applied	\N	\N	\N	\N	225435	225435	392430
30034	50940	9	applied	\N	\N	\N	\N	225436	225436	392431
30034	50941	10	applied	\N	\N	\N	\N	225437	225437	392432
30036	50396	0	applied	\N	\N	1000000000	\N	225449	225449	392444
30036	50397	1	applied	\N	\N	1000000000	\N	225450	225450	392445
30038	50942	0	applied	\N	\N	\N	\N	225461	225461	392456
30038	50943	1	applied	\N	\N	\N	\N	225462	225462	392457
30038	50945	3	applied	\N	\N	1000000000	\N	225464	225464	392459
30038	50946	4	applied	\N	\N	1000000000	\N	225465	225465	392460
30038	50947	5	applied	\N	\N	\N	\N	225466	225466	392461
30038	50948	6	applied	\N	\N	\N	\N	225467	225467	392462
30038	50949	7	applied	\N	\N	\N	\N	225468	225468	392463
30038	50950	8	applied	\N	\N	\N	\N	225469	225469	392464
30038	50951	9	applied	\N	\N	\N	\N	225470	225470	392465
30041	50959	7	applied	\N	\N	\N	\N	225522	225522	392517
30041	50960	8	applied	\N	\N	\N	\N	225523	225523	392518
30041	50961	9	applied	\N	\N	\N	\N	225524	225524	392519
30041	50962	10	applied	\N	\N	\N	\N	225525	225525	392520
30041	50963	11	applied	\N	\N	\N	\N	225526	225526	392521
30041	50964	12	applied	\N	\N	\N	\N	225527	225527	392522
30041	50965	13	applied	\N	\N	\N	\N	225528	225528	392523
30041	50966	14	applied	\N	\N	\N	\N	225529	225529	392524
30041	50967	15	applied	\N	\N	\N	\N	225530	225530	392525
30041	50969	17	applied	\N	\N	\N	\N	225532	225532	392527
30041	50970	18	applied	\N	\N	\N	\N	225533	225533	392528
30041	50971	19	applied	\N	\N	\N	\N	225534	225534	392529
30041	50972	20	applied	\N	\N	\N	\N	225535	225535	392530
30041	50973	21	applied	\N	\N	\N	\N	225536	225536	392531
30042	50974	0	applied	\N	\N	\N	\N	225537	225537	392532
30047	50995	0	applied	\N	\N	\N	\N	225640	225640	392632
30047	50996	1	applied	\N	\N	\N	\N	225641	225641	392633
30047	50997	2	applied	\N	\N	\N	\N	225642	225642	392634
30047	50998	3	applied	\N	\N	\N	\N	225643	225643	392635
30047	50999	4	applied	\N	\N	\N	\N	225644	225644	392636
30047	51000	5	applied	\N	\N	\N	\N	225645	225645	392637
30047	51001	6	applied	\N	\N	\N	\N	225646	225646	392638
30047	51002	7	applied	\N	\N	\N	\N	225647	225647	392639
30047	51003	8	applied	\N	\N	\N	\N	225648	225648	392640
30047	51004	9	applied	\N	\N	\N	\N	225649	225649	392641
30047	51006	11	applied	\N	\N	\N	\N	225651	225651	392643
30047	51007	12	applied	\N	\N	\N	\N	225652	225652	392644
30047	51008	13	applied	\N	\N	\N	\N	225653	225653	392645
30047	51009	14	applied	\N	\N	\N	\N	225654	225654	392646
30047	51010	15	applied	\N	\N	\N	\N	225655	225655	392647
30047	51011	16	applied	\N	\N	\N	\N	225656	225656	392648
30047	51012	17	applied	\N	\N	\N	\N	225657	225657	392649
30047	51013	18	applied	\N	\N	\N	\N	225658	225658	392650
30047	51014	19	applied	\N	\N	\N	\N	225659	225659	392651
30051	51025	0	applied	\N	\N	\N	\N	225680	225680	392672
30051	51026	1	applied	\N	\N	\N	\N	225681	225681	392673
30051	51027	2	applied	\N	\N	\N	\N	225682	225682	392674
30051	51028	3	applied	\N	\N	\N	\N	225683	225683	392675
30051	51029	4	applied	\N	\N	\N	\N	225684	225684	392676
30051	51030	5	applied	\N	\N	\N	\N	225685	225685	392677
30051	51031	6	applied	\N	\N	\N	\N	225686	225686	392678
30051	51033	8	applied	\N	\N	\N	\N	225688	225688	392680
30051	51034	9	applied	\N	\N	\N	\N	225689	225689	392681
30051	51035	10	applied	\N	\N	\N	\N	225690	225690	392682
30051	51036	11	applied	\N	\N	\N	\N	225691	225691	392683
30051	51037	12	applied	\N	\N	\N	\N	225692	225692	392684
30051	51038	13	applied	\N	\N	\N	\N	225693	225693	392685
30051	51039	14	applied	\N	\N	\N	\N	225694	225694	392686
30051	51040	15	applied	\N	\N	\N	\N	225695	225695	392687
30051	51041	16	applied	\N	\N	\N	\N	225696	225696	392688
30056	51052	0	applied	\N	\N	\N	\N	225754	225754	392746
30056	51053	1	applied	\N	\N	\N	\N	225755	225755	392747
30056	51054	2	applied	\N	\N	\N	\N	225756	225756	392748
30056	51055	3	applied	\N	\N	\N	\N	225757	225757	392749
30056	51056	4	applied	\N	\N	\N	\N	225758	225758	392750
30056	51057	5	applied	\N	\N	\N	\N	225759	225759	392751
30056	51058	6	applied	\N	\N	\N	\N	225760	225760	392752
30056	51060	8	applied	\N	\N	\N	\N	225762	225762	392754
30056	51061	9	applied	\N	\N	\N	\N	225763	225763	392755
30056	51062	10	applied	\N	\N	\N	\N	225764	225764	392756
30056	51063	11	applied	\N	\N	\N	\N	225765	225765	392757
30056	51064	12	applied	\N	\N	\N	\N	225766	225766	392758
30056	51065	13	applied	\N	\N	\N	\N	225767	225767	392759
30056	51066	14	applied	\N	\N	\N	\N	225768	225768	392760
30056	51067	15	applied	\N	\N	\N	\N	225769	225769	392761
30056	51068	16	applied	\N	\N	\N	\N	225770	225770	392762
30056	51069	17	applied	\N	\N	\N	\N	225771	225771	392763
30056	51070	18	applied	\N	\N	\N	\N	225772	225772	392764
30056	51071	19	applied	\N	\N	\N	\N	225773	225773	392765
30060	51091	0	applied	\N	\N	\N	\N	225832	225832	392824
30060	51092	1	applied	\N	\N	\N	\N	225833	225833	392825
30060	51093	2	applied	\N	\N	\N	\N	225834	225834	392826
30060	51094	3	applied	\N	\N	\N	\N	225835	225835	392827
30060	51096	5	applied	\N	\N	\N	\N	225837	225837	392829
30060	51097	6	applied	\N	\N	\N	\N	225838	225838	392830
30060	51098	7	applied	\N	\N	\N	\N	225839	225839	392831
30068	51167	0	applied	\N	\N	\N	\N	225925	225925	392916
30068	51168	1	applied	\N	\N	\N	\N	225926	225926	392917
30068	51169	2	applied	\N	\N	\N	\N	225927	225927	392918
30068	51170	3	applied	\N	\N	\N	\N	225928	225928	392919
30068	51171	4	applied	\N	\N	\N	\N	225929	225929	392920
30068	51172	5	applied	\N	\N	\N	\N	225930	225930	392921
30070	51167	0	applied	\N	\N	\N	\N	225942	225942	392933
30070	51168	1	applied	\N	\N	\N	\N	225943	225943	392934
30070	51169	2	applied	\N	\N	\N	\N	225944	225944	392935
30070	51170	3	applied	\N	\N	\N	\N	225945	225945	392936
30070	51173	4	applied	\N	\N	\N	\N	225946	225946	392937
30070	51174	5	applied	\N	\N	\N	\N	225947	225947	392938
30070	51175	6	applied	\N	\N	\N	\N	225948	225948	392939
30070	51177	8	applied	\N	\N	\N	\N	225950	225950	392941
30070	51171	9	applied	\N	\N	\N	\N	225951	225951	392942
30070	51172	10	applied	\N	\N	\N	\N	225952	225952	392943
30076	51197	0	applied	\N	\N	\N	\N	226021	226021	393012
30034	50935	4	applied	\N	\N	\N	\N	225431	225431	392426
30034	50936	5	applied	\N	\N	\N	\N	225432	225432	392427
30037	50949	7	applied	\N	\N	\N	\N	225458	225458	392453
30037	50950	8	applied	\N	\N	\N	\N	225459	225459	392454
30037	50951	9	applied	\N	\N	\N	\N	225460	225460	392455
30040	50952	0	applied	\N	\N	\N	\N	225493	225493	392488
30040	50953	1	applied	\N	\N	\N	\N	225494	225494	392489
30040	50954	2	applied	\N	\N	\N	\N	225495	225495	392490
30040	50955	3	applied	\N	\N	\N	\N	225496	225496	392491
30040	50956	4	applied	\N	\N	\N	\N	225497	225497	392492
30040	50957	5	applied	\N	\N	\N	\N	225498	225498	392493
30040	50958	6	applied	\N	\N	\N	\N	225499	225499	392494
30040	50959	7	applied	\N	\N	\N	\N	225500	225500	392495
30040	50960	8	applied	\N	\N	\N	\N	225501	225501	392496
30040	50961	9	applied	\N	\N	\N	\N	225502	225502	392497
30040	50963	11	applied	\N	\N	\N	\N	225504	225504	392499
30040	50964	12	applied	\N	\N	\N	\N	225505	225505	392500
30040	50965	13	applied	\N	\N	\N	\N	225506	225506	392501
30040	50966	14	applied	\N	\N	\N	\N	225507	225507	392502
30042	50975	1	applied	\N	\N	\N	\N	225538	225538	392533
30042	50976	2	applied	\N	\N	\N	\N	225539	225539	392534
30042	50977	3	applied	\N	\N	\N	\N	225540	225540	392535
30042	50978	4	applied	\N	\N	\N	\N	225541	225541	392536
30042	50979	5	applied	\N	\N	\N	\N	225542	225542	225542
30042	50980	6	applied	\N	\N	1000000000	\N	225543	225543	392537
30042	50981	7	applied	\N	\N	\N	\N	225544	225544	392538
30042	50982	8	applied	\N	\N	\N	\N	225545	225545	392539
30042	50983	9	applied	\N	\N	\N	\N	225546	225546	392540
30042	50984	10	applied	\N	\N	\N	\N	225547	225547	392541
30042	50985	11	applied	\N	\N	\N	\N	225548	225548	392542
30042	50986	12	applied	\N	\N	\N	\N	225549	225549	392543
30042	50988	14	applied	\N	\N	\N	\N	225551	225551	392545
30042	50989	15	applied	\N	\N	\N	\N	225552	225552	392546
30042	50990	16	applied	\N	\N	\N	\N	225553	225553	392547
30042	50991	17	applied	\N	\N	\N	\N	225554	225554	392548
30042	50992	18	applied	\N	\N	\N	\N	225555	225555	392549
30042	50993	19	applied	\N	\N	\N	\N	225556	225556	392550
30042	50994	20	applied	\N	\N	\N	\N	225557	225557	392551
30045	50995	0	applied	\N	\N	\N	\N	225600	225600	392592
30045	50996	1	applied	\N	\N	\N	\N	225601	225601	392593
30045	50997	2	applied	\N	\N	\N	\N	225602	225602	392594
30045	50998	3	applied	\N	\N	\N	\N	225603	225603	392595
30045	50999	4	applied	\N	\N	\N	\N	225604	225604	392596
30045	51000	5	applied	\N	\N	\N	\N	225605	225605	392597
30045	51001	6	applied	\N	\N	\N	\N	225606	225606	392598
30045	51002	7	applied	\N	\N	\N	\N	225607	225607	392599
30045	51003	8	applied	\N	\N	\N	\N	225608	225608	392600
30045	51005	10	applied	\N	\N	\N	\N	225610	225610	392602
30045	51006	11	applied	\N	\N	\N	\N	225611	225611	392603
30045	51007	12	applied	\N	\N	\N	\N	225612	225612	392604
30045	51008	13	applied	\N	\N	\N	\N	225613	225613	392605
30045	51009	14	applied	\N	\N	\N	\N	225614	225614	392606
30045	51010	15	applied	\N	\N	\N	\N	225615	225615	392607
30045	51011	16	applied	\N	\N	\N	\N	225616	225616	392608
30045	51012	17	applied	\N	\N	\N	\N	225617	225617	392609
30045	51013	18	applied	\N	\N	\N	\N	225618	225618	392610
30045	51014	19	applied	\N	\N	\N	\N	225619	225619	392611
30053	51042	0	applied	\N	\N	\N	\N	225714	225714	392706
30053	51043	1	applied	\N	\N	\N	\N	225715	225715	392707
30053	51044	2	applied	\N	\N	\N	\N	225716	225716	392708
30053	51045	3	applied	\N	\N	\N	\N	225717	225717	392709
30053	51046	4	applied	\N	\N	\N	\N	225718	225718	392710
30053	51047	5	applied	\N	\N	\N	\N	225719	225719	392711
30053	51049	7	applied	\N	\N	\N	\N	225721	225721	392713
30053	51050	8	applied	\N	\N	\N	\N	225722	225722	392714
30053	51051	9	applied	\N	\N	\N	\N	225723	225723	392715
30055	51052	0	applied	\N	\N	\N	\N	225734	225734	392726
30055	51053	1	applied	\N	\N	\N	\N	225735	225735	392727
30055	51054	2	applied	\N	\N	\N	\N	225736	225736	392728
30055	51055	3	applied	\N	\N	\N	\N	225737	225737	392729
30055	51056	4	applied	\N	\N	\N	\N	225738	225738	392730
30055	51057	5	applied	\N	\N	\N	\N	225739	225739	392731
30055	51058	6	applied	\N	\N	\N	\N	225740	225740	392732
30055	51059	7	applied	\N	\N	\N	\N	225741	225741	392733
30055	51060	8	applied	\N	\N	\N	\N	225742	225742	392734
30055	51061	9	applied	\N	\N	\N	\N	225743	225743	392735
30055	51062	10	applied	\N	\N	\N	\N	225744	225744	392736
30055	51063	11	applied	\N	\N	\N	\N	225745	225745	392737
30055	51064	12	applied	\N	\N	\N	\N	225746	225746	392738
30055	51066	14	applied	\N	\N	\N	\N	225748	225748	392740
30055	51067	15	applied	\N	\N	\N	\N	225749	225749	392741
30055	51068	16	applied	\N	\N	\N	\N	225750	225750	392742
30055	51069	17	applied	\N	\N	\N	\N	225751	225751	392743
30055	51070	18	applied	\N	\N	\N	\N	225752	225752	392744
30055	51071	19	applied	\N	\N	\N	\N	225753	225753	392745
30058	51072	0	applied	\N	\N	\N	\N	225794	225794	392786
30058	51073	1	applied	\N	\N	\N	\N	225795	225795	392787
30058	51074	2	applied	\N	\N	\N	\N	225796	225796	392788
30058	51075	3	applied	\N	\N	\N	\N	225797	225797	392789
30058	51076	4	applied	\N	\N	\N	\N	225798	225798	392790
30058	51077	5	applied	\N	\N	\N	\N	225799	225799	392791
30058	51078	6	applied	\N	\N	\N	\N	225800	225800	392792
30058	51079	7	applied	\N	\N	\N	\N	225801	225801	392793
30058	51080	8	applied	\N	\N	\N	\N	225802	225802	392794
30058	51081	9	applied	\N	\N	\N	\N	225803	225803	392795
30058	51083	11	applied	\N	\N	\N	\N	225805	225805	392797
30058	51084	12	applied	\N	\N	\N	\N	225806	225806	392798
30058	51085	13	applied	\N	\N	\N	\N	225807	225807	392799
30058	51086	14	applied	\N	\N	\N	\N	225808	225808	392800
30058	51087	15	applied	\N	\N	\N	\N	225809	225809	392801
30058	51088	16	applied	\N	\N	\N	\N	225810	225810	392802
30058	51089	17	applied	\N	\N	\N	\N	225811	225811	392803
30058	51090	18	applied	\N	\N	\N	\N	225812	225812	392804
30061	51099	0	applied	\N	\N	\N	\N	225840	225840	392832
30061	51100	1	applied	\N	\N	\N	\N	225841	225841	392833
30061	51101	2	applied	\N	\N	\N	\N	225842	225842	392834
30061	51102	3	applied	\N	\N	1000000000	\N	225843	225843	392835
30061	51103	4	applied	\N	\N	\N	\N	225844	225844	392836
30061	51104	5	applied	\N	\N	\N	\N	225845	225845	392837
30061	51105	6	applied	\N	\N	\N	\N	225846	225846	392838
30061	51106	7	applied	\N	\N	\N	\N	225847	225847	392839
30037	50947	5	applied	\N	\N	\N	\N	225456	225456	392451
30037	50948	6	applied	\N	\N	\N	\N	225457	225457	392452
30040	50971	19	applied	\N	\N	\N	\N	225512	225512	392507
30040	50972	20	applied	\N	\N	\N	\N	225513	225513	392508
30040	50973	21	applied	\N	\N	\N	\N	225514	225514	392509
30046	50995	0	applied	\N	\N	\N	\N	225620	225620	392612
30046	50996	1	applied	\N	\N	\N	\N	225621	225621	392613
30046	50997	2	applied	\N	\N	\N	\N	225622	225622	392614
30046	50998	3	applied	\N	\N	\N	\N	225623	225623	392615
30046	50999	4	applied	\N	\N	\N	\N	225624	225624	392616
30046	51000	5	applied	\N	\N	\N	\N	225625	225625	392617
30046	51001	6	applied	\N	\N	\N	\N	225626	225626	392618
30046	51002	7	applied	\N	\N	\N	\N	225627	225627	392619
30046	51003	8	applied	\N	\N	\N	\N	225628	225628	392620
30046	51004	9	applied	\N	\N	\N	\N	225629	225629	392621
30046	51005	10	applied	\N	\N	\N	\N	225630	225630	392622
30046	51007	12	applied	\N	\N	\N	\N	225632	225632	392624
30046	51008	13	applied	\N	\N	\N	\N	225633	225633	392625
30046	51009	14	applied	\N	\N	\N	\N	225634	225634	392626
30046	51010	15	applied	\N	\N	\N	\N	225635	225635	392627
30046	51011	16	applied	\N	\N	\N	\N	225636	225636	392628
30046	51012	17	applied	\N	\N	\N	\N	225637	225637	392629
30046	51013	18	applied	\N	\N	\N	\N	225638	225638	392630
30046	51014	19	applied	\N	\N	\N	\N	225639	225639	392631
30049	51015	0	applied	\N	\N	\N	\N	225670	225670	392662
30049	51016	1	applied	\N	\N	\N	\N	225671	225671	392663
30049	51017	2	applied	\N	\N	\N	\N	225672	225672	392664
30049	51018	3	applied	\N	\N	\N	\N	225673	225673	392665
30049	51019	4	applied	\N	\N	\N	\N	225674	225674	392666
30049	51020	5	applied	\N	\N	\N	\N	225675	225675	392667
30049	51021	6	applied	\N	\N	\N	\N	225676	225676	392668
30049	51022	7	applied	\N	\N	\N	\N	225677	225677	392669
30049	51024	9	applied	\N	\N	\N	\N	225679	225679	392671
30052	51025	0	applied	\N	\N	\N	\N	225697	225697	392689
30052	51026	1	applied	\N	\N	\N	\N	225698	225698	392690
30052	51027	2	applied	\N	\N	\N	\N	225699	225699	392691
30052	51028	3	applied	\N	\N	\N	\N	225700	225700	392692
30052	51029	4	applied	\N	\N	\N	\N	225701	225701	392693
30052	51030	5	applied	\N	\N	\N	\N	225702	225702	392694
30052	51031	6	applied	\N	\N	\N	\N	225703	225703	392695
30052	51032	7	applied	\N	\N	\N	\N	225704	225704	392696
30052	51033	8	applied	\N	\N	\N	\N	225705	225705	392697
30052	51034	9	applied	\N	\N	\N	\N	225706	225706	392698
30052	51035	10	applied	\N	\N	\N	\N	225707	225707	392699
30052	51036	11	applied	\N	\N	\N	\N	225708	225708	392700
30052	51037	12	applied	\N	\N	\N	\N	225709	225709	392701
30052	51038	13	applied	\N	\N	\N	\N	225710	225710	392702
30052	51039	14	applied	\N	\N	\N	\N	225711	225711	392703
30052	51041	16	applied	\N	\N	\N	\N	225713	225713	392705
30059	51072	0	applied	\N	\N	\N	\N	225813	225813	392805
30059	51073	1	applied	\N	\N	\N	\N	225814	225814	392806
30059	51074	2	applied	\N	\N	\N	\N	225815	225815	392807
30059	51075	3	applied	\N	\N	\N	\N	225816	225816	392808
30059	51076	4	applied	\N	\N	\N	\N	225817	225817	392809
30059	51077	5	applied	\N	\N	\N	\N	225818	225818	392810
30059	51078	6	applied	\N	\N	\N	\N	225819	225819	392811
30059	51079	7	applied	\N	\N	\N	\N	225820	225820	392812
30059	51080	8	applied	\N	\N	\N	\N	225821	225821	392813
30059	51081	9	applied	\N	\N	\N	\N	225822	225822	392814
30059	51082	10	applied	\N	\N	\N	\N	225823	225823	392815
30059	51083	11	applied	\N	\N	\N	\N	225824	225824	392816
30059	51084	12	applied	\N	\N	\N	\N	225825	225825	392817
30059	51085	13	applied	\N	\N	\N	\N	225826	225826	392818
30059	51086	14	applied	\N	\N	\N	\N	225827	225827	392819
30059	51088	16	applied	\N	\N	\N	\N	225829	225829	392821
30059	51089	17	applied	\N	\N	\N	\N	225830	225830	392822
30059	51090	18	applied	\N	\N	\N	\N	225831	225831	392823
30062	51099	0	applied	\N	\N	\N	\N	225849	225849	392841
30062	51100	1	applied	\N	\N	\N	\N	225850	225850	392842
30062	51101	2	applied	\N	\N	\N	\N	225851	225851	392843
30062	51108	3	applied	\N	\N	\N	\N	225852	225852	392844
30062	51109	4	applied	\N	\N	\N	\N	225853	225853	392845
30062	51110	5	applied	\N	\N	\N	\N	225854	225854	392846
30062	51111	6	applied	\N	\N	\N	\N	225855	225855	392847
30062	51112	7	applied	\N	\N	\N	\N	225856	225856	392848
30062	51113	8	applied	\N	\N	\N	\N	225857	225857	392849
30062	51114	9	applied	\N	\N	\N	\N	225858	225858	392850
30062	51115	10	applied	\N	\N	\N	\N	225859	225859	392851
30062	51116	11	applied	\N	\N	\N	\N	225860	225860	392852
30062	51117	12	applied	\N	\N	\N	\N	225861	225861	392853
30062	51102	14	applied	\N	\N	1000000000	\N	225863	225863	392855
30062	51103	15	applied	\N	\N	\N	\N	225864	225864	392856
30062	51104	16	applied	\N	\N	\N	\N	225865	225865	392857
30062	51105	17	applied	\N	\N	\N	\N	225866	225866	392858
30062	51106	18	applied	\N	\N	\N	\N	225867	225867	392859
30062	51107	19	applied	\N	\N	\N	\N	225868	225868	392860
30062	51119	20	applied	\N	\N	\N	\N	225869	225869	392861
30062	51120	21	applied	\N	\N	\N	\N	225870	225870	392862
30062	51121	22	applied	\N	\N	\N	\N	225871	225871	392863
30062	51122	23	applied	\N	\N	\N	\N	225872	225872	392864
30062	51123	24	applied	\N	\N	\N	\N	225873	225873	392865
30062	51124	25	applied	\N	\N	\N	\N	225874	225874	392866
30062	51125	26	applied	\N	\N	\N	\N	225875	225875	392867
30062	51126	27	applied	\N	\N	\N	\N	225876	225876	392868
30062	51127	28	applied	\N	\N	\N	\N	225877	225877	392869
30062	51128	29	applied	\N	\N	\N	\N	225878	225878	392870
30062	51130	31	applied	\N	\N	\N	\N	225880	225880	392872
30072	51178	0	applied	\N	\N	\N	\N	225964	225964	392955
30072	51179	1	applied	\N	\N	\N	\N	225965	225965	392956
30072	51180	2	applied	\N	\N	\N	\N	225966	225966	392957
30072	51181	3	applied	\N	\N	\N	\N	225967	225967	392958
30072	51182	4	applied	\N	\N	\N	\N	225968	225968	392959
30072	51183	5	applied	\N	\N	\N	\N	225969	225969	392960
30072	51184	6	applied	\N	\N	\N	\N	225970	225970	392961
30072	51185	7	applied	\N	\N	\N	\N	225971	225971	392962
30075	51197	0	applied	\N	\N	\N	\N	226002	226002	392993
30075	51198	1	applied	\N	\N	\N	\N	226003	226003	392994
30075	51199	2	applied	\N	\N	\N	\N	226004	226004	392995
30075	51200	3	applied	\N	\N	\N	\N	226005	226005	392996
30075	51201	4	applied	\N	\N	\N	\N	226006	226006	392997
30075	51202	5	applied	\N	\N	\N	\N	226007	226007	392998
30075	51203	6	applied	\N	\N	\N	\N	226008	226008	392999
30040	50970	18	applied	\N	\N	\N	\N	225511	225511	392506
30065	51140	1	applied	\N	\N	\N	\N	225898	225898	392890
30065	51141	2	applied	\N	\N	\N	\N	225899	225899	392891
30065	51142	3	applied	\N	\N	\N	\N	225900	225900	392892
30065	51143	4	applied	\N	\N	\N	\N	225901	225901	392893
30065	51144	5	applied	\N	\N	\N	\N	225902	225902	392894
30065	51145	6	applied	\N	\N	\N	\N	225903	225903	392895
30065	51146	7	applied	\N	\N	\N	\N	225904	225904	392896
30065	51147	8	applied	\N	\N	\N	\N	225905	225905	392897
30067	51159	0	applied	\N	\N	\N	\N	225917	225917	392908
30067	51160	1	applied	\N	\N	\N	\N	225918	225918	392909
30067	51161	2	applied	\N	\N	\N	\N	225919	225919	392910
30067	51162	3	applied	\N	\N	\N	\N	225920	225920	392911
30067	51163	4	applied	\N	\N	\N	\N	225921	225921	392912
30067	51164	5	applied	\N	\N	\N	\N	225922	225922	392913
30067	51166	7	applied	\N	\N	\N	\N	225924	225924	392915
30069	51167	0	applied	\N	\N	\N	\N	225931	225931	392922
30069	51168	1	applied	\N	\N	\N	\N	225932	225932	392923
30075	51204	7	applied	\N	\N	\N	\N	226009	226009	393000
30075	51205	8	applied	\N	\N	\N	\N	226010	226010	393001
30075	51206	9	applied	\N	\N	\N	\N	226011	226011	393002
30075	51207	10	applied	\N	\N	\N	\N	226012	226012	393003
30075	51208	11	applied	\N	\N	\N	\N	226013	226013	393004
30075	51209	12	applied	\N	\N	\N	\N	226014	226014	393005
30075	51210	13	applied	\N	\N	\N	\N	226015	226015	393006
30075	51211	14	applied	\N	\N	\N	\N	226016	226016	393007
30075	51212	15	applied	\N	\N	\N	\N	226017	226017	393008
30075	51213	16	applied	\N	\N	\N	\N	226018	226018	393009
30075	51214	17	applied	\N	\N	\N	\N	226019	226019	393010
30075	51215	18	applied	\N	\N	\N	\N	226020	226020	393011
30079	51225	0	applied	\N	\N	\N	\N	226045	226045	393036
30079	51227	2	applied	\N	\N	\N	\N	226047	226047	393038
30079	51228	3	applied	\N	\N	\N	\N	226048	226048	393039
30079	51229	4	applied	\N	\N	\N	\N	226049	226049	393040
30079	51230	5	applied	\N	\N	\N	\N	226050	226050	393041
30079	51231	6	applied	\N	\N	\N	\N	226051	226051	393042
30079	51232	7	applied	\N	\N	\N	\N	226052	226052	393043
30079	51233	8	applied	\N	\N	\N	\N	226053	226053	393044
30079	51234	9	applied	\N	\N	\N	\N	226054	226054	393045
30079	51235	10	applied	\N	\N	\N	\N	226055	226055	393046
30084	51236	0	applied	\N	\N	\N	\N	226092	226092	393083
30084	51237	1	applied	\N	\N	\N	\N	226093	226093	393084
30084	51238	2	applied	\N	\N	\N	\N	226094	226094	393085
30084	51239	4	applied	\N	\N	\N	\N	226095	226095	393086
30084	51240	5	applied	\N	\N	\N	\N	226096	226096	393087
30084	51242	6	applied	\N	\N	\N	\N	226097	226097	393088
30084	51244	7	applied	\N	\N	\N	\N	226098	226098	393089
30085	51246	1	applied	\N	\N	\N	\N	226100	226100	393091
30085	51247	2	applied	\N	\N	\N	\N	226101	226101	393092
30085	51248	3	applied	\N	\N	\N	\N	226102	226102	393093
30085	51249	4	applied	\N	\N	\N	\N	226103	226103	393094
30085	51250	5	applied	\N	\N	\N	\N	226104	226104	393095
30085	51251	6	applied	\N	\N	\N	\N	226105	226105	393096
30085	51252	7	applied	\N	\N	\N	\N	226106	226106	393097
30085	51253	8	applied	\N	\N	\N	\N	226107	226107	393098
30096	51300	0	applied	\N	\N	\N	\N	226212	226212	393203
30096	51301	1	applied	\N	\N	\N	\N	226213	226213	393204
30096	51302	2	applied	\N	\N	\N	\N	226214	226214	393205
30096	51303	3	applied	\N	\N	\N	\N	226215	226215	393206
30096	51304	4	applied	\N	\N	\N	\N	226216	226216	393207
30096	51305	5	applied	\N	\N	\N	\N	226217	226217	393208
30096	51306	6	applied	\N	\N	\N	\N	226218	226218	393209
30096	51307	7	applied	\N	\N	\N	\N	226219	226219	393210
30106	51337	0	applied	\N	\N	\N	\N	226413	226413	393403
30106	51338	1	applied	\N	\N	\N	\N	226414	226414	393404
30106	51339	2	applied	\N	\N	\N	\N	226415	226415	393405
30108	51337	0	applied	\N	\N	\N	\N	226438	226438	393428
30108	51338	1	applied	\N	\N	\N	\N	226439	226439	393429
30108	51339	2	applied	\N	\N	\N	\N	226440	226440	393430
30108	51340	3	applied	\N	\N	\N	\N	226441	226441	393431
30108	51329	4	applied	\N	\N	\N	\N	226442	226442	393432
30108	51341	5	applied	\N	\N	\N	\N	226443	226443	393433
30108	51342	6	applied	\N	\N	\N	\N	226444	226444	393434
30108	51343	7	applied	\N	\N	\N	\N	226445	226445	393435
30108	51331	8	applied	\N	\N	\N	\N	226446	226446	393436
30108	51332	9	applied	\N	\N	\N	\N	226447	226447	393437
30108	51333	10	applied	\N	\N	\N	\N	226448	226448	393438
30108	51344	11	applied	\N	\N	\N	\N	226449	226449	393439
30108	51345	12	applied	\N	\N	\N	\N	226450	226450	393440
30108	51347	14	applied	\N	\N	\N	\N	226452	226452	393442
30108	51348	15	applied	\N	\N	\N	\N	226453	226453	393443
30108	51349	17	applied	\N	\N	\N	\N	226454	226454	393444
30108	51350	18	applied	\N	\N	\N	\N	226455	226455	393445
30108	51351	19	applied	\N	\N	\N	\N	226456	226456	393446
30108	51334	20	applied	\N	\N	\N	\N	226457	226457	393447
30108	51335	21	applied	\N	\N	\N	\N	226458	226458	393448
30108	51336	22	applied	\N	\N	\N	\N	226459	226459	393449
30108	51352	23	applied	\N	\N	\N	\N	226460	226460	393450
30108	51353	24	applied	\N	\N	\N	\N	226461	226461	393451
30108	51354	25	applied	\N	\N	\N	\N	226462	226462	393452
30108	51355	26	applied	\N	\N	\N	\N	226463	226463	393453
30108	51356	27	applied	\N	\N	\N	\N	226464	226464	393454
30108	51357	28	applied	\N	\N	\N	\N	226465	226465	393455
30108	51358	29	applied	\N	\N	\N	\N	226466	226466	393456
30108	51359	30	applied	\N	\N	\N	\N	226467	226467	393457
30108	51361	32	applied	\N	\N	\N	\N	226469	226469	393459
30108	51362	33	applied	\N	\N	\N	\N	226470	226470	393460
30108	51363	34	applied	\N	\N	\N	\N	226471	226471	393461
30108	51364	35	applied	\N	\N	\N	\N	226472	226472	393462
30111	51365	0	applied	\N	\N	1000000000	\N	226577	226577	393567
30111	51366	1	applied	\N	\N	\N	\N	226578	226578	393568
30111	51367	2	applied	\N	\N	\N	\N	226579	226579	393569
30111	51340	3	applied	\N	\N	\N	\N	226580	226580	393570
30111	51329	4	applied	\N	\N	\N	\N	226581	226581	393571
30111	51341	5	applied	\N	\N	\N	\N	226582	226582	393572
30111	51342	6	applied	\N	\N	\N	\N	226583	226583	393573
30111	51343	7	applied	\N	\N	\N	\N	226584	226584	393574
30111	51368	8	applied	\N	\N	\N	\N	226585	226585	393575
30111	51331	9	applied	\N	\N	\N	\N	226586	226586	393576
30111	51332	10	applied	\N	\N	\N	\N	226587	226587	393577
30111	51333	12	applied	\N	\N	\N	\N	226588	226588	393578
30065	51139	0	applied	\N	\N	\N	\N	225897	225897	392889
30064	51135	4	applied	\N	\N	\N	\N	225893	225893	392885
30064	51136	5	applied	\N	\N	\N	\N	225894	225894	392886
30064	51137	7	applied	\N	\N	\N	\N	225895	225895	392887
30064	51138	8	applied	\N	\N	\N	\N	225896	225896	392888
30066	51148	0	applied	\N	\N	\N	\N	225906	225906	392898
30066	51149	1	applied	\N	\N	\N	\N	225907	225907	225907
30066	51150	2	applied	\N	\N	\N	\N	225908	225908	392899
30066	51151	3	applied	\N	\N	\N	\N	225909	225909	392900
30066	51152	4	applied	\N	\N	\N	\N	225910	225910	392901
30066	51153	5	applied	\N	\N	\N	\N	225911	225911	392902
30066	51154	6	applied	\N	\N	\N	\N	225912	225912	392903
30066	51155	7	applied	\N	\N	\N	\N	225913	225913	392904
30066	51156	8	applied	\N	\N	\N	\N	225914	225914	392905
30066	51157	9	applied	\N	\N	\N	\N	225915	225915	392906
30066	51158	10	applied	\N	\N	\N	\N	225916	225916	392907
30069	51169	2	applied	\N	\N	\N	\N	225933	225933	392924
30069	51173	4	applied	\N	\N	\N	\N	225935	225935	392926
30069	51174	5	applied	\N	\N	\N	\N	225936	225936	392927
30069	51175	6	applied	\N	\N	\N	\N	225937	225937	392928
30069	51176	7	applied	\N	\N	\N	\N	225938	225938	392929
30069	51177	8	applied	\N	\N	\N	\N	225939	225939	392930
30069	51171	9	applied	\N	\N	\N	\N	225940	225940	392931
30069	51172	10	applied	\N	\N	\N	\N	225941	225941	392932
30071	51167	0	applied	\N	\N	\N	\N	225953	225953	392944
30071	51168	1	applied	\N	\N	\N	\N	225954	225954	392945
30071	51169	2	applied	\N	\N	\N	\N	225955	225955	392946
30073	51186	0	applied	\N	\N	\N	\N	225972	225972	392963
30073	51187	1	applied	\N	\N	\N	\N	225973	225973	392964
30073	51188	2	applied	\N	\N	\N	\N	225974	225974	392965
30073	51189	3	applied	\N	\N	\N	\N	225975	225975	392966
30073	51190	4	applied	\N	\N	\N	\N	225976	225976	392967
30073	51191	5	applied	\N	\N	\N	\N	225977	225977	392968
30073	51193	7	applied	\N	\N	\N	\N	225979	225979	392970
30073	51194	8	applied	\N	\N	\N	\N	225980	225980	392971
30073	51195	9	applied	\N	\N	\N	\N	225981	225981	392972
30073	51196	10	applied	\N	\N	\N	\N	225982	225982	392973
30077	51216	0	applied	\N	\N	\N	\N	226026	226026	393017
30077	51217	1	applied	\N	\N	\N	\N	226027	226027	393018
30077	51218	2	applied	\N	\N	\N	\N	226028	226028	393019
30077	51219	3	applied	\N	\N	\N	\N	226029	226029	393020
30077	51220	4	applied	\N	\N	\N	\N	226030	226030	393021
30077	51221	5	applied	\N	\N	\N	\N	226031	226031	393022
30077	51222	6	applied	\N	\N	\N	\N	226032	226032	393023
30077	51223	7	applied	\N	\N	\N	\N	226033	226033	393024
30077	51224	8	applied	\N	\N	\N	\N	226034	226034	393025
30082	51236	0	applied	\N	\N	\N	\N	226074	226074	393065
30082	51237	1	applied	\N	\N	\N	\N	226075	226075	393066
30082	51238	2	applied	\N	\N	\N	\N	226076	226076	393067
30082	51240	5	applied	\N	\N	\N	\N	226078	226078	393069
30082	51241	6	applied	\N	\N	\N	\N	226079	226079	393070
30082	51242	7	applied	\N	\N	\N	\N	226080	226080	393071
30082	51243	8	applied	\N	\N	\N	\N	226081	226081	393072
30082	51244	9	applied	\N	\N	\N	\N	226082	226082	393073
30086	51254	0	applied	\N	\N	\N	\N	226108	226108	393099
30086	51255	1	applied	\N	\N	\N	\N	226109	226109	393100
30086	51256	2	applied	\N	\N	\N	\N	226110	226110	393101
30086	51257	3	applied	\N	\N	\N	\N	226111	226111	393102
30086	51258	4	applied	\N	\N	\N	\N	226112	226112	393103
30086	51259	5	applied	\N	\N	\N	\N	226113	226113	393104
30086	51260	6	applied	\N	\N	\N	\N	226114	226114	393105
30086	51261	7	applied	\N	\N	\N	\N	226115	226115	393106
30086	51262	8	applied	\N	\N	\N	\N	226116	226116	393107
30086	51263	9	applied	\N	\N	\N	\N	226117	226117	393108
30086	51264	10	applied	\N	\N	\N	\N	226118	226118	393109
30086	51266	12	applied	\N	\N	\N	\N	226120	226120	393111
30086	51267	13	applied	\N	\N	\N	\N	226121	226121	393112
30086	51268	14	applied	\N	\N	\N	\N	226122	226122	393113
30086	51269	15	applied	\N	\N	\N	\N	226123	226123	393114
30086	51270	16	applied	\N	\N	\N	\N	226124	226124	393115
30086	51271	17	applied	\N	\N	\N	\N	226125	226125	393116
30086	51272	18	applied	\N	\N	\N	\N	226126	226126	393117
30086	51273	19	applied	\N	\N	\N	\N	226127	226127	393118
30086	51274	20	applied	\N	\N	\N	\N	226128	226128	393119
30086	51275	21	applied	\N	\N	\N	\N	226129	226129	393120
30086	51276	22	applied	\N	\N	\N	\N	226130	226130	393121
30086	51277	23	applied	\N	\N	\N	\N	226131	226131	393122
30086	51278	24	applied	\N	\N	\N	\N	226132	226132	393123
30086	51279	25	applied	\N	\N	\N	\N	226133	226133	393124
30086	51280	26	applied	\N	\N	\N	\N	226134	226134	393125
30086	51281	27	applied	\N	\N	\N	\N	226135	226135	393126
30088	51283	1	applied	\N	\N	\N	\N	226146	226146	393137
30088	51284	2	applied	\N	\N	\N	\N	226147	226147	393138
30088	51285	3	applied	\N	\N	\N	\N	226148	226148	393139
30088	51286	4	applied	\N	\N	\N	\N	226149	226149	393140
30088	51287	5	applied	\N	\N	\N	\N	226150	226150	393141
30088	51288	6	applied	\N	\N	\N	\N	226151	226151	393142
30088	51289	7	applied	\N	\N	\N	\N	226152	226152	393143
30088	51290	8	applied	\N	\N	\N	\N	226153	226153	393144
30090	51282	0	applied	\N	\N	\N	\N	226159	226159	393150
30090	51283	1	applied	\N	\N	\N	\N	226160	226160	393151
30090	51284	2	applied	\N	\N	\N	\N	226161	226161	393152
30090	51285	3	applied	\N	\N	\N	\N	226162	226162	393153
30090	51286	4	applied	\N	\N	\N	\N	226163	226163	393154
30090	51287	5	applied	\N	\N	\N	\N	226164	226164	393155
30090	51288	6	applied	\N	\N	\N	\N	226165	226165	393156
30090	51289	7	applied	\N	\N	\N	\N	226166	226166	393157
30092	51291	0	applied	\N	\N	\N	\N	226177	226177	393168
30092	51292	1	applied	\N	\N	\N	\N	226178	226178	393169
30092	51293	2	applied	\N	\N	\N	\N	226179	226179	393170
30092	51294	3	applied	\N	\N	\N	\N	226180	226180	393171
30092	51295	4	applied	\N	\N	\N	\N	226181	226181	393172
30092	51296	5	applied	\N	\N	\N	\N	226182	226182	393173
30092	51297	6	applied	\N	\N	\N	\N	226183	226183	393174
30092	51298	7	applied	\N	\N	\N	\N	226184	226184	393175
30092	51299	8	applied	\N	\N	\N	\N	226185	226185	393176
30095	51300	0	applied	\N	\N	\N	\N	226203	226203	393194
30095	51301	1	applied	\N	\N	\N	\N	226204	226204	393195
30095	51302	2	applied	\N	\N	\N	\N	226205	226205	393196
30095	51303	3	applied	\N	\N	\N	\N	226206	226206	393197
30095	51304	4	applied	\N	\N	\N	\N	226207	226207	393198
30064	51132	1	applied	\N	\N	\N	\N	225890	225890	392882
30064	51133	2	applied	\N	\N	\N	\N	225891	225891	392883
30071	51176	7	applied	\N	\N	\N	\N	225960	225960	392951
30071	51177	8	applied	\N	\N	\N	\N	225961	225961	392952
30071	51171	9	applied	\N	\N	\N	\N	225962	225962	392953
30071	51172	10	applied	\N	\N	\N	\N	225963	225963	392954
30074	51197	0	applied	\N	\N	\N	\N	225983	225983	392974
30074	51198	1	applied	\N	\N	\N	\N	225984	225984	392975
30074	51199	2	applied	\N	\N	\N	\N	225985	225985	392976
30074	51200	3	applied	\N	\N	\N	\N	225986	225986	392977
30074	51201	4	applied	\N	\N	\N	\N	225987	225987	392978
30074	51202	5	applied	\N	\N	\N	\N	225988	225988	392979
30074	51203	6	applied	\N	\N	\N	\N	225989	225989	392980
30074	51204	7	applied	\N	\N	\N	\N	225990	225990	392981
30074	51205	8	applied	\N	\N	\N	\N	225991	225991	392982
30074	51206	9	applied	\N	\N	\N	\N	225992	225992	392983
30074	51208	11	applied	\N	\N	\N	\N	225994	225994	392985
30074	51209	12	applied	\N	\N	\N	\N	225995	225995	392986
30074	51210	13	applied	\N	\N	\N	\N	225996	225996	392987
30074	51211	14	applied	\N	\N	\N	\N	225997	225997	392988
30074	51212	15	applied	\N	\N	\N	\N	225998	225998	392989
30074	51213	16	applied	\N	\N	\N	\N	225999	225999	392990
30074	51214	17	applied	\N	\N	\N	\N	226000	226000	392991
30074	51215	18	applied	\N	\N	\N	\N	226001	226001	392992
30076	51198	1	applied	\N	\N	\N	\N	226022	226022	393013
30076	51213	2	applied	\N	\N	\N	\N	226023	226023	393014
30076	51214	3	applied	\N	\N	\N	\N	226024	226024	393015
30076	51215	4	applied	\N	\N	\N	\N	226025	226025	393016
30078	51225	0	applied	\N	\N	\N	\N	226035	226035	393026
30078	51226	1	applied	\N	\N	\N	\N	226036	226036	393027
30078	51227	2	applied	\N	\N	\N	\N	226037	226037	393028
30078	51228	3	applied	\N	\N	\N	\N	226038	226038	393029
30078	51230	5	applied	\N	\N	\N	\N	226040	226040	393031
30078	51231	6	applied	\N	\N	\N	\N	226041	226041	393032
30078	51232	7	applied	\N	\N	\N	\N	226042	226042	393033
30078	51233	8	applied	\N	\N	\N	\N	226043	226043	393034
30078	51234	9	applied	\N	\N	\N	\N	226044	226044	393035
30080	51236	0	applied	\N	\N	\N	\N	226056	226056	393047
30080	51237	1	applied	\N	\N	\N	\N	226057	226057	393048
30080	51238	2	applied	\N	\N	\N	\N	226058	226058	393049
30080	51239	4	applied	\N	\N	\N	\N	226059	226059	393050
30080	51240	5	applied	\N	\N	\N	\N	226060	226060	393051
30080	51241	6	applied	\N	\N	\N	\N	226061	226061	393052
30080	51242	7	applied	\N	\N	\N	\N	226062	226062	393053
30080	51243	8	applied	\N	\N	\N	\N	226063	226063	393054
30083	51236	0	applied	\N	\N	\N	\N	226083	226083	393074
30083	51237	1	applied	\N	\N	\N	\N	226084	226084	393075
30083	51238	2	applied	\N	\N	\N	\N	226085	226085	393076
30083	51240	5	applied	\N	\N	\N	\N	226087	226087	393078
30083	51241	6	applied	\N	\N	\N	\N	226088	226088	393079
30083	51242	7	applied	\N	\N	\N	\N	226089	226089	393080
30083	51243	8	applied	\N	\N	\N	\N	226090	226090	393081
30083	51244	9	applied	\N	\N	\N	\N	226091	226091	393082
30087	51282	0	applied	\N	\N	\N	\N	226136	226136	393127
30087	51283	1	applied	\N	\N	\N	\N	226137	226137	393128
30087	51284	2	applied	\N	\N	\N	\N	226138	226138	393129
30087	51285	3	applied	\N	\N	\N	\N	226139	226139	393130
30087	51286	4	applied	\N	\N	\N	\N	226140	226140	393131
30087	51287	5	applied	\N	\N	\N	\N	226141	226141	393132
30087	51288	6	applied	\N	\N	\N	\N	226142	226142	393133
30087	51289	7	applied	\N	\N	\N	\N	226143	226143	393134
30087	51290	8	applied	\N	\N	\N	\N	226144	226144	393135
30091	51282	0	applied	\N	\N	\N	\N	226168	226168	393159
30091	51283	1	applied	\N	\N	\N	\N	226169	226169	393160
30091	51285	3	applied	\N	\N	\N	\N	226171	226171	393162
30091	51286	4	applied	\N	\N	\N	\N	226172	226172	393163
30091	51287	5	applied	\N	\N	\N	\N	226173	226173	393164
30091	51288	6	applied	\N	\N	\N	\N	226174	226174	393165
30091	51289	7	applied	\N	\N	\N	\N	226175	226175	393166
30091	51290	8	applied	\N	\N	\N	\N	226176	226176	393167
30094	51291	0	applied	\N	\N	\N	\N	226194	226194	393185
30094	51292	1	applied	\N	\N	\N	\N	226195	226195	393186
30094	51293	2	applied	\N	\N	\N	\N	226196	226196	393187
30094	51294	3	applied	\N	\N	\N	\N	226197	226197	393188
30094	51295	4	applied	\N	\N	\N	\N	226198	226198	393189
30094	51296	5	applied	\N	\N	\N	\N	226199	226199	393190
30094	51297	6	applied	\N	\N	\N	\N	226200	226200	393191
30094	51298	7	applied	\N	\N	\N	\N	226201	226201	393192
30094	51299	8	applied	\N	\N	\N	\N	226202	226202	393193
30098	51309	0	applied	\N	\N	\N	\N	226223	226223	393214
30098	51302	2	applied	\N	\N	\N	\N	226225	226225	393216
30098	51303	3	applied	\N	\N	\N	\N	226226	226226	393217
30098	51304	4	applied	\N	\N	\N	\N	226227	226227	393218
30098	51305	5	applied	\N	\N	\N	\N	226228	226228	393219
30098	51311	6	applied	\N	\N	\N	\N	226229	226229	393220
30098	51312	7	applied	\N	\N	\N	\N	226230	226230	393221
30098	51313	8	applied	\N	\N	\N	\N	226231	226231	393222
30098	51306	9	applied	\N	\N	\N	\N	226232	226232	393223
30098	51314	10	applied	\N	\N	\N	\N	226233	226233	393224
30098	51315	11	applied	\N	\N	\N	\N	226234	226234	393225
30098	51316	12	applied	\N	\N	\N	\N	226235	226235	393226
30098	51317	13	applied	\N	\N	\N	\N	226236	226236	393227
30098	51318	14	applied	\N	\N	\N	\N	226237	226237	393228
30098	51319	15	applied	\N	\N	\N	\N	226238	226238	393229
30098	51307	16	applied	\N	\N	\N	\N	226239	226239	393230
30098	51308	17	applied	\N	\N	\N	\N	226240	226240	393231
30098	51321	19	applied	\N	\N	\N	\N	226242	226242	393233
30098	51322	20	applied	\N	\N	\N	\N	226243	226243	393234
30098	51323	21	applied	\N	\N	\N	\N	226244	226244	393235
30098	51324	22	applied	\N	\N	\N	\N	226245	226245	393236
30098	51325	23	applied	\N	\N	\N	\N	226246	226246	393237
30098	51326	24	applied	\N	\N	\N	\N	226247	226247	393238
30098	51327	25	applied	\N	\N	\N	\N	226248	226248	393239
30101	51328	0	applied	\N	\N	\N	\N	226380	226380	393370
30101	51330	1	applied	\N	\N	\N	\N	226381	226381	393371
30115	51365	0	applied	\N	\N	1000000000	\N	226737	226737	393727
30115	51366	1	applied	\N	\N	\N	\N	226738	226738	393728
30115	51367	2	applied	\N	\N	\N	\N	226739	226739	393729
30115	51340	3	applied	\N	\N	\N	\N	226740	226740	393730
30115	51329	4	applied	\N	\N	\N	\N	226741	226741	393731
30115	51341	5	applied	\N	\N	\N	\N	226742	226742	393732
30115	51342	6	applied	\N	\N	\N	\N	226743	226743	393733
30071	51175	6	applied	\N	\N	\N	\N	225959	225959	392950
30081	51238	2	applied	\N	\N	\N	\N	226067	226067	393058
30081	51239	4	applied	\N	\N	\N	\N	226068	226068	393059
30081	51240	5	applied	\N	\N	\N	\N	226069	226069	393060
30081	51241	6	applied	\N	\N	\N	\N	226070	226070	393061
30081	51242	7	applied	\N	\N	\N	\N	226071	226071	393062
30081	51243	8	applied	\N	\N	\N	\N	226072	226072	393063
30081	51244	9	applied	\N	\N	\N	\N	226073	226073	393064
30089	51282	0	applied	\N	\N	\N	\N	226154	226154	393145
30089	51283	1	applied	\N	\N	\N	\N	226155	226155	393146
30089	51284	2	applied	\N	\N	\N	\N	226156	226156	393147
30089	51285	3	applied	\N	\N	\N	\N	226157	226157	393148
30089	51286	4	applied	\N	\N	\N	\N	226158	226158	393149
30093	51291	0	applied	\N	\N	\N	\N	226186	226186	393177
30093	51293	2	applied	\N	\N	\N	\N	226188	226188	393179
30093	51294	3	applied	\N	\N	\N	\N	226189	226189	393180
30093	51295	4	applied	\N	\N	\N	\N	226190	226190	393181
30093	51296	5	applied	\N	\N	\N	\N	226191	226191	393182
30093	51297	6	applied	\N	\N	\N	\N	226192	226192	393183
30093	51298	7	applied	\N	\N	\N	\N	226193	226193	393184
30095	51305	5	applied	\N	\N	\N	\N	226208	226208	393199
30095	51306	6	applied	\N	\N	\N	\N	226209	226209	393200
30095	51307	7	applied	\N	\N	\N	\N	226210	226210	393201
30095	51308	8	applied	\N	\N	\N	\N	226211	226211	393202
30097	51300	0	applied	\N	\N	\N	\N	226221	226221	393212
30097	51301	1	applied	\N	\N	\N	\N	226222	226222	393213
30099	51186	0	applied	\N	\N	\N	\N	226249	226249	393240
30099	51187	1	applied	\N	\N	\N	\N	226250	226250	393241
30099	50952	2	applied	\N	\N	\N	\N	226251	226251	393242
30099	50725	3	applied	\N	\N	\N	\N	226252	226252	393243
30099	50743	5	applied	\N	\N	\N	\N	226254	226254	393245
30099	50744	6	applied	\N	\N	\N	\N	226255	226255	393246
30099	50763	7	applied	\N	\N	\N	\N	226256	226256	393247
30099	50773	8	applied	\N	\N	\N	\N	226257	226257	393248
30099	50782	9	applied	\N	\N	\N	\N	226258	226258	393249
30099	50783	10	applied	\N	\N	\N	\N	226259	226259	393250
30099	50784	11	applied	\N	\N	\N	\N	226260	226260	393251
30099	50811	12	applied	\N	\N	\N	\N	226261	226261	393252
30099	50820	13	applied	\N	\N	\N	\N	226262	226262	393253
30099	50829	14	applied	\N	\N	\N	\N	226263	226263	393254
30099	50838	15	applied	\N	\N	\N	\N	226264	226264	393255
30100	51328	0	applied	\N	\N	\N	\N	226371	226371	393361
30100	51329	1	applied	\N	\N	\N	\N	226372	226372	393362
30100	51330	2	applied	\N	\N	\N	\N	226373	226373	393363
30100	51331	3	applied	\N	\N	\N	\N	226374	226374	393364
30100	51332	4	applied	\N	\N	\N	\N	226375	226375	393365
30100	51334	6	applied	\N	\N	\N	\N	226377	226377	393367
30100	51335	7	applied	\N	\N	\N	\N	226378	226378	393368
30100	51336	8	applied	\N	\N	\N	\N	226379	226379	393369
30103	51328	0	applied	\N	\N	\N	\N	226391	226391	393381
30103	51329	1	applied	\N	\N	\N	\N	226392	226392	393382
30103	51330	2	applied	\N	\N	\N	\N	226393	226393	393383
30103	51331	3	applied	\N	\N	\N	\N	226394	226394	393384
30103	51332	4	applied	\N	\N	\N	\N	226395	226395	393385
30103	51334	5	applied	\N	\N	\N	\N	226396	226396	393386
30103	51335	6	applied	\N	\N	\N	\N	226397	226397	393387
30103	51336	7	applied	\N	\N	\N	\N	226398	226398	393388
30109	51365	0	applied	\N	\N	1000000000	\N	226473	226473	393463
30109	51366	1	applied	\N	\N	\N	\N	226474	226474	393464
30109	51367	2	applied	\N	\N	\N	\N	226475	226475	393465
30109	51340	3	applied	\N	\N	\N	\N	226476	226476	393466
30109	51329	4	applied	\N	\N	\N	\N	226477	226477	393467
30109	51342	6	applied	\N	\N	\N	\N	226479	226479	393469
30109	51343	7	applied	\N	\N	\N	\N	226480	226480	393470
30109	51368	8	applied	\N	\N	\N	\N	226481	226481	393471
30109	51331	9	applied	\N	\N	\N	\N	226482	226482	393472
30109	51332	10	applied	\N	\N	\N	\N	226483	226483	393473
30109	51333	12	applied	\N	\N	\N	\N	226484	226484	393474
30109	51369	13	applied	\N	\N	\N	\N	226485	226485	393475
30109	51344	14	applied	\N	\N	\N	\N	226486	226486	393476
30109	51345	15	applied	\N	\N	\N	\N	226487	226487	393477
30109	51346	16	applied	\N	\N	\N	\N	226488	226488	393478
30109	51347	17	applied	\N	\N	\N	\N	226489	226489	393479
30109	51348	18	applied	\N	\N	\N	\N	226490	226490	393480
30109	51349	19	applied	\N	\N	\N	\N	226491	226491	393481
30109	51350	20	applied	\N	\N	\N	\N	226492	226492	393482
30109	51351	21	applied	\N	\N	\N	\N	226493	226493	393483
30109	51370	22	applied	\N	\N	\N	\N	226494	226494	393484
30109	51335	24	applied	\N	\N	\N	\N	226496	226496	393486
30109	51336	25	applied	\N	\N	\N	\N	226497	226497	393487
30109	51371	26	applied	\N	\N	\N	\N	226498	226498	393488
30109	51352	27	applied	\N	\N	\N	\N	226499	226499	393489
30109	51353	28	applied	\N	\N	\N	\N	226500	226500	393490
30109	51354	29	applied	\N	\N	\N	\N	226501	226501	393491
30109	51355	30	applied	\N	\N	\N	\N	226502	226502	393492
30109	51356	31	applied	\N	\N	\N	\N	226503	226503	393493
30109	51357	32	applied	\N	\N	\N	\N	226504	226504	393494
30109	51358	33	applied	\N	\N	\N	\N	226505	226505	393495
30109	51359	34	applied	\N	\N	\N	\N	226506	226506	393496
30109	51360	35	applied	\N	\N	\N	\N	226507	226507	393497
30109	51361	36	applied	\N	\N	\N	\N	226508	226508	393498
30109	51362	37	applied	\N	\N	\N	\N	226509	226509	393499
30109	51363	38	applied	\N	\N	\N	\N	226510	226510	393500
30109	51364	39	applied	\N	\N	\N	\N	226511	226511	393501
30109	51373	41	applied	\N	\N	\N	\N	226513	226513	393503
30109	51374	42	applied	\N	\N	\N	\N	226514	226514	393504
30109	51375	43	applied	\N	\N	\N	\N	226515	226515	393505
30109	51376	44	applied	\N	\N	\N	\N	226516	226516	393506
30109	51377	45	applied	\N	\N	\N	\N	226517	226517	393507
30109	51378	46	applied	\N	\N	\N	\N	226518	226518	393508
30109	51379	47	applied	\N	\N	\N	\N	226519	226519	393509
30109	51380	48	applied	\N	\N	\N	\N	226520	226520	393510
30109	51381	49	applied	\N	\N	\N	\N	226521	226521	393511
30109	51382	50	applied	\N	\N	\N	\N	226522	226522	393512
30109	51383	51	applied	\N	\N	\N	\N	226523	226523	393513
30109	51384	52	applied	\N	\N	\N	\N	226524	226524	393514
30113	51365	0	applied	\N	\N	1000000000	\N	226659	226659	393649
30113	51366	1	applied	\N	\N	\N	\N	226660	226660	393650
30113	51367	2	applied	\N	\N	\N	\N	226661	226661	393651
30113	51340	3	applied	\N	\N	\N	\N	226662	226662	393652
30081	51236	0	applied	\N	\N	\N	\N	226065	226065	393056
30081	51237	1	applied	\N	\N	\N	\N	226066	226066	393057
30099	50876	19	applied	\N	\N	\N	\N	226268	226268	393259
30099	50881	20	applied	\N	\N	\N	\N	226269	226269	393260
30099	50894	21	applied	\N	\N	\N	\N	226270	226270	393261
30099	50895	22	applied	\N	\N	\N	\N	226271	226271	393262
30099	50913	23	applied	\N	\N	\N	\N	226272	226272	393263
30099	50914	24	applied	\N	\N	\N	\N	226273	226273	393264
30099	50931	25	applied	\N	\N	\N	\N	226274	226274	393265
30099	50942	26	applied	\N	\N	\N	\N	226275	226275	393266
30099	50953	27	applied	\N	\N	\N	\N	226276	226276	393267
30099	50974	29	applied	\N	\N	\N	\N	226278	226278	393269
30099	50975	30	applied	\N	\N	\N	\N	226279	226279	393270
30099	50995	31	applied	\N	\N	\N	\N	226280	226280	393271
30099	50996	32	applied	\N	\N	\N	\N	226281	226281	393272
30099	51015	33	applied	\N	\N	\N	\N	226282	226282	393273
30099	51025	34	applied	\N	\N	\N	\N	226283	226283	393274
30099	51026	35	applied	\N	\N	\N	\N	226284	226284	393275
30099	51042	36	applied	\N	\N	\N	\N	226285	226285	393276
30099	51052	37	applied	\N	\N	\N	\N	226286	226286	393277
30099	51053	38	applied	\N	\N	\N	\N	226287	226287	393278
30099	51072	39	applied	\N	\N	\N	\N	226288	226288	393279
30099	51073	40	applied	\N	\N	\N	\N	226289	226289	393280
30099	51091	41	applied	\N	\N	\N	\N	226290	226290	393281
30099	51099	42	applied	\N	\N	\N	\N	226291	226291	393282
30099	51100	43	applied	\N	\N	\N	\N	226292	226292	393283
30099	51101	44	applied	\N	\N	\N	\N	226293	226293	393284
30099	51139	46	applied	\N	\N	\N	\N	226295	226295	393286
30099	51148	47	applied	\N	\N	\N	\N	226296	226296	393287
30099	51159	48	applied	\N	\N	\N	\N	226297	226297	393288
30099	51167	49	applied	\N	\N	\N	\N	226298	226298	393289
30099	51178	50	applied	\N	\N	\N	\N	226299	226299	393290
30099	51188	51	applied	\N	\N	\N	\N	226300	226300	393291
30099	51197	52	applied	\N	\N	\N	\N	226301	226301	393292
30099	51198	53	applied	\N	\N	\N	\N	226302	226302	393293
30099	51216	54	applied	\N	\N	\N	\N	226303	226303	393294
30099	51225	55	applied	\N	\N	\N	\N	226304	226304	393295
30099	51236	56	applied	\N	\N	\N	\N	226305	226305	393296
30099	51245	57	applied	\N	\N	\N	\N	226306	226306	393297
30099	51254	58	applied	\N	\N	\N	\N	226307	226307	393298
30099	51255	59	applied	\N	\N	\N	\N	226308	226308	393299
30099	51256	60	applied	\N	\N	\N	\N	226309	226309	393300
30099	51282	61	applied	\N	\N	\N	\N	226310	226310	393301
30099	51300	63	applied	\N	\N	\N	\N	226312	226312	393303
30099	51309	64	applied	\N	\N	\N	\N	226313	226313	393304
30099	51149	65	applied	\N	\N	\N	\N	226314	226314	226314
30099	50997	66	applied	\N	\N	\N	\N	226315	226315	393305
30099	50945	67	applied	\N	\N	1000000000	\N	226316	226316	393306
30099	50946	68	applied	\N	\N	1000000000	\N	226317	226317	393307
30099	50726	69	applied	\N	\N	\N	\N	226318	226318	393308
30099	50727	70	applied	\N	\N	\N	\N	226319	226319	393309
30099	50728	71	applied	\N	\N	\N	\N	226320	226320	393310
30099	50736	72	applied	\N	\N	\N	\N	226321	226321	393311
30099	50737	73	applied	\N	\N	\N	\N	226322	226322	393312
30099	50729	74	applied	\N	\N	\N	\N	226323	226323	393313
30099	50730	75	applied	\N	\N	\N	\N	226324	226324	393314
30099	50735	76	applied	\N	\N	\N	\N	226325	226325	393315
30099	50746	77	applied	\N	\N	\N	\N	226326	226326	393316
30099	50747	78	applied	\N	\N	\N	\N	226327	226327	393317
30099	50980	80	applied	\N	\N	1000000000	\N	226329	226329	393319
30099	51102	81	applied	\N	\N	1000000000	\N	226330	226330	393320
30099	50748	82	applied	\N	\N	\N	\N	226331	226331	393321
30099	50765	83	applied	\N	\N	\N	\N	226332	226332	393322
30099	50774	84	applied	\N	\N	\N	\N	226333	226333	393323
30099	50775	85	applied	\N	\N	\N	\N	226334	226334	393324
30099	50785	86	applied	\N	\N	\N	\N	226335	226335	393325
30099	50800	87	applied	\N	\N	\N	\N	226336	226336	393326
30099	50801	88	applied	\N	\N	\N	\N	226337	226337	393327
30099	50802	89	applied	\N	\N	\N	\N	226338	226338	393328
30099	50814	90	applied	\N	\N	\N	\N	226339	226339	393329
30099	50815	91	applied	\N	\N	\N	\N	226340	226340	393330
30099	50824	92	applied	\N	\N	\N	\N	226341	226341	393331
30099	50832	93	applied	\N	\N	\N	\N	226342	226342	393332
30099	50841	94	applied	\N	\N	\N	\N	226343	226343	393333
30099	50843	95	applied	\N	\N	\N	\N	226344	226344	393334
30099	50845	98	applied	\N	\N	\N	\N	226346	226346	393336
30099	50846	99	applied	\N	\N	\N	\N	226347	226347	393337
30099	50875	100	applied	\N	\N	\N	\N	226348	226348	393338
30099	50878	101	applied	\N	\N	\N	\N	226349	226349	393339
30099	50879	102	applied	\N	\N	\N	\N	226350	226350	393340
30099	50893	103	applied	\N	\N	\N	\N	226351	226351	393341
30099	50896	104	applied	\N	\N	\N	\N	226352	226352	393342
30099	50906	105	applied	\N	\N	\N	\N	226353	226353	393343
30099	50907	106	applied	\N	\N	\N	\N	226354	226354	393344
30099	50916	107	applied	\N	\N	\N	\N	226355	226355	393345
30099	50920	108	applied	\N	\N	\N	\N	226356	226356	393346
30099	50921	109	applied	\N	\N	\N	\N	226357	226357	393347
30099	50938	110	applied	\N	\N	\N	\N	226358	226358	393348
30099	50941	111	applied	\N	\N	\N	\N	226359	226359	393349
30099	50944	112	applied	\N	\N	\N	\N	226360	226360	393350
30099	50959	113	applied	\N	\N	\N	\N	226361	226361	393351
30099	50973	115	applied	\N	\N	\N	\N	226363	226363	393353
30099	50977	116	applied	\N	\N	\N	\N	226364	226364	393354
30099	50993	117	applied	\N	\N	\N	\N	226365	226365	393355
30099	50994	118	applied	\N	\N	\N	\N	226366	226366	393356
30099	50998	119	applied	\N	\N	\N	\N	226367	226367	393357
30099	50999	120	applied	\N	\N	\N	\N	226368	226368	393358
30099	51000	121	applied	\N	\N	\N	\N	226369	226369	393359
30099	51016	122	applied	\N	\N	\N	\N	226370	226370	393360
30102	51328	0	applied	\N	\N	\N	\N	226382	226382	393372
30102	51329	1	applied	\N	\N	\N	\N	226383	226383	393373
30102	51330	2	applied	\N	\N	\N	\N	226384	226384	393374
30102	51331	3	applied	\N	\N	\N	\N	226385	226385	393375
30102	51332	4	applied	\N	\N	\N	\N	226386	226386	393376
30102	51333	5	applied	\N	\N	\N	\N	226387	226387	393377
30102	51334	6	applied	\N	\N	\N	\N	226388	226388	393378
30102	51335	7	applied	\N	\N	\N	\N	226389	226389	393379
30104	51328	0	applied	\N	\N	\N	\N	226399	226399	393389
30104	51329	1	applied	\N	\N	\N	\N	226400	226400	393390
30104	51330	2	applied	\N	\N	\N	\N	226401	226401	393391
30104	51331	3	applied	\N	\N	\N	\N	226402	226402	393392
30099	50840	17	applied	\N	\N	\N	\N	226266	226266	393257
30099	50868	18	applied	\N	\N	\N	\N	226267	226267	393258
30104	51336	8	applied	\N	\N	\N	\N	226407	226407	393397
30105	51328	0	applied	\N	\N	\N	\N	226408	226408	393398
30105	51329	1	applied	\N	\N	\N	\N	226409	226409	393399
30105	51330	2	applied	\N	\N	\N	\N	226410	226410	393400
30105	51332	3	applied	\N	\N	\N	\N	226411	226411	393401
30105	51333	4	applied	\N	\N	\N	\N	226412	226412	393402
30107	51337	0	applied	\N	\N	\N	\N	226416	226416	393406
30107	51338	1	applied	\N	\N	\N	\N	226417	226417	393407
30107	51339	2	applied	\N	\N	\N	\N	226418	226418	393408
30107	51340	3	applied	\N	\N	\N	\N	226419	226419	393409
30107	51329	4	applied	\N	\N	\N	\N	226420	226420	393410
30107	51341	5	applied	\N	\N	\N	\N	226421	226421	393411
30107	51343	7	applied	\N	\N	\N	\N	226423	226423	393413
30107	51331	8	applied	\N	\N	\N	\N	226424	226424	393414
30107	51332	9	applied	\N	\N	\N	\N	226425	226425	393415
30107	51333	10	applied	\N	\N	\N	\N	226426	226426	393416
30107	51344	11	applied	\N	\N	\N	\N	226427	226427	393417
30107	51345	12	applied	\N	\N	\N	\N	226428	226428	393418
30107	51346	13	applied	\N	\N	\N	\N	226429	226429	393419
30107	51347	14	applied	\N	\N	\N	\N	226430	226430	393420
30107	51348	15	applied	\N	\N	\N	\N	226431	226431	393421
30107	51349	17	applied	\N	\N	\N	\N	226432	226432	393422
30107	51350	18	applied	\N	\N	\N	\N	226433	226433	393423
30107	51351	19	applied	\N	\N	\N	\N	226434	226434	393424
30107	51334	20	applied	\N	\N	\N	\N	226435	226435	393425
30107	51335	21	applied	\N	\N	\N	\N	226436	226436	393426
30107	51336	22	applied	\N	\N	\N	\N	226437	226437	393427
30110	51366	1	applied	\N	\N	\N	\N	226526	226526	393516
30110	51367	2	applied	\N	\N	\N	\N	226527	226527	393517
30110	51340	3	applied	\N	\N	\N	\N	226528	226528	393518
30110	51329	4	applied	\N	\N	\N	\N	226529	226529	393519
30110	51341	5	applied	\N	\N	\N	\N	226530	226530	393520
30110	51342	6	applied	\N	\N	\N	\N	226531	226531	393521
30110	51343	7	applied	\N	\N	\N	\N	226532	226532	393522
30110	51368	8	applied	\N	\N	\N	\N	226533	226533	393523
30110	51331	9	applied	\N	\N	\N	\N	226534	226534	393524
30110	51332	10	applied	\N	\N	\N	\N	226535	226535	393525
30110	51333	12	applied	\N	\N	\N	\N	226536	226536	393526
30110	51369	13	applied	\N	\N	\N	\N	226537	226537	393527
30110	51344	14	applied	\N	\N	\N	\N	226538	226538	393528
30110	51345	15	applied	\N	\N	\N	\N	226539	226539	393529
30110	51346	16	applied	\N	\N	\N	\N	226540	226540	393530
30110	51347	17	applied	\N	\N	\N	\N	226541	226541	393531
30110	51348	18	applied	\N	\N	\N	\N	226542	226542	393532
30110	51349	19	applied	\N	\N	\N	\N	226543	226543	393533
30110	51350	20	applied	\N	\N	\N	\N	226544	226544	393534
30110	51370	22	applied	\N	\N	\N	\N	226546	226546	393536
30110	51334	23	applied	\N	\N	\N	\N	226547	226547	393537
30110	51335	24	applied	\N	\N	\N	\N	226548	226548	393538
30110	51336	25	applied	\N	\N	\N	\N	226549	226549	393539
30110	51371	26	applied	\N	\N	\N	\N	226550	226550	393540
30110	51352	27	applied	\N	\N	\N	\N	226551	226551	393541
30110	51353	28	applied	\N	\N	\N	\N	226552	226552	393542
30110	51354	29	applied	\N	\N	\N	\N	226553	226553	393543
30110	51355	30	applied	\N	\N	\N	\N	226554	226554	393544
30110	51356	31	applied	\N	\N	\N	\N	226555	226555	393545
30110	51357	32	applied	\N	\N	\N	\N	226556	226556	393546
30110	51358	33	applied	\N	\N	\N	\N	226557	226557	393547
30110	51359	34	applied	\N	\N	\N	\N	226558	226558	393548
30110	51360	35	applied	\N	\N	\N	\N	226559	226559	393549
30110	51361	36	applied	\N	\N	\N	\N	226560	226560	393550
30110	51362	37	applied	\N	\N	\N	\N	226561	226561	393551
30110	51364	39	applied	\N	\N	\N	\N	226563	226563	393553
30110	51372	40	applied	\N	\N	\N	\N	226564	226564	393554
30110	51373	41	applied	\N	\N	\N	\N	226565	226565	393555
30110	51374	42	applied	\N	\N	\N	\N	226566	226566	393556
30110	51375	43	applied	\N	\N	\N	\N	226567	226567	393557
30110	51376	44	applied	\N	\N	\N	\N	226568	226568	393558
30110	51377	45	applied	\N	\N	\N	\N	226569	226569	393559
30110	51378	46	applied	\N	\N	\N	\N	226570	226570	393560
30110	51379	47	applied	\N	\N	\N	\N	226571	226571	393561
30110	51380	48	applied	\N	\N	\N	\N	226572	226572	393562
30110	51381	49	applied	\N	\N	\N	\N	226573	226573	393563
30110	51382	50	applied	\N	\N	\N	\N	226574	226574	393564
30110	51383	51	applied	\N	\N	\N	\N	226575	226575	393565
30110	51384	52	applied	\N	\N	\N	\N	226576	226576	393566
30111	51369	13	applied	\N	\N	\N	\N	226589	226589	393579
30111	51344	14	applied	\N	\N	\N	\N	226590	226590	393580
30111	51346	16	applied	\N	\N	\N	\N	226592	226592	393582
30111	51347	17	applied	\N	\N	\N	\N	226593	226593	393583
30111	51348	18	applied	\N	\N	\N	\N	226594	226594	393584
30111	51349	19	applied	\N	\N	\N	\N	226595	226595	393585
30111	51350	20	applied	\N	\N	\N	\N	226596	226596	393586
30111	51351	21	applied	\N	\N	\N	\N	226597	226597	393587
30111	51370	22	applied	\N	\N	\N	\N	226598	226598	393588
30111	51334	23	applied	\N	\N	\N	\N	226599	226599	393589
30111	51335	24	applied	\N	\N	\N	\N	226600	226600	393590
30111	51336	25	applied	\N	\N	\N	\N	226601	226601	393591
30111	51371	26	applied	\N	\N	\N	\N	226602	226602	393592
30111	51352	27	applied	\N	\N	\N	\N	226603	226603	393593
30111	51353	28	applied	\N	\N	\N	\N	226604	226604	393594
30111	51354	29	applied	\N	\N	\N	\N	226605	226605	393595
30111	51355	30	applied	\N	\N	\N	\N	226606	226606	393596
30111	51356	31	applied	\N	\N	\N	\N	226607	226607	393597
30111	51358	33	applied	\N	\N	\N	\N	226609	226609	393599
30111	51359	34	applied	\N	\N	\N	\N	226610	226610	393600
30114	51365	0	applied	\N	\N	1000000000	\N	226711	226711	393701
30114	51366	1	applied	\N	\N	\N	\N	226712	226712	393702
30114	51367	2	applied	\N	\N	\N	\N	226713	226713	393703
30114	51340	3	applied	\N	\N	\N	\N	226714	226714	393704
30114	51329	4	applied	\N	\N	\N	\N	226715	226715	393705
30114	51341	5	applied	\N	\N	\N	\N	226716	226716	393706
30114	51342	6	applied	\N	\N	\N	\N	226717	226717	393707
30114	51343	7	applied	\N	\N	\N	\N	226718	226718	393708
30114	51368	8	applied	\N	\N	\N	\N	226719	226719	393709
30114	51332	9	applied	\N	\N	\N	\N	226720	226720	393710
30114	51333	10	applied	\N	\N	\N	\N	226721	226721	393711
30114	51369	12	applied	\N	\N	\N	\N	226722	226722	393712
30114	51344	13	applied	\N	\N	\N	\N	226723	226723	393713
30104	51333	5	applied	\N	\N	\N	\N	226404	226404	393394
30104	51335	7	applied	\N	\N	\N	\N	226406	226406	393396
30111	51364	39	applied	\N	\N	\N	\N	226615	226615	393605
30111	51372	40	applied	\N	\N	\N	\N	226616	226616	393606
30111	51373	41	applied	\N	\N	\N	\N	226617	226617	393607
30111	51374	42	applied	\N	\N	\N	\N	226618	226618	393608
30111	51375	43	applied	\N	\N	\N	\N	226619	226619	393609
30111	51376	44	applied	\N	\N	\N	\N	226620	226620	393610
30111	51377	45	applied	\N	\N	\N	\N	226621	226621	393611
30111	51378	46	applied	\N	\N	\N	\N	226622	226622	393612
30111	51379	47	applied	\N	\N	\N	\N	226623	226623	393613
30111	51380	48	applied	\N	\N	\N	\N	226624	226624	393614
30111	51381	49	applied	\N	\N	\N	\N	226625	226625	393615
30111	51382	50	applied	\N	\N	\N	\N	226626	226626	393616
30111	51383	51	applied	\N	\N	\N	\N	226627	226627	393617
30111	51384	52	applied	\N	\N	\N	\N	226628	226628	393618
30112	51366	1	applied	\N	\N	\N	\N	226630	226630	393620
30112	51367	2	applied	\N	\N	\N	\N	226631	226631	393621
30112	51340	3	applied	\N	\N	\N	\N	226632	226632	393622
30112	51329	4	applied	\N	\N	\N	\N	226633	226633	393623
30112	51341	5	applied	\N	\N	\N	\N	226634	226634	393624
30112	51342	6	applied	\N	\N	\N	\N	226635	226635	393625
30112	51343	7	applied	\N	\N	\N	\N	226636	226636	393626
30112	51368	8	applied	\N	\N	\N	\N	226637	226637	393627
30112	51331	9	applied	\N	\N	\N	\N	226638	226638	393628
30112	51332	10	applied	\N	\N	\N	\N	226639	226639	393629
30112	51333	12	applied	\N	\N	\N	\N	226640	226640	393630
30112	51369	13	applied	\N	\N	\N	\N	226641	226641	393631
30112	51344	14	applied	\N	\N	\N	\N	226642	226642	393632
30112	51345	15	applied	\N	\N	\N	\N	226643	226643	393633
30112	51346	16	applied	\N	\N	\N	\N	226644	226644	393634
30112	51347	17	applied	\N	\N	\N	\N	226645	226645	393635
30112	51348	18	applied	\N	\N	\N	\N	226646	226646	393636
30112	51349	19	applied	\N	\N	\N	\N	226647	226647	393637
30112	51351	21	applied	\N	\N	\N	\N	226649	226649	393639
30112	51370	22	applied	\N	\N	\N	\N	226650	226650	393640
30112	51334	23	applied	\N	\N	\N	\N	226651	226651	393641
30112	51335	24	applied	\N	\N	\N	\N	226652	226652	393642
30112	51336	25	applied	\N	\N	\N	\N	226653	226653	393643
30112	51371	26	applied	\N	\N	\N	\N	226654	226654	393644
30112	51381	27	applied	\N	\N	\N	\N	226655	226655	393645
30112	51382	28	applied	\N	\N	\N	\N	226656	226656	393646
30112	51383	29	applied	\N	\N	\N	\N	226657	226657	393647
30112	51384	30	applied	\N	\N	\N	\N	226658	226658	393648
30113	51341	5	applied	\N	\N	\N	\N	226664	226664	393654
30113	51342	6	applied	\N	\N	\N	\N	226665	226665	393655
30113	51343	7	applied	\N	\N	\N	\N	226666	226666	393656
30113	51368	8	applied	\N	\N	\N	\N	226667	226667	393657
30113	51331	9	applied	\N	\N	\N	\N	226668	226668	393658
30113	51332	10	applied	\N	\N	\N	\N	226669	226669	393659
30113	51369	13	applied	\N	\N	\N	\N	226671	226671	393661
30113	51344	14	applied	\N	\N	\N	\N	226672	226672	393662
30113	51345	15	applied	\N	\N	\N	\N	226673	226673	393663
30113	51346	16	applied	\N	\N	\N	\N	226674	226674	393664
30113	51347	17	applied	\N	\N	\N	\N	226675	226675	393665
30113	51348	18	applied	\N	\N	\N	\N	226676	226676	393666
30113	51349	19	applied	\N	\N	\N	\N	226677	226677	393667
30113	51350	20	applied	\N	\N	\N	\N	226678	226678	393668
30113	51351	21	applied	\N	\N	\N	\N	226679	226679	393669
30113	51370	22	applied	\N	\N	\N	\N	226680	226680	393670
30113	51334	23	applied	\N	\N	\N	\N	226681	226681	393671
30113	51335	24	applied	\N	\N	\N	\N	226682	226682	393672
30113	51336	25	applied	\N	\N	\N	\N	226683	226683	393673
30113	51371	26	applied	\N	\N	\N	\N	226684	226684	393674
30113	51352	27	applied	\N	\N	\N	\N	226685	226685	393675
30118	51385	0	applied	\N	\N	\N	\N	226807	226807	393796
30118	51387	2	applied	\N	\N	\N	\N	226809	226809	393798
30118	51393	3	applied	\N	\N	\N	\N	226810	226810	393799
30118	51394	4	applied	\N	\N	\N	\N	226811	226811	226811
30118	51395	5	applied	\N	\N	\N	\N	226812	226812	393800
30118	51388	6	applied	\N	\N	\N	\N	226813	226813	393801
30118	51389	7	applied	\N	\N	\N	\N	226814	226814	393802
30118	51390	8	applied	\N	\N	\N	\N	226815	226815	393803
30118	51391	9	applied	\N	\N	\N	\N	226816	226816	393804
30120	51392	0	applied	\N	\N	\N	\N	226828	226828	393815
30120	51396	1	applied	\N	\N	\N	\N	226829	226829	393816
30120	51397	2	applied	\N	\N	\N	\N	226830	226830	393817
30120	51398	3	applied	\N	\N	\N	\N	226831	226831	393818
30120	51399	4	applied	\N	\N	\N	\N	226832	226832	393819
30120	51393	5	applied	\N	\N	\N	\N	226833	226833	393820
30120	51400	6	applied	\N	\N	\N	\N	226834	226834	393821
30120	51401	7	applied	\N	\N	\N	\N	226835	226835	393822
30120	51395	9	applied	\N	\N	\N	\N	226837	226837	393823
30120	51402	10	applied	\N	\N	\N	\N	226838	226838	393824
30120	51403	11	applied	\N	\N	\N	\N	226839	226839	393825
30120	51404	12	applied	\N	\N	\N	\N	226840	226840	393826
30120	51405	13	applied	\N	\N	\N	\N	226841	226841	393827
30120	51406	14	applied	\N	\N	\N	\N	226842	226842	393828
30120	51407	15	applied	\N	\N	\N	\N	226843	226843	393829
30120	51408	16	applied	\N	\N	\N	\N	226844	226844	393830
30120	51409	17	applied	\N	\N	\N	\N	226845	226845	393831
30120	51410	18	applied	\N	\N	\N	\N	226846	226846	393832
30120	51411	19	applied	\N	\N	\N	\N	226847	226847	393833
30120	51412	20	applied	\N	\N	\N	\N	226848	226848	393834
30120	51413	21	applied	\N	\N	\N	\N	226849	226849	393835
30120	51414	22	applied	\N	\N	\N	\N	226850	226850	393836
30125	51463	0	applied	\N	\N	\N	\N	226945	226945	393929
30125	51464	1	applied	\N	\N	\N	\N	226946	226946	393930
30125	51466	3	applied	\N	\N	\N	\N	226948	226948	393932
30125	51467	4	applied	\N	\N	\N	\N	226949	226949	393933
30125	51468	5	applied	\N	\N	\N	\N	226950	226950	393934
30125	51469	6	applied	\N	\N	\N	\N	226951	226951	393935
30125	51470	7	applied	\N	\N	\N	\N	226952	226952	393936
30125	51471	8	applied	\N	\N	\N	\N	226953	226953	393937
30125	51472	9	applied	\N	\N	\N	\N	226954	226954	393938
30125	51473	10	applied	\N	\N	\N	\N	226955	226955	393939
30125	51474	11	applied	\N	\N	\N	\N	226956	226956	393940
30125	51475	12	applied	\N	\N	\N	\N	226957	226957	393941
30125	51476	13	applied	\N	\N	\N	\N	226958	226958	393942
30125	51477	14	applied	\N	\N	\N	\N	226959	226959	393943
30125	51478	15	applied	\N	\N	\N	\N	226960	226960	393944
30125	51479	16	applied	\N	\N	\N	\N	226961	226961	393945
30111	51362	37	applied	\N	\N	\N	\N	226613	226613	393603
30111	51363	38	applied	\N	\N	\N	\N	226614	226614	393604
30113	51357	32	applied	\N	\N	\N	\N	226690	226690	393680
30113	51358	33	applied	\N	\N	\N	\N	226691	226691	393681
30113	51359	34	applied	\N	\N	\N	\N	226692	226692	393682
30113	51360	35	applied	\N	\N	\N	\N	226693	226693	393683
30113	51361	36	applied	\N	\N	\N	\N	226694	226694	393684
30113	51362	37	applied	\N	\N	\N	\N	226695	226695	393685
30113	51363	38	applied	\N	\N	\N	\N	226696	226696	393686
30113	51364	39	applied	\N	\N	\N	\N	226697	226697	393687
30113	51372	40	applied	\N	\N	\N	\N	226698	226698	393688
30113	51373	41	applied	\N	\N	\N	\N	226699	226699	393689
30113	51374	42	applied	\N	\N	\N	\N	226700	226700	393690
30113	51375	43	applied	\N	\N	\N	\N	226701	226701	393691
30113	51376	44	applied	\N	\N	\N	\N	226702	226702	393692
30113	51377	45	applied	\N	\N	\N	\N	226703	226703	393693
30113	51379	47	applied	\N	\N	\N	\N	226705	226705	393695
30113	51380	48	applied	\N	\N	\N	\N	226706	226706	393696
30113	51381	49	applied	\N	\N	\N	\N	226707	226707	393697
30113	51382	50	applied	\N	\N	\N	\N	226708	226708	393698
30113	51383	51	applied	\N	\N	\N	\N	226709	226709	393699
30113	51384	52	applied	\N	\N	\N	\N	226710	226710	393700
30114	51345	14	applied	\N	\N	\N	\N	226724	226724	393714
30114	51346	15	applied	\N	\N	\N	\N	226725	226725	393715
30114	51347	16	applied	\N	\N	\N	\N	226726	226726	393716
30114	51348	17	applied	\N	\N	\N	\N	226727	226727	393717
30114	51349	18	applied	\N	\N	\N	\N	226728	226728	393718
30114	51350	19	applied	\N	\N	\N	\N	226729	226729	393719
30114	51351	20	applied	\N	\N	\N	\N	226730	226730	393720
30114	51370	21	applied	\N	\N	\N	\N	226731	226731	393721
30114	51371	22	applied	\N	\N	\N	\N	226732	226732	393722
30114	51381	23	applied	\N	\N	\N	\N	226733	226733	393723
30114	51383	25	applied	\N	\N	\N	\N	226735	226735	393725
30114	51384	26	applied	\N	\N	\N	\N	226736	226736	393726
30116	51385	0	applied	\N	\N	\N	\N	226789	226789	393779
30116	51386	1	applied	\N	\N	\N	\N	226790	226790	393780
30116	51387	2	applied	\N	\N	\N	\N	226791	226791	393781
30116	51388	3	applied	\N	\N	\N	\N	226792	226792	393782
30116	51389	4	applied	\N	\N	\N	\N	226793	226793	393783
30116	51390	5	applied	\N	\N	\N	\N	226794	226794	393784
30116	51391	6	applied	\N	\N	\N	\N	226795	226795	393785
30119	51392	0	applied	\N	\N	\N	\N	226817	226817	393805
30119	51385	1	applied	\N	\N	\N	\N	226818	226818	393806
30119	51386	2	applied	\N	\N	\N	\N	226819	226819	393807
30119	51387	3	applied	\N	\N	\N	\N	226820	226820	393808
30119	51393	4	applied	\N	\N	\N	\N	226821	226821	393809
30119	51394	5	applied	\N	\N	\N	\N	226822	226822	226822
30119	51395	6	applied	\N	\N	\N	\N	226823	226823	393810
30119	51389	8	applied	\N	\N	\N	\N	226825	226825	393812
30121	51392	0	applied	\N	\N	\N	\N	226851	226851	393837
30121	51396	1	applied	\N	\N	\N	\N	226852	226852	393838
30121	51397	2	applied	\N	\N	\N	\N	226853	226853	393839
30121	51398	3	applied	\N	\N	\N	\N	226854	226854	393840
30121	51399	4	applied	\N	\N	\N	\N	226855	226855	393841
30121	51393	5	applied	\N	\N	\N	\N	226856	226856	393842
30121	51400	6	applied	\N	\N	\N	\N	226857	226857	393843
30121	51401	7	applied	\N	\N	\N	\N	226858	226858	393844
30121	51394	8	applied	\N	\N	\N	\N	226859	226859	226859
30121	51395	9	applied	\N	\N	\N	\N	226860	226860	393845
30121	51402	10	applied	\N	\N	\N	\N	226861	226861	393846
30121	51403	11	applied	\N	\N	\N	\N	226862	226862	393847
30121	51404	12	applied	\N	\N	\N	\N	226863	226863	393848
30121	51405	13	applied	\N	\N	\N	\N	226864	226864	393849
30121	51406	14	applied	\N	\N	\N	\N	226865	226865	393850
30121	51408	16	applied	\N	\N	\N	\N	226867	226867	393852
30121	51409	17	applied	\N	\N	\N	\N	226868	226868	393853
30121	51410	18	applied	\N	\N	\N	\N	226869	226869	393854
30121	51411	19	applied	\N	\N	\N	\N	226870	226870	393855
30121	51412	20	applied	\N	\N	\N	\N	226871	226871	393856
30121	51413	21	applied	\N	\N	\N	\N	226872	226872	393857
30121	51414	22	applied	\N	\N	\N	\N	226873	226873	393858
30123	51415	0	applied	\N	\N	\N	\N	226897	226897	393881
30123	51416	1	applied	\N	\N	\N	\N	226898	226898	393882
30123	51417	2	applied	\N	\N	\N	\N	226899	226899	393883
30123	51418	3	applied	\N	\N	\N	\N	226900	226900	393884
30123	51419	4	applied	\N	\N	\N	\N	226901	226901	393885
30123	51420	5	applied	\N	\N	\N	\N	226902	226902	393886
30123	51421	6	applied	\N	\N	\N	\N	226903	226903	393887
30123	51422	7	applied	\N	\N	\N	\N	226904	226904	393888
30123	51423	8	applied	\N	\N	\N	\N	226905	226905	393889
30123	51425	10	applied	\N	\N	\N	\N	226907	226907	393891
30123	51426	11	applied	\N	\N	\N	\N	226908	226908	393892
30123	51427	12	applied	\N	\N	\N	\N	226909	226909	393893
30123	51428	13	applied	\N	\N	\N	\N	226910	226910	393894
30123	51429	14	applied	\N	\N	\N	\N	226911	226911	393895
30123	51430	15	applied	\N	\N	\N	\N	226912	226912	393896
30123	51431	16	applied	\N	\N	\N	\N	226913	226913	393897
30123	51432	17	applied	\N	\N	\N	\N	226914	226914	393898
30123	51433	18	applied	\N	\N	\N	\N	226915	226915	393899
30123	51434	19	applied	\N	\N	\N	\N	226916	226916	393900
30123	51435	20	applied	\N	\N	\N	\N	226917	226917	393901
30123	51436	21	applied	\N	\N	\N	\N	226918	226918	393902
30123	51437	22	applied	\N	\N	\N	\N	226919	226919	393903
30123	51438	23	applied	\N	\N	\N	\N	226920	226920	393904
30123	51439	24	applied	\N	\N	\N	\N	226921	226921	393905
30123	51440	25	applied	\N	\N	\N	\N	226922	226922	393906
30123	51442	27	applied	\N	\N	\N	\N	226924	226924	393908
30131	51490	0	applied	\N	\N	\N	\N	227017	227017	394001
30131	51494	1	applied	\N	\N	\N	\N	227018	227018	394002
30131	51495	2	applied	\N	\N	\N	\N	227019	227019	394003
30136	51508	0	applied	\N	\N	\N	\N	227061	227061	394045
30136	51511	1	applied	\N	\N	\N	\N	227062	227062	394046
30136	51512	2	applied	\N	\N	\N	\N	227063	227063	394047
30136	51516	3	applied	\N	\N	\N	\N	227064	227064	394048
30136	51517	4	applied	\N	\N	\N	\N	227065	227065	394049
30138	51518	0	applied	\N	\N	\N	\N	227080	227080	394064
30138	51519	1	applied	\N	\N	\N	\N	227081	227081	394065
30138	51509	2	applied	\N	\N	\N	\N	227082	227082	394066
30138	51510	3	applied	\N	\N	\N	\N	227083	227083	394067
30138	51520	4	applied	\N	\N	1000000000	\N	227084	227084	394068
30138	51521	5	applied	\N	\N	\N	\N	227085	227085	394069
30138	51522	6	applied	\N	\N	\N	\N	227086	227086	394070
30113	51356	31	applied	\N	\N	\N	\N	226689	226689	393679
30115	51333	12	applied	\N	\N	\N	\N	226748	226748	393738
30115	51369	13	applied	\N	\N	\N	\N	226749	226749	393739
30115	51344	14	applied	\N	\N	\N	\N	226750	226750	393740
30115	51345	15	applied	\N	\N	\N	\N	226751	226751	393741
30115	51346	16	applied	\N	\N	\N	\N	226752	226752	393742
30115	51347	17	applied	\N	\N	\N	\N	226753	226753	393743
30115	51348	18	applied	\N	\N	\N	\N	226754	226754	393744
30115	51349	19	applied	\N	\N	\N	\N	226755	226755	393745
30115	51350	20	applied	\N	\N	\N	\N	226756	226756	393746
30115	51351	21	applied	\N	\N	\N	\N	226757	226757	393747
30115	51370	22	applied	\N	\N	\N	\N	226758	226758	393748
30115	51334	23	applied	\N	\N	\N	\N	226759	226759	393749
30115	51335	24	applied	\N	\N	\N	\N	226760	226760	393750
30115	51336	25	applied	\N	\N	\N	\N	226761	226761	393751
30115	51352	27	applied	\N	\N	\N	\N	226763	226763	393753
30115	51353	28	applied	\N	\N	\N	\N	226764	226764	393754
30115	51354	29	applied	\N	\N	\N	\N	226765	226765	393755
30119	51390	9	applied	\N	\N	\N	\N	226826	226826	393813
30119	51391	10	applied	\N	\N	\N	\N	226827	226827	393814
30127	51482	0	applied	\N	\N	\N	\N	226983	226983	393967
30127	51483	1	applied	\N	\N	\N	\N	226984	226984	393968
30127	51484	2	applied	\N	\N	\N	\N	226985	226985	393969
30127	51485	3	applied	\N	\N	\N	\N	226986	226986	393970
30127	51486	4	applied	\N	\N	\N	\N	226987	226987	393971
30127	51487	5	applied	\N	\N	\N	\N	226988	226988	393972
30127	51488	6	applied	\N	\N	\N	\N	226989	226989	393973
30127	51489	7	applied	\N	\N	\N	\N	226990	226990	393974
30129	51490	0	applied	\N	\N	\N	\N	226997	226997	393981
30129	51491	1	applied	\N	\N	\N	\N	226998	226998	393982
30129	51492	2	applied	\N	\N	\N	\N	226999	226999	393983
30129	51497	4	applied	\N	\N	\N	\N	227001	227001	393985
30129	51494	5	applied	\N	\N	\N	\N	227002	227002	393986
30129	51495	6	applied	\N	\N	\N	\N	227003	227003	393987
30129	51498	7	applied	\N	\N	\N	\N	227004	227004	393988
30129	51499	8	applied	\N	\N	\N	\N	227005	227005	393989
30133	51490	0	applied	\N	\N	\N	\N	227031	227031	394015
30133	51491	1	applied	\N	\N	\N	\N	227032	227032	394016
30133	51492	2	applied	\N	\N	\N	\N	227033	227033	394017
30133	51494	3	applied	\N	\N	\N	\N	227034	227034	394018
30133	51495	4	applied	\N	\N	\N	\N	227035	227035	394019
30139	51518	0	applied	\N	\N	\N	\N	227094	227094	394078
30139	51519	1	applied	\N	\N	\N	\N	227095	227095	394079
30139	51509	2	applied	\N	\N	\N	\N	227096	227096	394080
30139	51510	3	applied	\N	\N	\N	\N	227097	227097	394081
30139	51522	5	applied	\N	\N	\N	\N	227099	227099	394083
30139	51513	6	applied	\N	\N	\N	\N	227100	227100	394084
30139	51514	7	applied	\N	\N	\N	\N	227101	227101	394085
30139	51515	8	applied	\N	\N	\N	\N	227102	227102	394086
30139	51523	9	applied	\N	\N	\N	\N	227103	227103	394087
30139	51524	10	applied	\N	\N	\N	\N	227104	227104	394088
30139	51525	11	applied	\N	\N	\N	\N	227105	227105	394089
30141	51509	0	applied	\N	\N	\N	\N	227117	227117	394101
30141	51510	1	applied	\N	\N	\N	\N	227118	227118	394102
30141	51522	2	applied	\N	\N	\N	\N	227119	227119	394103
30141	51513	3	applied	\N	\N	\N	\N	227120	227120	394104
30141	51514	4	applied	\N	\N	\N	\N	227121	227121	394105
30141	51515	5	applied	\N	\N	\N	\N	227122	227122	394106
30143	51527	0	applied	\N	\N	\N	\N	227132	227132	394116
30143	51528	1	applied	\N	\N	\N	\N	227133	227133	394117
30143	51529	2	applied	\N	\N	\N	\N	227134	227134	394118
30143	51532	3	applied	\N	\N	\N	\N	227135	227135	394119
30154	51564	0	applied	\N	\N	\N	\N	227249	227249	394233
30154	51565	1	applied	\N	\N	\N	\N	227250	227250	394234
30154	51566	2	applied	\N	\N	\N	\N	227251	227251	394235
30154	51568	4	applied	\N	\N	\N	\N	227253	227253	394237
30154	51569	5	applied	\N	\N	\N	\N	227254	227254	394238
30154	51570	6	applied	\N	\N	\N	\N	227255	227255	394239
30154	51571	7	applied	\N	\N	\N	\N	227256	227256	394240
30154	51572	8	applied	\N	\N	\N	\N	227257	227257	394241
30154	51573	9	applied	\N	\N	\N	\N	227258	227258	394242
30154	51574	10	applied	\N	\N	\N	\N	227259	227259	394243
30154	51575	11	applied	\N	\N	\N	\N	227260	227260	394244
30154	51576	12	applied	\N	\N	\N	\N	227261	227261	394245
30154	51577	13	applied	\N	\N	\N	\N	227262	227262	394246
30154	51578	14	applied	\N	\N	\N	\N	227263	227263	394247
30154	51579	15	applied	\N	\N	\N	\N	227264	227264	394248
30154	51580	16	applied	\N	\N	\N	\N	227265	227265	394249
30154	51581	17	applied	\N	\N	\N	\N	227266	227266	394250
30154	51582	18	applied	\N	\N	\N	\N	227267	227267	394251
30154	51583	19	applied	\N	\N	\N	\N	227268	227268	394252
30154	51585	21	applied	\N	\N	\N	\N	227270	227270	394254
30154	51586	22	applied	\N	\N	\N	\N	227271	227271	394255
30154	51587	23	applied	\N	\N	\N	\N	227272	227272	394256
30154	51588	24	applied	\N	\N	\N	\N	227273	227273	394257
30154	51589	25	applied	\N	\N	\N	\N	227274	227274	394258
30154	51590	26	applied	\N	\N	\N	\N	227275	227275	394259
30154	51591	27	applied	\N	\N	\N	\N	227276	227276	394260
30154	51592	28	applied	\N	\N	\N	\N	227277	227277	394261
30154	51593	29	applied	\N	\N	\N	\N	227278	227278	394262
30154	51594	30	applied	\N	\N	\N	\N	227279	227279	394263
30154	51595	31	applied	\N	\N	\N	\N	227280	227280	394264
30154	51596	32	applied	\N	\N	\N	\N	227281	227281	394265
30154	51597	33	applied	\N	\N	\N	\N	227282	227282	394266
30154	51598	34	applied	\N	\N	\N	\N	227283	227283	394267
30154	51599	35	applied	\N	\N	\N	\N	227284	227284	394268
30154	51600	36	applied	\N	\N	\N	\N	227285	227285	394269
30154	51602	38	applied	\N	\N	\N	\N	227287	227287	394271
30154	51603	39	applied	\N	\N	\N	\N	227288	227288	394272
30154	51604	40	applied	\N	\N	\N	\N	227289	227289	394273
30154	51605	41	applied	\N	\N	\N	\N	227290	227290	394274
30154	51606	42	applied	\N	\N	\N	\N	227291	227291	394275
30154	51607	43	applied	\N	\N	\N	\N	227292	227292	394276
30154	51608	44	applied	\N	\N	\N	\N	227293	227293	394277
30154	51609	45	applied	\N	\N	\N	\N	227294	227294	394278
30154	51610	46	applied	\N	\N	\N	\N	227295	227295	394279
30154	51611	47	applied	\N	\N	\N	\N	227296	227296	394280
30154	51612	48	applied	\N	\N	\N	\N	227297	227297	394281
30157	51613	0	applied	\N	\N	\N	\N	227318	227318	394302
30157	51614	1	applied	\N	\N	\N	\N	227319	227319	394303
30157	51615	2	applied	\N	\N	\N	\N	227320	227320	394304
30115	51331	9	applied	\N	\N	\N	\N	226746	226746	393736
30115	51332	10	applied	\N	\N	\N	\N	226747	226747	393737
30115	51359	34	applied	\N	\N	\N	\N	226770	226770	393760
30115	51360	35	applied	\N	\N	\N	\N	226771	226771	393761
30115	51361	36	applied	\N	\N	\N	\N	226772	226772	393762
30115	51362	37	applied	\N	\N	\N	\N	226773	226773	393763
30115	51363	38	applied	\N	\N	\N	\N	226774	226774	393764
30115	51364	39	applied	\N	\N	\N	\N	226775	226775	393765
30115	51372	40	applied	\N	\N	\N	\N	226776	226776	393766
30115	51373	41	applied	\N	\N	\N	\N	226777	226777	393767
30115	51374	42	applied	\N	\N	\N	\N	226778	226778	393768
30115	51375	43	applied	\N	\N	\N	\N	226779	226779	393769
30115	51376	44	applied	\N	\N	\N	\N	226780	226780	393770
30115	51377	45	applied	\N	\N	\N	\N	226781	226781	393771
30115	51378	46	applied	\N	\N	\N	\N	226782	226782	393772
30115	51379	47	applied	\N	\N	\N	\N	226783	226783	393773
30115	51380	48	applied	\N	\N	\N	\N	226784	226784	393774
30115	51381	49	applied	\N	\N	\N	\N	226785	226785	393775
30115	51383	51	applied	\N	\N	\N	\N	226787	226787	393777
30115	51384	52	applied	\N	\N	\N	\N	226788	226788	393778
30117	51392	0	applied	\N	\N	\N	\N	226796	226796	393786
30117	51385	1	applied	\N	\N	\N	\N	226797	226797	393787
30117	51386	2	applied	\N	\N	\N	\N	226798	226798	393788
30117	51387	3	applied	\N	\N	\N	\N	226799	226799	393789
30117	51393	4	applied	\N	\N	\N	\N	226800	226800	393790
30117	51394	5	applied	\N	\N	\N	\N	226801	226801	226801
30117	51395	6	applied	\N	\N	\N	\N	226802	226802	393791
30117	51388	7	applied	\N	\N	\N	\N	226803	226803	393792
30117	51389	8	applied	\N	\N	\N	\N	226804	226804	393793
30117	51390	9	applied	\N	\N	\N	\N	226805	226805	393794
30117	51391	10	applied	\N	\N	\N	\N	226806	226806	393795
30122	51392	0	applied	\N	\N	\N	\N	226874	226874	393859
30122	51396	1	applied	\N	\N	\N	\N	226875	226875	393860
30122	51397	2	applied	\N	\N	\N	\N	226876	226876	393861
30122	51399	4	applied	\N	\N	\N	\N	226878	226878	393863
30122	51393	5	applied	\N	\N	\N	\N	226879	226879	393864
30122	51400	6	applied	\N	\N	\N	\N	226880	226880	393865
30122	51401	7	applied	\N	\N	\N	\N	226881	226881	393866
30122	51394	8	applied	\N	\N	\N	\N	226882	226882	226882
30122	51395	9	applied	\N	\N	\N	\N	226883	226883	393867
30122	51402	10	applied	\N	\N	\N	\N	226884	226884	393868
30122	51403	11	applied	\N	\N	\N	\N	226885	226885	393869
30122	51404	12	applied	\N	\N	\N	\N	226886	226886	393870
30122	51405	13	applied	\N	\N	\N	\N	226887	226887	393871
30122	51406	14	applied	\N	\N	\N	\N	226888	226888	393872
30122	51407	15	applied	\N	\N	\N	\N	226889	226889	393873
30122	51408	16	applied	\N	\N	\N	\N	226890	226890	393874
30122	51409	17	applied	\N	\N	\N	\N	226891	226891	393875
30122	51410	18	applied	\N	\N	\N	\N	226892	226892	393876
30122	51411	19	applied	\N	\N	\N	\N	226893	226893	393877
30122	51413	21	applied	\N	\N	\N	\N	226895	226895	393879
30122	51414	22	applied	\N	\N	\N	\N	226896	226896	393880
30124	51443	0	applied	\N	\N	\N	\N	226925	226925	393909
30124	51444	1	applied	\N	\N	\N	\N	226926	226926	393910
30124	51445	2	applied	\N	\N	\N	\N	226927	226927	393911
30124	51446	3	applied	\N	\N	\N	\N	226928	226928	393912
30124	51447	4	applied	\N	\N	\N	\N	226929	226929	393913
30124	51448	5	applied	\N	\N	\N	\N	226930	226930	393914
30124	51449	6	applied	\N	\N	\N	\N	226931	226931	393915
30124	51450	7	applied	\N	\N	\N	\N	226932	226932	393916
30124	51451	8	applied	\N	\N	\N	\N	226933	226933	393917
30124	51452	9	applied	\N	\N	\N	\N	226934	226934	393918
30124	51453	10	applied	\N	\N	\N	\N	226935	226935	393919
30124	51454	11	applied	\N	\N	\N	\N	226936	226936	393920
30124	51455	12	applied	\N	\N	\N	\N	226937	226937	393921
30124	51456	13	applied	\N	\N	\N	\N	226938	226938	393922
30124	51458	15	applied	\N	\N	\N	\N	226940	226940	393924
30124	51459	16	applied	\N	\N	\N	\N	226941	226941	393925
30124	51460	17	applied	\N	\N	\N	\N	226942	226942	393926
30124	51461	18	applied	\N	\N	\N	\N	226943	226943	393927
30124	51462	19	applied	\N	\N	\N	\N	226944	226944	393928
30125	51480	17	applied	\N	\N	\N	\N	226962	226962	393946
30125	51481	18	applied	\N	\N	\N	\N	226963	226963	393947
30126	51463	0	applied	\N	\N	\N	\N	226964	226964	393948
30126	51464	1	applied	\N	\N	\N	\N	226965	226965	393949
30126	51465	2	applied	\N	\N	\N	\N	226966	226966	393950
30126	51466	3	applied	\N	\N	\N	\N	226967	226967	393951
30126	51467	4	applied	\N	\N	\N	\N	226968	226968	393952
30126	51468	5	applied	\N	\N	\N	\N	226969	226969	393953
30126	51469	6	applied	\N	\N	\N	\N	226970	226970	393954
30126	51470	7	applied	\N	\N	\N	\N	226971	226971	393955
30126	51471	8	applied	\N	\N	\N	\N	226972	226972	393956
30126	51473	10	applied	\N	\N	\N	\N	226974	226974	393958
30126	51474	11	applied	\N	\N	\N	\N	226975	226975	393959
30126	51475	12	applied	\N	\N	\N	\N	226976	226976	393960
30126	51476	13	applied	\N	\N	\N	\N	226977	226977	393961
30126	51477	14	applied	\N	\N	\N	\N	226978	226978	393962
30126	51478	15	applied	\N	\N	\N	\N	226979	226979	393963
30126	51479	16	applied	\N	\N	\N	\N	226980	226980	393964
30126	51480	17	applied	\N	\N	\N	\N	226981	226981	393965
30126	51481	18	applied	\N	\N	\N	\N	226982	226982	393966
30128	51490	0	applied	\N	\N	\N	\N	226991	226991	393975
30128	51491	1	applied	\N	\N	\N	\N	226992	226992	393976
30130	51490	0	applied	\N	\N	\N	\N	227006	227006	393990
30130	51491	1	applied	\N	\N	\N	\N	227007	227007	393991
30130	51492	2	applied	\N	\N	\N	\N	227008	227008	393992
30130	51493	3	applied	\N	\N	\N	\N	227009	227009	393993
30130	51496	4	applied	\N	\N	\N	\N	227010	227010	393994
30130	51494	6	applied	\N	\N	\N	\N	227012	227012	393996
30130	51495	7	applied	\N	\N	\N	\N	227013	227013	393997
30130	51498	8	applied	\N	\N	\N	\N	227014	227014	393998
30130	51499	9	applied	\N	\N	\N	\N	227015	227015	393999
30130	51500	10	applied	\N	\N	\N	\N	227016	227016	394000
30132	51490	0	applied	\N	\N	\N	\N	227020	227020	394004
30132	51491	1	applied	\N	\N	\N	\N	227021	227021	394005
30132	51492	2	applied	\N	\N	\N	\N	227022	227022	394006
30132	51493	3	applied	\N	\N	\N	\N	227023	227023	394007
30132	51496	4	applied	\N	\N	\N	\N	227024	227024	394008
30132	51497	5	applied	\N	\N	\N	\N	227025	227025	394009
30132	51494	6	applied	\N	\N	\N	\N	227026	227026	394010
30132	51495	7	applied	\N	\N	\N	\N	227027	227027	394011
30132	51498	8	applied	\N	\N	\N	\N	227028	227028	394012
30115	51356	31	applied	\N	\N	\N	\N	226767	226767	393757
30115	51357	32	applied	\N	\N	\N	\N	226768	226768	393758
30132	51499	9	applied	\N	\N	\N	\N	227029	227029	394013
30132	51500	10	applied	\N	\N	\N	\N	227030	227030	394014
30134	51501	0	applied	\N	\N	\N	\N	227036	227036	394020
30134	51491	1	applied	\N	\N	\N	\N	227037	227037	394021
30134	51492	2	applied	\N	\N	\N	\N	227038	227038	394022
30134	51502	3	applied	\N	\N	\N	\N	227039	227039	394023
30134	51493	4	applied	\N	\N	\N	\N	227040	227040	394024
30134	51496	5	applied	\N	\N	\N	\N	227041	227041	394025
30134	51497	6	applied	\N	\N	\N	\N	227042	227042	394026
30134	51498	7	applied	\N	\N	\N	\N	227043	227043	394027
30134	51499	8	applied	\N	\N	\N	\N	227044	227044	394028
30134	51500	9	applied	\N	\N	\N	\N	227045	227045	394029
30134	51503	10	applied	\N	\N	\N	\N	227046	227046	394030
30134	51504	11	applied	\N	\N	\N	\N	227047	227047	394031
30134	51506	13	applied	\N	\N	\N	\N	227049	227049	394033
30134	51507	14	applied	\N	\N	\N	\N	227050	227050	394034
30135	51508	0	applied	\N	\N	\N	\N	227051	227051	394035
30135	51509	1	applied	\N	\N	\N	\N	227052	227052	394036
30135	51510	2	applied	\N	\N	\N	\N	227053	227053	394037
30135	51511	3	applied	\N	\N	\N	\N	227054	227054	394038
30135	51512	4	applied	\N	\N	\N	\N	227055	227055	394039
30135	51513	5	applied	\N	\N	\N	\N	227056	227056	394040
30135	51514	6	applied	\N	\N	\N	\N	227057	227057	394041
30135	51515	7	applied	\N	\N	\N	\N	227058	227058	394042
30135	51516	8	applied	\N	\N	\N	\N	227059	227059	394043
30135	51517	9	applied	\N	\N	\N	\N	227060	227060	394044
30137	51518	0	applied	\N	\N	\N	\N	227066	227066	394050
30137	51519	1	applied	\N	\N	\N	\N	227067	227067	394051
30137	51509	2	applied	\N	\N	\N	\N	227068	227068	394052
30137	51510	3	applied	\N	\N	\N	\N	227069	227069	394053
30137	51521	5	applied	\N	\N	\N	\N	227071	227071	394055
30137	51522	6	applied	\N	\N	\N	\N	227072	227072	394056
30137	51513	7	applied	\N	\N	\N	\N	227073	227073	394057
30145	51536	0	applied	\N	\N	\N	\N	227146	227146	394130
30145	51537	1	applied	\N	\N	\N	\N	227147	227147	394131
30145	51538	2	applied	\N	\N	\N	\N	227148	227148	394132
30145	51539	3	applied	\N	\N	\N	\N	227149	227149	394133
30145	51540	4	applied	\N	\N	\N	\N	227150	227150	394134
30145	51541	5	applied	\N	\N	\N	\N	227151	227151	394135
30145	51542	6	applied	\N	\N	\N	\N	227152	227152	394136
30145	51543	7	applied	\N	\N	\N	\N	227153	227153	394137
30145	51544	8	applied	\N	\N	\N	\N	227154	227154	394138
30145	51545	9	applied	\N	\N	\N	\N	227155	227155	394139
30147	51546	0	applied	\N	\N	\N	\N	227164	227164	394148
30147	51547	1	applied	\N	\N	\N	\N	227165	227165	394149
30147	51548	2	applied	\N	\N	\N	\N	227166	227166	394150
30147	51549	3	applied	\N	\N	\N	\N	227167	227167	394151
30147	51550	4	applied	\N	\N	\N	\N	227168	227168	394152
30147	51552	6	applied	\N	\N	\N	\N	227170	227170	394154
30147	51553	7	applied	\N	\N	\N	\N	227171	227171	394155
30149	51554	0	applied	\N	\N	\N	\N	227180	227180	394164
30149	51555	1	applied	\N	\N	\N	\N	227181	227181	394165
30149	51556	2	applied	\N	\N	\N	\N	227182	227182	394166
30149	51557	3	applied	\N	\N	\N	\N	227183	227183	394167
30149	51558	4	applied	\N	\N	\N	\N	227184	227184	394168
30149	51559	5	applied	\N	\N	\N	\N	227185	227185	394169
30149	51560	6	applied	\N	\N	\N	\N	227186	227186	394170
30149	51561	7	applied	\N	\N	\N	\N	227187	227187	394171
30149	51562	8	applied	\N	\N	\N	\N	227188	227188	394172
30149	51563	9	applied	\N	\N	\N	\N	227189	227189	394173
30156	51613	0	applied	\N	\N	\N	\N	227308	227308	394292
30156	51614	1	applied	\N	\N	\N	\N	227309	227309	394293
30156	51615	2	applied	\N	\N	\N	\N	227310	227310	394294
30156	51616	3	applied	\N	\N	\N	\N	227311	227311	394295
30156	51618	5	applied	\N	\N	\N	\N	227313	227313	394297
30156	51619	6	applied	\N	\N	\N	\N	227314	227314	394298
30156	51620	7	applied	\N	\N	\N	\N	227315	227315	394299
30156	51621	8	applied	\N	\N	\N	\N	227316	227316	394300
30156	51622	9	applied	\N	\N	\N	\N	227317	227317	394301
30158	51623	0	applied	\N	\N	\N	\N	227326	227326	394310
30158	51624	1	applied	\N	\N	\N	\N	227327	227327	394311
30158	51625	2	applied	\N	\N	\N	\N	227328	227328	394312
30158	51626	3	applied	\N	\N	\N	\N	227329	227329	394313
30158	51627	4	applied	\N	\N	\N	\N	227330	227330	394314
30158	51628	5	applied	\N	\N	\N	\N	227331	227331	394315
30158	51629	6	applied	\N	\N	\N	\N	227332	227332	394316
30158	51630	7	applied	\N	\N	\N	\N	227333	227333	394317
30162	51639	0	applied	\N	\N	\N	\N	227348	227348	394332
30162	51640	1	applied	\N	\N	\N	\N	227349	227349	394333
30162	51641	2	applied	\N	\N	\N	\N	227350	227350	394334
30162	51643	4	applied	\N	\N	\N	\N	227352	227352	394336
30162	51644	5	applied	\N	\N	\N	\N	227353	227353	394337
30162	51645	6	applied	\N	\N	\N	\N	227354	227354	394338
30162	51646	7	applied	\N	\N	\N	\N	227355	227355	394339
30162	51647	8	applied	\N	\N	\N	\N	227356	227356	394340
30162	51648	9	applied	\N	\N	\N	\N	227357	227357	394341
30162	51649	10	applied	\N	\N	\N	\N	227358	227358	394342
30164	51650	0	applied	\N	\N	\N	\N	227398	227398	394382
30164	51651	1	applied	\N	\N	\N	\N	227399	227399	394383
30164	51652	2	applied	\N	\N	\N	\N	227400	227400	394384
30164	51653	3	applied	\N	\N	\N	\N	227401	227401	394385
30164	51654	4	applied	\N	\N	\N	\N	227402	227402	394386
30164	51655	5	applied	\N	\N	\N	\N	227403	227403	394387
30164	51656	6	applied	\N	\N	\N	\N	227404	227404	394388
30164	51657	7	applied	\N	\N	\N	\N	227405	227405	394389
30164	51658	8	applied	\N	\N	\N	\N	227406	227406	394390
30164	51660	10	applied	\N	\N	\N	\N	227408	227408	394392
30164	51661	11	applied	\N	\N	\N	\N	227409	227409	394393
30164	51662	12	applied	\N	\N	\N	\N	227410	227410	394394
30164	51663	13	applied	\N	\N	\N	\N	227411	227411	394395
30164	51664	14	applied	\N	\N	\N	\N	227412	227412	394396
30164	51665	15	applied	\N	\N	\N	\N	227413	227413	394397
30164	51666	16	applied	\N	\N	\N	\N	227414	227414	394398
30164	51667	17	applied	\N	\N	\N	\N	227415	227415	394399
30164	51668	18	applied	\N	\N	\N	\N	227416	227416	394400
30164	51669	19	applied	\N	\N	\N	\N	227417	227417	394401
30164	51670	20	applied	\N	\N	\N	\N	227418	227418	394402
30164	51671	21	applied	\N	\N	\N	\N	227419	227419	394403
30164	51672	22	applied	\N	\N	\N	\N	227420	227420	394404
30164	51673	23	applied	\N	\N	\N	\N	227421	227421	394405
30128	51494	4	applied	\N	\N	\N	\N	226995	226995	393979
30128	51495	5	applied	\N	\N	\N	\N	226996	226996	393980
30137	51525	12	applied	\N	\N	\N	\N	227078	227078	394062
30137	51526	13	applied	\N	\N	\N	\N	227079	227079	394063
30138	51513	7	applied	\N	\N	\N	\N	227087	227087	394071
30138	51514	8	applied	\N	\N	\N	\N	227088	227088	394072
30138	51515	9	applied	\N	\N	\N	\N	227089	227089	394073
30138	51523	10	applied	\N	\N	\N	\N	227090	227090	394074
30138	51524	11	applied	\N	\N	\N	\N	227091	227091	394075
30138	51525	12	applied	\N	\N	\N	\N	227092	227092	394076
30138	51526	13	applied	\N	\N	\N	\N	227093	227093	394077
30140	51518	0	applied	\N	\N	\N	\N	227106	227106	394090
30140	51519	1	applied	\N	\N	\N	\N	227107	227107	394091
30140	51509	2	applied	\N	\N	\N	\N	227108	227108	394092
30140	51510	3	applied	\N	\N	\N	\N	227109	227109	394093
30140	51513	5	applied	\N	\N	\N	\N	227111	227111	394095
30140	51514	6	applied	\N	\N	\N	\N	227112	227112	394096
30140	51515	7	applied	\N	\N	\N	\N	227113	227113	394097
30140	51523	8	applied	\N	\N	\N	\N	227114	227114	394098
30140	51524	9	applied	\N	\N	\N	\N	227115	227115	394099
30140	51525	10	applied	\N	\N	\N	\N	227116	227116	394100
30142	51527	0	applied	\N	\N	\N	\N	227123	227123	394107
30142	51528	1	applied	\N	\N	\N	\N	227124	227124	394108
30142	51529	2	applied	\N	\N	\N	\N	227125	227125	394109
30142	51530	3	applied	\N	\N	\N	\N	227126	227126	394110
30166	51650	0	applied	\N	\N	\N	\N	227476	227476	394460
30166	51651	1	applied	\N	\N	\N	\N	227477	227477	394461
30166	51652	2	applied	\N	\N	\N	\N	227478	227478	394462
30166	51653	3	applied	\N	\N	\N	\N	227479	227479	394463
30166	51654	4	applied	\N	\N	\N	\N	227480	227480	394464
30166	51655	5	applied	\N	\N	\N	\N	227481	227481	394465
30166	51656	6	applied	\N	\N	\N	\N	227482	227482	394466
30166	51657	7	applied	\N	\N	\N	\N	227483	227483	394467
30166	51658	8	applied	\N	\N	\N	\N	227484	227484	394468
30166	51660	10	applied	\N	\N	\N	\N	227486	227486	394470
30166	51661	11	applied	\N	\N	\N	\N	227487	227487	394471
30166	51662	12	applied	\N	\N	\N	\N	227488	227488	394472
30166	51663	13	applied	\N	\N	\N	\N	227489	227489	394473
30166	51664	14	applied	\N	\N	\N	\N	227490	227490	394474
30166	51665	15	applied	\N	\N	\N	\N	227491	227491	394475
30166	51666	16	applied	\N	\N	\N	\N	227492	227492	394476
30166	51667	17	applied	\N	\N	\N	\N	227493	227493	394477
30166	51668	18	applied	\N	\N	\N	\N	227494	227494	394478
30166	51669	19	applied	\N	\N	\N	\N	227495	227495	394479
30166	51670	20	applied	\N	\N	\N	\N	227496	227496	394480
30166	51671	21	applied	\N	\N	\N	\N	227497	227497	394481
30166	51672	22	applied	\N	\N	\N	\N	227498	227498	394482
30166	51673	23	applied	\N	\N	\N	\N	227499	227499	394483
30166	51674	24	applied	\N	\N	\N	\N	227500	227500	394484
30166	51675	25	applied	\N	\N	\N	\N	227501	227501	394485
30166	51677	27	applied	\N	\N	\N	\N	227503	227503	394487
30166	51678	28	applied	\N	\N	\N	\N	227504	227504	394488
30166	51679	29	applied	\N	\N	\N	\N	227505	227505	394489
30166	51680	31	applied	\N	\N	\N	\N	227506	227506	394490
30166	51681	32	applied	\N	\N	\N	\N	227507	227507	394491
30166	51682	33	applied	\N	\N	\N	\N	227508	227508	394492
30166	51683	34	applied	\N	\N	\N	\N	227509	227509	394493
30166	51684	35	applied	\N	\N	\N	\N	227510	227510	394494
30166	51685	36	applied	\N	\N	\N	\N	227511	227511	394495
30166	51686	37	applied	\N	\N	\N	\N	227512	227512	394496
30166	51687	38	applied	\N	\N	\N	\N	227513	227513	394497
30166	51688	39	applied	\N	\N	\N	\N	227514	227514	394498
30168	51689	0	applied	\N	\N	\N	\N	227524	227524	394508
30168	51690	1	applied	\N	\N	\N	\N	227525	227525	394509
30168	51691	2	applied	\N	\N	\N	\N	227526	227526	394510
30168	51693	3	applied	\N	\N	\N	\N	227527	227527	394511
30168	51695	5	applied	\N	\N	\N	\N	227529	227529	394513
30168	51696	6	applied	\N	\N	\N	\N	227530	227530	394514
30168	51697	7	applied	\N	\N	\N	\N	227531	227531	394515
30170	51698	0	applied	\N	\N	\N	\N	227541	227541	394525
30170	51699	1	applied	\N	\N	\N	\N	227542	227542	394526
30170	51700	2	applied	\N	\N	\N	\N	227543	227543	394527
30170	51701	3	applied	\N	\N	\N	\N	227544	227544	394528
30170	51702	4	applied	\N	\N	\N	\N	227545	227545	394529
30170	51703	5	applied	\N	\N	\N	\N	227546	227546	394530
30170	51704	6	applied	\N	\N	\N	\N	227547	227547	394531
30170	51705	7	applied	\N	\N	\N	\N	227548	227548	394532
30172	51698	0	applied	\N	\N	\N	\N	227557	227557	394541
30172	51699	1	applied	\N	\N	\N	\N	227558	227558	394542
30172	51700	2	applied	\N	\N	\N	\N	227559	227559	394543
30172	51701	3	applied	\N	\N	\N	\N	227560	227560	394544
30172	51702	4	applied	\N	\N	\N	\N	227561	227561	394545
30172	51704	6	applied	\N	\N	\N	\N	227563	227563	394547
30172	51705	7	applied	\N	\N	\N	\N	227564	227564	394548
30174	51706	0	applied	\N	\N	\N	\N	227574	227574	394558
30174	51707	1	applied	\N	\N	\N	\N	227575	227575	394559
30174	51708	2	applied	\N	\N	\N	\N	227576	227576	394560
30174	51709	3	applied	\N	\N	\N	\N	227577	227577	394561
30174	51710	4	applied	\N	\N	\N	\N	227578	227578	394562
30174	51711	5	applied	\N	\N	\N	\N	227579	227579	394563
30174	51712	6	applied	\N	\N	\N	\N	227580	227580	394564
30174	51713	7	applied	\N	\N	\N	\N	227581	227581	394565
30174	51714	8	applied	\N	\N	\N	\N	227582	227582	394566
30184	51752	0	applied	\N	\N	\N	\N	227679	227679	394662
30184	51753	1	applied	\N	\N	\N	\N	227680	227680	394663
30184	51754	2	applied	\N	\N	\N	\N	227681	227681	394664
30184	51756	3	applied	\N	\N	\N	\N	227682	227682	394665
30184	51757	4	applied	\N	\N	\N	\N	227683	227683	394666
30184	51759	6	applied	\N	\N	\N	\N	227685	227685	394668
30184	51760	7	applied	\N	\N	\N	\N	227686	227686	394669
30186	51761	0	applied	\N	\N	\N	\N	227761	227761	394735
30186	51762	1	applied	\N	\N	\N	\N	227762	227762	394736
30186	51763	2	applied	\N	\N	\N	\N	227763	227763	394737
30186	51764	3	applied	\N	\N	\N	\N	227764	227764	394738
30186	51765	4	applied	\N	\N	\N	\N	227765	227765	394739
30186	51766	5	applied	\N	\N	\N	\N	227766	227766	394740
30186	51767	6	applied	\N	\N	\N	\N	227767	227767	394741
30193	51798	0	applied	\N	\N	\N	\N	227847	227847	394821
30193	51799	1	applied	\N	\N	\N	\N	227848	227848	394822
30193	51800	2	applied	\N	\N	\N	\N	227849	227849	394823
30193	51801	3	applied	\N	\N	\N	\N	227850	227850	394824
30193	51802	4	applied	\N	\N	\N	\N	227851	227851	394825
30137	51523	10	applied	\N	\N	\N	\N	227076	227076	394060
30137	51524	11	applied	\N	\N	\N	\N	227077	227077	394061
30142	51535	8	applied	\N	\N	\N	\N	227131	227131	394115
30144	51536	0	applied	\N	\N	\N	\N	227136	227136	394120
30144	51537	1	applied	\N	\N	\N	\N	227137	227137	394121
30144	51538	2	applied	\N	\N	\N	\N	227138	227138	394122
30144	51539	3	applied	\N	\N	\N	\N	227139	227139	394123
30144	51540	4	applied	\N	\N	\N	\N	227140	227140	394124
30144	51541	5	applied	\N	\N	\N	\N	227141	227141	394125
30144	51542	6	applied	\N	\N	\N	\N	227142	227142	394126
30144	51543	7	applied	\N	\N	\N	\N	227143	227143	394127
30144	51544	8	applied	\N	\N	\N	\N	227144	227144	394128
30144	51545	9	applied	\N	\N	\N	\N	227145	227145	394129
30146	51546	0	applied	\N	\N	\N	\N	227156	227156	394140
30146	51547	1	applied	\N	\N	\N	\N	227157	227157	394141
30146	51548	2	applied	\N	\N	\N	\N	227158	227158	394142
30146	51549	3	applied	\N	\N	\N	\N	227159	227159	394143
30146	51550	4	applied	\N	\N	\N	\N	227160	227160	394144
30146	51552	6	applied	\N	\N	\N	\N	227162	227162	394146
30146	51553	7	applied	\N	\N	\N	\N	227163	227163	394147
30148	51546	0	applied	\N	\N	\N	\N	227172	227172	394156
30148	51547	1	applied	\N	\N	\N	\N	227173	227173	394157
30148	51548	2	applied	\N	\N	\N	\N	227174	227174	394158
30148	51549	3	applied	\N	\N	\N	\N	227175	227175	394159
30148	51550	4	applied	\N	\N	\N	\N	227176	227176	394160
30148	51551	5	applied	\N	\N	\N	\N	227177	227177	394161
30148	51552	6	applied	\N	\N	\N	\N	227178	227178	394162
30148	51553	7	applied	\N	\N	\N	\N	227179	227179	394163
30150	51554	0	applied	\N	\N	\N	\N	227190	227190	394174
30150	51555	1	applied	\N	\N	\N	\N	227191	227191	394175
30150	51556	2	applied	\N	\N	\N	\N	227192	227192	394176
30150	51557	3	applied	\N	\N	\N	\N	227193	227193	394177
30150	51558	4	applied	\N	\N	\N	\N	227194	227194	394178
30150	51559	5	applied	\N	\N	\N	\N	227195	227195	394179
30150	51561	7	applied	\N	\N	\N	\N	227197	227197	394181
30150	51562	8	applied	\N	\N	\N	\N	227198	227198	394182
30150	51563	9	applied	\N	\N	\N	\N	227199	227199	394183
30153	51564	0	applied	\N	\N	\N	\N	227200	227200	394184
30153	51565	1	applied	\N	\N	\N	\N	227201	227201	394185
30153	51566	2	applied	\N	\N	\N	\N	227202	227202	394186
30153	51567	3	applied	\N	\N	\N	\N	227203	227203	394187
30153	51568	4	applied	\N	\N	\N	\N	227204	227204	394188
30153	51569	5	applied	\N	\N	\N	\N	227205	227205	394189
30153	51570	6	applied	\N	\N	\N	\N	227206	227206	394190
30153	51571	7	applied	\N	\N	\N	\N	227207	227207	394191
30153	51572	8	applied	\N	\N	\N	\N	227208	227208	394192
30153	51573	9	applied	\N	\N	\N	\N	227209	227209	394193
30153	51574	10	applied	\N	\N	\N	\N	227210	227210	394194
30153	51575	11	applied	\N	\N	\N	\N	227211	227211	394195
30153	51576	12	applied	\N	\N	\N	\N	227212	227212	394196
30153	51578	14	applied	\N	\N	\N	\N	227214	227214	394198
30153	51579	15	applied	\N	\N	\N	\N	227215	227215	394199
30153	51580	16	applied	\N	\N	\N	\N	227216	227216	394200
30153	51581	17	applied	\N	\N	\N	\N	227217	227217	394201
30153	51582	18	applied	\N	\N	\N	\N	227218	227218	394202
30153	51583	19	applied	\N	\N	\N	\N	227219	227219	394203
30153	51584	20	applied	\N	\N	\N	\N	227220	227220	394204
30153	51585	21	applied	\N	\N	\N	\N	227221	227221	394205
30153	51586	22	applied	\N	\N	\N	\N	227222	227222	394206
30153	51587	23	applied	\N	\N	\N	\N	227223	227223	394207
30153	51588	24	applied	\N	\N	\N	\N	227224	227224	394208
30153	51589	25	applied	\N	\N	\N	\N	227225	227225	394209
30153	51590	26	applied	\N	\N	\N	\N	227226	227226	394210
30153	51591	27	applied	\N	\N	\N	\N	227227	227227	394211
30153	51592	28	applied	\N	\N	\N	\N	227228	227228	394212
30153	51593	29	applied	\N	\N	\N	\N	227229	227229	394213
30153	51595	31	applied	\N	\N	\N	\N	227231	227231	394215
30153	51596	32	applied	\N	\N	\N	\N	227232	227232	394216
30153	51597	33	applied	\N	\N	\N	\N	227233	227233	394217
30153	51598	34	applied	\N	\N	\N	\N	227234	227234	394218
30153	51599	35	applied	\N	\N	\N	\N	227235	227235	394219
30153	51600	36	applied	\N	\N	\N	\N	227236	227236	394220
30153	51601	37	applied	\N	\N	\N	\N	227237	227237	394221
30153	51602	38	applied	\N	\N	\N	\N	227238	227238	394222
30153	51603	39	applied	\N	\N	\N	\N	227239	227239	394223
30153	51604	40	applied	\N	\N	\N	\N	227240	227240	394224
30153	51605	41	applied	\N	\N	\N	\N	227241	227241	394225
30153	51606	42	applied	\N	\N	\N	\N	227242	227242	394226
30153	51607	43	applied	\N	\N	\N	\N	227243	227243	394227
30153	51608	44	applied	\N	\N	\N	\N	227244	227244	394228
30153	51609	45	applied	\N	\N	\N	\N	227245	227245	394229
30153	51610	46	applied	\N	\N	\N	\N	227246	227246	394230
30153	51612	48	applied	\N	\N	\N	\N	227248	227248	394232
30155	51613	0	applied	\N	\N	\N	\N	227298	227298	394282
30155	51614	1	applied	\N	\N	\N	\N	227299	227299	394283
30155	51615	2	applied	\N	\N	\N	\N	227300	227300	394284
30155	51616	3	applied	\N	\N	\N	\N	227301	227301	394285
30155	51617	4	applied	\N	\N	\N	\N	227302	227302	394286
30155	51618	5	applied	\N	\N	\N	\N	227303	227303	394287
30155	51619	6	applied	\N	\N	\N	\N	227304	227304	394288
30155	51620	7	applied	\N	\N	\N	\N	227305	227305	394289
30155	51621	8	applied	\N	\N	\N	\N	227306	227306	394290
30155	51622	9	applied	\N	\N	\N	\N	227307	227307	394291
30159	51623	0	applied	\N	\N	\N	\N	227334	227334	394318
30159	51624	1	applied	\N	\N	\N	\N	227335	227335	394319
30159	51625	2	applied	\N	\N	\N	\N	227336	227336	394320
30159	51626	3	applied	\N	\N	\N	\N	227337	227337	394321
30159	51627	4	applied	\N	\N	\N	\N	227338	227338	394322
30163	51650	0	applied	\N	\N	\N	\N	227359	227359	394343
30163	51651	1	applied	\N	\N	\N	\N	227360	227360	394344
30163	51652	2	applied	\N	\N	\N	\N	227361	227361	394345
30163	51653	3	applied	\N	\N	\N	\N	227362	227362	394346
30163	51654	4	applied	\N	\N	\N	\N	227363	227363	394347
30163	51655	5	applied	\N	\N	\N	\N	227364	227364	394348
30163	51656	6	applied	\N	\N	\N	\N	227365	227365	394349
30163	51657	7	applied	\N	\N	\N	\N	227366	227366	394350
30163	51658	8	applied	\N	\N	\N	\N	227367	227367	394351
30163	51659	9	applied	\N	\N	\N	\N	227368	227368	394352
30163	51660	10	applied	\N	\N	\N	\N	227369	227369	394353
30163	51661	11	applied	\N	\N	\N	\N	227370	227370	394354
30163	51662	12	applied	\N	\N	\N	\N	227371	227371	394355
30163	51663	13	applied	\N	\N	\N	\N	227372	227372	394356
30142	51532	5	applied	\N	\N	\N	\N	227128	227128	394112
30142	51533	6	applied	\N	\N	\N	\N	227129	227129	394113
30157	51620	6	applied	\N	\N	\N	\N	227324	227324	394308
30157	51621	7	applied	\N	\N	\N	\N	227325	227325	394309
30161	51631	0	applied	\N	\N	\N	\N	227340	227340	394324
30161	51632	1	applied	\N	\N	\N	\N	227341	227341	394325
30161	51633	2	applied	\N	\N	\N	\N	227342	227342	394326
30161	51634	3	applied	\N	\N	\N	\N	227343	227343	394327
30161	51635	4	applied	\N	\N	\N	\N	227344	227344	394328
30161	51636	5	applied	\N	\N	\N	\N	227345	227345	394329
30161	51637	6	applied	\N	\N	\N	\N	227346	227346	394330
30163	51664	14	applied	\N	\N	\N	\N	227373	227373	394357
30163	51665	15	applied	\N	\N	\N	\N	227374	227374	394358
30163	51666	16	applied	\N	\N	\N	\N	227375	227375	394359
30163	51667	17	applied	\N	\N	\N	\N	227376	227376	394360
30163	51668	18	applied	\N	\N	\N	\N	227377	227377	394361
30163	51669	19	applied	\N	\N	\N	\N	227378	227378	394362
30163	51670	20	applied	\N	\N	\N	\N	227379	227379	394363
30163	51671	21	applied	\N	\N	\N	\N	227380	227380	394364
30163	51672	22	applied	\N	\N	\N	\N	227381	227381	394365
30163	51673	23	applied	\N	\N	\N	\N	227382	227382	394366
30163	51674	24	applied	\N	\N	\N	\N	227383	227383	394367
30163	51675	25	applied	\N	\N	\N	\N	227384	227384	394368
30163	51676	26	applied	\N	\N	\N	\N	227385	227385	394369
30163	51677	27	applied	\N	\N	\N	\N	227386	227386	394370
30163	51678	28	applied	\N	\N	\N	\N	227387	227387	394371
30163	51679	29	applied	\N	\N	\N	\N	227388	227388	394372
30163	51681	32	applied	\N	\N	\N	\N	227390	227390	394374
30163	51682	33	applied	\N	\N	\N	\N	227391	227391	394375
30163	51683	34	applied	\N	\N	\N	\N	227392	227392	394376
30163	51684	35	applied	\N	\N	\N	\N	227393	227393	394377
30163	51685	36	applied	\N	\N	\N	\N	227394	227394	394378
30163	51686	37	applied	\N	\N	\N	\N	227395	227395	394379
30163	51687	38	applied	\N	\N	\N	\N	227396	227396	394380
30163	51688	39	applied	\N	\N	\N	\N	227397	227397	394381
30165	51650	0	applied	\N	\N	\N	\N	227437	227437	394421
30165	51651	1	applied	\N	\N	\N	\N	227438	227438	394422
30165	51652	2	applied	\N	\N	\N	\N	227439	227439	394423
30165	51653	3	applied	\N	\N	\N	\N	227440	227440	394424
30165	51654	4	applied	\N	\N	\N	\N	227441	227441	394425
30165	51655	5	applied	\N	\N	\N	\N	227442	227442	394426
30165	51656	6	applied	\N	\N	\N	\N	227443	227443	394427
30165	51657	7	applied	\N	\N	\N	\N	227444	227444	394428
30167	51689	0	applied	\N	\N	\N	\N	227515	227515	394499
30167	51690	1	applied	\N	\N	\N	\N	227516	227516	394500
30167	51691	2	applied	\N	\N	\N	\N	227517	227517	394501
30167	51692	3	applied	\N	\N	\N	\N	227518	227518	394502
30167	51693	4	applied	\N	\N	\N	\N	227519	227519	394503
30167	51694	5	applied	\N	\N	\N	\N	227520	227520	394504
30167	51695	6	applied	\N	\N	\N	\N	227521	227521	394505
30167	51696	7	applied	\N	\N	\N	\N	227522	227522	394506
30167	51697	8	applied	\N	\N	\N	\N	227523	227523	394507
30171	51698	0	applied	\N	\N	\N	\N	227549	227549	394533
30171	51699	1	applied	\N	\N	\N	\N	227550	227550	394534
30171	51700	2	applied	\N	\N	\N	\N	227551	227551	394535
30171	51701	3	applied	\N	\N	\N	\N	227552	227552	394536
30171	51702	4	applied	\N	\N	\N	\N	227553	227553	394537
30171	51703	5	applied	\N	\N	\N	\N	227554	227554	394538
30171	51704	6	applied	\N	\N	\N	\N	227555	227555	394539
30176	50265	0	applied	\N	\N	\N	\N	227593	227593	394577
30176	51186	1	applied	\N	\N	\N	\N	227594	227594	394578
30176	51187	2	applied	\N	\N	\N	\N	227595	227595	394579
30176	51365	3	applied	\N	\N	1000000000	\N	227596	227596	394580
30176	51398	4	applied	\N	\N	\N	\N	227597	227597	394581
30176	51149	5	applied	\N	\N	\N	\N	227598	227598	227598
30176	48616	6	applied	\N	\N	\N	\N	227599	227599	394582
30176	50997	7	applied	\N	\N	\N	\N	227600	227600	394583
30176	49319	8	applied	\N	\N	\N	\N	227601	227601	394584
30178	51725	0	applied	\N	\N	\N	\N	227621	227621	394604
30178	51726	1	applied	\N	\N	\N	\N	227622	227622	394605
30178	51727	2	applied	\N	\N	\N	\N	227623	227623	394606
30178	51728	3	applied	\N	\N	\N	\N	227624	227624	394607
30178	51729	4	applied	\N	\N	\N	\N	227625	227625	394608
30178	51730	5	applied	\N	\N	\N	\N	227626	227626	394609
30178	51731	6	applied	\N	\N	\N	\N	227627	227627	394610
30178	51733	8	applied	\N	\N	\N	\N	227629	227629	394612
30178	51734	9	applied	\N	\N	\N	\N	227630	227630	394613
30183	51752	0	applied	\N	\N	\N	\N	227670	227670	394653
30183	51753	1	applied	\N	\N	\N	\N	227671	227671	394654
30183	51754	2	applied	\N	\N	\N	\N	227672	227672	394655
30183	51755	3	applied	\N	\N	\N	\N	227673	227673	394656
30183	51756	4	applied	\N	\N	\N	\N	227674	227674	394657
30183	51757	5	applied	\N	\N	\N	\N	227675	227675	394658
30183	51758	6	applied	\N	\N	\N	\N	227676	227676	394659
30183	51759	7	applied	\N	\N	\N	\N	227677	227677	394660
30183	51760	8	applied	\N	\N	\N	\N	227678	227678	394661
30185	48846	0	applied	\N	\N	1000000000	\N	227687	227687	394670
30185	48733	1	applied	\N	\N	\N	\N	227688	227688	227688
30185	48707	2	applied	\N	\N	\N	\N	227689	227689	394671
30185	50265	3	applied	\N	\N	\N	\N	227690	227690	394672
30185	48961	4	applied	\N	\N	\N	\N	227691	227691	394673
30185	48734	6	applied	\N	\N	\N	\N	227693	227693	394675
30185	48753	7	applied	\N	\N	\N	\N	227694	227694	394676
30185	48598	8	applied	\N	\N	\N	\N	227695	227695	394677
30185	51186	9	applied	\N	\N	\N	\N	227696	227696	394678
30185	49148	10	applied	\N	\N	\N	\N	227697	227697	394679
30185	51187	11	applied	\N	\N	\N	\N	227698	227698	394680
30185	49157	12	applied	\N	\N	\N	\N	227699	227699	394681
30185	49607	13	applied	\N	\N	\N	\N	227700	227700	394682
30185	51365	14	applied	\N	\N	1000000000	\N	227701	227701	394683
30185	48754	15	applied	\N	\N	1000000000	\N	227702	227702	394684
30185	48627	16	applied	\N	\N	\N	\N	227703	227703	394685
30185	48963	17	applied	\N	\N	\N	\N	227704	227704	394686
30185	51398	18	applied	\N	\N	\N	\N	227705	227705	394687
30185	48935	19	applied	\N	\N	\N	\N	227706	227706	227706
30185	51149	20	applied	\N	\N	\N	\N	227707	227707	227707
30185	49093	21	applied	\N	\N	\N	\N	227708	227708	394688
30185	48616	23	applied	\N	\N	\N	\N	227710	227710	394690
30185	50997	24	applied	\N	\N	\N	\N	227711	227711	394691
30185	49319	25	applied	\N	\N	\N	\N	227712	227712	394692
30185	49066	26	applied	\N	\N	\N	\N	227713	227713	227713
30157	51618	4	applied	\N	\N	\N	\N	227322	227322	394306
30157	51619	5	applied	\N	\N	\N	\N	227323	227323	394307
30164	51678	28	applied	\N	\N	\N	\N	227426	227426	394410
30164	51679	29	applied	\N	\N	\N	\N	227427	227427	394411
30164	51680	31	applied	\N	\N	\N	\N	227428	227428	394412
30164	51681	32	applied	\N	\N	\N	\N	227429	227429	394413
30164	51682	33	applied	\N	\N	\N	\N	227430	227430	394414
30164	51683	34	applied	\N	\N	\N	\N	227431	227431	394415
30164	51684	35	applied	\N	\N	\N	\N	227432	227432	394416
30164	51685	36	applied	\N	\N	\N	\N	227433	227433	394417
30164	51686	37	applied	\N	\N	\N	\N	227434	227434	394418
30164	51687	38	applied	\N	\N	\N	\N	227435	227435	394419
30164	51688	39	applied	\N	\N	\N	\N	227436	227436	394420
30165	51659	9	applied	\N	\N	\N	\N	227446	227446	394430
30165	51660	10	applied	\N	\N	\N	\N	227447	227447	394431
30165	51661	11	applied	\N	\N	\N	\N	227448	227448	394432
30165	51663	13	applied	\N	\N	\N	\N	227450	227450	394434
30165	51664	14	applied	\N	\N	\N	\N	227451	227451	394435
30165	51665	15	applied	\N	\N	\N	\N	227452	227452	394436
30165	51666	16	applied	\N	\N	\N	\N	227453	227453	394437
30165	51667	17	applied	\N	\N	\N	\N	227454	227454	394438
30165	51668	18	applied	\N	\N	\N	\N	227455	227455	394439
30165	51669	19	applied	\N	\N	\N	\N	227456	227456	394440
30165	51670	20	applied	\N	\N	\N	\N	227457	227457	394441
30165	51671	21	applied	\N	\N	\N	\N	227458	227458	394442
30165	51672	22	applied	\N	\N	\N	\N	227459	227459	394443
30165	51673	23	applied	\N	\N	\N	\N	227460	227460	394444
30165	51674	24	applied	\N	\N	\N	\N	227461	227461	394445
30165	51675	25	applied	\N	\N	\N	\N	227462	227462	394446
30165	51676	26	applied	\N	\N	\N	\N	227463	227463	394447
30165	51677	27	applied	\N	\N	\N	\N	227464	227464	394448
30165	51678	28	applied	\N	\N	\N	\N	227465	227465	394449
30165	51680	31	applied	\N	\N	\N	\N	227467	227467	394451
30165	51681	32	applied	\N	\N	\N	\N	227468	227468	394452
30165	51682	33	applied	\N	\N	\N	\N	227469	227469	394453
30165	51683	34	applied	\N	\N	\N	\N	227470	227470	394454
30165	51684	35	applied	\N	\N	\N	\N	227471	227471	394455
30165	51685	36	applied	\N	\N	\N	\N	227472	227472	394456
30165	51686	37	applied	\N	\N	\N	\N	227473	227473	394457
30165	51687	38	applied	\N	\N	\N	\N	227474	227474	394458
30165	51688	39	applied	\N	\N	\N	\N	227475	227475	394459
30169	51689	0	applied	\N	\N	\N	\N	227532	227532	394516
30169	51690	1	applied	\N	\N	\N	\N	227533	227533	394517
30169	51691	2	applied	\N	\N	\N	\N	227534	227534	394518
30169	51692	3	applied	\N	\N	\N	\N	227535	227535	394519
30169	51693	4	applied	\N	\N	\N	\N	227536	227536	394520
30169	51694	5	applied	\N	\N	\N	\N	227537	227537	394521
30169	51695	6	applied	\N	\N	\N	\N	227538	227538	394522
30180	51745	1	applied	\N	\N	\N	\N	227651	227651	394634
30180	51746	2	applied	\N	\N	\N	\N	227652	227652	394635
30180	51747	3	applied	\N	\N	\N	\N	227653	227653	394636
30180	51748	4	applied	\N	\N	\N	\N	227654	227654	394637
30180	51749	5	applied	\N	\N	\N	\N	227655	227655	394638
30180	51750	6	applied	\N	\N	\N	\N	227656	227656	394639
30180	51751	7	applied	\N	\N	\N	\N	227657	227657	394640
30182	51744	0	applied	\N	\N	\N	\N	227666	227666	394649
30182	51745	1	applied	\N	\N	\N	\N	227667	227667	394650
30182	51746	2	applied	\N	\N	\N	\N	227668	227668	394651
30182	51747	3	applied	\N	\N	\N	\N	227669	227669	394652
30187	51768	0	applied	\N	\N	\N	\N	227768	227768	394742
30187	51769	1	applied	\N	\N	\N	\N	227769	227769	394743
30187	51770	2	applied	\N	\N	\N	\N	227770	227770	394744
30187	51771	3	applied	\N	\N	\N	\N	227771	227771	394745
30187	51772	4	applied	\N	\N	\N	\N	227772	227772	394746
30187	51774	6	applied	\N	\N	\N	\N	227774	227774	394748
30187	51775	7	applied	\N	\N	\N	\N	227775	227775	394749
30200	51831	0	applied	\N	\N	\N	\N	227948	227948	394918
30200	51827	1	applied	\N	\N	\N	\N	227949	227949	394919
30200	51832	2	applied	\N	\N	\N	\N	227950	227950	394920
30200	51833	3	applied	\N	\N	\N	\N	227951	227951	394921
30200	51834	4	applied	\N	\N	\N	\N	227952	227952	394922
30200	51835	5	applied	\N	\N	\N	\N	227953	227953	394923
30200	51836	6	applied	\N	\N	\N	\N	227954	227954	394924
30200	51828	7	applied	\N	\N	\N	\N	227955	227955	394925
30200	51829	8	applied	\N	\N	\N	\N	227956	227956	394926
30200	51830	9	applied	\N	\N	\N	\N	227957	227957	394927
30200	51837	10	applied	\N	\N	\N	\N	227958	227958	394928
30200	51838	11	applied	\N	\N	\N	\N	227959	227959	394929
30200	51839	12	applied	\N	\N	\N	\N	227960	227960	394930
30200	51840	13	applied	\N	\N	\N	\N	227961	227961	394931
30200	51842	15	applied	\N	\N	\N	\N	227963	227963	394933
30200	51843	16	applied	\N	\N	\N	\N	227964	227964	394934
30200	51844	17	applied	\N	\N	\N	\N	227965	227965	394935
30200	51845	18	applied	\N	\N	\N	\N	227966	227966	394936
30200	51846	19	applied	\N	\N	\N	\N	227967	227967	394937
30202	51847	0	applied	\N	\N	\N	\N	227968	227968	394938
30202	51848	1	applied	\N	\N	\N	\N	227969	227969	394939
30202	51849	2	applied	\N	\N	\N	\N	227970	227970	394940
30202	51850	3	applied	\N	\N	\N	\N	227971	227971	394941
30202	51851	4	applied	\N	\N	\N	\N	227972	227972	394942
30202	51852	5	applied	\N	\N	\N	\N	227973	227973	394943
30202	51853	6	applied	\N	\N	\N	\N	227974	227974	394944
30202	51854	7	applied	\N	\N	\N	\N	227975	227975	394945
30202	51855	8	applied	\N	\N	\N	\N	227976	227976	394946
30202	51856	9	applied	\N	\N	\N	\N	227977	227977	394947
30202	51857	10	applied	\N	\N	\N	\N	227978	227978	394948
30202	51859	12	applied	\N	\N	\N	\N	227980	227980	394950
30202	51860	13	applied	\N	\N	\N	\N	227981	227981	394951
30202	51861	14	applied	\N	\N	\N	\N	227982	227982	394952
30202	51862	15	applied	\N	\N	\N	\N	227983	227983	394953
30202	51863	16	applied	\N	\N	\N	\N	227984	227984	394954
30202	51864	17	applied	\N	\N	\N	\N	227985	227985	394955
30202	51865	18	applied	\N	\N	\N	\N	227986	227986	394956
30202	51866	19	applied	\N	\N	\N	\N	227987	227987	394957
30202	51867	20	applied	\N	\N	\N	\N	227988	227988	394958
30204	51868	0	applied	\N	\N	\N	\N	228010	228010	394980
30204	51869	1	applied	\N	\N	\N	\N	228011	228011	394981
30204	51870	2	applied	\N	\N	\N	\N	228012	228012	394982
30204	51871	3	applied	\N	\N	\N	\N	228013	228013	394983
30204	51872	4	applied	\N	\N	\N	\N	228014	228014	394984
30204	51873	5	applied	\N	\N	\N	\N	228015	228015	394985
30164	51676	26	applied	\N	\N	\N	\N	227424	227424	394408
30164	51677	27	applied	\N	\N	\N	\N	227425	227425	394409
30173	51707	1	applied	\N	\N	\N	\N	227566	227566	394550
30173	51708	2	applied	\N	\N	\N	\N	227567	227567	394551
30173	51709	3	applied	\N	\N	\N	\N	227568	227568	394552
30173	51710	4	applied	\N	\N	\N	\N	227569	227569	394553
30173	51711	5	applied	\N	\N	\N	\N	227570	227570	394554
30173	51712	6	applied	\N	\N	\N	\N	227571	227571	394555
30173	51713	7	applied	\N	\N	\N	\N	227572	227572	394556
30173	51714	8	applied	\N	\N	\N	\N	227573	227573	394557
30175	51715	0	applied	\N	\N	\N	\N	227583	227583	394567
30175	51716	1	applied	\N	\N	\N	\N	227584	227584	394568
30175	51717	2	applied	\N	\N	\N	\N	227585	227585	394569
30175	51719	4	applied	\N	\N	1000000000	\N	227587	227587	394571
30175	51720	5	applied	\N	\N	\N	\N	227588	227588	394572
30175	51721	6	applied	\N	\N	\N	\N	227589	227589	394573
30175	51722	7	applied	\N	\N	\N	\N	227590	227590	394574
30175	51723	8	applied	\N	\N	\N	\N	227591	227591	394575
30175	51724	9	applied	\N	\N	\N	\N	227592	227592	394576
30177	51725	0	applied	\N	\N	\N	\N	227602	227602	394585
30177	51726	1	applied	\N	\N	\N	\N	227603	227603	394586
30177	51727	2	applied	\N	\N	\N	\N	227604	227604	394587
30177	51728	3	applied	\N	\N	\N	\N	227605	227605	394588
30177	51729	4	applied	\N	\N	\N	\N	227606	227606	394589
30177	51730	5	applied	\N	\N	\N	\N	227607	227607	394590
30177	51731	6	applied	\N	\N	\N	\N	227608	227608	394591
30177	51732	7	applied	\N	\N	\N	\N	227609	227609	394592
30177	51733	8	applied	\N	\N	\N	\N	227610	227610	394593
30177	51734	9	applied	\N	\N	\N	\N	227611	227611	394594
30177	51736	11	applied	\N	\N	\N	\N	227613	227613	394596
30177	51737	12	applied	\N	\N	\N	\N	227614	227614	394597
30177	51738	13	applied	\N	\N	\N	\N	227615	227615	394598
30177	51739	14	applied	\N	\N	\N	\N	227616	227616	394599
30177	51740	15	applied	\N	\N	\N	\N	227617	227617	394600
30177	51741	16	applied	\N	\N	\N	\N	227618	227618	394601
30177	51742	17	applied	\N	\N	\N	\N	227619	227619	394602
30177	51743	18	applied	\N	\N	\N	\N	227620	227620	394603
30179	51725	0	applied	\N	\N	\N	\N	227631	227631	394614
30179	51726	1	applied	\N	\N	\N	\N	227632	227632	394615
30179	51727	2	applied	\N	\N	\N	\N	227633	227633	394616
30179	51728	3	applied	\N	\N	\N	\N	227634	227634	394617
30179	51729	4	applied	\N	\N	\N	\N	227635	227635	394618
30179	51730	5	applied	\N	\N	\N	\N	227636	227636	394619
30179	51731	6	applied	\N	\N	\N	\N	227637	227637	394620
30179	51732	7	applied	\N	\N	\N	\N	227638	227638	394621
30179	51734	9	applied	\N	\N	\N	\N	227640	227640	394623
30179	51735	10	applied	\N	\N	\N	\N	227641	227641	394624
30179	51736	11	applied	\N	\N	\N	\N	227642	227642	394625
30179	51737	12	applied	\N	\N	\N	\N	227643	227643	394626
30179	51738	13	applied	\N	\N	\N	\N	227644	227644	394627
30179	51739	14	applied	\N	\N	\N	\N	227645	227645	394628
30179	51740	15	applied	\N	\N	\N	\N	227646	227646	394629
30179	51741	16	applied	\N	\N	\N	\N	227647	227647	394630
30179	51742	17	applied	\N	\N	\N	\N	227648	227648	394631
30179	51743	18	applied	\N	\N	\N	\N	227649	227649	394632
30181	51744	0	applied	\N	\N	\N	\N	227658	227658	394641
30181	51745	1	applied	\N	\N	\N	\N	227659	227659	394642
30181	51746	2	applied	\N	\N	\N	\N	227660	227660	394643
30181	51747	3	applied	\N	\N	\N	\N	227661	227661	394644
30181	51748	4	applied	\N	\N	\N	\N	227662	227662	394645
30181	51749	5	applied	\N	\N	\N	\N	227663	227663	394646
30181	51751	7	applied	\N	\N	\N	\N	227665	227665	394648
30185	48540	27	applied	\N	\N	\N	\N	227714	227714	394693
30185	48677	28	applied	\N	\N	\N	\N	227715	227715	227715
30185	49097	29	applied	\N	\N	\N	\N	227716	227716	394694
30185	49098	30	applied	\N	\N	\N	\N	227717	227717	394695
30185	48584	31	applied	\N	\N	1000000000	\N	227718	227718	394696
30185	48967	32	applied	\N	\N	\N	\N	227719	227719	394697
30185	51719	33	applied	\N	\N	1000000000	\N	227720	227720	394698
30185	48905	34	applied	\N	\N	\N	\N	227721	227721	394699
30185	49320	35	applied	\N	\N	\N	\N	227722	227722	394700
30185	49321	36	applied	\N	\N	\N	\N	227723	227723	394701
30185	49322	37	applied	\N	\N	\N	\N	227724	227724	394702
30185	49323	38	applied	\N	\N	\N	\N	227725	227725	394703
30185	49324	39	applied	\N	\N	\N	\N	227726	227726	394704
30185	49325	40	applied	\N	\N	\N	\N	227727	227727	394705
30185	49326	41	applied	\N	\N	\N	\N	227728	227728	394706
30185	49328	43	applied	\N	\N	\N	\N	227730	227730	394708
30185	49342	44	applied	\N	\N	\N	\N	227731	227731	394709
30185	49343	45	applied	\N	\N	\N	\N	227732	227732	394710
30185	49344	46	applied	\N	\N	\N	\N	227733	227733	394711
30185	49345	47	applied	\N	\N	\N	\N	227734	227734	394712
30188	51768	0	applied	\N	\N	\N	\N	227776	227776	394750
30188	51769	1	applied	\N	\N	\N	\N	227777	227777	394751
30188	51776	2	applied	\N	\N	\N	\N	227778	227778	394752
30188	51770	3	applied	\N	\N	\N	\N	227779	227779	394753
30188	51777	4	applied	\N	\N	\N	\N	227780	227780	394754
30188	51778	5	applied	\N	\N	\N	\N	227781	227781	394755
30188	51771	6	applied	\N	\N	\N	\N	227782	227782	394756
30188	51772	7	applied	\N	\N	\N	\N	227783	227783	394757
30188	51773	8	applied	\N	\N	\N	\N	227784	227784	394758
30188	51774	9	applied	\N	\N	\N	\N	227785	227785	394759
30188	51775	10	applied	\N	\N	\N	\N	227786	227786	394760
30188	51780	12	applied	\N	\N	\N	\N	227788	227788	394762
30188	51781	13	applied	\N	\N	\N	\N	227789	227789	394763
30188	51782	14	applied	\N	\N	\N	\N	227790	227790	394764
30188	51783	16	applied	\N	\N	\N	\N	227791	227791	394765
30188	51784	17	applied	\N	\N	\N	\N	227792	227792	394766
30188	51785	18	applied	\N	\N	\N	\N	227793	227793	394767
30188	51786	19	applied	\N	\N	\N	\N	227794	227794	394768
30188	51787	20	applied	\N	\N	\N	\N	227795	227795	394769
30191	51788	0	applied	\N	\N	\N	\N	227827	227827	394801
30191	51789	1	applied	\N	\N	\N	\N	227828	227828	394802
30191	51790	2	applied	\N	\N	\N	\N	227829	227829	394803
30191	51791	3	applied	\N	\N	\N	\N	227830	227830	394804
30191	51792	4	applied	\N	\N	\N	\N	227831	227831	394805
30191	51793	5	applied	\N	\N	\N	\N	227832	227832	394806
30191	51794	6	applied	\N	\N	\N	\N	227833	227833	394807
30191	51795	7	applied	\N	\N	\N	\N	227834	227834	394808
30191	51797	9	applied	\N	\N	\N	\N	227836	227836	394810
30194	51798	0	applied	\N	\N	\N	\N	227871	227871	394844
30169	51697	8	applied	\N	\N	\N	\N	227540	227540	394524
30173	51706	0	applied	\N	\N	\N	\N	227565	227565	394549
30185	50277	51	applied	\N	\N	\N	\N	227738	227738	227738
30185	51520	53	applied	\N	\N	1000000000	\N	227740	227740	394715
30185	50299	54	applied	\N	\N	\N	\N	227741	227741	227741
30185	48795	55	applied	\N	\N	\N	\N	227742	227742	394716
30185	49103	56	applied	\N	\N	\N	\N	227743	227743	394717
30185	49104	57	applied	\N	\N	\N	\N	227744	227744	394718
30185	49105	58	applied	\N	\N	\N	\N	227745	227745	394719
30185	49106	59	applied	\N	\N	\N	\N	227746	227746	394720
30185	49107	60	applied	\N	\N	\N	\N	227747	227747	394721
30185	49108	61	applied	\N	\N	\N	\N	227748	227748	394722
30185	49109	62	applied	\N	\N	\N	\N	227749	227749	394723
30185	49113	64	applied	\N	\N	\N	\N	227750	227750	394724
30185	49118	65	applied	\N	\N	\N	\N	227751	227751	394725
30185	49119	66	applied	\N	\N	\N	\N	227752	227752	394726
30185	51598	67	applied	\N	\N	\N	\N	227753	227753	394727
30185	51613	68	applied	\N	\N	\N	\N	227754	227754	394728
30185	49123	69	applied	\N	\N	\N	\N	227755	227755	394729
30185	49363	71	applied	\N	\N	\N	\N	227757	227757	394731
30185	49364	72	applied	\N	\N	\N	\N	227758	227758	394732
30185	49365	73	applied	\N	\N	\N	\N	227759	227759	394733
30185	49366	74	applied	\N	\N	\N	\N	227760	227760	394734
30189	51768	0	applied	\N	\N	\N	\N	227796	227796	394770
30189	51769	1	applied	\N	\N	\N	\N	227797	227797	394771
30189	51776	2	applied	\N	\N	\N	\N	227798	227798	394772
30189	51770	3	applied	\N	\N	\N	\N	227799	227799	394773
30189	51771	4	applied	\N	\N	\N	\N	227800	227800	394774
30189	51772	5	applied	\N	\N	\N	\N	227801	227801	394775
30189	51773	6	applied	\N	\N	\N	\N	227802	227802	394776
30189	51774	7	applied	\N	\N	\N	\N	227803	227803	394777
30189	51775	8	applied	\N	\N	\N	\N	227804	227804	394778
30189	51779	9	applied	\N	\N	\N	\N	227805	227805	394779
30189	51780	10	applied	\N	\N	\N	\N	227806	227806	394780
30190	51768	0	applied	\N	\N	\N	\N	227807	227807	394781
30190	51776	2	applied	\N	\N	\N	\N	227809	227809	394783
30190	51770	3	applied	\N	\N	\N	\N	227810	227810	394784
30190	51777	4	applied	\N	\N	\N	\N	227811	227811	394785
30190	51778	5	applied	\N	\N	\N	\N	227812	227812	394786
30190	51771	6	applied	\N	\N	\N	\N	227813	227813	394787
30190	51772	7	applied	\N	\N	\N	\N	227814	227814	394788
30190	51773	8	applied	\N	\N	\N	\N	227815	227815	394789
30190	51774	9	applied	\N	\N	\N	\N	227816	227816	394790
30190	51775	10	applied	\N	\N	\N	\N	227817	227817	394791
30190	51779	11	applied	\N	\N	\N	\N	227818	227818	394792
30190	51780	12	applied	\N	\N	\N	\N	227819	227819	394793
30190	51781	13	applied	\N	\N	\N	\N	227820	227820	394794
30190	51782	14	applied	\N	\N	\N	\N	227821	227821	394795
30190	51783	16	applied	\N	\N	\N	\N	227822	227822	394796
30190	51784	17	applied	\N	\N	\N	\N	227823	227823	394797
30190	51785	18	applied	\N	\N	\N	\N	227824	227824	394798
30190	51787	20	applied	\N	\N	\N	\N	227826	227826	394800
30192	51788	0	applied	\N	\N	\N	\N	227837	227837	394811
30192	51789	1	applied	\N	\N	\N	\N	227838	227838	394812
30192	51790	2	applied	\N	\N	\N	\N	227839	227839	394813
30192	51791	3	applied	\N	\N	\N	\N	227840	227840	394814
30192	51792	4	applied	\N	\N	\N	\N	227841	227841	394815
30192	51793	5	applied	\N	\N	\N	\N	227842	227842	394816
30192	51794	6	applied	\N	\N	\N	\N	227843	227843	394817
30192	51795	7	applied	\N	\N	\N	\N	227844	227844	394818
30192	51796	8	applied	\N	\N	\N	\N	227845	227845	394819
30192	51797	9	applied	\N	\N	\N	\N	227846	227846	394820
30193	51803	5	applied	\N	\N	\N	\N	227852	227852	394826
30193	51804	6	applied	\N	\N	\N	\N	227853	227853	394827
30193	51805	7	applied	\N	\N	\N	\N	227854	227854	394828
30193	51806	8	applied	\N	\N	\N	\N	227855	227855	394829
30193	51808	10	applied	\N	\N	\N	\N	227857	227857	394830
30193	51809	11	applied	\N	\N	\N	\N	227858	227858	394831
30193	51810	12	applied	\N	\N	\N	\N	227859	227859	394832
30193	51811	13	applied	\N	\N	\N	\N	227860	227860	394833
30193	51812	14	applied	\N	\N	\N	\N	227861	227861	394834
30193	51813	15	applied	\N	\N	\N	\N	227862	227862	394835
30193	51814	16	applied	\N	\N	\N	\N	227863	227863	394836
30193	51815	17	applied	\N	\N	\N	\N	227864	227864	394837
30193	51816	18	applied	\N	\N	\N	\N	227865	227865	394838
30193	51817	19	applied	\N	\N	\N	\N	227866	227866	394839
30193	51818	20	applied	\N	\N	\N	\N	227867	227867	394840
30193	51819	21	applied	\N	\N	\N	\N	227868	227868	394841
30193	51820	22	applied	\N	\N	\N	\N	227869	227869	394842
30193	51821	23	applied	\N	\N	\N	\N	227870	227870	394843
30195	51798	0	applied	\N	\N	\N	\N	227883	227883	394855
30195	51799	1	applied	\N	\N	\N	\N	227884	227884	394856
30197	51822	0	applied	\N	\N	\N	\N	227912	227912	394883
30197	51823	1	applied	\N	\N	\N	\N	227913	227913	394884
30197	51827	2	applied	\N	\N	\N	\N	227914	227914	394885
30197	51828	3	applied	\N	\N	\N	\N	227915	227915	394886
30197	51829	4	applied	\N	\N	\N	\N	227916	227916	394887
30197	51830	5	applied	\N	\N	\N	\N	227917	227917	394888
30197	51824	6	applied	\N	\N	\N	\N	227918	227918	394889
30197	51825	7	applied	\N	\N	\N	\N	227919	227919	394890
30197	51826	8	applied	\N	\N	\N	\N	227920	227920	394891
30211	51880	1	applied	\N	\N	\N	\N	228202	228202	395171
30211	51881	2	applied	\N	\N	\N	\N	228203	228203	395172
30211	51870	3	applied	\N	\N	\N	\N	228204	228204	395173
30211	51871	4	applied	\N	\N	\N	\N	228205	228205	395174
30211	51872	5	applied	\N	\N	\N	\N	228206	228206	395175
30211	51873	6	applied	\N	\N	\N	\N	228207	228207	395176
30211	51882	7	applied	\N	\N	\N	\N	228208	228208	395177
30211	51875	8	applied	\N	\N	\N	\N	228209	228209	395178
30211	51876	9	applied	\N	\N	\N	\N	228210	228210	395179
30211	51877	10	applied	\N	\N	\N	\N	228211	228211	395180
30211	51883	11	applied	\N	\N	\N	\N	228212	228212	395181
30211	51878	12	applied	\N	\N	\N	\N	228213	228213	395182
30211	51879	13	applied	\N	\N	\N	\N	228214	228214	395183
30211	51884	14	applied	\N	\N	1000000000	\N	228215	228215	395184
30211	51886	16	applied	\N	\N	1000000000	\N	228217	228217	395186
30211	51887	17	applied	\N	\N	\N	\N	228218	228218	395187
30211	51888	18	applied	\N	\N	\N	\N	228219	228219	395188
30211	51889	20	applied	\N	\N	\N	\N	228220	228220	395189
30211	51890	21	applied	\N	\N	\N	\N	228221	228221	395190
30211	51891	22	applied	\N	\N	\N	\N	228222	228222	395191
30185	49347	49	applied	\N	\N	\N	\N	227736	227736	394714
30185	50273	50	applied	\N	\N	\N	\N	227737	227737	227737
30194	51810	7	applied	\N	\N	\N	\N	227878	227878	394850
30194	51807	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	227877	227877	\N
30194	51811	8	applied	\N	\N	\N	\N	227879	227879	394851
30194	51818	9	applied	\N	\N	\N	\N	227880	227880	394852
30194	51819	10	applied	\N	\N	\N	\N	227881	227881	394853
30194	51820	11	applied	\N	\N	\N	\N	227882	227882	394854
30195	51800	2	applied	\N	\N	\N	\N	227885	227885	394857
30195	51801	3	applied	\N	\N	\N	\N	227886	227886	394858
30195	51802	4	applied	\N	\N	\N	\N	227887	227887	394859
30195	51803	5	applied	\N	\N	\N	\N	227888	227888	394860
30195	51804	6	applied	\N	\N	\N	\N	227889	227889	394861
30195	51805	7	applied	\N	\N	\N	\N	227890	227890	394862
30195	51806	8	applied	\N	\N	\N	\N	227891	227891	394863
30195	51808	10	applied	\N	\N	\N	\N	227893	227893	394864
30195	51809	11	applied	\N	\N	\N	\N	227894	227894	394865
30195	51810	12	applied	\N	\N	\N	\N	227895	227895	394866
30195	51811	13	applied	\N	\N	\N	\N	227896	227896	394867
30195	51812	14	applied	\N	\N	\N	\N	227897	227897	394868
30195	51813	15	applied	\N	\N	\N	\N	227898	227898	394869
30195	51814	16	applied	\N	\N	\N	\N	227899	227899	394870
30195	51815	17	applied	\N	\N	\N	\N	227900	227900	394871
30195	51816	18	applied	\N	\N	\N	\N	227901	227901	394872
30195	51817	19	applied	\N	\N	\N	\N	227902	227902	394873
30195	51818	20	applied	\N	\N	\N	\N	227903	227903	394874
30195	51819	21	applied	\N	\N	\N	\N	227904	227904	394875
30195	51820	22	applied	\N	\N	\N	\N	227905	227905	394876
30195	51821	23	applied	\N	\N	\N	\N	227906	227906	394877
30196	51822	0	applied	\N	\N	\N	\N	227907	227907	394878
30196	51823	1	applied	\N	\N	\N	\N	227908	227908	394879
30196	51824	2	applied	\N	\N	\N	\N	227909	227909	394880
30196	51825	3	applied	\N	\N	\N	\N	227910	227910	394881
30196	51826	4	applied	\N	\N	\N	\N	227911	227911	394882
30198	51788	0	applied	\N	\N	\N	\N	227921	227921	394892
30198	51800	1	applied	\N	\N	\N	\N	227922	227922	394893
30198	51811	3	applied	\N	\N	\N	\N	227924	227924	394894
30198	51818	4	applied	\N	\N	\N	\N	227925	227925	394895
30199	51831	0	applied	\N	\N	\N	\N	227928	227928	394898
30199	51827	1	applied	\N	\N	\N	\N	227929	227929	394899
30199	51832	2	applied	\N	\N	\N	\N	227930	227930	394900
30199	51833	3	applied	\N	\N	\N	\N	227931	227931	394901
30199	51834	4	applied	\N	\N	\N	\N	227932	227932	394902
30199	51835	5	applied	\N	\N	\N	\N	227933	227933	394903
30199	51836	6	applied	\N	\N	\N	\N	227934	227934	394904
30199	51828	7	applied	\N	\N	\N	\N	227935	227935	394905
30199	51829	8	applied	\N	\N	\N	\N	227936	227936	394906
30199	51830	9	applied	\N	\N	\N	\N	227937	227937	394907
30199	51837	10	applied	\N	\N	\N	\N	227938	227938	394908
30199	51838	11	applied	\N	\N	\N	\N	227939	227939	394909
30199	51839	12	applied	\N	\N	\N	\N	227940	227940	394910
30199	51840	13	applied	\N	\N	\N	\N	227941	227941	394911
30199	51841	14	applied	\N	\N	\N	\N	227942	227942	394912
30199	51842	15	applied	\N	\N	\N	\N	227943	227943	394913
30199	51843	16	applied	\N	\N	\N	\N	227944	227944	394914
30199	51844	17	applied	\N	\N	\N	\N	227945	227945	394915
30199	51845	18	applied	\N	\N	\N	\N	227946	227946	394916
30199	51846	19	applied	\N	\N	\N	\N	227947	227947	394917
30213	51869	0	applied	\N	\N	\N	\N	228233	228233	395202
30213	51880	1	applied	\N	\N	\N	\N	228234	228234	395203
30213	51881	2	applied	\N	\N	\N	\N	228235	228235	395204
30213	51870	3	applied	\N	\N	\N	\N	228236	228236	395205
30213	51871	4	applied	\N	\N	\N	\N	228237	228237	395206
30213	51873	6	applied	\N	\N	\N	\N	228239	228239	395208
30213	51882	7	applied	\N	\N	\N	\N	228240	228240	395209
30213	51875	8	applied	\N	\N	\N	\N	228241	228241	395210
30213	51876	9	applied	\N	\N	\N	\N	228242	228242	395211
30213	51877	10	applied	\N	\N	\N	\N	228243	228243	395212
30213	51883	11	applied	\N	\N	\N	\N	228244	228244	395213
30213	51878	12	applied	\N	\N	\N	\N	228245	228245	395214
30213	51879	13	applied	\N	\N	\N	\N	228246	228246	395215
30213	51884	14	applied	\N	\N	1000000000	\N	228247	228247	395216
30213	51885	15	applied	\N	\N	1000000000	\N	228248	228248	395217
30213	51886	16	applied	\N	\N	1000000000	\N	228249	228249	395218
30213	51887	17	applied	\N	\N	\N	\N	228250	228250	395219
30213	51888	18	applied	\N	\N	\N	\N	228251	228251	395220
30213	51889	20	applied	\N	\N	\N	\N	228252	228252	395221
30213	51890	21	applied	\N	\N	\N	\N	228253	228253	395222
30213	51891	22	applied	\N	\N	\N	\N	228254	228254	395223
30213	51893	24	applied	\N	\N	\N	\N	228256	228256	395225
30213	51894	25	applied	\N	\N	\N	\N	228257	228257	395226
30213	51895	26	applied	\N	\N	\N	\N	228258	228258	395227
30213	51896	27	applied	\N	\N	\N	\N	228259	228259	395228
30213	51897	28	applied	\N	\N	\N	\N	228260	228260	395229
30213	51898	29	applied	\N	\N	\N	\N	228261	228261	395230
30213	51899	30	applied	\N	\N	\N	\N	228262	228262	395231
30213	51900	31	applied	\N	\N	\N	\N	228263	228263	395232
30213	51901	32	applied	\N	\N	\N	\N	228264	228264	395233
30213	51902	33	applied	\N	\N	\N	\N	228265	228265	395234
30214	51869	0	applied	\N	\N	\N	\N	228266	228266	395235
30214	51880	1	applied	\N	\N	\N	\N	228267	228267	395236
30214	51881	2	applied	\N	\N	\N	\N	228268	228268	395237
30214	51870	3	applied	\N	\N	\N	\N	228269	228269	395238
30214	51871	4	applied	\N	\N	\N	\N	228270	228270	395239
30214	51872	5	applied	\N	\N	\N	\N	228271	228271	395240
30214	51882	7	applied	\N	\N	\N	\N	228273	228273	395242
30214	51875	8	applied	\N	\N	\N	\N	228274	228274	395243
30214	51876	9	applied	\N	\N	\N	\N	228275	228275	395244
30214	51877	10	applied	\N	\N	\N	\N	228276	228276	395245
30214	51883	11	applied	\N	\N	\N	\N	228277	228277	395246
30214	51878	12	applied	\N	\N	\N	\N	228278	228278	395247
30214	51879	13	applied	\N	\N	\N	\N	228279	228279	395248
30214	51884	14	applied	\N	\N	1000000000	\N	228280	228280	395249
30214	51885	15	applied	\N	\N	1000000000	\N	228281	228281	395250
30214	51886	16	applied	\N	\N	1000000000	\N	228282	228282	395251
30214	51887	17	applied	\N	\N	\N	\N	228283	228283	395252
30214	51888	18	applied	\N	\N	\N	\N	228284	228284	395253
30214	51889	20	applied	\N	\N	\N	\N	228285	228285	395254
30214	51890	21	applied	\N	\N	\N	\N	228286	228286	395255
30214	51891	22	applied	\N	\N	\N	\N	228287	228287	395256
30194	51802	3	applied	\N	\N	\N	\N	227874	227874	394847
30194	51806	5	applied	\N	\N	\N	\N	227876	227876	394849
30203	51849	2	applied	\N	\N	\N	\N	227991	227991	394961
30203	51850	3	applied	\N	\N	\N	\N	227992	227992	394962
30203	51851	4	applied	\N	\N	\N	\N	227993	227993	394963
30203	51852	5	applied	\N	\N	\N	\N	227994	227994	394964
30203	51853	6	applied	\N	\N	\N	\N	227995	227995	394965
30203	51854	7	applied	\N	\N	\N	\N	227996	227996	394966
30203	51855	8	applied	\N	\N	\N	\N	227997	227997	394967
30203	51856	9	applied	\N	\N	\N	\N	227998	227998	394968
30203	51857	10	applied	\N	\N	\N	\N	227999	227999	394969
30203	51858	11	applied	\N	\N	\N	\N	228000	228000	394970
30203	51859	12	applied	\N	\N	\N	\N	228001	228001	394971
30203	51860	13	applied	\N	\N	\N	\N	228002	228002	394972
30203	51861	14	applied	\N	\N	\N	\N	228003	228003	394973
30203	51862	15	applied	\N	\N	\N	\N	228004	228004	394974
30203	51863	16	applied	\N	\N	\N	\N	228005	228005	394975
30203	51865	18	applied	\N	\N	\N	\N	228007	228007	394977
30203	51866	19	applied	\N	\N	\N	\N	228008	228008	394978
30203	51867	20	applied	\N	\N	\N	\N	228009	228009	394979
30204	51875	7	applied	\N	\N	\N	\N	228017	228017	394987
30204	51876	8	applied	\N	\N	\N	\N	228018	228018	394988
30204	51877	9	applied	\N	\N	\N	\N	228019	228019	394989
30204	51878	10	applied	\N	\N	\N	\N	228020	228020	394990
30204	51879	11	applied	\N	\N	\N	\N	228021	228021	394991
30205	51868	0	applied	\N	\N	\N	\N	228022	228022	394992
30205	51869	1	applied	\N	\N	\N	\N	228023	228023	394993
30205	51870	2	applied	\N	\N	\N	\N	228024	228024	394994
30205	51871	3	applied	\N	\N	\N	\N	228025	228025	394995
30205	51872	4	applied	\N	\N	\N	\N	228026	228026	394996
30205	51873	5	applied	\N	\N	\N	\N	228027	228027	394997
30205	51875	7	applied	\N	\N	\N	\N	228029	228029	394999
30205	51876	8	applied	\N	\N	\N	\N	228030	228030	395000
30205	51877	9	applied	\N	\N	\N	\N	228031	228031	395001
30205	51878	10	applied	\N	\N	\N	\N	228032	228032	395002
30205	51879	11	applied	\N	\N	\N	\N	228033	228033	395003
30206	51868	0	applied	\N	\N	\N	\N	228034	228034	395004
30206	51869	1	applied	\N	\N	\N	\N	228035	228035	395005
30206	51870	2	applied	\N	\N	\N	\N	228036	228036	395006
30206	51871	3	applied	\N	\N	\N	\N	228037	228037	395007
30206	51872	4	applied	\N	\N	\N	\N	228038	228038	395008
30206	51873	5	applied	\N	\N	\N	\N	228039	228039	395009
30206	51874	6	applied	\N	\N	1000000000	\N	228040	228040	395010
30206	51875	7	applied	\N	\N	\N	\N	228041	228041	395011
30206	51876	8	applied	\N	\N	\N	\N	228042	228042	395012
30206	51877	9	applied	\N	\N	\N	\N	228043	228043	395013
30206	51878	10	applied	\N	\N	\N	\N	228044	228044	395014
30206	51879	11	applied	\N	\N	\N	\N	228045	228045	395015
30207	51788	0	applied	\N	\N	\N	\N	228046	228046	395016
30207	51536	1	applied	\N	\N	\N	\N	228047	228047	395017
30207	51546	2	applied	\N	\N	\N	\N	228048	228048	395018
30207	51564	4	applied	\N	\N	\N	\N	228050	228050	395020
30207	51565	5	applied	\N	\N	\N	\N	228051	228051	395021
30207	51566	6	applied	\N	\N	\N	\N	228052	228052	395022
30207	51567	7	applied	\N	\N	\N	\N	228053	228053	395023
30207	51568	8	applied	\N	\N	\N	\N	228054	228054	395024
30207	51614	9	applied	\N	\N	\N	\N	228055	228055	395025
30207	51623	10	applied	\N	\N	\N	\N	228056	228056	395026
30207	51631	11	applied	\N	\N	\N	\N	228057	228057	395027
30207	51639	12	applied	\N	\N	\N	\N	228058	228058	395028
30207	51650	13	applied	\N	\N	\N	\N	228059	228059	395029
30207	51651	14	applied	\N	\N	\N	\N	228060	228060	395030
30207	51652	15	applied	\N	\N	\N	\N	228061	228061	395031
30207	51653	16	applied	\N	\N	\N	\N	228062	228062	395032
30207	51689	17	applied	\N	\N	\N	\N	228063	228063	395033
30207	51698	18	applied	\N	\N	\N	\N	228064	228064	395034
30207	51706	19	applied	\N	\N	\N	\N	228065	228065	395035
30207	51725	21	applied	\N	\N	\N	\N	228067	228067	395037
30207	51726	22	applied	\N	\N	\N	\N	228068	228068	395038
30207	51769	27	applied	\N	\N	\N	\N	228073	228073	395043
30207	51789	28	applied	\N	\N	\N	\N	228074	228074	395044
30207	51831	29	applied	\N	\N	\N	\N	228075	228075	395045
30207	51848	30	applied	\N	\N	\N	\N	228076	228076	395046
30207	51849	31	applied	\N	\N	\N	\N	228077	228077	395047
30207	51869	32	applied	\N	\N	\N	\N	228078	228078	395048
30207	51800	33	applied	\N	\N	\N	\N	228079	228079	395049
30207	51537	34	applied	\N	\N	\N	\N	228080	228080	395050
30207	51538	36	applied	\N	\N	\N	\N	228081	228081	395051
30207	51719	37	applied	\N	\N	1000000000	\N	228082	228082	395052
30207	51798	38	applied	\N	\N	\N	\N	228083	228083	395053
30207	51799	39	applied	\N	\N	\N	\N	228084	228084	395054
30207	51847	40	applied	\N	\N	\N	\N	228085	228085	395055
30207	51868	41	applied	\N	\N	\N	\N	228086	228086	395056
30207	51874	43	applied	\N	\N	1000000000	\N	228088	228088	395057
30207	51807	42	failed	Amount_insufficient_to_create_account	\N	\N	\N	228087	228087	\N
30207	51539	44	applied	\N	\N	\N	\N	228089	228089	395058
30207	51540	45	applied	\N	\N	\N	\N	228090	228090	395059
30207	51547	46	applied	\N	\N	\N	\N	228091	228091	395060
30207	51548	47	applied	\N	\N	\N	\N	228092	228092	395061
30207	51555	48	applied	\N	\N	\N	\N	228093	228093	395062
30207	51811	49	applied	\N	\N	\N	\N	228094	228094	395063
30207	51541	50	applied	\N	\N	\N	\N	228095	228095	395064
30207	51542	51	applied	\N	\N	\N	\N	228096	228096	395065
30207	51543	52	applied	\N	\N	\N	\N	228097	228097	395066
30207	51544	53	applied	\N	\N	\N	\N	228098	228098	395067
30207	51545	54	applied	\N	\N	\N	\N	228099	228099	395068
30207	51549	55	applied	\N	\N	\N	\N	228100	228100	395069
30207	51550	56	applied	\N	\N	\N	\N	228101	228101	395070
30207	51551	57	applied	\N	\N	\N	\N	228102	228102	395071
30207	51552	58	applied	\N	\N	\N	\N	228103	228103	395072
30207	51556	59	applied	\N	\N	\N	\N	228104	228104	395073
30207	51557	60	applied	\N	\N	\N	\N	228105	228105	395074
30207	51558	61	applied	\N	\N	\N	\N	228106	228106	395075
30207	51559	62	applied	\N	\N	\N	\N	228107	228107	395076
30208	51868	0	applied	\N	\N	\N	\N	228166	228166	395135
30208	51874	1	applied	\N	\N	1000000000	\N	228167	228167	395136
30210	51869	0	applied	\N	\N	\N	\N	228168	228168	395137
30210	51880	1	applied	\N	\N	\N	\N	228169	228169	395138
30210	51881	2	applied	\N	\N	\N	\N	228170	228170	395139
30198	51820	6	applied	\N	\N	\N	\N	227927	227927	394897
30203	51848	1	applied	\N	\N	\N	\N	227990	227990	394960
30207	51573	66	applied	\N	\N	\N	\N	228111	228111	395080
30207	51574	67	applied	\N	\N	\N	\N	228112	228112	395081
30207	51575	68	applied	\N	\N	\N	\N	228113	228113	395082
30207	51576	69	applied	\N	\N	\N	\N	228114	228114	395083
30207	51577	70	applied	\N	\N	\N	\N	228115	228115	395084
30207	51578	71	applied	\N	\N	\N	\N	228116	228116	395085
30207	51579	72	applied	\N	\N	\N	\N	228117	228117	395086
30207	51580	73	applied	\N	\N	\N	\N	228118	228118	395087
30207	51581	74	applied	\N	\N	\N	\N	228119	228119	395088
30207	51563	76	applied	\N	\N	\N	\N	228121	228121	395090
30207	51569	77	applied	\N	\N	\N	\N	228122	228122	395091
30207	51572	78	applied	\N	\N	\N	\N	228123	228123	395092
30207	51583	79	applied	\N	\N	\N	\N	228124	228124	395093
30207	51584	80	applied	\N	\N	\N	\N	228125	228125	395094
30207	51585	81	applied	\N	\N	\N	\N	228126	228126	395095
30207	51586	82	applied	\N	\N	\N	\N	228127	228127	395096
30207	51587	83	applied	\N	\N	\N	\N	228128	228128	395097
30207	51588	84	applied	\N	\N	\N	\N	228129	228129	395098
30210	51870	3	applied	\N	\N	\N	\N	228171	228171	395140
30210	51871	4	applied	\N	\N	\N	\N	228172	228172	395141
30210	51872	5	applied	\N	\N	\N	\N	228173	228173	395142
30210	51873	6	applied	\N	\N	\N	\N	228174	228174	395143
30210	51882	7	applied	\N	\N	\N	\N	228175	228175	395144
30210	51875	8	applied	\N	\N	\N	\N	228176	228176	395145
30210	51876	9	applied	\N	\N	\N	\N	228177	228177	395146
30210	51883	11	applied	\N	\N	\N	\N	228179	228179	395148
30210	51878	12	applied	\N	\N	\N	\N	228180	228180	395149
30210	51879	13	applied	\N	\N	\N	\N	228181	228181	395150
30210	51884	14	applied	\N	\N	1000000000	\N	228182	228182	395151
30210	51885	15	applied	\N	\N	1000000000	\N	228183	228183	395152
30210	51886	16	applied	\N	\N	1000000000	\N	228184	228184	395153
30210	51887	17	applied	\N	\N	\N	\N	228185	228185	395154
30210	51888	18	applied	\N	\N	\N	\N	228186	228186	395155
30210	51889	20	applied	\N	\N	\N	\N	228187	228187	395156
30210	51890	21	applied	\N	\N	\N	\N	228188	228188	395157
30210	51891	22	applied	\N	\N	\N	\N	228189	228189	395158
30210	51892	23	applied	\N	\N	\N	\N	228190	228190	395159
30210	51893	24	applied	\N	\N	\N	\N	228191	228191	395160
30210	51894	25	applied	\N	\N	\N	\N	228192	228192	395161
30210	51895	26	applied	\N	\N	\N	\N	228193	228193	395162
30210	51896	27	applied	\N	\N	\N	\N	228194	228194	395163
30210	51898	29	applied	\N	\N	\N	\N	228196	228196	395165
30210	51899	30	applied	\N	\N	\N	\N	228197	228197	395166
30210	51900	31	applied	\N	\N	\N	\N	228198	228198	395167
30210	51901	32	applied	\N	\N	\N	\N	228199	228199	395168
30210	51902	33	applied	\N	\N	\N	\N	228200	228200	395169
30217	51903	0	applied	\N	\N	\N	\N	228319	228319	395288
30217	51904	1	applied	\N	\N	\N	\N	228320	228320	395289
30217	51905	2	applied	\N	\N	\N	\N	228321	228321	395290
30217	51908	3	applied	\N	\N	\N	\N	228322	228322	395291
30217	51902	4	applied	\N	\N	\N	\N	228323	228323	395292
30217	51906	5	applied	\N	\N	\N	\N	228324	228324	395293
30217	51907	6	applied	\N	\N	\N	\N	228325	228325	395294
30217	51909	7	applied	\N	\N	\N	\N	228326	228326	395295
30217	51910	8	applied	\N	\N	\N	\N	228327	228327	395296
30217	51912	9	applied	\N	\N	\N	\N	228328	228328	395297
30220	51903	0	applied	\N	\N	\N	\N	228350	228350	395319
30220	51905	2	applied	\N	\N	\N	\N	228352	228352	395321
30220	51906	3	applied	\N	\N	\N	\N	228353	228353	395322
30220	51907	4	applied	\N	\N	\N	\N	228354	228354	395323
30220	51908	5	applied	\N	\N	\N	\N	228355	228355	395324
30220	51909	6	applied	\N	\N	\N	\N	228356	228356	395325
30220	51910	7	applied	\N	\N	\N	\N	228357	228357	395326
30220	51911	8	applied	\N	\N	\N	\N	228358	228358	395327
30220	51912	9	applied	\N	\N	\N	\N	228359	228359	395328
30223	51186	0	applied	\N	\N	\N	\N	228377	228377	395346
30223	51187	1	applied	\N	\N	\N	\N	228378	228378	395347
30223	50725	2	applied	\N	\N	\N	\N	228379	228379	395348
30223	51365	3	applied	\N	\N	1000000000	\N	228380	228380	395349
30223	51788	4	applied	\N	\N	\N	\N	228381	228381	395350
30223	50734	5	applied	\N	\N	\N	\N	228382	228382	395351
30223	50743	6	applied	\N	\N	\N	\N	228383	228383	395352
30223	50744	7	applied	\N	\N	\N	\N	228384	228384	395353
30223	50773	9	applied	\N	\N	\N	\N	228386	228386	395355
30223	50782	10	applied	\N	\N	\N	\N	228387	228387	395356
30223	50783	11	applied	\N	\N	\N	\N	228388	228388	395357
30223	50784	12	applied	\N	\N	\N	\N	228389	228389	395358
30223	50811	13	applied	\N	\N	\N	\N	228390	228390	395359
30223	50820	14	applied	\N	\N	\N	\N	228391	228391	395360
30223	50829	15	applied	\N	\N	\N	\N	228392	228392	395361
30223	50838	16	applied	\N	\N	\N	\N	228393	228393	395362
30223	50839	17	applied	\N	\N	\N	\N	228394	228394	395363
30223	50840	18	applied	\N	\N	\N	\N	228395	228395	395364
30223	50868	19	applied	\N	\N	\N	\N	228396	228396	395365
30223	50876	20	applied	\N	\N	\N	\N	228397	228397	395366
30223	50881	21	applied	\N	\N	\N	\N	228398	228398	395367
30223	50894	22	applied	\N	\N	\N	\N	228399	228399	395368
30223	50895	23	applied	\N	\N	\N	\N	228400	228400	395369
30223	50913	24	applied	\N	\N	\N	\N	228401	228401	395370
30223	50931	26	applied	\N	\N	\N	\N	228403	228403	395372
30223	50942	27	applied	\N	\N	\N	\N	228404	228404	395373
30223	50953	28	applied	\N	\N	\N	\N	228405	228405	395374
30223	50954	29	applied	\N	\N	\N	\N	228406	228406	395375
30223	50974	30	applied	\N	\N	\N	\N	228407	228407	395376
30223	50975	31	applied	\N	\N	\N	\N	228408	228408	395377
30223	50995	32	applied	\N	\N	\N	\N	228409	228409	395378
30223	50996	33	applied	\N	\N	\N	\N	228410	228410	395379
30223	51015	34	applied	\N	\N	\N	\N	228411	228411	395380
30223	51025	35	applied	\N	\N	\N	\N	228412	228412	395381
30223	51026	36	applied	\N	\N	\N	\N	228413	228413	395382
30223	51042	37	applied	\N	\N	\N	\N	228414	228414	395383
30223	51052	38	applied	\N	\N	\N	\N	228415	228415	395384
30223	51053	39	applied	\N	\N	\N	\N	228416	228416	395385
30223	51072	40	applied	\N	\N	\N	\N	228417	228417	395386
30223	51073	41	applied	\N	\N	\N	\N	228418	228418	395387
30223	51099	43	applied	\N	\N	\N	\N	228420	228420	395389
30223	51100	44	applied	\N	\N	\N	\N	228421	228421	395390
30223	51101	45	applied	\N	\N	\N	\N	228422	228422	395391
30223	51131	46	applied	\N	\N	\N	\N	228423	228423	395392
30207	51570	64	applied	\N	\N	\N	\N	228109	228109	395078
30207	51571	65	applied	\N	\N	\N	\N	228110	228110	395079
30207	51562	89	applied	\N	\N	\N	\N	228134	228134	395103
30207	51591	90	applied	\N	\N	\N	\N	228135	228135	395104
30207	51592	91	applied	\N	\N	\N	\N	228136	228136	395105
30207	51593	92	applied	\N	\N	\N	\N	228137	228137	395106
30207	51818	93	applied	\N	\N	\N	\N	228138	228138	395107
30207	51819	94	applied	\N	\N	\N	\N	228139	228139	395108
30207	51820	95	applied	\N	\N	\N	\N	228140	228140	395109
30207	51594	96	applied	\N	\N	\N	\N	228141	228141	395110
30207	51595	97	applied	\N	\N	\N	\N	228142	228142	395111
30207	51596	98	applied	\N	\N	\N	\N	228143	228143	395112
30207	51597	99	applied	\N	\N	\N	\N	228144	228144	395113
30207	51618	100	applied	\N	\N	\N	\N	228145	228145	395114
30207	51619	101	applied	\N	\N	\N	\N	228146	228146	395115
30207	51598	102	applied	\N	\N	\N	\N	228147	228147	395116
30207	51613	103	applied	\N	\N	\N	\N	228148	228148	395117
30207	51822	104	applied	\N	\N	\N	\N	228149	228149	395118
30207	51600	106	applied	\N	\N	\N	\N	228151	228151	395120
30207	51601	107	applied	\N	\N	\N	\N	228152	228152	395121
30207	51602	108	applied	\N	\N	\N	\N	228153	228153	395122
30207	51603	109	applied	\N	\N	\N	\N	228154	228154	395123
30207	51604	110	applied	\N	\N	\N	\N	228155	228155	395124
30207	51605	111	applied	\N	\N	\N	\N	228156	228156	395125
30207	51606	112	applied	\N	\N	\N	\N	228157	228157	395126
30207	51607	113	applied	\N	\N	\N	\N	228158	228158	395127
30207	51608	114	applied	\N	\N	\N	\N	228159	228159	395128
30207	51616	115	applied	\N	\N	\N	\N	228160	228160	395129
30207	51620	116	applied	\N	\N	\N	\N	228161	228161	395130
30207	51621	117	applied	\N	\N	\N	\N	228162	228162	395131
30207	51622	118	applied	\N	\N	\N	\N	228163	228163	395132
30207	51625	119	applied	\N	\N	\N	\N	228164	228164	395133
30207	51626	120	applied	\N	\N	\N	\N	228165	228165	395134
30211	51892	23	applied	\N	\N	\N	\N	228223	228223	395192
30211	51894	25	applied	\N	\N	\N	\N	228225	228225	395194
30211	51895	26	applied	\N	\N	\N	\N	228226	228226	395195
30211	51896	27	applied	\N	\N	\N	\N	228227	228227	395196
30211	51897	28	applied	\N	\N	\N	\N	228228	228228	395197
30211	51898	29	applied	\N	\N	\N	\N	228229	228229	395198
30211	51899	30	applied	\N	\N	\N	\N	228230	228230	395199
30211	51900	31	applied	\N	\N	\N	\N	228231	228231	395200
30211	51901	32	applied	\N	\N	\N	\N	228232	228232	395201
30215	51903	0	applied	\N	\N	\N	\N	228299	228299	395268
30215	51904	1	applied	\N	\N	\N	\N	228300	228300	395269
30215	51905	2	applied	\N	\N	\N	\N	228301	228301	395270
30215	51906	3	applied	\N	\N	\N	\N	228302	228302	395271
30215	51907	4	applied	\N	\N	\N	\N	228303	228303	395272
30215	51908	5	applied	\N	\N	\N	\N	228304	228304	395273
30215	51909	6	applied	\N	\N	\N	\N	228305	228305	395274
30215	51910	7	applied	\N	\N	\N	\N	228306	228306	395275
30215	51912	9	applied	\N	\N	\N	\N	228308	228308	395277
30218	51903	0	applied	\N	\N	\N	\N	228329	228329	395298
30218	51904	1	applied	\N	\N	\N	\N	228330	228330	395299
30218	51905	2	applied	\N	\N	\N	\N	228331	228331	395300
30218	51908	3	applied	\N	\N	\N	\N	228332	228332	395301
30218	51902	4	applied	\N	\N	\N	\N	228333	228333	395302
30218	51906	5	applied	\N	\N	\N	\N	228334	228334	395303
30218	51907	6	applied	\N	\N	\N	\N	228335	228335	395304
30218	51909	7	applied	\N	\N	\N	\N	228336	228336	395305
30218	51910	8	applied	\N	\N	\N	\N	228337	228337	395306
30218	51911	9	applied	\N	\N	\N	\N	228338	228338	395307
30218	51912	10	applied	\N	\N	\N	\N	228339	228339	395308
30221	51913	0	applied	\N	\N	\N	\N	228360	228360	395329
30221	51914	1	applied	\N	\N	\N	\N	228361	228361	395330
30221	51915	2	applied	\N	\N	\N	\N	228362	228362	395331
30221	51916	3	applied	\N	\N	\N	\N	228363	228363	395332
30221	51918	5	applied	\N	\N	\N	\N	228365	228365	395334
30221	51919	6	applied	\N	\N	\N	\N	228366	228366	395335
30221	51920	7	applied	\N	\N	\N	\N	228367	228367	395336
30221	51921	8	applied	\N	\N	\N	\N	228368	228368	395337
30222	51922	0	applied	\N	\N	\N	\N	228369	228369	395338
30222	51923	1	applied	\N	\N	\N	\N	228370	228370	395339
30222	51924	2	applied	\N	\N	\N	\N	228371	228371	395340
30222	51925	3	applied	\N	\N	\N	\N	228372	228372	395341
30222	51926	4	applied	\N	\N	\N	\N	228373	228373	395342
30222	51927	5	applied	\N	\N	\N	\N	228374	228374	395343
30222	51928	6	applied	\N	\N	\N	\N	228375	228375	395344
30222	51929	7	applied	\N	\N	\N	\N	228376	228376	395345
30224	51930	0	applied	\N	\N	\N	\N	228468	228468	395437
30224	51931	1	applied	\N	\N	\N	\N	228469	228469	395438
30224	51932	2	applied	\N	\N	\N	\N	228470	228470	395439
30224	51933	3	applied	\N	\N	\N	\N	228471	228471	395440
30224	51935	5	applied	\N	\N	\N	\N	228473	228473	395442
30224	51936	6	applied	\N	\N	\N	\N	228474	228474	395443
30224	51937	7	applied	\N	\N	\N	\N	228475	228475	395444
30224	51938	8	applied	\N	\N	\N	\N	228476	228476	395445
30226	51939	0	applied	\N	\N	\N	\N	228488	228488	395457
30226	51940	1	applied	\N	\N	\N	\N	228489	228489	395458
30226	51941	2	applied	\N	\N	\N	\N	228490	228490	395459
30226	51942	3	applied	\N	\N	\N	\N	228491	228491	395460
30226	51943	4	applied	\N	\N	\N	\N	228492	228492	395461
30226	51944	5	applied	\N	\N	\N	\N	228493	228493	395462
30226	51945	6	applied	\N	\N	\N	\N	228494	228494	395463
30226	51946	7	applied	\N	\N	\N	\N	228495	228495	395464
30226	51947	8	applied	\N	\N	\N	\N	228496	228496	395465
30226	51948	9	applied	\N	\N	\N	\N	228497	228497	395466
30226	51949	10	applied	\N	\N	\N	\N	228498	228498	395467
30227	51922	0	applied	\N	\N	\N	\N	228499	228499	395468
30227	51924	2	applied	\N	\N	\N	\N	228501	228501	395470
30227	51925	3	applied	\N	\N	\N	\N	228502	228502	395471
30233	51977	0	applied	\N	\N	\N	\N	228577	228577	395546
30233	51978	1	applied	\N	\N	\N	\N	228578	228578	395547
30233	51979	2	applied	\N	\N	\N	\N	228579	228579	395548
30233	51980	3	applied	\N	\N	\N	\N	228580	228580	395549
30233	51981	4	applied	\N	\N	\N	\N	228581	228581	395550
30233	51982	5	applied	\N	\N	\N	\N	228582	228582	395551
30233	51983	6	applied	\N	\N	\N	\N	228583	228583	395552
30233	51984	7	applied	\N	\N	\N	\N	228584	228584	395553
30233	51985	8	applied	\N	\N	\N	\N	228585	228585	395554
30233	51986	9	applied	\N	\N	\N	\N	228586	228586	395555
30237	51980	0	applied	\N	\N	\N	\N	228613	228613	395582
30237	51981	1	applied	\N	\N	\N	\N	228614	228614	395583
30207	51590	86	applied	\N	\N	\N	\N	228131	228131	395100
30207	51553	87	applied	\N	\N	\N	\N	228132	228132	395101
30214	51896	27	applied	\N	\N	\N	\N	228292	228292	395261
30214	51897	28	applied	\N	\N	\N	\N	228293	228293	395262
30214	51898	29	applied	\N	\N	\N	\N	228294	228294	395263
30214	51899	30	applied	\N	\N	\N	\N	228295	228295	395264
30214	51900	31	applied	\N	\N	\N	\N	228296	228296	395265
30214	51901	32	applied	\N	\N	\N	\N	228297	228297	395266
30214	51902	33	applied	\N	\N	\N	\N	228298	228298	395267
30216	51903	0	applied	\N	\N	\N	\N	228309	228309	395278
30216	51904	1	applied	\N	\N	\N	\N	228310	228310	395279
30216	51905	2	applied	\N	\N	\N	\N	228311	228311	395280
30216	51906	3	applied	\N	\N	\N	\N	228312	228312	395281
30216	51907	4	applied	\N	\N	\N	\N	228313	228313	395282
30216	51908	5	applied	\N	\N	\N	\N	228314	228314	395283
30216	51909	6	applied	\N	\N	\N	\N	228315	228315	395284
30216	51910	7	applied	\N	\N	\N	\N	228316	228316	395285
30216	51911	8	applied	\N	\N	\N	\N	228317	228317	395286
30219	51903	0	applied	\N	\N	\N	\N	228340	228340	395309
30227	51926	4	applied	\N	\N	\N	\N	228503	228503	395472
30227	51927	5	applied	\N	\N	\N	\N	228504	228504	395473
30227	51928	6	applied	\N	\N	\N	\N	228505	228505	395474
30227	51929	7	applied	\N	\N	\N	\N	228506	228506	395475
30227	51932	8	applied	\N	\N	\N	\N	228507	228507	395476
30228	51939	0	applied	\N	\N	\N	\N	228508	228508	395477
30228	51940	1	applied	\N	\N	\N	\N	228509	228509	395478
30228	51941	2	applied	\N	\N	\N	\N	228510	228510	395479
30228	51942	3	applied	\N	\N	\N	\N	228511	228511	395480
30228	51943	4	applied	\N	\N	\N	\N	228512	228512	395481
30228	51944	5	applied	\N	\N	\N	\N	228513	228513	395482
30228	51945	6	applied	\N	\N	\N	\N	228514	228514	395483
30228	51946	7	applied	\N	\N	\N	\N	228515	228515	395484
30228	51947	8	applied	\N	\N	\N	\N	228516	228516	395485
30228	51948	9	applied	\N	\N	\N	\N	228517	228517	395486
30229	51939	0	applied	\N	\N	\N	\N	228519	228519	395488
30229	51940	1	applied	\N	\N	\N	\N	228520	228520	395489
30229	51941	2	applied	\N	\N	\N	\N	228521	228521	395490
30229	51942	3	applied	\N	\N	\N	\N	228522	228522	395491
30229	51943	4	applied	\N	\N	\N	\N	228523	228523	395492
30229	51944	5	applied	\N	\N	\N	\N	228524	228524	395493
30229	51945	6	applied	\N	\N	\N	\N	228525	228525	395494
30229	51946	7	applied	\N	\N	\N	\N	228526	228526	395495
30229	51947	8	applied	\N	\N	\N	\N	228527	228527	395496
30229	51948	9	applied	\N	\N	\N	\N	228528	228528	395497
30229	51949	10	applied	\N	\N	\N	\N	228529	228529	395498
30231	51977	0	applied	\N	\N	\N	\N	228557	228557	395526
30231	51978	1	applied	\N	\N	\N	\N	228558	228558	395527
30231	51979	2	applied	\N	\N	\N	\N	228559	228559	395528
30231	51980	3	applied	\N	\N	\N	\N	228560	228560	395529
30231	51981	4	applied	\N	\N	\N	\N	228561	228561	395530
30231	51983	6	applied	\N	\N	\N	\N	228563	228563	395532
30231	51984	7	applied	\N	\N	\N	\N	228564	228564	395533
30231	51985	8	applied	\N	\N	\N	\N	228565	228565	395534
30231	51986	9	applied	\N	\N	\N	\N	228566	228566	395535
30234	51977	0	applied	\N	\N	\N	\N	228587	228587	395556
30234	51978	1	applied	\N	\N	\N	\N	228588	228588	395557
30234	51979	2	applied	\N	\N	\N	\N	228589	228589	395558
30234	51980	3	applied	\N	\N	\N	\N	228590	228590	395559
30234	51981	4	applied	\N	\N	\N	\N	228591	228591	395560
30234	51982	5	applied	\N	\N	\N	\N	228592	228592	395561
30234	51983	6	applied	\N	\N	\N	\N	228593	228593	395562
30234	51984	7	applied	\N	\N	\N	\N	228594	228594	395563
30234	51985	8	applied	\N	\N	\N	\N	228595	228595	395564
30234	51986	9	applied	\N	\N	\N	\N	228596	228596	395565
30236	51977	0	applied	\N	\N	\N	\N	228603	228603	395572
30236	51978	1	applied	\N	\N	\N	\N	228604	228604	395573
30236	51980	3	applied	\N	\N	\N	\N	228606	228606	395575
30236	51981	4	applied	\N	\N	\N	\N	228607	228607	395576
30236	51982	5	applied	\N	\N	\N	\N	228608	228608	395577
30236	51983	6	applied	\N	\N	\N	\N	228609	228609	395578
30236	51984	7	applied	\N	\N	\N	\N	228610	228610	395579
30236	51985	8	applied	\N	\N	\N	\N	228611	228611	395580
30236	51986	9	applied	\N	\N	\N	\N	228612	228612	395581
30238	51977	0	applied	\N	\N	\N	\N	228618	228618	395587
30238	51987	1	applied	\N	\N	\N	\N	228619	228619	395588
30238	51988	2	applied	\N	\N	\N	\N	228620	228620	395589
30238	51989	3	applied	\N	\N	\N	\N	228621	228621	395590
30238	51978	4	applied	\N	\N	\N	\N	228622	228622	395591
30238	51979	5	applied	\N	\N	\N	\N	228623	228623	395592
30238	51984	6	applied	\N	\N	\N	\N	228624	228624	395593
30238	51985	7	applied	\N	\N	\N	\N	228625	228625	395594
30238	51990	8	applied	\N	\N	\N	\N	228626	228626	395595
30238	51992	10	applied	\N	\N	\N	\N	228628	228628	395597
30238	51993	12	applied	\N	\N	\N	\N	228629	228629	395598
30238	51994	13	applied	\N	\N	\N	\N	228630	228630	395599
30238	51995	14	applied	\N	\N	\N	\N	228631	228631	395600
30238	51996	15	applied	\N	\N	\N	\N	228632	228632	395601
30238	51997	16	applied	\N	\N	\N	\N	228633	228633	395602
30238	51998	17	applied	\N	\N	\N	\N	228634	228634	395603
30238	51999	18	applied	\N	\N	\N	\N	228635	228635	395604
30238	52000	19	applied	\N	\N	\N	\N	228636	228636	395605
30238	52001	20	applied	\N	\N	\N	\N	228637	228637	395606
30238	52002	21	applied	\N	\N	\N	\N	228638	228638	395607
30238	52003	22	applied	\N	\N	\N	\N	228639	228639	395608
30238	52004	23	applied	\N	\N	\N	\N	228640	228640	395609
30245	52031	0	applied	\N	\N	\N	\N	228673	228673	395642
30245	52032	1	applied	\N	\N	\N	\N	228674	228674	395643
30245	52033	2	applied	\N	\N	\N	\N	228675	228675	395644
30245	52035	4	applied	\N	\N	\N	\N	228677	228677	395646
30245	52036	5	applied	\N	\N	\N	\N	228678	228678	395647
30245	52037	6	applied	\N	\N	\N	\N	228679	228679	395648
30245	52038	7	applied	\N	\N	\N	\N	228680	228680	395649
30245	52039	8	applied	\N	\N	\N	\N	228681	228681	395650
30245	52040	9	applied	\N	\N	\N	\N	228682	228682	395651
30245	52041	10	applied	\N	\N	\N	\N	228683	228683	395652
30245	52042	11	applied	\N	\N	\N	\N	228684	228684	395653
30245	52043	12	applied	\N	\N	\N	\N	228685	228685	395654
30245	52044	13	applied	\N	\N	\N	\N	228686	228686	395655
30245	52045	14	applied	\N	\N	\N	\N	228687	228687	395656
30245	52046	15	applied	\N	\N	\N	\N	228688	228688	395657
30245	52047	16	applied	\N	\N	\N	\N	228689	228689	395658
30245	52048	17	applied	\N	\N	\N	\N	228690	228690	395659
30214	51893	24	applied	\N	\N	\N	\N	228289	228289	395258
30214	51894	25	applied	\N	\N	\N	\N	228290	228290	395259
30219	51908	5	applied	\N	\N	\N	\N	228345	228345	395314
30219	51909	6	applied	\N	\N	\N	\N	228346	228346	395315
30219	51910	7	applied	\N	\N	\N	\N	228347	228347	395316
30219	51911	8	applied	\N	\N	\N	\N	228348	228348	395317
30219	51912	9	applied	\N	\N	\N	\N	228349	228349	395318
30223	51139	47	applied	\N	\N	\N	\N	228424	228424	395393
30223	51148	48	applied	\N	\N	\N	\N	228425	228425	395394
30223	51159	49	applied	\N	\N	\N	\N	228426	228426	395395
30223	51167	56	applied	\N	\N	\N	\N	228427	228427	395396
30223	51178	57	applied	\N	\N	\N	\N	228428	228428	395397
30223	51188	58	applied	\N	\N	\N	\N	228429	228429	395398
30223	51197	59	applied	\N	\N	\N	\N	228430	228430	395399
30223	51198	60	applied	\N	\N	\N	\N	228431	228431	395400
30223	51216	61	applied	\N	\N	\N	\N	228432	228432	395401
30223	51236	63	applied	\N	\N	\N	\N	228434	228434	395403
30223	51245	64	applied	\N	\N	\N	\N	228435	228435	395404
30223	51254	65	applied	\N	\N	\N	\N	228436	228436	395405
30223	51255	66	applied	\N	\N	\N	\N	228437	228437	395406
30223	51256	67	applied	\N	\N	\N	\N	228438	228438	395407
30223	51282	68	applied	\N	\N	\N	\N	228439	228439	395408
30223	51291	69	applied	\N	\N	\N	\N	228440	228440	395409
30223	51300	70	applied	\N	\N	\N	\N	228441	228441	395410
30223	51309	71	applied	\N	\N	\N	\N	228442	228442	395411
30223	51310	72	applied	\N	\N	\N	\N	228443	228443	395412
30223	51328	73	applied	\N	\N	\N	\N	228444	228444	395413
30223	51337	74	applied	\N	\N	\N	\N	228445	228445	395414
30240	52005	0	applied	\N	\N	\N	\N	228649	228649	395618
30240	52010	1	applied	\N	\N	\N	\N	228650	228650	395619
30240	52011	2	applied	\N	\N	\N	\N	228651	228651	395620
30240	52012	3	applied	\N	\N	\N	\N	228652	228652	395621
30242	52014	1	applied	\N	\N	\N	\N	228656	228656	395625
30242	52015	2	applied	\N	\N	\N	\N	228657	228657	395626
30242	52016	3	applied	\N	\N	\N	\N	228658	228658	395627
30242	52017	4	applied	\N	\N	\N	\N	228659	228659	395628
30242	52018	5	applied	\N	\N	\N	\N	228660	228660	395629
30242	52019	6	applied	\N	\N	\N	\N	228661	228661	395630
30242	52020	7	applied	\N	\N	\N	\N	228662	228662	395631
30242	52021	8	applied	\N	\N	\N	\N	228663	228663	395632
30242	52022	9	applied	\N	\N	\N	\N	228664	228664	395633
30244	52030	0	applied	\N	\N	\N	\N	228672	228672	395641
30247	52050	0	applied	\N	\N	\N	\N	228711	228711	395680
30247	52051	1	applied	\N	\N	\N	\N	228712	228712	395681
30247	52052	2	applied	\N	\N	\N	\N	228713	228713	395682
30247	52053	3	applied	\N	\N	\N	\N	228714	228714	395683
30247	52054	4	applied	\N	\N	\N	\N	228715	228715	395684
30247	52055	5	applied	\N	\N	\N	\N	228716	228716	395685
30247	52057	7	applied	\N	\N	\N	\N	228718	228718	395687
30247	52058	8	applied	\N	\N	\N	\N	228719	228719	395688
30247	52059	9	applied	\N	\N	\N	\N	228720	228720	395689
30247	52060	10	applied	\N	\N	\N	\N	228721	228721	395690
30247	52061	11	applied	\N	\N	\N	\N	228722	228722	395691
30247	52062	12	applied	\N	\N	\N	\N	228723	228723	395692
30247	52063	13	applied	\N	\N	\N	\N	228724	228724	395693
30247	52064	14	applied	\N	\N	\N	\N	228725	228725	395694
30247	52065	15	applied	\N	\N	\N	\N	228726	228726	395695
30247	52066	16	applied	\N	\N	\N	\N	228727	228727	395696
30247	52067	17	applied	\N	\N	\N	\N	228728	228728	395697
30247	52068	18	applied	\N	\N	\N	\N	228729	228729	395698
30250	52069	0	applied	\N	\N	\N	\N	228752	228752	395721
30250	52070	1	applied	\N	\N	\N	\N	228753	228753	395722
30250	52071	2	applied	\N	\N	\N	\N	228754	228754	395723
30250	52072	3	applied	\N	\N	\N	\N	228755	228755	395724
30250	52074	5	applied	\N	\N	1000000000	\N	228757	228757	395726
30250	52075	6	applied	\N	\N	\N	\N	228758	228758	395727
30250	52077	7	applied	\N	\N	\N	\N	228759	228759	395728
30250	52078	8	applied	\N	\N	\N	\N	228760	228760	395729
30254	52088	0	applied	\N	\N	\N	\N	228791	228791	395760
30254	52089	1	applied	\N	\N	\N	\N	228792	228792	395761
30254	52090	2	applied	\N	\N	\N	\N	228793	228793	395762
30254	52091	3	applied	\N	\N	\N	\N	228794	228794	395763
30254	52092	4	applied	\N	\N	\N	\N	228795	228795	395764
30254	52093	5	applied	\N	\N	\N	\N	228796	228796	395765
30254	52094	6	applied	\N	\N	\N	\N	228797	228797	395766
30254	52095	7	applied	\N	\N	\N	\N	228798	228798	395767
30254	52096	9	applied	\N	\N	\N	\N	228799	228799	395768
30256	52097	0	applied	\N	\N	\N	\N	228818	228818	395787
30256	52098	1	applied	\N	\N	\N	\N	228819	228819	395788
30256	52099	2	applied	\N	\N	\N	\N	228820	228820	395789
30256	52101	4	applied	\N	\N	\N	\N	228822	228822	395791
30256	52102	5	applied	\N	\N	\N	\N	228823	228823	395792
30256	52103	6	applied	\N	\N	\N	\N	228824	228824	395793
30256	52104	7	applied	\N	\N	\N	\N	228825	228825	395794
30256	52105	8	applied	\N	\N	\N	\N	228826	228826	395795
30256	52106	9	applied	\N	\N	\N	\N	228827	228827	395796
30256	52107	10	applied	\N	\N	\N	\N	228828	228828	395797
30256	52108	11	applied	\N	\N	\N	\N	228829	228829	395798
30256	52109	12	applied	\N	\N	\N	\N	228830	228830	395799
30256	52110	13	applied	\N	\N	\N	\N	228831	228831	395800
30256	52111	14	applied	\N	\N	\N	\N	228832	228832	395801
30256	52112	15	applied	\N	\N	\N	\N	228833	228833	395802
30256	52113	16	applied	\N	\N	\N	\N	228834	228834	395803
30256	52114	17	applied	\N	\N	\N	\N	228835	228835	395804
30261	52116	0	applied	\N	\N	\N	\N	228938	228938	395907
30261	52117	1	applied	\N	\N	\N	\N	228939	228939	395908
30261	52119	3	applied	\N	\N	\N	\N	228941	228941	395910
30261	52156	4	applied	\N	\N	\N	\N	228942	228942	395911
30261	52121	5	applied	\N	\N	\N	\N	228943	228943	395912
30261	52122	6	applied	\N	\N	\N	\N	228944	228944	395913
30261	52123	7	applied	\N	\N	\N	\N	228945	228945	395914
30261	52124	8	applied	\N	\N	\N	\N	228946	228946	395915
30261	52125	9	applied	\N	\N	\N	\N	228947	228947	395916
30261	52126	10	applied	\N	\N	\N	\N	228948	228948	395917
30261	52127	11	applied	\N	\N	\N	\N	228949	228949	395918
30261	52128	12	applied	\N	\N	\N	\N	228950	228950	395919
30261	52129	13	applied	\N	\N	\N	\N	228951	228951	395920
30261	52130	14	applied	\N	\N	\N	\N	228952	228952	395921
30261	52131	15	applied	\N	\N	\N	\N	228953	228953	395922
30261	52132	16	applied	\N	\N	\N	\N	228954	228954	395923
30261	52157	17	applied	\N	\N	\N	\N	228955	228955	395924
30261	52133	18	applied	\N	\N	\N	\N	228956	228956	395925
30219	51907	4	applied	\N	\N	\N	\N	228344	228344	395313
30223	51392	79	applied	\N	\N	\N	\N	228450	228450	395419
30223	51396	80	applied	\N	\N	\N	\N	228451	228451	395420
30223	51397	81	applied	\N	\N	\N	\N	228452	228452	395421
30223	51415	82	applied	\N	\N	\N	\N	228453	228453	395422
30223	51416	83	applied	\N	\N	\N	\N	228454	228454	395423
30223	51417	84	applied	\N	\N	\N	\N	228455	228455	395424
30223	51443	85	applied	\N	\N	\N	\N	228456	228456	395425
30223	51444	86	applied	\N	\N	\N	\N	228457	228457	395426
30223	51463	87	applied	\N	\N	\N	\N	228458	228458	395427
30223	51482	88	applied	\N	\N	\N	\N	228459	228459	395428
30223	51490	89	applied	\N	\N	\N	\N	228460	228460	395429
30223	51501	90	applied	\N	\N	\N	\N	228461	228461	395430
30223	51508	91	applied	\N	\N	\N	\N	228462	228462	395431
30223	51518	92	applied	\N	\N	\N	\N	228463	228463	395432
30223	51536	94	applied	\N	\N	\N	\N	228465	228465	395434
30223	51546	95	applied	\N	\N	\N	\N	228466	228466	395435
30223	51554	96	applied	\N	\N	\N	\N	228467	228467	395436
30225	51939	0	applied	\N	\N	\N	\N	228477	228477	395446
30225	51940	1	applied	\N	\N	\N	\N	228478	228478	395447
30225	51941	2	applied	\N	\N	\N	\N	228479	228479	395448
30225	51942	3	applied	\N	\N	\N	\N	228480	228480	395449
30225	51943	4	applied	\N	\N	\N	\N	228481	228481	395450
30225	51944	5	applied	\N	\N	\N	\N	228482	228482	395451
30225	51945	6	applied	\N	\N	\N	\N	228483	228483	395452
30225	51946	7	applied	\N	\N	\N	\N	228484	228484	395453
30225	51947	8	applied	\N	\N	\N	\N	228485	228485	395454
30225	51948	9	applied	\N	\N	\N	\N	228486	228486	395455
30225	51949	10	applied	\N	\N	\N	\N	228487	228487	395456
30230	51950	0	applied	\N	\N	\N	\N	228530	228530	395499
30230	51951	1	applied	\N	\N	\N	\N	228531	228531	395500
30230	51953	3	applied	\N	\N	\N	\N	228533	228533	395502
30230	51954	4	applied	\N	\N	\N	\N	228534	228534	395503
30230	51955	5	applied	\N	\N	\N	\N	228535	228535	395504
30230	51956	6	applied	\N	\N	\N	\N	228536	228536	395505
30230	51957	7	applied	\N	\N	\N	\N	228537	228537	395506
30230	51958	8	applied	\N	\N	\N	\N	228538	228538	395507
30230	51959	9	applied	\N	\N	\N	\N	228539	228539	395508
30230	51960	10	applied	\N	\N	\N	\N	228540	228540	395509
30230	51961	11	applied	\N	\N	\N	\N	228541	228541	395510
30230	51962	12	applied	\N	\N	\N	\N	228542	228542	395511
30230	51963	13	applied	\N	\N	\N	\N	228543	228543	395512
30230	51964	14	applied	\N	\N	\N	\N	228544	228544	395513
30230	51965	15	applied	\N	\N	\N	\N	228545	228545	395514
30230	51966	16	applied	\N	\N	\N	\N	228546	228546	395515
30230	51967	17	applied	\N	\N	\N	\N	228547	228547	395516
30230	51968	18	applied	\N	\N	\N	\N	228548	228548	395517
30230	51970	20	applied	\N	\N	\N	\N	228550	228550	395519
30230	51971	21	applied	\N	\N	\N	\N	228551	228551	395520
30230	51972	22	applied	\N	\N	\N	\N	228552	228552	395521
30230	51973	23	applied	\N	\N	\N	\N	228553	228553	395522
30230	51974	24	applied	\N	\N	\N	\N	228554	228554	395523
30230	51975	25	applied	\N	\N	\N	\N	228555	228555	395524
30230	51976	26	applied	\N	\N	\N	\N	228556	228556	395525
30232	51977	0	applied	\N	\N	\N	\N	228567	228567	395536
30232	51978	1	applied	\N	\N	\N	\N	228568	228568	395537
30232	51979	2	applied	\N	\N	\N	\N	228569	228569	395538
30232	51980	3	applied	\N	\N	\N	\N	228570	228570	395539
30232	51981	4	applied	\N	\N	\N	\N	228571	228571	395540
30232	51982	5	applied	\N	\N	\N	\N	228572	228572	395541
30232	51983	6	applied	\N	\N	\N	\N	228573	228573	395542
30232	51984	7	applied	\N	\N	\N	\N	228574	228574	395543
30232	51985	8	applied	\N	\N	\N	\N	228575	228575	395544
30235	51977	0	applied	\N	\N	\N	\N	228597	228597	395566
30235	51980	1	applied	\N	\N	\N	\N	228598	228598	395567
30235	51981	2	applied	\N	\N	\N	\N	228599	228599	395568
30235	51982	3	applied	\N	\N	\N	\N	228600	228600	395569
30235	51983	4	applied	\N	\N	\N	\N	228601	228601	395570
30235	51986	5	applied	\N	\N	\N	\N	228602	228602	395571
30237	51982	2	applied	\N	\N	\N	\N	228615	228615	395584
30237	51983	3	applied	\N	\N	\N	\N	228616	228616	395585
30237	51986	4	applied	\N	\N	\N	\N	228617	228617	395586
30239	52005	0	applied	\N	\N	\N	\N	228641	228641	395610
30239	52006	1	applied	\N	\N	\N	\N	228642	228642	395611
30239	52007	2	applied	\N	\N	\N	\N	228643	228643	395612
30239	52008	3	applied	\N	\N	\N	\N	228644	228644	395613
30239	52009	4	applied	\N	\N	\N	\N	228645	228645	395614
30239	52010	5	applied	\N	\N	\N	\N	228646	228646	395615
30239	52011	6	applied	\N	\N	\N	\N	228647	228647	395616
30241	52005	0	applied	\N	\N	\N	\N	228653	228653	395622
30241	52010	1	applied	\N	\N	\N	\N	228654	228654	395623
30243	52023	0	applied	\N	\N	\N	\N	228665	228665	395634
30243	52024	1	applied	\N	\N	\N	\N	228666	228666	395635
30243	52025	2	applied	\N	\N	\N	\N	228667	228667	395636
30243	52026	3	applied	\N	\N	\N	\N	228668	228668	395637
30243	52027	4	applied	\N	\N	\N	\N	228669	228669	395638
30243	52028	5	applied	\N	\N	\N	\N	228670	228670	395639
30243	52029	6	applied	\N	\N	\N	\N	228671	228671	395640
30246	52050	0	applied	\N	\N	\N	\N	228692	228692	395661
30246	52051	1	applied	\N	\N	\N	\N	228693	228693	395662
30246	52052	2	applied	\N	\N	\N	\N	228694	228694	395663
30246	52053	3	applied	\N	\N	\N	\N	228695	228695	395664
30248	52069	0	applied	\N	\N	\N	\N	228730	228730	395699
30248	52070	1	applied	\N	\N	\N	\N	228731	228731	395700
30248	52071	2	applied	\N	\N	\N	\N	228732	228732	395701
30248	52073	4	applied	\N	\N	\N	\N	228734	228734	395703
30248	52074	5	applied	\N	\N	1000000000	\N	228735	228735	395704
30248	52075	6	applied	\N	\N	\N	\N	228736	228736	395705
30248	52076	7	applied	\N	\N	\N	\N	228737	228737	395706
30248	52077	8	applied	\N	\N	\N	\N	228738	228738	395707
30248	52078	9	applied	\N	\N	\N	\N	228739	228739	395708
30248	52079	10	applied	\N	\N	\N	\N	228740	228740	395709
30252	52080	0	applied	\N	\N	\N	\N	228772	228772	395741
30252	52079	1	applied	\N	\N	\N	\N	228773	228773	395742
30252	52081	2	applied	\N	\N	\N	\N	228774	228774	395743
30252	52082	3	applied	\N	\N	\N	\N	228775	228775	395744
30252	52076	4	applied	\N	\N	\N	\N	228776	228776	395745
30252	52083	5	applied	\N	\N	\N	\N	228777	228777	395746
30252	52084	6	applied	\N	\N	\N	\N	228778	228778	395747
30252	52085	7	applied	\N	\N	\N	\N	228779	228779	395748
30252	52086	8	applied	\N	\N	\N	\N	228780	228780	395749
30223	51367	78	applied	\N	\N	\N	\N	228449	228449	395418
30246	52056	6	applied	\N	\N	\N	\N	228698	228698	395667
30246	52057	7	applied	\N	\N	\N	\N	228699	228699	395668
30246	52058	8	applied	\N	\N	\N	\N	228700	228700	395669
30246	52059	9	applied	\N	\N	\N	\N	228701	228701	395670
30246	52060	10	applied	\N	\N	\N	\N	228702	228702	395671
30246	52061	11	applied	\N	\N	\N	\N	228703	228703	395672
30246	52062	12	applied	\N	\N	\N	\N	228704	228704	395673
30246	52063	13	applied	\N	\N	\N	\N	228705	228705	395674
30246	52064	14	applied	\N	\N	\N	\N	228706	228706	395675
30246	52065	15	applied	\N	\N	\N	\N	228707	228707	395676
30246	52066	16	applied	\N	\N	\N	\N	228708	228708	395677
30246	52068	18	applied	\N	\N	\N	\N	228710	228710	395679
30249	52069	0	applied	\N	\N	\N	\N	228741	228741	395710
30249	52070	1	applied	\N	\N	\N	\N	228742	228742	395711
30249	52071	2	applied	\N	\N	\N	\N	228743	228743	395712
30249	52072	3	applied	\N	\N	\N	\N	228744	228744	395713
30249	52073	4	applied	\N	\N	\N	\N	228745	228745	395714
30249	52074	5	applied	\N	\N	1000000000	\N	228746	228746	395715
30249	52075	6	applied	\N	\N	\N	\N	228747	228747	395716
30249	52076	7	applied	\N	\N	\N	\N	228748	228748	395717
30249	52077	8	applied	\N	\N	\N	\N	228749	228749	395718
30249	52078	9	applied	\N	\N	\N	\N	228750	228750	395719
30249	52079	10	applied	\N	\N	\N	\N	228751	228751	395720
30251	52069	0	applied	\N	\N	\N	\N	228761	228761	395730
30251	52070	1	applied	\N	\N	\N	\N	228762	228762	395731
30251	52071	2	applied	\N	\N	\N	\N	228763	228763	395732
30251	52072	3	applied	\N	\N	\N	\N	228764	228764	395733
30251	52074	5	applied	\N	\N	1000000000	\N	228766	228766	395735
30251	52075	6	applied	\N	\N	\N	\N	228767	228767	395736
30251	52076	7	applied	\N	\N	\N	\N	228768	228768	395737
30251	52077	8	applied	\N	\N	\N	\N	228769	228769	395738
30251	52078	9	applied	\N	\N	\N	\N	228770	228770	395739
30251	52079	10	applied	\N	\N	\N	\N	228771	228771	395740
30253	52080	0	applied	\N	\N	\N	\N	228781	228781	395750
30253	52079	1	applied	\N	\N	\N	\N	228782	228782	395751
30253	52081	2	applied	\N	\N	\N	\N	228783	228783	395752
30253	52082	3	applied	\N	\N	\N	\N	228784	228784	395753
30253	52076	4	applied	\N	\N	\N	\N	228785	228785	395754
30253	52083	5	applied	\N	\N	\N	\N	228786	228786	395755
30253	52084	6	applied	\N	\N	\N	\N	228787	228787	395756
30253	52087	7	applied	\N	\N	\N	\N	228788	228788	395757
30253	52085	8	applied	\N	\N	\N	\N	228789	228789	395758
30253	52086	9	applied	\N	\N	\N	\N	228790	228790	395759
30257	52098	1	applied	\N	\N	\N	\N	228837	228837	395806
30257	52099	2	applied	\N	\N	\N	\N	228838	228838	395807
30257	52100	3	applied	\N	\N	\N	\N	228839	228839	395808
30257	52101	4	applied	\N	\N	\N	\N	228840	228840	395809
30257	52102	5	applied	\N	\N	\N	\N	228841	228841	395810
30257	52103	6	applied	\N	\N	\N	\N	228842	228842	395811
30257	52104	7	applied	\N	\N	\N	\N	228843	228843	395812
30257	52105	8	applied	\N	\N	\N	\N	228844	228844	395813
30257	52106	9	applied	\N	\N	\N	\N	228845	228845	395814
30257	52107	10	applied	\N	\N	\N	\N	228846	228846	395815
30257	52108	11	applied	\N	\N	\N	\N	228847	228847	395816
30257	52109	12	applied	\N	\N	\N	\N	228848	228848	395817
30257	52110	13	applied	\N	\N	\N	\N	228849	228849	395818
30257	52111	14	applied	\N	\N	\N	\N	228850	228850	395819
30257	52112	15	applied	\N	\N	\N	\N	228851	228851	395820
30257	52113	16	applied	\N	\N	\N	\N	228852	228852	395821
30260	52115	0	applied	\N	\N	\N	\N	228936	228936	395905
30260	52120	1	applied	\N	\N	\N	\N	228937	228937	395906
30262	52166	0	applied	\N	\N	\N	\N	228987	228987	395956
30262	52167	1	applied	\N	\N	\N	\N	228988	228988	395957
30262	52168	2	applied	\N	\N	\N	\N	228989	228989	395958
30262	52169	3	applied	\N	\N	\N	\N	228990	228990	395959
30262	52170	4	applied	\N	\N	\N	\N	228991	228991	395960
30262	52171	5	applied	\N	\N	\N	\N	228992	228992	395961
30262	52172	6	applied	\N	\N	\N	\N	228993	228993	395962
30262	52173	7	applied	\N	\N	\N	\N	228994	228994	395963
30262	52174	8	applied	\N	\N	\N	\N	228995	228995	395964
30262	52175	9	applied	\N	\N	\N	\N	228996	228996	395965
30262	52176	10	applied	\N	\N	\N	\N	228997	228997	395966
30262	52177	11	applied	\N	\N	\N	\N	228998	228998	395967
30262	52178	12	applied	\N	\N	\N	\N	228999	228999	395968
30262	52179	13	applied	\N	\N	\N	\N	229000	229000	395969
30262	52181	15	applied	\N	\N	\N	\N	229002	229002	395971
30262	52182	16	applied	\N	\N	\N	\N	229003	229003	395972
30262	52183	17	applied	\N	\N	\N	\N	229004	229004	395973
30262	52184	18	applied	\N	\N	\N	\N	229005	229005	395974
30262	52185	19	applied	\N	\N	\N	\N	229006	229006	395975
30268	52224	0	applied	\N	\N	\N	\N	229178	229178	396145
30268	52225	1	applied	\N	\N	\N	\N	229179	229179	396146
30268	52226	2	applied	\N	\N	1000000000	\N	229180	229180	396147
30268	52227	3	applied	\N	\N	\N	\N	229181	229181	396148
30268	52228	4	applied	\N	\N	\N	\N	229182	229182	396149
30268	52229	5	applied	\N	\N	\N	\N	229183	229183	396150
30268	52230	6	applied	\N	\N	\N	\N	229184	229184	396151
30268	52231	7	applied	\N	\N	\N	\N	229185	229185	396152
30268	52232	8	applied	\N	\N	\N	\N	229186	229186	396153
30268	52233	9	applied	\N	\N	\N	\N	229187	229187	396154
30268	52234	10	applied	\N	\N	\N	\N	229188	229188	396155
30268	52236	12	applied	\N	\N	\N	\N	229190	229190	396157
30268	52237	13	applied	\N	\N	\N	\N	229191	229191	396158
30268	52238	14	applied	\N	\N	\N	\N	229192	229192	396159
30268	52239	15	applied	\N	\N	\N	\N	229193	229193	396160
30268	52240	16	applied	\N	\N	\N	\N	229194	229194	396161
30268	52241	17	applied	\N	\N	\N	\N	229195	229195	396162
30268	52242	18	applied	\N	\N	\N	\N	229196	229196	396163
30268	52243	19	applied	\N	\N	\N	\N	229197	229197	396164
30270	52244	0	applied	\N	\N	\N	\N	229209	229209	396176
30270	52227	1	applied	\N	\N	\N	\N	229210	229210	396177
30270	52245	2	applied	\N	\N	\N	\N	229211	229211	396178
30270	52246	3	applied	\N	\N	\N	\N	229212	229212	396179
30270	52231	4	applied	\N	\N	\N	\N	229213	229213	396180
30270	52232	5	applied	\N	\N	\N	\N	229214	229214	396181
30270	52233	6	applied	\N	\N	\N	\N	229215	229215	396182
30270	52247	7	applied	\N	\N	\N	\N	229216	229216	396183
30270	52249	9	applied	\N	\N	\N	\N	229218	229218	396185
30270	52234	10	applied	\N	\N	\N	\N	229219	229219	396186
30246	52054	4	applied	\N	\N	\N	\N	228696	228696	395665
30246	52055	5	applied	\N	\N	\N	\N	228697	228697	395666
30255	52101	4	applied	\N	\N	\N	\N	228804	228804	395773
30255	52102	5	applied	\N	\N	\N	\N	228805	228805	395774
30255	52103	6	applied	\N	\N	\N	\N	228806	228806	395775
30255	52104	7	applied	\N	\N	\N	\N	228807	228807	395776
30255	52105	8	applied	\N	\N	\N	\N	228808	228808	395777
30255	52106	9	applied	\N	\N	\N	\N	228809	228809	395778
30255	52107	10	applied	\N	\N	\N	\N	228810	228810	395779
30255	52108	11	applied	\N	\N	\N	\N	228811	228811	395780
30255	52109	12	applied	\N	\N	\N	\N	228812	228812	395781
30255	52110	13	applied	\N	\N	\N	\N	228813	228813	395782
30255	52111	14	applied	\N	\N	\N	\N	228814	228814	395783
30255	52112	15	applied	\N	\N	\N	\N	228815	228815	395784
30255	52113	16	applied	\N	\N	\N	\N	228816	228816	395785
30255	52114	17	applied	\N	\N	\N	\N	228817	228817	395786
30258	52116	1	applied	\N	\N	\N	\N	228855	228855	395824
30258	52117	2	applied	\N	\N	\N	\N	228856	228856	395825
30258	52118	3	applied	\N	\N	\N	\N	228857	228857	395826
30258	52119	4	applied	\N	\N	\N	\N	228858	228858	395827
30258	52120	5	applied	\N	\N	\N	\N	228859	228859	395828
30258	52121	6	applied	\N	\N	\N	\N	228860	228860	395829
30258	52122	7	applied	\N	\N	\N	\N	228861	228861	395830
30258	52123	8	applied	\N	\N	\N	\N	228862	228862	395831
30258	52124	9	applied	\N	\N	\N	\N	228863	228863	395832
30258	52125	10	applied	\N	\N	\N	\N	228864	228864	395833
30258	52126	11	applied	\N	\N	\N	\N	228865	228865	395834
30258	52127	12	applied	\N	\N	\N	\N	228866	228866	395835
30258	52128	13	applied	\N	\N	\N	\N	228867	228867	395836
30258	52129	14	applied	\N	\N	\N	\N	228868	228868	395837
30258	52130	15	applied	\N	\N	\N	\N	228869	228869	395838
30258	52131	16	applied	\N	\N	\N	\N	228870	228870	395839
30258	52133	18	applied	\N	\N	\N	\N	228872	228872	395841
30258	52134	19	applied	\N	\N	\N	\N	228873	228873	395842
30258	52135	20	applied	\N	\N	\N	\N	228874	228874	395843
30258	52136	21	applied	\N	\N	\N	\N	228875	228875	395844
30258	52137	22	applied	\N	\N	\N	\N	228876	228876	395845
30258	52138	23	applied	\N	\N	\N	\N	228877	228877	395846
30258	52139	24	applied	\N	\N	\N	\N	228878	228878	395847
30258	52140	25	applied	\N	\N	\N	\N	228879	228879	395848
30258	52141	26	applied	\N	\N	\N	\N	228880	228880	395849
30258	52142	27	applied	\N	\N	\N	\N	228881	228881	395850
30258	52143	28	applied	\N	\N	\N	\N	228882	228882	395851
30258	52144	29	applied	\N	\N	\N	\N	228883	228883	395852
30258	52145	30	applied	\N	\N	\N	\N	228884	228884	395853
30258	52146	31	applied	\N	\N	\N	\N	228885	228885	395854
30258	52147	32	applied	\N	\N	\N	\N	228886	228886	395855
30258	52148	33	applied	\N	\N	\N	\N	228887	228887	395856
30258	52150	35	applied	\N	\N	\N	\N	228889	228889	395858
30258	52151	36	applied	\N	\N	\N	\N	228890	228890	395859
30258	52152	37	applied	\N	\N	\N	\N	228891	228891	395860
30258	52153	38	applied	\N	\N	\N	\N	228892	228892	395861
30258	52154	39	applied	\N	\N	\N	\N	228893	228893	395862
30258	52155	40	applied	\N	\N	\N	\N	228894	228894	395863
30259	52115	0	applied	\N	\N	\N	\N	228895	228895	395864
30259	52116	1	applied	\N	\N	\N	\N	228896	228896	395865
30259	52117	2	applied	\N	\N	\N	\N	228897	228897	395866
30259	52118	3	applied	\N	\N	\N	\N	228898	228898	395867
30259	52119	4	applied	\N	\N	\N	\N	228899	228899	395868
30259	52120	5	applied	\N	\N	\N	\N	228900	228900	395869
30259	52121	6	applied	\N	\N	\N	\N	228901	228901	395870
30259	52122	7	applied	\N	\N	\N	\N	228902	228902	395871
30259	52123	8	applied	\N	\N	\N	\N	228903	228903	395872
30259	52124	9	applied	\N	\N	\N	\N	228904	228904	395873
30259	52126	11	applied	\N	\N	\N	\N	228906	228906	395875
30259	52127	12	applied	\N	\N	\N	\N	228907	228907	395876
30259	52128	13	applied	\N	\N	\N	\N	228908	228908	395877
30259	52129	14	applied	\N	\N	\N	\N	228909	228909	395878
30259	52130	15	applied	\N	\N	\N	\N	228910	228910	395879
30259	52131	16	applied	\N	\N	\N	\N	228911	228911	395880
30259	52132	17	applied	\N	\N	\N	\N	228912	228912	395881
30259	52133	18	applied	\N	\N	\N	\N	228913	228913	395882
30259	52134	19	applied	\N	\N	\N	\N	228914	228914	395883
30259	52135	20	applied	\N	\N	\N	\N	228915	228915	395884
30259	52136	21	applied	\N	\N	\N	\N	228916	228916	395885
30259	52137	22	applied	\N	\N	\N	\N	228917	228917	395886
30259	52138	23	applied	\N	\N	\N	\N	228918	228918	395887
30259	52139	24	applied	\N	\N	\N	\N	228919	228919	395888
30259	52140	25	applied	\N	\N	\N	\N	228920	228920	395889
30259	52141	26	applied	\N	\N	\N	\N	228921	228921	395890
30259	52143	28	applied	\N	\N	\N	\N	228923	228923	395892
30259	52144	29	applied	\N	\N	\N	\N	228924	228924	395893
30259	52145	30	applied	\N	\N	\N	\N	228925	228925	395894
30259	52146	31	applied	\N	\N	\N	\N	228926	228926	395895
30259	52147	32	applied	\N	\N	\N	\N	228927	228927	395896
30259	52148	33	applied	\N	\N	\N	\N	228928	228928	395897
30259	52149	34	applied	\N	\N	\N	\N	228929	228929	395898
30259	52150	35	applied	\N	\N	\N	\N	228930	228930	395899
30259	52151	36	applied	\N	\N	\N	\N	228931	228931	395900
30259	52152	37	applied	\N	\N	\N	\N	228932	228932	395901
30259	52153	38	applied	\N	\N	\N	\N	228933	228933	395902
30259	52154	39	applied	\N	\N	\N	\N	228934	228934	395903
30259	52155	40	applied	\N	\N	\N	\N	228935	228935	395904
30264	52186	0	applied	\N	\N	\N	\N	229008	229008	395977
30264	52187	1	applied	\N	\N	\N	\N	229009	229009	395978
30264	52188	2	applied	\N	\N	\N	\N	229010	229010	395979
30264	52190	4	applied	\N	\N	\N	\N	229012	229012	395981
30266	52195	0	applied	\N	\N	\N	\N	229022	229022	395991
30266	52196	1	applied	\N	\N	\N	\N	229023	229023	395992
30266	52197	2	applied	\N	\N	\N	\N	229024	229024	395993
30266	52198	3	applied	\N	\N	\N	\N	229025	229025	395994
30266	52199	4	applied	\N	\N	\N	\N	229026	229026	395995
30273	52265	0	applied	\N	\N	\N	\N	229250	229250	396217
30273	52266	1	applied	\N	\N	\N	\N	229251	229251	396218
30273	52267	2	applied	\N	\N	\N	\N	229252	229252	396219
30273	52268	3	applied	\N	\N	\N	\N	229253	229253	396220
30273	52269	4	applied	\N	\N	1000000000	\N	229254	229254	396221
30273	52270	5	applied	\N	\N	\N	\N	229255	229255	396222
30273	52271	6	applied	\N	\N	\N	\N	229256	229256	396223
30273	52272	7	applied	\N	\N	\N	\N	229257	229257	396224
30273	52273	8	applied	\N	\N	\N	\N	229258	229258	396225
30273	52274	9	applied	\N	\N	\N	\N	229259	229259	396226
30255	52100	3	applied	\N	\N	\N	\N	228803	228803	395772
30261	52138	23	applied	\N	\N	\N	\N	228961	228961	395930
30261	52139	24	applied	\N	\N	\N	\N	228962	228962	395931
30261	52140	25	applied	\N	\N	\N	\N	228963	228963	395932
30261	52141	26	applied	\N	\N	\N	\N	228964	228964	395933
30261	52142	27	applied	\N	\N	\N	\N	228965	228965	395934
30261	52143	28	applied	\N	\N	\N	\N	228966	228966	395935
30261	52144	29	applied	\N	\N	\N	\N	228967	228967	395936
30261	52145	30	applied	\N	\N	\N	\N	228968	228968	395937
30261	52146	31	applied	\N	\N	\N	\N	228969	228969	395938
30261	52147	32	applied	\N	\N	\N	\N	228970	228970	395939
30261	52148	33	applied	\N	\N	\N	\N	228971	228971	395940
30261	52149	34	applied	\N	\N	\N	\N	228972	228972	395941
30261	52150	35	applied	\N	\N	\N	\N	228973	228973	395942
30261	52158	36	applied	\N	\N	\N	\N	228974	228974	395943
30261	52160	38	applied	\N	\N	\N	\N	228976	228976	395945
30261	52161	39	applied	\N	\N	\N	\N	228977	228977	395946
30261	52162	40	applied	\N	\N	\N	\N	228978	228978	395947
30261	52151	41	applied	\N	\N	\N	\N	228979	228979	395948
30266	52200	5	applied	\N	\N	\N	\N	229027	229027	395996
30266	52201	6	applied	\N	\N	\N	\N	229028	229028	395997
30266	52202	7	applied	\N	\N	\N	\N	229029	229029	395998
30266	52203	8	applied	\N	\N	\N	\N	229030	229030	395999
30266	52191	9	applied	\N	\N	\N	\N	229031	229031	396000
30266	52192	10	applied	\N	\N	\N	\N	229032	229032	396001
30266	52193	11	applied	\N	\N	\N	\N	229033	229033	396002
30266	52194	12	applied	\N	\N	\N	\N	229034	229034	396003
30266	52204	13	applied	\N	\N	\N	\N	229035	229035	396004
30266	52205	15	applied	\N	\N	\N	\N	229036	229036	396005
30266	52206	16	applied	\N	\N	\N	\N	229037	229037	396006
30266	52207	17	applied	\N	\N	\N	\N	229038	229038	396007
30266	52209	19	applied	\N	\N	\N	\N	229040	229040	396009
30266	52210	20	applied	\N	\N	\N	\N	229041	229041	396010
30266	52211	21	applied	\N	\N	\N	\N	229042	229042	396011
30266	52212	22	applied	\N	\N	\N	\N	229043	229043	396012
30266	52213	23	applied	\N	\N	\N	\N	229044	229044	396013
30266	52214	24	applied	\N	\N	\N	\N	229045	229045	396014
30266	52215	25	applied	\N	\N	\N	\N	229046	229046	396015
30266	52216	26	applied	\N	\N	\N	\N	229047	229047	396016
30266	52217	27	applied	\N	\N	\N	\N	229048	229048	396017
30266	52218	28	applied	\N	\N	\N	\N	229049	229049	396018
30266	52219	29	applied	\N	\N	\N	\N	229050	229050	396019
30266	52220	30	applied	\N	\N	\N	\N	229051	229051	396020
30266	52221	31	applied	\N	\N	\N	\N	229052	229052	396021
30266	52222	32	applied	\N	\N	\N	\N	229053	229053	396022
30266	52223	33	applied	\N	\N	\N	\N	229054	229054	396023
30269	52224	0	applied	\N	\N	\N	\N	229198	229198	396165
30269	52226	2	applied	\N	\N	1000000000	\N	229200	229200	396167
30269	52228	3	applied	\N	\N	\N	\N	229201	229201	396168
30269	52229	4	applied	\N	\N	\N	\N	229202	229202	396169
30269	52230	5	applied	\N	\N	\N	\N	229203	229203	396170
30269	52239	6	applied	\N	\N	\N	\N	229204	229204	396171
30269	52240	7	applied	\N	\N	\N	\N	229205	229205	396172
30269	52241	8	applied	\N	\N	\N	\N	229206	229206	396173
30269	52242	9	applied	\N	\N	\N	\N	229207	229207	396174
30269	52243	10	applied	\N	\N	\N	\N	229208	229208	396175
30271	52254	0	applied	\N	\N	\N	\N	229228	229228	396195
30271	52255	1	applied	\N	\N	\N	\N	229229	229229	396196
30271	52256	2	applied	\N	\N	\N	\N	229230	229230	396197
30271	52257	3	applied	\N	\N	\N	\N	229231	229231	396198
30271	52258	4	applied	\N	\N	\N	\N	229232	229232	396199
30271	52259	5	applied	\N	\N	\N	\N	229233	229233	396200
30271	52260	6	applied	\N	\N	\N	\N	229234	229234	396201
30271	52262	8	applied	\N	\N	\N	\N	229236	229236	396203
30271	52263	9	applied	\N	\N	\N	\N	229237	229237	396204
30271	52264	10	applied	\N	\N	\N	\N	229238	229238	396205
30275	52304	0	applied	\N	\N	\N	\N	229311	229311	396278
30275	52305	1	applied	\N	\N	\N	\N	229312	229312	396279
30275	52306	2	applied	\N	\N	\N	\N	229313	229313	396280
30275	52307	3	applied	\N	\N	\N	\N	229314	229314	396281
30288	52354	0	applied	\N	\N	\N	\N	229424	229424	396391
30288	52355	1	applied	\N	\N	\N	\N	229425	229425	396392
30288	52356	2	applied	\N	\N	\N	\N	229426	229426	396393
30288	52357	3	applied	\N	\N	\N	\N	229427	229427	396394
30288	52358	4	applied	\N	\N	\N	\N	229428	229428	396395
30295	52367	0	applied	\N	\N	\N	\N	229501	229501	396468
30295	52368	1	applied	\N	\N	\N	\N	229502	229502	396469
30295	52369	2	applied	\N	\N	\N	\N	229503	229503	396470
30295	52370	3	applied	\N	\N	\N	\N	229504	229504	396471
30295	52372	5	applied	\N	\N	\N	\N	229506	229506	396473
30295	52373	6	applied	\N	\N	\N	\N	229507	229507	396474
30301	52374	0	applied	\N	\N	\N	\N	229545	229545	229545
30301	52377	1	applied	\N	\N	\N	\N	229546	229546	229546
30301	52378	2	applied	\N	\N	\N	\N	229547	229547	229547
30301	52375	3	applied	\N	\N	\N	\N	229548	229548	396505
30301	52368	4	applied	\N	\N	\N	\N	229549	229549	396506
30301	52369	5	applied	\N	\N	\N	\N	229550	229550	396507
30301	52376	6	applied	\N	\N	\N	\N	229551	229551	396508
30301	52379	7	applied	\N	\N	\N	\N	229552	229552	396509
30301	52380	8	applied	\N	\N	\N	\N	229553	229553	396510
30301	52381	9	applied	\N	\N	\N	\N	229554	229554	396511
30304	52389	0	applied	\N	\N	\N	\N	229565	229565	396522
30304	52390	1	applied	\N	\N	\N	\N	229566	229566	396523
30304	52391	2	applied	\N	\N	\N	\N	229567	229567	396524
30304	52392	3	applied	\N	\N	\N	\N	229568	229568	396525
30304	52394	5	applied	\N	\N	\N	\N	229570	229570	396527
30304	52395	6	applied	\N	\N	\N	\N	229571	229571	396528
30306	52382	0	applied	\N	\N	\N	\N	229579	229579	396536
30306	52389	1	applied	\N	\N	\N	\N	229580	229580	396537
30306	52390	2	applied	\N	\N	\N	\N	229581	229581	396538
30306	52391	3	applied	\N	\N	\N	\N	229582	229582	396539
30306	52392	4	applied	\N	\N	\N	\N	229583	229583	396540
30306	52383	5	applied	\N	\N	\N	\N	229584	229584	396541
30306	52394	6	applied	\N	\N	\N	\N	229585	229585	396542
30306	52385	7	applied	\N	\N	\N	\N	229586	229586	396543
30309	52396	0	applied	\N	\N	\N	\N	229591	229591	396548
30309	52397	1	applied	\N	\N	\N	\N	229592	229592	396549
30310	52396	0	applied	\N	\N	\N	\N	229593	229593	396550
30310	52397	1	applied	\N	\N	\N	\N	229594	229594	396551
30315	52398	0	applied	\N	\N	\N	\N	229607	229607	396564
30315	52399	1	applied	\N	\N	\N	\N	229608	229608	396565
30261	52137	22	applied	\N	\N	\N	\N	228960	228960	395929
30261	52155	46	applied	\N	\N	\N	\N	228984	228984	395953
30261	52164	47	applied	\N	\N	\N	\N	228985	228985	395954
30261	52165	48	applied	\N	\N	\N	\N	228986	228986	395955
30263	52166	0	applied	\N	\N	\N	\N	229007	229007	395976
30265	52186	0	applied	\N	\N	\N	\N	229013	229013	395982
30265	52187	1	applied	\N	\N	\N	\N	229014	229014	395983
30265	52188	2	applied	\N	\N	\N	\N	229015	229015	395984
30265	52189	3	applied	\N	\N	\N	\N	229016	229016	395985
30265	52190	4	applied	\N	\N	\N	\N	229017	229017	395986
30265	52191	5	applied	\N	\N	\N	\N	229018	229018	395987
30265	52192	6	applied	\N	\N	\N	\N	229019	229019	395988
30265	52193	7	applied	\N	\N	\N	\N	229020	229020	395989
30265	52194	8	applied	\N	\N	\N	\N	229021	229021	395990
30267	52115	0	applied	\N	\N	\N	\N	229055	229055	396024
30267	52166	2	applied	\N	\N	\N	\N	229057	229057	396026
30267	51365	3	applied	\N	\N	1000000000	\N	229058	229058	396027
30267	51788	4	applied	\N	\N	\N	\N	229059	229059	396028
30267	51245	5	applied	\N	\N	\N	\N	229060	229060	396029
30267	51254	6	applied	\N	\N	\N	\N	229061	229061	396030
30267	51255	7	applied	\N	\N	\N	\N	229062	229062	396031
30267	51256	8	applied	\N	\N	\N	\N	229063	229063	396032
30267	51282	9	applied	\N	\N	\N	\N	229064	229064	396033
30267	51291	10	applied	\N	\N	\N	\N	229065	229065	396034
30267	51300	11	applied	\N	\N	\N	\N	229066	229066	396035
30267	51309	12	applied	\N	\N	\N	\N	229067	229067	396036
30267	51310	13	applied	\N	\N	\N	\N	229068	229068	396037
30267	51328	14	applied	\N	\N	\N	\N	229069	229069	396038
30267	51337	15	applied	\N	\N	\N	\N	229070	229070	396039
30267	51338	16	applied	\N	\N	\N	\N	229071	229071	396040
30267	51339	17	applied	\N	\N	\N	\N	229072	229072	396041
30267	51367	19	applied	\N	\N	\N	\N	229074	229074	396043
30267	51392	20	applied	\N	\N	\N	\N	229075	229075	396044
30267	51396	21	applied	\N	\N	\N	\N	229076	229076	396045
30267	51397	22	applied	\N	\N	\N	\N	229077	229077	396046
30267	51415	23	applied	\N	\N	\N	\N	229078	229078	396047
30267	51416	24	applied	\N	\N	\N	\N	229079	229079	396048
30267	51417	25	applied	\N	\N	\N	\N	229080	229080	396049
30267	51443	26	applied	\N	\N	\N	\N	229081	229081	396050
30267	51444	27	applied	\N	\N	\N	\N	229082	229082	396051
30267	51463	28	applied	\N	\N	\N	\N	229083	229083	396052
30267	51482	29	applied	\N	\N	\N	\N	229084	229084	396053
30267	51490	30	applied	\N	\N	\N	\N	229085	229085	396054
30267	51501	31	applied	\N	\N	\N	\N	229086	229086	396055
30267	51508	32	applied	\N	\N	\N	\N	229087	229087	396056
30267	51518	33	applied	\N	\N	\N	\N	229088	229088	396057
30267	51527	34	applied	\N	\N	\N	\N	229089	229089	396058
30267	51546	36	applied	\N	\N	\N	\N	229091	229091	396060
30267	51554	37	applied	\N	\N	\N	\N	229092	229092	396061
30267	51564	38	applied	\N	\N	\N	\N	229093	229093	396062
30267	51565	39	applied	\N	\N	\N	\N	229094	229094	396063
30267	51566	40	applied	\N	\N	\N	\N	229095	229095	396064
30267	51567	41	applied	\N	\N	\N	\N	229096	229096	396065
30267	51568	42	applied	\N	\N	\N	\N	229097	229097	396066
30267	51614	43	applied	\N	\N	\N	\N	229098	229098	396067
30267	51623	44	applied	\N	\N	\N	\N	229099	229099	396068
30267	51631	45	applied	\N	\N	\N	\N	229100	229100	396069
30267	51639	46	applied	\N	\N	\N	\N	229101	229101	396070
30267	51650	47	applied	\N	\N	\N	\N	229102	229102	396071
30267	51651	48	applied	\N	\N	\N	\N	229103	229103	396072
30267	51652	49	applied	\N	\N	\N	\N	229104	229104	396073
30267	51653	50	applied	\N	\N	\N	\N	229105	229105	396074
30267	51689	51	applied	\N	\N	\N	\N	229106	229106	396075
30267	51706	53	applied	\N	\N	\N	\N	229108	229108	396077
30267	51715	54	applied	\N	\N	\N	\N	229109	229109	396078
30267	51725	55	applied	\N	\N	\N	\N	229110	229110	396079
30267	51726	56	applied	\N	\N	\N	\N	229111	229111	396080
30267	51744	57	applied	\N	\N	\N	\N	229112	229112	396081
30267	51752	58	applied	\N	\N	\N	\N	229113	229113	396082
30267	51761	59	applied	\N	\N	\N	\N	229114	229114	396083
30267	51768	60	applied	\N	\N	\N	\N	229115	229115	396084
30267	51769	61	applied	\N	\N	\N	\N	229116	229116	396085
30267	51789	62	applied	\N	\N	\N	\N	229117	229117	396086
30267	51831	63	applied	\N	\N	\N	\N	229118	229118	396087
30267	51848	64	applied	\N	\N	\N	\N	229119	229119	396088
30267	51849	65	applied	\N	\N	\N	\N	229120	229120	396089
30267	51869	66	applied	\N	\N	\N	\N	229121	229121	396090
30267	51880	67	applied	\N	\N	\N	\N	229122	229122	396091
30267	51881	68	applied	\N	\N	\N	\N	229123	229123	396092
30267	51913	70	applied	\N	\N	\N	\N	229125	229125	396094
30267	51922	71	applied	\N	\N	\N	\N	229126	229126	396095
30267	51930	72	applied	\N	\N	\N	\N	229127	229127	396096
30267	51939	73	applied	\N	\N	\N	\N	229128	229128	396097
30267	51950	74	applied	\N	\N	\N	\N	229129	229129	396098
30267	51951	75	applied	\N	\N	\N	\N	229130	229130	396099
30267	51952	76	applied	\N	\N	\N	\N	229131	229131	396100
30267	51977	77	applied	\N	\N	\N	\N	229132	229132	396101
30267	51987	78	applied	\N	\N	\N	\N	229133	229133	396102
30267	51988	79	applied	\N	\N	\N	\N	229134	229134	396103
30267	52005	80	applied	\N	\N	\N	\N	229135	229135	396104
30267	52013	81	applied	\N	\N	\N	\N	229136	229136	396105
30267	52023	82	applied	\N	\N	\N	\N	229137	229137	396106
30267	52031	83	applied	\N	\N	\N	\N	229138	229138	396107
30267	52032	84	applied	\N	\N	\N	\N	229139	229139	396108
30267	52050	85	applied	\N	\N	\N	\N	229140	229140	396109
30267	52069	87	applied	\N	\N	\N	\N	229142	229142	396111
30267	52080	88	applied	\N	\N	\N	\N	229143	229143	396112
30267	52088	89	applied	\N	\N	\N	\N	229144	229144	396113
30267	52097	90	applied	\N	\N	\N	\N	229145	229145	396114
30267	52098	91	applied	\N	\N	\N	\N	229146	229146	396115
30267	52116	92	applied	\N	\N	\N	\N	229147	229147	396116
30267	52117	93	applied	\N	\N	\N	\N	229148	229148	396117
30267	52118	94	applied	\N	\N	\N	\N	229149	229149	396118
30267	52119	95	applied	\N	\N	\N	\N	229150	229150	396119
30267	52156	96	applied	\N	\N	\N	\N	229151	229151	396120
30267	52167	97	applied	\N	\N	\N	\N	229152	229152	396121
30267	52168	98	applied	\N	\N	\N	\N	229153	229153	396122
30267	52186	99	applied	\N	\N	\N	\N	229154	229154	396123
30267	52195	100	applied	\N	\N	\N	\N	229155	229155	396124
30267	52196	101	applied	\N	\N	\N	\N	229156	229156	396125
30267	52197	102	applied	\N	\N	\N	\N	229157	229157	396126
30261	52154	45	applied	\N	\N	\N	\N	228983	228983	395952
30267	51847	107	applied	\N	\N	\N	\N	229162	229162	396131
30267	51868	108	applied	\N	\N	\N	\N	229163	229163	396132
30267	51246	109	applied	\N	\N	\N	\N	229164	229164	396133
30267	51874	111	applied	\N	\N	1000000000	\N	229166	229166	396134
30267	51884	112	applied	\N	\N	1000000000	\N	229167	229167	396135
30267	51885	113	applied	\N	\N	1000000000	\N	229168	229168	396136
30267	51886	114	applied	\N	\N	1000000000	\N	229169	229169	396137
30267	51247	116	applied	\N	\N	\N	\N	229170	229170	396138
30267	51248	117	applied	\N	\N	\N	\N	229171	229171	396139
30267	51249	118	applied	\N	\N	\N	\N	229172	229172	396140
30267	51250	119	applied	\N	\N	\N	\N	229173	229173	396141
30267	52074	120	applied	\N	\N	1000000000	\N	229174	229174	396142
30267	52075	121	applied	\N	\N	\N	\N	229175	229175	396143
30267	51394	122	applied	\N	\N	\N	\N	229176	229176	229176
30267	51520	123	applied	\N	\N	1000000000	\N	229177	229177	396144
30270	52235	11	applied	\N	\N	\N	\N	229220	229220	396187
30270	52236	12	applied	\N	\N	\N	\N	229221	229221	396188
30270	52238	14	applied	\N	\N	\N	\N	229223	229223	396190
30270	52250	15	applied	\N	\N	\N	\N	229224	229224	396191
30270	52251	16	applied	\N	\N	\N	\N	229225	229225	396192
30270	52252	17	applied	\N	\N	\N	\N	229226	229226	396193
30270	52253	18	applied	\N	\N	\N	\N	229227	229227	396194
30272	52254	0	applied	\N	\N	\N	\N	229239	229239	396206
30272	52255	1	applied	\N	\N	\N	\N	229240	229240	396207
30272	52256	2	applied	\N	\N	\N	\N	229241	229241	396208
30272	52257	3	applied	\N	\N	\N	\N	229242	229242	396209
30272	52258	4	applied	\N	\N	\N	\N	229243	229243	396210
30272	52259	5	applied	\N	\N	\N	\N	229244	229244	396211
30272	52260	6	applied	\N	\N	\N	\N	229245	229245	396212
30272	52261	7	applied	\N	\N	\N	\N	229246	229246	396213
30272	52262	8	applied	\N	\N	\N	\N	229247	229247	396214
30272	52263	9	applied	\N	\N	\N	\N	229248	229248	396215
30272	52264	10	applied	\N	\N	\N	\N	229249	229249	396216
30274	52266	1	applied	\N	\N	\N	\N	229273	229273	396240
30274	52267	2	applied	\N	\N	\N	\N	229274	229274	396241
30274	52268	3	applied	\N	\N	\N	\N	229275	229275	396242
30274	52269	4	applied	\N	\N	1000000000	\N	229276	229276	396243
30274	52270	5	applied	\N	\N	\N	\N	229277	229277	396244
30274	52271	6	applied	\N	\N	\N	\N	229278	229278	396245
30274	52287	7	applied	\N	\N	\N	\N	229279	229279	396246
30274	52288	8	applied	\N	\N	\N	\N	229280	229280	396247
30274	52272	9	applied	\N	\N	\N	\N	229281	229281	396248
30274	52289	10	applied	\N	\N	\N	\N	229282	229282	396249
30274	52290	11	applied	\N	\N	\N	\N	229283	229283	396250
30274	52273	12	applied	\N	\N	\N	\N	229284	229284	396251
30274	52274	13	applied	\N	\N	\N	\N	229285	229285	396252
30274	52275	14	applied	\N	\N	\N	\N	229286	229286	396253
30276	52308	0	applied	\N	\N	\N	\N	229315	229315	396282
30276	52309	1	applied	\N	\N	\N	\N	229316	229316	396283
30276	52287	3	applied	\N	\N	\N	\N	229318	229318	396285
30276	52288	4	applied	\N	\N	\N	\N	229319	229319	396286
30276	52289	5	applied	\N	\N	\N	\N	229320	229320	396287
30276	52311	6	applied	\N	\N	\N	\N	229321	229321	396288
30276	52312	7	applied	\N	\N	\N	\N	229322	229322	396289
30276	52313	8	applied	\N	\N	\N	\N	229323	229323	396290
30276	52290	9	applied	\N	\N	\N	\N	229324	229324	396291
30276	52291	10	applied	\N	\N	\N	\N	229325	229325	396292
30276	52292	11	applied	\N	\N	\N	\N	229326	229326	396293
30276	52293	12	applied	\N	\N	\N	\N	229327	229327	396294
30276	52294	13	applied	\N	\N	\N	\N	229328	229328	396295
30276	52295	14	applied	\N	\N	\N	\N	229329	229329	396296
30276	52296	15	applied	\N	\N	\N	\N	229330	229330	396297
30276	52297	16	applied	\N	\N	\N	\N	229331	229331	396298
30276	52298	17	applied	\N	\N	\N	\N	229332	229332	396299
30276	52299	18	applied	\N	\N	\N	\N	229333	229333	396300
30276	52301	20	applied	\N	\N	\N	\N	229335	229335	396302
30276	52302	21	applied	\N	\N	\N	\N	229336	229336	396303
30276	52303	22	applied	\N	\N	\N	\N	229337	229337	396304
30276	52314	23	applied	\N	\N	\N	\N	229338	229338	396305
30276	52315	25	applied	\N	\N	\N	\N	229339	229339	396306
30276	52316	26	applied	\N	\N	\N	\N	229340	229340	396307
30276	52317	27	applied	\N	\N	\N	\N	229341	229341	396308
30276	52318	28	applied	\N	\N	\N	\N	229342	229342	396309
30276	52319	29	applied	\N	\N	\N	\N	229343	229343	396310
30276	52320	30	applied	\N	\N	\N	\N	229344	229344	396311
30276	52321	31	applied	\N	\N	\N	\N	229345	229345	396312
30276	52322	32	applied	\N	\N	\N	\N	229346	229346	396313
30278	52334	0	applied	\N	\N	\N	\N	229358	229358	396325
30278	52335	1	applied	\N	\N	\N	\N	229359	229359	396326
30278	52336	2	applied	\N	\N	\N	\N	229360	229360	396327
30278	52338	4	applied	\N	\N	\N	\N	229362	229362	396329
30278	52339	5	applied	\N	\N	\N	\N	229363	229363	396330
30278	52340	6	applied	\N	\N	\N	\N	229364	229364	396331
30278	52341	7	applied	\N	\N	\N	\N	229365	229365	396332
30280	52115	0	applied	\N	\N	\N	\N	229374	229374	396341
30280	52030	1	applied	\N	\N	\N	\N	229375	229375	396342
30280	52166	2	applied	\N	\N	\N	\N	229376	229376	396343
30280	52120	3	applied	\N	\N	\N	\N	229377	229377	396344
30280	52226	4	applied	\N	\N	1000000000	\N	229378	229378	396345
30280	52269	5	applied	\N	\N	1000000000	\N	229379	229379	396346
30280	52255	6	applied	\N	\N	\N	\N	229380	229380	396347
30280	52074	7	applied	\N	\N	1000000000	\N	229381	229381	396348
30280	52075	8	applied	\N	\N	\N	\N	229382	229382	396349
30280	52331	9	applied	\N	\N	\N	\N	229383	229383	396350
30280	52337	10	applied	\N	\N	1000000000	\N	229384	229384	396351
30282	52342	0	applied	\N	\N	\N	\N	229393	229393	396360
30282	52343	1	applied	\N	\N	\N	\N	229394	229394	396361
30282	52344	2	applied	\N	\N	\N	\N	229395	229395	396362
30282	52345	3	applied	\N	\N	\N	\N	229396	229396	396363
30289	52354	0	applied	\N	\N	\N	\N	229429	229429	396396
30289	52355	1	applied	\N	\N	\N	\N	229430	229430	396397
30289	52359	2	applied	\N	\N	\N	\N	229431	229431	396398
30289	52356	3	applied	\N	\N	\N	\N	229432	229432	396399
30289	52360	4	applied	\N	\N	\N	\N	229433	229433	396400
30289	52357	5	applied	\N	\N	\N	\N	229434	229434	396401
30289	52358	6	applied	\N	\N	\N	\N	229435	229435	396402
30289	52361	7	applied	\N	\N	\N	\N	229436	229436	396403
30267	51798	105	applied	\N	\N	\N	\N	229160	229160	396129
30267	51799	106	applied	\N	\N	\N	\N	229161	229161	396130
30273	52279	14	applied	\N	\N	\N	\N	229264	229264	396231
30273	52280	15	applied	\N	\N	\N	\N	229265	229265	396232
30273	52281	16	applied	\N	\N	\N	\N	229266	229266	396233
30273	52282	17	applied	\N	\N	\N	\N	229267	229267	396234
30273	52283	18	applied	\N	\N	\N	\N	229268	229268	396235
30273	52284	19	applied	\N	\N	\N	\N	229269	229269	396236
30273	52285	20	applied	\N	\N	\N	\N	229270	229270	396237
30273	52286	21	applied	\N	\N	\N	\N	229271	229271	396238
30274	52276	15	applied	\N	\N	\N	\N	229287	229287	396254
30274	52277	16	applied	\N	\N	\N	\N	229288	229288	396255
30274	52291	17	applied	\N	\N	\N	\N	229289	229289	396256
30274	52292	18	applied	\N	\N	\N	\N	229290	229290	396257
30274	52294	20	applied	\N	\N	\N	\N	229292	229292	396259
30274	52295	21	applied	\N	\N	\N	\N	229293	229293	396260
30274	52296	22	applied	\N	\N	\N	\N	229294	229294	396261
30274	52297	23	applied	\N	\N	\N	\N	229295	229295	396262
30274	52298	24	applied	\N	\N	\N	\N	229296	229296	396263
30274	52299	25	applied	\N	\N	\N	\N	229297	229297	396264
30274	52278	26	applied	\N	\N	\N	\N	229298	229298	396265
30274	52279	27	applied	\N	\N	\N	\N	229299	229299	396266
30274	52280	28	applied	\N	\N	\N	\N	229300	229300	396267
30274	52281	29	applied	\N	\N	\N	\N	229301	229301	396268
30274	52282	30	applied	\N	\N	\N	\N	229302	229302	396269
30274	52283	31	applied	\N	\N	\N	\N	229303	229303	396270
30274	52284	32	applied	\N	\N	\N	\N	229304	229304	396271
30274	52285	33	applied	\N	\N	\N	\N	229305	229305	396272
30274	52286	34	applied	\N	\N	\N	\N	229306	229306	396273
30274	52300	35	applied	\N	\N	\N	\N	229307	229307	396274
30274	52302	37	applied	\N	\N	\N	\N	229309	229309	396276
30274	52303	38	applied	\N	\N	\N	\N	229310	229310	396277
30277	52323	0	applied	\N	\N	\N	\N	229347	229347	396314
30277	52324	1	applied	\N	\N	\N	\N	229348	229348	396315
30277	52325	2	applied	\N	\N	\N	\N	229349	229349	396316
30277	52326	3	applied	\N	\N	\N	\N	229350	229350	396317
30277	52327	4	applied	\N	\N	\N	\N	229351	229351	396318
30277	52328	5	applied	\N	\N	\N	\N	229352	229352	396319
30277	52329	6	applied	\N	\N	\N	\N	229353	229353	396320
30277	52330	7	applied	\N	\N	\N	\N	229354	229354	396321
30277	52331	8	applied	\N	\N	\N	\N	229355	229355	396322
30277	52332	9	applied	\N	\N	\N	\N	229356	229356	396323
30277	52333	10	applied	\N	\N	\N	\N	229357	229357	396324
30279	52334	0	applied	\N	\N	\N	\N	229366	229366	396333
30279	52335	1	applied	\N	\N	\N	\N	229367	229367	396334
30279	52336	2	applied	\N	\N	\N	\N	229368	229368	396335
30279	52338	4	applied	\N	\N	\N	\N	229370	229370	396337
30279	52339	5	applied	\N	\N	\N	\N	229371	229371	396338
30279	52340	6	applied	\N	\N	\N	\N	229372	229372	396339
30279	52341	7	applied	\N	\N	\N	\N	229373	229373	396340
30281	52334	0	applied	\N	\N	\N	\N	229385	229385	396352
30281	52335	1	applied	\N	\N	\N	\N	229386	229386	396353
30281	52336	2	applied	\N	\N	\N	\N	229387	229387	396354
30281	52337	3	applied	\N	\N	1000000000	\N	229388	229388	396355
30281	52338	4	applied	\N	\N	\N	\N	229389	229389	396356
30281	52339	5	applied	\N	\N	\N	\N	229390	229390	396357
30281	52340	6	applied	\N	\N	\N	\N	229391	229391	396358
30281	52341	7	applied	\N	\N	\N	\N	229392	229392	396359
30283	52342	0	applied	\N	\N	\N	\N	229398	229398	396365
30283	52343	1	applied	\N	\N	\N	\N	229399	229399	396366
30283	52344	2	applied	\N	\N	\N	\N	229400	229400	396367
30284	52348	0	applied	\N	\N	\N	\N	229404	229404	396371
30284	52349	1	applied	\N	\N	\N	\N	229405	229405	396372
30286	52348	0	applied	\N	\N	\N	\N	229412	229412	396379
30286	52351	2	applied	\N	\N	\N	\N	229414	229414	396381
30286	52349	3	applied	\N	\N	\N	\N	229415	229415	396382
30286	52352	4	applied	\N	\N	\N	\N	229416	229416	396383
30286	52353	5	applied	\N	\N	\N	\N	229417	229417	396384
30290	52354	0	applied	\N	\N	\N	\N	229442	229442	396409
30290	52355	1	applied	\N	\N	\N	\N	229443	229443	396410
30290	52359	2	applied	\N	\N	\N	\N	229444	229444	396411
30290	52356	3	applied	\N	\N	\N	\N	229445	229445	396412
30290	52360	4	applied	\N	\N	\N	\N	229446	229446	396413
30290	52357	5	applied	\N	\N	\N	\N	229447	229447	396414
30290	52358	6	applied	\N	\N	\N	\N	229448	229448	396415
30290	52361	7	applied	\N	\N	\N	\N	229449	229449	396416
30290	52362	8	applied	\N	\N	\N	\N	229450	229450	396417
30290	52363	9	applied	\N	\N	\N	\N	229451	229451	396418
30290	52364	10	applied	\N	\N	\N	\N	229452	229452	396419
30290	52365	11	applied	\N	\N	\N	\N	229453	229453	396420
30292	52354	0	applied	\N	\N	\N	\N	229468	229468	396435
30292	52355	1	applied	\N	\N	\N	\N	229469	229469	396436
30292	52359	2	applied	\N	\N	\N	\N	229470	229470	396437
30292	52356	3	applied	\N	\N	\N	\N	229471	229471	396438
30292	52360	4	applied	\N	\N	\N	\N	229472	229472	396439
30292	52357	5	applied	\N	\N	\N	\N	229473	229473	396440
30292	52358	6	applied	\N	\N	\N	\N	229474	229474	396441
30292	52361	7	applied	\N	\N	\N	\N	229475	229475	396442
30292	52362	8	applied	\N	\N	\N	\N	229476	229476	396443
30292	52363	9	applied	\N	\N	\N	\N	229477	229477	396444
30292	52364	10	applied	\N	\N	\N	\N	229478	229478	396445
30292	52365	11	applied	\N	\N	\N	\N	229479	229479	396446
30292	52366	12	applied	\N	\N	\N	\N	229480	229480	396447
30293	52354	0	applied	\N	\N	\N	\N	229481	229481	396448
30293	52355	1	applied	\N	\N	\N	\N	229482	229482	396449
30293	52359	2	applied	\N	\N	\N	\N	229483	229483	396450
30293	52360	4	applied	\N	\N	\N	\N	229485	229485	396452
30293	52357	5	applied	\N	\N	\N	\N	229486	229486	396453
30293	52358	6	applied	\N	\N	\N	\N	229487	229487	396454
30293	52361	7	applied	\N	\N	\N	\N	229488	229488	396455
30293	52362	8	applied	\N	\N	\N	\N	229489	229489	396456
30293	52363	9	applied	\N	\N	\N	\N	229490	229490	396457
30293	52364	10	applied	\N	\N	\N	\N	229491	229491	396458
30293	52365	11	applied	\N	\N	\N	\N	229492	229492	396459
30293	52366	12	applied	\N	\N	\N	\N	229493	229493	396460
30299	52374	0	applied	\N	\N	\N	\N	229525	229525	229525
30299	52377	1	applied	\N	\N	\N	\N	229526	229526	229526
30299	52378	2	applied	\N	\N	\N	\N	229527	229527	229527
30299	52375	3	applied	\N	\N	\N	\N	229528	229528	396491
30299	52368	4	applied	\N	\N	\N	\N	229529	229529	396492
30299	52369	5	applied	\N	\N	\N	\N	229530	229530	396493
30273	52276	11	applied	\N	\N	\N	\N	229261	229261	396228
30273	52278	13	applied	\N	\N	\N	\N	229263	229263	396230
30285	52348	0	applied	\N	\N	\N	\N	229406	229406	396373
30285	52351	2	applied	\N	\N	\N	\N	229408	229408	396375
30285	52349	3	applied	\N	\N	\N	\N	229409	229409	396376
30285	52352	4	applied	\N	\N	\N	\N	229410	229410	396377
30285	52353	5	applied	\N	\N	\N	\N	229411	229411	396378
30287	52348	0	applied	\N	\N	\N	\N	229418	229418	396385
30287	52350	1	applied	\N	\N	\N	\N	229419	229419	396386
30287	52351	2	applied	\N	\N	\N	\N	229420	229420	396387
30287	52349	3	applied	\N	\N	\N	\N	229421	229421	396388
30287	52352	4	applied	\N	\N	\N	\N	229422	229422	396389
30287	52353	5	applied	\N	\N	\N	\N	229423	229423	396390
30289	52362	8	applied	\N	\N	\N	\N	229437	229437	396404
30289	52363	9	applied	\N	\N	\N	\N	229438	229438	396405
30289	52364	10	applied	\N	\N	\N	\N	229439	229439	396406
30289	52365	11	applied	\N	\N	\N	\N	229440	229440	396407
30289	52366	12	applied	\N	\N	\N	\N	229441	229441	396408
30291	52354	0	applied	\N	\N	\N	\N	229455	229455	396422
30291	52359	2	applied	\N	\N	\N	\N	229457	229457	396424
30291	52356	3	applied	\N	\N	\N	\N	229458	229458	396425
30291	52360	4	applied	\N	\N	\N	\N	229459	229459	396426
30291	52357	5	applied	\N	\N	\N	\N	229460	229460	396427
30291	52358	6	applied	\N	\N	\N	\N	229461	229461	396428
30291	52361	7	applied	\N	\N	\N	\N	229462	229462	396429
30291	52362	8	applied	\N	\N	\N	\N	229463	229463	396430
30291	52363	9	applied	\N	\N	\N	\N	229464	229464	396431
30291	52364	10	applied	\N	\N	\N	\N	229465	229465	396432
30291	52365	11	applied	\N	\N	\N	\N	229466	229466	396433
30291	52366	12	applied	\N	\N	\N	\N	229467	229467	396434
30294	52367	0	applied	\N	\N	\N	\N	229494	229494	396461
30294	52368	1	applied	\N	\N	\N	\N	229495	229495	396462
30294	52369	2	applied	\N	\N	\N	\N	229496	229496	396463
30294	52370	3	applied	\N	\N	\N	\N	229497	229497	396464
30294	52371	4	applied	\N	\N	\N	\N	229498	229498	396465
30294	52373	6	applied	\N	\N	\N	\N	229500	229500	396467
30296	52367	0	applied	\N	\N	\N	\N	229508	229508	396475
30296	52368	1	applied	\N	\N	\N	\N	229509	229509	396476
30296	52369	2	applied	\N	\N	\N	\N	229510	229510	396477
30296	52370	3	applied	\N	\N	\N	\N	229511	229511	396478
30296	52371	4	applied	\N	\N	\N	\N	229512	229512	396479
30296	52372	5	applied	\N	\N	\N	\N	229513	229513	396480
30296	52373	6	applied	\N	\N	\N	\N	229514	229514	396481
30297	52367	0	applied	\N	\N	\N	\N	229515	229515	396482
30297	52370	1	applied	\N	\N	\N	\N	229516	229516	396483
30297	52371	2	applied	\N	\N	\N	\N	229517	229517	396484
30297	52372	3	applied	\N	\N	\N	\N	229518	229518	396485
30297	52373	4	applied	\N	\N	\N	\N	229519	229519	396486
30298	52374	0	applied	\N	\N	\N	\N	229520	229520	229520
30298	52375	1	applied	\N	\N	\N	\N	229521	229521	396487
30298	52368	2	applied	\N	\N	\N	\N	229522	229522	396488
30298	52376	4	applied	\N	\N	\N	\N	229524	229524	396490
30299	52376	6	applied	\N	\N	\N	\N	229531	229531	396494
30299	52379	7	applied	\N	\N	\N	\N	229532	229532	396495
30299	52380	8	applied	\N	\N	\N	\N	229533	229533	396496
30299	52381	9	applied	\N	\N	\N	\N	229534	229534	396497
30300	52374	0	applied	\N	\N	\N	\N	229535	229535	229535
30300	52377	1	applied	\N	\N	\N	\N	229536	229536	229536
30300	52378	2	applied	\N	\N	\N	\N	229537	229537	229537
30300	52375	3	applied	\N	\N	\N	\N	229538	229538	396498
30300	52368	4	applied	\N	\N	\N	\N	229539	229539	396499
30300	52369	5	applied	\N	\N	\N	\N	229540	229540	396500
30300	52376	6	applied	\N	\N	\N	\N	229541	229541	396501
30300	52379	7	applied	\N	\N	\N	\N	229542	229542	396502
30300	52380	8	applied	\N	\N	\N	\N	229543	229543	396503
30300	52381	9	applied	\N	\N	\N	\N	229544	229544	396504
30302	52382	0	applied	\N	\N	\N	\N	229555	229555	396512
30302	52384	2	applied	\N	\N	\N	\N	229557	229557	396514
30302	52385	3	applied	\N	\N	\N	\N	229558	229558	396515
30302	52386	4	applied	\N	\N	\N	\N	229559	229559	396516
30302	52387	5	applied	\N	\N	\N	\N	229560	229560	396517
30302	52388	6	applied	\N	\N	\N	\N	229561	229561	396518
30303	52382	0	applied	\N	\N	\N	\N	229562	229562	396519
30303	52383	1	applied	\N	\N	\N	\N	229563	229563	396520
30303	52385	2	applied	\N	\N	\N	\N	229564	229564	396521
30305	52389	0	applied	\N	\N	\N	\N	229572	229572	396529
30305	52390	1	applied	\N	\N	\N	\N	229573	229573	396530
30305	52391	2	applied	\N	\N	\N	\N	229574	229574	396531
30305	52392	3	applied	\N	\N	\N	\N	229575	229575	396532
30305	52393	4	applied	\N	\N	\N	\N	229576	229576	396533
30305	52394	5	applied	\N	\N	\N	\N	229577	229577	396534
30305	52395	6	applied	\N	\N	\N	\N	229578	229578	396535
30307	52396	0	applied	\N	\N	\N	\N	229587	229587	396544
30308	52396	0	applied	\N	\N	\N	\N	229589	229589	396546
30308	52397	1	applied	\N	\N	\N	\N	229590	229590	396547
30311	52396	0	applied	\N	\N	\N	\N	229595	229595	396552
30312	52396	0	applied	\N	\N	\N	\N	229596	229596	396553
30313	52398	0	applied	\N	\N	\N	\N	229597	229597	396554
30313	52399	1	applied	\N	\N	\N	\N	229598	229598	396555
30313	52400	2	applied	\N	\N	\N	\N	229599	229599	396556
30313	52401	3	applied	\N	\N	\N	\N	229600	229600	396557
30313	52402	4	applied	\N	\N	\N	\N	229601	229601	396558
30314	52398	0	applied	\N	\N	\N	\N	229602	229602	396559
30314	52399	1	applied	\N	\N	\N	\N	229603	229603	396560
30314	52400	2	applied	\N	\N	\N	\N	229604	229604	396561
30314	52401	3	applied	\N	\N	\N	\N	229605	229605	396562
30314	52402	4	applied	\N	\N	\N	\N	229606	229606	396563
30315	52400	2	applied	\N	\N	\N	\N	229609	229609	396566
30315	52401	3	applied	\N	\N	\N	\N	229610	229610	396567
30316	52403	0	applied	\N	\N	\N	\N	229612	229612	396569
30316	52404	1	applied	\N	\N	\N	\N	229613	229613	396570
30317	52405	0	applied	\N	\N	\N	\N	229614	229614	396571
30317	52406	1	applied	\N	\N	\N	\N	229615	229615	396572
30317	52407	3	applied	\N	\N	\N	\N	229616	229616	396573
30318	52405	0	applied	\N	\N	\N	\N	229617	229617	396574
30318	52406	1	applied	\N	\N	\N	\N	229618	229618	396575
30318	52407	3	applied	\N	\N	\N	\N	229619	229619	396576
35	29	0	applied	\N	\N	\N	\N	61456	61456	229639
6	10	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61423	61423	\N
48	40	0	applied	\N	\N	\N	\N	61473	61473	229656
30283	52346	4	applied	\N	\N	\N	\N	229402	229402	396369
30283	52347	5	applied	\N	\N	\N	\N	229403	229403	396370
86	73	1	applied	\N	\N	\N	\N	61524	61524	229707
88	75	0	applied	\N	\N	\N	\N	61526	61526	229709
104	90	1	applied	\N	\N	\N	\N	61557	61557	229740
116	99	0	applied	\N	\N	\N	\N	61574	61574	229757
126	106	0	applied	\N	\N	\N	\N	61591	61591	229774
135	119	0	applied	\N	\N	\N	\N	61608	61608	229791
149	130	0	applied	\N	\N	\N	\N	61625	61625	229808
158	138	1	applied	\N	\N	\N	\N	61642	61642	229825
159	141	0	applied	\N	\N	\N	\N	61645	61645	229828
165	149	0	applied	\N	\N	\N	\N	61657	61657	229840
171	157	0	applied	\N	\N	\N	\N	61674	61674	229857
185	168	0	applied	\N	\N	\N	\N	61691	61691	229874
197	176	0	applied	\N	\N	\N	\N	61708	61708	229891
211	184	1	applied	\N	\N	\N	\N	61725	61725	229908
225	197	0	applied	\N	\N	\N	\N	61742	61742	229924
237	209	0	applied	\N	\N	\N	\N	61759	61759	229941
239	210	1	applied	\N	\N	\N	\N	61764	61764	229946
243	212	0	applied	\N	\N	\N	\N	61768	61768	229950
266	234	0	applied	\N	\N	\N	\N	61802	61802	229982
279	242	0	applied	\N	\N	\N	\N	61819	61819	229999
295	253	1	applied	\N	\N	\N	\N	61836	61836	230016
304	262	0	applied	\N	\N	\N	\N	61853	61853	230033
306	267	0	applied	\N	\N	\N	\N	61860	61860	230040
317	277	0	applied	\N	\N	\N	\N	61877	61877	230057
326	284	1	applied	\N	\N	\N	\N	61893	61893	230073
342	294	0	applied	\N	\N	\N	\N	61914	61914	230094
349	303	1	applied	\N	\N	1000000000	\N	61929	61929	230109
359	316	0	applied	\N	\N	\N	\N	61950	61950	230130
369	325	1	applied	\N	\N	\N	\N	61967	61967	230147
381	336	0	applied	\N	\N	\N	\N	61984	61984	230164
391	347	0	applied	\N	\N	\N	\N	62001	62001	230181
392	347	0	applied	\N	\N	\N	\N	62002	62002	230182
399	354	2	applied	\N	\N	\N	\N	62014	62014	230194
407	361	0	applied	\N	\N	\N	\N	62031	62031	230211
431	382	0	applied	\N	\N	\N	\N	62067	62067	230247
442	387	0	applied	\N	\N	\N	\N	62084	62084	230264
450	395	0	applied	\N	\N	\N	\N	62101	62101	230281
464	403	0	applied	\N	\N	\N	\N	62118	62118	230298
467	405	0	applied	\N	\N	\N	\N	62121	62121	230301
470	406	0	applied	\N	\N	\N	\N	62127	62127	230307
476	413	2	applied	\N	\N	\N	\N	62144	62144	230324
489	423	1	applied	\N	\N	\N	\N	62161	62161	230341
498	434	1	applied	\N	\N	1000000000	\N	62177	62177	230357
509	446	0	applied	\N	\N	\N	\N	62197	62197	230377
520	458	0	applied	\N	\N	\N	\N	62214	62214	230394
526	470	0	applied	\N	\N	\N	\N	62231	62231	230411
533	477	0	applied	\N	\N	\N	\N	62240	62240	230420
538	479	0	applied	\N	\N	\N	\N	62246	62246	230426
549	488	0	applied	\N	\N	\N	\N	62263	62263	230443
563	496	0	applied	\N	\N	\N	\N	62280	62280	230460
577	504	1	applied	\N	\N	\N	\N	62297	62297	230477
588	515	0	applied	\N	\N	\N	\N	62314	62314	230491
619	534	0	applied	\N	\N	\N	\N	62348	62348	230525
624	539	1	applied	\N	\N	\N	\N	62353	62353	230530
630	542	0	applied	\N	\N	\N	\N	62362	62362	230539
646	551	0	applied	\N	\N	\N	\N	62379	62379	230556
653	558	3	applied	\N	\N	\N	\N	62396	62396	230573
660	566	3	applied	\N	\N	\N	\N	62413	62413	230590
670	572	0	applied	\N	\N	\N	\N	62430	62430	230607
678	586	0	applied	\N	\N	\N	\N	62447	62447	230624
690	596	0	applied	\N	\N	\N	\N	62464	62464	230641
694	598	0	applied	\N	\N	\N	\N	62468	62468	230645
698	600	1	applied	\N	\N	\N	\N	62474	62474	230651
712	589	1	applied	\N	\N	\N	\N	62497	62497	230674
733	639	0	applied	\N	\N	\N	\N	62536	62536	230708
747	650	0	applied	\N	\N	\N	\N	62553	62553	230725
762	587	0	applied	\N	\N	\N	\N	62570	62570	230742
767	659	1	applied	\N	\N	1000000000	\N	62585	62585	230754
771	665	3	applied	\N	\N	\N	\N	62596	62596	230765
772	668	2	applied	\N	\N	\N	\N	62599	62599	230768
782	673	0	applied	\N	\N	\N	\N	62616	62616	230785
790	680	0	applied	\N	\N	\N	\N	62633	62633	230802
804	689	1	applied	\N	\N	\N	\N	62650	62650	230819
815	699	0	applied	\N	\N	\N	\N	62667	62667	230836
827	706	0	applied	\N	\N	\N	\N	62684	62684	230853
840	716	1	applied	\N	\N	\N	\N	62701	62701	230870
853	729	2	applied	\N	\N	\N	\N	62716	62716	230885
854	727	0	applied	\N	\N	\N	\N	62718	62718	230887
861	735	0	applied	\N	\N	\N	\N	62735	62735	230904
873	745	0	applied	\N	\N	\N	\N	62752	62752	230921
883	759	0	applied	\N	\N	\N	\N	62769	62769	230938
891	766	2	applied	\N	\N	1000000000	\N	62785	62785	230954
903	777	1	applied	\N	\N	\N	\N	62805	62805	230974
903	778	2	applied	\N	\N	\N	\N	62806	62806	230975
906	779	0	applied	\N	\N	\N	\N	62812	62812	230981
916	788	0	applied	\N	\N	1000000000	\N	62828	62828	230997
933	804	0	applied	\N	\N	\N	\N	62853	62853	231021
946	816	1	applied	\N	\N	\N	\N	62870	62870	231038
963	834	0	applied	\N	\N	\N	\N	62904	62904	231072
978	843	0	applied	\N	\N	\N	\N	62921	62921	231089
995	849	0	applied	\N	\N	\N	\N	62938	62938	231106
997	850	0	applied	\N	\N	\N	\N	62940	62940	231108
1001	853	0	applied	\N	\N	\N	\N	62944	62944	231112
1019	868	0	applied	\N	\N	\N	\N	62967	62967	231135
1020	869	0	applied	\N	\N	\N	\N	62968	62968	231136
1025	873	1	applied	\N	\N	\N	\N	62974	62974	231142
1050	891	0	applied	\N	\N	\N	\N	63006	63006	231174
1051	899	6	applied	\N	\N	\N	\N	63014	63014	231182
1053	908	6	applied	\N	\N	\N	\N	63032	63032	231200
1053	925	23	applied	\N	\N	\N	\N	63049	63049	231217
1054	916	14	applied	\N	\N	\N	\N	63076	63076	231244
1054	933	31	applied	\N	\N	\N	\N	63093	63093	231261
1055	906	4	applied	\N	\N	\N	\N	63102	63102	231270
1055	923	21	applied	\N	\N	\N	\N	63119	63119	231287
1057	950	12	applied	\N	\N	\N	\N	63163	63163	231331
1058	950	12	applied	\N	\N	\N	\N	63180	63180	231348
1059	903	10	applied	\N	\N	\N	\N	63195	63195	231363
1059	906	13	applied	\N	\N	\N	\N	63198	63198	231366
1059	923	30	applied	\N	\N	\N	\N	63215	63215	231383
1060	960	5	applied	\N	\N	\N	\N	63232	63232	231400
77	61	0	applied	\N	\N	\N	\N	61507	61507	229690
1089	992	0	applied	\N	\N	\N	\N	63283	63283	231451
1090	1009	1	applied	\N	\N	\N	\N	63300	63300	231468
1090	1012	4	applied	\N	\N	\N	\N	63303	63303	231471
1091	1009	0	applied	\N	\N	\N	\N	63308	63308	231476
1093	1020	3	applied	\N	\N	\N	\N	63328	63328	231496
1100	1032	0	applied	\N	\N	\N	\N	63350	63350	231518
1116	1040	0	applied	\N	\N	\N	\N	63369	63369	231537
1123	1046	0	applied	\N	\N	\N	\N	63380	63380	231548
1125	981	5	applied	\N	\N	\N	\N	63387	63387	231555
1125	1004	22	applied	\N	\N	\N	\N	63404	63404	231572
1125	1023	40	applied	\N	\N	\N	\N	63421	63421	231589
1125	1033	57	applied	\N	\N	\N	\N	63438	63438	231606
1128	1050	0	applied	\N	\N	\N	\N	63455	63455	231623
1142	1060	0	applied	\N	\N	\N	\N	63472	63472	231640
1154	1066	0	applied	\N	\N	\N	\N	63489	63489	231657
1166	1077	1	applied	\N	\N	\N	\N	63507	63507	231675
1173	1081	0	applied	\N	\N	\N	\N	63514	63514	231682
1187	1097	1	applied	\N	\N	\N	\N	63538	63538	231706
1200	1104	0	applied	\N	\N	\N	\N	63554	63554	231722
1208	1110	0	applied	\N	\N	\N	\N	63563	63563	231731
1224	1123	2	applied	\N	\N	\N	\N	63588	63588	231756
1242	1138	0	applied	\N	\N	\N	\N	63609	63609	231777
1258	1148	0	applied	\N	\N	\N	\N	63626	63626	231794
1264	1155	2	applied	\N	\N	\N	\N	63643	63643	231811
1265	1154	15	applied	\N	\N	\N	\N	63660	63660	231828
1273	1162	0	applied	\N	\N	\N	\N	63675	63675	231843
1274	1162	0	applied	\N	\N	\N	\N	63676	63676	231844
1290	1173	0	applied	\N	\N	\N	\N	63693	63693	231861
1298	1179	1	applied	\N	\N	\N	\N	63710	63710	231878
1305	1187	0	applied	\N	\N	\N	\N	63727	63727	231895
1320	1199	3	applied	\N	\N	\N	\N	63744	63744	231912
1330	1209	0	applied	\N	\N	\N	\N	63763	63763	231931
1334	1173	16	applied	\N	\N	\N	\N	63783	63783	231951
1334	1193	33	applied	\N	\N	\N	\N	63800	63800	231968
1334	1211	51	applied	\N	\N	\N	\N	63817	63817	231985
1355	1221	0	applied	\N	\N	\N	\N	63847	63847	232015
1359	1227	0	applied	\N	\N	\N	\N	63855	63855	232023
1379	1242	2	applied	\N	\N	\N	\N	63881	63881	232049
1380	1235	16	applied	\N	\N	\N	\N	63898	63898	232066
1381	1243	0	applied	\N	\N	\N	\N	63908	63908	232076
1382	1243	0	applied	\N	\N	\N	\N	63910	63910	232078
1386	1254	1	applied	\N	\N	\N	\N	63921	63921	232089
1387	1257	4	applied	\N	\N	\N	\N	63930	63930	232098
1401	1269	0	applied	\N	\N	\N	\N	63956	63956	232124
1443	1299	1	applied	\N	\N	\N	\N	64024	64024	232190
1413	1273	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	63974	63974	\N
1444	1251	8	applied	\N	\N	\N	\N	64033	64033	232198
1444	1268	25	applied	\N	\N	\N	\N	64050	64050	232215
1444	1288	42	applied	\N	\N	\N	\N	64067	64067	232232
1450	1303	0	applied	\N	\N	\N	\N	64086	64086	232251
1453	1309	1	applied	\N	\N	\N	\N	64092	64092	232257
1460	1317	3	applied	\N	\N	\N	\N	64110	64110	232275
1469	1316	15	applied	\N	\N	\N	\N	64133	64133	232298
1475	1329	0	applied	\N	\N	\N	\N	64153	64153	232318
1476	1333	4	applied	\N	\N	\N	\N	64162	64162	232327
1477	1334	0	applied	\N	\N	\N	\N	64163	64163	232328
1486	1343	1	applied	\N	\N	\N	\N	64180	64180	232345
1495	1329	4	applied	\N	\N	\N	\N	64197	64197	232362
1495	1349	21	applied	\N	\N	\N	\N	64214	64214	232379
1497	1352	0	applied	\N	\N	\N	\N	64222	64222	232387
1500	1357	0	applied	\N	\N	\N	\N	64231	64231	232396
1500	1358	1	applied	\N	\N	\N	\N	64232	64232	232397
1513	1368	1	applied	\N	\N	\N	\N	64249	64249	232414
1519	1377	1	applied	\N	\N	\N	\N	64261	64261	232426
1537	1389	0	applied	\N	\N	\N	\N	64289	64289	232454
1539	1391	0	applied	\N	\N	\N	\N	64291	64291	232456
1547	1371	9	applied	\N	\N	\N	\N	64305	64305	232470
1547	1379	26	applied	\N	\N	\N	\N	64322	64322	232487
1558	1398	0	applied	\N	\N	\N	\N	64351	64351	232516
1576	1410	0	applied	\N	\N	\N	\N	64372	64372	232537
1579	1411	0	applied	\N	\N	\N	\N	64375	64375	232540
1594	1320	23	applied	\N	\N	\N	\N	64418	64418	232583
1594	1338	40	applied	\N	\N	\N	\N	64435	64435	232600
1594	1359	57	applied	\N	\N	\N	\N	64452	64452	232617
1594	1378	75	applied	\N	\N	\N	\N	64470	64470	232635
1600	1396	4	applied	\N	\N	\N	\N	64492	64492	232657
1604	1422	0	applied	\N	\N	\N	\N	64509	64509	232674
1604	1423	1	applied	\N	\N	\N	\N	64510	64510	232675
1608	1302	11	applied	\N	\N	\N	\N	64527	64527	232692
1608	1322	28	applied	\N	\N	\N	\N	64544	64544	232709
1608	1340	45	applied	\N	\N	\N	\N	64561	64561	232726
1608	1361	62	applied	\N	\N	\N	\N	64578	64578	232743
1608	1379	79	applied	\N	\N	\N	\N	64595	64595	232760
1608	1396	97	applied	\N	\N	\N	\N	64612	64612	232777
1608	1413	114	applied	\N	\N	\N	\N	64629	64629	232794
1608	1416	117	applied	\N	\N	\N	\N	64632	64632	232797
1610	1429	0	applied	\N	\N	\N	\N	64643	64643	232808
1613	1432	2	applied	\N	\N	\N	\N	64650	64650	232815
1620	1436	0	applied	\N	\N	\N	\N	64658	64658	232823
1624	1401	8	applied	\N	\N	\N	\N	64670	64670	232835
1624	1418	25	applied	\N	\N	\N	\N	64687	64687	232852
1645	1449	0	applied	\N	\N	\N	\N	64730	64730	232895
1652	1453	0	applied	\N	\N	\N	\N	64747	64747	232912
1661	1460	2	applied	\N	\N	\N	\N	64766	64766	232931
1664	1463	12	applied	\N	\N	\N	\N	64786	64786	232951
1673	1471	2	applied	\N	\N	\N	\N	64803	64803	232968
1684	1477	0	applied	\N	\N	\N	\N	64820	64820	232985
1691	1458	3	applied	\N	\N	\N	\N	64831	64831	232996
1698	1493	0	applied	\N	\N	\N	\N	64847	64847	233012
1701	1478	16	applied	\N	\N	\N	\N	64864	64864	233029
1707	1495	1	applied	\N	\N	\N	\N	64885	64885	233050
1708	1441	16	applied	\N	\N	\N	\N	64902	64902	233067
1708	1458	33	applied	\N	\N	\N	\N	64919	64919	233084
1708	1475	50	applied	\N	\N	\N	\N	64936	64936	233101
1708	1494	67	applied	\N	\N	\N	\N	64953	64953	233118
1716	1504	0	applied	\N	\N	\N	\N	64969	64969	233134
1717	1505	0	applied	\N	\N	\N	\N	64970	64970	233135
1728	1514	8	applied	\N	\N	\N	\N	65007	65007	233172
1731	1517	1	applied	\N	\N	\N	\N	65012	65012	233177
1751	1526	0	applied	\N	\N	\N	\N	65037	65037	233202
1075	982	0	applied	\N	\N	\N	\N	63266	63266	231434
1781	1549	0	applied	\N	\N	\N	\N	65073	65073	233238
1793	1496	7	applied	\N	\N	\N	\N	65104	65104	233269
1793	1515	24	applied	\N	\N	\N	\N	65121	65121	233286
1797	1563	0	applied	\N	\N	\N	\N	65127	65127	233292
1808	1573	0	applied	\N	\N	\N	\N	65146	65146	233311
1831	1589	0	applied	\N	\N	\N	\N	65172	65172	233337
1835	1589	0	applied	\N	\N	\N	\N	65175	65175	233340
1859	1602	1	applied	\N	\N	\N	\N	65203	65203	233368
1868	1532	10	applied	\N	\N	\N	\N	65223	65223	233388
1868	1533	11	applied	\N	\N	\N	\N	65224	65224	233389
1868	1536	14	applied	\N	\N	\N	\N	65227	65227	233392
1868	1553	31	applied	\N	\N	\N	\N	65244	65244	233409
1868	1572	48	applied	\N	\N	\N	\N	65261	65261	233426
1868	1589	65	applied	\N	\N	\N	\N	65278	65278	233443
1872	1609	2	applied	\N	\N	\N	\N	65297	65297	233462
1886	1616	0	applied	\N	\N	\N	\N	65314	65314	233479
1899	1629	1	applied	\N	\N	\N	\N	65331	65331	233496
1911	1637	2	applied	\N	\N	\N	\N	65346	65346	233511
1914	1640	0	applied	\N	\N	\N	\N	65349	65349	233514
1927	1646	0	applied	\N	\N	\N	\N	65366	65366	233531
1937	1653	0	applied	\N	\N	\N	\N	65383	65383	233548
1940	1654	0	applied	\N	\N	\N	\N	65386	65386	233551
1941	1654	0	applied	\N	\N	\N	\N	65387	65387	233552
1944	1657	0	applied	\N	\N	\N	\N	65392	65392	233557
1946	1621	12	applied	\N	\N	\N	\N	65406	65406	233571
1946	1639	29	applied	\N	\N	\N	\N	65423	65423	233588
1946	1657	46	applied	\N	\N	\N	\N	65440	65440	233605
1952	1660	0	applied	\N	\N	\N	\N	65447	65447	233612
1968	1674	0	applied	\N	\N	\N	\N	65473	65473	233638
1975	1522	8	applied	\N	\N	\N	\N	65490	65490	233655
1975	1556	43	applied	\N	\N	\N	\N	65524	65524	233689
1975	1575	60	applied	\N	\N	\N	\N	65541	65541	233706
1975	1589	74	applied	\N	\N	\N	\N	65555	65555	233720
1975	1606	91	applied	\N	\N	\N	\N	65572	65572	233737
1975	1623	108	applied	\N	\N	\N	\N	65589	65589	233754
1975	1624	109	applied	\N	\N	\N	\N	65590	65590	233755
1975	1627	112	applied	\N	\N	\N	\N	65593	65593	233758
1983	1684	0	applied	\N	\N	\N	\N	65616	65616	233781
2002	1647	4	applied	\N	\N	\N	\N	65643	65643	233808
2002	1664	21	applied	\N	\N	\N	\N	65660	65660	233825
2002	1681	38	applied	\N	\N	\N	\N	65677	65677	233842
2010	1703	0	applied	\N	\N	\N	\N	65705	65705	233870
2011	1583	6	applied	\N	\N	\N	\N	65712	65712	233877
2011	1600	23	applied	\N	\N	\N	\N	65729	65729	233894
2011	1631	54	applied	\N	\N	\N	\N	65760	65760	233925
2011	1650	71	applied	\N	\N	\N	\N	65777	65777	233942
2026	1714	1	applied	\N	\N	\N	\N	65811	65811	233976
2037	1721	0	applied	\N	\N	\N	\N	65826	65826	233991
2038	1724	1	applied	\N	\N	\N	\N	65829	65829	233994
2045	1663	8	applied	\N	\N	\N	\N	65846	65846	234011
2045	1680	26	applied	\N	\N	\N	\N	65863	65863	234028
2045	1697	43	applied	\N	\N	\N	\N	65880	65880	234045
2046	1730	0	applied	\N	\N	\N	\N	65886	65886	234051
2046	1733	3	applied	\N	\N	\N	\N	65889	65889	234054
2051	1739	0	applied	\N	\N	\N	\N	65896	65896	234061
2057	1743	0	applied	\N	\N	\N	\N	65904	65904	234069
2077	1754	0	applied	\N	\N	\N	\N	65926	65926	234091
2078	1754	0	applied	\N	\N	\N	\N	65927	65927	234092
2103	1772	0	applied	\N	\N	\N	\N	65959	65959	234124
2107	1633	15	applied	\N	\N	\N	\N	65978	65978	234143
2107	1652	32	applied	\N	\N	\N	\N	65995	65995	234160
2107	1669	49	applied	\N	\N	\N	\N	66012	66012	234177
2107	1699	79	applied	\N	\N	\N	\N	66042	66042	234207
2107	1716	96	applied	\N	\N	\N	\N	66059	66059	234224
2107	1733	114	applied	\N	\N	\N	\N	66076	66076	234241
2117	1781	1	applied	\N	\N	\N	\N	66100	66100	234265
2118	1782	0	applied	\N	\N	\N	\N	66101	66101	234266
2128	1789	0	applied	\N	\N	\N	\N	66113	66113	234278
2133	1793	0	applied	\N	\N	\N	\N	66118	66118	234283
2153	1807	0	applied	\N	\N	\N	\N	66143	66143	234308
2156	1811	1	applied	\N	\N	\N	\N	66147	66147	234312
2172	1818	0	applied	\N	\N	\N	\N	66169	66169	234334
2186	1661	2	applied	\N	\N	\N	\N	66191	66191	234356
2195	1781	7	applied	\N	\N	\N	\N	66223	66223	234388
2195	1798	24	applied	\N	\N	\N	\N	66240	66240	234405
2195	1816	41	applied	\N	\N	\N	\N	66257	66257	234422
2195	1833	58	applied	\N	\N	\N	\N	66274	66274	234439
2205	1843	1	applied	\N	\N	\N	\N	66291	66291	234456
2220	1854	0	applied	\N	\N	\N	\N	66312	66312	234477
2232	1867	1	applied	\N	\N	\N	\N	66329	66329	234494
2242	1875	0	applied	\N	\N	1000000000	\N	66346	66346	234511
2257	1880	0	applied	\N	\N	\N	\N	66365	66365	234530
2262	1887	0	applied	\N	\N	\N	\N	66375	66375	234540
2266	1891	0	applied	\N	\N	\N	\N	66387	66387	234552
2270	1895	0	applied	\N	\N	\N	\N	66392	66392	234557
2273	1896	1	applied	\N	\N	\N	\N	66396	66396	234561
2281	1635	4	applied	\N	\N	\N	\N	66409	66409	234574
2301	1884	7	applied	\N	\N	1000000000	\N	66448	66448	234613
2301	1760	26	applied	\N	\N	\N	\N	66467	66467	234632
2301	1777	43	applied	\N	\N	\N	\N	66484	66484	234649
2301	1794	60	applied	\N	\N	\N	\N	66501	66501	234666
2301	1814	80	applied	\N	\N	\N	\N	66521	66521	234686
2301	1832	98	applied	\N	\N	\N	\N	66538	66538	234703
2301	1849	115	applied	\N	\N	\N	\N	66555	66555	234720
2311	1918	2	applied	\N	\N	\N	\N	66573	66573	234738
2327	1930	1	applied	\N	\N	\N	\N	66606	66606	234771
2328	1929	0	applied	\N	\N	\N	\N	66607	66607	234772
2331	1933	2	applied	\N	\N	\N	\N	66613	66613	234778
2334	1931	0	applied	\N	\N	\N	\N	66620	66620	234785
2342	1939	1	applied	\N	\N	\N	\N	66639	66639	234804
2349	1946	0	applied	\N	\N	\N	\N	66649	66649	234814
2359	1953	0	applied	\N	\N	\N	\N	66664	66664	234829
2362	1716	16	applied	\N	\N	\N	\N	66683	66683	234848
2362	1733	34	applied	\N	\N	\N	\N	66700	66700	234865
2362	1750	51	applied	\N	\N	\N	\N	66717	66717	234882
2362	1767	68	applied	\N	\N	\N	\N	66734	66734	234899
2362	1784	85	applied	\N	\N	\N	\N	66751	66751	234916
2362	1801	102	applied	\N	\N	\N	\N	66768	66768	234933
2362	1804	105	applied	\N	\N	\N	\N	66771	66771	234936
2362	1822	122	applied	\N	\N	\N	\N	66788	66788	234953
1777	1548	0	applied	\N	\N	\N	\N	65069	65069	233234
2417	1994	0	applied	\N	\N	\N	\N	66860	66860	235025
2417	1995	1	applied	\N	\N	\N	\N	66861	66861	235026
2418	1994	0	applied	\N	\N	\N	\N	66862	66862	235027
2437	2009	0	applied	\N	\N	\N	\N	66891	66891	235056
2443	2013	0	applied	\N	\N	\N	\N	66901	66901	235066
2450	2018	0	applied	\N	\N	\N	\N	66908	66908	235073
2480	2045	0	applied	\N	\N	\N	\N	66949	66949	235114
2485	1957	11	applied	\N	\N	\N	\N	66966	66966	235131
2485	1975	28	applied	\N	\N	\N	\N	66983	66983	235148
2485	1992	45	applied	\N	\N	\N	\N	67000	67000	235165
2485	2010	62	applied	\N	\N	\N	\N	67017	67017	235182
2485	2027	79	applied	\N	\N	\N	\N	67034	67034	235199
2485	2033	85	applied	\N	\N	\N	\N	67040	67040	235205
2485	2049	102	applied	\N	\N	\N	\N	67056	67056	235221
2501	2003	8	applied	\N	\N	\N	\N	67090	67090	235255
2501	2020	25	applied	\N	\N	\N	\N	67107	67107	235272
2501	2037	42	applied	\N	\N	\N	\N	67124	67124	235289
2501	2045	50	applied	\N	\N	\N	\N	67132	67132	235297
2501	2062	66	applied	\N	\N	\N	\N	67148	67148	235313
2511	2079	1	applied	\N	\N	\N	\N	67172	67172	235337
2518	2083	0	applied	\N	\N	\N	\N	67182	67182	235347
2524	2094	2	applied	\N	\N	\N	\N	67200	67200	235365
2532	2061	12	applied	\N	\N	\N	\N	67221	67221	235386
2532	2079	29	applied	\N	\N	\N	\N	67238	67238	235403
2532	2096	45	applied	\N	\N	\N	\N	67254	67254	235419
2551	2116	0	applied	\N	\N	\N	\N	67286	67286	235451
2552	2118	0	applied	\N	\N	\N	\N	67288	67288	235453
2553	2065	1	applied	\N	\N	\N	\N	67290	67290	235455
2553	2027	18	applied	\N	\N	\N	\N	67307	67307	235472
2553	2044	35	applied	\N	\N	\N	\N	67324	67324	235489
2553	2080	70	applied	\N	\N	\N	\N	67358	67358	235523
2553	2081	71	applied	\N	\N	\N	\N	67359	67359	235524
2553	2082	72	applied	\N	\N	\N	\N	67360	67360	235525
2561	2093	12	applied	\N	\N	\N	\N	67392	67392	235557
2561	2096	15	applied	\N	\N	\N	\N	67395	67395	235560
2561	2114	32	applied	\N	\N	\N	\N	67412	67412	235577
2566	2129	0	applied	\N	\N	\N	\N	67433	67433	235598
2571	2132	1	applied	\N	\N	\N	\N	67450	67450	235615
2582	2144	0	applied	\N	\N	\N	\N	67467	67467	235632
2596	2152	1	applied	\N	\N	\N	\N	67484	67484	235649
2609	2131	3	applied	\N	\N	\N	\N	67501	67501	235666
2609	2132	4	applied	\N	\N	\N	\N	67502	67502	235667
2609	2149	21	applied	\N	\N	\N	\N	67519	67519	235684
2610	2159	0	applied	\N	\N	\N	\N	67529	67529	235694
2611	2160	1	applied	\N	\N	\N	\N	67532	67532	235697
2619	2169	0	applied	\N	\N	\N	\N	67547	67547	235712
2653	2190	0	applied	\N	\N	\N	\N	67587	67587	235752
2655	2089	2	applied	\N	\N	1000000000	\N	67596	67596	235761
2655	2085	22	applied	\N	\N	\N	\N	67616	67616	235781
2655	2103	40	applied	\N	\N	\N	\N	67633	67633	235798
2655	2121	57	applied	\N	\N	\N	\N	67650	67650	235815
2655	2146	82	applied	\N	\N	\N	\N	67675	67675	235840
2662	2200	1	applied	\N	\N	\N	\N	67687	67687	235852
2668	2203	0	applied	\N	\N	\N	\N	67694	67694	235859
2680	2215	0	applied	\N	\N	\N	\N	67719	67719	235884
2682	2089	5	applied	\N	\N	1000000000	\N	67726	67726	235891
2682	2023	25	applied	\N	\N	\N	\N	67746	67746	235911
2682	2026	28	applied	\N	\N	\N	\N	67749	67749	235914
2682	2042	44	applied	\N	\N	\N	\N	67765	67765	235930
2682	2060	61	applied	\N	\N	\N	\N	67782	67782	235947
2682	2078	78	applied	\N	\N	\N	\N	67799	67799	235964
2688	2218	0	applied	\N	\N	\N	\N	67820	67820	235985
2703	2037	12	applied	\N	\N	\N	\N	67850	67850	236015
2703	2055	30	applied	\N	\N	\N	\N	67867	67867	236032
2703	2073	47	applied	\N	\N	\N	\N	67884	67884	236049
2703	2074	48	applied	\N	\N	\N	\N	67885	67885	236050
2703	2077	51	applied	\N	\N	\N	\N	67888	67888	236053
2703	2095	68	applied	\N	\N	\N	\N	67905	67905	236070
2703	2113	85	applied	\N	\N	\N	\N	67922	67922	236087
2703	2130	102	applied	\N	\N	\N	\N	67939	67939	236104
2703	2147	119	applied	\N	\N	\N	\N	67956	67956	236121
2727	2245	1	applied	\N	\N	\N	\N	67997	67997	236162
2728	2157	3	applied	\N	\N	\N	\N	68001	68001	236166
2728	2174	20	applied	\N	\N	\N	\N	68018	68018	236183
2728	2191	38	applied	\N	\N	\N	\N	68035	68035	236200
2728	2208	55	applied	\N	\N	\N	\N	68052	68052	236217
2728	2240	87	applied	\N	\N	\N	\N	68084	68084	236249
2735	2251	0	applied	\N	\N	\N	\N	68099	68099	236264
2743	2196	9	applied	\N	\N	\N	\N	68119	68119	236284
2743	2213	26	applied	\N	\N	\N	\N	68136	68136	236301
2743	2230	43	applied	\N	\N	\N	\N	68153	68153	236318
2743	2247	61	applied	\N	\N	\N	\N	68170	68170	236335
2755	2258	0	applied	\N	\N	\N	\N	68187	68187	236352
2756	2258	0	applied	\N	\N	\N	\N	68189	68189	236354
2759	2258	0	applied	\N	\N	\N	\N	68194	68194	236359
2760	2062	15	applied	\N	\N	\N	\N	68211	68211	236376
2760	2080	32	applied	\N	\N	\N	\N	68228	68228	236393
2760	2098	49	applied	\N	\N	\N	\N	68245	68245	236410
2760	2105	55	applied	\N	\N	\N	\N	68251	68251	236416
2760	2122	72	applied	\N	\N	\N	\N	68268	68268	236433
2760	2139	89	applied	\N	\N	\N	\N	68285	68285	236450
2760	2156	106	applied	\N	\N	\N	\N	68302	68302	236467
2760	2168	123	applied	\N	\N	\N	\N	68314	68314	236479
2760	2169	124	applied	\N	\N	\N	\N	68315	68315	236480
2784	2282	0	applied	\N	\N	\N	\N	68349	68349	236514
2788	2114	14	applied	\N	\N	\N	\N	68368	68368	236533
2788	2131	31	applied	\N	\N	\N	\N	68385	68385	236550
2788	2160	60	applied	\N	\N	\N	\N	68414	68414	236579
2788	2177	77	applied	\N	\N	\N	\N	68431	68431	236596
2788	2194	94	applied	\N	\N	\N	\N	68448	68448	236613
2788	2210	110	applied	\N	\N	\N	\N	68464	68464	236629
2788	2213	113	applied	\N	\N	\N	\N	68467	68467	236632
2791	2287	0	applied	\N	\N	\N	\N	68482	68482	236647
2793	2288	0	applied	\N	\N	\N	\N	68484	68484	236649
2798	2291	1	applied	\N	\N	\N	\N	68490	68490	236655
2804	2113	11	applied	\N	\N	\N	\N	68521	68521	236686
2804	2130	28	applied	\N	\N	\N	\N	68538	68538	236703
2804	2147	45	applied	\N	\N	\N	\N	68555	68555	236720
2804	2164	62	applied	\N	\N	\N	\N	68572	68572	236737
2804	2180	78	applied	\N	\N	\N	\N	68588	68588	236753
2413	1992	0	applied	\N	\N	\N	\N	66855	66855	235020
2828	2313	2	applied	\N	\N	\N	\N	68657	68657	236822
2829	2318	7	applied	\N	\N	\N	\N	68670	68670	236835
2833	2320	1	applied	\N	\N	\N	\N	68674	68674	236839
2858	2344	1	applied	\N	\N	\N	\N	68709	68709	236874
2860	2344	1	applied	\N	\N	\N	\N	68713	68713	236878
2882	2357	0	applied	\N	\N	\N	\N	68740	68740	236905
2883	2358	1	applied	\N	\N	\N	\N	68743	68743	236908
2909	2375	3	applied	\N	\N	\N	\N	68782	68782	236947
2911	2377	1	applied	\N	\N	\N	\N	68784	68784	236949
2912	2305	13	applied	\N	\N	\N	\N	68801	68801	236966
2912	2327	31	applied	\N	\N	\N	\N	68819	68819	236984
2912	2344	48	applied	\N	\N	\N	\N	68836	68836	237001
2918	2384	2	applied	\N	\N	\N	\N	68853	68853	237018
2921	2258	15	applied	\N	\N	\N	\N	68870	68870	237035
2921	2275	32	applied	\N	\N	\N	\N	68887	68887	237052
2921	2293	50	applied	\N	\N	\N	\N	68904	68904	237069
2921	2313	67	applied	\N	\N	\N	\N	68921	68921	237086
2921	2331	84	applied	\N	\N	\N	\N	68938	68938	237103
2921	2346	98	applied	\N	\N	\N	\N	68952	68952	237117
2921	2363	115	applied	\N	\N	\N	\N	68969	68969	237134
2922	2386	0	applied	\N	\N	\N	\N	68980	68980	237145
2922	2387	1	applied	\N	\N	\N	\N	68981	68981	237146
2925	2386	0	applied	\N	\N	\N	\N	68986	68986	237151
2935	2392	0	applied	\N	\N	\N	\N	68999	68999	237164
2953	2408	0	applied	\N	\N	\N	\N	69018	69018	237183
2972	2420	1	applied	\N	\N	\N	\N	69041	69041	237206
3004	2140	1	applied	\N	\N	\N	\N	69076	69076	237241
3004	2154	18	applied	\N	\N	\N	\N	69093	69093	237258
3004	2171	36	applied	\N	\N	\N	\N	69110	69110	237275
3004	2188	53	applied	\N	\N	\N	\N	69127	69127	237292
3010	2440	1	applied	\N	\N	\N	\N	69144	69144	237309
3021	2445	0	applied	\N	\N	\N	\N	69155	69155	237320
3025	2449	0	applied	\N	\N	\N	\N	69159	69159	237324
3046	2430	2	applied	\N	\N	\N	\N	69185	69185	237350
3046	2448	20	applied	\N	\N	\N	\N	69202	69202	237367
3049	2465	0	applied	\N	\N	\N	\N	69221	69221	237386
3054	2472	0	applied	\N	\N	\N	\N	69229	69229	237394
3062	2473	0	applied	\N	\N	1000000000	\N	69234	69234	237399
3076	2318	14	applied	\N	\N	\N	\N	69262	69262	237427
3076	2348	43	applied	\N	\N	\N	\N	69290	69290	237455
3076	2365	60	applied	\N	\N	\N	\N	69307	69307	237472
3076	2379	74	applied	\N	\N	\N	\N	69321	69321	237486
3076	2412	107	applied	\N	\N	\N	\N	69354	69354	237519
3076	2429	124	applied	\N	\N	\N	\N	69371	69371	237536
3084	2473	0	applied	\N	\N	1000000000	\N	69380	69380	237545
3084	2482	19	applied	\N	\N	\N	\N	69399	69399	237564
3092	2232	9	applied	\N	\N	\N	\N	69422	69422	237587
3092	2248	26	applied	\N	\N	\N	\N	69439	69439	237604
3092	2265	43	applied	\N	\N	\N	\N	69456	69456	237621
3092	2282	60	applied	\N	\N	\N	\N	69473	69473	237638
3092	2283	61	applied	\N	\N	\N	\N	69474	69474	237639
3092	2300	77	applied	\N	\N	\N	\N	69490	69490	237655
3092	2320	94	applied	\N	\N	\N	\N	69507	69507	237672
3092	2338	111	applied	\N	\N	\N	\N	69524	69524	237689
3093	2494	0	applied	\N	\N	\N	\N	69539	69539	237704
3094	2496	2	applied	\N	\N	\N	\N	69549	69549	237714
3115	2520	1	applied	\N	\N	\N	\N	69594	69594	237759
3117	2522	0	applied	\N	\N	\N	\N	69599	69599	237764
3120	2530	4	applied	\N	\N	\N	\N	69607	69607	237772
3124	2543	2	applied	\N	\N	\N	\N	69635	69635	237800
3131	2532	6	applied	\N	\N	\N	\N	69652	69652	237817
3131	2533	7	applied	\N	\N	\N	\N	69653	69653	237818
3131	2534	8	applied	\N	\N	\N	\N	69654	69654	237819
3139	2558	2	applied	\N	\N	\N	\N	69671	69671	237836
3149	2569	0	applied	\N	\N	\N	\N	69688	69688	237853
3163	2576	0	applied	\N	\N	\N	\N	69705	69705	237870
3176	2438	0	applied	\N	\N	\N	\N	69722	69722	237887
3181	2591	0	applied	\N	\N	\N	\N	69732	69732	237897
3182	2591	0	applied	\N	\N	\N	\N	69733	69733	237898
3183	2591	0	applied	\N	\N	\N	\N	69734	69734	237899
3187	2594	0	applied	\N	\N	\N	\N	69738	69738	237903
3202	2606	1	applied	\N	\N	\N	\N	69758	69758	237923
3203	2609	4	applied	\N	\N	\N	\N	69768	69768	237933
3209	2500	13	applied	\N	\N	\N	\N	69789	69789	237954
3209	2537	31	applied	\N	\N	\N	\N	69807	69807	237972
3209	2524	48	applied	\N	\N	\N	\N	69824	69824	237989
3209	2569	83	applied	\N	\N	\N	\N	69858	69858	238023
3209	2585	99	applied	\N	\N	\N	\N	69874	69874	238039
3209	2586	100	applied	\N	\N	\N	\N	69875	69875	238040
3209	2603	117	applied	\N	\N	\N	\N	69892	69892	238057
3224	2625	0	applied	\N	\N	\N	\N	69919	69919	238084
3225	2625	0	applied	\N	\N	\N	\N	69920	69920	238085
3226	2633	7	applied	\N	\N	\N	\N	69928	69928	238093
3226	2636	10	applied	\N	\N	\N	\N	69931	69931	238096
3228	2627	1	applied	\N	\N	\N	\N	69948	69948	238113
3230	2639	0	applied	\N	\N	\N	\N	69964	69964	238129
3232	2650	1	applied	\N	\N	\N	\N	69975	69975	238140
3234	2657	2	applied	\N	\N	\N	\N	69992	69992	238157
3239	2675	7	applied	\N	\N	\N	\N	70012	70012	238177
3242	2688	2	applied	\N	\N	\N	\N	70046	70046	238211
3247	2682	13	applied	\N	\N	\N	\N	70066	70066	238231
3247	2641	30	applied	\N	\N	\N	\N	70083	70083	238248
3249	2693	0	applied	\N	\N	\N	\N	70120	70120	238285
3264	2709	0	applied	\N	\N	\N	\N	70144	70144	238309
3265	2709	0	applied	\N	\N	\N	\N	70145	70145	238310
3270	2635	7	applied	\N	\N	\N	\N	70157	70157	238322
3270	2657	24	applied	\N	\N	\N	\N	70174	70174	238339
3270	2678	41	applied	\N	\N	\N	\N	70191	70191	238356
3278	2720	3	applied	\N	\N	\N	\N	70220	70220	238385
3281	2725	0	applied	\N	\N	\N	\N	70225	70225	238390
3286	2739	7	applied	\N	\N	\N	\N	70244	70244	238409
3301	2750	0	applied	\N	\N	\N	\N	70288	70288	238453
3305	2758	2	applied	\N	\N	1000000000	\N	70300	70300	238465
3320	2767	0	applied	\N	\N	\N	\N	70325	70325	238490
3322	2785	7	applied	\N	\N	\N	\N	70343	70343	238508
3323	2784	6	applied	\N	\N	\N	\N	70361	70361	238526
3324	2801	4	applied	\N	\N	\N	\N	70378	70378	238543
3330	2813	1	applied	\N	\N	\N	\N	70407	70407	238572
3338	2825	0	applied	\N	\N	\N	\N	70431	70431	238596
2804	2215	113	applied	\N	\N	\N	\N	68623	68623	236788
3349	2855	4	applied	\N	\N	1000000000	\N	70476	70476	238641
3350	2637	14	applied	\N	\N	\N	\N	70491	70491	238656
3350	2660	30	applied	\N	\N	\N	\N	70507	70507	238672
3350	2679	47	applied	\N	\N	\N	\N	70524	70524	238689
3350	2738	64	applied	\N	\N	\N	\N	70541	70541	238706
3352	2856	1	applied	\N	\N	\N	\N	70558	70558	238723
3356	2631	8	applied	\N	\N	\N	\N	70575	70575	238740
3356	2653	25	applied	\N	\N	\N	\N	70592	70592	238757
3356	2674	42	applied	\N	\N	\N	\N	70609	70609	238774
3356	2675	43	applied	\N	\N	\N	\N	70610	70610	238775
3356	2678	46	applied	\N	\N	\N	\N	70613	70613	238778
3361	2868	0	applied	\N	\N	\N	\N	70620	70620	238785
3362	2870	0	applied	\N	\N	\N	\N	70622	70622	238787
3368	2876	0	applied	\N	\N	\N	\N	70629	70629	238794
3369	2736	10	applied	\N	\N	\N	\N	70641	70641	238806
3369	2728	27	applied	\N	\N	\N	\N	70658	70658	238823
3370	2877	1	applied	\N	\N	\N	\N	70692	70692	238857
3376	2532	11	applied	\N	\N	\N	\N	70715	70715	238880
3376	2519	28	applied	\N	\N	\N	\N	70732	70732	238897
3376	2550	48	applied	\N	\N	\N	\N	70752	70752	238917
3376	2636	56	applied	\N	\N	\N	\N	70760	70760	238925
3376	2660	74	applied	\N	\N	\N	\N	70777	70777	238942
3376	2679	91	applied	\N	\N	\N	\N	70794	70794	238959
3376	2738	108	applied	\N	\N	\N	\N	70811	70811	238976
3376	2780	125	applied	\N	\N	\N	\N	70828	70828	238993
3389	2865	1	applied	\N	\N	\N	\N	70841	70841	239006
3389	2882	18	applied	\N	\N	\N	\N	70858	70858	239023
3395	2555	4	applied	\N	\N	\N	\N	70879	70879	239044
3395	2572	21	applied	\N	\N	\N	\N	70896	70896	239061
3395	2589	38	applied	\N	\N	\N	\N	70913	70913	239078
3395	2606	55	applied	\N	\N	\N	\N	70930	70930	239095
3395	2647	79	applied	\N	\N	\N	\N	70953	70953	239118
3395	2706	106	applied	\N	\N	\N	\N	70980	70980	239145
3395	2726	123	applied	\N	\N	\N	\N	70997	70997	239162
3397	2896	0	applied	\N	\N	\N	\N	71001	71001	239166
3399	2897	0	applied	\N	\N	\N	\N	71006	71006	239171
3402	2872	16	applied	\N	\N	\N	\N	71025	71025	239190
3402	2890	33	applied	\N	\N	\N	\N	71042	71042	239207
3411	2901	1	applied	\N	\N	\N	\N	71065	71065	239230
3416	2904	0	applied	\N	\N	\N	\N	71071	71071	239236
3456	2758	3	applied	\N	\N	1000000000	\N	71105	71105	239270
3456	2717	24	applied	\N	\N	\N	\N	71125	71125	239290
3456	2750	38	applied	\N	\N	\N	\N	71139	71139	239304
3456	2722	54	applied	\N	\N	\N	\N	71155	71155	239320
3456	2754	71	applied	\N	\N	\N	\N	71172	71172	239337
3456	2813	88	applied	\N	\N	\N	\N	71189	71189	239354
3456	2841	105	applied	\N	\N	\N	\N	71206	71206	239371
3456	2787	122	applied	\N	\N	\N	\N	71223	71223	239388
3489	2751	30	applied	\N	\N	\N	\N	71258	71258	239423
3489	2752	31	applied	\N	\N	\N	\N	71259	71259	239424
3489	2727	34	applied	\N	\N	\N	\N	71262	71262	239427
3489	2764	51	applied	\N	\N	\N	\N	71279	71279	239444
3489	2821	69	applied	\N	\N	\N	\N	71296	71296	239461
3493	2914	1	applied	\N	\N	\N	\N	71313	71313	239478
3493	2765	18	applied	\N	\N	\N	\N	71330	71330	239495
3493	2823	35	applied	\N	\N	\N	\N	71347	71347	239512
3493	2862	52	applied	\N	\N	\N	\N	71364	71364	239529
3493	2877	67	applied	\N	\N	\N	\N	71379	71379	239544
3493	2880	71	applied	\N	\N	\N	\N	71382	71382	239547
3493	2898	88	applied	\N	\N	\N	\N	71399	71399	239564
3499	2861	4	applied	\N	\N	\N	\N	71414	71414	239579
3499	2878	22	applied	\N	\N	\N	\N	71431	71431	239596
3499	2899	42	applied	\N	\N	\N	\N	71451	71451	239616
3499	2909	52	applied	\N	\N	\N	\N	71461	71461	239626
3543	2925	0	applied	\N	\N	\N	\N	71494	71494	239657
3640	2930	0	applied	\N	\N	1000000000	\N	71516	71516	239678
3665	2935	0	applied	\N	\N	1000000000	\N	71523	71523	239685
3685	2947	0	applied	\N	\N	\N	\N	71544	71544	239706
3695	2957	2	applied	\N	\N	\N	\N	71561	71561	239723
3696	2957	2	applied	\N	\N	\N	\N	71564	71564	239726
3702	2960	0	applied	\N	\N	\N	\N	71572	71572	239734
3711	2970	0	applied	\N	\N	\N	\N	71589	71589	239751
3720	2967	7	applied	\N	\N	\N	\N	71606	71606	239768
3721	2975	0	applied	\N	\N	\N	\N	71611	71611	239773
3724	2977	0	applied	\N	\N	\N	\N	71614	71614	239776
3726	2977	0	applied	\N	\N	\N	\N	71616	71616	239778
3727	2977	0	applied	\N	\N	\N	\N	71617	71617	239779
3732	2980	0	applied	\N	\N	\N	\N	71622	71622	239784
3768	3005	0	applied	\N	\N	\N	\N	71675	71675	239837
3769	3007	0	applied	\N	\N	\N	\N	71677	71677	239839
3772	3010	0	applied	\N	\N	\N	\N	71681	71681	239843
3781	3012	0	applied	\N	\N	\N	\N	71686	71686	239848
3799	3027	0	applied	\N	\N	\N	\N	71715	71715	239877
3816	3040	0	applied	\N	\N	\N	\N	71745	71745	239907
3825	3049	1	applied	\N	\N	\N	\N	71757	71757	239919
3826	2935	4	applied	\N	\N	1000000000	\N	71762	71762	239924
3826	2956	25	applied	\N	\N	\N	\N	71783	71783	239944
3826	2969	35	applied	\N	\N	\N	\N	71793	71793	239954
3826	3004	69	applied	\N	\N	\N	\N	71827	71827	239988
3826	3008	73	applied	\N	\N	\N	\N	71831	71831	239992
3826	3009	74	applied	\N	\N	\N	\N	71832	71832	239993
3826	3026	92	applied	\N	\N	\N	\N	71849	71849	240010
3826	3043	109	applied	\N	\N	\N	\N	71866	71866	240027
3840	2944	12	applied	\N	\N	\N	\N	71903	71903	240064
3840	2965	29	applied	\N	\N	\N	\N	71920	71920	240081
3840	2981	45	applied	\N	\N	\N	\N	71936	71936	240097
3840	2999	62	applied	\N	\N	\N	\N	71953	71953	240114
3840	3016	79	applied	\N	\N	\N	\N	71970	71970	240131
3840	3018	82	applied	\N	\N	\N	\N	71972	71972	240133
3840	3019	83	applied	\N	\N	\N	\N	71973	71973	240134
3840	3036	100	applied	\N	\N	\N	\N	71990	71990	240151
3840	3058	117	applied	\N	\N	\N	\N	72007	72007	240168
3860	3082	0	applied	\N	\N	\N	\N	72049	72049	240210
3864	3084	0	applied	\N	\N	\N	\N	72055	72055	240216
3884	3100	1	applied	\N	\N	\N	\N	72083	72083	240244
3901	3110	0	applied	\N	\N	\N	\N	72100	72100	240261
3927	3070	3	applied	\N	\N	\N	\N	72135	72135	240296
3927	3087	20	applied	\N	\N	\N	\N	72152	72152	240313
3927	3104	37	applied	\N	\N	\N	\N	72169	72169	240330
3927	3109	42	applied	\N	\N	\N	\N	72174	72174	240335
3345	2839	5	applied	\N	\N	\N	\N	70449	70449	238614
3928	3125	0	applied	\N	\N	\N	\N	72194	72194	240355
3952	3155	0	applied	\N	\N	\N	\N	72233	72233	240394
3966	3054	0	applied	\N	\N	1000000000	\N	72247	72247	240408
3967	3162	0	applied	\N	\N	\N	\N	72253	72253	240414
3992	3176	0	applied	\N	\N	\N	\N	72282	72282	240443
3996	3178	0	applied	\N	\N	\N	\N	72286	72286	240447
3997	3178	0	applied	\N	\N	\N	\N	72287	72287	240448
4024	3199	0	applied	\N	\N	\N	\N	72322	72322	240483
4035	3205	0	applied	\N	\N	\N	\N	72333	72333	240494
4052	3220	0	applied	\N	\N	\N	\N	72356	72356	240517
4063	3231	1	applied	\N	\N	\N	\N	72376	72376	240537
4073	3239	0	applied	\N	\N	\N	\N	72388	72388	240549
4080	3242	0	applied	\N	\N	\N	\N	72397	72397	240558
4094	3256	0	applied	\N	\N	\N	\N	72423	72423	240584
4099	3260	0	applied	\N	\N	\N	\N	72430	72430	240591
4116	3272	0	applied	\N	\N	\N	\N	72456	72456	240617
4117	3139	15	applied	\N	\N	\N	\N	72473	72473	240634
4117	3161	32	applied	\N	\N	\N	\N	72490	72490	240651
4117	3178	49	applied	\N	\N	\N	\N	72507	72507	240668
4117	3195	66	applied	\N	\N	\N	\N	72524	72524	240685
4117	3213	83	applied	\N	\N	\N	\N	72541	72541	240702
4117	3221	91	applied	\N	\N	\N	\N	72549	72549	240710
4117	3239	108	applied	\N	\N	\N	\N	72566	72566	240727
4118	3274	0	applied	\N	\N	\N	\N	72583	72583	240744
4130	3285	0	applied	\N	\N	\N	\N	72600	72600	240761
4138	3299	8	applied	\N	\N	\N	\N	72617	72617	240778
4145	3303	0	applied	\N	\N	\N	\N	72634	72634	240795
4148	3308	0	applied	\N	\N	\N	\N	72639	72639	240800
4171	3325	0	applied	\N	\N	\N	\N	72670	72670	240831
4180	3296	0	applied	\N	\N	1000000000	\N	72685	72685	240846
4180	3277	18	applied	\N	\N	\N	\N	72703	72703	240864
4180	3300	35	applied	\N	\N	\N	\N	72720	72720	240881
4180	3319	52	applied	\N	\N	\N	\N	72737	72737	240898
4180	3146	69	applied	\N	\N	\N	\N	72754	72754	240915
4182	3335	0	applied	\N	\N	\N	\N	72759	72759	240920
4183	3336	0	applied	\N	\N	\N	\N	72760	72760	240921
4185	3337	2	applied	\N	\N	\N	\N	72773	72773	240934
4186	3337	2	applied	\N	\N	\N	\N	72776	72776	240937
4198	3357	0	applied	\N	\N	1000000000	\N	72810	72810	240971
4204	3365	3	applied	\N	\N	\N	\N	72825	72825	240986
4217	3370	0	applied	\N	\N	\N	\N	72844	72844	241005
4222	3372	0	applied	\N	\N	\N	\N	72849	72849	241010
4227	3382	7	applied	\N	\N	\N	\N	72866	72866	241027
4245	3377	3	applied	\N	\N	\N	\N	72903	72903	241062
4245	3328	20	applied	\N	\N	\N	\N	72920	72920	241078
4245	3355	37	applied	\N	\N	\N	\N	72937	72937	241095
4245	3372	52	applied	\N	\N	\N	\N	72952	72952	241110
4247	3399	0	applied	\N	\N	\N	\N	72984	72984	241142
4248	3400	2	applied	\N	\N	\N	\N	72990	72990	241148
4249	3399	0	applied	\N	\N	\N	\N	72992	72992	241150
4274	3419	0	applied	\N	\N	1000000000	\N	73031	73031	241189
4276	3354	17	applied	\N	\N	\N	\N	73052	73052	241209
4276	3373	34	applied	\N	\N	\N	\N	73069	73069	241226
4276	3381	39	applied	\N	\N	\N	\N	73073	73073	241230
4276	3401	56	applied	\N	\N	\N	\N	73090	73090	241247
4276	3417	72	applied	\N	\N	\N	\N	73106	73106	241263
4277	3419	0	applied	\N	\N	1000000000	\N	73114	73114	241271
4279	3421	0	applied	\N	\N	\N	\N	73119	73119	241276
4286	3426	0	applied	\N	\N	\N	\N	73131	73131	241288
4293	3433	0	applied	\N	\N	1000000000	\N	73144	73144	241301
4297	3436	0	applied	\N	\N	\N	\N	73149	73149	241306
4306	3377	7	applied	\N	\N	\N	\N	73162	73162	241319
4306	3079	24	applied	\N	\N	\N	\N	73179	73179	241335
4306	3113	58	applied	\N	\N	\N	\N	73213	73213	241369
4306	3132	77	applied	\N	\N	\N	\N	73232	73232	241388
4306	3154	94	applied	\N	\N	\N	\N	73249	73249	241405
4306	3157	97	applied	\N	\N	\N	\N	73252	73252	241408
4306	3174	114	applied	\N	\N	\N	\N	73269	73269	241425
4307	3442	0	applied	\N	\N	\N	\N	73281	73281	241437
4318	3451	0	applied	\N	\N	\N	\N	73297	73297	241453
4330	3458	0	applied	\N	\N	\N	\N	73311	73311	241467
4345	3248	0	applied	\N	\N	\N	\N	73329	73329	241485
4345	3340	15	applied	\N	\N	1000000000	\N	73344	73344	241500
4345	3353	36	applied	\N	\N	\N	\N	73365	73365	241520
4347	3197	11	applied	\N	\N	\N	\N	73379	73379	241534
4347	3213	28	applied	\N	\N	\N	\N	73396	73396	241551
4347	3228	42	applied	\N	\N	\N	\N	73410	73410	241565
4347	3231	45	applied	\N	\N	\N	\N	73413	73413	241568
4347	3249	62	applied	\N	\N	\N	\N	73430	73430	241585
4347	3288	96	applied	\N	\N	\N	\N	73464	73464	241619
4347	3312	113	applied	\N	\N	\N	\N	73481	73481	241636
4367	3489	0	applied	\N	\N	\N	\N	73521	73521	241676
4368	3491	1	applied	\N	\N	\N	\N	73523	73523	241678
4378	3499	0	applied	\N	\N	\N	\N	73535	73535	241690
4388	3435	11	applied	\N	\N	\N	\N	73558	73558	241711
4388	3453	28	applied	\N	\N	\N	\N	73575	73575	241727
4388	3470	46	applied	\N	\N	\N	\N	73593	73593	241745
4388	3489	63	applied	\N	\N	\N	\N	73610	73610	241762
4390	3507	1	applied	\N	\N	\N	\N	73628	73628	241780
4392	3511	6	applied	\N	\N	\N	\N	73640	73640	241792
4394	3527	2	applied	\N	\N	\N	\N	73656	73656	241808
4396	3533	9	applied	\N	\N	\N	\N	73678	73678	241830
4398	3536	0	applied	\N	\N	\N	\N	73691	73691	241843
4399	3546	0	applied	\N	\N	\N	\N	73701	73701	241853
4400	3546	0	applied	\N	\N	\N	\N	73711	73711	241863
4403	3561	5	applied	\N	\N	\N	\N	73746	73746	241898
4405	3573	7	applied	\N	\N	\N	\N	73768	73768	241920
4407	3478	4	applied	\N	\N	1000000000	\N	73783	73783	241935
4407	3427	25	applied	\N	\N	\N	\N	73804	73804	241955
4407	3448	42	applied	\N	\N	\N	\N	73821	73821	241972
4407	3455	49	applied	\N	\N	\N	\N	73828	73828	241979
4407	3520	63	applied	\N	\N	\N	\N	73842	73842	241993
4407	3540	80	applied	\N	\N	\N	\N	73859	73859	242010
4407	3466	97	applied	\N	\N	\N	\N	73876	73876	242027
4407	3485	114	applied	\N	\N	\N	\N	73893	73893	242044
4408	3581	6	applied	\N	\N	\N	\N	73910	73910	242061
4410	3598	3	applied	\N	\N	\N	\N	73927	73927	242078
4411	3605	0	applied	\N	\N	\N	\N	73934	73934	242085
4413	3615	0	applied	\N	\N	1000000000	\N	73954	73954	242105
4413	3621	6	applied	\N	\N	\N	\N	73960	73960	242111
4419	3638	2	applied	\N	\N	\N	\N	74011	74011	242161
4420	3646	0	applied	\N	\N	1000000000	\N	74018	74018	242167
4421	3649	0	applied	\N	\N	\N	\N	74021	74021	242170
4422	3649	0	applied	\N	\N	\N	\N	74023	74023	242172
4425	3652	0	applied	\N	\N	1000000000	\N	74048	74048	242196
4431	3617	2	applied	\N	\N	1000000000	\N	74057	74057	242205
4431	3654	23	applied	\N	\N	\N	\N	74078	74078	242226
4431	3644	27	applied	\N	\N	\N	\N	74082	74082	74082
4442	3667	0	applied	\N	\N	1000000000	\N	74105	74105	242252
4461	3437	4	applied	\N	\N	1000000000	\N	74172	74172	242313
4445	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	74118	74118	\N
4446	3672	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	74120	74120	\N
4461	3506	23	applied	\N	\N	\N	\N	74191	74191	242331
4461	3523	39	applied	\N	\N	\N	\N	74207	74207	242347
4461	3543	56	applied	\N	\N	\N	\N	74224	74224	242364
4461	3562	73	applied	\N	\N	\N	\N	74241	74241	242381
4461	3581	91	applied	\N	\N	\N	\N	74258	74258	242398
4461	3595	104	applied	\N	\N	\N	\N	74271	74271	242411
4461	3607	114	applied	\N	\N	\N	\N	74281	74281	242421
4471	3694	1	applied	\N	\N	\N	\N	74304	74304	242444
4481	3703	0	applied	\N	\N	\N	\N	74326	74326	74326
4489	3710	0	applied	\N	\N	\N	\N	74337	74337	242472
4499	3710	1	applied	\N	\N	\N	\N	74367	74367	242502
4505	3726	0	applied	\N	\N	\N	\N	74378	74378	242513
4511	3673	12	applied	\N	\N	\N	\N	74396	74396	242531
4511	3697	29	applied	\N	\N	\N	\N	74413	74413	242548
4511	3699	31	applied	\N	\N	\N	\N	74415	74415	242550
4511	3723	48	applied	\N	\N	\N	\N	74432	74432	242567
4533	3736	9	applied	\N	\N	\N	\N	74470	74470	242604
4539	3743	0	applied	\N	\N	\N	\N	74480	74480	242614
4541	3745	0	applied	\N	\N	\N	\N	74482	74482	242616
4553	3762	7	applied	\N	\N	\N	\N	74501	74501	242635
4555	3767	12	applied	\N	\N	\N	\N	74520	74520	242654
4560	3765	10	applied	\N	\N	\N	\N	74534	74534	242668
4560	3767	12	applied	\N	\N	\N	\N	74536	74536	242670
4563	3771	0	applied	\N	\N	\N	\N	74554	74554	242688
4571	3748	28	applied	\N	\N	1000000000	\N	74595	74595	242729
4571	3520	48	applied	\N	\N	\N	\N	74615	74615	242748
4571	3532	58	applied	\N	\N	\N	\N	74625	74625	242758
4571	3549	73	applied	\N	\N	\N	\N	74640	74640	242773
4571	3568	91	applied	\N	\N	\N	\N	74657	74657	242790
4571	3587	108	applied	\N	\N	\N	\N	74674	74674	242807
4571	3606	125	applied	\N	\N	\N	\N	74691	74691	242824
4577	3785	0	applied	\N	\N	\N	\N	74700	74700	242833
4582	3788	0	applied	\N	\N	\N	\N	74706	74706	242839
4586	3790	0	applied	\N	\N	1000000000	\N	74714	74714	242847
4589	3775	13	applied	\N	\N	\N	\N	74742	74742	242875
4589	3721	30	applied	\N	\N	\N	\N	74759	74759	242892
4589	3738	47	applied	\N	\N	\N	\N	74776	74776	242909
4589	3741	50	applied	\N	\N	\N	\N	74779	74779	242912
4589	3752	60	applied	\N	\N	\N	\N	74789	74789	242922
4589	3784	77	applied	\N	\N	\N	\N	74806	74806	242939
4591	3762	9	applied	\N	\N	\N	\N	74830	74830	242963
4593	3801	1	applied	\N	\N	\N	\N	74849	74849	242981
4608	3817	0	applied	\N	\N	\N	\N	74871	74871	243003
4617	3684	6	applied	\N	\N	1000000000	\N	74890	74890	243022
4617	3790	23	applied	\N	\N	1000000000	\N	74907	74907	243039
4617	3718	40	applied	\N	\N	1000000000	\N	74924	74924	243056
4617	3705	62	applied	\N	\N	\N	\N	74945	74945	243077
4617	3721	72	applied	\N	\N	\N	\N	74955	74955	243087
4617	3733	84	applied	\N	\N	\N	\N	74967	74967	243099
4626	3827	0	applied	\N	\N	\N	\N	74990	74990	243122
4630	3832	0	applied	\N	\N	\N	\N	74998	74998	243130
4643	3790	15	applied	\N	\N	1000000000	\N	75027	75027	243159
4645	3838	0	applied	\N	\N	\N	\N	75031	75031	243163
4651	3840	0	applied	\N	\N	\N	\N	75037	75037	243169
4657	3853	0	applied	\N	\N	\N	\N	75054	75054	243186
4672	3861	0	applied	\N	\N	\N	\N	75071	75071	243203
4674	3775	14	applied	\N	\N	\N	\N	75088	75088	243220
4674	3722	31	applied	\N	\N	\N	\N	75105	75105	243237
4674	3744	53	applied	\N	\N	\N	\N	75127	75127	243259
4674	3745	54	applied	\N	\N	\N	\N	75128	75128	243260
4674	3777	71	applied	\N	\N	\N	\N	75145	75145	243277
4674	3796	88	applied	\N	\N	\N	\N	75162	75162	243294
4674	3815	105	applied	\N	\N	\N	\N	75179	75179	243311
4674	3832	123	applied	\N	\N	\N	\N	75196	75196	243328
4676	3864	0	applied	\N	\N	\N	\N	75200	75200	243332
4677	3865	0	applied	\N	\N	\N	\N	75201	75201	243333
4681	3867	0	applied	\N	\N	\N	\N	75207	75207	243339
4705	3861	0	applied	\N	\N	\N	\N	75239	75239	243371
4705	3875	19	applied	\N	\N	\N	\N	75258	75258	243390
4721	3894	0	applied	\N	\N	\N	\N	75281	75281	243413
4722	3895	0	applied	\N	\N	\N	\N	75282	75282	243414
4724	3896	0	applied	\N	\N	\N	\N	75285	75285	243417
4731	3901	1	applied	\N	\N	\N	\N	75300	75300	243432
4740	3911	1	applied	\N	\N	\N	\N	75315	75315	243447
4742	3909	20	applied	\N	\N	\N	\N	75338	75338	243470
4764	3615	2	applied	\N	\N	1000000000	\N	75374	75374	243506
4764	3566	24	applied	\N	\N	\N	\N	75395	75395	243527
4777	3936	0	applied	\N	\N	\N	\N	75422	75422	243554
4778	3936	0	applied	\N	\N	\N	\N	75423	75423	243555
4798	3954	0	applied	\N	\N	1000000000	\N	75448	75448	243580
4811	3958	5	applied	\N	\N	1000000000	\N	75479	75479	243611
4811	3844	8	applied	\N	\N	\N	\N	75482	75482	243614
4811	3840	22	applied	\N	\N	\N	\N	75496	75496	243628
4811	3865	39	applied	\N	\N	\N	\N	75513	75513	243645
4811	3883	56	applied	\N	\N	\N	\N	75530	75530	243662
4811	3903	73	applied	\N	\N	\N	\N	75547	75547	243679
4811	3922	90	applied	\N	\N	\N	\N	75564	75564	243696
4812	3969	0	applied	\N	\N	\N	\N	75581	75581	243713
4818	3975	1	applied	\N	\N	\N	\N	75591	75591	243723
4825	3838	15	applied	\N	\N	\N	\N	75617	75617	243749
4825	3857	32	applied	\N	\N	\N	\N	75634	75634	243766
4825	3869	43	applied	\N	\N	\N	\N	75645	75645	243777
4825	3878	51	applied	\N	\N	\N	\N	75653	75653	243785
4825	3893	65	applied	\N	\N	\N	\N	75667	75667	243799
4825	3903	73	applied	\N	\N	\N	\N	75675	75675	243807
4825	3922	90	applied	\N	\N	\N	\N	75692	75692	243824
4416	3634	6	applied	\N	\N	\N	\N	73994	73994	242145
4833	3980	13	applied	\N	\N	\N	\N	75748	75748	243880
4843	3955	4	applied	\N	\N	1000000000	\N	75775	75775	243907
4843	3488	19	applied	\N	\N	\N	\N	75790	75790	243922
4843	3500	29	applied	\N	\N	\N	\N	75800	75800	243932
4843	3621	46	applied	\N	\N	\N	\N	75817	75817	243949
4843	3661	63	applied	\N	\N	\N	\N	75834	75834	243966
4843	3688	80	applied	\N	\N	\N	\N	75851	75851	243983
4843	3708	98	applied	\N	\N	\N	\N	75868	75868	244000
4843	3731	115	applied	\N	\N	\N	\N	75885	75885	244017
4851	4000	0	applied	\N	\N	1000000000	\N	75903	75903	244035
4854	4002	0	applied	\N	\N	1000000000	\N	75909	75909	244041
4860	3954	0	applied	\N	\N	1000000000	\N	75915	75915	244047
4860	3886	17	applied	\N	\N	\N	\N	75932	75932	244064
4860	3889	20	applied	\N	\N	\N	\N	75935	75935	244067
4860	3925	54	applied	\N	\N	\N	\N	75969	75969	244101
4860	3942	71	applied	\N	\N	\N	\N	75986	75986	244118
4860	3966	88	applied	\N	\N	\N	\N	76003	76003	244135
4860	3987	105	applied	\N	\N	\N	\N	76020	76020	244152
4862	4006	1	applied	\N	\N	\N	\N	76041	76041	244173
4863	4008	3	applied	\N	\N	\N	\N	76047	76047	244179
4870	4013	0	applied	\N	\N	\N	\N	76054	76054	244186
4874	3841	14	applied	\N	\N	\N	\N	76072	76072	244204
4874	3864	31	applied	\N	\N	\N	\N	76089	76089	244221
4874	3882	48	applied	\N	\N	\N	\N	76106	76106	244238
4874	3902	65	applied	\N	\N	\N	\N	76123	76123	244255
4874	3920	82	applied	\N	\N	\N	\N	76140	76140	244272
4874	3930	91	applied	\N	\N	\N	\N	76149	76149	244281
4874	3942	103	applied	\N	\N	\N	\N	76161	76161	244293
4874	3966	123	applied	\N	\N	\N	\N	76178	76178	244310
4895	3747	7	applied	\N	\N	\N	\N	76222	76222	244354
4895	3798	41	applied	\N	\N	\N	\N	76256	76256	244388
4895	3800	43	applied	\N	\N	\N	\N	76258	76258	244390
4895	3817	58	applied	\N	\N	\N	\N	76273	76273	244405
4895	3835	75	applied	\N	\N	\N	\N	76290	76290	244422
4895	3859	93	applied	\N	\N	\N	\N	76307	76307	244439
4910	4036	0	applied	\N	\N	\N	\N	76332	76332	244464
4910	4038	2	applied	\N	\N	\N	\N	76334	76334	244466
4918	4046	0	applied	\N	\N	\N	\N	76349	76349	244481
4929	4053	1	applied	\N	\N	\N	\N	76361	76361	244493
4933	4060	0	applied	\N	\N	1000000000	\N	76370	76370	244502
4934	4063	1	applied	\N	\N	\N	\N	76373	76373	244505
4939	4025	16	applied	\N	\N	\N	\N	76393	76393	244525
4950	4074	3	applied	\N	\N	\N	\N	76407	76407	244539
4976	4099	0	applied	\N	\N	\N	\N	76444	76444	244575
4980	4103	1	applied	\N	\N	\N	\N	76458	76458	244587
4981	4105	3	applied	\N	\N	\N	\N	76464	76464	244592
4995	4115	0	applied	\N	\N	1000000000	\N	76490	76490	244618
5008	4126	0	applied	\N	\N	1000000000	\N	76509	76509	244636
5023	4143	0	applied	\N	\N	1000000000	\N	76529	76529	244656
5040	4151	0	applied	\N	\N	\N	\N	76549	76549	244676
5042	4153	0	applied	\N	\N	\N	\N	76552	76552	244679
5051	4164	2	applied	\N	\N	\N	\N	76568	76568	244695
5052	4165	0	applied	\N	\N	\N	\N	76569	76569	244696
5054	4166	0	applied	\N	\N	\N	\N	76571	76571	244698
5055	4165	0	applied	\N	\N	\N	\N	76572	76572	244699
5058	4168	0	applied	\N	\N	\N	\N	76574	76574	244701
5090	4191	0	applied	\N	\N	\N	\N	76621	76621	244748
5094	4196	1	applied	\N	\N	\N	\N	76628	76628	244755
5096	4198	1	applied	\N	\N	\N	\N	76632	76632	244759
5101	4205	0	applied	\N	\N	\N	\N	76639	76639	244766
5131	4220	0	applied	\N	\N	\N	\N	76682	76682	244809
5133	4224	3	applied	\N	\N	\N	\N	76689	76689	244816
5160	4248	0	applied	\N	\N	\N	\N	76731	76731	244858
5166	4252	1	applied	\N	\N	\N	\N	76738	76738	244865
5183	4267	1	applied	\N	\N	\N	\N	76766	76766	244893
5195	4278	0	applied	\N	\N	\N	\N	76780	76780	244907
5197	4279	0	applied	\N	\N	\N	\N	76782	76782	244909
5220	4297	1	applied	\N	\N	\N	\N	76809	76809	244936
5245	4308	0	applied	\N	\N	\N	\N	76838	76838	244965
5263	4318	0	applied	\N	\N	\N	\N	76852	76852	244979
5264	4320	0	applied	\N	\N	\N	\N	76854	76854	244981
5268	4324	1	applied	\N	\N	\N	\N	76861	76861	244988
5299	4347	0	applied	\N	\N	\N	\N	76902	76902	245029
5306	4355	1	applied	\N	\N	1000000000	\N	76913	76913	245040
5310	4358	0	applied	\N	\N	\N	\N	76917	76917	245044
5325	4219	13	applied	\N	\N	\N	\N	76946	76946	245073
5325	4226	20	applied	\N	\N	\N	\N	76953	76953	245080
5325	4237	29	applied	\N	\N	\N	\N	76962	76962	245089
5325	4254	46	applied	\N	\N	\N	\N	76979	76979	245106
5325	4271	63	applied	\N	\N	\N	\N	76996	76996	245123
5325	4307	97	applied	\N	\N	\N	\N	77030	77030	245157
5332	4365	0	applied	\N	\N	\N	\N	77044	77044	245171
5355	4380	0	applied	\N	\N	\N	\N	77071	77071	245198
5361	4375	11	applied	\N	\N	\N	\N	77090	77090	245217
5361	4385	21	applied	\N	\N	\N	\N	77100	77100	245227
5404	4398	0	applied	\N	\N	1000000000	\N	77115	77115	245242
5414	4389	3	applied	\N	\N	\N	\N	77120	77120	245247
5414	4394	8	applied	\N	\N	\N	\N	77125	77125	245252
5453	4307	12	applied	\N	\N	\N	\N	77156	77156	245280
5453	4326	29	applied	\N	\N	\N	\N	77173	77173	245297
5457	4404	0	applied	\N	\N	1000000000	\N	77183	77183	245307
5458	4409	5	applied	\N	\N	1000000000	\N	77195	77195	245319
5514	4293	17	applied	\N	\N	\N	\N	77218	77218	245342
5514	4310	34	applied	\N	\N	\N	\N	77235	77235	245359
5514	4329	51	applied	\N	\N	\N	\N	77252	77252	245376
5596	4411	10	applied	\N	\N	\N	\N	77272	77272	245396
5656	4404	0	applied	\N	\N	1000000000	\N	77275	77275	245399
5656	4407	4	applied	\N	\N	1000000000	\N	77279	77279	245403
5680	4417	0	applied	\N	\N	\N	\N	77301	77301	245425
5739	4423	0	applied	\N	\N	\N	\N	77320	77320	245444
5754	4435	2	applied	\N	\N	\N	\N	77339	77339	245463
5764	4445	2	applied	\N	\N	\N	\N	77355	77355	245479
5768	4451	0	applied	\N	\N	\N	\N	77361	77361	245485
5769	4451	0	applied	\N	\N	\N	\N	77362	77362	245486
5783	4426	7	applied	\N	\N	\N	\N	77388	77388	245512
5783	4441	24	applied	\N	\N	\N	\N	77405	77405	245529
5783	4458	41	applied	\N	\N	\N	\N	77422	77422	245546
5795	4476	0	applied	\N	\N	\N	\N	77454	77454	245578
5799	4480	1	applied	\N	\N	\N	\N	77462	77462	245586
4825	3963	125	applied	\N	\N	\N	\N	75726	75726	243858
5837	4507	0	applied	\N	\N	1000000000	\N	77508	77508	245632
5840	4507	0	applied	\N	\N	1000000000	\N	77520	77520	245644
5866	4472	1	applied	\N	\N	1000000000	\N	77553	77553	245677
5866	4491	22	applied	\N	\N	\N	\N	77574	77574	245698
5866	4509	38	applied	\N	\N	\N	\N	77590	77590	245714
5866	4515	44	applied	\N	\N	\N	\N	77596	77596	245720
5866	4522	51	applied	\N	\N	\N	\N	77603	77603	245727
5871	4532	0	applied	\N	\N	\N	\N	77617	77617	245741
5904	4560	0	applied	\N	\N	\N	\N	77665	77665	245789
5908	4561	0	applied	\N	\N	\N	\N	77668	77668	245792
5917	4567	0	applied	\N	\N	\N	\N	77681	77681	245805
5924	4571	0	applied	\N	\N	\N	\N	77694	77694	245818
5931	4575	0	applied	\N	\N	\N	\N	77704	77704	245828
5933	4564	14	applied	\N	\N	\N	\N	77721	77721	245845
5941	4584	2	applied	\N	\N	\N	\N	77746	77746	245870
5959	4600	0	applied	\N	\N	\N	\N	77771	77771	245895
5959	4601	1	applied	\N	\N	\N	\N	77772	77772	245896
5967	4609	0	applied	\N	\N	\N	\N	77783	77783	245907
5968	4610	1	applied	\N	\N	\N	\N	77786	77786	245910
5990	4626	0	applied	\N	\N	\N	\N	77816	77816	245940
5994	4630	1	applied	\N	\N	\N	\N	77822	77822	245946
6010	4507	0	applied	\N	\N	1000000000	\N	77854	77854	245974
6000	4638	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77841	77841	\N
6028	4665	2	applied	\N	\N	\N	\N	77892	77892	246009
6042	4682	0	applied	\N	\N	\N	\N	77917	77917	246034
6049	4688	0	applied	\N	\N	\N	\N	77925	77925	246042
6067	4701	2	applied	\N	\N	\N	\N	77959	77959	246073
6068	4703	1	applied	\N	\N	\N	\N	77961	77961	246075
6073	4705	0	applied	\N	\N	\N	\N	77966	77966	246080
6091	4716	2	applied	\N	\N	\N	\N	77992	77992	246106
6103	4725	0	applied	\N	\N	\N	\N	78016	78016	246130
6107	4726	0	applied	\N	\N	1000000000	\N	78024	78024	246137
6118	4733	0	applied	\N	\N	\N	\N	78043	78043	246156
6131	4744	0	applied	\N	\N	\N	\N	78060	78060	246173
6151	4753	0	applied	\N	\N	\N	\N	78077	78077	246190
6158	4756	0	applied	\N	\N	\N	\N	78084	78084	246197
6160	4757	0	applied	\N	\N	\N	\N	78086	78086	246199
6161	4757	0	applied	\N	\N	\N	\N	78087	78087	246200
6174	4765	0	applied	\N	\N	\N	\N	78105	78105	246218
6175	4767	2	applied	\N	\N	\N	\N	78111	78111	246224
6178	4770	0	applied	\N	\N	\N	\N	78119	78119	246232
6178	4773	3	applied	\N	\N	\N	\N	78122	78122	246235
6185	4781	3	applied	\N	\N	\N	\N	78140	78140	246253
6189	4786	0	applied	\N	\N	\N	\N	78148	78148	246261
6203	4794	2	applied	\N	\N	\N	\N	78174	78174	246287
6205	4803	1	applied	\N	\N	\N	\N	78184	78184	246297
6228	4805	4	applied	\N	\N	\N	\N	78232	78232	246342
6231	4827	1	applied	\N	\N	\N	\N	78253	78253	246363
6235	4830	0	applied	\N	\N	\N	\N	78269	78269	246378
6237	4831	1	applied	\N	\N	\N	\N	78274	78274	246383
6240	4833	1	applied	\N	\N	\N	\N	78280	78280	246389
6270	4869	2	applied	\N	\N	\N	\N	78328	78328	246437
6274	4870	0	applied	\N	\N	\N	\N	78341	78341	246450
6275	4871	1	applied	\N	\N	\N	\N	78346	78346	246455
6282	4876	0	applied	\N	\N	\N	\N	78355	78355	246464
6307	4891	1	applied	\N	\N	1000000000	\N	78387	78387	246496
6313	4898	0	applied	\N	\N	\N	\N	78401	78401	246510
6325	4905	0	applied	\N	\N	\N	\N	78417	78417	246526
6338	4915	0	applied	\N	\N	\N	\N	78433	78433	246542
6339	4890	8	applied	\N	\N	1000000000	\N	78443	78443	246552
6339	4547	29	applied	\N	\N	\N	\N	78464	78464	246569
6339	4559	41	applied	\N	\N	\N	\N	78476	78476	246581
6339	4562	44	applied	\N	\N	\N	\N	78479	78479	246584
6339	4578	62	applied	\N	\N	\N	\N	78496	78496	246601
6339	4595	79	applied	\N	\N	\N	\N	78513	78513	246618
6339	4632	113	applied	\N	\N	\N	\N	78547	78547	246652
6346	4649	2	applied	\N	\N	\N	\N	78568	78568	246673
6346	4670	19	applied	\N	\N	\N	\N	78585	78585	246690
6346	4689	34	applied	\N	\N	\N	\N	78600	78600	246705
6346	4690	35	applied	\N	\N	\N	\N	78601	78601	246706
6346	4707	52	applied	\N	\N	\N	\N	78618	78618	246723
6346	4724	70	applied	\N	\N	\N	\N	78635	78635	246740
6346	4744	87	applied	\N	\N	\N	\N	78652	78652	246757
6346	4761	104	applied	\N	\N	\N	\N	78669	78669	246774
6346	4780	121	applied	\N	\N	\N	\N	78686	78686	246791
6355	4924	0	applied	\N	\N	\N	\N	78704	78704	246809
6356	4928	1	applied	\N	\N	\N	\N	78708	78708	246813
6360	4807	8	applied	\N	\N	\N	\N	78721	78721	246826
6387	4958	0	applied	\N	\N	\N	\N	78760	78760	246864
6403	4969	0	applied	\N	\N	\N	\N	78782	78782	246886
6404	4969	0	applied	\N	\N	\N	\N	78786	78786	246890
6410	4983	2	applied	\N	\N	\N	\N	78805	78805	246908
6413	4989	3	applied	\N	\N	\N	\N	78813	78813	246913
6413	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78811	78811	\N
6414	4988	2	applied	\N	\N	\N	\N	78818	78818	246915
6414	4989	3	applied	\N	\N	\N	\N	78819	78819	246916
6415	4988	2	applied	\N	\N	\N	\N	78824	78824	246918
6414	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	78820	78820	\N
6689	5219	109	applied	\N	\N	\N	\N	79796	79796	247729
6415	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78823	78823	\N
6415	4989	3	applied	\N	\N	\N	\N	78825	78825	246919
6416	4988	2	applied	\N	\N	\N	\N	78830	78830	246921
6415	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	78826	78826	\N
6416	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78829	78829	\N
6416	4989	3	applied	\N	\N	\N	\N	78831	78831	246922
6417	4992	0	applied	\N	\N	\N	\N	78834	78834	246923
6416	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	78832	78832	\N
6416	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	78833	78833	\N
6419	4992	0	applied	\N	\N	\N	\N	78838	78838	246925
6417	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78835	78835	\N
6420	4992	0	applied	\N	\N	\N	\N	78840	78840	246926
6419	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78839	78839	\N
6421	4992	0	applied	\N	\N	\N	\N	78842	78842	246927
6420	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78841	78841	\N
6421	4993	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78843	78843	\N
5821	4498	0	applied	\N	\N	\N	\N	77488	77488	245612
6422	4788	3	applied	\N	\N	\N	\N	78847	78847	246930
6422	4789	4	applied	\N	\N	\N	\N	78848	78848	246931
6422	4790	5	applied	\N	\N	\N	\N	78849	78849	246932
6422	4791	6	applied	\N	\N	\N	\N	78850	78850	246933
6422	4800	11	applied	\N	\N	\N	\N	78855	78855	246934
6422	4985	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	78851	78851	\N
6422	4987	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	78852	78852	\N
6422	4990	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	78853	78853	\N
6422	4991	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	78854	78854	\N
6422	4801	12	applied	\N	\N	\N	\N	78856	78856	246935
6422	4802	13	applied	\N	\N	\N	\N	78857	78857	246936
6422	4803	14	applied	\N	\N	\N	\N	78858	78858	246937
6422	4804	15	applied	\N	\N	\N	\N	78859	78859	246938
6422	4805	16	applied	\N	\N	\N	\N	78860	78860	246939
6422	4806	17	applied	\N	\N	\N	\N	78861	78861	246940
6422	4834	42	applied	\N	\N	\N	\N	78886	78886	246964
6422	4835	43	applied	\N	\N	\N	\N	78887	78887	246965
6422	4836	44	applied	\N	\N	\N	\N	78888	78888	246966
6422	4837	45	applied	\N	\N	\N	\N	78889	78889	246967
6422	4838	46	applied	\N	\N	\N	\N	78890	78890	246968
6422	4839	47	applied	\N	\N	\N	\N	78891	78891	246969
6422	4840	48	applied	\N	\N	\N	\N	78892	78892	246970
6422	4841	49	applied	\N	\N	\N	\N	78893	78893	246971
6422	4842	50	applied	\N	\N	\N	\N	78894	78894	246972
6422	4843	51	applied	\N	\N	\N	\N	78895	78895	246973
6422	4844	52	applied	\N	\N	\N	\N	78896	78896	246974
6422	4845	53	applied	\N	\N	\N	\N	78897	78897	246975
6422	4848	55	applied	\N	\N	\N	\N	78899	78899	246977
6422	4851	56	applied	\N	\N	\N	\N	78900	78900	246978
6422	4852	57	applied	\N	\N	\N	\N	78901	78901	246979
6422	4853	59	applied	\N	\N	\N	\N	78902	78902	246980
6422	4854	60	applied	\N	\N	\N	\N	78903	78903	246981
6422	4855	61	applied	\N	\N	\N	\N	78904	78904	246982
6422	4856	62	applied	\N	\N	\N	\N	78905	78905	246983
6422	4857	63	applied	\N	\N	\N	\N	78906	78906	246984
6422	4858	64	applied	\N	\N	\N	\N	78907	78907	246985
6422	4859	65	applied	\N	\N	\N	\N	78908	78908	246986
6422	4860	66	applied	\N	\N	\N	\N	78909	78909	246987
6422	4861	67	applied	\N	\N	\N	\N	78910	78910	246988
6422	4862	68	applied	\N	\N	\N	\N	78911	78911	246989
6422	4863	69	applied	\N	\N	\N	\N	78912	78912	246990
6422	4864	70	applied	\N	\N	\N	\N	78913	78913	246991
6422	4865	71	applied	\N	\N	\N	\N	78914	78914	246992
6422	4867	73	applied	\N	\N	\N	\N	78916	78916	246994
6422	4868	74	applied	\N	\N	\N	\N	78917	78917	246995
6422	4869	75	applied	\N	\N	\N	\N	78918	78918	246996
6422	4870	76	applied	\N	\N	\N	\N	78919	78919	246997
6422	4871	77	applied	\N	\N	\N	\N	78920	78920	246998
6422	4872	78	applied	\N	\N	\N	\N	78921	78921	246999
6422	4873	79	applied	\N	\N	\N	\N	78922	78922	247000
6422	4874	80	applied	\N	\N	\N	\N	78923	78923	247001
6422	4875	81	applied	\N	\N	\N	\N	78924	78924	247002
6422	4876	82	applied	\N	\N	\N	\N	78925	78925	247003
6422	4877	83	applied	\N	\N	\N	\N	78926	78926	247004
6422	4878	84	applied	\N	\N	\N	\N	78927	78927	247005
6422	4879	85	applied	\N	\N	\N	\N	78928	78928	247006
6422	4880	86	applied	\N	\N	\N	\N	78929	78929	247007
6422	4881	87	applied	\N	\N	\N	\N	78930	78930	247008
6422	4882	88	applied	\N	\N	\N	\N	78931	78931	247009
6510	5115	0	applied	\N	\N	\N	\N	79200	79200	247178
6464	5056	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	79048	79048	\N
6488	5017	22	failed	Amount_insufficient_to_create_account	\N	\N	\N	79118	79118	\N
6488	5024	25	failed	Amount_insufficient_to_create_account	\N	\N	\N	79121	79121	\N
6488	5045	35	failed	Amount_insufficient_to_create_account	\N	\N	\N	79131	79131	\N
6530	5135	0	applied	\N	\N	\N	\N	79244	79244	247222
6537	5142	1	applied	\N	\N	\N	\N	79257	79257	247235
6562	5169	0	applied	\N	\N	\N	\N	79305	79305	247283
6574	5180	3	applied	\N	\N	\N	\N	79335	79335	247313
6579	5183	0	applied	\N	\N	\N	\N	79344	79344	247322
6580	5184	1	applied	\N	\N	\N	\N	79347	79347	247325
6590	5202	0	applied	\N	\N	\N	\N	79388	79388	247366
6599	5211	1	applied	\N	\N	\N	\N	79409	79409	247387
6600	5213	3	applied	\N	\N	\N	\N	79415	79415	247393
6604	5217	1	applied	\N	\N	\N	\N	79429	79429	247407
6607	5227	5	applied	\N	\N	\N	\N	79447	79447	247425
6621	5243	1	applied	\N	\N	\N	\N	79471	79471	247449
6624	5250	2	applied	\N	\N	\N	\N	79480	79480	247458
6632	5257	3	applied	\N	\N	\N	\N	79502	79502	247480
6635	5260	1	applied	\N	\N	\N	\N	79509	79509	247487
6642	5280	1	applied	\N	\N	\N	\N	79531	79531	247509
6651	5293	0	applied	\N	\N	\N	\N	79552	79552	247530
6653	5295	0	applied	\N	\N	\N	\N	79556	79556	247534
6660	5305	0	applied	\N	\N	\N	\N	79574	79574	247552
6661	5306	1	applied	\N	\N	\N	\N	79576	79576	247554
6666	5310	1	applied	\N	\N	\N	\N	79590	79590	247568
6673	5319	0	applied	\N	\N	\N	\N	79609	79609	247587
6683	5340	3	applied	\N	\N	\N	\N	79657	79657	247620
6687	5351	5	applied	\N	\N	\N	\N	79678	79678	247641
6689	5111	56	applied	\N	\N	\N	\N	79744	79744	247677
6689	4998	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	79690	79690	\N
6689	5037	22	failed	Amount_insufficient_to_create_account	\N	\N	\N	79710	79710	\N
6689	5144	73	applied	\N	\N	\N	\N	79761	79761	247694
6689	5180	90	applied	\N	\N	\N	\N	79778	79778	247711
6689	5218	108	applied	\N	\N	\N	\N	79795	79795	247728
6689	5227	112	applied	\N	\N	\N	\N	79799	79799	247732
6690	5335	4	applied	\N	\N	\N	\N	79816	79816	247749
6690	5254	21	applied	\N	\N	\N	\N	79833	79833	247766
6690	5259	38	applied	\N	\N	\N	\N	79850	79850	247783
6690	5292	56	applied	\N	\N	\N	\N	79867	79867	247800
6690	5296	73	applied	\N	\N	\N	\N	79884	79884	247817
6690	5330	90	applied	\N	\N	\N	\N	79901	79901	247834
6690	5318	105	applied	\N	\N	\N	\N	79916	79916	247849
6690	5354	119	applied	\N	\N	\N	\N	79930	79930	247863
6694	5362	0	applied	\N	\N	\N	\N	79947	79947	247880
6697	5375	3	applied	\N	\N	\N	\N	79964	79964	247897
6422	4951	1	applied	\N	\N	1000000000	\N	78845	78845	246929
6702	5214	26	applied	\N	\N	\N	\N	80000	80000	247933
6702	5248	43	applied	\N	\N	\N	\N	80017	80017	247950
6702	5284	60	applied	\N	\N	\N	\N	80034	80034	247967
6702	5291	63	applied	\N	\N	\N	\N	80037	80037	247970
6702	5191	77	applied	\N	\N	\N	\N	80051	80051	247984
6702	5227	94	applied	\N	\N	\N	\N	80068	80068	248001
6702	5260	111	applied	\N	\N	\N	\N	80085	80085	248018
6707	5394	2	applied	\N	\N	\N	\N	80114	80114	248047
6708	5398	0	applied	\N	\N	\N	\N	80118	80118	248051
6709	5400	0	applied	\N	\N	\N	\N	80120	80120	248053
6718	5414	0	applied	\N	\N	\N	\N	80140	80140	248073
6720	5343	9	applied	\N	\N	\N	\N	80157	80157	248090
6722	5422	0	applied	\N	\N	\N	\N	80164	80164	248097
6741	5446	0	applied	\N	\N	\N	\N	80206	80206	248139
6742	5449	1	applied	\N	\N	\N	\N	80209	80209	248142
6743	5449	1	applied	\N	\N	\N	\N	80211	80211	248144
6748	5459	3	applied	\N	\N	\N	\N	80223	80223	248156
6761	5471	1	applied	\N	\N	\N	\N	80263	80263	248196
6762	5478	0	applied	\N	\N	1000000000	\N	80270	80270	248203
6768	5489	2	applied	\N	\N	\N	\N	80289	80289	248222
6784	5508	1	applied	\N	\N	\N	\N	80320	80320	248253
6786	5509	0	applied	\N	\N	\N	\N	80321	80321	248254
6798	5525	0	applied	\N	\N	\N	\N	80353	80353	248286
6806	5535	0	applied	\N	\N	\N	\N	80368	80368	248301
6814	5546	1	applied	\N	\N	1000000000	\N	80393	80393	248326
6815	5552	3	applied	\N	\N	\N	\N	80399	80399	248332
6818	5556	0	applied	\N	\N	\N	\N	80407	80407	248340
6827	5574	4	applied	\N	\N	\N	\N	80433	80433	248366
6828	5574	4	applied	\N	\N	\N	\N	80441	80441	248374
6835	5583	1	applied	\N	\N	\N	\N	80457	80457	248390
6845	5595	3	applied	\N	\N	\N	\N	80483	80483	248416
6846	5597	5	applied	\N	\N	\N	\N	80491	80491	248424
6850	5595	3	applied	\N	\N	\N	\N	80510	80510	248443
6852	5598	0	applied	\N	\N	\N	\N	80516	80516	248449
6864	5627	2	applied	\N	\N	\N	\N	80563	80563	248494
6873	5639	1	applied	\N	\N	\N	\N	80588	80588	248519
6878	5360	2	applied	\N	\N	\N	\N	80599	80599	248530
6878	5362	3	applied	\N	\N	\N	\N	80600	80600	248531
6878	5385	20	applied	\N	\N	\N	\N	80617	80617	248548
6878	5421	37	applied	\N	\N	\N	\N	80634	80634	248565
6878	5454	55	applied	\N	\N	\N	\N	80651	80651	248582
6878	5472	64	applied	\N	\N	\N	\N	80660	80660	248591
6878	5478	67	applied	\N	\N	1000000000	\N	80663	80663	248594
6878	5517	87	applied	\N	\N	\N	\N	80683	80683	248614
6878	5546	104	applied	\N	\N	1000000000	\N	80700	80700	248631
6878	5582	123	applied	\N	\N	\N	\N	80719	80719	248650
6879	5644	0	applied	\N	\N	\N	\N	80722	80722	248653
6883	5644	0	applied	\N	\N	\N	\N	80740	80740	248671
6883	5647	1	applied	\N	\N	\N	\N	80741	80741	248672
6885	5647	1	applied	\N	\N	\N	\N	80749	80749	248680
6898	5667	1	applied	\N	\N	\N	\N	80781	80781	248712
6902	5671	1	applied	\N	\N	\N	\N	80789	80789	248720
6904	5674	2	applied	\N	\N	\N	\N	80794	80794	248725
6911	5680	0	applied	\N	\N	\N	\N	80807	80807	248738
6927	5692	0	applied	\N	\N	\N	\N	80841	80841	248772
6945	5714	0	applied	\N	\N	\N	\N	80872	80872	248803
6946	5719	1	applied	\N	\N	1000000000	\N	80877	80877	248808
6950	5722	0	applied	\N	\N	\N	\N	80883	80883	248814
6952	5725	0	applied	\N	\N	\N	\N	80889	80889	248820
6954	5665	7	applied	\N	\N	\N	\N	80910	80910	248841
6954	5684	29	applied	\N	\N	\N	\N	80932	80932	248863
6954	5716	46	applied	\N	\N	\N	\N	80949	80949	248880
6954	5707	63	applied	\N	\N	\N	\N	80966	80966	248897
6954	5729	75	applied	\N	\N	\N	\N	80978	80978	248909
6964	5738	1	applied	\N	\N	\N	\N	81001	81001	248932
6975	5755	1	applied	\N	\N	\N	\N	81028	81028	248959
6979	5762	1	applied	\N	\N	\N	\N	81038	81038	248969
6983	5767	0	applied	\N	\N	\N	\N	81049	81049	248980
6993	5786	1	applied	\N	\N	1000000000	\N	81083	81083	249014
6995	5795	1	applied	\N	\N	\N	\N	81101	81101	249032
7009	5804	2	applied	\N	\N	\N	\N	81123	81123	249054
7014	5807	0	applied	\N	\N	\N	\N	81140	81140	249071
7020	5816	1	applied	\N	\N	\N	\N	81161	81161	249092
7022	5827	4	applied	\N	\N	\N	\N	81172	81172	249103
7023	5824	1	applied	\N	\N	\N	\N	81175	81175	249106
7032	5844	3	applied	\N	\N	\N	\N	81209	81209	249140
7039	5858	1	applied	\N	\N	\N	\N	81225	81225	249156
7042	5865	5	applied	\N	\N	\N	\N	81234	81234	249165
7046	5875	3	applied	\N	\N	\N	\N	81248	81248	249179
7056	5887	1	applied	\N	\N	\N	\N	81276	81276	249207
7060	5893	1	applied	\N	\N	\N	\N	81284	81284	249215
7070	5846	13	applied	\N	\N	\N	\N	81319	81319	249250
7070	5880	30	applied	\N	\N	\N	\N	81336	81336	249267
7070	5860	47	applied	\N	\N	\N	\N	81353	81353	249284
7070	5885	61	applied	\N	\N	\N	\N	81366	81366	249297
7070	5887	62	applied	\N	\N	\N	\N	81367	81367	249298
7076	5916	6	applied	\N	\N	\N	\N	81395	81395	249326
7077	5914	4	applied	\N	\N	\N	\N	81406	81406	249337
7078	5805	6	applied	\N	\N	\N	\N	81421	81421	249352
7078	5829	23	applied	\N	\N	\N	\N	81438	81438	249369
7078	5834	40	applied	\N	\N	\N	\N	81455	81455	249386
7078	5869	57	applied	\N	\N	\N	\N	81472	81472	249403
7078	5888	67	applied	\N	\N	\N	\N	81482	81482	249413
7078	5861	81	applied	\N	\N	1000000000	\N	81496	81496	249427
7078	5898	100	applied	\N	\N	\N	\N	81515	81515	249446
7078	5918	118	applied	\N	\N	\N	\N	81532	81532	249463
7079	5924	2	applied	\N	\N	\N	\N	81539	81539	249470
7080	5925	3	applied	\N	\N	\N	\N	81544	81544	249475
7098	5950	0	applied	\N	\N	\N	\N	81587	81587	249518
7111	5973	2	applied	\N	\N	\N	\N	81621	81621	249552
7112	5974	3	applied	\N	\N	\N	\N	81626	81626	249557
7113	5976	1	applied	\N	\N	\N	\N	81628	81628	249559
7118	6000	8	applied	\N	\N	\N	\N	81663	81663	249594
7119	6004	1	applied	\N	\N	\N	\N	81667	81667	249598
7124	6017	1	applied	\N	\N	\N	\N	81688	81688	249619
7132	6026	0	applied	\N	\N	\N	\N	81703	81703	249634
7132	6027	1	applied	\N	\N	\N	\N	81704	81704	249635
7138	6031	0	applied	\N	\N	\N	\N	81718	81718	249649
7149	6040	0	applied	\N	\N	1000000000	\N	81734	81734	249665
7150	5923	18	applied	\N	\N	\N	\N	81754	81754	249685
6702	5182	9	applied	\N	\N	\N	\N	79983	79983	247916
7150	5989	69	applied	\N	\N	\N	\N	81805	81805	249736
7150	6026	86	applied	\N	\N	\N	\N	81822	81822	249753
7150	6028	87	applied	\N	\N	\N	\N	81823	81823	249754
7150	5977	99	applied	\N	\N	\N	\N	81835	81835	249766
7150	6011	117	applied	\N	\N	\N	\N	81852	81852	249783
7153	6044	0	applied	\N	\N	\N	\N	81865	81865	249796
7157	6047	0	applied	\N	\N	1000000000	\N	81870	81870	249801
7159	6047	0	applied	\N	\N	1000000000	\N	81876	81876	249807
7169	6053	0	applied	\N	\N	\N	\N	81892	81892	249823
7178	6065	0	applied	\N	\N	\N	\N	81909	81909	249840
7180	6066	0	applied	\N	\N	\N	\N	81911	81911	249842
7215	6097	1	applied	\N	\N	\N	\N	81963	81963	249894
7222	6100	0	applied	\N	\N	\N	\N	81973	81973	249904
7223	6101	0	applied	\N	\N	\N	\N	81974	81974	249905
7230	5826	15	applied	\N	\N	\N	\N	81999	81999	249930
7230	5842	32	applied	\N	\N	\N	\N	82016	82016	249947
7230	5863	49	applied	\N	\N	\N	\N	82033	82033	249964
7230	5900	66	applied	\N	\N	\N	\N	82050	82050	249981
7230	5877	83	applied	\N	\N	\N	\N	82067	82067	249998
7230	5905	99	applied	\N	\N	1000000000	\N	82082	82082	250013
7230	5914	104	applied	\N	\N	\N	\N	82087	82087	250018
7239	6111	0	applied	\N	\N	\N	\N	82111	82111	250042
7249	6120	0	applied	\N	\N	\N	\N	82126	82126	250057
7257	6126	0	applied	\N	\N	\N	\N	82135	82135	250066
7260	6000	10	applied	\N	\N	\N	\N	82148	82148	250079
7260	6037	47	applied	\N	\N	\N	\N	82184	82184	250115
7260	6055	64	applied	\N	\N	\N	\N	82201	82201	250132
7260	6073	81	applied	\N	\N	\N	\N	82218	82218	250149
7260	6090	98	applied	\N	\N	\N	\N	82235	82235	250166
7260	6091	99	applied	\N	\N	\N	\N	82236	82236	250167
7260	6099	107	applied	\N	\N	\N	\N	82244	82244	250175
7260	6117	124	applied	\N	\N	\N	\N	82261	82261	250192
7272	6136	0	applied	\N	\N	\N	\N	82277	82277	250208
7295	6149	0	applied	\N	\N	\N	\N	82306	82306	250237
7302	6157	2	applied	\N	\N	\N	\N	82317	82317	250248
7303	6155	0	applied	\N	\N	\N	\N	82320	82320	250251
7316	6173	1	applied	\N	\N	\N	\N	82348	82348	250277
7310	6166	0	failed	Receiver_not_present	\N	\N	\N	82334	82334	\N
7322	6179	0	applied	\N	\N	\N	\N	82358	82358	250287
7341	6043	7	applied	\N	\N	\N	\N	82402	82402	250330
7340	6166	5	failed	Receiver_not_present	\N	\N	\N	82394	82394	\N
7341	6060	24	applied	\N	\N	\N	\N	82419	82419	250346
7341	6077	41	applied	\N	\N	\N	\N	82436	82436	250363
7341	6095	59	applied	\N	\N	\N	\N	82454	82454	250381
7341	6108	71	applied	\N	\N	\N	\N	82466	82466	250393
7341	6142	106	applied	\N	\N	\N	\N	82500	82500	250427
7341	6159	123	applied	\N	\N	\N	\N	82517	82517	250444
7350	6223	7	applied	\N	\N	\N	\N	82565	82565	250490
7346	6205	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	82532	82532	\N
7347	6205	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	82539	82539	\N
7352	6225	1	applied	\N	\N	\N	\N	82575	82575	250500
7353	6230	6	applied	\N	\N	\N	\N	82588	82588	250513
7354	6210	23	applied	\N	\N	\N	\N	82613	82613	250538
7354	6225	37	applied	\N	\N	\N	\N	82627	82627	250552
7354	6184	43	applied	\N	\N	\N	\N	82633	82633	250558
7357	6251	10	applied	\N	\N	\N	\N	82676	82676	250600
7358	6257	16	applied	\N	\N	\N	\N	82700	82700	250624
7361	6265	6	applied	\N	\N	\N	\N	82726	82726	250650
7362	6274	6	applied	\N	\N	\N	\N	82735	82735	250659
7367	6276	0	applied	\N	\N	\N	\N	82768	82768	250692
7367	6279	3	applied	\N	\N	\N	\N	82771	82771	250695
7368	6276	0	applied	\N	\N	\N	\N	82775	82775	250699
7371	6283	0	applied	\N	\N	\N	\N	82796	82796	250720
7372	6303	14	applied	\N	\N	\N	\N	82816	82816	250739
7373	6299	9	applied	\N	\N	\N	\N	82841	82841	250763
7373	6290	0	failed	Receiver_not_present	\N	\N	\N	82832	82832	\N
7373	6316	26	applied	\N	\N	\N	\N	82858	82858	250780
7381	6322	0	applied	\N	\N	\N	\N	82868	82868	250790
7390	6335	3	applied	\N	\N	\N	\N	82884	82884	250806
7393	6337	0	applied	\N	\N	\N	\N	82892	82892	250814
7400	6346	2	applied	\N	\N	1000000000	\N	82904	82904	250826
7419	6367	1	applied	\N	\N	\N	\N	82942	82942	250864
7424	6047	0	applied	\N	\N	1000000000	\N	82948	82948	250870
7424	5760	29	applied	\N	\N	\N	\N	82976	82976	250896
7424	6166	11	failed	Receiver_not_present	\N	\N	\N	82959	82959	\N
7424	5761	30	applied	\N	\N	\N	\N	82977	82977	250897
7424	5786	45	applied	\N	\N	1000000000	\N	82992	82992	250912
7424	5774	66	applied	\N	\N	\N	\N	83013	83013	250933
7424	5827	83	applied	\N	\N	\N	\N	83030	83030	250950
7424	6207	100	applied	\N	\N	\N	\N	83047	83047	250967
7424	6225	117	applied	\N	\N	\N	\N	83064	83064	250984
7432	6379	0	applied	\N	\N	\N	\N	83087	83087	251007
7441	6386	0	applied	\N	\N	\N	\N	83097	83097	251017
7451	6395	0	applied	\N	\N	\N	\N	83110	83110	251030
7457	6403	0	applied	\N	\N	\N	\N	83120	83120	251040
7475	6417	0	applied	\N	\N	\N	\N	83166	83166	251085
7481	6420	0	applied	\N	\N	\N	\N	83175	83175	251094
7484	6423	0	applied	\N	\N	\N	\N	83184	83184	251103
7494	6430	1	applied	\N	\N	\N	\N	83199	83199	251118
7501	6439	0	applied	\N	\N	\N	\N	83210	83210	251129
7511	6343	10	applied	\N	\N	\N	\N	83240	83240	251159
7511	6362	27	applied	\N	\N	\N	\N	83257	83257	251176
7511	6381	44	applied	\N	\N	\N	\N	83274	83274	251193
7511	6400	62	applied	\N	\N	\N	\N	83291	83291	251210
7511	6417	79	applied	\N	\N	\N	\N	83308	83308	251227
7511	6419	80	applied	\N	\N	\N	\N	83309	83309	251228
7511	6426	86	applied	\N	\N	\N	\N	83315	83315	251234
7511	6444	103	applied	\N	\N	\N	\N	83332	83332	251251
7519	6457	0	applied	\N	\N	\N	\N	83359	83359	251278
7520	6459	2	applied	\N	\N	\N	\N	83364	83364	251283
7521	6458	1	applied	\N	\N	\N	\N	83366	83366	251285
7528	6137	33	applied	\N	\N	\N	\N	83407	83407	251324
7528	6154	51	applied	\N	\N	\N	\N	83424	83424	251341
7528	6159	56	applied	\N	\N	\N	\N	83429	83429	251346
7528	6162	59	applied	\N	\N	\N	\N	83432	83432	251349
7528	6180	76	applied	\N	\N	\N	\N	83449	83449	251366
7528	6222	93	applied	\N	\N	\N	\N	83466	83466	251383
7528	6190	110	applied	\N	\N	\N	\N	83483	83483	251400
7150	5954	52	applied	\N	\N	\N	\N	81788	81788	249719
7529	6181	28	applied	\N	\N	\N	\N	83527	83527	251443
7529	6223	45	applied	\N	\N	\N	\N	83544	83544	251460
7529	6191	62	applied	\N	\N	\N	\N	83561	83561	251477
7529	6276	79	applied	\N	\N	\N	\N	83578	83578	251494
7529	6238	97	applied	\N	\N	\N	\N	83595	83595	251511
7529	6251	108	applied	\N	\N	\N	\N	83606	83606	251522
7529	6260	116	applied	\N	\N	\N	\N	83614	83614	251530
7530	6466	1	applied	\N	\N	\N	\N	83625	83625	83625
7551	6481	0	applied	\N	\N	\N	\N	83657	83657	251568
7563	6488	0	applied	\N	\N	\N	\N	83670	83670	251581
7579	6445	0	applied	\N	\N	\N	\N	83688	83688	251597
7579	6457	17	applied	\N	\N	\N	\N	83705	83705	251614
7579	6480	38	applied	\N	\N	\N	\N	83726	83726	251635
7590	6501	1	applied	\N	\N	\N	\N	83759	83759	251666
7591	6501	0	applied	\N	\N	\N	\N	83760	83760	251667
7598	6463	10	applied	\N	\N	\N	\N	83790	83790	251697
7598	6482	27	applied	\N	\N	\N	\N	83807	83807	251714
7598	6499	44	applied	\N	\N	\N	\N	83824	83824	251731
7601	6515	1	applied	\N	\N	\N	\N	83841	83841	251746
7605	6522	0	applied	\N	\N	\N	\N	83848	83848	251753
7611	6524	1	applied	\N	\N	1000000000	\N	83853	83853	251758
7622	6531	0	applied	\N	\N	\N	\N	83873	83873	251778
7627	6538	0	applied	\N	\N	\N	\N	83890	83890	251795
7629	6540	0	applied	\N	\N	\N	\N	83892	83892	251797
7630	6546	0	applied	\N	\N	\N	\N	83898	83898	251803
7631	6547	0	applied	\N	\N	\N	\N	83899	83899	251804
7632	6548	0	applied	\N	\N	\N	\N	83900	83900	251805
7644	6515	4	applied	\N	\N	\N	\N	83941	83941	251846
7644	6534	22	applied	\N	\N	\N	\N	83958	83958	251863
7644	6552	39	applied	\N	\N	\N	\N	83975	83975	251880
7651	6567	4	applied	\N	\N	\N	\N	83992	83992	251897
7652	6570	1	applied	\N	\N	\N	\N	83997	83997	251902
7663	6579	0	applied	\N	\N	\N	\N	84011	84011	251916
7689	6609	0	applied	\N	\N	\N	\N	84061	84061	251966
7695	6616	0	applied	\N	\N	\N	\N	84070	84070	251975
7707	6620	1	applied	\N	\N	\N	\N	84083	84083	251988
7727	6635	1	applied	\N	\N	\N	\N	84108	84108	252013
7729	6636	0	applied	\N	\N	1000000000	\N	84109	84109	252014
7736	6641	15	applied	\N	\N	\N	\N	84135	84135	252040
7750	6655	0	applied	\N	\N	\N	\N	84154	84154	252059
7762	6661	0	applied	\N	\N	\N	\N	84167	84167	252072
7784	6678	0	applied	\N	\N	\N	\N	84193	84193	252098
7786	6680	0	applied	\N	\N	\N	\N	84197	84197	252102
7797	6690	0	applied	\N	\N	\N	\N	84212	84212	252117
7806	6696	0	applied	\N	\N	\N	\N	84222	84222	252127
7824	6708	0	applied	\N	\N	\N	\N	84249	84249	252154
7838	6715	0	applied	\N	\N	\N	\N	84263	84263	252168
7851	6728	0	applied	\N	\N	\N	\N	84288	84288	252193
7852	6730	1	applied	\N	\N	\N	\N	84290	84290	252195
7859	6736	0	applied	\N	\N	\N	\N	84298	84298	252203
7866	6366	12	applied	\N	\N	\N	\N	84316	84316	252220
7894	6757	0	applied	\N	\N	\N	\N	84357	84357	252261
7909	6765	0	applied	\N	\N	\N	\N	84379	84379	252283
7912	6768	0	applied	\N	\N	\N	\N	84382	84382	252286
7920	6777	1	applied	\N	\N	\N	\N	84397	84397	252301
7921	6778	0	applied	\N	\N	\N	\N	84398	84398	252302
7921	6779	1	applied	\N	\N	\N	\N	84399	84399	252303
7927	6785	1	applied	\N	\N	\N	\N	84410	84410	252314
7932	6658	15	applied	\N	\N	\N	\N	84430	84430	252334
7932	6675	32	applied	\N	\N	\N	\N	84447	84447	252351
7932	6693	50	applied	\N	\N	\N	\N	84464	84464	252368
7932	6708	65	applied	\N	\N	\N	\N	84479	84479	252383
7932	6726	82	applied	\N	\N	\N	\N	84496	84496	252400
7932	6737	93	applied	\N	\N	\N	\N	84507	84507	252411
7932	6743	99	applied	\N	\N	\N	\N	84513	84513	252417
7932	6761	116	applied	\N	\N	\N	\N	84530	84530	252434
7952	6796	0	applied	\N	\N	\N	\N	84562	84562	252466
7959	6790	17	applied	\N	\N	\N	\N	84587	84587	252491
7962	6807	2	applied	\N	\N	\N	\N	84607	84607	252511
7964	6808	0	applied	\N	\N	\N	\N	84609	84609	252513
7982	6823	0	applied	\N	\N	\N	\N	84638	84638	252542
7988	6836	0	applied	\N	\N	\N	\N	84654	84654	252558
7995	6845	0	applied	\N	\N	\N	\N	84667	84667	252571
7995	6846	1	applied	\N	\N	\N	\N	84668	84668	252572
8014	6854	0	applied	\N	\N	\N	\N	84689	84689	252593
8020	6863	1	applied	\N	\N	\N	\N	84700	84700	252604
8033	6878	8	applied	\N	\N	1000000000	\N	84729	84729	252633
8034	6870	0	applied	\N	\N	\N	\N	84733	84733	252637
8035	6875	5	applied	\N	\N	1000000000	\N	84750	84750	252654
8067	6901	0	applied	\N	\N	\N	\N	84799	84799	252703
8070	6904	0	applied	\N	\N	\N	\N	84802	84802	252706
8071	6907	1	applied	\N	\N	\N	\N	84805	84805	252709
8085	6926	0	applied	\N	\N	\N	\N	84834	84834	252738
8100	6935	1	applied	\N	\N	\N	\N	84856	84856	252760
8105	6941	0	applied	\N	\N	\N	\N	84868	84868	252772
8124	6958	1	applied	\N	\N	\N	\N	84896	84896	252800
8125	6963	0	applied	\N	\N	\N	\N	84900	84900	252804
8141	6976	0	applied	\N	\N	\N	\N	84920	84920	252824
8144	6977	0	applied	\N	\N	\N	\N	84923	84923	252827
8150	6982	2	applied	\N	\N	1000000000	\N	84936	84936	252840
8153	6952	12	applied	\N	\N	\N	\N	84955	84955	252859
8153	6971	29	applied	\N	\N	\N	\N	84972	84972	252876
8159	6988	0	applied	\N	\N	\N	\N	84992	84992	252896
8174	6995	0	applied	\N	\N	\N	\N	85013	85013	252917
8178	6996	0	applied	\N	\N	\N	\N	85020	85020	252924
8195	7012	0	applied	\N	\N	\N	\N	85047	85047	252951
8196	7013	1	applied	\N	\N	\N	\N	85051	85051	252955
8210	6976	10	applied	\N	\N	\N	\N	85082	85082	252986
8210	6993	27	applied	\N	\N	\N	\N	85099	85099	253003
8217	7029	0	applied	\N	\N	\N	\N	85137	85137	253041
8219	7030	1	applied	\N	\N	1000000000	\N	85142	85142	253046
8220	7030	1	applied	\N	\N	1000000000	\N	85144	85144	253048
8243	7042	0	applied	\N	\N	\N	\N	85176	85176	253080
8248	7045	0	applied	\N	\N	\N	\N	85188	85188	253092
8261	7052	1	applied	\N	\N	\N	\N	85206	85206	253110
8275	7072	0	applied	\N	\N	\N	\N	85240	85240	253142
8276	7075	0	applied	\N	\N	\N	\N	85243	85243	253145
8285	7079	0	applied	\N	\N	\N	\N	85256	85256	253158
8286	7080	0	applied	\N	\N	\N	\N	85257	85257	253159
8295	7088	0	applied	\N	\N	\N	\N	85274	85274	253176
7529	6361	9	applied	\N	\N	1000000000	\N	83508	83508	251424
8310	7001	15	applied	\N	\N	\N	\N	85312	85312	253214
8310	7018	32	applied	\N	\N	1000000000	\N	85329	85329	253231
8310	7037	51	applied	\N	\N	\N	\N	85348	85348	253250
8310	7042	56	applied	\N	\N	\N	\N	85353	85353	253255
8310	7051	64	applied	\N	\N	\N	\N	85361	85361	253263
8310	7072	81	applied	\N	\N	\N	\N	85378	85378	253280
8310	7095	98	applied	\N	\N	\N	\N	85395	85395	253297
8314	7103	0	applied	\N	\N	\N	\N	85407	85407	253309
8316	7107	3	applied	\N	\N	\N	\N	85411	85411	253313
8340	7125	0	applied	\N	\N	\N	\N	85447	85447	253349
8342	7125	0	applied	\N	\N	\N	\N	85449	85449	253351
8361	7155	1	applied	\N	\N	\N	\N	85501	85501	253402
8354	7145	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	85487	85487	\N
8375	7169	1	applied	\N	\N	\N	\N	85519	85519	253420
8378	7172	2	applied	\N	\N	\N	\N	85530	85530	253431
8388	6996	5	applied	\N	\N	\N	\N	85558	85558	253459
8388	7017	27	applied	\N	\N	\N	\N	85580	85580	253481
8388	7034	44	applied	\N	\N	\N	\N	85597	85597	253498
8388	7043	53	applied	\N	\N	\N	\N	85606	85606	253507
8388	7059	67	applied	\N	\N	\N	\N	85620	85620	253521
8388	7081	84	applied	\N	\N	\N	\N	85637	85637	253538
8388	7105	101	applied	\N	\N	\N	\N	85654	85654	253555
8388	7124	118	applied	\N	\N	\N	\N	85671	85671	253572
8394	7187	0	applied	\N	\N	\N	\N	85686	85686	253587
8402	7192	0	applied	\N	\N	\N	\N	85697	85697	253598
8449	7203	1	applied	\N	\N	1000000000	\N	85718	85718	253619
8450	7202	0	applied	\N	\N	\N	\N	85720	85720	253621
8469	7215	2	applied	\N	\N	\N	\N	85752	85752	253653
8474	7219	0	applied	\N	\N	\N	\N	85759	85759	253660
8497	7236	0	applied	\N	\N	\N	\N	85794	85794	253695
8518	7248	0	applied	\N	\N	\N	\N	85816	85816	253717
8526	7257	0	applied	\N	\N	\N	\N	85830	85830	253731
8543	7270	1	applied	\N	\N	\N	\N	85853	85853	253754
8546	7273	1	applied	\N	\N	\N	\N	85858	85858	253759
8557	7280	0	applied	\N	\N	\N	\N	85868	85868	253769
8563	7285	0	applied	\N	\N	\N	\N	85875	85875	253776
8579	7298	0	applied	\N	\N	\N	\N	85898	85898	253799
8584	7206	7	applied	\N	\N	\N	\N	85910	85910	253811
8584	7220	21	applied	\N	\N	\N	\N	85924	85924	253825
8584	7238	37	applied	\N	\N	\N	\N	85940	85940	253841
8584	7256	55	applied	\N	\N	\N	\N	85957	85957	253858
8584	7273	72	applied	\N	\N	\N	\N	85974	85974	253875
8584	7290	89	applied	\N	\N	\N	\N	85991	85991	253892
8603	7316	3	applied	\N	\N	\N	\N	86027	86027	253928
8604	7314	1	applied	\N	\N	\N	\N	86043	86043	253944
8605	7320	8	applied	\N	\N	\N	\N	86067	86067	253968
8606	7303	2	applied	\N	\N	\N	\N	86080	86080	253981
8606	7306	5	applied	\N	\N	\N	\N	86083	86083	253984
8606	7317	15	applied	\N	\N	\N	\N	86093	86093	253994
8606	7330	32	applied	\N	\N	\N	\N	86110	86110	254011
8610	7156	1	applied	\N	\N	\N	\N	86118	86118	254019
8610	7174	18	applied	\N	\N	\N	\N	86135	86135	254036
8621	7342	0	applied	\N	\N	\N	\N	86152	86152	254053
8626	7173	13	applied	\N	\N	\N	\N	86169	86169	254070
8626	7194	30	applied	\N	\N	\N	\N	86186	86186	254087
8626	7213	47	applied	\N	\N	\N	\N	86203	86203	254104
8626	7231	64	applied	\N	\N	\N	\N	86220	86220	254121
8626	7239	71	applied	\N	\N	\N	\N	86227	86227	254128
8626	7242	74	applied	\N	\N	\N	\N	86230	86230	254131
8626	7260	91	applied	\N	\N	\N	\N	86247	86247	254148
8626	7277	108	applied	\N	\N	\N	\N	86264	86264	254165
8628	7346	1	applied	\N	\N	\N	\N	86283	86283	254184
8629	7345	0	applied	\N	\N	\N	\N	86284	86284	254185
8630	7347	0	applied	\N	\N	\N	\N	86286	86286	254187
8632	7203	10	applied	\N	\N	1000000000	\N	86300	86300	254201
8632	7223	30	applied	\N	\N	1000000000	\N	86320	86320	254221
8632	7245	50	applied	\N	\N	\N	\N	86340	86340	254241
8632	7263	68	applied	\N	\N	\N	\N	86357	86357	254258
8632	7280	85	applied	\N	\N	\N	\N	86374	86374	254275
8646	7360	5	applied	\N	\N	\N	\N	86400	86400	254301
8666	7374	0	applied	\N	\N	\N	\N	86427	86427	254328
8668	7380	1	applied	\N	\N	\N	\N	86433	86433	254334
8682	7300	3	applied	\N	\N	\N	\N	86444	86444	254345
8682	7314	20	applied	\N	\N	\N	\N	86461	86461	254362
8682	7341	37	applied	\N	\N	\N	\N	86478	86478	254379
8682	7360	56	applied	\N	\N	\N	\N	86496	86496	254397
8682	7373	68	applied	\N	\N	\N	\N	86508	86508	254409
8688	7378	2	applied	\N	\N	\N	\N	86536	86536	254437
8698	7398	0	applied	\N	\N	\N	\N	86558	86558	254459
8707	7413	1	applied	\N	\N	\N	\N	86580	86580	254479
8710	7416	0	applied	\N	\N	\N	\N	86583	86583	254482
8713	7385	8	applied	\N	\N	\N	\N	86609	86609	254508
8713	7212	25	applied	\N	\N	\N	\N	86626	86626	254525
8713	7230	43	applied	\N	\N	\N	\N	86643	86643	254542
8713	7248	60	applied	\N	\N	\N	\N	86660	86660	254559
8713	7266	77	applied	\N	\N	\N	\N	86677	86677	254576
8713	7272	83	applied	\N	\N	\N	\N	86683	86683	254582
8713	7286	97	applied	\N	\N	\N	\N	86697	86697	254596
8713	7303	114	applied	\N	\N	\N	\N	86714	86714	254613
8719	7428	0	applied	\N	\N	\N	\N	86729	86729	254628
8728	7449	0	applied	\N	\N	\N	\N	86758	86758	254657
8737	7464	1	applied	\N	\N	\N	\N	86779	86779	254678
8739	7471	2	applied	\N	\N	\N	\N	86786	86786	254685
8748	7483	0	applied	\N	\N	\N	\N	86804	86804	254703
8766	7497	0	applied	\N	\N	\N	\N	86839	86839	254738
8773	7505	2	applied	\N	\N	\N	\N	86859	86859	254758
8779	7515	0	applied	\N	\N	\N	\N	86873	86873	254772
8781	7518	1	applied	\N	\N	1000000000	\N	86880	86880	254779
8793	7526	1	applied	\N	\N	\N	\N	86910	86910	254809
8794	7528	3	applied	\N	\N	\N	\N	86916	86916	254815
8810	7552	0	applied	\N	\N	\N	\N	86949	86949	254848
8814	7555	0	applied	\N	\N	1000000000	\N	86957	86957	254856
8815	7555	1	applied	\N	\N	1000000000	\N	86962	86962	254861
8825	7573	1	applied	\N	\N	\N	\N	86987	86987	254886
8830	7578	3	applied	\N	\N	\N	\N	87016	87016	254915
8832	7587	3	applied	\N	\N	\N	\N	87025	87025	254924
8833	7591	1	applied	\N	\N	\N	\N	87029	87029	254928
8838	7598	3	applied	\N	\N	\N	\N	87045	87045	254944
8840	7598	3	applied	\N	\N	\N	\N	87053	87053	254952
8310	6994	7	applied	\N	\N	\N	\N	85305	85305	253207
8851	7612	1	applied	\N	\N	\N	\N	87086	87086	254985
8855	7612	1	applied	\N	\N	\N	\N	87094	87094	254993
8856	7613	0	applied	\N	\N	\N	\N	87095	87095	254994
8869	7629	0	applied	\N	\N	\N	\N	87121	87121	255020
8870	7633	0	applied	\N	\N	\N	\N	87125	87125	255024
8876	7630	4	applied	\N	\N	\N	\N	87139	87139	255038
8886	7660	2	applied	\N	\N	\N	\N	87178	87178	255077
8892	7669	1	applied	\N	\N	\N	\N	87193	87193	255092
8893	7668	0	applied	\N	\N	\N	\N	87194	87194	255093
8902	7680	2	applied	\N	\N	1000000000	\N	87226	87226	255125
8903	7680	2	applied	\N	\N	1000000000	\N	87229	87229	255128
8910	7695	4	applied	\N	\N	\N	\N	87248	87248	255147
8924	7720	1	applied	\N	\N	\N	\N	87285	87285	255184
8931	7731	1	applied	\N	\N	\N	\N	87300	87300	255198
8930	7727	0	failed	Receiver_not_present	\N	\N	\N	87296	87296	\N
8947	7763	4	applied	\N	\N	\N	\N	87348	87348	255245
8950	7764	0	applied	\N	\N	\N	\N	87354	87354	255251
8958	7560	11	applied	\N	\N	\N	\N	87390	87390	255284
8958	7584	28	applied	\N	\N	1000000000	\N	87407	87407	255301
8958	7606	38	applied	\N	\N	\N	\N	87417	87417	255311
8958	7611	41	applied	\N	\N	\N	\N	87420	87420	255314
8958	7605	58	applied	\N	\N	\N	\N	87437	87437	255331
8958	7637	76	applied	\N	\N	\N	\N	87454	87454	255348
8958	7672	93	applied	\N	\N	\N	\N	87471	87471	255365
8958	7709	110	applied	\N	\N	\N	\N	87488	87488	255382
8959	7781	2	applied	\N	\N	\N	\N	87506	87506	255400
8960	7780	1	applied	\N	\N	\N	\N	87510	87510	255404
8969	7802	4	applied	\N	\N	1000000000	\N	87539	87539	255433
8970	7798	0	applied	\N	\N	\N	\N	87540	87540	255434
8975	7555	9	applied	\N	\N	1000000000	\N	87566	87566	255459
8975	7421	24	applied	\N	\N	\N	\N	87580	87580	255473
8975	7434	32	applied	\N	\N	\N	\N	87588	87588	255481
8975	7469	49	applied	\N	\N	\N	\N	87605	87605	255498
8982	7820	1	applied	\N	\N	\N	\N	87632	87632	255525
8986	7826	5	applied	\N	\N	\N	\N	87641	87641	255534
8988	7825	4	applied	\N	\N	\N	\N	87652	87652	255543
8994	7831	1	applied	\N	\N	\N	\N	87678	87678	255565
8996	7834	2	applied	\N	\N	\N	\N	87686	87686	255573
8998	7838	1	applied	\N	\N	\N	\N	87696	87696	255583
9002	7848	1	applied	\N	\N	\N	\N	87710	87710	255597
9011	7856	3	applied	\N	\N	\N	\N	87729	87729	255616
9017	7870	3	applied	\N	\N	\N	\N	87745	87745	255632
9023	7883	3	applied	\N	\N	\N	\N	87761	87761	255648
9031	7891	1	applied	\N	\N	\N	\N	87779	87779	255666
9035	7897	0	applied	\N	\N	\N	\N	87791	87791	255678
9039	7902	1	applied	\N	\N	\N	\N	87800	87800	255687
9048	7918	4	applied	\N	\N	\N	\N	87830	87830	255716
9045	7727	0	failed	Receiver_not_present	\N	\N	\N	87815	87815	\N
9050	7922	8	applied	\N	\N	\N	\N	87860	87860	255746
9056	7934	3	applied	\N	\N	\N	\N	87881	87881	255767
9062	7941	1	applied	\N	\N	\N	\N	87899	87899	255785
9063	7944	0	applied	\N	\N	1000000000	\N	87902	87902	255788
9070	7959	3	applied	\N	\N	\N	\N	87922	87922	255808
9077	7986	7	applied	\N	\N	\N	\N	87956	87956	255842
9078	7987	0	applied	\N	\N	\N	\N	87957	87957	255843
9086	7930	26	applied	\N	\N	\N	\N	88003	88003	255889
9089	8007	8	applied	\N	\N	1000000000	\N	88026	88026	255912
9090	8004	5	applied	\N	\N	\N	\N	88034	88034	255920
9091	8002	3	applied	\N	\N	\N	\N	88043	88043	255929
9099	8013	1	applied	\N	\N	\N	\N	88072	88072	255958
9103	8018	1	applied	\N	\N	\N	\N	88081	88081	255967
9105	8020	1	applied	\N	\N	\N	\N	88085	88085	255971
9109	8024	1	applied	\N	\N	\N	\N	88093	88093	255979
9114	8034	3	applied	\N	\N	\N	\N	88109	88109	255995
9124	8041	0	applied	\N	\N	\N	\N	88132	88132	256018
9124	8044	3	applied	\N	\N	\N	\N	88135	88135	256021
9128	7802	10	applied	\N	\N	1000000000	\N	88154	88154	256040
9129	8047	0	applied	\N	\N	\N	\N	88162	88162	256047
9136	8058	1	applied	\N	\N	\N	\N	88178	88178	256063
9142	8070	3	applied	\N	\N	\N	\N	88192	88192	256077
9143	8071	4	applied	\N	\N	\N	\N	88198	88198	256083
9144	8076	4	applied	\N	\N	\N	\N	88203	88203	256088
9159	8098	1	applied	\N	\N	\N	\N	88247	88247	256132
9167	8115	0	applied	\N	\N	\N	\N	88272	88272	256157
9174	8131	5	applied	\N	\N	\N	\N	88293	88293	256178
9176	8132	0	applied	\N	\N	\N	\N	88296	88296	256181
9181	8136	2	applied	\N	\N	\N	\N	88316	88316	256201
9181	8137	3	applied	\N	\N	\N	\N	88317	88317	256202
9189	8158	3	applied	\N	\N	\N	\N	88346	88346	256231
9190	8158	3	applied	\N	\N	\N	\N	88350	88350	256235
9191	8156	1	applied	\N	\N	\N	\N	88352	88352	256237
9197	7748	11	applied	\N	\N	\N	\N	88388	88388	256271
9197	7770	28	applied	\N	\N	\N	\N	88405	88405	256288
9197	7805	45	applied	\N	\N	\N	\N	88422	88422	256305
9197	7841	61	applied	\N	\N	\N	\N	88438	88438	256321
9197	7873	79	applied	\N	\N	\N	\N	88455	88455	256338
9197	7912	96	applied	\N	\N	\N	\N	88472	88472	256355
9197	7950	113	applied	\N	\N	\N	\N	88489	88489	256372
9199	8175	0	applied	\N	\N	\N	\N	88503	88503	256386
9203	8181	0	applied	\N	\N	\N	\N	88511	88511	256394
9206	8191	6	applied	\N	\N	\N	\N	88529	88529	256412
9210	8202	1	applied	\N	\N	\N	\N	88540	88540	256423
9218	8217	3	applied	\N	\N	\N	\N	88579	88579	256462
9223	8221	1	applied	\N	\N	\N	\N	88591	88591	256474
9227	8203	0	applied	\N	\N	1000000000	\N	88599	88599	256482
9242	8248	2	applied	\N	\N	\N	\N	88634	88634	256517
9246	8258	9	applied	\N	\N	\N	\N	88653	88653	256536
9247	8266	7	applied	\N	\N	\N	\N	88661	88661	256544
9248	8283	4	applied	\N	\N	\N	\N	88678	88678	256561
9249	8300	13	applied	\N	\N	\N	\N	88695	88695	256578
9250	8317	15	applied	\N	\N	\N	\N	88712	88712	256595
9251	8310	8	applied	\N	\N	\N	\N	88729	88729	256612
9251	8311	9	applied	\N	\N	\N	\N	88730	88730	256613
9251	8314	12	applied	\N	\N	\N	\N	88733	88733	256616
9252	8116	4	applied	\N	\N	\N	\N	88750	88750	256633
9252	8160	38	applied	\N	\N	\N	\N	88784	88784	256667
9252	8201	56	applied	\N	\N	\N	\N	88801	88801	256684
9252	8143	73	applied	\N	\N	\N	\N	88818	88818	256701
9252	8185	90	applied	\N	\N	\N	\N	88835	88835	256718
8845	7605	0	applied	\N	\N	\N	\N	87074	87074	254973
9252	8291	125	applied	\N	\N	\N	\N	88870	88870	256753
9253	8319	17	applied	\N	\N	\N	\N	88887	88887	256770
9255	8329	0	applied	\N	\N	\N	\N	88902	88902	256785
9255	8330	1	applied	\N	\N	\N	\N	88903	88903	256786
9259	8339	3	applied	\N	\N	\N	\N	88936	88936	256819
9260	8347	3	applied	\N	\N	\N	\N	88944	88944	256827
9262	8356	4	applied	\N	\N	\N	\N	88961	88961	256844
9263	8373	13	applied	\N	\N	\N	\N	88978	88978	256861
9264	8372	12	applied	\N	\N	\N	\N	88992	88992	256875
9269	8388	4	applied	\N	\N	\N	\N	89009	89009	256892
9279	8407	1	applied	\N	\N	\N	\N	89039	89039	256922
9280	8406	0	applied	\N	\N	\N	\N	89040	89040	256923
9290	8420	1	applied	\N	\N	\N	\N	89061	89061	256944
9291	8248	17	applied	\N	\N	\N	\N	89078	89078	256961
9291	8267	34	applied	\N	\N	\N	\N	89095	89095	256978
9291	8278	45	applied	\N	\N	\N	\N	89106	89106	256989
9291	8281	46	applied	\N	\N	\N	\N	89107	89107	256990
9291	8302	63	applied	\N	\N	\N	\N	89124	89124	257007
9291	8325	80	applied	\N	\N	\N	\N	89141	89141	257024
9291	7930	97	applied	\N	\N	\N	\N	89158	89158	257041
9291	7966	113	applied	\N	\N	\N	\N	89174	89174	257057
9295	8429	1	applied	\N	\N	\N	\N	89197	89197	257080
9303	8445	1	applied	\N	\N	\N	\N	89217	89217	257100
9304	8448	2	applied	\N	\N	\N	\N	89220	89220	257103
9307	8457	3	applied	\N	\N	1000000000	\N	89241	89241	257124
9311	8462	0	applied	\N	\N	\N	\N	89253	89253	257135
9319	8468	1	applied	\N	\N	\N	\N	89276	89276	257153
9324	8480	1	applied	\N	\N	\N	\N	89291	89291	257168
9326	8485	4	applied	\N	\N	\N	\N	89297	89297	257174
9336	8503	1	applied	\N	\N	\N	\N	89327	89327	257204
9342	8514	0	applied	\N	\N	\N	\N	89341	89341	257218
9347	8519	1	applied	\N	\N	\N	\N	89352	89352	257229
9348	8518	0	applied	\N	\N	\N	\N	89353	89353	257230
9358	8534	0	applied	\N	\N	\N	\N	89375	89375	257251
9375	8552	1	applied	\N	\N	\N	\N	89404	89404	257280
9376	8552	1	applied	\N	\N	\N	\N	89407	89407	257283
9382	8560	0	applied	\N	\N	\N	\N	89425	89425	257301
9384	8308	16	applied	\N	\N	\N	\N	89444	89444	257319
9384	8331	33	applied	\N	\N	\N	\N	89461	89461	257336
9384	8247	51	applied	\N	\N	\N	\N	89478	89478	257353
9384	8345	59	applied	\N	\N	\N	\N	89486	89486	257361
9384	8370	76	applied	\N	\N	\N	\N	89503	89503	257378
9384	8414	93	applied	\N	\N	\N	\N	89520	89520	257395
9384	8240	110	applied	\N	\N	\N	\N	89537	89537	257412
9384	8261	117	applied	\N	\N	\N	\N	89544	89544	257419
9388	8564	0	applied	\N	\N	\N	\N	89559	89559	257434
9391	8576	3	applied	\N	\N	\N	\N	89571	89571	257446
9400	8595	1	applied	\N	\N	\N	\N	89602	89602	257477
9403	8599	1	applied	\N	\N	\N	\N	89614	89614	257489
9413	8624	0	applied	\N	\N	\N	\N	89647	89647	257522
9416	8632	0	applied	\N	\N	\N	\N	89655	89655	257530
9418	8634	2	applied	\N	\N	\N	\N	89665	89665	257540
9438	8547	3	applied	\N	\N	1000000000	\N	89705	89705	257579
9438	8250	24	applied	\N	\N	\N	\N	89725	89725	257599
9452	8675	0	applied	\N	\N	\N	\N	89762	89762	257636
9453	8679	4	applied	\N	\N	\N	\N	89771	89771	257645
9462	8686	0	applied	\N	\N	\N	\N	89786	89786	257660
9466	8693	3	applied	\N	\N	\N	\N	89797	89797	257671
9468	8683	6	applied	\N	\N	\N	\N	89806	89806	257680
9468	8691	23	applied	\N	\N	\N	\N	89823	89823	257697
9470	8705	2	applied	\N	\N	\N	\N	89836	89836	257710
9473	8488	11	applied	\N	\N	\N	\N	89853	89853	257726
9473	8049	28	applied	\N	\N	\N	\N	89870	89870	257743
9473	8034	45	applied	\N	\N	\N	\N	89887	89887	257760
9473	8084	62	applied	\N	\N	\N	\N	89904	89904	257777
9473	8090	65	applied	\N	\N	\N	\N	89907	89907	257780
9473	8092	66	applied	\N	\N	\N	\N	89908	89908	257781
9473	8119	84	applied	\N	\N	\N	\N	89925	89925	257798
9473	8158	101	applied	\N	\N	\N	\N	89942	89942	257815
9473	8201	118	applied	\N	\N	\N	\N	89959	89959	257832
9483	8721	1	applied	\N	\N	\N	\N	89991	89991	257864
9484	8727	5	applied	\N	\N	\N	\N	89997	89997	257870
9485	8725	3	applied	\N	\N	\N	\N	90002	90002	257875
9492	8739	0	applied	\N	\N	\N	\N	90018	90018	257891
9502	8757	2	applied	\N	\N	\N	\N	90049	90049	257922
9503	8755	0	applied	\N	\N	\N	\N	90050	90050	257923
9515	8767	0	applied	\N	\N	\N	\N	90081	90081	257954
9517	8770	1	applied	\N	\N	\N	\N	90086	90086	257959
9522	8777	4	applied	\N	\N	\N	\N	90107	90107	257980
9530	8791	0	applied	\N	\N	\N	\N	90137	90137	258010
9531	8800	4	applied	\N	\N	\N	\N	90146	90146	258019
9536	8805	2	applied	\N	\N	\N	\N	90160	90160	258033
9542	8811	0	applied	\N	\N	\N	\N	90179	90179	258052
9542	8814	3	applied	\N	\N	\N	\N	90182	90182	258055
9547	8822	1	applied	\N	\N	\N	\N	90192	90192	258065
9550	8827	0	applied	\N	\N	\N	\N	90199	90199	258072
9571	8862	2	applied	\N	\N	\N	\N	90256	90256	258129
9574	8866	1	applied	\N	\N	\N	\N	90262	90262	258135
9575	8867	0	applied	\N	\N	\N	\N	90263	90263	258136
9586	8885	1	applied	\N	\N	\N	\N	90291	90291	258162
9600	8902	0	applied	\N	\N	\N	\N	90325	90325	258196
9601	8903	1	applied	\N	\N	\N	\N	90329	90329	258200
9603	8908	1	applied	\N	\N	\N	\N	90334	90334	258205
9604	8912	3	applied	\N	\N	\N	\N	90338	90338	258209
9608	8921	2	applied	\N	\N	\N	\N	90357	90357	258224
9609	8923	0	applied	\N	\N	\N	\N	90359	90359	258226
9611	8928	0	applied	\N	\N	\N	\N	90369	90369	258230
9620	8935	2	applied	\N	\N	\N	\N	90395	90395	258256
9622	8943	1	applied	\N	\N	\N	\N	90412	90412	258273
9623	8948	0	applied	\N	\N	\N	\N	90417	90417	258278
9625	8958	0	applied	\N	\N	\N	\N	90427	90427	258287
9626	8985	25	applied	\N	\N	\N	\N	90454	90454	258314
9630	8998	5	applied	\N	\N	\N	\N	90476	90476	258336
9634	9005	1	applied	\N	\N	\N	\N	90484	90484	258344
9642	9018	0	applied	\N	\N	\N	\N	90513	90513	258373
9650	9030	1	applied	\N	\N	\N	\N	90530	90530	258390
9657	9042	0	applied	\N	\N	\N	\N	90546	90546	258406
9666	9059	0	applied	\N	\N	\N	\N	90573	90573	258433
9667	9059	0	applied	\N	\N	\N	\N	90575	90575	258435
9675	9071	1	applied	\N	\N	\N	\N	90601	90601	258461
9252	8268	108	applied	\N	\N	\N	\N	88853	88853	256736
9684	9083	1	applied	\N	\N	\N	\N	90638	90638	258498
9690	9099	3	applied	\N	\N	\N	\N	90658	90658	258518
9696	9108	3	applied	\N	\N	\N	\N	90686	90686	258546
9696	9101	20	applied	\N	\N	\N	\N	90703	90703	258563
9699	9112	2	applied	\N	\N	\N	\N	90716	90716	258576
9702	9124	3	applied	\N	\N	\N	\N	90736	90736	258596
9705	9128	3	applied	\N	\N	\N	\N	90750	90750	258610
9710	9132	0	applied	\N	\N	\N	\N	90763	90763	258623
9715	9108	2	applied	\N	\N	\N	\N	90776	90776	258635
9715	8898	19	applied	\N	\N	\N	\N	90793	90793	258652
9715	9012	31	applied	\N	\N	\N	\N	90805	90805	258664
9715	8877	48	applied	\N	\N	\N	\N	90822	90822	258680
9715	8912	65	applied	\N	\N	\N	\N	90839	90839	258697
9715	8955	82	applied	\N	\N	\N	\N	90856	90856	258714
9715	9001	89	applied	\N	\N	\N	\N	90863	90863	258721
9715	9021	97	applied	\N	\N	\N	\N	90871	90871	258729
9715	9064	114	applied	\N	\N	\N	\N	90888	90888	258746
9720	9137	0	applied	\N	\N	\N	\N	90920	90920	258773
9723	8775	19	applied	\N	\N	\N	\N	90953	90953	258806
9723	9124	36	applied	\N	\N	\N	\N	90970	90970	258823
9724	9154	6	applied	\N	\N	1000000000	\N	90982	90982	258834
9725	9154	6	applied	\N	\N	1000000000	\N	90991	90991	258843
9727	9164	7	applied	\N	\N	\N	\N	91010	91010	258862
9728	9162	5	applied	\N	\N	\N	\N	91021	91021	258873
9729	9168	11	applied	\N	\N	\N	\N	91040	91040	258892
9729	9169	12	applied	\N	\N	\N	\N	91041	91041	258893
9733	9173	1	applied	\N	\N	\N	\N	91049	91049	258901
9735	9181	9	applied	\N	\N	\N	\N	91083	91083	258935
9737	9192	4	applied	\N	\N	\N	\N	91094	91094	258946
9738	9193	5	applied	\N	\N	\N	\N	91102	91102	258954
9741	9198	3	applied	\N	\N	\N	\N	91118	91118	258970
9748	9213	1	applied	\N	\N	\N	\N	91145	91145	258997
9756	9227	1	applied	\N	\N	\N	\N	91165	91165	259017
9757	9231	1	applied	\N	\N	\N	\N	91169	91169	259021
9759	9230	0	applied	\N	\N	\N	\N	91172	91172	259024
9762	9237	0	applied	\N	\N	\N	\N	91179	91179	259031
9765	9257	10	applied	\N	\N	\N	\N	91202	91202	91202
9766	9253	6	applied	\N	\N	\N	\N	91209	91209	91209
9773	9262	0	applied	\N	\N	\N	\N	91253	91253	259080
9781	9276	0	applied	\N	\N	1000000000	\N	91276	91276	259103
9782	9279	0	applied	\N	\N	\N	\N	91279	91279	259106
9788	9293	1	applied	\N	\N	\N	\N	91304	91304	259131
9795	9325	1	applied	\N	\N	\N	\N	91338	91338	259165
9797	9328	2	applied	\N	\N	1000000000	\N	91344	91344	259171
9804	9342	1	applied	\N	\N	\N	\N	91366	91366	259191
9808	9347	1	applied	\N	\N	\N	\N	91377	91377	259202
9811	9350	0	applied	\N	\N	\N	\N	91393	91393	259218
9812	9364	5	applied	\N	\N	\N	\N	91407	91407	259232
9815	9361	2	applied	\N	\N	\N	\N	91422	91422	259247
9818	9368	1	applied	\N	\N	\N	\N	91441	91441	259266
9819	9373	6	applied	\N	\N	\N	\N	91458	91458	259283
9820	9378	11	applied	\N	\N	\N	\N	91475	91475	259300
9821	9384	5	applied	\N	\N	\N	\N	91481	91481	259306
9823	9382	3	applied	\N	\N	\N	\N	91498	91498	259323
9824	9332	15	applied	\N	\N	\N	\N	91532	91532	259356
9824	9179	32	applied	\N	\N	\N	\N	91549	91549	259373
9824	9114	49	applied	\N	\N	\N	\N	91566	91566	259390
9824	9328	65	applied	\N	\N	1000000000	\N	91582	91582	259406
9824	9194	77	applied	\N	\N	\N	\N	91594	91594	259417
9824	9254	80	applied	\N	\N	\N	\N	91597	91597	91597
9824	9388	97	applied	\N	\N	\N	\N	91614	91614	259435
9824	9271	115	applied	\N	\N	\N	\N	91631	91631	259450
9826	9391	15	applied	\N	\N	\N	\N	91648	91648	259467
9827	9422	6	applied	\N	\N	\N	\N	91665	91665	259484
9828	9416	0	applied	\N	\N	\N	\N	91667	91667	259486
9829	9404	5	applied	\N	\N	\N	\N	91673	91673	259491
9829	9237	19	applied	\N	\N	\N	\N	91687	91687	259505
9829	9200	36	applied	\N	\N	\N	\N	91704	91704	259522
9829	9302	47	applied	\N	\N	\N	\N	91715	91715	259533
9830	9419	2	applied	\N	\N	\N	\N	91745	91745	259560
9834	9442	7	applied	\N	\N	\N	\N	91771	91771	259586
9840	9455	1	applied	\N	\N	\N	\N	91788	91788	259603
9844	9457	1	applied	\N	\N	\N	\N	91796	91796	259611
9851	9469	0	applied	\N	\N	\N	\N	91814	91814	259629
9859	9496	3	applied	\N	\N	\N	\N	91844	91844	259659
9861	9499	0	applied	\N	\N	\N	\N	91847	91847	259662
9863	9500	1	applied	\N	\N	\N	\N	91852	91852	259667
9874	9511	1	applied	\N	\N	\N	\N	91878	91878	259693
9885	9522	1	applied	\N	\N	\N	\N	91895	91895	259710
9894	9525	0	applied	\N	\N	\N	\N	91912	91912	259727
9894	9529	3	applied	\N	\N	\N	\N	91915	91915	259730
9900	9539	1	applied	\N	\N	\N	\N	91930	91930	259745
9909	9555	5	applied	\N	\N	\N	\N	91950	91950	259765
9916	9572	1	applied	\N	\N	\N	\N	91971	91971	259786
9924	9590	1	applied	\N	\N	\N	\N	91994	91994	259809
9927	9592	1	applied	\N	\N	\N	\N	92003	92003	259818
9934	9603	2	applied	\N	\N	\N	\N	92020	92020	259835
9939	9614	0	applied	\N	\N	\N	\N	92040	92040	259855
9947	9631	2	applied	\N	\N	\N	\N	92063	92063	259878
9947	9634	5	applied	\N	\N	\N	\N	92066	92066	259881
9956	9646	4	applied	\N	\N	\N	\N	92091	92091	259906
9964	9642	3	applied	\N	\N	\N	\N	92096	92096	259911
9967	9649	1	applied	\N	\N	\N	\N	92121	92121	259936
9969	9479	16	applied	\N	\N	\N	\N	92151	92151	259965
9969	9349	41	applied	\N	\N	\N	\N	92176	92176	259990
9969	9390	58	applied	\N	\N	\N	\N	92193	92193	260007
9970	9656	1	applied	\N	\N	\N	\N	92197	92197	260011
9971	9655	0	applied	\N	\N	\N	\N	92200	92200	260014
9976	9660	6	applied	\N	\N	\N	\N	92221	92221	260035
9981	9670	2	applied	\N	\N	\N	\N	92239	92239	260053
9985	9657	6	applied	\N	\N	\N	\N	92266	92266	260080
9985	9673	23	applied	\N	\N	\N	\N	92283	92283	260097
9987	9684	4	applied	\N	\N	\N	\N	92298	92298	260112
9988	9680	0	applied	\N	\N	\N	\N	92300	92300	260114
9996	9676	18	applied	\N	\N	\N	\N	92346	92346	260160
9996	9697	32	applied	\N	\N	\N	\N	92360	92360	260174
9998	9593	11	applied	\N	\N	\N	\N	92374	92374	260187
9998	9404	14	applied	\N	\N	\N	\N	92377	92377	260190
9998	9111	25	applied	\N	\N	\N	\N	92387	92387	260200
9998	9655	42	applied	\N	\N	\N	\N	92404	92404	260217
9679	9076	1	applied	\N	\N	\N	\N	90619	90619	258479
9998	9172	88	applied	\N	\N	\N	\N	92450	92450	260263
9998	9198	105	applied	\N	\N	\N	\N	92467	92467	260280
9998	9302	122	applied	\N	\N	\N	\N	92484	92484	260297
10000	9700	0	applied	\N	\N	\N	\N	92490	92490	260303
10006	9717	12	applied	\N	\N	\N	\N	92516	92516	260329
10007	9714	9	applied	\N	\N	\N	\N	92529	92529	260342
10015	9740	2	applied	\N	\N	\N	\N	92562	92562	260375
10019	9699	9	applied	\N	\N	\N	\N	92583	92583	260396
10019	9744	26	applied	\N	\N	\N	\N	92600	92600	260413
10019	9734	43	applied	\N	\N	\N	\N	92617	92617	260430
10022	9761	7	applied	\N	\N	\N	\N	92642	92642	260455
10022	9765	11	applied	\N	\N	\N	\N	92646	92646	260459
10026	9775	1	applied	\N	\N	\N	\N	92668	92668	260481
10028	9784	3	applied	\N	\N	\N	\N	92677	92677	260490
10029	9787	2	applied	\N	\N	\N	\N	92680	92680	260493
10030	9789	0	applied	\N	\N	\N	\N	92682	92682	260495
10031	9683	12	applied	\N	\N	\N	\N	92696	92696	260509
10038	9804	1	applied	\N	\N	\N	\N	92732	92732	260545
10045	9402	4	applied	\N	\N	\N	\N	92756	92756	260569
10045	9479	12	applied	\N	\N	\N	\N	92764	92764	260577
10045	9489	29	applied	\N	\N	\N	\N	92781	92781	260594
10045	9799	46	applied	\N	\N	\N	\N	92798	92798	260611
10052	9816	0	applied	\N	\N	\N	\N	92824	92824	260637
10054	9818	0	applied	\N	\N	\N	\N	92827	92827	260640
10058	9827	1	applied	\N	\N	\N	\N	92839	92839	260652
10060	9837	10	applied	\N	\N	1000000000	\N	92851	92851	260664
10061	9836	9	applied	\N	\N	1000000000	\N	92864	92864	260677
10067	9855	1	applied	\N	\N	\N	\N	92899	92899	260712
10068	9858	2	applied	\N	\N	\N	\N	92917	92917	260730
10069	9856	1	applied	\N	\N	\N	\N	92919	92919	260732
10071	9860	1	applied	\N	\N	\N	\N	92932	92932	260745
10073	9888	8	applied	\N	\N	\N	\N	92960	92960	260773
10076	9894	3	applied	\N	\N	\N	\N	92971	92971	260784
10077	9900	0	applied	\N	\N	\N	\N	92975	92975	260788
10078	9905	2	applied	\N	\N	\N	\N	92982	92982	260795
10083	9919	1	applied	\N	\N	\N	\N	93007	93007	260820
10084	9930	10	applied	\N	\N	\N	\N	93018	93018	260831
10085	9926	6	applied	\N	\N	\N	\N	93040	93040	260853
10086	9962	16	applied	\N	\N	\N	\N	93076	93076	260889
10087	9947	1	applied	\N	\N	\N	\N	93083	93083	260896
10087	9956	10	applied	\N	\N	\N	\N	93092	93092	260905
10087	9957	11	applied	\N	\N	\N	\N	93093	93093	260906
10088	9957	11	applied	\N	\N	\N	\N	93115	93115	260928
10089	9974	6	applied	\N	\N	\N	\N	93132	93132	260945
10090	9656	4	applied	\N	\N	\N	\N	93142	93142	260955
10090	9864	21	applied	\N	\N	\N	\N	93159	93159	260972
10090	9933	38	applied	\N	\N	\N	\N	93176	93176	260989
10090	9955	55	applied	\N	\N	\N	\N	93193	93193	261006
10090	9674	72	applied	\N	\N	\N	\N	93210	93210	261023
10090	9705	84	applied	\N	\N	\N	\N	93222	93222	261035
10090	9755	102	applied	\N	\N	\N	\N	93239	93239	261052
10091	9985	5	applied	\N	\N	\N	\N	93256	93256	261069
10092	10006	15	applied	\N	\N	\N	\N	93277	93277	261090
10093	9995	3	applied	\N	\N	\N	\N	93287	93287	261100
10094	9999	8	applied	\N	\N	\N	\N	93312	93312	261125
10095	9995	3	applied	\N	\N	\N	\N	93329	93329	261142
10099	10025	5	applied	\N	\N	\N	\N	93363	93363	261176
10110	10044	1	applied	\N	\N	\N	\N	93389	93389	261202
10112	10041	11	applied	\N	\N	\N	\N	93413	93413	261226
10112	9846	22	applied	\N	\N	\N	\N	93424	93424	261237
10112	9811	24	applied	\N	\N	\N	\N	93426	93426	261239
10112	9936	41	applied	\N	\N	\N	\N	93443	93443	261256
10112	9958	58	applied	\N	\N	\N	\N	93460	93460	261273
10112	9845	75	applied	\N	\N	\N	\N	93477	93477	261290
10112	9837	90	applied	\N	\N	1000000000	\N	93492	93492	261305
10112	9911	111	applied	\N	\N	\N	\N	93513	93513	261326
10113	10050	0	applied	\N	\N	\N	\N	93527	93527	261340
10114	10053	3	applied	\N	\N	\N	\N	93541	93541	261354
10116	10071	5	applied	\N	\N	\N	\N	93559	93559	261372
10116	10072	6	applied	\N	\N	\N	\N	93560	93560	261373
10117	10076	0	applied	\N	\N	\N	\N	93564	93564	261377
10121	10085	3	applied	\N	\N	\N	\N	93579	93579	261392
10122	10090	8	applied	\N	\N	\N	\N	93597	93597	261410
10123	10056	17	applied	\N	\N	\N	\N	93619	93619	261432
10123	9961	34	applied	\N	\N	\N	\N	93636	93636	261449
10123	9969	35	applied	\N	\N	\N	\N	93637	93637	261450
10123	10027	47	applied	\N	\N	\N	\N	93649	93649	261462
10123	10044	64	applied	\N	\N	\N	\N	93666	93666	261479
10123	9965	79	applied	\N	\N	\N	\N	93681	93681	261494
10123	9984	91	applied	\N	\N	\N	\N	93693	93693	261506
10123	10007	108	applied	\N	\N	\N	\N	93710	93710	261523
10126	10098	0	applied	\N	\N	\N	\N	93731	93731	261544
10136	10116	2	applied	\N	\N	\N	\N	93760	93760	261573
10137	9993	2	applied	\N	\N	\N	\N	93764	93764	261577
10137	10066	4	applied	\N	\N	\N	\N	93766	93766	261579
10137	9842	21	applied	\N	\N	\N	\N	93783	93783	261596
10137	9848	39	applied	\N	\N	\N	\N	93800	93800	261613
10137	9927	48	applied	\N	\N	\N	\N	93809	93809	261622
10137	9854	79	applied	\N	\N	\N	\N	93840	93840	261653
10137	9328	95	applied	\N	\N	1000000000	\N	93856	93856	261669
10137	9979	115	applied	\N	\N	\N	\N	93876	93876	261689
10140	9576	8	applied	\N	\N	\N	\N	93905	93905	261717
10140	9403	13	applied	\N	\N	\N	\N	93910	93910	261722
10143	10123	2	applied	\N	\N	\N	\N	93923	93923	261735
10152	10131	0	applied	\N	\N	\N	\N	93943	93943	261755
10155	10138	3	applied	\N	\N	\N	\N	93952	93952	261764
10156	10135	0	applied	\N	\N	\N	\N	93953	93953	261765
10163	10153	10	applied	\N	\N	\N	\N	93979	93979	261791
10165	10156	1	applied	\N	\N	\N	\N	93994	93994	261806
10173	10170	10	applied	\N	\N	\N	\N	94018	94018	261830
10174	10178	1	applied	\N	\N	\N	\N	94026	94026	261838
10182	10182	1	applied	\N	\N	\N	\N	94048	94048	261860
10188	10188	1	applied	\N	\N	\N	\N	94065	94065	261877
10191	10193	1	applied	\N	\N	\N	\N	94080	94080	261892
10193	10199	0	applied	\N	\N	\N	\N	94093	94093	261905
10209	10218	1	applied	\N	\N	\N	\N	94132	94132	261944
10212	10220	0	applied	\N	\N	\N	\N	94137	94137	261949
10218	10228	0	applied	\N	\N	\N	\N	94159	94159	261971
10223	10153	11	applied	\N	\N	\N	\N	94180	94180	261992
10223	9242	29	applied	\N	\N	\N	\N	94197	94197	262009
9998	9127	71	applied	\N	\N	\N	\N	92433	92433	260246
10225	10238	5	applied	\N	\N	\N	\N	94240	94240	262052
10230	9993	4	applied	\N	\N	\N	\N	94254	94254	262065
10230	9075	41	applied	\N	\N	\N	\N	94290	94290	262101
10230	9361	58	applied	\N	\N	\N	\N	94307	94307	262118
10230	9138	75	applied	\N	\N	\N	\N	94324	94324	262135
10233	10253	0	applied	\N	\N	1000000000	\N	94334	94334	262145
10239	10258	0	applied	\N	\N	\N	\N	94359	94359	262170
10242	10260	0	applied	\N	\N	\N	\N	94363	94363	262174
10247	10265	1	applied	\N	\N	\N	\N	94372	94372	262183
10250	10066	5	applied	\N	\N	\N	\N	94386	94386	262197
10250	10025	22	applied	\N	\N	\N	\N	94403	94403	262214
10253	10285	4	applied	\N	\N	\N	\N	94420	94420	262231
10259	10306	3	applied	\N	\N	\N	\N	94448	94448	262259
10262	10308	0	applied	\N	\N	\N	\N	94459	94459	262270
10266	10315	1	applied	\N	\N	\N	\N	94478	94478	262289
10269	10325	1	applied	\N	\N	\N	\N	94490	94490	262301
10275	10340	3	applied	\N	\N	\N	\N	94505	94505	262316
10277	10349	5	applied	\N	\N	\N	\N	94521	94521	262332
10280	10345	0	applied	\N	\N	\N	\N	94538	94538	262349
10282	10362	8	applied	\N	\N	\N	\N	94555	94555	262366
10288	10368	0	applied	\N	\N	\N	\N	94574	94574	262385
10288	10369	1	applied	\N	\N	\N	\N	94575	94575	262386
10289	10368	0	applied	\N	\N	\N	\N	94578	94578	262389
10291	10374	2	applied	\N	\N	\N	\N	94586	94586	262397
10296	10383	0	applied	\N	\N	\N	\N	94605	94605	262416
10299	10389	4	applied	\N	\N	\N	\N	94615	94615	262426
10301	10392	0	applied	\N	\N	\N	\N	94621	94621	262432
10305	10403	2	applied	\N	\N	\N	\N	94632	94632	262443
10312	10414	1	applied	\N	\N	\N	\N	94665	94665	262475
10315	10420	4	applied	\N	\N	\N	\N	94677	94677	262484
10318	10433	6	applied	\N	\N	\N	\N	94699	94699	262506
10323	10440	1	applied	\N	\N	\N	\N	94718	94718	262525
10328	10454	1	applied	\N	\N	\N	\N	94736	94736	262543
10332	10465	0	applied	\N	\N	\N	\N	94752	94752	262559
10336	10481	0	applied	\N	\N	\N	\N	94771	94771	262578
10338	10484	1	applied	\N	\N	\N	\N	94776	94776	262583
10351	10502	2	applied	\N	\N	\N	\N	94816	94816	262623
10353	10506	1	applied	\N	\N	\N	\N	94823	94823	262630
10370	10521	1	applied	\N	\N	\N	\N	94860	94860	262667
10371	10520	0	applied	\N	\N	\N	\N	94861	94861	262668
10378	10540	4	applied	\N	\N	\N	\N	94887	94887	262694
10385	10551	0	applied	\N	\N	\N	\N	94910	94910	262717
10387	10536	1	applied	\N	\N	\N	\N	94915	94915	262722
10387	10372	19	applied	\N	\N	\N	\N	94932	94932	262739
10387	10261	36	applied	\N	\N	\N	\N	94949	94949	262756
10387	10264	37	applied	\N	\N	\N	\N	94950	94950	262757
10387	10292	38	applied	\N	\N	\N	\N	94951	94951	262758
10387	10359	55	applied	\N	\N	\N	\N	94968	94968	262775
10387	10279	72	applied	\N	\N	\N	\N	94985	94985	262792
10387	10324	89	applied	\N	\N	\N	\N	95002	95002	262809
10387	10373	106	applied	\N	\N	\N	\N	95019	95019	262826
10387	10417	123	applied	\N	\N	\N	\N	95036	95036	262843
10403	10573	1	applied	\N	\N	\N	\N	95075	95075	262882
10409	10591	3	applied	\N	\N	\N	\N	95095	95095	262902
10410	10590	2	applied	\N	\N	\N	\N	95099	95099	262906
10413	10595	0	applied	\N	\N	\N	\N	95106	95106	262913
10420	10616	5	applied	\N	\N	\N	\N	95138	95138	262945
10421	10613	2	applied	\N	\N	\N	\N	95147	95147	262954
10424	10623	0	applied	\N	\N	\N	\N	95171	95171	262978
10425	10628	3	applied	\N	\N	\N	\N	95176	95176	262983
10427	10639	8	applied	\N	\N	\N	\N	95187	95187	262994
10428	10640	9	applied	\N	\N	\N	\N	95203	95203	263010
10430	10649	1	applied	\N	\N	\N	\N	95212	95212	263019
10440	10666	2	applied	\N	\N	\N	\N	95243	95243	263050
10441	10670	1	applied	\N	\N	\N	\N	95247	95247	263054
10447	10539	4	applied	\N	\N	\N	\N	95281	95281	263088
10447	10661	40	applied	\N	\N	\N	\N	95317	95317	263124
10447	10410	57	applied	\N	\N	\N	\N	95334	95334	263141
10447	10045	75	applied	\N	\N	\N	\N	95351	95351	263158
10447	10106	80	applied	\N	\N	\N	\N	95356	95356	263163
10447	10151	86	applied	\N	\N	\N	\N	95362	95362	263169
10447	10370	103	applied	\N	\N	\N	\N	95379	95379	263186
10447	10123	120	applied	\N	\N	\N	\N	95396	95396	263203
10448	10688	4	applied	\N	\N	\N	\N	95405	95405	263212
10449	10693	9	applied	\N	\N	1000000000	\N	95423	95423	263230
10450	10692	8	applied	\N	\N	\N	\N	95435	95435	263242
10451	10687	3	applied	\N	\N	\N	\N	95443	95443	263250
10452	10691	7	applied	\N	\N	\N	\N	95460	95460	263267
10453	10694	10	applied	\N	\N	1000000000	\N	95476	95476	263283
10454	10691	7	applied	\N	\N	\N	\N	95486	95486	263293
10455	10693	9	applied	\N	\N	1000000000	\N	95501	95501	263308
10456	10694	10	applied	\N	\N	1000000000	\N	95515	95515	263322
10459	10694	10	applied	\N	\N	1000000000	\N	95539	95539	263346
10460	10701	3	applied	\N	\N	\N	\N	95546	95546	263353
10466	10720	5	applied	\N	\N	\N	\N	95575	95575	263382
10468	10720	5	applied	\N	\N	\N	\N	95593	95593	263400
10470	10741	13	applied	\N	\N	\N	\N	95614	95614	263421
10480	10767	3	applied	\N	\N	\N	\N	95649	95649	263456
10484	10774	4	applied	\N	\N	\N	\N	95677	95677	263484
10484	10775	5	applied	\N	\N	\N	\N	95678	95678	263485
10484	10776	6	applied	\N	\N	\N	\N	95679	95679	263486
10488	10780	1	applied	\N	\N	\N	\N	95689	95689	263496
10492	10785	4	applied	\N	\N	\N	\N	95707	95707	263514
10492	10790	9	applied	\N	\N	\N	\N	95712	95712	263519
10492	10791	10	applied	\N	\N	\N	\N	95713	95713	263520
10493	10793	12	applied	\N	\N	\N	\N	95737	95737	263544
10494	10797	16	applied	\N	\N	\N	\N	95763	95763	263570
10496	10810	6	applied	\N	\N	\N	\N	95776	95776	263583
10496	10811	7	applied	\N	\N	\N	\N	95777	95777	263584
10499	10809	5	applied	\N	\N	\N	\N	95808	95808	263615
10500	10805	1	applied	\N	\N	\N	\N	95815	95815	263622
10505	10830	7	applied	\N	\N	\N	\N	95842	95842	263649
10509	10832	1	applied	\N	\N	\N	\N	95864	95864	263671
10519	10842	0	applied	\N	\N	\N	\N	95893	95893	263700
10525	10852	2	applied	\N	\N	\N	\N	95915	95915	263722
10526	10851	1	applied	\N	\N	\N	\N	95922	95922	263729
10527	10826	3	applied	\N	\N	\N	\N	95932	95932	263739
10527	10838	7	applied	\N	\N	\N	\N	95936	95936	263743
10527	10857	19	applied	\N	\N	\N	\N	95948	95948	263755
10527	10855	36	applied	\N	\N	\N	\N	95965	95965	263772
10223	9324	55	applied	\N	\N	\N	\N	94223	94223	262035
10548	10891	1	applied	\N	\N	\N	\N	96028	96028	263835
10549	10894	4	applied	\N	\N	\N	\N	96036	96036	263843
10551	10872	11	applied	\N	\N	\N	\N	96050	96050	263857
10551	10889	28	applied	\N	\N	\N	\N	96067	96067	263874
10555	10903	3	applied	\N	\N	\N	\N	96100	96100	263907
10558	10721	23	applied	\N	\N	1000000000	\N	96135	96135	263942
10558	10910	44	applied	\N	\N	\N	\N	96156	96156	263963
10558	10645	61	applied	\N	\N	\N	\N	96173	96173	263980
10558	10797	64	applied	\N	\N	\N	\N	96176	96176	263983
10558	10800	67	applied	\N	\N	\N	\N	96179	96179	263986
10558	10458	84	applied	\N	\N	\N	\N	96196	96196	264003
10558	10496	101	applied	\N	\N	\N	\N	96213	96213	264020
10558	10531	118	applied	\N	\N	\N	\N	96230	96230	264037
10566	10923	1	applied	\N	\N	\N	\N	96255	96255	264062
10567	10923	1	applied	\N	\N	\N	\N	96257	96257	264064
10571	10925	1	applied	\N	\N	\N	\N	96265	96265	264072
10581	10946	1	applied	\N	\N	\N	\N	96292	96292	264099
10590	10957	2	applied	\N	\N	\N	\N	96309	96309	264116
10593	10960	1	applied	\N	\N	\N	\N	96320	96320	264127
10595	10961	0	applied	\N	\N	\N	\N	96323	96323	264130
10600	10969	0	applied	\N	\N	\N	\N	96337	96337	264144
10610	10979	0	applied	\N	\N	\N	\N	96357	96357	264164
10618	10558	4	applied	\N	\N	\N	\N	96382	96382	264189
10618	10593	22	applied	\N	\N	\N	\N	96399	96399	264206
10621	10995	3	applied	\N	\N	\N	\N	96422	96422	264229
10622	10998	2	applied	\N	\N	\N	\N	96425	96425	264232
10625	11003	1	applied	\N	\N	\N	\N	96438	96438	264245
10643	10792	2	applied	\N	\N	\N	\N	96484	96484	264291
10643	10869	19	applied	\N	\N	\N	\N	96501	96501	264308
10644	11033	1	applied	\N	\N	\N	\N	96513	96513	264320
10644	11034	2	applied	\N	\N	\N	\N	96514	96514	264321
10645	11036	0	applied	\N	\N	\N	\N	96516	96516	264323
10653	11045	3	applied	\N	\N	\N	\N	96541	96541	264348
10655	11046	0	applied	\N	\N	\N	\N	96542	96542	264349
10663	11058	1	applied	\N	\N	\N	\N	96566	96566	264373
10664	11058	1	applied	\N	\N	\N	\N	96568	96568	264375
10673	11065	1	applied	\N	\N	\N	\N	96607	96607	264414
10680	11079	1	applied	\N	\N	\N	\N	96629	96629	264436
10689	11092	3	applied	\N	\N	\N	\N	96649	96649	264456
10695	11097	1	applied	\N	\N	\N	\N	96658	96658	264465
10696	11103	2	applied	\N	\N	\N	\N	96664	96664	264471
10700	11108	4	applied	\N	\N	\N	\N	96693	96693	264500
10702	11113	1	applied	\N	\N	\N	\N	96706	96706	264513
10705	11119	1	applied	\N	\N	\N	\N	96714	96714	264521
10711	11131	1	applied	\N	\N	\N	\N	96739	96739	264546
10719	11135	1	applied	\N	\N	\N	\N	96755	96755	264562
10722	11138	0	applied	\N	\N	\N	\N	96764	96764	264571
10725	10766	8	applied	\N	\N	\N	\N	96782	96782	264589
10725	10785	32	applied	\N	\N	\N	\N	96805	96805	264612
10725	10795	33	applied	\N	\N	\N	\N	96806	96806	264613
10725	10819	50	applied	\N	\N	\N	\N	96823	96823	264630
10725	10806	67	applied	\N	\N	\N	\N	96840	96840	264647
10725	10846	84	applied	\N	\N	\N	\N	96857	96857	264664
10725	10888	118	applied	\N	\N	\N	\N	96891	96891	264698
10726	11149	3	applied	\N	\N	\N	\N	96902	96902	264709
10730	11155	0	applied	\N	\N	\N	\N	96919	96919	264726
10739	11170	1	applied	\N	\N	\N	\N	96942	96942	264749
10743	11176	1	applied	\N	\N	\N	\N	96953	96953	264760
10749	11184	2	applied	\N	\N	1000000000	\N	96968	96968	264775
10753	11194	2	applied	\N	\N	\N	\N	96984	96984	264791
10759	11207	3	applied	\N	\N	\N	\N	96999	96999	264806
10760	11204	0	applied	\N	\N	\N	\N	97000	97000	264807
10760	11205	1	applied	\N	\N	\N	\N	97001	97001	264808
10761	11205	1	applied	\N	\N	\N	\N	97005	97005	264812
10772	11223	1	applied	\N	\N	\N	\N	97043	97043	264850
10774	11226	0	applied	\N	\N	\N	\N	97050	97050	264857
10775	11233	3	applied	\N	\N	\N	\N	97057	97057	264864
10776	11230	0	applied	\N	\N	\N	\N	97059	97059	264866
10779	11237	1	applied	\N	\N	\N	\N	97069	97069	264876
10784	11146	1	applied	\N	\N	\N	\N	97087	97087	264894
10784	10898	18	applied	\N	\N	\N	\N	97104	97104	264911
10784	10935	35	applied	\N	\N	\N	\N	97121	97121	264928
10784	10970	52	applied	\N	\N	\N	\N	97138	97138	264945
10784	11005	69	applied	\N	\N	\N	\N	97155	97155	264962
10784	11045	86	applied	\N	\N	\N	\N	97172	97172	264979
10784	11085	106	applied	\N	\N	\N	\N	97192	97192	264999
10784	11124	124	applied	\N	\N	\N	\N	97209	97209	265016
10793	11271	3	applied	\N	\N	\N	\N	97247	97247	265054
10794	11268	0	applied	\N	\N	\N	\N	97249	97249	265056
10795	11269	1	applied	\N	\N	\N	\N	97255	97255	265062
10802	11127	2	applied	\N	\N	\N	\N	97278	97278	265085
10802	11132	5	applied	\N	\N	\N	\N	97281	97281	265088
10802	11173	22	applied	\N	\N	\N	\N	97298	97298	265105
10802	11209	39	applied	\N	\N	\N	\N	97315	97315	265122
10802	11253	56	applied	\N	\N	\N	\N	97332	97332	265139
10802	10924	90	applied	\N	\N	\N	\N	97366	97366	265173
10802	10960	107	applied	\N	\N	\N	\N	97383	97383	265190
10802	10991	123	applied	\N	\N	\N	\N	97398	97398	265205
10804	11284	0	applied	\N	\N	\N	\N	97405	97405	265212
10805	11288	0	applied	\N	\N	\N	\N	97409	97409	265216
10809	11229	12	applied	\N	\N	\N	\N	97432	97432	265239
10809	10942	30	applied	\N	\N	\N	\N	97449	97449	265256
10809	10974	47	applied	\N	\N	\N	\N	97466	97466	265273
10809	11009	64	applied	\N	\N	\N	\N	97483	97483	265290
10809	11047	81	applied	\N	\N	\N	\N	97500	97500	265307
10809	11083	98	applied	\N	\N	\N	\N	97517	97517	265324
10809	11117	113	applied	\N	\N	\N	\N	97532	97532	265339
10814	11296	0	applied	\N	\N	\N	\N	97555	97555	265362
10825	11319	0	applied	\N	\N	\N	\N	97589	97589	265394
10818	11308	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	97571	97571	\N
10826	11320	1	applied	\N	\N	1000000000	\N	97593	97593	265398
10836	11345	6	applied	\N	\N	\N	\N	97627	97627	265432
10844	11358	2	applied	\N	\N	\N	\N	97672	97672	265477
10845	11364	0	applied	\N	\N	\N	\N	97676	97676	265481
10847	11374	3	applied	\N	\N	\N	\N	97688	97688	265493
10854	11371	22	applied	\N	\N	\N	\N	97737	97737	265541
10854	11308	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	97716	97716	\N
10854	11286	25	applied	\N	\N	\N	\N	97740	97740	265544
10854	11328	42	applied	\N	\N	\N	\N	97757	97757	265561
10544	10888	0	applied	\N	\N	\N	\N	96014	96014	263821
10854	11069	93	applied	\N	\N	\N	\N	97808	97808	265612
10854	11108	110	applied	\N	\N	\N	\N	97825	97825	265629
10860	11399	1	applied	\N	\N	\N	\N	97841	97841	265645
10861	11401	3	applied	\N	\N	\N	\N	97847	97847	265651
10862	11400	2	applied	\N	\N	\N	\N	97850	97850	265654
10870	11376	5	applied	\N	\N	\N	\N	97881	97881	265685
10870	11402	25	applied	\N	\N	\N	\N	97901	97901	265705
10870	11381	40	applied	\N	\N	\N	\N	97916	97916	265720
10879	11423	5	applied	\N	\N	\N	\N	97945	97945	265749
10883	11422	2	applied	\N	\N	\N	\N	97962	97962	265766
10887	11426	0	applied	\N	\N	\N	\N	97979	97979	265783
10891	11437	4	applied	\N	\N	\N	\N	97996	97996	265800
10895	11432	7	applied	\N	\N	\N	\N	98013	98013	265817
10895	11419	24	applied	\N	\N	\N	\N	98030	98030	265834
10895	11437	29	applied	\N	\N	\N	\N	98035	98035	265839
10895	11434	32	applied	\N	\N	\N	\N	98038	98038	265842
10896	11443	3	applied	\N	\N	\N	\N	98055	98055	265859
10897	11440	0	applied	\N	\N	\N	\N	98059	98059	265863
10897	11443	3	applied	\N	\N	\N	\N	98062	98062	265866
10899	11447	0	applied	\N	\N	\N	\N	98073	98073	265877
10901	11454	4	applied	\N	\N	\N	\N	98080	98080	265884
10906	11475	0	applied	\N	\N	\N	\N	98105	98105	265909
10907	11481	2	applied	\N	\N	\N	\N	98111	98111	265915
10913	11469	5	applied	\N	\N	\N	\N	98130	98130	265934
10913	11446	22	applied	\N	\N	\N	\N	98147	98147	265951
10913	11491	39	applied	\N	\N	\N	\N	98164	98164	265968
10915	11496	4	applied	\N	\N	\N	\N	98190	98190	265994
10915	11498	7	applied	\N	\N	\N	\N	98193	98193	265997
10919	11500	4	applied	\N	\N	\N	\N	98203	98203	266007
10921	11509	1	applied	\N	\N	\N	\N	98209	98209	266013
10931	11518	1	applied	\N	\N	\N	\N	98247	98247	266051
10936	11520	1	applied	\N	\N	\N	\N	98258	98258	266062
10948	11530	0	applied	\N	\N	\N	\N	98282	98282	266086
10950	11531	10	applied	\N	\N	\N	\N	98304	98304	266108
10951	11535	5	applied	\N	\N	\N	\N	98318	98318	266122
10958	11499	5	applied	\N	\N	\N	\N	98341	98341	266145
10958	11532	22	applied	\N	\N	\N	\N	98358	98358	266162
10958	11526	39	applied	\N	\N	\N	\N	98375	98375	266179
10960	11555	5	applied	\N	\N	\N	\N	98395	98395	266199
10961	11556	6	applied	\N	\N	\N	\N	98403	98403	266207
10964	11557	0	applied	\N	\N	\N	\N	98413	98413	266217
10971	11561	0	applied	\N	\N	\N	\N	98427	98427	266231
10972	11563	1	applied	\N	\N	\N	\N	98429	98429	266233
10985	11584	4	applied	\N	\N	\N	\N	98465	98465	266269
10993	11591	1	applied	\N	\N	\N	\N	98488	98488	266292
11009	11606	3	applied	\N	\N	\N	\N	98521	98521	266325
11010	11610	3	applied	\N	\N	\N	\N	98525	98525	266328
11011	11612	5	applied	\N	\N	1000000000	\N	98533	98533	266335
11016	11608	5	applied	\N	\N	\N	\N	98558	98558	266358
11021	11623	2	applied	\N	\N	\N	\N	98578	98578	266378
11027	11634	4	applied	\N	\N	\N	\N	98600	98600	266400
11030	11643	1	applied	\N	\N	\N	\N	98619	98619	266419
11033	11607	4	applied	\N	\N	\N	\N	98628	98628	98628
11033	11567	21	applied	\N	\N	\N	\N	98645	98645	266444
11033	11603	39	applied	\N	\N	\N	\N	98662	98662	266461
11033	11646	56	applied	\N	\N	\N	\N	98679	98679	266478
11033	11555	57	applied	\N	\N	\N	\N	98680	98680	266479
11033	11557	58	applied	\N	\N	\N	\N	98681	98681	266480
11033	11591	74	applied	\N	\N	\N	\N	98697	98697	266496
11033	11630	90	applied	\N	\N	\N	\N	98713	98713	266512
11052	11658	0	applied	\N	\N	\N	\N	98757	98757	266556
11053	11662	0	applied	\N	\N	\N	\N	98761	98761	266560
11055	11628	4	applied	\N	\N	\N	\N	98773	98773	266572
11055	11656	21	applied	\N	\N	\N	\N	98790	98790	266589
11055	11658	38	applied	\N	\N	\N	\N	98807	98807	266606
11057	11664	2	applied	\N	\N	\N	\N	98817	98817	266616
11068	11681	1	applied	\N	\N	\N	\N	98850	98850	266649
11074	11572	13	applied	\N	\N	\N	\N	98875	98875	266673
11074	11581	30	applied	\N	\N	\N	\N	98892	98892	266690
11074	11621	49	applied	\N	\N	\N	\N	98910	98910	266708
11074	11656	65	applied	\N	\N	\N	\N	98926	98926	266724
11074	11585	66	applied	\N	\N	\N	\N	98927	98927	266725
11074	11624	83	applied	\N	\N	\N	\N	98944	98944	266742
11074	11686	100	applied	\N	\N	\N	\N	98961	98961	266759
11074	11663	117	applied	\N	\N	\N	\N	98978	98978	266776
11077	11694	1	applied	\N	\N	\N	\N	98992	98992	266790
11084	11703	1	applied	\N	\N	\N	\N	99010	99010	266808
11086	11706	2	applied	\N	\N	\N	\N	99016	99016	266814
11100	11700	7	applied	\N	\N	\N	\N	99053	99053	266851
11101	11727	5	applied	\N	\N	\N	\N	99061	99061	266859
11104	11725	8	applied	\N	\N	\N	\N	99091	99091	266889
11104	11670	25	applied	\N	\N	\N	\N	99108	99108	266906
11104	11685	31	applied	\N	\N	\N	\N	99114	99114	266912
11104	11707	43	applied	\N	\N	\N	\N	99126	99126	266924
11104	11713	46	applied	\N	\N	\N	\N	99129	99129	266927
11104	11678	64	applied	\N	\N	\N	\N	99146	99146	266944
11106	11732	0	applied	\N	\N	\N	\N	99166	99166	266964
11111	11740	1	applied	\N	\N	1000000000	\N	99180	99180	266978
11111	11742	3	applied	\N	\N	\N	\N	99182	99182	266980
11115	11745	1	applied	\N	\N	\N	\N	99198	99198	266996
11119	11751	3	applied	\N	\N	\N	\N	99212	99212	267010
11125	11683	5	applied	\N	\N	\N	\N	99228	99228	267026
11125	11728	38	applied	\N	\N	\N	\N	99261	99261	267059
11125	11754	55	applied	\N	\N	\N	\N	99278	99278	267076
11125	11747	72	applied	\N	\N	\N	\N	99295	99295	267093
11129	11762	2	applied	\N	\N	\N	\N	99309	99309	267107
11131	11693	3	applied	\N	\N	\N	\N	99318	99318	267116
11131	11636	20	applied	\N	\N	\N	\N	99335	99335	267133
11131	11667	37	applied	\N	\N	\N	\N	99352	99352	267150
11131	11647	61	applied	\N	\N	\N	\N	99376	99376	267174
11131	11662	70	applied	\N	\N	\N	\N	99384	99384	267182
11131	11697	86	applied	\N	\N	\N	\N	99400	99400	267198
11131	11736	102	applied	\N	\N	1000000000	\N	99416	99416	267214
11131	11720	122	applied	\N	\N	\N	\N	99436	99436	267234
11139	11775	1	applied	\N	\N	\N	\N	99463	99463	267261
11140	11776	0	applied	\N	\N	\N	\N	99464	99464	267262
11146	11784	3	applied	\N	\N	\N	\N	99484	99484	267282
11156	11798	1	applied	\N	\N	\N	\N	99506	99506	267304
11176	11813	1	applied	\N	\N	\N	\N	99547	99547	267345
11177	11481	7	applied	\N	\N	\N	\N	99557	99557	267355
10854	11385	76	applied	\N	\N	\N	\N	97791	97791	265595
11177	11495	39	applied	\N	\N	\N	\N	99589	99589	267386
11177	11448	56	applied	\N	\N	\N	\N	99606	99606	267403
11177	11498	73	applied	\N	\N	\N	\N	99623	99623	267420
11177	11540	90	applied	\N	\N	\N	\N	99640	99640	267437
11177	11578	107	applied	\N	\N	\N	\N	99657	99657	267454
11177	11619	125	applied	\N	\N	\N	\N	99674	99674	267471
11178	11816	0	applied	\N	\N	\N	\N	99675	99675	267472
11184	11821	1	applied	\N	\N	\N	\N	99696	99696	267493
11195	11832	1	applied	\N	\N	\N	\N	99722	99722	267519
11198	11837	0	applied	\N	\N	\N	\N	99727	99727	267524
11202	11846	1	applied	\N	\N	1000000000	\N	99738	99738	267535
11203	11846	1	applied	\N	\N	1000000000	\N	99741	99741	267538
11204	11848	0	applied	\N	\N	1000000000	\N	99743	99743	267540
11206	11848	0	applied	\N	\N	1000000000	\N	99755	99755	267552
11206	11851	3	applied	\N	\N	\N	\N	99758	99758	267555
11208	11857	3	applied	\N	\N	\N	\N	99770	99770	267567
11221	11890	1	applied	\N	\N	\N	\N	99811	99811	267608
11223	11893	0	applied	\N	\N	\N	\N	99814	99814	267611
11227	11903	2	applied	\N	\N	\N	\N	99828	99828	267625
11229	11910	4	applied	\N	\N	\N	\N	99840	99840	267637
11233	11915	4	applied	\N	\N	\N	\N	99860	99860	267657
11235	11916	5	applied	\N	\N	\N	\N	99873	99873	267670
11241	11925	3	applied	\N	\N	\N	\N	99888	99888	267685
11249	11942	4	applied	\N	\N	\N	\N	99918	99918	267715
11250	11948	5	applied	\N	\N	\N	\N	99924	99924	267721
11251	11946	3	applied	\N	\N	\N	\N	99937	99937	267734
11253	11970	5	applied	\N	\N	\N	\N	99961	99961	267758
11259	11990	9	applied	\N	\N	\N	\N	99981	99981	267778
11260	11995	14	applied	\N	\N	\N	\N	100010	100010	267807
11261	12007	2	applied	\N	\N	\N	\N	100022	100022	267819
11265	12014	2	applied	\N	\N	\N	\N	100046	100046	267843
11265	12015	3	applied	\N	\N	\N	\N	100047	100047	267844
11266	12049	26	applied	\N	\N	\N	\N	100081	100081	267878
11269	12073	7	applied	\N	\N	\N	\N	100105	100105	267902
11270	12066	0	applied	\N	\N	\N	\N	100106	100106	267903
11276	12081	4	applied	\N	\N	\N	\N	100128	100128	267925
11279	11695	9	applied	\N	\N	\N	\N	100145	100145	267942
11279	11945	26	applied	\N	\N	\N	\N	100162	100162	267959
11279	11731	43	applied	\N	\N	\N	\N	100179	100179	267976
11279	11757	61	applied	\N	\N	\N	\N	100196	100196	267993
11279	11791	78	applied	\N	\N	\N	\N	100213	100213	268010
11281	12087	0	applied	\N	\N	\N	\N	100223	100223	268020
11282	12088	2	applied	\N	\N	\N	\N	100228	100228	268025
11294	12108	3	applied	\N	\N	\N	\N	100258	100258	268055
11296	12109	0	applied	\N	\N	\N	\N	100261	100261	268058
11303	12112	0	applied	\N	\N	\N	\N	100270	100270	268067
11309	12119	0	applied	\N	\N	\N	\N	100280	100280	268077
11320	12129	1	applied	\N	\N	\N	\N	100302	100302	268099
11332	12144	3	applied	\N	\N	\N	\N	100326	100326	268122
11332	12145	4	applied	\N	\N	\N	\N	100327	100327	268123
11342	12158	0	applied	\N	\N	\N	\N	100352	100352	268148
11347	12170	0	applied	\N	\N	\N	\N	100376	100376	268172
11348	12171	1	applied	\N	\N	\N	\N	100381	100381	268177
11353	12176	0	applied	\N	\N	\N	\N	100391	100391	268187
11361	12190	8	applied	\N	\N	\N	\N	100419	100419	268215
11368	12204	2	applied	\N	\N	\N	\N	100439	100439	268235
11374	12217	1	applied	\N	\N	\N	\N	100460	100460	268256
11380	12225	1	applied	\N	\N	\N	\N	100478	100478	268274
11381	12227	1	applied	\N	\N	\N	\N	100480	100480	268276
11399	12240	0	applied	\N	\N	\N	\N	100518	100518	268314
11400	12245	3	applied	\N	\N	\N	\N	100523	100523	268319
11403	12248	0	applied	\N	\N	\N	\N	100530	100530	268326
11406	12252	2	applied	\N	\N	\N	\N	100540	100540	268336
11409	12264	2	applied	\N	\N	1000000000	\N	100552	100552	268348
11422	12274	0	applied	\N	\N	\N	\N	100578	100578	268374
11426	12101	13	applied	\N	\N	\N	\N	100601	100601	268397
11426	12114	23	applied	\N	\N	\N	\N	100610	100610	268406
11426	12137	35	applied	\N	\N	\N	\N	100622	100622	268418
11426	12171	52	applied	\N	\N	\N	\N	100639	100639	268435
11426	12204	69	applied	\N	\N	\N	\N	100656	100656	268452
11426	12240	86	applied	\N	\N	\N	\N	100673	100673	268469
11426	12275	103	applied	\N	\N	\N	\N	100690	100690	268486
11434	12294	1	applied	\N	\N	\N	\N	100734	100734	268529
11438	12298	0	applied	\N	\N	\N	\N	100740	100740	268535
11441	12182	3	applied	\N	\N	\N	\N	100751	100751	268546
11441	12183	4	applied	\N	\N	\N	\N	100752	100752	268547
11441	12218	21	applied	\N	\N	\N	\N	100769	100769	268564
11441	12251	38	applied	\N	\N	\N	\N	100786	100786	268581
11441	12287	55	applied	\N	\N	\N	\N	100803	100803	268598
11441	12193	72	applied	\N	\N	\N	\N	100820	100820	268615
11441	12227	89	applied	\N	\N	\N	\N	100837	100837	268632
11441	12261	107	applied	\N	\N	\N	\N	100854	100854	268649
11441	12294	124	applied	\N	\N	\N	\N	100871	100871	268666
11442	12306	2	applied	\N	\N	\N	\N	100875	100875	268670
11443	12304	0	applied	\N	\N	\N	\N	100877	100877	268672
11454	12326	0	applied	\N	\N	1000000000	\N	100903	100903	268698
11456	11971	28	applied	\N	\N	\N	\N	100936	100936	268731
11456	11978	33	applied	\N	\N	\N	\N	100941	100941	268736
11456	12018	63	applied	\N	\N	\N	\N	100971	100971	268766
11457	12331	0	applied	\N	\N	\N	\N	100973	100973	268768
11470	12348	1	applied	\N	\N	\N	\N	101002	101002	268797
11479	12370	3	applied	\N	\N	\N	\N	101042	101042	268834
11472	12350	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	101014	101014	\N
11487	12376	0	applied	\N	\N	\N	\N	101056	101056	268846
11495	12387	3	applied	\N	\N	\N	\N	101083	101083	268871
11492	12377	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	101061	101061	\N
11498	12320	9	applied	\N	\N	\N	\N	101098	101098	268884
11498	12355	26	applied	\N	\N	\N	\N	101115	101115	268901
11498	12385	39	applied	\N	\N	\N	\N	101128	101128	268914
11498	12311	51	applied	\N	\N	\N	\N	101140	101140	268924
11498	12322	57	applied	\N	\N	\N	\N	101146	101146	268930
11498	12358	74	applied	\N	\N	\N	\N	101163	101163	268947
11504	12305	15	applied	\N	\N	\N	\N	101217	101217	268992
11501	12396	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	101189	101189	\N
11505	12404	1	applied	\N	\N	\N	\N	101241	101241	269016
11509	12412	1	applied	\N	\N	\N	\N	101253	101253	269028
11520	12401	10	applied	\N	\N	\N	\N	101280	101280	269055
11520	12409	27	applied	\N	\N	\N	\N	101297	101297	269069
11177	11449	35	applied	\N	\N	\N	\N	99585	99585	267382
11525	11700	40	applied	\N	\N	\N	\N	101366	101366	269136
11525	11540	43	applied	\N	\N	\N	\N	101369	101369	269139
11525	11578	60	applied	\N	\N	\N	\N	101386	101386	269156
11525	11583	62	applied	\N	\N	\N	\N	101388	101388	269158
11525	11633	82	applied	\N	\N	\N	\N	101408	101408	269178
11525	11564	100	applied	\N	\N	\N	\N	101425	101425	269195
11525	11600	117	applied	\N	\N	\N	\N	101442	101442	269212
11533	12453	1	applied	\N	\N	\N	\N	101476	101476	269246
11535	12457	0	applied	\N	\N	\N	\N	101484	101484	269254
11537	12465	4	applied	\N	\N	\N	\N	101499	101499	269269
11538	12464	3	applied	\N	\N	\N	\N	101505	101505	269275
11540	12467	6	applied	\N	\N	\N	\N	101522	101522	269292
11554	12479	1	applied	\N	\N	\N	\N	101548	101548	269318
11568	12492	0	applied	\N	\N	\N	\N	101567	101567	269337
11578	12502	0	applied	\N	\N	\N	\N	101579	101579	269349
11585	12506	0	applied	\N	\N	\N	\N	101585	101585	269355
11597	12514	1	applied	\N	\N	\N	\N	101600	101600	269370
11604	12183	25	applied	\N	\N	\N	\N	101634	101634	269403
11604	12218	43	applied	\N	\N	\N	\N	101651	101651	269420
11604	12251	60	applied	\N	\N	\N	\N	101668	101668	269437
11604	12321	94	applied	\N	\N	\N	\N	101702	101702	269471
11604	12361	111	applied	\N	\N	\N	\N	101719	101719	269488
11605	12520	1	applied	\N	\N	\N	\N	101734	101734	269503
11606	12523	1	applied	\N	\N	\N	\N	101737	101737	269506
11610	12529	0	applied	\N	\N	\N	\N	101745	101745	269514
11613	12467	9	applied	\N	\N	\N	\N	101760	101760	269529
11613	12487	26	applied	\N	\N	\N	\N	101777	101777	269546
11613	12505	43	applied	\N	\N	\N	\N	101794	101794	269563
11613	12522	60	applied	\N	\N	\N	\N	101811	101811	269580
11615	12535	0	applied	\N	\N	\N	\N	101825	101825	269594
11618	12536	0	applied	\N	\N	\N	\N	101828	101828	269597
11623	12544	2	applied	\N	\N	\N	\N	101837	101837	269606
11625	12546	2	applied	\N	\N	\N	\N	101843	101843	269612
11634	12428	8	applied	\N	\N	\N	\N	101863	101863	269632
11634	12472	25	applied	\N	\N	\N	\N	101880	101880	269649
11634	12442	42	applied	\N	\N	\N	\N	101897	101897	269666
11634	12493	76	applied	\N	\N	\N	\N	101931	101931	269700
11634	12512	95	applied	\N	\N	\N	\N	101949	101949	269718
11634	12526	109	applied	\N	\N	\N	\N	101963	101963	269732
11636	12556	2	applied	\N	\N	\N	\N	101973	101973	269742
11641	12559	0	applied	\N	\N	\N	\N	101978	101978	269747
11663	12571	3	applied	\N	\N	\N	\N	102008	102008	269777
11683	12587	3	applied	\N	\N	\N	\N	102043	102043	269812
11684	12585	1	applied	\N	\N	\N	\N	102050	102050	269819
11685	12586	2	applied	\N	\N	\N	\N	102060	102060	269829
11687	12594	1	applied	\N	\N	\N	\N	102070	102070	269839
11721	12584	0	applied	\N	\N	\N	\N	102108	102108	269877
11729	12616	0	applied	\N	\N	\N	\N	102118	102118	269887
11736	12622	4	applied	\N	\N	\N	\N	102138	102138	269907
11736	12623	5	applied	\N	\N	\N	\N	102139	102139	269908
11736	12624	6	applied	\N	\N	\N	\N	102140	102140	269909
11737	12622	4	applied	\N	\N	\N	\N	102145	102145	269914
11767	12652	0	applied	\N	\N	\N	\N	102193	102193	269962
11773	12568	3	applied	\N	\N	1000000000	\N	102210	102210	269979
11773	12541	23	applied	\N	\N	\N	\N	102230	102230	269999
11773	12558	40	applied	\N	\N	\N	\N	102247	102247	270016
11773	12576	58	applied	\N	\N	\N	\N	102264	102264	270033
11773	12591	68	applied	\N	\N	\N	\N	102274	102274	270043
11773	12598	75	applied	\N	\N	\N	\N	102281	102281	270050
11773	12614	91	applied	\N	\N	\N	\N	102297	102297	270066
11773	12635	108	applied	\N	\N	\N	\N	102314	102314	270083
11775	12659	0	applied	\N	\N	\N	\N	102334	102334	270103
11783	12665	0	applied	\N	\N	\N	\N	102344	102344	270113
11789	12585	10	applied	\N	\N	\N	\N	102362	102362	270131
11789	12500	27	applied	\N	\N	\N	\N	102379	102379	270148
11789	12518	44	applied	\N	\N	\N	\N	102396	102396	270165
11789	12524	51	applied	\N	\N	\N	\N	102403	102403	270172
11789	12525	52	applied	\N	\N	\N	\N	102404	102404	270173
11789	12559	87	applied	\N	\N	\N	\N	102438	102438	270207
11789	12577	104	applied	\N	\N	\N	\N	102455	102455	270224
11789	12599	121	applied	\N	\N	\N	\N	102472	102472	270241
11796	12411	10	applied	\N	\N	\N	\N	102495	102495	270264
11796	12657	27	applied	\N	\N	\N	\N	102512	102512	270281
11796	12464	45	applied	\N	\N	\N	\N	102529	102529	270298
11796	12619	49	applied	\N	\N	\N	\N	102533	102533	270302
11796	12178	91	applied	\N	\N	\N	\N	102575	102575	270337
11796	12143	60	failed	Amount_insufficient_to_create_account	\N	\N	\N	102544	102544	\N
11796	12214	108	applied	\N	\N	\N	\N	102592	102592	270354
11801	12675	0	applied	\N	\N	\N	\N	102614	102614	270376
11807	12678	0	applied	\N	\N	\N	\N	102621	102621	270383
11819	12685	0	applied	\N	\N	\N	\N	102636	102636	270398
11832	12713	4	applied	\N	\N	\N	\N	102669	102669	270431
11833	12709	0	applied	\N	\N	\N	\N	102670	102670	270432
11853	12730	0	applied	\N	\N	\N	\N	102703	102703	270465
11864	12584	0	applied	\N	\N	\N	\N	102727	102727	270489
11864	12654	13	applied	\N	\N	\N	\N	102740	102740	270502
11864	12440	29	applied	\N	\N	\N	\N	102756	102756	270518
11864	12437	47	applied	\N	\N	\N	\N	102773	102773	270535
11864	12459	62	applied	\N	\N	1000000000	\N	102788	102788	270550
11864	12487	83	applied	\N	\N	\N	\N	102809	102809	270571
11864	12505	100	applied	\N	\N	\N	\N	102826	102826	270588
11864	12522	117	applied	\N	\N	\N	\N	102843	102843	270605
11864	12527	122	applied	\N	\N	\N	\N	102848	102848	270610
11870	12740	0	applied	\N	\N	\N	\N	102857	102857	270619
11875	12693	0	applied	\N	\N	\N	\N	102869	102869	270631
11875	12683	14	applied	\N	\N	\N	\N	102882	102882	270644
11875	12690	21	applied	\N	\N	\N	\N	102889	102889	270651
11875	12716	38	applied	\N	\N	\N	\N	102906	102906	270668
11875	12733	55	applied	\N	\N	\N	\N	102923	102923	270685
11882	12752	0	applied	\N	\N	\N	\N	102950	102950	270712
11884	12755	3	applied	\N	\N	\N	\N	102961	102961	270723
11886	12757	0	applied	\N	\N	\N	\N	102963	102963	270725
11894	12647	7	applied	\N	\N	\N	\N	102979	102979	270741
11894	12699	24	applied	\N	\N	\N	\N	102996	102996	270758
11894	12540	41	applied	\N	\N	\N	\N	103013	103013	270775
11894	12554	55	applied	\N	\N	\N	\N	103027	103027	270789
11894	12555	56	applied	\N	\N	\N	\N	103028	103028	270790
11894	12573	73	applied	\N	\N	\N	\N	103045	103045	270807
11894	12595	90	applied	\N	\N	\N	\N	103062	103062	270824
11894	12612	109	applied	\N	\N	\N	\N	103079	103079	270841
11525	11699	23	applied	\N	\N	\N	\N	101349	101349	269119
11915	12652	11	applied	\N	\N	\N	\N	103133	103133	270895
11931	12798	1	applied	\N	\N	\N	\N	103167	103167	270929
11934	12778	8	applied	\N	\N	\N	\N	103179	103179	270941
11940	12805	0	applied	\N	\N	\N	\N	103208	103208	270970
11941	12811	4	applied	\N	\N	\N	\N	103214	103214	270976
11941	12813	6	applied	\N	\N	\N	\N	103216	103216	270978
11943	12815	0	applied	\N	\N	\N	\N	103226	103226	270988
11951	12639	11	applied	\N	\N	\N	\N	103251	103251	271013
11955	12827	1	applied	\N	\N	\N	\N	103285	103285	271047
11956	12826	0	applied	\N	\N	\N	\N	103286	103286	271048
11957	12828	0	applied	\N	\N	\N	\N	103288	103288	271050
11962	12807	0	applied	\N	\N	\N	\N	103296	103296	271058
11978	12841	1	applied	\N	\N	\N	\N	103322	103322	271084
11982	12844	0	applied	\N	\N	\N	\N	103326	103326	271088
11999	12853	0	applied	\N	\N	\N	\N	103345	103345	271107
12013	12754	13	applied	\N	\N	\N	\N	103382	103382	271144
12013	12782	41	applied	\N	\N	\N	\N	103410	103410	271172
12013	12783	42	applied	\N	\N	\N	\N	103411	103411	271173
12013	12800	59	applied	\N	\N	\N	\N	103428	103428	271190
12013	12842	94	applied	\N	\N	\N	\N	103462	103462	271224
12013	12860	111	applied	\N	\N	\N	\N	103479	103479	271241
12015	12792	8	applied	\N	\N	\N	\N	103497	103497	271259
12015	12806	25	applied	\N	\N	\N	\N	103514	103514	271276
12015	12816	31	applied	\N	\N	\N	\N	103520	103520	271282
12015	12836	48	applied	\N	\N	\N	\N	103536	103536	271298
12015	12853	65	applied	\N	\N	\N	\N	103553	103553	271315
12021	12874	0	applied	\N	\N	\N	\N	103574	103574	271336
12023	12876	1	applied	\N	\N	\N	\N	103577	103577	271339
12027	12854	0	applied	\N	\N	1000000000	\N	103582	103582	271344
12030	12881	0	applied	\N	\N	\N	\N	103587	103587	271349
12059	12844	10	applied	\N	\N	\N	\N	103631	103631	271391
12059	12862	27	applied	\N	\N	\N	\N	103648	103648	271408
12059	12881	44	applied	\N	\N	\N	\N	103665	103665	271425
12059	12901	62	applied	\N	\N	\N	\N	103682	103682	271442
12061	12770	23	applied	\N	\N	\N	\N	103707	103707	271466
12061	12791	44	applied	\N	\N	\N	\N	103728	103728	271487
12061	12809	61	applied	\N	\N	\N	\N	103745	103745	271504
12061	12833	78	applied	\N	\N	\N	\N	103762	103762	271521
12061	12850	95	applied	\N	\N	\N	\N	103779	103779	271538
12061	12870	112	applied	\N	\N	\N	\N	103796	103796	271555
12062	12904	1	applied	\N	\N	\N	\N	103810	103810	103810
12067	12898	2	applied	\N	\N	1000000000	\N	103823	103823	271577
12063	12907	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	103813	103813	\N
12064	12907	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	103817	103817	\N
12067	12840	23	applied	\N	\N	\N	\N	103844	103844	271595
12067	12858	41	applied	\N	\N	\N	\N	103861	103861	271612
12067	12888	68	applied	\N	\N	\N	\N	103888	103888	271639
12067	12910	85	applied	\N	\N	\N	\N	103905	103905	271656
12090	12934	1	applied	\N	\N	\N	\N	103949	103949	271697
12091	12618	13	applied	\N	\N	\N	\N	103963	103963	271711
12091	12854	29	applied	\N	\N	1000000000	\N	103979	103979	271727
12093	12903	13	applied	\N	\N	\N	\N	103996	103996	271743
12093	12925	30	applied	\N	\N	\N	\N	104013	104013	271760
12103	12949	0	applied	\N	\N	\N	\N	104044	104044	271789
12111	12954	0	applied	\N	\N	\N	\N	104052	104052	271797
12141	12975	0	applied	\N	\N	\N	\N	104090	104090	271835
12155	12986	0	applied	\N	\N	\N	\N	104111	104111	271856
12158	12987	0	applied	\N	\N	1000000000	\N	104115	104115	271860
12173	13002	0	applied	\N	\N	\N	\N	104148	104148	271893
12174	13003	1	applied	\N	\N	\N	\N	104152	104152	271897
12174	13004	2	applied	\N	\N	\N	\N	104153	104153	271898
12181	13009	0	applied	\N	\N	\N	\N	104170	104170	271915
12185	13013	0	applied	\N	\N	\N	\N	104178	104178	271923
12185	12927	17	applied	\N	\N	\N	\N	104195	104195	271940
12185	12952	42	applied	\N	\N	\N	\N	104220	104220	271965
12185	12964	54	applied	\N	\N	\N	\N	104232	104232	271977
12185	12985	72	applied	\N	\N	\N	\N	104249	104249	271994
12185	13002	89	applied	\N	\N	\N	\N	104266	104266	272011
12189	13020	1	applied	\N	\N	\N	\N	104285	104285	272030
12190	13019	0	applied	\N	\N	\N	\N	104287	104287	272032
12191	13021	2	applied	\N	\N	\N	\N	104292	104292	272037
12192	13003	10	applied	\N	\N	\N	\N	104303	104303	272048
12192	13015	21	applied	\N	\N	\N	\N	104314	104314	272059
12196	13024	0	applied	\N	\N	\N	\N	104324	104324	272069
12197	13026	0	applied	\N	\N	\N	\N	104326	104326	272071
12217	13029	4	applied	\N	\N	\N	\N	104365	104365	272110
12217	12700	21	applied	\N	\N	\N	\N	104382	104382	272127
12217	12866	32	applied	\N	\N	\N	\N	104393	104393	272137
12217	12710	43	applied	\N	\N	\N	\N	104404	104404	272148
12217	12726	59	applied	\N	\N	\N	\N	104420	104420	272164
12217	12746	76	applied	\N	\N	\N	\N	104437	104437	272181
12217	12764	93	applied	\N	\N	\N	\N	104454	104454	272198
12217	12781	110	applied	\N	\N	\N	\N	104471	104471	272215
12223	13053	0	applied	\N	\N	\N	\N	104495	104495	272239
12232	13064	4	applied	\N	\N	\N	\N	104514	104514	272258
12245	13072	0	applied	\N	\N	\N	\N	104528	104528	272272
12248	13080	2	applied	\N	\N	\N	\N	104538	104538	272282
12250	13080	15	applied	\N	\N	\N	\N	104559	104559	272303
12261	13027	0	applied	\N	\N	\N	\N	104573	104573	272317
12261	13061	7	applied	\N	\N	\N	\N	104580	104580	272324
12261	12962	23	applied	\N	\N	\N	\N	104596	104596	272340
12261	13000	58	applied	\N	\N	\N	\N	104630	104630	272374
12261	13018	75	applied	\N	\N	\N	\N	104647	104647	272391
12261	13040	92	applied	\N	\N	\N	\N	104664	104664	272408
12261	13057	109	applied	\N	\N	\N	\N	104681	104681	272425
12263	12819	1	applied	\N	\N	\N	\N	104699	104699	272443
12263	12820	2	applied	\N	\N	\N	\N	104700	104700	272444
12263	13034	5	applied	\N	\N	\N	\N	104703	104703	272447
12272	13099	0	applied	\N	\N	\N	\N	104723	104723	272467
12289	13113	0	applied	\N	\N	\N	\N	104742	104742	272486
12290	13034	2	applied	\N	\N	\N	\N	104745	104745	272489
12290	13095	20	applied	\N	\N	\N	\N	104762	104762	272506
12295	13122	2	applied	\N	\N	\N	\N	104782	104782	272526
12306	13140	2	applied	\N	\N	\N	\N	104813	104813	272557
12318	13153	0	applied	\N	\N	\N	\N	104829	104829	272573
12321	13115	0	applied	\N	\N	\N	\N	104833	104833	272577
12321	13094	17	applied	\N	\N	\N	\N	104850	104850	272594
12321	13135	51	applied	\N	\N	\N	\N	104884	104884	272628
12325	13166	3	applied	\N	\N	\N	\N	104899	104899	272643
11902	12774	1	applied	\N	\N	\N	\N	103108	103108	270870
12372	13115	4	applied	\N	\N	\N	\N	104975	104975	272719
12372	13108	20	applied	\N	\N	\N	\N	104991	104991	272735
12372	13079	37	applied	\N	\N	\N	\N	105008	105008	272752
12372	12883	54	applied	\N	\N	\N	\N	105025	105025	272768
12372	12897	71	applied	\N	\N	\N	\N	105042	105042	272785
12372	12920	89	applied	\N	\N	\N	\N	105059	105059	272802
12372	12939	106	applied	\N	\N	\N	\N	105076	105076	272819
12372	12955	123	applied	\N	\N	\N	\N	105093	105093	272834
12372	12956	124	applied	\N	\N	\N	\N	105094	105094	272835
12375	13207	0	applied	\N	\N	\N	\N	105098	105098	272839
12395	13221	0	applied	\N	\N	\N	\N	105119	105119	272860
12445	13182	3	applied	\N	\N	\N	\N	105161	105161	272902
12445	13035	17	applied	\N	\N	\N	\N	105175	105175	272916
12445	13038	18	applied	\N	\N	\N	\N	105176	105176	272917
12445	13058	19	applied	\N	\N	\N	\N	105177	105177	272918
12445	13078	36	applied	\N	\N	\N	\N	105194	105194	272935
12445	13041	53	applied	\N	\N	\N	\N	105211	105211	272952
12459	13131	6	applied	\N	\N	\N	\N	105222	105222	272963
12465	13244	4	applied	\N	\N	\N	\N	105232	105232	272973
12472	13214	1	applied	\N	\N	\N	\N	105236	105236	272977
12472	13215	2	applied	\N	\N	\N	\N	105237	105237	272978
12472	13231	20	applied	\N	\N	\N	\N	105254	105254	272995
12486	13260	2	applied	\N	\N	\N	\N	105285	105285	273026
12502	13268	0	applied	\N	\N	\N	\N	105310	105310	273051
12503	13270	0	applied	\N	\N	\N	\N	105312	105312	273053
12508	13273	0	applied	\N	\N	\N	\N	105328	105328	273069
12515	13301	1	applied	\N	\N	\N	\N	105358	105358	273099
12523	13311	1	applied	\N	\N	\N	\N	105378	105378	273119
12523	13312	2	applied	\N	\N	\N	\N	105379	105379	273120
12532	13321	0	applied	\N	\N	\N	\N	105406	105406	273147
12535	13326	1	applied	\N	\N	\N	\N	105414	105414	273155
12543	13339	2	applied	\N	\N	1000000000	\N	105439	105439	273180
12544	13338	1	applied	\N	\N	\N	\N	105443	105443	273184
12551	13346	2	applied	\N	\N	\N	\N	105455	105455	273196
12552	13285	15	applied	\N	\N	\N	\N	105471	105471	273212
12552	13321	32	applied	\N	\N	\N	\N	105488	105488	273229
12552	13164	51	applied	\N	\N	\N	\N	105507	105507	273248
12552	13183	68	applied	\N	\N	\N	\N	105524	105524	273265
12552	13200	85	applied	\N	\N	\N	\N	105541	105541	273282
12552	13209	94	applied	\N	\N	\N	\N	105550	105550	273291
12552	13225	110	applied	\N	\N	\N	\N	105566	105566	273307
12565	13369	1	applied	\N	\N	\N	\N	105627	105627	273368
12570	13381	0	applied	\N	\N	\N	\N	105643	105643	273384
12571	13381	0	applied	\N	\N	\N	\N	105645	105645	273386
12576	13391	2	applied	\N	\N	\N	\N	105657	105657	273398
12579	13402	3	applied	\N	\N	\N	\N	105668	105668	273409
12588	13417	6	applied	\N	\N	\N	\N	105704	105704	273445
12593	13427	3	applied	\N	\N	\N	\N	105725	105725	273466
12596	13433	3	applied	\N	\N	\N	\N	105733	105733	273474
12605	13454	0	applied	\N	\N	\N	\N	105762	105762	273503
12608	13458	0	applied	\N	\N	\N	\N	105768	105768	273509
12610	13461	1	applied	\N	\N	\N	\N	105773	105773	273514
12621	13488	0	applied	\N	\N	\N	\N	105810	105810	273551
12631	13503	1	applied	\N	\N	\N	\N	105827	105827	273568
12638	13512	0	applied	\N	\N	\N	\N	105844	105844	273585
12640	13092	5	applied	\N	\N	\N	\N	105861	105861	273602
12640	13268	22	applied	\N	\N	\N	\N	105878	105878	273619
12640	13289	40	applied	\N	\N	\N	\N	105895	105895	273636
12640	13321	55	applied	\N	\N	\N	\N	105910	105910	273651
12640	13350	69	applied	\N	\N	\N	\N	105924	105924	273665
12640	13385	86	applied	\N	\N	\N	\N	105941	105941	273682
12640	13460	120	applied	\N	\N	\N	\N	105975	105975	273716
12641	13518	0	applied	\N	\N	\N	\N	105981	105981	273722
12643	13518	0	applied	\N	\N	\N	\N	105985	105985	273726
12643	13519	1	applied	\N	\N	\N	\N	105986	105986	273727
12649	13524	0	applied	\N	\N	\N	\N	105998	105998	273739
12650	13527	1	applied	\N	\N	\N	\N	106001	106001	273742
12651	13531	5	applied	\N	\N	\N	\N	106012	106012	273753
12658	13546	2	applied	\N	\N	\N	\N	106044	106044	273785
12665	13562	4	applied	\N	\N	\N	\N	106066	106066	273807
12666	13563	0	applied	\N	\N	\N	\N	106067	106067	273808
12667	13564	1	applied	\N	\N	\N	\N	106071	106071	273812
12673	13571	3	applied	\N	\N	\N	\N	106091	106091	273832
12696	13599	3	applied	\N	\N	\N	\N	106144	106144	273885
12698	13600	0	applied	\N	\N	\N	\N	106147	106147	273888
12699	13602	0	applied	\N	\N	\N	\N	106149	106149	273890
12701	13606	0	applied	\N	\N	\N	\N	106153	106153	273894
12712	13619	1	applied	\N	\N	\N	\N	106186	106186	273927
12716	13387	2	applied	\N	\N	\N	\N	106203	106203	273944
12716	13422	19	applied	\N	\N	\N	\N	106220	106220	273961
12716	13456	36	applied	\N	\N	\N	\N	106237	106237	273978
12716	13471	53	applied	\N	\N	\N	\N	106254	106254	273995
12716	13423	71	applied	\N	\N	\N	\N	106271	106271	274012
12716	13457	88	applied	\N	\N	\N	\N	106288	106288	274029
12716	13493	105	applied	\N	\N	\N	\N	106305	106305	274046
12716	13499	108	applied	\N	\N	\N	\N	106308	106308	274049
12716	13532	124	applied	\N	\N	\N	\N	106324	106324	274065
12720	13637	2	applied	\N	\N	\N	\N	106343	106343	274084
12721	13641	0	applied	\N	\N	\N	\N	106347	106347	274088
12725	13396	5	applied	\N	\N	\N	\N	106366	106366	274107
12725	13302	22	applied	\N	\N	\N	\N	106383	106383	274124
12727	13653	4	applied	\N	\N	\N	\N	106402	106402	274143
12729	13599	30	applied	\N	\N	\N	\N	106436	106436	274177
12729	13634	47	applied	\N	\N	\N	\N	106453	106453	274194
12729	13654	57	applied	\N	\N	\N	\N	106463	106463	274204
12733	13657	0	applied	\N	\N	\N	\N	106470	106470	274211
12744	13670	0	applied	\N	\N	\N	\N	106493	106493	274234
12748	13673	1	applied	\N	\N	\N	\N	106505	106505	274245
12750	13678	1	applied	\N	\N	\N	\N	106513	106513	274251
12752	13689	8	applied	\N	\N	\N	\N	106529	106529	274267
12755	13691	1	applied	\N	\N	\N	\N	106553	106553	274291
12760	13709	0	applied	\N	\N	\N	\N	106579	106579	274317
12762	13716	0	applied	\N	\N	\N	\N	106586	106586	274324
12769	13731	1	applied	\N	\N	\N	\N	106603	106603	274341
12775	13735	1	applied	\N	\N	\N	\N	106616	106616	274354
12785	13751	1	applied	\N	\N	\N	\N	106648	106648	274386
12792	13764	4	applied	\N	\N	\N	\N	106671	106671	274409
12793	13768	0	applied	\N	\N	\N	\N	106676	106676	274414
12795	13772	6	applied	\N	\N	\N	\N	106691	106691	274429
12804	13786	1	applied	\N	\N	\N	\N	106714	106714	274452
12344	13175	1	applied	\N	\N	\N	\N	104930	104930	272674
12834	13808	0	applied	\N	\N	\N	\N	106758	106758	274496
12848	13734	2	applied	\N	\N	\N	\N	106786	106786	274524
12848	13741	6	applied	\N	\N	\N	\N	106790	106790	274528
12848	13761	15	applied	\N	\N	\N	\N	106799	106799	274537
12848	13785	26	applied	\N	\N	\N	\N	106809	106809	274547
12848	13805	43	applied	\N	\N	\N	\N	106826	106826	274564
12848	13742	60	applied	\N	\N	\N	\N	106843	106843	274581
12848	13779	77	applied	\N	\N	\N	\N	106860	106860	274598
12857	13829	0	applied	\N	\N	\N	\N	106891	106891	274629
12860	13833	0	applied	\N	\N	\N	\N	106899	106899	274637
12864	13847	4	applied	\N	\N	1000000000	\N	106923	106923	274661
12867	13861	5	applied	\N	\N	\N	\N	106944	106944	274682
12868	13863	7	applied	\N	\N	\N	\N	106954	106954	274692
12874	13879	2	applied	\N	\N	\N	\N	106974	106974	274712
12876	13879	2	applied	\N	\N	\N	\N	106982	106982	274720
12880	13865	21	applied	\N	\N	\N	\N	107011	107011	274749
12880	13834	38	applied	\N	\N	\N	\N	107028	107028	274766
12880	13871	56	applied	\N	\N	\N	\N	107045	107045	274783
12888	13889	0	applied	\N	\N	\N	\N	107064	107064	274802
12902	13901	0	applied	\N	\N	\N	\N	107088	107088	274826
12904	13901	0	applied	\N	\N	\N	\N	107096	107096	274834
12906	13908	1	applied	\N	\N	\N	\N	107103	107103	274841
12911	13917	3	applied	\N	\N	\N	\N	107117	107117	274855
12913	13916	2	applied	\N	\N	\N	\N	107132	107132	274870
12916	13905	12	applied	\N	\N	\N	\N	107154	107154	274892
12916	13898	30	applied	\N	\N	\N	\N	107171	107171	274909
12916	13923	43	applied	\N	\N	\N	\N	107184	107184	274922
12917	13926	2	applied	\N	\N	\N	\N	107187	107187	274925
12918	13924	0	applied	\N	\N	\N	\N	107189	107189	274927
12924	13934	0	applied	\N	\N	\N	\N	107203	107203	274941
12926	13937	1	applied	\N	\N	\N	\N	107210	107210	274948
12930	13908	13	applied	\N	\N	\N	\N	107232	107232	274970
12930	13884	30	applied	\N	\N	\N	\N	107249	107249	274987
12930	13919	47	applied	\N	\N	\N	\N	107266	107266	275004
12935	13949	1	applied	\N	\N	\N	\N	107289	107289	275027
12938	13957	1	applied	\N	\N	\N	\N	107313	107313	275051
12941	13961	1	applied	\N	\N	\N	\N	107319	107319	275057
12944	13963	3	applied	\N	\N	\N	\N	107326	107326	275064
12953	13978	0	applied	\N	\N	\N	\N	107347	107347	275085
12968	14007	1	applied	\N	\N	\N	\N	107387	107387	275125
12969	14006	0	applied	\N	\N	\N	\N	107388	107388	275126
12978	14014	2	applied	\N	\N	\N	\N	107410	107410	275148
12979	14016	1	applied	\N	\N	\N	\N	107412	107412	275150
12989	14025	2	applied	\N	\N	\N	\N	107433	107433	275171
12996	14036	3	applied	\N	\N	\N	\N	107456	107456	275194
13003	14040	0	applied	\N	\N	\N	\N	107472	107472	275210
13003	14044	4	applied	\N	\N	\N	\N	107476	107476	275214
13006	14045	4	applied	\N	\N	\N	\N	107489	107489	275227
13014	14060	0	applied	\N	\N	\N	\N	107508	107508	275246
13022	14077	1	applied	\N	\N	\N	\N	107538	107538	275273
13016	14062	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	107512	107512	\N
13029	14085	1	applied	\N	\N	\N	\N	107554	107554	275289
13035	14109	11	applied	\N	\N	\N	\N	107588	107588	275322
13034	14062	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	107574	107574	\N
13040	14127	6	applied	\N	\N	\N	\N	107612	107612	275346
13043	14129	0	applied	\N	\N	\N	\N	107630	107630	275364
13050	14149	0	applied	\N	\N	\N	\N	107660	107660	275394
13052	14150	1	applied	\N	\N	1000000000	\N	107671	107671	275405
13056	14162	4	applied	\N	\N	\N	\N	107688	107688	275422
13057	14163	0	applied	\N	\N	\N	\N	107689	107689	275423
13059	14174	11	applied	\N	\N	\N	\N	107732	107732	275466
13061	14181	2	applied	\N	\N	\N	\N	107755	107755	275489
13062	14189	7	applied	\N	\N	\N	\N	107763	107763	275497
13063	14187	5	applied	\N	\N	\N	\N	107780	107780	275514
13066	14204	3	applied	\N	\N	\N	\N	107805	107805	275539
13070	14205	0	applied	\N	\N	1000000000	\N	107826	107826	275560
13073	14213	0	applied	\N	\N	\N	\N	107842	107842	275576
13075	14216	3	applied	\N	\N	\N	\N	107847	107847	275581
13082	14228	1	applied	\N	\N	\N	\N	107871	107871	275605
13087	14232	1	applied	\N	\N	\N	\N	107891	107891	275625
13088	14241	2	applied	\N	\N	\N	\N	107900	107900	275634
13109	14291	1	applied	\N	\N	\N	\N	107974	107974	275708
13110	14303	8	applied	\N	\N	\N	\N	107986	107986	275720
13118	14321	7	applied	\N	\N	\N	\N	108020	108020	275754
13121	14329	3	applied	\N	\N	\N	\N	108036	108036	275770
13121	14332	6	applied	\N	\N	\N	\N	108039	108039	275773
13123	14343	2	applied	\N	\N	\N	\N	108050	108050	275784
13124	14346	1	applied	\N	\N	\N	\N	108053	108053	275787
13127	14359	11	applied	\N	\N	\N	\N	108069	108069	275803
13130	14360	0	applied	\N	\N	\N	\N	108092	108092	275826
13132	14373	6	applied	\N	\N	\N	\N	108105	108105	275839
13133	14387	3	applied	\N	\N	\N	\N	108119	108119	275853
13141	14400	5	applied	\N	\N	\N	\N	108151	108151	275885
13141	14401	6	applied	\N	\N	\N	\N	108152	108152	275886
13142	14399	4	applied	\N	\N	\N	\N	108158	108158	275892
13143	14404	0	applied	\N	\N	\N	\N	108163	108163	275897
13145	14406	2	applied	\N	\N	\N	\N	108171	108171	275905
13147	14421	14	applied	\N	\N	\N	\N	108193	108193	275927
13154	14442	7	applied	\N	\N	\N	\N	108230	108230	275964
13156	14447	3	applied	\N	\N	\N	\N	108240	108240	275974
13161	14448	0	applied	\N	\N	\N	\N	108259	108259	275993
13161	14449	1	applied	\N	\N	\N	\N	108260	108260	275994
13162	14452	0	applied	\N	\N	\N	\N	108263	108263	275997
13170	14448	2	applied	\N	\N	\N	\N	108297	108297	276031
13170	14314	19	applied	\N	\N	\N	\N	108314	108314	276048
13170	14371	36	applied	\N	\N	\N	\N	108331	108331	276065
13170	14445	54	applied	\N	\N	\N	\N	108348	108348	276082
13170	14288	71	applied	\N	\N	\N	\N	108365	108365	276099
13170	14312	88	applied	\N	\N	\N	\N	108382	108382	276116
13170	14317	91	applied	\N	\N	\N	\N	108385	108385	276119
13170	14320	94	applied	\N	\N	\N	\N	108388	108388	276122
13170	14343	111	applied	\N	\N	\N	\N	108405	108405	276139
13171	14474	2	applied	\N	\N	\N	\N	108422	108422	276156
13175	14488	9	applied	\N	\N	\N	\N	108444	108444	276178
13176	14479	0	applied	\N	\N	\N	\N	108445	108445	276179
12823	13803	0	applied	\N	\N	\N	\N	106746	106746	274484
13183	14392	37	applied	\N	\N	\N	\N	108542	108542	276276
13183	14449	52	applied	\N	\N	\N	\N	108557	108557	276291
13183	14455	55	applied	\N	\N	\N	\N	108560	108560	276294
13183	14511	72	applied	\N	\N	\N	\N	108577	108577	276311
13183	14329	89	applied	\N	\N	\N	\N	108594	108594	276328
13183	14352	106	applied	\N	\N	\N	\N	108611	108611	276345
13183	14375	124	applied	\N	\N	\N	\N	108628	108628	276362
13187	14523	0	applied	\N	\N	\N	\N	108640	108640	276374
13192	14540	2	applied	\N	\N	\N	\N	108674	108674	276408
13196	14548	1	applied	\N	\N	\N	\N	108698	108698	276432
13197	14545	0	applied	\N	\N	\N	\N	108703	108703	276437
13197	14547	3	applied	\N	\N	\N	\N	108706	108706	276440
13201	14559	0	applied	\N	\N	\N	\N	108723	108723	276457
13204	14568	0	applied	\N	\N	\N	\N	108734	108734	276468
13209	14579	2	applied	\N	\N	\N	\N	108749	108749	276483
13213	14590	1	applied	\N	\N	\N	\N	108766	108766	276500
13216	14599	2	applied	\N	\N	\N	\N	108780	108780	276514
13217	14538	9	applied	\N	\N	\N	\N	108790	108790	276524
13217	14590	26	applied	\N	\N	\N	\N	108807	108807	276541
13217	14394	43	applied	\N	\N	\N	\N	108824	108824	276558
13217	14421	60	applied	\N	\N	\N	\N	108841	108841	276575
13217	14450	77	applied	\N	\N	\N	\N	108858	108858	276592
13217	14457	80	applied	\N	\N	\N	\N	108861	108861	276595
13217	14495	100	applied	\N	\N	\N	\N	108881	108881	276615
13217	14519	117	applied	\N	\N	\N	\N	108898	108898	276632
13220	14605	4	applied	\N	\N	\N	\N	108918	108918	276652
13225	14609	0	applied	\N	\N	\N	\N	108935	108935	276669
13226	14439	12	applied	\N	\N	\N	\N	108950	108950	276684
13226	14470	22	applied	\N	\N	\N	\N	108960	108960	276694
13226	14522	39	applied	\N	\N	\N	\N	108977	108977	276711
13226	14574	56	applied	\N	\N	\N	\N	108994	108994	276728
13228	14616	4	applied	\N	\N	\N	\N	109011	109011	276745
13231	14619	0	applied	\N	\N	\N	\N	109026	109026	276760
13233	14619	1	applied	\N	\N	\N	\N	109030	109030	276764
13234	14546	16	applied	\N	\N	\N	\N	109047	109047	276781
13234	14572	33	applied	\N	\N	\N	\N	109064	109064	276798
13234	14598	50	applied	\N	\N	\N	\N	109081	109081	276815
13245	14629	0	applied	\N	\N	\N	\N	109116	109116	276850
13263	14668	4	applied	\N	\N	\N	\N	109172	109172	276904
13258	14655	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	109154	109154	\N
13264	14664	0	applied	\N	\N	\N	\N	109175	109175	276907
13279	14686	1	applied	\N	\N	\N	\N	109220	109220	276952
13280	14694	0	applied	\N	\N	\N	\N	109228	109228	276960
13286	14705	2	applied	\N	\N	\N	\N	109246	109246	276978
13292	14719	4	applied	\N	\N	\N	\N	109269	109269	277001
13296	14732	2	applied	\N	\N	\N	\N	109288	109288	277020
13298	14741	1	applied	\N	\N	\N	\N	109297	109297	277029
13301	14660	16	applied	\N	\N	1000000000	\N	109320	109320	277052
13301	14675	46	applied	\N	\N	\N	\N	109350	109350	277082
13301	14680	49	applied	\N	\N	\N	\N	109353	109353	277085
13301	14705	66	applied	\N	\N	\N	\N	109370	109370	277102
13301	14733	83	applied	\N	\N	\N	\N	109387	109387	277119
13303	14750	5	applied	\N	\N	\N	\N	109404	109404	277136
13305	14756	4	applied	\N	\N	\N	\N	109421	109421	277153
13306	14757	2	applied	\N	\N	\N	\N	109425	109425	277157
13309	14762	1	applied	\N	\N	\N	\N	109433	109433	277165
13322	14761	5	applied	\N	\N	\N	\N	109474	109474	277206
13322	14757	22	applied	\N	\N	\N	\N	109491	109491	277223
13322	14785	39	applied	\N	\N	\N	\N	109508	109508	277240
13322	14787	41	applied	\N	\N	\N	\N	109510	109510	277242
13323	14785	4	applied	\N	\N	\N	\N	109517	109517	277249
13326	14800	6	applied	\N	\N	\N	\N	109532	109532	277264
13327	14577	30	applied	\N	\N	\N	\N	109563	109563	277294
13327	14629	47	applied	\N	\N	\N	\N	109580	109580	277311
13327	14677	64	applied	\N	\N	\N	\N	109597	109597	277328
13327	14727	81	applied	\N	\N	\N	\N	109614	109614	277345
13327	14778	98	applied	\N	\N	\N	\N	109631	109631	277362
13329	14802	1	applied	\N	\N	\N	\N	109647	109647	277378
13333	14818	5	applied	\N	\N	\N	\N	109666	109666	277397
13333	14819	6	applied	\N	\N	1000000000	\N	109667	109667	277398
13334	14815	4	applied	\N	\N	\N	\N	109675	109675	277406
13337	14827	11	applied	\N	\N	\N	\N	109712	109712	277443
13338	14829	1	applied	\N	\N	\N	\N	109714	109714	277445
13339	14830	2	applied	\N	\N	\N	\N	109719	109719	277450
13345	14850	2	applied	\N	\N	\N	\N	109751	109751	277482
13347	14859	4	applied	\N	\N	\N	\N	109760	109760	277491
13355	14869	1	applied	\N	\N	\N	\N	109789	109789	277520
13359	14867	1	applied	\N	\N	\N	\N	109801	109801	277532
13362	14491	13	applied	\N	\N	\N	\N	109824	109824	277555
13362	14282	30	applied	\N	\N	\N	\N	109841	109841	277571
13362	14286	31	applied	\N	\N	\N	\N	109842	109842	277572
13362	14314	39	applied	\N	\N	\N	\N	109850	109850	277580
13362	14371	56	applied	\N	\N	\N	\N	109867	109867	277597
13362	14445	73	applied	\N	\N	\N	\N	109884	109884	277614
13362	14501	90	applied	\N	\N	\N	\N	109901	109901	277631
13362	14551	108	applied	\N	\N	\N	\N	109918	109918	277648
13362	14600	125	applied	\N	\N	\N	\N	109935	109935	277665
13367	14889	4	applied	\N	\N	\N	\N	109963	109963	277692
13371	14902	2	applied	\N	\N	\N	\N	109990	109990	277719
13373	14912	1	applied	\N	\N	\N	\N	110003	110003	277732
13373	14913	2	applied	\N	\N	\N	\N	110004	110004	277733
13375	14914	3	applied	\N	\N	\N	\N	110013	110013	277742
13381	14935	6	applied	\N	\N	\N	\N	110038	110038	277767
13382	14948	4	applied	\N	\N	\N	\N	110051	110051	277780
13382	14949	5	applied	\N	\N	\N	\N	110052	110052	277781
13384	14944	0	applied	\N	\N	\N	\N	110063	110063	277792
13387	14955	0	applied	\N	\N	\N	\N	110077	110077	277806
13391	14961	0	applied	\N	\N	\N	\N	110086	110086	277815
13396	14975	4	applied	\N	\N	\N	\N	110117	110117	277846
13397	14973	2	applied	\N	\N	\N	\N	110122	110122	277851
13398	14971	0	applied	\N	\N	\N	\N	110127	110127	277856
13402	14990	5	applied	\N	\N	\N	\N	110160	110160	277889
13403	14987	2	applied	\N	\N	\N	\N	110163	110163	277892
13415	15018	0	applied	\N	\N	\N	\N	110206	110206	277935
13416	15020	0	applied	\N	\N	\N	\N	110208	110208	277937
13422	15043	1	applied	\N	\N	\N	\N	110234	110234	277963
13424	15054	9	applied	\N	\N	\N	\N	110260	110260	277989
13429	15062	3	applied	\N	\N	\N	\N	110274	110274	278003
13434	15085	3	applied	\N	\N	\N	\N	110301	110301	278030
13435	15083	1	applied	\N	\N	\N	\N	110303	110303	278032
13183	14326	20	applied	\N	\N	\N	\N	108525	108525	276259
13447	15110	5	applied	\N	\N	\N	\N	110361	110361	278090
13448	15107	0	applied	\N	\N	\N	\N	110366	110366	278095
13451	15116	0	applied	\N	\N	\N	\N	110378	110378	278107
13451	15117	1	applied	\N	\N	\N	\N	110379	110379	278108
13453	15119	0	applied	\N	\N	\N	\N	110386	110386	278115
13453	15123	4	applied	\N	\N	\N	\N	110390	110390	278119
13463	15140	2	applied	\N	\N	\N	\N	110417	110417	278146
13466	14555	39	applied	\N	\N	\N	\N	110462	110462	278190
13466	14655	12	failed	Amount_insufficient_to_create_account	\N	\N	\N	110436	110436	\N
13466	14606	56	applied	\N	\N	\N	\N	110479	110479	278207
13466	14658	73	applied	\N	\N	\N	\N	110496	110496	278224
13469	15147	0	applied	\N	\N	\N	\N	110502	110502	278230
13469	15148	1	applied	\N	\N	\N	\N	110503	110503	278231
13475	15157	0	applied	\N	\N	\N	\N	110524	110524	278252
13479	15160	3	applied	\N	\N	\N	\N	110543	110543	278271
13481	15178	16	applied	\N	\N	\N	\N	110564	110564	278292
13482	15180	0	applied	\N	\N	\N	\N	110566	110566	278294
13483	15182	2	applied	\N	\N	\N	\N	110577	110577	278305
13485	15197	8	applied	\N	\N	\N	\N	110601	110601	278329
13486	15207	10	applied	\N	\N	1000000000	\N	110611	110611	278339
13490	15215	0	applied	\N	\N	\N	\N	110625	110625	278352
13502	15239	1	applied	\N	\N	\N	\N	110677	110677	278403
13504	15243	2	applied	\N	\N	\N	\N	110684	110684	278410
13507	15250	6	applied	\N	\N	\N	\N	110695	110695	278421
13510	15199	25	applied	\N	\N	\N	\N	110743	110743	278469
13510	15257	42	applied	\N	\N	\N	\N	110760	110760	278486
13513	15265	2	applied	\N	\N	\N	\N	110770	110770	278496
13513	15266	3	applied	\N	\N	\N	\N	110771	110771	278497
13523	15286	3	applied	\N	\N	1000000000	\N	110803	110803	278529
13524	15285	2	applied	\N	\N	\N	\N	110806	110806	278532
13525	15286	3	applied	\N	\N	1000000000	\N	110811	110811	278537
13535	15301	3	applied	\N	\N	\N	\N	110844	110844	278570
13536	15300	0	applied	\N	\N	\N	\N	110846	110846	278572
13556	15311	2	applied	\N	\N	\N	\N	110892	110892	278618
13558	15310	1	applied	\N	\N	\N	\N	110899	110899	278625
13565	15335	0	applied	\N	\N	\N	\N	110927	110927	278653
13565	15338	3	applied	\N	\N	\N	\N	110930	110930	278656
13566	15340	5	applied	\N	\N	\N	\N	110940	110940	278666
13568	15315	25	applied	\N	\N	\N	\N	110976	110976	278702
13568	15324	35	applied	\N	\N	\N	\N	110986	110986	278712
13571	15280	6	applied	\N	\N	\N	\N	111003	111003	278729
13571	15340	23	applied	\N	\N	\N	\N	111020	111020	278746
13571	15324	27	applied	\N	\N	\N	\N	111024	111024	278750
13571	15343	30	applied	\N	\N	\N	\N	111027	111027	278753
13574	15348	2	applied	\N	\N	\N	\N	111038	111038	278764
13579	15368	3	applied	\N	\N	\N	\N	111061	111061	278787
13586	15396	3	applied	\N	\N	\N	\N	111102	111102	278826
13589	15401	4	applied	\N	\N	\N	\N	111116	111116	278840
13595	15406	1	applied	\N	\N	\N	\N	111137	111137	278861
13599	15410	1	applied	\N	\N	\N	\N	111150	111150	278874
13603	15420	4	applied	\N	\N	\N	\N	111164	111164	278888
13603	15437	21	applied	\N	\N	\N	\N	111181	111181	278905
13604	15421	5	applied	\N	\N	\N	\N	111192	111192	278916
13608	15444	2	applied	\N	\N	\N	\N	111228	111228	278952
13612	15462	2	applied	\N	\N	\N	\N	111248	111248	278971
13613	15466	3	applied	\N	\N	\N	\N	111252	111252	278975
13620	15479	0	applied	\N	\N	\N	\N	111277	111277	279000
13626	15487	0	applied	\N	\N	\N	\N	111295	111295	279018
13627	15494	7	applied	\N	\N	\N	\N	111314	111314	279037
13630	15495	9	applied	\N	\N	\N	\N	111340	111340	279063
13631	15503	0	applied	\N	\N	\N	\N	111347	111347	279070
13634	15525	13	applied	\N	\N	\N	\N	111369	111369	279092
13635	15513	1	applied	\N	\N	\N	\N	111371	111371	279094
13635	15521	9	applied	\N	\N	\N	\N	111379	111379	279102
13636	15514	2	applied	\N	\N	\N	\N	111386	111386	279109
13636	15524	12	applied	\N	\N	\N	\N	111396	111396	279119
13637	15522	10	applied	\N	\N	\N	\N	111408	111408	279131
13640	15533	7	applied	\N	\N	\N	\N	111437	111437	279160
13641	15545	3	applied	\N	\N	\N	\N	111449	111449	279172
13647	15551	1	applied	\N	\N	\N	\N	111467	111467	279190
13657	14206	22	applied	\N	\N	\N	\N	111509	111509	279231
13657	14227	32	applied	\N	\N	\N	\N	111519	111519	279241
13657	14172	49	applied	\N	\N	\N	\N	111536	111536	279257
13657	14252	66	applied	\N	\N	\N	\N	111553	111553	279274
13657	14314	84	applied	\N	\N	\N	\N	111570	111570	279291
13657	14371	101	applied	\N	\N	\N	\N	111587	111587	279308
13657	14397	106	applied	\N	\N	\N	\N	111592	111592	279313
13657	14404	107	applied	\N	\N	\N	\N	111593	111593	279314
13657	14463	124	applied	\N	\N	\N	\N	111610	111610	279331
13659	15573	9	applied	\N	\N	\N	\N	111621	111621	279342
13660	15566	6	applied	\N	\N	\N	\N	111632	111632	279353
13662	15579	1	applied	\N	\N	\N	\N	111654	111654	279375
13663	15589	12	applied	\N	\N	\N	\N	111682	111682	279403
13664	15580	2	applied	\N	\N	\N	\N	111689	111689	279410
13666	15595	1	applied	\N	\N	\N	\N	111704	111704	279425
13675	15605	0	applied	\N	\N	\N	\N	111726	111726	279447
13681	15615	1	applied	\N	\N	\N	\N	111744	111744	279465
13682	15615	1	applied	\N	\N	\N	\N	111746	111746	279467
13692	15629	0	applied	\N	\N	\N	\N	111770	111770	279491
13694	15418	30	applied	\N	\N	\N	\N	111808	111808	279527
13694	15388	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	111780	111780	\N
13694	15511	55	applied	\N	\N	\N	\N	111832	111832	279551
13694	15569	72	applied	\N	\N	\N	\N	111849	111849	279568
13694	15597	79	applied	\N	\N	\N	\N	111856	111856	279575
13694	15605	82	applied	\N	\N	\N	\N	111859	111859	279578
13698	15641	0	applied	\N	\N	\N	\N	111876	111876	279595
13708	15662	3	applied	\N	\N	\N	\N	111918	111918	279636
13711	15665	2	applied	\N	\N	\N	\N	111929	111929	279647
13714	15672	5	applied	\N	\N	\N	\N	111949	111949	279667
13716	15688	3	applied	\N	\N	\N	\N	111965	111965	279683
13719	15703	2	applied	\N	\N	\N	\N	111984	111984	279702
13721	15707	2	applied	\N	\N	\N	\N	111992	111992	279710
13722	15706	1	applied	\N	\N	\N	\N	111995	111995	279713
13729	15725	6	applied	\N	\N	\N	\N	112030	112030	279748
13736	15739	1	applied	\N	\N	\N	\N	112055	112055	279773
13739	15741	0	applied	\N	\N	\N	\N	112064	112064	279782
13741	15758	13	applied	\N	\N	\N	\N	112085	112085	279803
13742	15745	0	applied	\N	\N	\N	\N	112092	112092	279810
13742	15762	17	applied	\N	\N	\N	\N	112109	112109	279827
13445	15111	6	applied	\N	\N	\N	\N	110344	110344	278073
13745	15749	4	applied	\N	\N	\N	\N	112156	112156	279874
13748	15775	6	applied	\N	\N	\N	\N	112168	112168	279886
13749	15770	1	applied	\N	\N	\N	\N	112170	112170	279888
13751	15776	0	applied	\N	\N	\N	\N	112183	112183	279901
13756	15801	6	applied	\N	\N	\N	\N	112212	112212	279930
13757	15800	5	applied	\N	\N	\N	\N	112219	112219	279937
13763	15809	2	applied	\N	\N	\N	\N	112248	112248	279966
13764	15810	3	applied	\N	\N	\N	\N	112253	112253	279971
13767	15816	1	applied	\N	\N	\N	\N	112263	112263	279981
13772	15833	2	applied	\N	\N	\N	\N	112289	112289	280007
13773	15833	2	applied	\N	\N	\N	\N	112293	112293	280011
13776	15848	13	applied	\N	\N	\N	\N	112308	112308	280026
13781	15647	19	applied	\N	\N	\N	\N	112346	112346	280064
13781	15705	36	applied	\N	\N	\N	\N	112363	112363	280081
13781	15815	64	applied	\N	\N	\N	\N	112390	112390	280108
13781	15631	81	applied	\N	\N	\N	\N	112407	112407	280125
13781	15638	85	applied	\N	\N	\N	\N	112411	112411	280129
13781	15644	88	applied	\N	\N	\N	\N	112414	112414	280132
13781	15673	105	applied	\N	\N	\N	\N	112431	112431	280149
13781	15698	122	applied	\N	\N	\N	\N	112448	112448	280166
13783	15855	0	applied	\N	\N	\N	\N	112456	112456	280174
13787	15873	7	applied	\N	\N	\N	\N	112488	112488	280206
13788	15867	1	applied	\N	\N	\N	\N	112490	112490	280208
13790	15877	3	applied	\N	\N	\N	\N	112508	112508	280226
13792	15874	0	applied	\N	\N	\N	\N	112514	112514	280232
13792	15877	3	applied	\N	\N	\N	\N	112517	112517	280235
13801	15894	2	applied	\N	\N	\N	\N	112552	112552	280270
13804	15909	3	applied	\N	\N	\N	\N	112571	112571	280289
13805	15906	0	applied	\N	\N	\N	\N	112573	112573	280291
13810	15922	4	applied	\N	\N	\N	\N	112599	112599	280317
13814	15924	1	applied	\N	\N	\N	\N	112622	112622	280340
13816	15937	4	applied	\N	\N	\N	\N	112630	112630	280348
13820	15952	0	applied	\N	\N	\N	\N	112664	112664	280382
13821	15956	4	applied	\N	\N	\N	\N	112675	112675	280393
13826	15972	6	applied	\N	\N	\N	\N	112701	112701	280419
13827	15989	11	applied	\N	\N	\N	\N	112718	112718	280436
13830	15997	2	applied	\N	\N	\N	\N	112726	112726	280444
13830	16012	17	applied	\N	\N	\N	\N	112741	112741	280459
13830	16013	18	applied	\N	\N	\N	\N	112742	112742	280460
13831	15997	2	applied	\N	\N	\N	\N	112749	112749	280467
13832	16002	2	applied	\N	\N	\N	\N	112755	112755	280473
13832	16020	19	applied	\N	\N	\N	\N	112772	112772	280490
13837	15883	12	applied	\N	\N	\N	\N	112796	112796	280514
13837	15952	29	applied	\N	\N	\N	\N	112813	112813	280531
13837	16022	46	applied	\N	\N	\N	\N	112830	112830	280548
13837	15858	63	applied	\N	\N	\N	\N	112847	112847	280565
13837	15877	78	applied	\N	\N	\N	\N	112862	112862	280580
13837	15926	113	applied	\N	\N	\N	\N	112897	112897	280615
13838	16008	9	applied	\N	\N	\N	\N	112919	112919	280637
13839	16029	4	applied	\N	\N	\N	\N	112934	112934	280652
13840	16039	7	applied	\N	\N	\N	\N	112944	112944	280662
13843	16046	5	applied	\N	\N	\N	\N	112967	112967	280685
13845	16044	3	applied	\N	\N	\N	\N	112985	112985	280703
13846	16051	10	applied	\N	\N	\N	\N	112997	112997	280715
13846	16054	13	applied	\N	\N	\N	\N	113000	113000	280718
13848	16055	11	applied	\N	\N	\N	\N	113027	113027	280745
13851	16064	6	applied	\N	\N	\N	\N	113040	113040	280758
13852	16061	0	applied	\N	\N	\N	\N	113041	113041	280759
13859	16086	1	applied	\N	\N	\N	\N	113086	113086	280804
13862	16090	4	applied	\N	\N	\N	\N	113098	113098	280816
13864	16093	0	applied	\N	\N	\N	\N	113102	113102	280820
13865	16098	1	applied	\N	\N	\N	\N	113113	113113	280831
13866	16102	1	applied	\N	\N	\N	\N	113117	113117	280835
13867	16108	0	applied	\N	\N	\N	\N	113123	113123	280841
13875	16131	4	applied	\N	\N	\N	\N	113169	113169	280887
13876	16141	1	applied	\N	\N	\N	\N	113180	113180	280898
13882	16149	1	applied	\N	\N	\N	\N	113206	113206	280924
13882	16151	18	applied	\N	\N	\N	\N	113223	113223	280941
13884	16155	6	applied	\N	\N	\N	\N	113237	113237	280955
13888	16169	2	applied	\N	\N	\N	\N	113257	113257	280975
13893	16178	5	applied	\N	\N	\N	\N	113274	113274	280992
13893	16181	8	applied	\N	\N	\N	\N	113277	113277	280995
13894	16184	11	applied	\N	\N	\N	\N	113294	113294	281012
13896	16184	11	applied	\N	\N	\N	\N	113322	113322	281040
13897	16176	0	applied	\N	\N	\N	\N	113325	113325	281043
13898	16184	14	applied	\N	\N	\N	\N	113341	113341	281059
13899	16185	15	applied	\N	\N	\N	\N	113373	113373	281091
13899	16195	20	applied	\N	\N	\N	\N	113378	113378	281096
13899	16198	23	applied	\N	\N	\N	\N	113381	113381	281099
13900	16182	12	applied	\N	\N	\N	\N	113401	113401	281119
13901	16187	0	applied	\N	\N	\N	\N	113406	113406	281124
13901	16192	17	applied	\N	\N	\N	\N	113423	113423	281141
13902	16195	20	applied	\N	\N	\N	\N	113457	113457	281175
13903	16186	16	applied	\N	\N	\N	\N	113484	113484	281202
13907	16218	4	applied	\N	\N	\N	\N	113501	113501	281219
13910	16225	3	applied	\N	\N	\N	\N	113518	113518	281236
13916	16229	4	applied	\N	\N	\N	\N	113534	113534	281252
13920	16236	9	applied	\N	\N	\N	\N	113548	113548	281266
13929	16242	0	applied	\N	\N	\N	\N	113575	113575	281293
13932	16251	2	applied	\N	\N	\N	\N	113586	113586	281304
13934	16262	2	applied	\N	\N	\N	\N	113597	113597	281315
13941	16263	3	applied	\N	\N	\N	\N	113616	113616	281334
13943	16270	2	applied	\N	\N	\N	\N	113626	113626	281344
13945	16277	1	applied	\N	\N	\N	\N	113633	113633	281351
13949	16286	2	applied	\N	\N	\N	\N	113647	113647	281365
13951	16288	0	applied	\N	\N	\N	\N	113653	113653	281371
13953	16291	2	applied	\N	\N	\N	\N	113657	113657	281375
13955	16302	3	applied	\N	\N	\N	\N	113668	113668	281386
13962	16329	11	applied	\N	\N	\N	\N	113711	113711	281429
13962	16346	28	applied	\N	\N	\N	\N	113728	113728	281446
13963	16329	11	applied	\N	\N	\N	\N	113740	113740	281458
13965	16348	1	applied	\N	\N	\N	\N	113756	113756	281474
13967	16351	0	applied	\N	\N	\N	\N	113760	113760	281478
13972	16365	1	applied	\N	\N	\N	\N	113793	113793	281511
13974	16368	4	applied	\N	\N	\N	\N	113806	113806	281524
13976	16374	2	applied	\N	\N	\N	\N	113816	113816	281534
13980	16381	3	applied	\N	\N	\N	\N	113841	113841	281559
13981	16382	4	applied	\N	\N	\N	\N	113858	113858	281576
13981	16392	12	applied	\N	\N	\N	\N	113866	113866	281584
13982	16383	6	applied	\N	\N	\N	\N	113876	113876	281594
13988	16413	3	applied	\N	\N	\N	\N	113905	113905	281623
13744	15753	8	applied	\N	\N	\N	\N	112140	112140	279858
13996	16434	3	applied	\N	\N	\N	\N	113943	113943	281661
14000	16416	0	applied	\N	\N	\N	\N	113963	113963	281681
14001	16448	7	applied	\N	\N	\N	\N	113975	113975	281693
14004	16470	10	applied	\N	\N	\N	\N	113997	113997	281714
14009	16491	0	applied	\N	\N	\N	\N	114036	114036	281753
14010	16494	2	applied	\N	\N	\N	\N	114040	114040	281757
14016	16512	3	applied	\N	\N	\N	\N	114069	114069	281786
14018	16270	13	applied	\N	\N	\N	\N	114085	114085	281802
14020	16519	4	applied	\N	\N	\N	\N	114093	114093	281809
14022	16524	9	applied	\N	\N	\N	\N	114118	114118	281834
14023	16517	1	applied	\N	\N	\N	\N	114120	114120	281836
14030	16532	1	applied	\N	\N	\N	\N	114160	114160	281876
14031	16530	0	applied	\N	\N	\N	\N	114165	114165	281881
14040	16549	3	applied	\N	\N	\N	\N	114195	114195	281911
14041	16549	3	applied	\N	\N	\N	\N	114203	114203	281919
14042	16555	1	applied	\N	\N	\N	\N	114209	114209	281925
14045	16566	10	applied	\N	\N	\N	\N	114236	114236	281950
14052	16570	3	applied	\N	\N	\N	\N	114290	114290	281999
14050	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114271	114271	\N
14057	16581	0	applied	\N	\N	\N	\N	114310	114310	282019
14061	16595	3	applied	\N	\N	\N	\N	114335	114335	282044
14064	16593	1	applied	\N	\N	\N	\N	114338	114338	282047
14071	16460	0	applied	\N	\N	\N	\N	114358	114358	282067
14077	16611	3	applied	\N	\N	\N	\N	114382	114382	282089
14077	16615	7	applied	\N	\N	\N	\N	114386	114386	282093
14083	16616	0	applied	\N	\N	\N	\N	114387	114387	282094
14088	16623	1	applied	\N	\N	\N	\N	114427	114427	282134
14088	16626	4	applied	\N	\N	\N	\N	114430	114430	282137
14089	16631	0	applied	\N	\N	\N	\N	114435	114435	282142
14091	16632	1	applied	\N	\N	\N	\N	114441	114441	282148
14096	16637	5	applied	\N	\N	\N	\N	114463	114463	282170
14098	16634	3	applied	\N	\N	\N	\N	114477	114477	282184
14110	16658	1	applied	\N	\N	\N	\N	114522	114522	282228
14103	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114494	114494	\N
14115	16671	12	applied	\N	\N	\N	\N	114548	114548	282254
14117	16680	2	applied	\N	\N	\N	\N	114557	114557	282263
14125	16692	2	applied	\N	\N	\N	\N	114582	114582	282288
14126	16690	0	applied	\N	\N	\N	\N	114584	114584	282290
14129	16666	12	applied	\N	\N	\N	\N	114606	114606	282312
14129	16667	13	applied	\N	\N	\N	\N	114607	114607	282313
14129	16688	30	applied	\N	\N	\N	\N	114624	114624	282330
14131	16701	8	applied	\N	\N	\N	\N	114642	114642	282348
14133	16697	3	applied	\N	\N	\N	\N	114660	114660	282366
14137	16696	2	applied	\N	\N	\N	\N	114695	114695	282401
14140	16109	15	applied	\N	\N	\N	\N	114732	114732	282437
14140	16562	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	114719	114719	\N
14140	16176	32	applied	\N	\N	\N	\N	114749	114749	282454
14140	16238	47	applied	\N	\N	\N	\N	114764	114764	282469
14140	16249	50	applied	\N	\N	\N	\N	114767	114767	282472
14140	16318	67	applied	\N	\N	\N	\N	114784	114784	282489
14140	16388	85	applied	\N	\N	\N	\N	114801	114801	282506
14140	16459	102	applied	\N	\N	\N	\N	114818	114818	282523
14140	16531	119	applied	\N	\N	\N	\N	114835	114835	282540
14142	16708	0	applied	\N	\N	\N	\N	114848	114848	282553
14144	16713	5	applied	\N	\N	\N	\N	114865	114865	282570
14149	16715	1	applied	\N	\N	\N	\N	114883	114883	282588
14160	16730	1	applied	\N	\N	\N	\N	114910	114910	282615
14161	16732	0	applied	\N	\N	\N	\N	114912	114912	282617
14164	16740	0	applied	\N	\N	\N	\N	114923	114923	282628
14170	16756	3	applied	\N	\N	\N	\N	114945	114945	282650
14171	16764	1	applied	\N	\N	\N	\N	114953	114953	282658
14174	16772	0	applied	\N	\N	\N	\N	114965	114965	282670
14178	16781	1	applied	\N	\N	\N	\N	114984	114984	282689
14179	16784	4	applied	\N	\N	\N	\N	114989	114989	282694
14186	16785	4	applied	\N	\N	\N	\N	115019	115019	282724
14188	16788	3	applied	\N	\N	\N	\N	115027	115027	282732
14196	16802	3	applied	\N	\N	\N	\N	115055	115055	282760
14199	16809	0	applied	\N	\N	\N	\N	115063	115063	282768
14203	16828	1	applied	\N	\N	\N	\N	115082	115082	282787
14205	16828	1	applied	\N	\N	\N	\N	115092	115092	282797
14208	16843	1	applied	\N	\N	\N	\N	115113	115113	282818
14210	16848	2	applied	\N	\N	\N	\N	115122	115122	282827
14212	16855	1	applied	\N	\N	\N	\N	115129	115129	282834
14215	16858	0	applied	\N	\N	\N	\N	115150	115150	282855
14221	16879	3	applied	\N	\N	\N	\N	115179	115179	282884
14225	16890	7	applied	\N	\N	\N	\N	115200	115200	282905
14230	16903	2	applied	\N	\N	\N	\N	115221	115221	282926
14236	16910	1	applied	\N	\N	\N	\N	115244	115244	282949
14240	16918	4	applied	\N	\N	\N	\N	115266	115266	282971
14244	16932	0	applied	\N	\N	\N	\N	115283	115283	282988
14247	16946	7	applied	\N	\N	\N	\N	115300	115300	283005
14251	16963	5	applied	\N	\N	\N	\N	115317	115317	283022
14253	16964	6	applied	\N	\N	\N	\N	115334	115334	283039
14256	16962	3	applied	\N	\N	\N	\N	115349	115349	283054
14256	16965	6	applied	\N	\N	\N	\N	115352	115352	283057
14257	16970	0	applied	\N	\N	\N	\N	115356	115356	283061
14257	16973	3	applied	\N	\N	\N	\N	115359	115359	283064
14258	16974	0	applied	\N	\N	\N	\N	115360	115360	283065
14260	16978	0	applied	\N	\N	\N	\N	115368	115368	283073
14260	16981	3	applied	\N	\N	\N	\N	115371	115371	283076
14263	16654	9	applied	\N	\N	\N	\N	115389	115389	283094
14263	16773	43	applied	\N	\N	\N	\N	115423	115423	283128
14263	16835	60	applied	\N	\N	\N	\N	115440	115440	283145
14263	16901	77	applied	\N	\N	\N	\N	115457	115457	283162
14263	16970	94	applied	\N	\N	\N	\N	115474	115474	283179
14263	16642	112	applied	\N	\N	\N	\N	115491	115491	283196
14263	16646	115	applied	\N	\N	\N	\N	115494	115494	283199
14266	16997	6	applied	\N	\N	\N	\N	115519	115519	283224
14267	17001	10	applied	\N	\N	\N	\N	115535	115535	283240
14270	17003	0	applied	\N	\N	\N	\N	115550	115550	283255
14275	17017	2	applied	\N	\N	\N	\N	115578	115578	283283
14277	17023	5	applied	\N	\N	\N	\N	115590	115590	283295
14281	17037	3	applied	\N	\N	\N	\N	115620	115620	283325
14282	17020	2	applied	\N	\N	\N	\N	115627	115627	283332
14282	16694	19	applied	\N	\N	\N	\N	115644	115644	283349
14282	16747	36	applied	\N	\N	\N	\N	115661	115661	283366
14282	16809	53	applied	\N	\N	\N	\N	115678	115678	283383
14282	16940	87	applied	\N	\N	\N	\N	115712	115712	283417
14282	16947	88	applied	\N	\N	\N	\N	115713	115713	283418
13995	16425	4	applied	\N	\N	\N	\N	113939	113939	281657
14285	17052	2	applied	\N	\N	\N	\N	115758	115758	283463
14288	17050	0	applied	\N	\N	\N	\N	115768	115768	283473
14297	17071	4	applied	\N	\N	\N	\N	115812	115812	283517
14298	17077	1	applied	\N	\N	\N	\N	115818	115818	283523
14299	17084	4	applied	\N	\N	\N	\N	115825	115825	283530
14300	17021	3	applied	\N	\N	\N	\N	115832	115832	283537
14300	17072	4	applied	\N	\N	1000000000	\N	115833	115833	283538
14301	17089	1	applied	\N	\N	\N	\N	115835	115835	283540
14301	17090	2	applied	\N	\N	\N	\N	115836	115836	283541
14302	17090	2	applied	\N	\N	\N	\N	115839	115839	283544
14302	17091	3	applied	\N	\N	\N	\N	115840	115840	283545
14302	17092	4	applied	\N	\N	\N	\N	115841	115841	283546
14302	17093	5	applied	\N	\N	\N	\N	115842	115842	283547
14302	17094	6	applied	\N	\N	\N	\N	115843	115843	283548
14302	17095	7	applied	\N	\N	\N	\N	115844	115844	283549
14302	17096	8	applied	\N	\N	\N	\N	115845	115845	283550
14302	17097	9	applied	\N	\N	\N	\N	115846	115846	283551
14302	17098	10	applied	\N	\N	\N	\N	115847	115847	283552
14303	17091	3	applied	\N	\N	\N	\N	115852	115852	283557
14303	17092	4	applied	\N	\N	\N	\N	115853	115853	283558
14303	17093	5	applied	\N	\N	\N	\N	115854	115854	283559
14303	17094	6	applied	\N	\N	\N	\N	115855	115855	283560
14303	17095	7	applied	\N	\N	\N	\N	115856	115856	283561
14303	17096	8	applied	\N	\N	\N	\N	115857	115857	283562
14303	17097	9	applied	\N	\N	\N	\N	115858	115858	283563
14303	17098	10	applied	\N	\N	\N	\N	115859	115859	283564
14303	17099	11	applied	\N	\N	\N	\N	115860	115860	283565
14304	17020	3	applied	\N	\N	\N	\N	115864	115864	283569
14304	17021	4	applied	\N	\N	\N	\N	115865	115865	283570
14304	16987	5	applied	\N	\N	\N	\N	115866	115866	283571
14304	16991	6	applied	\N	\N	\N	\N	115867	115867	283572
14304	16992	7	applied	\N	\N	\N	\N	115868	115868	283573
14304	16993	8	applied	\N	\N	\N	\N	115869	115869	283574
14304	16723	77	applied	\N	\N	\N	\N	115938	115938	283643
14304	16769	111	applied	\N	\N	1000000000	\N	115971	115971	283676
14310	17119	2	applied	\N	\N	\N	\N	116019	116019	283724
14316	17125	1	applied	\N	\N	\N	\N	116038	116038	283743
14326	17143	1	applied	\N	\N	\N	\N	116078	116078	283783
14333	17164	3	applied	\N	\N	1000000000	\N	116104	116104	283809
14338	17188	3	applied	\N	\N	\N	\N	116132	116132	283837
14340	17199	2	applied	\N	\N	\N	\N	116143	116143	283848
14342	17205	4	applied	\N	\N	\N	\N	116153	116153	283858
14345	17215	7	applied	\N	\N	\N	\N	116177	116177	283882
14346	17208	0	applied	\N	\N	\N	\N	116178	116178	283883
14348	17020	9	applied	\N	\N	\N	\N	116199	116199	283903
14348	16647	26	applied	\N	\N	\N	\N	116216	116216	283920
14348	16709	43	applied	\N	\N	\N	\N	116233	116233	283937
14348	16767	60	applied	\N	\N	\N	\N	116250	116250	283954
14348	16827	78	applied	\N	\N	\N	\N	116267	116267	283971
14348	16893	95	applied	\N	\N	\N	\N	116284	116284	283988
14348	16920	101	applied	\N	\N	\N	\N	116290	116290	283994
14348	16987	118	applied	\N	\N	\N	\N	116307	116307	284011
14349	17220	0	applied	\N	\N	\N	\N	116315	116315	284019
14352	17233	3	applied	\N	\N	\N	\N	116335	116335	284039
14353	17236	2	applied	\N	\N	\N	\N	116338	116338	284042
14356	17245	6	applied	\N	\N	\N	\N	116351	116351	284055
14362	16799	11	applied	\N	\N	\N	\N	116386	116386	284090
14362	16858	28	applied	\N	\N	\N	\N	116402	116402	284106
14362	16862	29	applied	\N	\N	\N	\N	116403	116403	284107
14362	16932	46	applied	\N	\N	\N	\N	116420	116420	284124
14362	16993	63	applied	\N	\N	\N	\N	116437	116437	284141
14362	17068	80	applied	\N	\N	\N	\N	116454	116454	284158
14362	17132	97	applied	\N	\N	\N	\N	116471	116471	284175
14362	17201	114	applied	\N	\N	\N	\N	116488	116488	284192
14364	17057	10	applied	\N	\N	\N	\N	116514	116514	284218
14364	17124	27	applied	\N	\N	\N	\N	116531	116531	284235
14364	16636	61	applied	\N	\N	\N	\N	116565	116565	284269
14364	16576	79	applied	\N	\N	\N	\N	116582	116582	284286
14364	16587	87	applied	\N	\N	\N	\N	116590	116590	284294
14364	16610	104	applied	\N	\N	\N	\N	116607	116607	284311
14364	16630	121	applied	\N	\N	\N	\N	116624	116624	284328
14365	17254	3	applied	\N	\N	1000000000	\N	116632	116632	284336
14376	17019	3	applied	\N	\N	\N	\N	116657	116657	284361
14376	16753	20	applied	\N	\N	\N	\N	116674	116674	284378
14376	16813	37	applied	\N	\N	\N	\N	116691	116691	284395
14376	16883	54	applied	\N	\N	\N	\N	116708	116708	284412
14376	16951	71	applied	\N	\N	\N	\N	116725	116725	284429
14376	17022	88	applied	\N	\N	\N	\N	116742	116742	284446
14376	17081	103	applied	\N	\N	\N	\N	116757	116757	284461
14376	17090	106	applied	\N	\N	\N	\N	116760	116760	284464
14376	17157	124	applied	\N	\N	\N	\N	116777	116777	284481
14377	16499	31	applied	\N	\N	\N	\N	116810	116810	284513
14377	16567	49	applied	\N	\N	\N	\N	116827	116827	284530
14379	17267	0	applied	\N	\N	\N	\N	116849	116849	284552
14379	17268	3	applied	\N	\N	\N	\N	116852	116852	284555
14381	17274	9	applied	\N	\N	\N	\N	116870	116870	284573
14384	17288	3	applied	\N	\N	\N	\N	116884	116884	284587
14385	17286	1	applied	\N	\N	\N	\N	116888	116888	284591
14385	17287	2	applied	\N	\N	\N	\N	116889	116889	284592
14389	17300	6	applied	\N	\N	\N	\N	116908	116908	284611
14398	17320	0	applied	\N	\N	\N	\N	116934	116934	284637
14404	17019	2	applied	\N	\N	\N	\N	116956	116956	284659
14408	17330	0	applied	\N	\N	\N	\N	116966	116966	284669
14412	17343	10	applied	\N	\N	\N	\N	116982	116982	284685
14414	17355	9	applied	\N	\N	\N	\N	116998	116998	284699
14415	17361	9	applied	\N	\N	\N	\N	117011	117011	284712
14417	17364	2	applied	\N	\N	\N	\N	117017	117017	284718
14430	16674	7	applied	\N	\N	\N	\N	117061	117061	284761
14430	16732	24	applied	\N	\N	\N	\N	117078	117078	284778
14430	16743	27	applied	\N	\N	\N	\N	117081	117081	284781
14430	16752	30	applied	\N	\N	\N	\N	117084	117084	284784
14432	17396	7	applied	\N	\N	\N	\N	117107	117107	284807
14433	17401	1	applied	\N	\N	\N	\N	117112	117112	284812
14435	17404	2	applied	\N	\N	\N	\N	117122	117122	284822
14439	17422	3	applied	\N	\N	\N	\N	117141	117141	284841
14441	17431	2	applied	\N	\N	\N	\N	117150	117150	284850
14448	17447	5	applied	\N	\N	\N	\N	117183	117183	284882
14457	17468	0	applied	\N	\N	\N	\N	117213	117213	284912
14459	17480	1	applied	\N	\N	\N	\N	117225	117225	284924
14466	17487	0	applied	\N	\N	\N	\N	117249	117249	284948
14283	17048	12	applied	\N	\N	\N	\N	115750	115750	283455
14475	17400	0	applied	\N	\N	\N	\N	117308	117308	285007
14477	17508	2	applied	\N	\N	\N	\N	117311	117311	285010
14478	17521	0	applied	\N	\N	\N	\N	117314	117314	285013
14486	17545	0	applied	\N	\N	\N	\N	117352	117352	285051
14486	17546	1	applied	\N	\N	\N	\N	117353	117353	285052
14488	17020	3	applied	\N	\N	\N	\N	117363	117363	285062
14488	17021	4	applied	\N	\N	\N	\N	117364	117364	285063
14490	17564	11	applied	\N	\N	\N	\N	117386	117386	285084
14491	17554	0	applied	\N	\N	\N	\N	117392	117392	285090
14492	17282	11	applied	\N	\N	\N	\N	117420	117420	285118
14492	17333	29	applied	\N	\N	\N	\N	117437	117437	285135
14495	17570	0	applied	\N	\N	\N	\N	117462	117462	285160
14497	17574	0	applied	\N	\N	\N	\N	117469	117469	285166
14504	17587	3	applied	\N	\N	\N	\N	117498	117498	285195
14505	17589	1	applied	\N	\N	\N	\N	117500	117500	285197
14506	17610	6	applied	\N	\N	\N	\N	117524	117524	285221
14510	17617	0	applied	\N	\N	\N	\N	117532	117532	285229
14510	17618	1	applied	\N	\N	\N	\N	117533	117533	285230
14520	17632	1	applied	\N	\N	\N	\N	117577	117577	285274
14521	17636	3	applied	\N	\N	\N	\N	117581	117581	285278
14524	17647	3	applied	\N	\N	\N	\N	117592	117592	285289
14538	17669	1	applied	\N	\N	\N	\N	117626	117626	285323
14540	17680	2	applied	\N	\N	\N	\N	117637	117637	285334
14542	17681	0	applied	\N	\N	\N	\N	117644	117644	285341
14545	17691	2	applied	\N	\N	\N	\N	117660	117660	285357
14547	17699	6	applied	\N	\N	\N	\N	117672	117672	285369
14548	17701	8	applied	\N	\N	\N	\N	117686	117686	285383
14555	17716	1	applied	\N	\N	\N	\N	117727	117727	285424
14556	17717	2	applied	\N	\N	\N	\N	117731	117731	285428
14561	17724	0	applied	\N	\N	\N	\N	117741	117741	285438
14562	17550	15	applied	\N	\N	\N	\N	117758	117758	285455
14562	17664	50	applied	\N	\N	\N	\N	117792	117792	285489
14562	17707	67	applied	\N	\N	\N	\N	117809	117809	285506
14562	17514	83	applied	\N	\N	\N	\N	117825	117825	285522
14562	17515	84	applied	\N	\N	\N	\N	117826	117826	285523
14562	17537	101	applied	\N	\N	\N	\N	117843	117843	285540
14562	17562	118	applied	\N	\N	\N	\N	117860	117860	285557
14571	17733	0	applied	\N	\N	\N	\N	117899	117899	285596
14575	17742	1	applied	\N	\N	\N	\N	117912	117912	285609
14577	17743	0	applied	\N	\N	\N	\N	117915	117915	285612
14588	17756	2	applied	\N	\N	\N	\N	117935	117935	285632
14596	17764	1	applied	\N	\N	\N	\N	117958	117958	285655
14603	17770	1	applied	\N	\N	\N	\N	117976	117976	285673
14604	17773	1	applied	\N	\N	\N	\N	117979	117979	285676
14609	17787	6	applied	\N	\N	\N	\N	117998	117998	285695
14609	17790	9	applied	\N	\N	\N	\N	118001	118001	285698
14612	17796	2	applied	\N	\N	\N	\N	118018	118018	285715
14617	17800	0	applied	\N	\N	\N	\N	118031	118031	285728
14627	17821	3	applied	\N	\N	\N	\N	118067	118067	285764
14628	17824	0	applied	\N	\N	\N	\N	118070	118070	285767
14629	17829	2	applied	\N	\N	\N	\N	118075	118075	285772
14633	17832	2	applied	\N	\N	\N	\N	118093	118093	285790
14638	17841	2	applied	\N	\N	\N	\N	118114	118114	285811
14642	17420	13	applied	\N	\N	\N	\N	118137	118137	285834
14642	17433	16	applied	\N	\N	\N	\N	118140	118140	285837
14642	17506	33	applied	\N	\N	\N	\N	118157	118157	285854
14642	17570	50	applied	\N	\N	\N	\N	118174	118174	285871
14642	17633	68	applied	\N	\N	\N	\N	118191	118191	285888
14642	17673	85	applied	\N	\N	\N	\N	118208	118208	285905
14642	17724	102	applied	\N	\N	\N	\N	118225	118225	285922
14642	17772	119	applied	\N	\N	\N	\N	118242	118242	285939
14644	17852	3	applied	\N	\N	\N	\N	118254	118254	285951
14648	17800	3	applied	\N	\N	\N	\N	118275	118275	285972
14648	17382	23	applied	\N	\N	\N	\N	118295	118295	285992
14648	17404	40	applied	\N	\N	\N	\N	118312	118312	286009
14648	17428	57	applied	\N	\N	\N	\N	118329	118329	286026
14648	17448	75	applied	\N	\N	\N	\N	118346	118346	286043
14648	17471	92	applied	\N	\N	\N	\N	118363	118363	286060
14648	17494	109	applied	\N	\N	\N	\N	118380	118380	286077
14648	17516	124	applied	\N	\N	\N	\N	118395	118395	286092
14649	17872	6	applied	\N	\N	\N	\N	118402	118402	286099
14650	17874	1	applied	\N	\N	\N	\N	118404	118404	286101
14654	17875	2	applied	\N	\N	\N	\N	118417	118417	286114
14657	17876	0	applied	\N	\N	\N	\N	118421	118421	286118
14666	17899	6	applied	\N	\N	\N	\N	118463	118463	286160
14667	17916	15	applied	\N	\N	\N	\N	118480	118480	286177
14668	17931	6	applied	\N	\N	\N	\N	118495	118495	286192
14668	17932	7	applied	\N	\N	\N	\N	118496	118496	286193
14670	17932	7	applied	\N	\N	\N	\N	118511	118511	286208
14672	17942	1	applied	\N	\N	\N	\N	118523	118523	286220
14673	17956	15	applied	\N	\N	\N	\N	118540	118540	286237
14674	17949	8	applied	\N	\N	\N	\N	118557	118557	286254
14675	17948	7	applied	\N	\N	\N	\N	118580	118580	286277
14676	17949	8	applied	\N	\N	\N	\N	118605	118605	286302
14677	17942	1	applied	\N	\N	\N	\N	118622	118622	286319
14677	17959	18	applied	\N	\N	\N	\N	118639	118639	286336
14678	17965	0	applied	\N	\N	\N	\N	118645	118645	286342
14679	17982	1	applied	\N	\N	\N	\N	118662	118662	286359
14679	17999	18	applied	\N	\N	\N	\N	118679	118679	286376
14679	18002	21	applied	\N	\N	\N	\N	118682	118682	286379
14680	17907	13	applied	\N	\N	\N	\N	118698	118698	286395
14680	17927	30	applied	\N	\N	\N	\N	118715	118715	286412
14680	17929	31	applied	\N	\N	\N	\N	118716	118716	286413
14681	17992	11	applied	\N	\N	\N	\N	118729	118729	286426
14682	17982	1	applied	\N	\N	\N	\N	118743	118743	286440
14683	17908	14	applied	\N	\N	\N	\N	118780	118780	286477
14686	18012	1	applied	\N	\N	\N	\N	118815	118815	286512
14687	18016	2	applied	\N	\N	\N	\N	118819	118819	286516
14693	18027	0	applied	\N	\N	\N	\N	118851	118851	286548
14695	18029	0	applied	\N	\N	\N	\N	118857	118857	286554
14699	18035	0	applied	\N	\N	\N	\N	118867	118867	286564
14700	17907	13	applied	\N	\N	\N	\N	118882	118882	286579
14700	17927	30	applied	\N	\N	\N	\N	118899	118899	286596
14700	17951	47	applied	\N	\N	\N	\N	118916	118916	286613
14700	17970	62	applied	\N	\N	\N	\N	118931	118931	286628
14709	18052	2	applied	\N	\N	\N	\N	118964	118964	286661
14710	18053	3	applied	\N	\N	\N	\N	118971	118971	286668
14711	17705	0	applied	\N	\N	1000000000	\N	118974	118974	286671
14711	17728	21	applied	\N	\N	\N	\N	118995	118995	286692
14711	17734	25	applied	\N	\N	\N	\N	118998	118998	286695
14711	17915	42	applied	\N	\N	\N	\N	119015	119015	286712
14711	17986	93	applied	\N	\N	\N	\N	119066	119066	286763
14711	18007	110	applied	\N	\N	\N	\N	119083	119083	286780
14712	17907	14	applied	\N	\N	\N	\N	119113	119113	286810
14712	17927	31	applied	\N	\N	\N	\N	119130	119130	286827
14714	18057	1	applied	\N	\N	\N	\N	119136	119136	286833
14719	18071	1	applied	\N	\N	\N	\N	119162	119162	286859
14721	18076	0	applied	\N	\N	\N	\N	119167	119167	286864
14726	18079	0	applied	\N	\N	\N	\N	119176	119176	286873
14726	18081	2	applied	\N	\N	\N	\N	119178	119178	286875
14726	18082	3	applied	\N	\N	\N	\N	119179	119179	286876
14736	18096	3	applied	\N	\N	\N	\N	119219	119219	286916
14745	17705	0	applied	\N	\N	1000000000	\N	119246	119246	286943
14745	17914	21	applied	\N	\N	\N	\N	119267	119267	286964
14745	17937	38	applied	\N	\N	\N	\N	119284	119284	286981
14745	17958	56	applied	\N	\N	\N	\N	119301	119301	286998
14745	17985	73	applied	\N	\N	\N	\N	119318	119318	287015
14745	18005	90	applied	\N	\N	\N	\N	119335	119335	287032
14746	18111	0	applied	\N	\N	\N	\N	119346	119346	287043
14755	18127	0	applied	\N	\N	\N	\N	119366	119366	287063
14757	18131	0	applied	\N	\N	\N	\N	119370	119370	287067
14764	18141	3	applied	\N	\N	\N	\N	119389	119389	287086
14770	18151	1	applied	\N	\N	\N	\N	119407	119407	287104
14777	18162	4	applied	\N	\N	\N	\N	119418	119418	287115
14785	18172	2	applied	\N	\N	\N	\N	119440	119440	287137
14786	18175	1	applied	\N	\N	\N	\N	119443	119443	287140
14795	18195	1	applied	\N	\N	\N	\N	119465	119465	287162
14806	18214	0	applied	\N	\N	\N	\N	119494	119494	287191
14815	18232	1	applied	\N	\N	\N	\N	119526	119526	287223
14819	18242	1	applied	\N	\N	\N	\N	119536	119536	287233
14828	18262	3	applied	\N	\N	\N	\N	119563	119563	287260
14829	18262	3	applied	\N	\N	\N	\N	119567	119567	287264
14831	18177	16	applied	\N	\N	\N	\N	119588	119588	287285
14831	18206	30	applied	\N	\N	\N	\N	119602	119602	287299
14831	18244	47	applied	\N	\N	\N	\N	119619	119619	287316
14832	18264	0	applied	\N	\N	\N	\N	119630	119630	287327
14839	18275	6	applied	\N	\N	\N	\N	119654	119654	287351
14846	17891	7	applied	\N	\N	\N	\N	119682	119682	287378
14846	17893	8	applied	\N	\N	\N	\N	119683	119683	287379
14846	17915	25	applied	\N	\N	\N	\N	119700	119700	287396
14846	17938	42	applied	\N	\N	\N	\N	119717	119717	287413
14846	17959	59	applied	\N	\N	\N	\N	119734	119734	287430
14849	18284	0	applied	\N	\N	\N	\N	119759	119759	287455
14854	18303	8	applied	\N	\N	\N	\N	119780	119780	287476
14855	18298	2	applied	\N	\N	\N	\N	119783	119783	287479
14856	18298	2	applied	\N	\N	\N	\N	119791	119791	287487
14862	18301	1	applied	\N	\N	\N	\N	119812	119812	287508
14868	18311	1	applied	\N	\N	\N	\N	119830	119830	287526
14871	18317	5	applied	\N	\N	\N	\N	119845	119845	287541
14879	18332	0	applied	\N	\N	\N	\N	119873	119873	287569
14880	18335	0	applied	\N	\N	1000000000	\N	119876	119876	287572
14886	18354	2	applied	\N	\N	\N	\N	119916	119916	287612
14886	18355	3	applied	\N	\N	\N	\N	119917	119917	287613
14887	18364	0	applied	\N	\N	\N	\N	119926	119926	287622
14888	18378	2	applied	\N	\N	\N	\N	119940	119940	287636
14892	18392	5	applied	\N	\N	\N	\N	119958	119958	287654
14894	18391	4	applied	\N	\N	\N	\N	119973	119973	287669
14919	18444	2	applied	\N	\N	\N	\N	120074	120074	287770
14921	18446	1	applied	\N	\N	\N	\N	120079	120079	287775
14921	18447	2	applied	\N	\N	\N	\N	120080	120080	287776
14928	18456	0	applied	\N	\N	\N	\N	120091	120091	287787
14935	18464	4	applied	\N	\N	\N	\N	120116	120116	287812
14945	18471	1	applied	\N	\N	\N	\N	120139	120139	287835
14946	18483	0	applied	\N	\N	\N	\N	120151	120151	287847
14949	18485	0	applied	\N	\N	\N	\N	120160	120160	287856
14949	18486	1	applied	\N	\N	\N	\N	120161	120161	287857
14949	18487	2	applied	\N	\N	\N	\N	120162	120162	287858
14955	18493	0	applied	\N	\N	\N	\N	120176	120176	287872
14959	18494	0	applied	\N	\N	\N	\N	120186	120186	287882
14962	18503	1	applied	\N	\N	\N	\N	120197	120197	287893
14970	18520	4	applied	\N	\N	1000000000	\N	120216	120216	287912
14977	18534	1	applied	\N	\N	\N	\N	120235	120235	287931
14988	18547	2	applied	\N	\N	\N	\N	120257	120257	287953
14989	18547	2	applied	\N	\N	\N	\N	120260	120260	287956
15001	18563	2	applied	\N	\N	\N	\N	120295	120295	287991
15002	18223	4	applied	\N	\N	\N	\N	120301	120301	287997
15002	18259	21	applied	\N	\N	\N	\N	120318	120318	288014
15002	18294	38	applied	\N	\N	\N	\N	120335	120335	288031
15002	18337	55	applied	\N	\N	\N	\N	120352	120352	288048
15002	18403	72	applied	\N	\N	\N	\N	120369	120369	288065
15002	18445	87	applied	\N	\N	\N	\N	120384	120384	288080
15002	18467	97	applied	\N	\N	\N	\N	120394	120394	288090
15002	18506	114	applied	\N	\N	\N	\N	120411	120411	288107
15010	18574	0	applied	\N	\N	\N	\N	120443	120443	288139
15014	18581	1	applied	\N	\N	\N	\N	120453	120453	288149
15017	18589	0	applied	\N	\N	\N	\N	120461	120461	288157
15025	18607	0	applied	\N	\N	\N	\N	120497	120497	288193
15033	18608	15	applied	\N	\N	\N	\N	120533	120533	288228
15031	18279	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	120514	120514	\N
15033	18616	18	applied	\N	\N	\N	\N	120536	120536	288231
15033	18604	35	applied	\N	\N	\N	\N	120553	120553	288248
15034	18620	2	applied	\N	\N	\N	\N	120564	120564	288259
15044	18627	0	applied	\N	\N	\N	\N	120588	120588	288283
15050	18633	0	applied	\N	\N	\N	\N	120600	120600	288295
15054	18572	6	applied	\N	\N	\N	\N	120608	120608	288303
15054	18611	23	applied	\N	\N	\N	\N	120625	120625	288320
15054	18591	52	applied	\N	\N	\N	\N	120654	120654	288349
15054	18621	69	applied	\N	\N	\N	\N	120671	120671	288366
15062	18642	1	applied	\N	\N	\N	\N	120699	120699	288394
15071	18649	0	applied	\N	\N	\N	\N	120720	120720	288415
15078	18659	2	applied	\N	\N	\N	\N	120735	120735	288430
15080	18662	0	applied	\N	\N	\N	\N	120743	120743	288438
15087	18674	1	applied	\N	\N	\N	\N	120760	120760	288455
15103	18686	2	applied	\N	\N	\N	\N	120777	120777	288472
15107	18690	0	applied	\N	\N	\N	\N	120789	120789	288484
15108	18690	0	applied	\N	\N	\N	\N	120795	120795	288490
15109	18693	3	applied	\N	\N	1000000000	\N	120804	120804	288499
15113	18702	0	applied	\N	\N	\N	\N	120813	120813	288508
15120	18714	1	applied	\N	\N	\N	\N	120829	120829	288524
14711	17959	76	applied	\N	\N	\N	\N	119049	119049	286746
15146	18719	1	applied	\N	\N	\N	\N	120880	120880	288575
15148	18751	0	applied	\N	\N	\N	\N	120912	120912	288607
15151	18757	0	applied	\N	\N	\N	\N	120930	120930	288625
15159	18769	0	applied	\N	\N	\N	\N	120948	120948	288643
15166	18777	0	applied	\N	\N	\N	\N	120962	120962	288657
15168	18781	1	applied	\N	\N	\N	\N	120970	120970	288665
15170	18781	1	applied	\N	\N	\N	\N	120978	120978	288673
15181	18794	3	applied	\N	\N	1000000000	\N	121016	121016	288711
15190	18812	9	applied	\N	\N	\N	\N	121055	121055	288748
15196	18772	0	applied	\N	\N	1000000000	\N	121069	121069	288762
15196	18763	9	applied	\N	\N	\N	\N	121078	121078	288771
15196	18803	26	applied	\N	\N	\N	\N	121095	121095	288788
15196	18762	43	applied	\N	\N	\N	\N	121112	121112	288805
15196	18791	61	applied	\N	\N	1000000000	\N	121129	121129	288822
15200	18827	2	applied	\N	\N	\N	\N	121154	121154	288847
15203	18831	1	applied	\N	\N	\N	\N	121160	121160	288853
15214	18843	1	applied	\N	\N	\N	\N	121191	121191	288884
15218	18854	3	applied	\N	\N	\N	\N	121204	121204	288897
15223	18857	1	applied	\N	\N	\N	\N	121224	121224	288917
15239	18871	1	applied	\N	\N	\N	\N	121260	121260	288953
15240	18872	0	applied	\N	\N	\N	\N	121261	121261	288954
15240	18873	1	applied	\N	\N	\N	\N	121262	121262	288955
15241	18878	4	applied	\N	\N	\N	\N	121267	121267	288960
15243	18884	0	applied	\N	\N	\N	\N	121273	121273	288966
15248	18899	6	applied	\N	\N	\N	\N	121297	121297	288990
15254	18908	3	applied	\N	\N	\N	\N	121317	121317	289010
15256	18917	8	applied	\N	\N	\N	\N	121330	121330	289023
15262	18923	2	applied	\N	\N	\N	\N	121361	121361	289054
15263	18924	0	applied	\N	\N	\N	\N	121362	121362	289055
15267	18929	1	applied	\N	\N	\N	\N	121369	121369	289062
15269	18930	2	applied	\N	\N	\N	\N	121380	121380	289073
15273	18941	2	applied	\N	\N	\N	\N	121395	121395	289088
15281	18954	0	applied	\N	\N	\N	\N	121427	121427	289120
15283	18957	0	applied	\N	\N	\N	\N	121430	121430	289123
15285	18965	3	applied	\N	\N	\N	\N	121438	121438	289131
15290	18981	0	applied	\N	\N	\N	\N	121464	121464	289157
15292	18985	0	applied	\N	\N	\N	\N	121468	121468	289161
15295	18991	0	applied	\N	\N	\N	\N	121477	121477	289170
15304	18970	27	applied	\N	\N	\N	\N	121534	121534	289226
15305	18997	2	applied	\N	\N	\N	\N	121556	121556	289248
15306	18996	1	applied	\N	\N	\N	\N	121563	121563	289255
15310	19006	2	applied	\N	\N	\N	\N	121577	121577	289269
15321	19028	0	applied	\N	\N	\N	\N	121606	121606	289298
15324	19032	0	applied	\N	\N	\N	\N	121611	121611	289303
15334	19054	0	applied	\N	\N	\N	\N	121644	121644	289336
15335	19055	1	applied	\N	\N	\N	\N	121647	121647	289339
15337	19062	6	applied	\N	\N	\N	\N	121661	121661	289353
15339	19058	2	applied	\N	\N	\N	\N	121671	121671	289363
15349	19078	0	applied	\N	\N	\N	\N	121702	121702	289394
15350	19079	0	applied	\N	\N	\N	\N	121703	121703	289395
15364	19092	1	applied	\N	\N	\N	\N	121726	121726	289418
15368	19096	0	applied	\N	\N	\N	\N	121745	121745	289437
15369	19097	1	applied	\N	\N	\N	\N	121751	121751	289443
15377	19106	10	applied	\N	\N	\N	\N	121776	121776	289468
15377	19109	27	applied	\N	\N	\N	\N	121793	121793	289485
15381	19123	3	applied	\N	\N	\N	\N	121815	121815	289505
15391	19135	2	applied	\N	\N	\N	\N	121829	121829	289519
15379	19116	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	121806	121806	\N
15401	19148	1	applied	\N	\N	\N	\N	121849	121849	289539
15407	19165	3	applied	\N	\N	\N	\N	121872	121872	289562
15408	19165	3	applied	\N	\N	\N	\N	121876	121876	289566
15409	19164	2	applied	\N	\N	\N	\N	121879	121879	289569
15410	19162	0	applied	\N	\N	\N	\N	121881	121881	289571
15420	19182	0	applied	\N	\N	\N	\N	121913	121913	289603
15432	19197	3	applied	\N	\N	\N	\N	121944	121944	289634
15434	19203	2	applied	\N	\N	\N	\N	121957	121957	289647
15438	19212	2	applied	\N	\N	\N	\N	121975	121975	289665
15440	19192	14	applied	\N	\N	\N	\N	121997	121997	289687
15444	19216	1	applied	\N	\N	\N	\N	122018	122018	289708
15446	19222	0	applied	\N	\N	\N	\N	122024	122024	289714
15452	19239	5	applied	\N	\N	\N	\N	122044	122044	289734
15453	19236	2	applied	\N	\N	\N	\N	122048	122048	289738
15457	19242	1	applied	\N	\N	\N	\N	122070	122070	289760
15461	19004	5	applied	\N	\N	\N	\N	122082	122082	289772
15461	19042	23	applied	\N	\N	\N	\N	122099	122099	289789
15461	19084	40	applied	\N	\N	\N	\N	122116	122116	289806
15461	19126	57	applied	\N	\N	\N	\N	122133	122133	289823
15461	19138	62	applied	\N	\N	\N	\N	122138	122138	289828
15461	19156	70	applied	\N	\N	\N	\N	122146	122146	289836
15461	19201	87	applied	\N	\N	\N	\N	122163	122163	289853
15461	19026	121	applied	\N	\N	\N	\N	122197	122197	289886
15469	19256	2	applied	\N	\N	\N	\N	122215	122215	289904
15479	19269	0	applied	\N	\N	\N	\N	122241	122241	289930
15481	19272	3	applied	\N	\N	\N	\N	122252	122252	289941
15482	19274	1	applied	\N	\N	\N	\N	122254	122254	289943
15484	19278	0	applied	\N	\N	\N	\N	122258	122258	289947
15494	19283	1	applied	\N	\N	\N	\N	122273	122273	289962
15503	19300	0	applied	\N	\N	\N	\N	122308	122308	289997
15512	19313	0	applied	\N	\N	1000000000	\N	122326	122326	290015
15515	19316	4	applied	\N	\N	\N	\N	122344	122344	290033
15519	19325	0	applied	\N	\N	\N	\N	122354	122354	290043
15529	19342	0	applied	\N	\N	\N	\N	122387	122387	290076
15530	19344	2	applied	\N	\N	\N	\N	122396	122396	290085
15536	19356	5	applied	\N	\N	\N	\N	122417	122417	290106
15537	19360	2	applied	\N	\N	\N	\N	122420	122420	290109
15539	19366	0	applied	\N	\N	\N	\N	122426	122426	290115
15546	19385	5	applied	\N	\N	\N	\N	122457	122457	290146
15554	19406	1	applied	\N	\N	\N	\N	122486	122486	290175
15555	19407	2	applied	\N	\N	\N	\N	122492	122492	290181
15558	19412	2	applied	\N	\N	\N	\N	122509	122509	290198
15559	19164	13	applied	\N	\N	\N	\N	122526	122526	290215
15559	19206	31	applied	\N	\N	\N	\N	122543	122543	290232
15559	19210	33	applied	\N	\N	\N	\N	122545	122545	290234
15559	19217	36	applied	\N	\N	\N	\N	122548	122548	290237
15559	19257	53	applied	\N	\N	\N	\N	122565	122565	290254
15559	19297	70	applied	\N	\N	\N	\N	122582	122582	290271
15559	19340	87	applied	\N	\N	\N	\N	122599	122599	290288
15559	19380	104	applied	\N	\N	\N	\N	122616	122616	290305
15559	19383	107	applied	\N	\N	\N	\N	122619	122619	290308
15130	18725	2	applied	\N	\N	\N	\N	120851	120851	288546
15580	19445	5	applied	\N	\N	1000000000	\N	122684	122684	290372
15586	19451	1	applied	\N	\N	\N	\N	122694	122694	290382
15592	19463	1	applied	\N	\N	\N	\N	122722	122722	290410
15596	19466	0	applied	\N	\N	\N	\N	122731	122731	290419
15604	19476	0	applied	\N	\N	\N	\N	122747	122747	290435
15604	19477	1	applied	\N	\N	\N	\N	122748	122748	290436
15608	19482	2	applied	\N	\N	\N	\N	122757	122757	290445
15609	19487	0	applied	\N	\N	\N	\N	122762	122762	290450
15614	19492	0	applied	\N	\N	\N	\N	122776	122776	290464
15614	19493	1	applied	\N	\N	\N	\N	122777	122777	290465
15628	19522	2	applied	\N	\N	\N	\N	122823	122823	290511
15635	19528	2	applied	\N	\N	\N	\N	122845	122845	290533
15636	19529	3	applied	\N	\N	\N	\N	122850	122850	290538
15639	19522	11	applied	\N	\N	\N	\N	122870	122870	290558
15642	19533	0	applied	\N	\N	\N	\N	122882	122882	290570
15653	19555	0	applied	\N	\N	\N	\N	122924	122924	290612
15654	19560	2	applied	\N	\N	\N	\N	122929	122929	290617
15660	19577	2	applied	\N	\N	\N	\N	122956	122956	290644
15661	19581	3	applied	\N	\N	\N	\N	122960	122960	290648
15662	19587	5	applied	\N	\N	\N	\N	122966	122966	290654
15663	19590	2	applied	\N	\N	\N	\N	122969	122969	290657
15667	19595	0	applied	\N	\N	\N	\N	122986	122986	290674
15670	19599	4	applied	\N	\N	\N	\N	123006	123006	290694
15673	19606	5	applied	\N	\N	\N	\N	123027	123027	290715
15674	19608	0	applied	\N	\N	\N	\N	123029	123029	290717
15680	19614	3	applied	\N	\N	\N	\N	123054	123054	290742
15691	19626	5	applied	\N	\N	\N	\N	123095	123095	290783
15694	19631	0	applied	\N	\N	\N	\N	123100	123100	290788
15702	19644	4	applied	\N	\N	\N	\N	123132	123132	290820
15705	19645	0	applied	\N	\N	\N	\N	123149	123149	290837
15707	19649	0	applied	\N	\N	\N	\N	123164	123164	290852
15710	19658	3	applied	\N	\N	\N	\N	123173	123173	290861
15710	19659	4	applied	\N	\N	\N	\N	123174	123174	290862
15713	19667	2	applied	\N	\N	\N	\N	123186	123186	290874
15717	19430	9	applied	\N	\N	\N	\N	123207	123207	290895
15717	19456	27	applied	\N	\N	\N	\N	123224	123224	290912
15717	19496	44	applied	\N	\N	\N	\N	123241	123241	290929
15717	19517	51	applied	\N	\N	\N	\N	123248	123248	290936
15717	19526	54	applied	\N	\N	\N	\N	123251	123251	290939
15717	19582	71	applied	\N	\N	\N	\N	123268	123268	290956
15717	19638	88	applied	\N	\N	\N	\N	123285	123285	290973
15717	19161	105	applied	\N	\N	\N	\N	123302	123302	290990
15717	19200	125	applied	\N	\N	\N	\N	123322	123322	291010
15726	19691	0	applied	\N	\N	\N	\N	123361	123361	291049
15727	19691	0	applied	\N	\N	\N	\N	123365	123365	291053
15732	19713	5	applied	\N	\N	1000000000	\N	123390	123390	291078
15733	19717	1	applied	\N	\N	\N	\N	123394	123394	291082
15738	19733	0	applied	\N	\N	1000000000	\N	123424	123424	291112
15741	19736	0	applied	\N	\N	\N	\N	123436	123436	291124
15742	19744	1	applied	\N	\N	\N	\N	123444	123444	291132
15746	19756	6	applied	\N	\N	\N	\N	123463	123463	291151
15748	19759	2	applied	\N	\N	\N	\N	123473	123473	291161
15749	19769	12	applied	\N	\N	\N	\N	123497	123497	291185
15750	19761	4	applied	\N	\N	\N	\N	123503	123503	291191
15751	19772	1	applied	\N	\N	\N	\N	123514	123514	291202
15754	19778	0	applied	\N	\N	\N	\N	123534	123534	291222
15755	19778	0	applied	\N	\N	\N	\N	123541	123541	291229
15765	19814	1	applied	\N	\N	\N	\N	123588	123588	291276
15767	19817	0	applied	\N	\N	\N	\N	123598	123598	291286
15769	19826	2	applied	\N	\N	\N	\N	123614	123614	291302
15772	19835	0	applied	\N	\N	\N	\N	123623	123623	291311
15777	19853	0	applied	\N	\N	\N	\N	123662	123662	291350
15780	19861	2	applied	\N	\N	\N	\N	123676	123676	291364
15783	19865	3	applied	\N	\N	\N	\N	123687	123687	291375
15788	19885	3	applied	\N	\N	\N	\N	123710	123710	291398
15792	19898	3	applied	\N	\N	\N	\N	123726	123726	291414
15796	19910	1	applied	\N	\N	\N	\N	123742	123742	291430
15800	19932	1	applied	\N	\N	\N	\N	123767	123767	291455
15801	19936	2	applied	\N	\N	\N	\N	123771	123771	291459
15808	19946	4	applied	\N	\N	\N	\N	123798	123798	291486
15809	19952	1	applied	\N	\N	\N	\N	123804	123804	291492
15811	19964	8	applied	\N	\N	\N	\N	123815	123815	291503
15812	19965	11	applied	\N	\N	\N	\N	123829	123829	291517
15812	19966	12	applied	\N	\N	\N	\N	123830	123830	291518
15814	19960	4	applied	\N	\N	\N	\N	123850	123850	291538
15815	19967	7	applied	\N	\N	\N	\N	123867	123867	291555
15817	19982	12	applied	\N	\N	\N	\N	123897	123897	291585
15817	19983	13	applied	\N	\N	\N	\N	123898	123898	291586
15817	19984	14	applied	\N	\N	\N	\N	123899	123899	291587
15818	19993	4	applied	\N	\N	\N	\N	123908	123908	291596
15820	20001	7	applied	\N	\N	\N	\N	123921	123921	291609
15821	20017	11	applied	\N	\N	\N	\N	123937	123937	291625
15822	20023	17	applied	\N	\N	\N	\N	123962	123962	291650
15823	20018	12	applied	\N	\N	\N	\N	123976	123976	291664
15824	20021	15	applied	\N	\N	\N	\N	123998	123998	291686
15825	20015	9	applied	\N	\N	\N	\N	124011	124011	291699
15826	20013	6	applied	\N	\N	\N	\N	124028	124028	291716
15827	20019	13	applied	\N	\N	\N	\N	124053	124053	291741
15828	20011	4	applied	\N	\N	\N	\N	124064	124064	291752
15831	20033	2	applied	\N	\N	\N	\N	124091	124091	291779
15834	20038	2	applied	\N	\N	\N	\N	124108	124108	291796
15836	20050	1	applied	\N	\N	\N	\N	124120	124120	291808
15842	20070	1	applied	\N	\N	\N	\N	124152	124152	291840
15845	20074	1	applied	\N	\N	\N	\N	124164	124164	291852
15847	20083	7	applied	\N	\N	\N	\N	124176	124176	291864
15849	20082	6	applied	\N	\N	\N	\N	124195	124195	291883
15850	20085	9	applied	\N	\N	\N	\N	124208	124208	291896
15856	20096	0	applied	\N	\N	\N	\N	124233	124233	291921
15860	20102	0	applied	\N	\N	\N	\N	124245	124245	291933
15861	20108	6	applied	\N	\N	\N	\N	124258	124258	291946
15862	19958	10	applied	\N	\N	\N	\N	124269	124269	291957
15862	19998	27	applied	\N	\N	\N	\N	124286	124286	291974
15862	20018	32	applied	\N	\N	\N	\N	124291	124291	291979
15862	20028	35	applied	\N	\N	\N	\N	124294	124294	291982
15865	20114	2	applied	\N	\N	\N	\N	124310	124310	291998
15875	20136	0	applied	\N	\N	\N	\N	124344	124344	292032
15876	20139	3	applied	\N	\N	\N	\N	124351	124351	292039
15888	20143	0	applied	\N	\N	\N	\N	124372	124372	292060
15889	20150	1	applied	\N	\N	\N	\N	124379	124379	292067
15894	20167	2	applied	\N	\N	\N	\N	124404	124404	292092
15561	19420	4	applied	\N	\N	1000000000	\N	122648	122648	290337
15909	20198	0	applied	\N	\N	\N	\N	124473	124473	292161
15913	20207	1	applied	\N	\N	\N	\N	124485	124485	292173
15915	20211	2	applied	\N	\N	\N	\N	124495	124495	292183
15917	20220	3	applied	\N	\N	\N	\N	124507	124507	292195
15923	20228	1	applied	\N	\N	\N	\N	124532	124532	292220
15924	20231	4	applied	\N	\N	\N	\N	124541	124541	292229
15928	20236	0	applied	\N	\N	\N	\N	124552	124552	292240
15928	20237	1	applied	\N	\N	\N	\N	124553	124553	292241
15930	20245	7	applied	\N	\N	\N	\N	124563	124563	292251
15938	20253	0	applied	\N	\N	\N	\N	124592	124592	292280
15941	20256	0	applied	\N	\N	\N	\N	124601	124601	292289
15947	20276	2	applied	\N	\N	\N	\N	124627	124627	292315
15953	20290	1	applied	\N	\N	\N	\N	124647	124647	292335
15954	20293	1	applied	\N	\N	\N	\N	124650	124650	292338
15964	20301	3	applied	\N	\N	\N	\N	124688	124688	292376
15967	20312	5	applied	\N	\N	\N	\N	124699	124699	292387
15972	20315	2	applied	\N	\N	\N	\N	124726	124726	292414
15977	20335	13	applied	\N	\N	\N	\N	124751	124751	292439
15981	20341	0	applied	\N	\N	\N	\N	124763	124763	292451
15981	20342	1	applied	\N	\N	\N	\N	124764	124764	292452
15987	20359	3	applied	\N	\N	\N	\N	124787	124787	292475
15988	20363	1	applied	\N	\N	\N	\N	124791	124791	292479
15990	20362	0	applied	\N	\N	\N	\N	124796	124796	292484
15990	20363	1	applied	\N	\N	\N	\N	124797	124797	292485
15992	20368	0	applied	\N	\N	\N	\N	124802	124802	292490
16000	20395	2	applied	\N	\N	\N	\N	124842	124842	292530
16001	20404	2	applied	\N	\N	\N	\N	124851	124851	292539
16005	20416	7	applied	\N	\N	\N	\N	124876	124876	292564
16007	20426	4	applied	\N	\N	\N	\N	124886	124886	292574
16008	20428	6	applied	\N	\N	\N	\N	124904	124904	292592
16009	20436	14	applied	\N	\N	\N	\N	124928	124928	292616
16013	20441	3	applied	\N	\N	\N	\N	124945	124945	292633
16023	20459	1	applied	\N	\N	\N	\N	124975	124975	292663
16026	20462	0	applied	\N	\N	\N	\N	124986	124986	292674
16026	20467	5	applied	\N	\N	\N	\N	124991	124991	292679
16026	20470	8	applied	\N	\N	\N	\N	124994	124994	292682
16034	20494	6	applied	\N	\N	\N	\N	125030	125030	292718
16036	20495	0	applied	\N	\N	\N	\N	125038	125038	292726
16039	20507	3	applied	\N	\N	\N	\N	125054	125054	292742
16046	20516	2	applied	\N	\N	\N	\N	125079	125079	292767
16050	20526	2	applied	\N	\N	\N	\N	125092	125092	292780
16052	20531	0	applied	\N	\N	\N	\N	125097	125097	292785
16054	20228	11	applied	\N	\N	\N	\N	125120	125120	292808
16054	20322	42	applied	\N	\N	\N	\N	125151	125151	292839
16054	20374	59	applied	\N	\N	\N	\N	125168	125168	292856
16054	20422	74	applied	\N	\N	\N	\N	125183	125183	292871
16054	20425	77	applied	\N	\N	\N	\N	125186	125186	292874
16054	20488	94	applied	\N	\N	\N	\N	125203	125203	292891
16058	20544	3	applied	\N	\N	\N	\N	125244	125244	292932
16061	20550	2	applied	\N	\N	\N	\N	125258	125258	292946
16062	20548	0	applied	\N	\N	\N	\N	125260	125260	292948
16068	20559	1	applied	\N	\N	\N	\N	125287	125287	292975
16069	20567	5	applied	\N	\N	\N	\N	125297	125297	292985
16070	20571	2	applied	\N	\N	\N	\N	125301	125301	292989
16070	20574	5	applied	\N	\N	\N	\N	125304	125304	292992
16074	20572	3	applied	\N	\N	\N	\N	125330	125330	293018
16082	20582	1	applied	\N	\N	\N	\N	125354	125354	293042
16088	20581	0	applied	\N	\N	\N	\N	125370	125370	293058
16088	20583	3	applied	\N	\N	\N	\N	125373	125373	293061
16090	20603	13	applied	\N	\N	\N	\N	125390	125390	293078
16091	20591	1	applied	\N	\N	\N	\N	125400	125400	293088
16091	20608	18	applied	\N	\N	\N	\N	125417	125417	293105
16099	20633	1	applied	\N	\N	\N	\N	125451	125451	293139
16100	20442	7	applied	\N	\N	\N	\N	125460	125460	293148
16100	20553	41	applied	\N	\N	\N	\N	125494	125494	293182
16100	20563	44	applied	\N	\N	\N	\N	125497	125497	293185
16100	20576	47	applied	\N	\N	\N	\N	125500	125500	293188
16100	20632	65	applied	\N	\N	\N	\N	125517	125517	293205
16100	20492	82	applied	\N	\N	\N	\N	125534	125534	293222
16100	20493	99	applied	\N	\N	\N	\N	125551	125551	293239
16100	20437	116	applied	\N	\N	\N	\N	125568	125568	293256
16104	20639	0	applied	\N	\N	\N	\N	125588	125588	293276
16105	20646	4	applied	\N	\N	\N	\N	125595	125595	293283
16107	20650	1	applied	\N	\N	\N	\N	125606	125606	293294
16112	20669	10	applied	\N	\N	\N	\N	125631	125631	293319
16116	20681	3	applied	\N	\N	\N	\N	125646	125646	293334
16123	20697	2	applied	\N	\N	\N	\N	125675	125675	293363
16124	20704	6	applied	\N	\N	\N	\N	125682	125682	293370
16125	20702	4	applied	\N	\N	\N	\N	125687	125687	293375
16127	20710	2	applied	\N	\N	\N	\N	125695	125695	293383
16129	20611	24	applied	\N	\N	\N	\N	125723	125723	293411
16134	20723	6	applied	\N	\N	\N	\N	125752	125752	293440
16141	20733	3	applied	\N	\N	\N	\N	125788	125788	293476
16142	20738	2	applied	\N	\N	\N	\N	125793	125793	293481
16150	20753	2	applied	\N	\N	\N	\N	125823	125823	293511
16151	20754	3	applied	\N	\N	\N	\N	125828	125828	293516
16154	20740	12	applied	\N	\N	\N	\N	125847	125847	293535
16156	20759	1	applied	\N	\N	\N	\N	125867	125867	293555
16157	20762	1	applied	\N	\N	\N	\N	125870	125870	293558
16165	20776	2	applied	\N	\N	\N	\N	125896	125896	293584
16171	20784	0	applied	\N	\N	\N	\N	125914	125914	293602
16173	20785	1	applied	\N	\N	\N	\N	125923	125923	293611
16175	20678	13	applied	\N	\N	\N	\N	125941	125941	293629
16175	20718	26	applied	\N	\N	\N	\N	125954	125954	293642
16175	20771	42	applied	\N	\N	\N	\N	125970	125970	293658
16175	20538	60	applied	\N	\N	\N	\N	125987	125987	293675
16175	20654	94	applied	\N	\N	\N	\N	126021	126021	293709
16175	20497	100	applied	\N	\N	\N	\N	126027	126027	293715
16175	20533	111	applied	\N	\N	\N	\N	126038	126038	293726
16178	20795	2	applied	\N	\N	\N	\N	126061	126061	293749
16182	20805	3	applied	\N	\N	\N	\N	126075	126075	293763
16183	20803	1	applied	\N	\N	\N	\N	126084	126084	293771
16187	20815	2	applied	\N	\N	\N	\N	126129	126129	293812
16184	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	126098	126098	\N
16191	20820	3	applied	\N	\N	\N	\N	126144	126144	293826
16195	20844	3	applied	\N	\N	\N	\N	126168	126168	293850
16196	20842	1	applied	\N	\N	\N	\N	126170	126170	293852
16208	20858	2	applied	\N	\N	1000000000	\N	126216	126216	293898
16496	21560	2	applied	\N	\N	\N	\N	128040	128040	295674
15902	20187	1	applied	\N	\N	\N	\N	124436	124436	292124
16215	20888	5	applied	\N	\N	\N	\N	126268	126268	293950
16223	20901	0	applied	\N	\N	\N	\N	126291	126291	293973
16224	20909	4	applied	\N	\N	\N	\N	126302	126302	293984
16226	20920	5	applied	\N	\N	\N	\N	126314	126314	293996
16231	20930	1	applied	\N	\N	\N	\N	126341	126341	294023
16238	20942	4	applied	\N	\N	\N	\N	126378	126378	294059
16239	20845	12	applied	\N	\N	\N	\N	126391	126391	294072
16239	20884	22	applied	\N	\N	\N	\N	126401	126401	294082
16239	20934	39	applied	\N	\N	\N	\N	126418	126418	294099
16239	20910	55	applied	\N	\N	1000000000	\N	126434	126434	294115
16240	20905	17	applied	\N	\N	\N	\N	126456	126456	294137
16244	20951	2	applied	\N	\N	\N	\N	126479	126479	294160
16250	20954	1	applied	\N	\N	\N	\N	126494	126494	294175
16253	20958	0	applied	\N	\N	\N	\N	126500	126500	294181
16258	20858	2	applied	\N	\N	1000000000	\N	126518	126518	294199
16258	20576	23	applied	\N	\N	\N	\N	126539	126539	294220
16258	20591	29	applied	\N	\N	\N	\N	126545	126545	294226
16258	20594	32	applied	\N	\N	\N	\N	126548	126548	294229
16258	20660	49	applied	\N	\N	\N	\N	126565	126565	294246
16258	20717	67	applied	\N	\N	\N	\N	126582	126582	294263
16258	20771	84	applied	\N	\N	\N	\N	126599	126599	294280
16258	20831	101	applied	\N	\N	\N	\N	126616	126616	294297
16258	20896	118	applied	\N	\N	\N	\N	126633	126633	294314
16263	20982	4	applied	\N	\N	\N	\N	126663	126663	294344
16265	20987	2	applied	\N	\N	\N	\N	126671	126671	294352
16268	20992	4	applied	\N	\N	\N	\N	126676	126676	294357
16272	21017	6	applied	\N	\N	\N	\N	126709	126709	294387
16274	21019	0	applied	\N	\N	\N	\N	126719	126719	294396
16278	21028	3	applied	\N	\N	\N	\N	126736	126736	294413
16284	21029	0	applied	\N	\N	\N	\N	126753	126753	294430
16291	21036	1	applied	\N	\N	\N	\N	126770	126770	294447
16293	20962	12	applied	\N	\N	\N	\N	126787	126787	294464
16293	21019	29	applied	\N	\N	\N	\N	126804	126804	294481
16293	20520	46	applied	\N	\N	\N	\N	126821	126821	294497
16293	20863	53	applied	\N	\N	\N	\N	126828	126828	294504
16293	20864	55	applied	\N	\N	\N	\N	126829	126829	294505
16293	20556	72	applied	\N	\N	\N	\N	126846	126846	294522
16293	20609	89	applied	\N	\N	\N	\N	126863	126863	294539
16293	20526	106	applied	\N	\N	\N	\N	126880	126880	294554
16293	20585	123	applied	\N	\N	\N	\N	126897	126897	294571
16295	21047	0	applied	\N	\N	\N	\N	126906	126906	294580
16295	21048	1	applied	\N	\N	\N	\N	126907	126907	294581
16300	21055	1	applied	\N	\N	\N	\N	126924	126924	294598
16303	21062	2	applied	\N	\N	\N	\N	126934	126934	294608
16306	21000	10	applied	\N	\N	\N	\N	126951	126951	294625
16306	20991	39	applied	\N	\N	\N	\N	126979	126979	294653
16306	20987	56	applied	\N	\N	\N	\N	126996	126996	294668
16306	21030	73	applied	\N	\N	\N	\N	127013	127013	294685
16306	21045	90	applied	\N	\N	\N	\N	127030	127030	294702
16309	21072	3	applied	\N	\N	\N	\N	127049	127049	294721
16311	21073	4	applied	\N	\N	\N	\N	127064	127064	294736
16311	21074	5	applied	\N	\N	\N	\N	127065	127065	294737
16314	21081	2	applied	\N	\N	\N	\N	127079	127079	294751
16320	21094	0	applied	\N	\N	\N	\N	127107	127107	294775
16325	21109	0	applied	\N	\N	\N	\N	127122	127122	294790
16329	21136	14	applied	\N	\N	\N	\N	127153	127153	294820
16329	21142	20	applied	\N	\N	\N	\N	127159	127159	294826
16331	21144	1	applied	\N	\N	\N	\N	127182	127182	294848
16333	21149	3	applied	\N	\N	\N	\N	127191	127191	294857
16334	21146	0	applied	\N	\N	\N	\N	127192	127192	294858
16341	21174	0	applied	\N	\N	\N	\N	127220	127220	294886
16352	21195	2	applied	\N	\N	\N	\N	127256	127256	294922
16353	21209	2	applied	\N	\N	\N	\N	127270	127270	294936
16354	21221	4	applied	\N	\N	\N	\N	127282	127282	294948
16360	21237	1	applied	\N	\N	\N	\N	127306	127306	294972
16361	21237	1	applied	\N	\N	\N	\N	127310	127310	294976
16365	21244	3	applied	\N	\N	\N	\N	127325	127325	294991
16372	21265	2	applied	\N	\N	\N	\N	127357	127357	295023
16378	21279	0	applied	\N	\N	\N	\N	127394	127394	295057
16384	21292	1	applied	\N	\N	\N	\N	127416	127416	295079
16374	21122	0	failed	Receiver_not_present	\N	\N	\N	127364	127364	\N
16388	21302	1	applied	\N	\N	\N	\N	127429	127429	295092
16390	21319	0	applied	\N	\N	\N	\N	127446	127446	295108
16394	21326	1	applied	\N	\N	\N	\N	127464	127464	295121
16395	21330	6	applied	\N	\N	\N	\N	127479	127479	295136
16398	21337	1	applied	\N	\N	1000000000	\N	127490	127490	295147
16398	21341	5	applied	\N	\N	\N	\N	127494	127494	295151
16408	21364	2	applied	\N	\N	\N	\N	127533	127533	295190
16411	21368	2	applied	\N	\N	\N	\N	127542	127542	295199
16411	21369	3	applied	\N	\N	\N	\N	127543	127543	295200
16421	21385	3	applied	\N	\N	\N	\N	127581	127581	295238
16423	21387	1	applied	\N	\N	\N	\N	127587	127587	295244
16423	21388	2	applied	\N	\N	\N	\N	127588	127588	295245
16427	21394	2	applied	\N	\N	\N	\N	127610	127610	295265
16429	21397	1	applied	\N	\N	\N	\N	127617	127617	295272
16434	21408	1	applied	\N	\N	\N	\N	127646	127646	295295
16438	21424	0	applied	\N	\N	\N	\N	127668	127668	295314
16443	21433	2	applied	\N	\N	\N	\N	127683	127683	295329
16445	21439	1	applied	\N	\N	\N	\N	127689	127689	295335
16446	21442	4	applied	\N	\N	\N	\N	127702	127702	295348
16450	21458	1	applied	\N	\N	\N	\N	127725	127725	295371
16451	21462	2	applied	\N	\N	1000000000	\N	127729	127729	295375
16453	21464	4	applied	\N	\N	\N	\N	127747	127747	295393
16454	21401	26	applied	\N	\N	\N	\N	127777	127777	295423
16454	21440	38	applied	\N	\N	\N	\N	127788	127788	295434
16454	21345	55	applied	\N	\N	\N	\N	127805	127805	295449
16454	21364	67	applied	\N	\N	\N	\N	127817	127817	295458
16454	21397	70	applied	\N	\N	\N	\N	127820	127820	295461
16454	21395	87	applied	\N	\N	\N	\N	127837	127837	295478
16454	21453	104	applied	\N	\N	\N	\N	127854	127854	295495
16454	21388	121	applied	\N	\N	\N	\N	127871	127871	295512
16458	21476	2	applied	\N	\N	\N	\N	127887	127887	295528
16466	21499	3	applied	\N	\N	\N	\N	127919	127919	295560
16472	21337	0	applied	\N	\N	1000000000	\N	127938	127938	295579
16473	21503	0	applied	\N	\N	\N	\N	127948	127948	295582
16474	21505	2	applied	\N	\N	\N	\N	127953	127953	295587
16483	21521	1	applied	\N	\N	1000000000	\N	127981	127981	295615
16488	21534	0	applied	\N	\N	\N	\N	128006	128006	295640
16494	21555	1	applied	\N	\N	\N	\N	128031	128031	295665
16214	20878	1	applied	\N	\N	\N	\N	126257	126257	293939
16504	21588	3	applied	\N	\N	\N	\N	128087	128087	295721
16507	21603	7	applied	\N	\N	\N	\N	128105	128105	295739
16508	21611	4	applied	\N	\N	\N	\N	128113	128113	295747
16509	21613	6	applied	\N	\N	\N	\N	128122	128122	295756
16520	21638	1	applied	\N	\N	\N	\N	128172	128172	295806
16522	21640	0	applied	\N	\N	\N	\N	128179	128179	295813
16523	21403	5	applied	\N	\N	\N	\N	128188	128188	128188
16523	21405	6	applied	\N	\N	\N	\N	128189	128189	128189
16523	21413	7	applied	\N	\N	\N	\N	128190	128190	128190
16531	21663	1	applied	\N	\N	\N	\N	128221	128221	295848
16532	21666	4	applied	\N	\N	\N	\N	128231	128231	295858
16534	21671	2	applied	\N	\N	\N	\N	128239	128239	295866
16542	21677	5	applied	\N	\N	\N	\N	128256	128256	295883
16544	21681	9	applied	\N	\N	\N	\N	128274	128274	295901
16544	21685	13	applied	\N	\N	\N	\N	128278	128278	295905
16545	21680	8	applied	\N	\N	\N	\N	128287	128287	295914
16546	21685	13	applied	\N	\N	\N	\N	128306	128306	295933
16554	21693	2	applied	\N	\N	\N	\N	128328	128328	295955
16560	21712	0	applied	\N	\N	\N	\N	128356	128356	295983
16564	21662	1	applied	\N	\N	\N	\N	128372	128372	295998
16564	21687	35	applied	\N	\N	\N	\N	128406	128406	296031
16564	21723	52	applied	\N	\N	\N	\N	128423	128423	296048
16567	21737	0	applied	\N	\N	\N	\N	128450	128450	296075
16567	21740	3	applied	\N	\N	\N	\N	128453	128453	296078
16570	21731	0	applied	\N	\N	\N	\N	128462	128462	296087
16571	21741	0	applied	\N	\N	\N	\N	128476	128476	296101
16573	21747	3	applied	\N	\N	\N	\N	128495	128495	296120
16574	21746	1	applied	\N	\N	\N	\N	128499	128499	296124
16576	21089	0	applied	\N	\N	\N	\N	128507	128507	128507
16579	21759	3	applied	\N	\N	\N	\N	128558	128558	296171
16576	21719	14	failed	Receiver_not_present	\N	\N	\N	128521	128521	\N
16580	21766	0	applied	\N	\N	\N	\N	128565	128565	296178
16584	21767	4	applied	\N	\N	\N	\N	128591	128591	296204
16586	21243	2	applied	\N	\N	\N	\N	128609	128609	296220
16586	21248	4	applied	\N	\N	\N	\N	128611	128611	296222
16586	21069	21	applied	\N	\N	\N	\N	128628	128628	296239
16586	21102	38	applied	\N	\N	\N	\N	128645	128645	296255
16586	21160	55	applied	\N	\N	\N	\N	128662	128662	296272
16586	21217	73	applied	\N	\N	\N	\N	128679	128679	296289
16586	21279	90	applied	\N	\N	\N	\N	128696	128696	296306
16586	21336	107	applied	\N	\N	\N	\N	128713	128713	296323
16586	21386	122	applied	\N	\N	\N	\N	128728	128728	296338
16586	21387	123	applied	\N	\N	\N	\N	128729	128729	296339
16589	21785	1	applied	\N	\N	\N	\N	128745	128745	296355
16592	21795	1	applied	\N	\N	\N	\N	128757	128757	296367
16595	21797	3	applied	\N	\N	\N	\N	128768	128768	296378
16601	21806	0	applied	\N	\N	\N	\N	128788	128788	296396
16610	21799	11	applied	\N	\N	\N	\N	128824	128824	296432
16611	21812	1	applied	\N	\N	\N	\N	128842	128842	296450
16611	21814	4	applied	\N	\N	\N	\N	128845	128845	296453
16612	21816	0	applied	\N	\N	\N	\N	128847	128847	296455
16620	21835	2	applied	\N	\N	\N	\N	128866	128866	296474
16623	21586	16	applied	\N	\N	\N	\N	128889	128889	296497
16623	21640	33	applied	\N	\N	\N	\N	128906	128906	296513
16623	21691	50	applied	\N	\N	\N	\N	128923	128923	296530
16623	21712	57	applied	\N	\N	\N	\N	128930	128930	296537
16623	21785	78	applied	\N	\N	\N	\N	128951	128951	296558
16623	21563	96	applied	\N	\N	\N	\N	128968	128968	296575
16623	21576	97	applied	\N	\N	\N	\N	128969	128969	296576
16623	21609	100	applied	\N	\N	\N	\N	128972	128972	296579
16626	21840	2	applied	\N	\N	\N	\N	128981	128981	296588
16629	21766	16	applied	\N	\N	\N	\N	129008	129008	296615
16629	21826	33	applied	\N	\N	\N	\N	129025	129025	296632
16629	21759	50	applied	\N	\N	\N	\N	129042	129042	296649
16629	21748	64	applied	\N	\N	\N	\N	129056	129056	296663
16629	21760	67	applied	\N	\N	\N	\N	129059	129059	296666
16629	21820	84	applied	\N	\N	\N	\N	129076	129076	296683
16629	21793	101	applied	\N	\N	\N	\N	129093	129093	296700
16629	21852	118	applied	\N	\N	\N	\N	129110	129110	296717
16632	21858	3	applied	\N	\N	\N	\N	129125	129125	296732
16633	21862	2	applied	\N	\N	\N	\N	129129	129129	296736
16637	21872	2	applied	\N	\N	\N	\N	129147	129147	296754
16645	21900	11	applied	\N	\N	\N	\N	129192	129192	296799
16648	21904	2	applied	\N	\N	\N	\N	129204	129204	296811
16653	21915	4	applied	\N	\N	\N	\N	129231	129231	296838
16655	21914	3	applied	\N	\N	\N	\N	129244	129244	296851
16659	21925	1	applied	\N	\N	\N	\N	129262	129262	296869
16660	21930	6	applied	\N	\N	\N	\N	129276	129276	296883
16662	21421	22	applied	\N	\N	\N	\N	129310	129310	129310
16663	21933	0	applied	\N	\N	\N	\N	129312	129312	296913
16667	21942	2	applied	\N	\N	\N	\N	129327	129327	296928
16671	21944	1	applied	\N	\N	\N	\N	129342	129342	296943
16676	21954	2	applied	\N	\N	\N	\N	129372	129372	296973
16677	21955	3	applied	\N	\N	\N	\N	129380	129380	296981
16681	21974	9	applied	\N	\N	\N	\N	129402	129402	297003
16687	21784	0	applied	\N	\N	\N	\N	129421	129421	297022
16687	21537	18	applied	\N	\N	\N	\N	129438	129438	297039
16687	21574	28	applied	\N	\N	\N	\N	129448	129448	297049
16687	21675	63	applied	\N	\N	\N	\N	129483	129483	297083
16687	21737	80	applied	\N	\N	\N	\N	129500	129500	297100
16687	21799	97	applied	\N	\N	\N	\N	129517	129517	297117
16687	21855	114	applied	\N	\N	\N	\N	129534	129534	297134
16688	21990	6	applied	\N	\N	\N	\N	129552	129552	297152
16689	22005	5	applied	\N	\N	\N	\N	129567	129567	297167
16691	22012	5	applied	\N	\N	\N	\N	129581	129581	297181
16693	22015	1	applied	\N	\N	\N	\N	129591	129591	297191
16698	22031	0	applied	\N	\N	\N	\N	129609	129609	297209
16704	22044	0	applied	\N	\N	\N	\N	129629	129629	297229
16705	22053	6	applied	\N	\N	\N	\N	129638	129638	297238
16707	21873	22	applied	\N	\N	\N	\N	129667	129667	297267
16707	21925	39	applied	\N	\N	\N	\N	129684	129684	297284
16707	21982	56	applied	\N	\N	\N	\N	129701	129701	297301
16707	22038	73	applied	\N	\N	\N	\N	129718	129718	297318
16707	21857	90	applied	\N	\N	\N	\N	129735	129735	297335
16707	21891	93	applied	\N	\N	\N	\N	129738	129738	297338
16707	21840	110	applied	\N	\N	\N	\N	129755	129755	297355
16708	22054	0	applied	\N	\N	\N	\N	129768	129768	297368
16709	21773	14	applied	\N	\N	\N	\N	129785	129785	297385
16709	21890	48	applied	\N	\N	\N	\N	129819	129819	297419
16709	21947	66	applied	\N	\N	\N	\N	129836	129836	297436
16499	21578	0	applied	\N	\N	1000000000	\N	128058	128058	295692
16709	21761	106	applied	\N	\N	\N	\N	129876	129876	297476
16709	21762	107	applied	\N	\N	\N	\N	129877	129877	297477
16709	21763	108	applied	\N	\N	\N	\N	129878	129878	297478
16709	21885	125	applied	\N	\N	\N	\N	129895	129895	297495
16710	22061	4	applied	\N	\N	\N	\N	129900	129900	297500
16711	22067	0	applied	\N	\N	\N	\N	129906	129906	297506
16712	22070	0	applied	\N	\N	\N	\N	129909	129909	297509
16721	21521	10	applied	\N	\N	1000000000	\N	129948	129948	297548
16721	21450	29	applied	\N	\N	\N	\N	129967	129967	297566
16721	21506	46	applied	\N	\N	\N	\N	129984	129984	297583
16721	21561	64	applied	\N	\N	\N	\N	130001	130001	297600
16721	21617	81	applied	\N	\N	\N	\N	130018	130018	297617
16721	21675	100	applied	\N	\N	\N	\N	130037	130037	297636
16721	21737	117	applied	\N	\N	\N	\N	130054	130054	297653
16722	22059	7	applied	\N	\N	\N	\N	130070	130070	297669
16722	22072	30	applied	\N	\N	\N	\N	130093	130093	297692
16725	22091	4	applied	\N	\N	\N	\N	130124	130124	297723
16728	22092	0	applied	\N	\N	\N	\N	130135	130135	297734
16730	22096	1	applied	\N	\N	\N	\N	130139	130139	297738
16739	22104	0	applied	\N	\N	\N	\N	130171	130171	297768
16741	22114	5	applied	\N	\N	\N	\N	130189	130189	297784
16742	22113	4	applied	\N	\N	\N	\N	130196	130196	297790
16743	20784	25	applied	\N	\N	\N	\N	130225	130225	297818
16743	21122	0	failed	Receiver_not_present	\N	\N	\N	130200	130200	\N
16743	20817	42	applied	\N	\N	\N	\N	130242	130242	297834
16743	20883	59	applied	\N	\N	\N	\N	130259	130259	297851
16743	20938	77	applied	\N	\N	\N	\N	130276	130276	297868
16743	20995	94	applied	\N	\N	\N	\N	130293	130293	297885
16743	21000	97	applied	\N	\N	\N	\N	130296	130296	297888
16743	21001	98	applied	\N	\N	\N	\N	130297	130297	297889
16743	21063	115	applied	\N	\N	\N	\N	130314	130314	297906
16745	22123	6	applied	\N	\N	\N	\N	130332	130332	297924
16750	22130	3	applied	\N	\N	\N	\N	130373	130373	297965
16751	22130	3	applied	\N	\N	\N	\N	130377	130377	297969
16756	21959	20	applied	\N	\N	\N	\N	130409	130409	298001
16756	22001	37	applied	\N	\N	\N	\N	130426	130426	298018
16756	22054	52	applied	\N	\N	\N	\N	130441	130441	298033
16756	22059	55	applied	\N	\N	\N	\N	130444	130444	298036
16756	22118	72	applied	\N	\N	\N	\N	130461	130461	298053
16756	21863	89	applied	\N	\N	\N	\N	130478	130478	298070
16756	21543	106	applied	\N	\N	\N	\N	130495	130495	298085
16756	21604	123	applied	\N	\N	\N	\N	130512	130512	298102
16758	22142	2	applied	\N	\N	\N	\N	130520	130520	298110
16767	21657	11	applied	\N	\N	\N	\N	130553	130553	298143
16767	21701	37	applied	\N	\N	\N	\N	130579	130579	298169
16767	21762	54	applied	\N	\N	\N	\N	130596	130596	298186
16769	22157	2	applied	\N	\N	\N	\N	130612	130612	298202
16770	22161	3	applied	\N	\N	\N	\N	130616	130616	298206
16772	22109	13	applied	\N	\N	\N	\N	130640	130640	298230
16772	21888	16	applied	\N	\N	\N	\N	130643	130643	298233
16772	21943	33	applied	\N	\N	\N	\N	130660	130660	298250
16772	21988	50	applied	\N	\N	\N	\N	130677	130677	298267
16772	22000	51	applied	\N	\N	\N	\N	130678	130678	298268
16772	22008	54	applied	\N	\N	\N	\N	130681	130681	298271
16772	22067	71	applied	\N	\N	\N	\N	130698	130698	298288
16772	22119	88	applied	\N	\N	\N	\N	130715	130715	298305
16772	21868	105	applied	\N	\N	\N	\N	130732	130732	298322
16772	21884	122	applied	\N	\N	\N	\N	130749	130749	298339
16774	22165	0	applied	\N	\N	\N	\N	130766	130766	298356
16776	22179	1	applied	\N	\N	\N	\N	130783	130783	298373
16777	22181	0	applied	\N	\N	\N	\N	130785	130785	298375
16781	22200	6	applied	\N	\N	\N	\N	130807	130807	298397
16784	22105	6	applied	\N	\N	\N	\N	130828	130828	298418
16784	22118	25	applied	\N	\N	\N	\N	130845	130845	298435
16784	22191	46	applied	\N	\N	\N	\N	130866	130866	298456
16784	22164	63	applied	\N	\N	\N	\N	130883	130883	298471
16794	22211	1	applied	\N	\N	\N	\N	130929	130929	298514
16786	21719	11	failed	Receiver_not_present	\N	\N	\N	130900	130900	\N
16797	22222	5	applied	\N	\N	\N	\N	130951	130951	298536
16798	22225	8	applied	\N	\N	\N	\N	130965	130965	298550
16803	22236	1	applied	\N	\N	\N	\N	130983	130983	298568
16804	22238	0	applied	\N	\N	\N	\N	130985	130985	298570
16807	22241	0	applied	\N	\N	\N	\N	130993	130993	298578
16812	22253	7	applied	\N	\N	\N	\N	131013	131013	298596
16818	22262	1	applied	\N	\N	\N	\N	131046	131046	298629
16826	22273	0	applied	\N	\N	\N	\N	131066	131066	298649
16830	22282	2	applied	\N	\N	\N	\N	131081	131081	298664
16833	21254	6	applied	\N	\N	\N	\N	131094	131094	298675
16833	21863	33	applied	\N	\N	\N	\N	131121	131121	298701
16836	21724	23	applied	\N	\N	\N	\N	131164	131164	298732
16836	21719	12	failed	Receiver_not_present	\N	\N	\N	131153	131153	\N
16836	21773	41	applied	\N	\N	\N	\N	131181	131181	298749
16836	21836	58	applied	\N	\N	\N	\N	131198	131198	298766
16836	21838	59	applied	\N	\N	\N	\N	131199	131199	298767
16838	22287	0	applied	\N	\N	\N	\N	131212	131212	298780
16843	22295	3	applied	\N	\N	\N	\N	131228	131228	298796
16844	22299	0	applied	\N	\N	\N	\N	131232	131232	298800
16854	22314	2	applied	\N	\N	\N	\N	131265	131265	298833
16855	22259	8	applied	\N	\N	\N	\N	131274	131274	298842
16855	22312	26	applied	\N	\N	\N	\N	131291	131291	298859
16855	22296	33	applied	\N	\N	\N	\N	131298	131298	298866
16855	22285	50	applied	\N	\N	\N	\N	131315	131315	298883
16855	22260	66	applied	\N	\N	\N	\N	131331	131331	298899
16855	22263	67	applied	\N	\N	\N	\N	131332	131332	298900
16864	22323	1	applied	\N	\N	\N	\N	131357	131357	298925
16868	22213	0	applied	\N	\N	1000000000	\N	131366	131366	298934
16868	22104	19	applied	\N	\N	\N	\N	131385	131385	298953
16868	22165	36	applied	\N	\N	\N	\N	131402	131402	298970
16868	22283	73	applied	\N	\N	\N	\N	131438	131438	299006
16868	22332	90	applied	\N	\N	\N	\N	131455	131455	299023
16868	22221	92	applied	\N	\N	\N	\N	131457	131457	299025
16868	21891	95	applied	\N	\N	\N	\N	131460	131460	299028
16868	22079	112	applied	\N	\N	\N	\N	131477	131477	299045
16869	22335	6	applied	\N	\N	\N	\N	131497	131497	299063
16870	22340	11	applied	\N	\N	\N	\N	131515	131515	299081
16871	22332	3	applied	\N	\N	\N	\N	131520	131520	299086
16879	22367	6	applied	\N	\N	\N	\N	131563	131563	299129
16883	22377	2	applied	\N	\N	\N	\N	131579	131579	299145
16884	22380	2	applied	\N	\N	\N	\N	131582	131582	299148
16885	22128	4	applied	\N	\N	\N	\N	131588	131588	299154
16709	21966	72	applied	\N	\N	\N	\N	129842	129842	297442
16885	22305	71	applied	\N	\N	\N	\N	131655	131655	299221
16885	22361	88	applied	\N	\N	\N	\N	131672	131672	299238
16885	22220	94	applied	\N	\N	\N	\N	131678	131678	299244
16885	22223	97	applied	\N	\N	\N	\N	131681	131681	299247
16885	22112	114	applied	\N	\N	\N	\N	131698	131698	131698
16889	21953	17	applied	\N	\N	\N	\N	131736	131736	299300
16889	22000	34	applied	\N	\N	\N	\N	131753	131753	299317
16889	22057	51	applied	\N	\N	\N	\N	131770	131770	299334
16889	22058	52	applied	\N	\N	\N	\N	131771	131771	299335
16889	22117	69	applied	\N	\N	\N	\N	131788	131788	299352
16889	22168	86	applied	\N	\N	\N	\N	131805	131805	299369
16889	22235	104	applied	\N	\N	\N	\N	131822	131822	299386
16894	22391	0	applied	\N	\N	\N	\N	131857	131857	299421
16897	22400	1	applied	\N	\N	\N	\N	131873	131873	299437
16900	22401	6	applied	\N	\N	\N	\N	131883	131883	299447
16902	22402	2	applied	\N	\N	\N	\N	131887	131887	299451
16902	22403	3	applied	\N	\N	\N	\N	131888	131888	299452
16904	22406	1	applied	\N	\N	\N	\N	131896	131896	299460
16911	22424	3	applied	\N	\N	\N	\N	131938	131938	299502
16912	22424	3	applied	\N	\N	\N	\N	131945	131945	299509
16918	22433	2	applied	\N	\N	\N	\N	131966	131966	299530
16920	22434	0	applied	\N	\N	\N	\N	131971	131971	299535
16922	22436	2	applied	\N	\N	\N	\N	131981	131981	299545
16925	22441	3	applied	\N	\N	\N	\N	132002	132002	299566
16928	22456	2	applied	\N	\N	\N	\N	132020	132020	299584
16929	22455	16	applied	\N	\N	\N	\N	132037	132037	299601
16936	22474	6	applied	\N	\N	\N	\N	132065	132065	299629
16937	22472	4	applied	\N	\N	\N	\N	132070	132070	299634
16947	22330	10	applied	\N	\N	\N	\N	132107	132107	299671
16947	22388	27	applied	\N	\N	\N	\N	132124	132124	299688
16947	22439	44	applied	\N	\N	\N	\N	132141	132141	299705
16947	22223	61	applied	\N	\N	\N	\N	132158	132158	299722
16947	22011	77	applied	\N	\N	\N	\N	132174	132174	299738
16947	21919	94	applied	\N	\N	\N	\N	132191	132191	299753
16947	21944	101	applied	\N	\N	\N	\N	132198	132198	299760
16947	21948	102	applied	\N	\N	\N	\N	132199	132199	299761
16947	22183	120	applied	\N	\N	\N	\N	132216	132216	299778
16953	22495	1	applied	\N	\N	\N	\N	132233	132233	299795
16954	22495	1	applied	\N	\N	\N	\N	132237	132237	299799
16963	22511	1	applied	\N	\N	\N	\N	132274	132274	299836
16964	22221	5	applied	\N	\N	\N	\N	132284	132284	299846
16965	22510	0	applied	\N	\N	\N	\N	132287	132287	299849
16976	22520	1	applied	\N	\N	\N	\N	132329	132329	299891
16979	22521	0	applied	\N	\N	\N	\N	132331	132331	299893
17001	22546	0	applied	\N	\N	\N	\N	132378	132378	299940
17002	22548	0	applied	\N	\N	\N	\N	132380	132380	299942
17009	22564	0	applied	\N	\N	\N	\N	132404	132404	299966
17010	22564	0	applied	\N	\N	\N	\N	132409	132409	299971
17013	22573	0	applied	\N	\N	\N	\N	132420	132420	299982
17020	22594	6	applied	\N	\N	\N	\N	132450	132450	300012
17021	22594	6	applied	\N	\N	\N	\N	132457	132457	300019
17022	22589	1	applied	\N	\N	\N	\N	132459	132459	300021
17027	22512	13	applied	\N	\N	\N	\N	132493	132493	300055
17027	22532	21	applied	\N	\N	\N	\N	132501	132501	300063
17027	22564	36	applied	\N	\N	\N	\N	132515	132515	300077
17027	22505	53	applied	\N	\N	\N	\N	132532	132532	300094
17027	22526	70	applied	\N	\N	\N	\N	132549	132549	300111
17027	22535	87	applied	\N	\N	\N	\N	132566	132566	300128
17027	22581	104	applied	\N	\N	\N	\N	132583	132583	300145
17028	22599	1	applied	\N	\N	\N	\N	132590	132590	300152
17044	22622	1	applied	\N	\N	\N	\N	132639	132639	300201
17050	22636	2	applied	\N	\N	\N	\N	132659	132659	300221
17052	22428	16	applied	\N	\N	\N	\N	132679	132679	300241
17052	22466	27	applied	\N	\N	\N	\N	132690	132690	300252
17052	22490	37	applied	\N	\N	\N	\N	132700	132700	300262
17052	22528	55	applied	\N	\N	\N	\N	132717	132717	300279
17052	22557	67	applied	\N	\N	\N	\N	132729	132729	300291
17052	22576	75	applied	\N	\N	\N	\N	132737	132737	300299
17052	22634	92	applied	\N	\N	\N	\N	132754	132754	300316
17052	22416	109	applied	\N	\N	\N	\N	132771	132771	300333
17055	22641	0	applied	\N	\N	\N	\N	132794	132794	300356
17056	22640	1	applied	\N	\N	1000000000	\N	132800	132800	300362
17059	22657	2	applied	\N	\N	\N	\N	132816	132816	300378
17061	22662	1	applied	\N	\N	\N	\N	132821	132821	300383
17063	22210	19	applied	\N	\N	\N	\N	132847	132847	300409
17068	22679	1	applied	\N	\N	\N	\N	132873	132873	300435
17079	22697	1	applied	\N	\N	\N	\N	132906	132906	300468
17080	22707	3	applied	\N	\N	\N	\N	132916	132916	300478
17082	22716	1	applied	\N	\N	\N	\N	132929	132929	300491
17085	22731	5	applied	\N	\N	\N	\N	132944	132944	300506
17086	22600	1	applied	\N	\N	\N	\N	132946	132946	300508
17086	22648	18	applied	\N	\N	\N	\N	132963	132963	300525
17086	22704	35	applied	\N	\N	\N	\N	132980	132980	300542
17086	22716	38	applied	\N	\N	\N	\N	132983	132983	300545
17086	22726	42	applied	\N	\N	\N	\N	132986	132986	300548
17086	22633	59	applied	\N	\N	\N	\N	133003	133003	300565
17086	22692	76	applied	\N	\N	\N	\N	133020	133020	300582
17086	22623	93	applied	\N	\N	\N	\N	133037	133037	300599
17086	22653	110	applied	\N	\N	\N	\N	133054	133054	300616
17088	22736	1	applied	\N	\N	\N	\N	133074	133074	300636
17095	22751	3	applied	\N	\N	\N	\N	133092	133092	300654
17098	22743	15	applied	\N	\N	\N	\N	133119	133119	300681
17098	22742	20	applied	\N	\N	\N	\N	133124	133124	300686
17098	22750	23	applied	\N	\N	\N	\N	133127	133127	300689
17108	22762	0	applied	\N	\N	\N	\N	133158	133158	300720
17109	22766	2	applied	\N	\N	\N	\N	133162	133162	300724
17115	22719	11	applied	\N	\N	\N	\N	133186	133186	300748
17115	22764	28	applied	\N	\N	\N	\N	133203	133203	300765
17115	22717	45	applied	\N	\N	\N	\N	133220	133220	300782
17115	22728	62	applied	\N	\N	\N	\N	133237	133237	300799
17115	22771	79	applied	\N	\N	\N	\N	133254	133254	300816
17126	22786	0	applied	\N	\N	\N	\N	133279	133279	300841
17127	22770	8	applied	\N	\N	\N	\N	133289	133289	300851
17127	22761	25	applied	\N	\N	\N	\N	133306	133306	300868
17128	22789	0	applied	\N	\N	\N	\N	133317	133317	300879
17133	22797	1	applied	\N	\N	\N	\N	133331	133331	300893
17134	22796	0	applied	\N	\N	\N	\N	133334	133334	300896
17142	22813	0	applied	\N	\N	\N	\N	133355	133355	300917
17142	22819	6	applied	\N	\N	\N	\N	133361	133361	300923
17145	22825	0	applied	\N	\N	\N	\N	133370	133370	300932
16885	22195	38	applied	\N	\N	\N	\N	131622	131622	299188
17151	22655	54	applied	\N	\N	\N	\N	133448	133448	301010
17151	22735	78	applied	\N	\N	\N	\N	133472	133472	301034
17151	22775	94	applied	\N	\N	\N	\N	133488	133488	301050
17151	22814	112	applied	\N	\N	\N	\N	133505	133505	301067
17152	22845	0	applied	\N	\N	\N	\N	133519	133519	301081
17153	22848	0	applied	\N	\N	\N	\N	133522	133522	301084
17154	22851	3	applied	\N	\N	\N	\N	133535	133535	301097
17155	22851	3	applied	\N	\N	\N	\N	133545	133545	301107
17156	22848	0	applied	\N	\N	\N	\N	133552	133552	301114
17162	22868	3	applied	\N	\N	\N	\N	133602	133602	301164
17165	22882	0	applied	\N	\N	\N	\N	133616	133616	301178
17166	22830	4	applied	\N	\N	1000000000	\N	133623	133623	301185
17166	22727	25	applied	\N	\N	\N	\N	133644	133644	301206
17166	22770	41	applied	\N	\N	\N	\N	133660	133660	301222
17166	22777	44	applied	\N	\N	\N	\N	133663	133663	301225
17166	22815	61	applied	\N	\N	\N	\N	133680	133680	301242
17166	22879	78	applied	\N	\N	\N	\N	133697	133697	301259
17166	22702	95	applied	\N	\N	\N	\N	133714	133714	301276
17166	22686	112	applied	\N	\N	\N	\N	133731	133731	301293
17167	22892	7	applied	\N	\N	\N	\N	133752	133752	301314
17168	22892	7	applied	\N	\N	\N	\N	133762	133762	301324
17169	22500	1	applied	\N	\N	1000000000	\N	133766	133766	301328
17173	22905	0	applied	\N	\N	\N	\N	133789	133789	301351
17181	22916	1	applied	\N	\N	\N	\N	133821	133821	301383
17185	22916	0	applied	\N	\N	\N	\N	133834	133834	301396
17189	22924	3	applied	\N	\N	\N	\N	133847	133847	301409
17194	22943	3	applied	\N	\N	\N	\N	133867	133867	301429
17196	22943	2	applied	\N	\N	\N	\N	133874	133874	301436
17203	22957	1	applied	\N	\N	\N	\N	133898	133898	301460
17206	22958	2	applied	\N	\N	\N	\N	133916	133916	301478
17207	22960	1	applied	\N	\N	\N	\N	133918	133918	301480
17217	22972	0	applied	\N	\N	\N	\N	133945	133945	301507
17220	22979	0	applied	\N	\N	\N	\N	133966	133966	301528
17222	22985	0	applied	\N	\N	\N	\N	133972	133972	301534
17224	22987	2	applied	\N	\N	\N	\N	133980	133980	301542
17225	22990	2	applied	\N	\N	\N	\N	133983	133983	301545
17226	22993	2	applied	\N	\N	\N	\N	133986	133986	301548
17230	23007	4	applied	\N	\N	\N	\N	134006	134006	301568
17238	23021	0	applied	\N	\N	\N	\N	134046	134046	301608
17242	23023	0	applied	\N	\N	\N	\N	134062	134062	301624
17245	23031	1	applied	\N	\N	\N	\N	134076	134076	301638
17248	22612	7	applied	\N	\N	\N	\N	134088	134088	301650
17248	22649	24	applied	\N	\N	\N	\N	134105	134105	301667
17248	22705	41	applied	\N	\N	\N	\N	134122	134122	301684
17248	22797	75	applied	\N	\N	\N	\N	134156	134156	301718
17248	22825	85	applied	\N	\N	\N	\N	134166	134166	301728
17248	22836	88	applied	\N	\N	\N	\N	134169	134169	301731
17248	22895	105	applied	\N	\N	\N	\N	134186	134186	301748
17248	22953	123	applied	\N	\N	\N	\N	134203	134203	301765
17249	23035	0	applied	\N	\N	\N	\N	134206	134206	301768
17254	23047	3	applied	\N	\N	\N	\N	134233	134233	301795
17258	23055	4	applied	\N	\N	\N	\N	134247	134247	301809
17267	23071	0	applied	\N	\N	\N	\N	134271	134271	301833
17274	23082	1	applied	\N	\N	\N	\N	134282	134282	301844
17282	23089	3	applied	\N	\N	\N	\N	134304	134304	301866
17285	23093	0	applied	\N	\N	\N	\N	134314	134314	301876
17285	23096	3	applied	\N	\N	\N	\N	134317	134317	301879
17294	23119	0	applied	\N	\N	\N	\N	134349	134349	301911
17296	23126	4	applied	\N	\N	\N	\N	134366	134366	301928
17298	23135	1	applied	\N	\N	\N	\N	134375	134375	301937
17304	23155	0	applied	\N	\N	\N	\N	134416	134416	301978
17306	23165	0	applied	\N	\N	\N	\N	134426	134426	301988
17309	23170	0	applied	\N	\N	\N	\N	134434	134434	301996
17315	23179	0	applied	\N	\N	\N	\N	134454	134454	302016
17323	23197	5	applied	\N	\N	\N	\N	134480	134480	302042
17325	23192	0	applied	\N	\N	\N	\N	134489	134489	302051
17326	23192	0	applied	\N	\N	\N	\N	134496	134496	302058
17326	23193	1	applied	\N	\N	\N	\N	134497	134497	302059
17328	23168	13	applied	\N	\N	\N	\N	134518	134518	302080
17328	23147	30	applied	\N	\N	\N	\N	134535	134535	302097
17328	23162	47	applied	\N	\N	\N	\N	134552	134552	302114
17328	23197	65	applied	\N	\N	\N	\N	134569	134569	302131
17329	23210	9	applied	\N	\N	\N	\N	134581	134581	302143
17331	23206	5	applied	\N	\N	\N	\N	134599	134599	302161
17331	23209	6	applied	\N	\N	\N	\N	134600	134600	302162
17332	23215	3	applied	\N	\N	\N	\N	134606	134606	302168
17346	23242	1	applied	\N	\N	\N	\N	134652	134652	302214
17350	23246	2	applied	\N	\N	\N	\N	134661	134661	302223
17355	23256	2	applied	\N	\N	\N	\N	134683	134683	302245
17358	23265	2	applied	\N	\N	\N	\N	134704	134704	302266
17359	23265	2	applied	\N	\N	\N	\N	134707	134707	302269
17360	23263	0	applied	\N	\N	\N	\N	134708	134708	302270
17368	23275	2	applied	\N	\N	\N	\N	134741	134741	302303
17375	23283	0	applied	\N	\N	\N	\N	134762	134762	302324
17379	23291	0	applied	\N	\N	\N	\N	134776	134776	302338
17381	23308	3	applied	\N	\N	\N	\N	134793	134793	302355
17386	23314	1	applied	\N	\N	\N	\N	134810	134810	302372
17388	23212	10	applied	\N	\N	\N	\N	134827	134827	302389
17388	23263	27	applied	\N	\N	\N	\N	134844	134844	302406
17388	23311	44	applied	\N	\N	\N	\N	134861	134861	302423
17388	23221	61	applied	\N	\N	\N	\N	134878	134878	302440
17388	23231	64	applied	\N	\N	\N	\N	134881	134881	302443
17388	23188	98	applied	\N	\N	\N	\N	134915	134915	302477
17388	23245	115	applied	\N	\N	\N	\N	134932	134932	302494
17389	23322	2	applied	\N	\N	\N	\N	134944	134944	302506
17390	23331	8	applied	\N	\N	\N	\N	134962	134962	302524
17391	22806	4	applied	\N	\N	1000000000	\N	134970	134970	302532
17397	23349	2	applied	\N	\N	\N	\N	135004	135004	302566
17399	23357	1	applied	\N	\N	\N	\N	135021	135021	302583
17400	23363	7	applied	\N	\N	\N	\N	135036	135036	302598
17404	23372	2	applied	\N	\N	\N	\N	135047	135047	302609
17405	23374	1	applied	\N	\N	\N	\N	135049	135049	302611
17421	23404	5	applied	\N	\N	\N	\N	135103	135103	302665
17422	23400	1	applied	\N	\N	\N	\N	135105	135105	302667
17422	23401	2	applied	\N	\N	\N	\N	135106	135106	302668
17423	23401	2	applied	\N	\N	\N	\N	135112	135112	302674
17424	23407	2	applied	\N	\N	\N	\N	135118	135118	302680
17432	23174	7	applied	\N	\N	\N	\N	135154	135154	302716
17432	23275	42	applied	\N	\N	\N	\N	135188	135188	302750
17432	23322	59	applied	\N	\N	\N	\N	135205	135205	302767
17151	22600	37	applied	\N	\N	\N	\N	133431	133431	300993
17432	23172	106	applied	\N	\N	\N	\N	135252	135252	302814
17432	23262	123	applied	\N	\N	\N	\N	135269	135269	302831
17440	23435	3	applied	\N	\N	\N	\N	135302	135302	302864
17442	23434	2	applied	\N	\N	\N	\N	135313	135313	302875
17443	23433	1	applied	\N	\N	\N	\N	135318	135318	302880
17443	23434	2	applied	\N	\N	\N	\N	135319	135319	302881
17447	23444	4	applied	\N	\N	\N	\N	135341	135341	302903
17450	23455	7	applied	\N	\N	\N	\N	135354	135354	302916
17451	23449	5	applied	\N	\N	\N	\N	135370	135370	302932
17451	22640	13	applied	\N	\N	1000000000	\N	135378	135378	302940
17451	22667	29	applied	\N	\N	\N	\N	135394	135394	302956
17451	22723	47	applied	\N	\N	\N	\N	135411	135411	302973
17451	22764	64	applied	\N	\N	\N	\N	135428	135428	302990
17451	22860	98	applied	\N	\N	\N	\N	135462	135462	303024
17451	22921	115	applied	\N	\N	\N	\N	135479	135479	303041
17452	23471	5	applied	\N	\N	\N	\N	135495	135495	303057
17454	23472	0	applied	\N	\N	\N	\N	135503	135503	303065
17454	23473	1	applied	\N	\N	\N	\N	135504	135504	303066
17455	23485	6	applied	\N	\N	\N	\N	135516	135516	303078
17456	23502	15	applied	\N	\N	\N	\N	135533	135533	303095
17457	23487	0	applied	\N	\N	\N	\N	135537	135537	303099
17457	23490	3	applied	\N	\N	\N	\N	135540	135540	303102
17457	23511	20	applied	\N	\N	\N	\N	135557	135557	303119
17458	23501	16	applied	\N	\N	\N	\N	135589	135589	303151
17458	23520	33	applied	\N	\N	\N	\N	135606	135606	303168
17459	23507	1	applied	\N	\N	\N	\N	135610	135610	303172
17462	23507	1	applied	\N	\N	\N	\N	135645	135645	303207
17462	23519	18	applied	\N	\N	\N	\N	135662	135662	303224
17463	23523	14	applied	\N	\N	\N	\N	135682	135682	303244
17464	23543	12	applied	\N	\N	\N	\N	135704	135704	303266
17466	23451	4	applied	\N	\N	\N	\N	135715	135715	303277
17466	23468	21	applied	\N	\N	\N	\N	135732	135732	303294
17466	23423	39	applied	\N	\N	\N	\N	135749	135749	303311
17466	23131	56	applied	\N	\N	\N	\N	135766	135766	303328
17466	23513	73	applied	\N	\N	\N	\N	135783	135783	303345
17466	23149	97	applied	\N	\N	\N	\N	135807	135807	303369
17466	23159	100	applied	\N	\N	\N	\N	135810	135810	303372
17466	23213	117	applied	\N	\N	\N	\N	135827	135827	303389
17467	23548	12	applied	\N	\N	\N	\N	135847	135847	303409
17468	23540	9	applied	\N	\N	\N	\N	135856	135856	303418
17468	23548	26	applied	\N	\N	\N	\N	135873	135873	303435
17472	23558	16	applied	\N	\N	\N	\N	135894	135894	303456
17474	23563	4	applied	\N	\N	\N	\N	135911	135911	303473
17474	23568	27	applied	\N	\N	\N	\N	135934	135934	303496
17474	23569	28	applied	\N	\N	\N	\N	135935	135935	303497
17477	23577	1	applied	\N	\N	\N	\N	135943	135943	303505
17480	23587	2	applied	\N	\N	\N	\N	135969	135969	303531
17481	23599	6	applied	\N	\N	\N	\N	135981	135981	303543
17484	23603	2	applied	\N	\N	\N	\N	136000	136000	303562
17485	23604	3	applied	\N	\N	\N	\N	136009	136009	303571
17486	23599	5	applied	\N	\N	\N	\N	136017	136017	303579
17492	23623	6	applied	\N	\N	\N	\N	136067	136067	303629
17493	23625	0	applied	\N	\N	\N	\N	136069	136069	303631
17502	23643	2	applied	\N	\N	\N	\N	136093	136093	303655
17503	23645	1	applied	\N	\N	\N	\N	136095	136095	303657
17504	23652	5	applied	\N	\N	\N	\N	136102	136102	303664
17505	23649	2	applied	\N	\N	\N	\N	136105	136105	303667
17510	23664	5	applied	\N	\N	\N	\N	136129	136129	303691
17511	23653	0	applied	\N	\N	\N	\N	136133	136133	303695
17520	23679	1	applied	\N	\N	\N	\N	136176	136176	303738
17525	23682	0	applied	\N	\N	\N	\N	136185	136185	303747
17532	23712	2	applied	\N	\N	\N	\N	136225	136225	303787
17534	23717	1	applied	\N	\N	\N	\N	136230	136230	303792
17535	23723	8	applied	\N	\N	\N	\N	136248	136248	303810
17536	23728	0	applied	\N	\N	\N	\N	136253	136253	303815
17541	23737	3	applied	\N	\N	\N	\N	136271	136271	303833
17549	23747	2	applied	\N	\N	\N	\N	136302	136302	303864
17554	23751	0	applied	\N	\N	\N	\N	136315	136315	303877
17556	23751	0	applied	\N	\N	\N	\N	136321	136321	303883
17565	23764	4	applied	\N	\N	\N	\N	136355	136355	303917
17572	23774	5	applied	\N	\N	\N	\N	136380	136380	303942
17573	23742	3	applied	\N	\N	\N	\N	136384	136384	303946
17573	23738	15	applied	\N	\N	\N	\N	136396	136396	303958
17573	23762	32	applied	\N	\N	\N	\N	136413	136413	303975
17580	23778	1	applied	\N	\N	\N	\N	136431	136431	303993
17583	23784	0	applied	\N	\N	\N	\N	136442	136442	304004
17585	23790	6	applied	\N	\N	\N	\N	136466	136466	304028
17592	23455	8	applied	\N	\N	\N	\N	136506	136506	304068
17592	23477	25	applied	\N	\N	\N	\N	136523	136523	304085
17596	23455	7	applied	\N	\N	\N	\N	136551	136551	304113
17596	23473	24	applied	\N	\N	\N	\N	136568	136568	304130
17596	23412	41	applied	\N	\N	\N	\N	136585	136585	304147
17596	23489	58	applied	\N	\N	\N	\N	136602	136602	304164
17596	23570	68	applied	\N	\N	\N	\N	136612	136612	304174
17596	23573	69	applied	\N	\N	\N	\N	136613	136613	304175
17596	23648	87	applied	\N	\N	\N	\N	136630	136630	304192
17596	23699	104	applied	\N	\N	\N	\N	136647	136647	304209
17596	23514	121	applied	\N	\N	\N	\N	136664	136664	304226
17597	23809	0	applied	\N	\N	\N	\N	136669	136669	304231
17598	23758	1	applied	\N	\N	\N	\N	136673	136673	304235
17598	23811	18	applied	\N	\N	\N	\N	136690	136690	304252
17600	23798	15	applied	\N	\N	\N	\N	136719	136719	304281
17601	23068	12	applied	\N	\N	\N	\N	136737	136737	304299
17601	23475	29	applied	\N	\N	\N	\N	136754	136754	304316
17601	23099	47	applied	\N	\N	\N	\N	136771	136771	304333
17601	23496	64	applied	\N	\N	\N	\N	136788	136788	304350
17601	23498	66	applied	\N	\N	\N	\N	136790	136790	304352
17601	23525	83	applied	\N	\N	\N	\N	136807	136807	304369
17601	23554	100	applied	\N	\N	\N	\N	136824	136824	304386
17601	23174	117	applied	\N	\N	\N	\N	136841	136841	304403
17606	23823	3	applied	\N	\N	\N	\N	136871	136871	304433
17609	23828	0	applied	\N	\N	\N	\N	136885	136885	304447
17609	23829	1	applied	\N	\N	\N	\N	136886	136886	304448
17612	23830	2	applied	\N	\N	\N	\N	136899	136899	304461
17624	23846	2	applied	\N	\N	\N	\N	136934	136934	304496
17627	23852	5	applied	\N	\N	\N	\N	136949	136949	304511
17628	23848	1	applied	\N	\N	\N	\N	136951	136951	304513
17628	23849	2	applied	\N	\N	\N	\N	136952	136952	304514
17632	22896	13	applied	\N	\N	\N	\N	136978	136978	304540
17632	23474	30	applied	\N	\N	\N	\N	136995	136995	304557
17432	23171	93	applied	\N	\N	\N	\N	135239	135239	302801
17632	23517	82	applied	\N	\N	\N	\N	137046	137046	304608
17632	23536	94	applied	\N	\N	\N	\N	137058	137058	304620
17632	23550	99	applied	\N	\N	\N	\N	137063	137063	304625
17632	23553	102	applied	\N	\N	\N	\N	137066	137066	304628
17632	23011	119	applied	\N	\N	\N	\N	137083	137083	304645
17635	23859	0	applied	\N	\N	\N	\N	137096	137096	304658
17639	23577	4	applied	\N	\N	\N	\N	137112	137112	304674
17639	23570	22	applied	\N	\N	\N	\N	137129	137129	304691
17639	23647	39	applied	\N	\N	\N	\N	137146	137146	304708
17639	23692	56	applied	\N	\N	\N	\N	137163	137163	304725
17639	23713	73	applied	\N	\N	\N	\N	137180	137180	304742
17639	23734	80	applied	\N	\N	\N	\N	137187	137187	304749
17639	23757	88	applied	\N	\N	\N	\N	137195	137195	304757
17639	23586	105	applied	\N	\N	\N	\N	137212	137212	304774
17639	23613	122	applied	\N	\N	\N	\N	137229	137229	304791
17645	23878	2	applied	\N	\N	1000000000	\N	137256	137256	304818
17646	23880	4	applied	\N	\N	1000000000	\N	137265	137265	304827
17647	23878	2	applied	\N	\N	1000000000	\N	137270	137270	304832
17647	23879	3	applied	\N	\N	1000000000	\N	137271	137271	304833
17648	23888	5	applied	\N	\N	\N	\N	137280	137280	304842
17651	23073	15	applied	\N	\N	\N	\N	137301	137301	304863
17651	23122	32	applied	\N	\N	\N	\N	137318	137318	304880
17651	23165	49	applied	\N	\N	\N	\N	137335	137335	304897
17651	23220	67	applied	\N	\N	\N	\N	137352	137352	304914
17651	23256	80	applied	\N	\N	\N	\N	137365	137365	304927
17651	23306	97	applied	\N	\N	\N	\N	137382	137382	304944
17651	23357	114	applied	\N	\N	\N	\N	137399	137399	304961
17653	23879	3	applied	\N	\N	1000000000	\N	137416	137416	304978
17660	23899	1	applied	\N	\N	\N	\N	137434	137434	304996
17661	23903	3	applied	\N	\N	\N	\N	137438	137438	305000
17670	23232	20	applied	\N	\N	\N	\N	137479	137479	305041
17670	23241	23	applied	\N	\N	\N	\N	137482	137482	305044
17670	23288	41	applied	\N	\N	\N	\N	137499	137499	305061
17670	23399	75	applied	\N	\N	\N	\N	137533	137533	305095
17670	23461	92	applied	\N	\N	\N	\N	137550	137550	305112
17670	23579	109	applied	\N	\N	\N	\N	137567	137567	305129
17673	23922	6	applied	\N	\N	\N	\N	137594	137594	305156
17674	23916	0	applied	\N	\N	\N	\N	137598	137598	305160
17674	23923	7	applied	\N	\N	\N	\N	137605	137605	305167
17678	23878	2	applied	\N	\N	1000000000	\N	137616	137616	305178
17686	23878	3	applied	\N	\N	1000000000	\N	137639	137639	305201
17689	23946	7	applied	\N	\N	\N	\N	137662	137662	305224
17690	23946	7	applied	\N	\N	\N	\N	137678	137678	305240
17697	23965	0	applied	\N	\N	\N	\N	137703	137703	305265
17704	23973	1	applied	\N	\N	\N	\N	137721	137721	305283
17706	23974	1	applied	\N	\N	\N	\N	137726	137726	305288
17714	23988	3	applied	\N	\N	\N	\N	137747	137747	305309
17721	23998	5	applied	\N	\N	\N	\N	137786	137786	305348
17722	24000	0	applied	\N	\N	\N	\N	137788	137788	305350
17733	24028	0	applied	\N	\N	\N	\N	137837	137837	137837
17734	24038	2	applied	\N	\N	\N	\N	137847	137847	305407
17735	24037	1	applied	\N	\N	\N	\N	137853	137853	137853
17736	24052	9	applied	\N	\N	\N	\N	137868	137868	305427
17738	24054	0	applied	\N	\N	\N	\N	137877	137877	305436
17743	24059	6	applied	\N	\N	\N	\N	137910	137910	305469
17744	24055	1	applied	\N	\N	\N	\N	137913	137913	305472
17748	24061	0	applied	\N	\N	\N	\N	137936	137936	305495
17748	24065	4	applied	\N	\N	\N	\N	137940	137940	305499
17749	24067	0	applied	\N	\N	\N	\N	137942	137942	305501
17751	23878	8	applied	\N	\N	1000000000	\N	137958	137958	305515
17751	23868	29	applied	\N	\N	\N	\N	137978	137978	305535
17751	23912	46	applied	\N	\N	\N	\N	137995	137995	305552
17751	23943	63	applied	\N	\N	\N	\N	138012	138012	305569
17756	24081	0	applied	\N	\N	\N	\N	138032	138032	305589
17758	24086	5	applied	\N	\N	\N	\N	138061	138061	305618
17758	24091	10	applied	\N	\N	\N	\N	138066	138066	305623
17759	24094	1	applied	\N	\N	\N	\N	138069	138069	305626
17765	24097	1	applied	\N	\N	\N	\N	138087	138087	305644
17769	24115	2	applied	\N	\N	\N	\N	138112	138112	305669
17771	24117	1	applied	\N	\N	\N	\N	138129	138129	305684
17772	24132	1	applied	\N	\N	\N	\N	138144	138144	305697
17774	24138	3	applied	\N	\N	\N	\N	138154	138154	305707
17775	24143	8	applied	\N	\N	\N	\N	138169	138169	305722
17777	24149	0	applied	\N	\N	\N	\N	138175	138175	305728
17789	24166	2	applied	\N	\N	\N	\N	138204	138204	305757
17796	24175	1	applied	\N	\N	\N	\N	138227	138227	305780
17797	24178	2	applied	\N	\N	\N	\N	138230	138230	305783
17799	24185	1	applied	\N	\N	\N	\N	138237	138237	305790
17800	24184	0	applied	\N	\N	\N	\N	138239	138239	305792
17814	24208	0	applied	\N	\N	\N	\N	138291	138291	305841
17821	24219	2	applied	\N	\N	\N	\N	138311	138311	305861
17825	24228	4	applied	\N	\N	\N	\N	138330	138330	305880
17834	24239	2	applied	\N	\N	\N	\N	138361	138361	305911
17836	24245	1	applied	\N	\N	\N	\N	138374	138374	305924
17838	24248	2	applied	\N	\N	\N	\N	138385	138385	305935
17841	24245	1	applied	\N	\N	\N	\N	138396	138396	305946
17841	24249	3	applied	\N	\N	\N	\N	138398	138398	305948
17841	24250	6	applied	\N	\N	\N	\N	138401	138401	305951
17847	24253	3	applied	\N	\N	\N	\N	138431	138431	305981
17855	24028	8	applied	\N	\N	\N	\N	138462	138462	138462
17853	24261	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	138448	138448	\N
17855	23934	24	applied	\N	\N	1000000000	\N	138477	138477	306023
17855	23945	45	applied	\N	\N	\N	\N	138498	138498	306044
17855	23965	52	applied	\N	\N	\N	\N	138505	138505	306051
17855	23977	58	applied	\N	\N	\N	\N	138511	138511	306057
17855	23982	61	applied	\N	\N	\N	\N	138514	138514	306060
17855	24030	78	applied	\N	\N	\N	\N	138531	138531	306077
17855	24084	95	applied	\N	\N	\N	\N	138548	138548	306094
17855	24149	112	applied	\N	\N	\N	\N	138565	138565	306111
17864	24273	0	applied	\N	\N	\N	\N	138605	138605	306151
17868	24290	2	applied	\N	\N	\N	\N	138658	138658	306199
17866	24190	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	138617	138617	\N
17872	24303	2	applied	\N	\N	\N	\N	138676	138676	306217
17875	24308	1	applied	\N	\N	\N	\N	138685	138685	306226
17876	24308	1	applied	\N	\N	\N	\N	138689	138689	306230
17880	24324	0	applied	\N	\N	\N	\N	138708	138708	306249
17887	24336	2	applied	\N	\N	\N	\N	138736	138736	306277
17889	24342	2	applied	\N	\N	\N	\N	138746	138746	306287
17632	23494	65	applied	\N	\N	\N	\N	137029	137029	304591
17896	24181	5	applied	\N	\N	\N	\N	138780	138780	306321
17896	24196	9	applied	\N	\N	\N	\N	138784	138784	306325
17896	24264	26	applied	\N	\N	\N	\N	138801	138801	306342
17896	24316	43	applied	\N	\N	\N	\N	138818	138818	306359
17896	24216	85	applied	\N	\N	\N	\N	138860	138860	306399
17896	24252	102	applied	\N	\N	\N	\N	138877	138877	306416
17896	24241	117	applied	\N	\N	\N	\N	138891	138891	306430
17897	24354	7	applied	\N	\N	\N	\N	138907	138907	306446
17898	24352	5	applied	\N	\N	\N	\N	138922	138922	306461
17899	24369	5	applied	\N	\N	\N	\N	138939	138939	306478
17900	24364	0	applied	\N	\N	\N	\N	138941	138941	306480
17905	24372	3	applied	\N	\N	\N	\N	138979	138979	306518
17908	24378	0	applied	\N	\N	\N	\N	138990	138990	306529
17912	24385	3	applied	\N	\N	\N	\N	139005	139005	306544
17915	24388	0	applied	\N	\N	\N	\N	139020	139020	306559
17917	24398	0	applied	\N	\N	\N	\N	139030	139030	306569
17926	24415	2	applied	\N	\N	\N	\N	139056	139056	306594
17931	24418	1	applied	\N	\N	\N	\N	139075	139075	306612
17932	24422	1	applied	\N	\N	\N	\N	139079	139079	306616
17943	24443	0	applied	\N	\N	\N	\N	139117	139117	306652
17945	24453	4	applied	\N	\N	\N	\N	139127	139127	306662
17946	24450	1	applied	\N	\N	\N	\N	139131	139131	306666
17947	24450	1	applied	\N	\N	\N	\N	139138	139138	306673
17953	24237	11	applied	\N	\N	\N	\N	139175	139175	306710
17953	24290	28	applied	\N	\N	\N	\N	139192	139192	306727
17953	24315	35	applied	\N	\N	\N	\N	139199	139199	306734
17953	24328	39	applied	\N	\N	\N	\N	139203	139203	306738
17953	24371	51	applied	\N	\N	\N	\N	139215	139215	306750
17953	24435	69	applied	\N	\N	\N	\N	139232	139232	306767
17953	24233	111	applied	\N	\N	\N	\N	139274	139274	306805
17954	24471	2	applied	\N	\N	\N	\N	139291	139291	306822
17959	23993	3	applied	\N	\N	1000000000	\N	139309	139309	306838
17959	24092	23	applied	\N	\N	\N	\N	139329	139329	306851
17959	24274	40	applied	\N	\N	\N	\N	139346	139346	306868
17959	24465	57	applied	\N	\N	\N	\N	139363	139363	306885
17961	24041	35	applied	\N	\N	\N	\N	139406	139406	306919
17961	24120	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	139377	139377	\N
17961	24098	52	applied	\N	\N	\N	\N	139423	139423	306936
17961	24157	69	applied	\N	\N	\N	\N	139440	139440	306953
17961	24239	85	applied	\N	\N	\N	\N	139456	139456	306969
17961	24309	91	applied	\N	\N	\N	\N	139462	139462	306975
17964	24496	4	applied	\N	\N	\N	\N	139479	139479	306992
17965	24495	3	applied	\N	\N	\N	\N	139488	139488	307001
17966	24496	4	applied	\N	\N	\N	\N	139499	139499	307012
17971	24505	1	applied	\N	\N	\N	\N	139514	139514	307027
17973	24507	2	applied	\N	\N	\N	\N	139524	139524	307037
17977	24514	0	applied	\N	\N	1000000000	\N	139550	139550	307063
17979	24519	1	applied	\N	\N	\N	\N	139559	139559	307072
17981	24526	4	applied	\N	\N	\N	\N	139571	139571	307084
17983	24543	7	applied	\N	\N	\N	\N	139588	139588	307101
17989	24565	2	applied	\N	\N	\N	\N	139613	139613	307125
17992	24575	4	applied	\N	\N	1000000000	\N	139628	139628	307140
17994	24492	8	applied	\N	\N	\N	\N	139647	139647	307159
17994	24545	26	applied	\N	\N	\N	\N	139664	139664	307176
17994	24498	43	applied	\N	\N	\N	\N	139681	139681	307192
17994	24531	52	applied	\N	\N	\N	\N	139690	139690	307201
17994	24565	69	applied	\N	\N	\N	\N	139707	139707	307218
17994	24562	86	applied	\N	\N	\N	\N	139724	139724	307235
18001	24594	3	applied	\N	\N	\N	\N	139760	139760	307271
18005	24597	2	applied	\N	\N	\N	\N	139770	139770	307281
18007	24598	5	applied	\N	\N	\N	\N	139785	139785	307296
18007	24604	8	applied	\N	\N	\N	\N	139788	139788	307299
18015	24614	1	applied	\N	\N	\N	\N	139824	139824	307335
18017	24621	1	applied	\N	\N	\N	\N	139831	139831	307342
18019	24620	0	applied	\N	\N	\N	\N	139836	139836	307347
18024	24639	3	applied	\N	\N	\N	\N	139858	139858	307369
18034	24571	2	applied	\N	\N	1000000000	\N	139885	139885	307396
18034	24609	13	applied	\N	\N	\N	\N	139896	139896	307404
18036	24653	0	applied	\N	\N	\N	\N	139902	139902	307410
18039	24657	1	applied	\N	\N	\N	\N	139911	139911	307419
18042	24538	9	applied	\N	\N	\N	\N	139925	139925	307433
18052	24674	3	applied	\N	\N	\N	\N	139962	139962	307465
18054	24676	1	applied	\N	\N	\N	\N	139964	139964	307467
18058	24679	1	applied	\N	\N	\N	\N	139976	139976	307479
18064	24690	0	applied	\N	\N	\N	\N	140006	140006	307509
18073	24701	2	applied	\N	\N	\N	\N	140026	140026	307529
18076	24710	0	applied	\N	\N	\N	\N	140039	140039	307542
18084	24728	6	applied	\N	\N	\N	\N	140065	140065	307568
18085	24615	4	applied	\N	\N	\N	\N	140070	140070	307573
18086	24727	5	applied	\N	\N	\N	\N	140090	140090	307593
18089	24556	15	applied	\N	\N	\N	\N	140111	140111	307614
18089	24528	32	applied	\N	\N	\N	\N	140128	140128	307631
18089	24591	49	applied	\N	\N	\N	\N	140145	140145	307648
18089	24647	67	applied	\N	\N	\N	\N	140162	140162	307665
18089	24690	84	applied	\N	\N	\N	\N	140179	140179	307682
18089	24724	100	applied	\N	\N	\N	\N	140195	140195	307698
18089	24404	103	applied	\N	\N	\N	\N	140198	140198	307701
18089	24569	120	applied	\N	\N	\N	\N	140215	140215	307717
18094	24736	1	applied	\N	\N	\N	\N	140232	140232	307734
18101	24749	1	applied	\N	\N	\N	\N	140247	140247	307749
18105	24756	2	applied	\N	\N	\N	\N	140262	140262	307764
18115	24749	9	applied	\N	\N	\N	\N	140305	140305	307807
18115	24753	26	applied	\N	\N	\N	\N	140322	140322	307824
18118	24770	4	applied	\N	\N	\N	\N	140346	140346	307848
18121	24778	1	applied	\N	\N	\N	\N	140360	140360	307862
18126	24700	5	applied	\N	\N	\N	\N	140381	140381	307883
18126	24739	22	applied	\N	\N	\N	\N	140398	140398	307900
18126	24777	39	applied	\N	\N	\N	\N	140415	140415	307917
18126	24692	44	applied	\N	\N	\N	\N	140420	140420	307922
18126	24734	50	applied	\N	\N	\N	\N	140426	140426	307928
18127	24790	1	applied	\N	\N	\N	\N	140435	140435	307937
18130	24802	2	applied	\N	\N	\N	\N	140454	140454	307956
18133	24803	0	applied	\N	\N	\N	\N	140461	140461	307963
18135	23993	9	applied	\N	\N	1000000000	\N	140474	140474	307974
18135	24252	56	applied	\N	\N	\N	\N	140520	140520	308012
18135	24440	73	applied	\N	\N	\N	\N	140537	140537	308029
18135	24725	101	applied	\N	\N	\N	\N	140565	140565	308057
18136	24811	6	applied	\N	\N	\N	\N	140582	140582	308074
18140	24812	0	applied	\N	\N	\N	\N	140599	140599	308091
17891	24337	4	applied	\N	\N	\N	\N	138760	138760	306301
18151	24839	11	applied	\N	\N	\N	\N	140650	140650	308140
18152	24841	14	applied	\N	\N	\N	\N	140667	140667	308156
18153	24828	1	applied	\N	\N	\N	\N	140670	140670	140670
18153	24833	2	applied	\N	\N	1000000000	\N	140671	140671	308159
18153	24760	21	applied	\N	\N	\N	\N	140690	140690	308178
18153	24797	38	applied	\N	\N	\N	\N	140707	140707	308195
18153	24718	55	applied	\N	\N	\N	\N	140724	140724	308212
18153	24740	73	applied	\N	\N	\N	\N	140741	140741	308229
18153	24837	90	applied	\N	\N	\N	\N	140758	140758	308246
18153	24793	107	applied	\N	\N	\N	\N	140775	140775	308263
18153	24826	122	applied	\N	\N	\N	\N	140790	140790	308278
18153	24838	124	applied	\N	\N	\N	\N	140792	140792	308280
18156	24854	11	applied	\N	\N	\N	\N	140834	140834	308319
18157	24857	0	applied	\N	\N	\N	\N	140837	140837	308322
18157	24860	3	applied	\N	\N	\N	\N	140840	140840	308325
18158	24857	0	applied	\N	\N	\N	\N	140844	140844	308329
18166	24886	3	applied	\N	\N	\N	\N	140888	140888	308369
18164	24875	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	140877	140877	\N
18168	24892	2	applied	\N	\N	\N	\N	140894	140894	308375
18169	24901	1	applied	\N	\N	\N	\N	140903	140903	308384
18172	24903	0	applied	\N	\N	\N	\N	140914	140914	308395
18174	24916	3	applied	\N	\N	\N	\N	140927	140927	308408
18176	24924	6	applied	\N	\N	\N	\N	140940	140940	308419
18189	24936	2	applied	\N	\N	\N	\N	140980	140980	308459
18190	24936	2	applied	\N	\N	\N	\N	140985	140985	308464
18196	24938	4	applied	\N	\N	\N	\N	141012	141012	308491
18203	24946	1	applied	\N	\N	\N	\N	141034	141034	308513
18205	24950	5	applied	\N	\N	\N	\N	141050	141050	308526
18206	24947	2	applied	\N	\N	\N	\N	141053	141053	141053
18210	24953	1	applied	\N	\N	\N	\N	141062	141062	308537
18213	24957	5	applied	\N	\N	\N	\N	141082	141082	308555
18221	24972	1	applied	\N	\N	\N	\N	141112	141112	308575
18222	24663	0	applied	\N	\N	1000000000	\N	141113	141113	308576
18223	24777	10	applied	\N	\N	\N	\N	141137	141137	308592
18223	24816	27	applied	\N	\N	\N	\N	141154	141154	308609
18223	24870	44	applied	\N	\N	\N	\N	141171	141171	308626
18223	24904	54	applied	\N	\N	\N	\N	141181	141181	308636
18227	24891	21	applied	\N	\N	\N	\N	141218	141218	308672
18227	24903	24	applied	\N	\N	\N	\N	141221	141221	308675
18227	24945	41	applied	\N	\N	\N	\N	141238	141238	308692
18227	24836	58	applied	\N	\N	\N	\N	141255	141255	308708
18227	24869	75	applied	\N	\N	\N	\N	141272	141272	308725
18227	24906	92	applied	\N	\N	\N	\N	141289	141289	308742
18227	24894	109	applied	\N	\N	\N	\N	141306	141306	308759
18227	24969	120	applied	\N	\N	\N	\N	141317	141317	141317
18227	24925	125	applied	\N	\N	\N	\N	141322	141322	308770
18233	24892	13	applied	\N	\N	\N	\N	141349	141349	308793
18233	24941	30	applied	\N	\N	\N	\N	141366	141366	308810
18233	24990	47	applied	\N	\N	\N	\N	141383	141383	308827
18233	24950	64	applied	\N	\N	\N	\N	141400	141400	308843
18233	24980	81	applied	\N	\N	\N	\N	141417	141417	308855
18243	24998	0	applied	\N	\N	\N	\N	141443	141443	308881
18247	25008	1	applied	\N	\N	\N	\N	141455	141455	308893
18249	25018	1	applied	\N	\N	\N	\N	141465	141465	308903
18250	24997	17	applied	\N	\N	\N	\N	141483	141483	308921
18255	25021	0	applied	\N	\N	\N	\N	141501	141501	308939
18255	25022	1	applied	\N	\N	\N	\N	141502	141502	308940
18258	25024	0	applied	\N	\N	\N	\N	141508	141508	308946
18260	25023	1	applied	\N	\N	\N	\N	141515	141515	308953
18263	25031	1	applied	\N	\N	\N	\N	141522	141522	308960
18270	25044	1	applied	\N	\N	\N	\N	141539	141539	308977
18282	25068	0	applied	\N	\N	\N	\N	141577	141577	309015
18283	25074	1	applied	\N	\N	\N	\N	141583	141583	309021
18284	24996	0	applied	\N	\N	\N	\N	141584	141584	309022
18284	25003	3	applied	\N	\N	\N	\N	141587	141587	309025
18284	25042	20	applied	\N	\N	\N	\N	141604	141604	309042
18284	25015	38	applied	\N	\N	\N	\N	141621	141621	309059
18284	25018	55	applied	\N	\N	\N	\N	141638	141638	309076
18284	25058	72	applied	\N	\N	\N	\N	141655	141655	309093
18298	25097	0	applied	\N	\N	\N	\N	141708	141708	309146
18302	25099	0	applied	\N	\N	\N	\N	141716	141716	309154
18306	25103	1	applied	\N	\N	\N	\N	141727	141727	309165
18308	25115	8	applied	\N	\N	\N	\N	141739	141739	309177
18308	25118	11	applied	\N	\N	\N	\N	141742	141742	309180
18309	25114	7	applied	\N	\N	\N	\N	141757	141757	309195
18310	25116	9	applied	\N	\N	\N	\N	141778	141778	309216
18315	25075	4	applied	\N	\N	\N	\N	141803	141803	309241
18315	25114	21	applied	\N	\N	\N	\N	141820	141820	309258
18315	25092	38	applied	\N	\N	\N	\N	141837	141837	309275
18315	25125	55	applied	\N	\N	\N	\N	141854	141854	309292
18318	25141	1	applied	\N	\N	\N	\N	141868	141868	309306
18319	25140	0	applied	\N	\N	\N	\N	141869	141869	309307
18330	25156	1	applied	\N	\N	\N	\N	141900	141900	309338
18331	25156	1	applied	\N	\N	\N	\N	141905	141905	309343
18338	25176	1	applied	\N	\N	\N	\N	141930	141930	309368
18346	25193	0	applied	\N	\N	\N	\N	141949	141949	309383
18350	25201	1	applied	\N	\N	\N	\N	141975	141975	309405
18354	25216	0	applied	\N	\N	\N	\N	141990	141990	309416
18359	25227	0	applied	\N	\N	\N	\N	142004	142004	309430
18364	25230	1	applied	\N	\N	\N	\N	142015	142015	309441
18367	24833	9	applied	\N	\N	1000000000	\N	142032	142032	309457
18367	24825	30	applied	\N	\N	\N	\N	142053	142053	309478
18367	24870	44	applied	\N	\N	\N	\N	142066	142066	309491
18367	24904	54	applied	\N	\N	\N	\N	142076	142076	309501
18367	24913	57	applied	\N	\N	\N	\N	142079	142079	309504
18367	24955	74	applied	\N	\N	\N	\N	142096	142096	309521
18367	25003	91	applied	\N	\N	\N	\N	142113	142113	309538
18367	25042	108	applied	\N	\N	\N	\N	142130	142130	309555
18370	25080	9	applied	\N	\N	\N	\N	142166	142166	309591
18370	25050	27	applied	\N	\N	\N	\N	142183	142183	309608
18370	25097	44	applied	\N	\N	\N	\N	142200	142200	309625
18370	25188	78	applied	\N	\N	\N	\N	142234	142234	309659
18370	25229	93	applied	\N	\N	\N	\N	142249	142249	309674
18370	25182	110	applied	\N	\N	\N	\N	142266	142266	142266
18370	25197	114	applied	\N	\N	\N	\N	142270	142270	142270
18370	25054	117	applied	\N	\N	\N	\N	142273	142273	309693
18376	25249	0	applied	\N	\N	\N	\N	142293	142293	309713
18381	25252	4	applied	\N	\N	\N	\N	142309	142309	309729
18381	25251	22	applied	\N	\N	\N	\N	142326	142326	309746
18381	25044	39	applied	\N	\N	\N	\N	142343	142343	309759
18150	24837	9	applied	\N	\N	\N	\N	140633	140633	308124
18381	25174	84	applied	\N	\N	\N	\N	142388	142388	309804
18381	25184	87	applied	\N	\N	\N	\N	142391	142391	309807
18381	25230	104	applied	\N	\N	\N	\N	142408	142408	309824
18383	25264	3	applied	\N	\N	\N	\N	142430	142430	309846
18385	25267	1	applied	\N	\N	\N	\N	142433	142433	309849
18392	25276	1	applied	\N	\N	\N	\N	142452	142452	309868
18398	25287	1	applied	\N	\N	\N	\N	142465	142465	309881
18410	25309	0	applied	\N	\N	\N	\N	142500	142500	309916
18416	25316	1	applied	\N	\N	\N	\N	142533	142533	309949
18417	25327	2	applied	\N	\N	\N	\N	142541	142541	309957
18421	25332	1	applied	\N	\N	\N	\N	142556	142556	309972
18422	25304	3	applied	\N	\N	\N	\N	142562	142562	309978
18422	25303	20	applied	\N	\N	\N	\N	142579	142579	309995
18427	25299	3	applied	\N	\N	\N	\N	142607	142607	310023
18427	25305	26	applied	\N	\N	\N	\N	142630	142630	310046
18427	25322	39	applied	\N	\N	\N	\N	142643	142643	310059
18427	25330	42	applied	\N	\N	\N	\N	142646	142646	310062
18431	25350	0	applied	\N	\N	\N	\N	142668	142668	310084
18432	25355	5	applied	\N	\N	\N	\N	142680	142680	310096
18433	25352	2	applied	\N	\N	\N	\N	142684	142684	310100
18435	25080	10	applied	\N	\N	\N	\N	142706	142706	310121
18435	24880	27	applied	\N	\N	\N	\N	142723	142723	310134
18435	24929	44	applied	\N	\N	\N	\N	142740	142740	310151
18435	24974	61	applied	\N	\N	\N	\N	142757	142757	310168
18435	25028	84	applied	\N	\N	\N	\N	142779	142779	310190
18435	25064	100	applied	\N	\N	\N	\N	142795	142795	310206
18435	25113	117	applied	\N	\N	\N	\N	142812	142812	310223
18441	25365	5	applied	\N	\N	\N	\N	142839	142839	310250
18443	25366	0	applied	\N	\N	\N	\N	142843	142843	310254
18444	25371	2	applied	\N	\N	\N	\N	142848	142848	310259
18449	25376	1	applied	\N	\N	\N	\N	142864	142864	310275
18453	25290	13	applied	\N	\N	\N	\N	142889	142889	310300
18453	25338	30	applied	\N	\N	\N	\N	142906	142906	310317
18453	25320	47	applied	\N	\N	\N	\N	142923	142923	310334
18453	25355	64	applied	\N	\N	\N	\N	142940	142940	310351
18453	25300	94	applied	\N	\N	\N	\N	142970	142970	310381
18453	25324	102	applied	\N	\N	\N	\N	142978	142978	310389
18459	25387	3	applied	\N	\N	\N	\N	143014	143014	310425
18460	25385	0	applied	\N	\N	\N	\N	143015	143015	310426
18466	25392	0	applied	\N	\N	\N	\N	143028	143028	310439
18475	25416	1	applied	\N	\N	\N	\N	143075	143075	310486
18477	25415	0	applied	\N	\N	\N	\N	143090	143090	310501
18479	25416	1	applied	\N	\N	\N	\N	143107	143107	310518
18480	25419	4	applied	\N	\N	\N	\N	143118	143118	310529
18482	25416	1	applied	\N	\N	\N	\N	143131	143131	310542
18484	25432	9	applied	\N	\N	\N	\N	143155	143155	310566
18486	25435	2	applied	\N	\N	\N	\N	143166	143166	310577
18492	25450	0	applied	\N	\N	\N	\N	143192	143192	310603
18493	25451	1	applied	\N	\N	\N	\N	143197	143197	310608
18494	25455	1	applied	\N	\N	1000000000	\N	143201	143201	310612
18500	24990	16	applied	\N	\N	\N	\N	143242	143242	310653
18500	25024	33	applied	\N	\N	\N	\N	143259	143259	310670
18500	25026	34	applied	\N	\N	\N	\N	143260	143260	310671
18500	25031	37	applied	\N	\N	\N	\N	143263	143263	310674
18500	25069	54	applied	\N	\N	\N	\N	143280	143280	310691
18500	25126	71	applied	\N	\N	\N	\N	143297	143297	310708
18500	25216	105	applied	\N	\N	\N	\N	143331	143331	310742
18500	25254	122	applied	\N	\N	\N	\N	143348	143348	310759
18506	25484	1	applied	\N	\N	\N	\N	143369	143369	310780
18509	25490	0	applied	\N	\N	\N	\N	143375	143375	310786
18509	25491	1	applied	\N	\N	\N	\N	143376	143376	310787
18511	25491	1	applied	\N	\N	\N	\N	143381	143381	310792
18512	25494	1	applied	\N	\N	\N	\N	143384	143384	310794
18514	25493	0	applied	\N	\N	\N	\N	143389	143389	143389
18514	25371	17	applied	\N	\N	\N	\N	143406	143406	310814
18514	25437	35	applied	\N	\N	\N	\N	143424	143424	310832
18514	25489	52	applied	\N	\N	\N	\N	143441	143441	310849
18519	25508	2	applied	\N	\N	\N	\N	143466	143466	310874
18529	25532	0	applied	\N	\N	\N	\N	143496	143496	310903
18530	25536	1	applied	\N	\N	\N	\N	143500	143500	310907
18531	25540	2	applied	\N	\N	\N	\N	143504	143504	310911
18536	25538	1	applied	\N	\N	1000000000	\N	143526	143526	310932
18538	25562	0	applied	\N	\N	\N	\N	143539	143539	310944
18548	25580	2	applied	\N	\N	\N	\N	143573	143573	310978
18549	25578	0	applied	\N	\N	\N	\N	143575	143575	310980
18554	25602	4	applied	\N	\N	\N	\N	143599	143599	311004
18555	25607	9	applied	\N	\N	\N	\N	143617	143617	311022
18559	25620	1	applied	\N	\N	\N	\N	143634	143634	311039
18561	25626	4	applied	\N	\N	\N	\N	143643	143643	311048
18565	25635	1	applied	\N	\N	\N	\N	143657	143657	311062
18566	25635	1	applied	\N	\N	\N	\N	143664	143664	311069
18579	25653	3	applied	\N	\N	\N	\N	143692	143692	311097
18588	25674	0	applied	\N	\N	1000000000	\N	143725	143725	311130
18592	25682	0	applied	\N	\N	\N	\N	143737	143737	311142
18596	25682	0	applied	\N	\N	\N	\N	143757	143757	311162
18603	25691	0	applied	\N	\N	\N	\N	143779	143779	311184
18606	25696	1	applied	\N	\N	\N	\N	143786	143786	311191
18608	25698	1	applied	\N	\N	\N	\N	143790	143790	311195
18613	25703	1	applied	\N	\N	\N	\N	143802	143802	311207
18613	25709	7	applied	\N	\N	\N	\N	143808	143808	311213
18623	25731	2	applied	\N	\N	\N	\N	143853	143853	311258
18625	25732	0	applied	\N	\N	\N	\N	143857	143857	311262
18627	25743	4	applied	\N	\N	\N	\N	143868	143868	311273
18629	25743	4	applied	\N	\N	\N	\N	143878	143878	311283
18635	25755	2	applied	\N	\N	\N	\N	143905	143905	311310
18639	25768	0	applied	\N	\N	\N	\N	143922	143922	311327
18640	25775	3	applied	\N	\N	\N	\N	143929	143929	311334
18651	25786	0	applied	\N	\N	\N	\N	143963	143963	311368
18653	25794	2	applied	\N	\N	\N	\N	143970	143970	311375
18658	25799	3	applied	\N	\N	\N	\N	143997	143997	311402
18658	25800	4	applied	\N	\N	\N	\N	143998	143998	311403
18660	25803	1	applied	\N	\N	\N	\N	144007	144007	311412
18663	25736	12	applied	\N	\N	\N	\N	144027	144027	311432
18663	25743	16	applied	\N	\N	\N	\N	144031	144031	311436
18663	25780	30	applied	\N	\N	\N	\N	144045	144045	311450
18667	25814	0	applied	\N	\N	\N	\N	144065	144065	311470
18673	25301	24	applied	\N	\N	\N	\N	144105	144105	311508
18673	25351	41	applied	\N	\N	\N	\N	144122	144122	311525
18673	25360	43	applied	\N	\N	\N	\N	144124	144124	311527
18673	25366	45	applied	\N	\N	\N	\N	144126	144126	311529
18381	25147	73	applied	\N	\N	\N	\N	142377	142377	309793
18673	25540	97	applied	\N	\N	\N	\N	144177	144177	311580
18674	25820	0	applied	\N	\N	1000000000	\N	144194	144194	311597
18675	25820	0	applied	\N	\N	1000000000	\N	144197	144197	311600
18678	25825	2	applied	\N	\N	1000000000	\N	144207	144207	311610
18681	25766	13	applied	\N	\N	1000000000	\N	144237	144237	311640
18681	25700	22	applied	\N	\N	\N	\N	144246	144246	311649
18681	25711	23	applied	\N	\N	\N	\N	144247	144247	311650
18681	25726	40	applied	\N	\N	\N	\N	144264	144264	311667
18681	25751	57	applied	\N	\N	\N	\N	144281	144281	311684
18681	25794	74	applied	\N	\N	\N	\N	144298	144298	311701
18681	25841	91	applied	\N	\N	\N	\N	144315	144315	311718
18694	25861	3	applied	\N	\N	\N	\N	144357	144357	311760
18699	25843	0	applied	\N	\N	1000000000	\N	144370	144370	311773
18699	25855	20	applied	\N	\N	\N	\N	144390	144390	311793
18699	25861	36	applied	\N	\N	\N	\N	144405	144405	311808
18707	25878	0	applied	\N	\N	\N	\N	144428	144428	311831
18711	25622	3	applied	\N	\N	\N	\N	144445	144445	311848
18711	25825	18	applied	\N	\N	1000000000	\N	144460	144460	311863
18712	25896	5	applied	\N	\N	\N	\N	144474	144474	311877
18713	25900	9	applied	\N	\N	\N	\N	144488	144488	311891
18726	25927	1	applied	\N	\N	\N	\N	144526	144526	311929
18727	25929	0	applied	\N	\N	\N	\N	144528	144528	311931
18736	25945	3	applied	\N	\N	\N	\N	144561	144561	311964
18738	25951	2	applied	\N	\N	\N	\N	144574	144574	311977
18742	25961	3	applied	\N	\N	\N	\N	144591	144591	311994
18744	25962	0	applied	\N	\N	\N	\N	144596	144596	311999
18749	25975	1	applied	\N	\N	\N	\N	144612	144612	312015
18754	25985	0	applied	\N	\N	1000000000	\N	144626	144626	312029
18767	26001	2	applied	\N	\N	\N	\N	144664	144664	312065
18769	26002	0	applied	\N	\N	\N	\N	144667	144667	312068
18776	26016	8	applied	\N	\N	\N	\N	144689	144689	312090
18778	26020	1	applied	\N	\N	\N	\N	144696	144696	312097
18779	26019	0	applied	\N	\N	\N	\N	144698	144698	312099
18789	26035	1	applied	\N	\N	\N	\N	144731	144731	312132
18793	26042	1	applied	\N	\N	\N	\N	144743	144743	312144
18795	26053	6	applied	\N	\N	\N	\N	144760	144760	312161
18802	26066	1	applied	\N	\N	\N	\N	144782	144782	312183
18803	26069	4	applied	\N	\N	\N	\N	144790	144790	312191
18804	26071	1	applied	\N	\N	\N	\N	144792	144792	312193
18813	26080	1	applied	\N	\N	\N	\N	144816	144816	312217
18825	26091	1	applied	\N	\N	\N	\N	144838	144838	312239
18834	26099	0	applied	\N	\N	\N	\N	144849	144849	312250
18840	26106	0	applied	\N	\N	\N	\N	144858	144858	312259
18847	26118	0	applied	\N	\N	\N	\N	144873	144873	312274
18849	26120	0	applied	\N	\N	\N	\N	144875	144875	312276
18849	26121	1	applied	\N	\N	\N	\N	144876	144876	312277
18861	26130	1	applied	\N	\N	\N	\N	144893	144893	312294
18875	26144	0	applied	\N	\N	\N	\N	144919	144919	312320
18876	26081	4	applied	\N	\N	\N	\N	144924	144924	312325
18876	26104	21	applied	\N	\N	\N	\N	144941	144941	312342
18876	26127	39	applied	\N	\N	\N	\N	144958	144958	312359
18876	26087	56	applied	\N	\N	\N	\N	144975	144975	312376
18878	26146	1	applied	\N	\N	\N	\N	144993	144993	312394
18896	26162	1	applied	\N	\N	\N	\N	145024	145024	312425
18898	26166	0	applied	\N	\N	\N	\N	145028	145028	312429
18904	26172	3	applied	\N	\N	\N	\N	145046	145046	312446
18920	26150	4	applied	\N	\N	\N	\N	145076	145076	312476
18929	26195	0	applied	\N	\N	\N	\N	145127	145127	312527
18941	26207	2	applied	\N	\N	\N	\N	145146	145146	312546
18949	26214	0	applied	\N	\N	\N	\N	145165	145165	312565
18952	26216	1	applied	\N	\N	\N	\N	145168	145168	312568
18962	26222	0	applied	\N	\N	\N	\N	145184	145184	312584
18970	26230	1	applied	\N	\N	\N	\N	145199	145199	312599
18972	26233	1	applied	\N	\N	\N	\N	145202	145202	312602
18985	26242	0	applied	\N	\N	\N	\N	145224	145224	312624
18997	26251	0	applied	\N	\N	\N	\N	145249	145249	312649
19005	26239	10	applied	\N	\N	\N	\N	145266	145266	312666
19005	26245	27	applied	\N	\N	\N	\N	145283	145283	312683
19008	26258	0	applied	\N	\N	\N	\N	145289	145289	312689
19020	26266	1	applied	\N	\N	\N	\N	145309	145309	312709
19029	26281	2	applied	\N	\N	\N	\N	145330	145330	312730
19043	26294	2	applied	\N	\N	\N	\N	145353	145353	312753
19044	26300	2	applied	\N	\N	\N	\N	145359	145359	312759
19060	26320	0	applied	\N	\N	\N	\N	145399	145399	312799
19062	26330	8	applied	\N	\N	1000000000	\N	145411	145411	312811
19063	26322	0	applied	\N	\N	1000000000	\N	145413	145413	312813
19081	26348	0	applied	\N	\N	\N	\N	145451	145451	312849
19084	26356	2	applied	\N	\N	\N	\N	145459	145459	312856
19085	26361	7	applied	\N	\N	1000000000	\N	145472	145472	312863
19086	26358	4	applied	\N	\N	\N	\N	145477	145477	145477
19089	26367	4	applied	\N	\N	\N	\N	145487	145487	312875
19090	26362	15	applied	\N	\N	\N	\N	145505	145505	312887
19090	26365	16	applied	\N	\N	\N	\N	145506	145506	312888
19096	26372	13	applied	\N	\N	\N	\N	145550	145550	312932
19099	26383	1	applied	\N	\N	\N	\N	145568	145568	312950
19100	26387	2	applied	\N	\N	\N	\N	145572	145572	312954
19101	26390	5	applied	\N	\N	\N	\N	145581	145581	312963
19105	26396	3	applied	\N	\N	\N	\N	145599	145599	312981
19108	26409	4	applied	\N	\N	\N	\N	145618	145618	312996
19121	26324	3	applied	\N	\N	1000000000	\N	145647	145647	313024
19121	26390	23	applied	\N	\N	\N	\N	145667	145667	313044
19125	26432	0	applied	\N	\N	\N	\N	145682	145682	313059
19126	26435	1	applied	\N	\N	\N	\N	145685	145685	313062
19130	26361	10	applied	\N	\N	1000000000	\N	145702	145702	313079
19130	26388	31	applied	\N	\N	\N	\N	145723	145723	313100
19130	26433	48	applied	\N	\N	\N	\N	145740	145740	313117
19132	26439	5	applied	\N	\N	\N	\N	145756	145756	313133
19134	26453	5	applied	\N	\N	\N	\N	145768	145768	313145
19134	26456	8	applied	\N	\N	\N	\N	145771	145771	313148
19142	26476	5	applied	\N	\N	\N	\N	145801	145801	313178
19143	26475	4	applied	\N	\N	\N	\N	145807	145807	313184
19146	26483	2	applied	\N	\N	\N	\N	145816	145816	313193
19150	26503	12	applied	\N	\N	\N	\N	145840	145840	313217
19154	26511	2	applied	\N	\N	\N	\N	145860	145860	313237
19155	26513	4	applied	\N	\N	\N	\N	145866	145866	313243
19166	26538	2	applied	\N	\N	\N	\N	145909	145909	313286
19167	26539	3	applied	\N	\N	\N	\N	145917	145917	313294
18673	25483	80	applied	\N	\N	\N	\N	144160	144160	311563
19173	26566	7	applied	\N	\N	\N	\N	145947	145947	313324
19179	26587	4	applied	\N	\N	\N	\N	145974	145974	313351
19180	26324	9	applied	\N	\N	1000000000	\N	145984	145984	313361
19180	26349	29	applied	\N	\N	\N	\N	146004	146004	313381
19180	26393	46	applied	\N	\N	\N	\N	146021	146021	313398
19180	26440	64	applied	\N	\N	\N	\N	146038	146038	313415
19180	26448	68	applied	\N	\N	\N	\N	146042	146042	313419
19180	26491	81	applied	\N	\N	\N	\N	146055	146055	313432
19180	26533	98	applied	\N	\N	\N	\N	146072	146072	313449
19180	26361	114	applied	\N	\N	1000000000	\N	146088	146088	313465
19186	26600	6	applied	\N	\N	\N	\N	146124	146124	313498
19187	26596	1	applied	\N	\N	\N	\N	146128	146128	313501
19188	26605	2	applied	\N	\N	\N	\N	146138	146138	313511
19196	26621	2	applied	\N	\N	\N	\N	146170	146170	313543
19199	26626	4	applied	\N	\N	\N	\N	146189	146189	313562
19200	26324	14	applied	\N	\N	1000000000	\N	146206	146206	313577
19200	26115	48	applied	\N	\N	\N	\N	146240	146240	313611
19200	26123	54	applied	\N	\N	\N	\N	146246	146246	313617
19200	26136	65	applied	\N	\N	\N	\N	146256	146256	313627
19200	26158	82	applied	\N	\N	\N	\N	146273	146273	313644
19200	26173	99	applied	\N	\N	\N	\N	146290	146290	313661
19200	26195	116	applied	\N	\N	\N	\N	146307	146307	313678
19202	26629	0	applied	\N	\N	\N	\N	146324	146324	313695
19204	26636	0	applied	\N	\N	\N	\N	146335	146335	313706
19205	26653	11	applied	\N	\N	\N	\N	146352	146352	313723
19205	26657	15	applied	\N	\N	\N	\N	146356	146356	313727
19210	26666	1	applied	\N	\N	\N	\N	146370	146370	313741
19212	26665	0	applied	\N	\N	\N	\N	146377	146377	313748
19214	26687	15	applied	\N	\N	\N	\N	146398	146398	313769
19216	26686	14	applied	\N	\N	\N	\N	146431	146431	313802
19218	26694	2	applied	\N	\N	\N	\N	146449	146449	313820
19220	26693	1	applied	\N	\N	\N	\N	146468	146468	313839
19222	26707	5	applied	\N	\N	\N	\N	146486	146486	313857
19228	26708	0	applied	\N	\N	1000000000	\N	146512	146512	313881
19235	26717	1	applied	\N	\N	\N	\N	146540	146540	313909
19236	26718	2	applied	\N	\N	\N	\N	146544	146544	313913
19238	26718	1	applied	\N	\N	\N	\N	146549	146549	313918
19242	26719	0	applied	\N	\N	\N	\N	146559	146559	313928
19246	26738	0	applied	\N	\N	1000000000	\N	146578	146578	313947
19249	26743	2	applied	\N	\N	\N	\N	146589	146589	313958
19252	26751	0	applied	\N	\N	\N	\N	146600	146600	313969
19255	26754	0	applied	\N	\N	\N	\N	146614	146614	313983
19256	26324	11	applied	\N	\N	1000000000	\N	146633	146633	314000
19256	26381	30	applied	\N	\N	\N	\N	146652	146652	314019
19256	26380	47	applied	\N	\N	\N	\N	146669	146669	314036
19257	26768	6	applied	\N	\N	\N	\N	146712	146712	314079
19260	26765	3	applied	\N	\N	\N	\N	146739	146739	314106
19261	26766	4	applied	\N	\N	\N	\N	146750	146750	314117
19266	26778	2	applied	\N	\N	\N	\N	146771	146771	314138
19270	26785	0	applied	\N	\N	\N	\N	146794	146794	314161
19271	26789	1	applied	\N	\N	\N	\N	146798	146798	314165
19275	26795	0	applied	\N	\N	\N	\N	146810	146810	314177
19276	26795	0	applied	\N	\N	\N	\N	146813	146813	314180
19277	26798	0	applied	\N	\N	\N	\N	146816	146816	314183
19279	26804	2	applied	\N	\N	\N	\N	146828	146828	314195
19280	26809	1	applied	\N	\N	\N	\N	146833	146833	314200
19281	26808	0	applied	\N	\N	\N	\N	146835	146835	314202
19286	26829	7	applied	\N	\N	\N	\N	146871	146871	314238
19287	26824	2	applied	\N	\N	\N	\N	146874	146874	314241
19291	26848	0	applied	\N	\N	\N	\N	146905	146905	314272
19292	26852	4	applied	\N	\N	\N	\N	146916	146916	314283
19303	26881	3	applied	\N	\N	\N	\N	146954	146954	314321
19304	26878	0	applied	\N	\N	\N	\N	146971	146971	314337
19304	26895	17	applied	\N	\N	\N	\N	146988	146988	314354
19305	26882	4	applied	\N	\N	\N	\N	146995	146995	314360
19306	26879	1	applied	\N	\N	\N	\N	147012	147012	314376
19306	26896	18	applied	\N	\N	\N	\N	147029	147029	147029
19306	26897	19	applied	\N	\N	\N	\N	147030	147030	314393
19307	26903	5	applied	\N	\N	\N	\N	147036	147036	314399
19309	26905	0	applied	\N	\N	\N	\N	147045	147045	314408
19315	26921	0	applied	\N	\N	\N	\N	147070	147070	314433
19318	26934	3	applied	\N	\N	\N	\N	147091	147091	314454
19321	26595	1	applied	\N	\N	\N	\N	147104	147104	147104
19321	26881	18	applied	\N	\N	\N	\N	147121	147121	314482
19321	26839	34	applied	\N	\N	1000000000	\N	147137	147137	314498
19322	26825	7	applied	\N	\N	\N	\N	147156	147156	314516
19322	26629	12	applied	\N	\N	\N	\N	147161	147161	314521
19322	26693	32	applied	\N	\N	\N	\N	147181	147181	314541
19322	26755	49	applied	\N	\N	\N	\N	147198	147198	314558
19322	26816	66	applied	\N	\N	\N	\N	147215	147215	314575
19322	26885	83	applied	\N	\N	\N	\N	147232	147232	314592
19322	26878	100	applied	\N	\N	\N	\N	147249	147249	314609
19322	26935	114	applied	\N	\N	\N	\N	147262	147262	314622
19322	26840	124	applied	\N	\N	1000000000	\N	147272	147272	314632
19323	26954	8	applied	\N	\N	\N	\N	147282	147282	314642
19324	26963	8	applied	\N	\N	\N	\N	147291	147291	314651
19329	26969	5	applied	\N	\N	\N	\N	147339	147339	314699
19330	26980	6	applied	\N	\N	\N	\N	147350	147350	314710
19331	26976	1	applied	\N	\N	\N	\N	147356	147356	314716
19335	26997	8	applied	\N	\N	\N	\N	147385	147385	314745
19338	27008	0	applied	\N	\N	\N	\N	147399	147399	314759
19340	27015	3	applied	\N	\N	\N	\N	147416	147416	314771
19343	27012	0	applied	\N	\N	\N	\N	147443	147443	314790
19349	26980	10	applied	\N	\N	\N	\N	147476	147476	314820
19354	27042	5	applied	\N	\N	\N	\N	147503	147503	314843
19355	27056	8	applied	\N	\N	1000000000	\N	147518	147518	314858
19355	27058	10	applied	\N	\N	\N	\N	147520	147520	314860
19356	27051	1	applied	\N	\N	\N	\N	147526	147526	314866
19356	26917	6	applied	\N	\N	1000000000	\N	147531	147531	314871
19357	27055	7	applied	\N	\N	\N	\N	147543	147543	314882
19358	27048	0	applied	\N	\N	\N	\N	147551	147551	314890
19358	27056	8	applied	\N	\N	1000000000	\N	147559	147559	314898
19359	27049	1	applied	\N	\N	\N	\N	147567	147567	314906
19365	27076	1	applied	\N	\N	\N	\N	147601	147601	314940
19368	27083	5	applied	\N	\N	\N	\N	147618	147618	314957
19369	27085	0	applied	\N	\N	\N	\N	147620	147620	314959
19370	27089	1	applied	\N	\N	\N	\N	147624	147624	314963
19377	27098	2	applied	\N	\N	\N	\N	147650	147650	314987
19385	27103	2	applied	\N	\N	\N	\N	147675	147675	315012
19172	26558	2	applied	\N	\N	\N	\N	145939	145939	313316
19399	27134	1	applied	\N	\N	\N	\N	147735	147735	315072
19408	26356	10	applied	\N	\N	\N	\N	147775	147775	315110
19408	26386	27	applied	\N	\N	\N	\N	147792	147792	315127
19408	26417	44	applied	\N	\N	\N	\N	147809	147809	315143
19408	26449	58	applied	\N	\N	\N	\N	147823	147823	315157
19408	26472	70	applied	\N	\N	\N	\N	147835	147835	315164
19408	26484	73	applied	\N	\N	\N	\N	147838	147838	315167
19408	26537	90	applied	\N	\N	\N	\N	147855	147855	315182
19408	26603	108	applied	\N	\N	\N	\N	147872	147872	315199
19408	26659	125	applied	\N	\N	\N	\N	147889	147889	315216
19415	27168	0	applied	\N	\N	\N	\N	147912	147912	315239
19420	27183	5	applied	\N	\N	\N	\N	147934	147934	315259
19421	27183	5	applied	\N	\N	\N	\N	147941	147941	315266
19422	27180	0	applied	\N	\N	\N	\N	147943	147943	315268
19423	27182	4	applied	\N	\N	\N	\N	147950	147950	315275
19430	27205	3	applied	\N	\N	\N	\N	147980	147980	315305
19435	27217	2	applied	\N	\N	\N	\N	148003	148003	315328
19439	27228	2	applied	\N	\N	\N	\N	148017	148017	315342
19440	27232	6	applied	\N	\N	\N	\N	148039	148039	315364
19441	27245	1	applied	\N	\N	\N	\N	148052	148052	315377
19443	27253	1	applied	\N	\N	\N	\N	148060	148060	315385
19447	27256	1	applied	\N	\N	\N	\N	148068	148068	315393
19451	27263	1	applied	\N	\N	\N	\N	148094	148094	315419
19452	27261	2	applied	\N	\N	\N	\N	148097	148097	315422
19458	27289	7	applied	\N	\N	\N	\N	148130	148130	315455
19459	27293	1	applied	\N	\N	\N	\N	148134	148134	315459
19461	27294	2	applied	\N	\N	\N	\N	148140	148140	315465
19467	27306	2	applied	\N	\N	\N	\N	148158	148158	315483
19472	27323	2	applied	\N	\N	\N	\N	148179	148179	315504
19477	27339	4	applied	\N	\N	\N	\N	148204	148204	315529
19479	27340	0	applied	\N	\N	\N	\N	148213	148213	315538
19479	27346	8	applied	\N	\N	\N	\N	148220	148220	315545
19483	27347	1	applied	\N	\N	\N	\N	148228	148228	315553
19491	27362	4	applied	\N	\N	\N	\N	148259	148259	315584
19495	27369	2	applied	\N	\N	\N	\N	148274	148274	315599
19498	27381	1	applied	\N	\N	\N	\N	148289	148289	315614
19499	27383	0	applied	\N	\N	\N	\N	148291	148291	315616
19504	27392	5	applied	\N	\N	\N	\N	148316	148316	315641
19508	27396	3	applied	\N	\N	\N	\N	148338	148338	315663
19511	27396	3	applied	\N	\N	\N	\N	148350	148350	315675
19513	27394	1	applied	\N	\N	\N	\N	148356	148356	315681
19516	27405	2	applied	\N	\N	\N	\N	148370	148370	315695
19529	27416	0	applied	\N	\N	\N	\N	148415	148415	315740
19531	27420	0	applied	\N	\N	\N	\N	148423	148423	315748
19538	27416	5	applied	\N	\N	\N	\N	148450	148450	315775
19538	27414	21	applied	\N	\N	\N	\N	148466	148466	315791
19538	27415	29	applied	\N	\N	\N	\N	148474	148474	315799
19543	27443	0	applied	\N	\N	\N	\N	148495	148495	315820
19545	27443	0	applied	\N	\N	\N	\N	148512	148512	315837
19545	27449	9	applied	\N	\N	\N	\N	148521	148521	315846
19546	27448	8	applied	\N	\N	\N	\N	148530	148530	315855
19547	27453	0	applied	\N	\N	\N	\N	148532	148532	315857
19551	27359	5	applied	\N	\N	1000000000	\N	148557	148557	315882
19551	26915	26	applied	\N	\N	\N	\N	148578	148578	315903
19551	26990	43	applied	\N	\N	\N	\N	148595	148595	315920
19551	26845	60	applied	\N	\N	\N	\N	148612	148612	315937
19551	27016	77	applied	\N	\N	\N	\N	148629	148629	148629
19553	27469	0	applied	\N	\N	\N	\N	148637	148637	315957
19557	27464	10	applied	\N	\N	\N	\N	148661	148661	315981
19557	27442	14	applied	\N	\N	\N	\N	148665	148665	315985
19557	27448	28	applied	\N	\N	\N	\N	148679	148679	315999
19561	27481	3	applied	\N	\N	\N	\N	148700	148700	316020
19562	27483	1	applied	\N	\N	\N	\N	148702	148702	316022
19567	27497	1	applied	\N	\N	\N	\N	148719	148719	316039
19568	27228	15	applied	\N	\N	\N	\N	148736	148736	316056
19568	27292	32	applied	\N	\N	\N	\N	148753	148753	316073
19568	27356	49	applied	\N	\N	\N	\N	148770	148770	316090
19568	27413	66	applied	\N	\N	\N	\N	148787	148787	316107
19568	27423	69	applied	\N	\N	\N	\N	148790	148790	316110
19568	27463	81	applied	\N	\N	\N	\N	148802	148802	316122
19568	27194	99	applied	\N	\N	\N	\N	148819	148819	316139
19568	27201	116	applied	\N	\N	\N	\N	148836	148836	316156
19571	27496	0	applied	\N	\N	\N	\N	148850	148850	316170
19576	27505	1	applied	\N	\N	\N	\N	148866	148866	316186
19584	27524	1	applied	\N	\N	\N	\N	148893	148893	316213
19592	27531	1	applied	\N	\N	\N	\N	148916	148916	316236
19594	27530	0	applied	\N	\N	\N	\N	148918	148918	316238
19598	27551	1	applied	\N	\N	\N	\N	148939	148939	316259
19600	27553	0	applied	\N	\N	\N	\N	148944	148944	316264
19607	27196	3	applied	\N	\N	1000000000	\N	148976	148976	316296
19609	27112	5	applied	\N	\N	1000000000	\N	148996	148996	316316
19610	27578	2	applied	\N	\N	\N	\N	149012	149012	316332
19611	27582	3	applied	\N	\N	\N	\N	149016	149016	316336
19615	27593	0	applied	\N	\N	\N	\N	149043	149043	316363
19616	27598	5	applied	\N	\N	\N	\N	149057	149057	316377
19617	27606	5	applied	\N	\N	\N	\N	149065	149065	316385
19618	27610	9	applied	\N	\N	\N	\N	149078	149078	316398
19620	27486	4	applied	\N	\N	\N	\N	149092	149092	316412
19620	27541	21	applied	\N	\N	\N	\N	149109	149109	316429
19620	27595	38	applied	\N	\N	\N	\N	149126	149126	316446
19620	27505	63	applied	\N	\N	\N	\N	149151	149151	316471
19620	27538	66	applied	\N	\N	\N	\N	149154	149154	316474
19620	27565	83	applied	\N	\N	\N	\N	149171	149171	316491
19620	27491	101	applied	\N	\N	\N	\N	149188	149188	316508
19620	27548	118	applied	\N	\N	\N	\N	149205	149205	316525
19624	27626	5	applied	\N	\N	\N	\N	149235	149235	316555
19626	27637	9	applied	\N	\N	\N	\N	149259	149259	316579
19627	27631	3	applied	\N	\N	\N	\N	149266	149266	316586
19630	27653	2	applied	\N	\N	\N	\N	149288	149288	316608
19631	27660	6	applied	\N	\N	\N	\N	149295	149295	316615
19632	27658	4	applied	\N	\N	\N	\N	149300	149300	316620
19633	27629	12	applied	\N	\N	\N	\N	149315	149315	316635
19633	27641	16	applied	\N	\N	\N	\N	149318	149318	316638
19633	27609	33	applied	\N	\N	\N	\N	149335	149335	316655
19633	27640	37	applied	\N	\N	\N	\N	149339	149339	316659
19633	27650	40	applied	\N	\N	\N	\N	149342	149342	316662
19638	27672	1	applied	\N	\N	\N	\N	149388	149388	316708
19643	27678	4	applied	\N	\N	\N	\N	149406	149406	316726
19647	27587	3	applied	\N	\N	\N	\N	149431	149431	316751
19647	27631	18	applied	\N	\N	\N	\N	149446	149446	316766
19391	27123	1	applied	\N	\N	1000000000	\N	147710	147710	315047
19647	27607	43	applied	\N	\N	\N	\N	149470	149470	316790
19647	27614	46	applied	\N	\N	\N	\N	149473	149473	316793
19647	27663	63	applied	\N	\N	\N	\N	149490	149490	316810
19647	27616	80	applied	\N	\N	\N	\N	149507	149507	316827
19647	27673	97	applied	\N	\N	\N	\N	149524	149524	316844
19650	27698	1	applied	\N	\N	\N	\N	149547	149547	316867
19652	27705	5	applied	\N	\N	\N	\N	149557	149557	316877
19660	27722	0	applied	\N	\N	\N	\N	149586	149586	316906
19664	27728	0	applied	\N	\N	\N	\N	149600	149600	316920
19667	27744	4	applied	\N	\N	\N	\N	149626	149626	316946
19671	27754	4	applied	\N	\N	\N	\N	149662	149662	316982
19672	27750	0	applied	\N	\N	\N	\N	149666	149666	316986
19673	27771	13	applied	\N	\N	\N	\N	149684	149684	317004
19674	27761	3	applied	\N	\N	\N	\N	149692	149692	317012
19675	27788	12	applied	\N	\N	\N	\N	149719	149719	317039
19676	27788	12	applied	\N	\N	\N	\N	149737	149737	317057
19677	27787	11	applied	\N	\N	\N	\N	149754	149754	317074
19678	27794	0	applied	\N	\N	\N	\N	149761	149761	317081
19678	27797	3	applied	\N	\N	\N	\N	149764	149764	317084
19683	27812	1	applied	\N	\N	\N	\N	149806	149806	317126
19684	27813	2	applied	\N	\N	\N	\N	149816	149816	317136
19685	27818	9	applied	\N	\N	\N	\N	149831	149831	317151
19687	27822	3	applied	\N	\N	\N	\N	149845	149845	317165
19689	27818	9	applied	\N	\N	\N	\N	149869	149869	317189
19690	27825	5	applied	\N	\N	\N	\N	149875	149875	317195
19692	27831	3	applied	\N	\N	\N	\N	149888	149888	317208
19694	27751	16	applied	\N	\N	\N	\N	149917	149917	317237
19694	27776	33	applied	\N	\N	\N	\N	149934	149934	317254
19694	27802	51	applied	\N	\N	\N	\N	149951	149951	317271
19694	27826	68	applied	\N	\N	\N	\N	149968	149968	317288
19694	27742	85	applied	\N	\N	\N	\N	149985	149985	317305
19694	27782	88	applied	\N	\N	\N	\N	149988	149988	317308
19694	27711	105	applied	\N	\N	\N	\N	150005	150005	317325
19694	27724	109	applied	\N	\N	\N	\N	150009	150009	317329
19694	27726	110	applied	\N	\N	\N	\N	150010	150010	317330
19695	27838	2	applied	\N	\N	\N	\N	150028	150028	317348
19696	27836	0	applied	\N	\N	\N	\N	150035	150035	317355
19697	27846	1	applied	\N	\N	\N	\N	150045	150045	317365
19698	27872	10	applied	\N	\N	\N	\N	150071	150071	317391
19700	27884	1	applied	\N	\N	\N	\N	150083	150083	317403
19702	27655	9	applied	\N	\N	\N	\N	150097	150097	317417
19702	27745	26	applied	\N	\N	\N	\N	150114	150114	317434
19702	27815	73	applied	\N	\N	\N	\N	150161	150161	317481
19702	27828	83	applied	\N	\N	\N	\N	150170	150170	317490
19702	27832	86	applied	\N	\N	\N	\N	150173	150173	317493
19702	27856	103	applied	\N	\N	\N	\N	150190	150190	317510
19702	27694	120	applied	\N	\N	\N	\N	150207	150207	317527
19705	27899	5	applied	\N	\N	\N	\N	150227	150227	317547
19709	27900	0	applied	\N	\N	\N	\N	150243	150243	317563
19715	27364	8	applied	\N	\N	\N	\N	150270	150270	317590
19715	27745	25	applied	\N	\N	\N	\N	150287	150287	317607
19715	27778	48	applied	\N	\N	\N	\N	150310	150310	317630
19715	27443	65	applied	\N	\N	\N	\N	150327	150327	317647
19715	27444	66	applied	\N	\N	\N	\N	150328	150328	317648
19715	27456	69	applied	\N	\N	\N	\N	150331	150331	317651
19715	27509	86	applied	\N	\N	\N	\N	150348	150348	317668
19715	27569	103	applied	\N	\N	\N	\N	150365	150365	317685
19715	27622	121	applied	\N	\N	\N	\N	150382	150382	317702
19723	27766	26	applied	\N	\N	\N	\N	150444	150444	317764
19723	27789	43	applied	\N	\N	\N	\N	150461	150461	317781
19723	27817	60	applied	\N	\N	\N	\N	150478	150478	317798
19723	27842	77	applied	\N	\N	\N	\N	150495	150495	317815
19723	27865	92	applied	\N	\N	\N	\N	150510	150510	317830
19723	27715	95	applied	\N	\N	\N	\N	150513	150513	317833
19724	27926	1	applied	\N	\N	\N	\N	150515	150515	317835
19726	27939	4	applied	\N	\N	\N	\N	150532	150532	317852
19728	27935	0	applied	\N	\N	\N	\N	150538	150538	317858
19734	27953	0	applied	\N	\N	\N	\N	150563	150563	317883
19738	27908	13	applied	\N	\N	\N	\N	150586	150586	317906
19738	27844	30	applied	\N	\N	\N	\N	150603	150603	317923
19738	27718	47	applied	\N	\N	\N	\N	150620	150620	317940
19738	27860	65	applied	\N	\N	\N	\N	150637	150637	317957
19738	27928	82	applied	\N	\N	\N	\N	150654	150654	317974
19739	27958	2	applied	\N	\N	\N	\N	150669	150669	317989
19743	27963	1	applied	\N	\N	\N	\N	150680	150680	318000
19745	27978	7	applied	\N	\N	\N	\N	150695	150695	318015
19748	27987	1	applied	\N	\N	\N	\N	150707	150707	318027
19749	27971	22	applied	\N	\N	\N	\N	150731	150731	318051
19749	27916	31	applied	\N	\N	\N	\N	150740	150740	318060
19749	27919	39	applied	\N	\N	\N	\N	150748	150748	318068
19749	27970	56	applied	\N	\N	\N	\N	150765	150765	318085
19749	27961	73	applied	\N	\N	\N	\N	150782	150782	318102
19760	28004	0	applied	\N	\N	\N	\N	150816	150816	318136
19762	28012	0	applied	\N	\N	\N	\N	150824	150824	318144
19767	28018	0	applied	\N	\N	\N	\N	150846	150846	318166
19768	27956	7	applied	\N	\N	\N	\N	150863	150863	318183
19768	28006	24	applied	\N	\N	\N	\N	150880	150880	318200
19768	28018	28	applied	\N	\N	\N	\N	150884	150884	318204
19768	27957	44	applied	\N	\N	\N	\N	150900	150900	318220
19768	27969	52	applied	\N	\N	\N	\N	150908	150908	318228
19768	28017	70	applied	\N	\N	\N	\N	150926	150926	318246
19768	28003	88	applied	\N	\N	\N	\N	150943	150943	318263
19770	28028	0	applied	\N	\N	\N	\N	150952	150952	318272
19777	28055	2	applied	\N	\N	\N	\N	150982	150982	318302
19778	28057	1	applied	\N	\N	\N	\N	150984	150984	318304
19783	28074	2	applied	\N	\N	\N	\N	151015	151015	318335
19788	28091	2	applied	\N	\N	\N	\N	151042	151042	318362
19789	28093	0	applied	\N	\N	\N	\N	151044	151044	318364
19790	28098	2	applied	\N	\N	\N	\N	151049	151049	318369
19798	28112	3	applied	\N	\N	\N	\N	151074	151074	318394
19801	28112	3	applied	\N	\N	\N	\N	151098	151098	318418
19803	28124	3	applied	\N	\N	\N	\N	151110	151110	318430
19804	28125	4	applied	\N	\N	\N	\N	151121	151121	318441
19813	28145	1	applied	\N	\N	\N	\N	151150	151150	318470
19819	28160	0	applied	\N	\N	\N	\N	151169	151169	318489
19821	28111	2	applied	\N	\N	\N	\N	151181	151181	318499
19823	28174	2	applied	\N	\N	\N	\N	151188	151188	318506
19837	28200	2	applied	\N	\N	\N	\N	151231	151231	318549
19840	28206	2	applied	\N	\N	\N	\N	151240	151240	318558
19847	28110	1	applied	\N	\N	\N	\N	151266	151266	318584
19647	27597	39	applied	\N	\N	\N	\N	149466	149466	316786
19854	28227	0	applied	\N	\N	\N	\N	151322	151322	318640
19854	28228	1	applied	\N	\N	\N	\N	151323	151323	318641
19858	28240	1	applied	\N	\N	\N	\N	151341	151341	318659
19861	28250	2	applied	\N	\N	\N	\N	151356	151356	318674
19866	28265	5	applied	\N	\N	\N	\N	151381	151381	318699
19867	28263	3	applied	\N	\N	\N	\N	151399	151399	318717
19867	28271	11	applied	\N	\N	\N	\N	151407	151407	318725
19867	28272	12	applied	\N	\N	\N	\N	151408	151408	318726
19868	28262	2	applied	\N	\N	\N	\N	151418	151418	318736
19868	28279	19	applied	\N	\N	\N	\N	151435	151435	318753
19875	28238	15	applied	\N	\N	\N	\N	151469	151469	318787
19879	28298	1	applied	\N	\N	\N	\N	151480	151480	318798
19880	28111	3	applied	\N	\N	\N	\N	151489	151489	318807
19880	28039	20	applied	\N	\N	\N	\N	151506	151506	318824
19880	28150	37	applied	\N	\N	\N	\N	151523	151523	318841
19884	28309	2	applied	\N	\N	\N	\N	151547	151547	318865
19887	28316	1	applied	\N	\N	\N	\N	151558	151558	318876
19890	28328	1	applied	\N	\N	\N	\N	151571	151571	318889
19894	28340	2	applied	\N	\N	\N	\N	151602	151602	318920
19895	28340	2	applied	\N	\N	\N	\N	151606	151606	318924
19900	28343	1	applied	\N	\N	\N	\N	151625	151625	318943
19901	28349	3	applied	\N	\N	\N	\N	151631	151631	318949
19905	28356	0	applied	\N	\N	\N	\N	151648	151648	318966
19906	28363	7	applied	\N	\N	\N	\N	151665	151665	318983
19909	28366	0	applied	\N	\N	\N	\N	151682	151682	319000
19911	28372	2	applied	\N	\N	\N	\N	151692	151692	319010
19917	28390	2	applied	\N	\N	\N	\N	151720	151720	319038
19918	28399	6	applied	\N	\N	\N	\N	151729	151729	319047
19919	28395	2	applied	\N	\N	\N	\N	151732	151732	319050
19921	28344	14	applied	\N	\N	1000000000	\N	151755	151755	319073
19928	28415	2	applied	\N	\N	\N	\N	151774	151774	319092
19931	28416	1	applied	\N	\N	\N	\N	151782	151782	319100
19936	28424	1	applied	\N	\N	\N	\N	151802	151802	319120
19944	28383	10	applied	\N	\N	\N	\N	151833	151833	319151
19944	28028	27	applied	\N	\N	\N	\N	151850	151850	319168
19944	28031	28	applied	\N	\N	\N	\N	151851	151851	319169
19944	28040	31	applied	\N	\N	\N	\N	151854	151854	319172
19944	28096	49	applied	\N	\N	\N	\N	151871	151871	319189
19944	28113	53	applied	\N	\N	\N	\N	151875	151875	319193
19944	28121	56	applied	\N	\N	\N	\N	151878	151878	319196
19944	28158	73	applied	\N	\N	\N	\N	151895	151895	319213
19944	28212	90	applied	\N	\N	\N	\N	151912	151912	319230
19944	28347	124	applied	\N	\N	\N	\N	151946	151946	319264
19945	28432	4	applied	\N	\N	\N	\N	151952	151952	319270
19946	28435	0	applied	\N	\N	\N	\N	151955	151955	319273
19948	28452	7	applied	\N	\N	\N	\N	151972	151972	319290
19952	28460	0	applied	\N	\N	\N	\N	152001	152001	319319
19953	28469	6	applied	\N	\N	\N	\N	152010	152010	319328
19956	28486	0	applied	\N	\N	\N	\N	152032	152032	319350
19958	28370	6	applied	\N	\N	\N	\N	152053	152053	319371
19958	28451	20	applied	\N	\N	\N	\N	152067	152067	319385
19958	28117	38	applied	\N	\N	\N	\N	152084	152084	319402
19958	28148	55	applied	\N	\N	\N	\N	152101	152101	319419
19958	28204	72	applied	\N	\N	\N	\N	152118	152118	319436
19958	28267	89	applied	\N	\N	\N	\N	152135	152135	319453
19958	28358	113	applied	\N	\N	\N	\N	152159	152159	319477
19960	28496	0	applied	\N	\N	\N	\N	152175	152175	319493
19964	28404	4	applied	\N	\N	\N	\N	152191	152191	319509
19970	28519	0	applied	\N	\N	\N	\N	152221	152221	319539
19975	28523	1	applied	\N	\N	\N	\N	152253	152253	319571
19976	28522	0	applied	\N	\N	\N	\N	152259	152259	319577
19976	28524	2	applied	\N	\N	\N	\N	152261	152261	319579
19976	28525	3	applied	\N	\N	\N	\N	152262	152262	319580
19981	28545	1	applied	\N	\N	1000000000	\N	152291	152291	319609
19985	28554	0	applied	\N	\N	\N	\N	152306	152306	319624
19989	28558	1	applied	\N	\N	\N	\N	152323	152323	319641
19991	28576	11	applied	\N	\N	\N	\N	152341	152341	319659
19992	28571	6	applied	\N	\N	\N	\N	152348	152348	319666
20000	28545	4	applied	\N	\N	1000000000	\N	152382	152382	319700
20000	28493	11	applied	\N	\N	\N	\N	152389	152389	319707
20000	28502	14	applied	\N	\N	\N	\N	152392	152392	319710
20000	28566	31	applied	\N	\N	\N	\N	152409	152409	319727
20000	28483	48	applied	\N	\N	\N	\N	152426	152426	319744
20000	28516	65	applied	\N	\N	\N	\N	152443	152443	319761
20000	28534	100	applied	\N	\N	\N	\N	152477	152477	319795
20002	28594	4	applied	\N	\N	\N	\N	152499	152499	319817
20003	28591	1	applied	\N	\N	\N	\N	152501	152501	319819
20009	28604	5	applied	\N	\N	\N	\N	152534	152534	319852
20009	28605	6	applied	\N	\N	\N	\N	152535	152535	319853
20010	28613	3	applied	\N	\N	\N	\N	152543	152543	319861
20017	28621	2	applied	\N	\N	\N	\N	152566	152566	319884
20018	28620	1	applied	\N	\N	\N	\N	152569	152569	319887
20022	28640	9	applied	\N	\N	1000000000	\N	152593	152593	319911
20027	28654	0	applied	\N	\N	\N	\N	152612	152612	319930
20035	28671	1	applied	\N	\N	\N	\N	152632	152632	319950
20036	28670	0	applied	\N	\N	\N	\N	152634	152634	319952
20049	28697	2	applied	\N	\N	\N	\N	152680	152680	319998
20052	28706	4	applied	\N	\N	\N	\N	152692	152692	320010
20052	28723	22	applied	\N	\N	\N	\N	152709	152709	320027
20053	28734	1	applied	\N	\N	\N	\N	152720	152720	320038
20055	28704	1	applied	\N	\N	\N	\N	152727	152727	320045
20055	28705	2	applied	\N	\N	\N	\N	152728	152728	320046
20055	28722	19	applied	\N	\N	\N	\N	152745	152745	320063
20057	28711	8	applied	\N	\N	\N	\N	152765	152765	320083
20057	28728	25	applied	\N	\N	\N	\N	152782	152782	320100
20061	28760	0	applied	\N	\N	\N	\N	152805	152805	320123
20062	28775	0	applied	\N	\N	\N	\N	152820	152820	320138
20064	28777	2	applied	\N	\N	\N	\N	152828	152828	320146
20067	28713	13	applied	\N	\N	\N	\N	152847	152847	320165
20067	28730	30	applied	\N	\N	\N	\N	152864	152864	320182
20067	28739	62	applied	\N	\N	\N	\N	152896	152896	320214
20067	28770	69	applied	\N	\N	\N	\N	152903	152903	320221
20067	28751	84	applied	\N	\N	\N	\N	152917	152917	320235
20075	28786	0	applied	\N	\N	\N	\N	152955	152955	320273
20078	28793	1	applied	\N	\N	\N	\N	152965	152965	320283
20079	28798	3	applied	\N	\N	\N	\N	152970	152970	320288
20082	28811	4	applied	\N	\N	\N	\N	152990	152990	320308
20086	28830	8	applied	\N	\N	\N	\N	153025	153025	320340
20087	28836	6	applied	\N	\N	\N	\N	153035	153035	320349
20087	28847	23	applied	\N	\N	\N	\N	153052	153052	320366
19853	28229	3	applied	\N	\N	\N	\N	151319	151319	318637
20089	28878	4	applied	\N	\N	\N	\N	153085	153085	320399
20090	28879	1	applied	\N	\N	\N	\N	153095	153095	320409
20092	28890	3	applied	\N	\N	\N	\N	153120	153120	320434
20092	28901	14	applied	\N	\N	\N	\N	153131	153131	320445
20093	28910	4	applied	\N	\N	\N	\N	153140	153140	320454
20093	28913	7	applied	\N	\N	\N	\N	153143	153143	320457
20094	28822	4	applied	\N	\N	\N	\N	153157	153157	320469
20095	28918	12	applied	\N	\N	\N	\N	153182	153182	320494
20098	28925	6	applied	\N	\N	\N	\N	153202	153202	320514
20099	28937	7	applied	\N	\N	\N	\N	153211	153211	320523
20099	28940	10	applied	\N	\N	\N	\N	153214	153214	320526
20100	28931	1	applied	\N	\N	\N	\N	153217	153217	320529
20102	28943	1	applied	\N	\N	\N	\N	153240	153240	320552
20104	28959	6	applied	\N	\N	\N	\N	153265	153265	320577
20106	28959	6	applied	\N	\N	\N	\N	153283	153283	320595
20107	28965	3	applied	\N	\N	\N	\N	153289	153289	320601
20116	28983	4	applied	\N	\N	\N	\N	153322	153322	320634
20118	28992	1	applied	\N	\N	\N	\N	153331	153331	320643
20121	29005	5	applied	\N	\N	\N	\N	153352	153352	320664
20125	29024	3	applied	\N	\N	\N	\N	153379	153379	320691
20126	29027	9	applied	\N	\N	\N	\N	153393	153393	320705
20127	29027	9	applied	\N	\N	\N	\N	153404	153404	320716
20128	29029	3	applied	\N	\N	\N	\N	153409	153409	320721
20134	29048	6	applied	\N	\N	\N	\N	153452	153452	320764
20135	29044	2	applied	\N	\N	\N	\N	153458	153458	320770
20136	29048	6	applied	\N	\N	\N	\N	153472	153472	320784
20144	29064	1	applied	\N	\N	\N	\N	153502	153502	320814
20146	29066	3	applied	\N	\N	\N	\N	153514	153514	320826
20147	29021	7	applied	\N	\N	\N	\N	153523	153523	320835
20147	28970	8	applied	\N	\N	\N	\N	153524	153524	320836
20147	28972	10	applied	\N	\N	\N	\N	153526	153526	320838
20147	28990	11	applied	\N	\N	\N	\N	153527	153527	320839
20147	28985	18	applied	\N	\N	\N	\N	153534	153534	320846
20147	29019	19	applied	\N	\N	\N	\N	153535	153535	320847
20147	29020	20	applied	\N	\N	\N	\N	153536	153536	320848
20147	29068	21	applied	\N	\N	\N	\N	153537	153537	320849
20147	29065	22	applied	\N	\N	\N	\N	153538	153538	320850
20147	28992	23	applied	\N	\N	\N	\N	153539	153539	320851
20147	28979	24	applied	\N	\N	\N	\N	153540	153540	320852
20147	28986	25	applied	\N	\N	\N	\N	153541	153541	320853
20147	28991	26	applied	\N	\N	\N	\N	153542	153542	320854
20147	28998	27	applied	\N	\N	\N	\N	153543	153543	320855
20147	29001	28	applied	\N	\N	\N	\N	153544	153544	320856
20147	29002	29	applied	\N	\N	\N	\N	153545	153545	320857
20147	29008	30	applied	\N	\N	\N	\N	153546	153546	320858
20147	29009	31	applied	\N	\N	\N	\N	153547	153547	320859
20147	29023	33	applied	\N	\N	\N	\N	153549	153549	320861
20147	29024	34	applied	\N	\N	\N	\N	153550	153550	320862
20147	29032	35	applied	\N	\N	\N	\N	153551	153551	320863
20147	29036	36	applied	\N	\N	\N	\N	153552	153552	320864
20147	29042	37	applied	\N	\N	\N	\N	153553	153553	320865
20147	29044	38	applied	\N	\N	\N	\N	153554	153554	320866
20147	29045	39	applied	\N	\N	\N	\N	153555	153555	320867
20147	29052	40	applied	\N	\N	\N	\N	153556	153556	320868
20147	29054	41	applied	\N	\N	\N	\N	153557	153557	320869
20147	29059	42	applied	\N	\N	\N	\N	153558	153558	320870
20147	29064	43	applied	\N	\N	\N	\N	153559	153559	320871
20147	29033	44	applied	\N	\N	\N	\N	153560	153560	320872
20147	29037	45	applied	\N	\N	\N	\N	153561	153561	320873
20147	29038	46	applied	\N	\N	\N	\N	153562	153562	320874
20147	29039	47	applied	\N	\N	\N	\N	153563	153563	320875
20147	28974	48	applied	\N	\N	\N	\N	153564	153564	320876
20147	28994	50	applied	\N	\N	\N	\N	153566	153566	320878
20157	29096	2	applied	\N	\N	\N	\N	153647	153647	320959
20157	29099	5	applied	\N	\N	\N	\N	153650	153650	320962
20160	29116	1	applied	\N	\N	\N	\N	153673	153673	320985
20162	29057	2	applied	\N	\N	\N	\N	153692	153692	321004
20162	28887	15	applied	\N	\N	\N	\N	153705	153705	321016
20162	28983	16	applied	\N	\N	\N	\N	153706	153706	321017
20162	28944	33	applied	\N	\N	\N	\N	153723	153723	321034
20162	29068	50	applied	\N	\N	\N	\N	153740	153740	321050
20162	28841	67	applied	\N	\N	\N	\N	153757	153757	321067
20162	28865	84	applied	\N	\N	\N	\N	153774	153774	321084
20162	28896	101	applied	\N	\N	\N	\N	153791	153791	321101
20162	28931	119	applied	\N	\N	\N	\N	153808	153808	321118
20163	29132	8	applied	\N	\N	\N	\N	153822	153822	321132
20165	29155	18	applied	\N	\N	\N	\N	153858	153858	321168
20167	29164	1	applied	\N	\N	\N	\N	153873	153873	321183
20171	29187	3	applied	\N	\N	1000000000	\N	153905	153905	321215
20174	29195	2	applied	\N	\N	\N	\N	153913	153913	321223
20175	29198	0	applied	\N	\N	\N	\N	153916	153916	321226
20176	29200	2	applied	\N	\N	\N	\N	153923	153923	321233
20181	29058	2	applied	\N	\N	\N	\N	153949	153949	321259
20181	29017	19	applied	\N	\N	\N	\N	153966	153966	321276
20181	28809	36	applied	\N	\N	\N	\N	153983	153983	321293
20181	28827	53	applied	\N	\N	\N	\N	154000	154000	321310
20181	28857	69	applied	\N	\N	1000000000	\N	154016	154016	321326
20181	27716	89	applied	\N	\N	\N	\N	154036	154036	321346
20181	28077	98	applied	\N	\N	\N	\N	154045	154045	321355
20182	29147	10	applied	\N	\N	\N	\N	154056	154056	321366
20182	28779	27	applied	\N	\N	\N	\N	154073	154073	321383
20185	28874	1	applied	\N	\N	\N	\N	154103	154103	321413
20185	29141	18	applied	\N	\N	\N	\N	154120	154120	321430
20185	29146	23	applied	\N	\N	\N	\N	154125	154125	321435
20185	28984	44	applied	\N	\N	\N	\N	154145	154145	321454
20185	28890	47	applied	\N	\N	\N	\N	154148	154148	321457
20185	29170	63	applied	\N	\N	\N	\N	154164	154164	321472
20185	28372	80	applied	\N	\N	\N	\N	154181	154181	321489
20185	28406	97	applied	\N	\N	\N	\N	154198	154198	321506
20185	28846	114	applied	\N	\N	\N	\N	154215	154215	321523
20186	29239	6	applied	\N	\N	\N	\N	154232	154232	321540
20187	29245	2	applied	\N	\N	\N	\N	154238	154238	321546
20190	29249	3	applied	\N	\N	\N	\N	154248	154248	321556
20194	29271	3	applied	\N	\N	\N	\N	154270	154270	321578
20197	29276	2	applied	\N	\N	\N	\N	154287	154287	321595
20200	29287	1	applied	\N	\N	\N	\N	154302	154302	321610
20206	29235	10	applied	\N	\N	\N	\N	154329	154329	321637
20206	29224	27	applied	\N	\N	\N	\N	154346	154346	321654
20206	29225	28	applied	\N	\N	\N	\N	154347	154347	321655
20206	29242	31	applied	\N	\N	\N	\N	154350	154350	321658
20089	28875	1	applied	\N	\N	\N	\N	153082	153082	320396
20214	29309	0	applied	\N	\N	\N	\N	154423	154423	321731
20215	29318	6	applied	\N	\N	\N	\N	154432	154432	321740
20217	29316	3	applied	\N	\N	\N	\N	154443	154443	321751
20220	29315	6	applied	\N	\N	\N	\N	154465	154465	321773
20222	29318	7	applied	\N	\N	\N	\N	154486	154486	321794
20223	29326	9	applied	\N	\N	\N	\N	154498	154498	321806
20232	29344	1	applied	\N	\N	\N	\N	154531	154531	321839
20233	29351	2	applied	\N	\N	\N	\N	154538	154538	321846
20236	29336	15	applied	\N	\N	\N	\N	154563	154563	321871
20236	29326	32	applied	\N	\N	\N	\N	154580	154580	321888
20236	29332	48	applied	\N	\N	\N	\N	154595	154595	321903
20236	29342	51	applied	\N	\N	\N	\N	154598	154598	321906
20243	29373	2	applied	\N	\N	\N	\N	154628	154628	321936
20247	29403	9	applied	\N	\N	\N	\N	154658	154658	321966
20248	29396	1	applied	\N	\N	\N	\N	154660	154660	321968
20248	29399	4	applied	\N	\N	\N	\N	154663	154663	321971
20252	29412	2	applied	\N	\N	\N	\N	154683	154683	321991
20252	29415	5	applied	\N	\N	\N	\N	154686	154686	321994
20253	29425	8	applied	\N	\N	\N	\N	154696	154696	322004
20254	29424	7	applied	\N	\N	\N	\N	154708	154708	322016
20258	29439	6	applied	\N	\N	\N	\N	154728	154728	322036
20264	29452	6	applied	\N	\N	\N	\N	154753	154753	322061
20265	29450	4	applied	\N	\N	\N	\N	154758	154758	322066
20273	29469	5	applied	\N	\N	\N	\N	154791	154791	322099
20274	29469	5	applied	\N	\N	\N	\N	154798	154798	322106
20278	29016	9	applied	\N	\N	\N	\N	154828	154828	322136
20278	29139	26	applied	\N	\N	\N	\N	154845	154845	322153
20278	28983	43	applied	\N	\N	\N	\N	154862	154862	322169
20278	28329	59	applied	\N	\N	\N	\N	154878	154878	322185
20278	28545	77	applied	\N	\N	1000000000	\N	154895	154895	322202
20278	28946	82	applied	\N	\N	\N	\N	154900	154900	322207
20278	28953	83	applied	\N	\N	\N	\N	154901	154901	322208
20278	28389	100	applied	\N	\N	\N	\N	154918	154918	322224
20278	28828	117	applied	\N	\N	\N	\N	154935	154935	322241
20280	29484	0	applied	\N	\N	\N	\N	154948	154948	322254
20282	29486	4	applied	\N	\N	\N	\N	154957	154957	322263
20286	29493	2	applied	\N	\N	\N	\N	154979	154979	322285
20291	29501	6	applied	\N	\N	\N	\N	155015	155015	322321
20293	29497	0	applied	\N	\N	\N	\N	155023	155023	322329
20296	29507	0	applied	\N	\N	\N	\N	155036	155036	322342
20298	29524	1	applied	\N	\N	\N	\N	155053	155053	322359
20300	29532	6	applied	\N	\N	\N	\N	155064	155064	322370
20307	29554	1	applied	\N	\N	\N	\N	155089	155089	322395
20312	29567	1	applied	\N	\N	\N	\N	155108	155108	322414
20319	29584	6	applied	\N	\N	\N	\N	155139	155139	322445
20319	29580	9	applied	\N	\N	\N	\N	155142	155142	322448
20321	29597	3	applied	\N	\N	\N	\N	155160	155160	322466
20327	29606	2	applied	\N	\N	\N	\N	155185	155185	322491
20328	29606	2	applied	\N	\N	\N	\N	155190	155190	322496
20329	29354	12	applied	\N	\N	\N	\N	155205	155205	322511
20329	29364	15	applied	\N	\N	\N	\N	155208	155208	322514
20329	29419	32	applied	\N	\N	\N	\N	155225	155225	322531
20329	29434	36	applied	\N	\N	\N	\N	155229	155229	322535
20329	29447	39	applied	\N	\N	\N	\N	155232	155232	322538
20329	29504	56	applied	\N	\N	\N	\N	155249	155249	322555
20329	29559	73	applied	\N	\N	\N	\N	155266	155266	322572
20329	29347	91	applied	\N	\N	\N	\N	155283	155283	322589
20329	29590	108	applied	\N	\N	\N	\N	155300	155300	322606
20329	29414	125	applied	\N	\N	\N	\N	155317	155317	322623
20338	29636	0	applied	\N	\N	\N	\N	155355	155355	322661
20340	29637	1	applied	\N	\N	\N	\N	155368	155368	322674
20341	29606	11	applied	\N	\N	\N	\N	155384	155384	322690
20341	29640	28	applied	\N	\N	\N	\N	155401	155401	322707
20346	29653	0	applied	\N	\N	\N	\N	155430	155430	322736
20347	29660	4	applied	\N	\N	\N	\N	155437	155437	322743
20351	29669	1	applied	\N	\N	\N	\N	155452	155452	322758
20358	29680	1	applied	\N	\N	\N	\N	155472	155472	322778
20359	29676	12	applied	\N	\N	\N	\N	155489	155489	322795
20359	29686	29	applied	\N	\N	\N	\N	155506	155506	322812
20360	29685	0	applied	\N	\N	\N	\N	155523	155523	322829
20366	29702	1	applied	\N	\N	\N	\N	155549	155549	322855
20368	29707	0	applied	\N	\N	\N	\N	155554	155554	322860
20369	29715	2	applied	\N	\N	\N	\N	155562	155562	322868
20370	29715	3	applied	\N	\N	\N	\N	155579	155579	322885
20371	29720	8	applied	\N	\N	\N	\N	155601	155601	322907
20372	29733	3	applied	\N	\N	\N	\N	155613	155613	322919
20378	29740	12	applied	\N	\N	\N	\N	155641	155641	322947
20378	29712	29	applied	\N	\N	\N	\N	155658	155658	322964
20378	29721	46	applied	\N	\N	\N	\N	155675	155675	322981
20384	29755	1	applied	\N	\N	\N	\N	155705	155705	323011
20385	29693	2	applied	\N	\N	\N	\N	155709	155709	323015
20385	29726	25	applied	\N	\N	\N	\N	155732	155732	323038
20391	29781	8	applied	\N	\N	\N	\N	155761	155761	323067
20392	29780	7	applied	\N	\N	\N	\N	155769	155769	323075
20395	29783	1	applied	\N	\N	\N	\N	155776	155776	323082
20399	29626	6	applied	\N	\N	\N	\N	155792	155792	323098
20399	29676	22	applied	\N	\N	\N	\N	155808	155808	323114
20399	29685	25	applied	\N	\N	\N	\N	155811	155811	323117
20399	29754	42	applied	\N	\N	\N	\N	155828	155828	323134
20399	29423	59	applied	\N	\N	\N	\N	155845	155845	323151
20399	29468	76	applied	\N	\N	\N	\N	155862	155862	323168
20399	29505	95	applied	\N	\N	\N	\N	155879	155879	323185
20401	29789	2	applied	\N	\N	\N	\N	155915	155915	323221
20402	29749	3	applied	\N	\N	\N	\N	155919	155919	323225
20402	29742	18	applied	\N	\N	\N	\N	155934	155934	323240
20402	29753	22	applied	\N	\N	\N	\N	155938	155938	323244
20405	29794	1	applied	\N	\N	\N	\N	155963	155963	323269
20407	29811	3	applied	\N	\N	\N	\N	155980	155980	323286
20411	29819	1	applied	\N	\N	\N	\N	156001	156001	323307
20412	29822	3	applied	\N	\N	\N	\N	156009	156009	323315
20413	29821	3	applied	\N	\N	\N	\N	156015	156015	323321
20632	30342	6	applied	\N	\N	\N	\N	157971	157971	325252
20417	29837	2	applied	\N	\N	1000000000	\N	156055	156055	323361
20418	29837	2	applied	\N	\N	1000000000	\N	156060	156060	323366
20420	29844	4	applied	\N	\N	\N	\N	156073	156073	323379
20421	29843	3	applied	\N	\N	\N	\N	156078	156078	323384
20431	29860	5	applied	\N	\N	\N	\N	156116	156116	323422
20433	29865	2	applied	\N	\N	\N	\N	156127	156127	323433
20436	29876	9	applied	\N	\N	\N	\N	156155	156155	323461
20438	29871	3	applied	\N	\N	\N	\N	156171	156171	323477
20446	29887	0	applied	\N	\N	\N	\N	156195	156195	323501
20213	29305	4	applied	\N	\N	\N	\N	154419	154419	321727
20454	29901	4	applied	\N	\N	\N	\N	156230	156230	323536
20455	29901	4	applied	\N	\N	\N	\N	156236	156236	323542
20467	29787	3	applied	\N	\N	\N	\N	156274	156274	323580
20467	29857	23	applied	\N	\N	\N	\N	156294	156294	323600
20467	29784	48	applied	\N	\N	\N	\N	156319	156319	323625
20467	29902	65	applied	\N	\N	\N	\N	156336	156336	323642
20467	29842	82	applied	\N	\N	\N	\N	156353	156353	323659
20467	29908	99	applied	\N	\N	\N	\N	156370	156370	323676
20467	29834	117	applied	\N	\N	\N	\N	156387	156387	323693
20468	29926	3	applied	\N	\N	\N	\N	156399	156399	323705
20472	29935	2	applied	\N	\N	\N	\N	156412	156412	323718
20477	29940	1	applied	\N	\N	\N	\N	156426	156426	323732
20478	29898	0	applied	\N	\N	1000000000	\N	156429	156429	323735
20478	29752	3	applied	\N	\N	\N	\N	156432	156432	323738
20478	29761	6	applied	\N	\N	\N	\N	156435	156435	323741
20478	29808	23	applied	\N	\N	\N	\N	156452	156452	323758
20478	29882	40	applied	\N	\N	\N	\N	156469	156469	323775
20478	29912	49	applied	\N	\N	\N	\N	156478	156478	323784
20478	29815	59	applied	\N	\N	\N	\N	156488	156488	323794
20478	29789	96	applied	\N	\N	\N	\N	156524	156524	323830
20478	29800	113	applied	\N	\N	\N	\N	156541	156541	323847
20479	29955	12	applied	\N	\N	1000000000	\N	156566	156566	323872
20484	29973	2	applied	\N	\N	\N	\N	156591	156591	323897
20486	29945	2	applied	\N	\N	\N	\N	156601	156601	323907
20486	29961	19	applied	\N	\N	\N	\N	156618	156618	323924
20491	29982	0	applied	\N	\N	\N	\N	156648	156648	323954
20499	30004	1	applied	\N	\N	\N	\N	156675	156675	323981
20500	30003	0	applied	\N	\N	\N	\N	156678	156678	323984
20501	30003	0	applied	\N	\N	\N	\N	156682	156682	323988
20508	29898	4	applied	\N	\N	1000000000	\N	156703	156703	324009
20508	29971	6	applied	\N	\N	\N	\N	156705	156705	324011
20508	29569	7	applied	\N	\N	\N	\N	156706	156706	324012
20508	29620	25	applied	\N	\N	\N	\N	156723	156723	324029
20508	29676	42	applied	\N	\N	\N	\N	156740	156740	324046
20508	29740	57	applied	\N	\N	\N	\N	156755	156755	324061
20508	29741	58	applied	\N	\N	\N	\N	156756	156756	324062
20508	29793	75	applied	\N	\N	\N	\N	156773	156773	324079
20508	29856	92	applied	\N	\N	\N	\N	156790	156790	324096
20510	30017	0	applied	\N	\N	\N	\N	156826	156826	324132
20514	30020	0	applied	\N	\N	\N	\N	156836	156836	324142
20515	30036	14	applied	\N	\N	\N	\N	156852	156852	324158
20516	30035	13	applied	\N	\N	\N	\N	156873	156873	324179
20517	30032	9	applied	\N	\N	\N	\N	156892	156892	324198
20517	30039	17	applied	\N	\N	\N	\N	156899	156899	324205
20519	30049	2	applied	\N	\N	\N	\N	156911	156911	324217
20524	30053	2	applied	\N	\N	\N	\N	156937	156937	324243
20526	30069	1	applied	\N	\N	\N	\N	156953	156953	324259
20528	30083	3	applied	\N	\N	\N	\N	156967	156967	324273
20531	30086	2	applied	\N	\N	\N	\N	156977	156977	324283
20534	30089	2	applied	\N	\N	\N	\N	156990	156990	324296
20536	29787	11	applied	\N	\N	\N	\N	157009	157009	324315
20536	29805	18	applied	\N	\N	\N	\N	157016	157016	324322
20546	30126	2	applied	\N	\N	\N	\N	157062	157062	324367
20555	30139	2	applied	\N	\N	\N	\N	157084	157084	324389
20556	30140	3	applied	\N	\N	\N	\N	157089	157089	324394
20558	30142	1	applied	\N	\N	\N	\N	157094	157094	324399
20559	29955	37	applied	\N	\N	1000000000	\N	157143	157143	324447
20559	30113	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	157115	157115	\N
20559	30043	58	applied	\N	\N	\N	\N	157164	157164	324468
20561	30157	1	applied	\N	\N	\N	\N	157183	157183	324487
20568	30160	1	applied	\N	\N	\N	\N	157215	157215	324519
20569	30164	5	applied	\N	\N	\N	\N	157227	157227	324531
20570	30166	7	applied	\N	\N	\N	\N	157237	157237	324541
20573	30058	14	applied	\N	\N	\N	\N	157266	157266	324569
20573	30068	18	applied	\N	\N	\N	\N	157270	157270	324573
20573	29986	29	applied	\N	\N	\N	\N	157281	157281	324584
20573	30046	46	applied	\N	\N	\N	\N	157298	157298	324601
20573	30127	63	applied	\N	\N	\N	\N	157315	157315	324618
20573	30063	80	applied	\N	\N	\N	\N	157332	157332	324635
20573	29995	98	applied	\N	\N	\N	\N	157349	157349	324652
20579	29949	20	applied	\N	\N	\N	\N	157388	157388	324688
20579	29982	36	applied	\N	\N	\N	\N	157404	157404	324704
20579	30027	53	applied	\N	\N	\N	\N	157421	157421	324721
20579	30121	71	applied	\N	\N	\N	\N	157438	157438	324738
20579	30110	86	applied	\N	\N	1000000000	\N	157453	157453	324753
20580	30175	0	applied	\N	\N	\N	\N	157468	157468	324768
20581	30175	0	applied	\N	\N	\N	\N	157471	157471	324771
20581	30177	2	applied	\N	\N	\N	\N	157473	157473	324773
20583	30178	0	applied	\N	\N	\N	\N	157482	157482	324782
20584	30191	5	applied	\N	\N	\N	\N	157494	157494	324794
20585	30192	6	applied	\N	\N	\N	\N	157505	157505	324805
20586	30191	5	applied	\N	\N	\N	\N	157514	157514	324814
20596	30076	0	applied	\N	\N	\N	\N	157556	157556	324856
20596	30145	17	applied	\N	\N	\N	\N	157573	157573	324872
20596	30106	34	applied	\N	\N	\N	\N	157590	157590	324889
20596	30137	50	applied	\N	\N	\N	\N	157606	157606	324905
20596	30110	67	applied	\N	\N	1000000000	\N	157623	157623	324922
20596	30086	87	applied	\N	\N	\N	\N	157642	157642	324941
20596	30118	95	applied	\N	\N	\N	\N	157650	157650	324949
20596	30085	108	applied	\N	\N	\N	\N	157663	157663	324962
20596	30165	125	applied	\N	\N	\N	\N	157680	157680	324979
20598	30216	2	applied	\N	\N	\N	\N	157685	157685	324984
20608	29946	3	applied	\N	\N	\N	\N	157710	157710	325009
20608	30142	20	applied	\N	\N	\N	\N	157727	157727	325025
20610	30236	4	applied	\N	\N	\N	\N	157740	157740	325038
20611	30233	1	applied	\N	\N	\N	\N	157747	157747	325045
20617	30256	3	applied	\N	\N	\N	\N	157776	157776	325072
20618	30264	6	applied	\N	\N	\N	\N	157784	157784	325079
20622	30281	6	applied	\N	\N	\N	\N	157824	157824	325113
20623	30242	17	applied	\N	\N	\N	\N	157842	157842	325130
20623	30272	34	applied	\N	\N	1000000000	\N	157858	157858	325141
20623	30257	54	applied	\N	\N	\N	\N	157878	157878	325161
20623	30259	55	applied	\N	\N	\N	\N	157879	157879	325162
20623	30230	65	applied	\N	\N	\N	\N	157889	157889	325172
20626	30286	4	applied	\N	\N	\N	\N	157915	157915	325196
20628	30303	10	applied	\N	\N	\N	\N	157932	157932	325213
20630	30320	8	applied	\N	\N	\N	\N	157949	157949	325230
20631	30330	6	applied	\N	\N	\N	\N	157959	157959	325240
20453	29902	5	applied	\N	\N	\N	\N	156225	156225	323531
20646	30203	9	applied	\N	\N	\N	\N	158036	158036	325317
20646	30212	26	applied	\N	\N	\N	\N	158053	158053	325333
20646	30248	39	applied	\N	\N	\N	\N	158065	158065	325345
20646	30350	56	applied	\N	\N	\N	\N	158082	158082	325362
20646	30296	73	applied	\N	\N	\N	\N	158099	158099	325375
20646	30274	80	applied	\N	\N	1000000000	\N	158106	158106	325380
20646	30229	88	applied	\N	\N	\N	\N	158114	158114	325388
20646	30237	105	applied	\N	\N	\N	\N	158131	158131	325405
20646	30311	122	applied	\N	\N	\N	\N	158148	158148	325422
20648	30377	3	applied	\N	\N	\N	\N	158152	158152	325426
20651	29986	29	applied	\N	\N	\N	\N	158186	158186	325459
20651	29994	32	applied	\N	\N	\N	\N	158189	158189	325462
20651	30210	49	applied	\N	\N	\N	\N	158206	158206	325479
20651	30026	66	applied	\N	\N	\N	\N	158223	158223	325496
20651	30115	84	applied	\N	\N	\N	\N	158240	158240	325513
20651	30161	101	applied	\N	\N	\N	\N	158257	158257	325530
20651	30232	118	applied	\N	\N	\N	\N	158274	158274	325547
20658	30385	0	applied	\N	\N	\N	\N	158299	158299	325572
20665	30405	11	applied	\N	\N	\N	\N	158329	158329	325602
20666	30396	2	applied	\N	\N	\N	\N	158333	158333	325606
20667	30396	2	applied	\N	\N	\N	\N	158346	158346	325619
20673	30414	1	applied	\N	\N	\N	\N	158373	158373	325646
20674	30417	1	applied	\N	\N	\N	\N	158376	158376	325649
20675	30424	8	applied	\N	\N	\N	\N	158392	158392	325665
20677	30416	0	applied	\N	\N	\N	\N	158402	158402	325675
20679	30427	2	applied	\N	\N	\N	\N	158416	158416	325689
20680	30417	8	applied	\N	\N	\N	\N	158425	158425	325698
20680	30404	25	applied	\N	\N	\N	\N	158441	158441	325714
20683	30343	13	applied	\N	\N	\N	\N	158468	158468	325741
20683	30350	30	applied	\N	\N	\N	\N	158485	158485	325758
20683	30359	33	applied	\N	\N	\N	\N	158488	158488	325761
20683	30410	49	applied	\N	\N	\N	\N	158504	158504	325777
20683	30297	66	applied	\N	\N	\N	\N	158521	158521	325793
20683	30369	84	applied	\N	\N	\N	\N	158538	158538	325810
20683	30419	101	applied	\N	\N	\N	\N	158555	158555	325827
20683	30310	106	applied	\N	\N	\N	\N	158560	158560	325832
20683	30332	110	applied	\N	\N	\N	\N	158564	158564	325836
20684	30432	1	applied	\N	\N	\N	\N	158581	158581	325853
20686	30434	0	applied	\N	\N	\N	\N	158586	158586	325858
20695	30338	10	applied	\N	\N	\N	\N	158633	158633	325905
20695	30340	28	applied	\N	\N	\N	\N	158650	158650	325921
20696	30458	3	applied	\N	\N	\N	\N	158654	158654	325925
20697	30458	3	applied	\N	\N	\N	\N	158660	158660	325931
20705	30479	5	applied	\N	\N	\N	\N	158708	158708	325979
20713	30490	2	applied	\N	\N	\N	\N	158729	158729	326000
20714	30489	1	applied	\N	\N	\N	\N	158731	158731	326002
20716	30456	2	applied	\N	\N	\N	\N	158738	158738	326009
20716	29808	44	applied	\N	\N	\N	\N	158780	158780	326050
20716	29826	49	applied	\N	\N	\N	\N	158785	158785	326055
20716	29835	50	applied	\N	\N	\N	\N	158786	158786	326056
20716	29887	69	applied	\N	\N	\N	\N	158803	158803	326073
20721	30356	7	applied	\N	\N	\N	\N	158828	158828	326098
20721	30410	24	applied	\N	\N	\N	\N	158845	158845	326115
20721	30465	41	applied	\N	\N	\N	\N	158862	158862	326132
20721	30358	58	applied	\N	\N	\N	\N	158879	158879	326149
20721	30376	75	applied	\N	\N	\N	\N	158896	158896	326166
20721	30412	92	applied	\N	\N	\N	\N	158913	158913	326183
20721	30414	93	applied	\N	\N	\N	\N	158914	158914	326184
20721	30423	111	applied	\N	\N	\N	\N	158931	158931	326201
20725	30499	3	applied	\N	\N	\N	\N	158959	158959	326229
20726	30498	2	applied	\N	\N	\N	\N	158968	158968	326238
20728	30499	3	applied	\N	\N	\N	\N	158989	158989	326259
20729	30498	2	applied	\N	\N	\N	\N	158998	158998	326268
20730	30508	2	applied	\N	\N	\N	\N	159008	159008	326278
20736	30528	2	applied	\N	\N	\N	\N	159045	159045	326315
20738	30530	1	applied	\N	\N	\N	\N	159050	159050	326320
20738	30531	2	applied	\N	\N	\N	\N	159051	159051	326321
20740	30540	7	applied	\N	\N	\N	\N	159070	159070	326340
20743	30550	0	applied	\N	\N	\N	\N	159087	159087	326357
20744	30555	5	applied	\N	\N	\N	\N	159098	159098	326368
20748	30569	1	applied	\N	\N	\N	\N	159119	159119	326389
20751	30579	5	applied	\N	\N	\N	\N	159141	159141	326411
20752	30585	3	applied	\N	\N	1000000000	\N	159147	159147	326417
20754	30583	1	applied	\N	\N	\N	\N	159155	159155	326425
20760	30536	7	applied	\N	\N	\N	\N	159178	159178	326448
20760	30574	8	applied	\N	\N	\N	\N	159179	159179	326449
20760	30589	9	applied	\N	\N	\N	\N	159180	159180	326450
20760	30561	26	applied	\N	\N	\N	\N	159197	159197	326467
20760	30599	43	applied	\N	\N	\N	\N	159214	159214	326484
20762	30543	17	applied	\N	\N	\N	\N	159262	159262	326532
20762	30441	33	applied	\N	\N	\N	\N	159278	159278	326548
20762	30475	50	applied	\N	\N	\N	\N	159295	159295	326565
20762	30533	67	applied	\N	\N	\N	\N	159312	159312	326582
20762	30435	85	applied	\N	\N	\N	\N	159329	159329	326599
20762	30405	91	applied	\N	\N	\N	\N	159335	159335	326605
20762	30415	94	applied	\N	\N	\N	\N	159338	159338	326608
20762	30462	111	applied	\N	\N	\N	\N	159355	159355	326625
20763	30590	7	applied	\N	\N	\N	\N	159370	159370	326640
20763	30509	36	applied	\N	\N	\N	\N	159398	159398	326668
20764	30593	0	applied	\N	\N	\N	\N	159400	159400	326670
20767	30602	8	applied	\N	\N	\N	\N	159432	159432	326702
20769	30613	0	applied	\N	\N	\N	\N	159443	159443	326713
20772	30620	4	applied	\N	\N	\N	\N	159464	159464	326734
20773	30618	2	applied	\N	\N	\N	\N	159474	159474	326744
20777	30637	4	applied	\N	\N	\N	\N	159511	159511	326781
20780	30644	3	applied	\N	\N	\N	\N	159523	159523	326793
20782	30652	1	applied	\N	\N	\N	\N	159531	159531	326801
20783	30652	1	applied	\N	\N	\N	\N	159537	159537	326807
20786	30589	12	applied	\N	\N	\N	\N	159560	159560	326830
20786	30556	29	applied	\N	\N	\N	\N	159577	159577	326847
20786	30557	30	applied	\N	\N	\N	\N	159578	159578	326848
20786	30578	33	applied	\N	\N	\N	\N	159581	159581	326851
20795	30683	5	applied	\N	\N	\N	\N	159618	159618	326888
20797	30685	0	applied	\N	\N	\N	\N	159626	159626	326896
20804	30701	1	applied	\N	\N	\N	\N	159644	159644	326914
20808	30711	1	applied	\N	\N	\N	\N	159658	159658	326927
20812	30715	1	applied	\N	\N	\N	\N	159667	159667	326936
20818	30588	12	applied	\N	\N	\N	\N	159691	159691	326959
20818	30551	29	applied	\N	\N	\N	\N	159708	159708	326976
20818	30679	45	applied	\N	\N	\N	\N	159724	159724	326992
20818	30611	62	applied	\N	\N	\N	\N	159741	159741	327009
20818	30661	91	applied	\N	\N	\N	\N	159770	159770	327038
20818	30714	109	applied	\N	\N	\N	\N	159787	159787	327055
20820	30723	0	applied	\N	\N	\N	\N	159804	159804	327072
20833	30738	1	applied	\N	\N	\N	\N	159836	159836	327104
20834	30738	1	applied	\N	\N	\N	\N	159839	159839	327106
20835	30741	0	applied	\N	\N	\N	\N	159842	159842	327108
20836	30721	14	applied	\N	\N	\N	\N	159858	159858	327123
20836	30664	31	applied	\N	\N	\N	\N	159875	159875	327140
20850	30763	0	applied	\N	\N	\N	\N	159922	159922	327186
20852	30767	1	applied	\N	\N	\N	\N	159929	159929	327193
20857	30783	3	applied	\N	\N	\N	\N	159963	159963	327227
20859	30789	3	applied	\N	\N	\N	\N	159969	159969	327233
20859	30792	6	applied	\N	\N	\N	\N	159972	159972	327236
20861	30806	2	applied	\N	\N	\N	\N	159986	159986	327249
20866	30818	1	applied	\N	\N	\N	\N	160005	160005	327268
20867	30787	3	applied	\N	\N	\N	\N	160009	160009	327272
20867	30738	20	applied	\N	\N	\N	\N	160026	160026	327289
20867	30781	37	applied	\N	\N	\N	\N	160043	160043	327305
20867	30794	54	applied	\N	\N	\N	\N	160060	160060	327321
20867	30726	71	applied	\N	\N	\N	\N	160077	160077	327338
20867	30769	89	applied	\N	\N	\N	\N	160094	160094	327355
20867	30814	104	applied	\N	\N	\N	\N	160109	160109	327370
20874	30828	0	applied	\N	\N	\N	\N	160129	160129	327390
20877	30749	14	applied	\N	\N	\N	\N	160154	160154	327415
20877	30789	31	applied	\N	\N	\N	\N	160171	160171	327431
20877	30739	49	applied	\N	\N	\N	\N	160188	160188	160188
20877	30785	83	applied	\N	\N	\N	\N	160222	160222	327481
20877	30833	100	applied	\N	\N	\N	\N	160239	160239	327498
20880	30758	5	applied	\N	\N	\N	\N	160251	160251	327510
20880	30789	23	applied	\N	\N	\N	\N	160268	160268	327526
20880	30835	40	applied	\N	\N	\N	\N	160285	160285	327543
20880	30775	45	applied	\N	\N	\N	\N	160290	160290	327548
20880	30782	46	applied	\N	\N	\N	\N	160291	160291	327549
20880	30769	63	applied	\N	\N	\N	\N	160308	160308	327566
20880	30818	80	applied	\N	\N	\N	\N	160325	160325	327583
20889	30848	1	applied	\N	\N	\N	\N	160355	160355	327613
20899	30862	1	applied	\N	\N	\N	\N	160377	160377	327635
20904	30864	1	applied	\N	\N	\N	\N	160387	160387	327645
20910	30883	4	applied	\N	\N	\N	\N	160416	160416	327674
20912	30744	7	applied	\N	\N	\N	\N	160428	160428	327686
20912	30745	8	applied	\N	\N	\N	\N	160429	160429	327687
20912	30767	25	applied	\N	\N	\N	\N	160446	160446	327704
20912	30851	59	applied	\N	\N	\N	\N	160480	160480	327737
20912	30793	77	applied	\N	\N	\N	\N	160497	160497	327753
20912	30736	83	applied	\N	\N	\N	\N	160503	160503	327759
20912	30747	84	applied	\N	\N	\N	\N	160504	160504	327760
20912	30731	101	applied	\N	\N	\N	\N	160521	160521	327777
20912	30778	118	applied	\N	\N	\N	\N	160538	160538	327794
20914	30888	0	applied	\N	\N	1000000000	\N	160550	160550	327806
20919	30897	0	applied	\N	\N	\N	\N	160570	160570	327826
20930	30924	1	applied	\N	\N	\N	\N	160601	160601	327857
20931	30925	2	applied	\N	\N	\N	\N	160610	160610	327866
20935	30941	8	applied	\N	\N	\N	\N	160637	160637	327893
20937	30935	2	applied	\N	\N	\N	\N	160649	160649	327905
20939	30947	2	applied	\N	\N	\N	\N	160661	160661	327917
20940	30951	0	applied	\N	\N	\N	\N	160665	160665	327921
20948	30979	1	applied	\N	\N	\N	\N	160707	160707	327963
20949	30981	0	applied	\N	\N	\N	\N	160709	160709	327965
20957	30997	5	applied	\N	\N	\N	\N	160731	160731	327987
20960	31001	2	applied	\N	\N	\N	\N	160741	160741	327997
20964	30894	15	applied	\N	\N	\N	\N	160766	160766	328022
20972	30934	3	applied	\N	\N	\N	\N	160787	160787	328043
20977	31029	0	applied	\N	\N	\N	\N	160802	160802	328058
20988	31041	0	applied	\N	\N	\N	\N	160827	160827	328083
20993	31048	0	applied	\N	\N	\N	\N	160838	160838	328094
20998	31063	11	applied	\N	\N	\N	\N	160876	160876	328132
20999	31052	0	applied	\N	\N	\N	\N	160878	160878	328134
21000	30952	3	applied	\N	\N	1000000000	\N	160894	160894	328150
21000	30921	23	applied	\N	\N	\N	\N	160914	160914	328170
21000	30972	41	applied	\N	\N	\N	\N	160931	160931	328187
21000	30981	44	applied	\N	\N	\N	\N	160934	160934	328190
21000	31009	61	applied	\N	\N	\N	\N	160951	160951	328207
21000	31057	78	applied	\N	\N	\N	\N	160968	160968	328224
21000	30917	95	applied	\N	\N	\N	\N	160985	160985	328241
21000	30961	115	applied	\N	\N	\N	\N	161005	161005	328261
21000	30970	118	applied	\N	\N	\N	\N	161008	161008	328264
21001	31065	0	applied	\N	\N	\N	\N	161016	161016	328272
21007	31074	2	applied	\N	\N	\N	\N	161036	161036	328292
21009	31074	2	applied	\N	\N	\N	\N	161046	161046	328302
21011	30936	16	applied	\N	\N	\N	\N	161065	161065	328320
21011	30590	33	applied	\N	\N	\N	\N	161082	161082	328337
21011	30551	63	applied	\N	\N	\N	\N	161112	161112	328367
21011	30545	80	applied	\N	\N	\N	\N	161129	161129	328384
21011	30805	98	applied	\N	\N	\N	\N	161146	161146	161146
21011	30633	115	applied	\N	\N	\N	\N	161163	161163	328417
21011	30624	122	applied	\N	\N	\N	\N	161170	161170	328424
21014	31088	6	applied	\N	\N	\N	\N	161186	161186	328440
21015	31092	3	applied	\N	\N	\N	\N	161190	161190	328444
21021	31099	3	applied	\N	\N	\N	\N	161206	161206	328460
21022	31098	2	applied	\N	\N	\N	\N	161211	161211	328465
21039	31109	0	applied	\N	\N	\N	\N	161271	161271	328525
21040	31110	0	applied	\N	\N	\N	\N	161272	161272	328526
21041	31111	1	applied	\N	\N	\N	\N	161276	161276	328530
21050	31123	0	applied	\N	\N	\N	\N	161301	161301	328555
21059	31133	0	applied	\N	\N	\N	\N	161323	161323	328577
21061	30952	4	applied	\N	\N	1000000000	\N	161336	161336	328590
21061	30888	10	applied	\N	\N	1000000000	\N	161342	161342	328596
21061	31142	13	applied	\N	\N	\N	\N	161345	161345	328599
21061	31019	30	applied	\N	\N	\N	\N	161362	161362	328616
21061	30979	47	applied	\N	\N	\N	\N	161379	161379	328633
21061	31122	64	applied	\N	\N	\N	\N	161396	161396	328650
21063	31138	0	applied	\N	\N	\N	\N	161405	161405	328659
21063	31147	3	applied	\N	\N	\N	\N	161408	161408	328662
21064	31143	2	applied	\N	\N	\N	\N	161417	161417	328671
21065	31143	14	applied	\N	\N	\N	\N	161435	161435	328689
21065	30841	31	applied	\N	\N	\N	\N	161452	161452	328706
21065	30937	68	applied	\N	\N	\N	\N	161488	161488	328742
21065	30985	85	applied	\N	\N	\N	\N	161505	161505	328759
21065	31003	99	applied	\N	\N	\N	\N	161519	161519	328773
21065	31010	102	applied	\N	\N	\N	\N	161522	161522	328776
20818	30657	90	applied	\N	\N	\N	\N	159769	159769	327037
21072	31159	1	applied	\N	\N	\N	\N	161567	161567	328821
21084	31173	1	applied	\N	\N	\N	\N	161597	161597	328851
21089	31177	0	applied	\N	\N	\N	\N	161612	161612	328866
21096	31185	1	applied	\N	\N	\N	\N	161640	161640	328894
21105	31196	2	applied	\N	\N	\N	\N	161665	161665	328919
21106	31194	1	applied	\N	\N	\N	\N	161667	161667	328921
21117	31207	0	applied	\N	\N	\N	\N	161701	161701	328955
21121	31218	2	applied	\N	\N	\N	\N	161715	161715	328969
21124	31226	2	applied	\N	\N	\N	\N	161726	161726	328980
21131	31233	2	applied	\N	\N	\N	\N	161742	161742	328996
21134	31236	2	applied	\N	\N	\N	\N	161751	161751	329005
21140	31237	5	applied	\N	\N	\N	\N	161772	161772	329026
21146	31252	3	applied	\N	\N	\N	\N	161789	161789	329043
21146	31255	6	applied	\N	\N	\N	\N	161792	161792	329046
21148	31261	1	applied	\N	\N	\N	\N	161798	161798	329052
21159	31281	2	applied	\N	\N	\N	\N	161832	161832	329086
21168	31294	1	applied	\N	\N	\N	\N	161853	161853	329107
21169	31143	16	applied	\N	\N	\N	\N	161870	161870	329124
21169	30909	26	applied	\N	\N	\N	\N	161880	161880	329134
21169	31053	29	applied	\N	\N	\N	\N	161883	161883	329137
21169	30916	63	applied	\N	\N	\N	\N	161917	161917	329171
21169	30968	81	applied	\N	\N	\N	\N	161934	161934	329188
21169	30993	98	applied	\N	\N	\N	\N	161951	161951	329205
21169	31003	102	applied	\N	\N	\N	\N	161955	161955	329209
21169	31010	105	applied	\N	\N	\N	\N	161958	161958	329212
21169	31058	122	applied	\N	\N	\N	\N	161975	161975	329229
21171	31139	1	applied	\N	\N	\N	\N	161982	161982	329236
21181	31304	0	applied	\N	\N	\N	\N	162016	162016	329270
21185	31313	3	applied	\N	\N	\N	\N	162033	162033	329287
21188	31077	1	applied	\N	\N	\N	\N	162041	162041	329295
21188	31113	16	applied	\N	\N	\N	\N	162056	162056	329310
21188	31158	33	applied	\N	\N	\N	\N	162073	162073	329327
21188	31197	50	applied	\N	\N	\N	\N	162090	162090	329344
21188	31235	68	applied	\N	\N	\N	\N	162107	162107	329361
21188	31275	85	applied	\N	\N	\N	\N	162124	162124	329378
21188	31289	92	applied	\N	\N	\N	\N	162131	162131	329385
21189	31142	5	applied	\N	\N	\N	\N	162152	162152	329406
21189	31059	22	applied	\N	\N	\N	\N	162169	162169	329423
21189	31104	39	applied	\N	\N	\N	\N	162186	162186	329440
21189	31149	56	applied	\N	\N	\N	\N	162203	162203	329457
21189	31213	86	applied	\N	\N	\N	\N	162232	162232	329486
21189	31253	103	applied	\N	\N	\N	\N	162249	162249	329503
21189	31291	120	applied	\N	\N	\N	\N	162266	162266	329520
21190	31321	3	applied	\N	\N	\N	\N	162275	162275	329529
21198	31333	0	applied	\N	\N	\N	\N	162302	162302	329556
21199	31337	2	applied	\N	\N	\N	\N	162306	162306	329560
21204	31351	0	applied	\N	\N	\N	\N	162328	162328	329582
21205	30942	1	applied	\N	\N	1000000000	\N	162331	162331	329585
21205	30946	21	applied	\N	\N	\N	\N	162351	162351	329605
21205	30900	22	applied	\N	\N	\N	\N	162352	162352	329606
21205	30909	25	applied	\N	\N	\N	\N	162355	162355	329609
21205	30831	42	applied	\N	\N	\N	\N	162372	162372	329626
21205	30916	76	applied	\N	\N	\N	\N	162406	162406	329660
21205	30968	93	applied	\N	\N	\N	\N	162423	162423	329677
21205	30978	97	applied	\N	\N	\N	\N	162427	162427	329681
21205	31002	108	applied	\N	\N	\N	\N	162437	162437	329691
21205	31048	125	applied	\N	\N	\N	\N	162454	162454	329708
21209	31356	1	applied	\N	\N	\N	\N	162462	162462	329716
21225	31380	1	applied	\N	\N	\N	\N	162496	162496	329750
21235	31397	1	applied	\N	\N	\N	\N	162525	162525	329779
21237	31400	0	applied	\N	\N	\N	\N	162528	162528	329782
21239	31405	7	applied	\N	\N	\N	\N	162555	162555	329809
21243	31401	4	applied	\N	\N	\N	\N	162568	162568	329822
21247	31415	1	applied	\N	\N	\N	\N	162589	162589	329843
21248	31417	1	applied	\N	\N	\N	\N	162591	162591	329845
21251	31424	2	applied	\N	\N	\N	\N	162614	162614	329868
21252	31424	2	applied	\N	\N	\N	\N	162622	162622	329876
21261	31447	6	applied	\N	\N	\N	\N	162648	162648	329902
21264	31449	0	applied	\N	\N	\N	\N	162666	162666	329920
21271	31461	6	applied	\N	\N	1000000000	\N	162695	162695	329949
21272	31466	2	applied	\N	\N	1000000000	\N	162700	162700	329954
21274	31472	17	applied	\N	\N	1000000000	\N	162727	162727	329981
21277	31425	6	applied	\N	\N	\N	\N	162747	162747	330001
21277	31471	22	applied	\N	\N	\N	\N	162763	162763	330017
21280	31444	4	applied	\N	\N	\N	\N	162781	162781	330035
21280	31479	20	applied	\N	\N	1000000000	\N	162797	162797	330051
21280	31468	40	applied	\N	\N	1000000000	\N	162817	162817	330071
21283	31500	3	applied	\N	\N	\N	\N	162842	162842	330096
21283	31502	6	applied	\N	\N	\N	\N	162844	162844	330098
21284	31504	1	applied	\N	\N	\N	\N	162846	162846	330100
21285	31506	0	applied	\N	\N	\N	\N	162848	162848	330102
21286	31510	0	applied	\N	\N	\N	\N	162852	162852	330106
21293	31527	1	applied	\N	\N	\N	\N	162883	162883	330137
21297	31538	2	applied	\N	\N	\N	\N	162906	162906	330160
21302	31120	24	applied	\N	\N	\N	\N	162945	162945	330199
21302	31123	25	applied	\N	\N	\N	\N	162946	162946	330200
21302	31168	42	applied	\N	\N	\N	\N	162963	162963	330217
21302	31205	59	applied	\N	\N	\N	\N	162980	162980	330234
21302	31244	76	applied	\N	\N	\N	\N	162997	162997	330251
21302	31281	93	applied	\N	\N	\N	\N	163014	163014	330268
21302	31295	99	applied	\N	\N	\N	\N	163020	163020	330274
21302	31299	102	applied	\N	\N	\N	\N	163023	163023	330277
21302	31335	120	applied	\N	\N	\N	\N	163040	163040	330294
21310	30942	1	applied	\N	\N	1000000000	\N	163066	163066	330320
21310	31085	20	applied	\N	\N	\N	\N	163085	163085	330339
21310	31055	43	applied	\N	\N	\N	\N	163108	163108	330362
21310	30959	61	applied	\N	\N	\N	\N	163125	163125	330379
21310	31002	83	applied	\N	\N	\N	\N	163147	163147	330401
21310	31045	100	applied	\N	\N	\N	\N	163164	163164	330418
21310	31090	117	applied	\N	\N	\N	\N	163181	163181	330435
21312	31546	0	applied	\N	\N	\N	\N	163193	163193	330447
21315	31553	2	applied	\N	\N	\N	\N	163204	163204	330458
21319	31558	0	applied	\N	\N	\N	\N	163235	163235	330489
21321	31577	2	applied	\N	\N	\N	\N	163254	163254	330508
21324	31584	2	applied	\N	\N	\N	\N	163264	163264	330518
21324	31585	3	applied	\N	\N	\N	\N	163265	163265	330519
21332	31593	1	applied	\N	\N	\N	\N	163289	163289	330543
21335	31598	3	applied	\N	\N	\N	\N	163301	163301	330555
21337	31599	0	applied	\N	\N	\N	\N	163305	163305	330559
21339	31600	1	applied	\N	\N	\N	\N	163312	163312	330566
21071	31159	1	applied	\N	\N	\N	\N	161564	161564	328818
21351	31637	5	applied	\N	\N	\N	\N	163374	163374	330628
21355	31642	0	applied	\N	\N	\N	\N	163389	163389	330643
21358	31616	3	applied	\N	\N	\N	\N	163409	163409	330663
21359	31672	13	applied	\N	\N	\N	\N	163426	163426	330680
21362	31679	1	applied	\N	\N	\N	\N	163458	163458	330712
21362	31680	2	applied	\N	\N	\N	\N	163459	163459	330713
21367	31685	1	applied	\N	\N	\N	\N	163488	163488	330742
21370	31688	0	applied	\N	\N	\N	\N	163499	163499	330753
21371	31689	1	applied	\N	\N	\N	\N	163506	163506	330760
21380	31700	2	applied	\N	\N	\N	\N	163537	163537	330791
21382	31711	3	applied	\N	\N	\N	\N	163548	163548	330802
21383	31712	4	applied	\N	\N	\N	\N	163556	163556	330810
21392	31628	12	applied	\N	\N	\N	\N	163597	163597	330851
21392	31632	13	applied	\N	\N	\N	\N	163598	163598	330852
21392	31688	30	applied	\N	\N	\N	\N	163615	163615	330869
21392	31600	47	applied	\N	\N	\N	\N	163632	163632	330886
21392	31634	64	applied	\N	\N	\N	\N	163649	163649	330903
21392	31668	81	applied	\N	\N	\N	\N	163666	163666	330920
21392	31682	87	applied	\N	\N	\N	\N	163672	163672	330926
21392	31687	88	applied	\N	\N	\N	\N	163673	163673	330927
21392	31700	123	applied	\N	\N	\N	\N	163707	163707	330961
21393	31728	0	applied	\N	\N	\N	\N	163709	163709	330963
21396	31732	0	applied	\N	\N	\N	\N	163721	163721	330975
21399	31744	9	applied	\N	\N	\N	\N	163737	163737	330991
21401	31737	2	applied	\N	\N	\N	\N	163752	163752	331006
21403	31747	1	applied	\N	\N	\N	\N	163773	163773	331027
21405	31756	3	applied	\N	\N	\N	\N	163789	163789	331043
21411	31719	13	applied	\N	\N	1000000000	\N	163824	163824	331078
21411	31425	16	applied	\N	\N	\N	\N	163827	163827	331081
21411	31083	33	applied	\N	\N	\N	\N	163844	163844	331098
21411	31125	50	applied	\N	\N	\N	\N	163861	163861	331115
21411	31170	67	applied	\N	\N	\N	\N	163878	163878	331132
21411	31207	84	applied	\N	\N	\N	\N	163895	163895	331149
21411	31219	89	applied	\N	\N	\N	\N	163900	163900	331154
21411	31220	90	applied	\N	\N	\N	\N	163901	163901	331155
21411	31262	108	applied	\N	\N	\N	\N	163918	163918	331172
21415	31772	7	applied	\N	\N	\N	\N	163949	163949	331203
21417	31767	2	applied	\N	\N	\N	\N	163966	163966	331220
21422	31783	1	applied	\N	\N	\N	\N	163997	163997	331251
21424	31787	2	applied	\N	\N	\N	\N	164004	164004	331258
21425	31788	0	applied	\N	\N	\N	\N	164005	164005	331259
21426	31789	1	applied	\N	\N	\N	\N	164010	164010	331264
21433	31812	1	applied	\N	\N	\N	\N	164049	164049	331303
21438	31827	0	applied	\N	\N	\N	\N	164071	164071	331325
21438	31828	1	applied	\N	\N	\N	\N	164072	164072	331326
21440	31836	0	applied	\N	\N	\N	\N	164080	164080	331334
21447	31861	2	applied	\N	\N	\N	\N	164114	164114	331368
21448	31867	1	applied	\N	\N	\N	\N	164120	164120	331374
21449	31870	0	applied	\N	\N	\N	\N	164123	164123	331377
21452	31879	1	applied	\N	\N	\N	\N	164143	164143	331397
21454	31883	2	applied	\N	\N	\N	\N	164165	164165	331419
21456	31501	21	applied	\N	\N	\N	\N	164190	164190	331444
21465	31910	3	applied	\N	\N	\N	\N	164246	164246	331500
21466	31911	4	applied	\N	\N	\N	\N	164257	164257	331511
21467	31911	4	applied	\N	\N	\N	\N	164267	164267	331521
21470	31918	1	applied	\N	\N	\N	\N	164287	164287	331541
21476	31928	8	applied	\N	\N	\N	\N	164303	164303	331557
21479	31931	1	applied	\N	\N	\N	\N	164314	164314	331568
21480	31931	1	applied	\N	\N	\N	\N	164318	164318	331572
21482	31933	3	applied	\N	\N	\N	\N	164328	164328	331582
21493	31950	0	applied	\N	\N	\N	\N	164360	164360	331614
21496	31960	1	applied	\N	\N	\N	\N	164367	164367	331621
21497	31960	1	applied	\N	\N	\N	\N	164372	164372	331626
21504	31975	1	applied	\N	\N	\N	\N	164391	164391	331645
21510	31991	2	applied	\N	\N	\N	\N	164417	164417	331671
21511	31999	3	applied	\N	\N	\N	\N	164425	164425	331679
21515	31719	23	applied	\N	\N	1000000000	\N	164462	164462	331716
21515	31085	28	applied	\N	\N	\N	\N	164467	164467	331721
21515	31019	45	applied	\N	\N	\N	\N	164484	164484	331738
21515	31478	62	applied	\N	\N	1000000000	\N	164501	164501	331755
21515	31468	80	applied	\N	\N	1000000000	\N	164519	164519	331773
21515	31514	98	applied	\N	\N	\N	\N	164537	164537	331791
21515	31524	101	applied	\N	\N	\N	\N	164540	164540	331794
21515	31580	119	applied	\N	\N	\N	\N	164557	164557	331811
21516	32010	1	applied	\N	\N	\N	\N	164565	164565	331819
21518	31113	15	applied	\N	\N	\N	\N	164585	164585	331839
21518	31133	32	applied	\N	\N	\N	\N	164602	164602	331856
21518	31168	44	applied	\N	\N	\N	\N	164614	164614	331868
21518	31205	62	applied	\N	\N	\N	\N	164631	164631	331885
21518	31263	87	applied	\N	\N	\N	\N	164656	164656	331910
21518	31298	104	applied	\N	\N	\N	\N	164673	164673	331927
21518	31333	121	applied	\N	\N	\N	\N	164690	164690	331944
21521	32021	2	applied	\N	\N	\N	\N	164704	164704	331958
21527	32026	1	applied	\N	\N	\N	\N	164718	164718	331972
21533	32035	1	applied	\N	\N	\N	\N	164735	164735	331989
21539	32037	0	applied	\N	\N	\N	\N	164750	164750	332004
21541	31843	31	applied	\N	\N	\N	\N	164786	164786	332040
21541	31482	47	applied	\N	\N	1000000000	\N	164802	164802	332056
21541	31405	59	applied	\N	\N	\N	\N	164814	164814	332068
21541	31472	72	applied	\N	\N	1000000000	\N	164827	164827	332081
21541	31519	93	applied	\N	\N	\N	\N	164848	164848	332102
21541	31571	111	applied	\N	\N	\N	\N	164865	164865	332119
21542	32047	8	applied	\N	\N	\N	\N	164888	164888	332142
21543	32044	2	applied	\N	\N	\N	\N	164892	164892	332146
21546	32040	0	applied	\N	\N	\N	\N	164909	164909	332163
21546	32041	1	applied	\N	\N	\N	\N	164910	164910	332164
21554	31960	9	applied	\N	\N	\N	\N	164934	164934	332188
21554	31748	26	applied	\N	\N	\N	\N	164951	164951	332205
21554	31785	43	applied	\N	\N	\N	\N	164968	164968	332222
21554	31845	60	applied	\N	\N	\N	\N	164985	164985	332239
21554	31878	68	applied	\N	\N	\N	\N	164993	164993	332247
21554	31881	69	applied	\N	\N	\N	\N	164994	164994	332248
21554	31977	103	applied	\N	\N	\N	\N	165028	165028	332282
21554	32031	121	applied	\N	\N	\N	\N	165045	165045	332299
21558	32065	0	applied	\N	\N	\N	\N	165059	165059	332313
21565	32076	3	applied	\N	\N	\N	\N	165083	165083	332337
21566	32075	2	applied	\N	\N	\N	\N	165086	165086	332340
21574	32082	5	applied	\N	\N	\N	\N	165113	165113	332367
21580	32086	1	applied	\N	\N	\N	\N	165128	165128	332382
21582	32098	6	applied	\N	\N	\N	\N	165142	165142	332396
21349	31629	1	applied	\N	\N	\N	\N	163362	163362	330616
21591	31766	9	applied	\N	\N	\N	\N	165192	165192	332446
21591	31357	25	applied	\N	\N	\N	\N	165208	165208	332462
21591	31390	42	applied	\N	\N	\N	\N	165225	165225	332479
21591	31439	59	applied	\N	\N	\N	\N	165242	165242	332496
21591	31498	76	applied	\N	\N	\N	\N	165259	165259	332513
21591	31531	86	applied	\N	\N	\N	\N	165269	165269	332523
21591	31543	89	applied	\N	\N	\N	\N	165272	165272	332526
21591	31604	107	applied	\N	\N	\N	\N	165289	165289	332543
21591	31660	124	applied	\N	\N	\N	\N	165306	165306	332560
21594	32117	1	applied	\N	\N	\N	\N	165322	165322	332576
21611	32140	1	applied	\N	\N	\N	\N	165374	165374	332628
21612	32140	1	applied	\N	\N	\N	\N	165377	165377	332631
21615	32147	2	applied	\N	\N	\N	\N	165387	165387	332641
21617	32146	1	applied	\N	\N	\N	\N	165392	165392	332646
21618	31766	5	applied	\N	\N	\N	\N	165399	165399	332653
21618	31950	6	applied	\N	\N	\N	\N	165400	165400	332654
21618	31664	23	applied	\N	\N	\N	\N	165417	165417	332671
21618	31732	40	applied	\N	\N	\N	\N	165434	165434	332688
21618	31767	57	applied	\N	\N	\N	\N	165451	165451	332705
21618	31821	75	applied	\N	\N	\N	\N	165468	165468	332722
21618	31859	83	applied	\N	\N	\N	\N	165476	165476	332730
21618	31870	86	applied	\N	\N	\N	\N	165479	165479	332733
21618	31922	103	applied	\N	\N	\N	\N	165496	165496	332750
21618	31971	120	applied	\N	\N	\N	\N	165513	165513	332767
21626	31974	5	applied	\N	\N	\N	\N	165550	165550	332804
21626	32025	22	applied	\N	\N	\N	\N	165567	165567	332821
21626	32136	56	applied	\N	\N	\N	\N	165601	165601	332855
21626	31975	71	applied	\N	\N	\N	\N	165616	165616	332870
21626	32008	74	applied	\N	\N	\N	\N	165619	165619	332873
21626	32055	91	applied	\N	\N	\N	\N	165636	165636	332890
21626	32018	109	applied	\N	\N	\N	\N	165653	165653	332907
21627	32154	0	applied	\N	\N	\N	\N	165670	165670	332924
21629	32160	4	applied	\N	\N	1000000000	\N	165679	165679	332933
21631	32168	1	applied	\N	\N	\N	\N	165687	165687	332941
21636	32172	1	applied	\N	\N	\N	\N	165706	165706	332960
21644	32190	3	applied	\N	\N	\N	\N	165740	165740	332994
21645	32190	3	applied	\N	\N	\N	\N	165745	165745	332999
21647	32195	1	applied	\N	\N	\N	\N	165756	165756	333010
21653	31602	1	applied	\N	\N	\N	\N	165779	165779	333033
21653	32197	18	applied	\N	\N	\N	\N	165796	165796	333050
21653	31871	19	applied	\N	\N	\N	\N	165797	165797	333051
21653	31441	22	applied	\N	\N	\N	\N	165800	165800	333054
21653	31521	56	applied	\N	\N	\N	\N	165834	165834	333088
21653	31579	73	applied	\N	\N	\N	\N	165851	165851	333105
21653	31642	90	applied	\N	\N	\N	\N	165868	165868	333122
21653	31660	97	applied	\N	\N	\N	\N	165874	165874	333128
21653	31715	113	applied	\N	\N	\N	\N	165890	165890	333144
21654	32209	4	applied	\N	\N	\N	\N	165907	165907	333161
21655	32206	1	applied	\N	\N	\N	\N	165913	165913	333167
21663	32232	1	applied	\N	\N	1000000000	\N	165944	165944	333198
21666	31765	8	applied	\N	\N	\N	\N	165959	165959	333213
21666	31425	25	applied	\N	\N	\N	\N	165976	165976	333230
21666	31297	45	applied	\N	\N	\N	\N	165996	165996	333250
21666	31331	62	applied	\N	\N	\N	\N	166013	166013	333267
21666	31382	96	applied	\N	\N	\N	\N	166046	166046	333300
21666	31431	113	applied	\N	\N	\N	\N	166063	166063	333317
21667	32237	2	applied	\N	\N	\N	\N	166078	166078	333332
21668	32237	4	applied	\N	\N	\N	\N	166084	166084	333338
21675	32252	1	applied	\N	\N	\N	\N	166111	166111	333365
21675	32253	2	applied	\N	\N	\N	\N	166112	166112	333366
21680	32095	12	applied	\N	\N	\N	\N	166135	166135	333389
21681	32102	11	applied	\N	\N	\N	\N	166148	166148	333402
21681	32205	43	applied	\N	\N	\N	\N	166179	166179	333433
21681	32261	60	applied	\N	\N	\N	\N	166196	166196	333450
21681	32116	72	applied	\N	\N	\N	\N	166208	166208	333462
21681	32129	88	applied	\N	\N	\N	\N	166224	166224	333478
21681	32140	105	applied	\N	\N	\N	\N	166241	166241	333495
21681	32181	122	applied	\N	\N	\N	\N	166258	166258	333512
21683	32270	3	applied	\N	\N	\N	\N	166268	166268	333522
21690	32278	2	applied	\N	\N	\N	\N	166293	166293	333547
21691	32276	0	applied	\N	\N	\N	\N	166302	166302	333556
21692	32284	8	applied	\N	\N	\N	\N	166321	166321	333575
21697	32297	3	applied	\N	\N	\N	\N	166346	166346	333600
21703	32306	1	applied	\N	\N	\N	\N	166363	166363	333617
21707	32324	7	applied	\N	\N	\N	\N	166391	166391	333645
21716	32343	5	applied	\N	\N	\N	\N	166430	166430	333684
21717	32349	5	applied	\N	\N	\N	\N	166436	166436	333690
21717	32352	8	applied	\N	\N	\N	\N	166439	166439	333693
21717	32353	9	applied	\N	\N	\N	\N	166440	166440	333694
21718	32356	0	applied	\N	\N	\N	\N	166443	166443	333697
21726	32368	0	applied	\N	\N	\N	\N	166466	166466	333720
21733	32287	8	applied	\N	\N	\N	\N	166480	166480	333734
21733	32338	25	applied	\N	\N	\N	\N	166497	166497	333751
21733	32211	43	applied	\N	\N	\N	\N	166514	166514	333768
21733	32262	60	applied	\N	\N	\N	\N	166531	166531	333785
21733	32315	75	applied	\N	\N	\N	\N	166546	166546	333800
21733	32363	91	applied	\N	\N	\N	\N	166562	166562	333816
21733	32219	108	applied	\N	\N	\N	\N	166579	166579	333833
21733	32281	125	applied	\N	\N	\N	\N	166596	166596	333850
21737	32320	0	applied	\N	\N	1000000000	\N	166624	166624	333878
21737	32197	16	applied	\N	\N	\N	\N	166640	166640	333894
21737	32173	19	applied	\N	\N	\N	\N	166643	166643	333897
21737	32118	53	applied	\N	\N	\N	\N	166677	166677	333931
21737	32171	71	applied	\N	\N	\N	\N	166694	166694	333948
21737	32231	88	applied	\N	\N	\N	\N	166711	166711	333965
21737	32290	105	applied	\N	\N	\N	\N	166728	166728	333982
21737	32339	122	applied	\N	\N	\N	\N	166745	166745	333999
21738	32386	5	applied	\N	\N	\N	\N	166754	166754	334008
21741	32381	0	applied	\N	\N	\N	\N	166767	166767	334021
21746	32390	0	applied	\N	\N	\N	\N	166785	166785	334039
21752	32400	1	applied	\N	\N	\N	\N	166804	166804	334058
21753	32331	11	applied	\N	\N	\N	\N	166817	166817	334071
21753	32396	28	applied	\N	\N	\N	\N	166834	166834	334088
21753	32350	45	applied	\N	\N	\N	\N	166851	166851	334105
21753	32398	63	applied	\N	\N	\N	\N	166869	166869	334123
21753	32352	80	applied	\N	\N	\N	\N	166886	166886	334140
21753	32395	97	applied	\N	\N	\N	\N	166903	166903	334157
21756	32403	1	applied	\N	\N	\N	\N	166917	166917	334171
21766	32418	1	applied	\N	\N	\N	\N	166950	166950	334204
21773	32431	2	applied	\N	\N	\N	\N	166981	166981	334235
21590	32116	6	applied	\N	\N	\N	\N	165181	165181	332435
21776	32374	25	applied	\N	\N	\N	\N	167019	167019	334273
21776	32328	60	applied	\N	\N	\N	\N	167053	167053	334307
21777	32449	5	applied	\N	\N	\N	\N	167068	167068	334322
21779	32452	2	applied	\N	\N	\N	\N	167071	167071	334325
21786	32457	3	applied	\N	\N	\N	\N	167088	167088	334342
21787	32458	0	applied	\N	\N	\N	\N	167089	167089	334343
21787	32459	1	applied	\N	\N	\N	\N	167090	167090	334344
21788	32458	0	applied	\N	\N	\N	\N	167092	167092	334346
21791	32469	0	applied	\N	\N	\N	\N	167111	167111	334365
21791	32472	3	applied	\N	\N	\N	\N	167114	167114	334368
21792	32453	15	applied	\N	\N	\N	\N	167133	167133	334387
21792	32425	32	applied	\N	\N	\N	\N	167150	167150	334404
21792	32460	49	applied	\N	\N	\N	\N	167167	167167	334421
21792	32466	66	applied	\N	\N	\N	\N	167184	167184	334438
21795	32196	5	applied	\N	\N	\N	\N	167204	167204	334458
21795	32222	22	applied	\N	\N	\N	\N	167221	167221	334475
21795	32173	40	applied	\N	\N	\N	\N	167238	167238	334492
21795	32382	74	applied	\N	\N	\N	\N	167272	167272	334526
21795	32450	96	applied	\N	\N	\N	\N	167294	167294	334548
21795	32176	109	applied	\N	\N	\N	\N	167307	167307	334561
21795	32200	123	applied	\N	\N	\N	\N	167321	167321	334575
21796	32382	2	applied	\N	\N	\N	\N	167326	167326	334580
21796	32435	20	applied	\N	\N	\N	\N	167343	167343	334597
21796	32470	37	applied	\N	\N	\N	\N	167360	167360	334614
21796	32400	54	applied	\N	\N	\N	\N	167377	167377	334631
21796	32451	71	applied	\N	\N	\N	\N	167394	167394	334648
21796	32424	101	applied	\N	\N	\N	\N	167424	167424	334678
21796	32438	105	applied	\N	\N	\N	\N	167428	167428	334682
21796	32439	106	applied	\N	\N	\N	\N	167429	167429	334683
21799	32486	4	applied	\N	\N	\N	\N	167460	167460	334714
21804	32493	2	applied	\N	\N	\N	\N	167479	167479	334733
21805	32493	2	applied	\N	\N	\N	\N	167485	167485	334739
21806	32275	4	applied	\N	\N	\N	\N	167493	167493	334747
21814	32512	3	applied	\N	\N	\N	\N	167534	167534	334788
21822	32535	2	applied	\N	\N	\N	\N	167569	167569	334823
21823	32534	1	applied	\N	\N	\N	\N	167580	167580	334834
21824	32546	1	applied	\N	\N	\N	\N	167592	167592	334846
21828	32557	0	applied	\N	\N	\N	\N	167615	167615	334869
21829	32562	3	applied	\N	\N	\N	\N	167620	167620	334874
21829	32557	4	applied	\N	\N	\N	\N	167621	167621	334875
21833	32573	1	applied	\N	\N	\N	\N	167635	167635	334889
21836	32307	6	applied	\N	\N	\N	\N	167650	167650	334904
21836	32362	23	applied	\N	\N	\N	\N	167667	167667	334921
21836	32421	39	applied	\N	\N	\N	\N	167683	167683	334937
21836	32477	56	applied	\N	\N	\N	\N	167700	167700	334954
21836	32482	57	applied	\N	\N	\N	\N	167701	167701	334955
21836	32485	58	applied	\N	\N	\N	\N	167702	167702	334956
21836	32534	75	applied	\N	\N	\N	\N	167719	167719	334973
21836	32470	92	applied	\N	\N	\N	\N	167736	167736	334990
21844	32594	2	applied	\N	\N	\N	\N	167785	167785	335039
21846	31788	13	applied	\N	\N	\N	\N	167808	167808	335062
21846	31845	30	applied	\N	\N	\N	\N	167825	167825	335079
21846	31859	33	applied	\N	\N	\N	\N	167828	167828	335082
21846	31907	50	applied	\N	\N	\N	\N	167845	167845	335099
21846	31917	53	applied	\N	\N	\N	\N	167848	167848	335102
21846	31966	70	applied	\N	\N	\N	\N	167865	167865	335119
21846	32012	87	applied	\N	\N	\N	\N	167882	167882	335136
21846	32071	105	applied	\N	\N	\N	\N	167899	167899	335153
21846	32124	122	applied	\N	\N	\N	\N	167916	167916	335170
21847	32599	1	applied	\N	\N	\N	\N	167921	167921	335175
21850	32608	1	applied	\N	\N	\N	\N	167948	167948	335202
21852	32612	2	applied	\N	\N	\N	\N	167955	167955	335209
21856	32619	6	applied	\N	\N	\N	\N	167989	167989	335243
21860	32626	1	applied	\N	\N	\N	\N	168002	168002	335256
21864	32638	1	applied	\N	\N	\N	\N	168014	168014	335268
21870	32172	14	applied	\N	\N	\N	\N	168039	168039	335293
21870	32274	17	applied	\N	\N	\N	\N	168042	168042	335296
21870	32093	34	applied	\N	\N	\N	\N	168059	168059	335313
21870	32148	51	applied	\N	\N	\N	\N	168076	168076	335330
21870	32206	68	applied	\N	\N	\N	\N	168093	168093	335347
21870	32264	85	applied	\N	\N	\N	\N	168110	168110	335364
21870	32036	102	applied	\N	\N	\N	\N	168127	168127	335381
21870	32045	115	applied	\N	\N	\N	\N	168140	168140	335394
21870	32054	118	applied	\N	\N	\N	\N	168143	168143	335397
21871	32331	18	applied	\N	\N	\N	\N	168164	168164	335418
21873	32644	6	applied	\N	\N	\N	\N	168186	168186	335440
21875	32633	13	applied	\N	\N	\N	\N	168209	168209	335463
21875	32644	16	applied	\N	\N	\N	\N	168212	168212	335466
21876	32647	1	applied	\N	\N	\N	\N	168215	168215	335469
21878	32649	0	applied	\N	\N	\N	\N	168220	168220	335474
21880	32657	5	applied	\N	\N	\N	\N	168234	168234	335488
21898	32692	4	applied	\N	\N	\N	\N	168287	168287	335541
21899	32691	3	applied	\N	\N	\N	\N	168292	168292	335546
21900	32695	1	applied	\N	\N	\N	\N	168296	168296	335550
21901	32695	1	applied	\N	\N	\N	\N	168299	168299	335553
21905	32510	13	applied	\N	\N	\N	\N	168322	168322	335576
21905	32563	30	applied	\N	\N	\N	\N	168339	168339	335593
21905	32613	47	applied	\N	\N	\N	\N	168356	168356	335610
21905	32622	50	applied	\N	\N	\N	\N	168359	168359	335613
21905	32673	67	applied	\N	\N	\N	\N	168376	168376	335630
21905	32495	84	applied	\N	\N	\N	\N	168393	168393	335647
21905	32544	101	applied	\N	\N	\N	\N	168410	168410	335664
21905	32596	118	applied	\N	\N	\N	\N	168427	168427	335681
21914	32718	0	applied	\N	\N	\N	\N	168465	168465	335719
21915	32719	0	applied	\N	\N	\N	\N	168466	168466	335720
21918	32727	2	applied	\N	\N	\N	\N	168482	168482	335736
21923	32741	4	applied	\N	\N	\N	\N	168506	168506	335760
21929	32761	0	applied	\N	\N	\N	\N	168538	168538	335792
21938	32772	1	applied	\N	\N	\N	\N	168561	168561	335815
21942	32776	2	applied	\N	\N	\N	\N	168574	168574	335828
21950	32793	0	applied	\N	\N	\N	\N	168597	168597	335850
21951	32796	3	applied	\N	\N	\N	\N	168609	168609	335862
21952	32802	0	applied	\N	\N	\N	\N	168615	168615	335868
21956	32816	2	applied	\N	\N	\N	\N	168638	168638	335891
21959	32816	2	applied	\N	\N	\N	\N	168665	168665	335918
21964	32827	1	applied	\N	\N	\N	\N	168685	168685	335938
21966	32827	1	applied	\N	\N	\N	\N	168691	168691	335944
21976	32829	0	applied	\N	\N	\N	\N	168723	168723	335975
21979	32836	1	applied	\N	\N	\N	\N	168736	168736	335988
21981	32221	5	applied	\N	\N	\N	\N	168746	168746	335998
21981	32112	22	applied	\N	\N	\N	\N	168763	168763	336015
21776	32405	8	applied	\N	\N	\N	\N	167002	167002	334256
21981	32278	74	applied	\N	\N	\N	\N	168814	168814	336066
21981	32274	75	applied	\N	\N	\N	\N	168815	168815	336067
21981	32287	78	applied	\N	\N	\N	\N	168818	168818	336070
21981	32338	95	applied	\N	\N	\N	\N	168835	168835	336087
21981	32402	112	applied	\N	\N	\N	\N	168852	168852	336104
21982	32835	0	applied	\N	\N	\N	\N	168866	168866	336118
21983	32841	3	applied	\N	\N	\N	\N	168872	168872	336124
21994	32864	0	applied	\N	\N	\N	\N	168907	168907	336159
21994	32867	3	applied	\N	\N	\N	\N	168910	168910	336162
21997	32876	0	applied	\N	\N	\N	\N	168919	168919	336171
21999	32700	0	applied	\N	\N	\N	\N	168925	168925	336177
21999	32742	18	applied	\N	\N	\N	\N	168942	168942	336194
21999	32802	35	applied	\N	\N	\N	\N	168959	168959	336211
21999	32853	52	applied	\N	\N	\N	\N	168976	168976	336228
21999	32561	86	applied	\N	\N	\N	\N	169010	169010	336261
21999	32597	99	applied	\N	\N	\N	\N	169023	169023	336274
21999	32606	102	applied	\N	\N	\N	\N	169026	169026	336277
21999	32657	119	applied	\N	\N	\N	\N	169043	169043	336294
22000	32881	2	applied	\N	\N	\N	\N	169052	169052	336303
22012	32900	0	applied	\N	\N	\N	\N	169089	169089	336340
22013	32902	2	applied	\N	\N	\N	\N	169094	169094	336345
22016	32906	0	applied	\N	\N	\N	\N	169100	169100	336351
22018	32907	1	applied	\N	\N	\N	\N	169109	169109	336360
22028	32920	2	applied	\N	\N	\N	\N	169142	169142	336393
22030	32925	2	applied	\N	\N	\N	\N	169147	169147	336398
22033	32938	2	applied	\N	\N	\N	\N	169170	169170	336421
22036	32925	12	applied	\N	\N	\N	\N	169190	169190	336441
22036	32207	29	applied	\N	\N	\N	\N	169207	169207	336458
22036	32268	46	applied	\N	\N	\N	\N	169224	169224	336475
22036	32306	63	applied	\N	\N	\N	\N	169241	169241	336492
22036	32365	82	applied	\N	\N	\N	\N	169260	169260	336511
22036	32429	99	applied	\N	\N	\N	\N	169277	169277	336528
22036	32485	117	applied	\N	\N	\N	\N	169294	169294	336545
22037	32952	8	applied	\N	\N	\N	\N	169311	169311	336562
22039	32958	1	applied	\N	\N	\N	\N	169317	169317	336568
22043	32968	1	applied	\N	\N	\N	\N	169331	169331	336582
22045	32981	12	applied	\N	\N	\N	\N	169358	169358	336609
22047	32985	2	applied	\N	\N	\N	\N	169365	169365	336616
22061	33008	5	applied	\N	\N	\N	\N	169404	169404	336655
22063	33015	2	applied	\N	\N	\N	\N	169414	169414	336665
22069	33023	0	applied	\N	\N	\N	\N	169434	169434	336685
22073	33033	0	applied	\N	\N	\N	\N	169461	169461	336711
22074	33033	0	applied	\N	\N	\N	\N	169467	169467	336717
22074	33038	5	applied	\N	\N	\N	\N	169472	169472	336722
22077	33039	0	applied	\N	\N	\N	\N	169485	169485	336735
22081	33053	2	applied	\N	\N	\N	\N	169502	169502	336752
22082	32995	27	applied	\N	\N	\N	\N	169530	169530	336780
22082	32997	28	applied	\N	\N	\N	\N	169531	169531	336781
22082	32998	29	applied	\N	\N	\N	\N	169532	169532	336782
22082	33038	46	applied	\N	\N	\N	\N	169549	169549	336799
22082	33037	63	applied	\N	\N	\N	\N	169566	169566	336816
22083	33056	4	applied	\N	\N	\N	\N	169576	169576	336826
22084	33060	4	applied	\N	\N	\N	\N	169581	169581	336831
22092	33077	10	applied	\N	\N	\N	\N	169620	169620	336870
22098	33099	5	applied	\N	\N	\N	\N	169646	169646	336896
22100	33100	6	applied	\N	\N	\N	\N	169661	169661	336911
22103	33113	6	applied	\N	\N	\N	\N	169674	169674	336924
22104	33119	2	applied	\N	\N	\N	\N	169680	169680	336930
22105	33127	3	applied	\N	\N	\N	\N	169688	169688	336938
22112	33140	14	applied	\N	\N	\N	\N	169729	169729	336977
22112	33107	17	applied	\N	\N	\N	\N	169732	169732	336980
22112	33075	34	applied	\N	\N	\N	\N	169749	169749	336997
22113	33144	0	applied	\N	\N	\N	\N	169774	169774	337022
22116	33151	4	applied	\N	\N	\N	\N	169789	169789	337037
22117	33157	5	applied	\N	\N	\N	\N	169795	169795	337043
22123	33177	0	applied	\N	\N	\N	\N	169829	169829	337077
22127	33186	2	applied	\N	\N	\N	\N	169844	169844	337092
22128	33189	2	applied	\N	\N	\N	\N	169847	169847	337095
22129	33192	2	applied	\N	\N	\N	\N	169850	169850	337098
22137	33209	2	applied	\N	\N	\N	\N	169887	169887	337135
22141	33235	9	applied	\N	\N	\N	\N	169924	169924	337170
22143	33227	0	applied	\N	\N	\N	\N	169930	169930	337176
22144	33227	0	applied	\N	\N	\N	\N	169937	169937	337182
22146	33240	3	applied	\N	\N	\N	\N	169954	169954	337197
22148	33250	6	applied	\N	\N	\N	\N	169964	169964	337207
22152	33261	4	applied	\N	\N	\N	\N	169975	169975	337218
22153	33266	9	applied	\N	\N	\N	\N	169990	169990	337233
22154	33266	9	applied	\N	\N	\N	\N	170000	170000	337243
22159	33273	4	applied	\N	\N	1000000000	\N	170027	170027	337270
22167	33280	0	applied	\N	\N	\N	\N	170063	170063	337306
22172	33303	1	applied	\N	\N	\N	\N	170091	170091	337334
22174	33309	0	applied	\N	\N	\N	\N	170097	170097	337340
22174	33310	1	applied	\N	\N	\N	\N	170098	170098	337341
22177	33319	0	applied	\N	\N	\N	\N	170114	170114	337357
22181	33335	0	applied	\N	\N	\N	\N	170136	170136	337379
22184	32923	12	applied	\N	\N	\N	\N	170163	170163	337405
22184	32924	13	applied	\N	\N	\N	\N	170164	170164	337406
22184	32921	30	applied	\N	\N	\N	\N	170181	170181	337423
22184	32967	47	applied	\N	\N	\N	\N	170198	170198	337440
22184	33023	64	applied	\N	\N	\N	\N	170215	170215	337457
22184	33084	81	applied	\N	\N	\N	\N	170232	170232	337474
22184	33147	98	applied	\N	\N	\N	\N	170249	170249	337491
22184	33197	113	applied	\N	\N	\N	\N	170264	170264	337506
22184	33207	116	applied	\N	\N	\N	\N	170267	170267	337509
22186	33353	1	applied	\N	\N	\N	\N	170285	170285	337527
22187	33357	2	applied	\N	\N	\N	\N	170289	170289	337531
22195	33380	0	applied	\N	\N	\N	\N	170320	170320	337562
22196	33384	0	applied	\N	\N	\N	\N	170324	170324	170324
22199	33259	8	applied	\N	\N	\N	\N	170344	170344	337584
22199	33327	25	applied	\N	\N	\N	\N	170361	170361	337601
22199	32902	53	applied	\N	\N	\N	\N	170389	170389	337627
22199	33022	61	applied	\N	\N	\N	\N	170397	170397	337635
22199	33377	62	applied	\N	\N	\N	\N	170398	170398	337636
22199	32914	79	applied	\N	\N	\N	\N	170415	170415	337652
22199	33261	96	applied	\N	\N	\N	\N	170432	170432	337669
22199	32939	113	applied	\N	\N	\N	\N	170449	170449	337686
22201	33401	4	applied	\N	\N	\N	\N	170472	170472	337709
22205	33413	3	applied	\N	\N	1000000000	\N	170488	170488	337725
22206	33414	0	applied	\N	\N	\N	\N	170489	170489	337726
22208	32997	12	applied	\N	\N	\N	\N	170507	170507	337744
21981	32228	56	applied	\N	\N	\N	\N	168797	168797	336049
22211	33435	4	applied	\N	\N	\N	\N	170580	170580	337817
22213	33441	4	applied	\N	\N	\N	\N	170595	170595	337832
22225	33468	1	applied	\N	\N	\N	\N	170635	170635	337872
22230	33472	3	applied	\N	\N	\N	\N	170655	170655	337892
22231	33432	10	applied	\N	\N	\N	\N	170666	170666	337903
22231	33427	27	applied	\N	\N	\N	\N	170683	170683	337920
22231	33459	42	applied	\N	\N	\N	\N	170698	170698	337935
22231	33441	60	applied	\N	\N	\N	\N	170715	170715	337952
22231	33447	61	applied	\N	\N	\N	\N	170716	170716	337953
22231	33450	62	applied	\N	\N	\N	\N	170717	170717	337954
22234	33484	5	applied	\N	\N	\N	\N	170741	170741	337978
22235	33487	2	applied	\N	\N	\N	\N	170744	170744	337981
22240	33499	3	applied	\N	\N	\N	\N	170779	170779	338016
22243	33499	2	applied	\N	\N	\N	\N	170792	170792	338029
22245	33506	1	applied	\N	\N	\N	\N	170803	170803	338040
22246	33506	1	applied	\N	\N	\N	\N	170812	170812	338049
22248	33515	1	applied	\N	\N	\N	\N	170825	170825	338062
22252	33529	5	applied	\N	\N	\N	\N	170845	170845	338082
22256	33536	2	applied	\N	\N	\N	\N	170862	170862	338099
22264	33549	2	applied	\N	\N	\N	\N	170888	170888	338125
22266	33558	6	applied	\N	\N	\N	\N	170908	170908	338145
22270	33569	0	applied	\N	\N	\N	\N	170922	170922	338159
22272	33587	7	applied	\N	\N	\N	\N	170940	170940	338177
22277	33598	1	applied	\N	\N	\N	\N	170957	170957	338194
22283	33606	1	applied	\N	\N	\N	\N	170971	170971	338208
22284	33293	6	applied	\N	\N	\N	\N	170980	170980	338216
22284	32527	36	applied	\N	\N	\N	\N	171010	171010	338246
22284	32535	40	applied	\N	\N	\N	\N	171014	171014	338250
22284	33036	43	applied	\N	\N	\N	\N	171017	171017	338253
22284	32583	61	applied	\N	\N	\N	\N	171034	171034	338270
22284	32634	78	applied	\N	\N	\N	\N	171051	171051	338287
22284	32685	95	applied	\N	\N	\N	\N	171068	171068	338304
22284	32737	112	applied	\N	\N	\N	\N	171085	171085	338321
22289	33616	0	applied	\N	\N	\N	\N	171111	171111	338347
22291	33617	1	applied	\N	\N	\N	\N	171126	171126	338362
22296	33302	3	applied	\N	\N	\N	\N	171152	171152	338388
22296	33339	20	applied	\N	\N	\N	\N	171169	171169	338405
22296	33385	37	applied	\N	\N	\N	\N	171186	171186	338422
22296	33446	54	applied	\N	\N	\N	\N	171203	171203	338439
22296	33524	72	applied	\N	\N	\N	\N	171220	171220	338456
22296	33531	74	applied	\N	\N	\N	\N	171222	171222	338458
22296	33541	77	applied	\N	\N	\N	\N	171225	171225	338461
22296	33597	94	applied	\N	\N	\N	\N	171242	171242	338478
22296	33307	111	applied	\N	\N	\N	\N	171259	171259	338494
22298	33638	2	applied	\N	\N	\N	\N	171279	171279	338513
22299	33647	8	applied	\N	\N	\N	\N	171288	171288	338522
22304	33669	10	applied	\N	\N	\N	\N	171316	171316	338550
22309	33577	3	applied	\N	\N	\N	\N	171332	171332	338566
22309	33640	22	applied	\N	\N	\N	\N	171351	171351	338585
22309	33576	40	applied	\N	\N	\N	\N	171369	171369	338603
22309	33615	57	applied	\N	\N	\N	\N	171386	171386	338620
22309	33671	75	applied	\N	\N	\N	\N	171403	171403	338637
22309	33635	92	applied	\N	\N	\N	\N	171420	171420	338654
22314	33685	2	applied	\N	\N	\N	\N	171448	171448	338682
22316	33688	1	applied	\N	\N	\N	\N	171451	171451	338685
22316	33689	2	applied	\N	\N	\N	\N	171452	171452	338686
22316	33692	5	applied	\N	\N	\N	\N	171455	171455	338689
22318	33704	9	applied	\N	\N	\N	\N	171475	171475	338709
22320	33713	6	applied	\N	\N	\N	\N	171495	171495	338729
22325	33723	5	applied	\N	\N	\N	\N	171535	171535	338769
22326	33718	0	applied	\N	\N	\N	\N	171537	171537	338771
22330	33728	4	applied	\N	\N	\N	\N	171561	171561	338795
22333	33728	3	applied	\N	\N	\N	\N	171575	171575	338809
22334	33744	9	applied	\N	\N	\N	\N	171592	171592	338826
22335	33746	1	applied	\N	\N	\N	\N	171594	171594	338828
22340	33763	1	applied	\N	\N	\N	\N	171614	171614	338848
22340	33766	4	applied	\N	\N	\N	\N	171617	171617	338851
22344	33770	5	applied	\N	\N	\N	\N	171652	171652	338886
22345	33780	4	applied	\N	\N	\N	\N	171660	171660	338894
22350	33740	5	applied	\N	\N	\N	\N	171680	171680	338914
22350	33723	22	applied	\N	\N	\N	\N	171697	171697	338931
22350	33783	39	applied	\N	\N	\N	\N	171714	171714	338948
22350	33765	56	applied	\N	\N	\N	\N	171731	171731	338965
22351	33788	1	applied	\N	\N	\N	\N	171740	171740	338974
22354	33697	2	applied	\N	\N	\N	\N	171748	171748	338982
22361	33802	3	applied	\N	\N	\N	\N	171777	171777	339011
22365	33815	2	applied	\N	\N	\N	\N	171798	171798	339032
22370	33820	0	applied	\N	\N	\N	\N	171824	171824	339058
22370	33823	3	applied	\N	\N	\N	\N	171827	171827	339061
22372	33828	0	applied	\N	\N	\N	\N	171832	171832	339066
22373	33832	1	applied	\N	\N	\N	\N	171836	171836	339070
22381	33862	1	applied	\N	\N	\N	\N	171876	171876	339110
22388	33828	11	applied	\N	\N	\N	\N	171907	171907	339141
22388	33807	30	applied	\N	\N	\N	\N	171925	171925	339159
22388	33803	46	applied	\N	\N	\N	\N	171941	171941	339175
22388	33812	49	applied	\N	\N	\N	\N	171944	171944	339178
22388	33864	66	applied	\N	\N	\N	\N	171961	171961	339195
22389	33876	1	applied	\N	\N	\N	\N	171978	171978	339212
22392	33881	3	applied	\N	\N	\N	\N	171989	171989	339223
22393	33879	1	applied	\N	\N	\N	\N	171991	171991	339225
22401	33893	1	applied	\N	\N	\N	\N	172023	172023	339257
22402	33903	5	applied	\N	\N	\N	\N	172033	172033	339267
22403	33900	2	applied	\N	\N	\N	\N	172037	172037	339271
22404	33890	15	applied	\N	\N	\N	\N	172057	172057	339291
22411	33918	8	applied	\N	\N	\N	\N	172091	172091	339325
22412	33916	6	applied	\N	\N	\N	\N	172099	172099	339333
22418	33913	6	applied	\N	\N	\N	\N	172124	172124	339358
22420	33931	1	applied	\N	\N	\N	\N	172137	172137	339371
22422	33936	4	applied	\N	\N	\N	\N	172149	172149	339383
22426	33941	2	applied	\N	\N	\N	\N	172166	172166	339400
22429	33948	2	applied	\N	\N	\N	\N	172176	172176	339410
22432	33959	3	applied	\N	\N	\N	\N	172187	172187	339421
22435	33813	8	applied	\N	\N	\N	\N	172204	172204	339438
22437	33709	13	applied	\N	\N	\N	\N	172224	172224	339458
22437	33772	30	applied	\N	\N	\N	\N	172241	172241	339475
22437	33827	47	applied	\N	\N	\N	\N	172258	172258	339492
22437	33882	64	applied	\N	\N	\N	\N	172275	172275	339509
22437	33924	77	applied	\N	\N	\N	\N	172288	172288	339522
22437	33932	80	applied	\N	\N	\N	\N	172291	172291	339525
22437	33691	98	applied	\N	\N	\N	\N	172308	172308	339542
22437	33722	115	applied	\N	\N	\N	\N	172325	172325	339559
22210	33427	6	applied	\N	\N	\N	\N	170572	170572	337809
22440	33904	41	applied	\N	\N	\N	\N	172392	172392	339626
22440	33962	73	applied	\N	\N	\N	\N	172424	172424	339658
22440	33897	76	applied	\N	\N	\N	\N	172427	172427	339661
22440	33959	93	applied	\N	\N	\N	\N	172444	172444	339678
22441	33972	1	applied	\N	\N	\N	\N	172449	172449	339683
22450	33982	1	applied	\N	\N	\N	\N	172477	172477	339711
22451	33984	0	applied	\N	\N	\N	\N	172479	172479	339713
22455	33991	1	applied	\N	\N	\N	\N	172494	172494	339728
22457	33994	2	applied	\N	\N	\N	\N	172503	172503	339737
22460	34001	2	applied	\N	\N	\N	\N	172513	172513	339747
22462	34003	0	applied	\N	\N	\N	\N	172518	172518	339752
22467	33698	14	applied	\N	\N	\N	\N	172549	172549	339783
22467	33731	31	applied	\N	\N	\N	\N	172566	172566	339800
22467	33790	48	applied	\N	\N	\N	\N	172583	172583	339817
22467	33842	66	applied	\N	\N	\N	\N	172600	172600	339834
22467	33899	83	applied	\N	\N	\N	\N	172617	172617	339851
22467	33940	96	applied	\N	\N	\N	\N	172630	172630	339864
22467	34009	116	applied	\N	\N	\N	\N	172650	172650	339884
22470	34015	2	applied	\N	\N	\N	\N	172667	172667	339901
22474	34023	0	applied	\N	\N	\N	\N	172682	172682	339916
22477	34045	3	applied	\N	\N	\N	\N	172710	172710	339944
22478	34047	5	applied	\N	\N	\N	\N	172720	172720	339954
22479	34046	4	applied	\N	\N	\N	\N	172728	172728	339962
22482	34071	13	applied	\N	\N	\N	\N	172761	172761	339995
22485	34083	6	applied	\N	\N	\N	\N	172782	172782	340016
22486	34091	4	applied	\N	\N	\N	\N	172790	172790	340024
22487	34089	2	applied	\N	\N	\N	\N	172806	172806	340040
22489	34117	3	applied	\N	\N	\N	\N	172834	172834	340068
22490	34118	3	applied	\N	\N	\N	\N	172842	172842	340076
22491	34118	4	applied	\N	\N	\N	\N	172849	172849	340083
22493	34117	3	applied	\N	\N	\N	\N	172864	172864	340098
22494	34114	0	applied	\N	\N	\N	\N	172869	172869	340103
22498	34117	0	applied	\N	\N	\N	\N	172888	172888	340122
22499	34151	26	applied	\N	\N	\N	\N	172917	172917	340151
22504	34162	0	applied	\N	\N	\N	\N	172937	172937	340171
22505	34178	18	applied	\N	\N	\N	\N	172972	172972	340206
22508	34185	4	applied	\N	\N	\N	\N	172989	172989	340223
22509	34183	2	applied	\N	\N	\N	\N	173007	173007	340241
22509	34180	17	applied	\N	\N	\N	\N	173022	173022	340256
22511	34201	1	applied	\N	\N	\N	\N	173030	173030	340264
22514	34208	1	applied	\N	\N	\N	\N	173037	173037	340271
22515	34207	0	applied	\N	\N	\N	\N	173040	173040	340274
22515	34208	1	applied	\N	\N	\N	\N	173041	173041	340275
22519	34226	0	applied	\N	\N	\N	\N	173063	173063	340297
22520	34234	8	applied	\N	\N	\N	\N	173080	173080	340314
22521	34246	11	applied	\N	\N	\N	\N	173092	173092	340326
22522	34243	8	applied	\N	\N	\N	\N	173102	173102	340336
22525	34260	0	applied	\N	\N	\N	\N	173119	173119	340353
22531	34270	0	applied	\N	\N	\N	\N	173149	173149	340383
22534	34296	0	applied	\N	\N	\N	\N	173177	173177	340411
22537	34313	6	applied	\N	\N	\N	\N	173197	173197	340431
22538	34312	5	applied	\N	\N	\N	\N	173208	173208	340442
22547	34336	7	applied	\N	\N	\N	\N	173242	173242	340476
22548	34335	6	applied	\N	\N	\N	\N	173254	173254	340488
22550	34347	2	applied	\N	\N	\N	\N	173266	173266	340500
22554	34357	2	applied	\N	\N	\N	\N	173282	173282	340516
22561	34371	6	applied	\N	\N	\N	\N	173309	173309	340543
22565	34377	1	applied	\N	\N	\N	\N	173321	173321	340555
22566	34376	0	applied	\N	\N	\N	\N	173323	173323	340557
22567	34381	2	applied	\N	\N	\N	\N	173328	173328	340562
22572	34394	0	applied	\N	\N	\N	\N	173359	173359	340593
22573	34406	9	applied	\N	\N	\N	\N	173371	173371	340605
22575	34407	0	applied	\N	\N	\N	\N	173382	173382	340616
22576	34410	6	applied	\N	\N	\N	\N	173391	173391	340625
22577	34413	4	applied	\N	\N	\N	\N	173406	173406	340640
22578	34418	7	applied	\N	\N	\N	\N	173420	173420	340654
22581	33971	1	applied	\N	\N	\N	\N	173434	173434	340668
22581	33981	4	applied	\N	\N	\N	\N	173437	173437	340671
22581	34037	21	applied	\N	\N	\N	\N	173454	173454	340688
22581	34063	38	applied	\N	\N	\N	\N	173471	173471	340705
22581	34090	56	applied	\N	\N	\N	\N	173488	173488	340722
22581	34123	73	applied	\N	\N	\N	\N	173505	173505	340739
22581	34145	90	applied	\N	\N	\N	\N	173522	173522	340756
22581	34036	103	applied	\N	\N	\N	\N	173535	173535	340769
22581	34042	104	applied	\N	\N	\N	\N	173536	173536	340770
22581	34182	121	applied	\N	\N	\N	\N	173553	173553	340787
22584	34444	8	applied	\N	\N	\N	\N	173581	173581	340815
22591	34459	4	applied	\N	\N	\N	\N	173609	173609	340843
22592	34471	2	applied	\N	\N	\N	\N	173623	173623	173623
22593	34474	3	applied	\N	\N	\N	\N	173640	173640	340872
22595	34473	3	applied	\N	\N	\N	\N	173648	173648	340878
22599	34479	1	applied	\N	\N	\N	\N	173672	173672	340902
22601	34496	3	applied	\N	\N	\N	\N	173700	173700	340930
22602	34498	1	applied	\N	\N	\N	\N	173702	173702	340932
22605	34504	1	applied	\N	\N	\N	\N	173716	173716	340946
22608	34507	2	applied	\N	\N	\N	\N	173728	173728	340958
22609	34513	3	applied	\N	\N	\N	\N	173739	173739	340969
22620	34525	0	applied	\N	\N	\N	\N	173783	173783	341013
22621	34525	1	applied	\N	\N	\N	\N	173787	173787	341017
22623	34533	1	applied	\N	\N	\N	\N	173796	173796	341026
22626	34535	2	applied	\N	\N	\N	\N	173809	173809	341039
22632	34546	1	applied	\N	\N	\N	\N	173834	173834	341064
22635	34550	1	applied	\N	\N	\N	\N	173848	173848	341078
22638	34557	2	applied	\N	\N	\N	\N	173865	173865	341095
22644	34563	1	applied	\N	\N	\N	\N	173884	173884	341114
22650	34576	1	applied	\N	\N	\N	\N	173913	173913	341143
22651	34575	0	applied	\N	\N	\N	\N	173915	173915	341145
22660	34585	0	applied	\N	\N	\N	\N	173943	173943	341173
22663	34605	3	applied	\N	\N	\N	\N	173973	173973	341203
22667	34613	2	applied	\N	\N	\N	\N	173981	173981	341211
22671	34618	0	applied	\N	\N	\N	\N	173993	173993	341223
22671	34621	3	applied	\N	\N	\N	\N	173996	173996	341226
22675	34632	1	applied	\N	\N	\N	\N	174010	174010	341240
22678	34638	0	applied	\N	\N	\N	\N	174019	174019	341249
22682	34644	0	applied	\N	\N	\N	\N	174035	174035	341265
22688	34657	3	applied	\N	\N	\N	\N	174059	174059	341289
22692	34669	1	applied	\N	\N	\N	\N	174079	174079	341309
22696	34679	2	applied	\N	\N	\N	\N	174101	174101	341331
22700	34686	0	applied	\N	\N	\N	\N	174120	174120	341350
22701	34689	3	applied	\N	\N	\N	\N	174127	174127	341357
22702	34692	2	applied	\N	\N	\N	\N	174130	174130	341360
22440	33949	24	applied	\N	\N	\N	\N	172375	172375	339609
22710	34705	0	applied	\N	\N	\N	\N	174165	174165	341395
22712	34711	1	applied	\N	\N	\N	\N	174177	174177	341407
22716	34724	2	applied	\N	\N	\N	\N	174196	174196	341426
22727	34734	0	applied	\N	\N	\N	\N	174223	174223	341453
22729	34739	1	applied	\N	\N	\N	\N	174230	174230	341460
22736	34753	0	applied	\N	\N	\N	\N	174244	174244	341474
22739	34776	3	applied	\N	\N	\N	\N	174281	174281	341511
22744	34793	3	applied	\N	\N	\N	\N	174304	174304	341534
22750	34801	0	applied	\N	\N	\N	\N	174326	174326	341556
22754	34529	8	applied	\N	\N	\N	\N	174343	174343	341572
22754	34060	24	applied	\N	\N	\N	\N	174359	174359	341588
22754	34088	41	applied	\N	\N	\N	\N	174376	174376	341605
22754	34109	58	applied	\N	\N	\N	\N	174393	174393	341622
22754	34141	75	applied	\N	\N	\N	\N	174410	174410	341639
22754	34169	93	applied	\N	\N	\N	\N	174427	174427	341656
22754	34195	110	applied	\N	\N	\N	\N	174444	174444	341673
22754	34212	113	applied	\N	\N	\N	\N	174447	174447	341676
22755	34808	4	applied	\N	\N	\N	\N	174459	174459	341688
22757	34816	2	applied	\N	\N	\N	\N	174477	174477	341706
22761	34825	1	applied	\N	\N	\N	\N	174492	174492	341721
22766	34833	0	applied	\N	\N	\N	\N	174510	174510	341739
22768	34838	0	applied	\N	\N	\N	\N	174515	174515	341744
22772	34864	12	applied	\N	\N	\N	\N	174545	174545	341773
22773	34856	4	applied	\N	\N	\N	\N	174558	174558	341786
22774	34860	8	applied	\N	\N	\N	\N	174583	174583	341810
22775	34873	0	applied	\N	\N	\N	\N	174596	174596	341822
22776	34875	2	applied	\N	\N	\N	\N	174601	174601	341827
22780	34886	0	applied	\N	\N	\N	\N	174612	174612	341838
22784	34896	6	applied	\N	\N	\N	\N	174640	174640	341866
22790	34918	6	applied	\N	\N	\N	\N	174669	174669	341895
22791	34920	2	applied	\N	\N	\N	\N	174671	174671	341897
22796	34934	1	applied	\N	\N	\N	\N	174703	174703	341929
22797	34938	5	applied	\N	\N	\N	\N	174709	174709	341935
22806	34948	0	applied	\N	\N	\N	\N	174740	174740	341966
22807	34947	3	applied	\N	\N	\N	\N	174744	174744	341970
22812	34959	0	applied	\N	\N	\N	\N	174759	174759	341985
22818	34969	4	applied	\N	\N	\N	\N	174782	174782	342008
22819	34970	0	applied	\N	\N	\N	\N	174783	174783	342009
22829	35001	1	applied	\N	\N	\N	\N	174825	174825	342051
22831	35006	2	applied	\N	\N	\N	\N	174834	174834	342060
22840	35022	1	applied	\N	\N	\N	\N	174865	174865	342091
22846	35027	0	applied	\N	\N	1000000000	\N	174874	174874	342100
22849	35035	0	applied	\N	\N	\N	\N	174885	174885	342111
22854	35039	1	applied	\N	\N	\N	\N	174896	174896	342122
22855	35040	2	applied	\N	\N	\N	\N	174902	174902	342128
22862	35047	0	applied	\N	\N	\N	\N	174932	174932	342158
22864	35054	3	applied	\N	\N	1000000000	\N	174943	174943	342169
22865	35054	3	applied	\N	\N	1000000000	\N	174948	174948	342174
22867	35058	2	applied	\N	\N	1000000000	\N	174956	174956	342182
22869	35057	1	applied	\N	\N	\N	\N	174963	174963	342189
22873	35067	1	applied	\N	\N	1000000000	\N	174978	174978	342204
22879	35080	3	applied	\N	\N	\N	\N	175009	175009	342235
22885	35093	4	applied	\N	\N	\N	\N	175032	175032	342258
22886	35097	1	applied	\N	\N	\N	\N	175036	175036	342262
22890	35058	16	applied	\N	\N	1000000000	\N	175066	175066	342292
22890	35097	37	applied	\N	\N	\N	\N	175087	175087	342313
22896	35112	3	applied	\N	\N	\N	\N	175114	175114	342340
22899	35113	0	applied	\N	\N	\N	\N	175122	175122	342348
22903	35108	3	applied	\N	\N	\N	\N	175137	175137	342363
22907	35131	5	applied	\N	\N	\N	\N	175157	175157	342383
22908	35136	7	applied	\N	\N	\N	\N	175174	175174	342400
22913	35150	3	applied	\N	\N	\N	\N	175194	175194	342420
22915	35162	1	applied	\N	\N	\N	\N	175206	175206	342432
22919	35148	2	applied	\N	\N	\N	\N	175221	175221	342447
22919	35150	11	applied	\N	\N	\N	\N	175230	175230	342456
22919	35155	23	applied	\N	\N	\N	\N	175242	175242	342468
22920	35172	3	applied	\N	\N	\N	\N	175251	175251	342477
22922	35175	2	applied	\N	\N	\N	\N	175258	175258	342484
22925	35175	2	applied	\N	\N	\N	\N	175269	175269	342495
22928	34936	10	applied	\N	\N	\N	\N	175288	175288	342514
22929	35150	24	applied	\N	\N	\N	\N	175322	175322	342548
22929	35156	41	applied	\N	\N	\N	\N	175339	175339	342565
22929	35162	58	applied	\N	\N	\N	\N	175356	175356	342582
22938	35189	2	applied	\N	\N	\N	\N	175386	175386	342612
22941	35149	16	applied	\N	\N	\N	\N	175409	175409	342635
22941	35133	33	applied	\N	\N	\N	\N	175426	175426	342652
22941	35136	50	applied	\N	\N	\N	\N	175443	175443	342669
22941	35184	67	applied	\N	\N	\N	\N	175460	175460	342686
22941	35153	85	applied	\N	\N	\N	\N	175478	175478	342704
22942	35198	5	applied	\N	\N	\N	\N	175495	175495	342721
22944	35202	3	applied	\N	\N	\N	\N	175507	175507	342733
22944	35210	11	applied	\N	\N	\N	\N	175515	175515	342741
22945	35194	1	applied	\N	\N	\N	\N	175521	175521	342747
22946	35215	0	applied	\N	\N	\N	\N	175536	175536	342762
22946	35216	1	applied	\N	\N	\N	\N	175537	175537	342763
22950	34625	9	applied	\N	\N	\N	\N	175557	175557	342783
22950	34635	13	applied	\N	\N	\N	\N	175561	175561	342787
22950	34690	30	applied	\N	\N	\N	\N	175578	175578	342804
22950	34734	47	applied	\N	\N	\N	\N	175595	175595	342821
22950	34782	65	applied	\N	\N	\N	\N	175612	175612	342838
22950	34838	82	applied	\N	\N	\N	\N	175629	175629	342855
22950	34897	99	applied	\N	\N	\N	\N	175646	175646	342872
22950	34943	111	applied	\N	\N	\N	\N	175658	175658	342884
22950	34953	114	applied	\N	\N	\N	\N	175661	175661	342887
22951	35223	5	applied	\N	\N	\N	\N	175678	175678	342904
22953	35178	15	applied	\N	\N	\N	\N	175703	175703	342929
22953	35211	32	applied	\N	\N	\N	\N	175720	175720	342946
22953	35227	49	applied	\N	\N	\N	\N	175737	175737	342963
22956	35197	13	applied	\N	\N	\N	\N	175760	175760	342986
22956	35217	31	applied	\N	\N	\N	\N	175777	175777	343003
22957	35239	7	applied	\N	\N	\N	\N	175793	175793	343019
22957	35250	18	applied	\N	\N	\N	\N	175804	175804	343030
22963	35257	2	applied	\N	\N	\N	\N	175825	175825	343051
22967	35258	0	applied	\N	\N	\N	\N	175835	175835	343061
22967	35259	1	applied	\N	\N	\N	\N	175836	175836	343062
22972	35268	0	applied	\N	\N	\N	\N	175850	175850	343076
22980	34953	6	applied	\N	\N	\N	\N	175876	175876	343102
22980	34971	14	applied	\N	\N	\N	\N	175884	175884	343110
22980	35028	30	applied	\N	\N	\N	\N	175900	175900	343126
22980	35090	47	applied	\N	\N	\N	\N	175917	175917	343143
22709	34708	3	applied	\N	\N	\N	\N	174163	174163	341393
22980	35274	98	applied	\N	\N	\N	\N	175968	175968	343194
22980	35163	115	applied	\N	\N	\N	\N	175984	175984	343210
22982	35282	3	applied	\N	\N	\N	\N	176001	176001	343227
22984	35295	1	applied	\N	\N	\N	\N	176014	176014	343240
22987	35298	2	applied	\N	\N	\N	\N	176030	176030	343256
22990	35304	3	applied	\N	\N	\N	\N	176046	176046	343272
22993	35309	0	applied	\N	\N	\N	\N	176057	176057	343283
22994	35315	3	applied	\N	\N	\N	\N	176063	176063	343289
22996	35329	7	applied	\N	\N	\N	\N	176077	176077	343303
23007	35350	1	applied	\N	\N	\N	\N	176116	176116	343342
23009	35353	1	applied	\N	\N	\N	\N	176121	176121	343347
23017	35366	4	applied	\N	\N	\N	\N	176162	176162	343388
23018	35369	7	applied	\N	\N	\N	\N	176178	176178	343404
23019	35370	8	applied	\N	\N	\N	\N	176192	176192	343418
23020	35298	24	applied	\N	\N	\N	\N	176221	176221	343447
23020	35352	41	applied	\N	\N	\N	\N	176238	176238	343464
23029	35378	0	applied	\N	\N	\N	\N	176268	176268	343494
23031	35380	2	applied	\N	\N	\N	\N	176275	176275	343501
23032	35378	0	applied	\N	\N	\N	\N	176276	176276	343502
23035	35393	6	applied	\N	\N	\N	\N	176302	176302	343528
23036	35399	2	applied	\N	\N	\N	\N	176308	176308	343534
23037	35402	5	applied	\N	\N	\N	\N	176321	176321	343547
23043	35419	2	applied	\N	\N	\N	\N	176351	176351	343577
23045	35422	2	applied	\N	\N	\N	\N	176358	176358	343584
23047	35058	3	applied	\N	\N	1000000000	\N	176366	176366	343592
23047	35054	18	applied	\N	\N	1000000000	\N	176381	176381	343607
23053	35444	5	applied	\N	\N	\N	\N	176413	176413	343639
23054	35440	1	applied	\N	\N	\N	\N	176416	176416	343642
23059	35454	2	applied	\N	\N	\N	\N	176434	176434	343660
23061	35457	1	applied	\N	\N	\N	\N	176441	176441	343667
23072	35475	0	applied	\N	\N	\N	\N	176482	176482	343708
23073	35478	3	applied	\N	\N	\N	\N	176489	176489	343715
23078	35484	0	applied	\N	\N	\N	\N	176503	176503	343729
23078	35486	1	applied	\N	\N	\N	\N	176504	176504	343730
23080	35489	0	applied	\N	\N	\N	\N	176511	176511	343737
23081	35493	1	applied	\N	\N	\N	\N	176515	176515	343741
23089	35462	2	applied	\N	\N	\N	\N	176547	176547	343773
23089	35516	19	applied	\N	\N	\N	\N	176564	176564	343790
23089	35460	25	applied	\N	\N	\N	\N	176570	176570	343796
23089	35500	42	applied	\N	\N	\N	\N	176587	176587	343813
23089	35505	43	applied	\N	\N	\N	\N	176588	176588	343814
23089	35485	59	applied	\N	\N	\N	\N	176604	176604	343830
23090	35520	11	applied	\N	\N	\N	\N	176628	176628	343854
23090	35530	14	applied	\N	\N	\N	\N	176631	176631	343857
23094	35543	5	applied	\N	\N	\N	\N	176652	176652	343878
23095	35539	1	applied	\N	\N	\N	\N	176655	176655	343881
23109	35573	0	applied	\N	\N	\N	\N	176704	176704	343930
23115	35590	3	applied	\N	\N	\N	\N	176724	176724	343950
23120	35601	0	applied	\N	\N	\N	\N	176742	176742	343968
23124	35615	2	applied	\N	\N	\N	\N	176759	176759	343985
23127	35626	3	applied	\N	\N	\N	\N	176771	176771	343997
23130	35200	15	applied	\N	\N	\N	\N	176798	176798	344024
23130	35380	32	applied	\N	\N	\N	\N	176815	176815	344041
23130	35139	49	applied	\N	\N	\N	\N	176832	176832	344058
23130	35155	51	applied	\N	\N	\N	\N	176834	176834	344060
23130	35164	54	applied	\N	\N	\N	\N	176837	176837	344063
23130	35228	71	applied	\N	\N	\N	\N	176854	176854	344080
23130	35561	88	applied	\N	\N	\N	\N	176871	176871	344097
23130	35273	105	applied	\N	\N	\N	\N	176888	176888	344114
23130	35358	124	applied	\N	\N	\N	\N	176905	176905	344131
23133	35628	0	applied	\N	\N	\N	\N	176917	176917	344143
23136	35570	4	applied	\N	\N	\N	\N	176946	176946	344172
23136	35582	38	applied	\N	\N	\N	\N	176980	176980	344206
23136	35618	62	applied	\N	\N	\N	\N	177004	177004	344230
23136	35625	74	applied	\N	\N	\N	\N	177016	177016	344242
23137	35638	1	applied	\N	\N	\N	\N	177019	177019	344245
23138	35642	8	applied	\N	\N	\N	\N	177035	177035	344261
23140	35646	3	applied	\N	\N	\N	\N	177046	177046	344272
23141	35648	5	applied	\N	\N	\N	\N	177055	177055	344281
23143	35652	2	applied	\N	\N	\N	\N	177066	177066	344292
23148	35673	0	applied	\N	\N	\N	\N	177087	177087	344313
23151	35336	10	applied	\N	\N	\N	\N	177106	177106	344332
23151	35345	13	applied	\N	\N	\N	\N	177109	177109	344335
23151	35398	30	applied	\N	\N	\N	\N	177126	177126	344352
23151	35457	47	applied	\N	\N	\N	\N	177143	177143	344369
23151	35515	64	applied	\N	\N	\N	\N	177160	177160	344386
23151	35570	82	applied	\N	\N	\N	\N	177177	177177	344403
23151	35628	99	applied	\N	\N	\N	\N	177194	177194	344420
23151	35315	113	applied	\N	\N	\N	\N	177208	177208	344434
23156	35629	0	applied	\N	\N	\N	\N	177231	177231	344457
23156	35639	17	applied	\N	\N	\N	\N	177248	177248	344474
23156	35654	35	applied	\N	\N	\N	\N	177265	177265	344491
23157	35680	0	applied	\N	\N	\N	\N	177278	177278	344504
23163	35693	4	applied	\N	\N	\N	\N	177306	177306	344532
23171	35701	1	applied	\N	\N	\N	\N	177328	177328	344554
23174	35056	2	applied	\N	\N	\N	\N	177337	177337	344563
23174	35109	19	applied	\N	\N	\N	\N	177354	177354	344580
23174	35127	25	applied	\N	\N	\N	\N	177360	177360	344586
23174	35193	42	applied	\N	\N	\N	\N	177377	177377	344603
23174	35202	45	applied	\N	\N	\N	\N	177380	177380	344606
23174	35218	48	applied	\N	\N	\N	\N	177383	177383	344609
23174	35277	65	applied	\N	\N	\N	\N	177400	177400	344626
23174	35322	83	applied	\N	\N	\N	\N	177417	177417	344643
23174	35378	100	applied	\N	\N	\N	\N	177434	177434	344660
23179	35567	1	applied	\N	\N	\N	\N	177475	177475	344701
23179	35623	18	applied	\N	\N	\N	\N	177492	177492	344718
23179	35682	35	applied	\N	\N	\N	\N	177509	177509	344735
23179	35569	52	applied	\N	\N	\N	\N	177526	177526	344752
23179	35627	65	applied	\N	\N	\N	\N	177539	177539	344765
23179	35579	85	applied	\N	\N	\N	\N	177559	177559	344785
23179	35640	103	applied	\N	\N	\N	\N	177576	177576	344802
23179	35652	106	applied	\N	\N	\N	\N	177579	177579	344805
23179	35616	120	applied	\N	\N	\N	\N	177593	177593	344819
23181	35720	12	applied	\N	\N	\N	\N	177617	177617	344843
23184	34988	17	applied	\N	\N	\N	\N	177659	177659	344885
23184	35051	34	applied	\N	\N	\N	\N	177676	177676	344902
23184	35109	51	applied	\N	\N	\N	\N	177693	177693	344919
23184	35173	68	applied	\N	\N	\N	\N	177710	177710	344936
23184	35233	85	applied	\N	\N	\N	\N	177727	177727	344953
23184	35237	89	applied	\N	\N	\N	\N	177730	177730	344956
22980	35215	81	applied	\N	\N	\N	\N	175951	175951	343177
23189	35736	1	applied	\N	\N	\N	\N	177784	177784	345010
23196	35737	0	applied	\N	\N	\N	\N	177801	177801	345027
23203	35749	0	applied	\N	\N	\N	\N	177818	177818	345044
23208	35754	1	applied	\N	\N	\N	\N	177835	177835	345061
23214	35548	6	applied	\N	\N	\N	\N	177850	177850	345076
23214	35549	7	applied	\N	\N	\N	\N	177851	177851	345077
23214	35607	24	applied	\N	\N	\N	\N	177868	177868	345094
23214	35664	41	applied	\N	\N	\N	\N	177885	177885	345111
23214	35710	59	applied	\N	\N	\N	\N	177902	177902	345128
23214	35749	76	applied	\N	\N	\N	\N	177919	177919	345145
23214	35627	93	applied	\N	\N	\N	\N	177936	177936	345162
23214	35547	110	applied	\N	\N	\N	\N	177953	177953	345179
23215	35757	0	applied	\N	\N	\N	\N	177969	177969	345195
23216	35757	0	applied	\N	\N	\N	\N	177972	177972	345198
23219	35758	0	applied	\N	\N	1000000000	\N	177979	177979	345205
23222	35718	11	applied	\N	\N	\N	\N	178000	178000	345226
23222	35760	28	applied	\N	\N	\N	\N	178017	178017	345243
23222	35731	46	applied	\N	\N	\N	\N	178034	178034	345260
23222	35766	63	applied	\N	\N	\N	\N	178051	178051	345277
23225	35771	4	applied	\N	\N	\N	\N	178060	178060	345286
23228	35495	14	applied	\N	\N	\N	\N	178085	178085	345311
23228	35549	31	applied	\N	\N	\N	\N	178102	178102	345328
23228	35607	48	applied	\N	\N	\N	\N	178119	178119	345345
23228	35664	65	applied	\N	\N	\N	\N	178136	178136	345362
23228	35710	82	applied	\N	\N	\N	\N	178153	178153	345379
23228	35715	85	applied	\N	\N	\N	\N	178156	178156	345382
23228	35753	101	applied	\N	\N	\N	\N	178172	178172	345398
23228	35468	118	applied	\N	\N	\N	\N	178189	178189	345415
23242	35784	1	applied	\N	\N	\N	\N	178220	178220	345446
23244	35631	4	applied	\N	\N	\N	\N	178227	178227	345453
23255	35793	0	applied	\N	\N	\N	\N	178260	178260	345486
23266	35808	0	applied	\N	\N	\N	\N	178284	178284	345510
23266	35809	1	applied	\N	\N	\N	\N	178285	178285	345511
23269	35811	1	applied	\N	\N	\N	\N	178291	178291	345517
23273	35812	0	applied	\N	\N	\N	\N	178301	178301	345527
23276	35819	1	applied	\N	\N	\N	\N	178312	178312	345538
23284	35758	4	applied	\N	\N	1000000000	\N	178332	178332	345558
23284	35805	25	applied	\N	\N	\N	\N	178353	178353	345579
23284	35656	42	applied	\N	\N	\N	\N	178370	178370	345596
23284	35592	60	applied	\N	\N	\N	\N	178387	178387	345613
23284	35652	76	applied	\N	\N	\N	\N	178403	178403	345629
23284	35655	77	applied	\N	\N	\N	\N	178404	178404	345630
23284	35634	94	applied	\N	\N	\N	\N	178421	178421	345647
23285	35831	0	applied	\N	\N	\N	\N	178438	178438	345664
23287	35838	1	applied	\N	\N	\N	\N	178451	178451	345677
23290	35698	11	applied	\N	\N	\N	\N	178467	178467	345693
23290	35777	45	applied	\N	\N	\N	\N	178501	178501	345727
23290	35812	62	applied	\N	\N	\N	\N	178518	178518	345744
23290	35314	79	applied	\N	\N	\N	\N	178535	178535	345761
23290	35326	83	applied	\N	\N	\N	\N	178538	178538	345764
23290	35379	100	applied	\N	\N	\N	\N	178555	178555	345781
23290	35436	117	applied	\N	\N	\N	\N	178572	178572	345798
23293	35849	2	applied	\N	\N	\N	\N	178589	178589	345815
23302	35365	6	applied	\N	\N	\N	\N	178619	178619	345845
23302	35375	7	applied	\N	\N	\N	\N	178620	178620	345846
23302	35378	8	applied	\N	\N	\N	\N	178621	178621	345847
23302	35434	25	applied	\N	\N	\N	\N	178638	178638	345864
23302	35492	42	applied	\N	\N	\N	\N	178655	178655	345881
23302	35548	59	applied	\N	\N	\N	\N	178672	178672	345898
23302	35602	76	applied	\N	\N	\N	\N	178689	178689	345915
23302	35663	94	applied	\N	\N	\N	\N	178706	178706	345932
23302	35664	95	applied	\N	\N	\N	\N	178707	178707	345933
23302	35715	115	applied	\N	\N	\N	\N	178727	178727	345953
23308	35869	2	applied	\N	\N	\N	\N	178750	178750	345976
23312	35777	6	applied	\N	\N	\N	\N	178763	178763	345989
23312	35812	23	applied	\N	\N	\N	\N	178780	178780	346006
23312	35841	38	applied	\N	\N	\N	\N	178795	178795	346021
23312	35770	55	applied	\N	\N	\N	\N	178812	178812	346038
23312	35771	56	applied	\N	\N	\N	\N	178813	178813	346039
23312	35775	59	applied	\N	\N	\N	\N	178816	178816	346042
23312	35809	76	applied	\N	\N	\N	\N	178833	178833	346059
23312	35844	94	applied	\N	\N	\N	\N	178850	178850	346076
23313	35876	1	applied	\N	\N	\N	\N	178867	178867	346093
23316	35879	0	applied	\N	\N	\N	\N	178875	178875	346101
23317	35881	2	applied	\N	\N	\N	\N	178881	178881	346107
23332	35503	9	applied	\N	\N	\N	\N	178921	178921	346147
23332	35560	26	applied	\N	\N	\N	\N	178938	178938	346164
23332	35567	28	applied	\N	\N	\N	\N	178940	178940	346166
23332	35676	60	applied	\N	\N	\N	\N	178972	178972	346198
23332	35680	61	applied	\N	\N	\N	\N	178973	178973	346199
23332	35717	78	applied	\N	\N	\N	\N	178990	178990	346216
23332	35757	96	applied	\N	\N	\N	\N	179007	179007	346233
23335	35904	1	applied	\N	\N	\N	\N	179013	179013	346239
23340	35911	2	applied	\N	\N	\N	\N	179022	179022	346248
23342	35912	3	applied	\N	\N	\N	\N	179031	179031	346257
23353	35768	12	applied	\N	\N	\N	\N	179073	179073	346299
23353	35803	29	applied	\N	\N	\N	\N	179090	179090	346316
23353	35820	37	applied	\N	\N	\N	\N	179098	179098	346324
23353	35851	53	applied	\N	\N	\N	\N	179114	179114	346340
23353	35884	70	applied	\N	\N	\N	\N	179131	179131	346357
23353	35921	87	applied	\N	\N	\N	\N	179148	179148	346374
23361	35936	1	applied	\N	\N	\N	\N	179179	179179	346405
23362	35940	1	applied	\N	\N	\N	\N	179182	179182	346408
23366	35913	0	applied	\N	\N	\N	\N	179191	179191	346417
23383	35959	2	applied	\N	\N	\N	\N	179235	179235	346461
23383	35961	4	applied	\N	\N	\N	\N	179237	179237	346463
23383	35958	7	applied	\N	\N	\N	\N	179240	179240	346466
23390	35974	1	applied	\N	\N	\N	\N	179259	179259	346485
23392	35986	3	applied	\N	\N	\N	\N	179281	179281	346507
23397	35871	16	applied	\N	\N	\N	\N	179312	179312	346538
23397	35903	32	applied	\N	\N	\N	\N	179328	179328	346554
23397	35939	49	applied	\N	\N	\N	\N	179345	179345	346571
23397	35977	70	applied	\N	\N	\N	\N	179366	179366	346592
23397	35508	88	applied	\N	\N	\N	\N	179383	179383	346609
23403	35996	1	applied	\N	\N	\N	\N	179404	179404	346630
23406	36000	3	applied	\N	\N	\N	\N	179424	179424	346650
23407	36005	0	applied	\N	\N	\N	\N	179429	179429	346655
23410	35712	17	applied	\N	\N	\N	\N	179454	179454	346680
23410	35750	34	applied	\N	\N	\N	\N	179471	179471	346697
23410	35757	37	applied	\N	\N	\N	\N	179474	179474	346700
23185	35726	0	applied	\N	\N	\N	\N	177767	177767	344993
23410	35896	105	applied	\N	\N	\N	\N	179542	179542	346768
23410	35930	122	applied	\N	\N	\N	\N	179558	179558	346784
23410	35937	125	applied	\N	\N	\N	\N	179561	179561	346787
23416	36015	14	applied	\N	\N	\N	\N	179592	179592	346818
23416	36018	31	applied	\N	\N	\N	\N	179609	179609	346835
23417	36020	1	applied	\N	\N	\N	\N	179611	179611	346837
23420	36024	0	applied	\N	\N	\N	\N	179617	179617	346843
23421	35995	4	applied	\N	\N	\N	\N	179623	179623	346849
23421	35997	5	applied	\N	\N	\N	\N	179624	179624	346850
23421	36003	25	applied	\N	\N	\N	\N	179644	179644	346870
23424	36030	5	applied	\N	\N	\N	\N	179668	179668	346894
23430	36036	0	applied	\N	\N	\N	\N	179681	179681	346907
23436	36039	1	applied	\N	\N	\N	\N	179694	179694	346920
23454	35960	4	applied	\N	\N	\N	\N	179733	179733	346959
23454	35993	20	applied	\N	\N	\N	\N	179749	179749	346975
23454	36027	37	applied	\N	\N	\N	\N	179766	179766	346992
23454	35964	52	applied	\N	\N	\N	\N	179781	179781	347007
23454	35970	55	applied	\N	\N	\N	\N	179784	179784	347010
23454	36004	72	applied	\N	\N	\N	\N	179801	179801	347027
23454	36039	89	applied	\N	\N	\N	\N	179818	179818	347044
23455	36051	1	applied	\N	\N	\N	\N	179825	179825	347051
23456	36055	2	applied	\N	\N	\N	\N	179829	179829	347055
23462	35957	9	applied	\N	\N	\N	\N	179851	179851	347077
23462	35991	26	applied	\N	\N	\N	\N	179868	179868	347094
23462	36026	43	applied	\N	\N	\N	\N	179885	179885	347111
23462	35741	92	applied	\N	\N	\N	\N	179934	179934	347160
23462	35748	95	applied	\N	\N	\N	\N	179937	179937	347163
23463	36056	0	applied	\N	\N	\N	\N	179954	179954	347180
23465	36074	3	applied	\N	\N	\N	\N	179972	179972	347198
23467	36075	0	applied	\N	\N	\N	\N	179977	179977	347203
23472	36083	2	applied	\N	\N	\N	\N	179996	179996	347222
23476	36088	0	applied	\N	\N	\N	\N	180007	180007	347233
23480	36100	9	applied	\N	\N	\N	\N	180023	180023	347249
23485	36111	4	applied	\N	\N	\N	\N	180043	180043	347269
23491	36117	0	applied	\N	\N	\N	\N	180052	180052	347278
23499	36076	9	applied	\N	\N	\N	\N	180095	180095	347321
23499	36086	12	applied	\N	\N	\N	\N	180098	180098	347324
23504	36141	1	applied	\N	\N	\N	\N	180121	180121	347347
23507	36142	2	applied	\N	\N	\N	\N	180131	180131	347357
23516	36151	0	applied	\N	\N	\N	\N	180159	180159	347385
23518	36155	0	applied	\N	\N	\N	\N	180166	180166	347392
23523	35968	23	applied	\N	\N	\N	\N	180225	180225	347451
23523	36000	40	applied	\N	\N	\N	\N	180242	180242	347468
23523	36038	57	applied	\N	\N	\N	\N	180259	180259	347485
23528	36187	9	applied	\N	\N	\N	\N	180279	180279	347505
23529	36189	11	applied	\N	\N	\N	\N	180296	180296	347522
23535	36184	3	applied	\N	\N	\N	\N	180320	180320	347546
23536	36203	1	applied	\N	\N	\N	\N	180325	180325	347551
23537	36219	7	applied	\N	\N	\N	\N	180340	180340	347566
23539	36222	0	applied	\N	\N	\N	\N	180353	180353	347579
23542	36223	1	applied	\N	\N	\N	\N	180363	180363	347589
23549	36239	1	applied	\N	\N	\N	\N	180384	180384	347610
23551	36243	5	applied	\N	\N	\N	\N	180395	180395	347621
23552	36238	0	applied	\N	\N	\N	\N	180397	180397	347623
23558	36252	1	applied	\N	\N	\N	\N	180435	180435	347661
23559	36255	4	applied	\N	\N	\N	\N	180444	180444	347670
23564	36267	0	applied	\N	\N	\N	\N	180464	180464	347690
23568	36271	0	applied	\N	\N	\N	\N	180478	180478	347704
23574	36284	0	applied	\N	\N	\N	\N	180501	180501	347727
23579	36291	0	applied	\N	\N	\N	\N	180519	180519	347745
23580	36293	2	applied	\N	\N	\N	\N	180525	180525	347751
23582	36300	2	applied	\N	\N	\N	\N	180532	180532	347758
23586	36303	1	applied	\N	\N	\N	\N	180547	180547	347773
23590	36311	3	applied	\N	\N	\N	\N	180562	180562	347788
23592	36314	2	applied	\N	\N	\N	\N	180571	180571	347797
23594	36315	3	applied	\N	\N	\N	\N	180584	180584	347810
23596	36318	0	applied	\N	\N	\N	\N	180600	180600	347826
23598	36303	14	applied	\N	\N	\N	\N	180623	180623	347849
23600	36333	6	applied	\N	\N	\N	\N	180649	180649	347874
23601	36336	9	applied	\N	\N	\N	\N	180666	180666	347890
23613	36351	1	applied	\N	\N	\N	\N	180715	180715	347938
23616	36362	2	applied	\N	\N	\N	\N	180732	180732	347955
23617	36361	1	applied	\N	\N	\N	\N	180737	180737	347960
23621	36371	2	applied	\N	\N	\N	\N	180754	180754	347977
23623	36378	8	applied	\N	\N	\N	\N	180772	180772	347993
23626	36121	25	applied	\N	\N	\N	\N	180819	180819	348038
23626	36179	42	applied	\N	\N	\N	\N	180836	180836	348055
23626	36231	59	applied	\N	\N	\N	\N	180853	180853	348072
23622	36376	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	180759	180759	\N
23626	36288	75	applied	\N	\N	\N	\N	180869	180869	348088
23624	36376	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	180778	180778	\N
23626	36302	79	applied	\N	\N	\N	\N	180873	180873	348092
23626	36361	96	applied	\N	\N	\N	\N	180890	180890	348109
23626	36098	113	applied	\N	\N	\N	\N	180907	180907	348125
23627	36396	6	applied	\N	\N	\N	\N	180926	180926	348144
23630	36402	2	applied	\N	\N	\N	\N	180935	180935	348153
23634	36411	1	applied	\N	\N	\N	\N	180949	180949	348167
23637	36419	6	applied	\N	\N	\N	\N	180967	180967	348185
23638	36422	2	applied	\N	\N	\N	\N	180970	180970	348188
23641	36429	0	applied	\N	\N	\N	\N	180995	180995	348213
23645	36440	1	applied	\N	\N	\N	\N	181016	181016	348234
23645	36441	2	applied	\N	\N	\N	\N	181017	181017	348235
23651	36449	0	applied	\N	\N	\N	\N	181039	181039	348257
23652	36450	1	applied	\N	\N	\N	\N	181047	181047	348265
23658	36467	8	applied	\N	\N	\N	\N	181077	181077	348294
23659	36468	9	applied	\N	\N	\N	\N	181088	181088	348305
23664	36475	3	applied	\N	\N	\N	\N	181103	181103	348320
23670	36486	5	applied	\N	\N	\N	\N	181125	181125	348342
23674	36483	2	applied	\N	\N	\N	\N	181150	181150	348367
23684	36509	6	applied	\N	\N	\N	\N	181187	181187	348404
23686	36515	0	applied	\N	\N	\N	\N	181193	181193	348410
23688	36526	1	applied	\N	\N	\N	\N	181204	181204	348421
23695	36542	5	applied	\N	\N	\N	\N	181237	181237	348454
23697	36538	0	applied	\N	\N	\N	\N	181247	181247	348464
23698	36547	2	applied	\N	\N	\N	\N	181256	181256	348473
23698	36555	10	applied	\N	\N	1000000000	\N	181264	181264	348481
23410	35863	88	applied	\N	\N	\N	\N	179525	179525	346751
23521	36169	7	applied	\N	\N	\N	\N	180190	180190	347416
23706	36571	1	applied	\N	\N	\N	\N	181296	181296	348513
23714	36590	0	applied	\N	\N	\N	\N	181324	181324	348541
23716	36591	1	applied	\N	\N	\N	\N	181330	181330	348547
23719	36602	2	applied	\N	\N	\N	\N	181350	181350	348567
23722	36604	1	applied	\N	\N	\N	\N	181355	181355	348572
23726	36619	2	applied	\N	\N	\N	\N	181382	181382	348599
23733	36451	2	applied	\N	\N	\N	\N	181423	181423	348639
23732	36653	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	181416	181416	\N
23733	36334	19	applied	\N	\N	\N	\N	181440	181440	348655
23733	36369	29	applied	\N	\N	\N	\N	181450	181450	348665
23733	36384	33	applied	\N	\N	\N	\N	181454	181454	348669
23733	36442	50	applied	\N	\N	\N	\N	181471	181471	348686
23733	36503	67	applied	\N	\N	\N	\N	181488	181488	348703
23733	36563	85	applied	\N	\N	\N	\N	181505	181505	348720
23733	36618	102	applied	\N	\N	\N	\N	181522	181522	348737
23733	36505	117	applied	\N	\N	\N	\N	181537	181537	348750
23737	36664	2	applied	\N	\N	\N	\N	181561	181561	348774
23739	36665	3	applied	\N	\N	\N	\N	181574	181574	348787
23743	36667	0	applied	\N	\N	\N	\N	181585	181585	348798
23746	36686	14	applied	\N	\N	\N	\N	181604	181604	348817
23748	36673	9	applied	\N	\N	\N	\N	181629	181629	348841
23748	36687	26	applied	\N	\N	\N	\N	181646	181646	348858
23748	36684	38	applied	\N	\N	\N	\N	181658	181658	348870
23751	36702	0	applied	\N	\N	\N	\N	181679	181679	348891
23756	36707	2	applied	\N	\N	\N	\N	181696	181696	348908
23757	36453	16	applied	\N	\N	\N	\N	181713	181713	348924
23757	36512	33	applied	\N	\N	\N	\N	181730	181730	348941
23757	36570	50	applied	\N	\N	\N	\N	181747	181747	348958
23757	36627	68	applied	\N	\N	\N	\N	181764	181764	348975
23757	36639	73	applied	\N	\N	\N	\N	181769	181769	348980
23757	36647	74	applied	\N	\N	\N	\N	181770	181770	348981
23757	36705	91	applied	\N	\N	\N	\N	181787	181787	348998
23757	36441	108	applied	\N	\N	\N	\N	181804	181804	349015
23758	36708	0	applied	\N	\N	\N	\N	181821	181821	349032
23759	36667	2	applied	\N	\N	\N	\N	181827	181827	349038
23759	36673	5	applied	\N	\N	\N	\N	181830	181830	349041
23759	36323	22	applied	\N	\N	\N	\N	181847	181847	349058
23759	36388	39	applied	\N	\N	\N	\N	181864	181864	349075
23759	36440	56	applied	\N	\N	\N	\N	181881	181881	349092
23759	36356	73	applied	\N	\N	\N	\N	181898	181898	349109
23759	36464	107	applied	\N	\N	\N	\N	181931	181931	349142
23759	36428	124	applied	\N	\N	\N	\N	181948	181948	349159
23760	36715	3	applied	\N	\N	\N	\N	181953	181953	349164
23762	36576	32	applied	\N	\N	\N	\N	181994	181994	349204
23762	36653	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	181962	181962	\N
23762	36498	75	applied	\N	\N	\N	\N	182037	182037	349247
23762	36470	80	applied	\N	\N	\N	\N	182042	182042	349252
23762	36471	81	applied	\N	\N	\N	\N	182043	182043	349253
23762	36522	98	applied	\N	\N	\N	\N	182060	182060	349270
23762	36475	116	applied	\N	\N	\N	\N	182077	182077	349287
23772	36735	1	applied	\N	\N	\N	\N	182125	182125	349335
23773	36740	2	applied	\N	\N	\N	\N	182130	182130	349340
23775	36745	0	applied	\N	\N	\N	\N	182138	182138	349348
23780	36754	3	applied	\N	\N	\N	\N	182153	182153	349363
23785	36764	3	applied	\N	\N	\N	\N	182173	182173	349383
23788	36764	3	applied	\N	\N	\N	\N	182185	182185	349395
23801	36779	5	applied	\N	\N	\N	\N	182235	182235	349445
23802	36780	6	applied	\N	\N	\N	\N	182243	182243	349453
23805	36786	2	applied	\N	\N	\N	\N	182252	182252	349462
23807	36794	0	applied	\N	\N	1000000000	\N	182260	182260	349470
23808	36794	0	applied	\N	\N	1000000000	\N	182265	182265	349475
23818	36815	4	applied	\N	\N	\N	\N	182304	182304	349514
23819	36819	1	applied	\N	\N	\N	\N	182308	182308	349518
23825	36831	3	applied	\N	\N	\N	\N	182342	182342	349552
23839	36855	1	applied	\N	\N	\N	\N	182411	182411	349621
23843	36875	5	applied	\N	\N	\N	\N	182431	182431	349641
23847	36042	21	applied	\N	\N	\N	\N	182462	182462	349672
23847	36182	37	applied	\N	\N	\N	\N	182478	182478	349688
23847	36075	40	applied	\N	\N	\N	\N	182481	182481	349690
23847	36130	57	applied	\N	\N	\N	\N	182498	182498	349707
23847	36193	74	applied	\N	\N	\N	\N	182515	182515	349724
23847	36238	91	applied	\N	\N	\N	\N	182532	182532	349741
23847	36298	108	applied	\N	\N	\N	\N	182549	182549	349758
23847	36360	125	applied	\N	\N	\N	\N	182566	182566	349775
23848	36881	1	applied	\N	\N	\N	\N	182568	182568	349777
23849	36890	0	applied	\N	\N	\N	\N	182577	182577	349786
23852	36897	0	applied	\N	\N	\N	\N	182587	182587	349796
23853	36021	5	applied	\N	\N	\N	\N	182595	182595	349804
23853	36184	22	applied	\N	\N	\N	\N	182612	182612	349820
23853	35910	39	applied	\N	\N	\N	\N	182629	182629	349837
23853	35947	56	applied	\N	\N	\N	\N	182646	182646	349854
23853	35952	59	applied	\N	\N	\N	\N	182649	182649	349857
23853	35987	76	applied	\N	\N	\N	\N	182666	182666	349874
23853	36042	103	applied	\N	\N	\N	\N	182693	182693	349901
23853	36091	121	applied	\N	\N	\N	\N	182710	182710	349918
23861	36905	2	applied	\N	\N	\N	\N	182734	182734	349942
23862	36906	4	applied	\N	\N	\N	\N	182743	182743	349951
23864	36915	2	applied	\N	\N	\N	\N	182761	182761	349969
23867	36921	1	applied	\N	\N	\N	\N	182773	182773	349981
23868	36925	2	applied	\N	\N	\N	\N	182777	182777	349985
23868	36926	3	applied	\N	\N	\N	\N	182778	182778	349986
23872	36937	5	applied	\N	\N	\N	\N	182795	182795	350003
23876	36950	15	applied	\N	\N	\N	\N	182827	182827	350035
23877	36738	43	applied	\N	\N	\N	\N	182874	182874	350081
23877	36653	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	182833	182833	\N
23877	36795	60	applied	\N	\N	\N	\N	182891	182891	350098
23877	36802	62	applied	\N	\N	\N	\N	182893	182893	350100
23877	36812	65	applied	\N	\N	\N	\N	182896	182896	350103
23877	36870	82	applied	\N	\N	\N	\N	182913	182913	350120
23877	36924	99	applied	\N	\N	\N	\N	182930	182930	350137
23877	36687	116	applied	\N	\N	\N	\N	182947	182947	350154
23879	36953	4	applied	\N	\N	\N	\N	182960	182960	350167
23880	36951	8	applied	\N	\N	\N	\N	182971	182971	350178
23881	36967	5	applied	\N	\N	\N	\N	182982	182982	350189
23888	37000	2	applied	\N	\N	\N	\N	183018	183018	350225
23895	37004	2	applied	\N	\N	\N	\N	183038	183038	350245
23900	37012	0	applied	\N	\N	\N	\N	183050	183050	350257
23705	36568	1	applied	\N	\N	\N	\N	181293	181293	348510
23907	37018	0	applied	\N	\N	\N	\N	183071	183071	350278
23915	37038	8	applied	\N	\N	\N	\N	183111	183111	350318
23916	36794	0	applied	\N	\N	1000000000	\N	183115	183115	350322
23916	36771	20	applied	\N	\N	\N	\N	183135	183135	350342
23916	36828	37	applied	\N	\N	\N	\N	183152	183152	350359
23916	36882	54	applied	\N	\N	\N	\N	183169	183169	350376
23916	36939	71	applied	\N	\N	\N	\N	183186	183186	350393
23916	36999	89	applied	\N	\N	\N	\N	183203	183203	350410
23919	37055	2	applied	\N	\N	\N	\N	183236	183236	350443
23928	37072	3	applied	\N	\N	\N	\N	183265	183265	350472
23930	37075	2	applied	\N	\N	\N	\N	183272	183272	350479
23931	37085	2	applied	\N	\N	\N	\N	183282	183282	350489
23934	37089	0	applied	\N	\N	\N	\N	183289	183289	350496
23941	37096	0	applied	\N	\N	\N	\N	183317	183317	350524
23942	37099	3	applied	\N	\N	\N	\N	183326	183326	350533
23952	37106	1	applied	\N	\N	\N	\N	183366	183366	350573
23953	37116	5	applied	\N	\N	\N	\N	183376	183376	350583
23958	37120	0	applied	\N	\N	\N	\N	183392	183392	350599
23960	37123	0	applied	\N	\N	\N	\N	183397	183397	350604
23961	37127	1	applied	\N	\N	\N	\N	183401	183401	350608
23962	37135	3	applied	\N	\N	\N	\N	183409	183409	350616
23964	36751	12	applied	\N	\N	\N	\N	183428	183428	350635
23964	36808	29	applied	\N	\N	\N	\N	183445	183445	350652
23964	36867	46	applied	\N	\N	\N	\N	183462	183462	350669
23964	36923	63	applied	\N	\N	\N	\N	183479	183479	350686
23964	36978	80	applied	\N	\N	\N	\N	183496	183496	350703
23964	37032	97	applied	\N	\N	\N	\N	183513	183513	350720
23964	37043	100	applied	\N	\N	\N	\N	183516	183516	350723
23964	37102	118	applied	\N	\N	\N	\N	183533	183533	350740
23966	37142	0	applied	\N	\N	\N	\N	183544	183544	350751
23969	37157	9	applied	\N	\N	\N	\N	183572	183572	350779
23971	37162	0	applied	\N	\N	\N	\N	183587	183587	350794
23973	37178	7	applied	\N	\N	\N	\N	183612	183612	350819
23980	37162	13	applied	\N	\N	\N	\N	183644	183644	350851
23986	37205	0	applied	\N	\N	\N	\N	183673	183673	350880
23987	37208	0	applied	\N	\N	\N	\N	183676	183676	350883
23988	37210	0	applied	\N	\N	\N	\N	183678	183678	350885
23989	37210	0	applied	\N	\N	\N	\N	183681	183681	350888
23990	37213	0	applied	\N	\N	\N	\N	183684	183684	350891
23993	37031	14	applied	\N	\N	\N	\N	183707	183707	350914
23993	37089	31	applied	\N	\N	\N	\N	183724	183724	350931
23993	37126	43	applied	\N	\N	\N	\N	183736	183736	350943
23993	37208	60	applied	\N	\N	\N	\N	183753	183753	350960
23993	37153	63	applied	\N	\N	\N	\N	183756	183756	350963
23993	37156	66	applied	\N	\N	\N	\N	183759	183759	350966
23993	37196	83	applied	\N	\N	\N	\N	183776	183776	350983
23993	37052	100	applied	\N	\N	\N	\N	183793	183793	351000
24003	37232	1	applied	\N	\N	\N	\N	183854	183854	351061
24011	37244	0	applied	\N	\N	\N	\N	183881	183881	351088
24019	37264	2	applied	\N	\N	\N	\N	183902	183902	351109
24020	37262	0	applied	\N	\N	\N	\N	183904	183904	351111
24025	37275	0	applied	\N	\N	\N	\N	183927	183927	351134
24027	37291	10	applied	\N	\N	\N	\N	183949	183949	351156
24027	37292	11	applied	\N	\N	\N	\N	183950	183950	351157
24031	37296	0	applied	\N	\N	\N	\N	183960	183960	351167
24032	37298	2	applied	\N	\N	\N	\N	183965	183965	351172
24042	37310	0	applied	\N	\N	\N	\N	183989	183989	351196
24047	37326	5	applied	\N	\N	\N	\N	184008	184008	351215
24049	37329	2	applied	\N	\N	\N	\N	184016	184016	351223
24061	37347	1	applied	\N	\N	\N	\N	184052	184052	351259
24063	37296	30	applied	\N	\N	\N	\N	184085	184085	351292
24063	37338	45	applied	\N	\N	\N	\N	184100	184100	351307
24063	37344	48	applied	\N	\N	\N	\N	184103	184103	351310
24063	37017	82	applied	\N	\N	\N	\N	184137	184137	351344
24063	37080	99	applied	\N	\N	\N	\N	184154	184154	351361
24063	37128	116	applied	\N	\N	\N	\N	184171	184171	351378
24068	37357	3	applied	\N	\N	\N	\N	184195	184195	351402
24070	37368	2	applied	\N	\N	\N	\N	184206	184206	351413
24070	37369	3	applied	\N	\N	\N	\N	184207	184207	351414
24075	37374	0	applied	\N	\N	\N	\N	184216	184216	351423
24079	37380	0	applied	\N	\N	\N	\N	184228	184228	351435
24079	37383	3	applied	\N	\N	\N	\N	184231	184231	351438
24084	37392	0	applied	\N	\N	\N	\N	184244	184244	351451
24086	37396	3	applied	\N	\N	\N	\N	184250	184250	351457
24091	37403	0	applied	\N	\N	\N	\N	184281	184281	351488
24093	37407	0	applied	\N	\N	\N	\N	184285	184285	351492
24105	37419	1	applied	\N	\N	\N	\N	184311	184311	351518
24117	37426	0	applied	\N	\N	\N	\N	184321	184321	351528
24118	37431	4	applied	\N	\N	\N	\N	184326	184326	351533
24127	37449	0	applied	\N	\N	\N	\N	184362	184362	351569
24128	37449	0	applied	\N	\N	\N	\N	184364	184364	351571
24135	37467	0	applied	\N	\N	\N	\N	184394	184394	351601
24142	37484	1	applied	\N	\N	\N	\N	184415	184415	351622
24144	37133	5	applied	\N	\N	\N	\N	184427	184427	351634
24144	37205	22	applied	\N	\N	\N	\N	184444	184444	351651
24144	37245	39	applied	\N	\N	\N	\N	184461	184461	351668
24144	37158	56	applied	\N	\N	\N	\N	184478	184478	351685
24144	37198	73	applied	\N	\N	\N	\N	184495	184495	351702
24144	37276	74	applied	\N	\N	\N	\N	184496	184496	351703
24144	37282	77	applied	\N	\N	\N	\N	184499	184499	351706
24144	37340	94	applied	\N	\N	\N	\N	184516	184516	351723
24148	37376	14	applied	\N	\N	\N	\N	184548	184548	351755
24148	37411	31	applied	\N	\N	\N	\N	184565	184565	351772
24148	37451	48	applied	\N	\N	\N	\N	184582	184582	351789
24152	37491	3	applied	\N	\N	\N	\N	184591	184591	351798
24157	37501	1	applied	\N	\N	\N	\N	184609	184609	351816
24163	37509	5	applied	\N	\N	\N	\N	184625	184625	351832
24165	37512	0	applied	\N	\N	\N	\N	184636	184636	351843
24175	37535	0	applied	\N	\N	\N	\N	184676	184676	351883
24177	37537	0	applied	\N	\N	\N	\N	184680	184680	351887
24187	37458	22	applied	\N	\N	\N	\N	184729	184729	351936
24189	37559	1	applied	\N	\N	\N	\N	184742	184742	351949
24193	37559	1	applied	\N	\N	\N	\N	184750	184750	351957
24195	37561	1	applied	\N	\N	\N	\N	184755	184755	351962
24195	37562	2	applied	\N	\N	\N	\N	184756	184756	351963
24201	33609	8	applied	\N	\N	\N	\N	184786	184786	351993
24201	37534	25	applied	\N	\N	\N	\N	184803	184803	352010
24202	37582	2	applied	\N	\N	\N	\N	184811	184811	352018
24204	37584	1	applied	\N	\N	\N	\N	184816	184816	352023
24207	37587	4	applied	\N	\N	\N	\N	184837	184837	352044
24214	37600	1	applied	\N	\N	\N	\N	184867	184867	352074
24226	37620	2	applied	\N	\N	\N	\N	184907	184907	352114
24232	37623	1	applied	\N	\N	\N	\N	184929	184929	352136
24235	37630	2	applied	\N	\N	\N	\N	184939	184939	352146
24239	37518	11	applied	\N	\N	\N	\N	184961	184961	352168
24240	37638	1	applied	\N	\N	\N	\N	184964	184964	352171
24241	37638	1	applied	\N	\N	\N	\N	184967	184967	352174
24250	37662	2	applied	\N	\N	\N	\N	185019	185019	352226
24251	37660	0	applied	\N	\N	\N	\N	185024	185024	352231
24257	37677	2	applied	\N	\N	\N	\N	185049	185049	352256
24258	37679	4	applied	\N	\N	\N	\N	185064	185064	352271
24262	37694	2	applied	\N	\N	\N	\N	185086	185086	352293
24265	37695	0	applied	\N	\N	1000000000	\N	185097	185097	352304
24269	37714	1	applied	\N	\N	\N	\N	185131	185131	352338
24270	37715	2	applied	\N	\N	\N	\N	185136	185136	352343
24272	37720	3	applied	\N	\N	\N	\N	185145	185145	352352
24273	37719	2	applied	\N	\N	\N	\N	185148	185148	352355
24291	37735	0	applied	\N	\N	\N	\N	185196	185196	352403
24293	37739	0	applied	\N	\N	\N	\N	185203	185203	352410
24296	37743	1	applied	\N	\N	\N	\N	185218	185218	352425
24297	37670	4	applied	\N	\N	\N	\N	185231	185231	352438
24300	37761	3	applied	\N	\N	\N	\N	185250	185250	352457
24306	37769	5	applied	\N	\N	\N	\N	185274	185274	352481
24312	37778	0	applied	\N	\N	\N	\N	185300	185300	352507
24315	37791	4	applied	\N	\N	\N	\N	185329	185329	352536
24316	37796	2	applied	\N	\N	\N	\N	185334	185334	352541
24317	37800	3	applied	\N	\N	\N	\N	185338	185338	352545
24318	37804	0	applied	\N	\N	\N	\N	185342	185342	352549
24319	37821	11	applied	\N	\N	\N	\N	185359	185359	352566
24320	37814	4	applied	\N	\N	\N	\N	185365	185365	352572
24323	37832	5	applied	\N	\N	\N	\N	185390	185390	352595
24322	37829	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	185380	185380	\N
24324	37831	4	applied	\N	\N	\N	\N	185396	185396	352600
24326	37843	2	applied	\N	\N	\N	\N	185406	185406	352610
24329	37842	1	applied	\N	\N	\N	\N	185414	185414	352618
24332	37856	8	applied	\N	\N	\N	\N	185439	185439	352643
24337	37859	0	applied	\N	\N	\N	\N	185478	185478	352682
24338	37862	0	applied	\N	\N	\N	\N	185481	185481	352685
24348	37883	0	applied	\N	\N	\N	\N	185514	185514	352718
24350	37888	2	applied	\N	\N	\N	\N	185525	185525	352729
24365	37908	2	applied	\N	\N	\N	\N	185563	185563	352767
24366	37914	3	applied	\N	\N	\N	\N	185569	185569	352773
24370	37923	4	applied	\N	\N	\N	\N	185588	185588	352792
24378	37911	1	applied	\N	\N	\N	\N	185607	185607	352811
24378	37907	4	applied	\N	\N	\N	\N	185610	185610	352814
24378	37918	21	applied	\N	\N	\N	\N	185627	185627	352831
24382	37941	2	applied	\N	\N	\N	\N	185643	185643	352847
24386	37946	3	applied	\N	\N	\N	\N	185662	185662	352866
24388	37951	1	applied	\N	\N	\N	\N	185669	185669	352873
24391	37954	2	applied	\N	\N	\N	\N	185676	185676	352880
24396	37920	13	applied	\N	\N	\N	\N	185702	185702	352906
24396	37898	30	applied	\N	\N	\N	\N	185719	185719	352923
24396	37930	45	applied	\N	\N	\N	\N	185734	185734	352938
24398	37958	1	applied	\N	\N	\N	\N	185753	185753	352957
24401	37962	0	applied	\N	\N	\N	\N	185760	185760	352964
24407	37972	0	applied	\N	\N	\N	\N	185775	185775	352979
24418	37999	0	applied	\N	\N	\N	\N	185808	185808	353012
24420	37965	4	applied	\N	\N	\N	\N	185816	185816	353020
24420	37976	22	applied	\N	\N	\N	\N	185833	185833	353037
24420	37998	39	applied	\N	\N	\N	\N	185850	185850	353054
24421	37713	6	applied	\N	\N	\N	\N	185865	185865	353069
24421	37766	23	applied	\N	\N	\N	\N	185882	185882	353086
24421	37850	46	applied	\N	\N	\N	\N	185905	185905	353109
24421	37901	63	applied	\N	\N	\N	\N	185922	185922	353126
24421	37917	69	applied	\N	\N	\N	\N	185928	185928	353132
24421	37944	82	applied	\N	\N	\N	\N	185940	185940	353144
24421	37988	99	applied	\N	\N	\N	\N	185957	185957	353161
24421	37730	116	applied	\N	\N	\N	\N	185974	185974	353177
24429	38017	0	applied	\N	\N	\N	\N	186014	186014	353217
24430	38017	0	applied	\N	\N	\N	\N	186017	186017	353220
24431	38019	2	applied	\N	\N	\N	\N	186022	186022	353225
24440	38036	1	applied	\N	\N	\N	\N	186049	186049	353252
24443	38038	3	applied	\N	\N	\N	\N	186063	186063	353266
24447	38042	1	applied	\N	\N	\N	\N	186078	186078	353281
24448	38046	2	applied	\N	\N	\N	\N	186082	186082	353285
24456	38055	1	applied	\N	\N	\N	\N	186109	186109	353312
24465	38079	6	applied	\N	\N	\N	\N	186143	186143	353346
24466	38081	0	applied	\N	\N	\N	\N	186145	186145	353348
24467	38083	2	applied	\N	\N	\N	\N	186150	186150	353353
24472	38086	0	applied	\N	\N	\N	\N	186160	186160	353363
24472	38087	1	applied	\N	\N	\N	\N	186161	186161	353364
24484	38101	1	applied	\N	\N	\N	\N	186187	186187	353390
24490	38117	1	applied	\N	\N	\N	\N	186207	186207	353410
24492	38121	1	applied	\N	\N	\N	\N	186213	186213	353416
24498	38129	3	applied	\N	\N	\N	\N	186233	186233	353436
24502	37932	3	applied	\N	\N	\N	\N	186246	186246	353449
24502	37670	20	applied	\N	\N	\N	\N	186263	186263	353466
24502	37615	54	applied	\N	\N	\N	\N	186297	186297	353500
24502	37625	57	applied	\N	\N	\N	\N	186300	186300	353503
24502	37634	60	applied	\N	\N	\N	\N	186303	186303	353506
24502	37697	77	applied	\N	\N	\N	\N	186320	186320	353523
24502	37753	94	applied	\N	\N	\N	\N	186337	186337	353540
24502	37810	111	applied	\N	\N	\N	\N	186354	186354	353557
24510	38149	1	applied	\N	\N	\N	\N	186384	186384	353587
24512	38151	1	applied	\N	\N	\N	\N	186388	186388	353591
24513	38152	2	applied	\N	\N	\N	\N	186394	186394	353597
24514	37850	16	applied	\N	\N	\N	\N	186413	186413	353616
24514	37901	33	applied	\N	\N	\N	\N	186430	186430	353633
24514	37939	48	applied	\N	\N	\N	\N	186445	186445	353648
24514	37982	66	applied	\N	\N	\N	\N	186462	186462	353665
24514	38010	80	applied	\N	\N	\N	\N	186476	186476	353679
24514	38037	90	applied	\N	\N	\N	\N	186486	186486	353689
24514	38078	107	applied	\N	\N	\N	\N	186503	186503	353706
24517	37695	6	applied	\N	\N	1000000000	\N	186542	186542	353745
24517	37708	27	applied	\N	\N	\N	\N	186563	186563	353765
24525	37911	1	applied	\N	\N	\N	\N	186581	186581	353783
24525	37765	18	applied	\N	\N	\N	\N	186598	186598	353800
24525	37813	35	applied	\N	\N	\N	\N	186615	186615	353817
24525	37883	53	applied	\N	\N	\N	\N	186632	186632	353834
24525	37927	70	applied	\N	\N	\N	\N	186649	186649	353851
24525	37988	95	applied	\N	\N	\N	\N	186674	186674	353876
24223	37617	2	applied	\N	\N	\N	\N	184897	184897	352104
24525	38044	119	applied	\N	\N	\N	\N	186698	186698	353900
24527	38152	28	applied	\N	\N	\N	\N	186735	186735	353937
24527	38053	32	applied	\N	\N	\N	\N	186739	186739	353941
24527	38060	35	applied	\N	\N	\N	\N	186742	186742	353944
24527	38103	52	applied	\N	\N	\N	\N	186759	186759	353961
24527	38142	69	applied	\N	\N	\N	\N	186776	186776	353978
24534	38178	0	applied	\N	\N	\N	\N	186802	186802	354004
24535	38171	4	applied	\N	\N	\N	\N	186810	186810	354012
24538	38182	0	applied	\N	\N	\N	\N	186826	186826	354028
24541	38193	2	applied	\N	\N	\N	\N	186849	186849	354051
24547	38197	2	applied	\N	\N	\N	\N	186857	186857	354059
24549	38201	1	applied	\N	\N	\N	\N	186863	186863	354065
24555	38205	1	applied	\N	\N	\N	\N	186873	186873	354075
24557	37921	21	applied	\N	\N	\N	\N	186903	186903	354105
24557	37962	38	applied	\N	\N	\N	\N	186920	186920	354122
24557	37970	42	applied	\N	\N	\N	\N	186924	186924	354126
24557	37982	45	applied	\N	\N	\N	\N	186927	186927	354129
24557	38058	79	applied	\N	\N	\N	\N	186961	186961	354163
24557	38102	96	applied	\N	\N	\N	\N	186978	186978	354180
24557	38141	113	applied	\N	\N	\N	\N	186995	186995	354197
24568	38226	3	applied	\N	\N	\N	\N	187035	187035	354237
24571	38227	0	applied	\N	\N	\N	\N	187044	187044	354246
24572	38230	0	applied	\N	\N	\N	\N	187047	187047	354249
24573	38232	2	applied	\N	\N	\N	\N	187058	187058	354260
24576	38243	2	applied	\N	\N	\N	\N	187071	187071	354273
24580	38249	1	applied	\N	\N	\N	\N	187080	187080	354282
24585	38266	6	applied	\N	\N	\N	\N	187118	187118	354320
24586	38264	3	applied	\N	\N	\N	\N	187123	187123	354325
24593	38277	1	applied	\N	\N	\N	\N	187152	187152	354354
24599	38286	0	applied	\N	\N	\N	\N	187173	187173	354375
24601	38287	0	applied	\N	\N	\N	\N	187177	187177	354379
24607	38304	2	applied	\N	\N	\N	\N	187199	187199	354401
24613	38307	2	applied	\N	\N	\N	\N	187217	187217	354419
24617	38324	16	applied	\N	\N	\N	\N	187242	187242	354444
24618	38319	11	applied	\N	\N	\N	\N	187254	187254	354456
24618	38322	14	applied	\N	\N	\N	\N	187257	187257	354459
24621	38329	1	applied	\N	\N	\N	\N	187267	187267	354469
24631	38345	0	applied	\N	\N	\N	\N	187306	187306	354508
24632	38346	1	applied	\N	\N	\N	\N	187310	187310	354512
24633	38348	0	applied	\N	\N	\N	\N	187312	187312	354514
24639	38365	7	applied	\N	\N	\N	\N	187345	187345	354546
24640	38359	1	applied	\N	\N	\N	\N	187347	187347	354548
24641	38359	1	applied	\N	\N	\N	\N	187355	187355	354555
24643	38358	8	applied	\N	\N	\N	\N	187378	187378	354576
24643	37921	25	applied	\N	\N	\N	\N	187395	187395	354593
24643	37962	42	applied	\N	\N	\N	\N	187412	187412	354610
24643	38004	59	applied	\N	\N	\N	\N	187429	187429	354627
24643	38005	60	applied	\N	\N	\N	\N	187430	187430	354628
24643	38010	63	applied	\N	\N	\N	\N	187433	187433	354631
24643	38095	98	applied	\N	\N	\N	\N	187467	187467	354665
24643	38134	115	applied	\N	\N	\N	\N	187484	187484	354682
24647	38373	3	applied	\N	\N	\N	\N	187510	187510	354708
24651	38376	2	applied	\N	\N	\N	\N	187525	187525	354723
24653	38376	2	applied	\N	\N	\N	\N	187533	187533	354731
24655	38380	2	applied	\N	\N	\N	\N	187541	187541	354739
24661	38398	2	applied	\N	\N	\N	\N	187565	187565	354763
24670	38405	0	applied	\N	\N	\N	\N	187590	187590	354788
24675	38422	1	applied	\N	\N	\N	\N	187615	187615	354813
24676	38427	3	applied	\N	\N	\N	\N	187620	187620	354818
24679	38432	1	applied	\N	\N	\N	\N	187629	187629	354827
24681	38449	11	applied	\N	\N	\N	\N	187646	187646	354844
24684	38456	3	applied	\N	\N	\N	\N	187664	187664	354862
24685	38458	5	applied	\N	\N	\N	\N	187676	187676	354874
24692	38473	2	applied	\N	\N	\N	\N	187712	187712	354910
24692	38476	5	applied	\N	\N	\N	\N	187715	187715	354913
24700	38483	1	applied	\N	\N	\N	\N	187753	187753	354951
24702	38497	0	applied	\N	\N	\N	\N	187767	187767	354965
24702	38512	15	applied	\N	\N	\N	\N	187782	187782	354980
24702	38515	18	applied	\N	\N	\N	\N	187785	187785	354983
24703	38511	14	applied	\N	\N	\N	\N	187808	187808	355006
24704	38501	4	applied	\N	\N	\N	\N	187825	187825	355023
24704	38518	21	applied	\N	\N	\N	\N	187842	187842	355040
24705	38505	8	applied	\N	\N	\N	\N	187856	187856	355054
24705	38522	25	applied	\N	\N	\N	\N	187873	187873	355071
24710	38544	3	applied	\N	\N	\N	\N	187906	187906	355104
24711	38554	5	applied	\N	\N	\N	\N	187916	187916	355114
24712	38552	3	applied	\N	\N	\N	\N	187921	187921	355119
24712	38555	6	applied	\N	\N	\N	\N	187924	187924	355122
24716	38564	5	applied	\N	\N	\N	\N	187947	187947	355145
24719	38580	7	applied	\N	\N	\N	\N	187970	187970	355168
24720	38577	4	applied	\N	\N	\N	\N	187975	187975	355173
24721	38576	3	applied	\N	\N	\N	\N	187982	187982	355180
24723	38593	18	applied	\N	\N	\N	\N	188005	188005	355203
24723	38608	35	applied	\N	\N	\N	\N	188022	188022	355220
24723	38614	41	applied	\N	\N	\N	\N	188028	188028	355226
24723	38615	42	applied	\N	\N	\N	\N	188029	188029	355227
24724	38586	11	applied	\N	\N	\N	\N	188042	188042	355240
24724	38615	42	applied	\N	\N	\N	\N	188073	188073	355271
24725	38590	15	applied	\N	\N	\N	\N	188090	188090	355288
24725	38607	32	applied	\N	\N	\N	\N	188107	188107	355305
24726	38622	5	applied	\N	\N	\N	\N	188124	188124	355322
24726	38630	13	applied	\N	\N	\N	\N	188132	188132	355330
24726	38633	16	applied	\N	\N	\N	\N	188135	188135	355333
24734	38650	0	applied	\N	\N	\N	\N	188155	188155	355353
24737	38659	2	applied	\N	\N	\N	\N	188179	188179	355377
24740	38676	4	applied	\N	\N	\N	\N	188204	188204	355402
24741	38688	16	applied	\N	\N	\N	\N	188234	188234	355432
24744	38694	4	applied	\N	\N	\N	\N	188266	188266	355464
24745	38692	2	applied	\N	\N	\N	\N	188272	188272	355470
24747	38703	5	applied	\N	\N	\N	\N	188291	188291	355489
24751	38721	3	applied	\N	\N	\N	\N	188317	188317	355515
24753	38728	2	applied	\N	\N	\N	\N	188328	188328	355526
24759	38739	6	applied	\N	\N	\N	\N	188350	188350	355548
24761	38738	5	applied	\N	\N	\N	\N	188361	188361	355559
24763	38740	0	applied	\N	\N	\N	\N	188370	188370	355568
24765	38754	5	applied	\N	\N	\N	\N	188391	188391	355589
24767	38758	1	applied	\N	\N	\N	\N	188398	188398	355596
24771	38765	2	applied	\N	\N	\N	\N	188411	188411	355609
24778	38776	0	applied	\N	\N	\N	\N	188431	188431	355629
24779	38781	5	applied	\N	\N	\N	\N	188442	188442	355640
24781	38744	16	applied	\N	\N	\N	\N	188463	188463	355660
24525	38037	116	applied	\N	\N	\N	\N	186695	186695	353897
24782	38788	2	applied	\N	\N	\N	\N	188504	188504	355701
24784	38794	5	applied	\N	\N	\N	\N	188510	188510	355707
24792	38828	8	applied	\N	\N	\N	\N	188548	188548	355745
24795	38833	3	applied	\N	\N	\N	\N	188567	188567	355764
24799	38845	2	applied	\N	\N	\N	\N	188583	188583	355780
24801	38854	3	applied	\N	\N	\N	\N	188592	188592	355789
24807	38865	0	applied	\N	\N	\N	\N	188617	188617	355814
24810	38493	14	applied	\N	\N	\N	\N	188640	188640	355837
24810	38515	31	applied	\N	\N	\N	\N	188657	188657	355854
24810	38549	48	applied	\N	\N	\N	\N	188674	188674	355871
24810	38586	65	applied	\N	\N	\N	\N	188691	188691	355888
24810	38603	82	applied	\N	\N	\N	\N	188708	188708	355905
24810	38606	85	applied	\N	\N	\N	\N	188711	188711	355908
24810	38618	88	applied	\N	\N	\N	\N	188714	188714	355911
24810	38653	105	applied	\N	\N	\N	\N	188731	188731	355928
24811	38870	1	applied	\N	\N	\N	\N	188739	188739	355936
24815	38740	0	applied	\N	\N	\N	\N	188757	188757	355954
24815	38712	17	applied	\N	\N	\N	\N	188774	188774	355971
24815	38743	34	applied	\N	\N	\N	\N	188791	188791	355988
24815	38790	48	applied	\N	\N	\N	\N	188805	188805	356002
24815	38852	65	applied	\N	\N	\N	\N	188822	188822	356019
24815	38728	80	applied	\N	\N	\N	\N	188837	188837	356034
24815	38729	115	applied	\N	\N	\N	\N	188871	188871	356068
24822	38900	0	applied	\N	\N	\N	\N	188924	188924	356119
24820	38890	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	188901	188901	\N
24821	38890	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	188914	188914	\N
24822	38901	1	applied	\N	\N	\N	\N	188925	188925	356120
24823	38902	2	applied	\N	\N	\N	\N	188929	188929	356124
24826	38910	7	applied	\N	\N	\N	\N	188948	188948	356143
24829	38912	1	applied	\N	\N	\N	\N	188961	188961	356156
24831	38911	0	applied	\N	\N	\N	\N	188966	188966	356161
24834	38919	2	applied	\N	\N	\N	\N	188976	188976	356171
24836	38931	4	applied	\N	\N	\N	\N	188988	188988	356183
24842	38944	0	applied	\N	\N	\N	\N	189028	189028	356223
24849	38961	7	applied	\N	\N	\N	\N	189054	189054	356249
24851	38976	5	applied	\N	\N	\N	\N	189069	189069	356264
24855	38985	0	applied	\N	\N	\N	\N	189081	189081	356276
24859	38997	2	applied	\N	\N	\N	\N	189107	189107	356302
24862	39006	3	applied	\N	\N	\N	\N	189132	189132	356324
24864	39016	1	applied	\N	\N	\N	\N	189142	189142	356333
24866	39017	1	applied	\N	\N	\N	\N	189148	189148	356339
24871	39019	2	applied	\N	\N	1000000000	\N	189159	189159	356350
24879	39042	0	applied	\N	\N	\N	\N	189196	189196	356387
24880	39046	1	applied	\N	\N	\N	\N	189200	189200	356391
24888	39059	1	applied	\N	\N	\N	\N	189226	189226	356417
24889	39058	0	applied	\N	\N	\N	\N	189228	189228	356419
24897	39081	3	applied	\N	\N	\N	\N	189266	189266	356455
24898	39082	0	applied	\N	\N	\N	\N	189267	189267	356456
24903	39095	3	applied	\N	\N	\N	\N	189294	189294	356483
24909	39105	0	applied	\N	\N	\N	\N	189315	189315	356504
24914	39110	2	applied	\N	\N	\N	\N	189332	189332	356521
24919	39115	0	applied	\N	\N	\N	\N	189347	189347	356536
24920	39118	0	applied	\N	\N	\N	\N	189350	189350	356539
24924	39126	0	applied	\N	\N	\N	\N	189367	189367	356556
24930	38978	0	applied	\N	\N	1000000000	\N	189401	189401	356590
24930	38866	8	applied	\N	\N	\N	\N	189409	189409	356598
24930	38810	25	applied	\N	\N	\N	\N	189426	189426	356615
24930	38873	42	applied	\N	\N	\N	\N	189443	189443	356632
24930	38929	59	applied	\N	\N	\N	\N	189460	189460	356649
24930	38965	69	applied	\N	\N	\N	\N	189470	189470	356659
24930	39003	79	applied	\N	\N	\N	\N	189480	189480	356669
24930	39064	96	applied	\N	\N	\N	\N	189497	189497	356686
24930	39121	113	applied	\N	\N	\N	\N	189514	189514	356703
24932	39134	0	applied	\N	\N	\N	\N	189526	189526	356714
24932	39135	1	applied	\N	\N	\N	\N	189527	189527	356715
24933	39138	0	applied	\N	\N	\N	\N	189530	189530	356718
24934	39138	0	applied	\N	\N	\N	\N	189533	189533	356721
24936	39114	15	applied	\N	\N	\N	\N	189553	189553	356741
24937	39143	2	applied	\N	\N	\N	\N	189571	189571	356759
24938	39145	1	applied	\N	\N	\N	\N	189573	189573	356761
24953	39139	10	applied	\N	\N	\N	\N	189611	189611	356799
24961	39172	1	applied	\N	\N	\N	\N	189650	189650	356838
24963	39175	1	applied	\N	\N	\N	\N	189661	189661	356849
24966	39195	7	applied	\N	\N	\N	\N	189681	189681	356869
24967	39199	2	applied	\N	\N	\N	\N	189685	189685	356873
24970	39206	1	applied	\N	\N	\N	\N	189695	189695	356883
24980	39222	1	applied	\N	\N	\N	\N	189737	189737	356925
24983	39226	2	applied	\N	\N	\N	\N	189748	189748	356936
24984	39224	0	applied	\N	\N	\N	\N	189751	189751	356939
24985	39225	1	applied	\N	\N	\N	\N	189757	189757	356945
24986	39236	8	applied	\N	\N	\N	\N	189767	189767	356955
24987	39238	10	applied	\N	\N	\N	\N	189780	189780	356968
24988	39111	14	applied	\N	\N	\N	\N	189795	189795	356983
24988	39174	33	applied	\N	\N	\N	\N	189814	189814	357002
24988	39229	50	applied	\N	\N	\N	\N	189831	189831	357019
24988	39104	68	applied	\N	\N	\N	\N	189848	189848	357036
24988	39165	104	applied	\N	\N	\N	\N	189884	189884	357072
24988	39222	121	applied	\N	\N	\N	\N	189901	189901	357089
24991	39251	2	applied	\N	\N	\N	\N	189928	189928	357116
24995	39230	2	applied	\N	\N	1000000000	\N	189938	189938	357126
24998	39253	0	applied	\N	\N	\N	\N	189973	189973	357159
24996	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	189963	189963	\N
25000	39260	1	applied	\N	\N	\N	\N	189987	189987	357172
25002	39268	1	applied	\N	\N	\N	\N	190002	190002	357187
25012	39288	3	applied	\N	\N	\N	\N	190038	190038	357221
25029	39310	1	applied	\N	\N	\N	\N	190089	190089	357272
25029	39311	2	applied	\N	\N	\N	\N	190090	190090	357273
25030	39309	0	applied	\N	\N	\N	\N	190093	190093	357276
25033	39316	0	applied	\N	\N	\N	\N	190102	190102	357285
25038	39117	11	applied	\N	\N	\N	\N	190125	190125	357306
25038	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	190116	190116	\N
25038	39126	14	applied	\N	\N	\N	\N	190128	190128	357309
25040	39321	0	applied	\N	\N	\N	\N	190147	190147	357328
25040	39322	1	applied	\N	\N	\N	\N	190148	190148	357329
25042	39323	0	applied	\N	\N	\N	\N	190150	190150	357331
25056	39354	0	applied	\N	\N	\N	\N	190188	190188	357369
25058	39368	3	applied	\N	\N	\N	\N	190202	190202	357383
25063	39374	2	applied	\N	\N	\N	\N	190218	190218	357399
24781	38513	41	applied	\N	\N	\N	\N	188487	188487	355684
25080	39417	5	applied	\N	\N	\N	\N	190290	190290	357471
25082	39425	0	applied	\N	\N	\N	\N	190301	190301	357482
25084	39437	6	applied	\N	\N	\N	\N	190313	190313	357494
25085	39438	7	applied	\N	\N	\N	\N	190327	190327	357508
25089	39452	4	applied	\N	\N	\N	\N	190353	190353	357534
25093	39456	3	applied	\N	\N	\N	\N	190369	190369	357550
25096	39460	2	applied	\N	\N	\N	\N	190378	190378	357559
25104	39431	5	applied	\N	\N	\N	\N	190404	190404	357585
25104	39456	22	applied	\N	\N	\N	\N	190421	190421	357602
25104	39442	39	applied	\N	\N	\N	\N	190438	190438	357619
25105	39462	1	applied	\N	\N	\N	\N	190446	190446	357627
25107	39465	0	applied	\N	\N	\N	\N	190452	190452	357633
25109	39470	8	applied	\N	\N	\N	\N	190475	190475	357656
25116	39490	0	applied	\N	\N	\N	\N	190500	190500	357681
25119	39495	5	applied	\N	\N	\N	\N	190523	190523	357704
25120	38903	13	applied	\N	\N	\N	\N	190537	190537	357718
25120	38956	30	applied	\N	\N	\N	\N	190554	190554	357735
25120	39020	47	applied	\N	\N	\N	\N	190571	190571	357752
25120	39021	48	applied	\N	\N	\N	\N	190572	190572	357753
25120	39039	51	applied	\N	\N	\N	\N	190575	190575	357756
25120	39093	68	applied	\N	\N	\N	\N	190592	190592	357773
25120	39149	86	applied	\N	\N	\N	\N	190609	190609	357790
25120	39208	103	applied	\N	\N	\N	\N	190626	190626	357807
25120	39261	120	applied	\N	\N	\N	\N	190643	190643	357824
25123	39496	0	applied	\N	\N	\N	\N	190654	190654	357835
25128	39511	2	applied	\N	\N	\N	\N	190673	190673	357854
25131	39518	2	applied	\N	\N	\N	\N	190683	190683	357864
25134	39516	0	applied	\N	\N	\N	\N	190702	190702	357883
25134	39519	3	applied	\N	\N	\N	\N	190705	190705	357886
25135	39522	6	applied	\N	\N	\N	\N	190715	190715	357896
25143	39530	1	applied	\N	\N	\N	\N	190738	190738	357919
25143	39531	2	applied	\N	\N	\N	\N	190739	190739	357920
25144	39533	1	applied	\N	\N	\N	\N	190741	190741	357922
25144	39534	2	applied	\N	\N	1000000000	\N	190742	190742	357923
25145	39538	2	applied	\N	\N	\N	\N	190746	190746	357927
25145	39539	3	applied	\N	\N	\N	\N	190747	190747	357928
25146	39541	1	applied	\N	\N	\N	\N	190749	190749	357930
25146	39542	2	applied	\N	\N	\N	\N	190750	190750	357931
25147	39541	1	applied	\N	\N	\N	\N	190752	190752	357933
25147	39542	2	applied	\N	\N	\N	\N	190753	190753	357934
25148	39540	0	applied	\N	\N	\N	\N	190754	190754	357935
25148	39541	1	applied	\N	\N	\N	\N	190755	190755	357936
25148	39542	2	applied	\N	\N	\N	\N	190756	190756	357937
25149	39543	0	applied	\N	\N	\N	\N	190757	190757	357938
25149	39544	1	applied	\N	\N	\N	\N	190758	190758	357939
25149	39545	2	applied	\N	\N	\N	\N	190759	190759	357940
25149	39547	4	applied	\N	\N	\N	\N	190761	190761	357942
25150	39516	3	applied	\N	\N	\N	\N	190765	190765	357946
25150	39517	4	applied	\N	\N	\N	\N	190766	190766	357947
25150	39523	5	applied	\N	\N	\N	\N	190767	190767	357948
25150	39526	6	applied	\N	\N	\N	\N	190768	190768	357949
25150	39529	7	applied	\N	\N	\N	\N	190769	190769	357950
25150	39532	8	applied	\N	\N	\N	\N	190770	190770	357951
25150	39537	9	applied	\N	\N	\N	\N	190771	190771	357952
25150	39540	10	applied	\N	\N	\N	\N	190772	190772	357953
25150	39543	11	applied	\N	\N	\N	\N	190773	190773	357954
25150	39507	12	applied	\N	\N	\N	\N	190774	190774	357955
25150	39510	13	applied	\N	\N	\N	\N	190775	190775	357956
25150	39534	14	applied	\N	\N	1000000000	\N	190776	190776	357957
25150	39508	15	applied	\N	\N	\N	\N	190777	190777	357958
25150	39515	16	applied	\N	\N	\N	\N	190778	190778	357959
25150	39521	17	applied	\N	\N	\N	\N	190779	190779	357960
25150	39525	19	applied	\N	\N	\N	\N	190781	190781	357962
25150	39527	20	applied	\N	\N	\N	\N	190782	190782	357963
25150	39531	21	applied	\N	\N	\N	\N	190783	190783	357964
25150	39533	22	applied	\N	\N	\N	\N	190784	190784	357965
25150	39519	38	applied	\N	\N	\N	\N	190800	190800	357981
25150	39535	39	applied	\N	\N	\N	\N	190801	190801	357982
25157	39560	4	applied	\N	\N	\N	\N	190835	190835	358016
25178	39601	2	applied	\N	\N	\N	\N	190924	190924	358105
25183	39601	16	applied	\N	\N	\N	\N	190944	190944	358125
25186	39608	6	applied	\N	\N	\N	\N	190986	190986	358167
25186	39611	9	applied	\N	\N	\N	\N	190989	190989	358170
25187	39613	3	applied	\N	\N	\N	\N	190994	190994	358175
25189	39616	0	applied	\N	\N	\N	\N	191010	191010	358191
25191	39624	3	applied	\N	\N	\N	\N	191024	191024	358205
25196	39631	1	applied	\N	\N	\N	\N	191043	191043	358224
25200	39579	36	applied	\N	\N	\N	\N	191095	191095	358276
25200	39608	70	applied	\N	\N	\N	\N	191129	191129	358310
25200	39469	73	applied	\N	\N	\N	\N	191132	191132	358313
25200	39545	90	applied	\N	\N	\N	\N	191149	191149	358330
25200	39527	107	applied	\N	\N	\N	\N	191166	191166	358347
25200	39591	124	applied	\N	\N	\N	\N	191183	191183	358364
25203	39641	0	applied	\N	\N	\N	\N	191199	191199	358380
25209	39665	0	applied	\N	\N	\N	\N	191226	191226	358406
25217	39686	2	applied	\N	\N	\N	\N	191256	191256	358436
25220	39688	0	applied	\N	\N	\N	\N	191265	191265	358445
25221	39693	2	applied	\N	\N	\N	\N	191270	191270	358450
25223	39696	1	applied	\N	\N	\N	\N	191277	191277	358457
25233	39707	1	applied	\N	\N	\N	\N	191316	191316	358496
25234	39708	2	applied	\N	\N	\N	\N	191322	191322	358502
25240	39712	1	applied	\N	\N	\N	\N	191344	191344	358524
25242	39723	0	applied	\N	\N	\N	\N	191355	191355	358535
25243	39596	8	applied	\N	\N	\N	\N	191366	191366	358546
25243	39668	28	applied	\N	\N	\N	\N	191386	191386	358566
25243	39702	45	applied	\N	\N	\N	\N	191403	191403	358583
25243	39612	62	applied	\N	\N	\N	\N	191420	191420	358599
25243	39680	78	applied	\N	\N	\N	\N	191436	191436	358615
25243	39721	81	applied	\N	\N	\N	\N	191439	191439	358618
25243	39621	98	applied	\N	\N	\N	\N	191456	191456	358635
25243	39679	116	applied	\N	\N	\N	\N	191473	191473	358652
25247	39726	0	applied	\N	\N	\N	\N	191504	191504	358683
25249	39736	0	applied	\N	\N	\N	\N	191514	191514	358693
25251	39750	1	applied	\N	\N	\N	\N	191528	191528	358707
25253	39756	4	applied	\N	\N	\N	\N	191544	191544	358723
25255	39763	1	applied	\N	\N	\N	\N	191555	191555	358734
25256	39767	1	applied	\N	\N	\N	\N	191559	191559	358738
25262	39778	3	applied	\N	\N	\N	\N	191582	191582	358761
25265	39789	8	applied	\N	\N	\N	\N	191597	191597	358776
25266	39783	2	applied	\N	\N	\N	\N	191608	191608	358787
25072	39405	2	applied	\N	\N	\N	\N	190254	190254	357435
25271	39709	43	applied	\N	\N	\N	\N	191692	191692	358871
25271	39741	60	applied	\N	\N	\N	\N	191709	191709	358888
25271	39780	75	applied	\N	\N	\N	\N	191724	191724	358903
25271	39794	78	applied	\N	\N	\N	\N	191727	191727	358906
25271	39761	95	applied	\N	\N	\N	\N	191744	191744	358923
25273	39816	2	applied	\N	\N	\N	\N	191764	191764	358943
25275	39823	2	applied	\N	\N	\N	\N	191771	191771	358950
25276	39822	1	applied	\N	\N	\N	\N	191774	191774	358953
25283	39838	4	applied	\N	\N	\N	\N	191812	191812	358991
25284	39835	1	applied	\N	\N	\N	\N	191815	191815	358994
25285	39837	3	applied	\N	\N	\N	\N	191823	191823	359002
25291	39754	9	applied	\N	\N	\N	\N	191849	191849	359028
25291	39728	38	applied	\N	\N	\N	\N	191878	191878	359057
25291	39745	55	applied	\N	\N	\N	\N	191895	191895	359074
25291	39771	62	applied	\N	\N	\N	\N	191902	191902	359081
25291	39780	65	applied	\N	\N	\N	\N	191905	191905	359084
25291	39836	82	applied	\N	\N	\N	\N	191922	191922	359101
25291	39671	99	applied	\N	\N	\N	\N	191939	191939	359118
25291	39734	117	applied	\N	\N	\N	\N	191956	191956	359135
25296	39534	2	applied	\N	\N	1000000000	\N	191981	191981	359160
25300	39868	2	applied	\N	\N	\N	\N	192007	192007	359185
25302	39870	1	applied	\N	\N	\N	\N	192012	192012	359190
25303	39873	1	applied	\N	\N	\N	\N	192015	192015	359193
25310	39888	5	applied	\N	\N	\N	\N	192033	192033	359211
25319	39893	1	applied	\N	\N	\N	\N	192065	192065	359243
25320	39895	3	applied	\N	\N	\N	\N	192071	192071	359249
25328	39921	3	applied	\N	\N	\N	\N	192115	192115	359293
25333	39928	3	applied	\N	\N	\N	\N	192132	192132	359310
25334	39927	4	applied	\N	\N	\N	\N	192137	192137	359315
25342	39935	2	applied	\N	\N	\N	\N	192171	192171	359349
25347	39950	5	applied	\N	\N	\N	\N	192194	192194	359372
25350	39952	1	applied	\N	\N	\N	\N	192206	192206	359384
25354	39955	0	applied	\N	\N	\N	\N	192215	192215	359393
25360	39966	0	applied	\N	\N	\N	\N	192237	192237	359415
25361	39978	2	applied	\N	\N	\N	\N	192249	192249	359427
25363	39981	1	applied	\N	\N	\N	\N	192256	192256	359434
25369	39991	1	applied	\N	\N	\N	\N	192282	192282	359460
25372	39997	0	applied	\N	\N	\N	\N	192291	192291	359469
25373	39998	1	applied	\N	\N	\N	\N	192295	192295	359473
25375	39990	6	applied	\N	\N	\N	\N	192308	192308	359486
25388	40015	0	applied	\N	\N	\N	\N	192348	192348	359526
25389	40017	2	applied	\N	\N	\N	\N	192353	192353	359531
25390	40016	1	applied	\N	\N	\N	\N	192355	192355	359533
25395	40025	2	applied	\N	\N	\N	\N	192375	192375	359553
25398	40025	0	applied	\N	\N	\N	\N	192387	192387	359565
25399	40029	1	applied	\N	\N	\N	\N	192391	192391	359569
25405	40000	7	applied	\N	\N	\N	\N	192440	192440	359618
25406	40045	4	applied	\N	\N	\N	\N	192448	192448	359626
25408	40056	1	applied	\N	\N	\N	\N	192459	192459	359637
25418	40064	2	applied	\N	\N	\N	\N	192492	192492	359670
25421	40068	0	applied	\N	\N	\N	\N	192505	192505	359683
25424	40075	0	applied	\N	\N	\N	\N	192514	192514	359692
25428	40031	2	applied	\N	\N	1000000000	\N	192533	192533	359711
25431	40087	6	applied	\N	\N	\N	\N	192555	192555	359733
25436	40095	0	applied	\N	\N	\N	\N	192569	192569	359747
25446	40106	2	applied	\N	\N	\N	\N	192597	192597	359775
25449	40108	0	applied	\N	\N	\N	\N	192610	192610	359788
25451	40117	3	applied	\N	\N	\N	\N	192623	192623	359801
25454	40121	2	applied	\N	\N	\N	\N	192632	192632	359810
25457	40123	1	applied	\N	\N	\N	\N	192639	192639	359817
25457	40124	2	applied	\N	\N	\N	\N	192640	192640	359818
25463	40132	2	applied	\N	\N	\N	\N	192656	192656	359834
25467	40144	1	applied	\N	\N	\N	\N	192671	192671	359849
25476	40149	0	applied	\N	\N	\N	\N	192699	192699	359877
25486	40166	1	applied	\N	\N	\N	\N	192730	192730	359908
25487	40169	1	applied	\N	\N	\N	\N	192733	192733	359911
25494	40179	5	applied	\N	\N	\N	\N	192759	192759	359937
25499	40181	1	applied	\N	\N	\N	\N	192773	192773	359951
25502	40189	0	applied	\N	\N	\N	\N	192781	192781	359959
25506	40196	1	applied	\N	\N	\N	\N	192794	192794	359972
25515	40204	0	applied	\N	\N	\N	\N	192820	192820	359998
25517	40204	0	applied	\N	\N	\N	\N	192826	192826	360004
25519	40207	0	applied	\N	\N	\N	\N	192832	192832	360010
25520	40207	0	applied	\N	\N	\N	\N	192835	192835	360013
25529	40226	8	applied	\N	\N	\N	\N	192869	192869	360047
25530	40219	1	applied	\N	\N	\N	\N	192871	192871	360049
25530	40222	4	applied	\N	\N	\N	\N	192874	192874	360052
25537	40239	0	applied	\N	\N	\N	\N	192897	192897	360075
25545	40260	2	applied	\N	\N	\N	\N	192924	192924	360102
25551	40201	1	applied	\N	\N	\N	\N	192941	192941	360119
25551	40252	18	applied	\N	\N	\N	\N	192958	192958	360136
25551	40238	38	applied	\N	\N	\N	\N	192978	192978	360156
25551	40272	56	applied	\N	\N	\N	\N	192995	192995	360173
25551	40260	73	applied	\N	\N	\N	\N	193012	193012	360190
25556	40088	0	applied	\N	\N	\N	\N	193033	193033	360211
25556	40098	3	applied	\N	\N	\N	\N	193036	193036	360214
25556	40156	20	applied	\N	\N	\N	\N	193053	193053	360231
25556	40207	37	applied	\N	\N	\N	\N	193070	193070	360248
25556	40258	54	applied	\N	\N	\N	\N	193087	193087	360265
25556	40096	70	applied	\N	\N	\N	\N	193103	193103	360281
25556	40116	73	applied	\N	\N	\N	\N	193106	193106	360284
25556	40102	90	applied	\N	\N	\N	\N	193123	193123	360301
25556	40161	108	applied	\N	\N	\N	\N	193140	193140	360318
25556	40213	125	applied	\N	\N	\N	\N	193157	193157	360335
25560	40295	1	applied	\N	\N	\N	\N	193168	193168	360346
25568	40310	4	applied	\N	\N	\N	\N	193213	193213	360391
25569	40312	0	applied	\N	\N	\N	\N	193215	193215	360393
25574	40316	1	applied	\N	\N	\N	\N	193243	193243	360421
25574	40319	5	applied	\N	\N	\N	\N	193246	193246	360424
25575	40321	7	applied	\N	\N	\N	\N	193257	193257	360435
25576	40332	14	applied	\N	\N	\N	\N	193274	193274	360452
25581	40336	0	applied	\N	\N	\N	\N	193284	193284	360462
25587	40340	1	applied	\N	\N	\N	\N	193294	193294	360472
25590	40353	2	applied	\N	\N	\N	\N	193322	193322	360500
25596	40363	0	applied	\N	\N	\N	\N	193334	193334	360512
25600	40367	1	applied	\N	\N	\N	\N	193340	193340	360518
25606	40386	2	applied	\N	\N	\N	\N	193377	193377	360555
25608	40388	1	applied	\N	\N	\N	\N	193379	193379	360557
25613	40397	1	applied	\N	\N	\N	\N	193402	193402	360580
25619	40408	6	applied	\N	\N	\N	\N	193425	193425	360603
25271	39783	26	applied	\N	\N	\N	\N	191675	191675	358854
25630	40440	2	applied	\N	\N	\N	\N	193493	193493	360671
25631	40445	4	applied	\N	\N	\N	\N	193498	193498	360676
25632	40446	5	applied	\N	\N	\N	\N	193505	193505	360683
25635	40460	7	applied	\N	\N	\N	\N	193531	193531	360709
25640	40472	1	applied	\N	\N	\N	\N	193549	193549	360727
25643	40297	7	applied	\N	\N	\N	\N	193564	193564	360742
25643	40306	10	applied	\N	\N	\N	\N	193567	193567	360745
25643	40356	27	applied	\N	\N	\N	\N	193584	193584	360762
25643	40409	44	applied	\N	\N	\N	\N	193601	193601	360779
25643	40455	61	applied	\N	\N	\N	\N	193618	193618	360796
25643	40292	80	applied	\N	\N	\N	\N	193637	193637	360815
25643	40321	98	applied	\N	\N	\N	\N	193654	193654	360832
25643	40370	115	applied	\N	\N	\N	\N	193671	193671	360849
25647	40487	1	applied	\N	\N	\N	\N	193698	193698	360876
25650	40491	2	applied	\N	\N	1000000000	\N	193708	193708	360886
25655	40497	2	applied	\N	\N	\N	\N	193722	193722	360900
25659	40510	6	applied	\N	\N	\N	\N	193747	193747	360925
25661	40527	4	applied	\N	\N	\N	\N	193764	193764	360942
25667	40537	2	applied	\N	\N	\N	\N	193781	193781	360959
25671	40542	1	applied	\N	\N	\N	\N	193792	193792	360970
25675	40544	0	applied	\N	\N	\N	\N	193802	193802	360980
25680	40549	2	applied	\N	\N	\N	\N	193822	193822	361000
25680	40552	5	applied	\N	\N	\N	\N	193825	193825	361003
25682	40549	2	applied	\N	\N	\N	\N	193838	193838	361016
25683	40552	9	applied	\N	\N	\N	\N	193855	193855	361033
25685	40559	0	applied	\N	\N	\N	\N	193859	193859	361037
25693	40588	2	applied	\N	\N	\N	\N	193903	193903	361081
25699	40593	1	applied	\N	\N	\N	\N	193918	193918	361096
25709	40603	2	applied	\N	\N	\N	\N	193949	193949	361127
25710	40603	2	applied	\N	\N	\N	\N	193956	193956	361134
25712	40613	5	applied	\N	\N	\N	\N	193973	193973	361151
25713	40612	7	applied	\N	\N	\N	\N	193981	193981	361159
25717	40619	2	applied	\N	\N	\N	\N	194006	194006	361184
25723	40633	4	applied	\N	\N	\N	\N	194029	194029	361207
25724	40637	2	applied	\N	\N	\N	\N	194033	194033	361211
25727	40647	0	applied	\N	\N	\N	\N	194043	194043	361221
25734	40665	0	applied	\N	\N	\N	\N	194070	194070	361248
25736	40670	5	applied	\N	\N	\N	\N	194087	194087	361265
25738	40675	4	applied	\N	\N	\N	\N	194097	194097	194097
25741	40671	0	applied	\N	\N	\N	\N	194106	194106	361280
25745	40676	3	applied	\N	\N	\N	\N	194121	194121	361293
25752	40690	2	applied	\N	\N	\N	\N	194148	194148	361319
25760	40694	0	applied	\N	\N	\N	\N	194173	194173	361344
25771	40705	7	applied	\N	\N	\N	\N	194209	194209	361380
25772	40711	2	applied	\N	\N	\N	\N	194213	194213	361384
25773	40711	2	applied	\N	\N	\N	\N	194216	194216	361387
25779	40723	2	applied	\N	\N	\N	\N	194242	194242	361412
25784	40736	3	applied	\N	\N	\N	\N	194267	194267	361437
25790	40744	2	applied	\N	\N	1000000000	\N	194291	194291	361461
25792	40743	1	applied	\N	\N	\N	\N	194296	194296	361466
25793	40745	2	applied	\N	\N	\N	\N	194301	194301	361471
25794	40764	16	applied	\N	\N	\N	\N	194318	194318	361488
25795	40750	1	applied	\N	\N	\N	\N	194321	194321	361491
25795	40751	2	applied	\N	\N	\N	\N	194322	194322	361492
25802	40771	0	applied	\N	\N	\N	\N	194350	194350	361520
25807	40779	5	applied	\N	\N	\N	\N	194373	194373	361543
25812	40787	0	applied	\N	\N	\N	\N	194388	194388	361558
25815	40797	4	applied	\N	\N	\N	\N	194401	194401	361571
25816	40795	2	applied	\N	\N	\N	\N	194405	194405	361575
25819	40802	7	applied	\N	\N	\N	\N	194428	194428	361598
25820	40805	0	applied	\N	\N	\N	\N	194433	194433	361603
25824	40814	0	applied	\N	\N	\N	\N	194458	194458	361628
25825	40823	0	applied	\N	\N	\N	\N	194467	194467	361637
25829	40831	2	applied	\N	\N	1000000000	\N	194485	194485	361655
25837	40844	1	applied	\N	\N	\N	\N	194520	194520	361689
25842	40846	0	applied	\N	\N	\N	\N	194536	194536	361705
25846	40854	0	applied	\N	\N	\N	\N	194550	194550	361719
25848	40855	1	applied	\N	\N	\N	\N	194555	194555	361724
25855	40882	1	applied	\N	\N	\N	\N	194588	194588	361756
25860	40884	0	applied	\N	\N	\N	\N	194600	194600	361768
25862	40892	7	applied	\N	\N	\N	\N	194623	194623	361791
25863	40884	0	applied	\N	\N	\N	\N	194624	194624	361792
25865	40715	3	applied	\N	\N	\N	\N	194638	194638	361806
25865	40752	17	applied	\N	\N	\N	\N	194652	194652	361820
25865	40863	51	applied	\N	\N	\N	\N	194686	194686	361854
25865	40888	59	applied	\N	\N	\N	\N	194694	194694	361862
25865	40713	73	applied	\N	\N	\N	\N	194708	194708	361875
25865	40745	91	applied	\N	\N	\N	\N	194725	194725	361892
25865	40798	108	applied	\N	\N	\N	\N	194742	194742	361909
25865	40853	125	applied	\N	\N	\N	\N	194759	194759	361926
25870	40904	2	applied	\N	\N	\N	\N	194777	194777	361944
25873	40908	3	applied	\N	\N	\N	\N	194785	194785	361952
25876	40910	5	applied	\N	\N	\N	\N	194805	194805	361972
25877	40905	0	applied	\N	\N	\N	\N	194806	194806	361973
25879	40916	5	applied	\N	\N	\N	\N	194823	194823	361990
25895	40935	0	applied	\N	\N	\N	\N	194860	194860	362027
25896	40941	6	applied	\N	\N	\N	\N	194877	194877	362044
25901	40951	0	applied	\N	\N	\N	\N	194893	194893	362060
25907	40955	0	applied	\N	\N	\N	\N	194908	194908	362075
25908	40961	6	applied	\N	\N	\N	\N	194921	194921	362088
25925	40978	2	applied	\N	\N	\N	\N	194959	194959	362126
25931	40990	0	applied	\N	\N	\N	\N	194975	194975	362142
25932	40995	0	applied	\N	\N	\N	\N	194980	194980	362147
25938	41011	1	applied	\N	\N	\N	\N	195000	195000	362167
25941	41012	2	applied	\N	\N	\N	\N	195026	195026	362193
25942	41012	2	applied	\N	\N	\N	\N	195035	195035	362202
25946	41020	1	applied	\N	\N	\N	\N	195049	195049	362216
25953	41029	1	applied	\N	\N	\N	\N	195066	195066	362233
25955	41032	2	applied	\N	\N	\N	\N	195072	195072	362239
25959	41035	2	applied	\N	\N	\N	\N	195086	195086	362253
25964	41040	1	applied	\N	\N	\N	\N	195103	195103	362270
25966	41040	1	applied	\N	\N	\N	\N	195113	195113	362280
25974	41055	1	applied	\N	\N	\N	\N	195138	195138	362305
25985	41073	3	applied	\N	\N	\N	\N	195163	195163	362330
25986	41076	0	applied	\N	\N	\N	\N	195166	195166	362333
25988	41079	1	applied	\N	\N	\N	\N	195171	195171	362338
25995	41086	0	applied	\N	\N	\N	\N	195186	195186	362353
26002	40831	2	applied	\N	\N	1000000000	\N	195211	195211	362377
26006	41103	5	applied	\N	\N	\N	\N	195230	195230	362396
26013	41123	3	applied	\N	\N	\N	\N	195257	195257	362423
25626	40423	4	applied	\N	\N	\N	\N	193464	193464	360642
26014	40454	38	applied	\N	\N	\N	\N	195296	195296	362462
26014	40455	39	applied	\N	\N	\N	\N	195297	195297	362463
26014	40512	56	applied	\N	\N	\N	\N	195314	195314	362480
26014	40565	73	applied	\N	\N	\N	\N	195331	195331	362497
26014	40665	107	applied	\N	\N	\N	\N	195364	195364	362530
26014	40666	108	applied	\N	\N	\N	\N	195365	195365	362531
26014	40721	125	applied	\N	\N	\N	\N	195382	195382	362548
26025	41134	0	applied	\N	\N	\N	\N	195404	195404	362570
26033	40728	8	applied	\N	\N	\N	\N	195424	195424	362590
26033	40784	25	applied	\N	\N	\N	\N	195441	195441	362607
26033	40836	42	applied	\N	\N	\N	\N	195458	195458	362624
26033	40888	59	applied	\N	\N	\N	\N	195475	195475	362641
26033	40931	77	applied	\N	\N	\N	\N	195492	195492	362658
26033	40967	94	applied	\N	\N	\N	\N	195509	195509	362675
26033	40974	97	applied	\N	\N	\N	\N	195512	195512	362678
26033	41009	114	applied	\N	\N	\N	\N	195529	195529	362695
26037	41143	1	applied	\N	\N	\N	\N	195544	195544	362710
26039	41145	3	applied	\N	\N	\N	\N	195554	195554	362720
26049	41166	8	applied	\N	\N	\N	\N	195583	195583	362749
26051	41179	0	applied	\N	\N	\N	\N	195596	195596	362762
26053	41186	7	applied	\N	\N	\N	\N	195615	195615	362781
26060	41158	0	applied	\N	\N	\N	\N	195640	195640	362806
26060	41179	12	applied	\N	\N	\N	\N	195652	195652	362818
26060	41152	29	applied	\N	\N	\N	\N	195669	195669	362835
26060	41145	46	applied	\N	\N	\N	\N	195686	195686	362852
26061	41209	8	applied	\N	\N	\N	\N	195711	195711	362877
26063	41212	0	applied	\N	\N	\N	\N	195718	195718	362884
26064	41218	2	applied	\N	\N	\N	\N	195724	195724	362890
26065	41235	4	applied	\N	\N	\N	\N	195741	195741	362907
26067	41241	1	applied	\N	\N	\N	\N	195756	195756	362922
26067	41244	4	applied	\N	\N	\N	\N	195759	195759	362925
26069	41247	1	applied	\N	\N	\N	\N	195768	195768	362934
26072	41255	1	applied	\N	\N	\N	\N	195786	195786	362952
26076	41260	0	applied	\N	\N	\N	\N	195795	195795	362961
26084	41268	2	applied	\N	\N	\N	\N	195813	195813	362979
26096	41158	1	applied	\N	\N	\N	\N	195842	195842	363008
26096	41173	35	applied	\N	\N	\N	\N	195876	195876	363042
26096	41134	52	applied	\N	\N	\N	\N	195893	195893	363059
26096	41189	69	applied	\N	\N	\N	\N	195910	195910	363076
26096	41247	86	applied	\N	\N	\N	\N	195927	195927	363093
26096	41278	102	applied	\N	\N	\N	\N	195942	195942	363108
26096	41284	105	applied	\N	\N	\N	\N	195945	195945	363111
26096	41139	122	applied	\N	\N	\N	\N	195962	195962	363128
26101	41301	3	applied	\N	\N	\N	\N	195978	195978	363144
26107	40948	0	applied	\N	\N	1000000000	\N	195995	195995	363161
26107	41209	19	applied	\N	\N	\N	\N	196014	196014	363180
26107	41176	34	applied	\N	\N	\N	\N	196029	196029	363195
26107	41183	40	applied	\N	\N	\N	\N	196035	196035	363201
26107	40763	57	applied	\N	\N	\N	\N	196052	196052	363217
26115	41315	1	applied	\N	\N	\N	\N	196068	196068	363233
26116	41316	0	applied	\N	\N	\N	\N	196069	196069	363234
26129	41342	0	applied	\N	\N	\N	\N	196103	196103	363268
26142	41357	1	applied	\N	\N	\N	\N	196132	196132	363297
26149	41358	8	applied	\N	\N	\N	\N	196159	196159	363324
26149	41359	25	applied	\N	\N	\N	\N	196176	196176	363341
26150	41374	2	applied	\N	\N	\N	\N	196183	196183	363348
26153	41372	0	applied	\N	\N	\N	\N	196199	196199	363364
26156	41378	0	applied	\N	\N	\N	\N	196216	196216	363381
26157	41382	4	applied	\N	\N	1000000000	\N	196225	196225	363390
26158	41382	4	applied	\N	\N	1000000000	\N	196230	196230	363395
26164	41402	2	applied	\N	\N	\N	\N	196261	196261	363426
26167	41412	3	applied	\N	\N	\N	\N	196274	196274	363439
26174	41424	1	applied	\N	\N	\N	\N	196286	196286	363451
26175	41427	4	applied	\N	\N	\N	\N	196303	196303	363468
26176	41443	6	applied	\N	\N	\N	\N	196319	196319	363484
26182	41451	0	applied	\N	\N	\N	\N	196344	196344	363509
26183	41451	0	applied	\N	\N	\N	\N	196347	196347	363512
26185	41397	6	applied	\N	\N	\N	\N	196359	196359	363524
26185	41389	34	applied	\N	\N	\N	\N	196387	196387	363552
26185	41388	49	applied	\N	\N	1000000000	\N	196402	196402	363567
26185	41427	70	applied	\N	\N	\N	\N	196423	196423	363588
26187	41457	3	applied	\N	\N	1000000000	\N	196442	196442	363607
26190	41197	9	applied	\N	\N	\N	\N	196460	196460	363625
26190	41222	26	applied	\N	\N	\N	\N	196477	196477	363642
26190	41233	43	applied	\N	\N	\N	\N	196494	196494	363659
26190	41117	52	applied	\N	\N	\N	\N	196503	196503	363668
26190	41127	55	applied	\N	\N	\N	\N	196506	196506	363671
26190	41160	72	applied	\N	\N	\N	\N	196523	196523	363688
26190	41240	89	applied	\N	\N	\N	\N	196540	196540	363705
26190	41276	106	applied	\N	\N	\N	\N	196557	196557	363722
26190	41305	120	applied	\N	\N	\N	\N	196570	196570	363735
26190	41308	121	applied	\N	\N	\N	\N	196571	196571	363736
26191	41470	8	applied	\N	\N	\N	\N	196584	196584	363749
26192	41477	4	applied	\N	\N	1000000000	\N	196591	196591	363756
26193	41290	17	applied	\N	\N	\N	\N	196609	196609	363774
26193	41235	34	applied	\N	\N	\N	\N	196626	196626	363791
26193	41332	78	applied	\N	\N	\N	\N	196670	196670	363835
26193	41369	95	applied	\N	\N	\N	\N	196687	196687	363852
26193	41426	112	applied	\N	\N	\N	\N	196704	196704	363869
26194	41482	4	applied	\N	\N	\N	\N	196721	196721	363886
26198	41486	2	applied	\N	\N	\N	\N	196741	196741	363906
26205	41504	3	applied	\N	\N	\N	\N	196765	196765	363930
26208	41517	0	applied	\N	\N	\N	\N	196782	196782	363947
26211	41522	1	applied	\N	\N	\N	\N	196795	196795	363960
26217	41530	0	applied	\N	\N	\N	\N	196815	196815	363980
26218	41538	4	applied	\N	\N	\N	\N	196823	196823	363988
26224	41548	1	applied	\N	\N	\N	\N	196847	196847	364012
26225	41330	6	applied	\N	\N	\N	\N	196859	196859	364024
26225	41363	22	applied	\N	\N	\N	\N	196875	196875	364040
26225	41424	39	applied	\N	\N	\N	\N	196892	196892	364057
26225	41489	56	applied	\N	\N	\N	\N	196909	196909	364074
26225	41547	73	applied	\N	\N	\N	\N	196926	196926	364091
26225	41111	91	applied	\N	\N	\N	\N	196944	196944	364109
26225	41392	108	applied	\N	\N	\N	\N	196961	196961	364126
26226	41565	11	applied	\N	\N	\N	\N	196989	196989	364154
26227	41558	4	applied	\N	\N	\N	\N	197006	197006	364171
26227	41574	20	applied	\N	\N	\N	\N	197022	197022	364187
26228	41579	1	applied	\N	\N	\N	\N	197027	197027	364192
26231	41590	6	applied	\N	\N	\N	\N	197045	197045	364210
26232	41592	1	applied	\N	\N	\N	\N	197047	197047	364212
26014	40409	22	applied	\N	\N	\N	\N	195280	195280	362446
26243	41615	9	applied	\N	\N	\N	\N	197083	197083	364248
26247	41624	0	applied	\N	\N	\N	\N	197101	197101	364266
26249	41631	1	applied	\N	\N	\N	\N	197108	197108	364273
26251	41641	4	applied	\N	\N	\N	\N	197118	197118	364283
26261	41671	5	applied	\N	\N	\N	\N	197160	197160	364325
26262	41674	2	applied	\N	\N	\N	\N	197163	197163	364328
26273	41706	2	applied	\N	\N	\N	\N	197208	197208	364373
26275	41708	1	applied	\N	\N	\N	\N	197214	197214	364379
26280	41161	2	applied	\N	\N	\N	\N	197236	197236	364401
26280	41288	19	applied	\N	\N	\N	\N	197253	197253	364418
26280	41177	32	applied	\N	\N	\N	\N	197266	197266	364431
26280	41181	35	applied	\N	\N	\N	\N	197269	197269	364434
26280	41064	52	applied	\N	\N	\N	\N	197286	197286	364451
26280	41097	69	applied	\N	\N	\N	\N	197303	197303	364468
26280	41142	87	applied	\N	\N	\N	\N	197320	197320	364485
26280	41202	104	applied	\N	\N	\N	\N	197337	197337	364502
26280	41255	121	applied	\N	\N	\N	\N	197354	197354	364519
26282	41726	2	applied	\N	\N	\N	\N	197368	197368	364533
26282	41727	3	applied	\N	\N	\N	\N	197369	197369	364534
26282	41730	6	applied	\N	\N	\N	\N	197372	197372	364537
26288	41736	1	applied	\N	\N	\N	\N	197394	197394	364559
26294	41760	9	applied	\N	\N	\N	\N	197420	197420	364585
26299	41768	4	applied	\N	\N	\N	\N	197452	197452	364617
26300	41766	2	applied	\N	\N	\N	\N	197455	197455	364620
26302	41769	0	applied	\N	\N	\N	\N	197463	197463	364628
26309	41429	2	applied	\N	\N	\N	\N	197482	197482	364647
26309	41600	19	applied	\N	\N	\N	\N	197499	197499	364664
26309	41755	34	applied	\N	\N	\N	\N	197514	197514	364679
26314	41790	1	applied	\N	\N	\N	\N	197538	197538	364703
26316	41789	0	applied	\N	\N	\N	\N	197543	197543	364708
26320	41790	2	applied	\N	\N	\N	\N	197562	197562	364727
26322	41796	0	applied	\N	\N	\N	\N	197570	197570	364735
26333	41805	0	applied	\N	\N	\N	\N	197608	197608	364773
26335	41814	2	applied	\N	\N	\N	\N	197619	197619	364784
26339	41823	2	applied	\N	\N	\N	\N	197629	197629	364794
26344	41828	0	applied	\N	\N	\N	\N	197646	197646	364811
26344	41829	1	applied	\N	\N	\N	\N	197647	197647	364812
26347	41829	0	applied	\N	\N	\N	\N	197655	197655	364820
26357	41849	6	applied	\N	\N	\N	\N	197694	197694	364859
26358	41424	15	applied	\N	\N	\N	\N	197710	197710	364875
26358	41489	32	applied	\N	\N	\N	\N	197727	197727	364892
26358	41544	48	applied	\N	\N	\N	\N	197743	197743	364908
26358	41595	64	applied	\N	\N	\N	\N	197759	197759	364924
26358	41657	82	applied	\N	\N	\N	\N	197776	197776	364941
26358	41712	99	applied	\N	\N	\N	\N	197793	197793	364958
26358	41753	116	applied	\N	\N	\N	\N	197810	197810	364975
26360	41854	1	applied	\N	\N	\N	\N	197824	197824	364989
26366	41867	5	applied	\N	\N	\N	\N	197840	197840	365005
26370	41881	5	applied	\N	\N	1000000000	\N	197859	197859	365024
26373	41884	2	applied	\N	\N	1000000000	\N	197874	197874	365039
26375	41899	5	applied	\N	\N	\N	\N	197889	197889	365054
26376	41894	0	applied	\N	\N	\N	\N	197892	197892	365057
26379	41905	0	applied	\N	\N	\N	\N	197906	197906	365071
26384	41911	3	applied	\N	\N	\N	\N	197927	197927	365092
26392	41380	3	applied	\N	\N	1000000000	\N	197968	197968	365133
26392	41379	19	applied	\N	\N	\N	\N	197984	197984	365149
26392	41443	36	applied	\N	\N	\N	\N	198001	198001	365166
26392	41505	53	applied	\N	\N	\N	\N	198018	198018	365183
26392	41515	57	applied	\N	\N	\N	\N	198022	198022	365187
26392	41525	60	applied	\N	\N	\N	\N	198025	198025	365190
26392	41583	78	applied	\N	\N	\N	\N	198042	198042	365207
26392	41531	95	applied	\N	\N	\N	\N	198059	198059	365224
26392	41720	112	applied	\N	\N	\N	\N	198076	198076	365241
26394	41947	2	applied	\N	\N	\N	\N	198089	198089	365254
26396	41958	7	applied	\N	\N	\N	\N	198100	198100	365265
26403	41974	2	applied	\N	\N	\N	\N	198126	198126	365291
26404	41977	2	applied	\N	\N	\N	\N	198129	198129	365294
26406	41977	15	applied	\N	\N	\N	\N	198150	198150	365315
26407	41981	2	applied	\N	\N	\N	\N	198158	198158	365323
26409	41607	13	applied	\N	\N	\N	\N	198181	198181	365346
26409	41724	47	applied	\N	\N	\N	\N	198215	198215	365380
26409	41764	64	applied	\N	\N	\N	\N	198232	198232	365397
26409	41797	79	applied	\N	\N	\N	\N	198247	198247	365412
26409	41834	95	applied	\N	\N	\N	\N	198263	198263	365428
26409	41874	112	applied	\N	\N	\N	\N	198280	198280	365445
26412	41991	2	applied	\N	\N	\N	\N	198295	198295	365460
26414	41999	7	applied	\N	\N	1000000000	\N	198306	198306	365471
26414	42005	13	applied	\N	\N	\N	\N	198312	198312	365477
26415	41999	7	applied	\N	\N	1000000000	\N	198324	198324	365489
26416	42011	1	applied	\N	\N	\N	\N	198336	198336	365501
26423	42025	1	applied	\N	\N	\N	\N	198363	198363	365528
26424	41793	6	applied	\N	\N	\N	\N	198371	198371	365536
26424	41833	23	applied	\N	\N	\N	\N	198388	198388	365553
26424	41873	40	applied	\N	\N	\N	\N	198405	198405	365570
26424	41926	56	applied	\N	\N	\N	\N	198421	198421	365586
26424	41931	57	applied	\N	\N	\N	\N	198422	198422	365587
26431	42037	0	applied	\N	\N	\N	\N	198473	198473	365638
26435	42042	3	applied	\N	\N	\N	\N	198499	198499	365664
26436	42049	2	applied	\N	\N	\N	\N	198506	198506	365671
26446	42068	2	applied	\N	\N	\N	\N	198550	198550	365715
26447	42067	1	applied	\N	\N	\N	\N	198553	198553	365718
26448	42067	1	applied	\N	\N	\N	\N	198557	198557	365722
26449	42068	0	applied	\N	\N	\N	\N	198560	198560	365725
26452	42071	1	applied	\N	\N	\N	\N	198569	198569	365734
26455	42024	9	applied	\N	\N	\N	\N	198586	198586	365751
26455	42075	25	applied	\N	\N	\N	\N	198602	198602	365767
26455	42012	42	applied	\N	\N	\N	\N	198619	198619	365784
26455	42072	59	applied	\N	\N	\N	\N	198636	198636	365801
26455	42044	77	applied	\N	\N	\N	\N	198653	198653	365818
26458	42087	5	applied	\N	\N	\N	\N	198676	198676	365841
26459	41979	5	applied	\N	\N	\N	\N	198683	198683	365848
26459	42037	22	applied	\N	\N	\N	\N	198700	198700	365865
26459	42012	56	applied	\N	\N	\N	\N	198734	198734	365899
26459	42072	73	applied	\N	\N	\N	\N	198751	198751	365916
26459	42087	90	applied	\N	\N	\N	\N	198768	198768	365933
26459	42019	107	applied	\N	\N	\N	\N	198785	198785	365950
26459	42020	108	applied	\N	\N	\N	\N	198786	198786	365951
26464	42099	1	applied	\N	\N	\N	\N	198811	198811	365976
26467	41985	0	applied	\N	\N	\N	\N	198819	198819	365984
26467	42041	17	applied	\N	\N	\N	\N	198836	198836	366001
26243	41612	6	applied	\N	\N	1000000000	\N	197080	197080	364245
26467	42043	67	applied	\N	\N	\N	\N	198886	198886	366051
26467	42098	85	applied	\N	\N	\N	\N	198903	198903	366068
26467	42019	94	applied	\N	\N	\N	\N	198912	198912	366077
26467	42078	111	applied	\N	\N	\N	\N	198929	198929	366094
26468	41857	12	applied	\N	\N	\N	\N	198950	198950	366115
26468	41908	29	applied	\N	\N	\N	\N	198967	198967	366132
26468	41995	58	applied	\N	\N	\N	\N	198995	198995	366160
26468	42060	75	applied	\N	\N	\N	\N	199012	199012	366177
26468	41831	92	applied	\N	\N	\N	\N	199029	199029	366194
26469	42104	0	applied	\N	\N	\N	\N	199063	199063	366227
26470	42110	6	applied	\N	\N	\N	\N	199077	199077	366241
26475	42123	1	applied	\N	\N	1000000000	\N	199099	199099	366263
26476	42126	4	applied	\N	\N	1000000000	\N	199108	199108	366272
26478	42135	3	applied	\N	\N	\N	\N	199117	199117	366281
26481	42138	2	applied	\N	\N	\N	\N	199129	199129	366293
26488	42152	1	applied	\N	\N	\N	\N	199152	199152	366316
26490	42155	1	applied	\N	\N	\N	\N	199162	199162	366326
26494	41985	1	applied	\N	\N	\N	\N	199178	199178	366342
26494	42073	27	applied	\N	\N	\N	\N	199204	199204	366368
26494	42136	44	applied	\N	\N	\N	\N	199221	199221	366385
26494	41999	59	applied	\N	\N	1000000000	\N	199236	199236	366400
26494	42015	68	applied	\N	\N	\N	\N	199245	199245	366409
26494	42149	82	applied	\N	\N	\N	\N	199259	199259	366423
26494	42042	100	applied	\N	\N	\N	\N	199276	199276	366440
26494	42095	117	applied	\N	\N	\N	\N	199293	199293	366457
26495	42175	8	applied	\N	\N	\N	\N	199310	199310	366474
26502	42191	1	applied	\N	\N	\N	\N	199337	199337	366501
26502	42192	2	applied	\N	\N	\N	\N	199338	199338	366502
26508	42210	0	applied	\N	\N	\N	\N	199359	199359	366523
26509	42180	2	applied	\N	\N	\N	\N	199364	199364	366528
26509	42204	19	applied	\N	\N	\N	\N	199381	199381	366545
26509	42202	36	applied	\N	\N	\N	\N	199398	199398	366562
26509	42016	46	applied	\N	\N	\N	\N	199408	199408	366572
26509	42025	49	applied	\N	\N	\N	\N	199411	199411	366575
26509	42084	66	applied	\N	\N	\N	\N	199428	199428	366592
26509	42146	83	applied	\N	\N	\N	\N	199445	199445	366609
26509	42201	101	applied	\N	\N	\N	\N	199462	199462	366626
26510	42221	9	applied	\N	\N	\N	\N	199474	199474	366638
26512	42224	1	applied	\N	\N	\N	\N	199487	199487	366651
26514	42232	2	applied	\N	\N	\N	\N	199499	199499	366663
26516	42233	0	applied	\N	\N	\N	\N	199503	199503	366667
26528	42251	1	applied	\N	\N	\N	\N	199541	199541	366705
26529	42252	2	applied	\N	\N	\N	\N	199545	199545	366709
26533	42264	4	applied	\N	\N	\N	\N	199557	199557	366721
26536	42268	8	applied	\N	\N	\N	\N	199588	199588	366752
26541	42295	6	applied	\N	\N	\N	\N	199620	199620	366781
26539	42279	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	199604	199604	\N
26542	42292	3	applied	\N	\N	\N	\N	199624	199624	366785
26554	42328	1	applied	\N	\N	\N	\N	199670	199670	366831
26560	42338	2	applied	\N	\N	\N	\N	199694	199694	366855
26560	42339	3	applied	\N	\N	\N	\N	199695	199695	366856
26563	42345	2	applied	\N	\N	\N	\N	199704	199704	366865
26564	42151	19	applied	\N	\N	\N	\N	199724	199724	366885
26564	42207	36	applied	\N	\N	\N	\N	199741	199741	366902
26564	42261	53	applied	\N	\N	\N	\N	199758	199758	366919
26564	42317	68	applied	\N	\N	\N	\N	199773	199773	366934
26564	42321	70	applied	\N	\N	\N	\N	199775	199775	366936
26564	42137	87	applied	\N	\N	\N	\N	199792	199792	366953
26564	42103	104	applied	\N	\N	\N	\N	199809	199809	366970
26564	42166	122	applied	\N	\N	\N	\N	199826	199826	366987
26568	42354	1	applied	\N	\N	\N	\N	199841	199841	367002
26573	42366	3	applied	\N	\N	\N	\N	199867	199867	367028
26576	42373	3	applied	\N	\N	\N	\N	199874	199874	367035
26577	42379	9	applied	\N	\N	\N	\N	199892	199892	367053
26580	42123	1	applied	\N	\N	1000000000	\N	199906	199906	367067
26582	42392	0	applied	\N	\N	\N	\N	199918	199918	367079
26584	42394	2	applied	\N	\N	\N	\N	199934	199934	367095
26587	42399	0	applied	\N	\N	\N	\N	199953	199953	367114
26588	42404	5	applied	\N	\N	\N	\N	199964	199964	367125
26589	42404	5	applied	\N	\N	\N	\N	199970	199970	367131
26594	42420	1	applied	\N	\N	\N	\N	199990	199990	367151
26596	42419	0	applied	\N	\N	\N	\N	200001	200001	367162
26603	42434	0	applied	\N	\N	\N	\N	200037	200037	367198
26605	42450	3	applied	\N	\N	\N	\N	200053	200053	367214
26609	42454	1	applied	\N	\N	\N	\N	200064	200064	367225
26615	42466	2	applied	\N	\N	\N	\N	200090	200090	367251
26616	42465	1	applied	\N	\N	\N	\N	200097	200097	367258
26616	42471	7	applied	\N	\N	\N	\N	200103	200103	367264
26618	42469	5	applied	\N	\N	\N	\N	200117	200117	367278
26620	42478	6	applied	\N	\N	1000000000	\N	200134	200134	367295
26621	42486	14	applied	\N	\N	1000000000	\N	200164	200164	367325
26622	42476	4	applied	\N	\N	\N	\N	200176	200176	367337
26622	42483	11	applied	\N	\N	\N	\N	200183	200183	367344
26622	42491	19	applied	\N	\N	\N	\N	200191	200191	367352
26626	42501	1	applied	\N	\N	\N	\N	200204	200204	367365
26630	42510	0	applied	\N	\N	\N	\N	200227	200227	367388
26639	42527	0	applied	\N	\N	\N	\N	200260	200260	367421
26640	42528	1	applied	\N	\N	\N	\N	200270	200270	367431
26641	42535	8	applied	\N	\N	\N	\N	200286	200286	367447
26644	42543	3	applied	\N	\N	\N	\N	200303	200303	367464
26645	42540	0	applied	\N	\N	\N	\N	200306	200306	367467
26646	42545	3	applied	\N	\N	\N	\N	200315	200315	367476
26651	42392	14	applied	\N	\N	\N	\N	200345	200345	367506
26651	42451	31	applied	\N	\N	\N	\N	200362	200362	367523
26651	42511	57	applied	\N	\N	1000000000	\N	200388	200388	367549
26651	42217	78	applied	\N	\N	\N	\N	200409	200409	367570
26651	42113	90	applied	\N	\N	\N	\N	200421	200421	367582
26651	42118	91	applied	\N	\N	\N	\N	200422	200422	367583
26651	42179	109	applied	\N	\N	\N	\N	200439	200439	367600
26655	42556	0	applied	\N	\N	\N	\N	200465	200465	367626
26656	42558	2	applied	\N	\N	\N	\N	200471	200471	367632
26659	42563	0	applied	\N	\N	\N	\N	200479	200479	367640
26665	42581	6	applied	\N	\N	\N	\N	200516	200516	367677
26666	42577	1	applied	\N	\N	\N	\N	200519	200519	367680
26667	42580	5	applied	\N	\N	\N	\N	200529	200529	367690
26670	42580	5	applied	\N	\N	\N	\N	200550	200550	367711
26670	42581	6	applied	\N	\N	\N	\N	200551	200551	367712
26680	42602	0	applied	\N	\N	\N	\N	200583	200583	367744
26681	42560	2	applied	\N	\N	\N	\N	200592	200592	367753
26682	42613	4	applied	\N	\N	\N	\N	200600	200600	367761
26691	42631	2	applied	\N	\N	\N	\N	200653	200653	367814
26692	42632	3	applied	\N	\N	\N	\N	200664	200664	367825
26698	42652	2	applied	\N	\N	\N	\N	200688	200688	367849
26699	42652	2	applied	\N	\N	\N	\N	200691	200691	367852
26706	41932	3	applied	\N	\N	\N	\N	200728	200728	367889
26706	41992	20	applied	\N	\N	\N	\N	200745	200745	367906
26706	42018	28	applied	\N	\N	\N	\N	200753	200753	367914
26706	42030	31	applied	\N	\N	\N	\N	200756	200756	367917
26706	42083	49	applied	\N	\N	\N	\N	200773	200773	367934
26706	42151	66	applied	\N	\N	\N	\N	200790	200790	367951
26706	42261	100	applied	\N	\N	\N	\N	200824	200824	367985
26706	42321	117	applied	\N	\N	\N	\N	200841	200841	368002
26707	42676	7	applied	\N	\N	\N	\N	200857	200857	368018
26709	42476	9	applied	\N	\N	\N	\N	200877	200877	368038
26709	42550	26	applied	\N	\N	\N	\N	200894	200894	368055
26709	42583	36	applied	\N	\N	\N	\N	200904	200904	368065
26709	42639	53	applied	\N	\N	\N	\N	200921	200921	368082
26709	42672	71	applied	\N	\N	\N	\N	200938	200938	368099
26709	42463	88	applied	\N	\N	\N	\N	200955	200955	368116
26709	42467	94	applied	\N	\N	\N	\N	200961	200961	368122
26709	42509	105	applied	\N	\N	\N	\N	200972	200972	368133
26709	42480	122	applied	\N	\N	\N	\N	200989	200989	368150
26713	42699	2	applied	\N	\N	\N	\N	201008	201008	368169
26714	42698	1	applied	\N	\N	\N	\N	201013	201013	368174
26721	42710	0	applied	\N	\N	\N	\N	201038	201038	368199
26724	42720	3	applied	\N	\N	\N	\N	201047	201047	368208
26729	42738	6	applied	\N	\N	\N	\N	201079	201079	368240
26731	42739	0	applied	\N	\N	\N	\N	201083	201083	368244
26733	42743	1	applied	\N	\N	1000000000	\N	201090	201090	368251
26737	42759	2	applied	\N	\N	\N	\N	201111	201111	368272
26739	42763	3	applied	\N	\N	\N	\N	201115	201115	368276
26745	42765	4	applied	\N	\N	\N	\N	201142	201142	368303
26747	42642	12	applied	\N	\N	1000000000	\N	201164	201164	368325
26748	42776	2	applied	\N	\N	\N	\N	201172	201172	368330
26753	42485	7	applied	\N	\N	1000000000	\N	201191	201191	368349
26754	42478	4	applied	\N	\N	1000000000	\N	201203	201203	368361
26758	42787	3	applied	\N	\N	\N	\N	201238	201238	368396
26758	42788	4	applied	\N	\N	\N	\N	201239	201239	368397
26762	42791	1	applied	\N	\N	\N	\N	201248	201248	368406
26764	42799	2	applied	\N	\N	\N	\N	201256	201256	368414
26767	42802	5	applied	\N	\N	\N	\N	201286	201286	368444
26768	42808	1	applied	\N	\N	\N	\N	201292	201292	368450
26771	42822	3	applied	\N	\N	\N	\N	201326	201326	368484
26771	42836	17	applied	\N	\N	\N	\N	201340	201340	368498
26773	42842	3	applied	\N	\N	\N	\N	201352	201352	368510
26775	42155	14	applied	\N	\N	\N	\N	201375	201375	368533
26775	42213	31	applied	\N	\N	\N	\N	201392	201392	368550
26775	42236	38	applied	\N	\N	\N	\N	201399	201399	368557
26775	42246	41	applied	\N	\N	\N	\N	201402	201402	368560
26775	42308	58	applied	\N	\N	\N	\N	201419	201419	368577
26775	42363	75	applied	\N	\N	\N	\N	201436	201436	368594
26775	42420	93	applied	\N	\N	\N	\N	201453	201453	368611
26775	42474	107	applied	\N	\N	\N	\N	201467	201467	368625
26775	42518	117	applied	\N	\N	\N	\N	201477	201477	368635
26776	42128	6	applied	\N	\N	\N	\N	201492	201492	368650
26776	42187	23	applied	\N	\N	\N	\N	201509	201509	368667
26776	42243	40	applied	\N	\N	\N	\N	201526	201526	368684
26776	42300	58	applied	\N	\N	\N	\N	201543	201543	368701
26776	42438	98	applied	\N	\N	\N	\N	201583	201583	368741
26776	42510	115	applied	\N	\N	\N	\N	201600	201600	368758
26778	42851	2	applied	\N	\N	\N	\N	201617	201617	368775
26781	42865	1	applied	\N	\N	\N	\N	201634	201634	368792
26784	42192	11	applied	\N	\N	\N	\N	201653	201653	368811
26784	42225	14	applied	\N	\N	\N	\N	201656	201656	368814
26787	42871	1	applied	\N	\N	\N	\N	201669	201669	368827
26792	42879	2	applied	\N	\N	\N	\N	201687	201687	368845
26793	42887	0	applied	\N	\N	\N	\N	201695	201695	368853
26804	42903	1	applied	\N	\N	\N	\N	201728	201728	368886
26806	42910	0	applied	\N	\N	\N	\N	201735	201735	368893
26811	42925	2	applied	\N	\N	\N	\N	201759	201759	368917
26812	42931	5	applied	\N	\N	\N	\N	201765	201765	368923
26813	42927	1	applied	\N	\N	\N	\N	201768	201768	368926
26816	42948	3	applied	\N	\N	\N	\N	201793	201793	368951
26817	42952	2	applied	\N	\N	\N	\N	201797	201797	368955
26821	42429	24	applied	\N	\N	\N	\N	201834	201834	368992
26821	42500	41	applied	\N	\N	\N	\N	201851	201851	369009
26821	42567	61	applied	\N	\N	\N	\N	201871	201871	369029
26824	42963	3	applied	\N	\N	\N	\N	201888	201888	369046
26827	42962	2	applied	\N	\N	\N	\N	201899	201899	369057
26834	42974	1	applied	\N	\N	\N	\N	201921	201921	369079
26835	42978	2	applied	\N	\N	\N	\N	201924	201924	369082
26840	42995	3	applied	\N	\N	\N	\N	201948	201948	369106
26841	42998	2	applied	\N	\N	\N	\N	201951	201951	369109
26848	43029	1	applied	\N	\N	\N	\N	201985	201985	369143
26853	43043	2	applied	\N	\N	\N	\N	202005	202005	369163
26856	42906	0	applied	\N	\N	\N	\N	202012	202012	369170
26856	42920	17	applied	\N	\N	\N	\N	202029	202029	369187
26856	42976	34	applied	\N	\N	\N	\N	202046	202046	369204
26856	43021	48	applied	\N	\N	\N	\N	202060	202060	369218
26856	42897	65	applied	\N	\N	\N	\N	202077	202077	369235
26856	42952	95	applied	\N	\N	\N	\N	202107	202107	369265
26856	42963	98	applied	\N	\N	\N	\N	202110	202110	369268
26856	42985	116	applied	\N	\N	\N	\N	202127	202127	369285
26857	43048	4	applied	\N	\N	\N	\N	202141	202141	369299
26861	42899	4	applied	\N	\N	\N	\N	202160	202160	369318
26861	42957	21	applied	\N	\N	\N	\N	202177	202177	369335
26861	43008	38	applied	\N	\N	\N	\N	202194	202194	369352
26861	42905	55	applied	\N	\N	\N	\N	202211	202211	369369
26861	42898	72	applied	\N	\N	\N	\N	202228	202228	369386
26861	42963	88	applied	\N	\N	\N	\N	202243	202243	369401
26861	43047	91	applied	\N	\N	\N	\N	202246	202246	369404
26861	43014	108	applied	\N	\N	\N	\N	202263	202263	369421
26861	42917	125	applied	\N	\N	\N	\N	202280	202280	369438
26865	43059	2	applied	\N	\N	\N	\N	202300	202300	369458
26869	43073	2	applied	\N	\N	\N	\N	202317	202317	369475
26874	43081	4	applied	\N	\N	\N	\N	202334	202334	369492
26882	43077	10	applied	\N	\N	\N	\N	202366	202366	369524
26882	43047	13	applied	\N	\N	\N	\N	202369	202369	369527
26882	43068	30	applied	\N	\N	\N	\N	202386	202386	369544
26882	42931	47	applied	\N	\N	\N	\N	202403	202403	369561
26690	42638	9	applied	\N	\N	\N	\N	200650	200650	367811
26883	43092	4	applied	\N	\N	\N	\N	202454	202454	369612
26883	43097	9	applied	\N	\N	\N	\N	202459	202459	369617
26884	43100	2	applied	\N	\N	\N	\N	202462	202462	369620
26886	43101	0	applied	\N	\N	\N	\N	202466	202466	369624
26886	43104	3	applied	\N	\N	\N	\N	202469	202469	369627
26893	43113	2	applied	\N	\N	\N	\N	202493	202493	369651
26894	43111	7	applied	\N	\N	\N	\N	202502	202502	369660
26894	43100	25	applied	\N	\N	\N	\N	202519	202519	369677
26898	43141	10	applied	\N	\N	\N	\N	202560	202560	369718
26900	43135	4	applied	\N	\N	\N	\N	202576	202576	369734
26903	43150	2	applied	\N	\N	\N	\N	202594	202594	369752
26906	43162	5	applied	\N	\N	\N	\N	202606	202606	369764
26907	43158	1	applied	\N	\N	\N	\N	202608	202608	369766
26914	43171	2	applied	\N	\N	\N	\N	202633	202633	369791
26918	43177	0	applied	\N	\N	\N	\N	202642	202642	369800
26920	43143	9	applied	\N	\N	\N	\N	202663	202663	369821
26920	43126	26	applied	\N	\N	\N	\N	202680	202680	369838
26920	43159	43	applied	\N	\N	\N	\N	202697	202697	369855
26920	43155	50	applied	\N	\N	\N	\N	202704	202704	369862
26920	43168	54	applied	\N	\N	\N	\N	202708	202708	369866
26924	43195	0	applied	\N	\N	\N	\N	202734	202734	369892
26925	43197	2	applied	\N	\N	\N	\N	202739	202739	369897
26928	43202	1	applied	\N	\N	\N	\N	202747	202747	369905
26934	43218	5	applied	\N	\N	\N	\N	202790	202790	369948
26938	43227	2	applied	\N	\N	\N	\N	202802	202802	369960
26941	43234	3	applied	\N	\N	\N	\N	202812	202812	369970
26953	43266	1	applied	\N	\N	\N	\N	202868	202868	370025
26943	43244	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	202831	202831	\N
26954	43267	2	applied	\N	\N	\N	\N	202873	202873	370030
26957	43268	2	applied	\N	\N	\N	\N	202885	202885	370042
26964	43284	0	applied	\N	\N	\N	\N	202929	202929	370084
26961	43274	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	202914	202914	\N
26970	43015	36	applied	\N	\N	\N	\N	202983	202983	370136
26970	42963	50	applied	\N	\N	\N	\N	202997	202997	370150
26970	43047	53	applied	\N	\N	\N	\N	203000	203000	370153
26970	42995	70	applied	\N	\N	\N	\N	203017	203017	370170
26970	43052	87	applied	\N	\N	\N	\N	203034	203034	370187
26970	43107	105	applied	\N	\N	\N	\N	203051	203051	370204
26970	43162	122	applied	\N	\N	\N	\N	203068	203068	370221
26973	43293	0	applied	\N	\N	\N	\N	203078	203078	370231
26976	43296	0	applied	\N	\N	\N	\N	203087	203087	370240
26981	43307	6	applied	\N	\N	\N	\N	203107	203107	370260
26987	43330	1	applied	\N	\N	\N	\N	203132	203132	370285
26992	43340	0	applied	\N	\N	\N	\N	203148	203148	370301
26996	43349	0	applied	\N	\N	\N	\N	203160	203160	370313
27001	43360	0	applied	\N	\N	\N	\N	203184	203184	370337
27002	43364	2	applied	\N	\N	\N	\N	203188	203188	370341
27006	43370	1	applied	\N	\N	\N	\N	203203	203203	370356
27011	43377	2	applied	\N	\N	\N	\N	203226	203226	370379
27012	43383	5	applied	\N	\N	\N	\N	203232	203232	370385
27018	43391	2	applied	\N	\N	\N	\N	203249	203249	370402
27021	43391	2	applied	\N	\N	\N	\N	203257	203257	370410
27025	43399	1	applied	\N	\N	\N	\N	203268	203268	370421
27027	43214	15	applied	\N	\N	\N	\N	203287	203287	370440
27027	43269	32	applied	\N	\N	\N	\N	203304	203304	370457
27027	43318	49	applied	\N	\N	\N	\N	203321	203321	370474
27027	43370	67	applied	\N	\N	\N	\N	203338	203338	370491
27027	43248	107	applied	\N	\N	\N	\N	203378	203378	370529
27027	43257	110	applied	\N	\N	\N	\N	203381	203381	370532
27027	43278	116	applied	\N	\N	\N	\N	203387	203387	370538
27028	43401	1	applied	\N	\N	\N	\N	203398	203398	370549
27030	43404	14	applied	\N	\N	\N	\N	203419	203419	370570
27030	43405	31	applied	\N	\N	\N	\N	203436	203436	370587
27031	43405	2	applied	\N	\N	\N	\N	203440	203440	370591
27032	43405	2	applied	\N	\N	\N	\N	203443	203443	370594
27038	43415	4	applied	\N	\N	1000000000	\N	203464	203464	370615
27041	43232	15	applied	\N	\N	\N	\N	203489	203489	370640
27041	43287	32	applied	\N	\N	\N	\N	203506	203506	370657
27047	43422	3	applied	\N	\N	\N	\N	203550	203550	370699
27044	43274	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	203526	203526	\N
27050	43431	0	applied	\N	\N	\N	\N	203565	203565	370714
27053	43198	0	applied	\N	\N	\N	\N	203572	203572	370721
27055	43433	5	applied	\N	\N	\N	\N	203602	203602	370751
27058	43446	0	applied	\N	\N	\N	\N	203617	203617	370766
27067	43469	0	applied	\N	\N	\N	\N	203650	203650	370798
27068	43474	6	applied	\N	\N	\N	\N	203661	203661	370809
27069	43464	11	applied	\N	\N	\N	\N	203673	203673	203673
27069	43246	28	applied	\N	\N	\N	\N	203690	203690	370837
27069	43283	45	applied	\N	\N	\N	\N	203707	203707	370854
27069	43327	60	applied	\N	\N	\N	\N	203722	203722	370869
27069	43341	65	applied	\N	\N	\N	\N	203727	203727	370874
27069	43354	68	applied	\N	\N	\N	\N	203730	203730	370877
27069	43403	85	applied	\N	\N	\N	\N	203747	203747	370894
27069	42932	103	applied	\N	\N	\N	\N	203764	203764	370911
27069	42991	120	applied	\N	\N	\N	\N	203781	203781	370928
27076	43490	3	applied	\N	\N	\N	\N	203813	203813	370960
27077	43493	1	applied	\N	\N	\N	\N	203816	203816	370963
27080	43296	1	applied	\N	\N	\N	\N	203825	203825	370972
27080	43357	22	applied	\N	\N	\N	\N	203845	203845	370992
27080	43407	39	applied	\N	\N	\N	\N	203862	203862	371009
27083	43512	8	applied	\N	\N	\N	\N	203882	203882	371029
27085	43519	5	applied	\N	\N	\N	\N	203895	203895	371042
27088	43518	4	applied	\N	\N	\N	\N	203912	203912	371059
27090	43520	0	applied	\N	\N	\N	\N	203917	203917	371064
27102	43547	3	applied	\N	\N	\N	\N	203956	203956	371103
27103	43554	4	applied	\N	\N	\N	\N	203963	203963	371110
27106	43557	1	applied	\N	\N	\N	\N	203969	203969	371116
27109	43564	2	applied	\N	\N	\N	\N	203979	203979	371126
27110	43449	15	applied	\N	\N	\N	\N	203995	203995	371142
27110	43504	32	applied	\N	\N	\N	\N	204012	204012	371159
27110	43556	49	applied	\N	\N	\N	\N	204029	204029	371176
27110	43347	67	applied	\N	\N	\N	\N	204046	204046	371193
27110	43381	84	applied	\N	\N	\N	\N	204063	204063	371209
27110	43193	106	applied	\N	\N	\N	\N	204085	204085	371231
27110	43230	118	applied	\N	\N	\N	\N	204097	204097	371243
27120	43580	1	applied	\N	\N	\N	\N	204131	204131	371277
27129	43605	0	applied	\N	\N	\N	\N	204164	204164	371310
27130	43610	2	applied	\N	\N	\N	\N	204169	204169	371315
27131	43614	6	applied	\N	\N	\N	\N	204182	204182	371328
26882	43048	81	applied	\N	\N	\N	\N	202437	202437	369595
27139	43624	1	applied	\N	\N	\N	\N	204203	204203	371349
27147	43638	1	applied	\N	\N	\N	\N	204237	204237	371383
27149	43641	2	applied	\N	\N	\N	\N	204243	204243	371389
27150	42583	15	applied	\N	\N	\N	\N	204261	204261	371407
27150	42639	32	applied	\N	\N	\N	\N	204278	204278	371424
27150	42697	49	applied	\N	\N	\N	\N	204295	204295	371441
27150	42808	84	applied	\N	\N	\N	\N	204329	204329	371475
27150	42854	99	applied	\N	\N	\N	\N	204344	204344	371490
27150	42864	100	applied	\N	\N	\N	\N	204345	204345	371491
27150	42920	117	applied	\N	\N	\N	\N	204362	204362	371508
27152	43642	9	applied	\N	\N	\N	\N	204381	204381	371527
27154	43651	4	applied	\N	\N	\N	\N	204401	204401	371547
27158	43657	2	applied	\N	\N	\N	\N	204414	204414	371560
27158	43660	5	applied	\N	\N	\N	\N	204417	204417	371563
27160	43666	2	applied	\N	\N	\N	\N	204423	204423	371569
27165	43681	2	applied	\N	\N	\N	\N	204447	204447	371592
27167	43683	1	applied	\N	\N	\N	\N	204452	204452	371597
27170	43687	2	applied	\N	\N	\N	\N	204464	204464	371609
27176	43707	2	applied	\N	\N	\N	\N	204484	204484	371629
27177	43712	4	applied	\N	\N	\N	\N	204489	204489	371634
27179	43716	2	applied	\N	\N	\N	\N	204499	204499	371644
27180	42957	2	applied	\N	\N	\N	\N	204505	204505	371650
27180	43067	36	applied	\N	\N	\N	\N	204539	204539	371684
27180	43124	53	applied	\N	\N	\N	\N	204556	204556	371701
27180	43174	71	applied	\N	\N	\N	\N	204573	204573	371718
27180	43225	88	applied	\N	\N	\N	\N	204590	204590	371735
27180	43272	103	applied	\N	\N	\N	\N	204605	204605	371750
27180	43284	107	applied	\N	\N	\N	\N	204609	204609	371754
27180	43335	124	applied	\N	\N	\N	\N	204626	204626	371771
27191	43736	1	applied	\N	\N	\N	\N	204666	204666	371811
27193	43741	3	applied	\N	\N	\N	\N	204674	204674	371819
27195	43637	7	applied	\N	\N	\N	\N	204686	204686	371831
27195	43686	24	applied	\N	\N	\N	\N	204703	204703	371848
27195	43738	42	applied	\N	\N	\N	\N	204720	204720	371865
27195	43635	59	applied	\N	\N	\N	\N	204737	204737	371882
27195	43687	76	applied	\N	\N	\N	\N	204754	204754	371899
27195	43644	99	applied	\N	\N	\N	\N	204777	204777	371922
27195	43651	100	applied	\N	\N	\N	\N	204778	204778	371923
27197	43752	0	applied	\N	\N	\N	\N	204810	204810	371955
27198	43759	4	applied	\N	\N	1000000000	\N	204817	204817	371962
27207	43776	3	applied	\N	\N	\N	\N	204856	204856	372001
27209	43778	0	applied	\N	\N	\N	\N	204858	204858	372003
27213	43583	8	applied	\N	\N	\N	\N	204878	204878	372023
27213	43637	25	applied	\N	\N	\N	\N	204895	204895	372040
27213	43686	42	applied	\N	\N	\N	\N	204912	204912	372057
27213	43738	60	applied	\N	\N	\N	\N	204929	204929	372074
27213	43786	77	applied	\N	\N	\N	\N	204946	204946	372091
27214	43798	14	applied	\N	\N	\N	\N	204973	204973	372118
27215	43788	4	applied	\N	\N	\N	\N	204984	204984	372129
27215	43801	17	applied	\N	\N	\N	\N	204997	204997	372142
27215	43802	18	applied	\N	\N	\N	\N	204998	204998	372143
27216	43748	0	applied	\N	\N	\N	\N	205001	205001	372146
27216	43790	17	applied	\N	\N	\N	\N	205018	205018	372163
27216	43737	34	applied	\N	\N	\N	\N	205035	205035	372180
27216	43795	56	applied	\N	\N	\N	\N	205056	205056	372201
27216	43796	57	applied	\N	\N	\N	\N	205057	205057	372202
27218	43808	4	applied	\N	\N	\N	\N	205083	205083	372228
27222	43815	1	applied	\N	\N	\N	\N	205104	205104	372249
27223	43818	1	applied	\N	\N	\N	\N	205107	205107	372252
27226	43819	2	applied	\N	\N	\N	\N	205117	205117	372262
27227	43818	1	applied	\N	\N	\N	\N	205119	205119	372264
27233	43829	0	applied	\N	\N	\N	\N	205142	205142	372287
27242	43851	3	applied	\N	\N	1000000000	\N	205170	205170	372315
27244	43851	3	applied	\N	\N	1000000000	\N	205178	205178	372323
27250	43856	1	applied	\N	\N	\N	\N	205193	205193	372338
27251	43631	15	applied	\N	\N	\N	\N	205210	205210	372355
27251	43685	32	applied	\N	\N	\N	\N	205227	205227	372372
27251	43735	49	applied	\N	\N	\N	\N	205244	205244	372389
27251	43785	66	applied	\N	\N	\N	\N	205261	205261	372406
27251	43766	100	applied	\N	\N	1000000000	\N	205294	205294	372439
27251	43627	120	applied	\N	\N	\N	\N	205314	205314	372459
27263	43870	0	applied	\N	\N	\N	\N	205341	205341	372486
27265	43870	0	applied	\N	\N	\N	\N	205346	205346	372491
27269	43691	13	applied	\N	\N	\N	\N	205368	205368	372513
27269	43743	30	applied	\N	\N	\N	\N	205385	205385	372530
27269	43706	47	applied	\N	\N	\N	\N	205402	205402	372547
27270	43800	11	applied	\N	\N	\N	\N	205429	205429	372574
27270	43843	29	applied	\N	\N	\N	\N	205446	205446	372591
27277	43887	2	applied	\N	\N	\N	\N	205480	205480	372625
27279	43888	0	applied	\N	\N	\N	\N	205484	205484	372629
27281	43892	1	applied	\N	\N	\N	\N	205488	205488	372633
27283	43874	0	applied	\N	\N	\N	\N	205498	205498	372643
27284	43579	1	applied	\N	\N	\N	\N	205509	205509	372654
27284	43605	9	applied	\N	\N	\N	\N	205517	205517	372662
27284	43655	26	applied	\N	\N	\N	\N	205534	205534	372679
27284	43705	43	applied	\N	\N	\N	\N	205551	205551	372696
27284	43755	60	applied	\N	\N	\N	\N	205568	205568	372713
27284	43806	77	applied	\N	\N	\N	\N	205585	205585	372730
27284	43757	110	applied	\N	\N	1000000000	\N	205617	205617	372762
27284	43591	121	applied	\N	\N	\N	\N	205628	205628	372773
27284	43600	124	applied	\N	\N	\N	\N	205631	205631	372776
27294	43914	1	applied	\N	\N	\N	\N	205653	205653	372798
27298	43920	0	applied	\N	\N	\N	\N	205666	205666	372811
27299	43926	0	applied	\N	\N	\N	\N	205672	205672	372817
27302	43935	3	applied	\N	\N	\N	\N	205684	205684	372829
27302	43936	4	applied	\N	\N	\N	\N	205685	205685	372830
27306	43946	2	applied	\N	\N	\N	\N	205698	205698	372843
27314	43958	2	applied	\N	\N	\N	\N	205719	205719	372864
27319	43971	3	applied	\N	\N	\N	\N	205741	205741	372886
27320	43975	1	applied	\N	\N	\N	\N	205745	205745	372890
27324	43984	1	applied	\N	\N	\N	\N	205763	205763	372908
27335	43998	2	applied	\N	\N	\N	\N	205798	205798	372943
27336	43999	0	applied	\N	\N	\N	\N	205799	205799	372944
27342	44017	0	applied	\N	\N	\N	\N	205823	205823	372968
27353	44051	4	applied	\N	\N	\N	\N	205866	205866	373011
27355	44058	5	applied	\N	\N	\N	\N	205879	205879	373024
27356	44061	8	applied	\N	\N	\N	\N	205891	205891	373036
27358	44055	2	applied	\N	\N	\N	\N	205903	205903	373048
27358	44060	7	applied	\N	\N	\N	\N	205908	205908	373053
27360	44065	3	applied	\N	\N	\N	\N	205925	205925	373070
27134	43618	0	applied	\N	\N	\N	\N	204191	204191	371337
27367	43994	29	applied	\N	\N	\N	\N	205988	205988	373133
27367	44046	46	applied	\N	\N	\N	\N	206005	206005	373150
27370	44100	1	applied	\N	\N	\N	\N	206028	206028	373173
27373	44106	1	applied	\N	\N	\N	\N	206037	206037	373182
27375	44108	0	applied	\N	\N	\N	\N	206054	206054	373199
27379	44132	0	applied	\N	\N	\N	\N	206084	206084	373229
27381	44140	5	applied	\N	\N	\N	\N	206095	206095	373240
27384	44145	1	applied	\N	\N	\N	\N	206112	206112	373257
27388	44148	1	applied	\N	\N	\N	\N	206127	206127	373272
27390	44155	2	applied	\N	\N	\N	\N	206140	206140	373285
27390	44158	5	applied	\N	\N	\N	\N	206143	206143	373288
27392	44159	0	applied	\N	\N	\N	\N	206147	206147	373292
27395	44162	0	applied	\N	\N	\N	\N	206150	206150	373295
27395	44168	6	applied	\N	\N	\N	\N	206156	206156	373301
27395	44171	9	applied	\N	\N	\N	\N	206159	206159	373304
27409	44201	0	applied	\N	\N	\N	\N	206207	206207	373352
27411	44202	1	applied	\N	\N	\N	\N	206214	206214	373359
27419	44208	1	applied	\N	\N	\N	\N	206238	206238	373383
27422	44211	1	applied	\N	\N	\N	\N	206259	206259	373404
27423	44126	9	applied	\N	\N	\N	\N	206276	206276	373421
27423	44176	26	applied	\N	\N	\N	\N	206293	206293	373438
27426	44228	0	applied	\N	\N	\N	\N	206326	206326	373471
27428	44233	2	applied	\N	\N	\N	\N	206334	206334	373479
27431	44233	2	applied	\N	\N	\N	\N	206343	206343	373488
27434	44237	0	applied	\N	\N	\N	\N	206350	206350	373495
27443	44243	0	applied	\N	\N	\N	\N	206385	206385	373530
27448	44258	5	applied	\N	\N	\N	\N	206407	206407	373552
27449	44254	1	applied	\N	\N	\N	\N	206409	206409	373554
27449	44257	4	applied	\N	\N	\N	\N	206412	206412	373557
27451	44260	1	applied	\N	\N	\N	\N	206421	206421	373566
27458	44283	12	applied	\N	\N	\N	\N	206453	206453	373598
27461	44295	1	applied	\N	\N	\N	\N	206474	206474	373619
27462	44295	1	applied	\N	\N	\N	\N	206483	206483	373628
27462	44298	4	applied	\N	\N	\N	\N	206486	206486	373631
27467	44320	9	applied	\N	\N	\N	\N	206527	206527	373672
27468	44315	4	applied	\N	\N	\N	\N	206546	206546	373691
27468	44332	21	applied	\N	\N	\N	\N	206563	206563	373708
27469	44336	1	applied	\N	\N	\N	\N	206567	206567	373712
27472	44345	2	applied	\N	\N	\N	\N	206583	206583	373728
27477	44364	14	applied	\N	\N	\N	\N	206609	206609	373754
27478	44360	10	applied	\N	\N	\N	\N	206631	206631	373776
27479	44381	5	applied	\N	\N	\N	\N	206652	206652	373797
27480	44385	1	applied	\N	\N	\N	\N	206656	206656	373801
27481	44391	7	applied	\N	\N	\N	\N	206680	206680	373825
27481	44394	10	applied	\N	\N	\N	\N	206683	206683	373828
27482	44407	5	applied	\N	\N	\N	\N	206696	206696	373841
27484	44420	3	applied	\N	\N	\N	\N	206709	206709	373854
27485	44446	5	applied	\N	\N	\N	\N	206735	206735	373880
27486	44462	13	applied	\N	\N	\N	\N	206751	206751	373896
27487	44463	15	applied	\N	\N	\N	\N	206779	206779	373924
27488	44452	3	applied	\N	\N	\N	\N	206795	206795	373940
27488	44455	6	applied	\N	\N	\N	\N	206798	206798	373943
27488	44472	24	applied	\N	\N	\N	\N	206815	206815	373960
27489	44450	1	applied	\N	\N	\N	\N	206820	206820	373965
27489	44467	19	applied	\N	\N	\N	\N	206837	206837	373982
27494	44498	5	applied	\N	\N	\N	\N	206872	206872	374017
27498	44506	1	applied	\N	\N	\N	\N	206883	206883	374028
27499	44508	3	applied	\N	\N	\N	\N	206889	206889	374034
27500	44509	0	applied	\N	\N	\N	\N	206890	206890	374035
27503	44516	4	applied	\N	\N	\N	\N	206903	206903	374048
27507	44535	5	applied	\N	\N	\N	\N	206922	206922	374067
27508	44544	14	applied	\N	\N	\N	\N	206946	206946	374091
27515	44559	3	applied	\N	\N	\N	\N	206971	206971	374116
27517	44561	1	applied	\N	\N	\N	\N	206976	206976	374121
27521	44584	2	applied	\N	\N	\N	\N	207002	207002	374147
27523	44590	1	applied	\N	\N	\N	\N	207008	207008	374153
27528	44578	10	applied	\N	\N	1000000000	\N	207035	207035	374180
27528	44304	30	applied	\N	\N	\N	\N	207055	207055	374200
27528	44329	47	applied	\N	\N	\N	\N	207072	207072	374217
27528	44362	64	applied	\N	\N	\N	\N	207089	207089	374234
27528	44377	76	applied	\N	\N	\N	\N	207101	207101	374246
27528	44381	80	applied	\N	\N	\N	\N	207105	207105	374250
27528	44389	83	applied	\N	\N	\N	\N	207108	207108	374253
27534	44563	4	applied	\N	\N	\N	\N	207137	207137	374282
27534	43914	21	applied	\N	\N	\N	\N	207154	207154	374299
27534	43965	38	applied	\N	\N	\N	\N	207171	207171	374316
27534	44017	55	applied	\N	\N	\N	\N	207188	207188	374333
27534	44064	72	applied	\N	\N	\N	\N	207205	207205	374350
27536	44612	2	applied	\N	\N	\N	\N	207216	207216	374361
27544	44620	0	applied	\N	\N	\N	\N	207248	207248	374393
27546	44626	2	applied	\N	\N	\N	\N	207263	207263	374408
27546	44632	8	applied	\N	\N	\N	\N	207269	207269	374414
27548	44637	4	applied	\N	\N	\N	\N	207283	207283	374428
27550	44641	2	applied	\N	\N	\N	\N	207290	207290	374435
27552	44644	0	applied	\N	\N	\N	\N	207293	207293	374438
27561	44656	3	applied	\N	\N	\N	\N	207327	207327	374472
27564	44659	2	applied	\N	\N	\N	\N	207337	207337	374482
27569	44670	1	applied	\N	\N	\N	\N	207354	207354	374499
27577	44273	4	applied	\N	\N	\N	\N	207381	207381	374526
27579	44682	1	applied	\N	\N	\N	\N	207402	207402	374547
27580	44686	5	applied	\N	\N	\N	\N	207412	207412	374557
27585	44701	2	applied	\N	\N	\N	\N	207431	207431	374576
27588	44710	2	applied	\N	\N	\N	\N	207442	207442	374587
27588	44709	5	applied	\N	\N	\N	\N	207445	207445	374590
27591	44711	3	applied	\N	\N	\N	\N	207456	207456	374601
27596	44729	8	applied	\N	\N	\N	\N	207488	207488	374631
27598	44734	4	applied	\N	\N	\N	\N	207500	207500	374643
27605	44753	1	applied	\N	\N	\N	\N	207531	207531	374673
27610	44721	0	applied	\N	\N	\N	\N	207551	207551	374693
27610	44745	17	applied	\N	\N	\N	\N	207568	207568	374709
27610	44499	41	applied	\N	\N	\N	\N	207592	207592	374732
27610	44509	44	applied	\N	\N	\N	\N	207595	207595	374735
27610	44560	62	applied	\N	\N	\N	\N	207612	207612	374752
27610	44620	79	applied	\N	\N	\N	\N	207629	207629	374769
27610	44673	96	applied	\N	\N	\N	\N	207646	207646	374786
27610	44731	113	applied	\N	\N	\N	\N	207663	207663	374803
27611	44336	5	applied	\N	\N	\N	\N	207681	207681	374821
27611	44402	23	applied	\N	\N	\N	\N	207698	207698	374836
27611	44505	40	applied	\N	\N	\N	\N	207715	207715	374853
27611	44557	57	applied	\N	\N	\N	\N	207732	207732	374870
27611	44617	74	applied	\N	\N	\N	\N	207749	207749	374887
27617	44780	6	applied	\N	\N	\N	\N	207786	207786	374924
27617	44782	9	applied	\N	\N	\N	\N	207789	207789	374927
27621	44797	0	applied	\N	\N	\N	\N	207806	207806	374944
27625	44806	3	applied	\N	\N	\N	\N	207822	207822	374960
27629	44816	3	applied	\N	\N	\N	\N	207842	207842	374980
27634	44827	2	applied	\N	\N	\N	\N	207859	207859	374997
27640	44834	6	applied	\N	\N	\N	\N	207869	207869	375007
27641	44833	5	applied	\N	\N	\N	\N	207880	207880	375018
27642	44836	8	applied	\N	\N	\N	\N	207895	207895	375033
27642	44839	11	applied	\N	\N	\N	\N	207898	207898	375036
27643	44831	3	applied	\N	\N	\N	\N	207902	207902	375040
27651	44721	2	applied	\N	\N	\N	\N	207955	207955	375093
27651	44746	19	applied	\N	\N	\N	\N	207972	207972	375109
27651	44773	36	applied	\N	\N	\N	\N	207989	207989	375125
27651	44825	54	applied	\N	\N	\N	\N	208006	208006	375142
27651	44710	71	applied	\N	\N	\N	\N	208023	208023	375159
27651	44764	88	applied	\N	\N	\N	\N	208040	208040	375176
27651	44788	95	applied	\N	\N	\N	\N	208047	208047	375183
27651	44796	98	applied	\N	\N	\N	\N	208050	208050	375186
27651	44847	115	applied	\N	\N	\N	\N	208067	208067	375203
27655	44871	2	applied	\N	\N	\N	\N	208096	208096	375232
27656	44874	2	applied	\N	\N	\N	\N	208099	208099	375235
27662	44884	0	applied	\N	\N	\N	\N	208115	208115	375251
27665	44897	2	applied	\N	\N	\N	\N	208136	208136	375272
27672	44902	0	applied	\N	\N	\N	\N	208155	208155	375291
27675	44902	1	applied	\N	\N	\N	\N	208164	208164	375300
27677	44901	0	applied	\N	\N	\N	\N	208170	208170	375306
27683	44753	25	applied	\N	\N	\N	\N	208211	208211	375347
27683	44897	42	applied	\N	\N	\N	\N	208228	208228	375364
27683	44834	60	applied	\N	\N	\N	\N	208245	208245	375381
27683	44883	75	applied	\N	\N	\N	\N	208260	208260	375396
27685	44918	3	applied	\N	\N	\N	\N	208266	208266	375402
27690	44928	0	applied	\N	\N	\N	\N	208292	208292	375428
27692	44930	2	applied	\N	\N	\N	\N	208300	208300	375436
27698	44915	0	applied	\N	\N	\N	\N	208312	208312	375448
27698	44506	17	applied	\N	\N	\N	\N	208329	208329	375463
27698	44292	34	applied	\N	\N	\N	\N	208346	208346	375480
27698	44315	49	applied	\N	\N	\N	\N	208361	208361	375495
27698	44344	66	applied	\N	\N	\N	\N	208378	208378	375512
27698	44368	83	applied	\N	\N	\N	\N	208395	208395	375529
27699	44939	1	applied	\N	\N	\N	\N	208412	208412	375546
27702	44940	2	applied	\N	\N	\N	\N	208431	208431	375565
27703	44948	4	applied	\N	\N	\N	\N	208439	208439	375573
27706	44953	1	applied	\N	\N	\N	\N	208464	208464	375598
27706	44956	4	applied	\N	\N	\N	\N	208467	208467	375601
27717	44980	0	applied	\N	\N	\N	\N	208503	208503	375637
27720	44722	5	applied	\N	\N	\N	\N	208514	208514	375648
27720	44747	22	applied	\N	\N	\N	\N	208531	208531	375664
27720	44648	39	applied	\N	\N	\N	\N	208548	208548	375680
27720	44703	56	applied	\N	\N	\N	\N	208565	208565	375697
27720	44757	72	applied	\N	\N	\N	\N	208580	208580	375712
27720	44813	89	applied	\N	\N	\N	\N	208597	208597	375729
27720	44866	106	applied	\N	\N	\N	\N	208614	208614	375746
27720	44909	120	applied	\N	\N	\N	\N	208628	208628	375760
27720	44912	121	applied	\N	\N	\N	\N	208629	208629	375761
27723	44983	1	applied	\N	\N	\N	\N	208639	208639	375771
27734	44999	4	applied	\N	\N	\N	\N	208671	208671	375803
27736	45004	1	applied	\N	\N	\N	\N	208676	208676	375808
27741	45010	3	applied	\N	\N	\N	\N	208688	208688	375820
27759	45044	7	applied	\N	\N	\N	\N	208743	208743	375875
27763	45049	0	applied	\N	\N	\N	\N	208760	208760	375892
27772	45060	1	applied	\N	\N	\N	\N	208777	208777	375909
27774	45070	0	applied	\N	\N	\N	\N	208787	208787	375919
27777	45077	1	applied	\N	\N	\N	\N	208796	208796	375928
27778	45077	1	applied	\N	\N	\N	\N	208798	208798	375930
27781	45078	0	applied	\N	\N	\N	\N	208805	208805	375937
27781	45079	1	applied	\N	\N	\N	\N	208806	208806	375938
27786	45098	1	applied	\N	\N	\N	\N	208829	208829	375961
27793	45111	2	applied	\N	\N	\N	\N	208853	208853	375985
27794	45117	5	applied	\N	\N	\N	\N	208859	208859	375991
27800	45122	1	applied	\N	\N	\N	\N	208878	208878	376010
27808	45136	2	applied	\N	\N	\N	\N	208917	208917	376049
27809	45134	0	applied	\N	\N	\N	\N	208921	208921	376053
27814	45159	1	applied	\N	\N	\N	\N	208946	208946	376078
27819	45170	0	applied	\N	\N	\N	\N	208966	208966	376098
27823	45181	2	applied	\N	\N	\N	\N	208980	208980	376112
27826	45182	0	applied	\N	\N	\N	\N	208987	208987	376119
27830	45191	0	applied	\N	\N	\N	\N	209008	209008	376140
27831	45193	2	applied	\N	\N	\N	\N	209022	209022	376154
27837	45214	2	applied	\N	\N	\N	\N	209049	209049	376181
27838	45216	1	applied	\N	\N	\N	\N	209051	209051	376183
27841	45222	1	applied	\N	\N	\N	\N	209063	209063	376195
27848	45242	0	applied	\N	\N	\N	\N	209098	209098	376230
27853	45252	2	applied	\N	\N	\N	\N	209114	209114	376246
27859	45263	0	applied	\N	\N	\N	\N	209137	209137	376269
27860	45269	0	applied	\N	\N	\N	\N	209143	209143	376275
27867	45293	1	applied	\N	\N	\N	\N	209170	209170	376301
27871	45134	0	applied	\N	\N	\N	\N	209181	209181	376312
27871	45141	3	applied	\N	\N	\N	\N	209184	209184	376315
27871	45192	20	applied	\N	\N	\N	\N	209201	209201	376332
27871	45245	37	applied	\N	\N	\N	\N	209218	209218	376349
27871	45281	50	applied	\N	\N	\N	\N	209230	209230	376361
27871	45160	85	applied	\N	\N	\N	\N	209265	209265	376395
27871	45287	55	failed	Amount_insufficient_to_create_account	\N	\N	\N	209235	209235	\N
27871	45211	102	applied	\N	\N	\N	\N	209282	209282	376412
27871	45261	119	applied	\N	\N	\N	\N	209299	209299	376429
27880	45311	1	applied	\N	\N	\N	\N	209331	209331	376461
27882	44954	3	applied	\N	\N	\N	\N	209349	209349	376479
27887	45343	1	applied	\N	\N	\N	\N	209402	209402	376529
27882	45287	24	failed	Amount_insufficient_to_create_account	\N	\N	\N	209370	209370	\N
27889	45344	2	applied	\N	\N	\N	\N	209409	209409	376536
27895	45358	4	applied	\N	\N	\N	\N	209429	209429	376556
27896	45359	5	applied	\N	\N	\N	\N	209437	209437	376564
27902	45374	1	applied	\N	\N	\N	\N	209462	209462	376589
27905	45390	8	applied	\N	\N	\N	\N	209478	209478	376605
27907	45406	2	applied	\N	\N	\N	\N	209494	209494	376621
27911	45416	3	applied	\N	\N	\N	\N	209510	209510	376637
27915	45425	0	applied	\N	\N	\N	\N	209525	209525	376652
27922	45440	0	applied	\N	\N	\N	\N	209555	209555	376682
27924	45445	2	applied	\N	\N	\N	\N	209562	209562	376689
27616	44783	10	applied	\N	\N	\N	\N	207778	207778	374916
27938	45482	1	applied	\N	\N	\N	\N	209622	209622	376749
27940	45484	0	applied	\N	\N	\N	\N	209627	209627	376754
27944	45507	1	applied	\N	\N	\N	\N	209650	209650	376777
27946	45508	2	applied	\N	\N	\N	\N	209657	209657	376784
27947	45514	5	applied	\N	\N	\N	\N	209663	209663	376790
27948	45513	4	applied	\N	\N	\N	\N	209668	209668	376795
27951	45516	1	applied	\N	\N	\N	\N	209677	209677	376804
27953	45525	4	applied	\N	\N	\N	\N	209692	209692	376819
27959	45536	1	applied	\N	\N	\N	\N	209718	209718	376845
27960	45538	3	applied	\N	\N	\N	\N	209725	209725	376852
27967	45560	5	applied	\N	\N	\N	\N	209768	209768	376895
27969	45559	4	applied	\N	\N	\N	\N	209789	209789	376916
27970	45555	0	applied	\N	\N	\N	\N	209796	209796	376923
27972	45560	5	applied	\N	\N	\N	\N	209818	209818	376945
27972	45563	8	applied	\N	\N	\N	\N	209821	209821	376948
27973	45555	0	applied	\N	\N	\N	\N	209824	209824	376951
27973	45564	9	applied	\N	\N	\N	\N	209833	209833	376960
27977	45351	19	applied	\N	\N	\N	\N	209863	209863	376990
27977	45405	36	applied	\N	\N	\N	\N	209880	209880	377007
27977	45457	54	applied	\N	\N	\N	\N	209897	209897	377024
27977	45469	58	applied	\N	\N	\N	\N	209901	209901	377028
27977	45509	70	applied	\N	\N	\N	\N	209913	209913	377040
27977	45556	87	applied	\N	\N	\N	\N	209930	209930	377057
27977	45312	104	applied	\N	\N	\N	\N	209947	209947	377074
27977	45362	121	applied	\N	\N	\N	\N	209964	209964	377091
27984	45588	2	applied	\N	\N	\N	\N	209997	209997	377124
27988	45604	3	applied	\N	\N	\N	\N	210022	210022	377149
27990	45605	4	applied	\N	\N	\N	\N	210041	210041	377168
27995	45615	2	applied	\N	\N	\N	\N	210060	210060	377187
28000	45618	2	applied	\N	\N	\N	\N	210072	210072	377199
28005	45625	3	applied	\N	\N	\N	\N	210085	210085	377212
28009	45595	9	applied	\N	\N	\N	\N	210109	210109	377236
28009	45389	24	applied	\N	\N	\N	\N	210124	210124	377251
28009	45400	27	applied	\N	\N	\N	\N	210127	210127	377254
28009	45451	44	applied	\N	\N	\N	\N	210144	210144	377271
28009	45507	62	applied	\N	\N	\N	\N	210161	210161	377288
28009	45546	74	applied	\N	\N	\N	\N	210173	210173	377300
28012	45634	1	applied	\N	\N	\N	\N	210190	210190	377317
28013	45638	2	applied	\N	\N	\N	\N	210194	210194	377321
28022	45664	2	applied	\N	\N	\N	\N	210226	210226	377353
28023	45662	0	applied	\N	\N	\N	\N	210227	210227	377354
28033	45679	1	applied	\N	\N	\N	\N	210253	210253	377380
28036	44856	0	applied	\N	\N	\N	\N	210285	210285	377412
28036	44726	17	applied	\N	\N	\N	\N	210302	210302	210302
28036	44745	19	applied	\N	\N	\N	\N	210304	210304	377430
28036	44746	20	applied	\N	\N	\N	\N	210305	210305	377431
28036	44773	38	applied	\N	\N	\N	\N	210322	210322	377447
28036	44825	55	applied	\N	\N	\N	\N	210339	210339	377464
28036	44869	69	applied	\N	\N	\N	\N	210353	210353	377478
28036	44917	85	applied	\N	\N	\N	\N	210369	210369	377494
28036	44953	102	applied	\N	\N	\N	\N	210386	210386	377511
28036	44993	119	applied	\N	\N	\N	\N	210403	210403	377528
28049	45714	1	applied	\N	\N	\N	\N	210441	210441	377566
28050	45423	0	applied	\N	\N	\N	\N	210443	210443	377568
28054	45718	2	applied	\N	\N	\N	\N	210459	210459	377584
28062	45729	1	applied	\N	\N	\N	\N	210482	210482	377607
28065	45737	6	applied	\N	\N	\N	\N	210496	210496	377621
28067	45740	0	applied	\N	\N	\N	\N	210505	210505	377630
28073	45012	5	applied	\N	\N	\N	\N	210540	210540	377665
28073	45023	8	applied	\N	\N	\N	\N	210543	210543	377668
28073	45057	26	applied	\N	\N	\N	\N	210560	210560	377685
28073	45093	43	applied	\N	\N	\N	\N	210577	210577	377702
28073	45125	55	applied	\N	\N	\N	\N	210589	210589	377714
28073	45134	58	applied	\N	\N	\N	\N	210592	210592	377717
28073	45185	75	applied	\N	\N	\N	\N	210609	210609	377734
28073	45234	92	applied	\N	\N	\N	\N	210626	210626	377751
28073	45286	109	applied	\N	\N	\N	\N	210643	210643	377768
28074	45760	4	applied	\N	\N	\N	\N	210664	210664	377789
28075	45762	6	applied	\N	\N	\N	\N	210681	210681	377806
28076	45756	0	applied	\N	\N	\N	\N	210685	210685	377810
28079	45758	2	applied	\N	\N	\N	\N	210708	210708	377833
28080	45774	8	applied	\N	\N	\N	\N	210733	210733	377858
28081	45773	7	applied	\N	\N	\N	\N	210751	210751	377876
28082	45780	0	applied	\N	\N	\N	\N	210763	210763	377888
28084	45798	5	applied	\N	\N	\N	\N	210781	210781	377906
28086	45797	4	applied	\N	\N	\N	\N	210792	210792	377917
28087	45798	5	applied	\N	\N	\N	\N	210799	210799	377924
28097	45812	3	applied	\N	\N	\N	\N	210834	210834	377959
28099	45816	3	applied	\N	\N	\N	\N	210848	210848	377973
28100	45819	6	applied	\N	\N	\N	\N	210861	210861	377986
28104	45233	10	applied	\N	\N	\N	\N	210884	210884	378009
28104	45278	25	applied	\N	\N	\N	\N	210899	210899	378024
28104	45286	28	applied	\N	\N	\N	\N	210902	210902	378027
28104	45342	45	applied	\N	\N	\N	\N	210919	210919	378044
28104	45386	62	applied	\N	\N	\N	\N	210936	210936	378061
28104	45437	76	applied	\N	\N	\N	\N	210949	210949	378074
28104	45446	79	applied	\N	\N	\N	\N	210952	210952	378077
28104	45498	96	applied	\N	\N	\N	\N	210969	210969	378094
28104	45551	113	applied	\N	\N	\N	\N	210986	210986	378111
28105	45833	4	applied	\N	\N	\N	\N	211003	211003	378128
28112	45847	1	applied	\N	\N	1000000000	\N	211037	211037	378162
28113	45854	4	applied	\N	\N	\N	\N	211044	211044	378169
28118	45866	0	applied	\N	\N	\N	\N	211066	211066	378191
28125	45878	0	applied	\N	\N	\N	\N	211086	211086	378211
28134	45885	1	applied	\N	\N	1000000000	\N	211104	211104	378229
28139	45896	0	applied	\N	\N	\N	\N	211118	211118	378243
28142	45899	1	applied	\N	\N	\N	\N	211125	211125	378250
28143	45901	1	applied	\N	\N	\N	\N	211127	211127	378252
28146	45889	3	applied	\N	\N	1000000000	\N	211140	211140	378265
28150	45920	3	applied	\N	\N	\N	\N	211164	211164	378289
28158	45952	4	applied	\N	\N	\N	\N	211199	211199	378324
28159	45949	1	applied	\N	\N	\N	\N	211203	211203	378328
28162	45953	5	applied	\N	\N	\N	\N	211228	211228	378353
28164	45955	0	applied	\N	\N	\N	\N	211237	211237	378362
28169	45844	13	applied	\N	\N	\N	\N	211259	211259	378384
28171	45957	3	applied	\N	\N	\N	\N	211278	211278	378403
28175	45968	1	applied	\N	\N	\N	\N	211296	211296	378421
28179	45968	1	applied	\N	\N	\N	\N	211304	211304	378429
28186	45979	2	applied	\N	\N	\N	\N	211327	211327	378452
28200	46005	1	applied	\N	\N	\N	\N	211364	211364	378489
27934	45471	3	applied	\N	\N	\N	\N	209601	209601	376728
28209	46016	0	applied	\N	\N	\N	\N	211381	211381	378506
28211	46019	0	applied	\N	\N	\N	\N	211387	211387	378512
28224	46035	1	applied	\N	\N	\N	\N	211417	211417	378542
28226	46037	0	applied	\N	\N	\N	\N	211421	211421	378546
28243	46062	0	applied	\N	\N	\N	\N	211476	211476	378591
28231	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	211439	211439	\N
28655	46704	4	applied	\N	\N	\N	\N	213356	213356	380437
28232	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	211445	211445	\N
28243	46063	1	applied	\N	\N	\N	\N	211477	211477	378592
28250	45490	15	applied	\N	\N	1000000000	\N	211509	211509	378618
28250	45938	35	applied	\N	\N	\N	\N	211529	211529	378638
28250	46017	45	applied	\N	\N	\N	\N	211539	211539	378648
28252	46076	4	applied	\N	\N	1000000000	\N	211557	211557	378665
28250	46049	52	failed	Amount_insufficient_to_create_account	\N	\N	\N	211546	211546	\N
28264	46090	1	applied	\N	\N	\N	\N	211585	211585	378693
28267	46092	1	applied	\N	\N	\N	\N	211591	211591	378699
28283	46109	1	applied	\N	\N	\N	\N	211642	211642	378746
28268	46049	16	failed	Amount_insufficient_to_create_account	\N	\N	\N	211609	211609	\N
28284	46112	1	applied	\N	\N	\N	\N	211645	211645	378749
28297	46123	3	applied	\N	\N	\N	\N	211676	211676	378780
28301	46133	1	applied	\N	\N	\N	\N	211688	211688	378791
28309	46151	1	applied	\N	\N	\N	\N	211718	211718	378821
28313	46168	1	applied	\N	\N	\N	\N	211738	211738	378841
28314	46132	7	applied	\N	\N	\N	\N	211746	211746	378849
28314	46123	24	applied	\N	\N	\N	\N	211763	211763	378866
28314	46139	41	applied	\N	\N	\N	\N	211780	211780	378882
28316	46173	4	applied	\N	\N	\N	\N	211799	211799	378901
28320	46106	0	applied	\N	\N	\N	\N	211809	211809	211809
28329	46190	1	applied	\N	\N	\N	\N	211837	211837	378934
28331	46196	5	applied	\N	\N	\N	\N	211849	211849	378946
28335	46197	0	applied	\N	\N	\N	\N	211860	211860	378957
28336	46200	1	applied	\N	\N	\N	\N	211863	211863	378960
28336	46201	2	applied	\N	\N	\N	\N	211864	211864	378961
28346	46225	4	applied	\N	\N	\N	\N	211916	211916	379013
28347	46222	1	applied	\N	\N	\N	\N	211921	211921	379018
28348	46109	7	applied	\N	\N	\N	\N	211935	211935	379030
28348	46162	14	applied	\N	\N	\N	\N	211942	211942	379037
28360	46247	1	applied	\N	\N	\N	\N	211970	211970	379065
28361	46246	0	applied	\N	\N	\N	\N	211971	211971	379066
28364	46250	1	applied	\N	\N	\N	\N	211980	211980	379075
28371	46259	1	applied	\N	\N	\N	\N	211998	211998	379093
28377	46076	16	applied	\N	\N	1000000000	\N	212025	212025	379116
28388	46277	2	applied	\N	\N	\N	\N	212056	212056	379147
28393	46277	2	applied	\N	\N	\N	\N	212075	212075	379166
28401	46289	2	applied	\N	\N	\N	\N	212093	212093	379184
28409	46294	1	applied	\N	\N	1000000000	\N	212113	212113	379204
28414	46275	1	applied	\N	\N	\N	\N	212125	212125	379216
28414	46268	10	applied	\N	\N	\N	\N	212134	212134	379225
28414	46263	28	applied	\N	\N	\N	\N	212151	212151	379242
28419	46312	1	applied	\N	\N	\N	\N	212180	212180	379271
28424	46327	10	applied	\N	\N	\N	\N	212206	212206	379297
28428	46302	3	applied	\N	\N	\N	\N	212219	212219	379310
28428	46300	20	applied	\N	\N	\N	\N	212236	212236	379327
28428	46303	22	applied	\N	\N	\N	\N	212238	212238	379329
28428	46330	35	applied	\N	\N	\N	\N	212251	212251	379342
28435	46349	1	applied	\N	\N	\N	\N	212273	212273	379364
28436	46093	29	applied	\N	\N	\N	\N	212303	212303	379390
28436	46047	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	212280	212280	\N
28441	46354	2	applied	\N	\N	\N	\N	212325	212325	379411
28443	46355	0	applied	\N	\N	\N	\N	212328	212328	379414
28449	46365	3	applied	\N	\N	\N	\N	212355	212355	379441
28452	46368	0	applied	\N	\N	\N	\N	212360	212360	379446
28459	46378	0	applied	\N	\N	\N	\N	212378	212378	379464
28465	46383	1	applied	\N	\N	\N	\N	212391	212391	379477
28469	46388	2	applied	\N	\N	\N	\N	212400	212400	379486
28477	46403	0	applied	\N	\N	\N	\N	212421	212421	379507
28480	46406	1	applied	\N	\N	\N	\N	212428	212428	379514
28492	46419	3	applied	\N	\N	\N	\N	212465	212465	379551
28492	46422	6	applied	\N	\N	\N	\N	212468	212468	379554
28493	46424	1	applied	\N	\N	\N	\N	212470	212470	379556
28508	46270	0	applied	\N	\N	1000000000	\N	212511	212511	379597
28508	46438	18	applied	\N	\N	\N	\N	212529	212529	379610
28510	46445	1	applied	\N	\N	\N	\N	212536	212536	379617
28513	46448	1	applied	\N	\N	\N	\N	212547	212547	379628
28515	46454	2	applied	\N	\N	\N	\N	212558	212558	379639
28524	46465	3	applied	\N	\N	\N	\N	212590	212590	379671
28526	46469	2	applied	\N	\N	\N	\N	212599	212599	379680
28527	46476	3	applied	\N	\N	\N	\N	212606	212606	379687
28541	46496	0	applied	\N	\N	\N	\N	212646	212646	379727
28542	46412	1	applied	\N	\N	\N	\N	212649	212649	379730
28542	46491	16	applied	\N	\N	1000000000	\N	212664	212664	379745
28543	46499	0	applied	\N	\N	\N	\N	212665	212665	379746
28555	46508	0	applied	\N	\N	\N	\N	212698	212698	379779
28559	46517	4	applied	\N	\N	1000000000	\N	212716	212716	379797
28560	46522	0	applied	\N	\N	\N	\N	212725	212725	379806
28562	46526	1	applied	\N	\N	\N	\N	212738	212738	379819
28566	46539	2	applied	\N	\N	\N	\N	212765	212765	379846
28567	46544	0	applied	\N	\N	\N	\N	212770	212770	379851
28568	46544	0	applied	\N	\N	\N	\N	212779	212779	379860
28569	46487	11	applied	\N	\N	\N	\N	212798	212798	379879
28570	46552	8	applied	\N	\N	\N	\N	212817	212817	379898
28573	46477	4	applied	\N	\N	\N	\N	212834	212834	379915
28573	46526	20	applied	\N	\N	\N	\N	212850	212850	379931
28573	46471	36	applied	\N	\N	\N	\N	212866	212866	379947
28573	46482	54	applied	\N	\N	\N	\N	212883	212883	379964
28573	46524	68	applied	\N	\N	\N	\N	212897	212897	379978
28573	46530	69	applied	\N	\N	\N	\N	212898	212898	379979
28574	46553	0	applied	\N	\N	\N	\N	212927	212927	380008
28575	46558	5	applied	\N	\N	\N	\N	212938	212938	380019
28583	46572	0	applied	\N	\N	\N	\N	212977	212977	380058
28585	46576	0	applied	\N	\N	\N	\N	212985	212985	380066
28590	46589	2	applied	\N	\N	\N	\N	213004	213004	380085
28593	46602	7	applied	\N	\N	\N	\N	213020	213020	380101
28596	46600	5	applied	\N	\N	\N	\N	213045	213045	380126
28600	46612	2	applied	\N	\N	\N	\N	213060	213060	380141
28602	46610	0	applied	\N	\N	\N	\N	213064	213064	380145
28603	46613	0	applied	\N	\N	\N	\N	213067	213067	380148
28604	46613	0	applied	\N	\N	\N	\N	213070	213070	380151
28604	46614	1	applied	\N	\N	\N	\N	213071	213071	380152
28207	46013	1	applied	\N	\N	\N	\N	211378	211378	378503
28623	46471	8	applied	\N	\N	\N	\N	213138	213138	380219
28624	46644	0	applied	\N	\N	\N	\N	213156	213156	380237
28627	46648	3	applied	\N	\N	\N	\N	213177	213177	380258
28633	46664	0	applied	\N	\N	\N	\N	213198	213198	380279
28634	46667	1	applied	\N	\N	\N	\N	213201	213201	380282
28639	46451	10	applied	\N	\N	\N	\N	213228	213228	380309
28639	46461	17	applied	\N	\N	\N	\N	213235	213235	380316
28639	46466	19	applied	\N	\N	\N	\N	213237	213237	380318
28639	46520	36	applied	\N	\N	\N	\N	213254	213254	380335
28639	46573	53	applied	\N	\N	\N	\N	213271	213271	380352
28639	46617	66	applied	\N	\N	\N	\N	213284	213284	380365
28639	46629	70	applied	\N	\N	\N	\N	213287	213287	380368
28642	46677	1	applied	\N	\N	\N	\N	213306	213306	380387
28654	46704	4	applied	\N	\N	\N	\N	213350	213350	380431
28656	46700	0	applied	\N	\N	\N	\N	213358	213358	380439
28664	46713	1	applied	\N	\N	\N	\N	213383	213383	380464
28665	46344	14	applied	\N	\N	1000000000	\N	213398	213398	380479
28665	46469	36	applied	\N	\N	\N	\N	213419	213419	380500
28665	46524	53	applied	\N	\N	\N	\N	213436	213436	380517
28672	46595	0	applied	\N	\N	\N	\N	213468	213468	380549
28672	46607	17	applied	\N	\N	\N	\N	213485	213485	380566
28672	46654	34	applied	\N	\N	\N	\N	213502	213502	380583
28672	46683	44	applied	\N	\N	\N	\N	213512	213512	380593
28672	46684	45	applied	\N	\N	\N	\N	213513	213513	380594
28672	46720	62	applied	\N	\N	\N	\N	213530	213530	380611
28672	46582	80	applied	\N	\N	\N	\N	213547	213547	380628
28672	46603	97	applied	\N	\N	\N	\N	213564	213564	380645
28672	46661	114	applied	\N	\N	\N	\N	213581	213581	380662
28677	46710	8	applied	\N	\N	\N	\N	213610	213610	380691
28683	46738	1	applied	\N	\N	\N	\N	213629	213629	380710
28685	46743	3	applied	\N	\N	\N	\N	213634	213634	380715
28689	46747	0	applied	\N	\N	\N	\N	213646	213646	380727
28695	46757	1	applied	\N	\N	\N	\N	213664	213664	380745
28704	46774	0	applied	\N	\N	\N	\N	213687	213687	380768
28704	46775	1	applied	\N	\N	\N	\N	213688	213688	380769
28713	46777	0	applied	\N	\N	\N	\N	213699	213699	380780
28720	46779	1	applied	\N	\N	\N	\N	213706	213706	380787
28720	46780	2	applied	\N	\N	\N	\N	213707	213707	380788
28726	46789	1	applied	\N	\N	\N	\N	213737	213737	380818
28738	46803	0	applied	\N	\N	\N	\N	213765	213765	380846
28738	46804	1	applied	\N	\N	\N	\N	213766	213766	380847
28740	46804	1	applied	\N	\N	\N	\N	213770	213770	380851
28741	46797	0	applied	\N	\N	\N	\N	213771	213771	380852
28741	46323	17	applied	\N	\N	\N	\N	213788	213788	380869
28741	46414	58	applied	\N	\N	\N	\N	213828	213828	380909
28741	46459	75	applied	\N	\N	\N	\N	213845	213845	380926
28741	46516	92	applied	\N	\N	\N	\N	213862	213862	380943
28741	46527	96	applied	\N	\N	\N	\N	213866	213866	380947
28741	46538	99	applied	\N	\N	\N	\N	213869	213869	380950
28741	46596	116	applied	\N	\N	\N	\N	213886	213886	380967
28758	46815	1	applied	\N	\N	\N	\N	213928	213928	381009
28762	46820	0	applied	\N	\N	1000000000	\N	213937	213937	381018
28766	46828	0	applied	\N	\N	\N	\N	213947	213947	381028
28769	46837	1	applied	\N	\N	\N	\N	213972	213972	381053
28777	46851	0	applied	\N	\N	\N	\N	213996	213996	381077
28778	46857	6	applied	\N	\N	\N	\N	214010	214010	381091
28780	46862	3	applied	\N	\N	\N	\N	214021	214021	381102
28781	46863	4	applied	\N	\N	\N	\N	214028	214028	381109
28784	46873	4	applied	\N	\N	\N	\N	214044	214044	381125
28789	46892	9	applied	\N	\N	\N	\N	214066	214066	381147
28806	46915	2	applied	\N	\N	\N	\N	214114	214114	381195
28807	46919	0	applied	\N	\N	\N	\N	214118	214118	381199
28811	46923	1	applied	\N	\N	\N	\N	214131	214131	381212
28819	46932	1	applied	\N	\N	\N	\N	214152	214152	381233
28823	46816	10	applied	\N	\N	\N	\N	214171	214171	381252
28825	46947	6	applied	\N	\N	\N	\N	214189	214189	381270
28830	46954	2	applied	\N	\N	\N	\N	214218	214218	381299
28832	46955	3	applied	\N	\N	\N	\N	214233	214233	381314
28833	46959	0	applied	\N	\N	\N	\N	214237	214237	381318
28841	46977	2	applied	\N	\N	\N	\N	214271	214271	381352
28842	46979	4	applied	\N	\N	\N	\N	214280	214280	381361
28843	46983	1	applied	\N	\N	\N	\N	214284	214284	381365
28854	47008	5	applied	\N	\N	\N	\N	214323	214323	381404
28855	47011	2	applied	\N	\N	\N	\N	214326	214326	381407
28855	47014	5	applied	\N	\N	\N	\N	214329	214329	381410
28856	47019	0	applied	\N	\N	\N	\N	214334	214334	381415
28857	47033	14	applied	\N	\N	\N	\N	214365	214365	381446
28858	47033	14	applied	\N	\N	\N	\N	214382	214382	381463
28872	47064	1	applied	\N	\N	\N	\N	214428	214428	381507
28864	47043	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	214401	214401	\N
28865	47043	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	214404	214404	\N
28884	47085	2	applied	\N	\N	\N	\N	214471	214471	381550
28890	47102	1	applied	\N	\N	\N	\N	214495	214495	381574
28893	47109	2	applied	\N	\N	\N	\N	214514	214514	381593
28896	47107	0	applied	\N	\N	\N	\N	214523	214523	381602
28901	47083	0	applied	\N	\N	\N	\N	214539	214539	381618
28901	47072	1	applied	\N	\N	\N	\N	214540	214540	381619
28901	47111	13	applied	\N	\N	\N	\N	214552	214552	381631
28901	47115	31	applied	\N	\N	\N	\N	214569	214569	381648
28901	47112	48	applied	\N	\N	\N	\N	214586	214586	381665
28902	47120	5	applied	\N	\N	\N	\N	214595	214595	381674
28905	47084	8	applied	\N	\N	\N	\N	214622	214622	381701
28905	47091	32	applied	\N	\N	\N	\N	214646	214646	381725
28905	47094	49	applied	\N	\N	1000000000	\N	214662	214662	381741
28908	47134	2	applied	\N	\N	\N	\N	214688	214688	381767
28909	47133	1	applied	\N	\N	\N	\N	214690	214690	381769
28911	47137	2	applied	\N	\N	\N	\N	214697	214697	381776
28921	47150	4	applied	\N	\N	\N	\N	214719	214719	381798
28924	47151	0	applied	\N	\N	\N	\N	214730	214730	381809
28925	47155	4	applied	\N	\N	\N	\N	214741	214741	381820
28931	47165	1	applied	\N	\N	\N	\N	214769	214769	381848
28937	47181	1	applied	\N	\N	\N	\N	214791	214791	381870
28942	47183	0	applied	\N	\N	\N	\N	214804	214804	381883
28943	47183	0	applied	\N	\N	\N	\N	214806	214806	381885
28946	47198	9	applied	\N	\N	\N	\N	214824	214824	381903
28951	47200	3	applied	\N	\N	\N	\N	214841	214841	381920
28959	47219	2	applied	\N	\N	\N	\N	214874	214874	381953
28965	47231	3	applied	\N	\N	\N	\N	214896	214896	381975
28621	46640	3	applied	\N	\N	\N	\N	213126	213126	380207
28975	47251	5	applied	\N	\N	\N	\N	214938	214938	382017
28977	47252	0	applied	\N	\N	\N	\N	214945	214945	382024
28983	47261	3	applied	\N	\N	\N	\N	214971	214971	382048
28984	47152	6	applied	\N	\N	\N	\N	214982	214982	382058
28984	47209	23	applied	\N	\N	\N	\N	214999	214999	382075
28984	47260	40	applied	\N	\N	\N	\N	215016	215016	382092
28984	47150	57	applied	\N	\N	\N	\N	215033	215033	382109
28990	47261	1	applied	\N	\N	\N	\N	215050	215050	382123
28992	47271	2	applied	\N	\N	\N	\N	215056	215056	382129
28999	47281	0	applied	\N	\N	\N	\N	215075	215075	382148
29002	47290	0	applied	\N	\N	\N	\N	215087	215087	382160
29006	47303	0	applied	\N	\N	\N	\N	215107	215107	382180
29008	47306	0	applied	\N	\N	\N	\N	215115	215115	382188
29008	47309	3	applied	\N	\N	\N	\N	215118	215118	382191
29012	47317	2	applied	\N	\N	\N	\N	215134	215134	382207
29014	47320	2	applied	\N	\N	\N	\N	215140	215140	382213
29023	47345	3	applied	\N	\N	\N	\N	215177	215177	382250
29025	47350	4	applied	\N	\N	\N	\N	215187	215187	382260
29029	47362	4	applied	\N	\N	\N	\N	215209	215209	382282
29030	47359	1	applied	\N	\N	\N	\N	215212	215212	382285
29030	47360	2	applied	\N	\N	\N	\N	215213	215213	382286
29030	47363	5	applied	\N	\N	\N	\N	215216	215216	382289
29038	47373	0	applied	\N	\N	\N	\N	215237	215237	382308
29041	47382	2	applied	\N	\N	\N	\N	215250	215250	382321
29047	47393	1	applied	\N	\N	\N	\N	215276	215276	382347
29049	47399	1	applied	\N	\N	\N	\N	215288	215288	382359
29055	47407	3	applied	\N	\N	\N	\N	215308	215308	382379
29056	47404	0	applied	\N	\N	\N	\N	215311	215311	382382
29060	47421	8	applied	\N	\N	\N	\N	215340	215340	382411
29062	47419	6	applied	\N	\N	\N	\N	215356	215356	382427
29067	47423	1	applied	\N	\N	\N	\N	215386	215386	382457
29074	47432	1	applied	\N	\N	\N	\N	215406	215406	382477
29080	47434	0	applied	\N	\N	\N	\N	215426	215426	382497
29084	47440	0	applied	\N	\N	\N	\N	215437	215437	382508
29085	47443	0	applied	\N	\N	\N	\N	215440	215440	382511
29091	47456	0	applied	\N	\N	\N	\N	215463	215463	382534
29094	47468	3	applied	\N	\N	\N	\N	215478	215478	382549
29098	47081	11	applied	\N	\N	1000000000	\N	215501	215501	382570
29102	47473	2	applied	\N	\N	\N	\N	215519	215519	382588
29105	47306	7	applied	\N	\N	\N	\N	215538	215538	382606
29105	47358	24	applied	\N	\N	\N	\N	215555	215555	382623
29105	47384	33	applied	\N	\N	\N	\N	215564	215564	382632
29105	47393	36	applied	\N	\N	\N	\N	215567	215567	382635
29105	47447	53	applied	\N	\N	\N	\N	215584	215584	382652
29105	47310	70	applied	\N	\N	\N	\N	215601	215601	382669
29105	47365	88	applied	\N	\N	\N	\N	215618	215618	382686
29105	47432	122	applied	\N	\N	\N	\N	215652	215652	382720
29109	47493	3	applied	\N	\N	\N	\N	215669	215669	382737
29110	47498	3	applied	\N	\N	\N	\N	215674	215674	382742
29115	47514	6	applied	\N	\N	\N	\N	215702	215702	382770
29116	47510	2	applied	\N	\N	\N	\N	215706	215706	382774
29117	47508	0	applied	\N	\N	\N	\N	215712	215712	382780
29118	47367	1	applied	\N	\N	\N	\N	215721	215721	215721
29118	47311	18	applied	\N	\N	\N	\N	215738	215738	382805
29118	47364	35	applied	\N	\N	\N	\N	215755	215755	382822
29118	47404	48	applied	\N	\N	\N	\N	215768	215768	382835
29118	47456	65	applied	\N	\N	\N	\N	215785	215785	382852
29118	47508	82	applied	\N	\N	\N	\N	215802	215802	382869
29118	47302	99	applied	\N	\N	\N	\N	215819	215819	382886
29118	47289	117	applied	\N	\N	\N	\N	215836	215836	382903
29118	47299	119	applied	\N	\N	\N	\N	215838	215838	382905
29126	47258	0	applied	\N	\N	\N	\N	215875	215875	215875
29126	47250	34	applied	\N	\N	\N	\N	215909	215909	382974
29126	47424	51	applied	\N	\N	\N	\N	215926	215926	382991
29127	47544	6	applied	\N	\N	\N	\N	215944	215944	383009
29128	47151	9	applied	\N	\N	\N	\N	215959	215959	383022
29128	47205	26	applied	\N	\N	\N	\N	215976	215976	383039
29128	47259	43	applied	\N	\N	\N	\N	215993	215993	383056
29128	47311	60	applied	\N	\N	\N	\N	216010	216010	383073
29128	47358	75	applied	\N	\N	\N	\N	216025	216025	383088
29128	47389	85	applied	\N	\N	\N	\N	216035	216035	383098
29128	47440	102	applied	\N	\N	\N	\N	216052	216052	383115
29128	47491	120	applied	\N	\N	\N	\N	216069	216069	383132
29130	47559	5	applied	\N	\N	\N	\N	216084	216084	383147
29131	47555	1	applied	\N	\N	\N	\N	216088	216088	383151
29135	47575	1	applied	\N	\N	\N	\N	216110	216110	383173
29136	47581	0	applied	\N	\N	\N	\N	216116	216116	383179
29140	47590	1	applied	\N	\N	\N	\N	216134	216134	383197
29151	47621	0	applied	\N	\N	\N	\N	216183	216183	383246
29155	47628	1	applied	\N	\N	\N	\N	216195	216195	383258
29159	47258	0	applied	\N	\N	\N	\N	216216	216216	216216
29159	47081	10	applied	\N	\N	1000000000	\N	216226	216226	383287
29159	46878	31	applied	\N	\N	\N	\N	216247	216247	383308
29161	47638	1	applied	\N	\N	\N	\N	216264	216264	383325
29162	47541	12	applied	\N	\N	\N	\N	216277	216277	383338
29162	47616	35	applied	\N	\N	\N	\N	216300	216300	383361
29162	47136	50	applied	\N	\N	\N	\N	216315	216315	383376
29162	47138	62	applied	\N	\N	\N	\N	216327	216327	383388
29162	47181	79	applied	\N	\N	\N	\N	216344	216344	383405
29162	47282	96	applied	\N	\N	\N	\N	216361	216361	383422
29162	47454	114	applied	\N	\N	\N	\N	216378	216378	383439
29167	47640	1	applied	\N	\N	\N	\N	216397	216397	383458
29168	47641	0	applied	\N	\N	\N	\N	216398	216398	383459
29169	47644	3	applied	\N	\N	\N	\N	216406	216406	383467
29176	47655	0	applied	\N	\N	\N	\N	216436	216436	383497
29178	47657	0	applied	\N	\N	\N	\N	216441	216441	383502
29179	47660	0	applied	\N	\N	\N	\N	216444	216444	383505
29180	47660	0	applied	\N	\N	\N	\N	216447	216447	383508
29181	47660	0	applied	\N	\N	\N	\N	216450	216450	383511
29183	47663	0	applied	\N	\N	\N	\N	216459	216459	383518
29184	47652	14	applied	\N	\N	\N	\N	216475	216475	383534
29184	47618	31	applied	\N	\N	\N	\N	216492	216492	383551
29184	47662	48	applied	\N	\N	\N	\N	216509	216509	383568
29187	47670	5	applied	\N	\N	\N	\N	216532	216532	383591
29196	47681	1	applied	\N	\N	\N	\N	216561	216561	383620
29197	47687	2	applied	\N	\N	\N	\N	216565	216565	383624
29198	47690	1	applied	\N	\N	\N	\N	216568	216568	383627
29198	47695	7	applied	\N	\N	\N	\N	216573	216573	383632
29199	47690	1	applied	\N	\N	\N	\N	216576	216576	383635
29202	47696	8	applied	\N	\N	\N	\N	216606	216606	383665
28974	47245	2	applied	\N	\N	\N	\N	214932	214932	382011
29208	47678	60	applied	\N	\N	\N	\N	216699	216699	383758
29208	47620	77	applied	\N	\N	\N	\N	216716	216716	383775
29208	47578	97	applied	\N	\N	\N	\N	216735	216735	383794
29208	47631	113	applied	\N	\N	\N	\N	216751	216751	383810
29208	47633	114	applied	\N	\N	\N	\N	216752	216752	383811
29209	47702	1	applied	\N	\N	\N	\N	216765	216765	383824
29223	47718	2	applied	\N	\N	\N	\N	216806	216806	383865
29231	47728	1	applied	\N	\N	\N	\N	216834	216834	383893
29233	47737	3	applied	\N	\N	\N	\N	216843	216843	383902
29234	47741	1	applied	\N	\N	\N	\N	216847	216847	383906
29239	47750	3	applied	\N	\N	\N	\N	216872	216872	383931
29244	47756	0	applied	\N	\N	\N	\N	216884	216884	383943
29255	47781	0	applied	\N	\N	\N	\N	216921	216921	383980
29256	47785	2	applied	\N	\N	\N	\N	216925	216925	383984
29259	47788	2	applied	\N	\N	\N	\N	216934	216934	383993
29260	47789	0	applied	\N	\N	\N	\N	216935	216935	383994
29266	47793	2	applied	\N	\N	\N	\N	216984	216984	384042
29267	47816	4	applied	\N	\N	\N	\N	216991	216991	384049
29271	47641	1	applied	\N	\N	\N	\N	217016	217016	384074
29271	47689	18	applied	\N	\N	\N	\N	217033	217033	384091
29272	47821	3	applied	\N	\N	\N	\N	217038	217038	384096
29273	47830	0	applied	\N	\N	\N	\N	217047	217047	384105
29274	47368	26	applied	\N	\N	\N	\N	217079	217079	384136
29274	47377	29	applied	\N	\N	\N	\N	217082	217082	384139
29274	47428	46	applied	\N	\N	\N	\N	217099	217099	384156
29274	47481	63	applied	\N	\N	\N	\N	217116	217116	384173
29274	47532	81	applied	\N	\N	\N	\N	217133	217133	384190
29274	47583	98	applied	\N	\N	\N	\N	217150	217150	384207
29274	47629	115	applied	\N	\N	\N	\N	217167	217167	384224
29278	47735	3	applied	\N	\N	\N	\N	217190	217190	384247
29278	47784	18	applied	\N	\N	\N	\N	217205	217205	384262
29278	47794	21	applied	\N	\N	\N	\N	217208	217208	384265
29278	47748	38	applied	\N	\N	\N	\N	217225	217225	384282
29278	47758	55	applied	\N	\N	\N	\N	217242	217242	384299
29278	47805	73	applied	\N	\N	\N	\N	217259	217259	384316
29278	47802	90	applied	\N	\N	\N	\N	217276	217276	384333
29278	47835	107	applied	\N	\N	\N	\N	217293	217293	384350
29279	47844	5	applied	\N	\N	\N	\N	217300	217300	384357
29298	47879	2	applied	\N	\N	\N	\N	217364	217364	384421
29299	47879	2	applied	\N	\N	\N	\N	217369	217369	384426
29300	47878	1	applied	\N	\N	\N	\N	217373	217373	384430
29301	47877	0	applied	\N	\N	\N	\N	217377	217377	384434
29301	47880	3	applied	\N	\N	\N	\N	217380	217380	384437
29302	47877	0	applied	\N	\N	\N	\N	217382	217382	384439
29315	47908	0	applied	\N	\N	\N	\N	217421	217421	384478
29321	47919	2	applied	\N	\N	\N	\N	217441	217441	384498
29328	47928	1	applied	\N	\N	\N	\N	217460	217460	384517
29331	47690	9	applied	\N	\N	\N	\N	217482	217482	384539
29331	47741	26	applied	\N	\N	\N	\N	217499	217499	384556
29331	47796	43	applied	\N	\N	\N	\N	217516	217516	384573
29331	47846	60	applied	\N	\N	\N	\N	217533	217533	384590
29331	47899	78	applied	\N	\N	\N	\N	217550	217550	384607
29331	47930	89	applied	\N	\N	\N	\N	217561	217561	384618
29331	47333	109	applied	\N	\N	\N	\N	217581	217581	384638
29331	47344	112	applied	\N	\N	\N	\N	217584	217584	384641
29335	47944	0	applied	\N	\N	\N	\N	217607	217607	384664
29336	47946	2	applied	\N	\N	\N	\N	217613	217613	384670
29337	47951	4	applied	\N	\N	\N	\N	217618	217618	384675
29342	47966	2	applied	\N	\N	\N	\N	217637	217637	384694
29343	47968	4	applied	\N	\N	\N	\N	217645	217645	384702
29345	47972	2	applied	\N	\N	\N	\N	217655	217655	384712
29351	47988	3	applied	\N	\N	\N	\N	217680	217680	384737
29359	47998	0	applied	\N	\N	\N	\N	217709	217709	384766
29359	47999	1	applied	\N	\N	\N	\N	217710	217710	384767
29365	48010	1	applied	\N	\N	\N	\N	217724	217724	384781
29367	48013	1	applied	\N	\N	\N	\N	217730	217730	384787
29372	48022	1	applied	\N	\N	\N	\N	217745	217745	384802
29378	48035	3	applied	\N	\N	\N	\N	217776	217776	384833
29386	48067	5	applied	\N	\N	\N	\N	217811	217811	384868
29387	48065	3	applied	\N	\N	\N	\N	217821	217821	384878
29389	48074	0	applied	\N	\N	\N	\N	217838	217838	384895
29390	48080	2	applied	\N	\N	\N	\N	217844	217844	384901
29391	47908	23	applied	\N	\N	\N	\N	217869	217869	384926
29391	47954	37	applied	\N	\N	\N	\N	217883	217883	384940
29391	48006	54	applied	\N	\N	\N	\N	217900	217900	384957
29391	48054	71	applied	\N	\N	\N	\N	217917	217917	384974
29391	47871	89	applied	\N	\N	\N	\N	217934	217934	384991
29391	47996	106	applied	\N	\N	\N	\N	217951	217951	385008
29391	47890	123	applied	\N	\N	\N	\N	217968	217968	385025
29394	48086	2	applied	\N	\N	\N	\N	217977	217977	385034
29402	48105	0	applied	\N	\N	\N	\N	218007	218007	385064
29405	48103	12	applied	\N	\N	1000000000	\N	218027	218027	385084
29405	48110	32	applied	\N	\N	\N	\N	218047	218047	385104
29411	48119	2	applied	\N	\N	\N	\N	218074	218074	385131
29413	47938	7	applied	\N	\N	1000000000	\N	218089	218089	385146
29414	48131	4	applied	\N	\N	\N	\N	218095	218095	385152
29415	48130	3	applied	\N	\N	\N	\N	218105	218105	385162
29426	48157	2	applied	\N	\N	\N	\N	218151	218151	385208
29427	48160	0	applied	\N	\N	\N	\N	218154	218154	385211
29427	48161	1	applied	\N	\N	\N	\N	218155	218155	385212
29428	48160	0	applied	\N	\N	\N	\N	218158	218158	385215
29436	48173	3	applied	\N	\N	\N	\N	218186	218186	385243
29440	48197	13	applied	\N	\N	\N	\N	218210	218210	385267
29441	48185	1	applied	\N	\N	\N	\N	218212	218212	385269
29441	48187	3	applied	\N	\N	\N	\N	218214	218214	385271
29443	48199	1	applied	\N	\N	\N	\N	218240	218240	385297
29446	48200	0	applied	\N	\N	\N	\N	218245	218245	218245
29451	48225	5	applied	\N	\N	\N	\N	218273	218273	385328
29452	48229	2	applied	\N	\N	\N	\N	218277	218277	385332
29457	48241	1	applied	\N	\N	\N	\N	218293	218293	385348
29461	48249	2	applied	\N	\N	\N	\N	218322	218322	385377
29465	48256	3	applied	\N	\N	\N	\N	218335	218335	385390
29468	48268	3	applied	\N	\N	1000000000	\N	218355	218355	385410
29471	48277	0	applied	\N	\N	\N	\N	218372	218372	385427
29476	48292	1	applied	\N	\N	\N	\N	218397	218397	385451
29478	48298	7	applied	\N	\N	\N	\N	218425	218425	385477
29481	48297	6	applied	\N	\N	\N	\N	218457	218457	385506
29482	48293	2	applied	\N	\N	\N	\N	218464	218464	385512
29208	47575	9	applied	\N	\N	\N	\N	216648	216648	383707
29487	48319	5	applied	\N	\N	\N	\N	218496	218496	385544
29491	48333	6	applied	\N	\N	\N	\N	218524	218524	385572
29491	48336	9	applied	\N	\N	\N	\N	218527	218527	385575
29500	48351	1	applied	\N	\N	\N	\N	218553	218553	385601
29507	48371	2	applied	\N	\N	\N	\N	218575	218575	385623
29508	48370	1	applied	\N	\N	\N	\N	218577	218577	385625
29511	48379	3	applied	\N	\N	\N	\N	218593	218593	385638
29511	48380	4	applied	\N	\N	\N	\N	218594	218594	385639
29512	48376	0	applied	\N	\N	\N	\N	218597	218597	385642
29516	48391	5	applied	\N	\N	\N	\N	218623	218623	385667
29517	48393	7	applied	\N	\N	\N	\N	218632	218632	385676
29525	48408	1	applied	\N	\N	\N	\N	218661	218661	385705
29525	48409	2	applied	\N	\N	\N	\N	218662	218662	385706
29525	48410	3	applied	\N	\N	\N	\N	218663	218663	385707
29529	48201	3	applied	\N	\N	\N	\N	218679	218679	218679
29529	48155	20	applied	\N	\N	\N	\N	218696	218696	385737
29529	47525	37	applied	\N	\N	\N	\N	218713	218713	385754
29529	47627	71	applied	\N	\N	\N	\N	218747	218747	385788
29529	47676	88	applied	\N	\N	\N	\N	218764	218764	385805
29529	47681	90	applied	\N	\N	\N	\N	218766	218766	385807
29529	47690	93	applied	\N	\N	\N	\N	218769	218769	385810
29534	48419	0	applied	\N	\N	\N	\N	218789	218789	385830
29543	48437	4	applied	\N	\N	\N	\N	218819	218819	385859
29549	48445	3	applied	\N	\N	\N	\N	218854	218854	385894
29550	48449	0	applied	\N	\N	\N	\N	218858	218858	385898
29551	48457	6	applied	\N	\N	\N	\N	218866	218866	385906
29551	48458	7	applied	\N	\N	\N	\N	218867	218867	385907
29553	48454	3	applied	\N	\N	\N	\N	218877	218877	385917
29555	47719	16	applied	\N	\N	\N	\N	218906	218906	385943
29555	47763	33	applied	\N	\N	\N	\N	218923	218923	385960
29555	47818	50	applied	\N	\N	\N	\N	218940	218940	385977
29555	47870	67	applied	\N	\N	\N	\N	218957	218957	385994
29555	47920	85	applied	\N	\N	\N	\N	218974	218974	386011
29555	48027	119	applied	\N	\N	\N	\N	219008	219008	386045
29555	48028	120	applied	\N	\N	\N	\N	219009	219009	386046
29558	48463	1	applied	\N	\N	\N	\N	219022	219022	386059
29560	48408	15	applied	\N	\N	\N	\N	219043	219043	386080
29560	48363	38	applied	\N	\N	\N	\N	219066	219066	386102
29560	48379	51	applied	\N	\N	\N	\N	219078	219078	386113
29560	48410	54	applied	\N	\N	\N	\N	219081	219081	386116
29560	48415	71	applied	\N	\N	\N	\N	219098	219098	386133
29560	48368	88	applied	\N	\N	\N	\N	219115	219115	386150
29560	48448	105	applied	\N	\N	\N	\N	219132	219132	386167
29562	48474	3	applied	\N	\N	\N	\N	219142	219142	386177
29568	48492	5	applied	\N	\N	\N	\N	219174	219174	386209
29571	48501	2	applied	\N	\N	\N	\N	219189	219189	386224
29575	48504	0	applied	\N	\N	\N	\N	219198	219198	386233
29576	48512	4	applied	\N	\N	\N	\N	219206	219206	386241
29577	48514	1	applied	\N	\N	\N	\N	219208	219208	386243
29589	48048	1	applied	\N	\N	\N	\N	219261	219261	386296
29589	48095	18	applied	\N	\N	\N	\N	219278	219278	386313
29589	48151	35	applied	\N	\N	\N	\N	219295	219295	386330
29589	48237	60	applied	\N	\N	\N	\N	219320	219320	386355
29589	48280	72	applied	\N	\N	\N	\N	219332	219332	386367
29589	48327	87	applied	\N	\N	\N	\N	219346	219346	386381
29592	48554	5	applied	\N	\N	\N	\N	219371	219371	386406
29595	48564	6	applied	\N	\N	\N	\N	219387	219387	386422
29597	48571	2	applied	\N	\N	\N	\N	219406	219406	386441
29598	48576	0	applied	\N	\N	\N	\N	219411	219411	386446
29600	48580	1	applied	\N	\N	\N	\N	219418	219418	386453
29603	48469	3	applied	\N	\N	\N	\N	219431	219431	386466
29603	48519	20	applied	\N	\N	\N	\N	219448	219448	386483
29603	48571	37	applied	\N	\N	\N	\N	219465	219465	386500
29603	48496	54	applied	\N	\N	\N	\N	219482	219482	386517
29603	48480	72	applied	\N	\N	\N	\N	219499	219499	386534
29603	48497	78	applied	\N	\N	\N	\N	219505	219505	386540
29603	48557	95	applied	\N	\N	\N	\N	219522	219522	386557
29603	48579	112	applied	\N	\N	\N	\N	219539	219539	386574
29607	48597	2	applied	\N	\N	\N	\N	219561	219561	386596
29613	48614	0	applied	\N	\N	\N	\N	219591	219591	386626
29617	48632	7	applied	\N	\N	\N	\N	219612	219612	386647
29618	48632	7	applied	\N	\N	\N	\N	219621	219621	386656
29620	48636	2	applied	\N	\N	\N	\N	219634	219634	386669
29623	48645	5	applied	\N	\N	\N	\N	219655	219655	386690
29625	48651	5	applied	\N	\N	\N	\N	219667	219667	386702
29625	48652	6	applied	\N	\N	\N	\N	219668	219668	386703
29627	48660	1	applied	\N	\N	\N	\N	219689	219689	386724
29632	48671	9	applied	\N	\N	\N	\N	219705	219705	386740
29639	48680	1	applied	\N	\N	\N	\N	219730	219730	386762
29640	48684	0	applied	\N	\N	\N	\N	219734	219734	386766
29647	48697	4	applied	\N	\N	\N	\N	219761	219761	386793
29650	48709	2	applied	\N	\N	\N	\N	219779	219779	386811
29651	48726	0	applied	\N	\N	\N	\N	219796	219796	386828
29654	48740	7	applied	\N	\N	\N	\N	219824	219824	386855
29655	48753	0	applied	\N	\N	\N	\N	219837	219837	386868
29655	48770	18	applied	\N	\N	\N	\N	219854	219854	386885
29656	48787	4	applied	\N	\N	\N	\N	219871	219871	386902
29657	48785	4	applied	\N	\N	\N	\N	219880	219880	386910
29657	48804	21	applied	\N	\N	\N	\N	219897	219897	386926
29658	48805	3	applied	\N	\N	\N	\N	219901	219901	386930
29660	48827	6	applied	\N	\N	\N	\N	219933	219933	386962
29660	48828	7	applied	\N	\N	\N	\N	219934	219934	386963
29661	48830	1	applied	\N	\N	\N	\N	219936	219936	386965
29661	48831	2	applied	\N	\N	\N	\N	219937	219937	386966
29664	48841	3	applied	\N	\N	\N	\N	219962	219962	386991
29665	48849	4	applied	\N	\N	\N	\N	219970	219970	386999
29665	48866	21	applied	\N	\N	\N	\N	219987	219987	387016
29666	48885	12	applied	\N	\N	\N	\N	220006	220006	387035
29667	48884	11	applied	\N	\N	\N	\N	220023	220023	387052
29668	48893	1	applied	\N	\N	\N	\N	220032	220032	387061
29671	48910	9	applied	\N	\N	\N	\N	220067	220067	387096
29672	48901	0	applied	\N	\N	\N	\N	220076	220076	387105
29672	48918	17	applied	\N	\N	\N	\N	220093	220093	387122
29673	48909	8	applied	\N	\N	\N	\N	220102	220102	387131
29674	48930	11	applied	\N	\N	\N	\N	220123	220123	387152
29675	48950	16	applied	\N	\N	\N	\N	220143	220143	387171
29678	48962	1	applied	\N	\N	\N	\N	220167	220167	387195
29678	48967	4	applied	\N	\N	\N	\N	220170	220170	387198
29679	48965	4	applied	\N	\N	\N	\N	220179	220179	387207
29681	48997	16	applied	\N	\N	\N	\N	220214	220214	387242
29682	48985	3	applied	\N	\N	\N	\N	220219	220219	387247
29486	48311	6	applied	\N	\N	\N	\N	218488	218488	385536
29686	49004	5	applied	\N	\N	\N	\N	220282	220282	387310
29688	49012	3	applied	\N	\N	\N	\N	220299	220299	387327
29689	49015	0	applied	\N	\N	\N	\N	220302	220302	387330
29691	49036	6	applied	\N	\N	1000000000	\N	220323	220323	387351
29692	49036	1	applied	\N	\N	1000000000	\N	220328	220328	387356
29694	49043	3	applied	\N	\N	\N	\N	220333	220333	387361
29705	49054	8	applied	\N	\N	\N	\N	220392	220392	387420
29706	49057	2	applied	\N	\N	\N	\N	220395	220395	387423
29707	49058	3	applied	\N	\N	\N	\N	220403	220403	387431
29709	49068	6	applied	\N	\N	\N	\N	220419	220419	387446
29710	49086	16	applied	\N	\N	\N	\N	220459	220459	387483
29711	49067	5	applied	\N	\N	\N	\N	220470	220470	387493
29711	49070	8	applied	\N	\N	\N	\N	220473	220473	387496
29711	49087	25	applied	\N	\N	\N	\N	220490	220490	387512
29712	49067	5	applied	\N	\N	\N	\N	220500	220500	387521
29712	49084	22	applied	\N	\N	\N	\N	220517	220517	387537
29713	49083	21	applied	\N	\N	\N	\N	220546	220546	387564
29714	48509	8	applied	\N	\N	\N	\N	220563	220563	387580
29714	48522	9	applied	\N	\N	\N	\N	220564	220564	387581
29714	48502	27	applied	\N	\N	\N	\N	220581	220581	387598
29714	48513	30	applied	\N	\N	\N	\N	220584	220584	387601
29714	48515	31	applied	\N	\N	\N	\N	220585	220585	387602
29714	48570	48	applied	\N	\N	\N	\N	220602	220602	387619
29714	48624	65	applied	\N	\N	\N	\N	220619	220619	387636
29714	48679	82	applied	\N	\N	\N	\N	220636	220636	387653
29714	48807	99	applied	\N	\N	\N	\N	220653	220653	387670
29715	49110	19	applied	\N	\N	\N	\N	220698	220698	387715
29716	49100	9	applied	\N	\N	\N	\N	220708	220708	387725
29717	49125	13	applied	\N	\N	\N	\N	220732	220732	387749
29718	49117	6	applied	\N	\N	\N	\N	220740	220740	387757
29718	49134	23	applied	\N	\N	\N	\N	220757	220757	387774
29719	49131	14	applied	\N	\N	\N	\N	220775	220775	387792
29720	48846	1	applied	\N	\N	1000000000	\N	220783	220783	387800
29720	48146	12	applied	\N	\N	1000000000	\N	220794	220794	387808
29720	48255	23	applied	\N	\N	\N	\N	220805	220805	387818
29720	48155	26	applied	\N	\N	\N	\N	220808	220808	387821
29720	47973	43	applied	\N	\N	\N	\N	220825	220825	387838
29720	48024	60	applied	\N	\N	\N	\N	220842	220842	387855
29720	48078	78	applied	\N	\N	\N	\N	220859	220859	387872
29720	48130	95	applied	\N	\N	\N	\N	220876	220876	387889
29720	48187	112	applied	\N	\N	\N	\N	220893	220893	387906
29722	49151	3	applied	\N	\N	\N	\N	220919	220919	387932
29726	49161	4	applied	\N	\N	\N	\N	220953	220953	387966
29729	49178	4	applied	\N	\N	\N	\N	220985	220985	387998
29730	49186	3	applied	\N	\N	\N	\N	220993	220993	388006
29730	49189	6	applied	\N	\N	\N	\N	220996	220996	388009
29734	49187	4	applied	\N	\N	\N	\N	221022	221022	388035
29735	49184	5	applied	\N	\N	\N	\N	221030	221030	388043
29738	49192	2	applied	\N	\N	\N	\N	221047	221047	388060
29739	49206	10	applied	\N	\N	\N	\N	221061	221061	388074
29739	49223	27	applied	\N	\N	\N	\N	221078	221078	388091
29741	49240	6	applied	\N	\N	\N	\N	221104	221104	388117
29742	49250	7	applied	\N	\N	\N	\N	221114	221114	388127
29743	49267	8	applied	\N	\N	\N	\N	221131	221131	388144
29743	49270	11	applied	\N	\N	\N	\N	221134	221134	388147
29744	49275	8	applied	\N	\N	\N	\N	221143	221143	388156
29745	49273	6	applied	\N	\N	\N	\N	221159	221159	388172
29746	49269	16	applied	\N	\N	\N	\N	221187	221187	388200
29748	49291	22	applied	\N	\N	\N	\N	221227	221227	388240
29749	49281	4	applied	\N	\N	\N	\N	221233	221233	388246
29749	49290	21	applied	\N	\N	\N	\N	221250	221250	388263
29752	49306	5	applied	\N	\N	\N	\N	221265	221265	388278
29756	49326	11	applied	\N	\N	\N	\N	221294	221294	388307
29757	49320	5	applied	\N	\N	\N	\N	221306	221306	388319
29757	49323	8	applied	\N	\N	\N	\N	221309	221309	388322
29758	49322	10	applied	\N	\N	\N	\N	221329	221329	388342
29759	49347	6	applied	\N	\N	\N	\N	221350	221350	388363
29759	49333	8	applied	\N	\N	\N	\N	221352	221352	388365
29759	49348	11	applied	\N	\N	\N	\N	221355	221355	388368
29760	49363	8	applied	\N	\N	\N	\N	221375	221375	388388
29761	49367	11	applied	\N	\N	\N	\N	221392	221392	388405
29762	49366	11	applied	\N	\N	\N	\N	221404	221404	388417
29763	49363	5	applied	\N	\N	\N	\N	221412	221412	388425
29764	49369	0	applied	\N	\N	\N	\N	221418	221418	388431
29767	49407	2	applied	\N	\N	\N	\N	221456	221456	388469
29768	49408	3	applied	\N	\N	\N	\N	221476	221476	388489
29769	49405	0	applied	\N	\N	\N	\N	221492	221492	388505
29770	49433	12	applied	\N	\N	\N	\N	221520	221520	388533
29771	49442	9	applied	\N	\N	\N	\N	221544	221544	388557
29772	49450	1	applied	\N	\N	\N	\N	221552	221552	388565
29772	49467	18	applied	\N	\N	\N	\N	221569	221569	388582
29773	49450	1	applied	\N	\N	\N	\N	221583	221583	388596
29773	49467	18	applied	\N	\N	\N	\N	221600	221600	388613
29774	49459	10	applied	\N	\N	\N	\N	221623	221623	388636
29774	49476	27	applied	\N	\N	\N	\N	221640	221640	388653
29775	49484	4	applied	\N	\N	\N	\N	221648	221648	388661
29775	49501	21	applied	\N	\N	\N	\N	221665	221665	388678
29776	49521	13	applied	\N	\N	\N	\N	221685	221685	388698
29777	49513	5	applied	\N	\N	\N	\N	221691	221691	388704
29777	49516	8	applied	\N	\N	\N	\N	221694	221694	388707
29780	49510	2	applied	\N	\N	\N	\N	221731	221731	388744
29780	49513	5	applied	\N	\N	\N	\N	221734	221734	388747
29781	49528	7	applied	\N	\N	\N	\N	221751	221751	388764
29782	49552	12	applied	\N	\N	\N	\N	221775	221775	388788
29783	49380	5	applied	\N	\N	\N	\N	221780	221780	388793
29783	49321	22	applied	\N	\N	\N	\N	221797	221797	388810
29783	49397	39	applied	\N	\N	\N	\N	221814	221814	388827
29783	49472	56	applied	\N	\N	\N	\N	221831	221831	388844
29783	49538	69	applied	\N	\N	\N	\N	221844	221844	388857
29783	49548	72	applied	\N	\N	\N	\N	221847	221847	388860
29785	49568	15	applied	\N	\N	\N	\N	221876	221876	388889
29785	49570	17	applied	\N	\N	\N	\N	221878	221878	388891
29785	49573	20	applied	\N	\N	\N	\N	221881	221881	388894
29786	49560	7	applied	\N	\N	\N	\N	221897	221897	388910
29786	49577	24	applied	\N	\N	\N	\N	221914	221914	388927
29787	49570	17	applied	\N	\N	\N	\N	221936	221936	388949
29791	49587	5	applied	\N	\N	\N	\N	221990	221990	389003
29792	49582	0	applied	\N	\N	\N	\N	221998	221998	389011
29793	49597	2	applied	\N	\N	\N	\N	222013	222013	389026
29794	49602	7	applied	\N	\N	\N	\N	222030	222030	389043
29684	48997	16	applied	\N	\N	\N	\N	220265	220265	387293
29797	49627	20	applied	\N	\N	\N	\N	222076	222076	389089
29797	49661	55	applied	\N	\N	\N	\N	222110	222110	389123
29798	49667	0	applied	\N	\N	\N	\N	222116	222116	389129
29799	49671	4	applied	\N	\N	\N	\N	222129	222129	389142
29800	49607	0	applied	\N	\N	\N	\N	222133	222133	389146
29800	49553	17	applied	\N	\N	\N	\N	222150	222150	389163
29800	49337	34	applied	\N	\N	\N	\N	222167	222167	389180
29800	49442	51	applied	\N	\N	\N	\N	222184	222184	389197
29800	49669	77	applied	\N	\N	\N	\N	222210	222210	389223
29800	49376	88	applied	\N	\N	\N	\N	222221	222221	389234
29800	49379	91	applied	\N	\N	\N	\N	222224	222224	389237
29801	49681	6	applied	\N	\N	\N	\N	222241	222241	389254
29802	49681	6	applied	\N	\N	\N	\N	222252	222252	389265
29803	49698	12	applied	\N	\N	\N	\N	222269	222269	389282
29809	49721	1	applied	\N	\N	\N	\N	222304	222304	389317
29813	49449	12	applied	\N	\N	\N	\N	222329	222329	389342
29813	49481	15	applied	\N	\N	\N	\N	222332	222332	389345
29813	49720	34	applied	\N	\N	\N	\N	222351	222351	389364
29813	49332	37	applied	\N	\N	\N	\N	222354	222354	389367
29813	49346	54	applied	\N	\N	\N	\N	222371	222371	389384
29813	49384	71	applied	\N	\N	\N	\N	222388	222388	389401
29813	49442	88	applied	\N	\N	\N	\N	222405	222405	389418
29813	49585	105	applied	\N	\N	\N	\N	222422	222422	389435
29813	49718	122	applied	\N	\N	\N	\N	222439	222439	389452
29814	49728	3	applied	\N	\N	\N	\N	222444	222444	389457
29815	49751	15	applied	\N	\N	\N	\N	222467	222467	389480
29816	49730	9	applied	\N	\N	\N	\N	222479	222479	389492
29816	49735	24	applied	\N	\N	\N	\N	222494	222494	389507
29816	49752	27	applied	\N	\N	\N	\N	222497	222497	389510
29817	49754	0	applied	\N	\N	\N	\N	222499	222499	389512
29819	49781	13	applied	\N	\N	\N	\N	222526	222526	389539
29820	49779	11	applied	\N	\N	\N	\N	222543	222543	389556
29822	49804	7	applied	\N	\N	\N	\N	222568	222568	389581
29825	49807	1	applied	\N	\N	\N	\N	222591	222591	389604
29826	49808	2	applied	\N	\N	\N	\N	222603	222603	389616
29827	49824	7	applied	\N	\N	\N	\N	222614	222614	389627
29831	49828	2	applied	\N	\N	\N	\N	222633	222633	389646
29832	49841	15	applied	\N	\N	\N	\N	222650	222650	389663
29835	49853	4	applied	\N	\N	\N	\N	222667	222667	389680
29838	49872	5	applied	\N	\N	\N	\N	222686	222686	389699
29838	49889	22	applied	\N	\N	\N	\N	222703	222703	389716
29839	49876	9	applied	\N	\N	\N	\N	222713	222713	389726
29840	49893	3	applied	\N	\N	\N	\N	222730	222730	389743
29840	49910	20	applied	\N	\N	\N	\N	222747	222747	389760
29841	49920	3	applied	\N	\N	\N	\N	222757	222757	389770
29842	49942	16	applied	\N	\N	\N	\N	222779	222779	389792
29847	49969	12	applied	\N	\N	\N	\N	222811	222811	389824
29847	49986	29	applied	\N	\N	\N	\N	222828	222828	389841
29848	49969	7	applied	\N	\N	\N	\N	222849	222849	389862
29849	50002	2	applied	\N	\N	\N	\N	222881	222881	389894
29850	50005	5	applied	\N	\N	\N	\N	222893	222893	389906
29851	50019	10	applied	\N	\N	\N	\N	222907	222907	389920
29852	50023	13	applied	\N	\N	\N	\N	222924	222924	389937
29853	50024	0	applied	\N	\N	\N	\N	222926	222926	389939
29853	50027	3	applied	\N	\N	\N	\N	222929	222929	389942
29855	50051	0	applied	\N	\N	\N	\N	222954	222954	389967
29856	50058	7	applied	\N	\N	\N	\N	222971	222971	389984
29859	50078	9	applied	\N	\N	\N	\N	222998	222998	390011
29861	50085	5	applied	\N	\N	\N	\N	223015	223015	390028
29862	50101	11	applied	\N	\N	\N	\N	223031	223031	390044
29862	50104	14	applied	\N	\N	\N	\N	223034	223034	390047
29864	50110	1	applied	\N	\N	\N	\N	223049	223049	390062
29865	50112	3	applied	\N	\N	\N	\N	223060	223060	390073
29866	50127	9	applied	\N	\N	\N	\N	223075	223075	390088
29868	50124	6	applied	\N	\N	\N	\N	223092	223092	390105
29870	50144	16	applied	\N	\N	\N	\N	223122	223122	390135
29870	50147	19	applied	\N	\N	\N	\N	223125	223125	390138
29871	50144	16	applied	\N	\N	\N	\N	223142	223142	390155
29872	50129	1	applied	\N	\N	\N	\N	223147	223147	390160
29876	49787	8	applied	\N	\N	\N	\N	223190	223190	390203
29876	49959	25	applied	\N	\N	\N	\N	223207	223207	390220
29876	49761	42	applied	\N	\N	\N	\N	223224	223224	390237
29876	49827	59	applied	\N	\N	\N	\N	223241	223241	390254
29876	49936	80	applied	\N	\N	\N	\N	223262	223262	390275
29876	50055	96	applied	\N	\N	\N	\N	223278	223278	390291
29876	50071	99	applied	\N	\N	\N	\N	223281	223281	390294
29876	49784	116	applied	\N	\N	\N	\N	223298	223298	390311
29877	50175	17	applied	\N	\N	\N	\N	223320	223320	390333
29878	50158	4	applied	\N	\N	\N	\N	223326	223326	390338
29879	50185	9	applied	\N	\N	\N	\N	223350	223350	390361
29880	50178	1	applied	\N	\N	\N	\N	223353	223353	390364
29882	50208	1	applied	\N	\N	\N	\N	223383	223383	390394
29882	50225	18	applied	\N	\N	\N	\N	223400	223400	390411
29883	50208	1	applied	\N	\N	\N	\N	223403	223403	390414
29883	50225	18	applied	\N	\N	\N	\N	223420	223420	390431
29884	50215	8	applied	\N	\N	\N	\N	223430	223430	390441
29885	50231	4	applied	\N	\N	\N	\N	223446	223446	390457
29886	50232	5	applied	\N	\N	\N	\N	223456	223456	390467
29888	50241	5	applied	\N	\N	\N	\N	223474	223474	390485
29890	50239	2	applied	\N	\N	\N	\N	223491	223491	390502
29891	50248	2	applied	\N	\N	\N	\N	223497	223497	390508
29891	50251	5	applied	\N	\N	\N	\N	223500	223500	390511
29894	50259	4	applied	\N	\N	\N	\N	223526	223526	390537
29897	50258	3	applied	\N	\N	\N	\N	223555	223555	390566
29899	50266	1	applied	\N	\N	\N	\N	223573	223573	390583
29900	50268	3	applied	\N	\N	\N	\N	223585	223585	390594
29901	50266	1	applied	\N	\N	\N	\N	223593	223593	390601
29904	50288	2	applied	\N	\N	\N	\N	223623	223623	390628
29906	50302	7	applied	\N	\N	\N	\N	223646	223646	390650
29909	50306	1	applied	\N	\N	\N	\N	223663	223663	390666
29912	50320	4	applied	\N	\N	\N	\N	223689	223689	390692
29913	50320	5	applied	\N	\N	\N	\N	223698	223698	390701
29917	50336	3	applied	\N	\N	\N	\N	223731	223731	390731
29920	50275	0	applied	\N	\N	\N	\N	223751	223751	390751
29920	50283	16	applied	\N	\N	\N	\N	223766	223766	390765
29920	50290	19	applied	\N	\N	\N	\N	223769	223769	390768
29920	50302	36	applied	\N	\N	\N	\N	223786	223786	390784
29920	50304	38	applied	\N	\N	\N	\N	223788	223788	390786
29920	50312	41	applied	\N	\N	\N	\N	223791	223791	390789
29920	50298	58	applied	\N	\N	\N	\N	223808	223808	390806
29920	50349	75	applied	\N	\N	\N	\N	223825	223825	390823
29797	49610	3	applied	\N	\N	\N	\N	222059	222059	389072
29926	50368	5	applied	\N	\N	\N	\N	223871	223871	390869
29927	50367	4	applied	\N	\N	\N	\N	223889	223889	390887
29928	50366	3	applied	\N	\N	\N	\N	223907	223907	390905
29929	50365	2	applied	\N	\N	\N	\N	223925	223925	390923
29929	50384	19	applied	\N	\N	\N	\N	223942	223942	390940
29930	50207	1	applied	\N	\N	\N	\N	223948	223948	390946
29930	50315	12	applied	\N	\N	\N	\N	223959	223959	390957
29930	50299	28	applied	\N	\N	\N	\N	223975	223975	223975
29930	50217	34	applied	\N	\N	\N	\N	223981	223981	390976
29930	50337	50	applied	\N	\N	\N	\N	223997	223997	390992
29930	50274	67	applied	\N	\N	\N	\N	224014	224014	391009
29930	50340	84	applied	\N	\N	\N	\N	224031	224031	391026
29935	50404	0	applied	\N	\N	\N	\N	224082	224082	391077
29936	50406	2	applied	\N	\N	\N	\N	224094	224094	391089
29937	50411	7	applied	\N	\N	\N	\N	224109	224109	391104
29938	50405	6	applied	\N	\N	\N	\N	224118	224118	391113
29938	50392	33	applied	\N	\N	\N	\N	224144	224144	391139
29938	50409	50	applied	\N	\N	\N	\N	224161	224161	391156
29944	50431	6	applied	\N	\N	\N	\N	224183	224183	391178
29947	50432	0	applied	\N	\N	\N	\N	224203	224203	391198
29948	50437	5	applied	\N	\N	\N	\N	224218	224218	391213
29949	50450	7	applied	\N	\N	\N	\N	224231	224231	391226
29950	50461	9	applied	\N	\N	\N	\N	224242	224242	391237
29954	50489	9	applied	\N	\N	\N	\N	224270	224270	391265
29955	50486	6	applied	\N	\N	\N	\N	224277	224277	391272
29955	50487	7	applied	\N	\N	\N	\N	224278	224278	391273
29957	50490	0	applied	\N	\N	\N	\N	224291	224291	391286
29958	50501	1	applied	\N	\N	\N	\N	224302	224302	391297
29965	50518	2	applied	\N	\N	\N	\N	224340	224340	391335
29965	50528	12	applied	\N	\N	\N	\N	224350	224350	391345
29965	50531	15	applied	\N	\N	\N	\N	224353	224353	391348
29966	50523	7	applied	\N	\N	\N	\N	224362	224362	391357
29967	50534	2	applied	\N	\N	\N	\N	224376	224376	391371
29968	50538	5	applied	\N	\N	\N	\N	224392	224392	391387
29969	50552	6	applied	\N	\N	\N	\N	224406	224406	391401
29971	50554	8	applied	\N	\N	\N	\N	224426	224426	391421
29974	50556	1	applied	\N	\N	\N	\N	224442	224442	391437
29975	50555	0	applied	\N	\N	\N	\N	224459	224459	391454
29975	50572	17	applied	\N	\N	\N	\N	224476	224476	391471
29977	50573	0	applied	\N	\N	\N	\N	224486	224486	391481
29977	50590	17	applied	\N	\N	\N	\N	224503	224503	391498
29978	50575	2	applied	\N	\N	\N	\N	224508	224508	391503
29978	50592	19	applied	\N	\N	\N	\N	224525	224525	391520
29979	50609	17	applied	\N	\N	\N	\N	224542	224542	391537
29983	50636	14	applied	\N	\N	\N	\N	224588	224588	391583
29984	50627	5	applied	\N	\N	\N	\N	224598	224598	391593
29985	50634	12	applied	\N	\N	\N	\N	224624	224624	391619
29986	50480	3	applied	\N	\N	\N	\N	224634	224634	391629
29986	50507	6	applied	\N	\N	\N	\N	224637	224637	391632
29986	50457	23	applied	\N	\N	\N	\N	224654	224654	391649
29986	50503	40	applied	\N	\N	\N	\N	224671	224671	391666
29986	50469	58	applied	\N	\N	\N	\N	224688	224688	391683
29986	50579	75	applied	\N	\N	\N	\N	224705	224705	391700
29986	50523	92	applied	\N	\N	\N	\N	224722	224722	391717
29986	50548	109	applied	\N	\N	\N	\N	224739	224739	391734
29987	50641	0	applied	\N	\N	\N	\N	224752	224752	391747
29987	50658	17	applied	\N	\N	\N	\N	224769	224769	391764
29988	50649	8	applied	\N	\N	\N	\N	224779	224779	391774
29988	50657	11	applied	\N	\N	\N	\N	224782	224782	391777
29989	50654	13	applied	\N	\N	\N	\N	224798	224798	391793
29992	50671	2	applied	\N	\N	\N	\N	224834	224834	391829
29993	50681	2	applied	\N	\N	\N	\N	224844	224844	391839
29993	50684	5	applied	\N	\N	\N	\N	224847	224847	391842
29995	50691	3	applied	\N	\N	\N	\N	224861	224861	391856
29997	50688	0	applied	\N	\N	\N	\N	224872	224872	391867
29998	50705	10	applied	\N	\N	\N	\N	224889	224889	391884
29999	50708	13	applied	\N	\N	\N	\N	224911	224911	391906
30000	50722	7	applied	\N	\N	\N	\N	224925	224925	391920
30001	50414	8	applied	\N	\N	\N	\N	224936	224936	391931
30001	50556	25	applied	\N	\N	\N	\N	224953	224953	391948
30001	50353	42	applied	\N	\N	\N	\N	224970	224970	391965
30001	50396	59	applied	\N	\N	1000000000	\N	224985	224985	391980
30001	50358	80	applied	\N	\N	\N	\N	225006	225006	392001
30001	50451	110	applied	\N	\N	\N	\N	225036	225036	392031
30001	50469	118	applied	\N	\N	\N	\N	225044	225044	392039
30001	50470	119	applied	\N	\N	\N	\N	225045	225045	392040
30005	50752	9	applied	\N	\N	\N	\N	225082	225082	392077
30006	50749	6	applied	\N	\N	\N	\N	225099	225099	392094
30007	50772	9	applied	\N	\N	\N	\N	225122	225122	392117
30008	50776	3	applied	\N	\N	\N	\N	225126	225126	392121
30011	50788	6	applied	\N	\N	\N	\N	225156	225156	392151
30011	50805	23	applied	\N	\N	\N	\N	225173	225173	392168
30014	50831	2	applied	\N	\N	\N	\N	225199	225199	392194
30016	50843	5	applied	\N	\N	\N	\N	225211	225211	392206
30016	50846	8	applied	\N	\N	\N	\N	225214	225214	392209
30016	50863	25	applied	\N	\N	\N	\N	225231	225231	392226
30017	50839	1	applied	\N	\N	\N	\N	225237	225237	392232
30017	50856	18	applied	\N	\N	\N	\N	225254	225254	392249
30019	50843	5	applied	\N	\N	\N	\N	225271	225271	392266
30020	50840	2	applied	\N	\N	\N	\N	225298	225298	392293
30020	50857	19	applied	\N	\N	\N	\N	225315	225315	392310
30024	50874	6	applied	\N	\N	\N	\N	225332	225332	392327
30030	50888	7	applied	\N	\N	\N	\N	225365	225365	392360
30031	50901	7	applied	\N	\N	\N	\N	225378	225378	392373
30032	50900	6	applied	\N	\N	\N	\N	225396	225396	392391
30033	50924	12	applied	\N	\N	\N	\N	225420	225420	392415
30033	50927	15	applied	\N	\N	\N	\N	225423	225423	392418
30034	50934	3	applied	\N	\N	\N	\N	225430	225430	392425
30037	50945	3	applied	\N	\N	1000000000	\N	225454	225454	392449
30037	50946	4	applied	\N	\N	1000000000	\N	225455	225455	392450
30038	50944	2	applied	\N	\N	\N	\N	225463	225463	392458
30039	50965	13	applied	\N	\N	\N	\N	225484	225484	392479
30040	50962	10	applied	\N	\N	\N	\N	225503	225503	392498
30040	50967	15	applied	\N	\N	\N	\N	225508	225508	392503
30040	50968	16	applied	\N	\N	\N	\N	225509	225509	392504
30041	50968	16	applied	\N	\N	\N	\N	225531	225531	392526
30042	50987	13	applied	\N	\N	\N	\N	225550	225550	392544
30043	50975	1	applied	\N	\N	\N	\N	225559	225559	392553
30044	50988	14	applied	\N	\N	\N	\N	225593	225593	392585
30045	51004	9	applied	\N	\N	\N	\N	225609	225609	392601
29924	50352	0	applied	\N	\N	\N	\N	223853	223853	390851
30049	51023	8	applied	\N	\N	\N	\N	225678	225678	392670
30051	51032	7	applied	\N	\N	\N	\N	225687	225687	392679
30052	51040	15	applied	\N	\N	\N	\N	225712	225712	392704
30053	51048	6	applied	\N	\N	\N	\N	225720	225720	392712
30054	51042	0	applied	\N	\N	\N	\N	225724	225724	392716
30055	51065	13	applied	\N	\N	\N	\N	225747	225747	392739
30056	51059	7	applied	\N	\N	\N	\N	225761	225761	392753
30057	51059	7	applied	\N	\N	\N	\N	225781	225781	392773
30059	51087	15	applied	\N	\N	\N	\N	225828	225828	392820
30060	51095	4	applied	\N	\N	\N	\N	225836	225836	392828
30061	51107	8	applied	\N	\N	\N	\N	225848	225848	392840
30062	51118	13	applied	\N	\N	\N	\N	225862	225862	392854
30062	51129	30	applied	\N	\N	\N	\N	225879	225879	392871
30063	51135	4	applied	\N	\N	\N	\N	225885	225885	392877
30063	51136	5	applied	\N	\N	\N	\N	225886	225886	392878
30063	51137	7	applied	\N	\N	\N	\N	225887	225887	392879
30064	51131	0	applied	\N	\N	\N	\N	225889	225889	392881
30064	51134	3	applied	\N	\N	\N	\N	225892	225892	392884
30067	51165	6	applied	\N	\N	\N	\N	225923	225923	392914
30069	51170	3	applied	\N	\N	\N	\N	225934	225934	392925
30070	51176	7	applied	\N	\N	\N	\N	225949	225949	392940
30071	51170	3	applied	\N	\N	\N	\N	225956	225956	392947
30071	51173	4	applied	\N	\N	\N	\N	225957	225957	392948
30073	51192	6	applied	\N	\N	\N	\N	225978	225978	392969
30078	51229	4	applied	\N	\N	\N	\N	226039	226039	393030
30079	51226	1	applied	\N	\N	\N	\N	226046	226046	393037
30080	51244	9	applied	\N	\N	\N	\N	226064	226064	393055
30082	51239	4	applied	\N	\N	\N	\N	226077	226077	393068
30083	51239	4	applied	\N	\N	\N	\N	226086	226086	393077
30085	51245	0	applied	\N	\N	\N	\N	226099	226099	393090
30086	51265	11	applied	\N	\N	\N	\N	226119	226119	393110
30088	51282	0	applied	\N	\N	\N	\N	226145	226145	393136
30090	51290	8	applied	\N	\N	\N	\N	226167	226167	393158
30091	51284	2	applied	\N	\N	\N	\N	226170	226170	393161
30093	51292	1	applied	\N	\N	\N	\N	226187	226187	393178
30096	51308	8	applied	\N	\N	\N	\N	226220	226220	393211
30098	51310	1	applied	\N	\N	\N	\N	226224	226224	393215
30098	51320	18	applied	\N	\N	\N	\N	226241	226241	393232
30099	50734	4	applied	\N	\N	\N	\N	226253	226253	393244
30099	50839	16	applied	\N	\N	\N	\N	226265	226265	393256
30099	51131	45	applied	\N	\N	\N	\N	226294	226294	393285
30099	51291	62	applied	\N	\N	\N	\N	226311	226311	393302
30099	50964	79	applied	\N	\N	\N	\N	226328	226328	393318
30099	50844	97	applied	\N	\N	\N	\N	226345	226345	393335
30099	50972	114	applied	\N	\N	\N	\N	226362	226362	393352
30100	51333	5	applied	\N	\N	\N	\N	226376	226376	393366
30102	51336	8	applied	\N	\N	\N	\N	226390	226390	393380
30104	51332	4	applied	\N	\N	\N	\N	226403	226403	393393
30107	51342	6	applied	\N	\N	\N	\N	226422	226422	393412
30108	51346	13	applied	\N	\N	\N	\N	226451	226451	393441
30108	51360	31	applied	\N	\N	\N	\N	226468	226468	393458
30109	51341	5	applied	\N	\N	\N	\N	226478	226478	393468
30109	51334	23	applied	\N	\N	\N	\N	226495	226495	393485
30109	51372	40	applied	\N	\N	\N	\N	226512	226512	393502
30110	51351	21	applied	\N	\N	\N	\N	226545	226545	393535
30110	51363	38	applied	\N	\N	\N	\N	226562	226562	393552
30111	51345	15	applied	\N	\N	\N	\N	226591	226591	393581
30111	51357	32	applied	\N	\N	\N	\N	226608	226608	393598
30111	51360	35	applied	\N	\N	\N	\N	226611	226611	393601
30111	51361	36	applied	\N	\N	\N	\N	226612	226612	393602
30112	51365	0	applied	\N	\N	1000000000	\N	226629	226629	393619
30112	51350	20	applied	\N	\N	\N	\N	226648	226648	393638
30113	51329	4	applied	\N	\N	\N	\N	226663	226663	393653
30113	51333	12	applied	\N	\N	\N	\N	226670	226670	393660
30113	51353	28	applied	\N	\N	\N	\N	226686	226686	393676
30113	51354	29	applied	\N	\N	\N	\N	226687	226687	393677
30113	51378	46	applied	\N	\N	\N	\N	226704	226704	393694
30114	51382	24	applied	\N	\N	\N	\N	226734	226734	393724
30115	51343	7	applied	\N	\N	\N	\N	226744	226744	393734
30115	51368	8	applied	\N	\N	\N	\N	226745	226745	393735
30115	51371	26	applied	\N	\N	\N	\N	226762	226762	393752
30115	51355	30	applied	\N	\N	\N	\N	226766	226766	393756
30115	51358	33	applied	\N	\N	\N	\N	226769	226769	393759
30115	51382	50	applied	\N	\N	\N	\N	226786	226786	393776
30119	51388	7	applied	\N	\N	\N	\N	226824	226824	393811
30120	51394	8	applied	\N	\N	\N	\N	226836	226836	226836
30121	51407	15	applied	\N	\N	\N	\N	226866	226866	393851
30122	51398	3	applied	\N	\N	\N	\N	226877	226877	393862
30122	51412	20	applied	\N	\N	\N	\N	226894	226894	393878
30123	51424	9	applied	\N	\N	\N	\N	226906	226906	393890
30123	51441	26	applied	\N	\N	\N	\N	226923	226923	393907
30124	51457	14	applied	\N	\N	\N	\N	226939	226939	393923
30125	51465	2	applied	\N	\N	\N	\N	226947	226947	393931
30126	51472	9	applied	\N	\N	\N	\N	226973	226973	393957
30128	51492	2	applied	\N	\N	\N	\N	226993	226993	393977
30128	51493	3	applied	\N	\N	\N	\N	226994	226994	393978
30129	51496	3	applied	\N	\N	\N	\N	227000	227000	393984
30130	51497	5	applied	\N	\N	\N	\N	227011	227011	393995
30134	51505	12	applied	\N	\N	\N	\N	227048	227048	394032
30137	51514	8	applied	\N	\N	\N	\N	227074	227074	394058
30137	51515	9	applied	\N	\N	\N	\N	227075	227075	394059
30139	51520	4	applied	\N	\N	1000000000	\N	227098	227098	394082
30140	51520	4	applied	\N	\N	1000000000	\N	227110	227110	394094
30142	51531	4	applied	\N	\N	\N	\N	227127	227127	394111
30142	51534	7	applied	\N	\N	\N	\N	227130	227130	394114
30146	51551	5	applied	\N	\N	\N	\N	227161	227161	394145
30147	51551	5	applied	\N	\N	\N	\N	227169	227169	394153
30150	51560	6	applied	\N	\N	\N	\N	227196	227196	394180
30153	51577	13	applied	\N	\N	\N	\N	227213	227213	394197
30153	51594	30	applied	\N	\N	\N	\N	227230	227230	394214
30153	51611	47	applied	\N	\N	\N	\N	227247	227247	394231
30154	51567	3	applied	\N	\N	\N	\N	227252	227252	394236
30154	51584	20	applied	\N	\N	\N	\N	227269	227269	394253
30154	51601	37	applied	\N	\N	\N	\N	227286	227286	394270
30156	51617	4	applied	\N	\N	\N	\N	227312	227312	394296
30157	51616	3	applied	\N	\N	\N	\N	227321	227321	394305
30159	51628	5	applied	\N	\N	\N	\N	227339	227339	394323
30161	51638	7	applied	\N	\N	\N	\N	227347	227347	394331
30163	51680	31	applied	\N	\N	\N	\N	227389	227389	394373
30164	51659	9	applied	\N	\N	\N	\N	227407	227407	394391
30047	51005	10	applied	\N	\N	\N	\N	225650	225650	392642
30165	51658	8	applied	\N	\N	\N	\N	227445	227445	394429
30165	51662	12	applied	\N	\N	\N	\N	227449	227449	394433
30165	51679	29	applied	\N	\N	\N	\N	227466	227466	394450
30166	51659	9	applied	\N	\N	\N	\N	227485	227485	394469
30166	51676	26	applied	\N	\N	\N	\N	227502	227502	394486
30169	51696	7	applied	\N	\N	\N	\N	227539	227539	394523
30171	51705	7	applied	\N	\N	\N	\N	227556	227556	394540
30172	51703	5	applied	\N	\N	\N	\N	227562	227562	394546
30175	51718	3	applied	\N	\N	\N	\N	227586	227586	394570
30177	51735	10	applied	\N	\N	\N	\N	227612	227612	394595
30178	51732	7	applied	\N	\N	\N	\N	227628	227628	394611
30179	51733	8	applied	\N	\N	\N	\N	227639	227639	394622
30180	51744	0	applied	\N	\N	\N	\N	227650	227650	394633
30181	51750	6	applied	\N	\N	\N	\N	227664	227664	394647
30184	51758	5	applied	\N	\N	\N	\N	227684	227684	394667
30185	50158	5	applied	\N	\N	\N	\N	227692	227692	394674
30185	49094	22	applied	\N	\N	\N	\N	227709	227709	394689
30185	49327	42	applied	\N	\N	\N	\N	227729	227729	394707
30185	49346	48	applied	\N	\N	\N	\N	227735	227735	394713
30185	51394	52	applied	\N	\N	\N	\N	227739	227739	227739
30185	49124	70	applied	\N	\N	\N	\N	227756	227756	394730
30188	51779	11	applied	\N	\N	\N	\N	227787	227787	394761
30190	51769	1	applied	\N	\N	\N	\N	227808	227808	394782
30190	51786	19	applied	\N	\N	\N	\N	227825	227825	394799
30191	51796	8	applied	\N	\N	\N	\N	227835	227835	394809
30194	51799	1	applied	\N	\N	\N	\N	227872	227872	394845
30193	51807	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	227856	227856	\N
30194	51800	2	applied	\N	\N	\N	\N	227873	227873	394846
30198	51819	5	applied	\N	\N	\N	\N	227926	227926	394896
30195	51807	9	failed	Amount_insufficient_to_create_account	\N	\N	\N	227892	227892	\N
30200	51841	14	applied	\N	\N	\N	\N	227962	227962	394932
30202	51858	11	applied	\N	\N	\N	\N	227979	227979	394949
30203	51847	0	applied	\N	\N	\N	\N	227989	227989	394959
30203	51864	17	applied	\N	\N	\N	\N	228006	228006	394976
30204	51874	6	applied	\N	\N	1000000000	\N	228016	228016	394986
30205	51874	6	applied	\N	\N	1000000000	\N	228028	228028	394998
30207	51554	3	applied	\N	\N	\N	\N	228049	228049	395019
30207	51715	20	applied	\N	\N	\N	\N	228066	228066	395036
30207	51744	23	applied	\N	\N	\N	\N	228069	228069	395039
30207	51752	24	applied	\N	\N	\N	\N	228070	228070	395040
30207	51761	25	applied	\N	\N	\N	\N	228071	228071	395041
30207	51768	26	applied	\N	\N	\N	\N	228072	228072	395042
30207	51560	63	applied	\N	\N	\N	\N	228108	228108	395077
30207	51582	75	applied	\N	\N	\N	\N	228120	228120	395089
30207	51589	85	applied	\N	\N	\N	\N	228130	228130	395099
30207	51561	88	applied	\N	\N	\N	\N	228133	228133	395102
30207	51599	105	applied	\N	\N	\N	\N	228150	228150	395119
30210	51877	10	applied	\N	\N	\N	\N	228178	228178	395147
30210	51897	28	applied	\N	\N	\N	\N	228195	228195	395164
30211	51869	0	applied	\N	\N	\N	\N	228201	228201	395170
30211	51885	15	applied	\N	\N	1000000000	\N	228216	228216	395185
30211	51893	24	applied	\N	\N	\N	\N	228224	228224	395193
30213	51872	5	applied	\N	\N	\N	\N	228238	228238	395207
30213	51892	23	applied	\N	\N	\N	\N	228255	228255	395224
30214	51873	6	applied	\N	\N	\N	\N	228272	228272	395241
30214	51892	23	applied	\N	\N	\N	\N	228288	228288	395257
30214	51895	26	applied	\N	\N	\N	\N	228291	228291	395260
30215	51911	8	applied	\N	\N	\N	\N	228307	228307	395276
30216	51912	9	applied	\N	\N	\N	\N	228318	228318	395287
30219	51904	1	applied	\N	\N	\N	\N	228341	228341	395310
30219	51905	2	applied	\N	\N	\N	\N	228342	228342	395311
30221	51917	4	applied	\N	\N	\N	\N	228364	228364	395333
30223	50763	8	applied	\N	\N	\N	\N	228385	228385	395354
30223	50914	25	applied	\N	\N	\N	\N	228402	228402	395371
30223	51091	42	applied	\N	\N	\N	\N	228419	228419	395388
30223	51225	62	applied	\N	\N	\N	\N	228433	228433	395402
30223	51338	75	applied	\N	\N	\N	\N	228446	228446	395415
30223	51339	76	applied	\N	\N	\N	\N	228447	228447	395416
30223	51527	93	applied	\N	\N	\N	\N	228464	228464	395433
30224	51934	4	applied	\N	\N	\N	\N	228472	228472	395441
30227	51923	1	applied	\N	\N	\N	\N	228500	228500	395469
30228	51949	10	applied	\N	\N	\N	\N	228518	228518	395487
30230	51952	2	applied	\N	\N	\N	\N	228532	228532	395501
30230	51969	19	applied	\N	\N	\N	\N	228549	228549	395518
30231	51982	5	applied	\N	\N	\N	\N	228562	228562	395531
30232	51986	9	applied	\N	\N	\N	\N	228576	228576	395545
30236	51979	2	applied	\N	\N	\N	\N	228605	228605	395574
30239	52012	7	applied	\N	\N	\N	\N	228648	228648	395617
30242	52013	0	applied	\N	\N	\N	\N	228655	228655	395624
30245	52034	3	applied	\N	\N	\N	\N	228676	228676	395645
30245	52049	18	applied	\N	\N	\N	\N	228691	228691	395660
30246	52067	17	applied	\N	\N	\N	\N	228709	228709	395678
30247	52056	6	applied	\N	\N	\N	\N	228717	228717	395686
30248	52072	3	applied	\N	\N	\N	\N	228733	228733	395702
30250	52073	4	applied	\N	\N	\N	\N	228756	228756	395725
30251	52073	4	applied	\N	\N	\N	\N	228765	228765	395734
30255	52097	0	applied	\N	\N	\N	\N	228800	228800	395769
30255	52098	1	applied	\N	\N	\N	\N	228801	228801	395770
30256	52100	3	applied	\N	\N	\N	\N	228821	228821	395790
30257	52097	0	applied	\N	\N	\N	\N	228836	228836	395805
30257	52114	17	applied	\N	\N	\N	\N	228853	228853	395822
30258	52115	0	applied	\N	\N	\N	\N	228854	228854	395823
30258	52132	17	applied	\N	\N	\N	\N	228871	228871	395840
30259	52125	10	applied	\N	\N	\N	\N	228905	228905	395874
30259	52142	27	applied	\N	\N	\N	\N	228922	228922	395891
30261	52118	2	applied	\N	\N	\N	\N	228940	228940	395909
30261	52134	19	applied	\N	\N	\N	\N	228957	228957	395926
30261	52135	20	applied	\N	\N	\N	\N	228958	228958	395927
30261	52159	37	applied	\N	\N	\N	\N	228975	228975	395944
30261	52152	42	applied	\N	\N	\N	\N	228980	228980	395949
30261	52153	43	applied	\N	\N	\N	\N	228981	228981	395950
30262	52180	14	applied	\N	\N	\N	\N	229001	229001	395970
30264	52189	3	applied	\N	\N	\N	\N	229011	229011	395980
30266	52208	18	applied	\N	\N	\N	\N	229039	229039	396008
30267	52030	1	applied	\N	\N	\N	\N	229056	229056	396025
30267	51366	18	applied	\N	\N	\N	\N	229073	229073	396042
30267	51536	35	applied	\N	\N	\N	\N	229090	229090	396059
30267	51698	52	applied	\N	\N	\N	\N	229107	229107	396076
30267	51904	69	applied	\N	\N	\N	\N	229124	229124	396093
30164	51675	25	applied	\N	\N	\N	\N	227423	227423	394407
3	1	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61414	61414	\N
246	214	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	61771	61771	\N
719	623	0	failed	Receiver_not_present	\N	\N	\N	62511	62511	\N
922	797	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	62839	62839	\N
1412	1273	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	63971	63971	\N
3520	2922	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	71478	71478	\N
3543	2922	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	71499	71499	\N
30268	52235	11	applied	\N	\N	\N	\N	229189	229189	396156
30269	52225	1	applied	\N	\N	\N	\N	229199	229199	396166
30270	52248	8	applied	\N	\N	\N	\N	229217	229217	396184
30270	52237	13	applied	\N	\N	\N	\N	229222	229222	396189
30271	52261	7	applied	\N	\N	\N	\N	229235	229235	396202
30273	52275	10	applied	\N	\N	\N	\N	229260	229260	396227
30274	52265	0	applied	\N	\N	\N	\N	229272	229272	396239
30274	52293	19	applied	\N	\N	\N	\N	229291	229291	396258
30274	52301	36	applied	\N	\N	\N	\N	229308	229308	396275
30276	52310	2	applied	\N	\N	\N	\N	229317	229317	396284
30276	52300	19	applied	\N	\N	\N	\N	229334	229334	396301
30279	52337	3	applied	\N	\N	1000000000	\N	229369	229369	396336
30282	52346	4	applied	\N	\N	\N	\N	229397	229397	396364
30283	52345	3	applied	\N	\N	\N	\N	229401	229401	396368
30285	52350	1	applied	\N	\N	\N	\N	229407	229407	396374
30286	52350	1	applied	\N	\N	\N	\N	229413	229413	396380
30290	52366	12	applied	\N	\N	\N	\N	229454	229454	396421
30291	52355	1	applied	\N	\N	\N	\N	229456	229456	396423
30293	52356	3	applied	\N	\N	\N	\N	229484	229484	396451
30294	52372	5	applied	\N	\N	\N	\N	229499	229499	396466
30295	52371	4	applied	\N	\N	\N	\N	229505	229505	396472
30298	52369	3	applied	\N	\N	\N	\N	229523	229523	396489
30302	52383	1	applied	\N	\N	\N	\N	229556	229556	396513
30304	52393	4	applied	\N	\N	\N	\N	229569	229569	396526
30307	52397	1	applied	\N	\N	\N	\N	229588	229588	396545
30315	52402	4	applied	\N	\N	\N	\N	229611	229611	396568
63	49	0	applied	\N	\N	\N	\N	61490	61490	229673
96	84	0	applied	\N	\N	\N	\N	61540	61540	229723
250	222	2	applied	\N	\N	\N	\N	61785	61785	229965
602	527	0	applied	\N	\N	\N	\N	62331	62331	230508
906	780	1	applied	\N	\N	\N	\N	62813	62813	230982
958	827	0	applied	\N	\N	\N	\N	62887	62887	231055
1056	950	12	applied	\N	\N	\N	\N	63146	63146	231314
1063	971	0	applied	\N	\N	\N	\N	63249	63249	231417
1166	1076	0	applied	\N	\N	\N	\N	63506	63506	231674
1275	1163	0	applied	\N	\N	\N	\N	63677	63677	231845
1325	1203	2	applied	\N	\N	1000000000	\N	63756	63756	231924
1334	1158	0	applied	\N	\N	\N	\N	63767	63767	231935
1497	1354	2	applied	\N	\N	\N	\N	64224	64224	232389
1503	1361	0	applied	\N	\N	\N	\N	64235	64235	232400
1594	1355	2	applied	\N	\N	1000000000	\N	64397	64397	232562
1605	1424	0	applied	\N	\N	\N	\N	64511	64511	232676
1624	1435	42	applied	\N	\N	\N	\N	64704	64704	232869
1720	1505	0	applied	\N	\N	\N	\N	64983	64983	233148
1760	1531	0	applied	\N	\N	\N	\N	65048	65048	233213
1870	1607	0	applied	\N	\N	\N	\N	65294	65294	233459
1975	1539	25	applied	\N	\N	\N	\N	65507	65507	233672
2016	1705	1	applied	\N	\N	\N	\N	65794	65794	233959
2216	1850	0	applied	\N	\N	\N	\N	66306	66306	234471
2262	1889	2	applied	\N	\N	\N	\N	66377	66377	234542
2306	1915	0	applied	\N	\N	\N	\N	66569	66569	234734
2334	1932	1	applied	\N	\N	\N	\N	66621	66621	234786
2386	1969	0	applied	\N	\N	\N	\N	66821	66821	234986
2398	1982	0	applied	\N	\N	\N	\N	66838	66838	235003
2420	1996	0	applied	\N	\N	\N	\N	66867	66867	235032
2491	2052	0	applied	\N	\N	\N	\N	67064	67064	235229
2553	2062	52	applied	\N	\N	\N	\N	67341	67341	235506
2553	2083	73	applied	\N	\N	\N	\N	67361	67361	235526
2630	2178	1	applied	\N	\N	\N	\N	67560	67560	235725
2669	2203	0	applied	\N	\N	\N	\N	67696	67696	235861
2701	2227	0	applied	\N	\N	\N	\N	67836	67836	236001
2737	2253	0	applied	\N	\N	\N	\N	68102	68102	236267
2760	2170	125	applied	\N	\N	\N	\N	68316	68316	236481
2780	2279	1	applied	\N	\N	\N	\N	68346	68346	236511
2804	2182	80	applied	\N	\N	\N	\N	68590	68590	236755
2804	2198	96	applied	\N	\N	\N	\N	68606	68606	236771
2912	2326	30	applied	\N	\N	\N	\N	68818	68818	236983
2912	2328	32	applied	\N	\N	\N	\N	68820	68820	236985
2923	2386	0	applied	\N	\N	\N	\N	68982	68982	237147
2984	2429	0	applied	\N	\N	\N	\N	69054	69054	237219
3076	2395	90	applied	\N	\N	\N	\N	69337	69337	237502
3095	2501	7	applied	\N	\N	1000000000	\N	69562	69562	237727
3131	2535	9	applied	\N	\N	\N	\N	69655	69655	237820
3184	2592	0	applied	\N	\N	\N	\N	69735	69735	237900
3189	2594	0	applied	\N	\N	\N	\N	69740	69740	237905
3209	2552	65	applied	\N	\N	\N	\N	69841	69841	238006
3209	2587	101	applied	\N	\N	\N	\N	69876	69876	238041
3247	2665	47	applied	\N	\N	\N	\N	70100	70100	238265
3328	2805	0	applied	\N	\N	\N	\N	70387	70387	238552
3340	2830	0	applied	\N	\N	\N	\N	70436	70436	238601
3369	2765	44	applied	\N	\N	\N	\N	70675	70675	238840
3395	2683	89	applied	\N	\N	\N	\N	70963	70963	239128
3489	2722	13	applied	\N	\N	\N	\N	71241	71241	239406
3728	2978	0	applied	\N	\N	\N	\N	71618	71618	239780
3826	2986	52	applied	\N	\N	\N	\N	71810	71810	239971
3826	3010	75	applied	\N	\N	\N	\N	71833	71833	239994
3867	3088	0	applied	\N	\N	\N	\N	72062	72062	240223
3927	3110	43	applied	\N	\N	\N	\N	72175	72175	240336
4081	3243	1	applied	\N	\N	\N	\N	72400	72400	240561
4157	3311	0	applied	\N	\N	1000000000	\N	72649	72649	240810
4180	3331	2	applied	\N	\N	\N	\N	72687	72687	240848
4245	3395	70	applied	\N	\N	\N	\N	72969	72969	241127
4306	3096	41	applied	\N	\N	\N	\N	73196	73196	241352
4345	3250	8	applied	\N	\N	1000000000	\N	73337	73337	241493
4347	3270	79	applied	\N	\N	\N	\N	73447	73447	241602
4402	3553	7	applied	\N	\N	\N	\N	73738	73738	241890
4424	3510	10	applied	\N	\N	\N	\N	74036	74036	242185
4443	3667	0	applied	\N	\N	1000000000	\N	74109	74109	242256
4472	3693	0	applied	\N	\N	\N	\N	74306	74306	242446
4571	3657	8	applied	\N	\N	1000000000	\N	74575	74575	242709
30267	51719	104	applied	\N	\N	1000000000	\N	229159	229159	396128
5418	4400	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	77132	77132	\N
5999	4638	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	77837	77837	\N
5999	4639	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	77838	77838	\N
6410	4982	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78804	78804	\N
6413	4990	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	78814	78814	\N
6414	4987	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	78817	78817	\N
6415	4991	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	78827	78827	\N
6422	4982	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	78846	78846	\N
6488	5020	23	failed	Amount_insufficient_to_create_account	\N	\N	\N	79119	79119	\N
6488	5027	26	failed	Amount_insufficient_to_create_account	\N	\N	\N	79122	79122	\N
6674	4985	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	79612	79612	\N
6856	5606	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	80529	80529	\N
6857	5606	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	80538	80538	\N
7354	6205	58	failed	Amount_insufficient_to_create_account	\N	\N	\N	82647	82647	\N
8951	7766	0	failed	Receiver_not_present	\N	\N	\N	87356	87356	\N
9623	8952	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	90421	90421	\N
9799	9333	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	91352	91352	\N
4674	3746	55	applied	\N	\N	\N	\N	75129	75129	243261
4742	3891	3	applied	\N	\N	\N	\N	75321	75321	243453
4813	3970	0	applied	\N	\N	1000000000	\N	75582	75582	243714
4825	3939	108	applied	\N	\N	\N	\N	75709	75709	243841
4852	4002	0	applied	\N	\N	1000000000	\N	75905	75905	244037
4860	3907	37	applied	\N	\N	\N	\N	75952	75952	244084
4895	3779	24	applied	\N	\N	\N	\N	76239	76239	244371
4986	4109	2	applied	\N	\N	\N	\N	76475	76475	244603
5061	4169	0	applied	\N	\N	\N	\N	76577	76577	244704
5065	4170	0	applied	\N	\N	\N	\N	76581	76581	244708
5138	4227	0	applied	\N	\N	1000000000	\N	76699	76699	244826
5325	4289	80	applied	\N	\N	\N	\N	77013	77013	245140
5810	4488	0	applied	\N	\N	\N	\N	77473	77473	245597
5869	4528	1	applied	\N	\N	\N	\N	77613	77613	245737
6339	4615	96	applied	\N	\N	\N	\N	78530	78530	246635
6346	4691	36	applied	\N	\N	\N	\N	78602	78602	246707
6405	4949	0	applied	\N	\N	1000000000	\N	78790	78790	246894
6422	4949	0	applied	\N	\N	1000000000	\N	78844	78844	246928
6422	4847	54	applied	\N	\N	\N	\N	78898	78898	246976
6422	4866	72	applied	\N	\N	\N	\N	78915	78915	246993
6422	4883	89	applied	\N	\N	\N	\N	78932	78932	247010
6601	5165	0	applied	\N	\N	1000000000	\N	79416	79416	247394
6702	5185	0	applied	\N	\N	\N	\N	79975	79975	247908
6703	5380	0	applied	\N	\N	\N	\N	80100	80100	248033
6798	5526	1	applied	\N	\N	1000000000	\N	80354	80354	248287
6883	5648	2	applied	\N	\N	\N	\N	80742	80742	248673
6930	5696	0	applied	\N	\N	\N	\N	80847	80847	248778
6970	5747	1	applied	\N	\N	\N	\N	81012	81012	248943
7066	5903	1	applied	\N	\N	1000000000	\N	81298	81298	249229
7070	5889	63	applied	\N	\N	\N	\N	81368	81368	249299
7099	5952	0	applied	\N	\N	\N	\N	81589	81589	249520
7150	5927	35	applied	\N	\N	\N	\N	81771	81771	249702
7189	6074	0	applied	\N	\N	\N	\N	81920	81920	249851
7341	6125	89	applied	\N	\N	\N	\N	82483	82483	250410
7473	6361	12	applied	\N	\N	1000000000	\N	83155	83155	251074
7528	6361	13	applied	\N	\N	1000000000	\N	83387	83387	251306
7529	6353	8	applied	\N	\N	\N	\N	83507	83507	251423
7592	6502	0	applied	\N	\N	1000000000	\N	83762	83762	251669
7674	6593	2	applied	\N	\N	1000000000	\N	84034	84034	251939
7874	6742	0	applied	\N	\N	\N	\N	84331	84331	252235
7926	6784	0	applied	\N	\N	\N	\N	84407	84407	252311
7959	6772	0	applied	\N	\N	\N	\N	84570	84570	252474
8004	6849	1	applied	\N	\N	\N	\N	84675	84675	252579
8099	6935	1	applied	\N	\N	\N	\N	84854	84854	252758
8210	7010	44	applied	\N	\N	\N	\N	85116	85116	253020
8289	7084	1	applied	\N	\N	1000000000	\N	85263	85263	253165
8302	7094	1	applied	\N	\N	\N	\N	85285	85285	253187
8344	7128	0	applied	\N	\N	1000000000	\N	85455	85455	253357
8484	7227	0	applied	\N	\N	\N	\N	85774	85774	253675
8605	7313	0	applied	\N	\N	\N	\N	86060	86060	253961
8627	7345	0	applied	\N	\N	\N	\N	86280	86280	254181
8632	7225	0	applied	\N	\N	\N	\N	86290	86290	254191
8713	7274	85	applied	\N	\N	\N	\N	86685	86685	254584
8740	7474	1	applied	\N	\N	\N	\N	86789	86789	254688
8843	7599	0	applied	\N	\N	\N	\N	87066	87066	254965
8844	7606	1	applied	\N	\N	\N	\N	87073	87073	254972
8866	7625	0	applied	\N	\N	\N	\N	87115	87115	255014
9000	7848	1	applied	\N	\N	\N	\N	87706	87706	255593
9086	7949	5	applied	\N	\N	1000000000	\N	87982	87982	255868
9161	8101	2	applied	\N	\N	\N	\N	88252	88252	256137
9181	8138	5	applied	\N	\N	\N	\N	88318	88318	256203
9202	8180	1	applied	\N	\N	\N	\N	88510	88510	256393
9252	8122	21	applied	\N	\N	\N	\N	88767	88767	256650
9252	8264	105	applied	\N	\N	\N	\N	88850	88850	256733
9255	8331	2	applied	\N	\N	\N	\N	88904	88904	256787
9256	8338	2	applied	\N	\N	\N	\N	88911	88911	256794
9291	8282	47	applied	\N	\N	\N	\N	89108	89108	256991
9291	7965	112	applied	\N	\N	\N	\N	89173	89173	257056
9435	8653	1	applied	\N	\N	1000000000	\N	89696	89696	257571
9473	8094	68	applied	\N	\N	\N	\N	89909	89909	257782
9476	8712	0	applied	\N	\N	\N	\N	89974	89974	257847
9566	8850	1	applied	\N	\N	\N	\N	90231	90231	258104
9623	8950	2	applied	\N	\N	\N	\N	90419	90419	258280
9677	9078	3	applied	\N	\N	\N	\N	90611	90611	258471
9696	9102	21	applied	\N	\N	\N	\N	90704	90704	258564
9723	8703	0	applied	\N	\N	1000000000	\N	90934	90934	258787
9762	9238	1	applied	\N	\N	\N	\N	91180	91180	259032
9769	9248	1	applied	\N	\N	\N	\N	91237	91237	259069
9823	9399	21	applied	\N	\N	\N	\N	91515	91515	259340
9829	9304	49	applied	\N	\N	\N	\N	91717	91717	259535
9829	9184	63	applied	\N	\N	1000000000	\N	91731	91731	259548
9945	9621	0	applied	\N	\N	\N	\N	92053	92053	259868
9996	9670	3	applied	\N	\N	\N	\N	92331	92331	260145
9998	9610	57	applied	\N	\N	\N	\N	92419	92419	260232
10046	9813	1	applied	\N	\N	\N	\N	92813	92813	260626
10085	9943	23	applied	\N	\N	\N	\N	93057	93057	260870
10817	11308	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	97568	97568	\N
11332	12143	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	100325	100325	\N
11498	12375	45	failed	Amount_insufficient_to_create_account	\N	\N	\N	101134	101134	\N
11500	12396	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	101183	101183	\N
12074	12923	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	103921	103921	\N
13257	14655	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	109152	109152	\N
13327	14655	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	109534	109534	\N
13366	14655	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	109951	109951	\N
10093	10009	18	applied	\N	\N	\N	\N	93301	93301	261114
10116	10073	7	applied	\N	\N	\N	\N	93561	93561	261374
10137	9941	62	applied	\N	\N	\N	\N	93823	93823	261636
10179	10182	1	applied	\N	\N	\N	\N	94036	94036	261848
10189	10189	2	applied	\N	\N	1000000000	\N	94071	94071	261883
10223	9284	43	applied	\N	\N	\N	\N	94211	94211	262023
10230	9091	22	applied	\N	\N	1000000000	\N	94271	94271	262082
10287	10368	0	applied	\N	\N	\N	\N	94570	94570	262381
10288	10370	2	applied	\N	\N	\N	\N	94576	94576	262387
10349	10499	0	applied	\N	\N	\N	\N	94808	94808	262615
10387	10257	39	applied	\N	\N	\N	\N	94952	94952	262759
10388	10553	0	applied	\N	\N	\N	\N	95039	95039	262846
10421	10615	4	applied	\N	\N	\N	\N	95149	95149	262956
10447	10675	21	applied	\N	\N	1000000000	\N	95298	95298	263105
10451	10693	9	applied	\N	\N	1000000000	\N	95449	95449	263256
10469	10725	1	applied	\N	\N	\N	\N	95598	95598	263405
10484	10777	7	applied	\N	\N	\N	\N	95680	95680	263487
10492	10792	11	applied	\N	\N	\N	\N	95714	95714	263521
10506	10825	2	applied	\N	\N	\N	\N	95846	95846	263653
10558	10428	7	applied	\N	\N	\N	\N	96120	96120	263927
10609	10978	1	applied	\N	\N	\N	\N	96356	96356	264163
10644	11035	3	applied	\N	\N	\N	\N	96515	96515	264322
10677	11075	1	applied	\N	\N	\N	\N	96623	96623	264430
10725	10850	101	applied	\N	\N	\N	\N	96874	96874	264681
10760	11206	2	applied	\N	\N	\N	\N	97002	97002	264809
10780	11236	0	applied	\N	\N	\N	\N	97071	97071	264878
10802	10889	73	applied	\N	\N	\N	\N	97349	97349	265156
10854	11038	59	applied	\N	\N	\N	\N	97774	97774	265578
10875	11415	1	applied	\N	\N	1000000000	\N	97924	97924	265728
10917	11499	0	applied	\N	\N	\N	\N	98195	98195	265999
10991	11591	1	applied	\N	\N	\N	\N	98480	98480	266284
11033	11560	59	applied	\N	\N	\N	\N	98682	98682	266481
11038	11651	1	applied	\N	\N	\N	\N	98730	98730	266529
11078	11695	2	applied	\N	\N	\N	\N	98996	98996	266794
11125	11690	21	applied	\N	\N	\N	\N	99244	99244	267042
11172	11814	2	applied	\N	\N	\N	\N	99532	99532	267330
11177	11693	21	applied	\N	\N	\N	\N	99571	99571	267368
11177	11494	38	applied	\N	\N	\N	\N	99588	99588	267385
11198	11838	1	applied	\N	\N	\N	\N	99728	99728	267525
11219	11888	1	applied	\N	\N	\N	\N	99807	99807	267604
11266	12032	9	applied	\N	\N	\N	\N	100064	100064	267861
11333	12146	0	applied	\N	\N	\N	\N	100328	100328	268124
11426	12108	120	applied	\N	\N	\N	\N	100707	100707	268502
11441	12184	5	applied	\N	\N	\N	\N	100753	100753	268548
11447	12314	0	applied	\N	\N	\N	\N	100889	100889	268684
11456	11992	46	applied	\N	\N	\N	\N	100954	100954	268749
11511	12414	1	applied	\N	\N	\N	\N	101255	101255	269030
11525	11848	4	applied	\N	\N	1000000000	\N	101330	101330	269102
11525	11589	65	applied	\N	\N	\N	\N	101391	101391	269161
11604	12287	77	applied	\N	\N	\N	\N	101685	101685	269454
11618	12537	1	applied	\N	\N	\N	\N	101829	101829	269598
11643	12561	0	applied	\N	\N	\N	\N	101980	101980	269749
11739	12624	2	applied	\N	\N	\N	\N	102150	102150	269919
11789	12526	53	applied	\N	\N	\N	\N	102405	102405	270174
11789	12542	70	applied	\N	\N	\N	\N	102421	102421	270190
11851	12728	0	applied	\N	\N	1000000000	\N	102701	102701	270463
11864	12657	15	applied	\N	\N	\N	\N	102742	102742	270504
11888	12758	0	applied	\N	\N	\N	\N	102965	102965	270727
11890	12759	0	applied	\N	\N	\N	\N	102967	102967	270729
11894	12556	57	applied	\N	\N	\N	\N	103029	103029	270791
11897	12767	0	applied	\N	\N	\N	\N	103099	103099	270861
11934	12795	25	applied	\N	\N	\N	\N	103196	103196	270958
12013	12784	43	applied	\N	\N	\N	\N	103412	103412	271174
12013	12825	77	applied	\N	\N	\N	\N	103445	103445	271207
12015	12822	34	applied	\N	\N	\N	\N	103522	103522	271284
12061	12774	27	applied	\N	\N	\N	\N	103711	103711	271470
12180	13009	0	applied	\N	\N	\N	\N	104166	104166	271911
12261	12983	41	applied	\N	\N	\N	\N	104613	104613	272357
12321	13101	34	applied	\N	\N	\N	\N	104867	104867	272611
12343	13175	1	applied	\N	\N	\N	\N	104926	104926	272670
12398	13224	0	applied	\N	\N	\N	\N	105124	105124	272865
12445	13060	20	applied	\N	\N	\N	\N	105178	105178	272919
12519	13304	0	applied	\N	\N	\N	\N	105365	105365	273106
12523	13313	3	applied	\N	\N	\N	\N	105380	105380	273121
12552	13211	96	applied	\N	\N	\N	\N	105552	105552	273293
12552	13250	125	applied	\N	\N	1000000000	\N	105581	105581	273322
12640	13425	103	applied	\N	\N	\N	\N	105958	105958	273699
12647	13522	0	applied	\N	\N	\N	\N	105994	105994	273735
12711	13614	0	applied	\N	\N	\N	\N	106181	106181	273922
12729	13554	9	applied	\N	\N	1000000000	\N	106415	106415	274156
12819	13799	0	applied	\N	\N	\N	\N	106741	106741	274479
12842	13816	1	applied	\N	\N	\N	\N	106773	106773	274511
12923	13934	0	applied	\N	\N	\N	\N	107201	107201	274939
12926	13939	3	applied	\N	\N	\N	\N	107212	107212	274950
13002	14039	0	applied	\N	\N	\N	\N	107471	107471	275209
13060	14164	1	applied	\N	\N	\N	\N	107738	107738	275472
13062	14191	9	applied	\N	\N	\N	\N	107765	107765	275499
13113	14305	1	applied	\N	\N	\N	\N	107998	107998	275732
13155	14437	2	applied	\N	\N	\N	\N	108234	108234	275968
13178	14494	6	applied	\N	\N	\N	\N	108472	108472	276206
13183	14435	3	applied	\N	\N	\N	\N	108508	108508	276242
13185	14515	0	applied	\N	\N	\N	\N	108636	108636	276370
13192	14542	4	applied	\N	\N	\N	\N	108676	108676	276410
13217	14460	83	applied	\N	\N	\N	\N	108864	108864	276598
13226	14482	14	applied	\N	\N	\N	\N	108952	108952	276686
13365	14882	0	applied	\N	\N	\N	\N	109943	109943	277673
13373	14914	3	applied	\N	\N	\N	\N	110005	110005	277734
13409	14997	2	applied	\N	\N	\N	\N	110183	110183	277912
13441	15102	12	applied	\N	\N	\N	\N	110328	110328	278057
13441	15104	14	applied	\N	\N	\N	\N	110330	110330	278059
13585	15388	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	111094	111094	\N
13657	15388	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	111489	111489	\N
13704	15388	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	111893	111893	\N
14044	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114218	114218	\N
14045	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114226	114226	\N
14047	16562	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	114248	114248	\N
14377	16562	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	116781	116781	\N
14841	18279	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	119666	119666	\N
13451	15118	2	applied	\N	\N	\N	\N	110380	110380	278109
13461	15137	2	applied	\N	\N	\N	\N	110411	110411	278140
13503	15241	0	applied	\N	\N	\N	\N	110679	110679	278405
13513	15267	4	applied	\N	\N	\N	\N	110772	110772	278498
13565	15340	5	applied	\N	\N	\N	\N	110932	110932	278658
13568	15260	8	applied	\N	\N	\N	\N	110959	110959	278685
13636	15516	4	applied	\N	\N	\N	\N	111388	111388	279111
13657	14408	108	applied	\N	\N	\N	\N	111594	111594	279315
13743	15759	14	applied	\N	\N	\N	\N	112126	112126	279844
13781	15667	0	applied	\N	\N	1000000000	\N	112327	112327	280045
13818	15935	0	applied	\N	\N	\N	\N	112647	112647	280365
13830	16014	19	applied	\N	\N	\N	\N	112743	112743	280461
13837	15880	80	applied	\N	\N	\N	\N	112864	112864	280582
13837	15897	92	applied	\N	\N	1000000000	\N	112876	112876	280594
13878	16147	7	applied	\N	\N	\N	\N	113194	113194	280912
13902	16190	3	applied	\N	\N	\N	\N	113440	113440	281158
13960	16312	5	applied	\N	\N	\N	\N	113694	113694	281412
13989	16416	2	applied	\N	\N	\N	\N	113908	113908	281626
14004	16472	12	applied	\N	\N	\N	\N	113999	113999	281716
14129	16668	14	applied	\N	\N	\N	\N	114608	114608	282314
14135	16696	2	applied	\N	\N	\N	\N	114681	114681	282387
14168	16748	2	applied	\N	\N	\N	\N	114937	114937	282642
14224	16889	0	applied	\N	\N	\N	\N	115189	115189	282894
14263	16717	26	applied	\N	\N	\N	\N	115406	115406	283111
14282	16868	70	applied	\N	\N	\N	\N	115695	115695	283400
14282	17015	106	applied	\N	\N	\N	\N	115730	115730	283435
14296	17066	1	applied	\N	\N	\N	\N	115807	115807	283512
14302	17099	11	applied	\N	\N	\N	\N	115848	115848	283553
14304	16745	93	applied	\N	\N	\N	\N	115954	115954	283659
14348	16913	100	applied	\N	\N	\N	\N	116289	116289	283993
14348	16921	102	applied	\N	\N	\N	\N	116291	116291	283995
14364	17189	44	applied	\N	\N	\N	\N	116548	116548	284252
14447	17439	0	applied	\N	\N	\N	\N	117175	117175	284874
14470	17488	2	applied	\N	\N	\N	\N	117271	117271	284970
14486	17547	2	applied	\N	\N	\N	\N	117354	117354	285053
14505	17603	18	applied	\N	\N	\N	\N	117517	117517	285214
14510	17619	2	applied	\N	\N	\N	\N	117534	117534	285231
14562	17613	33	applied	\N	\N	\N	\N	117775	117775	285472
14562	17516	85	applied	\N	\N	\N	\N	117827	117827	285524
14615	17794	0	applied	\N	\N	\N	\N	118025	118025	285722
14648	17809	6	applied	\N	\N	\N	\N	118278	118278	285975
14671	17933	0	applied	\N	\N	\N	\N	118513	118513	286210
14680	17930	32	applied	\N	\N	\N	\N	118717	118717	286414
14682	17999	18	applied	\N	\N	\N	\N	118760	118760	286457
14711	17938	59	applied	\N	\N	\N	\N	119032	119032	286729
14737	18101	0	applied	\N	\N	\N	\N	119224	119224	286921
14809	18218	1	applied	\N	\N	\N	\N	119501	119501	287198
14846	17895	9	applied	\N	\N	\N	\N	119684	119684	287380
14886	18356	4	applied	\N	\N	\N	\N	119918	119918	287614
14890	18381	1	applied	\N	\N	\N	\N	119947	119947	287643
14892	18394	7	applied	\N	\N	\N	\N	119960	119960	287656
14892	18395	8	applied	\N	\N	\N	\N	119961	119961	287657
14893	18389	1	applied	\N	\N	\N	\N	119963	119963	287659
14893	18390	3	applied	\N	\N	\N	\N	119964	119964	287660
14893	18391	4	applied	\N	\N	\N	\N	119965	119965	287661
14893	18392	5	applied	\N	\N	\N	\N	119966	119966	287662
14893	18393	6	applied	\N	\N	\N	\N	119967	119967	287663
14893	18394	7	applied	\N	\N	\N	\N	119968	119968	287664
14894	18389	1	applied	\N	\N	\N	\N	119971	119971	287667
14894	18390	3	applied	\N	\N	\N	\N	119972	119972	287668
14894	18392	5	applied	\N	\N	\N	\N	119974	119974	287670
14894	18393	6	applied	\N	\N	\N	\N	119975	119975	287671
14894	18394	7	applied	\N	\N	\N	\N	119976	119976	287672
14894	18395	8	applied	\N	\N	\N	\N	119977	119977	287673
14895	18391	4	applied	\N	\N	\N	\N	119981	119981	287677
14895	18392	5	applied	\N	\N	\N	\N	119982	119982	287678
14895	18394	7	applied	\N	\N	\N	\N	119984	119984	287680
14895	18395	8	applied	\N	\N	\N	\N	119985	119985	287681
14897	18396	0	applied	\N	\N	\N	\N	119986	119986	287682
14897	18397	1	applied	\N	\N	\N	\N	119987	119987	287683
14897	18398	2	applied	\N	\N	\N	\N	119988	119988	287684
14897	18399	3	applied	\N	\N	\N	\N	119989	119989	287685
14898	18396	0	applied	\N	\N	\N	\N	119990	119990	287686
14898	18397	1	applied	\N	\N	\N	\N	119991	119991	287687
14898	18398	2	applied	\N	\N	\N	\N	119992	119992	287688
14898	18399	3	applied	\N	\N	\N	\N	119993	119993	287689
14900	18401	1	applied	\N	\N	\N	\N	119999	119999	287695
14901	18403	0	applied	\N	\N	\N	\N	120001	120001	287697
14901	18404	1	applied	\N	\N	\N	\N	120002	120002	287698
14902	18405	0	applied	\N	\N	\N	\N	120003	120003	287699
14902	18406	1	applied	\N	\N	\N	\N	120004	120004	287700
14902	18407	2	applied	\N	\N	\N	\N	120005	120005	287701
14903	18406	1	applied	\N	\N	\N	\N	120008	120008	287704
14903	18407	2	applied	\N	\N	\N	\N	120009	120009	287705
14903	18408	3	applied	\N	\N	\N	\N	120010	120010	287706
14904	18405	0	applied	\N	\N	\N	\N	120011	120011	287707
14904	18406	1	applied	\N	\N	\N	\N	120012	120012	287708
14904	18407	2	applied	\N	\N	\N	\N	120013	120013	287709
14904	18408	3	applied	\N	\N	\N	\N	120014	120014	287710
14905	18405	0	applied	\N	\N	\N	\N	120015	120015	287711
14905	18406	1	applied	\N	\N	\N	\N	120016	120016	287712
14905	18407	2	applied	\N	\N	\N	\N	120017	120017	287713
14905	18408	3	applied	\N	\N	\N	\N	120018	120018	287714
14906	18409	0	applied	\N	\N	\N	\N	120019	120019	287715
14906	18410	1	applied	\N	\N	\N	\N	120020	120020	287716
14906	18411	2	applied	\N	\N	\N	\N	120021	120021	287717
14907	18412	0	applied	\N	\N	\N	\N	120022	120022	287718
14907	18413	1	applied	\N	\N	\N	\N	120023	120023	287719
14908	18416	2	applied	\N	\N	\N	\N	120026	120026	287722
14908	18417	3	applied	\N	\N	\N	\N	120027	120027	287723
15190	18806	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	121049	121049	\N
15296	18279	7	failed	Amount_insufficient_to_create_account	\N	\N	\N	121486	121486	\N
16185	20806	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	126109	126109	\N
16190	20806	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	126139	126139	\N
16330	21122	0	failed	Receiver_not_present	\N	\N	\N	127160	127160	\N
16586	21122	1	failed	Receiver_not_present	\N	\N	\N	128608	128608	\N
16662	21719	14	failed	Receiver_not_present	\N	\N	\N	129302	129302	\N
16687	21719	40	failed	Receiver_not_present	\N	\N	\N	129460	129460	\N
14909	18415	1	applied	\N	\N	\N	\N	120029	120029	287725
14909	18416	2	applied	\N	\N	\N	\N	120030	120030	287726
14909	18417	3	applied	\N	\N	\N	\N	120031	120031	287727
14910	18420	2	applied	\N	\N	\N	\N	120034	120034	287730
14911	18418	0	applied	\N	\N	\N	\N	120036	120036	287732
14911	18419	1	applied	\N	\N	\N	\N	120037	120037	287733
14911	18420	2	applied	\N	\N	\N	\N	120038	120038	287734
14911	18421	3	applied	\N	\N	\N	\N	120039	120039	287735
14912	18418	0	applied	\N	\N	\N	\N	120040	120040	287736
14912	18419	1	applied	\N	\N	\N	\N	120041	120041	287737
14912	18420	2	applied	\N	\N	\N	\N	120042	120042	287738
14914	18427	1	applied	\N	\N	\N	\N	120049	120049	287745
14923	18448	0	applied	\N	\N	\N	\N	120082	120082	287778
14949	18488	3	applied	\N	\N	\N	\N	120163	120163	287859
15002	18449	89	applied	\N	\N	\N	\N	120386	120386	288082
15107	18692	2	applied	\N	\N	1000000000	\N	120791	120791	288486
15128	18721	0	applied	\N	\N	\N	\N	120842	120842	288537
15146	18726	18	applied	\N	\N	\N	\N	120897	120897	288592
15195	18821	0	applied	\N	\N	\N	\N	121067	121067	288760
15243	18885	1	applied	\N	\N	\N	\N	121274	121274	288967
15426	19190	1	applied	\N	\N	\N	\N	121928	121928	289618
15461	19241	104	applied	\N	\N	\N	\N	122180	122180	289870
15484	19279	1	applied	\N	\N	\N	\N	122259	122259	289948
15541	19376	3	applied	\N	\N	\N	\N	122436	122436	290125
15559	19398	113	applied	\N	\N	\N	\N	122625	122625	290314
15623	19509	2	applied	\N	\N	\N	\N	122806	122806	290494
15684	19619	1	applied	\N	\N	\N	\N	123065	123065	290753
15710	19660	5	applied	\N	\N	\N	\N	123175	123175	290863
15717	19197	122	applied	\N	\N	\N	\N	123319	123319	291007
15766	19817	0	applied	\N	\N	\N	\N	123591	123591	291279
15812	19969	13	applied	\N	\N	\N	\N	123831	123831	291519
15813	19957	1	applied	\N	\N	\N	\N	123833	123833	291521
15817	19985	15	applied	\N	\N	\N	\N	123900	123900	291588
15833	20036	0	applied	\N	\N	\N	\N	124099	124099	291787
15875	20137	1	applied	\N	\N	\N	\N	124345	124345	292033
15875	20138	2	applied	\N	\N	\N	\N	124346	124346	292034
15904	20193	1	applied	\N	\N	\N	\N	124448	124448	292136
15931	20238	0	applied	\N	\N	\N	\N	124565	124565	292253
15968	20310	3	applied	\N	\N	\N	\N	124703	124703	292391
15981	20343	2	applied	\N	\N	\N	\N	124765	124765	292453
15990	20364	2	applied	\N	\N	\N	\N	124798	124798	292486
16018	20446	1	applied	\N	\N	\N	\N	124959	124959	292647
16054	20328	111	applied	\N	\N	\N	\N	125220	125220	292908
16100	20496	24	applied	\N	\N	\N	\N	125477	125477	293165
16125	20704	6	applied	\N	\N	\N	\N	125689	125689	293377
16129	20412	7	applied	\N	\N	\N	\N	125706	125706	293394
16175	20598	77	applied	\N	\N	\N	\N	126004	126004	293692
16210	20857	0	applied	\N	\N	1000000000	\N	126228	126228	293910
16239	20857	1	applied	\N	\N	1000000000	\N	126380	126380	294061
16270	21008	10	applied	\N	\N	\N	\N	126692	126692	294372
16293	20865	56	applied	\N	\N	\N	\N	126830	126830	294506
16295	21049	2	applied	\N	\N	\N	\N	126908	126908	294582
16410	21365	1	applied	\N	\N	\N	\N	127538	127538	295195
16411	21371	5	applied	\N	\N	\N	\N	127545	127545	295202
16423	21390	4	applied	\N	\N	\N	\N	127590	127590	295247
16454	21462	5	applied	\N	\N	1000000000	\N	127756	127756	295402
16498	21577	3	applied	\N	\N	\N	\N	128057	128057	295691
16512	21630	0	applied	\N	\N	\N	\N	128143	128143	295777
16523	21421	8	applied	\N	\N	\N	\N	128191	128191	128191
16564	21715	18	applied	\N	\N	\N	\N	128389	128389	296014
16586	21150	6	applied	\N	\N	1000000000	\N	128613	128613	296224
16586	21392	124	applied	\N	\N	\N	\N	128730	128730	296340
16623	21727	61	applied	\N	\N	\N	\N	128934	128934	296541
16641	21884	1	applied	\N	\N	\N	\N	129166	129166	296773
16687	21582	30	applied	\N	\N	\N	\N	129450	129450	297051
16709	21836	31	applied	\N	\N	\N	\N	129802	129802	297402
16709	21959	69	applied	\N	\N	\N	\N	129839	129839	297439
16709	22020	89	applied	\N	\N	\N	\N	129859	129859	297459
16723	22084	3	applied	\N	\N	\N	\N	130109	130109	297708
16743	21011	99	applied	\N	\N	\N	\N	130298	130298	297890
16748	22123	6	applied	\N	\N	\N	\N	130362	130362	297954
16770	22162	4	applied	\N	\N	\N	\N	130617	130617	298207
16771	22163	5	applied	\N	\N	\N	\N	130625	130625	298215
16784	22167	40	applied	\N	\N	\N	\N	130860	130860	298450
16833	21462	22	applied	\N	\N	1000000000	\N	131110	131110	298691
16833	21014	35	applied	\N	\N	\N	\N	131123	131123	131123
16836	21841	60	applied	\N	\N	\N	\N	131200	131200	298768
16855	22270	68	applied	\N	\N	\N	\N	131333	131333	298901
16868	22231	55	applied	\N	\N	\N	\N	131421	131421	298989
16885	22143	21	applied	\N	\N	\N	\N	131605	131605	299171
16889	22059	53	applied	\N	\N	\N	\N	131772	131772	299336
16889	22287	121	applied	\N	\N	\N	\N	131839	131839	299403
16902	22398	4	applied	\N	\N	\N	\N	131889	131889	299453
16944	22482	0	applied	\N	\N	\N	\N	132091	132091	299655
16985	22528	1	applied	\N	\N	\N	\N	132347	132347	299909
17036	22603	0	applied	\N	\N	\N	\N	132610	132610	300172
17063	22213	0	applied	\N	\N	1000000000	\N	132828	132828	300390
17105	22758	1	applied	\N	\N	\N	\N	133152	133152	300714
17151	22570	1	applied	\N	\N	1000000000	\N	133395	133395	300957
17151	22550	20	applied	\N	\N	\N	\N	133414	133414	300976
17151	22741	80	applied	\N	\N	\N	\N	133474	133474	301036
17157	22830	5	applied	\N	\N	1000000000	\N	133567	133567	301129
17199	22952	5	applied	\N	\N	\N	\N	133887	133887	301449
17248	22757	58	applied	\N	\N	\N	\N	134139	134139	301701
17301	22698	1	applied	\N	\N	\N	\N	134396	134396	301958
17326	23194	2	applied	\N	\N	\N	\N	134498	134498	302060
17331	23210	7	applied	\N	\N	\N	\N	134601	134601	302163
17337	23226	0	applied	\N	\N	\N	\N	134624	134624	302186
17341	23236	1	applied	\N	\N	\N	\N	134637	134637	302199
17388	23289	81	applied	\N	\N	\N	\N	134898	134898	302460
17806	24190	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	138260	138260	\N
17807	24190	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	138265	138265	\N
17866	24120	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	138616	138616	\N
17866	24261	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	138618	138618	\N
20162	29100	17	applied	\N	\N	\N	\N	153707	153707	321018
17896	24261	52	failed	Amount_insufficient_to_create_account	\N	\N	\N	138827	138827	\N
17953	24261	79	failed	Amount_insufficient_to_create_account	\N	\N	\N	139242	139242	\N
17961	24190	8	failed	Amount_insufficient_to_create_account	\N	\N	\N	139379	139379	\N
18135	24190	22	failed	Amount_insufficient_to_create_account	\N	\N	\N	140487	140487	\N
18155	24843	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	140809	140809	\N
18233	24875	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	141337	141337	\N
19820	28164	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	151173	151173	\N
19820	28165	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	151174	151174	\N
17432	23377	76	applied	\N	\N	\N	\N	135222	135222	302784
17443	23435	3	applied	\N	\N	\N	\N	135320	135320	302882
17451	22804	81	applied	\N	\N	\N	\N	135445	135445	303007
17464	23542	11	applied	\N	\N	\N	\N	135703	135703	303265
17476	23573	0	applied	\N	\N	\N	\N	135939	135939	303501
17530	23702	0	applied	\N	\N	\N	\N	136215	136215	303777
17586	23787	3	applied	\N	\N	\N	\N	136472	136472	304034
17596	23578	70	applied	\N	\N	\N	\N	136614	136614	304176
17599	23448	1	applied	\N	\N	1000000000	\N	136693	136693	304255
17609	23830	2	applied	\N	\N	\N	\N	136887	136887	304449
17632	22930	47	applied	\N	\N	\N	\N	137012	137012	304574
17644	23876	0	applied	\N	\N	1000000000	\N	137247	137247	304809
17645	23876	0	applied	\N	\N	1000000000	\N	137254	137254	304816
17651	23229	69	applied	\N	\N	\N	\N	137354	137354	304916
17670	23340	58	applied	\N	\N	\N	\N	137516	137516	305078
17674	23925	9	applied	\N	\N	\N	\N	137607	137607	305169
17718	23993	0	applied	\N	\N	1000000000	\N	137760	137760	305322
17764	24096	0	applied	\N	\N	\N	\N	138083	138083	305640
17889	24343	5	applied	\N	\N	\N	\N	138749	138749	306290
17966	24498	6	applied	\N	\N	\N	\N	139501	139501	307014
17994	24509	54	applied	\N	\N	\N	\N	139692	139692	307203
17997	24586	0	applied	\N	\N	\N	\N	139742	139742	307253
18061	24686	2	applied	\N	\N	\N	\N	139995	139995	307498
18104	24754	0	applied	\N	\N	\N	\N	140256	140256	307758
18126	24709	46	applied	\N	\N	\N	\N	140422	140422	307924
18145	24824	1	applied	\N	\N	\N	\N	140616	140616	308108
18158	24859	2	applied	\N	\N	\N	\N	140846	140846	308331
18172	24904	1	applied	\N	\N	\N	\N	140915	140915	308396
18227	24874	16	applied	\N	\N	\N	\N	141213	141213	308667
18248	25014	0	applied	\N	\N	\N	\N	141461	141461	308899
18285	25076	1	applied	\N	\N	\N	\N	141664	141664	309102
18342	25179	2	applied	\N	\N	\N	\N	141933	141933	309371
18370	25150	61	applied	\N	\N	\N	\N	142217	142217	309642
18381	25090	56	applied	\N	\N	\N	\N	142360	142360	309776
18411	25314	2	applied	\N	\N	\N	\N	142505	142505	309921
18435	25007	75	applied	\N	\N	\N	\N	142770	142770	310181
18469	25403	2	applied	\N	\N	\N	\N	143046	143046	310457
18500	25169	88	applied	\N	\N	\N	\N	143314	143314	310725
18531	25538	0	applied	\N	\N	1000000000	\N	143502	143502	310909
18614	25713	11	applied	\N	\N	\N	\N	143829	143829	311234
18673	25404	14	applied	\N	\N	1000000000	\N	144095	144095	311498
18673	25423	62	applied	\N	\N	\N	\N	144143	144143	311546
18692	25854	2	applied	\N	\N	\N	\N	144345	144345	311748
18711	25843	11	applied	\N	\N	1000000000	\N	144453	144453	311856
18712	25900	9	applied	\N	\N	\N	\N	144478	144478	311881
18752	25983	0	applied	\N	\N	\N	\N	144620	144620	312023
18752	25984	1	applied	\N	\N	\N	\N	144621	144621	312024
18841	26107	0	applied	\N	\N	\N	\N	144859	144859	312260
18852	26122	0	applied	\N	\N	\N	\N	144879	144879	312280
18921	26191	0	applied	\N	\N	\N	\N	145118	145118	312518
19054	26315	1	applied	\N	\N	\N	\N	145384	145384	312784
19090	26366	17	applied	\N	\N	\N	\N	145507	145507	312889
19111	26417	0	applied	\N	\N	\N	\N	145626	145626	313003
19161	26526	1	applied	\N	\N	\N	\N	145888	145888	313265
19168	26549	6	applied	\N	\N	\N	\N	145927	145927	313304
19180	26450	70	applied	\N	\N	\N	\N	146044	146044	313421
19189	26603	0	applied	\N	\N	\N	\N	146139	146139	313512
19215	26674	2	applied	\N	\N	\N	\N	146405	146405	313776
19256	26479	64	applied	\N	\N	\N	\N	146686	146686	314053
19294	26857	2	applied	\N	\N	\N	\N	146924	146924	314291
19322	26637	15	applied	\N	\N	\N	\N	147164	147164	314524
19344	27022	0	applied	\N	\N	\N	\N	147453	147453	314797
19387	27115	7	applied	\N	\N	\N	\N	147687	147687	315024
19389	27123	1	applied	\N	\N	1000000000	\N	147700	147700	315037
19411	27160	5	applied	\N	\N	\N	\N	147901	147901	315228
19461	27293	1	applied	\N	\N	\N	\N	148139	148139	315464
19465	27297	0	applied	\N	\N	\N	\N	148149	148149	315474
19528	27419	3	applied	\N	\N	\N	\N	148414	148414	315739
19554	27469	0	applied	\N	\N	\N	\N	148640	148640	315960
19620	27487	55	applied	\N	\N	\N	\N	149143	149143	316463
19633	27636	57	applied	\N	\N	\N	\N	149359	149359	316679
19647	27648	21	applied	\N	\N	\N	\N	149449	149449	316769
19670	27752	2	applied	\N	\N	\N	\N	149652	149652	316972
19693	27835	7	applied	\N	\N	\N	\N	149900	149900	317220
19694	27732	111	applied	\N	\N	\N	\N	150011	150011	317331
19702	27768	43	applied	\N	\N	\N	\N	150131	150131	317451
19723	27743	9	applied	\N	\N	\N	\N	150427	150427	317747
19742	27959	0	applied	\N	\N	\N	\N	150676	150676	317996
19742	27960	1	applied	\N	\N	\N	\N	150677	150677	317997
19768	27970	53	applied	\N	\N	\N	\N	150909	150909	318229
19768	27975	54	applied	\N	\N	\N	\N	150910	150910	318230
19849	28224	3	applied	\N	\N	1000000000	\N	151296	151296	318614
19872	28284	1	applied	\N	\N	\N	\N	151446	151446	318764
19916	28387	4	applied	\N	\N	\N	\N	151717	151717	319035
19944	28286	107	applied	\N	\N	\N	\N	151929	151929	319247
19965	28502	0	applied	\N	\N	\N	\N	152197	152197	319515
19976	28526	4	applied	\N	\N	\N	\N	152263	152263	319581
19993	28578	1	applied	\N	\N	\N	\N	152352	152352	319670
20000	28574	83	applied	\N	\N	\N	\N	152460	152460	319778
20009	28606	7	applied	\N	\N	\N	\N	152536	152536	319854
20054	28736	0	applied	\N	\N	\N	\N	152722	152722	320040
20055	28706	3	applied	\N	\N	\N	\N	152729	152729	320047
20079	28799	4	applied	\N	\N	\N	\N	152971	152971	320289
20085	28814	0	applied	\N	\N	\N	\N	153009	153009	153009
20543	30113	1	failed	Amount_insufficient_to_create_account	\N	\N	\N	157046	157046	\N
20576	30171	0	failed	Amount_insufficient_to_create_account	\N	\N	\N	157358	157358	\N
20596	30113	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	157562	157562	\N
20608	30113	10	failed	Amount_insufficient_to_create_account	\N	\N	\N	157717	157717	\N
20620	30113	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	157792	157792	\N
20651	30113	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	158171	158171	\N
20716	30113	14	failed	Amount_insufficient_to_create_account	\N	\N	\N	158750	158750	\N
20105	28960	7	applied	\N	\N	\N	\N	153275	153275	320587
20147	28971	9	applied	\N	\N	\N	\N	153525	153525	320837
20147	28993	49	applied	\N	\N	\N	\N	153565	153565	320877
20169	29172	3	applied	\N	\N	\N	\N	153890	153890	321200
20185	28970	26	applied	\N	\N	\N	\N	154128	154128	321437
20206	29266	48	applied	\N	\N	\N	\N	154367	154367	321675
20206	29267	65	applied	\N	\N	\N	\N	154384	154384	321692
20242	29364	0	applied	\N	\N	\N	\N	154619	154619	321927
20278	28328	58	applied	\N	\N	\N	\N	154877	154877	322184
20278	29117	84	applied	\N	\N	\N	\N	154902	154902	322209
20318	29578	3	applied	\N	\N	\N	\N	155128	155128	322434
20339	29638	2	applied	\N	\N	\N	\N	155363	155363	322669
20376	29737	0	applied	\N	\N	\N	\N	155623	155623	322929
20399	29368	112	applied	\N	\N	\N	\N	155896	155896	323202
20437	29878	2	applied	\N	\N	\N	\N	156159	156159	323465
20467	29864	38	applied	\N	\N	\N	\N	156309	156309	323615
20478	29837	75	applied	\N	\N	1000000000	\N	156503	156503	323809
20508	29572	8	applied	\N	\N	\N	\N	156707	156707	324013
20508	29746	59	applied	\N	\N	\N	\N	156757	156757	324063
20508	29923	109	applied	\N	\N	\N	\N	156807	156807	324113
20573	30110	72	applied	\N	\N	1000000000	\N	157324	157324	324627
20579	29951	22	applied	\N	\N	\N	\N	157390	157390	324690
20641	30363	1	applied	\N	\N	\N	\N	158010	158010	325291
20680	30398	10	applied	\N	\N	\N	\N	158427	158427	325700
20694	30454	7	applied	\N	\N	\N	\N	158622	158622	325894
20716	29840	51	applied	\N	\N	\N	\N	158787	158787	326057
20721	30419	94	applied	\N	\N	\N	\N	158915	158915	326185
20738	30532	3	applied	\N	\N	\N	\N	159052	159052	326322
20760	30590	10	applied	\N	\N	\N	\N	159181	159181	326451
20761	30602	8	applied	\N	\N	\N	\N	159239	159239	326509
20780	30641	0	applied	\N	\N	\N	\N	159520	159520	326790
20809	30714	0	applied	\N	\N	\N	\N	159660	159660	326929
20818	30623	79	applied	\N	\N	\N	\N	159758	159758	327026
20818	30663	92	applied	\N	\N	\N	\N	159771	159771	327039
20854	30778	8	applied	\N	\N	\N	\N	159950	159950	327214
20880	30792	47	applied	\N	\N	\N	\N	160292	160292	327550
20912	30748	9	applied	\N	\N	\N	\N	160430	160430	327688
20912	30812	42	applied	\N	\N	\N	\N	160463	160463	327720
20912	30756	85	applied	\N	\N	\N	\N	160505	160505	327761
20951	30984	1	applied	\N	\N	\N	\N	160714	160714	327970
21000	30949	112	applied	\N	\N	\N	\N	161002	161002	328258
21023	31097	1	applied	\N	\N	\N	\N	161216	161216	328470
21065	30880	48	applied	\N	\N	\N	\N	161469	161469	328723
21065	31058	119	applied	\N	\N	\N	\N	161539	161539	328793
21104	31194	0	applied	\N	\N	\N	\N	161660	161660	328914
21169	30870	46	applied	\N	\N	\N	\N	161900	161900	329154
21188	31316	106	applied	\N	\N	\N	\N	162145	162145	329399
21205	30870	59	applied	\N	\N	\N	\N	162389	162389	329643
21263	31444	3	applied	\N	\N	\N	\N	162661	162661	329915
21285	31507	1	applied	\N	\N	\N	\N	162849	162849	330103
21302	31402	13	applied	\N	\N	\N	\N	162934	162934	330188
21302	31125	26	applied	\N	\N	\N	\N	162947	162947	330201
21311	31548	2	applied	\N	\N	\N	\N	163192	163192	330446
21329	31589	0	applied	\N	\N	\N	\N	163278	163278	330532
21337	31600	1	applied	\N	\N	\N	\N	163306	163306	330560
21346	31612	2	applied	\N	\N	\N	\N	163345	163345	330599
21360	31667	8	applied	\N	\N	\N	\N	163440	163440	330694
21362	31681	3	applied	\N	\N	\N	\N	163460	163460	330714
21392	31633	14	applied	\N	\N	\N	\N	163599	163599	330853
21392	31690	89	applied	\N	\N	\N	\N	163674	163674	330928
21392	31677	105	applied	\N	\N	\N	\N	163690	163690	330944
21411	31221	91	applied	\N	\N	\N	\N	163902	163902	331156
21414	31762	0	applied	\N	\N	\N	\N	163939	163939	331193
21438	31829	2	applied	\N	\N	\N	\N	164073	164073	331327
21456	31547	38	applied	\N	\N	\N	\N	164207	164207	331461
21515	30942	5	applied	\N	\N	1000000000	\N	164444	164444	331698
21541	31603	2	applied	\N	\N	\N	\N	164757	164757	332011
21541	31407	61	applied	\N	\N	\N	\N	164816	164816	332070
21546	32042	2	applied	\N	\N	\N	\N	164911	164911	332165
21583	32090	2	applied	\N	\N	\N	\N	165149	165149	332403
21597	32126	2	applied	\N	\N	\N	\N	165337	165337	332591
21618	31960	7	applied	\N	\N	\N	\N	165401	165401	332655
21626	32083	39	applied	\N	\N	\N	\N	165584	165584	332838
21653	31503	39	applied	\N	\N	\N	\N	165817	165817	333071
21653	31662	99	applied	\N	\N	\N	\N	165876	165876	333130
21669	32238	0	applied	\N	\N	\N	\N	166086	166086	333340
21677	32254	0	applied	\N	\N	\N	\N	166113	166113	333367
21692	32286	11	applied	\N	\N	\N	\N	166323	166323	333577
21706	32320	0	applied	\N	\N	1000000000	\N	166379	166379	333633
21717	32354	10	applied	\N	\N	\N	\N	166441	166441	333695
21733	32318	77	applied	\N	\N	\N	\N	166548	166548	333802
21737	32065	36	applied	\N	\N	\N	\N	166660	166660	333914
21757	32405	0	applied	\N	\N	\N	\N	166919	166919	334173
21775	32435	0	applied	\N	\N	\N	\N	166985	166985	334239
21776	32409	43	applied	\N	\N	\N	\N	167036	167036	334290
21795	32321	57	applied	\N	\N	\N	\N	167255	167255	334509
21796	32440	107	applied	\N	\N	\N	\N	167430	167430	334684
21812	32507	1	applied	\N	\N	\N	\N	167523	167523	334777
21836	32488	59	applied	\N	\N	\N	\N	167703	167703	334957
21836	32324	109	applied	\N	\N	\N	\N	167753	167753	335007
21870	32197	10	applied	\N	\N	\N	\N	168036	168036	335290
21884	32664	0	applied	\N	\N	\N	\N	168244	168244	335498
21927	32763	2	applied	\N	\N	\N	\N	168534	168534	335788
21981	32168	39	applied	\N	\N	\N	\N	168780	168780	336032
21999	32508	69	applied	\N	\N	\N	\N	168993	168993	336244
22036	32356	79	applied	\N	\N	\N	\N	169257	169257	336508
22082	33005	10	applied	\N	\N	\N	\N	169513	169513	336763
22082	33006	30	applied	\N	\N	\N	\N	169533	169533	336783
22103	33115	8	applied	\N	\N	\N	\N	169676	169676	336926
22112	33089	52	applied	\N	\N	\N	\N	169766	169766	337014
22152	33262	5	applied	\N	\N	\N	\N	169976	169976	337219
23657	36376	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	181068	181068	\N
23733	36376	113	failed	Amount_insufficient_to_create_account	\N	\N	\N	181533	181533	\N
22184	32925	14	applied	\N	\N	\N	\N	170165	170165	337407
22199	33384	63	applied	\N	\N	\N	\N	170399	170399	170399
22208	33046	29	applied	\N	\N	\N	\N	170524	170524	337761
22208	33114	48	applied	\N	\N	\N	\N	170543	170543	337780
22212	33438	1	applied	\N	\N	\N	\N	170583	170583	337820
22231	33452	63	applied	\N	\N	\N	\N	170718	170718	337955
22251	33519	1	applied	\N	\N	\N	\N	170835	170835	338072
22285	33611	1	applied	\N	\N	\N	\N	171100	171100	338336
22309	33583	37	applied	\N	\N	\N	\N	171366	171366	338600
22338	33756	1	applied	\N	\N	\N	\N	171607	171607	338841
22377	33850	2	applied	\N	\N	\N	\N	171861	171861	339095
22418	33914	9	applied	\N	\N	\N	\N	172127	172127	339361
22440	33893	6	applied	\N	\N	\N	\N	172358	172358	339592
22440	33923	58	applied	\N	\N	\N	\N	172409	172409	339643
22467	33952	99	applied	\N	\N	\N	\N	172633	172633	339867
22499	34135	9	applied	\N	\N	\N	\N	172900	172900	340134
22515	34209	2	applied	\N	\N	\N	\N	173042	173042	340276
22578	34413	4	applied	\N	\N	\N	\N	173417	173417	340651
22581	34051	105	applied	\N	\N	\N	\N	173537	173537	340771
22598	34491	13	applied	\N	\N	\N	\N	173669	173669	340899
22652	34576	1	applied	\N	\N	\N	\N	173919	173919	341149
22709	34705	0	applied	\N	\N	\N	\N	174160	174160	341390
22737	34758	5	applied	\N	\N	\N	\N	174263	174263	341493
22768	34841	3	applied	\N	\N	\N	\N	174518	174518	341747
22828	34997	0	applied	\N	\N	\N	\N	174821	174821	342047
22855	35042	4	applied	\N	\N	\N	\N	174904	174904	342130
22890	35060	1	applied	\N	\N	\N	\N	175051	175051	342277
22929	35144	7	applied	\N	\N	\N	\N	175305	175305	342531
22946	35217	2	applied	\N	\N	\N	\N	175538	175538	342764
22950	34628	10	applied	\N	\N	\N	\N	175558	175558	342784
22960	35252	1	applied	\N	\N	\N	\N	175814	175814	343040
22980	35148	64	applied	\N	\N	\N	\N	175934	175934	343160
23020	35251	7	applied	\N	\N	\N	\N	176204	176204	343430
23107	35574	1	applied	\N	\N	\N	\N	176697	176697	343923
23136	35628	21	applied	\N	\N	\N	\N	176963	176963	344189
23151	35664	110	applied	\N	\N	\N	\N	177205	177205	344431
23174	35434	117	applied	\N	\N	\N	\N	177451	177451	344677
23184	35258	92	applied	\N	\N	\N	\N	177733	177733	344959
23184	35305	109	applied	\N	\N	\N	\N	177750	177750	344976
23218	35760	0	applied	\N	\N	\N	\N	177977	177977	345203
23246	35787	0	applied	\N	\N	\N	\N	178233	178233	345459
23284	35658	78	applied	\N	\N	\N	\N	178405	178405	345631
23290	35737	28	applied	\N	\N	\N	\N	178484	178484	345710
23302	35381	9	applied	\N	\N	\N	\N	178622	178622	345848
23302	35676	98	applied	\N	\N	\N	\N	178710	178710	345936
23332	35623	45	applied	\N	\N	\N	\N	178957	178957	346183
23332	35682	62	applied	\N	\N	\N	\N	178974	178974	346200
23376	35958	1	applied	\N	\N	\N	\N	179215	179215	346441
23410	35795	54	applied	\N	\N	\N	\N	179491	179491	346717
23421	36000	8	applied	\N	\N	\N	\N	179627	179627	346853
23462	35701	75	applied	\N	\N	\N	\N	179917	179917	347143
23520	36152	2	applied	\N	\N	\N	\N	180177	180177	347403
23555	36250	5	applied	\N	\N	\N	\N	180421	180421	347647
23609	36344	0	applied	\N	\N	\N	\N	180695	180695	347918
23631	36408	1	applied	\N	\N	\N	\N	180941	180941	348159
23699	36555	7	applied	\N	\N	1000000000	\N	181272	181272	348489
23757	36648	75	applied	\N	\N	\N	\N	181771	181771	348982
23759	36409	91	applied	\N	\N	\N	\N	181915	181915	349126
23759	36416	93	applied	\N	\N	\N	\N	181917	181917	349128
23762	36493	82	applied	\N	\N	\N	\N	182044	182044	349254
23790	36763	0	applied	\N	\N	\N	\N	182191	182191	349401
23821	36825	0	applied	\N	\N	\N	\N	182321	182321	349531
23821	36826	1	applied	\N	\N	\N	\N	182322	182322	349532
23822	36826	1	applied	\N	\N	\N	\N	182324	182324	349534
23822	36827	2	applied	\N	\N	\N	\N	182325	182325	349535
23823	36829	1	applied	\N	\N	\N	\N	182327	182327	349537
23823	36830	2	applied	\N	\N	\N	\N	182328	182328	349538
23823	36831	3	applied	\N	\N	\N	\N	182329	182329	349539
23823	36832	4	applied	\N	\N	\N	\N	182330	182330	349540
23824	36829	1	applied	\N	\N	\N	\N	182332	182332	349542
23824	36830	2	applied	\N	\N	\N	\N	182333	182333	349543
23824	36831	3	applied	\N	\N	\N	\N	182334	182334	349544
23824	36832	4	applied	\N	\N	\N	\N	182335	182335	349545
23824	36827	5	applied	\N	\N	\N	\N	182336	182336	349546
23824	36833	6	applied	\N	\N	\N	\N	182337	182337	349547
23824	36834	7	applied	\N	\N	\N	\N	182338	182338	349548
23826	36835	0	applied	\N	\N	\N	\N	182347	182347	349557
23826	36836	1	applied	\N	\N	\N	\N	182348	182348	349558
23826	36837	2	applied	\N	\N	\N	\N	182349	182349	349559
23827	36838	0	applied	\N	\N	\N	\N	182350	182350	349560
23829	36841	0	applied	\N	\N	\N	\N	182354	182354	349564
23829	36844	3	applied	\N	\N	\N	\N	182357	182357	349567
23829	36845	4	applied	\N	\N	\N	\N	182358	182358	349568
23829	36846	5	applied	\N	\N	\N	\N	182359	182359	349569
23829	36847	6	applied	\N	\N	\N	\N	182360	182360	349570
23830	36842	1	applied	\N	\N	\N	\N	182362	182362	349572
23830	36843	2	applied	\N	\N	\N	\N	182363	182363	349573
23830	36844	3	applied	\N	\N	\N	\N	182364	182364	349574
23830	36845	4	applied	\N	\N	\N	\N	182365	182365	349575
23830	36846	5	applied	\N	\N	\N	\N	182366	182366	349576
23830	36847	6	applied	\N	\N	\N	\N	182367	182367	349577
23831	36841	0	applied	\N	\N	\N	\N	182368	182368	349578
23831	36842	1	applied	\N	\N	\N	\N	182369	182369	349579
23831	36843	2	applied	\N	\N	\N	\N	182370	182370	349580
23831	36844	3	applied	\N	\N	\N	\N	182371	182371	349581
23831	36845	4	applied	\N	\N	\N	\N	182372	182372	349582
23831	36846	5	applied	\N	\N	\N	\N	182373	182373	349583
23832	36841	0	applied	\N	\N	\N	\N	182375	182375	349585
23832	36842	1	applied	\N	\N	\N	\N	182376	182376	349586
23832	36843	2	applied	\N	\N	\N	\N	182377	182377	349587
23832	36844	3	applied	\N	\N	\N	\N	182378	182378	349588
23832	36845	4	applied	\N	\N	\N	\N	182379	182379	349589
23832	36846	5	applied	\N	\N	\N	\N	182380	182380	349590
23832	36847	6	applied	\N	\N	\N	\N	182381	182381	349591
23833	36841	0	applied	\N	\N	\N	\N	182382	182382	349592
23833	36842	1	applied	\N	\N	\N	\N	182383	182383	349593
23833	36843	2	applied	\N	\N	\N	\N	182384	182384	349594
23833	36844	3	applied	\N	\N	\N	\N	182385	182385	349595
23833	36845	4	applied	\N	\N	\N	\N	182386	182386	349596
24323	37829	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	185387	185387	\N
24997	39255	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	189968	189968	\N
25005	39272	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	190012	190012	\N
25006	39272	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	190019	190019	\N
26468	41885	99	failed	Amount_insufficient_to_create_account	\N	\N	\N	199036	199036	\N
23833	36847	6	applied	\N	\N	\N	\N	182388	182388	349598
23834	36848	0	applied	\N	\N	\N	\N	182389	182389	349599
23834	36849	1	applied	\N	\N	\N	\N	182390	182390	349600
23834	36851	3	applied	\N	\N	\N	\N	182392	182392	349602
23835	36848	0	applied	\N	\N	\N	\N	182393	182393	349603
23835	36849	1	applied	\N	\N	\N	\N	182394	182394	349604
23835	36850	2	applied	\N	\N	\N	\N	182395	182395	349605
23835	36852	3	applied	\N	\N	\N	\N	182396	182396	349606
23835	36851	4	applied	\N	\N	\N	\N	182397	182397	349607
23835	36853	5	applied	\N	\N	\N	\N	182398	182398	349608
23836	36848	0	applied	\N	\N	\N	\N	182399	182399	349609
23836	36849	1	applied	\N	\N	\N	\N	182400	182400	349610
23836	36850	2	applied	\N	\N	\N	\N	182401	182401	349611
23836	36852	3	applied	\N	\N	\N	\N	182402	182402	349612
23836	36851	4	applied	\N	\N	\N	\N	182403	182403	349613
23836	36853	5	applied	\N	\N	\N	\N	182404	182404	349614
23837	36852	0	applied	\N	\N	\N	\N	182405	182405	349615
23868	36927	4	applied	\N	\N	\N	\N	182779	182779	349987
23900	37013	1	applied	\N	\N	\N	\N	183051	183051	350258
23952	37105	0	applied	\N	\N	\N	\N	183365	183365	350572
23952	37111	2	applied	\N	\N	\N	\N	183367	183367	350574
23970	37169	7	applied	\N	\N	\N	\N	183584	183584	350791
23993	37078	117	applied	\N	\N	\N	\N	183810	183810	351017
24063	37144	65	applied	\N	\N	\N	\N	184120	184120	351327
24119	37430	3	applied	\N	\N	\N	\N	184335	184335	351542
24153	37488	0	applied	\N	\N	\N	\N	184593	184593	351800
24198	37573	0	applied	\N	\N	\N	\N	184767	184767	351974
24219	37609	1	applied	\N	\N	\N	\N	184882	184882	352089
24249	37659	12	applied	\N	\N	\N	\N	185016	185016	352223
24307	37768	4	applied	\N	\N	\N	\N	185280	185280	352487
24349	37889	3	applied	\N	\N	\N	\N	185520	185520	352724
24402	37965	0	applied	\N	\N	\N	\N	185763	185763	352967
24437	38027	5	applied	\N	\N	\N	\N	186040	186040	353243
24472	38088	2	applied	\N	\N	\N	\N	186162	186162	353365
24502	37560	37	applied	\N	\N	\N	\N	186280	186280	353483
24525	38024	112	applied	\N	\N	\N	\N	186691	186691	353893
24527	38050	11	applied	\N	\N	\N	\N	186718	186718	353920
24557	38020	62	applied	\N	\N	\N	\N	186944	186944	354146
24614	38306	1	applied	\N	\N	\N	\N	187219	187219	354421
24643	38052	81	applied	\N	\N	\N	\N	187450	187450	354648
24699	38480	3	applied	\N	\N	\N	\N	187750	187750	354948
24720	38580	7	applied	\N	\N	\N	\N	187978	187978	355176
24723	38616	43	applied	\N	\N	\N	\N	188030	188030	355228
24742	38675	3	applied	\N	\N	\N	\N	188239	188239	355437
24781	38501	29	applied	\N	\N	\N	\N	188475	188475	355672
24805	38868	3	applied	\N	\N	\N	\N	188612	188612	355809
24807	38866	1	applied	\N	\N	\N	\N	188618	188618	355815
24815	38723	98	applied	\N	\N	\N	\N	188854	188854	356051
24860	38998	3	applied	\N	\N	\N	\N	189116	189116	356310
24927	39128	1	applied	\N	\N	\N	\N	189384	189384	356573
24948	39160	2	applied	\N	\N	\N	\N	189597	189597	356785
24988	39110	87	applied	\N	\N	\N	\N	189867	189867	357055
25029	39312	3	applied	\N	\N	\N	\N	190091	190091	357274
25071	39400	0	applied	\N	\N	\N	\N	190249	190249	357430
25117	39492	2	applied	\N	\N	\N	\N	190508	190508	357689
25137	39523	0	applied	\N	\N	\N	\N	190719	190719	357900
25149	39546	3	applied	\N	\N	\N	\N	190760	190760	357941
25150	39522	18	applied	\N	\N	\N	\N	190780	190780	357961
25150	39545	40	applied	\N	\N	\N	\N	190802	190802	357983
25200	39457	53	applied	\N	\N	\N	\N	191112	191112	358293
25243	39605	11	applied	\N	\N	\N	\N	191369	191369	358549
25270	39806	2	applied	\N	\N	\N	\N	191645	191645	358824
25271	39736	9	applied	\N	\N	\N	\N	191659	191659	358838
25291	39798	21	applied	\N	\N	\N	\N	191861	191861	359040
25328	39918	0	applied	\N	\N	1000000000	\N	192112	192112	359290
25404	40035	5	applied	\N	\N	\N	\N	192431	192431	359609
25464	40137	1	applied	\N	\N	\N	\N	192661	192661	359839
25558	40293	5	applied	\N	\N	\N	\N	193166	193166	360344
25621	40414	5	applied	\N	\N	\N	\N	193431	193431	360609
25625	40420	7	applied	\N	\N	\N	\N	193457	193457	360635
25626	40419	6	applied	\N	\N	\N	\N	193466	193466	360644
25643	40304	77	applied	\N	\N	\N	\N	193634	193634	360812
25692	40580	4	applied	\N	\N	\N	\N	193895	193895	361073
25727	40648	1	applied	\N	\N	\N	\N	194044	194044	361222
25759	40696	1	applied	\N	\N	\N	\N	194171	194171	361342
25815	40798	5	applied	\N	\N	\N	\N	194402	194402	361572
25822	40807	0	applied	\N	\N	\N	\N	194442	194442	361612
25865	40808	34	applied	\N	\N	\N	\N	194669	194669	361837
25917	40971	1	applied	\N	\N	\N	\N	194942	194942	362109
25925	40980	4	applied	\N	\N	\N	\N	194961	194961	362128
25994	41089	3	applied	\N	\N	\N	\N	195185	195185	362352
26014	40617	91	applied	\N	\N	\N	\N	195348	195348	362514
26014	40671	109	applied	\N	\N	\N	\N	195366	195366	362532
26052	41188	1	applied	\N	\N	\N	\N	195607	195607	362773
26096	41203	18	applied	\N	\N	\N	\N	195859	195859	363025
26136	41346	0	applied	\N	\N	\N	\N	196117	196117	363282
26157	41380	2	applied	\N	\N	1000000000	\N	196223	196223	363388
26185	41380	22	applied	\N	\N	1000000000	\N	196375	196375	363540
26190	41310	122	applied	\N	\N	\N	\N	196572	196572	363737
26193	41274	51	applied	\N	\N	\N	\N	196643	196643	363808
26225	41548	74	applied	\N	\N	\N	\N	196927	196927	364092
26225	41554	75	applied	\N	\N	\N	\N	196928	196928	364093
26238	41602	1	applied	\N	\N	\N	\N	197070	197070	364235
26263	41675	3	applied	\N	\N	\N	\N	197171	197171	364336
26295	41754	3	applied	\N	\N	\N	\N	197425	197425	364590
26302	41770	1	applied	\N	\N	\N	\N	197464	197464	364629
26356	41848	5	applied	\N	\N	\N	\N	197686	197686	364851
26390	41935	4	applied	\N	\N	\N	\N	197955	197955	365120
26409	41666	30	applied	\N	\N	\N	\N	198198	198198	365363
26409	41803	81	applied	\N	\N	\N	\N	198249	198249	365414
26424	41932	58	applied	\N	\N	\N	\N	198423	198423	365588
26459	41963	39	applied	\N	\N	\N	\N	198717	198717	365882
26467	42093	33	applied	\N	\N	\N	\N	198852	198852	366017
26468	41881	110	applied	\N	\N	1000000000	\N	199047	199047	366211
26540	42284	4	failed	Amount_insufficient_to_create_account	\N	\N	\N	199609	199609	\N
26970	43244	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	202950	202950	\N
27027	43274	77	failed	Amount_insufficient_to_create_account	\N	\N	\N	203348	203348	\N
27866	45287	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	209164	209164	\N
28230	46047	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	211433	211433	\N
28230	46049	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	211435	211435	\N
28250	45287	5	failed	Amount_insufficient_to_create_account	\N	\N	\N	211499	211499	\N
28268	46047	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	211595	211595	\N
28377	46047	6	failed	Amount_insufficient_to_create_account	\N	\N	\N	212015	212015	\N
28508	46049	17	failed	Amount_insufficient_to_create_account	\N	\N	\N	212528	212528	\N
29098	47043	3	failed	Amount_insufficient_to_create_account	\N	\N	\N	215493	215493	\N
26617	42470	6	applied	\N	\N	\N	\N	200110	200110	367271
26651	42500	42	applied	\N	\N	\N	\N	200373	200373	367534
26651	42120	92	applied	\N	\N	\N	\N	200423	200423	367584
26670	42582	7	applied	\N	\N	\N	\N	200552	200552	367713
26687	42618	0	applied	\N	\N	\N	\N	200630	200630	367791
26706	42207	83	applied	\N	\N	\N	\N	200807	200807	367968
26770	42825	6	applied	\N	\N	\N	\N	201309	201309	368467
26776	42357	75	applied	\N	\N	\N	\N	201560	201560	368718
26821	42370	7	applied	\N	\N	\N	\N	201817	201817	368975
26856	42994	82	applied	\N	\N	\N	\N	202094	202094	369252
26880	43086	1	applied	\N	\N	\N	\N	202351	202351	369509
26882	42988	64	applied	\N	\N	\N	\N	202420	202420	369578
26896	43119	2	applied	\N	\N	\N	\N	202536	202536	369694
26935	43220	1	applied	\N	\N	\N	\N	202792	202792	369950
26996	43351	2	applied	\N	\N	\N	\N	203162	203162	370315
27080	43303	4	applied	\N	\N	\N	\N	203828	203828	370975
27110	43414	99	applied	\N	\N	1000000000	\N	204078	204078	371224
27132	43619	2	applied	\N	\N	\N	\N	204187	204187	371333
27150	42752	67	applied	\N	\N	\N	\N	204312	204312	371458
27150	42867	101	applied	\N	\N	\N	\N	204346	204346	371492
27180	43008	19	applied	\N	\N	\N	\N	204522	204522	371667
27195	43654	101	applied	\N	\N	\N	\N	204779	204779	371924
27215	43803	19	applied	\N	\N	\N	\N	204999	204999	372144
27216	43779	48	applied	\N	\N	\N	\N	205048	205048	372193
27251	43757	91	applied	\N	\N	1000000000	\N	205285	205285	372430
27284	43858	94	applied	\N	\N	\N	\N	205602	205602	372747
27302	43937	5	applied	\N	\N	\N	\N	205686	205686	372831
27352	44038	0	applied	\N	\N	\N	\N	205853	205853	372998
27360	44069	7	applied	\N	\N	\N	\N	205929	205929	373074
27360	44072	10	applied	\N	\N	\N	\N	205932	205932	373077
27408	44200	2	applied	\N	\N	\N	\N	206206	206206	373351
27460	44302	8	applied	\N	\N	\N	\N	206472	206472	373617
27484	44438	21	applied	\N	\N	\N	\N	206727	206727	373872
27516	44557	0	applied	\N	\N	\N	\N	206972	206972	374117
27543	44622	3	applied	\N	\N	\N	\N	207247	207247	374392
27594	44720	2	applied	\N	\N	\N	\N	207470	207470	374615
27612	44771	1	applied	\N	\N	\N	\N	207756	207756	374894
27644	44838	10	applied	\N	\N	\N	\N	207921	207921	375059
27705	44958	6	applied	\N	\N	\N	\N	208459	208459	375593
27720	44916	122	applied	\N	\N	\N	\N	208630	208630	375762
27746	45023	0	applied	\N	\N	\N	\N	208707	208707	375839
27781	45080	2	applied	\N	\N	\N	\N	208807	208807	375939
27821	45178	2	applied	\N	\N	\N	\N	208974	208974	376106
27826	45183	1	applied	\N	\N	\N	\N	208988	208988	376120
27860	45270	1	applied	\N	\N	\N	\N	209144	209144	376276
27871	45286	52	applied	\N	\N	\N	\N	209232	209232	376363
27929	45454	1	applied	\N	\N	\N	\N	209578	209578	376705
27962	45541	6	applied	\N	\N	\N	\N	209740	209740	376867
27986	45598	3	applied	\N	\N	\N	\N	210007	210007	377134
28034	45685	7	applied	\N	\N	\N	\N	210274	210274	377401
28036	44747	21	applied	\N	\N	\N	\N	210306	210306	377432
28069	45747	1	applied	\N	\N	\N	\N	210516	210516	377641
28083	45789	7	applied	\N	\N	\N	\N	210772	210772	377897
28106	45833	4	applied	\N	\N	\N	\N	211010	211010	378135
28201	46006	0	applied	\N	\N	\N	\N	211365	211365	378490
28343	46215	4	applied	\N	\N	\N	\N	211904	211904	379001
28508	46443	20	applied	\N	\N	\N	\N	212531	212531	379612
28573	46531	70	applied	\N	\N	\N	\N	212899	212899	379980
28573	46511	86	applied	\N	\N	\N	\N	212915	212915	379996
28604	46615	2	applied	\N	\N	\N	\N	213072	213072	380153
28607	46599	3	applied	\N	\N	\N	\N	213084	213084	380165
28643	46675	3	applied	\N	\N	\N	\N	213312	213312	380393
28672	46685	46	applied	\N	\N	\N	\N	213514	213514	380595
28676	46723	0	applied	\N	\N	\N	\N	213598	213598	380679
28741	46378	40	applied	\N	\N	\N	\N	213811	213811	380892
28747	46797	0	applied	\N	\N	\N	\N	213904	213904	380985
28793	46903	4	applied	\N	\N	\N	\N	214082	214082	381163
28856	47025	6	applied	\N	\N	\N	\N	214340	214340	381421
28905	47078	25	applied	\N	\N	\N	\N	214639	214639	381718
28966	47233	1	applied	\N	\N	\N	\N	214899	214899	381978
28967	47235	4	applied	\N	\N	\N	\N	214907	214907	381986
29009	47312	1	applied	\N	\N	\N	\N	215121	215121	382194
29105	47467	105	applied	\N	\N	\N	\N	215635	215635	382703
29126	47098	17	applied	\N	\N	\N	\N	215892	215892	382957
29144	47601	0	applied	\N	\N	\N	\N	216157	216157	383220
29172	47648	7	applied	\N	\N	\N	\N	216426	216426	383487
29203	47693	4	applied	\N	\N	\N	\N	216611	216611	383670
29204	47696	8	applied	\N	\N	\N	\N	216620	216620	383679
29208	47634	115	applied	\N	\N	\N	\N	216753	216753	383812
29214	47707	0	applied	\N	\N	\N	\N	216778	216778	383837
29274	47329	14	applied	\N	\N	\N	\N	217067	217067	384124
29288	47857	2	applied	\N	\N	\N	\N	217331	217331	384388
29331	47847	91	applied	\N	\N	1000000000	\N	217563	217563	384620
29361	48001	1	applied	\N	\N	\N	\N	217712	217712	384769
29391	47870	10	applied	\N	\N	\N	\N	217856	217856	384913
29422	48146	0	applied	\N	\N	1000000000	\N	218132	218132	385189
29427	48162	2	applied	\N	\N	\N	\N	218156	218156	385213
29479	48291	0	applied	\N	\N	\N	\N	218429	218429	218429
29491	48328	1	applied	\N	\N	\N	\N	218519	218519	385567
29511	48381	5	applied	\N	\N	\N	\N	218595	218595	385640
29525	48411	4	applied	\N	\N	\N	\N	218664	218664	385708
29529	47575	54	applied	\N	\N	\N	\N	218730	218730	385771
29555	48227	0	applied	\N	\N	\N	\N	218890	218890	385930
29555	47976	102	applied	\N	\N	\N	\N	218991	218991	386028
29555	48032	121	applied	\N	\N	\N	\N	219010	219010	386047
29588	48538	2	applied	\N	\N	\N	\N	219254	219254	386289
30198	51807	2	failed	Amount_insufficient_to_create_account	\N	\N	\N	227923	227923	\N
30267	51807	110	failed	Amount_insufficient_to_create_account	\N	\N	\N	229165	229165	\N
418	372	0	applied	\N	\N	1000000000	\N	62046	62046	230226
2107	1686	66	applied	\N	\N	\N	\N	66029	66029	234194
2804	2181	79	applied	\N	\N	\N	\N	68589	68589	236754
3286	2732	0	applied	\N	\N	1000000000	\N	70237	70237	238402
3286	2733	1	applied	\N	\N	\N	\N	70238	70238	238403
3286	2734	2	applied	\N	\N	\N	\N	70239	70239	238404
3286	2735	3	applied	\N	\N	\N	\N	70240	70240	238405
3286	2736	4	applied	\N	\N	\N	\N	70241	70241	238406
3286	2737	5	applied	\N	\N	\N	\N	70242	70242	238407
3287	2733	1	applied	\N	\N	\N	\N	70246	70246	238411
3287	2734	2	applied	\N	\N	\N	\N	70247	70247	238412
3287	2735	3	applied	\N	\N	\N	\N	70248	70248	238413
3287	2736	4	applied	\N	\N	\N	\N	70249	70249	238414
3287	2737	5	applied	\N	\N	\N	\N	70250	70250	238415
3287	2738	6	applied	\N	\N	\N	\N	70251	70251	238416
3287	2739	7	applied	\N	\N	\N	\N	70252	70252	238417
3288	2732	0	applied	\N	\N	1000000000	\N	70253	70253	238418
3288	2733	1	applied	\N	\N	\N	\N	70254	70254	238419
3288	2734	2	applied	\N	\N	\N	\N	70255	70255	238420
3288	2735	3	applied	\N	\N	\N	\N	70256	70256	238421
3288	2736	4	applied	\N	\N	\N	\N	70257	70257	238422
3288	2737	5	applied	\N	\N	\N	\N	70258	70258	238423
3288	2738	6	applied	\N	\N	\N	\N	70259	70259	238424
3288	2739	7	applied	\N	\N	\N	\N	70260	70260	238425
3291	2732	0	applied	\N	\N	1000000000	\N	70261	70261	238426
3291	2733	1	applied	\N	\N	\N	\N	70262	70262	238427
3291	2734	2	applied	\N	\N	\N	\N	70263	70263	238428
3291	2735	3	applied	\N	\N	\N	\N	70264	70264	238429
3291	2736	4	applied	\N	\N	\N	\N	70265	70265	238430
3291	2737	5	applied	\N	\N	\N	\N	70266	70266	238431
3291	2738	6	applied	\N	\N	\N	\N	70267	70267	238432
3291	2740	7	applied	\N	\N	\N	\N	70268	70268	238433
3291	2741	8	applied	\N	\N	\N	\N	70269	70269	238434
3291	2742	9	applied	\N	\N	\N	\N	70270	70270	238435
3291	2743	10	applied	\N	\N	\N	\N	70271	70271	238436
3291	2739	11	applied	\N	\N	\N	\N	70272	70272	238437
3293	2741	1	applied	\N	\N	\N	\N	70275	70275	238440
3293	2742	2	applied	\N	\N	\N	\N	70276	70276	238441
3293	2743	3	applied	\N	\N	\N	\N	70277	70277	238442
3293	2744	4	applied	\N	\N	\N	\N	70278	70278	238443
3297	2745	0	applied	\N	\N	\N	\N	70280	70280	238445
3297	2746	1	applied	\N	\N	\N	\N	70281	70281	238446
3298	2746	0	applied	\N	\N	\N	\N	70282	70282	238447
3347	2848	7	applied	\N	\N	\N	\N	70464	70464	238629
3927	2938	59	applied	\N	\N	1000000000	\N	72191	72191	240352
4415	3629	1	applied	\N	\N	\N	\N	73977	73977	242128
4594	3802	0	applied	\N	\N	\N	\N	74850	74850	242982
4674	3739	48	applied	\N	\N	\N	\N	75122	75122	243254
6221	4816	0	applied	\N	\N	1000000000	\N	78216	78216	246327
7260	6008	27	applied	\N	\N	1000000000	\N	82165	82165	250096
8682	7328	85	applied	\N	\N	\N	\N	86525	86525	254426
9379	8559	4	applied	\N	\N	\N	\N	89416	89416	257292
10014	9737	4	applied	\N	\N	\N	\N	92559	92559	260372
10087	9958	12	applied	\N	\N	\N	\N	93094	93094	260907
29649	48701	6	applied	\N	\N	\N	\N	219774	219774	386806
29661	48832	3	applied	\N	\N	\N	\N	219938	219938	386967
29666	48882	9	applied	\N	\N	\N	\N	220003	220003	387032
29683	48991	10	applied	\N	\N	\N	\N	220242	220242	387270
29689	49017	2	applied	\N	\N	\N	\N	220304	220304	387332
29709	49085	23	applied	\N	\N	\N	\N	220436	220436	387462
29714	48462	10	applied	\N	\N	\N	\N	220565	220565	387582
29714	48974	116	applied	\N	\N	\N	\N	220670	220670	387687
29719	49138	0	applied	\N	\N	\N	\N	220761	220761	387778
29725	49153	5	applied	\N	\N	\N	\N	220945	220945	387958
29747	49280	3	applied	\N	\N	\N	\N	221192	221192	388205
29766	49398	6	applied	\N	\N	\N	\N	221447	221447	388460
29779	49511	3	applied	\N	\N	\N	\N	221719	221719	388732
29789	49565	12	applied	\N	\N	\N	\N	221968	221968	388981
29797	49607	0	applied	\N	\N	\N	\N	222056	222056	389069
29797	49644	37	applied	\N	\N	\N	\N	222093	222093	389106
29823	49804	7	applied	\N	\N	\N	\N	222577	222577	389590
29848	49984	23	applied	\N	\N	\N	\N	222864	222864	389877
29870	50141	13	applied	\N	\N	\N	\N	223119	223119	390132
29881	50194	7	applied	\N	\N	\N	\N	223369	223369	390380
29903	50283	8	applied	\N	\N	\N	\N	223618	223618	390623
29921	50344	1	applied	\N	\N	\N	\N	223829	223829	390827
29933	50395	6	applied	\N	\N	\N	\N	224063	224063	391058
29961	50511	0	applied	\N	\N	\N	\N	224318	224318	391313
29980	50617	5	applied	\N	\N	\N	\N	224550	224550	391545
29989	50656	15	applied	\N	\N	\N	\N	224800	224800	391795
29991	50665	10	applied	\N	\N	\N	\N	224828	224828	391823
30004	50734	0	applied	\N	\N	\N	\N	225065	225065	392060
30025	50874	5	applied	\N	\N	\N	\N	225339	225339	392334
30040	50969	17	applied	\N	\N	\N	\N	225510	225510	392505
30043	50992	18	applied	\N	\N	\N	\N	225576	225576	392569
30046	51006	11	applied	\N	\N	\N	\N	225631	225631	392623
30063	51138	8	applied	\N	\N	\N	\N	225888	225888	392880
30071	51174	5	applied	\N	\N	\N	\N	225958	225958	392949
30074	51207	10	applied	\N	\N	\N	\N	225993	225993	392984
30099	50954	28	applied	\N	\N	\N	\N	226277	226277	393268
30104	51334	6	applied	\N	\N	\N	\N	226405	226405	393395
30110	51365	0	applied	\N	\N	1000000000	\N	226525	226525	393515
30113	51355	30	applied	\N	\N	\N	\N	226688	226688	393678
30118	51386	1	applied	\N	\N	\N	\N	226808	226808	393797
30137	51520	4	applied	\N	\N	1000000000	\N	227070	227070	394054
30162	51642	3	applied	\N	\N	\N	\N	227351	227351	394335
30164	51674	24	applied	\N	\N	\N	\N	227422	227422	394406
30168	51694	4	applied	\N	\N	\N	\N	227528	227528	394512
30187	51773	5	applied	\N	\N	\N	\N	227773	227773	394747
30194	51805	4	applied	\N	\N	\N	\N	227875	227875	394848
30219	51906	3	applied	\N	\N	\N	\N	228343	228343	395312
30220	51904	1	applied	\N	\N	\N	\N	228351	228351	395320
30238	51991	9	applied	\N	\N	\N	\N	228627	228627	395596
30255	52099	2	applied	\N	\N	\N	\N	228802	228802	395771
30258	52149	34	applied	\N	\N	\N	\N	228888	228888	395857
30261	52136	21	applied	\N	\N	\N	\N	228959	228959	395928
30261	52163	44	applied	\N	\N	\N	\N	228982	228982	395951
30267	52051	86	applied	\N	\N	\N	\N	229141	229141	396110
30267	51398	103	applied	\N	\N	\N	\N	229158	229158	396127
30273	52277	12	applied	\N	\N	\N	\N	229262	229262	396229
30278	52337	3	applied	\N	\N	1000000000	\N	229361	229361	396328
10115	10065	4	applied	\N	\N	1000000000	\N	93553	93553	261366
10539	10883	0	applied	\N	\N	\N	\N	96003	96003	263810
11131	11666	72	applied	\N	\N	\N	\N	99386	99386	267184
11634	12476	59	applied	\N	\N	\N	\N	101914	101914	269683
12203	13039	2	applied	\N	\N	\N	\N	104339	104339	272084
12371	13205	1	applied	\N	\N	\N	\N	104970	104970	272714
12861	13838	3	applied	\N	\N	1000000000	\N	106904	106904	274642
13086	14228	1	applied	\N	\N	\N	\N	107887	107887	275621
13086	14229	2	applied	\N	\N	\N	\N	107888	107888	275622
13086	14230	3	applied	\N	\N	\N	\N	107889	107889	275623
13087	14234	3	applied	\N	\N	\N	\N	107893	107893	275627
13087	14235	4	applied	\N	\N	\N	\N	107894	107894	275628
13087	14236	5	applied	\N	\N	\N	\N	107895	107895	275629
13087	14237	6	applied	\N	\N	1000000000	\N	107896	107896	275630
13087	14238	7	applied	\N	\N	\N	\N	107897	107897	275631
13088	14239	0	applied	\N	\N	\N	\N	107898	107898	275632
13088	14240	1	applied	\N	\N	\N	\N	107899	107899	275633
13090	14242	0	applied	\N	\N	\N	\N	107904	107904	275638
13090	14243	1	applied	\N	\N	\N	\N	107905	107905	275639
13090	14244	2	applied	\N	\N	\N	\N	107906	107906	275640
13092	14246	0	applied	\N	\N	\N	\N	107908	107908	275642
13092	14247	1	applied	\N	\N	\N	\N	107909	107909	275643
13092	14248	2	applied	\N	\N	\N	\N	107910	107910	275644
13092	14249	3	applied	\N	\N	\N	\N	107911	107911	275645
13092	14251	5	applied	\N	\N	\N	\N	107913	107913	275647
13093	14252	0	applied	\N	\N	\N	\N	107914	107914	275648
13093	14253	1	applied	\N	\N	\N	\N	107915	107915	275649
13093	14254	2	applied	\N	\N	\N	\N	107916	107916	275650
13094	14256	1	applied	\N	\N	\N	\N	107918	107918	275652
13094	14257	2	applied	\N	\N	\N	\N	107919	107919	275653
13094	14258	3	applied	\N	\N	\N	\N	107920	107920	275654
13095	14259	0	applied	\N	\N	\N	\N	107921	107921	275655
13095	14260	1	applied	\N	\N	\N	\N	107922	107922	275656
13095	14261	2	applied	\N	\N	\N	\N	107923	107923	275657
13095	14262	3	applied	\N	\N	\N	\N	107924	107924	275658
13095	14263	4	applied	\N	\N	\N	\N	107925	107925	275659
13095	14264	5	applied	\N	\N	\N	\N	107926	107926	275660
13095	14265	6	applied	\N	\N	\N	\N	107927	107927	275661
13095	14266	7	applied	\N	\N	\N	\N	107928	107928	275662
13096	14267	0	applied	\N	\N	\N	\N	107929	107929	275663
13096	14268	1	applied	\N	\N	\N	\N	107930	107930	275664
13096	14269	2	applied	\N	\N	\N	\N	107931	107931	275665
13096	14270	3	applied	\N	\N	\N	\N	107932	107932	275666
13097	14267	0	applied	\N	\N	\N	\N	107933	107933	275667
13097	14268	1	applied	\N	\N	\N	\N	107934	107934	275668
13097	14269	2	applied	\N	\N	\N	\N	107935	107935	275669
13097	14270	3	applied	\N	\N	\N	\N	107936	107936	275670
13098	14271	0	applied	\N	\N	\N	\N	107937	107937	275671
13098	14272	1	applied	\N	\N	\N	\N	107938	107938	275672
13098	14273	2	applied	\N	\N	\N	\N	107939	107939	275673
13098	14274	3	applied	\N	\N	\N	\N	107940	107940	275674
13099	14271	0	applied	\N	\N	\N	\N	107941	107941	275675
13099	14272	1	applied	\N	\N	\N	\N	107942	107942	275676
13099	14273	2	applied	\N	\N	\N	\N	107943	107943	275677
13099	14274	3	applied	\N	\N	\N	\N	107944	107944	275678
13100	14275	0	applied	\N	\N	\N	\N	107945	107945	275679
13100	14276	1	applied	\N	\N	\N	\N	107946	107946	275680
13100	14277	2	applied	\N	\N	\N	\N	107947	107947	275681
13100	14278	3	applied	\N	\N	\N	\N	107948	107948	275682
13101	14275	0	applied	\N	\N	\N	\N	107949	107949	275683
13101	14276	1	applied	\N	\N	\N	\N	107950	107950	275684
13101	14277	2	applied	\N	\N	\N	\N	107951	107951	275685
13101	14278	3	applied	\N	\N	\N	\N	107952	107952	275686
13102	14275	0	applied	\N	\N	\N	\N	107953	107953	275687
13102	14276	1	applied	\N	\N	\N	\N	107954	107954	275688
13102	14277	2	applied	\N	\N	\N	\N	107955	107955	275689
13448	15109	2	applied	\N	\N	\N	\N	110368	110368	278097
13469	15149	2	applied	\N	\N	\N	\N	110504	110504	278232
14004	16468	8	applied	\N	\N	\N	\N	113995	113995	281712
14471	17499	0	applied	\N	\N	\N	\N	117285	117285	284984
14474	17515	9	applied	\N	\N	\N	\N	117302	117302	285001
14890	18382	2	applied	\N	\N	\N	\N	119948	119948	287644
14895	18393	6	applied	\N	\N	\N	\N	119983	119983	287679
14902	18408	3	applied	\N	\N	\N	\N	120006	120006	287702
14908	18414	0	applied	\N	\N	\N	\N	120024	120024	287720
14909	18414	0	applied	\N	\N	\N	\N	120028	120028	287724
14910	18421	3	applied	\N	\N	\N	\N	120035	120035	287731
15180	18794	3	applied	\N	\N	1000000000	\N	121010	121010	288705
15410	19163	1	applied	\N	\N	\N	\N	121882	121882	289572
15895	20171	3	applied	\N	\N	\N	\N	124408	124408	292096
16235	20857	0	applied	\N	\N	1000000000	\N	126351	126351	294033
16297	21051	0	applied	\N	\N	\N	\N	126914	126914	294588
16709	21768	109	applied	\N	\N	\N	\N	129879	129879	297479
16947	21951	104	applied	\N	\N	\N	\N	132200	132200	299762
17422	23402	3	applied	\N	\N	\N	\N	135107	135107	302669
17432	23229	24	applied	\N	\N	\N	\N	135171	135171	302733
17432	23164	103	applied	\N	\N	\N	\N	135249	135249	302811
17454	23474	2	applied	\N	\N	\N	\N	135505	135505	303067
17959	24195	4	applied	\N	\N	1000000000	\N	139310	139310	306839
18494	25457	3	applied	\N	\N	\N	\N	143203	143203	310614
18907	26174	0	applied	\N	\N	\N	\N	145049	145049	312449
18907	26175	1	applied	\N	\N	\N	\N	145050	145050	312450
18907	26176	2	applied	\N	\N	\N	\N	145051	145051	312451
18907	26177	3	applied	\N	\N	\N	\N	145052	145052	312452
18911	26181	1	applied	\N	\N	\N	\N	145056	145056	312456
18913	26183	1	applied	\N	\N	\N	\N	145060	145060	312460
18914	26184	0	applied	\N	\N	\N	\N	145061	145061	312461
18914	26185	1	applied	\N	\N	\N	\N	145062	145062	312462
18915	26185	1	applied	\N	\N	\N	\N	145064	145064	312464
18916	26184	0	applied	\N	\N	\N	\N	145065	145065	312465
18916	26185	1	applied	\N	\N	\N	\N	145066	145066	312466
18917	26186	0	applied	\N	\N	\N	\N	145067	145067	312467
18918	26187	0	applied	\N	\N	\N	\N	145068	145068	312468
18918	26188	1	applied	\N	\N	\N	\N	145069	145069	312469
18919	26189	0	applied	\N	\N	\N	\N	145070	145070	312470
18919	26190	1	applied	\N	\N	\N	\N	145071	145071	312471
18920	26145	0	applied	\N	\N	\N	\N	145072	145072	312472
18920	26146	1	applied	\N	\N	\N	\N	145073	145073	312473
18920	26148	2	applied	\N	\N	\N	\N	145074	145074	312474
18920	26149	3	applied	\N	\N	\N	\N	145075	145075	312475
18920	26152	5	applied	\N	\N	\N	\N	145077	145077	312477
18920	26153	6	applied	\N	\N	\N	\N	145078	145078	312478
18920	26154	7	applied	\N	\N	\N	\N	145079	145079	312479
18920	26156	8	applied	\N	\N	\N	\N	145080	145080	312480
18920	26157	9	applied	\N	\N	\N	\N	145081	145081	312481
18920	26158	10	applied	\N	\N	\N	\N	145082	145082	312482
18920	26160	11	applied	\N	\N	\N	\N	145083	145083	312483
18920	26161	12	applied	\N	\N	\N	\N	145084	145084	312484
18920	26162	13	applied	\N	\N	\N	\N	145085	145085	312485
18920	26163	14	applied	\N	\N	\N	\N	145086	145086	312486
18920	26165	15	applied	\N	\N	\N	\N	145087	145087	312487
18920	26166	16	applied	\N	\N	\N	\N	145088	145088	312488
18920	26167	17	applied	\N	\N	\N	\N	145089	145089	312489
18920	26169	18	applied	\N	\N	\N	\N	145090	145090	312490
18920	26170	19	applied	\N	\N	\N	\N	145091	145091	312491
18920	26171	20	applied	\N	\N	\N	\N	145092	145092	312492
18920	26173	21	applied	\N	\N	\N	\N	145093	145093	312493
18920	26174	22	applied	\N	\N	\N	\N	145094	145094	312494
18920	26175	23	applied	\N	\N	\N	\N	145095	145095	312495
18920	26176	24	applied	\N	\N	\N	\N	145096	145096	312496
18920	26177	25	applied	\N	\N	\N	\N	145097	145097	312497
18920	26179	26	applied	\N	\N	\N	\N	145098	145098	312498
18920	26180	27	applied	\N	\N	\N	\N	145099	145099	312499
18920	26182	28	applied	\N	\N	\N	\N	145100	145100	312500
18920	26183	29	applied	\N	\N	\N	\N	145101	145101	312501
18920	26184	30	applied	\N	\N	\N	\N	145102	145102	312502
18920	26186	31	applied	\N	\N	\N	\N	145103	145103	312503
18920	26187	32	applied	\N	\N	\N	\N	145104	145104	312504
18920	26188	33	applied	\N	\N	\N	\N	145105	145105	312505
19116	26420	0	applied	\N	\N	\N	\N	145630	145630	313007
19578	27516	5	applied	\N	\N	\N	\N	148877	148877	316197
19900	28344	2	applied	\N	\N	1000000000	\N	151626	151626	318944
20088	28861	0	applied	\N	\N	\N	\N	153068	153068	320382
20147	29022	32	applied	\N	\N	\N	\N	153548	153548	320860
20452	29898	1	applied	\N	\N	1000000000	\N	156215	156215	323521
20645	30371	0	applied	\N	\N	\N	\N	158024	158024	325305
20877	30816	66	applied	\N	\N	\N	\N	160205	160205	327464
21277	31473	24	applied	\N	\N	1000000000	\N	162765	162765	330019
21554	31936	86	applied	\N	\N	\N	\N	165011	165011	332265
21787	32460	2	applied	\N	\N	\N	\N	167091	167091	334345
22158	33268	1	applied	\N	\N	\N	\N	170022	170022	337265
22185	33345	0	applied	\N	\N	\N	\N	170277	170277	337519
22532	34280	4	applied	\N	\N	\N	\N	173161	173161	340395
23067	35468	2	applied	\N	\N	\N	\N	176466	176466	343692
23410	35829	71	applied	\N	\N	\N	\N	179508	179508	346734
23515	36154	3	applied	\N	\N	\N	\N	180158	180158	347384
23516	36153	1	applied	\N	\N	\N	\N	180160	180160	347386
23517	36154	1	applied	\N	\N	\N	\N	180162	180162	347388
23517	36152	2	applied	\N	\N	\N	\N	180163	180163	347389
23519	36156	3	applied	\N	\N	\N	\N	180170	180170	347396
23519	36159	4	applied	\N	\N	\N	\N	180171	180171	347397
23519	36157	5	applied	\N	\N	\N	\N	180172	180172	347398
23519	36160	6	applied	\N	\N	\N	\N	180173	180173	347399
23519	36161	7	applied	\N	\N	\N	\N	180174	180174	347400
23520	36156	3	applied	\N	\N	\N	\N	180178	180178	347404
23520	36159	4	applied	\N	\N	\N	\N	180179	180179	347405
23520	36157	5	applied	\N	\N	\N	\N	180180	180180	347406
23520	36160	6	applied	\N	\N	\N	\N	180181	180181	347407
23520	36161	7	applied	\N	\N	\N	\N	180182	180182	347408
23521	36162	0	applied	\N	\N	\N	\N	180183	180183	347409
23521	36163	1	applied	\N	\N	\N	\N	180184	180184	347410
23521	36164	2	applied	\N	\N	\N	\N	180185	180185	347411
23521	36165	3	applied	\N	\N	\N	\N	180186	180186	347412
23521	36166	4	applied	\N	\N	\N	\N	180187	180187	347413
23521	36167	5	applied	\N	\N	\N	\N	180188	180188	347414
23521	36168	6	applied	\N	\N	\N	\N	180189	180189	347415
23521	36170	8	applied	\N	\N	\N	\N	180191	180191	347417
23521	36171	9	applied	\N	\N	\N	\N	180192	180192	347418
23522	36162	0	applied	\N	\N	\N	\N	180193	180193	347419
23522	36163	1	applied	\N	\N	\N	\N	180194	180194	347420
23522	36164	2	applied	\N	\N	\N	\N	180195	180195	347421
23522	36165	3	applied	\N	\N	\N	\N	180196	180196	347422
23522	36166	4	applied	\N	\N	\N	\N	180197	180197	347423
23522	36167	5	applied	\N	\N	\N	\N	180198	180198	347424
23522	36168	6	applied	\N	\N	\N	\N	180199	180199	347425
23522	36169	7	applied	\N	\N	\N	\N	180200	180200	347426
23522	36171	9	applied	\N	\N	\N	\N	180202	180202	347428
23523	36021	0	applied	\N	\N	\N	\N	180203	180203	347429
23523	35927	1	applied	\N	\N	\N	\N	180204	180204	347430
23523	35929	2	applied	\N	\N	\N	\N	180205	180205	347431
23523	35930	3	applied	\N	\N	\N	\N	180206	180206	347432
23523	35933	4	applied	\N	\N	\N	\N	180207	180207	347433
23523	35935	5	applied	\N	\N	\N	\N	180208	180208	347434
23523	35937	6	applied	\N	\N	\N	\N	180209	180209	347435
23523	35939	7	applied	\N	\N	\N	\N	180210	180210	347436
23523	35941	8	applied	\N	\N	\N	\N	180211	180211	347437
23523	35943	9	applied	\N	\N	\N	\N	180212	180212	347438
23523	35944	10	applied	\N	\N	\N	\N	180213	180213	347439
23523	35947	11	applied	\N	\N	\N	\N	180214	180214	347440
23523	35948	12	applied	\N	\N	\N	\N	180215	180215	347441
23523	35951	13	applied	\N	\N	\N	\N	180216	180216	347442
23523	35952	14	applied	\N	\N	\N	\N	180217	180217	347443
23523	35955	16	applied	\N	\N	\N	\N	180218	180218	347444
23823	36828	0	applied	\N	\N	\N	\N	182326	182326	349536
23829	36843	2	applied	\N	\N	\N	\N	182356	182356	349566
23831	36847	6	applied	\N	\N	\N	\N	182374	182374	349584
23833	36846	5	applied	\N	\N	\N	\N	182387	182387	349597
23834	36850	2	applied	\N	\N	\N	\N	182391	182391	349601
23901	37014	2	applied	\N	\N	\N	\N	183055	183055	350262
23905	37017	2	applied	\N	\N	\N	\N	183068	183068	350275
24514	38117	124	applied	\N	\N	\N	\N	186520	186520	353723
24986	39228	0	applied	\N	\N	\N	\N	189759	189759	356947
25538	40245	0	applied	\N	\N	\N	\N	192903	192903	360081
26014	40948	3	applied	\N	\N	1000000000	\N	195261	195261	362427
26424	41989	74	applied	\N	\N	\N	\N	198439	198439	365604
26467	42087	50	applied	\N	\N	\N	\N	198869	198869	366034
26511	42217	4	applied	\N	\N	\N	\N	199480	199480	366644
26725	42725	0	applied	\N	\N	\N	\N	201052	201052	368213
27195	43700	117	applied	\N	\N	\N	\N	204795	204795	371940
27367	43943	12	applied	\N	\N	\N	\N	205971	205971	373116
27683	44892	8	applied	\N	\N	\N	\N	208194	208194	375330
28169	45847	1	applied	\N	\N	1000000000	\N	211247	211247	378372
29064	47416	3	applied	\N	\N	\N	\N	215371	215371	382442
29206	47698	1	applied	\N	\N	\N	\N	216628	216628	383687
29206	47699	2	applied	\N	\N	\N	\N	216629	216629	383688
29206	47695	3	applied	\N	\N	\N	\N	216630	216630	383689
29206	47696	4	applied	\N	\N	\N	\N	216631	216631	383690
29206	47700	5	applied	\N	\N	\N	\N	216632	216632	383691
29207	47698	1	applied	\N	\N	\N	\N	216634	216634	383693
29207	47699	2	applied	\N	\N	\N	\N	216635	216635	383694
29207	47695	3	applied	\N	\N	\N	\N	216636	216636	383695
29207	47696	4	applied	\N	\N	\N	\N	216637	216637	383696
29207	47700	5	applied	\N	\N	\N	\N	216638	216638	383697
29208	47564	6	applied	\N	\N	\N	\N	216645	216645	383704
29208	47572	7	applied	\N	\N	\N	\N	216646	216646	383705
29208	47574	8	applied	\N	\N	\N	\N	216647	216647	383706
29208	47581	10	applied	\N	\N	\N	\N	216649	216649	383708
29208	47583	11	applied	\N	\N	\N	\N	216650	216650	383709
29208	47584	12	applied	\N	\N	\N	\N	216651	216651	383710
29208	47589	13	applied	\N	\N	\N	\N	216652	216652	383711
29208	47592	14	applied	\N	\N	\N	\N	216653	216653	383712
29208	47593	15	applied	\N	\N	\N	\N	216654	216654	383713
29208	47594	16	applied	\N	\N	\N	\N	216655	216655	383714
29208	47601	17	applied	\N	\N	\N	\N	216656	216656	383715
29208	47604	18	applied	\N	\N	\N	\N	216657	216657	383716
29208	47606	19	applied	\N	\N	\N	\N	216658	216658	383717
29208	47610	20	applied	\N	\N	\N	\N	216659	216659	383718
29208	47611	21	applied	\N	\N	\N	\N	216660	216660	383719
29208	47616	22	applied	\N	\N	\N	\N	216661	216661	383720
29208	47617	23	applied	\N	\N	\N	\N	216662	216662	383721
29208	47621	24	applied	\N	\N	\N	\N	216663	216663	383722
29208	47624	25	applied	\N	\N	\N	\N	216664	216664	383723
29208	47627	26	applied	\N	\N	\N	\N	216665	216665	383724
29208	47628	27	applied	\N	\N	\N	\N	216666	216666	383725
29208	47629	28	applied	\N	\N	\N	\N	216667	216667	383726
29208	47635	29	applied	\N	\N	\N	\N	216668	216668	383727
29208	47641	30	applied	\N	\N	\N	\N	216669	216669	383728
29208	47642	31	applied	\N	\N	\N	\N	216670	216670	383729
29208	47643	32	applied	\N	\N	\N	\N	216671	216671	383730
29208	47649	33	applied	\N	\N	\N	\N	216672	216672	383731
29208	47652	34	applied	\N	\N	\N	\N	216673	216673	383732
29208	47655	35	applied	\N	\N	\N	\N	216674	216674	383733
29208	47657	36	applied	\N	\N	\N	\N	216675	216675	383734
29208	47660	37	applied	\N	\N	\N	\N	216676	216676	383735
29208	47663	38	applied	\N	\N	\N	\N	216677	216677	383736
29208	47665	39	applied	\N	\N	\N	\N	216678	216678	383737
29208	47666	40	applied	\N	\N	\N	\N	216679	216679	383738
29208	47671	41	applied	\N	\N	\N	\N	216680	216680	383739
29208	47674	42	applied	\N	\N	\N	\N	216681	216681	383740
29208	47676	43	applied	\N	\N	\N	\N	216682	216682	383741
29208	47680	44	applied	\N	\N	\N	\N	216683	216683	383742
29208	47681	45	applied	\N	\N	\N	\N	216684	216684	383743
29208	47685	46	applied	\N	\N	\N	\N	216685	216685	383744
29208	47689	47	applied	\N	\N	\N	\N	216686	216686	383745
29208	47690	48	applied	\N	\N	\N	\N	216687	216687	383746
29208	47691	49	applied	\N	\N	\N	\N	216688	216688	383747
29208	47697	50	applied	\N	\N	\N	\N	216689	216689	383748
29208	47556	51	applied	\N	\N	\N	\N	216690	216690	383749
29208	47557	52	applied	\N	\N	\N	\N	216691	216691	383750
29208	47558	53	applied	\N	\N	\N	\N	216692	216692	383751
29208	47559	54	applied	\N	\N	\N	\N	216693	216693	383752
29208	47566	55	applied	\N	\N	\N	\N	216694	216694	383753
29208	47576	56	applied	\N	\N	\N	\N	216695	216695	383754
29208	47586	57	applied	\N	\N	\N	\N	216696	216696	383755
29484	48304	2	applied	\N	\N	\N	\N	218478	218478	385526
29603	48491	75	applied	\N	\N	\N	\N	219502	219502	386537
29625	48653	7	applied	\N	\N	\N	\N	219669	219669	386704
29813	49705	32	applied	\N	\N	\N	\N	222349	222349	389362
30058	51082	10	applied	\N	\N	\N	\N	225804	225804	392796
30223	51366	77	applied	\N	\N	\N	\N	228448	228448	395417
\.


--
-- Data for Name: epoch_data; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.epoch_data (id, seed, ledger_hash_id) FROM stdin;
1	2va9BGv9JrLTtrzZttiEMDYw1Zj6a6EHzXjmP9evHDTG3oEquURA	1
2	2vaRh7FQ5wSzmpFReF9gcRKjv48CcJvHs25aqb3SSZiPgHQBy5Dt	1
3	2vbJ9MyuaQbetkM41dnrBRgoioefF5SsnYgT4nD5Dfst7SrAzTAM	1
4	2vbsVxBcEcCteELXMaSprEnMikJ1Y7LwUjENiBN2FygP8nyMhvX6	1
5	2vaAacnAihstCS2ugN4P61vEqFsdtERB3hnEC5ZFZiwV92JBTPgy	1
6	2vaGKALUWBAyjCG5DZgAdPwHfgoSa3RpBVPbcWc9nAJgqiP9uUxU	1
7	2vaG7P6N4x4umDk37gPFBXX8HShshwmtv2spKUTE6iviR9qhbXdp	1
8	2vbuMt3o4gAUhVfWq8joReEAUAJUQfCqv9gSKtx2yqxjm9HzvePd	1
9	2vbpwhApYQbaAP4G85EZaZyedxUefxcTFTTmnPxeV3RdxiL7hszH	1
10	2vapLu6tAdD21NruwHqjfSf2Ag1QYjniaCMVaNZBwEvbw58tdCeR	1
11	2vbUZNKiRGo1sF1WJXwrxi2Ui9Fcnp2P48gatd4iUvc6MPNhfJ5E	1
12	2vasdBVnbKBXN4wYTdxxEF5sH9FyYHxX28gCyJWZKrtdctHJAVXn	1
13	2vaTpcWoEhr3xbWP82Tg3nbeSwNfRiv9M9iwpz6q3wmM1ptt67Ng	1
14	2vaHw6mxB6fbcED1gTxyhcvf1TfenGZzkREnf75LvftGyszAHc5o	1
15	2vbf1keW5b3bLo4s22LxPiQXSPWh3jopQrZHy1abF3iQPGhwkCUa	1
16	2vbrZjeEQSWo1GFDMs9kwPTk9y7x48oHqF33oujb5t6hPFRz9xxG	1
17	2vbQS1bQX8HJC5RiPsKXAc7V8UTeQ8SXCNvbWwwPKfFyyvqV59sc	1
18	2vaDVUc8JgvF5H1K4vdcQFWtLjCioCEfDUz2wpGpX9swUe4kTm8x	1
19	2vbXdy1cedJuQpwmbgM9JdnRffDD2E17XRE7diq15YdHXRJdLt7b	1
20	2vaEjL2BR4SxsrPtMJD2SWxvri53tq1XrQNfsRK3nH2fXmTFQjBa	1
21	2vbkuNArUcfAtLpGFXEtsaAvnyBCJwRhXo951L7Jg78kyKE8GbDt	1
22	2vb3PvU98YyE4vs6vbgcAjYKF6Senc6M92pGmq5H8SqeZ3TaPrRG	1
23	2vb5KCbVB7frH9ziC34S2FvYYmTjwoRJBKUDnDm8t6f5SbHdAyjA	1
24	2vc4qvQ6QTZ7eNi3vuUZew7ErEmnzL457uJpJzPLQBy6aPcgTJ2W	1
25	2vbzw3Tg2u1mL5JPibj9k6ZSwrdJ2CuU7KrSNqBD7654wPHkS62c	1
26	2vaDixuSBwJ7L3ygE1csfwatV31soZLApJAaw6PAMigKNwB9RJut	1
27	2vbAp2odJ4B2gk2YD2t21F5KVWJmkG8RyjT2LwZSW1gPZo4Lo9zy	1
28	2vbfAvyjoh7CnC3F54K6vq8EjHuSp6bSCV3HXPR6Uwt4J5T4wjNE	1
29	2vbuepufNF1Qp7N7bmQncHvbfauunoKQp2h282bxMVKr4axdboUH	1
30	2vbo5n2ZJ4V15DLpt7pDMfX5wz2B5PUJiapDaHYJZasV88Rv95kn	1
31	2vbRR2PAXTvrRZCtfzBqnPXD54gN6Q6Nz3MS2QjYDF278KbhaJES	1
32	2vbMYvpJT39CHL8M6nqk79CL5NJ23rxQH87C7J9CRoCxiwEFEhM1	1
33	2vb4Pfo6gYhAqqppmq4guG6SzhnvEkoXoz5qqNfHcyn58o2pc8fk	1
34	2vbzCYVxG1NvCtQ6u4gLiEGJw97eBa6DovxrC8nWm21gkF3XUhzk	1
35	2vbjGUPNpPtgNn2DnYyHu8GkQsEXsxWcxM3eLEwfkdeLGVCoKgWs	1
36	2vaiy2boN1pZgYg1t15KtxMKJem4bMTYAgxV1W3gfnGv1VChdVTR	1
37	2vabLpuWrbb2raJAQhTn5mJ3oy5NBaqCP2bmXYMPCM9TMcRom2JE	1
38	2vafRmkndigvZaVdXQZvUtDpudNYzVaLV6M3YXq94sseZmvXjnBZ	1
39	2vbpqXZGLbZDcpqRz3PRjmqVKfDtdefzHFyWCzTyAV6RaXjZEw8Z	1
40	2vbsNhS5FpacpNVQM2pK9sgskZhq8GAds1m8XVADTuXqbD6andKf	1
41	2vaSfvNxvNoteArZoNvgcCHeFa9ddsxySfVyt4re518qw6bseRTa	1
42	2vb5N8m5ianqR8KaFEi6d2jEhT6hdSTm822kgHoJfF2KEWgGR65i	1
43	2vaoeLXoqgk18ew9S5ZCNAB9H4Qzgw1buJV4w1Sg3QKSqPxXzxj2	1
44	2vaoKAeU8aci94u9vg2Cfa9Tqa7DYHpPcSpxfdtcBWh3XsLAf33y	1
45	2vbGj1X65gn52EwqxTUeksfSW83mkfmLPaDSUvWDuaoAQP5HzrxW	1
46	2vbemWYgxE3azYz6j7FqvxXEdT5YmmVFCjCJZKfX28NkLnn5bQg5	1
47	2vbypmPvjSTsepDoKXrmBQEMvqU1x7Sm73yW8VTEj2uJgLx5YfV2	1
48	2vbzsFvMoMb18nBgT2ML81u6AcCy96bCv6V5jaxts7BZ5AUBKC26	1
49	2vbzNyU8GkbCHJkAAvFRxa2TEJZsQYksYJm5ZGYBY5MA53Rmqamu	1
50	2vbiunJ4cbHL6cQFiY36UJYTJ8PLJtehQkFrTWftQyWUS51JWVEk	1
51	2vaKLmroGtgSUA5wTikQftJ2qkJGDHcD9b5HM9ud7ZaAERyaVUyS	1
52	2vb5TfKsivLowfAS33hg1yrAhAL1k3RzL8v5obameYsMGuFEDYVA	1
53	2vbQPCpDTWyggL9WGjxL96vQPf4fSSEG7H6sYJ56mVCghEttqCr1	1
54	2vazxCVB5AmqFnAqYPMGruewnsCPheU6k9gbJeCuKKq8yMvmJ3g5	1
55	2vaeCMZTftKkYC3vMkSKHGtVHcVyQMtypJJDBgPvStne8ViiSwuy	1
56	2vaNm28bUkgK1CDhzYy6R5QCc9PVmbU7A1azTdiTAUPSJfCigaXp	1
57	2vb7fn2KdfGb5ijAShSZdR1nyFzaG5ydJBSc5kNFK5dPUNsdD3kB	1
58	2vbWkWWdCqCejfJGPSxqpLkTMnNZ43ASKoC6pJMMgcCqo42gVeBr	1
59	2vbHGyyvzVxdWdwTJN4UmBjRQpNgYfEgCkoKa1zv6b3arTJCojWx	1
60	2vbRtXca36VcJtaHhUaTjfc7FjTZTLHnHj7wNsRA5cBpVqyC6DhB	1
61	2vavJpDtLM9H4wM7P55CmNtkueae5sE3Tbxnrzckkqj7T932KeMR	1
62	2va9mr7pSwFJDJTK5HDgU9PU4JbZyxynnsVJT2VqzBjKpdFUPd3r	1
63	2vbDfZLrQxv5CyEfQ3mqTSjdGgmZdPDgr5kDjzyDsuYnUAGHVaUS	1
64	2vbQ88D9VQHt9EV5yrbh8FD3tPRVrFpb3D3iogZh2oMVViX8YmBy	1
65	2vaXTcWFRNw68rSgQ9cpBHFjXB6jYUwKhzw4BjYu6tEtkmsuUQLT	1
66	2vaaZTve3Y9sZY94xCvHigWe8VyZs2k15RnN7QSFzGbnAxuC6xDN	1
67	2vbKk5b21KqXzbJVoCFrNr8bYbFX4SuCcfJHSmSQr8W6KxZu8FU4	1
68	2vb12RBq4t9kgjbMNX1uZoDCNbEMgJitNsup93E17Ax7jbGnxZr5	1
69	2vbaDf1bt1juKEJE83CQbLnSkivGrVf6nudNWmNcGppUwEP21mCo	1
70	2vbDSBD8tZngXEt1c2MnG4g87uzcduv8UoB43eZEEHH1dYS2cBCx	1
71	2vaf86gHtX7a2gtB2ZFMycEmoZgFxi6Yid8dbecrAyoqAMdootnJ	1
72	2vaqJmXfMQSCCtt8uXBo69FNFn47wzWF2sjZQPtnPEHNALhpMrUR	1
73	2vb5iANW6t7vnmC2KXCDnwf3vjmCnnZatyp4ohtEoHSjhPV1ChDM	1
74	2vaPRkit7NvbxJMHNida5UcZBXsbCzuLsHoHSqGjyusVPwfPwiXo	1
75	2vb8kAui3J1KvF3TmGh46S6uwdBEjcJt2TVtFydRJmqYvJxiUJGB	1
76	2vbipCQ6fy8Zi3xz1Sxtkng8NwLtWc9s7c1DPvmsGCMtCHHT7UqW	1
77	2vaNa4vcCcg1tCU2cjk4uJFSYaeuEaRxgeS9Ly7yXmaYvtLuXePJ	1
78	2vakuzhuw4dHza1qPWCeQhyaBK8T6gjwtHgEcMHnumMWFKk6Snw2	1
79	2vbyuGutYcBLC9vz4mHZSZurqWKo2mNRcAhZWhdL1y8Bgva8vcSs	1
80	2vbPUYjJ8QvjcKc5D5FNF3xbQUDEVKrASWtsvh64PVk9Mwvs3zA7	1
81	2vbBzGi4PNNjkSNUMnt2zsE3hn4yUymSvYHKuKZG2k2Lu3WmbzFU	1
82	2vbMP7DSc4qbUaRLLXJLiEaMLL7cdy8fyYec1Yj391sxb4Njg4JX	1
83	2vahTBGFXr1KKYLAg2khr4qXCdcE18woPrEJiASq2gZQY6fYjXhg	1
84	2vaKUg3oyZ55UjRwDm5VDr6pBjdR4Wv5USzjoE7fVenRoFDNFAHy	1
85	2vbnuCgU22WEebhUojoRb3gW87VoV6onNJ4u8W6ZJFk7TYBvkkMo	1
86	2vaqBCDTxQW9CJ4iLXsWcNS536ZhRJPsPoXeXh6SbgUxqCWnfm4u	1
87	2vbzcM7Lqn67FWapEZRvakab98GKKuLwAU2FojQJVTLW65bngD2A	1
88	2vaqa6Hitfu32YZBjfJWth4GYm45vXT1JbtK3Cq9HpCarhqyjHgT	1
89	2vbQ1Ri5QuVoo1MsWci3s7rP7sGAzGuNSWmzb521LcUJYVgSr2m7	1
90	2vbatYpFYq5pWKQWByD8A6bquhWEwdCRubNxXd4BAv4sAEs8BMMR	1
93	2vc2tKc6WcUngUStvwbm1RqzTNzLmmatXgntntSwYg4eoK5NQciZ	1
96	2vaitLn6BWLmGKfgQ7rM7V1RUjhPkdwjYZfL65zeD8EwZw5oAKV6	1
99	2vb4PUmssM33Q2pSNHWe5GbjBTANp5ufTvyeVwfVgSab61AadVGy	1
100	2vbE6QXDafQJHPWdNFWcQyDjs3t7M1VWhLskAPgN9gAkQq8pW1yR	1
101	2vbV8mCzU6wzHtGGNoqC5pEyQQt9UaMi9Uzzwrte1L2MTefuzPJS	1
105	2vaKpXLU63CS6AfduSEfcbHhS8B5q7jvKVUoUhdMknb2iQxktNqN	1
106	2vaUJq4Gj1XeaUrCiPDmpJHqjFwZu8HaZnRBZfheHpBEwmWwW2QD	1
107	2vb8SMt9XmFxK9K9gTrSEdEr78SqbhuZ4CA9xfNQT8KtdXwkdZyB	1
91	2vayW5XMUfvDCLivYrTBsEJ22esdAprk3WUQm4Nxp3cHHedQqjyt	1
94	2vbhHy6r6eg7tH4D5tDmTj7BA85s3ooqDCjzGfvwDPSroAHKnP41	1
97	2vc3v5yi2rHidVp9kvLNU6to6XnDxvGx6tC2J1Fa6BvCqUwGkWvs	1
102	2vaZJNug1BdXex4MK4KZLVrcVbjpxtuDNgiEvg9v6VauvVvCF7wc	1
104	2vc5GAmoQGqPsJd5ykdBQQX19iyKujXaMdN2xUxdZMxkfkkBgsU3	1
92	2vbVSxG7VW1kQP1hGLmTuo89fwkJPVd31zmnYtbcgXKTtKrNtdFp	1
95	2vbgyEkKzuBtk7SMdcayu3Fh2SCBdktc8j5NWn7qZtgp4HKdpTa9	1
98	2vataxM3VUntahKptPfmG4J7P8ifodhzHyJtRxrPmTcw2L5FrYsx	1
103	2vbYa7WpmpUctWMtEcHSZF7mPTjinZaUpLUK4HvYubLTe8zEdrqa	1
108	2vaeJdKRsqKBB2G5xAYnvWqkKJoqNYQ7GHGwXLYFWUDDtawsYtPj	1
109	2vb4C3Nf4f4VQKG9ZEUy5kdi5Fcm4FX7dSJQY4M3jARnsQ9EwHdc	1
110	2vbQrDC4iGYJpRWRTApDB3pugzrhMWef3iKDPxth5oGnHwR22dPg	1
111	2vafEargVE7HySyiPELbLXkKiUbbhbKfghiijsunsoqREdmx4uwD	1
112	2vaJwQHEUaJnzgymsS5QJQGmVukEVacVBpp3ccWTdE2LCiv9b5S4	1
113	2vajUPhiwX4cBNFNhSsJLLVHVyBuUNbiBeFRBSGXDgB6wRc7pagH	1
114	2vaCnhTJ5oLphU7smCiZikGTg3M7wn8NrMaYrdZHiTuDTUDNoL1X	1
115	2vbY7HDNsesCrTwrmtpr6aTihdMy4Ji1F9Ei4J1oSKYjmps2Hni8	1
116	2vaxcYDibYCwEUFZMJRaVWasftw7yPMBLdZwkSkfidunjtvpRmDK	1
117	2vbn8JGJ7D3hf7cd4PcBJfTxf5ieT4X17qTUuF5e6JVMfYxw1jHd	1
118	2vb29AjXzWjEfZZn6HazsiFB6dQcuSKVJZ48zWwvhHGY8RW6kTUR	1
119	2vaqeixg1iRP7M7NhPZT2THzVxAkPtpiYAeXMBSYzydVdchXVM6B	1
120	2vayjuMMXBbDeHaradQFbSqy8U5bmoVAicaNgWuG9esjZxn3PTJr	1
121	2vaJkCTJifjPwwcBsXfPVUbY5cwbN5bVnGxmwB7x6r3hgEt7WE2V	1
122	2vaJzzyZVE9iRhryiLxQoihKxMw4DzfTjL7kuqDLzrYakdjf7Kkv	1
123	2vbAdnEgX1BnRwqLoY1HR6GvGMjqGFUM9NvCr8npDVD9DyDZvjp6	1
124	2vbEVNToYMbqaoY8NCAjyovz7fGeJjfaHHk8DQXSvSM6iPjpe6e4	1
125	2vaC33ZkFiHofQCZJdbFuweddG6FjWZhnZZBGa6kzEsjMNtYy29H	1
126	2vaSfmJgz7YX8LvgQVx2qmZpcKdhXWq9YD2tpMkSudcByANd1Q1k	1
127	2vaoMb22zVT9m86cRJNCGX5jKpYHzGwePYhCWVhtckjPWqN2ShnQ	1
128	2vba4wESNLwGss8iKyg7ZuWPAQYqeyYuPJKdBoikjT6FULDXkAsf	1
129	2vbyJkKCUTxEGYsBTpkK6yBVM15rXhYUTg8XFAhSmVXCwMWrD6sv	1
130	2vaxgo1Wz2jJQXSaRBD5Bnz4F9wYRqFs2pQqqmSiBJgByictBJ4f	1
131	2vbxZ6habfeDzbsR4Gvuvb2eJLYNss8umuEUrEXtDJsiV9VeaCuW	1
132	2vavxFGuKuz6YihRayXcE9JDUDGTgeaef57i2Bj7FUr5YzjSnwMa	1
133	2vbDCHeSi8wjUheN6b1WknxnSSnEPGVhXUjJV3rSZDSeiVsaibWt	1
134	2vaqvvJv3Q3zbiE7184hK5hzB5QQuuaHXVddQzaKuSsZnGzNnNSZ	1
135	2vaPC9JxSxRg14czNwUgPmBEZaxJQN39KTAUGqVYHaumtbVss8tf	1
136	2vb1mzpqUbGgVFRkqSpcrTPG1ZAdL6zmisdVsD9biXramFH4XMZF	1
137	2vb41eZWEg1RHCPY594Ww9tXBHE2zNYUMAV3xuypevtKNFGJ7s9M	1
138	2vaC2kBqYctGzWmd5KMsVn1w9PVdviAz4oYunb97tmRsGgemCnSq	1
139	2vb9wDXfvDFtqeT3SubeXCFh2fmNaGK9yCjbm9xewm6Qpk6aKsi9	1
140	2vbacXBr47XtM1Wk8xGveXVS5STgGQyRCEvpFMHPF7TnbAerxLNa	1
141	2vaVQFZQhSBJyMrdc7hk4aoxKgdyFjs8TwoUHFYTsRgwsMpxAjig	1
142	2vbdy7TARY9U1wEwbxr94qmCokVPydUCjHNWcCJh8ti3SB9jsrJH	1
143	2vbnrd1DQj2EvohJBKNcBhgpcPdLsG5Hb1U56VzLK7J5GgugUp9D	1
144	2vafKFgNrGv1LMKfQP7hQs6TVNqg1FErbhgNv8t5sV5oGuVoAJZ6	1
145	2vbZV3WdjL7YedrGbjv7pTFDTkr7FtA1rQp5xCUuzquPa9BTdZKg	1
146	2vaHryLQ43RMXv8Jfx4PUVvZJt8JnNvpfYPRA4JayYqjuZXmiQ5N	1
147	2vbYqJpN3xocNCeG4oFgHFP3YdHvW8nruvjG2Ry9sSFyJBPY2EHa	1
148	2vaiE5mvY4PkzM8MVGMDKFDYYwhnyxTj9Z52Ux2pbdMoBUfGmR3Y	1
149	2vaGN5EjrLRzgAxBoi89CKkSrjQCWexzYyuyKh6iZmd6HLe1Xj7n	1
150	2vbFwdsvg4BxhP3RtjP8dPqdzZLT3e6vrAXZcsvx7aTRt6Fo1j6X	1
151	2vauZPbCA3CeoxMS1vygAskfr5fiwEYWAriQWFphmNmxsiV11DbF	1
152	2vaHAXePUtfBiaveDqSpSv5h91EeEdVGdfiRXZSyXYYyNfSNhCVS	1
153	2vbw9AZbFqXHqcJL85PdJedrJJ2SgxGRCyzFoTuRC5pM53nS2bf4	1
154	2vc4UgWkoC64QNaWg4x8Mp7XvX5MZSAuP4rfBpEa6PxHwDNquYqE	1
155	2vayvwsjZAHYLE6MGxe3U9DgXZ5tEfKNRqhEsyki2UVCb68ugTxJ	1
156	2vb5tzkCWTLn9uB5SdFduKDHSDFEce8x5qG6YGby8Mt6oSa3a7kp	1
157	2vc22Q4aswexb8A5hJwbEy6ELvWbassbmQWeMB917eeK2m8yLYYV	1
158	2vbB94UEqo7jSabcNRHQDnco93PfvdyeX6f51nqiu2NH3mAp7M87	1
159	2vb3d6UdrpXTrLxjxjbwHPZJLpJzQZNBYV2xrZYJRWJs3KaX7LGY	1
160	2vbHacZT8YJm6HGsgfSu93juFFQCwNCxB882EhbAeZKPhUbN45Aa	1
161	2va9bnep3ExEEEFgssW6TvpoQsm4vrmBvbSp5Jyhax52Rm7e7XrV	1
162	2vaHMB7wzefvJryKqEsMnC1vH9ugnno5sHZfNBdYACToL3ktLp55	1
163	2va9p5yW54Js15v24uUExEbRDKX3uxyEYxK3LVq3Q5tsAJWRosJN	1
164	2vbsBY3gMefwnKVVSqyp5CJFDhPaD8V53pDDzxDrqvTH3iRTRVDQ	1
165	2vbkn5JBDVv2hqJiTCVXQJgbhXKUWMLDZrJrDVfGhYzNEB36fMWr	1
166	2vbLpVw67u1qZS8T3DRjLrwcZjZT3Moevmdxj9qfRtmZXKLk8Fbm	1
167	2vaNjQX3eEa4LYWjWA1JtedCiw7nuSXfmQkPXi1zBMecxBPs1VVG	1
168	2vbasEzcFyw9McNCQjav77M1xR3BRQkRVbHiwg6GUttdyqzNT1AS	1
169	2vbrFzKjq3R4X6HBJeKe3qei6DPQ1VEv19KJANzjFt2v3pRH3xLb	1
170	2vbfqshz8jJLtU1Vr6HU9MQtWpjeSVG63PxoQ2m1fu51tAngiNVV	1
171	2vbDyAyibsVL4cn4cpu3ZCawEPR5UuF4jfZJXeL3vMXCBaFVRK2P	1
172	2vaJjXerR5dGs9N36SKXoDBYwoHyBFZyDJEYVajc72kE2tmcdMox	1
173	2vaMfsarj8vkdtc5uAtLvjSdL17EsrVBbGVYC5FkEkjCHFD9rKPU	1
174	2vbqSJ2naxJWw76NjvLMEQ8njNsRZGY89AbNKzN4tt1b5DacKorh	1
175	2vaArBxB1CL31JzbFNXnXmw3KY4JyrnjveXxnKxzua8fudK4srTY	1
176	2vaoij6bt9wkuyp2cUiaUGtQR5XHEGEom9a6GAb2bDod719PoAvH	1
177	2vaZFS2RhTwismU36JEGVXfLCutWKW9GhqWLTdtbdrm6RycPRJp3	1
178	2vagQt6R5yZ9DPcdYemm6svWtmeLTXScGyiUZGUvdHDfsb5TzDA4	1
179	2vafeYw9VvHoaENDfJJvGDWiQqaNWTDwtSnHGHmJ8C8qkqcfv2yi	1
180	2vangQnvXCbnrU4Mnne67KKGpCtsnccid5Pdgg8NV9tTVfN1ps9u	1
181	2vbwjhdy4NuY4JgWZWHhDBynWbveZFoxzXYb5zDHBHsc5yk7kGF3	1
182	2vaQxEbbRwgMrGVi2igFPxdwm1ggfkzGaMSSBbffMEktPBr6u33K	1
183	2vaMKKMp3RGr26wWYrbDjSrDRFR3Qw5vCMAdk8tnjg5JNzHeCdGq	1
184	2vbKcQXrkMLer1kcpj1Yrpq8fukz2wTpv1Rr9VsN98D9B2y7kzv5	1
185	2vbBLHzPcQANU98821Jk8DXtzchomkZGd69VuTEvJBQrLZTjwzCf	1
186	2vbdzZncCY8eRVzJSf7FV2SE4NPTUhdcmHFMGwxDvjCtMkvMyW3Q	1
187	2vbyQ3q82pRb9hbzX5PWDKdchKSLcmZY76PedSFSgi3955hYwxmS	1
188	2vakJew18PRU7UGGHNJLqGVaJPBiViYMfHc3aaU7NDtkCLwQ6WYu	1
189	2vahUS6wBSSV77kgkgMaShQZEbVZg1NE1odsrD6SF76fGHE8HSrp	1
190	2vaz3xDqCv4eUGXQsCkmsp3vygHKHVpC39TyWpGmZHSrWFkHscbt	1
191	2vaRhCTAGAf2ig6b51p9ihNqX7A9Vx8Rrjkmqg4i3wMh3624EiQv	1
192	2vbBLc9dhEtC4csKGB2sYDNhX3NasRVHmooFLaaCHwN3kX65SXrv	1
195	2vahUbhUEoP6TUqYKY3Y4aU4RN9JnsGzuMME33HqTkMgR3bJdFW1	1
196	2vc4CaJXs57FSAE3TDPrBmsQdr9v4aYJ7EaPJCi1Yppnpdm6VCAq	1
199	2vbvfQdh5BB65Q25kDxTuVfzNumST88soTiAxFpBVSEPLEJmXUPr	1
202	2vaKZ8Kd3iB8sD5hiZy6Sq3V6QVq7CKqT3TWPEAfTkaBtzG6ATUR	1
205	2vakCk7x8jThw4f5dBhK9h6wern1RzoRcpETieYJfVt8nzhL99cb	1
211	2vbrEm8F5odX46ANA4ELEczxxCPtXaQ8xTbo8veSHFxEJVp4Umud	1
214	2vaKVTK2xNBpbNB1rfVibFL1yYonRf6Fi9zLJgxqFWJy1iLA5pGM	1
217	2vbNEgTjToZ8ZgfCUTJE5pqaL3SN6Ctwsdvj2oxiwdzD6MyrQiuM	1
220	2vaRfeUW5MgZ7fXsN4R5QbHtHVzYSuCd2eaKMEByPVKnbwMgSHhj	1
223	2vao8VF2t38UcZa661db88pZhEBZ9TsMdRFgrqkxmtxFJAGkMSs2	1
226	2vbPK641xFweqq3UzWcbZBpQYYL1hue8tozLeePTpLDe2b1to2fA	1
229	2vc1Xh48JHV7H5tajTyD5p9hB7d41JyqTgbgb9HLHg19Q8rbVDc3	1
232	2vaBySkcDQCPtSiD5ekqqwaxVQPfaedgNuKEqZ4158y6URAM4Qhq	1
235	2vau6bNR3GRgdT4v9HD1ZvjskbZGzFRJ8hJTJMSg7TFv4vqfrCnK	1
236	2vb1vbX3JywKsgzYS7xvqXhsxPMzdxZyGohYD6zC5MZxNss156ri	1
193	2vaeAsWBhg4x68aBmyPTSHMeXrGo1BRUqRVD1QGy9dh1CK2u6Sgc	1
198	2vbcWspZmkL2GkZY9iL2HSaGPnzHdLNuuNotS3dN7FPxuwpcm1xS	1
203	2vbaNmYY2ZtwkwiHwSLMUxy7PRDhSwgfBMYboq3ANXDfUzJy879F	1
206	2vauy59AqadAD47pzsFTu8Q2KauBADnD3HsYc1vw6MAQkkjcTpsy	1
207	2vbz8xkTLD3w9myzfDquZ7RoMvpFeT8omwg4didmwV5gmru2u9EJ	1
210	2vbhjBZUws5ZactQYA7ayqY4Pcdvd4Q86VFHniFapnqDSmQQqZLH	1
213	2vaLtgKZXfwVRc4t8VKUA1oyQAdqP96hiGV5ZCBPR1HbuTgCytkt	1
215	2vaHLxuBNPBphGsH4MF7qdS9opKnDjQK6mVbdBnJQNAKVU9DgWM1	1
218	2vb1N3SWif42YADVnFwcgQSUPKTvLkbLzGoAsVypqvVaQi5HC5xz	1
221	2vbjTxwJR4quKTq2EyVq1ZfgpMCQsyMaFCpLwJEBZ9qRYrqSBvSU	1
224	2vazQ3ewpHZCqMDrcqgVk7kKeedABgEUuFy7BdeZUFqsk4CxgD35	1
227	2vaJkGWBxAAvaXxaHsn9Uw1LmZvb15rJgZnJRLEJgFQ3CLzkyTBd	1
230	2vaNXTXFE7YqpmzHUJCAhyKbZhorFCDCERNqZsyP9rDDas9bVpbK	1
233	2vatj3YmHxVyHbMAR6vxNEA6EgufKUBtVh9bPgoZBWHTX4WkWQ9r	1
238	2vaB2SSNatSmXR5dGXkSkL97YfcSLNv4gAs3Gsfz2kNtVaeCzRF3	1
194	2vbD9D2gUpzHry3MArNwTMgbTnCRCdmgtzC3tqyurZnD9JJULX6p	1
197	2vaLxpB6btcftyrecnde3nt6i9b6M43YvbxjfgR2WrGbeieBw6gK	1
200	2vbsuBMoGaf2TsjkJPJNXC5Rid8HE1TtF2oqkumj7hP9SxaKLQeS	1
201	2vbgs98vBpzdNmWGmQge2P673EnWK9BLU7NoDmJef95h1DZsbkUH	1
204	2vbvJ2SjAVKN33JbdhEzQ6miWmBAtxqeBEKnGSvNQ1zSWjLvD47j	1
208	2vaF7Xnk1uGWasNDAxWioJNBWd2NEoAQtAf89xcmZDwSFPGtSYzr	1
209	2vaRD3Luw9g4pTY9wGAJH4kwiv9r59Qxkno9zzE2V7dKmN3pMuPf	1
212	2vbgvCPsiFYtbwXQeiXxrnvVvU8VhqZbUxNoYseeN5eM3h4VpDiM	1
216	2vbN2NQc9rKLkgktXsxBxd5FGBfzjKF96g5jm33itoN8aSFCSvPQ	1
219	2vah2mjEBdR5PNNypnt6dJmiZQ7LWcgynfrCYnYCxJttTmWy6UC4	1
222	2vbWLk4B7D96bRVds4oiKd1rS4zoHSwfHvqycMoTJDpZAAhfiD8n	1
225	2vaBADQsR8EQVe73up3ack5JDWDmShxiiHrsUEoXqLdbUp5TCVip	1
228	2vbkwjT72ZjmX5pv6Le1a8eyqLMN5ZD59dXWLmLQxhTTDuHK5Qz1	1
231	2vbLRCRoWxjJ2bBxVBR471affvwnBznQfCK78MWQ85UW9NmAwW7S	1
234	2vbsaw9AqRSPMAAdTGSQVwU39TaaQGP5kmpLMjvYjYfB8NSe4ucf	1
237	2vbaP5wUyrREcakx6ezmYc2fr5k4CEoXbG4BxwRyWrsRU5HG44NB	1
239	2vaKttkEd184Ac6GdZaw7NqMUyrgG6fUTvHcXHxHoj3uZPV6ts5g	1
240	2vaCMzHgZi3kBdc4knU86hLNt64e7NmY7u5bJktUGRUAE4FApA7Y	1
241	2vbsTpnwku3539GVvjx7EQHtLjWhSRP27aP1et3PiQgx1qFpcYvf	1
242	2vbnwcCRvN51HbdVzL2CB61UdZwf53GDnvUoyPqrizcZvBe3dTHa	1
243	2vbCwbqDwb8qbvC1ue2EiEmgeSW3sLpKTR7iusufto3cKbmNe2gv	1
244	2vbcJG4DrJw9iapsMvtRi3Xvfmrz4jGUVwk8rNEiFDYP7NL8WCBB	1
245	2vbwj1wBn34NCZKj27JuemgZyhUtdnd7NZ5bxwcwP9PKEv3z41a3	1
246	2vb6EX5jeVryEapAkmj9DM6GjPH8drn97qU4BpwfZxj9DRJAE2uJ	1
247	2vajBbxqcackpUFZ1GNTbYsfxT5EyXbcLe86c2Yh141uuYouaRjw	1
248	2vabSxhgdBUZgfr6EaSmfm1JxeQqZaXgZjGF9PsnaJQFr35s2Mgb	1
249	2vahhShD8475S5oyieufGc6TBRNbRc5VqyitQj4FKAmKk2wLJ81Z	1
250	2vaE76tFNKjZH6yKo6U1MXwPKytkms5PecsWvfE3o6G8TiF5FH9x	1
251	2vbrz4TiCdZe8QsQWfa4q28vTpzc2qb7jvZNEDvTuqPXgbhBUGet	1
252	2vbgadqci76pTpGWzr8Jos9NF9zSP9NK78g7V5YvXvXoeuyBQSyH	1
253	2vbZPVU33EcihbZefjXxKVoCCe4wJC5VY9iK5iKHLQz3PEFnmcNk	1
254	2va9rHqUghXPGPJUKd2Mif3KA3uTALWrwMzBMCDoKwv95Ciy3BRm	1
255	2vb3T7vp4LWQ543MHT7rv81U3XQg3MyotGYYWX5B3uLKmHebEDic	1
256	2vaBJK1gxot98j1oVLwK56iX8BbdEZLsshH9A4nLfjBaufxVvFhR	1
257	2vbkJdNxWAgS1GZsKbKtEcn55mMUChTWSDQuAH4RobMVtpf9Jc2i	1
258	2vaH6gdagW5QZEwxRGoe2cevvXd65zJyNGzZXiacLDGW9ebHmHFn	1
259	2vbKi4fkAKG5vit1ucNuFEDXxwXRuQqcLC8h3pjJA39mPN96YK47	1
260	2vbHxCuPMnX2Zc1iWu4qa8x4bLn4QRZ1ZSB4TA9dEkkEyuGqBDui	1
261	2vapzEHgRqh7g2FvFLn878cVnmLjyoJvUrs88uCerC1BVUmPEUSF	1
262	2vbdHfCjQoFAiYHcgeiUmc6d8JMdskR6cRVJodVGJtqBmjdUcTAR	1
263	2varQpkU59brYiZgDNCANMy4wYz1oZeM6VD1pN34L67JFK7mkN2Z	1
264	2vbWatZrdH6cXiCcZBVsgjHQ152jfGgkhet9WLw3azn64XqEkWLw	1
265	2vbue2HYcHFpD1C5xNmU8yiSj5bUQeay33kWSozsrgcKw9JtYViu	1
266	2vbn19AmktU5xMYG3rCgfg8TcogcKrXFa3fSh6gwdWFpTPrWTX6W	1
267	2vaWs9cyETA5tEcBXZJzD1zdJKTbeaGmeq472pFG67dd6VRa5WLe	1
268	2vb9cpScuDF3UQn9VjaCDEQSEb3YQUAfUoSBEEV5UoT5F7jG51x1	1
269	2vaR5c48Rgw8AT3o5shgHMcne7q4XJx5uUKtfopKf9ZePFtPWdkL	1
270	2vamgBK3UqY9C2KQxxM2EoGrWKHx43kT7EKwqnC1FFED23ADYGsa	1
271	2vaL48y2ipWRcV9TyaFn83L3cQe4wSBiXa2HaHLPBWq56qVSsEjG	1
272	2vbqAdqfUVkWW3bdRZrX34qNnypuAxwVbmxuinHW6Tm92yuh8Nwx	1
273	2varkuLcQRSqf6SSjMtheZrJ7e9XjKVVsbaYD8YwHPzy52YFpYSc	1
274	2vbFmkcEkDdgKwfEVcVJHN9tCJ1Vnkvf8VNonHZyQJhUD2v1dvnB	1
275	2va9FyfbX4HoG46h5Qg9GdjkwAcKGYHaCp9KMFAaSoi24qk5QmVo	1
276	2vbXRsmLcSMJbTHZ5TWoN5LLncj7ew9Tbd6PVE8QgYqHJ2vHmfpE	1
277	2vbL3V8yJCioBDZDF2HrydZgXbdNB76cgeeRRpomojBJResQB4Hb	1
278	2vb9XwqQKWc7ibvFghnLP4UDFgsq2EykfiaGEy4AgLm77uXWRz5Y	1
279	2vbQFYhNQcfwCrjf5sYnWUNzb4aMau92Ais9PgKpEWU13UpeYR3o	1
280	2vae4TnkCS6z6R45tvBPVcMnEsKZrmDDXASZhPUvkxTeoTdL8FJS	1
281	2vanRaCMRJitUyFmSMtF1aE1bqwZzdDdxo7vsca3kDUc2qDkumJp	1
282	2vbQiRW7R5KiESRK2R5rBuQdXQqreZ3drWoUhzcrDYr53e7SW99F	1
283	2vavdswpSULJ9RXbnE8JfeV7GZmrUH6psPK3toJwrQJHu5gDBPHs	1
284	2vaqcGaC7JJeqCYkRCMB6F7qwcZmzyVJsGkWu7QzAvKipui5So54	1
285	2vbzz3cK5mPsF7dXv65DY9jrsj93dJEsvAmPV1K4oPmELfrpG6bG	1
286	2vb7fd6qr9jh4Ms1GYQmgMdjiNMJPaFkZVJZo3NYdw9PRikbqiGs	1
287	2vbqvf24zdKEWiZxD9qjb6QNVPgxFGeieNYVaKyoocwd5kVSGqY9	1
288	2vb5umGS69d9wEiCBrv7tiwgk8QhvomMu6vFk17S17xE8C1NfxL7	1
289	2vazjD2DTMUUEa5UHnHtmvE6rWBcNdAq8wmACtd6YMPkjFi8mVpD	1
290	2vapHMf2MP3xQrVrfh8R5kDTqsokMLD2nos7tkjusewf3QVvhFqQ	1
291	2vasswbFwK4v9XkUif7WfEYUJCtugW5msykwdPsbMYigNs4xmH6x	1
292	2vb2k44DRMGebf4FMYhMC7zZe6B2FDVdsMwuMEaFvGU2GrEUqsSv	1
293	2vaWhJ6mD3PB9AMiH7xH4dTTkEgCuLMgCoXDroQTSzvmYdkZQPte	1
294	2vbe4TQTxeEHAq5ZYKMRiBA5HmiCUZsADGv6uRtiia1fztEj7Zcp	1
295	2vasEqNM7xA9Wdk5VWJB5KaXW6wczDUT5QMepCvasmX6Q4GWcTsR	1
296	2vaH6zkTndSNcYK2j5d3orCb68BNpXLnrvabLqnhN1gAcKmAYT9p	1
297	2vbswbkvFhRaY2JpJnbDUhuoAMe2fhgiSY4fjFHGjF2mLxpUbynN	1
298	2vaPW1EMSD8UgPt8ttXxpyGZ5RgfThKjKratD7Gki9p4vroXvaWK	1
299	2vaKo9DWCdbwEG9SYUjQ3S5UTRkTQBhDFwJgoqtsqcdVrPPhxrxg	1
300	2vabn4fd7doYGyHwyQKbXC9E99e5GRdczuH4c6kZQocgmMcCgVnN	1
301	2vbR3hpYiqPjtbEcbGqLWxu9bdxE5enEygWsVADVFsMSj1WBT48b	1
302	2vbCMByArUawXtgNEhHxn9GeKLpQTPojmtur3B8r9jHtoBCvJJsz	1
303	2vbteNyyk5vCTpiKCMGrBgAJDqTgNqNe5UzPdaCufpV3gXmKcdCr	1
304	2vbqbckntDpfhR246nBz4ecd5Y2JeqTnvbjjR1NNpx4DC7ahoxBN	1
305	2vaAhcZjSai7fob3hTobUbDGjBwmG6qtGRhxFhhSBAn6piYw4qfJ	1
306	2vb8gcRZ4YswksvcwihbV5gqDbdSduE9uHXLajB9tajy8rfnFYsy	1
307	2vb7scz7bgbmEVi1buyxPufwK2LY3YEXyxRuKjJ4eDUoxEQsigpV	1
308	2vazRWMDxvPV8AXUXGennJjEsu1zsrBR9fWvguuWKFCVY6GArKgd	1
309	2vanX95PZaHnXJuxgfmaFs1VmqNnZL5TvFKpRMqzEvqHqVmjWqhw	1
310	2vaEAKbDVCuGkbDVVjD9KUbgVPYT18h6iifpeYvYpsHJ82dESXXE	1
311	2vaLVSNcAQTJfo1a3HHUoXba7vfbkQjNRUJeXyQzoWT5n6y2cH91	1
312	2vaDpesvzR7w33myvTdx6aCHRP3gPC2vC3ahDpkYuWTnxqQkeAUe	1
313	2vb6VKt6w1pf7Pz3VSZpVkjmcZa45QdYjzNfPDExYzCgCq6AeigT	1
314	2vb3Sb1M5MtEgMqB5H3Wzqa5xSMWpnqd45LXCVLEa3KX8jWpMAyn	1
315	2vbLUqMgLr8cLWvUkR6QdrkYewrP7QKaiNRP2bEJxwDScF1TRoPe	1
316	2vaKP5rJWBZaZbqCDe9PmWTYgSzLreUoYB4TkYfdfDcwYZ8NN2q4	1
317	2vbr7XsxuS7rTTxgPQmpZ6qjb6v3mgwwXfXSPHweJrXxWW2zhMfN	1
318	2vaFPTTXnbDYMwikakAz1KEsSTRjqmgbPdCxynZ3kEZe6ed6HwWc	1
319	2vbcZJrgSfNwbg9Fu8hKt7gqRSYhSfBWH4rEanSmtu8fd1kBBWB5	1
320	2vbbub29siz7TRQV6sEdxcbuUdDHipQbzChfsQumcRoUR5wAhBuV	1
321	2vakuA6anQvooe79KR2rguaBGC4TAygf3RzUMvkVt1HK6wkdaYgj	1
322	2vbtv6CgsqNhk42ETcdAR4LxVN8A5aDqLraGSe4k7eqQQmvTifqe	1
323	2vbgqbckEQ7Y7hAbQw1xgVG8QRj1T7tZJstPCKUp8b19wgScsvMU	1
324	2vaWPzehQsiXomi9Ted65KDsbVz9trJDQ9orSsFEDKR3fdrxf8eh	1
325	2vb49Nih1wQstBcgjUUvuS2cH1v5C7cT6MwVKfFS4ojD3ESBnP7w	1
326	2vbBgCUrH9kTVqLHv6yAhAtY7RJz7Naz9pWsXfZKT6Nnc8CfHLXy	1
327	2vb63fTocVjxv4Zp9MXy7HcoeyvTzNM7bhNjNk4WzLG2sa6pZuBh	1
328	2vaZFQmVLBaSyMHcXRieHBVk57aKtGnjGFCyQtEwvjUJ9Hh2F3Wn	1
329	2vaJsTGpVzwAW4JJDBqZAsKNV38mcTC1hErU59FCyiZLBnqtnbq2	1
330	2vbwvQx4i3KQKEJPAWNp8xrZ1KQfvirLMhjCcr5FiFtrKnKUoZiu	1
331	2vaFo7sgxUURAdcyF39GXCMaNJyvqyiLXjRntQ37u6Qbg1FoP2Qa	1
332	2vaqwCsx7ksZLDYxea37JvVqZjYYPPxz9473ikncF2SGwZ9uYVcG	1
333	2vavNbiupd2tjX4HcUEW6yuTzQAZPfi5Knkak1UF1RF2DVRUX5iQ	1
334	2vbyNb6ZuimMiFomjW7J2JTBTwscnL7uGBX9TBVjbBLXasYrorYG	1
335	2vbp3e53QrTyzT2fsQ3Kw5VoLPGRrsX4cU6d8Lm35TdrjyGvpG8c	1
336	2vbTTQdnb2yTEqMCUrHpxNLGqN1sErbifikNFNaHar4xrEfnVKTR	1
337	2vaQdRWBLQ6WTBW8RaD93VX4noup6613J6SosoTn69PYWtGcxo9T	1
338	2vabHTYFB73ZpW1ZzSHdQjTzXG3W7meixM8D9Sy8wrmKfCfhkcoK	1
339	2vaGsnkvzqgpm1sUoVTwG3qaLFeAYNQi15jE2xLgguX1fPUcZCAZ	1
340	2vbAPvTLF47TFbFsF6egDjTpZkBrZi4Wp2AgpsvT8HLu23aLqVep	1
341	2vbPXYm6yxipgF9Ym75KqxiwPysVaMaFz8WiczY5TFsBtYmi6cp2	1
342	2vboUacGu1n1ywPEELrV4ZCqCguEKeYWoZRxAUiGtyZychdmQKSL	1
343	2vbbYf1LqNMtqxSJ4Gj9AxB9b8uKSj3n7NY1ZDjdV7Qv4Gwkb6vH	1
344	2vbd8fY2W3o4f1XcHFMWGGBkiEuCk8eixMNRF39YjKsX8ox1g8Qn	1
345	2vaZRd3euW7ofso8ByvWuvZzFjUwmsMjm7kGFg9oBEheiknzHDze	1
346	2vbrq9dheHEKqP7DN2PR143X4q9M31SxQArn3AWgG2ybHoFYuX8v	1
347	2vbNha7oTH84dtB1k8rXpndsAa3kYPzLPPRYjxLrGe5RcEgQ1FT4	1
348	2vatgQNTomTwExqDpAH6zHnU7yj925h9sc8p4QQewyMNWZJGuoee	1
349	2vbYM6hgHvdTJZa7YtJBeE6UTy1GJJEiWH9QeCtqbKgLfCgGCuj7	1
350	2vaSQRCb9WsctSuA9Ti6AmHj3GXTLNDZxu19vU9ZSCKmmTvXPKt9	1
351	2vbrPoQrgVfJnvtWtuKCAssbjLxmNezC2tar1WPX7sMwZksTdVEu	1
352	2vc3DWtLprq8uPNtBuRPWbQqEsgqBnBAsWg96AuConfraoVQZzty	1
353	2vboPtF4mudSp3UYvS2iPNieMBmWkBJ4eRajYPa87YUb26UYjLZv	1
354	2vbqBgn84f27eFFuD34AncLxHpaXo2C4r6phAdKhfDTRZuGBjJhN	1
355	2vaPWDHn4zmJAcvxVfbiosLX9phrHTnVhQTcPkjiK8zXq4ZvcXmV	1
356	2vbsJ9i842NvTWppvxVdidzS1W85ByYF8bJz811vENBvDm9NX7DD	1
357	2vbrZTmbryu2WQgwozu2C4gijcZ6y5WfpEgkatjUeWbHcPFreGgb	1
358	2vauy3gagDtsVGnuGW8T55snNLK2cHSaHeN2NLSr1GDmSnyDBxFz	1
359	2vbVaE928CBmxnJx6K9CVdToq2f4bGaLNw5NnTPDUZi5iDMosMvF	1
360	2vbk3o4MywNjUmgfWTiep4FoTgFvm4WsvryDGqPRxSkvb9YqrnyM	1
361	2vbf4YJL9BvcxBZMq6cimPkz8QPyxZfN5FLVPSr4b2yw23kW6Dwg	1
362	2vbTcHFWP1Wt7nnfum1BxjxprEaRhmRjGFDqAfhEVrdemcWg9uLA	1
363	2vbFPV1DdPeQMEQ8nwTyTpCVrB6mpkBMwsHUoFGXruQZee8ZEheD	1
364	2vaWMFnFpuGHbXf4oP6bA5KZxJpty1yGKrGeNAbXuQkqbypz7QBp	1
365	2vbBAhabgWrD9NV2QX7A3FUd2DNMbGYPFyevq9tmv64vmHM26iQe	1
366	2vc1p86BWskx34pzn86St1Y6jbXYPjAQFerZiALFLNRrBPaS6Hrg	1
367	2vam1BZKjrfruGu6d7F1gmijNPi78qoN95aSzr1FgyEFUofdEozZ	1
368	2vaGLHvVUr7x4CnS1rdrRjCGVWwcKm7bq7W2rmWPjWwX5rhMut7e	1
369	2vbm4u5R6MUvh82pmyRu8XK6QxAGgdDMBjLyt5V7vUkQjWTCvu9H	1
370	2vayQSkNLzEx2vDM9oZVFwjcxxa9BgPPLiTUJ6oJ74FtWFE9gPDG	1
371	2vb1K3my1i2s4R7x4qC6VveCvEv8BpzJwK4M19BYkcsnVJneHWTk	1
372	2vaKaan2x9m9AJRdW3ZEEg1csZt5oCe4XVnRkgCvwKFgW7DNzE3u	1
373	2vbKhs5s3bDErcZnDR1K11Jrcw7yByN2Dfh8GqGCrGjYCo85sbUE	1
374	2vc5WFwAX2S4xw4W8DiVkjn9M7YrRSQiUxYiGVwjDwt57e4jvn5P	1
375	2vaMte5icXxiP9fG5Ya9m2eJWZbciU5BZTEvtTCgEVXzzNq3Ldcg	1
376	2vabA7gz5yKo6gYnrzZqUYsbwakQdy9sqatTdNAzHbHHgsktpqS3	1
377	2vbXNnQUP8tNhmDnZV6tHmRFr1Eu36N63fRnaDG8nyTDhfvcKTFA	1
378	2vaCEnLm9BBZf1A6ftjSNz4c636SqEwpJtVSaS4JuJXNnUt1qWfL	1
379	2vbJna72vqrk88r2hwZWKMPJRusrAkQLHqvMsDfLRYDEogTNetMw	1
380	2vbsbwGAjtwR3HxD33henpadRqUXDMJ9Q4TqqVmgJT3UE8YLNfe7	1
381	2vaAxMN65Z4TXfyPvAvAApMwxN6usQYPzfuLshRwF4riwsDuT5S7	1
382	2vbsXrSagQoonRDDXk74147VsJac5Lmjq9TW9j1gx7oPZuG1SYSN	1
383	2vbk3z4cFKWpsE3RnYQ5CbgAfg8MgXA9sN3qiS23iCWiJHnt5bbk	1
384	2vc5ukf2bZMNNqEbmbK158wZZ54vDgz1gxZ9iE7h7JVv619LPVZi	1
385	2vbFC2w9qeavx4iuk9rGjxY69AAhm8tmpAEo91gjiW575WwaqGJC	1
386	2vaieqBxy7aVwfrFySmpkf19JHz88fAGkqcTw4K3zgr4nUquSjkg	1
387	2vagZSrMAVMrh9THZh1QSMNoM3Qsp7BfjrFSrEHiFg1YNAQh2hrt	1
388	2vbRAxcY3KcFc1RjBvqYkmjV9pYifCTQW7i7x5SG4BJMVbt7yUre	1
389	2vbf688pKerbfKVRmMqWbAp5VzkaUV7LWGAZxqhTsZ5eaMYxzAfB	1
390	2vbj8xKNqunHL9RzyBGUh314fAEbDEwfFQsKP5fGYsAAgju7D6EC	1
391	2vbdqL5Ye61ohgBHXBCYAZs4ESRizPikrUCv8tnt5Yruu72sNCfP	1
392	2vaBw5tdKLe3vT4dEUPgRfXNWycg6kqSkbAPYCR1E1uTFefSh8JC	1
393	2vaitxB2tkhpYE3X9RPL57JRqrfHFBUiF5w26nYRejRphHGwA6eH	1
394	2vbKJz4TmtBdiDVYAAHJsmHmtmxDRFPzHGTQEN8LsJFoEs9TJrjR	1
395	2vakXoQT61jgNBwD2PtZUwn15Hmwb6b1GkhYzyaj7MYf4eZaMEsu	1
396	2vb6SSvnYoDcRpXMV6ypSTmTG4WDENvJE5W7W1D935fVGKXiYMRe	1
397	2vavDqrUBvmjgnMBz2fav1oBfybJVjVpwmDm48L8AuDAku5jND5E	1
398	2vaw2p3bKEfhZ3i3GsbSEdHxwqSfsfiuDNcYY48fWpTw2AMU6vwJ	1
399	2vabqs29vHYz6ZneeKwX8YQup3SLuRtjPNzNLiYjgYhPjpkcENts	1
400	2vbzGMTc2fmG34yYuFZ9Q6SnVPyuuKtR4ep2ixBJAz5zyfHsxFSt	1
403	2vaXv8ansbWtcUh8w95WyoShHuwZjMMF7g1pzpAhcJkNeSk9Q4zt	1
404	2vbHkAin3bUkj2bJ4X9RFjxBgj5JTo5SMxoXy5CG5pN9yQofq7cr	1
407	2vbFtFYXex2rRAxPPsXXGswLD5L1UtnprpGLyQ3762xeTdyfA8sX	1
410	2vb53d5Qwo9g4gJU8dyXAMHUdy7A8gqEXjR7nN8rTQwg9Kh9yQdm	1
411	2vbJf5BQh59sTSVaUdSQBqKugJriGmM9x5WjUd5m3fUSYNAtx6t8	1
416	2vb8SVru7tSBmpzSKFQMCPaU8VgDukMASGxJeDnLRtHCbjoXsf1m	1
422	2vayDuwyPrd1G1yQpHA1CoUJ2pTZEF35buDgrEEXzP7JFuqcDSWL	1
423	2vbbMbTXYqmzfemTnKLn2XKtuyJxaBj9MCSwbKzYbxGERJECSPXw	1
425	2vaMEuNHw3mA9qea6ANi6eKEBw1wnhafrpUzLwhuSX6FLVV5fNLY	1
427	2vaGW4Z7317CiQJdSiXLTUbQCJRRGVSaFM5A1Dvq2F5A3aPGXMUk	1
428	2vaJjtFS1XstsVSEu8SSYfg7SBTGkbtEw1AUTwEmvFEVaZaB7PYj	1
433	2vbZ1bAoDZZhAym79L27d4LVs3Bpsmhahp17Th1tzwAHdvF6ZwMU	1
438	2vbZk9vsg4fKvtkW2PpreV2iymcn3XjZ1hawH8mhmz8Xr6kvcuMS	1
441	2vbJWZHSHKuNds5wzgJ7faLi5EfoJkujbne1WFF1RxaMZ8Ney6JR	1
442	2vbfF72uRRVdPzbfFSr6W3jzxAnC7BWYvUdyTZ5He3ynhiTT7fmb	1
445	2vb41sRgyGM5rw92xnMvX24eVMFuKuFjrCANneSbB3tQZRv1RL2w	1
446	2vbYAqNQyDduo16aSvvrnKcxFunmcXdxYSsRga7ig3CwCyq5w64Z	1
449	2vax3nCUxwCxqwwhs6aJ87ozGihqq1sx9Gi9opmPaKhG267AWPBC	1
450	2vaSUmGAyL6oTLCCmxBixBdWqXdBMibanhnhtDQ8L67HUyLq8ivZ	1
453	2vbDF4shPGG6XoZoW7GSSvfyQiWFW89SzrNZ9ajgpvKM96rEXfMt	1
457	2vbxAe5sevnCrU5R1ooJvYPEHoqibxRNJvFuLQ3CPTms3tVnmSho	1
459	2vauGbZxgGDLvUsMZM1gRF8q1BzgFpYpj9zJws5u5QSBaojswwVu	1
460	2vbm7VeYimPMVARFsGw5uaCMz4RmSwRjmL7TojAV7E9tnS5iYdNS	1
461	2vbCCFPhv17CRcTvWXrwbirVUua2QnxCZ7mHZQ4eb51VSNwB3Rpp	1
464	2vbBsBvkLk5ERpYE3duEMeHn3jzA4o13PfhXwZRVyFkzsF9Scm2C	1
468	2vacaTtWQBaiiijrnJJ4pRZYMkKYRhnhopPTdWZgKXcDodWZiiM1	1
471	2vbtquSsew3xnuoVpyPKtie1iNd8w7koWFsna6FzZxyBBSwLttMd	1
474	2vbFrpTFXTmnnS7CPBHEVVVEAVRJRL7MyGBg8giUF4iejmaXE4mY	1
477	2vbDqXgBjYn2E8iTNbXXMnW3UJHTw4GM96WxdSeincUybEWtSeXW	1
480	2vbuVKzeEKb2QPL627HbYyCZTz6wzsqvPQqABiyaZmTVaU92iQeB	1
482	2vak7kYZYcq2GTeJiGnnaMoXRWGu1Y6abDSxF9MuFiCW4Mq5MCNc	1
401	2vbxWebkpG74Qn8kxkr6Duy5trxMqsMAKeYysxtQXgNZYgbniunW	1
402	2vaV3AWobpRT5bpN9TGgQ1xcrSQ6NqLPcxBEXWnunN2kYS3ymeBP	1
405	2vb5esQC7MLFDfWEF8VS266F1bykkKqJ1DegMemxTvXzPvu7B7Bg	1
406	2vbXfMBkzBt9AMpBpD9PU4EZJCZWWTmMz3RfhbvWKnvcXdrs18PA	1
408	2vbbvnM4HvWU659AAd9mhhu8WAHWZBrPRvxhUJaPN36mVjktnipE	1
409	2vawFpnsTjLNeAnACbuSev4GCxT3wLDBcVh3bsQ4AXwfzo88FbDi	1
412	2vbBt8nPLByiZaUsq9pepLAabhW4vamJssawSgkwQcFffxdC4VYr	1
413	2vbZCqTDsgBmQ6EuVwcgFThmzdvMbeYnCz3goAj3KkaegfmqtDmt	1
414	2vagSHWzdEma7vN1mX2nHz168q6Cz8TdfhwgW1z2sSDSJsUnmeAd	1
415	2vb12kjFKWrDYyicdrLP6KKbBmLotFXEfjKowAx8KknaZ5FsgCYA	1
417	2vaXtVDNh6gjUbJw6oWs81KGxcQeEF7THGHypajBsaFKR12gLJyb	1
418	2vaEpuFHr22nCzLWi3qc578c2peHmbex5cRygZNj7fCy7we7RFQd	1
419	2vaqaJ4smX5JmRAL1MiUPqZjRTTg7fTgkk3y4QADNS2vDbMZh5yo	1
420	2vabM1o7ujszY6zmd9HkRKHYD1wRVZA4fG2kbYF1pbZT9dj7zfcv	1
421	2vbMBUmqe15pXn1ysPhfdz7BskEEs7SLcoTTwAnkf3sSDNkVvt8c	1
424	2vajk4QHAUddJTRMMH5FnQHGyxsA2DfiBPssx59qqxzCquzcuh8L	1
426	2vamVfL5KWqB4DohDHcn5bVaZeUt6V9GwRWYiQPLU4XN35Rbgkfb	1
429	2vaWMfFivwqHzPuRTR7Gk9rBHbmoYNXVPtZoRDJfDaYgG1TBp2jP	1
430	2vbGpZKNkU1MPxvTTpT2onywru3VtyFAv2fw9vmeeEsVjtVDbZHy	1
431	2vbweKjrYa5LnsE5PLTMExfiCSkvntxGEwBfB8UMZ2a8VDVG894r	1
432	2vaKtcCKPfhd5M54RjBYh3HYQEDzhGZGs66Q6gbqqyHsBCUNbvkh	1
434	2vb3WdVvt3tEYdWVfpg3iB7Xpq1FgxgRzX4zTZdHDmxUpdycyBNY	1
435	2vbryiULgjPVWDTrB6asYxVVDuAy7P5C53QTtJNpgYq1uxRjsfbb	1
436	2vbkyhwqn4QgyFP6cxFmZpZ1oRRBGwAnY8xw3f4EcRNgAsjSHsVh	1
437	2vbixPd84BEkSBPB9odwbEYUimpdMG2iCVs1z7xRoMiyQ5BdFHCc	1
439	2vc3af6KuFEGdMP1AeCfvkCtY1eTNzUqPwABr4LoG3MPN6tXa3r1	1
440	2vbB5UYFwoSu5ULU2bGBgmRmEWq6Ufxz35BYJT6gv5iHFVDKZKLH	1
443	2vatPMSNoEAHPjn85gTzQieRZuBzkccMDCh8rfb6N5U2B3PPdC7u	1
444	2vaogCxV4d3QKdrfd3qtN85g82Bxwvfg9sNpaEawb1oKPPHQDCKN	1
447	2vaiFCwcFNSQPa5XmQDBmCCAmuBHZpWMcrY7FzxPxwcJPWNMrRGX	1
448	2vbP5Vro86jzZ6iBiGx6cY21LuDJ3Xho2pcnZCWGcXRWqv2jgRj1	1
451	2vb2qkgs5MQ56hz5SYQs7z5G7q3bQYC22y9f1F73kDrraWPgLeM2	1
452	2vaAyZ9dpAMsaMQrtSYHFhV6AaLc4GoVdiAJM2oFhKyKSPFuiDHR	1
454	2vaGt259aXVbHSJCRH8gwpxMf9PgvMJHNaNoZFkHZ4Gax17tiVaY	1
455	2vbWyUKvi8LQ34T8fDFjAstPctQ3VM7X5bew5KTxLS9HKYD8EzQn	1
456	2vbyHnr9XTW8Mzf4FUefFjHa6J3DKcxF33nhfaUJ1QXnJgMKhdTL	1
458	2vb1n6DkrxowBrv6sXLeAdQbVLeS24Z1EQ946z7FQhtchvngG972	1
462	2vbYhFHnDyF461UKjA55YUcP1rap5pyW4k3YkEcSQiziXx7sWFZ3	1
463	2vbEJ71oQbM9PfwefQ27MpQS2SMEDhcKAUHrC6kjnM3WG9xra1xL	1
465	2vaQyu4Hw2HzHxdtepQe8xYgnt6Yp5Cug4iy9VjjUbzEEEfqMQTB	1
466	2vc3iHS6zKRphKnmg5wUPFk67nvhqg82sn6aCQCiEzsA7R9dSf7g	1
467	2vbmPECH2gZtz4nDMWL9Fjpdb5SgMpcqSRJWuUJABQgsRFDnZBhh	1
469	2vbypWGu2wYhzDu4J8sPSpLNGCueLJNnNJZhacKKgnY8JFgeUqKr	1
470	2vbG1PUYRotcBBKbatRS36Qgxvca3h4sL6Ze7quKEWM4Y2hAUKvx	1
472	2vaRt62pRwqLRN4aek11b7PKRM25AJYaHN9hYhneA4apLV6i62dt	1
473	2vbrrb9fH2CzFoF3PTVYtBL7v2nkFtFq4QaueQGHBuSZaG4isYFL	1
475	2vb7vkdEeUCRVAAHtEBhEu525op1ZEobMKkfWP59rndXzXDVJJp3	1
476	2vbfMaPBH7ZdxjLnnUqQwcxu5WjTabbKS5gnK2yF8K8Ao4yVPkhW	1
478	2vbZbL7HWVrvcCmpRKg3fe6nHSPSVwo1qHA2xeZ5nJd4pt9YqNxa	1
479	2vaNZZ2BzBC69k9WEDis1vjZFAoHKxjh1tDaLokkBH6ZHWpV6iGh	1
481	2vaCYskaLH6aW55sZKrv8jW62m5bfZu2WvcPPidqMGFqaqrePfpz	1
483	2vb8PBQEp1nFEwd6Kc3Bj2dn82fo7ct5GKdZNtL5hDHnFWCdfEoH	1
484	2vb5putTZv3jTri2eCmWsBDfgQZNVUkb5jApDisDuqNsD43VyZVP	1
485	2vadtzzGaZB3gng9jjF4SkDJYP249Mgo9axwHzj5DT7h16AsJXVe	1
486	2vacyyM4wx1c7oxy4SmZxV2SLcYDqR9bnh7rTgGRUycfqLZxHt6N	1
487	2vb2BhBwXjFghxPq67XnBcHUwtJKyfF25gbc55UdT3fCBXgPhNJx	1
488	2vbAaj89qPk5XsJQUPk5bVx8fYW7YsyUxdZLZMC17rdd73RVGPLb	1
489	2vb3RJMe7gBUdGz5qMp2pQvjHhQWSpja14xWs7w8vk3GVV2WTwx4	1
490	2vbH5VLCedh9XxxPatXYTexHysnNC4D9bL3fUujFBwQzqttQQxtV	1
491	2vbc9y9XQBknDrLRHAn3iWA62MiXmmVNo5SKkq9YZcQzDfDStu7N	1
492	2vacUuaQU2eyqAii2fbMiKBfXUAuQuMstkBqTzXVER8zKVMd4HUR	1
493	2vakfeeHbagusvQHggTq84XDhxADvcjHs7C2PzbabBbL9CFgUt6Z	1
494	2vbdTgGv4eT3YbqJsrKtcuQyKnBWQmsba98SxBPpLkQoC9YfEy5A	1
495	2vaoemo1M2SJg37XdcJYU52iiuKKM7vW62nq34yYT8rNenqpPiEF	1
496	2vb25QQhUTtkzKf5TufJwrb2hMox736BJo3MUuLjF3aNn1kzdKhC	1
497	2vbsJGzytWGgz71GPpamezii4B8CeDrxrowAT1kCmF47ct1JQSnb	1
498	2vaCjhLW2i3yvHCbwCvXRkAD3dv7KbNtU9B1HpKdGhngLEYvcG7c	1
499	2vaRtB94Rq5pPqHEeyNfSv17qYDYfipnVMUoLudqNKjC8f591Pfn	1
500	2vah9oXRPKske2uBTJtoEmQ2kn32E6PS3xaFsWLJFz85nqz8zqc2	1
501	2vaxnFJ27ZbXdHxswEpGXPUnmS1bMX34LAynbnvADSCusnrDURzR	1
502	2vacvuT2yS1rLMcVjpZfAbvTcSVx2ubJvkhe1URGawL75nzNzkqL	1
503	2vaTxR3FCpRnsXM5UCjS8ihcHQhP6bRuDc5xwe6Jj6vC5a3YwFpj	1
504	2vaqiDiSjcbgnxbuQM7kFJwr1QnxPiKKP5SzNVs5zsGYubJkKmg1	1
505	2vbnYBfJyvpqaMwuz2wVN6LLrDTscSpSWyx9ApTEB8pmKhkYK8Y8	1
506	2vbm9vGpSMc9Ncjysn1TTf6y2Y8hMGcHYseorpiznGfgHoN6A4Ai	1
507	2vb4N1rXUdn9sJxNaU5mbm42u7cLyjB8KhGuFUmeX77GhJ1a1sz6	1
508	2vbaPRCYTQWchXB3zzwSC2UeFYhTkfimzshs2rAoFwrNSTcDAobe	1
509	2vbrY1YvaPoZVhE9mjWsEgNsgnJ1sfAWSEQcykQhtKL45DfarDYt	1
510	2vbYd5VN1aYENx3F1YEZqitojAUcPLLs6Y8rgEmN2WeD86Hj2Tav	1
511	2vbaLcg4CA6vB4R6LV88pvQUG3PLrfUpzUX7mBtHVe3kZc44YRbx	1
512	2vaB418518FjBmVkH6ZUf1y1KLRghPhyqPkTzysoGVUm3USmLefz	1
513	2vao5ysBeZHYoSPt3cBtJe96cSz1BvcYUzMB8uzVKCb833pgDMXe	1
514	2vbmGC3gmRs6CJrM5r5MYsKMegfhMZ3oQYTHV3rX7DDGweLXfHnA	1
515	2vbDW3pGRJEsZdhmGm19uByBdciGY5fVNBdbG3L1FMj1mUgj5coQ	1
516	2vbkM3sxqaLQRbC6RKNXTEfSG2rmYKG7fmBpDBCzcs75MoDSVSYS	1
517	2vba7qYkAcjph5gVTQSn4QNRTkDuYwwXDvKo5n7pYEJmxXoV4CvN	1
518	2vb5uX8PyAL2tVAr8AK9MX3MhUMzmbUeyD8CbNZjKpuc6txa1Cdc	1
519	2vbW1adxxHrkEV2AuDfvW6Z34tZTZRkfxiEBw2dGXp2Mn7PyRJUo	1
520	2vbn8U7GgTgyF93qjx6VtSWBjDeJBcCqAzZeVNprDTp4rh32bCXw	1
523	2vbsxT3QaJCvdF7mhj58bLBEuhwvC3yRhUyPpcUWy28BSY5iFEf3	1
526	2vb4HEhGMmCMYnqUrJQD2d7XNx7ytSeKyyMUpreKWdCyZctiyemE	1
529	2vasXgwBSnXUvU67HG2BPp2qhQfZ2g1zhutxmxSBrJjR1NWu8qej	1
532	2vbkwUt2FHw4GLroWFjUsMCNjvHnhwk1u84x9tWzfNAziuYpoLXS	1
535	2vb9kvTbXmMC8xpeQjrwV2A8cavUTLv9FySwg9cc7B42zE5fhRSU	1
538	2vaRvHYquCEsFNwwvB8XsWFpiBvTPsK7swWdFFuN9LhyTCL6Yrku	1
540	2vbzkw3vgwNoGJnatkv8H57qJ9QXAnFCDkSyZEUzm1XjGessUUNq	1
541	2vbPEeHXKEQFMhBDx97jKWJNaTVMt8D989dm34Y4CpmHLgGNSkGy	1
542	2vbxWzaQ38j5AV7YCz1yZiFrV3Sm3zPa3TvrhiDDNfm3pzhu4AKW	1
545	2vaj1jy5bS3TPBz6Y1KmsDrtDwDBzzhj9Uo6BKuwxKJuKedwPxkH	1
547	2vayv2Pnqg4krKwByHitcp3kxCMv5ckkguJu6XSCpiLaMi2hVSf5	1
548	2vbE23DbEakqTyi9pwXRuaJTdTA7ww5XosoVT8aYesShXfyGRup7	1
551	2vbkjriHyN3iwmy44UP6YqpVbeGNbbCYJN6tH4DfCJsMDzLa4GjT	1
554	2vaGrK2AKZbHWo37utTEy1TS3TuzgJMoP6VXU1gCogDG7ME2bvGF	1
557	2vbXZZWBRUH2FvcCUeH3PEAb2tF8XMvgY1Z7xPABgpQ2rFmP4yWX	1
560	2vbamWGdWQ6KLdkmisoWk9nyaC2TLqoFskiJLfa71LPkAfvQjHyX	1
563	2vbBPcogKU6be7XrvhZsU6bvHMaQdYV9JPJdeFQgpP5yEnBiqN2D	1
566	2vbdSHZLdofdg3m2gVUL1ti1RcfHfHqv6bSnG2QFqUcFgLKb6N3m	1
569	2va9nZc5uZEh6ArAY6m3gpthuZ755uxZ3G6NLd2EZhxgBpNEyufc	1
572	2vb1cQBWR6M5gBZ3uZcHFXVcMDTXW4xvu9W8MLn7wajJpYyKejLr	1
577	2vaZbapYSR2dq4x3i4tHA3mgrTegBU5nLpn1cz2ZAD2hiaX28258	1
580	2vb9fx6CYSMbTpF81SRLkDhc6M8qeYT6ZPtYCd2R8niceFcYg2wH	1
521	2vbRu3jDXdcHL3U1ne1Z2kB4yftASWdqQqkczkjYzbPntj7Ss5fQ	1
522	2vbUWw8aCcWrF2Xv12kB9BCoHrv4zzXmNpGyjAD9cUpXn4qKd6cA	1
525	2vahu3Hmandy8iDwUbcew1pzFux2n9cvPQg6s3uH8bWe1xfR5hS8	1
528	2vaeCAr6Pp1VHv3EU2vvYzrNMShxUMMarVhox3USHm6exBw3ik6E	1
531	2vbUcoZH5idnyvUdEGW4Eb97jQTJ9Uhni6nEkKQWFDjvMf9NkSuX	1
534	2vb3sKQDfF2cQUtyNypsNzGzUr9y1qaNs3gScsautZaDdMba7Hnq	1
537	2vbhnGYTsqzrZzLMppFFZEJozDZksVZx9LVaqzYLXYWrJCtLiwgH	1
544	2vbN1THLgQELwyczejjij8zPk8k4eE2iCxqhHuk9ZKD3ZryXD67F	1
550	2vbCTcCaMJXQHZHLf6uHtVssniCgwLsjDM72SXP6QwuwVcffCsm2	1
553	2vbTYxGZ67U2oD6DkDhURhRqo8TeyGG79GNELR9o4umemJQbGtK6	1
555	2vbHTBwCCQv2jSo2bV8sUDCQbZ1VEohQQsDyn14KVE6fWbsJSTVX	1
556	2vc1ZkQnTCRzMQGjmWN5ZtwgfpAAe1fRKXVNzcJHBZLFt1qR1mFA	1
559	2vbJAN9n3RbFQrGi5RFdg7T4izVtxymV1ndcEAhhnfe2TEg78ctT	1
562	2vbvFBye1zjN3btxhpANaJ2oZaaRzfWShGj1aAvDw9EewPhKVYQz	1
565	2vaTBGVAWtqj3ZZba4EupVs92Ne4LMv5GCHzu7CiEzLyrN4u1bgo	1
568	2vbkRK5vd9WhA5CKti3fwCHyni4HvjKHaFNfmqC19435gcanyn7B	1
571	2vahbD9BG7Ce19kGokodoHDPzY4izqBDtMtwpB36JC8urkTTgPoA	1
574	2vbw3TVUrmGmyxaThnibiZBbm3naFf6x5gSLXcMfLXub5gQTSy6G	1
575	2vbnoTpCzzQXBnx5gzhLfyFYPwFajQc6qQRGRRhsLm9R1Arw3JNc	1
579	2vaThAeqM6Dhbc6p6VZymd5B21Qhv7tKbnsHfWmFJrCYpGTLgixD	1
583	2vb6ukrRBVAf5htyDCTtZRQ7ZCPzaHxEZZuNg5khKfncDEqKewWA	1
524	2vauYBWmq388YArzGosTg6yPzfTtp1cBW7J1DqdftwWL1DeWiftp	1
527	2vaE2JA7c4qaQzKjktDfaBxru59gkNcvcRUt7zYJMcUNWpfLwCbN	1
530	2vbHuUFxkhY7jx1FrxBpRUXkY4s9c27PmvvPWQz1eKCuS2tDAozx	1
533	2vaAR8tTei1jBiSFJ7J9zSQZQ46fFqBQT39Cg4fpP4qfjhAFMoub	1
536	2vbqv2d1sU4ZG2z9HA2BBa3H5Q4LJCs3TYqWb4dEq3oSFhPdVubA	1
539	2vb5huqCgKY9Eq9wPLpvujPKLBDsXz7iXEnyWWLtrRNU7opD8zUg	1
543	2vaq5foF9uGDWynpFnakgjKYuBU5uqEUGZEUXozN9sWVk24ebBEL	1
546	2vbxVuMScwKfxnPjHwpRnssB1KwXgZ5mLhpFrSBYE43qcuEqxJ2P	1
549	2vaACuTbPLqTPae6tuxyN98HWARavbVgKRtdSuo54HPFgsya7B5B	1
552	2vbZhHuRiyUBXYPV2uk9Z8PopHcfw6E3ajg5KvQ2JxZovCPfLMTr	1
558	2vazv5RBqdKfuEMkKri4Vg3PF1VD1KcVB6XrbRztK5qnFcem5DVT	1
561	2vbjX4A1dkh2QGKyFMvBx2YixCn6sjVXbNcsdMW3PPSF8UbXniho	1
564	2vbqjopxji47EndBFV2qsYCgXdMMSD5kvfRKKXdnx3892PeMf5vC	1
567	2vaApf5xZc8YarW9v4HedZjgnnQT4bcBbKZnHtKnnNxyogtUUJbg	1
570	2vaRhcuPyPzCwdwuQjZstnS2UDQ5qNJpon4GSpQ3mtudcUB49kbJ	1
573	2vaRHNnaBMRa39tjm1cLr1J6SwzskpNmwPgZFSz4DfRPu1WMTBaR	1
576	2vagUs4fF4YuDw5SVPoiem687yYmDmnvqZ8k95PQb1SY4TrRrBSJ	1
578	2vah3G69ZuWDwr6mrsLqeqFxqPfKvDhv8SLbA6VS3zHnHis5rjAB	1
581	2vamxxZjHSDBFQRSLzt7uU3FhyP3mf8zNcewGZCGGCQ5RJvppN16	1
582	2vasjYQRiGXD9zLwiNScQxRo1AYyx1nGMNw2TffseLJ96nb5fNw6	1
584	2vaNHm2obzyXUKoLvjPTwqNjoKao3JB2nqagPRHtcARVP8dBgkFs	1
585	2vbeTkdPwocmRf3H4onWrWyZ3j959io2FUEsi83P87JHXC7G7bpA	1
586	2vatjgW1MGD4fcMx6Tu2RjQWApapo3pYk2doLN1msDWUfQd7229R	1
587	2vatsA1xsKFZ2zMnACvULeNAo6FununmsUjN6mPF8EZehYYR3Mg1	1
588	2vaL5abp8qrZraJ9MdvwzShTibGkUcJZLoPUviCxuGuw3RZi5Cj2	1
589	2vc223Q7h2tK5LYt2iep8L5ACP3MFP1Aom9SnzSkoAaWfAtHQCrF	1
590	2vak2XydjaBxbaWUygRnAx9H9eGTF3euDMkeCdyNbo28rJBFwvMU	1
591	2vbK2Q3H7dM7AZqnUxsdkCDzDavSRxHYdbjeCK2rGmH5pRdgNd6f	1
592	2vb5yNnWFMQiwm7WvC6BZTE4Tg8xeao9wg9FLKuF91TsMPprX4ww	1
593	2vbtSWCWap2QnmCRAhN7BvZJeV9hWCCccG3gJYj7sgaw62jN7e9x	1
594	2vamg8KXsarDjxYJ7Ys4eXFbMjUN4QXh2qvn4K363jfdhJoQyvvh	1
595	2vbMEtZGe3EJmLj2v5ah4QymyVxEpxYGdNWEmkJaT6bQS6S6GFAE	1
596	2vbRmKsz2XHc5D72c4RrU6nqawmq5Qnoq4dfdk2kNtuBAf5u5HLg	1
597	2vaCvrs3D81SBSMgYJnk5X4SKrnqR31H9NqqvJF65U1B5GnZth8P	1
598	2vaPe4Z9a9gENcuzYdFKYCJ46noawXJ4w3KYtButnFsCZBL9MCtK	1
599	2vbGcso6TRML79UyHEzpH54oanu9xr5iZ4dBSNjyfpJjEcesXWjL	1
600	2vbFgRkxXDRzUSEjK1gLir6Zjup7iPVPTzEbVycoXMf99XUHWVn6	1
601	2vaWzuUroX9eQxFByUHh72SqiM48EU9wqwwoBwhMBq39EFJ8YcX9	1
602	2vbsDvfzPHSTrAhUYDmHV4xTr5sRdbFnrE8JZEw4jvQVmUamwLR4	1
603	2vbPbTya4Su4LtfaCCv4sNjSLqe87RVki41xb7dZL3mWN7suYBq3	1
604	2vayEARdPstFahjjFkTonSHbka3Rb54obLYCfEosF93W1xbTJpbh	1
605	2vayny6bHVa8yBBHeR3fowN1VJ5SFgCem48yEHWDyQd8Bu4gG6Bo	1
606	2vb99R51akcGop7ErAyKE8HHMMXTXUFK7f9u6qGtmwj8UaK9sw8Y	1
607	2vaD3aXPPJ1gW1pXPGz2fjZ5PWC2B7GJtZAYav7RFSJmZMbmgtcW	1
608	2vacXjreaVYTspH2pXdZuCsSQKWSsvG4rHhqQqM5wVusk8QUD31T	1
609	2vawm7E6y9iUp9QwTvCQCDjW2nuYU8fH4nyKPGF3WJiD9ePANspM	1
610	2vbSQfkMfFtRsqh8mjS1KsMbFVmtr4rE8y2DD3XetZTgr5kf2XQA	1
611	2vb6Wskkj7axgftMidgAD9Tmx6hTzkF2N36P6TkjU9NLKpmPC6oQ	1
612	2vaiKZzPqyXvwNZnFmmipMJVgTs8FRhD7cfihad2kKbWgsL4EhSa	1
613	2vbfNC8UN3ymh9HGstKWFeoQNyN4rWNTZ5XJ6cxeTCs7Dj4SqS91	1
614	2vaRGic1PitavnmEcYrLYvUYFmaYtzapdQJKyKGcSYYxDLteRf38	1
615	2vafcTf5vbeN3btU2r8kWnEVqDMKvD6HsFHazRHGvJ64k9Ya9HZC	1
616	2vb3ycNJ8MkanpbjhnJN7y2uWsaJbCpktTMGCtwNU3gBZKSN8pgn	1
617	2vaPcTtBdsw617U8cNsYCJST11F35PREAnaDWrDiSanT9DHkVH3K	1
618	2vbJQfasL1kz5B2eVUyHg8ftqKuJstWHANXGMSDnoinRpt5zzRun	1
619	2vaVNaKSTWa5gv6661cYhZ5Z1BwhbKxCVBgcKB9pm2dUBe1x1etv	1
620	2vb8Uf5TEkyQcwmxzvitsPeGZNqa4cAgv6qs6fUPVKJJVMXRAfmc	1
621	2vaFGs7KB3C93dGUXvxFx8LJA5CvLs6iunWP1pYnTcPFA7u4TNMx	1
622	2vaBkuUTeidcaXXWdWugYwXQ3gV6oS9qKaLkFDcAQdgXtCF7tHTj	1
623	2vbzFVwYDGMVZCJKhSquc13CJk1j88WSSmvxNLuzr4RsfeaqCU2n	1
624	2vbZkS5nBPSxfN6iJPvqnt8pM9gFCBKnPetdD4FTmHL9wPqx74E6	1
625	2vaQcA5kATzmrknkY7wyRrR28XcG4iEPoLu1hQz4JQ2pcVncFHgN	1
626	2vbs6wAeuQByHhSokpUNfF6e9MT5vzVMeuVPk5tvUCfMaUneR8N2	1
627	2vaRKAiJNkSoMZoydf1Msio5eWerWWL3KrzGNFuJLRYtSzPm7Bjo	1
628	2vbPBBmLig5jkQDDB838CWxVL98YAcr3U1Fpg7kZrck5fKwFys8u	1
629	2vbRZ9qKs2t1GzL7DBrBTqwtznyL49poN3akdZzZjYQZk5sY74kM	1
630	2vafQHyfF15xg6WcTJAjxgG68XiXAdj1waGQxJxnkQZ6Dp2PaiUi	1
631	2vbGQePAp1KKrszsMeSovuYcqchAcqpXCVzVav5sBXXQsdqqa3Wg	1
632	2vbftzR4VW7bi3K7jdT6PfNJwY4RT8tjeRiWsm8djmGWZKghrrkv	1
633	2vbUAkSocHcMgTVzRBXnLarH6NyRS1DhseQaQTyo75VzXX3Xn4QU	1
634	2vb3oooiqiNuotJ34hE58NB8AfUhNRX1LWL4QD3yB3dfJMLCphdN	1
635	2vc2g9tkHFmtGT1jzEff4XR9MmrG5Rw32HBkBeqAyscescfo69A8	1
636	2vbtyTveHodXjdtKjxofhArvCfzu5CM3RrWrRfFmhEGuhmquPZwa	1
637	2vbVEGaUzTJ4ykbKhYK9AB13WDKoaXTAfsFTPW1BjMJ41eDd5FfH	1
638	2vbh6ZkpVvtArsoUs2mAuR4UXKsipq74TwLBdPTmsddBTBeTaC2R	1
639	2vbybPBFJ1QasHW8HVyrGRdd6zSx2HmXxfC3zZihAr5MMk7xu2ri	1
640	2vbRMvHjBYAuQx4KPTBw7b3WGvTyrp9B3z9SibVPEDZWFzk1nDJB	1
641	2vaJtc3JjrxLzSdpR5ZLq4Gknr9G2GN9bGUqh6kyodFgfAiuQpDX	1
642	2vbX8wTM1bgiUSbj6yQFdBNY6NjmZvCKtdx12e5ayuPyzxi5Y1FZ	1
643	2vahDvNmfsgVE3uiNVuJfYTV3MoDCPLM9Z5yaCaysR7Pk6VeSSvQ	1
644	2vbvH4Z2N3D3cvQ5Week9H41csHSNaGhmCyFrP1Kd4kzuetFQLkx	1
645	2vbYwjvzesUvH4g83fXtti1zTdvUQ3jp8HgkaeCdNHGiJGdLUzFX	1
646	2vaMQeMq4pxEDAC48vdgWvsMcUpfgu7E4Kx5vLzjU7PyD1MugDaA	1
647	2vbvseJry1raWjgJ2DPQnF1jys7h7KtF8FD1kRsko6ypxiN9gyHu	1
648	2vbW1ce9J9BFgHHuxjeS6oYv38d7yoJesv27Ej2FhKJPYeqPbtRj	1
649	2vbcbCoj24ugzujAVic6UPZyAeXFbi9P1hMkFCoS8AUv6vJRmMsZ	1
650	2vbDFcpzzqLDFtfNXbyEgptDXf4MfFaXMGmvGEybo52ts4T14hPe	1
651	2vaLaM6D6SFVtWgteCDGn387kAGwDndoSGKS6XjQbhoqPkKRWr5M	1
652	2vawDGCJku9qDMi5Q1BqC9iJH8BZmwQjEFQpENefUFuRExva19r4	1
654	2vahDLHgzr9xAWzCpG5MdZi4ATXLCeDJQVh6yQd2FdEGp8KyKSkP	1
657	2vavB8bUh7ymxigpofsKFUidzxZQRyhQf6p2JpnBsJHc47V5ZVZ5	1
661	2vb3MuL8s54WvUJoHWFLyd9a78XQCeq2uKafoTB3jY9p3p67dX4K	1
664	2vbnGGqk8iUq8rc6apY1LSLKMzgfdNLsXgyzzQurZTEDTxt7ieup	1
667	2vbTKswVshYzGrndTRELBSTw1Q5FRT99zYs2fKcWHzTGuxfhz5qN	1
670	2vbqimvnNVr9scQyMWT3BzqnjTNceXXfgxNN54T5wN1gRbJC8SUu	1
672	2vbCLKBYoE64kjgnF5mMUhzTHX7DZAFCQ14Afa9f7hAeV7pQePz1	1
675	2vawXEkmjiu9UonQyALTZHxVnqCDskDPD1wEZ9BZyeYjwxYJ8aPJ	1
678	2vaBPetVrTrxmABoCocymAuaKpZd4MTq8WPxZ8UuFJcY6MDzxNB4	1
681	2vamHXrWsAtWEC9LhdJZ8JPQi6MMkg2hMr4qELHTmFpUiUVPb8ag	1
683	2vbhJSeAeo1AWMRPQbRhuUvoHUEb33pVSeC4tQxT43pU5yTJpTYC	1
684	2vaBjMnAWLcJFkJ8JQL7pwBwCaWxCDeQ4sG8NRKHFVeW1m3FE48i	1
687	2vb83tUy1i8uU5rHg4VzWJiWnDvtqfLDGenKnyMQvnZp3aXuiNKV	1
653	2vaqgbT9QhZm8pQNTx4Z4ZgMSibwWGjKxm8jk2Wm5jM2wyuFLGPZ	1
655	2vbzdx59eiwrhsKp276cW4fEyAdWJ9WaeN7tAbhCn21ouTnGwBLo	1
658	2vbGyUB5wcaZyjuFUM1Tjiy8ptnYJEGB1xqBVvmcJgiZqhPf89Fs	1
660	2vbRYz5FcHwCJPRtEnBM2L1mQkwckUtzGAf9uauQL5QJem59DV16	1
663	2vafpJ455UumPfrsLPxzLh7vDv45LzNjP3tJcT5eyjETvxeaAfAf	1
666	2varWG4r5oqzVQ4wd9Cg24NRSR6Qk3AuHddSeYRyxz5zFdS4e3gr	1
669	2vb6hovXAbQfSqjxgUMcoaGgsorcv9XQXoit6pHTuTgX27qfSqRQ	1
673	2vab8H8ZjPWVzJAAxvmy2DMQXeLQPDGSMiq8ftrnQEPLs67L1EDK	1
674	2vaVb15c6rVrQpCXeYaw5KEMFuvm6X9LguAeYvNjKtzbXZv4Bj3g	1
677	2vaV3Zvj6MuHEvB3WiXur7qdMuaomG5S3zPueJKyWzPqewEsfQkW	1
680	2vb8UyLXZJ4aT5oekKb5n7TScBVkV2Faznz2Aq9VmyttY8DNJSjM	1
686	2vb38snhmjYmXxap1yqd4DoVVrwND7BDWRRf6wJQo5JChnSLkQt5	1
690	2vbVxC1Wp3yGdhtBmzVxqzjTfUJiduzyqJ4T5xwP6JDhiri5Gh2q	1
691	2vc3vXzvyKoK5wagGLYtviD3XraUiUAbYaTpTc17zbkD6FxKjX1E	1
692	2vbHbberD1dyeEyLEGHhNPrprErkrsfbYvi7bnCMU5QtsYEcx6ZX	1
656	2vaKbuM3TY2d2ZtZngA5vZcmLyJroAU8iNvpWw77fxECYyKDnawi	1
659	2vaZo6JHVLrcHgzX8V6SjQfQXTgeUQRsV65eg5vsvKX1hV6DorNa	1
662	2vbqvqFHnmhGK2NcKtufFjHZ2vFaRpHgjy6xXqMujfMWFHKbStBG	1
665	2vbKesSsehbnAWTvsU3QHLxadSDL5yw2wswRHV5AE1BUCGymCsoa	1
668	2vbLDHHuJbtcDJXpkqShGJKsnuK71PZfbgsaTo2nuDGXKQSMr4Pd	1
671	2vaSJHxFDFhaQkSm1LNiQGrDKKqEku6Ks54AXc2qq2FBwF4yqSyr	1
676	2vb2t1dPm17gepjPG84Kdxd44xbNqArhRhi6uWD3noMDWePEkFkW	1
679	2vakavhHt3KYxbQKX1FfCkeph4stgm3XGeK8zGQjoEdQVSuJwKA9	1
682	2vaGJvZ2vcxrq3pgqzRSAgdxnMjQfE6xGMwkHzgUJdpU21vG3Lyq	1
685	2vb5F7EvgidW8PkKZhbHBrCiM4xgDbFkaTL3JDmqoXbhUxd8UbgU	1
688	2vaSL6a2yhDem1dDCvCYgSCEA6Ehbc2kT8hJmvz8TbyDa1CxgKSQ	1
689	2vbj47EwAroujLwEDaY7UHt4iqbCVgyQSDwQePNo463uyTw36Mzg	1
693	2vaHjyooXGsZwwABZwXDmPUHiPqjhv3rc63yY49EP9bzUemkmi8Z	1
694	2vbzzmiERe5ZWicBe8tzQmqyJ1r65Jbtopceaf9oMYWoZt4iNQBR	1
695	2vbsTckpQc922UAovJUihnQHYWvCacyEjiwh4uNSuaiDFcFnYP7c	1
696	2vb8FaRGi4QCbvRi8xMQ3AYx5WyzaCz4NKFpA8ijTLngXtsGpBxN	1
697	2vadpW5Ze3M4jpsMhSPxCjegRKk6PeWxDUuukeQQLU6VamiXw2pX	1
698	2vbtMDWbFdtdLpxUBVxNahLwiVjRXmKgYpc2QNDg8SH2im3PPCZG	1
699	2vbDoenhbJ4ie6zcbzD3N46WC9reSUAqxFh2Wdj2z3BaDgFiLjZ6	1
700	2vbzLSQF7ptLCgx9bsgs8ShoKL2tEipEE1XShCy6f4e1E8ss6zsX	1
701	2vaRy9SHRXccP5ULvCMtFEm9gzx4EJiCbaxL7zHFSDMkne1Lf2ro	1
702	2vb9e8EWTZ5w4KdzvGm8QUQbgTjdL4HZ4cbymtTnxn42eVeSFe2E	1
703	2vbsJYiiP4mq18SZjC6fpsYPBwmYuNk9yFfJytgZ19tAnftbp7V6	1
704	2vaWocveQQTPQtaACxpQ7P7WgtUdsh5LtFd9XyVhWnrV7E4gz4mm	1
705	2vbDxhRycg7y1kLtMqdRYCWr9cNzPvuKCEgRqXLGvQoEeRWiCFjL	1
706	2vbYkGm4RNYnYnT4xw7dixpb3x1oJCaRiCo8WMJPWbZQQEVxB4PT	1
707	2vawSkK5PbUmUB7SD5orgS1Y6rD4Knp2N8HqAbAXxNnEiJ18MJZd	1
708	2vaDcrThFsA1yoXGS6rWRHzbsASf1A4rx2E3iEnr5EftLGnVrhn9	1
709	2vafsa7nfHgXxcd8oRA5quASUi9HjBpY4Xb3UzxAJ3EnX7fdbbVG	1
710	2vbNqhG6G8DJQHGWcZL41WJXpAjikNzvDPx8LFvVTbayxzgKV4FN	1
711	2vbhbnnecdE6S9W6NukFhCTC7wgXZCiVzX72CuxcPeWz8PSYHVxZ	1
712	2vav6fSMu4Gz8ZYWZbCVB8iWURH8nJeBXbsUyRvWub4XUEzJ6dqm	1
713	2vbMrSqMXkbyaetGK3cJn2s4nWnCVsbo3kEgzhzaTpUkLJMAv3an	1
714	2vc56YUiXAndNLheTiEPcK8A4er9F4MPNUPpcJfuU8tdYHefaLL1	1
715	2vbAgn71SwULDnfGPSkB9MMfiqRxCR2jAHaGqNFtTAoiaNRnG66s	1
716	2vb3kwH5bXmotbYinQDEjDP2jkLuwao8BzKjTJNsrcxFkaTw1f5Q	1
717	2vaauJQZEe7P9CRpLYRn9TQ7nwMTDJCQcNnqQcVfsGUpRQPb9rN2	1
718	2vafzSekey9T8LPySzyj7UhHhxoGnAfp1pQDPEXyf817CcGFSvJ1	1
719	2vazwzJjHQno81SFRodvfjQQSgWYHEUxmafAfYESYa1QBaSmmMLu	1
720	2vaVbKZbUXipfk4QgCfqPM5VoGkNrhsZeHV9TUbwh8M1ArFK1fe8	1
721	2vajYJiV6QShqn5Kw61cuxUSEnWoJQYhXCPGzoyVTHS6rTvj7MfP	1
722	2vbQZbZjs8J5njXx7KUf4EMwtxGaDbx4p1cLwFaMzstBmtB3XSob	1
723	2vbd1jum3GTyPrS5z5wBBBSxwE5ZPZXZUsHsZDF4YLuMmKmk75Ld	1
724	2vc4JShZZGFyJeZH9ZcbiBRY3bA5H7vsyTtGBJdzrkX46YXM2k6E	1
725	2vbb5pup9mhrwehzc4KE9tjn2qoLB2g3L9GvnVi6Yti7o8ongAzS	1
726	2vbh8sGiyrqHAjuN5V6io8ArRbtmyYyprYKJRgFovtgFfnoyWr3e	1
727	2vbsuGtrwGAdQUQhEHfLUv8F85Xah7hb6Z4cSpBbByL5ubLmgdiF	1
728	2vbfvskmA2svrBTceBy98VDAVXWGvWZQYwMTsXDRS5HkKxESgT2j	1
729	2vbicc632zMdgHS3TKVrqG4SmxnGPRKypaGjhCQzraWKg4UcpYJD	1
730	2vbagSo7kDsq2dLYVzkaDNYg66qFbZF3SRxzu8FuaQn5hTgAN5gU	1
731	2vbBTA4ZDRaBctyCND7dHeP65jauQyk8TfQY1M3och52TWavhd3N	1
732	2vbf69aJA5MDRfTK9mb7zozEyS1SNgV4LQqReL17wcP17e55ToEc	1
733	2vc2N8MaQwuwgSCtg9BcUE1VPPuFd5kquP93zzcBCFtwVFbA783P	1
734	2vbcuEVf3SH8kE7oisRq1ChEtG82eX9jSXnaStH4yTUu6Yxf3ej8	1
735	2vaid9yQxmrR8L9UZUVueTLL3S4GebkGkM127DehKuQ5o5XjAJjb	1
736	2vaiiHmPcUB5XBybJS7Djazq9xYNqEU9WanSk6hpC9dWEN9pVMgG	1
737	2vamw4DQjin8UrDqk1SCvaLgaw7a54Bp8Jkr4ojGeNFtaECpd4si	1
738	2vaiFeBAVXvyvxwKw6s7s86n1Gkk1V3UAmx8YZ9c84rdnVbBA7oK	1
739	2vadecsao2QbRSkjZhbBgSYRnKnDnUE5TeLrDznVp39aatFY9WNz	1
740	2vaCdNxaPRuox4j8RREGi55AuvNF2bTHJ76Tp4Qt8caWWwy4PzGW	1
741	2vaRMYjxppFVMLKac7LV7FYk2Nh8HumChGugfxt9btGKRCayfajJ	1
742	2vaZ8zLWVnQmCv4hK4r7fMPa4WagFqeTHffKKUyqKcjKkqdfwD1u	1
743	2vb9REZh58zWrifneBFpmxKkPGMGMT1hLfZSsVsMvygAhRCoqWtM	1
744	2vaCPGCFPrfu1HSfN9G2xVhAHDPuBPnFreoLugyEY8BLGuMZQAeG	1
745	2vauqgTFiChio4iELBhTipNSCw4amdro6J8JbkYGdBfxZT8xfp91	1
746	2vbSgq85QFXamDawPsLyBvC7geh1RvkiYZGV8eeGVPc88BS32Qd6	1
747	2vbCQNSHXe942YpVzdmjbyqvuzwXGXwwYw8SLpMLwAJEqEkc7ZMF	1
748	2vbFeA9hfDKPyxdKcwWZdR71rLqbt6wACkWDeJmQZaCmcJQbgkw5	1
749	2vb4J9XhKEQbKt2mScG2SBeqshFwbdJ6K6dSUf4b4wkVBQnE88oo	1
750	2vbPTr7Q5EnnrSGf8e7iPLgHjAAj2rYjhhRndzGmjxHsuMp5NpaW	1
751	2vbmxHnYH5T78vPTtcsNhpTg8PxoU3CUGf2DDYP6XVLdcnfRZxZj	1
752	2vbmiW8HpYBi5wPh2pkx6TA3CgNhAWVpW3XZ5yrb67nFGCurrkfn	1
753	2vaj6QdFcGDwak2YVbJNKDbvJ1wRdfMGoRXa2avjUvnfxfaXx666	1
754	2vbeba7MreGbWUczbQ4sMfmj56zjaMYh8GXFEcRMmfk2pvTgM4vn	1
755	2vaJMis4x1naCKVGNjsfETxmGidtebNccvvYeWjuoZeRkUBCRZyh	1
756	2vbH56dZwumrRBnJZa88Bwq7f9hyDQD8183KpMwBFoJ468sSEDTX	1
757	2vbXyb6KP6M2XzL5upDbTGPQH2dSkEZMA8Vrjn9NxYYsbtowzV5L	1
758	2vbYnDMrV1wUkQq3jJU59xY1Bcu4ak6vV886NcZGUpWwPLM7YEM2	1
759	2vasERVdw3kajwmaJB4qQvrds4YkGkRHFegArUsAJMy7sWQUf2jr	1
760	2vaGAEK7SVLMzgTRnb4haVprJtk5pF1zAwbpV46gHX3Pj4snnHig	1
761	2vbm5bYZTNk4nK42hGjt7gDnRApPP8Jf8rPdBX4xLF6pdRWTfsNK	1
762	2vc2o4yGbhR7nDWgKz9BqFzjkW3orEVUhwK6T39fL4svuM7nHNPF	1
763	2vawGMTDN3tscJjLNd5fFKWtmsZD2X338vrJppWzFdF4wvf7yH4z	1
764	2vajBoPRZcBUgyH7wq6obf7vQAcsFD4BL73dQKnFAqhApeDbFV4j	1
765	2vavFnHf9XP4oPSHd89GzK74TMWVLYviAEhagYMeQT2XPYLdn5Z5	1
766	2vbDU642VapyPEuK5xER1x4RJefHu9PUg15nAfdNmev6TLtQRAKu	1
767	2vbQLLXXyiTZtoNRQANHcuMwZVY945b3rhDbnMQd7uYqPC2i7jr1	1
768	2vaS9eXMC3KsPdVryd9Csw6zcVEa59T5QvV8eX75xwvvXXcbvvBy	1
769	2vbXzJZdVk9aY964H91h6XU32QEfXKPBWqYJvRvj1e6s22VB6LQp	1
771	2vb9ANa6fJxK2NVkWQ8KF8uqpFb1WcpPzQyDz6PgHhgyDiBhMGey	1
772	2vbAh8ipwapK2UofrKp8gCwGVreV2MdMXmuA9yY5VRDXPHCGh3Ku	1
775	2vaYV9ghi8f6yBv2sBZmmPmLpkjBM9aVbY2mfvXNXhxDFDkTAjDh	1
777	2vbdXeibytt8rHuZ185baPDiCKG9yNH2c7qE9y8yLXA58W2kcQMU	1
778	2vb2Fa5KfvcX9Z2trKYMyFmTE3fsvyMfxYvfkEp64hQk5Q665Deb	1
783	2vaVdYNP4izEXXVNchXsfDRJ3dF9RSzxaWZEjRekZbn4PRwABYXz	1
786	2vb13JN1pzdAwNcityZiVfoL5e8Q7sn8HTEkEAWt7QQ8Zj5qg3RC	1
789	2vaQGCb6YHcJuta3Cps3zRPpeVethtiHzyHKq8VBWSi632itSS3r	1
792	2vbZ5WuAG79Pimp9BC6Cn1ZFq6TLATbfrpRfpBhkiHs5vhUx6djH	1
795	2vbWngN72YcyqLEWQsSi27n9fsYee7CmT2BrKZNmnXjSVUEk6nCF	1
799	2vbUnA59LeKatKaiEmchWmzSZn7cDuKEXcU8vjW2kWz6wQYejzv6	1
800	2vbqMwNbuWt6UykF3nrjKZALDt9gEUZBLfEww5brM91XzaVrvKvS	1
803	2vaY7BHT2qtF2aCVpowW7d95WHN5kAztJWAKUfQinmRvENwLLtQZ	1
804	2vbX3M4PH9fVbweRFDpYk2TB3a127Rt7znubU12cwGwiz318ZrAf	1
807	2vb2XfM3hXCpF67B6H7GKV1AFz4Bgn5XwcRttt2G3Wg751G41Urx	1
813	2vai2UWPz8nTpjmPG7yYRJgk22s8dimU41TD4nG6EDAaBi4KBEeq	1
770	2vahugD6MMj9CEMR7hyugwyyeju6QNjHhdVjtzF7JvCn6HcHaNHN	1
774	2vbY9ryzxtkGQWx82d4V7e7wJJXfehh3dF93ktDKAZrvi5ivUQ6n	1
779	2va9wv7ZEz4HEfjWrUF1UDMBQGvvXzrsojSAfes4jg3D5NRyiGp3	1
780	2vasyyzDuHPTKUSMcP5QytsPR57fpu3jWxWH3B3MuQMZsdKKR3Ut	1
781	2vaq14vCUwhn6ouvUW5DHGHnrtVtFPkq6fFijqFLiRfgW4CotBVc	1
785	2vaHPLsEutLkw4FNsbjQwgX9hn969FB4YngvBTBoTXn5n8Vnf4Np	1
788	2vbNfzJL8NveWLzHYkWFsx3CV5WQJiiQ1jvo7kAGN7APuKjQR1s3	1
791	2vbctChB4h4iiiXWnRnvQkAWbGGc7541XvWPbPaxSwwQkM9tv3s1	1
794	2vbWjngfX9KVu7NHb76UaAP5ihJ3k4XTZbb5Smta2GvRKmtHzg2D	1
797	2vad3C7rM2Z3BmjRSY4UsDtEzf4DzD5txZdJo4GYQdNGmM5wtnM5	1
798	2vam64czLHmcjCheh1hwDCX1GJT4FGDWNwrza1F7j4SWRoWqZHoH	1
801	2vad4kF2fU8kf2sXdDKf3MJZzpgiJM9G9oPqUmuooF7rnWxvsHeo	1
806	2vampVHno9PhhV5ybthGCdUZLDxHfyZ2WEKnKgeJZyeghGstjkb8	1
808	2vbdWfxwDNjX6VpdomhGbBGmq2Pp8RDemTT5hgyYK4isajy3WV81	1
810	2vaUtD4y9JgKRCpcBay4NeAeNVkNmJDpVVQdnyPc9utpSUMzqAtc	1
811	2vaALrRnoBCeVjWNeuBm9QN3B7GgpLeW2t8ca7voSBqpuwvNy1vg	1
814	2vbdYC7xouLBEFabmx4p81hZsoqzCcVyq8sasDp8KNfbFdJqzdiJ	1
773	2vaog5wsba6XuPHxsXj4HcBYwfLCkCHYoBPjAUh2tNnQp3uHuQ8p	1
776	2vahheugzxKdzfTu13SKWR3xGk9enYUtM7umg2ni69i1xHc4xhz9	1
782	2vabBe5V5TPtJAZaU7XvFUMgTBAY913J65X9m38oqr5b5CajgdLt	1
784	2vbMbuYHkoSMEBTRfBNcs83JVgndq2av5k9BkBr1gr4MxFTPpisR	1
787	2vbZpJu245P2zkw1cdg2Ukbht9TVRUrQixrhMsrDTXKjKUzooFkx	1
790	2vbq7c2kpnEGxykyshmhf2t5F4JpYW5BmDvizv9VUeGqxDhkwU1H	1
793	2vanQpKnC6z9jk5dfEry6U1GzZGFjmQbokisu2r3CkqPFV1TkbLq	1
796	2vbNBg6PEfCt6SuB6XbXb432vLoq9TojJuX4YMp891jcK41vu5dL	1
802	2vbdcwF8aR8Zw19BwG33wmLS59B3nrejrM935kw4ZoUJh7HdzJZx	1
805	2vavMT3EUg5c7r7Bqe9QS5HLomegQ7tUcvFhiHFSNRVHvJzYypCD	1
809	2vanr7RgV81VaFuLe1Q2wQfFMCBunJWgZd492LmhqGyZrYLGLmts	1
812	2vagHaJKN2CWhPFpwuDxHV2XG7j6EdASMi7UjggXeNm7Knx9VuSL	1
815	2vc2kgNRD6zTrAq1E92nJBV7JaApYe2eqUigo6TK9HQUViMwdAhe	1
816	2vaqST1TZPPmYV7ySKWsLhtpRH4KQrbn6mYM9d5BCNjbFk5393Ye	1
817	2vbSvaj7nRZp1EwddPPPrnfMttCKmYc9oyQDmPsgZSwacyvRf8HB	1
818	2vbZHbhdht7tBsgsvrdY4mjGph1hu7HyifYv9dBhFJMKbjpf9Zjs	1
819	2vbyuC9BWdL9EFHwnp9ShAdTUrewDeBqgzTjqGuWt7DEMAcghWHn	1
820	2vbiBnjSHxto8m76YGqyVjAvCjarP7YMsV4kagwNZnC863bbb4nw	1
821	2vb7tT3GQDCngt5bEQ6JQSPfJFfvZ2zWs4QdvgVVuMmyLyPV7FFf	1
822	2vaT3e5GMu81uUDDbTzzRVziUr6EzxiLYXmtnN7TCw7yhuEhp7yM	1
823	2vaUcCL6xK229DkaK3y5ABHJoXtuVYXfj18W5BZcGcT84JV4nedv	1
824	2vbaCBdc1JwVKAxvCyrJN3mP2xK2uPCvw3126xXdTco7L2V2LJ2r	1
825	2vaBE51JiaQznbqxyURR5XqFLuzQyFQJYm9rnPQ1AvNgqJ226quF	1
826	2vbHFfUrkzEs1k1ijpaZgz7PBHVjEuGkttbCMKRJMdbC146oUC1E	1
827	2vbLCXwPChxLakEFToa31Yw14hCCJMSe8Yz8FRMK3hb5X6kFvck5	1
828	2vbNkrLbYd89k9HuB2okERU9iw171epDWxBr46wGnw8w74B8EpRv	1
829	2vbrvuhZbxHctFbaJy9SS36zD19McUUhsDhkH3G7mQqzEpRttXc1	1
830	2vb8sPgUUx9wfUF3SaFePwPCkhvW6KHPpp92x7YVM5GGpL8ak9wb	1
831	2vaeDX4qgPWpJ4ck6ApqjKFkaLyYP4wAk8xFSRHTV5sLgiJY6WWX	1
832	2vbVont5nPbVfBEicCwujmabB1TAuBKmt4grCFwQzu8ZTkJPYHap	1
833	2vaeFg7SGap45xXJ8zSEan7dQXvPgyFCNz5hkT6cW6AaGne1yDH3	1
834	2vaZgLKputywGySqJRTPKKS96xePJYHNUBEVJGPBhKtuaK5KgCf9	1
835	2vadvH6bVSfj523NpiQKzQbD9ijSkBA1LribrcsX8kiijW4UhsPQ	1
836	2vbtZbceL2vtinnPRwuAAHF1vXwgWKraQbVkXLHwtQYJVm6b7Q1x	1
837	2vam7WeyM7nbx8zibxEEHQbRDoQ3SKcZxtsW4AxYqpszDEcKjhky	1
838	2vbv8tdXkdCZss2oX1qJec5BY33XNv1MPRfL76DZQZxeHqJpDNoD	1
839	2vbxuhGE4nRe4vf8G3J1ebsvRjNNxWX2xWoqRXyYwAkeFnh86awF	1
840	2vbAxGXKGgwT5NKYSXMGDrgQEhfyR8sX8Hsecejk7RH3YxAY8JxS	1
841	2vanvm5ceCcGbJRrKnSNc8yXaeD5UYAmNNBCKTH54noJB3qo6bMR	1
842	2vaZGiUJse94hmEqDkTY1x277BG6hXg9LpiM1f1WeyrKfjw4kqV4	1
843	2vbe6sYzvc8qHNpWeVBt3VCYVULLcnPJxyX1JkEfSEhQjfNohEdn	1
844	2vbKCMaDhjHg5Axr6Fhyqh8MrbmczSZToMefotwEzcBwm7uxdFFC	1
845	2va9WCsyArJZ1ZakoGY8vDcqdGMgCdCxyhVVakHydwqBCvh4sFWc	1
846	2vc1YdgFP1or6hDkgGuxYRScBpTqXvkiG6a5tMHizE4Evgj81vwW	1
847	2vbwWxKbpe6WZey98VubDVSPSNpKEuV9pWewRi1zAESUrhSjPhw2	1
848	2vaTD9VcK6XmvJWFbG6uoTHazza6tk9rZpR4UMgzHxAezZLpGr4y	1
849	2vaJEU2En22eRoSJ8YZHLQ489jvjRwPCCexhygobaQSFYnzVMVja	1
850	2vbiHpdEj6FqdqDQU41uBHLW3Skcqpxwe57YKKMkz1CF7dSXThQw	1
851	2vbW46K2qFPspnhAowSM4G724P3nbZTMRWTtt8i4DNKsvGXXJuLi	1
852	2vadc3KgyFwxjTGRMWJSo9Js9iSJ1uvt6iCvUkhoVHmQmGivSTxi	1
853	2va9YEPWQGBMB7sEmoBJuVyFzrHpPDGDWHzNFdrLyTNr35KPKuzt	1
854	2vbwAqmBeNwCm9P4FNxUhmoEHKeXf1zJt4175Gdj8RVk4ybtsW6g	1
855	2vaHHwLEfcZdZ1BSy5m4ZwzbDnZ5Wsx2kmFpZVj7nk12Kj75rYwf	1
856	2vbQoY4Nap2T88cFbp4cphUZEEi4kKjvUcSDp9xcDyxDzoUSv7nx	1
857	2vaerrRMU1pUg4Rj1SqXRceyvpTvQC6j6oQNjo2S56Ejbf6BsUSa	1
858	2vavHxKGjJboZDBt7gpv8mYzmL4Pos4Kw7K27iDNhBxKeq42UQTY	1
859	2vc4hHyoKMGo5YmagTLjmioa7UXckqx5TrJd5pn5aCBAZ7eh7okm	1
860	2vayCTR9cNiE6oz1PEw9CVTsQQAovjzGxNKkW2pQ6P9KzU8rBBhD	1
861	2vahh9GwXwyaRi4PD1iCsCKATTY6YV7YKyGKER6vjDmC4XELvVrs	1
862	2vbsj8dLjLjBPktUZSugVRC5wsfpXv7U4oukWqy7TQTmWAKEzS28	1
863	2vbevTCrJsQBAZU1DELe6VMH3R7htfE5EiqGRPRYir4Dji2jtL12	1
864	2vagR2ruz7Nq6U6mg9aC26iRBdYRbCLJckLhgGvQg1SaQRvgQYCu	1
865	2vbFQ88ZuuyELx3tZVd75goExJh6EEangefvbAyqukG35FoYMugM	1
866	2vatMV2447pdHqbdAy8Q6YNa7szn1abCw6m1PYuzWSfZfZdnhqZd	1
867	2vbsWQRQByYCqTFdAYPrsEGhzrSB3JyCFK6JH9F6B2HtvGcgkHzF	1
868	2vab82nate27krxr9AfLfRckNeL51bHMc5Zy697mpe4nFfAcwgMF	1
869	2vb5fVEKuNiXvCXH4rtDXipJu57mVNvfpTqoAu9bMEBnAddNAWjF	1
870	2vaU2fvX5H43UkBSa328TgrimdMRaNmiN4jDTjmo7pxGcrAkYHLN	1
871	2vb9QuyodERdsGsjKCSBGAJimNTFd12zGtjpDpXtaU9YawAqzkpV	1
872	2vaRf5gNcXnCabmWyskwPbSoE3HpEGSVAuTM75QyQRF6iULRZX7u	1
873	2vbWRmEghV3NXyZDs5HhAh3x3i8vMMa76zLQNn3a5UzhJDDN3uPv	1
874	2vbgVoNCj64T6TH34rUNH1YHoi8RkN6wPgLBvfJ7XQ2KQhmzxLWR	1
875	2vaaVFrZCuURD2bRzk7qcs3ZPr2mpsqQb4NoiwfVq1CodPm2H3C3	1
876	2vbCDZK32ksjt1fqQKqioq6WBXrRWg4ZFcEBck9fEXdeUwofAGsL	1
877	2vaToZxdiPwmgu7uvor9gw3FjRUtQTVGW6oH1MJuYEtqRjhGmg3N	1
878	2vbXLeo1GgmMxwZMVJjMXrZL6mwmip5xwbptfDnRRW5vhaLUcn8A	1
879	2vbjRfswd9acu97EEMkPRSFT414g38Z9bwxQpNjFKNr9hvKJTEop	1
880	2vbB34tPCxhbu3xWCEpJAk8UXsuXV6Yer9a3W4TFZAXkSwnNSWLw	1
881	2vbAdeRFrZGQnf5x2Y3mpqFYt1KmfCSdC5ntnvaKqJLYdx4M3X7C	1
882	2vaL424aFRFg8x1wvSBn19bFWgYXU8ZWvYJqyFj3nbnnNURFrA31	1
883	2vb8abFsMwVVfNe1FrZwLXhgxxvf8qF4yh1A6PfjSj4EhZ6Gsbco	1
884	2vbpfdw2kAmgpqhUb3A6vhNFby1ntwhyPTEtiWZvum8T7GKgTxs2	1
885	2vai3vPMp6FfC7q8cHg3JQUvtHmsYcjDzrFruSL1VgyWGcHtLDGK	1
886	2vbxdedKhYingEmxbQoXhPnhsXsCdz8JLnpzyGbcdGktTYe7tPxV	1
887	2vbMMfX1QSDJCr7qXMvinozEgQyJK56E99ZfQaN49ozovRMVx24q	1
888	2vb7J9WRJwP7Qkb2jmyBdCY89axCDsSMvSmdaGkdTN54c6V3kATu	1
889	2vbiHwegMSJRNZaq6fNdFS7JGNjJgEwbiXbDgTtFpFjHBVn1EWqN	1
890	2vbvEQzqDH12cBWbj98MyNVkFsBghsuKazzWK2DoN39FNYwASAaT	1
891	2vbEJHAVLoJTNh5wkMT2GYqfMWsX7pZy2KhwHiCvCPnHQS5YJAnF	1
895	2vbdhw4DpufzQps9ed1wi1gSeeKQnTeRqxs22kvA23Ft7ccqaFK2	1
898	2vb85By2BnZtJ6T7RvqsVuTDq4Kk3LXR27k5eYCSAZAeeRCtZYve	1
901	2vak4oWWBhXNUqL4SsXeDkfhiwDNZuCL6UCKsmZFgR3i5fiq5GMz	1
903	2vaAgmPQjA2uW5ZscPwvUyBPSqimZN13xsKeff3WpCyxGqhucdHa	1
907	2vaqThf5SzRTqnWEU3uUwM5THTDNKcbk7JTDxvDVKV7sLUQEMDF3	1
910	2vaQtYiwjW2MAKBdADDh1fEuYrHNTL33WVsv87BMGBZ9j5rNKLZp	1
913	2vaLB6dhcwryHqZwsHRiP3MBGS42cLdhyUTR8hmKLQffHkAKs6s7	1
916	2vbe8gxsavVhbEuMvXg6o8bEJjHy2djBWjRZpEZTwwog5kdHoHyE	1
918	2vbH7dLnGwLgF4QTwVqxVkZYM7wTD4WSzsFWRf1suu8vYSmAkwfc	1
920	2vakga1Frtd3shHmwxYvprBAEA4SxC8YA7QzphP2M3P9T2827qnf	1
922	2vbra1tEKpobWqBo1pTeqsPCd1tLf3XSKCWkixip6i8tdtBtAyhD	1
925	2vayKuRjogqTgYkQpxSJKUbjFXw4AajfaT3xd8x7HnEWzj4F59Xn	1
928	2vbxto37n8iQyRaynsu7dnn9FrtYzfkxnotecrYPzzryHsWyRZff	1
931	2vbgCCWbVMxuXfumD1GDz9idz9dFwheSs4TPmN9PSyAV4HGj7eL8	1
936	2vbxNPfkzSum7qBpPiXBnLCLHZ53pDHGPpdEfh98pWLRCcUBeK9R	1
943	2vc5LCU1qptqwyPGdo6bRSVEpk2VrXAdx13i5kWBQze2giCgvw3H	1
946	2vafa7JGpYDmK4mjKB1cftNQoMusDy2WYL3fLdqsoELVAmBrmE1P	1
892	2vbNNC76BRxD9Umc6qjyAQXvAAGtbyLRXJU7FKVFDqEAoPE3Fzks	1
894	2vaPc7wADKqrUjYWLPRMBAhZdC8GLh7v2HUWZEQe9nbkrwxCJ94T	1
897	2vayWKou8augXCn7P9RVw7nzKp4cLtXS3sFTpYCcu6nXxGDwsFir	1
900	2vbQSFUUToJuH749uGVdDjMXfa9fbsc7PPcrc8zSLbBhyW6efNB7	1
906	2vaTPJ3FxZCNiYUGHeFhbG6eAkYqMwajhny1sEBevQgYybSey4Ps	1
911	2vb9vaRmNVMcYuQcNZBjwN9p43yKuVDQV2vTf3bN5Ds2vuxLqfFW	1
914	2vb6pdx532mR9LqWvw5gn7RzcZPZM8GxDkD9Qrt4wpMBaY7iQJD2	1
915	2vaZzpLJeY8Q1FQnrMfrQ4fD96kGNVQafmzQ6bXExfYEf6eoYBKi	1
917	2vb43bdDBLV4Q6oD7ouVjaH3jwrjEtv9mXmZviUAD5E6Sa2CbotT	1
919	2vbFyMHSnjhzpciCSjD8DTz6cTm9tJ5NTtMptgZ7crgw4Sr2eghW	1
923	2vbV3wUU9ndkHq9MUFZLvSC6C1TJVDpwYTad6CotwTu6QeYmRFWB	1
926	2vbCpmQ8a7WAzUCLSoy4JuctyuocHo44L7HtRkcvdsiJnBrUtsNn	1
929	2vbcCQCsbq9QoXUvU49m63qBqNqYhRLinNzi4R1ghxnoejS3NWPe	1
932	2vasQk9UCffYH3n69k14qhsiMko9ZhoXg1psdcvw3ofaSrPL6A1d	1
935	2vbJgM2z5WX5x1t2CtEBztxfML3TBV1wyWaagXX2c6KPydYCkRDb	1
939	2vbeKNxiufP9vCvgiePhothVm6p6u914E7RCAbpuGoSBouRa8ipz	1
940	2vaxT1FsY2xN1xwnnNdhSerpKp5seBeTJg3SMkaLrvGQSnfjcQKz	1
941	2vaMX4JEwqLZSwJA84iPgFGupT7JbXCwCeF6SkphC5v8U2Gi9CMT	1
944	2vbJWs3uCRhyPatFCvegM5AyvSF2gunezT5KnaUDiQFMWAqJqSyU	1
893	2vawqrn7eobXimHP4WkbemnhuB8vhYw9BZ1exzj5WJNVzN6X9AQW	1
896	2var1fYWdYmnooebBUuuDVKk7t9HiiyJm6Gj1UmtR3nG28mzc8C8	1
899	2vb1e6MtfTouVWuVCyy7BsYuSGpu3imggaNLfrVfGULKuRsko7gp	1
902	2vbTwDu84cQab1A1AvwDBgFvomjS7P345bJyF7u7wtSQceQCyC86	1
904	2vbvcswjnLUnEZhPhecC4FEQDgFHMNiEgiU3JDkBUtyN47DrxriK	1
905	2vbi5KVCmEGmuAnCcR892UfGy3VwRExpWWiN456abcB2sX4JRoup	1
908	2vbZCRKmvL27prZz197jBY3npwVGCMYeeaCL8kF9KL4aYZaHPteC	1
909	2vbSuu9oUoFQMVgsxAbvCMFQya9kTBC8EP4AXgxzEvaj3ftVQ5Yx	1
912	2vbpJFQXGTgWsbyWyfjnjyy9eoo3W66nSdn5dKQUQAbL4zaEj4gW	1
921	2vbnsKui1b5htLLnLVRDZfnik3xkLrzmLfjcMvxMYjsTx9VKJ2jN	1
924	2vb93vfwAooCBUGQ5nVGf6DzUWaMYVafpgcDEyXaWjcrMtotusYP	1
927	2vb5YP8GwqHH14ihLTSadQPrnZ8UfktgK8JcoGMH5WCBaJVppjiM	1
930	2vaXGmiHfvLeyAvp2wPX8cZdWAKGY4ePg1vARugm8nGonzoqY9tb	1
933	2vaRZaFmERdX6oX9jDbv8XeE4hJ5kDqpiXM6NnMLV6eumGLfYM36	1
934	2vbxqjrvdc5SCHvJ9d7UzMhAZCBK46BiceVcAB4Lsfso36uFFNxG	1
937	2vaw2XrfvCbH41bnTY2vVew4QgU7675EfKtYGjWE4zHwmyLGWSsp	1
938	2vbj8x6Q8JM9pEahCA7WbqET4onCP5ya5HYqcAgjVtLfGv7EHbec	1
942	2vayZjWaJJKNggusWsND7KLi5K97GcXxPaZj7XNHkNmDhdVFk2uf	1
945	2vbC9S8z5LKWNY5wXPphQqDJWk15vnaH5UMf7fa4cs84B8XrzrBg	1
947	2vaY2Nbnig9hHDiUNteW9gsMJQ3FS16ADGtxsQ4T7sWTnxvFjTfr	1
948	2vaHPgh2iS5QnmyrVdLUr6a6ipgQ3UNi3psA9CapE7zpFhSqkVQp	1
949	2vaVAP4Bx3Nq6XKjNBMvNC1vFqXDVdT8e5qrkVeNTTWRz3RX2PcM	1
950	2vaP1vggZryMtMSDpK36adYLSXwa29mGkzmPbadLKrPdkgbL5qL9	1
951	2vbF8D41ikjY9rELCWgnTsBPcFA6z3jMA2RDWJBrEGV1EUvEkHn3	1
952	2vbtixHu3sCixoaNvxzU8S6Nre8uRDQRRj8hvhXLZ9refYDrX8fu	1
953	2vaihaVtjo6ReN2ZvtqaLe61q69PBfTAuM3oUPkYsybn3MxZj6BA	1
954	2vc5gAGNLaDg33YUvhQC7o8KWdHXaogigzLhNkgAHMKBJe9KufVQ	1
955	2vbbVTewGc1bLJpQvJBJRya5YLx1owtUocgQKdSRdP7UavkxaQkt	1
956	2vaBXKUp34SSi6p96jefTwTvTsJAGbjsvbzUcqEKxChFsVKGmcCb	1
957	2vbw35772Fmc63MajimhmrYi1H53CEFnfSz3kejhHTgs3sPaS9KU	1
958	2vbDeZmoGhG9MWDyrtGn25RXpeagN9eZrpQybNaWPKgVLweLona3	1
959	2vaPhAtF2Dxe1HYAN3MPsHLdAymgNWZw2d1QKf6yNrv5RnCdz4jT	1
960	2vaP9WskxdvdvuJeGcfiYLCcHL8Y6YZ43CYgYDqYVASvYNfA5s6j	1
961	2vaiyesEAXxg5LPVGQQ2Cjw1kypReHN1jWjN13KFrWR35w8Yaz3T	1
962	2vbckENfgNK14nuZdcy4oqVkAMUhXeaDBud1LGvQnpqBzdCMscAK	1
963	2vaMZcLoDY6HZdiWrTuYBeoC5zVVrDBCp9fc6uSjEcfC5uhax6sh	1
964	2vbyyPPrwkhpx1xe2J4PEKUsJj9qg9spMXC9Uzzf89fJJmXCdmBU	1
965	2vafxP5cshRrAH7unJhFd2EXBrDZtBPobRvaZge98EJ9tmmmneYY	1
966	2vbT6dWHb9HLjhjX5AFGYNJmSDMshDyAn368SJQfQ3pand6YvMzB	1
967	2vbBQJEp1fSY6gWk6sCKW2Kvk8tuuRC6mgug754Qk1pGtWvGYpng	1
968	2vbPgTVQ4r22ccEUo2RtQLRQu6ivwpPa58nCVXBj5KwSBWVhyHB6	1
969	2vbak6Ydq7vuNEcLbRgY6aCaHQsiqXYWvrZiiBndUAAfCchfdYSP	1
970	2vb4VjN5VhKhh28UEJETqNMP8PD8fxupAJFC5o8obdkFezK9GXpa	1
971	2vav5tfePNxPZ3WFqeoBE36zEjJ2ifWuRKQ6AhmLYWUHBY4zZYRu	1
972	2vbxDfLkVyhfzZsj7STduqYwU91ukTz7Yd1A7b2UB1XJatddd3be	1
973	2vbmpPTBqYJ5YfQGp9Gx1YNHkgEJitPvvyDcd9VkKYrir2wxb1r8	1
974	2vc3sNN2MWUzAsdL8K2iVfLCerUGmRHP7stfpAGrXDsA1aYchrET	1
975	2vajtNwDoLQbQMGSu8nmG1hBp961tGgEFBhtRwx14Qcj26p9be3o	1
976	2vannyQGT1BPRaUEgXPzcgzMVnmEMNGVMLCB8hCxMtb6ruSbpAg2	1
977	2vbVN1ib3Uy7rv3dFbSRbtfmPNjZ5qcu31PfEDbtnz4sJEvUbcqK	1
978	2vaF52taUzh2bd5szo8zUF2HUidcDcgyxXc3JgQgWtEAhyoXtpAF	1
979	2vaNemT5XFb8vrQJETmEGojvRcAnh5jSFe7gM6VFkimKvixEKqab	1
980	2vbz1MsEmq43CWHbYvy7AADpfverSA4r6af8jsQoLJ79NY4Bw7Rm	1
981	2vaAfjJJmBYdVf9rbTV2ZczuWqEi6vFs7oHYCmms2F6vhSzdUN12	1
982	2vbV2pJAgQTKwgat8LD2tEAQUgnhP9j8RFfdZsj5kKCG4gtVmQmr	1
983	2vaY1gRh9FrPK6Uhw1p748hLroAfcRW2a1HrvuHgYqxf8fNaQPRR	1
984	2vaH9ZwNxUTtHCSBYknqyRFSutqUsAHsHCQdtZ5ewiURvrmuGe2T	1
985	2vadzgTEUoEYti1pWNEtHzCcqDJJxxBK3ZQ6nM85L8pTg6ZqmAJZ	1
986	2vayRshVssNawpiF248xBMGLTLG73uS3VfUU6xr7wzaGf11jVjR1	1
987	2vaopLvBinjQufJDHHcwPE3SuwFEUjGvDs8TJD4hGnVbVGTWjzLa	1
988	2vbzz4iBY6k3bwPnsi1Yv6Dmdq4WtfkqPLycxXkf1X6xvtWRELTU	1
989	2vbaLqtDQ5wv7AUAmWx9cK9LCkFX1pwJD8of2uVQ1by8NcuQNENp	1
990	2vbV1Cy6hnjZ2tHjEoZ8TrprjBsN4ryfgNHSUPjrR7tMoRXJkq2c	1
991	2vaRdTaKe68ZbR68BLJDi65wPZuYHE4QdXtTPZHRLzAY1j1KYwWg	1
992	2vb8rhjXbsPXDKRrV1nub9yvSV8wCn87766PNCK3zRa2zuWe2i3K	1
993	2vb6gig43v3P5e2sKXbC3y25x27GpU1PZvfUtbh8ikQFZwNzJxri	1
994	2vaMF18bRTWa7RsZcwvxj7rmrijYME19wq7Ah66Q4yKrtig4if6N	1
995	2vbB97snqjTdoFqtQNte1wetk3KWLx281LnSbf88pCiKRqtGPo9u	1
996	2vbgeeZrgzp7UXHqjJYWcfkQJ6dtHdTT5SEZjVYox88nvFMhL1DT	1
997	2vc3YTvTWkDkJQufWtHhXt1u1UGjcBEjMuG4mFvhXEGrDkrD8Pgj	1
998	2vaiw1MVMSDtzwkSRXCGDTaCCcfNPnF1x2wsijHGryRz7Qmg3vF6	1
999	2vb3i65BAZ97kGN6hLLFZyWQSVcU6sQriYfHWLKLZ2bdZLMDjZt5	1
1000	2vbze4emfnmBr7ky1yabcnNjH5ePqGWwyVnoiFo7BhcKtuktdfwy	1
1001	2vaHds1cUEazjppDgoJMnHUfqfG52MSMvqnCPM5Ah48L5asbTJzV	1
1002	2vaks6wAVURdH2B5KWFJCCnQvQc4v8DSQarXPNSVAtdxXGnGgpGA	1
1003	2vasSaegduvd5Kb3GMqZfsbigFsd2qK8J6QE6JaMEVefWD5yZNcZ	1
1004	2vbpxyjpVfvdun2THk6eDNkAEAzje3nEXYxUWrej5Pf7FTDksCUJ	1
1005	2vajai6N6vgx3Q8Fk4M7f7qMHVmQbK523C7EWc9BYrdSeCLrjscd	1
1006	2vaEp7i91FVLNidUpcPRcd7WxJGJbboHEN8zUyCrPnnRsEK3aHyK	1
1007	2vc1FsoHZFKMAp2g1i26JyP5g6Pg8Yv4uih1tAChBsQuRSahT2y4	1
1008	2vaGQbS7TMBtWYwzSMFbvqvVjLx1swSrsAgceWZucir14VjRavU8	1
1009	2vautTw4kT6rvC1QB2hJRrsqMqt2cFisohNt2eDMiiT9PARB8eac	1
1010	2vc2K51r1vd9mHQfvB726oKibaeq2Eh2JZkfzuL7xnVsvCPvKJnn	1
1011	2vbzzibnW63k7JWLE6jbmt4dSJ6e3jNBdwYW46w1w6TbqTA7tC6W	1
1012	2vbA6VtKC32QDK55RchfGFHuYxyNNkmBfVdYrdRdgEdZdCQfimbw	1
1013	2vbK9KnC31CxffL3XZvwGvBQQRRzP1uu8KsgzxNFSyzD6DmFxxrV	1
1014	2vbZ8RoPULcqq4jJUEjcH7usmnPqVXN5nAAoXBuYGd3D7Gu9ivB2	1
1015	2vaaPwaDfznhuBnGczxKwoMvJyGKFwm5wQzwKsM2p12ErxrsD2mQ	1
1016	2vbSjXkmRbfYy6hom6nAUMQrPYQro3EUBE5pvTxwtDXV53Ly5t64	1
1019	2vbdCKxpMGP7gWCLAhdAGYFdKUMgSS3itzeAMrvGZNSu8MH4HVPL	1
1020	2vbE1KupFbVPHF9F6gC6SXkvdGxY1RR1yoM7XzhGH2MXZQkzhYoU	1
1025	2vbDNM7VShVvGmhKRqZdggQ77RaZxYqYbmJFxGjuoFzFH2ejzSff	1
1030	2vafrP3uJ3TN1f2E8CHc1EJocCF4CVn6Zzy6G9ZMNwxUixioaeMF	1
1033	2vb6YUBudAgLo8bhfu7i7Le3BYjqJwAF6xPjQMdtvpdqkoY2RrnK	1
1036	2vaXH3vg5h4ARqgqT5D1yJuLEsVJfhUFENLDiEkDyJPbEfiQWSKB	1
1039	2vbxqJ9ozdC9v5vkvjfRdPRv3VywYAUXDSYvifhbsXN6m6U78uDF	1
1042	2vang4QKSPCSyaJKaUW218U6mNbkk6cLrpCMmon7bXCvXnwEGgpc	1
1045	2vaKHKURY7g5KZqXvaFmKREZAgioXW737MzDst89NMP6ANSeo7pu	1
1055	2vbPEyQcv1DkuE7pTXBantKNsxk9hGMrL2MG5Qads6cTQmrtGmZn	1
1058	2vaLY1ku29nQpSok2FghFiDNo5gyFuaHSyurQZhtgpwsedGWnL8X	1
1061	2vaewNVH2vN6mmjtwKRrdr87g2YWdgPzrL6tzY8V8sgfwB5prXBt	1
1064	2vaVJBfue2pS6WFP1YQ1DYgPdntekmWLnCJJ2NV79y4N71r2fabk	1
1067	2vc3Pg3XwjeQpMCftVZmGvo4NdG8hCr4HKCpUhp33GFLAo8KK7RL	1
1069	2vanvqkBL5n2EHvqdSFRkge1AKku7xFXVvHkzUNxu7aM97KB98U8	1
1073	2vbz3qiXJNwSeVHCGizQPqgSgbNwRjcxtLNPrB8gWV2wTwj33Kx8	1
1074	2vaTTKfJJXoQziUvwwXwuviaX3bbcadP5BAuH4StY2UHwhcwHH11	1
1080	2vawQ1AbYQxWCJq1D7FfME9ghgBnwzEtgx2kC4s984uA2r9SjKZb	1
1083	2vbLT6vZ3bE1g35VjPVRrcxG1FJJE9xsFJ6npaFDevLWuh7AQAUP	1
1086	2vbRAUbGXMPeq2Z2Jh9S8XorueptKCQyY4Qsv8qDrXgx1qefz1Kn	1
1089	2vaEyDZgyGiHVZTQqmPx1K4zqtSw3PzVQ9TkpfZDxv9ZMVHEojcL	1
1017	2vc3Yc4mTHRZ3krvNKDaXNXXehcKRfWRQTuzQgjL22Qq1JafRWnd	1
1021	2vbwGKY3Z875Vs8DWDrFoQdu6obLyrARdRT1PRSLrSqqDU8pQBSv	1
1022	2vam2FaZBNyd9K1gZnTPiND36RPHjzjq5NQwRZDRbQMEwV2A1TMY	1
1023	2vbFnop2bMCvrFWGMx7DXBoYZEU69zBAdzskNt3ZTGi4oMeXSCx3	1
1026	2vamtbr42C5um69UUTG7UKquPFBef62fRwSu63yBv4zKizqsQVwT	1
1029	2vb89gD3ZebaKpnPC56WavYtzAR72wYUY3RHyHsNq4vZ6yBi4ci5	1
1032	2vaUyhxkxsaAGg5YNZwyH2VZBP1DuJ1P1oyeMGboUzz2xkDgfCgQ	1
1035	2vbQLJVxudxDCtEZwLgipYHs7TE3jjV3mtFA9tr9KgmFcP8VhMie	1
1037	2vau8M6inv2btGxsRv9yZHG5a3kWUXSpapM1tVX46pNiaBzi3S7u	1
1040	2vbXghY9hG9B5s62qx1hVJS6TP1KK8ooZ7zwTzVF3LX4p6n6Jwdm	1
1043	2vazmmL7ZaKC81xxX8SHFLCAe15B6qbZe3TgKrndspHx5gBpo3xK	1
1046	2vb5DtR3StnzxPkkXkEvk9rPAdApfW9p8yP9nDf3y9h1yp13SE35	1
1048	2vaJYgiYG2bFSduaYanWNfVBgQa469bwxAYnYsLHGw9YNYcAg2dC	1
1049	2va9fbZwfyjJEEPgq7odmyzWhWUtijqZ2zPGaV4AihFpviGonvU2	1
1051	2vbGNQjZXWFdhkzc8dJshGwp9rQpKMZ5s8Js4tD1zYUGKiKHWAK7	1
1056	2vbjWX4qDqaGN15p6tJPePSRxMZ8Q6LuiahSnVbCYfC8xUturoPC	1
1059	2vc3SW9AAxizZv5UR9kdgWNRfTb6hyt9QjHYLXwDZwhpTAiE2sp3	1
1062	2vaSciEdriuryRiJPVkyaPPEWxL5rKeHYarXR8nrUg49yU9zn526	1
1065	2vatdZzcdEw5dbioLYoq7Y5s2YbG98DNDYGzzw4utdz1YRM4GLRg	1
1068	2vc2tpdBdqfxYJaigsKdv8HsHXte1xyLhosE2GXhn3CESbiWRthX	1
1071	2vaeRDnj3BNi94FNUxQHMpREchwq9X3xzbuNLgV1Bi78bfjZmyBS	1
1072	2vaiswnzgJmbd6QEsysELv4JswTtsVs4RKLdtWjrNGLLr9TgrLZP	1
1075	2vatpWnZAWfpzoqHcaDEGvGfuAEtoLn4rKWEH1cZQwrH3NVe9uwh	1
1077	2vaPyeW6wKEEJjfZ8VUSsVAxxrAW7GMzJopuTGZsB5ZUfCEuTUiw	1
1082	2vaEUodRFzuEQZLE964eFQPc1oiRaxmyhmvj1TUd7nbFgaEB7FUf	1
1085	2vbj5XZfN6EvD78DdZFsuesS1VmGbTKBvrJtQpNuESgBA8aUCbw6	1
1090	2vayjMsaQKW67W9S7YQ8KtNVn57LNZZnUHXYwwmqrDSy11KzEzXp	1
1018	2vaXwzKsiWko2FQDbTBVMAjbgw4hKb1NH4vr7bkkjmuCrqnm3cEm	1
1024	2vay7GUzLK4xjTLMpmn73MkLFwnaeFiAmKUhP9en5VgGNMmksrWt	1
1027	2vbyiUkvFL2QZfwrXAWaGqZVhhK9QQnFZAAYAR94JTwjmVjKUEmP	1
1028	2vbq1g9do6yfsLaEeoNHumq8roxa62u38TH6qaDLdWpF3nyDGzHj	1
1031	2vb4VykL3rezcRp9scWMbxQsfoF3vNtfQ16wkt2x3qF9zkZsgMka	1
1034	2vb4EW4tmR2ZhrA6H1uDRiFkW7ZYYv5EJs9DFvZXM7KqDzBwMGNr	1
1038	2vb5yz9FAST5J1UZaGvuJ2D4hjeFyUt9pVb3WH8Skxn1BxhJB9NF	1
1041	2vbmwvMh9BrUoYKJFC9ZN558g7NGe52PXGFTYkRPHX2XBzJT2fNC	1
1044	2vc3TZzNAwz14XAQ2xPjFTAwkwqg7DtY7kBAWNAUPwnukRVLiGLa	1
1047	2vbNcAeiR6pD2VwUkUNmFLEyVyottTotwEZWN9Vq7jE9VfW3yrLq	1
1050	2vc13AdtQiGLyMtyiYzMZZiTbt36HbebFxN6TycCayV9AVGuMHCy	1
1052	2vbc2D2RLt4PiGUJB3SLkT63y4LEhSyZqT5oGBVAvHkVcoUzLCQb	1
1053	2vaRfKEKgET9ZjVXy1qNVvRtZSV2YxQJaVCa78bfM7RABm3mzJSm	1
1054	2vaEL6J518Lz3dA4HQAF4V2Z2VmMmBN3rpZuQaXj1akmV5m4Vjwj	1
1057	2vayyqrZ1wztjkUAVcwt9EXFzGSzFbtJGQPZ41XU4zjCb2LfaHvw	1
1060	2vagf4o2FfhHQQEDg6gvuQMyg48s1yrcEUTYACT4QWy48oGztwAK	1
1063	2vbU3P5yC1cRvjeMQQ43pk3CJouAh3jjkW4mHoaEvc37gBA2mXMK	1
1066	2vaHEMWM5snVsTmnNYAMoYvpDWo3eVMmbxMfhK4gB3aGmzFY6Zd3	1
1070	2vc1REd6TpktpYjRyFakAN58hQM2pSKXKXBPtiiZM163PsgzDy3t	1
1076	2vbC1EC1VG9jn4Q9SBiiVpPWWBaX5JxzRgXPcG6MnVQVtiLctF4P	1
1078	2vaEvRzJdtpwPwEqx2b3QqnCctXzFCf43F7yhJQd7DVSkzT7awGv	1
1079	2vaq3kuMEH1THmN6QgcdRdqr8FDu2afJLMLQo4keUQu9TidSQd8T	1
1081	2vayoRJ9TtCLtqSQVDi12i7H4VMaTQ5qiX3C2L85EE7dAUguxhtg	1
1084	2vaybR2M2cCjQRU9yFoLNJAcrMHbe1Mijf6iipUrrWUBMo9pkWfQ	1
1087	2vayVxYohVXp11PE5S3hra2LUVegBbv3odcNuvQTfiZujzB6AU4r	1
1088	2vauiHV8EvUpDNBbb1ZhWacm3UFn6yt84wHCDsa7fGDFEhzTWAw9	1
1091	2vbFG1Y4Brm2vfobsmCaftQzhRoJBv1EQ8ugPK8gVjAKwFg6xbc9	1
1092	2vaEgb2KwxkH7haWYo9Ac5f7yXbXv9Yx9nCcBtNA9W9FozYf3hKg	1
1093	2vaf11saWahmwT2Whp7SmqEwBJfC9bQcWXCvLSnpSCU2A1ZBVSiM	1
1094	2vb1FCEf1psp8yoV4sX8tVv2fWdHfoj6HcUS3exwdiJgmH4igpMA	1
1095	2vby8HhBrU8H99WcfSSkA9FszzJirSm49XN7MWzvNmMeCbB3LFTg	1
1096	2vaat1ypwRn9e2Pra26tReb1RbAm5hwthstECmDjppCHtGVsvRma	1
1097	2vbGxao3d7WMCGza525urABhitfgbGTXEq6rbikziji5hMbt8g1q	1
1098	2vax4cGdaWWnDdXzetxYKok3JYCT42ri1TVJYsqTCpihNpkXPS2E	1
1099	2vaevmMwfZqNr8j2zGpbrg3crG8LGb27HqwDitZtBrTnHUjgf9dx	1
1100	2vbHBzDkhB9B5H9J1iRRrdiWBrMne2QwgVViQ1vNnwFQgVhJkp76	1
1101	2vaYG5U11i56f8hVEonjN2EuMNqj1wNsYjG124CXX6KzeCibsZwv	1
1102	2vaog1aLPvYizRw2yVQs7Cb711VBmMniWB24YbpBDkBc9RyZEMqs	1
1103	2vaHj7h9EFdL3iFBBp1R5depZCyowBQoKDyYXacEfAguFmrsneaS	1
1104	2vbpC1ACY8HGWa18ocPSuqVM1puMSEy2ofChbBKHVSAZJ5HjJiHz	1
1105	2vbJ8568aw8dvQ3yvTxhp8HKCPgayzCWjaSDAxUiSKXsUUyLEupr	1
1106	2vbm4oFqMTx8igk4kQcjzh4dUSHY7LYWTfxNeTr6pVrxhCJBXLHp	1
1107	2vbveEQtzZjfpiAHRgeoatJNpqCUVFA2vNDe4rLYDP3qjC7R3h9B	1
1108	2vboeVcgkdh4VhxRhmUDPGfHLkH91a7mHJYhBvowcr6GCH9q99vN	1
1109	2vbvZKLdsoq3kW4B4zGc1PEiYPmXes47VQJovTcfT8i2tevPxA6F	1
1110	2vbbYYLrtTbko1Uh3TdAeY2UQoUD12brLDPzHAe3cdCudpb7hbTg	1
1111	2vbjo43mNhRXjRUiuREhAuDqwCM59Bajei3SwjeLpcK2UKUuGVAB	1
1112	2vaqXF1gN6SMuKJEKxgVbkeA64NHE97nqhHz7tLeMK3A9hgK56iy	1
1113	2vbFTLMZjZ8Dg9y5jabT6gixyRJiYGPeS7kbN3Qi57YqAggFE8jB	1
1114	2vbGKVoeyDATU3gSccLCpfNpp2anGtLuupntzG6MuhNa5iDWZBrD	1
1115	2vbuxGvFxbic44Vt2jHr3QLpq2jffWhFgMo34jgkqV9Cm92P24BB	1
1116	2vaT87MBYoaHjvsYDwoWWw67quG3ZvxC7iiFJn7VHETHnLHdSLjd	1
1117	2vama5WrDA1Rnrcf4WpDeMe36Lu2DZDeGxdajgCGTZYyXhF9yo4U	1
1118	2vaRfhTR4SYujTWUBnLEc8bz1NybJGphoRnMM7WrYvouaxQeN3DT	1
1119	2vbqGgVHZHipY3GJBgmrWk5jawpbMJST91qoYmmHq6h24F7BTj5d	1
1120	2vae58RkFbULdpSj8Lj9QAejQRPwJBKVyMtpDMZGv3mLet7qFEhV	1
1121	2vaRfCYfjNqggpLoJFeigsmn23FRsUecLfZ9MJmzpK62F78fNxLd	1
1122	2vapxVughvATRnxHKhxgAGgKLaUyBN94L4YYubDn9x7FLg1zC9dR	1
1123	2vavpruLkE8yDRxeoSD6DqCVQRsK6sdDAeSv41kdrBWMu9C4WUXT	1
1124	2vbXoSUNEp7eFqQ2eJxJUNNpwSWfxEkhxHJZhwx9MhbYH7aW8Wtq	1
1125	2vbgjBpC78Kj6ffaDvCgM1dF15CfPRWvqn6CJBwDWpRhsPz5tb8F	1
1126	2vbqa31ndfXwrV1ewv5rTHUt9Q1L5hPe3quKLwmi5bZhv3dMW5dt	1
1127	2vbhXPj74ZccSUXRhx8EguSkw3gxQwiEYa8Fiat78a6YojmZJbXz	1
1128	2vaLtQJgtzCoU6AJDGNt41uCEEcgzRtfNdEF3HozyGovWHniCG8k	1
1129	2vbuLfpfqowZE9Up947gZ7WP5guLViKZ81LzxqWA8x8KkqpmR4fB	1
1130	2vbjVb7my9fE8cZYTa8yqLkcHpPzCiV2GctGETnCrt4mRp7QHnkV	1
1131	2vbduXX5S18WuWVWXS6g4rDsGgmjWTBJQ2d5LNCT6Vq9UFig6ZDy	1
1132	2vbf35uThPvMQxNRSwEGqB6ChLwRmNTf8ceofZAwjJmtcxsn4BKQ	1
1133	2vburzGBvhSCYg9ggj5MTgiSx5dx8HxfLrbFLvAPadMijp3NT5m6	1
1134	2vaFNP9WUSEQWpCUQWLHJbto6SoZiSgrkeDjmdD11KrgeL6SwgBF	1
1135	2vaPtP69gJLSKnQEaBTQb5xnwaow8xo3JSEoBhvLmAKyFZb68B9W	1
1136	2vaWzvMgSqgiT5fvSYcNPGFcJ3tKVAbbhoM9D49HF9n8Kw3yXGXS	1
1137	2vaBZ1sgpZ1f5MK55Njog8VLkqryH13xmK28RMAxHaH1i7MXoJyw	1
1138	2vbUHX6b4SNPbtcVk2U55quL3QP9J7YamR4XUgtFwDicW4LjnVMM	1
1139	2vb4iXzcC9MSxKHq1dR5szpZmYRMN7wA35VV5VyozpdYufBwjQc5	1
1140	2vc4pCgibGP8eQmcFoZXfDzsqyKkE12ZmLfNrHSvKpxojwLpDZhL	1
1141	2vb9nkPtDQzyZgg86wTRkQY7iBB2PZM2MhmUreW4vsTC7mGpdv5M	1
1142	2vbsLRaZbxEKrvhiQnjQXmjKXsYxYikfboBm3saeNkf4pmKBFzzi	1
1143	2vbvd4UyKAro7oBhVEp1z3Ye3BtwJnq2hocXscKbsabHD8R47oVL	1
1144	2vb8CTK9r1xDpcpVx7u59gTYtWiPkYHKU22sNAoKmHUbkyFw7yiu	1
1145	2vb5w1MKyn7Pxwa6hAeQC3KYdzoAB9oopJKseYN84vbEAK4oV7Rn	1
1146	2vbYxPKjMpTBVDD69pa8jDjw1VPZ4wP6GSJQpNNYPDdNGGsEyznt	1
1147	2vaW45qPFAH36ePiysP8QVe21WSxCqjxRCMmYsc9hQqLLdrmFPcW	1
1148	2vbrdWVk5QJfDPEfhzUgVivEXvBrsECAJ2ojUk8qGrsz3wBquh1q	1
1149	2vaBzSiTocFf5Yw9te6pL7cngfnHcKcJzyFTEALe5jPhpjZ3aLWk	1
1150	2vaDmyZMpQ6JVcv1BxcYYnKTHQYejR3U8fk42ZUbTPFMgapQFEAt	1
1151	2vbVAky3m4pMiHx5Gr4wDumXACE35rAfAqw2frvNv1uUCe4hesMa	1
1152	2vbkT77qBdMRiMq95bgLJMk4dG8VTi466TLWUWbgwNbxNieJLA6J	1
1153	2vaDuxjtsJjwC3AbfCVM2g37XmTTnEN4ek1WNF97kmxRWyeNWgRm	1
1158	2vaHSVLdcwh8V8WGgwBxzRFMnV2GiF3KF84KaE342rooeAwkXkdW	1
1159	2vbR7LpvmW7gY9kxxmv94f3mWbr65CntfuQVjVfTNY9kePZJU9xx	1
1164	2vb5M1zZtAhDDL2WCB1yUYvmaVB4nNLwBqZXF9eeMbMt6Zurq8Tc	1
1167	2vbzv38dosWZkUEJMrqTMvMj7VjC8uQ3sp5rhUTx8sysqUAqDSNZ	1
1170	2vaXS8VDESST3K8pRAU457oqFRfpH1huEuNftRDD8JWET5fpKMwS	1
1174	2vbmk1ZFUuS6u5kH9mMgF3HhgS7aLN2kFQCzBbQcCKFzv8sEfG8g	1
1175	2vaznzwt5pRPu83Y4wLfV8mCZQWAgYZwiFx9qwB7yBjhm2EpgajF	1
1177	2vaUNY4hxYt67UzroLvbLbTXjuJHofZXsthbjyi9kNKTEHDPT12c	1
1178	2vaXnL24HmCdoWhe2LFTXMW1TLzTQ9C9qXkgWvHWSNJk54CTZko5	1
1181	2vbxzxrGrr4BnrVrEzu8N3Kymwzxye66mjQXim46mZNUcSszA5MT	1
1184	2vaYesDhs5MSbVNzHvVWVdXhnMQb4qe2KrC3iFyndRCHWEmLuwT9	1
1187	2vb9j9aqanZMKd9r5a2wLhDRzugVSZxPwZaogjJYgMqV4x1GDDdX	1
1192	2vabvQYquAmNQg4h2CfUM8RUZdwLcdvYVNpbpU6JBxUirSKnjFEB	1
1195	2vbPRmATfe8sTz8khqbRhYhDgMg72hh32uaijsH48udknN7y3BFu	1
1196	2vbwYJPdpvZKHYf7PrshGw74AM144JJFitqSDu64yPpFEMBYcvNF	1
1199	2vbzQ9bnp7249nq9HP4m9q3XFMSzfWzcQwVPJhSAe1itHRLYjQWd	1
1202	2vbSTXHoKdw5wmxAsDgtoig64pKcqjFXgneErTtjuU8j7UEPfmKk	1
1203	2vat8fHSpddv49m2HHGdxoxhNhUqdnT4hfWoDvwGMpC4DZW859ZV	1
1209	2vaLfKShBLGFGFX561FLevoaj97CdipBCM6hEkPH8bD1bqvW8mdN	1
1212	2vaNmgKYnctZtk8X7uFwoxSEbSs21EdYbpecT45drCfrZ4LF4Jna	1
1213	2vaTxUFReGJ4eW2PMNPc1rUChb6mt8Vb7M55UuuDBpLigyzN9xR3	1
1218	2vaE7YFDwMEFXgnsniobUXRztXFSB3dw2RDgc9gV9WEXABesKtcp	1
1221	2vbsYmgsm8YQYa3uQKdDHPNdjT5ebawBXgpdBGQpuoDgrtVSJhCy	1
1222	2vaHEhFoDzxzSHk8rNsEBWAfjJHtwXF7haUA7nSz5zZMtZjDpDDB	1
1227	2vbmd2K7eHkW5MHLVa2KN7Gp8UhduFajNQ2NW8d7WYGm8MVq252L	1
1230	2vbm9C2NFpBiqrsqZk77U7oM6dt5GbNzVrN5XoRczjcvfHaJk9FW	1
1240	2vaEWKegfZT5qrhXBCGzTaArxfnPDam5LSy7guzXu8BrBnQsSjnW	1
1243	2vaTe3fJHzZ3DD9qwc5LSvUGMHcJcFFeJqYzJJA4jnz8LhhqjGKx	1
1244	2vaLxXgXT8PmstK1j9nHu5gGUFMdkvoTq1RjQPFnbYZZweUG19Qd	1
1154	2vaMHnsVSM7TrTSsKPHkLCKvAG6zxTxD79b8j8QnWD1gbaJhSYvU	1
1155	2vc2V52u58sJ6aqCGpC3FTtm6Pz3j6oqYhHF2DBkE5EP5szPttPV	1
1157	2vanjHJxzohtoRJjiGzNiGRzUfLJkH41ELQxP89CeHSLnBazEJSY	1
1161	2vbkLN92i4UfThAnodTQuWMSjQRaVoF4eKcNQMgPcobjMWdVoudc	1
1162	2vatiA3GzCnGkJj53paQA5BMrkbuM1oJfAnvCgacGS7fh1i5fAx6	1
1165	2vaWXRTkHxcYeXVkQuu3spaQUYHxLo5f1XQNEFcmXqM3nqCRAn68	1
1166	2vb9jjpj7rbDFCZBnvd35iHBtv55MUVZ1BrLbtJW9LDGGjYypicV	1
1169	2vaPCZZE9sPZTEwyHF8LSyDiijvNGE1rMYduw8y5co4PG5iYnCch	1
1172	2vbcKJ13N2Lu7ngLdGVQbGCxDerYpexgUvZ427Co6j9zsyQcTPcn	1
1173	2vbuyefaB8jGtuRwHu6XwUAqxSRx2AgX7ya7FVm6NqyCgLUBsKoA	1
1176	2vax5xRQwNTvJXQd3tLRu3STfr47tEcfCDmNoNqWvaoX3oRJu1BG	1
1179	2vawebyQ1CeyAzcvMCuoLttp35HFKJVDMVKfiY6FkbJVNVc6L6Up	1
1182	2vaM5uPtWtpFnXoWxE7NqUDaKn2ETrHaxc58FPPs6iXV1GEtmo79	1
1185	2vb3NiUQvXdfxfVFjq1f2AHwpDbyxobbUygwwq6tEoByLeqcvKzR	1
1188	2vbYB5KTj55kSSNqD64Wg8ak1Dz9UpWH8Vyf5Eg8tynBpWwCJpxs	1
1191	2vb5SzaXLwHfMnhHJuMJ2seh6tq1mRQVHJ9ZGFseFfjENBKHH1pn	1
1194	2vaPd71RZyKTBjybDJYJB9GKvd4BnuMYVZvq4d42pTPifP91pMiS	1
1197	2vbrHzSW9LWEBxeTzKBU2Z2gcjCuhi7Fo2a87NfPj3s3sftdk7Xi	1
1198	2vaxgf1o25cVsxR21ZkK1NA7fAGMfjTkZBT2K4d6C2j5z8vkNbBK	1
1200	2vbhkx6f6dmp4uZK2Y2AJshPimHqPuhdDrVSrLHZV54MXTcKT7E5	1
1201	2vagfdD1crhF1s329z8d1tTH7brmeyr9VJyBg1CiJx73prJrauRg	1
1204	2vbM1KtcGkTcucuvRAeAZXeSkDJkPBdJTsJsq7MCGyUspxXt63Dp	1
1206	2vaQExRso1HvZTBcdwnQ24yDHTVs1GbqiAKi5iJRfVq7192vSQte	1
1207	2vaWUWqqc9ZiQGrGdzouPqJkDmhVDepfByLpd6wpUq7MYiXTuxdc	1
1210	2vapvFS3ti88ykMj5k7j6ooeDk8z2uJzpVPnsZtsf2WwdpzCUgU5	1
1215	2vatj9zqfSwk47DWokECX6k5i3xf9FUG9J4NATyu2zcYgJwVGCbp	1
1216	2vaV2e8nWMjbfBexDkUva9bm5hjRsXxjXZFPd1J4fftxbck4tSHk	1
1219	2vaMbH4V6Pv3XCAXM1PNRaGtjahtMi5bp3wR1t3AunJ3Px285Ak2	1
1224	2vbR3ENVRv1LFi27gH5bwaRnuG18aCWpErwPJFcbPv2gswraVTwY	1
1226	2vas39p2BWg3TNAyRFQpcjmcakfnmUnx8GW6ehfGW34AL3cJB8UN	1
1229	2vaTPhvrL36Zd2h2txZrib4i4dnJe63zVpKtEzgmRgCAxk8acZ94	1
1232	2vbBXpBYKZ9jNUAEEeX6Ut4psrd3pboZEGQneV4RY3nnJBhMHubb	1
1235	2vbmc5uBoMi5D61yj3yBLHGuz4MTRnuf4YUWZ5bTd9h8EsXguKNu	1
1241	2vbR8FxSASKkHcuskoBMmbpH24gmtxp81MZVHrAHa8pPEWUvbxfz	1
1245	2vbDecSYMH5wuCUPtpXKqWG9a5LWgbjHCKspyax5bnJEEjyjEmhc	1
1247	2vawoFML9V9WfNxBWfDaLNtZGWN5w11To4L5t8soriEJS7P4Myn5	1
1250	2vaaxLzHAVWTUuawsBrrzKFWFDgRwdqNrCZ9yKegxWcAihcyvwTn	1
1156	2vbK1nZ7XnpR65m5vekwCXMN6hFsHQMAfkCBiqEyo9eZF6HdBtGc	1
1160	2vb6vDPL3zd2UHc5yHeLQ3sNo7dxxH4XjPY82tFBT26qviP5wmeT	1
1163	2vaFUi3KDRKg3GmbfxUBQMnzVkEDy5X675YMM1sVjvTfzF5cTpmS	1
1168	2vaUhY7g7gYMgNPzAvgie4XMEeegL7U91NrtRHHpzHnEVKXRR63J	1
1171	2vbRNRYe8BAi2jkXK3BkeD4YDqUaq7vXAJ3QmEpk82GogSb1sqou	1
1180	2vaS7VVVN1LwrGMyCxGHZgapM2cvbjbUKQQw1CdFTaGKS4PEkEXU	1
1183	2vavHMJxj8g7d35xgZtZKbDfrJCW1PH372zCAf65s9w5y84thDst	1
1186	2vbKoo6u5FBsiqxYGXQ8gZ1u64YuWkkehe4SjzEojYDbSkrqxYcz	1
1189	2vaXTQpejy6hyjCT5XrrJxUpekRbXR2McZy9j7kUTwV3FbDnb9iE	1
1190	2vbc2wMRzouoCkuy8fpCjkTjGYuzKKsECop28E9ghpczYMJPG8Zy	1
1193	2vbZ3Gk1LnGaY3LTW89YeDSgBN8KvFDJcGrghvSJinFe6Jjf8Udg	1
1205	2vanZ3f5T6QjBBsAqbaDPwiEYw9xBascJ9VeAK5TNReKWL6R3vtB	1
1208	2vaiVoni1KQvDucXi99484xxcveehh5yqwKrJWdvrb7y8seWeHuo	1
1211	2vbuf1qqspVbbL4zgLAiaPdx8HRWL8AcZypCkQgZoVB6dramSqpv	1
1214	2vbzg7o8bERMV73DjAb8Lg2g9EhN98u8PFLjhrAzV7aHmQCCwvp7	1
1217	2vbPAtAfQzL92QeBFAeDG72qYvbKk6atEs1qhhHfj7kU9s5fz8cY	1
1220	2vaaVxWpdyBrve8nBGUtSxDBkotXiVdnXZKaoEY1qG5CXaVHkYaa	1
1223	2vb47pkdWVePjb5DZr4QK3VzRm5cjLhHU948AZMoDy2B7BrShH3o	1
1225	2vaTuFKfWKPeVDnKePHbTB3bok3jvcC6BC9NKz7EzU8VYHNCEu3A	1
1228	2vbE2GW2yy6A5EgQCbgSWAn4BzRVCHHBhsWWFC5MU86hLDLHVRYZ	1
1231	2vbU481pBmPDDoyvy3HTaLVZU5i1hSQsSLLe1EF3dzwbT3PgeFpR	1
1233	2vbwHgpYkzsqjuBuarxTwqNUUwyK3j4JwJzNUYmxMWCRnt9WDu65	1
1234	2vaVYzMyckaKcvkabTGBFWbrx7HiBQkebErXG9dQHsEeLDB7yeiq	1
1236	2vaeRYRc4quL8AHoRpDfvhxNvWN8uuvZJE6ubqu5bv7xYLcnhcES	1
1237	2vbfuJ4AuT4EysqsCTmDgba8v3czHkPkWWkuzQM4W1KDebMxcJEZ	1
1238	2vaaD9mLaWXdVrRHdYpQ3RAJBd8V4Tj2NCH93Fv5nFX9mDCtrQMk	1
1239	2vaFZmLKBNoSJ7NJGNhxXeEi1L8p6t6vLqokuDZgdYE2TiWKcV4B	1
1242	2vbFqw5tXg7cdhNC45YFHTvALJVgKDmPnZm7vdFAoTwSCocHr2hT	1
1246	2vaD2sKybV8PSjWP62hmyoWGmR4YJL2csNVxMfRzXcapQxqvMGds	1
1248	2vc3ENyPggKWGPAMX2pJLxYuts4CbujQHgPPchTR3LNnnB7afn6y	1
1249	2vbo1XPXCt7bsiRKWQSnHCNQpqrBv3AcqEtiXDXvqK55o2ZyMnqa	1
1251	2vap6XkNwdK8kvYBxXcsTh6RDjeVao9mkcB9JKBeVVXoDgqB1t3D	1
1252	2vaXaAYJRCVwhirDmNNegJe5YbgfFHaHooS4YXyr6ubvdz5yymYH	1
1253	2vaqvqSjkq7tGjohkJptxDgHxzzCiCoWoBJWMchsJDE9D82NGLVE	1
1254	2vbvbYovHK227mmLD9BfKp8jjMfHSRihE2tGvnsnHjCCV7xrb1fL	1
1255	2vaaLMzVDznmZLchWgujsFEXSeweyfLa66KhtaeQdHjYMeQHJ79g	1
1256	2vaqwtRAcMzw5bZ5SiH2fM4rNiZLG1AMuDosv2i32qcpVHBLTbLd	1
1257	2vaTxD9TbsUYS7Qcxhy8DewBedKWgxM8ZC1NEPE7GAo5aLa7irHF	1
1258	2vc4k4GGvu6p2kGtE767GyobkeJDquywTCivHUeyB6dVrFZXpNjV	1
1259	2vbwZdACHHZFE2o1kJ1gbQPJ1kgeyPssDX2SKVLn8eePQeCmyBhY	1
1260	2vaEAH4kxqEx9rFGq3sYwPnPBiqXyGtD2Sk8XDAvyLs7dJ51GcMm	1
1261	2vbcAHvYpJ6VycwZSPdZ6uhVTYP4yDt9HZzgJWsDtuxAxQuyF9vy	1
1262	2vafH5CbE46pRXC3zHyZUrWdGYBWpqCpzNx6A1EFpcJVv3vG5d9F	1
1263	2vbmJH4aoeEosZ3VCJhaqf842HB4QmCZEqwA6bMFkxmTCRxduYfe	1
1264	2vc1KJJLV3NrYEpGFeQtU3fNYPFGgGpGWZMG1Thh1Xnd2qhZ8ewG	1
1265	2vb4taftq1iULmK9uxKLG1VPYMpgTXnDHom69bjtWVLZCQcaUCpo	1
1266	2vc58Mx97p8A7NdsWA5gr557o6TnxNyTkX1hheCYF4CHZ9PuLwyr	1
1267	2vbAGcuWGMmkYEfNUx6JMLE4Ke1Kp5SXCh8eNBXWA11jGSQXFxuc	1
1268	2vaERDKQuAToWNsdGSuwhG9eRXfy6ycmWpsxh55gszXW8VPa1YoR	1
1269	2vbeR4CsqCJNsRapEN2iStWTUifMQa1piEnDFRmea5yucZS4wtx2	1
1270	2vaREJsj3YHYovz6eQwe4chmLLotp7EJNNyQMeFCQc1onmoLn495	1
1271	2vbbMdcKNZARvea7kn2nPp6tSAJ6JdR6UaRUA14Z1SygcEEVJZhW	1
1272	2vbNgduVhs5xfWSdYEB5prTAXpoFpiL6RWJ1nWkKaCLxjNuhY9Jd	1
1273	2vbgdjirC5gzFhvWmABKUyMWu4PRMhHSaQ4s7tis31eAHqc81WJf	1
1274	2vbkrwxkxmxWmAAv7TVZNPrqMJMKRQXivVK2ToNhS2YSeSvXtCT6	1
1275	2vaNjsEcAPvaFxGDP9GYr5phe5YpmhmVhydLCsrxt9moMLFWDgfK	1
1276	2vbsPaHNV6iEeWV868sZ8oqD6EhE3ZsEQQsAkEAm1hqeDFdrJYVg	1
1277	2vbCUsHdTXcYBaQ8YUPomY9R2hS1vr5Mb3xMNpHcLuUhFPmBznrC	1
1278	2vaJ9Kgd4KWHCk9bPyNFCb8Gk2cQytzFGWCWEPeNB1k3zY2DWvts	1
1279	2vaDguykmMVfS3XrWkUt4nugVN8VXN6rs5KEQGWE3DWRHQfiJyHg	1
1280	2vasxwkXMMuhuZA2f6fDAgF1sWeEFYn4QuL65g1k1wZYSP2DJUNu	1
1281	2vbfvGjwUFrFqkobk1nXoMXHvZWCZYE1pr8oZfTByPbVKyH7kPyQ	1
1282	2vbZMYnKnxmMHgyAFTqAu8fc37vcu7UDrcN5gWHHtK9YkPU8bpVh	1
1283	2vbpZjqZRYX37rMkgMQSnESgXzbUyqNDh3zJqXPTA2CemG3o8yx4	1
1284	2vadnHHNMPxaeSp3BPypfXKR6xcHVBdNpJEwPJqpr87sLT9xquqZ	1
1285	2vaXZcRwMshFcGxeUez7WMHtYYJVPdztNw7ANS3kDN222oKtkJME	1
1286	2vbxzPxLmxb5AAy9cVB3UjZpyiFGNyN3Wb9bexsiYKE9xEeYgZoS	1
1287	2vbRHAi58toE6RGLBzGDAt8BmDRre4SqoMVY7SRPnVxgerXfH8Dw	1
1288	2vb93i7UK8FNq1T5R4Sq2KaDFtJp7zsZU14K3odWwvXkhwZAdB1C	1
1289	2vaUBKHtMdNrACV19SjD4tMWN3C5cfSmC5pCaP42KiBZqwh3iqBp	1
1290	2vanLvmRWaXUNekwqFV6Y9rmdHxCS5PZHxW7ey6iShLdUKYQzrtc	1
1291	2vaSXhcfxNNw51wknR9CMYZ3mEKYy2hkLBEAbDuSspNtCRrw7VvU	1
1292	2vaX8XEFH2fXsUpyWYtrCCjd5AVXqNcbqwZcefBzhsAV5Wwr15N8	1
1293	2vbWzQodrezApVmFrvXyLBS62QPD8eViWmYHVLuASGx9EjoHiNjo	1
1294	2vbxjgwGv2aHR65QvrHPu9RbBdUG4iEugNWrNcZSEeAPvS4aeHjF	1
1295	2vbXwJqzgYAfM1LYQpqC9GNZhPjAod9DSemH5gQKsAVotKBB6pxn	1
1296	2vaBWZWX9mTwtiSqbCM9TGfnqKvJ6oiFXvvLemuHj3fCgwaaw2Cv	1
1297	2vbSqJ8ynpFHaUHDNjxP1DdJwewovaLRLbxevvWhKU8YhJax72XN	1
1298	2vbk2DiQ4tEXxqpFvt71nNFTTEWoqrakkRnQCq4vNso1LZkbg629	1
1299	2vbRU2H8WP5etCWppLT9bvgp8UpeAR87HQriYPsMc8pfAvodm3uL	1
1300	2vbqY9TkuiQ4URYbay4hwSXFLQPb9YYJorXAEaKfREcfRaWHMGFX	1
1301	2vbcajQvjec6SeHGCCa1PLKzg3LiPopZDrp4mSsgme6nVPMpWZzb	1
1302	2vbbWK6ZRPisMktoVMxoW93gqLK8joyFbDhUJLLV8jq2pS1o84D3	1
1303	2vbvQJvbDBr8t4N8JjibysyRHg7s3tMZA47HWhED8q6K7aAF7GaD	1
1304	2vafkyvB5TdDsQoRDvBTbgtLbyDrnUF8RbYGcXzmUjEjFuGJ6tVa	1
1305	2vaDgbW7v6rQVEDwuVjQKXeuQ4bHREiYMibXJ8tNCkbFjC2iyiRy	1
1306	2vancmCvAbdCq9xTgtmNbbuhX3HoUA224Hkrj7P2UU34ys7G4nbM	1
1307	2vb457BTSwHnQt1KdxwE8DXdRZzquH9hXVX8sDh2EyNY463zhbcA	1
1308	2vbo7qk87zJYxWCwVn5uSxAPBVYjf3HZzbxibgsrhGbnbxxREUuT	1
1311	2vaEGFY2XHUnpZT6jGHqukB1pM4UJyWdRNCGDXXdGQX9qro1P7T3	1
1314	2vbeyTeMHJPVvx4Nif5mP2vhVCRsCkqHn46tXs5DeWNKR4MqUTcP	1
1316	2vaV2A6gvrxqXNgDSyD19qq75uAZigMh4manM8DMbqwBNkWqrNyo	1
1317	2vaZUnbBstNo6smNtExjuCVEDNSbZTpd8prXYEVdf9KovyDaxpBj	1
1328	2vb3tZB2yBh81DJdLeTXMj6hEAVMPUxaD2YJKe7nJQbUd8ze999A	1
1331	2vbHmxX5MrtW4Ug4ZRd7SARZTJZsa84XcNgZfLzzJ22Npk1BragD	1
1333	2vbAMNanCZZfFy5Smh8F6iRa7V5iEjg9sRdsrdsVsjRVBTJWpe3i	1
1335	2vai1KstaW4fGcpkopw3f1CAS8kMrA9jC3bR6uAMy73z2TR1GhS6	1
1341	2vbCtoqoaUQiKJgrdVBPG1bWMcPi9iRc6nYNnqgek16smYABAifv	1
1344	2vbxiB5svPDfHw6DLDkR8ZWTM8eBC5xgRzc9bdWhuYziCFSkxVE3	1
1346	2vb3w81SEh6HoAtgNAybKG7UthEFqhAJVGPfQXLBVrPesaGZzH8Q	1
1347	2vbXaQdwmG57nkAV7Cv1J4SoYEq1N5qcNh5R7LuKvWhJjx962SGa	1
1353	2vbz85Mk5CErndx6PkvLvcQ23XzR5Brq87vL1S4UJPnHv6b8ZWkb	1
1356	2vb4Y9G6byYSiznukDyVFEx38DMx4gnXQR2YyMWmqBimWorA1vmh	1
1357	2vaRGtNq3DRFFUa7D4PUdCFPZL3DZBM53rXKjBStDBdA8JnhLjGP	1
1359	2vaZGuWFCUJJD8dNnNawWezPkCc2HendhJs4jjztEaF4u5jQF7XR	1
1360	2vbUDy6X8EHSeE7dNEfUaZd1BU1nd2K5pPhqgo8QphknF7DsgwyJ	1
1363	2vaRiy3FrdwNjDNSjjZx6HFkmsNSsYxpvAxiu8ksC6bjEw1uSPAG	1
1366	2vaFty1rEAo1utwV1CKSEf81FUz2jqWzGggWfXLDQKywtFfyig1f	1
1367	2vahx2FUEaN9AFtGzujaJ2hurZzzdbsKcB7EqHvBAdHLozFgDi6V	1
1371	2vbjTcEMF4g4p4mhdkUCctDXnqsSWfHJ4nWUoA2QUB8tVnJexq3F	1
1374	2vaS4JpCz33tVETf4vCRCTJD7uG7at4otJWYeko1nTRZLKAyDo3U	1
1376	2vbUW6tH7ZATHzkJseobJ1m4KhtpdfRJmB1aFfhQHqDp8MRoUwGX	1
1379	2vags1aJPgdvEJE2HvH26Xtc1zeb2CJM4zfX25JhZpd3y5WGLGXP	1
1381	2vbkB1eSgGuNhBAByXFLZejSdfVfpLiuiVSqZ5hQPMfGhzmFYRV2	1
1386	2vbCNqTta2gCXMtqQ937wqBwzJHJrYsmfJHytgEHHojjFAhvcHPJ	1
1389	2vabpL1gWgKnq4iAAMEhEnC1RNJKd1HV7dWYyviM9p4Yg17bpdT5	1
1390	2vbZe5q5TsDT8GdDk2PgvSePVbUaJZy3miSHq3k64NxsitY3hLYs	1
1394	2vaC3FErSZvuDxv8GHRV4EZBUsKHoe61UsaRyZdQC9weRW87Qnsd	1
1396	2vbGVwVn3hTcixc6K2M9AqdZhVsNyQGiR1vbAVYFfBwR3dhDSnRc	1
1398	2vaZVdPWhNtAQGUxGG5asymVEAvJP5eMMPc9ku1T2fx1ZMWfiTKD	1
1402	2vaWnDUfdX78GRAHVTHrq7MX4LgNQejJudCzf2bgRHrf5FpbcfnF	1
1405	2vaoGnMsXaFuikY8U26yFWS8QWAJsxj3bZzEFgw3aiCgojf18up3	1
1410	2vawHWWz66gjQ8VJTdv3u5uhWUfjZH1c8r2YvFJopwHCKxgkpTbP	1
1415	2vacBoUvM2AgsMAFB5JcSdKKxbeS9WBnvaGEdkM43VexNXzCwHtw	1
1416	2vb5yrgendoTsS8X7wv637GeoiNbN1E3hqinQu2NzJywu1HXPRjw	1
1418	2vaAeWUoTeQAzi2Vk6kvSfmU1yXBiAp4fB15TCHd4B9SKsYKY5FW	1
1419	2vbSMK7d26ezh2ZswNRx59RLpu5HTeAA7iMxV2y6c5RJohwBJNE9	1
1423	2vbpCZnD7ezxYhxKa6uFM1pxwHGZp95J5VXKGAJDTEDUUsm4J7rp	1
1425	2vbWoGJcJCtAddvJ73qtmZ48WD3dR1MZjXUn1zz2JkTSSvYSpdoU	1
1309	2vbByDHiAeqyoDew3T3idv9R7WWKz5VCiysWV2Gc4KRBUB48VcME	1
1312	2vbj7VxGmajvDKSngtAktQ29EEQPUJQXpirBaHZuCkhxYveRExxY	1
1315	2vbwJvjut7iUDCRQUMFMfY2G5eJ3aRdssV9DCLerC2YSHDGj4xsP	1
1318	2vbGTJ5hmUv77MsXeECrM3TYdCs7Ao3TWACzfRAbaNMWfatdM4HW	1
1321	2vbA1jx76toAuCjqPJAY4Dag3DXUCyjmF7gqFsBsSMNGZkSrjvJg	1
1324	2vaqGXi7xnMe3cSUjTtUvCuGSzTZw9RiRsHBhnBJ8kTxyfXUkwar	1
1329	2vaHL5EAMMxgc71iMU55oYGmYoSEWm1LQBN8rd1yzoDDC6o38pZL	1
1336	2vaAhsWUEW6qqjCVDSDVzM7M5vNTma4zzmBM6A4L8XMFKN2PjGRW	1
1338	2vbM9zudtoZAz35bpdiN1sxBfeN3hLVmm8sfFFyHvQ8mh3j83son	1
1339	2vaCbh74UkTT47K58Xm6wCNeE4CtbaRMAA6TFtas1VQTjZw5EGpT	1
1340	2vbbNX88Cytogbtut4B9wrLWQY5GQzB5dud6NUD3nfZQSLBYNNPu	1
1343	2vat4YS65uuiDjj7mrWpAWH17UirbtBqhFgoDodKxe4WWfR863m5	1
1350	2vapj8wWY4vhXEtnh88FEh2o441XnLwqLC5TzEBNprcYec5AFrTy	1
1351	2vbhdMgwwe6GzjvhqUGZzsp3kJ44f8dMwMqmkUBKFSPWAn1ESqvo	1
1358	2vbQKdqF4MGhDRYhZ5uKFdn9NqqyhNje6bB9sQwPH2UJD8p8GJ9B	1
1361	2vaw373Fd4pUJ58W7q2itkbm2hJymaYGoBpGzvahoGwFaSWqVgg8	1
1364	2vaHX3tBarwSDQf3GL4j3kdZDTXzXkzEbgsmuoYqf4ETtUs5GN8a	1
1370	2vbyqD8SHYyYinEoJ2vuRNonqrpVu5aN6bQVPVoDqNVxHTq6qo2d	1
1373	2vaNfM6i14zTRRUsSpo1P2h1cUC532V1eNUMCofz1UZikcKTX2E5	1
1377	2vbLfJSEBYGkjq2n3oong6DCGtPvuZu8hEPPHvaMzLZixgSDZ3xc	1
1380	2vc4D134mUHLrd243MeFdPyXftN3vw8iYBK9Gf9NUHEeWJsA1MiA	1
1384	2vaLZqnsLvouAFo1P7bUBXTYBqXeSUbXTqdbiCCrSx7efggP56ud	1
1388	2vbwiagA75hEoezUWpEkVP6x9oMdggc2CjfmL5akxz1xB2dMPQyW	1
1391	2vak1VhyWUyhZwZEKausLFV4R1SgaAraDfUhjp2Vtw71SMXcPRku	1
1399	2vaqXpUXBzgra5v5GLhygm4K4WBtuRHnYBU9DmMY8TwJKW8QS1H7	1
1400	2vbuRPs79BCcMXtiRfpGwsRyMTgPkc9bnPFqEBptASm7bJ7FiWFD	1
1401	2vc5nYVp2iVAfWJHdDE6cPu3VktcfRXuEWepGtNcgLFThQrNTgNk	1
1404	2vbwz1tfbDvwQAVCaEkXQkiUmhjU3Bb55YVwmgSzvRgGUUhnQ2kk	1
1407	2vb8U5YWJPer8Tp5ok3z4JTwTbwb9dkQrPxo9eF4m1k4SVio1eUQ	1
1412	2vbT5QQhwdCPL3c9giTzPhCV4ifNSbWZ2kVxLdTT9wujhthj7aE3	1
1420	2vaDFPEqqjHsQBvhAd4eexUedjiyErZY7vuUziM1J5B6ZdwZpR6V	1
1421	2vbUA2ecRSP4bQ2WfdmVvdUhhibthcBWfqGBVAqxSxJYZFQDNsDi	1
1424	2vbNgRFYwCq8g1xAw9edZzyrPC8bMy7bfaHh7qSYTvk78TmxLZ4t	1
1427	2vbQaW4qkKqy4uh2rWztWXoYHhTYdyuNzvd71vqva5wDuLUsh95Y	1
1310	2vboYVRKSxi85AtSJM1TWpTxYZL9foBijPffcrXwcPxdxXCiZtMf	1
1313	2vafN8adV4yVoCHoiN6oxiHHsLdTMcxcEtfuv8wtafZGHc9KyXtM	1
1319	2vaS2WvN2YNVeSNCVUmfVra4NL54d1PoGVcCF51hYwdckxnPYB2Q	1
1320	2vbaUBkVHSeeL8JcKfVXUiwvBn8fyCGgTaLagBMavKSvte2kfzWN	1
1322	2vbjW2L1YPKrk87jN2BJSwwR5t9xDW6WFW8Ay5ZgokGn6ArpdcLf	1
1323	2vbMidR2Vs9bN89UxYnEwi73LNgKg7rF8ZxeCZi6SZPuSvwCNPH4	1
1325	2vaZjWqr6k7bB3wJjjqJjbQDpTDMGp5Px8J5AhQVLhDvN4ziSP75	1
1326	2vbsw2mkC9s3VVN849giaDPmSsbCLLW1yPsUypbvDGCxuDwsUM1a	1
1327	2vbWYvjPw7aTkxDyCHRfJdyCHf9vJuqAS4BE1uH7Ch53jjAbnTqq	1
1330	2vbN4F4YjZR8S6Bqwz16qFb16Dj9vskyDHB3LvoBButc9k6FDjnQ	1
1332	2vbUHeb7waVYCgD4w2yTeEixRX4yRyM92B74Q7Yh4NKS7Nf2C6hT	1
1334	2vc56VbRqterJDWiYy2BnJJE5X25TuR6PqVQYeLNZwMuHRq5xdpA	1
1337	2vbPfoDozNWyBhr4pkFs9Z3fJQHEWFGEmrZYDCNSysNVmx5tasGc	1
1342	2vbYYDAE4kDkmeYJdf3edtv3p2mJzbvq1pXPaKqkqy6b4kYfcsNh	1
1345	2vbqV3paystcMyYkPXeaASC3ictbQ5drcAobRjNYPk6ueYjEy22d	1
1348	2vbo2QpA9X5QUPriSCWUw6phHrQMbpyoKk3kiPvUSfj8xokc77Dh	1
1349	2vb5KP8Y3LNFWgjxaXNfPwvfG1CWdixawZKwwwNLNKVUAKC7urHq	1
1352	2vc2aKVi2mk3pD5xr2gsjzpX2gN2YFHtUweUamVvuWkkr5WcPHCP	1
1354	2vbKJguLrjUHpyWT3cH9Xv5MvDnyz9CCdWGbQXBkaQic3aE6o8DD	1
1355	2vam1GnMaKonWQiKPT12Csxxb5dpymJGtEEhbuqnGvetnw5NZx8m	1
1362	2vbNZw3Lvj9y8VZ64yt7KGdnxzURwaZSQtT4f3K345uDpK9r6rxE	1
1365	2vbWESUrKd3cR2w2P8g224oPK6ZSyWfQ6rPbDn3H53deGbhAagbL	1
1368	2vavCynhzGNMzuo5U4jpy7QT3tiD8UDx9p7xDDhcCbB6agZRHAR8	1
1369	2vbGo9RH5auJ1pij9dVXVtwudXQD13knDwjap3ifSw3F5kQpHfiE	1
1372	2vbSZcwoZeYdmRHDiSNTqyTz1XhVmNihre9asuXBPm7aEYKUnphU	1
1375	2vaHLwQdTsGTajeXnEGzcWhGU6FefRmYJKFFc8yZSw2YzUccGR79	1
1378	2vbhNnyndrgLb6JoEgkpHiz4p6qSQRFduNP8Q2SL3u6puDaaXbaC	1
1382	2vbpL9j3a3GaYYaiXiPpzYMLo8xvxwWZ4LETFxUDj7NhcttZvgpT	1
1383	2vbpyoCNxfL41nHDaK3eGWox73jEktt6tMPQkxe3gejssJYQAP1w	1
1385	2vbBw4GR81sgeXcZedHap8Rn6oz9HinjCidGKmoYC7o4gn6uYQMv	1
1387	2vatb97xfNANQFrvAsKvDbJ3Q5noBq99M3ZHVRjMTGsaakJAiGbz	1
1392	2vaUs7uELdBdgqAzfmX8B2xMFKxBSCe84tgtLbNY547p9tzF1neE	1
1393	2vbiQcsDwbPUqfFTe1HgZP9Bmq2v5aLsrazye5zEmK6te1nX19EW	1
1395	2vbogZymgvexigfouuUchBBfcjexVpXxckCqwXpzQRBoXaadNjKN	1
1397	2vbHAuPE7n7PU6DSFLjmwzxD6mQSRmwkoPujSxzsiiHbn6w9dbw7	1
1403	2vbpxgCQdff2Qfx52MH7Tb3dmMq6N4Q1fvTtZEoTqc8gkyKm21t6	1
1406	2vbJRgAJUqqrEkeyNeydSj7eaAZd91bTLhAwzhHqudd1c4jFFCWs	1
1408	2vaXfnBuTfSi44QTXWmikJiiK5sWqaATV5Gm573xEBvq6pJrGQ9U	1
1409	2vbgCdfzrQTy29afG75WdSM2Bqkw4JMA3D5tycYVaUFWotFDAtyQ	1
1411	2vbQX2nNMBnLTStYms7tX3FcBeWkKmWEutY95iA3FuhEfPdfm1Qh	1
1413	2vag69NAqP2G6KVi22tbdMzende4Cidvm6GEaURx3D2rPNAvLFsy	1
1414	2vai543XxJFLqQyiVUMqP5E66L3ZNbywQc8wWF8u2Qh27pi32kek	1
1417	2vbFzds7faALLvy1Sjz5LfuxCgyDZGCbr9kCC2cvYNFDjfVoRmvM	1
1422	2vbTxEay5XTig3VkA6Dap3ZVG6SQVCg116oE42L5eLU9Jsp4iJvh	1
1426	2vaRVciKLWUwBqLZoRkehZtWYo5mb2vqcqtcmeKBBMoKmkjkFiGX	1
1428	2vbvheGUojwFNQSE4suAap4hiddFLoxug3EnHfuC73Lk4ufsmatQ	1
1429	2vaHVQwShPTr4zPkw7eSjrhkQFr41tgYyE1jbioJCVhWSwThdKcE	1
1430	2varYtqGeuXB6Gw5qxERgSjgdGbrz4cKYbeQGasd4NYJMEsQYX6j	1
1431	2vaS56YPGi73ZgCmaJ5UCYmLKL6cEYqPmM2QZgTU2sFBt2dEwMH5	1
1432	2vaApwn3G8eJQWsxVTYPWU8vkbiXxvRn91YL1TCtNsB8YeGpJVFJ	1
1433	2vbRMffy6bh98hqAYzNYsJbofMcEsFP3CzVP6kzQXJ6WiTCgXgG4	1
1434	2vab9ExUmxHGWoGiVowk6oLj1beea3hVwHJHV9NWMnEGtZy1Xmfj	1
1435	2vbjUKqxfYRRDsAkJzTgv62QtHnR3UZ39UF1VH3kJTZh6kibbMxi	1
1436	2vaVVkKtp6ieXctGbWvKHUPfdY8Xszv3hCE7tngjbH7yMSKTawDy	1
1437	2vaNhD5AMAfmPLqjSspWdfKbUfrP2zXA7aeCAzf5Pe4kkcDeXnqg	1
1438	2vaoYNufQE6a3RncG8SopGqN1jDf27Z62Ze5n1b9ZjwFF3nMjccz	1
1439	2vbDxN6XoN2UUhgwbBMwfL5SfrVMzaNhAedFJD63WqFyVpN5qcMv	1
1440	2vbTPEwza9ZiZqdsrqoJiM4cmBKA5tsvqn5akZvcJqF34PSqHxgj	1
1441	2vbEFN8gN41UjhcnqrBV2kM9F6Na1shcXVzgcVoBvs12mKWtsTtx	1
1442	2vaZZbYen3Rgmvvr3cvj9ULA86ujAy72H1XppBXV8ePZUQXpcCDM	1
1443	2vbFiiSHN4H15385wL6Z6mQ73skjoLaVxDva7dwRdk6vCsQqkgvp	1
1444	2vbD3x2LwZTvh89GQeEuowzWU4n9jCAAququj6M1JpjDAMQn5jy3	1
1445	2vaQPzLphXQzy3m4jhn9ecjEoFn4HwXfgYQBkh8jvcJVQfJ6EkqY	1
1446	2vaf7p1gqBBQHZ1tqn8GEnk3STdWExEj3LmxVLEYYF2ExK7Hnb4F	1
1447	2vaik9WaWJgZezxF6aSNWGvG19qprVaBjn7hZgzErDo5zNH51DLN	1
1448	2vbjyYAYu84uberrYS69tDT9EwWJ5p6bJ5PK9iZgUnZBvxRMk5Nw	1
1449	2vbR1MPNCbSo3buwtx7deQCRtp8eHXkyT1Aj492m6eZ398JF3XCH	1
1450	2vc1b1iLcd8rodUZD28Fw81q6YzQDn4EvZdUhop4V5bA51JbEoPx	1
1451	2vbYoN2wuy79pALizqmTXKS7NfLQA8HQ32N6uanGci3Yaz8XF7VB	1
1452	2vaZR24ASMBn64E6oZ5FjXJtbw6qFj21SvgF9rmKkwMR2qU7Wp4S	1
1453	2vaRm5kXGKaZ9MN8WctmGRsMKzrhGJAfDYCCG7rx91wE3ZNw1fJj	1
1454	2vaTrvLpVdE23WzPgAY1FbFmbfFAntufyyR4PgZgse2TqX8XQ9hF	1
1455	2vbAcJtNdcGFvS3BjFVrJrvzrxpsGwoBN6mkQPKsLFRwKJ4BLR62	1
1456	2vaJcuYerfJVKndhuCgYCGvfpeC9wFiRzSJbGeut3aCxPfo4tB7Q	1
1457	2vbSfaSXHqEsX89z4gEAJMTumkbMdMu62m9adX7cCqQL7gCsk71J	1
1458	2vaAdJm2exRgLaSwTmCkDhyzKW34gEA3MnE1fnozaz7z7F689Zfi	1
1459	2vbiL8AeDmQj82SDJoDjndy5fmSHxL5FzFXMoCSvHaNuCPCtzxSv	1
1460	2vbLByTTd8FZKW7z9ydCEvzaW4ShT6i5vj9hwcZfrpsea8o9onDV	1
1461	2vbfSTnDhgisWx2pkFT16yK16mdxcQLTL2n26mVEgLmvgQ3rpKSH	1
1462	2vbP4WUF9UT6ovFx5rvixWzBn4wLQnt8sbHoPNWkiFhJy9yiaV8P	1
1463	2vahMkcQGFiJg6C7ozmLs1hiwkVp9aYR8WhGwexByPy1Qs7uFifY	1
1464	2vc48uFmhUqgwcSuP54HR3MXxcayq62yTLSskLVCZCCmuSNfahKi	1
1465	2vbaoAAX1PGHToUa8CrWCfDSJyAdTBiuVmbT41bnZqPFpvHRLu1e	1
1466	2vaUqzzS7LBca9HDZdYHGVUrVf3uB75sPhqC9Qn9jTy2zyFRJgE7	1
1467	2vaHxvK4KtVZQcdJAAME3LAA3c5m2rttZTyVwCe7HghdGKKgvhXJ	1
1468	2vaC3g3jJaLGc86BvnNG59DtDvNYmd7sVcStC6d4kbLBoTdrGr1G	1
1469	2vawv2M8oxo43c7xqiavXnLKUj7ceWZJm8QLCfTgiM9CEVoU47L2	1
1470	2vacgeGBiHQw1decpmCj9xEu4o684a5RwoSPdTHGdVLGNriK6tPv	1
1471	2vaYKYPMTHykDkrhJTEGrpckhfMfZno5W4GEKYoD3ubwUowScQSs	1
1474	2vc3G2qevozoiyFHQ34mSYxr4o9UBvfaubgaygjcr2ARSDYEEVAA	1
1480	2vaebzjeWqJZ2CTuP6bfn8DxXBGzQ1Q35ejek6FjVs1Bfy78tx5y	1
1483	2vaVS4SNeqMgHxSVDBB5deirDAGKSDcyctbWahDfYmNzMTh8bt2d	1
1486	2vbbGWe2UtEVCftzLtonuG5TKGRsYoLfkvpWUkfVHtYG17PVhyFc	1
1488	2vaEWfbViRz5gkx2wekQ8xUouu7DbX3uU43dL7BSu3EnyFfVyy8z	1
1491	2vbgxYTNAkvJ6aFNkr3aPCyby8EPV6rfA3rmB53TqQmZGxiD1xqF	1
1492	2vavBhFtrRiU645CF1evhTjskbJyjqNteEx7GRnPKLRQ2o7inMJL	1
1494	2vbx4Rxu8siPVNJc8gigGQ67PnEQv54fbn57JkhceR4ckyb1XspF	1
1495	2vbW6TEXxeWbo2pbj9N8jL8wb4ep3Wri3jUCs73n34zRiCub8VRC	1
1496	2vbjxDpxGtnnR65n2Z5QHLkgT6rbJKZYskQsxVsfxDYASfPSYrvE	1
1499	2vaCgBbK5zbPD3DR9ZszSNDgrtdg8LZtLAq9ggXcadrrAWeJHxqX	1
1506	2vbkycp9fZeDRrf2CGZ8Lu7Dk14YXTSMtzNj3JSNi96QNWYMjXnE	1
1512	2vbU4Xx9hmhGbPvwR1jm324shaM6BeDRe5WUCbACRnKzgEPZePFC	1
1515	2vbkj1hnDqXeBMkzactesNDsGfkZngtD6eJ3fk4Tu1cEVthd4D6z	1
1517	2vbQPiGddJx73ehTDw1GC4Snp8sFDy2y6ipMtYjRrtmMNooNf41d	1
1519	2vato8V1M3oTg1j1ohhwfCum5QuKAREtd9o1PfM9fwSt2bDSsmvN	1
1523	2vbyd9RkCLg5QnWMK9uE5cEvPDi9HumMkqA9BHRF1QzAF93amyi8	1
1526	2vbk4rr8wrYsozX6PybYnaXTaTg4VQX5d3ttgrbKPXB3WravJXR9	1
1530	2vbUu7bAAYyCh4uRJGuxrNFpJLvzHTpRiZwRWtPELJRoBqbwHMEu	1
1531	2vbAi3gYwTDoXHohp3rqaG4GME8rMmgFjdPRjMnoBFknoy3p1fvL	1
1532	2vapbptf2gdjZKSLEYd3zkeUrzpQ83936mzd7tge9hpHZVFaUMNx	1
1535	2vagx5i8ZcG4xU7WyvMaK9xtsnattzcA8DX8iLDYUzyYHt65vv1x	1
1539	2vbNk9bCUYD73zv8GQEMd3UEqRYJc3sKN5bP5YZMdr6KizMA3UAs	1
1540	2vaaDckk4WXg6wg1HCYj6WBxh5SbeEZwpy6EXjB3HGSCyrgr13z8	1
1546	2va9R3vmM8hAtV1CBLwuCWsv5YVx1oXx7XcVsYhnv22ieUDs18x8	1
1549	2vbPq2fs2We3hT5LWnXP2h9J3EUTKSSq14yariMYPNJt7nSzcX6t	1
1552	2vbYk1JXCyCekdK5GHN3yfEBmcFfLqhLqDSsr96Bvhi1teQ6PurY	1
1560	2vbMhwzsZgVr8azY6hc9D8cmpWQM3SSzAnpBksyJ2xiZEuomnRJG	1
1562	2vaYN5JyqUCU2wh172bEFb8DA12ccZrd2G2r9t1H1c5NX6ZcZTza	1
1566	2vbdxJX9juZR8QwYmit8cEkZJdWKJDdedHT1fshF2sPPfxx8jebd	1
1567	2vbRAG2ExJ1NsZs6WDLCBhcN9GBe2EZbz2dYwvxbLPAurEBMnFiF	1
1576	2vbKKJ4iEAFLhAUwUe5EkTxrHkfePyV1hRL37aXNHTb5eJ3v2tn2	1
1580	2vaJ8iT1uwVoDjdgtuEpwJnufiWZJMqXF59Twr3LuXLZXiEc12QB	1
1582	2vbFWWBeYeUnseLf5igw1d1MLecm97XLi8kNzrNpWmTedVzNaxYo	1
1586	2vadGoEHrajLvEFVdJ53hNjk5ynBdD6kJVzuNjbxrT8CoWiRytXS	1
1593	2vbJhR1LvP9cgpn9MVuV7MgzY7X7r4YP4a5S8fF4J23bKAcvjX4k	1
1595	2vb12DvHcakHAt8coamGwDPJ9d5zRXWoS5CEs5XadFmqJcsf93rt	1
1596	2vbarpqPsKu6XXSnyNizbZLuJNNFWnrk8rKWpQoWynDFnUP7NXDF	1
1599	2vahpNc4UwEERJiy3AFZTcbRGs9Khzry91BeNpt8ymxpL2LUPShZ	1
1609	2vaZMM8ZqNCmw9Xr2hEu54Sk83UdRheGN5uac6pc4DLcmkVyN5yw	1
1612	2vbZfM7Mm3Ks9JCeXv3KyNrZJusTtidQQkNFUBDvv5ZubPmFFu5S	1
1617	2vbo1iJHYfVPHLPT7nF7jEs3m5xFRtzLL9nHuBqeZN6zQk1jCHHc	1
1620	2vbzUppqvhFW3KTCDZs9cnEPmmz5rWQTdGoEpah4dbokLfD7NNEX	1
1621	2vav5NAPRPeDdAyrY9yuDDixNeS27iqF1Xsqr1H2iRcvC9KL44nm	1
1623	2vaUM3xRXEbm2T2xyzR7buY2JbpNxAtUUn6HBjJY2fhMC6eVyrdb	1
1472	2vaMhfi7c2oHD3LmSZPyHZRfo1ch1J88F3zJiJxGD8PfFUzcvw34	1
1475	2vb7BUGEAi6brbeXyQ3PMwS6coFnzR8rpq55gPeXrAYLVR4mptGE	1
1476	2vbY89AmUBzjMsW8L1GpZ4grxPQdKQHPrM1Zud68ZHxEfLVYGNrY	1
1478	2vbrjrkKNU2jG1RGxzJR8KvcfrUeuoarQbuR2dkX4crmwG7xs83h	1
1479	2vaq8jeKy92G8DLjkVAjxnG2Q5bExzw2b39VziA7foMFaBNihZ6V	1
1484	2vc59SrBZK77j6AjK6uq5ehaK1Ysc2qBeU1gjuDaCUXXeN5P3T9p	1
1490	2vaw3sng9EZ7TK6SZt7V2GaENsrDPMkRcjfCBHgSSxta1apuKYpY	1
1493	2vaj6reAq8ASvp5CBkkqWwZzdbYK9y9pwccaeRh2KMTuHSX6STQ2	1
1498	2vboCHpt8Sf6KmRPAicLDDDwQgHEp3mbbipwHrEm87PWXmAvwtod	1
1500	2vamcCBmrqX59ekGWp9FAPE1Hbbe9DYJgjj1VH9FLdDhEatj8rAp	1
1501	2vbJhnR5Kyvg7VWQyaTUrzATUc18vMTMthjdF8sPpfaVNFv7ogMW	1
1503	2vaAZYkyCYFBLsNt8GUux954sDc6Gphvi686WFFB8mcUkKyYji6e	1
1504	2vbcQN8exwqwWcE6MwDbfRWA3DnMBQsvCZP3q3AqqhMvn7jfknLc	1
1505	2vbFs7JipCXgyunbYPa3CLZu9PA2Fkn5z5wWi4wnm9KvAHyrzQ4y	1
1508	2vaGqaRMBEjRYF7x4CuPnd4braHvHa6bRbk1vKJrP1h48F1aR21S	1
1511	2vb7g6eLaEXHZ8UzUmtoMRvPuDMLeyM3mBSrPVb2jooHsqcfBg6c	1
1513	2vbvhzYbdp2sZGchYfNSZBEEaQBivAFa5JwGkneWuv7oQe18dsfd	1
1514	2vbc2ZWKSwTkuQJcTLH78QQA3rt7JY3qAPC52ii4BHnamjAMuk83	1
1520	2vc3Dm5XPipKvrXLaDrnsfcwrUURSLJtHQrXj53PG37m8wtbE1sa	1
1522	2vbT2BCmHrnWbs7SYZfFH6BPTcENYxKXxDrCnFfGszjgpMGBpLPr	1
1525	2vbEebQ2fd2biJsvkx1azjrJRM3QVpdBb99mBGTrVQSNcVEZqCZh	1
1527	2vbX8rnupYeDkHWjoP4UQo3DsRw1cNFuKgU6GDjUwMPmWTzojXw9	1
1529	2vacq8eyvTx2SUhs6XJkA5W9qKgtGzpRwzXNera749R7wMN98tn4	1
1536	2vaz5X245XXu75HehQn1baqHEX6GFtStByNMPTCuYCFjGpdFXbLT	1
1541	2vaYnwJy88xX6oHFNCvpZLso6vHYYYgd9AhJvX3aE5PEQvj3UKjq	1
1542	2vamdStiQUWobuprq4QF8t7kL5RD4SNHmYUQYKfm6xCkX9b7SSin	1
1545	2vb5SnS2CH6mf9SQz7936AQp3koWTTQsC7xAA8L8rSU9UxRY8v7o	1
1548	2vbeQXhDFbj4evVNiRs2WT5f2GGr5n4r8wwXL7bxeZzGKAmyYHka	1
1551	2vajT1FnrwsaLSU9t1nPW82hkH8D1NcbrzXCxiMZCHan8YXoM3YY	1
1553	2vbWVRF9nE1BNb9YunPWSww7nWzVg6jWfmnjB3H3WsB1Sa9VH4ry	1
1554	2vbVoJrnysPc1Ko1gXbwfpR3FJvgtQJx6DAY2UMSTKU2BDVJ2GFh	1
1557	2vaXDL6kyerm2JDZRnXRhEtKtEu9hiFddZqWPcMse7Qvw7PL3Cd3	1
1563	2vamCLWGkDqhd6V66Es6G8QXiuLMWU2ryQcpQdurjS3xJ8bhnpTd	1
1569	2vaGs92xHfLFy9K5VwuXgQNt21n1i51TM9jPFgU4h6RLFsxAnGYa	1
1571	2vbzgFMw8yEG4G6UArNVwms4ufamz7Vt4dPiqCaEfErX1gSJ9GSc	1
1573	2vanBuYmUWvDRhZgQCoxUdWxrqbxp9Uk9rzKT7JCe6N5kztLcXp3	1
1578	2vbLx3yhBG4wuFVyWsobwUJSXKE2PdKxiVextXYJdmkdUUaPRAUi	1
1581	2vaBWeN46FnVpjXTgkA3fVpqimt6aPgtRqYAGmVvDL8c2eXFN9Bz	1
1583	2vaL1tGYWCsN4VkQJmvjPEE4vD8UsqrAfbsF9ikYqZP1nh6skDFu	1
1584	2vaMW2hf1a7BJueq9vmNQtTjADJMtmQAWKQMX7dbyi9zp9h1Nqmn	1
1587	2vaTXKdz4kBKCmmDLVii6Pc8LdbPborhFjj1T2vXWfDh7SBuEGvN	1
1588	2vaLQfp3tUZHRo5ssZwUek3xgXt6Wd4FTiCqNk5WjRPs36Fgdhww	1
1591	2vaACsGyspRMAhbWxmMB8GnJVQLhbvhdrjY6hZLppLHw11TpShDW	1
1594	2vbsriEKNp9KKpMKmv51NWrpAx6aGQRQHUdcgv8n4GzT5cAsWGAB	1
1597	2vawG2eXKm5rnoE9pbamGZn6sGoXjYt9fpd1PyyNoNa4mXWJKs1P	1
1602	2vahzRLyATHk21bkg8Un6JUSDkFsTUUFSFhwgwv5prapNeK86hQW	1
1603	2vaKhCuiezwtmcsgEXrHH9KMRU1YAPz8TwQje1CRureUWLvMwQEj	1
1605	2vbFdom5mhFwEbgusCjgtGyUCTidvfypRSkQCQWMcbfe9SikMe7R	1
1606	2vaZV9iSz864FXYc9ymc6pXCY6tucV9JPBanmUzd5vi765Svw2km	1
1608	2vbckvm3jwRpYFpELY25X81Fkrkf6Eax4A8Kp2f28b6EEUUnrY22	1
1613	2vb57oyHVzJM7vF8fdoMccyRuCLjAnbeya56GqyEscWLMLSwQ2L2	1
1616	2vabFZGfzRokVbYMmwPDy4pFVge67VJS7TTJdB8w37T3CZWLgE4B	1
1618	2vbiPSuJG872ZDta47y5wuPaDy6TNbVRYrwJ4tBcnRyMHTfTcq2y	1
1473	2vbWSqVNPcyzJzXMYWTXgCh5muuEsrU1nu77zhgPGDWfNmiiRgAc	1
1477	2vbz1h3kw4FJmHntiD63bNaEUkrQVUJmY3iLXeuQoSra73YQrSiE	1
1481	2vb9s3uPQiEaxvYNrG8qksMjNxC2XbEFmdjPNsHyZ6aPRRckYwXd	1
1482	2vaAxXdj3Sw5Ait4ez2Hr2VEiYL5EFP6fQVJCHq41xT28yEopwVB	1
1485	2vaDBUpNAxA5pNG9SW2oWjv3RXRvu81yzMz7B1uQysCjUwfKbfeh	1
1487	2vamc44uzxNL2Kaf5s7v99JtNS7zDL6AUamUP5HZEp5sHx4SiubJ	1
1489	2vb1hHsAjoWdmasUc3jXZLpQ2k1H6muUNFN4wpwSviub42Tb1uud	1
1497	2vaqLHLpoLHK7MV2jbwZCn4bFkK9ErxihBH24CEXVpo9psGyMNdu	1
1502	2vbihW6msdJxwvLwpgqgufAe2Q7n2JgTn4H2bse6wduXvJG4C2Hx	1
1507	2vaocQrvyw3qpfEAa995zggJchXe7jHaf91qWkUEqzABCXjdxfBN	1
1509	2vagGGevUdgHrjBaLuTFLq2cm5xcYStBBjUmZ8bMdyhcNNDkJW6p	1
1510	2vaAR5GcfqejN1veD28BLiVWmUDkVzFGzEQ3GB27dHkeMRR1yAXc	1
1516	2vbSgUvJhbxZapxmi2xU1AVbYmti6crYnNhsz8ofg8DNmFrjGfwN	1
1518	2vbiXcFqkuX3zJwMGr7VGBoZMZmenHxi3mCfWtxNDyGEwbuN518m	1
1521	2vaz6G8PG79zjqNVeHXjneYnEh8YDZhpYe8YKkbdrmK5W2HrL4Mx	1
1524	2vbKNoaM3gDijkfL8J88UJ8jLKQbQTGSnSNKNLZbRysbAf9zyiTL	1
1528	2vbMMG1TSPVu5vC7xF5JttEntnRwUow9F2QDe47fEH59j7mqfPWt	1
1533	2vbF1rPrzTdzJ7QzZMK6juMwvRBs9o9bCtu7iAbFUuATWi66estm	1
1534	2vbFNhpqjzRiif3eSMFPmq3rz4FCG11tVCZAKbjdBqzEGS4bMFyQ	1
1537	2vbRHkuLZyGQzYSqJSoDovJipREeBGpmcFSMi891nj4qC6t7fFJW	1
1538	2vbDJCoxzYKsFfNeEP8B9maEsXZa7TMDoZ2fByT37zsVqbr7ubYY	1
1543	2vbkT4V4Urxg2zGhGT4Hy1vCbAmTiTGpxhWa8vAb4esd3cdyLZBq	1
1544	2vaUNfQtZ7i8h2RY93LD7DXarZ2muGUWvSTA4cpm7HXscveNxGqq	1
1547	2vbTjnNBHiBLZA7y3ojuPTahL3ZA8eMCbmw5GyyRc3x2kTGYAEH6	1
1550	2vbxSjXvQiDfrfmx3rg4e3bGRaiypKqCKr1BGtxQ6YWtTBHEfkEY	1
1555	2vbtv88gQ2SWLFFkPiZeKv7c4TiaGkzD7u35QdohhWzjHfjW7YEm	1
1556	2vaf8tzdNZFvxbzkm7qjHKCFWo9VGUvNL6hz8hzRApwBRfJHaw8X	1
1558	2vaiYJjHTTDtLirKcDSzk26rDY5AhgiTLwfEeJkqEoSDEY3Pspr9	1
1559	2vb3d7hAH3gkbwVELmzuYFF1FckomqB5G3wchuNLb7eYzm7pSkib	1
1561	2vbz9r93vnt9fPAFvi9KMRycVrf3pj3fUSWukXo3H6n8qqeH8NgD	1
1564	2vakQV2eA65uo1GKoSaWG4SY1iQnc3kysWbHc6P8r1p8w1QUvYF2	1
1565	2vbrGdnNUnLhVigwoqWZE92WsVjs9dVZix1NcVd6Kq9CF2chFddU	1
1568	2vbUiXS2tyZmpmSBqW5b6VfRWPsDBYhByWS1SZC2sEsRY5VbBre9	1
1570	2vc1t1wkHKVQUZq94spG6j9kDwpe7JApCgCUg82MQhxpgkKcHTCU	1
1572	2vad6opHuitQEJuPUpNLyUYMx3RsBtQHNAdUs6AeNtrdJE8Gqm37	1
1574	2vbzmFyMK56R9GUvNP6Q2KMWnnq92TVo2WssUDNzteZMzRuSacVA	1
1575	2vas6266DsascuxZGionwNm47CEhpk2L4jBXDgkRnTPQE9HzLVr8	1
1577	2vb3hL1RbzQdq22x5EP5FfRxGQa9vZNr7zUJoz2VeNYfj7nJxi1M	1
1579	2vc3owdPvjg7jwEF4RP1ZrHg6LoRSMCAJQc5fbQVJ1L8BEGRrBuN	1
1585	2vbUdtDGeTfnxZopStwzcEbeVXPAcppNpNK7Rz9RFjPmq3XLWvhg	1
1589	2vaumdA58tLfTXFp8EFjDh8XqWDmkoZVaBKeYzu3LtW4MaT7obvb	1
1590	2vaR3USwWie7GQrCABRe4VQeTS5FjqsTYvFQJvRUvFBB6Qqnhg4e	1
1592	2vamhACjn4taLRCHHjTq4R1pY8yxvE7dDu7S4p9JVdpbWuMaBYoc	1
1598	2vbBZkfFgXdnp1q1Q8ctRMc52a5nvkbqJ4RMwXKo42yGH1g6H9EJ	1
1600	2vbDUyJyPQ5HidD2BasCcdUCRK2YWjxNUoM4QFeM2kVm88DCno4T	1
1601	2vaP5QzKdnKKcuRData1QJAVHPdpgzu7ubfqPWrAvYhBzKYDmzVx	1
1604	2vbwtbW1AuKDWh3JjPzKtvXVAomhoRHEwd7SpzHTUCxBYDRexsnL	1
1607	2vbt2qorJhW7jDkwSKs5EVwF6BEubbXyKPNprKVY6FMm3UU7i1WS	1
1610	2vbnASdhCame6N5NDUDVLcCS7foBWh6egntnnfoXgDLyKEScMCSo	1
1611	2var81URQ1gshKbn3agg9TjTbL4NqcuYPBpKLasmM87Lczr4NRxS	1
1614	2vbqAGCnFs83Wu5TDjafKATzR23hZqc9ezAsikHJ92THrP5nuaig	1
1615	2vanSguZRG5fCeovAFMCTJtz6sV2yok5CUJ65mWQbVu9nsA8HyiR	1
1619	2vak8AuHxjNUH4xVdjkGfis1EWePT5bgamVruBHsW7B8LRDnK33C	1
1622	2vbT4RgyfHTt9NupEd4avpppLpkawcJuraw6VQhvAp3q9ABYt2TT	1
1624	2vayuBZ7r4MkjfQgoa1ANa9eZbCJLFaKEVQ8CEz2muSzpbXZem8S	1
1625	2vb1jxt6fKrqd2q6qSxrGNjEs87yF1hY16njsRRKcYBrH7Ks6Uww	1
1626	2vbLHefdJAFX7ThSMhS7AKFkt8eS6ucJWaSCPrQGyUNrrse18nQQ	1
1627	2vbCATHDEaJzdccL635hdo3mJwnF1WemVypD9SeRB5cLJUcHfnPs	1
1628	2vativvV3A8jiDnyivkiw1kTCH3Pn7XDnR9trTV1gmsehJncaH9c	1
1629	2vaQAVfCwnanSKaQTHH7LMcS96qJapvqYaPHddVjUYw8NB1dysKk	1
1630	2vbHBLfzoAvkQ7tYfxsaijq5t8AUT1d4Sieb54QvqgyWnVUFfTER	1
1631	2vaDg9Uu69EifW1hQFwHT1UtnjA9hCgdJ6aBBTuuSSF4WJbLeRUL	1
1632	2vanU6jmjNnuLRWgUySvFRNfeazmrooJx1pHgHGmHdq37f8HsZNJ	1
1633	2vbPKVHE5DPzN8wVCUhGWuvXy7FzgjaKmZZ4ZhfkTx3AjxYXhUqn	1
1634	2vbpYDtqcV6u18fZaSgpPKUdWhkJD42j6YKm9L1EpwiohhUSKGdi	1
1635	2vaXbtUpLsBAuvkNKD2CTrx3kfD9goFAJGuxdLdEoKT8fKb2HZya	1
1636	2vbmaMreqKLwVSo8zDufqhndYfrrTrtDS64FgW6zSjRMrCTHwytg	1
1637	2vbbFwaqf3jBRfzgiHV6ECn7t4Dh6YeG5cmkK6La34Vt7XMsoK3g	1
1638	2vbtoDTdUW4uJ7LK833SgKuvpn5ThzqV9YpWaGx5mqhh3jCkvwU2	1
1639	2vbn2nmvhsE2n6xVVmbvUve244hB67ZR29gcpXWtYQhChuKk9W9t	1
1640	2vaNb8ZGGG953Fyd3FbRw1ySLbwF1GZy1k5BT8Yb2fuBURzcpKQX	1
1641	2vbXLRmoJvgqmBjprJBaKqDnuKmifwJB58xh4w7wjSRK1npAzJjv	1
1642	2vaYySgBdAKGxCfZ8mTkjsnUTkcti6VYBz9VfyXKgVRmFUqMDV43	1
1643	2vbtgQTxzoAo1Mso3H6K5prvTb6DNBTFpnVF9nA8XM8XzxrV3dXn	1
1644	2vbEVGGaVxTaTyBgmdThHw2DkPhNBKXMjDiHgTjLfcCifQAtVXFH	1
1645	2vaDbJu8yVzLAWSHv5fKEY8UKd69hSEtZ793KZ1dMe78mXvJXS7s	1
1646	2vaVGZWqGB4AJ2AaSvaZ9MHWBS8KzF1f7ExuH4Eryc4bv2V89SM8	1
1647	2vb33YiSoAzPN3UBUTb9U16DPcV5pW6vF6Lp32toWAv3a5orem6o	1
1648	2vbraNMHfvfmLhFWwaxSwaxPYPzaaR3nCh8s7y2F5uxWEd8bLqRL	1
1649	2vbFYPFJHZ76RDbWHojHu361N4ZzwgitBPVrhk8pPMQk3X6AwiGR	1
1650	2vbpSB1VE14eAzXxCRGWFyiAAJshYRjsSuWjRTrjQyUED3xvDWZA	1
1651	2vaBbtfE1NkLN4stXohLsb2M6mUWqfnBBEijFXVPppFiGSeAgvff	1
1652	2vbn4sD5E5GtVDZz2VX9v9Ycod6KCViLWBa9Hpgp8VqL61bQaxnt	1
1653	2vb9cV3XDu6MLF4y9uzjJDb6v9qsTJRCYTs6na3vZUFGDh8vm5KR	1
1654	2vaWR6xAJdtyrDfjQqjcxhk8UUZA2wMCY8a1Bv17MmcDCvtq9PKa	1
1655	2vaosgPeyWTh8VJ7CXd3KptNzSkQxvZKzpzQWMPy2aqeW5tJ7xTq	1
1656	2vawFn4fAY3vSihquPaERfPKJKUWYbX1VkYxAN1TpAYgf8zXixBo	1
1657	2vbK8afdGT5iVGMHpEGbGuLZNA2JfjfYZhX4S3QBtAE75PaRBT7E	1
1658	2vbBTMe1jc9uSapF7qVPFFThc38sVKQ5tdq4u94k2FPnfysCUNBg	1
1659	2vaW1mqZqLFvBdUyPUM2mkQNFcX8xFDariapWKFgHbW17mtwKy6A	1
1662	2vc2yj8ztYk1v6LH1ss1TZpsjC6SQhJGiDBX7pUbgMPe3RZbfo9m	1
1665	2vavcAzRgNi8x7smMxg9m6mDCV4cw4w6k19pX6sKbCecxYGtcNYf	1
1670	2vaPS959PhuYwBL2EuZDmWniuM85JZVU7Kxkg8aSwp13QuzZZkwR	1
1673	2vbBZdtuqyoj2Xm39EwAcfcjEm7PsCnep4qQVEFKEJMtu3RUW8VZ	1
1674	2vaCZwVXjqsADdQ1GmCEXtrJUNpdZhakJFegSbwd2bSfGifNJ72V	1
1677	2vbQFywyNQCgnW52fa8QpaQgz8Bi3Ht81kHb4pRzm4PinG6Qy33D	1
1682	2vbfdCN115TadmvAgMdPT68jS4TZe867cC7kFFKeJCuSbR8AjRSZ	1
1686	2vbGKdSus44VUzeviiQw8sWiFGBxqtTj8AUWKBNTytJkR7iUB6Sa	1
1689	2vbksxwG6ZkEEnDjaCE64FSeK6oLWzT4oXMRdiwB3HvsEHtCFrHR	1
1693	2vapbVWq3XHLgES95jnC8huMCbwcEYwYtj7mm3fNtJ2qGaQziQXT	1
1694	2vbJhGc1L9LsjiNzQPL1unx5n9rsvUABXoEJpbjaATMqz1nnZtoK	1
1695	2vbQEyBmUHghoX5ViYyTc5SLMhyvYZ3Dx7eopseZSTyKpC1o4hcm	1
1701	2vbxVFDSTZNWAAZLqMNK1sFfJm7DuG553Pqum2BJ1Pqp9Z1MEo7s	1
1704	2vbwh4f99T9iUSUM1KoNCiw1JTgu6Tiitk5gpEKjwnH4S9AeM1ks	1
1709	2vbGG8fe2MBPR58jMEvkLUhkvXfG4RSRUAS2PCbvEBwbXk2tM2NP	1
1710	2vaQ2QkGPwfv26R4g7Ww2vcZfNMPApGJ6nQm7w5qc29SrHZnSPYV	1
1714	2vbp6ytLrvSPV4mVB1d8JoKtvN38c4Zg4x9yYsrqzHVxBYhDQbhZ	1
1715	2vaqv4mivLQRAi7qNDotbLWgR1Mu28sh7gt3LP162GkoiHqzRtoe	1
1720	2vbVWD9tEWGmEuEmVLxSLghC5nuyGhrkgGsS6pHwWqdsap5j5Du7	1
1722	2vamN8jdWf8P1iyDfCWpT6gAYCUnNYGJq6ruhjJRm3zKyDyMXBot	1
1724	2vb6cFWuD5Q1b5KA6pq3cxBSznaVZtMf5frMFrbXo7zUvrxo1YPX	1
1729	2vbbVFq7ZxKsqfBxfCyhMU8JNSpLd3a4wkVSKhM7pFNXFwRk17R3	1
1730	2vbfhFFavVigA4Ze2QzS6eZWNLdGWRFzPUftSk75HT8uRTfAr5nz	1
1733	2vbpF4C69wS7zUcqzFvTxaWXfbRtYsixb26o8mvq1XBEbvvS7jAv	1
1736	2vbm2qpwn2QU8jM1LgjLNxTEGcsKigodwzBbVmthQpPDDDEfKFzN	1
1739	2vafRePiMeJsYsMTrgrZfKnhDi3NqanJA6AoacHLiphRtBUqHry2	1
1741	2vaHY4doqYXXvmMiw3iNQG3KuPg5TYMmKsu6ycwYqbKRZENjUh8Z	1
1742	2vad1Wad8cCGSTGWwtxfisC3vziNYrxHXK1Sivk8jBUVSCQcU6Ea	1
1745	2vajWHZytRZBUEF1c52me4VudfebuTfQJ8pmiCfdsi5p8wBdBtW1	1
1747	2vb91tHN4ZvuYvpTnfpPgJqchYuLa3PdSefcLuLSnD8hcmi3Dpvh	1
1752	2vb9Zr5jQruLcZ5yeeYBgtJk8iFEfKmkW4baRHvxABVSjqKPGnzz	1
1754	2vbH6hvX27THmnew5mjHYfnz9xmffGD6i7pHe6ZiRhEmFpTnsWE3	1
1757	2vaDgfpSFMr1nkDoYq9eEM22mSpcZoWLgjoEXKeWz4eWCGTgda9N	1
1760	2vb9RYuup7BFdoGUW9DyYoWMyk7xBDRaR8PqsdKr6YhUde3fpNtd	1
1762	2vbfaV8QW2Wv8UvJSUQ23kFJAEqDmvemjFK7MSj9hi2yDrbnXxvi	1
1763	2vb3MJ6yzug1rVqdY1e1RSZuc92SpxxdFehWuhEwmMr2YjJHouWm	1
1766	2vaWj6Sa3gYFPtkfcT9Ya1B3ADooFT9EjkD7RFpiA31LRHnu8SrB	1
1768	2vaxsxfxQUskzBmD9e4drerVUToq1VVkLHeCvTKbYnyJx5fSryxJ	1
1774	2vbrMDEzUjCetwsswbLux1VcQqR1r8dronV8RV1cXsaEH2A43zpN	1
1778	2vbdLP1J4Q9iGzDcHCafws72NjxxR42tnSSrvYZtzzXj3wWEtF7j	1
1782	2vaQMmTTR5QzBmPEAo86fGicvN3vJyLfTWe2FjecMv4ZuM7VJBaJ	1
1783	2vaSMLX2V7Dx7hsaXWNEZfaLCZH9MewWhGpVDnT64ECHXXfBC3kD	1
1787	2vaS4bMtd8q9S7ZXnxbjrmXpkqkiqbu4kzAvt4FD6hpwZS3qLPHv	1
1790	2vaLzi2AHdsSAjqzaf92bd6GbZrGPfreTb5jAnb2RFhmteSChpBa	1
1792	2vbUPpJmQfjwg5DoNpeXcQUjZGLqyHPW2uQ9yioUefJ3FsrikF5H	1
1794	2vaXBu7io6fakzhZxZep2KPSjgAvaCfFuiWWyGdsr2RPxeN44vwz	1
1798	2va9pV9prNzgJnyzfGohvPjoKaPXB6recXhWKQaKtnNrki7Hj3Bz	1
1800	2vaRne9KE6CMitgFTH177phTuSqTdhNPr7iEH4GXMGpB3dKvUtfF	1
1801	2vb6JrTVX89HznzB836Krc78BRBXkEoPzfaHfPg2DLpnrf1WjQFD	1
1803	2va9hL8Pfs5GFqbY11uNgvF7azHVDzBgU6drowr7Vc5wEtB6WETM	1
1806	2vbUvQu8rTKMPaWSasdxj63BCi38YVJy9PpG3hAjee8jdLLLtbPC	1
1809	2vanDqQNBZpA8EoPKC86bo81UyRoj4jDaxX1W9DrboUReU78Y5w8	1
1811	2vbTZsDANjQJT6CUk6zsQPCv7h5bXNYYec9sacJeCvjDK8CNNxAs	1
1812	2vbNe6WqrAs3QGmyG1RfRNXsauTAoXCqZmYmLDY22Sti52F1X58E	1
1815	2vbYcNRUuDGMtax11xRzhh6T2NHSbfGi12jZAZsYJ78G8E4ZuCrK	1
1818	2vaS7CmTGQqf5a6RMLpCAmizfwokNP8DBYBWZ3EDd8ZMArgC2D9p	1
1820	2vbmPnd743CTZcf1gD4J8LWWd31Rnbj55DVkFD3x9zxGhZTRG5gN	1
1821	2vaq6gjvfhTJ5LKPiK9JBpcuWHBtvsUdge619iAthTH2ciUBHbgF	1
1824	2vbUXo3MS9TBsg7N3chCzYTsE7dvtz8xnBV2qbi5jhtdsZj7wMhQ	1
1827	2vbt3ZEVzpsN4D7CMGAdNcBDBo7dHLPj7vj35EA5jr359sLAAnEL	1
1830	2vbscoGETAwxK5GUsxWHwr8CJb7Q39krtsBXbqX2QVmrkTDCGqxi	1
1833	2vazQVn1yTgeqN4uGCAR8MjriDSMRNk5Teo3nL9z5zsi1akKmu7c	1
1836	2vahb1oAQTMDaKRwp28M9QnQT877fksU13Xpr3711fpdw74suzsh	1
1660	2vbgFmuZsNLCfsdJ8VaFNpgs3qXKsbjFkeCZ58hZMCw4mbpnsGWj	1
1663	2vbiH9oo7PBfR8hxwp8W66CnbCqV9CheyH7F9U5wgpXCqzeGfSFx	1
1666	2vaHMQq3hw9C8R5KU6hQNJVF5vAiHTWzVc2wwBX2vfEs8ds8FqFU	1
1669	2vaBg3hopQs9JBSpSBn6TbDztJifnSoHop9pWotGeNpqvb8mzFvC	1
1672	2vbAFHwXtXJ5WhqACB4tALG3G98Uo8groNCxGutwP7r2dM6MzxEm	1
1675	2vc16EiaX9UJJqwXLnSPBfeHe94zUr9ty69kFBCsm9vytMR8qQhH	1
1678	2vaCLYd7nuVchPjF7w36pQrZhvmqb79Y1jFqLUM4XFfe12Qtmyzt	1
1680	2vaa3tRWwLPZC8wLQtzwDd8juvgPfWp66ooPgDWj2DZpX55NmBRE	1
1683	2vazfgQy4s8yE95GhY7QftxR7jzJQXVsdMEMy6ZhzGGb4yTVhJio	1
1685	2vbc29SdtKA3LLyELhg58Gy9nRhQAdVUWwmAwqbdM8UKeFbHoEmj	1
1688	2vaLvxXWe6adE4GumJYbHtvcJHYjZPuoEbrqTispE1iztiqwcLUJ	1
1691	2vc4PznUeAZTXbEy4Cdqvwxr3HZNbmta1RwsWReCVDt3tGwX1RPy	1
1696	2vc44hXbQAW6Z9AqyJuKSmoRqyLpgXpf5uPAk36GG9cWeSpvkVAr	1
1697	2vbFr2Mntm1E6oXjRJJW5CahsBQVTUE8Y5ycqJh92dBkMWhgeBBS	1
1700	2vbmnGmpfAKX9VEKCXGmwQsLf1mBGPYVdZKRr2WALRv388kR6w74	1
1702	2vbvNLGWJwq44jWBQk897GRb5DHUUunnGQbkuD5tTytXzhFyAeQf	1
1703	2vbPBYyA6wB6TtvEUGgwi5WdGnnHfxvC2jRtFirzdMGUrijzamE9	1
1706	2vaftR57EAZoqTVEw1zeQgMhP42NcT6Kxab7NfyERwrGsUTuoT9w	1
1708	2vbQ8EtHSY7i7PpUtz5Zbo9LjaEjkdgQBtvjF8bcWjd167Y4bryh	1
1712	2vb2zubtik6iPuw47zopB8Fz2u8iM9xEpY1d7BDeRbS5yfZXmn3w	1
1717	2vbV47FzeDTo4HUQohyaXunoNTqdDrFXixxt85ZE2bNZnBLPc3L8	1
1723	2vaZmYk1XaUEQAy5pyeDydJhWQ9Ct2EGdomrEBwneMtVibidbyvm	1
1725	2vaDzS7EegjTgN5fYePBRRDX1qoEfK6HpgopPeXyosEBRM6eo5qF	1
1726	2vbt752zZe5gDEKRd6ue74LMQCsfwbcmQbUBnGf1ntVdCUt4ru8v	1
1731	2vbcjuEBnvFh2MwJK8bmLLB5cnedZEG7G6253oAR6mFkwdmmXL6A	1
1732	2vbckinVVKyvmSgT5BxBME5ycVVzaNZagpbT9TqgzV2a9ynbPhAG	1
1735	2vaA2wXqMaVZ87jHkAbt26tdPJsEwXHmYFFTqCXjKr9cmYetpsrY	1
1738	2vc3Sz5nSo5CS9mJHem2qha7uBtQsJqsCpMVCzjFmTfuzCCEE3Ew	1
1744	2vbGmGyLgcsPP7D2QCW1TeF2AgWgGJLsJFXgU5TiQKSo17Bhyhc2	1
1750	2vaqzcbauS4fhxHMhBTPEaUfbtaHRraDQfcCMgm14ovkh9SgjU1f	1
1753	2vbdZL5pEJWbTgrVfG9151JUToMehzMsKEVpHKKVwLaaD2nvjDQm	1
1756	2vboHqFn6PVXYUvnDNn8XuAQRs2eaCM4M736eMKAopFxX9MDt7o8	1
1761	2vb3sG8K5rRfNc5dqX4ijpbRnqGrizEt4asuUWwN426wJJynwdSM	1
1764	2vaxDntEy3q6cbnC73GQaZinUE4LMgQ3dNaEQeb2qn7R1e7F2xC2	1
1767	2vbEBNx3tseLvvzpWiFD4vpFQRVdaG58pmr5sQAPXDeCaMTWnJ1f	1
1769	2vbQ8TP7saG4rsBXxmLwDi9wMo8w3BSQ2smPibo2Jem8uuAGtWZ7	1
1771	2vajTrv7kNLxNDmWWAZNhTp6qALVtEagJ7U5oNXX6xZ5njQYx6jK	1
1772	2vbLibJ4211pPraxWDfYE9iirZb94KFPWS5epVD43uE5CQaajrpa	1
1777	2vbVEeUY8Px6t8iFPyrgoBH6Ev4WyCEatQRMv25yY8oZTbKNPegd	1
1780	2vbMNauHYu4GEPW8KDXQE5xqB5WzZxtnzFTjVQdiyPGmPoHotsee	1
1781	2vaza3Gs3tTzjhjZfujL6C2u34rzEGvt4MAEjzvKZX88m7Xvoy3d	1
1784	2vaz5rY86q9sjw58zB54upmn5kgcQzrtAMvabXF9LL6vfxnRxB3r	1
1786	2vaWkcgnHCSCfQ4RcqTxsVk191cu2RzKTDMFhrEnUwjXWv8pmHbj	1
1788	2vacunaTiq2NmFSWd94Mj21cAmS6dXDG5qaZQu3ZcPgm98CHqySo	1
1789	2vbJ82dLssX8VcapS9fsZqdDxxVgs9RKAG1XxRXeRj2fQjuM5iMo	1
1793	2vaksvDkkA4XpxqpBgX3kvXYaGjzJPCaA4nwKsg6o7yFXWGqy9QJ	1
1795	2vbBoXwPY4nBckjDpazDD3BTmf992fU5dveM8PM4Pp3jnD6UZ8Lb	1
1797	2vaWVnMz1iNSF8GncChqEbhrzkioK3BuqhNySt7Mp3prwv7ByikJ	1
1799	2vbePv2rMLcGkcncCs6hxWGGwrpmbWq1y1iUkGgTXxJfnPG7nkDu	1
1802	2vbj39DJakJztFdgx98bE7dPn6vLxb7wTeVsGfkQaisRU7oHVufj	1
1805	2vbwwh1houepJscyyZBydtUDmf9vZmVaQiXyiYhs5G4y4ymaMTq4	1
1808	2vaUEbsV7zSfn3vMvgFSsnt5EeeVXowmm73BrbypwwPomGupqeTD	1
1813	2vaWmGdLWQaqMZi6VVBnTMccYCVaEQDVAAqFjAdhaPFB18EdVA4y	1
1819	2vbWDPUcRL1jXci9mqCCB27BcDSULahJB2a18Rqytys8cumqtBJm	1
1822	2vaEBNRg2NBT5MboRWstzUBtGfaKURtKGGXuq3p8FrF58RbvELdT	1
1825	2vbeb3xNgUrhLEDdkoMAr5Ay7kqHy99qCMmEc9GsyYmFvgBSDJ83	1
1831	2vbAevzfLHkGPsx1eP5zNgQrbu7dZ4ga7PrCP5e4eHen51ELKZHi	1
1834	2vbvgTY9iryeS1qt3JVgBmFE2BqY1Xj1VTBfdvXgBrXQsvgAAucb	1
1661	2vbj8BGBzDq6Ko31mjQ1Cn3g8kE6WmV6dG9VCsv7XcV48NFWVVq1	1
1664	2vaK5ECEfJs3jBLd9SHXWxEq1u1yBU3tfth3N23ycBE4j6k8rh3K	1
1667	2vbHbuzgpa32a6G1voZyePVFHTPQRwX7hmeKaLEivx3vfkBJGu92	1
1668	2vaappD3MyfXj5Xpo2ReN4PRwBFjjf4emYsphAQnHhTJJWZDtJzU	1
1671	2vbzfzoivWujQ8KGUb6Wmn7k5CDBEmYeCuG5dLNd8LsvwvHXRHxd	1
1676	2vaikEafDGuhnfNNtJPcs2EjLLFf36oKwhqnPEAbnhQaCsLAVv1k	1
1679	2vacZniZKbvgKkptgkMW51MFt8X2P2LPSB13xoTLXfb4uVusLonK	1
1681	2vaLJFRivqCJUuPrdwufQDyQv7u76z5tsybEBsTHukX1hKR3tAEj	1
1684	2vaJHo5CLe9XU6qt6LE4Ldy9ViNWtfYSm3PBUw8TJt7tWGrTER3Q	1
1687	2vauanTSyi2t5NACdm5F73L6bS4Yi3n5FqVedexTXLMnXKZw5bAs	1
1690	2vaEsPTyFwdcG6KvjTpW5KnEPeRiAtYE37gskPdt5mBM8dZNyXyp	1
1692	2vaJY5hCMdE74qg26rPvwANV8kWzBVpyFdHcyb6eDuCHXQ9h8TPt	1
1698	2vaujugFWXz2HJ3DH2UbiixCae9gmhsQiMssC4VvxnxnfGpNBkLX	1
1699	2vax9ch1tDNEfBZonDgbQ6X9wFbw6aBvfJsL2T44gfPvvmWbbbY2	1
1705	2varU5Lk7pGgEDxFAFqtyr8FVHeqhjzK4K4TMbS3TCDXTFxpVNRS	1
1707	2vc3RUBHvMS9ktEmAyvQSqE56iMDQo1uKvsfRJBgySueQXFhC4xN	1
1711	2vaazVQXtC6ZBF4HMXYTSjfAhZHbE6syiLQu9xahNFsLfsv3bZiB	1
1713	2vbdAeMUKZF1KjMXThrmqfu9sD1CWjNQ2gyryZm6ybdsy7mJjTww	1
1716	2vbEciRhFd8vPFq5ncSzgZgbH8vDtYqRspYw4M8YUy9RAJkmGAMP	1
1718	2vc5tVDQizNBHpkmft1Xdtvbefjvh8JKWkBS5zPAAf4isjs2hPhm	1
1719	2vbhBxbpuGxm4CVDaLg1qYTPFbkC8hh81dLcHRsJNCnXkq8rym6R	1
1721	2vbMQT3pra7NDtLYFz3yqK9UAGARDrTGfUL3ev2WdSo2xYLEAkk4	1
1727	2vaV8X5bTeu42d7ssxPNzjBZPF49bESvudugk5TLHfRVQPLazrCr	1
1728	2vb1og1bJhU8dLCcnsEBhwPGMH4PU5zzL6ZAodrw1uiFALTnbyKr	1
1734	2vaeYwfRNJ764jALXYiE8XKhMb7zDj9N1LuEdKRuM9T8v9XuB7BR	1
1737	2vbSDSoVYG91ZzSfxfvJYvmMLo1rrM9ureK61PXH7mEiKBpV9ij2	1
1740	2vagwAFKjQ8GbvKwKm9b74kCDXocefXLeD2gvM85zsr3CyEyoj4s	1
1743	2vaSUjKwDFgbcNwVZTDncwQkyVRK8myaeydF4BkUX2cGDa1bAc1R	1
1746	2vbrBe2cWCVbaooGuChqGSH5CW7tD6axJriBXs5X9ehffEWy4FQp	1
1748	2varbBx3dtJPktiFGsYb9DfoMimCzBeK8aaKoXWPvy92UqTwVRQi	1
1749	2vbCVFhM8QStb3ppSbEeyCz6eWVafZoTB8BXBQJdeKBMDA9SJmpB	1
1751	2vaMYF4JJ4dVMgWHCTmfMCEqkxpuTrJ7QK1BcrMLiLS3xkNCierL	1
1755	2vasPYBsSAbyXHsAFpys9VcGiALYav1mM2qUD1Eia1hcvHw5z4pD	1
1758	2vb2bJmzz2EmU6W9eRNUL8ftebx3aduCExehaRw5WVBu2keGZMa5	1
1759	2vaAig4BmzQtEhWT7DCTQhTR2SxVzoQFtHdBSjtfGs2xrZVQcG4P	1
1765	2vbvtK2qV5KM311VoycvBkenXpkCuQehZi4vyPyYCJt2fLQVisNA	1
1770	2vakk5Ga626pFCCyH2Fhdt4XVjBdsK97TfNPoMeHAimEMPSCedqa	1
1773	2vbTw2vitGgXX1zRtagcShaNMt3BCH7JK4oL2W1y7FVCobBuvyED	1
1775	2vbJRbxHzE26tjbrf1BymMjjysWdhhf5BLxtzpvq1UsLhC17Un9s	1
1776	2vbNeUbmg82c8QJVuMUd5ER1onCFCr3wFECstM7R2SBi7M2TfNQV	1
1779	2vatbUc83fDk82kjGYXvQXDWomfyURJKFz65jdaj7NbEPq2TNLCy	1
1785	2vbxmgoHScn9fZ4YjbB5GfbPdPauYXuLZb1yMP7QZhSR3HZkp9Ft	1
1791	2vam8e7aiVdVyMsHMdJTdJ9z4eVhfgHunGSD5xsmMDuhF2bQspSB	1
1796	2vaGHL4yAmX8ePRMQePm6DKj9SrD6WkwU5zykWzte6MdpaQ6gSdc	1
1804	2vbKMxmSbKvNetXmYjLYf5rSZScVz1xKfbd7ymxgrDwEffdfNu33	1
1807	2vafQCKUTPRaQMtR7jpd3fNspPBLVd2qStYttCpZBB5RrFFzAxF8	1
1810	2vbme2AZK9YhmYVsfH3WNiTYNDB1rPm9T7RVBqCvcr5LdNFyRVr2	1
1814	2vbik7LdaYqaQLoxfcBscwmGMcCc3tcFXR4RxL92p5vqFnLnyQ1G	1
1816	2vafPLWQxht47zgJLdpwMU4JfXVpMcAZ2jzjwxHVxASGPXA2ZGsU	1
1817	2vaFF51jR9xsG8ujV7Y5ECxJHUpxQerU27wsberWHZZTTQTYfs84	1
1823	2vbjUehGP5jxUC5x8bA3EgBV4jEoLHSnaTmx1wWsDntTzaWJt2Y6	1
1826	2vc5smx5C8Pt2fryDSsaF4aZWh4WBmmGRMyxJ3E2By6cZFdvif2m	1
1828	2vaP9Fg2yr8zMwTHSLaz6RgTj1LfTua9nTMTaMF5s2e6XrpZWvjX	1
1829	2vc2LBPmTnwgUJAQV4vRueyv3MosXQA6NuAwnto4TCfBnBxv4Tmo	1
1832	2vb3bErcsDbTyZvS54sgQbqGD5VAaDv2v2giuNm921EHB3omcYeq	1
1835	2vbGb6JxoScz7p1XPmM8wuDcidjWR3QtK5TncfLcURQ2iLuJLq4j	1
1837	2vaW6F2vboknsC1snoYEEaN6mb3Vkd2S5REa7xBf9PY32Eo7PnyT	1
1838	2vaSrsucwNaRvuE9fUKo3kDakC832i3sP2Te5wxXRB18v1vkY2Qv	1
1839	2vaZWx9PUnpeEuik25PRxEZV3VfMiwBV3wTGcsCCzZYVrAbjRwWZ	1
1840	2vasSk2dcWYNgYtVopCCY9yVMC9heFGazb7mmZjwcTqaJW9LSWSW	1
1841	2vbzgqhBbfmdpZNgboECxka2Dt8Hz1XxYDyM2n1Do8VAXTV2tttR	1
1842	2vbkJsquXGms8UMdWjy512yujno4QMDHsdngYTezjHJydoQF1pgV	1
1843	2vbh1eNQeBPyvufYFPAiaEH3qL2KXyisGEWd2xWMca8BMQUTR2sh	1
1844	2vb533Yon9fCfQaYc1meNEAq3dVwwcVixrJUfmH4yPerDq9Tkfwu	1
1845	2vaUvWneDZ1s3czomGeXorwmpeY7Ah4nPjYXGwZ3WNA1XBZJ16ML	1
1846	2vc2MQR4ukGfQbwd6bAe4WGvL6hNLEaqMbUfn87WGUUekCMfv5b4	1
1847	2vbbaQw9sUgundsTSfxmTESEcoTEZE4zgwK9JUqSrA4Tm7vqDkZN	1
1848	2vbVtqnxFTpxpax8MvBJdcMCsegQpqMdNizYogHtvjpDQhaabTXL	1
1849	2vbboBVAXUpJKhxKhuh387RgP8M2H2JYyJ846ysp9UXxPwmFFmnS	1
1850	2vaH9ruWKHsdQUEYvcR9m5vFuDrmsYD3SGxEeYf21GTTY3h8wVxE	1
1851	2vbJ5ezNkDUdxCE42fhHAaXLttkEyGtxjyh2GN65HZBVg5gprkLA	1
1852	2vamgY9MEgNgHNQuCHMus318sin1MQD4iegWD5Av5yHPjpgJinG2	1
1853	2vb4zdpa36xSCDTacNvhNo25Sio5Ju1QJHedwKH7Qg6AW7gzGeGP	1
1854	2vb9ZVabi5VpYyBNsk7p3B2iZ7uhL8ieK3NpNymsyygfKWL1jkB5	1
1855	2vb3i9D7c29kqhGPyXpJkBpYFfapTechqJr3zUqD9beqAa56ZoQj	1
1856	2vajaygj14cpoaj2CUwoggD8oWAf5ZbKfPpnafmqz351dikM5PPD	1
1857	2vaKJD9HxtoveMgtqvQMH7NfKjwVfvWoCttBx3rd7C6LRbTZrcm3	1
1858	2vaBaFmwfm77Q1EvRcjciM99pHpPs1GnTBoWMkd2CMUmkk5hkAYD	1
1859	2vaXQrE99QuJx4PqhF8f2AxeLLCK8BRqjoWpAA5ffHF7SdDhvJpg	1
1860	2vbFuzdf4NrU8A9qhZyMcTk3U9P8D7tE3LnwwJQNGzEhvQNByjFe	1
1861	2vbbxgL22qUxkC7mZrJec82UrvNNE31F9WA8kf9hrsWPGLW6fC1e	1
1862	2vbuR19LoSik9RQ4qRpPpT3zmZLkN3NhgWVHxQkQitiwr42FUVst	1
1863	2vbj8RiCnr2hVta4wc1GwcAizDFhcHVrzCRfHWTi1sr31ULydqis	1
1864	2vc115j69MfruxWLybsLqKoKL6DXRrfpA5BFmaH62uaTwtj4sG6h	1
1865	2vaK3ysDFCCpU69HGXsKzWQU73QJ4jbX82uzGmP1iiidzfQFPAhT	1
1866	2vaDNEyuNMyLaP4RGGWuZgLDqRxLYJ2MfEvNxupzRAspuknfKc16	1
1867	2vawJ3APBNnfXWNGr9GJMaDkc3AVT7LA5fiBJCNX3sxvNR6A8pUs	1
1868	2vc5mGApmQU1RFMgEgxtxaBLsBeW2vL1Wj4P7d6KD3gHdMMwE8u8	1
1869	2vaNVocegjtz6hdSiWsGw2dchnzGUtNMQgei6ZgQvr2RfZaLftsK	1
1870	2vbHk5gczFcVFDnDBPi1V1hHJ4yrUCnZpFnK4zD6CvF4AHkj9V8P	1
1872	2vaaajLxvA9nUfDn1oi77kFTtmyVe5D5CGwrFroMLiVdjdNfaKnA	1
1879	2vbEpQq6zjzyf3pUPjLfZmUKBmJck6mnGdp1usXWpMMNhakb7zsj	1
1882	2vaUJfjpXRHH91sRc5aXFPwSJ6vXjhC7FejnonD18k92FJwnSvdX	1
1885	2vbem1PtoNS25vLZnEHi9QznNkAYfXsSWwgdAmziXDYKTeeMnBsb	1
1887	2vbupkjtAyVRMaLsc2jPvv14UkfXpAh3EyTE52wonrdNP6VktRta	1
1897	2vbBKMv5ifx1sN8kTeeNutaxBJSR8WTKnc9HzEaCWzbDXPYfpdtU	1
1903	2vanQn8b3G7ae4kWGYAt5AvXJPXbiRtEpQJPZ3rqZupxpNey9mUt	1
1906	2vaMqf5xdij8xPEnNPPyYApFZazYokCLCqBK9xzG1tdaAkMvf96h	1
1909	2vbgURRbUp33aJctcSoF9TSd39vk5K8dSiLHuufUBk4k615Wj4nQ	1
1913	2vaJ2R68JZ3RJwsmtYPqGSbMgUYtu88kSrBW3Wk3xd2fywed31sZ	1
1915	2vb9ZFYg1ujDE6LgV18PDMXe4pzM2M13AAHKSDjJqTeeFiL6xNMh	1
1917	2vanEDvTBwKd2HZCnt8djXiuiXpY139y6x3yGKjSPpixMZARpBCE	1
1918	2vaFcRwnyUM7AVbwRLT5CMMHzqM2moUpc18gx7vWjYMmRbqX8AG7	1
1923	2vb8p6rzZBTdnBxoD813sfm1VtvVMB7HEoivd2dpRze2nb1QPKWj	1
1925	2vaLs6mebvcgNTBQPozN5rSwALQSGmUTPbfN4swas4o4jDjfLhGn	1
1926	2vaQ7hbx93bKVAiuU9Li82WTfRwE8covyXcp5feymCBdQMSLzSwZ	1
1931	2vbXgx3AqJN5QMzdZ7DDM7uqLja8mkX41nPj4g735a4ob8AcW76W	1
1932	2vbAPzF2rJxFiFSVgVkCP66cbwPgstTohTzn27rzJLBU9twm3T77	1
1934	2vb8bqtLf2dKknwuh2xUd9CN3zHinvS6UGtz24aWM1qfy2PqYZTk	1
1938	2vaPqqpNq4AFS7cR7TFUNRN8r6oMh75t7Rqdu1tCqw63RZ1aryay	1
1944	2vb8UjbPXnhnxYuXGhekuQHz7fPCCLQhVUhsSsZccc4DBELQvV17	1
1947	2vbKp3uzoZbTu8AT7Hn2vmci7f3ssZUcEqxef173X4H7nfVwaymf	1
1950	2vboYgVmNd4wp6Yq4JGNykKA8q2Z6NQDiwtjzPAU2o5MGQHiGZSH	1
1954	2vaQPXdEW9guG5fNBRjFXtLtMG6aCaXzhdYt5UaWMykHQqm3QsHP	1
1956	2vbMcRjTREzVzF9AEL1F4oPiT45DLtDaQPs1LH2jxEgqzqRdehSK	1
1960	2vbv7ba6qF3YqFSLzreFBdBgaeTQapru2mNvEZj7epmoMgPYLwKT	1
1964	2vbjsNKzvwMoQPuhGLQVducoBNkwZcy69CDpTKJ3fEaTYkqJa4H3	1
1970	2vaRMH6jKXpmZfkXC82MxCuWQ6BaAcRSNJUNegvjVPexbY9zVDmi	1
1974	2vbaJUKQpCx47eHfVdBX8C8YKDdx1iNbJcJNNUZsrF7FpQRh2ijy	1
1977	2vbHzR4tPJiacGJcyU4sqNcFa4zitSX5hVTuKJWLprsNPUk3aawg	1
1978	2vamfFJJzXQiXaqL1A6T9178Bt4nFRBep2xATyfs6J53ZrPYULv6	1
1981	2vbnepXDPomnsKFpPE9GbYMRph2s7ks1tQ9NbAPmYEcXHceimWRi	1
1984	2vaQTXRne58YVs1mCSR4BgUwP6SqWhJoQwJa5Eais7qpig9vYAYP	1
1985	2vbE2mr79JG2ACHtGDSTszvRrom2vqmGZwcvwvMhmeABHioASUjV	1
1987	2vb6pW39WG2swFkB3rGoHiL5TWVeUU6PQ2NEukVru16pb7TnmLqF	1
1992	2vb5JouEFfgw1xV8eug1fYcztNTJXJ3MaxdmQ9HACZaPyC5Nnj9f	1
1997	2vajn6ZuzXzz69ttg7fgny5PxwtsDmMkeEoTjsmWffoGjMZEsjpH	1
2001	2vaLvwwcuepXx8SJtGE92vdc5nqK7o9DX4asfZ4rFjZLgrvUE2VP	1
2004	2vahHs4SPmfjQDp2uTTZdWu91uTxkzcxVi3NHw67ZFJZ8kcVqKNK	1
2007	2vaLpRkoiG52GYEdQW1MXNMLvAUsPLRawxeVm6B5Ympy6AMHvV9H	1
2009	2vacrittaiap8Ki5iNQjnfJt7WVb98W2t4QDM5dsPi3124tTvWxM	1
2011	2vbDstEqDTvN2PWxSuj1mq3EUcy52XLJxfrbeaYHrLy31XDxd5XV	1
2012	2varfNjiWK57NDcwR2hVYuymytgrjXTE7KaGtfwJMTBJtb7L5QhD	1
2013	2vaGF6QxmZtK2hx3gbnZcEhPhZQv87vEV2iC2DKovnPEGbZXG2jT	1
2017	2vb7oRZQtp88GQCLsG1Lx734zg1wPCvvJRgMq5hbKSbmM6U9HQeC	1
2018	2vbz9rUE8rtWkDfu7W6E1rtfjJ7BheWJkm7vfiZhiXoeCNkmuKNb	1
2021	2vazMm5h2QWcx8XHFdKzfRiZ1UcdeQNFehDZBdEzY4NyQh9uWFdh	1
2023	2vaAog865nJdB4EyWDvobTXCAqcM62gsUQiFiKoyqSd7Nkkh5gen	1
2024	2vaNEonRLvZvpN4LGjtK73N2e41Qc29kTND9P3MDCAgj8tVmuvPm	1
2027	2vbtiL2chL3Qx5vfydmULW32xHB9bVWh7439nco6siTtju7tfdFD	1
2029	2vbHmg5K79XmDz5uSCRPLHgi9CgTggRLzvZJCK5T1Zx9f5muQjX7	1
2030	2vb5d8KZFGcEe3pRSopYrReXW8hLrZKENTvS5gz9SDqnM1xpP9AP	1
2031	2vbjDi88gkzPt5yf84Cwnoz7resdj3doaXiPrXX3XyQgta2GXEuD	1
2034	2vbsAaSyhtNUse5wAM2GoDGeZXxFLxiXh6jKdebqMF2xRb3yUXRZ	1
2037	2vbXrErYXeuSxdS7WUR8zTZ7wHhpXmaTnMHm8mPiuKPm5rjG59VX	1
2040	2vbUwKKRybbxUWFBGHj59vigoZfbETpkxL13aHeKKEHXbSRJe9Yb	1
2042	2vbB9Je387D3dPF2Nr8bfbMWXA6wYeNAYEyTAZHib1N5pi84smKD	1
2043	2vbLfn61UHM1WM4ZJWFdh7fETFVG8rdRuzoSgSuCNAAfLvqtafL9	1
2045	2vbajmf2uR6PnfRuTLZNdKdHpMQp1xfLge5oFzmZzrVp5iLh3UAY	1
2048	2vaAayqCKeDR1iuGhw23QBV6caDEjah1a3Nd4XZBmk4vLtZ6cdSF	1
2050	2vatZojCvXQe74vsy1mWNwJdaEhVe7ShX8BDxCPK8xPe2XTDm4hJ	1
2052	2vbrJyWoSFuCSNm9AP7TL2pQdHSqDR6dhrF4dgoknQCF6S8FcqrS	1
2056	2vabARW2soUnZq4nLjjjPn6WHHx7afS3NPDcP3eAJNQRxbRaffVQ	1
2059	2vbVTVU2hWdpU7VvY3yKPmNUwMd7NYVBc4q7SbCaGVG6W4TnMvpC	1
2061	2vb5HptUJyYCc75TRpKSbLEjmL9FuXfyZJ58X6MAhTx1TVXGSBv9	1
2063	2vb5d8uCSkdLUEs7U1Uyv2H1fsf8iUampboaTRKJ2abAUamRD6Pp	1
2068	2vauVPpg53UGrtSWMKMu7W9GNVTnSypy9NU5ksnAUwUdKxGvxMNa	1
1871	2vbTL14FgcoKzfc7YPU1QobNqGFex3ZVgnGetK5ZwF1zwMAueaKn	1
1876	2vaeoxagGJns6Y4S3gogNvshv6SbTBZurmSYKftDcantBEnK9P1K	1
1877	2vbhhoBL7aB743jzyWyMw4TMALbZEwQgeRSE7tMjpAJJfqFySeq3	1
1880	2vanCevTRUdcQszL1iPfCxwewoBcaSJnfBu11qwMYmKNPZmNviuZ	1
1883	2vbse2EXL8C1woBnKZAuxGZ1zHNKgyUUSY2iekGi7AFT6AhDV9J9	1
1889	2vaCUxcBs1jQhesT54Xyv1x1ihrRt2ZLHruxrVxAtC6qo1R9vkEX	1
1891	2vbGFBULz7VWPJx7nAaSsLKg5FUkzVUoHbnzh62S6uvX2TnHSzUH	1
1892	2vafVLV5bxYnBxtBAGPPWUDVtbCfXM1FpLo6zpjiLVYkP3zS9bSv	1
1894	2vaZHSfHzMD7Zxwd827Te2LseGPoiTBd8ve5QV8vJYDsbJUfE7Rf	1
1898	2vayGqVuUXaAJPa51kf4Ak3A9NYeYjovP47naPwah6qRznpZfJgU	1
1900	2vajPRrPvMsxKKhnyYyJTT24qLZBJAqMwpyWFMXUAgQPkPP53Boq	1
1902	2vbJiWH5z7eeHv29ZeVRgMvM28eseEeAaMwVmnEc1xuvPopYb313	1
1908	2vbCFSXB9FQnmpks7Utp77CbPKky9LFQ6sxQ1VftTULmtdjJ9QnT	1
1912	2vbxMtt58ZxyYtcfetu4wTtaYnvLfpkSU6U99uUunjx544npaV1k	1
1916	2vaMde9D1qXVnQhvtyJo8QUJuy9tAeHhrHKwcNhof5MZv1jJC2B3	1
1919	2vbCq9Y7zB8tfdMWKDe8KAwrtu3Mqr27Fw5sCGNuDMzJNMJT2GVN	1
1921	2vakeDcjjN8j6cmhMThLN7qgZBGkfNzPGo3ZG5yJ9sKPyS84rvRu	1
1927	2vbUMBFAWmNHQggPHHekeXsrwNUreW45pMZ2wy9pgo8Q97YktB29	1
1929	2vaDSzJzL8HgaZJbN8c3eKLn37T9dNcxKZgdrspzhtfAeaGnLymH	1
1930	2vbdtrxBUovYXeWnQAdyzKftNmXN6EpXU8cDJVXW8Xa8LTKYR5Z3	1
1933	2vagojZVPxSe2PPyFhSsuSuRndtfhVYY3eN743DB45eLVPvHuDEf	1
1935	2vaDCYjncsde77BENFDTCbNQQSgZBdfhYcFqifwEXnSfiSFLTw5R	1
1936	2vadyouh8VjP2EfdwigT713yKwqLsaQ8RM8M1T3tjvJQevsV2awg	1
1940	2vagESRET4rTkPwVY3auRH3NXMrwm6RA3ytxA5TWtvsWhkpBPqJp	1
1942	2vaq8nrmPwb52WLegvatf4eSfnhukJEqr6SctJRcMM8ZmeR1XAc3	1
1945	2vakwRmsn6GpNciRukXt9oKapxQJjJgrR42ZyET7a3P6E5Tdqo8g	1
1951	2vaWRAnmVL3fbfhKmquXjA6tZHBtwf42swF11Xmm8DUuDsfEEmyy	1
1953	2vavm7Mxiv8ZDqKtiR8vioxJuBRVkdyL8SBUfa99KGxB7f2dFZxG	1
1955	2vbHUDkmeXKTRwwftL7tz4emhaTNYVFSD5D28kMcrtN3iizNgskN	1
1958	2vbHJ4bFkavDVo18LCw4AkcXTWJvh2N3WyEreSquwmfTJ3YTMFkK	1
1963	2vbJELyCnfpjd7yJyF5d1ndFtwcfxzcfiNUjxKSD6LM8fuoTVzYm	1
1966	2vavS5QhCr5xa2Baih5XzHmYfb41fDmB7GAcgs5bcjx7zCxRMRtT	1
1968	2vbgL5mQzFhrKw8Sp31TnBTS6xHz4fgcXxLzQog7CciDXG3ZAN3c	1
1969	2vazvRFPpFazgTTwkJdNztGvbAGDw6WyP6T2Z63ZtWWhKjUS4BDa	1
1972	2vaAV5SC8czXYqCa9vrtqnjRgMdubmo6cP6AYvbBmzavUUNsQPXj	1
1975	2varN3x1uQegxBYE9p6GW7X2YmsPNiYXTzdWzYZkoLuH6vhfMfav	1
1979	2vaQ1iUkXK5Xe9NeepdgYaiemKc1fxNeiJ9ZFYW2TMYnh82yw7bP	1
1983	2varoT7EbVThDbY9YK4NyU1HUUZBTcsBH2ZKYB9JmNBHsivSDQHy	1
1986	2vadVcCUUXReea83PE45BP5CG5wgKKFbdZVcuMxuSTqtxYytDVeq	1
1989	2vc2AK7nY3g4zVVsKRqMS2dLpTVxQq1qvqkVwsZTv8bUbBqBFC5q	1
1990	2vahgENZo7pvKmqY3RjQZgWuRnDD6PJFP6Hhz4r9FKHk4bE1Zgn9	1
1991	2vb5whHRmArGDGrvNGZtqPmd1b8S4WckUGNAxtuCwGqXmbTa5oQt	1
1993	2vb72jamTsjZcUvDqDYU2U9M5FFbWmf3NBUNrLyFawMees4PgPht	1
1994	2vaUGijsq2odEHGHRzeG9MLv3gDXbuH9zqxULbuhoPU63PvG652g	1
1995	2vamPEsBhRVYChPqbBhiNoyfRJjQUPmLkoEFToTNKSeBJwav6R1K	1
2002	2vbAmoq2a5ZKtpPeSxWekmYDVGMttAdWhFr9mEmyAnGwNApFFsAT	1
2003	2vaiWvFNV4RMgT9Jk6Y3den2jATckqNfUqV4FXCdBkkFHqsNcXbP	1
2005	2vbp14ALq9qfXWVTPg8WwVgHUonhoicEoXor9XA63ZiNkfkJv4As	1
2006	2vbea55ZSE1H5RPLGpiAyvPqjDzaHya4qc6aNGp2aDe1qxxD8QCE	1
2014	2vbiNDzjdgDKuJVNRLQ92QiJWNyopsLw3HEPeHWDuNrb6FZw4h5n	1
2016	2vc31TFvp2on4qpPN1k53ek4gLjHxUvjybJD88bEn9k8GvR6LpBb	1
2020	2vanfWCdvsdW5KeK7YpkSPv75E6a1Sz9ocKwAZCi8R2aY4NTWXvZ	1
2026	2vbELjDGpKMZuFXLMX3VCcpW71BJnnXDsm8KzjhRvQ8Q7jTVqBdj	1
2033	2vbGnMq5SBX29N7wEnBa1HCiWtqjyBbcyVdfyFWA7w7HM8VbAbxY	1
2036	2vaMX8vSUMnzY7CmeXKzbVRS1huXNXr2AeUn2XB1Jb9RpAMEcFLr	1
2039	2vaT5132byeA74Huha4AeHpkmfKxCsiVVcCV9a5KtCTGxsrzbHfM	1
2044	2vc28H4iyKYpEQ1jg8jqdcY27s16J7CquEwsoTNVZQRPPkba2qtD	1
2047	2vbBKppexCPS1WT5xDLWtQnVZgwrRohk1qJF3f5aZ4zBWJPhixU4	1
2049	2vagmeLLGj48nwojuXvApTbDg8JshdYR65GGrWf1rsh9K3MQCZFQ	1
2055	2vbYdLpVbJiwGaFHcXuCqTUmvP671xbNBy7ryo4dMXhXi22uzNo1	1
2058	2vaKwiZ7PcmKezqdfCARTAxsPTVvdvSqyVQWhTAPCTdBbS8qQUsm	1
2065	2vbwNH1SnZFbSsVHjjrY3aaySw4GrbViidDKX6TTeYnEb5DwGh3R	1
2066	2vc1a3eWGTanzvKdMS41oXjbhDSt79x76zWEVegTr8hCPM1VAW6Z	1
2070	2vbsYtHvqPth1nnJNbK4AfZCJXxyDzSLrbCWhGDACM47cjDcwVTa	1
1873	2vaRRW5zeubqe8MkNe7iPo1TwDBP3xQzbCT6SwtzWEGGQE5VMCky	1
1874	2vaFH4AwQLXn9LsNR8UdjmpCMgMyHvZR3mrppnGHp6hPD8GUdKXF	1
1875	2vad937LRQkrPpYu5YPqy4deKi1s3mdiCCWGiLCeDoQGNhGb6WdX	1
1878	2vbjSz7hReb41gG8t4Y5J6TXR4nmR84RByLWbYnByRvxKTrg7U8V	1
1881	2vadvM26PsFeRcf3AWcMy8sTP9Y356FzymQKqnZb8TkvFNKeGwBc	1
1884	2vak6oQVijeC9F8qq4NknQZRifckH1oPC6ZCzpbgKeaLusMrNEgZ	1
1886	2vapwdzY7RPUXohV9dkPEUmsCsW2ipxE5TmafmaCdBKexuWtZQc2	1
1888	2vafAcVbdGWanVn5yVNPpqJm5wNapZfxv5G7ZKwrYYpuZsWbFEDD	1
1890	2vaBUwPmvTCraAfwTcv1W2qpEPkmk4yUrmKC1RTghPTNmcfdPRNJ	1
1893	2vaVFM4rtYWEj2VGNEkwWb9muQCV8xeFtz1ENwxQByrwYtsHmQYa	1
1895	2vaqbs38s2cJMtZ7sBetzM7pvR9qzoJuwG8M6dg7AZuEPLx7Hj9s	1
1896	2vbBPDKyfSeQFD4NRtpS9dbX6XZyG73FwQs3uPSPVCBknNZ6KNQb	1
1899	2vbjZkocATzxkQ6hK3FvWhgmnYbT3bRLEdKWs5PTzRfKUQrynuus	1
1901	2vaHHcXJvX3NFzGDgn2jis8kCKJ5rEbz6KCyefK35zvW4nNhbdgm	1
1904	2vbYZxQoWUvsHjoGCPhFQy1bqn867aoR9YFvUhK9UfS3gUYxeguB	1
1905	2vbQxmJA74QKeCvqgEDCZBfLDU4CddAtcuTmQQkwzapcSPAnKxw3	1
1907	2vb9aUgNGaBmojcSxR88vZyTju7X5nL3H9oAxry9aXa1Qar13ddw	1
1910	2vamD2Q7aRCWQwWEXbTpoGzUpAS4WLd56x5Xb2LiTsL8vztqhrTA	1
1911	2vb9jTT9mGooByhFLMr8ohwSuV1n7fWaiFNKG6kYTYaan93FCciS	1
1914	2vbX4hmfrinFBpEN16wow16vT3DdMEFuYhR6ATcunzf2sefr63Ya	1
1920	2vc4qNmuTSzfb47KmhkwHnawQEv3Vh1RAhkvmCTH8GHPedWRWdoF	1
1922	2vbCCzrHu19gvbePJo4p6tf7G3njMxziDVymcvrndM97i4GsUKaW	1
1924	2vbdGZHL3paah4HQgdLHnQnvhn7Dh9KRyvPdYZg9QfBVd48avY8D	1
1928	2vaZZGWNnokg9pYpnhtQkBm5HpXcdVjKTngqLKwBbydUyghHQiFq	1
1937	2vaycMasDivjnLPycgNP2TJa7onLUsoAwG8A3fhRRnaRYbvEYxAx	1
1939	2vbV2w3hsbDpKNeJz2BS3tvrspPnPCB3kLZEvS8CLBcDFQGcBRtg	1
1941	2vaWbqQSVmnjM8YEQEQJe8dULeWqoAVhmoVWWcD2eGZqu5QrP4oL	1
1943	2vbdWhq7eoXgThUdnuQ7YsEHiAKmuv25mdEvVgyo4J6UMKRqM6de	1
1946	2vbdSj24CqixLBYZGTtXuvPFbmqAXwSQifNH3NBN84f2xBcGjMbQ	1
1948	2vaBo5GSf9SYfZPc1wyuykH7aciYSXuAg6j56Gb1zQjtaVcA4zeM	1
1949	2vaSth6TVDU3uBuzM82BEBoKoBxE8Bc2C6J2gF9xMkQwnySqVuD5	1
1952	2vb4gvDNiHgEskxZ7rC7FWKxMpEdWCzFu4arHzM8brU7nV3AqBuU	1
1957	2vbH8h2rtL3RjKZjRv4rm6VqB861XvHJvt8pgKxSp1zWhRk4o1DT	1
1959	2vahibJXDaVC9V9Agjh9Ri7MJDWeAfxGbTirxThLUg6dsgjFJB88	1
1961	2vaZx3eH7oj9eLYYB6hHiCnneWPcTYnXzGk4FfifJ5y4FCErtabi	1
1962	2vbwoT3rLLiQbeLhrDCqhFi1Pss2AjmU8FsrzHDBa173Y5bte1gn	1
1965	2vbwH6Wvm68R6eF69Pdn6tu7M47A7utP4dkye3LycM6Gu6nCUduF	1
1967	2vaKRXUYhCzA7YYcPuTBhngWr3jDTQD1rkZM6s5cL68Ke7teKuVE	1
1971	2vbmYKSJpCM5hZwGN1wK7fzMjdG8hxqp2UXwx8zsVbBH2q6RLt7L	1
1973	2vajRnPRiSoBpXMEJJs4gAYSYQGh2eNuJqWStxknt5n2dH39DJG8	1
1976	2vaPY62Tt1DhbiUVEUzHuVjs7dGsV78HUds8sEzus8FRc6Etqu5x	1
1980	2vaumaq7ibgJK5ceR59KqbNCDSE64EPnjNKrLmsq2QadBJ3QE1Hw	1
1982	2vc2BqiGJbPUPvb5DWhw96vobPGBNp6RCBw1iJEHJbU2deAQVnzr	1
1988	2vbJeZjpLp5oSdvSXaqtvVFMESu242xqbfwVcwwtdP957Sv98DEK	1
1996	2vbH3zxKjd7FJze6yMnXvz3YYU7P4Biz9fsiF3ma54Cv8YVjCNo1	1
1998	2vbDEHayEUgcWojMEyZJMs4mwrDb1PQUDU75sHFSS6J37x5fMbrP	1
1999	2vaGuLb4M1gY5NrVLf2jm6e3MXMFGdj9YAzgF8P6b1KbixomDZqA	1
2000	2vbTjLA2rAT4ozc6cfZDiPkdbgMWzMbEyLy6r3iu7CgBpXPgEUAp	1
2008	2va9yEf3u4h7ewPidCD3QaHC3wYf9aSQYNTvvML3VVre1JbScT7Z	1
2010	2vb5R4mZccbLWF1rknZkMnhgqUV3c3AEnDRnshqCsPrf1xxZ3WVU	1
2015	2vbXxYAUcQE8XdEuQCjtvotYVWjKcctgBwzcTvJSM6DBRdRHBuzR	1
2019	2vb9uozufS92XfmgWLFjUHUDAXmvL9TdQpGJ32fFB9ycopK91TSy	1
2022	2vbrr72ZZ7MCdT24skG1GJxpamuva3s4DHLVfCfMdUfWDvcpzxcE	1
2025	2vau7sMQF3KUduMrpKrEgnVkZB4wz3CS2E7HrgUFi57GpkPr6Zyr	1
2028	2vazZUWmsTeJRHgJK6teBAmEaAJFHbLJegVoGWfLWiZXvddndvtb	1
2032	2vao2gxiZ33jd7JHQXybjMFiLVCBW2TS1F3XGonQFFFyLSL1THU6	1
2035	2vaYVnGjhZErgu7CJz7WoNftvK5tewdq3faYWPdV9BjLVuwUbDix	1
2038	2vbfcf9dj5mxiwqAV2FKDeeANiRZ1MAB5hFHmte13iugYy9tq6hN	1
2041	2vagTtyHXYnf3T2k7GEZEWwM7S9yMG3U19RYMVa8UB3osipRLxKs	1
2046	2vbrQ3LVCmvBW8ryhGyfbUu19Z97tF29R8Y6vz1ScZG7aB8jucvw	1
2051	2vaD5jKvER26a8jp2zRHB8m7Wrd2xqgp9VdschFVCSFM5Ghtgv8F	1
2053	2vbVuQ5emtgg9hhb8UHVsppzxhmpK5FrYxznTDZwh5q4iREkmr4D	1
2054	2vbGa8JhjnWdvyb3KVNqbPmkPwL6qAD3RvfAFn7VPxHDiXToYPUt	1
2057	2vavb2auJX7atSpkoijkiUkLSwFVezQKaKEL6jX9JTTJeymEvpee	1
2060	2vbYn8TmTbG5p2XXU9JiQChRgEHYdfMG4iCDd2UrzrHmDXbnxYbi	1
2062	2vaJeYGacFKsinyQptBvcMpB89Ldjn7Qz9uBjDU4iLdFaRfMekgf	1
2064	2vaiaVkU4tbqSdSgacNA5ZNVJ1kr1ETS3J9CUacVqdYHTwQTnhxa	1
2067	2vaFH9Hn77Vwnys5CYCWmtcapSdrAum8FzewsjhHf9M6j2ZDTNEt	1
2069	2vaciPUGbxdU7NHmDVjZ123F7gBXXuWcmo89LjvU3HtRLi8a31aR	1
2071	2vb92zqCRY1PwLpFS8oGLAeJd5T78cTMcZucPwAduMq3cgjr2jPS	1
2072	2vbb3nJA1eNVfKtKP5Wc77uyFazZ7bJGBifUVVaemty69W8xYsQq	1
2073	2vbzD7KS2KtmgMSP1WuAuRVmAJWRdmygLp2XCLeVxFKeAXYNFRmz	1
2074	2vbH4CATLTxcsGBunSesDitXMc1wZsetWtipZkud5fjQq1FyqhEU	1
2075	2vc2gLaxXnS8SLdqMAnNQjhDHvp96RW4k2mHMUuvTULg1y3Xda9d	1
2076	2vagSwamSLnXvQcAZVg9FKoYKXmaFiNvedstrHD6okCs6WCmL8pP	1
2077	2vbWsdU5yq8nitfPJSPd5xQ4Yuh7GvyqJZhzwdFcDAJepy45rg8t	1
2078	2vanPex4AJsvSePTpV2JWJki8iFk55AK7LL8Wp3FH3JeybKVCoVW	1
2079	2vbQpRKUocSHvSK5wvW4wnS2hFrTpAbBW5CHWBSXxXR8wwmGSJUy	1
2080	2vc4okzv7p9pRy61px1v4WGMd2nptJVe8uwK3RLf7FoB7Ei4J9Po	1
2081	2vbPci68QnE7z7oeg1r7mi6TAiz11TTcayNZXuzf69i1B5DQugcd	1
2082	2vbfpioDrRA2v3p5UBytrq9GVSxDSgYwDQQRNXp3siJo5em6kDkY	1
2083	2vbiAVG7Mgd98t2YTPf2miaGdrsf2vqRnPdEC5YpazeVWGjLmqBc	1
2084	2vbbo6BLixXZoxp5r3Y72iYnS49uEgmUUiSbLZF6RASkwX9n5uwQ	1
2085	2vaQBK47j4Li2d3YVZi1VW6BSgVBvZmGqUkdyae4Vuc9bv27h1CV	1
2086	2vbeRQH64PeuV6AtNMSBchr9DMrS3RkJeebGmmerXT6DxpPf3kHf	1
2087	2vaRrk8HypudmxB5phorgJGmnP4Knfxdw3sTvzFaU6QdnRCUuWcH	1
2088	2vaot3x7g1X7G8Hb4FMzEKJK3gMLbs1djNFHb2LsiGZoCFhsmBcz	1
2089	2vaNsDQNGeGRRba9seQevCk9n3Qsf2WxFoASuHTZ4Bv1Bw5iS1qP	1
2090	2vaWRjWn5R6XSs9Vps5zd4nbQJxmCqYLouaiNrFqy8Us6eEpE7DB	1
2095	2vbESxHGyQM7WzmJTNYdrdCLL4wXQ9ccRhsRBBRGnu6He5EN2o9e	1
2099	2va9aofAzV2r49jqkBt6dUvo9p8RDYMwMphQ8pWnyZtehJS24NuX	1
2105	2vbBS5LjQ8eB7c1XysmTDKWV7K1ns4JF3HpR3TFivNg8Xra3wNfX	1
2107	2vaxSskQpfKLkwapGSzitYqnjRL1rmZsm2XMEYESJDxYtGjqieh3	1
2110	2vbTNhttzhsqtokuuiZoKGPSjwofAkUv168nCQzr3kc4FDE17VVc	1
2111	2vaqFJx5PdJPSRucqP38uf9j7NbVmduq2FFuzJsgn74fsGQCFX2V	1
2112	2vbvQDFSknryEkPt3UZrCUWg2BRZMeFMvKBdjwWUGGySoaXo3gGc	1
2113	2vb8u4LyyXYqLRa3JT2gNsh31Pr5g4zwPsdFSphbnD5gwos7CW51	1
2115	2vbpU8YKUN7TGCc4PKTyp2xJJNCDyJYrSdfx3D8VvewMmvbBfU9d	1
2117	2vaePdwfLhmMUtXDbZVhn6i9f3E71dLiSHhRmVBWCiBzBca6387f	1
2118	2vay17ALYmCvtSW7khd78iaSaBaFnkKnjNvVAiKYd8DJ6ddoZr3K	1
2120	2vaVRZ1y1ChgCSJzvbxPkVEj6eXpJvgvYU1VKa1fvzy3aDURfgYU	1
2128	2vaPt77ocgdPD7W6FNUwTYycKhgqPZu1hdZYJyMWWzrhSmr7zff5	1
2131	2vai88dya3ZFDFwjegYmFZSQSVy523ePKmZtkEirLEbXcTnbTufJ	1
2132	2vb4soAW6Xc2o4mrBFeXjJGusAYQ4LzhUGtpmvc6mgp9J14Q4UHb	1
2135	2vbh2Gh7FYZ7c6iueGSqiL32m62iEQaC64Vu489kCyZwjruKjeHc	1
2139	2vby1m8THsytvfuBJSagfw6kWY1zXmrxD2D9BYqsjQnStXS7HGa4	1
2142	2vagMMVruVYa2ijD7bnXSaFw7VU4tVP3dfHS9DwcDxFxoGafb1T7	1
2145	2vbQFr6pDd7xAHmJLodRcy9U8YuscLt2A2aoG1kHbTeHHdatyyS2	1
2147	2vbu6pYopq8deusBWmWahoM8W4ERxHPk4scVYR5htUJwg3SdxUVb	1
2148	2vbZDbXWYNsyP4FXTrY6r2JkT7yfZ5mUH8wn1NF8WhNBX7DjoWYX	1
2155	2vaDgqZrAZPop1qLGa5zpVSshhhWgbvrTiA2mV3fWm3tT4GJCY5D	1
2160	2vaMtPPzUaroVBFHk19egyByQsQYue8MsWvRzt3asYHYWf3SwfbD	1
2161	2vbfYVd42GE85g3XSEH3ZpRr1Xrkgfnu1rnvCyjY3PPgm9cjG4iv	1
2163	2vaq885sAFgXTr7mmvXjp51wpTXTZgd4XrJAnxQvuu56Jva9QGvX	1
2166	2vbLJN7vPPcUEdMyTfsUJvMfYN3CHzVwc8rczC2isSytcDvotqn6	1
2168	2vau4kmvsUtTrf3WpHqz13hv4ojrhESa6VNfgMNTkDb6vihQpo8R	1
2170	2vaL9YioSK5ovm5Mpk5S7g1EtQfY5VbBKAzprfiyfYenJEwjki1G	1
2171	2vbUrXtMAwjJpm6ibcCABe3yVq5tV8aEjWmqsYv6pg1QB9NDLn4D	1
2173	2vbpZBERVqzGpm6HeJYFpMiEaazBGKNZF7sE5GEnjgGqffLXe9eZ	1
2174	2vaCY5on8AMkmgdca3wfLct6N9AFntC2CnUKZkCemPT5jx8d71eu	1
2176	2vc5AbvDD523WTck2q8m8DJHdkcX7pJhBSjce1X1WRkuj4S1c9jV	1
2180	2vatbUka1Lgd9bvKzNapWG2Ho8RF4RutZ6HdaZtx14ncHArpkjYK	1
2184	2vbEUZuKz5NF81RgVLB4WgDR7BUrnyzUqn19vhuh5v4mhV41rhpV	1
2187	2vaqobVBvHdHLnCSAdYJ1bGWj719qT69kdE9B1qXqngSPrSFjYvd	1
2192	2vbE9LTjbWMBavxRLCfKPrwXB2bRthRGXTfx1MFkFwcPGzVvSzf6	1
2196	2vc2BwmJj613D2oixKaRAxjiSi7xgBVUx8sXWrXnENUuo6sErJri	1
2198	2vaQfNN9stcepf9Xy5Vbt8nJj2UxL8dnEqkezKaRndS3SQidcE6b	1
2199	2vb1jtVr78NN9cbr9HVKt7SHquz1f5PRKsza5zsoKLnNTYrLc5Z8	1
2206	2vbkNM2vCJmn42hJTjEbHjJhXStzAnKnTVSACtxAcCGz8YcoLAtp	1
2212	2va9Rmiqy2LgNXgtGkGVYpquKumtZ5qytzxCoPnWuN9TtbGaN8ur	1
2219	2vaorKfkTgiFePU3How7C4pGKbU5sF4pp3VN1xsqs9uj6QcqACbG	1
2221	2vbHcfU2dXY4LEnDC1VpsFqyKvMpBWNB639qxzcsCXy2k1vQiwXf	1
2226	2vboarc5wmRmz5jCMpto3wLmfxCjzoL9Tq9kqAEd3M3R86ehQFAG	1
2229	2vass2XA7BNkvzJMmWH85udmMKQo1Qqwgo94GtqmhnK4fy3dyd8R	1
2235	2vbop3E64EDcSoS7XV8wcZPeb9SSSi4ytwSN8VuevKMXznQMGkg2	1
2237	2vc1kkyk5zeWMfS36fJzP9g124Zg5P84sU8YhvhE2k247VrvgQVx	1
2239	2vbAvLGHsMuijv7u9BEpKi1L9MfR6fSgJhWWdqLmEkmN66NKm25H	1
2240	2vbHMhAZR6d3TThxNXspjSNXpo7srLCvj11t2jhgASstZAVee9nJ	1
2243	2vaGCBmtYvQ4sue3hTCTDUFEDeeMurFA15cbJvLnuAWUpNSwScgY	1
2246	2vawAuemwogXbmhbhxHUqJbyZnEApEDvFSRYu6jsDzWVPZqWfN1r	1
2249	2vacNJ2gEnjwsM217aEyaErM7QmUw1Z36RgrP9JXZY4vHC3Y3TEq	1
2251	2vb8sprUvvnw3Fwg6GVB3smbqB8nZKh9RTMS7dMgfffd4JeiYjJx	1
2254	2vaFjTJuPrqY9pcA77KkUJUTwphe862sJRCpJB1fVNpQQyRBaYSo	1
2255	2vb6wnoMPd1eiDyYdMueSeEtBsE3bPh94VkGzM1jy9gR4ThUSwnC	1
2259	2vaG9hQiR23ZYzSjoKH8NxuTTyjMkYacxHoQHMftbuEAAfLK1VTd	1
2261	2vaveyfiUqJLjxDT6JV9SoQLxHeJUfS8f4xWt1XTryJNEgzNFZtL	1
2263	2vc2tEMv5MqgD2Q2L55gww6Lgv6aEHJ9MniDGXJxcQmgQsx83yGd	1
2266	2vaGrzjyyXSZespXskCeWLbT9YiESCvAXhyiS2NaP85EaXMJStau	1
2267	2vavxuznXgsmCzFrLWm1xVjqkmoEJr574wwSGx9nrjQCAjA1AiEA	1
2273	2vbk6f5ndZaqCLvdm1QTdHMGD8HvzUUpyvWqWXYMUjNvsZtBqAKV	1
2274	2vanE1gKSE11LtZopFQqC1hmZNcVJHz6T27rffd4QacMJn7pjgrZ	1
2277	2vaoHzSn2pP4RKc2wcwbSGrBnCYKjq5obwkDzpzCk6mrbpZ41im4	1
2280	2vbGPLHbGRrvgcHdCThufHFvzaT6xLiQ6PXXownmA8UunW9JZiVb	1
2281	2vbrMeJXBAFFxKbErk1ETdbbUjE1yMdzfPhr9FiygH7CYLameL22	1
2285	2vbQmbMvRkki74FchpYLdJzJG3rtBrCvyCWuVA4E2krb14JpQXAk	1
2289	2vbcSpq2mkvr2BALmSaT76QStEGh17L21p4TD6KGjFX7hHtWYbVn	1
2292	2vbao3mKFWJ2duZSWkz7eVwNXspimZ1ES9tqNkXTfzVAaetnunJ7	1
2295	2vadaYsk9kw9BDg3aGfjBfcNfbgyBGqA4iBCmf2aD9WuHcNYFhya	1
2297	2vby4u82nE675GrMGqjT7Ea3DyKzQ1zXo3LRra7B8xGA2XLYdiNx	1
2301	2vb5aMs1bwo4ZoetwjaBs9cBAeTVHTfz7rsxMY26bg3cCyeUkemH	1
2304	2va9r9jR67jrgnRShHNRbbV9kPoJLVLYr5hM5Rkt7gwEA62a7mkn	1
2310	2vbuHJmaACiiKYD5MobfhUzjAMdjfTVHyZEA2BojdXdffUiRpqup	1
2315	2vbDfvJsiMNhJvM66bNLvR8vE5NUre5swVRZMGe8ALJPyAEynGpL	1
2318	2vaxyRJP6REra9Zm2vSNKiGKSr9ynPrJ9iDyBPqXoCqSuNwNw9t3	1
2319	2vbJYPueL7HXKxw6bJXL2PscVdVxyhMbwfb46NjECmAqjPLMT5B6	1
2322	2vbqxZdv1JWoNRjLYiWxWYxLUdnrwM3otSTxw3WXrG1cQw3XFCGw	1
2325	2vbUWDccNpNTzXLU7JkQgXrpswx53g55LR616qH9kYVLBrAQsZ1B	1
2091	2vaNnh22nDkFoovkbUxhw9KQpmFC7Ltk2wkDcwBmDd762mTysrRU	1
2097	2vanAbFveiLD4ZTqHq6MuhzBck5WMrQXF53Z8ndHJT4hLoXWmm8S	1
2100	2vc1vdxP7vaTALsu5frkdmoBiFyFvVqr2bxnwic1Xor9saE7LXnB	1
2102	2vb9UHgWkpt45qwvEwDcCwSoCtZ3HQua7vxF6nPnW6kn7KE15BnR	1
2109	2vbupwTkZTe5btCCJiihVkacihfkYbucvgb1qZ2zUzVHsdPuKjoi	1
2114	2vasdQ1uwhEmHGMhmZmyEbyQw7xXSHE3uRgD16zMfEo7zLNiYA68	1
2121	2vaXkHQuxoeFr6vv5AnabxZG7tsYaxcodmFADd4MfYEy5Q51Q8Gy	1
2123	2vbX6WRQJHWsZofdzpa1Cq4hX2p4ypCuoE2HmTtLUqX9vFLvLgTs	1
2126	2vb7oFQK2DttxYUYu5U51hCr4wmYp5uiYBxyUnMLV175RRnbvmUU	1
2127	2vbFtddQuAe4uLZnimZiLtftwdcrNe3zow59QPJNQQZxNbNpw6hk	1
2130	2vbSPT5tJvr5pBeJuMDo9rDwExMaKWxDzcQG3ZWeRkRBtBpKgX28	1
2133	2vbiMuCPtW3NjKkV2DrXmv3UxyjZyi2bDvfjDfZXdaFSeu2RkfgB	1
2134	2vbinuDPSE1UVGHY8FMt5iD7gu3MGHh2SxFQNMhhvFKTP2SBcvtB	1
2137	2vb4kySz6tADdNQ5DQbiyMWFE3H1i2UjX1v6p4UviQwWwuWGSiNc	1
2140	2vb8L51JBzgAhH1m3PWLFbXdHpJoviUa1BuQ69asBDjaAsksGn5m	1
2141	2vbbLjZTwTYwTpFKLWkn7etTyfXckAGNebyHNS1xZRuCGkF1YVon	1
2144	2vaTzcehCbxhDbucr3EbMcdAfoQA7ieEibr42gddnqZiW2SEgDMj	1
2149	2vaLf4Bn8BE97eezxrPPEQLkH4FQ1Js5Lx1WFZWdKwUaBscrXhsB	1
2151	2vawFipDYGH77mckMD3ZC4r6fA7yY7VhborMkw23DyKRarRnJt85	1
2153	2vaULzaZLCLZb8fTuGX8TpEGZ3JBzkQy4hjFWqUV8vPxgvvFZ5h2	1
2154	2vbSYdWv3apzrQabCZnJcTGAQMwV22NhCs5S5azBN5cja7w2XbZw	1
2156	2vac4xA3p7Ybamxv7a86ADngEbM6Wr7qQ2XjoWp3GNkj65gK27bn	1
2158	2vbVHxyaFLvjNDeeK6itrVvRGhCqnusy4LeMLVzkxH3vgHwrxRek	1
2164	2vaY7Hg5WNNqEkfkZ7DB5jUH6E6jjCJTqX3zVFthYiidFPXbH6sM	1
2167	2vbS8CLaJEGb1v4aop5WioMYjEGdPCuwFFfmnAUJzS6niDGAUQiv	1
2172	2vb24KKP7ky3dL91YP6GwgAWhZntYEPXjLu3JhexcSnyPoVVrbQR	1
2177	2vaxvxz5XP3VxofcpFJDmfssgYWBeih7ir8wW8gvsEmTkH3mMc5W	1
2179	2vaXvD6PyXVDpZuo9zP3EyJ3Ve5WB5ydrkPvpWV9B4to37vjEtUE	1
2182	2vaGg4R756ZpbFdsSwbMuVRUtZR5bgWdSzb8oq9e1TbSiQo43RVs	1
2185	2vaEkxFbDaNKa94nuSNUYF4BgbEQpvfX9b3ihVJmzgLM1Nwrdohm	1
2190	2vb8uck8kwp6WP3Qa7mmg4kmZLk2uJyjNAbFHa6RTYGzFVjcvz8H	1
2191	2varKdvM7rrUHf1pg5gRNFSkWWdRvsVXK8amtjsS4Tw2tRRvg9sT	1
2194	2vbxh1pcJasycmxbvnqkkusBPt9oFsTXHYJZiPYXf8QNPmsmJVF7	1
2197	2vahihTukZ7oYu3pqwipRa3PywEDaTWdVsABNZ3Aw9pvUNZhhorw	1
2201	2vaMBbcH7p4iJ4Q3wqu6rmCY2Y9CPYxonPPNxvQHGWuLMG4odcQA	1
2203	2vaiybWy3NEnd9MQcLSDoa9t8ea14HBCrwTyEcAJAkfsixV9rTpH	1
2205	2vaF4kLFJCB6Hvbg2wtq84HAebrJ843FVVz3RZ2duTAtg65iDf9r	1
2209	2vadof8GSgn4WNR61qyE3nyFdTUtaT2w8m7eu4o95mJWrw3Efzn2	1
2210	2vbU4W7J3KF5Bg31AV8gPqfzxdZhYpEFXwBU8XK5SL29qyTg4wa5	1
2213	2vaEfu38dQfGctW95mv3ZDs2Cx3zKVZQB7r1nmaMTUPkj9Hirbib	1
2215	2vaqSfWFwvFzf77DfrKYjyfJMmv5Y2MHX5CMrwjyjSzoXu4bTikr	1
2218	2vaYeuyNzBavvsbcsVgFhsUGKzSN6VesckoxGA72hGZUVAqdfb9u	1
2222	2vazKL1MVbiRBDCtDwaawsxEMNkVsBqoZPcyDLWGWk5QZLjbXW9o	1
2224	2vaX16n9h5bnagCHxbmKB6MNaPg8rkgefndWts226huqeABHAgWy	1
2225	2vahJKxpQhhAXoT4aecdMmh9HtQM9moWuq1T83M9p15NrraZzBJA	1
2228	2vbnUrPT9Toi7Y63avf6mKTc9i9dcAJCdb1EzHSoxRZekTxPrxDy	1
2232	2vbFwVVckWjMnR8igF8h5CuqRQfBVVfgtwP43DH8wR4BJJtafs4L	1
2233	2vc4r8KHzSCkz9EsvTavj3EDGPwS6Gq8FrPNLJ4no2yCxFatz9Mi	1
2238	2vaL73qFozL8jj8Ctt3oQFzFJmsKNUd4sPLg8Bdwj6xgTvQVnFUQ	1
2245	2vbidtuuBKUbEWzf4HiQhiTY1DaghottZtP82KqRk3vLpPTex2ja	1
2252	2vc4no1N97KLDUV719n7AbHeYV61N9bbVHRWCGo55rF5j86YZLv4	1
2253	2vbyQz8NZWCPWeND3mmxSxEfrRxZNZ9HU5w1UTcBbn1WCVnvDkdT	1
2256	2vahqhSzGcWC2MNeKf2SgXrVJVUynNbMqhcsYaJe2ZGciQazWx5s	1
2258	2vaa7Uz14rk75GcQJRsbgYzQj7zfwseGME7gU41v8HxivRAPzNwM	1
2262	2vaq4mNNiZeZEczbsUPWZpiQsqMuzAqXwAFoPLLk5b8id65bMyuX	1
2265	2vbn7UfH4uWqSeXnxyT8mAXukEuM9GZhiLftrxP15ytnzE6BYMXi	1
2268	2vb7z8H2MCB3UBbTTRbvWRrizcJ1qceWhXpDaTKVcc8BjbegZPA4	1
2271	2vaLNdUqSXLzzS578H9M3VkFuj8BN8JJeQCGG1x4tfzeFdAUNpsd	1
2272	2vad7BZgDwpM79T3hxseuqWkXSc1TZop3TxiXetkJfyaL875c7yX	1
2275	2vanmueLGrf1NKBNJBiupqzTqAKnUPmjZpV2fTs9m1sEutewtX8J	1
2279	2vafjvtVFGMR78CqBgQbRNVMJa96j3VQSdp4dY6TVHxyXG4qcGK7	1
2283	2vbDeMauJai8qZperggX8Q3zSTd6Y4F65euRxbEQFtLfGnV465iv	1
2284	2vadhYUbWoW81GZhox5yVzQKrsuFE444k1zLUdFFiKuPjVGKTgVy	1
2287	2vbge5JR981zk9Kf5C7jreFykqRp9ZdTxs8dXg1qcQZeo2y1DSPF	1
2291	2vaX6VmYiWqKbRjjwZjbQFL15M3wSyn71MkEPLKAq7a3cdy1ScCR	1
2293	2vacP3GQdYPqBYaiQhZozxv32xT1AjJLwPoctudnErS1u1YAyv86	1
2294	2vadPu6Hbkuo7kWG8ccADSBmXLRuyapP5HN8grooPS6CJRL1sM76	1
2298	2vaofP5bW4phQbu63C4wTVH7aW5xUz4F9d9HFZ9eKYfRwAmbZjEn	1
2300	2vaJsaJdpVpCwhxT3bgzDPWhhjmjNT7gcXaDTmmUawCtcuJR8eQb	1
2303	2vbSF2sQrVoVhE3w4nZTthKPMYLSsrBkqJwrw29CK4BtJQAFDesN	1
2306	2vbcCATcT1qabj4BdDdaaKjiNNhsPyXaWrU4mkuKnsyT2duoDtXq	1
2309	2vb9Ad7cxAhuzFex4fCv5C5rHtYVwVmUJRn4f4qt9vVQXcce9Rjb	1
2311	2vbvnXT4CHDg7fS8fdQXErWFwAFjr7uzzm9iiwn6viqfPJ8gA4SY	1
2312	2vbuxZkAtDjvBmKnk6YzgsVmsEfDpprkvJ1QUo9q8Fq85VLBsybM	1
2321	2vaK5ogCHqQMxDEQBHrjLJZBkTkhnrvRnu6zLgh8Y7zviK8MPHfC	1
2323	2vbw59bZLrY1JCzExwmnwaFLTe5KR6upkCTNvTfSJFpRhYXofGC6	1
2324	2vaAQBHShZqjkLXJiiUK1o1rP6NxwPGV9wNLZpZA2M2VxQmowL7d	1
2327	2vc3gLzevLr4gok7fSgk41jByJUYiiHBGQxETKvYtXkcwjsGXpoW	1
2092	2vazrEenmCmQBPXrv6Wp9eDBerNi39gKGX5wkCsW4sasATpzEeHh	1
2093	2vavnhi8dGawjfE7Sup92FYJNU9AorMKcbwvG1RUg873QDqfnLwA	1
2094	2vbvo5DtEzwDhy3Mv1m9Yv6i6nVfoy7XYU9PrjSHYEHquDgqPDwf	1
2096	2vaQ3GuX6KU1J4Qzc9sqjr19omVMWmMuqC3DPN16PuzD6t5Z6N2h	1
2098	2vawq8qcCLvMfhpbhyt8zTvB2TGzhFfoipH23yS2S3dBycYHwDNQ	1
2101	2vaqq6jZ3S2AsTebpSJYWqNbGkNxnaw4qDCm2rBimq93C6ye5jGB	1
2103	2vaVw9FZsGR8qpg2osJX26UYzYnYnqGJgTiKjZ74drRjkEYYj6ZY	1
2104	2vc21FRoMWoFrsBoG9rcWZjLZ7kvNxCHNcSuPxbuixi3NoNJe9pu	1
2106	2vbSp5UDgjGP33ZMBefqfj8ArEpEfuXKiQ2djAqNTHFqjNmbicxm	1
2108	2vbjWRrVvJwTi25rzDnHowPRSgSXzaUQ83s74mJzGRQXxfuH17tz	1
2116	2vbcgHgMi8EMf8EsKhGgDgXfagbsvGLnFWNjr8khoFHe1zJ5rM77	1
2119	2vasK3RKv1KwqVQD2C1MzWV5FD47mDXb3zo8gczpF4HTGbSgmQo2	1
2122	2vbRLL2GuVaBXbhwQ1VWtF1rQtqq3KyuX1Lt1FUUJrqeE9Ay86Ae	1
2124	2vaYAFJQvKwar5GGDG2KaZZB5Ctp5998Q5EdzMdp5Ld81VCKFgJZ	1
2125	2vbrAo3PYEmwmP8t7S6DW9CHB6X5FqAz4R1JvxB1HQg941Dy1xUg	1
2129	2vaFYpS6mF33jMGhu163oMB9PdP5pT1zpwcwHvcoZ3SpvTHneq9B	1
2136	2vavggtm4oH3LvJ4GZSTd27NCCUATnUaJAHsDjg7avaBYDbyZJJT	1
2138	2vc4zWVib83Y1H6VBR7zARPnGXQv9k1pKycw8mUYqzfZgAm3qEXS	1
2143	2vaJAjLqE4ztJHii6qEwdqAXWq3tDtNW3UCQXWYT4YRgZBdf6gXk	1
2146	2vbEs1kjQgdw7LfdGjijoZ6G2rgft59Bkc1FeqLTmuKUDoiNR9kY	1
2150	2vaML7hGCL1AQEJEZ3UXwhjzEr4LtfxrLtEWk3MmDh4vU1A97VtC	1
2152	2vbrKsPrw6r1fWF8E5rrNPwvqMN2T8UDnGRXWXqEVc8V8JhpkofW	1
2157	2vbHcw7ooDwaFMSLcT34jph2TGo6ZewMbVwKQuvfASnwYV26zfLm	1
2159	2vbfkDQTvvJDQCy6yoNmsBz7Z1pfv1ufLJymuSBoCrbYgGz3f33e	1
2162	2vatku6oF11PvJb2x9z6q3cq2YaCTjpwyqEd5cZQ8wHsYXpB5r2t	1
2165	2vbu2U3nw1bAzo4wFwRyonTTdHVFCS1wyCBFsPhrTCvjrWZ58avq	1
2169	2vb4zejwL5ScWyUeXusqtHvERCrrsbwxrSMp6BY5zWajKccRAS9U	1
2175	2vbrv1eLYaBhc1TcEdAC6fV4DUNWf5v3RTzhfDq15tNB7FPAXMuH	1
2178	2vbFycsZJYVbovSc5MARFkFpv1awetbsTx6PEkyNsbsFbMxegFMb	1
2181	2vayxTf4xtovM6Ye5B8ooy611CPPfRTPwWPQVNaLwRsX7M6nAv18	1
2183	2vc4SeSxxs8GtDQDT4VEsscZrMwBH1RuRDt34kbbGhAH3jrmRYrH	1
2186	2vay4KMgiKdc9vpGC8pZYsrdd9wcEfarAcwx8biFgrxaAZhymuLH	1
2188	2vb8u9nvxS3a9PdwAaSHBuDa1HkwPbgiara71wfeRC9qdV5FC5EF	1
2189	2vaUZuJjAi6diChubeVCJraKgXZBS9pxhJ5P4mLCXDT6XAfCGhuJ	1
2193	2vbQNz6QGocLu69UtepMig8v4DHPGsoqNXkfcmjFMAEpu9Pd8PMc	1
2195	2vavMVr6SUC7KkmNrQ1vAhREHcxN1ER4SpWafdDLYDLG7P9x2qRX	1
2200	2vbhzVhY2oywrd14FSBmt5J76AtS6pj4NJetjZgMURhtyqwieaEa	1
2202	2vbzxp9rscTAKZMRPJdePztGMqjJmEgiWfPETLcEUTZGTcYh3sRM	1
2204	2vadB4r2QGhVpVep9HsemU1ikiXzLoZxwTTvXpYXsZRwYcSoiNe3	1
2207	2vamEyyT65XpSamA8FzUjNv43gtZF8SamdzeXW11ifnkq6Es25u3	1
2208	2vaQ4SMpd89vyqkGmFTmQpMZJBXdP5cCcxvc3eneZjMn3JnZsBsc	1
2211	2vbjvWXnWJVurqoZQKFiUPmvGV8nCzcdz5uofv9tVwGk5YFLUWpg	1
2214	2vapC63mUASYHWNiwpGCnn8Ak79GopbZBy8HHH71DcfYpNX7KhiM	1
2216	2vaR4gJUsjVLpsyHhM8zDEb6T5KHAiPQURTwZ2rzH8DPUq5y8Pdd	1
2217	2vaMXxFGCv8YHHMCFD4NMQ74DPdUgy1xmRRkh7YPw9XHugMQzkpT	1
2220	2vaaFT3VPFEgQWcAPUB5WMdYUz3s7mn7ybutr9nioHaK8S6sLiGT	1
2223	2vaT5adSzpF9GbNZKHxgcBAWS83jnRpYRSNHhCqExkrCi9vg3GcF	1
2227	2vaFf2itSNHaEk1EUfPpBi9dW27EKhHyzGhjuUJeXGPuuxnSxGaH	1
2230	2vbdhy2aoMdAAXNVNV8624hKpb2PmAWuigicTBUDVrm1GBZ5ZA7R	1
2231	2vbcZZrDWUYREpQyWLPHujbUNxMy4hTeHykZ5SwPNcBXQGb3rUKU	1
2234	2vbVPVbAutKkBt8TiGEqRESH9vqwsn1CEVtExnYDmbMJVw92huZy	1
2236	2vaXfAe5Wf8b7GWfgkwuFwvvYhuo58dSLaGsXwjaibCSRfxxy6Bm	1
2241	2vawgRkztZtkZDQ5BSNaT9t7moZ8C9H7v2sQ5iPfJ4h7RW39bxDt	1
2242	2vbGyPHn1BWY2izGL9hGTiTyQGT3QanwjHaGvoRyPb7x7QzyvcqV	1
2244	2vc3C7Z4izLWZYfcd5b7smGVgQ9M4N9qRE9m9s4uwdtsug88zPgN	1
2247	2vaZA36g5W5P2zA8MkurKqCbA31QgEc5w4wMFG8Lddw9gk4ARSJL	1
2248	2vbd2PAhjK19CCcTvYCe2PsdASCJzUXKvJsDWm9pdVM9fsb69yVk	1
2250	2vbrySigvSRKxhJS8NicU54fcB5eVofbAHGc1ehL6nGRDRJHAdDS	1
2257	2vbt1kWPKP1MeCPWVkWV1wfQUpdFHXi5XPs3SpVJqQkX4kwAxtCM	1
2260	2vbncPVERRGNReaD3VALismwbBFjdAu6iUvxmvD1bvwJdAmRzhcK	1
2264	2vbbCasoH5LnA5dWyDC8FgXySqP4E4EV4vcjADn9mmmtya9S1L6t	1
2269	2vaqgBDroUvdA3XNixKZtkNwKppuyRoPEo1higkgsHQMYakucZoA	1
2270	2vbRAsozzRRM9ZuD6ktJ8aMYnsLR7kjZWY2gHR1GLw74JVv8QJnr	1
2276	2vbijXhWWcxgHr1wf46Gr95neXktgRHkJHxpK3WqQdWxjsccLhAw	1
2278	2vapfpxbrhjw9CazoSUYGnRgZu8La4ujvDifA1BkLa7yuNw7cbRw	1
2282	2vagHYTSRwYxx72tY4RjaMbkUQgnbkdr85zVY57UayAeKd6Dd1NP	1
2286	2vazVczBgo9qj2RKKc1AQ3HDBu8Y8KZ1QibksbybzZHAvuQbbbXN	1
2288	2vbyFc2XJWpeNe4Q7L31PAijRdxVdaYgocWcfXRSnk1ZQwrYrk2q	1
2290	2vaS5NLvPeWtyAf5gKvSCE4JgY5P5LaGTfBdcJ3bbxrLjjBHvK1A	1
2296	2vb6gRV2xhptdL19JDME27gYiF42iAebB8w9uGJE4V6JJRmyTjHm	1
2299	2vc4cE7QFUvh5qgyN8D48bMdDSCjbN7Ffxfyri5YodGmcNxqTX85	1
2302	2vaQP8TuYKP6nL9huo4Lz7LBrxgYPfQ4P3u7JHensr9S4yJQwLP8	1
2305	2vam5GHJ57mhJcrnykDyKgvoGRD6FY92W5Qm8H54HtSQupMxyZ6a	1
2307	2vbzjTGV6GX9N3hE1mXKRwir54x38nBthuQJvS3VNqHcRboWPAbB	1
2308	2vbmzhtfe3EjVeEHXxDb2LbBxax8FtLyJbCQjFMh1T6LwuWp2jjr	1
2313	2vbx478AxdZBo5qjjfrDjQgU7AAWpbG2BdTWnhVjptrui7tpcofe	1
2314	2vb7hWWTmSAU51k4PBMagzssGacyd1p1ECto2jkUaYittk5haXBA	1
2316	2vbuRQK7g6Ep2wcBuDqyW8eRW7Q6PG6kovtH78bMrUvyj9DN1TAo	1
2317	2vaGwczbMD4CzHtoL6jeGJm42dezVHpmuAicmqReJRkBJBy2K88p	1
2320	2vbctsCrfY12pvarJS477orT6EcVAmwfKtWmrcHsL2fY8JXcQxNL	1
2326	2vbHW2DJaLXcYjD13D4aKoxU829Gw3DFX6taPtgJhCYgTXFSzFNK	1
2328	2vaEjbsHUzeDpNoSnc7Q7ZvL2hRfiVCLh1P5D91pWo7VMLZdWQV4	1
2329	2vbC4uJFvJvufBcCeEKw4ctqYQ2d1eRDTvWC7jeb9dbjQBSyQ9EH	1
2330	2vaneQ2eJZ2KG9axWQboA1Ey6wXAgcst7YsAZ7uMGaqoRK94Uuv6	1
2331	2vc4AZZej2cXEa8Z5jc7PvonVcYu2TU3cPWWhjfci7xjrkmH1gF4	1
2332	2vbBa7qVeAcfFCwNv7gxiRFFrbH7PvVQRHZDpQVovDc1wP7HuauP	1
2333	2vazmMwkjmKUBvjJXQGyMiiGJPj3wQ7XhW6pbkFJV5HJcGKCSSEr	1
2334	2vbpTPsg9gpG87bkqofaueUJe2oQVQBxx1SVoFpS58uGobwp5pgu	1
2335	2vaJV2YPPqyUCC6CDpH7x53QnUXSd4d6t83hCwZ5zUrovRLTxTSP	1
2341	2vbXer9pf5De8WyKHVRVhY3HpLRMwJCDiBcttfieQiqLoaYMRdbQ	1
2344	2vbLJaaF7kggcVKPHdiEzkNZFBVUjdszh1Gix9Qsdjv1NnPTepLn	1
2347	2vbvtXEGCN6W9MaiCdDXbEsuKT74rpXvJh2Xo4BqqkYazbXtT7uD	1
2349	2vc5n1aoYxurK5YxMNP2n8ypCDCgVJDgEwMp3d2PKuWkR17aZXPQ	1
2350	2vbMESk16Y3u4dGZdku9v7JJerCQEdCkNEgEPoG8gka43Gy7KKvZ	1
2353	2vc2utm8Jv2GNWZ9QXVVLBgPxUKurGCYiJHRxHn8tyE3SvtNQ18p	1
2355	2vbbuQbpLmLQfphQJJ4Fn4yL5jSpTP2JCwTce8MReY84kQDGDz4L	1
2356	2vbnJGGgsPYaW2qT7fS2kdza74vNPNjrjk6hHF8ZzhkDDnVCZPvw	1
2359	2vc5Cn1ZQzmwiNBiwgPGhmWjTMkDx8wWjg7U2YsZo9YDNhTTXHDU	1
2362	2vapFkPoNjcg8NwSU2iqn4FLp2J3f96YLSx64vv8kMP2K1FpQ8D6	1
2365	2vaNn3FjHAbvgVzqNBJhzVq3ADeEXAxCfMwkhpQPjdsziUwugMnG	1
2371	2vaLNZgo2Zmyy9edavoSV8kcgQY5HLUBCMRw9dfvJuEq81L3DGTM	1
2376	2vanbFR1fufBfP3H4Bs4MQvijbPqN4CYRe42G3jsSENWKRt4kwSr	1
2377	2vbi7ChcJZX7zxP9ueBYS9sXiLiapbTPjaZtTRi64HVYttzvJSa3	1
2380	2vaVcofYrPDyTEgin4j1iD1n9zyZ3sNAL4Xk8QkBhDeHcMe521gB	1
2384	2vb1wc1xKZzkD7qPqNtS7obaeLmof6DNE4zvgigSFAxQNT4AZPPw	1
2386	2vaHfKs9pD9CX4AFZeHChSeToiYsGqfZ7Tqjh8Y3GPUAYrRBoy7B	1
2389	2vbhu8tSdTdiw8N9MbSKKS1BRix5Y24cHeLx5vk6sK6g5VRhZ8H1	1
2393	2vaDBBUsCzhFPAoQLHSeUENX3idry1trMHUWpTZWu73UvMVLGQZk	1
2399	2vbFr94Wwrf2wpu5uGmHT1mUwNJmFrTTpi8qrVy9afjwDp11zAmL	1
2401	2vasA53QX3SkSBuuxhxSwCDLHdjyYS3QHHervdcxmf8h2x2HNaMJ	1
2404	2vbVYyVEU4KmbyCvqscpAAc1fYFZYU7ewPhzJG8LzP7rXouAFxh4	1
2410	2vbABkyiVzbU3WTqBQvUwAnhf5HZwfpYJou6GMHVmczREkv1nvYz	1
2413	2vaEkq8pM2rzBAHbmHaLYQttFJ8mpEozJeugKbLAGyc6dbquM5Zt	1
2416	2vaCaasVyKcqeXfVL87FSkfexmMgFtfgHyd2cgfp7X4fEJQec5bU	1
2420	2vb5H3M7CyDw3HmWFSQE2zvvwGRa25VjmLRGv6s2aaEcpqfZXRfD	1
2422	2vb74fUUAYWaZK7diovKvjhfFuKU4VnHqVxMwFNFvVu9nzZUiM4V	1
2425	2vbr9zDbumP9iBaCtVNYQzfbry4hgKBu6kjW4tCFLFzX6mFfduc9	1
2426	2vbpxxdahZ43c84ZhCqc4DwrPiLbkhGk1CY4Zaxjop5WCKhrXeon	1
2427	2vbGurbmUDuTFCnfE6q4sBnNz2LTTERMX4rJMNSaTAAA4K9qKPyh	1
2430	2vboPKWuZmXLtxt8qzUEaocGzCcKqvfQBDpqDR5rnTecWLBPDgVq	1
2432	2vap3H7CXQVLeTkC2cDdwieAR8Dt6QmK1hwGxPgMgL87e6vwSLC2	1
2434	2vavKwyCvK1xiqgPapfaSSLMPHChzoxQ9rSVndkXkbjf4DRnEfVX	1
2435	2vaRyfJwR1hNhaJDNYDk8ybhoUAoTKvEy3Fc1hTb9PE5nEvoxkgk	1
2438	2vbxHkFQmL3kH6dwGB9DpWDxYBkrvCW9HhVYdTNBH4fEbnKe36J3	1
2441	2vagyzG8pTPh18xqvMeJ12ax6zDzwo5dRQxV4Bz2V6fgUy7TMQok	1
2446	2vbJBM3WDSmK5VBvZ529AmNu5m9GjKLc14j7B9cecHVAP6p54kf7	1
2447	2vaY6Kb1YdmV9dT4Je6GsLJmeyCpsfn1MxgddDQwLmUds3GHLE5R	1
2452	2vaGY48ymahWy13YbADpiijMxtJJ3yXRqgT85WPViZe11t4KTQQH	1
2453	2vazTkNWpQpUme3hENdELDseRCNaW3moQVtH64Vfy1wEwfm7ppyA	1
2455	2vbwu1ZGDcGFBpHrhi4QrZAezarJQpySJ3Gr4nQnPQeCv74b5XQy	1
2457	2vatTo7g3kuUHPYxAPB6e6FrdJMazyS1gtkVawGuHeYZp9LbezYi	1
2459	2vc4w4Y9NxvRzR6yinKm4uq53syrC8tqf6a4URTnfqWqRvGZLy3K	1
2460	2vauRQ84LPs4uCbCe2prHLyeWH8sAKTeXFz6HTGw4wBACZjdqULv	1
2463	2vag9SS6Q84cnXC6X9i7qMekHXC3A5iFNpXUjECwjbrfqC1VfGNV	1
2464	2vbw347sWW17QYnZ1VLMHxrhvHyR1RMati2xraAjktQaGrVLkqvm	1
2467	2vaBMG7GE5K5xEzupbuXrMBkJrxp9ciJESvGZDo4r77qEHKyktaU	1
2470	2vbECzTRCjNpzs2M98FahBC7BMrk6yP2keUMpfBxtwb9R7G4k1gc	1
2473	2vbVvmcBQJAtupBoRJmXZYXD8sJBRqBEdW88ZXWfGWhWmiKSheu1	1
2475	2vancP5VNUhSJRnhqxci3yCgKvoBh2YRsMiTq8NFwthTkihRn7bR	1
2487	2vbhmcxdCN4EKBw6KCw2SZFYj2DhCyrW9wzp23jhVcwwEiK71eix	1
2489	2vaMGbp3gD6vDPwowrtrr94Fsjh1hpHVTyyzq2ch6JwZcYqHRaeR	1
2492	2vaJM5hH2FwPTBdUUF3pPsFrkvMZcCk2ZyPHAiveVu3EipeNKA1U	1
2495	2vayAJKVgHA7eMqvFTZdGFJ4Z1xMRZwVjGrrYFsH6T2YFyXjBfcq	1
2496	2vbQVDgcDfmNE2VsvhBFfpuMUEGqji3Y8yxuZjjH29CPe8mKqQae	1
2499	2vajzLVA1GLxtux8LJTEQ3wTLwcv2jpzK8V7F4avsh86pq3DcZ1F	1
2502	2vb15nbHJ1oEUxb2BUMhd8sb7XniEiyMPipvfzRXYFHoEc1oQFoS	1
2505	2vc1zkVsJsgDiHgdwnzjLYk2VMS4d2PJfiuq34tGZUQQa5ntPV7X	1
2508	2vb8CCEHagGAGp17XdYMGdWre5VzdntwcvigBzsXbQUu6phKeuEZ	1
2514	2vaZFBNHjhhuAM3pfXL51RjB7zLDJBMweHjLQrSgGkpp9B6drCGM	1
2517	2vaLM5dgG5Dsuj2KLiH2Jp4qDEPJe5PnM7MtRp8YavdTQtEQdUei	1
2520	2vbmNVwdp4tP1s5mvMQorqWXttK3JxM719ijeLTbwr2fVde5Yy8T	1
2523	2vc2AyNNHFbgCeaSBpuU2sx2rtQKQ3DHhpvWMyUqnBbt5f15pw1D	1
2525	2vaUHigqpRuxQudEBPWfycKmAXDyB3QnkL9s24f93NBjcYpJyHSy	1
2526	2vb9g5MYoMPttze4hYj1wCtUr45XTufxhjBJpYZkhLji3NuJfZA7	1
2528	2vaRESxpGAvzRftChJdbpX5pa6SxLcKgktRZ3GtmvaqGrjAdwiAb	1
2529	2vaFyffs3uKJ1NC5xU4UBQ7uhfQZds33CQgHckcEdAMu1mhiyGKN	1
2539	2vaeTWZ8SkScCJzJGfivWq7ths8harEpapHxviW1ZEB8ogrfb6hh	1
2542	2vbWMgUD9pgs6oMgMiaSUsMvZiqE9f4MWbHqPeKfpHpTJcNEfXrh	1
2545	2vaTPnvEiQmdvXqfmrXTScgxZ6pPAfsDzDu3m2Lsj5JTj8bZHuTb	1
2548	2vb75eR7YVZuSwKtr7y29oN2xvJxXFaovZSLNHKKF8A7DaKB6dFW	1
2555	2vbgKBce6QxyrwGhgVUJ4CcRvmtDryGRNHy8F7tbrfJEZjPb6fnG	1
2558	2vaExQKNXCHGjVzRFpMDmqzMhGsTAWh5jbZ239V7u6d6Z8VvNJic	1
2563	2vb1KfwzWPdBR7Jw3kmfmH4Bgp4Di1wH47PrQyhm8Fgz2LayLtn3	1
2569	2vaZ318K2pKuNPSyNU1N2dDUTFFMXpM5ABA52Vb6WRmJYnFkVFhK	1
2572	2vaU4JpT41YoFUfCaV1W23gFFPYgDcUz1pA74wJosTCSChHiVK7a	1
2578	2vaViHZ1r4q5YNqGaJY4Usd2Z9ufdv1efgGdbFoXZmWvuv5xJz36	1
2580	2vaHe2KW41t2nwP5ZjBKdmaN999cGiVhdUZgkLMbbNg7C3Mg6A5T	1
2581	2vbPypZYD7ZqZ2ziDUmwojJ8ASPhwzw9KgAxLsx8B9DssGnA4T6S	1
2584	2vaRCUquFYkcZB2ibv96tBWdUjfdq4tzG5xycbY8KJTTtG6UC3W7	1
2587	2vbgHrFtZpeQ26cw8YyvSCynqekaewXAEwJ8zrPATjhK4D3VaheX	1
2593	2vbRkfMrUbeKZBeu1ArebiemUQSomhvnyV7WgYa3SRVE8eAkKGwu	1
2598	2vb9kbWgPE7fXz1Xy7Ycks6E1PA6Yy23WMNicQRv173UwGNNCGcf	1
2601	2vbGrA8S4Pb88nwBVRqw7fq3DLsaLtthJjKzeiKvaTCVUVzdbxH9	1
2606	2vaFH7n9xhNy7VZ5JsZ7W7FerAvmahhdRTWpDiVYaA9TDLfhCpDd	1
2608	2vbmZsV4USfDAbmLBhYq8g9XTL3CC5MNeSWEDUKnN5GsMHL8J5SF	1
2611	2vbyVgyXDRU9B5c3ZDrHAhXwZp4mnKjxkUWCcukH2BKMJp3MPm2P	1
2336	2vatGbc6pYXMfnsYjFBEL1ZHa6LbSNmwp2bAkvVLuWWytNqGC7zz	1
2338	2vadzBpJZ785ne2hwcwgKtnGEN5nLQbNRkARKKQVUdJjjXMj36x4	1
2342	2vai6KQuHCHXc81wv9xQXptmAmsnsGtguLc6gHr4eRujLGDPRioc	1
2346	2vbGAST1WhjRqrUvrWrD6qx54bdcE7jHkuxnYdkA2SsqhJz6qrP7	1
2351	2vbapvHVLYjhKDm9hdXRsNDtb33JMdzJgM6S9vBW8E6VSo7QSDDD	1
2354	2vazd5sZiy65usgwsmn9BpAuQCQHUnuwX1skEaXgbx8jyF2YTZYM	1
2364	2vapbsC4ia1aZk5PRoR2hfzvTPxrK1qW2sLhgxR6HyvaFrNtiWdT	1
2368	2vaotigZhXf359kGEqBoxVToQ8iCWaTKnRpYos8jmfaZRFoGMYJN	1
2369	2vbknC65zeEpBXzbeP1zVphmf99EZJwFJnYgzaQZ8hcnUko5bfDb	1
2374	2vatXgKvS5G8LxpfmY7P6RMt4txYaqjBbDiupUYVNpC1NefyBFMZ	1
2375	2vazZLozPzEkGepFGfvGnBgdmDHB6hGqExC1bwvngHmfKkykhxBj	1
2379	2vaqKwZNvChurWa83yGcLxdM4cBm6vwusoKuZosebVvX989aLcAS	1
2381	2vaSwKFAaEii2zs2aFwNZgp1isyZtJ2GKr7kwzvyrkHhFykizmZh	1
2383	2vaSdwJhjtHEfZpHsC35JW6BD6NAyoaGoWC1LZV5eygb64H7rEZa	1
2388	2vadNMEJhfyQeCQ31Ws8NN4554v5wUrhX3Atd4VZUeAGZet1vWZ6	1
2394	2vbHHeQCkQ55F1sSURSvZBPHoVgTLwK2nrCMDsDEcqidE5t5XQEk	1
2396	2vaFdK21wH95PmA1zSxjwiVPzHHRV1hG3q8fwumyaDcbBa3EmwkA	1
2397	2vbajQRzBLvD2UG4LSSv8gwunstQxznHYZhyHwAgcr2LVK4eXC2c	1
2398	2vaM6L6NW9WKCDKCfgaYv1qBzmeuEDgAC7njF5J1jhbFben7vrY4	1
2406	2vaG5pN6B6vDF9bAJKL1Fnvn4sQGttgt3WUfMc8wpJer1pyv3p6f	1
2411	2vaXvDhnt6Uu2g8s6R9k15SJsmNEqrE5dgWUT24qhraQEoHkaAx1	1
2414	2vb1BW2VBMsMsUZFnkDdAaN1qUcmuMjVCECw7NSbjvHhDQuSd4Jy	1
2417	2vacXF6wJgasQCqWaFEH4mCMWLXGiqHEEmAcFvo4fiLKUbjVbv6X	1
2419	2vaq5iHdLnSxZcynKFwmeaciJWrp2RZ8dKZ3uTCrofBQLnpkY5AA	1
2421	2vaijsjRzzYHQ97NZQxSrvipsF7HDvLqrsV3PJuRpPMxqecHFviP	1
2424	2vaXdm98BgyS5rq7Zn5mBySx3wUdDvcpSYvhgFiyqYp4L3MNzxFz	1
2429	2vaPCA3vs1g3jw9ZR74ySDqj66gwmEbnuMB1mtSnRezkaDRD6GtE	1
2436	2vaZPsP5Js4UEcp8AcCYAb89yPTADKE6AegrPvNCrPFA8fTLTBLK	1
2437	2vbvGvrcGhB1hYJ2BQw8pVkwffD42iw6Woz5ibqHsYYahkhMca9C	1
2440	2vap58RtFKrsgmHRmKfLz2P3Mz4Y1zrs7dv1t4imvF9KB9P3ZccA	1
2442	2vbhGY1i2JoUckSyLp7NHnTvxB2BJJtB2fnBvYjWwanE59RCJbvd	1
2450	2vaJZFeeCZsXHZGTefaasw1dwv2pKerpZcZgN4GKigwanWAev2uE	1
2469	2vbkVdA7KZgfUFS7c32VeWNPivETQ3zzimjF2YvMwY1YVeu7DX89	1
2471	2vc4oBE9NJVHMsTxRTACZmJDyv6LG3dNm5N5DC5Zy7qiqm5gup9f	1
2472	2vaCbXGbgr7KxqPgHnoN2fp4avxs45yShN1UEpAh9JX8U77ydkc6	1
2474	2vbkXXaVkRN9v8PpVKd1zvfFa6uEZRZXTgbfbzNpsdnUM376QsZN	1
2477	2vaoEDQAN2mBE3Hb7wVBkZ5wSqDh5LRLgXB5rPWo1yRFH57VaFgW	1
2478	2vbJSu9pgsZwDsJTgL2NFoK3jB3MeDKbKwsUo4odGinPkeQXR8HF	1
2480	2vbUXJwsUCazg2GXEXVztnyGTRh3LbLe488C4CLH1Hr527Uf5V8S	1
2482	2vbnU1bvfD58URmT4Yhe2jnDjV4UT99K2URUpM7iGDGL2augYbkd	1
2484	2vaALrqykjCo6E9BdEwmA9x5TNiyq9F3ee7PCiiCnD7LSQjuzFDc	1
2485	2vbyM4fwT2tngrtcazpmY2ztE6Q13ijpEri7jVxQvkcQELpVejRW	1
2488	2vapuoHH3vc48fb1ss8egntmsH8C47apRh2rYXgtkw8fSFpEzpSh	1
2490	2vbJhAVtERnXVwFV3EyL8Q7rRJtEcCYSKdpj8rUt8PUsavUX9sVf	1
2493	2vaoUJCxaeTgLE3TUkwc3f1CgfaiEi6wfiiHSQqogAToth2kkMjc	1
2497	2vaR5vPArAEwWtnB1VhTNv4zsDcGauqC6G4dzost194wr3K62Bap	1
2500	2vaf8xh2kPDsPQ1kBcCP2KKUqsB1Ce8StLwqukEXScYFD6LoVQUP	1
2503	2varnHjH6BrpSjRkNg8kAZW7pvC7k7ZeBNL6WcLKeZz45XAWQpz7	1
2511	2vbVdoqtft4LEbKkAeUmsxtxz5ZVtxx13Fyi6kuczB3ySwHs2goP	1
2512	2vavDqFtWhkBZ7HKe78hvF3J6PRDA9c7tjAsQV2kLZJZYUmjnb28	1
2515	2vb5TmSbD8Ci2CPNRzG9kGZJPRnyXYyuDcX2YpEfV1tGkxUj7J33	1
2518	2vauhBoboA9fon6ANusvwDMSRG9U8ubTvGkYnY4BL9PgnPcSvXdx	1
2521	2vaAWgUuWCxw2ozgDiuGKehnvGqqMkEDDdaRxMDJ2wk5WkGFn84U	1
2524	2vbmVzW8UXRs9UFEGmF3GYuSp8y5sxa7xstw1iRwr7aLXWSFe1DM	1
2527	2vat5sg3HT3v8p6MkokCK8adZtHbBVH4oMj1R1hSbEYmJGMpQuZ4	1
2531	2vaPQNBe9GewbyLMrYiJGDAUCsCtAR1dUwuHjetaG3dEE2atqatG	1
2532	2vaX6TTGyVwo9pRvFLAkisQezcfr7NHSoMFGXtTFhFYHyfuZG3WS	1
2534	2vboxpxhkCw5TsJe4nRL8ZZLYdJKtXSJmDFgHucTfnau3fqYjhGH	1
2535	2vbxGTdfp6sPCST36cZRtwz8CAq7BMLeRpL2AVS2x4B19JEvTjPx	1
2537	2vaMoNQ87oYGEifsjDS4BQxd6aU6XPQtN2nUT82cup6Py5zJgFh8	1
2538	2vbReNvmVKRzLYtSNNWrLit3PTNQgAYRpyULQYSRyy4Z2pcxFBVN	1
2541	2vbXNFTshk4PAjk3TguX35EHD8b1nZUtVTmp9aXcUUcKy5LMq6kp	1
2544	2vc49jr6KRHKYMn52mr5NUwU4f1xqhEoXcXPdASy1BkyBsSL5gaS	1
2547	2vbgsZjatXQnKwrSXt52VukMFKjK4nQHvPUYrz4kxeugPHrfpGiL	1
2550	2vas1MAuadaKeMnbd8HzQ2SsYxgEf94Ng8v3St7wzQKyyhbw9ngb	1
2553	2vbuHToD2wXh3bShPiMnEtAxRHLZfwDS3n7ty8wuCY4wznb2sbB2	1
2554	2vafcEzVC6peemqFR6SVydjbHphNLTanoajdUBLu3AAzDbEnq3kA	1
2557	2vbguyykMWXce5ufzkjvGzUGQzjc11vQnUoJwTMhVK3EQYdJpiAx	1
2560	2vbwtNFPgCgk9vNw7Cd6HtJr3V7BmztioTQS7kXbgByNe5GKmJ1Y	1
2562	2vbwf3eGF9Mdbz8wAap3TYmAmoMdNroShWEfDTyQjuYGEWNvVKcT	1
2565	2vaRdR4WDa9XFf4AQBZAjWaDWBMof3b5VKpGKPizNnkaZHmMZjFQ	1
2568	2vbZoamRWuRvSMs6HpWs1RJGAXZDtRrJdNVYjiYx4joTokc1vRmK	1
2571	2vbcpngAgEFKww5HUaBjEMr6mkq5DiAfNrgriV5qdtZzyFU3gCLp	1
2574	2vawFj4xV52EZ9D7kNZWprgXu8qMeNGPhmeSigsWvCxJpnb3xxwG	1
2577	2vbBmV6Kcaadknc9aNVWgpbe8nWcPKUbhZPoC3XQNZKSNhbzgsJJ	1
2583	2vbcSXAje46uHsVFX9oDLKJHjHke9dd8GfZwBXqmow3VxXHQKkJJ	1
2586	2vbe9gXG1waWpBckdThpwXrGqqhknSJZrgj9G4eF5z6JtZYxrEis	1
2589	2vaBHdLVJBH1MvYV5s3WEUxNatW4VLaR6x4R9sJwEvbwwypfFeEE	1
2592	2vaL4bS5Vr2e4Dgf7Zw5Rw3t8JX64sbp2p2r5hEAh3aD6nye1k2t	1
2595	2vbWNeCbD1KMoQiF6fy6YQbJBwvxGty4Ba4XbGSCEumYNgRCjFQn	1
2596	2vbgZHujn7h66vymiKJhC69Z7D5v1PjuWvmzyTATrqqdwcjrftvm	1
2599	2vbzxVg3ZhyJvY6bvstpjVFJK6EVBg2rWVuWLEE8wRwbokkRiQ5D	1
2602	2vb7mWL2H5Z4nMUymZdweyWpRUiivjfXXb9bxBoZ41Yn6mNhQemK	1
2604	2vbgfxH3LJ1bT2qwECUP7VWhdp49Wa1YGex2FVD8gxyjeZXJNtaT	1
2609	2vbdchkYkH3XPKY19geTmVvYZiywUFwP3DiYnD84xT8ugqZrZFjj	1
2337	2vbcfB5k1hmKdEdn3RKN2QzsH251TFf8udum7HRsG5GkyJnzj9m8	1
2339	2vaJA8CBrLmikZjoKH9CdQ85YpwYAuSzXetRVSKzUCnSGB99yh7G	1
2340	2vbDVdubQhMLuUtAvHp9BYJ5Cf7cQhcRj9nWQtRmKoikvJYmfMyg	1
2343	2vc4RGWEj1reN2WtYvzKzdN6wDn1to32SADJUH2PFV6SEv6Xmrzf	1
2345	2vc22hUXxnRdGNmgaaq1wgWv7bG5ANYvmyWFvYUwjYTbwrG8xA4t	1
2348	2vbLXPBft6u2SaqVZJMzcuvq44ayo3GpKwyZ5E8kfXZsCHP6YTMx	1
2352	2vbFEh7vHVxPsub4GjxsQ648z5Ytt65kHuDUKme832JUUD7NcnsR	1
2357	2vbWVB9ttnQMvjreAT264GUUUyQuD3v4wpxSaAvGYt9Phg9L3DA5	1
2358	2vbZ8Wj7VdDksixnf2M1bbqAGGnYs2EYxFx4EsAVfMC1VXcsorA6	1
2360	2vbNenMcJR1eExswfVKvwcSv4cukcVj9NvdrqbWEdcXUN6R7RJDW	1
2361	2vaQ2Xf1kUBEBybpS9z7yKXU2CNmJBvQZLcEKbDyZncdfCxS4Thd	1
2363	2vbNvJV91Azkb2MLXPAfkRtRwdf7tELQm7KdhtHYiuqbk97PrvT7	1
2366	2vbxmFiGf8TNuEc18hmVk3BaN6VFJgTUQwg19A4F5Waag2oPv1C6	1
2367	2vaqnLepxB7gnemtCWtkQvjV9N8CUbBKbKcgUx6i25rTGtH9o4FH	1
2370	2vaFJqGWLk9kn2di7TGMzSab8YHGVuDr6JNWn6Gbbd58U7jn3V4C	1
2372	2vbvDDHcLfM83GgH3S3JTjYUNhmMMwByD44UhR9WaVBY8eu1Sn2e	1
2373	2vbbgA2VD9CX2cArdusu7tngpb2rj3SESVREUdVwZ3vrGNJEqmj3	1
2378	2vbozN2WtbW4TD46mFn5BHpHmvst5sdvyek4QzJmfhmkTeJBDbrC	1
2382	2vbp1HnfmKaCDtxVJCaXe63KPtWrMpgY6c2swXo8X75aicVGVrrM	1
2385	2vbUfBt6GZjt6YSpTqyCnjfHodnjhoDr5V1rGEfY6yrCunbPn2Hs	1
2387	2vbgKRSMo48xmeAxZjEJojSjGJRWvTGPSxzmXgomurRKJB4QQxwp	1
2390	2vbCRB9dyc94xrkiLvAkkh85C1hdH9hXLy9uPEzd3v1E7QY83i6c	1
2391	2vaArRkmXPduZdnj5mKEySpqLXJQgxUjqjoz8nC6FrRL9ithHX93	1
2392	2vayQPrguuJmPgBDtyh5KCCFaBb3mnEqiGgnA76WpeGw1U39X8Zq	1
2395	2vbtkfeaWpmF8jMP5AvYSMKXstWWDYAS6MbVxYYw2F6fYbpkhpqT	1
2400	2vbDTePYuuz12Rs53pSYoANompyfYAogxvUGGByA4nASpdR74hYP	1
2402	2vbhKGpCpT9Qncu2o33X42LDRq2dVPULXey4wL7jHkwEqzAk4eeF	1
2403	2vazRHfQh8pmYyLvFXqzEqvkHsxJWEpPdTT8af6QpnSGHyikj7W6	1
2405	2vas6BXHrhGsY5cxRy8w7Hv1GbTHyNEQUEHrJ6ngHHGt9YXrUg63	1
2407	2vayM786a2piN1pKdogzq6uprae7NgSdvBAkxwCaBdTRLb6YJ6bj	1
2408	2vaFBcv3DhvJYaBqJJGyvB7rW6JvgiPaTtk7t82yqntoCor8GLSD	1
2409	2vbaw5FnHEdJtHFtFduSB3MKFn2S4EB6GZc6cjfDuQuioyP4zuo9	1
2412	2vaAv3wKF1qLwpTQzWvMdTV7qxhavpBX7aSTLnceLgD3htZSDLuM	1
2415	2vayLZXfH3o2TTcGBfNZJ1KYJ8LRmna2Ccb3CAfvp7LujaXGNQYE	1
2418	2vaGHu5vMyaULWhb4XduALyKb4DB3vRRKfFeFiN8CTgunWbQpete	1
2423	2vaX3MxmqCrzQvpbtAcwKvFGNBrYxeztegydtTzhwrSgY67ggy2G	1
2428	2vb2Gq7LQZenPddscaBEW3rKZkeQjjdkAzBXddjkJYU91nqk9r2s	1
2431	2vatxKYkFegvcKEeGy7hD3UtoANewy5yxSWwd4Zgk7w5g7LZqkvt	1
2433	2vbCisqwLYvdCzRGzseKt9XuVxJSkoJSSwhcdPTbBp52ZxtHas1d	1
2439	2vaeqwCEV146uUPxJ8gPqXuF8HEKXBQeX1MH3FarpE1U9EXew5AD	1
2443	2vbKeA3WhZQDBSfYzrKtw1YYu3G1ES5dcjyhayQHcZiNZ5CzVuno	1
2444	2vc2gKyw3fkcexBCCdJ2KejEBEDFEJDjxkciZ3A5pLfcMRueQoJy	1
2445	2vapvFomc1FoN8o9EpVYuqvyd3NcEVB6c5xBjTYEF81P7WF2ybQS	1
2448	2vbY4TgACex8hp4ATq5LXH86gF7TZpK7ianr9Ffrk6Sh1rxD1PR4	1
2449	2vbMykhn19mCHcoj4kTdAT46Bmaxf8ciwGGQbX2nNqMWYa2qTB1V	1
2451	2vbPuUUSU1qF3HQLkUj4YE75byfP8JckuXTsqfdfQaos1CNDfL1w	1
2454	2vaFudyiiKQBzoWJGbywCW1ZYQEob5QcdjTZ1iP6ivBhe4Jh79Rm	1
2456	2vaBm5iT6ZEvAYoLPj4w35gNZSZRif2E8tkdnJLwDnQnqbAM2EYs	1
2458	2vaaZJsUBj7jytSed7HzQsifqRChFfW7ivSfFH8BJ7HEGLNxyvS7	1
2461	2vaVKv4Q3qgy2JfxwiDKTRwL8idKbqBJxkbNc4WmaGoDuQaKZDX4	1
2462	2vaGdkbeTgh5UWGnzdLUa4uiJPbfrm313ekNLm6veSorUiKjhjkm	1
2465	2varrgeyVqbsfzVTt7iGtRUFQugi758BsM2FPjwQtRX6BuGmiyuz	1
2466	2vbYefrD7cpEkDt4qzCkqBMBJo6J7gHF9NvjKkV1fG91z1L92Zp9	1
2468	2vbiQhTxS91ueQxPVw1CqdU12ePxj29z3Q3uYi6XQWRGJQ8frxx7	1
2476	2vakpsosTL8xZHSeHP67Y9x6YXHSELBsE9dacGXYhKY9iZMdebqr	1
2479	2vbUqWwBjCMX31MQ7dUMvMRrNxCDAFHT8VrvDA54UCPboAjvynK9	1
2481	2vc31wdJxmec3XJbUx3CgGDrMvuf14eNmnV9j6eY7FJWnAv4G1kh	1
2483	2vafvqw8XcGTsj3W1LyBJPDNtyBoCtCQwPVGZrVqXy7qaQ4d2Evv	1
2486	2vbtMJG5uRYWVrsTXASynCEgbaoSb1sYJKDTmD2UTLytN4nXZYpH	1
2491	2vbAWBaJSV1JVzaqE3hKNNdCgjRVYz3p2VVmnsghQ7LzPYCk1HFq	1
2494	2vb25dQNy3U7u7uMDCXJiw6KZtt8FTRq4GFSeF5JDGvkaqRaLUjG	1
2498	2vaUuY2Mvt24zk3RnBhKkD5X3h5P1ij8x4ZWQpWasYNrc3rcMw1a	1
2501	2vaEaZ2GFu4NYAL6tb3jr7xg6xkRf497iEAAUH5P6K5eYizDAaYC	1
2504	2vaF7JhwJWt1vMcMxDzSsCxm3jexbwP35BXW2SUQhq2JHbpuhQK2	1
2506	2vaE4Sae7wS55TT5iimYtmNAzStJr1miLMFEFnTsF2ogYPhARWmb	1
2507	2vbt2GUUWJCJmKfYZJWXS4QVsK87ykWTfrRWk3hCTw43VdqoMF2f	1
2509	2vbY9GhrPSWUz3tYup7dv5F9GZKscd7odyDVntfq3ixP929kBKnd	1
2510	2vbk6FKDQzvr3qBEcKmDWRt68tCiAxtu3Ad5enG1tpSHC6uMp61D	1
2513	2vbxhBfWSLKBtEdovf2fGDqt51oXQZ3ejuDWw9VfnJjabBL3LBmB	1
2516	2vac6qszs8aSoyYWfDs6pcibZpvN7ERD87TJz5nHF99ULi2bA5tg	1
2519	2vadT8LmMKyyD3YBjCbc9HHyDvJ91Aw6P5JYzjNkzsoKjhDnPVL3	1
2522	2vbb15v2bZ3sx8f9u7FZioo5qTMkzVTnFvZ72nYapRK3Ztw2FE4J	1
2530	2vaTPo3rRmKYzE1pQrDen9cgVwZzFqqCwKnwSWGEwBBbbb6Ac4D7	1
2533	2vbADgPWTF6Du1ub3pP7QsFUxqCPvrQHSvSJv6mNtDTVudajwRCC	1
2536	2vbSRjxFg7yFv3b9dpmZiSPJarDJfJLcGwGxK64nmgo1WXLgNSLM	1
2540	2vaEzsYNy3qiy58aHTnE1faYwdaLhKPbsYX3JiHZqzdELn5bxzg9	1
2543	2vbCMH9YPZjBcJoNyAfq5ZR1B7gedjHgEuhDU2TeDdPAePEVqiEU	1
2546	2vbg5zp8HFMeehbMVwZN8ZhJW7a5ezmy6AQs3ytjHh8hgQci9Vtt	1
2549	2vc1HLPaKJSdyb2NixSTkJMES6xBDgmaFJDn1sGDVSoQKSzxAfac	1
2551	2vbihNXmzFhZRQWDhUYqUpMqe5xQv6S1PTkKP3J1iDeFP1KEHmWT	1
2552	2vaUk7rUmm6f163XmUmoJDJ8fGFghfWbWfaDgtuVVoE7b8dmcCqJ	1
2556	2vaX9u9CesJLkp9QBU6fxcWVCW37WJyNib7MRRzBBKnofAzbLpWM	1
2559	2vbBdT1pgrtudEsYpPx7nYRJyfiYE2P2vzWWzxgL4ca6EhK1UKtd	1
2561	2vaoLgMqoDSvvFd16BG5hFRxGHMJuJLmGQnj9nDjKDUPHPRrkB9i	1
2564	2vaERdX9CTHwVATr6x9aJMxKB4n3sXSMfCUMzpqUG46PWb9KFwcC	1
2566	2vby3dUZtzWM7DvemAoqzHWhTbK8X5LZkL8GPQqT1HsvqkoRx1CK	1
2567	2vb8Pxa9FKURaQeUNV1TB7S6UZ5FWYxEV6FhRQoN6YsTB7CRRtWF	1
2570	2vaq9AtKcU3mMahcd7oAijpxMkzxAbRkXCMyzYp2rtgzSgziMpWe	1
2573	2varjb7ffXhFZn3qdEt8Zz11VJnogMBc7c3wWLmb6sLtjH7LTMCn	1
2575	2vb6cYsGBNF8sGq8BAxieRbKhRpkNcGpJN4CgdGkth7CXkghhD2t	1
2576	2vbmpPsdgx426HzpQdanoQ5eCjnVreaaNgLrxhB72Wa2Ww7kQdTY	1
2579	2vbSdUWdrpNLoTCB8RAW4ZkLDDMfSY1wEcsYDmwEARjeJXfeshUj	1
2582	2vbDNn5ownWzrCBv5bvK3B6J17ZWPBuM95TPdYnicUzzQrNFf9tC	1
2585	2vbfoSJxwCmBtz3vX8LidjbhuFj3HvrT4sdVaKsc4cBogsVj98LK	1
2588	2vb9rnfZZ2WcbiC1uetBA7eoUBK1pWwXVLC2ovHcPbdLHEQAgjwM	1
2590	2vbH2wNTTfUUV5LJpZjwWYtGM44Whz8HTeCHS7f1rR37gAU5AHtq	1
2591	2vaxoi9quGZH7PAvucB3imwcRoBrfez477CRYjWtTXcd4R6Eo98m	1
2594	2vbWdJPyFDXvBuSoT7kmPkEZfFforKDkdS3kiqcmaXVr7ChWw7ok	1
2597	2vafLjqu5HcpA9PswU1z229Dt9jWrbA9Zko1eNSmPib235BDJsmi	1
2600	2vbcDPGpusuRYWykEbcrjdV841qtcLYXFuyH8NAqSb3DsPVNscD8	1
2603	2vc2LChGoTsFJhdKL7cbCNCN3trUxhVxCQBWv1wpv6bpWHGFL2UF	1
2605	2vaEZDgg7sVPcLdmNB98mLNsRCVFqdCaRYtfbnCUbGNZGSdvFgzC	1
2607	2vb5BQpvfsubacVHLhmBQuhCKkUZW7tGRojWMi6VuKhj6jFT1Fvp	1
2610	2vbRpF5ZG748NheGtXdeWvRDrnuS5Teic3KCV4UyYHW5QqQyRvvN	1
2612	2vbRYuFzW3zwNpttsnt22dSTWR2aXh43D67XbXK4ooasQDk2nPjU	1
2613	2vakNJuqsm5kLSA97wXiuRgZSQBwqoV6xQQNr65kNxyV8iJhtbjF	1
2614	2vaK5173brSzyyhu8X7aTc9mLF8jpFbQB58wvMrfaQFFGwYjTnnD	1
2615	2vaKP6P9chVtZ4a2PCaSuhUDUxRFGTDk1659nUnpVZ5cBVNjhkEX	1
2616	2vbtrJTza4FVPhsAYdhwFfSfiEd4cphsFY2ndSbA2wzhik86m3zy	1
2617	2vbXnHQNf3LUMQvo7XXL1CA5ABg9EcoYSfPMejhiAZ2UdeVDVQar	1
2618	2vayCbHot7vq634gZDCz9VK1mGyP4kgBiXZmrFhwp9Gtuds4MGNi	1
2619	2vaXodS1S6knirxARSAx6CrWh2EegkF8Ejvknt8zA7N3GpwQRShQ	1
2620	2vbzvE2tAGK7tj4bjCXWL9JWPPWSF3rhHJZYTa5ERNAE8BCvpNze	1
2621	2vaRDWGL3QbPSPMLBuTnV2TUeKVe7PTRAwfdZAnLqzhsqJcZPgEe	1
2622	2vaKXoeCECTRnuo2ErGmYybYooxnrk5xA5qZTVK1zpxpSPsRtaRf	1
2623	2vbv7emq7SQZBAjcWTjPp3L2sLRFBBHwEmPnhqitvHdRYstnKjNd	1
2624	2vb55oLoqj4qFTX2Wdkr7FG4qugX3PLfrqCufyaaxg3uUBGhw9Fp	1
2625	2vbuqHRc7V2W5GaiotkEQuPSRScScthtUEZt8yN8mud38seNeosH	1
2626	2vbNAJ64dpzQfP1HSP6LQ9RJxHoMJSJMiD8k4G42j49bHCCBMq5x	1
2627	2vahzqwGiAsUkL7HVaJdNFCdcnbWFvzsimFTGLwfghuwM7GHcVYP	1
2628	2vaCQVimaZhsAPM7PygzDzYutCYAJSMMCmdFok268Q4AQMKCyUWz	1
2629	2vbDcxAydXjukpwNsa31gFx7bDy3KVsc62RjzuCBCtexsmtJRKRk	1
2630	2vbWXga6cxrzk5oJdH6h4UHpxioE2xSAHu91oFE7Sc3NqkbWa7jP	1
2631	2va9ozHFP2CwSBWEW5xHtttonUEx76rg19us2v5YhNmQRQdGB8s5	1
2632	2vbvq7yb6yXxa41KYyJewH45jeoS1Q6fZrC3S6knuT6HmuXb97Se	1
2633	2vb1HWKAZ9qozDN6ido5nCwgsoTvdLydEupQDU9iZUUGmtrsimE1	1
2634	2vbKHLBVAUgUy9m4t4rmFsDLUBtTMch33PV2XkcDKvTF3DGmU5g3	1
2635	2vamRzUBQWuNVGsy4L7NZ2FRepRt1d575CtTkQ9B5nnJHFasPJAf	1
2636	2vaDYHY2uZbSUTXmvXBJ9ns5zurEN5a5BuE9dzoazwsg9LrEiDDT	1
2637	2vaoHu4CFsB7Ww2cXJU6FgUUhztwrGY8C7AuMJgzQGPbKAPvCvBZ	1
2638	2vacWbKMmFA3qWqmE7vkRpEXXME1TpWnnXwA94wxjNGrYPm7mHvY	1
2639	2vaiSrb9RiyEEQQkm2Nr2AGH3gKtsDoBc7VuEggomZjLHn2oRXZs	1
2640	2vauUKeSqsG14hsqpLRByRM5rtnrWGs3YGusShPawBYvG6Qvi1aU	1
2641	2vbFD9NJZyHm1DatEmMurFfesK3zeqegfK28yaGg7mJZK3izxwVU	1
2642	2vaJ7i1jYkwWjmcnD48ixKhV6SZcngL1cpbozxfTZnLV3uRFx2ia	1
2643	2vaczvazdgUha147HA6NTubeii913ZYaR8JrrToJTdThefztPo9T	1
2644	2vbNTkw6NYMLAyPrikDzPaHAp1VoXemQpzgY7n5GxmhdV6Je6QiQ	1
2645	2vajKhhwdNSFWvu4qJpLQBmSY2JocdJ8AyDw3396UaEgxko7tsUS	1
2646	2vatvoZLgVEMw8Kx78rfLsyqtnsvHxP1kWPJkHxH2FQBidDfdPXV	1
2647	2vbnHzthntW1GQFvE2Thn4YmTg6PHktuMtmJfM5Prmhw1M2sGAhb	1
2648	2vaXVmpnmBLGqkz7c7XxowrPmpoZfcCeEn4kFxhg4YYXUSZXBAPw	1
2649	2vbsY3UZ9YKfhEuXYwt2iWMSsSgFr1Dcvt5dZkoLNVpK9T37gCDY	1
2650	2vapxedLQM3z6S7CmyB8j5JDgPa2qQz1LSpy1BbZzA3WLDcrmMf6	1
2651	2vbmQ7fv3ty2e9AneTrJJY7yASu3rm9AfRQXvHEAgwHiMGxEwdaD	1
2652	2vaUhv8cG5XRUHR9awZwy5v6AhrYf7nURBfco5w6JN1AGwGmczRZ	1
2653	2vbEjxCbTCmHSG5bacch4Xrc677rWWNvzw3Mh4gkYZkyGd4uUiLC	1
2654	2vaF3LD9dQRLMuvVWSjbRM1udgNSAfEFNZTzBa2i4dSUrP7CrynQ	1
2655	2vawEqiBvzeTL1DbxiMKu6nuzLq6tQSj1ABww8c2u4pfVEeTjtkb	1
2656	2vbc2qVGwuWz8rJmBNaQLsSXPSTnwGCLYFNUscey9tSoBkWQrRWd	1
2657	2vbyXKZNFYr7ChXqWWzMhfHUineBTtiZXuCGj4x5EMxYJxU6ZsjH	1
2658	2vboa6ByFsWrYFwhFdTpReCYTGSf7a6sibxydseAXcsSzZPd3muG	1
2659	2vb2LPrjXutQjhvLe4CGxyDMyqTV2PjcdQ2bZH4vpMTk7fYSUfoF	1
2660	2vbXVojE2KwVkJ295FhobSQQ33X8Y4XAYULJQDH6C5Jh9mq7cFZL	1
2661	2vb1A8nMTMX7WfPPD6vo9qoSjujK4qgA3iaLQEwzeMJ9rCafWCRP	1
2662	2vb9v6b9WXaa8W4EncJ6uMrUcC6m39VpTqUNoAqXftoC95TPSzQp	1
2663	2vadifjTpw9ufU5ozYh1TR2xaygD6FQRbFprGqquxXCNKbUx4Reu	1
2664	2vbQo2eSjs3NYyRhYi1ruDpJ8byEXwXFsKwHk57ehbJ4sPaS6nWv	1
2665	2vavvdEqXmXwPxhc7ZJ9V3yYPtuPDCyxCFoFvoUtWuFJJJxmuN3W	1
2666	2vbJ49wvaGGTBWHnH7q11h4JLvTz6rv8YrHP5pyUqYaZwbZ2pi9A	1
2667	2vaFfK3WiBSNgkQXJvYrdf3SjpppeWfjKTvgpkYPUDquMLD9Wp4p	1
2668	2vbECfzHguv6wR8heX8jrZbtcbVXTA8Nf7wrTXggRDiytub5qNfC	1
2669	2vc4YTxKdb4FTRpuNQvgLQrrSKAUQRAtKJjXhvfBFGKNdMxW64hr	1
2670	2vbBjrrkcFAhxDcFYBC9xZr11kaEJ5YF9jrrnPrZRVwYmtzYw7iT	1
2671	2vamxSV4vNBbSn7RrjVZzhBpomLuACaXdEd1LwEfMK6R5uafN7hH	1
2672	2vc4RD4Hkxo1cvjCBgqZKNSEYzR2SbVg8iHAGuupJrS5TiBp74qC	1
2673	2vaTPDGt2bmMBwY5QaRz4aWu6iPdmF64LyTMcPkDy2oumDH8vsGW	1
2674	2vbxNAXKD6taicD57FVEx9sxPy4Z2pBqtfXroHr5TsB3pTYiw1vE	1
2675	2vaL29gKp4cquym9zkDX2VAjQWZ4BA69HVBf6YgnxvrAngbee4t3	1
2676	2vbExrMqz5D9hHtqfnEbCVHzFw3wGkFK2FNMam38ZkVQvsDijamA	1
2677	2vaxWAS2dDsyfV2tBAqn7xYNvoJiKgeq1HrRJx3egcBXt72vAtd8	1
2678	2vbzAjdPkfqEUTB7wzD3dK12ZbXrZ55g1wEwT7bn9A8zjFXk2Qig	1
2679	2vbbHaTNe3iGtZ8s7vEfZC2LhxYgp2DBG1hLpVTahEGu1u9wWj6A	1
2680	2vbirLPRxnWWjQaNTghsvdf6J2aTdbQ6N6EvPtN8D6EgZHmd31Ds	1
2681	2vamos6NGnZrvABPXkxgCGKNvg7dkbnBAt1STEhDrkZ3pW64umMF	1
2682	2vaxKNvDw7j1PXMUP93xKt2JBmXmWxJGbvcXaKhtbyyc7ziaY7qh	1
2683	2vbPa4Kd8BaFhwD8SL9mSV1raLb8t397khjMW9ith4BgA8f87jhJ	1
2684	2vbCAn8UusSdWLLvpewdFtpv1LA1ju9S8F4eqTtnfr7wQviXC1Q7	1
2693	2vaTcmBcLiED96vyQDubghoN2E3wxz8WoQyh6aotpxjqm3fNMSkz	1
2697	2vbUs4bQWWQd2LBay8DG1Ns4WRAjCEUmRiVK1Q2vucDnaKBKwD9G	1
2699	2vbiX94yvwMtkRHCBGNKQiogVQDZgzgdU5m98sx2eZqE8Yb7fUoo	1
2702	2vaiVWL1zcxAq6phV6t6iUjP6mDMj8DyAZe4Etr68tSXpmHLf8Pk	1
2704	2vaMkVUdsQKPrccDNEa6nYBFBa2JUX9kdqSpxSATxoioaGiLgdgQ	1
2707	2vaXmuUWu82YUrtJZsnUAVvvqz6mjkncwb2P1k5J3zznR8UmJV8a	1
2713	2vbdR1BecxXxx7pSM3eJcgirBSmpZA9qDYEMMUkyFMnEEMU7cRxy	1
2716	2vaRRAWRS2bKWLirzE3fTLtPetaQkAySXeycyLcUDPB2hPd2s9k7	1
2719	2vaLpmhowzH8mDc3DyBDS9FhwWXByK4QGcUNphrAzHVxYuK48YNd	1
2721	2vc4bHWWbvkcKEBexpJdg2vbVYwfzNrBCv1p1Qx6DgZmfdATxD99	1
2722	2vbtXGt4ew1K8X8FQU86LpEnuj7KxJpDuEPAVPiysYr7bAB6TLk7	1
2725	2vaubbkMGD1Efsyxb9Y5gKdY5neArjmAocKHYXTmh42TNzS3nob5	1
2728	2varxkRpW6Hws9y38CJC7hpY7MgWY6u7vCEKnDbTNEsXABCMGnWr	1
2731	2vaaLz2bcEFpEkyidkKBWRG3Jhbn4EoQdPo3dv7kHDsA8EQT4S58	1
2734	2vaMpFaD3aJM39wG4eY435QGp4TSsiw3sHvSWm2tndVLw73cnwd3	1
2737	2vaTBUf1F9KKdgxeKecs72EL3JZ2jxt26RXtBq7Lc8vAZvFd8MiX	1
2740	2vaEZHqnWvYdvmUPix2ThGFhwJ6uXqjj2EFsL7FEqCDkQsbcyVdi	1
2743	2vaU75whsV7X9ranNqfsKX8o55tkb5va8Rpf9kmZk2xUa87m7aLP	1
2746	2vaNVpL4sVvmeSVBpdPXmwXApZk9FMisy5t8CCrPe3MDn4KscKdm	1
2749	2vb7u8oXQTVHvorMshudovRCEQcfyn16EGEkro7HV9CUjFLVfpWD	1
2752	2vbJRqtf1dVZuzUiR5GyFonaV6XRueK2nHzQj8qYsxSg55mz7atk	1
2757	2vaXxBfiYrN2vwEXhxXGBpziEYVt1w6b9wZ73kTsm9xndpcCudhB	1
2760	2vb22rxSg77bEnQSMwscvqueKZA6SeG3pJb3x4aP94V9k5mbEvFN	1
2763	2vbh5Kk36Nm79xfvsjUagf5tpUACxxnQJwm34FHXTYAiwerV9TxZ	1
2766	2vaMrZ13LskZyfmCizmwvu3AExmSGKTKNfxFmaRoLfC19dmvLuqJ	1
2772	2vbuu5Q1B8ZKvHy51JMSDd3pkqtybfVLkyc3EKkmqHxk1NQdwkDH	1
2775	2vbLHTYy7k1mhUQhtECHSpuvwpDJZLdj5y6DjXcxX6YP81oL3p65	1
2778	2vad1q4FrxKVDtcy6sjuWVsrVoGMk8EwrdYYCKKMiQSXhD1DtY9V	1
2781	2vbtHSVQPsqSZbdpGNxVt3AK38AofebppjvBhcJVN9qDYZvWVpda	1
2784	2vaE7UPFYuv4AjiLn66UXGcVMKcvRvFkdEHUndWCjiXw9rU2zLca	1
2787	2vbZH2nDcJe8GVoAkiKdQEdx9n4886D4Pme1g1TbgDwRW7x5wF9P	1
2790	2vbKWKefd5U9EbXmmZqqM2a9NTwLcuSKHEyWimo2p3BxAcb1oNG7	1
2796	2vaN7HgTwYYF4kibMee4WcShLJVhXsoXJrD8iF4PUWJVeQBFVSs2	1
2799	2vbrokatszumZfeLxmTwwiDrbHtsL6ZMo3mVoGEy4xJFP8i48JRP	1
2802	2vb2mXAGxqNXjPAxkPhn7hzeSJiTqmmo7RKMqH9uTC3Ee6XWznND	1
2805	2vbMGrtQTasjWRjKGZZkYWoTqT8oz5DrwpNESyzyuVopfoWP9hKm	1
2808	2vaZRwhzKB9PN3rwpukxeYcKM25gR9x3NhJvjxMx2v2HRetq3oNj	1
2811	2vbruWecCHyq5ckPPuxX19Cjxy1rARW5a4APp2BdeRdkS9NDSYhf	1
2813	2vc2H98Np3mitXKkVSVoZw9BAKhRpSCNAboMg19rFcSmVhNMaaAC	1
2817	2vbsUY5oL267nb7ZAW6XNzjBYsCAGiRWVjw3qjrGwAeFnDwduNev	1
2823	2vbGugBYNxA8xvRSv63f9hYMJP58jqnroFuUMxPwaKXYDDzmjmGD	1
2826	2vbgVB4ydemzvCYCcGACckD7nWP9LhnCWVzr79LPPJxjDjshRLrJ	1
2829	2vbbCCQxfD3DUrvBE9frNTJe72iYcnXQqPaAzvbNRYvGvizWs9vZ	1
2832	2vb9i55McYJ4UAq7Cy2YCryiq6tq5z4987yDQVgknLEFjKjxTVEs	1
2834	2vanP7oa2rtqdw9xgHyZkv2KN5X7eFC4RFwwTNbL7BeNGv9nVrp7	1
2836	2vbC9SoBfRAzpL1Ph2hbtTMNbD5QQ2XVwyeAeayz2f66oBjrARSP	1
2838	2vaVcpdUh2dQzEmzWY7xYTRksVNP7M49Ez4aUEtUq6thPpGdaPTw	1
2839	2vaqh79AsHznfBxHZntuJVxsSxYsQ2NAoJreRmgRAZyiv89d5E4f	1
2840	2vbm5kF5cP2hrMT3fti9VNeN7cfgHMHwcsjxRs2iEYXtHVUqYYpq	1
2844	2vabVh413BS6vC5xs4fsKvh8TrR72guG7SUbjrGEzEGV6wRjRwpA	1
2845	2vadZHShJRdrtrMNFWVLLkivxbzhbmPbK5YhQyLKXjwjyZB69bmF	1
2846	2vb2BdokDT538YaKef6NNr7CJCUxmEu9qd381cUeNB8Phyo7mGte	1
2849	2vaMGvsFoumKABCPR6cMG9VViYkmVmhYvb5AzqGT7hXCZyG3yY1g	1
2854	2vbdPReekMSRiPYvTXSYQsgt84ciRUxLMptq3iNrSRYQ3NURC594	1
2857	2vaxMtfYYkJXBngJrNAUvGksj5bdkmVGJeAra3dPaQ6yXjaXSdHh	1
2860	2vbAip9Fwenp3LH4M7NYQdgmfiNcfsQdGcYu78qK9zWWjR7aDYmf	1
2863	2vbneD4Ei3r7gwju7DDbBf1JpVLdM8RRf7rr2n2HQHcxwA2BeecA	1
2864	2vbKUzSYmabg8qof518rb3py72WE4Aom8boc7KVoEZGkYCeH71oL	1
2866	2vbMwZ3x6z7zVtjLG9pZ6WiH1z3Thqm7xaiKQ5gC1xA1f9Ahud36	1
2871	2van1iUuvMtFWbAgJhmvfriT7JinR3Q71J8kqPMSNiiiuHHP1uAQ	1
2873	2vbhS62XzDTvbCYJsP755dskPSAi35HY6LptCLDVtsYMR5eEt11i	1
2876	2vbUJzaDzsmhZ5GvkytGqqr8QhT8Su7BsvkFM15q1UTMVo4QbJ4y	1
2883	2vbRVgQcXV87CkGykwRc1yaHS1ahypGrCwn7kzwHoDcbM5F7kPpr	1
2885	2vbu6ndkHFP8jxgpzXviSMLEpL2nznTmcS77xNugVcADk5o16hXC	1
2887	2vaaHQ6f7VNh3KgKzuLjugbgqw5qn37crA4aruZEP6dvHCKADqoK	1
2890	2vaV2YwyQFQFnpK7BcY3Eq6Rs1n1ecshXEhfKYqFYfZEp9Fo7GhK	1
2893	2vbYGwDnxKBd8xmZuezk7wTv1rUeqT7sVd2nz4FvK32znWibQPdg	1
2896	2vbDGLhodziVYMQFkke5TzDKyjREnAwvgVh8yFaAN4awhb2WCski	1
2899	2vaSQFM927aMU4KfjUMEJ1kXY6ipnVLY9ZNKA9rQ29ZsAE6FFMjV	1
2903	2vc4n9bsENfEyw6kqdFu3UU7Mr8smY3686vd7o4vYhT2fACtw4Li	1
2906	2vbTGPDwFqMZKdK34wjaKM3b9BFS2LkgsiAAfjwPfmiKzYtgWUTN	1
2909	2vaxa2GgxtWLyVLYreNUd6YznuSnt4uP48A7fcxxRanRzoF7pqea	1
2912	2vbBF3ckh6UdL2SgyNfmEizWzT1iJR4vK5E1spVXFn67jPW9ZKep	1
2915	2vaQpAcKUXXY8m5ZqpwDFEqcCx62YTZZnat6SrTCEXuyLeU8RPyD	1
2918	2vbcQvLVvthoGFH6kJrsFHy1xKPVgfoNSwaDTzR9JxRkQHib4hE6	1
2921	2vbiiGTCMr7mfpgammQ2MjrkzrmKzngHCjegRhVLmF16sXrej5NK	1
2685	2vbuECXG9LzZ9AenKVPf16Dab2c2b5TgpJKdidZk9Z2egxvzUYFq	1
2687	2vaeStCL16WQomiXBuVnWXF2oxVWSEpDwj2HsLtxEfkFmstDpwJP	1
2691	2vb4H3PhMeSBRF29KXscRqvUjD515K6C3Nv23Ek4Ut5RSDK8ssJB	1
2694	2vbRqeY5opmhd1qN1hnKoJ72DKTLLBrQ5kQyud5kTn7s1gwwK3h1	1
2695	2vbBDCetRERLHs94zupwZqfBS9q8pRgx2gTUrmg66f2MGX8BVZfm	1
2698	2vaLL8WA1AbzvLcN6sPCRtrGcUkt5MgDWhTpx6JjhXGy5gsYfMzj	1
2700	2vaZXqfXFjL3PALZrVbuxQ7SoapXs8mFBU6gyitRBNUu3uUJuNqn	1
2705	2vaczksjN9PpoBs9YaYjM9ZFWPjqB2cqrs3D5VxUC7FVMYgygDPb	1
2708	2vc3g8PDf1tEkYYGt8uvqRdZJHpKpNBuzVsJhp2rnFTMwTtxKgDn	1
2710	2vaTTgD9vCabMMHXEuor7zRP8GFpbJ4eY137Y2EEBaiESCJRxToG	1
2714	2vbRNnTcPK48z7J2Jrki6AK43pXi6vYyHj7htgiaAFfeCZaHgFDU	1
2717	2vbL3743AJU2StC1JnRML5inDExEhtzj5XTHyta8AGGsDihErEmf	1
2720	2vbYKKomRnEMmar8jENH8HdJod6FeuLGCtsXFWtb5RomemAvSvC4	1
2723	2vbcayysWgcBb2LHhs8Rxj1kL5ow9Th6mRu7CFAfLQK9Efvzomce	1
2726	2vbQSVUYcrdELGox5aEEFM2ZigXM9znhMnknuJzBMd8QNF6DKyn2	1
2729	2vbFaxdK33Ra9BJNFWdq1ZLdxDpVAAaHVoT2VQVLSWimaFBU2mG9	1
2732	2vbcGga9b9GdSjc3UW7Y4ZQDcgvzJkFEthzLnnpdewcG5NdcHv4e	1
2741	2vaWSMxU8EFEkLJRtQY8AbXe8cXGJGhBXpJmqHYuZmTipz3rH1ZE	1
2744	2vaY8wH4ZgabS77PDKxiPAoSS6uWNehDQxp3vqvrPDXuLipx88Kt	1
2747	2vbxzmqjLSUjfDrZkgHoSCQG1f8zJSQHraA3XNgdm6HmYjhBA8Je	1
2750	2vbRtqCU7NH6qCFPRqQLxdycpkPntxoRgW9iTwHZWuUvnqHjutcn	1
2753	2vc4acBWBcSAnnnbg88Tox7gJo8vViSkcFARTUXHAXdupfH2fFJ9	1
2755	2vbKweXwvLEDJPc9oznvw6bgRKoAC75NUybbsrWbJoWvy4rEf7Ax	1
2758	2vbVoD1LwgN1by1paFbDvRCNb2vpu17dtrT6AuE74B39YQApc7S7	1
2761	2vbYeg4eNTBkStaZsB4tbEeJ2uKUYtGEbeu6aLyS5caLidbesbD1	1
2764	2vbanewf832sRDVK83w5hYBpNMX4E9Rxt4e6E8Cj8AeWuMePf39B	1
2769	2vaHNgoAygARJViAdF4zXRBkPXqB7fqNXiK84ohBMCKfR5jFGEzf	1
2770	2vamYxfLfVnNymgCwpsQd1ty8YRMuZMQJzqABFNko57ZXQHKiM7w	1
2773	2vbxg7x7edFMUaykGsQLEfpm6CKgWRobCVddDEm8sSVYX2ULLCes	1
2776	2vbUStWAQsN4KezeRuCWd4uP8S7VXhcvaALbF9XrVSxvDNCbjetN	1
2779	2vbWgz5ohCbyRrXX8AaDcAprTEMhDmxvGr4zzxVeMgwRyFB9KxoS	1
2782	2vbD1XZLYpyhDGNWgjaPqD8JVTWZrm3g4zTypvv68AVqZXsa5TJ7	1
2785	2vbaCs9aQxB27skucKhij3wtjjadVMNYeJNnbxBvL6EWtpQKxZ2R	1
2788	2vaDxVHofo14KueyWyRdEvREaC1VdjCmgFwxSQvSCwxUguVAuUPy	1
2792	2vbFDjHhf1skwSzgr2SaoAq79KYoqNGYakcd3Rz4t6N1BaF2kwjY	1
2793	2vaMv6Tum9hFTqEtbDGVkxYqYkX9GudsJd1rB7kVL4X3MtBJDxdU	1
2797	2vaiZKnEejBeHMvcwEE5u8WQyxw2CFgjtx6pTTxZq2jdqzBbmKCR	1
2800	2vatfwuWSfa3RZRnVhuZRBg5QjaL6pntGK64UMnW3w9fHE5K4tmp	1
2803	2vbfwfybTUA7MTyLxKmwmg7QGme6g36TRvBSd8QMEbkjvpExTHz1	1
2806	2vbQGEX4qkUZ3Hedfy42dMVFJdFujbr2XNt2oMcgz74KKDJhMUNi	1
2809	2vbryyDqQHET3XNSfpRZG6nNV64C2R6YSz9RvW7i1y9ZYKQtTZfJ	1
2818	2vajswFZYTukB7Pbc7zbQApnQNUQfsWd9DihNGVKG4Gr8GH6nqem	1
2820	2vaFAALWnbqRyfq94BfYagXyFrUZWKULPtwZmTmGqqBF3xge8kZu	1
2822	2vaPaP8LrqLJr4wob6rAHuW1cjXusLpkZZJhaze5VxU5MKSiu7RS	1
2824	2vaAN9H1GiSvRqFvbxBWvWPh1NuByfgFTL43CiUpoQW1W8CUrC2A	1
2827	2vaqdF85gFF12ebi5dPAc6xfjQSnecSNTWkS1Nu7C9oeFSXmc29G	1
2830	2vbgXJ71nwWNb7rWh4eM1VvBu1Pz28QvnSLrvyEYfQYNK7WY1L8x	1
2833	2vbQXvTYNvp3AHqRwncYTK8RSwEPpJG8k1PAiaxqnH1LAj5YmrfV	1
2843	2vbBFnxKcLusT5hYCgviPTuLMgdRMbfo6BmtaHz3SsSAPVwL1mXx	1
2847	2vaVvX7kKhV4Zscd6kr7X3LpvMcbD6EmizJSBCQhwyGHhnn5xNaD	1
2848	2vagJrLLgbyJ3qbbLkdXHVCnCWz3Mv5w7JpjrhwtMqdw5f5DXfQC	1
2852	2vc314ixY36yFNxY1asKYb85y69stgjxi4znVeSs8Fc14xCe6fNj	1
2853	2vbhQ7xEDVp61UkHausobH6FVW5giqTFC2qiuh1uWvWWvSLvX5uS	1
2856	2vbosmyzLwfYA29Z1RHMef5ARnSaELZsFgUByMALjCZyiGR1Q4ud	1
2859	2vbB7ygqkVfhVPixCcYujHMujirXTTm8nx7AypfgRc7qGgQgETaF	1
2861	2vaWqc463DpGPmFxHY6S1qWYEdpkUfaCaEtwpVWG6drWACBUj5CF	1
2862	2vbQ4Eq4sPdqFBXLtn9GCo93dTj2TvuDxG9dBTMMH1wP7vzf1drs	1
2865	2vboYdEKiZCJSNBPhQ9VTMVjfKVZdC6ua7EaiynscrNJ7yR2Z6zi	1
2867	2vapRRn4Qn3qzMzivJGTCupKivA5dbzC39wW7ZpZ1arwyuMqVaDK	1
2869	2vbY9HCyZXNWoWuGADUm1Vz1zWXSWKdmCm6SYBpD68Ffv8dq8mLp	1
2870	2vaATwTPZdw3g79xKDF9RaDCWPCV8vBneBGec6GCZa2BRN3fgGfk	1
2872	2vc2EQBvnrUdNxgcNd1sWeHf5fMdvq5N42Y5gBmLicaj6jqBPpAD	1
2874	2vbEZ4C4V31P7NqVwEbH4o2Q363DoEBKCFha3RPqEYgY7wyNsmtN	1
2875	2vbQhw2etxNCjdzumTHQP2xfAAr1HA5AjujLemRrzksSWw2CYgUy	1
2877	2vbKUhWxvwWbrUSMW5ecYrKjDSFHryBNQBWoTSRV7z2uthJgeKTu	1
2879	2vbit5fTkA1FPaNmvbpE9HQApxZ7VtrEPyEt2jzaXAfR5JMFXgyg	1
2880	2vbW5BXBzdKs2urMDHr3DTxU7VQffnyNs7Xv423C3RSxuyTiqkWi	1
2882	2vaQb2L3aFhJvBiG5ckGozti6k2FUtBP3AedXDNBU5s5D23LmrWb	1
2884	2vbyQjXkKoJrzqAvxwL1DcqcF3x6No6UhiJWuzprq2SakXjduvoD	1
2888	2vahc3oECe73Jc7QPXUeuu6pDdyzg9vszTtCjMGc1mdypwmY5bGu	1
2891	2vaCX95AwKfrk4LHAT1SwNPJwvRhQowNguN8AcKgEiWbhqgaqj9C	1
2894	2vbrH7mxzzeZJqcJwKi8RqGhHxGTKpDSaVMwXURdCMjSguy5XSE8	1
2897	2va9XWgTkbzkqqzw2RHhBSjKvLwUkU9LL2pHeu2EsExbcUKuk9fE	1
2900	2vbgfxrzkxx1tq5cvm91uEJKtzHu3gKqYcCtSEAz6CB89Y1XCkSS	1
2907	2vaQrVGmTn7JWRwqNvM9Gigv2cDvWdgSwGNQnTbfXyzkLcJJytmg	1
2910	2vaxtXmiEPBFgvAxMxvyMZJShRTUGVU2mkfvkRHoPMrzSTxrE7qK	1
2913	2vbASoH2jXJYusNDhYfy2sCbuFprg7nVquKsXo7CqUpmVC8pZr9L	1
2916	2varh5QjKJU5SWLLryAjAY9Ug24rearmSL3Qf2oqmVsS5EEPWpNu	1
2919	2vbSwpkYt66vT5SFhhLejy6baiQWFi2kRbRMBS2B2EQrPPzWfAav	1
2922	2vbfzWtuzbNtLXj4b2HQwa67oahU2Kmfu1fq7Wis35noZ45GP5ME	1
2686	2vbxFWhLcnZWSjCT8ESd7zVLS1gdLUY55yVYPWDGLggadYc2G7c3	1
2688	2vaV6PDG79x8daUDP7LUPLyik7WRiqkuLvsNfSh9QbsfVvBoK7io	1
2689	2vaqnmzCaknCVEJAYGbJWX3k8gJtiEYvv59bPQxYpKH5no982bSw	1
2690	2vc3Z19Sgojfbpmmk6kMCeM53mxhCsXuzLJDd9gSB42VWgyGyAaB	1
2692	2vajss245HrQmaFxPe97P2FzSZHtDSXoZNHWFhnbTNkfV9yKZZVM	1
2696	2vaa92gfNfWjLEaqMEjTqoArfNjdt7rfxKBrGeXdVULyNRS5VSac	1
2701	2vb5BFGTcGuuQsUfMYt2FWBLcVirXV2qa6mQ3puYMBXZ8iSrhiUA	1
2703	2vbnLWvA3rRhrDc9SdggtqokiSeozrkEaTQjLah4mEzKvDxEbuQW	1
2706	2vbSQQUZxJqjQ3AWgiFeY2TmByLbQfwtUx8b4PeKNPSom3954tam	1
2709	2vbh3uHF261G1Lr1uriBVMFsmABjSaSrMDh6QC3JjB4jBSVkKYuN	1
2711	2vaf32qTMECbxMBGrhFGV14Y3NpWXbxqUCFF4BmJy9a9eMFbBXSf	1
2712	2vaMqEz34fQiZndv7aX7Qgax6muvbKrE5JsK9DP5ohoYNY382e1b	1
2715	2vaivG3dKApErnBpaw5bNAL6TzjtpQoun83wH1hJCJmoELdGLZ2k	1
2718	2vbfZ9XTRhHL6eQ9SXqZtvPeJNB7nNabAuuwsB9H22HNUYi7QiGm	1
2724	2vbvuS2o3zx5ndnVqrq5FuwyK3JRGj2potd5B7qGn1M2sRWtyo7x	1
2727	2vaa5HCxSmTTBqvjp9cYyhNozyz7HHM6yzcCo6B5rwFoVsKpizPv	1
2730	2vankcSMFAmRPLipD9GXEwRgWAoJ62ti6BbyMizGvHAEHiyTsJCR	1
2733	2vbRxTkkaPSbpWz6mVPiG5pAgJiAxmjXDrkh8g7FwfePcBLieTzn	1
2735	2vbPEF7ruVke9HehHNZfWMUey1oLkTy2xngAg1C9uVjMBYHrURQq	1
2736	2vbt7u2EbKDVBXj4Ce38XdBxYxQ1U61opvw9sHb3AkchefBg85ux	1
2738	2vbZmmPyCqXi4TQSnddyYDVwtYK98fzCfxzTbsvjr9s4d65RSzdZ	1
2739	2vabU34v1YvWGhmRQurPwKjiiYZdhKLPSKB4DCTAtyMrC1GQcKzt	1
2742	2vb3HpME9EPBdy61dDnBnjiKiC9N1sjPba6xQe5YCGLa1ACRQ3yC	1
2745	2vbAf8nLXcP4EyphyQeR2WQmvjqepqbarFKP7Em53uhiCP3vG3gZ	1
2748	2vb3Wrc3jbhJLZ8Lwn3tzQuHCPazPoWZeTbJzyayGHbKKkeLB9Cx	1
2751	2vavLPRrcNY9DK6LD8LhFWWCGqK2P63UxHkMHGksezvBV2CH6phg	1
2754	2vaWWUqhMAtrZj6V5YB1vNuQnCP7QXPJKs2RycGsByzzL4Amjhvb	1
2756	2vams7AE8CXzoH6BdaayNtkAAGVJQwSJ4cAWGmfvT5tDkvsg1fGF	1
2759	2vav9J5gWnvLaTwmZSSmTk3NmrWGsh2Xb5qhEPdSbrcXi5TyNMBV	1
2762	2vaft1awFhh9c8q6RwQTfbBEpJTozbNRcbiepEdjjtyStpcuGgCb	1
2765	2vb58NYnEaF8CDfPEq7ptaYxReUCbhAm9CPoHmb3NPEuRQn5PJEV	1
2767	2vbfhkqMFHYycoorzTUSh74ATGtNG3FmuBkHiHneafV2poTXHANF	1
2768	2vaf4BqFke4THSQ2Q7fNxeipcCKqKZYq4UiP9y3SjH6N5E6t3xVW	1
2771	2vbcDnCroi28Ty3fKjUhpfRMyjaL5yv2cs4o1J4WqRvh2UbPuFiM	1
2774	2vaXv58pWMva6U3aDewhLNNGNGijLHKtX9odFyjsUVh2pj1Nt4DV	1
2777	2vb5HXSknFdHaUE7bmniEerkcbbP3Df4UKZyZzkubTTxwtafs4dE	1
2780	2vajRs4PtvZbHYqonpbPAkWa1zkbG2S8SrPAWM5SEQVKyrLjyynx	1
2783	2vbN49qihmQodtLJZ4vjYtritJUV3Hr5mvYgdvrQnTvVLcAwEKxY	1
2786	2vbnFTVPTC7UudcNLvWHuHuXgdnaQSgj78i3xYBmZ2BFtMBXH7mQ	1
2789	2vbmi7yBYRFJ62GVwY6jX21EcLX1BLRCuB4BYsf3PWkVRVuPbs3r	1
2791	2vaJf8aRvszLnxDDFFqJ1bGowgAqzPewUy45MQ83vHQtP8MGSuvT	1
2794	2vb9pMaRCZxgYreCQsh91t3CLwU7v1TWt9UCiv9Zu6LLxPmFVBnH	1
2795	2vaeXLKiy2V3q5YEyfu2pWoDvtAQuTvrxAuV8BpteC5qDKVdJeuS	1
2798	2vaZ8EsTrtWrDopUQNrF5FwM3wNRmvvpDzvzTgTtHK89TQX8682N	1
2801	2vc4Le2Z5aso3n9CaZEFG8rM7RpVg1TSRgKsPQUeKtJzrNKArQyb	1
2804	2vaFHT2z2FrzmkyYsbo27ZFoaWRyAWAK5SStgKTf4hup9XM1odt4	1
2807	2vbsjhWfnUmNc2eunXHTRFx1e5RQ9jZhSKiK6zTwh7HMKpRmg36w	1
2810	2vc2c2qsw9oKLCPxWYLGr5LR6KqnK2J7xgNQvPMBWRRD4aac9wtX	1
2812	2vbWkVQaMSPzFvhiMDjP6QcCJhDQfhvZnShV3gH6bFReynQye6Lt	1
2814	2vbsbwGcnn6UWaNkFUHN6nN1Trr9RDVCoHKsgS9Ho1PooQJQ1oca	1
2815	2vbRuL34uF1TTJM2WiUBApTFpAfXXW4DyUv17HCTqAPd4ymhe4wS	1
2816	2vbTTioKfnidq53HkmmDWk1ZXzJtT9V18n43hTTbEo2ABeRVWBp9	1
2819	2vaTenabNicJsKpyoMa2zFGg6gjsdpVhbqbwHWhGUC6zN7ske5Dn	1
2821	2vbSrVudCVTg5xteiZLMJKaJMufufPtN2aSJC6YZ1CqLViBsRqHN	1
2825	2vaCukut9yPLVwji1PbReyZeGCz7uDX1U3AM3byagtvW1q4CjUvC	1
2828	2vbv9fbArGUvkp1CGeCLb63HoYVRWUF6xPSuRbNV6Gj8fVXxDeVt	1
2831	2vbqhcmqDKRXCW4RUXTrKNSUaSbpQoeRBpKq9Ktfq8wsRuZwmsbk	1
2835	2vboTewQMLSoB432Fx7xd5mg2rzN1qn6mduiJ2uWUYpjAxz9yAgu	1
2837	2vaNDy8UKP2gUqrAYQ4LAhypi3EvPoWFHQ9wnEKndZEWeCupVam7	1
2841	2vc42ZcQ7ATGm9SX1ip6moRWxnjcGzra6iBCeF4WtUFn2CEKp6p4	1
2842	2vap7VCxLbNbqTYM9fcxcp84pdveqXF7qPJ1j2jbrpToq3okHVyR	1
2850	2vbJ3GNX5Mkr18ceAUb4RfdwtFfYp43B7E3iCBwUp6Hx9sENbgXL	1
2851	2vb9co2XMPAp9kgqM9H8Qhc3CjLL4oimvEPkBaBeA83SpC1JJPT2	1
2855	2vasv2LFq3o6eyPAXdGAGd673sJYZkFpRVnxRnUcmyTo4tPEM5hV	1
2858	2vbyW3ZAMVoPzpoKbDs28sNFx8gTjU75DkjFPVmysicXt7h3tWfR	1
2868	2vboh3FFb7EdjNt6bwZb91c5bzzC2HPJZoBts4SLozA2f6nKr3QG	1
2878	2vbH2fzH4K2LBqQai3jZRgtBpDo83XcSbwBsTMstZKWMyxCQ9nnZ	1
2881	2vbafDMnQodtaCiycw6XLmeoXfxLWnWGB4DSvSxrfiGdHqBt6E27	1
2886	2vbnCFVTA88n5AWwgZqtjBjrsWWg56Nw2H8Gu9uWhqsMWyLcGyRf	1
2889	2vb8yPSzA787wSrjNanZqnG6FJVPpaXyVWCN7D3MZ778c85NJHsq	1
2892	2vbziHvNU48bwFkhMZeaF6DfUdUXB7CLAoxH4NaaZU2PM7pKFnyE	1
2895	2vamMUXtHfL4AMyooqDtRX6xw8ehuxVi3N4BXB8d5tzdaapvt3EN	1
2898	2vbkrECkUzCvrRC3cjBkoPqCDFVkCE57X27yYbkdTPA1gNE7NvYo	1
2901	2vbkRT8J7ZWJ86GFzZ3JponcDmQTz96bk3BuSTqaeyKAJC43xPxy	1
2902	2vbBjYFqcDyoRprQjUxd1cWF7tR8eETDG7jgbAN6XgnLkHHjmiH5	1
2904	2vaYvQwH7rdpyYuRpcPJxe5NKarvXdTx88pE1Up7Y6zgpbgP1Jiw	1
2905	2vbGGQ4WjpeTtPLJQ6u1UynRAsFZJfBtENtpTLSQqmVocJayeBnq	1
2908	2vbAhKietEZfGZvkxAGRt63u91g9FBiU3gXXHvKNiGLaqdmTqGy5	1
2911	2vaFAQ5YedBwwa6x4HGtYV2MpQZPZoUZf4Lvuz3WyCzabLikr8TG	1
2914	2vbWvF5yfyfY5KZvAGHwzRKkGL9p9vCEEZL7KxZoM3jLLvULPmXo	1
2917	2vbB3MnNJuqxvUdN1FRHuXLmFvHjewanxAoPjCiYAZNmUJCsT4Ay	1
2920	2vayex4B2AuRe1JgQvJFMkJdnhVjHjFshB93btyaif9b5EdNWFH4	1
2923	2vbEQd4oRvQhctzok2M6BrPAEozvHiAT8zv5Wacrxz6KhaJ5kPw4	1
2924	2vbWPayQ3Qb8u2ZkBUrsCpLPzpy59nZHdVpdM6K9ixycJCxS3x1s	1
2925	2vbG5e5RoWKCAqxuuCDF46tNDHiteVSdSWBeKXyTFqJQnWYGfLgN	1
2926	2vaAVf9A6R9kkMJvSYwmz2YT64Yb5GxPCRg5nWVvqGPqBu3zbYas	1
2927	2vbzbWnqYNeTRaTLKDeiG6s57vPubt1g2MwpSNRW9PSjy2RXWb5K	1
2928	2vbBXQxYrjuzb2xWMcXQTntHaaa1CdXnfao7XxTk1qdgiP1YXvtx	1
2929	2vaG2UGeVWo7QBk1cwbZEwmWzZc3fT66T49YD18Cidru8zJduQik	1
2931	2vb4mTP6yuoD4iabTZtbZqGps3QWntzXhih6YkZiUiSvnmz73RKQ	1
2934	2vb7qho234FXkzhVAVnoQg6g6W9AwZJB9iS4R9pGBMZRLfcu35ce	1
2937	2vbctN5kgKGopLdcfjMs4KZAZL9h2wAPvFFxdDDSsdwoqw1ULNC3	1
2943	2vbgLKQBbNNSUJU3pjnnFraYnyiM1YxNzCrYiymqCZbDFHB6bcsf	1
2946	2vbVN4ESvvE3wr63EZcJtt4vDXy9EYZhKcQrnGQPwv6H1HPQA7xh	1
2952	2vawkGYi1ytirJagUD8YkVZjNW3MQZwMRwq2oVJeg9MfsEF1UaTQ	1
2955	2vb9iTWNUGkeihoC6KLxLNg1tVE1DUhYF5xNKGmkDY3sTBFrSUTX	1
2957	2vb98yr6zxwgrQQqa2KrFMJqEk6ZSvKXRoHKsmNdHckLyT8LJXQB	1
2960	2vbC8moHgofi34UTXyvmws1JYWUz1kHkdRk5HaohFPbK9F9xztUd	1
2963	2vbvPNppxwUkGyDzSdDkmLyzc3wbiGabMQYd6mwCfvBkdZjAUUw9	1
2965	2vbqdJLYHM2uyjkXA6zUn4R5p1su9NmVu8LycbvwJUKcKvtqjKEv	1
2968	2vb3ew2p1BVEdAX4nzxQLtaQsfHDGffSEMs6x2debbs3ZUVWko6a	1
2971	2vaSxLCcoGmrHuxMPpqBiqbpR8eJ4dY5msS4GiTjhDZQSEQpkCq5	1
2974	2vbZ8iaT5pkbZ6R2TwxaVztAiQ9Bm6NPer8ttVoCz3oBESCwv5PV	1
2977	2vacfp4mxq28o5vkQA1RHH2SDYTPFyi7UbUJwFZTDta5gxRc159L	1
2980	2vb6puRScDa2SUVrgr6467zituehwK6FdoDFMJswqgQEWJqy1vSL	1
2983	2vbj5zXTHYRfvi5VLyiWw2Y7Y6eao4Zi9YFJAtHXSfAfxJ7mmRkK	1
2986	2vbwJwtDEPpk81tYSXBtcMSjXif1YTCC2mJ6XjrkcLpGwKVvy36Z	1
2989	2vbqEgBkKjsx3PDctCahTCWyVMZrFay2kQMzo3uYotRnH2zPe1UC	1
2992	2vaBcKxNnHW4oehZtPDr1U2fPVqzqUpYtkWucxLZTw3xiGXhjWdg	1
2995	2varaHpngbNK3Dqh3VzaFfQVQL2mKSFyB2bUPhWSEcdehn4PgEf3	1
3007	2vazFAxRRqmACBhj1o2PWzRY1XupG43qbt275GxZ5FMynWZhKYb7	1
3010	2vbMdDGiuwxvg3GN4eSbj8rxQspQ194cyBwUByZKvvfxfWakR2mZ	1
3013	2vbf3fV2oPv8o2bDD12VCgMicKYk9BrrMjLErKWbrNBnGgzM2hJK	1
3015	2vaSNeETRqVgRzoTovXXseXsWwNHe5Qm69N48kTezxgA6LEaA9bq	1
3018	2vbnN6tzy2TuPAUNxFX74LMjvnSXuNVqRFjWFFqfXrQrQwGA2tSc	1
3021	2vc1DStktC6CaMT8mroQYndYMW2VDk6CZZBkQPQHTSGTWUkm9pfG	1
3024	2vb4aY4sKgiA82TM5zfzibD3ekEYttqWwkzezeQ1Ukw48sdzEmX7	1
3027	2vbAgpZTVE2RujNJQL4iep3SHFafcFwWMbLXCGWdRtznMN7gT1sw	1
3030	2vas8TGKnUubQeh8LumvNuScW5Vkekvk9NHtATWBZvb6WYBARYMX	1
3036	2vbxbRYzxxP5GgGzYcsZWhcYkCWsZFacPsWoqDzVhMoHwHaBvhNd	1
3039	2vbPsBSaC6HG7Pr7mmU6PE4x26vXQqzrBfSRnqwwbYC54fcsp4SK	1
3042	2vaN7jh8tVeczUfQ92s9iJ8QVdtyTU1NpcMMRm54ZHf6k1wkCeyJ	1
3045	2vai9oCobaNWAnkQWdmKTAJvQz1NvHGuW9uLLSgBwyMT4MniBxQb	1
3046	2vbte2jeZ1Wv8nBKqYaKqRyoW12TNzCM3Ag42oieMRjkGS4kTUZe	1
3049	2vaJut8MBFTCK6STCX237kgD8NJEMctJbUXQepj9BhkESYbktmYK	1
3052	2vasEjpb3DbPoztQ3mBqtvaBMhZpvXbzy8uECzdwLLGveyP2mUzL	1
3055	2vbozfr7EQUK3YfdyTUvBEDowaWvfeStHCzfdiuopz1FVwGjS4rj	1
3064	2vawfpTihDA71oCmvLpYugMkdgQKQx7inib3Nt8d9eisg4JtuWcx	1
3067	2vbYFBj1VvCC9J3BoEoh4dPPS5UBxDhNg1gQAfFb7NSD65EiaBL2	1
3070	2vbxoSHjLZxoBPw4N8Lwxq8Pv34Ug5HbquDz1kruZyuM81ZyPynb	1
3073	2vbRQcTQXc41Q2CETXBt5F6FUuPzk9PJUJXZdDyxBmHUiZ9JCaa1	1
3076	2vbEJYyZFuZWminD5fdSyebvyshHKnwpQDRwzDXnvLK2k8jJtRWq	1
3078	2varwFjhb7nd8A2VUmfTnavZF3dZfgjkvJeGZGS68XYKKtRsUiUL	1
3085	2vacNDwCKY5G326zFroajeArqujXAg2RsGhfvD1vvvjdRiVNtAhR	1
3088	2varQtjaUwU5K4vdNo28YR2WB6SmXbKz815JpwS57GxWNKXZRhJw	1
3091	2vbhQMQq4TMV16taDKYkv3xGvtPWnwcTvPyVuNAjXkmvKyCXggJ6	1
3094	2vaeAgQbubHCy15cQ4wG2YQiQVq9szphtVKQyg9KMRN5vHiKnVtv	1
3097	2vanRAQs5MJWVMw6B2coaazGk2CXsURZkEAKkfHbAVz6pN8HXjvh	1
3100	2vbDLWABAV9jE1CxSGRYeVhzmD4vFm4gPwrajjR5D5cxpgoNCkoD	1
3102	2varKtsGYP2FudrxrxuhNcgBQ9LQoXKJU1AJ7hjwbQYqc2dckQRV	1
3110	2vbSPGvF3hWbE1UzmzSGyJDBmwVsxwuiSbm8g92nBgb9bJeEkP8h	1
3112	2vc3FZVDaHSnigNhejqKmZU2seS54dyjDjgxBs7H543fp4AU9Ri5	1
3116	2vbDnQGZtReRrhD8k99BCSet1PrdaPFhvq246XfKqiSZ4Z5LL5Mq	1
3118	2vbmtFLHScuDxhYMiAhxmbSAvEaJyafNLVvq1ANK1QhigcP9dEt4	1
3120	2vb2sdxuLWZNqhHqGoPQ25gm7EXWkdC6znUccUt6Dye7Jw7wZQXa	1
3123	2vaai8QiacYiq41ewMgvN9Ceb8ZLZ82sanxA9KKDnYCANWbPBSLi	1
3126	2vb4pcnbiVkQj9xCHNRhAzkcKS1YjSFpeJ8E8HxTmqRHQc3rkLkp	1
3129	2vbHXeBiCPscREZuRYMdp1ihAhEW5vkE9kQyxB4SubpZ6y9tKtPw	1
3131	2vbjHhv5nR1qJUBC14sAGQPrjjjPmZ9ZvWX1nAZ5taJf1GQrsfBh	1
3135	2vaTxFQMLHSGWjzzTzhwkXm8swsHRbeCHHNsZJPK1FR6qh2rypME	1
3136	2vb7ST4pvKvY8woPyCMdVyKcep55rBfUb4wY5JxYSKxVWh94pdEf	1
3137	2vajtqDTFaPdf6oYVFTTLNikNnqxVxKF6mFkRvBrfUtZNuN1qX9m	1
3139	2vahL7aVGMR2Mnctc3tfVtQRqSLCk1mhk4nG2w42ogT4UBHmPvMV	1
3141	2vam6eyce6nppLV4x5uWfuJC3E9QBKbf2cQmvcD3eyMLmjeQedtW	1
3148	2vaoNQifQJSZdBMBKfZFxtrrFE6SqBpq5qzeYWoCgydudB2iXRMZ	1
3155	2vb3n9vxcYu9ab1ZFSqXhLRuEVBKe4TBqnL3TeqLyrPRNMP9wrV7	1
3158	2vazXCYLm2vNhYodxHJJiafrPaX3bk9nWxzSrmCtVkphd41XGcZ3	1
3160	2vbwn7Y32ZoBiGnUrf6XdQSe3GTTUFEeYbXpoT6agXYX3cUbARaP	1
3161	2vbLx4cNfi8Yp6wcyUVuQcydoWA2TfuZqYxzPCRSi1k2owm99KAD	1
3162	2vbB3gHrhqbMyoQunjtfja2Yh5wHivxaV4E8j7tBLQfQgAW5YxUa	1
3164	2vaYxh3P4btn9zWqZGPwiavcHBpbbk7Un9gX8Mf15XbdCZHL4r5g	1
3166	2vbm9vk4QbrdxYNAdcM384Rty6aakdtDsFxAmQf5hsu6BHyjxFFR	1
3171	2vaFhq7c82Z34eUiEYHrAo9VsFZpMp8gWtMMSpV3YuGY3wnGVdth	1
3176	2vbtW3QdVeNS8iZ7zYmAjbdbWFFxRHzoTTR4Dk9cDmuAt9f6isCX	1
3179	2vbJkkQ38knk1i7PZv724FwuEH2CxpmkoPqSftxD8NqCQRj9ZRjV	1
3181	2vaCz7n6gjWhZxULr8dKdb2LPqwvyVLiisxcRUSReXk5xJzkTPA7	1
3186	2vauAv1cTR82MdEWDhNorhygtfLN8C2g2Ke7bFyjuzbfveNyRizY	1
3193	2vbPzXx7hahZSGWZT1z45EPHRtE7ru4YKeQeqABrdA5bdUHNcjhe	1
3201	2vbjvjp41DvoPWzJsovmGMUDCkkaaTFHAu6vZCpPB8kp6xCekgqj	1
3206	2vbuNicHn9VyKFRszoUx3dYbC8jBdJj9rv4tMoW6ybHHFvaebCQN	1
3209	2vaeNzAKNqK6jEcs9Xps1EgLHA5FAQB4HgzFU6MLJ3V6AiTs47Ke	1
3210	2vaBzBKnitLpBUMrYfCqtkxJnHaqM28Qx3uDYotxofeJqybgXNVr	1
3214	2vaJUk8QCZV8RQD2RPViauekrQmwGg8LK3TktPmDtfHASGMCUk9Q	1
3215	2vaY3pi4m2kQEmWMEmQ4nQYCo2ZX2TCmTkr4nSRPByLVzCNvxie9	1
3218	2vbRKMEMSyaXcSC7HCigEL23vncUBGG8TmRRRdeq3kqJDwvCG8LY	1
3221	2vbdzE2KRHvuKKcdc8SHyFwW3PneKRDYtccTyNmz68j1ixHDBcaK	1
2930	2vbrQvim7JZJUzk9djpMV12CNnJbbZAbdRVKiuJb3PajRZWPmbYa	1
2935	2vaaxN7zQfbAn6uLsWkFU2NDmvxrqjw1ZHhrmizLBkKw6RoTxorf	1
2938	2vc2zh3QwsHEa6aNRp4cutS8SK2yCAaZZ13pfgr8YkdPCA9puYgf	1
2940	2vadsh4WPSqr9iTX3JdNoai4TV14VyWihZ5pYXdt8CJaakBCnpVK	1
2941	2vbMbJvuy1Q8S3DDssGv3eAJtv6SXMp93b6M6xkyCJ4BfYRjn3q1	1
2944	2vbeW3YQ9hZPXhdHnCt595sSAS3jNksGYwTv8a3KCGRRcmA9aEM1	1
2947	2vasCHAUyChWjdD9siRKHPkNkhHCjgrh35FV254P1Zpe87ayp7gR	1
2949	2vbfQrEKb3vzHvgEKCaLbw1eH9RzN3nz7vHSD6MGo4VKw9D6K94t	1
2950	2vbPePKj9U7kAQ1Hbuz7FyyBbBKuHykLXUYVEr6czS457MNiqvaV	1
2953	2vbzLJa7DmLQjR4nkWgwdq3dP6HKXPAaSs1nyzKKU9HbDcnsWivN	1
2958	2vbqh3YTBLg1a2ZWbcQqtoQaPWuHqJHpg2oHp7aURTkmVYnSBSAX	1
2961	2vaotPPPScPNXpNkkB5DBiPhM6bcLuoeFn51vc4VcnaNbYb88qzD	1
2966	2vc5WR3KZ2tAGUiopezT7pQv897ZndtFLhZtgAgfxJBFWgioyABn	1
2969	2vbsg7pHuBgN3H1Ux91yrLHFdf9UgbdfKLciu66UhXzNdqUA1EPs	1
2972	2vb7eQ76GipbVvC1SScerPTzGNRGQXDdQ4LpTqQMZM2R6JpmdG3u	1
2975	2vaBHx5tororWGZpJg7ikBFD1oApaoCntdiyMLieTgugoPSzHVtU	1
2978	2vbmbkLARkYc8vkXwZKhjmLb1fSXKDbVYgc2JqHxnhZRDWs8EkE2	1
2981	2vaRCyPoQ4hgvvWqb6SwKv6N11Bp2xLt6vgm7gqsUhN5vngHxkav	1
2984	2vaAoRdy1zbRSmLQLBxJkB49aWk2nXvxRrY5DUk7rbHUBHmwTNEg	1
2987	2vaKFbDPCquyUQcqjGJvzPp4yJ9i5XTtquHjiS62TXrARwDmncMk	1
2990	2vaghcpQRRVvPYSmXnpbtNrfu65dPxbCTSHUxDY1YdRVqXrqiMxc	1
2993	2vbZhu9833jTrn6uq5o4hZrxWNjwUQh5sMByfpYk8K428YZKC455	1
2998	2vaLJUnHJ9hVSnu3nuKqyFr8hDtdkd3yT37wSSwgHwuzFBCSyRpd	1
2999	2vaVc2NqVgbkdymaS1RTATgo754HiSfMv8LdjSevdcAFQ1vUGvCc	1
3001	2vbrEvV7w5TLQYGhpN988UazVJ648L53EvPU6jvYR3KBCRzgriJC	1
3004	2vb2pUp9s3vALmo7jkKKGxS6xvcBkjUxMXpCAyWi5vgYmHeNujLt	1
3005	2vbVoYyq19uL22E1pJRiU1ZvYW49voRgc8dKk6Yqy8pGbaU79cw1	1
3008	2vbF8kkvRudCEoM44T3iZSTpxJwrpGnZT3XsjPVS66zLV7e4U1bR	1
3011	2vaEYC2mE9CdNbbni6iU6bkdBQxcucK3E8oMJ3VQSEyX9voVuX32	1
3014	2vbtrPc5t5oebPE79YnpFdrc21FDaa7p7TQhqfY6cuDTXJUjJYSi	1
3016	2vbiX9eZ4NeZ4UciiHDA7EhQ6PixMY1z843tyV3jpQ2xcSZinUt4	1
3019	2vbNN2Bz5EUnFKSb2A5P2CWeBuxfvDaSQw1fo6st6DDzTScFfu2T	1
3022	2vbR349UKYVWAruAQWDLWLHARyNY6dCcTfQyK98CLTfpiLFHdJia	1
3025	2vaYVpUJLjsFd7xfZS2868e8KuyL2St4t1CiMHUYrax8dBDe9gB8	1
3033	2vaQy4QVr6vpnkWrbYDqvjWqki5iTWmg8PTF8xKc7bsMxiu9pjqE	1
3034	2vaKSXf9ZZKERroQhf9GKJoPJwuu1XCnTniq8fzBiQYghyZYjdNp	1
3037	2vbLqVmHrDTVAmrcUw7ojQqMMUJDWS3efHsQ72n7oAwJdrvPDv81	1
3040	2vb7iUckmxY5TWrk1hRSZwLCSKyGURMdqGeFetqDaSPu5fM52gJN	1
3043	2vaVvqhiq5Q1rHDALBnNqW75vp1H5zFNYXuZsUEfi8nZMLzCUGCr	1
3048	2vaiDGHckhVFQbJjFAfJ5S18xrE9pNfvGu25yVX89NoePLSmgGeX	1
3051	2vaj8tWr9xBxCTL6k7Xh4QQtNaZ49Zvzo5NQvnESBZJNqdt53VDn	1
3054	2vbDT6LyZxdCGgTPNgPcSFKowAajYVxfsj5qe3wYXqNAdgJWcq6r	1
3057	2vaE29rsAbiKTiEbrsvHEre85Rm3Mf8zG8koPLZ2aziPeC99J4bU	1
3060	2vaukQrshV5abWm6kMaWAFDy98ucSzv9Qsk2GdhwGg9KG4TBTptz	1
3063	2vaQttZT4W1cv6Z7QywqT9xZERVg65tDen2UzusjGpt2H5ogyjsc	1
3066	2vbiiQs5CRjd5QgQB2jzjENsRMuRRBy1kT6MFwCNRkaop3cuBjjD	1
3069	2vbL7nrLF9n9C8kUx9CPRwb9caizQfmLSJ924hvFqMGvouRoMmwd	1
3072	2vaLpKZtRfbrhaevkqbSJ8rrKNtPDWrTLN6M8NSmo8UVhrxBthX3	1
3075	2vagEyJCx6fQo3vQANJkEtZqCR5B7vjqnHtbKAUuANCnTDxzyQmv	1
3079	2vc2ecYodDrwkWVhPRkT5NXHePKT6Z1VM7bgHY2Hh7UDNMzRWaL2	1
3081	2vb85FKvooQimbFqYJKwAXroXTidHpurpH5nSwQ98DBC2nWHBqKb	1
3084	2vasjHnGRtLzyiYWkAQVUVeJ6LHbLc3fm2U3vSkQ7BjPRmdduFFL	1
3087	2vasEKa9963M59YgHCCfUVWAn27gKjwQXM5H9BT6y6afCyfUkjZe	1
3090	2vaxzS4h1ASbRQyMCE1cCiVDT5j7UXVVwBn6q6SAXZ8FEQaCWAGr	1
3093	2vbxAmNtTK5iq5h7JUqbPvD9LaqGMHdH2AMh9J1zTUf4GA2RB19X	1
3095	2vaLszmFmrNsHAKGGzNnwN2LHZYAaJadwCQVHUHhf9wAz9M5HD6g	1
3096	2vb9uTDFBhCgjbwNDuUi9TzWXvUX5skFBVgN3kqaXfDTjnau1JJD	1
3103	2vbxfrwemjpY98yqXq4j7CSDSxQTxemrDc4RXPZqbv31WCJW4CHk	1
3105	2vax3P3efnt8mka5UhKhJdQUqtaZMWgbKdTVqnmwoyHKvYeXntHg	1
3106	2vbGxy8nERPNKajgQqh2suD5VUAmmNQsyFFJG9MYGq6RSxCYboNh	1
3107	2vaxUog3pmbsTEYdmpkiTSWJTnXNZDd6aHP7Yc65xh3kGGytqpxj	1
3108	2vaz92mZDtUCPz1wbL3xhs435i5dJusNgxEHcuffR1jw3AmVdJz6	1
3111	2vaL3mtcUdFzVq7AFjAAYV4SeTrvjZHvY1VuAsUZ4vVkLGpLGaqL	1
3113	2vbddz4UpWk259QVaxnWXTC5E42Vyo8NuqskdMyruKNjsBrffnnd	1
3114	2vaeXGbnHVttd6Dcta5F4rYHFq4E1pbARZ4RcfZaNrw6X5UjmDcE	1
3119	2vc3VW5Mj4mEuG66VWoLo12S6kmEW8nSgDUf3nt5xU9HDoQ7C8Ci	1
3121	2vaGCpxnMFzVCMKgLUBb7ZauQ8SLJ5ByoSa9VumVpdMWBuZxfAdH	1
3122	2vbwfDKun6J1mtTpKwdv29nVGKLtFhnxh4LPdE7gXTyg4fpjWwAw	1
3124	2vbN88kBtkcmmAqxPvmbdDteXXWNjdLMLorJ9dchnjTFzckHDRUE	1
3127	2vaDdXDujHa8C21rsDCYFBjM5pRSJEr2PJx3UbPEkuNh3Ugi23B2	1
3130	2vacvDb2dhFkozEGEaStFp8wiWydQsYiew7U1dMZtJmqcR6L6Uja	1
3132	2vaMhm9nHi3BMwqiqFKCt79QyyMwBSdnftpWrQqVDkJwzmzAWxVY	1
3133	2vbRyCwt6iJ5G1wK19VqZyHYeB3nUHEYsBiBaASZMqEypAJ7AajT	1
3134	2vacTt97g3Mjw7GBaEfYNjQ8TGTdPTvLhenEF8x4qwmTqKHdXGzD	1
3138	2vbi8U3dZHeHPB4PXLv6G1NLLDsVuKcuPwuTfq7BThTYJXWPHzMY	1
3140	2vaH9374vuZMVmQzyUmBCbfLUq6rgeX8Uht2ocsjprwNk2XPcqgV	1
3142	2vbBZB1cWw3vCHrzrBTdPAq4Z7Yqw7HLHU2MMXPJkogt1N4bPZzY	1
3144	2vaVgLTUGuVLZjxykrHzKo62rHegdMYsgq5CMjVvsajWpB2rnfFi	1
3145	2vbA6zezecqyDUe3sXphbFp4f4a4pZ5jMkrkcRshZb55DRanFtrr	1
3146	2vaNLEnNPSHHZ259P7tZPFuhs6xgrQPQsfds1Xc6wJv9oyZx2zme	1
3147	2vbHRgsmozGpMwU7xRiquSt73WLEuZUGp3Uuos22Yh5LHMZbsiMv	1
3149	2vadaiWV1rmwecbcGXsK8N79MQFboG8K33u38R4igTJqKXXteGCW	1
3150	2vbSf3fHmGtFpg64ULr4SjhPZZi3F2Y3SWX4dQFWrjRgyKFCDzzV	1
3153	2vaVr9YBmncHNKrn6bRJpsmePn47qfE21bq2jxSeVrz13fEc75ig	1
3156	2vbkQfx4YTXRRWUCSKFRG5gsnZMuPTDrBNPxu7KbS2s8LJKkdNWY	1
3157	2vbsPjiUG4g6RFxa91Z6Daxu5Ro33awFBf3Xh1QsUQ8J1yju6Zw4	1
3159	2vbA2Suo9P1ptPPsejwrNsi4GppwFczjEbLSnQaPGivx6VbJ2fTS	1
3168	2vbEsHHSiEsD5egzdBR4QtvETvaXQCNDtMqyW22YwQrVi9Hq3eNN	1
2932	2vbUcYjx39GUVtsvjSG2cF8fG4MTmLH3R2rGxCrq7iXRiYp19rge	1
2933	2vbwUFGALXyTZrerwywub7GE6VrmZNNdxw4rQyMmjvrbPUnVviL8	1
2936	2vb5xiJQLCHHC7imdXXJSbSCzxEf8ZaSbphtVbjLHyUG8N81iDiB	1
2939	2vaAprDWrj23DJRWmV2g2cxcLKSve8sLczHpWZR9UXs28P7D1q37	1
2942	2vbgzqJa1ivJuUUFetiRwtP3d56eyYwTyUVBmYdrrYVbEbv3dncM	1
2945	2vbJskho9nnQWYZkGKAzPZtrNXuCJUxDv1XSuXSMDTkfyFtuSU9N	1
2948	2vaGLsXyAdaMp38WUFrPzCsLNGduSPLCNV6EYbpU4Ec8ZEvzJQKn	1
2951	2vaCdtHJxyu5vV6SJU9QWMqgUyKRYPk23PbWZfyUNkBd7EPEJwaC	1
2954	2vawwwWGzDtz42N8EucgPWYUKfEW1GHQwsfpA1Ebf9WmviZ1LvWG	1
2956	2vamYDsemF7Wm1ErNNFUJa5R4aRzsWavGKecaHhoywRGrG1r8v8L	1
2959	2vbaUmT8U9ZCU31Xo1cQ8e9yuppzCysX1VPyEbVDcRcWQC8v7WNd	1
2962	2vaWrxhBdb2CaaKSLrA7HHuHG4ZUf7PfJRveebUnnCxRUP9rzQtV	1
2964	2vc2ktHVwLYpkoTDg5htW3iwsDCs71h7EtrX8GPMjjFKDHeiXG5w	1
2967	2vaNzwtzakaB4FVd21kq5REq2YzmNpWWxFqzvK2vPVD18YbTNqwM	1
2970	2vaCKik4ELP6gWr9kFPfxWrS8w4V5f7kLNyKAqeMyrGfnWJosqRC	1
2973	2vavBjEHDi6kDGGJ87JSq265TEJJXvsQ3AnJDFXvuPoMKR5cojBf	1
2976	2vbApt7VDQhEksDXUcdvqgw47odG8RQ1ZHfrUbUuTuSm1nTXuUAF	1
2979	2va9zBuKvgc5qe1wrcgTcT7p5ApcYRsNGcPmHyiFCBiihF5zFHbw	1
2982	2vbu79hjMSz85BvV6CCVjdSmTN3NR51CthPQWkh7WsxQc4ySUkMP	1
2985	2vbF3f3hjNrPABhYWPDropYNoVzWGhzK9usBUi3EuhmpRa7b2a2D	1
2988	2va9v44EmwMCs7G71dJK7tfDzCaSezpL6EGy9SQzAFzZPJjqrx1J	1
2991	2vayzAcuVECBh631C36Qj14UH1Lvyd3doBr9cUts1Y5TPQxCJfJr	1
2994	2vbxH8LynKsMsduzMcyginvwGZeuQ16NdvCTvnWghFeYaW6As2Pk	1
2996	2van973QWLJnLnDK7qCaBjkRwBdVthJJ24GBfPTZGnTjyuK9uba7	1
2997	2vbpXPt9NWqfYFLt1KnWcGQvzvP5afyGyyThyzvBmoxQVT66s2LS	1
3000	2vbTd4dGPoDVPXSJYmCV83wrcKBxwUAhaiurwLMwQmHwtFzGcVZr	1
3002	2vbf5ernAMEW2CG2PNQrtBb6K3s81NbPwgqYhycDYy7Gmv9AkQZR	1
3003	2vbSaA2mCF5mc174Sj2fzey7LZ6WoeHSWAKfq9cDHyn8c6YPcMMj	1
3006	2vbqzGbYtJ8YgCcvEvSmkFKb6iDHXD6npyxUxbSZVWNfEfJv7LnZ	1
3009	2vaqEcVNV1JddQLj9fq7HmcaYCayAhAEZFvFjqYJGNhs17d5CSpL	1
3012	2vc2YFUTtyaZ8mcgiCqw5GSWePAA7T4pMFUuZ2HTZiPRB84rStrD	1
3017	2vbKBaxskvRYuQYecEkTgPT6YrLwvDJpCQDhDGXQhfE7cSctvSWy	1
3020	2vaBoSNu6878hSwuuGA52kN7vkzQgmqyBnB1ozBbRhRmpAe3asyo	1
3023	2vbn3PE987C8UKPzBFAwUCxAJtJsm3nMqaPPQJ8TGiVhA5oruBoA	1
3026	2vadFua32k6PKf7rjswKEWrq912kXNuVA8FekeXamrszvtxSxTt4	1
3028	2vajcUr71xnzerJAh7GQkf1Gv2z9zsDuAzuH1sq3P31afRRV3Eed	1
3029	2vaSSb83PkAC9nZ9oFQekSLqSVqdeyUQErHt3zT9e7irAHjFHQDZ	1
3031	2vaJ38uM6fN9qJSvi5XJVTWgBPPp8oQ4BZ55CBYjZnnevTZ6NCWG	1
3032	2vaTsTUYMu2iVAeLrpdNSM8eTG6VBEYumiRLxg1kZ1MFWrP8smwE	1
3035	2vb1i2B7xdiTsXpjkKHuAs2oekN9kB6cgnSxAt5gs8Uf3ocYo1Tp	1
3038	2vapYa94WjFS4TS8F5o7Hwhm6iezSoA5Czrp7h48XrXWfV39dnzQ	1
3041	2vakybKHxsRLW5r823CaprnuPc7GsQtWnbAzoVc9Hs7yFixB8vqa	1
3044	2vbvizE2x9wh36fGjXBeuiEQRHL6aumaVrcpgiowQ3ddMdnp7mif	1
3047	2vaGhGmhcVKG61WSiCmafcapDeRFtohFG18tM5bLD7iJYqfZR35J	1
3050	2vc41SwkfJ3TM8U31pDPakAv9HpyhWpneGjyQFaqFRR6QpSCvxdT	1
3053	2vbvQdCHSWmNh576mFysLDTXVX3LUuJJNbg1D1owPNna7sLBSEmi	1
3056	2vbdnsaDbRfYq5J237Rz8SivcKKiK633NWAD3ajjLm3iNzmziePW	1
3058	2vbzgrUojrHm4Tru15Yj2ubd7jR222v49qiWHaWkPLspQeEJkjd7	1
3059	2vbnSZR99YWwT9phuXEYrStMAmVEpWoVX2JbPTHwBMdhChgqVgQu	1
3061	2vaodz9fz3dXtYQWzEoKmjJmcvMVHAxnXbrfD96iouj9UxVPTZES	1
3062	2vaVzoJSJDf7Veiohjwwm9keKAenUAn8FPrsTKi45TV7hRmVDymJ	1
3065	2vbERMe9jL5qsZfxuUJmvVpUYyi7CG1pb5AqrpPtStjRyZc2jYQJ	1
3068	2vbzvLYYX1vv5yRj5RKSMxTm6Ubama1omc8avnokcPYtVqGJzQS9	1
3071	2vaeJpkSga7zh9UKvd6SzaKN6posMqimdTZ7JwUWaUJZot7orgUE	1
3074	2vbG4tNgcx5qxaNFQU28Xbwqx3BqTTfXWVRrnyUvnKWiw3bA4G42	1
3077	2vavs78VKS6NTqrTUQPMA4PtikgTfhkYmpVYK5S1vfFDeBkkWd8M	1
3080	2vaB349Mpt5NqR48EB37ugv4KA6iA8f4VrMzd7BsUVfJ9gtLqsxe	1
3082	2vc3wRybtPzSPYxWZxKoo3r2asLt3aWmDqMyfFUAmjDnjPnaV17p	1
3083	2vbKdR3Q7oxvakqVtAFBsq5GCvrhwz6o4zhzhoBdKc3ssPJySBEJ	1
3086	2vb9fD14s9QaEUVDXwAcZzpTmvq1qhz7ZEwKeYXFxobzUZDNpy8o	1
3089	2vaX77Vqw5aG2aT16GXZG9ewGoKAQjTx1eizg5DUa3pzpKAuc66p	1
3092	2vbuydbvYy6DB9LLAVdHUiCb4UDk5DKJ3VAwfqM4dcEyaVrQNySh	1
3098	2vbb6G5PaduYHNsiVJMBSBxfaBXC9T6an8d9L8YdS1xgAJttGSEX	1
3099	2vakLzbojr6uA2vKzBHLUW91KfVrMzrtPHXgUUk7bAHaifA7iSpJ	1
3101	2vc1CyVM2axjD24jxkbKLACrq2aV4rfMNGuYv1eDbVb9y2B4yEdg	1
3104	2vanka76auEpo5oFMUHtuePgWaJP46jesGUtT4uyUUd7BR21PZyr	1
3109	2vaNNczSLcRbyVK526jhoHuGJufHgC6QXP7p6AN4ZzpoBzzNb5V3	1
3115	2vazFcEpUuw4pXo469GC9etukqbJ9TMn591NEwczjoy1GkRRFasD	1
3117	2vb4wZ475wfRu4WT4ZaoKfNerdXdewPhyzdkRu6BpdTmqjkLPnE3	1
3125	2vbejCufcjcKNXVb6BszMbCtyTpgQpqDgocCPqvjqxKVfZJdhmV1	1
3128	2vbanxd3R6uVBnC5iw37tCmsLNfbMfjYqJweRYTTSGZrAKcmGe9C	1
3143	2vbBHPkgtophadRttuQ4yYR8ijQP6JPL49yUTb4ogrsaD2EucrKL	1
3151	2vbTdxAaNMhtpRSr6P5eJ85DBujWHgvKM95Ft144iVVKNFJkrs9D	1
3152	2vbMVLWps15oJNyzYEJY1tWbAdXNVFyZyZtPMqUZpd9GDZYZbJYH	1
3154	2va9cNz6tj3nXoKQE2FWU5QiPQmQBRQyJtgFDfto6T1MeBs4zGA2	1
3163	2vam9smUDQNXFhp1rUoJmVL9ihcvyi6vksugEWKnPaMxat41mkUp	1
3165	2va9iY5YzykMbunJf9KiV2DM7AmBt2WWr2jNWmc5jFfSy6cmLPNR	1
3167	2vbBEuRA117gvFkKf6UHTA6HTWbVPdWceoo63ZbxbNyryf2a3Wyt	1
3170	2vbWtg72CYwbwJvgSpw5LiswPuSaHwEbob1R2dtWmLZ8D9TYzNQU	1
3172	2vbAeYhspTSiRdtTNBAduGBUWBfsU6YHxuDa8ioYzyE3KwMuoneX	1
3175	2vafNA8sHi2tnzwRnXBRRf4LXrqwpya8MgjdXw9KERMwpUts3GJz	1
3178	2vagVNXKJqT8yaSN2B4nW8GZ58u9kVxP1KFs4vzMXGzNLF2HnnaH	1
3180	2vbZLA9mehskWk4EkULiQfTaasP9qXRwuk4tA5gJtmtGXJRroKmR	1
3183	2vahoS66KbzP3dvWLCafiSDb1aiT5HHq8T2L1SfLxbZiYTxhE8UJ	1
3185	2vbZdiW9k9aJaaxNxr3quuwpAss6C71ESHLAKAK8tapbHSaUirrm	1
3187	2vbepnYFP8vqvJXFYJ52eudW4M5HHX9jD7ma3iQDMcGWGdB8q2ab	1
3188	2vbkrSkEeGauwykJQxZqpp9rb9jKcYxYWLJdJRvTiA47pGNU8f2a	1
3190	2vaPa9pnZXu4GWPShRc7N3SqqKiiUrvkywXiueVGYUg7PK81Lx6y	1
3169	2vbqtYR49kWwL2oAgpvHywL4xj6om6uCCCuoxJ4MFPo1qERN5gtJ	1
3173	2vbskdoPyuB8DN4Ygqyw8E5a1N1yeGE8JLnDarWiSnYENE8Su2uF	1
3174	2vagNhhEBPXQPVjRFciGqQUta3CBhGCc148uXQBBepaB95hzRxwR	1
3177	2vaWF3DMntTNyp3UeiMmc2qCazmCSCw52VUHm4M7sAopEZZP8fGP	1
3182	2vaqzkMXVFoFDSbi6p9Pm92dDHHSvTsmKxbDbuNvspHojeCVLtCh	1
3184	2vb82fA9UVRJXzqLR5aj5hQHXd3SSWBT52BhSTEqvYtgKiGi1Yf9	1
3189	2vbdSzHu2sCrmeWYTbRDxReNet3nY38CJwMHemKXe3USSsjiqHvx	1
3191	2vaUSxKAAaPg5mxPhXZQ2PHjMFWQ7sZaMUG7xwhgqoRJU8ApwRAt	1
3194	2vbocpEzaNRRdrrjxCHsbm6TWYinSzToAKo9A2pwR2FAW1GQut2H	1
3198	2vbdBnUvgSFFB8nJkPZxAQsJk8xnrssswGR73ZkGxFhWTJxTc1ea	1
3199	2vacNgkmNruG9maXtd9cmfZ1t5ivq7b3Zxc9drdM6Lys9eJqX58T	1
3204	2vbjDuUoyFsX2iw1jU8sGuFfobdefDcCe3s5zFnruTx44chKLfq8	1
3205	2vaoBWggQEdy67BkT1Vxfmd3q9oBHYRJbxnzry8aqmFoPXnnc53J	1
3207	2vaG8dYD4MPSwT5KDBPY2Ja5TrbQTeVVvkYFNdWCSrwf9aJKS5tS	1
3208	2vaXTTx4veimiYhcurkK8TYAwe1FSGQt5rYBuc6sWr22AfKBGxwc	1
3212	2vbTJbdWAoCu89Bzsm5qta9AuxY2sde5bTJUxyw2XqjUq9VN7s91	1
3213	2vaLkeV8fqnoRqCbnTU8W2yAGZzTE7XtdS1tYnuHrMi5rjDpBQ6c	1
3217	2vc3sccTe9phuzg4UGCwTQXtqKa2kywY9dC9up1sVxvMtDvHhFCA	1
3220	2vaMVXGyJU2GnWG9KnLXNy1xaqHRFkr7rPWw3tMGNiyr4Kd1xMq6	1
3223	2vaWYTto6ZPpR81Fiko2ke7HT6Txayaq9DUcPvdYEcvp7P8UVTyz	1
3226	2vangYMWGtzy656RG6N1pNCvtPbTAJWkbcE9d5uzqShbv2DbLUKP	1
3228	2vaJedaXhjZ5x81t8e4bMDSnjeC1fccZQDt5qsZuAvKtzbttmz1V	1
3229	2vaH65ZpEVQu4giqELkLuxV5ZjQN9bzUgeGiXscND7SvcmNW1BD7	1
3231	2vbJcEFhGWnkG9rwRhf2zwtPBfZzwSKomq2ZHrvvwpK7rjKKJL69	1
3232	2vaEuqykPgHEGhwFNPqmZvuD5wTAvRBPFaksyaYRyCywC2r1NJYu	1
3238	2vacCX8swN9Cjth9Zv6DYeRGCvqJhp2vEDeM8ZLhzGCcgjWzoFNe	1
3241	2vbUWdYTgJVUCt3G3r8YcMDqhTRJaan5isiXNutTdAJ5hjiBbwZN	1
3244	2vah4cpNAJPmi5mM2tmEswrYt1ufwEWJSXA5BCkYZxnsYScLuJT5	1
3247	2vbZWUmVhbja9suMddb5a4g9oTQ7BcixGJxjrd1bLZEHwaXDCJyz	1
3251	2va9sXAWSyGQb2XuSuVY9RJYkA4PSNXW7V38mH5xkt8siyiSEpHm	1
3254	2vaLaZDVu9vHyyXQhVLh69T1j8UdFm34aHAdAnrXxzTyJAvCnRVh	1
3257	2vaFfvL1bUhJAW69kP2b42bUQbAbBMgisy16P1kGv6qrWTWRMptk	1
3260	2vamCEcrdr5wuUMmyTcBpa6ouk3bisSBm9FKBMSYt1kvQmHigZ5s	1
3266	2vaUVE4NuNWMKwEggpjMCZLwHHv2FS3c9isNCVU6eHhMjtgq8HDA	1
3192	2vbeJmyEdaNyex9ioW1UxPnXEMsdMwmdeVL4TdScNngyuKynUjaz	1
3195	2vbbfXbFhQ6SJDQazzF6wjBKQQVUgfeny8foGqJzEG6baZFTzXVH	1
3196	2vasb5eQgKLRPhssm9BvWqUEiRvHJKE6rRALS45k2NdPqzPwCLnb	1
3197	2vbdeurNxpqCpGyS7us6abajVip1X6AAHdbfD57jgAb7FJHfTNBU	1
3200	2vaAVYGk8FbmXLqTymZgkcXxrpnbenACo6K4jLeBvef3xsLfndjq	1
3202	2vbQkT3rN4vadGtwbcPm6YxmW691du18dCwBrhmsDgmMDZxMenx6	1
3203	2vbCbG3f1AWeWmvwkV8dzK9aigXJ8Es82xwM4naLwT38KzjrEt4P	1
3211	2vaXptpxtereTn3ks5QnmcE1DY4iyy5C9PntGTScqJm5J69HMfxp	1
3216	2vbHAND9frQdvvtedS6zrbHCLYrNgQMYzdE5PkMGMDVpQMWaX2mJ	1
3219	2vbAfgKWr8kwLmFAZnoUpo6yxZVkwe714s9SYea8W2dfYmM3cLFE	1
3222	2vaPaXELEDB2KzikhonKr5WLz6vom8fgNorvWXu5DSV3YjWFvNvG	1
3224	2vaU14wABvt9muFDXhe92yB88KRiR2mMxRoXHufBWgDK5gA5WUEY	1
3225	2vaTeVN4VQSNE2nTg3qfxv1TyjVwcTjmD13VZGyoFoZY2vnEawzv	1
3230	2vaxEZsbXttRsP3V2rZtyVwMa5zY1niC96vg8z3q9S3Ft3jJEv2F	1
3233	2vb4oRGojhTyikM8AVtTAEh4aP7CvsSSyovZVQWDvCC4EXmh7Xjy	1
3235	2vbwQ1hVcLHo7TXFnVuBRQ7kqJatPXuMCsSvAGTvA29Zbbs6uX5H	1
3237	2vaHG4v4iTWGocRSQmGVF4FuTQ4DNWFCZZ6ZvZKNrnEMdoNDHsCE	1
3240	2vbt8ZRLK7Gy1AufGSLFBJsi9qzm5QhrDKqFGYYGoFZox6Cs6KFL	1
3243	2vaiWpRCkmRitbeUius5Qfd1m1D8TpFubAePWB9YYbBhVeMz29xy	1
3246	2vaUA2Hjk2eDX9HuQ4nJWyLQUAVVRPLZPZYPYBJTwhNQvfqgbj4U	1
3250	2vbw72vynH1g4dsZMXThjvMAwnUi6gAp5oWEbybHS3Auf72GFzL3	1
3253	2vaCQAeds2SGkHrAT7egooMLFwYhuqkvXfsD1mWhKqjUY1vMSpTa	1
3256	2vaVQMw2YpGbniSW7dLpRpJm5rUg6a6hnvWjZvht5tTtznYvc8on	1
3259	2vbKS8cpi81HdcpP1aBeMCbYDmpQzCTHqcPLUUEUsxXK5VvVAbGj	1
3262	2vbMsm6a6FFpZzLWa1RwYDMegHCSj7YEEuCaip92Lu6eHV5Scssc	1
3265	2vbLKGXa7V3vnwtZHd7fDFxtjc96hQgqcrRpGZpJaQBGTRYTXWqm	1
3227	2vaqzxyjV7QQmgabaPfSEV6niWdgUduZQAVnsGf7chg6gzbhXufU	1
3234	2vaRAkD5opKBcFeG8KyBWoaYYBzQsycGidjKNzHEaZHQrda3SNnq	1
3236	2vb9fVwVxNs719GWf1CWT1f5QEjfZ2bFS4zHVH8cba8C7MGExBzK	1
3239	2vbqLK86RRxBwGe94Hr2q1pMLZzuYxkr5eDZ5cT2NLNJxrvn1fZd	1
3242	2vb8VdnSc78zdahVyVEeXoupdeVLt4TUdkD6TBfXG5yzC1iVLk2S	1
3245	2vasUbTTxMyf1xXJ9Kj3S1EXYCa23YaEkPmZTKULUpf1pzBbM6jX	1
3248	2vbkSfvXX5J9iqt9V7xbLqYDdESSoXpUMvyPADaWDq9c1wRWe3r1	1
3249	2vaFnQ9Vyjd3KFrPgddGQCkrzkzVS8yyhzg9dMNErYT4ePoWDa76	1
3252	2vaQnhh6LQ3fexCAubSPSd1Se2xT1PaQsEnYnoX87tGTPFHPUYXR	1
3255	2vauz6UN8isv9PD4yTqbnGo6gqHtjE8DFVWvApH77ZWXevmRuioJ	1
3258	2vbGESMAwFyRY8nrpttWiDith2N4zsEXsLrWRLeVQFxcakYHzj2o	1
3261	2vbHnxGKzd97k2pr8WoiSpCCJTxitHrYeAKSEAabA8xaQeMmXzRq	1
3263	2vaRuzZjnsRPZKnPdX8vPxfAVhFkXJAgMd9rHnZbawUrhiyghaid	1
3264	2vb3fZHkVchauamohqMgqdHXUEsyTFbSxYgyCj2jczbSQhJ58Qpu	1
3267	2vaxCb2iY1op59nMKnHxbVnKPfgLBMCYUCUKGmKWgU7oz9ak1nAU	1
3268	2vaK2jpNsgM1PVWY7GRySzUF5EfHiGoJpQRFTEY869x3mEj7TJ5E	1
3269	2vbVp7ib4gTjCAz4nh4k1Y5dVssXMtLaAgSRUAnHLVSyFegvb6ib	1
3270	2vbcuTuewBPLLPHvvCTWKUBfSjqLkJ3Nrf7N5Qc69BpVk945AhXN	1
3271	2vb3uNhUcxc5SambTHVwCQN9Mxyag8SpkrgY2HmpdGQ1rq7QZvr9	1
3272	2vaUTuAERfPQeuYpioV1KiPtQnQbbv6RWPN6rxPUjfVKBVZUFSG7	1
3273	2vaFwwbAusTai7yUs8Zkv9xSDuYdKyoYQvsRZWsSsLg5yVSBV6tw	1
3274	2vbYDSKNJmRwGasaGf38vyMU4XVEnT1qJDG1RMWE5J8AXsSzFBPg	1
3275	2vaGyk2Bo7rjcoipDePceGRhuh5dKd1ywupbKDs5GQQsDGEjiLD9	1
3276	2vbfj4EAVhyEZ4YB5PTPZnW28Bk2wWeei3AXTZyezeehfvszMo9g	1
3277	2vaGjotjM7ZAwcmUc8GkebNgnSQrRsSjVoAfBYcftrQW96z99Rwp	1
3278	2vc2D5UwZMnt3p9c95MkKMfg6BcbKQUDSfbJxedfQYwQaZu6MUZV	1
3279	2vafbfK4mhWBjmS6AmhpigDoQRAc1u2FNib3QUhVRPyaTQZ5tDBN	1
3280	2vasTMTubRrKjtWQermmpgDBJou6HjNHc4Q6rh3HVToHnrdYhwtv	1
3281	2vb3Sv376q5U9mNRGiWcLyM445AJyehGjdzJQvk85QehUXJa2DLW	1
3282	2vbzDGssMd5Uq5t8jhBqe98Y9wDfXdCz9p4k5gK8RwZVCbj4Do6R	1
3283	2vbjjxAN35fhhVBC7BxrxdvsiGNYSo6hg6z1zfp3TV5ZDpL3J8DA	1
3284	2vaZEBKdPaszri5wsG2kZtYpYdDME5RBfRctW57tNz4uRc7XPHC6	1
3285	2vaLE7QJMZuNr86vbuNvLwjhVsXjiBmVuWYtQMsbGb45TQJTfvuu	1
3286	2vbot3XnVxM16bCg4Gub391jmEyq4iMWcTCrH7EGgf3oSvwNRMmz	1
3287	2vauypR9cUrnFqdWKUjtiMJWzjSPqQRm3dBFhettKc4Qh6tuuaQH	1
3288	2vbYHDENPZ1EvVySGixViBrEJ2aY76AJCBv6CqnD7AZKaPjkwjFC	1
3289	2vbyzYfVKWVSDpJWhKkG3oN1dQdDpgctg6g3HPiuYXganM2YFRr8	1
3290	2vaDTYavdacXpVKCoN2sGs3DfFkzvUsweN9VHGfWr3gNjWiGk3LW	1
3291	2vbfqBxeeCsAa3yJawCGwE3uotJJF4c8kDCRiHqrENi4ozgxmtBX	1
3292	2vabHbc4evPCbjqrXtjV2JfojoX23Qzik89kwYw7DLZZFxrVgiXt	1
3293	2vbtPZhgoEiEnSZhbpwyRYwNnSUs9mUHUDQfBviCz4qG7Kd68HdB	1
3294	2vaQ5DD9CiKodBjLQm3FbRj6rrTPhSY6KvNDrVpkFuUkUPBm1jkM	1
3295	2va9FBvnzvAEwqCtLjgVgomzVAuMmLhfpGLLQvAYT3s15eH7c7gc	1
3296	2vbbtesG7ygLrJAC5eBXRCx8kjJ5rnSDDFXveyrYNGa33dnvXti9	1
3297	2vaGVzBiqvLYamPEpNHKewuzRv5TWEKePDe5SAbNhYHj2aUoubv6	1
3298	2vaJkKL6kjywXmw2rBJ3zmbbbB4bvGEZBKQtXp7oHXn6LD95tSUH	1
3299	2vc17ZvepKEiXm2pBPuxR9g45w9Ud7ZRgeB3uMiSBXX2F1iBvBps	1
3300	2vaJD6YKJmVSFJ7fVy8dm5VjTYtouWL7UcAJ1ZbwsAfeb3zjrF3F	1
3301	2vaEBF7ag4XufaaNSKmHA594P8dPb26AFjyjN476vuiykASf4rCk	1
3302	2vaTcKrwvyHca6s6g3P5oNQigCbBvQzBxi3fn6wnm5EACUvXFof3	1
3303	2vbmsmDY8H2bP75Ay9P2GNY1HkTYg5gwCqCcsVQdbejZifvG9xMd	1
3304	2vbJCQxuJA72izcoGX9Q8gNhyzAYYFf9PX1DKaFug59yLFpUKQEE	1
3305	2vacrk3Rfmz2yLSQb3coBVQ5SzdRiFFnwpjQy1h7cpmar2RYVK6w	1
3306	2vaCqWxe3SMCKHZA7VJx7Ls8kKYrhdzbt3urJFhWbKSwj2dJcLAn	1
3307	2vawP3eqPoQVj1Pbwdf5ByPMvRhweeCUociTtELdKB14RQdsURC9	1
3308	2vbA9HN4cxY945HUMMai1eeVtVcNLjLHw8S2SjZV9tqGYme2y6ny	1
3309	2vbGSiriY6BHJmy18YxewoULFDNktqZEJa9JVMNRM1aFuPAWmDuj	1
3310	2vb8eWhdtK3xMm1oAPMsbsWmip9H3YyyKHxBJn34LXJwSvB7iEZH	1
3311	2vaDbJcEGCS3YXFoQsa46NLdtJ3QSrXRTnkyr78p9DtKvoscnxsk	1
3312	2vbx6bUyRBiAGpwKoLwEPBZBa5EnFVoFPepw5wpiFb7rjdEVoBoK	1
3313	2vade1c3Z389ga3SjdpTAnC8QjNsiicMjkLW8vdF7qC7gCbeYZhH	1
3314	2vbuoTxbzjs1TCsj4fvw38Y89s4NwJHZoCDgEc8dXnMzvimC7BUh	1
3315	2vbgTwiw7EJxnxVw1g2XpGQ5HYkJwb9QXDW9HBCcv4wdM3FaAskW	1
3316	2vaXuQkYT4GbYESpSbWYSgkTbQLMEzFc9iuzDBB9TTwie3C6hvYQ	1
3317	2vazJMonjGGGJWHZTaD4mUwv7N1b91pNxNCjZjBfHkGZzvbHBvcA	1
3318	2vbrmPARXCtyTCEFFSthLwGcXBLWAB6BaKyexfQ9pFVfvuyyufDR	1
3319	2varsbQpLpWXroWfornZgPmf44LNqxCPAw3TzHv7knq6XUjHuFKe	1
3320	2vacNCSbngyD36ji5FuVpK4ZtTnoVgKvDggEZ6Y7FTj6o4YrkGR8	1
3321	2vaxhBEZXk5Aw4mbZdEqozNdx9HHToSFk7RWDLnVwtRtW3ZfD1d5	1
3322	2vbVHkGh8sQtqyJkTebE9vRQd1Tn64w1LWzPZkc4tdzRcQQoynep	1
3323	2vawGGGEqZzU7exzPRVhCRwrKDkQH9BCYWWN7qXvgvDs4h65RJJp	1
3324	2vbxd7AAgwijBi7GuFjojyJrNEcJoLaVRwDp2dBSCfKH57Qz8nAp	1
3325	2vc58SDmqbSHpwLfBXC93fHcwJn4sCDeQ4gyis6JXgHxxATc2RTw	1
3326	2vb3gp25QgDSJpqpw9qTMst8iv7eokrrExS4oJGadif4ZdsCkKho	1
3327	2vbeipqaifd9tcDBbpqRacTv3g4FDsBjA4ZVs9bWvt4ek4baLkhp	1
3328	2vabCxVSRfNZEFhapQutoouiuM6nqnXjyskHPCj67xzD4wQJYQM6	1
3329	2vaMt5du42CetQmRAQ8ENY8nuFoj5WghmS5EihNbrW5yU2B63NSY	1
3330	2vb3M3oSYTj66kncnc5nqNk9TJtRhhcQRmugFrPL8qxCNYKQsdZk	1
3331	2vaqsEN8FgrS8RTzMxVRvhsWvk9BKtCdH23VDFzdzFndnhFSejr3	1
3332	2vabQGYFr1AP3yCiQzHBZFwQsXLeiB1bxgpv2xdP1Z6jL2V5j6eH	1
3333	2vaNoPMa8zMyQGhoyVYHwi7BnhampTaP5wbXszfgKZv8yu8A5E6X	1
3334	2vbu4rcZ4NWA98vLF5EuhQqEqntYHYaxyebnuHGNiAcFwqKyfMAe	1
3335	2vauDXskqAc64YvLyaWh9Joof17GvTA42yp3LkUqxt1ptjomAtuC	1
3336	2vbPpaq88Y8c3PBPy1MkVLXKB6RmHrGmAbiVhHvDMksGnLq8wyq5	1
3337	2vav1c38X1xQcpDR2cAaNyeM8vtWG3y5Gq4q7GwxmkXYtzMkaN4m	1
3338	2vb68MGBmg9a1pvmijEuVv1EF32QJ2TN8QtfVCJvhiPneFnh6qmw	1
3339	2vb1JJHLQxZudHbq7A25Ac4fgfCfMDzxkQ6n7D1rYKDSXbTwSeJ5	1
3340	2vadgQdCjJUouHbae8XJf8T5bFTrxCSgSPhkAETPm3jYFHFA3dUM	1
3341	2vaDqn8qgNYvdd96DWnwToMVjmKkEefHv9MMZyuVjSimwpAjP7rx	1
3342	2vaffqoU5zLk7aabMBDzeuQNvXMV4xrCGQM6Kk55jpe5eARqBvWZ	1
3345	2vbqNadZQjTscwKgFyDiddPx4Af74nP496NJXzeygUvHY4L1haPR	1
3346	2vahJwJwKXF1VWdrmnFjte8NNhfrRZBmCAT8Kd5you5oTnsTPAzi	1
3348	2vbvDJ8DbZiaEUdyYXJMPKZRKymEm8kMNagSgGsihcxfaR9P8AkZ	1
3354	2vc2hug36oVUsZpGAkB2bgTaijGj3KbWgWuk1wig6CC4XZxZQLPW	1
3357	2vbnHmY7yvtzGDpy6FwN5XL6i9DPFfao86UDRSyhwTmNbQWUon6r	1
3360	2vbpGxKFikTXvBNb7TK7v5fB2zKoDDC5wtmowi2vVxn9tPgGRkiZ	1
3363	2vaSVpUQz39x9fLqiRYLVH2Te1C8oVERAAYgGdDA2w7fYowSUj4E	1
3370	2vauqjXnc2TXHo7E6GxhFEkYe7UbR5Qhcwmw7hgR1ZaB1LN9YsVt	1
3373	2vbbpwfwVTBMeRd4NkXZRCty6mTgXg4zc8VMyLz3ewkai4QLttjw	1
3379	2vaeooJGwT7mq3HP8VQwCb7HD6ejioF5qMDpBRUDgreJP9wDCWqy	1
3382	2vbWkYNv5UvNLviHxQSeS1dRrJQrr7CecYckKrRjBJzzAzhCLPT3	1
3385	2vbHrj7HyNstH34Ht3a6fnyqd7bBrZR6YRZbpRQCAZ6gr9LNCwKS	1
3388	2vasGTvxtghtGxkrNfBZXK6AmrPsfdYD3M6tHsDgdpaEjqwZiinF	1
3389	2vaphsrSYs9NsDhYnvPeYutdpwYS3tNqUQZA9TLc93ot19Y1kgrV	1
3392	2vaB8bPEumPFxo5EUyLoopwGbKh1PoerSDMSdSU2ZN1bwP2LkwNE	1
3395	2vaTrnpH1WXTmEaPT9ewRebLtEB7r5HbakjB6hHH3PuviM9sN7kk	1
3397	2vb2mMnLhsdW7P4okDsD8171m2gZJVqptoAZtpgjZJHS3Z2fQpFk	1
3398	2vahkDVbsFyGQA4Hp62fjkoHai1haKs6fz6nZiDTZBoE6PSuTFkf	1
3401	2vaK64sv5xbapXy4gdmrpqbZQJ9M3kMfyzhk6MtPUqTMvMFu9oeG	1
3407	2vb7Tx34FiLvZr9gPsHU5t1syLFxq6GSnKTFg4n1QxiFUiQ6dF42	1
3410	2vc5KHX9onYHXeV8kAcfT6sQsHSYhbxExmLnTD8HheuNuXQikkgu	1
3413	2vaoDUGJQSnQPNTRRZ3jDrs12VTtW8NGpFGvkbeHuDyYFXddfYNV	1
3416	2vbj1XkXMFunP3rXF5jEkWMyAiFkRobNWYp7mepCZQP7zBsTEKhd	1
3419	2vacbpS8SBpf3Rjye1PzzBq6ZbUnVr2juEr2rapSo1Ht5dzzqoyu	1
3422	2vb8GYVGbBR5xB5SoN79HdPZB79JX6LcpeCv72M2FH9QgCXcJ7Ho	1
3424	2vaA6mhoWvJFsxnBMjued2tpWesXUbSTPyTBLrnF7h4GyY7DRSsz	1
3425	2vaxjkoFZnzqAdEaSSTM2uLhBD4PYHzMotEbBR9Eg47iPfUQLGJs	1
3428	2vbgJq7qiEMg88vHMSSRRoXJ8SpGhewZcaUyp2royZh3RwcVQbyA	1
3431	2vbYpvzXfL9XmrDYsevitj3SYPcj6pM6vS2mFv7SZEwFcVv5QtxW	1
3437	2vbiAcH8tzfiq6DxEGjiUAVU8enay4RvgB2jqy5FkfEr42ytXcLP	1
3439	2vbKfbSB2SLfcK6aP6W9c1WZWuon9KDtARxrK4WVfwiQXZeydPtr	1
3441	2vbYDXvwnAKVPkXbx71qXTwwgHiWY4XuG2cyNsXcG8DJ21J4tuwQ	1
3442	2vb9fx5igtNC7xuyRStshijqzGTh6zuNHyQzUq3NkgEJsJyfV5GF	1
3445	2vb87JzGRCbynYg5upmgUozBtX22xbCQAqe61e8vgZctc6DupWBD	1
3448	2vbYq65WSi2GPveQ6GrTbCRAD6mgMiwRb5XCyMnMEz94M3SM7auG	1
3449	2vaZb9ko2cSFXJJQLGCQujqTih3gAQydE3Br8dngRJijdJg9haag	1
3463	2vau2VckfNNcg6t1vAq49Pp52gvH3WRVXdfJ96mLVbkQRHTTvSZx	1
3466	2vbQuXMjDb1jeWgy5fbVqtLZFoHMfKzj6wPyMH5Vbpq6uBUeg8FY	1
3469	2vafsHgqQeCD7E8731ukKaofj9mX5n6qXp3CxqcDUdR392DAavVU	1
3472	2vaWKWqhmmKLGVLo3A8sVyhYRmiYx3RiX4hMfo8SaBnvC1H5Bbyj	1
3475	2vbP52FX65qAEsY488nhryHTyjWtFjQRRUJuWZVbZqpwauySWpW9	1
3478	2vbC8VxYg5Sn4jhX9Nk9yF6BwXyVknmSsC8d3CuZtY2mPA97QxDW	1
3481	2vafYgqQrG6Qp7N9X6tATb5zsyXEXiixUtN96N6Qs89Fy9QWpreq	1
3484	2vaboiQBitvhnRoRXfrvjuP6S5PPK6LxJyYJyDyiACnW7vuo1Mss	1
3487	2vb93ixWw8dzB24Yak1rLkQgLQdzS7dU3wWBPJ7RmdSamcdCSwrT	1
3490	2vb1GdsajKjD7y2QzycyucLVqGceK9tmrZhGqwDSGqWRyYdLWmDU	1
3493	2vbMLeXY8rTR6ohhFcydU31eyeGVyWA5bft92sTauBTgYNvN2qZy	1
3499	2vbCUtYJJDZvFV77HD8jv8ziPfepnYP3M73WUrsAE4efeRDeXNxz	1
3502	2va9X7gfTLcBoTQ7rgKtsqZz2YZjZMniHNecwabm1EwxFAEpdKb3	1
3505	2vbDQ1gGU2kgTWdQWKPmFmZ7n8nusEF8vwqCgCkQ2fvdKTTRdtZh	1
3508	2vaBXWpamhKmmGhCo5epN2dasHAX2g5xEZPzuTKU6gFdTDRr1isG	1
3513	2vbockQoJcSMikuko1WRMSXqtYnr3RwdY6qMrAHSpK731TkF2HRb	1
3516	2vb6m2WDJyNqwKUghEHgkMf2zGm4G5f61YjZHGxY1URixeBRDF5H	1
3517	2vaxD6naEMvCs9DUygUXcFuUHekVmF7NpTavY11ct5jqQN6ddnht	1
3523	2vaJdYzRA8XQiLttUYT1etcWixhR3jx4aqDZjzrF3S9W51tvyjKc	1
3526	2vb4Gc5d6vJqsittH66mWzP75vSvAkMnVUmjHZLkyEWJ5CX8Cmhw	1
3529	2vbid41LstDe31JuMiKAFY2U7DVB9qcimC3EgCfZzwvixNkNfchJ	1
3533	2vamAzBJmszjWFUJAX3614weXMED7jcDYcXEUpDt6MmSxHry87tp	1
3536	2vbWpKiB7NkTTAR3WRAo35Mr23aDa3RCe23QBfvXpfAEMQdzjiLd	1
3538	2vbbUjFSVtqUtbNGhTSi6LYArVhnxSphJQLUn63pmSaQdhanCQN9	1
3541	2vazMNwzYKPerzU2mxGNcoYr2vjiMcuTt2SXdYDhCitF1jwshxqC	1
3544	2vbeZ59sKW5Z5R9AvBty6Q6U3ujGLraNCgN7EZGWosAbBdoVW5c2	1
3547	2vaoCemGt1FVPkSdyAS3S6deytdu8y18bbZyJ7wfseYHqRcbL6Pc	1
3550	2vabBVBG3ELBEGidauUTzY47ziU9dj4Dd2wYP12uo5FstAchic4U	1
3553	2vbPnR1YwnUU9ZeHcoCQwGF86TwC7f4aZCVVjN57256P9H5Mr6Tj	1
3556	2vaUKRP5Fc2QK6wahvHCzWBzLdkjXfs8QGuwNimXdmEdtTxzCXzH	1
3558	2vbnNiaQuzqLScURzY647WskJLfCcemhedtyxSksSvGvmugnzm7X	1
3560	2vaAefQwNPZS8DDgzRG7TH328mfJG6bKVzAgCKzuELH3BGYyaWby	1
3563	2vaojEQ4aZz4RwzNwi6B6Gddj2T5zvGzBuqUfZazYPBQ9Tin6xeh	1
3567	2vc4BSFUR9hELerYxVTrCktty6wR8EWDGBL9VspFnQMDkfJQUNoC	1
3578	2vbZth7GjCXL42uRfpWGcSVv51Zuh3udhecrSjmPbBHQHDR4BCmZ	1
3582	2vag5w8wCRLu6HaGcsWHoNt4muUTHqfUNiZ5b53HVeLqEFqL2jXe	1
3586	2vaKZPVkYZP5cNvDjTnT5bhqsRaXgfSNBz2ZFZGmnjvPawdwTWmj	1
3594	2vaCeGyjX4hH6J6nF4E896NswJDb8EtW8dDaZUkTWMCUDUZtBSa7	1
3596	2vayygdU3D7AkDTxCp9LMWSWNbQkYzwxwXusJ6DogH8TKAQqtcEw	1
3600	2vbwh5Jbs8sddZA7Emz1WG44nBfFSDvWxwVQ8xBfMYgeUDMzqDDZ	1
3601	2vafEa3hDNyS2sGXQ1kdTxm9B5kpF8gMH34asnBqvcQdUjkqURrp	1
3604	2vbkHxKzEnXcy7pYQuRz5yN3nLoCc5NRZTApftoEq22zf2nxzZA8	1
3606	2vbhFvGezo4AgCvjecQq26SvMT13VWrf9MQzc9hyiqK4FqDjsyyV	1
3607	2vbYqGn3hbYaUYcoNpcjiq3DtBVnN2RX3AiHJ3Y8yMz2Xj8BwGoD	1
3612	2vbiUPJS2tZJ1FE47aBxsVEhk8xKYPcw6468setw7Hjq5tnzKu1Q	1
3618	2vbUTz2fCw5SqP6r7AF9kkJyCGUW6ZQZycjFy8fK1fAb3ngLG6ks	1
3622	2vaxx8v6R44ijeGa43qxcCYzkF6kP1XR7w5mNDUtrrizYdja3n3q	1
3624	2vaWBh5sATCocoVWLXJV3gwtCNgY1yt9DfZdPtnTurngR4jKAKhD	1
3631	2vbcfahHWMxPwnZV39GY3xKgk3cCYeqNTHKdtS8rmYJYKW8iwJ3k	1
3633	2vb6DGKm9aVJs63b1V9BsmXyi6n6AgHeV8uopYErkvzK8fVT5x1S	1
3343	2vbXTRA4D2kSd4FAuT3uFP8i5oBdMmJHCiCmFoWcuBveNcPKbwH2	1
3349	2vaZXCEsRrqLFmG1dVey8iW5L4Xj4SYqmUi9tZdJ6bNztH8byma2	1
3356	2vbT2aj2zUwWfnYqBaNisBi8xxfhbmTV4Zr6MhWFPNTQfMFmaM1v	1
3358	2vb86NpWimaPD8HfRtXjdY7uPVTzk328pWaMDqrk1KHBSiqbmgXV	1
3359	2vaAcWXQktexdQtCottv76bFopM6wnR9X6QZ9jKS43pf6LbnJhZz	1
3362	2vaFs2Gj16ij1T6rbkdpj4sMivr3WjX6WuiewG26AAdMENmqePuW	1
3364	2vbX7fmZk4bb8uaYUhU76Jr4BAK445MC5BTHz1Yu3B7rAwBtVBDS	1
3365	2vbkuFs8yzsgD6TP5j7MrJUDe5HVjmewFjLFsvC5jQZZVPx4Tbb4	1
3367	2vb1CN6wfhUwBtUhTiYLiTkiDwaeUxKLHUGXVoVdiCJFgq48w1UE	1
3369	2vb5RvrScjqNjFUpAbh49k94MiLxBgn58avfcqbzLZzGvda4oMgN	1
3372	2vbNTAE5AHUniZLBiB4Kh7caDASEFZhVNsxc8rmJetv2NHmYdJuc	1
3375	2vbfBnkuU53MXz2s8ncczU8KUExjtFmB4ovaygcshaVmwznZ8gaF	1
3378	2vbBRrwiRG5ccaWZzwHhdWZoCWEMHXyVQfx9ABVohaKpeyTw2E3y	1
3381	2vbA52Ur6ejT2s4KkLNxUe6PZppBaTFPaK2RKkrjUkZZdvLrrXEX	1
3384	2vase1r7e4ghmww65fDug1A9kzB6pCHTatFrZcviGqDQSE8uT4XH	1
3387	2vbtnCfjBFqvMD1rtt6J9kVV9Jh6FGSELHbQW45Vw7ZFzC6Wm1VA	1
3390	2vbAxhzASDnoDxiBU62A1otFx8847g3ng4cdqeSPzHXt38g6KXMx	1
3391	2vaqYuE4ZN3waXMAc15Jv23QYNA6EgSyUcNKg8uSJ3BHeCoFaLtt	1
3394	2vb597EUff2RFLDnyh5CnCRtXrYfL5Z3y4cM6g3VapMomAzHFoG5	1
3400	2vbdpr7dVTihfg5Nbs3WN18rfzng8asbknfXPzX2LEQcXuyyErhU	1
3403	2vbYfPrS1QzqcdUAKQMv5AhxUqyvsGXe248hn5nYbWnSqYiAcgfb	1
3404	2vahszyVAq775zrNTfK3urPetkVKGFjS7Vodcpc1BgLRtEYheSYN	1
3406	2vbYKkt4tbhBYSyXK3eBTe2XAYgymUV9SaqUKXrqRLC88Ni4LjgG	1
3409	2vaPkvFcvtQT14ZAEG3dExLDipr4pg1zfx8ii65b9r93gUba524a	1
3412	2vbUy8G2gXZo3ueqJ94RUYxZkXEk9epYEYfhcMCaYxj6w4f197BL	1
3415	2vaVnkumNAecjKX8sguvmsYagrebyQ4XiNJT4Yj852rEd31meHsm	1
3418	2vaWfZg4uifRhXsHJxdA46Lucnxq28SZqFbs5yqPtQAD8cQ6jzsZ	1
3421	2vazEDuZDz1HaNCv9Rv6ma51qkDVUN5aefQcnXtQUycx3bkMMY3U	1
3427	2vbrdhs9Vz9r44oi7PtgwY7oGsPnHa2g3FutoBYrba81mnP2buxS	1
3430	2vbdHzqkLVcUXGjnkuH4nAs7FrNpNa54jtFyUxKq6c2yVhdWXVEg	1
3433	2vbUNGamCEq89GjvCQRD53AFmM4eDsf3KzuZ1NuHnDMidR1X5mA8	1
3436	2vadK9z66y7YHDUYg6BXusgTW5vrhLorguBY3AD6uAzAEVYaeVp2	1
3438	2vaz6NKw7oyVHweNDtf41yxt6hXogpHgMZL6Gathcu4k9CHifoQp	1
3440	2vbJcHbQdv4bgNyF864jBgGKnTu3o44bPyKDq4aZDSwemneU5MV6	1
3444	2vaEeLzzMoQ3i2fcy2QTE6c7qp25K3YTcWoqCJNQLexLgDxGC9yT	1
3446	2vamzSAjUFr2cug41Fma2ViztfuU2tAPaxHGrBt8Akbm4QGKjeBY	1
3447	2vbyR1RG8mx45T6cgvs3MF6yesnqLnnHB9KYmnAq253pyMSJU1Nx	1
3450	2vbTT8kjbHdk8GkREZA7Rvs5nvJQQnjtfxfUugdtUHr95cuJQsed	1
3452	2vaWQxLmpYaQD8tioqfyCjFWAjYjrZkuh9zebhAtejRox5ie1NSv	1
3455	2vc1dydZowZRx1KSarQdo3xm1kvVv838T7V6Hj4jNX3U4SVAi8tW	1
3457	2vaSfpHcQcrGSgwtABk5fqE7ksnj8TeKQwCpjCTQtnkdHqqaLpA4	1
3458	2vbXVcHP3gTZYQaewd2isMquQ5hDnfwKghCwZrKctNrAvCiCLF1C	1
3460	2vam9GWuUUyuVQz7dBAwcrShdubUDu43j5VPL7z1F67gYB4cU18J	1
3461	2vaAkoxowoBTuBSMBaSLPJPDtcmkinmf7fuFNbxoDQ8efaah4JzZ	1
3464	2vaSzcR9qd8UxWN8kAUaR2a87EzHd39fkq5Bs4iaXPzGsjTR1em4	1
3470	2vbqCULdeVJ2V75BKeMF82stGRRa8veBR3puDZn5amh6jMFwcBxW	1
3473	2vas4SGsXRsiWU5Vv9PWMTB8zr87V8Tp5dbwVrs4rBU8jWtZHxz4	1
3476	2vb5erno5bUSt5AjWYRqH5LbV5B6bkXM4JmBign7LdaPSCUfBmtL	1
3479	2vbXCaqityDTgEcEpbnZzfY4ojpLpRweTmQbRx6dpmXy4krWm637	1
3482	2vbRmaBfBpZdWHU1xbKXBxWU8eaagUeUoaWXFcmiuD4ktn7zsxFm	1
3485	2vaJziPNFUWvkbQBRD4ngWMaCaFrJtYwKRbkGFPTFtAommobK3dX	1
3488	2vaZCE3iJ1tQAskooQXn8xEvjdGnGMTicX5fgD3y3dwAmS3RqVTY	1
3491	2vaEYX9SmUcJQwxTd6irnZsfGfiatZrvx1fh78rbeEFo7dvRzVHd	1
3494	2vanLVeYhLk34QqPDsdkGTbGs8cLupi1VLMxtFkyh2mGUXLVe9C7	1
3496	2vajf3BHPqNMid62sbEmGmLQargdvo5GtjayPBbT1bggg4xHejBK	1
3497	2vanej4R1u4qRYgvG8HeDUZqNhPahwRynFwDcA4UPd7Sj3bkXDMy	1
3500	2vaXazvMJgjY8v8i32qkfCD5rBYpsz1PYS9JxEb7xWLZh1j7qyG4	1
3503	2vbVMHc7NLfZkPEYwnLjMoZsL4Bv2F7RRi8Ut4sNKZAEsS9MwQs7	1
3506	2vaeUqP1p9SMdSkKeit1B1jBxmXXSm2Nq9db9UBu75Qk49YrRNzJ	1
3510	2vab16MpXdTMmjpNqWTv2LPTWNTgQphJyMSRpchGW7UMeiFPVxtq	1
3512	2vaA3EaWmKckx5GRq3zcuzoWtXAwSZcVzYmtAf8H3sz9o79aNQbc	1
3514	2vaB2MpxEiCqtu6fMcG6kWLPP1ZgT2CqU82pBQdBQ3Hi8UvtvSZc	1
3515	2vb7jwVVLBFM46LqaJtPcyYfuwA89y36h2NKMPAaj21hi3JPSiPU	1
3518	2vaSDzLLdoSb73psuP9gXpcjSKpqRjTtznm8u5u5inARHQB9E4ex	1
3520	2vb1aSKiJsfEzncoLhBjUTBs421B68U62fj9hZ6ET5keZwP4k4os	1
3521	2vb5QRg9dZs19WuqkguuEe1kyRNjcPnoE3FrJ9LifUbK51Qi5TKb	1
3524	2vb6ubUytme8AUxRaM3TBfC69PnTNzroRiRyPNzDzVBGJ9CzxMm7	1
3527	2vbP9tuL5FEApK7LzC8ZpbR67Q96chfbFV3AKwNMQc5iZP13CHdE	1
3531	2vaDDiPpaM2JbdCDyGEwEFuek9KikS14QW76QgWACEM6Roia6Zsk	1
3534	2vaK7GhRAnFHVjtTTfFMyhmGXL5GoEGvmdM3ZzfrhRcJjacPrZyV	1
3537	2vaJzMEgRx7LQZKt6eygki49dzh6XCatLUcFek48qS3Km3Lnpwqu	1
3539	2vbpwsEQc4j6A5y7p3mns7LUu7SNYFGGhx2ozmk95Ziw9FsFUjxP	1
3542	2vb6RjAYUbmpyD3FvHHkWLTXPGhBnMhuaNg6C5HoRQq43d1Eughg	1
3546	2vajkwPgJd1ycnU3iuPyB6fFtELLnCppVMFFmFTwWkD7vXzwL3ye	1
3548	2vazWkxbyQT9VNfDURDcKUWubJBTsphQ28ZsWiDab7bZohucmzRH	1
3551	2vbQN9xAEjrMTeyjqNcXPHTsj92s663yQXQLyuBM7g4GgQn1s1L1	1
3555	2vbNjPXCU6YHi3mQz65K4V8qnuCYfVwzbRK6qkcTRNSZg6k8FC8P	1
3562	2vbAfCKJjQxXzULEka5hr68zWG5ugwH1LmDADRD7H8moNM2jBsmL	1
3565	2vbEefHkgjWda5Cun4RbZHJ3pnooRFMSkYaeiQnz8CW2owbERC92	1
3569	2vbd7i3iZRxPs6YbFcarKwAkEeQRq3YmJd7KFeKQqU2SV4VMkNhL	1
3570	2vaTxhgsoXg2iRVZxjnBudrT15vz2j5iTb9QH8rxEqqBiWny96XM	1
3573	2vbZYH7fKSq9bK5aNERCQTWNpQhbfoEMnHUJXhN6RoGT1Be7Seaj	1
3575	2vauxVFU72t9qW92kKN41tVsoDdCtWQ6NrwMpc16VMezsYyefwfE	1
3581	2vaWnyv85VbYB1uJp6b3VWgoG9tk2H8SupgPHY3yRekxKJij8YNo	1
3588	2vaTMV8FRTmPzxdY1h9rfWokYicqkKFFprCcWXoTueMQMk4cSgJZ	1
3591	2vaydVeYktYZnspqtQJBeCxDyJ6NzK3qAYwqMjVhfsNrXAtwkoWw	1
3593	2vbM58JjYmR3iFMC3NhkTab7tL6EH513GQ6GSMAa9r3d6vsGDX41	1
3599	2vbPaQzsCJXzEbLqQHNNW8U34RoiAemWF7aW9AhbEJTzb7mkrg1B	1
3344	2vaAAAwdLvCakxFKbCZnnzYY3ftxZ9vEs6xC4s6pXmPdNx2mFqSh	1
3347	2vaPngMkMjjLUn5wMQPA6woXMW4DkHVMPWJWpjgfsWDXvnRN8zuj	1
3350	2vb8kZ8TNMaaVgzo8T2FZzpVf2gVJFCCBW43wcEqAd5MQQrcRkQS	1
3351	2vaQWCsoa8B8BoohT8WGLxeAyG25BT1LsBKsqEY1PXeyLzvCLt8n	1
3352	2vbfT3rJPLjqnBbtQDzvnsT4RWVd2LwJJ5atDgbmV5r3y1cMvNhn	1
3353	2vbHMNuvY92iVi9CTA2uzwu11bt43FZ6JMoyR3pBLVy4xirKGe8e	1
3355	2vb35tvE8o2eJfhyujKxFnjeVbjfZXe7xPM95iigrhif52TqPx5f	1
3361	2vazQ6q3L33B3RRqDYFr29GharkmevripzZm7ngqmdfiFNwAy2RN	1
3366	2vc4Mw1evK6kacJZaW5mdfoHTHvQDWsYpVFJPssGsqdC9R84zuE6	1
3368	2vau5C9zTAF1rNxznZDes73UpTeTUtyj491JSZoHAdiz1ACbyhTA	1
3371	2vaShF6WMqAZ14YRed8JEdTEbmohzgARpAobfireUsRaoTKrFEiM	1
3374	2vaM1HXu2nbje4WRwL4P4GUc4cBGvxaXPWULKd4foSBYQZvWgrdp	1
3376	2vauYNJrekmxSSM8Z187dCUhEePYCipe3KpZUE5UpjXwWzyX16dH	1
3377	2vaA4n8sBy5Amf6wnSGGfXXeFjELvpL9JKFv6opUqCr4A7PawarW	1
3380	2vc5PRNz1Y6P2pYdVxBp77e6fci75GzkDCMwz12eiZyXuhfUph5c	1
3383	2vb3J2ckCM3H9M7EhEPLFZr2HY48SKzrG3UtB13Bxjq4mQumwTGF	1
3386	2vaQuZgVXDTMFgLBZW7zHxgYrR8ZtNt8ydtzPm2YkBZfjA2HiFYy	1
3393	2vbRh1NJ7JXPj2PvDi81uR1MNpx6QH1wETJpQanDsTGgKumXitat	1
3396	2vbQK8zRqbJtup1ruXDDWtitwB332CpFH1oJ8UyE2kAgWKTLfQ1v	1
3399	2vbxTCmP1tsCK68UYG98w8zDd6ShZ2YxvMtqbx7psXLQsXphmB2c	1
3402	2vatfAEASkRfhTRYmM1MZRXFUoSoC9i1ALhY9cB2K6Jgk27sW5tu	1
3405	2vanbzQuZXBQwRtnXH8mEFopMaRkbxBhHjY2Np9sN7VwNFvfqrzm	1
3408	2vaCgh6efmn5zLizLNR38uV9AEfByW4sANQs5aXSsoqjMuEYuxi3	1
3411	2vaPPcYP5ebWzSVkxHKcaY7LoCw4GSVrtu1uv7BRTKqP279rgEKN	1
3414	2vaynbeh51KG5VDTMnBrWX9YhzFPCbBbLd2KDEzAcDDz1qLJ8Dre	1
3417	2vaXvtuB43ivJEsjtQQSyGzEDbUW2ovreRSGaxqEtesctKR7VBcu	1
3420	2vbUgN6h3DYWFMxZNdNJhjDuJhPEG4YfgS4DHqHCCUXE8UexNUU5	1
3423	2vbYFDwQvhdg6Tgvv1yL4V4CNiymVPrtMyh8cqSALLqw2FExcGLM	1
3426	2vbFwhBoJDUeFd21e74ZLmKEmVTWdsJzi8JSgT6NvXVpVFWHYVr5	1
3429	2vbTyPwXXkFNcTNLa7eKC91cJ7HByChzUcbV4B8smjhDN11dPngg	1
3432	2vbXysuu8MJCbDtjd8pA8etsC5tNy7NtVtMecAVvZyxNHbxHxZLL	1
3434	2vbm1WzX6kkiopo1NAS17o4xmazCt8Y8T16oQH7Wg5H71KSUxNKT	1
3435	2vbHEA76sH2emLSos7eqMR486SvMw62mYmTBJP2vu1qsxsEZ3FLD	1
3443	2vb7QziJs8ECEt7QDYQLbTaL4JjTP3pnwEncCocA2VMeTzq5W39F	1
3451	2vaM2U54QfbvUKhPTFyXBPuRJ6WbdVVP7v2ugC9Y5tbTxreaNQuf	1
3453	2vacogMZjtHpPdPwui2PGALZT4UZLAWM48NrykwTFtKhnmJZNQtd	1
3454	2vahzyfEyh6smTgrygECvjJjfXuKKzUZT8PejQh5v1VUUejMKaUo	1
3456	2vaAZtbm8e6bFL861AMpL6Ahhn3gwApSnjLm94QG6Wvkp4Vzw2R4	1
3459	2vbsj8PQTqGaZaYMx56ae1AYpx64rnEhw3zvCpZs7s9gPRgCFTri	1
3462	2vbb74XmPaeRHSPQKptpERvdvzfGPcd87bRYr3MAm2R1AV4J6ia6	1
3465	2vbjc1noPCnkr8aqx5rSiB1mrr8SNnvBpBQT4E1JzNKYbHUh1Z81	1
3467	2vbLbSAvL52ZD1taPYY8vBHjCxFq9UJsuA7NxyZpFodrWKqbTSVS	1
3468	2vb9Nh37j21mQZExVzxWdNVGt8WbGtTasrMh4k2cz9ZcZvB8pff7	1
3471	2vafG6V2H6FDURtHjchWr3zWq1XaNvGzQKubMzUkxEok8PKABbnP	1
3474	2vbmfuqhmAgQw82yC4H4BkN3Q8mMt7D1fx7ZrnADgb8JZtSMUbWJ	1
3477	2vbk1BYpB2Kx4C7ynJ2rxDo3BawKEtBJsjFFZTticCy7C4Ai6Jsw	1
3480	2vaojTPFwqGTu5XsKF8soDt6XheK2WGmXrkgv5FLoEY2rmDzejZY	1
3483	2vahaeDkEBteZbpLCf4otrA1E8uNFDxnfJmtX5wWXMiFhCf9acCh	1
3486	2vbTBf1Mq9aUcP69WpStGWD87peUsTjSjPEWuhkACdqeth9xVryr	1
3489	2vbRzUMDWmn3m124jra8ao3JYeBrjBPSXBFxZYeAHSDd3edZNaED	1
3492	2vbkEqQ3CxrbKWVqmtphZnSwah9bF53WVNoCXVBctHV1T8UoA35i	1
3495	2vbD1Jz7b9T7jUi5Z77wWymA72reJpKfXkimYwbsue3aHL8zeeQB	1
3498	2vacsRr2TkUHbvFzzaoteUNz6YiTrc7gnGN2yTidpi32rCqeNwd5	1
3501	2vbp8oyhxvozvJqydM3t9jBqogGZRbJCoh2tL3Hcdn1LhRTwBsZz	1
3504	2vbgzjSXMqbjkt2EatddC2dJcGGG4RahWXvaC5YkKZ81gGrNHwAd	1
3507	2vaYkwQ16wv9YaeYfwyN7Cxs8gijViMKgU8NB8sPUfvwcvnfn5bf	1
3509	2vawtnG5uFCQXUMwj77WTWNCEZDHqDCXm3BquDJa9yRUcvN4MeQV	1
3511	2vaXpL1aaYSN8qt9AvMzepG6rSJZu3xko9amwmcDDtAikTKZwtN3	1
3519	2vbd61hrizL9EhZvTbFLgZ6sj9ejZ1wQtWgjVuZeg3WzhPxT7ZBj	1
3522	2vb1j22oe6YCP2S51HM4GAvFgXStJhtGYNtMdg6yuXbMMQHWNTpD	1
3525	2vb8a3ZyZsr8KBX96wiW2SgVGaafpDn19nTbg4FNoXbeqbVEoMs4	1
3528	2vbFKVg5fX9eQzrdVYQ6S3ua8xFGrYn7YVNGWxK8u5LcDgNEAGxC	1
3530	2vbHCSSUMkFHnnssNGaaq3xUKgQH3tAVsZwZzvcRHdySuJAviqqv	1
3532	2vaYyMvcQxjJepBGJgi87284XNuksdvw9MRYieZnMBG6tTborx2C	1
3535	2vaSmrRiSUnSCGdKn2JfsymHJqqoJxB2SeRj4z4kkwQNfEbCtC6u	1
3540	2vbHWzWhiDszj7t6PD8djJHor22qfNAPiaoaHfTohWPat4G6T8hH	1
3543	2vb1dyRbvq4zgTizsVw3cVqDB2BgAxEPnrX9cDc4HN36Za1FJ4YE	1
3545	2vaEMPeSPsMK1NG9cqfKJEPVigt5rGfkQdnMmKcB2MdqhTfavj1P	1
3549	2vafvzmWaWGqt9BMW5uAWK82x7R6MrWjL7KGoH4sBQQH6dMpvhXd	1
3552	2vbt5PFCP9p55cUyPZGokJm7YCeRYEKY9rjxsYCmhs9JmWd6N4rj	1
3554	2vc5mvMdhaaod69BiLfbBrEADkUENFTjjLfbZc2BGCiQjNriLfvR	1
3557	2vazkyNvha1UZd54XtSnGA51HF6dJBaCuforUvuQdBA1336DeyPt	1
3559	2vc1SSZm5M8icLjrada5V2DdNWJRHDauGhYgmHY2qSiJCMt9QA63	1
3561	2vaofz5K5Ca57rh4rD9PWvuynqXghtPw4jCn8Z8mJRSDhbJdwkcs	1
3564	2vazj4RLAMJNZs6Kq9ds59MbHXR1x3AXqyR3qqGSNGXnTpJ7rS2e	1
3566	2vbyN15fmMey2Fp8o7Qc7tVUMvWsjrzFo1y9vXe8YNwK1vv7KZQg	1
3568	2vbndkcKZabG25Nhq8Z2u1HVMTZMjNaaLK6ZduVhxPzFGcum5Tdx	1
3571	2vbFeM88PBgQHpQ5Ga5x9rQVMgKHdd3TrzKEzpKsHPZe93xyLGKH	1
3572	2vaqssFJdZ5ugMZDBCWPxYakwPxv5dTWaDNpsTS8WPcYmXSSPpdY	1
3574	2vb5nTYWr6oeLY15vnegafsYzZVENC1jun8Pz12k88DMMEy7oBAT	1
3576	2vc5NgHdPeDUdrPNzmdPiCqHSthVv7aZaNujnEevr6n7NxVbLoY8	1
3577	2vbgQxyyi4ngGft7Wo7HcYnSR6EWCKG9XrXtaMGDKNyDtLyeZ3ra	1
3579	2vbpJJVvo8X7NnMGTto6KmkGVQR5Y1Tc91fQgTzgRGKXAihJGRA6	1
3580	2vbxZLQtJ4okP4QQKUKov7dQq2bWtpvuqL5Uw7WLocxZj18DGW2N	1
3583	2vaaGAAcZHfJw2ocA273psfWNsQw13TJHXm8nKoaBYMh2L2MXzUf	1
3584	2vbXdQtPgMpaja8rfzKR8FsUsdN5zAw1ozMKUqZ3rv26e11UYQ5G	1
3585	2vbhA2r1HhxAeK4J86QgVzLTU7PCTgMaRzJPHRRmxBGGJFVfC57R	1
3587	2vbjHvysQC9RfekGwpW6DHtzQ3swtRhZZQLcrNMzMoygUe3bBScA	1
3589	2vbxej4x27ASChLGhZE6a8ZCbDwy5fpVk2DC74En9PU5oiPxXas1	1
3592	2vb7nYCA9SJKRxuqR9sm5nhAJ58Sa4zhZMxmde6uxnA1QjVid1Zg	1
3616	2vbrRvAiMbGr8Q7EzRQKXW9TMCYwPex7ePiG4ToJ3uoA1RNeJ8Vf	1
3625	2vaDP9Vfn6mmCLbtCPaZhZ491Jmtzd3WkLM9zeUmP9QvhVr4rSxJ	1
3627	2vam8Hb2ZsTyVr2djhfVxXd51zZfmv8trZ4QWLAjqgkfjGk2sSh1	1
3629	2vbwkyFZiaVccqBuxEXytjjaSAiDBNa6VYyFPEwQ8GpCNwEHNiU9	1
3640	2vatgEkzuEuCoSKGVGmfRECP3m5L32cDGeAdbnb1gT6ZV3LvXZFk	1
3642	2vaGRQN34wKZFn4wL9dR1Z3WWLYUMzDXZvd11i3VSTRnq4LMUAoa	1
3590	2vbcNu1eXijPxd3Bcb6ARDV4MgR5vGNHU8WFPuMzgraUnaEFpFfj	1
3595	2vaD8YEScki3U3kHAqkKQpvpmZSgJCHD5LggfFiaGgdTNaGpcduq	1
3597	2vb1iipYuetd9u8unbF3D5GdEajboQ4Y2MYJywNUw1H4aWfeSrSh	1
3598	2vaCX8rvUWE2fQrM5Lc6JJsHAh5AVf7gDz6k3cML68PerWofV7Fy	1
3602	2vbPo7CkF4Q6b5yW8P6kdgzAigjiq1siiX4J4uS9MRoQ1BpDp8Rb	1
3608	2vbotQXz9TnhZz766Qo3Cp5EVqfay1FLc8d6ZAiiwJV9CH6QMyge	1
3609	2vaJKCY3MHLtGfpTy2ynQsmZLsjcW2dkuo7C42hHvk73rhMeef9y	1
3613	2vbeAs4kUmFQaRhNn3M46vCRmvhr2qwFbn7tT8yDGGJhLQAEbw8M	1
3615	2vaK5wwte2mbQbpkrAXGcjVXgAvXHQp4gjCeLsiubj3i9jZCTwCH	1
3619	2vayzSo6xGfVQYXu2ngFgR7aBXcEzjnQvcfrUmvcHN5TkcxLyAvs	1
3621	2vaweuQKy2NDXh8eSjyDhhNJ8z5xzeHuaBDUvsfuMvDeau9ShN9k	1
3623	2vaMtaxVxXWDGFkX4tsYsscvmm2VpfgVNQRC8iuKiGz3ow2DnfKy	1
3626	2vbAmnpHE78jVg2F8M76fjj8WWdNdsiF92n7BThiP8K7XFhbM1WP	1
3630	2vaeA9DabfRuJdwiYHNVjUKjVAUSkSydKfPsgUCyaZVioCop8Ff6	1
3632	2vbvnF1EkcQw8vXPMMuXy3puZ7Pr5YpTjHZxHwHb7FrRvSsL3J9C	1
3634	2vbHQtG5dLVsyyBYokcgcA3iBUaEmj5kfwDNgSZJFa6BYaiD3LP8	1
3638	2vasqEMAuqmSBDyMBesj9yZYqH35ie1JM5xYfc5fZeLRYxfA4Dsd	1
3641	2vb1P4nCgN9w2enxp8JjEjT5PCkYfP6UgyGSee8hbNZzNA9Pm38L	1
3603	2vbow3jfL6vZevVTLix9aVnYm2dFUrhYSNJ5nb3gmhStp9PCua72	1
3605	2vbKyhsV7qpBxX7tY8RajMukjQfit6vkw6ScMWGvdbEcCtKFc157	1
3610	2vaH3o8hXPwBTCqXFtMm3LUXtEXxMTCMgvUJi4DQaVQt3JoyEp3M	1
3611	2vaJAxBf8D5M6Ya4P7GEgY3PJBrgvUNNTcozJ84QiG54jiDPL6pq	1
3614	2vayWrYUnHQUuaXYS4H4xhD47acQagbyftGAuZ8n4YQJYwGki665	1
3617	2vbgEtZgcszNMtBWi78VmYbRXs7pGC2Z51txkKbXmcCedxU8Q6MW	1
3620	2vbcte1jQUhjHpXYaMEJE8xZRtRrdwvhAcKxeaBZ3gSSSfZQsPVa	1
3628	2vb1PmZjnVZ8ibGbQSo3buij9GPMMD3unEXF3sSpXQvnv6umHYYL	1
3635	2vaEJXhreGUML1HQBsSYsEJQuatWD55U5kiiHENa2eyccSnJZ1aL	1
3643	2varE1HDc8ZVJzbfg6yp6VNgJEwPg8jyLwSLGzw2Xhm55wgDxVEi	1
3636	2vb3ZZwqp283prAJX39jq5xX2kL7VBzDupRupibmS9yzAxVZzDt9	1
3637	2vbxuchCyP1DbeD8D871pqLsybRJFsHr7P7PaUX5MortA38VAW5S	1
3639	2vaDtNGwguKKJ1HS6Pgi5wYf2R2bywj5AyCxbqnBuU5AERdGFskk	1
3644	2vagsa23c5jkpn8pBtx4wyh5UKFNsEpY8A3g1BHabrXmMY8zcP7d	1
3645	2vaawKC5RbHFTXP5BzLjFozcgEzpRicYb146kndX6Arfw958orNA	1
3646	2vb1dvDTa8pba5JoGpsEqxvKUEoH519ji6QmdckC65gp7iaJBS7i	1
3647	2vbYSr8SumZRk68VxsYagcvvfZWzao6VeF7hzyo6tiJjbiTN9oVj	1
3648	2vbkQzmffQHJwXQCipeS8HUPn6LonHiXz4Fd6mjAevt1EATWNkZQ	1
3649	2vaz9kD9c4utm8kRTUqjEyCJ7mjCgBAtBztbjCsC6gHsEhaYZqEU	1
3650	2vc57Y7JvKZ5pcy5iwEutY6SXMhYzoc9pDTpk2FS1vQ2dGC5TDvi	1
3651	2vbZ8RFXapyBi8dofDhP4WJhwzqiBYSzAJBc799SHtatzPouw58z	1
3652	2vavDv9LJbczsmH6gXF4gyok5E8F3vCrFAeRKgSVcKm9hoDRwTCm	1
3653	2vaUUjY2ycvoLHVGn2h8aLfs19W4Zdez6CAkMenrG32QDPDtRNcB	1
3654	2vahT5xBJaMbQ1mPQypuoayFAgCkyK9sxW4zTeRjt9dKFKxttPDb	1
3655	2vaPaFyCjKXN8h2RGf9i1hBGH56dRStgz8GV7xDiUbptL2PrKRqs	1
3656	2vaUZGZ4yEd7hEs6MtThhKhL5DHqdiGmcD5ExvJWhZHahxM5TLR7	1
3657	2vbrhajoqXUCLd4vZmQiQqNxnTVairkBkK5jf95YmSiP7Ar75X5r	1
3658	2vbXggCDTZtHURxV5fPk9RvcCqAXG6u3EKMjzTUZsb7Qi6ZkqHMz	1
3659	2vb7cNU83e6cnvkjSt4B4dD4FYHQ8hzGjLcaRHrAkFJiAAGgmcwf	1
3660	2vb7kYDirUyN8EJCduPGvyUjaRWGGhGiQN7xLsWHXgNFgeCh2VVc	1
3661	2vaQ3KLpDkgULNnrunogNJfhqKxzTK5wkvJiExbcvYXot4YpGzPW	1
3662	2vbMfZjqw1vtjAf9BVKxBdpDsdRGM37NF6L1fg2HKrP6Zp3uAqPv	1
3663	2vb3Zyd8C6x79dT8v2zw6kAAsyVpExFCemc4DcrK2qRCz2HKMu5R	1
3664	2vadhA9eviLsMwK6Qj7n9246YU8LVoeb2mDDKZWgtUKT3jL67hXL	1
3665	2vbk4nA3A1rWJvS9ACfi3Tt6LCnrc7iXEHw5Zqr23xoGQMLAPfWA	1
3666	2vbKYfuordYEkABBizShqSjTs13iysAfjPeDF7JfRJcGEvFSxfi5	1
3667	2vbDu8HD7atwkhKcVPqFFJk3HDiiVUxvUMgS5eaYWsP3j3bi9deX	1
3668	2vagNWUd2J59YcL9EG87eFRxLfjSrTRh8bB6RfsCm1gbqrh8Guxv	1
3669	2vbXsLQnjWfbGaAvG8tbxzbPWCbt6V4QqixtLxNdpcHyUpqX4Qz3	1
3670	2vahcZLqEjT8wXhnsa7fecFRZv4d4gLp9Bb29aBrZQPRDtw4kGPR	1
3671	2vauMJ1gSZLwBAB9y5189oNTjW6ui1ZiqGC8b9mFuBXLGfsJW2Ld	1
3672	2vc3KRPD8KmnCkzJZTaEBCsEwD1eVY5zFk1hcJVzZuu7T7KbasgQ	1
3673	2vbpM5v662y2LgKARA9SxUk7uaJs9Z3MFoNBzhBZuKj1oD5R1iY3	1
3674	2vbDh8sFp8xZVC1BwY9kbRzQdV39mmFWm74VUbUZZ4rbSExECiCG	1
3675	2vaxzF4FnDM1pRCHVYu1wN143Dz8ZKVHKQ8FHXsTBp9wBd7LwXf3	1
3676	2vaFFmvERmZVTSgkVSBQVPo3FrZpiGrhqzxDw3FToMuosMC5hqFi	1
3677	2vanU6NZhUeCZEQLey4TBhNRum4k3Zu9xyCdH3QdZLnzeM53A338	1
3678	2vb41dupkumGmuuwxyif9jTKyQG59X47KWMDThexajKHgoxaDCbf	1
3679	2vaiDaS1eaaKV3BPGjF694U36ZpCvj8qZE7H5XhTxu8skLt4Nij2	1
3680	2varGoWoBBWZnr6KkYrT9YPWvpTfVkBwAkQ2hscuizqF1TeZEtjk	1
3681	2vaNn5rj3DLVApFNaWRZ2hiqBgse1p4oq29CiXXq6z1uuTbWY63r	1
3682	2vaTZEVgPES3o4o9NV7e6btG88oBEBvLQVmnTzn9MYdXAh36bRtT	1
3683	2vaX7TExAjLsKBrQ6WtRRkFR8Z61Zxco8b3rWUfN1tbiorkALh9b	1
3684	2vbjcq2uKrtYwaGzJ7txGst7Hn65PCWzJRiHTjBkWzxp8AJDAE1e	1
3685	2vaBZsF8NyiSBodDryGhyrE93ARbwi7w8vCQvZWYX3LfDELfdEqm	1
3686	2vatiQRMXmoRf79M8q93x9yST5K76tnuWd98Q38AMBHqwYzP6jDn	1
3687	2vbEiN6tcdQJsWycxqhsEZdqBjrpub3M1DGoa1uTvmSMCE45yRFP	1
3688	2vbGHVjoSGNnhPG3r7mNvqMNhniDMReYfUP1WDxtvxqXCQBL4i3T	1
3689	2vbNWf2dz7E2smox4pko6SSmniNkWchqsy2bZbdu1koZRLfgQ1MR	1
3690	2vaPErpiAaFVns4sW3QmVRbp78y6Uy6K7t9Mxa1zyNoGfK4Ret8P	1
3691	2vannneK4Y7CZFjgXBhUxJPA6JYNq9xJE2XtpJLvr5aDpfxeY6LW	1
3692	2vaNhTEW1VtwZfTZ9xtPuUxSkwT322KTuhmnWWJq3wpL8yqCY6Wh	1
3693	2vaHGE2jzN1KzRAQnK4Jk1Nj4Tr2qoLrngDc9AFvev1RCgZW5VZL	1
3694	2vakQnvpWy6mYuv22L7LXZGh57f2GioN1RuQFsGhFLkNFsgDoFeP	1
3695	2vbdqwqyK4jmRLUm2voGsdBZdToNtuixYfqgNS7USJkhGVXyUETb	1
3696	2vata8UiUzj8bghAe3cb2AJrfURaTLXLmHxXd7DJdHfiXhbYDdg5	1
3697	2vahuEXxkLFKZu2SixUr5nvwEZGZg7bdk1PECTXfzJ3JpDwyqLkm	1
3698	2vc195F1MU8jTY7Wvu7yZAzfibJmGYxCYJGBLUmEYTSpd8ugqvyK	1
3699	2vbDUnuwbPutznB5yyxLmNjuA5i4uZBrTDMUAUJ7AdXcuhYkBLSM	1
3700	2vaezv1yozTkWmKDHtnAAuH22GFvmQxBmYcD8A5WjaDtbmuwV3Wn	1
3701	2vb5tKLAUZi716H9Py2sGue9VtPii8uYigxYMTU37uGJSRULfoDK	1
3702	2vbQ9uLadU4sFXRSVazhrZxc8GX4q4CYVGsK8JdsKNh8KGy8o8WD	1
3703	2vaMaNKmJGys5M3WQTtB6Kq5CPK3pqGZKpvnqWbGmy2EL3DLzkU6	1
3704	2vakKTuACqvEQcMzTjQe2fHobjnRBhYGZWdR2EAxxJViWDtyqcWM	1
3705	2vaHZFpNPNwSRJv18R8vzacPCYU2yKnQUHvKeagZBmBYrEoQAvj3	1
3706	2vadfz7AGPVba1YZd6EQqfpV9TyDiPM1HNXHCiBNJSGHTfWm2Pk3	1
3707	2vbeEskrQBY9jYuonT18DUNoPDPcmeWK6KUM8fjmNkpUFz5PDk9G	1
3708	2vaQYYi94P7ApwR555mFk3nnpofUFU5SMPYR2JuTQ19t6EqRQd1V	1
3709	2vb5R2Y7nm6BLRH4UmiVG8kpdYCx5L8MDvQXDeZrDvTGbsUZ1HKs	1
3710	2vbN1ZsVGr2iXpmVZAvm8AEyGWGreUNaacgEnzJAbvzU1bsBAHp8	1
3711	2vbUbLtCvLkDAoJ1F6AjHnik2BzKZvRYVEgQaruXR2xKKCNFJkK6	1
3712	2vbbXNY4Rkxg1gG7fkWdyEE4zE57z2CnPJhzYc5Zivi2zGFyfG3H	1
3713	2vah4zLk5Uz89hXgLwDorRL6MAXzCozUecskAt3BaGXhZeneBDqh	1
3714	2vbwUgQns3Ez2KL1kLWo8ii85nn56n7sHFn6qcLouKqQZATunXxQ	1
3715	2vaWQeXwX8gmgFM9574h4aNTGSa5fy7dRuU7kumiwv5s6g45dWgr	1
3716	2vbzNSogaGdQ8nhvsFoUPATmhMF3UPncwwUhoHYE7ZoPBgKvX7uB	1
3717	2vbEFyDhvFVxHgqMc2gMgAmC77sJuauaFCknHvShrU3hvWhcQwsp	1
3718	2vbjb2JBhyYWbvtCC2sAeDxs81CZd3itWYbXR8wqdTfY4jMnqx78	1
3719	2vajNFA84hqMpGaxHFGjmdkTnZGdWoucFkWQYN5aDSrMsLdTXo5W	1
3720	2vaf8THWznDZiVaxnGUDeDWedr6X6SFkPnDyQ3FdQgshxRKSKqJb	1
3721	2vc4zTf7RceE4AHmM2JuuDgLdaCCtL6so5p4Rn99XweK1Rn3WU4W	1
3722	2vbkTACXmXf2HX2mcNVgzKwdsyMRimezeL5k1QTecY3Vb4esMRHx	1
3723	2vaHdYsa1J4FjiZQE6nUgLxgjetw8aWrEzwToTSrf1PnWR5AMUFJ	1
3724	2vbf6VCsppAH3kqrRrYxt4j1sT2xggZ7AwdhJuQT1BU2gXLBeaNc	1
3725	2vb4HSEaL2KrXioyazTt38zbaTuv9cfWp9x5phSpLrTf81DZwSgW	1
3726	2vaMTE8M4LLZ62axipnG5dMYGCrNr37dNrWXzpm75vUmM7HYeqzw	1
3727	2vaRn9QqQPb1K1KiX7v7VnZHb6WhEDT4nUmDprq863dA53antC2B	1
3728	2vaMFUwRnYfRXAqarhGwXCYAWoKEfHtkmDnDrTNCmy9tF2vRjwzy	1
3729	2vaKHXhGGBTsaC7o2iQVVCZgZSsE8CphXz7ekAQitnzNm2pb8rMd	1
3732	2vbSfzqEFZscuW5MYK1xGTHqgxyWagBmQbt5EMySoPNaCBAtWYHF	1
3735	2vbbA4dXraatrjJCM23EJqVKeQMoBqqxVaubKbqFbJnwyd545VP8	1
3737	2vay7zGtGCj22cTe3wDDrSSNQRCRkj2MueGK7tP1Yp9M9N2rQ8yT	1
3739	2vaggLNVit9NBdSnw5SFiwNrsy39rYyzc74BfAtQPZcfKCmUsEW4	1
3744	2vc4inA5H4hVQVLH6wxC9Utq4Mai1hnt1MGFZSWfVQuSaT3PRt1i	1
3752	2vaAKhgAmAZmHsKVLUXAhrTd2ZQbVduvpaVfZeJrhkKEg6Dfr3nj	1
3754	2vbzggGKVDzxm3vN71LWjUayvcKfwHi5tNmfUjmZriqBamTRkuzi	1
3757	2vbM5V3Tky5fHbjQBQt9jwWfAuCbq2wgiXDrnkSiGv92dBq7iNDM	1
3759	2vaxsjZ8f9Vuyw7siy92aUMUv891hLpbngyF49KQJ7bSyEvoNzqA	1
3762	2vaDmNFkfhXGrAqo3e9zphpF3XRNZqEZqueVmmL6nv3gg51VfTrd	1
3769	2vbo2WkZdALZeypcbRD3EZnG2XXRXE9dXYgURSni3eziMeiSghZn	1
3772	2vbm8FkP8SkRUkvQBkt1oobQM3QGDhQzHYiRYqS8JxhRNoVvd3YH	1
3776	2vbS3Nq42kznq5GTAqwUdjh3D54EmJDXC5pkunaUVAeyTj3YGyLo	1
3779	2vbvnirhCnegamA7R12REK4DaDBdfmH9CtVs7mqrBSjPU3tN8dtJ	1
3782	2vaHPPWgBBwXmmsmYBsg7G62WVSWfdyUoW9aeycFBUtxr4jBhUmU	1
3788	2vbbwCdbuP45kKXony3yZRHhx6uazh7QxXex5iZZcSS85hj4siZd	1
3791	2vbgkyF8Qm7CBLD5ZGNzop14HNKk16oM99k6sJJe5EVAyFnxq8mz	1
3793	2vc2vQVjbETKZtVQkPmPymbjH414TaAFXn753FXFMcVVMiCZheiM	1
3795	2vb4HqYFV6nh253d7H7zDFJnMkXZ49ZdcosYkzNTRubytSbAe9E5	1
3801	2vas58KM1D9KQjNwBUnKF8VpQjPLcvXrN3pFYiEnRicRb1gu6djv	1
3805	2vbq2eRwwErt2e2LVdSi5zLeLbAChPa8VJio9F6sKDiNB9paehkq	1
3807	2vaR1cmgsEq8qRGmKSeXWufJCQCuhfTi5Cmc9Va6kGAV8KNy9hcG	1
3812	2vb5AE7aQYTpyjF88GhB8rWJ5PDDk8CKGF9dxzyvvNV1vSmPNtJ8	1
3815	2vbmbzhCD2kwU2vcCNPLeVUu35i2eFQPa2oSLZtDzdc8j2aPxvPK	1
3817	2vatgEqSUKWGAB4Go87fkBCmp1iDQpcvqtVmhWYWPSZuJHGFpih5	1
3820	2vaPfoNewBvwQgibbMTUnBgC1VFWtQs9JJvvvSCNammFaguGWEkN	1
3829	2vc2GfUjHmxFyuLG4uUjgBLVMV43TxxYaJPspvfaGHqPMFNcL3cn	1
3832	2vaCXKXH2yHy88jXBZtqF1DEr3vvJBY5rwqiZpdAq5u4JPdMUj6Q	1
3835	2vaVrR6GN1xxMbRKQVc6Bt6mYkDgS2kw3WfYerbex1NfwafZEFAm	1
3837	2vaXNB796z1WujEYBqieQU2wuraNQbuoJx9DbEvioZJgKSDv5E1m	1
3840	2vaVbTG32HWZdY1CiMZtymM3zRbWitMvefnH5ykB5RB2mF8rxwZZ	1
3843	2vc4DB9qj4b5JWkkV49xzCk1PxZNLb4HwBioVsnHUCCRaLB2FHEh	1
3847	2vbdDjKt51Lbr3M76wyKHVYHq1GwdPzPt2WvuP61etM8h4nDX9Jo	1
3852	2vbs8StGMUJxDhjtBDfu7BSB8Gqwuo111TzRoQnEbwR8ePtPyquS	1
3854	2vbvzEYkv28EPQwfwnWZwAgFaFb8hEwhqGkUdcE1EUJdQGgvmtb1	1
3856	2vb91XUXpuj4qwRmcAbSMgsj6ocqvEuLuBqdEYX7dbbDDeiD8dBC	1
3858	2vaGZZsxV9bUc4SmmQQiPN4G5xo7CTjPbTDZtHERm3GjpxhvS1E7	1
3861	2vbu8SB5JznstrkRZZHUsA6QosWfZPfyAuhjnS9yR3umAEwPGPzB	1
3863	2vayVKQrZgT5SHajLPcQg5e1nWZ747bYyPAQgQPdWzRrNhV6XhmP	1
3866	2vbfTnFjHCo4vCLM4HjLWFszjTUWQZg79593n3tDVnHiPYTGo47d	1
3870	2vbvxCc9Cdzh2qrhLhPggbDqizdnacn8WiDA1FZ2HNY99agZzeNm	1
3875	2vb2hdMpaFvQr4Pby9Lrg1mXdjyqQNz7LSgMBT9uiYMzRTq9xHRv	1
3878	2vad4egdS1TAAJvUoaYVnMZkWnbPJy8tEQKu6xm49KQ2qKdNrPoQ	1
3880	2vaKwKbkQtn8rpZKpSsua4iYaXRpdrQ8uzk4c8ba6vWyj78Cdc82	1
3882	2vbWJKmtJjoaYNj3AzQhHEiDoqsLkHu6G98iKGqSeRMbe7Y13ce5	1
3887	2vbwT3CP1PueFB4NGjX9W8CqjMBUwF97FAe3qkLPGhhyPP6CHeua	1
3892	2vb9MVx2CJxzyt7MBprc2nodV8dpZB9jmSiPiL98Ch7McS6g81he	1
3896	2vbLTgz7y44TFZD6QfqGhiWTJgBQMdk2jDaKiHWXjtw6L4vBCDfd	1
3899	2vaDFDCNV6gaEhWqgddTVXdgeH4LwNo9CFDyP8u6Xm2tKrm9vysh	1
3913	2vbxnJsqYYH92YgA5D1ZcTggRSB3yRXPmprjJMWQEmdKdyQ9xZVw	1
3916	2vaF5f3ERq1se6GJhH8wMhBnU4Zb3Kd9cZivgCKjKA4sb67mZcRJ	1
3918	2vbTeAWAZBHZuFSuQXWHHPEjrfokPRrsLdtYy1pB9T5b7MJ2Mfxa	1
3924	2vbcUeHsF5reiY6aVcC46RtnvKtq52eu9jkXqKqPju4SPNpbMnkq	1
3932	2vaEM2xA6G13mkkNDchBN4ruvUdgqB89RiL6PKJqbBh8D29ezNJh	1
3937	2vb1BCAK7p7Hxr9xVW8JjATu23iXoiQXs7frZc7sKs4c4Bp3GMUZ	1
3943	2vaLQpp8AY96hAw3JqSoiStJj6Ahdtyd4RQApSj1nfTzNokHRiN5	1
3953	2vbZbPy9zBztZeGxX5CDpXLavzTz2RFbSmH16CmAEgoe9nn5ofkD	1
3954	2vagxuMwBaaJpJw22ej4GdGUN2uq3qZvphumgSSro15RGzuyft1j	1
3965	2vboekUs9YcuepfU87SJYrrkugY5CQ69aCifht4YNUKYeFPxTMFt	1
3966	2vbxrnswKKEde8mRtYE8EsC4MDPhZEQN9jVy5x62bf55eyeidXNe	1
3969	2vbVXvtUmpGiSdeRRZnqrtxjGNXxq44qnQPAu1GgxxB8oPCiHdiy	1
3981	2vbzCznTB9c2hc5S8kQHaZXT3ttBo8FQvJnVmZiLNe5hBdzurwSH	1
3983	2vbdeBK669JZXUxHe718MbGwLAi9ukx7ThdcCgY4c9DtzKGf54VN	1
3997	2vbcp2JMFs51HrB3Gogon4FgvXLCLhP3exGZ44JjjSX1yt5NKP8T	1
4000	2vbuCu6Wm8HxLLKc93uxqbRUx2wh1tLU1v31ACAi376fkN4KFVnt	1
4002	2vamAChZ8nejaPTGShmQKye9xxV3cbwMtWuwBCALU7qnKwSa58M4	1
4004	2vajjVFzQwcorSReMLEee7nVHDbZUupZX1w7phBoZVsxbg3ivms5	1
4018	2vaE1q7qPecUXhQv7JJrvvWNEfoFB36oWedtj2gFmLoChiKG4pyn	1
4021	2vaozZe2WVymec9C3BootfWRjxHh7e32maSa77RbTdDiSYiB2q17	1
4023	2vaYrxm9frg3ZURV4d89wv4WxZ6nJKNsemthBuYXD5HnETvUSwUW	1
4029	2vbQ8mxAdo21YdUFZ4JcrbSrcz66qNAhZN3qPY8eMMqZrjP6pq6z	1
4037	2vbYy6uMqLQPPi5n825TXkgP85FDkrhBtYdaSntHFoo6TFFPMnHw	1
4044	2vbfbYPMZbxPV4v7AwuifzVcas7P8F6Te6Z1bSZ21yVNV71ASavo	1
4046	2vbw6uGWwT9HYkWnri41Y92MoZRTZHJjThuBveisnhpK6H6Ky8zc	1
4051	2vbx7cdEYy2t2n9hqMCPfdawAzotuQFZabL8aEhNre5aHPBzk4eV	1
4054	2vbXncA2YjtELhTkaLNmmPRwyiDfgDVBaUD7JnQ83tYwKJMEkPA7	1
4055	2vbtDDzuR4XnLgw9TeYr5VGPFDeqEfe11DUrbHUAHuyhpxVNJ3uU	1
4056	2vaJyY8FW7VLkufjbZ9eBp68E3zmhLWLiJUdVzoh8LJuWv1A3xuq	1
3730	2vad6knf6BxP1wnq8JUEtjp1EuvSmyapiXP75hKYH84CF8PjmePf	1
3733	2vaaY4P42YkWWv7Cd7ESJM7xyQLB4yM6wPMu8UCnacLk19Lrus2f	1
3738	2vaJcZkjBEqdFL3oFNGC4EfHKMMB4qjNvokpuiZ5v8m8CV4k92yK	1
3742	2vaPgUPh4mRnKmCSkUDzw3AZ5XS9HQobLFVjs87H6q3UD6WZgSKb	1
3745	2vauVH3bMJ5xs8nKHGjjaAAi6KNtSXvA1BXj1j8WaYrbinJz3cC6	1
3747	2vboMWz1pPWriFthv8z86jWmKrhpyKV6iySC1wo2eBVSZxmqm2xk	1
3750	2vbrcjgsKZwyKc4gAUTdwSo3h6kAAR2w9s6DRKEwGvmRwLiP2DCt	1
3755	2vaAbPmN2dqMvL8YWv6CQ8awMDUqDQ2opsXXcnYQ4LDiSuv4wrJ3	1
3758	2vbbnz74145ug8feddh7ZJZm7GVb9w9iY26Zb2dTfnCjCyYkTjfY	1
3760	2vaGMNB6CfcVDm4j8UoACaJbGtTunWfNdjzJLT7Nv9sFnhDdq1Wr	1
3765	2vaLgPQ1WaSPkidGewoFXKVGp9JRpV96dUmCHseDGTSWTQFqVco4	1
3767	2vaRMW6hE71ogKbSEpb7RZRh9Lc5HxPyUNpNizc8Cadgsoi9NJu6	1
3770	2vbrYhbAjRh4h1sWaNcscJBb1BhtRJhViunmbNjPRVPbmsHfydKu	1
3774	2vauGMczAAH2WGEcktdKLnG4zikwrM8Kh74NRGftkwcmvBC9Ux8Z	1
3777	2vbMiyJ4mn3DS15BLQU67v67YVQFc2iBPZAas8QDvzMb4a9iDC5S	1
3780	2vaky7RQmZa2jCDcmHGUER1kjPXJE2D9fr6V7ujuyTenugzbtSvD	1
3784	2vbQG1Th5dE5jVw4ugYp7jxCp9JEAGBv3RndLKdAScquwTDuZTnw	1
3786	2vbvBRvBbixS9MBwW7HZLZ7C8pTkjuXdFzjvng7ado11rqYNGsX1	1
3798	2vbmDQq9j4SNrh1GtuB7y8vdiUtxBTy6taCeGa158q6NfUPQE7av	1
3803	2vb9cV14HH1Gpb7EHD5hRwomtUe9iMpkZNLzmLuoKuEV76AtZnxU	1
3806	2vbnsQeQvDG9bXTMUAzjjRctJxDn6gEkLrkgbumfsq5kV4CD5caH	1
3810	2vaiJco4bpJLbhvrNiMFq7VbyeB9S2kpq1rTjWL8zLBKUXnRZiAu	1
3813	2vaNXgeNNRnQ1MS4yQkSp9jN6pEJWgPvktZhtgp3vjtD3kMJk28E	1
3822	2vb9PcdTUdL3jM4k7djTThh7QoYweaRUVzjCJeBh3HD2BgLCakm5	1
3825	2vbdeopXAcJEFoWficcAmeQv4TWUbrdJX2t1oVNNyFNiK8Sdiizz	1
3827	2vbNrNp9ZkvSNoiV6Drig34Js7YB1Byh5bcHjB6nMvMXcTFwNJnp	1
3833	2vb9hdd7h4zqgLrEchrhq6taQgYUGzBz3NjNjthkG6joyo2PswX9	1
3844	2vbmBSF8GFgU9xjwh5e3R1TmUEwhRvMqX3QyYDvj4kMFYG2jSUBY	1
3848	2vaCr9FBrkM1FcCF7WiXgvezQV8oksmqkVsqGHx8iPG5KPxXSN8v	1
3850	2vaG73T8SqXhkKZAsfLhgT6LQv5RXt826MpCUjLMUsH5uZ9EadkF	1
3853	2vc47gBd8TyxvnbGZvkqYXPYzATdBtUGVXRFREwEwJ57V5iPXUMi	1
3868	2vb8Jj9EZf6SnErGQpgv8mUf9BqbMnAQsDhjF3gVNgHXQpGFYTVv	1
3871	2vayyCNF3yuEpsXU5zPJxj7jyT5cTSf2YW6G8AR4vXGWxkuJm3Rw	1
3873	2vbb7yqfQnvLr4tUXHfGruK6xVBXNTqD93SoxyiEwVfaDSouDAGN	1
3883	2vamwKXz2uNuikyTCHAmA5xNp1wvQpqwPYHTZe3bRFWPVUoLDuC7	1
3884	2vbrc3G6aL4WgAgz2mYLkUBx4hMikQEFkNCcoZt1kDPREAcpehNV	1
3885	2vbL13JKkmwF9sks7nmyRyXKDgFAwo3XWpnCAbkW9xX9hzK2LDHb	1
3890	2vbJTwR8B3XcFBvkh2MMoR8gjfWc2Mqrw1xnda9tqNjEDu683Amj	1
3894	2vbYWjj4e3NLudcW6nnTCeShQMw2GLkJYx8rPNZ5GMW1rhng1ee3	1
3897	2vbMLtjPQGFwi4FrLmRnFTXyrwFkWhuV1iHYFmLhxP3Bt9XxQE7g	1
3902	2vc3sm1W9NuPCx4RwfDA9ZXFj4MHT7XshQfE9uij9j9ztnoHVX5a	1
3904	2vbWy8h3zjQYMSubu2KPyAB5FMt7WpZFuG33cAzzyJQ9qnsyY2H8	1
3906	2vbB7nApT8FnvQVBNbCNGYBsgdquurJTtw1FQNb3N1SqTK8Byx2f	1
3908	2vb9K4mQtXmr9hBZctMuJ1stfDnYcXbTzqBmx5ZgJreF9VnmxWps	1
3911	2vaqHBMdWatFZq8ZHMJ37ordPtbP7SENWCnq88EDU4dqRtXR6q6o	1
3914	2vbPEwMUjFhx4K6hSLtgvoSZcn3NJAZbhcacR3fuEry2dgax1dAx	1
3920	2vaz14g4rGZ8HE67xwpDSp2tBrbVnFq2HdVLGCKafc8nyCNycHEX	1
3922	2vaYNcwDrANoaFScShqPXJoVQ1EhW6EGC9SBTmFDPKBAyejAFznR	1
3925	2vafxDE4cEvDsyDG9vLtpJeQxttimRG1HuAxpS7kRu4kugypw3aF	1
3927	2vaN59uiRbs7ypQMTBcqnAUc3bXJPVZKx4X1aaYrFcQFiTMYGArz	1
3929	2vbuzzTWCuREN7ekxNZ7XVp2WJajZBRqLdz7dKagb1J9YBDhWFWb	1
3930	2vaaCzbkURLomQkEoVgJ9fUuBRCG94y45k1sNonK6F8dC9nqJz6V	1
3935	2vahCQKMNNJvtKJGr2YYoA9ZM2nB8HNJ3dYi9cxUoK5VoFuPePyz	1
3938	2vbicf22zxAT3drqTQLvACNLhJpUu3261xtiqCc8g7s2ZiirPzjA	1
3944	2vaccVinTQRSm1go6Fw6zQipPJvXtALhNKyFyJzPQ3FfGGvoqkkQ	1
3945	2vay7JK76DxsbDaSHMQV6NDzJZGbdcD6CoGhvFVpGAbKZ15GS3gk	1
3949	2vbdLTWwhSKNG4EPKG9rKYDLEmvfyLUPBLpHk6vRkztEUgmjgwgM	1
3955	2vav7jzhHeC1QyVGWK1RJBHSAPY7raNHKK7hwGEetwBhpEcS8L2T	1
3958	2vbMw6nUoN5RkP2U929o2Tgt6DhQW93Pz7bRS18sEM9TUw16Tpjo	1
3959	2vamZ5axceL9ymodRHXX2eE3TmZ1bwQgCVpcpYGi7Y1cCTgvF2Xr	1
3967	2vagkHHGhGZmNvP5ze7idsV6tdFxzbW3nv4xfQGRnsANAJ343k5z	1
3970	2vakT4yaKfiH98GRJ2XX5VHqeLBkvkLP59BrJUiEcMbmYyDjoSsK	1
3977	2vaBKDfSoNFaJpWrSy9jBjp8aiYqMDe4xpp1xc3mz9yWXSgfFzV3	1
3986	2vbGnWhsBdiRZypJiymBBBQqBct6bUFpbUv8whRQqDtDkM9MBGgV	1
3989	2vaLczSVy1HHPx4Cg5Dibmjkc3inf1UhmVygo93Qk2esA8mTnkjz	1
3991	2vaYgVfHtVjcLiHZ1nz8GoiU9JjB6PunqU2tP6kETA2mXFVVZjT8	1
3994	2vbUVZrwgmZkEktN5sb12FjTmC2Fs4qA6K2N9r8FTZVXuYdiCj9G	1
3996	2varuxeuRyjYJPq9cFroZz5Qr7N8f6C8zF6PfdyHiEmd8s1U6Rk7	1
3998	2vbXCKTwDoggLkgaCknTrCcTpsUMmMYRFmN1GnczMgFniVGRwopG	1
4001	2vbBSEXPqRhzp87iMQSgGStXV5RWnKP85VdHGXNfWh6wyzByagUK	1
4007	2vbZHJURosURREQBhMe4a5nHVZKYNWQTjiQ7eNUnbYSPqEUmKRoJ	1
4013	2vbWPzoWzxbbaspCjUhBgz7ebPkQhegeFfUgy68saxxyUBDPkMJk	1
4015	2vbnrpVEhmoZF1EGXEeMdi4Bet7e3JxZqh61pv8TvB2CvpDNVN64	1
4020	2vb45mmjw5TP5GfYSp6hGLoHaQzYPtRb6ZxrxWUHzZCSXJjRZwHL	1
4027	2vaJ3zf9c7vFad533ny8BZkZqCpryH728uyAjydMFjkTwc42WTz2	1
4028	2vaxcKFHcy3zebemRkAw8MzwFXBrWCm55iZ2KKpfPH4X6thmfFsU	1
4031	2vanfnEa3QoWTwB2n6V9bF98Atang6yVyZoTSqWxWtV7Y1cL3b2L	1
4036	2vbAdcVCxkw1BsD7FDDuoSKZfo4Si6UvptRZiEgtRsee9crpjxfj	1
4039	2vbPn9hTWMH983qB4JngPvvCKmxqrNKk4M7jyiEGcVSxaCDz5LGH	1
4041	2vaxxtkuYeXot6hbzYjinZFbNWU1wUdUU8qdN5VaYkY85NhRCF76	1
4043	2vaE6gQFewcKKt4ejhHUQYZjUY8UPMicKMebHPn1tcFUf27kDhwg	1
4048	2vapCFrWChEg1X48MW6Ktpkcnk1TgjGJGbWwnMs3bJsvYrfjsTvj	1
4050	2vb5svD4u3wAmaNVJcmAXtjbrCa1ce8Un2WLW1vH4QxLEEQTqEHG	1
4053	2vbYyDaudyya4KDApxsgxPb8fN9SQjPdj4J2M1rDRc9mQY6dTKFE	1
4058	2vc4JxPntgMmZdfhiTY5NMhF6AyKGb5ZWyAoVkLxBqeBJBqPJyvo	1
4060	2vb6aZJj32jNRQHz7EMJqLvQMiAfRNZzm72Vqkgr8PtW2JLGEKR8	1
3731	2vbfq3baaE3TZpntiXuJx1McZE5mzJkyicVaqf39q5yChfhnvM8z	1
3734	2vbfqeNwT9spoeHh9pfpLRPQUscc6cS3n1VygmYNw3UdyAWVWMzm	1
3741	2vaTqYwBSNmN5FgPyHxMUqt32swjmSVaU6mp2BR8AavWw4ojdryP	1
3746	2vayfKR3PqCunXAW2dat5hDYm513B5epDbAuJMaYNkZW67yH6Voi	1
3748	2vavstZGMUF8dxjAgxjmKcBDHSgeNAmXNW7DmYYqJjiCFuixrrnM	1
3749	2vbCvMZ8Qbpvue5e2p2xfW6HDgToEZQJHFE6teit9wpGKtzkZWWm	1
3756	2vb7dz6uEoaLWLfYTZNGCfoxoKLtbLkLXmuugk2RYCyaNt8p7CXQ	1
3764	2vbKp7tVkCzp4ZrhnbfMqgWUpuebHxhEYBpn8ANDQVCnPRhuupcr	1
3766	2varZaKAw4NmaTbemLByDyxdyDsU8DjLp4opsRiENsMbZMf27Fzo	1
3771	2vaymGCyeEMgQrDnxPs1VhfyAZXapUPbgMZ3pkfd1ZjP92hZcoUu	1
3773	2vbjXCb2cpC7dArLJmXa9QVCsPZ2ivYEyMpnLEgEApoPRr7N8vwh	1
3778	2vafbZMK6pGJTgCryHQBAnbEmRfdMqXQ6eyzeueuFwkkdiZtu7ov	1
3781	2vaHjcwucTyaZzxKPEwbMEyMSNujPc3XukfPtVeiaTQQtYdBvym9	1
3783	2vbSh65QxeyoW51t7xoC1gfjVh41Zjy6TfBTjA6g1bGZ2jfNtB4Y	1
3785	2vat8gMQnsEzso48PPWjrWwitrefomnhbnaaAMvMCxhgi3Ucxw8j	1
3787	2vb5pBJN78AFCaWKVA1ysAp1ztV4XdVN8dXkemPQqMiuYyVSvYpr	1
3790	2vajsZcybtC3pZK6jqXqyQ1ZkneBHq5Zo8yz4vKg5csTQoNqWzpY	1
3792	2vaGfNGcTeP8XzaVL6ApJBf9HzrGNj5EvoXF6fL7jZAQy6YLW54T	1
3797	2vbd1v9dH1NhCsXEM8vFBfpCYVoiYB1yU6b7mL215Utnk9ecSzxa	1
3800	2vafFnioMo7GiUmbVmXsyCHHMuASs1Gs3v55yJkUDHANbum1M6oL	1
3809	2vbaQ6tNwSxMrb9XP9JdYZ18Zj6tseTZTZ8G2e62RPRDfUvaArrp	1
3814	2vbKFbSThohFpoAyGVV3UpCMwEm4uVCMCuxmg7QqAisrQC7f9LuW	1
3816	2vacieGNWMciz7UMBtGbNddbLbyWRuaXq4G6Zt8DnRGvmT77rFBa	1
3819	2vbbp8SWHYNqmRNu3F3LEwGnnVVkLYz3emszb1FadK42p5FMNTuv	1
3821	2vbMdnoyfoK2c2HM1kSUMicgAwssTC1vKGfWuJCfqiFbT3zWKbUq	1
3824	2vbyZ9CrSQiNfMBwJxzTP5Lza8AHf4nWFuTX33LjpPpmZ6UoxQ7a	1
3826	2vaGxLaK9sAySh2gW8egvRBwZvczgYZ8MV6FEv1HCqnQdkrduafv	1
3831	2vb1BvSqrperkMsPGBaWJBkf7ZtdEMQ2C8BPMyxmaRCwt6AQG4RC	1
3834	2vaGukzUii42UawPHcZRNnGrrZgA2Bc2WPKAeyt4hweH5A3h3zgz	1
3836	2vbh7XHmxcmZgshP598wgAAjVt6RbhkPAPozM3EjSon1p7UTXQva	1
3839	2vajb5TxYuVyApD33Bg4rFV268yoqkiR9g3GrVt8vgk5MPQZwXSR	1
3842	2vbs9snkQ8QY2L22amg3cAEVubiP6yZbc4sid4LSEkEbiRrSe17K	1
3845	2vaTwCnyBTyD9oXFpjbB68Lt6V7uVLmhRsgT4LyroYC63rT1n94i	1
3851	2vaYjvnTbkqVE3z5SLFsf2kkYQXQyPKaYVCocVNuwqvWkA9vYa3e	1
3860	2vb2rhPJi5RESQHCVd84j2FVau64PxdFQdPXG1VQTT13LBmrMhtx	1
3865	2vbL6KtbMnKXnpq1udZuMWQF5cRHXDdQHvwDG71NJHKrkpZWm6UG	1
3872	2vauGbi5UkHAunv6qb1xJyE5xzShX1uhA1AZFGyauAs7jwmM7wCg	1
3877	2vbjFQoaRmgemwmqPTYoYLDpH4jap1DkEWiU5a4EKVWVPxEZWB42	1
3879	2vbrRpwbjgK5vffWy3vUT8uPVmvuRTQJJpijnoKTQgSUAzzKLXJD	1
3886	2vbyJcHBZdgPnGouMFzMJRdX1zZjaRunEynCQsosw6Ubm5tQFcQv	1
3888	2vbHG721gTGepRrqNeiG31Ac9J19KpaAExUE8Wa7j9sMo39E4oVt	1
3889	2vaymk7mUYdtVrskaYtHkeJeM9fnn4sGESAifHcsRMjSQxJ9bcK1	1
3891	2vbwWNfjTqv3bca81JdB4Ms3Eos4JbvtmiaQWXMb7zQ2u28eceAA	1
3893	2vb1qSgstzg2VeypDXAhVwPwcngcZ8vNXoBHCzBmPLajt6Sox2N8	1
3898	2vaHAdgaBXn5GDvQeED3he7AgqBXELMYXiH2goafo4QWHQWhjfz9	1
3901	2vb3QmgRoMhevE41ouD4SaZYYgTVRuUeRcNvcFbqcrnYo9PUB844	1
3910	2vasKg6vZi4n7xQzoLYGKVErGi5jniLzvuhqW1v92cQwqB3ZDrdC	1
3915	2vbz6bSyQycLwzoQ7iviBcohwVx1xAGkjPq6pVr4J3X6E3DFZndP	1
3919	2vbec919aookcKQxdsjhb9ZLfMqtXBQZ4AMydPEgJqUsgXjaBHRe	1
3921	2vbmyWcwUWYH7sXwUG9476t2ou8hTotBCzA9jT7RMwbfaYda9eY9	1
3926	2vb6AJpCkat9F3dCtsX1oH5iQ29GpmYWzZoV9kFejM8S9h5gpqdc	1
3931	2vapJ3tH7iuXUNQuF9jK54sRzQEH8XcDpestLCPgK8nJZcvoHjcb	1
3934	2vadoiwSja2MCJNLX1AuXZBB7u4CV8R4vFRnc6SeWWY8vTaiZPwe	1
3936	2vaqmssEUM6eR5724pDMYKSQzBAMKBsyZpPx71T6wcJa3zMCP59d	1
3940	2vaLcDX1CWi3P26QaiydbnQL6yNiAdWNsLh92zD2sPksDmSBHJ7E	1
3941	2vaSGCgkQ7erw24teHrbQCMMwMnDvRWsPmZdmF3TWPAzd91n9XiH	1
3942	2vc3wTtwFzuy3F5MyZgDdknUYxZDHPdo4hRc7yocxxxWYs1PZ9C5	1
3948	2vadbgUitihgvjvbTHpETGUf9i52bTJEbsmqTuW1P9R9EooX9rpK	1
3951	2vaCwePkAZiz6iZaqixNL64MmLhGpfMjYWsnxVVcyuSaGryvSp1T	1
3952	2vbzNQDP2k7G749wCuWSVD19Gz6zuCCbUStCkMSnSFmJzUX1ZXcs	1
3961	2vaTGpwDmAJB6eWQaXbqWzzSGChBEr2ucfXV9oweW9zS7C3FKLiM	1
3968	2vbDaXJPT1SKzYf9x6XVxYpnh4UkpLHked83CQo2nWaHW2Q2CSAy	1
3973	2vbCZGkWSFtW3bM9BrfhBwS9nsFSpWk1YiXKzaZGTjUbK8E3mHFA	1
3974	2vc237pGQ8bsMBhhuf41j5owAU1HXEbBeDMckUnz82EGECpdHpfN	1
3978	2vaXxvE1xe51Zzkm6oHGCL73TLvEURgcNjCydf3xUfU88Q7f6FpQ	1
3980	2vb1A1RoSVGUiPZfoVP57FVbxr7QR6ozBhF3QHhsPLwkvmerS3qz	1
3985	2vaCeUYxdwnim7njhYH5bNuVtCtL55h35ZQPEAni7qzSP985fKgu	1
3988	2vajY7tyYNLmmjqy7U3YfEvzeLMQRwxWkwmGzsS1HvPGbyZQicwN	1
3990	2vaKKyk8uJhMfbjPvBNDyVn9fhE65LnR7GxPckHNdg1wtcgKGXMb	1
3993	2vanWQ7dvXivGHeo3Hha9GG3wXc7HT6RGhJZ6Kgyp2Rxh3fNGmPu	1
3999	2vaB51i2SUjrfyydkRZ8S6tEDZh5xtduKT7FR7QNW5eL7yKU57Pg	1
4006	2vaCWN98vbWYR4skCxzVEpawwLMKCPNhevEU1mvQZBNWfVQC23iW	1
4009	2vaLezmAoreMguNan2DSSCKX4FBoRebwno5Fq4bkyWzqDNt6N6vD	1
4011	2vabU1dKTKEnrsBo6dsLu65QKLKu5EiNLpPFEuxDNzhtgjXdtqUw	1
4014	2vbYU6pwkxHQybAQ3gNheEhmgzw2792KPfAL4936UzcY27HA3TnM	1
4016	2vbvmyTNbavzC5NHbzguouDuUFvgMdz9MCiVBHy34U5PrpgLJWhA	1
4024	2vbT9cQgJw2kVJ8jubrcdesBxaMcTpGQJYBUDXrjDt39M1kNmneF	1
4026	2vbHdDfxFvs17ZsAJn7h35v9WVDidhjM1oHfgsgd26qoSZ3jewG4	1
4033	2vaphKwkiAVFLKqgbceDESTyoeM8ZYLuBWAUYw2t6NtAVuToZr5v	1
4035	2vb2FRV5QYWTX7bC7rxPJkdxw8Hwr1rXjXAnWPEuMhmcEHeqrTzt	1
4038	2vb7TZRVDmnmMhzDxGWQmqAxqYZiSYagFYCTKYESNCnNg9WAQtkD	1
4045	2vaGDxRrKRtLRoHr2udeHW3MXd3Q8q9PdVsgwhEw1FmiMsWE7R39	1
4052	2vbfUYmbZ8W5zekF5U2kcZwrKXeZELEP4PCMDtaFfV2mKrXtk1se	1
4057	2vc56Jj9oWer6bbfwvhFPBupVbqin2zvUwG5ubpmtbZbk6rdrfhd	1
3736	2vaomxBZrzy95p8Szm3Hs9uyJC1cswct8s8NZtCS4nzv58oW3yGs	1
3740	2vaWirGELUgzbjuqmdV5Ebv9VqcnG3ZrQ1hEACmo5PwjGCGp4zDG	1
3743	2vbUjwPrWMSHrFrpmjp5riz2cEckdD69mduVEiC8mLxLd7MpKBCX	1
3751	2vbhBupzxaFD14CKJ7XW5VRw63AtPKKcxeAuXLRCps3yiW6BQqqF	1
3753	2vbvh4QrJu6CtxY4hxJxC5tb3XpS7WVS7YaaGSAiah8fVKuSqxvM	1
3761	2vbyDDehSBV5BrQJGCm6WkCeHbwmF69u2am6L43Tq5QKXGSkyWov	1
3763	2vbpaoTn1yPLmRD8ta5gYXTrh4izRpukYW3JT3fQBenXpcHT3WQC	1
3768	2vbCSEpkUX77EY834LgYB3UGzStk6ZWa91GYvDQWQ8ZcRjRCj3dM	1
3775	2vbiWWkcxsW4BBvpF9TTMG9hdUmMja2j2fvGtTeucYC3fxZGsynv	1
3789	2vbz5snHi4mNxiKyU6WzVwFBD5nivFx7ACCrnbKPSn9cEDeWvtcM	1
3794	2vaPMghjMNFurXMowoHDqDy7kqsho4juFgWkZwovPfuXrMP7s1M9	1
3796	2vaZjGMaNxn3B1bMs71nSCndWKwvPLJpzGLtZDmQLz4k5H937aC9	1
3799	2vaUYwdxRCtBTrewG5JZsyboc4frJT72wFGAcTU4JNtiJGV2W8fz	1
3802	2vbDPp2iSB45Zng7HKWDTnpHysGpLEiJhREoLySKECdzzbXxG7Ld	1
3804	2vaSqbE9tVft8uDvoEZFJiJMEBC3HPoAQmimQsUDnkpKWxQnN84r	1
3808	2vbwZp3Hf2RwKTePMrYESgNaSarFw6HL88h5DxqeGzjuQE7wuCFF	1
3811	2vaRkdL2oUPApFXRQrAshihpxZ7NC53y3Lzd7LgjwJotNF7dTLbH	1
3818	2vbxaUu2dL2P1WuFxYqXw5Y2BEmF5nfEmGe9XGYfKBswsqJipzPR	1
3823	2vatp9ZsUbvo99Qp5Q6Zhpu6rZvohciEM5imiuzBTWv2hqS6tgEr	1
3828	2vagQZ1KEk985BSZdnfoKNAT15HF9sGvcZj2ixUMYbAbs3J1DAhM	1
3830	2vaAAQgkDdZ7JqzxiS6N2DUwdNJJMjVbkh6B9P4dP6zJrEmdujxk	1
3838	2vaExgafowZX7AP2ShB6jk5ymd2LDGb18ztUy79x4SJnc3bTPLhc	1
3841	2vbugZuUvMuZFiqoAe1XDeStpnLJ1TW1cBSfS8V2qJZxcHUmxjDT	1
3846	2vbDgeZ6k89LBJw3NH8GC9U54Z1SwDyjV6AJuhZAba5t7QnrD3bM	1
3849	2vajw4kAumqjgJQut3cbYbLkteZvHeS6wYYfbbaiU4DXo3meHFCy	1
3855	2vanmpCoztrr9aZitzYhtYEkaKtRVZ3uGAhtgxnB5fVcoM4BpaTf	1
3857	2vabqxnMVZ73pPN8jZkEGVRF72gCM91a8CszBk8VjCrihNvxzUw9	1
3859	2vbPtYJ6xAVcbkr6dUz5nxjC8bGfikkiCLKyse95TimWdoyzE4Cn	1
3862	2vawAhkdwVLaHq2CUB4CZeUiUukgGXBTtvW9WRJtpyNcfu6c1cHV	1
3864	2vbV1qbLMq8hcnfSHyyX4tLC6k53A1mYu8Cj47rS6EmGxupdAAf6	1
3867	2vc3hsVMmAYheVRBdWkoop4DYhjXJiRy29cAZrzJ4MQ5ufVkEfWL	1
3869	2vbzUCfpbjYD4KZVXFZCdRftAfqcbPuEihdtLyZ78D2yxsWzr9Gr	1
3874	2vc5aLEghbJBEpRcyJ6vLiRxioA1ioycs1SPHND7f77Deon4KiTf	1
3876	2vaEmHCTNyQ3WXj8pD5rE8V27uQqPLEYk2b2RhEfpQYJtLUZe2Uu	1
3881	2vaCPadAtGotep7BkayrGzYYrbTgSZPf4WMN9KFR63Pm8Dt6UfS1	1
3895	2vaPC9Pehv57AY9fUwQAPmCwV6BSAVZMtNMnSrLNzfxKZDHP81B2	1
3900	2vbNZPtZ9kSYLn7zXRiDZuRkfxd3tn6zFWg8TkuXZFdUe4uAywYg	1
3903	2vahLMfER3HgWa5uZPkLRUJWtRyJdhkBpdQACzsxHDgPv1ynhsMw	1
3905	2vabnUn68cU8WbBJ2mzhBvoLQd9GDaK259RyfLzMpVVBTByaFKkj	1
3907	2vaQ3AAf2hGakF83akxrQEvR6qkzrgDiGZ8kAKVZb8PbGpvVoDca	1
3909	2vaccJPVyvidajWitpC4VbRbx1xNMnpbgUBu4WSvUyrrJ8RPM88b	1
3912	2vbkAcP1oWpi6eJ5wU1bJfvYehVtRHBMUPv1hgNxXC7h2QKmWkMN	1
3917	2vaynrpRUk2NZQoAzkZi4EDNx4jMgjps2fG6L6upVVZcQxKMunNL	1
3923	2vaMk7YDtkKDph4J7bvVsVsnFcuDHEtGbixK973WgoHZqMVNwzKZ	1
3928	2vbX4M2MG65ntPRQ9zWvVT82oGHV52wyd6vdCWjHLt1tVBAcN9B6	1
3933	2vaGK4gCXxBnDiqiBW2Pm9LsMRSdVutvPg8mgKmy5BxYkdgAw99Z	1
3939	2vbARiMpKQae9DLZjL3eJNAfihhD1jsymGLAM94r3CAiYhtkH8Dc	1
3946	2vaBnqxJ8gPE1HyvoNzVEFNimEzpucrAFGf5jfRqqXKgSLao5aMt	1
3947	2vb6nRctMPCRiYCuDMvug7SgMT8JrHofPhsTb4rwJJVLESynM1Ak	1
3950	2vbx4aSVUkrsuX5BvuTjLTQQa7o65N5eTZF8YRGRtBqg1CCKvQcS	1
3956	2vbSjiXRzPzJAPWnYbLCQT9qtgXuJfnwwqptxpQWN3vgSapbuZ3T	1
3957	2vbhtRshZwrbZv6NAsfUD3isWAJqotJHwprArndFqhSGqyGNNEKr	1
3960	2vaHYZcXAxNpma5Zz5zhrnyWbQyRPJYyk8FgtPbi967YfPnjXK6V	1
3962	2vbzzLY9SmTLkvC7BfSk7SgSS3cxza5FiBpv5PaZfBMmetr5kKYs	1
3963	2varb7eVpsxxRUnaUC65qw7wAJq7nMqmcmzu4L3gV9XkbpvnYZmx	1
3964	2vb9wpzutY26Mt1A5bScAR26Lo94mLwYoP1YoRXxGytzZhjrM3os	1
3971	2vaoME5ymojDzo3HFZUCzbY9cLZVxFjGTtxrhHGb79K8aNLZm4n7	1
3972	2vbUDwxpmYjAtqGCvKDTHvsbq42qLfJFevfkAiiWv1aAun3DfxFK	1
3975	2vbrFMRx6zXeobgWR6aodGNbqKykasaSPR9x4WfthR78jMnY1c2R	1
3976	2vaGqJPn3essvLppLJN9EpkTpqfbyYG4hDEbX1P3mwPWuFzqihAc	1
3979	2vbbBeqQ8xFARZbNnJJ89C3Bwh7fcze6uquAByFNs6on6QTWjoSJ	1
3982	2vaobE3UqSABNYR83uKvgP9v28ZiZtnnXMTspMX6gM2BEEwi4SKu	1
3984	2vbgFA2TTJqGb62G4PensZ3ffVU2ehSZRFVrPwhzYoSZNyNtsXH8	1
3987	2vatnimU6qbfJNvjHTm1NrxetmnttAHMbEXPmrGaj1twVCdYcGUf	1
3992	2vc1Vka9TTnX2sUYBgehdBqLLcvUfJqs6myCFm3xYUUrmA6yYL8e	1
3995	2vbbJ6baP4niqEDDEtTzZXRSDMvb4Z2boZqkADhfTxBZm3PNwS9j	1
4003	2vbNqLRHdgJmbksLweqE2tZ7n4xGm9dNBPEbo7uV8pdW7ZHW1pau	1
4005	2vbAWnECdGBSXzWDmPusbvd2SUWroaF1NvL99Yn8uF3QNFNxLHDf	1
4008	2vaxtnf9SMunjK8xS5oNDLY4ToXG4FVt9LwqoD1iRc8iuuBZpy4v	1
4010	2vaAiefmVCJizV3P2V172pfENVsWe4W3LEucSduAiFKx9RzXYoi5	1
4012	2vbxAAJtG9wWGRqXWAeTXjvAMnfN4ymYc96det1qHJjmwg6EP22u	1
4017	2vaggLk3SUJiowCZxcVsesR6Zpoo2sG9DVfF426kx3RUjDVei5mK	1
4019	2vbiVSFLtHhXCz7ZKPtfbzxBGh4Jj33EP9WsHsqrWCqR7TmiDE76	1
4022	2vc1btGCHn1arAujZBbnj27Fgj7qCqZpRtLPAUxagCVcyFPGDkpf	1
4025	2vaC8KWUoJbnNJkFqzfmCsNdUtrfoybHfTJP23xGyKEuPMS8j3WC	1
4030	2vbvdZkgGCNxNAtW9v3ZqxtYGETgbbTpKZr5hrPpAN24kqLzrGGY	1
4032	2vbnpxJe6f87vejx9Vfpi8bSnkmgGtoA8mvQ8796parTbiyHZe3p	1
4034	2vaoPDGQhNubYqsrnWs3SmRzm592jaYgrWUFoRtDsxJm5JDbthtv	1
4040	2vbi8pkbfzmM4cpui3MDNf9VrnkS6p1qTxhS5wpBAKMG2dMadWfX	1
4042	2vaSAcykLSM3nEv71nX68DhxRrmGSoxKhDgt5hRa1mD1QF7sy4RM	1
4047	2vbZkMR1FLckd7o5Jo4nqY7Nbj6fh2Qx5YU1vjFiLX6nWjTbFyHA	1
4049	2vaGaQvs4kzMLEZh7vpFZtiLpHvGMfHKcn8N8b728N9ri98Cu4oU	1
4059	2vbwjku9mxfxmxRVfB4L4br3RGLdxxBdqneVAfDRDEeoVqU2Pc5H	1
4061	2vaYV7QL2tLaSYs2dwsoi6PxyHLk9cWW4cU14HChdd5ffvHT6DcJ	1
4062	2vbLuNmx5t4g9KCA2KuFS2cuDrJ8Bgs6kP8y55eD5Hp5FHLuzEG1	1
4063	2vbBgbuMDCHL7FWYFJsnohFdG32sszu1CeHyRa21G44nang5b8gF	1
4064	2vaQmRZtdpJp6MTubE9rz77SpkMSAj1S9PL7F8zVsWbHdjq3LYAX	1
4065	2vbaF9cfcS7Gzef8RmKuLoQTTcBz8axoz2r9mtHjcpWf83gLXrLx	1
4066	2vbGsikYqMeyfmuVACFNZ7rzDAj2Rpnw2cYUiTnx9BenAWPgsD7K	1
4070	2vbNX4K1FGKhp76iRGvjGYcd7eRPx9kUMMArEgkKaKVU579tn5ha	1
4075	2vaiwdREhp96EJBKjEqG8TCYy5f8zg6x7dGq7YeKq2Y2dTdfpp6b	1
4077	2vai8oweTsRDvYKeaQU3Y1unmkB4S183HRMjUK1c8KYkZipGJcJs	1
4083	2vaQtfej1q6SpVp43nJTSrksvUYzYrWB9Yo8XW65rTrWpXm79Er5	1
4091	2vbN6KrHRmwaCujijpG48nroXHzqpRqm1cUBmzjz7Sdao6nuXk2Y	1
4093	2vaAJ2nuD9zenB3fwYq2G4rpdxbRwtqjwWuTjo6zowuTLc9DpQXo	1
4098	2vaAGh9tsKngK3mQH7rH6wqaJCCycNrjPnQLBdxaLousCkryFcmT	1
4100	2vbeeCxcJFFLMfU1JkVemrn21LjKo1Nwvqm7oa3x2jJ8q5Zyg3uy	1
4102	2vaKkQeHpbebeD6WrEwL47SWu4zuqznQpeevHPvTTLYYgCFf1A8a	1
4110	2vaVLqH98ACNN4BJdyTeDmFWrW4JsiwBwCDMEoFkG6Rn5ASEzn9y	1
4116	2vbN8aMg6hXtynGGirotPcStxzNWH6fi127NxGYThj2vjvdviAEr	1
4124	2vc3EN5dJKUVZvUjES7TM3o7dhWpGjKTKDdNo1ajDmf9VkXsPknz	1
4126	2vb7GG4SSMvgbFFa5oPn1azE7Fs46qoqKFwrq1Tu4hqamCNKpqmV	1
4128	2vbPeTcFuRZ5wfYjrXvUcqGmTDoHwPWdhgJ3FobTLpu9V9YFa9FT	1
4135	2vbqAPW7aB8N8bUWxwRGsxGcHrqAA9P2M7WBL1ens2vXywVahJsk	1
4139	2vanBQqCL6i8L7feBNP9qukHqcwamd9RhHY37JJowHnt6tgXTCgJ	1
4141	2vbWf3pFLVq6xZPbBXSmE1BHy8gBGUW5jPH3YA15cJjw5PqmK6xc	1
4146	2vaYUaZZfHQDQnU43CRrJRTzNe5cQYpuSoLcLgVYFGgKMwmrySwD	1
4148	2vbLSyN6su4yWufWAaPDUB895cYKNwCFZPzjRzqX5HpziVFDTa7i	1
4149	2vbDuGsHPiHYdqP7stnjDHSyTuq5zGQRyzuzhzZBt6kwezoLeLqt	1
4151	2vbew1UWuneT28uzFXg7jXHFMM57Ykc8ivSNHCqMfFBTpBQqbTo6	1
4154	2vaYsKU9AD4byGDQ7WFVoaEQRQqe9JbxTJSk9ksknas8g2UDDLKP	1
4156	2vamkjJDrJh4bEnpCGoJRtJz18BJSY45gdCaU3o2aKovE4zNw93N	1
4159	2vapEEstudNaQm5gR1bV1iJMNV2iogf9pEkXLtGUZjVsZ1NYREMS	1
4161	2vbFDMKDgCtdFCQVgGHKk1oP7ozniQZcrSG2F1oZeMAg2iWbJesP	1
4162	2vadhqdCpFvzMFuDUdqV5ZX2MXmniG5a4vtMybPXDZRR4uC6THJ2	1
4167	2vb4q57xm211pbAibdKVDkJGLEcYuGSmmwEkWbCqx64VfWh9qk6e	1
4173	2vc14uq7Yeo2dTqVUY9yPj9HNWKtV1VRiLdnbdXheywN3p8nDx5W	1
4176	2vaCsVRUGbkFWCYPdpWL84jo3gXgeXs3FDCNcHjbWuZnwZmwqyhU	1
4178	2vbUzWpLd7QFkvoNxRRLjNBXtYPBbH9Rg2b8ZUPbqGbDnWHRuXNQ	1
4183	2vbnGLJaqUVF2S5FezSguJMK2TPPhuTJp6zUwuQsCxxqxcbvA8rR	1
4189	2vb9WN3XAbN7rZ5jG24rureZbesYUVfe8bw4jGL6hoQmaYauRtUe	1
4193	2vbVfk7krpqbwWoYAKbiH1iWwKdfZ4pBaEGyjYW5MBTjDUHwPQwP	1
4195	2vbsqDLEn8bgdjtSbd1xLwTHxvnTC36Vc8Fyxsd8w9cs5Jnk65hJ	1
4198	2vbN3eyhYHfQdKJQwFUEF8ui4fq3YQEw4yQJ2m39QJNVCiqM6Vh6	1
4200	2vbC5KcSWABqk4yMrGCrE5VWfL113HnMFPvH6Lx93YfGJKVMmBfb	1
4202	2vbtsKnj4QRcEcKHiLc1Y6jph9cWQbYTHPtzMMWyqYQf1m4QL6Gp	1
4205	2vbzuNo8EEtnuXkBBBcBVLyiZpc6Vck4ejPwo6v2iEE4JJYX8zeQ	1
4210	2vbzBKVUKuCW2t1Nhdh5fYFB6aA6GUbkrkas8T1Q1xnup96ahQoF	1
4212	2vbQGqFCsjKaupNNu6LdW4Yz9itjRjVmoFcrV8u4bhRtiFTn2L22	1
4214	2vaczKYWz9XzsdwahzSmanekHtdCyRieaq9bBuEEznfG7VXHQcVY	1
4220	2vaGFmLVxZtbjCY4iWTZFvYfoAjrArQRNsRUzSQBRPUkJCKu8vyV	1
4223	2vbm2RrDorV9Vmnw1CexAT8TusNhTjUS4qh9XCdYe3PvptDVAQXM	1
4224	2vbZjzYNBYKjdg7q4tyeCfCLeu77AC1kqq3rnDFHwpygAw8DzU2D	1
4226	2vb5Pk9bU1VjF6GukDKXpyp4XVeVuiCdWmqWVCAFuwTtguQZMEKs	1
4229	2vahHkY9aGHFn9JbD2CJdHa6Hv2BxLRw9WbxqkmagzErnEBoQLe4	1
4232	2vaQW2Hb7bALCwyp3X2pGUpTVR4QneUaRK6bKYzzFC6qDZ4z86Yn	1
4237	2vaPAJ1ZwihCi5CZquQunYGduQD1nvdDYNxeHUixA3MMFdCkE5BZ	1
4242	2vc5kPDkwEM2MnMHw77PQ4nReaELHHpSN8hki2efG6DzEqeg17MT	1
4247	2vb6Mm5uXhjQC4EfrooyKTf9rGucjWiVuKdQyDEFmUsQBrwR2mWy	1
4250	2vbXMYrMMUeaXmeMWCj4XvfxgUftMvCALT6qmWxjKvon3HKEBRtP	1
4252	2vaWqAzC3PPeqZTTn741REN7dS2NpRVaziwnkirV413R8oDC7uTi	1
4259	2vbTqPXFkTPDGaMmBTqTu8gt3MbkSHS46HTZPTHtpzCjfwAZhjnR	1
4266	2vaFgZ5hsZSK6nHq3jZiJR4VaJS8tmN1eFviwXQRQWgJcEfhC2BN	1
4268	2vaCs9KuxisHewDmxB9qcpG4DXjjT14dEkiEMHVzQucCrZPEkacw	1
4275	2vbG9egsZTMBUxcCBXsrxaCFetivkCdhHMAR6g5ftbPF1gTAaJmQ	1
4280	2vbwnav6EWDzkyfAyNL5bo9fFa2GXLLXzCeMBUZuE2GWcgbmcaYq	1
4281	2vas6KrBGxDtSFqfMyQnxn26a8qeJkJaxzh4QMoKd5uRSzHxc8Wo	1
4283	2vb53ZmVovdPkJQhcxjdJLKY1meQQUNYe2yzfpsXd335QTV4cvoN	1
4285	2vaR18xhJQDF8mF8XRrXaeXg6j9XTK32KbBLabKXhw5cJ3S4zmoA	1
4288	2vbFdMGQDM3cQZrTnL8sFbdFXchiuAD8mmrCVdh6mXzSreKhqZPz	1
4296	2vbtgWYPMYLqFNMsDgAA8wgS5sNXZdfm75iCjURQAfqhfrzmyJiS	1
4299	2vaK8x76covFM3sRbzTKRUHREykZ6D6yJW84K2iU6MfAorTW1HxQ	1
4304	2vc1NyjVCmAXMkvWW3gKNEGns4c26ZxfR2XMfBumi7rT6ZUU7i4b	1
4306	2vba3JQh5s6nWXqP5ntN2gVGRPWtXQbj47Ahgt2eQCV21gbuDzgN	1
4309	2vbZBvUFAQ7ZniGX5MeNJGRp2rE6zpXtquCP25BQ7aYfk3RmQpcj	1
4311	2vb7LHLmi4trCbM5hhyCXu2RnWVZie9hNKrnJLievJv4CBgbh36D	1
4314	2vbrRyAPBjTuqStKyXbkZpxkWvAHv8V7QDfqXbUJAXcXxwh2tyyR	1
4316	2vaNb6gZkQJDf64UnLK83et3GsEEQsK5fNdmzTBL4HYF1u2YYwS1	1
4318	2vc16rygjQu31WC4S9BJaqcEnFSQSm9mLoy6LbpTvopAX8WbgVAs	1
4323	2vbEJqG885LE89qriwkKbRvkeLPgoMEqL3WH8BpHFTQ6jTaRmMTA	1
4329	2vbkWx5MxcnUJxnckqjduHBV3nRoqV8pGREC7MSHNwRFi4aPPTfb	1
4335	2vbsfYWgt5FRG8r5MjGBw7B7DGAiYJS1dcHQa7xiRmL97viByUKe	1
4340	2vbNRPNpsZiCLFSLkSmGBQ3LArx2CURf9ySu2mprCHMhwLAbAwBj	1
4346	2vaoTP3v9PGjqQX8nu1MNLXNc86ZUfeSEpNo3KhDmBiist6KAsBU	1
4354	2vbEAD5YP9E9S6GXfEtnW7o1Ysp2Utiq6pvELLGR6zz9oKr7qRqg	1
4356	2vbkNzLZBL14HPcCyqh3P2kxS7qoJCftap2NuFnG6p1UofBLnwTw	1
4361	2vbPyLtc9Hj15ZBYUvRc6SDJPkopHiNNZpsJ8vGUyPJFcQGcQsdP	1
4363	2vbFi8zk7ocmxxtapZUgo1RrGoJ9LdYzFVKsdKZXxz7UX7Zj5Rc5	1
4366	2vb77fGuKYxL1kvjb3cbDQaTRgx6CmQP1F7kgrLH7J6wyG9DT2aR	1
4368	2vaRHx9HPGMV5BYSWV524qLbTAWTDUjm2nHvZ4vkYJ5JizQq9ECu	1
4370	2vbZEeKgXAB5xo521kiwpHG6KZ18CaA9gq39qLTauRuDZaWWpB57	1
4372	2vc1fGKecidtpZjzcRn7wPh1MfNw561zRfWkD88VGNW8QN1wMTFv	1
4376	2vc4yoDmzN8duQEbNDKisWT7ZLPGizSpuccZXaNw4bpABpW3MTnM	1
4380	2vbUf1J26VhjEk3BXUffqfQ8CNFdZMNcotcGtvvbSPS6YwEySVht	1
4382	2vbrpwwRqdk5613AtuqPDe7C6VbBjyCTtLsU89yWBBKaza6Svhtf	1
4384	2vatTmUPefB722XMjjQKyWt8EcshVVuJKfz3yFBdbxsTJFLMnZMo	1
4067	2vauAGZMdFquAzsygDF2QTfLZnQdde6KdwvztLrbVhYhBNjoAgVU	1
4069	2vamFJF1XiPEzqnqxhAnTLWJVMyWK1xEz8qzNEZ5R9Q1PDrfLoh6	1
4073	2vaasZhMx1KzW1SK8NP5EuHuyeQB9XyVUJSejn9dDuaJKZoWkdR8	1
4078	2vaqQ7p8n4L3QZMyTM8BUYXEesfSs4DufGbE8WMNt33w5Qt6vPzY	1
4081	2vbUWHVwKQEE7hgb3AjUjG3jVapz9aBM2WMorVKAwvutUnxNqZ3i	1
4084	2vc39zUn56PCDrstSXFt7xT4FzVT4531kEs4q9DrC1DV3mvkMZ8v	1
4089	2vaqDJXLHxj12AM8fEKVXhNxATuGcpiMYXAoGhEvyyB5RNq4a5ZH	1
4094	2vbT5WufWP13csoXEvUeWvxeUzCurAH5drfe9GCuGLHKgA4WLkhu	1
4096	2vbzgGaZhHsSq17vSZDfV3a75pM873UexzxCPFfUEpEE2hDVs2LL	1
4103	2vaw7gxkTeCoVBGmPG5BtStChGUy4Wj4X8HcZ9nnaEpMYhARwyST	1
4106	2vbogxKaAySfySPFDLxjUoQCBALw5eMkdjyiDWXr7EffgHL2VWBa	1
4108	2vbUKNjedk35GFdZ4z1nyEiqvMFakFQ5S3CR46LPQxDMqruVCrJa	1
4114	2vaim8eax7mWr7A3z9LsiUE47TFaPKRcLbVDtYjEZ6z9A5uGTKwV	1
4117	2vasyZA8mzHmP8rF1x7N23AMdhojPcGSUg5n4mQrGVhjmfVijQTP	1
4118	2vbVpC7RdwZDrD6DGxgFGyDoXT6d2H113LHvkfjHJcFC1zBV7ATQ	1
4120	2vb5due1BQjNXKGzxugTqt6vAEu94aE9dT5U31s1TuVesGCpjMXB	1
4122	2vaBzb66hKiYJgrQvyFsoH4Px1qhFg9AD1vD4srutFfghxdiiZBk	1
4129	2vc3QmAbC68AQUdX5enjLJxNXyhvW29oKyvt3Kp3s2mwB8j8V7Lf	1
4131	2vaW8Yipkt36WmTgyqibWqkKi6WYPUjDwJpUAYsetzygehkCfZ3m	1
4136	2vc1nY3wu9oX92ySZb2FQhfkqEHgBvHfKKouhUqpNacFVYGg6W3S	1
4142	2vaFr1ibzZgofADuPNkuDEhzB3xykXsS7kwzU1RkxM8aoFkKG6Sq	1
4144	2vav9GEoZpu7tzwYEvk2EQoVFPWCyVtBMBHjpvstbxh21RhdAwLD	1
4157	2vbWFUXDRhvV5ETrUzgj1sxDiPKrJjtrP33W1UJ3gKHomQ6H7WB9	1
4163	2vbSHD1KFFzU9hhtV9s7NoQxPRt1sTcMwKg2r2SeCRBdiAdfNSZL	1
4165	2vbrRNENMk9EySmYAiXMP5ibdLegQ8EvM9fMyJvEMTLqoLoKM1PH	1
4168	2vb9ysYzQNUYsxcuVBk6uqtWxqVo9WRqtJXnZoppie7xFUUJQFdV	1
4170	2vazW3y7VTTsspS41hm58B1vU44YWFsPwUTra8garRxUioPf9tdK	1
4174	2vbSWtmjPc8CGXBVtWUJ8X6vLmE4TZVKyA14cyihzbbutqRwHZTS	1
4179	2vbKixpEZi6azKQG8j2qMgMYmeUnX1qHAEVJsi4d8JJgjejm1UKs	1
4181	2vbZyekFLih2acQncoaSMx4ZYwEt4j8X9MQUY8DFGA1bFjzvZvvy	1
4186	2vb3n7AcKHb4hdfADK543VaE4mJcb6xwuApWfQJRxnwhVCXTAmTb	1
4187	2vap5GFzWmGBJiN8HVZpDR4Zds8DfFDwfeTsPFqEQiqdhV7kwzT3	1
4192	2vbr2rx7b4P7ZbytSiGKXNLrGFD3VhtbASccPzTeUWYhgDekjtBY	1
4196	2vae3H5FHk7HkMSfTJzv5aBf3ntidYgs66for8ttjgHaEX2nGeHB	1
4203	2vaKn5g4tV4QUPmPibja8FhunX6wWBnK1VpxfJ41AP72wMkSd8z8	1
4208	2vaEe98bUMTFmzprmukhR9yL3F8q1THgm8RFSnGngzeoFNnKP8uB	1
4211	2vbRyPtrnkRbhLHHbKJA64y6Gdffg4ea1Gbngx2UTRn5EH9HsZ61	1
4213	2vaHisxGNbdxPQEYLUB2LqvkKPNU8zhE83Ud6ppMHSSVjMA3zmw5	1
4215	2vbjCvwhFGmqbkHyLwCxsnmnh8WY56wibc7hmZKeCfjbqmJEnXEF	1
4218	2vajG2YgjbAwoLgzYupwwusjLduxTn9BnY39YYTRe1Z3WwLf9iFr	1
4227	2vbivKE1tRecVoLoLJG1HYPm8s878D14mpXvKaaEm5BwcG3NCnbY	1
4230	2vaRUis1GJz6YK1EMMA1hm9H1Jk8vHfWupBLkw1KdESexZ6tmJFj	1
4233	2vaMTPWGViWeKbrNJmdB9FxPGNvT89UahAa8boWPD3mdFNdFhwC3	1
4235	2vasMvuyM8Pwu845T3bPFn3Ks6vwF7NCnuPy3cAxw4q4rcuZJSvk	1
4238	2vb1nYFGSWNa7VT4xnsdpCfzvsB8fdn4cnS6rrEQvAjc53ynNAXk	1
4240	2vaHuYG3Eobk8mFnCAmpQ9YqE6n9hfhKP61Lrr8ZF3UKDGVvmaJ2	1
4245	2vbZTcHMKyMGV39g5NEbDw6HZQfUxqbur23fPnzH3RAtJ5215kBN	1
4253	2vbYQgrt44EsZYWSajBFyzfyTHudXukrqURWZTnfGDpwdbHaipGF	1
4255	2vbzuF6GHd4pEWFv2tywS7nnNyHeZVM2Ub3wEnJ9LrKiGzLYV5UU	1
4257	2vakwom1zJrnjF3mazycQVsWGqNnqKHgDiRZaMAMDCJCCnbvuBiN	1
4262	2vbrwKTR2S5HjN9DV7udsMEBi2d912WdYTNh4s4A76ovT2EfH3hf	1
4264	2vaLPMfvGVjzngCjTsbWHNdb4AzHfp5ahKpxLUFVCxCjDLqeuiWR	1
4269	2vaZLKcCrfafptJ68178TwcJ2MQpQsLdGuQDHzb4dFvVXrwWNMMV	1
4271	2vbBBnyKydoEc91KckpnstEFxUgRUJFEorVw7LojMzSr2L3pDxMx	1
4273	2vafQg2MG9kfLcxRqannRxjXC9LUM5mDDDnMT2TJACJyfvUZTRcd	1
4276	2vaKdhTbk9UL8ebN8xet9YgyAZ8SUdbJiNsAKDBhaGyD46VtBpwm	1
4277	2vausVkVUaBwfTkHeBRNgpzgYfeKrQLjXGBam84YFD3pXXkhLVJ2	1
4278	2vbYbd2h3WMb97rK6fvRcubgGg58SU5YjSc5g17x8zKGnjEhTE4F	1
4286	2vaWeJnMLdng1DRY2hek7U1kDKAUcymMGXQM7Rim9EoFyGjyYoJs	1
4291	2vacYXsenFSYqzFBUGRVwkFUQWiYFhPAtjP8qjB88JsXFPgiagd9	1
4292	2vab2d5yBK5PjmTKZePksg3R6qE5c3ShXhbzjnQwynh6BZtjajqp	1
4297	2vbH35qAmtGQpsfYRQTHiiL4ZVqRViNyCJTbUaXQuFMC4Tx4yjHP	1
4302	2vbX1ApvEc23urAkGTbvWF1YLiBoy26TgvVwasftncpQi15hbisx	1
4319	2vaYD2CzjGLE4FKcW23RuCVzHbccXwwhyDYE9sVA9LG92fJR5p7G	1
4321	2vaW1TQHp583a5BqqwwCqFs1bgpVVarG1dvLAEcdk82WBU3MAt1H	1
4324	2vbRJs45nkNXHH8uJJTM68J5tYxNdQAA4fc6VZEySCYFwB8GbDr6	1
4326	2vbyvGFVqRqDSPZ9VLA6RQS2NCV7BfaYQfXR2hcgsCDTv7aCXNE7	1
4327	2vaY6mUQSoNhaEDHEMFiWEz9RxLc3hfyqygNcj3XdLi6mk16gE3L	1
4330	2vbeXi5FsPAjQaJ1Pk3dR6grdBxaLJo5n1qVCyHKv25tAA4RQVMf	1
4336	2vaPtUj97ZnpvUJgZTZ4ZB8Fpjhi287srNjiDmL4UVVPkA886Ydi	1
4344	2vbmfVnfQbJqpN5fxNHAHdUz2S63T1sAPq5WxSPPRbucNwUJtcAM	1
4348	2vbsGb7FNHJwiHSe3XsmjgcidMxpudbcN68QPHaszE9nm3SBsv1x	1
4353	2vajgLBnuijzwnTAoovdYBAvX2GHMHAQTvhb1YzzE3UT6cjz9W5d	1
4357	2vbZxCo5N9kjPbsFc6XHt2Avo68MEzQxekFrAWb1MKgFLao8UF4R	1
4360	2vbnDsXVV5uKxV5RWYc9GCZRzBwpYDehUZKXHESSJc3KMUiXesFT	1
4362	2vb16SBD9vRCQWUfx8ZtCUKsxk6FHP7Q28nL6Q3eQKj8YUWMiAFt	1
4365	2vbm6MR42a7NKKfWqvEAPLWoVKzu6FcWRcQK6QEfRCJVpTjzaYFq	1
4369	2vc1rs2u7hzwz5yLUMp3t6wn9Zd7zVV4KYqjH7z15VS24TSEmsfC	1
4371	2vbAS6rPFGifTZSKAEhKkcWaF6jQU6Qe2P2NvXf7TLrGfcM5Cd1U	1
4374	2vbuArmzG5W1R4Mgq1xBnMR4bHXwDFE7kJcm6TomLEntapgn2Eao	1
4379	2vbAw9EbKHBR96MixE7qwJGuR9nW8JLxGADH9dg3k9Z9wEUD9MX4	1
4388	2va9vBEgcW994DVr2LeCfqorWn8WMG8yTWxUZr2WMdozG4TBERZq	1
4390	2vb7avV7T9wRsVxw6t8PG1cytaz4G1z5JbFkocF4BLCPnD4suuHr	1
4395	2vbTobyM5zG9F18upKbntQQAb3gfqJwpTnCvT4PZZki4aw2E1h1h	1
4403	2vahsPnDu6Yj2HVWuw5DwyzwMPfBU4hGSoeM9gteBLYJbPKxoRJi	1
4412	2vbVpE7DZ1yopNXHGeHCWt3ieyyM4U2PGDsss4dhRB5o1tdG6MG6	1
4415	2vbw79pGfT9juzhWYcEstFD4aH2eGutXxQdQawB34RoaW7Q5jBqe	1
4418	2varmLYqjLw7Pw6ZUgpmtMkfqkgbVe6GM1NMJ7LJehfp259gY7RC	1
4068	2vbwUGo7DQyMYYVnevxL6gxZsi5rmvLT95Cta5vyXP8Y4zwtm28d	1
4071	2vb68CziVEmoSYpUPNoLGnQC8r36mw5CfKRNDK5cMunVWWhMBxeM	1
4072	2vbouMk3DeihASSrWmd415fLvDaJrcTLuTSPrWTjGgzgN7tiUHkg	1
4074	2vaV5RRxFdaCCFazM1xWJVBo8WMHqe5PoCJ9n71MzXVz9G2NRWve	1
4076	2vbmTbToZtATS7kReR1tunz7wooMbqXV5EU3oszQtuuaGoGBqx99	1
4079	2vaTg8hT3ZEEKBP3gAuZPuKooPqVCJccLf7btYGeTJ82Y31xb57Y	1
4080	2vb71eCxDhFkBbm6hcm8hWA5HRvsDbjwMfJcnoUajHrc3kbERePr	1
4082	2vb6ueWGQQyy9Mo975eRhTrr3tLo9xAcbufiBpbYkDMc7nHrsgwM	1
4085	2vbtHL9HMXBBdmKAnq1VdgxqE1JZeEFQkwTgQgeynfVgoboddMwm	1
4086	2vaV1LxBiqPY6aR4QdgvbmyhAyawLP81ckmnGWTFqPkYBf4X3npR	1
4087	2vb8xCRNn8hYtd1ZhD1f5r5xXzUnsow9XfiDRvsdEF4825PYDscE	1
4088	2vbMoctmTh7hZ9FeSik8TsoNDwnyLTu6CQAJUue6Rdbz4H8gUZRH	1
4090	2vaCT4dbfHHc8QXsXN61rAMRewdhguSL7kG6hicD63RvUPaYLz1v	1
4092	2vavRRo36fpLgQC27S8SM2wQVg1wkERE5AAMqMRTSKBpsKWQWqUm	1
4095	2vaSFXSTQBHVsu9udzcfZQPyibZLNsAfRcdAhUgwBnCYJLyeXJEH	1
4097	2vbogAhJu6ym9xQ78mxGihc4RRnrBhhTJA9qV2eersxrYf6esarz	1
4099	2vajP4v7iXgdk8NLKDY1ob1CjfwG8DiqqfXcSemarGutuxavJ7Ji	1
4101	2vb4pkG1QUD2gZDkNuux4LojFmgoEdbnwutHZePmmrHgzVhj7qD4	1
4104	2vaGnN4Z7BrnWYgh1Ffeqt3TbR4fAhLJmSJ7npHt7juAuVbBtB9o	1
4105	2vbQAZFbiubkUX2fK5YdV9qptuoP7gTCLaS5MxMgAPjUs64ZaTDJ	1
4107	2vaHDunNnqCjo9NbX5LSMtro9NS7o4tbJay6WWATmBirc9F3xHAP	1
4109	2vbT4nYE6AE1UhRyknFFUAnub5xVJ1pc998mMJTNNYNRoproP2Er	1
4111	2vapiVxXs26LxRHEaY9sW2P76DNNMQzkc9Qf2K6UJnatwuDAyw5C	1
4112	2vbuEZ5EEy8U2Unuw3Rh2BH33xZ4GJ6B95424xb5zUHfZN6FN9eY	1
4113	2vbr5gq5AXNKwghr2z9oqtW9uMNBkWWY42xFpJ5NpfG4VLvYdTAj	1
4115	2vaPWifCcRDw781k89xZFGhra34oftNiNwNMWs33kex9m2uKXmN1	1
4119	2vbgT8ciT3drkot1hM5zeWDE2SNcycG8PQTgFt5yQ4bsJBhEaij6	1
4121	2vbHoeY7g98VeLf5EfVSbQLiMoxLwzGT3PWo7DxxSrEic92gvnwr	1
4123	2vbVpmYYoYPixd1Y5qJiSrQBXC5nJPiertsrhh4WBZCJEPF3dJTL	1
4125	2vaUMuoTAXzgT6QMoc8MNhkH5SYEFtWmEXgYEBH9qodq454iLG5d	1
4127	2vbXJsDzjKV4SqNGSzXetYSzyhipJRsWZgUjttC4WMQYEpvvykah	1
4130	2vaNJujsWGUptcxT8eHDVF7ziedvaaN8zeXgMEPKEDSrSq2UtNG7	1
4132	2vbBg6iCdZDsMms2XAudRSQmPNdUdtUdBadt5DAkX6Mrzz265YhR	1
4133	2vbBnABhshtbsN7z23NkzVnqWu7pqMbAiCYUkem8oa2A8o3Y1mHk	1
4134	2vaUZcw8HX8pchtoQdbx3YzJTc8ww5DCR1T6V6foaWbk2W8Xabf3	1
4137	2vaKwfi73oxr76FY1R6XPVZxkmegBU8FeR97pzCxEyZrwAX262Zp	1
4138	2vbApFAJWnfzAxcCaeiyUtKwULyNKY5bdfyj5migEe7L3T53bsCD	1
4140	2vbv64rnz34xVdxjhASLWo4UcCHZeWvQngMaE3aemdSvhtPKyVLX	1
4143	2vaPW2DHodaFPH19x1cLP3g2fp1Q3MNgS8QsjTUZ9U97CD9GRFZb	1
4145	2vaos2oMT5K1gB75aFVXWCupnHYGei8kXWCX4vLEnk5epbyAigCt	1
4147	2vbpwJ49kkmB7DkuFqnAjvZMPEbcCf7yPJrd25rLHjHZse5iwk5V	1
4150	2va9MDqBSuEPfEXsodoFzYW25n3xJWBwczjBVg6ji2m7LMTTdyrL	1
4152	2vbJk4rSBViSKcv5VUkLUzqBpbDaJNNn95PgUkAy75JHfeKxU5mB	1
4153	2vb3ENomEWTT7BakLunSzz54qadhtijqph2qYnoz2r585p7vvkXk	1
4155	2vbrS2z5mn86eK3rdeAWo8J1faLozjX4Wdr1h8FbJfkCJxe7tuEE	1
4158	2vbci4YB75WV1CTD9SVS5xEbRdreJhZfbojmBSSDPUocDL3B9yyB	1
4160	2vaV34eFChVaUuAnmkQT9caLrMxiBNSVridat3xp9JM5xhahPKXk	1
4164	2vacKe1p36Qug3RZcR67yuqLqs399E5K6D35AsvY9jXgZbyPN34H	1
4166	2va9c1Yaa83JxbGovhSFWJxCCqiWf2H1mxsWY4yKm7T5ePJsrP3o	1
4169	2varvgopAQojBe4C47wUZ81TmC8Rrbxa5UTYLnLkDPvSg7H16BJi	1
4171	2vbW71zFK2nMLUz3RnD3pine2Xp31y411o2xtK1i2pncgAUQU7i9	1
4172	2vbNgarfEwPBmWihDT3JpiyfUqs3y4dX2Dqqo5CVtbUdtbYAuEG1	1
4175	2vbqz1mNVkkqTcYbksYWRt5FYXFAXhgEVXTc2zPLMH2t1sAPhBVz	1
4177	2vbM7YXWhqYCMViZhhkYSnhtEvwfU6dJE7f3HWyqdnqK4QJWroPE	1
4180	2vbM62zfFAf6ww8TChx5RvaxLHcogsv3StynkCU5yrHJYMkBoiQi	1
4182	2vbpNfkQuUoQbD89mMNaLdCghcvNhgtwX2eBvyqKqFaj1FkpXeK4	1
4184	2vc5FJuAck3gTfv3uWsPzx1qMh1h5V5jBW6JagGCkYbVf7PYyUEQ	1
4185	2vb4m1ZZYayt8nwHuoU3kKQ3fgpvWseZMSmkoZ3URJYRSvL4m5qp	1
4188	2vaP3EuoiCpHRXeBVzwnA3zeGuSKM6tC5dRFCW4AZpT553G4By7g	1
4190	2vaLyWsuWZ5G3Gt1hjokUh6inENGbARaJaWuRcoHd6RHfq33TZ5a	1
4191	2vaHAueCJZRavcW71qpT4hYm1tRtV7jQyAhhnDE7HhgoenNsUEdV	1
4194	2vbkrWaKVgDhX1jSzU3Fn8cQ5zhJ3m6cR2b62mmqg83nUyuvMdis	1
4197	2vaMGwVuZqqQDC1WNzkpxXR5Bs2FS9auwKBhaLPmG6VLz6cR9FHA	1
4199	2vbyK3zCDpqVxxD8GwjX2iJzpPybDUS1nXfhRyDyd9JLSzx8W7pL	1
4201	2vaP48tKFqGaBzwvirvtznWKrSWLp6nA16m1bLJS9ewqeUjbBeNQ	1
4204	2vbXvVtLVjwiGjqVuwgcYcJ4urjQMFFbvDRpsQhpu33shpm63mW9	1
4206	2vaHMXhvf5yygSWMsuxcjQejBLF5XUWrqjGhp4nH6jMNLGAeqpP4	1
4207	2vaxaLg1i13qQYbftnPzVZu9BEgx2s4uFxHp1xSamfNjCU6quAMP	1
4209	2vbEpQb34QdsU8obFPFVpM6WQkBASVTD4ftBWj7Udr6jbtbBrMiY	1
4216	2vc2qLj9Nkq2jzKtnaHD4got7W8VLde56vSmqy4CXUPwEXmjUN1w	1
4217	2vbZfcr7HdQ9PPcJ8av7JCyeJA3vCTUYRMq8ywL5zKB79YYDPSdk	1
4219	2vavYBv91kFaHpAQDLjCYBNH1BLbYKUtMobUPzZMPd1WgdztzNab	1
4221	2vbiMdf9z8YcpmTFHrHFkVzLiKVMFJxK61cQF2JtyBYtJf1huLMa	1
4222	2vc1eEP5pdVUhVcr9LS4nkV9w7vaPPggj9aTF34ZLS4W5wUqq6WY	1
4225	2vaJ1UnnqudaGzmrQJNWS1tpX9Jd26mnyZHpu4T7D1fRtLrng9tP	1
4228	2vbhJPp9MJDoYL7muTvmPiBwJ7dZqSrB1jrCEkPq6Er5rGPbQP3U	1
4231	2vbhHHtRABhJM7NXaKQELr6YCs7mgf8Vs2pz8h5cceQ4gpeye5kr	1
4234	2vbwJM8upSXfvr1dfB3L67iFTpgZQMpcfi4ecRymYu1HS1bQHAEd	1
4236	2vaNb4A82ZsXKTfUQEsyXvRw1w5Y2sHjxPBMEFWUco1LyHqfoqAv	1
4239	2vaDcJyPJ644K4c39Vbnj6ooBpLoHeZfhUH2FwXBAfXU8VGvM1hG	1
4241	2vaseMBAZHKe5qptKDEyXPeM5dJPZQSsXHNJS3jWg8J1S2boykef	1
4243	2vaHRhCFbupRC19nRBPNDaF3PPLp1Rhj3Xh6B65QjdJzQmyy9Ydd	1
4244	2vbwXs4pVKGJLAvALF74Pq69yqNT57xAYqoDTjbAi28DyRXD3v5L	1
4246	2vaVvDPDKBtCPgvSmCQxaoHh2igHLWs7p3nBQeHAkb8Z74m6F7KX	1
4248	2vbHyvkWmrDkfriAMDT71ev3c92UPYHwuLWvJu6Qgd6E3bzvQ3Ru	1
4249	2vbqSiU3kAD9WcFns8USqnnya3wddUETJBgwjj51MkbS5dr3gX83	1
4251	2vaPvjyeyiFLJ9GfsDnAjs5fELkg73ideduicgJdXnuhBbLSh63L	1
4254	2vbs7R3PAc1G5HvTbcrKrkQFHzgwxebALUnuQdkiudD3Sbp8m7d8	1
4256	2vbAhjZmeQGdDyvZ3aX5qbVcjZo7zL5BXW8PapKRf4Dzq76pe9YM	1
4258	2vadUHjuW5Rj2vTzwR1Pu84U1VCSogJqHHf2JnePgTVQrVDmSGs1	1
4261	2vbds1cfnGLw4bc6UQyWFC84CmN56atHSve7bhjzUaY6Dj449gVC	1
4263	2vc27krYBSWJvKupZ6fTScXVViY2ZKjYdVnaQFQxhHDYcJNNikQ6	1
4265	2vaNsaou5GJiPLitjtHdPnwsbT6qzA8mXQ5MtnZdFnDrpa8Tdc6P	1
4270	2vb91tiG3ZJnVvKdhmGdMCGaV92Hhwze2hWrGWr4Gr6xxm5Jthet	1
4272	2vaXgh4KDXRrMjtHJmWyQRjP5kqkPVvWbNA5WN4yQuGD5sWjgUKq	1
4287	2vbsNRSjbXNzHLGAr5W6purHMtWUmXaopKKR4gPhn98wARdW1aBL	1
4290	2vbEJ7nkD7sfcwcj29dSaBwrYgQXbuQDFfbZNJdSSu5Ahf7GbHWw	1
4295	2vbYgG5UiuUmg6bzKWEXZaAa1RdjUs6Bsp1dz1e3q6qCxdozd7PS	1
4298	2vaLVEcrnZbEytFdNLxtj3tNZusQsv7RSdWHSJBXXA8XMowf3m5p	1
4301	2vadd4zYwyn37f6cSdtQbGRYvzEzPakWVcMwCUxwipTkFkv8Wy1E	1
4303	2vbQvuHFz8afhqgDeycnYkZ755HVkdpE1e6V2uyd8N8QULH62G3m	1
4308	2vb28e4kPgz7JFTyGE2eaRfbRp3nruiVtprTsiWiiahp9JYWVmyp	1
4313	2vbr6Qt9G4W195F4ZN28zF5fWju1CoQwJGgKz4F9NH7hNu8wuqLa	1
4315	2vacs1SSfArM5bo7vxvfThcsZZrxwkAh3xfJ19R2LqYpiujoj6w3	1
4320	2vbv8YLrDe7dJBXYdVpfFU99EnFbdNbe8kLVsuXFXwBdFW6a2omd	1
4322	2vam3KVTR2gKtWvnKghzAj5DMs7uapzvbQfUUQUKgADqwKMrQ455	1
4325	2vbRGsK8wbdKWnFKPAYKskdwjdvX2WhULbsWQiXabYwtbvTxykWw	1
4331	2vb7fkDQPb3mNm8zJxRYkdXyqumBrL7iz6eMjGmGwbZKR7UqZjaY	1
4333	2vb978MsxXypKsrrxGR3dbwHarUWiShqNTQrQZaqHtKuhqwMKY7U	1
4338	2vbDuvSkqbUrXKkcfk3brUTxecxMHRKRqJSEt7FBJJjoQrvJEi2y	1
4341	2vbvrqffxFjSEyNXf6qoX2jqBCnEoRYtzrtajhh662KVECS62wd3	1
4342	2vaDbCUp5WHdFAhty7Chw1KdHCXrP2vsS8KyG4sjYSbmdfWTSe84	1
4347	2vb5WQE9mZqLjYKmyNdc7LjD42AcJaSJ5uroHbfJDWncw5ezNiQS	1
4350	2vbZeSVpV32KJAE377tJnZkUE6NJzSqBXhFrdSfv22au5iEZ6a25	1
4352	2vbPfWdPKpKv8Em79EzUKCStM5vgzYjDdFHpWfxa2y2ecR2Ys2gG	1
4355	2vadEvBYXSwc6xhPFyQzpYc2Jx3cHJ4tzvRtWoBkbWBcmMFZKTnq	1
4359	2vbeybFAeeHbhxogDu74aCiQrUw1EcN3RsQqpostNdrHjYacSveL	1
4364	2vb7qMgd4HTfKsCVHd1VpQBgkKGXZStr5R8k8P6kgBCsrWUVrPb3	1
4373	2varaX7z1NEUgWKpexhzkRaNefaQkJabrJdzuRFHLYnkkq7Sh5sB	1
4378	2vbPYywumwAM4NfFin7fgiHa8a2GUP8KL5BKMJZdDHgoSp2gqitg	1
4381	2vaZ2VygBxiNpRLKnCAtXiw7a41TTvz9aDWb2dseJNvVRvgLXuKV	1
4383	2vaxU4C5Zrm1RickzbshmVtpb3TcPrcUKgiiBCUBbrSU1yfGXgGg	1
4385	2vaDpHorTdDpzAZcYuD4GWovEvTGkerEGcP4fBYuzzDbL5348WvT	1
4387	2vabmmgHa4azMste7uqDYzfhK3WHjz3kiP8CVw6kifLDQjvNQ5ie	1
4392	2vaXh2Npsr9J9g4vQLwJnm5MyMRYZBS3TPnR9F5Y42rjnTzYhD7s	1
4396	2vayEaLWpqBjNr48N1cJzogmyXfZZxqBNJzeV6o7pqAtS8mhJENM	1
4398	2vbNFZEjeHzSZsjDchfVP8QEssgtJCMmHhMYJ6rhwb4giCWr8TFS	1
4401	2vbzdmiNQKLdeUzuEBdsqsger61zdHwuUB9zMMB26yZ1LPofmqPH	1
4405	2vbneTtE6wf16ikPvnG8kEsQ3QCwVdjxLK6acSrsRKjaZJHV7Fkf	1
4407	2vbWnDdcb7N6TmjvBrLhKWoGRGefxR4jVtnfaoDR68hy7bNYcru6	1
4410	2vakiomaZtXJSy6oTfD5p4FoXtchEkL6PNDjCGnibe3qECTf6HQL	1
4414	2vaZZgQ7mngxNYoPAWEajCfs6XzCsjLvyy7EJFubriykkj2SGQFi	1
4420	2vbukDP9oZvzSLJGHxizDTwPKhKLciWmm4CKYZnCmZheCYCoZhoy	1
4422	2vbZU9TKQ5GoYUVoxvSuUNo7RPe1xbEzUfmCRq1LbR9TnZz3DiMG	1
4425	2vb3SXxKJ2Cz9myrvcJQVffMmoxJ8aoBdU67fSZoCwUGhFzvtMMU	1
4428	2vaKBvkx3xqxkTEYJxusq6zAP5Go3UShkvM6mCK3xoohAE4zHee6	1
4430	2vbWomXimzNiDgLzJkrRB5TzXRdn5xK6BuFnJGwCQrwQSpkt3txZ	1
4431	2vaNiGHbrJ71XiBURRb2Eqrz5vTU6s86zTgDcGYn1UChKEVkN5NU	1
4434	2vbS5wcK7Yym75WS5TjedzwowdQnp7JFCZb84Pxhf1wPqMsbQVND	1
4438	2vbx38Y3gec8hDruDoU8BNPXcZSndfkk23hqg5kKgt8J9uy9WatP	1
4440	2vb3aiQLxHr4qxbi7rpZ9hTk8sjYThcXvQRfkYB43zDgatwaGGSW	1
4443	2vbjmefRHuCH2oTgs8CC48XHuFWkxkRR9kPUwcsSkkxtGn3GXdmb	1
4452	2vaTG4coEFtZeMgBeQ5ZMwkmtw4yvBmg4FohLgizGmJmnpAFsfSC	1
4456	2vaCKB1bchLgWdKgoeGAo9pWSXpMksX7qCWQdMyBS5F2ahBiap9m	1
4460	2vbKfH7nKyZGTp6cqjCWSLgcMyADvFnqdzKQwn3k5p51vMohLQhb	1
4463	2vaSB993rMdmg7Ho8QhadtMToXS4KcR69txDKoM6NcMPSXi1Ug7q	1
4466	2vavzEh8eQ1UNFeEfPDfBQ2ZynpccTYZTbd1au6N83T26Pb64jm5	1
4469	2vbiGdEyQi6ga43LVp1VcptX2J4k3Ydd8aGzYkxHy6RJGX2ocLVm	1
4472	2vbXDnNjUiwRTqsnDdEHK95tgDfUif6CpcBXVvUc6FUWYmxYp5uT	1
4474	2vaPg76KcxhzbXfBQpi6VoEwzhcghBBAUcVPEPbHFJz76SdjgPzZ	1
4476	2vbqQvjmr41SPrqu9UAXJ2Tfr3ZKRPjLkjAXNd6UMqHFcvt6qYL4	1
4484	2vbfC1hq6hsYQmZJ2xoh9JxAcSSb12NePWaC7exFqyw452eiND1A	1
4486	2vbXqr87uvz5HY8VEUjX4wxYcmwSdi6wVn5AEZQeusZ2tbhgDJ5V	1
4488	2vaViTqo42UVfBw2TURkxGiFEVGW7pEqVbyTUQbA5b1urRPYZKyt	1
4493	2vb1Kn7kmL1AAE84LV8AApm49oDKQak5H4qG9nSGYBBLbUVeH6RA	1
4495	2vbM7m69yFGnHJkt2QGtoh9nxrnCB3GQnvvjuDd5CWMPNkPgd1iF	1
4501	2vb3iejxZHtP9dSGPk8ZvJJ8K7bykUaaCdFVbV3z4QzQ9vD6iCU7	1
4505	2vc19dTrShcaKWCyyqw2QNnNdd6Rj16JWbpEwwcwgovk6yVtX2n1	1
4507	2vbLJuLdeMuu5VGmLjX75Dd2BjjjDqWqDEcEtEH1EFBuA7uCTM3k	1
4508	2vajdN8EzjoNYimTSjS7ZKMnvFcc6d6d6nAxXjCt4sE7tFewHeWq	1
4509	2vbhrEaRm9rCjWaRGjcpPEMjd5eoRLfm4bcp2YtmZFxTjppaGJES	1
4511	2vc1Znps7KNrLF6DPQKykcvXv497pNhJGodM5P6PnNeMHJtkYNPr	1
4260	2vayLpvucVRvFaog4ykwVqzNNSxt3skjPrbfHhKwsAv2KSQRnvzW	1
4267	2vaed7LjhHpoCYuM7H8YPykh7cP6GzXJxmZmqoTcKUDpn7xKpwXh	1
4274	2vaYZQMKnhZLmGVpPvBgJQQYGWgx6JzPQ3a4JmaZfkj3k28HpV4V	1
4279	2vaB14PLqSpoMMiSbUeeiTMZpUv3ijFxEfDCSqwo7YD6ueNjr7ak	1
4282	2vaD1HG7s8RiEa3YFW9iwvN4RvAR79Dp56BZS2xzjtAvGhT13Fxv	1
4284	2vaYWrLahBTPSZAsc1c1RKWZmzMn8YHXxrzH5DNT6GZRz2YjptPh	1
4289	2vahQGwgSw85iA7W1m6u2sXQRVQmmqieEY4gsPS2Kw19Pv5Te4Vw	1
4293	2va9hFYphmxSR5e6ZcypxxpbVBsbn5Bqp5SQh2fMq51fBebqgWaC	1
4294	2vb7ixu61w74rxaoHQAW8JQVgvEqXUqEmDqo6MJcKKws4sNGkTBk	1
4300	2vaPAKu8avaTc7Ezo9DAvmo2FXNiQm3ZHyEWujYYgruy8Ykz2HVY	1
4305	2vbaTbujZEBzm8WLW1GxzXkyZz2zgxgYXaPLG4ySTieD2JftuLPQ	1
4307	2vc3bSA1WazojnyhsPUR7Nv3K6682SeCGRpnNCntwJEReGXWEgzP	1
4310	2vbg3G7nkt6SuejURvvZH6ter5sPWZ8hhxbBpKJYX4X25atxwiJa	1
4312	2vaEVjRGmdTQRtXjFnFuTeCXg2vHbYRBA2Z1DtFpgtcTXxEh1R91	1
4317	2vbM15gwBaS8kW7WEktc9ke6wZtXfFLHQUsh8TsuyTPu8MNZkvNu	1
4328	2vbyB5K5tJC1JFKfP97SHcbcPyoPxdSo5HZFj5xdo5j65frw9757	1
4332	2vbP9K2Rw4kGD74JLqJDEYPewZgipQ6P2Dy93VsJhrm14WXKhMon	1
4334	2vaZv3WgP1nj9XrdVbCTj5YH2cuF4TcYNjan36WniRAbXyrE9q8t	1
4337	2vbZZigvJY6NkBfPSAzUUiLnYgzudNA55Mkbiz7Nn86xsaTqMqYp	1
4339	2vbJrTrxLS2TqVs1VRuwf3w9S3gG6LKcyj55sghBqZEgWRg4M44b	1
4343	2vbRvatkZKW1UzBGL2cBxPNH7wakaSrShx6mAkQNh3qQrpNUahuc	1
4345	2vb1EtCsq1PsUbVEZKG43JWzUEgxmPY7cJvFknVAEtrJ3JPVWgZ3	1
4349	2vb8sJY1zn4JEqZQZEtnykdwj2vxz5x4g86A4xiPonTF6wHaeDBG	1
4351	2vabpta9WcBMvcvxsX3YxL3b5Z4GoMAKWsKS4htGtw4jj9mRKQ7x	1
4358	2vaXyK8Scmc4azUDq2zNh82dpDS35z24nEt3DqMtCA7Vx4v4PDY8	1
4367	2vb5Lk6jfcj63XYTJX2KhHZMKBcB5wVP664cWpnxVaa55FTVcihe	1
4375	2vam8LTEr3mVcvcRtybgcwG7UiksVMSv8N4RRHX8a2ZhYTJfBm6F	1
4377	2vamnkUV8vjMkR6u7iQZd6rSbsUNGqr9xpvDwSUeBDvHdkEbe7uc	1
4386	2vbe9eCNF68Cq2D1xRjdoM4oFDjyqg9L42pS1SDk6MQHZxUW7K18	1
4393	2vaL1hDuetHywvAwYkH1GYR8h28AMFmZfaxxudhNkm6iodd8SmbB	1
4397	2vaYPvFoh3cULRhkgpPyau9qUjTiFGZvgT4VjRZrQxptjnAoBvi2	1
4399	2vaW5iFa8FR5eFu1ErBoYa4VJprqW1rXXyta8iaNcMruYpdfK61N	1
4406	2vbRzoosCisEfGcBtfygcne6nos8M5NxWSpGPvFezHwJi82Xk3Kt	1
4408	2vaZEauevy8sNNviCaBj2KFtSUtUvrvPhxk9Zdzkqn1hRBhMEYXB	1
4413	2vaLWX1sqGNQs9JT7TxDVw7TKGZmcCsnTkwe7k1JXcW2t3p835Bj	1
4421	2vaF6SdJ7DwqaRT8ioJsXFR9YFPZUJyTffa8Da8dfNmLypv5L7XN	1
4426	2vasBNSwUVcL8SHD3wkTZS6htznmUwvubqm9Da4Xk958gKhbWJfK	1
4435	2vbSWm7Gc37t2QQNrjXxiM5KEnZtjHFCsPJZyYyUr3QvGE5tRaCA	1
4439	2vbUoUQ8UkaERiBHTDaT68u1QbuWoduK2tj1roWMS3uuTT1xqpRw	1
4444	2vaEBnjJ8ekC97mMDEY7QZM26BwFv5r4HB6GKzmPTX4QoyQ5kP6N	1
4449	2vaNguX2rvePzRaTDEAb5mmqZ3b8PuC213mb1pLr66Mzu4ea5KsE	1
4451	2vbQ4kHvx7kNRdynKncy5WXtavWfSxYRdi74Vih1gSfiLVKDUABP	1
4453	2vbsh56mBX4BrTVgsvKtFAYxBtmXuD1SkYR38DqEowtGwP7Cm9k7	1
4454	2vc1vEkFUB2DhxdQaGk6ttQU9MpwEZUh1h12q5rBhKxWMeaQ8m8v	1
4457	2vav4gxVoAYHhyX6Jfu2xx2gcMeZu9FrESp7ucdjDGS1CCN46vqJ	1
4459	2va9pSjvzv2rp6hnhEnHk94TdMpa6mFncemev7b5VtuS4nkLdwxU	1
4462	2vb95qqDzFWD7sC4BbWAsnFM4mZHoDAT7rtmLJQdmpmEzkgoBfwr	1
4465	2vaMymkJY65WnJ7nxZHFSNmEEJB3vbs1zbsHgFagg9fWXrz4KbHB	1
4467	2vbrxPyXrAmaW31SrjeE6KrwQgriE3XHbXKQkYAGAZmtXA21taf7	1
4468	2vaya3g9NetpJZnMGiydRz8oJLaMh5hvPisyHn8XRePZsn3B7uxS	1
4473	2vabUDMTHBdjE4H2WSrNDvuYz9Gg68m59TUdJvuFmLSpPns7EYh3	1
4475	2vbbHNudYjvvSq836jqLipnpyiJrJcv5btvxRfdS5xbVgr4ZXfe9	1
4478	2vaeafuR5cbAsWHZTQ1SyHUqvVw8aQYzC8cMihmhn7T6sp5hd55z	1
4481	2vb4xhtX76aKfPBQyJzNHDcaBXic3FmqQVNbRdcZq4gCjUQaAdg2	1
4485	2vbyCMA6y53WAxD1H7cLJ3AhtQWgfGFKTXnYdFx8nhidM1UgA3MR	1
4487	2vbeHZfTfNoT1jyTAR5vw2HZiMXCczEvuTwwqHbu85wD5Yk4QotR	1
4499	2vbVPSrWQfmNUJgrhk6uv6RGqEW4QygGyt6RpeZtUfKk6QSGeezB	1
4503	2vc42ynJFwZMh5x88kkwFeZ9bCs5KTt6AZyEA6PPqYcEmCBaH9vA	1
4510	2vbCCVgCvdfULuu9SKEtS6mtjeYzUp4EqxZWpp5hS7HU6SSpTPcS	1
4513	2vb8H1oxTR63daG6c5izuw54z8oyUSAAdhhzwuRmJQLQwovQmbt7	1
4517	2vbEJZLGNxffRNiJVjZWtYR6MtCqeCbYBzaNun1LRGofSnc6WLGQ	1
4389	2vbFynp1wT8UH3kSPPrJyrRwuiuqyLGNcsoY7xichqnFTgTVduzx	1
4391	2vbyucYba7XFjYbnzCD1r2tEjUNbcTWFjb72rRm6GwrUvnsJxXn8	1
4394	2vbCAtN2WtR4rVUfFMu2qtHowULoWCMnCd1xNKMHV4wqDKWhK3GA	1
4400	2vac5d1EQRjDUuX8n2ZVjEXKCtZ5Nt7QXSpjPbN5adY2rRXdmb7A	1
4402	2vaxisPSpzwa6crYnSyohmpBLDotLBUZza5darLG1yKVRb3u8s3N	1
4404	2vbLWHLiBQ2McEWe4XTUFTFezJ4hYmCZwp5kkeVZvMasSBwK8Ucx	1
4409	2vbmtGL92QZGWHbfmL3tQagUMHfCLgvCtRJmXLbcUhNQtvkMtz5h	1
4411	2vaHLMvTFPyj6gEctJRaLH3r7AFL4LVbMADaYQRmEK8rL58SUMRd	1
4416	2vbHo6njERShdNirbymgq8dZfzJyMnRiBAKU77pg6gSsw7dkxCi1	1
4417	2vbzyMXHMxaPvTXqKujwGNdkgwjmniuJ8CnmKbdBwxMzwALysXaP	1
4419	2vbVHFEMobK9tncehdNSfc1KMgedF2QDtrsZg4C2KZc8N8Jighst	1
4424	2vbGj7bCcUp6pxhDxTz3gJtoGuo5ubdAx4PamLqRn1712d6f24ne	1
4427	2va9wRrxHRe2dJX51Fk2cR7nhGAt8PQwAHZzJi3ay62nNsuknGUc	1
4433	2vaGhJKbVQDF331LTSdTsAQ4UYqCvY6sJ7GJ1fdjkHyxYAVR9GKQ	1
4437	2vaTRy61xxSRZgVmdFcYQkXnWWRhHPwGL45YtgAmHa5fjXxxEkMe	1
4442	2vanVvu3A9h1oxmnsbCFgUcNP8F4aShEA7x41CZmneNxe8KvwjfS	1
4445	2vac7DGPchHNt3Zyb2KmayUoTefAwhhM82HtaS1jJ8cXJ3y825kZ	1
4447	2vacPNKwK7QWwZQSy9h2deM5JxfPytWow8vBB6ZtA8UcNJUqiA7m	1
4450	2vbavoMoKFy5oPs9ntLJmze62W4bQSFHJEUCd4Gfn9ZqbwFKhHFR	1
4455	2vaU8vFJTLhrdLfxfe9xTn9H67kXh14Ve2une9rEh9z78CzY5qQj	1
4471	2vbgucm9ACTxg4wHupnU36JuSVBkVp8xLFNRXUby1NcpsAEyPM4s	1
4479	2vbuCZVCtyE3UjxJoz2J7dySD2aVrR3WnZ8u23umBsPHYoUDwEYo	1
4483	2vbSpQeCd4CyGNneJ5wUstihfEDQ1DZFpCeh3AmsWikjFTC8GN7G	1
4490	2vaHtxqodjT9VHxC5dJdVDt77Rk5HtoExd43oDi6QGra7STTFTsD	1
4492	2vbdgvXw6i9u6MGpMYryPwyhsoA79DhkqPLm5wMhYK3zH7LtdAfU	1
4494	2vbB1G87JMumH2yLurcrTd4u3YDDUoibgGCS9pPhdvmfa47EDMwb	1
4497	2vaWpT1STFqGqjcSDx156EY2TAd6u4KYcFPSurncifiT7SyJJxR1	1
4500	2vc5Wamzxt9dNrLpamHnLGz2jQUTVCYqNtkFLW1E85e9JthGKaC1	1
4502	2vbfBFwPJhfwykLarNZtUfwCQNZUnpqtNEP3axScqGW3jXQfq3fz	1
4504	2vaAzKV8eunSoSJ72aZrc9fHPkxvrFRR57F48S4SVcY3oPnypesg	1
4506	2vbqnAwST9EGNH2F3jArPZGMzn5YA8QTxX72LB2MQgH3jCL2Q1rt	1
4515	2vazpkYHif3qVvugNspwjqp4ereMd4A1wFXBNxEjKpL6EEdf23wK	1
4423	2vbLqwSTt6pauPrVZDGXNqd1chiGhSJWFHHM7aqrA7QQtjSDYnKp	1
4429	2vbFauKUK5RyGQpiDW5fSNJ4PT4DLFrYUSf7DKFyHLrKDrPqCr9R	1
4432	2vbNLEqEpddLaj5xzCA9EtzvbzRShAZKWjJYemu8DWf794dRrrsw	1
4436	2vamENyYLTB4LHk3BsxXMyvgc9XiGfHoEXmhWW8xvvqjYmoEuUbf	1
4441	2vaDhkpaAxzpH1XF1WiwUyhqfQoygxq3nAAseEkeHpM2bNzgTj5C	1
4446	2vafmbtbc6E4cpEes53mk9owjWKfuCu9dHpss3w483bgAC6JkqWn	1
4448	2vaiAB9a3L4b8UZdjHAjrzQ9fx2QssH5oNM23GbnwWaTKVniErkP	1
4458	2vbbdMGHBpsSMqYsNpWQZNxjyZTBLyxjGXXqhUfm3JFbLqanc4EU	1
4461	2vaSRJz1XZDVzkqBfRa5BszgQ9Bgsw8ti9p6u5qWEcRx9Twqw7sV	1
4464	2vbm18MBvgpqoUATEAz9hCnW7ACULFRVkMCtVMGJjBrn8bSwyaqQ	1
4470	2vahbPwbVfeEnHUWtppxFDFUchhcVzMmD9eXZb4zkp4hmupH2JdW	1
4477	2vb7cYV4AwWSobGuwsojBmK8a4mY3upcGsDwfFZFN8Pehsu7qjx2	1
4480	2vavp3Cd2KuA8omWfqE1dT5fBnntZxRffdHXMqkjRzoreEix1DBW	1
4482	2vb7wdBERP2DRDyQx3as2NhekMfyhUabJDud7wuxsiH8kdxY7XPp	1
4489	2vbWJBCFjZdCsthFmtzMSKxz6KmevKKSoTWEmyL2ygdHyujFFrRa	1
4491	2vbMN7gddq5f3A3AxZz9Ks7XoCr996nFnDnAf6MNSR9FTkLBfw2b	1
4496	2vbrWuxkrzjeYbCndYJdrReBZ7JeiJayTNtVeaoCDFzb7tGK7Pb9	1
4498	2vaR61wuxwmPfh2Jqic9nkkTDsKN74fw9Qff2hdWhTzQJ3KoALkB	1
4512	2vbqmPo9XNC6xuUPaeY2QndbN2ZhPXJxN5Jaxug4UKpa7s4iy2NE	1
4514	2vbzCQXvJtC8evj6YNW5NvT5NL8rbYcFj9aTTP3sEWtCLawQB4WZ	1
4516	2vbxZ4KGPHGYxrNHxeypLgWi5n6MMEe5yjyHo6f5yfXqYo5DL8uT	1
4518	2vboqMgXytLzoo91T7MhatzyCfsnBtidSQJZHJYEKDVPaPZsy7q3	1
4519	2vav2oAvCSE9vhY5tvYDbMLZNj4Bu93vhdtkZv3yUcUgs1ayKg1Z	1
4520	2vb9Bq2Wh2wQmkZdpmarb1JRx7MB4jQTGaBKWgo1TDcB4RHzFxi7	1
4521	2vb454Mj1kF24P8zGZBUXGurZUoKwDRAJDREvLyV7LA1djVRBEnX	1
4522	2vc5iZffUeUh8Mz4EMT4r2QeGpMhGTmhpNKhtH2k9aFqkgQj3kQ6	1
4523	2vbaAX3g4rPZRz1L3DBL3dWVsUN6sjKQhhGyd95H7L79aR7WgWx6	1
4524	2vbAfNhf2D9u5r3d9cKqPmxKnmM2hdtTHRqQPYtPuZXCjgakep8K	1
4525	2vagYa2hV5fLCY5dwSXmkTcjDyU2cRNcT9gAGfmAmXb1URycb4q4	1
4526	2vaUfGssBR7WLYqNW2nGdwJvzeGS1fhpYUwzepFwh3hykwjyHGWz	1
4527	2vafxQPqWXqdy2r9FuKe2jnfhCRtyUeMVi5fJcz6HtBhBzEAMJW1	1
4528	2vbJBGG9gaYDXpxYbsAsmiLxGmoTd6sq1KuawHLYfPUyVbvDBmTN	1
4529	2vbMGPrZWb7Exvg2qgJmHbw8HCbcz66YNAo8QvnUQ3v81bCHwW7h	1
4530	2vbDpSp7s3XzYeEwvvuTD21Qr3Z1vbTN29jQdWXWNhEs1AwsbsHo	1
4531	2vbhmqX2yekinzUhXsDPiP8HeAr5YU1CekmGfqSuCwx6wpuvxWgu	1
4532	2vafeaqynEBEhuCTek8439T4TW9wUX5ZzMUqD7NQR8LKUZZWWvhZ	1
4533	2vbTbQnTZSr5knne6Pf6w9dtojYXn8hVX3qqVJwbuKqbi9TZGZjJ	1
4534	2vbCFidV4sjdCJZYsmPn2654C6HeNmDNDW9kJz4X23U7ZsWTBsvx	1
4535	2vb2gQARquPskmHCNVAmCwu4iV8FU2bh2WCCWx3duFAeWJnMS4co	1
4536	2vbbsPQNpLSca6eowEUVmw5jAi5Xe6uYaHjoxWSDXzjeKJSFhuSW	1
4537	2vc3eBNcUR9oPNdvseTb971iN8Na8S7QxZxboGdBmDNsC77xhh3R	1
4538	2vbBL7w8xHcBWWyBjJs2jUX4S6GG6fthaEWX7AvxWPzt2kAMPjVt	1
4539	2vaDGyWDm3MB7MqUuwq4aUhLBqjUw39X8jccM7HzkaqBbCcAmxS9	1
4540	2vaGCEtw5dCmCpdniWJaD6Y7s5EqDjssNgw34qURzUuxythynBwa	1
4541	2vat1u88b8yjzR2Bj2caYDWaKwcsWpJqn2prL33zdKZgMXa9MdNf	1
4542	2vb6qoWtuVym2yaovTbYKGAcZzwiQ6M4oDaRiKquFkf6VNroBkcv	1
4543	2vbKi8g2UHrCu9GW5wkxhXkDQb3PBbsyG3osjspKYKED9S7UDC8u	1
4544	2vc1LjHsPMmRMxwV9ZixozM3kdXaa7bVku3dr7EZhcgjZdQ4s8Ao	1
4545	2vbgu6ADykVV3pWu3PyC9hhaCDbbXuYs4tssXETsM9g6eybbfDS9	1
4546	2vaZKGeJrgdFoshSrTnDbGXfoYBwJgfJve5bo1Sty52skDzJfHRC	1
4547	2vaRsDcHhS1bj8otPkzy1PTkexMZCpmpecpzHfgqnyK1eWrDbtxh	1
4548	2vbXMk3kr8sFa9aErJhuCGp38cmy7KWeM7FkT8qBi1mwRK78baFK	1
4549	2vavtGfxdEdomcVAEM8arcn5qLb6YP49sg2NaNshVrrnT7cjJgEt	1
4550	2vaZuJjCNzmHGxN6uh2cCP2E2ACj9MJgcQtsgx8yYicGwycpvK6U	1
4551	2vb73qDvN1tD9nHwobQL82HrvWMh3GZbCzESZL8QA7wfcDM92XtX	1
4552	2vbtRAre4Yo2yB7WZjxRSuz1p5TPcRQFtK5raRUNo8mrRedHWUKg	1
4553	2vbMMs39GWEyVnPJhDwpNykumz3MGL8CHPhNpHxoxTR4C8G6kfqU	1
4554	2vagqGkFJztTxTcJbqper3RhbPCmwQSoJyjPhC8QPFXDmQVAUbLw	1
4555	2vb8HJkzmPMFgv2tFaqwY5ChNPJMFEHHdsWUyFZWB83kRVN42j7k	1
4556	2vane7bKxEk1T8yagq7ERdjp5ctXrjxq1f6cWWvJNGZxsCBSbqzj	1
4557	2vaesP5bzjLXnkiG1Y9twgeqzJr7USMoPrN5kjTPqD9wqTLi3x3y	1
4558	2vasK75Muw1kM1jmDfKQ4zNd77BJ1jGnACAJjqoEMSPFzaRHZWKN	1
4559	2vbCzZPETRkHdtPo4fRb3hDwvdWgAsNGgSWzfJqsig7tEFTTuwig	1
4560	2vaHNKGL2m6FfUEuvAJW9hGD8skqv5dCHbNpAr4Wm6V4NrPYM68E	1
4561	2vaoWLzBQQc8B4bCkb94U7YRwqYEHW6RTk8x9dKKTai5113sHseQ	1
4562	2vbUBbtxs5UB2nUmi7WABfbjc1BpCLu4GXyTiFzqfzC98vV8RFJC	1
4563	2vajtPEAhu89aN8WFe4z3WTWPZ6nBKm22tR26dfNXgR3Ca23twg9	1
4564	2vbHsaxxGnKjE9GSKmWwytsN4CHS8QpBbdTFAztxqSiTLhFaVuNS	1
4565	2vaZ4a2v5p63h2WoLBCrg21Ukrdp7QmJ7dNo5gZcKD7iuy8iidqG	1
4566	2varNZQwoNMr56pyR1HiYEML6QMQtJg4AK2UzF5bGwxxHa1zj3dT	1
4567	2vbaAvMH7vi5kwNY5mw1fhueZuNVrAqhoH7i59MgTtBmFDT4YUoJ	1
4568	2vakUKJ9XBB7PgCTAdJreQHnmsah3GmLEgzFgQrjk1FJYCF8P8wR	1
4569	2vbEaCmVy17TBG2Pi2b8ngAkbyaBjKbb5cq6ohzjqL4uZUkBfN6H	1
4570	2vaF3i1sDNRnd54bULyqdhvT5Fcd1kTbvgWuoUDyyw4T466C8gTz	1
4571	2vbCDjf3a6TBNYNLX1D8tqbkrw9t8aK8dhimjgL2wQdxz4gwFMWe	1
4572	2vbgAuPFdPfV3u7d3ss96daYTJhzZ3veMXhxCvXLMw8itVPSMVG3	1
4573	2vbgPCmXqFvupasEi9FFpxKABXxgCFvrjRvsVw452pk4jYGkAXpq	1
4574	2vbVyLACvm2f8rXZvqdhBtERDMcBgDEN2yB5j3uKV6DmW4dB9TTy	1
4575	2vaaMPqkjxY2SWK2LHzzT2uT4cey5Mq6ZCSAJRGoGBKGvRLNXctZ	1
4576	2vbes2tQYfHqAC8znRFxgExsQ9sm6LWXyUvLRMURgwosFvQjPnFD	1
4577	2vaL5Em2P27cL5qMM6e5xkpMKsZZMVMmyMCyJPatxwoTdD2LEgH5	1
4578	2vc1j2tGa1xA7ff81wKWgGKsZeQDSptiDurEVYjBobnXEdGugndb	1
4579	2vbUvRCi5QD142CSdUX8hASAwmiWbUHn5iUgZvWsDLiUoPz53sS4	1
4580	2vbiHVqVLy9DkYgKpoHsB1xTv4nhQqGCVvHStiM8AnJL96GcAuox	1
4581	2vajG74uJtUV5QK5HdEMG6KAijjMZYjoHb6nkZc5ZeBRw87QczdZ	1
4582	2vbVoR4kEtwMSbtSBLLgzdNwVcfWcxhoGwhoMxxiKsZXu3sKMf78	1
4583	2vb9gmHZg9danXw5mAjJRJdGtcXFk33p6VgNALCtQmpxaLGWWihJ	1
4584	2vbvXhMXfLsAY2fTpdSef9WHqL7UoV2VDUuAwfzaYjbPb7EKyxXS	1
4585	2vakiWhVYs73EyAEJzBr8kDWzefuPjA1W2s5vqgxhripeBXhSTtC	1
4589	2vbKZdzedPVV53g9NoVDEqSYSMQAJ4H9mVsf9tysqZ1EaJSQ2c6e	1
4591	2vbKBJzYn7zzQpnnBQVUF5gTWtQ9usWt6WjL1FLLt5FWeBscHrp5	1
4593	2vbh2e91jFtEMkSPmFEwWQ67m5bk1tPrG7X4XYQxzLxxEoXMuRFo	1
4595	2vbhs8eARdqw7scZ8xuQR6fGxgWwdvYCxmfH5ecAfHaYKNrCxxGL	1
4603	2vb3GpBhPgwCopq3K3sDMXkNjQGKc5eyQhFJ3QLhoAgkFr8Z88J9	1
4610	2vbrifGCC2xbS2hpAhjinpU3JVUVv69ayXYwyi3fUiWzuUB5S5XZ	1
4612	2vaSVqzLcCPThrurKVzFSEEy4ENGZV9hHj2sanR2hYSfAQ6emvYJ	1
4617	2vc2G8A4YE43RiRhHv8k1Q8XCpK1XDYWLcFphzDETUGx1uSeC1MC	1
4619	2vbExVazgCsK9mfsvvjWJyLCnfiGDLwsLAU5Zc3VJX47jibNxgsb	1
4625	2vbE3WiaM9wBCaWaS2FiYFEXX2YZM1Td9FjewDeLwMPtSK1SRvUw	1
4626	2vbvPaXyLjtG6D91N7GkLXeKrpj4EqY8DBrAzzAXo7iRBm8TnvAQ	1
4631	2vae8387wwt6NzqEVs3pqXxwowLWZRu4D3KgVdkCUwrK4QeWjkTq	1
4634	2vbzP9mcDSSmCW35gYr162uXTE1KWBEETeqBg3Lk1GCVfK8VK7mU	1
4636	2vasxDN89LkMfUerAwJiMwtuBHQDxWqa8sME2tawe2XzXExkYeHA	1
4641	2vbvpWf39uDBBKnWLoDz7nQSkhKJRJ6UAsqcW6s4XgxvUCSdMZJt	1
4646	2vajaAMj4xnH2ymwceDhq4yPayYMRZXyVDJVSwD2qpM1AiU1MFWz	1
4652	2vbrb39K3sfr1P63XjCdikXrWcs3aHQ7f5eXSVTcA9mDbjomXadu	1
4659	2vahKqUTDgz6693JCZkXevTSW7AemHi28UEBgKuAi5HD2u4d2k8D	1
4662	2vbhfnLmMwgWYDv6un56JqdEDCLt4MqjpjzKZnqLRa4H1LRNi1zA	1
4664	2vbohyVNz75epLTzJSSKQPynSzLSHnv3dtoz44fiCSF2CEtXQseU	1
4666	2vbJgwJEoHCTVR27CJQmKVpzSspY2ZPUTjU9dWns7UAWoeTMUtMy	1
4669	2vbXfJQmG48JwfTccdKNRbbv52boQFCiHWYwK47DtqJuKAsiKVAF	1
4671	2vbsQiZJg7MBamY8jwP3asGPWz43i7r2xpQNRmKbs7cxLu2KjzJp	1
4675	2vadwc8n3rQtiZ6tRF7gHuDYBVJ5J8c4h7v7MVyfyKaHCdkbqEcq	1
4682	2vbFeqEKQGfXvdRzd6amWMcVDvNB854ukFCNeYMrnAQK9bjNsufP	1
4685	2vaqzYZh7JLw4aTJbx3QpFHraHCNQRTwRHbuwa4ixjeBuuu9v8no	1
4689	2vbr7BftoavqddTpDiiHKDnoR2ZZUPHgGWvDW4EDUQS2sap281o6	1
4695	2vaPDiVJxccKTFcu3vz1yLmn41nGmj7buP8FZBPgTqdsjep3Ax4v	1
4699	2vbrK8UPVVivfR5vYLYoPamftRRPnWdjwEJwYi6cUrWTQwPKZRH6	1
4700	2vawqqooCSzd1eZ2E5w88MomdBdhKdaYnZcc736LApLMGJePmyQR	1
4705	2vbkKwdqZHsfiU8SBgWAiP38SsiqHJ9PJatyAVYjGtnhUkT9UbSf	1
4708	2vahfDDGXdoV86tcvnjhkJT95MbroFPtyGbNy1t6RJfwTMsPd18T	1
4709	2vb1DNipXdCRoeBv3uzSH18V4s7bjN2bZTzvdDi1FH8rtTh5Wnfo	1
4714	2vamm1hvvW15Rnn6qXCx5AhsTsijDhEAop2K985Eag5e9F9J1fG8	1
4721	2vb1ovvjrsQkudwajD7gA6FHC5kXc8ddjRtF3JDxPfnccoyWxpTi	1
4723	2vaubcF2HFZ878z6SiFHNUyeb74wtUxG1k3Crf9RL5TMSfpYUQrw	1
4727	2vb3E26QUFVCA5MH3pPbo7yYhNsdZdLnLXZURYZChbFJ9NaLtheY	1
4730	2vaaeceadezFrzVhCFEJ9ZEhMwA7pAyHdNQf3vgUzje47iHMy4ff	1
4732	2vaykWRcFyVS9zDuVYWKAp4yid97UAM1hsQBXW57CFaKZ5hcHVUi	1
4741	2vc5aH85Q67K1dLPaP2CbsVBtYt8rNq54e5KqGAJ11BoUJGmjSsE	1
4745	2vboiCEQXc7z3f77XYuLQjZWUY8gCapUQDaBfKQsi1tpCJUggiJx	1
4748	2vaeW7v3JCynUFRtpmpJfgycn1hp9MP9GVML26cctcybP533M3bq	1
4750	2vauFik7YHdETwDdznZucKnDsPpnmUNgbLQDqfYkPDKdfW4vTwZs	1
4753	2vbzgvvFc4FB4hpyKqLvs3UUp71k2DA8pEQSN9oN3bmeXDCGESDw	1
4757	2vbSsVJbDQUELQCm2Ynijm817Zo22DmqoRnHwFZaGUkGnSHES6qz	1
4760	2vad1mfvEXx2EiX1gBaBN1KoQ1L5Ay7iLrchATKaW2HDnwEbNFdq	1
4762	2vao1uU9ZFgCqFXPxFgmAjm6TmeZos5wSuRbuDqQ73BZsqkdEzsP	1
4764	2vaJKTSTvhpEwR7ATBpHSMBW1pAABHTxdPRKX95BL1JY1Xnmbsd1	1
4770	2vagCt4FVHfMehayhs7ChWrhqLG7R9mByUkobfBJm45HtW9zbEeT	1
4772	2vaqmnibVpHJg7R9hrZ57mMWVcY6TTDq6YtdKZZJey7LvLfHoL9U	1
4780	2vbpTaAuQsS5zYEz8q9NkmqwUTJvsdmdge18c9oxgx1DPK41T62n	1
4782	2vaXZxVJuE4MdRiEp5EMiB2vHfEk3fMSqyk3jTkcgMHK2H3NQc1F	1
4788	2vaPjMxKgVvNNX4D8Vm57oNbS1f4j7wZ7Efz5jRiyYnYU9q7FQs6	1
4791	2vamGjrYf75HnTDfNnqtjUbiyryroLfd2aSLeBXnFqc1JzzAj9Zq	1
4796	2vamrvhLJ4NsEUstVQ7r8ePXazPsDkVkKbrR42QPK6AqAXxAExUA	1
4800	2vbdbC8dtn2UmJjGtx3w1JfntkRzvNUpfgxbzzdtLdyNaQwQVb73	1
4807	2vaYK8UY8iRnSGQ5kGiryT6njTVG4fgACNroJ3zJJDXoSuNe2qvR	1
4810	2vacjish23THmLV6zeg2QfM73qiwUPHUBJXPfipM8tJRuM6k9axC	1
4813	2vaT13KGZo8qgXNzvYkUysP2x6CG4vYKAnDiTNNyWottMQUW4dHU	1
4815	2vb8FTAXjsQzwi8q9biNU34C2vJn6QGg7kmsw1DdgD2aeHXmMg38	1
4818	2vaRChgicks4qLmKQarv5L3qk35dRTkR6yakLMgdCWgFoiWVD51r	1
4823	2vbFEa1PgKTVX16o947bXKSjB1ctFTCXsep6oUNmKd9mFNJPzVUf	1
4826	2vc2iMJkGJh6jurdMSJhn1GvrMaNhHUjEEWbFp4Lrri6eiQ3YeRW	1
4828	2vaquBrwesyGqU6wTGzr79681uNL9HZu55a1kFfKyS9fm6eMisss	1
4833	2vasbtoV9q2eWdb2VQiQ6srLCUTdbx9hrZrcF9yzbngkzCLesqAo	1
4835	2vb4467BFjKPKzg1ptGwXEs8LoQhK5SmoGnQvZrD9QYuvNWSuEh8	1
4838	2vb5XUBooF1tAvuvj7tctsrYtfRG2N4dmmjLQmZZmP7Yv4nP7A9o	1
4849	2vare5CNbr9bwyuMmp1jVU1esARsdkSRy9Men3ZxWxQkRoKxCHx8	1
4857	2vbvdRNAFrkZsaoXi78NN6JQrU3vHbXCGMnGt3gfP85c1jDkhtLn	1
4859	2vbi2k7AEPx1FRbiAy8JrVm7pSyS3Zwsgxh7YbMiYbxPwWvzkkpP	1
4860	2vbhZzisVgj6452eRBo8SXyQ6yMnzegkmeRRtx62oDqtE2VNwe26	1
4864	2vbXbQDKLmoj6N2neb8YH9AtizvFWNdJxmHf7v76gCVtHQXfVu5J	1
4872	2vb79tuqqq8vCTGuLvocYDEbLhUovL59Vsrx5pkPH9GnqyYxLH5J	1
4876	2vb9F8JwVcyomLE5omED1oX9WVMcdDmuYG3cVPkqsFoHigc2etkF	1
4885	2vbfN7NXPFdHeDpH6PyHjGRQBvzEovEY2ziLybpboLwa2JcnzWtQ	1
4887	2vaKeg1tdeeiJRjS2LorgPV2DFHKzW7m3DUchPxVwzMujwqHBop7	1
4889	2vbVSrkCjkqZfWjGXJGYkfcFz8dygQjMdtQ6dshXLt1UNEWeFfY8	1
4891	2vbj8WDVJx9en31oPtLWBnTPP8EEEUi5bXeEjqXJSxadRcC2fMVb	1
4895	2vbfvpruUhWfr8cGVoHutkrbT2KP9MDLQqeccoNtw7sDajfhJFRX	1
4896	2vbBiirpN9Qaj7avtDmuV2PayR2SqnpeY1uDvTxQkusmUJbfyWmn	1
4900	2vbgeB5fLm7VZGzKe7Zi7xW9LrrGJVAsR1Y49yQN38WBCVycH6Hu	1
4906	2vbsZP5uJuzM2Lu1QoY7E2Y3WcR7HfnbAyDh4ZoScpmJZsCTQKHT	1
4908	2vbpJpcwQ8MsQQSP8JfTu9hSNSYPDuGuGMW9pPySzEag4KGtkDij	1
4909	2vbFce9RRRmHk91czP6gBWBxahjXskVedtGK1XzTmCw6mv8Bys1u	1
4916	2vbwdcvhPZvCT28nYwBtYfUvwRF9Xi5jcshum4gbfqoBCaHb2UtY	1
4924	2vb2SipNqe1NjXiQxGy5X65TsFNJ1fDHQU5LJ4LaWbYZZNv9LvzD	1
4931	2vby9q7Jfy5kRXtomSBPWAqgsx76vs3SfxX164QgvUZWsRQLWZ47	1
4586	2vamx2gx6J58ajZNpxJYsxg7b9JDAUHvzVkbUeG3Ym6CrUtS4om2	1
4592	2vbF5iCJeYE4bRWj6oLRmfm4tQ3eaDGKeFKBgdgRuHApo6JW9BEE	1
4598	2vbygMMZHAYqQGD7GVtb1ooBpy5yA1Pbu6AcuauY5pnupYHrAyyz	1
4600	2vbnSuri9f3asVurwnXSpEnePaohYLoFvgjLnRWFxzvC1N2gnkTc	1
4604	2vaCrJM1qTyXVLyLNEerZM4AtcodqGPmJmyHxBCHPhw1tcK5nmsX	1
4609	2vbwbYxE5SybcP2KmMNG2c3cgv5mxeusfZM3yTRS2jhWhRP2t7G5	1
4613	2vbQ6k4uRmeP5ypkHmC3AXwFYnVKZeqPV6RyG658tqwHSXSHdSsi	1
4618	2vaQjHeNxD3mrxfmC4Ypc9XWgr9YiMH3M1amYYB9qZhuwBK9hpLF	1
4620	2vbmZ8RwgMr5YtcdVuW7Gz6LVquoMHFuVGYnKYCxCUsf8KyCaaNk	1
4622	2vc3AMDu82RU3eC7wEz8n52kprCTheb5fwC8EKCMYw8X2JnTERjs	1
4627	2vaGj1nbbMWKiRqAZvpDP8FmfC8FPXKSeZCF5ThHCHxEVQCiKgJ9	1
4629	2vbEdPujMCtMbrhZWJVdAxJr4iMZgQhjD22VKXynsWaVJpfPszgE	1
4632	2vbaACNJZNkig7WqLwjNAgwNahK7rPqvgYdXguXQXeaL1WqU85mT	1
4637	2vaXEbWuBvJmT3wKrapLirTJFXiwSTBsXDxsKbE1qj7PqQaPE5sV	1
4644	2vbh94VMos3HjG32UgW6tpgU54cMpjrYL43wXcrwPVCkB3fufCyV	1
4647	2vayqHgnM5jXSuDhDWZr2okJEwz7irFXcLoykdFFxz5ZnfxsCmYe	1
4649	2vb6PqbbkR5br9F5GLgBGoNhJnfmRXhgFAXcRhBMF47EB9UziLyr	1
4657	2vaihqEF65SYZZEJhiTwq81nkm4cfp8fZo1ropAd194iyuVTRvgg	1
4667	2vao24sW2U66967SXJmsUr1qT7gBAxktSo8eSRXWTcENuphwSMkw	1
4678	2vaezc9KZwmuseBmwuVUgT81ZBP17Nsu1za9onFKq6WnKe7NV9Sd	1
4681	2vagAnACBxWrFbAwTstABUBvZ888D1tvzHAyoNFW1VDSf1xnxuCP	1
4683	2vbTzLW3HekktjRtCCTPKCY6n97dQhxQXHsCZ2qHbVrGzPpsRZEP	1
4688	2vbKwYrurivrT4h9iHVYgEsdK79LunMF8Vs1WQ4649Wm8kMt4TzL	1
4692	2vb8k8jJZPLt3XvVMBgByBmLJKYcQbGwjFKNYQKYyUiRcDDQzSgR	1
4693	2vbrLwzrsCcwaAziYydp5pSrdxsE7WLGQLkhimv4dYFmgtFGs9Be	1
4701	2vaphwjzf7b9ufcd6TKgPvBZJp6bPpFGrwFRAn6eyNZYzMBm8x1q	1
4703	2vbF8QqkkvK67gm4x1mwfiboKtwLS5evs7x9uizZ1cKCVJSupwxd	1
4710	2vbYGium1qNcA5h74rabpHMeusFavHKocKLsrUEDbwfwZ32JY35H	1
4712	2vb3Ko2AbCXBcK2MZknasTzLFbtdUVgxSc8xud3sXxmqN7WqnG12	1
4715	2vbR8twZawzXZfbW5SNTu6fRrCAeV8QrPB3hjmCP48Wg5x54X9aZ	1
4717	2vaWHbTSragxhp6TUTKA2J9JZoz4MBzrUfdw7StVSuJWJaNhBMRD	1
4725	2vatuEX8jgNcGHPLnZpVZqKXY8UTNdzPdEXkhiwqu4TVEfhwkLjJ	1
4728	2vas6bkd3bjbtXxYWSmBNUNNVzkc7Pbyn1LQieN2sU7kf1jV9y1L	1
4731	2vaXkRei18Zk8iGyLDSejKc6ZPfzwm8EW61sd7zMgQrpRihcXxFQ	1
4733	2vbDqfnsPgpcvLzFYbRGKX3a8NT1uZm3uCAD7fijjfi3s8DQv4cc	1
4738	2vbuoyGd7RnoYLTfHJouM1PckWDGjfNJfQCkW2yw3yZSKNfvbRMH	1
4742	2vaUycGNCA5MiHU13CYTYApHxw9hiuWsvZGViPGSv3pxN9TN6ygt	1
4751	2vay4uvyhDuEdxouEro7ef4ZqQ8p8dGV4XWchiQifubzU9cKNFg4	1
4755	2vb2Jmpvt7SeNMAcfcukHDyqy6fSug7hdCXMQsEvyAB4kmh7NFY9	1
4765	2vacfoC9fGnp8UX3ksKpTE1NgSdsQ63d6KGqPCmNASQAG7HkeLEn	1
4767	2vb8rJLzJGaTrUengcM5mVN9sd4Rr6oKD6HvhN6rrus3fL78eLDk	1
4771	2vaRC5ogNdGPbyLAuVB7upzXvAxQFkFyFtb54KgX7cRX3myTt9zh	1
4773	2vbihGwoMmpuEv3ymc72NQMbcnfooF83YDT3gKAuPinzrYp2Nc67	1
4776	2vbUcuRKbS2Nh236rDyKKFe8TpaEj4BC31wT2VmCiBaUGwYWPckm	1
4781	2vaSyW9iKtYUG98BS9MUwg8BEq1akiBDaxiYtvXdHj3hrsH8rDnb	1
4783	2vb267WNTJh2wEsZuc9quU5heP4saqMGCa7U69TZGoHmcuzq4q2n	1
4785	2vavgqgumXCa4nxTWwP29Yx7qSTekqADpfXsDy82oV8KTzy7tArU	1
4794	2vaDSUD4XdpCgfKQMMZuyAfBfatfeDZmk5oUfCXe8UNRirDaoX5X	1
4805	2vaQXpPxcDq46Tw1xRLANL9HXVL88yiT67uqU3RfSWSPas6Yyppx	1
4808	2vaqqXQiKrCMxuExBatYPSU6HkQKSjgBKXbgoaVqc5NxuEdnUsJH	1
4811	2vaW1rHZG4gtJwC137DAzjmbvCLLXEZAQXYKCnzyt5Z1xNkARc8B	1
4816	2vbmxE7xXqP8EH9Kz1tCKUN9bDpFeEpEJ92xzbs1tTP6p9qiDbRC	1
4819	2vaaEA2b4hKJ1UNjRcu32YPNNS9o1mUCMYUMr7ESUsuZaTJSb6UG	1
4824	2vax2MRAhU44VyvES9dHYAA4ZNtXG3SQWChSKsDww1RjFKTjVeDB	1
4829	2vaWTaeUd2u4u3w2sAaHHbC5e26yCa2bGKXz185Vr3aBHU4TRx2a	1
4831	2vbCeSnRAZLGmHXVYdGQ1L6zuie3LaisGH6gPAhNqWd4vfvZ1yop	1
4834	2vafkCpkAViEQSd4ZrVjRejjNdkgaVdvfmnJ66nvaE8oCJUGrdM5	1
4837	2vahonr6TuSKhE55k22dqhLbfMwTdcZjYLA1kfSCx7vFWPExDN7h	1
4842	2vaBspewGjaLuvY7aUdfkyd1Y5N8Tzs5W5mKLVbwkh699s8C3J2r	1
4845	2vaAu4V7xEt6jWWxbYuUNszrUrea2XSkBCeyKcNhQBjBjhvYK5Ht	1
4846	2vaa8jDVwb2GSbkFgARUbd9hcg2KCd1vajUPTYzZRHEiAoTzcNYJ	1
4847	2vc2jf7Q62WUMFJ2As5Rd8ha76VazWQ4GAmHYABxMGfm7AFwnTcc	1
4850	2vbqU99qJ53HMzK5QVbgfJLn7TZCVe2ZsgbWawWrArFxmMAM8SGZ	1
4851	2vaxpsHLRZuW8mMoKiFS6oQPRvf5VuyAjewRistmF1amuXmcmEso	1
4852	2vajQkPD5KCyKKRzFUhyvsGVDpq7c7goVGH6iD64DpV7ofdxsF8w	1
4854	2vaZdJHzREMqm8z9BsMfVzFPsBHvWmQP1i5FPYLTK2UnQDNEPxxf	1
4861	2vbhDy7gZhu3Gqf1PDo6JTZ6Vn492v4s1XW3jSZmjJSTA52gFu8e	1
4865	2vadBEiwpZcwdcFLWQhhsQix7AU7yAmZhX1KNgEbSGQxWcnF1kua	1
4873	2vab4sN3eepDtkQqXoHa7216KjenFEvY9u6BzWG5onbbQgQtHRVo	1
4874	2vbe9vY3gAHnGSbkaRxqrirneqq4Hq2KYCzjsvHchzcma4ARtdJ9	1
4881	2vaa9Kg3Wm1PWKNChYAWZdwnqMoDpjqwT2wc1X9seJhMe5k3uLjq	1
4882	2vaUYAECXiaboQ6w8J8FTAHs3XGrSDDSyLDJyCzWZkpGpx5vXDP1	1
4888	2vbfQtkDqxMLWeCHPdXv63Ya9FhK6gkAruGLHvNi7fhRwPR1MYyY	1
4901	2vaQyHQksGW6tvrxaFYR2d4eXtDpbVMrSmYGXjBtD5CCXKmnbdSS	1
4902	2vbjoN9LrTmoTgNtbmx85RQ3pNPh3sP8hFZsh8njEZVH2WDmEgRk	1
4907	2vbs176saiWtTdoJz6JjVaWsYhzFPGa8aW5rAiYa5hz4j7p75d2G	1
4910	2vaRBCjJcdRt7hqECdcaiNvZ371fdBbckFcGAu5EfwhSuFS5Cvyf	1
4917	2vc4zHaxndf6m5mjGqdahn15drC91ucGSwGzEghrjLu5zREQjoUW	1
4920	2vbMu3aBCDE8Vrfxwnh4W6raKLibamysCTCedpRChKW5Kj3yRnB7	1
4925	2vbWyeY8HCggpYDEHAopfTeLuGMz74QLmWcKE8wKGkg1hXvPR1PE	1
4927	2vbz1niGSq7UXYavo75Z1WRYvY15214cQsPLF7gPNs3iGjbRA37s	1
4929	2vaBHEPygBdJENPPrDsSxHNEd1u3ktDq9cKEeRj35tabhZR5TzBX	1
4932	2vbqrycZYZAYYHek57gn7XXdRYhhqDTX3K6fNwYt9NEVpSjkjJuv	1
4938	2vbQFqag69BgWSctgxb8V4LXJFjgoozjJbK8QTopTR1AtaFPQgt5	1
4940	2vbPkrX18hcoE3WD9srcSn4YTpcXWtvWs6NZqEKBtb3mZ8f42Waw	1
4941	2vc5SJ14EUPyvFZMiunGHUiTX5r7Ry7rgRAoJeJP794KJfRgDHo3	1
4946	2vbQRazfNoiuEjs6KHzKvouDjMpsnnjz8UxmdL4YcWgu8zctdsYq	1
4954	2vaVnX9Zh3QDmYRcueTuoexmyxWT1N6rdvi9hLejYn7w5ArsdmG3	1
4587	2vbnQ5RyKus8k98ENprsmMbuhao1mHqdYUJakDyY1WU3frqzPvxs	1
4588	2vaeKgz1uhCifjbPpCxoA3UkC2XekyfMCo27DrPNNvaavPthBAUn	1
4590	2vagcgcaxjqnXoCKHB2kkqoarERfkZF9x3uqQRo71FXoDDcJeeTf	1
4597	2vaKRzSm5VMrCNTUToMKNojTqJVLk35Dv4MBQtdpnDFtsuKzv7f1	1
4602	2vaRnvMehbHE4fPPhbuyfB29jvccBu3HzMj3wUpLjeVupiCLJ6KM	1
4605	2vapU3Gzrb7AmJ3w3sHKk9VYyD3qXvDXk5RTxL9BXGzzoM7RQ2or	1
4607	2vavbquynmeMio3v3ze9vGPMrMZCJqWzqrJsS4NEncxTNMNqsnpy	1
4615	2vaz11GHaDhQVEJSaihuFNrw76i6C6uLhaHTwXfHscZ6CmwUGC8k	1
4616	2vbvv6M6kgBwyZvWKkbuPahHVNHraF6kSxWLjPxL2sV9SvZ2BUcJ	1
4621	2vaVm5DSSMKk6XtV52APQ64jMrBGRRJkbcGJJ7Vuamn5uEtUXcYV	1
4624	2vb8uakshTCKxj8wTKmAzGKYb77tGqSGBTRW3EsRteSBAZoosh82	1
4628	2vbToDtX3kFg46dcP6yAMMtriQh8PzpQjMjkG7zoRxuHXxE1DitV	1
4630	2vbxepV8kDgQxom1sbSWG1nwXbdoqjnyFrWuRCTLKsExirU8LReb	1
4639	2vb4eG6ecF7cabGfGwauKGCUBbTCBEn1YTqDV5Vjh9Arru5jeLZC	1
4643	2vbJcV75gAvVucbwKn77dzQAj6jtRwgEwtwQnYgfmfBr7QUooQ1u	1
4645	2vao5GBvfKqHN6ko9b9tK7w1bbHq1Mmt6DzTAnMU1rU8uEbRvEBE	1
4648	2vb38TjCEXb9JBUXNeD9TKKsJ84xQAJvPUsQTDcJSVnmA7aGqxro	1
4651	2vbBmvQcUVXGyPLW9QrJeLHgK1d3fRsAqH9YQw9XSXEZdUqNtAcx	1
4654	2vbwaoeeyprWAePhGLWRpvyNNeQ95w9vk3Kb6yC6Mk9YgBzRKfMP	1
4656	2vazpc4CYjKkk6ZGULVCUuEkb9EdhNFD5txCDrxZX9dJzUKBdvYD	1
4661	2vbTW9PcaNECuyYQmGWHePhiadnWX4LfSBEmNpXbqfgqKrKaoNXM	1
4663	2vbFARu56TxALTyeWJJy8UHSTUcXyYZbgwTzwTRqkPFyLTje3nMh	1
4668	2vaejsi6QASJhfJrLitmrbuTEUpuHpwCxz5AZHVUX95R53RJf2uD	1
4670	2vb7j4g9TJkEyHHBuUKKTXAZkyMh4QgyGsiMYLRU69nsbWYhv2Gq	1
4673	2vbbpnLwAv71ieqw1YXjF2gTyykMr5ukqVuFcMyowfNrwEbsBSUu	1
4677	2vbc5nZXhz1X56PgxNtLiMjbRuvKHMAZx2kQvnXGo3LFk7xsx5gx	1
4680	2vavREPDGGT1w11DNAfzby5VjHN3SM1X3cbHKwkxW623aZ5EvY8G	1
4684	2vatf7Bb7ssPE6c6NmNHVFcuD4AYxXawUak4YbzWt5SFdrLimN7K	1
4687	2vbp27PqMR3R17xuBzoNcbKTojQpLovkX4QVuWiXuCHkKZNy2SfR	1
4691	2vbPxKg7MAw8MbiZJBt2BeiKuUWYJKe1bSbmoDPajJb6cU1b25Gi	1
4698	2vapCqWeGavfWkcUrZYkofMjYShr8JcwGMneppTUVuTj9WZkppU8	1
4702	2vc2JMoe3cQJEZ4heS7iVCXPNuneMy98yUTwVeKvLXkxQ6eFSLsJ	1
4707	2vaa89vGRwViq7dqx5tcUKHEt4ufPR3HpuoASiaX1DoADX45c6Cd	1
4716	2vajUYiTdmR6N3gABbZvxxwEPs4ZwZENeAQCF3GHM884mLgxTJu3	1
4719	2vaiiovDv56ccsmBqzwfXw8YhhEnELrtC12C4svBUJAQHA8RUh8Q	1
4720	2vbSzAuefNMZDMg5hLoEZGFthsgs9Hp4fYSJh9rTEwafo6io5wxR	1
4722	2vbmUn6zLUHJHZHYBxgbNt1s2j9ce4Pgv8bPYvQVB9o45t4sHpcp	1
4729	2vb2mcr6XMXdXsc25d9LPAsvp8HhXtLgPH1sUHuuUy1YXmSSkTwb	1
4737	2vbVz6zxcZkBRAXs2ocuUaaEa3EWjKM2s7eDtdFXbgdJaFiaVrgD	1
4740	2vbbRpr4nvNDzSdRnU6LJwD9Rk7dyVPaJq6v8CSL8sJX66iczyZZ	1
4743	2vadECjXSBhKRnYheUfkSvfHDfpVVsEp5FsdFuXrteVY2WMDCt5L	1
4747	2vbjcXR6Xk1i9977akcHCkZRTZBFULxRJ82hvmSBzVsiyggEosq8	1
4749	2vb1WPeWiiow4JKxzMpMHu5Nvq4KxDE2epwXqmN2QLTN9h9Rv5qk	1
4752	2vampUGCG2xnWaKPsYbwqTQLUKA9QDfKZmD5Ti4wQ5qPzvGFBYUS	1
4754	2vbHZe9jduDKaXX53GoQmhX4YQSvCQPF8qxQAmtDJ71PaN51XDvF	1
4759	2vaP3yGAaMpYXN28RWnMq1dsQzkNTzSZrEJ59Rb1vF3pRX53Vn49	1
4766	2vbW9W1WsqufyoUUPAEUS4TyLtn7EhhubfeQXyz8BLuzMCam4obc	1
4769	2vaTD6r9HbfFFAtTg9CvZ5r8MMKCUWEVVpjGw3fCc5aH5SPAfef3	1
4775	2vaH3F2TitqFuxvcDNFX1dbj5qZRMEhTvMtneEFpLd2L58FBP4w4	1
4778	2vaJUwybpzxuLJFVCbEob5tSNgJiLLgetwY32Z1Lgxbc2wpvaJF5	1
4779	2vaebZUmDeMcmm68UgJEkYWrgQ99jVuSHpFRRTEhfwCm2NSEgfPE	1
4784	2vapVXQBrSnZ54zFjD9t4axLWgbZZfQH6hvTy9pnHnjTfhvwiwQT	1
4787	2vboMezCTT9X2rhfG5sPCq4hW3pvHus92naZnzEpPRbLATVmDEJa	1
4793	2vaAMkzoKsskPrCd8GRGjMAVEvAvCqhzmkYhkymWVaNQjGNQnrfk	1
4795	2vaSSrRbm9WVc2mNPZyiBU5gSMqiNfkPXshX2dDg89R1heaLj5yd	1
4798	2vbRfCSt5eZEWB4kvxzbSDN4DBrTVo6kVVS7a56QTEffgVT8C2tt	1
4799	2vb5ECXUtfHkov9WbiUa4KFPSJ3fPzqpLVFPpfkp9YHHzdrojY9w	1
4802	2vbB9wMpHknazY2Eq2NJA1xUHHjZrzbgJ53usk8Zu81ZVZo5DsJY	1
4804	2vc3W42eJiTjbMzkghXJgp1wwAr11RkMZeh4KH3WNKFvnXN17dvy	1
4806	2vbts61UuAAga4tr4u4Ayabw5Nbx6d2waPgGnfEAweXtpCby17v3	1
4812	2vaHtKod3Bs3sjmor4JJwzRreCb3WZJXm2dNWd6YWZBJGhDBfHxp	1
4821	2vaTgpuhdE93iPjPpzdctkhzPBkeb6xWSuQafL4FYGFdaeLsaGvo	1
4822	2vaWkHqgiNckmzxZPMBpUwk4A4eoy9Rp56D6Be4oCpLiyHe1TdgE	1
4825	2vaarFQ4UvPncmKqF4wsfbNN9jYzPQkZsdZwwkYSrUYeRnDzKgRs	1
4832	2vbBNQTatUkEavCZ2TFx6QnXCPtvjgZAPfb6fnFa9ufy2CR2aygo	1
4841	2vbkfZjR3jazUDgQ4v33Srs3bzqpAxSxchGwqw1VEPEnrp3H7ut8	1
4844	2vazcMe9tYdfHvxGTdWPpZqpgWYkPgWjfVFS3Ua7unaUkkCjAoTF	1
4848	2vbTZpM8K2FkosUHaRrTz82K5skB35RoTeqMcxG8nazZiSQh9dzi	1
4856	2vb31CiTKR7hUMw9d8LJjBKahpmyvmHgdBvwLC2vLyv6i4FXNK8T	1
4858	2vaxUP1bERVZhkSGZUYvCfAsFCMs63jBa7FMQEEixRUxbTnXQvzk	1
4863	2vaPAHsdeKM9EeqJFBAZxmf7Hn6L7k1ivdMNqsL6yXUmsfnjoP1W	1
4867	2vbkrYJphYgQniCPuqcd39MXam1N72wfYdyNvRrsmAEcUcGKbBtD	1
4869	2vbq1aYaViDuPsADYqkfF8ZnicV58zhbeRHAYAWWAojb6EqKz5sF	1
4870	2vbVg1XVrPFtZuAB1Vzx8xfg3suadVyxS7uKMEnGdAM6MNUtEPa8	1
4871	2vaaaaCTpzykSQwrMt1AdS84JntjDpyw8MoV7fKUu27xxzSb6iw8	1
4880	2vauTAqjzp5ya3ouLa8o9BS9FhbDmx2BcKJbChsQEYNU8sbpfo3A	1
4884	2vbpm4xytFTFRq5K89ySULgqZ8egVRyfgqDzWyZnFduVh9AtmHGZ	1
4890	2vbxxHB5z7Zdah95ZuZ59z3ohFLRuY4zsw6aKQ9MsdWa4egPMPtC	1
4894	2vbNSsmVPDuFMSutXwGQTjgAiZPTLfbEphHaVwQ8FxvrrWwPMmJR	1
4898	2vbiYHru8fPGUKmFWqKKGG5chUuqPLqiNn1JEMx4gQYWGk1CRXpY	1
4899	2vbX9xHsBT4pZATRb1vd4EAhVip9B1yqzPaixuG7pfHcitH2oAM8	1
4903	2vaBDLxp5xg8F8iabVRW9MGcuniCPpPJgkt7fxwsVJoNvwE1PwK8	1
4905	2vb2b7QeTFdfsk6tjMbmg3mcbioXCHHGQjfhH2UoBX3s3sk8n3po	1
4912	2vc1jw4u4bFobnxkhVdqDqh17kTEFjGGSrZVidUNtLKm8A36C7S3	1
4915	2vakj17ovipd3jKZwELtRDRqzdNW5fRFNZvCSVJ9CDTqKKW7dgHt	1
4919	2vaGyq71csMksb1WbL5uqxCfMS6LYCMWLLQacqd7qNhpVwq14Zsk	1
4922	2vbo4ZrnT2sj5yDfUSuEFcXc9LqdHh6G435LfBStbbdDtfuChNwZ	1
4923	2vaJ6qZD3de2FP5CNCcCN3FuiEitmAMZVu1CrXhjr7y8Yo1fsv41	1
4594	2vbKB6C9CvEnsTkK7TZLMkkhfTSAaR4trjgrsKPB4PV9XsGTJuX9	1
4596	2vbjcfcm6PWwADAhPo4VppCyCp7jVCNixUsdKK3pCNnqqo5Q566s	1
4599	2vaxcTevv1qaqcN2117VqshLTnGPz5kJTQkFMGio9CSGAnH5qxJd	1
4601	2vaknNsdx9uVeiqm39iRCzYLeoUDKzbDVEgnUDnn6jqwGQKWL1ZU	1
4606	2vamESbzhDbc8bPp5nGvTytXs4cVgcqqpv58NS9oJ2wXqR9H58wk	1
4608	2vbnZKqB7CAKv389iUBThhvS8TWWbZYeyFJAY7Vy5HQatt3y9Kku	1
4611	2vaeZ6R4Askn2UJU1DczdT7dEsaBvrQ4JCTbHyW8wJ2DW43futPR	1
4614	2vbY9tUMWt2zWhuwBmstU6yp9JfV77sotLx6bCr7MM5waPhCJP2S	1
4623	2vbJRboAGtcnA6dHjzTipCVzMyGie4tpCe8fRWpuncUxdNKZpptx	1
4633	2vbXNCVuL9djbWZeNJLnJ95YeXYauq5MXwXTQgxq97hhBLPX1U5W	1
4635	2vc5EUwBJyz2L6cvAY2xSQb8LHJnaZgFwBDxyie5wSWDWSgfhEgU	1
4638	2vaBNwjZS4oi8TggtE7GmwxvPqnPj4gfeTEtgpcNFEvX8H1R9sZA	1
4640	2vb3iiUjQbCHKLHsvdPUfBo5MBdNLtPMXPPkww2tmqz54SVk4Yoe	1
4642	2vc5uCSQP2hHBAFSuCCajqkLBxV7nN5nxUWLTRbycikeeU7AHJ5q	1
4650	2vaCZjT5G6EjnrcW7T1ybHZzFFYyLeaF9HpxxyRjEDEagntnasWY	1
4653	2vbU58WjHvo2L4prxtvD3T8BvH3arpNdFY6mvh4uJcZEFs63FtkN	1
4655	2vbbXAFaAbfEGt8YFKcaBr8GF2o8fhRnF87jxkssQ96VzyS2wh5E	1
4658	2vb5K81nTieiq3EN7Jg6pPN2kVHkGjGsrgZgRJs9Meao6rxZerfJ	1
4660	2vb5Wb9ZzXoGdg3U5ir8xwbdVz3uUpRQux4Km96YfNV4dCRFbAgy	1
4665	2vbhffX6rMz3YjnDiAsatqCgNzThVCFZtJianaZkNtoSjnnF5Uqw	1
4672	2vbiL8P6Fp5h4pwiGVNdtPoqL6fmS8urDEDHkkVeXRvMaBbnMKb5	1
4674	2vb5cRcUTD19fvqTwz5fbcdwtweBvvaFkcJxdVEZPP4gkCsRZULg	1
4676	2vbwSQmfYZiZJoZU4F5Acwbt7DLRhss7DBJT1neqgo2nyGJb61vb	1
4679	2vauor4gfQ3VzUTv7A2GtpfaJ49ZHtrD3emqRGiUvfTY1acY8wWe	1
4686	2vbsQLcxTGCf39ZTWfsTuWZYm9XJNZaCyqtyxZac9evYTVb19ZdU	1
4690	2vayG2iTiZC1XAC4mkQssmrDPVAamUrGMbtpNrGRiQHS6QGJajMf	1
4694	2vbCziBMFCgZSNaJGjcHUdnFZmRQ7jp4SzQ6uY6JmhGW6ZRbQgQo	1
4696	2vc1RAjqoqesi2SFmXJwLMy8xrQADTzSx4KK3k1ZzXqByCz6VeT9	1
4697	2vaDXszxmJj7pkB4CBHXoJPwWjVmaZxT1GdWaiwssN8WipqtxPUu	1
4704	2vaKkxAFjk2EnnaJp1XBGQhF4zfVeApcuhRsBBRd5UFFurSKWHG7	1
4706	2vbReNEAuYNGHS9CdM3SnPfe3Si8gXW6DzJqww8fwpxQAmCXvfUd	1
4711	2vaor5AWrNv3puom1N9RtEJrXWcV1Mm8mJ9mZrNXxcxLXLbL6rZM	1
4713	2vaHdfcwVH39kMyV7m8NVCKHXP8XcomM5XBpPkmrfN3Jfr5WrUJQ	1
4718	2vat9nzneL9ayrqWsLapCgCNfnFo7CrUzPAJd2hKheomkRavgP2X	1
4724	2vbn2eSUtW9hJ7iKtS17JD8i6CPxdC2GK694s8J9dW99NFnCN7c9	1
4726	2vbjwLZzvfpd2xJRiNtoddnkkGqFLfPwh7jprkf8Kx43e5XWp2Bg	1
4734	2vbLXkxdcXngYnxs3jV8QV52MtjcrKB4kBydeXAkkwUEPomZyN6p	1
4735	2vaNWa2YDoAa1ASNfham6Y626oreyMXJ1AZjCBhomd95SSvAAJj4	1
4736	2vbFgJzMBUnCttQreXWPSz1sG9sbbFPDRqghB4Z5DFTtSmtQbYDZ	1
4739	2vaCPqMYFdSZntM6rEB8LxY4F1ifwTN7c94LvKg4UVvjKa16u2fK	1
4744	2vbVizuBiej8MzxVBHgwQZvEHdTnSpq8n8jZRhSh44egZJe5ZVLs	1
4746	2vanjJ8az2QALizHLXaDCobJzzFdvmHcrTaRzzYVBQEuUtCBfefK	1
4756	2vaqfQUHGVuG8LC8ER1fGW7Q4HEtGPmUPHswVBc1nsnteXMRhJ7u	1
4758	2vb959uKFTdzTU7GFnLeZK9nZ1bAcwLBcwmfjyfWRn9c3aTQiTwa	1
4761	2vbrf1QiTo7Lkuw9m4a8jjy1PyLYNtr9RoJoYjs9SEPrK2bzJVRb	1
4763	2vbm8jZRQe1qAAqY4BkzVwbKYWryjAbbhriEBPQ4sH9A9ARGigt5	1
4768	2vc4JLMcaNQvS4b2P6GNXqwjgEmCTwJyvDB5p3ntNTVcjLqm79St	1
4774	2vbx94YYK9xCDiXvbjEQxvYww4e8ZtxQBJfzjShjyN4JaczGtRhk	1
4777	2vb1R1tCjo4X8Ytg2pGBiu5YSFU1tNvGVDU9uYnPkF9MCkQkXKa8	1
4786	2vbUTZaLajB3zoh727EZcNX6cWkAMWEk8KyyLQwRp2CbaJ1HCupt	1
4789	2vacyR3ykzgQmKYqQLFJJRLbxSDzH6hL6gHigUfr3SBjnnSRfswQ	1
4790	2vaGVxLz7GMn62NDMW2raqKAfNS7qBN14DmUftCPYVNz4j6H93AX	1
4792	2vaQ5csoY8Ge4vemwdpBqwtfhAFuCtnCrcDYLeAaaVpSw96UMnvz	1
4797	2vboTD6NuJvMSUUjc7pY33KDUpFtA6PJYiQ48SFYhRBYnSDQFxXF	1
4801	2vbEdDUHwjEUhi5pK88A4Xoow2c15bx2VdmQxqyXxBDDDQ75Y7Zc	1
4803	2vaeS4p4LXKMuorJq5jpPwgRxsbFp3d3LDEhzh9JkkrhYHAkMSWT	1
4809	2vbm8FiCv2DznMZhqLFQ7QzzRUaj5iA7RwprsaYFc82rRBmzBKEF	1
4814	2vaaYkESBeq8ugGzL7xXrjJyAb1UEiSdPvTTB6Nfc4uYQvHiZoid	1
4817	2vattaWGwUu74gf6ovADccVTCnQStLdLAHR2Bich4pGt1fhE3bHe	1
4820	2vb2nRGTDEkzA8rRyXwziuw1mecgshwYCLHhrRmGPvoBGUT4c3j2	1
4827	2vbmxaZjjKUfh9LiMcZJFRiXiTW1yvJqMJXZ7NcsRQnte1hcgGnw	1
4830	2vbh3xKjddsGBGJBGFv9VtVtRYtgzWCW7X86RDZDtU4eSo5pBzzz	1
4836	2vb5GVa7pUS84boDiUpMVM7T8fXtcHN928XRb8B8vCVcyHHPJMpB	1
4839	2vaABG6qC1DxXFkUM1pRvy8i29dx1Ur1wn8vzXzcDzf1eM4mQ42F	1
4840	2vbU8n35pC2CByEhpHte21AVZjZGXh3jdAZ3bQqWS2xVsfsA16XD	1
4843	2vb7TmxUZKHAKtGcJ2skgqvxu2K2TwTJSL2m4PxQ1KKgBD4DL7mf	1
4853	2vb3Z5sprFRRovWeLuQSS8TQ9vDwkSKi86n2nXKuTnV8Zck68SNH	1
4855	2vadWGmPNgu69qWArfihAg7Rf9wFPvveWQS1k6GPCQCwKNxV8bwx	1
4862	2vaSZuA8FECHYVHnAQEys5bD4mNRSKMnqq7D5BZHRpVzRJGTwdAK	1
4866	2vbx7p7Tcic5C7FV2k7KgRxL2eM7w1AsRPy6b4ddxHruL89VM1DX	1
4868	2vaQCoVQvhnqJ1ZNDh9tJR54zcp49LS3wb473jcFgWR7mX7RH9E3	1
4875	2vc11j8Fpgm7iMeEnGTPh6sJkBF8adaeMye3DAt97qAUgoA7QRCA	1
4877	2va9tm55rHut54JCKueU2RfhMQjCpJo5Kxwntab8tfGqbEDgxLEc	1
4878	2vbshr3EzwXMwxiT4FffecSWwSY1PAUFyXPeHNSBCZQzZiaVpbuC	1
4879	2vaRWMDAd2f2DGx3q9mkVpGERcZXqJSDKDKH2FuuUtRaKE6GBJ8B	1
4883	2vabc7zgYnefFMyBb9KceoXEok4jrX16dsBh1vRBC2SkTXWd4juz	1
4886	2vbyMAHMF9xVxBuxriUauC91pCvkqDfeWYahGg5YooZgvebt3s7n	1
4892	2vbNRYWtUfW6nfqfC7cGft99S9nebFGfFdmeAxPRpvoXGHjyk4LZ	1
4893	2vapkRynep1vau9rwPsRQeRD2J4urEbaQtEQyWE1bSoBaTd6K5GS	1
4897	2vbJMqbeDEZpWc44LmnuckKUMtMFt7fVAuNpNWrzh8hc7zye2Dpo	1
4904	2vbauo48UwZgzgBqsUrEEj9Ltvvm9d1gwnmTf2GiTDeReGvQRRtL	1
4911	2vb6863QhqBhymizW1JBFihJEa1Lw1vZjiSCBc4NcQd7WS61Fctj	1
4913	2vaH9R8ieumHW3QqvxzA4X8pWeRU1PMJV7jSMG5uyngjjRB7NDgD	1
4914	2vbsmwDgB5Wr4BNX7PRdXuWUFRxYgEKwneiZmYpJhHmgtqNzU8Um	1
4918	2vbBYtsVDdKYu4Gd7eRYDbXYoHPNYmcaXV64Ss5Ybd1rwPHWX6pn	1
4921	2vaEEVmRZuwGBX5jLuK1QrS8G8h1bCmUYQBKV9R9j3zyqhfkzae6	1
4928	2vbccFGdWVk18EzFfTzWmisHTLhwV9qbznzqZmSABYQrvNBzYkWb	1
4933	2vb8BJrMBuemLQ9N94y9GkL4rrywyccDW4NGLUGwNfHusSpS3BYu	1
4926	2vbsHgjw2P9dsNx9anBxtd23NvUmEziqwCkwkvSWLx8uMUB3mamg	1
4930	2vaHrk8hUHpKFcvCRpWwJw59G8RCgVgqApCat9EACBGAc9nN6Fp3	1
4943	2vbnXwvWTogtw9icrKyE3xDF6M4GfYagzaSpC3414bytxzALLsqM	1
4944	2vacjg3nSZs9i2BpQTVSf3GabqxMFNHrPSeyaUjH38CQC8w15xYd	1
4945	2vb1x8Q41Y94QtCqtUXuPifQd2G7s4tLxdK2iV5dSqdhPe4HjyDD	1
4948	2vbmqw3geUgDG7Nfdu5XtXQGinFhyEoryphgQSSydiak1GiXKPLL	1
4952	2vaZZMgbZF95u7kbpH9AsZtJTzqMXSrrjiiRTuh8rhK1PKH1FArD	1
4956	2vaTA1Gr47PvCuwbATEf6XtccXkkDrm7pnCqt5WsRSqEB6NsBXwU	1
4960	2vaNU9XigjKbGtZsFa3E4aUTdL9hu6FPVv1r8SGHA1fQrZQ9h5YY	1
4967	2vbXnKQUaZP2xHQHip2Gdw9YJv8dJCWWqxLTtQ1qDaCVjD2oCoEy	1
4970	2vaPBANfQQtU5MMDbkBwRhJ45FhZB6jMXugQX2vHbU75n5GNJQym	1
4976	2vaY3t1PUtVME2drM2gqwzmAX7BiRLK9eZyyYrFcnrXQ3ZE8WyYm	1
4978	2vbPnBbHKYmgSxzAEamVAcp4QfHFV7AY5R8tLTuqGzuBeXWjxRyn	1
4980	2vbCRozgkvjCJYkRG32keB1MSfdLmuA5mcnrE8sfzR4QxHv12J5o	1
4985	2vc1zrNmxMjyHM7UPw6cWUh2WEd4sZGCiwePmgBHNbCoLP8eiQNG	1
4991	2vb5rkP1Ez51szVkmonuPFrWYkXQaXkLnMTfAiE4iZEf9JM3reU3	1
4992	2vaUirWq9LhZ3czaTzvE9j6K9ytXjARvEtsMqDvDYPGbkGKTjF1F	1
4994	2vc2AD2Rt4AUPRwrB3W79pmGPfTN1g3oxqbAnp5JKcvythNXvWpy	1
4996	2vbqwj3scECQ2gSAbxabjYjfZnQBDtNjfu2nZFxkzk5CvsMJt9Qj	1
5001	2vbG2SdPbDzF6F9PvoFujn1jJoLW4g9g1zfF6qMRFJubLJWusKXT	1
5002	2vaK3djrWv2V8uYn8WNRpGFHs6t1ZqZ6z491xToPu2cfDEfBaHqL	1
5015	2vbLpsYiGZiYotn4VRWw3vwpk5UgkGDkkXYz1ikv8mzSAF8v3xsG	1
5020	2vc4Dqr3y8uHWKcxAUMB4NfV4Do14e4XrZfJj4oKyqRM8D5jGZxm	1
4934	2va9snA5jSy3JUYui5awknwJPKXDP7dyqAJhJqKiCvKw2hdkESpL	1
4936	2vaaXgahUmk1gaFeeDvFwwHQkBMJRRUsFiJFQJ75zp7eZUaa1PFE	1
4939	2vbXdbGscMZQouU863teiSWAprGRkWYukiXwQVmtd3FdYN2piZxo	1
4942	2vbM34EQ7Dx2zhn97mnuYUrzVx667fM4tW71TokiXk161kWVTuDy	1
4947	2vbfiwTunJC2RU4UxQ1gxruafvDcDbQa5KQ8W2EZGsGSwxMG7xKL	1
4949	2vahpwhsmef6hqaTSrS5bffxf9MqsMkf1cgGpRyKc1xgMUoriGhi	1
4950	2vab79ZHuCxaLyhQwgFAno7LHo4CMDKsXHHrn2qph92e3K6TKoJQ	1
4955	2vbAyFopnJ2o8BqL2JjKAopxj9ccdALnP7LBuvw9oSEyWXpSuAAf	1
4961	2vbZ77hwkghvzYE8W4qMk3Y2B3iepAYUsvkL5t5WXEVoW8hwEvCg	1
4964	2vc51C3jwBx3B1riGnKKfQwDw9desfoMLMvXtnHsErhhGwg7HEmG	1
4969	2vbjy7EA87UatpCmoGj4zfvtMHLPDwtEMEro7macfNEV2Tw2fjzb	1
4971	2vavVPm7czyBoHNX7os6txUFg5qJQ1otz1eAHtbZzYtH1hNxHJ5q	1
4973	2vaGzToL4w9pu2SsWw3GvWFpM2hN6WAkpiugXxykM9kXoqkZhesq	1
4979	2vc3885QyxQpaQtVTVQP6nYZMjqiEtNq2FMZ4pu6mPbraKmTndSv	1
4983	2vbSiHs1P19r6XKYA6pZEBHLZhoEiY3CfNVHixJdGRR1k33U1aoK	1
4986	2vaommPigoaPitP1rHsMh9cB93mFEtrRWdJU14S3WgHCpjKNFsvC	1
4993	2vadpwAvvbU5n4Ab2TXGPJWJnqik1doygX4eR9eajdgqfeiowpKu	1
4995	2vbvh2NRmYYRwM2cjFogfrG1JspsRzktLyavz17RPv98fAayyMNf	1
4998	2vaL8TbiZu6GnH5sFx511AiWy7VAYqesjvgZKoXFLxw8zEbw4dx6	1
5004	2vaWeNmr3gBjByiNPwkuKt9r2EfHW6vi7KaPiRJcHDPTHJapc22b	1
5005	2vbzXffAMTGD5fPPQuSbvrckqaggVHBYXMgDYZUiQ1xDAFzmMVEn	1
5009	2vbR5pKSMxwd1bYES5hHFaMRErXfM19wAdiLyUd7y7N6snvEhakW	1
5012	2vbpLF1B9AyDJ61152mEwhfUqXwL2F2EzRMjcR7A1unV72axAtCu	1
5016	2vbqtSNaKAtXJK91bUqf2oqgzXVAVQTe3tuykorPq8R1dAePdd2J	1
4935	2vanMMMxoxTgTdpDni23afbymJNwThkQAbf6vYhzaLmC8sSPUaVB	1
4937	2vab5tjiZJAGdNpVw1BzEbmJfeqmyds7gnNPVpy5EQ9FNjqFCXkB	1
4951	2vc2iTnKRYFfi5PXE1fpbHkNk5gDegAXcNnyCEv9ppomGQDxi3T1	1
4953	2vaiCP5w2my8bqBSveKaEWn7L2AhBrS7x27u58DpCAFoy8kUCTGy	1
4957	2vaFFp9Thp9AzLDcatrLnVXCriehku7wFLZemBbWVWPXq3pg8RUL	1
4958	2vaTdizozMXcc4J19pT8snut8DTioPfdD1hm3RwsrFZ6yg2Erjmj	1
4959	2vam17U4HqdJk68vFS7ozstLodWb5U8CSVJxmpV12NdhtzgheBQT	1
4963	2vaX9V6fWE27bf6duzhHouQPHp3ffE4VDqeexAMDouk8ZP96Ty3h	1
4965	2vaYpNimxuyNa3n14pDSSNYZWjfRFBpkRuVatQsqkxXvmbn9uAkC	1
4966	2vbrvE47RSRcjf8RdjqcNhtfub5gHiiQxXxW79aN59Xm29D6ZkgS	1
4974	2vc3ehjoSJtb5PvctrzQwkTZZpidSSyyKdnyTJ4KBrdE5raR4bUQ	1
4975	2vb3N9dionPvKVu49ef5uZnz4C8EHZ3zJes31Jt8NUdEXjQmGnJ2	1
4981	2vc31wjasnFWCxsd7NhavtRSUHTXTGXd3Xv8fySvsi8brkfyWYB4	1
4982	2vb9ECtRAL4PpdTT4QNx9vwyQMnUC7qvxuNyhd73bUK9GTEH3n7c	1
4984	2vayD1DZw9PCxEp5bjGaPehzC81c6iV41UkSuoiF2ds3jV1J8uQD	1
4988	2vaWFuZ96aKRvZ78if4NaikqtaGY8CCh5w88wVYcz7gvvxrrhgF1	1
4989	2vajA6k6GG89DchSSEqdG3dzv1gSRV7XcdKtehWGkefjWX1UBgNq	1
4990	2vbKUv2BDMSngvZmUFNcXUQo9MNvUV7CVikE1sgoAFnTuMGVspdZ	1
5000	2vasRQkiyVWPyVZoa6ZoFE7N39srpruvkFscYY7MBgwKTEx2Wbop	1
5006	2vbpoQie1sas3M1YbRSe4jQEE2auBywi18YFjesYB7MLfsoLf9wo	1
5011	2vaY1wWWVKW7J3b53K3bLsHj3P1ySvmxGYjy28MUGTewde2fkijQ	1
5013	2vbUCsRJGEXKQ43k4JKvP5fg47kRhdrDfWR6s33AiNi3aFCMvzaw	1
5019	2vaeG36EdGTE2NM4KTxRJGt2Xc2jPPUDakCcizAKzRffyGebTzgu	1
4962	2vasrx9gz4kBPNFpG5bHf5bxUFUGVYaaeMd6jiguMxDTfUQCCpRj	1
4968	2vb3dzcc9SBHhuMPQgqPjSRQTYhwjDbdmCDkvfK6t5mzv2v5n1hr	1
4972	2vbxbU6pj6Puo5EaTJFk9nzqSJqWBg6smQdmMFYL8hFNoYFaoHLo	1
4977	2vbhg8G7JStPTL7JirZUgyqUemoJLFFmaBGYBXB9JbUbwuGqZGak	1
4987	2vaBzTsJVYzYKqf5VZTRJGkeBGGCatmHUp9vEfYSPXoMQDUnSQmn	1
4997	2vbiR3UWUE9fgLbvFoquqDzvxwcmn4SiPn7A19NBxr4GcmeNnTtR	1
4999	2vadDJkBf6q4sTNQbB5R6egntQZhybAvhW9V7BsrKSZ8iMobdey6	1
5003	2vacaukhycRoJHXzZrn9wVMJo4Y7inXe23JNRSZwykzKX5CxxyD6	1
5007	2vaB3p1JbtmCcDjrGUu9hosoXYrsuCA5iW7DFCxVb1wLc5LVcvSX	1
5008	2vavf4Z2o4qxrhHkB85V1WzRdT1nwxicPx34moSiosVYNsCw3wyo	1
5010	2vbFfVYGSoMcB21KQc5Z74kqc6WoNearHyxgX5Mr9kHpn6NKtW2B	1
5014	2vbvreheAtnwyMnrQiqZBs4om52Uyp6HjHS17M7a8AqBcdb63pc8	1
5017	2vayBDUGmWQ5ipwjrmxAPDhyRPMsuSeG4mUhJnr1qVLCCbbsKzZ9	1
5018	2vbWhHbXzRtYJ6yLLokmNYhg3B4YTGF32CC6KAeU4iPABUASJdQr	1
5021	2vbrFc8kJdh584uGoa9LosM5p75sLHJKVT7CNxZnhWnufnL7uQaR	1
5022	2vaw6ctPu2wTLNuvN9rkFEBA1fE9TGQkYuGRAsWLzV2MBwGjzx1n	1
5023	2vc1PQXjDmiJErRZAZAC45N6cEX9ew2HU7o1gzwJ5XLrzeMonsNU	1
5024	2vbaCu4doovkgZ3EwtuE9oZM3QsLo8fiVTProFqzAkRJhJ24QnRu	1
5025	2vb9nAAYXDoXbhMFyGx9jwpgSLQEYV6MwUDTdwz5rtvCFhyGyHDQ	1
5026	2vb2V3frJkMYsARt9MN6JwUCMXaXTToWvCxp588riAkbyCSJosQt	1
5027	2vadEv5t82h4U7YpXSL65sDJWcMvmaTcuCZXA1JGL3zY1WCkRRDj	1
5028	2vboUdcgGEMvueAJTJLYc6hTkxMLcjzjD2XNHzXPnNQNzUsDEV4X	1
5029	2vauL1PedFN96gvyNXDjtzxwGHhq63cmpxe8i47svTjhucZGKyQ4	1
5030	2vaVKtsYVSYExN8pkGzRpDsYaL4JKiv3upbuNGvofdxYxYgJEaTD	1
5031	2vbjE6YrLH7W5TALwMLJKixiwQU2J4TZ8spyowwxqeJgR7XA6f2n	1
5032	2vbHqwMb3ngaaqps3sBYgxiHepKdY5i1eAeDU8rqaHvquiNurJi5	1
5033	2vb4ZNSFc4B7C2pnPa5E8WWqP8oChwEdoY2bav2pY8ikrHRqeYmB	1
5034	2vbn6Nk87pS2TUCFusaY9yvFHXRtaut5684KhDoXbYSn8dsxcs5V	1
5035	2vbpPpFM3xwBACS8N4g1ifKFXWesVLwRfzaC5MPL8qV9TCCLkvuu	1
5036	2vb38dqvEtNaeDER1b4JttL18xFZbnDeeXQQgim31fLv1djPYhCi	1
5037	2vbgTvPLKaBK3ghZ7uQRiUCpeDyByaFYrKXPsxfEhbEdG2itts6v	1
5038	2vacndxhytK7Wg5EVVKXQcKGHX4iLsuEFXP9ELvX4g76MR5vWHAL	1
5039	2vboj9Tj8YeSAP9GgD9zWwuHCmLmw3gzxyG9YJeCZtwspmqTG94J	1
5040	2vaBsxX3iheqh98zYHTSobJU3mh4XugVBZCtgzFwAmcGHxppQAsg	1
5041	2vb7i2RnSE14TzGPankeBTBV4dVb6wTFh9Q8JLpQB5Vzpw9GVdVw	1
5042	2vbWiUw34P9wH9hN9azgKgN2ARkiDRf8J5t2eMrSZFnPexr3JxB9	1
5043	2vc1j3NEAbiNNRKCwqcmekFdjh7gjJ7w2tR1hJVhKEm8Wd4vy5XE	1
5044	2vbKBcWf7M4nKdAjGMo4R5ST9NeUqehwSiUkrq3GpvShvV6nYBn5	1
5045	2vaMJer8zU4JBGKoMAqtACLxi9D9kCAP7czTt1D6Dhb5x4SN8nPA	1
5046	2vbN86EAtJyGrKEbyZdK8UnJneV6ZPjRMoVPCiRPMw4YGBMwEGY4	1
5047	2vbgUjHuxASLCMm6HGJicr7q1PFo4e1nCSjaSyhzxAR32kSND6Sj	1
5048	2vaCLfZxtmVp6pHb4rwwT5oHA1Ms3Nw7eTW3Wgq3Rush3i6ZTPDV	1
5049	2vbapUKNxcjqPvwJ1ENdMwgdAPtcQgkEPcaS8vCrpxTcNyREtcPA	1
5050	2vbMfBvYRJ9vs5dmQwAJSD8X3GzEEgnbyP81L5Yn7uA9HKitQkFz	1
5051	2vbhwaFRXS8BAJLjR6HPoLPk7HixUkQeQuUK4uXqs8Cg397kR18r	1
5052	2vbpDMteBpHDQZrJH3EtTRrXpU8mZAfu7LWw1hgct47bKgCsJL7V	1
5053	2vaUZgJeujUztpVwcaqqJAAaHdBtfYykDPFynNj3peHeeAejFna1	1
5054	2vaHULB7ncr7986RXRi7vUbgTc2oWfgkVTHH9anYN697gcLEv7dG	1
5055	2vbBcdDmopfDwrwHtQCejhNkSWq9pq5ZyNWy43XSkJb2Hze2BH7x	1
5056	2vbMXUMhmEhTtEG1K61wY8iWGKw273gB2FCgxtVTXwgg7Fy1TWCh	1
5057	2vaQ1GpGPFYvGRjfBehtFGCDYA8a67iG9gt7fS53L6DBtdwjv6t8	1
5058	2vb8m5wp4ZCHDvdwVAZ1JhB32Zd8WCkgmGWA7ahnXrPXiiwXbmZJ	1
5059	2vbeTncDdwHwFaDbHDBF5ecYraUcCp9r64VxSpWyuAER9hdLjSxT	1
5060	2vbSdZG8NRRfaJBca5qnkowXHHUrguRak3zbKBrYmrbu1D7PTfgD	1
5061	2vayEx36mEZ9oUCivNrw5fMg2QFdW1jDvPKzHhLGeorVMoCRiJj9	1
5062	2vbi6bUFF2j22mtNsgjizBqH4ARdfuhKPXSmQTnNtrxaeBLwveVm	1
5063	2vbbebVkB79fgtMQ5fB4M6fKjy93WyxZYL7kTcNaCaNcAM4GzNyS	1
5064	2vbNvYhoxBkZdJbzdMBZ9sEJV54XEAdNtsbitB7nKt6bK4W7QCJ2	1
5065	2vbZNsBvm5xT26DCvPdLRq9FVjgonMRL32Q9Uaurusz7qvNuCYUw	1
5066	2vasXxSuncuLxykcAmfgjNLNyvNXTWxhsWUwhYKiQxQccPTsxoSc	1
5067	2vasQBJnb62fVfdeYVvF4inoZstPjWb9fZg1ZeNyUS6tbiLNeBSW	1
5068	2vc2DvDwCqSsy8uziciuBVXMHX6Ey65FEb2dFfhZMH4M7naHiHq8	1
5069	2vaeSJybk48jBGE23Yd2xqzjxwsMmbWsX2Sov8u9qTyjuzBtJXJg	1
5070	2vbSU8GEHXd8TTPy8AVxreqG16dLyGBpC9Ve4hubyraUvbDaG2Zr	1
5071	2vaQNg3CAxmBw5y5AJdTafnK3XewayM3Vq8gX1cDvp8d6CjEXXKR	1
5072	2vauXf7T8ftbJP7VXrseHr2Nxj8oCJMyLWmNFiaVABUkNLBxbPNG	1
5073	2vbLCuBv6nnwXYce7ANdn6hrNtMLnDfNSYTaQx2iZvk3nkmVxpaQ	1
5074	2vbsxwBCHGSKLzx4fqYrFsWExnrsNZgMYAgG4hchvvZEQVGmPHqB	1
5075	2vbrTXQyanrGSsWSAg5zzWdy8mFSvg22LnnMhXxSoBh9To1q7vZz	1
5076	2vbZts6BpGcYfskMAAVphSzHpHdVuhhoBHrQTTE9JF4xizmZP81Y	1
5077	2vazS6owem6GituNxnPpih2FY74ZhjZXZbA6pYHiPwiz6omuEnAe	1
5078	2vajSJrCNqJF4SjjuJ8ktXHgGrA1QjWrVLwMvtXeWpXFBmaWZCMG	1
5079	2vabWgbYYx7gCTn2uaYoacqBE8iiePNFvLZnQuiTfxKvu5vMTmZP	1
5080	2vbkJQ1nsCQVwuYbVDVTHBoiihhemXQz5iaMPFvGtaeHGc1E1Jju	1
5081	2vbLegD9DAsgDLmqHg2Pr7NxbtFnHK4K7dV6q8ms14sBmyTPzGs1	1
5082	2vbY1DeALhGyrqNStxjvFyhWmm16KaPoC5ctc8jwciv27AXrWfoe	1
5083	2vbeGSQgvsyCkzNmV82j6ddGRJ38dUvPRekrs1p2oA1kmCF4Ka8i	1
5084	2vbeyDk1sYiipNCbL6Q9wcWg9wDWNPqrtNy2A4r8FVaQbXphdaBr	1
5085	2vbc64RZULyaBU1fasez65cqSd5V3p7Mo91WVoP3k8Ti28qP22Zq	1
5086	2vbcEwZqyuX5DEmKUqFaHx2CtDYxGuvWKmQK2DPpdNx6uA3Qn2sq	1
5087	2vbQrWpS2jry7vef7jxU6FdkKX9UmDoZqVZtsEqdSg5FQBoZWMob	1
5088	2vbx1zLaFMQSXTxfqJcHZ5zTxWpS5n5XPWoQwhXai8uZMa9Gho4F	1
5089	2vaAcH7JMF762geKdeMbs3XatWyRv4sWaQ1NbEhc6pn42zYFbWAZ	1
5090	2vabVc2ay4bwoQaA6HtSsh4iHDqF3LK7YFCmD6AbFKYhcPBotPr8	1
5091	2vbtiTzB5r9bbbpeG4aYttLmtgP75uzrPv7r7VKCh9cjwn4He6uH	1
5092	2vb8329txXKtjk8u7RQWk186BuP9gqrmNCGQHSPUDjJVWqxRykRp	1
5093	2vbMn6TfjgXhQYMdZQp5kLyMF67LFb5Rh9WSch2GmTXyLH57wWRX	1
5094	2vbZYLnLGRUAat9BGXdR66S789TjRUBRwi475BiTBJPS82NdsW64	1
5095	2vawwubFsfnEYetTFF5pHHH6r3s43Xbj2KqLvkQc85MVFXvX3kKX	1
5099	2va9GPSBE54uxYHaCt7YX7kcdvzd817inWLvAbipcZcQkNRgvbPH	1
5102	2vbpqiaUg9aCTM9rePSa8fqVjDt7G6CuQS1kRpkFicyH35N6SFAH	1
5113	2vbDEQyr6ZaLZinJ3xcXzxQMvAF5oN1pzyMK62iijAmdW2WgYMN3	1
5116	2vaihz6VMMGm874rReR9MHR4zCQokVmWHSCq2NgFpKKjnVgb1ejB	1
5121	2vaV74q9hdJw4riW22bAiPTm3eo9QPCBmZhfk8rw4JG7cWbVzAEq	1
5122	2vazSdN87pRPBg7cKo84TNEp5JxdyGSWG38RxmCbLZ259w8WdiMz	1
5132	2vacQ25PPoxYB2gwXLm2xKEMhVhp9pRWa2PiLGKH8Tf1fNMdQ37o	1
5134	2vbRFoYCKXsZUphYqirFY1wWD6JWuFkggMpbL3s3cSMxAvnYjpDb	1
5137	2vaNBys33p8wPE93Shg87UPyhfpsbwocq3NH7Ai7wSCQKv9AbVt1	1
5144	2vaoHcM5PryKBWcT4CMKBfregLxFuNXkQ58SWCQ6WyeK8c5nB3kp	1
5147	2vbvXyWJ31vJraWauRiGoABZXffhYvYR6c37hbFXHduEpsTpG54Q	1
5156	2vbeu48uxBSRuhsRQGv3M71Xf2PnqF41PMr9u6S2ggmet47DWY5F	1
5158	2vaokXWQxS9Dz2JJXdkhvBGVNNdu8r8YFxxym3wr3XLw2DXRJ5e5	1
5167	2vbFRdnea9ohC6JkNfj79Gapia3qGszDJJ4ThSnN6vP8eyDUmnDC	1
5169	2vbFh6w7VmSngSwVpBxkXsogTLeodN357H9NUEtuosbC25F6NFcV	1
5171	2vbky2AcoF3W224KAETBmw77QmTybs29sWtGQWzz2gYsN77sLh6B	1
5173	2vbpBdzYMCGyenJWnwNB7P9DFfdNibjbSM725X2AY7gJQHGNJmvM	1
5178	2vaFYkXZZi6JFfEcXdJwDGQJJ836BMxvYJAmMR4ZU3bNTGFEPdVX	1
5180	2vaQkPeExmY8qLtQaPbnzeopWtepYj7YMGtLhhAxNd6hgtns2MHL	1
5185	2vbaDQcPWggWkMr78K3kmq6ZyAAjHyuDMhNgevoMv281DpqvaGMF	1
5188	2vbv88XtxQDSWHUm7LoWdA7TKsgPFFf84fkqQ5nEmv7sNHQmh6FZ	1
5190	2vbsk7Not5vah5f4wL7FrANu3TnLcw4hoYprA6Usgpp38urHqQqd	1
5195	2vbsZcukCuM5x4YCzfuruPTCpZoLHYqqNLeDqYGLF6sxVgSdNynQ	1
5200	2vbHt7BY8c1DfJHrPWXzryTvttMevwRQfyB9feDiJRMYhz9QeLhn	1
5203	2vbN4gEYk9qk75rMQTM2YorqgCQDyqc9Co5ebPXn1GwMEr38wyGG	1
5209	2vbKGx6MMJjZvAuFrZ63U1D32frihc5SHPDvx1Pxdq8A7qWw5rQT	1
5212	2vaead8BZ7FZXfMvSMzV8ZN8eTFe3MV5nLCSZe3Cm8qZMzsFdKfL	1
5217	2vbmmvUuj26qcESqbR5gPGEtH52qmRpBgUoDRwh4Nw5Udgh43m9r	1
5223	2vaQxXcQ7JsNJNwDkB4JjcgHeyR1HzFHSreNqg7zC4fxhTNuZV9R	1
5224	2vaoTvXSsDnryGfrca3NYv3uGyKnRAdJdud7sJMZTxbGntSndNsk	1
5226	2vau6NLHwevRFrd64bq22qWn5D8BJjp3ELC968UQPY5gUKcS81iP	1
5229	2vaV2hZV3ouPsjp84V2oH8SQ2P62o8cobC4Z67YsbebZJkJvcsvq	1
5231	2vbxgiUcWghHdcY6zgbY6qoMVJwCbwbQbgTN9GNe3dDCXJUqj8xn	1
5233	2vbNtXAknUvN63WUhmb87Wu2FM9EXDKnLwGJ9e98frrwpRmACMhP	1
5238	2vc3BRr6YPySzKqqnNRReJzA2UT6o2rhprxz9D1h1hRHgr2XrgjX	1
5241	2vbnsMTUXR7s82tXTPXtwNqhoQcBhz89ur8DzePm5AR8JqoWrVPt	1
5245	2vaxYWXcw1CT8EVq8v1eGpUKqwx1MmUNgjPDnYi2YvyzS5c8hwro	1
5249	2vauDvb4ShqtPAUSfXLLHo2ocfZgq3QdDugtsng46vddEnfufbHW	1
5253	2vbVLZB1oSGH3muYpGFLhaRjis3RMfNzeW9oFRNywLRtfJr1T9pj	1
5256	2vbts8xNPJgRzTPmkLbnfpkegQqky7r3ars6QXxSDosDw5CyWFXZ	1
5262	2vawKzb9gxAmVqHMntijG9zzSgn1ygoLGkLA3QxgRBCzyWPPrbhp	1
5267	2vc16SSX7w7PP3V76StySDAPQSQCNNnT5cnQAK2ZeHuciwWHgyox	1
5269	2vbURkMVL2vEnFem9cmSxBuSdttmHuweXbHJYfbw3uyUDUDwZSmZ	1
5274	2vbwviak4u8M4T5qr1xB3BxhmPjobJ97ghL8FKzHQRwN1RJcHuMT	1
5279	2vaZ71rQF4tPrjFmvQ6TG6LiUdcCycEYuTisn68B1EiP5du1Dqgh	1
5284	2vby4M35J5V5dY2hyx6ThmyYbbFVAYXZi8JriopkKY6w6SWKkaMJ	1
5285	2vaqWdQ8rg73YkaLBJPQcVYyi4q3FHRg2FSg4Ru2nMVcJrYKW486	1
5290	2vaLz2Ueq2KBGGL7Yquz53sGoTy3qhsutUoJ4NKn6mBtXrwYZAk5	1
5295	2vbbdi7vhfpezy62fXALKcJaNCAowg7ZUoVT3mLpG3Sd2d3nPbYa	1
5298	2va9oFy4DtiPvDdTk2BJsBzADZjhFVam13moZxTv3nydQE7T318G	1
5300	2vc1soJnEvn9qqbThx7Xw7npqwGWFzxgyFsCZgALbR2iYCzBndEy	1
5309	2vazgaAhNjWFnyUMbi6dWVG6pQDh1xk33S2VyfseCrxs2UmtYyvU	1
5314	2vaG8niw1pvXS7pmPPDhoB4s3rY84SXrnrMNQKM7gFiNN3qaE29m	1
5316	2vbvarXFG4xpDV955FLEeXSy8SnsaBJcX4ZQ6Yt47uVJKUDGRPiH	1
5319	2vbb2744S9ao3uNJo8bQMVz32cdPXafRy44vmMQLSmxFJft5DFNk	1
5323	2vb4gKJhaxh1TsXcBXKrCUsQEJ5DPf2wV5ZMVwe7fzGZqapaP7TB	1
5326	2vb2atcyzeMyJpB8dsXx1FgDSNHSkQ3vqznV6QL8yJ2g84UB9qwy	1
5327	2vbFoiyuhPf9qNmQW7qw3WneHX9vvQ8MroE4VmH4hNv2MFyrgqJF	1
5334	2vb2qDXpMPW6HChrJRzKjb1uUSDfaQ8cVvTbeLEDSbqbEe3quxSx	1
5341	2vc55roKWwntVGYbp2PBJNnyUMfuvX77qtEYoKQQTCo4aosWzENd	1
5344	2vbVit1NaCwu9SpXc3oyVjnFvnS754FpHXB1gwAk9agwmEGyA9Xv	1
5347	2vbcVQG3hxyQYpwHGCvYramtAXaS6Ym3qKDFXD28UsNbRKveLYGd	1
5353	2vbFvZVKRMqnUoYTAHQoFCYFLfFf3edyE7mBeKzo15DDB9CrDV4C	1
5360	2vaTnpvZqUbR76WFfZEdbDkp9M4KhbfmQSHt4d6wW1XdwTiNeaQn	1
5365	2vaaRdSAPvFQSzpzfD87pnsSgArDSJ8UpJJ8S1yPtU6Eo537cBxz	1
5374	2varX4gi2Kd3F3TKH4ioTudEMr98bdJjemHzcQbZxGZFYjK7q67a	1
5376	2vbA3VMzPiiArqApArsEB51LENkQoqyKPCtYPM8E2Gw4JSCrCXZG	1
5380	2vbKCAPN4QrrqMSRyPg5ULfP2EGRg9n3U1hZRkrdv1UhbzptXt77	1
5382	2vaRgomiCmtxDB149cby4zHjBokbGUVLpPuKqB6erd3zRQimHHdJ	1
5389	2vaySj7baEeuNva7Si1cqqjfXj76BTJeiBtVVJcXHd3kjvGuJeic	1
5394	2vbBgUXfEJ4pRbVs2Vv5spdjeo8p7bA5nx9a56LvrG3y5618uX3K	1
5396	2varBFDiHgwz35yg2JVHz1dWgzE5F9n7KsT6bqhoEdW9XtdqX73R	1
5399	2vaz8LVXvH5gox8ZiiWL3eaA1UnD7H8RyeT2X9wUHA5StfMBjY6F	1
5408	2vb8Q84PfoVjAvaP4oMRP5bNVSa7n3Cd6FBHUtgftxxxPj4qKzNe	1
5409	2van6gwK5nmtaqmoz8edVyvW4B3Mfj8ejqDM4NjrnyQTyCe8Twan	1
5411	2vayTtuqCtKqkS1DnG8yvi32RW6wXjxdvN3ExT3mXfGjEWBUeHmR	1
5413	2vaU2HmPaTn2FNkEqvdpZkBXZvfmD81iESFDrb3UwfPW4a3PR9ZD	1
5419	2vaadJbu4unWHGf6NKydi9Fdzdnp4TdpP5oLGnTb1Sw41Zos9bhj	1
5422	2vbdLHCyNbhHFNRnFgKdp2xsbkxb6ACEwBNfPBq7ehdSbfwVdd4F	1
5425	2vbGALEQeA5c1RyjRvTT1a79tn51xoWJXe1DQwFcz9S1M177N3Yu	1
5427	2vbg4XkPPATJLXYVSUvuKuTwDSJPtwhmVpJ1k4jBTdmjsBqWsUGe	1
5437	2vbdxt1HvL7e2ZMKso8khymLuDmZ7W7jMjeCBL7U1JCLyNaYjcjn	1
5444	2vaZjAKbeysXEPAwsRK4Rko7HwNorVLnYc8hViW1rTaBM93CYJ8u	1
5447	2vaEMfTQfiZEjLxNwzhraTHSKAyuEwPRGcuTFZEaJJWFxQAGpAUF	1
5450	2vaXpj186zJroBHi7NGfU6EJa66tLDjQAFt5rZwxQMP81hshD4jf	1
5452	2vc5htyRG19DjT3RvauyU3s4PwHru84CxeC6k8anq2oeKfJhYfpx	1
5455	2vbST9vRLa7d1QMxvmKATg27zhHuZ4M5H76mtRnPbGAN1dPDGyqZ	1
5096	2vahknxdFwntqgvQ7L2jitdpqZ4S6Jk9iQ3i8PifFeojKahk4msH	1
5106	2vawk8obzyuesaT9vZrANWFzLUUJue7K886uK5WFQB28HmQbmXSx	1
5109	2vavgZPC67sktycn4y2VmhjBAefrked9pDGc7231LJhzBZjXvsCb	1
5111	2vbWemLgx8vDmMevznMb3wVf4fw7YtRgHnWGkXz3Yp7RbFnGrPqs	1
5114	2vav5z64xwMjgpdS8XKbE9SeuSt5rA7ChvzTTZbq2sJen78WSfes	1
5119	2vbdS5YDkidC4xYvrLpdfAEKze3wj4noFP7Y9iYytyuASSkfHPhM	1
5123	2vbawG5h3pcDFTX3BSaUERGWRGeHy5oDYDVMdtRFuAAfGkd3q9Q5	1
5126	2vbxnzd1jPMAzknZiHG3p2eh3DhRXVUPrB3udWmwEzTLqn1RiwTq	1
5131	2vbSESKu8s2fQ1YvXX3EHBrmdmpzcz2PhGaPSrxNLp1CHWNDbUCU	1
5133	2vaK6hnyC937QnAxBGQAacXjJSKbAc9Z2omgsqo16Yv1zUwxJKs1	1
5136	2vbuXq2pLeHa5QXeqtKf8qB7ZUchWTosD4rWaMPeCGuGWaj6usvD	1
5138	2vb7GZGAxrH3STKT44RiKdYsvZWiPbNQBFp51Sc2WtwWq4Tyj3RK	1
5148	2vaaSM7LbsH5SJPfSQYq3N4aND48WSVyYtf7xUBBEEuo9mEP2yRz	1
5151	2vaAhnjAv6epbNXhvZkidDxq2kbERKBF7v3h8UmaCjG9egLZVHb5	1
5153	2vbs7mJyKkMnfMDtPXcraYbi9oeZSRA4NyaGYaKyf28SL5cwQ2Jw	1
5155	2vawVntua6Txe3zjJnxkrTyGfWxQcSdM24CwCpJCm2qpGUad1nsz	1
5157	2vbdVfPqrZe4KjQG4otNu4MYwPk3cGSAddpuTrvX9LayQyzw8Lsr	1
5160	2vbDL1pd4t2nKZDGAmhwd2ym4YBNGuPdCNMbGVYMAQohYbZY5C9y	1
5163	2vbTzXEuyH6hakytdgixSyaURyeA62248hYZ2BRC3ADp9iGyv75G	1
5165	2vapt7JrGfLW2jZNrxx6apxQsrfXWuyzeJCMRxWtRmeLaxvGsCjU	1
5168	2vbvKHobVBZodXrpNUkbTex855js174MeRSrbeQQGCZ5ucx1vW4K	1
5176	2vaMG2G8HuTYHu9TRNVzgKem89qJ6vkFghpscFmagS9nBLKwi1kF	1
5184	2vbaVUxPZMUdyAt5avGYreCVum9XhoZkctzBhJCakk4sQgA7pFPf	1
5186	2vbFpwgzyY9evm6zw4WsaTW3pJmzihJYzRb5EPK6rK1xhmVi11CN	1
5191	2vbPjf3zgTnjTSsP3pHzpHA83fwhnwJN6w5aNYY6kv1S7HeSKh2D	1
5193	2vbYqYby3vrviVKCW3KPtDgxyDnf9cjLsciTMc8Mq8NabQmVYRrT	1
5196	2vaRCkqo66Cndx18276LSN5kqdYrRnXJmaqWea24sKnjfeNiHCx5	1
5199	2vannFjgzzQ7vZTzXzJuzTFzqFeLESmWSMzT5ML9GStK8k4gBqEY	1
5202	2vb49JsQsZrbCpvpDrjpPhU7rB1AuAMDopFoirs6Z5aw8R2y2AbZ	1
5213	2vbyuFxPNSvRLx5Ynry29sz9BWQo4P5XGHPxucboFWGF8uEXktRX	1
5216	2vb6bLuYiyofgYGK1D3bdNMZt4gmiMW8iymrTaAhr5LUNxjc6Rkr	1
5218	2vadnQpeZRv3YCB8ibyEUvusuqUJ2M1c1F39t77ZVLL1o2ELdGD3	1
5221	2vb5xAdzHVAEfkBfLyej3Y2wpMREGAX8zxZbLE5ZzzMmxnZjetso	1
5230	2vbU2bq5DkmcrFHMNfVtxVkwMiXRSvFwNiUikF44EnVdg5nwu3Sa	1
5232	2vaXQiMXnLhMFxZPGUjXNH8vc4Jk1Rz2HNtkVTetbGTGdzBxXeM3	1
5243	2vbLybEdjpSSmCPcLDRDt314LakfJvbNo28JEUKD3Guj23UEzjSR	1
5247	2vb7EraEPeSKaoCsnWbXYxY8g4mbn9YhcenfEhQL3msEvTxucZw9	1
5252	2vbKJxZ1trorRqurL38CseeqHqrmAHgHU1SD9uTyFp5azu3Q5yJ8	1
5255	2vb7vJ4wAnUCMgcNcQAcZ6cFggrPKpndrecEfDGKhznYhfSpAWnc	1
5259	2vaHCBnQgQ7LKAPgWq9p3KVSnJZqaAtstUVsw4gE5a4sb1SVh2mL	1
5260	2vbWeCZK8qc2gryUPrpkJnZW24wAr9BFi3VU8ogW3N7wos42kQ9x	1
5261	2vbycCbpGxWewu55WWZaM9nFqgmJQtrUdmjDos6VR39U3ayFAG9e	1
5265	2vbWpp28v4E9CRYtz2ACsjgCbKSpVDunotDw3xyyDzKk75rQfQu4	1
5268	2vbUMzmrRfL3ThswB7wpKU99UEscSdkha9yXU89nETb7hdMAnY94	1
5271	2vaTMqPzmqu4k2C2X4nvRwZof3JK3oTgtFamDNnYR2dAiUtXUeXP	1
5276	2vbF1nGi4nAACSVRs6QYV6d1K1g5z8CmNitqtmomadjcshZxaM1J	1
5278	2vaffowziWuMv5CgKkkN7MdtZUt5bcVY33p1DKNwphWZH6WPXth2	1
5289	2vaBoT8npfNQyDSbHwEtGaZPZA7rg2YVU6Q1vv95Mwju1qn7bbVA	1
5294	2vacozRVDqQbYDLA7YkGwMGVVdE2pDWcSTm6vN3edmSjQ4ep36zT	1
5299	2vaSjGQD5cJVBso3LwLeFY7o3LrkqAMFHoJHamH7Amg1vh9oiAZc	1
5302	2vbRQaTiXHmWD23Hh5oTeJnMCKuGGXFEPhB4UieV1uY5v41hfqMf	1
5305	2vbpQxKQVUnKMScukAEyBjJPx8LYrWQDgXxwPf5H9TVGmrDvjFYk	1
5308	2vaVdHfwLsRt2xYAiyyJzeJBW5XGTr3xG9sXs8ATdZq7pfbK5kbN	1
5310	2vb6ewmCcC2V93qhq8Mtc3igJnWvDzJjV5HRxa1dgoaGMJuP4pFf	1
5317	2va9o3Qxv4WSJddnJa7Ev7eLoLgPMxuyzuC9DgdEUyTZtNzQsQgF	1
5325	2vbTFvUV3ZX7kWjqRFmCqkbGr3hhoferUN72jqpDoPpi9objkbuN	1
5328	2vb3H1pNt65QZmbsQgCF1XMPcdWr88UYL3MkdZ6Xpxgnf2my51QV	1
5331	2vaAnSLVqKWCWxdSiofRchsfspruvqMAdtQKWLfRL4oMo2UMVXXD	1
5335	2vauY14tFjghsrUrkSWY432RH9QZ6cPNH8SMCmdoGzqeFGizggNH	1
5338	2vbDaHkZqXVdid3GSDWyzFrE2NHJ3Bso45p9zxxfpmHeQEGUX42K	1
5340	2vb5K37EBJEWg2KfS3pKHXV6Lbp8UcYy89TuRXLfnEBH6Epon8XH	1
5345	2vaNDyyaRbZmCTEVNf9VcqQupC2j27QWbK1XNzCpqFqmBzY7yFXu	1
5350	2vbo3exFt1RKRpB95Fw4sUjvzpcGENbbRD18oGdc7yVqJNPJ8aPf	1
5354	2vaYyeYK5C669ogjwaEeY4xSonJ2UYiZvxC3Nwf5WcuhhSU9Easc	1
5361	2vbgriEY9EegH1m4aWoue1xjPCxS5kPUqLRcqFi3T4YYpcvCDszt	1
5368	2vaYiXEUBihgiJmQVAgsTV2aMvWUroebGL7GSPtPumSCYZzyL3pU	1
5370	2vbs3CjywPxusum1pSfoqfetP36WN5TUzrpeWw4ncgBSqA5jAvjN	1
5375	2vazXT7Go6JGmgM1uhN2JuMWiyCVjm4sUpJC5u5WRtK3syUd6wN5	1
5377	2vaKWKu3ayBSRfP3LpLjJ2Ah6gbYbFGkMuCWdEvXFaU2P9PgA1eM	1
5378	2vbBK7KuyLzGov9yLUqR56M2TNrgFbsVd4YHqgqfXTsHxC8CK2SY	1
5383	2vabVX5GV1eGbYjFm7QQ7zDdXk7UaeDkGiaYQ7pZgU3tRKjs2pVn	1
5386	2vbFF4MH3ewk87VQyC1qCCvUFagrNRAgA9BBGCUXjBX9nw4djCZp	1
5388	2vb1orzJW7QrbzeLoUaGs8d66KpextKbNHC64PtSANZwgoZF9sLf	1
5391	2vbtDqsavw6v6ASCwLYhk9ij6mTsCQb89bgNf3DezfuFmsNhP12F	1
5395	2vaeUrxdS7i4BBqLobpqZj6aUMZEjDLFsnD2QzJwEJPWZW8pcXf4	1
5402	2vaX2uPVBtjvq4Ss1ewauB4M29icGm3QUeYV768b1xeBn7Lrhjry	1
5407	2vaVmRiXmYg52sLmA4A7fxMwgn4UDmzc6kEp5anGWkoAdfHMxcQV	1
5410	2vbReAiLiom2kXT4QeGyKASmKtqY9UUeNGv4LWy2WYs6SJSmfQXP	1
5416	2vbQG1RJWsTSQVebiBjzXffwBnpZpCgXnBKaJ1LFtUhobtPeHSnU	1
5430	2vbfJSa4dL1m1Mu3A1mAZFM3XDm6rYyf6X3c1683QMwv2bJpspE3	1
5433	2vbcLvvPfkMrPqXvkePbkR3YuBQCebg6SYHr6T5QizQSU7X5KNxV	1
5435	2vc2ZFozXBNNejQmw8NfCxnCX6rKZCBkYpeUq9KwBnpKai4vxPJc	1
5438	2vaqtR51mMxeo8JshGGinr3Q7Ch35cFzSJMXSt7833zp6CDbE1kd	1
5441	2vbXwvUKQAXugRDnqdLNNdscYN66YCgc6zpoJEUkAT5y8CiLdEK3	1
5445	2van8vtEFCwUjRBDVeqF1ggCAVzKLgTEQiPopf5zRonnFEztwRur	1
5448	2vbKQKat98Dgc86JstWN78uB48L7cwQ5d5B82eFodXr3iuzqDbPK	1
5453	2vc3xHF3gfC3DwWYpbDJ3NGRL96dbmAoTSRdT9i9SeCKQ3SLiHPr	1
5457	2vbrAG2ReQSSUu3c48oeVTBbazBx6h1mjgg1gLCKCzBVQ3hf7ne7	1
5097	2vbbSRuqRUTwyqr2V6QkQzAmemMkFeke7CoGPNZQVkVSzZ1dJbLF	1
5101	2varHPab1rEiBeNmy4URmsSaEkZ3KocSjeVJHANP4WeGUZU6uXF5	1
5104	2vbqUSuj7Y9ctZuM6eYuq6nn2MuESjPvLHC46vJwKXbFooS6xFiV	1
5107	2vbAzT6CZx23KCULi2KcKySdTXuBTW9hK5VXuhWfiHjBSUQx13RN	1
5112	2vaxiSFpbHd5rw2edEBKVEG16qXHfdSx5exz6rAZrYZmdzVSpB7A	1
5115	2vaSAsuyNxWMQtt1PiKy7XwLy5ki99dX9SGMVZF85iVPJpJzh3YV	1
5118	2vbDxAzsweYZ7mKNAW8t5nQ15gDoeuZkVg5Ga2Btw1sNo7px85iq	1
5120	2vau9KL8a4ArEfMXamYeLyJet7pvMfV4Un1ZtPAQFGMc5SNZtFLf	1
5124	2vaP5DWm2gPav3rTQ6gfccV9FFV1RpzePmS8hoBhCxB7vFZigWKT	1
5127	2vafezrRGxhLqQKV2Hdq2pfTQCenYzX4brcpkPMmzJoSJy5EAZsH	1
5129	2vaVCz8ZYbMU4EP3LxcFgccUYByBVHbmQtUKNpKcF1jmqNSzHrq3	1
5139	2vbzN4cRYQMGJzEyhA6M3Qz3s9M7J6QBz1877sTQmGg5YhmDhb4P	1
5141	2var8hK2cXCqMc3BVu6aBCGjV646MAprtYEZfmgUVJAtF22dnkfB	1
5143	2vbxcAgwMZbZ7tNrG2JjJCiHXRH68HsvLMuKBGkRweiWWFyPLZmJ	1
5146	2vaDDZLtqNJFcL1iS6KD2FB2Coz43SqgufhYJsUuZTw3Aszab7GF	1
5149	2vaBr6nWUkmswjhY11qHNVzrAmgXHcw2BeBvnkA8jBAGenFnevDq	1
5154	2vbMThZTjrixX8HJWyaLHcknLMChEwD2C5eC7jUAhGji7xUvTwsv	1
5161	2vbCNAy9JSNuArXZfyeL54pg53VNvzxmFxpLB52ugTrq4LJECSL4	1
5162	2vau3aXcCkLAhZ6o749QsPFUdss7zBxGzvVVkc5E89VU5JTGRaS5	1
5164	2vc2N5bpUPFLWBKk3oes5SvcJDiT7XJoUXHFqoGQPdSZo9874mMD	1
5166	2vbHFgohWPfMa8ppjhKULSY7r16FJzJyvzewaYHCzjrFXs4Tb8Rp	1
5170	2vaTxurwThTkzE6uviWcPKXr2f91dv1EioKC1KxoQpAW1zvRuwPZ	1
5175	2vbg5rnJPC1hKyb9r2urpu3u9yoE5sPxbXdGSvtMEPALgH5GS9Tn	1
5177	2vb3YRNXqC9W9PCfCkkUWFLKt1sBX6C6yX6tpTzdLLWFqCM2YWPG	1
5179	2vbDMsdrrX3U7hXpRkHpyuDq6gSsgVF4biTnHcSKN1LgrggQCGib	1
5182	2vbsG16wZsNPFwQcNi4TLHiCvbUFYniA2Gz4jw9id1yQf29uTYm9	1
5187	2vapaThVcgrLfHYYa5Grq8v2LgYuyDWs39a5zbuxbXcMaT1WRmpp	1
5189	2vbG2Mzd8K2kRdu4na1PmGShUvLJjRtg5FGEkgTh2r5jL6oDnXz5	1
5192	2vaUzfihETwvU7hD9MiZErWyr8PVCe43SaQPbQBqrcsvqryn9MeE	1
5194	2vbao3B2dWWTRpuo3U76suPLKpvv26Js8nzA6vU8by5jg3rYpcsh	1
5197	2vbAXcoEjyqLwQrnMQHw1PycxgCGThELpSN7xVaGhNH5Dwt21rgT	1
5205	2vbpCvPMVrXJgZ9VpVZxqGBxVqhWoGEj2pFbGbaSrKTnzEGT4i5Z	1
5206	2vbZ2tzLJS4HYdpKmzcNNypr6XYA7Srn3xxTRn79VddrrRMCp3QX	1
5208	2vbGZRS4TdGCQvAZeWaGgJwkxhdimHmf1ns2WdeXDS3cctS8Q1eF	1
5211	2vbSL6woSXKPCvvAV5V7HDbfgxuFjXjsFNing5pZPqG6vNCJj666	1
5214	2vb4qziMDWH18paZnSh7re6SygwLdssV8QS6hacamwd2UxELJafG	1
5219	2vaBSTHDvPVB6veZsjcz84e3CVNBjZgDTWtE4aF1hkjYwwT3KXAd	1
5222	2vbwx7cgunbWXYeK77RK5QkH2nsPTCqswU1KFNKGTcMBw7fvL92D	1
5228	2vbLYgwXbjGJZfULB5aC2dyH1nnKnmCmLxPFnUqh2UNbnk4pV5in	1
5235	2vb7YCZt9RLbDv8tScgzqZPfbcmS6Kx4CKpz1JJ2ha2Jqi1S9Mmd	1
5237	2vbprQ51JiBH13Nf2czZTEaRo698ANUcUiCmPWsgq2BecUuoM82i	1
5240	2vbaoDR83msB5xp9DtjUgEGy3JtJn2XdKsGNAC61xEEVMR3G5Cjr	1
5244	2vacTgm5J1bR2EozkUex2QPyaj2sea5aDHxFd7uGfS34yoQbVfaK	1
5248	2vb1SGYY5dY8hwyvdssqgXTvj8eEGdCM7nKeK5oFquDTjuQfHArf	1
5251	2vaRUSbjV3iaw7gSHmqehTcR8bwFXmbQFGpaEYbUiXFef7L93d9A	1
5258	2vadhpsEqy1RGQiUMCTZYFMrxVgo3izfCKcnMCMQC1vtFtHiJjGe	1
5263	2vbHrwC9sdPF1E2oAvP5XessPUfQBSwwGKuU1CNNFm42gdvuBksE	1
5266	2vadLBL4NNJVuUZRrr5hKbh3iwygnbL88KdV15S2giuDcFQ8zvhT	1
5272	2vbghXvXQhYu97A9bkChzyMdGeWfPPPxhY3XkettUfow5NWahVBC	1
5273	2vc3KU8WxLgG11GnawXRuoXykcdCcRH3f3MBjjNTcKUG2L4CLdFf	1
5277	2vbNTURPuk3HB8pEDX4Qo4jdDSLW1DK9hXnVvrcGExYvxu7mLp8x	1
5281	2vaJDMWfdtmBTUNDf6W6VfH9VCuXaDhWrEB2st4B7U8Rv4drZSKj	1
5283	2vaSTDYANVbNPs4ij5YSqrJe2hhtExLCvVXai8hTER95AnGjKPDn	1
5287	2vbvRezA7KUaV6hu892Xj84HHSXMCcz8NC8u3uSpmBAa3fir5ZDa	1
5292	2vbx4Lw7y69yaV35moKfHaDMzhAVLtJQguvTW81kwRzWrcXRa6vq	1
5297	2vbuf4GRFnaHT64ygWAGfK6iCVJfGBzbnUaQXh5ZWbmD8PAyhtcv	1
5303	2vaXTTDqiknCXY1dKzd7Nwwonh3o9obdjW3v1Sre8v4Ft5VoYbUk	1
5306	2vaQ7onzkHQxPVc7pb7UxvRc5REGPr65EPLZWkspNahrv1DSLYot	1
5311	2vbhm2rN9D22zShPeqhJmFTojgsyUoGSfHM5nw3pKXvSUHgkG1Wr	1
5313	2vbHm3YySbAfXyd7Xge27F8qpPc3EcqZCVEL7nuWcycUrgMEm97H	1
5315	2vapXvy1DqPU4UsymgUCXeBPyxfBxxnVeeJp8zZHGexRxWSA9hzn	1
5318	2vajv9GKujEGq549y7HQJAAgu48nWbCrffp83AK64xDbfxpTmg54	1
5320	2vaznJid1eqCVs2JNTwJKe4UPBuXqvjQBbYc713XgtpaSonKTBDF	1
5322	2vbcVFtxoWetZhMae93Vpzd3t3eiEfezKcYkbZjNKq9CQ1miV2rN	1
5329	2vaAZ4wroiYCe17V6ECS9D9Cch2x7CxLPXkUfYoK6sgWtRwe8vez	1
5333	2vbfkvtUvNTz71nH5z1sH5KesfQdWmgZvvFszdhHoBxGWrW3H9AD	1
5336	2vbTFEMmuCKM7eGiQVuuSJAL2CWjpr8v59wMmYscPKthFD2yjX1Q	1
5343	2vagytQdSs514DYRbFf1cJHLHabhqD1H3Np2PUeAcPaSCYmAaryT	1
5346	2vc2SAeXxnri1ud1jA37BY2DqoAAhHSxTPACngHyU3c4FCKSF39m	1
5348	2varUmeH4kJ9ZCnRic6bH2QcUjUHj55YDanbDiXeR6u3Cu1W9npP	1
5352	2vavoMvnN9Tjx2eYZ4VUvQxkrzkUr3LEhWrAvNeCpPRWXUbp5yjV	1
5355	2vaf1x2g9MG1fX3XKV8k1SS5qijb3LQ9vhGmjEVmpG3BzvMWAomD	1
5357	2vbiTxa3R1sfzwTmnndgUmUKJnxyBwanfUm64C5tcoxJzYXUDVDf	1
5359	2vaSDo4stnXJDjWfS5nn7Ri9gKm1GqfvmFpaTcP2Lk4a8jjYsiEr	1
5362	2vaXjCbvA9eUEns88pct6ZXZn8zQBTduX4D3owvdMEKb5YWqUjzb	1
5364	2vbJZHUvSjaTwPYxQwqRpADG939RgrzSBjnnrVsMLwYpWSCXA22A	1
5369	2vbwTBhcv3VgwLTzNoZM2MAqStN4Q6cV8hBvKbJbXfLY1Ea8r74b	1
5371	2vbEjTXr5NiGrf5s9byM19hqyFbVKyNJugeM6ybcqzXUihcC6LXd	1
5373	2vaUg6WHbfpYYycGwj3sfWCykMXqstPuKTz8XxKMFrbu8Gd4e7kB	1
5379	2vaPssqGsWoGYRtz1Vrpak9coXpUA3ZETQm8pB68qvs68smitHKj	1
5381	2vbmDCN7ZbZ5k71g2HBWCjpB7EtgMRA4jZ617hqiUSp7doyF5XN4	1
5384	2vbMW4Yk5iNd46ANpJeKGALvgATuV4Pb6KMwKsAr72JQBdzUWWJn	1
5387	2vbMgnNQHAVahVrxGTGdbQQkSgkZm5DtDDxsWEyQpocxYfqKMpxP	1
5393	2vc3LK8aBxQfKMhJ7JT2QHJuKNDAqqTk3hWkoKyaHV9FfMHHLf4K	1
5398	2vapmFeS7ZuFS7PeWNpwuf6jxTs9Do74BXss5tpneBTRitnKN8Fa	1
5401	2vafyfe2QsKuptMAofM7rSK5iTwJSuaAAKFDohezyRWfxDiFRJ9N	1
5403	2vaSb9jEhAvyojYJ3eq1PMonhqRR9ppcKvf1XPhQVsVi7xuZ1oH2	1
5405	2vb2CtQuSABZUDAcxkoU3NGfiLkEsnLCnjnGFqLEhMxow6zwjMMZ	1
5098	2vc4xD3FVbLSuDwbfdGxPhD2PJF6ZCF1LdTonSbbUJ3YsXMBbazR	1
5100	2vaM5S7BPdLQESW8UpcRKro1xv6E5xiHBTzd1p31A6YYC3YP84wb	1
5103	2vapsmKZeaLLiRCB5Nr7JuxW4wGHwgGHcqNFq1999rBfMMjY13Gs	1
5105	2vangUFq2g7mVQb5W3P2hRoJBkfeKAqTQR8NjjhBfmLk1UjPVtWN	1
5108	2vatBhLmjwZeqZ2ZibVbhhM3hgnWVtXt6Nz8Srx7et6y7xaC6VJ7	1
5110	2vaiwmEkn8goVUVcuP3SE1SebJryNxY8pogxZCpDXdwpANkBZG7H	1
5117	2vaf6Hse7ZJDYvSkbU4FTBrTtQ7GuMF5aumFiN4HxxW52F8Fo4XU	1
5125	2vaYYbA8Mo2XFTrqaBt9HU5MHJju1ArLsXnC2SBzSsx61Bit7JAt	1
5128	2vbt5DmcJPWPGh3WrhkVXVbz62s7rBri82K1CwQ3DPmgAX61aaEh	1
5130	2vbcbycaT93VXZdwXJ7VFcVu9H8Et4FVb2c39p6pUBw7q742Lwz6	1
5135	2vc3fMkSMJDpHvNUxLxxQjNBPyHpEgtsUvJidX55S1NH59hgwoQb	1
5140	2vbZybs6hQfroFEEXYcaCyyLHyZDufCM7CrEyyWEqS5epZ4xDkFK	1
5142	2vc2mjfaVFUUg3FZUhnfTKoqA7QzXWQ3nzhB3seqVcH9vkLL7etS	1
5145	2vaRdgDQqWm3EqSEG3q8RMzWAMiwhiS7vBme36HL2dBeUkUgF355	1
5150	2vbttF95WazbMEozeh9Ln8giE9fRnmnsPmpc86SaPf2At9p57fJz	1
5152	2vbypvmzVTmLgjKUmgVi6LsqkJpZQAAuuo1DuzFHMQHzEphytdzN	1
5159	2vbCinkdrEirfeHe6hz9ngjxrLe28APVMRE4Hf6PqbjLGg1kbef9	1
5172	2vaEjhatfkKjM2xP2YCNkQQGvz4BE5zmYPUH1iLZXcpeGGkG4aE2	1
5174	2vaLkGdK778Jo99E9exo6sWDjSe25N19J85P9kWFrgTGAggt1heT	1
5181	2vbhyLSFHer2zAvhusdq4n2h6TLb8T9goYy6xPgZnbyNsseYDVwQ	1
5183	2vaTRvmdNofoKgjQwFpMvpKWarGEfrQcPFaq9V2LVZ8yU1FcYRz3	1
5198	2vbYJbXiM5SVpqsbj7ZfkYMure31jkaw4ZhhMrWFfN76o6gRuEYi	1
5201	2vaPGgUruVzahbMJBLSCiQGQKkY82N3p8DfhwbiuaXELspbBVjLW	1
5204	2vaEsxRX74sFKqLSLtvwPUCiy5KMN7Gsk7w7mnf4ZLtvcaUKSyWm	1
5207	2vbPDj13zR7Ac1gEQpY3hLnfGZvtJvzuLYkuXQpEqMKqVuHeyCkd	1
5210	2vbubnuTCYUBCBkbuz1hgMtcejigFjq3pkq8oH1anCVtGSLWrhau	1
5215	2vaRaL8sS85pMrrLE7PuvsRJZsMhyUaRBEh7prc2btjvCA4V9x15	1
5220	2vbhgDaNF4fDkG5dekKUkgQFWmi6B1LioDXiRfPqnK6pwLw9gjbM	1
5225	2vbaYbpEscFAXs7u5gDFUox9iLE391eJb2MvZdF4EvhGDhX38Xxs	1
5227	2vbki8xKLeGSmST5KuBL88f8ePqnVVXs79XiPqGuBmk5Ya5ry4w2	1
5234	2vaGdtmqVxiA18jbTDsGN2cspcfYPaR6objDiGJivkEtrxrhugDq	1
5236	2vbtChNPJd3pdtcHzVfHDYRMr4EM7MtoXGcBTxr7MND6b8bvozJc	1
5239	2vaymdQRVHzqzGUSPMGzjie3fscbtPNuRJEQBTF8kudLmzC5Y2wn	1
5242	2vaeT9miFkf1o6VkhCQHS8nNWdsmpfjL2LvY4nfT7mGw4MYsPX3V	1
5246	2vbP8Y9Zk3FPHqEZTCdnYJpZ5XssqTcJYvzwAkFmTq977dqFcAPu	1
5250	2vc355gdhiHuKvyr4BRbjPtcxkPbjUHbZCYHhVqaCRsV9bK8v8qp	1
5254	2vbZesjFebXPZeYiwDVrspcrdnTMK1VFJiZW2tnC5CVFBntKKSzM	1
5257	2vaEAM4fbRKm913YRtDu2dZYt6Cg5yTBckBew48vMjA1Jp23uXJ9	1
5264	2vaz21tSQ1in3wZBqWH9xKnADkg1WJmW3uejuXdACCaJyUGrs2ZX	1
5270	2vbuyrmhMXqVG8RbM9veWvYXUF6mxpwUT8KDn2FuXyRSA5Fanxhs	1
5275	2vaPH3g5adv6sdf9EHBgbG7JtSJmW68ojG9VGZLqN5Zab6K97Aoc	1
5280	2vajrneqgXEFMD98p3oXBYBMkE6hBZae8Twr8h1WxUKBEgwRJuEV	1
5282	2vbRiRxujCfLhuiRGyUznxZB3FeRog2joBbmdQUaNgHdJakRBmUM	1
5286	2vabdUHqUXjYiuER6jjm8EXRKbPXuTs15kKXTTLUzcUztzngdch2	1
5288	2vbDPzRP7Np8NCWUpbnU8kSjrVRDVkrfviY1mx8jJMgtSNKvj5nW	1
5291	2vauUF2F5zUaz3Jj9CRjyo4MpR3WiR7UNU6cJLTVRWWbAkFetMP9	1
5293	2vbiEmTuYWxs85swx11RkYhX6eHwTKwoBJ82oeACg41vUzKm38u7	1
5296	2vaF63gL5YU4ZGUS4JRTbpzQY8ornLrNRnk16BAYb2hoYgYMvKSE	1
5301	2vahJGxZXN7pghvKpcbKf69KGiRJ3PN6A8eEyXWDN3HQk86L3nvP	1
5304	2vaJizLjTaJFaKfxFftwNAag4fFv2ueFLfoPqWEXqAALV3dCjsjH	1
5307	2vaysbNU4T7g68Dyi4MNiAKN2RSMZKRfxVLjSdnxzB3UetL3CQRt	1
5312	2vbRqtigHtd3BUX4UrghWmn6nyfwQp4ctqRSXiUz5AU74hsg5n8y	1
5321	2vbRXKo669FNCor44mw5d73JAReFVz2c3d34LPTGvYH3BUrLCPTk	1
5324	2vaUGy7zStTqkn1ZEafWULUJ66zXGRtYsjuSwoSYmFzCAGYTduBc	1
5330	2vaCnCcob6TUFHYajn8fGrDDJgErxcN37ANG1CpSpMSTc6g4g1st	1
5332	2vb4RLtrd2Ca8uBaUyYz3h5SMzBczgmCXRCLLFJHS7Hx6gFUHhwj	1
5337	2vbkkxtsoSjxXQ5pxa4rp4we1duS8UwguKd7HoJsBh4eB21HNu31	1
5339	2vbFm43C9iuyHdzrS3LBeeYuKTd84dxhC4XQpcYeir3Z3zrKw914	1
5342	2vc2HXkDn5v8jjeTNWX8TyFXgTiiLFjwDLwP8tzA8s38oUk4SLQw	1
5349	2vavutx8Px49RbZPAhCqQ2zNncg6QvGYEe28aJU49qBRTf5cwJjW	1
5351	2vbZNEsZfmqwB4ABjNpvGUjQrnW8eZDgGo8z8tVnfRK293zqZK6L	1
5356	2vbEAJjRQgTNCiYgYvfPJfUR35vxUSwvvhM1Uw9x4GDCF9Qp4dg7	1
5358	2vaL25PfWSF9BcBxXmjF3gF1KVb8BFBu9PoLEZj7riAu3vXed7d9	1
5363	2vbh8J2XZHvRMmSv8RBJN6LSYafqsNibif5eU7YXismi7yvfTrzJ	1
5366	2vb4Dcxz21PNMXPM3iRiah8ZcNtkiYDDroGKF62vwKgbArhXcyJv	1
5367	2vbbehLFhig33QcXq6LchCdn5RYRGF9iJwP9NGVEE2XiZAn1Sn54	1
5372	2vbGGooEwvQWifDDT3zjVRk2eTGTjgZt1yNjsah5jhxCZ5W3dM34	1
5385	2vbXPqsS4qHrU8cYjj2JtN7w7wnXvHTM9ehjFJuLwhquaZumfm69	1
5390	2vaJLSmv2zPLyPezedLia2QoAt364tD8RSCf6fqeHesMS8MdVdLN	1
5392	2vacWskqGPGPfMVR91BwLRPmjsivEawFaB53NJveeDELCb9o3aTd	1
5397	2vbPSg5qznLWhDAHs92y7jdDSCE1DsnWJDyXu7NcMEYTp8MXV7w8	1
5400	2va9GSL1Sqjyo5iywAViKUkgz7uDWMwaC2vkkRHLX8Tp4h6dTyLu	1
5404	2vbPESUEnkbMFoWSvXKYMDkYkHqrQhhgZXNLLdCyLAh2JhVtcBvf	1
5406	2vbdkUV7D3YDbFsCqTeXw5k25uBeKJ4QHf8tidxqumiXmNh6PXUm	1
5412	2vbRxUcPkF3kjm8FsZT3QL19CuYjmp6vq5NKd4SJ7UvBjdHVcKTF	1
5415	2vbXqjmfGA3xWWVXwYZxbnV4TMpcnn7HQUjHYsoScSg8EuCWuUBL	1
5418	2vavZwEkjF45wSc4heKZ3kJoduSwj6UGE3usqE3xT1RyjaaaHBKj	1
5420	2vakqZa3wFiJsUBRnodVh7xGJNtr1TUQiy1WbQf6HX8bozkbnmx9	1
5424	2vaZfrJHGpngCA4xS4EPL4pHTF6FNXK2i2g2fxRwuC8n7d9xJv3Y	1
5426	2vasYxMUxbua2dYKB39xKZ5VVecYku2eg1SLyMY9RqxLF4veWuHR	1
5429	2vbJTiCypFjD1EUogdHGWiEtCbdAVDiXoKbxSUYFeam4Khx2TC9q	1
5432	2vbSG5CLdYgPfcqPR4ke1bMA2d4bNR6ne5E4WjoAhgHFZdv1m5RP	1
5434	2vaUmXRh6hRGZfqELHG9ZBpCC1q8x6NehnAe1KHPkptkDkhsrdhS	1
5440	2vaLDotXtMBcaovp9m1aYt8NXnSs1XDQAQE4n6CKMi5gV2DSUVqT	1
5443	2vaBbmcMddtKms1ikGE9pgx556aqghP9yao5RFBAwz7jNtqk1Nt8	1
5449	2vbDrh2R5MWEy7fXoSVyxkZdKhwJJEQFFMJUy4zYWdKRKUEuDxZB	1
5451	2vbcaUNV19chvKJQB2TkKKbRZzGV8vo3Gfq6q4MbM5nh1eVp4qM1	1
5454	2vaafSk64cQxqzWRe8Nv6p8a7xmNasUgoRADhJvfEjsmGiZwam9e	1
5414	2vbdjm6VFGAgZ6N2H79ASSzTpaTiSwYWGt9c6RW6DiTNdB6bT2gG	1
5417	2vaM2j2mV6kGqdReBhATL3c2xQpiapTjuqQWvfy5fnuRBS2UPmt8	1
5421	2vbpA3anyuSQz1G5ybpSz9pnzUwe6mB5NB6gqRfX14gS1Qpzpvo6	1
5423	2vaRrGwewDAN91y3Sc7hRD1zNq54A7gKPigCsq9BtfaXvhsQwTMt	1
5428	2vajrz2NzT82xZXsKnnzP1uVkcpPxykRUyUEGPbTxPGXH2Z5pRp1	1
5431	2vbXrkJo3cqaQtpopsLgMU4ayHk3QQafEk9GRZLvbz5m6PBsYa6M	1
5436	2vaeKffNeCsji9VVbBmjZkSnoG7YVusyyrVHp5N3iKP5KfVz8u7z	1
5439	2vacrzsdjsyNHQ1K8txQcS6Ze6cYFNu4vhLrzzxvrQiw3TUY98Go	1
5442	2vbuHmkPmvAmibmqFRuqEUjjcdLqYNpEMzDobCKMigwDTULE2ZLv	1
5446	2vbSCh7o5ZojkzhT7wryDJY67TCMLe9McVGRJtbpwLNvsqv33gyN	1
5458	2vb8uoSgBXpeMUc2VosMsBhXcHXvTfUKDA1j2BnUX6xaWvQFXW7o	1
5461	2vbSqcjKBc4ywqSnCH8X47o6g7ADGKXY2TAFabMKxUtMWoMZaicK	1
5466	2vb6M8hJAE4H9ZnfoiQQbqPfDm2q1MH9WuoPLDHop999Ri4tKiyG	1
5468	2vb7YqgvEUfp6EnzCgyQeGrX8m3buK11Q9ph2iGavnrN5ip9QfQw	1
5474	2vbjpCbzASQVBikKSfxzQaKuBm69c6J53pDZShFoqMYsHdjsewse	1
5479	2vbdS7FUixSUqDvDNxnMunzPC8gwuuACMuzW3pCTojsbfgKmu9aL	1
5480	2vaSB1Bb65wC1QmbetRwnYFb4cJbDXbS5hydviwF9Z7Qy42Dt8FK	1
5483	2vadh3PtDdFsVqYaJPQgVf93v1EVn9p8us7t4y28WjuV2iigL2yX	1
5485	2vbo6E13JNBmYNu2TbXEUWZ8xqJT2iM4MWw4vSGjCb9r52RhBfdL	1
5487	2vbrkCLqFNANLUxvgsmFgjYU55E1bPtUTibrLLU5gvGQmMJFKJYK	1
5490	2vaHeEnmnZsEWUtWyHD8TLnRgXRUSDDpobYrkJzdQ6J4MkoGFsdF	1
5493	2vam2NDu9oxdhVrmo3s9ZDqKZ8DSiS9jGNWvQWVfVNTyzJsn5BQV	1
5494	2vb6VPNdBmUrCUM2vYKee4AJRboLGTxSHS5dQwetejQ5YNCDV2hh	1
5499	2vaCTQSWCqhXt8jNBf9AfHuPS2jW7erzWzYN15AxF31zD82eNo1U	1
5502	2vaXXkSYst6Vf5VY3yMecNHKNR6EjMK3FeJg2h65Bp9mq1Epr61u	1
5504	2vbYPb4CSW2isaa7aWJprkn43f63aFBFXeDGE2v7oMadCCeq3uWT	1
5508	2vbNHkrcG6Zzp2v9eqjitLLpFEwGyhY2H1yJYaA7mVmKfGGYSqf7	1
5512	2vb5H4J2mE3UuJ4uMbK75pq4XmVcz174zw2vU3BtzXttALyoTU29	1
5514	2vbw6JAL6DU1aBr1fpGd6b2A7B9AnLEkZmUeKVwRsNfCb6f39kZN	1
5529	2vbikopnBEuujk2dbgjzb5vdxzVHiUssBa3KpFA9EXHe3oXQ55gf	1
5533	2vbuU6UgX4MdzPDyfk6HQdQgTxdJHNZdspJci3ZbMwVXPLsQcJye	1
5534	2vbLFdS64QAPuFPqiCEq6xsQH8iTCTbtx4GNVzaycjPNn4JphWQ1	1
5538	2vbgNiaX3bLxDiJtYYBEyDL1BKGmptjQF6qH91ADNT2BUqtzfxvf	1
5541	2vbFLcwhSSbmCLpHnADZGPxrUDBz8t9qLa9JpMAitPVCW3erXEn7	1
5544	2vaSVEiN2cpbZJeextrMdUBd9EAG8hXVbFtqTPme6zQXLVqhixLG	1
5556	2vaFTaEauovb5a5N33Lz5miqxtbpcf691dufnWLHh3e7A1BCKJ22	1
5559	2vbRsh1NYBZnPag4vXNp5YFvUNEM2p3GFcqzdzDjLpdqbXVS3dE8	1
5561	2vc21z71aaKQQWzrvAgxWyfz9nGnnbXm7e92NrcmmF3FwETtztxW	1
5564	2vbEtazZSTZBKMF3CXFCK4S6Qw2kX4eScx3qEZjH7akhdhkYJ1h6	1
5571	2vaD7BMkVE4ster9HaTpGm1QzU1gxMv4SkMsXjow82qwdQJA9NoE	1
5456	2vbBNfZTi6avkDAXZoZsist46VmbYAutVJC8oYsLN39JdNiS4dEt	1
5464	2vbbvRSUfr12uUWcLyzSCv8pNyzZc9TLpsiAf2ouUFH51TJfE9zU	1
5470	2vaXkLJSyNHCEPvFpkv3dTy2uyCxVkZFjd59tSb1i2FSJqRi1SuH	1
5472	2vaKYKkZKr7CSVkxXfaRNQWw3H32qwx8aA89E4VYz3S5p7MxRH8C	1
5477	2vbPYvMFnFYjWpzcpAGRD7FbBDWC4GsRs4Wa3y4giDhtKpK7oJhj	1
5481	2vamjb9DgBQmgViC4KRzdugzJYkRCEGGDPxFsYs5EPAXFfRcBqYT	1
5497	2vaak1V1XPdj2uqZLk6tM5D9ryyqvr31qFHywotEBNyzfhhkRM2A	1
5500	2vaK4w1e3HbarUusXqzU4pDEh98Rfvs9kvtuZgVbyEbsuE5eQYQU	1
5505	2vbHMB5u3Hj4ha8MaRe7X1gbbtFTrxMRnDdxwCjdAH4uMVE2eeSe	1
5509	2vasj18XNbDD9bLpB5qDa34FtvDYtkWQc4c5G5RsPzdyCmC1xb1b	1
5515	2vbHC2f3Dp6NLWturSfCeVELuBGk3PdVPxSXzZ2aMFjGRGGvNgtU	1
5517	2vasKqK55ukkf7G6Gsucj3zAkQV8NRxaS9nhY6kJpz242wYG1zDa	1
5522	2vbeUnvbWzdhcXBwhhwrbohbN2fCbq79C4uhNAjmdWQwjuGFpzNo	1
5527	2vc4Tw88mFTUCEvSPXXHHiepv3AQz85h7KpiT8rJivpWhKo9UeYZ	1
5530	2vbK186BCKewEn4HKdRBNzA4NAcFJdRGtHANY9c9wLDb8p1djXGg	1
5535	2vbpLovoKk9xq9bo3qNDnatHk5TcT4exWFMn4qHRiv6rd6MrB9oZ	1
5539	2vbLpENBhERk1c7ix9jSjaQk8whRfECNqx7BHfapoNxrA8w8DhNw	1
5542	2vbJSKi5rKAVF6kzYMcyRKDPNGLjNWbuNqPdAnAn4XpjTHYqSJGf	1
5547	2vab3R7iegxmch8N1mZYoUni8ycSzuTyoEt4skUnn3ivLtNHtodp	1
5551	2vaEEd3D1SzJxCe1vYYnrMn6KfGJQRJQiqTU8ujLonkideTjmYwy	1
5569	2varS335zDtdYQHQ4Le8rdNFnLas4XthKbuvbx8VUgan1rNKYPRF	1
5572	2vbVJq1nnsqKcUsQZSzDxgjydsiccrKFYx21RQ3RjuNefAkexhZD	1
5459	2vbzeXcK2PdyvBAE5kfK7bcWnuTPpsuAcvnqrKKcS1hQQYHUHXxb	1
5460	2vas6brnRwTv5gYJzoWNWyUGAwGaeksUHb6meqxDg3EKQNxTwAhD	1
5462	2vbbB5bYG3U3oVdRQP8XSGxQYvf3VMWKnUZBTv7Jy6mXEs4avdyA	1
5467	2vb6wqxB2QhDJkbmfEnmsJ9eS97iMPNZqzGaEXsSxHGSgRtJaYZb	1
5475	2vbbspkiuY9sUcn1r6yqaK3hvWdrsZ7gFeiKbf3YVnC5BvXqAKmT	1
5484	2vavT7QzfscjJKNRuWh45wW3iroi42374qHVwUFZKZ57fCrSqXkb	1
5486	2vaL6PV8XxKNnx2RZaNJ2Xf9hjBEeSXcDd9dQXcRcVqtJjZT6abs	1
5488	2vc1YPALFFAufYVX3UAHpKiJUS9nCpg88az2BVQjUWhkxdMkY6uT	1
5491	2vb3oEBtg9o9qUEcqi44U8JeTqBVGxZjJDJz6i4rWuSRCZv2gDB5	1
5495	2vaxjDi4kxneRPYDZd1yt3NdJSFgwTPTVWz466C5x9cirAHn6RsR	1
5506	2vakoig52NnCJYRbTER8pbce7QcL9Ui24jV7utJ6L8ZSYFzA2NNW	1
5510	2vb3zhsjv8NVAJzSNBeJ8WsGbs2GPP7F8amWofs5Zwis4hnND48x	1
5513	2vbwCrDLZuSzr7KeJigurSgKCULLwGAxKgqNjnE18b5Zusp6j3ZT	1
5518	2vaZei9uaWSeLgi2yjJ66L6vmEeeRPjJ3rcsQXFtGsHpA73PgTGq	1
5520	2vaAw1YUCYSbH8PrmYQN32bAvPGd8Jr5rqtECuch1cGiz5JwNCcH	1
5523	2vaozS9xX1iqJWVXZPmMKPeBbruyDTKzppTHnN9R5NK7vPdUdJAB	1
5525	2vaSB7nboei7pYkWVNDswPRRjc8XYEEDFq6zkN1H5cZH7HMYi4Ap	1
5528	2vbzjQFL4wHs5tH764vakMbSS4gSpo7wZBDgg2gQpfSkEbPmhLkc	1
5531	2vafstTVU4uykVgzGb5aCva7LT8iLCDAZP2Whf4FdQpEXXTziy3v	1
5536	2vb4koWp5bpcYJJmB5ghkkbDAXeZgFN5kffJx6VY6amwUvfJMxgQ	1
5540	2vbUkL4JRoFzhDJF3aNWmrfPJKsXy8m92LLn6Sy2JY5vVLj5h4Hp	1
5545	2vc5rDhPmMCDR2p9FmLTnb3w8jeRQDFSCrnaJmjquNSxtxGomJuY	1
5548	2vbHLep5jcc3hUcE9a53GCgPL1TeoY2eT7zUUkrzXTtQiMqTwQwX	1
5552	2vbcdsMgF7wt2RHKninkSkrYMwtyni5o9mXtbzdrw5ASB2VjHKU4	1
5554	2vbmtDU5ZsCCrWfNCGPiGHyoGvs9ZynWcgtM33fAWLqfFxDdQApt	1
5557	2vb59QFYmsmse1nugs9WbinF8XiXytJPJ9NBresgJVeuuy1J3pGf	1
5560	2vbUSJ1tBf6c7CLjY23SoA9KqxEGK3fi9JC7h8jbHPBgFMCF23gS	1
5562	2vbLJ5xCkPZTqhtukfnEYZcqeE5KbqGpvUgtxP1svkCHQjrMEwwF	1
5565	2vbEHUCDCNWC4AaonkiFWLVCCTPHhB5FUAbrwEVFyyiT2of8hhBK	1
5567	2vaGRuvNf4M64yr1hyHtnQZEUNoWVTUMX18PA4sPsdAnRCtZdTmk	1
5570	2varAzedKX9QbmfvvDNpuZhfNHjssTqMER7Z2B7Ef2JQrRvUzSNM	1
5573	2vbTog5NyoamoZFYsfJhgw3rG2xnizj5B4ErV5JBwf71vfC4EjhA	1
5463	2vbHpf9251zVBoubmVBUGpUrW31wVo9SVn7gg8mmL3txeryoAdAN	1
5465	2vbEEPzBALAnrD2sxkwLpUFEuqgep6UszKaxvudstVbJKWUeZfc7	1
5469	2vbfqhwPnDP23wKLiBFSsdRunn4BNn8DwVrY5JX8ECJisoexpNjX	1
5471	2vaaYEy5CFHrXjkCEdtcgMqK1aM9mgqYgQp9LiJUzxuYWdsXx95Q	1
5473	2vbLMYTPN2WdC9taydDKrH2oJeo81mNt1ard1VqxtxLfGiUHzuWD	1
5476	2vacJGGgWa67hEGyYgKG2hqp1mtXJtQfpYopiaHn5FQTeboHWy1J	1
5478	2vbAT1k1gn2YGXzULhrazaXDPfoaRCdA4wR21cGdV2crNCFYSxEo	1
5482	2vamNRDgmvZbFyV5xMDyUTWS378gCJ31W7WaN1F8hxMeZo2q1UeG	1
5489	2vajnoW6yrNDh7i5TEX4Ruv3Xyvu7Pjzc1ifixZd8Dq3GotENsC4	1
5492	2vaBnEAv82N16sis3p1dKvwfa2mW2u4SNSMYH5oGCc7P312NiYBU	1
5496	2vbNHGfieWiX3w9AiioFCGVaDjHC2bxLc2b8z2gE8TrBW2S33fVv	1
5498	2vbyDVsDZqww3cVWiaNKQ1EGdLj3uubDZDLUVKFwMyhreNgVEtrC	1
5501	2vamsEd8xFsruhCqst7ZiSwjytYXWqq6Nxpb7btpn2XM3oopSF6h	1
5503	2vb3FQuBA85UKrCau6ZagcnuC5HmoBhyUTS6UesMCvAq6GWbYmhv	1
5507	2vbvGwEUdiPFzQ6UXDWWJYZEKbpRVGMq2yVHS2R6qyJHdVN4ft79	1
5511	2vbvM1G4jQWScUwCrpqFR2JxpsPXpq4wffG8DLYCebtqdskGHjy9	1
5516	2vahnukchN874c5UwZ3d46XRvhkEnon9QzpxgrFeRnRpXDfs9sT8	1
5519	2vaCCfyf7kWAeTbZoZZ9CwYFfpr9BghyTxRmUZNM7oLXt7mwdkk6	1
5521	2vaQVTGWuvCFd4bFnmQgpQ4KeSEFmMCju7ADTCD14Rbas4PgeWz4	1
5524	2vaweLbXj4TN24yXNuE991Crmpr1Bx3g9c9T2vkYud4ByAdtG8Ug	1
5526	2vafnAasU97BwSwjuvXiGh9omQDrARWW4Wa134CirwVimNBTAEpg	1
5532	2vb1ZUW7Pkkf5UfYmhsqh8uDFW32F5nyihB8RJuPNYdm6F3zPwRX	1
5537	2vc4CEEeT9QyirkwMwpP8h75MesV5gm9cVMMjSDRttDkaBBQvkwd	1
5543	2vaELCf22wsoPFQvckfP5nsvGwoAjzd7SyGPvzRdXpz72cqUCTpd	1
5546	2vawJ3ash7gi9ErXsW1zaFXyds6VGeqeqqvd1gRKN6rtqKBzSgLw	1
5549	2vaNP3RC7MuxXoXLvoYjW3YJtLUyxmQ7Yguax3WQQ3dXDqHCYsxB	1
5550	2vak9KNMsPQjEwCRGQKuqzzNcwrWK9msWXyWvypSPqqTCqdT8yVR	1
5553	2vb7orLZwuM6D4fhT3gcL1Xpshq6dSaL9uGcTSmhxZqzEG9hTo9K	1
5555	2vbdNWacUFWYwQ6VyZz8HY3dPHGnwpdWyK4Rfj2r3UcP5PBd1YRr	1
5558	2vbC1SrcSGPnLgpRLVgNeqQQUPNxnjoiAiJBQazncCKQgDAKbuj2	1
5563	2va9LAwDZYpiTVwVgfoKXn74sBooQ82yjEEpwbfuGGuyNTy8DACr	1
5566	2vbypoGjgs5wEjY559GRjLkNEGVvRCUTo3hxVAuUg1JU2nnKPhuE	1
5568	2vbFrV7tBa7UoSTWmtM88miZWGfimJMWQXv2631JJSLPFbLSiT7v	1
5574	2vbgPdJKqf6oXRWVv8ooDoVPLVvXtcSpuXV3CxU4nP4nuTBuVQZV	1
5575	2vbFCZsyKbjsTbgx6GRectai1RW9LvAfvnK9EpSu8FCKPSPiK156	1
5576	2vby2RQW7dy5fir9cvzmjsqawQ4KFS6mH11yxDG6bNpvCEijxJpy	1
5577	2vbi25hMYCWrUTNZcWj4wipyurXGjGohDYWXt7upK6kPAYsYBwei	1
5578	2vaiHGGsruSecfCRBFHNm7siK9A1xpd2Bzgd3SguNP24FN5HuSmS	1
5579	2vadF1Ux97SteY9u4EUwzqcRdWoBqxAcsUHvL4bZtj7hdFkDgTN6	1
5580	2vaG1DzpEk3ZVRcNiZxuFfadXD7QSAUExT73D6M32TiyHd4k7gUx	1
5581	2vapHkHTSQqakyKZqDTANLRUhAcDBSGpATUAdwvNhyUFT2HDVRsW	1
5582	2vbEk9GYKL5KwUsPrJtqTqu4TRgUy2gYzZipcwoH6qAkcL3tN9zG	1
5583	2vbmcXaC81wR4hZgBvG2qErW17r6qGVXzFpX3ipDkwjNncvGYpNE	1
5584	2vaxHGY8A7wseeL7z8gvEqn9feNPyuZxznAUJEmTUKzrN6Uk3nmk	1
5585	2vaDu1CdaneNPmV7iqtPf3vCqxRASZABLS8ZYegUK78wuuHrAVT4	1
5586	2vbuL85Pb6yA8GWyxcwFcsogK12TXRcSrpUqEUrUDsmhPfMhxnN4	1
5587	2vaHDsYozSij8yD79A2oRtroxhf2GeDYL62RZ4vj9UfJ3fjB8bYJ	1
5588	2vbE2T3kHnscyr3cGBpyopY6ewyCwaXrnMEwhKHLungCwav6VeBV	1
5589	2vawMaJaEND1AP29L1bpPD3veWGoxQwzxtDq14SKGTXueVtkkwga	1
5590	2vbiDzi8voANEvJK3RxG7zzAcQcvqNsZGK4XR41CEyj3c7FtD2Ck	1
5591	2vbTrHwpf2P8fnRYU3rmdSS8exESroXLW1AGTBEprVtc1SzdmcAx	1
5592	2vaeDQNtHZyx6Mb3rdmfB4UYZTozNJHjCumqt9dzGgbjHS4HFL1V	1
5593	2vbhusqa2aqfuCcDXP58AVgUKroLcLdEmT68L6qvRUDnzr95dirw	1
5594	2vbzuobb5LqyGNVPSF6s31qmDK7uBawaKkbNDpWXUT3yvxNzmoP3	1
5595	2vbyMWquQMedSnQnTqkHqMPeckA5Gzf8hJGa1fRKqXKHMuLxpkyB	1
5596	2vbeXDkhWodPY4vjheeayBNiuC3eW2DUgJmps9bnfzAAffQNTy2t	1
5597	2vb9CYabXYoQFErZrgN1iz7KXK9FeyL5R6WagdMFN8k79GuNrEji	1
5598	2vaLSxcH4N79MtGV4HjF3RLNRNdaSFDmrKFrAN7zCPXRLU8g7KMo	1
5599	2vbTw6Ysu72sNu2TSfMqwkVnonyDfsNsBkK37rRZrsuQMFAK2KA7	1
5600	2vbDtLrFwwMdCeB3ckes4kn1BRzMuzWdPxv4YA4WYFiwKBwFSnDW	1
5601	2vadHsRvMAM2rU7ES89hXcjcmUzZTfYSU6ecSLrLEmVhtBrEdZVi	1
5602	2vaqYbqqsVko7TCufcmUPUJM9y18AdQRHGjrccsByqDj7djHCB92	1
5603	2vaSVgxjZYFakLHXmhVbBbzqj1TkCYQRYMPnN2edSEWYfQ5yxzv6	1
5604	2vaMbrgZSWt483CCLVWDPJ6NjCGRDhW3yhLXFxDPXdtfkYiWC163	1
5605	2vamC6p974AjCWRFmaSUjKZQinYdDQMPu12s3fX6RnB7agQtakpY	1
5606	2vaT8NoWSGoTL5QeYhfsFXgKRUMfJuYwDVr29EvEJGR127BsbLks	1
5607	2vaupr4V46v5h1bWnjdJu8Ty95VWy4iyRjPEigo1FxonvjgXc85t	1
5608	2vaHhszcVhCmeG3NNWkVzEdbHPXtLKcFbRkiCCjBzBGxa8Y4teik	1
5609	2vaCs8G1iAekfCtNHMP8CTvxeehoNDqJoBwutaquf7YnmapiXd3g	1
5610	2vc38cJouSa9og5JbTsrus1jfzyavi3UtTn1qBjQPR8MmnUdQdMM	1
5611	2vbKY2xSLutdgoNFHStBGNDnDLH6XdkVXUQFT1czrZwzqBTu7y2A	1
5612	2vanarSsqgC7ApR6crVo37E1KJDDFuCtMi69MYv7eS5B3USkJF1k	1
5613	2vav4u1wmBu9h2EuCtKBFzrvxyY2tA7HkViTyJ4qNTHn3A462qg7	1
5614	2vavuERkuL8vASdzkoR6orJLrNSK3E78hFp7bd5Zv2oHiZrEyxEp	1
5615	2vbshDCMiinkBQxeZdywbov296gDZ4b92iebCN3Dix6y6u7VpkTp	1
5616	2vaU2r99MJHcK1gGNe6pNMS9VU8iECvpVdoSW7MRX9HTFVTt1hEu	1
5617	2vb9fPWf7PeaNqDSFyVrYspLuvHW7CzSadTf7FcxCvr1HM3G1TTZ	1
5618	2vb4kVQmgQFfPgsYQPy4C53jFsqRiX7HGndhFTsbQFhkv8EQqHFJ	1
5619	2vbHXCvfTKMVCEDW2bZbQiduaynoigb3VNrwfBe2bcJphHv5cXEB	1
5620	2vbYVAFAB48idwtTh1D91QSD8LVg1LQSBC5jBefpB5zSN3dG13f3	1
5621	2vbQekPNk8XiEcnRBwMWYoLD7oSJCPEMmHkYBjoKP4pZEqDZ5puK	1
5622	2vagxMNinZdTTsXRdanrYCygv1NAmsQLV6yivpWFNCtNZTvkH3U6	1
5623	2vbsufTMCAqAfWA3fynW1eL5u6AtmpupjxDhou9Pyt7XKknt1yq9	1
5624	2vat8aSapyfaFLHphmon6GaGXDejJsf19BE8bqWrAZifaLi91rQw	1
5625	2vaUD9KFfSVKmdCrnZcGzaQqzBFso4HmgJnPXgRc3LygwVgT1Cgj	1
5626	2vadL5SXyua52fgxUBGDif2uBEfjLyENwpD1NrE3m9x6V6CMXXzk	1
5627	2vbbxe3NU2b1kj6EWm8aqpujycUWYvvAEVFr4ANdPHZycrKTJcZU	1
5628	2vbbULTou7AMyL1LyhrYfZoNKWQDsijoYSSJACnwwZAByDrSuBtA	1
5629	2vaQbsTGifrhxXcjXB9o4xwgcFciMWMjqeqWS7iJyD4aQ35LftHj	1
5631	2vbAjKRdb1AqXX2i7CCRaN1xXsBiXN681b7fMfnPqNBRQHEHSGAu	1
5639	2vabhkZ5QPh4Sbrgs54VcLwLhNbMogrfJCNEgmjcz1jQTRAYRGnt	1
5641	2vbQrZ76G13feYLhUB2W7g5qkt3LLwTGkHJMz2qUPybMHZhRzhZB	1
5644	2vb9tTyzM5PRKq5MJyNb7AytnDZyY55n7DfJxqFQ9p7smVCHsa5Y	1
5648	2vapLkySB5HtYMwcQs4TtaAeWkknXCKwjBwRzN4hPTnTrLzCy3St	1
5656	2vaK4DaaABqDusPz7aH8XV9TpLVpTuGfV5CZLjzcWAPejr5Y6CC4	1
5659	2vbHPur2vkvSpV4XhuqoFn4gmKaQnHhCfgZjgY1Ee9GEwdiNNRow	1
5660	2vbpcnFDf1t7Yk8qv5RGYSSGAnLsJbm1GGph7wdGjHS2JaD8WKhB	1
5661	2vbipG2TTyjuWesxGmfWVAtNNdvcUp7YudjPVuMeqrWgYas2aPNz	1
5663	2vaXaMAMUyrLJodS11WzPujG8GSN54Uc3Y28th3M957T6ZzNwN68	1
5666	2vbjLVet5cmqFj7fBg1P9dYDH7Q5ChXMhiwBKKxBHNwJwry66cj1	1
5673	2vbeGAbXDnH8DPYFn7PinQ8aGqnjtpRCGCnUTL1WLpxt4QzV2gpH	1
5685	2vbmMf8oFGsHTTkDcmTLKjRQn9GxFZch6PfYxFN5NM5x78EwV3VG	1
5689	2vbfwe3kYs3pGjToz81MhUARuG8bzRUAQM8acPkWaBrAxxrTQvdb	1
5693	2vbKPMxXwgnZVENfhh3qPifDG8drFEDrjHmNxvPKayGFyDhU8E5s	1
5695	2vaQ5vT6CQu231K9qAYCDMxzZuHceJSRzBDKgQ9AVRCEPtpueKvp	1
5697	2vbpTHmbRTp71j2NbzR4rttKubXYmNwyWscGRoBSbzCphLZrBhfQ	1
5705	2vaTMTVXemLZHQsLSGsGweqHfDHU8SfBGLSL5THhzhvgdZyAe9Zq	1
5707	2vaYJ3XtoJ7ydp37Zi7mp8xahJoxckgoreN2pvDPHvJ2GKUW8UYM	1
5715	2vb9PV1uSGssjpA9M6kEMqBwk6brKWUg64LrTempV11NLwSugVp2	1
5720	2vamcyKuAC9i843T76bdUqjGpvt367bCho8NXaf2Y9WJBEcv3ErT	1
5722	2vbXN1B9HKeEm8qHEhLsP58N9VJuZdRBs6zJykcF9pWqhoq5y9fv	1
5725	2vbuPrkgHgqKZ3uY2UgoW3wHJLYdhfW1YTfXiBJ4Fi4wjHzWaeNb	1
5727	2vbsf2UJtQHvZq61qXtZFx1aAH8JBpRKi9Cwq5kk6FEzRKE4shAS	1
5730	2vaRXBntb6XPpjAFvbzqm3yEHMvX6Roced2u9u7hbBLitn62ejZU	1
5731	2vakt9L3YYF1LwLHQQrQ3AYEptk9e58GtjQ96jDUxijYLEcqDJKB	1
5732	2vbUGYC4FmxmucbU54ZBeFS1hgdvqhf9QZzbT2k6k7p3XATQCmhp	1
5734	2vaBYC2VuHqC9EsoVQZVoXVD1axmeYgkygUB1hPzsw5GRCd3QFTB	1
5738	2vaparyy44PuEXcFviHzgzAoqqAjGZki1yra7HJTajzyM6B4Nhnj	1
5745	2vakKFAsVqbGuXh8CdcxNWPQydjw58kxF136gV1epA5T3H9EwMSY	1
5746	2vbjQwAxiUEky4ePZzmJfMP9W3NCGPQr9FpK7NUQaJVcGKjRqYHa	1
5749	2vatYtyUh5D1WeBoxVWJdbH3Kwt5qfivUB1CwSGEXJKmkscFD6Qm	1
5767	2vbWX7v2QHBSZ9TALXUCwNj48QUiQMqGJgL5gbtfFMeYsaZj9RcT	1
5772	2vadXXZ3wCA8dzYzgjZ8HgS7dsA5NNie8w3o8njKipUVvRzQBfu9	1
5780	2vajGNvXQjqoMxV9oWpxeRTZuKfbzwsJKYdr3Mak23GCMkrmd2Yy	1
5785	2vasYDkZ5PvfhZZY6TniHK5iaU1HQLeWrhEqHXNvgHQniQcpeJxc	1
5788	2vapHaDxDkpCXHNDn8efdtFPMC6d23KeiRdbe7FpKT5x9HHnYDau	1
5790	2vb6xaix1TwXU2WXZCLjH8VXKwZNHdyUKjJScmwMe343VmwBapKW	1
5795	2vbsJio7aHS9jTg6Ch3JDKtgGdKCUDz1y8L4tiXJHZBLc5SWERfR	1
5801	2vbGuKHkW4xCiE5DKuxZaJcNaURG2bMoSg7CFYM6PCrpR7cv9gy4	1
5803	2vbhWtJn2CxYnSWicPanvnbj6xyawshoquGUqSRghDVQGCRrai91	1
5808	2vaYfv6swYFVWsRr5kLUAcaZBQcg78fP2ktqa6K8p2Q6vAtobwq1	1
5814	2vaYgvtx3t2RhJywUhQ8aNCS2Qm5fBZUyDbCH6YcLUMF2DtrXboq	1
5821	2vayA2WHJ2cT2M1LMagADk5J9M3swda8JNGqfmRovJmUHAMc3vUv	1
5824	2vaXkmNn98WKT2Q29MWYCRYtcWgcqz2VrvSJSKvdqWhByvTy9oxp	1
5826	2vay2p2mYBW8ZcNbjWVur7Gvtpvt4RmtPNrey58zTTzjFmxNwDH5	1
5828	2vaEhDFHmgJVvNtbDzgiRPdPaD7674NGQ9s15RGmKxLcxhMLRc2c	1
5831	2vbx1HScPe3GEW2RLiFtEmAsdWVEscNGWCU6RMZStynWUMYncWnE	1
5838	2vaHbc7sLAGtXVxjHY5kPx615NqH2yitNamjMJV3J2hUMgtrznbk	1
5841	2vakpN8yVtduKCw5Cc4cKrsfX5yA8iyrqD1ZBGstHkSd2QHmqGuz	1
5844	2vaiutxXQrKkeFofjW5ZTABXsHQ99kumrdgEkcm46cDCAcnFWr3X	1
5846	2vaGKRa7r9HGNsbPLVetfgCzyyGxhZyGGDC712fDokZqwSCY4E37	1
5849	2vaKVLw4RB88yzb4qmdBYdsduELVuoynZYFnn6pka2xx2sqkgDr1	1
5851	2vafwzWLvkXGjPkP7beLW5fJc4KbtAGC796c1zJyoxXyJzsxr699	1
5854	2vawzfnHd1rBTrPYPfXUtLgjgFWnZ3FD4ka6Mpy5zEPakZpCJBam	1
5858	2va9ab2zDXFid6Zs9D8Gzfs8xfB89cR65bvnaRiedZGM25nxsCBR	1
5863	2vaSXz3VjHEyWAqiYNWiSeppH1xRRNZ3ij9E1aKS7wTWc19VNdv1	1
5868	2vax2TtZsgpCsi1cgE9ZnKxJEDvQTYrprZFqYnZJ1aYTvZ7xeEHc	1
5870	2vbe3udVGqwwoNUyy4wKPSvdQerueGMcUsmvce52E8LWg4Ebq5JV	1
5875	2vbZNXQEHnVsuZ81B8zcNGvpvjmDXcZLC9c9ToFzBGek7PM7xHN7	1
5883	2vbN4BnVaXPrT6rzza5pnSqJ5M9wgL1xM7iFzA6P12DkE8Ud4QHX	1
5886	2vaNzzzyoNfiCqefZRLJkK1NSDgrsFyPvaaesWtb7FrENjA8KCDh	1
5890	2vb8svGqJGjRuNGiE2P7irAfSaob3rd2Sxod5fJKWHAdx79NFUX8	1
5892	2vbQUdAsaWmr6GwUqvtcvFVABpU9EfiskBN1Jje8nzT73VEDEQ8a	1
5897	2vas9Jj66vJnhJWZuDJFgYrkFBnGsRpDThxUMQW3eRhR6wMcLppt	1
5899	2vaGZAgY1gBMnXpeMniFhSMF3wVTECRmwAz7gkhLHzuyqmnvje7g	1
5907	2vbSG2kL2ox9mhtgozFvLcrm9BrrrDe2hX1WVcmKJwxQtP8aWUVz	1
5909	2vb3vE8aUGiJK2V27s371XohfR2kLG6S1ZBhJd4dxnpsMtENUCrq	1
5912	2vahQw8kVMybEkF35kvFHUF3t8m8apVbft8vm7iLTyn1di3L3Cze	1
5930	2vapRQUHnNWBRP7bQRma4dSBzy8HfrxCiwQjaxJEqtAVuyqmT21M	1
5934	2vbPo1JWmdR1qKAzcAWETz2vDT5KzNQUuDLvYxVnGL7tBjju8Ltc	1
5937	2vaidXWeeCX1T23wE4uVH2RVenCNgXtiYPjY2k69y1NLaSPJmn1h	1
5940	2vatLVhGpNPfMmYAodxB15x7F6RKipQSn8FDkp47SG64eycGLw8d	1
5942	2vbMfpAcYcUdjBRLZjFHtS1U4q4tqamrCQEmVKTXakTKnLWuuaez	1
5948	2vbzFioCufTbyZVmuwWkskuJmySDfFUN51cN19fV2PhcVyptqYCq	1
5952	2vaWLS1dUhbCFh9nA1w1qvhCMtQW4496H6rL1YnFnnKVg765NNp1	1
5954	2vbGjcDt7CQ6hutxW3vfH4RPeAAunQt2isyGR5sHgRe3DUmcHfvi	1
5956	2var8Q6dkeF4CF5utfage1XQyjtnf86vh9PMbvPTAPMq7WLW8VTY	1
5958	2vaUBUNRekkt98qrfyJZi9FzS5ZYCGrZcq5eTVSE4KXtP8Nw8V5H	1
5963	2vai3VsnMRwsYLnuxdWFJ3pmoAE1utwNVWtHZvznAY2LEHySDCGu	1
5965	2vbHhffknWCyWfJzogapC7RfGaznRCGXmso9RrTGAs5hRd5PpKRr	1
5972	2vaNiPKF15gh2zmmjBH1kW6Vhv1phBSbZg67djHrrpyhUc8gqRkD	1
5976	2vbKqwRQWRxrbRFM2js3V9s4AXkNgAWPSpW3shAhYJb1rbnkF4NN	1
5982	2vbdS25dx9C2yureUVeYRZMU3vNZiqk6Dz1LFcbieUHEVQveVRwu	1
5986	2vanL3NFRb4ob8dEmz6deCNhG35zMKajDDYG6B3mAgMHsyLBopSj	1
5991	2vaiYqGvzXpSxTJSyrgrK1FzFhQjMQ4iUgtejuh9NN8qyHV1ZaGT	1
5994	2vaibLCWv6JZV1Y4QkGsXG5GJtei1rrLPFPCjmCBx9ZTT7hR6BKg	1
5630	2vazit1ZE55nSbPS9gbs5uEe36vPJCmM4Rk72wgbXYY47iyKVSfG	1
5638	2vbUH4rYeHosqfyJPwAj5xfLd6hKBdnK3Usztib2GvjzynkTqNDq	1
5643	2vapXntZRswC9JniaPsqCStUWPrQXnAjuSJ4htnkyG3HbVWN9xGm	1
5647	2vbPei7uP3BkEghEEQm11pjLP6Xo5A1wLYt6Ge1HzucdCaCk9AJx	1
5650	2vbu5ookcfh714TCY2LpjafEYpBAyCHCnZToKeEJkrpW6XkfnLdB	1
5653	2vbXzxvNBb4zFMbbNposbeF2GMrgwKjJhwkskrxbaVfbFdcvaeph	1
5655	2vboaP76fcYKnBJh1gxZecdBJMfXVY1Rsz47b8s8w76tS6ejZUyP	1
5658	2vb3SDaS3StiMu1cHmHhbpmwPQQzUmLwTkpkc5C2xkDaDt1RYJTf	1
5665	2vae43hYhUKW2uPGwU46UQMTaenp6XZokyum8hLSN1TeyP25Cm1E	1
5670	2vbsZbxMHPgYxhaF5VUBwhtKgT4QvxtSJBCcW8JncTGx7UU4XsK5	1
5672	2vbGirQT2XEE6N3TQwELkcBbQRG3cXy5pAxZV5Lsi3GeGPGU2Ffh	1
5675	2vbxEU1NRiwPQMtuV2XRydybxQYGJ28dh65G4knYgKoLsREJkvit	1
5679	2vbRRc2gtyYb4GibD3e76VH5oHQfDi8cNCK8ZEexpCGuPPhHv35J	1
5682	2vc3KYhkCLWMWo37235uw9poDFuLXasimpatXEt1D1S4pXe8mgEF	1
5692	2vacv5NYkA3kZeA6ygJ3fhFt3tBv2RAy4miS1DfQSeB36QkGuzmL	1
5694	2vaxRTWd5Lprkg1hosZapr5fvXinkZ3Yga22iSeeJ7RuJw8ZQt2S	1
5702	2vc1XTA8cvzjzUcgm5uPnqqQhuwWQwgm6fnzpuB8DV4N4i7Ud4aw	1
5704	2vc3KV68iooc7c1Sdc6fFNZFzV5rSQtjKMoSbav1YYoPrMUtBeNf	1
5710	2vbbKYrbDKfirg7B3hq47kRVyEpRv2zSWr9C6TqCJL1icgNVB9e8	1
5713	2vc54AKmCDK36wBbffLBdx2jAyaCD7Mdp9SipuCDYinFrqc2R3Ru	1
5718	2vc2xuv3PbFDSPV3eP5B2YhfnYB15ekUwGPHAjC1TThwZMh3xymS	1
5719	2vaycWEJo4yQYKbe32jJK8Fp3b5aamU67NTuqgvpWhEv25WXWJX5	1
5726	2vbXehZFMXmE4eVxwXP1imo3zEZYDht4T9J6RTp5VbrAPtkaaLnJ	1
5729	2vb2n7oB6UjTfxxNAHipek1e4HmgXifKCyWSmJnHDAZCw5j66NPR	1
5733	2vbN4a747eihCHLmbpunAN2cEk1kubvXqHCAunxTwhDQxfbYanR8	1
5737	2vaJJk6dEaNyLgSDZGN4d4Urhrc7f9dLiiXKsxwXu49saTwBichx	1
5741	2vbSNnYj5CtD4RUYRjVWX1NWPj5oq53M7JYfM1aJDTjaaHgUj97e	1
5753	2vbueJXFwzJxZg3GsZ7UPowvRGYwwXUj9TUUk4XyrhHDUHxQJVeH	1
5756	2vaxtBn287JUDhdL1yELR6zcPZNwuHZwgxw69hmZUbmsBG9Rk4WH	1
5758	2vbnL5F8fBj51WXXNYwDxvQtWMSzLpgoGcJNBfLgj7mk4NJPSBnN	1
5761	2vbyjLzxFvoZsUmyW3N6bXxbXMcGa6HMYFe18vahpJW6SN6uYfdD	1
5764	2vaceFkhFnpB3S5C1TDYqQAbjVafRXtHMcaJPhfRh6pfRAkDR7mY	1
5769	2vbZpy8oVZWhmgyhdeXR7aSXzrv6SxmonUdJ1f8WVVpg94XJ9nyd	1
5771	2vaZDQcEbZ1V2byix16UuA7MArhZ3jHDc5KUsbCqbRRRgDVEtnVV	1
5774	2vc3ZJpZTNxETpjwFSZJfj38GpwJggMmm8LzvgspgNvVq7XtYG8C	1
5777	2vatRdXnqX4imavTt5yY8DDJbaUnpbYhUycx1NMSdsYmbh63Z9aC	1
5784	2vb7EfWkgaagP9YnGhBJfdnDX9HpzBY54vgJujYAe9Vu24yTK9S7	1
5787	2vawNS46S4XjHS5zoUrjHahB3LxHRdhFkuDavQ4Sv9bdU3DzVmhk	1
5792	2vaUMdZGokmErr1KGXT2Xf3GRGNAGqUMEc2TWvMnte3FRw8Jt5LW	1
5798	2vaB5CoVpvdNkGdyjKXUPDnoEf7siJA1yFMCbp7Chb1NdTBS7dMB	1
5800	2vbMZ8kKEREWc19SiRdbqBdEGNwnk8dpGTgsPb2KHQL19TscmTWV	1
5802	2vc5NQa3EfSqgshxvMLnj2pBXCWg21HNsMJoa3Qr5iBDw6Z6avsS	1
5810	2vc2YwzcqbxxxpT1R1jVyjGab9uVQtKqA29yU5G4bZGJxJvY3Hyt	1
5820	2vb3HfEgAWUAcEHxokht3jAnAUin18gf5Rwr4u3SbENuN41bWZ9q	1
5822	2vaom4fANZ437CYyk1ALPF5bGWmhZQaG2RPBdN3NNgqxVnk7sxDe	1
5825	2vb59BgXXHDDtKKGseznYGv32SbQmoTmFrcZ2r3Mva8kQqUejapP	1
5827	2vb6UUvgw8Wbh6entoxhBhfRjV49iEFruFGGU5JwHhfwQcqCHPyS	1
5830	2vaRdgdTrmUqHS5yoFnxzCwVL5NrjZicRPrAfS1EvxFUSPn8Jref	1
5834	2vbPMM6MZPStu5P6SXyYYyXAiJ9ekAtmqrGBXriyGugLcSpCT1xh	1
5836	2vbe5DVNSNxph7r8PxBDNLLxgNhkTupzNgbTyKWYQKDcndRRfQGf	1
5845	2vaSTNr8HsUho4Ncdp8gx82ng7RhWcfq7FRsGcX6hVqgPSc4VnY5	1
5855	2vadh9DZWWcWJAEqhXzC9pvUnSezP7YNCmfTyt6jU6d9qUL5hv3L	1
5857	2vbqTu67bprScRXtjYjtTdrUxv4NGyYNGj4Z8u6nnRcuZwGGLZsU	1
5862	2vbDr4BWHubgpaLYYDPMLxyfMKuFgZU762eLogDWC2m2cWX9vcJw	1
5869	2vbqvywB59VHGCDD28ThEXqQVRF72QcnPXeqsa7YsYvgVdfR9q1p	1
5873	2vayQwosMo5CuEwn92c96hhN7YesZBHr3XdNx9Cck2BghAqGPw9t	1
5882	2vauyS9N3kZAYzXWUPCyDdtK9oqqX2PbQEKXseeQDR6LActR2Snk	1
5884	2vbu3MgaMSKP8m1GLWjYXmgh4U7L7dn7N5nxng4is48x7vbD3G5t	1
5896	2vafbwtuEc6B2gUzfQw2jdDciWvCZt5cioUYnNTCiY2aZyT4pFN7	1
5898	2vc2GTt2adWoMMEKF23dSdxZdpBoqYRt5wDkJxMqwCYX9pXUE6zX	1
5900	2vbLWLpaG8StQ1Wa72T35Xu5S4xA7D3kpGZ1GMjaigM7zSYmM5Bm	1
5903	2vb9vr7Mny5vSyqCCV2PMb8RU2w4XkshGuxr6cyS7fdq7Wt5pNnU	1
5914	2vagaSbMAe2n1AFDAgfmSNQGAMfMgd1FdYS17JJjPQ4Hfwi86mDe	1
5918	2vbnZFzq5kqsyWqpfNhvfvCFxhnuCYmghRc6PmhNR13D1ALr8dSA	1
5920	2vbRe9BbzY9TsXxDaZxBE3s9mkdQh5irwnyz8ELF4MZhxoU2dpmv	1
5922	2vbZD3mV1DpXJeDJjgpRJs6NhVktm5TTg1oWThsg3aRX8q2BF5ui	1
5927	2vbX8afTAC2rKxVjV7f38NfN17U5AXCFtvSzPoXUjbSDFmost5xq	1
5929	2vajGzjW7PDaLGP7NPLFGwmtRbUS3usE58SeySew3xfW4zsNBkw7	1
5933	2vbn8zqcDuPN9f5xPuVMuTVcVSN3MuPMWY4qsqPGkhKeCpHSJ4T6	1
5936	2vb46ECPPy5qAx7Apke8t2JLmRWSaWEx7Zd6h9tMsHyGH3wVb5JE	1
5944	2vajSAywzbQ3oRRVtrmcEyVEH3C8FQhdKQdkUody8iyevCNvK8hr	1
5946	2vb85iNtFrWMuj6f2UwgVvWwdSDht1uUxBQMcY7Qb4ju4VMzzMai	1
5951	2vbaMdcz1vV9jUudBnkUi77ZeRLDKAst87hfvE698So85JUT4N6i	1
5955	2vaa8BBGv5AB4ZB1s68a2KakANJBJcGZg6GLBXaaubRhu3xD4gF9	1
5957	2vbEaknwJ6vaPmefmLm7P2sse2R7iwAe15WKerfGwZBRQkKwkbVU	1
5962	2vaCye3C9qk9krbfD4UfwGNWq4FPobsvASAvvb7kcUhz65ckHcBn	1
5964	2vb1dMpNBMJANjCisCbrTGp34wcct6KeJ6qCcrBAryTVwhmQGYE2	1
5971	2vbSAGrDNpJDDaTkgD9qgDsKVfFk23cMrXhJ41jynuQbUKwVZFqS	1
5978	2vb6AbzJn6nZGLgqLdLsF96CVwwnvYKfN7Rniks7FjgJ8DpVdEeJ	1
5989	2vaJ3KhYwFja4uvHBfxGeChhfJae4uzcNF7Y3ehohYiFotAXbpWG	1
6001	2vatNhfvNhgxhZcVa8KhcNTZGYAn2yEzPszX56GwPjxR6vFDYVdu	1
6002	2vbrw3QKPe2v5XVc9nwcA4kwhSRi5cG9GuWouhshuBQYj7DmCgrR	1
6005	2vaFZkyY1gkbYhQvNdkR2CJA71e8dkS6NVbWkNZxjiLzBbSXrMPE	1
6012	2vaE65v3L4db2grQx1eeYiPxnNvY25VHmZRA2e9TqDaNtL2pJcV4	1
6017	2vb8YZbCRZBV7zPAS6ADquicnuyTR5K1HJdrdd2AwMdhBsg2sB4C	1
6019	2vbg6nwe7Fg3hDEDPHup7gGQBu5SfM4HYyn8EaHBH6wGtobVe4k9	1
6022	2vb4BZUNFRVHWRPgx4AuTKxdtHd8aPUoTYCz7DT3ewL9PCZ5j6CC	1
6024	2vbpnrS8gqo9zsHw6xjQMRNpjr72sViffvsxNbvFKMRrYFYdKS1L	1
5632	2vakBjxrX2Q5C22DnT19hcnoJHBRRtJnYf9CdCeW9zZgo6xDQmX4	1
5634	2vbdEmg5S4d5K5Va7GpVnFc4o564ywg66C5xw3DqVTY5BCwhQWeV	1
5636	2vaHrjDjpRu34MGssaqczchgjz3RQY2BJwWed1YzxfFasmw8Hpda	1
5640	2vaBZbbrjYCAhsM2jzr1GWtK7uy29ZKLtW3ZFDuVgPZK9TMa5qy3	1
5645	2vba1qwgVJeWdepeqieVMdzmniA6KKw9BQy9pw3EKfqCzQ1BX9rE	1
5646	2vbGLZ3kpR1u5fkAnDb5t8PYxVGWKmM9bYcQesQ5jCu9idVxo1Gb	1
5649	2vbZsccbiWSissEcrcvPU7daex9erZnUkq9tNx2MWqBUQdNYPeQr	1
5651	2vaHgpDhczwNCVDo8nCoWubVgXvLcWqWxitjXXyjr9nkuD1cWARe	1
5662	2vbFekAe6hQ7ci94hv4bXFmnwpP9K8tC2urhKcvVjfBimb8uqeob	1
5664	2vbTjBJREvX53vsDLB6eosb6qoFXvUbSt953kjMw7mhxUTyyBbJR	1
5667	2vbiHoztNgoEfMPRmo7qdg64GmumAvygW5YSUaxmNZ6pe5gDHaxH	1
5668	2vbaS58NDLKL15xgj7aYR4UES88qJ2BFQ1mPeQkHnobUxkJm1PY7	1
5674	2vbrCNeqoL7PxWsaJxque2SrtQutk7rvq1T9fcbtn5gFvc6MYKdz	1
5676	2vakamBbm4xzGgKaoWduUY6ZypBbVkccgC6XwevW5imEcHwtfzmj	1
5678	2vbaNQuzzJvAAAVcXY7r2hjhpQbAgVzgDh1EiVvey9exc9qqFk5N	1
5680	2vbn1iXLRgomFcy89Eji98hu7zN5gDhuW5b3TPRrhXGLycpQHxxG	1
5683	2vc47CExFEpXP9cZHqE1jwtoS3bG4Hc94Mmxh8pRyD3fbq2p6Rje	1
5686	2vaE5uAsZT84EQdHLoZDQxxAZ8QypC5eh2HR4ZZvizNQKrGTBmZa	1
5687	2vaqMxpkoDrSYP4tp5tQbhDd8GdJD1Kx2GeMSSpLyLDrPkBd5vwK	1
5690	2vacpba2Z4ZHsXYFwzcy2xv1R6eb9anfxm62MGYBosjfeP6m6zBk	1
5696	2vafSHnXNFkUX5e16o9YQHHyD8dkkPBPEkTRgJAw8H88oy156GRf	1
5698	2vc1LoVjPfJf8KRGNPdQWJoCdf1StvvsPq2cRu5PjDRcU6iFEcZj	1
5700	2vbr77aPBhkcr3pWakbSwgDBaLQHmHHdSC2zNw92gYz9f9cQvLgG	1
5703	2vbvTpGkA9WCgUS4mpyN1qY45Ro4i2JRQLfbZjkbAqWtSUebiZLh	1
5706	2vasKEfd2kFE3MRoUESWSYao2T3SQDE8ZoMYAbVcKpb3UxrchacT	1
5708	2vbygAMAheyRHGDe3EJofzHX3r4scAR4fmacucofQ6RpQPFNT7vn	1
5709	2vbzD4HyTR2qWPPoSf1WjF9QLnJn6e8g7d47B5P3cWpEAbmAcExK	1
5711	2vadgLPJ8k2ExcfuXN4LRkqnEu7JkHd8wsiq35Udp3dJ8XFikK2Z	1
5712	2vaL9PQqwQP5e39BA3srQcD5yj5J2VPSDM4CHsaPGhgQY3Cu6Piv	1
5716	2vbf3rfS4K7B9G2hQRR6vWVGvVZrtqPuqX9BWgJKg8agk7Gc3AhJ	1
5721	2vbs9qdjvMRS7saRk1SfLN1GKupMzSUD2cYJuQzvWq5By6dhrW5S	1
5723	2vbBSBcDz1K8KgJEP3KhrgwL3eqPpmCqrXeoSAgMCepujepnYLBS	1
5735	2vae6LvzA19TMcWDGH7LEW286rR7y8yvtBjDLLfjBML7fyfr4eNs	1
5739	2vaedmMtUawSkXsSdEPDdhEGMkGHLyu1ai5Qg35Fe1NTAjcpE72r	1
5743	2vasKKxhs33fozguvLz1m59hV5wJGxt4JbVLz519deUmkbrppoTT	1
5744	2vatyQDyPHM7buUozscVDMJxrMBCbwqWssncoG8vrdKCH1nkSEt9	1
5747	2vavWXA2S9BGgRacpV3nowhYkhU5mv3opKHLj3QNjyv6kgBVVgAv	1
5750	2vb9WA6e8R2Gp234o633Cehy4st7kAMEt1fndyZh96WqNoe8VExN	1
5752	2vb4nMo6vgkW4YaipFupQG9n2gZgQSQTjSabYq3M4MqHxCoxLQfT	1
5754	2vbCngjNeRMfdd6XsMjNAC1AzojYkYQGhdaPhAxWsUX7Sag4tStM	1
5757	2vbBbpZJc3zPxvaM8PARiQiqPkZRWenitqSf23S9dB8ywR6cfZBL	1
5760	2vbqu5Zn2Z73kBzv3W8qYj7QV2ptSqdSTwqr4r98dZhPHBF89H4b	1
5762	2vaDzp8HT8zUCqMwiT6KLUBEAiiCZqUMhbS6ZaqTvBe29H9fswDJ	1
5765	2vbc3gUvD8rZEYhzB5XJJvx3mZ15R1y67rYjJETUVs11yf6ioZrQ	1
5775	2vaifCXdra5YJzisi6TC6j1rmSqfFJxpDtSNMXCCi3K25LVFvecf	1
5778	2vazWjy2NdKyVbctHZwdMhv2G2cDyWvZpgsXV7ctcCS4CDDFBrkY	1
5781	2vc2fkuyTp7fb16pHTsMDRsmnqrXvh8hYF5FHs278wCBd3qKn782	1
5783	2vaj3uCg5y2Vu85wmNg9KrBnRg5Erq5mCtQEQhrvBm9nerLtAmes	1
5786	2vbQCoLTiCG5fFAza3NanCM9uBkvJEG9oPYmiNzDaHfpGLJwFfVs	1
5791	2vbkpReEEPQhvRTqTH57w24zDHW5tovT17V8FomfoYLin9jAbvBh	1
5793	2vc1m1oQJui3Eyh3C9rGXQA4sFZMapTAhcUC3g1tdmxZKBtRuM7m	1
5797	2vc2FjC6ygzpJYsVfK9ZB39rRFnWboj11DW3gQ1cEoksTZZVdD7B	1
5805	2vaVFVqU1N1LWRVynPDpxNUWabheiNN86HR8k1wjtX2ea8jaBDor	1
5807	2vb8hJymCFyME1YqUMBvgGAyNe5XMRLBFWo4Taac9Sc4uzJhyyhp	1
5811	2vbYRbjDfP2FZUmAoZguyJpgWqdkft2615TL5mPGQu8TqsfxvBnK	1
5813	2vap9mgbBx597rsAKHDe6azGCYYZKjRgoXzYbVs3e7BB3cfAhJMU	1
5816	2vbxzWXWydtqJLAGao9Ptzboia9uWFmKe7qe3n5GYuDhGBxnpT51	1
5818	2vag2i8V7XdHxJA1bmbnfS9qvWooWQkNfAnpp8YpLWJDwTHV2STh	1
5823	2vbWabaga77CH4r2fUugoBbL6a5rzfBpVaSoFhfvtC9L7LuvDf5t	1
5832	2vbGWJnntuNqTfScvpkFmViKi8kjTDLibjcy9WFKgLYAEPTAi785	1
5835	2vauvh3k2bEPi154JcdR28LvEnAyv5hDHqpWqMbZHCwd5tsUiW6Y	1
5837	2vb7BzEqVwZVCVWH7Bke4EgRAhcQiwLiV52cAgPgtncbMAFhy2Zs	1
5840	2vastLpDtJj8PpTZY2EjPC4hVXy4LXF7DYr4EfDUBzu4CH3PMtkB	1
5843	2vbHsY1rH2CdjHPMCyTtdaaPy23bADEPHbvmRNkmBTarNiwzy8Yh	1
5848	2vb7kA1NEzCf6LvknD6hK9oGcFqVk1NvWaeKPQWaFdFJ9jc4v5yu	1
5853	2vamNPkVnABXnpbfu4FrwqhFQp3tgFFW3R2wG37VLKQmjmvcARWE	1
5860	2vbRAA1YDyjV7X6nPQdjfnZZdne6FXJV82wvPKep5gHbQ2E3rGPk	1
5865	2vaeWMVUyZrNDziLPJBC2aHRb3B5aWvbHB57TYeMFUbJE4wogoT9	1
5867	2vaHwGnN5R3kMYPKbL1ekLsu6ZfEzWUR145SsHdfi1m4qeL9Lbf3	1
5872	2vbNuNa5e4h9P3Qn2hWT4WhHRQKGRdkoJANESyCCYwqJ2v14Hz9K	1
5874	2vbLiKTZY2xGPrhhLfjMDqWBo1gNmgTcPbo6XMsJ2yY2aThMq8DJ	1
5877	2vbsxW4bpMGP5viWKq3S7j7sVeGiDxyRAPnCKF2Fx1NdYNDzofQ7	1
5879	2vaSWdkaFpBAYmo5oUJZU3E1B5ppVNC3DKV3n3ez8Kr5mDe3nZFG	1
5885	2vb9bpnSczX739n7Wz7gySZQmVbjGcTWX5KFH5cYnSzutizGFDpg	1
5887	2vaMatPmT5UniqUbn2hyt1QST6Cy5X3KH5FryXBcVahNk49Lf7Jd	1
5889	2vasCuZwSgSrAh6RgfN9pEUcLHQpzKnXSfQKjEnYGBPGEgJQuhmn	1
5894	2vaVGBeHVjnokGMnBUTdBAgng6antg3RG3hgEchw2c9X74i9kgAa	1
5901	2vafQGrAWLMsjEk1x6FdpDiyUfffzMRjSzKrK3v6oGxz7BxnrxUh	1
5905	2vc52kKs2z6oiWLNbtPUvgMn2yumLEYrJ9CMCzpoAnjF8pM3Gth8	1
5906	2vb5Wyvio9eA1NQFJwEXwL6KHBTSm2zHHVgV112HNfbeqHoPSWWF	1
5908	2vaKdbtVtXCY2n6ZSfm6SNCM17ef66ZaYw7Daq346cLhTYMYwqvj	1
5911	2vbi2xkHCL7QPMN999jnTaLdLkcTdCEt2h64MK4GrhsVPXdEirHf	1
5916	2vbPqtDtvKWGy321saCxV9CyhV4khacY5Pft2HWGXsCpcbP45SSD	1
5923	2vbL8FrGUc5TvJVWbFfEMcjXBd9vv7BJyankcHVW8CATh91DoZJT	1
5925	2vattDxU63xYreFoimsjQHZs842zStYr9kh1UikgB4JrKPsU5XCZ	1
5932	2vbhb7DbG4dE5rqb5KqSh4b7c8KXnrsDvYUNeq1Yw4nRuyGrFriG	1
5939	2vakPVusPLFmRbgJMEdhu2qhVjN4VkwPw2V5m2yYrgwSKHWAHYa4	1
5941	2vasHyhShjsV5WwNr3Y3GzwAjsSjhu8tfCw15X61WFFEEejYN8oq	1
5633	2vc5b2TgzcVW5czQy1ND4E8obtSaSppT1vWTV7KppXTKrgHT29n8	1
5635	2vbkjrwSNt2WUuaVzpMQV6mNaNn2KoYS9dPpht5AJJYeGwkUtZs4	1
5637	2vb6uBwzHpjbESfTKj5YbgSVLcfed4mgaBD5CAGUksqnNQnAYsvB	1
5642	2vai4y62Sxktw4JvZ6yrZd3nToFm4sMQqU8ze17MSnfUyQNwA5WT	1
5652	2vb2n2MJ2gukpv6Sed9nWzRTEEFxcEi7RyzVk2SnNkDgtxVwNnWw	1
5654	2vbDo4zZFCLC1xu9nSPZtepvEhyw29PbY14FTxpumZfaeYwkSbd8	1
5657	2vb4pxfFfCz4ffo2JbwJCiRjfgZZSoVFrPBLZooGnYAJ9f4KYZVY	1
5669	2vb9zoBmpMADZayx6NfUFD5AZBBKNzauqk3ouGoxzGvTK8ibYf8X	1
5671	2vatZDjKKhgZL3PaideAPYUAnaEsGX6vBJFhgyom68JWT2ugcuzG	1
5677	2vaNeyrzvtT9uUoxfrDXKPG5F9ukUmoaFwFZxd2BhzEMHmTiG5SV	1
5681	2vb1miYLjVVqYACRkTqyhBK3tL6d6JAw8Bq3vuoNaQSAV4bjhng7	1
5684	2vaV8dm1U1TkKmVfyYvxsiEUCgkkMLQScTpCTvrDtWg2Y8A52j6k	1
5688	2vboC6qJsMsHvXkxXYTbVj72sG79EkSapdfFv6ottkYpQBqxSKHK	1
5691	2vbmGhQXP1HHCJu7tKPq2WXNgHmcHobDgofegaBaSjwyYr74nVaW	1
5699	2vb1hZqjPBZLZ4GCANGuNvsJyJTbo63qQrMDd3o6eR7Srct5t9k5	1
5701	2vbG3DgARdC3UtJFaup37yNy5YhioaBVY5ueq38dYS7tCg9r2gq8	1
5714	2vbh6dBas4eEFn2Q9pfGmEC9XpVE29Jk2qwbvdDVh3utBVCfPXTn	1
5717	2vatuoFjJayX4onKp3XbbckL67VpuLBfPjBnLqMaEuzB7b8cNJir	1
5724	2vaoFvHfrif1LtrXa7qGNCSQadpM7VS6w4Nsje5Gy2mYN11fKRVk	1
5728	2vaiU6oxKyrjW8T1mCF7fK89pnXRDFHZ27f68G6L8ajdmeQ7EyJg	1
5736	2vaeeoJUQjEPfy7sRS3ENQ5swmZ793WmPdBesR4iuiPEEzaYzgFx	1
5740	2vbmywopLd6tNT7hQQ4k2Qas1XqHrCPM2LMB9hatN3ZC6CGJfvZv	1
5742	2vazxhqTTnmmQVv56Q876azMZpq6DsaAfmUzKEvEbHPXLyzgMQus	1
5748	2vbJRQmBxoe5jLsNPc9z7oNHQYPuvf5BvURZvvtDzBQiJafcnw9H	1
5751	2vaWe8pep6mHeXnBBebG2cac9NNVCjJbTZ2ccAR9ScrhkGcDSAVq	1
5755	2vbHKUFzCkfYjX6K99BmxRECDpYLKHRvPVDfNamo7uhnwhWSrLek	1
5759	2vaJN7kL6f22VxEdRDXiBQMhZ4YkvwCSdZnU5MWLY8gZ8Di9f8Mw	1
5763	2vc3ihsoeKVFxdqBNpnU7um8KUPf6mG9CqoGnLJgDYBufCwvHMLS	1
5766	2vaWZkQbqZf4NioWJkLoTnXWHhMXZxjrNEqhtPVAt9ZJd2YBifVb	1
5768	2vb2ND8icXzDXLjWqrA6T4rkos1AQQWd5YQ1t8CpFhZaKpEMGdWg	1
5770	2vaThuHQauDzdDA1qeYZHLHuYMsEgM2VgzJdqA9wHMfWFSDQZ28P	1
5773	2vbuvWiYPnzaoVbe39xqzBjTr1UEydSnXGUkejinyyjB2u8SJen1	1
5776	2vaKTvXtWRQ8D65TmUeCPUBMnE6ZqKegFi4Lxv9wWcPn9PKQ2NhC	1
5779	2vbTkNHz2cdZkhLNDZGC57aBtmYoCM2sfHv8EgjE9aaze1Y3ADkX	1
5782	2vaozhHrZWhnQZecWXmzRZzpZT7LgdnYPpGsXaBchqrGJysXCoqt	1
5789	2vaaegJfyeF9WsUhoy6GeRKZZn8RoQsxdV9xp2wvgS3CJfnmZpfp	1
5794	2vawUzAaj6re2puV3mYmuCfLCv64T4KMzVYUFsKw9kuWkjKmCTxU	1
5796	2vaxyciSGXSQju3ij5FWPKFiJQFroyTSoLqUfbZ3nT5iNqoKrj9u	1
5799	2vb4Yk3BV3a96cXV3SkYNvws41iqSt4uHSFcDSXxPgSBFnBtrAMZ	1
5804	2vaD3und5e91HCdnzgL5Cba9VGk6zJiu3GLkAZ1ZYGbAbpZFUPyP	1
5806	2vaFj9mPiSsnQeYmwumZPa3MoC16UmFtcT27ZjR1dDa411MMAo1y	1
5809	2vabhqXx36qu7LMFodDASdx7fWfzQzZxbpHWGjiy4csbmUpv94Mb	1
5812	2vbWGmRzFxatAP3TSd1epLZ3fvWi8SWJY8QbHkpUx1JSNTLRsmmF	1
5815	2vbgowQrKyUnGfe7qVX4R2ghx3s7nD9679Pp9LKEWFnK5WEvpsbX	1
5817	2vaY5YJmG6aXWyNy4PKCq45TuNYbosDJ9ZW9rXQRsuDiCiSwbCy3	1
5819	2vbynU3Cs2b3h1ps65Lmz3ALZGai1hXzJmcFHPyJQgF1xwetn94F	1
5829	2vavRFaie7RaVf9JzH4uam85htWV8iJTZDVoqhztwJ4pLSdNCHSR	1
5833	2vazJCebyRBvDrYboK9EuDNBEV2SHxVYnemvSotjjRN5QdZkBapF	1
5839	2vaj1arDYcAatD4VitAfxXAZifv8hHprieNimPWfZtoa5EbkAtZs	1
5842	2vby2QNrJHX6pvcAtVz44NjVR3bk3fY2gG31HF5btTNDr61CbWTs	1
5847	2vb42wXGdeZ4M8FT53DbvmjjdQYx7NGbyXcpg7eLY7ABKhaKfbd3	1
5850	2vaN51CeANQmJTWVcJ4mrzKmwMchvoFZS3eEDd5YCNhfq6C6DxGf	1
5852	2vayC3PbYCTrMaJxt4hSoaD7ADB92PY1o1T4Qgc73zPMEN73YmNU	1
5856	2vbkX3yzJioYEtC2NLXEKxAaHo1F7RbvhDz9eJBwXAumg5Qc3474	1
5859	2vbzEtCmnRkB61iocBSeRhJq2CcKrJaNPNEqDivazRY6H1fW2SeK	1
5861	2vbgBiTSbaqvhUSiRcLeYjHZKCfqTPMpaqgYLsfzY8NLm3JNya89	1
5864	2vc1SbKZJ5yQ8wDRakmqdooYA9dpQTtsAGBeQMrQsj6dHQrdwZpe	1
5866	2vaJQhDMTwNJrQByNG343xGS1U9iVQKTFFUp9ADGDbZYFEQmfrCy	1
5871	2vbFTnzVkuqhbdBcKb1YasjcL5edKPb5CbzU6V3rciAi66eTATom	1
5876	2vaaMRMzFqqnKkhUz9gTMHhYByuyWdCZXLcM2oD66n4Nxc1n1CXQ	1
5878	2vaWqnc9o7UhvvNhkh8UaiwYQtfvGoNZh5b98Z5bm5kSQB7LahXE	1
5880	2vavQiPXfv9heqmUcN73JAoNh68LszZ6oQCEmt4y3zgAb8xmps3u	1
5881	2vatkKjncyKJ5xJshkcV8GYYydNseo2fjJZFVs6bLpNZh7wS3ZaD	1
5888	2vc5TXmbuDjjqrYRfkFWFzpG3D2LZffYsC1j6rb4Jg4XW8Kyk59g	1
5891	2vafnmY422qcVwtnoDSxWciyVQMjFjZQdgdScPjSamMB8r1bASiv	1
5893	2vaZjThgYKECMcVYZj87n3WiwduTc7oZg152N7PLXDXTxbY54sWs	1
5895	2vbAwyUYWkmMhPiY7bgfGmUTV3Zab84KmTrLBYhbko7PiwUDNn3L	1
5902	2vbcJRvFy13fAeMRLZWLdU92s5fnr8GqNqmmiCJTwQJkLWgvHwCz	1
5904	2vavkHyG7sb6dxhpDrTFWqPV3i2DBVi1VNiVzYGfZFnes9uk3h2b	1
5910	2vasqrtf8nfqNMvLotr9NHzrPkKMAH7G8YKPFHFEynrTsM6vkoHS	1
5913	2vaauzFCy7RYGBTPYPMR2FG34kHHbnUPyYhxeyfzAzuU3ELeiYUT	1
5915	2vaGUS7hyV6pC4zjvUKp5g52iivQcLi5Kpw2n34vFWQuvoDZv9Hn	1
5917	2vaLr47SP7NrEi5tiKWieZqUoE2zy6bxqPaqDCP8TBCj82biM6eG	1
5919	2vb8HyGGoRo1KdxPHzyTawo2uxomeofMnjdaW1aHPtmoAYijGjch	1
5921	2vacGaPUzf8MLLhMhrH6JFFkZUNDYZDopdDpnUcFyboBSCyABd4s	1
5924	2vasxjD2gDqTHtcebEf6Ro2wHb5E9EaiChUShMLUiu34MjeXtR72	1
5926	2vbBtwGxDNJmxKxJkoiztWopVhz8ehhpiYmsNighNK4BrBHZRexU	1
5928	2vaHBXftdPUn55DRtZDu2e4PY11ogA6hRzW5xh8xzhpwMCQbdLxw	1
5931	2vbKBxP63rX2VsbptGiGAD1PMHnn1a9xEDb6DskSiKyz7FK9FN1o	1
5935	2vb5muZTST2XcpaNBmv4utHFAeFGXZRppARL74KVRdRYN891w1w2	1
5938	2vaXThWzpneaBWMb6swuNRoYhou1RMQ9EBesFUE9TkXv5FHYCyS3	1
5949	2vaUipgnRjsNrWGRxEUibmL23NPkJ2eFKKmWgtyJjwFv7LcHJQgx	1
5950	2vaGLfFVuGv4HtcohbVMAUHecF4uEAY3H45HywHuq2XYYEH4vfjV	1
5953	2vagr7maJTxadPaXDgJnjWV4GQ2hcWB6Xx8yCZg8mdcGqyzuBY1P	1
5959	2vbGvpWt2BibjwTHasQQySJzA1cHc2PYTyuQBgH6WEcwrd9yWdSv	1
5961	2vbxyc9FnM5NJWX1WqZ4fCstnnAvforuumVysXo7FcGDxA7TS6rx	1
5966	2vaQ4P7cgAafuFhcgRQDFBKe2vNNerBxdaEV51YyJVUjGMHmCWNT	1
5968	2vbkPcH78ddEJ4YWaxsyupjer79uNtMp1xoYtBVMETzA8n4S1UCU	1
5943	2vbfbLQb54V92Qaj8CE8fXuF5S5XWjxH5qe9vZVDpsRQUECzxTkw	1
5945	2vaj2g7gRdW1cmuF54zyR1XN5BzyPmi9VD6C82ZvMygw4sxRGhgv	1
5947	2vawbRcTN3VoaCfwzqa13829X2xwQ7GJS8brMvhZUNwkRzbRJCAq	1
5960	2vazs9yMeRjyWXVRrYMF8AqP5rwubQo1jCoH9gvnh5zRwcDWhohw	1
5967	2vaJTi4RoUGGGrqftJsmpkVbrFbuZfEXRVXw3riecraDgCfvQGjw	1
5969	2vbwAbXchqDuLk8jFg3VNbvcVY5GgKFvX8pNjCi4zuwNVCD8pDqH	1
5974	2vaHEuMY5KAsNWX8U8G79DB4EHwYkLseeQzwSoM4McSVFmkgXhte	1
5979	2vapiwszc5PZxykrTrrkzAhBArdZ3dmAqmDQnbEwG2wHG1wWntqv	1
5981	2vakhQ2KfwZfAkvBBxtQzDBjBLLRbDt6KxfYQEio6VErGjqeYWxT	1
5983	2vbHDnYrSe1zenFW3KWMLvEpNXMJRM581jqtaEP7TacqFJ3rqFCi	1
5984	2vagPqc399sdvhbMc9w5myfA5QmJbxd4M4DiREF6yX8CnbQnYCm6	1
5990	2vaVcT2RafHvGmm5EjoXBkp5NDgqrxqLwd1LsMDC13tekzn6Yjxc	1
5992	2vavJDeVTfj8CSyK3p25PEgz5imW6sXttahJA5WwwojMYsKuRtsi	1
5997	2vbTf5GnTdxRFHg7RNirScFJpgFpi894YaK58Pra6z6jD7x2mpiP	1
6000	2vbr4qLebqkDhowVoQNjTYXWK2hyhNgghX6pSC3jDazKhnty3wqn	1
6009	2vbsEoi4V4R7MMZ6UjFKS7rbhhucKiuEG2RmydKymZPtkoCwvnFn	1
6011	2vaGA7xA1rnxYvWnpp8ikGEzwxXZHetgJ2TWFh7s8Te8PY4w2xK4	1
6015	2vbKvNjugvxkJTdz4Rp2j4BcSLkx2pQdj9aT3mwhnF4e49eFqq9o	1
6016	2vajM61b7BQmwbttdq7qwu29591aDrGfn1pj7kvAsUfKLaAVbuTg	1
6026	2vbsBwfhtVFtAM6BKo6fpSSWTaEnK5d4GPcdVZwznsqzyvcUPru1	1
6032	2vaXpSFJmcriecTkcZoRUCHqcTmbAr2wBzYvqMxksvsEG68wohxq	1
6036	2vayftS1bPygX9jZseTUyPD5qCxXiJJGqoeBjxK1R7mstNxcAWxW	1
6039	2vbLx1QT9eHwoo8zKHUbTJGmRAs51FRAyb5koU2WRX8kUkhZFatB	1
6041	2vbttBKRkM1yWNGwZmJJBxknwgggVLCo7kJ8fva5Hu5M5GfuRXrX	1
6056	2vc21iKBKr13zzbvUBCUYtQi1paDwWAiHsWhU7wM7AYFb5yXbCwp	1
6058	2vbAbA73F9MNv1vnsAZwYAupTP7REohL59yCWRsZ8MNp5FKjTacn	1
6067	2vbws2FZZ35RoL2dxsCJaykmMmj6NtwaWH717L52ZgTZg8Uc7tdn	1
6068	2vc3ZMJXkCGtTd2j3kRMBqSjwwwWrUDm3Cz1N6AH3cUUhVXZgiNj	1
6070	2vc1coRwz915cbYR6E2zMa4abjECvbAPa8P1NkRydDm8rphTwhR3	1
6072	2vbGYtrPuViXg6gQJ1uxva7iB91QhFpg3zfDN8LKRak2nYh5W22Y	1
6075	2vabGjYCdwhpuJZc1n5Pg7sAdHUGripkzhq32uVpVp1jto99MBuN	1
6080	2vau4y2R93vAQvmLqW1wMfA1bLRKDqNc8LLTPLYzEqm9CgnjCamz	1
6086	2vbBGv3o4sRrqQjvbZCmKtuYSHKJwG3hz19tN6NCk6dZGQ2XXSC6	1
6088	2vakTXDccZFWU9vRpqnatah68n7bGbAJpEJCKU1CKyY5Kowu1M5C	1
6093	2vbMMHMZBUR5Xc1ttZHtpm53XZnQG6Uh52hMR9MDgJdSjWoYxpwD	1
6096	2vaMbx5VCawGc1X5K7df6M8WeRVh6WCcY6oYBwCq2HNvEFSVKYor	1
6098	2vaDjEECkp2KKfUt5ScpckkHeWDj7NkcUAan2QbHHHWJoNMMAwVh	1
6111	2vayTBs78pni1Nij8AQoTz4bFGmCzYbqbtYsEWoVNtLvA9ABZcCP	1
6113	2vaPxjEWhNSFH8Rs7gnLu1E9hfv9ieEkAt1YBesEzJFBFVEmNmsW	1
6116	2vaqUyiiTibVy4QSxH5yxSKfxpCEsmwz5ZKg7y5LMQq9bExdJYM4	1
6118	2vbfcfRbCegb59KxfnuaQcSSRStr3ByEQnRhe1ijXx9AwCAhBxi8	1
6119	2vbnU11L7PqNtTeWYswYSwXF1cvf4RzMn5Y7pEDw74yUUZ7MCAVe	1
6121	2vbY3tmQGDpeg1U3yFnHBAPCSeSFUgJyF2TWwRDfGHBx2FURTkj1	1
6124	2vbtrFJheQw85UTr5fLUn2NWVuD9hJEMf2kbczBFCSPjtCi9vDx7	1
6128	2vaNXSf3C42f5zbvL8Ufjuxk5qVvDuTiDTMXSATwttEvidXKo1YT	1
6140	2vaujoB2VX2g35Cb4uLUY4nTcDVZFRD61odCAKk11tknCKSf5K6x	1
6147	2vbe1Vy6Ek15GmkWngbt7vEW1t1xG3fkXWhBBK1zEGecz1ShiQzN	1
6150	2va9D1fimzdqRSeCSVVh7LgytfpRcrcuwELoyCkkcHuXzK62qbti	1
6151	2vbVbn9WZMXi8665aYPePLrk84w7yonT7TfuTqEGNgXjHA63YH38	1
6154	2vc1fAC2HHR41z5kacRAJNd3yqTSVoPUhApdfkZEETfvMDmxsL9q	1
6156	2vahQvtmx83W4mstAE6Xu7KuUc7FnjzSbc4hesnGmxNzyGrrkECj	1
6159	2vbz2ZQ4kwvnyLDMb999jvBTiQdUKomTySDrDcVMJ9oZfQikfRsn	1
6162	2vbFCh5oU2wXuWfNG2hUsjviu9zANNVSo3wKrUkHoo9j5sXe1Nj5	1
6165	2vaJ6i9noxopR1KiufxZ6KDM64ZT4t1pqdMjBxXZiKVxNJMaWAYb	1
6172	2vaDRV8d93PECdn4ryTzubXkvPCT5UPp6NR985KPzADgSSRcD7w3	1
6179	2vb9FNiheNNFLQSzZyatHLnQMmtx9ZotkKi49C2V9mabvHJJ4Go5	1
6180	2vam3aezNZd2dnDXSjw2FN5kwuCxhKGghLCYe7G46aVxGURNMuTN	1
5970	2vbFzcT6hzxYZZQqB5bwBs1eQ8KsTmPLU8PvUfAPGYLFz9KFffxJ	1
5973	2vbEAUt8XmDxCGzp6ExXBgbq3utBMbiZFKVfkmnahGiAyzQgyT9o	1
5975	2vaRoQGNnfZAjNPUyAsSXQqWeTn9LnfqkGeBdnwoVjgep43vckNN	1
5977	2vbLyoUGd2KBCQikFrzZ1smrUMzjkvgqwgJpVCUJmP4m9n8JyrH8	1
5980	2vbWYdQHoXQkWmDDpBfDwpw9jNFpMJa3adLgfaMvYiPqbZNcTY6o	1
5985	2vaCHWZS4ifpSRD7VFKeYows51rnYUrqbDYuvwWyzzT3dcEGwT15	1
5987	2vbEcXcA939PsE5zwL2jcUPf5ZQTa3pSkuBTAMARmJire5iJ6YXJ	1
5988	2vbQY52KPm2mZQKYwPSWz3aU9kM8yNmr71sHbc9U7hbGDp8KnphT	1
5993	2vaiRjzajkcG5KQhTo1tZKNQ53VogmiLpXmhQRgbkTtLqUeTtFTt	1
5995	2vbc7tcMmXUubmUKRsLo7FAyHpB3MES2owHiy1wom8vwi6WGbFgE	1
5998	2vbP4dkJgyr5PoCrZ1nZ1vVFagfxjYDHa1kWVR8fDgmuvrY4TJzq	1
5999	2vaqL8zQk1EZ9EjUauTbquYY7tAehjZtHfCv6Nspw6fdFuEu2gQv	1
6004	2vaSN25TsVZy1Q5shQ9765Ba3wqM68tFymcm39ia5pCTtUWpGMKs	1
6007	2vautnRfZXzChoi8uceToxKyjXUfePzEzwKjMfrxwFDsnaYDD156	1
6014	2vae9rVQoArkV97ZNjBVXGez2JGi2J4az7zXm8gaBpwHuVRLeXw8	1
6018	2vbnfDbV617hYgmvtVuZu3iqU3VkfBcRyiMtDZS4JDAw2ZekCBtu	1
6021	2vc5sP8yxJRdmx6rR8RZCHQq9oQsJLg8wNgdaNAe5MNMtRLWB2sD	1
6023	2vaWNdoGRQZCoQBkm7qgMNXm5wvvBXcRQdEdcH6vHGu2YBNLnG5f	1
6028	2vbfKrQxsGut1xj1hPbY73d9KPvVv8Ln6HS7rt6um6LuYC66yT3C	1
6031	2vbu83hFM6SrtAzt4T6289p6CMyuwKvQ3SPsdDSxLQXmNUyg2F6r	1
6034	2vbjxpzc2xkGGRBvJB9tTeFHATwPtsx8e8woTbxCB7HhtyQBAYCS	1
6044	2vaPcHKL37sq4pWEdH9rVnzJjfWBaSnGCd8kq3ZfPB7tP8321qcZ	1
6048	2vbSFwFDdaTqBbyM16igtAij1cirB3ApUi1wv4mZMFrLAwQBFiJr	1
6051	2vaXPUJ6AwQmFZsWRTTV8t8k1G2PFVqD781iVgTMb4jWJ9WqcTSX	1
6053	2vbFYrudLURztueqkDihgNPvW95c3P56rH5Ty4sEjyGZtGZAG8XA	1
6055	2vaMTdmjvehK57NuWYNeKEaVDZji7Cq9gr4PLdfKVWgcTscc8tJ6	1
6061	2vbPabBYwzJunLibeGr3cwzsECNDPqHf5kfwjbMkucK5eunbbHH9	1
6063	2vbSJYFs6zL5VqExCte37DpGBpV6mdwEUt1JuDT7inFqdnY1uUev	1
6064	2vbsjGcL2tY6PDg979eKqB4wf5yUiQ1SJQiyxziyFPetjCALpUJC	1
6074	2vaR12xdkZWcAPvQVGe1WJyExETipSK2nCEgKsWYnC7fYGHVvqWJ	1
6077	2vbDKpA9a3kMRmFfVhsHquG8ANb5GGYjKXPGAS8QWRGVibf4WYss	1
6078	2vajv4DM6uN2yWgqwhNKj5wpqVhSUfvbofytXwZUJXWNszfKmVzN	1
6079	2vaGZnu1JWMKJWuyACzgyE9ZyFsNzHtgYEKXizyP9NC4NpT1LuFR	1
6084	2vbptBJLMRyiVW1h7eALmwZmhrMnZicjCJNWD4LBaY19n9QYTAHx	1
6090	2vb3LNaBUfUKEBFMFKbQuy4KHGYhomtcNrtCgjJGapot6FwEE98S	1
6095	2vaoDGoSCsuPRSTGyvJAH2CS2DaHmiaTbzzs2W88bK3i5szVrZMU	1
6101	2vb7QtZkTWeJ327yWW9NzVnUFw4dMMvniZnpGbDiEbSPpLppfELo	1
6102	2vbGpQh8P9CdGBjEMyDAF93dqa1msaYKDeFfeAtFqgSTzyhQCAwL	1
6105	2vabTqnFhDqPk82cdrKffM4zBsMePs4sTUSU8sTMEn7NmLn1qucq	1
6110	2vbuginnJK9RYdk9Gi2GgGmDh3ZntbCzZ54kCsceGgcVftNUzx7i	1
6115	2vbW1m9Vkk6LJdWJPjoDfzZ4mF9UALyip8PsJ6Mz9U5ZpvyH2v8w	1
6123	2vbKAtRPACb2Z6aZohLVrtFLBcZUF22mgRLrJFK8G6sNEAoDmewW	1
6125	2vbwNtqU1XFxGjAagTbZMagkMvFUVcdUB4pskX5t62NPPTCKBvRX	1
6127	2vaTXX7FQePT1hjXuhwiKM7Nzd3Y2UhqYDub4Z5h8YwZd9heAjiN	1
6130	2vbRdfqaUwfHoTW6ZRwfNpSyQFbSFJJmiGpWA4jpiJ6uFNDs9FT4	1
6132	2vbCVeU7r6b3XyurSY9bX861ZfmbiVqGhXU7T3wgyDSwcAYZ73gi	1
6134	2vbHmGLhUKbTi5wzzkWQ8fhnxvNmWQZNwiNyaDA8Xgfw9F5gzAJ8	1
6135	2vboBZQESd1PmX95CPzQKsJS32zFGbxr5iH7tgY8C9tP6EfS2NBC	1
6138	2vb6hQ8tanym4FMPcVqf2E1jAykvSRkNPvv5fptt9GJpddN4FJ8Y	1
6142	2vbhgZLbRSYud5veZiJEhEHEpZKqyoaKXd75pNtDdzv9MYJYPy7J	1
6144	2vaXHhAzgcazPg4Uq6jSh6aebnDmCu1dmqMaRGZd1RUZP2bXdRv7	1
6146	2vagvqoTTbkkhBsjoYk1sE9rYpEU5LRhNJkTnwaJixtLgmgs27kx	1
6149	2vb6RKhv2UmXPoN3g8Z1HY2gncLgm8timX9c2hZ2EjgB5JYuDVtc	1
6153	2vactiRMHqwXo4vseFCsokbJBH5reRhFabEjNUX92EqjTNEhDAcU	1
6167	2vbBsnBtnooBcXWzodU38JJZDePd7AZzaxPDfNaHJ7ARCCo9W1ej	1
6171	2vaqTSsc4AsxKznZDwTkj21vxSQNtnGvu6EywLnr7BKKsFbDBvZ6	1
6175	2vbEf9vkMcWQok2yioB1RWFPhwAZ2Av3pNcPnxUQqt1Pkbg7oc1y	1
6178	2vaCDFcvyhkvL6QVLr9MbQe5H4CRF335SVFH1fZbt7XRLnTVYs1h	1
5996	2vbNaxWxg4XUPUi4Uuij9Yf2pwaAgiGbPMukhxdA4z7DnibxNQzY	1
6003	2vaiXofkzTpR6bkd1zhCVvfduF5tnLEch48DLszUJdaFKtAWXt7e	1
6006	2vbHEPe8EcAP3VaSm1MkAV8GQcwdGsaYzpPh5rd5TvDwmjtjf6tQ	1
6008	2vbdoLy47BXcYps41sGaKYsg7bTnMmUPf3CVzBTotoB3bBsfA1jy	1
6010	2vaWje7QkEHeEHcuXD1VYMz3N5RLNbp5FLs4pGqj4hh5u9Thx9DC	1
6013	2vayXeW4Hc3ZGCeXTZqRMefZrSdXzt9yetQGR6NgHuu8jHDWvU16	1
6020	2vafUWQ3vd6GyMF7X7Nt1qGRXS2RD7DVdM2XzyJSxrP396stZccC	1
6025	2vbgzSKuL4RkJVRAoPQH2wL8JxHRN2U5C3DdBTBjnLzhcDVvpCb3	1
6030	2vbayfLZsMWnJGcsVKE8Ld2SDhwsxnkV42BtsAAytSCbqsnDkzZ3	1
6035	2vbJ1C61FHJvjXQ97as3PQEcPtAWZM1kEdUNSBQ4SBau2rPnyWDv	1
6037	2vaPTeTwKLnQecwWjoebcUaEQUtbdjmSNSEEKZ43YMdPWSSpLPJb	1
6038	2vaywY8Pr2ALYDjh6xGyiKjBRkRup5UU3dLTPs1UXVuQHxAeritG	1
6043	2vaMhmgK3jHoB6aCH5Dxw6gz2b5H6vep8wTEKfNKJmz9WXdiA8WY	1
6046	2vbHZd46adtKY5bg5UNnopBbAnNqcW7p71aWGZATe29eiW5XJ77F	1
6047	2vbdrebSFKcuzdpNTwrL8U532D9on7m92HyRTirzk9G9gPyb3UwC	1
6050	2vbhQ4GBbaDPxQtvxyiuXTkpqQRxHeaVMJjc7gp9muewqHH8sYkR	1
6052	2va9DYrkeQiEeMXpQ8aEY5RAFfHSNYhy4jcqbpuqyUQsQ2JBaeZo	1
6057	2vbfDs6j3oDVnAoDAvbMB3tnR2U6YyaJBCzpcYRKhom75TCDARJT	1
6060	2vaE3W6mfuXqSMqkiJLhQ1sruu9xHrW3iPcSuBqCnLTzrYNkHcCZ	1
6066	2vaRAh5aBqUCe4ooSZAjRzte9V1AYEdUWUYjJvfEL6DTYHTbpBWB	1
6069	2vap1hKcTrVqyH2ZDihxxAptCT3mdp2qZUptFrGajnu2U85pVvbZ	1
6083	2vbQx6Mw5zxZUbEZ4xAQKgRfHDjgpQNmnUHvSDqGqutVjBh7bLgJ	1
6085	2vaqgSLNccdWq2SHCgTm4Jdst9jHDR6q7Kv3V7SEhf9mFFb5GhWF	1
6092	2va9UVmyPNiYjR7xGGM6QpUCDViyfVBZP47BzGGYTPWjJjfAe84R	1
6094	2vaggzVAeXP7oUskJBZsWC98AoFSCiDnnXEdcvtvZgEQTnFBVUgU	1
6097	2vbKbDD6rtoivkGWknT9CHFYHhq7ZjfxFn1dmwGcZYdUYPUhkpJT	1
6100	2vbAnp3JpAaeJKYa8UmBcmVUf2WoeFYG8qkymZakB3xjzbaUoRnM	1
6104	2vbTQRzqisC7pBip398a1bLX1vUEzXzsDn7GWZWb7k2NNXPnECwn	1
6107	2vbwUPn96eKWFhnjb8BfZKRg1vZcF65aQD7GQ7Fjf2mToWHJePeB	1
6109	2vbD7UBHdoRCEZrMBDY95sQr5D5byrouQTUZfUach9QMN7tzGQam	1
6112	2vaLcYr9iiVmk1gqChQpcVSHLPhp4m9p6EgA6fzqnkDE4US384mi	1
6117	2vbLUy5Pb1weNc3aAFt9QnsXFQZPCbtkToq3uDnc4NFCUtmLYt2n	1
6120	2vb6dC2GHwjuGdBpXnZLjqHXY9Anu8axQHyMHXVXr7ve6UrUri87	1
6129	2vbi9N7KYj2onVfsEc56nds6xM7YJu49Y3vpsG9G2XV4r1nRKQpc	1
6131	2vbPLp5xmx4rhHJHNQYZfo9c5mA2wVLynYGZSXsG4X3qPUt3SngZ	1
6137	2vay3odG9uoeNBHXGvPnjcagWHuGS6Y5cVV7j6QFUHHMG1GzAdZg	1
6148	2vaFeyHhGuTuxBB5QrFoYRQL54g2rRW5M2eZ8DQDEGcHhEovvH65	1
6155	2vb23N4HkUQq4diYEVqCRh3Tyykosd3mcgZttKeKQ2xoXJYbrLwP	1
6158	2vbxdZKPGCQqrEdKRy8W1Rru4HghVbfSRwqBGjsxHFbkPAxwjHnk	1
6161	2vb4Krpoqc5PSQvzcF5eQgvLTmwwA7EBkommSu17TCtWJnYU5jJq	1
6164	2vacQP9FBVy5QStnviSrx7VrY4YoTayLmkthvb76dbManVAY7fzG	1
6166	2vc553MrXVEFCiPjxDCgPeLs7KQrLDtXBigw4NekBFp1NrvoeDPw	1
6169	2vaeY16RwVXC8Bjoi5aEFJAN13YQiw4BWQZXPjntPaaB7W1rARFR	1
6174	2vbvdGDTqSKj3XD5tfi4Lq4Y6BebwpnfSFGjVNyGEXJFsoCaLmVE	1
6177	2vbsVHLfBckRTd6vwDgHQaigv4vnk65XKC1wEs6KxYHVPYaBw8XH	1
6181	2vaFiGkqXrEYNNarr6oW6sEAhMTbo4Tt1XkWsSJ5WTFtXXPXjpP2	1
6027	2vbT4S4KsHF1Dfch9kcw5zvCFe3aTJtoX56RnHw85mmHshKEU433	1
6029	2vbXZurvELNcDX9PbnXUYcQbybCKiGEf8qJX9nnQg1179KUrgTcn	1
6033	2vaGTw122QYW4F3QbY3ETRc73UccVk9HptGaoJB2ajKt4tj9fHNR	1
6040	2vbbJqRFKCPhaA9GcpzknRK1Ff9TnyFK5AnfS27EB8jrmcbWsyHW	1
6042	2varUB9Vv1L8ry8h2EMoePykbvmLjFtUYjwxGppKvSzThW5ZNWkR	1
6045	2vc2UqzFKpCdnLmupvB2iWYXqG9Um2Hog2giJSwetR2RKXUMugWL	1
6049	2vbsmYo1gCMHdRoh5d363eEsF6gEAaPAcvpAeEXtUpdsAjnqwfAi	1
6054	2varNmHfyNg4T8sd2NAWJ7KjaYfzbpaTHMkoekFtBYAKJGYjQ6EV	1
6059	2vauEBU6DdPro5AUQiTfpvxMkooHj3whXoLf3fXjuWGPdUnDW3iu	1
6062	2vaZHU4ggiCQefFE1a3SCuLmyTUKGs2ceenUQtsU5qAjXPqG4kM8	1
6065	2vaX99knmaiiiKUHeuKL48hpxuYwLBMK1ENZ6ujSKAwvs2ZnMsqB	1
6071	2vbHaSdxyDZSmt4KGBoD17nyroc7Dr82Y8Gksywhq9iktzfjZtoE	1
6073	2vbaqgPSfMKeV3s1iiYXXgJyzJHZUDQf5tNry9J6YGLZc8d6yUyq	1
6076	2vbTtmMFo9VzWJjYfVMBdbR4nc79pZpjEp1KYcdanBcHo6FyDjpw	1
6081	2vbCHwoMiutAriJkgzKpVRGoqd2RhHWC4nbeBqc79didkryU2Esp	1
6082	2vaqNDaimECZozuQiwAgVuv5cN4uEFbzmagpo3H6iG8jtzxc6g6T	1
6087	2vbjr5m3cMThSddhZbgWvSZkELoSJLiDGpxhPFGGWjW34tspq3v4	1
6089	2vaUa9dnWVzf1KdxVE8fjAWqoVETvRJzwoWspwTe1hPvdLwVKDCq	1
6091	2vbZx8edbnWmidL5QLmiZ1bGkQdjjcr1cRBNWJRFVggrVCph6bZg	1
6099	2vbbCZ9jKDxUH5jntbhLVW5BfrePQsuz3uEPDdFjNnyRUa7XgSXj	1
6103	2vbDQus3D42LKzwktJ4JLqAPZzCCUHmbAav1zNCz8KTu14Fo9fDu	1
6106	2vc2QjTT7vHmpbXLMZmTg64BcCCtGRZySiUyEd6Q9o2xLgnRE24q	1
6108	2varuAftz1tiWcA64sZgzCyS8BaxzBdVKibFXJFGDL2oBByzScWj	1
6114	2vaKaiDvhwfhsp2Z1ZSYqKQenkXv42QkLsdToD4uB5NouNKcnQje	1
6122	2vadR26MfVf1chgz8PL6E6U4ZNDgHz62GMtCZSMh72diMCcvPEQv	1
6126	2vak5DDfhQXqRU3hzSKjbZFb5TYsVAnkdJSiqg44y971ecQxqpdK	1
6133	2vaneieLEw7ddMEStMKPYyaz1C8hxZa89NtzdACV2tXWg5uKcVq5	1
6136	2va9obhx9V2EfwWgRAwMmxtdpRJaVWAQoLTstmgw9yokBFR4E2KE	1
6139	2vbFY9PrfET9Jfrkw5yhGicCDBYucTDnVTtrMQZT5eeujNGGdZGt	1
6141	2vbHN79gvwJSWi2fvoeMHo43NSXjY8mTAMWv8gkSbtJ7FEBGEVKH	1
6143	2vaKumBxCZvR5pxB5UGYh371xQ8aKVxpLPduttfPquCCRH6PXned	1
6145	2vboJhcN36H6hrWudRqPftaJ1MZ2w648Cb9F8XGoHSiBt4ubSsHx	1
6152	2vbCiwPmfY8MztfgnthgAAxsydDxMMvrWgXTS2fuScUMXUvWpJKh	1
6157	2vbEVXSi87nUQiFvkB7PwYY9HRu11rB4SWjd4iXA9CxYLZQHnACQ	1
6160	2vbLnALpZWZzGheZ1MGNaX9RGrr7VRfjyARFTajq8NVh1yMyXYGu	1
6163	2vap9hAi8jw2HJiw1hnuiDRuxZJF6zdsf3VXrxngZD7EU7X7WxhF	1
6168	2vbkMeHHc6mfwy2bxEjKHrde81FfH53nfXzMvYNxhJZizoEa6f8e	1
6170	2vaanw41gHcbU1V6fQFhTvdQbHKZMSrXMLZbdWzjDGMZYa7u6ju1	1
6173	2vbmXUsCDTTkQhdKcrUMJ2aSczpQruvKP9AgCCzfW1voYhZkKRSh	1
6176	2vaQxuChADH1cr9AJAPEaFq4rHTuDiG5CLYCoHuA2hdupJcxuvyT	1
6182	2vb8N5vjJBBq3pGaCRemEcYavp3v9GDYuxyrKPG1tKcHzvoEsYLJ	1
6183	2vbFLWK3T3sM91zP3wxSVAmWTCF6gBPDxt7uCgXqBAke1TEhcER3	1
6184	2vb7REA98XzpKo8taNaxh5WKY9G5tNdD9jxJikJvzNw7RafnTDQN	1
6185	2vb3TZLnTXd7qRHkdBjuRpZbD53wtXi9bgRRZ3QSAGguqKJAJGx2	1
6186	2vaLGUaiYgMMJRcoNFbvJRQB8sMqS3LAgXXcV8YrEfxuvR7C8byE	1
6187	2vaHnqZyKfnFG5kSBn1AaQamCBMNi9d4ZTCRAEkjds4mGtZvKpv3	1
6188	2vbZyyTj7xbA6rt26NZwwzrbXWdTK1hS4MTTuwJoGZQSGbfLLbaY	1
6189	2vbim4Wbeq5eN1i1HDnoLoCddPQ4B1hVTEW6otK6jSrwNPYejEQB	1
6190	2vaeRv2ARpi9ckd6kU7hTSWszCEemgf6SBtPGZQJjVFXtqvELg8n	1
6191	2vb8nAeXSskxAprGGYq6SdTnvMZJ8ysf2V2AxdoeR9h2sWvoA1ZR	1
6192	2vbXH5G8JNmhswgt8VjWneTjn2z7eVmGHQaZdPRM98nRor9krBY2	1
6193	2vakLuKEqXaGiQqnQ7oJsqDmAWJujcYLt2PMkaAE1HV6SBsYjF9k	1
6194	2vbbzq61i6R5erV6NHFQGpxKAeG9o5tTHR1rz8heUG27UtFv2SoF	1
6195	2vbNsSxqzpHJ9m5stVZfy4hvch6a1g5DtGhysTVaDZjLm465zBsF	1
6196	2vasNMksRw6YCHu2DbKo9m5rCekmRebC6RePYEJKYP37m3eZ7M2d	1
6197	2vbbSUT6hYk65ZCWcyyhZ9g8br2oiGowScQCHy6QwYCSf6kJyCjL	1
6198	2vbf6rn8E9T7KgE74BAYPjpUVcg6HrADiGqkLwZn1imKv5veJdRT	1
6199	2vaN9n8DaX9spktbxNbxCyqH4mzSb8s5pndjZ8jGZZxSHvAg1Yvt	1
6200	2vbEX2QJo8W3oJMR3M1bEf3MXRuaJoW3tfbNfB5zrLmB1MmUgBqa	1
6201	2vbzAwRz3pjo4srfXkgFD1JCkWAPWDk5aRWLvRx8eTJZ6EMev5w4	1
6202	2vb8vg3hiXwc6MNs74G99SQ6JdeoBPT3KZNU5h554rqsXzrfNeKV	1
6203	2vaF7cAhJbGQCiDMv5bVUNFifcCze2jeuXG5o2pvdFLSNDuZH7qu	1
6204	2vafDucyS4Mvb9kn6sEqUaAc1GjjuWr8Vgv1qCH1o9UpVkpTdqYA	1
6205	2vacYaqm4P1iPbmggsvTXKo5cYt9R5Fzxu8jrbe55hy7XdFNA68M	1
6206	2vbwR6Hxokh6qcYnPmssbJRo4GrfArRxhkQiwFzDJfW31WaTamFd	1
6207	2vbxrgCDzSeW37eu8cVj7DdTG73LeBjvXDakv6AX33iTPsfmBy8Z	1
6208	2vbdCNmmoZx2jbj2HFBBvLjubdmpqE1fefjJhcUCqHXyUZj52CDF	1
6209	2vbnpSVcHmvSHpsZwpNoV5s4bHVBHMRG1gdBsbD65D2NB9hfPg7j	1
6210	2vbCeCWG8b8q8bCiRda6jVVLQWb8zbTzzPdB1x7S6PXwDS72YZzp	1
6211	2vbJjkbNsCtNdvJfCRRhz8b1xBSEDAt6tTv5BGm3XATLR4Y2xkjY	1
6212	2va9vXU4ev1yihFLhDJkmwCD1Uv5wq59MVZSev5T3HUdDr6NsQHs	1
6213	2vaLykeaeFEiZFfstDNX4BesKQewT2UqsmQbFGRjpqZJyv5YDfM6	1
6214	2vbk9BNQpBvdMtie6KEPCyEnWtKn6kKg93vpvT74HY2WM8jmS4j8	1
6215	2vbvXbQHFLx6T6b3rxJGUYNqNRxs6Qan3rJKCuV949gkyKQkV5ai	1
6216	2vayhjB1AHyTxgoFwWYctQADHTEWmHBLKdytCPVHohctnd5Qv8qM	1
6217	2vb7TkEQQp72585UPNknhb6xkLSwxdU5qSjhubUDn6JZjez13MPm	1
6218	2vbBH9krFDtinA4Nd3Hio2XGDFcFnkXom83YdBN5xJrQdtd17VRt	1
6219	2vbYqPRkSQpqKjgh6TR2sbiHPUdFxje19bRaQkeaVaFqUFAA5X2H	1
6220	2vb1UbtoitUqAkCEhMb58inKmbVrraLLv8nt7rrErjrDkdKmpDeu	1
6221	2vbZu1R1e8MvZJUfzsLheDdkkn8EbkdRtYfxrzwHjnyPsEqGs68w	1
6222	2vavN9VD9nQprRDFz2pBMUqgcKzxQUFzxdzc86bCgL2GqKyY3KWT	1
6223	2vaKuw5UwL34aUrxiAtaRm1By4s7QghiEorWgNjVphemw4NUYw3P	1
6224	2vaHavPcVQRBg1pFajnSKkc1bkGoLN6fNvTPHyzYvW4BeJih7WWm	1
6225	2vas5vhcu6rw4U9eBnZXPA2NfF9ZZWsQJCFM5SNkTTwnMjvHnywL	1
6226	2vatNhqYf8feNneDeL3YbtdMPCyFAE5vncWdcWPn3EPpHbApKGcK	1
6227	2vaUZgDJwss4aaJyXpm6ptAz8xFEErHTnofBP9Y23ew7zfWWpcHF	1
6228	2vakFGef6XAnGXXbgn8DUUn1EaaoRaUjKSxdBmyxTHWyKMEFNCB3	1
6229	2vbgBeQuaJXj9hjWA4628tQakGe74zZRZ7HvoBUXkudavA6VSVuY	1
6230	2vaFqSW8bAFwk1tEz9NFHdevdsRWBvJSZDqFgXmrM4tdbLwV1bKR	1
6236	2vakWsJvcAtSqwnhncJzbkZhfgVr6sibv2DcJ12YaNWBLPHSpcgW	1
6242	2vaojNPjMX17JaEdnMnatfsxkUe1Hdh7Mn66knpGExbSf3T19VMN	1
6244	2vaSRNEQwuELWbuPh88tqiHQx8TezNf2o3BoEBEdpU6c5GYMv7K7	1
6246	2vb2R9GCe3GpXT6uZBXtUtuSyNyzsybrrRCJ1ZgaR6EUXGdEAwn2	1
6249	2vbz6osfGibHwZWpswU9JTRQBwVA8g7ejUKYHPZEjykfE8Bg433f	1
6251	2vapFhSth3vGZF2DqrmEnx8quikFjA17onCyPDhCxEhKALYUYYzj	1
6256	2vbAJcyZovErCbDa2wCj1rMroim5DsUobwozRyW6BKWkvHc9kGei	1
6262	2vbRbbXDVbLkcsT9ANfwtMEHVUC24ydNHmJpwERjKs4gbrW8JyKy	1
6267	2vbwtUayBMvcxUW3V4p1iDQFCaKRfQwrCoQdfUbRZ6CGsaPLHwmr	1
6269	2vbbaj5rr8Kxuf9NffhPUeH1hRXdZsjNCSCUgLqBkEL8ENdi4bn4	1
6272	2vbXTGfdtTcUcdnhmMZKqF8yyekyoqS7PbVaX7o6sXfhph3sfHKT	1
6282	2vaQK7iv9pirzjGeV4iNJxxpggz2ZRp91W91roxLKJSNpxwwAX36	1
6286	2vbGudkw4teZAxbMqxFz7gwKWBtct8fY3HWKisPnXDD2GrqmvGso	1
6291	2vaJx4ueAVpKbocBFF5NKAJanVB4rKJ6MbCLkMqcMTQijYKT3uB2	1
6296	2vb79dnZESUw5nW5M3vVaMaGuPupwT6GuAZCcnX9SkF5Z7QfeFNo	1
6298	2vaaZW7amgm2Ff7cUC8bYdPGVZzakMJf3v1QvBBmuQSfdjsetMHg	1
6303	2vb4ZMiUaKryySgLTzx3eJFW1kt7W25yhrsCsPu4xhGeGkDfKiUn	127
6313	2vaqNs42ME49X6VC4K3strrko2v4ijvAqm87HdGaaKCUsuG1rEiJ	127
6314	2vbyPAspdyeCNWKMhG8dNwbDg5CiYZrdg6rTYFVYWnjrFtZ9g1LU	127
6316	2vax3GBWJKzZXego1h1AMj37tNpnstm3UArGxgFd99vNw5ZTkeQN	127
6319	2vbAC6N8BWKbL5gos9vW8RQ3woqdiNHsKamTNREVo1trnms6wG9K	127
6321	2vaVeVdzzN82TWqTWcnMKEtxSNAu3m3ABM9UyVRWitySnhcWyZun	127
6328	2varKSfarMt1GRWJ9MUpeYoiyiShGX5LdnRFn6KHaW3Nxg1D4jwT	127
6332	2vaNgJcyJseyUcyRcZ4zgVuQYDDa6sjxv7wcr8rwPs7KrcPa1vsn	127
6339	2vagPZ4ETMnCG7yjEbhHEwu7odV3imeTxbh5dkzhFGB3FGUcKu34	127
6342	2vbjRYPGXGLd3hwAqXA4qAEycsC3HPZEhMva6GiGWzWiCd2x7sFE	127
6345	2vaeHGhzLSqV4cwTWEhnudeoX4zRCaHdBgLZSz3SRCXsqnteXiME	127
6347	2vaubs1SSDJw8hwb9QHkzchWJburdq5nxFkQGAy6NAZ5i7wGCZyw	127
6356	2vaj6ZU9cgpMnwpVs2qfAMU6UwM5Eyrdh4VioGmzqThzf8goXwPW	127
6361	2vbgTBn5iswxUwggjzuEDmadTnoNDsmjoKAANYiJya1dRW7migWU	127
6364	2vate9zARWMx9J6MCXnTKKE6ETAQgAQVpgm5Z2BLCWyhWz4z5UX6	127
6367	2vb2Sd55b5Z52g6JrnxsrZXT3NnquY6meopEtJsHb1Em4wNa9orY	127
6370	2vbYrdwWriGStnaspzNdddrrLtQnji46FSzvkWmdYzhYt18PKCVV	127
6374	2vaQbQUv8DKYZURahdtUnDbNbFQNBKc5eX1EmoAvSYHPszd1PeYZ	127
6378	2vaZoB17Rn6ut51AXmDdp8CigxgvEiXjaVhNN2znkQ7aC1FUEsta	127
6383	2vbS31wMq5hwUzrSjNux7RSpks95cojXg8WXgPa9EhshkWe2bBxa	125
6392	2vbkhvrnvFrjz8b8sDEs1YUe1YJG28ECgmHAhNcid3HuSidbvSGT	127
6402	2vbwBvqnuRNqVALi1XtNaxDHWdz6qBncouCUYSKJo8bqJ3WFvuvq	127
6404	2vc2shLF9kqFp1DmaTxkRepTnCw27R2Bzifst8PVLw9ZM2g7vpas	127
6407	2vc4M7nbqEaQ94DZCpKqaNGtdYSz2wxkMfyZobXxkLNwo18JCdC2	127
6415	2vbYzJYiLwxN8Gd8kUHoRejCb5wCPFrot6EZZkfUp1jX1y9FVreZ	127
6434	2vbxaMMcQn6s4x7ecs5YvWwarWvVG97Z4rBuQgxasZ3ec9eS17UT	127
6439	2vbjgpYVRajptw9Xxf4ZsCwJ2X1XUoTCSJDHHcVzWQACA2TV2aus	127
6441	2vb18TEVb418eEvTeorSWPgWi5QCD8WYpz3gFSBZ4VkdmAxP6T92	127
6445	2vbS9dfzwh3h7MStwf4jViUkDGR8D3vZLfeBjEPqJ7Wm729PkPmh	127
6452	2vabDXC9j2z4tXRFQXuN1JecAHSgWTqaLnTgE6Su4cw2LY5k8CKV	127
6454	2vafVyjPQj265spvMAdaozyJLKCeei4Yga32zYUcbGDGaZ5sPzzx	127
6459	2vaeyofWsmmYb6wCtCQcLTmw9YfRVEZYMJviFef7h6X26HWBme2m	121
6460	2vaeyofWsmmYb6wCtCQcLTmw9YfRVEZYMJviFef7h6X26HWBme2m	122
6461	2vbdNwizoKz2WwLuszSKqRPMN8F4APeqGqms33JsVNcLcMyQKo3w	127
6466	2vaQ7PpGCJwvzDa3TpGQvdsed3NuLbKsbz2Rq39gGnzDKxtMcwJx	127
6470	2vaXsdu38b738F8kVgRV6SvWYGGwSbV2HkySCj7175JPWrh8qJxw	127
6475	2vc3ndxoQzCa1Uy4eQ5FFL65454CdPKHWPbai5mKRmwgxfo3bG8z	127
6479	2vbWpTDv5PWrebAuP6J3inVQsnnTaNFZDFGeLpiojqsnxWUkcjYW	127
6482	2vbsAsYDuxJVnYDMDtY8vPzEBJJCRVWg3gVC6w1j72agn4knEZ4E	127
6485	2vbDiggC2mtc53wGmBxdiU2Hx3zA7cfrsbgfmTxEETDhHKM3Ka9b	127
6489	2vaQZfmBcw8yxP3jcv69ctxUAmvTbrPAP1tLPwUPMguBgD4nfRxd	127
6492	2vbPa4buzw521f2LvbUBm1figrku3b7LqbEG35dCERKjaipfGWMo	127
6496	2vbJEWsJ6DxSv4WEi2ZirvwtqcLUNXz1CQS9DhvHcmvnyX53gdUR	124
6501	2vaAhmwAKvhBUNe8NVW8M5uiQvMuPXYP7K5qC2M7RVr1yQHKdEkn	127
6504	2vb8waoVvRo9uEunBkdtvCW5RhRLNHMuBgR778GhzESoZ43wX9xr	127
6505	2vb5sXLa2Br1rV6mxaA7H5qCBFNGfsdHZKt7vtWSjjzwXhfQy33R	127
6508	2vaK8Kz4VWyG7buYnsHgUB4rt8w25riLx4voDNEKknrtAWXauFKW	127
6518	2vaSdU9rEkU6MzDLFBU5VpK1dzzXkcDnJCC4rpD2zof93mpejfr5	127
6521	2vaBfgFLdg6EDrXNQygUFGXM4Rn5vM6L3JkdksW1NHqQW8aStudm	127
6527	2vb5HHmR8NT3JtYAtQe3T5S2wGQXa7rZBBhxCe5mmEZMYG5n8fPA	127
6535	2vaqtgDUk2fkU8kxgsM6CdtEPNQZNxYoxQ4NML9KraSafYKjeNGf	127
6538	2vaRPiAwPCrwruwHKYdcBGCNPemQ4myS7LwEPcfPpcpUgKJ6h327	127
6542	2vasQY2sQeKpvovgZsriBErMWkz2KWUGcYwWyH4FL9aqnnjeNGFX	127
6544	2vamSodB2XG7Fybk8fPohrNt3UbRAu1AmHL4uMbSiXp2eCNvZKPB	127
6548	2vbjddDYERTnMe235MzHwzfzw4GbwK91oYKCpqe4tsfU5F6PfvLN	127
6551	2vaxb9UN6LZwyCQMg2hkGJeHTuNtiodGpHLr3USupQdFf42D7Nzz	127
6553	2vazp78z73A3FYahwnxZa7UVGQXcuqG4yjBozKfgfyZ8uiSFJ3rV	127
6564	2vbUvUr5epFUZLXcXfs9iFDVMNvxP7MfH3QBzrHkXdjtZyfkkGMA	127
6568	2vaHzBiz5DChHv1APJRiz5UhpvUzai6yuSH4LmDV4cVCXuohy6M9	127
6571	2vbadasPGMCWwqJwxHZg4Y63apJfvELqApBVzvmP9CbFN2zAGEiP	127
6573	2vbvW8DuUb95j2twncZ8LLzXGqDk7jXtW1vzccQpW8gdRcqekc1P	127
6579	2vb6dGAPi6pJUVfCPTsuE3KTSDkhESLAcyK3o13hVdbZLmFzVqTS	127
6586	2vb3sGubF48k8qjVghNunP9owVuNsp6JwYF2sVGtsfdF97T8UHcS	127
6590	2vbtrPdgwtjhUz6Kpr2E8ZAHKhj5Af4Wm5KfTfm4yCV9VXC3xpiL	127
6592	2vbnYCkyckebCaTZiuEQNFTmdTpjYts2jpT3BE6FE1k4LyD8pJwZ	127
6595	2vaghJCMo3WY5vxSRun69VABzjmx3FjcFbWqKDixWEej9N9DgfcE	127
6597	2vazYXjJeyrYdQAmLwUdu8QUbqBjrbws1CoL3xd8QRYVbLT5h8fL	127
6607	2vbB7EsZ1ZFB3t9EJLzKR2mopKYACQvhmrjvTeFxvEdMY76RAEdU	127
6609	2vbQiFfzBF1t4VfxBRjbmh4TdKaNxGhyYTKQft3pRbVzfNgV8yLK	127
6619	2vaR4aQTz8TsY4bGNTLNtjopNbCDfHKQovwQAsGSqt4dzRN7YbZc	127
6622	2vaXDHqocTrAt42SXLCRC6rWu9ub7YsPHHzknKyqYBqRuAqLhwvD	127
6231	2vbjHmzJa6eQYXhB5pVDZGPbSM1KBtsFqfgQRqRDTPwZcugox1Hw	1
6233	2vaj5TUrUYUWovrxwgSuuR2PqPc8M9t1m8VWbQvmBcZz1dNEjoTz	1
6235	2vaz9dZHCY3h2M4hQfENrPBwU5w9f7tCFNeMeAHcHX54ceQNTg6s	1
6241	2vbNhjRevm6bKr1abdeTvB5ENaYSfnrjZswxYsX2cRBNCwegndCA	1
6243	2vbik9MNtJGdDpGegvW5jvMj73qumkBu5WcgP46mUivgfmoyHqr7	1
6248	2vabRMEYxZgzLZiQh1MFwvD9bnPNt9LMBmLXUMHhGk5UYYs1uGSC	1
6259	2vba5kZFtYdAGQmFsUjsjBWZi51jpjy1ZBt66Uk3DNsBKWcLYv7g	1
6261	2vbX7pZXh1JiBZNh7s7VEhjecNKVYpYvjNng5rgEY5dKX4MB5FJY	1
6264	2vbnuStyPsPcjv5d392nLVktLEWstUqzTzmDJFgf6kScHgms9F4d	1
6275	2vaYjVH6KGhnDNio5Y6qPnnZhG2MLrSWqnUn71obi2kKoGuUKLAt	1
6277	2vc4Eh5QKGPAkttPuAszeeYbGCs29cH6GEtizcT1iAuVmsZbaqZf	1
6280	2vbpjRpUixPpWyEarBoGioXeLe8i5D7yqUdMSZT8AaW7aDHfmrHZ	1
6284	2vbpKceM5qWUHPkgALkkfLLviEPfG6p4GPA4fcwo4T83APzLU86G	1
6289	2vb9ve1pt4N9ovQiNtMJNu5eSoGkjfznMsWUHQ7VbuKrEM8Rn5tz	1
6294	2vbK8EfnTcq4pi9Z61htWMPtGiumEWbBvRZQ92wKoh1eXBE8cvL6	1
6301	2vaMKZSXxYDaUzYVRZBNVRmwW7JwXE3vS3NKZfR8d1aijpZU2t3q	1
6302	2vak3rrudGmUWKRaYLZgnhjrkn8E5sJ5mfGABnyAEmSnfsZrWhJX	127
6305	2vaTPXuxcwBHAoRb1UCx3KEQf7wwYxhQCk6B9yLpKGeqzAqFdtjc	127
6308	2vajWUJFiuSp3XWku2RHCKLBb6XURvcKdmZhf4G1QEpYfCLpNhpC	127
6310	2vbUSLk5QDB8xmVZA43hNdv4wa697983Cduoom86Wjr5Tbp9DqiA	127
6312	2vbUDPEbCJkiiEC1uzaoUiwoTqLJYbfRjtu3qiShpppnhEhGpBDa	127
6320	2vbzHqwuLH6JWQ8tGSvxFDDwEBuzDQpvKWUjVxTWK4jNqcMUnwaw	127
6323	2vbU41s1wC9wSi2NeCbGC2zdC6RWBuQKdMo6fk75jMvsMqHFQFvH	127
6325	2vbTLTNBYU7TCUiiRSdh4pToPKm4nA8qLQjBDZMULskRGBSLNT9J	127
6327	2vbE24pVUe8PBTo4ECtGUErvek9swdcKQW2yDpVc9pvnXBU5HFEt	127
6330	2vav1Rg6TYdrN2ov537zLbR8yB4BrzCPJ4xsi9FTk8vAnNaPChTC	127
6331	2vaHEmyEqiBXgdvKJ7sSqAsNfRLjBphiBwXgKHqRr7kaZXX4fqne	127
6334	2vajP2tRteJKqP7jGSxnQmwtCGbMhcmbvmSefcGqtFhW9mhtAvEk	124
6336	2vakBWhiiJdC2EiJCH25htWyJc1GituAEKoQ9Z41Lhn4jQZghXeq	127
6337	2vb4seqSZAiLV1WDKjjdbhK9sgqKmvtUY3eH4M7LxgbGZU6tEbGi	127
6338	2vaeWoVeAEbhZGFhbpgsYDoWQtYCQUCsFHim34NFy5WwgLzEC3Z3	125
6341	2varXxvadnjo5ER88XDNYcEzDfVUYwMFV9J1eRoVnTGU2Bthp3gJ	127
6344	2vau9je2gXqU9NxYuowC96J3PCZniymJgDxcqXmkVZRMJdNycmWn	127
6349	2vaL6yqaeHNqdSX5uCt383C8TdvTEG8CC42xcTgtiJQVyKxWktdM	127
6351	2vbBwZnb1p3izxegAuVcnGFKBQ3e4y2L1eiGjCsJKdaLi2bB58Hp	127
6354	2vayRhiJDM419uL7Fj15wu9dcXaGBh7F5m5j1ExmANADwF8mHgYL	127
6355	2vbiU7xbkns1RaMevuui36wGjHvu7ZV6ExtBvDQDFJxzXQ1D124r	127
6358	2vbpw7Am7HnGaayrVUhraLobjFXSYebFACMi3JJnY3ABD1ciRj9v	127
6363	2vaTboSFJ7RasJRAZCExPJuNuKMce3JWhr8wnkpJSFHuszmhZFWe	127
6377	2vbbyB5q9Eak59WDX9riqBWteYm7AUxaxwykanZnMcP1i5royAcd	127
6380	2vbuQM3QctXKoWMFw12f7UNra23Sd8qz2SB37czwXrq7rXTmECRT	127
6385	2vaCrxrCUHy7XfDFwbA2Kzg6h5UCgdsaKVL88xmH5y7QS1wAdxAW	127
6388	2vbKGFerg43zBXmWcawXU5PnhEqxqrvzPaGdzjwohMAbg6Sf1h4A	127
6390	2vbi2sw8kBTx66uhphQbUVWGmN9ggG9bzTNsns8qag72hsbgvRNB	127
6394	2vb9TzZqHstfsLkwePAW2yqt8TUkDD21moJS3Y4a3bQZH5ArcQeb	127
6397	2vbHcfnBoFxR2P4db5Pb5y8Wax5SP5cCENbfeNWrwbty1hAbQSLa	127
6399	2vb2wq3WJtmEFv6osA7UueP5PRaSK9qqUzyqGMgpq35RT4f8kCXr	127
6406	2vbDLVtLah5jqmvtaigjGTvkuvaoQ2NDDZFQmVyzqspWwXSq31Na	127
6412	2vbYM88ceJUYVpUVaY9rtdKNcMiKDdoB59ig2CiWmATG6GoJs6QK	127
6414	2vbCkWTYqs5SJ1MGqVvZsjfvdMnbmoNovZsaaCmfwqDzcTXZz9Xq	127
6417	2vbwL689bxHstkB8jQfDfNNWkx9GX7jR2Mm6SJjx1cs8n772e52B	127
6420	2vbi2S5jsdMQBSpEvM9jEJV8VQkxp1Wd4h4ugNTNHp5uLr7BrEPk	127
6422	2vbqqfzy1EMP1M4VVKZ8LJCkZAno66aZazVNQK4rLKvdbwDiHehL	127
6423	2vafEsAanxwVw7sDFwU6Aj9xBgw71ZtbqJpEPadFjT44U7BbcicB	127
6427	2vaa6wLyn7mtm6LL3EddokrY21NJZ2xP4kbWKdcKmFotdJphyEWZ	127
6429	2vaUfPee64YDnwukHBE5BpULRcMid533Vc6pR72mu4ydESnq5H1H	127
6433	2vc2ZqCmQ8ZQbrEgdggwxMCHp5GhT1KjWD51euiaPsHy3AQ18bab	127
6436	2vbYMbu41CTuh2bgWEBXmLCges9qTesmbKHNYw2R27GNNL85Hi42	127
6438	2vbKzB2xG1gotYovtMDPXcugScGxxMGE7tyKHcLTdTq4WeDdaL3G	127
6440	2vbqcj2VTFmvKdQGi7KgJ4oFhvKYnLaNzeJqiqobUJpGhyNdC3aN	127
6443	2vc15kemVB7EAxFfxFtTqmnrP6SzwvVtfwzfZ8eACjksGBCNnB5f	127
6444	2vasZHFtywnhvpk81Upi3pnVa321UF11h2nTqCxCTNhSNoppiC1Q	127
6449	2vbLNXXnjxEx47cKhv3jj24yQ7gxohtBpqstreQ6aAuL49V11yxM	127
6451	2vaFxH3MQ6Y7sNKS4uhDa2S9janKy7NzXNg2GoLxBnJBu42EENyq	127
6463	2vb4vWoJcDtuZ6mwuCChNXXF1jymBiQzqD5gmWP6DfgWtiyjpuVf	123
6465	2vaNCFi2qVypXZWbn8pyScAdRr9EBZ9NByTyDejRwUWPqz2H9rxt	127
6467	2vbRZ9iyingA1PcdgBnnNryecF19Awp4hu82C35VWhK1iKpgqpTA	127
6472	2vbborwMFw5tJ7DnbdZsNgUQfPLVxYGCoQGNFBo8hS1MBG3UbT1n	127
6474	2vbGb2n8PJPEe5WnhcEgeWqtUnzgo1cEzaPKrsdYB5zCCTQw8CpC	127
6484	2vaWNiBt6BCDMHbGh5xXFAG5UfHEFu3Sh9xAF6cYhhBWaCAzxLoJ	127
6486	2vbFgHvB4toAU1MuTzW7HCyo3UXbN46BbR5mDe59BWVXHv12MFMU	127
6488	2vakHqoG2c9EaspsJrjFEnsdWXNN8zj34twhAvgLcn5wuHqtGGQy	127
6491	2vc2S4tKMWT8WEoAZ7rvPJtqzWpybPRsbTSZozBjYqVjtLDddjor	127
6494	2vaj8yErrpNPvHj8Gt9GTDiYzhEUhsqGGXDh8qFPe7C1n8q5rXuq	127
6499	2vaeA6oM8X4srViMrebwuhha22JjmWbngLdFN4LqQPCEPHRw5nFX	127
6510	2vaNpTdFgTjyvZzoY3gp8HPSN6SehpCUEKmJbemHHRcxtWXwLLeX	127
6513	2vaNnFpF7hguC68bWDViR3cHCeAiBicoiVetjTtvQMDfFkB6H7mg	127
6520	2vavVvUGwrSvC2m9k62e4f2bwSeE2rJr7c6SuxUPxqUiDMnUPVe3	127
6523	2vamuzayj9T6CJdTKeEEdBw4GQuqGrgTFEUS8t19Gyh4Hcz67nMd	127
6526	2vabpSaXFcsWgXkM9RzeRZn7QvU7D3YL8Ym5pG7GHJafPadN5UUC	127
6529	2vaP8PGFxGuPb7k9dVrFMJnQqpD6TqsvzhFZw3UaHPsccRXTmBfV	127
6533	2vbZmoRn33cm5vPyoBrE3Cqysvbf3Lop3V8x99XvkGBVGuYxWYqo	127
6537	2vc4ZYPDGmao5kLfJ5nBzXtySqsChNW7XWAU78gd6v7uh3YxfJUn	127
6539	2vbE8NUaRNpekCu2TW5ZLqgTEffPMgrfgR3CkEMiLmbSw5AUFxAi	127
6541	2vamowvAVwvqRXHte795zoPG6eeUtUv1EASXH5ubm3oVbH3rhZL1	127
6545	2vbqmmHk6gKPhpGi5PUifBThiMM6jScJdbThjfDd2jKGedEgembD	127
6550	2vbegf66jAu51gZ89u2xyHp3CgT371pHeWahvWCRwZBWNPftTvri	127
6555	2vbmsaxK8ti8TyuLuTi9t5rKRuhzeqaERSQM8Bm5zxaGhHdTAi4w	127
6232	2vbgMxs4siuWdTeg3xyHJNmQaTMcnwjjL5uE13EyfCvfmkxePUHm	1
6234	2vaTYTqh9wzbLPSUuYRSCqPt8AukEoK6jnMq1VmJWPbwcMmFj3s5	1
6237	2vaD9C1in2kTBv48xNStpgfXYkGAFNp3SbMQsFVKJkizJwYxD3Xx	1
6239	2vaj2NmXz9YMkGgvjA13zSyYkfFimgFBTKBmW8kf49vZuTxn6Qs1	1
6240	2vb74vJ47RzvPhvV2wxJPW2pyfFkGYnS53tEdk8YMhPzELjoy3z8	1
6245	2vb6yU38HooA49h95LK6KuAp3gxcx2cy1ogSv2ZMf8MJkDh2VE8w	1
6247	2vbZRZ82gpsJtCsgAEHGQzhi9KPMAUv5aoXq3Kr3LZ8213T26M9E	1
6252	2vaUjbi37iahzsuD7WZZzC4E2gxkhJmQAnAWTo84yFmcUTHdZpsi	1
6254	2vaoD7PmqdQ1K7tziG52jiadNPt4nun4c1eqYMYFRhW6SY4jeCNb	1
6257	2vbKxMg5v76bC8DDv9zmQuXkTM7r2cwiBhn7N847NXru7eb4fKAP	1
6260	2vaiFiXb4JyEVKDwjS5PTifuWy2WyqBncVX77r2YxCovx7mGX8SP	1
6265	2vaPiJHzo3LgypWwmDKBAq2R5n5srHkQ5Bym8PgANiwFza6tvWMB	1
6270	2vbbzXwWyrcrWkKKhJzQnCwTWWAjFDe18Er4vwyWgBAWWgZPHUKZ	1
6274	2vae6NvT4Tj57rerkvTWgFuqGgxg3SmweRA1F2m5u4KiteS1kHLU	1
6276	2vba9FkBb1rZgBg1wAPUsbWs58MEUvGrrusCSEagrj4tqEBsfmdt	1
6279	2vbdiWvAjQ3JXLqyw2fJXh5GZ8n6PxL9cTcWBv6156e2ggy8u3Et	1
6281	2vahEqHW8sHVCsDo29tut3iKDbhoNoPUseufgWM5CcyAu5rfc7MH	1
6283	2vbA9e5gPhYgNYtuF2jHzjdi6gv2zMWhFBFpw2XY6dgBMJoWhZz9	1
6288	2vbySvGrZEjge6metgnzUNJZtTkrp9tHpLaNcE6UJoVY64ibRs1D	1
6290	2vawJZjBDGhwdmx1Qp1ooc7TMKkWCpHWQjBnHSjnh3ww1vpEwCps	1
6293	2vbPnZqWHNMoCJbPQXSz5zEJYQ3xX5CzxgK2uH8PPvjfwBEej8km	1
6295	2vbqEkjTi6c5myZUnKricqXByitY9WBvEijys2ZdDoyMrA1yGaEg	1
6300	2vaBi1ZufTGhZKXsf9LEoFYWxXzpVYD1gzdWj1PJCUc5BAD7xLSB	1
6304	2vaYHjaswZy1zCV1VdBudVU9i8bX3TMoamNwwVdT2b15xwLuZLzn	127
6306	2vb6n8kBetHSCbRuMhB9A85tFPuf8GqaSMLCta4LQ7PvuK91cMFg	127
6311	2vai9ngPC4h3ggELpEhvEPPRkAzed2swM7MToKphXZM3W2S2q7GF	127
6317	2vbmdUGrgAK2m8bLMDZpezPi2sdYx83qmH81xJWfdUtQKVh2dKnu	127
6329	2vbJySGMit3JBYdFmWjCqr447gGsm9TMAkbEUNnxFejV8ZVC6jxk	127
6335	2vax3qoLJo7Xhwn5eiDNQGzA9vWMau9QmEyPKYDqm7knFH93LH3z	127
6340	2vaDgPjQNmPvgdr3L31rg5FwwWAJx5rKVLE4jnFN1n3j6PB2kEme	127
6343	2vbGxLLmoXQou8xwrFLKkC3icDE7GVtNaDv3S3qQcJcYCHKC3CvA	127
6352	2vak8YsuFBLuxmmi1rrLmaGcsqHBm33FofUobDaz8R8msyarzUCE	127
6359	2vc4z871NWGcb3Hb16ANzPgrFMKwyw51qAujvCBGyXjd7ZdjP5yP	127
6362	2vaFUnUMMvfvg7BGafCSjvsubDjJexQQmGUSYXRpjtpajc9pPjk7	127
6365	2vb1eyNyEoUfQCy53nMgHEE8wqkb2m68MFcqA6sze4HP1R7aYuBQ	127
6368	2vbH6wBp71rGmCUT5Bg5ZvQAGfRk5WNMKX1ccD4fF9VDto7r7TPA	127
6371	2vbTZ2PY4jrKKeLXwpmoh2znFmWafFfeEYhjSWPGzU79JZLVAbpZ	127
6372	2vbQjqXVYXpyXy9g1ssv6AaDWderQzSSVJyA6tJpkmAGzmhbx276	127
6376	2vc1NckreekDLoJ2mqxjUxabBygf1c4Xy9P7d1cdvqbEH1n3DR5z	127
6386	2vbS31wMq5hwUzrSjNux7RSpks95cojXg8WXgPa9EhshkWe2bBxa	126
6393	2vbspNhthQau7Au97MpBKfZf5Puu1DQ685Ebi49dsupCYB9kFxCq	127
6395	2vaKbjfwyqc4Jc25yT6x7PpDVf77K6tgCq3ykTdkrXvSPoq8kqiz	127
6400	2vaL2vpuUUXALJU5UofvknHA7cqykaRtFGzLZ4zNX7VKPSaWVHji	127
6405	2vbnjriF12A7FjTPHbyNC8pbbp6eKcLmHyYKFqRi44w5iRJfc8My	127
6408	2vb2bbLsvPhNrzw1g7zaEBXsgWub1hh4EjUf4bCBBVYAcnGysSbL	127
6410	2vag4NuejBYKXh8gs9gsvNxBR8W2FNxLh5HKzEY6ihism5YwGDhU	127
6413	2vb84dJzod8d4KiRaPw72oHuSrZtu1pEjRPEh52TfhjwgGgHqMSR	127
6416	2vaHTGUUq5mAmyo37wFJQDSkhaWhyvkSPh9VYxpj3csi47gbbfT1	127
6418	2vaVQcShAkuEWXySnqFKs48tcbCJL75RUxG1JhkyxVJiEsQChgPR	127
6421	2vaMifke2V43chvhPKw71y159Diu3myTeoxAP19Vv2cqrWoSYGrR	127
6424	2vakpdTGB6ruk31msb5cp8vvQvvggPymu9af735nRLuFAWfjEwF3	127
6428	2vaDa9CrnnqdNSgdVdSQNr4iojELivxkvEdrUjgGjqomnB5VedDD	127
6430	2vaADbNJ5RuqCLpsnJsnghm7QDe33oBFwdKAUnzugdAJS5zBnDBG	127
6442	2vaMAbu6CDSQYTDwcypuKBmpyTU5k9j4EUq9F3M6uvuhhGjRRgHM	127
6446	2vaAQE3Zh1KTbyxd8tkXT8ShVB67EudroRx7nMRaTsAMzR1gBwVb	127
6450	2vaysXXJTBPtwM2BrMRJaw6zH2JbXQzBhLS4eeQB2vswiFGvfDVV	127
6455	2vajQk5pH3FwQQ7pmfr9rLzc6VxXJV4dLZ7CzPuNXA6P1uyi8Ayh	127
6457	2vaM9UrpjpykLvqUxNzVBdZEDPqku5jfHYDveEdQdJxwi5qrXLWq	127
6464	2vbsoGUPqpSQPC8AC5pjrLzJjK1CQxPhrcpjkYCwKnMYYQmAAk1K	127
6468	2vbsVTP1v7dfxAhwjZ5YkFZYsumjys4dtthsanzftshLmHTo1J8D	127
6471	2vbSqyJfF1ggLGLqkdTS44KtNs95U21pBrCtrKS3gE1vi1a8xA8d	127
6477	2vaFp98JXf47AmtfUVmR6oYfZehY2Jrdu74eyzo8AY6TCV15RkJR	127
6480	2vaZWjxJR14WThkD5pQNn2Qf2EGbLo83NuFmrciBnTsoEYQRQTGP	127
6483	2vc4kaw2jGJVzM5Crk4a49rnU5BhS2YXTdShThPA657bdq3NxS22	127
6487	2vaoKAEY26ez91kgPt3h7usoiqJQfHazGddMSJDDDSiRGnLeV9pv	127
6495	2vanXY7MjWfTT58JvtgnYqf4xaM9mubwNEBMjANzqqNQ9LXRAr6Y	127
6497	2vaZ1B257y2D5FEn5N2mQuwet9Kfxs5buJeZG9ZN8gpCnaS58ewp	127
6502	2vc5MJhDmBVYDoAmBrh14z2Pg2nD5CM3UyyX1WpKYKfFBxtiR12T	127
6506	2vbMNPrzapPbuzSPA2B3vEc6tN3oTLgVy1dQ5Arc774iDA3cSrec	127
6511	2vaeZmBKkd2wjdZ8tjJHmhuRHYgznBZLFmhNayoqeEjS5iYnqzHb	127
6514	2vbjthvTPX5yQXG9c8WE59yLMJnCBoxmbPjs6L2Lo4TNCEf6BU8E	127
6516	2vag5xsZ4a2KJp8EAU2vhcAfvtsQjV9d7A4LvZvZhRqAdH2gM1ng	127
6519	2vbBXYMpxWyCWxraWVS4i5K3NXUYoJmhXdjCjpgtNQU427ymSaHD	127
6524	2vb9bW3i59nKavz6emZLYKR5ABMTFqLgAiDe3WDick3Vrg7PXC8W	127
6528	2vbY9JT6xHC5oL7eX1E18iqNJcGoS3b1w9nknqYsGQJxMquznSpy	127
6530	2vaJnVFd3KL5nEScT68Z1gU3tmQ86saXigEvHUUeWUJ55NUM36gN	127
6534	2vbGB15WQHquA8k4uGLeMUSQA9QR9wfgQofpNwkuJuLr6TYTdouD	127
6540	2vazUvkmeThp3RGUgVzPyr922aUeNxmSAF3LoAoK16tFZ6vt4WBx	124
6546	2vakS9xXyfmfU5HUwjykhT8norYCuyPhceKQLPwBoLQN7fxrkUU9	127
6549	2vbgfj7md1nh195rwCnZnWXVYH3maX4YZoyjyzSdaxVJNS9HtYBP	127
6558	2vby5ru5o8Zui78cnNLwbiTdxg9Spa515Nt41RXG8xFguss3S4Py	127
6560	2vaFY3eN55n2kiweL5QitnsSoyYtoWtcgUC5aWqGrWtDJUPNzMEs	127
6562	2vaVXBhPfQRZdixYkrsrrsPCttrPixnjsZYMrtjbU7cK7WFFA1Ui	127
6565	2vbPokGtYcwjv6vgXDcaUnRNMLQ6KvG2kYw4eCTtccYq6nVY32Ww	127
6574	2vbsSFeJ4m2YQbWgoCDFDTR81oR1ma42rpJEh2KTn8U9kg7HTQKr	127
6576	2vanfNKm81VZHGSryZyPe7EN4C6dCRq473GEdoh4WEdcHtXGrc7c	127
6582	2vaJkPs3WSDUaBnxorA54HFsL9bgAxgj74xyvsNyWZZx2ybvRQRU	127
6584	2vbGpGCkZDyEx6GhSyL5mEr5ofVmiGz21MbfKoujpYqfegfy9im5	127
6238	2vbfmbtZWfdTycwmM2XjSSZ5JXdU1TrqFXjLg6zZbDq7zbTUJ4Je	1
6250	2vauPA87dBpXbhXvVpoQWjWQUudMQr1kX9PCtJS6uNkSh2pKkkQ2	1
6253	2vaJKLHWMvikCoqnE9pfz5wYymoHH55UPFEAb1tWuP3bwRdyCaoi	1
6255	2vaCVsNoyVAkoDcXFzVJeTKdBfcvzw8WLRjK3hVhn6awNHrmLeR3	1
6258	2vaifebXRAyFB3VnUHVVb3V49QeJB3BJ82RGht6CzriMUH5qfN6d	1
6263	2vbvfWSZTYukeBqgL4sNig9LXUBoUs4oaCex9dLhdjn9ZsK24TPt	1
6266	2vazYXJaaw6etgRrRJP6eckkATURPcvmM1zWn9xbWdz4XPpBM6Jm	1
6268	2vbBhBcB3XBqRbh7tkSSqhsFyV9D8vmcq4BCjBXLLGQCDEahWBCS	1
6271	2vbUXrtoBHr7YqJfQNXELJk5wZgXJFuuhAher6dPeXYTQrCuKABs	1
6273	2vanjByLZ4vu83dQnj2Df75PMahkxiaCqbdt7XmNV86CCE18Y7w9	1
6278	2vaAiabzsZh8WwqQJM9LjjYfpHtQwYqi2Gvzva8h7wvgQ2WcAa3G	1
6285	2vbmkQnXTrsf6S8Gacfx6Msd5yUx5FjBH74oTPEzKG8ASHh8gExX	1
6287	2vbQL8CcCZU7F4TfiHnUGcoVhPeUKcT1qERMatKiBxZVQVrdW3xi	1
6292	2vbRAXqNhznZCYM1dHq3ryepBnivrebhb71DMaeRFkFuYJ2RgDDZ	1
6297	2vam5CG7yXD2Upip1JCbvDkiiWoXv8NF9u2DHFYSRf8w4Jv4nwzx	1
6299	2vawipJmuBM3u65MToGRXFFVix4VcL34nfy8PsGXJWi8mtWwC22a	1
6307	2vaHcC5BedicSLYUFw5jdWkWSVYNWr8PYDyd3b7PaeUMGkXN8aPP	127
6309	2vaNGHCQKbr4z9KoyMp7vRYQ2N4UrGxaD3WmD7Bz5C9YXRnDE59q	127
6315	2vbNSx2zJPnrer9HN92fg83ChJ8n3JceWkbRgV1xdwHAF8Dnv3bh	127
6318	2vbS3czyJQupW8aCpaw6nSrQxeaaa6hCdMkzsV3UbmVM2vH1W8Bq	127
6322	2vb21YWoUiZUjNKhAj1AeRh7LK5ZnhEqWetgXYB2RuUXManrG7P4	127
6324	2vahZpjcxgEexh7M863j5AuAb3rmdzTHNAaLkzuYFRujMYaXnwGv	127
6326	2vbdnGUyoPrSTJ6ajVNNW7o1ar78kaV9Yv5W5TZS1aDMtigNezQ1	127
6333	2vbDLSFiFFfEShqARTWzQvVrApSUqpbcwh8gTNqWkGFgDjZhrmDA	127
6346	2vbj19wyPo65ssWEiEefN1VLtNQvDSd7WaF9pDrsY3wLbhnGzmud	127
6348	2vbK4sk69FEHp2ooCsxd6vzCuGoaZFjFrFhNZC12TJpCL9Xua5HQ	127
6350	2vc5ddaV11xD9GKN3wJFi4hhArzgY9URiFVGZzEFonMG1fPusz1q	127
6353	2vaTeW6Wh9iJT8EGymm6wDzdKSr1eXd1irwdXkqHoReb8ExBmXXU	127
6357	2vawhjjug2sWYePrjrzKfrwa9NTGZ47TYSEwyiuUhwEoKKvs4icA	127
6360	2vbZuuKSqBWpzJmqNwgXxqpgJ5A9HoRXdCVX26xYYTwyVvBtxrdV	127
6366	2vaqm7B6bkmLXHDMpfzRVSWjz6N57ATMxn8sxjd7VTWAVAk78q2r	127
6369	2vbAUZRjfSx3kXi3pAgW8vFYWxPfPLYwafpstnzwf3TeVeETMJbJ	127
6373	2vaPG8cuPV56C51Mxa8zAgwnJe6CjuFJCQiudNFUFqVmH1AW4ekU	127
6375	2vacKexYWwcTY5haFYyoeTen9CRUkPmiUng8hnduDCPRYd2qcsR5	127
6379	2vaMVLUexrDT5cmYs6nLw9QkjVkdcCsjTCtRLzXysd2wrfu2GEAH	127
6381	2vaazrogAKGdB6YtryVWSwQZZwReKuuEmSsM3fbBt6DuBG2eT9yh	127
6382	2vaVo4rLZqRz5SJdPuimop2K9bc6HWCBhriSq1tMFsMU4VTujJwy	127
6384	2vaNHnPAGWzk9ULzuc4Mjg892zbms23n6omaEDh4F154K5FEhsgg	127
6387	2vb6D1FEntdopsboKFA4id9DFA8JjFBpyNJTeXaZcDSb2PW2XGGh	127
6389	2vaMfGBrUm51uHJggtTTrBjvnZanLmdnKZXwfo2nx3Cw5wx9PQLf	127
6391	2vbgoj9TvYgm89JtLgJN3Kf6VQpQLktq4fjhkvPKV9pF2B1qv84Z	127
6396	2vbsYkxYezPaxtU9Ti51LhXePB2YXc7iWbYVMre8uahcoWYWDv7Q	127
6398	2vbLAKYntAdMFeyAzwMCYwa9rid8etQa9TUNZ8VgaC3qe71N57jh	127
6401	2vaBPjqk35EsYHRHYKiLW2mUC5qzLT8GEYDG89VatTRSFXus1HXS	127
6403	2vbYUiYRk4Kqi7gQsszZGqt2SyJRsXuYA6ie74ARw92AwCMfXxAr	127
6409	2vasG3MQ6v6DufWTJejDVge7r4NaR3qgqDqTq1B7t3ghQbVzv97R	127
6411	2vb7nPtQxyMjnSqHdtNkePQX7W6vcUkYe9HCSMFgdJdrwjB9AsSV	127
6419	2vaSxqQVgtpardczuzUo6ynN9wqBtUB31uUtHPQ6Rixc7FASHXDq	127
6425	2vamANchimWdjtCMi2oTBT51zbyg6mpsJUo439wyFr9t7nxgb6RJ	127
6426	2vaLd7VKi8yKQeX84Wh7VXEqvQE3tWXr4mDo7eVY1Ejrp5JKmoD4	127
6431	2vbHHyL1EaVK8biE49kzNQqDBgPMFSeQSCg6QXXSfvZqhHeNKqKt	127
6432	2vbYfvNeAScJVWyww7uzgRyUbZTYdKnaigWBE8BjmupTig8ygU27	127
6435	2vaPr4Vaz9dZHY1ruNHVJThUpUXjwPgSTzZ9jnL2eUyvFK4wzfih	127
6437	2vbYzbQvgEWEBwZu72RpiyhSsZif7XAyLyh4nZwtXYfzWEZu7gWm	127
6447	2vabpCz38ZpNQ1SKkRMRi6MbXNSDtviqVGBUxhSuhV1oB63jg36s	127
6448	2vagMF4c9CVXX9agrYUoAQbj1h3aGy3mA2L6XHLhrG7jPmotzNYS	127
6453	2vbRm3AzooTj3tWb22obKFmCBjkMDgStEatVuZZNRmK8YoyuXuTY	127
6456	2vb3JA6viyoQCryqemEc21zQf2RV5V26QQ6tsdXVyNWB21Feuhr9	127
6458	2vbDR9gedJnxa1MKaeHJzGi2MRfFZngRrXFtRfmvUwX11Cp8rLak	127
6462	2vaeyofWsmmYb6wCtCQcLTmw9YfRVEZYMJviFef7h6X26HWBme2m	123
6469	2vbumLY12X8eK8JPxaxf6d5vPiNLAM2hC6LrnxHCaR2UrwDu42H9	127
6473	2vbfgckS58AtKNZ8NbpDT6UV4M6JkkpsuhPaqFqJh5RsNbpaLuEk	127
6476	2vaFna3JAu3spc9qNhcG9RAPskJEBJqWvAVxJ8x4YmLYCN1emBBM	127
6478	2vaSEdajjy2mZX7w5kAEQrreNqE9uBoX57XGyyeaobTB2F3niYdn	127
6481	2vbKBwRYVMELeVMZekAEUN9dJbxzKYNGAK2B9Vm7pDaLFxT5fm8G	127
6490	2vb2qtr2KenRMsE9PBf1atw7omCuCUDZu2Eqr6Yhvag46WMTkMSQ	127
6493	2vbYr67RSx64mgVnSuKfzCRBpmWEaWbiAhExpuFr7dnndiU4QkjZ	127
6498	2vbidgphTAkzxAkh4E31x1SkDz4y8ziLtUa9S4QbQrKrWJFsb54T	127
6500	2vbPaWBS93kXvKoQoSfcn4apNZka6CJTm45ck7A1Us3GTWP2Fh3V	127
6503	2vbf83BU1XjhcwMzAcnD7gJwnXKCsBUA9ck9wufRTv28y4YNmLP9	127
6507	2vaJUh7PDug74f1Shg5EZi5zpaeDYXg5Vq6fjEVa4CS3MPvavr1h	127
6509	2vbAoExsBVhrBc76Pdcwac7V4NjFJW6SbXzT2fT7Ud39ogVmJCMg	127
6512	2varqwPHomFT3aGDhU6UFmCYX3pFFEpSRuxXrRyc1yhRGwc7u7mk	127
6515	2vbXUhKi2C1GREzhVYb3Eznw8FpZrH9wq5bXYRuQG1qXKFgFQiUo	127
6517	2vaujiqFpwsRV8CnKgSKscVuYAm3am1t9TDrDgGpRxgNFsxd3N9A	127
6522	2vayZbdnMbF4tsqdqdbGTppwGoyT2pg63x9j6BdBZhdKt46HbvyD	127
6525	2vbeSgGioAAac44rRfXQpKNdDpgH9NmZvbh49TgF6qNRZs9TeKnB	127
6531	2vb7113DbJkzqHBHpKMP6xnSKvyvTjWGMHJJ7QQ2VQqneFeL7vAJ	127
6532	2vaWfadx2Txn68LDVCHYKeMW1WRubS472CijDcGnKEVAS9YQE6Kt	127
6536	2vbL5Jo1DKevmrAGH3vHBDygEkR8cmSkKhEMMThaSQ1sKbzkH8uj	127
6543	2vakgqgv9KGsLcEGGqvZj9219DaLrjfG7unE2QvJDVDiC4eJGYmt	127
6547	2vc1yBvGhdKvkBQz547ESCSB3JH4EV33vLAzy87qha4zpN6R2id4	127
6552	2vbP3jw9SQot67DKX35gkdmCgkNeEMBzjUmSMLc5q7jS3WGRh3kW	127
6554	2vato2LZrHv7mgj5kr2UYXitYxRTBRrCwH8FnAcqqi9W1mTdWcsA	127
6556	2vb4wScB9zjXycz2Mswp2VqzGiRyqfjF1P4ZKWhq43kuygn86XGh	126
6566	2vbknndv2vuZauN1qjK8nyioPYwgRhNpwm8UyuA2vqexdr7baSs4	127
6567	2vbS3T2RBBRQVo1PUiBAcjzCBHw29aW7ZwgBMyoswgG5VgqpKQ6T	127
6569	2vboAcLYru4yzgg8VHJjVuwx9AHqK26nJFia1o9sWUExES3HybDo	127
6557	2vaKxSRzwrWNWm7avzQjHEEd1PKDidKiGaarTGXbK9V8SaFWVJia	127
6559	2vavvwcdfmc3jVaHA5Jn5MfNbzDqWJow1MWTrUnQaSy9SJMoBhW1	127
6561	2vbvbMFijZmECGwTrrG2wGd1u6FshkSDgJnN1U3LC7Xt1FzV7v4v	127
6563	2vbGExdPrVrGigbp7mEwxsjieXJhnw9JuqJiHZ99shFiUr8E3h4P	127
6570	2vaM45A1C6nwXwUptaCswmLT2nVzdkURTgPN5ja2Pf4yqqVck5Zi	127
6575	2vbMcin4xVMS5NNNLSZ2AZij2Y5eSuDet2vgoNG4yP1a3zUnxHW8	127
6578	2vaMgKN7KMXkCgejt5q6tXWwTWwPoH1b3CTJTEcAJyvvCJhJhrGM	127
6581	2vb7EetdMkFGzGCC5ssYEG6SdYUfS92MEoFDRBNRVnNZ88HmeLaV	127
6583	2vbw3hJMHHEka4Cu73w8hAoTyswis3Lb1hjXzQtmRdX74cW83y56	127
6585	2vbMFdhAfHoCjYSC3PyPihsZrPegv2c2x11yjgCg9hSRWb83hE9m	127
6587	2vbonNxjZPA1siao5vLUnRQ2t4LMQ3qpCAXr3uUHvim27XRXbWUY	127
6588	2vai85xT87SWdY7vsCorcg4h17tU8ac8suQFaeaUf1FHgp2raGnT	127
6589	2vbGyMdUH7msFoBXobsou27vNJbey48Q3zQfHjvSAABqzYU7frRv	127
6599	2vaCiKBCpzmXpMmv9S6vLRneqkhD92Xd6Cmxt7qPfvLFmGUCZhRA	127
6602	2vb4uhmQyJSpdoWXrjN2yoijDbrs2CAgvXSGEip5dFUvJtaLc3f6	127
6604	2vaMnqrzcXEBN2Y7VZG1As5M24Hz438JjXinVg93pgZ8RqxsdMQe	127
6606	2vaZVjoFoXJkMkTFHh3dxM58YrohkU6ktLok2Biko3XtAdfy6Bow	127
6612	2vaaisBRgUVENKxbzVBsAuG6uHk39i5ZpmpHdii4YDmKFKa2aNxD	127
6615	2vaouYJAf9cwBcK2ckR6245ifnmXfN5MUeTXKCvAD4LVXjUCKeQR	127
6624	2vaECgR3GiQ22jXruXF45F7RnXESVbbrcno8NF6dbCZhq6rHSMD5	127
6628	2vbwRxfG6MJA2sMk1DHuUFHEgsJTFu44QKq1DbBdX59jx99Ch3F6	127
6629	2vbGzHPxi8v9dhvaQDvwdmt5ReV1tPBvjXXk33mUzDZw8izcFp9D	127
6634	2vbSZyHQJTr7fLyx5n9Jooiik4xiYatTPSAEJGDAMt67VYtmrJUB	127
6639	2vaAkdEmVwru39V264g86dv5vfqHbgf3C72qrpdD5TwPiuHeKdGT	127
6644	2vaANY6yLc77QGmCiPg1KNsj1xFnbcMDuaj8zABEnMQuypGrDMQQ	127
6647	2vbH4dAjj2QgasUVxfhhssZQ4xTnYuGrRwQL9Wt9dEcDpp5ZdS9g	127
6652	2vb7baGjAwAyvyKUyzNXgzrSAwdJgoMwCss3rsyPxCEmVgPn6s49	127
6656	2vbLd4rje8qn9TCM9Ct4nUwWtkZC3jhzUqcFHr4kHrYMcp2sTVLQ	127
6657	2vaQDpwH9PZpcpmYuRaDrti2MEteB6scv74MRz2b95SDxpJFHueN	127
6662	2vb6ZUA1iCvA57qRZVzyfEC2G6V2KRbJEdKyFMoPbzNx6RyRRJb8	127
6667	2vbJ2ST3FDsM25QTuQc6HaaL4MnMrVnWxaBjfYbtzrodtH5NPRVS	127
6673	2vaHNUGpJHKE9Jyg3ivooT7z4m8tPXvf4xYgieHQ8ZRKAVhaj7PV	127
6674	2vadipf9PohCxoaBs9neFoSwz8tfHKrNsYWH61X6MMwcAKxwTpqa	127
6679	2vb5XCd2D7Q4w88KXWPwWPHMZX5JRiDhXDToLzKhGaDUeVgNhu7z	127
6684	2vboK1B9ougBFnDh9h7m6R2jC1MGe42w7HnkSfysrLNHCAhvakZi	127
6685	2vbXUJrb6G2rjD513UVqGnR33BvNPF7yYLM4hWq3aAdVQ7R1s6x8	127
6691	2vbGWQZfgTkHFrPi2BgVQJTyi7kRZtL2zPxHvEk4QaHfsEZp85p5	127
6695	2vb3zhPCnCMp4JoHXZHfEHFrRbY69NewbvXzUSTXuA4H8X6CRHw9	127
6696	2vc3EHX6GM1CFaNRk4qjrkScafgyCWsPkgKb872LcPfq3LmBgsor	127
6700	2vbqxiKjFokmcpF73urveJVDH9mz9b5z5DJSoeZYpUXBLg1G2o8L	124
6701	2vaTHTmEikjisDyJ2L3WahoTLgHRpZTGisNRBme7cEwkgmrVEPdb	127
6702	2vc4cR3ZGd2yjkzcoeZj2ZqruHcFfaDFsxmMU2AgGNHUsej1Awy5	127
6709	2vavz7L7JyBva5BwjUKwZh3MyeCi8DFCSzdXRbc7YoDJT9qrsVbm	127
6713	2vaeMd9shfnQfDUY9s7qTrmsx6PZKMe3SWM4snvcrVNbGfvbfa7a	127
6714	2vbgrVcA6Df26ekn5Rj99tYvipEN4Psp9oGSVNihsghc3HK5UKRX	127
6719	2vaKH5VzQVUdk9Xb3R5QLyJSWZHDLWAHFivpUBh78ZMUK8o8YyH2	127
6724	2vbmp56QSQTekBUqGFu3mj28uxc9SmDqoRHtcfSww2XCPXzcfpfS	127
6725	2vaxdFmDD2Vh4zhW9VZjUvPAURCKxKzjWr223ArcXrfFgoDQehiT	127
6726	2vaHnqqRasi7JXsBAQXWkng68vGeqWsEyX79eiPL6Zp263cPUFNT	127
6727	2vaAsp86yyeb82Zokk4WSTbMbPE1FMrHEudUB1Nk9zQMJtNTri8n	127
6729	2vaSraVchX2YmmsX4QnQ6nD1pAc9WjyWKeDThzPUY6ys9RZ2f4Dv	127
6732	2vbwukE5cHveqBPZyUHLJ621KJokpwpCxBi9aMwVqNsGB9ZUVfqc	127
6733	2vakPucys6ymUWRQN5e14UtHg3rUkDmASJjkRWzstAq1vRk62ki3	127
6739	2vaNkaon8ru94GTLzE3Zyo9NeUHe1o3RnVBLC4eMuso9pwp8eN1p	127
6745	2vbqAVhLyqqpRVcSmaUx9CDWWsw6khU6mG7PovPkA2d2HhaGfjFQ	127
6753	2vb6JmVLhYF476bY4hfKsB9i8v9CLQTzH2EgaBdwQ7NPPiJivERD	127
6757	2vaP5GBYH1wD9AGTEVvrNiVAsbCeqTYhsf7yxvmVkAvpqAr5PuKP	127
6760	2vaAnFYiAmKU2LpFWEW3fCp3DVcKvPmoHqTCpVoG8utRzSgRzteP	127
6765	2vbod4bUcHYpwfZhC2vDGMWKxy528ZEcwbqtKp6pB8DeQ9NqRfhA	127
6771	2vbXQFwuyVYAncWJhPEcsnTwaUG11LCMsMpK9Stj9hPUHvzA2dGT	127
6778	2vazhyNL74UqSmuMc57sh9GY8cGD4WUjrUC7sAAiGjxyjRvey8wa	127
6779	2vb2mD2uaeXHsB6bkK82SpxpoQWQjRG4ve2bJKcEYMTE3Xw8Vpam	127
6781	2vaXP79danKZaC7fCPq4J545CZHPEEvzDWYkHf9bWYBxKaLxymaN	127
6782	2vbTbqujb9oe7K5CimBBe6JZxouDKQEAyrTvfvU53PZmtc6vAdC9	127
6790	2vbZBZaQXZ7N25KJrabTHhKSXu8Xe9dt2u5j3mWFDyYdPxYRSZYk	127
6791	2vbB9GwbMN1GEgkBV17pTJwMMhhbT4txocSVXaDSKkAp6uKReyHk	127
6794	2vbXsyBxh66LaUYG1KD7VFeNY15EfPnk66WzVy3ve68xjTwryiRU	127
6804	2vaeFpbtQaSgiryxzSvoptUmezLWT1Jojk64WTaNUSiijRmX7zES	127
6805	2vbWj8xQyximhoZgH225X8YJWDndS9tVBMo4QgYWPrK3HR3vYYA1	127
6810	2vbxQ344aae7q9TZ7ZnbcQnzDQssAUd4gMxRdEy95wZzryPmiPk2	127
6816	2vaTzQwCheWYGYVBMFZ3Tt8RisKRvPbbm9hX4GVC62Pfp193DDhP	127
6824	2vatR46tskQPS6ijtxw8dWgD3rspMnoTtbawUNkmwL9TyGv44VVN	127
6829	2vc3mFsovNTFAuxJtuCdueRwdnYeCKvLvKsCmdQFv6sPDMNGGw5Z	127
6845	2vatRGNpGhtFTZTRn3n2u6qFPDwZ8tAgvGeaZs6ggwk5ZGLEbtby	127
6572	2vaZGNMD6HvFpT5CqV5rwCvJbNkY6WwxUtZ6YBAsi65KSYQxPXfc	127
6577	2vbXrj9deLiWWNARKyn2CcvSoqQ7U9c6DzVHAhU5YCWKuUXQ1x22	127
6580	2vb39UMVWqcBpWZqUioJVFL87iXzsEkQ2YzMdV8qCyqENP9T2JDQ	127
6591	2vaThpADJv9CSaxjhRfayeSnQ3sZNSMNZCfbfaxAw7qy7kvBJei8	127
6594	2vaCvTns6Yh3sDSdZZAkc7Bh84jQnhR6x48gzCZX1s8rwnGsbmRv	127
6598	2vaNn3S6kv8koGZm7y3C2oG16dBDaJpHB8FmMKNhfm5JDuHdBuje	127
6601	2vc2xwsamBhYiNRc5TvM9axZyp11UUiieu5mGJpb3iNLNwM79Vwu	127
6603	2vaX7ZaAaD4Cdsz2PH1TXY9hu1pa1PLCSy5meTdTmTQqSEoi2AFA	127
6608	2vaMfvofZRyYfANeDV1ZLrz9d7D1n64KFGWKEQx7qbewWK8ASVFc	127
6611	2vaS81BXgthzcTxQanM3smmiuQDWvx8Dzi2mhfiEjDQPku3myVW8	127
6614	2vbSMXM7GjnyCF4DtC9Ev6LaUDuNSoGDsiqu7G5ZRXyxiRDfkjet	127
6617	2vb9fvSZFYRQm6aBTJiDaYuj6Wju2Yyn5Xxic533StiEHkh6MmGL	127
6618	2vaetyw8ewfjZwHSaQEYGP4vfctW1HVc9onHhBCFTT63N5YJurA3	127
6621	2va9ttsQeCzaqUUcFasN7S1MeygPBoWX1ASUo139kJXa9EmhR71S	127
6623	2vbNMECiPNurd8mXYRKBNBuga3baLugVCzLV3oLqkZ5jED7sp73o	124
6627	2vacTJmaVGaM7SRm8jf2kkAwT5mgGhHMxjAHLtLnALsL7gkha4ms	124
6632	2vawxgixJJLs5P7rffcArezphrTquTc5RG3sMeFce6VmcnGBV76g	127
6633	2vboKSekBKXtNUkVL8YfuxtAKsUymS7Np1xHd8fbwXmJVxMopKtt	127
6637	2vaCApBBUceuyXvMzcJwDr2F7HeU5i3AyNed2n7oDUmH7eGxjjTZ	127
6638	2vbpksPkvDVqaB9rRyd681iMzDMMtHHqZLh1B3pwa3TWtR4ez4BW	127
6643	2vbtWL9VZduAizVcYc1qkNaVuzjj3sAF1wBX6cJx1PQf65BguSzA	127
6648	2vaLjL65aukXFNwFPspwTecyECR5vp6SET7FA4k84xFvAuFseKpL	127
6649	2vbxzZ6ei7885aBqyyZS15Ps65AnRqyHoptvTGax64uB2bV5vZfK	127
6653	2vapkMcUkLNYvTZKG4T2uTjAWLyy1XjXNQ5vetJSqUjX8Ug13CH2	127
6658	2vapGwzE5F1gxPQ2PC9gdFSrzmopULkTa5qCVVw9nuE2RsToxTj8	127
6663	2vbULthNXXB3Kb5cb3EMvSHxuMTnajWTeZHYSX6VR7ps6p2pJFqD	127
6664	2vb1E4v7bzMdP5BtzmBxt1WP4kGjjQak4NR6oH13vfgKXUu98A3p	127
6668	2vakvh3zxoprYoPmGmvaCustTiGXzptXQtokE8hU6WBtRLN9cXHM	127
6669	2vbmBMpaNCj39qPTXwGoCeCzcbH78fcnaTgFZ9vuvCtVkQkv9wWk	127
6675	2vbfaB6pNLvmw31ULKyi8Ea9HYcVtvKZix2uGSR6bgr4nrE9Q6Ad	127
6680	2vc1z3PSDrS5UrQJCa2N5nvRLJF7i2aSCu9GBogQHwH6jGHcCkmf	127
6681	2vbJgGWiho54U51qat38K3qnnpC5FPA3iag6K9P317mPczrBVCm5	127
6686	2vaNi63hd13f9KGg69h1MKfuddsKArHDZQn64uQz14KNPtEKSdSo	127
6692	2vaB8MUrh1VphCHmWsLXMgVaacGSJeHutJo5ShomXX9nb4gSMnTj	127
6697	2vaWEojaghE5RCe4fsdcboDqy24djJoKhFk4UrEfQ62WcAUCZi7z	127
6703	2vbgsALhqR22rDt1iTSfwsVVsF1N5r4qzquQsjzQDAkWxEzp3NaZ	127
6710	2vbbMjaL7PNt2yw8rBkCisLu28GpXUHmrbHs9GqDR5NvC5DXwfJp	127
6715	2vbwaEYVec4HsCQyKEZbYBww9jfacnVMAPHQuEFsUDMDF6NjXVXT	127
6720	2vbY9czoo9WDKsW5h6uSb8DdVx2mDTiL7Zf69K3cT9Jap66zXejz	127
6734	2vb7oCPzRVGLcJP7g2uq3Jgp8LLRi2byq5ReHZX3sq2gYfDpXC33	127
6735	2vaMDfokyd1NFaQ8EVKYDA9BK65HGgpM1dmWg2eYMzCL7Du4g6c9	127
6740	2vbn1J8bbq8E2G46cgwu9F5ZLbZ7WD8GEupsocgrCLtxYb9NFmBJ	127
6746	2vae55YDAMN3K9CHFshNkPHCCSZpaF67wdF65eVRM13GN3nRNrEi	127
6747	2vbXcBsWwvR5mAhJq8oazig8YiJQEdRcBHQg8n2vyraaEyHPoHnE	127
6759	2vc5BAPum2PJofYs7zRCHCqHT2k3M9zbuekWXBsigvjwMGXDJAWF	127
6762	2vbsU9uEWTLEyXGN8LaPdzV7LRpSyMYT3FXkzKRFBmahEL8taLhA	127
6768	2vbxhyJukM2bPT8RTogNnHojPzZAghNi7mqFu7pQwTVU9Ug3jZ59	127
6769	2vaR5cFeFwehp4nmZ9ijVTemKjnr7kjJyb4tkzEqwCGBA4WpmCge	127
6775	2vaqjgxdK3kfrVEMRXBYbo9ZQwEQ7ZZ836wwxciuNpZMg5uz6Dxc	127
6780	2vbWJndr25e5iVCzsVXsmxECbZDg7yPtYhGAdRj8xphzg6Ez5fTD	127
6785	2vc2EpkUoxgejgM5MDFURGNySHtFejk3UkjThpBfB5WXxNJEDR1S	127
6797	2vafZKieUw2LCgXKVouJSMVWmYm9zLDAs9hrbWWDc8tWvxNV4Gmy	127
6802	2vbR4fT5XwxgsD6TBc3nEGGn89qqm6Qzp1BFZBoGPEYSEUv55Ggw	127
6808	2vaBvyDiLVPDgNhTFhA6oUW1YaLDU3ZU62ZBBRWUSeiZtbzsEuMK	127
6814	2vaoqWqJ11doX4wmymMsEvo5tT2V5DXQJeUBzARYRnzfvirP6mzS	127
6819	2vabAQbh8VDsHtK4naJNu5149Qw4VBfRnttDPgcF3S5wXVnY5goH	127
6820	2vasygvnYK9bSFdyDvgoyityWb56zTsjioH136QkpZ2BDkzMG7LK	127
6822	2vbj8bKciL871zm1urmvpW3avzBdc19j515TfUffkmcEfcqz1QA4	127
6826	2vbTvGYZezYapA1nHvQ97J5mMPCoQkSTfpQsNWgdLRDNaUftFLLp	127
6832	2vaMHcctzzmtwMRy4qmeD789H7RmyjPn7D42cHUUwkmFrQqknoEq	127
6833	2vc5drjQrPEsvDEh3jJd7fsrSgf7MYVjHGRuMnsqE8RDLqvUR7A2	127
6839	2vbmx3RjM59hd1UV4hZirp14UnbPkZnmLhaG7DBNjb5ce9BzTLHU	127
6842	2vbFbvXLmwv3Eski3b1nNaa4PN88P1dvmq26Aog7trxXTrBwyaWv	127
6843	2vbLWB2VXXpJUCTMuTCiowekGffM3zhrVPQnTgXjffarhUb6mQxr	127
6848	2vbp5nUKXcLCTpA57FGNTRZAug6EUb6T41FPgtMT5QE5dDVejkgH	127
6593	2vaB9fiDLrfitbj7QAiM6Q25ArWXdTwNYz1UHCD24GRdAFZicv9x	127
6596	2vbxYkvHhzJrimbWWnbrat6LYzALy48Fox94cqg64uds8SsgQygv	127
6600	2vaYHayNoQRp4sGntcjfFDUx2pfjs6m8CEDQ81tmQsebPNVBWC3z	127
6605	2vbphW3xjHYzddFCCiGoCwqWcH5AKJjMeinXF6yrRsSSx1wsQJwn	127
6610	2var8B3JTX8kZBzkGMEuaQ39ua738jrDFABC9pt1vQVDmHna2N86	127
6613	2vbeH6cyFMdsxHump89U1Sok9JppvkfFXjCSCw8CwcVML2c8kvti	127
6616	2vaJC9BURE75QxMaS1VFfFLFwVmDcdnmvcxt95c3WmevVzjYT4P5	127
6620	2vbHyfQ3JxwqFqfGXxvJpAJbziQbTTQu6m4yTBfcaKEufZrxNnqA	127
6626	2vazzFWwC9sMwESAQbnL7yysPZYsVy7qfAsHzci7iJSCSu6WLFm7	124
6631	2vc2fsCMk8vNA1QYbs5a26BaGTNFS2pAuSXcXLKghfkc9MkHYyj4	127
6636	2vajSDPBwwGt1zDdbUK65QiB1KeFeFa3TAWeQBJ7fWbkiPcpJMze	127
6642	2vb2GTkBZR6est5DKiackRXwUtp1ejTPNm2a6bDWo5pMGitk5NpC	127
6645	2vbajfYKtLJUqxBJ9KpHfK55by6aBkBQGcwNZYRris1h6zmkQxZo	127
6650	2vbWP2Qo7AgiaAebJteEQ3b4qBwUacuCc38JhGeWgu1ZhKwEByEc	127
6654	2vb1Lnfc36igipucLYeQfPXwXiY7oHXwchCR8EcKQBvkdDuYvfwJ	127
6655	2vaoY3xGjnSj1HCPVSUDg39sKzeW44fs1h9D1Vc9XRsEbKpXNZVg	127
6659	2vaLwCaQmEz3cmhpMFBeLfiDJ3xt4u48Tq9oLGaczR2SqWuEV23c	127
6660	2vb3tcqpaMXVPCcmcfwd7mYkZFLpPkiTQWSsduapyqFGCDGmMA2L	127
6670	2vaxQkKE7QhTs4SYTTvQEFfVAUYmmEAJk6EWEf4NaV8KNBRtFzc1	127
6671	2vb2ECggKrf5Fn1MHJkNefyw1ipdi3dniKohR8ZS7wi6m5BNBe9t	127
6676	2vbix6gF1MRiFArPWsE6nmcwnuWBr9RWDRirxDY58KbF91zgrmt3	127
6682	2vaiyKZx6uDrWn61f2V8ExoMLh45TmvxnUXmVfxKwvzdKEQ6DBkb	127
6687	2vaxRLPeb3nG9cHWR8esN3gzvZogqoPSiHxcTCi74J21ZjMnskA3	127
6693	2vbT9qQpGwi5mZeCnwwP3cQd7fKy2wGvqt1MN2SncZRq4fdb2UC6	127
6698	2vapC8oS8ENxuGfUQnpU8UGqKAPgkYcgWjE6KcgPsHQAy73kaD7A	127
6704	2vb86XCE1obyh18xsXzDJ8m3pNfsWfFka9i7QX235z4V6jBsBEX4	127
6711	2vbS9aQuWDfRpDEMvGxBGJSXUBfhZnrGg1w2zUkb8XHmC9Fit758	127
6716	2vaPuosRSFxMns9k4rXzMyQAhFjebhd4y1F6bDMZYfWF2P6LoiTG	127
6721	2vbHLjZrHJLH56X16JakPBDxWKmi9oVAeuBwWDhkUttZZj6GFQcR	127
6722	2vbKDXJevyy2THxpk2JDpHEJyCyGCeHmrSCMFN1aH79MATEBSBvU	127
6730	2vafyaRjXz7WgG9rTCj1iD6gS7RreG5ZoP6a5b7mQdvUPRmTq2J2	127
6736	2vbPMN4QSiM3qDJc3nwU9Ks9g6xpfkBhefuf3Fhwq8ABvgorWGJf	127
6741	2vagzgihJPHPBKiqtak45GGNyGQvYwjij23y7YMkEZQpUCv9K1kZ	127
6742	2vaZSW9o24V32XSBVSoXrcX328Kpg9uvAivABdaXRMrDEuRV5sXT	127
6748	2vbPTB5GUGjXk5H1RiLJUz9S5WPLRW2vemi9RxwqQScde2tfyPZs	127
6749	2vc33wcfCy1bfrAXZFn9Y6jq3DP51K9fR8U2BfmUA6NVgEN2YvB1	127
6754	2vaE9FVRVjvKr3EhQyMsEqY4w8k9xW59UrsMbC1VVWCjgzwKJLit	127
6756	2vaeSaMCQrW3Pc8sVgp1W1syFB6LtG8edACsjbRSPEeMNgDpPABX	127
6758	2vadVXZfS6Mg3LU7GpNkpjEJpB8uC8dyZcmgdzqwjipkBFwqxY9v	127
6761	2vacnAp2JCTa4MsWxH74X28QB4VLBBpnyruEtbVAxCTUraDiyJiu	127
6766	2vbjzzfMDwU7ee2aJdTPy7dXVmHPdTGaC9EB7Ek48sBHjpZCbGDf	127
6767	2vbPAukAHBEbbFF4UkerJyDkjVXyR1YAKk1MuQv4oLNdgQFCNxzr	127
6772	2vbBM6EMFH4EfRzwUCp6sH8AZbBmzti8UvLkWugdFVCarGASN44B	127
6773	2vbM96i8BbFan9dwMAKqVtAgQZcXAn3HErWmoV8pxmQBX8Kkc14Q	127
6774	2vad8fWEKLSCmVJMJKCBDE1ifFrHFsLjpHHdgp2b6tdRvTpPrd1K	127
6783	2vafJbpAmmvtrCMYMwUFuVWhoyPTZNb39NxtCRzMN4MhQUVnM9ZN	127
6784	2vbiwYEiFja2GSrPyUELpJ5NZ3b1aQEKYqKQUPDpsca9QMYAYVtx	127
6792	2vbV5L6j2VvVJFV2tWKUXDTWLBFuTAZGUNg7vuf16wcoZmY8d5Lu	127
6795	2vaHvDmet8zoCtcdbqB1dKN3fybD8FPdn14RPZvBL55dSKyHKi7G	127
6796	2vbjuQCJitgyZWp2W1UEF8gCwL1PhGYhCyaFtP4LiyYi4qapi2nV	127
6806	2vbVSfJJvkGuSZBiAq7gZQuCh1YeSXrMzJRaqf2abdgKyntu8PT5	127
6807	2vb1gF8ZuNHUhae6pE7ZKcVctszdmiPu5BQeWCNhUMhqLNPw95SH	127
6811	2vc4v3vKZtoA3fiNRrRZXgNRVDfYyd5mgDChLpEvvp3jg66Sgccb	127
6812	2vadetvDGbwRDZ5ij47xgBaqBrV4uWvaxyprhZXbBFkSddW9eMsB	127
6813	2vbnVi7qajgbjrZAGN2zytXwMN9RC9fS3TEbkVedMeTstxS6ft5i	127
6817	2vadVFEmEroYQfWRV1t7t6TthpR56r2g4cV7LUnGJuwM4FbT1Y6r	127
6818	2vaxFZTh9x3zFh24deSsYnVg1aSWrDpUHc3TeGmpD4JNW9CPNqky	127
6825	2vantnRLRzfkwwugkyxJgRSVFadRUyaozuk4V8evheZfvskchWG2	127
6830	2vbXoHRSfA7vtzNh7QgfmY1QH6mkv3StN6rkfYRFaGUD6dPTVMgz	127
6831	2vbT9g17opRzCNpRQvt8xyiJk1MTsZPjVHiYVFYSDgmgWaFPECMP	127
6835	2vahfVbqwoyvDsxEbnS9xYJocLGKVyoLFq9tcVfyE5kezK15uW7x	127
6837	2var9ThojD9EFxWEQwnQEADWx9k19WDpBt6TLo3ZVNYDc435rSb5	127
6838	2vbZ7SGvheKyRcwph6BDaCaX9cySXqLnN7rTZ5h8reLGjerHBNfV	127
6840	2vaNP2Cq41AyDG4TSYecV4dvwRtqxugsJ5tzLjkQdvtqbrF5RuTT	127
6841	2vbmapo5qZTsHMH5HSnk8ZeuAWjEpa9TGtazdZKZKnLgAoZ9BVB1	127
6846	2vbgKRMDmW8PbKeCzUXapy3Fy65NHibxLwAp43byHaevzvA7Fhps	127
6847	2vbnKQ84QJnYyWeHEJHGX6jm9inuv3asX8WAMHXhjDVnNf8ZL3XY	127
6625	2vbdfm5yCvMGgopsTuEQA3JMfSA7yHpLspUFPwrJm87KL2UQs5S7	127
6630	2vbKbUiXX5wYd79PxJd3shpve4VnTPHM7VTvjKgJzGdGQ7L1ULBo	127
6635	2vaB1zH2vwUSJT7fBW2L3gqUAa85zZS2kUtsD5znnNfRTKRs7DSR	127
6640	2vadXhfodPj4HiX62wfETQ7k3PkHwJGurkgqJirxp6EMX6WRbxUD	127
6641	2vbK91k1vgFs4wdKz1yWyTH1ftoshp8mysny5VaRNynQ6yo45u5t	127
6646	2vaQ3NChY3xpFTd9BhxfmGZRGRAVfarvMMQc2VhW63XYefbs4cJP	127
6651	2vaUkr6rJEdjUNuVDRHGWSzFDEVmNLLHop1ZPAkr2Usqkb8cXfza	127
6661	2vb71T6MKDpRe96kwNrQSwPge4iKS1dSzTsR2HGDe8uaKeU2dy6k	127
6665	2va9T942guuXwFSrbyfPxG6QZab7QmXs5Zq6zSH3FJP9SraSftyW	127
6666	2vaoje64sDGWFiZRLv3KZi3jk3V1eVvA4EZSHJAzDUaCjQxrCvGd	127
6672	2vboVRrGWHjWiovwyax95KVC9sjzJwoSn3nbHK3TU5acKxjUdusy	127
6677	2vbSL5J8SP9dXCyhqBvVJ8sK8JPEq5dLfrB9yXV4SgqtgUBy18nH	127
6678	2vbd1ijHWPRr3xt9PtfuY97hZ6BATtyWvbm1ExBMfZnvyCwmgDVN	127
6683	2vaz4FcVVNYXTX9gT6MSrYy8bc4CUTFEYVYspeiz42QreTyS6yFc	127
6688	2vbPSuxUZDQWhxupnMHvDaTBVnhaPDu7Yb5PJKWNBusaD5Tx8Z81	127
6689	2vbuNDkFj9ibsfGSNgGWdmfewHLBAj9akwdRbZdMzfVEAejBAHnX	127
6690	2vbbybeXhvo5kFAjkXm3666VHAQHseFt1dFAdUR3vK68WyGA56h5	127
6694	2vbbiJoDShb4P48yemVBSQTKYLQ3HZu3S36b6X5kWTexLvmWoFR4	127
6699	2vangKGpbHe64KFi9kKNge7GGwrh4pdNskUU3Sf94ow2JPb2RQgj	127
6705	2vbygbnrNwYBUyCC32Jfj2oBpCzYm2XLymnhTSFAfQ1KpNQnTCzJ	127
6706	2vbzEJVjfWYGMdmhfGfQjr4pDgaaBrQss5KjYWx3Aa4P6Bbugz3g	127
6707	2vbfE9aSsWGULGXwd9tD6wrgqTGeuiTX4PzmcAiRRqKuSsRFk7tn	123
6708	2vbHvDjy4DPHrL7bZew9SNLqNvHRz3E7WopLmqMtauWB4Mx75e2j	127
6712	2vaugf3qY2sXqiFqDaZA4oqXMkpw52nbvBLvWQZVHvvbhLibdh2R	127
6717	2vatpjeGySE69mfRnKhjoQFP3BbCtqrMNHQy4HvNpeRKHZBEBH7h	127
6718	2vbERvun4QV6QEyryQRRjQAWQj4jZsSdxPTJgtDfTwMytyTp1Nuv	127
6723	2vbSpYn4p7nh3F1iPhaoseRbKPcDGvDPiCnFdbCSPPAv2ZmB1F2x	127
6728	2vbqw83TBcBHCfAEw4nhYWp4Ks9jXyTJVR9Vk3R6CnK6MyfvtpPt	124
6731	2vbWDMN79Q6TQbRvHYBgbwVGmycxnq39VZEizfToBeRouckJPGQb	127
6737	2vbZ555W16bCQoZ5ZmxUrV8XrZErrp5H8qB59XCHCSVWJVv5HkFH	127
6738	2vbRdQgdh4gfDy9QsZMBJxwT4KEwFPNGrsodcUvXvgn74XFBhhoi	127
6743	2vby8inA8w6v3hqKDxMamoFDcaKy3hopsuAijhF6s8CZpEQVdw8X	127
6744	2vb1J3o3Gvqs6hocuT7TRLZDrT612Ac1BUnQC4DrG6X22pcCpEx8	127
6750	2vbQ3zFxhfXUxSMwoSigeu4mUJENs9L8wm4CbwDTXt1Tob3bUNuq	127
6751	2vaUuGe7KkWJ1MoygJPGyX9ripuMQaU19H2LwwtfhwMmAh14Edwe	127
6752	2vbZSteTcAb895Q1PMtLTexxRmzHEqHY6jjXX4ksG13WNj2oSCaX	127
6755	2vbuLcnu93of6ZzyH8sc3U6yTW6QfrSCRVBbSeYN6jvmiLN6kZHK	127
6763	2vaCvyqQR31frcbF7HXuU3BiMxiTBXnA2oLaiSene2SjzsA5Boux	127
6764	2vbHLe8e3raASm4p6bg1jGPM3u2FJKZjXz36s5bQ5ezRXCLRmdi6	127
6770	2vb8wCnDN6nwBfbenCTticVuft33nMjjF7WXWyjHMiscGh8ywLgE	127
6776	2vbqZdY6dsEp7t5zMfkR8WJNe3gdUfi44oSW6KmffTh9YMxuNQZ7	127
6777	2vapbCkDQMG4E2xwHqGu671T2g39Qg2ScgoiHLb37YCnWsRSBZdD	127
6786	2vbXE2pVDxogfb5y84DCEziWQBCm7hRrHCicQ2AVBhgL1Zophzt9	127
6787	2vaa7j3LCt3upmDUgMFvYqeyDavSiDiE3iDkBVuEVSSpfKJRfUi8	127
6788	2vbCTx2nCtjR5ZthYke27VxipLx8pSw2Kt4jBdWFu4m5RUX5rNar	127
6789	2vaCCJMVbYegM5UNboce378NgYGHBaZd14PD27yUZ7uoNvtWt7sM	127
6793	2vaF3Hm3PwCiuyWWFdv3AXjmFptwwjqecrDNiEdaZuNHiReFSqJG	127
6798	2vac9Ki7Kb75LQQWXWqHiX5Z5FTyFRknmNc42BHarUZZDohRXGWT	127
6799	2vbqSunfpPTgpCJ1yVBN7JSCvsKEETqGFj1hftRcng8NbZFYZCDP	127
6800	2vbPftWkze89j99BneLmmX71dtQuFYcKWRswKpDGDfxW8FWZy989	127
6801	2vbzV7XTAfnmxuLFuX6CvaPooA4iYmzVv6KbktHHgB1bkr8BPdEY	127
6803	2vaN9Jgo6cJMjJErKNMCr6c3oxXuTrwMXpZxrHhtP3jVyJZozNVx	127
6809	2vaL3z3zK2XDnFb6Q4J789PUZRxPSWZp9F8cyqJiXY17atcD46Bq	127
6815	2vbh92vAC5kjd9tmfVzem4Mt5s4fJ7cAxbcC5Z4C9BHpvydtEtTU	127
6821	2vb87pnhayvoYkm7ZZTRWreZkqcfBUKq9bs3yh2eAVi2ABV9Bhi8	127
6823	2vbwVgHYtd6pruT5TW8ce1EDagU1nW62ouD456mGU94d2LTbKX9Z	127
6827	2vauX6VmbKQfHjsvqfcefL3bpSJZh8tvRhf4mFpCFyHVFNMAJX2q	127
6828	2vbbhEXM2AiJ6RMANaP1zWov4kBDjSSwr1mtBqoHN2wV1GfGcsfW	127
6834	2vbfhGW6TNaSHsevDSrtth1BUkoZ7QJ7xUWrCMpJwD4xTWUV96sU	127
6836	2vbmcMBrjQEUY2bdeYmVmqXNeWwCFp5oU3piE2pY8NsDdy2e4JJL	127
6844	2vbdbjK4kg2av3mDpeNfyue6XYg1rqY3YkSPcKnJ4DbTWu77EDce	127
6849	2vc2pmqwkDrB4F1AarguXwWXQxoNWnYf2jwsd3qFtEgE5aZDdcTx	127
6850	2vbR12qDWJRpbDZ3voPi3CkBBuWL8REqbJmJxh21voieXPG7TNnq	127
6851	2vaGBB2AqBgCAzyNj18nYjBGvY1kzXscxqTPzkPdbYgyUwnotHgA	127
6852	2vaqhJS3AA8FY5EEYuF8uzL77vQciA1BsgsNmY5Z5xrwdZaMSbQw	127
6853	2vbWUam3noWFHn8dqZep8puQwtcKcDTJeNpxB7ExJsAQ67J28i2Z	127
6854	2vaoHie78B6sxcSAP8ugXcApr4J7V8pckzTAK8AqHKmD6YBDZ6Mp	127
6855	2vaQDfs7UmucUyfe1SynV6Fc97GpCWZftL3CB9Hm82WSz2543W4U	127
6856	2vbrTsLEdQpWqjtwdpXW7oBtCEnLHtGCPAbrBHbaoz18fNv5DCyj	127
6857	2vbq8zB99rhnY47vg8DkX6xPs3arfrRJn2yJvwV7ckmvE8Pz4vo5	127
6858	2vbNnemXwst4QWM23Xg597tant7qPt8u6yidkYn6nmd4t21qUmqi	127
6859	2vaLtHusYWKgqJ8cmSEAUbymfX5SQQNmNcGcc55qMpiK2WGkR8WP	127
6860	2vbUWbzYNQv7cxeXQK2K9CzmmVXAhwQZQ19xtaNXYuiBZrTC9SG5	127
6861	2vam3RXUEhfr3e7k1gp7fbDceeArSLmeyZKGgJ92qgyTzPMiXP2a	127
6862	2vbkXrV2Ltf57a5j1pJ5kKcaLN2o3ZbF4dspwCnR43EkXAxwGpgc	127
6863	2vad8tpwNpWE7KKNAEVyUagT1VgriHSq8RhxUuAa7eE9it8JY9am	127
6864	2vbsqX2pXLBVbn88ZXfLD9s4UqM7fi42aqZ3LgRsgfkFCx1xR5iu	127
6865	2vbjjEmbnQdzHMgGsbHcrHZANhuZVCYgT3BKoDzN7UZPDp9mkZAP	127
6866	2vbkRp6fT9kYSongAsWJGyiYAzdtMhVb9seNm35zbD4eD2gjvb5U	127
6867	2vbUWePuKbVw3TUX9F2m1kHwzdJxZ2U8PdJhcgXmXMw5FXUY8iJH	127
6868	2vbNGH1on6jXEeyXncPtqzu7B8v57KzEEWGbBoF2sqP1si8yZ9t1	127
6869	2vaoc3v7aHUTLW9QytK68r8feUaPnxGmfBM9vvuCXEF4DhUi1zm2	127
6870	2vaRyqshgBpfKgq6VdKCDQTEpReBqa89uJtMqcyBkZWmbnisa6oU	127
6871	2vaKBiUxfgqVx9UoiLoFFYtNQjYCpP466t4Ag75FAq96if7PBFjH	127
6872	2vaLo91FG5CsMkPw1Cj477VQgJKqtubEwoGbVUhHawx1iA4bnMnk	127
6873	2vc1Qn46VP4qMYEtzmqMg9ikHyFb4fPmjf4XHPmX15fQrkLsRut4	127
6874	2vc1qz7eSpqxfJntnAwW9Bzw6683T2MsLgwyrusQ6iEhi5DCxdDy	127
6875	2vbSxPKumsbuq39dYm3p2pgKxs9AjpxjXgUesFAVE7CzKGXdGHHZ	127
6876	2vaRFg8fffpbkJYZBq54cRMAJi4BPqXrJ63eKr2vkpofigPzAga4	127
6881	2vbFYfY3cTEZZs4iKoLchZoJWQ6RJVGe6nRx5faxFUzA65KLzk2q	127
6882	2vbw93hZgGNipF9uEsxUBsHAZ11EnrC7aJKwG33VxWRmAix8Q8SJ	127
6883	2vbXjEvwzVA1LNg7juys7XXBKQqEaKnck9c2HFHC3ARcaSXgTrx7	127
6885	2vc36E6caeUeQcJVKVBTxQ3PD5SwwbfAYv16d5rM7aSucqT2ZnCm	127
6886	2vaxkrn4W4jH6Cso4HDyqfxQakdJcb69A6jcYkpsdCnwMEZNq4ji	127
6894	2vakcwYiR5WfZYuZMd1Sc1k7TwiEGjXcwN6BpD7u9zTb4DFiTLY8	127
6895	2vbYanekFigGTeoTGjb225ypkXsq5ewb1ERHjtHnWhhjJFmwaKZn	127
6900	2vaynVQRDBQsjqofkTheVNuV1FNiAB5JdQ1Cs728vpqhyBd8sTo7	127
6903	2vbEVV8xgLEGmLhijCoku53UvYo958JsEct7Bwg3nhFQE2aoheXg	127
6904	2vaGs6ASXczD28gNbrd7XAHCdfVX1QwyhrjPLYy5nqu3ThrKCrGZ	127
6907	2vayhPqY98zwGv2TtHDHk7zhXtGhp2jRFrktEeB7aixSvJe8VYzo	127
6909	2vbtfm3fTs3nhBUukytyMgdiXY1xLmLSnkaarsVzUo8WW4o2NwMU	127
6915	2vaXrjRtA92VsSdt34ZS6GG7jxRLaxWsNNFHUcVavhm7WUrTfNbX	127
6919	2vbBN3m9HGgup9fEgGYU9cWjzpZGtevBqnZdSnneRRqdCYdMfZZL	127
6920	2vbLXsPHwTaaQ22HXpGLDLh9yjYiRuGftDqNuVSq5EBKpdueMxrK	127
6925	2vaLBjUXR3dxS6ey1gHfKsB1aAxsPc4EX6QTVtw2sEwSGHBh1J9g	127
6930	2vafW1TEsnNgAyEehyg91HbaBBNrMqm1tuBCvVZqZSd1SBqyJhWC	127
6939	2vaGNfhRq5VGuAWW2ras6jxec2AaoSVntTgEWQQBNdGvzUJphZsg	127
6946	2vaAPT7sHmaKUYhdubjtMepxf6F4Fd7p7qsRJZecKEd5bFeacZVF	127
6950	2vaeTPisrqvRMTR5SJR2ezYSYR8gAv87XgBbnccxeu2CJRwqYRaA	127
6953	2vbuXRGyUFg97YDuHsVVB8vvwGmyyKooJoZdnnaE7kYFuDqUEuUq	127
6956	2vaqGcoDRjwBSFrHPm4oHuGiNng5W2mTjKsKr7i76GfUBUihNH8e	127
6957	2vbMkvGK7sfzeKRc76inRyKDyoivLuepmjNTcHCf5Cg53x34GkwG	127
6964	2vaWv3f5v1mfyyadou88gPKzpntUexMPKrJGLERVYuNKXomi9hxn	127
6966	2vaDECDsNaafUNThemLt77E8HWLxfvVQKP8dfwWG67SFk79hT3bH	127
6970	2vbH1PQumkCS3cWaEoBRQ32D31CHxEhWUn3f68guF5Ms5qFUFnrf	127
6975	2vb8epy97xkBsnYeUqWibPxm2drBNznqNBy1uFaZFyUpfacRQMzu	127
6978	2vacyQhHc9XpceapLNT3emwb7Wi7JuHBBc8nNyzKPPkRzpxjk3Pr	127
6981	2vaqvrJ23CKZuN9Wm19CCYHUDuqYtHnnnPs4r4J4M6PdFGkwCrmZ	127
6983	2vayWUEi6ufUeXvBXCK7vZ9UQd8gFAoL4s9GNvj4UfeBNdjehAXf	127
6988	2vbgdTdsDCYQ5kywMmeeftLqbdrBydJZeGUfcvpiZpZ1TEx3P4QL	127
6991	2vb8xpYXgLYxYeYZwBPzeG1K7pmjfTQYjAe4yGZuxyjjDThriWdi	127
6994	2vbQX5kqxrE5LisvAyWq1gyCBp2BLmsAjMy59wA53N5B57mFYAVA	127
7005	2vaHt2nPrCpZhrAvRgD59JYxGgEv4ohJLfmFziqrHSHbkaiGUVpB	127
7008	2vaU55k5PKjC6gRM8Wpjsi6fVuzg3bCrUTHrMWCt4VrVHjjekgp3	127
7013	2vbj9d6LB3QXUF78Rgzf8PdYtuXU5MUdmosX9CWBzCbFBj9TVDnv	127
7020	2vb9HThydaupPdzEVE9j2CG7M1SaKzBgQXF8iGmBSQtwL2P7SouM	127
7024	2vbK3q8Z6NcgzY3EzkZ7NTQzv2rkcKCj1moZCT2P3EfFvU9y2niG	127
7027	2vbU4dghm1HoALpG7zX4JA6m2qRHmviexyxHne1eohxh5QmCXk5K	127
7032	2vbmyDipGRa8ZnamDErqSDGkpXjkbAeS9BGXVRbsqqEgujuKeYrd	127
7036	2vaJaXBqCyHnGUnNGgtgdERoFQjnipcrsVa2SLzrwataKrztUhuZ	127
7038	2vaizLWSUSDrXE4wLhyebMN6K8aK8xd22BQ6shebyumQy8V8qHBz	127
7040	2vaRfrcmAa5uccCaDGRG2fBAcyd92U1kD5mH8qyca86V4qJCe6GL	127
7045	2vaDoJFf9qaRRwDzwXTFnkLRKNUr8jrFhaVH4fjtxhBLkXBcv3sJ	127
7050	2vaEJW2hyzFSCakb2vLtzCkzYwvVXSAKYjFbTqMhdKevMQcEUHQX	127
7052	2vbvktjtk799Brqe1usbcHQSQR6C56mP5x7HvvreYnunp2n9zR2m	127
7054	2vbYbQDBtu2URYqFu5nSAHPASLd43ahfKd49aEHweFkkbQVtt3XD	127
7059	2vaJeEg1Lno5hASfyfAJvpxZkAfycCq4e6r64AJbSgjhLkfrcEL8	127
7061	2vbyM99wovcFQEsUcn3fhei8KSXEq3mWdY42ajJwg3BDA51ijAAc	127
7069	2vaqEWtQZda7YsyuoMMMv51PnMGHkoyZsVxS6iPaWTji7LsHmvSC	127
7071	2vaiqqpp3RHJ1Aq37wjc9CNvuRRQfdJUf2U9LNtWbcMZw8Jqjept	127
7076	2vaphJr459xETjyxWLUywaAYWDzR36YnK92BzsQbn1yXHzgrKK9p	127
7084	2vaiE4y18U1BYvn3JDteUmWWot3xBzDEjxY2iM3d5zru51GF6L4y	127
7086	2vajNFy2GQS2EiX7EouTdj3iypUynCpFTSg2y11LMzaikgnRxJmi	127
7091	2vb97CWNDsAibBPxqBayfHiEgixwkRGYms9qEP1r8NmcPUbW6BJS	127
7099	2vaNDeTmaor5NgTLfPc5kXFsmKX7kpEo2kVW4wdcUSrZFzW6nRzJ	127
7104	2vawiXZUq97FtQooqyKaeSKs9ZNZ4DZfYWJWevYp9Tw5fyWizsjF	127
7111	2vbigifQKXP8tbT52CEQ3pQkDk1Brg7GPhiReqeRCSHpzbAdFy6g	127
7114	2vbEpjCwAFgQ2tc1ojzeEs8Tc6zqiFncqy3F3EoAsman9bvqDCdm	127
7122	2vbZwSfpdtRbiEmn4LisDpy47fU8wrJ2c5dTbAR8T59i7C5bs6t2	127
7125	2vbEbnjW78MTUrCuLEoouXLHkwPaqpoARVbQkrpNoArBskPYuvMB	127
7127	2vbN8ZrdPRhFEsdBtenqE7KCk43ew3XeFm1gWnWWxHzhXmM7PDCb	127
7134	2vbbmqXX474ZGnVsHsJc38M3SceLWmxQzdmvhgwRqP3y9TAGTKkz	127
7135	2vaNoYWaP9ctJgKVEujfxEY74WgY45qpGDPtSQb9Q4uvY5xvn7GW	127
7147	2vb3zdtzCEPExpnZ9owq5jHtFux6BZmZM2RJKMho9sVpY7ZUmjUo	127
7149	2vbFF62u3Gmj9Bz8EBNdhPBfRnyxbSTS4CPFs5NeQSsKhTemuQU1	127
7155	2vaxfVsM5KGhmcPvey57wa5CYTSSYT6CbxhW5wSsLyREnusu64Ti	127
7164	2vbkbFBWUtwzj4LCcHUbYk483B6n5VjyXhBwDUPpGq4Mc3GNYWgf	127
7166	2vaE3Y4jMvUgj3KWEmrZMfAoQHGzcJbqcGtaNHiF89Z8xfYXvpD5	127
7167	2vbskjGZrJYRMZ3ZUo1EmVECKaWwBm6ZbV7YU6zRA6GAYj2hcjfM	127
7170	2vbcWVigQWuDAHEwBzbdfptmuMYmRAj7AG39gocLFEX2HUifzYNF	127
7173	2vbYi5hEWY3dVMC6JNP4UHMKNTqmjkSSy8Jgw2tZHQutFWUYcvUi	127
7174	2vbUpE61XfWi45iMrz97Hiohv8R9K68BAgMMdpfvfzzFR3gFRzMr	127
7179	2vaqxF3K2ABzDtFEm24z6YwyC2CMD46JHXeRsV3ZfHFCXQ9hGtkm	127
7181	2vaDCWpSZJa8eFiXa4jj3pHyX9DSwaUqm71kDta5nBTbFoedjokk	127
7187	2vc5UQi9w3bkhk8CUz9Vku9cYvFPMtv7i8CKS49R63AJoBn7KbwJ	127
7189	2vaRsUTeyp53wAhbhyk6G4uZBB9yxNaXUfhys5p7EW8CNGpgGhrg	127
7192	2vajyapqeu6JdYqZqvt5DDNkkU3w5puM4oKnXk26peyRpKs7GDuG	127
7195	2vbFuGQ8tM6sd4zpzYHY63ztBqxnx7d4z4bKA3pwGG7FM1kExw6j	127
7196	2vbyhMcwnkao5tVLNPZkAsZxYigL5EaY4b9VYqWMbYSqTcvkyqFz	127
7200	2vaxfBBvRdP3Sskb2nF2Qtuqot7bJWMgWoM5nS6TPGTYAaKwy9jM	127
7201	2vaFkru76tc8YxXFMxQuPmxNFcXFmYomWNmajiKEP7WjiuL7G1g2	127
7207	2vas1QMFAdsVSR4FpXaQyQmBfyrXi1RrcC813n86eVHTziu6dpJN	127
7209	2vbtqaR9mq5NjjH4FbUoqLACysTouL5j3zdwEb6HZvD2AbJQGGdD	127
7211	2vaFSQozLPQS9QZSkqhuA8CxC54RLosVdpd7SGa5BXJGC13Rd1nq	127
7216	2vaG2jpsYWtbTF6FcKvYFUBWeVA7t424wb8r1kf2btV7xqzHZYz9	127
7222	2vbFLQJc6zrQCMVKg7YiBWeSzBDSiWtmr3s9op1g7wbPtMswxxWd	127
6877	2vbBJhF8XoQ5CmyJcfiweKydPU7ZKh8mfioHFnmPpuhPF7Xafc3q	127
6888	2vc3YSTFETEEQFNPS2qYUeX3Fh6cD5yfM2s477DyWAH2bUYhRVgK	127
6889	2vbRn314Z7LyZzV6yBCS8eVxAf1mMpy9GxepuuLHDqY9V6UrP1X2	127
6891	2var1fFrvC9a5wuhDt9QFDt3iJpUhjiT7Fo5hhgrdRPamaFW3QLc	127
6910	2vaeKhzBAWmf45CMFRsyzjxfw5vzwKFEE6bygr8cDm1o2V9HpMqq	127
6916	2vbQkkhGUZgzcebQLbaon77PQWGDeNnHvHKHvy5jiR2R2rDr2RCF	127
6918	2vb6adPqZHSRrc3vTdGSXseSxGSgTbeHZncoj4ameanskJRAMAb1	127
6921	2vbkiHpJfMEERE88ABUeXtY1RT4ANMFfXULqov12Nj3TbPcpQum9	127
6923	2vadS7vYM16Tpreoc36cTkaVRvTFGRVvaTrUAzi9L86ByNyGmLnW	127
6926	2vayZpogYCY9ApScupM2TyLFvjNw1bH6pG7xhFjpMwcGjkge9VmY	127
6928	2va9sA2NzXJPAK8ZZg3bWyjZAeRRW5QcXXn9WdxBb6sr1QYWNXog	127
6931	2vaaaoXHAmrNrnZXGCbTBEFcarZWGet8y9KJv9sxRPYDpH1fpSjf	127
6933	2vb3xA4NXvAv79V5rScf9Re74wn7hWQMaSjrAcxhbm8NeCDkiaQ4	127
6934	2vb31KqixunNmkq5ikjd9WLG91YAK6AP5obp53N7L8MVdFbWUabU	127
6937	2vbP36CPzzuSF6Ud5Tgw2fagwio5SscM2iC7wwHYC9iSCDTpftbq	127
6940	2vb1m3NPZjCPuTGFec72YF12DvA3W9PSDf2sJa8vxrGyKfCqCxtK	127
6943	2vaGH7hk78ToFQsS8ctur212EHsVNvoPTCFoCGHGdD9gSGoYeC21	127
6948	2vapTUMqUee9hVw3fkX6L1YV4UDMTFBLmFvvQGoAU3ri7fTEU3ma	127
6954	2vaVSWFbTdmPaX7pfix3rY4HT6jZax6Nv2gSjjJiRzJ1WGtHx5UL	127
6958	2vaauG3DBPHwTGNxCv1A6uNAE2phoNRRrzYDXc1QcZ5585iLshco	127
6965	2vawms4pGc5yAtqBD6yKhGpnCn7uz2ifBTHF9YrQyxYoCsq7ZfLD	127
6967	2vb7Ni1hGtCJ2HtjAdq8bcZib25CD5feUWbfEECxeavNRZWhBrXu	127
6968	2vc2jBRuSMWptfhT26j41zbutCA44q7YT9pGCqVyDiqMh4UB15h4	127
6971	2vax8JQeQHJvaoaXNDg18M1FZouXFb9A9F6hnsbuFbs6KktWzaHD	127
6976	2vbJWxQAqxo2rZHm7nFKPomuvJc9cjRzf9J1ivD5Ry78TtLK4WNa	127
6984	2var3CjZEKMsjaSiqWDiKouwyL4xLpuLZ3uB2DYURvvYRqdAZtqZ	127
6986	2va9vVpCrdeeauhCVBhi7CumhyG3LhZLKwtKCW4dTf9ebeoLQpnu	127
6989	2vauhkD7ncKSkhMY4o33mWjWw815DRE7p3ZVajZcfyRhk23wNfnj	127
6992	2vbwz6869afcqUcsiMTdooiCqoPz3gxsBmMfS8dCx3FBCXSzTNME	127
6995	2vbTerXg6KCYKSa3mSyeBBKEGjZPq289hSxcKzTtwrQvCDdScTXj	127
6998	2vavsMK4J1MTMBFLNgn1SY7JuUMpjQPD5qVhGwsamqv4JrXDf8Rq	127
7001	2vc3MPR6UzVST4YSaEtoR9MfEC9FB9wPRydGCKE7cRdvZR2PHVtX	127
7003	2vc5sWtPR2a5HehzREyF75GTpfc98FRrbiHX7xG83nYmG4vCBcU1	127
7007	2vbmoyzcX3qMtEZ4yKzjTk5JraZSG85gWk4UXSNx6VzPyG82mgVR	127
7009	2vamisxujjcwsq9qFA5pzdnRawFuhP7fSayVqGzRYcwoUDZGias9	127
7011	2vbCL8yUC2Ze8LMU16a2qC3gwsVadNdofwxSQhDvGquz99fsry2p	127
7030	2vbj4z4gP2fDPkHqFTGuPZPmMcYtws8fLdUZhiygd4mcg9AZeCNo	127
7034	2vc4ZWCFgeBj2S9APuax9FtJ4FPdq5MaGGcrKreexnUa1NVPDJ6t	127
7037	2vasqoZBcBk3hUpEEmsQMaxizcoC9fspcQQ6WWu9qGJ8hvbkrmpE	127
7039	2vc4p7VxUm7DfMUDNVyf8M68vwUsURFaWbwsgNY2Z73aTZcirV26	127
7043	2vbvWKV7w8CLbUtNwtKSXvqXmfsNpjrz9ygeFMHVTSZTJpaw7G71	127
7048	2vaVPnPHAtaxmXUHyeGkB5EPrX2HEFtbnB3m3R9jKReNEJCS9xvT	127
7055	2vaaTfms4CnSPqffFkyJKAqamDfHx582Ax6YzHdPLyN7ADFgdPjw	127
7057	2vasHSyAf8imi5GVToiLS5ewb19Jdhy35joL7HBD56WNW7ru3U6A	127
7062	2vaktgbcezRk4m7ATYQ52gZZg1jMAezUj4GFmJszyiozp3BDDX7g	127
7064	2vaVjBQgumPxKontDDKotM8rpoRpRvvMYZR5kFkppzJjFaeGUD5C	127
7066	2vbMRCf3H3kXaRqDX91rB3X6j2bywL9G4g4PhTBetuAZjtaEN75a	127
7070	2vc2TDH2BP6FpEhPoFcwHYMmNaQ7UZSYXyTXzFAAUPA9d3VpubG3	127
7072	2vbM5RoGuBeqGFv8gwHNEroqZB2ystetR5gK4LrSjjggnGog7eoJ	127
7074	2vbGqqRoNuYv73qYsL1YJv6EnxHFXT2BpGp8sR23Y1EPzWGzkGEa	127
7077	2vaa48nEtYCJW12RTLNXzCZ2wrUn1pnUsR38xgKcz7iwSJF8Tw1k	127
7080	2vbCFeSpSZ7xqEbN4yiFys5dYJgvJvWDipFUPUe3Khi6go1CcyUc	127
7081	2vbczdVC1jRMLBN798pSJj889dBmdc6c919xZV84mFUMZ4n2RuFH	127
7082	2vbYUz8fKxgZGRR1q1xxzX42V78rrzeQaX4opJhzcHs1FrYwf7SP	127
7087	2vbLcAghZqMxeBUzotEBg5nhiRNGY4ptC6qT8yLBq6ZkPywaxVQ4	127
7089	2vc2TnLWGfkBPcLWshSqp69dW5C1GhF3hvNm1ti5P1tf4FgUEQv6	127
7094	2vbHfyhMMkwDeWdw41WPvT5B6XULVmwVqR8TLnsArqHk5bnWNM1L	127
7095	2vbauQRN74QtFQ3q3cFX521SrZYjbe294AN37EVUNxV6dnvZvxVG	127
7100	2vaou7xCxUAVFqfbzWGM1Ub37W78eMmdBGpxp9YZgkvFpWTFNR2E	127
7103	2vbjeS9hQ9iHBrb3xvNbVJDBdpmFFP4dbV2uisSSbG8UaUuHimhq	127
7107	2vc4qxCQG1GX55tKVCBBJRVLBtpTPdeBUCcxgSwsmmUHuSJpDoYU	127
7109	2vaSPqGXq1ULrsdojZpJ54amapQgmhAGbtss7Q43E4PrSLQqWb4y	127
7115	2vbgYfRauNDN7BcEfN3TciFRXonzqqYfPsDu9vNgNbuYciPS1r6K	127
7118	2vaWbxQMtQ7KVeVDJPat4UGXDdyD1L5Mo87UXPbihfha3BYP2m9k	127
7130	2vbNeLpaR4UvXQJ6bVqYXt7fToC4uvx3rPpXdStjrmTsHwQxWTGc	127
7131	2vaeuD36DjJDZZXVBxyi6DFntmNScGhtCR6vAniNcvv8tg2pnQwh	127
7138	2vbLcVcgbajA1rUVyAwgfhW8UMTsm29sBawiwmNAAMgvuQa19hYr	127
7142	2vanJiWimNXT1pJJj9JAgdE1f8xD36JPmBv2ANm67NN54aNSxRki	127
7143	2vbhezPcZYM698p4N3eJhWR3FaPUnv3ffXmSV2P7skAu5HwXrsu3	127
7145	2vbJeWnpUoP6QUD4Fbxnq3WV6LAR3pXjR8uMdbm4XtcjuGZPYgP8	127
7146	2vaW6MyJzQrTuZ6AJJf7qRnehGadovqEDRjvEjpMjgPGwtHUefox	127
7150	2vbtDrpWJWzM1wTPjUXPF5v6ow9vBBotBsg2XkzehY8i4vmHN5Ag	127
7153	2vbkYid1SKzW7tS6UgmPXMYXrFqMBEyNmDfvHVkZEPWVRwTsc2XP	127
7156	2vbjfp69KKnPSqpthhwsQpLHuTtDnpwdWPP7R8XyguRgPVg3SKdq	127
7158	2vbtTCJmpnKgMqoSPMLiiRjm92Ck8DFisA6kbeuC4atKJkEa76Gk	127
7160	2vbHxCqbLiuRLHSgpoohB4H6hVMhYQ6HFaJcBetvf4PKVjz59kys	127
7162	2vaDZnBgPLfXCmZS9PKuwbGXBnzo3qu42mxLJduSQiww7QUC7CjK	127
7168	2vbHpyALu69QD2fs7a1FMCVcFGWzyVmfr5Vi1KXnbhjp8dpzztsy	127
7171	2vb3jmxuEkfJNgq25xmovjVRJ2tTsPoPwyZx9waC39NJSo33J1dw	127
7175	2vag4TaAkNC72x3KBMtGHbkYyk4r8LxWMeyQC8KUYngr4vba1htW	127
7177	2vamJyjRD1LeVBMSPWKZjfUcLG2k68YKQDkQzx5SXudFSLtXow5g	127
7178	2vaYeEzjAooAwic9zWCngTXcutrYy7AH7bubvEm8BjD9mSzvvWAK	127
7182	2vbtejbAxnAaAtmXvVfY6U2YoNYQeo5vYeQrxokbMknhMyfetuDM	127
7188	2vbJa2cvcxwmNByWuVAosd5buso2w7ZZni9rw246JWMBYYWfVCed	127
7193	2vc2ggAXHdsCWDKBtyaYZnZ7kWQ322DKb3Ah4KJsERJjcgvB6DUZ	127
7197	2vaDqcKGJzgpCugh6KzeHLFVUXvPoxm7KaDSkB8z974LuBKyg6fU	127
7202	2vae9Xq53CQFjgZGqdHzDfateGgeCbss5EHYTM8RCWUjqBy4fh32	127
7210	2vbez5divF2eyxu2c9Xy7LGMyBhyQUBmqG5vM1Nb642diLydurHo	127
6878	2vbaKCm3A2ocit1BcySrt6Dn5nwgEvpFUeFcvAv6sANWMg3rezrs	127
6879	2vbDRDuNgE1eCVpmNBki32zwKhUQqDnekD8noDmT6D6pMw517g5S	127
6892	2vaSUfquG3gVz7gRmLbFCi418zd6eXR8bC6gi4f5ei2wKufPfS4X	127
6896	2vaARC7ructiyXyCkDjqUL8o11ERhKt5JFQa64ZtiN1sxJGyuP7B	127
6898	2vbXXWehWVC1qF57w2YRFRKMBxjtcaCHzYUAx4xvgu4gfqSsBfVS	127
6901	2vbnVpiuYvaDVyZfvPBMrRvpVPCecTBXG41vwpc7QsdjKN1feHsG	127
6905	2vaY3qKygoAWZAzidUXLYkUFQMtKsbQuhgCZ5oykQJpaGA52SkSg	127
6911	2vbQ6mnDrscWFX5Yj99RhVKdccppbVwjK5WikQmWx2WaiBg3W8Hs	127
6912	2vb1sGy5fUai9i42vrwiPjWJWvDMutHvC12WxADfhEiknnKoEDvL	127
6913	2vakXKnyWPHvpR8hrXbkBtvsbptG9gVq42ZA6WvZ1KmUrRwyPohv	127
6917	2vbwS3hnKg59r3UBbqAj1AwXvkm3dou2FNJuwxGL66JbcbmjVBGy	127
6922	2vc4arB6cdY3t5Wc6MZf3f4e7aiNeuKcVDc5kDG4E372o8uHo2o1	127
6924	2vbDcuphpYABxuQ1S7eAj2MSphzGTp68RcpzA8bptvxd3ArgediW	127
6929	2vbMrsU1BG82QR9ca1qeVnLVKgLMNy3ZRWzscwJvnnVpbqQffKvj	127
6935	2vbxQVAyt3NVZ8zqzMkQrDgt3pPcXHLrpaHbdeX2WDAuxViji2m7	127
6938	2vah1T7L1HQXKaS4BLGtP2DmzBXzRx4EJzePSa8csDHn63Ugyrqh	127
6941	2vb4D5C8BaQJi9NDLLCHeAKehsTBEqRYxozbLkFVCcQDR847bpmA	127
6944	2vaqJKefH6rJyCLD7X6XuNUAnJsBNrPnDwvEAST29ZZoUymWm6an	127
6945	2vbA4Sc4cWaMT8XtWzvqHrqAFuJVVJnDCcMpfPdpvrBHVF6prJ6y	127
6951	2vb5AVLvcnjhMSWsBYWixEDUXygJ7VoMmco1hWQ7h55bjgFbiJhi	127
6952	2vbDmZzoxTNQCZ2hSmpK4evwKLQk52owyYswEVDn8o2u8uCzoZFq	127
6960	2vbL2tfdAPYRsKh1aoxCuvPH1W65C4Fd9THH9um4LiJe1tEStTBJ	127
6972	2vbkQ69QFx51Uji6rPcN5nZrT7V8RiVc89qYYEthEVBiVgFG86fz	127
6974	2vauyHZG71jNQcLQc22hrwYhDKa143S4tLTkfXYaD813gDiK3Xou	127
6979	2vaAF34PFbkRy1HwcDRVSZcDao3DtonpKRRCZ3YhjwP3X1s1mHGz	127
6982	2vbi42zsifcQ7hMQa7KLVtik5fpHtpPmUNy4rEyShyoUdDJFLJJG	127
6987	2vaFfEveRt9Y7oe6x9mNc5Yh4ivEeanrgyF8jzMZ89JhSR1X5oki	127
6993	2vaHsXRzUo9jwbngibVKtoyaJY2Uve3A3ZNptrHzvJSiH6VSBXCG	127
6996	2vaGegAPE7FTCmFhFwZ7oJWpdtbHuSJXj3Z9vLc7dmvzZ8gbJJEr	127
7002	2vaH76bgGi9wfDPPAjde5TP59NtpHQBtzJinZAXgup6v33X8ocVV	127
7004	2varoiHJbzLfz5KMFWRvEnXTtpErntRRn8CRikprCwRixq7PWtqC	127
7006	2vbC2ZfBAsBehFjUg4egwiXwrg6ZKY3ReqmkbJNNQ9WyqYFpBbu4	127
7012	2vaVM51nGHFfXbfzYUFMd8ugS6yjfq6KjujETuaDb63gFdhtPbmR	127
7014	2vbE53vuWSbBT7gfXRAoChnYhhn6WCCw9J4SEcfrnkjaaqz3Q9Uw	127
7016	2vc5koa18P51ZLGCRnsZVZWH6gx88mrebZ3Uphdqx6zMN5yDTLsg	127
7018	2vb1i88uKaSYNgbRmqeGtBDETz5WksmKfBTEZJ4kTANYbpifPrB6	127
7022	2vb3UNXHCibvkPR7WNTGA6HHuKVd9iYKu4Wi7Yk9mEgzP2jG9xLZ	127
7025	2vaHixczowCjEjZs9nf3h3G8PgWKV6bgbfb1AZjBA5Pc1Y3rmqiX	127
7028	2vaXxskv1PZh3BDpLrJsBWpoU2vSxcs6EjvbsonjkbmGcXa8QLty	127
7031	2vabHckW36p2bBFBb3zazKstXEFTHK3yKFVL8rLNHS81VZcm3sE6	127
7033	2vapRLjEzB1nRhE1jeoPwrUy8GyNfgkHDBfgVDpwhHELjGetBwZ1	127
7035	2vb42mneeKhSzCW7TpYamarLnpSGFopYdSjSfA4VJDKhR7zZRu1P	127
7041	2vbsCELnP6LCswLrWszGAPb1JgcfcmS1RUCaWnY1tq7TqwFWrRPg	127
7046	2vbhrdA5byuc3tBw9W8teiaPnwkGuXAajuYP4VdvnBn3HonSCzzT	127
7049	2vbHLwoeVjwGMc4H5fTZLDifCMVE53a4VhRoDJ58eA1XuZVyCXZg	127
7053	2vbToFRzkgXrqEeZ15cgsbYJhzdz28Fn7hEvN3qiNpmTgVQsZSyh	127
7056	2vbLxsCrqHqU591BYUNajrJEiaALKc3zejSmqDX14iYh9BYW1PZP	127
7060	2vaQGo3BbYWymJW5EjVEuqn1EsAaePUEikRX9heB86LLU2KuA6Ep	127
7063	2vbJWNQUvLqmDfNNGqdJu32bahGr8JnGBfj34Vd9tArYSHPG7d7d	127
7067	2vaQiNXM5ZYwuR2RMcX48tv7FjTCiosiWZ7ZVYRd6oqmyTX71Dgp	127
7078	2vaiV4j9iLKnhJavkb92NXvXxqvxvv8y118CHQ2c8XPdvkPqrPBY	127
7085	2vas1bCF5oh5emESQt9Vz9eNqW3KoQgAssXDTrJuTLdN6Z1XwtbK	127
7090	2vaJ6mqseTq3U28WgUebxjSW46LP16TEMb3jsZrBJaAegZtzjt3m	127
7092	2vbBiMhrfTt1Drgob19iw12DxSePYh5V6GNyqV3YjaHwmMmyf47A	127
7096	2vbjPHhC3irNe5i2Qw7BVVihjxyu3zZZkBeUTcpjkYzBL3YC8pwb	127
7098	2vaQzKFetNhx4uW4dg5k6f6hXfnqYWeqJ1P6CXnze9vnoRK2fM3F	127
7101	2vbiYiQx8ZMR2UWYbGhrpwBgMw5dz9kwBAvy1qNiTayvKdVef85h	127
7105	2varVFWZG6CNuQuCQkkz52CF9MXzpDRsHwsxm92EEmoZXj4GM36x	127
7108	2vau7mZD6xS9LCLdD65r1CCTtKaeZmdYpmuMTWBDbHYPx6Fvfmxw	127
7112	2vbGtEpAj14ZY8SsM2t12pUbzsfV169r4Yzern2nKA2Tw6ZGc1tC	127
7116	2vbyfxMK9ugctm4ZCeEYGDs6Wjafmm6eXv54WGwwVKfdJmZfma3a	127
7119	2vakh8EssBQ5p5SY7BWAsw1Fvdr7x81cTB7fUHyeHkKhyyaqdBfK	127
7121	2vbgZeFXbWCXiLwyMR87eqFeJTjVFxYouF4hLdJH8NJhvuVYtihs	127
7123	2vbpqe9LnwaBHB14dSXNWudw91ZAdWRktTrLvD93Y524FWL8b1Cw	127
7128	2vbwQ99PbW1nWz1yy8w2wLvpkTg7rpn8gdR6pAdKvo3Cvni53y61	127
7132	2vaXo55q6z1uZ8ez4RFFxUyvSSimpBf9tiEJJRKjyL3w7c1Wp6ZJ	127
7140	2vbUd4Lq2yG2injLpCFbD2c6vagZ1FaSFBxByAP64xRJxi5K2GKj	127
7144	2vaCx3E1rvfE2YPsUhd8WMw7YHqGVc94uQ4cGao4qwUcnEezqfoy	127
7148	2vaCumSdaFAFJsUbaiGZ5WZSihNNytq5cRAY2dbJtqDj5z3RTy3F	127
7176	2vbhP8H5aWETFJrJ1aEpbG6pEyxsMGj6LKEQBKqcSXMuP4Jc5MFm	127
7180	2vbEZsLWLsgsyDCnNSCysM7RYNGFm9AfMYZk3UYcZzuMBhBKvKXE	127
7183	2vbKryTixV28Knm87ZNioKEdvW67iELCT1kqzkr3Vb4UQvsJbdUi	127
7185	2vabxfDFprmYrnby6mWEKiPbkqxN9Y8JqWFKkyQBeM89YcyKVP56	127
7190	2vbPmHg7DvkuTFrK4tXfcjkgPr7yQeyvp5bu5hpAV69FjoYm1VTd	127
7194	2vbyMD6aCiYmKQYigjkLEcD92niEBEzckQ2BdUVmgHKFhrYPBtvH	127
7198	2vaxK5ogBy3ZXvRAErGbuozAFZcUqZSJoD6X4H979w4f8HJdgZVs	127
7203	2vaDCkL53pWMr7NuLcysjiUL96NXmUNFAWdSSJT6TpR6gR9rB5uK	127
7204	2vbYaxhyUp72t6Wny11LdLknUkRZcMMSgx8ytuGBhcMZmCys2Aet	127
7205	2vaihT3mjPoW9z2j5V21j364TVLT2vff7eDFjG3memeDRquQuP7v	127
7208	2vbN5qDE1sS9cAt5U58hZYgp4ian9PqrusTYCwynemGSWSBc66oX	127
7213	2vb4tcReLxxARkDVcb3RkmC1yAGoDfiSJpZYxfx6eVnmPCJiyqbE	127
7215	2vbXWZXniahPH9FPLS2o2ShRAfBE31zTuWNERAXjGTSWhGH8KHdb	127
7217	2vbf24Un1Ff1EUXDkZJW4c1pBEgYf3ut8j7MCFDJbkWW6AmCY2PZ	127
7220	2vbq99vDCzH9V9b3GX8H5LicgAfXYPS6M17ZqhrfUVCWxaXLu7Ex	127
7227	2vacd2bmZjvjQB8GLLAN9CH7PFE7FwAbeFDDRRVcFkraujA4MiG6	127
7230	2vbA5SANCTxKPKiccPFbukuVBzJfJSLpQLBLvQWmZ3jmhZbXzZSE	127
7232	2vawSb8tEx9JaGDv1mFer9J2pC1ViVWn5vFMgV5VxM8bShtk4pRA	127
7234	2vadgWVeuDG4SpEEFzWwSvBMkuCgM87A4d1HQzQuQRQcg3AYQxwV	127
6880	2vbKbFYSPCdBudidQ4JCur1N1N3dgS2kqcwmGJjXytteD98EP32B	127
6884	2vaxQubWnTeidPFHoiyeE2wJvv1Cdt9W4wfueLwPaqKP5qdtmwVu	127
6887	2vbub99jEQtB53SwJLZ1NoLycz7DeY3EnW3Hw1JmLNKZD5kmCdYf	127
6890	2vb4Sg66NVc9eAWM9fYV9QpP1yUnwm9W16xMTtL2HDAuJJug6hUv	127
6893	2vb4XFdHhBKBomk5drbmamK8EPWRqVy7RUeYp4rUan6TJYmAW8vj	127
6897	2vbzJaJzawtaLFiYPpkQ9WJ2synhr5gWoFhBvg98cWinQy3EMpv4	127
6899	2vbEBAe8vS7d6sRYTEo2qnWwnQ14gmXnsw3HWB5ymBMGZBZ72aAX	127
6902	2vbZWS12G8WsV9qYztvxqE9MxAvsjtQ5JxwfviLnTiJuUqMXgMfc	127
6906	2vbbQo5wYwg9vqXEeSynX6buPQ8YQdEDkECxKhQetWcGg6E6X9H2	127
6908	2vaht8BbEsZJ5Aeo77T3z19WbMVW43F71MTFxaMDM2DEJzLP6M73	127
6914	2vbVpuPQzAc6rHwzwRBrcfchKfsRcbtRYdqJLr9BgeQ6vSPp8YEn	127
6927	2vbnVhqpi7FwKbA2eoZaor54wycNJLzecNmdGSvWRRwmW5JDd2KL	127
6932	2vbzc2BMxCur2Dmpw1N9TzpjEUA4PCfwcL2Xkgnt3kQrYwVRcLLU	127
6936	2vajzToiFx7UZmMtc11e8k7X5cfsDNupUHjcXTktmnpkves3apna	127
6942	2vbzxM1gxVr5SBQgDkjeumkjxpd7Nfv64JvCVhErBf96yUdHnqRQ	127
6947	2vaMYRZTo9g6j24MChcbeaRSGYCENHPEroWXwGP6PLLijQEPBd55	127
6949	2vbc3bExH68eczCGijGV2ubP2uUUWWq5Kfwmob8WQHkUNduZPawk	127
6955	2vaEagtAVjnZaeHXaoKaRfe3tfH9WLZvCHAUAmELV9fBGGA8YVKE	127
6959	2vbqXZkfNFy77j3BakNrNtsb6QHPGZUquesFPSJu23hBxPMPFHQJ	127
6961	2vadyBPrPAztVuhHtzGMKybFeWsYMQvoqrdTakZuPJwLADobZWvu	127
6962	2vbAGJ4z31LLgVmV2prNcQbDrwHE2phtgWcZPWkw3vpbkjZPLtYz	127
6963	2vc3ovUN968v3fgr59w7qT8JHHMJEUptCaTtVonphFDsDehnZi9m	127
6969	2vb8YHwY2sGSku3F5UmAmqoQVj5nSED6xLdS6wqHXb4CNtkpkmmU	127
6973	2vbtiiCxWJzyb8Rbh6QA1mCfxf9PbzCJeFFzYqZUdQwA6tDHimAh	127
6977	2vc3hcXTV6aodY8UBP7aiDYVez9EHXfUFzsRNsX27eNAV5LPwQw5	127
6980	2vbKzQtJuTGYg4KysquVtAwjoi4aEWfb6Pgp3w1qwtgrRXrb3njt	127
6985	2vaWc6H6iV1QxuuhJUJHFoQu8fcikSU1FrZGWdawQsqF2spdgyj6	127
6990	2vb4gSgeWWDUyy3PnLeVSgype8jw1ca1QcaVnFdczU4DsQbdNazZ	127
6997	2vangpaFJ7VGenaUZ2D5bMvFNyVYzrnTiXit16e4564XNQsZy6cD	127
6999	2vaCXHGD2AN7mQRMpmSCDyDuTuY8nJ6ZYdZYoCBvgP9egBMZsMVi	127
7000	2vb6QxCuwuBCz4t7p4FqNZsMCzUVMhvYRA1WPUJQk8N475z7HF1G	127
7010	2vaKHxgokmJ9juoNbvrHhp1tHPotwC9dtVpTUV4S2jQGwQDEgyo3	127
7015	2vaBKjeaWzMeL3H9uPU9ysuMUp7Wt9iLfc9Y79fnoGCvcoVMNQMu	127
7017	2vafehRcq4wWLexC6RoVp8mePvvdXkXdABeFrs6Q3GePuKLSmUCj	127
7019	2vay6Q54aGSyR6hYcpW4tcKqRj38wkU1Wc4QHjdHxErDQk39giFF	127
7021	2vbvVavBPbEmZjujuMgzRwbiv7LrYuSFTpQoLwjgauBBKqFDNY4P	127
7023	2vbZrktW6n7iLGzgpm7z6NwVCDCAbQVHPGzKXbmSvk2FbHSMm4g2	127
7026	2vaFkEUeszWYtBZgCv66wXndtSghFubBGy4VtSP8WZ63hPoYhpxB	127
7029	2vaEV9sj8xbpVZNpBei2gYTGAhZQKb4moNPWYCMKwkuf5joeUmnL	127
7042	2vbw2MGxuy1EkRvaPtxAniPxQWNH5ibdP8AVY8kkXY1V1zbo3Qwp	127
7044	2vaTvZJQaGuYWtR1W3xLi88vYAtkAeSRcw3bAtYeugbu7G5VvAVp	127
7047	2vbaHZhKMN5sRgQkrSGmzxMS2evMEGJ2mDs5Wb2P44uF19VeRQ4d	127
7051	2vbEJHJs6x6Qoe7cbfUCKzxLtJSLSNqxvwcV3U4bqjuWfQp7PYJm	127
7058	2vbRmUwY1qFVqLP5MN27yj3JwfwZojnDCXVGiQ2V6uyMWQMSR43x	127
7065	2vbMriK4tWevfBhfcus3chVu4Rz1dEtAavnKRfXGc18E9idmgaxU	127
7068	2vbcrKaLeEk25ocPiifbuGUG4zYwV8zuQoYDADz1NhoSMCmSXCFu	127
7073	2vbPwwoLr8jL3amkzNSNAQnJMJLCPZyne2hAW19SxCcNhsW28nBw	127
7075	2vaDpDrJcgkaHZPAWh9c6cUvNTLG418okrn5CGq48ZQJUWUtXCT6	127
7079	2vb3AA4n5jNYJsSuZZaJTRMzfU7HAKXui9LYsPT2XrpA8RJuQEUH	127
7083	2vazTKkBm1R8YLP9avDHERcoCEErwqSXavSWRuLXWyEDShnZhLzc	127
7088	2vaDopjSY6q7vv1o75oWaLwR8MoJjN5oUGk9nVFVFmGjxMgVFBLD	127
7093	2vaixwJCRZm8cJMEWqPBgTjDseFAu2Fe8D8zFgLDRFN5r5FjmqsJ	127
7097	2vaN6tucsXLN7Z8KEebprynC8n1MsttkPQhbG3THw4dCGujCu4nL	127
7102	2vaor2jk35h5PXsXcufLbF8BHCqkgsdFSrhECcUDTLVYRRMY2sF6	127
7106	2vbmYuJbuN6ap4vGyyr552qJSTysefGJ6p8awYgJ55W1JfE92mQP	127
7110	2vaUsC1Cbuq5jWh5Fc3HChxYuzDCv3jzbHQ2r1cfcGdJN3nUzHnW	127
7113	2vbytBW2LhvZHvjQKoFCHVr6aUxzCW5zYLTDL1Gtbs83PvufL5pd	127
7117	2vbSCFyLMMZUf6KJM9qR1KrUyMVGqnNTh2ihJ11QJjzWiwBej3rE	127
7120	2vbTGp8q31q7NAoKBLVk4atjZ3hoY9HrNsm5vQKZ7HrnoGHDhVtR	127
7124	2vaHUTQ98AU8GcPh9mWYGrQWnSGFtYsM46CKBxtHF1C3sM2HGf1A	127
7126	2vbZsQZc7oUMPKQJAKH4hfGSRAKv3zWoPAWEacvGhvpqRmcKmr1T	127
7129	2vc1VKcNZCFC3apCvs84X3Vzj7P9ukNRRwaAFsAkNkMsFhr6MpB4	127
7133	2vb9UnQHjFw1kWm3MNcDETDa2LJXe1m4uUtiyg7VUZwhVhrNNXTk	127
7136	2vb7cxMA9WjPsQdM8kYTcMg1kTLzuB5AKmvSSG2gFY7GXA9Tx9Z6	127
7137	2vbKxh32Mxto77gUTxv3Dt4tfAMvEcTf6kdEYbHDMAg1sJjBuZJX	127
7139	2vbHcGTvk7D4SMzDPX25yWN4whYLgJscW1S7ZNi2CxnnK7StTPUx	127
7141	2vaopyFqEccctST32qAe2BZSpAErG5dZoNbAUvw8RQaktcbnKz45	127
7151	2vbtCjA7BBNj4m9KYmXExgNrjkhCaSnor8oEqJb1zQS1nmKL7zGj	127
7152	2vbKcFB4MA5n2VqVmPK6ABwywWt6PLqwoMyf3v7y7JSiLmidqgL8	127
7154	2vboz51z8cd57jp4nLJbnqM9N3sPRYXfJs5HFzSsnoKpyucr77L6	127
7157	2vbSasTmVGjmoxuUqLb2uw65giYUH1TgxZjv1g1mqfkYCfpSFrtj	127
7159	2vaaxRRotMvShfWP54SeiKchMUSZwQ5LMUnEV6uErZVwGufs8ngV	127
7161	2vbPozJfS8mcJF2tYWiMc8T9X5z6bLmnZ3wDjK1wUTbCouyuuncK	127
7163	2vbmRnSAgBYCegcbb63PosdGy739PuDqwMgZnY3JbsttmLE18CUe	127
7165	2vbCh8FZnkrSqS95dmR6KehsmoSsHsgXkYayvzeo9ukM3zqkHMKS	127
7169	2vbrvxsyvJTXnua7wuL9FzfZUgXJ86mM2gdqyTnkyuVy88qd7MnR	127
7172	2vbN2jUUb6B8SMwpjHAVRH25zTV2XWUtYvXrXWZX6Jse7Huaegnr	127
7184	2vaxByoVJbpxxgA6DYXqbVjFPnugFwWizMD46kx5qVQY18P7dRiA	127
7186	2vaqj8D41U6UCAocq6PQCEuZQ1hLDt9YJgerZprVDxXYVtgARoh8	127
7191	2vaeumYAhUfMC1xbKjax1nipcDbxDJzRypHmWJK4dUYXcgGNgxju	127
7199	2vbLFNgbF8Bq1k7JxzssCCz1pkctiEWk1RXFRwrrgryg6uWWYpMk	127
7206	2vbYufitEHgpY2fL2Nf9g7aMmFJVUTVB6L6AizfSkofPVRfq58dq	127
7214	2vc1wh1F9H9xVi5RrBvH75De4X5wY6qYVbU5ex4K527DDVfmEUrR	127
7218	2vbvWjxGSHf5kpW4KPQmE8vXBpZ5hpNb4mbGfYJhAgKbGKKwVdjR	127
7221	2vbxXjowtqVhDiqYajBFfxPXEd18gJBoU6QdS5AtA6j8WbSMTui3	127
7224	2vbe5pvYMWRJFmGoWhRogQfmSft5egu5QXauDnJP6JwMPb7oQwtt	127
7228	2vaKBgYwT6VdoYbpeTw46kXBFzxNuc2vAeEPvtBFyQ7JWFarp2FM	127
7231	2vbckp6wzRxyCxZozbmykKXy6P7qox8c7Js9n5oSTf8SqZGdm6ht	127
7212	2vafuCEm91hHyPuFU72gbw8UXZoHfRPEYVqXw7MhVm7vAnXTM2XF	127
7219	2vamBzX2SnybFY6xMfJnHACcFcGYwooyLyqkiudn9t96jr1kF7hu	127
7223	2vaeVuUVSEECnLmUcMA2cHRwTfE8a1WyYz8v2KJuDfT9GxGrAtrM	127
7225	2vajz82JtsQ1yj8qBZ4gr5q8PQGTtwgr7cJ8ZB5FTSwGDnUvx5AG	127
7237	2vb4TsTs3epkNzZuaGMMh8VUfAUQ9myEtVYrhW84ushn5W7sM66o	127
7239	2vbHnruMuNKzL4Y6cSSKpsq3GLZomWKyVUpWUeALhG9qYrfFa1jV	127
7241	2vbXSmG1M8xoysxxF3QCnGghg1vdSMvKJzuUEXyWJGkHU9LhXf6Y	127
7247	2vaMK7ToD8owktvUyb2jhTmyoAHZsbBHH6DhNhpCcALCUAp74U22	127
7251	2vc3djRDZuken1HY9h5uD8FK77FBRQ97nvxE8cvi6DWBYziw8iUP	127
7255	2vaoQbfM4NriQcV7kV9P1t5r2eNCfeA28G6QNcE2iDaDFdy8G3Hc	127
7257	2vaKUFt6hodArMfp79TFQfPHjXdHbXuPpJbF3766oPhdFJyWNv4U	127
7260	2vawH1kARWuZkkySrRxTbrEB6F6uV89cCBysV7ZHkwqsiVWBhQqE	127
7264	2vbmErg63xsHHtBdbHr5PCGm5dcQRbmCd5VHoGn7pfeUq5VmfaHz	127
7267	2vamvHvW8kRYCBMq7g2t1PsqCVqDMoZidTg3LaFbsT3SdfzsSqw1	127
7269	2vaS9d9kzF7bStZQPnJcbEEGvjYCtjk2NZFR4ueRhTEVHxoJRUYL	127
7272	2vaZBBDrtdigTtg8JpApzHhG9NbLQUA7mp5JS8CJ8NZsRDjZkwNi	127
7274	2vbAuAKbKt737i3psUGKZDEsGnRsnX8Jdr5PTqtT41pTnqTqBFUH	127
7283	2vbQ8xBR8dy4c59B3NQXJDjuP3SKcb23n9ibPcUBk9jGYrZm1Ecg	127
7284	2vbeiTWmYZFABaSpuwk6uLW5vHLf2E672UMNbm6wU9CQLDTe1vEv	127
7287	2vadQcmobYYKT6YZxK5puAhNXbT6LfrNcxYxXHjiDNtFUJ3j4y2Z	127
7288	2vbTbhX4vWRjxXUuXHd9kz7yaZNSjNRCbVu9TCaG9xLkzVoAgbeG	127
7291	2vbZ9w7uYaZLBHGfYQkUFtwqZWsAv4ZBG2jFgURKfMhf8rifa8gs	127
7294	2vaLELXh2gmFU9F1WCB4RJhMpvGe5ViCPyiwoBjrz9UJMG5Gix4C	127
7295	2vbT5MCondEm2qpu4mQiTxApR3QpG3z4wvt7Z5YRdJPx2qVztTEK	127
7300	2vb1kGyzGGd1XmRSR7ANfkdSeF2mGfNRbgvPkS13vM9vWETxJFsa	127
7302	2vbyKnJQXK9Awp3Dqq6AFvUNEiezwfFqr4DUzoDV3DgrTtvqdZPN	127
7304	2vadG2UoaeKL4xZREd5vdt6M4PQrQz21DAixx3uBKo9h8CeZtS7W	127
7308	2vb9dGfZ624Thd8RP4LReUc3BFr8Tkv8NreMB5U6svYP1YLfVKHf	127
7310	2vangmiXz4HfuZEi99RvgPLWTVj97JvU2Lh3fzWyzqmBKsYNgqzZ	127
7312	2vbBXUSFmnJushULNSJL69gmQpG8uktTD7eA2mfLU6pYUDDxHPTp	127
7320	2vavGXgj7v7zEndtMabgLoRuFinah7wgeS4AMcgaG8dDfjpeDtXf	127
7321	2vbFuDUTYuuHZwvi5vMHcwVdbWcv7W9qB87huCw347TtqVGL7Y4b	127
7323	2vauaukuho1tkwCmJXPSuVk6nb7X75TZYLGmrASdg5nykZ4up223	127
7327	2vaoVE5qfVRmJAeTjmtjpTp3faUWe1EShqrKD72pBoqxKAfXAQLM	127
7329	2vaJPcjE1YV9U95XH4rhJgSg6MFgEvFX73zU4LRg2Wfmt1HnHPH5	127
7334	2vaBuQgc2pVLnHPoNCx2M5rSMjmi2k2muZdeS61jzGA2Lb9cF6p3	127
7339	2vaYk9SGoR7w9JWRQnxwhKJmCn9fstqYar8dyX1wixziX7p5Qzej	127
7341	2vbLrw12bA3ZsRYzE3J5wvYHmFAhPaga6XfziiHVYzSb1cQr6yeM	127
7344	2vaBbsodga3Lrawpo7EYhNo3QQJgzAr11sfyHZQmXkJu5BcFvKVT	127
7346	2vainHjvw6ygB4hPTasomhu8WYz8d7Lsa46KDPx7fKpFDXm6wn8j	127
7350	2vavpniUi5LArU3rTMwLhQ7RD8AxQFUwAXNqrB4NVj3B1NzN4mzi	127
7357	2vakxvzmSWdYTcQD8ANhgEPQ2DpyFCTAAJmp6EkydprE7YqUyvms	127
7362	2vb5PvDkhdjksLvu9dS2yavjbMdDsVNWAcoChLrt5EQkTijHe9Ys	127
7365	2vbGNaDadTUtdcNeQC9dKBdYgxTyXBjY78P9dvV4v77ejdhLzP1j	127
7370	2vbpCiEbzTGZWpkbveS1uRPziMcoGtGhp6EyPLgrTLXm1ro9z4o8	127
7375	2vaY64ySShXni49Sb1GLSpMRCKGTQzZk1vr6YA31Fwjvi6thmYXb	127
7377	2vc48oR5KbCMvGnLw5Pp7yt6NZAGaUPmcdTZxyr65pGyPMrTy5Q3	127
7379	2vaqgrWJKAKE6YB6aAVvQbPRzTpUz1MnHNcXdttGAoMdCxQZjsCb	127
7387	2vb1D92soWB671eac195ZJSPxvFcUJG2eSuHRH4aGs9BjJFF7g3W	127
7390	2vc4MLx69FPefjSWnsc3Y237Z78k2Y7GMtHw1fkJ9rPdkQJMfyce	127
7392	2vby3eQY1VeXzPWz87QYVxN6DNuK6wPh6ZU6njz61P423FUG6id2	127
7401	2vbjbyUeCTSMjVajrrEURaEJNoELBvA9BvipDQLeXBujvpJo12Qs	127
7406	2vc35p9fynaYzsaUrMSC3PLnoUMVVuMjpxN5mpDbey7NenowSHe6	127
7410	2vad2sVPwGjci5ckuvkk9zGZJzLkoFoxpwSnTxzNTgTVdigo8pvK	127
7412	2vajo99CnzZs4qfhkPveEWKQ5b5srDvUECr91VL9faMHzHYQ6Q1H	127
7418	2vbD1KFfVRctciKuaWJfW8DD4tZt7krkHJmrjTVjTMeY8Mffr1zh	127
7430	2vaDyTFnL8XBvUZR3L2NU8apCfhFWeKzvhva6iYXCpE7BAiZFbTH	127
7433	2vb11dSNFAm4b9A8YX23cEmZTCujfUyzGuSHYzDoLsHsn43HoeNJ	127
7435	2vbHNF8sgWSTfVG5KsHzYkD4dLQ4Buu8QSSDNyRh1srwdQLQpQeu	127
7441	2vbqfEJ51xcmZFaoRd4MKqbywN3eJTGZZkX6wUyxsNsxiNMj3YJ2	127
7446	2vaQrQB6aB65HpbHu5deXGmho1csYJSBfk5o5vues3U5kjKcLUFL	127
7457	2vapXVhi1zDPZVurE883KqBHKxC7Ac7fLacTtsb1cPYT3RMT8mfM	127
7459	2vaFTN7PDpHUpZQvRjUSoYDP9UaAyrqX5YgHaXo8W9LE5KVGY2Rm	127
7462	2vc2nnB9LjexmAVRHAeRGQVd5uopP6Nvtp1HfGtsBK3dEiQPCZdg	127
7473	2vbtUfdZYJEq4S1TUqHjs27nYAniWDckW1jQUBwnB23GvqfUyP8J	127
7480	2vbDmULMkV8tWfUfL6xPiEtUjgmZt6YSPPhow8aY1uNF6ZHJc1uw	127
7485	2vaQzQZmfyeMPz7fSijNet9t6dHbdTnCXPnDowBBKKEMKfHgRksq	127
7491	2vawdscVSBhbtYZbambRKcMsRFUh68YbQvojJpeJR4skLXkmWerD	127
7496	2vbVZXgRMMWvvFvwVSv3qrnh41ScFTvogXCkiwj9CAwFixvCT8p2	127
7500	2vazDfXcWL8jRfGjcUCfKd5XrKotaqNkXzhdKotQ5uh4UvRUhyJP	127
7503	2vacV2suku4nRn4EoijKZ3HxrSoiyfqXVzGp5uduwqkNKaxdFoYh	127
7507	2vbHhYnpJbxc3nHFMzWGMxb6dJnKyAH1edjH5ZijGkS32zTkxeCA	127
7513	2vaG66jQDiBJ22RcchUPqskkjija6qJUb4yTE35aLdghTz3VdTLP	127
7520	2vbnh24NCPYbcjFd7ibXuCEDB4eeNfNtqRmuAeD1cx4DpCjbG1Wx	127
7522	2vam6FG6c3TSKcafjQNrf1rxAj6LS4WyvofgdXcmUUbwqw2twyve	127
7527	2vapGhxKzYWTQ1Km6iiRC3Bm8ELMD2AKZN6pVDtHYjQBE8BX6vqp	127
7535	2va9JXnVybomY6cYdWAF2v6XrC43CnVsrtwiRSrTXRww3kg5H94t	127
7538	2vbHrkEFaGbhT8hjdLEyNUhwPQsmLaaYhCs5jsuoFdMoKFQZUAym	127
7539	2vbnB9mJ78QKoBuh6c87pAHz1dUHJHCtqnDow7TNmcKC5qVug6SP	127
7544	2vb8VRoFj3sdqxNGPoZC9xGe2uH8xKCDk2qrpVTNaNDnZvLfMaQu	127
7547	2vbZj3h3uQSixfaUhMc4Bimf7nN6MHwnRsh2zPrdwubDVkXJ73Nz	127
7549	2vam5AywUqEd7Gr2dQyStFhkfxfyNBrAouwX17V7uJufBAb2Xxw8	127
7554	2vbWeTNjDEscD5b7srzoQGPBPb9xpre5Hr3SQ75h7RrgSUyKu2io	127
7557	2vbK5yLU1JUVK4wuDvvyqjbXPHDh557ZB3ocH2gj3DPhDfgubDWm	127
7559	2vbMuQjyTbCeCoopB9ta936VtVnmVRRUADvju96SHdYGxgaweCrs	127
7561	2vb4CYsv4mFE6NKRBjk27akiu8VBcmFpQm9AcwsasyTHf7p1cCbn	127
7564	2vc47PaP55GdQrVKV9xPynPKiphRNnZVNkcBGEQPMG1ozQv4DrbJ	127
7571	2vbZcNn8R2epXNG1SvHNAutmFx5GZGJG8S33SK4G975P1njzbSp4	127
7226	2vae9zq44h2SfdgJMgjZyJy7QuC3f8x2eZ56SP4AsefMtSCMHHzT	127
7229	2vbipmGoRRg5snXWJw2RgxmeyGPu14o9xn97s5nGVq1UNQCfr44z	127
7233	2vaXmuXM9o37FTQJ7yprcwnf9MeHHMoNdMNg5teV71oQkXLg3woP	127
7236	2vbTuaKTa6umGazwhezdWUD5RECLvWGJLBZefTmzhffXpohMiuye	127
7238	2vbtXFK2fnYqkSn5R4WisTjB7HPSNMRQfdQw1tACbKiE4j53NJXZ	127
7244	2vb4uPDTPLH6yvMJL5eWFyKEL7WZBsLP8nLjevet6Bn9Lq9BhNQL	127
7246	2vbK8KH3acEvim5QBG9SggEUtnQXwcd6tPMsmgCTXG1Cu8xQLJKg	127
7248	2vakNCfhfpDiJyYbanA9aJ3dq7pjMbhoMy5KbGBkK8eXAxXB9w5M	127
7254	2vbrCxKyK3TA4WtUA3vCdxTDwzf4J3cHC2hvF1AeYu54PcEgY3o9	127
7262	2vaqdFcG4o1WyfjUXwNHAYh7ovHaKh4GWDiGe7KrZSoRFNkPH8LA	127
7263	2vb6rJRuxPmJEtQuzUXr2EBCLKU8uRfyRmf1RUd9C89XcQDzakgw	127
7266	2vbTBP65TzH4sC4BEqqCSBXuPJK7hyryKWqKFwdYoKGL1MoXf71j	127
7271	2vc3Lb48zKPEPe6a85Hfvsnz8LpncEGSqztozn3454HjqT6JgeSF	127
7276	2vc4vhTPnbqMz9tWDnqYRNcZ6tof73CU5HQbUrFp1pXQ5sJZiWbn	127
7277	2vaz3ut5mN44dzYwUJ8mpSZb3xhpWMJE1E1imLXS3jNYjW1wiEqa	127
7280	2vacGo2PdJpeLwNhqXBz2kFZnUVKGFFUEjqAMTL5sF1vrv2BfQZg	127
7285	2vby5ci49beXP6RDjDgugQTyEwnoCbgEC6paTP5hXCK79yxZVQS9	127
7296	2vb2GTaitBtSXLzoVaApzd7D1wBNnEjFkPS19wuRKcToLpshywd6	127
7298	2vaymq1hKHVaya5BxjceeKSC96UDTQ6Tg7KfSwp8XgMPYA5YwkSA	127
7306	2vaQSoXGSUgU5iJ9MJQrwjnc7DDNy1ck9WWDLoWJXHkMKLF4gmc4	127
7315	2vbavuFPvcXzV7bJWphCPfXwexfSeCKC7eDXZwqY7v7MkscBP2Bo	127
7318	2vbH9hyeyTK8KCawuJMzn3ryFMFE5ep9gDNtPo4ENAcTFJ3BEokx	127
7322	2vbvM7P8Ph3V8r6GtNLJrDNN5rKQZP66m87jRmsextC6xw9chNuu	127
7325	2vaH9mrWshGwvAHZFiYxFVcKzUj2kmciF3zeJve14vuBnHPeAXB9	127
7330	2vbEsRgpy6hEnWa48syu7rAV5J34C3NxQRUeyWXTs5aFmEikJ3nQ	127
7332	2vbcN71VT65KRjfUv6GXrUT1WbryJJoBGEBcL8h3yep8UMzX69MJ	127
7335	2vbAbuHHBtEAPQJ1zcgtSgrMxTPGSR71GpeZRDKMP9UKibuBuWSV	127
7347	2vaN2ZZxLWA1msrtER9XGM57H3jJPq9P3QQeLbuD5NqUtFyhZTh4	127
7351	2vbGLZkTeaupaisPLKmyepAnFsRB89TMD9yc2dCiDWTQQHYdzdoy	127
7355	2vbT2Z2vq2eVULvdMkcwwsD86ZkMkVnLNnRRrvqonSkWWrkV18dz	127
7359	2vaUyufkf6CsoWPsTpc2aRDQFL11N5z9r8HfVVcZtKkwb1q4amyo	127
7360	2vaG2JVSf6ZcxiU4LMp3NiR9uKXEHb7vBeVu9o8Ka2jSy1eiYDLV	127
7363	2vaFURvL446AxSP4jYX54E4GdBfXwbDm2ZcSDiypPAP3wLcrovvR	127
7366	2vbKkurFTrKeghJeXTwPwyQmSFFJfDJ4exGBW5AEeGxJNKG9Gkfv	127
7368	2vaqbTmkn3xMtkpoMJBFF5HVFw7BoEBuoTa1ty442jnBZk2LhxjN	127
7371	2vb5EmXpPBiJFtYwYPAxsYbdAhHXexbQ9TwWEjKZz3oVoMgiGp8J	127
7373	2vaAKMXD26dhmTbCpWeXjJnVNS6AJJ2AXLECNvDbmmc2QriyXktW	127
7380	2vbDuu5xjXnuaTXHvATVLUqyboVJPP7WExRVdHLpkPaZ7m3aEzh4	127
7385	2vbNrLMSbt3cbLTWPiXPuVt1KKhudsmNmvXRaxG9cgTSt7n6ZotF	127
7394	2vaC1WHjS8SYH1x5o6tHvCiurzotMUbi39sGnFaiug2TKG3vxQQf	127
7397	2vaE3UFB1JKZir7XqnuDrxqg7zmZuyjdWB2U6YnMioVJ2F49uqmf	127
7400	2vb692kxpNAWBRYMZPCZdpNHA6rByQdBx9q27shRJTrVfwULFZ2e	127
7402	2vbdDp3EbEQcLcwDM6n25kqtNcUK1xe4z18GyUPF9tSSANLT3qz8	127
7408	2vaSdACQB4FsfuGT9VLskN6bEsRGocQDjksEbCjo9o5PFndGh9RE	127
7413	2vazmViRuZL33L2XLZ3FZkosRj3kcgBGvCkyeHd3xhHymy2E49si	127
7415	2vaP9e3k9AokM2hqu6srHEMo7hk2MP5ypU5Ygy1VguSzAmwFNMx8	127
7421	2vaeSWwdmTQDyeRh8e8F8wvrRfF3MGaysoL6QU1E7H2pgLK4Wwy6	127
7423	2vazgqdD2BhwPGrXHWV8fWdFJVxdntJTSGRCU1UG8cDE7gHRhS1k	127
7426	2vahscBuHiY118F4amuQc9FN6tgWgiQwMKSo5LBv1MH6tCGCySds	127
7429	2vb3Rjv6FWiKH87ex5MbPaK6NYDuLbt58rNkSL39zfdxEonsvRMi	127
7431	2vatZmzDfDNQvynCs7MwQ5qFabmQGaB9SwpQZBMixz587cbC4aYh	127
7436	2vbiW37HomWMCLdmELZyDgGZT9CBdNo54ubLkDZaYhxYoFUppL7h	127
7439	2vbRwZiUBomAYKRcJtRUubq5HQx1KGjpjPAdZpQufxCHhsjW1mg7	127
7442	2vaKPkf7jWnJbxgoXd6QJGhKh2ujDQHdNUvizxGpdZLnMehDQUUh	127
7448	2vbCFJTKPuJMKhpesq3RpzLANcDDFPE7SEVaWmMmzaqRfN3UAY4z	127
7451	2vbXrDihks5TcVYnSQxMgWAYYQwBf8C5gX1dan86RQaiNQVDv1rx	127
7454	2vbPrjPDqfacrAeLp5qYqqzyUNEKxUQXExn3xkk9v4jHMY8of8Fz	127
7455	2vaPyUUhipkTJXUBSLymP3fmshSsacKn57nxWEPxbsuHfwRb5DGQ	127
7458	2vatDXad5wnnuUGiHdnwVJA5TovzuobAh94wfuH5ccp3obrQZhRc	127
7463	2vbaNipoi5gJjGPBJ5v8423YKQySbXFu8FC4QiRKQoxiMNSSWj8w	127
7464	2vboPcUGUdgn8582ptcgXWVLMMMkyn18Y1DUm37Uy3HrJVbcEiKN	127
7469	2vaUZcmgtZXvZcHvKodvaNWKgM6dQdRs5tnCyaJbVw73CpK2xhxK	127
7471	2vb94y42h8DhGyiFFEeQ76L33ps591faEn67UxNPa14Uy7VgqrV6	127
7476	2vaPy3yNtaGSUVkcpc7dPSjCic7WuVL2cKYJqcW7x3RNGZbrteCQ	127
7478	2vadxUritTCD9gr3ASt3t6dAZH8bb4zmFxe8DtEF6mRDjuGZjeJi	127
7481	2vbesqMVTJRcPUAde8WY2MCyDQv92XgJuU3NkntcRhUprZDQPQCx	127
7483	2vbmcR7DGa3iAVzvFpCxnEDbudjFpd5zQ5sTv5r1y9HnYhKc4FRa	127
7486	2vaLbv1yjjUYX8nd3hffJJ4g9YpgPvs6StsWmDcozA1aBfHA94o2	127
7488	2vaanjRNxqX28FvAkgfKKba6s6jBcAxSwaMq8yevev7Dw4z3CdSY	127
7492	2vbdnrUKK2Va8bXvLTyYkhR6QPTiXogxSDaoHtwFvTPLjTvyAUK4	127
7494	2vbqCAu2GWKrSx8vYXRciDumryf8qrGfb75AZpkJePm9rq7u3Y9K	127
7497	2vbmNcbRnjJieXT75auUToN2CYgr6y2ro7ogC4NUb6jTDgQDtUtY	127
7504	2vaKxQPLARQHCUb6PMK5gGr5zHBjkz1S8v1rE5r6us1HAxFckKmk	127
7505	2vabyfs3PXvTnDRR8QoG5khQFTvp4GdjeNdQ8s2arBf1zZMbeM7W	127
7508	2vc5QWYA63h4hZUtTfXfnkj5q9ysCaqiohS6aETeYcXWUjFe4Q3o	127
7510	2vawRLLrAxfhQ5cLXmh2GXYvBEHBGVQCrdhj1V3AHxYPoqfBLbJi	127
7511	2vaKnEraHCgcAm4Wr2ftrDgU5dj32LubgDSUgWNu77huUmaDwk2T	127
7516	2vbQ5YxNAaLMLDQRKjXEcdVs5sv4w1tG1QiyAT5tKNbuZVuqLwYG	127
7518	2vayartHutEgwJi8XMmrWp2G1MGNGB8kXhAK1RPsSt9azoxEUGYY	127
7521	2vaHywXW8Jysh1H2UNaZqeYF83Uxe1rUZErbyRp5wtQtAnJSzxtr	127
7525	2vaQqiXLdJUSSrhg2T6MqZnd9nWkKShcFv8RbvqzTJWAeACJguhh	127
7528	2vbxBxwyAvbVYCDi3mAEPZ7b5aYYPhB6BdGAoYypFXEQZoqoJGBg	127
7530	2vbQjcoaDA3ZW7juR59BjpnDVtMDBj7nFLxZbF61yoEgeuQ8Fgcf	127
7533	2vaJeKMTLLpqMsWE9KdUNmqDRfyf8J2wdhrBTTuTZBHdsU47kovA	127
7536	2vaTzyNBLmXzWentB4BpbsT5CtMq6Akvc2Qojyg25LHPhiSoJVYW	127
7542	2vbshWFAvju8nzLNU6xMVuSmoHXVQcGwzhEoCxyGYFskVPXD58Ct	127
7545	2vazvgj78YdUfEG9yHF6FJoUew5jz3Ee2f93AnK9rThUWtVRLaMJ	127
7550	2vbfDQyE9wVpnYDGRyxDNZv3PNYKa56K9Yfyx5SGnFzfcSU8tS2e	127
7235	2vbYB1KriMzpAo8LVgKmfHPUyqe6MdBawRn7hmeksLrnPG1rTy1n	127
7240	2vag6F3Kemv71UtssrVZZAmR3h4Mv67te9D3Sb8MDaLzZv6eCmfv	127
7242	2vbo8nNqTAiVhY5kr9v36jYhk91oyiNqaRgWQSAVZwzyQVUaENhQ	127
7249	2vazyh3QQcJDoqJZ87tvrdL6SgUuFeRu1o3DgcPwhx5CGsxpjbRG	127
7252	2vbButqRTBX7MGi7n6SdWYMTksrt1f5NbRuLFwETQvQaAw2DUo3t	127
7253	2varzGCMQ5DL7kegU324uPQDirCGjLWhyuGxdctLtP6jYQQLaHHZ	127
7256	2vaj9XL1zZyQerXTA3JAMoomqw46DmheHvbKzAmeLekXaad6FHAN	127
7258	2vbhEj3qDGKxgKqDWkrBgbHKmj31pjWv4Qg8ipgoceiMqeXq1QcL	127
7261	2vbXR23ig99KscWRdSyyGzYcvWvx3s8BXtZa3aiDLuzZ762BvCYF	127
7265	2vbF6rVaVV8ZhbZFJCjbjfqFc4pLakcLD7TKVNaW8RisoA82Bbxi	127
7268	2vbLch6SRKM9pTpe2JyTEWU6JXyUR72ExrJYN1t4DjqVmJZnN8Qd	127
7275	2vbXWiCnyZzjQL6ZPckkmM3FJgxLVH47Dje2N8HVDB2bKY7qecT1	127
7279	2vbtC3YRTxbyDPHxz8ssLNAUfrPJ1oBmZ2u7ccfwdrwUp9TkkYGM	127
7282	2vaFPAHJitpXzeBbv41dsYhya7VwCXG7QXBArQwNH9wwUWQiVuGF	127
7286	2van8V2nbErJ4MAByEV5HZxrY5bhAksbDRLcfsFf5MMu3vhzgWvG	127
7290	2vc4Z21F1eJy38BwF4KW7PSHzXe8k2Phu9yUgWoVdaRBBFkwr6w7	127
7293	2vaZqYXYuKHq5H5Hxg5YstkhSWgKBb1e1zzuyWzuJKoG8UcLg5Hd	127
7299	2vbKd7zKC2AYiGXczwzWxpaeWfJBmM8eXu6JHeRDDX2sieQLJiN9	127
7301	2vc1AWHvJ7WErziZG2gwy8AytpGKsAo9GpyoRxm3uKpRibmSu34N	127
7305	2vbKR9TCYxr6LyyXSBRucHJ6xNQQzkDXANBsJj8mWu3sfqfVR1GV	127
7307	2vbqkiUDaTDvzY2rpN2VNF7HCK4neqgU9CvMb2SK3NdjsuWb5Fjo	127
7309	2vbhbv9k4v141NejMGyJZHPF3TvhXhtBes4dwR3iLQhgzQjphEMr	127
7311	2vaVjiqcE82xeuUGP9QauCkoCbTvGskBLqsjaM452yyYKMXTDEVS	127
7314	2vayrYsoRxa9WPzNKGvjMf7VsFBvpXGuydmoFAWVtchA1zzcYPKh	127
7316	2vb7bYAQtPzxQE5NmXyeK4ZN9jjCucXhYNCHJ7MAviKjYgpBcuKc	127
7317	2vbWhZ9fDiacgaHQ4whd4fErCEJ8qSsXQe7MLuSY7rp9fjXu8ds7	127
7324	2vavdSnhpLajEyFg7QJEpFDsJV1NGNbQQ9YAtXeqwHHX6j1efdvs	127
7328	2vaXH2n9FYQBUwuNrZ7X5ZsS6xc7kHXos29XVVp9SNxWbb6ffKU5	127
7333	2vc4oRGHm5nDvFmVg3kksqcHgPLA1S1U9pBbMSVSuD1twEpNHpEB	127
7336	2vaBbjp24M7dfovXMmAPg1Suj2XXpFuJLGpNbJkWFVSHbw7U6zrr	127
7340	2vbxBQJC7BJde8Xh8ThNZitn47mGAV2Edzj3VPMcGTnJXbs9UnfM	127
7342	2vbtWHrBcenwbMS6ASXw26qFYUhYdmUAwkuRCkn6LyouYy5wnX8z	127
7353	2vbnmPpDKwPDAN4j2DCtDyp47Ko2BwhLEm95w2HGbWP2vyyTrfFE	127
7358	2vazyRbAMVR1wBhHXKCyuiSXXurd1NT4DcNuxBxzxJw3jJ3Fdcgr	127
7361	2vbyj4o2U9tWwMNdEwKTQYH3vRkU9SYeTqLvpxazqqDoRRTuwK7s	127
7364	2vb1vszNJm6ZCHrKBavq3Bcp1tR1EiscBS6envtiNGDMqT8GsDwM	127
7372	2vamjYXUGfkJBns8kLrEyM3NbZvMA6tTFwHmnurMz3nF6Q547mME	127
7376	2vaau8ZZm8zPddRPT9xSq6EW3sQQNZ3guB6jNjmkgub3WkJMFg39	127
7378	2vaYmX3wNMJEbn16qGVJUkpzuGNVu2JfvmRx21nNWWZm6m9a8J1Z	127
7382	2vaMRyBmtE1xjKWSAADWQ6A9LoyhQnuA8paDYZjHPDmWxLU1tcKz	127
7383	2vb4So3bQTaJH6URjFHB1YcaTCW2V1V2bRzHKV5XAdrgRPt4zbFz	127
7386	2vajUN3tQzUN5wp1rxZbAyiE4raFDNaK5VdPEaQGFeuQ7VXH7hQh	127
7388	2vaLf4DW2G496A4Ur6Zok5hkCswPbMrMrijNxgjatXQT7Ew6uFtt	127
7393	2vb8X6S8dMuW5pogRmJ216EPNij4Npim8GRVaiGYTf34pathVF4Q	127
7395	2vbANi1fAKkTLVJ7j1KYSxiJ7VXtD2yQAQSHocr1WXhSQpc5DuhF	127
7398	2vbCLVbJ5WYXUbcApWBTPHF2NfKVm5faVaor8HpE7dZkoUmkPEPQ	127
7403	2vbYeZmPRUTnN6TxmHga7YNSQzoWGBMg5qyNWJMkXejrrHPEgrhk	127
7404	2vbDUyU1TdcrXFsDE4ACaSBAmWuEvu5FNLjWX53iA3R7iVwk61tv	127
7411	2vbF1W2rZZNVpaj3DK5CJu1ctAwrjr5VmFCL7yxWDMDYYtnhFSJf	127
7419	2vbmJ4FGyMuLFcrtVHw4VLrNbAshDwd913bANLW55KHrpzvj8bAj	127
7422	2vbwxyAdBZeuJJiXUcDZ4JmrN8gLUezDBmEnwW6QHBGdmQhz8cmw	127
7424	2vb9huQpd7i8XWDmLEUHDXFxJHDXsFbqrwDmyzp2VVAVa1oagkxh	127
7427	2vbVKeHZmHFFm6TW7RGYQRD99B5N7cmoCzSqMEQ472tpqGkMJELa	127
7434	2vb4XUhug5fggA3ta1qLjiASM3vqnRx8PC77Pa6684KfQZnMVruj	127
7443	2vaCZiJjDukodQPAhmzCf82rbgxU6YzQWpZQWUqXScNKe7y8yyPs	127
7445	2vbUq9p5YWK52Jh8fid47YEwYxhSNFufS5teyX8Vgqmr9o2ujbpt	127
7447	2vbgme34bdqJrgPwKjAD7p5AFb8jnsCTfE1isVk99e7Wn5RsL8Dj	127
7449	2vb5beGeKq3wUgyAX9JtKpkaFZT7e8uffBv3vF2ZBagkZ6JSgYCc	127
7456	2vaUKBy8iHa2gKEKHsmYrmMXkkKQa8VKZC9JQz3REaMXM6szbFbT	127
7460	2vbotUUHsozhBtk12u9PXNwYYdV3xrZXTfYrP1YD3CBHSrEn52fo	127
7465	2vaPjoMtMwu8sdPsafxahQ93abWsEtp1DeM6FaRmZNi7oaGoboGU	127
7467	2vav8okTSD2MNRdjeDdSN7xAiGSAwkQPNGygutRWKEk8p9UTUi2K	127
7472	2vanWPkJD3uy6J1zRuz4huSLHeeH6ceYo64sP8LVqWAkfgMLnGXJ	127
7474	2vbs21tTpJYEKdjHSXrqitmPDbo1WATwA7Mi5SGzQrB6reABL28A	127
7484	2vai6ipBhd8ZeMd5C4yNvBSekZx1AjdabJZFVHjN5HKdyFFsLRq9	127
7487	2vbKaEy1CVuXrTJWSas8qbebe11oeAGq7Ud3Hq7kweooSyc5khqj	127
7489	2vbqSipAXkt3SodfX2xjFu1Z3ZoyjG78F4gQGqzFFYHSmEFcgEBf	127
7493	2vah1ACW9MWkKwffANBb3ChxeZiT5hqyhze4v96UPAGhXc9EZhPV	127
7495	2vaJc8WYAZz1aEo19jZdvJ4kuwAVyh8DPfMGA29w4CmN2UwJdGWB	127
7499	2vbxrYcReuwr4ksHZ2rdE9VkSiH7QrC6oKcaTUV9n5Htfj3KKMb2	127
7501	2vc3NNSvNc6qGSXdDpqSxwioBgT96NSiuqpTR2pm4DAzaX7F7V7e	127
7506	2va9KrTFAxAJ9po6kwZGyfgbmkc7NgamLfRy94AVqr5AuMaXvpcr	127
7509	2vb6xxZHS5DLSJanrGPM6Wpg2YqE7x3q4HZQqfpdhnKX8ywujzPW	127
7514	2vboDaoBCDoRE8iFWN8Es3AtkXetvvTvRFTSKRHRuaZ4F1Vaq5se	127
7523	2vbG7i2yTHohdhNVVAQTWgDQzQ4EhhikzPvHbTVW3i6bTTGKQh67	127
7529	2vaXPcmz4n9g11MxNQCXZkSEcvry3np6MaDrqQ4xa3EW8wGzesGM	127
7531	2vb72tUAxxv9WsGu1rrvk3GMkkkWixZ55s5CBMr8bb28rjcBundN	127
7540	2varzpSqvhH5BwotKWMhUUUxSKX4RWQpcZxKDT39XXqufCnppf9T	127
7543	2vbtnw5NoYzK4DBxWDNPqrSnnVk8NjwbfykaMM2ST1kRodQBT4z9	127
7548	2vbXkcp1pmz9qDrcEt4ZU4epz727tMFJbRYKgi4B82zsnB5KcR4U	127
7551	2vbhsNPP12M9kTFKiWpzqWCUxCCEn7SrTAdxg4wFSRTvkFgEiM5o	127
7555	2vajLw5tPHj7M7YCGocAfgoEQsUSTdLtWbsmFRYcARmRE9LfwwjT	127
7569	2vbP85a81xy7uNwomQe4je5qLTR7FPH6Pjthhx9CUTaMJxk2Hj1C	127
7573	2vaJQ5tKMhPmYNnsk7LHBVWWRbtA5wvYvpMufscvzBbuXD5W1zzt	127
7577	2vbog6QZdSj4w2vZ6gPtZqhnx8f7THABwLasJQ7SZMkCsgZE8sj4	127
7587	2vbeFxznj11Ho2wk1zLpDyhPC1jVc1EuN8PfjypQNWTae3c5doXf	127
7243	2va9J137jUHaAer3ayqTxjxVyfFCkWV644LMn5J3zPzWQJBdjnjc	127
7245	2vbyALYToeq5KH6KotTxQqcw3DzGWTJRRTpGp34ZtjbjdvvRetWM	127
7250	2vbJ3Qvm5MwcqhG1vAR66aV4pJJsUusY5ygCV2pScZp1rFbvXNjM	127
7259	2vbLQGLmxmLFFSKL6AkDGK59C532WoGbkC6h86d8JGYGr3EAdgg9	127
7270	2vaP9z9WwdR7gS76DVt656mgXFaD6eXtPiU3xYFWoW2WQtKsvNrm	127
7273	2vb8bxQj7X3QFusywQqdM2SxCv36sL6ZQ1hTpPyrLRii7ZQkjV3m	127
7278	2vat59n2URCAkYiAMFqmav5Vaj7RE4hUfyXvhTnR1yLJQDHQmkBz	127
7281	2vbEg6Nhoc1jrUryLEFc5vQVohfcauchF527vvu424jSXcv5a7UV	127
7289	2vbSE3NgyMPKtisWu2jaMCyLt5Lw6tHdFDZP3dycEoYVx8bxCi55	127
7292	2vbXkK3JCoDGR56qDEeFs9VBY6AJJ2TXfsgWtXTtMo4DiX5BCwWa	127
7297	2vb9GrSCL7xT35JEWycgAhaK4MUEtQZBrc8BcNZrfCV8uXx733sG	127
7303	2vbUn7HN6VFsn6whY2fq9zDuEkWBUTSgqN12n5rTthNeHgmRM4jE	127
7313	2vbhCrMCLgXC9dexisFRs75iwF6X2oh5c3doEepiS2mUQovw48yi	127
7319	2vapaB9YJwsgerkrSLzNrsXGHn9DRpPNiTgD3QQ12LaPmgPe8SCw	127
7326	2vc4yT6NqtzwsQzQmRwPU79Wh6Z2YDprc3DJJ9PkqNRYj1vEdeMY	127
7331	2vbKP8j5Hdk9pBEpuY6CAENPTrrEycMQq8Xu7JGE9zTs1Dk1UGjk	127
7337	2vaHAEwPSXu84upbhCjXSS3GmhJhwvtmWNMZMtKesqZ235ERsPS8	127
7338	2vawyLWTho5on58r6KANK6rEb5y9eYpkcr8wr4sUS1LoaKdcxLVN	127
7343	2vbrm7JT94q4pFWmBHtAXaRCfapCFzTBcR2ye6xvsFhMGEGywgXB	127
7345	2vaAKvhWcLbAuBzi6S5Wzeot61TRgWESJ449UgU1Xf8Hu98L5FvZ	127
7348	2vbgPbMEMNkWSB24mENJ89PKj8uBtFiRUEuChacBt49WuEnjMD7j	127
7349	2vbHFjrrRMxiucbcmxcyYCUDf2LfPRxuDMTXySCx6SzaB368HPCv	127
7352	2vaY9VVjK2P5FatG8BwYHJ1qJ8sqcAUjFX4NneqCSy12veBcNCao	127
7354	2vaqiAw3jZcx2BGVv2wektNjds9X7jwA2yj4DsScJvwxf2ZyrAq3	127
7356	2vahVFP7Hu6w5weEXrUShiVVJPE8f7FAyAbVqbZZKoziga7csQ9f	127
7367	2vb1VHg3mrMZqfpXBSsirxYoBMjZpudQDw3aj3HMf73Akg4Cagt3	127
7369	2vaLw59z3VdDK5ZQ76sbc4e6Jx6ps37QEZEcxhdbKtUEdEzwGT7A	127
7374	2vbwrFak4kJe9U21c7854xYWrAmumDw6njxYttvY6jkLmZZKxpqR	127
7381	2vatEHdgq7SYVMQFAJEBwHRZt4eiYvaEeuU2sJGkKJM6RJkmFHnp	127
7384	2vafj7izKXHWJMS1QU3HmM3N2vczV7xHB4vwZX7pT2jug5wja1FD	127
7389	2vb1XoAsEqJ8shRMXeGKyfo8XrBLSHtapPg3XPYA429N7E3PfgpL	127
7391	2vbXMSxWPdrX4L9G4btphtkpDLR8J3LvjbzTi5UB57PdJeSMr2pQ	127
7396	2vbtLcuyYKWVtJAsxUXhbZsCmp8rqkZRUui9LjTCpk1d1xzodiKQ	127
7399	2vaygdLY9ZDXNTe6pBPE7ru9DYxkJ2zkP6tqANnNb4NSgdizCLuy	127
7405	2vbiR7JrMQbtQeEnyQe21NsVd3LzqupauWb1vNyBiAx6EBj6s93t	127
7407	2vbPTGa4s6ZbtbdoaZz91D5DGacc9m8u7tYXthirfzG4kQEtFpwD	127
7409	2vaxkXyXYCxsoMCCN7J9RXH6PYB6W3f6dUxVVYLccNYLekeX9kMR	127
7414	2vbpmJCDeNPL3KDdR8xzxDzMaiJi1qHoJuirPLGxmZUyxWX8TNPB	127
7416	2vbfa7qKe7suYrAN5xYoipYhfSvVs3eTdHEBZDyDxWGQfLBre4ov	127
7417	2vbgnvgf64xrEAExKNDsuJacgxQo6EnG8GDX6DpnVwqFU71J9fEy	127
7420	2vbEjiYTwnAB4fk3SK9Lg61VCdjxvxPc9oUtdUJaxkDaDyCfCWYe	127
7425	2vbfMdXnJsVY2f2ENsYdDxWPR73Xc5ULyp6e2ybdy8kcG6eGW9aN	127
7428	2vbqXP5G6ony7W5oWaCGX1zYF3gjqvaA1H7L6R7ozPsf5CBiuXCZ	127
7432	2vaK71WLtWrfdRXhZLpzrF9qanPK68NY95ep2V7tQ1hT1XBuxTw5	127
7437	2vbQNmxEaGqTenqrCf33gVXSi6K1NdErfoU8MVyu3VWhnQwvuerW	127
7438	2vaCu79u2NevURQ9LtUtfjcgaW6obz8PX1ZkXwxYtSJ7hGsCoK2m	127
7440	2vbBG8mUg2t7vfBvyDXqQML8DgZSND8TKtBrtuE4mzxb9F5xBYtf	127
7444	2vaMJLZQMusQQMjN6bnReZdwhYhGYvJWRucmEh2fzfNDkq11y7oJ	127
7450	2vajg9xGPLbnraLaoPBo3AZ7EMLNnKvyc2TqXn1P8RxDJLzCSvdX	127
7452	2vavNZAafZK31yvvV6Ntu8iwpU7D3UgAvz5Bp1uN8jjrn9GANUeq	127
7453	2vbpneMviAJaLJe2jvhTew9JfjEPMu4gerfTezmba5VwWMqvya2A	127
7461	2vaEVgcPV5BQf1AF4r1bckJTwNW9BjSB2ZirKVhDgU2C2rZrn3LT	127
7466	2vaPhpd74V6aDg3ukLWzaWD7tkFFW4gfNtaGhorzjzdo2iM1z8ZX	127
7468	2vaNY8P4hcerz1hRBedkFU26NQmGbrypWGwWSrKJigWhQhbK3rDz	127
7470	2vbpWp6AviNrfjzrAzL7bkC56z7TvVy3tzNfZpitNhjcXCJuKYWn	127
7475	2vb1k1LEnQF9hHcSXEFMANxsLSmNXdwT8cZ1zReDrruuYCAcnssv	127
7477	2vaYypuTQ2arVZ8e8Aa6F7yLzoxppBfh4iEnwNjLkAH2KVUKgFCY	127
7479	2vba4XEMvRRfSaToKAKKD3mVfPVTJXC8JoPKyMZ39chUnhYcjJkU	127
7482	2vaaJNUsMtVXm3jsuM5d3rcBsGGdc4ggD3MQpvBhCabXdjB2aMtL	127
7490	2vbjYAJnVgNaZNs9YftUW1uBgb5bee9ic9yPCudGbAAYeboWD5Pb	127
7498	2vapSgoPHm8ytL7i7LrRHwNjoFjG3sCdQCCji3ZPC2ZwJpUVJcNH	127
7502	2vadLUV51oXcQjYoX99jc45zDougWnfFfKsyYKhY3PgtWMjYyGKQ	127
7512	2vaXKZGskqkc1Y92izrPUXjStwDcdsyCVqvbBMXty6zaNPc43Yqc	127
7515	2vaktg2f8ovG5WGqCx4nFoeQ8TWrkQb8ZA1NRUj1gkBmzEZp1NC4	127
7517	2vb5SmWpJSaYoiBs2GgWEqkE99Q3Dye5ZXiEoZ5bfJMd6VwtVkeW	127
7519	2vaN7A5tdjot2Km2NTpaKyyZ6XUFH2NG53sp2CPgpb6zHgzBNkrC	127
7524	2vapEfgdsEEYKQcbTyvzGGXzWjiRStnPjk8hMXg5LQWrY8oaoJiS	127
7526	2vaGwXQ1FZqzkVZB7teBVPe7mknFtxTrqZCUu3yHYdvTspySGu7d	127
7532	2vbmvqsjd9NYpCT64Dk7zDHfVzobaHjXb8CZar8V45Wj2wJaFz83	127
7534	2vafjeC8djA2iBBUUdrxUC1TcQ1Pj7eadRi1soESRrPW3wJitm8s	127
7537	2vbKVFyyo4NbBq8T7SXBpJLYWVffUaUiWBqF9J92kZNU4jeU2pit	127
7541	2vbPHeFH5KCctREQ4JCZpqqkFL23RXjnEWBwgPNAj7nQcqFC133L	127
7546	2vbFFZqNENrk2UCDAKq34rw959iJMtLSEP4ruFS3URHEUYjJRU4g	127
7553	2vaChqH7JiMGurfmTg5CfRn8kL7moPvtg66RAFy3sn2fLsHtCGrE	127
7556	2vaRj9TieLdepm5ukEcXk95fvqUcmyNUZorLeAGjxvtfdrp46Nta	127
7558	2vbZ6HhEDUUJyi8kNKLBJkr2bo2xhbMc8js1rMtDhHNxyBYZqsRQ	127
7560	2vaifhkTHm14fqqPq83Az7AgkbA6yL7zhjmSWREih92qHRbZ2Qt6	127
7562	2vaBG6y91yPjtkwr4NrXYCkh9Jg27zLgwjXtHUaTUo3HdLbSiVwt	127
7565	2vb5aKqx8nNdTBS7evABN9FBq1wXvkPKieogK6DRAnuFEV4zgBnM	127
7567	2vaaX8zpfGarKumkVYDDHhjwonbDiR5dwZPVkigi5QWowNMkKE8H	127
7570	2var4zBu1j93RZNmtvLVJgVQN4Abgr2TFHRnwVjdyoJEhSbBtjx1	127
7574	2vat26cVmVcBhwjPKQpWuSzv1TCK1bV24JujWNp2XKBbn3Uk7Pju	127
7584	2vaL2Kzhvws2fTRJvRahvoM816WADy8rFRBmngFjKN2QzLV4tEaH	127
7552	2vaVgEM4xxX8qiw26FsdGCL2gyWfL5nZJNxxvy5WvD8ZvJX24Sob	127
7563	2vaD9x6uUW5aRLo9MtALnU6uyeiR1vYWmiGsoJ9JtYCmQvTJU1mP	127
7566	2vbot4WHbotEX5sekNVp8eZSTKWRLbrRybX56t8tBL1zcrqmCyA2	127
7568	2vbMcuGmRZiKWaa136BzVWJKBjVTT6cV2ekptnRXxoJCKN19Lj2A	127
7572	2vaa7UavJ2vmE2TRwgNJDHFaqKibCP6D77h5Qxg8tFmWoUwTB5bW	127
7575	2vbNhU9cYftE16D5qwG8YFviewe5PG7nUbzq6TR2RBt1BAKrL2pm	127
7578	2vb3KS4hYpAXKe2HW4kNhPZg91NJRKfoaJ2vpccUjxhnd5iuadBS	127
7580	2vaAx74QYqJGc86xBfMBzJN2fQ4RiJizMkDXtEWw9eE5a8FERiUe	127
7582	2vbUb4CKBKXN9piragjZZng1SPpCoCDLfJuBGCP5HBQWysuBwpF5	127
7585	2vasnhcnHWj3bVzzdJ6YZo734dsvHNX1LczaRoar93se6HPGcv7M	127
7576	2varwvZPKg3nV4HoF29QrwmzQd9pqywVNHjfQZyY81XvWKwnGsuc	127
7579	2vbhHLRuno3E7P9WuYpYUs4RPzsws3FHbnBrhnJpRWYH1BHaHyGi	127
7581	2vbkUETzDZkU41o3JjLt26sAcZoh1kVxG6DgR4484Apzrx6eH4Ei	127
7583	2vbETYZ5uA4z6X2UUyb5uZXE8qaL6nQZ76az3NDeQsQKSdTeYEtC	127
7586	2vaKUA7vSokMPL8nFssH9FtFZVNtM2wUTYhKwttjtoUKDDz2B6Uv	127
7588	2vbA2crqhD962fnTWVLw3eg8bQv2tUcH5G5aaUGPosPmU1APdUkM	127
7589	2vb5uQ2SdkE3GmsjsVDTXtGNizUEDjEdzT8EfQpS5y8zjM2vP8jo	127
7590	2vbB5SzkZs3rHy53dBQvrCbetcg4cKAnjWZmmmPpnGQogestGx6V	127
7591	2vbjNbdwGk5HL8EqHxStTLfsj5urr4X2oczMDyKdvuzoro8yfPhs	127
7592	2vb8Lg5WM1R3BB82RmFUXeKEvscCqHfvBDLtFH6rB3LPKm7yDVuD	127
7593	2vbuPyG599Scnhf9esdLmG1zj5fdL6Wp8kt7cEqn4bfaHs5tdAXB	127
7594	2vbUht8ngvauaQTZrdaC4beQfwuacvzzGcUHqiU8bDzR46gZdmsV	127
7595	2vbDBHqHesnNSBmjDLKvn4idnXNjSkEAFQFtjhMT44MK2ZiTrHKn	127
7596	2vbmR1VeidibRvxLf6pGjWaLHnYNYANFNpmCDeHc5vACnGKqyubd	127
7597	2vbwijTShUsFaYfqPVvXj3i6GeUxnP4nwrWV8248tSVTd77XTxEo	127
7598	2vaUMcBgrnw89Mq4uHNHHpo34KnEaREGeQAxQWTRvikbY74BU2mr	127
7599	2vbb72kphfr7bgXRecmJh1a2fQ6EZsLqrUC6xtFFHCYp13FS96cN	127
7600	2vaQKozuMJs3QrSKKad1rMXpQ4igyJpa1B4cP6eZNhmYt4kqWuZ9	127
7601	2vaLNzthagzzdCTEtpvsp4L6nXLAvWRqNCXAsxr1rpiqVewhjXpj	127
7602	2vbzXLZqLbx75UZ2r9iP8iM1XSqbNoRaBqErmKokM7ePtTTAEJZF	127
7603	2vbFSnaeP4wSyqb3q5AWwymx7uTyR2vGSbFSFJrc1MgvnLvHk5qp	127
7604	2vc5ZL24CNezFXKSiVfZLyhwV24eGFTVPxr2xXd2vWCcnJWG4h4w	127
7605	2vbGB854MLE6XqhneoH1L2asSy1oTGmX4uu2J3Zc15eK65AC3pzB	127
7606	2vaRzzutPYmk5BEKdUJppZVpQ3xqYn7dY4Ch91tLrApkR97cfvH9	127
7607	2vaVi9o3bYV6jaNgY8SGfXCKzZNNbEiheHM91az8ZryeceYJcPMD	127
7608	2vbMeur8p5Y3EYTABnNNMaqPKU3jYYgS5wQBFd6Cg2UeXyKfjYTL	127
7609	2vbfNWVxrthzLtghmJcBiJBNophiSqTJS2bXvgDq8bhnyLjyww2S	127
7610	2vbhLd19nAokHxLHAGKwn6oppsV16XsncHe8YUJEraxyvscshPGD	127
7611	2vaQd4sYEhGZs3e8ZN5idPkyejG9rMTnyDV8bXVVF1MFX5qtHLQ1	127
7612	2vayShxfXM72SamMFBgNaNGpXj3hYiqCMcxPJ5fwXYUEPDSJKyTJ	127
7613	2vb66aEqX9ckudn5RTt5DjY5y3CfrwRA8Lmb1NX3UyWJnYeJC7Ed	127
7614	2vbSDmXc1BgSjc9w441gwuhvDLb3MTjKUvcALVKmQPNJZG8spzdg	127
7615	2vb1cun6iCixsCKzD5Fb1XQSiTh3SNA9VhoXWdyayVENeTPcAyfB	127
7616	2vaXmxRqUKjNUPJpFCUAAYR4WL3mpC8Voz7XDoviadb7EShErRTm	127
7617	2vajE9f9DqnebcHUMG62Dp11nZMs157B6dcoQ7Nn8cQCpU62LWfa	127
7618	2vbH9fsGza5fH1wAC9LCp26KxyDbaAgREdWAtEYDv1KBZFd4mGAc	127
7619	2vc3FQyssT8yfbW1m5NgJJsjhykgx55a6WkJbp1ejeYQouBpJtNu	127
7620	2vaWAJxWcdPoYAQxp8NWRpj6zR8YLV9MM1dUxML7Y8PUCEmu4Nhh	127
7621	2vbmj8ki7oiKs5PjUyydQZNMfh3tPouHFUdfTD2yZ9fQ5EzFM3i6	127
7622	2vaZWonjEw9aB8S6o8iRkNCSTiYe2N7KuT5ja9nt5AHfrYLWrAWD	127
7623	2vabmu5VwiASt86eXhu72ikTMedof5WfRkh7er4Aq9JDvZuikZrX	127
7624	2vaS5bnRSBe9KHt1xUXNAq2THMtrY8FAdniUB1v942qCjDcwYWGD	127
7625	2vbCTgW2WTGuHevVXMPm31QaFQdHD6u8SdVyHpcjihCpeJfkqYRw	127
7626	2vc34vjbXZqW3RX44d5CGF7txyt6S7sNbheMH6fkqkAFX6xGRAfH	127
7627	2vawyooZ8qH79nnNvyfWBUzHxgM2QNazjQmS2PWZqHvSsaaECQHV	127
7628	2vb9EPtMLurq2dUyfyNPxdW2XToSJCSsmHV4Yy2XTEC6to5VbSLX	127
7629	2vbRdF8McgUnNrrxbtvmtoSTbuck4xLcE7t48tUK4sfmoBbtvRLR	127
7630	2vbEfcBG8aHHNYn9T8CLr4YWA6sS53v5pnv29H8Kc65dbUYXHQBQ	127
7631	2vaieM7v91TTgY1bcYjHKJo8cuachyS2vJ8E6jGXk92oFtEYrQH6	127
7632	2vbGU7NFPpRVoXYpupmzDN1fy9iceje1hVVzc79BpZpprgB1Lyj8	127
7633	2vaWtfJrvHDD3rhEAfDZ5F7z1PnCycfwA1gmreNCgwKFZHz7iwTj	127
7634	2vb7nkds7GBYEnbgvc7u6BKzjEDhsbaMb2nkAxjdU7V6zmChcrE5	127
7635	2vauQ1GUu55TNHZjHWvp2Q6qWDQ7pXMtwVSc7jQ3qeqa7gRGnKJX	127
7636	2vaMGdCySnetwq1uB6yHeWUUtTktJXbj1qtg7txxdc3phZknLCRc	127
7637	2vbdJf9Dx3w21EzcopqE8SMj2TAkq5kWn7Ekb2AnpDxmPHncBqPK	127
7638	2vbrbv3xT7iGMfkTyfzHp44oDTJYRngmYE41VQfrxwVNRsEWBJC3	127
7639	2vatQEX7Q8BeTZPf9HzZUR5EyMEnRK5efevpzSDKHjmoeKsBYBUu	127
7640	2vbxSWPUHaiRCpNeL4eRnmy2vBZPek4LaZ1gchPbT1wSUXZ4vyJ4	127
7641	2vbZF1fo2xG6pRNkFqpf5M7TtRtcVdrfXVpdBxJtXtnY48cyfLdu	127
7642	2vaLVDj5qsLg4xZcafV4KbnwDWhEQfXPuLoQsaMYbuBJQ5CxqMwu	127
7643	2vaupSY121A25npCs2vomVbSW17mvt4iNBdxrqyiSQyRUjcL91nD	127
7644	2vbFNFSwvsqXhToaLwrxrFV2g3DZnHf43zJTpXkrwnLeXWxceU5B	127
7645	2vbExt63XKsfaX6T5tTR2JVB2BDdfHa3o1iGf3RykbHNN78cknb8	127
7646	2vaWGFKz36Bi2UhNiiTR3kv8JXtJEhXUxNqc8XwnBVbAAVC9fyjH	127
7647	2vaNTDWkHZ5sbMjiNaVmc425UpN7Bm1YK5NoQtneppVkDuf5x4Np	127
7648	2vbBRaPgknMNbX9RnkT95vDaxu4N3xtWwhPKezma6sFHjNrrZa87	127
7649	2vaDjJiayS1u9khv73W3FG8Vq9CqcCFM4Jm5ZTaQckfzazoXVniK	127
7650	2vbtc7QwQvqfcgsAg1XJxg4s44sE1tCFSAVGw2qfqQU7WMSzhXza	127
7651	2vaxHC9tR4zWCZZnXccZd22b8mcUHT72cVmELJ4ziaKWEaJRcLDL	127
7652	2vbWqetdi1NExFuA9nUeC9qgFCVSBYHVwV79xp5q9jYuUuZXK5Ff	127
7653	2vaHQg4ou6v2VbCYnaQA4eJ1vo52Q8nTfgjmk5GqJfdeQxpjui7R	127
7654	2vbd1xfpxMAKrtANrWLuVAY9yF9LKb5LKtedxJr241d7fb2gwCq3	127
7655	2vbeSXhNZ2CEbkotWDLK73KHaYbWZJmWYHaRvktnvFwKunfxsXun	127
7656	2vbwQ5nAm1ZcYpVEYEK9TbzhYJ5u11k3TKikcN5ph1um9GA8Bo91	127
7657	2vbaKSYfepi8i8hNTzDzhMGgSFFUHRh38vK2ienZPRjdrKe57yZx	127
7658	2vbznqVJVATuEf6BGWnywtZbf8J4aVQb4j25WyZjtAXeq9kEW6Ep	127
7659	2vbM2g7UgZskauVB59mxBMbcTZxdAaizt6W8SwFpzj9SbCTnZMwA	127
7660	2vbN4DnzYDGqADuWjJQKtkF2UPGan11Eo8qFnf4XpW2RRCjzEQSb	127
7661	2vbG1ouCauy9aqe3tiPnvfSpsW8HNWm46uA6LpKXuAQuH6in8aaP	127
7662	2vabPthYXaR7RBxwXWQDeaSPbJxbQdaTVeuNJTYJkHdm71UVZjQh	127
7663	2vbQp4R645hRbdFTqL65bFetGbGtDgTUWaAPZX5hPTyno7m5CZca	127
7664	2vaRQAUZxnRQwTy6WcRip7KcBmN9jyJwfYEvSKzHPt4NFdkdLXVW	127
7665	2vbsUmv2SB4YGCxJbUcT1ceWHoUFNNL8syt7Pv3yU397GtMbaLxT	127
7666	2vbKY3swfeSc1YQQwwjJH7iFbcVHdjY8mBmPy5yjgRvzeDLurrkG	127
7667	2vaxyAcfYYVAy6fg3vvymagbjHZSF33eNvC3x5KCAdzTgtnH4MP3	127
7668	2vbFhDnR1EWh8rwyFZ8PP53JCVDGN4yRGU1324yBkpktiRjaUyXk	127
7669	2vbWQAMxnJqthtsWqaaMd3PZ2vTpEfNm3LHrb6VtvPmTZvyVf6oK	127
7670	2vabq614W5ZR6Jj7oPzNzcHh7R5jZVShcCabo51DrUDhsCWAWVA6	127
7671	2vbSdgbRirFzUyQDpNERWHqJSLtKTmEbD1BXRNcPmCXCJDQJh1Su	127
7675	2vakDYBuaMJT2qjEDNLyctZGdRqBrGMtbhdpnkumwTd7nLf1pc1s	127
7681	2vagnQ5QepyjgWgDDChaZh3xcigQvASRuCExsPP2roY58ntHhqFb	127
7683	2vbNEasqZhhZNC4R9s1pg1bvwQjtyV9udnJXv5q41mrbaK9tGcTm	127
7691	2vahrFEZjJzeo5Fnn2JyXuYXThG6to1AU8LVEeEFoTNZogGsrxWF	127
7693	2vaQ2sKXbjVH4rDmmvPeJMB5yLTXSVDcytriipdhFCtPhbc6ypgP	127
7696	2vakV8yBGKB5nDqfLxGfQqZsNkxLz3Y2DzTuwBeBDyntbqMfH41b	127
7699	2vbU7rKVKsmgfDhL5nkE5jTkMAq94EWgvdHLS5XYcZVZqXmiEsrE	127
7704	2vaWjq46vWn239F726kG1QatLgrFYPbNfTDveHU9hSQm2XaxMj6C	127
7707	2vc4XycztDMpjgz1NQe8N8cWFRU9QwsSKHbpcxmHL81P2hThqXzM	127
7710	2vaf5CmfQTZHkuVBEPK1GRWcy1BFau9jyaraBJUNjDctSC47aLJy	127
7715	2vboTawsQQzvyRjH5cGDA529HiBbndKcctRaMK8bmwePB5pDjeG6	127
7717	2vbduRYyYkwU6yfFb8cER4C14hawkNgDMVReFjbJYawC59s4kcF8	127
7720	2vbFHf6ukQShQns9KLctEpbYN6oq6WjvBhhbkehLCrdbPasqDLcr	127
7727	2vakNksaXY4noyjpQru75wY5eUgEgcp4N8bDJcYQZNnkS8AiqUQc	127
7729	2vbBDKWXXg3FiGgyoSiMiwsWHshWtSwCGnPkQWP3qLYz1RDBu3Q3	127
7731	2vbWmyTifcGceqNGs8xeT4cUq4tTNxqanA8tm9qtahnqy4Y1bqUQ	127
7733	2vbbuqbvuhjNnwRLiSqvxTX6Ek3TLXiYAqCUMtk7EFR4jzM63z5G	127
7737	2vamTdkp1G7oJTzEgY6A4AivNwpi289cjvWYPtx2aZthhT4ERMVY	127
7739	2vb8BiQLyjW87qNQZEZnh2WrFT9SrTKzVtToBRSXbxmyXQK1uB9x	127
7745	2vc42oTg1csuujYp4zZDcaerPQ3EYKRogQbaX6QwsjxUQ7NpJZtq	127
7747	2vbqN5kZSeWpXcEB8CSUARMVreYBKLVFoFtpR2FdjcpQEcmYsamk	127
7756	2vaHpZEakoSrZNGYrzHyYBuEA5ug4HT1QCvNamnXBunVPBXANdN2	127
7765	2vaLt3VRXa6RcjB6QEMYdsy6apZvuZNvpcCwkVMwc1oBUXvQSSmn	127
7771	2vaDTk9gTo583gQQTcoGDwV15BuEJovgwEbEkGcYFLXuR2TVrwU6	127
7779	2vaKUnT6xg5MqioNZuHkG1ehPxzTqGk58aqa7QfW9WpvoUufaa4E	127
7784	2vaQsv3diT7phjQuJuvQYSef76GLp4cUTL9MTJut5BZ5pbUTxDk9	127
7791	2vacrcx7MHGtodwUgAY7zvjYAuFMpATtWprvMRwWo6Xc7GsG68hf	127
7796	2vaeXJQDqHgyMhQs2K3ojDuZeAafsgSUmur7tH5Z351NrxspemX8	127
7806	2vamnCxLXXW7ywwNXqcvZwcdPSqAW1vSSrEE4o5f97qv5rULz7DP	127
7808	2vbqS9TASsLHr1CVP6h4eAmARgE5NM5MW3F34res6zhRCgGPUPQc	127
7811	2vbiUEFsCRk9UKwL2nfdXKwHcia7xA91Qda9n65WQTSLG1MWBLQm	127
7816	2vb5EJ7BYXvyLh6GHrkn5DobDfWZ9iQRhawiXBLWShKPKNDbJwdX	127
7820	2vaCvCqThxU5aKozLqBRgJGEujprSj1EuLFFaTuF3CaXfnRnLQAM	127
7824	2vaxqncCyJum2ACgHbFpUqAqDAPsw4N7Hb92UPQ456oG9ngMfw1m	127
7827	2vab1bZCCLfUQ9tdkr43mZvTdYPCSpXx9qFaJceMc6LnDN8Cv5G6	127
7829	2vbYn9oKR6shH6XDnyGWsJdiUugMnWmbSrqgwxqLYftsTNXrLsaW	127
7834	2vajDhywuxXq7a8VuAfWUbTzNAkFo8wSQBeq55q6E2xrjKMrtYzc	127
7847	2vauahNJ2M2VrPAi5GNSWpkgji3PFrDWWGzfnFpFf8GnrbSMyAfQ	127
7849	2vasHEeE3Ur48CCWXBtYtUSAEjRDEkuNgL6a4uCawubTskdFcB2R	127
7869	2vb9isZYVrVG3iQpFcNkNkgoTet4PrBLrcqJaoB7yVmFXmuN1cag	127
7871	2vbhSyPsdXghsSQq1mL6iN5dpnv7gP3yD9JqBAHJUHxNk9xZmZiT	127
7876	2vby6QuFrweqKmNnC6jXuPV15iCncKpHqFg8UGEGLihykfR2Lsa4	127
7879	2vbnP5y8twxU7iYVQE1ERZ38PNkBkrrC2M9c2cyXoRwGqZFGjD48	127
7885	2vaKHS8nwGrwQ2Yo6Li1uATijNn1GP8LtihgN9xinfeFTJgFtX27	127
7887	2vaVCC9ssfxH5xa3JqJspRXV8jbCHx73tZ6UyRphDFEi7Drrx7Wu	127
7891	2vbL9pSLMZvaeczHHuGeLYMNSkZUptAKvoDSRa7nifTPds6fhQnw	127
7895	2vb2y3SNTMX7UKqqSHFuF7Cq4NB7v1zBQGrruMWtqzvYxJK1c668	127
7898	2vbknXWTAyC7SNCXj4JWaPqakUtq8ra6vC4Exv7GxVAbsPCUF7Lj	127
7900	2vbMGTLxasUNQy5GhfSyGpyMk8pXMy5MJYutRC9saAZDoGJCBynA	127
7903	2vav9zkdPx79vYd6g4TKTevU9w7AW1jAoBzCWsS1eBZfRPLoH2Sz	127
7906	2vb3SJNsvEuXLWj9ovhAWRBSHGYksAGp5Ue7P8XRCBrbqaT8Bqd8	127
7909	2vb5x3eDUcoJCM7Vfwt2qJBkqd765v8Kb9x764dpUcy4xE7YcJcs	127
7911	2vaxiXtceuLuEXHruJbLGuMviToVFcfQxL59UuspjgnqLit1Q6ji	127
7914	2vahter1qNQFgsem5iLWuV8bbEcfpL1s9kkQ2G4xtApjkkirr8Sh	127
7916	2vbJA3Z5AetkqTJewLXdZPLTCzvQcEhZZGCmx67ekzHfdKVJC8pj	127
7918	2vbohXXQwL9K3hXsLUpThRie2EyjY3vtob71ybJoF4TshvMWWPta	127
7921	2vatMWtz1GtXjbEeMnxzG8vmR18gGRWvkQFnfQfwpkakZUXVoy6E	127
7924	2vbVxbziubtofpYYaM6EdvN3DTJQVAgxHBARWiUyRr6zMnnCAdBS	127
7926	2vc2XyjFpSfYTCHFnbJmX6WcpSyAC4UgptkQyv3wKwpJE3Rtdv6P	127
7932	2vbZV9TaSBcvYwHdkDNBfRcRqVppMN31JdjB8ZWwvbq39fyTB39V	127
7935	2vbQ8aqPzmhL6pcjFqisMBQeCAJ4YSQx39ZyMvwSkeMmqo91WLxK	127
7939	2vbeMAJym6ckhDHoJXp4LtEcy97iBZYdG5qaZGoK5xjdrv5645KX	127
7944	2vb2smJ4UNQdZnswXzjTnGhv9DuQmFSs1qSFUqdKEvSQ27bLUjqL	127
7947	2vagLkXYsfj1bBmcPnsp9Moak5VicbYiPKVqY96nRKd7sjGUM6mV	127
7950	2vaLvD4ouW8DXhpNNhN71fffpLM8WsMmxUZDHh9RX5BnzzNACD6z	127
7954	2vb26J5Cc7JWhM9hzXPMPHGLyfhKKRxoRDXBSLZyq1M9kKdPczAM	127
7957	2vauepyapSdHTo5vaJdSgsuo2P4YrHLoaoSAAyP7XubkfzvEH7Ks	127
7959	2vaSb4B3p5ZAeSQHhjjf6n4K9E52SJ4dHK19E8mz2JKS3oYBzfJj	127
7964	2vanTPUJd2QrGoWN7SpepkQ5sR8kmephrogTMJMHpgyHhRJPT6b3	127
7971	2vapBCKknKrzV9Px1MY2gTEkCbTRDQndgHQRJU9B6yKsLFeRMKNt	127
7974	2vaUmdrQuhNQnr9C6QZtKHKkYrXz7v2wpQBANzqagooXiBsXRUN2	127
7975	2vb8ofTUr9AdUCKjzB3PgaqPdkJGVtD5o763uZ5VLiNrdfubm6HF	127
7979	2vbVYa3orMGYF1qTBRUfJmCwkNiVef8w9f2n6vtodEVkZcL7TxUz	127
7983	2vb5kWGn4XekBSxYvvvMTYzeehhdJAeJ2QbyNkfse4cw6CfNBvmS	127
7986	2vbUnwGCVziPP2xg1GWqxutCbdguNAeYbsUusgAtLDtpv7ztatPn	127
7988	2vbtTzWWfQ4KHFhNgWkUZ2d7LHEqUGxPpETb6vyao2RowftChzr5	127
7992	2vaEwMkxKirpajm9CfHNxv8rNpCitot3s98aJz5xrVxQC3bvbBNK	127
8002	2vbcHPSNhgNmrpZkvzaYzzxnRSnLzgHjqybHTHnYh3siEz64f6vh	127
8004	2vbJ19bEGVYkcYAmGkye1dXy96gKmqAAUbdLYYkM2xMDJpHkHper	127
8007	2vaWNwJQiuJvqThaJcCGM5yvHZKmbS8qFtYXg6KPTSgUUF22HZLU	127
8010	2vaAxgimySMq9MxgEWbtAXWEPJYRZCtQp2seMs9d2RrQuBE23E4D	127
8013	2vaU1yB5zaNzKQ6MzqgENNzy9nYqwEYYF8qVJV9DNAYb8vi7GJQx	127
8018	2vbxrJj58XRAFsM5L9NXxcURqbKWxDk5nhBcdf24suLYMjCutmoA	127
8025	2vatQZGyGjbmRyPE9EA2eDt66Vifx3GNXRTPhehNnaR5MgBQR2iU	127
8030	2vbKDnL6JPqKxo5PBoGVEAfEoPReVCiUgpqiJchnREPMcC9en7ud	127
8033	2vaqnWV5FQ7oJc9xkva4eNKiQFrYpk4z5Q77s3MNtQBbW3hpCTXu	127
8039	2vauoX1ET11ejUyuLziyQoM7aG2G22UioCQt1ETh2XDwmLSZrYPQ	127
7672	2vc2FDSFSFWnV2Z3kQZ1JnnfUgckDbB5ZVZrx69EZm47KaofuMje	127
7680	2vb95tjhz3wgmxAyM7ja9RvLYEwHrna7KA4tvF2sNrVvxZHqrX6T	127
7682	2vacr84UFvGCXPsVWwEBNhpnNZHwYFQggE8oMY1DSkLwt6jeRRrn	127
7684	2vbKTUsbAyVpvoxZbATUmh8F9ewnoAWTiDAfZ6M9qBtFzHUBfJii	127
7686	2vbr8T4Z5SCUCuKKwRwPh32VPgvLYfYPmVyKY1b8BhttBM7DaoMs	127
7694	2vaSWT6G2LQiokGE98tQLyT3AnbjbdPceNnQghGH3CfXJsQ3BHcq	127
7697	2vbunGmDPndGPXCN8UBs1DerGHRbvwonwoaUS3GccMFZAEk3QGPG	127
7705	2vb9SgGgERUcekLqughnWNbPVqPJKAAM7YNdDZ6NokNWatTGmk78	127
7708	2vaGXmPLPquDd44mvNCypX3aPXTZmVBXLZZ3fA6Krb8dUeJmYLcD	127
7713	2vb5H8KmwC5yb9HevCLRRd7s92EHidQQkdx1UquGCHSEgoCqgy1X	127
7716	2vaaBMkt1rqSZQqQWqbzgmDUmFtSphv7JdvmA4eCLdFZah2CTP5H	127
7718	2vbMkZ55BDsTaREshB7hr6AKT7HJVk6BRmRxnCEoNZ8UVeNjcTSa	127
7722	2vb84wkjKdkBK6r7bjH5ha2cRDqxw4BMdnfGqE8Pd3NmTnqNnpd7	127
7735	2vbsE2cfszB3hDu82tphRqzbCyDoMnMU7m8kYZvJ8FzxqJ8ReCrt	127
7736	2vbV9zmHBbUm72mxmoE1qQA23wdo39qbUYoFwsmurqq1e8s8Q1WM	127
7738	2vauC4BPWFigtZfCdZHF2s8YkTW1dcW6S66Pxn3J4DxLhwBdoc4G	127
7741	2vaLGUbWNyyjVAjsvtNKW9W3AtQKyTuEz8SJKSeBqfbFgPDyFe41	127
7744	2vb1g7vz7mAm2F3UadCSA2SaxsAmnYA2jRiXqa4BN4oUhsaTF6kk	127
7746	2vc4wJHpuJPN3q6G3rVbk2XCtAvB7vc5eNzJ1HK4QFm1qcXw34hE	127
7749	2vab56hbisJfv3omkrhPTUrhxBsKzAd8Q3etoxV7r2SW8wchLaDN	127
7752	2vbQEA7dATLXHLNFzyrENVZ9GyLNiKcbSdMyJ9oXWAEQPPuhASka	127
7755	2vbRcQRo5pjrYjQVXUXXPWwChLvwjyW5CEvUvqULBVC7tqw3Noeh	127
7758	2vaWf4gBAU2LKpxXk6zHNcyiVWAWWnGgrhSPDEHUtVzEUim1Yhmh	127
7760	2vahrTsqysxvVW1fu5bUcrRCSvWMmUaKaB9tEh6YNsJLi7rLbuEQ	127
7761	2vaP5qRK7RTQGDuHz1saFDHbyUXUmSAM4DcXU2YQnoo9N3tB51bi	127
7764	2vadkZEQKU5kEUKy97hEUAdQzi94y1YcsM738T6z3aKkq39UUqXA	127
7769	2vaZffvt32Q4JWnTx5LXbDxsVwGiwh981j9jaKaAujdCu7M4DpDS	127
7770	2vaBchqWPKLgPJi2f8KKUYJq16s7sjLr5c9Y5PcNDyLwQs2PbvgS	127
7776	2vakM4qBra2yZV9RkU65fTJvxDTCHqomL1oTRULXra9ZkdyGvBef	127
7781	2vaR6NmL9suCAatMFzgPhqfdYMz6XVZCTVkozACKTi1SvSqXqUuh	127
7786	2vc1X7986GCMoq5AQ9NgWy8CDJk87xL4gAX9ErywNc1vZfeU8dw1	127
7788	2vaaeRsM9i1CSf9Hzjccc9GJTAEeHhgmBmKu6u815a3sqSg8Dy2k	127
7790	2vbt7PCUvbzXy4Uuja3C3w7vP7C9XYPrkcPagTauPPYYAd1R87hj	127
7793	2vbzSQUnfjF3LJudEc4HmBHoBdU28JmA2p3fYYC37gMaedQ22UhU	127
7795	2vbYw3CcSxLW4VKK3hFbozTLfGyX2erjWNjy5b632NGPJB77Pmtx	127
7798	2vamX4wcGu28A6DEMmWTMaaSKmLHBo4BWdoDGBU1sVWMFaSg9p2E	127
7800	2vbXUVuaZshRrQcc66U2RWdrhxdDeyk8hhJgPsQ1iEqmWoCtuAi9	127
7803	2vawu5vH2MQLgT8siAJhpjgxkREFaTdjXKhShQW7sM3K3KSMGfz3	127
7805	2vakhLzmnz8j9XEdqrJSVMkWfBFjeJ1UtmAhUbCUs2ZtKJxKo86S	127
7810	2vby48LdrkRbALMq3q4jE3dfCQRTdzx1vgd82dBnfAxG68SP71qA	127
7813	2vaSMzfDu4y7MnoxhSXbWqySTFPLYt37T6qJAozGSUmH6keCx1yT	127
7819	2vameY8u45pQWa7fjQT24TncrHz6KyUYrkqy5z1RJdJYnyATwfPm	127
7823	2vb2a4SqCijni3x6BpbEHUKKFCzRzSL13xD7MeRcXwHi9wF8QgjF	127
7826	2vbuNWMxnZu3MdF7TUZTxWpDmH3oDe2UZ8QX5zZ5hqQMEifpfg9M	127
7832	2vaBd2RN4PVEPfvA3mgNkce3rntbZKbCnA1KXDrD1ab482aooxrF	127
7833	2vbhZhmwdbiaTXjuhYz2pFYRhouipoejPXFPgAFJB5MPBStfaEVF	127
7836	2vaMD19tBZHriBZTiBBW6LmsrdxTHBM7nm6vSX3gXnfg8rw58WsT	127
7839	2vb5VpepYE8YAy8vAkXaiDUZRtFEoJGFPtCBneUMpWKfQ2xJhjUo	127
7841	2vaLg9jmmpH1Yh3T9AUHtkBsdkJ6zrCcxU52wQFqFjZhkK733bRS	127
7844	2vbJ82MyPQaL18yQYMnzVS4pcP87dfCCJYq155BgiQF9ZD2BbpnU	127
7846	2vb1dJfjQkUW4TpMrvWd7zvhVwGKJonp1TppHxVgcCyCQC1ka2vm	127
7856	2vanMRdH3ibmu6GLYeCwGcry3pnuhsGfbNVY4fvgS1JfZmQoNRRV	127
7858	2vavZDCAFjfSTFLSHoTGEN1hoaqCbjE4B6yoom8Nn39BXt6TxisT	127
7860	2vbtLTwtLeEJpCpDdABYS24CyFd6rddqnHvebyNp2oPLoukfqUu3	127
7864	2vb6grwX5H7pvWViUgK745cDhisxnZrZFCuENhB1nf8AiWXB5z3y	127
7866	2vaEebiNsAcwgE9Pp6aMm2RwTquTdLkGSECnk6X6Ru1LRG9SAyaU	127
7878	2vbdQRP4PUZp9MZxnWYrEB6njmpkctBe1bRnBg6ybx5r5ez2K2tD	127
7882	2vboPJjb4TaPDFaemGJJaS5ptyyZJkNkyMyeFiLbBfQBZ1rzm5Ue	127
7884	2vaTJLXkE6rwLe1meb27HVQJmGbSXo4Csu9zxMtHbKXrDUo8HykZ	127
7886	2vaZXDuLgZaATVRMXHd15oKppRk6whrXkuUhMuzNKuiqPC3SG99H	127
7897	2vaKAusiggbsUcMgu9ci5yzJiVTjCoGM8FktV2bcB3xyiBTBbiDJ	127
7902	2vbXgMWci26ya9ypTgcUiVJMRPZUP9c9P8VQp1FGAn6SQ78oXSGr	127
7905	2vbb1zbYgmFwXnBuhZGDwP9Eb7TjYhwZwk9G4CbP816298mcNURo	127
7908	2vb3rccbE5qvtpQKHxbJ2MU3DJS3kCuzUbnnYL7GYBe1aocMFFnT	127
7913	2vbnCttFiyu5qgAiafLczNjT9AKmCQ97cyknWvgHE2e7n1WRtQAB	127
7915	2vbb5pKTEZwXDtdsZjQxS7AKKgMCystTrTQSmYdqjiLD4P5EADSq	127
7920	2vbQ3tvXpKfFEZWPhnuP8BttFXcKXxcWWPgZUE8P57SWmXu3Mxd9	127
7923	2vasAHfGXy8iMvGrY3UMVowzsYeZo6X2LN2bgJf5LmHQAaZVERjH	127
7925	2vbg2Bjf2f1g4PzNFsGJhzEUbY2mL8QebGu41RHQnLmFa2zhjxaW	127
7929	2vatixtcPtBiLf8x22n9C1Xq5hZmrL9XiGXXQVJMqn3SBS48ZDsX	127
7934	2vbnNqSjWL242uSnzjFiLxw7pvgTbqznop7wcoZSGxApLT69M7Kt	127
7936	2vbyonjNN4zGvTLeMzFFoAyJK3y4ZEycWbnznUiArRZJGA4HuPWi	127
7941	2vbZfpFDu4Nd9BQhnDCXrpqnMgHGsjv3BedCeUxHGi7rU1AvZeXu	127
7946	2vbFYtncTws7PfpndWneHxdLxdhowhYPHqfR5V1hnE7D4xzuCn9H	127
7949	2vbi9Gz3yPFgqfVMiXaf3FzpF15eWZLcwZtimn3rJhJ97kKbxZaE	127
7952	2vbymXWF5wRwtRQz9VSpojTWt8UL2qguvbYUgM3dH65ujjqq6D97	127
7956	2vbprj1mDfRNByTNYii4FcoSVHFH5DfrxTVmMVkJP5E9o4kUGYSZ	127
7961	2vbn2wjuMVRWiqWP4KUkXmKEdNMLakcJ8w3FdfiBPsPiRdJye9qf	127
7966	2vaNRvtc8c4ho6EVVnMAUisSHfAxb9LsX9yaE1QCVSr1q6BxZQYL	127
7968	2vbEtsCqVga8mjdeW56Bs4PMbtPSbhi5mRKYZvU5t2B39pNbmwvi	127
7978	2vafFtYrXZeoPjN8MXkwqFs1xHLyZqC6dyBNcw6nFVBp2tA1cPey	127
7980	2vbW27cmgZJszr7oNV4y4zt3B1sXpVe1hF1gG8m83stDe8VAaD89	127
7991	2vbscG2uzor8JqhPphceEHiaz2EHrb55sjXdxka9TF6ENTjTzuLt	127
7994	2vatUpSBWjGtt6zhB4tHHDahhz2gHCo7awfhjyedaYzDTDVWazbh	127
7996	2vaYVt5GjUMzJjTXCW6qtxsWRm8FSWvqgnbgVV1BboyXkQnkm9gv	127
8003	2vboNEsgq9jDS23zY6Un8vttKUsGsz7vuoB2yacNubnxj24hfi6L	127
8006	2vc5jsJefGjQZ5nbhpsj4UjnurEVNvLbWx5MUFfSrFknr4HNuQqN	127
8008	2vaWoVj6pWVCxGvcPMEeMG4w9km66U9KX75mUHDbuKPz9b7oATgK	127
7673	2vaZ27zLpnLmU3Zw1EBVoieBmDNhHpzPVK4KUiLFADWYhGkQM8xE	127
7676	2vavzsf64aaYnQxaYdHUaDK2f29jercWkYP99FMNE6PYHZpWAUSf	127
7678	2va9um1GmoCkjsqu4KZRubGtyghDSoqtdEBD9BR1reLEBVbeDcxt	127
7685	2vbfrYpK3aFWVQ5Frdyvwbqeg9KE54uXkpQHhZZpsn2XWcKchBHU	127
7687	2vbDEVprxLtHKz6JuXQ59VSVDaMJ67SYuykgtXozYzCHdeTTESEM	127
7689	2vbGadbFmx7VKddyYwJhW4yce3ySS7gNeVYQgek2kBmSeLrMyDhG	127
7701	2vbM34Vy42YyKQyvbRZuVripotR7CKPBJwiokg3sohS7SsPLgRQ2	127
7703	2vbRPrTBX2TWd678rDhYEmxgnuiiDk94ZDYs713T8XgMzLRV52bA	127
7711	2vbfAsCGTbCSF4bYTsy8Sh3KMdAjCUz3oNnYpS8b3gEi6uDt5jSB	127
7721	2vc3HGd28cgVXB7Bf5dcdZSitFig3sHYnDqD5UwRsbyH237VP4mA	127
7723	2vahMmpMCWqzxMCogmVnzwcftmzpKj9pZxhStRRKfETvYfow8xkw	127
7725	2vaJiD1Z6ap8rkLQGsQqjjzkyH5tSKXA4ZPWfVdGidbuyh5HsEHj	127
7732	2vbm2xvr3CC3usGU8VuJEYcN29y7bgmBwmehwJuqzELcTe5djEGp	127
7734	2vb32DxTuirH7T9UNA7pyXF1p6f7tBgpR924u6TwMkSu4VyFTkn8	127
7743	2vaFKBoDfDs4ProVhuXPLWQQRxzeDzJc9HNfSjp4r5SQQVK7pFYh	127
7748	2vbHiHn9YMkK2L5BXvybVuZaaoNvMz4feY4RCuagCkS8WhBB1TgW	127
7751	2vbygmPkmQ62q9RP9d8LmwcftqpTk5ty37G1qXPedfmTezcpnR2A	127
7754	2vaJa3Dj3WwXHVKLX8Q8ZXxDG2vjeisQAFKo5CoRsA9X1AVJnLQt	127
7759	2vaoiGG1H45rxBCbMAMtrBRqXQyGLgGLGUE6LNBp6o9XwX7HLQNE	127
7763	2vbQMniD81Q3uis5oQiw798B3oYTZb3JoW2TFpHFFr4wXnsBYcyu	127
7768	2vav5wAVKjvJ5xEHKDrK8SY6RiuFKi5Yocxs8TnGNqZtHZ2bPFpL	127
7773	2va9FZkkoBjHBZvzLMfBHWzyrZNpX4FBM6MSnQM6tLHVbuGV89Kn	127
7775	2vayJR7sJEtb4SaNoQj2AeRYJtSXxCqobBGKGCJfZPs8oo2kZJHi	127
7778	2vai98MAkJHWpb1T92zVBdSDWoaXciaticTENn5hQGfxrtMgbTwC	127
7783	2vbbJDuutq7BkrH3ukWscw3UmtidJVYtd2HywL2x1nxU6bZvjmim	127
7785	2vbUXzwUmcLMkdyqZ2GAccCMVNuQoqCkwcBcGFrCAJ1dKVfbBTAk	127
7792	2vbQfB4y88xYpbA2XAjB5FhhU2qw6UkKjCAhkSYMenGMK4tiExVP	127
7802	2vaMPkFjcdx3XQSijuo2hPATqri3fBUMjSPWELN6fGb3ajcQiQES	127
7809	2vaWizVPzJ7NCXq7hriL7qBNxMTJ6rzM6Sis5xFF9hqMisbR6qjC	127
7812	2vanJPAeKVv79joSN5CaMGmUxphSxEna2kRWJzgWZcbi3y1PHBie	127
7815	2vb1qdrnvFJTkMKhYp4Bwxnz97DrasU9yuHu5zwAkaQ7gYaEn94R	127
7818	2vbyPpLZPTtBfSxCtYqF6v1MfzxkP8JR1jbrn7g7C7Rc6uvGhbaN	127
7821	2vadsX94YvWD3fHJRDuzefQ8RS58CLFnjXBwYbjhkuiFbiEuY27t	127
7822	2vaazwXqQAjyQ7tEWrHub7ggK8KhDU8tgoWgxMopj4WDEKU7aFub	127
7831	2vbAHCQMWz8LSGGCJtzLXrPtcUtjcKtBAg8ryH5Jy9JU5qhhsWab	127
7835	2vbjFPn12fyz6hWTsxMXMctEZ7NbnnbWXhwuT6oo7onAdUg83GRr	127
7838	2vbacu1QXE4cJyKdBWRbZAP4d3EUr38v8PE4VrLisrQAE4GfWSeQ	127
7840	2vaDrFXJEq4YL8BEeiNbeFLBnBXmkKUmTqAAkZWVKrzRMK3bimdt	127
7842	2vbhGSmi7qtKbBxsyFanvFNJEhdwZWHZLS7uKwMgBiUv1vSaZwHP	127
7843	2vaqxWDnSZkVU3dou1dUcSNNsZpyRu2tkbRrwYf8dpMUcFL83EBe	127
7848	2vaoYnwca2Mid4WiJocLGAJMMq3XK6dW6KmYHsq3iTj99FTR4uBh	127
7851	2vbxp86Bp1C4R6WMc4DP1VWXru5wcdQZ4f723QbAdZUEBnivAYqo	127
7853	2vaTNv5qutFtf2AbifKvcXinkL2umkkduncFyH82HU8vYRhjFpgc	127
7855	2vbFrjeytTWP4gdQvDZLunvAxEbunrcGRM7fmSdJAziHTerneXCh	127
7857	2vbWNh7emhS3TNHLt79xBrYNhxzkFUxkXAneEcCq1Cnhc7kP3poD	127
7862	2vbi5sSzD4mkHpRfM86weNMbR1BmzJRHxkNUTL16zvzb82ZmYBkm	127
7863	2vc2fPjVd9zcXgAG47fHfGyrBJeuGLRiZPz75zsUmoan8tPLzbbj	127
7868	2vc5h2zVFpquCf8uoArsCBP4Z48vs3PfBi7npLQJh4A7jXpqnCGT	127
7870	2vbpvbkYJtp4mnKqoHzfQvJCem1o4uuCbre4v87dN34M22SjUEkc	127
7873	2vbsY256hYHEwJ6hPLresKtx1agge2DPf4k4XTTUJmCKaLWJojK5	127
7875	2vaiSqA1eYLmdc9e7aNjeiu4SHYPpbHPo99EXojV5stFxuCzwjcY	127
7880	2vbiB56c62DZNXJJDNkR1hL1iDB9Ah8FuDUn1x3muFA6mLHBAdU3	127
7881	2vbSDTMCAb6mTq8kXe8tAbvgsKmQTDxVFtQi6qLwctSHgnai7eUC	127
7883	2vbacMdjEFs51d68Cjdy3jXVQPWdUPaMMa4ZZmFDCjDGdv5NZpHq	127
7888	2vbWebfqR1mgh5RXSdTw6rNfED1rDNxrvSuEb3zdh9UdPqDzJnrU	127
7890	2vc1a2nN11vmB5NBk6ud2x3gBEkAjAAXYgrFodXuq99pbnCzrzd8	127
7894	2vasJPAV342AuhqxzM3vuihe8cuuLvnndVu1Qt18rJahnYcXVCK3	127
7896	2vbzueLCofAVxGoXP6GAvAB3fDWbMPdP7hswmY5ooPPdMqees5Nf	127
7899	2vbRFvmx5Xd5pB5GjMK2PsFbZZGEubFaCcT3QL5gDnBt4q2v9taL	127
7904	2vbAbnuLb5ecUD8QN22m66yRXMkANMtNT1GcJfhiH3eghnbpPsoh	127
7907	2vbNoKnMJLSCEKUJqFoWDnpfPHdKc5NxvyPr6LUUrvn1NWYUZYzP	127
7912	2vbhGTL5jby6MJxb2a9haNp4MPnPDqwM1DdHbkGwTEgbAfjHi23G	127
7917	2vaXieheKNR3aDfvyoqFdaGkhKi52KXX5YLLCTNt1pHEek5JUQvB	127
7922	2vaJhrtptw7ssxeZteBY8fGJSnn54jAphZ5wqHhbzKGrdGG1d7bY	127
7928	2vayXM5G926Q8HXsVJBFXkFwjPMECRcF5DzAa3sBX3XFxTLVLqam	127
7931	2vbkm5FBK3A6BwCGuvegrxchGU7b5Av6VJFyAwkPWfFyEofxY6R4	127
7938	2vagzhoxvH2MhbRNqhErjxUgtmzpeSFjNPoTZbFXhMDzVPNp9dgL	127
7943	2vbzuAaQECUZLxcGQYfe6amKHnSDWL6gW1Qvab1hDUx4Sb4LpaHf	127
7951	2vaCrkZo4MD25Kdjy5S5T4tX4KHv6YwXc4bi2CTGLCHzKKaNt6zu	127
7953	2vbC31JZvvs4s6XXCFLr3nN5P2pcw3RHJtRhGYnXcisRthhgKomz	127
7960	2vagiHC2q1xM5LxnoHz6DAw671kcsvcgZBm81SR6N28uNjWzC1Nx	127
7963	2vaDZ9Ve6nUNxTwkBXdcQa5Z2MdNE1GXGjF6ow5zeUPNBxhV3tu9	127
7970	2vb7nHwnUxDdWu8EM1ERTYL8DoXr3bgK4JCVMYa8dCuDV2rtutnG	127
7973	2vbS954cRiMJnUo4n8LMabvjtrRr4SnPUW9dCak56Tmqdinid5ij	127
7976	2vbazhzHuwspu22XCBWfsypA3k1RoLcgqua2x6gqCvxuLPiuB1P1	127
7977	2vap981prtd6n2oUowcQeXxPFjBnjzB4nWvogkCEerr7ZftQEnnt	127
7982	2vaqRd1ANFqghxvaEVwScrRxUS479VtoFPPPrmRVthZTvnCSHNiJ	127
7985	2vbdmVBhBYh8iU9fkLbTBAj6jpioxFJ3nmMsySyMbsdzDqTsyjz4	127
7989	2vb4H2fHTSk9pL9NBQW7Rz73TVX7JzzJHr1Wuc1enCDxU1fF9gqD	127
7990	2vbJTq3dj8StQgH642TFhN9oaJVAMeCXoqeHtT63CZjva1zdKowr	127
7993	2vbi7Ebtx1eKp33LbPKPHt8ccCpDcPUt6SrkpuS6BbVhkoimmEV5	127
7995	2vb78Z2WKPFmQ6TBXBNaLSakupYRTkZ8Ppm46JXsxwtQ8dE7s1by	127
7999	2vaeTA7a7NhFZpGkVkpVWN8C3oqoKRm7iR4ofSvv1unVz6Sqv66g	127
8000	2vamSz16y8npJAnxudtCsLyrGYQkUpYogLPAQxQYDMBAJafPiggv	127
8005	2vbYZcRdLsaz7ZzdCMmq3LuwcHAd8YctExDF6MWaLHtQ7rN3DdYf	127
8012	2vbzUYJp3QDiFJuxvyuEH2dAdt6PNgxuKaCMSs79C5VfyFNJ2SKJ	127
8016	2vaS7aruWUAC9NnVKWDBTRgt4nGpgSomuQ6GrhkXxk5ARCVJGbqh	127
8023	2vapSZ82WxPSFELLwzRBqy6e1CspmZ8LF3pDyXspHFCh9N7kwpfS	127
7674	2vai6uqUq7NfRyUDU3cgphJmfWKT1ubGQw2ooFtvLYgWqwma5uwV	127
7677	2vawWuuQaf5PNmpWDNAs5WrUiGTsWP5qZENj4vhTnEUhaPSuwEBj	127
7679	2vazDLMJCwrKmYFUJCxwKV1DoYf5NWbDcSSv2krMDRhz7bEQQgGz	127
7688	2vbYsrhgLXSo9fo4cjxQxHY9JZNmvPjgStRivj5My7KkfUt6qPYe	127
7690	2vaQPguAfBvrBnB7P8L59iEQ1hfddbSpLNcV3GRM19usv7Y8iCCX	127
7692	2vbK2QoU3u54zH3mksrqEgCJ3aeqqrRT5LyG83Kv3AvdFJmTTvMT	127
7695	2vaozLV3U9o8XwAoF7BzF5WE8hL8mybz4YPQQrJWym2e2RkL4JWs	127
7698	2vb6WLAWUhFSSehyLLBHhmV7YXbu1FLGWhNMgRWGTmA35zQPHZMX	127
7700	2vbz8Yn2jw1Mt7XzC6s3Xf2sGyo1dwYWMSW3mgpK84Jy2woyZNTB	127
7702	2vbBvFFXCQHTcRAEUVfwDzi6MvmTQ75RtnAE5pu1t2PJYncQLJLk	127
7706	2vazW4E2kJd7FVKpk52FuQhi3pF7MWARgUXuAx97anmnsijzSW3x	127
7709	2vbiimjXZNp6LqNBswRco1wZCj1viHASYtT8WcxQ4oiLt1ABxk4P	127
7712	2vaJGEj8wYv8MYcvXXg4oiPtaxXYL7VixtfBR1y5rh8dCscSQb5D	127
7714	2vbiuSSV5FaeBUbDWcJP3PZAznY3L6DY93uq4bNozYgemBjCJqim	127
7719	2vb8rncS4iwKnCgooGWKCpraS2WA6gU1p4DZrMmtxWQVH8DzaTfV	127
7724	2vc4DDGpSY4wZXWLu7xhoxvgi4sbDn8G2x7e4YFziezdTSW7Z3iJ	127
7726	2vaVR9rEdYdrrC1Dn6UW6vXNHuY7QtjMyW8i8aYQ1iHQ1M8jhZsK	127
7728	2vbhA5WpBWFpXXKeHDdHyrLQhsC76UQKR7ofKodsCVx3YE9qxZtH	127
7730	2vb5FtHTrjUWkZU64UszkWgAv2KYtAL13dLrMRtWXU8Q5SVFfngf	127
7740	2vaTiL86pDR2uyAyedJqsRPdh9uDdZ5ncELcRHE7Tx3EPjXkuyqD	127
7742	2vboySuBBPvrgePYTKAAJsJBvQXq3rSZMNHLj3iNckpYkeLkDZfn	127
7750	2vbxsaubuGGMi69ypzd6xxmBaUBUCC6c6toQmGkzXaNKPZMrCj4Y	127
7753	2vbF8iMsCzkHs1V7tohtoLgjwtpBXEek9K9GXFMMTokPQu1T3qsk	127
7757	2vbcp5jFTCMkwBVUDD17K494B1cr3ekho7pTCWV9EExzYG9Nnqb5	127
7762	2vaFCgKYBxBM3ejps3fLz3r8n6MCwtqMptokDfGdJ7H32HubKqdQ	127
7766	2vaaV76Wv1Nev733LYCn9u85UCrqxXWttDsoERjBfjUjsdDCCYSH	127
7767	2vaRVy8ZsbJahGLvXmM5kPpXDaJ9ro1GiPY5xT9SeXMPE1XQrNJ4	127
7772	2vaYWtszcPUbHvyLYXDybzJpcXw88YrX2dwsnVaktX2pfcivbTbT	127
7774	2vacf6KBTVTexNXfyGyFngJXTXhdtVtoznS6LcwkAcpcBV4ChqXF	127
7777	2vaZ2HeHdjTj2fRQggUBduARiCprZt5a3YDEC92wby1gYsDj16wx	127
7780	2vbsLafhqQ6PLiNAjwXG5swT5PFv2HEioWMLaNcLKueEB3GGrFRz	127
7782	2vaMrNCViVSmpBAS4tHNe9KmuGdPyNoNZAP72juV1qm4RVU1hEbx	127
7787	2vagQLTUPQmYTSyGaygXC5KAeen28twBgDNVGG75mvgRRam8vpQE	127
7789	2vbdLRqkFfjqe2hQjFqUxLNSXWn8KMzBpoBjZFy4doxL2qeD8w6h	127
7794	2vaFFuPq64maMGJWrxT5Eqidgzkzj1m7HFGz4TWw2yT6Tug6c8Ng	127
7797	2vamWX56KebX2RVWZRMcrBSLmHc3StKJ5fCKWzdfy2BLj2X18Zw3	127
7799	2vbMTjeiT6z85SGbAHo1MrwZLSHBQLLVtxd8RsS5TDvfyc6axWdo	127
7801	2vbpRPNu7oeDpfEs2FLdH7Y36qWnK8PNtEVg53jdu8FenAdvQgpz	127
7804	2varSiPxbF5HcPc119g4jf2Earjhv9WvGu51nY8dht1NKPPNPh55	127
7807	2vbDXTpbpNWk9NhGAQHPsGpdqHuJkMDKasW9FUq26dmrgEAcvrAL	127
7814	2vbLWqs6DjWGPRAZFZkRgmquF9vBzW6GvxXUQZRgvk4oh4mqHQdQ	127
7817	2vamfpy1oCmf1E8SL5w1VavKY2e3mx9suYkYG9yPQ76okXszjaYd	127
7825	2vaicTxswudwsJuxMN1tSQCtJPgJ4WG1D8tdPkdkD66EMEdgGWj1	127
7828	2vbC9zpXe68m14AM7oCz5Gt6kGFLQun2KLezYpPmbxAociYZMqXk	127
7830	2vakHtWE6Eifa5E2xseqrFSAiTcbEFXN8bomHQmMEcw4dcuWH7BL	127
7837	2vbz7DMn1ouYs9eL9VBRDnqaPLFSLuQ9f3K3yVGXXzcg59bSusQ5	127
7845	2vbNDEKo8XSMJx6y5jcim95pZAEu2UM1aGexyfFHRunZmhB3gCoa	127
7850	2vaSdVi8EXL5MySqHnZQjsvKWWUW5UuvM1yxeCvnKXskx1PbYyWc	127
7852	2vaoBju2hND7g1KvWjXGZy6ZxG7udD5M42YJo1qb6YREehUc38pp	127
7854	2vapujjBFrYZnWM1U3fPQTEbYBfQ3Vx579Kb7XNMAqt93reLZKNw	127
7859	2vbnQBfQoGtx3ozC6bmJUdLfmEyeM3DZA4ZQgVUoKLDPT2jHXidP	127
7861	2vayXG5ackUsLGYxg2JLddacuTo9Anh1jcQrVp8hGtUqGgSRmoua	127
7865	2vaYHUdxjebexPAaxi1J5mqs6ivMgMJ8BURHu343Ebo8gXKTuPSx	127
7867	2vaPZ2vWEU8E9UVpGyeYy1QMKEoqMiGBmaCEPvnEp4JE7qJbHe9Q	127
7872	2vaVNLguiMbXDWdhh7qM1nBaBxp6cRbMkGJ9bi9zuTzENNydThHp	127
7874	2vafzQwhKRsjDheCF7wTatdf98ncsV7CGaDQDJu61RfYaakGHR6U	127
7877	2vbytA1gPPZKhwgwvL4AqVsn53w6wXmjKCpgANyjs1FfvVfNR8LD	127
7889	2vaq1fNtUkuCh5fjQWLcQ62Z3UD8yJPUiP5zUwuUCskfCM35DruW	127
7892	2vbWiE1CSGvXaou72nVDwTtczgcfmLyBs7FdnPPCV8bHiceWi4fB	127
7893	2vaqkErX7nFjkbgQC32kiiuHhtZYydR39kHaja4EEN5AQVffHKfq	127
7901	2vbhQDG4z3tkZkNK83imKqBWqhQGR6r6k9DijAuPLVkBtYng1ygp	127
7910	2vbvgSkoYqsK6QwcczhwBDLjdwdfJrt6Y6aVwVLu6XCDJdxhBU9f	127
7919	2vaSJub9vsbzz7JGg5hsWEf3UaeibSKzb3nzqApjJ429QtaCr73F	127
7927	2vbA6EkY6FrE2Swnj45k2gMYK3JBTwffu6pKD5UQWkr2H9YbEn9j	127
7930	2vai5Gv8AvkDsdgLpGQe2ZdSo7yPzZWJycNSLsVjhZV7NULxbSeU	127
7933	2vaqyV6T7kJ7TkFmsN1NAdKvV6LMvCvGVPkh2SivhgZbSmXiSf1q	127
7937	2vb1ZEMKQCdKJFwrDvicMFysGaPkL2pvAFEhKNXvHNdmJBM4zM8m	127
7940	2vbeVe378GXs9qhPc2QKj2sVTwo8hAnUwDNjPX6Af5fQFQREadDe	127
7942	2vastSvmUJJQ1VpNP4vUXU15TDUAynKda28f3tAW9HeXiKHm4SMT	127
7945	2vbuSqTVrC5GmFgFG36GsRtS1D1GmnpLartJ6B2FazSLcuY7zCQs	127
7948	2vbVnmqVLRXWQDvNcE3FhGAaKF8dDjhEvSk36eLn9f9TWpmjLnhf	127
7955	2vb2aQZTMXNXafA9wDH48WwmVsMnMUhvNfjXXqf64sf5EfDK1xDc	127
7958	2vboniA3Knb2AFqBDKJjQppMywB231qcaRX5iPH82dfZZxH7VX8s	127
7962	2vaqzNZWKnqBf961aQe6nc5DzPcsHwFdw6HaTsC2TCyh1jCQuutd	127
7965	2vbwBMArbfL1pKpHn38Ldd8hZcmhAqvubNVHQ61NL3pJ4GPEucMn	127
7967	2vaSp6BiVPXFwcfkKBYCYGaaUUzfe3dQBMGFBTuAb9QePH8zBwyf	127
7969	2vabGCDyA55JwozGPumtbgchEq4KqjFjn57QL9MwtuoqedVJaDXe	127
7972	2vc2tCVq9TgcPY3grFqaqvG5zUnMUFdMGykwzxjmPJLFwnkdWKPK	127
7981	2vbq51dUhhS1YsrjT9U1ivhku8e5iaaBqMpG4cxbtdxfNahn38uW	127
7984	2vbeY3YLRyB3Tvyw8fEREgJxP7CsVuhXdfHynf15vwutjgoGKKQY	127
7987	2vbQTgXP7zDPxDsA87CJ9TVwAMFcXriwTDcW9vuB1NiKR9XR4QuM	127
7997	2vapqymXq9EEfeakCpbfKLThAQqp3mmj4vVGhKVFmQTw31BywQzP	127
7998	2vaCiopnVNhhkCfjG8NYRMziScMyD9Ti3WfsKajwcQEsjaCAexnY	127
8001	2van5xvgpwHVrMakNMGt24CMHooF5ghX4eNfTXfuPmRxxvd3hkj7	127
8009	2vc2cWNNcTrto2PWvtuJQYVLmTt19McGsxHyWuRFmSFFqMfxVeUw	127
8011	2vbo3uWjuNYCK4q3ZkEWH3X5ERAshL2Hu179r74ophPNfvhyZanR	127
8015	2vbTaJUz7R4EUgZRUSTgSfUtE4onAH8gVSV8g1AyawPrGh9qsF1e	127
8017	2vaKEeCd5QLUpuh2MWoKjNEHJh1v4nRcM9Bh9bHhdrnP5nsozwzL	127
8014	2vbQS5VJ2vQdwgAGSwJ3vuUGJqyF5urj7dMLbKLnUPpbbc246ZW7	127
8019	2vauW5G6hbBw7iaYkVhiCYsshniRCsykGg8meKJXk9zimpX45ovu	127
8021	2vaMMG59NkK5tqo5NxewCAdPu5zy2n6WMw6UHFdbwby97AjC84na	127
8024	2vb1JnM7DBxmg7Gca2DGLRVYjGrFp4CjJPZUcLYvXZNaaaoNoXDC	127
8027	2vamFs39NBeKQnbGgBArq67TtfJAUKDhjnJrjnGZCuY4fqXSrzvZ	127
8028	2vbh6RSzWDLKsHcHEs4rQSYkNjvbKzaA8veXk4m5M1t4DXLSC11G	127
8032	2vbkEedKQurBCusTk6PJMP4jD8btJRA2qHNRTCewFTdtMDqrfrjR	127
8037	2vbNSQ1TFPimHp9Es7f6LxvpzszERC3bzU1zSU6N8e3MHyjreFnM	127
8044	2vaJKrm3bF1ArdGxq3tkuekaea5rYoXkF6YxHRQt3T7k1V9PRjQt	127
8051	2vaR6v5taDmRCjbpxfE2SUZSkLkGzW5YC84wkWLqxz1gedFqZNEX	127
8053	2varvRPF5jPtTrRMT5bAHPFD91nquP3MP6uGcoYoDFptWSnTfaWQ	127
8055	2vbJ612ZfmHaoEAWKYD6HZbKjmBnBxBCz12rJ1kLqBPt49DHsn64	127
8058	2vc1suuxTKYmJJnVVV6SpVdrwazQC1nkYBEXhmTcAd8jr4k2eC3q	127
8060	2vac32LEQGBjJi5xk2rnN5Em56NUs1zook3UmmKbZ8sNrcdmPiUP	127
8065	2vbbFozj49HLRxiFvdXz36rysVjbpTyzDjA8tNRPWMT3N1tdP66z	127
8072	2vbJbRCZNAwaueXgVY2q3bsva449wbByQxjaGjW8wP31o4Yfay24	127
8075	2vb1MpnHQWBZW8vto7ps668aiN93h3W3nZ13zKxetfKu7Z1um5td	127
8076	2vbaDhdzaP7baLMFyjLJheCWTC1fWjECWDDG5vndoo2xgujgY3KZ	127
8078	2vbsQoD1npuE7ytFsXwULDWSEs5K3eCesFAU5nDK3aeB9XbVSnuB	127
8080	2vazQwtStj9wKiLPibpCXgpZjP3Qt94ZkapDBwTPJddok9sXMwqU	127
8089	2vbybSCKk1vQjJHvDyZhHXZinucxRTV53WmT6SgGT7kHmJBL1p7R	127
8094	2vb22aucv6CVTa2PtwLKrcUhLm7oYXNiDQ6EwZ219XWcYmoxwYKM	127
8097	2vasGFtrK3MrfMmUpB4z8pFhNJcFpK9XCZjC1hxMRqcwvTyGq3SX	127
8101	2vbStUhYEkGdTuUW1HwEASJ3DBoBJiy1R8r6anHtgYzAo8c3XjiB	127
8106	2vb2pzFGerLkjy6xGDvY2zQfgaKdYR3toDJeMJSNremdBZkbW7sD	127
8111	2vbFgNcAAKqpPRQ7hQehML5DCXa4BUiHtNYGE4vRpUrV2ZB5fTYt	127
8116	2vc2CnxSXVSUYyNn2yoMWgBDntXp44YjjXoZW7GQTuf9JAtfTiHm	127
8124	2vbRwMfcaaEmGwVDDnpby6AK3Vev5Ma1umgKbG8RGiAnx9fGW6wb	127
8129	2vbGLW8YknkztS8c7VG3fk4Y5RNRNFgwxmxyzWwjVUvL5MGTbgws	127
8131	2vaDeSCjJVi8FMLTaVYqrLqwNxPMH7qfttvyJ51cxro71QQPQT3v	127
8132	2vbsB1LJTxCLEPF5mpqeo7ZFT6xrf9cm5mTna5qRwyEZY9ZFTMHB	127
8133	2vaqdPumHPQPXqJBC3WyZ1Su752TiY4n84eW9wTTmZ5P6gNzeWJo	127
8135	2vbjixfsFyE64CgbUnmPTjLvaoBpYFFTUZewMGVWLXjRoUTdZwfn	127
8142	2vazPjLv83zDCztgxbiowWyTxcx54SHtZVmgb3qKDU1YtpvT5cXk	127
8144	2vbrWrmEzCWQ4eqMhZcj2SuHH9mJwNT8tjQehHrfjWD6ga6Vihrd	127
8147	2vbMbjZ66PeWioX9iiewEVgh1HFBMeFTLSceY3922GVGpDPzcgfH	127
8151	2vbjfDee67MeazFgwroMApykwncKxMgkFHQ1wUwsRWrt9Lf4X1A4	127
8156	2vb7VTQVS99YfzzC631mV5UtSxcnN23HgQEHGgN52ZkmkStZzJND	127
8161	2vagwfwjFUK35uTbJaDxpUhqGXwN1vC16bo6egjBxbaxbPhSpnQs	127
8164	2vbmx889dm4i68c8sPRcS3ud4i2kaEmyz4WGdwj8rCsCzmSS7JxX	127
8166	2vbxCHRiUg5KEPuqDsPZPKG8LsQvyJiTkPJkCbQYAkmx4eixbReQ	127
8169	2vbqA8x7VeU77PdVVXP2NmSkfdxR9UCtW1MbFJEB1qhT6zN7fotN	127
8170	2va9N6ntanEe4ERpeo5ZTY3SGPLjDRzUinRvt8rFcUv9pek1QJvU	127
8174	2vbgTLgkvAhtSLfPQ9zsqWEPAVctHsGisH8jkrS9Gus1YB62DaC5	127
8182	2vbF53B7A8egYbc13GJZzNMW6Sxz4Raxi3QNKAQ7rXaob1F9uNDD	127
8183	2vbHaoR2MX8bYhqBgwVv3ipyvGXD3Kj9Wnyqj2o2xixnBhjDWty3	127
8186	2vbL1JbSWGYqiMHtQw5zEJRAStVCpBCkoQFAAHtXiEHZWMAYwios	127
8189	2vaJM6VLwvWsAXv9ri9juECJA8pgbGfiYRoibzoeZqgANBA1FSUc	127
8191	2vadp7N5N1kNKdPxiZjo1nCY5KD9bxvDKg81ibouPx4KP86brgGE	127
8199	2vbg1o7UnzaD4HTpwd9EoAHp9rMAGNrj6FG1GpXZCbKcRVfPuPZH	127
8201	2vc2vGMVr6X5p3RyuNZHitaTT9EohX8zmhKtdihDdcGDgRqwrwga	127
8212	2vbNHGXox4swjS42FqLDaueyF1iCMu5vQkvHVR8z4pHy8wVRpE4X	127
8219	2vbXaB2VQ2i22VebiZSnmYtRKLN1FJ4kE7qJJjWmkAEpuLZJHbQ4	127
8222	2vbhzi6MLJ8mPPmSsnegrLTVaiXaDW9HRJVHvPziKo2SRqdHmy8g	127
8225	2vaA6HBpzQDHnyaQfLJkShyvrTxasQDZZoghux2Xz59eK1JKrjJf	127
8229	2vaWR6nj2b1NCdV8pvstapx7XEXGb2zT39uhhsLDRyRe2Bck8JgL	127
8231	2vabSYc6MmxnXvidc5Sd2tLMdBvkaShGD5QDutsivkdyWrFnBuYB	127
8232	2vb7o5VRbgx3F8gVkQTb3uchnBEgp6ApvnLFdkdjT8mgNYqGdGka	127
8236	2vaDXQHodVUTLw1VMHPsxH4RZ6E53puhGcBX6JnAR1TnMhzyS6G3	127
8238	2vbcxji2SfHWwNsBuZQihHWixofQjvXkbbyLm6ctf9jy4aQFrWEz	127
8240	2vbE3yYxh3QVJrDsmhX4pJMm8PXCJGPYkf6KCqiSB9yCRnRzqdpo	127
8243	2vbotvzVuM7aqezF5nYJ7YezaS85iUHdiDrJatxokeq4xGB6YnL4	127
8246	2vaJZk1BkChWSWbNDKv6GjAEXWF7KkDxxegFgjtP7y5uAudaE1Ld	127
8252	2vadjEvY3tRWg4YGu4MCuNWVqXiQrDX7L9DBGA2JosVwSg9R9aE9	127
8257	2vayPMvcnr6Yz9m61p7oVdA3KpnitBGxRzrBB9VD1gLwu7g7goD1	127
8262	2vbUrWVrbh7y9xa7r45QpkcrP4XxYvuFpJstprKmsnNpgUiy7Dms	127
8264	2vbdLcS2Cp4C88RAqzxPWc1TNtuKcHBmKvP5K6xShYQYPtytQVa2	127
8266	2vbQpThwW21ty1LQywyq5cwH71RQMiWrmfs1iwrG39qy2Bh3xJmf	127
8269	2vaA17jZE1kEs18WhLBxynKGzsq1beRpKVUSU9okqbu2BzL6Hwbp	127
8284	2vbbTn5YAuKAmu6qvpwKv7M4tWRwe5cCQmmSyG76iKoGQsnJdxwx	127
8286	2vbmYv5ts4xS9Yz9wm6zqL3pPTv66C3ZkRHpjyUfc2WWZwY8i4jS	127
8289	2vaGUQ7yx7nKDzd7k3TwGL6wp5Q7AsvEh8JtfueTfz969u9q6RNe	127
8290	2vbbT2VRwjyZ5JR3opz8owucVdpSUYoep4mT7oDMP5fwbBNtZ6ea	127
8295	2vbLgiXLfhscDYBP47TuQdtKCDNbd5VgFpfFnhZNgF3MnP8sWqq7	127
8298	2vacVKThM2v9bnAtSRu7vdNxxt1Zqa2SEHBiBAcJZYUopBEYEMj6	127
8300	2vbrmLZQQ4tMtiJGhcrtKNwVnTfGJRHLN9ogDFtGnCx86nTwEV7g	127
8305	2vbjJb2VDH3FyQRpjafjMZD2dxyDjXbYRUxXVpxHApSW5nwaNfrX	127
8308	2vauVHDknJG9mNLN64HMpBvk1M4PwDAaHR4FAuhtH4N9WV5uVRMw	127
8310	2vaRyzdcXPevR6v41pHW5PKQMZBrmxFgditSwtwF3M5VyyGWjkUF	127
8313	2vbrVjVNY6h5RCRuWf1nD8W1j5m1xmJMWsryBkAbR4sopXBhxBV2	127
8317	2vaR6fNiedqq2qz9RdQToJkDjCNgAmrC5YAGsRLuxCmnMW4iCSiL	127
8318	2vbEv96ikAG75fgmLXbPwQtuMkxGrM6ANfYmorPZxS9Akxg3PnnT	127
8327	2vc1y1vkMk9mMyuN7XzucUZs4HxJkHCYg8GySQM3cVko1Nzc2xqN	127
8329	2vbkwqDtHaBdxnaZS7KoceK8rnnzRFhzxLzF6Wxq2jKaa4P3AsfM	127
8334	2vbwCH99WRseXZ3G3dKJjFr1LQSRrEXPSELFHWtnZcRoAQHfAz1Y	127
8336	2vaopvnr62t8Tuhi1k6J8AB5QbKTGxkaFUuhvSLX5ijP6BxgnrWr	127
8339	2vaA4oiS9umU7pvgH11T4Nd5LvP39jgLxEJAYCFSmQ2dNBoaa1pz	127
8341	2vbXMFCLA2L8BwqdUhYmYzus5H1fwXHyAjf12TRvMJR4xyvd71y2	127
8020	2vaWimbqqY1MmNQwXH41Jn7JBXFM6vKnYvZyLpAbD2XPgPEr6VaR	127
8022	2vb2D5761LEMsKPC2ypCeEzjjcWskJDjxDUumctmPu6GU9jGQLWJ	127
8029	2varHsy2D11B11MSZTyVE4qRU6sHJ5LoFr88yRbnoKoV8tw3A8LX	127
8035	2vaAJWeW9w7FQkQt41VcVfzB9E38e7dBCKryZiMwhR6KnZHiBfxh	127
8038	2vasjyMLz11dnWSiTGVRhShVJEJVWcGVMgTABifQrJkubQ4U37u2	127
8040	2vaB7wPajARpzAhDk3qFmiDPho45gxNvGDckQAx7idKFVjAcQmKf	127
8045	2vbS3qhHqvCsb3BYhib3JYcLt2XQ8tSXXyU8bB9JipkfVRMvkDcx	127
8049	2vc4vcX9SPtv1usmHWHDiZcTrvTZxVdFmfpR6hAHN34DvN4S2Jfy	127
8052	2vbJdsb2w2HVZ61iL3V39X8xUZuVoKpPPMCFEVe96ymLBanHhyBV	127
8056	2vbtfmDnf5Yku1Vd2GUwgQ9ENz2mVcbUVWQDfhZt7JzYBcLq1Tfs	127
8061	2vaaysKMXa5zLA5TEtU16wc7iZhTvwfnuKNN4w9ckZGGb4GX19u5	127
8063	2vak4gNPK1ejMsfCs3sQNMibd8yXVUtJzowbYXyUb3qRu9zVLkxP	127
8066	2vaYG7hTtwJC983pwW5V4nc7N3QABm7ZLzRVtWRbRbe3fMRoGUw3	127
8070	2vbTH6KkE6EgLk7jADvw2ZhE7cQfB5tXNxxYm1xg3RMtmTkb9NEc	127
8073	2vaz3bcjkvjchXdCShhT2Fk8m9D9CGnXzgy481oMywmorLizyZZz	127
8077	2vaa3CXb6D1eyHVVMg4D6xFgwWeajtrgVAVY6UkkJ19GBT23Mj5Z	127
8079	2vaWPNNtwoH3hNF949ycQJFRbKGryUPDWvLdm8RUMgMja1QdE9z9	127
8081	2vaTxVUvZTFEKkRrbBAd71iNTSuk7yrqZkLjgCmqXXXrS8kEMt6h	127
8085	2vbAnPyiEKeP4Bui2jufb6wSV6D7qsL2CXFsEAxfiobhwUGSGtVi	127
8087	2vbEuNNUZsLb1ttP4CkbLPdJq3bAeaPbKZw7LTX7Hjwem8NySG7L	127
8090	2vatQLiHRHaQAaPwAmB9S8K8AosiaVh5Zou96Padnc5rmixjpZZY	127
8095	2vbmWRGEUurwn2DqATgNugxcgDqAEbXFv6E5eiGRrNTZp4L2qpCw	127
8099	2vaA6V3momfxuh4bEwAueCS6pMswGj2jsp2wBau7S8AvFBxdTr6s	127
8102	2vapZ7NS6B9LTy5pCH26ghHr7hnoXLTszTvMXFGcKmLnCU74eJVp	127
8104	2vbHNEf19mB85vk4UhcYvq2DFfPJWfoz5nige5FAGNJLcHBbrPSj	127
8107	2vbBgnNZkPM9rJ8RBzkF1KRLicHWrZdPYkzgurNk98juFiMLzaqx	127
8109	2vc4M1RgJS71aMGKWjcX2TKZG4RT8QoQ3FtFu7pTcQcHuStbBaYZ	127
8114	2vaftHpHSJg7RAXPD5hGiC9kkcg7YjRPRVeXArEbpWWb6quHqrhN	127
8119	2vbzBAZD8kqZRpbtwE4K8N7d7pqwCSVzP5bVgPnkSkVBAnDJWYjJ	127
8122	2vamVWxQv9Yr7gPEbSYmoxjDkmDo8JCqxdsTrwu8bSb4n2uyMJtL	127
8125	2vbWZzTrXnu6JVw7EbRBofjHGRcbwvQ1nPiRWy7ZqbGSFCCb2KtQ	127
8127	2vaE5ecfo5E7en9xnQbNPJVFqymSUXuNf1FEAtug8d8oBuJvL7qk	127
8130	2vbqavLQMUtQDWTXdXnhdpUZHvcTVL8aRWCq5YbrNQzH6yCmkuyJ	127
8136	2vahUb3dyi9k8Xj4gUNB7FcM7WJPzAKQYPAm1Y28JU3xDhuDuR4K	127
8138	2vbqJeYEfZ9dKB7byh4y21USo3Vo7DTXCPVsZtwdpHHXmfcNk769	127
8143	2vbMmUbgMsqdYiGbxcDhP6kRuRzKYtUjqj9q61LZfsjJfVkPU8ej	127
8154	2vauPwuyLLcfCkhYyENfikgKuggkVDeVSDHF4aqxY4ueHRXjEun5	127
8157	2vaAhExvptUL9kJw8Xk18tfpUcwwsfzVUBFPLHUG85SLiTXUNB4n	127
8159	2vaZzrmN81vfwK9ZNXEfwiUsP95XxzrmDJuNLk4mydT4P3Lo2Gmo	127
8167	2vbhTJcTCEJpCQxBZ9tm6C4YthW7HxAUBLPA5BxzuUSb478SkwN9	127
8172	2vbosWw6nETdicNShCaZdyqWJtXguaBn8grrG3rW8WwdmxfWkz1m	127
8177	2vbcMj3e3mCbvgFByp4kGVBVokyU8MiGf6qZ29GmodgWtHoTrxGA	127
8180	2vb6f3t8V61rW8yCBhrfZ3CH5g6gbBucjvhyUqGNB57Dw45USJ57	127
8184	2vbHHRRHQPcskNyCWLRQQxiFA4BKTp6BQfjn8cV5Peh63qombTjV	127
8187	2vb664DQoK1zN3gjoHExTbu9gSctXfAtmHFQ5X1wv8cqwnXPfJtd	127
8192	2vbHRG9TiC9GfXN9gSeB8gwg5gUXqgQfq59As5Qpasge95Y7TGaL	127
8197	2vam8AFmSM77Mg4r8rEfTV2brM6hPcEaZr5eofv9xgcTGsieZren	127
8204	2vc1tPFUE3Pfqvd7b6T9KUKkbh2BSw2Gd3vtLw74PjuY8i4b7Fmi	127
8209	2vbXCN75urpvbKe69LB8VbuHBYd1GQvsiZGXnorcqKQbwGxScd12	127
8210	2vbnfvNwNFY7grpdYmdQtYQLrkExoEbTuZ4JKYTiHsjp8bweND12	127
8215	2vav8Ash7mGATSehAyyxZYG7cTviYTCnKS6HPKoTivDSE9eQp3gC	127
8217	2vafoemVtLLkeFanHCbSd6mAePka815jnz3gVLHiRs1SxosZJarQ	127
8227	2vbt22pbjFMLafcG8ofteUauXWQNm8TJojkuNUPHiYjwuR5tW37p	127
8230	2vad4gd3TW4vCGV9YbdrK5FJ2ttqcCUWu1nVwppwUEL9YxHgD29R	127
8241	2vbNh7T2rxMqyf1kgQyGzhTSnQAyuraRmhdgepmKwgrHboorkJKg	127
8244	2vb7GpWZUw1Cyh7mRUuMn6P1wcB255XoJKtq9N9XRsSgfKtvBFCC	127
8247	2vavfXS874nDpCb4uAmNqgxrtEtMYGeyDg8fSsqN6hqwvFA3Nqap	127
8255	2vbq2KHwZDPdeu1ckR1KrPhvtYqvxyy3a6T3axVzAsu8cTZxkEkG	127
8258	2vbQ8PPHdiLP3gGpwdG4NgkFmg5TNZ3UKhczVTaACLmDQgiS3K7n	127
8260	2vbXd6reor4UaQNVsHZB2BrLRhLmy3tvK14cLpX8vsNr53wQDdon	127
8265	2vaWbmznZCCncDEG7YA6AFNPPc624kQHsUw61t7GcZG9irDjJw1E	127
8267	2vbwmmxXqrM9fTo7MS5gZSA49vXqRwprP8FhQqYA2wxE2UnNxGJL	127
8272	2vb7d7znbYu8QA2tLqirT4RVDCeisGqRzP6VDo2qH1tqY6Ut9VKE	127
8275	2vacRFfVR5Udo9EYWpmMuAQWSWBzocoZCtte6hwJ9B8Y7jNpkaAu	127
8277	2vbzpT2s8LExBfYnQSyp7TwEbVBzN4QoeFzpRwoPtPF3eMh5pJsh	127
8280	2vbKtBMYgWUAsNi6eVaKx7aZQySmSiRfRSDZkioVJ1csExi4U24s	127
8282	2vaNXJaBU6aZmGL7kxiJtdXBkpnVktCshkwer4KSgoARPkVdBSJW	127
8285	2vbZq2cv8n8B2meV7qorQHsTY6hFQDpcRsWtxm26kcv1Bu1irNwA	127
8287	2vaNMJrYALCToMeXsFpe9H1uJCvxusiFYtGKEtXSqcmo5HVxMKN2	127
8293	2vbCRGvsKA3xHPgpovJsUrz7cmYJw9bt4pjGVi5d2D5d1UqqTc1J	127
8296	2vaKx9vWdWSqbBeV1djgmv2j7w8erNPEfTqRvSoYQCzLdJrifLqV	127
8301	2varC5sHU46XCR4YZ4mJQqG42dXW6d9A6mv5SMgtr31SoUCdSd4R	127
8303	2vaJwPLWZKLKGdzFNUiSChH76ZKPhBVMonJXbHZrhwbFYFyq2iog	127
8319	2vbjYwxuBrenQgGtKSq4eaz2DP8dm1fjSLtXi8psZHtJW5NeQrpy	127
8321	2vb6T1NHAPivF3xVYh48hypRuKLEgXZo8fz8nehgVmNkyZGy3n6Z	127
8325	2vaxyfxdF3hNPDjp3qraugQ58ESaHcsBi543DSAXEUQys5aS558q	127
8330	2vbGEU7EMYxiUF3a2uoSjPprkbehv8PzZG2PMB9M8eafVTjrq8JS	127
8332	2vbs8Vqw335XXTHXyQfVsEwMmNyq3zHGPQdC4QzrJGzjbYVsGxrB	127
8337	2vavKqdqGHrjDTe967ULCVtcGvbmazCLSEmrmLsoqhG7W6ftmSbW	127
8340	2vbxY3uo9b5Wb5hQiqpXc37edgajg499uMTDSefZ7bMqbBVkVy1T	127
8342	2vbtWMZDB3VfPC2rFteT37T4YEsHcPr4VChQwHAGyfJkxDvnHT35	127
8349	2vb5YSDig9JAhz4jqJWcim81wtSDaedqQhSxLXnQzFHmW6S8ASB4	127
8357	2vaebDguEmM6Y3ZCVAqCyj6ZP8h5dwWpnxUd8pWUHGrCdHUiXenF	127
8362	2vaK3sTg7EsXpamdCfugJ5AWFrQHLg2frpJiXNYzu2x5DLXEW5Ve	127
8366	2vbWrY2Roprw2PgdGTW48Y2B98ePMWZWD4UPs5wbHpGeDpMs81ic	127
8367	2vaCdb2ahXfyKA4ieJGNa24svW4jppMSFGRDs11gyJanWGYt3W4Q	127
8370	2vbRVXFPHuSi36p1km2sN656UxM32uZhCqTUcFMR1uxcdypLvpub	127
8379	2vb8Wz5sQ2oHEzFw1oUQ6QFky4WjXNezQEM6wwwxkGMb2Zwhehcx	127
8026	2vb4e7ADnm5GicPpK68zWWudg6GbQ6XXh19KbeucRjybkoUAQL8a	127
8031	2vaojnRkwa4JoDm3MMGEp7egsmckqHKZnwHXkziG2YAbZQjoorU8	127
8034	2vbhe5wB4BoMokPPvSnd9yiL6pmQ8cGuve1FdoNFiCkmHZi3cTv2	127
8036	2vc18ykwa52yJjk7koyr2KN9Vi1iSsC7Th8iPUvVhwtVL8GRS1Cs	127
8042	2vahYXmrwtqTCMMCqp21aixYbWiZmarRmpC8f7f7MuFAxenZCDV5	127
8043	2vbwU3jHTXGLLUDUDxXt5dyPPMWYEcUAX1FYn6z2rWcAB3sWd5xe	127
8048	2vbCFjAhyvRmvqB39mcXs6oKYy9TbaQ6sz5EFzEDj3orDZN2XbVu	127
8050	2vbA6kCDSSoNwz61yvP9jqxXWiXN3ivPHDhSmzUGTzaVKC3j3RD4	127
8068	2vbmz3xvWxFPCBuaFVHniUqwghPQFquU1wD9DZKGryjcfwudEc7t	127
8069	2vc5sTV3HzjVbEjzcP3bGX1Tupsygvo4bxsbq4pvCxN5WarFcuvr	127
8074	2vbea4kre8SXHBeqJgSwFroVMAe17zz9VkF7eacTsWLwZUUaPzAo	127
8084	2vb9bbtFAB5fMYVZTToEAJNvD3fqUXan7CBzKYX3zC7SABmusQ2o	127
8091	2vbW9HqUDbJpgGWEaRTWvKvx8Tr89NXDyUEvjdSUaSRHtFNpCxyP	127
8093	2vbRAYuPsbvcaeg9RARxDf9GTwWLDC3ooRLMV7dJ6TpLUxeYm7cP	127
8098	2vbBk6vpJ2rdkQZpyYKPsUm2YahEXs5cxmtb6KTFjJp3uZxmAAf9	127
8108	2vbgj1by8sS26MLno2TsLk745Xy6pwtWYeJGusSTCGCMhLQQmjxr	127
8113	2vaQT2SEBKeQRJqhG2PUHPJZt5qpQiVkRPyoSv5y2Mp3FHTwixfd	127
8118	2vajnGo1wk2SQEBXZ6Msa2ASXxJxDZqyMzfZB5v4geWiAKM1irSA	127
8121	2vbH9qX7gW74uRx59ktH5B8j6R3EsnnwGdfpGHcMsNLeWzXLKvMw	127
8126	2vaopFHfPBjuWdAMkvbDKBois61uYqN37X8w796rZkvihcc2oVrG	127
8128	2vaNYPLQ27aSA62txDHLUhaEzsPmNQF9XNsFCb3P19dL8cuKCYP7	127
8137	2vbEvpnxP5m7NtkrC8wJTkBGRMEqAYFABLZpuxKBYuFQpZD5b5gN	127
8140	2vbBz2RkV64pstEdJnqS9NvqbR9ce1W86z4qxEMajpEm7Egw2UVD	127
8141	2vb5N6bgJBEgb2TeNQ55FxTZFD6vS6d1FLAPWUWn7Esgzu6odCc2	127
8146	2vak283t9wBNe8AmXuxpmsewLBkGFgSnkyHyMngcfdRJqctWpJCQ	127
8149	2vbt1aCZBVJhgL8axsuBswiUD2VALpUaZqVSFNkksurm46P4vQ5H	127
8153	2vbxAKB5Cw1bp3nudwYsp24voYbquFL4ERe1Qd2PMMqiULKMG9L1	127
8158	2vagBiyeG8LSDTFVUcmLhC3QKoBzXt2MGbzCBZ9BdiRvsibBxrRT	127
8163	2vaVahw4iMXeMTVkitBkWMeC595wF3nFXkMPWLBW783pUfM4Dihk	127
8165	2vbqbssUjygujQaHxoiEGbPicsQDBFy91zq5H3WbZBec1FqQqxZE	127
8168	2vbK15KsdPwCbTmMK5hcuGaBuwVefrtLkNYUWFTFWNMaddEvdZok	127
8171	2vc1nHv7FJFZ33JFKUJMu2FGbtKQ1wv69Fx1VdXLJUY2ndr5ujQ1	127
8176	2vaCDiPc2v8ZxkpCP3K8LJMCAcfThwktCG4f7NVGXWDXpupdjiuu	127
8179	2vbgfdAQS7LzvTMmnYQ1h9dNUR4hHVansHDMFCjUqUHe9YqSbA7y	127
8188	2vbxFh61kUvwSLkeCJvxGyL2CVzRUziSqb2XpqtSF679sfHHnqm3	127
8194	2vaYE5bKkg8m93wGVaJbF31buqeNamijS7pz9QUwTUNt2DeBDNFA	127
8196	2vbX9jMWYsGZYCPvfHPZv2HpTtNpLHFjqj4DuW8eVsBzaGnexyDx	127
8203	2vb2bsoMCtqPQoVBGYe5LNGZQjpHLCEBY6qkRaLn5KpRH74P9ybg	127
8206	2vbycQaMi9fuhS6uWUfGT3pmSKqTCAsX4GeVzCvRZRL5FeWZryKt	127
8208	2vaZtTE1YZthix3EKD9XpquuDYBDNoVWRq9GVVk1AdehMMpYTnEG	127
8214	2vat1ZhmhFvRLHQsV6Rh9bKQBBdN3fFCg7GY8V7H2ZzutJpoBf3U	127
8221	2vaEXN68nhB63WTgwX9826XnnyoJvH2M8k5pJPXw4EQenFAdVNmC	127
8224	2vaj9o7D3tFn2fqtgAH8qo5FXrzvG8WoSTT9g4e11k9MkkYeH5mG	127
8233	2vaZyZ7ZNEtRW2atsqPdRVpodLRCcfcnxe6W5s9CuyXjQvGuXDuN	127
8235	2vamRcg8xzFVeeZn4FUm76MjgXK5zDT5Keu7r8ZfVToWPd1acADG	127
8237	2vbEU7MEyJnDtfCbiAfiLVVAisepDdofLQnB6Szvoqvviz1QZB1Y	127
8245	2van197vAtjzf4Mv7sEnmGfLKja5jVhj3zL2UA3PuKBqV5snehMV	127
8249	2vaZg8dNYskHRujpfZN7ajhbRhk89MRAZLTBUe9UhktjBjZYzVox	127
8251	2va9Pv32mzcA5PhkWdbVqdrwbtgkPCrwcjoykVjdgGZ5BMpVvNHW	127
8254	2vaEGcQxKJHri94LVa7TydFCbzFm5T6V6gX3MWj53thZRA6efJKj	127
8256	2vbKVvhiViriWX5Ewi8dCw4C8skkTvR69wuqDsTajQ7bZxNC92zR	127
8259	2vbap6aoX5eGccVKWTQc6U4V1kbJBwyAqPvhjiirjiCa4Hd7rg1o	127
8268	2vbKngyki5xcmVNYSGBUvPSH9BviHbRPG2joUjTtZZDbvGnk7jQx	127
8271	2vav6F5s2dkFh1sKwGEP52r7bWhnHRAu75e8RsRkWi3bnXjy1AZj	127
8274	2vakP6EMKA76pqeEZDTkvFA7MXA2tNNfa7iQUiEaUqtaK35aPPWA	127
8278	2vbXsFYmMY4HDVrWdZjR1Sif1vM4qnXARpqQQbtNqcdRMPQkuu7z	127
8283	2vaRVoC4bC89vy5qefWH6b9Sr4qVv23zRftaeNur6w1QDALvoGvM	127
8288	2vbPBCLRz2c7QLaYphUhV8XaFrqjVp9PuKtctara26zrLfwHjec3	127
8291	2vbkR7HHzsvigFdTwLNYKc2i3W7egLqTt8H2g899P7AGCtoiWJsX	127
8306	2vbGBQ2oASESgYQtaRYCLxW4MsHC9y9qtnK3PPj1gMbHHAtoCBc3	127
8309	2vaXfamAJFeqQSJF3VXJoqCbHmahQBT5HizX3YJUJXry7eWrocrs	127
8311	2vbZiZE5aWdQtqx1vnpCTgwxdezDPNB2hASY7AVUvcceSDaBMaZ7	127
8315	2vakmZNmn69MLoCCvwxUPe92oc1mQ8e2xmqJ87bY2ujNuf6dPxUQ	127
8320	2vawNpb9z3E5ncYyh2zsS1aTNity2w459AbETk6gXxp2NomCTgnC	127
8322	2vaYZfR1CEuccExkdFercrpAgqnBRxid49La7CY3nwvHeSnWJbBz	127
8323	2vbAKHJEuusaRp4UWxhekAQKPErL5gWs6FPaznkPYhniFZwJLkw6	127
8326	2vbHYKqpawr9JL1wUUSHUgjBipBZ9QfRgLvSAxqCLqoynVHQiouN	127
8328	2vbvjYh8QYT3KzqHQLirzKef75jS8zarYkMcnJVnKTTmtDUoyEgN	127
8333	2vbHeMGXsopPx4wZgPfY9sYSx7DEPmt4JD6WNxn9ZbdT6pnzFB9V	127
8335	2vbkBHUsHZ1VqUXkf1y4qBGDPezfJARvMe9rZc6d84tRo61KnMxD	127
8344	2vaCqJ7wo8RkYeRpzgAK6EzmRQybB1GpBb84xz7kRboVrNP6B9Bs	127
8350	2vaUQg8etxEs7rD8k2qMeYhAdSjqJ6e57yRi8eTuFeDu1pMMr7tc	127
8352	2vc2PxLoJdDDZ3TDVsxq1edHsrZ3mnMs3cDoR1dR45bNzbcmGPxh	127
8353	2vbaDKnuxtTd7D2zN7hggnBsra1CWZxZUNnNZQBx1nFM12w88N66	127
8358	2vahLVXZ7b7XfbcRsgD5AQuQYZS6utyTwaMuExWg2z4BqZqeh9gj	127
8360	2vafyJvFX6jBacfBMSRDCHhC2fpMr7T4do1T2qoEzunvEAETxVLA	127
8363	2vaa2FpWZXfAUXpWP4B8qr5MNy1nRjBSWzY2Hpymc4rHjUSWMkW8	127
8368	2vaXciuNTY29YoPBbGcsFVrmAeWuxyfgENac2qVVXMQTsnXSKRVV	127
8369	2vb99SCixY33P11RUbPRxRSpciDKbYEGwGbLzJ3apLYnSvtYrC5J	127
8371	2vaGaG7FWixs1Xc4wNbAppjquJHuw3VHfACe7vtYaAAAFXxFGCp2	127
8373	2vayjbMM1wPUYdeRSCwjBJmW14ysmaLf2G31KDYjdXU1dxpoq5Wu	127
8377	2vbNWawK2ws3sccEbrLyMTBQMtwsJmWNhLCXE6NX1KyF6tnwxv6W	127
8380	2vc4Ld6gVtivYyjGry8oco6bY2WQ7z9czeNSYhxfye3eKsYzy7LP	127
8383	2vbHfRZZreoXTxJQkUC45YVJ5ifjtwuNWCcRKT3Jv9jcRnGxwrw1	127
8385	2vbmccGetJLY84h52GTNLxAi4WMQ9kApkRVNjvtbJLPKYCeuV7rg	127
8387	2vaJw6Us5XTHqqdKMYHZd3GcvwoPHdW5dRHBGTm6sZGRR8XUsW5h	127
8392	2vb2QJBjAL97mts3pQJZTxoE85iE3wrFGp4yYoMYqUN2ftuvRRaZ	127
8395	2vbMZgRg8VJwCBZ2DFpAbaGLkEzyT1aDATm6QX66USSKTmQqbkvh	127
8041	2vbND832Mce49enufgLepacoDL1beCijQquWSvsgdod74wGESnNE	127
8046	2vbQUnVHWZ5uzo8rtG5uYdHzZMQemzSy94YX8Uto7CtyaJvDqCv8	127
8047	2vaKmBtir4XoWYiLV22SZqUn92UXAt8Je4zHPgeS6A9WKMaqdYoK	127
8054	2vbTPk9PcdxhzbtfvDG6QhnYfGtsLSzZNZYUUx55RLEC3BCxoUSh	127
8057	2vaM8g1i3j13CpyTUfCULxEwdjbFy7yn5M5v5kiZfMxUhDTZkFxk	127
8059	2vb97F1iwifxqT1sAiJcX2YNbK7v6SWL1r5XKjZqW8bMpFuvrstT	127
8062	2vbgAL39jZsR5pyqKZkvDGELrAhS42dk9jodfgvLAwg3aEjNoZJn	127
8064	2vaSnFvaD4F9Bn4A4HJCKTVarJdRf8C5eX74hyK1NP3aMSH4L7ps	127
8067	2vbyAdSfYpwrWumgf1tYgpFQNREiQQeSeDaSLvTUY3DFSbfnKGLz	127
8071	2vab2UdnAgEbddc8eHMSte5VGSJRLjmCmb8sQmz66sLRwRcRdQqx	127
8082	2vbRv2ykfJSRUZzU5irn8xAae1ceQJYhNcyqwtJUfysjHZ6zYG9m	127
8083	2vb4FtiFAxP7ZRcqbAFuRscfx6eVHe4vCv7n9ee2YoyQ4Fhzz59z	127
8086	2vb4Xv9TFaku4jQyDUpKGKkbzqHRgAFMU6tQ5vguso7t3DzqXxkC	127
8088	2vaxXL94g7QtKLhR4izcd4SjeCM5uSakPjzZB8ZUBtiW7cBf7EVo	127
8092	2vbtEipz19QpEGUvJEFyKa9e79HJruPTCRekWTpy6DYBXJbMzVQN	127
8096	2vawFR15DFtHsSmWnoWpjFh6tj2X7HG2YjAPnf6js7P6Uf29TG6f	127
8100	2vaj512LKXWMB8ThDFhkMJdud56poJu5TX5wwTijgjc7Ea4mGAAR	127
8103	2vc2aRf6EBUqf78bX47moJvaMaGGh3uxiXBmwsGXCHzPt9ji8SH8	127
8105	2vbBSPxfsTNU5qFKd4nPH96iGCk6gsjYzxByyFpbVaRaZ9n4XeJX	127
8110	2vaf2ayCFfJpmjNovjtezRKCCh3fioGJhM14WsrJZVWPUdEtVTNq	127
8112	2vbwFtVjTuKFjnDY15NFLJBr3JvfAhgZzp1qBGSXhTtki6Sr6Fkk	127
8115	2vbJ4sXfascj5pazMVUiu4TRWYNumu7HBAbigiPnqDinSLsF2NoL	127
8117	2vagFMb4FjdPhFDEjieE579JJhwBYMymxXYkrtmweheoUARmqv46	127
8120	2vbtqaUuMVDs2FFzHwrDYWt3S2EnQgdgSA8ZNMJwWKKJZjt5oRR5	127
8123	2var8gkwVkgcfaviGZBdnd2bzLkgRiT6Rnw5LU4BKhfygxzyiJhx	127
8134	2vbxLAwFNeYXYMPt3yUXH7K3pZK5r897qtM7ivPmzwPDSDbjX2cq	127
8139	2vbWCuBnJwknzJVvpecKRSsZPPmDY4idLWG1Hx2DucHDbMS6oy6F	127
8145	2vawK63iequHMxsCxCP8CwK9KFfR5hCELEWAJa7uSRQSY4h9qZEX	127
8148	2va9M1ah8Dp3aRVWZGTHddec2GErTmaZQN8kUYLgoWm3EgPivXwb	127
8150	2vbvWGuuLodkaGvXvMUHAFFcE5fBNvxTVFzVyHaGe9BJQBBT1vn7	127
8152	2vai6XuVqfKHkyapL1pArUnKLLvHCUgKB8upLKcdPA7KUd2nXHHt	127
8155	2vbctoDFYeMWzZ81UahWZr9feJHoMSUqALJFoSpD9fFJibJ7c4Vj	127
8160	2vbYXqJLYimdbSQzeWouam1Qd53vMGJKoYM2bBYF7FXTCuQymncT	127
8162	2vaGnCP6s1UXJVsE8T9fW6ymZmG2D9bB35b69fAvqRKoUBUaCeUd	127
8173	2vamEYDLTBpBsodrMU9kkd8ehHs87UghT8vSyGGdvLKyXj8hx7pt	127
8175	2vbRhQNsbFZE7uif1YHqCTYzya1RDSxmF2gBwg6P846gqJuQdiSp	127
8178	2vbMwF4BMY89BNJM1hVwudgdEFV4GcCwazrYMW3hFJKD8ic359uL	127
8181	2vbta8ERFVVALGPGft6pa4HAuezQzM7KXZa13v1zje9pxABk6D4r	127
8185	2vaHZKu2YnbopvoyXtpimB9nyyLv3pNDPo9j2gGi9yPNXqE1acy1	127
8190	2vbt7TViU4fA56vDeVPCPomAgGKusRBAXEXDBVxvRsiTTbpoqfRs	127
8193	2vag5MATLDSkgfCKBKuemPV59oWaQCqTKK86S7KHW4PHnVS5em2Z	127
8195	2vaWUQTAWcaxPrJVBHFom9UaFpjpK8d387jN8f83Lfy7TX9VsqYN	127
8198	2vb6L8Rv7ZHDWmnJou8qZie8u8HiiWe9inWmCQcYTQxydwFX9sQc	127
8200	2vb4EB5AYY8gXGSBwgDcy5TmiMCcLCExJ6a51hm59Q1QQrvTBnp8	127
8202	2vbLUZhL7Psjw8pnNdo8U3G9nFxo6P9m4My8oNoCr1QJ4sf82Lf1	127
8205	2vb7ZP1c74JZpaRijNfsmK6XtBJbwr6Nooq7vjEMUfPpFHuPxntB	127
8207	2vaULhFWNJRPd8AK9anwBrmLqeAuMFcrhARa9YeTmKRdAUz2qv6F	127
8211	2vbW9A8fhvpMP2n2Fu7znPg8QySnQW6ExtKa24RLQUnjVaLJWe7u	127
8213	2vbHKSbxqk5JC4F26mJKseaaSiwmcT86NMXiEmSzqgzNd2ebpzXF	127
8216	2vaZ71hspdDXXBvo9LwCFYv1CogcHhEEqba416odWoL5MvgHhqjK	127
8218	2vbSn5dQ2ekcB2xvJsUsptCP7oMqR83HDEzETzMAZk6mLR5nbYzm	127
8220	2vaHcxuRTTaXTc2QY7MoxzWgwBAaJYTcuK64nRM9nYbqvreFuvTQ	127
8223	2vaBDSMFJCLGKsj3RAHN5fckCY1Ps25D7sVqPHCiPSqXWuSm2E1Q	127
8226	2vbwZ8CHtgDVQybZd6UmvXVCc1oAfjKtaetLyRmW5R2Mpfz8tKKr	127
8228	2vbhmk4m95rUAWCqbNKJnZNuqrGS3Q7dcFdyhyUUE4FvkAcKtnFZ	127
8234	2vbZXQMiUSTY63yg8ZXuiN6Vxc5tqmYnRufrhe8dkSUmjUZVQRWf	127
8239	2vb5XhQdZ7Yr5jDpqcmZiCRKLfqaceJkqEumcX2CZXkcEuabQALG	127
8242	2vbRaXmCXVEnWcU6Lq5MXFx6ifcBe3bTXQkmEM5N9bAHWsvf2Ny3	127
8248	2vaa4jXD8jQsAWXtat7a5VXSDKfmQWWLqLAzAXdQfGKsERLrDeq7	127
8250	2vaiBGmvnXg7ANrUs5hcBciD3HoEiZHeP5QH6jnrgmhcEbcnVSBR	127
8253	2vaV2fdgiHHwFRXoXkLhTYQc44RtGfoFzJcjecUwtgQd26f1bgvP	127
8261	2vbyKyq9nr7fNkiyrqTYQoF5StpFcvj1LRChaBDfgiA3n5Cc9aPX	127
8263	2vbQr2XkcPnPRPnBSYRHFv68kxY1E3VA6Ubjj1g7hRofZek3bKnr	127
8270	2vaitNY9S1Twe2BUxmqfE7VXDFtE4PdZ3MWsjDa6MLPt5mY6dNut	127
8273	2vaxm7PCcA1A4esvbsmMVeaGqdUGXnkg58t1wDqqqQaXUsT2pxqC	127
8276	2vbjYcsR2ruu94RewG9VLGCUWkAy6ab7sHfDcg8xLx72aLcHA4Kv	127
8279	2vb6rJiUBG4UsUe4TL3JCd2BmQAoNCHLUHo8E8KWMsMDWt7wsW69	127
8281	2vasExcLNS48nJGXESesxRMqJcVcfqNUP9qrG9gZQkbnmHFJVFD4	127
8292	2vbpEtW5yBbHv2oqqUdx4MicTdVpUXfKR7rDKiDgvYD8TB6F1fpw	127
8294	2vbJgniGpNeFmkCcLGmTBd9kezr3ge2Ewg5pM3pzpozc8z154oHi	127
8297	2vbFbowtkcbA8dTrZpMzHg4autx7AHwjiqx6SPzusYmKtQAze3MZ	127
8299	2vb2Mtusx4ZrXM3nim8r7pm9bBHQXH1KRtwtDax13cX5iZm9s8KJ	127
8302	2vbzkPLANuSeovxfP6Wu2yY2XKENCJXVpjrfLYgQ4jrK1sA88TC5	127
8304	2vbpDzHjkpucQpRsLv84ksUQc8UPJsWuqDe8J6XBZ5vniCjxDa7U	127
8307	2vaRJe3kpSi9NWNTRr96mXQqpojRk9kudz41tEUxx96mdmTL3eJT	127
8312	2vaDevvdGroqgNqWeZDgKH6e4E6VFwdpZRFGCQSPpPYhFBZXdv6c	127
8314	2vafR8BQ3BaK7Roys91RTZ849YziJHzW8Cwgq4UXqQ4HdRNyN4Hn	127
8316	2vacYbofBxSs89Vd3ea5evMpHYzH6A3FNxqXYZ125FkLRYU8Fhki	127
8324	2vbomJtAa1DBNFHUnSbypkmXniZZ48o9wRzqUKhGrxrTBL5vzLct	127
8331	2vbLjLoNj2XUcfTr21EAkvuWVCCVPiRRYnJhCfVEsw2rg2qssvmA	127
8338	2vb9ExLNrKb1YhphPgSS8yriCLKWGXuKPJB8hxk8UeNPVr5TRoaw	127
8345	2vbPG2xHymVpZ8nrKZj3o1j16fJghytxzgHnq2X7qC7hW5UtCUnd	127
8347	2vbBSKJsyuGX69EZfGCduFV4hpg7xex7byDcU16LLMUDzE8YXCu3	127
8355	2vbBApkwMCfTh8arwfMxHmnDVXWSYtkYxZNz5abHFpRCZcdaNQMT	127
8356	2vbm6tdiVhitz7MVmNFd1rWkzRf7yN6PKsmeiJ8ZVBUHEWKNSvtt	127
8364	2vbpLJ91vQuhdsRuNbKoxzsMRjrVAFkBXRcTFF9DJ81oe6LdQ6um	127
8372	2vaj5KqaFnL5qGfWv2VUAhBKtJMwLW1J6sRLU9hMjRW5JbTHdGhA	127
8374	2vbtcRrS5fnAtzUkT6JHLHebX5CwZZErPcYxdkdvFauyR92HwTQB	127
8343	2vaaDatGFWjG2MLDjk8HxYryXQq7VBJcB7xLm2c8xJWDkQaByYob	127
8346	2vavbFomsycG4aR851VvK9bNiG9pr3V8gFxUhxU4Z7QR9Prc7TGT	127
8348	2vbDbX9fx6ENZFhN7gDxUmMHTx2TzhCPs8t5Qx6XYm3PgqBkRwE4	127
8351	2vbZwYCHNJoWm6evw5wpEAavmR29mKGePuaWtcfympnp1ZYKRthD	127
8354	2vadVtpD4NSEsCTaiCC7F1UEP4hX9PFjQVukpPZCBPygGoJtTBAD	127
8359	2vbFVNdQGaQMdYZ8qa29C13CdkBjoTo41uRJeQNFSe2Zy6fQ4R3p	127
8361	2vbweEPfvQXS5n5xb2xUF898rXdvTcJ4mnFpuD5t4ko5ZgCofBzS	127
8365	2vaCA1WsKka4W8fA7rtyDvbRPsnr1a2XfD6dz9NeBCYiZ6kUaM3f	127
8375	2vb92No3HvJ6eyxuqrXQpX7Jta3fHLWcfSuG6AuYBToYdy3n8bmz	127
8386	2vaisJUj5hV6ciNWK28vMJLoeYVKDbLRMLkfMaYKtRnLhaKkBCr2	127
8389	2vaDb7hztLmfbXPCDQUzGPdPNj3veYgJr8sN1AQMMr9uSJ3xnG89	127
8393	2vaj17ZR8qBP6HKhPrDLZ3A6j1rVhG15LRKwEPCBPUgs4fHoMkY5	127
8396	2vbUVB9GUMvn9oD8hCRko2E1NNr4wbvvEmBF2YADREzE4GFhnLvq	127
8376	2vb7yJwjJYQH9kPGRLQAZieU5ZAzQK8cxtSNjWU36oapYTVcCV1u	127
8378	2vbdJAAKcuh7bosm83kCTNCvdirxXeoESDgcHWXxTuqMKPshePv4	127
8381	2vaM2TU1G9N9NgVogizCamVvdXxyycdgGqGoiUZgoM8zvKmc1NvB	127
8388	2vbJ1nLRmXnTfFtsiWzKZStdywAuBmnqntYwQ7S8A7BkRWQGygpR	127
8382	2vanR9T6RcYW4ep13uqEaoqj4Qh2S7EeEC5xQbcTDuRC25bL6Bai	127
8384	2vaHpqDiu17RHMycn1stpxjqbkQ1xWgv5r2SWWDJDCM1y4E5qxy6	127
8390	2vbeDKNCMs6DRnkmRKRLRaMopXagNzo5AesJLHsFmTnP1gtRW76H	127
8391	2vayvz6adzmig21JR8uYvshxpHkfqBXgxPKj1KFxYdCSaGDtfhVc	127
8394	2vbxZsCaZNcdezeFrCaAjgtwbUC36ucVVtiPjdG1R3VKxAawqW4d	127
8397	2vaoxtRrVpFUMnysAkKjoboqj8crcwRxtJcdc6EEqimqtHzviWxE	127
8398	2vb6apobY8KVx1zjMGTgzfk3H6TJSCwAL72RJqmE61Pu4Mrhgade	127
8399	2vaK59344ykdE32aq26LsZe3ta2iivGBn8oxfXiQ4HEsYGLUv1y7	127
8400	2vbnvBizXkSYKm1a8s66rveDUVc3gdegMo8Zt78hU5tPbPhYg2pA	127
8401	2vbtVS2TGJS7dMyAWo5bTV9jHbmZbhMqQmjDmPe9AdFgkaJRYiUE	127
8402	2vb8gT5VsUwGrVb3RdMbcYiZumRRBHZY2hDKyNWMKcfmNXbABgJg	127
8403	2vaJpzUgqXmZnFNQaynbDNNv8BNRLeNWaDTVBo5Th76MJjUiYwfn	127
8404	2vbbiQGqsRfJT4AGPXLbyvMAavDdZcwUni95KqEr3LuayGUdCHCV	127
8405	2vbVPVrJ4SuA1dQKhcgV9x2JbgB7cjcoWfhd8BpRkqjfhhqhrTKy	127
8406	2vafBJVc9prEFHzWQkTieMPHTuA2i9PHQ7D3VUcw27McL9gJQr5G	127
8407	2vbZZ3sboQN8fXu7P6aoy2C4vo1QyQfruMJfgtd6cuJATYW84fUx	127
8408	2vaRLBHuPkvJ4NSnzLwEeNHoBfMwg1AP57KTnuNH2NoC8X2nR3bt	127
8409	2vbNjNfpZKRuzSirnLxLTk21XAKUosNJ6KULRD5UUZUCSrgQJKFn	127
8410	2vbuQmcPFrTjMQS67ZyjyW6sy3vdUfmVayukwkxULvpTyUv5P1za	127
8411	2vbTYtK8XxeLHFW6gwn4XodSVWJxxsv7aY8cui5uKMb5VxTMzFd4	127
8412	2vc3Bw5aqHPkaTWZHDteyGDW2jWmxEQeW1vRsjEnefzXbCBmpkjz	127
8413	2vbhZv7qrgMycq6JWibMF27kdrJajgM2Nz6USVRVa9Jx18FAf5t1	127
8414	2vatVndU6GPeJt6dHTDMG5rugT4haACm1QCjFJD6KwAzT1RpjGmp	127
8415	2vaF8jx5aEsoG5QR3unxCeb25jnGmaTeMFLoYv5Dk8rpGrw1xekk	127
8416	2vb2JXxAdMmV2WvFEtuB488KjHL396r2v4kd7w73WjkUuc6cNTsE	127
8417	2vbQboEYLYUnEwf2xfgCcHrXx8mCR4Xou8NhsBMXDKL58bF9cZsn	127
8418	2vafbeNUqYKCLKadeYom6L998SkQQoNW5nFmrbipNBoA1u93FEMC	127
8419	2vbNd4tKQcb6wdyZ77XCjbey8MZA6GLe4D47emc5pok1Mgf6t5iG	127
8420	2vaP2yYsiyrTZrEJ4AuN9mJcvmNp3Uwbmea2CRifGz5U9pQPHkUJ	127
8421	2vaQBXTWqbRPSs3ZW3nAcPJzvoPULTGRYH1RxKaLdL628be9pnku	127
8422	2vc31ycUrnhg985imwPqq3tzYnoVRVojYjbYuanBJSpFavSwHK5X	127
8423	2vas6dxJ4dK4iMfCvWRuuQJ2nRbk8fEBTcFUufjXmh2fy1tnD7U4	127
8424	2vac6aJ4sUgQpvzcejvo5pUmRLtBtbUav8aqqN5cHofhvL67nRAE	127
8425	2vc594CxTxayfTCDXHaog6n1SnFfp78K6c1D9bfyHhYBGTPwRbbz	127
8426	2vagC32uErKEcZKTqM1EpnVZE4QyctfjEjhME4izRkB8UT3ocqJU	127
8427	2vb9QGC52rW899Tq1GmxMjzw8ALP6dS6Fc6xFqxrtfVYAPwJtcJd	127
8428	2vb1DAaUG73Lv4bKewoQcWuNk8no2ggp5DZChN1Y1TQdM2hUCA7S	127
8429	2vbvULcVPJoFXgzmLmWdrYuohUxAHMUhBUDcBZoqRjy62PpF4PGu	127
8430	2vbukmxXsBMZQ7zQGqkMhErqTLMFq3NZHcmT8xSfwQNodL3iRjPW	127
8431	2vbdXY7LGmXEwDtgSn71WctE1LdMN6pYyyNxasia82E4aYvmwZYf	127
8432	2vc2hjHViJJFUwYEELDptE9iJR5WhNJUeZUMxskCwJHAqvkWBWJi	127
8433	2vbWJK6rfmLgvrKStupAW4eUCUdbmpgJMmgN8vNVcvnwMkJhUqut	127
8434	2vbEkBGJrhChUcdnpHqSdBjbRETyAM8xhaQHRp9iTxDzFd3JgTRD	127
8435	2vaVbTjxxcaZqiQb5Kmh5yQAxQ9fWe1RyDXgZ7Ti6hbUoof9zxHJ	127
8436	2vbsJVzxuUBnSRVWUqbUxSSKrLbThjQcsyhMmrvwZmj6TvGMw3Ke	127
8437	2vb9ubRp5JoMNUE4dDPxFysHQCp5SCJwN18mAVFaQdaLuwxzYZFm	127
8438	2vaZMqD9tzEUVh6K3foDtyyokqQCCw13QyfxLWxAT63SyT1NgQEV	127
8439	2vbAge3meSkPuQbe4Zboc9HTCHgwLaSMaK2JTWRYiJU75vQEfucT	127
8440	2varnQXDqGFQRQ3QMd6GCjNAKRhQXdP8bAN5KgZcZaUdQPVMsEsJ	127
8441	2vc2Wkiwt3WoSLx3UxnJMebDKTB23hdTMQ4zC1mJQEtbJVRLrbm5	127
8442	2vaG5qNkTNiHVY8EQoLPKrxn9DMT1YkTzF2Jur4mvpnee6MfsYQ1	127
8443	2varqTPcXBVMHYcxYUfwmDSam23XweAac743wg58FHXfKrYyCHbt	127
8444	2vbWcHt7MSA4YSUQSotWCcRJA8z5TB1GJDq3F7nE3DYkFDcvAXkg	127
8445	2vaNBGvjon2oN6w6UbMsKqADbLKpmrf6kGYxTQGhfm7uopeCFJsD	127
8446	2vbMmtArrpspAQNZRZWqf6VorUkdaR5yW8jPcw6wfwhTBq1QVrHf	127
8447	2vb1h5Ls28S2QiJGuf8kWkJ8wvHB3xm4nncsNcA7t3j3mnkkp8mJ	127
8448	2vai7YJsKKo52N9yX79i6NPSrwTgPZ9K8P2aQQ7jsv3NF3YRydLL	127
8449	2vc3hBsCsNNxbS2aMzj939YkKBNtsexvujMqxx8VXLXfQZbNBwNA	127
8450	2vbFtRTrmnSqpkSRfrJAJhWm39PVmiGrSPb9sQ7uceBuWJ7GzSYm	127
8451	2vauwgH3SfdSbdeu4zZxdfYqBZHSPsxfpsrNBisvJPFfduN99EHv	127
8452	2vbcgjX1V3gC9G4rH6nTPzwy29pskvvbq4AccJUbBe7Uax1NHHvL	127
8453	2vaouFbXHXCyp4HLUS6HTYRJEv9vz32PeVP2m84MbbFr9Q2YH6Vw	127
8454	2vaLEnYvMLZUGWwAcKpb2B4txuNo46hb4f6sjPoEAcYKALbrNGVw	127
8455	2vaX7sNFh2GQDdj9aTQijgSXtnbJh8kbSRDhPgdw9zqWTtJi4bXE	127
8456	2vagcxEBFYFQeRMycN4tASVbybzyHv6R8HJeDe6oB481fQuceqXZ	127
8457	2vaW2vbes21NeNQEoZJKsZ2mWYUo72AdsReg1jFD2mCeaehyjSFj	127
8458	2vbTXMUZQgVNmJEGrXfTvugJCjbEBdB3cQtNHy1DKdXBpNsBtRjG	127
8459	2vbC3anvAEU9skDj5CdjfJuM9hbbvr7PSpYQXtCWKpnBN2WA8eFx	127
8460	2vbucce38EWsKsBfE2UBvFhZshGn4N9jnaXBq9uLz367AGXEeBvo	127
8461	2vbizkwFk7wbPNmeimXH2RqVPaXzHXGixc9Qh9g2HLDS2VmSQz1x	127
8462	2vbR4mzMfW9hLphDJVwHLMqVKhx8hi1xNgm6WZ6RUGhyrN5h7ESg	127
8463	2vasfCQeAHv6xcBA5t49deLNy1Zd4WHjZp2YnUc2DsccBTmZ1D7Y	127
8464	2vbEmv9Btf8JSBZxPCww9KRgGBSYy1k6jG6e8E6XnN2RmFfv89pW	127
8465	2vaz8ofgFkxc26GBcRBBNBdWBp9ezf9Ltou4rGVFgusiVVoW9aVg	127
8466	2vbkSeAPKCXcQopkRhGyBpSy2jpHtK9fQmspvpi67VzNQTZrHpW6	127
8467	2vbGrorBCGCPotms971qxpJetFdJUYgv9tVzYQNotDGUsZ9sZGFi	127
8468	2vb8aP8Hr5N4a5YGBuEfxYY5EvAHu4Qg9W87cKqhiQwfGZHzYY3q	127
8469	2vbs3zmKfkeU5boSRSZoYWacxJVfzEbXYYknVuDHSXRCxv9CzQ88	127
8470	2vahmuTMuvuUmAJvNFFhNaCi8iyi1d4s6UvZXw6vqT3Z12YgTpjX	127
8471	2vaHWq5z8N3jXMLqUUQGQdd4c8GfZYbSgyNgab3v4wZfgaQqXK6m	127
8472	2vaCdJvu1x2drLSBik2gs3iPRLpXyTfGXaUYCzbA4TzUhw9CJNSs	127
8473	2vaj3BykHA7LrhyrRFmfNv1n4Qwx2pJU1wAjTBy4ENAcGzaiRhWR	127
8474	2vaR5CKfQNo7PucFbw3WMsWZeiDQK8VxoZfHdVsbBdKVzKwTN48e	127
8475	2vbryPDcvyKNjaR9uojgJqoB3UPaNG6mntNoege1oufdA5qoiqK1	127
8476	2vbRK9cwwUr8kJWGPoTVSAG12Jw7wPKT9jKUEvu7QULH4Cxwbe5q	127
8477	2vbr1FX1Y1GswzAUkEx81t2Z2GP88yS6ShF4LhZL8stxaU796u4D	127
8478	2vbcUX4CKwjJW5p3PJpoQjMhkQ7XTH4aiomcV36p3W1GEi4JKgbT	127
8479	2vaNonPEhjucVuUGH1bkU4RqJg6PCtxQ5wbxBzY2NXuTV6Du6z6e	127
8480	2vbynFeqnhBpbKuEtbuV5ZkodjgYXde71nuszykfNp1snZB72Hvk	127
8487	2va9CVtjnULaLB1X5BvAKb3Tz2Tcsc6Cy6yqxKKMTLmxHsBNLv9d	127
8489	2vbXjgbVDYDhhe8BPMXKg5MggMZGK4vz3LWQeVjEFtHKqZxcX3fT	127
8494	2vbTqbrfNS93VBoxf5a2uG5T6AQwHKBdvW4SKHhqK9cHvcsmuhjx	127
8495	2vbJxMfej49J1N4x2co1GzKRSDxxqRwTF6dcX7Y9XBKsdmscTtD2	127
8499	2vaE8jFhrsmVT3oy7kCT6cfPsafsLXKwFN58376twStFF82hHfiW	127
8504	2vbMhjT83JsoKvFwoL27M7vR7Ma5TkH6X9vuwd1KTXjYwJLZd2tK	127
8511	2vaDpnsUSzNZSGsVaSWXN67V23rv3MgGfpT3mHSrbdosYYMT1DPe	127
8519	2vahesxnYTknWtdkqz1w87xtMtQazvoDoLdGJcQjYrmTqieZXfJA	127
8521	2vbzgLZDuGuNbHVcEfiLYmyR8bw21RJjv4P95FyNtKPPWy36ipXB	127
8524	2vabEL3T78yQjeHgtaFYkdw4iBK16Pgk5LjEdoevtixMtiFY7ePX	127
8527	2vaZ4sbRQz7vekyuVqazvDxeZaY1C2szgU2F9bstGQHFyRwtJiJB	127
8531	2vbWjFbUHGn5efcABXtSjuVakPhqzyegjcQyWpUjUjVVNzr5HFcr	127
8534	2vayPLNHVka1M4HtWqEJe7zsGboaYYCw3fzFapXk3ZAijDAhJrEN	127
8537	2vaSixrAUsht9EFHw8SKYmkuSDPTnQfnVxmBgxAEChr53RNZNseU	127
8540	2va9gva7F9bUNXg3ryb1LfcusAjzcWVrGtLF7NFdHRpWahxmxDhR	127
8543	2va9ekUntYu6f59WvzdXZ18w7YM1S45mUN7RzWHnqA2D3zH9Un2N	127
8545	2vbFrnWUaC7qtDEPSuKCbuJZCEm6kYYV3BjhY2cCpJ4iZXNFAurL	127
8551	2vboPwVkYsD2vq1DzKipbbMs6oc7awCyruHiZnpQZfYsaQcyaSZ2	127
8553	2vbf5jq3X8YN6VC5G6q5zUwMjtX8iq1zeAdowWKVrn8FdFAxjXNx	127
8557	2vaBhXYkSFDoeAQqiRSwj51jteBhPcRJUdMKf1gvWw9RApsiymhs	127
8560	2vacneBHcAeuWcPUkocjJRHp4sas34FYH5pu8nsWMtfBY4Ehs8Wi	127
8562	2vaPGsVCJRRnvKXN27HzcaZWCCuLbbs3P1xALwGDZLhfjhG9HzRb	127
8564	2vaokRJLjuzrGDPVpyQTjKwbsPYouyedByTdsem6YV5ZyExgTqkw	127
8566	2vanTynMagNLrDWWmB3vS3Ayd4SSYUNdTef4uJxYyV98oYBrp1EV	127
8571	2vaPzcMJzP1yR1SfhDsLwbadNuCU63sv332xwkFxUGniE8atdGWF	127
8573	2vbzjVD3u84P7jJA7z6s5c8pQjCU34DaEqufyMSWrvsfMDsMwJVS	127
8575	2vbXfWKonfP5URpF71t1zFT3GbYeDoSE2X8iEGu7CWC9E1R5d7Nh	127
8583	2vbVX83mFuFLUneSJKBtnGZaFzW8XaZPyyDWRPhYVMENRYaxs4Pv	127
8589	2vamtzNCgKtBECH1EqAWX1WJarwvWyt9S2DM3DyZxPqaBBDbjvqZ	127
8590	2vbrgLRxcXbA6btMVhL4ofEcGhWiziHGuSZPBn3fXAkhx3W7r7jc	127
8592	2vbzMrdpPFYMZHC7BjEHPa6mJodZ6wRsktoHbHMMUqMJAKt5sDhb	127
8594	2vaztzUfcFopdozuc3za1jstvKsP69EeRse8oXRFVeGjHPuaShhT	127
8596	2vaFTTPWxqUuDfhSrUzCuNeVQVtFX87TVrKiCfF2VEfTR6Y2w8FL	127
8598	2vbyPVSam3VCSNfuritv6PR9cf3yCYRnW6VcWu8QzCy4WniDmdmi	127
8601	2vaMTX54Nah88Xh2apgABSmf3DePtS9FMc6mzzecGZEjA9DEXdCb	127
8603	2vb7nWtjks7FyTspDfL9kgtk6rwHZ3FGfz7AoevCJkpL6QecEGEZ	127
8607	2vc4vgSUCwNmLmdRWMLXNnKxQmWQ4fH3tRJakFGuX39t27TWYvk7	127
8611	2vaT3ymyPsXVzqEFQ6QFrBbu4CrSU2nsyvKDRTRdhuRUKF1i1zyg	127
8613	2vahF9SdSj6EW8UZa7GQjbJ4Q6oYovzBsoAN4gy4i8XNkUmbUzHw	127
8616	2vb49yAY1z14rBAaYoqdM3sdcjZU8SdhicZztFvvrDf5EhPgG3G6	127
8623	2vbtCm9ynUyUFtSX822My5WmDzY8dzRonEJoeonkxMmoq5aCjcX4	127
8626	2vaPYnSc6Jrnb8csZymJ46VqprBbSsKPNyMcTNkS9aSx4V5otUKe	127
8628	2vaJbvYyzYMaepwnx8oj7NnjF7DB12nYfiKLaHt4FAgGV8vLfCWq	127
8638	2vaegMiG6cpZ2Y2KfX9YDMmaj3hF7DyvfzavCVRGQFTBJ71TBuC1	127
8641	2vaAtT6WEmJ7akeaNwr4HwfSbvmLoH4jkWXYNPSLmczC4BFeUr7C	127
8644	2vbfdaQjmkwBjndsLGh5o9hdLmuhh88wvRCQmPe6H79Wqv1pRDbb	127
8646	2vad9DfLkFeFAUQ1aVCHfrvjGTBoi4Zt7d2pVFEECUfgLTL14vSz	127
8651	2vbTj9sFdMgJH61FbqXAyGJoYbLSGjzW8VSbkMdgfs9ethKkgSTu	127
8656	2vbSYHZJZcnxx6s4g2SKKEgm1xjFsWPQr8dQypA4fafFxmfZh9zm	127
8659	2vaSB1NEYzYrGzLmXapFkW9vDWfpH7oVz3hWAzRMYHP7K2ebnCqF	127
8661	2vbqhv9AuunWVELvnhzg9HHFQ92y7endceQr8xMjxSb2yZukqWwV	127
8666	2vbkCCmBAmGudmbwdFS8FmKku8zYiHJJBbrrL23bkEhCzrL6XWGm	127
8669	2vbEBWXoYpoTHkckdP5NdWEKBGmdgsf5sH3hfAaxzA1FG1tdNKj9	127
8671	2vbUv3ez2Xp7xhPxTkgQbkhQ6Foyp7ki6JrMTRGuFEWBU5Fhhnm3	127
8672	2vag1NdeDq8cKYJAXGCCSbd4C3VsppTJMBvYN2FRM1cLTh65P5Zk	127
8674	2vbhm6VGetU4gmk3gH7pQXVnaPTo2UvaJveuBQj8jYx2ZHLpX6Co	127
8677	2vbsrG1VyJiDNRfdii31U2xBKsguEVWdn3CHbXK95PFVh8iKYouL	127
8683	2vbe41oZe7Dv9pw4da9GVN5Gv3gKpQ1rGcAH5A7AziKDUWaM6Epc	127
8688	2vbA3wm47M4L4sf36tpjqqF5F1Tdy7MTs6f6u7f4LyhN15mqh3jP	127
8693	2vaGVS8zEefS4Kzrk4EHinn8WwYbvVLZK5C2rGBQdm2LN8FjKYWa	127
8697	2vb9D6KJWjfAUrfEE5WzxNJwt7vHE6NZ4DJY65nuwGEmtaqLc11W	127
8699	2vaYi2yP7qncvEqTEoRhLju3FNVm6HohxPrhe92MdRG5zgvKhXPR	127
8700	2vabz2bNdR8j4rX9ih9AamcHsPjcGa4a5of4Le32yv4qHi8XBhU9	127
8703	2vbFGbFs4CTYCPavVZLwvfxF8kpAyxvrGKbmtQsX6QDBKRt1y4aQ	127
8705	2vaaC2nQryMQ4RsiDYT2ug2ht2Nk6x6Euig3Dqu6QCzQWoxCaeZE	127
8707	2vbt85E62RJXnGaELhvtcXyBpRJAxvayg289RC6TizfNQdiZ4svF	127
8715	2vbhHL8wUcD6Xh9RogRAqYop45RitStGZh3XXCrXouajLai7r3yu	127
8716	2vakqnVYNCq49tahAibHhkY8YZoDdHZWMWRWvPCbuDDYpbbwNU93	127
8718	2vayMoSeFYomMNSJUjNRRYPzU6dJBcjFbyLWULLnecWTfk6Mg51q	127
8720	2vae4kuG9L3nMKafVmMJHCPFSWTpUZVTBYfdk9wCNXiSE5e1HNQp	127
8722	2vbcGjPhaaohzFATRiqALsjSAALs6FLvYdFogQXPsW8DM5r5FE3B	127
8725	2vc1bf5Y9a7ocLPNKovo5RsDdSiy1U2RHaupMxNKQVsktUP6YuuS	127
8727	2vbxfZyBZ27nqwCNFqBeKwh9YpfnTGbxS1vDEDrH5P9UGtm5qa5M	127
8730	2vbj73FaKavjBAX9kjBRRDKcvXAeW39ZAmmC7yqA6hTKmKnqkVYi	127
8732	2vbiwwTvZoh91ExzYCpsWq5WxkQA82JCrKCKjLYoTRh4pPAHGNsG	127
8737	2vbp82YgxyRPBo1B59GUwxGEqFiCNKNiAQBax28eoYCZF9cQiedN	127
8741	2vaKCeCifRjm7yXGgspCPeugxGe4msnNe1Gx4ZjjY4XcsXG2Va5K	127
8745	2vbAgYk7foFfynPuvJLc3p4JvDeoknTPqbmnBLEPxqXRbkVm4CHh	127
8751	2vaUcqkFRs1owCt6mhmmQuAq7mBaZUjxcnA2aRCTUqDdM3zWJDEf	127
8753	2vbbRwkBp9Cg7USv5dspRHRG1osAy3YYFMMwPEvK7nbu2L4w6Su7	127
8755	2vbxBdyLTjpZeA4zdD68dGD24QT7LSh5kmiTnBS7u1uArioK88ka	127
8758	2vbsav7j5yxVbsyWdHusseKPkeQyxTYDqYQPZFjtaVk6QRUdoZRz	127
8763	2vbxQpGVoomMJQkRcsSFu4djwJHVfXNswDNpCHtGZaNoGr2buexs	127
8765	2vbwLHyyqSGPqGvwgzz9pPz4VmLjkHpaoTQdZAaxNP6Z1mT58HS8	127
8774	2vaKMpYR2Pxg3BhzFtZjYebdwWQfehueisgDE8KFnAbefpAS2DPA	127
8776	2vaDC69CFpuC6ytwz2sVb3qhTH9C8Vcjj3yNKUQMnjVQ4xnGFiCk	127
8779	2vaTHuHmk7pebbW8sQr34Mie9FgkCEgUGpLKqyHPwtwfmwS3DsLy	127
8481	2vbBXJF8QsBdo5DaEGGejLitwSgNf64U6F1b8wxKgxWpBKY8vGSt	127
8486	2vc5RVLAZy5aro8opaVvFwXCWW8GWeDH47WT8Mhv4F6TTBKj6B8g	127
8492	2vamiwC6ZFNViUCKGZNaFsEpR7hafXXSHoR4xVRMnhAkdE3DfVMX	127
8496	2vakfqjEkF1YKJaGoTbfJqFz4Dr1Tx8H8SXXHUHMmpTKk2Cfxhg8	127
8498	2vc5QamvWkGH3Z9a9n3hQGJeCS7fYDZyRypTssPAGENEhQhMWm9G	127
8500	2vaTRhgJDkWF9RSUEvrK1ejpH48jo4KCon8Dx7xnvosvdTq2862M	127
8502	2vbNB8nbACtjvaJSwsR1h5r5bDCv7TQsS8DHwyojhnst85eiFHVX	127
8506	2vbtngAoEFHK3NawQXD4NxrEhxG8BJYDfFLpHdkUkmbDqz94T7kt	127
8510	2vbPxuK4ETgjtmSt78mNqp3LQ2EXKwBmYZSuCksXuA8fTRQhDiig	127
8516	2vboaiRc6w11APudwJ65PudCrs88XCo4W7B2RVVSYSHChor1D5fW	127
8520	2vaWa3kBQtM4KodtQzGJrLHq6iFZnnjYDKwcc3CtgNY7m7GrtuA9	127
8526	2vaZsqNRZPKrEUfkev9f3MGD4R9yktcUUVSjttcFquVvRweqSEdM	127
8530	2vc19drYQ2pY1rKvhqy3TE21KGVEDytWv9aypTVgkDzJWRhAFi2g	127
8541	2vbQdenmSkB746caWz6iJsAiX4wUtUNWzvSVpPrhWpRE73iMufz7	127
8544	2vaZCQ12Mec94LfWS1j5cNtbXGBKeLH4qT4BFgJYLdgWCJs2ZvQX	127
8549	2vbGxVj55ZVC2LMJLgTmEffLXwvWFYCmQpb5p9LPBJnr5ZJLdbb8	127
8561	2vbnx5kHQxCiCZYDnaQf1DFxEt7ZkKSkeJg9Kp1Q9TewTHvGdj9R	127
8563	2vaBJcSgiNXPrgjHa1yrw1koJDzVJEqi26ZGcj7WutRLVrNjWHk5	127
8568	2vatmjo7R72vSKvzAsYL8taFAruS7gtAXq5pZQExXBLnzjfeZwrV	127
8569	2vaKyiascWBDc1n5pkct7q7NYcqNhhvb2kCrCrHPmJBmiHmHyagc	127
8579	2vbWu4ihushSg3zRBgGKijaw5ZgD9hnF9KeESSfDZ4yXFs7Tkfi2	127
8581	2vaB1nYyWup7s4tH13vfq8aW3na81Qha1sr7etc1vyfRofFf4foq	127
8584	2vbNoo9UrsUDfQeBQKeu3BJmkHaCb4NkkBmBDuiEcf4SSdTVkrbs	127
8586	2vaAWRwrn2Gy6BDfDkSqD7mP43p4avcB1J3ihmz8ppjRyLd8V1RK	127
8588	2vaNvVHCvG2wwVe948J3VwXTsPyhHHkFmCF5CTMiv37PRmgtkxCS	127
8593	2vbdGvqNo8cMAgdQvWxcDuzUC2isWTEWjhLppnRwTQrdrd2HB9Y8	127
8602	2vbpfbSGkDxMppuuPuP1CfEznZ5vgDpZzzas9nQEzKYj9cq4Lat4	127
8605	2vbHFKmdPAgELr3zHVhhhNmiWzTxBzjNXhiBiwPH4Npev7Lkw8zW	127
8612	2vbk47PQSbqtFWvU19cbKsjJP2qD4i487XsaQrfPMWswELoXFf5c	127
8615	2vajCcPrJjTDNJmkUqWFFmuBBMZxodQT8wFQMzaeGSYcZjr83PdM	127
8618	2vbvQTxnSFYeNTc52LFjmDQZn4grwXatWEoyVEEqv6KpjM9zVRZ4	127
8622	2vaeV5KrdVrMzqYbpxLV1qmrDAV9Qxb8gXJJjVDQhcrhcmGE9FbX	127
8625	2vb35pdy2261yNqLCCNGhG8FBvhgY9KYwa7hYLCZfnMzu2JhqnbY	127
8627	2vbKUr7uf3fVwWN5zUm7EWa9teuTAtpch5vdBHH8N5WomSQxjQt5	127
8630	2vbTfi2sSCFM8cuej7PNrq3xBvqkvNZrgYg1DSdBUbERX2Sk1LHt	127
8632	2vaGKQU1iSAkMfZhwVAi6B7QJEsvWPdeTKoUovUQL2YnXXE57iWr	127
8634	2vbjQstgiJjZdjt1qoTiAm9inahj4w5QTtXnsbPR8oQkwXVUxmRs	127
8637	2vbdFYfq5RSD974xWTJ3zXzH9xWKNsFW2RkfqZixW3ddJ2Hjr2va	127
8642	2vbAobZPh1f41aWgYGyB975bQDGEtgHUYdMFcfXJGnjkFaBhhy1x	127
8648	2vbSEt2a75BNNupyLj8dU8kTCrcsSLZLE5gS35HPc4VPr27Y571k	127
8650	2vaPiC5y7P4q4UkzYAsZNRy1iGHtqL2nHByqpKdUS1Sm3EAdUqA6	127
8653	2vbS5qCCCPUh7yZDKhkRY4PHmT8zUTdjLP6ZuuTxGYaACBm86i62	127
8660	2vbG2nuR1RuSEWozNw5yXXiz4LtYwL3rmbjj6Uhae4bSEPWxy69j	127
8665	2vbM136CZKgT2G2c5ZHo1pBT7S863fBWSyacpXJGbHNE4qRtR5G9	127
8667	2vbrNiufYsSk6kSpWQ3fiyfANUSp7QWvbxAEhMfgYrPREkwRXbMu	127
8676	2vbGqFBqsQf1bpkcism3aEDB4dXvWZEeDLb8wYdWQgf3CBw71hiT	127
8679	2vawzAHHLzDMFVKWJ63XP2UXyeJkF1Y6KCEQLdXbBDHVpo8AiyZJ	127
8681	2vbMt9feJVDxA6kU6X5RZFUfVPgGza7v3tqNgj77opF4Z6ur622N	127
8684	2vaE8bv6hyv1KqwcRphiXxzrrsaLuzgQCSsX5YteCk4RQ2aLLSdD	127
8691	2vb1fEeUs9AEM5nERo9z7rL8GvVP3qEq8SHMx3kbREQukYcdsEhd	127
8695	2vajZ1ARv8axtaopibwp8M4CvmZHBZdabfS5UxnSMa3x112wEhmP	127
8702	2vbpCxYXQitjMpkjRdRNXXpgpLZGevwccpv3Kr2NDWk6i8NVSeKh	127
8708	2vaVu4fqMKnav6cxh8Z493x3a1TRg93F4T4tDHRDQ2ZnWGWD3x2F	127
8711	2vayRAwHs3zP8C5quhGx1fb1s9EQdQqa8Uz9xWk44Ru3MSdK9PBN	127
8713	2vbb969HSptRTmyw67GTuEcpxchtKskeGkXAygCUrQ3kLQ2JLd6a	127
8717	2vaAeA5T9cguSXHrdHPcEt6jEZZD5EEF7S484VJM67aVndvoiiFt	127
8724	2vaFGXr7dkWPhSESUbyEHZgn9Pt9sTbj2MZHH1DYVnM5ccKkT9ww	127
8726	2vasKzZEnqAf8eViLtbNQJADf4i2ZR5MWXRDPUcyoqX5HWfyeF5s	127
8728	2vaVzgbjscxnRij7U8CmQnY1ycpnxkEmwXFZXR4MzLF8MTgTE3k3	127
8731	2vb3KCfWkYFABmAwfbsdE311NKWMPH3Mxti2JZ6HqaccHPjJrKch	127
8734	2vaeoN8iH7LAw4Mqr9vrEaNJg6eRdrueb8nLKGLAtWsmFEU2tunQ	127
8743	2vazMuYAaQhanFXF9YuRmtH6hqt3GZvYZ5kRtLNtfVSP1m1sj7SM	127
8749	2vbbw8s2UYjgYRDt96nFemCaJs6p8v4suLYtSPTLyWVPEUqJHB9y	127
8752	2vatak1pXH7iqXmxhpooEdww4pLroFscvuQjTQPGxrUCXVREoES6	127
8757	2vb5wevWvb9YkqbEYSmgnse9ibCjgGq8EZiXBHCkky3opr3qZjvM	127
8760	2vbeQbdh9TQ4xq2tjNjAd2qzBcsnJ8NXEeLiPcDFBQQCQmfFgq7y	127
8762	2vc3Px8xKKcSzuXmFhKNhF5rtguyXYLizcXE5JxESn3JSiUN9U9N	127
8764	2vbb2cizbb4j13cRfCxmn89MxVjXY5GwZJBcKyFQS3riUet4nRVg	127
8767	2vaRxKZF6nVcZpLD6Mp4wsfd6vhWu3ZzNUd51sM3yXnqzRWVb1ys	127
8771	2vaAKX6Y468pNu5p9Rwq8Gc1WETUhYNHDEam6EKtbWZW1DETWSvd	127
8773	2vb5cB29R1eVrFJCXwGRhpoKnPNaWX5J1oAjyPMNRMMxaciG8nmo	127
8775	2vbWtdWUiZZqjvQEUvNxmMT3K2KKurtBCVNicqkQzCirno6wsXPc	127
8777	2vaabULimosZd28F9E1bCN7GmFFeeyZLnT14daAXicFA2BvtbAVp	127
8780	2vbNPLpA7jptSFpEMWUKAoQrToP2j7ciHHC3iLAfCqzqyQFCSgxW	127
8783	2vby65w1Hs742f9CNyTjzqbnTg49bbXRraocULSBXtH4FM5QC1UJ	127
8788	2vbVddZBNGksq7xVzPoc3vE6aJKBG9CAK45DfTRQBxXE1YhwSxUp	127
8793	2vanNMJTGU6fefLB1yUvTQNiJfhJJhC9Km7y5of98f51Jqsko3oQ	127
8796	2vaUq8LjNDnwqtym5QNwLbTSoF3yPHJWvqgeWjEBsJBkG8Zh7JYj	127
8800	2vavTV3uxGobsttXDbz5DZuSzuXp4n4LtmgPSzjR7qiLzVYXraqU	127
8807	2vaLhv6phzjEcoTVBJ8Ncw57hEtb1vhALgcNbWPydK5MCEPdJ3Ks	127
8811	2vbMM7Wt2krNqEEqQ5UvnBmiMKkpdkvVHRMFPNRXRi96FGchexC6	127
8813	2vbVgrJzRPx11Yrkv63Ndo6R7MLcnEHpd4LvhL9nTWuaLARB518w	127
8815	2vbjoQrE5ExukgPS6A4TCX8sf95YcfB56937MaRwBr9pExJZJhPM	127
8819	2vbm7cuCxAh4EHmkSaCRJ32xy3bcL3G7npAXz18iAjq97cuKJ2B6	127
8820	2vbY43iaF9HUZDCs9i624rVNC3JD82h3qLgVD8AUJYz7vK8iAh8A	127
8833	2vc5AMKas3mxJhtFo1HEuQoWyyKivjmBmFKs4YGY7Mw4yUpsBGfz	127
8838	2vbvcdw5obfd9o47ztvzhJsY2Y99Fp3nU4s4sSa7poht12kduKR4	127
8841	2vc58qVbiDX73CQo7hnpRKFkPyJ5NDqm7mBUBFHg8fAn9qALNLhH	127
8482	2vafkUJT9MtJzAsPTyzkDdC2znWSt38WS1Kf6mBR1iTSfSTX7noA	127
8484	2vaJqez6fvwprvAu2NctHmX5jqxvgQRiekRPcMXiTPGJ8B44GZfX	127
8490	2vaugZdeN4mNCBvScDXLBWF2jp4bUMmHi4HrSkEDXMcBJjmmpv8Q	127
8493	2vbZo71vgDVdV4CjbqWHvznndiaJKPt4563574UvxxeuC6uPExD9	127
8503	2vb5LrqPTNNa1ML2htK4KVpjXQDmrbVSqYcfwBidWQFkuPKRrM48	127
8507	2vb9PGDmjnuqjbwaUv8jAXn7t6DdPH7VZkygNMqqfNTgo63S8Uj7	127
8513	2vbMrNy6c85QEUhaE58PABA2WZEmiWVpmz7y4wYBdeCnKiqPtiG8	127
8517	2vbVNQRJH7nNeXuKVoWpyhJfygBoRipMF5iTSu4TTKiQuc1iV9cL	127
8518	2vbdxFUz3iSTsZqEGoaoUHdXVKdC8RENGKoHY6CZZrt9YoSvvTex	127
8523	2vbxKynnGpM6DSKbnRoVfa9ziqT8oACLFG23ffGZ7R4R6WYho5xm	127
8528	2vaFThdLC6nyrSDqe1kp5LzUzAuQ9zgEEtZ5yLocCP7ehKLSJbHw	127
8533	2vaw5r32khacBNn4goAARcDyR5127E13DNDJVQALK7932T5vVYr6	127
8536	2vboXjWvwLeN7epkPV5buuSCLujN6mnavQay34rkDW5RXN2WUqRP	127
8539	2vakXp7w1UyXd2r6ebWzJRfkyJpKdaQt9GNKS6XqeSAVXhgB8NUU	127
8542	2vbJ3Vi1rYzvUgwiJKpe9jGiphp9FLxF2y3Mz6Qznd9SZTy1v6c7	127
8547	2varVwts3HR4vp48jdEbXexeghAJEuzxssFYoA8Nx1EvANufqnF4	127
8550	2vaAvrKSKEjMZxqghwczZoRJrvRkqUzLRmAXM2ckM8tQQ6rp8tte	127
8552	2vbwPowAKs7kdWeUhE7wztQeyWW7Xuc3WeahFcxgHqTD7f1bJDia	127
8555	2vbbLa8BZFmWSdnXPHAmGbLQavVk9M42caXketiKKqVaNjHuiice	127
8556	2vaG4nnhVassdatjo2brZnqkfaoy45Qi88KkK1kSqwzfm6xUYPTB	127
8559	2vbqhP7DbGrE616c5PURm69dr4UzFT7XzQsoLRqnDFcDCKaj2Dkq	127
8565	2vaFy2T11Nx1zvt6ndhvA7gJ1VDz68AxCUgzvzTbUGCpsG4xSfjg	127
8570	2vbVscysPrHGXTrRSuEvZ6ipVqvLuqFWcEgqQ4ASfAkZ1N3KVQvG	127
8572	2vbweQeBrxLeGTya8Hg1VUFFVfr7fzHqFLrxKsZeLPgFao3ugYdR	127
8574	2vbZUNjc74PBjreEnyi3zu31DuDrVEe9MD484281Do2X5ZMLvbby	127
8577	2vaQMhZ6wYf4g7WKWWawvJaXvvVfPnkajcbepAMuL6FLe6hHZFBX	127
8580	2vc1kMUbjzSThHpcc2zrYML4eKYuBuJnjw9o8YGqsvv7DdHjhzhE	127
8582	2vbQgRZkhTEWLq5QFH8CJSuNXffDBktHrorK9xyiH3jCpafDM2Ga	127
8595	2vbt2U5PVjaN8tJCnGVMqGi1PNw3hcUgWnCWmLzQjHwNqaqasthQ	127
8600	2vbXfbWymkXnPnD3CL3KjtkTGoA581rL8NXLqRS75RTeapKuKmXD	127
8606	2vbhr26AbErtdUSN3AmTU1mEr2NF92g1Vb3ybgYY5dK3MtrJFwZA	127
8609	2vbw21DQbWEXoP3uzq9SoAubLL9Fm3pBL4qYzjtZpRFkpNfvnnes	127
8610	2vauXTPGMRgK3cfmDSAekV3SjYHxBtRpc4eazDbxapGkU9z9NWrP	127
8620	2vb2tgcmuB9UtzzS3a5b9G98t2CybhYMGoukc2UizQF633iZzpeC	127
8633	2vaEnK3sYKuWg3QFGmdDgK1QmEGrx5KxsUay1aQLQS9wQeUErLiq	127
8635	2vaJA9A1FvjrNT6oUmBASaNHWbTKtWHg2rmbzRaZQCaTaw5JrJZv	127
8640	2vbwVJA7JBHifayrttYGyctdCuWCtRnB2YGkESEUdHxbXXr9MtB4	127
8643	2vaKELZVtCUyKbZSLpMufjpcUYVZjE3yrPiqGpLY2T3gG3zoSneg	127
8654	2vabXDMbt3eCoLvSUm6PxUGKSMxH9356pv9q874uQFauLss6XL2J	127
8655	2vbuUqUAuNVy6FcZLDC2ZnBqv24dNit6rzmb61dXuZy9MoTdGo9Z	127
8658	2vb9UbY1R9XLx36Q4VWZcDwzFA94kFVxyyENp5B3Q1GbXnsurRNC	127
8663	2vaSCMsmqC1bwwTN1MHMjSptAcPdqtyYQ2QUEsBfHJkXHLB8mUYz	127
8668	2vaKvPkXy4NoL6QmQc9dVDZ93J3SzohYvvsoT1Z9X9Pr4dTQG6bD	127
8682	2vbHwdQcXiU9yfq8hb3qGc1riTMgxrxMtNXGwfs1RT9kz5Juue5d	127
8685	2vbuuPrY9HMSoqqnn5sAJYSS7etXWwFirLVTakw167TZoHCaxQeo	127
8687	2varWYudUzxXQdS12rmWPPeKv1XaWcewHG8TLhnfKLbirsN9PL1n	127
8690	2vbUH9ppnQFCWXmBc4HmgP4yCPTFH6ndZ1ucAGth6T85JVxU3seU	127
8692	2vapg57e7P6iNiHxYemi3h885nUMpkxiVgheCgMKzXnC3jtnwnf9	127
8696	2vb1wExjE9tVCVn8PrYmoX48fPCY9JDPoQSzw8wRyeXm6ksiAUAG	127
8698	2vbXdVv1rUSUJ8tzB5oZ5DsAgAityAW6p8RfNQaKYWESfNVFpvAo	127
8704	2vaV7sNzkkjReSiHaT47eSQiZJeXUZc2Atsgk55sCzLGF3CUNNR5	127
8709	2vbw9axefTDLnBLgAaBNTtk5ywLhyPyzRDaUYPC9MA73ziFfyFHw	127
8712	2vaJgurSdJE4ZpqjXNT36iNgLjiE85YHJiBLoDkdCZjAyj9aTRRb	127
8714	2vac9wrFvU5pnybs6tj6GXowMnN27Z8XShyVL5jrQjnDWb8rdNjs	127
8719	2vaJG3eAjT5ntuof7g1F6cn7abbZR7nnXya9dbErs9Ge7udnoXJx	127
8729	2vaUmC7dMhNPXiDeWH8LxikBVArMV6AfsF2Ee7nNTQsDHTmFHHsh	127
8735	2varzdidGZA5HuLmntWKfmfJ2j19arBetdqTamn3qavZLAGjYKwJ	127
8736	2vavphFfrPFK6vLnZthVm9scFKj3raiJ3k9zep5VFKbPbPpY1Qyw	127
8740	2vbfFd15fJBZ32JmA6zhtw5GKQZn6a9bsC9mmXUhUZ36ZhZuSVth	127
8744	2vb4w5ZZ6hM6WFP44vXCar1ukCZmJDRZuayWQGznYTgrxSUtZmmx	127
8747	2vb8Ptw3F2rGcRtoTnHBXn7RW7pCUsmeazATzfA9sLo9uRCVAr6x	127
8750	2vbazevBNg6kYA23sWmKMRasgwCMuzQmtsDZBtgmjJ3miYURSUwo	127
8769	2vaFJPKnyXg53YBQ5GKNTbeVUuZQ7ByH5aKdvLSPR9mzrdiPjrgP	127
8778	2vbfPKPHVBA5R9qd4xeKAQgJoTk7TXF5EEqSm1o9EEE55zhVMN9G	127
8781	2vbpBzHnRHJvRkpH9gQpGYHfL2nDkXUYhLJosZv9pGe2EU53cHCU	127
8786	2vb4Xwb5gZZJ5JazzUwPbRsavMJNNij5Ca9qKJf8hBditWjWaFDW	127
8791	2vbvWBgV1GKKZuzoY7GvGGCzp2AUXZdUtDsEwx4gw933yDRuFBGD	127
8798	2vbXKo5xsVFvx8tNnkuLC1JMM47NYEufTguwmmjbuWJHAcfG7CxG	127
8805	2vanKMAeoETDY5tGXeT6rQmyxeRRsb1hXtvqmzav8V7wecnax8e6	127
8808	2vbz82HWqVKUhcP6Ysr4jcUbJHJLoq4sJ997RntDDkzcGzTt4gFM	127
8809	2vbQea8FbjBvtidUkPvxMTpJp6biQoFtxNPtq2526sAfhPKkx6uy	127
8816	2vbDLykpT84BoNADqkcvHKkyspH3odo8zQGL2ZUjcqcYvqH15m7M	127
8821	2vbScG9i7SAXNvyEdSkAqR45gmrnFhYRXTs9t83PZcg8ThqaQ21M	127
8823	2va9N3pz1Si7MrGGydwkpJcNKnSKfP6s1ozKA26H7gWGw1NbAfxS	127
8829	2vaRvu2nSXpsNeMWk8uGYi9HaD3ddxvgefFofRzXTbY3EKYdDRkr	127
8832	2vaQLGmrgNdkHjuJbwLjfhcVj1PtFHKoqDh7z1Y2kC5gP8ywS5k9	127
8837	2vaHCXsGRFJjYBWsGR3NRp9bYUNSNtok6PMp25kHnNbNQhnrr5An	127
8840	2vbA6nfbfYcGvn6ay6bi4gjiemkdvJLRKyEL9ra6CBRBBWbV2S1h	127
8842	2vbj4aAhkRE45Yx1MpJ7ZuMQayRKSJPP6FhzDm26WGQeUm6onrep	127
8845	2vaXm82fKjJCM8FSvVxCv9WLqR5No2eHrYV9N782V9nNYuA4hDbd	127
8847	2vc4LGPmHakjzwsfgYwAseRgsRQtiooJj5wPwzbx8uAoge9Sy7DU	127
8852	2vbsp6y3S1LHSMtNAaRjSST2xMp42Ujp1J5kJHWX7uq2F8KHYoeo	127
8855	2vbPc5GM2jJr4EwfLx7ALboWisYUxorXK6LSedAY8ee5SvG6qNKn	127
8856	2vafGa1ZaeS2iAbEgFpm46nmdKh9qJS8a75Q25aJ41xqXsCDB9aT	127
8874	2vaVzeXjKESRPMKodRS5Dv2AbPL2f6sMMfEy2et8LMPM5Y1eoTZQ	127
8881	2vavipUQdyqaMTodFGThJyqKinNgZQEGrjStdPnYp4V21c9uBh2k	127
8887	2vaiDa9sNvR3g216bTWWYZY3WUV5ngTKabaiLmVj1SYZEfZwaxgf	127
8894	2vbbD9VhBex5CKWVcffRotSGNGBSEgj7BXnDVd2kgG46dB5vdmMB	127
8483	2vbD5YZtfDNva7fS2bMUMMS8hVxhBgJduHemJyfecwTV44cCHVbB	127
8485	2vaSKTnJvG67PyENNrM6Xiw82h96bM6cfSvefZGQW5sAXZDjSkPg	127
8488	2vbHnYRqszoen1xV1zVmmt9DYS8VmqPf2jVQuBWDGb6xWUjTEPCi	127
8491	2vaZDupapMSJdWic3f3e398L1QjLUiR9DCz1MjTCEg1X6H3qcTMi	127
8497	2vanCHskDzvqSCC4o8nGeVyP8BHJUaGkHvzs82q6YpcoAapFbRCq	127
8501	2vbhDCkGFohUjifRFhuJt7SVDGi4icBna1gBbCNgn8qw5XeNznRJ	127
8505	2vbt8sFRwbfqt5x9WVeeS1jFfHz5TFHwkguDuSMJbXg9Sf5gvhQb	127
8508	2vbkKVipazmb5qHUtRqv5uCDqPMBz58RbjTyVtWUy2qXv4gPKeQY	127
8509	2vbBZ3SJcAVxCFZWMHPUY9VG5bDSRTRuUoS7V4YnYTfKgeHXo1Ln	127
8512	2vbR3L2d2tkDaxvGDx6tF9vWcRFmegwgMtj1sXYcPPBc7rYsrVD1	127
8514	2vagKZ8uWHJobKkJJVEfTtELBZzksVNbRG1JomodsyPvbuVWYTJQ	127
8515	2vb8NguGkoCjyAVr9KgnbqBFjMATPzFV1kDtqbkRHkadGFLrMUMw	127
8522	2vb4UB3mRUzH8safk6vDPiwDLGivi3YykGxDUkLtn5tEQ6FHvSSs	127
8525	2vaiU1jjYysadr7jDbjwPWfsAWAhbpsGihGEa6Nd3jXBHJTznSoq	127
8529	2vbkpqrQZv1BdF5udpnePAhHYDJxfq2NWAKE3WoddoJQexKnvuUc	127
8532	2vaHLpxkr4ZXQPabdiwJwvYMED5QHFPKNZBmxDvkYM9ds9g5kJm5	127
8535	2vbdmfT1fBvtXyQQaWUQWGjEwkvnLDXzkySgytSmukeyS58iSJop	127
8538	2vaHVxv3469hAdNf258gHooNDNjWSeSkQC7SUgfTWp3dhYKMvmba	127
8546	2vaR83nGcHxnyTynvzYmraBQK1k2WTJ9eDwGniuR6952crZQptx4	127
8548	2vaPfjv3cpEswM1qNTW8C9EPC3oscs3EnpYZ8JKLEG5TZG8rA27N	127
8554	2vaMtAzK6NYatk2qcHhaFAX7WCnYR6BEoy51tdg3xhDSoeoP8xtV	127
8558	2vbeKnQGQsnCzp48JzW9fDA3J4NGKkkwdEPjd5dTpWo6L5CqNXfT	127
8567	2vbAQPZzrJFa23e64m1WrHjaEjvYbB2B4Q4wHhYYvgp7eCjHkwAN	127
8576	2vbndgHiGDcTYkm129mqfGMJxNUSisZq4ZudTKr6VM6CSLo5r29L	127
8578	2vbnLkPTVHguEqLTCQFmhoTGGJHp3gtMrfHLqcuKYMqZCTWbirM2	127
8585	2vbTjXUo1V39NkK4i9mZVguAE4GSx8cZQ6gjfwZkthsSrJsrUeJP	127
8587	2vb9jXcmcyz2UaGBHPCBaHgzQBQdiS9kTMinybrqqSLZumAYZsyU	127
8591	2vc3E7qxtRB44uPhGzE9nDBTqsi2MrLMb2secZKso6S5tFE8wifE	127
8597	2vah3jcVjyKnjXHndfCEF7VFhrqt4nM9E3WBDzk9w87AeE49SF6c	127
8599	2vaW5128voD1CfHCPFgu2xkbTLeSP3o9YEM8M9qrXoGVvKeGJv5D	127
8604	2vbWztskSLWeNYUgvGy7G6bF12Ny7i4oP2q2CNYvdcG3SqEnRkXM	127
8608	2vbjohwnrV6HkvMoTYoSL2HdxuFhy6wqQYhZ4SHoQzA9MeAuRQqu	127
8614	2vaZ1YPFAWFLxfTBLTweHtWcY8RyVSVsshWsBn7Cdvdu1Q5Apu7U	127
8617	2vazgy5iEsjYQzmh1CSfXDtBEBBhBADqzKX5W1Dy29KR5vkbHBdH	127
8619	2vbSdMpVwyAVxbTW669THnRwcULgJZHJsUWyYpcSmwcDLdEbg9bJ	127
8621	2vb3J79MaifAaTHzbjVSikw3oRYv3bw3y66RsJjJ33c3UKVjKUNd	127
8624	2vbxRdSXCn9mSVauwwcK21bqpgZSvVqmHx1A2pWhfEso79z77FQq	127
8629	2vapijDnGtxkf2GkUi1JzMZQDmq5fMHERzrxGuY4QgDsHf7aFgc9	127
8631	2vbcwDDwK4gpx2JbQ3MYFxXwXAX6FMhc9DnqDHTsG2jqpsH7KJ1Y	127
8636	2vaUXPVdjHkik8LPn7A4P4hyKuG5rgcfNfPc7419oGWhotX82rej	127
8639	2vakUo2iKq6Ps4QpF9gqSosjQSQ9WdTDrX85HDUdkrEQ4unaF97s	127
8645	2vbbzVXQXWCtm9dfQ5aYiKqyeHmWokKw3wxG7U16zbF4t8omzYvV	127
8647	2vapLVhU7rHws6hsiDjjJmFtVJggFdYq8gRh8inWVUntrYDWm8bu	127
8649	2vbPt2P3bdERAA9sNk2XetUTwoLYjKRCzQNNE8KZwwrKuwxW7Exv	127
8652	2vbqyBS4yTW9NfXrJY3pEV37YxxC6TRxDW82N3Rbz6us9LLeJJa7	127
8657	2vazL6s4atCzENiLkfmw8N8Tyfpv7PsnXN9T1FWsdExxZm6Z9UtX	127
8662	2vakt4xfhNxmJ9jor6BbRXAwmXkFAtoviiLDFPSu9RSx9Q3e2Khi	127
8664	2vadkMavH8Xx7ukpZH9yxHkjoCatjQMdYTBR8Coao5g3s5RPt5JK	127
8670	2vbQkHLe6ye1KSmnUTJrmfAJ2uG929Ao1aN9XtC5sAjNje7F4Nqh	127
8673	2vbstKjPbiH3jZhMLk5aVrCJcH1CfzQ89hECej8WiyANuPZ2k4ha	127
8675	2vc3KXPcU9oJAvGqkRcJQYNxSEJ7oNjqMzzeKr1QzyjUiGu63Kqr	127
8678	2vbyNBQqaF2MXxLkzwZAa4zHoaDSvdkDDVepC3k9DCMY5nvCKEhk	127
8680	2va9khp3Gjp5ykH3z8xkvEuqdhAyzi4tsZpd4yhRH1LHKfE1sYK8	127
8686	2vbYemsYT6ZMcDiRybBhDSsacxBZD1p3xYoL97BfW71hAckuZqoV	127
8689	2vaUq1zHa9ftjKYF6SJf3HMpVmAFm1rjTeevqB2MZoZyGLBs2u8E	127
8694	2vbxLrcTwFnHLrSC7vzngFqbVcqgwW6bEMGoXyyRWVFq4kw9L5oN	127
8701	2vbFYTJVNRTZongNv2fJ5CFJPLU3tfdToxMoCm4Q7rrX8f5gzUx6	127
8706	2vc1ePyPrV9XhoT2UU9ZNb9gNhnpL22z4baw21NXH2QXE9G5zhqV	127
8710	2vaDij3TRrvrCRrTAbsDoy8ppTMgrhJ12rCNrcxuTuozfrKK7bAU	127
8721	2vbPxq28vMQENFaZPvCnS5tFVFcYMYgoByx866pQ7Yfy7wqdDw8b	127
8723	2vb3bgpys7HSMWpQUixaL9jbDwJSYt3e1VzGjs7uzp64hSy3SFTe	127
8733	2vakA1QSDoNU2GZBEV6CqZLiYynjqfk3pZzwELyQrWFdBeR5i6kh	127
8738	2vag4UrebUGeNVsrb8V6wGABb5NzFtc2dJiEDBXeKH7JjukSAHgJ	127
8739	2vad4eGyU1erQ5dRTvRVgHn72gcbFiJ5M4mSGov7tQ6R7JqZXko3	127
8742	2vbcQ1BbymLJdBp9dajEzK9iRhKfgssjCEC6CmCLuuQj6QpP9wBc	127
8746	2vaooBkpcwUpPV1qm6HF38hV6Qo2hVE92zNs2wuZij9bgTBaFiHg	127
8748	2vbfPfCiAHgwzxzd84suzdYMLWmNKQbyo41BWsKj1jR7HMPy48F3	127
8754	2vbFgjnsBiYzQ1NJVNUGriX9uqFieF4XddaKqgNBbwPEoFf7pHCm	127
8756	2vbHuzQ8DgDPpPTgKkU3BqihyeTe19LrhCFr6yLZCTGEhSTUhVgH	127
8759	2vbAspa1iVEGMdtDPYmXgAb7Xmh6E1xb3ZfMSuHjbk6Uzoj9E1jo	127
8761	2vahgbM7FyuHuSZj7Qh61XVUiCZMyhezY755rR8GaK8Q3aww48sJ	127
8766	2vadNDP73zST1feWd3cLruW5FEEpW1kXmFwcc6oLwXwuLaqT9TGe	127
8768	2vapuofFa3LgYkUHL6vg7UfTsBxg8nAMZUqVqMbJ1bU29dQtWSUN	127
8770	2vaxA2NwZMsY3puMjQzTyvn52dihbFeSLBhRWp3oy2vne7nbbECn	127
8772	2vbiX1yiPJXqkvYUzgbXT9kJvF4m6Hr5WEP7B9JjEpFHhsoCqJAy	127
8782	2vb93foS9GjRQyTEUiF64agkncLKWkJgoUQgtSgn4a4dMFpFBMRt	127
8785	2vadmAWBL9E7e5HwvjxrwmuuCBT1T5EkyhKFg7HRTqVhEXWWAfWA	127
8790	2vaBXcHn9jHYL4yncr6MrRXkqt38ZXTeTETwpqJA65Rzcx2hrz2r	127
8795	2vbDyyJ9orZHBG7Riy9qUpexhtgff8hrVot1E156JdsKAgc8RqnH	127
8802	2vbCd7CgJXRN3eLfRq6cWUgQtBJ9DkEUEPBQscyXQGGjq6ZTe8RZ	127
8804	2vayZm9VAv84hmwa2DkKE69ZX4LL8dMwF67kqdMa9qL1s9duobXR	127
8810	2vaKKJbAHyQA6QBHVTFuKmHEaQ2ueL4ZDQg5gXH1NwYxQiqXajJo	127
8812	2vaA6NAhu5cc8uwNmT5ADiCD7kRPTFqnmHTBWEKfytamWJ42Smv9	127
8824	2vaEs4LXNJ1teaGuCWP2Ewsqoyp2J2DthWyTPvVndhzxZKByA7NV	127
8826	2vauqwRLSW7LGBKvB4GzZugw4Sij46yrQvCw1CVqfU3xSXmTmZD2	127
8830	2vagoZ2jRMk7rFc5Y6BK1VWCG7HStyyATwTpccMbt5HTXTL2Y9Ja	127
8835	2vaTeck5icHV3Hd2gPEnvkX8R3npegcjCx3pDToiyfgpnnund78j	127
8839	2vbY52edkNMWqsaFvdZGpqCYsYv8Zt4SiARmcTzx7au4c9UzpDsU	127
8784	2vacCG7YGBHbai5CsVypF9EZkBDbnf1eKLkQtxFeThw8tJRnLoVW	127
8787	2vaoPeLS1Fq1HrT4zT3nh2koHuss5oqSWhddFyxVPmfjSc4eouQr	127
8789	2vbU6apG84S7VxfdP7ydj2AAfQh3kKDYzF3Bk5mL8PNbe1AqFnTU	127
8792	2vaEKy58RXMMPvQzoi9AMt35iZiNCDg1Xe5QFUx2gnMrNQYFXJ5S	127
8794	2vbvvRP9ADcgAV74HW3B2SZKhgkh4zWJhGfYobLC6tpTt8S4Rgmr	127
8797	2vakVUboDCe9KosYPi8fnNL3A4JBg8ZuSdiPNKe9WBBn1xECFGiQ	127
8799	2vbS9Zcb1QL24Yx6W8YT3Hg5YDL1VoRmx6n43sV1ygMg2MgKZu6r	127
8801	2vabm7K3QMCiw3LxtCZQqwMcZpvJGjSQdQCDcQmSfXsQWVYzWc74	127
8803	2vbUNzx86awtX2SCZdQfxWKwzmamYnaTKZtokexSUafiQ5E62FLG	127
8806	2vatfzGif4VWoXLbjKeX9UMJU75mXJTsS2LTfsdxRzudUUTv2dQU	127
8814	2vaguWpbwhXYEiNRRWqMNSsGWEobKkjxXGqStyCAHQ5meU4b8eXZ	127
8817	2vbfPgKgix5GvhkXLRPMToQruKamsXQopMyMModte5fMvTtR7pub	127
8818	2vaWMHCs1muSoMCMoaV5kk46Z6tc4JsENwoY3iEbEaWhntHrtkJf	127
8822	2vbnqnepfBUGrBnvAe16KoDXQFHRbTGi8K89EUfCQCUjNyq5XEWV	127
8825	2vbAugH85axDf8LDcYoXZJgV5yoFQpkiDZpk3gDgD1JKkfM26v52	127
8827	2varH9naXHUcK5XZAMUCrjV6YYgEWAzn4q48eXam2zdNbExd6NmX	127
8828	2vbpLpBbbFA2fsJE7rDkE1jYRBVDBUZVodARA3jeBU8PoYJTBtpp	127
8831	2vaNfTR6xUVnV884MeN7Crf6KrZqED7qDp13XfuspsX1rdGq8S8g	127
8834	2vbC8p9sPv9jwAZVdoQyKwDa5p4asWd7CeaWBuHyGhPP1Pf9DzcA	127
8836	2vawwNptoMCVCGXNbiuoWGGWXzxvCTAV2tD1cEzqbkxV9yD4M4mR	127
8846	2vaszuQS36UsNhsZUMfDEiddnK52T5pfEmeF6staHtHaMrgL8Qxh	127
8848	2vaUhpa5HY6DELCs124hmHLfzmcXNLy7wqLhgSTYwrBcf5VTjUvM	127
8854	2vaNe9YgnxxbXUyvivVmNQpAgnZ2pri1vKM6qjLdSTTehv2Epm4f	127
8858	2vatKrbRE8WF6VA55oBKCZTGzcvDT7zkMPH8ak7BkCtvc5zkdYxF	127
8863	2vaARrh7G5XVJGKejAxXyRU92fjUSYNKQaBa3XXxpzvU28JYGr4q	127
8865	2vbgyErfgopspCgjhsMPdpQU6Viwo5DWfYALefmiSoHo4BnzfXWb	127
8867	2vbDrUWTCK65HR2tqzppo7HrtcDbW7Uz5ncBQ27Ay1H7KVqBvhQa	127
8869	2vacDdubxSgvjkNiEy2MsXpNXzvmUraUAik471DhFxP1vNujX7HF	127
8871	2vaALaANTacUU5raHzqohp1qU1t9nfE4Rd1LjNkkXEenBprbSRiu	127
8879	2vamMTGmmWk5hnJ7YCvXSVaEZi2tw5Z7ZWPn8Vgxj7E251d4SMts	127
8883	2vbJrSkS8KS5tbWbmagH1CH1S8UgbiAWAHgNx9Va8tS9ajKPUhnV	127
8886	2vb2J668Mhg8E4TUL2YYsjLAnPWpyT4Vd9fakbvBGLgWsededQHb	127
8891	2vaSTDogiUeti26eyMZg7iXMHznoZifsryRAZGvwWCMyG9TPj1WU	127
8893	2vaAULoNEw13XjVRteR76QWhfox7fov7oD34KoW12z5k28hu5QDe	127
8897	2vaJKQyR2gY4cemEpGZgjccCjV11rmW53gtFuihw8xG3Uf3mxvH4	127
8900	2vbvjUEgYoHE4qt8idbTfNXM8GE9GraFr6aUWii1rZ79xRzDFZDk	127
8907	2vaKeFjueku1bPjKCpyPHimeikiKD9hdsiJPXPKj5zDW3RiFGrXx	127
8908	2vb463YxhzxKZowegzNT7dqQM1WyAkMCYTRSU7RtsLYfW3EQGhvV	127
8909	2vbqsYA1GzVXq18ABGQoqDKexnsecTQayS262FoYofFKQddnircH	127
8912	2vau8KY35q66wPF27dbubQC4xhnzG6LDTcoR9gKZwxg4nXW7r4u6	127
8914	2vboVnyobGmcj8KJSsfZZiadu7GcjdBDp8V1A2De7Hh3TwwLdaqc	127
8917	2vbQnFCwL6XYBaPDFb9qgYnTqD8aC7yMpL7M8RmsNJDHT2u7hVSK	127
8920	2vakYbpnBBJVKJbSY9QGJd8GZH9kVebRBMY8BUFUzVxf7t8MJp6r	127
8922	2vaLkPuEwdqxc5SEpu81izo4d5tgRbeceD32vNpgP1Vfk1QM3C1y	127
8930	2vbLpe6zghbvd45xKxnSGa2p2ShrajMNfGSFPnrJwto7A4xxmjYk	127
8935	2vafK7i7Q4Uw1M6tmpLHRgonYL5GHZCKf8wnX3XdWuf2Jx6kraQa	127
8939	2vawgWqFPnBZfRDVDgkCyGyaAqsMo76pQfkEdtozNrv5btf9nP99	127
8948	2vajcNg3H118U8azLSxDmYXQnFt2r9LQCp81ufBN4c5hzXTfeypU	127
8951	2vbtM56HRq9wnqLdXh1mAFqVYwDymmCGFsdH69KiQvqosYeSydnM	127
8954	2vamw2rzGaf5eGhEbvQpCwBKxsW98tXdpWQavah7WXCpE96xQtvC	127
8958	2vbjrmPh8u9PqCwReLZZYQ4L9S6t3dJ65e7B5jZvTK5JEgT8vw8g	127
8961	2vb1apLpf5V1vfuStuymSd6ZqJpUVzFKScpFtBEMV6ZMKVy5kM4K	127
8969	2vbvDHfjvtpbQb5rd2rMszg8bwdYcSC2ed2cutUre2JQgP7AyMoH	127
8971	2vaPEjo4WzxhSEyH4buc62Xd9PgrTyKQbKddHGipvP6Yj12ATgmt	127
8973	2vbujTevtBq2KffphHotma21EsodgCmUjjkvoqenpMNUQ7R5jkkn	127
8980	2vc2iEDrN964c4LmBgtnKk3voGoX6E4pdbeRKiXHp7W2eJicJTJn	127
8983	2vaUt3jL2ANePEzHsChncEWxDw8voBd8SykpDJtqz6mPzWKENcFG	127
8995	2vazQaauzeAJkFRpoFyjZGHYjQAn8D1S2a5fPocwZHxEgLkfdJyR	127
8997	2vaTPbgAxgu2ePuqoheE8L8xzjessUf91jJdH3YE8qs2ZB1iTzWR	127
8999	2vbpTnE8BMjJ3LZVUxakPf2ajucc1s3FKomAaxZpNMYoy4MiQKMC	127
9001	2vaYAt91XrYVj3a2Lgi5hMMPdnrWVt1sU4rd19wWXpVLSBQjzM58	127
9004	2vbtxt59qxBJiauq9bWNRD9U3wDAUe4UqMYYcF11B2YSJFmAdrU7	127
9008	2vbrjBpGEweXaUJqTBdppUHFtm41AEwL2b2U8VFuPdGhaaJEyxSE	127
9014	2vbBcRxzcSnGZdxuguQrkHUpqT162tnfdFa6jLr2Fc5DkB4q1kgq	127
9016	2vaTa8UvkRmKcCpyyTHRLnZ5oXJp11CRyQmmREuCkmKycMYGtzY2	127
9019	2vaMmrxMt5UCLmAcArLi7tN11rvC1FTmT5K5bFaKdFL7pC6FzCUA	127
9025	2vbRqgjbaBuMbBK3dt53SFnsyVeV6bjq3W64mkDunvnHQXZgRZPw	127
9031	2vawzsNoEChMkpkvq1axKtvbhd73NpanDHun9wKALLkTf6x2zzPX	127
9032	2vaMcGNS1CfjLkXy9qtGLVRQPPLaUhzWK7bXyjoyTMsFd5qAjp7V	127
9035	2vaEaGy3McAtduz1z8LLwUeMLCnYxbvGxmRt2LLT1429vagm6g48	127
9042	2vbtZrHFp1jqDFM2NJS2vZAA56fZEnHonGMtZkb5P9E3uxV9rzhV	127
9050	2vbZKGZhkEDv789c9rGPjXG9dL2KsDWHwQkc6eqsfraj4gE85keV	127
9051	2vayNm4vRsUauwzGAVjJUbpRLF9ubGDCywQ3i5yApUL3ECUU4KUv	127
9062	2vaZn2W7skqLszVeUo17vrz2yTvfhqdC7JX3Xjors9B8jt34Lnb9	127
9065	2vbJRFvHDmGQKG6x6arQ5uWbYxtg1feoREFX6HWporz8zMPTEdDR	127
9070	2vacrewGK2VFSF9CLuCmA1VtkbQRkiKMZKFgdXc14kt62QC9kHFi	127
9077	2vbVZUkxrAj8b4VhyKp8Rx9R3rj9VjrKk9EWtMpnmacTAXuDfR2e	127
9080	2vc2epEcqc6t6VpAVBbkptempTKc6ckP2B2T6X2HUqY4od8V1xkM	127
9094	2vbXDRW8jFj2NBuDcSZ7mcGw7bXf2CM6DYXXyaSUgDGg2UecnbE9	127
9101	2vb8zd4tQjZv68Lw2xDt9hMK93zXmp3p6G3DY8WscB7sSwBtp9QF	127
9106	2vbvB6KveoitmJXan727f4SHwtNzqx8xWdupng7YMesdqZ77rP8b	127
9107	2vaW91pYcEUjioQAqGg6mhm5qUCdGz66PgBrny859yUWG9QHG9EJ	127
9112	2vbHMiCBz4NoLTsKKjkeKEsC7117oAnPo2rLHZsHoCN8GsQuqjkQ	127
9117	2vauoaGujJjohwWXsQfHp8fpFStVWpxqaH2D6xkBmaaQwhncGw3Z	127
9125	2vaYz1nowVw9aAsMcnmXZt75cviovwdWsPZMhgQUdUyJHzq23pwQ	127
9128	2vaph8TJHdGtNUAbgDFUG7jhzNfinUx3gpEtJmqMdiJGVarsixi5	127
9130	2vbKj5TRksNqbaBj5kbRpmDmJRM2VL4jHb8zsok6KXfR1ZDFmnKo	127
9132	2vbRrte4NKEYM4dRN7QF72m6wwGqhW2cK9JAWKb3BYc8tat1DP3Q	127
8843	2vafcxAubBM2JZFEZP7Xebd8oaVJb1gEFCUxvXKRuHLr1Bhg28zb	127
8850	2vazugWKQtSECV21yAcK9p9hZtiszAJ7j8AFVM3mhfUU78MfJ3BS	127
8853	2vbeqQCFKLkH9GuoCyzZ23NNSR8QxJFZ3SzHGce4R2WgVHNfxZB7	127
8857	2vaLaNS5d9PsxfmDrwU9t3jJnVkgvFrDMn9ruQMSB3g2orzpKLXA	127
8860	2vbz9DWZVoZfyt2UFX4iF56cHsPbGw3x4v1utdGBq5wfiEBuFqmx	127
8862	2vaGyjNWyex1iPZ7irvgBkxcLwLWSrFMNui77LhFLADbcmdJthqb	127
8864	2vbjGYvAiorqEhc4ZiQk6vM5EtgaLjuGctovkW1uUwk9h4j4yfnN	127
8866	2vbe1uVDZmYwaBmFTpdxukJ97v8jhi1gC1Gnq7BACXWoK6vFgaw8	127
8870	2vaoqjtDMFz13ttXuuVnmvwFjWYaHMHzDqM5FvQgAn6Ld8fsR6Lr	127
8872	2vbBqCN2hCCdYpyuyhWNjSUty5D13fCSpQnwKcYRyPqFHWdwN6Hw	127
8873	2varmCffYB27YbJyXb2kMQHhmr1Uus2WR2UG36RUZmLdbkHHmGLS	127
8876	2vbjeUtobvsrSNtr7ns9ehWwACQnF1Uwr11xKQRnoRUoyMNe7bDo	127
8878	2vbCwXV5zwLF578QXx9pUcEZXiWDSySfua7KwYHrNuyj14oNPDMD	127
8880	2vb9yrDqeBBQq7ujo4UVBxVvuNxv1SoDuhUuovR9vvguBfPfqvwD	127
8882	2vbGeUjHqfYPe6A9m8mtRMuMhju8nnX3TeAVLwff7u3NwYi9AZXU	127
8885	2va9Rssa5ebYsih4Zzt7f8SvPBC9S9jBUcfHWYNrBSn49LieB368	127
8889	2vbWigA7JZSJF9DkUA6crYydAThgpJEjeSYdBqRKeeyFc3MoZXKo	127
8890	2vbfbSGx8EK6kxaKCNcgjJtGirtoRojMDwUMVs8AuLDyH9NzYY9Q	127
8899	2vbcL2fUFtsDstYtxg6Tv8rGnKJKRBNR6yDJfrmrdaD3CGj4Hf67	127
8901	2vbaorSTeYj9WVhcBANwer7KVKseW26D8enSnQDGyzGx44R1hcDX	127
8905	2vbfoVFeTFZR3HUd4vSuBa3bXfGXQeNUBtRnnKxVmGSoWSix98bE	127
8906	2vaBTShc5SiLyQJ3CLq5Z1TvQMWvnqDCKemdDqUwFAGgfbW4abHS	127
8911	2vbWJVJfgxvyaJMSDTyKPmG21uxYsWj65tRAuCbkuCR8HZ2Yq6MC	127
8916	2vc3Z5CFrHWVwUEzdYSfPo59qskSt8zMK69cjip6XGVos1ASg9AU	127
8919	2vbcpKRLo4Uec6APo4k43ZcQERQmRUXtXymGmjeBxUNnQYc3Yymr	127
8927	2vb6yUhRKXPBLqFEudaFgeJWRf4buw9Rth2hohorJsmMbWGFShz8	127
8929	2vag9ttdzf43ZSUDakwQDmUAC91mra3RPi3WZZB6zJ3hPMpF9UV9	127
8932	2vbVwmzjqthkqVsuJ7Y3xzmBRgVBWAsuoHQbEifGmaqQisq5TXLC	127
8938	2vc3td8QfXpM192znjgnyHBf5x6usHpJxLDj12vWJTxGWBnabNL3	127
8940	2vafTBtHHjTU3e5iMQDaisPVFS6VC72N7Pqu6PgDoYr2C1n4oMDw	127
8942	2vaodyz6YzAAutmDDpv3obvuSW5PuT4imyiHyf8FPVpLAgZWsErx	127
8945	2vaJ2cEbUFTyZMG64juQgDGLdqVh3vcKrAutx1qoRNJZqDFiR6rg	127
8963	2vbzu6ogzWfZESQW3WerxhW7yWDfWiLKzoAjfetC8wypnmi53reC	127
8964	2vbo4UPdJLgoGAWTAyWMSYhAmtT72V3WjkYyJ84RcFq3UgabGJf3	127
8966	2vbuS9hBMM8giq899GnFZdYQZivAMipwRaUm7bh38yaxi1NJkiuM	127
8970	2vbfL2B2XRweiMrTH36Q9UFHDcTJuhH58p7gpxepviK92GJsZij7	127
8972	2vbaynhQCAmm4mEifbSFwPTkEy9ZSp5EDZRbTiXPr2noRd9i9JGC	127
8974	2vaiJe9UbtWuy9ZnioBAvvzCqQ9pqwS2Vc6byLuQfChPYA5JcgNv	127
8976	2vaucHbhxXt3avVZD5XuKVdWUwvQGdDBqtSfM7ZWVjPRi54DbGxp	127
8981	2vbpEEDPiCbqEXHxvySRGHRhwVnfWAHqx23ZH8XAoAStE3xShZzX	127
8984	2vbd7WMnFCS2HZnTGQwhrN5qsVzbDmw9WB54uJB4jsrSRZPGEMKD	127
8988	2vbbfms9npskQpKdr8EANTn3f6yktCN2h7wxevHwW5UrBvwBtUUp	127
8990	2vaPJzFga8zhL5HP5WRJREqQwMp1uhSAm7UzYGrNg2KiPFXjEbmg	127
8998	2vamzrZosrzSrSygJmRo6pqew2FoKQA9M62NxnL3FR5yU2G9rJt6	127
9000	2vbPkeDhwjYtS2GSQB8hRHwHzoS3SQGDEqKMSAY72d8CCQkw65SD	127
9002	2vbWt2BJAxcZMo324oAEkE3BZrihETK3FHozi7fhiXQMhuywBYCm	127
9006	2vaRkTNtNcqusixQM4ayBKGNWw6xLBNoXJHLVYNLrEpwoELFE23B	127
9009	2vbHoB8UqQUQ4VxNvXKZXVEupa5nYoE5vYHqBER4KsZ57MjbpDu3	127
9011	2vbyAHiaZQJAoWntCxbfxizBr5tMwvLhjHXxeKbgtCe4CNjL8KZY	127
9021	2vaCNNmP8RNHBbwfZisTxvXQZCxJcbqubLbbTMVtDqqMn1Y79MWh	127
9026	2vaQjD9LJZw59HNAdiFYgdNxUv62RZKpHj8voMyZLjkRTeorkq2c	127
9037	2vb5uQKU6sqRXUQqxpHpLieqxtmSET3TvSpTzzfiZR8Him8xBkKR	127
9040	2vbf8KXBG7NfpzAy9gAewyAZo1DTiVkyCHS8qVk72SJVMAAk7Jji	127
9048	2vbNXag4she6zoNebAMUzFwepjf2VPPUjGiWFNkm99MuFszaESpk	127
9054	2vbPAPnJTiANVMSUz9TPzKVBh4fsQEYahgw5qyEyHBkiPkyitbiW	127
9056	2vajrw3CyjUPoipLASpDYpmFTUBr1uB46YwudA1JkwJNjUFdsLSF	127
9061	2vaWzJNJYeGqicotp6bdaQ5SL3NinrdKKoHv6XERQyYXvArLjy5x	127
9063	2vaZcjAWwtnCcuPJmp4iwfyKmjjmwb97BcEGXWfaku6tJVVgQnZe	127
9066	2varQWcfsQfgQFRHupfZJWen2nY944CLv8gLd54J7kWy13SwhoGr	127
9068	2vaoT3KGKZ664vWZ441yabx7arYBidEwhtGtcYX1jQMw4YQteVwq	127
9071	2vbW6GNLRGnNQ4mbHAxmBeXZbg4WaQuthWMSFgxgdUSYmEjoRVng	127
9076	2vaTLdvFESXpmxjoM72K9rcemeiGaTNSGV2PanneEJMSkizDSAzT	127
9081	2vbRLbezvfRBNky7gnF6sYvCpzz1jkEFjxRucTtAH52TLwo3firE	127
9083	2vagqXj7zWxYuqCUwo2DHS9ZN4c32MnYHagWoETSLqSLoDx9FTiM	127
9085	2vb9JA9EYamdvF7WERQyG4GwkwR3ktwPy6S29LPJTwFE8SZeuRMt	127
9090	2vbQ4ZhJvFmhmYS6PgLvDbuj2goWE4ceS4yiCKDJqyJvMxztFddt	127
9092	2vae9uGLVirWwRiNpifQt7EV8tL7jDXB8kuA7MH7P5cELntNeEMx	127
9097	2vaikPdPuF4ESzZFQSnfrnT6WPejNEMu1TM6MEqDtfTzzGgjuZhv	127
9099	2vayScjdYDRAoiuFteM5sdMqJo4jQr9nx1qCM72KkK3jyCtKhmHJ	127
9102	2vasVnNs7wesDHDKUdmH557d9TBJ5VTAuCaRiFxDpM1yvy1Qbyqa	127
9104	2vc39HXd47SEE8oCF9pY8QEBDwfvBbgaexhC3SbVhwkejyxs7cgX	127
9108	2vbyAxNUhdo3Z2jGrAWduPYASJTVZdSDX6V4LznGNRXkj3xHPEJK	127
9110	2vbbC6zZZZGHJDX79wGaFaQTjVmPnDiAFXr8jn1BoQ2iqjh4eWPZ	127
9113	2vaY2oj9iwA4sM86ACkuiQbgboPXPvW1J8StTSezEPLPzTY9hTDC	127
9118	2vaHhG769Y5FUxbRbwjKA9YD2MCmLeiemPzZkDAsphGQ2SDByCVV	127
9120	2vbPCVkxnCgur8J9kmMB7x99xiEnxsKLFu7RBX5eL7HR8mZ3aB1N	127
9123	2vagcdNWUwaSDK56XRmU4KPAyBFEiWG5brdLtH8wCjFY9RdVAAY4	127
9133	2vbCAvyDxqqXmAkaP8XGRSRHnQDQ5QYpE8dkuvUhcFbGfnzvZQJn	127
9139	2vbzDTAdW8hd1z3hYGxcTHhsXMxeX4mciVAEV3b1NEqHSPfdhoS1	127
9142	2vbfcmzJuG2QSgzPkwNpcw9q7Mmun7easwVLhbCajKthJgnamF7C	127
9146	2vazVa6S4bv6FHpnjumpMWypwtrrisxxLT2EYbzEYJpWoMovDxyC	127
9148	2vbAtKyY9cuJRT3y7qKbqZwUKQdyhLNyv5fVnLPSuohBK6Tpbqs2	127
9151	2vbLdtPhAVophrNsmp82zmMCQFUAQruqc7eTTCZzXcv1o8ZJke1z	127
9153	2vaLhW9bxnSB9uYBETukU2xQGzRr5tiUw6chCzPn9Yy1tLZBfAzq	127
9156	2vc2hDU46pnwfEMq77K5WEndHYMxVezNFYAD6sn3B7mjZ4nphaKs	127
9158	2vagfTv2dFgac4gQ7EC24RNKcwxoQ5LGm8cSi6nqpGxwJq284YQ8	127
9165	2vaT7LWtAkr3L2TM2sLi4YcSoFXes9TwiFdKew8mvgBGLp2orH6N	127
9166	2vaQfybi9P7pTSdsdWEhc9uCcvLFkiw9BUup4L6YZ89DQhhKtLYp	127
8844	2vaCDZzFf4eTjHSS9dqkVdtXA2Qsat9wAZs4FVZpbYqzvZXowJcG	127
8849	2vaQhiZuq2p5d7U5HTdmeusXRyi2fYecJ4wgXESwdTe26ZkMLqNU	127
8851	2vb5mfRiexP2NBoMDmwB3jeXbQp3vkdchn4L6sHU7iQxHrrSL78i	127
8859	2vbXVYj82zwwDJpxkYtSiVhogdQcAmebr3FpMUGE9v9epaSVMgFd	127
8861	2vbyYEzoKS8RgfSzJMXMXyvaXBYMH6Vo5fYpULKVH2gH5RFvpUDt	127
8868	2vayky6GxNS7z6rYqXDpov7g4BDCSyzgZjj6HyQaWudo5CFahxSq	127
8875	2vabmik2gRT6Hs1FiDEGaVzhQA86KmiL2Amg9TFUKQQ8u6xSAHme	127
8877	2vaaRKE11om3EzYfVaR12tjsax8SqZs4JLnSqG9exVxRLCQpdfka	127
8884	2vbpkVvZSMtcPUgH5sovz66KHETfHiWGdnkwmcWT3qSFMmQfzwKB	127
8888	2vaTqHaHJ2U4F8WiAfKwvxw1epMcsBRSdxuB21eqiAtojJwXycFh	127
8892	2vbcqNA89EWkbnoBRbnp7vA2CQ3jVNPVgQDEMVmwdZ8g11mU3xph	127
8895	2vboVExnBhEMVVCcQTPnqciFozozXwRbchWurKRScjo5P7iAPd1a	127
8904	2vakZdHTdzofrTBGcXZ9vxXzVxACuCuqVKw1mGdvBxwj2ChcaER1	127
8913	2vaz1rCGqw7swdaQsiM98XMJPL4HqSEJ8zX8k6CDxVcdU5EwUxwc	127
8918	2vb739DwWcyFXvbxpsBd3WnRogphTX14BQsdwEhURUAspdD2af9h	127
8924	2variK7VdPwj95H6kECsqhXWoB66CwgyUs6upL6hLYUMD6EMQknV	127
8926	2vbeFek4Jc7VS2wJ4SeGNrCbHBA1TxuRk7tUuYmERzvkWUZ2Z9yi	127
8928	2vaRj6hh9mEJojvNUneMywMAPfSdTvFAMDYYkmSSYRgMFpbshzcJ	127
8934	2vaJrbiDbTDL36iyjTkq64Tvqw8PpnjyZf3STKranFjYMVhWxttZ	127
8937	2vbhW9aN3vq6FQSWV1TyhSC2Wk8BAEFDaubZoKwYvBrJ9Qdv9hKr	127
8941	2vbvMZJk1SS9vkbcmAce1ExrcyE5KzD1z2gMLAtt4mmR4AMaT6QX	127
8944	2vbfULWGeiaF5JUqtLdNKKbJa9VeZ4dxNRgn4pFqAuhQi4Vdzc5h	127
8949	2vaStpp5Bq2VxBh57FKXBTzs5apdpbKC4RK15XvdjrAJQD3rhBUD	127
8953	2vazDCsaZwWgQueeQP6UMSjZ1iENFrgq6grc8S51SrSDwwmNX8oU	127
8955	2vasMJrCC9iTWXEkQjJYoqrFemUYFZHtS5Dvfk3Ej38kdGAz7WuR	127
8957	2vbudLJCiJktwViBZNk1Y7ScQQfsmmxfm7fYPHcxRv2qSkPtYAcp	127
8960	2vb2DMXBNQHfjS5dxUx7rpJN4LEaM8XCikUWmZJXiayHwUNQRarn	127
8962	2vatYaddshVC69bCfZTTsTvrFjji5kYUZ51yeS8bBR4H5smyVT42	127
8965	2vaZx8a6UKzr9axMbCiTFoNceULocsnK1jERF1FFZTmGgAssUmUt	127
8968	2vagacm8oByB8B6ztdbFtC63eLghmNcDQmAWzrg4WXkzFYCYaqWA	127
8975	2vbkr8NzLtEALtsNvtyM9PL5w4eVAVVE3avdJmbpkhtFq4JPoej1	127
8979	2vaCpY8tvLqXYF5HY7qjubheB7VQ7iTtcHkzoFE8qB9CjE5YYccv	127
8987	2vawtzS7JyzNPNnyNYrtEcYrR9MGokiWkrjBCU69ReFEfYsmiCAB	127
8989	2vaKntVoHTLxKwj4AaNMbQP4oPZa1dwyZEASTYYkWpoRBo7R8XUa	127
8992	2vanNxz5vnyKKCX8LKZfM3VuU8fYx91fZfurDueW6VdnDDjVdD8P	127
8994	2vbDvuyceyy2fpRdE1MXJ682sS7T52mgU4ge2C4H67WWvPKrrHTV	127
8996	2vaqDUr2eXUYgNk1536mswK9B8cnzP5sZQKC4CcmaTkfKdpHYXua	127
9003	2vaJwzt5oc48YD3sMBWsGroy9p1GJk7GtGjFDDoap37AyqpkyeC9	127
9013	2vb8ySxAUvhXFr1YVB2ZyuRdv3a1Hc86FnvAmNmda3MP5esn3VcF	127
9015	2vbE9zUDqCQHiovaxPdXN8xqS3wd6am4aYFeQ8yxrWSgbT452LG5	127
9018	2vadWk8hWvDp8o1oSrzJLzG7eYYTNkakbooNkko5oGMMAJbQ6BjG	127
9020	2vbhWHMRL8xwwWYzrroE8v9QWf7CVdkzjp16J3C7QaAgLEMnUhJD	127
9023	2vb9JH1eP1E1a6W5ieVnUFzYqbgoHx3TrR8xKP4QdHGbYcjunvkz	127
9024	2vbcwvknfncYuu5zeE5h3tdMPMi7kDDr75QMGiiRPrvneYeLM2pc	127
9028	2vaZvDWE9S8h4JVJfi6RhqYJ3GgPKA9g8TxQvhXATB6D2SyPU55W	127
9030	2varavWA9X7FPKQQFiPoQnqsn4Z8sU7YqGMRs4YUwN42KGCLcaQx	127
9034	2vaNq2BFAqPezXVB5A6emyXsYKC8kU2j3eY74wPCoZpY2w45WQM9	127
9038	2vbs3SWQGXjBezgpAMyoL71uR9aQdiZxcFDZHoSZ419XRQNQbsWF	127
9039	2vbpj2MpC62QNjCsZy5DKQ1EbnmSfkWFKgEA19Gy5paGSgKyTV8d	127
9045	2vavgkprrccyiQqvS9pzwW4NHeo6hZWNsBrS2TsSkptrWB99yM9C	127
9047	2vc1bLwfNRUywzda6hRJRSkQViyFZLNZUD9SVbB3pARrXPxHApqK	127
9053	2vb2GurDdYcCUXFEKkBHZ6oXSZ3MBy3iUsUCdThzW1vm34ruucqC	127
9058	2vbGqKm56fdjABMjXxNw8AS8gLR7VmcekdJg3S7LMCSaGfB76aiG	127
9060	2vaiS25GuMR2KrFUCLPzMBM7ZTgGjhfVYdynnyKCfaL3XyFXjsJW	127
9064	2vahaPYbyhUjUWXRTPKA5M6cqcxLS4u9U3T1tXoicxSMvdX4eLaz	127
9073	2vaLRcN3g89YdkDpinKczbdk3USiFwcQpcxBqewMAroDvTy9ECbJ	127
9075	2vaXoiZsfiDJnMP9uwepo1hZzUune3pqaqtQBBmTLAEFD89z7P2Y	127
9079	2vbrRdqHY3bWmjc6kWwJmQhf32VH9hqjSxSxbHF6ns5qkyqTBtuV	127
9082	2vbKrbT1fqYsw6gA2okgPUA3vbz9Pgo5GUSakbVhJhgvvcsPbvEv	127
9086	2vaCRPCYEcAqoJrLb4LY2ECPykudkpZK3FCXuez3KnRRYcrnj3rg	127
9087	2vb6fG1dhhRNXE3Ajz4Pwicr6wtdpyZjFUKuUa52bZm23AEkEtD8	127
9089	2vbZTPA9eQsKM9BnKa6zU6QxQnpfKtpdXWmToNnPSykjjdCvRbnX	127
9091	2vastztzkdtzcm8YGaxc2fce3JfQtwyuw7TyLmWDAY5Hi5dok9cs	127
9098	2vbn2btn8FRkeAQyKVxgLGtiM2y53aFrxuKwHVHmDoqrjzYvXYKt	127
9103	2vbtCqfKx9w2HGN9VLHxMD1aDiEsivKBHgrc9sVQBfYtiEk31yUV	127
9109	2vbhhD2AZ2i2tR5rjegkg6cUw8Vo7A8Zn1YMLwk1jwegvUvsAHmr	127
9111	2vbSdScdV88sYB1nvSF9xCnJk6GuRRDnnF1976PGE5b6VitBxwvK	127
9115	2vaHGCXZ3DMxpyUbjxV8rTc1PNeMQLCh2FLfA13BEWqVkGVqiayC	127
9122	2vbcH8wV1f9tockVQFD3hUcRApyCP12TdqCNmU7sy4GU6nZtNePE	127
9127	2vadPA5PYptpsm9W9DorrM2p6SwVsDj6JHan7MdMVRVg3eHH41VV	127
9129	2vbwsCVLAKJ2R7y68mGV6TmVdgZdYf4tZcoNTGADpoK3LS6tbzHf	127
9131	2vc5cEGqhLiZeNaeXgHarUQtyN4vPXXgsLnN34hJcfPaCtgERbUn	127
9138	2vaztHCgduZ2jYtfmuoBHuaz1e9atkmUzcXbP8hxX39LzZsC6Dn3	127
9145	2vaGN1jkYo6yFD32C377gbtHBY3FEQR5zaRdzBXBFtiHa6gfxukJ	127
9147	2vboM1FJacru9wcEeacqx2NBxQfU5gicwaNtxyVbTPYsmJx36pKj	127
9149	2vbjXBNtZyakTrxkrqY8HKTNhPugsC2Tp7Z6c7jirnhFkh3rQTRE	127
9154	2vaJyvhSpW7PXpV75VUwa4TeHgRmBz7xQnnayDvAAgZ8EBiesM7z	127
9159	2vbBWkaAimdZtFkLAzSmVL8Lo53UqtVrBV6gTksfha5zoaw5BgoZ	127
9162	2vbazS3J9QxFdXDBQYyRzHFqw8chVPM2Axqfy3dHNu573qYcTdUX	127
9163	2vb5w7gfN9bdeEiGTuwRjT3VUjCbQYk9rA4knQDn57Z2jbWEXDLW	127
9168	2vbdevXfa4FJCuCZ6jwEkmtcY2TavrDEGkavWBnaviWbWhNnmeUZ	127
9173	2vb1CZD16UQt7K72Gt7L93hrA7dwp9vitjyWeG3xmdtaKDqktn6o	127
9182	2vbrk5Ew434BMiUFGqut3qaMNECpVhGtQdQmye3RdLY9zmevdVdM	127
9184	2vbHpzxaSapNqUNgCmgTEng6ZdnvZRb88roGwgvEhwfFESMnGHk2	127
9186	2vaLH8SDaK59U7aH526riX7cpA5r93LSwihFd7z4p12LEPAjJvAG	127
9194	2vc2bvNTpUYeq6XpX5wYzzGHnFmo2871EUvecu7n97wihZC8tESi	127
9197	2vbCCyHhJncAeEXkjaz9h2MWz5aMVGEKA9d5o3SzxgXM5K6Hmwp4	127
9200	2vaSvLzBNGzT7WXsd7dJE9iu6m66QmUt6rQ4Wcr8shhZReF6sZi1	127
8896	2vbpjzhhv7vU5fo31Yns4F7pfsKW24vRfrgafTP5AJFP4QXFZfEC	127
8898	2vaDFakA1nXcv2Rvrxk8adBYmbvxHPjVPvG32kdtYRJquLPuQ43B	127
8902	2vbhNPpUZFoXt1cPThcP39iRSSNJ65XRpiuvK8RYwB6LriA8XZRr	127
8903	2vb2TMxwNJjxmrikhhsnkrBcdCB4LiyJdj4TX9ZMiT7d4HGijcLV	127
8910	2vb9njYTdT2MA27zaHbSGydtw3Xdc19o8GQcquEuPsBVqvssVQKH	127
8915	2vb4dC1bnDVYCcXbyGeppUnUauHaNrpZmQ8vgCppjXxBj2bAqR9D	127
8921	2vbPLWyCqo9WvMGGm5yxMK5dKDCF1ajLNyzffqjrYBFojMA6RXt5	127
8923	2vbqWehhhaCn2rWe3dwvs9TxGid3AFMSmt1whQKAP66NxKwyreHe	127
8925	2vbLMnqT6QCiedzZzkaRuUz8KtScFjRzYTxvN2Miywk58Rsre4ET	127
8931	2vbHxrJ6LW4JSfdWGeNCwRkRyW7dkARyJ6Zin8tKKoQauoYyKxDp	127
8933	2vbwfFeDZwkafi8UtstDfBQQy2R6Q7Y2jEMZEudVWKRtq7x4Rq2M	127
8936	2vasuTbaX463tQsomuJKRitQWghQTcerDjuwQUS3mzVi6CPxMBQg	127
8943	2vb9kdhkhmMUnuW8dNEJHFcf9EiDvaFzbzJBai4cgtxKm3hfnNWt	127
8946	2vaEPwAKe7Rend4ciSC46Hr2LWgAADbhYDEDjBJu2eX15CcYXAAd	127
8947	2vau9dTsLdxhssNYDMLW8H1xPv1SGhaNU8a5JG4L8DbP9AKCA4Sb	127
8950	2vbvvojdhuk3vq6ThdYwDKK1QDSfigsAGvnkcBMc3a48r454WxWW	127
8952	2vbPj2dU59rg9rSvfrnvdkoXE5vLVnUwq9WDzgB2ZXravyH18x5Y	127
8956	2vc1b9Fsv4UwYBAdP2HDTZLFbKGPMr42RACrLqkJ88jxkWqzeygS	127
8959	2vbbf7xKzRKkcgiZACf5W69vQzfhghr1YgVkyWPf3WR5XrbRXPq3	127
8967	2vbPAZeEb9ZpqDYqFBXBQ1ToMAi3UDFBnx1Ppj2ZY1qdecDS9kGh	127
8977	2vb7bN4t2yrECQXVY7c5jVrWwEZLQykmNurL2HtHzziSDCiqSZ69	127
8978	2vau6VTatdeNUoheWE38uYsDSfKE4XWHPXDo97uXdDTjYQ9LNDQe	127
8982	2vaerxWi6xLi86TvvxKjRN7kQMudxbkJ8KKBtHV6ye5k8ZbpmNDQ	127
8985	2vb7QYBABQMBJe1z2KS564LgnmmriwSKzzsry1q4zZDgHLEsZXfH	127
8986	2vaB8dfAMChmCMVE64PMZVAPCxrC8MjZpYoNntD8X1St3RprUxHk	127
8991	2vbjHiskoXoxJzoHqCtSwzymXAYJmmUTZgNjXfjzqmQyRp2HaevN	127
8993	2vaN4d4wkRhY18p8rk4akZd7kF6vbgw2etezcLkUGhEpnWkQnNh1	127
9005	2vb1Gc6rE9bQGSH9GSqTipkyQ8JSTBK68FkGmhHVZ76Tc1MxbQt8	127
9007	2vaoEmxYZcjLg2gLH1WS2XFedgJiAPwSRfrJDG3jzbVqNfkvdyjM	127
9010	2vbUM7TzdDEzibB2zTKbY615dJNp29juDGTFwpCHQh3UoQhgzRdR	127
9012	2vaRCy9tsUapyzZgHekosy4ksKmfjQtWYy6GYP9iQjXzNdo7eVS2	127
9017	2vaNmGx76J5p2TxtmJWymr7p9EJDEuaGtKHDRWLdGcnMxkNJaYXg	127
9022	2vatZxFFUuVmkGXHwpUpQWKCnbCFrdErqHS3xcqtHfSwD4cioHMx	127
9027	2vapB4Zar44kPJZfSY4FwgK9J3CjMoyDdV8wCvG5gTxrmLWtBHUJ	127
9029	2vc4YGXh6NP5uyMVL3ynCPPUUZNPgTVPA8EbrhCtmyHMpFWiznV9	127
9033	2vb4FLwGtBj3uoduyCC4upmLsx2TJyueAxUx5uux1huXZ3CBC3hy	127
9036	2vbTcrVYK4k6FKbPSeccbrfiBRzKVp2Dh8ZdrLJm1tJbGjrEFDVv	127
9041	2vaYKrxEAPfhdvJFaetRhwX3kAM12aZExJbvYSJgHiJAZ7DY5gUb	127
9043	2vc37yjaHArfc1WNV5Mc3RbSw4HX8cxKFBxCzjyGQquB7yHjpAb3	127
9044	2vb95mZ1x4MYdpstFt2SLqsrFbVJyTyNUyc4KTfgQ1rTCSJLzmPa	127
9046	2vaZsdgUtZRFqJRZi1diRxhFSqxKEKXY8i9cmFhNsCAeFHj3XXdM	127
9049	2vb9eAA8LCF5PuTJpVreAM2ByNwLznjZWMuYimJWWxfPjyZU92no	127
9052	2vapVNbUmBpLT7dookczwyaJCSC8jnXTHTcZ6st2mHDLD76Tggvp	127
9055	2vaaNvjdtoLN7qqqLezoUDXhFz6Yp6VwiE7UyWCGCyLrJ8KCXb4y	127
9057	2vaSbKWYWiYPQaWxXz4hMa2RWDSXQ6859PoKqEdN3HWabhb99BBC	127
9059	2vaiHLqefjRx8QBsNSURTuzWE91p3byT9S6gqHrcad9eibR6Q2Tw	127
9067	2vaqD8SQuJdPJUbNaj92mTDjnSQRiFectHiUjchHQhphQfgN6vZ3	127
9069	2vbcsVZrh33679hvVkmzN85jvpSzFMwp5Ero25AVeGbXDjU4QRLd	127
9072	2vamtCw3wvX68Vt6b22MF1wUs1uL43yt41TghcgvFoWR1Xk44QFg	127
9074	2vbEKnhxwUdPvbwZPeghH9UHSw9nRd7qVF7bKoeGG4gTPuW2umst	127
9078	2vavt55CynTZLeKAohGhMcUwANW2KHM2NNckiwsxLjUW9PNLJygH	127
9084	2vauNjgzVW2nvvcbSwP8m6aYLvGi1G73TygZsGx1NeCMesii5rue	127
9088	2vaoFgjC2q9pWzA3nyG9DW6Nhsg3zQybaiGu8uXYVMzXShCJKYvg	127
9093	2vacEB2rzMp4vhbMyeNSvH9SREvNDKmwiHXuvyGYW1ZCH1KnTXiG	127
9095	2vbGMjrAF1T7KwFSamerhX9ogjVwJeKrEGrVxAMiCPyKsd7kvVnj	127
9096	2varhbgFTVqZDj4eUm93PE6fD3Wp9q8ph7QLJqQchdf5SwWB8z8t	127
9100	2vaLVNCxr72AKJESDCo8jXQLuw8goKc9ozYMojwEhyfNphiVNhWF	127
9105	2vbJbGcenFNeE2Kyg8djkeHrPcksg5usRxojFdJFgLxQHfNf9DSw	127
9114	2vapa5Z5LXD742TrhvyZeeZX3sRWtPPGZZ8qXkGVPfcfoZmjZoLt	127
9116	2vbQmTVnsXi4341GdQyKzH2pVVTugq5fPgtAbX11WR7L282Vk6qk	127
9119	2vazNXx6yjrxiQWNjGXDNoFccZjTe5Bx1nEo7r5B13NVZ915uwEY	127
9121	2vbkmtcWrAauzwKjwZeVinoryV4pAXqwcYVY54Qzy4aXAgzDXMMZ	127
9124	2vaeKDAARDErRXY4oat6V5iSW68kPx3bgVDnP2dhR1db4cYzAFdK	127
9126	2vbh3bDYwLVCpS1twRMPPjSqhgpWF9WWgaM6V2eknHEDmW2wrUz1	127
9134	2vbMdwEdHP7BTCSQF2p4Q2LChThRMAZM5vvZdweQdzFobM5VYdXg	127
9136	2vaMUF7VJZe8FVFDjChwHCk5Hcd82QgKjAjnjsdaVqdH5oo5fu4v	127
9137	2vbmGUNn1ZUmrkdL74DnThcUG1m6hy1L7UV9YmPfdPHheiZW3ZMo	127
9140	2vc2JVbPL3X58toTJjBzb4V7CnGDc7pjDyJue6MKBjmXYesS77NR	127
9143	2vc2vhSqCMGC45tLCJWbJD3wgbXvp9UqsBw4E72KVCbYqcNXNzim	127
9144	2vb34CSxgQC23VY4AsxuRmisteL7PLUXRg5sXU2sQgmoKd3t1F22	127
9161	2vbsDcNWQcxPtCrdFekvo9Lu4S1wDoMgiiff2tcTDgecE5mVD16p	127
9167	2vaf7NsNkFwnEdygamEBSYNdsYSAva1QFpMEBHVFV1YTgg2uxkeo	127
9170	2vbVXKmbi7KrZqYBQ3gZgxVoKRd7mX7ahZp1uzkvBLNsGKZGsNjc	127
9177	2vak3yxbzhxiYZBkRwYjPR5HYabQvSDzV96eb5iWCucJbbgY1WRq	127
9188	2vboajDVtebvAXRbLE58aaK35ghs2DViAtANJahLLmwcoVCHfPXS	127
9189	2vbrQGqroUWAiAKeJ2Jzitcp9CL1gEUvqKSdRwHeETek1QLAvUwJ	127
9196	2vamGdEkywaTcmaPnvbm21fBZqRU8aPN3aNqfD4FfYDtZ5YWVoRG	127
9199	2vbaHovGcxfgtAj8yTRMcQRQCveYkxUaMb3Eyn4uBLscd73qhbJC	127
9209	2vc4ehEmAvgA2jWfEjcvQ7nDvzfTp9AaKDTUZtJd5Ly4f1gsW63Y	127
9211	2vbrVwk7qEje1WgRSnLm8VeFX63qTvFapFPobHeKrU3XvAYiH5E1	127
9217	2vbUgmfswRQw21zMpZ2fA6JVXd7wFc61Xe2kmd7KTU1qJbe3HnCv	127
9219	2vaVhv8a8NfoGLyiavTXSmGxZ1WANv5ASuJjwvMZo1UnxyN4GTJb	127
9222	2vb3G6ea8Nd3LREYWFyiPu4rBdkf1hBNX8pCA8vteGmcLtzUWVe2	127
9224	2vary8UnX1MHezLecC39eF7ZiAdn5HdGHWH57vCSgmTzhV6bTNeM	127
9228	2vaQ3NL9Y3uj19cFLj5JHQYj5Z7NFKJT7DqJTP5R5M1kCzKxzDKp	127
9240	2vbWRrjn1PTa9XyS7cUZiopRpdCmdKvis7hBBUKsfkwej562NuTh	127
9244	2va9wRPPC8cv79QZzwt5AA3FuyRZhaDZrbkDN5os6YekLizFuT2H	127
9246	2vbLrBFXdMsu6ajVdpa4zgwjcu7cx8t1dH1imBGzToUwJEhva6uY	127
9135	2vadET6fqeFxsepe5k2HX284vBDD4h7uoe2ojk2NDVMLLh4aHf6F	127
9141	2vbN1kmQnpu6WcFFAaP33XgqBwKmGSCtHvw7Vw37w2upBafMNmBx	127
9150	2vb1HJpF2Nyrsr6XeBPLkPrYmKF4vwcfmS5vJDYtX6ZQN5tni6vv	127
9152	2vbfHPFzmM3RtsbdmDg3NcbvSpQXzTP8AFkJJg5NoGHia9A51oFu	127
9155	2vbo86jr4Zw5PMf2Cb8Pm6Ni8W1sTAxMmxUWQrhrJ3rmCpqjbxGP	127
9157	2vbueVujYUgQ8bFmm2RXgN5p8dsVD7Uk7aLD5EDUU5NuFMvMoT5Q	127
9160	2vbbyt23adv7zbGy1MUs7Dx5ZDt3MP36Heg2pdN8oeWA8kxBrtFG	127
9164	2vbpV2yAKK1V3aahQE5dCx6MLta97QKaRg8SRxzQoHx1E8TLvPWC	127
9171	2va9qkhW8WR7vF1ppDvbYWamxrYSSZJhGT7ZT9FuB4RV2uxLW9ky	127
9174	2vabZT9kgVShUAeKfAVoe6DgL4BDi3h2q8LbkLh4pUBSDgT39gDU	127
9178	2vaWCwc9VXFj1aPbAc2koJyTRxrwWUd9crN1B8Tw79B7sczkdxPg	127
9180	2vastxoBDLZt9YycoZbnbphWTAZ7XEA2Kx7amRn7guu51MhrinbD	127
9191	2vaG2yEcwPQDReXnum4eVdyNGtDAgekUJwS9CCH4cB8YqxG82Neg	127
9193	2vaosRL3Pkhwu5bEUc9qLnqivBqXTcrUjDLodiYissydPZrtFKWx	127
9198	2vaeT6KeAx5NudZxfswTrjf8C4cwm2EtYdVjb1PDSiy2Xn1ZY9f5	127
9203	2vc1QuGHvykUCbpHY5mdQQ9GKGVVrY2JFNrFoT5A7QgJY8RWW2RV	127
9205	2vbrPWKXJn88SeZq6YWLtu1DzwqrkEJ2va2wxEfqf3kg5QKLeyz6	127
9208	2vatJtkjGrYvDxD61AXpnw3o9sSZq9M8S3ptim3HZy3rG7oHvov5	127
9214	2vbcDAB4BFrDkG9qEsNDYRCzdvRSn3sPSf2LseHJqZKqXbrJZe9D	127
9216	2vc1Qpwo9S85B7yA393GAA2iWAw4vHeVTSwe5p1MMkUiXpybRn58	127
9218	2vbgQDWyGk8jwFmE6GPz2XFSvMZxjakKNQVx3EYkbZsPf74jwyaa	127
9221	2vbKyMPAEfdbrGgYerGeNxRTczPebB2uDCjCww4bJhWEQbnYbyiK	127
9223	2vaXWFFgyAD55bXwiBgnycLUodHYLrP7C2BnmubAPtD5NeBUWbk7	127
9230	2vapwdJHDPBcRJPjRovuujPLTfoKjkznmUv3tgzr8Y1AVGbZ79WE	127
9231	2vaAFvTegChYEjHEcRA9y5EywcGp1VBhoTuU1r5F2A5ndmgPG4M6	127
9233	2vbuHSAc2TnhBsgpXNYzWiUYL7JvkcmMRiTfttQJTwbBY45roJw7	127
9238	2vavQuEJZESTdJB1u1huWrUmme4mYvcHEX7ZUTLPKpv5m8JxhG6i	127
9243	2vbDRoLMGE7kuwoTubSpkNxwcqDKU27JDTWxpfMRW9dDDskVu7rb	127
9245	2vbsBPSqFq13jytwcRHervYFdUpwK2feEZaZ3wFKXCWvV9JAW6hd	127
9248	2vc1FeAfRBxpjtsV6sf8yJLuiKaJPM955rietrpxEhcfYxUuNJYZ	127
9255	2vbz2Se5vRqb17ZQPEiDYfDkQixoBX3UEx32dfyrR7e7ggdzNkBt	127
9262	2vbS2DjvXuiN1KZHuPweZZg7Rwznj3bshnEvhMgjibg2PaTzRMqe	127
9267	2vbkAoYJRBSMPDs9ctU48wQwGS6kKB8UeNaYCJPpAjGHReTYTzRN	127
9269	2vaBBg4Nb9Luq1KFDve6BEmhj44Mu8JKkn8UXXBGrtLj9oGKLnsS	127
9276	2vbrztKW2yN4PdeMQUMVZsAMCL2sQDh6g6mRnsnigzq5Um9EsSFc	127
9278	2vaJ4QNKmmrLWeL8qeNV9EoUYsCVubBUptpuXVd2H3n5PcW9iaKo	127
9285	2vbLLGQPsRdoo7TaNxXUNEs9XJTrpqm8XimbdrYGi4TS8m7tTAdz	127
9287	2vaD29wsfpbSyd2Wd9h7SPFGwh7BBdmQXQc1kLDFYouj38vcojKR	127
9169	2vbxQqejW5RCLzzM25uFe75GX6MQKodoVoCodYJiCRVddxMhkGa9	127
9172	2vbU5LhTFkMcgCJMFLwVufFWEQd5KHaWsduJdC2AN3SxCHBTHaZY	127
9175	2vbzXC2U65mvWT3aRHPjuWibmu1NFFRyrnS8wkVFaMnCKX5qr3sV	127
9176	2vbcQoZ6SFVP9F2bpiKDj7tBUtnxBCf2pmrw476JJASaybzEhuvM	127
9179	2vbXVqyTXy9Bns7YBpm4CATF8vTBJnHuy2yMk8dWBWMowSo15x82	127
9181	2vbpduq3i4ge7AvG8vzVcJZwxu6zTp95Lk41Gq3ScYWszU5htCRS	127
9183	2vbzfrLSmtwiXwwvnQJJ9t8v1ERVnfAmUUvp7kdBmqdnN1w2ymrs	127
9185	2vawTJMqZJs27F3muNAboLhMvP88chTERbnc4yPr9p5qoY1hu2xh	127
9187	2vakcry3c723L4TaBtSsMrDRCx4jn4owwX1uxTAWbN69vmFNeaAn	127
9190	2vb4q47fke9EAbe8QGQSLBkwTWWTfKM8ZWqS5urP4zZiWGx5t2AZ	127
9192	2vbKMFarCP4bhsisQUaQgwBRNCUsf9T4Q45tFDn7kP4JRR61juoa	127
9195	2vbRSi6hZepYXjXsvWbzcX1zcQAENvALLuFz9vei1jqmgcj6yAZP	127
9202	2vbPHL66wcpzwWqcdaqwJG1rsHGrGVVeHyhuY4CMXhv7F2Aw1qEe	127
9210	2vazWMRKembC567k5y2SP8spdHnSVAc9jLocBLjt7Yi2uyB1k7a1	127
9212	2vaWsHWoRy49fgkTEivBEEvq2Lz7ycEUuYDu7Ph9TQ8uGHG2LmFG	127
9213	2vahivtk9axr2vEnKMTxWJfZrPLp1J9uLRkdJnXSQERXLs6tTWvU	127
9215	2vbAdJCQkNhZG6KCQyoQAVBDtkEieV4ZsxquHH7PGTqq2hgWK6Tk	127
9226	2vbwFVtS45YwTYtnBcks28hcfqJJpK6REz41cG2ftyE2rseqtswm	127
9235	2vbwiM8VsTsLcctMiZWsiHAaFnYVwgLzUMP9UD8qCMznzJ1DLAQS	127
9236	2vaG9PfGwtm6ikz6ktE2eb1GaDZVWp3uocE4tUTwPLw1MxLS7xuG	127
9241	2vbMVMpofX4TTPfVbctNqQqip463ahuLtT97uDU6pqfVBJThC4Sd	127
9250	2vbqCmnpcohx3NifHbzw6aqHAdXvdn4oP5AEaM2KnwuXQ2yMiF63	127
9253	2vbDUFWPH9DSiFNWEspVW69LmBzqoHqKfv4AVh8nqfEU5UXuASNH	127
9259	2vaCCyKmAsVvnZvLcQjxoRdJ57RW884w5xCsyNG3LSfSEqqSDxeQ	127
9261	2vavXHc7miay7ofY7UdSG4EdXfEFWG7N2cb62cWVLU1VXhZRoS8i	127
9264	2vbUDhCHfATTAeuDBp7TLqP9prwWVsgLGg2ZZ9UTG1VZSzBMzNb5	127
9271	2vad7mWXcQMCdKSDpp3yHW7BJJpzxRCoaK3QkZoC9b6yTht3YFCR	127
9274	2vb7NDMXLQtUpFCt1prbU5RcCvY4TfcDYdgEZrR4Fvu9Vt7aNgsA	127
9281	2vadEVWWAGBLTSjyv9KYcvXZXuH5eJ5YWdTrDh5hx46TAZU1BVu9	127
9286	2vamAXPULVwtGiLCwMmzGX4WFdXMxUtoQhHV6WZnqgvnA8NLgVHQ	127
9201	2vanU3YPHx9sj9C15aKh7a8wWRVdQAadLiT1UUu4zC9nyVfk9yAY	127
9204	2vaf9iaPqJFKHcrtxVwP753kg8VvBYwT9XkcrBsEdEzdJvq1LTpp	127
9206	2vaX2LwfBMWFWRBL6U2S6RzFFtQPTbGFazQZYb6hx1pVTSnwXbp2	127
9207	2vbyuhC6gRfj4ouJ8t7KqhGbbFR5bht7M5sNiaHhwRHHSLKi26eK	127
9220	2vawuAwq3mVZYbsEo3QWRX3nxSKftJjYwraDvb2XPvJv7CEoAHx8	127
9225	2vbBBR1SJvJBgPg1vgimQAsMvNrYV55cRLKW1JpAbDymrYdJANqx	127
9227	2vaUkdbkZZpY6rU2vtg4EKMfNo2qzggdDmggB5cJEp7A8eA7VerA	127
9229	2vaQEBL6zrN781F7y1uFA8GjUbZe66t8yC5YwKHuLohpcgJhymEa	127
9232	2vaehpZfhFWJ8YRvfbBFtVekm8nJbLPuu2SRNkJ2bTQbkwDhWnSw	127
9234	2vb45fm5iroPHC2rudfviTzJudLziaiBYKZauXqjgfSriKo5JmT4	127
9237	2vb21oPcKysFQbP4fvk8V8tjeWKkM4reFha8NqeYBQmF1DtDKm4U	127
9239	2vbL5CcXhCEGKq8uVMe5UBrrLe9MaNHtFXdkf95xABSwQPeNKoz1	127
9242	2vbmQPJATJyppkrL6wNvizFMtYBBRwhejhXsGTckYFHdP43nS6rp	127
9247	2vaXcfUeQtMxfuZZWNagt57ofedLeLrG3BqUgS4UTbmfNKy4kg2z	127
9251	2vbhmBH4YJcuRMTC3UaTi7qK7CHfRiAGXPLWVeto7tCMaszUAE1v	127
9254	2vaaE6i9KHcEVvFnGBConWmmYTjr4kFq7GZxUGgE7u4YqAYJ55nc	127
9257	2vbz3ytWJBXvpESrwhC9tLGkkqscqU6TJFnjy3cXnYi1qRjdqtMB	127
9260	2vbEhTZqeFHsy8GMykmHqSipamDr2nk8rPScrky45yFwxzgVBFqb	127
9266	2vaboh3YU3Ak1XjdDKwCXb2ePPryih51QrTxnwKBNt6QkJUPwtnP	127
9272	2vb9yT3tHxqv5inF1gfr3gDzQvifCELACqzASTUyJtfa8zSWUeXn	127
9275	2vb1RZCPrVe7HwTCdtbyWsr1SzemkGKDrQcxQqckUAJH57mTrJZS	127
9277	2vaTjo1fAMrsiwiKB8M86fegcn4yfQK62rScp1wcZQWMn8krqmVw	127
9282	2vadYTAWFdkj6Jv1tnDbLFA7nMCmg7GY7rC8t2R5NaCrzxrqrasQ	127
9284	2vaCtGmRm1WGaT6uAXtzhYshhXv6oBpDNrrdseggmzHaonaLjiiy	127
9249	2vbZrkWB9icXabpLyZo3tFMnEFrcnLJoRjo5m4JFz3m2Z5KJctKp	127
9252	2vc5C3W8sBzaJeENyXtW8RwmwP4b9ASaXnQemePeUb5y8nZ2oqBK	127
9256	2vaBW2bxF9NqesouacdjB9sgU4jhVNGgUX71mG6125iH5pCEnY4y	127
9258	2vbUa5dyXze7jgiDMKFADMYY1fEdj7sG77Cjm9N6g9yAwrjd6QeM	127
9263	2vbdeV1uYqEe5R5E1X5v75eAdaxAd5NiUmqjJPDj3BkgbUkfDMge	127
9265	2vb7SNVz4jW5wgfDereLEy5ttTZ3ce95g7o6tkgKZPfb8Czz6HWu	127
9268	2vaaSZgSdEYQ5zvLJUUFmzbkUe2rGFpGRMuDoeTstZiSquvMZMLx	127
9270	2vaL4buUYovxABZ7Fg56ggMXsrFkNcWx4oRrhzGGZ7CmunrCWWmT	127
9273	2vb57SqWAmez7xnuj54yDXCWTqvXZ9Z7yqzXbJyhgyNWDDKnUZ79	127
9279	2vb5yKzuZUkZUhUAgYq9QDpSnVpER5CMjtJiFEzXgu4B4BsaRPqm	127
9280	2vc5BB3t8YzGPfYjSEQ2y7Q9G4n5PK1w7pJVcCC7ZDFxo2HqALhE	127
9283	2vbDqmZhdFjtCnqud24gxeL89BzurSBy4pAwobBbkiL7XTa9pvk7	127
9288	2vaSKeSe6cxLAsFf3yBEC9u3PRGAhohe8G6WuXowNY7Hr1epuUJw	127
9289	2vbqpUoGiWBoKeU9ASfqFWWG1RMgYhTZtdgjDrysh4xer36GPhyA	127
9290	2vbGeKCPcFDzD8mjHwHsA8a7ziA26s6wC9MX4RKCbndXqxPReFYT	127
9291	2vbvBi9qK8oSQyHBcGvYQrKfCD9TVGSukfqbwWGvByAkrqTnVgA4	127
9292	2varH8r9npo6DgoCKUAjpnqRMkNJyYYi7w6N28tjr1eQePcbi92P	127
9293	2vatrxmVnmQ6WkrYU9B94D8mJ151cEb4fY8GL5BcnGMriWKgaxrz	127
9294	2vbjqHQ5LQ2TszVm7N7Y21RaixMaDsTgBdjbC9LH9wNbcqTeYUaR	127
9295	2vaJse1FTA4WLfi3ywT19YdmQ6cc8a8WaC62mUmtHfjJ75TN2nNy	127
9296	2vaV2KR4H7LGHRpxeDzqCPtDy7ZBxTfvyxSEgjDDDGFkAJoLMgQq	127
9297	2vbKT4AvKWSk58QvUqd7tTtyjZy6DeJ6BJus8knPCMCh35VSHjPM	127
9298	2vaJJHbstYDHrkeVTkH7M3iykWcv9opP68qUseCjTsd1c9Pf6vLB	127
9299	2vbyFmS7EoqAvAMCc1b2sazRGioGnY29royNAk2xWNXKTKuA2yxJ	127
9300	2vbNx4tNmqSNV997u7L9P1FmhXvSTnbmJAWEnsgpNAqFybsr7bnC	127
9301	2vaY5pzopjxSCMmwkwgxcNSQFSnWyvJot2J6EoQhwqpDvwrCNbNY	127
9302	2vb6Ug76RXX2AqMtMrEEgZ3rLLzV9D4UFepYWscAEGME8jvC2VH6	127
9303	2vbRxXm9opVQE9BfM4XH31bZUoNTjtBzDdDVW8dWLussvZfzVVG5	127
9304	2vb9FWpidSZ4UuDm7wtUjjBAoENz3GQ8S6Z3Th2v38DYjmoAH216	127
9305	2vbEWmoTmsMbMbV6Md2umjgbHAgCo4JNayHH3S8eBKWU43Q7GNmw	127
9306	2vaWwZrYgLHhKtFRGFK99Fzxsp5tbV83SyYn1WmJc2V5cJHz9cDT	127
9307	2vbRtpqu2idx4kENEdBLqBQEZfb2kdmmZj8bMYJh1xkkEu4jHeis	127
9308	2vbKgWmK5ZwfDuuQdHbLGKjqDEHG9GiXTXGeEqwYUchuBq5nAvxA	127
9309	2vbxP9n4WUKDrK4TeAtu4phvSU8nRP7TS5S4pmW2GzJcN3vEdJpm	127
9310	2vbYM2FyYmEQng8NN5r2cyELqFoTF2kiXzDF9gxWQpjGxNgor9z7	127
9311	2vbtw1yBijL7rJPdQTXAnrcby8jjqK62jAKSrkuS2rDHkJ3R7way	127
9312	2vavJ52LrvXm8JohQSY2i1Uwya7jk9nZPqUBrhnMiZpBr8QWbaFC	127
9313	2vbmnDAPdPx3R2ssRy8AJJGLio7Edh94EJYipaMB8ktUAYS9uHhs	127
9314	2vaiaC6JwhumwyqCe456FWTLQyqJo24X2FeQs5LrYVtekdXVhtZY	127
9315	2vawoxYiyjDWte7dYqi74zJvMrBZyVcJgjXfhj42JmDgeYFaWcjm	127
9316	2vaLaNiZgC6R2WxN4RtGvXN8XnqrT1z3gi3e2tFn4r4b8TrziAQ1	127
9317	2vbpYLpMfjFrhgbSsQxnytNNqy2UVqFf5aAHa9L7QcWHMEc6x4CP	127
9318	2vbwgU8UyNqE5pMCepQLbaXcRJrH351UTbVUdaHUuUaQsYYMufAC	127
9319	2vaP2yZftDcs2F3jnkVkwdCgPuufnSaqD1XRsvLmNa4qvCjv7XNC	127
9320	2vbMJXdRneuFK9N64S5nm9ck89MhGrrEw2dpzCFDwQ6sVTdxkUUN	127
9321	2vbYGS5tVjqLGRd49Qnp25Qc78pAn6WUqoMo8jEYMm4vXviUZbaG	127
9322	2vc2dUtzrqaVi2AwPK5WM8b1SJHd9pn3dgtEd3n6v9jKLWt75Sv8	127
9323	2vayT39jD7Lg7EqTsh8g5V2dpFwLzKKfNyERArE4boK3i77BjXRd	127
9324	2vawq2M4YK7kZ6L9DmCtnAFfAAi7E7fUZLpwMM2z69gEixZ6vh8K	127
9325	2vbNGVNaBAk3pvnv6LevPDt47sreqWdXcjT83NgLtfqPjf7zRBmi	127
9326	2vc3HC2RoskUE4S5i4v5C5dweyZ3aaP8wbEqRg5Qu7D6gqGwLdVb	127
9327	2vaPXcQwR1k4up7cc7Y19kaHcYZASG91ZEVUb2Wa4GxAUmyf9JGL	127
9328	2vaZ5E7etHY6vQjVHWYELZazgTYTVpoxY1UyPRzMmLwYFdKbBSEG	127
9329	2vax31bVE7b5g5ob7SxT3PLqG1j4Q41xiJJzcBGQP5jF25Ar7JXz	127
9330	2vaaADpdSJALEiXzZxdVSarG7GtXLPiy8zrvjanXP1w3apmxDoKr	127
9331	2vbJJn7YCJv9djNHVbryFPwHhMwZRAbcMbcqs2Q6mzv4sL6CG2bg	127
9332	2vaNUJ7hhHRzwZbdcR2XVMBcnnVVV3pSyySHhmL6pHnXE1jo3M3S	127
9333	2vbG6EPhyXt5o9z1RVkMtSYEq7F1KuRUB6cv3yF8v7DH2nYgZyr9	127
9334	2vbYHKWn9bHMs8yAzZZ2V45gfbGyKWTusbwqrCnvoeuDHMF6c8Bg	127
9335	2vbtqvQjUXVFUSz8ezRNrD6FjY8bMiMPYtyPKQ5zxDWmN4EsmbsP	127
9336	2vaLQWcF6SWJCTrSqnCb8JZL4EzZmP9bnPs8TZzZax1vYHkjRxRU	127
9337	2vb1Rg9s98cG6nxNj3X1H8D1T1qenm9BUenpTfHbMSuKcNPkWubB	127
9338	2vapu8syCJYwTAiHd7o23qdubT884PBYoB45cispc1cudrffBgw2	127
9339	2vbr4aYG9rW7k2NfEEPGC19pPNvJoxLs4m4exSjzoz1yceXgB7fj	127
9340	2vacJm2kwb9HaK4UGXNfEWwsQ72SGyJ3upsXog7mnv8a9CvGUo4A	127
9341	2vbV1AfPiZaDjYubQQH4uL4gXVubyh3NpCv4G8GgFaVikmno5Z6d	127
9342	2vbGqAzTQjxHjWdQzvSUDEABVyY5BZbnQzzus2r9eYkFBGYKZ6zZ	127
9343	2vbaHkcXhogvicmyfuP5LphxS2rnTresYbmeRiboRcbZXpcxLR9M	127
9344	2vaMEByxaGUmCkz4dcdPShpkVHkPqbH5ADgr6okAF5NxupPR5KRQ	127
9345	2vbjVMxX4GCrX2d58hNepeGuCTHvU2fZTqga91pZY1afs7sdEGcB	127
9346	2vaxbNYZDFKSEWhEgUefQ9UDvRuSpPHbxnh5AETGKZLiyMaZCtj6	127
9347	2vaoBSWogkKGkibL94DD6JcDHnLKY38BfWfWoivc52Z1Kz111xJR	127
9348	2vadfz57hwybQ9ewkR3LqB3VAgPLwAKNMFAGFYvb1JvosFYddEJg	127
9349	2vc4F2K2GwLqRYwymJ2qTqaH1E6wMEGYGmE3XbxjnhyXJd3gTMob	127
9350	2vb7o2JhG7GgWaZGbbPEjUDpMZM2xVLz1QV1UD4z9N4uSgDGtv9J	127
9351	2vbQ5QRtQ3ymAjGhvT7Nh3ahaqXcokapfkQ5tSjJJiSgJNh4WuA8	127
9352	2vba4BRHpamWvLudvyT5CSd2otkYABJyadim77gB3iF115fHFz3f	127
9353	2vbPmuK1n4mjQjJwRF72x3Ky1wzXGGUGPb7oMzaR4AnPyKVCQ84s	127
9354	2vaLdeyP85y7DB9g61VBR3GVctBCp4XcNhSrKp2w15RzVumYeZFa	127
9355	2vbPjKvcZRdPW9cyz25STCxMirFb84jhSA515N2uc45kQeoDg4qa	127
9356	2vaMAUwJXqTX2ZpBfNhgxhATHyaGgPBGUitU4PqDme7LRiKotMPy	127
9357	2vaAeV28S5engDVw9xNXKCX1pYVYQHVLAUXPPsvYwkwM2gAyi1Qy	127
9358	2vaHZbdcqes2Krx613FaQ998oxFToZ8PLgKTEtpJ9QqETHL3RRPo	127
9359	2vb7H46aMAp3yJRtFmTWjP37h6dwFzPFSwXvQD8iVL7t7xdyEzaU	127
9360	2vahMi9vUcBZEt3ybtZPN5iTShQiUnPERvf3Y1ogAS9HRwb4af3N	127
9361	2vbtHaBxwMje3TYXR4znx1awECpJidSMMoy87UtytyCtx8ifWaGt	127
9362	2vazetRAkfrCSuUr1Cpg83m9gzdxMC5eK4oj34GMjkvn2St1MxEw	127
9363	2vaMUxLX7jRckHic6TwmBecT14LLDhTRkDmM1Tghd3EyVP6QjWuH	127
9364	2vbEKW3ynfLrQFkT19PYfAQKxFYaHgb5ir3K1mT2bsEeFhPsZRj6	127
9367	2vaiWDjUxEs5kj7LJw7LHXLvnmo4u6eumvMERB9fb9LHYLd6DGCx	127
9370	2vbkmNPRYSJvwVh8yBPV8b6E25irf1dD5e7DjjVb2DDt6XEPWwRV	127
9375	2vaiT6wGHYp1iaUufpSDVtc4UhDcQWCEZRmAaCGaE7Dr8oDRL6ch	127
9383	2vaGjzuRxcMyVWiUyFsHqDswwd6a5mkqGq38okE6XLwi4yXVShZm	127
9385	2vaVvjCeKmV8DADv7U4yVERNMK4qnatkNkgVRXBYG2G8ocx2Gg7B	127
9398	2vb6sSeP6jTbxeZgYGpHdna2pWaJw4vf3owvdwhSD2pGbH9fYJ5C	127
9403	2vbXDuwbFLKAcGQhi6hy7cyRC6TKjtiW2DwvqxpT1RoGhKTdZNZx	127
9407	2vaCjHFvnR4VghQgUfvHi6D8fuybZqCk6rA3SHwTtf5F2tqN5VNJ	127
9412	2vaUUj4Ggu6LFFGJTq41wksLek2QNfkVdtS9Fji6jDwjyCp3ad12	127
9414	2vbgc7U74kL7ApTuq6A9Q3ajtX9yFxfUj9PPgumTyMSwBmM4AdvW	127
9419	2vbTmr3h14tSb5BCXrgm34tYCf64h4wjM8kCRAeMCbE9LtoDYgpW	127
9425	2vbLVSSJ9AsTBzPKzgB2GpL7GP5uHJpyEpxESVfxKGGBxPrS2Smo	127
9427	2vbuxeTsX4BSD8EfgfS2ovL7Mxo57x3RtN99T6eo5hZAT8mtQ9rF	127
9432	2vaTxafWcfwnYYHp4DQY4soSb2hLmyKR5YMaW42tyrKBgSf3J9UT	127
9435	2vbSZoij8sjWjCHBRmcPjHkwbwXgCeFGj9znNorWrN3HtDDFQK7E	127
9437	2vbA8aGtBCBCBpbzDnjVe1syQE8JJ6BePiwmEnP7q1DZaMdcPNLM	127
9438	2vbk3udU16hLDPzVUZDkzcLJ9PuFia7rNAp5sRwDWRtxeJdzehVo	127
9441	2vaMAvtVhoXpY7tBUyDRwAqMsS26r9Y2byYyAbiat2hjysmnXJg9	127
9446	2vaa9j6q5Jbf4xP3MnkxXt7AsbHTcjS5DEpoA3vtHLqDf6673BnN	127
9447	2vbygT75YHy4jDefBDkZEDGbATxZSEabYdR6WsQajeAb5ZBP3KUk	127
9453	2vamPCveuEFi7sjaquMrLbsUkx189qRAUZWK8AvoNXgyrnYu6TV7	127
9458	2vbLxQXDCneULSTCVLq12CXpUDijELiQSS3Thqv7hFEso3x4UeQL	127
9461	2vat3ViWkgWh8PH8zZP5PaXAj5KNzp4CT7dAaer68Jom7pNJS85q	127
9464	2vaQAUhG9icgj2LL6bR9PnRV9apXPHeEX8XnFAJcDYsH19gT78Fx	127
9467	2vaXZWsZ14zYfdk7ZLPjKqfGyGtaofN94G1g4f3TDSibS13sNCzh	127
9470	2vbFVohgHJkYYinHDsrmxr1mbhqQ82a9oGFChgmm86vyLBfr1xvz	127
9475	2vb1SX17X9AUvLo1EWaW5M1hz2GSLXEWX5pcnFxWJo3y74Bzv46z	127
9480	2vaJxwPRLfidFnphARxXRD6vQQesJ6uR9AHqANGciTGaQrR2Vdtf	127
9483	2vbf8uMtWhVeS4q98pKJGH3dTG9AoEkZN8YtyGcu4Ws2W3U6Gr5m	127
9486	2vbeJgW8dUy4tfiPshuzoDaaKQFQmButXWQfZfHKuVEdXPr8Gcek	127
9488	2vaDL1cf6hdp3BpNTVzmnrBVW5TQNth6FyYdmBDmjMknpGJmdXHM	127
9491	2vbpQXv3QHREFRjhtR4Pagh5RaGNTBPy51jmhXTT83CBjG2SgsBJ	127
9493	2vbFbmgFeF3HeC7zp7Yg5ukFhBjAFVx7oLa6ruKyx8CgJrttXbMA	127
9496	2vbVrh2wCVHGR1diBDvSDDpgcq9a1trkxNKs4J2FMeagRybyCyLi	127
9499	2vaHNZj6PwmNdrsR7ZxUy5d6UzMcL4bUy2tHctRbYDMSaJ8271t3	127
9504	2vb34xM1KKtTyjwYpz4jNDLW6D3F1QRxSmrdSYhKyZQzzpb3XLEK	127
9508	2vaovCZEu3e6x9Zhi87mCTNUJfZJ4LJ9fQsQHzqhD4jAHFuiithA	127
9512	2vbm4J5zqSnZxfP4VQ2J7Qf4s9uVgqLqGEfJp1rassMMGvxjstUq	127
9514	2vc3UVscA87xp6TEbz65CtxJSCPtJFnTRV8NKskufistwHVE8j6v	127
9516	2vbNK6vRx1SjpCXhYfrffAPjgn3bufk9Mfhw6mkUE8pQBgg2wHB9	127
9520	2vaREgyuipDrbFYW1nLDHVurV6aiTWWFWt6jrwPmE7h4mVK2W2h8	127
9525	2vbq62wupGe2vCcpupUWPnKNfEDP4QWs148BKEqoXS9GxksJdSk7	127
9534	2vb8YzqiaSwhMtu3j12gLUHWeZsu1BTYNjK5QCnd6xHALdMnYRTu	127
9538	2varwSGCp4PywDynxrjiXabnFEX57gmbw7ePC9XyTkejnPAgb1gr	127
9542	2vaxhMFw9nxMBFYzVJk3AqwC6Pi1dXYiLqqWy2DnJ3TXL1KhMPZf	127
9545	2vaQHCWENKqQhKdraAq4eyJxi2vA3jRFpZpiaH1ZJceFMggCxp7C	127
9551	2vahaT3fMe1eH1h34XUQNmjcuZdVUKBz3mKbMtna27n96dtueEVc	127
9562	2vaerc8rD5GXpeU2uyowwZkzwhCmxCgdjjFbdQCLqmiFZtTDrpWv	127
9567	2vb6wfuzAYBZ1nkuLJ1gW3HvRy5WLA5AZujhPfvdemwYj4Gr8oXk	127
9569	2vbyoAv1oQyZ95zUMDEZz6RjL4t9EpsHtkYr7J5sEYXU17tRE8X9	127
9574	2vaSZkknNc1Q1D3B7HvAt9iiQHs1ey1UCTiSL1K8Vym7BXZrNP2U	127
9578	2vbwT8ytbmqKb6Zv1Cew33VqKDTVbNqvJLJLWEK3w722UPXdxVej	127
9581	2vbdk1EkZ88kqcx6w4NyrNaEZGW5Mw6ioh1V9AACtGYsjQFTs4cz	127
9584	2vb8YpxPXpoEGGeoGZ3eyNyELxgseUBjs7g2DeuFfF7TAMdGwWPs	127
9589	2vaHfoaz87LwUWBEXcQBUHcLDpEtHeh7W6ReSYFGnRaxMJHu5byg	127
9592	2vakid6qypW1xk2CdVPEXP1pQHkHZy6UMSSBg5gUjdbYD4hYEbxq	127
9596	2vaQ5SL2LDMYemP8ediFHRMx3da3PDcNFZZUdXnkFKP2PAjYUpAk	127
9601	2vbEJUEsVXiYnEontyAXe8ghe8ZZGx18ks5DjJHrh1HTd5F2fPcM	127
9603	2vaTJCag7nxChrp8zCd2egfYt9BVUp9aPf4EcWgLfkr9bbMnPwFG	127
9609	2vbZtseWMUsM1Gwiq5qwZHU5dB77kYYSrrU2yQoZuZyBtfYsAvvZ	127
9618	2vaqhEHg52MaUULf86aUNzjtqPcKWeywupTP3BfMs3C3bsbpuSQh	127
9620	2vbGmuBvHuusaUqdxPNxkBazrPM4eVgHoHcENzzoxyXnT6VvvSEm	127
9623	2vaEjvPZ6cDC4p6EXiKxsxYUYzi2JFp4ai7vnjVuH7xv4tSGVmQr	127
9626	2vc3JQ4GEhEkNuKyDgzDZycHb4V6WRWrv8MNmffveoaCHXRfPCeQ	127
9629	2vaerTS2nD5j79Z1hqU5UZwoy4JkurAHFjEhgXdQF7qBdn3g5JhH	127
9632	2vbohrYPwd7JPbexbo4SziGKV7CN4smXnBSSfU4NfRyrEh9TmZbU	127
9637	2vbFm4e11DL6tnuqMYgr1DK4q1Yup9PztKR8rYx4NbVA2CPkjLjd	127
9642	2vaSxCjp3HXnSTpcWcazMLFQz1PjnURNEMHXe9VuZbpouQKEnzkV	127
9644	2vc2x69xgtHEVrzrDNkTf5rvoRUgazzjtTnLvquLTmPv7FofRzZr	127
9646	2vbQ1K46cdUZi5mptyBtNZFYxWRKqX7oQh9tk9fm8jhK8TV5C74e	127
9651	2vbXGTq5MJiCkEzjChRthCywmvRbAvzfKzpB3wfsXELMotXYxM6T	127
9660	2vbi3dnCsrsjm8jnpd71nvrQxrcrrAXv78pQ7faJaoz3rfWZQWQ1	127
9663	2vayzyrHaHVKYtkU1qze3zvWm5VFyWLvypLSt8Rrxvt6djk51Rf2	127
9669	2vbp2vD1ejhbpVwp3DK6xEQCDJBFpuULZGLWg39x6LDr2VYS4mxu	127
9670	2vad6swM7bCF37nkixS1j1qLFdBArgdZKgzwR8DSL5vj7sh2dgBP	127
9673	2vaHvtufmo4oUCo4fbrc3fPSYpzSeAFw47WnpoCP8ZkkAv6yVHKN	127
9680	2vbga8qfqTsB9PJStKxMYap1wu5hdnLHQUbbzGK6jWTDBbVArmn7	127
9682	2vbnewSA7Eg83CXwnVCt2xXGPuQTTzQBc77qFEbMEWxZjioRLWMq	127
9686	2vbYkw4oNyoZWVUekXN68d3DK2E3bZRuF7bpuaScVZVf2QeYNbm2	127
9690	2vaep44LwDNEJzxmhoh3svFpgfWMhLQEyL4dVXf8xYSCdbqx69d3	127
9691	2vaHwLbRoH2Xw2aNceCj4QzPeobmUeStuevEu46VbrRYpoxxjG1h	127
9694	2vbdDxTbi6ksq4r6SrcGpnWtd685ViX39RLNTBsz8c18yqH5es5z	127
9700	2vbPrRZp8G5UK7kAeQB7GS37bjTbBErQPRaaQ5axsY94AqpMVZTx	127
9709	2vb1Xsfcxe6gJsgBybTe36L2ZoSJpVPeDVbo5h77VhEgLAYUfxkD	127
9712	2vc53cfKeMoCT4eEqewSH8BXYz5Brg1PqTp4yBaNXH1x84hoMs4c	127
9715	2vagRAE7TZjSYaw8RcbZqaFBwrWwgZCUH3gpubXf8KyMjFR9iQ2B	127
9719	2vbhiPpe1R8QMUsQE4pCjHFme7LGiuirGKZui93TzkY5T4ANoYkR	127
9365	2vbDMkoL1xrFQpbCTo7N7GECa8nnRgFJQjfd4c2z5uXSJoMHCo8v	127
9368	2vaExCwyKxM6UhyLXyphMpCfebZ3Tt6vX1QczKww5i4aFecFRsGp	127
9371	2vaPmexon5bztJwNzhbP2dLjSgFXNdKc9cezG484hDWC5dcTFdPc	127
9373	2vbzt11mb1kAukWsG2T7QokbwsReu1DXqXUCnU84Y3BQoaFqbS6u	127
9376	2vawjjrPjtvtr5bJRNoKx68D29Td4ndEBY6W2iVWFLnc2as6yNTt	127
9381	2vbxWERDxzmM1V5Hj4v9boBGUp14C38AGHNYAH2ygbzxTSt4QNts	127
9388	2vbT9J2c3KzQsMaChhw5AtnzNpywc8tZinxnfCWKHvVioCHKrEEn	127
9389	2vbiZB6KE5X17L3tfemoNJEJmTpfCaTAvRKkdwD51nEaidXM5ZEZ	127
9394	2vbZnds2C9won8f4UwRD45jXUuvr1pWcqjFocmgRigoJrkPVVy1q	127
9395	2vaDdyLZPEoouwkUbm3fmsKv2gxK377sd7nRjd7Subf38jxNbGAp	127
9401	2vazkLXNL5eETxYuU3XYVTWfJZESvC9NmpcHa5t8vJyacsnHb7Uq	127
9404	2vakeWGrcyyA4vxHAcfjgnt76W7nWR5crJqH2F3KKSobXcYdCeGt	127
9409	2vbaBcbEN8CRC6uVFpBSW458hNw2CrUtGQ63z4s5WVxLfAVcTtqP	127
9415	2vc5fWqvSMfeaar3HW27AJEp9behsAQgYDzL8m4Qv1FH643mML9G	127
9417	2vaGBPmJp8EUH5dZSECnfsUQ6KhvaRDwC5giv4YsekhyzBMQze5D	127
9423	2vbYudySSsihtrKe1PJo79wY78RJ8QmRbJKrTSSAHEXZ1B9oAfWL	127
9428	2vb7ePkq7S7xtLpRmhRTveryeQWCDPSvT6BBXSJ7TLAY7av2mrDF	127
9436	2vaHRmtEW2GNBYmTS3rqkJVM2rwhegUYYyShPnCVJJEwTPrQFUDt	127
9442	2vbixBbAa9H19uzJQ6Qpj5f2PTHKgjAYUo8iev6C6d67P2E8gE92	127
9443	2vajHgzccDzLqmrvNyMw98y28Np66vCVdDkfmuBuuNNbMin5HREA	127
9448	2vaq3aR9gdqbKg8cyUuS6uvvX8DDNiaLXi9KvzBvrcxxweD4wAMk	127
9454	2vaBy29LB5KsEKmFMYQZ93sc1YZeT3jEgYb9JcXjLwPba2jaoLMK	127
9456	2vbUshj1KcwvDRW9M495iS4gv4iEuwzRj8DUdtyPEhBs6ebfmWbS	127
9465	2vbLpKhZTgaKZy8qhTgPJ7raAZZFYvryMqwQFPs2gxi8w9beJSYU	127
9472	2vao7GhiXSi798mzN5FMWhM8QfsBf3PZ8bAjFvhrHkCye8aPdBHV	127
9477	2vaFcmTBQNxYKu4tTAwEwrRJiLot1oYBfdkh2G2gE9PePGLqBfqQ	127
9481	2vaN3ukucVm29g6k7D38G4xHGPr5BrqvJa6pACFQr3w2veNQBVir	127
9484	2vbyNXpCY7zLToFZYiRvf2eh5gDWnBYdBdp5azmKkhL1Pt6SnuDc	127
9489	2vaCpY6iZVQL5ZRvBB2SmDjgdRK5G6AebgiWLa28KJFX3EJvz3nQ	127
9497	2vaaXt8fptD8wZ8Hdqxp7MLRzS3sNa1LbgX1TRW2bmt6DUTJTzD9	127
9505	2vbz4muoLE91HunvJKavT9siXPfNY9uDU3NdKyWLMqMM8YQqHFqC	127
9510	2vaXBJ5xRHX1KNDetiQW1ZvKTfQNdTMjSvrmwQSJsVUCkukbAugH	127
9517	2vbgXFUxVRFNWz531mzhp9WX5eFBoCavk7B8FMthXx6KQUcz2Swy	127
9523	2vaBWPJ84MidQUuS5KsTpPcp3wMwK5iGjrVbsXq2ZXWyBFSpwGym	127
9526	2vaJisnDaEmyLskQgVCFcp8N22pL5buruWbxUsJUc8bF3hJHdMWh	127
9527	2vbRFWNNToi3pkYX7a5GMKJPcKSkiXrAdTn2giKCCxjuRKnLvNvL	127
9530	2vb2w1LQCXZeWHNtc2BBd2ezD6if4tNHSFy7ZSunUHoirPZ3ty3u	127
9535	2vbobrz6WHkk4dync4XLLRmcdEYPqWogzoGif7YYcr7V6Z8Mc2tV	127
9539	2vaR1ukLR54vcm5shG2cv8TDj1r3CW6jrgnTrKMTLvYQF2WvQYNR	127
9540	2vbMQ1Rzm4jjY2WEq7RspEiZFutjpavHasn6KwnAvykmkj5hijyb	127
9543	2vaeSqqXjfdcugy6mJU9jtsXefwgcwkqpdKgj3Sxe5YXeRH4bpMU	127
9546	2vbLCXX1DyK8gRxUZEqDMJcmS9rbGHCcYrs8dEJyuVQT5NUCqSKj	127
9549	2vbPDViE1tmZe4sbRbi57xkg6JZbCGStgWjCSVJHqyZFem4EMFbh	127
9554	2vbDUHrDU7rMkfU5RL9i4GZrSSKCiEGeqtQGA9obhCh2qk1L5E5D	127
9557	2vbtspGHojVZXbH1UbJArr466259785TYQV4gvCVT79yjhUywtGU	127
9560	2vc1qfbi1b4tq9FKmRK8kfZibAJcFiQ5PdDKCXizBHJ24kMWPfq7	127
9563	2vacJCSsFJNKaRoAg6XVi8vJHGP6jK3yFaHzZojQz4HEqn3fXKMe	127
9565	2vb5QQWKpYMkLDbsCXcd8fVVgY9oksN9wdMmbtLB5Axd1ezGCoAX	127
9572	2vbN4ghVbHrYCCzTSkysUUL79JAnfWrUeoajs96ihPHWLHeJmL21	127
9575	2vb2QYSbLqC4CmoiuxznUBKaSBc9caKm5ZvqFgfoDLouP23vmY6B	127
9579	2vatoUC9CwMjvvRtPhcNHvBqzaSSCEUUD3JSokGxPjjw4ZfiyHt6	127
9582	2vaCQkK1gBi7UteeBzfRwvUcZDwfiU9QRfvfGJG36jk8BFPMHHmH	127
9587	2vaS3iu83wpMoBZ4M6Uy5TirBrjYridWJ5BtnWnqYLYHmZ6EBVrG	127
9593	2vamyK1qa7cCmWbUCAbfqQaMLWSq7LQS455FjfiDorrbW6hj3LBL	127
9605	2vatdjdyojKwbGjB8qARcjeVmH7sVNkP3oxtQqmtgNNC9WjvFZVN	127
9611	2vb3sWUHKDHVwDMh1zQ6Bnnig6cMzozZr9QKM4R2idzKW18ppt2U	127
9615	2vbRed5jcAvSNZjSLy93JBueVJ9eUnjdxh7SEyHW8v9Fk1F4NLv4	127
9627	2vbq3euBbHCpELCJvbGURPRShJ1ZHb9D3pgGJthS5rWr5cpbgUjN	127
9630	2vbK2V3h81PiYQaQ5RQuuQCN2fxTJRbZ3YWfdwa6evnVXbTvR7DA	127
9635	2vaA76a7xQ9S8dREzTd4eQLHdcrjxyYJ62Sw8N9Z6HU7vh59zhFi	127
9647	2vbyP7TSH8hGv7soCx6X8XwtxQA6EQh55Arn3cuh6JKGUqNjicha	127
9649	2vbAUsTDNV85rcoKh7cMpsgBj4y91CyDmxVihMxsMkutsvinC9be	127
9652	2vbDPKgQbKCCPDf4ecb5HpLFwR2hjh3SSxmYfiT4eNjdMRNm5Mk9	127
9654	2vb5KyRv24hJtXxsVoiku1gXW9MCczBbcBM8jzu2CEN95sELrckv	127
9666	2vaN7LqZ67Gtfos93UjgsuVbLrdMn6K75pQuZHFVgpL129evzxAw	127
9675	2vaEJyiTCW7CXUTTshnK9SgfRUJLVrqp2tY5Cb56vCdyu8pMBc3D	127
9677	2vb3i9N9jkM5NBqDwRak2mdEriyi4z55MXiuDEuVikvRXuKgfzLd	127
9678	2vbQeUvf2sNCMrU3693N2zvJqiBxZrMEma5w2NTCUwqgURmqDXYM	127
9681	2vbVRpkFMkjRGRy69mxvDCSnmKRhiT6TmSzkgbfZEqKofLLbLUSN	127
9683	2vbHhUNcndRbyLWBLrMWYhga3Bh9FZyX3grcZCUVTWSxECuQeJcj	127
9689	2vaFcn3tfmkRbuXGSd8E4QHZYNsYKrG7dRUg6tyyLJirboa5BCHH	127
9695	2vai8rwWwuoMpuUjQWCJu54zfcxKhDxXiFcMRnab3dWrfKn85gSE	127
9698	2vbMRiFriUzsWuRfoJYBt7ht426kNX8AY5zPwHSbtBq5NMwBA7j1	127
9701	2vbLJbsMqeUQWpVuQ4eCgs83Hz71vGcFhFRXJ8huh6RkbC95ddh9	127
9703	2vaUMucknZXvxEmQ9HQj1zFK13hH184m2WWgnjBQiLKGRYujTuNw	127
9713	2vbj7jxKNhLzSkEeq2qrRj5ppGkUVMSJeeAZJ8HbcLTrRWcCp1xe	127
9716	2vapQAfsT5EPduEsPkhjjVDZLSANjEtkeBGvbkDngBXNAQ1g1MX5	127
9720	2vaPE7DP94a4ez7c4gavheMerafWejuuu8ruhfgvZAswxykEz9Dn	127
9723	2vbhT12yaZ2s5ujTVZZzCixPqKiePqGszptHf3sM9oAhsqZb3FfW	127
9729	2vbY6vesUp6anS46GZRrBP8Ps5rowQAkMcTtZG37jDkSP6kZybwo	127
9731	2vaWyddPCAHihT5g97fPERmAXe3aJBQvwCUFW6iHDwh6MKMZKTK2	127
9736	2vaiCGkmwBdZh3jtLe2BZLMFMXWo9tu3WiKdH2W3rfYajQDhkhen	127
9749	2vaMHceMgQAub21RQCe7opzrpfFVLVLL1CQLLcV14tptqYwjcnBo	127
9752	2vbcKsDWvUXygwC54LdKj4juyd2A3s2qiKRuRVRpruj9qY8uWBPh	127
9756	2vc5UXo3oW5BxWMxPTZy8zGLGVo1SJjEutaNJrgfG1P3kzGSg8Cx	127
9758	2vbmZg7oSi6AMVBCyLBDL3UByxUfJYLiQ37D1Yq4QLdYtaCCn4TJ	127
9762	2vaiUnmQgsYQBfQ3skz6sEUZYSrGt53AQkFbGRxRfYsQNfLXimwU	127
9766	2vaCarnKQgqCrXeCV2Byme2QWPitnTUKoQt6XRhvp6FUj2BNMqs3	127
9366	2vaJGzCaYW8YyHHUKCszRbuoHWbVULhvWBZu7zaY9cXBwV4291MC	127
9369	2vaaBTyBXt4Mh5V7nKCzixmsbDkxQcu5PnCMoWKzwdKSumSH9pe7	127
9374	2vbMH9uWYr7ZfS1ZX8WugfbrAJ4d15XS8qkiTLUhjSNvLnDsWTEz	127
9377	2vbuCYV48zL4aLef9fKNM99GteN5y3Vp3bmqsrqBN74cipDBfUPv	127
9379	2vadw2qZLQoj5rWJwHSymTPGUSCxkgJFDMtr9sBK9WaBKQSyyM87	127
9380	2vbTHJJbCtx1Xt8FZkNNPYRh8j4y9WPRdMMjiEdLpLYjzQExLxmf	127
9382	2vaa6GmTYHkPiGK3Ub5FMuW1Fj3ZAu6jW6MXRGZRj2pnReUoe4jL	127
9386	2vbuxv5fAeTBJA36hr8xUX5gzSboCvme8HWR3QJ2TijZLmxwN39x	127
9390	2va9osQmE6XcTjkeZEpGnHaPS7EXFrGAeq5q1RwsJnDRhneQoLZE	127
9392	2vaBMMZ988YYHTDC3PVc5pFZEDC14XZ3X9d26yvemaHykfjgdzTn	127
9396	2vaKopbL2YqcUQstrZp2FNDyxLDRUtbW3CNsicMdifdPQ2e6mf1K	127
9402	2vaRrUH4AhuFQ4zNtG7QJt9DwLhg9Xu27cggQwBkscwMmaroxRfi	127
9405	2vbo1VBEyLh49yyq9jfJYbsDgzVCw3eNePPxTy8HUPALNQSU4HEY	127
9410	2vagn1rj7oxirzXVwN53a9GCpQrgnPQQcJaEwcYaJ2jtHhEzoRJP	127
9413	2vaMSkr4eH9pvrJakd4fGk6JfLfxJC9eA5z3oBbX1orG9pUkCbtP	127
9418	2vagS4AdhhH1zpoNBRP3sfa8kV2H9YcZduVD8HjXdKKpKmmz8BCW	127
9420	2vbdWfK82vptnW53GsWEiCkzPC7SWdzhJ1wCxAXwCVByJmduPnkJ	127
9421	2vasG3hUwvGyv4rRrT4Q8hw5aJ49fUsgqXqR7NgopDfD9Mz1te62	127
9424	2vbC6LBxLwx1zFt7gnN9vnJ1TGfb7HGRf4GL4YECD7w5WP4NiqB5	127
9426	2vbqqF5xN9rf2czQ8jumCmhekNZxjsoHj3FUdVsyvgd9RrFEXqJA	127
9429	2vamLrNt1zJriBDcJyfdQ7nwqpEE22LjkGjNSyiLmXvqRcquPwX9	127
9433	2vakZMb7bhqbRH5PHSuA1ZLY5uKsswyQxJrH8vfxc3oEZa1V57c5	127
9439	2vbKHSXeMVuWowsyoE55eFiMsre7Pjx3RvZeYeRrXoTX5v32NXa5	127
9444	2vaaYgw5BzuJip5F3wQm6g4DoxNwYrc7xnL7qKgD74umT89QXvUb	127
9449	2vayyYW8dZCYzHqY2egznPvy3tD3qm32q2EJZdHNAwr46yQbSN9i	127
9451	2vakXAQ3v3t1CQ6MYy94wC7ybqhYqhMPWinrhbjmnuj8k9FB3SHZ	127
9455	2vadfNhZxJEZTPGLqKRSgfTVx6CQ5DpBy1fjMdSjmZyKvRLdhDSW	127
9457	2vbwQdr6brwVESEwuqfuD3pcJP9e4BT8u6xdiP2j16bQvETaaG7F	127
9459	2vaM5dY4YkY9FJbC2RfUAz3ZVhHbzNpLM2fD4BAkANztLiNrPAKB	127
9462	2vb2FSmgPXjzwwUggAoqLJyxhmSaXebeTVpNYFT9iCChhajNPx7P	127
9468	2vbQXQNzKD8qf9kdn5B1gkDFKhEEqh68uniYKEV9WZjtnvCHZcmr	127
9473	2vbpHqpMUvPeQdfMBh2QQwwHzkC63xe33JdTDSxccPjcPjZvYeiM	127
9478	2vbNq6TJrRx9K5DxkuJyHabp1RJZo7mBJDsCcHGtR2TrCqxaCB2d	127
9487	2vaDW27S62qEBCEhD1wmRADudNdRZQkgD2KiBfUcDA7mXTf7KQB5	127
9492	2vaM4gzY75qtPmN98ZfAVXeTTm1StVrBr7h9cwHQqg9uP8hSQZ7B	127
9494	2vc19hG36romwFtYCutenT9qP1v4P1pa5YvoKRHmzawpLqNizZ2Y	127
9498	2vaktnFJsaoFGQ9WP3uHbf1EDRu1o3khguyD5SZ5Qy3SsjWtTX1X	127
9500	2vaYZDAd7VgVdLTmqzHeB7KNxPvuvg1KwGBNL73M8khYgVFszDvV	127
9502	2vaWYG7LqKL2gCZUfAhUTNZXfMoyjXTsr2TgtzNnbC5WSUVmoxy3	127
9511	2vaYeGL3ufsWtDkmQuDLQzavT15J2pphAtPhoqLET4beYruqxK1G	127
9513	2vazskxcqXmf9v8BEokYyyjc1TwEUfP66Ew3ModRgWBoWsyWEid8	127
9515	2vabQ2pwVWHBqK9NEjqRK4ZJ8uj7DkGqYgkKHPRfCi6D9ah5SZo9	127
9521	2vbbUY55pEU6WRk3zr2vPSzXGFJoPcrmrNEWdhF5kdYnKk8QhmuQ	127
9524	2van3CAsvUxykEyvCQS7AEi1F1qh7NTBbgtCFLY132FJ3eM3znNd	127
9528	2vbKzMpfoyf8Em85Lda1buauYF4oyxmhYtdmQmJ75LZSU97MybaG	127
9532	2vbwLD75waeKABLa3PBJNQ29WL6buWGQf5svT44ZVyn9s7xf9XLM	127
9533	2vbeqquUpcCdpGopkWZRqpoh5outn3SkUuuGubmwriKwsTsqUTgr	127
9536	2vaMxEfBxqy87Y44eFqZ7WbkwFabBcw61jtYRtx6aqaXUVTYUW2i	127
9547	2vb48hfr674PmK7j81Msw5qXarMZyMEuTL82Lrw9VJznqygzh7Gq	127
9550	2vbtzcAQjApDECQPqRGBefE6SiSeDxtLNaVco8eY8c82hFbfKeB7	127
9552	2vbLRRBLp8SBhJyTpqAsGKEkhLg9SkEDj2krBf6age8EXHBRaECb	127
9555	2vbEKwKzHG8do1tFB2vDFXpe3VSoPNujZPw1553aQew8ceZByiWg	127
9558	2vbRQUBRwpXD78kza1Vve16iqBYA9fv54eeZereRdrXizQXrsPKF	127
9561	2vaNMqQSzs9FGssxQGMmEf3pjxNMdyWodZERFGB9UryeYo6L8NHt	127
9566	2vakJgw9WFBkBw6LtkghSCjsF3fQX2rDA4kqeGii2wZTbEh9qi65	127
9568	2vaUBzjYQcA2jN27aYdvVhF1CuA1vCRGRPF6qVZj1Q9rXCoQQt1n	127
9570	2vb5ojx93SA7DXB5zjyKEtAPM9Y7JKPNCJBc8DCaAkPDk18YdkvH	127
9577	2vay4yUniAydGPR9jHondhEW3CCCcuXnkpSh21y4NcaZEshhx94c	127
9583	2vb9xa4Cy64DgfZbTeoyUUteiNciNxr3FKSEswf7LxQuPgUJWdvQ	127
9585	2vbZzwk8NmtRyLFhU9AwP5KKnkh5bpQHCScZTinvdnuQGDcm6gYS	127
9588	2vbVhJg2AVVuH8EcLW1DRGtQNoPbYJULnMJy4PX68RVYM5mZMsxD	127
9590	2vbQiBCt9zWj6CU2bEEtwwicV2EKtAheCopKzcmRRmLd59vwgLoc	127
9594	2vc1g7o5Z9rJJkYpbcHjmxA2GxUEJgGn5FLmp6kBD9sQHJLy9kD5	127
9597	2vbdVmG3e3giogkdYDawsfA1Y3CCEgHcC3WD3WLii2UfQJYTppU9	127
9599	2vaZ57swZzj8zK7UbFNnD5LqQR4A9bqrk8dUHusByA7qUjFTfdE4	127
9604	2vbSdvGU9ExEXGaKCMDBYb33Y7KKGTTbHdam2egQ5dfWoFjzDg36	127
9607	2vbmKFTdNC8SSrku2xW7dEdcUjAa23V9SWVoWHitoGDoGyBPN6RQ	127
9612	2vao4jyqVsrfmHVTenX89gB8vHS2qRyTVRbRUWLy3dfJMK4s9Xi3	127
9616	2vbZ3oZVi4VPk3uW5tAkJL3cvRg5ATrgUZoRbJuF2mZ1AxcM1tDc	127
9619	2vc3cDFFQUz2pbkSsF9qKLvwDPvjLyXEaEwK1ByDvFBrwkvAmawX	127
9621	2vaZhevtvL3Kb1kXKQa2Zjdv8LJXNwjAc8m8xezsFBTAMLh4ttJd	127
9624	2vbj6hXLnHEPqFv7KHVN4hZPpXJ7xuBG4QMGg6nTQuJ9DWuAZKFi	127
9633	2vaeAu6se1kSjRLav5Qz1zeevra7XfxDtYuVsPJiJW28dhYQ1S1B	127
9638	2vaer9zhAQDpEwLaLhnf1tynnBJeraB4WhRUxn5mZXkewTjyS72e	127
9640	2vaHrFrLpbNp95WBaEDizJ179kALwxSVp5g6ToU6xmRLcn99uhRF	127
9645	2vavqNJxXd6DjyHKGLXBqMkb47iQZNQS2Fq2mQtv4CyDixcY4ZFW	127
9648	2vbNgxaVLGeiEvw57ijY4WYuLYhYBVU3evTWZYEdSHGLVMNUavNu	127
9650	2vbcGoNizJtRfczMZzUAJHzMtYvT3jjpYWWNNaNkhNQ8XwpiuwZU	127
9653	2vbFX7bzdmPCyxCbYPRSmnfKRFUTrLb7jKtXuyjWHVtBMBza8vC6	127
9655	2vaioVGHvWxxLyhqeRt8yy4gCNaNXxrLBg64S8PmW8deccsU3A9E	127
9656	2vaApAcWxukwJymnJ1THfrLpvhaVTSozF6KsTzNRoGCqDHfCC1UQ	127
9658	2vbXMMwRVrieC9AmNwrt6jrrFgZEq1pQrkz75nVz6g3BewqkSShw	127
9661	2vboRnH3QnUBJjL7eyUjsAbuZ5mrZ7dH62BdVytaiREnAixjX9T4	127
9664	2vbVHf6xXAXqntJ8RKA3rn8MZzDXLwfyfHQUoVEtAJg8CiBbrS4x	127
9667	2vbDJHrJX1PJF769U5QH4nbvQZvtmrfLpgcU8rfuH3dv2Jx34kja	127
9671	2vbDHr4vurE8KtXTsGfHZBKBZcnJP8qp5VqDBtJeuLN4TKVmrgvX	127
9674	2vaS3vpauLAZeGmcsNq9avtSp4Pbn7ufY6FkvWkQf28NQUM37Ko7	127
9676	2vb7KdEjzHUgFJv5zj4RkLyg9Li3pus1otmdg2X4aXzMveyKhNZv	127
9372	2vbFMnBEPAm2kLSYmWz93uTqA9EnEjWZvVHWcpNQjKXNRGVxpJuK	127
9378	2vbUynf6yfCBt7VoEniELEWZPrVJyVeg7SR42FZmbJtfAAEAiEER	127
9384	2vc34wnDRawk3vBEAQ6fwMdN8biuKuK7QdnWz7fU7nEBS8kCdNXm	127
9387	2vbHNGZsVoqhnpHomK51SL6cy9xEPsuSu7dYvDp4rpwRgq2eCNJR	127
9391	2va9EAS9WZmwQJYgjWgPSfsGqmSupT5a5KtfDYrKSv3yRM5zm3A7	127
9393	2vbJceGtpGuZw8VWAEhi9ZCotSc2rntkteCgQnoMTFDTDKn8AYnS	127
9397	2vb3yyNTXSbu9KS52hvUMBkoSzgXb3GsGhG7Q5WPPCyKXZWTHUQU	127
9399	2vbw4LfLL7dtwranTF37ASK8KGagfkTqbBMfnKNsWXH5EwamsAR1	127
9400	2vbfgNSAmUfdbvM5QV3fZgLnDWYiU1JVMV83X5H6xpxA8HK73Nmz	127
9406	2vaAMAFPD5o4d5ivYU28zKMnxoFZ8L22vJLcvjgkzqPGMwSAedEw	127
9408	2vbQ7uztiq5EpUAk4KAj8v2x5BPBv3oQYmEmXhJWHES6Gg9qVTtP	127
9411	2vbCK5QJdJyyrfRQkdRBZXSZmUoc3QEKxnPFwzMF6jfxpYfZtVno	127
9416	2vamMuxKr2eXBz5RQZaiFGcWLpzXmct2zfzdkN1hEAZmNk5T5rpM	127
9422	2vbxMqm4QXNDWK7PNUMmsUVvmMs3AVvHruauRxyXz3GbDp3qz7SW	127
9430	2vbsMx6YCG53Ghc31t4oZuk4vroBfUJAwY6jxFAnhRD8u8KrJkS2	127
9431	2vbH4Z5zAUtbANwJYz62hiDjNSphbAYbneFLheCyWuApsk81nZhy	127
9434	2vb52adddAHJxgKLJnZ9ZH7EcuHcn1M9zFRksYnXjycETH7h5AMj	127
9440	2vb1Y5jk2QkyQJmgtLMrf2iV6UydvZGHqs2dwnMck8J2J53MfvHv	127
9445	2vak2rokpY4GvnqwdVmRi5qjdXX8sSADdsZUa4fX2RGXCQpABFJQ	127
9450	2vaNayvHFvYqWk4Gk4bxyBEoJnWqcZVYK3GEG35xkjy4pjiMewok	127
9452	2vbh23NYcgMkJ5HfH67hSW46En93BtDAG5n7TUY5Qe8U3uquhfzZ	127
9460	2vbSd9ByNW2Q5XtgBEyrSq9mVbeEoWhSFqvmjnaqbh3ZpPi66rxh	127
9463	2vbsmzWWdkxPdYhshGttsgUM3A4LUMnHnKJhoDDCxcHwCYVDNUBK	127
9466	2vaFfgffcunKZxJLLxXtsNHmBJ1BiM4u5a5mSaA3i4wSTjMNZaJa	127
9469	2vach1Tp5KFR931D2UUQnhKPVdYLovu2LFkn4DvvRP5fJN9QuDQh	127
9471	2vbEPHSUtwGo1cSaDZ2atEVvBAoVLsoeuVgS5XbWXKJUQZULAxXo	127
9474	2vbTpvDDQSNMEEnXSaKkhNXSwQQLSna6WtcWfxAZ1mss4JFm3q5E	127
9476	2vau49M2CFAE8Bfqkjeov9FtYi2FVGP1XFrTxUZ9CfWmr9de8NqS	127
9479	2vaKN2ENiBZQNq8AcLfHLeRwhU7gf6hPcBQ4mdmbX3D77uD2kL6P	127
9482	2vbb9U3ySNYxQhKwirsEKsiRoP8yi5GoM4PGRLJf47v8YY5bHCHk	127
9485	2vbLxFBuC1sXKcNmAVUbV4iiba2pvyvsF1Jb6Q1bH8DSq7NGezL4	127
9490	2vb5hstZDR19qua1EG2CbXFTYyaEYNxUN9B5NArXjYF7ayMVATQt	127
9495	2vb7ktoemGmdP6EABEbPWhPzbcq3FuuAdBpUTKTBM3Wu5YWo2PdH	127
9501	2vbiT4PBDxiwQUJmSMEWzrqbK2ZWq6ErJwhJ7R5QzGkY4hF4S9JG	127
9503	2vbJxwQcSTjiUnTdmcTHhPhyTsd2TcuJjtMG5hFTrvjBYhdk4mD7	127
9506	2vaEGv1AZ5CtBDQLCc4C9db18umgLiiey4SbuYZCzg9xC9iwTpEu	127
9507	2vbVtEGvnBywW2y8wdRTxCPFXd9fAoJRKGgBdWchy6WFdpLH9rTD	127
9509	2vc4yLnat2JfYsCjjDMiZRsP2qBtrAXdfwCW4bGS3JVJxpLax5NV	127
9518	2vbjAQsUfEiddph7xVgegeNGeqCs6Gd7ydVNZzWfdLLpH8dD9bW3	127
9519	2vb36nRtS9Dawfyie7GFGKgxR3kjZnbiYtC6zWUxzkaTLPyuCggw	127
9522	2vabpEgivByV1wp6e4CQVPb7svhb5diHCP9pG6t8BzbGszeMJF9s	127
9529	2vbV16r31Zwm9BFqg3ZHCygivEkGTvFaWJN28xTv4dKqgzThfUhM	127
9531	2vaPpzzPAnAqmya4rhsSk147d26QYAUDc5snDhx21veYZ5pNQ2a3	127
9537	2vb9s8EZL5aY97ZzFarAxcAtSXMNh6Ns8wDUPAHF5ojDuDkJhRDk	127
9541	2vbzVoU9XG2DdqKrNLHAe5LkwpmVWQ9XWA13tH982V3dfhMwcZFM	127
9544	2vbWk4KJ8UQKB7oe45CP3HwfcFZY2n1CfYBsyMSM5kPieR7M3vf7	127
9548	2vbwuhq8Zu3ksm6Pn21Wkq38HDp3yZ9CCZkbsgvUUVLadXC7GjXp	127
9553	2vbFxruiA4nzx27W8z5xPVA1eygUXCzNisnTeVwPinxCXxrp4poj	127
9556	2vbbubFjgpw5iUv8ybuRAWBv6JnX36t9pGqhS9nhhuLkZc1tciSe	127
9559	2vbtHyFeScrzKDWFusWe1tyMgqKdFwx5TdsXCHhVGHRusFXmUkun	127
9564	2vbKNuUWzc1gGzX8rxNooKUdaRUQ8buY23PnJiPjkmREDBkq1uip	127
9571	2vbJWWAB9QHqb8aJnZaKWbCkyZJS1d3ZJNLh1svW3snvVL6eie53	127
9573	2vbGRDh3HTqoLMhVVG9AQQ57sMgo2HvTKBw3SFAmny16QKBFzXx6	127
9576	2vaDaKvQixpyhXGfkoRQFnFxsZQJrG7HbdvTGo2mZZyBnSsNo5Dj	127
9580	2vaVu958BnwCdAT7yczrPiANGtxU8ZDNGbnUWhv3TBF8xWPsoBeJ	127
9586	2vazHK8VixZfWydz6uasnbW9CKwKL3nU1jUU957R1D6AeFXKQEvt	127
9591	2vbHrBbHTWWzVGBvR4ZkvjhuZ6rTu2wyoFJHRuPhJMoPbuYehqLA	127
9595	2vaZAedkpcqF4Ur5KLmY1ckyqmwF6TRskcKHELAUqi5x75qCyfAi	127
9598	2vaeegdtEDFmXju1dKtscWgPsUP35QX1zaXTpRfEcj8Mc6RYRBnG	127
9600	2vaJD5gPy6W9jbCkvTNkXgw5QwGAzMvzFZFcgmXvnukDdmDRaqqv	127
9602	2vb34AfrEc7dnmkAERfiyisUKEHUBgH3k9GHppWPLEWx5SSGf9nC	127
9606	2vbHVT3C5MHZJSEo3TLXodoDNXJo2vRo7CEntp79Ssf5Pp2PJhW2	127
9608	2vaq1mZ4QZxFSud19CtDCBRm7v6Qex2doRGRv8zHxqjmSwontX6U	127
9610	2vahH9xYi1diDzak9D6rhFyT9NQJ8DnMrU2Sd7NhLzVZ3QLj1WB9	127
9613	2vbaUuyZpD85ojdvZx26ze5Dz5W55oVLgQVF1Dw9iLXKAwQuWmg9	127
9614	2vapVbWX9pY7Nb8yBdRwmp3ewKSEpDd9djo4RLATUPfLD7hx1rzw	127
9617	2vaKm2sazj6ob7DE5kn9XQxds9RWqDgR6MzuugjMcqvhUXdBnFfj	127
9622	2vc2uwEMtyZcEHwYW5yDzar5nLF32DrKdTUFCW6fGooM3itP1CuG	127
9625	2vbkiY1sKYUiNRRuEen5WgUvZYj86VD9toF71V7n4jn625mqR5Vs	127
9628	2vanKfNP5nyhppPeQpNofrTpUeR3wBuzHYbTM396jpwpKN2ZVLzq	127
9631	2vaSeix9ZRqJovh1HZvwvBUhKBguw9Chi2MnGjPMi4vTYgvGRar9	127
9634	2vaPYxhqKQ8cfnZ5t2bN76ZvL1EUNt1tti6zb853cEtxsVsYAnYP	127
9636	2vbAZN2K6jwbWHP6SFboGd3qJHmSgb5aEgUcFW33hCcD93rmfC1j	127
9639	2vaxCSUKk4fdboUKEWy1VMGRcw4xJkUhhRJNEuALL8S1Ne6Z5G2q	127
9641	2vbgbTnfDsuqFjBy4SStSzEhqDka23fK4MmZdgPQkE66CHdHsXCE	127
9643	2vbdhAa5ihcRuo16vroPuDymjB7m4aqYx3aW5DX37NogzKV6cptr	127
9657	2vbaL2qbwHNCSLWY3uSCQwVREWgQVXDKZ3RW5MVLfqtYWp2yuTfs	127
9659	2vaitMw2vrSFr5K5dR3XUPs35rBNNCXj2TVEqWv2EFcPeL41tjqJ	127
9662	2vawvhPjNDWAfam2aaLsQYUvqNwfrHCzQ2BzgFV5FixxuWMKiVhz	127
9665	2vadcuYUepk28wUHGPGdAYS5T8UqzXejrCZVGWJU2K85tj1JCAhn	127
9668	2vbrNhxGJCPykLw97EfcevkArV5KDMnvXa2t2GieuezmMj1tRMYV	127
9672	2vbWw6VgPkXVhNhdGEUZAtZs83dL5iNS55WRwEEXC23xqsTo6qtR	127
9679	2vc2tZjrEbdEqqtVz3v1UTMaYTvMfro8wbSS9Mppods9bhmvZtTV	127
9684	2vacGdfQUQVDRAgfMyn2PsTWAh5VbJPAbFX35qqhoqreb4CB7sKQ	127
9685	2vbzMBgz7YhBFPLsTnQkuJPEiRX4ZawWFfaY1sXLUhbrpVSx9Y1t	127
9688	2vbraeewYJDnQM3hGFrjG9LrWshohKEvAZnfRkUgVrK21QNDYyPu	127
9693	2vafBKc5cbJd2WQQbvquVqeCpu7HTS8xcJr8eF2Z9oi5hssbre9F	127
9697	2vb2pP4gXvqpsUGsDLrfCSFpUx5TZ65tncLGNsanrFMGNuKKv77v	127
9687	2vaHPkkHhoh8UVYiXhFDM3b4ELagN4QQ62mqgYdfmaj7b98yZ8pM	127
9692	2vaAThf35EpMFisberVTUs7WAp5SbtiTmoqa75PUg44uL7EP4zPJ	127
9696	2vaFx5mbM7xsnMxDPDEDDD3QymLWv8chaxDENZeXerJoGFcfAi81	127
9699	2vbspkiY1aS7L14wvGT1M7FiyXCnFpdUdnVZ9aA7qbaWxfVLp8Gq	127
9702	2vbQvvMv3q7Vc8Pu3YyqDKRPuGb1HTWHctUgwVB6pjfS3LfaP6fh	127
9704	2vbywzTu9sQJYgFQTktx6VUUnYeWt7fSv7hJyktPb9zpZsmHkCeU	127
9706	2vbrXZnNGzDLukWG8qHcgsyVxDgVJdiQKr8z128sadjDMiWCocFR	127
9710	2vaFbt39L7FWvdzbnxeYqyr2YovNXJu1R1bJYEWvRGJKi2G2p3V3	127
9717	2vbJAtkB1QnWFrgJp89BQk9SbMEL3W3zfRPN5xtKFAvBJchnxB3g	127
9730	2vbgzvZcAmo2jTkXPqmAsf1p7LXiCtnxY7xhkNkb2nEj4XPftpUo	127
9732	2vbkKH74mNWRBxAYxjEFEtuox14yzvRMkDJPLogdVd84AHAdVuW4	127
9739	2vbmntvQN6fzh3w5gRgDp3BdBAiTNzCWfWCguMyhAHLKt3PT313Y	127
9741	2vaB5gdv8KeV1GvyvDxyXNNwUndeoZtd4ap4irjYAfHa1EyuUBU7	127
9743	2vbhm7at4VLkYJcCLBVHWKfnAhTMNk8WkwFBjExfevm8WsrxT976	127
9746	2vbtGtqeL4DXvs4tQ4LrbmTYpj3rvcz3Ddp68BsZmNLdCAuVHTwa	127
9748	2vaaRRLRuZ5m2oZENA91aM2Bom8kVpQHHnCZ8qXVnCYu9SsGgMDm	127
9754	2vaQufw373FCGki1WJywaLZk62yPiaukVzsQ4XTy9Tqtt2kXxrP1	127
9760	2vbx7yFRngLrdWGVd8zziGHFsY1B8ebPy8gMDXv8Dc35tc5ztjjR	127
9763	2vaNSTPtDqtGdtzuW7vZkuvGdBAdmACBEN14wkLGJkSNPjoYYG9z	127
9768	2vbC7NDmsn74C5zTnqjCvHRSMP5gvZVK5peQSgKSJuZcRw4sEynF	127
9769	2vc3dPmj2inVT5Sc32V7SxZBj1FrNFw8mFawTw1aNghwedkLQbtb	127
9774	2vbmWq4yydcHMKPNVjv3FGRJ4VbzBPsAX1LM9h5uoixxrCm2ouK1	127
9778	2vbaN9TYDQsFXU57hLnHBvoZCQJVSNjiMgz1GEa16jbts1KUta4p	127
9782	2vbqngB2XSwyrfMenDCLSLXgcf9ctRPBKkVCT28TJ8LkLMsHxakW	127
9786	2va9tZ4BhPdAmWmrFjM1Rx24tB918GYT7dbcUPuryPAEMP6XbjTg	127
9791	2vb9wciPk54EW2ReFcHiNZVY8JEeScUEpNScjsSyoFTS43GFEJzq	127
9795	2vaG27Mb2wCum1fXpXi3dSYPFv5e63uJv3UsPFsySMesLbFNt7tw	127
9801	2vbDd6VQLcK9QANn4RgFjfmaesqGLvFo3VSMxNVfksrNxKhKYr2r	127
9804	2vbY3EpcbA9PECedJidrW89DPDfL7aKxJswWhMrQAznnS1DrvYqy	127
9806	2vc1vYrDni1VZs24ACRcfnSuYr9QazHnEeuWZrzFAJ5WcbxpS8kn	127
9809	2vbcqfYDCtWs2D9RefDtAaCdGHHRpoMApLJmD4GZ91Z5uTKpnTNX	127
9811	2vbd6pM4yh64qzsucpcDehwpN7PmDWvaTGeFh2rxF5KGvAKZYpFP	127
9813	2vc3WTRUoDEVPygKdQ7T65JnPypJqM827e3irX9iDUAzRkRtB1cJ	127
9815	2vakDW1mruR1dRBHLeZnmHE1KRHGe41fTk7JtiwWuJEo6tMebZHu	127
9818	2vadXFWYg26YduWLs1YmqgSfFV8BdhvkvdkxqbYg3e3gSqzy4Kzc	127
9828	2vatdmX9roWh9ky2y6fcjeLDVT7qdE5EGM4fh3hdRxZhPx6t2rsT	127
9831	2vaa1QeeyrrKQFhP3CbFjij6H7yW3iv1GbFXSKvAB1Fz7Qj4LMTU	127
9833	2vaicyNnnrNsNzFcTgGZYdViJumx3FfetrymqWjzwW1KnmpWijTe	127
9834	2vbsxRFZKuZ8fJXpj65mqUAtw8APBGQBgK9TttUWLBWpVU2esDpG	127
9837	2vadWkS8mdoAB3dqKCpDPgtayRmUT1QMs2dXvnE5jMrs5eKYFuYB	127
9841	2vbeuKr2d8EFsT1NJrS8HB4Ed5fgynkJMkm8oHgaW3RstSKWQMCL	127
9842	2vc5WToHMxPcMsDgdo5NP9ijsLxbn2uTDDJGY2R6XigwyRLSXzH8	127
9845	2vboma2gH24wXCzh8zZLtPierwQvnTbmQnmJHQLeJpvDGNQ93Vj4	127
9854	2vagpB9wwN6P56jn524LkPC6MLcVhxqegwew7jy7CG3DqdTST7r3	127
9857	2vaoXrjZRmHfyuby4NdA9zTrvSpzNrfyku9DkcmLCTU3arHfRCZ9	127
9861	2vbS1JLbJfguwP2iKZkFr6hePLJjg8vnESM3X5JHLjDR6Cfb3az3	127
9865	2vbpfXopM8WjgB1nB3gu6rgcsCtcaM5aM1yc59ZJiCJj9rZAJFQ7	127
9868	2vbHY77Ui8Mfn22WBk6YjVDZzjoQZZJRyvh2f1W3NDZGTX9tR4SJ	127
9875	2vbjxFAGdLap6Qb9LDpm2CSKd6aUEaK4ayVe5EUuS7ib8vzqpvRp	127
9880	2vaAXjiyyYCRwKyTyYiAF5J7r2gHXsFma6HPXEAg86r1u38BYVZk	127
9885	2vbhAbdZnh88sDNAarWa6wLtfySvDqKRWCpfoK1NhqxTqNVKUbvY	127
9887	2vaKNvUD6bef7jxg64DNURgaV35jjPGumu33rN35fzEKLWALqNT6	127
9895	2vaSu7B9ZK7L9CCgn1LmrX71KZxdusXQCESV2ieNruvtHyCoKTuU	127
9896	2vbpAa8jnf8xyubmoVrDXfDHZtUmgBbLTQNnKuEhk4RwnduDLDun	127
9902	2vaPzGi3kfF2Sz7z66sjho9Jbd6XeEDMkmBZQxrHoihknquzpUQ6	127
9905	2vbXCFgEELrgeznanoYqoqazV4rhgq1vnLo2VR9N13jiYP1eiNg6	127
9907	2vaRmxagwwMuY4zeVKmVqRNeCcSD9ZexM8mGm3mzTjerYucBuomc	127
9917	2vaHWaCw4fZSJnecmbZnjydcZcjwQwkwD3pw2mZY3jnjrA1msDra	127
9921	2vbyKoCZbGAvc23YjysZJDhvMfUVzhuZF8d7kk4bqGvNWXRkkUEk	127
9924	2vbh6CwNmmygbzkxBW7acdjuMwqb2aSYV6JSD2kYsWe14hP5k9JQ	127
9927	2vc4xDxYVSiLofmbDPxn4mHiENixDnfXwiMKz3ngBVAmNfP9ZbcF	127
9929	2vbUo3jviJkTM3U3UdB9sHSwb3UNf98jFZ6XRd4zTjeguZ7uP4CR	127
9933	2vc5FXqLaah9Jsm6obC5Xzshp1g3PQoBfzT495Q8KNMG3F1dCPw4	127
9935	2vbc45dNyhXHnqbMfwYoAFUSNE8GajrHf6gGE6tMyvCYzKMR4qCg	127
9936	2vbhoiJ8bptVGwboFCyQphmbXWMAxQrDDpL6eKqgKTgYwzukxZXr	127
9940	2vbcQBgF24WUkgSDMMPRUPyFCEZVta9W4ehqiJQ3j38gKUfdRbwY	127
9949	2vbzg77MhJur3qCLbEEH3DzEv87UpJkobnXe3kTBYGdsFrBWW48t	127
9950	2vbY5wkVy6hokrR82UnqrRtYJWoSvb5JvYu2drFYSNe7REYK6onu	127
9957	2vb4doV1DNKanHYywPwhw4yLdau1wtGxuKaWq89aDmwG43CyAeD5	127
9960	2vaSpcNtpib5Ed3AqbXPctVMj12rfRac2hnnN3nQSfJFU4f7RffP	127
9964	2vb8rDZxMkTsjRThD6cbteXzSMVzDQsJjLuKY64iYGm3S8RTeDk1	127
9967	2vb35AtDFc7h7wNdkdNbC5ojijHDCr9zP78scmAete1pspwGrHPT	127
9973	2vbUzV9QKhdn7NumBQLPB2Q2rnmxiVSHkiY3QmFS2qQr7Am1V6k9	127
9980	2vbD37bLLYbjnXMV3FJNnAKrrfsp947AS1V4RDeL2vAtCFFQS1AC	127
9983	2vbfDXxThuHH98wyaahs6pC9xkJ7aV7C2A2STHaPnmXfhdV4krDR	127
9987	2vbMT1Y1cBLdX7bMo5cqEcGj876qL6XwJDcGc8vfbGAauKPcR8Dt	127
9992	2vaKZqtVqoMefKsjcysQjqVXda8nYDkiPYDtNxn73KCEjqwfJgAj	127
9993	2vb11CFpaDbTaBots4HADRaJMC1WDP2xNgAQLD6GBgsF1F4fkUTF	127
9998	2vaGUiZZY97U31w67Gqh2Vut2RztNYbzMq6H1k6A8DpJMQnUgFCd	127
10003	2vbT5eWt6A2ra345oJqTTi83k5noucnhMEwK3kLfQwkbbH4ADDPS	127
10007	2vaBVLSoHQG5hYNQ8eLSPziKFPQs9wN8gscDyBDngY1zERhcyhZP	127
10015	2vc4ZpvCFRwbbqw9Bet8EKy7Ce2wnbDJSZQDXfqDoYHC3SAuHgju	127
10017	2vbF9ZMumNWyZnBQjmdC2ZkCVgEeuu3NcvoWS42jVVkRehWku9SG	127
10018	2vaaPp3p4w7p3YUwpxPx4fRJh9WQmmxh2MWmgPCNhuXY64Y5yfcW	127
10022	2vaxFVDQnpeBp1imxLsryYK5EJtWD2Juq7y6dE5WNeFTmzuXG7eq	127
10026	2vbWcnWzAaLYVZBC29TVpGikEuYbKK2j1D9rb1zJUyu7eQH31MfD	127
10033	2vbqUo2nZbVHwR6Gs8KwVcHBvuGon6pFS34bzqWDE7GZ4DYiUqcH	127
10034	2vbb4xpNozDfXnKoMXh8e1ZNhBnnqxJxCWR5f21v8FRPM7HpRc1X	127
9705	2vbyjUj2iN6HCtEGqPjv5ezRt946SutgB62Sbjm9QhMQGzEoUZHy	127
9707	2vaq3DQQEy3nhLCC1tx1DKaEn7gnwwiaGcFT7GJ8no5TN1AJhwaJ	127
9708	2vabXwRfakZj5SkMqm1U3TbKB8wZXM8D93UWHpnFKsZ15LQ3NnFZ	127
9711	2vborxL48z5GeY8ef27QVzDpdemDnvr4ojWaVVyJdC6VU3FMbx9K	127
9714	2vbcLm2Q2f9SjqcgakoBjLrPGGyjCeHh8SjTt8jidMMhzbTht8jE	127
9718	2vbUJ8HupK6cLAuz7tegWERBQMkSxC2CSzJMYuU1PxmCsDLE5qnf	127
9721	2vaYMnkqnoLTKFqk9DU7Ekt5oJJse5naMSgzQBV5Tkj9E8d6QqS4	127
9725	2vb61f9FeHExrkmBsn1bT3HrCsf1mX9bzewsjTaLMWaqHRiyYVqx	127
9726	2vawRKSekLYrcUjbmscmmKTczrWaTU8NbrDzq1CdqPDUdcmnvVT7	127
9733	2vasMD6hpPBdaMHoupQSPzVZfGjxcF9Ead2y2fBaxFoHMZkpbJTi	127
9734	2vbh9QYUFhNbDbRcBC9sMr6vRMMMW2TGpBnLHhAjTYixSbrMJN8W	127
9737	2vayp5ocy2NdFLykVgkzBdENZeTqEWwUKYHnTMs39SL6AgDLoYDd	127
9744	2vb75dDuhnVnJ9fAtte2HiQ8XSHZc3KV4gjTmvDTYMTcRDjaddfX	127
9750	2vb2qo7eh5fHx8rb831DBu7zjL8bqGCeENLy37xroZi9X2atF9uG	127
9755	2vap3qyEzxHuXrW2UjCjABVDFHAnhBYojSvK51zhFGp3tQ6oZMMN	127
9757	2vaqeDD2JXBkz9cZTdiLMz9WGVGwb8rsfSntfLzAn3ueNC2zSQ4X	127
9759	2vabNKfT4bJLgfwppiKwg3WjUGiEqpSRLE64sN8xjAT4vbTHLNxG	127
9764	2vaPEhGdNWKu61DSmdKuFTrHAaHiTRMa8V4JkjiXGpGPzZLMZXha	127
9767	2vaTCBUkCcwHqBj873MbZ8R5RAZtLxB7vGismsS49uzUQLZjZp3d	127
9770	2vafLB3cp28Zkxc6L4XFZKCs1hWNY7n1F1iJmCr4hAvZdvucqi6R	127
9772	2vbbVjGPUQPxJtdvghQQBz13NdVPZNFukd544bY3AtTnEsHAhoDf	127
9775	2vaa2nvy8Nn7qAnGRo8hMK6Xq8MsH4mqeSW7rZbzn51Bhz69Wah6	127
9779	2vam9QDjYm9fHHkV4A8pnSYvVfty2Zfhc2QtUuj64fC84Ke55kYq	127
9784	2vafAsiBQEg1XaXWKLQqrGY56oFVyfCAhX7ksfKXt82MwP3jutqa	127
9787	2vbFJrE6wjYeVmtwtFPpt1KiJBs1rhXy4uXVnBzMwRr9nSFxJZCX	127
9792	2vbpGuJ3PvuydHLtGdD3kgUw9RNDQ7gfeeC8D2ZLL2ZwfeNT23fX	127
9798	2vaYGCGu7LqftKj8eUMR3sFT1TWseDFUHww3FUGeGm9SoynTKuR1	127
9802	2vbHLvWXCLd8mQdbjNcrGoWUgt6N38zqaBkwmUw4imbJUrmMU833	127
9814	2vc3Lrpnasfa91HL96nMQfFtG7bQt1RYADWY5HLrkgcqKrXipdVr	127
9816	2vaT4JocjfMzbDv9oozHdmqRhLV6ME7ayDstg5uKSD4jmG5DbgkB	127
9824	2vaSn6jauvVWQa7TjbWtBidFJt77zPJPZxFjHFS1trorcfqK1znV	127
9829	2vayCbcefsqXCAUeBRP9gZUXPKaoGgcvFxPqk7MkzHfofgoqbWmL	127
9843	2vaD8BYGqJFDViwb9a18z1wK7NS9d3aLn5YQt5ebMe41HieuKuQc	127
9846	2vaymYenF3gujkkeBQ2j1diZU5KnZYbNgxsC1ypirFeoxZNmTE31	127
9849	2vbCkxuBRWG28AdiWBVS3uKMNH8G2YHWfZD3qE9ZRTmFAXSyQU5m	127
9852	2vb1PpMgDgxzeZq6HZqqLhe6qfTcy91ZE9y8WqJaFxFt9UhpNcr7	127
9860	2vb6VCT1kP56uNVhEaNkHpcTTDeGBmEswW3K3ft6hYSW9i7fBVa9	127
9862	2vbEzPRDABFtt8EeDTsq8NtYcUQ4WeKdEYaeQw24tKtCZfCMHSKq	127
9863	2vbR1KDbBLJeyttT884bAvHputP4A2B21B33zfB2V7PenJTY9A7f	127
9869	2varyJ2EEBqniQoSk9iE2em6SopLRQ7nft1uyQ2c68uPkvqcSLMp	127
9872	2vaAUVnCLqMcYQ1EVaXvdgJCzt97zP4vJEoG8Ksn7tCEEVHwpGE1	127
9873	2vagLTZgrKWqqshSzmuHTLmeAbSKsK9RXCFaJ7AWC1A3mFfyG429	127
9877	2vaYn19Aqsb9jfgZbV2ox76pFgs99KV3EF798BmVNWF1WUSRqVCk	127
9883	2vaY4g5zizC6a9DJzLV43cVGdbPyR6Tw9hpgZDcmdXXFqVH7ucJi	127
9888	2vaF8vNRt6Kky3kfz8JbfLbL2BXVvqwAsb6qxsf3AqSpvf9S7VAC	127
9890	2vb7QZz4i4UpcmeG6uQYudrekUc2BqMsEPq2NrhJz5mqgne9zsRJ	127
9893	2vb1Q7L3oRiGxpgX8aQGo3t6p5zZqK8d2CHwr99AtCk8FgywX59H	127
9900	2vb8WM1oqhck8K8f7jZLXiy4bNnpPM3wgm7wGSXNaCXW4Kz2nMww	127
9903	2vbdUnrB1irC2mnq56zwrwQp6fqaXfjxcY3s4PVZfaug86KS3mjB	127
9908	2vatiggGRZiqrNx7vk9cAXzvsUVWbPbXM5KcY2nuw4ssVJen5qMA	127
9911	2vbhW3W8xdFFuWE4Gez3XHSPP3kJR4a4cmm5atfv9R9cVqmcG9wH	127
9914	2vbJtgP6ZqiTg5W19Srsmd797oedh4xKhSz9LtVWNvpSYNHo74CW	127
9918	2vavAoQcjtHDycTnWJqHkKeoeQU1zTf6WMm1foqCvDBwnVyasiJj	127
9919	2vbVJsvQSGoaD1AXipa78GYderB3xygnwgZP1cgtCEHLtREoK85C	127
9922	2vaoTjM3wDdsyk3t8kfdwdRH4vbK8YU12d1hnoRB3ibudQ5BQ1bi	127
9930	2vbsEqgNBQNXdpSczbcJ8b17r8JPRJxtSb2YJXZhzNG6BeLTG9EP	127
9932	2vaKAbo5SzUuUpREvhVXEpTJQx2E1grZdyBreTRUKfHw1XWQaYLY	127
9934	2vbZTqVbbfN8GzC1iaiM51wtBdgPxiuqrgyRM1uvXQu3sxeutwMF	127
9937	2vaiWA1WYVPBSsT1cU9dTUu18GiykHWv6SY2yhQ15ynvDwUKLpNm	127
9941	2vac6agxmEFxZtFNyG2xppjddrTjeN4LcdK58Gcs3MFEfyfmyzU7	127
9951	2vbKfrkirTRk43PM4KDtnvdLmQjrNDsvShGJRQG4yqqJECSVDBqp	127
9952	2vb9c8c7XgYx1HaJzBWhHJypisaUjsgDGCFRaZfe2EEeYzfLE2uz	127
9956	2vbE1imLxDUW28seUjfkoSKeZKPAoETC42EKyFxqKT9EHAkFcPwT	127
9958	2vbtz9V7KqS7FJrgUXjDCBJ6qKkthDbiKMap2WGFmjjESq3Eea55	127
9962	2vbMJjLben1XuDjUJCrs1ennQsKtEFNpDuwQyy2yr3RF7znJiicW	127
9974	2vbzm5rx1iVqTZrqY8zndMPv5T2gCBr31YaGqWfP3s64481pkmNy	127
9978	2vb4nWW2oj352TjSUV3ygSmG2UMvjhWoeXhUQhJBGntw3P7dmgmB	127
9981	2vaRhooeaeNzrMffta32kd317qWgS2h2tt7LtgTSojjRBEPngWZm	127
9984	2vbuVq8oMfw1yLbgban4R3N29XhBNmcahyRt799N9eSAkVexYgZC	127
9989	2vbXh1UzmFbDTv3RgygAb9gqg94B5pkfK5fmX8y3Nipqo7w4qsN7	127
9996	2vaBYR1EQcxffUFZt1EvY4gbXRMimHqYyZW8N7wixR7tKha4dgmE	127
10000	2vbPPzmLmcHThx49sRPfFrrcYWPUhCVNhYyi8H98zdTAk2rCKRNa	127
10001	2vamTBAv6KhoKfmFDLakQHCtLa1sXyf5Q4Vs2aMLBa4Y2J3havFK	127
10008	2vbF2tqUyFd5gR4dYaCWu2aaYKoTQw7ZvtoECcK8Lb6cWdXFs78o	127
10010	2vahDktHSzMf83HS45XZ58dQVuyyfCC5F2P8xt8tpYctYZBPGx3W	127
10019	2vb7qa4RD4fVrCDN1urEnzvtXeGhmZaQwg43uecvMvmfZ3JEBbnZ	127
10021	2vbcdsWMSvoKWj8Wv7A4dS9yUq1dhLhAvkgGqmyTiqc9BwE8KR1v	127
10027	2vbcXT14itfruXpoygF4yveQKYVbuhphEypLwkFxrT4Fek6mKLzU	127
10029	2vbrp7Y7rGgac7DHawQTaV3KCkfDAKxqTcXf8dZP4YSv3cmRcrHS	127
10031	2vbP5TUHTB2HYkAwkp9d5Ht3JKeUGgup9L4NzWey6QQrJXwVEjbv	127
10038	2vbwvZKQ4pFNrRQp3hVUwRRRs3F6p76CEuyiTMSe3t1iFBNGJj46	127
10040	2varQTSgdPmRzbXRJSWiKEyLdEvu1BTUdzMGhJZZb4CBWWz4ggA2	127
10043	2vbogApfMYGJDqtX6JwTCQpfcK3URXJwCVJkCyVZCMW9kLnQXnmV	127
10048	2vaj56a5QGRKpCcJm4EGq9YSx247qR9aKxPnk7bfhzxMXA6nQHsM	127
10050	2vbtdoYoZCTyTpq6pWV8o7kVPm4TynHJw2DVqc6fQ1gmBds9CyNq	127
10056	2vaLAGRrJ8NzhhQNNLyYHyffAvkBToQgVGNLkWBtHwjTQ863SRK5	127
10057	2vbu6pVTLcxm1tPcXfRTEKJf4edy11nt5WoZF12iRwL4S97JhuPU	127
10060	2vaycLumkWF5khYJkhsy6QBxpxNyt8pV4K97c5SDxLT5jHgwhETD	127
9722	2vbcwbijcFpHWaiCDuADhQgby4J5YbzNZVHyC3ZbRVTcYhRvLYKm	127
9724	2vaCkrKxhWNaMxTDTha9XbGy6Fj1AP39zvzPRyWysX8DN8TaSF5o	127
9727	2vaPzJr4b8NixneJbcQKXi5Y34mhHeHSTxwt4zbRHKLcAWcPBNn2	127
9728	2vbzX7owwBE2D5Tc2RrBrv8QUtCoueBZXDiGcTcKHdNw4Q7wNVCA	127
9735	2vaxFF4MksfR52r1ZDdu6ihQKf4i7kDAtVd7fqcrCaHKcjQHaqEY	127
9738	2vaFaotn2HGLyri25BiH28jAWa6ZSKdxxYoQgxjcF9aK6ob6AL4u	127
9740	2vbTDig2fSTsXkWcgZ35CXx92FB4bouSJFU91C7Yd9DgThoqu5C3	127
9742	2vaa59NnMrisWi9Q7A9j1A4qxPnB8tpnDGupjgVZr7CwTkDJzu3V	127
9745	2vaFUuyDwVNb7GJJiAzraub4M5GZJPat21ttdZkXCWNTrLwH9vhv	127
9747	2vc2xQRT4cne8ZKGphVzDnH4T9EU73a9TBCEv8kJufzsSz7G4VVr	127
9751	2vah9CopKt76D8shdkXkANpjDSyMZZhKhMe8L4YC5mA1q6MX3Dob	127
9753	2vadrucivLcuFVgABodi8g7FZnu68MhMcR1ogmCXwY6NiRUzAe3Q	127
9761	2vbEcZcA3g41wWGKbckJi2j3fM1ZF1aPdS285pLccQxJ7dcQELRo	127
9765	2vbXf5KtP4Wfv2FXj9byD9HCJ66tuESAHtSoGzewGzjACUTQVpJk	127
9776	2vbnqrEThVrqEFTHHw5yAt7KQjtVXeDfmW9bcPyZwcLXmmLKHx5r	127
9785	2vbSaAbKTn228afVpKWXWqBAmRb3DsVHofiRnKRTGYDZohA3kK9j	127
9788	2vaEupe2FviVarKouo95VWdAsFgUfT7iAuB3wgghBr7ZHQ4ofK1C	127
9793	2vbncmktUdinBAKjrx9ht83Kfu5j9zrGu3xYnmhPqga3mLCdL66D	127
9796	2vb253MZ4kkSzGJiQWsVib54xq2MAxrxWMVeeSZGv2f8iSQ2V4zP	127
9799	2vab7TGhQNT77wZUxezqmfDpWRXJPmdXcz52WeWhWgSvkz9YEGEh	127
9805	2vbj4uqWmSd9oZmGAT7fFLTioMCNP9zPoH6WLySdShvo1KHUbdYF	127
9807	2vbsvBDPpQ51MGriM1wsYf4KVqWaBnP4QPVPjodAn38KcddXPomf	127
9817	2vbregdFUkFceDSPnjpbwL4uuS3K2co8S8Gtzxw12xNwNQDgxLoc	127
9819	2vatc7VmihAteXL3haVc32pn2Z6BWcvi8GTgcEpSo7qZysTnS6Ty	127
9822	2vafdoAiQhcePwgKaEBKuCh18gPbSRqSXsdkGHysV8k8b7RMHLyF	127
9826	2vajqkuzfFQnpmu4guBF3G7ptXXrw1izjnxya6KQJVJ6VSiAG353	127
9830	2vazD7sVpRkfD82ypXfsmxyZuosv6AykamSZuN2Fgkux4JhwAMWH	127
9832	2vab8jPFQSouyPcg9DETiWYANtSKypsEaVRRQimj1y1tMbVxQpqa	127
9836	2vacducxRcznArniaf1HLeMnZBHb5bQs1ufoaozqPavWLQSxKz1m	127
9839	2vadCS8RF1Dhi1dv9oXr764FJGGbuovhAqvorzENtVH3byUoCP5q	127
9840	2vaGB5BrfHv1WyHtbjcee8kpdmtV6i8xkcRQJfuiit2ycUAAxv4C	127
9847	2vaxfk3XaqE52GPkfxdjtQFYGZ47LbDKDe4tnvGXNuHMnaVLVJso	127
9848	2vaBLSKyunRmVzabpmKbhgHQ1sZihW7LrpBPS98XyoDJrU1Uy25b	127
9851	2vaQYM5FZHCj4CW82kYXGN8LH2Z6vTdesBzzJ5QPKnermJLP9uhR	127
9856	2vb6zkf6jqw1cQS7yMuXSKv2cL4CQcHjabH21EFL8QMi7hLGPZx4	127
9859	2vabRKVjCh3HtLGGDU6iqz9kMNeEeLB2qREZRroktdsaZ5MfzJua	127
9867	2vb8GzPUT4zcy7j1L89n3btiA8LYctpZA1epuGEuxUmUMfkgL77q	127
9871	2vaYugnxSXh4N19zr9H1zp9j8rQZfHSPkESYSgn7FJSrd2nFcFU8	127
9876	2vaibxzN6f7xyRQjPQxT7sJHeKCa1ct55K1tjPbr9h2Vp6bUmzpi	127
9879	2vaZiyMm8JvDXuasmMS3MFzf9NcW9PrWyytypdxAtj7EEh2ucu2e	127
9882	2vbZc4evgVjszZ1LNZ7MBn6aVqCH6hTTYY5fs4Xq9RHWGhTJMm6J	127
9889	2vbFeL4M6iLnVGCQua3HqVeiDbwZXZyAJfBvvgpR6onA77oj9ZDj	127
9892	2vbFeTWweJupfXRseCASftapjRip7kg6KZZhvCvm1pnZKiDxA2UK	127
9894	2vaYoCC46pmro7qxQEqFYch2n6aEWnYicbsVastPErmpG4ZP5VpD	127
9899	2vasvEb8iEZ3owmQWE41UVAGkFSB5AVB24Uae6RtSReJJsTN2HY1	127
9901	2vbQZc2SYzBScMZkzoSQGfg6wDdSAGVDfQYYysDijbBugsZA1c7g	127
9904	2vb2Tyoahzw11rJNWy58UxhCatpzsvGFfcUScjNZQR4XtkMMyg9C	127
9909	2vbBR6nrPC4XCnQeESvMjCTxjLrhzW2qUZgXrE2rsotNeafBUCj3	127
9910	2vbdent9THKx31Aw7yy6V9oe89vsmsGwmr9LETczkNqhr8B9NqL6	127
9913	2vayueqRNe9DxirKLFH12N1SG3BKfSdgvz21QCGkcznLxn7t2eLE	127
9916	2vc4KtqijE6WokbhcAcxSsVNLxuxasainhPbDZrPboHZAHrVC4uY	127
9926	2vaDtynKfPdQGa2sqNnsxKNVBdbhZwXJKVZ26C2yMKYdKoK8NnAm	127
9939	2vbBhrMZ6uj3eUAPKji1DTwvQYPBmscxRq1qfF63yvnZppYchN4s	127
9943	2vbW6yRb7SUi2LBsWYWN1yeAkjL9thzQPKWGsH2sWgvNgNm5Jf3p	127
9947	2vaKGBzjbUZhbQaic3gxLRAioizwWutveFirDh6esEsG6nBdsDCZ	127
9948	2vbpa2ucqzEtzxxdy3DrjNcu5Kb6bdCQezSCh9p9ysGvfNMq3XWf	127
9954	2vapDwwD96SzShtWzZYi2Q2x7AdCmEcDbvQvXnCMfzfiFMPX8ht4	127
9955	2vaUreHSPWzz2YEELtFzbSgHc213Bm1UKwi3Nvn1C992ricn3ryc	127
9961	2vbfJx2tiC1etuUxf1mjEEF3v1KaxtQnzuXDDCXgJwfE14Fp6EAE	127
9963	2vb35H2mb5CgU85WAJfUomYtY8efAKfgRpPwMHpKXKQHqCo8ThFH	127
9966	2vaKaX9k4ue66WQyT4535B9XLJ4FzGaAnfqWgGShYLonDgc5Lmmb	127
9968	2vaVveXgg3ZuQFtrupMQS4XkHpH8x2jgqBug6VQFu1xM1fUoaVud	127
9970	2vahEKMz3Gbu8tKB8FPq1TwCG2RuA7uy81Dbmz4yRUJXmp2KoUYo	127
9976	2vbEEkL8VW6GxmzjDj5PEaxxhdbMDx2AhJfnx2kwWigUbRwN8avS	127
9977	2vbYvnjRKUA8ugaoQpdAEv182dPxX3mve64V5b2iXpzGbzN4Vck8	127
9982	2vaPWimSCEehfjYwqpcVv1umXAZzZy4rfPriTxpvXnagvQnEtjYV	127
9990	2vbFMw815oh6tNEy6VpmXeVi9V1fGnhSA1RW75MFuShkk2SLMTAc	127
9991	2vbYCqN64Z393v9vFQYEsTQdCZVnktMJKnD3DMGtT1nwYhwyzCiM	127
9995	2vbGDmSSC9nn3twRNS7g7GoznKL7d7JWopmvKpKyfu6ts8WiNL64	127
9997	2vaeecJQbv5x9tMiVVtz1ULR5B9xjJXb6Ajp8BAp8Tb6JXpMda5G	127
9999	2vb5zJzSddAosuB3vo7owNQiuVEszQEN5cq2rfHXXGhUMFkxvJfo	127
10002	2vbRxRKTRHyhxBryifNuhnjAzPhZWsisTipjVCC4Tx91pJYnBZRM	127
10005	2vbnCgHombS6ZrVWaZacaJ7TBQhjEkb9qp9NrVELACVKB9Gw3YFy	127
10006	2vb86ueeUkn1TwDzvjSZGBA5nFFczLGiyTbHRdNMcrkvB1UJ7Pf9	127
10012	2vbzYnDLynXnBKUJ2g5C3kZJp3m6CdxdxmfXbnRGnfirGCDqWuDZ	127
10014	2vbEz4HEQXkiXd9BPtARVFbQ5t9Won78Wjk5gSheH8nahBMFukvw	127
10024	2vbHq5MJ3owo1ycnUa6Fqhqagr6r4yquS8Aj2BfBoLHHShUnxE3w	127
10037	2vbzYFQALDJR58PvYVUAMp1BxoaQqWhrRq66jwF7zfGGaUYgFN1D	127
10042	2vahguvPQ2WwdMmNGWtbdcWyvDzKswxXR199Wfnr35p3FaJSv1mD	127
10045	2vaYVTMfD6JsSCooJ42Mu5z6d8HQFr9XF7AD2rzq7xxYH7LusKsQ	127
10047	2vaVww81UZ4XghC6NpEBJ56fB1RxUgkLYhTsDBfTaPN53JKpAoqQ	127
10049	2vakvv1GeTVLvgv7XiC2RU7AX6FVPDNm3S3tCzsKLbuyBFbHq1gK	127
10053	2vb38TqvWSo7wTg93n4cbJxh8Y6pyTmVbqrWUfPNa7Hwd5qvjduU	127
10055	2vbsp57NnuB4Cg5tDX1WDaSjTxMp7Xw4oZKdoQD2LMpNxeRvqBgf	127
10059	2vbg9tQ3HhenuzTDRB2rYvf6DQMK4kA25d2vgUfJy8r3HKbmx4m8	127
10066	2vappWiGqxJbyQvexe6WWhDAUR4eu6g7UXXgVsPqkru7mKbxnD53	127
10068	2vbK3JEZiLMgB6mCQ7g2r441EkKM1EpVUWFp5LfBSjmjXmtbuPY2	127
10074	2vbXmVbHkMRKUx2Z85xvWozEPXrzxJonmQFGhMQkDYqTvau4DGFT	127
9771	2vaWgQuz7bjmbJDjEtYwhjFAJPSFfe22gyaRULrggSMkYFEL8FUs	127
9773	2vbhymANXDBZG1yavnZToKyuwF99LLT1eKfym9vtx2uHdB1ZtxN2	127
9777	2vaVSpu71sWroZj27f6UTkCk3HuTwsmANMfaBz6svs8ndEC668JB	127
9780	2vbFLhshTZ8KDkvbetitTvbYwhLtS5Nvg1P326FxGof7dvq5hYy6	127
9781	2vbDGVgJZUxF94nywMmBsADMtWEpZjoK7G3KSLXN8JaQJWtfZ36o	127
9783	2vbv4xgXSMd5ttXS9hkPM2xe2ns8bkqrmW6pCH2D47x3V3VdVhWR	127
9789	2vc1rmmLUNpt3phwYbU35yaz4NA8qQYSAKuipygbWwRHSTJMM4Hq	127
9790	2vandPyEeRdxi1zcXDtjaZcf6am163VdMJYy1eyYgiajfnQHzfUR	127
9794	2vaAYCSD1LZ2sD1WMeZ7TUzKsBNtAVYSB4c46Hck1x2jbJCpnA7L	127
9797	2vabXmnojiTYfTCNJiPKhFwEfxSz9zX6L7d2cSf3VCguDw7tQ1xh	127
9800	2vambVeox18xP2id8jnucGYgxGejax7MQufRBWkY1z3ETFoSrYAs	127
9803	2vbcfyYvasWYFF23S5wxUbsQUdcviNpYfTs9UACstAvsAENSTigP	127
9808	2vaUybYyDz9ubGdt6FbGH9ab3EQ8XzPDyKHFzkpV3mfLCNuTpkQT	127
9810	2vbPsbvGtGoLMohnzmcBASpjzEaZjfjPhJ8Xw7SbN5HrCU6zrDwB	127
9812	2vbAfEBKdReSVVr5h7pqyrS1bYQFb1mj1kjcdcBYkgwDhfj1FAFt	127
9820	2vaUbr554AZzqcupbnoPFxxi7CYmKFvaqR3WcVzcebSGbvN64mKa	127
9821	2vbWgXrmuQarQgZnjUV4mUSDiLb64AucWgptDE8ANQJchArdQdKy	127
9823	2vb8Sn2GLvU17nokAs5T76Qfi5UEXuk4q7C4sw6mzLfDCVSDFoWm	127
9825	2vaL9ZT4jCJAmnVbHEqnN66Kzf7URbnSS2cWdc2wGriX3L5aqcv2	127
9827	2vbPrHi9g5oFFk1P46XbWXkAYMwwZsoKp1QEvnN6LUxh344PZ7JH	127
9835	2vbQy7wXAP8yQxhhYgj6Q5k5a8JX39X3tvsfb5gxMrSXD5bGx1ek	127
9838	2vaoShSTX8ewVfsoCQWU3JeetshCKB9Pc87K4zo1hrCweuo5ZxpG	127
9844	2vbG5GfAbkAiry2hPFdCfQZmAu6PuFEJqa4jCK7ipKaT7H5K7Hjq	127
9850	2vbWXp1ysqtx85eimEV6SNYq37z5UQznUq5EZY1BSVw3CKY49Ekm	127
9853	2vb8GvuWxzWqiggpo2rfvAchZJBifqhYtf4KUbr3Q67R939u9bKM	127
9855	2vb74idX9E9r4brwesbc3L55dCPPFbKJrrq17dbVYSjAcTqs4TUe	127
9858	2vbZ18G5n4yuhkf9rD3ENqTUpJ2iLAy2C2nK31eFGsrCaUU3ojim	127
9864	2vbcMb3MPfWVEn74GLxcDYGHzGTMCW3PKhqRdCrXJeMFKMF6N2mK	127
9866	2vaF58zXY9qjmkzzFxEewXtab5caXmnvaLL6Z5ZJnezite5wgkVa	127
9870	2vap82vgw1rVHVdJ5c8qTeSq4GGPKSPwbj2jVPrRbJRMLNDWkJLB	127
9874	2vaZFu9FnnsAdJ3Xeh8heW2tNeg9p9JoPUYYA6FybCbamPbft7Qc	127
9878	2vbJAG8xuwebScJhbnJUP7FBVaLdUrA9aRUV2t99vSoz4kund3wa	127
9881	2vahf2AN6y18MJ3CzfyDEXrum37mz8NLwjX8Fyi7S9dNhY5YyihD	127
9884	2vbfYmdqkRjgcFVhiZutCbq7c83nK9dpq5YRmBoJAyDw8usUNYvW	127
9886	2vaNnSWYMrR8F6ja8fYiyG4nmGxYfCjnkRNN8J2Tqkt3kX3s4RfV	127
9891	2vanJFrJgMDpntahNJk94VonSCq9Jwx7PpG1YstATq2soPEn7SCr	127
9897	2vbQhmhJBrobPNXA7K8UkhdNtzHe7Bw93567qh5ruDHT3nhD6KGa	127
9898	2vbbqX8TZ1v2gjmEMN4rkCLx7gM33iLHthgAcE9eTD1kaVdXZ8Pa	127
9906	2vaAtUKVcLoBxeemuYwzjJNCow17nY6shKQQka8LVdKsUmYZVJAL	127
9912	2vbUJqx2cUsULsLVmr3jf4u1ZWxCLwH58A819hM4GhpeY7ZbyGrx	127
9915	2vb9KRhQKjyK9wrdtUynaxwTTrxrpCrnFgE1TTVZNq4i3yBmAVY2	127
9920	2vaUPyxyXbBAF5x7gqD697YYSCGLQutEpguzgbtejHvS8P7A9jUa	127
9923	2vbbJ9AzRZRvCHNxLTesvz7rQtdLf59VKzv92yaWq3cZ1jqfbrDW	127
9925	2vagSxb6gmYpVEg8jScyK7cgsJBQbbHa5UrCSm1Vju2yDZEW5Pju	127
9928	2vbpnVcbMxk21W4Xp2ej24uzPN9YsYhBN2Y5u5bsZfGkSgJtCk1j	127
9931	2vaXed5sHgA6k1fEx21zaWfRUmovUPtGJWUEg9eDVRVoHGn8orJj	127
9938	2vbRSuPSZRsVpk2meuJUg5gZJCQp7BfoJTFGmFpFcabdgsFM7NRK	127
9942	2vbCVD7E1gTReH4mkAmWi7Lt34tDpzqvogJbMM8XKqfDcG5NEYvb	127
9944	2vbppB8M6UJTDUFmBMwFUnV3oy89EqUp5vRbpFBwfpwRcPEFj8t4	127
9945	2vbFhwiKNN6kX5PxUX7oVh54ob1ZfKsafxJFybdKQcFFtR2WVqYY	127
9946	2vbqro2VQEJyzZoyzjizNBQSsjQCDKCAuFybBU47rcw7xwjwzbre	127
9953	2vawtwxrDot4iXJQX7XDHpE9F3CRWSqBVP8hweKqjPC7PJFXkTN7	127
9959	2vbAKJoDUYQHhwxfzphEHYy7ZhQQhwbpZMpqsb9jLATQ7NQKZZKX	127
9965	2vaZumhtxD65AyWuJpnNhGiFzMLDSrcwPy982TEe4hB2VZsFnKPc	127
9969	2vaWE4vpih59DnhsmeqxiGrrETu1E6AeuQAyQBD5o83dnNs8eMYJ	127
9971	2vaXUKbmqwAtKXTusZPZJ89VUYgjs2WMupVvnXqovn8GpWEDvt4P	127
9972	2vane3Dx4HHVd73yqzcPJm2nHUjLvK4osVzqzF8qB9DfmveqEjsZ	127
9975	2vbPvKPEyrNVBJHoLQLFSv2tc9QNhJUd7Q1s9jH1PgppN5CfxvuH	127
9979	2vbUmFNVwfrgxeoHguV15GtWr2MCrQ6BFdt1a7aaxMTBAeQxR5nt	127
9985	2vb9Gyue8uUhtTzCk8K8CTTVzeaoEtVkWneGteBun72xLA7oopcM	127
9986	2vbM85gnD2BUdemGZ3nCkLyW7fWE3BrqMVezg5FwkAq55fhBEHLa	127
9988	2vb8GCkLQ1XX5JUxym8KttBB5gZf1Y2KMgFqSLPuu6bEVHRAutS2	127
9994	2vbYpSyHpck9YpD5mqromX8BD7pevazf9MQAyWurpbBSGRMszifZ	127
10004	2vaUteirfuEhEzLsJb2HmmfiaCdLdBPuyqyEZYinZGF9HhzEcBKJ	127
10009	2vaP2GQuRwy8gYDVT7DtNtbzcqnuPSeULmJ2wGGr33ekrijfT8bM	127
10011	2vbTHNA8iHzinc5CdC1UNbFzcmuraG2wrnVewFb1ckqHsx2s9XfX	127
10013	2vaN5kCfjKF1TofH3QiQrvid9zpURN7f3TAAH6umRiKFLdgKyKVh	127
10016	2vazwDf6oG1wBVRZpavyL1xgbJ8CbN8HY2bV8eZH33QGyG6TiPwk	127
10020	2vay6JyBEg5Hjic5bPAXb5EZc519VzQATqXgw9FiQFH33F3SBcTG	127
10023	2vbRuJFp4jh4WedTTHmqgDaQj3XPzKioMY5Fordxutn3UdssLotj	127
10025	2vbrkwF6sQ1qhP8jB8Y5C1HNGeB8me2VmVUF8brcYXJYmEhSRHFc	127
10028	2vc26jUjfddGVV8vqLQ98b68ubFTL9i4eZqRxhzobN7VvhHYJMw6	127
10030	2vakTKxDBNemtMGwjK11c1zNqZUi2EZwyHvATp6s9f2DGnoFkDNj	127
10032	2vb3BydjvE6zcrVT8H69mY5sruLtJrnnQ4QEutNEQwRHV3XuXfab	127
10035	2vb3z4mpY7gLDZKF5pdzqG63jkGGrrmBxubdjzqroBkXtpdHPWM2	127
10039	2vafE2qz2W6aqp7VxhvNBTAGDbiSUdp2ER1jwBtBB7Mhn2F1m3Fw	127
10044	2vaFh89hCcwumdbRiWuoDafdzNL7hDPDWWVbwoZh3rqjeAs1YwHW	127
10052	2vbygsweLd9vT1ERHYHUa2Vnz9BZqQMHErDCz7cH4BLwPZpVTLRy	127
10054	2vb4WwuJezHm9Yz2uTWkxHTKgNHCX9ChLgFE8pr2S5gUZPrbyaqA	127
10064	2vbi7cJy79qxxuLmZcnttooBYARF53ZDDHDVSaXFEPeTmbVp9e9s	127
10065	2vaExCDd415avPQ2anKoej3ZHgYKTjtqVQdQ9Tqx2onMDxiNtinF	127
10077	2vaeb7FsiTFiNUhZ9es4vdtXcMwsBw6QDMUfUB73QmVZxa1tADWe	127
10090	2vbMPjqJsTxfyjeJJHfoaSrMxSFCovZFGMtwfraKuiELRvL9G74C	127
10094	2vaqo9smL6HKYdvNrw3nAUSuSU6xzHRbjk5Sf4UagqZi7AQjRWxu	127
10096	2vaCwdsQhSXiWJk5x3V52gcDKSRK4y8K5U135CLut91UCmFYRJhK	127
10102	2vbRQg7n4Wwey44KPJEjM38bfFKWZDD87UfxJ2vh1vKtc9J8N4Zz	127
10103	2vbcW7658GyucQu8hpqAsH9veXqd3bWBHSQCtxVa4PQNsj7DpGMW	127
10106	2vbWvCX5yP43DmkTMdVssko6tEaWbVavGbUQpoHJxzJf1a7JCouX	127
10036	2vbzdBTCebfDpehjPXNZdjo9pK4gcPVHArmzXqBvpLUhcqTzyvkz	127
10041	2vawk985t83y7evYiMrVJVcQKdxCL6at3HqnK2SLUr4GcNZmzcKP	127
10046	2vbvVaxEWAU8z2f9nsonCtvN6TKAQrEFBh9i59d4pAtuJ3ir3UDQ	127
10051	2vaSFX9PMPRUdi6Y2YaMqAdoCJvdz8juqaEBevoA2aaf5SjiP2gH	127
10058	2vbnmnNra73qpiKdVW2LRS6qqzTKSDd7MoK1mhqPUjNTPnCKdJXb	127
10061	2vbNkVcWu6sMD56Sz3nXaQv6mRvJThZr6tckHXhRPwaKZj7Ar7ed	127
10063	2vadYvoRsT1XoYjiVABPwPM8KWXDmnCnZ1ykBLcoNdTKS9gi891Q	127
10067	2vbuVdreRP6bhP2Erq2ZRMrnFpHi1dn9wjBnqa2174hvETtuw3cH	127
10070	2vaYj1bKTwRw24KdXS61F65v4uxfhErjFVmWi2WHzz3HwdtAgBdG	127
10073	2vbAFgiqLTbxyoExXJgsiu4PzTzrfYvWJ8AG7UUCTxFgQAax5Fuc	127
10076	2vbLiMDU5pnGEKpVTTS5uRdNSJX7TXqm2Ki8WKPK5scEVo2qohAQ	127
10079	2vb33P96LWgfxTv2rLhoxcDi7JWGAPLFtpNwkSzkHKQWB3G1VGBN	127
10081	2vbiRhUhoh1k883WJTpSqP4HQgjGQ4vszdwDBTcNnMmBGbdkhUhL	127
10085	2vbgJXhu7QRvEShWtvR3XcsMYXtvwnxu3wKpM1kSGaTPg9scEMrL	127
10088	2vbt4wmq1yxsFxcP9T7FsSD9qR3mgBXHRcdHpyvfLgct28oG15rr	127
10089	2vbLq7dwdYjnWrTVkGtSu9dehCVXQcy9cLgoeMKLkMYKRaf5JMan	127
10093	2vb3nPSDYxcbxAcE2nUSevSM55jD8nmMhaCUP4qLtB4B8XA6nHNN	127
10098	2vbdTYUN7SU3A9zWxx3y7a8ZvZHyfQE12k8QtDhFKLxvspuL7819	127
10100	2vbM9s83Xp1GMo4kpN1ZfwZ1XCGkoRqYa2W6bxoUANccC1TYoq8v	127
10101	2vbvsLe3dvZ3WJN8Tej9ruun78DJKnz2omaVTjFGY7mgamd8aZfE	127
10105	2vaBaH2UGKV3yEshEPXcoEEEg3FpMEZ5HxeN6sqDNv1qCgxZ5SLh	127
10112	2vbBkbir84knkqQGrdiuGzkPoa6gy2YUhGwNRoRBxzvFRJ1CKERX	127
10117	2vb7drPQBBUmsDWu6o9iPSMsdJWdDNeRWtg6kAbmUtd2ACvko5ke	127
10120	2vbnJ4q35xrX3k9ueXkdN2oYb2GfGdeLi6CP9V2APPDvyAgntTuu	127
10124	2vbTJeKvoD6yGNm9ByD9m2jrWyxMuHaFhmvydHcvq1W778GGN2M8	127
10132	2vaB1ENPSmr73TptKNodbjCbAEERpxA264AcSRG2YyisKQNTFfeu	127
10137	2vaKJdfuxLqtEyopk9NbsvGjVAqmfZ8Ym2CTn9MiTviqYKUK9CeQ	127
10141	2vb7dVTWse9dNh47NdCaY9RAU5cEfzQaZ9fvYvQYbYaKTLcM7asM	127
10142	2vbKhg12tU3n68rsnMf9g7ujBsPAbgBqwAk2VzJk2tdK8hintUMe	127
10145	2vbR31cATvNHeqadx36q7zrfP1vzjTPJGkVGWmQVkFPwkrv7Zs8L	127
10147	2vc2CnJ9KFbSqqF8c1Jy5HoBco1YwA4T79ULmenhWDhq9JhyHrUc	127
10157	2vaUG7dLfaN5wgeJmhGZBs8JBwJoJaLHr663oY3F5sS4LfiBNEiz	127
10165	2vaoBjQR3DTf9Lh5NnL9Zbyk9ViSHvLD3aMF48PPL7hJCm2sHcrP	127
10168	2vbsnt72VXsNsacjMSfnuseb4s9GWHqdujLH68Uex4zf1hrc6mWF	127
10173	2vaiQwT8hpjxAHEJbazJh6pExTGTixsZo9Bukc5dVwWVXZBReWLs	127
10175	2vbaGXMUrepjN2DVEoE3YxySft53ELFykmXekG97BcBEj5wZmk2f	127
10180	2vbmqJzn5UKkCojzjECAiqJQcw3TsE4oiHFkCs7awNNSVxitp8Yx	127
10184	2vbt6apfGZNkNEqVBC8miWVDXX82pjCW5QU4pnnVaXTUKf4hYUBa	127
10185	2vaqYazvk72UoSv2UEieTGXDxzKnYtCHGxHN6gVfkmQfvkxCc6ny	127
10194	2vbKzk7JeQGxgvBkiQgLjaCEm51vU8PmKdHhNwgy3Hd81u4R9kVW	127
10196	2vbpPNKJq6Jrg1TvfgPYidxMscwr97cKBvWeRPNQjPMxeYzMkDPM	127
10200	2vaUwTChmyUaRTzYnj1s38yxsFTfuE3NuQoR7DyAN7n3vckegb7x	127
10202	2vbJvSvC1RLpwiWyuZ3Lpu442JnevrNoFGyNYDu45vZwiX87DJAa	127
10203	2vb4oBvB8DXyfXGXNcyuWMGd2gDcbzpgysutywBw87wmzbMG5YV2	127
10207	2vc4ERU8PxUMCkZrXPMSBn4GjxHBtaDE3tXZCL8JR2EirwzJUZzW	127
10213	2vapG8FbK2DrsukJdyW3yznsWXjjvJkJpfNyyovCBnX6aN4X4eEk	127
10217	2vbdtdJsQWQWxXj98tVeaXaoHtBTFV49SLQTTeFyJaabY7cqASkG	127
10218	2vbmiXfUkcuYQhdHDqwPa1fDjbwJxxcPiNzKGajr6S81fgSrUXkY	127
10221	2vbJH5sLpiP2KsEpNMH11Sy2duDDbjguv3aUeSHmSL8bhrUfs1Ku	127
10226	2vahrWY5eacgNJCXTSkNLTspa1dcmV5J9DTv3QYcfFfmATJY4WMo	127
10229	2vafPAsnhhzvRFotA1YvbzfE8qvxe6z66eUjJ2NhRMYa1xo4tpPa	127
10232	2vaSnSZVFEEx5kEerzz4WMh3UoTs7h5rYoWTiVTUxHJ894e97YMm	127
10234	2vaFFzu7h6muKBJ4XApUc2c1qxZf51JHnKA5hK7SqNzo3tVpdvYK	127
10236	2vaFRWw23NHD7avqhn77WCLoFBC2wuN6d3ty2MvHTHsdsWFEg8Tx	127
10239	2vbcKSh4eXskLWGp8QJviYrwXv1yu44EEca8NbwKWdKMTMnGCDBC	127
10240	2vb98yvpbcZtHaFzBer2JBhTGPSkQHm5TH7t9jyG9ArvkgS3BJuc	127
10241	2vaQfNxYYcEc7RthVDQXYr6F1zQCbpmVd3n4ABwVJ2VTLa6QLPzQ	127
10246	2vbRUfcGTaAKbrFTq8ziqBmeS7zrdmRtikUJpKtobAUQ2VRHkMZU	127
10250	2vaYKWwzb3nfD5ZoBiTd26tTgTa4eGAy8pMrNXq4ZJsiZvaJPxaF	127
10254	2vbXxWSdDkKsQoKuYHzd4UcTVrv9wa2osuwLWrieB34FdqRFVgJe	127
10255	2vbiHqJcYdQoFYV7SMgm4fcNEEH1fNdBRti8nfmUhmHpAeo5FmBU	127
10260	2vavnzXpvmHkRdDmRgCw9PVdwKZYZYWt3vaCKRZvox33gsqMX79J	127
10261	2vaKTx2a7Mdi7QtBTH7deHerT8gsAwpx9zu68B6X36ptBboUJHfY	127
10266	2vaKsLRp2ah8mSkYnK63N8FoapxgTcNx4dp2dm4vZ4eFeJ4ZMzcb	127
10062	2vbrXLQD7PHUxTtCnDEt8s9JnZhFQudARhciuEMCJiFWALdnL7do	127
10069	2vaxqkhBP9rERpecYvexQTxdDM6LwiYXtq7TLmZcMjuqWpfWxCam	127
10071	2vaQiiML9eYHoXqc3C5Vd1E7s5RjJYmDwjMcbnyoqvTMx2BtfVFg	127
10072	2vbQbnRDqneLf3ZVKQV2rXf4hB5f6yLbw8wfqNcgfZMop5bkN6Pv	127
10075	2vaggESvTKbwiprGC5Bp4jF2SPCZ82CjBAm3bSquXgBcTn2WMXqr	127
10078	2vbWvrNncaszvAwDdDGZuttAPokRvmfswEXdcWZJAYayQHD68soi	127
10080	2vbYTKEUFrv7aXaRfLHPG2fRLKVrEcshGqktStcDm4nFzBQF2i2F	127
10082	2vavMGZzkQmBC9fAtkG12ePKKudsy9qSoSpZhzR2ckiCJMXVvXh6	127
10087	2vasdksuU4AtFp1q7S6ur8UoZVruYjJj5G14Cz7bLMcDYSJJqYan	127
10092	2vbxzRk8rQpTFoB18ZHkfVymuoZArSZeok9m3fbc1moFQmdoNFSK	127
10095	2vbqsMEZKSYBm8v1aepvqk3R3QFdshB6aYkx8jfPouWF9BNmfV8a	127
10097	2vaRrvLzhwg4HccYQ5L79gneijtvB66jA4oi5sAXM2sJDdqyqefp	127
10109	2vbVmjqr7KZMdJ4EaiCwwZHkx7N2CozSan4LvJo33YPA4cKTStfi	127
10114	2vbsU6Y59ycAg2dvBDijt6r22VP2XJnoD4evGfz5P8webvL15ZUB	127
10116	2vafE1EkLqnm34CEMWTVsLwQLbXp69AZ5JxfF6Tjumtzq7XvA5pJ	127
10118	2vbzzHvaJ3QGAx8t9BudimURhCoV34hrLWkgiUERoZeZCkhZ6vne	127
10123	2varV4RdjYPhsE91TJqMekmS2WkTC1Ag9yG2JkvvBeQbnDfHSZV4	127
10126	2vbpS5HyTHoLH6jwosW4Y2rF1rV1aUuZWjCAkKhE5Jn9dXtUzHsX	127
10129	2vbL5JUewa4QasJqhLcPL3J46vCqmWb9SH9USaCkhC5646dqLfxz	127
10140	2vawmgFvqcSQtLJfCrYKoa1gxuzU9cAuWAN78ay9vGwSq4isvkVD	127
10144	2vaBjzYN3n71FkCXP4tzYFTcjgMZcETfNLy4eP1GPAeVgtz78KRU	127
10149	2vaoWZHChrgQMQg793ywhKatRr8Tks45Lf841Vw9PG186yku6Cx5	127
10152	2vboJZJrupvwSPhhN2LRkLNazuQ7tT5uaY9L3Yfuzx7oPYViQJQv	127
10154	2vaYE7TNohMkrafuvnHvnqKqS83JnoMD5AvhyH1m2C2UY1EdKZPd	127
10155	2vaxQ6LcmpWn1pGAgx2eBeVPmwFq85JVwPZBVifQiD2pneZuu1M9	127
10159	2vaez5PVACcBKT7ZaCms15nBJc1wUsFxnGcwQLouBmL2y3jKL6nQ	127
10161	2vbbHyYGzynTL6sMFdSH6hhp92AHocZWtD4TAXT4DkvL7djCp94M	127
10162	2vc4c7AQMCyNfZZ95XEqMhbdz2Ei3KSguh8yDCjqMoS7cQwyhUqV	127
10164	2vbcRVBTCFd47WuBPi84Un7TGCTSvSBN52pBPMsKBjnnBo86S2Hc	127
10170	2vaZDTWhtEvL3KGKyYHUP5iNFPVSZdZNCFpuxdhrn3aR2efzBkUy	127
10177	2vbCQmW6fLbc4LxZzKoMCdQqxQ8ZiDW5NgNpvFrSy9uJbk9S1qtW	127
10179	2vb9Wk3u1eXFUjmp2qu1UgGqEEGxAHW1q1f71imsyNvfhgkrqL6U	127
10186	2vbmEtE4mgftN3Ktiv94Ey4VcYFQfsE1pgrcQcH3PrS6xaakdsmP	127
10190	2vbEAU5KTp5p1KBD1SNB1H8G5exV2MLnwmWhVY7WziyAYCvnFvnF	127
10191	2vaghMi7povuctqrT2nRjao6Mc9soxniCdJ3ipTcXSroKzHvE8p9	127
10198	2vbrKEqzvarNeNuF4pjwMdoXPTPSDNDuLgu2H2q4EyBQ5sjK6e2b	127
10199	2vaXYzrCwSvVxJRrPdee11SdzknCdpaz5sf1JPURsopGjEiTz9oC	127
10205	2vbNxwiy2g27VdqWgV6ZeiJetAK6cfNCVK7PGS2F9Spx9Zm5vcdS	127
10206	2vbpH6MF7unzW1yJ4UjVTa3NQuo1F1uhAZn3wdkuknY3NJ1UQtd4	127
10209	2vaNmiqe2tmBXHPcdeakrj1Nga9c3ZCfBpx1AzXRnjRsov3Kwt91	127
10214	2vbw9KR3MqGMTfKdn565GgJ5VJDaQCipAz9GJiwJpt2qzJ5veew2	127
10216	2vbMxgw8hWfUv61r86YbBm5ED6EctdhCPv2Y7nnwPE1RoQLrrRYA	127
10220	2vanFcLRoCrysR84TpCMDHo3HvX7aYGUvK6sVDPh3oNaJFWa9363	127
10222	2vbdVNoKWhqMtjLs4DzVczopJEHohXqx7PaHV2rV9Y1DvazWd5YF	127
10225	2vbTVjiVuetvR3eaGkpeNgSWFBN7k5ZcN3zVg6LEZteoFebBZ7yd	127
10231	2vc5XPzVmGHML3LG4XdHHst7nxtBr1rE4VhKErWXw6eMjEyFansd	127
10235	2vbxasqDZ8tiqH2ZSdtwmL2pczSouoU2fzRyhmL1W7amJNRRNSK7	127
10243	2vaipEtj7dkKHmFaGNwo3LqmPzGEwd1Qaq2dokUaAShFWDALzwPV	127
10249	2vagaHJtQ5SRhqxGBGt76bkrQkBpcJSrk9XVsdSqiMA2RJRNShAo	127
10253	2vae2eQZ8Ubg6JLn64v4W4MGZYhahUEM2qSyv79cPrjD5vpkJnJp	127
10257	2vbvAXJpd79cLQVTsek7SfuK6xc2bZtvv66JUu7qK46u19hCZtiQ	127
10265	2vbmGxPDUbansfGnxR3MkZBz44rZeyTjWddVAE9oKTD9QSDbFsMT	127
10083	2vbq7Nm4fpeTfNA6h4JYPFRE2A2sVsSKxgw1tc6KPR3tBuGyfJ54	127
10084	2vbDiBRgj6NzAyLerxeXDff794P5x4QQn5soCRkquYjua9NJ5QSG	127
10086	2vaiTfDfvf6qKFyimxN82tWHiXdp1tVQqSxXdJSoWHSuDZH6v4tT	127
10091	2vazzeN1xMtn85byuVE3vKsSVPukUEMs53AraSphFW4xbe4K8uzr	127
10099	2vaxNuh11qHzsrJzKWX1wgpGY9r4cuxCZbr7nFRkvxffj3NwXVdN	127
10104	2vbAmkEsVeSw5mkBN2HUk1QgkzL9c5wTgvHygNpU759hC9fNTTsw	127
10108	2vbUrR6deWDK2KtBGZshfWhSF8M87ZVyJu99FjjPi1sphduzdGvv	127
10111	2vb8jmxbWxVkipAu4xwpkAMaRKLQbdpndZJ22je8cBdtrdcLtWZh	127
10113	2vbMELqS1NkmfFFoKSU54MbfKAdNxKGDBe3cGaLFPyBCyJmAQeTi	127
10115	2vaniPjukb7Af1PonfxStrv5ssZx1P1vMcMXAa1gkLdQmS3Hd7zs	127
10119	2vaZh8e1ddQ6znBAMt28FN8h4RA6yER7VtYMhyXYZhF1mjemAheW	127
10121	2vasxN9M452sQiF9PRboi9NYbs2tbYMqQc1wC5WD7K3C9aQcsgTY	127
10128	2vbvSaNRFiaK7T8imXF9M2Kmv6dS5C3H68HaFNDm1M8ZFpfde8Ng	127
10133	2vbGGeSTVqc2kdeYN4MR1fLy5vZb14NXgKGnKLEovzy4ccigFjoN	127
10134	2vbz4whvkTzojSSWvBsKKpcP8HkeFGTz5hA5JjeMBi9g8H1ogVQw	127
10136	2vbQp1vv3cV8cxKDNQYbHCBN98dFwVKFufA3Zfe3uWF1EX713DPv	127
10138	2vaUbyXgRjE9rKxKN6bdq4f8mmb2dMFMdZPaXNxvYYLUXDgSCuTR	127
10143	2vbdXBTzAz2abSghQzcfMdapLBYrYc284aTpejzoRD8BWKHZJPZw	127
10146	2vbQ31pz4U8xrcefHnYSvkNKjsGGijX6HJ1r3qqkg4NDy2J1B3mA	127
10151	2vaVWFY24KRc8zSBw2eSJmd1oAWU3cJUZC6gLz2JfHpKVwqBSatb	127
10156	2vc39M5HTdcJhD7m3hiWZre6ESkFX4BbN8F9GzuXeZ2FmoymY6vF	127
10167	2vajddQFvQci3dvfDMVBYMdJFjaVPw8Xn2GvnJpzVUYw53s7Y8Km	127
10172	2vbP3zNvSRaDaXCFpBjxhtHRMmN5iowyfd3dED6wCmwcmpvUYvvX	127
10182	2vaDNPqm7urugRgvCp4KParV9v1JfYHHPcemKhDNo3qonmK3jF65	127
10188	2vb9HrymPsVucoqwPrSfAKFtYbJCgojF3B2FgdjKUF5Re5aBuzBU	127
10189	2vbXJegqL5mLxskx8ezDBodkayGwvgXeEAVAR3z7wyhMhsfFhNtX	127
10193	2vbXhHwPjk2JA5yN5febkiRFGCLpWxmhzYsM8q1vMpZxL3H1LhAn	127
10195	2vaydDjSdbQMAvrki3QUTbcku8KuoGv7ftb3Z9xjDF2xW2GRW6VZ	127
10204	2vbwN4ay7bA4W8r5MkWn7DJKjkTuH93hdLtj2nukoWUT9SsJ7s6m	127
10208	2vbXchcTJv97UwRapXgLAhwyG8zkPDab1brvV9XPKM5jwMLLpDLW	127
10212	2vbfRzguTrqsVcZ4FE4csVijSzeD8ubcDyUsU1CrpSZNvwXn1JeZ	127
10224	2vak14R7WCTRFGFw5neh2hMxp8e9KMgHsdRbFnjmFCyawuHF9EjA	127
10227	2vbwrsF8c8PXEDKfNC6UiPSXwFp2VTAePV6dEraAQv9LU1VGUjTm	127
10228	2vaJw1K6krHSxQ9MMpyGYjegGwAks5Dd5GKgAxKKmd3RFgpsFPbN	127
10233	2vbsHPReNYbGRrWbUywf15JS7qVdtRfY4ZYz7P6NhBdZWv6LabZQ	127
10238	2vbESjyfPi9Qw1sThi3vbEWZq4qUNxeu1ADwLN4dj5XWq9MzWtcT	127
10242	2vaBixboBCBPXXkvxW6Qt7BiSPPqy6jdssj1sD3aBTekRCB8HHxK	127
10247	2vb1TEmck3WD35UX7uCjMS3PKcUy2NkBHBjHQF1DMLcaBdwB6jTw	127
10248	2vbzV2TdNeuFEjPGDBsjuKpzFUcvxRfpG8cxXLtobkgFfeu5mamW	127
10252	2vbHtwJ85KrLm8FdGDrL4BEUcY5nD3GRKPURkyW2sCPhQPGZe3u7	127
10256	2vb1WdkmspbSKPjDwbmu1oJK3jPzWXnt4FoVRWe4a6rb9hbxN9EH	127
10259	2vbRWCBpayibTcjDCVvdLwwCVahAHN412m1rja9jyUmDtjhH1fYm	127
10263	2vbtT7BTkGVq4KWcuD1HnahgJJsgALSzRnPxPNToLA2T1gKhMKTP	127
10107	2vaREyuktY7EPnYNoAY4noxa1pTrY5GWzS1enqXkmQirLVPs9Nhf	127
10110	2varZMRnJ3TQSRu21VzdFnqJz4C79gNFHj25JLYakoip3BXmWNhx	127
10122	2vb22jnbArSroDKDze1v7Hth9gzhbYakDLH57xDnUBVP6qH3x6EM	127
10125	2vahxaG1dJmbfi3QGkcUrCKMSjgy2XfjLM9uDNPSFoKAVoj1un2L	127
10127	2vafoqBFfcSeGCWwL6Ww2nXfyWFeEwMN5NCW9Z6VRmvUKGDRBoWw	127
10130	2vaEg4ATKGZSXCfpPNh8Nk9L21nyKd7646ebZJYLez62JTEBfgiG	127
10131	2vc2K6H4Mm4LU6b4QSaW96VoQDZe3QEi1gPUpgoDfDJwBQTaKp2d	127
10135	2vaa3giVVZVQaabnLcC54d9VYKHAfYLT9CzUtcRvhnZHW3E3mvmq	127
10139	2vaEZBXUpHfgpR8LhCJuGSwtrM3GLGoVGCgGsrUPypVoFgyvozoo	127
10148	2vbMf5at6EaCiiUE96UxtqAcZk7M9jUSFcd91S9b9cYFrAVmPqcD	127
10150	2vayorg8zzJckyBs8bKDhNcufUW8M5ER7H3CDk4FRB2DWw1tXdge	127
10153	2vaU9Cw9CYgCpxnTEzEYTYuuhDV2SjCs11wvxSDKt4wXhk2x7uXw	127
10158	2vacpYty6TqGdPCMVhGszsd6M6VuaJ6LkYiNUNDVPpjxatZ5v7VV	127
10160	2vbiiRJgD7hkRzHGmMvjVZyXNc3yyxosweUPsG118TR9PWoy2Tck	127
10163	2vadqwTGAKu9mryJBkxgmtzS5xdNEnNohDmGHzK7jpd4iPjPsM2h	127
10166	2vbeZQ9Ggg2vGYJxNZveswz2fsokBvJBGQjqM1FX7bpckXsXvGhi	127
10169	2vaqFrGTBEY5X4VsNMEUuiqBXG5e419MApecJbz9rRKng89mak8Y	127
10171	2vazu84eoPJ43KBx6fi5teyWHh7n3rsKkj3c5ykQ2bgpX9BuVC5z	127
10174	2vbb6Kfswzm3qwycpg3rtCjPtHfw9zrisLCVh9iLk3oqTdL3wgeJ	127
10176	2vaTTPkFeiiUUspDcrvSTpV6LDWVBiEHdAHc4T8ZDVzRuDeGG7Ja	127
10178	2vbe26MZberaXB7b666tPH9q1NNbUzFoWgcTpgWNBrqXuzqE9wES	127
10181	2vaZ2cjHqhWLe9AFYfVA8kwMLQ9fcucwDDMBgvZroycxE935sCTW	127
10183	2vaKtrFYjeG6HCDVdFvqo5XkmKTfaVFaSyWbMDEwe8rBG3gq4PmC	127
10187	2vc3CkdAhDDCkZASTUetNmLQkcs7afi6fFD4GmW2x2o22TiBmobs	127
10192	2vaVgwyVmHBzqwYQ4CMiQsphRwgDXnpaDZwgrzSSXEvvre6VW9Qx	127
10197	2vaSRtrmzhGJ6NLq1rLvexUHvGgDZfFU23T8wypzcPPqHpTjVF9n	127
10201	2vbwTUBsifbF354HZW789i24oK3ZjE8JFWoL2yg5RYQbNHwPigwo	127
10210	2vb6bJXc5Qp6jE2AcUa34wCJRGUp6gKZoL7kCDsHoBSpQXq8JogT	127
10211	2vb3kdmWSCfjtiG3EPS1Vr5sfiLAQUNRMTtGBRx8L3B9SHbvwGJ4	127
10215	2vaaaP15cC848hr2SUn5oUndLQBsHpLjErHC8Xfk3JT9EiUByaLB	127
10219	2vahkzKHkipREjtbAxXw25uXL5r6JH8Kq5Xb2LkbrSLnUKgEgegu	127
10223	2vahTPr71Zt7hFfBxsWLm8NiAFxjh51z8MJf5hgU8N3zuTc4Emc7	127
10230	2vbvptbuqmJQEWLB67HaUKmhfPvbRW4pgNgdZHP875qVaXCArGwL	127
10237	2vbcJ8Lckg9x9yAHVMGT5ub9EvUkFwuKvFM6xerPNwBqGAfznEfv	127
10244	2vabCYt43kaHpHxV3sUBjxjrhMDS9x1gEATXSQ7wCtbWzhK9ZWVs	127
10245	2vb2CVZXSZ6ameVWegSKkGEQoTcw8YswxsnVzxgQmVGJRuMpkCo8	127
10251	2vbifAWaabjT5wEFNWbBB3EWvAw1JkAkoPMqsdCiR7iL5UVPjpn3	127
10258	2vbM7yN9kuw1QG8c3mHfskgavDfQPhnSWrrdmitcU45sxsuggHcE	127
10262	2vbyAdLtyGNmFVu4ANm14Vjs7JCsXq9q5gUXW2eXbtwi5ZZEyz8k	127
10264	2vbj66RxknyRyv98JVBHrAiaPaqLVrAYExhZKa3PYeBXs3Yz5d7J	127
10267	2vbscGz8QQYFUxn3j66XWZMnG5w2tfsYXJaWFsWeEfKGnU7LyWd4	127
10268	2vaCS3RY7nbdYE43qygd5yvomQ3hEHkEcWp7pJDgYVSCp5CQfC79	127
10269	2vbwXwLkwMZcULp42aVX7Eee1TvrxounXJynSJKcjannfi35un9c	127
10270	2vauG1HyYN32fMxuxgRT2nLuRuJNvnEXJXJVizmPtU9h2rbYegun	127
10271	2vak47GxbJLUAbqJ4NCLvMtBDUGaht2EotTu21VC6XyAK76CJbgV	127
10272	2vaVdGr5akfJCQPMAMDqYTwonkmNzFJfc9rg9HX56PkGdeb3fbuV	127
10273	2vbYBwaYoTbZbbEGqWSxdZHcXRwPMyvrNijcjcBir5E4VWc2q7Rf	127
10274	2vaQiBHxc3GSiQCEE6sniWfbqfXfvZtG2AdUTwZY5Qym4e4Sdq6t	127
10275	2vafdi5frddDBRSF8xnwnyswJUZXpT7vHGWSFSTtAo5QY6yAdopj	127
10276	2vbUo8yKeKLCPSTcDcmNM21xvophmgWLCNtHrRunNivck8XhoYZy	127
10277	2vaHXdc5k5XSwJsKKGxqY3dSe1Bx5mUPeBbcU7PLYx73zXV4X4v8	127
10278	2vaRMZZEFLVTJJyTFLHjBqQ9DGCFqYqKgxc98SmQ4F9MwU4nLNjo	127
10279	2vb4gLeZNkZB4nCed9tEtqiGYN5cETGiRXxynzcyiRS3HYwhNyKr	127
10280	2vbTnxrvTvgZ4VPGBX1mddk7eeK5vQtvtrzExwPh37jjTEDnimET	127
10281	2vaGnF9ZNsnMfUPM6ZxJwGA4gKmsMJZ6cDVgxGfAbVzLjmN1WoqL	127
10282	2vc5cSFNckFYVRHdvo1ELGtmkd44kcJzgWzZAxLzjiuLdBExHnS8	127
10283	2vakH49dVrgU7HzTEMnW4C7YAAtPubGzbr4jZkdPqmfo8zKsa68a	127
10284	2vb62QHvHR8b6hF5XbwfoQ6JhakAc82xGoyKp7suXXNKoQ9S9AwY	127
10285	2vash7DqH3Az3UoTbzuexWUV91Sg9vgSf3DN1VYci1XzfmxaeNx1	127
10286	2vbuwYCPwmW5KifPADvMjRVetKZhGqnDRS9Gkp1bwoJUoEjxbbYJ	127
10287	2vbLhqL7wtimU28TKUri4XeNJzguXD33QgLrrpjwxqHuTQ8popgV	127
10288	2vaUX5m4kB1MqFJAd57JoLpoYhU6mzQSP6V3Ev3WnenTdWKaTUXR	127
10289	2vbVnPxtnUQ2uP4NRBaRYaPY3UfCPy5oGjDejYWS2porYcNvdP78	127
10290	2vaEn9zCgReZgLFoK3GGNFsD1bpT5Jz8oyiHmsqwP8Rfo47LE2ps	127
10291	2vaictHpTDj71te7Gj3sFcgUb4qWsGGv6SBnjq9a9XpuwndNgocG	127
10292	2vaAWUddqnYhj9m9xVxAxNg55Skvf3cSTXNtV47jJYz6KxWsjuoH	127
10293	2vbeecp18RaHhVphxfQqCK2UpZg2faQoSnuBR7aLKEPjh6TH2dop	127
10294	2vbDarogRPiGHkB4C1aT9eRyMcbsZrGPm29Y1r51oz19URNRCkyc	127
10295	2vbR2KUh113MAn5uWFcQGPWkWAwnZkc24Jofkasg8WfwJxMVh2tD	127
10296	2vad7JR66TM1mufjJyT8hrzyWGjiPnyJGhNA7mYg6njoQbYR2wnk	127
10297	2vaCb4GiZHLoSUs3zFNoPC6hV3QuySfekWvtBXdTHCoHrYTTc5oc	127
10298	2vbZtx5rGGdXFRvDF5cMgyowahGs8DYmwwZB8NeJTu9VZcedgt2z	127
10299	2vbQyAhJ1sw6WdYc1m7bsGPpGTdPgpsE4Mdymxc2b5GSns4fgiv5	127
10300	2vaqDHXYYN5qRySDneoRGzEA3DTu2gWretsP8n9WN1goUqj5Q1rY	127
10301	2vbnkJDz4BE99tmDTra81pBAYK8FDKKwjJA9vrw2ZGnhELQyJvcr	127
10302	2vb6UcZXghvqKaZBrpSVmcxUhL5jxSGjWuZzegAYaXckRr9mKWeo	127
10303	2va9Cbm3dUeVBWJsfU4A24zBHqsY3nzmx6ezHjMzEMU6Cp3KKx1B	127
10304	2vbSpQfSG2JTkPS9ECnqEVhGaXFRfDZUYczYnzdPY63vkmEuiPRF	127
10305	2vbNsf57e8prQCYdD5tHRQkmYHiNdMgvHNeCKHkvuW5oi6Y6m9pH	127
10306	2vbomdizbjPcZsLF3ayACtfwzxDyUm1ogEqMikgcLbhuLwAHJW2d	127
10307	2vb51qp3yZVknArKuHcX7ZayYPghyzbsQi6RYdg2Xmtb4ya5o2cZ	127
10308	2vb3cQ85MoPUxubbEW5GUkY5nvbX5RzTdJ7nxNdubMHwjKzro9kA	127
10309	2vaHeGARnMNwQKR7fJtZ5Pobvu5fPSZixDdsqPNM1mtfSaY3YX7W	127
10310	2vap22xPZ2guxBeHrzWd2rLBLXN97TtYouPJrDTNYdxvUDngDTRr	127
10311	2vaPzs9cqC4dX8tvs1ooCi36FZFquK9P7FBzdUdEub2kzyaxFf7f	127
10312	2vbQkvo5YDHmLSs7D6Jf6VAs6vrWUUkLPeqw3boSVu4iTTUVP4J5	127
10313	2vbom5puzwRTHUsSc5z5CdNwgdZQvoU43kyDTLQ6bkAAFWQtuZsZ	127
10314	2vaApiEFUUJKNyC8JSBDo7U7PNVBMfgiHXtGj2BNeXZzX6jsaMZy	127
10315	2vbVkW1sStjucbVTqTXMgn2ozDJ8Ko1MgJiftsraksUTvWiov99c	127
10316	2vaUQT14VQFA4j2R9RV6aK7YtVfVEpN55skA1N9APy3ptG2t8TAJ	127
10321	2vbd5busrJj4TyYsngwd2f5U848NK1bpei9VDoMLMBtVzauGUsEm	127
10323	2vaNFvougnLA2dfdSxR6tmn6QHp8uBRqwwSATytb2EVvrYDtciEx	127
10327	2vbfUHJbD7SSz41hnMPFczaAobsXoVTwHGxfcf9AgJmKFPqn3e37	127
10331	2vbHXfEnyyBj4LZqcZAumT8NdpsawHGEK5V2ri9C4fzuZ6oUEBQq	127
10332	2vbyoKr89jDEpQYQaBcM3r3GURA2eDiMC1Aqbq1Fo2KK2m3mrkUA	127
10335	2vax8zhRFyDGcTJ2GWfc16tydeKy16kdyqRNRQ95cEJTmGgnsusg	127
10337	2vaJLzznrgdAS5aoKWcjDnCkwYJP4fbCf43TEPrjAFQwKDGDi5hS	127
10342	2vaLzeAY8mvqAU3cMQpxoL5iMyXqoJYrKo24yfESEdqKqqMzWj4S	127
10345	2vbMXhYKmGKxkHskwkqU8kcLFkJvgvSJE21ZNT9KCptvXv498psw	127
10350	2vbA3ydi7WvkUrUASKnkFM1qPDbtdfxSFMAk9rQEnUjK3g5xt54e	127
10352	2vaRbe68R5XDVNU56htAwrjMfDD3CNgQSBhU8Vd3ATux6HwrSQEH	127
10355	2vaRK6kvjwnmcpchqEC9qLdMDKm7HRa1oLgg2Wh8ynBY97syCKUi	127
10356	2vaRrpJHS3VKDbVVFBYRpPFeqN1gXmeC5BPA65Y5cLGmDBwuXGy4	127
10358	2vbS8CDZCpeFEfuQXHABzfmwqoTk2TiJYUNUukksP1kbppj6Bkns	127
10361	2vba5yJsrUeg2e6XkFNMrHdMkQ3iQfhCnsjggJ8ow3a8naukTshD	127
10366	2vaD5gHouaaX8XJ2CWraKApLmTicf7TH6kvooE9YYFMsjaS8Q9Gg	127
10368	2vaFuc5mFAf9HZCqpDg3vU1ijgcxEttGBCQd5ygq9EkE3ABamgco	127
10371	2vbth5XSchcsCKA5aUUvGLdvXCKP5EPRE8Aaju6qkKo7RDzwpZgV	127
10380	2vaX839t4zoYJx8ySyrdjBJhixcd5CSAdHxCWWv2Z1MR92QDoNax	127
10387	2vbPoJMPptRfbXa3N7GLsSdTkeoWKxapUxCQXxctjpXYc5Bv8cDL	127
10390	2vbxGyXf1ScDrVoYnbsWfGoyPqkdzEWaiAACDnjgFq6oqjmKd1EG	127
10392	2vbzb2hAVPwi3DEUH5azzchVj2vcdKqdXiCxJC9MmFdxpkgmkzBL	127
10394	2vautNjBNXnELG29t5pxtiitr4phdBmSyHZTQpajzJSnKdU1d5qs	127
10398	2vaRb8y9pkZ2a6r9SXVpSU3Umw37MeLgaFL6sAzWRdgXpVJrw3Ju	127
10400	2vamSV74oEC6aHdumUUTpKWuxKLmwNeokeTiKyyRm2tecWw15Zy9	127
10402	2vajhbh9d6UFJTj4rrNhcBrohSusyYyDSnQ2tNqsp7A43KVpWJEB	127
10404	2vaTwYN8P5vXEvJrAXvfKdxfvj53mthdLp8iiyopdsid6PJuFzwZ	127
10415	2vbCqrmNhZTufi5N62H7qAZCzMJPwduqyNhSujVFPf5aQxvJbN3W	127
10418	2vadJt2dgqrB35EPWxSJ5pZcXAcHakedijm6zm3TvSSr6Mbp8Da7	127
10420	2vaMZxYtxg1od88LD6jGLJSNxtZyxKS8HbcVrQQRBXU62dZboUGH	127
10425	2vbkyJjRPiD2FArKG3L1z7dfEEtuvt6NhTKnwQZhvyF4XvNPnYuE	127
10437	2vbqKCENnZGT4x8psy9E53kjU9NunGu9msBa3U9q5VDjHPpECT9N	127
10439	2vbBRDVswGHr2XLZ1RcFQPYbgrbxnfP26US5hBE1XqhzkqQSCs4r	127
10443	2vbt9ZaLNHvL2qu71Y4yKqNpyzGVe9EDHJW7NYaGG75DoqVBDkJM	127
10446	2vbfJ7XtKvQkxychoUwyvMeMJro4PM2xr6CRQAHPxCQb1XpZid2u	127
10464	2vasjkre1yd6sA764TKW1jZXABr1oQi4vqyRY5XHEvTg4nrgfEdW	127
10466	2vc2MpNMrtoWSdtMvNm36ha7dK4M7jn89aNexhpMydv1ufELpfXM	127
10468	2vbhcvdBSHHKBG8U7FV9iGZTqQR2sNniKmrVTTaYByoWkQMf7ujt	127
10472	2vacNo3EtDRo52rEdzuUQSyXPsnFbPg5D9xKZ5eMCsrMFpzJvcQQ	127
10474	2vangTU53DH862WSTEC5SrhLhK6oJ3HXbvksEMSkZcXUhYPvcznB	127
10476	2vaFdnpo9g2MsgXAoNfeDp6WgUumeR5bHF39ueefv5fqqRovm4pd	127
10479	2vam8X28FtNkYR7d3A4XswdonD7vM7N3VLcjmUhX5PEmJv9XTQv5	127
10482	2vaS7DsHpGeABg5Vv1d96L6T2KdpfChvzUkGMthPqfy3t1gnLeFc	127
10488	2vb2fmPq4p6Sw7JGWwgL6uufGRdT4ufCAMhgaPEDaggZD3dddwgC	127
10490	2vbV4W7m9zni7cpUFANeY1zZHg8TuFiSY5D4vZRYjbhZ5oB6yxpy	127
10493	2vabe9Jdfg1vkAQDsYeUkTNLwfrwD6Dc9otueQMnsjgtjcwenAEf	127
10495	2vbbizEQxtnWkyMjLA4NJnTSZSYbhjvqg6GszLg56US5P2HVyueR	127
10496	2vbNqaZuHgm1g6ECz4CqMUUJqDu84bpmbDLtz2oWoy4kaNYDwJnA	127
10499	2vabDCCigeFXpMqwNdjLEpcDm6zL3f8s9Na92DvKnHc8f1GzM6MG	127
10501	2vc5gS5XcmbGCRaTjKdn4fuogwNkz5Unv5M8Ai34zXahotpNHHyP	127
10506	2vbo6vPn4y1bMV9HdB8PLiPst8nyBaSg8JhbeV4Ja9bAyshdWrJy	127
10510	2vadsj7p3nF8oSkuPDFxSqjvupNSwKuC44YVy3inoaDaFuP1jBpv	127
10520	2vbj1cAQE1SLqNL5av5CkmoB5MXhjuFkVjEEgou4yM7tYjBjkQJu	127
10526	2vaqRBFb6T5MQzyJDkzqJyBG9JdrwAyxEB1jKWm7xZ4yeVNvdut5	127
10527	2varig7u3or68qtGcSc1tboWUBTjDBhxrqEp8MephVnpqJWc1bmC	127
10532	2vaCq14EtP9HjDEYDGhzoyedaFVvTHY7jtiapSDM5nUzR1ZJBLAi	127
10534	2vb2HcAnLSFPreVkDmZsTrvL7Kt8hCAwkha8EgUyjMt1hF9eckha	127
10537	2vb7yEbtgWtEKYUoxQAbDSd3GGWbcawQXY1azoXqEjBKNb97fXjR	127
10539	2vbedwYpcfYd5v1jQiHELb1Fh5JbPx2pFgKv4iNNykff3ohn2mm5	127
10544	2vbpT2ELZ7Y1xt7qLz8ZnNK3EYNgdC51JorfVMXhdsaUXvrjC943	127
10546	2vbkKAkrgRA1Jan1X6hWHFqVPKrTbeJDQ4f1GBHPACF4XQnAEMfS	127
10549	2vbA39kqT5xDA4MyYzKvYoTmxL4MpgHUFyxJPeDXytgnTNAKNUFS	127
10551	2vbFT9paKaXFGfWTXp4s1JHmT7Fnb4TKzgwgrQMmdPCUbV7Pf8XC	127
10554	2vagUke1oU7gccMTEznumohNPDzxYCDF92b4tEv6L9pDSUyJkzkQ	127
10556	2vaYFUhaLN84B3XheSEBDduR4LxvGpcp6ZW5fW3YCHX1cKsPB3p7	127
10561	2vbUwoVaRzXDF5YKCi8HwNMfqSfQEFeUYyWgTvbUz81odCD6BiFT	127
10567	2vadWAwHeeCQnSFqv6LgcJSpgJiMBkkKbtBszFkAN8M5v3jdfKVs	127
10569	2vbdxidoFAhJwqdPCVY5vv7QEU3j6cdURWHJZ59nRDST8dhbtYkz	127
10572	2vaKNbmKL4qDGFj6LdXe1vpXjbR4AdWG11pTHHSsqJcnXRuZN6EF	127
10579	2vaxzpc3RbHcVLyjjM5Q6hGHWfFb3dmwUDV94XRUkCzttSFVqrLA	127
10584	2vb9vfGrV15dZFyq9ivYJyZtViWvAysjwxxhAc3jzAC6Ehg5fvxj	127
10587	2vaYHLftg1bS26JeLL5QaS5ainFVYSdT8LFWFrqR4EK6LXZF4pwT	127
10589	2vaNZrYLBD6sVAWpFGrcd9ZRCEGRBzzQ1RL2PVFxVfYSZav4epUu	127
10591	2vaAiR1LXpfQMmFFW4gXRcCdtbFXn4d3ZVc9cYkQehe6K2Un5Smg	127
10599	2vbeYiguWKra8HG4vqNCaPfyRk1JHdxtrSAGMUD2VU9uCK2BYrPo	127
10602	2vaKt2VCPvYoS51q49CpxqKx1Gqb8iy7dqHBHef2vzGjpzMCQp9Q	127
10607	2vabkrBwANvKtsbVGGknBXEEtn7odtUeLAUtv6Deq5WtHSdSdV1K	127
10610	2vatpVmT7tEqFpVJLrFPhHX1aYUUkXAh25pxwVCC3giv6NF51Sgw	127
10619	2vbrM4De8bkP9U2aNk7JjLGvBxAVTGuTjnaFV6nB4qFTyYrLjeZW	127
10628	2vaKoxWorxAYdAa9MaG3naqzL24uAJUmXuL3NecAN7BmXmnZ5Hdh	127
10630	2vanhnh9rjHbzhGACuE5rv1JW7a4zmCi5TThaG9q2TVdPLf3vBRC	127
10635	2vaUePJW4EuGtYP7S9qkxEoR67K4b4qJianuRTzYiq6iFG981wkQ	127
10638	2vbiV9ydXcXRMPWoJ3b4avzHbsDtj7Z15HED14Dp8fwrJAMKvfMc	127
10644	2vbLKUXsmtCxYobYv2GqWNQxYkLv3o9Fps9sBVdxgUEYf7pHRVj6	127
10651	2vb6kr2KKA1rPtZspteQnAg5vdZUPK7ZEPFR9ceeGQ1WewhRmXiA	127
10653	2vaxXgkyqKKe89zZJinP6NeS8duCFgG1G4H7AJNgsYBwxQN6oCxN	127
10317	2vbnRjWHodC5VjNoutxufvdRn74y45egvcAzyqHkuVzv5rPCz93t	127
10319	2vbeS2rq9nMSeTHKnva2pX39VvH8815dfTR6ixqoKYBjnsMfLeXk	127
10322	2vaEVYz4o5MdEyvheGg8WMGh9cpSPSXkCKjYFn3AgSSkiVvLHp1T	127
10325	2vaCUJBdvAVWptZDLdtUufptdHUzhaMiQKMGQGeRzhUYxwZ52Rfo	127
10328	2vbwtC95hGK4brpZwAm18U3wP6vgrWzrCRNsgWz718jT1jeSHsSi	127
10333	2vbLxXProrwRugkce9sFwfwAkUNVWS2b52uUdE4K8HDUBvPy9tWb	127
10336	2vaJCdnfBuNGRaNEJyCEQiwiHhtfHCMPcEMHjEXtPgCJmPxTxuDJ	127
10338	2vb1fBKHwoeqaFbkuz2rANZKsv6xa8iukr9FsqwNQSiceCuVcrZv	127
10340	2vbZsQuxLNi6bLFmhvTzo8NsNVFipNmQb21bpNvvULQe2PzuMNiN	127
10343	2vbHF5D8oApqM7pccsfYvdgVyiJ4bvXPUm7wQmRJCznykd7QeKyA	127
10346	2vbv8ExvW9LhTJKLgMdSxDGbb9CTvDvVgFhN6yVaWTPH8wTFnXXn	127
10353	2vbMKkAcxkovJxdGxcXTCEzZkS3jgAyX5Uv7qHFrEvZKSDNcmAwL	127
10357	2vbUxr9B1GuAmNkZ2GqZti93NibdVkU8JFy98pYfFQybs1Nd1UJb	127
10359	2vbh9V4Pj6g7qvSHg5YwwsL3zFzdh4qkScZY8tcmpSGYVyfWsGBG	127
10363	2vc2ypRMpK9B89kJyuu36UNvHD2dUCZVa5S372VMJudGXmhJ5Suv	127
10369	2vakjinibMbrKCcKokVLySxiYbZ3h67d7WVFtCdm8gDMoqsuzEmp	127
10374	2vbg9jJnq84r1DySYsymQwckfyGFcEJPLwB4trTYcJYVsfLfaDJE	127
10377	2vbM1MTyFth6f3ZWtrGyGxgwLCNUMps2qLxZFMf6CUKdrjpapdge	127
10383	2vbryThG7Fs1dPBGdCYitx32AneYDTvjbDfNBV21XHtXfJq417GC	127
10385	2vaqTByz7DWh2VGCLaMdany5rh9gAQe4vDDsosJdSQ9KdGtxp3MV	127
10391	2vbZ6ZnAKCimbPJYV9zxhwCSvHWd8qBQwMk1G5u8F8CVGgLb6nt9	127
10393	2vand5TG3SakH9UGANER2nt8kvdeDnCDqhMPh6fjSBX77K2UG3cZ	127
10395	2vaD6u1zb37ZqC6JJuXg1MC5BBpoceeqaFSEKf52BF84QR2hNjPV	127
10405	2vbigo5jbi6B9yKiZ5pYYCchPLjiFGW4Pqsza5Tdnm8KT54c5LzW	127
10408	2vbmHuTob6S9TaFydiVgheS4zXBsT6V1UnMvujV35UdF4e4nfdsx	127
10412	2vaNoHBabMx2idA8wMx3jYfvi9pvvs4CmgAJVwHVaeYhNi3XxgiX	127
10416	2vbx77hMQ1xcLeo1CFu5MDpKkbpcGeH2q8RZN4KeYfuJTCHQ2PUi	127
10423	2vbtZ9tdKANxpYz8oBnYi8VihMWQ848jgdFG8RfFvSV6DysvXvq4	127
10428	2vbubDgsXzaua96gQyQv9hCRiDPGLLo6zJEMKqHqgVszfFCzAjh2	127
10435	2vamajnW5rpNGW6kQ8rJwjKHuurJYBwLuWYTW4xZ47DKHmfydLqs	127
10441	2vbCPTw5JpokVo86cSAzALEVGEEpHDJX8tbMrJQEihyNhjtAXUj6	127
10449	2vbh9RPYAgoA77p19Zp3wmRYKtzwgWcMGQdoPPG7Jf5iogsgZhH4	127
10452	2vbRQawVRtqAjtGcP41J9eyesqp9gA6ycg82mXPnbWB7d1KmwpHp	127
10459	2vbXpNCW3KfGexdyYPf3wLYkCvxwohzdeizLB2u46iiZAQvACGvS	127
10469	2vaSKRocVqWPGbZVKMuQ3SqD7DUYDgQYQZCW6JbmZz7dwXqg2dhG	127
10477	2vbtXTaXnc7QeKfjxDHXfKKQcGhUbMHBa8ZMY6o7MKuvmH1eqVPZ	127
10484	2vbfvzvpdPFj2Um4fsH8GAo4zFEX5E22J823M7MziozZ5AnRP5S6	127
10486	2vaD6R9b6qBmbfq6YiS6JjLnsQFSHPqvSDigV9ZrRfae1p6idzax	127
10491	2vbmuzWGBwewacMkMJRi36uzKahSN5DMDLyoDCYpMwy3ES8G2zpE	127
10497	2vbgRVqUwLSLN2yb43fh41zzKMkeUBqwXWQmuPdPAnG4fhsmSAGy	127
10504	2vbmgSQzFDJPfFB8TBXzVqPbEAXuRaFWVmKN9rJVThnK6uBDiPi6	127
10507	2vbPjUoR97v87X3TVtrX9bgJAwVLVj5EUVETAt1CaGLHctyuvgY7	127
10511	2vbGzrheK1yLkY1upEr7XFScxQdBQ6GWjNmnUW26K2G1uCSb44tw	127
10513	2vbZRk7aX2QcbM7sSr6Q88EKeNxoHvkkheFKbptPrizZSWkZm4s7	127
10516	2vaSyjQBSV5JBoAqVtiRumwnP678BPPVEMM6bCFBCKaVDWxq1h4S	127
10521	2vb981e1tY5Mrq765QGPKpEA3DZ8YLuXtN5PdQXFNYStZzSCqdE1	127
10523	2vbAp7rnmGqzdXnrfvfsfA3ay7W3XSe7eD1KomkLbSQe4VtnsUdG	127
10530	2vbA8R51EQRttkXQLR9AGRtenSNd1CaTzTb7C2cdXKYVjUkGx7NK	127
10535	2vaww5DBxAXiqCLtE1AxgXHY3Pw5g5fkFukrnKXuKRpDzzb1L3zz	127
10540	2vbpUwPdpXqQxqT6LBJj7gZDiiYAVYNipwfXL3WaP8FyKTSdQzQw	127
10547	2vbnqkhkEcur9YKgAwJLF54GZ67EKfBaQ22nQo84MXYsdgrtVd3J	127
10557	2vbBdk3PCenvwj956F5FytXhC15hfNq5NYNk2ES39shs7ZgwAsXX	127
10559	2vbuYfBPR2cKYtLaUW4LCkxyqTxgn5NaCRFS1w4oSczphWB4kYo8	127
10562	2vbAzLWRkMFTrWL3TjZkbYp2DZaVin1DYzxvouXsxcKQmJ1A6rUD	127
10564	2vaBSUgpSHXpcwUjvkXUUDAYwZaTWdt2K4VFnK5uPS82Roumz98B	127
10570	2vbh2N8MsJdf3kDtfWFDC5NGKLkg1rLtZbJf4tHT7Y1vGnkxYNsy	127
10573	2vbDQHnkFboNXS6T7RDTxR7evQPfF1dBewyZAHCLNVbxLVqQXtaN	127
10575	2vagSSAKcdg48GKopRzFPabZZCfrq32B27pPLWrcfJR9nnSvCYEi	127
10577	2vaUGDcM7bCBTbYwrjY5XFSRE3FuEwEAdVhBvYvym1kLmEHoaY1M	127
10580	2vbvBsanzGUUn5LHUrRe5QHRfYb1HsLDtKjjK7ubAcisKCsz4ifT	127
10588	2vc2RfybLAqEq78g3TMuMpXd8doqR1mQPghWf2TZnGktSw16hp5e	127
10592	2vbGNHByhUkW4Ysf32B88GNnAo3pVX9PFjUPszZbjFbDYiLpkq9w	127
10595	2vbSp6w3QC6tHSJvtJnpZt3wTZp2n8DA3dGr253xztgd5GFhPtij	127
10597	2vaG4gfMcuv5EdPWvhedhj6Mpv1VzCNJ1oEHB2Qf7kvFy11EK33N	127
10600	2vaEEcgUy1ebw6t1SLVqWpJbbs4hQFxbbhzroKxe9c9Zg6BvBfDR	127
10603	2vaofKUVUUSZxmu7Y5qUWei77rvjGaE9TitNcfmDD4rXKB1mUA6K	127
10604	2vbGD89SNfAVKzbfymgusCLheim8ynxaxrYuA2wxpiE7JK2AMmTs	127
10608	2vbS9FiRZijfbmLaJ2YZ2orokSiv1dC9GAtNzPvpqZNuVQ5WTK8b	127
10613	2vbzvmvi1zFEFzXvoHcftRUFF2KSzv82Ee5ydVKvHAEHuJRZjjbo	127
10616	2vbRhgTM33nrS6ru9dux1CTjPd48NFEiLBiRfKbVoxDfFbm7ohvK	127
10618	2vaRVu9CqjipCwend1XgPG4StD6vfuB7SjEtH8g1Ficnw5CP8Z1L	127
10620	2vbeZghHEiANMNzRtqtDjxXdoMFA4NkSAeCKk7cSUHFgzsYaGSuH	127
10623	2vbLiuddGmaDtJPGQLFLFeWsiZaev79taZAdFVji1bgSaRRU8DRb	127
10626	2vaCvRVTZ3TDGvoGmfhS5roZNuVHDrpNCw4epeY5h9kvq1uGyQVy	127
10631	2vbZbNN11xzBFZhCyyJHfZSL524AyJ8wMvNXH6qHSyXU1RVowUTG	127
10636	2vb5APYxmZrX4TmhDBtcjH9xt1y9uaYd2Hs9xPsz6bQhLG12rgCv	127
10639	2vaU2515eYPvC9eUd4LtDiyToPvaBjcfmNB7tSeKwX5vL5xJJuY3	127
10641	2vbGkKr5Zn66ivXjhm44nwLeMEummtRspvKJJ5JRa9MxomUfwUQ9	127
10645	2vbhCGLVzinkTFV4Qk6NeETcekjcWvMNfSJSpp97sLqTPNQ9ct7K	127
10647	2vbbj7pcTRZEydK9Gkt45129ues57M7SvKHxbmhHh9mjwJ6vVFv6	127
10654	2vaHufsygLFT1HcoMdYBibdY4QpoDczfq5U6m3FoMUcz4KctWYTJ	127
10656	2vbLaRtWHhUdphDMp5cmTs7YPzvyAwCWzNb7civuihq3b5cxm1wa	127
10657	2vbDAPtZhXz3kVkVThsCsvbqFgJQMFFRuNg9HM4FsoB7kRPpzbWX	127
10659	2vad6rCokaCV2zm4LaoGVVe5ymZHNyesCdKvxSQhmc7xX7fAAHkU	127
10663	2vahDyA9s6PZivgkbFuUAB7DVrne76rzyzSHLGVM9Te4SUJ7XF8k	127
10668	2vaGJFP22bx4KkGkFkNTKGSdbNi92QrYLGpw96yfmbeQ55okLjZ3	127
10671	2vatSdzb1JuR4WLA9z6tFFmcd4g6nuhXJ25RHRuZfevR9S6XN5TU	127
10673	2vatNiN26Qa4fL4UKYwjcSjj9ZkdsZHiRLei6tDB2FLCrAUzkWVp	127
10318	2vbuayXGLPNkVH1aU8RKcmBGeCrEPEUc6hNgJ7N8aRu4f9nYMDzE	127
10320	2vaMBunne92jy98tbp7kLnjeKVCU2CrUFnaupw3xx8QEb3wxBvm4	127
10324	2vbfm37yHXGXoXPbxQjpyGpWAqW6TejENnNvn4Wn5n1WK7PAibiB	127
10326	2vbR5ca3tuWaYesVp4tCYdXh42oL1pkkMWq42crtVJQxx7n6WisT	127
10329	2vbnSv41E4ixECdx5wXQt16kqoHsT5tnHYfKRB1UKJZVBqC8hWhx	127
10341	2vbbDQHmbjxFrDnhoUJDyA1yJ5PaPBE1MqpN1hhpUPLrniwqhJsC	127
10348	2vaunrWygPbtkrXwAbHWpEXLT8KhuLHP6NqyfxTRfx6RXArQTHsx	127
10351	2vaSQg1zxbK9V6iL39zf1ehdt1EjbybcLWfefadm2bFQzwVadCKW	127
10360	2vbmk9rCDZF4Qf6ykgimP93RqNZLFgCx6JMseNZrG3NW9rdAHQdv	127
10364	2vbwTqc7pc2xg1m6ZVTyeVnPXqgvtj1HY88jwaDsCciodZj6UVzh	127
10365	2vasKfrWykVkaqn3X721nUUHQXXM8M9b5jRmYu3NX2BMgygBNtqD	127
10373	2vardwuyvhzQ7P4TRXV3SyyRKFg3wFarMJXih8NzZYmkvf66Rsc4	127
10376	2vbBTzA8AoWBn9W5sSKHe88Wz6VCiyoLM9dKbJK8djwLjH5aTrpP	127
10378	2vaiJEYqn3t6wpYivfwuhqNpKHnEgr1eLeJUtSPdGorwUxAZUwA2	127
10379	2vbx3ucmm3tf1FnPoYdvXcA1UPebmKdqV4WsfueaTy7PzgPG9Ct3	127
10382	2vbXVbKjTvce79eDoTWyQH9tLXzJFHLUaxPDH5WpY867w3PqWQU4	127
10386	2vb5MDM8vn9QCr6mPajztzB1nerMye3K9FfJMJFos8nKynP3BcLc	127
10389	2vbiyFnnHRG5aetFt68gSZca6b9YkAUNNqZ1Fjho6HY2kfyc6oax	127
10396	2vbp2AhhkgKbune8Q42dq3qmvWLNqMg3CNnSevUcxA1u9yAZHZeu	127
10401	2vbZzYRmUtowUL12bSDFZcxcPKLaznPQ9Umqh3HTaN5bAKHPMrDb	127
10403	2vc2dZbSrr71PEZuKL5uswLugo68J9sHPgH9TJDELpCHQZkx37Mc	127
10406	2vaTgLGsKT1emyfDUQfRt8gNXeAhHfYB3jCDPfVa2SieSkCWdrWZ	127
10409	2vaxNZYnrFsGCJgeDSJWEuYvdgAegDsEwLzjHyZ8mxxfRi2FHDMN	127
10411	2vbFGCnJJA6ASbCGL8ZQEPz4afsn8GXjh31E2DjtoxR9Gd2foHUS	127
10413	2vaboLfb6RDssV4FHDKLDzVDuCNVTrfLrq6aTAL3AkmkjZQdJNSH	127
10421	2vc4hfFjfywWgUgSzDDfGdHgYQ9jRyRier5gMJf46KE6k8msUXhp	127
10424	2vbU5afucJbh5jofNMaQ6h492k2WYxG7BGLHLrmtCsvfusTiVfpG	127
10426	2vaD9Zumgcw59Trf2XJh3aU5MPmWeUVjy4vgWrpfnmtT4bY8wvmQ	127
10429	2vasXJqFUPzAWngAiiyQqyVcaJonijNpCFfuVW1ji3it6NVJMGrK	127
10432	2vbkcsyWR2cdCkFz4kuso6gPNMeVz1HKwfGUMcXNhvTy3AzRW6HY	127
10433	2vaXWnWLQ5c6cxhAwqimR3Bg4mT7FDKyRANmwzBymE5AfgCqt3rA	127
10436	2vbQvQRjRuoUFNAWueZ1Jb4mMUbSSkmNVeYWNnvwotUebYxJxrvp	127
10440	2vaeGWmsLRwPuwpQs8p9d5k4TyPi5X3U48Pdv8WrGoNUtW25PcX2	127
10444	2vbyPv1yzn9UUWzaUCCu8V2kYgVyJAonLLeBhrrtF6CFcXRbdmbd	127
10447	2vaJw7sFyEWF4cNbpHZwkKSeZ896nQ2TbvnuUwTowMps9gNm6Sg8	127
10450	2vc4WrVoejV7Ph42vtNgNpAb9q89eeiYTMi8qSGLXFi5DXcFjW2z	127
10453	2vbCqAsWQngCY62VPryW9PisJ9jdShSS7hQfMGCDmS4uyYYbacTk	127
10455	2vaLbGLEp7PvuDk2Tk3jAL6mDwsFQ2ExNVCaNpnLQPx5dzgnbG1A	127
10457	2vaZrDhARqiYpVPAtwSpxjxwEfpEaoauMo7HZsH7pUup6myhMPH7	127
10460	2vbJfRS3kzgf5SvaRSFg6CByRge9JXfRjpjwjfCMQqWjk5Xgk1FP	127
10462	2vbxyWAZvyguzkwBgD2PQ8bvifV4S5j9qZ4AcheVKpZqMCSqZZhm	127
10467	2vbvhqFfmKAempRtrZyPAL4gaidGJ7ZanpN69GTUJjCMw4DzmqdN	127
10470	2vbGCfaw9SbwHLntKQYPw47C9zAmH7twn98YapP2ptYmjBzaJGrH	127
10478	2vazwuNdqvYhyhv1AuN7tmA61oZKa54zYWBjX89o6URDpKBbBZ7B	127
10480	2vbwD4RYzVo6nVeUXDdfaSCAJtyhMw8qxtHLZFQpQUpRjWBQ9X4Y	127
10492	2vbsiAwWsNj7V5br2e7WJkhfzCaTZPEPuNQaUHRWyNUkLvCJXw1k	127
10494	2vaxMQf6nUJ5Ht7JDv73jYyVtgLeE4aeb9tn3bmpYDUTdgQjaiCQ	127
10502	2vacAPQuHh5ZsecJLR73yGFQgEQ6PapSpJMUBUr4cWRXKw9eSuki	127
10508	2vbRF6ok2xoPJot8ZCMxq9tXfjMWv6rs8yNTQ5pQynjGcZ5e9Sk1	127
10509	2vbN4ZyYgtMBvR91k8iYwKXsGwcTRi7rhSTBQb5Ns4ad1nBERbbe	127
10512	2vanjJn5nVRhJNHxyRmz41KaSs57ps3Lzdivjwob6oxePLBpiMnb	127
10514	2vac9AmFjbgeX1J8ober6RdX4EBLxkeVwQMXhfbpbxE1CQVoGMEe	127
10517	2vbAKo14k1G4xzjdVr8X4RR4Nox4je2NJm7LvnmN36eF5QyaJydh	127
10522	2vc3nzNvqQZ5D3FFcF9ymaLcdVkg5azLz1M2ZdukMcEzu8hRnRjS	127
10524	2vadxKrpPyuXLus68jvJcRYZczLExPHBGHARDt9g1QTSQ4d5AFpg	127
10528	2vbToe3ksDRkeRQLiHVxwEf5i3YMfojj4zZJc1fmGPxEDYLtEMqq	127
10533	2vayxBHBgMQB2eojD9NY3ST8ZEBEoaE4Rfa9D5K9k2cKvmGwRB3D	127
10538	2vbFSRThE9CnrhDVmiHJkjJfpM8y5VKB3YjWi9ZK86VAq9Z1zZoJ	127
10542	2vbmdTd8WUWiWGLfK8NHV8uJV7KhAxMMtGGys28YqcK3jq8bCvyd	127
10550	2vbrv52DoU9kJyEGY3ZQf1fYa6k3nfoCV8Sw8ZQdfKh8X7BcSsQV	127
10552	2vbsnVapGZQeC5yymStqBCNDZarNo5JPDQwNo2gwjJrFTqU8WYPQ	127
10555	2vaD3U1koyRJEatNSVj6qq8ujdVh1AJ8DA6nu7eDVPD7kSsWeJUK	127
10560	2vaUGBFuVx6xRvggr9jJPADPSHus4QGap243R6LQs4BNb41UZBYP	127
10565	2vavr1hvMMUeRqrWpZ2y7gz5DRG9u2s2h6cjwBjGyqfnJbmnxvwD	127
10574	2vbakVkfiJajB69cEDreaxgAZp9JNppKi6uy48cayX2xsB7Eaaei	127
10576	2vaysXpQHxbie9DB4a6eKJmU4dz8dhGWviMtfbHNrj4DXe28CTT5	127
10578	2vbCJuBUpjJ6Efgs3cBXzuQmhquqJtyFBde1ETg3RdgPXjXJgz3j	127
10581	2varNJBT7m1wC3rvw8RR8yvKJzg7B8BkdRuWtLupd5tLiiUKMxLs	127
10582	2vbAcX7KBMbAmnq9fdxEojySzEE6zNUp6cABYFYvbXMK25XHSxae	127
10585	2vaKovZ2rDRPSVDh6PQ3AQn4Re85SKbTrmKf23zh1eaMPiybPuie	127
10596	2vavHhgpRLncJz7tduuTTkGoVX5WT8m6v2FvA9UKFhWodaXJPr5G	127
10601	2vbft7BLSPJdUiKJXdzUFAk7opxyvbMKdzF3wdBD41yeKWx9gsqz	127
10605	2vbcVb7ouwnGoUTK51eKXsF5BcMC5qKW4ArAAYjZQF8PZ4Cq3pcU	127
10611	2vabUsVQiEivctm1cRDzYf7BbuuBjDokScyBDzK3HW2pTr2GpAHP	127
10614	2vbGaS7rXnsyGNwdxVpd1eBydAp7Y1kHEsFNaeq1t2KM2a9p1bwK	127
10621	2vacngTGeMCBiQYYmq3bd861s1spXphs5BwgsRpKnkYwYuJ9xrFn	127
10624	2vbmUkPVxQtmy6G4guNefPqySPPdpBQZM2P2TixHp25Y3vvdaJpX	127
10629	2vc3iZsaNZwY3C37Kbu1s2GjAQwJ5RU9yTD66VTKedPSRGBjnJVr	127
10632	2vbxk5P93kvqrtyvdvRyYz2XkZsNcUuaAmYdTmAqZQkc81SbzmDv	127
10633	2vbwB6nxkAxs8ztauY67eRdwfaTLJ18Tb1kQYJ7NfNoJwNNph6Rq	127
10640	2vc3puAua5kACd9ZxV9GF32CCCbRrZQ14vYFhLKyAknwvm8P2aSE	127
10642	2vbKASjezUMrzKmBux2HUghHAcUpM4JTWq6vpVCwgZ2yKbYcuNSN	127
10648	2vbXGC6MaJFXXhfgn1KeFueQDke8wPVoJ85FNvXWLnFdcCUAhNWM	127
10649	2vbznirFhMgRaAAY9vr4twnYHyNS3YJBaAbQkdUKPaSJ4KisJCGv	127
10652	2vajLsYNjFcm7Lc7r3MKG4iB6tAGNw2TEDiRWW8nVmmLqKLW3hfF	127
10655	2vaYbbM663qzKnGAj9kWaTCSBNXWdu4ErHJZLFcS86UpcYANbRmc	127
10660	2vaNerYZnFQHRYp3MSnSve5pVvrGF6CLXewVnHBmEGrfVstVsctr	127
10664	2vbHYqVuJzxWM1B9G1RE9LRzM2kZPAj6AmxpjctpordMXCDKYytc	127
10330	2vbWxNuPFC4n1srUzVMTi3MSQ5V4Xpu2qAPFhcuWGLsBdYS1we2s	127
10334	2vad94V3ztQC6WF3KSpBQAGZvWVeSKW4RpuuPdX4n6MN6XGsht6t	127
10339	2vbU4UoG9KjNLLaSi3bZnuw4725biawagHmbWcSKX9E6bmgJnwEL	127
10344	2vbPrFjZLdkKe4p4BnJXyig3qcu7cNyVFtrrne9EsQ5hLjxDTPv4	127
10347	2vaP6DP7ZVSUTVFAyfgyyjY4BhavxS8RLQp1z4vFRPPNSJxbZTdo	127
10349	2vbrgGSnzuhrNoBftAtopP7tpcjDQ1EGn8mgKA6NBnwwy8DbqqU1	127
10354	2vagsfbYo155bsLyQ7mFCFHbwSNWRfDKBvCURKnFJ5gpdAcmdXjQ	127
10362	2vbBhZ9crLj4K1SAmQhmti5JnTtJT2nbAukquRisBpDoqeHpAKC7	127
10367	2vbHHgYeCsYqAFp52dj6u36hHov4yPrK9zSbV11P6pSaMgsQ4GEZ	127
10370	2vadWnoobjga3Gi88UMuG3mWxUSp9ZBY72YTGg43HrjTZPLmAshJ	127
10372	2vapYEPSUp2zoyDs1XrZpmRDST9VzJ4TqKSXYGFEQdUXjKFuL42b	127
10375	2vaJhS989U8SPzCRJmLTNb9jfAW4ie51xe5zncBKRuYonq6dHB6v	127
10381	2vbAiwrjQGkrFA2CSNX8pCeqUVq36mf54ytKwLwch3vJ5z1iZxBW	127
10384	2vaBw1wNfAK91gHmNUufN969BHdD5r6EtYnqF5zxnJfzQu3Hn9zL	127
10388	2vbti8sAnocijDNtz7Ysxgci1AiRmDPjpR2LmD862crXrkqzKdcu	127
10397	2vaQ8xaKxb7Y1pCKEcVPrHoB8r2JDQUSgVpYusBLqgrBMkTeFyux	127
10399	2vbC4S687f7ioyrc8fV32FsLHJ4PPk8beYnCw7DwkD83LrXcGyj3	127
10407	2vaHt1ZKTS9zdCAFdZ3KvUA4XstPGH26hAFJrKQ425rPWACK9qQz	127
10410	2vbrm5QneMq8Xux1wmCv9keRTxUF2sKvaaz7MwP6kR6B9ToG8yYg	127
10414	2vbz7hbDcWCW3NKmMpvVu5U9cyVo9h45eU1rTH81jcjGL7T25ZXP	127
10417	2vaJwXuEHoSWCVujyN4PBqoG6x6P3wNPUXcAEhHD1BWWzdLdEDiy	127
10419	2vak18bkGYiND3QjdTTNWtqzsiX2QFZg3VDQwdgVKne6LYQdaTWk	127
10422	2vbdWsr7WsxSZCvG9agyzpP9J1oUjqU312apK7nkCDhAdsPFxTNP	127
10427	2vawS4sKgVfFaRaQaTejbawNk5X5BrHf8TWDL4D5joY8RBCRvnvn	127
10430	2vaiaQXMCF9V3nvyygJP6a6U7v8fGuKni8CYoCGwPzu3EXBp5nAe	127
10431	2vadKDum669N41SEGUzQubfpkJFPDyfDEzMi4ECEx6wWX1F5naYZ	127
10434	2vb73AqtUh1n7Zj5jBDpszRmZDWhWdtpUthxumhJX1axGD8enhYL	127
10438	2vanVcpfHhxTbB2XEUwf5fokLxJrt5AvJVtXg2NpU4uv3zdLp41x	127
10442	2va9CvsjTepCB35bUB91dwXLhEJCTzb5AytkSnF83qeRUix5QGb1	127
10445	2vapxdK2QXN8X1nYR5BxXWEvVGhwgDXmav621VVygC2XCuGTahQP	127
10448	2vb9vB7X4dK9GyZ6xHSpoGPihPgDCMW4p6V9UwymUdTYZBTmxffm	127
10451	2vbfejfhxVKtZFZyx26PoTBrTCaEJW58bCBgN5Wmw46MYdUx163c	127
10454	2vbFLPZYLXc3Xd9NYAxHFuNuSXPXqEPiJxKyA9e74mv4BJSGx18C	127
10456	2vbsLTPGW1Y73NY9TYe1nGCgp4TQMjzePxiUmAZo2dAtNJAKNbTb	127
10458	2vaQx66o1zAAh5hQjwaV6rNhG883RYhV87LUcCJkyddcgoRKZkar	127
10461	2vakcLfQSKWQnMcBWsY6trgo5zD9bgbSfZM7agRrb2Npmc3sdPni	127
10463	2vbbAyjdM8FJC1j2FtdHuoXzydDX8Xi32a4NPGDH5EdMkWsx33qD	127
10465	2vapzxUPfUVJ3J473sryshYF6rjbRHiw1KVAPBLroZWhg2PLZaU6	127
10471	2vbGpW3ZtR6J1dmWZ3yK2sNFT6rXiy2KvWieAQ2iHwjPTumoSAGG	127
10473	2vak8AJVpRH8ZprwSAE69xRvzns6z4PBBmTpHnWqmNMpS6Wfxxex	127
10475	2vbUszojNEMthvL6UcNdVvN9qHeCqmcmod3vdupKHgk1WVuYPE1z	127
10481	2vaG8FVePbUwq4nLhiNWSKhRc7rb3JLbnxdb8QsUBrtAAYcvD9Bc	127
10483	2vag3PrSnzUr3cuGvQidsfqtAssHZUhUEkqhSTFB9sqYV7BzENxW	127
10485	2vbt5RJ93NGrwTX4QKH6DsApZ4iRCXUgcgnkhbRaXhtwE8RowE5q	127
10487	2vaeb9EpZWGbgwcGJi1BnUQ8ybTEvrpErVgGJ17oKBWVWpz3ptrB	127
10489	2vaThfV6nfGBg74vUjbyV7PpUzUXPpq8zZqoHS7uSeGAacsN3N9x	127
10498	2vbDzq18v9SPx7YmHtmagBNhR1r5uCD2GR1Lb4z8j1D98pDwVckh	127
10500	2vb4uLtt4grv58UR6HP2ZXp5pkTHergpSs5icQ49xhBU65FckkwE	127
10503	2vbHkTUuYeNiQnz3kA2oHRDZTBg3hyqejWJGc2kRxhmKyeGfLG3y	127
10505	2vajvCLjMysNtZMeQXEQJ2QBuhUb35RBZ2HjsrkT1CLDH1L8UUqS	127
10515	2vai3SFCB6E7mjh5eVWKJBooVU851ZWNgENhWwSPK9X3ZSGwfFhb	127
10518	2vbzfixEErKxsEpTpUiUEPhn29EgVxc5JbG8ECgeN8LhHFUH85sc	127
10519	2vaf2SnymVJh88Lp8fFCTRUv96c2HvdPwVXr2EVVCXz9K8Roa6aG	127
10525	2vaMqQrHG9vFN4Pkb5XBBcUS6Kzq5AFqKGTH9uqnSJtEDaUrSKZW	127
10529	2vaaenLDbmZgZbHDoXgbX9nw4gknzenRreF1nmh39r99f3VJyFXb	127
10531	2vb8uqFk3CYsWqaJQvAebsZ8QGwuRfo3QD3Tw7XHZ8qymNLM7wRk	127
10536	2vbLYEGWiJCU5AqC7Zvtvr5cBy4Dc9xsBUcobaavDL8Frj1Jb86S	127
10541	2vbbUyNvW2cNhGeqRY7hFgMzPcofHNxZBUu8CYcbTiz3yyC61bDN	127
10543	2vaM26j7tMPXVRAwDyUy619MkMBVcSzXFtMXDW538FmkQt8pmZUv	127
10545	2vc3ec1uem6zA9axTo4QMLovq1ny4QtTqwABnFeYzQnSq3fBEYR1	127
10548	2vbw9koFEw8og7TYoMN8VLUcW23jZCVTV8YVKQ8MjKBWXRq3LtvJ	127
10553	2vaHM8aiDVdfp5xBheHhj5qrHWg5TXdg1ykKpMp2S4EH6WrM8f4P	127
10558	2vaZpS6QVVmcnsbMya8kmVhDjtqMCAgRFS5XxiW7KnzkFKggFi38	127
10563	2vbQXdB8oJGhdfA8V4vJFUALKpCguy8YzqZfGhtXufpWgogXNbtK	127
10566	2vbadVBZ7YA7drDVu2qJbHHrwcbtskDryPPfhXzZY4ffygstQz6w	127
10568	2vaVS5useyz6GL1zHJ17JNz7quCEikTM1nrc1asYzYv4uZtbPgEB	127
10571	2vappj6feuJcaenu64GyqZXH4rszjT2csWBiFM9KALSBkHSEr5uq	127
10583	2vasUuKQ8WqKuScViKUAENtpRxVBU9YAxNNamb95D7AA2GuQezzH	127
10586	2vaMND7jYE99ibD8wPB9gXtqCSA3xuKTH6yRR4k7JJzr8zKwSA5f	127
10590	2vbs87VwMvj44xg4bhexSZeYcxQxVLDJJhdzo5YWQ9tKm2cE1zxw	127
10593	2vabfaEgKUGRYiDad1mxpAUa9bshgZydzJ9hHXY87QBXktaw6Vyx	127
10594	2vbEEtspeoqKh8wkAQUF1GRXC8KDJ3ZAXEVRoULWjGTutciwbBFm	127
10598	2vanDY8qyLQzshuP4sY93LHEFkaGxvUfzCkt7TbWERA8dHcPhtBX	127
10606	2vawiHPNiDGY5o4BXYVXec8pCdmM1nnH8q39iXDs5Us8pDtgjCSL	127
10609	2vb4fSzFo9eyzYtniL5KDmuMdBFVNTjoUJWXBbPQAQEB6Lr7niRn	127
10612	2vb5oE5dxynDfHCZRk4dkszaDSZdy1m1dEpNHCUSc7BMx3ajjw6p	127
10615	2vbxxVxjRPBVzZXeKWa6DenD5yB78CU8jjgEagvQq26j5FjVwSnZ	127
10617	2vbitr1et3uzEazhftmsksmU7F5QdSscoNpcP8KmvysKCHuHvUsR	127
10622	2vaSygoxjcfFY5oHGdFpmemfpujy29Qx7rMrWLrduVyXY8FtMwtM	127
10625	2vbdXtD5WFF3ccgPhR1oM4JST6DnmzfeVCzUCR6gD8uwegBACNMP	127
10627	2vbP1wrKUsBTkJRd8ZrBu93oEz3vaeYWfr3psJi3dRUaEFVfeUYk	127
10634	2vaxKhcijbnXFX5sAD28QBoCNYLW73YEtuVGNLGc6w5FRaP6iM4G	127
10637	2vaUEgXJvcyPEqfFYcj2pcWyQDAPaW6vmsuKP9fB7kpSC8MW6Mf8	127
10643	2vaAznZzW8EgTPbrEJsaEAAzhVXjiPEHE2j7ttgbnQTSHE8qpGrF	127
10646	2vbX6v6HTvBzsMbkDErFz2gq79QJocGVCGjMHThQy9Tj2AqoPRet	127
10650	2vbTgoF5aj1jGfB7DtuNapAyq8ZYwkgSBMsovyXNgzL3TBu6ATGv	127
10661	2vbLyaecBGpQkKA4cwHV4ZoDcLhfrXqrc8Qz5jZsBdLoCDxDbXZx	127
10665	2vb6HuU9NpKo11Qa2PZo6wFAHoeTmz116HUzpqjSFuDA7GmiUUUG	127
10658	2vbAtX5M4fc6eybHesfzMYVDtoDauEdERsWBttx3oDsJbp7amgjy	127
10662	2vbru5e8PKVNoKZo2GTzWEufdvCPb6WGUUn2DKY5QFqCUgHkWLC5	127
10667	2vaEbxfQk4xsBCytLzGgmR4nhZR65v2esWy9b6jAZY7pZW45CW2q	127
10670	2vadfJGw4mWKbBYyEEB7TW2RPSFaFJ2gPxW72MjGVVJqECXc1fwk	127
10672	2vaTzrDrDcn6TNeVMNaVoCcXV9BVZMnrg6XaPHfS6xiWvkQeQXBY	127
10675	2vbj8xWeH9gGYLKBJnFmNKLxeZgVR7rzgeKgKsejoHHA2WnoysGL	127
10682	2vbxYoZ5bo9PJEtubHGa2CtkDjkR29L2WauueJrtPQ69Peia2Zcy	127
10684	2va9Uw786iKTZyyBsPigAVoNQHx6374pSVbHuZSvi83Np65oZyxL	127
10687	2vc285Jc3KGeuC4QUnjbQARYAFwW5xxHQELjE5WEQiczhW4p5Liq	127
10691	2vayWbwj7rMhmy86utFJsyrETdYK4juP2RTFAPSVSEKnx2oyfMsJ	127
10696	2vb4n47sY3FjS1yppDU3JrsfhCsBLQkR3tqdq4i9M5SjdgSrttRY	127
10699	2vbLFoYiDHWj7fFTfSeX9CDrKrZkru9X4JKrJR7XqjWFCE37XvF7	127
10702	2vbQdFfC9PBLd5n3cYo3PPasmgtNLGWjYj69g9AnrBFq3mpatAAZ	127
10704	2vavLVD1VQLtUkQDVLcpLLCzeKyC4KEZwiV3xXfjRw6MFieFZYuP	127
10708	2vbfvRtCxPw15yMYi4PqUQBYeGcbeLzxA7QfVBUvDWLXzsycJGyu	127
10712	2vbxzfbH7jnqnVXpPyzbPKRNNSUv3LDiXKMGX6DZnXRmDJAJnRUY	127
10715	2vaTCWjCjzXG8prrDfRBhzVFbQ7RzMunyDB34nE7aRnfezquGCUx	127
10720	2vbbdZ7L6NjkE8Ny5tTmXSKM74rZFzoj7cAaznMAdbVy1Yj7re5A	127
10725	2vabW42WiM29x4YzbFToWwq9biN8De5eoQon5Jz9p41TGkenZXEx	127
10728	2vaQCJ9JRUpJNq3GcKp36ZD4P7dRPKP9GyDfXDrcG8absnfpfgsR	127
10730	2vaqfpvka8ZGvLK4PQtWuJswJwZUS5VK5NfRyXBUzxuuRTXFaTSn	127
10734	2vaur213pueBRAfpsdFyGuU1XZapVYDRr1AUfkmWtNZosVsK261J	127
10744	2vbiFGwBJbDphqwjTmb2DPHigt62QbBHzSXCT4GsF1G13ABGPhSf	127
10747	2vc4a6VasLJPWKwJcGxDtrc2quxi1Q8LNW37sNzQZeVm1tBGCeCQ	127
10748	2vahU3QfvPeSsG4rWSGN376N8CT2pvVgTkuRY9eKymW4TnqKpfMg	127
10753	2vaphTsR6Gt5grT5XVW7DvbRAN3H3hSU8pgjAd2HmhvKrgczhD4n	127
10755	2vbCr1A2uJ3is1cZE7QjggNtHen4vi1M12w5LAL76zuBWNRFGVki	127
10757	2vb1zfVjQSEwmpNwMB8YTvUF3qStnhdJ3FpWkZM5T1G3EbmagiaY	127
10758	2vbYes5rmCotiStJ9iSzhRAF4M1qZR6NUWzwPkJPyKsKnNeYCLh8	127
10762	2vbPYfgh2j8qezNkFcnJfpC85pqy6PcdxxJEHea9dA65gWjD614D	127
10769	2vbX7jCKZSTaN1UebBx4QDXu1HeEwZs7ScPqubxxbtetQqsE7G1P	127
10772	2vaApXh5WpHfjj2DKwncd6HbGSDM4nMQR4xsHYtmBMbMgNGPpyxV	127
10779	2vaWphEnVgHf5VKXaDC794itig5V1WynFcXJx6CiF4jb1qQvw6Ah	127
10781	2vaMhcFBDCrVxkXR1hjxDtzYsrFffhhfDAYi5DLuRvsZvHa4YDVN	127
10785	2vaFeR3NDQAPuZQVLKnePJbEZwPzt9oDUArqTUJnpyEv8UHnWSGb	127
10791	2vbeRP4vthxqgtAKyDfKSx3GbL7vVBRirFwzSR8nCp5Psgi6iQxR	127
10792	2vavyahcepNKioakxJgDMLq6h5sjpEKiRGyxerJmioFr2LD75tuc	127
10797	2vahDJJebriTx3UjbRirjcxDTgi75UewfHLvRzNjCmLHCkAGjYWU	127
10799	2vaDBpPfHApTdZVNhSUp4ah26A1Pov1Enq9daf1TLmbJWMX59VWM	127
10800	2vaLr3kwrQacBtmrKjF9om4VHRSqL78hwCQ8fkLMj2k4oaN1X7xB	127
10805	2vbyugKKDztepMNsXkLPrTWtU9VjGJSxwgCCgkRiArpW6xDJrzMa	127
10807	2vamjDZhj3WDZEdrFQBmJdkP9dWfMLKJoZMsom6AFxXGuKGNSuZG	127
10810	2vaWnkq3bqujWxM2Cegi2PM83a3F32rBHXaYnAnR8vGwiUsBqLdi	127
10817	2va9RHFFZ3287jmQHEKcb3oBFXAFYe2F5DWQFVKm5DTjN29r1Bvj	127
10827	2vbC6YvTxFzmebucnjEb1zbFtfXoHgiSy7ZjVBawDiXXP8CRL1Xu	127
10832	2vbEhoDFocphNZTzGeoZoESUYYUQy9tgY4vHN8gFk7twwmJfYZvR	127
10835	2vbP6yqHEDN5njSejBqMWrZkiY1LNhG87rWESx9EZXTJnh2N4Mro	127
10839	2vayHJX7HsQLEFbzMdKmwp9aMPVH3x5dQ6jmkmvd8eV5o4Pbk2hc	127
10841	2vaj3mvqptsSmKeVkNMKuPXjrSuVUyByNQE9sBDa8FQqnPpLkLi2	127
10846	2vakFE6GW8q4zfEGUsgNtGzhxjH5kqsKYyNiqvQvPs2nkYtqxpdR	127
10856	2vbHYnyaZxgUwdPMg2zf5nyZQkNqqaHPEiVjF5R9Jv8vSCTizSan	127
10858	2vb3cmVpnDZgK9Qdru9xJng5yR4nR3nEXavSMgUFpK7vm5vzVrWu	127
10864	2vbqWHpiWkLFVysM9fPysy3F2qweS6cRr7NMjUCyWdWtTf27knqh	127
10867	2vaJcrtWZFLo4MrQKJFxorXAnnSWPcw3GQ8GgXuNPKyZVKJkFFwj	127
10869	2vbqLzi1nzFSXjf1EX3XGyhSCG5EYaJUGZ5AsxNPTdBX6TxgtXQw	127
10872	2vaYfYc3c2gwAujokTLXf9tNh1bcU8awJpzXvbt2KmrktmWjkHQy	127
10878	2vbV7mspmifPvWJPzkaPKL4qJR4LDfVZ8KA5m6yK11s8rBT1D4Wd	127
10880	2vbb5RyU9uy5ZMnqoqxeVA6fpJRsCXgM65528kJu5NnC2tJYgmt2	127
10883	2vbYwFMAPrgXw6SsPWJ4Uf1Ych3E8FuRmgKMFFgRe6EJLcgo9EUF	127
10888	2vc5CW63ZfSsYeFwGLgiUpZ7VJJdSMphGybFXE1ShurGweVzezRq	127
10889	2vapwBryUYcr55x6X4cDcPvgUfiz7Wm6KvNLCdoJjSDRH5MyveFp	127
10892	2vbJ5CSZouNL13FQCptTJm5WHvQdTbwTNiJkY4GuzcSwygRtyrFA	127
10894	2vaxsN4Ar6mqkqNsM73NaBhY6MzRWh1T68Jsy7Nkia5aQBS16Bxm	127
10897	2vb53r8rBN8mJigdfc14Uk6Et3shkjbYUJ6cy82Zafyodtm1HduF	127
10902	2vbukJvbF7YcVKMoLiUtbSsZXtUBxH3e94BV3B5LWZB8tEfTXqTJ	127
10905	2vboDMVW9B1PfU3ighpXSqTvjtRJ7mfGoDcFMfxjcJEdbxZiPxkZ	127
10911	2vb7LMNhH8RLaXeCpavQNNGPvbryQPnRhp9djtRCR1dm9AUyPP2Y	127
10917	2vbjgjcFL9mMkQFdTj72wf3HnRUWLZLmkJigsgaSCDS2sWKvDzC8	127
10922	2vbis4Jzeo5XpFJJ69RAMq1J1NRuLQpSQwbMdTK2vhrKhfniw6pQ	127
10927	2vbWarvatm7C6QGNEpNvCKYmP2mgYNErdXeaRLXv5JheS1encHQ4	127
10930	2vbZmxFmhXyPMoWefPtTSUu3KTsWuTVy8SKfTpATZpqTr7Eepf8b	127
10933	2vaceKHwRhxjZBMMNTRhCTU1F5cZdafLjsQAav37bjZpPSWvj5gn	127
10936	2vaKiZ2u98STTxs2Da6NcmP83LJwYSMsPihBwPM56VAYG3iT3cV1	127
10949	2vatZ4sUJTu2w3WHVs4yoAbk9u4iJEacdCD3uLaFpaa7ttnKL1Zt	127
10955	2vaPNztmutSC1TfYgGj7wsTEtvhJdNtokyUtRfb8JrC6Zjk9y6zj	127
10958	2vbkh3HV24SDgikeVjrr4xQNeKmxyL3LszVhZTNppEGJ8XYYHtDr	127
10966	2vbqD4Dc6C5s6sFfe8HfKxKNeuC4vMRTpskKoxxvpovGYNZD8FwD	127
10969	2vaeAGVGsobbQyDJfXEJfJmfPHsUcA4LQ72kGXZhKMfwSBTaC5bb	127
10973	2vbq7z8E2sNQTWubcHAk5wZy7RMwYwdtCwUSxR2fEZ7stvrmJBqU	127
10978	2vaTebuz7c1nvQBUbrrjeWMnYXug5of9fhEXggx8zryBY2sMTd8E	127
10982	2vaKxG8DmMomkHrdd1XgiRvsWjarmhkmFaA5UMkaPtJcuCBmFPNf	127
10984	2vat9oJhkoBy1mBNPRqBoyynBRLHPTRhTLnrAarCNkhU9nLhxqCh	127
10986	2vaUa4fPuA3AfMh4eymBNDKsZT19nMd9wCzZLxyBxm4577pcbLED	127
10988	2vayVF2TzSQ7eq6tpQSedWbMqpVkncPanq6JRqDXmWiCBb2PSiwx	127
10993	2vbmsYmUPMwFr58jLmMFAb7Uo639EramMhETf1wK6Y7p3JTf9rVc	127
10998	2vb5LXoNUwmNE9oaNgYuaEbs9zn5ocnYYFpHevLvi8FL7f5XA9LG	127
11002	2vbimpaXw683sGkwVbpTum6tNEggjXjQhdB5EE8k2cCBPVRVdVsn	127
11007	2vb9Rj2vM451cx8r7p5mCjh2W1r8k52FKZQMYjKWRrxGwVuzgKxQ	127
10666	2vaLDQwaquy25ganWwkSP4CsnSryVjbSF5gHXPW2JcuvgAhPGade	127
10674	2vbUG5KjmYSPtGNtVw9FjdqUusaYoMYuD7szKheqsGrmgwAbCC2Q	127
10677	2vacEan7a7xSoeUzuPFFKeQmqi5UjjAaY96D5yR45QxMu4BR6MTN	127
10679	2vb86MCV41h9Fuar1nfjiRhecZJcX7YL1V1kxQrrsV1Nj9eUgGzS	127
10681	2vb9uVbR63WAuBNfk1ZL3qFvuugzuuaFBqMbDUadPKGHPx6o8ojk	127
10686	2vbZqpVS1FTyJB9nVg1ePZNRLR8tYevueLix7D5bUhNqW8AkfSti	127
10690	2vaWFqw85d6GPaGFkL2QmanwgZTZF4m37hantSrV3TyQ2KG6Smra	127
10694	2vbuUk4eQG8gaaSFaVruQGBQaNcYt8m2z59rLEQLxWSdLdHPzFt3	127
10698	2vbGWMoC41cCKbn3mJn6min25tNdVn2RNvMHw3vLGQn7eobk6JCf	127
10701	2vbi1Bk2v5KRjL3NbrKQoXbkWSkPmmHqJBzp773SeKotCxwww3aM	127
10706	2vbhJzPCp9SV9uLXgRDxkURWU52PsykGAn6aBBbmf2DFHgUJydvJ	127
10707	2vbyphSYPR9bLjcgqXMkNQ39SQhW54PDwqyagF3PjrvQEpGKU2Qd	127
10711	2vbYkhcSoUvFCdRctfh2uDM5A5UeATRLGNh8Bw4i1UDUFK1DE5od	127
10713	2vb9E66KpUXdWAZX3wxGPhDrEFurTghvrTVGs74nS4BXG5Hc4zie	127
10714	2vaFdeJHkQnKUCW1xoBLTTRWPGYJrPHy91DuVR5oxTDDcLnfM9a3	127
10719	2vbNSdqxA8HG1TD49FsPWT2WYDP87zPgq12Gk51V6jH2fF9wRzjA	127
10722	2vaWovgw3ke1r6GpQhkNsz4RnmyvBgYKt8UXFXDrmHKbo39zjDpq	127
10727	2vc43iaH9CSvmACmic1piw12UY4kZmDZYX41A12bGgqCn6Er6T1c	127
10735	2vbRC3xsJ4YBDAvFYXorhoKWyCQJZZGRzyaD5pCu5AjhALo7a4Dy	127
10738	2van4Tu1rrTBxF8qXVEjDQMYhQPP2XYFZjM2Z9WT2STpH6SiLrJp	127
10740	2vbfQX5mEEDKioTATxwZH8B3qcEhAZrr6jh4FzRqpBhPb2ExpBJp	127
10743	2vatTTerWUmDBhvUCa3jgGnbx5qqpdL5TXKeMkLKR4G6sCZmzPDZ	127
10746	2vairKoJ95tnYYMuhEJeeqrNbfVgDo5QAeFK4oLYoJREzwCu8K2f	127
10750	2vacU83MYJvWcnvosM8zg68M9FsZBy1a6kGTMdifNaFZHQB12iFv	127
10754	2vbfjMfJpnAqiex4vJ1E9rxRnBnYwGemGAG6xm7xX4sVF63KYZpW	127
10765	2vaxsoFCBYxStaBXMvXK7329yDrEvPm6RJhrhAwutCNWrMEX3xLS	127
10767	2vbc4fWboS6DYE6GNH5XZbUXq2T7mgXAdK1iJxM2JrGv9476ycTX	127
10768	2vaNLH6iKoNKUgaEbdu9LUjfMURWhK1H4bVBvArktEeZ3bWQADAY	127
10771	2vaNexMMjkJnyZJhERcGto5piWa3Pxaqt1nfiDF7uYmndp5rwuYL	127
10774	2vbsDb7TBiu5EqdX1UFEcrNMSCbXzyhfmLBZivHFfNpg8LJKfKYJ	127
10776	2vaqPjCC8aFXM5q46NEakcQ236vks65xH6aTo6j7uuLVnsXS4xCh	127
10778	2vbEYApHx1eaKyEKrpMc42ErUjSBEpcf6rQSncnQ9rq6Ay8UPP4Y	127
10780	2vac1jhb64eRDXm2ceii6XdSCeX3d2GdAkjTCSHLDWZKvLA5LjWp	127
10783	2vb8eHo2mz2YX5opALS1wnWncRGhZvF5Wz8pf2swVYrmpP5mNC9y	127
10788	2vbBYufr4o3hC93eaeqeezdjwos5LPKABdA6nqMy5QnyrovvPMgK	127
10790	2vbpGUYi8biY7j8B85vr1Yih3cNmHnkfAabij2Rg7fPdEhHjUgMu	127
10796	2vaZUFUSKyrTV3x6j491snDGEWADGhaEBpHQ9KWnhyuoKnE16KZx	127
10802	2vaniKttCFrfZNJT1vzWiVsGfXVW4ttpTL6i96ZPygkvL3SbP9qE	127
10804	2vc18FUF6MsmybqVywsXhJKuzZTutaswNfenR44kBe8BVt6ptwEo	127
10806	2vbEkbXP4SHoR6M7mmVPucH9p4ws1JBrBfADE3BuZd3xnjFkJKWZ	127
10809	2vbx1RXbYY7bGUGV5UkSPm6DoKq54eFKUNvseT1GrW5g6QLiU65W	127
10814	2vaV7bUq9zwfDP14WQSCos123utJnCAmB5hDmK5UqsZ6sztoyesb	127
10816	2vbjL3axqqwfWkF5LTRH9xgNqjgKKVqERPAWogDqHi6UrV9ktVRF	127
10820	2vbHowr12egjf4DvvX3mXadBQ3GRX4MJtMf7HsUAUMdmWfktPqaS	127
10824	2vaRziSMUeR67AiCxbPX67QjddhVj45R3ubJaV7D3poExFuJmcj8	127
10830	2vbuWku7efX6r8GsjpWTWiVvVvGEjzMnr77aNwQncERqedk9VcFe	127
10834	2vaDi3r2nREjVMXzHsFYkuqvnnwb3Y5V4bEcbubWxo82QYM37Enx	127
10838	2vbKexM53bjqzjh3U3RVjr7J4QBXZAt5FQJ9FhMcS4oD4GmoV6pr	127
10849	2vbmkXeyxM6Ra4oXve3NT1Jwn477iNpAhWK7XNZJXYRUjYtBdMyC	127
10853	2vbzmVfoHrX8EMaEDu39zLYkTn4mtzpsu8D2iC8qJNmrUTrPtthL	127
10860	2va9VGvnbUmUGmsKTiFFA8renkpXUQaEoBcqt3oUFZty7Lmb49La	127
10866	2vavMf41i8kDRhPJDVvTShQSFcByaHCXJkQ3MegSs7Xcct5NQrQS	127
10875	2vbWbfdEZTZ2eXaariVmxQf5xXCoV1J9XwkrSCDuBoeoBRe7kjcb	127
10877	2vbEL32qAfLULB22FmARisNrC6cxYw6RZrTsfJbERTLSgnZGNYxQ	127
10882	2vaJN3tE45G9aDDrcSE8uSLqZezqPAcaU85R46Pj9J7R5gevawg3	127
10885	2vbj4KYK3jSRdH5B2qm673cicDfqKhkX8rVrEgqoaSrY9k1S2RjV	127
10908	2vaBPJ2eLJtZ3uCLyRPeVpCx52WifWMYUBfoNNYagGBWQyuyHjqa	127
10910	2vbA9UVF3SdcJJkgQCpASsfqLSsy88ezvS7UZXpG54ixE8wdkjTD	127
10915	2vbr5W6KavwtEi1D5VL1MsASHkhn4fXV9ShznjBUHeC8qGhemH4C	127
10916	2vaBKjLMGYFYiYSwZYztvYhWL5pwd3cDYjyiyVTTT6UZNrEb96GA	127
10919	2vbhVy1h8fT3oxnCcFc9Spj8BVRjkzH8o3fzjroJ9RMAgb6GHzLr	127
10921	2vauHBVbbXDH5LFyKYH7zYnYkBbMh5WmQffgN8KL5dq2PMU3nEd9	127
10924	2vaPo9w5mtkywjMavTD673rA4tCw75eRwZEkm3B2FP7AaR8xtF5u	127
10926	2vaEtBduaSnmZcokPoKwsqAk7paaPUpvE9W4zpSosiEu3WPc1W1R	127
10928	2vbcR8EbTRwgLCZ4tcPNVSieuVhS8rXrgCQdVaZ4MzPF5KxnEcin	127
10929	2vawmkZjQ4KGXyYxmeRciHaL3kBZKxoqzwabALNZ6SrGwceZA3kq	127
10932	2vbGhRix339ggkFvpWed6hpCwUyxzxajE9g67h57vehwJmNvg2db	127
10934	2vaBmtaQw7PknD41Zc18ckNC3wZbjJgVhJ4TR7iw2XeqLFFXSDg1	127
10939	2vbzCtt4ctDVx1LeENRXsoy6q2Smg4LjxPmNWZAYsUQVSzkT6gd4	127
10941	2vaQkRDyMBiRqYvGBFcXGKi3BQziRd3kkKtP26Gc9p7uZ8jRvrce	127
10943	2vbXgkgVrf3ksMzoy8BosXDgWY1EcvwFrEi5Ni4TBKA7gvFAcsVP	127
10946	2vaPDpEfqZng7XbotYoPSSS4LYitm6bfbJhMA7t1neuRxD6SLY5j	127
10951	2vaJ973qZeaTC6uGUogqEoRR1nqezPYNtUPdHPsB6Vp7rmct3MC4	127
10954	2vbeCEEWVtyNdRNBF3FEyJxUCwU4T1oSgMwypPzsncpnfFYe9gfZ	127
10957	2vbKApfSTqALQYqrgU2sQK2fe1Z11twpNYN1oG93KrqHTfbwWR1N	127
10960	2vbsUD1g69hRqcJJkCbpnXPjmpGvCh1VJmjiDVZubxSkfy1E8PLY	127
10964	2vbr4PfbtDUT2bg1LErC3PLpjTbKGDWkkLoiuPaHjC8NVbPdDhiJ	127
10968	2vboXfW3ibDGyEUWztKytNm9xYtuPLMwGz2Xnj7WwXHZghuEkNLm	127
10971	2vbx1ukoLf3DNDFNk3Mb1sVCaB3hayzsrqTfZaAxU7mtCRrVWXeE	127
10972	2vbpWHP8EmF9hmN7kR3fzCP5dMXgVftQqxSm8NyrouBqjUXmNtUR	127
10975	2vaQHqHf1cXb1CvyzYzwbiLMrH1cBcEdzYjbdAXL8wNwYfDFoGBw	127
10977	2vabFFyd5v7sFioavxCJjEt89QicMK6nUQGJUKagLxRbmZgDyiVb	127
10979	2vbDzJjKcpA1orcbTP9MpJz28fNAWQgmHZJqdkQgJdp1fhcdh7K1	127
10981	2vaS1dw6arbK6xUpegeCZXdCS1GN9cLGctPpcj8eiLDAheaqRDVT	127
10983	2vaXo8drTT1CcTxxMwkxZbMFDV2bhXTYvP91NDRoeQp8VMPrKdQH	127
10992	2vbaYwYszLyHNHevACXLVF6dMJ5XNSRY58vNxbxdcNvXdkzxEGBq	127
10995	2vbnd59uCGoH4Scq9A15AdvfkCEvgCKy2S6PwYKsGp2vQejfeiXd	127
11001	2vbqNcyDqAFpFY9XHbpgAgEAectAkMAwyYbyMdsc7dqbKq1NYsGn	127
10669	2vaVQaHtuVJkE6zeVAHi8BghfEqhjLuwg7QYU8DQ5UKTJM9RiT3E	127
10676	2vbhtSFLpKvYbXV7sx6ZnW2M2QT8YnndGP32mFxt6B1UhXoBcBWm	127
10678	2vaF1DGibPnJmHKueKKse4nnGaQEdJ7i4UasyD1zNeko2P9nou1n	127
10685	2vaLYx9cBBgXFMi9CUKtJ3ppEi2PYgA3DMRZqFc4263qA6sexEbP	127
10689	2vb15dJP1Cqhk8NSgUqGqzimDJizBaa4guW5BbhZk2UF98gr1WsF	127
10693	2vbUHswexunyyf5ScLARU1wfPLSH9uEQDc6VbbCK9NySvPJSrDJK	127
10700	2vatqYuidwq8eH5BF1WMsPWch5BvCRPsb3aKk5Kd3fmXCDAVsW2g	127
10703	2vbYEJcgcDoxN2NaaKCKmSSfWpZUdnQjGzToUTCn2a6FxqZLRZsR	127
10710	2vbwA1iCT9GCKSSvDLFWM1EHCW4e6uZKg5qgFSdi6EqC4ZCHbTQ7	127
10717	2vbJ7hLS1q6dpUSKn8oZMWxJRZzx63AvPqLy8EtMvHK8uJvzhBv2	127
10724	2vbf4tBPHkcbs4ErHokeERHhDTtsR8rSV1i3AGr5TnuYcTWs7fTx	127
10726	2vapLjbzEDwhzjHuSdagy5efWR2RwPLNuNBbpi6fF6vH5xFfxpyk	127
10732	2vbv252morFP5cQfvjNMzCgj9xC3nWi15iwZF9VPP3JgqNZncHkx	127
10737	2vc3HyCQk5tFBFu7PNckqrdqVMZp92Njafv9eHc7fRkEgAo9DQke	127
10742	2vbf7g6q46tE6F4PVALWAPS2SHAZKfC6KRneQRpxKJkwc8Qh4G3U	127
10745	2vb16L4PUmWmFg9PV3nZyHcbqaWgDQASiQgcUSuKMLgRkSeKdYZH	127
10752	2vbYAcvqRqU1b1mHqfZvHn76Qicn9MZyVBXLyHRJe9uHH4znHTwQ	127
10756	2vazjxP6SRvtpbEUz8LHZik3ymRUL5jdKP6pJhuwXJKw2mQ3968h	127
10759	2vaPmGoBz4N1EMeZW8xQpn3MveSzgWbzigJ7fJmanV38k23SKeT6	127
10761	2vc5FgwcjTuZ3aGL95i1xnJg6wgHurAzjpshPVtfCtrnpbdyPJQE	127
10764	2vaq3P7K8zfng5Tc7CboBaKau7WN1g1Cxj31WPLdmZKnbxH8Zc45	127
10770	2vaoPCdYNcchngo4Xvc11tTuxNPuf2MKaoSiWzJbLqEaLN7HzUrx	127
10773	2vbcP9DHQZLVjL3gPRP7zQET7WAy4AP49TPzrbJa3Zsjpib1Mvwr	127
10775	2vc2CRTipbLaRLoAsd5q7F3Bq5XYFrqEcPJ9rpvqL2M29PzzWzVw	127
10777	2vbxPjebc1QfRnXEmSiGe5XFZsGGsMqPE8XuYQmR93TKRo1o4rhA	127
10782	2vaqYzJtaVA5QakJSd28bzYZmhCYJKWZbtEdeuoQYHHagyY2RDv6	127
10784	2vbKzy6nzDVvNwyGXeW4rXTbxYT2nLFqemeAVbKjJnLmrZvnFwG4	127
10787	2vaPzdLNakRkHwqu5jm2JfruNF7Y4JA7gT9a9jRGSH2X4oqYtvd6	127
10789	2vaF7czk27vRzy3QXmaFRcCLEAnerXWmAwSrDkpCjffjdkB4kPYT	127
10794	2vaBJbSgQ65WNFox3jekpoxkGjzAoUMAvL3Ue2fqfcuexNwRotxy	127
10795	2vbeT6sKLjNNZUzSs1E2gtWQRNnbV3KGrSFNL5FBZ3WVujwGss6k	127
10798	2vaVPQnSfg6hHmNpd3edK5FzwZ4UUSUbC2dyBMm6iMpbqqifmW8f	127
10801	2vb6LefxKYMp6Bmmp5AqZpocyaCyhQoGKDqPvZ9nDX18FVYjM2Mf	127
10803	2vbqHp4q8JZTdKmPk81ACApDcUaTzUrNjDYKy12dBaSLQ24bdDQY	127
10812	2vaqJquoNcNc9yNWExQcMJ9vRJ8fCWBugy5Zu4dmojGmHSTxrSss	127
10813	2vbX9PgEoq2dC7g3rFC8sKzKdqgEgvwXuMN9FGDg5Bg1E9xoS6sc	127
10819	2vbs51fu5GAzuQgou4Wi7VBG12icSHHL6fCWBxzzMePFJRvmUCE1	127
10822	2vadtPxK1WsYHsd8FZMsJAumtiBvcYpkTur9vnTmqd6VJHHZ6Cnt	127
10826	2vbqXCYw2XR6ceKMgUKNDN4kMBgYi1BjTj2Y7DGb7dcJYqLzahvc	127
10829	2vaYQCNe9HEQ2iW9b5Q5tQm8eeQW62SpzTJe6HaZ5WrbUNLSdjgz	127
10831	2vb2tHXrLitQH6ct8ufaKSm3aHK12mYgSzybJyYsdAUhUYW8PvuP	127
10836	2vbGeZQR2iLb1mNE3aAEwTHgFMhNHsGS17VaxVXG1gXpM3RJpVtS	127
10840	2vbTpjwnx1kryz8aRyPJHD5KGFxrwEeTwb6tpNYEhTB19GuhGyqF	127
10843	2vag5QZvEBoVM51F6eYDo44ucvhbvrysi7gGDXkfpvJrPTuoVtYf	127
10845	2vaYe4N7p9T5gWiRMojc1c9pzdEJsofAaX62BbasV2KtDCP6y6iv	127
10848	2vbQmnMbof8jQCKWzbX9t57vFhqwXCTxYZ4p2eLk3mNuwLhKHV8D	127
10852	2vaQCdN8zZfNXJuqhpS5MnNyQAQSVito53LH3oMsazfHgF9vRc3R	127
10855	2vaUGJ5nu1ipXLWmhzZsEj7tbPVmgvuaQpfNc1mz2seeCZW4gff4	127
10862	2vaXpKRCYzffhoHHFnfW1b1SB2h1K5DZKrXLnUc5v15x2SyANfvr	127
10863	2vbEfD1vkYtPfGhkKC6iExjQi4DRLRs9E5ntasb6hTWXKHvyQ1y8	127
10871	2vbBPpb8GuNdZBxbcPWxbZQMfigZYWbHHbW6HAMVYGqA9rywDChK	127
10874	2vbZwN2d7y7SXd9KziUWmQx3g7VJrKpSfhYT3KQCcyrpxGcEiDQu	127
10879	2vb4wmA2DfKmQmHzcHCmMJe18BDoMge3PLAhT9LHSm5VefYSJvcA	127
10881	2vbansFbn8WxepyDpNwbSC8EHzez5eb9QtzbRjoQ94mqT8PREUu6	127
10887	2vbr5s4gKMq3tHdr4bPHUBvFTETiq31NiKKvZCVNBia7fLGESjpN	127
10891	2vbptJWPnYWAuEvWKxp18M72VgTFPPUSJ18w8wwhJa7ByJjD3LCJ	127
10895	2vaybTcJTRg5X7gbyeYikTeMGVobDBLzmAoL7TisymJWm6MsxML8	127
10898	2vbUWm5zg1zKeUomEVHbDgKggpohvb4a64zHsMSbg6Dz1CVLeUze	127
10900	2vbaB8b3RrPVVSt5NmU5hZwnGgVy3XjPQdunaxfceyzeHQKYWUT7	127
10903	2vbQSSktdNPvgCS94s8G5NrmmM7sTYkpKA4RoiVoWUjhULTfeKLg	127
10906	2vbAhAuP3ZtwiVfrNBVN5pvKXS1YhCXkb1P8hJStcAmk7mqNRxg9	127
10909	2vbYD9WyUNXWrkbB182pGZnwf6t71WTdrjEihguWLJJB854T5q4x	127
10912	2vc5DwS3ZFJLNCTp76CrAP6LMeJQyFUpNfKc9YB9QUbKb6jsKcqj	127
10913	2vaa8AteNV1dBGbu9HEmixHN4bw6tF8LtzPncD1LaNg6HLfrJnw3	127
10918	2vaogh1EFxaP8MsjmvGCq5tdDdDubHacTsVe4ht7t7EhNEpSPuVh	127
10937	2vaQcMJF5gp3cg45wFggtGd9SHBWRoPh67NbjUNYJWWePU15FjZw	127
10942	2vaqJ7uBdTk4zqDi6tv6BgMpfFdKeZhi7d8249pib7gNK85AqSHW	127
10944	2va9Xvue63uyAsy6ik5vV4UEDPhmYzQUnWuYZRUkam7U9e3pAHiC	127
10947	2vaytcHPgqiKcFw5Lx42S6bjXmuZDdLx2Lx9ATxJzEXAEEeVfLen	127
10950	2vaMhan8JvoeSYZSqhRnRH5vkMc7pQqHb4cwvERN4UW6oKXmN5FZ	127
10952	2vbij8cWEiGvPRP7a6cecu6sebtYUGHkdYEnA9hrc9dgTaaYTnKz	127
10956	2vastgDyQ2GxjgqFAgEY3UrdibedxennKFmL2MD3uFL7s58XLo8b	127
10961	2vbUh866Eqqx3ZEcQHT55RyYJehHS6BfmqhuZ9gpUn5NBo5RtxTh	127
10962	2vaF77cX6yJ76yWiWbDufN6TgxwwPGjMGT5VMvKBPtUybn8uzPS7	127
10965	2vbbay1MYym14GHc635XzCGmsj15AB3tPegSw47HUCZQGpoLzixx	127
10976	2vbHwDj4uDVvCQ2MnoY7BPdHn2F7kDv28pFE1fDA8TYimNRteowN	127
10985	2vaDq7cmFyzvZL4x8a65hEpSv5VtsN6zD457DzN2qksTh2xprLFK	127
10987	2vbGej28XrfePEUEBkrJ6dDAwe9AqAacZ42JwaccfY8ernNQbK5g	127
10989	2vb9xeU4xahK4NWYpUwqhX9yoCvAcVbbFVXjGjsoLszPoxh3ts9c	127
10991	2vavtDWzKpoCkC6z1F2AMwqxQMD4ssp6gG8VAnpmrCR1irogemDH	127
10996	2vb3zmx1eJdL7YB2zWXttjvZ26LTnCR2PETbbXU4ByfW9rAqJEvh	127
10999	2vaM3YbJkREe3QydcgSHF1fLh37NAEX9Kpkz8amNw5W6qn5HpxBd	127
11003	2vafwYmgC8qemMG3UkYRPDgyKAcp9nvDQpCjdMqB2Er2QDdzzNAM	127
11015	2vbVWUsEYfdkivX2JkbwMz6p22H6obrGqYRQp1VCHQUXmU6x44Py	127
11027	2vbcdENy4crGzHtxwaKNoALTdiQ2Tk92xUN1KfmnjeXa4Vrkmj9H	127
11029	2vaiB6fx59gNWeJp93tpN8DpqsoMa1jGPxNjiUVou2zN4h4yD7yC	127
11032	2vaUhw6HbfNhN1bCqFpoLnDAgbN5DD4v1f82TAGUeyTtaPyR5pa2	127
11034	2vbFfFKULZPVqh6yewJYJfzCQZmPay7J8aBAkSpuLn5kzVTa9om1	127
10680	2varPbP2i5sXNXQYNBt6jzMCH1Srcwi711AjRayNPMjQPu4CTU4i	127
10683	2vaq1ZWUFd7To2zGH9H2KtvPKoNNQW3zcgbYTR53tVEqepapDMQP	127
10688	2vbhwAtyYP22ffPCBzzdEYzEd65wvM5AkAQYVPTsuPhuvmf1FidK	127
10692	2vb4kqBW4fvTBDm7Wpt7ehgQCJMYb36j6rYH9BMnEM34khs4yxTG	127
10695	2vbvJjUa5gYExAC2TrM2vPiKjLo3932xhD4fdmqF9kPdjc6WVjTN	127
10697	2vbvoNNyEFVGaynqjJSiLoZ7LPdq7NmqL1mqEyMzMRjqUJ8j2BjT	127
10705	2vbWF9aa8JYe65VZ2yM7VLbB5VuySoPmaY6Bvp8nqMWWDB5jrqsj	127
10709	2vbXHUkgYpXsBUVfNMSHShzux41yDqT5ErUDkBHdZxGcBHgFVNud	127
10716	2vaTFGMH9EWPfmJ5QpSRvQSWYPUygCtuyQmcv2fcFifCbm8qQMgB	127
10718	2vbhuERZu5jcoUxDxBHRbCW93yt1FytPFtF3y3RXWt3Wgyngg9vU	127
10721	2vbsS4muVWSA2egCDRtKSeYorW16p9UDVWFhRpBjdcbjBMAzL592	127
10723	2vaRB4kmrL1ch84xg82f6q6Th7G6W1x8fgJsF7uwyvszDrhaDUEA	127
10729	2vbEcgbAw8ybqoeNNkBoQfYXFY9JMPFTpxXEzcki23yK7b4Y6Jaz	127
10731	2vbt8YV7hBmgiVFnpbyPKnufYGADTpJA4YrMcD55vwTpvbM1aNY5	127
10733	2vaNayUqw7jZfeQxoxJs5PrexJ4NBr3vVq1pfzsyzEPJSW6kKJ37	127
10736	2vapnMtsGYWua4UrSBaAM6EQPfv7x7Ap5j66f6B6iZkXn34xR8Le	127
10739	2vbXce2AjcynVTHBpsjXQvsoz7Y7kDvBUYpVDeFcsEjAsx9TEJhN	127
10741	2vbf7mkTnNxpUdsRtSAdUwYWWaCZWvFDK7euDwoBMVEYoJybnDa5	127
10749	2vbeECdM86peoZFGnabTiHgStqXLtFre94Lz1EjdjCSFdS186T4a	127
10751	2vaF7N5LPzdza3bqPmjbumKY9oZzfVtBKZcWaXo6VZSfFaSUCfqu	127
10760	2vasN3JVkADwpxK6KUFC6BeydbwMSYrJYAZsBg9ywfWJd8NkBoCH	127
10763	2vai6YQNHKCts9NQuNKNxVFL3aFeenBWQEbJankVfptrweqW44BJ	127
10766	2vaMy644jopcqmPbsyYPFmCHAbJfvseZwSRR6qQQtBiZ83rAJXeJ	127
10786	2vbyeuBJ8sd48ChFG6fnxyQWQWy3e3k8CT4yrmoejz8Ney5FAKRR	127
10793	2vbMxpHRtSFQkZvuK4egPRRmrfPQtgGixhUpNvPWmhvRTd9MRKLz	127
10808	2vbFezBoWYZXvKXL7wfwEiafmEmHzUD74pKTwwBU28Atwoaxx4dt	127
10811	2vbMgvGedo35kcdz6qtgCnuaUSECcywcovMrKviesTCzbDktAF8i	127
10815	2vbg1Cydp98tNyYP4hbPEtpLtKsgFtDUMSG5etMF5ZC5GwqfJzc4	127
10818	2vaYeaVRE6DyVFYAzg8e7Q1D3R4XDDpNzjp2d4Dsc3o3ooeyVydr	127
10821	2vaZenkEBm1xQ8yKGRDhztokF3ZBEbVGnLmc4W5oGZN9cG1tgTze	127
10823	2varGH8hMzTgQdNAbzvNEXi9d86wvPZ5gDGXRsjkEp23naLCHt3x	127
10825	2vbhBHsqbKXMogZx9TCepvHLd8hfA27kYcg8NXgqz2mFLjnNx1Nw	127
10828	2vafBbZbDNt4ejyq79nJRg4SQL436P46ukmToZoFPrB8ofqnS19k	127
10833	2vaArPum2YSu6A3tpnijYUGHXPcUdzrHW4BrZwquDBR9E8wVXoxp	127
10837	2vaj2v9F3FBPgZ5r2a7Q1vLdGnep58QuRmm8Ra5GnjZaJ98ZmSBT	127
10842	2vabHcgv8bcFwiGcq4cUczLNrZzgF7Yqz7sQ7H1nXTWez55v3XYp	127
10844	2vanfzHZHkrUoDuqdvw6UjdD7yAf9gEtvdeJE6edxDVKQUyftt69	127
10847	2vasecQFmanp8rPZdGforfnd1vypEZSVezGfUBBcwQeVYqECXwFp	127
10850	2vakyM3nQbj2czJbS6Cq1bY1e6EsESBA8UwqRbcxrWbnzpPYfC5Q	127
10851	2vbpb4ogURBeFFeA2wbhmib3ozcXkPRbRvtt6TZEyq4zvRmNqHDT	127
10854	2vb6jLojvz9mo4rVHMqWCBAF1JfwaJyAWfHpeeXhdLJrJvA21Xta	127
10857	2vaWmTns4Bak7iH3bBEikwUSpTkcjWjk1BCVtkTR7HF6YwKgU5UA	127
10859	2vbNGEj3PLBD9e1bxQhkJ6MJ7xphoF1u3d9xY5yjBLBbyDMqNUU1	127
10861	2vc3XKcbWrAU7Ec3rxQw5MP75bLmhVraSk6LtEM51MpAJFkCJJ6G	127
10865	2vaQFtKU6R3r6e1mq2JjFJQv6YmLkUHjZEGtWF7Gx8BokutzX6cJ	127
10868	2vavYjr816rTGfV9VNxHJ183131GCZZYYWwSBThCjAtA9iH7oWi1	127
10870	2vbjVwQyJVVk6iGAgnAkwGTuwbPJF9pBZP9zHaojAZjRdEctv7u8	127
10873	2vahG8dFQntdtX5XfVrEPFjYzesNU6n5Y5VqSGr2VmEJd2mKAsfQ	127
10876	2vaEMr9SH91cqutpfUBrNLuDuASxWGxekZe3GYwLqrWTtTe3PYTL	127
10884	2vavbZDvzBPco2v3Uhy4ny7vmg951aE7mx82pNuUKCuHZ7aXTE1a	127
10886	2vbSwFAHKmhu6tFovvKFrmnP1eqYVsy5SPhXF5Tt8gWV6H1svi5T	127
10890	2vav2g67TdiRy5Js5pNTddn6s3F2Fp5mQ6q1Ag6y8hhfYYk8qJ31	127
10893	2vbK32Zm9a4y5C4nrPVxV6yWefwVvdcQBK6HZ7J4YvmX33RyMVRX	127
10896	2vbsvfz3Rw3hggi9FvZGGXaL4FXCV1sXd9UJGKQR245oFGegTy3D	127
10899	2vb2CeBXXK31JUY8bGdvJz5Zw2ucMGV4xmYE1uYAJDnyPhK2LiYS	127
10901	2vbrkjxrkydCNmdAid8JWWveV3X1QLRorCzwDZc6SfbVv7N8GZ3e	127
10904	2vbJTPMJSWBzxGTdNDQ9MhrXhs8QymcU2LcocmHb55aqwcgfn3Fa	127
10907	2vc4VwUCp9TFKRanRitiJkSFdrkoJE7bvZqq3q8jDku9zJqcEbw7	127
10914	2vc5PpwUarbNXsX89UAG3F5PjKvFWyPhfQ7em9mF4UkHjifcfohH	127
10920	2vc5ar5wQxD8vGppcFL88ocR9tEH5pxA75RcjNEv6d8HtL7ocuQE	127
10923	2vbCPXFf5wiSVyMJKQYwMckHZn3iqNHNkc2g9BZBGDQfEcEqSCEo	127
10925	2vaYUgXNmaixS9rbhsUERjcmAjyqoYxXYzUjt2Aq3yEofECW934s	127
10931	2vbcWvxyevibo4LAQqf8WCY2FTWEPrwjpmp1mbu7uLdp1USDFkfM	127
10935	2vabrNwDaWVMQxqer4GnwNbDtgY6nj7S1EhioDWoEffVEWrxnLYF	127
10938	2vbD8xkZZrQ9jZAShLr6BWjKgZ4ajQ6YsGGjQQErooHjYE11dYWL	127
10940	2vaf5JxvFtyNgjcaaQWE6Y3ZgPv5T9HtfJ15AN3jz5whBCmiyRJy	127
10945	2vbxNWsWcoe22aB7zCR3dQ97cUVCTQ1GdabKniBDYUCiNy1YiCFn	127
10948	2vc1iPBgb8KjqsqgLGpyd6Xei5PSSQkWcpTXJqaWGdguTTmP8hZQ	127
10953	2vbcXK5ecTBGMQtevnxY3vFQKNcd86mYBvgwKePBx1x81asbQEqe	127
10959	2va9MpffkZ24UtPxWtfjB6Gjzr53UWStWvgfUVYj9ArSAdb14yJA	127
10963	2vaSqLSQvzspVb1SqHcjZ49wKyUT7YXBnAgrFxkNQuu7T3N7dfAS	127
10967	2vbWQQia5eeWiyNb9D6Q6i9H9CDQnqQttU5vuS6y4UexWQ3pjnYU	127
10970	2vbB89h5XrVks5MkGHDQkL9xiPrEJCysL27FXr2PB1suJSQhfsZh	127
10974	2vc57SVyyhDXMrGk3ch7UD5WyFraQMCRgJaRL3Dgn6Tcw27Fhiij	127
10980	2vbQkbZCnpYBHrVuoXWG3CeqEEEMu8HsQCsmCTGXCxumKqcRp8Z7	127
10990	2vbgLaT2emZzMNfUJR8MK4SJHCxZyMebaW1cCceJbngRkWEejVNj	127
10994	2vaTZTWqk71PCU6wSGt49YvFqVXJai9u9jCHEjRswpuEmZNT9itN	127
10997	2vbj9B1VwiFWwsmkpAZRg4okZmymmeRm9hxgh2ExtWnJkNPmfq2y	127
11000	2vabknb7WqSFGrAo28SmwTeTcusLbJvqZqi8KdTLcF6qDnd6zXYn	127
11004	2vaw2n9kYvZSJ4tuZchq7tYdUb81NMnJDypSC4XaCwPo8odUdGF8	127
11005	2vaUJW7kf9k8E47LqrpRc6CWNgv1xsKBjsGnucN7vuveMwLvCBVj	127
11010	2vac2ioUdEzWBStNQzFcp7uxousAyruwikJntN3NVsxx4oCAqebH	127
11012	2vbEuBuyQp6tarcfxirQtigmJzge7vQym85qYveDLas9wcpMATrs	127
11018	2vanXaij3qp1fyWwpVzGDVPtFeaNwbUAuipuZ8Q3zeRPXwk7YiBs	127
11020	2vaJi9Wb19gYPU75Xv11iZxrUmZX9tLz9XtBfMJqxVNC3hY9PmmB	127
11023	2vbpGWqpbsspMrMyeDkHzRXfDHNb9N8fcQtw4DUxVmQfMdzK4uc4	127
11025	2vaff81Pnd5Jb47prQK444G91LafWq1JFrHi1acx6EWvoFf2igCE	127
11030	2vbzjVV2qc5LjUciLALgwvtiAcvShwAoppENBB5vNXAxDogFR91M	127
11006	2vbE5XfaD4zX2TnPuLRZLHyD6N1XbPjW4xZQJQJ2QCw3hcNwADxT	127
11008	2vbVKBX8p3FH5xf2Qa2ZxbaUdBCrZ3mDce9r8oYFKZVLSDRCb4w6	127
11009	2vc3zW731qyLycnC5KLDokbMG2xgpNFLkxjq1pdMJdR3FWNxmKLN	127
11013	2vaLFfjyxyPTAYatxsbi9L2nHCmCvkYVQYUMssfhwMKZcms9ZCQ5	127
11019	2vbsR44bBXosuDGXM9g6u6cSZC7WpdosxM9s9MMuvo7TUEb6sYqi	127
11021	2vawJ5M7gCUWMZUUgtKCTr4z9c8ArGWQs26BpTqSLYArmL5xjMxY	127
11024	2vaLDNMkoGDc9nt6nfNVBECxBYiiByvk1DkkNDr1UawerjcqqzAL	127
11028	2vakPXdCmHfcG3N2dtpJfwxU4n4QpkhQM3ATcpdjj1eEoEkpxYxi	127
11041	2vbgkDjR6upT4ExqDBGqBVasDxaQk54sMq3DbApAarJv4i9HVy5U	127
11043	2vaRekZKgheifqzTPKf2ZiDB7Vqu1a5necYrPxyaMfP9xwhfe9Yq	127
11054	2vbVZYoqKLWgCjuboJdFZCqwJsebmPcp5iBHLrHWw2DLenpATGYF	127
11063	2vb9V98XGZHZPBQvEBSnvoXxPCaNV4pRiELJsHEa78P81vUgouAb	127
11065	2vc5AjuoFD6qfkbWbWGm39723XQsZrha1xEALJZ64mDoW4KtSYbt	127
11067	2vbpYSoUrZVdTgXGh2VQMEm4eJNe55VnHaRWem4C7ozVKVDQ99fv	127
11070	2vaAz5cCDxZoV4i5Cir1Gc3JmF1EFDsGY3rdkKKWWcNAVXKcS114	127
11077	2vb46NeMtwiTwfMfyxPcoMsCVDDxca5knF5QwXGAd3LeoAsqJCvm	127
11082	2vaBYAmLMxfkNfrbqAng7o5DuP8hwYf8b4E621wj7xdLoc5kQYpc	127
11086	2vbDFGid1uBA1qgn1rVbWV4ARYawN3dhvEyWgaJBR9HmbFi7JaG6	127
11088	2vakWB7KC8MrrNnBmVQi2RKiWsWqd57ej3VVfyaEL7jqkEwdVxU8	127
11095	2vaV4G9HP5N7pdCqZKjpk2FrsnfsT39BuBNjazTWdnBRmR7eqNha	127
11102	2vc4cDMjBfeyLy7G3B29vf5G8mprTuxTjh6ZtU6QFa3W5QLa3i9E	127
11103	2vanbKjnytybY7rbXjfi5ZmfKNJhasHyaPT6YGSPdmqzsHxvfDHc	127
11105	2vbhsEAV8avJHceNexhHiMrVvvsCfVkR6KBoH4xpbvg73Vn4fJoJ	127
11108	2vaFsjaYVRfCQ9vuwV3bSeDFwiriGzcq8d4gUdxqSZcXzsa4r5AB	127
11110	2vbJybvboAbdS64a4J4gmAsggaDFZDr1ib9xdEbWH5fpok5fdsAS	127
11112	2vb67hQ8LvBhdLaMpttAuWMT9mMa7U4bsxm8sqjReN36Zv5G4c3c	127
11124	2vc1Xwexf4xNMcCzShjEwLQsjGZbUNrWVBWjVcxCmPb85RZDxiYy	127
11126	2vavUCDZgy6QYMdVpr9Ujjt7va4TDzymZLMEWRQcMj7zLt8Tcozv	127
11131	2vaDBrEuiMgGjQHrm9hZQYWPrcgMAZJpqZ91cvTRTmNtvhLP4qtR	127
11134	2vbB9qt7RrW34MSsXRvK66fDBhJUwcZsTGuVDgYFSp2iYXwV7RzT	127
11142	2vbW4oSYWxs8fAFYj7zQPqH8et9MUAdtbhFLWrGz8EjsoXNeyKqU	127
11149	2vbskC9tbr8GVBFVszrdLv4QPr58PCLKCNU4gPE4hRuzjQ3zC8Nq	127
11152	2vaTHBuiPBdZEwWSmNshRCe6GStK3UTjQQ5bTaJuRncvBFdxvtfw	127
11156	2vbGdub6cDnJCdwY7z82X9gzrbQH5u2vshAhhjsem8PCyTZQDfrv	127
11161	2vaoc53By31YZRJqSw9qnnmLFdUWqNhVmGGquaPBVvZtKPvJRY8J	127
11169	2vauMhRMSi5n9fkkZSyxYweffeojG2MSTcqniZcMuZ74nW2wmjsF	127
11174	2vayY88Q41Df4GXoMgggpxA7ZP9cD2PMewr8eVKTRcLnjWuY7Wkt	127
11182	2vbhN25EbtvXV747D2KGH4j3oAQSMtbe6J9gLQ6Mn9mzcXvw5XW8	127
11186	2vbVjJ2pPejmUjCUx2baUd9w5NJSzFAuY3pGwahR1hLheqsChoSz	127
11189	2vbn3v3qXefAA3G9NT5yWhBgPZRpQcnL2WTNk2hR6ZFMYgLdjmQw	127
11195	2vaFqr1TJucQWzaSFdj2gfFv1uRfJrNvXbjggGA7eo8azKzzqnSJ	127
11197	2vax5ZrMJ3L7dXFEz7UCGeS4sKQhtKMcqd61d7SMhFbS4FP3CRkZ	127
11199	2vbhneWSv4DDmLgUPw7uHVCuPxWb99uvA8bF8SZ1d1mepn8vuXxS	127
11203	2vbs41Jec1TfUm8qKKHgffhoda55qrzjdYfmp3G1hiaTuSTFn4T9	127
11212	2vbWVM3wyEXkyiPDozhPto2fk5NYxBeBDbN5hoz81X8PkJHqt9d8	127
11214	2vb1to19upec4Qh7onURqbPMBa3rmxY5w8tSz45rJuRFfvFUEZRb	127
11216	2vaaZheXZNQ4j2iXT6AQgh2yecSW13RCBweBhDWtNtHgY1D1GASw	127
11219	2vamR3pBgGQPJdTu7uenHh9NCVAQDYL9WrCeqZxajSuuodqxq9S8	127
11222	2vc2L17SRnNotcUvetGEyAvorDvmUSZY47tamYiraQZHFucc4jCf	127
11223	2vbLBGRHSPKs7qCqkx4wm1qtB6aAXajJbb7tag7vCjxF4AH1iRYT	127
11225	2vbQZP33UazB2kMNn2RvbAqLnReQUPmcaUb9HSwfiF4KfnvF1SD7	127
11227	2vbfidKMZ4P78H4QTXyufiRFhq3NL3qQHnkBb9TgJzV7bh6sJfZL	127
11232	2vbt8wiPYLazUczJP7V4HkgyMHZtXAiEVz2RGvzS7fo3M8rmrEZN	127
11237	2vaU1pMJ3soQN4eDKKpD1oH9iZavEkmqSqhtk6kuzbkb5ikWGFD8	127
11239	2vbwqqywfrRCsNW9EU23BVgWbYPsS1YcXNTYHASwg4gfPrMQf1rV	127
11242	2vc1kmtuyuc5WZvviE6HNhwPXjxtVDS3eNF9EvY92fHwdVXc2ME9	127
11247	2vbYXVLpqn9eXeeQkYkxUvLRxA2VPM87qPpf9M1a5T74g4QLSZwH	127
11249	2vboFNXN8QvYfKRtzZenPktoM5K3bSVj1cYYDMVPepEDokHQ3iEw	127
11257	2vc5cbhrRHFe46n1Y5catGTc4FGDbt6YS54GJKt7xSDqysM4Jkoq	127
11262	2vbYGJej9AUQV79QkSsrU7gyAz799b5hZfwfa5XocJGiiRQMFJiJ	127
11264	2vc5TVb46fYwNfUwYef1pEULPECAmrG9Vu8dh1yEVq3j6nTeBPSY	127
11270	2vbALr7truGA5we3DYGQpEjQCx7wP4gt4STq5Ywy47q5h1NaCA5j	127
11272	2vakugi6xQbRGUFoNAX1bA2RXGwKQgzduu8SPe2865mZfmqsXZLH	127
11275	2vb4VXi2REMPFGgVDDEe76vQ5Wkcsszxr5icXxFZESFDdib9WdGN	127
11281	2vaJe3zWMgRHPggKfESrKBZcGKJknfKm8YqavFbiN1RQqnH2rNvu	127
11283	2vc1iF2avNy6G4Jo6D2o4ZKZnd2Whrtc6LmXtDTHUUH1EPtpw57H	127
11286	2vbuHHuHgLqnM5v9VNtEbCCZ9Mzi8CwhkmUqMMXxe4ZCCkGtz6F7	127
11291	2vaUxTGWic77Ex4oGF4MdWM1pZ3ogLK6WX3YoNn2K4kbzXFmp9G7	127
11293	2vbqMuf48UugAfaDcweDckxF7yezvuidVVVYgcwoyJgnizFZFcZy	127
11306	2vbf6Vcca1bVom4bsmWeS8UYmBcY4b8xbD9ZTptHyyHHwzKqK8KG	127
11308	2vb1HTMeQbpMFs4DXn2VVC79BvPe1fuomrFuQ5dt8LMKfowDjDEo	127
11311	2vbERNhcVeyVUm2emrAt1m6FXm1d9AhnWpXqGEaprjd7Xv3ZBY2H	127
11313	2vbyDQCwGmngQ2URofzvYebrQix16nk7aZJHovBdZWjVsiPPQTy4	127
11321	2vbDLsHZht8dUtXvKbU17cVYLnZebibANeRfnz9V8sJzPoEqtrur	127
11323	2vafu478SCDDzvsgcxQbxAHt7UuX9hRJ8zcembbiAawixEfWq3zp	127
11325	2vbdGJG3h5eu2maNZrobKMz1tfA8j8DuaqC7odXycyfGhQWTPaJs	127
11330	2vaTSjXd3rW6WTxCpybjSo9Qd9Wyi2Ue5wyFSSSWYsudwe4Npj5Q	127
11331	2vaXo8RYuDuL9SyFGTghM5fTjQmGsWrviVHvXMSZeLAk4L3hEDEs	127
11334	2vakUmfDgFZ3aKybEwnmwV4q94UkwZZBjLUoMupF137vRmeJVB5B	127
11339	2vbLgyVnVut3oddhwJ8K3jcjHmr62WTxeKvKyRNm8ApQYRcoSbcZ	127
11011	2vbQ3JM69zF3csH62n616XcJZFLbt1eDTDsHjZZ4LE75FnFREMMv	127
11014	2vaw1p3Kgk8EwS2DbmCUVio9exMjRmRPvRgAD9NnJAwwbnuC37LS	127
11016	2vbPLPSd1pE37ZUMPXvm1hxK2qHtEeEjF83RVEALj5GPQYeTXKtL	127
11017	2vba1ZLyjzCcZHWWwn1eJknUmQQLVC9xd6ThXGHxRd9JkgcZu51d	127
11022	2vc3yDZmTjp3vmRiBMQ2LbHWtTVB6d8V68UpH7R9ZC1R8sWTeVxQ	127
11026	2vabJEjqwCiXSAWFY3jLWpeKLZagMQFpb4thHcBoCfGZLuQJr3dX	127
11031	2vbb9oNuvCsJtroLfsVnyTXRgXvV2FT3haJpU5Jkt5ZggCtCb7BF	127
11036	2vazr7NuioDRqzmCbe26UCeEFDmDtSpuSG1LgKnU1oJKNP65dCoU	127
11042	2vc5ropNTMfPqzNyCSvtPEbg8bohbvxUHHLCDaq2L9B8hwFBAbXi	127
11044	2vbEjFQcSSjEz4BrGiZ3fN1eFACtKWehHVPw7XVL2RpKfKfBNPrT	127
11047	2vb2858Cnixs5KAF8R7p6Lwr7xpFcXvHkZBxJ1GUJF2sicg5FDyf	127
11055	2vbrNSDGFp1tQZDGsUoNcYVPxaz4w2JAxWpQGihjVimvmacNBEoF	127
11056	2vb5ytHHxxKQcE1fDSt2SfrtKEejsq1woN47GhgMY95TgvKD7i1w	127
11061	2vbnmtuD2ZgsfTY1ypLDYsG3gaFkhk5bL3rnYutAGSCUkVuaNteN	127
11066	2vajsBD58ugPmA76e5mQFCHXw4EZKgugdCrGoYnpQ9HH6Ac3x5Pe	127
11068	2vaxBkvCtWomkGMr8EAeUBbjaHSMiRbXwZgbxHGAugeJYxzrzjyj	127
11075	2vaamoKZF8u7Kw1gHcv5fXJ4UJTL3w3jzDPrcfwksKCi6HJ3i99K	127
11078	2vazpkBsCK61a1bQh5ptaWaMcr55VE3c7m3wkBSbbo58aKr3Thje	127
11080	2vbFe7tuur8PMDFpmcxChSVtc1xJpbqk1MLxzV6AB7SN8dP2Av7Z	127
11083	2vbVE4UUXcJ7JiFBo4Gmmsh5qfkV18BzkT4JYEnhmyEbjWi1Mmop	127
11093	2vbZtXpnsT8CCxZB4a8V1s3b4T5a4BxeVSdJviviusodYdy9U6Yp	127
11097	2vc4zyiGecUF4pNPgnVSQ353JoUfqgSaVPgPgknWevr5ysPajmdX	127
11098	2vaQDV6Es37zYaTNXWpVSm5vvpEhdaoEdDrj4yDSehohHK5P4Bog	127
11099	2vbQKkrefCEKUqGFESMrfcUohc4Vj3BYXek9Js1PvcjXgc74RksX	127
11106	2vc4LPs6Uknm9ZXMt9B6tbD17UpygGzwfgm9AqWS7Nh6oFoa4MdW	127
11115	2vbb76bbsn12BwFT4GzgKotWuqr1Qz9psXaR8nCL9gbYvq8gt9xW	127
11117	2vbgYK9PjR9WLkQu2YYBie7huyBoG8MRmPqC8XKTUAR5rzgPimy1	127
11122	2vazNmxw5DnaLbddtrDR9c27cippsuL4qS9VTgAy4zBK3syPgpqX	127
11125	2vabrF8wzTAHmk6SWAjvYrBbDFWjWof24Mw5TLtyrkE6Fj8rgnn6	127
11129	2vbqSAw2tqgbZub1Q1wGoCiSRuUi8GW5wsngLoCePKecWUonLiL6	127
11135	2vayXiEKPKesSz5oH5tbEhbws2qUTqwmBvS2Q2pbwuga1Yp1yaLQ	127
11137	2vaW7wudFMSHCX93gMjXviYewN5av7x7Xi75rYwr4jzmPzwKJNUr	127
11140	2vaivevxmcU9JaVow2PvfM4BusqqGXnDsygQ33ZQ8cVX8TWoEDFr	127
11145	2vaicFb9P7BffoxhbBEmUZEuSX32vm7abTaF25kb7rrHxh2kgGJE	127
11147	2vbhseT9MT1UKFxUtEE15DKrbE5LH543RPijgaXQwDDprq4MRUDd	127
11150	2vbjaLfaKQxpSAWUa71ZS9UA1UW2jzYsED93wdRwgGa5MfVBFiEP	127
11153	2vaALEUF8RD2YE32EtB27BkKDNLaFBfy6zwLoPW7bLmxB9PjzQ9u	127
11154	2vaAdFSBkqxi2A8zGG7944ayEjDsyjGFbT9siTt68SApHuDgtVDm	127
11159	2vc2v1J71ksf6B6HCef9ZUtYYcwu5G3MPHBHADMi2nq2xsUzLd2p	127
11162	2vbbgAaaVuQ6u3XHjoSJEuLrNruqp2MgMte9DUG14UMh6TincF1e	127
11164	2vaT5fQmoqekHTLucsxA3xcTw3FjDnttGJgMczPRaeG5nhaW5Da6	127
11166	2vbFeyn8kTLLkReTeT4Pj3pagrYXydCeLYw2F6iKVv9YAzEzuba4	127
11171	2vb1kKZSbUK6VpQmTf3hyvAhNkhP3hTA1M8KZxEuKh6CGQKciGm4	127
11175	2vbkwpQhmRUeWTJ1WsDUacPAJLEkzWA9fjMwcEqZgPgQgJzKwiDh	127
11178	2vaRPFoWmcmakPwreYUJnV7CnrnPcji3cLMM3PyxKTeymctKQvGq	127
11184	2vbqhTzQVMh3xg4Pyr46enbcwpiHJFMBY6G7tpMFvi5xAGwkPDpY	127
11187	2vb3FPNGkaa5xJP18UbEGPoP8YhsKAaMdhnRB4JjkGFzmzggP8pE	127
11193	2vbMijzsgMDdcUj4tXByKjXNTSDmBNLEzaTPgo9jmFqFK64fXBLW	127
11196	2vai4ztaKooprSzZUbYWp3WLcPvHH3j6oX9FQyttFLXZUSjvcABm	127
11204	2vacW3f6N1B78dF2aPe9kHp9yXcxGt74rXKWhCWBe4ejK9xRbdL4	127
11205	2vbekBhCtfmUjp98LJ3cHZXm1ubyQaHXPYZkAXfwTx8CdMYimgrb	127
11208	2vbqpAZK6po4x4PQxVaJv8cZyS6RrCNh2ZvQXsWDXnHL7Kbs7mt1	127
11211	2vc217cXaeikhXDCZ25dH1qBCKwQJVGUNw5LXeshHd1TheuTWCjQ	127
11213	2vbtYJ3mQHT5ymq2TeLAnRcSa1BLTf23ov8S2LQaTUa2oX1v3onq	127
11215	2vaHmsrVSKDPznsAG2tkoM972mUZkfqPGwZ3S4i4yUiqbiqbGHo3	127
11221	2vbcGZXrJbEnDcKn5fEKtdUp9pd3HCoru12Fx3GuqJ5cGFiUA7ZD	127
11224	2vbbaLhekQv3fUo5kPz5htdLqBgtZnjCxcCMCm71HkPLQFhNDWa3	127
11226	2vaJjssd6CKEtdn2gTTFmqi6UQCox6PvDn1GjPG4wvXHwctTn7yp	127
11233	2vasrHM7bnbT9igX5nrzt98v3TvxrpzJR4HwwnPECv6hvfoNB4Gh	127
11238	2vbUkAdn8hodTFWdJrogoj2HFzmKgC8Fjk48adqQecaiNRMgpSeE	127
11240	2vb5ri1KuC73BTe8yyavgZJs39qQh5ZaaD3MmL4i6y7LTAV2oySk	127
11241	2vafyxULzcrQuGRvnZrRTsBiKuQ5Yw5ZybSLQ5kVYVdaGvSuXZFw	127
11243	2vc3m9TLAdWFvDn1VBQQm5QH998vbieVthaZHJXYW48mNJk8xS7k	127
11248	2vaemTAd6KiULefuNkQQTV6p9o7m2YXQCdfeDQpddeFKxQ42difV	127
11250	2vaSh7pm7Kphvn5yzGonsxWWNd82raTC4k7oe3uYcsjPz11hpdxA	127
11255	2vbLECKUR5TR9Bp8qHbrEoZbMe4KaGUQBWvMeKjBwgcZ5AXrZEws	127
11258	2vaacnMAHU7i6sAQ3rRyQsWpyp2CoCgFieDAs1C94f6SKVeRWSGz	127
11263	2vbYbDBmh56h7TGLBbSf6zmmRYeML4XSQQk42poUmiJ4zS3nnXVb	127
11265	2vaouDxPWyjEFGBu5YUsfFKrDNgymDyFvCvbq1DDYRQxAWhATmCj	127
11268	2vbSM2Ynksvrm2ahGWVYuj3SjM4K2UEMJJictHDHHFH2mDh8j7Qd	127
11277	2vagY4u81mVeerA1bDgdJYu4X7UrrWRjPpAhyeq2fcDQ3UryTTQQ	127
11279	2vbDDvqjF2g3oscCjdnThrjXFt9Dfbp1LvfUkPuZEvgyjBhVbgYi	127
11284	2vbnEPAj1Hb5Na2FRrXvLhjZWDdNz69koVNGTA7T9BGqaZaJFA3Q	127
11288	2vbYLruJa95NLFVXLE8kGRedNiPZxZwycYuvunEt2c3Y16jsoP2P	127
11294	2vadqk3NRFE3UdZ26WcEVgTUwLSD2FuA6UY69A5ecGHV9nRbBWv2	127
11297	2vayfbT2us3tnJxAtpPxtQACerfapv19Wsw4gbgj8fLJt9P5YASS	127
11301	2vagXvuQPd8yQ3Tda86QpiWmQceQnN7Xcf14x4bjaT17tk5fyJfB	127
11303	2vafD9LF9z3pErQGSvBR62aEVztFpMGHDdzU2Ao97LHjR74ASavk	127
11304	2vbUD7ft9WYC4htPn556hJNz8JvfJtJqd9KWcZtbM4cdNvjkX5gp	127
11309	2vavaw7Agg49VH8BZuLjLYozTY9Hgdt7GzFFBVnTJTZw2hweWfUH	127
11314	2vbjavp5rtq6CL36xX96DGCuuyB8bGgckXoVwM4qVC2FeX95RcRX	127
11316	2vbMsQv9gQQ5UA2pT7VNksQWZipeMwYkXxS6kNugYnMjnRPBKrsY	127
11318	2vaGn6BSkv6wEZ5kgTVZG2znc2gU3owWJ81FZDkPKhTC3kn7na1U	127
11319	2vazBRCKzjT3FfaLCVWWioZJcwoZ5KrutVGZLfHAWw9LXsTY3bnE	127
11326	2vbVNBqHHtnB2UgsHjfZSqEF3nmQwQP5zMTHK6N7gP389uqHeXfB	127
11328	2vbQGpqdJSwUoquGqkkEp34HWA44fueBi5PifcZsoVoMuHbm99Si	127
11333	2vaeieacSEXFQAQu3yvwrouuu22dfRV9gZu9b9sXtwckx6sAQ4ev	127
11336	2vamEfbtjcDEQiXL2xKjyRXbVYz4tktMiJEGGQxrsjqbxiEJF9jf	127
11033	2vbpTXUacG6rdtbFfELoNhAmryvML429cGjpGT4chdDyXnZhaFrE	127
11035	2vane4TS9UHmp5NLxEfugXbFHuc9PaxAZzGMh57xRut7dbAkJP36	127
11038	2vbVxk6pBBEwztXKNhiAbtLzk7KZne8rt3F9DX6dEw9Hm34Amxgz	127
11040	2vaocpi39V4ubhXg4JvrtgV3HL9nwomv74RYaGy1ithSBT3gcVjX	127
11045	2vaEKPmZ62fMWeiF6ge4jHZwrwcSDPUiDqujS3srwNY4QGd8t1RP	127
11046	2vbeSXGqWsQTH7DxMMt63Tc9wAXwAbs6XGJaHARVNv6hoEDk1Zs1	127
11049	2vaPE5zRN5qqPaA21EP8Qit6xyfJzyDHrmnvm5Yk448aLjTcDpUC	127
11051	2vayJsZkK8jAGQG9FGGYPuNHsNMwzQvrfiRBG92pW7uAiq2XdzeC	127
11053	2vbvDixmux6jqAbcFboVWtxrUsZ11sEasb6CEPZjKeWjj2HrSVBv	127
11058	2vaKHesKvrYkSJcRrCUqQ9B6nUoGCYdHCQcvAUo7avutCemXeqZV	127
11060	2vbyArVkF9SM7xSWHyXRiWzB5yrB7A5fFgRDjhnjkayAEvVSkGYG	127
11062	2vaKMiDZ8LomKgAUxpcmNSgTV8iULZ2D15AiqfEyDrpGMyQbm2e5	127
11069	2vahLgnkS5yqcdxURUPoXWxnLvt7dFNuMys4JtvzbuRnYziVhMSf	127
11072	2vaWCduwDbrwNMDc9FbSfw6qZKNW4QqCjo6Agv6QJzYZASjgikdz	127
11074	2vaRyLnZeP8FZMzg1k64tk7vVnge3c5Hixr5hAdgSBcSxn9E53q6	127
11076	2vaGEHTGGmz89utNggeZe1PuM8RP64TenW8eD3mKjXiGCbuhwWSv	127
11079	2vacfhh9xFFx5vpWhixca853XFR5kGnyfnY2PT8y7Q6kCbKUeVWz	127
11085	2vbR52rQNwbWyXL1fjwQLp66eekwTR2TfocfVRGL1EK6aQ7otWYx	127
11087	2vc3jYeCGCrtdw55tsf3nSK19onaRQmsJEji7TXp3z5HQYuycar6	127
11090	2vauWFB4ujcEuhAq51dgJtwhA5mt1THu3CoYAu1i98Yv8B64FB6y	127
11092	2vbPS5gqBX9KpDiDTSoxZzBdaeGrGnCMa1KJixs4TkSXFpGbHDEY	127
11094	2va9EmMz5mcTshaJTLNaQ64Ui1xdfpjqvHRMuqFzjBJm3B1hYaue	127
11101	2vbUhpmv8TyrAR3dxzHAshZTAtcKDD3aGxXAsYRM7pMV6F5abJMF	127
11109	2vaAkwo1XmyvUVNnAXYWNfTRXm3TMwzsiHiXrFu3rkuagE9n48Vb	127
11114	2vbbTrGeNERiJ3HHwQqSSe26rbEnePsxp4ES9oQEAZnjzn7aPSCi	127
11119	2vabJhS5mebEm3rgUCUD3Z57LM148eAxdZAELN41kBDA8qzhSYWN	127
11121	2vbV7RxfN13ojgYaKhFrgBa6HhU8DtY1hhjTPZjVgfuv3s6X4oAc	127
11123	2vb1tQhf1fxAhWC284WbP6TEWy4KvkAFQaXjUGLhebXrVycf43k1	127
11128	2vaox4biYG8WknyWTkHTcoqChrko28fEizmbQ6rS2yYRbGgDxbEG	127
11133	2vaT4jLqybHwisRFvnDqWkUKnBRpZJkBze33wERqudZnLqfpGQL4	127
11136	2vbg25k7o7ao3bojP9Q6oCScFW73bbkCj3Mvo9X9xGwxmwB8ouFG	127
11139	2vaZdBbQZ3grkisNMh7EDK5erd3vxu2LPYxKwPiiVGQFxJqaAsAM	127
11141	2vbd2UNw35SJC14AuFSjkputMsWXH736zzF3FRRbptr6ovWNQK5a	127
11144	2vaTt5AS3nMA2z8ALC4USH72LS6XLSzk38AoYtYhvchh32TT5m2i	127
11146	2vbVXnRdtJ5xgm5NogZNha2ZCv91Ax4gp72XPm5jtRoeYyNWupSC	127
11151	2vaZoRRkeVhA552LZSfLZDFixxxM6E4Tf8VtLSpyGikUyBbYwk2h	127
11158	2vbifqPJuP1URJSKB8XSRQxZjoJ4AZFb8yT989FTuuARt4AataoL	127
11160	2vbgsDGsqsoMQHGNjZfDj6BNdLfbtXAEfCEU6mvoDyFxty5kX4BN	127
11163	2vaA1HXnrHK6ZDuuEvjX8NeQMPsSWfkhLc2XMBvbqsev5tvdruQe	127
11167	2vaAqKDZrvVPreGat3vpfqLvt16kCVC3XHc8YvvoLVkZ5zU8SmpN	127
11168	2vbWkcwje2wZz3TnU5ZNtGXUHfZXHUZoKSL5PCK5qvVUKLUXPdvt	127
11170	2vbg5twwEwyEg5rQDaHsgpaaP26epLJgFTVueLpiKNYnedht8U5t	127
11173	2vaHyMhf5wi8PjbLsvWqapN3pPKhCtzNCGCzrZ1DTZYc2oYUNht4	127
11179	2vapshCeWLyKBKGCEi4EN2g8HroWXjgYav1PH7y5RxBN2ftCiFKt	127
11183	2vbK8RytWvPb3caDjfc8qDpKnMmjUKPWM1Rz7CrJpddB8nKm4oUK	127
11190	2vbmDRVELSjNByQJ2so7HspUAodHU4YcKziFG1JadUhpPWqPGSti	127
11192	2vagX4eBK4YuySynD728n4SZbaorzbmiVM6Rn3gA6gKzNFkxNxWn	127
11194	2vbRjLZVtVXvryrzYuwt6tt5gXpNtRNo4rDApJ22gxpXX2SCUJtQ	127
11202	2vbQNbRTjN5ShvyF7jQ5HUVVq4bWWZVz1gVwQTtPytzuy19zbtmp	127
11206	2va9XGQM4pSntfyvccrYX4EKpjPpAwGkZB2hsKnG2BzkMnWoJyaW	127
11207	2vbBcbxFyr2WHt7g6ag2pPaKWYH9CHKnNDxdbSwLFNnfBa2gKugr	127
11210	2vbLjYKSgoig6sV4jyt8wqF3KJzV7vytao1QM7u9qps36mCPqTgQ	127
11217	2vaqe2UdNcxiG5TjNmFpYY5Fua2cxiB3gFu7YDcPMSFT2aDVCCxT	127
11220	2vbrH2o5H9oR3jqQ2XgbsDLxX9zJD1sDMfB75JxF1hHvJyq9QzDZ	127
11228	2vb2swEwjHiUUryjuUTDD29oUfi3eLQTgUJ4qqCqEP38t1zZ5uBm	127
11230	2vaYRdkGEsCEG1unrWJs13AS3bY2w8FeVj2fsik7aTsq81qZh8Ws	127
11235	2vbWzaLqvT8BpYWs1iAd5FdBvFgiBoqJWSakNFp2Tq3h7X6ufnig	127
11245	2vbBH9wEtia6g35tUEvvJvV4rHCWbFqKFqpsgyc5tLvicgqRX5JA	127
11252	2vbwb4MXVYzQpDY4xT8A8554JwFBY2TovC34VbButMxdyzUxMR61	127
11254	2vb4McMjPBt1Taq31FeNiBD8A6fuBP55ZgDcVN7Gon3rA7aWUk3C	127
11260	2vb7wS58tzFkBDGxn9fsqdKnBBJ9z6Zrarbr7DhjYmeubRYMUReT	127
11267	2vb4JWxPQhF35zraEJdZ3Zagx9Lyy88wCtkQYSYNHTCZkZMhQzN7	127
11274	2vapRBsdmPBuoVhXZhLqYoDajnEGBY6DnJANd2uKfWeREAn2q3fU	127
11276	2vbSgkNpqTWr2SSs2uMBJeR8ZPQgjP9MiZYjR8W5QFu8Xz2rp9XY	127
11278	2vabeJEaWaUW28ThinvTpmYU9qXorT3kcQR9gbojgscfS6mphyhn	127
11285	2vaoTKCyW3nN2Mg1gBzAJvtK5CS5xJAACpZtgmmhKNTgyjeatRCJ	127
11287	2vbTry9QMFuWzwaQp9kYk4MAYhySaV5Pdc7crNpgDg3WgodJDgup	127
11290	2vbUZkcsLBhehS6YYy2dBPtd4nJ2FmpBbe3zcSLM2JYc6x5C8Naz	127
11296	2vasubsx2ignnWi6hYnzoVasJFhy8Ej3sBk7cZSGddnH9CTcQMQC	127
11300	2vbUvEBXhbmHkfZz8wUfLLTPJyymJsMheEookNTnmQhZj9WkvmzP	127
11302	2vacb3qJHLtAzDJ18Nvf5ew3fEQUAFmP2H3cqcXpuWFNW9dy9xfc	127
11310	2vbBHd3hUC5WC3vaSk7mvjXySvzKncHyGkPjJGv5ott8XtE4u671	127
11315	2vazMpHzz8GQR2WgCstkbAKWTUGPQPRyB7TDDoUrqodhjZWAHBQz	127
11317	2vbM23eEqhEkK2cWXvZPRKRVinjwsdW2jFQaS52VKXARFCEtWE3e	127
11320	2vbB7jsYeSvtuvXtXZchbLv3JqxuB3EmpZX5kuMzhKfFsjCipftf	127
11327	2vandp37xw7pxbQDDGbwDR9xRt7xPwVSvC79UFG5Trwxsrep1VYq	127
11337	2vbFWTcA96bM3XVWWBo885UTaT2pdCoJAMgf6TheV3cYEGyLGZ5E	127
11342	2vbQXAfymvms5DYoYujGJe4fMn5T1i1zd4jbJ4Rvv6pu9sw3TvMt	127
11037	2vb7EHq97fyxxmWLdvGpn8aaPcR5THA4hQ97P9YDzd3i5ZBLMFpf	127
11039	2vaGHLxxP8EnKAocLUjJoZi9GmvEAQzs75LFS5H4UsWFAv3D64gN	127
11048	2vaUA5oyYyaXPN5J8pjB6AGC1KQDUN6tNX8VJsA3xYnszDHK2hVJ	127
11050	2vaGkJT7GFzmbcGWHdEwciPAf4f4jYQLL2fnjVJ9NW43nTka9s1m	127
11052	2vaCT82rafez1cyP1Jcw7fYakC66uJVzJLMvXvf3FanLMkXvYP9f	127
11057	2vc3KR2C7YvU67grMGhnZZXHRsv2rGvtgS7sMeVdckDcq6RuscFV	127
11059	2vbzwzV7T26HLe1dw1dE3Dx1ajxWa42zEip13XkHBRgGbsr3Xp64	127
11064	2vadCCebJLJxCrk26GWJ3gHYeMqgLJwdMsdTVjh241k4sqnEfRQW	127
11071	2vbP7Qapmm3Bn3zU6zGxPDbPqZMSmjCCPSmNhrk1Z5dVeLEiumQK	127
11073	2vbgQCHredbCj4GMYMFRbzymhd7jMnB3tZUx2K6qZeXUJ9oErsjo	127
11081	2vaVXL4CZKJXGgo9kdeB7qNpJVpcituDJdozrs7vwGLMuy9UxtxK	127
11084	2vc2o9Nyrv4gXvhxAF5LvySa1mSWz4NbbngwRXuTMSAAfSYs8ZEs	127
11089	2vbwSR7r4mxpuLqG5qKyAaCSnH3A9qxVsdZboBnuvg5SHkb1uqz2	127
11091	2vbUH7si2rsTBYuVySAzncHFj1Cfuw35HNyFfX8RZRkpTNFZRydw	127
11096	2vbVMdZkanDa4apYqZ1PTPhi7D3hfCv3chPk4FoLA6CNKH565ErT	127
11100	2vbkr3tZMTsUoNSgBhiU8tWxtjgkQdT1BRinqkjArdypQ8HVQDFF	127
11104	2vaAqMB1CcbvP5vuvEjSgaEfQLzGgWNARLp3YJedqqbxdDnAWYi1	127
11107	2vaWL84CPCkHS4CPQJo37m5Mu8GNicEJzGgTbh82E6ZjWquJiyV2	127
11111	2vapwnTvPQZiGk8bu896ouwrLRiK7rNDbPRHZgSkDeb3Xbbh1HRf	127
11113	2vbYwPSvVYQYnfyw9TqmDj72HajHV3mwT6KMqaGZcpaeFd16DVXQ	127
11116	2vaRkryEjM7GRSCWwRamYpyk31dKAXicqE9hR6P3Qxkk3stkH36g	127
11118	2vbtUnW7jDCwtSZzojF4HgfXNBK5nLbwFW8caPvKZTqW7aatjG88	127
11120	2vbCDPq3fTxDkQDyaBENQkqhRixmhxBB3oXC4qzh2P6SMWCcqMdF	127
11127	2vb1H9AKjPuGMSptc2E8HpJLbgDU3cXQdCCE1fJj4U1mwEX5USDU	127
11130	2vbd5EiNGCZd9xp1ZAtZFutC6D5ivDFPCumLGnW5KbZGiYchLMns	127
11132	2vbtG9T2R2wy1XG88gYfzB1NCwnSm8NdKrHfKY978S6kKX33QAaw	127
11138	2vbMUSow4M8eHtZXK3Z3aNtgThC43y4vfygHJqPSgp6VUQjG5gPY	127
11143	2vaTRrUsfyYU5KRTP6B8dsVwPftCpmeWmdZhbx71v8t9CMHUc46X	127
11148	2vazj6xEEm4ipusb4XERMj5Uvcs67tGKs164NwgiMDTicyCKAG9P	127
11155	2vbu3VsWJ8tQFWifKyvuZqbmigXQcqaw1LDRKCzKP5CwteUbKo9q	127
11157	2vbUk1dJJk66JCrPfLr25EmRYU6ngJsrUVLLwrCzArYbHHGiDrTW	127
11165	2vbkZi3hN1Ew8Ym42Yw9s4rMQstMYUXQxgmajNcoYg15JGjwwkSz	127
11172	2vbXNdrz2jLZB2tTKtacskY81k1CsAqC2TUCy9yyFbC9F8GaeaLq	127
11176	2vbqDe1qPXSJVsmPUB2LDnmKcVRDSdEHbx6rz8fwv1fg7XcYJEKR	127
11177	2vbMANNauNsF9JtepNdWqvrPyrT86wCRP4drnGxZPSpvL2jQS5h1	127
11180	2vbJe1NbWijPGH9SNRZ6RiR5HesdBfj39UFTRQMv1udck3wsCcto	127
11181	2vaiXSkSrZuwoAnkHpTSZj3GazA1b23w7Qe7YT8D54pJYWJRksNS	127
11185	2vbq2xjgYgipZBDSWahrCf7k3WazDoixbFcv7oBgSGBShrPaZBuV	127
11188	2vaixjmhRqaHTcwFMevUbdZ22xv6jAaUXg5uMRYsbt4NTe7coBTp	127
11191	2vay9CNxQQSBHyzGscAFTtUMQPm5y1s9VcE5RQZFCsas597uCPWV	127
11198	2vajViiMTRQxfKfYh74tWWWHtp1ZQWkZkVrarQZe9mdQqopfQPdf	127
11200	2vbgqJKz9dhwz6tTE5BLpDKmG4QrpUCXTZtM1S9H1eMXGnuLPeGX	127
11201	2vaGb6UacpnkqZGysQ6jnycYHXaVSbCYyVZ5nGusde112XNUFJc5	127
11209	2vaLJ8aEywunfcyTsKyzTCfwAeiZyLTUu5QCDwE1XcqtHSYAM2BL	127
11218	2vbpRjZB2zJw6xLMYNd6yZ3ezKxk2CXUx8rV86N2qDkySXx26puc	127
11229	2vaXC5aBwHSGfezAWt5HtfS2KHNgpH1pwNuWpAEj2bBUo8MVwYTa	127
11231	2vaUDn6qWKKpeXYi1N7kvhxQDB68nNPSTjH2kVGCNK6dWH1GHxeA	127
11234	2vai3D3uwMSnVaRnUg5bNE1F8FpAZVf7pKnVtaDNciB8DZJX6boN	127
11236	2vb5hCPFeSsbBQpKPq1Tzgfsx2yJrdCbnYnyNRC38MyDL3H8Fk4C	127
11244	2vbaA1sHEMhxXvc99MVQnHfNu7TYcbCcMTRkydcvTMtMLH76QSG8	127
11246	2vbBDsu6EP6dZAXpbyPbfbJ3sQXuCw74cHbZucPmV9eFW4QkNfRf	127
11251	2vaj7pp78RjAxzCmc2hyXbQvp2s6PesqVZ7yapA3ZQCsTjomBssx	127
11253	2vbcSpDU3S7vhegGEbCDzWAopHT8UcXY5DDqxnoFNmKPr1sDNcVG	127
11256	2vatsaokmydDMekPEfMRTYSyAJPWwqPNvV1QrQZ1VuLuqJWohGVv	127
11259	2vaYPkxsGaNZrNfee1dWoi2dpTRtpYb36aCMftxBDSQjeggWvrcg	127
11261	2vaK9rsszeiDntoGE8iLUm9GnxQpXf3am1r17B5GfgEJdFdQ92QE	127
11266	2vbLxqRs77S9Y4oKQA9pRyH3KaxKxHHYLUGErThKETtZh9Df9VUh	127
11269	2varrNvToc5JysybkoCQNxacemZGhXti8sMDrcZrLMfA35X62uW8	127
11271	2vaYSDSXYobiWJcDsRWM4vxrhPj1PC8F4b7Cuaib7Dn4GrvGZ62J	127
11273	2vbpZMDihAEvsfSq5vgtnAsYeqKwWc9MVbr4zJk6FWftX68qhu8j	127
11280	2va9E9YyaX5ED1G4Eg3ty6uEdomyK6qP8zm7CshXYgdnrxwxSsif	127
11282	2vbRhpsYnyEAXDz2SuP7bBFYFqKJt8DeFPbgPTTcT6pgBSTiLNZD	127
11289	2vbjrU3ZD71ikTxTaEZmB3exdDVqJkp9Jt4jEM9QguXmQ7GqXtYf	127
11292	2vbfDMm4rvHL5Bdh4Lqz86HtY4vzX1KgAWAza8wBwFxFtdLk3wYi	127
11295	2vboE6b1K6d4ubhDtW33d18CCjCLJMfLGUS18cn5SJdRhL6HTAb6	127
11298	2vbYVkF3nuAH3M9LaFEKwMVACTqE2zirDVaJ8duxaA8oRLSUP1WE	127
11299	2vbMAHC5TgjHPnbab4cEGTQtKiUYot1GeioVh5hM9nCmTgmYoXsf	127
11305	2vaWsEehJq8PZqyZ4P4q2kRzd6NiJ39GyDayiFe6v4oX2nB6QaPN	127
11307	2vbuYtHDK5diAqCzmFB4EmBtyf6NLRomnnoWk3WcHopWcPHwVVzf	127
11312	2vb2dgPciYMME3X5zXLMENKahqHE53tXKcP7r9jyZbQjQjQqtsBx	127
11322	2vc2MQi2icB2R8rcLJZMSZVSX8EJmjPMAejaMCZRKuxn8FJuqLYT	127
11324	2vaB5fd91GPrA5tXPSSJtwKAtJ8J7HNMi1oVQk1L51cipBEmzkK8	127
11329	2vb4RS1CZ65yc42gE58SPxajmchDGB2RvPYydDDFGvy7VsHxzJRh	127
11332	2vbQthdivcMhTLSwWVjeZmJjeqVjTohp4qAHm7pQXCcmzBFe3FfB	127
11335	2vaM8691toDetS6nFcfBADmw7PjWnaD6LE9iwmSRPr8o3tbzTZKU	127
11338	2vbeV1hkk8h3djBtqyCJgVWaFe5erDxnh5Y7rWj7raJdKycGXEXG	127
11340	2vavUCatK2W6t5mxZgCuXskN7uXGY3niqdVBuEV4FRpbq7P9Lfk4	127
11343	2vc2jfsGT4xyzdSpjoLJh4DXTy7FhCnM98gsuk4Naj2QER7TukCj	127
11341	2vbT4yRaYdjtXYmpPNSHEshUYJ4LMvL5WyQx7FGkhrzxdkmLRSRG	127
11344	2vbn4nksdend7t9f86ts9bB22z1fbXLFSSMRmJqrrV4pNnRmVfDo	127
11345	2vb443dQK6k1Sy1h1HoVD6NMKDxkvhd37NsVsP6AAbi2yMtbqVmp	127
11346	2vc3XZv7WyQgLAH2ZNP3FJgRX1jZVPDTQtrdzrhwFHG7GDUF5txb	127
11347	2vaU9dz6Z1WodGWxocG2oVm6VH2uBuQtGytQRTsUJZwCehiJzLBy	127
11348	2vbbL8hSs4KNCg7rKzZt34zfbZbMrjogK5QSZiBAcL1UaoXJ6naq	127
11349	2vbbyenY7f16o54KhuCvWtb51AoUhEeE7iar8rs9xE4PVN8LE6UV	127
11350	2vbu3NRMojiwTTzf4X7uRic2oF2gkkrwVcfxp7srZ3U61b8i57VP	127
11351	2vavnjHTc7HNDtzsrFhw7riAMnNQ7b2UdH5ZF6ya6gqBhpGZL4V8	127
11352	2vb5xUNkHrpKyBvyw4kZ8LWQ3HEF5sTXd2t2yGHdoPYf86A4GH4q	127
11353	2vbnP3WNviPKfdnuW9xJ7go6EVWSBhNFo2qhGUvPffxyVFzY4r9u	127
11354	2vbvdjcshHMWpBXWEAH6MDG2DEknakwyaXgN2TRhBcGMa7em8FpW	127
11355	2vaqza2JPAqBuC2Uz7Xvb7zY8ap5CUHkkRGeS495SMNaSqwRW2A9	127
11356	2vbgvRYNJoGBrLWXUVuEvqV4xBEXbSA8YDeTiuGeBeHsdSrXboDh	127
11357	2vawiuBXiSpCggraBmpCjADD4fXu3MrM9e1nQt5R7nggRMmxKV6p	127
11358	2vbAsPuCn28iP7t4exMUMjzgPkZqxgjkz6o4JZLN2wHvJZPBzWXY	127
11359	2vaydStJdtTDDxYcHoDeUp98qwoeLmTuTx6Xqrn1FCjQyKrDR41v	127
11360	2vbaKNzhZa67AtHWq36QriHy9qryh5o6jkZpPBpEayWTjfSb7snX	127
11361	2vbTA7R57kynmXJrYHQD9MbA9yEsKRropzwuiDa8XhBW1N4TRE2n	127
11362	2vbi7K839jg6HE4wQxrGPY1jw9BFhvr4fSQWZnuZNTAG2aBEx1j6	127
11363	2vbTe6tDMkQnnFrgVSrthghYEbrEFSQDSEiiu485qGSfhp22E3VF	127
11364	2vbwMH6Kt16vUea2rUs1wUGAV3bZw8tBKAJvU9Dqw31eiRiv6N76	127
11365	2vaXd7bxZ2jhtijDaDGWxWwBm9dMyGYuQWG9jvQtBsNJKxwk7xLV	127
11366	2vbvvvHMy1mStxiTexmAohkFbyAE1tkZdvzAyA6VCJVMTFjRgWEL	127
11367	2vbmAfiQ2AKQDH5XJJ9sMY2sMEVv4ADBPZiAJbBndJhNJqnJYQKw	127
11368	2vaUFgNazRdqTKjkH3WdN9k536yLMyuSWAcMu9UdNmS9o8LfRvyt	127
11369	2vbPFUoHjNYb3ckB36LjfAPiKFA4CtxRUubKW8iQFBV2Cybk35wn	127
11370	2vboRE2mXAw8ccUYuVxSswBDr38mCL7A6GmvgYLaijRgq2xsqz1y	127
11371	2vaFxKdeAQzJa3StMN7Ljjfnk63DFdZWfjXWQUW7AwrFhbkMFPji	127
11372	2vbM2wCZswMiLXZr6mf3run1fyCKijWJmnzBypMqeEDWHjxMaz99	127
11373	2vbT2i1Uuw4jC59DgQ8Yhn7y8Vi1wT9qtrV8GvM2dhiB8FftQn2D	127
11374	2vbDVXScofqWayXCus8YWaxAf8pF1Db4yGS6eMLGb17f8u2eZ5VT	127
11375	2vabTrKSrmCcXJY5enDXbQTo1fWQ36pCnJJa9jPzoCQWJajf1SQy	127
11376	2vam6jg9kkdAJhfAsArWHvpahzxPNZ3aBQKjv6WvfLVysBctYXSQ	127
11377	2vaZ6PFTGurG9jx5fZqaNR5kqAyA9sjfKZQyhBjHLESeNNmgj4gH	127
11378	2vb1AJvDnYAXSRMRkkfVGeYdNuWT2WYzenHTDe1vprvibUsA6zNn	127
11379	2vb66m9QNLbdLYRwhfPatquWWBXhwU7nk11hQ7B653ESZn4LrL3p	127
11380	2vbtbAc7DCw9AUmspBENJ5kqMruNen4q4xbPSHQh8qTJFAsgk9io	127
11381	2vaUgysjhikrzCHLQRXpNouvVy255H9Y5toLLi4JTfbNzuQ9Wt4i	127
11382	2vbhfx3w2RUXatpahmqbwDDCk5jzkcf12bmmNJQ3GX1R7Peqdg3k	127
11383	2vbVXhdc6RbQBVXQepAxCVLrAcsTPa1QXBXSu2LrtXXuRYnyjkdf	127
11384	2vaD6ghTZJdV8MeSnrnWSodgmXCypayi3zxxBnDmkqyUHwjTvXVc	127
11385	2vbiejfbm4s7jNFtp5oA3seXjA3pENJGxenpTjTuKdKDhMkw7EG8	127
11386	2vbbLFNKKy5Bh9KhKA6ZrDneLywq9o5Y4ZG3htQdwRH1oCobf5TC	127
11387	2vbrAM3MGwfcj5BZj23wgYv5UcfKzFLPkkBRQrXFMrq57bngYkxZ	127
11388	2vaUB61C3rde7EyZBw6FLEps2LRtY6HQEVuRAieFaZLi78bDq7Vp	127
11389	2vbWXR6hnnCkvEZB33v7MpFpLM1Pp1JKNvE8FvnnMdegDtTzPsJp	127
11390	2vaGYh7k5DX6QkSHtVAGBC6wkXBchyS7aCFtxm3MAcCGTrNzJ1fv	127
11391	2vbyUyTaSm5aUactLnUhJT6Rwqm2qAUpmy2vvGZJchatrV72YJ5D	127
11392	2vantpuN4cvahUrpALLFi1Jj7E5FdK4vomHUrzzHeGNmtwL2QeN8	127
11393	2vbZAW6sbfuEt1bCE6gmuBcHeU1h9WiTm7hogfdbtpsQ2GmGP1vJ	127
11394	2vbH2tsNN8UvVTxCr6ZEU7oHEAaac7UPmDai9ad7JNGwX5rB4vAA	127
11395	2vbxpBWu6ppqXxNwqJaaEX5XeeBDH8PJuZsJyajYsrMtD9GSELNU	127
11396	2vave4Fzg5jVViCoHDawquUXcM16ZrA6qokYsscEzKWEQD1rZ5rh	127
11397	2vc2kDmeBCtVEK5DsRuqKxrzmh9dGR2nUhAPZt7rMXzvA2NjSei6	127
11398	2vc1R3gAE1x9yGpRGvH5zgMvyDPpo5p13W1B6n9b4SnBHFj4EkGH	127
11399	2vahN13aanLU7r4uYTQSEDcDUU6nSmDBJVFGNxJeAtUNNYreEq9R	127
11400	2vbG1Q7z6JQtkycdQd9DhArvHw5SRL7HB5yqr4osrpxq3TnXjXmU	127
11401	2vaZNV1G2VuzMKvsfGYdYdYufJmJ7RgzfLiWMEGek56AJX8roU55	127
11402	2vbuAaef85yLG5zCdtFyYQVSHLJZ4ZhCZ8D5izNvsxYJxvk1LnE6	127
11403	2vbzLtpBPKaoiZdmG9asKCb9dgrDxzm8FeLNFb5J6BcEYjUSh8v3	127
11404	2vaho6jd8pwKD9oaJqkv1SWy2FeUpyLVgtTAMBbhVaXcAetTpfYr	127
11405	2vaBRaVMCVHpjFeNrBH6koH1e3Mm6GbBdaRX1jr3zVDy3dWGGkXj	127
11406	2vb1v5BkDEo675dSYWpbN7tJZTmrnfwW5rnY46Z9iDSM6Rpvanfn	127
11407	2vbr29YeFe2LBF1Vya3HZ59Fnku9pHFKAQSVxD3xa3x4aWQZVDb8	127
11408	2vbdS4632rNsT1MGxiczMneL4HoeKiUNkvHmtWyQhsR5BHmvEE5E	127
11409	2vaQqn1Epqrr5qZKJxSwJr8uYcRoBh67goY4sbcQAaqkiqo5rzcB	127
11410	2vacoK18uEPpY5ZQEJoSER2z25egfJGwGK6JRTPCsGBmGcKQGSt3	127
11411	2vaw9Jg9VK8SBivaJQtH5k6PnCLDiHeHGAYVYi9SaHvr3jXAUpmu	127
11412	2vbHds65EXcteQLgiPJqMaDvod1PpKcknzTmsypVWFqZFNaghpED	127
11413	2vc4gNY8NX8e3Ziq7jRjVW1bSHm4S9ZW2n2esh4RftAVpRmG4FsA	127
11414	2vbSUAbL81R9mirfXT2wa4Np1yBZC7VyZP9KyNueZKCdkF9cZj2c	127
11415	2vbPCEVBd8zaiRAywuY7XitUcDBbcxeRh2JBqz3LN1CYepNSH2ar	127
11416	2vaUvhMJEaCVgFgvAzhq6sRdCrCuX12UH5S7PGTkXeERMbbZ682x	127
11417	2vbeu1FmnTye8oYy7WQnUynkdohxQ2oT4fJPSQutFP75w8aqUxrB	127
11418	2vap4ejSKnWWxo75dPY6efBp9qNfhkiuT9iVVWqA5wZXL1XodBZf	127
11419	2vaWk5ysTVQaigs1aUfaegj67gbgYgayPZQKNBMaGNbDMncA7rcV	127
11420	2vaGv9zPcnrESUqcgyCZH5ygRnyMjJmNcmCJLjPouteBAShGXygE	127
11421	2vbvg3hZvqBsDi99QBz1MvqQWjaKj3pn5rs7gaYmG43JkachZcVu	127
11422	2vbaeE6ap2gpmgja2AJEKwDyTGvFo8zajUPhsnZ7765X94D142xo	127
11423	2vbLp7RAKtrkCVDLh48j9maF3R1U9KEx8zFjj8qNknVX5RxRLaoQ	127
11424	2vaMKgsFGF97LLWxoYcvDf5Bw4mcvRMJyn6e6x13tA2cePRzHhAh	127
11425	2vbTRiHm7MZAp3x9VgV8soAtwe6KK4EQQKtBj1fF5q181aDAHatc	127
11426	2vaMeSV6qZwg7kccN2xGB32bvCm7pPSVDYrm1bCg9u2SJm2s7cuc	127
11427	2vbrkii7ofms4ArsemuDrGw5kdD2u6HvGyeQiGySxND4JQqqNoXe	127
11428	2vaa6WqHKzusRbeZCd29LcML2qzR6PwSjeAD7jdx66QX5op2yBZz	127
11429	2vbFB1AVa38ieJ2SEnPviY8L4azJei2a39XLSixt3mUEq9jxrECR	127
11430	2vbDac4vLcH6HAQuKA8F4BjNVWydQwU7wsSgJijJZZKizefQmy1k	127
11431	2vb8wzCykmCE8a4nzbz3QvrkjWkuu4XSQ3q4NG11V9wa4ccd4WiT	127
11432	2vaZakS3dJ31j39Bea4Ts7bkALWwiVcwU5ZEHUrMgjNQGEeYviV2	127
11436	2va9M5siD12aN7ZCad48oJSRRjVAjXtwQYVHdj6CVFKzwndVFPAv	127
11439	2vb4EDTTH4rVGModdC1rtKBhcswZ5nxJVyujmuP4EsUfi8C1tDeo	127
11441	2vbp84fwUGzUfZ4PM1w1MmRAaZ9x1Bbz7MmNCGxDH9JWcMBBXvrS	127
11444	2vaJsS4GrPh8nChP7KxDqQiHTodiidPcZ7r9FwqkMCSTUUKn9GeY	127
11448	2vbZ66oVfm9fqMtVxQwKYuye7cR99d8BLvyUFimJDy2TEy2ch4rN	127
11453	2vb4EtK7SkhTuRweHzW6PJfi1PXVKFwS53Q38hNWr45xvn12yUCT	127
11455	2vaWzdz9tXCFeYymczkWqrZfEDVKdKzV4BBnrY1eDQi4WHyMHPEx	127
11460	2vaFXo3DBkb9GQuzbF3LdkRJxByQcUFA4jF5TknwxYwNantXf5ad	127
11462	2vaXSRv4KTs8DPcFoo93dS17RBN78h6DBPMU9495rJYeCppieQXg	127
11469	2vbAXNisFDW2FQ8CFALh4wjR7HBRRpbkrTh2FsD996svvLBZKFqe	127
11476	2vamo5GJSxWtUsXr29W8YxGSNWAxou8frUCWP33YbvR7bAezgAYU	127
11478	2vbQ2Pk61eSbYWjBLUxg6B3r7pwLFDPkq9KEGLys1pSeurnsHGKd	127
11480	2vbAePtz6PKugXMtB13JfUXvDU6x7Aw3X659JT4kWVexq9ZiBa59	127
11484	2vb7QXc1tVhJCJj7i2dEd4b96UU23NPF6ZkwPY35LJPBVH2w9adX	127
11486	2vb3Fd6rKSUntzE6arNvcoJzBHFiEDypmmyEa8WyX9TQFHS39Mm5	127
11491	2vbMecAjZWQ2xe2YNrnYb9EieMTirLD7KcrcAs9E8q9UbaC2b89t	127
11494	2vbQSs3114PfeTXQk63hYYSnv4Xm9hnASo9wvS6gnAAiWTqPj9i9	127
11500	2vap1biiS4Fq95aNDU9EUDgDtaVt221sY4DxHUqxGauvitqNJRyv	127
11505	2vbtqRJcY1FAHKmRo9rThCzQxGkQJMHPtXVYcjHgQx3wTqyntEDC	127
11510	2vagKFT46nriFtYior9RMEtA1W4u8nSxP26qUrkUksQErsGHRkYn	127
11512	2vaPP1YmeLaynwDJ1WijaZgoHVkoRqJfs18VNCT7rd9HDWEN2Sj7	127
11517	2vaDnN57xGxmkUtVDFwBPSa3ZPQ1W1wo9Qu7BjAYRWVbY9HkC16n	127
11519	2vb8PD9HGDgJQviHUhKVbGG8BhWKJMXeb9o2ukD9JZ3ABegGhasS	127
11521	2vbqe7B8Q31kzBUdPYxXWX6gQRSMvXx4DJkxGDD6HDNbhoM4J8eL	127
11523	2vbTydDKjepHojgt1oEsPUFhajXFdxYotrHxKQP4PYEdJDJ12D5J	127
11531	2vamcnjhJq8YXdAYFacn2482vq7aVpwXE1eA61bDssF9TKKYo3Ew	127
11533	2vb1AqvNy7qvnHyx2CNV82kqLTVvEtJbk94zVTqXjprYtLqTPebt	127
11535	2vaGdhTH6nbTUhAjFZCMSHZdrfjB86sRbsjPiSwQGzrFJ86eYwhS	127
11536	2vbUWYVyDNkw7Y7oYQ58DaJgeWdATyMZuWbcv1W8K4r254dGDoo9	127
11538	2vbmcoc2hNzK5g19YzUXMi3KM3eTKzavEve5cr3eUNk7jR44duYB	127
11549	2vax8XpUhp1z4w4mLykm2orLQc7ac4XE5vtqzMs9BqvNU5rQLZFN	127
11551	2vbuQw55kQZfLnbUpb1MZMopyMTbegebUKNuCHm3xwcp6jhTkqLb	127
11553	2vahLz4QDPakwAj3EFUapz4UEA3sKxgW44wvhQJinGPL3mA9kqDE	127
11555	2vbXxJnvLQQqBYJAL4eSwFqoDtbJnpwYZhhHPju6RSnugMy3MsxP	127
11558	2vbKvZABnRbVdWCDmtv3V85injTZfKJSqQ2vWN4fJvnsZumy1V8W	127
11561	2vauTCkqLBe59MFWnnb7gTCfqgj17qJgFoUvJPDfz41gQG5Tvg18	127
11562	2vc1CJZG4NYstRNjpCgHm6rkfgAfwebCRyZnR2kNGF1U7yZGXmxb	127
11565	2vbFtfpAyAYeAhGTZtGSPWbyvNpZpu93DnwX2BuwiLonecSPvmmq	127
11568	2vaD3Behg1jmQB2U5a1TCQxBy9XW9vHoE6TVPcyVQvxkr3Pq8yq8	127
11570	2vb1NyC5jdxNrrpTbhS6hEMesNpLBQ1u1sJFtUebhxMnMN6s7MHV	127
11574	2vbN18WcurBRZ7sEVwaXA7hi8U2655mXt22UZEfGziQHK48VTCYT	127
11576	2vbgkjoWuMHd6RxLLcuPBc8YCK4441fvjawtBUmhomqZAnPGnmby	127
11579	2vbuULW1uCvLaB8FJ8kwxmu6HeJWMiYiBLeRNFNzHdbhxi6zQFBZ	127
11582	2vbQfhnowbgcqcUcfMvAWsBaZEdUixbHz75UKSoqr4FU4ZCFRoz2	127
11584	2vbc6U4nsZwEyeudNAA3g7T2agvWgttrNSP8gMaAXTM6XjDNmNMF	127
11587	2vb8muj9kt6AdvJp6cQQfDDroRRwoyfbD2AXw1JKxJWT3dPRQTEV	127
11595	2vc3HtcxgUiDmjkxzmcT5tLGFJWjSwCwnsQKPmHRPifSepQYKx3f	127
11602	2vbwHEXAMQo9gqP4kbJpiKNBPrzvW6TckMqy48DStV65N9pFP5dg	127
11606	2vbjbsgnn1Ff8h5uqNEMJXJyjwb7x5UsbtDR2h8j19pmwdMNgY9V	127
11613	2vaaEyVmkSawwvENhfvRDEXAPse2LdPEkEZQDYwAYXMiewrxWuQs	127
11619	2vacivQ3RaCsHoeUwjCDPpQiXqD1exBp48r54GAmNgGbntJdmrTY	127
11623	2vc16LxuyoRUthKyANebA6K1y8EBTJhppCcstVMQmDweUSCH2etM	127
11624	2vaQHq47CgeEq9MhRAhGmHUpZKW6928WEhLBDf7MkcuyrVVfPMWD	127
11636	2vb1nVsHYG9siY2BVokExNse62DowFZYMkiysPjWHNkYdNpfid5h	127
11638	2vb7x8hkfm8H2zLYzCoSE1aqjZnLSc2ML14EBdUnwNhF7UgUNpgU	127
11641	2vbokiKuKsHjAWFa9Pw7eoSLZY16nkb1Yhi1Jp29LJwzMYnoJ746	127
11645	2vaDJbHAkjSKQNfEJSFwxVqD17RgzjEcqPzL8JrTp4LW18Sprrtn	127
11647	2vbGFXKZDXYz378ak3CegnYmxywZzxmQyq3Fh6dZg6chzTHvPEjg	127
11652	2vambPH5YCgwMZyBqMFVcvkEt6FtKVGsaGJBom2SwaMiWHzdZWuK	127
11654	2vc2pLEsCSDc5LhqHgNoVPu1GGV5ZTLr74SpHZ8oDyiK7ZQzZ3Cg	127
11656	2vbnCREAbKaF667jrtvN4fNZYuy6XYtV666qkqh7ivXZqLTQp2Z3	127
11657	2vboqJvPzehq1hvGDrucDdBJXCFXpLENYebvkbkYR7Ck3uB81KYc	127
11659	2vag7PFtBgyEYJ1zrNnhkspiCGMPs8dNtA6hCXJNHc41b6sbPCwx	127
11664	2vac9du4QS2neS5webykWvuvBhx75XM5rq7uQNq8GEz3Lz1w6nzy	127
11666	2vb671CUyRHAzZfMam3X8rzfYjHE2X7ygmyfYmB75Yxun7A7qqF3	127
11671	2vatRT5bjkc58G1bmjRHsKoxmQyknhSZCxaJSqjeBrvtN4MRkcrk	127
11675	2vbiQKUQFKB4w1wCRZnaAswmBE7Z3NAaeMtExXxUpJijyfguii95	127
11678	2vb7FDCf4JMT1ZhRbWWVEueLZF4q7muC2bBbQ61UZfzJADNxTQUv	127
11680	2vbKR3o822xeWkBt272UtyQoP5Vvi2v1oWymw7mTMwPXXwWrU8WJ	127
11683	2vaHXPnNvkKHcYh7fdMkiUovJMnHfs6pbHMEpgSHNGyo6xCMBsrK	127
11686	2vaAk6SgHFjbrP7qLZgAuwpMuUHkE9wTHCWymg3Bbdkbg9Dev19F	127
11688	2vahdUGhxDF71wxsNE1BBPqn9A7g8vCH5dHULuqJNVSZPUkCkuRp	127
11690	2vaXeS8BmqLZWqQQ88ShbKaR6twJC2rKy1LpQfZF46pwFXFNtNH4	127
11697	2vayyVbcHbzEwe1pz8qC2CyMsSMxapQxbqXeJn76FvKr66941xkA	127
11698	2vbCT92t61Z5r3wb7CQmU7F4xu4Lr5NifKniXyh251cdzu94eN7e	127
11700	2vaJA4yhCFfZANiHgZw7zV6S72oTqtDsqvGD1waEo8qWRBjDeyB1	127
11702	2vbVh2V7GBZZeLbNjnZjmqhVLkari5geTCET7oFz28HQF78ohaYj	127
11707	2vabnY3JUmM7jYDa8uWuinLyQhXKShRzd39cLwuvoGpJcCjDpkrW	127
11709	2vap1kRTYYyHk3Ji6CRfFqfs5VNtTpCeVM5s5v2m92f8qnZAeP7y	127
11716	2vaW827bP3oWUCDuR7tKY87JWRawkgDaYRL71dzAWR2DtsgWgWpx	127
11722	2vagds212EBHcpkpVnEe38qj1gPC5pneNDXuymHQku6FPVjaR7Fb	127
11724	2vbDPn34pJva5sz2McsgkpEG6BfvJTzCHNVFLnMWdCKfAa9BQDyk	127
11726	2vbLsENovt8EfPWAe9zs91d5YZdnzEajTVUa3r8hFrZgZC5a2ie8	127
11729	2vaMkqoUSasAo8rQc2g7JkLzcm1GUo6T11MWzHXpLesgq654skpc	127
11731	2vbRSHKgz1a9DqWgssMK9NHdzPxFn1K5ShPHN8oGUrVQMzRf3CX1	127
11734	2vb9yPXxWQCXeJ5VuAhANpZfNNN5k6yD3dU1VkQSS2Wr3D8TY4jA	127
11433	2vbh5Qk3x9PtJ2HmF3MGw54CjGMy6rncV38kfocyguYgStroHxo4	127
11435	2vaVFMW5dtegbQcUrEMEfkbqb4vBWERMjunD5XQ9Cy899s3orL2D	127
11438	2vard2pQdh4XCsDV3FH3HS8BiJn9jVpmw1Es88HSgKQ797qwYhHQ	127
11443	2vbp8tBL74kycv4vs1Ph7PqQXB642YQyMXrga5pj9wuVB5BnFieR	127
11446	2vaGr9bg4NdFFNosaMaPpFRF36Mf358jvxvgJXcFQFsEtw1CYiNN	127
11450	2vae8CagSUd7UKth973497VbQzD2M1sAV68B9asits74muZgM3vK	127
11452	2vaVaBPkqXXr6bBUWqz6DCzm6wXu3mPkr8GmV8euHytEbJvQtpNo	127
11457	2vbCzCBUwfbsAbPGL8X7Sipg8Ay61gVnoZpVYfFL4zaoR1sy2g7v	127
11464	2vbZrXQUXAdDvuRAbgsajDmoNEZx3t95FrMmrvzUyx1y7s7bSL1R	127
11467	2vbJK7DiJu9Mfi5rV2f2PRGzNxWBqoAt4SjYurKPxkBmpTdhz9qF	127
11468	2vaXTySMBsE3EhKFbP5DbrXpmKQ1GrSEpRVdtmbXFd6YXZ6x55aJ	127
11471	2vbyGziVc7X6DgWDU1hawzaoey9iAdB5JVofv81HcpCaGB8fgQTX	127
11474	2vaD3Dw7JUKHWUMCoMKffF8kpy6KhvQkmJ6W8GQvFTiHeQ3k6bfo	127
11483	2vbp8VmCs1Ri2aJjjoWSwcRur7ec4YJ4Q2rHm7z7Yjed43LUBVt7	127
11488	2vc13GZ6dRCJgjhqD6uQE4a4PBeYKKAW488kUGSCnEpnQGdr4gj8	127
11493	2vbQNcJEEneEg4cgCLaupygKHAtX3ap9SZ9ApUZwkQsZPtzMdBXN	127
11495	2vbUn53qgKRyctFk9uAFhX15hguyLNjmeyqZqDY542b6TzKHnrsP	127
11497	2vbprpYFwQDxC5rf1xU6M1tNT4dBRAwGNdRGYmKqepH11GUxZYTb	127
11499	2vaV34oxyexLetSRfaGiErstkLPVtzPYvKQk9bHveUDxGD66ynag	127
11502	2vaaZdQJgQR21BmxLQZFKa1jwc9aPZJbrKyUaZnaHJ3zVMCop9Jw	127
11504	2vbNoefBHpaVti94AxCjEGatZtskJESzWLU2cpAkykJ6kfAWn5nN	127
11509	2vb3CP9Sio34537SpYTn8UMuwegmsQJ6KcBLWtCDV2Y9ZhTFDgXy	127
11514	2vbWUhncKWBXB9deTxjHr7rSfHtoaMB1SaX3dt2FoJRK686WyPEp	127
11525	2vc2qjCLXiYtFHCRPWVaFrvzyEtdpM413vGs6pHxaq6ZozpZP6rB	127
11529	2vbAeYKHRnpV2MqfJNjKM9fhYJgtNeRPoYc4svApJyH4JECFR8yA	127
11530	2vb3BiJ1RWYwj2m9RLe7jqquQzCN672nSppGXXTUUrd8W2LFFgdi	127
11532	2vaspoVwKUwQtQp1mxvS1FDbZXFo3WvgiypcqSmdWXSgcxpwYzv2	127
11540	2vbHishLFuegdmWxTUr7Rt6h7r5r3H2QPwCxqHXbgAx4LrqRTMwK	127
11542	2vbfpjoUKxEpo9Set6mK1KvKjxHhVaYrhfcMpewebeuUfvuCQixX	127
11545	2vaBjvPdwtppP1gqxiVrC5u3WrSZzLhpgG6NCtpYdHsquoZjCtmr	127
11548	2vbAqiTLviU3iauT6xLCThKPfXwmTAvKR7JPN38oHvuJrCM11X7o	127
11560	2vaWwft56DXJDPWopRFV7tVj7vd4KFubTeg2F4rViuUuikRdcup9	127
11564	2vbwnUMVvwLUw5XSSHFWMsoenAkoFeNabcNB5bBZVERk1fwTQQTv	127
11567	2vbyZPBGPsYPNyooemNcQr5cpUXiX9AcTJct1VW2bDtCFHWDqHSK	127
11572	2vaFH9aWbPMRXDaGP3zh6GsWUCTuUd3pjnYExpi2wehjhRb1sTBF	127
11573	2vaarjgpRxY52NKK62xxaCxfmWHBccpaH6xh865pgxAQ3hftEJbC	127
11581	2vbRxuTtVyhphR3jQtgxHhxde42fCVvkSm1wRLNz2Rx11phe6Gat	127
11589	2vbfSqDjgDWWFZsif1hvhPbWewKPNzBKbr5WqVdb6RGbCTETZeeL	127
11594	2vb21s8dSQreCbub2b5ZG3qWqsXEz4JkDrZjPTBtywbChKqvey5C	127
11597	2vbEgyxVPea584M6dZQAZ5aBVUPG3qya7qF2mqE3BC6AyYuthLXt	127
11604	2vb67cSa14thRjUMj2zxpxYwKPFmdPcBdCx4925Gwr6dmUkVyyPF	127
11609	2var7Y5qCRQDHwy4SarEfSTtE3kZ94PnQVSntB2xp5BEpqTsuTW5	127
11612	2vbVFcSJGn2zV6948JjSZVKS6H2eP7xBB7DTwPDiitNSBCTb3PBh	127
11617	2vahUdcj14joDgV8vCu9FHKmD2rzraoYP4UgjBRUZkBhBcYWveDD	127
11618	2vbWJyimJK1mQWQxV7P8x7NxFwLn25ViQMZsjNDteii89ZXdkn8s	127
11620	2vbb8waJ6tjnYsUeB5msHELqcBmhJydnAL1uhTr7JbMnvReEE9bd	127
11625	2vbddJwjyt15tq8UXowTKhJNQh6iw5mrvzviK9Rwfbg94wk384nn	127
11633	2vc1vdUBZhfmqr9gLSmG6nbpLC7WdhqyPZivjmtyo9j57JCWiQXn	127
11635	2vbm1jDy4ERKyGfGKhcqFhyzzeEC2EnVEecLBwSB7xcArQ6tuWML	127
11637	2vbysPpUyNvBqCDz1mfpaH14yysFRTn9goNfUF4KFP7rYjtH6v3j	127
11640	2vaUuyVKnEHG83y9ZTWgkLGTvTLELnp48yfox9aimEbbf25AarsL	127
11642	2vaLLPqRY9gE9oMzHGHEgVaE1hniAAHCRuUWGubWiarzPWpSewG7	127
11646	2vabhtXFrdb3p9xAMdpdXU4eibEN1wPbp1sDWcx8fsNuGQYBwt8M	127
11655	2vazpaSJ3bvq1rGqGk1JSG1Ppcnj96ixt581jsPwKmN96EsXPdb5	127
11658	2vajJgdN4QiTKf9Vms1Tm8MgZA2dfWALvT62JhEJgiYDvBtn5AWo	127
11660	2vc2etb4gQ76EQjxyXBmViBaFYiQHm3ksC2XZH5becLuaE7ckWsY	127
11665	2vbJGF7JzX4gvBqdtGTiZZue22iMR1aS8uee2k2M1rzNJjyxjyjD	127
11667	2vbwGPbgNLxZuymuFLWXkLfqKL87mP4jYdBWbTwUXmtzjpQbVJr2	127
11681	2vbV8PF1GF4QfPs2RfG2xW84HG22pej2pC39TL2JdfPMwiuQLzWC	127
11684	2vaFUzKir96Qdy8ce5Vb7qvrUu2ugeuDuW1tBFpAJS5gXeBL7nMS	127
11691	2vaNdFdAtXciLF77yD91SxwDnrdvSCEue4UfR8MYEt8DfqwZpwdV	127
11699	2vafqe54gmtJt3BAX2sasDRuMVAEF8WYA2GdJgm6QXsee8E6M4wa	127
11701	2vb3uwUqVzcaRvoEBfnRvy6kiHEUei4oqfDpAPqZVcANJTyL2EaQ	127
11704	2var9pRqj72KEUk6HucMmvsFdJGPZv4Bw2QSS9Wn4DqtXt22mXhM	127
11708	2vbwMoK6Y5N9z2ceYfYVwyGjGFZtXLbVLESpwd7MRQtPpdpJg14Z	127
11712	2vaVQDT6v4Q6Whip6ghS1TLxVo8DnQewNM4a6Qk8n9PEVuH3EPu5	127
11714	2vbYh56LnxoLFWTDzPh85WULa8C97Joez6bMEp7vw6ShfpMKSe7Z	127
11715	2vbTweVkSiKjSfaQ67nUnj2EckT2DsAGb6vw4uYDJvZcdMyxxNFZ	127
11725	2vbgwfwov8P6Am4yszDmEDCHEDsPgyX4JYcsW1Dm28kksNo3tfEJ	127
11730	2vbEp8SPWWmHmEPfU8S4GAMxBMXivS9jigdHxoSmcLUKabhT7nUo	127
11733	2vbVj4RiZSk1FnjzZ7vxHpkHoVwE54PLPEMqXNiE9DrXq8t1rv1C	127
11737	2vbc6urjruFEdjYvUZ4QY9dkqFLr3YBuuYgEH6R3VNV1DvgzwZgz	127
11746	2vb6fkeRnxs7VRmN8kEpNgAr3aSCJtogrEoyKg2XxnfWgSh6CVuA	127
11749	2vaSyQvjwXAxcFwuggHwtrYV75ZCriDSDtouzzY8TrNVy7ucPvNV	127
11754	2vbEnpS6biJ1hMfHX3oAnEJ2WnUE79SBuXE6nvknkHaycPTj1C4A	127
11760	2vbLxPoBxV4T2BBvFz4gY6wpVLq69oZb9ojD7Q6r8TxPXWsNL4rM	127
11762	2vc2P4jziJnmB7uQcfounbRJ9uptvBN2vkw2Sw3vEPYdkYcvXRgi	127
11764	2vb5BRNq5uqfGuor9WayUbNzRw2oKEZUPm5SV19EvVsB7ctrGvs6	127
11766	2vbkEFZZRDHYKtBaysPUoYnUDG7y8ypCNNCprMM2oWPBQUvhCvvD	127
11769	2vb738ddh45L2hTEFY3fyAYpZK92MsEYC2kNBagEKKdNUJfgJ15A	127
11774	2vbCo6FQaHjFzm3rk5ZAbfgV4gZw7s1s51MuuCZPFkV5Bbz2tEXP	127
11786	2vbNTgmRp3R1KGwGGLu3mwqgJYsJVhYUQxtkFXJ7k4xaV1an59Xe	127
11788	2vajch45Xn872Ztz9qMyEVkowUvUoqF1cNXmCau6pmeeECX5chrZ	127
11790	2vagupiatDLhHnxJUVTemdxH85oX197C7GJm78Zfw78V98bBozHu	127
11794	2vaBYVxQhgaJQvBsMAwbj4jYvamnchCCmGKywxyMULwDvJov32jS	127
11796	2vbDy15xyoSF5RJ68vo2R2nthAppkRVDc3cSNrt9FmAumppt8ybV	127
11801	2vbpFhzUVbPsjY26mjzRC3RDY9vqVYjUrHGkodKLmkUcfw9RX2fT	127
11809	2vbUM1wzXuU9Gq2X7qo3wR2TvWYmkA81XqcjL3LPJaSjvkQNUukN	127
11434	2vacDPAqV2BBKJ8HsmNS49BRXCbdZw1PRCMWeDwCF3Q2dKz8MC24	127
11440	2vaKczy9wwUSedt6Aa6vqLzai5oi71gZtxmfrtzkcTKpP3XANrKZ	127
11445	2vbAdvULy7QPAXZoLE9PtjNTGD4k9L88xovP5yE1RiEThN4zwSpQ	127
11447	2vbXCv1Q5CRpDFrJ2KezQS8LX1D5oyj6Ndau9aMGcdjUuJgs3Ajf	127
11449	2vag81748DKxv4DV8ijoPV6GZeFcw6NRDSkaybpnXwHPk78BK3d6	127
11451	2vbiweAJreu13NzqVZ61pTAAoeQG4TBpvjPKak7x6ic4uTMziaA8	127
11456	2vbW95FDngm7T2ou5LzkosfYxumEHDTaVvz2tyTvdU3Z3WaL7Rdu	127
11458	2vbRB2vRk7STRXRibFg7rVHofYjy3RjWrHoExp6QxPNKccxfQqrt	127
11463	2vbXDSK74vdqAuXXh2qo16si4Q52pYdHV2CjAfwMQfF7WNLT3sjj	127
11465	2vaNU1bjHYNa9BcrgFvXbp7te8QeYdk7x7WhF6U97PUt3EXWsKoj	127
11466	2vbVXi2d2cqL2JdRuTDoXmqLr9hQCmFYjuiPXcytKxW2khqqN1Jr	127
11472	2vc5DNNhWMXKHGMbSwQXBMiWfta6zr5ftMwb7aKrzAkYJs3ZeuYF	127
11481	2vaCfnaGgHcazjJWqAfSAhVADLps6QJ7G6QB12hrBLWxyMr1RMFa	127
11489	2vb3uDjqiNnzuQeLfo9i1TDwKBshQSe5FxnLJYwT2fMjdQPX91RU	127
11496	2vbw8DexvVnURBCKMZGS22a7AgH2KSTjZ6zvBc9G8mAz1ptco2kt	127
11498	2vadbWjmkynY3HJjSKZe8Tx7QtYYbb7gKtPMnWt9KAaeCQrM1Ar7	127
11503	2vawy2vAoP5dxNcW99fjrbP4XZ1AdZQYiTwA7mcR8ebdMAkzaRUd	127
11507	2vbuszaQdgPgw4wRAyy16ZnqxmmSK1DVWz51Ti5fKESo6uniY1Ap	127
11515	2vagLK81gsFuwvMPuX4avj29DsMPBzEwN3ZuBHfVevjkpkk3NoAs	127
11518	2vbmGCQTdBF928Hr9amMEw2UjVVkuD19Eq1YSfLq1Hn5Dnz9aTRP	127
11526	2vaik1xf66waSaSPHjmGbGg21a1XxGDyjNV7x9KbXcm9PEdk7Ywi	127
11527	2vbXsRFduTkVX3fYxuvXtZFLGAw2v2STT2uhoqXh1sSUdwabL6VF	127
11541	2vb99d6KWU8DXJsTyH4ZTTnvNAUS1dhrfHCaQZ7BYxYCXDVzD6Kb	127
11543	2vaCdqbb8sfLDeyT1D88evmstzEULM2pRQJSDjsuqyJLewm9ZJJL	127
11546	2vbkQyTqD7G1e4fb5pEJUV1bBTNGBf7eXYnTdrKgvuzvM5Gw3MHg	127
11556	2vaxzeisCQ1Eo8c5TUnbgPLxtVht1oRmf4Asr37fSP2h3CDBYR6b	127
11559	2vbC46X6w56uWSWJxdSaQNXytH2WrVrb9swTNFVo3zmHW7wPDpFu	127
11566	2vbbD4GoJfMUZsAYy8r8XoTADY6iyGU3rANVFTEmFpFCXnzfET48	127
11577	2vaPhKCtv44aKh7Nj4qzSfgJyuzv37DBkKtkzqr1Pjwpe4xAv933	127
11590	2vaM74LD1KiB9Kf2dMFxk2YwNuHi5RJxyfsBz4Q6237L2Jp1Xw7Z	127
11592	2vbiscg1hhr9fHJHPkajSQoqDJLM7dDMrb6WTw4NrFvU1eVS2o8Y	127
11598	2varNyjM8Nb9PE9pxMDMXtaKcjUhYDsHQMq19Vitv7Bs31a3RkGn	127
11600	2vc2osmveaahNBTqUYzadx86DQGNQ4Zxssoj59qSoFWb2RNGeRxn	127
11603	2vbwHAY2rEmJKBex7VMyNiCSg7z5WQ1P2SpcxVtdmHmbNpgSLMSc	127
11607	2vbX8jtDoFk9SDXhMWHrkrPr6thHzuARUDQ4sgu1UX5V2T3ThjRX	127
11611	2vasPgqMvfksnhdHtSDUmrhRB3LLA3qnZN9U7VsbcdXg8jgwdvky	127
11614	2vamnnWZH3e8j1b9yAFw7XXWBSzsz7YcFdWN8Yrgj5ecNrD2zzan	127
11616	2vbNtrNNeBdJtjWMj5mLN3mShFxZv43W4k5sPXJaR2cco3strCsb	127
11621	2vaion2vJY5VYVV3UC4FtQvmA6FBhXYiJ3rFGuoJPECkoXr11TP4	127
11627	2vasqkoY3FuYPabe89ZFYpE59qf8DCBMNEj66dNHNanGhaJJsjzj	127
11629	2vaZeNpbyq4Y5yknvzziVz6pzBjKyG8T5JS4n5aCWG4RWWzBJmyH	127
11632	2vc2LEHsVEoRcRaTw8NVELzbSvWZsEchaXqL4JY163Rp6aYmoH1x	127
11634	2vbS9277DuCYKCor9tvEejRqsTvjn4eFJYB8k4fratyKemCkR4gY	127
11639	2vaeKYXmsjcPxXAjWYFQjj9SvGmMKwCSJZ3pSbP13qQkwSXhWLuq	127
11644	2vbdHK5t8YJmvSda3QTqkVV6tZ382MYxd8pMmZ3PQwvL2uUWmnpC	127
11648	2vbnU6FUZM7fgNy7pze9tJ6wW1HZJRgjJgCu6cjZ4k2P39ZDowye	127
11650	2vaqvZG6c9tEfZWLCnAZYHsbVFZaDsk9q1oqhiTqeqxA65PTgi3F	127
11653	2vbZ1P2iryiWz8ud427MsFNeND4WrHtsp1w86m1fBWEdzsWfMD93	127
11662	2vbE714GeYmb2wT6pw9kmg3xGQriSiMoTu7r85ztGpxuPyshH8fY	127
11669	2vbwKZXB29Hbvk3jscd9LrT8gpsY2EZt2rgw49UKE3ttZPrYyMVu	127
11672	2vaie7B5gwBuuFdKqzVfC3cTwxRHx2cdGZHe8tovi4jd7BeYfkBV	127
11676	2vbaYWUwsBM3xuut7XPGUmyzANsh9kKLcrD7wdrwYMcyvAAQjy7B	127
11694	2vazRfX2EwKNYKQk6pobwSXGbtTpX2TNavXascSgXXWvWbcuEtFm	127
11696	2vaLHPym4rzrBiobP6JrRp6Td3xj9ZiKV79jeATKLkzQAGY8ZMPh	127
11703	2vaLXZBtWzGCdF9mFNjQaB9hDVszyZmSpwDcPsirG4iAkNCHnbPs	127
11711	2vbvqrXhDokXSpNa8PqCDybs9U546KzxgADwBzZdPdCP5gDcofeF	127
11713	2vbyYcPXgMrShWMek7dWyX4Zp4XYVDME26CGYjU4CVRLWgjh79bc	127
11718	2vaPdQ9ekqo1U4BAeYpwsJSFeCaXFwWwbSQvGkUZYKUEqNeo6dU4	127
11720	2vaEcxs72Z7HbcrzF5iMBWvJVFwYW63wopfTVmNDwxhXt3DY89z9	127
11727	2vbfbFLZbWk5ELhsAL4yJH551uRw7mJGtwdyRpnHE6Q6F6FQgjwx	127
11732	2vaVAtB8KuAkBgN4rC7V6v6465xFN36WzdDnzKxWeHcmbkbqDDg2	127
11739	2vc2GkkXRtnNzHwVcuA7LJGPK2Z2dVc4RPS4GhvokuwqMnwCUXbB	127
11742	2vbC5jeTpkBV2i6mPYatJnqLnMQ3NL9XGyYLrFj3VyMbPznApCwR	127
11744	2vas1bXZXv96oRk1jkvS5f5JC4yh4YpxhiFoSJHnmsRLcAKhiip6	127
11745	2vat4Y6nGQaDgZPHjCVrWCwnnkyhVtdsBohr3rXVE9x1Az1nCp9E	127
11747	2vaNnSet4aV7z6RYr7EC6pT8NF6UnZ9t2uSRbjZZ2bWugU8H7MPj	127
11751	2vaPzJgMN12y5miXLyYXo1kSFbpFkQzUAx6fydzdXjDtHdnmzkee	127
11757	2vbCnikrhVUsHVakcikSKuwiWJwvNpE9kMGSHwf4vnfkDW9ahGha	127
11759	2vbeFi3vtfCUHQxVuf6JgEhigY7UKyhF3fVXTy6LeoMuxPb8bLZ9	127
11763	2vaRBMv4PHEv7F6w1bDQL5HXz7RY3s92cJ3qQoQ4AySQVANN1S5U	127
11771	2vbQVvsCYZ4YQB24cMBpXHe21h2eWPod8Ld7TTScYRbDzv7Fd3Yk	127
11776	2vb85jmeqPrL4xLotWpqEQs53GgYv4cPRnDgJtt8AydLTHT3BMP4	127
11780	2vaj1xUprVwSn2TeyMG4WW7msymQN2ayMhbQSxtSZyQa4eaP6SX3	127
11783	2vbLMexmJCshqmkdBs2AU25fag7uzwkYwh4yGhpCXPiPGUkgcZED	127
11785	2vaMm16QGGUNzHpNLThQFuUQ65HeHUG59Toqx8RiemKMKA4KUkFV	127
11793	2vbv2rbC2qzGvwJwgtRtQWcwzNcSk3fYFcatTxniKmpYJEdZgt3B	127
11798	2vaWdzobKZ7jqPqDqs8ywj7zL4mDRAheBCF1ajanZFarK5mmH9gL	127
11800	2vc5V83tekuwU2MkVS5a7CyXDGignyz8TpwrkjsJVMuYN6x13qUs	127
11804	2vbvkSJkHx8RVHCp9D8T5L1CLbFFRMA6dFdSwBVitTJ69Zekxj61	127
11806	2vbUzmzyPWeSYEsZq3AizGoRTFMa7dyNs66oev3cKwasE96KiCXm	127
11810	2vaXieTxcnEgPb22XbsrRiBJQDKtwdVnPFYBa2sUUgbVJ5PMK9ic	127
11813	2vaV5gtyE4q4564vvpHMWUhRcxbmLBgAzxaWSqpMiVaJZNWSPR9v	127
11816	2vay4Zb3Fo2rAyWgghskTbpG4TqVTDXFTF9ZiVHCzGjvWt5hGEg3	127
11830	2var6THR9M1t4B3VxNrN3vJXssgBgh8iLxrx1ycARm3S7pUN3vPF	127
11832	2vatz14i9iZgvKF7P4RLX2DKqpcPuLVKmNmYT2RWmo3hZoGnfMtb	127
11833	2vbHg6FJWS1g1Fr3ACg8hJ1CK1vqHpy3jGCWaNWeHsn3HMMi25kg	127
11841	2varJp4LVAiEkUPo8xE2t1au1DfyZbMuNQgzjUPD4hABEWQRJC1b	127
11846	2vaCVQEsPtNocabTz8E2rqeTUYY8NR6B2Cq4fpmtodmZNUHhGPzb	127
11437	2vaigEYtXNWGBCmqmLFULds9QXtjCDzmTt28E8eWj3asuZHUCM1c	127
11442	2vbWSTeGnegY9xMubHhszhsfxVrNyRup5dqtWPW9Dcx3amosmmBf	127
11454	2vaH4oVushVBHU7cum8wmQDcw9dN16w2jvCy9GzdrSVJrVCm1ZTx	127
11459	2vagk5V6AWQPLDSwyW2YRMy1Hhc2dK3QGgRApmbMF3BTxL4P79de	127
11461	2vavccgLEkAroj7vbesgxB4QU1JJqTcvADXfbLNyVkv5pRBfT7jt	127
11470	2vbtYVBAxyhSk8a2px3Vr8HxDk59rPJJLU5kj9arzavK6jcRAeQ8	127
11473	2vbpERKhvnNUrpUTxniMVouw6ZMimWM2PNsdTw5tkheEN9fo72fq	127
11475	2vaNBJqTw7H4iBsvi5PhNvGK2ageunCfFVRehPDfU2w95hNNEjnn	127
11477	2vbdRDjzVvpudNu7vhERd11TogwMKLavTd8qv3pti7vGYNd5hP7f	127
11479	2vb94PPFMsxx9mEYXcJdxi5pYpty6FR8i9QDuxMBgRXokrspGw7W	127
11482	2vatM9BosiHbrcX2vbUQEtVHwAAGs3h75zfuxo79pPnrY46S2KMZ	127
11485	2vbK1BEw9Rbn8t6m5sqJWKxbDdgjxpTJ9sNqHRjVPW9JNu2pEuMP	127
11487	2vbQgLuf3hs49TsceAPig9ikCJWRjzWR1KrdXihNXssoUmByawNb	127
11490	2vaxi3iv1NJ2dSW7v25sN29niJ8i8wSZmetHBk1EAPWxcRyBSwDu	127
11492	2vb8TLeDU3jGQHK7mPENuaUh3RjT6PFcco28ZZzPkRouCWkeHzwQ	127
11501	2vaaFcJnQsDom4bdWXnPm21GYcjng4Nd6Md7YhvntKrqzRA1Qnjm	127
11506	2vaGvuyZktnvYMF5fvtQ9f2sfB6dWqT7mAdj88M6erdFpmsoZUXB	127
11508	2vbSN2uAc9FmS1g7GTqYD71QEfCEsEbuYw9wjNyhny1qSps9LRQy	127
11511	2vbRRo8dVQfjmyNWmghNLagU3unBKcZoGWbnYen1q8GXM7h7Dby9	127
11513	2vbdwPf62KtrF9C8WfbYPRTxrybGEJR4rM83GM7C6zPjUGvLgQ2c	127
11516	2vb8UDjbAS8iYvTvR8ARKmTZJAACezVXMPCKC2FApbsazWKdtD7r	127
11520	2vbquNakAGWtjh3T35pgYyAiPaeXzZzs7uUA2rymeNE2oEkNTYS9	127
11522	2vagVMYgSE3rxzf6qCMYGmbcXCF9w1myQAQ5XjUCGNrybjghSLEW	127
11524	2vadnLmsx3BpKSxddon7B9YXmNimkmJwm4U4GKoe8xPuzYXsk2PC	127
11528	2vbhS3e99g7vXbcretcgApr9T2eU8o4ojVf8cMCF1vn16fHAh3yx	127
11534	2vafGeSF7GXyWnaZunGghtBAEcTfjKxwDwGUW5Ft1q6RVmCY7P6B	127
11537	2vaFcSnjQBJri3ssGLUU2MQBpBSZVerP8EQpPcGap4fRAEunNDfj	127
11539	2vbXRFVrms8kAdk7kugfuhmmuCXezWmLNmY6Cj1xa9e7RFicLs2D	127
11544	2vaGtjPxSYUoz4xKB26WXE5UBu3fzrU8rRr5jsJggvTiLsYuoGxy	127
11547	2vbJAwC1U5J5BDAoKPGw5hm99PZxX2Yik7iKFiaDgfm8hWoPmqD1	127
11550	2vbLaoR7Zg6Fwy733QQgdwt6JaFjWTZzxjKrqWtJEBePh58bb8dZ	127
11552	2vaR4wzDJ6EKeJkCkEi2SXx1hdsCpQSreVsusSW2mtJdP1SSGSQi	127
11554	2vbdESFmowPQgWwit7iu6j6EkvYjHzJ4RBZAHVJw5JCMBwJpb3h1	127
11557	2vaDzm3PPyMmP6LAnkoPAxzmNwVetvMkYBgvGukudT6jrhJcZrbo	127
11563	2vaydyW4rFiQda5z4cSH8pH1efDi5GrJE3dQqME9cdA615QENEDA	127
11569	2vaH81dmSLHKBwUw2hk2RAPQyvSHctvsymneXu5MjogQKPnr4fxg	127
11571	2vbCurJnanEKYkYrpCnzPfoetaA1jVVj7hXpHBBeJHWWnch77Ufq	127
11575	2vaVysLtVm63UanFDoRSfPmGGdRBNHg3XQ2avuHmPEWvDn3VQG2x	127
11578	2vaiaZGUi3SiJrA4jFm2yaBhfezFctxv8k3eqmYjoKSHk42iyoeL	127
11580	2vaBrcpM9UHx1UcbQuVkBETMdRmwmA2ZsrFBG9xdd7Lxwuxq3e49	127
11583	2vbgq7wPGYMhysSzBBJtcNHGDAJ1wWZ85oX1qVFJsdoP8KdtwHK8	127
11585	2vbw8GzQ8ujr5kRfXP8hUjnFCED3Ri6Wp2HqTtCECFQZtekG7o3R	127
11586	2vbkoNLTLC6eQo1vnmtYe54gHkVQ9NH4adBWcYWRoL3VYKSAkZwC	127
11588	2vbgMT6srBpqws7svYbwAHJb8UCtjnBmGMPkBUrQmHRpMHVUCLZZ	127
11591	2vbnPfkDwCZFu5ZYFZx1WqRS5pSsfdG8tFwvGnBgRWs4KHd7ANdv	127
11593	2vaHUNkS6u67WsTfHYW5MgTU5BYKqQdyDrSY3CuNNZDceA2P8orq	127
11596	2vaWvXTSmPKd6mRHgrvsP1KZDHB5ra17AVcwKTaZddq1UX2BZi2t	127
11599	2vacnCBmMdSYvjxuYw7sAonbsFTuTywRt4z5k2Xat38R2zB6sHvX	127
11601	2vaS9id9ZQybuQpWtbryXrrTRkdg9o2jLyuCMtzm4BKV8XpDsRvL	127
11605	2vbUxicLB64i6SszCg6rGWTU8d8byGDSvh9YaQXPPKC8buZEA4LC	127
11608	2vbSS28qxQoCHRbp24Yc7FkGNTpCqhqEb2y3vqeQxz2z3iZda52j	127
11610	2vaYQ9nczfLbJzQn7TvoJT1uF2nY6CXRWfPz26HJg7kw34wr92Y3	127
11615	2vaMxmDy52VUBLqSsjwN2cn9V1V5LEXu9cBrSHmQU5rV4cuHqXCU	127
11622	2vb7dJinPbVtrJ5Xq18t1nrE7DWnatbBEqUNP8B2DjA1AtFM74sr	127
11626	2vaDck6XNvXqfM79rotPwN7ZgMwTwBiCovzU5dYmoVJRg91bt2aZ	127
11628	2vbMVJJauiSqWb3swQ4xTzojkVbkVyzBTAfFxQ5sYCVkcTVedKW2	127
11630	2vbL7o5z8gUgL6a3kno9posJuQ89sK3kRAmhkiQBbCHUV2UprqKd	127
11631	2vbgSCKJDKw44KednCtZ42ghbZEpatjnpN6Tm5cB1xjjuUqJrj3Z	127
11643	2vc3btnyVNnCg9ER3tcv1hP4bRxfXrtU8oFNvrQTeRWfYPyMJXCH	127
11649	2vbanHSuYLN9hfhmwe2e3hLFnffCdKpYg8Af3wgZvjp46z8uD5aC	127
11651	2var2CpFcou9Fhb8CaDCaHm9Ys5gesVLYHN9uYEGyBtSEBd7sUtU	127
11661	2vak8gy4qanSBz4JkijrjPTQ5AYrqH1rhWgpLvLkmJeDK9yKH3Ky	127
11663	2vaSYBb2xR3o6pGPE1KJVLAtJpCtnVaH3voMD4TFfXKSrSWExPQm	127
11668	2vaLDSRjwCMXzW9S5Hj5BZnyvVeRbD5iam1c5FSFJxCGdUtVLXcM	127
11670	2vbZT1nAqpNJ6WFVyqcx6wT5yKZxLTPnkpem6hUVHbZkgV4kKEyy	127
11673	2vas9srHnvPtjsycisuwep2Y4pVcPXZRfURDsV37uECQfZzVyqGs	127
11674	2vbtXWngTqfJNk7LTRAQsm8JezELb56A1UXQzW7NQQ14GLq2KhNp	127
11677	2vbdvc1Ns46udRduJXLDJwaihcv5HTy7RVb6bCNCcNPnZojwaHRB	127
11679	2vazzxRCrbWDdGusqf9C7ikvtAfTXBgGJBcHsk9XGv1HvmJVuEVt	127
11682	2vc4G6tp9bTDzHRYENzfb2zm19TtXmCUB6uEY4ujHB2B5dvdPbFD	127
11685	2vauunNT6S3r2UzMu4R5fVusTY4TCxroZNk1PgeXK1De3Srxa13z	127
11687	2va9dTjvyLB41tf4KG8bMEpXBXcZhg8wNGfp6deqrrv99yCNambS	127
11689	2vaPnnccso9CZG9f7Nu4atDP4PY6dQMGT6XQJ5E4khsUtkauP6C2	127
11692	2vbo6oDB5CzTd4eFdcfyJ3c8NGeP7JXEoSYp9pRpUKcQcmeLxCuq	127
11693	2vaFNqCcYx23hBwzUvDTnpjn6hcBCfzuaPZBgNtNRfsTShmjGnt9	127
11695	2vc2RA3xtifW83eANW8Wrro6jvJwoPz2c2cTHKm6rgmdb1d5vfmH	127
11705	2vaiXwBYQisDyi5z4YyXZRbMKSDHgrp8PUapjQpzkBssmGY36kAn	127
11706	2vahLFYKVsZdiYZCJwr4Cs4B5JkjYdcWRjPYnByo27TVmgEYKRUD	127
11710	2vbYGvphYJU5saNgswfwuCv9ekqrDLqPtZTRDUdBejTHUxAFJ7Xy	127
11717	2vaDiYu6w84aXto4wNqj97KxTUAjdd4C2tgsXErn81a6GHnHM8uh	127
11719	2vbocCaixejbNzVuohzN97YBzxnCgP1DennwQdPcs5HnTuW8kysF	127
11721	2vaVPoMmXM2VLsqguACdviEQeFvPC9RHNSrhgsSrRqEUWBRNN3R5	127
11723	2vb4MqB6fXrNrCarFdrBghFeMgiGu6RTohBYPuyVDcCRnwn4htgP	127
11728	2vb7SuMEePeBrcpxFDaqAzxryWg5Eao4eofmydGR99YAfLgs1nKr	127
11735	2vaLwvEP6oY4yDWrzhbdZJ5Uep2cKn1cLRR2xffKeac1fH6aeASG	127
11740	2vawz6LqziztgaiGEY28b1Cujx1qZigYQeaBnbNSqEZjouS47tjN	127
11743	2vb13pA4PH6K2nWxEzMjhXfAcPkVtDpCUuu4ss1jgpSLSV2tLiWH	127
11750	2vadM4jTLBN9LUnWBE6F7Yd5DykqDCxYdN8B9TSZdMfM2TfBaV8X	127
11736	2vbNLFc8Vi64RwAnD2KRt44drHB2HuCw4aqkxywER5RN5EWccF6m	127
11738	2vakVypGabJaH3rbwEfEHwRBRxpUdZamUY5DRsiUaHZpFRsrpz93	127
11741	2vb1QeBXeS1J8HwJt2AnmeXpa1ifCLWDorMqWAKEyzKdJyukoGt6	127
11748	2vb5NHraqq8mgAVP9KnTe4gXVRLBZVtUH5BevwRxaqn6ZEUu31VP	127
11753	2vbr1B6XHaHjfs2QrR1f1eVvtTCJu7D2qqcCrNpwoq5wuwVKkevv	127
11755	2vaHBd3ENgArLA4tD14UpBBgQLj3t7NnftB2V1ZG55kPuA145dyW	127
11756	2vaonsHbDFNqRw71ZdBd1TGmKgjfGstPhU8ryBBsyVXfcnkzPqHN	127
11758	2va9oYSb8irbLLZ5RF5v8s1HTzK9ASitckWD8QchjTSz2Xz5jmUR	127
11761	2vaium8rwsnKvnBna6sF8CRU461QLDNNzGr8jREWYqKrEWTFHUMh	127
11768	2vaH5m62ovhCzRDRYVRGD9WSXup3hmB6PwkUaoNRaaGD3pgx77Sk	127
11773	2vaTcLv35GPHjd1e3knMWLZEd2LEoE6Gzh2ttTwj9pUCbWv5bLTK	127
11775	2vby8gLr1HqYWgy3Z7kduJZgkVYnjp5VGnsPe9dRSiXeg5qZf1mL	127
11778	2vbRmrghJckxgv279qVp6XuKBpT2cQG9ZwvFQTmTzczwnhuCyUss	127
11779	2vaZYUNjw7HDr7uarZiBjA9og3KYMRChPrENy7HcCXmbyfW2MZwP	127
11781	2vaQvrhzSj1r7MxWCp6NMasfTygqy7vWDbWWvtrdSZkYKPH75i7f	127
11787	2vaPtc4XRxi7xD385gQBRSCVt4kitpWcLDLLjBHhfuTd3j3rK1pu	127
11789	2vbW8CYfCyTRUnuaW9Y29isNpSggHyHn13qhqeM8vY8qKXR1YGPT	127
11792	2vbKGPpqXJNFzTW36n7syTsJ6d7r5EBPbhtkYnQiuKgcTMe3uNc8	127
11795	2vbxw7Lw7BAr35XyVhjb1ig3tJMmFo15Zv8sbcujzdUE44c3J5io	127
11803	2vaYgZzv2RkQtZU8RipUTu18kB7Aj3aaCgRcuzKdXxmHCXQfzJjM	127
11805	2vaRLCSWbv5MrqXYKZcxtN2Ejfq5L8UDeqWxBiJjTQKTr3qjHyZT	127
11808	2vaRKxQu4qDAa3Jr1x6gsikTnfLNo49FTRfF4vxUTu8XHFJCeojt	127
11818	2vao7StWnmVDZyF9wFwJMccf5ks9a9aYyB1B1isZVsevsaQXHFKN	127
11822	2vb6USPoDk6iPe5VE8c1WxuaybgZkeFWMN1pFDopmPwvkKQfkS3N	127
11825	2vaXxBgQZPBvsCKZYjejs3qVoXvMAYd8umifVw433jcmwfQmFVUs	127
11836	2vc2BpTphgyot4bMVCpU2Rgt9Hg4RKug4qZEpmh3WFvs2eRaPQHS	127
11838	2vabSDY5GQeZRc8KALEaKfpHLk3KRXm6JL9TtqC5EAqYJXVc8V9H	127
11843	2vbFJUAWXcMge7UtZdH6r7i3uwtHDnWkzN3DoaAt8XUcWBTvF2SS	127
11848	2vbYcunhqovJHcyWjJ8F3u3T84eTgpefNu2qLaGyWExgdqtyvToD	127
11849	2vasWjRspZ7uFWXdSr4geJs9mWW5d21H32bTLb2GDBzE7TABBXFD	127
11851	2vbcexrzDJKpHAM6QZgDv8ULMA1sVELGvasybSBs9rhoBE7DkmzL	127
11858	2vampot1Fiy7kNQmy5wu2pUPBGd1pkoaHTyBpBYWVwXi3qRzWowe	127
11860	2vafHy5S1ihcvvnHgoJGnZX2B8XVvcR4H97bx2DEkdBnUzbKovoR	127
11862	2vaY9BVj8cfPHaD3hWkUWjNfoqG7ihBbPEcpDnhYP2ppwt9TXoni	127
11867	2vbToeNqG8ov1a9fJmaUxz1gaQioYqdNukLWEXCFSrZumLm1ADhd	127
11869	2vbFqUTnziVxCgQ77W9hEkLekFAbeQzxmCZmF4XPNdsoEkzYmcH1	127
11877	2vbi5Ro79bdCmKcHnS6MJNZSNfb86kke5b7ptCwgdxcm9A2vMynE	127
11886	2vb7HUaHoytbgZbjDeBqFWmwc6YqvkzuwcwAqogdnfw3GCTRbAZo	127
11887	2vaqw126hqPRs1FrvTFizMB7fN81KB937TB1Fhftq81MAmbBmKV5	127
11891	2vanJNP9PVzjtC6Aij8GNp4ArDMxyzBmDAkjDvXFzdZyQ1EJFqYp	127
11898	2vaoxvFxRF5dughJPe4zaPw2yGwy26gBYEWNugkznNAHMy4T18e7	127
11900	2vahm3kvs52QQyg8Lju8cz3MfJdsb1wWTAd7XZ3tMU9LciVu41TE	127
11903	2vbNCvbwayRVDkbHB7QtMqD8D8QuQsPSi8CGRvt3fmiBXciemQzk	127
11905	2vbtHjJbGvf9KYyRjE8qNoyD6CyUAicPSZRwWbLgadjZDvD3vgsj	127
11908	2vboZTxyENXELT4VaphF7fmMQczHTNriNt4eptNGu9aCv52r6K1E	127
11910	2vbHSctJXkQAjzsYjdUu63CPrMDRWXqsd32ZSnbKoatDkzwFzhRQ	127
11911	2vbrR9Rj9BUcthkdGPGPfMW16MKqFQccy7qH4LRfzYtPQC3zwGJi	127
11914	2vbEAfYCmBY2vxFPQKDANm2MhiiK5wM6F1YWTdhfZCcA2e1N51S9	127
11916	2vavUjiaY2W3CkpNP1gUL65j7gf3y3VpnQxh7esKvXFz2S2peqw3	127
11921	2vbVL5A2GR7U8fB5q8R3KxtMtdKsz2oWNfQn1SENTcCBHo32LJB1	127
11924	2vapRbHU3yA6P5qiguK2CKdTCRamAahk9iYyFo9TdhgDKuP4Anh6	127
11928	2vazN8MtZurZhn278A8Kts1mwBGz3K4qnHs3LvjAFRhqYDuB4T9Z	127
11930	2vaww6HAXWoGkkLHAzKFFFbG6pEyYRALGyrMBC6KeyAD8wimyoHp	127
11938	2vb8goAnABSS1tz2KqvXrZQ3RPRjtJP5GYYCjM9Xu9jkMEr7gpr6	127
11940	2vbsVyugncCBn2BVnRBdCkaLhd59w3xPCsuhABJHcqrxjvRLQ5B5	127
11945	2vaS3h5UnGM7phBjzHauJHvHVcVKph188VJWeQu7AyNRJtkRe4XH	127
11954	2vaUXahYtRwfZzvB2vzT5LjXcg8zFrVa84ztv9MCR57iAoBzG1k5	127
11957	2vbLehJZzFjLFM5iX6WKTJvfLnvw4c588t9d8SwrLx1YDFUzTrSk	127
11959	2vawesuofXBtjzWav4v7ecrEWYVqyUXRo2n2yRR2gudbzHNfKNAp	127
11962	2vboqU852FLVCUspyAqeVf77N9uuvwxKcYGdHzWkRpngXozgEx8p	127
11965	2vbEVo77XfvvoycZzianC4RUBpgu6nhnC6j56Zc6xqf19wnTDx2h	127
11970	2vayg83FgmyZBw8iWzKHU1M7pb2NXxq6Nm4q3iNeAEPsYmNmzSin	127
11973	2vbEPjJsGgHJRojbbFBAQ32t7GpL3ueCtjyg2dWFLfVejbLC4n1Q	127
11975	2vb4CaRLjiZJjtRrsbwv8tCAdnhRsPTFYcdg93kZADWSKC3BxRZJ	127
11980	2vaKo6mHPaCt1UxKXREMuK7FHnQzkUfZLEFzrW4bYedpYssMC65y	127
11983	2vb8coNYARFnoiqTP7mHcMFYvj1bnz2Pc6K6QA7CcFhuVBJLwyep	127
11985	2vawkdLgSLsSVVcPKs1A4wSuWBq5hkPJihLCZmKqePs1qYhdqaSS	127
11988	2vc4U728R96AbHmhV2XzhJSQNxf83nYDHoVvk3tfBYYK2WBcLKMp	127
11992	2vaVVmc4vHbXC1ZMY3R7D7NJUpYqq7SrMhRxqTBnteW5QdGw27fP	127
11994	2vaZBAeUFgZAPG2kZrsPrWM64VFoRC8exmu8TnJ5VTe5kraJwsA3	127
11997	2vaNTnT1nTAgX8Q8SPhV2eunM7YiKrikJwTJxrPrDcKciyYdogtJ	127
11998	2vbHAt18iXFjXFxJkJUkyt48LUrXEDUP22Qr5nwDv2k4Urbs83ka	127
12000	2vbFjudDjicgQVsqKAoP4fCoDnubk5CgK3nx2zLHctHT6TQRYmUG	127
12003	2vbJpxQid9eQrtQLHnL9QgMQpcrqAUSmU8zACQoqFfwp3BW6d2nv	127
12005	2vberQN982hykUjrdgbXaXkcrmqK2Zo5aPkq75wJBtYC8b6sarP3	127
12008	2vbFWhbZa819mt3xTJ54TGQjbYWDNvhqGY7nkFPkjrrBvhKbNXRL	127
12009	2vaJJipwgF5pHvbNVPhaRSkh9Jc6VKLBpC4Pf84h3roiegjd8bkZ	127
12014	2vaqruPVAAZk2ts24X3bGouoFeEutMwqeVNcewkzTXtnkvowkjj5	127
12017	2vboqTmsYhCDDr799dwjRBfbyB64SGc6Wdy4mmXJejfPrKK9cByD	127
12021	2vaYGt4o1Egoep6BFwYD9z2HfroKrmgWDFFdFFrfzcY7kiRcKrxU	127
12024	2vb9aoAgDfizmZazPej8z2dqU6QQoTQQw7zcJVJcX2Se96Yqidcq	127
12025	2vbUYZ7rYXjMNR1pUjJRpwgJQdobVHFXRzs44QkRuQfP3AdqQ6r3	127
12028	2vc5TepgR5H8rjX4VdPD7FDZACsYs45qiFzkh8XETM6uGQxmoHii	127
12030	2vbtYU4GUBw2cMbBrpQV35prvEzoBkkvUCduek7QLVdzYarTKXhk	127
12044	2vbUeqEKvzUeRt2NtBZvFtxpYJS8NPHsPRYQjAN2e48CF1eKmEpU	127
12047	2vb8y6dZGvaM8LpDRQA65tiJ5Gu67MJ4cETVzNfwh5EkyvGWHFQc	127
12050	2vaAkd6pRDr5sAWB53AkfHmwaHKFAtx3YPewC42GqSSd8bgiCdbG	127
12054	2vbGu7VsEDeaZxHbfExFajj5cDLe1Nsiu7UtT8HuwzzkFoC4TPFz	127
11752	2vaSJBJjb4fruDDbP42SKLkBuENmnUPtGLknvFrh6nAnv7YZokpG	127
11765	2vaac9A5MxTdsifDt54PoqVW3oWJgkBJrvtbUY2tWynMEbpQBxc4	127
11767	2vaDdrWZkVtfhtAxcNLTxMbqWSiXKD3x29pkkXWQsxeX5yzZRmeo	127
11770	2vavYni94e7MPZYUAEJNngGxxHCN4GbUQZGowbJceJnvE8xTvncA	127
11772	2vbZPdV7bipe16jCtd9NbgYqWmu2SAqNpdPr9RZ8XvEfdau3zrw7	127
11777	2vbnY7DawTvtH7fkfWTGx7mkX4joiKbarmPGgg63ZMEiSPaQG4Uu	127
11782	2vbgysnAsHL31J8MPjT5t5HYhdednWikve2JPcsYPUf7n6XMBEGP	127
11784	2vbErZttrABubERiKm29TuN43DrqkYKpjpPi77jBxs9efEpBw2Hj	127
11791	2vbygmQEEWebKUTqJGYY8VHvrFp3cgNcF8cceW7mRqg4h2nExiEP	127
11797	2vaqJQmKZjXqZfDiSFcZyruBEHH9qos5uEH4g9PVPhtdHvszsk41	127
11799	2vaCsnAGGvDD2iKHiukWo3v2fuUPNSe3b3UMQ9irrjucxZyBa42t	127
11802	2vc3JZwNasqi1c2bukwhnoK8aKh4Z85iEpYYkfDn5JLR5jCjhnTN	127
11807	2vak2VcTDY5ygyy79UauUAVrCGppijghoAjfRb1mddRvJvz7GkXS	127
11811	2vbKBnf8Fo2KB6RHLAQyq2VbJvHyF9KKnY1K6D3hBrvnNLEQ2szF	127
11815	2vbP5CtzaPjBoSaP34W3G4dzzErSyKkWzbccJbVAGrzpcpuajS8w	127
11821	2vbeXDbCJP5ZQm2rKA7w1oHBkfTuVGy5FMFibv28kPzHXjAJsL1i	127
11824	2vc1Eju9JJgMiEabYhNDpLbEqZp83jpeiuegTfsd3AQmp65NTGZ1	127
11827	2vaEmBrgp36YYfR5LvngTGPjnBLeYDmqro6Wmg7Zm5RBQcvgzkZV	127
11829	2vbRkAtfqfNVKfPvpzkRbcsyZxBPUxEDXSm75JFowcMkm84rrWgV	127
11831	2vamhQyVYYyYGt11YZdf748rboz13xVnt44t4NsoaJ2zCd9b1iV6	127
11835	2vazJEqhRYeBuQtrtfPB5SKsKAU7MH36qeysjuQASpHL5TgGs8iM	127
11840	2vaoMq834XhuTKUK8arhQMU8ThJqmogTHa6pXw5yye8YMSC7JHtm	127
11845	2vbKme7uM5sXXVvNtgVuKWweHb2WUQ3GFLXpzH3UC4cZV5dnPXVM	127
11847	2vbpZLJNcUVdgXXQZFHfhqqjJpxpNn357jni4rUFkDDQdnRWHHeQ	127
11853	2vbkg69RnXNavauE6wE4LT2oj2FhNPL111czXprbPGXjCePFpp6m	127
11856	2vbWSKucTVUYW7yGvooCyRkJqfk4h4BTz5U3XijWE8JYKy8ycrKS	127
11861	2vbYmo2W3ufuLu1AfbucYvcQb8tevGH6UrzHVLaocm3DpgD8zzsx	127
11864	2vaZ3XxBGz8uUgQ32QBrCk7paQ75HCAKew6ab4FPWU4UHiKXBKXc	127
11866	2vbyMz9PG2zq9jbo72QD2BYT8K9BGuWNpQ2cvLJfwtDNGfWX3BER	127
11871	2vaTo795mdoEWUq2PBzq1e9WxaSzjRdhZtCtBcC41GNiKQY5SJgN	127
11873	2vbgUDau3PmYGFB6MgtK4XFKaZjebNUAYpYCC919CKUMeGqsmoaR	127
11876	2vaAQMD7RPGhhJz5qGREz7nhvy96wEa888aLqpf3sw3m87huWf2c	127
11879	2vbPYfpjjrWPV2a92uFQrur3pNVvfgfeTbtT3VvXs3bH6ZfhDyEZ	127
11882	2vaqwsAWCXbmdEqm64vRNFCp4Ytwi4h64oGZEzTN8NPyUM6zYbUU	127
11885	2vbdXJZx8Pyti8G533hjEqzXmiNSXxRUbkU5u55fmeJwcmiY698R	127
11890	2vaq8aYYd2LzxT2qmd4dEM9UcWwb4aiXuyRed8WjxjDhKR3xUUZB	127
11895	2vbg9MWJ8byvEp96G38g3goU7nVgZvi3BAH6mMab1ADuNWB6jabd	127
11897	2vaFbexBWdPhBgja6fjp7Jb6cgPzkMQHy8unJqT6aujfGYfAEDLy	127
11902	2vbNHVnE1Mnwcda37QYvthpzqi3KtJ6Na8qJTRZiB8v2qSiDxPmz	127
11904	2vajEWASfWo8SRD31xkQe2UoF3ocs4AEttW5LVgGTVCCrayhh5V5	127
11920	2vc1assg6sNDteyJ1g3Ppee9w3RwqKDLG7ZiqGjjN1yXMJqnHZYD	127
11923	2vaLam3yAP416HFizeJB5npd3fToP1XfhWwVRy4LamjqnjxznHXv	127
11927	2vaABSJw9y8eqQNXy75TbbmRit4XgAm16DgAzHycYKVcDQ5fpoXp	127
11932	2vbNhMxinr7Q7XHvQVq9bgfpybiLU9uKp1tJPCGFjB4vV1bbxEBD	127
11935	2vbXAfC2kyhBtRTTczisxXhy6ySSuGB6MqKnjmTkfNUWgLV8nZpb	127
11937	2vaBY1PnUTyG8q9ZnLyhwKoXoJTsucLTbvbZvGxgjyYbypkKxqE5	127
11942	2vbRsPzKSZxhhMoZ1ndvKGP8YvfWp8UesqVtM1WcEUVprnp7iPuK	127
11948	2vb2dT2JzZcrihnMepFSDzNDyAchWyUeY2mpnSyViG3Dts57m722	127
11950	2vbbSLo99sg9dTfRYhBE65gbU3bGpcoraMbpCWC8N2LnPwsFmtKP	127
11952	2vb6BTVticdPUWkC2vDypDPczs6CCegkb4JJt12Px5Eo5A4rArx4	127
11956	2vaNS94RMse4i7Wb8b3e4sxxWX8nQ4u8vptEcSrD94hUJujnnk5S	127
11961	2vak4VFeLMXPMHZZUSSWSjSFAXq9uretnoYPPY3irsEiDEYMvzf2	127
11964	2vb7tAHTdfgsLhMvprWeWvKcahCRbrVLWGP3fSRyXk4dKmiTstrB	127
11969	2vbD5LAp7GjqvVQfwWGrJ1dQ2Y3GBJREbuHWomiR2Dfui7VM18fX	127
11972	2vaLqEHhLwx9gi1GGHKuMrQeRzY118zKDTS2R8Aim3viYY8cwe6q	127
11974	2vasB9mShyLagm4wuRJCwohW4VWqvoE2LMabSYgtv6aEVPRpkDUF	127
11977	2vbrErWpq9ufX43CUJDmjw5FzKsBk34gJvm66ShZwt2U2oaDdy54	127
11982	2vaPwqPAGHs1XRPukq69uK5CP1VBr4KynSZTkmDNze4xhTsn5r8h	127
11987	2vaRwKurq2Bc5ZR56hAVxRNFnk4figMtiNs85Nee9NFVit9MfRT4	127
11990	2vaYaZZCGUfCWxHCRzMAURZJaJttgZaAwdEHBMxtxUtxsMUZvfai	127
11991	2vaVFXDZJpCd2QomvzSavzxYgGBJjtDY4uTQcoc37nLa8bWxJJ49	127
12004	2vbE7WeUYHT2jMvQc9Y5iCsUTaBGBXBBVz6o6fjy6zfSfasb8BFQ	127
12007	2vaKPYeJVPH3znR1iSJyVwgvP4FL949gLfGrMveJZqQ7iM9J1KpF	127
12011	2vbk47cbYfg26XMV1UHhGD8KNMd3wiakjC8Zp885nn2Mk3qVLGkg	127
12013	2vbsbS3UBd4vmMYUXUQxCwj5pWNrvPdsJsbJQNiasp9SmWFfULne	127
12016	2vbGWij4k1vFWZA65D16FPuQ7Ck8RDAypVCTzP9ZAACV1RHRe7Q9	127
12019	2vb4DA5sXHPNk3dKpGhgCbJ7CQfb86CCStxUdJMHqoYSbW6w9id2	127
12020	2vbPbKfiYVAikFWQ1bNx3P4FQrbx3Wz64hP8Rc11DqVce1VTcvxk	127
12023	2vaVEJy37CghqVzZqyrJcsAFLCzJzJ5Cni826PqeX9DCKCDnrNpk	127
12027	2vbMa68GHUr52L3P95L52YwaJA3bwreey1VRJUUPvYsR6VgFazBU	127
12032	2vbfx9hHJ5C2Ye1Y3b59g14LvgGfuddaEL138oAtENxm1dmvZYap	127
12035	2vbZN9MkebAgMWgiZowashhzui32sDwkejevfNeqUzx1bboWNNVP	127
12037	2vaEeF6xNspFUp5h2asJPN8VzfMCG1RVMLgxGZbXz1qAVLupkkF5	127
12040	2vawWP6ScjzMSCsrnPseer9SkMEYS4EsRDRwdVcZ2Km9Xytoe3QQ	127
12042	2vbeY9bKgtfLN7dky8dohuoPujKAQrKGVrfBPiPBTcqdG7Zm6CSm	127
12045	2vbQ9RERFVcBoARf8BbkRycg6T7Em6NiKcVLPeqMSVzJS6kVyhCV	127
12049	2vbj4jpRxJKdZtSwBmCjSqYo8FiFv1b2sDmSEHiD8jJKEJVpKB8L	127
12052	2vb7QxoTqBpEvm6An4vXuyRr6RXrTikr5NhN5igBSt2hzKPbfqDp	127
12060	2vawto147EXPdwM5D2fQys3euxZUrvwzKmmpCk7VeyvLb171qPuw	127
12069	2vbA4a4e9VfNNvBidZDs34A36QQc2XybN453bH3VsFcqZfQ4pnJR	127
12071	2vbe2GnxhVzb9PHadJ5ZdxrsM47MEHjJgQC11NX64vqG2FZ6xC3K	127
12076	2vbsYyox5qd13kf31XRZt32PrnTQ2v414AeS1v7UwqmPmdb7ACRS	127
12078	2vbNP9QieouhFMjnHbgtuxoit6sZN5NB8pnrzoVmjmoyEhuB8vL9	127
12081	2vbfxcu9GpKxgzWR87ADddhCDQNASft6WYfb8c2MdZifaiG27qdE	127
12084	2vbwGeumrWi4F5o3KzL9nFuYFxbCs9UPeh6pM6mWptvo1GXwZiA6	127
12089	2vaAh7X3ALEvn1G7Az3su6z2b9nmm4paJRTvMHsvjeZGvQxgH4RA	127
12094	2vbBzZUJcxsfRF4GCJUAZc7HgkCdV1z2R23XdZ1G2KVnbyj1kFKA	127
12099	2vawze5ZhonR7Xeg3DYnepBiSNxsWJ4cSYDjmFUzYaP4W1hypRC5	127
11812	2vaJYy5u5CaaZHFx5qbqUUjEVHsPHyYYJ799qHNFz7fHrKB6f3SE	127
11814	2vajVmfTJLh1QeQUjzdmzrkVxV9o44f9MFFpgZ72fVhQqrbUsDWT	127
11817	2vbMwDUWsvW5HLdgcmsWimyKr2wFi4WjmBqJ3oVWvQ5GRDoDNgDL	127
11819	2vatRRJ2d92Eow7Ne3szdjvANVkb3nYYFJ3rSbtx25p6c6z1Eqzd	127
11820	2vbtTpwKZSazRFy22XncfdBFUSVY8Ri5sxrZZyQERsZ68tobvJfQ	127
11823	2vaaWqD6GZWmguieemmAVRsKdQGZD2XWJ6GLRH1X7yw58rsHKr2U	127
11826	2vbnqzFArRWczLAhZmK33H5RaLm4zSXCtswPosHe9ESXXKHsxcyr	127
11828	2vbEKvc5Lnan9kgAF48ZZPxD5TKZQ6kJmjcatLNHN3kitwDdmK2T	127
11834	2vbx4h9ytwyy3hrg6ZzYBYG18Hfe1S3pyvDnnBggaBu7zd7gBAyt	127
11837	2vc26LRGZXypnLnxsJxPUQiry71F6mdV7BcYeV9pNvYK7r4QhwWp	127
11839	2vahd3TDzzVXhKdM8d2MvvHcaFsMmQZ2SySwm9Ue91Cf8iqnsZsc	127
11842	2vb6kr3RiGj5Q5fSVo8VFjEdxz6WnVstHgcsNva74L8joWRWgegP	127
11844	2vbmmqf9ZXVfqXK6BEJYzfXyy1iHu7TH1VYeWGSLkSEswbnyHmdA	127
11855	2vbhPZzicTRHHKkPVvRK6Vsuak826MtoLwzkPyGZpBawCmtnyqfJ	127
11857	2vbd7re8tpTwkJgANv3iXTer24mHXFyLXbStPvZKQtiUTx8wU3yG	127
11863	2vbCEwBBHTaJUDpv66niXtaMrgYVmRL9bdbpqpADgMNsL7fXCtWX	127
11868	2vbQWdPuLyomLQxEngJpP6UtxXCTr9pqmS2iixaAemX22sCTouEf	127
11870	2vbkE3hDP552UkSdaagCkYaK3dS6MTK1fhsniXewAMehA7orBT2p	127
11875	2vb7DK68JU8U8oHdyxzdEsjPpDkQKgmmFbyZKMF5sARDE7ZVNmsb	127
11878	2vaN4128276c21tXRDp1EtepqAF9q185MJ9HPk3BZThtyKPVGLPq	127
11881	2vaKbcvpwGNtPLJgf4sBRfjQr8QanuqG5iWbYzA2bByfwUqQSyDB	127
11884	2vb2K9naKytX67TPEazRoSbxscXpoU3jBaS2wiakUqzegUmd5G7S	127
11889	2vbNVGB17vHPmomr6SywQfPcKUGJU5AsiVDxuvGkeXNDipEeaAVh	127
11894	2vbGSRoKeur8YSeK3ijsSp3cMUrs4Lmc7VXwQ5Z5U378tLvNLDpd	127
11899	2vbzXrSqEkvYZohMhNEaGGrJTZYJ3oiSbcaLd833gR2C5m1Jhifz	127
11907	2vbnSKDa8FgbzZEvizZ5SHS81mdJ7APCBxtVQoYYv9PQSfYLDLsB	127
11909	2vaXMMhrkrBT1CQXrp34j8zaNsqCNv1qtsyB8diQ5NjkyKmqvWb3	127
11913	2vai9u2kJfmer7PsRkU5ZphoawEt5djNc9Sz55vtWZ8fwTPmVHKH	127
11915	2vbbbLg1U1QXCMx1nxz6AkxHG2Woq6gW16zEN7o4xozzqgfN3XaY	127
11918	2vaPstcLQh7DqF4AiaNVMvbN9yXQeEmNWDoXvf9izScjULaNiaij	127
11931	2vazHw2Xv4Y17LxQEGBbsRkMkcgvyqzbd35CJT47bBR6iZ2ozxLW	127
11934	2vbzT2qab4onFkuUYavn6p7qBscqYstHz75zXhGN8y5Y88WoTCtX	127
11939	2vb39yjvfZkDTgED9PJEwduwWPD9vTMNNTaSrhLu88S5KVchwQm5	127
11944	2va9ENyXxFezMBrf5cMJcjWyFc5sLugksgWvr2UZNAqZVqPPWbvN	127
11947	2vbCCb59ofd7yrHwtYdLUPnENwRqGD8uiUFwZb2dKeUNGnPKNTHh	127
11951	2vbYeqtbKW7eYdRN4Bcy4X3uVJp93PVUvkpGTkmz5w7x7ETmqUpR	127
11953	2vaSaMFuE1wDeF4NpzqTKjGDNjtw7XiLEXDAtxcKpkcTgvJcBQZX	127
11960	2vaCyBAmRzW6PkFTwR1v9LXXBnL7dbvSNGukVYH2bXk5XCMBkQU2	127
11963	2vbwX1RMYMqdiaZw6xAiYXe4jq8Grt2rzGXEKgh9EXVrKSZ4ynFP	127
11967	2vaSojMmvqgBazqoAjArBLzCnHdxApK2Nb5qrZFRuDet28dkAXqN	127
11968	2vb7ipqCxN1R9xJvgz7NTwhmciuZJUZ7L7HYRPZwRwErFYqeDTZR	127
11971	2vbmHzUC12TcdDjaw27hjLJ5Eh4LZsxb5yuakt9G6GhiE9E8tuCe	127
11976	2vbfsaZnGJ83aM2N54SFZH1KC5F54LJbuQEUdwP3YtfHp4Bx8H5b	127
11979	2vc4PhHKiRjapgQsBQUFVyh2653B3sdWWDuUvf8L3S5D5xcfk95s	127
11981	2vbuBDBjW5JfvUgqCHtp31dvq3LgiF5Mj9MUUaZbBEhaD62pYQuN	127
11984	2vbXYYg3cPLVX925XZcrKLp3Tuhqihr7fWyvSkBWesLpyWkgNwPi	127
11996	2vac3Wn9pM4iQbZtY47aoEurqQJG4rapH1xFQ8VKo9sfHmF8AZq6	127
11999	2vaL3ztpW1pwTxpaTyqXSvC79rZbnLHT7uDAx1vRmNz2LpG8nh8A	127
12002	2vak7ijjJG93aPU9KxYFVe6rAwbSFuW8aJtDZnc8EVUPZ9YpvTNc	127
12006	2vatWKWS13ZVs3gDuzV6aNRPcAfXz6w5K8ibxZJADphJamRmDtak	127
12015	2vbUb4RSPWPCojz5srFsWtUYya985cZeDdpUYw7rJSL4v5xo9h84	127
12029	2vb2dWVB5m5JpiFQYPNpT4qbfTKTAvZLoAHRXeRStPc4TosAhog2	127
12034	2vbteEZ76JH67UhtpqXVa25eSgoLSbjDwYs91GBUo1mLWLMNT8eR	127
12036	2vbCAakZAUn7e7fktJmbkWWhECtXV5DNfVquHQsTodPGCZzNC3gH	127
12039	2vc5eNWztjQUQurwzAd4qCTDqzZjBzgbkxpsd7w22oQTejW3Kxnz	127
12041	2vauKf4HjpgoUjSxiWki8rjQyYEuf1Eb1WmhkVru6AaJ13ZSo7sr	127
12046	2vaNozDXR27pUjsdh9jqgTbLU31xSBHcphhBtFDZB1sAG382kJy3	127
12056	2vbjKVjkAyNihYmRcQCTnEpfcjvQjAKThrHGDsUK8vtrsEAV9c3c	127
12058	2vbW3YhkwC6mQMrRCuujjZwn85vdgPNfD2i4JSxXhRnv1W7ERw8w	127
12062	2vaArx9Z6Z3uevAkYvPqYNECbYG7qJvbtqqksaHNRkrFAWjd5sjj	127
12065	2vc4MxVLfiWGL8SM1Hiuk2CD46q78c4A7CsC6az1HAETch2JQPL5	127
12066	2vc1Pcn9EodvtTCEwdrNedkUBk8ajXxAmb28Z5rLhbG8M1aSqeGP	127
12068	2vagCKaLtyajAndp75SmmJdVrLEXFhnoizBYYRbcxAPZZNRFynBm	127
12080	2vbnYQtVKPwpjXWJLsdtErG2omJda9UJbWLB7ZGTSGpgAQCpQCMA	127
12083	2vb6Ca6tXD7QJLFpZYsBenwwS9NxvzHX7K43VNncFF2yZkddM5M3	127
12085	2vb1tqaKC3eASSjcya1eiHvXf9yoonLqWYsKGdCS8shDxtNvLVBH	127
12091	2vasUp4e1ZyXKFySHgr8K3xvF2Tj7W8vggmX69cHfXXVKY4cy1RX	127
12096	2vaNGZY3XvH5EggWQwjifid9Gp91t1paT438oiJbTPwAnhA38HLN	127
12098	2vbxo6AoYFGcmDSFmpaTBYgswZw8yqUx27Mcp1oKLMRfWkTjWB8Q	127
12101	2vbFMGh8std4vHMS4J1q3DhHx3NigCbQAZwmegkg3bcKgXvrk7mw	127
12104	2vadXhTdzCsd85CwBoNv8pk8aCKQvyVgHsPFQqFgtWhTDFeAuaof	127
12108	2vaFsCSpm4TA6B5kMTVGS3BWtfpa3vbWgAZeH7vyQaYg1CkyxQYS	127
12113	2vbvgXzPQk89PpcnGG312LYfurP8Ymuk7rxAX8ihQ6D2h2c2EA6w	127
12120	2vbp9HiwZszuPu2E5iJ7SFUSFPtEGZuayZQvAA9g7N5V7y2SkGBo	127
12125	2vbNX6XbXA6EqnxCdrhkognPzde7g3u4bDUv3vFead5sW2fEyHrL	127
12132	2vbyvrW5XmBHw7xCAiAxo32UgLY2EDTesGeLrp6UYtkgG9EbumwN	127
12134	2vbHESzn5BW2ZsaBtLKaPF6h7tEXBYhsuu8Lu6n2VKHoBippmMQ5	127
12138	2vc58TeT3ts6ARWeAVGW3LydxfUGx8LMsTGvf1v4HpapevuX9N2U	127
12143	2vb2Q48uAuMW6zFfTArGGaah3MBeiSTmC1BoNBCosEhWtuqnTsM7	127
12150	2vaN1MNXfq7DFDHRwootCM3hxmEaif4HWck3YMkbH4Dpx6fsShUp	127
12158	2vaeHZQoVQWmi81Qqx1csAPvXqvtBEFQrWFyvMCbG3Sc6etMmDnf	127
12160	2vaAqQWkTryLdL8JwpvrhdKa7ScVaZH9VrCGAQBcxTpipS1oLxa7	127
12163	2vaLqo9GSxdyBBt32HmLk9QeHnuLkJjWPbeJ1jzDSfAUJCiBhd33	127
12170	2vb5eHQu9zQPb3ZHLJVkbwnBJhJ5eUtJoQ1we3CN9Whfr7MX8sY3	127
12172	2vaN5Lg4etk1NmEyJwdcdBybnjH3BQjSgyRef7q45TuycnpQztEq	127
12175	2vbdJwfJtBHxqg55gWVXqi7uccq8vPxEyzJJNosei7qbk1vbVh38	127
12178	2vc5VjWF7EZGDToAM9J8GoiJ4PknTwhrJk3mkYHXTBuwPmN3qmzK	127
12181	2vbubYJjqBtZpbXocm7JxMckMsjchR4fJRn9PbozzJyDkGG2gjnT	127
11850	2vaRxLxvYkKfbyckrDwK5Lm5y2sTgZvJguLeDNgLv1w19ggsZwmm	127
11852	2vaJiJsRs6RsqzfuqLpLgDMxC44EJ4xx72nMJFsWaZoTEUZLxpuK	127
11854	2vaq2ZNmp6JaKe1FypBfgaTA4f6zg6kDNXK4FPDmhPW8fg2p8iGG	127
11859	2vah5EaS3p4Ydxh8rfnyWcmJhCknQHiKYPYcPmfgLhqHiqAu9pNR	127
11865	2vb4D6dwrzsptwyHHxCcAawWRpasJ1ZhRNrTb9oZbsCUQX4KjSED	127
11872	2vbMqsjcDr4pFrf8bd9yQvMjDuYfCQvxqZSc2v614r2ZGqF6c1cv	127
11874	2vbAMFUWAbFRSsUn1HNto6Ng7RYzG3AtqpHXG9VMY2cvYpTqHFq9	127
11880	2vbBkWSjY6YirG8GZLzb37Dojj9L5HzBz4feTJ4jKdgb27BKNssD	127
11883	2vaDtGaRDsaEJq1FJwZops7SE5sHss7FHFSk86MSHjtvoWLCgaXU	127
11888	2vaL9ZvZt4fxop4WJVy6YaM24B8QhBjmMHZDNn5UkzXAiYFs1XWt	127
11892	2vaNtoCz2NakGq6T4NKNA6uf5Y8wZbVHGXqjR2Y5nYgF728b22x3	127
11893	2vaa8W15WtruK411fkq79fwdnXtvpZciVspy3kYRm3SB7sEiU2ty	127
11896	2vbEWJjbuguFfanf8c477u6N9DthAPPi8kXp6jYBajSVvjsRW3vS	127
11901	2vaLoDdgoo9Y9CaGsdwRJdxSZce1z19BQKTqoLXKejY6R9RSzaFe	127
11906	2vbNnWCkCF6SwMk7oNV5URFPazsNg8ygGwnMmfdbaaaFnCbzfaDg	127
11912	2vbLvCTQTdgLqd3RHMAy4rcXfXKUaPTa3cJgEaEr2umUtzwY9qLQ	127
11917	2vbau4V8gYKXPzMSreQEZ5VKPbpBStjg46vAUZshxgN8ZMht4bGJ	127
11919	2vbWaAeN8MgQvbxMdyoz7U2y8YoMT8iDCvQ1eq5ub51epd7BjZyp	127
11922	2vbjSUTr5sae4FE8NDCzeJxcV3Ron8tMSDC37pmob1zmP1WjDD6n	127
11925	2vbbYM327PRFmqmJtUKUk3AFnGmvZyMAerywHTvCQqToqX1CwZYB	127
11926	2vbPd62PqTHVnDH8ZhdozSDHq8FFqmKtGmuw3ihRp6kG111cU9Jw	127
11929	2vaXzj6KbNZJ7bpLJxH6iLe4A5esu91z6g8asAx23m5WoCd2gT2u	127
11933	2vbPPMJzdNie8EzhADxNxRhTEG3puYhDi3t6mKPB3m4BAESFPVAs	127
11936	2vbYJRjwoFbMWgYXLEJdu7F5Zc9p3hAm3aVo8b7dw4cYcAwdQ6aE	127
11941	2vadmxsVRcCWN82uGtuvGXhkAe3WLEZBeTbmq5wB2H9U4mcxBSbC	127
11943	2vaKCoSouDg9kB4E5cerK2FatGrtHzwfdTaSPAD7orEhXtKxumVP	127
11946	2vaue8mqTMYuXuDZPP8MooF3FtnfmNcpRaC3kbKKK2CWUQtDQxV6	127
11949	2vbxjUEWNAWEcAjXUzjsYzyQmczCsPSFkh6usvJ4nSE8YfvV87Fx	127
11955	2vbs6xnyeqHJqcwWgNFrN135Fbe3mQLZ65JXnabpWUaFX4q1RVXe	127
11958	2vaxWDG7yoo8ByLP4cCy1Hq38X8gthA65qHey53NsPc7PapJiLrg	127
11966	2vbC8U5ySvD2CtrdjqDekBQVTdUPNi8Rek5rhKg9RxrYshxUg7N2	127
11978	2vc4zneoVdj8qnxKx4WC5pjCBZPivP43HwupnFB9MUVcYTQnre5W	127
11986	2vafvrx1GRAtiGkKhJjfB39jW6GRjwyThwn98vubFyAAgg5ZwRj7	127
11989	2vbueBkGh5gSsEKSsHa6B4LxAMd6AEPGzyQwHUZqUi9MZZ3v3eff	127
11993	2vb448naxhAbcnjXLEUg7d1nP4odrJPXLP3aUAJmWY4AW5ej6t1D	127
11995	2vbk4PNSrHbnachMfYHeFoFAhUN4dnH2HiCeFcQAyHRRJnajAnkP	127
12001	2vbqsVfpufs78kcQ1qEEXDT7f8KN5YBgXtbaMsAs24pUWZQkLvoV	127
12010	2vbx1XepqBBe8QnvwPyAnSF4bQyUTyqJCV4Zmos3t2vyYMF9DGry	127
12012	2vbexd2rEKAHwMxogW2KZR3myxXSQZEtf4MKNNf1cpgVo6FGAZmR	127
12018	2vaqnhuEbuh1jc9m5MP8eRwAZiDRKDd1VmEL2qKQJH5YVqAZVMGM	127
12022	2vaeqUaDKJd4Tm7y6JBkHdHcGXdXGFn2b2roJZqHjg6HU6K62QbP	127
12026	2vb6yQzm2V5ePiuo72pNyMaAjWEwNbNqKnAWNWqjvTberGmKsTEG	127
12031	2vbNC6ugFq3bKwpiWRbHy7TCsnpeHeSCkrydnXY2QmmwRoMrc4kf	127
12033	2vaSU6cDdqCBqHfaqznaEuPJmCqfiUEHfMDqQq1vuF1wjzGQCnEh	127
12038	2vbFHN8d2cixzw7CmmYdJBcuibcpomopJd3K6j7zMMzfoEhNdTfG	127
12043	2vb6hHxW6sPxSzBJXPJK27tgZmoYNyTJz4Bwt4BrKPCLpwvnQxV6	127
12048	2vaegVtSv7fA9jncirNYjfBrBv6NN9cyhYPJV98TTMQcaQ2jLEE9	127
12051	2vavRhoeC4F58sioHkmANUHZ9N6xQL5FBMqRF4pmqFuj8FBHZ6wP	127
12053	2vaggJt6FcGJSYzhChQQPsdnrJRXHcFQUgQbvZ7T4HS5QoSJh5Lz	127
12055	2vakxAjnKWW74QSiMzHJPyjFYk2tQphMy8M21zT3HmAhussFwGaa	127
12057	2vbf5nM57Vkhi9xnucwtaNG91RXVj5mrhJBTww6Ksp8ZQe9YAgr4	127
12059	2vaEensJcSdaPcD92a6q9yzXizGU8u8oShqbDayJnN4bwsjGKn9E	127
12064	2vb3dDHZK9oaESok9nEkaGYvq5mLFugtFSk4LCEekVVxPH8Bnn1V	127
12070	2vaa2arg4ezFbVuWymNSpwqQWD9qFzqv2yP4eaDirnW6h5ppD33p	127
12073	2vanZ2J5Y5unHcy6xJF3VqnzkRZ2SZcFzMDmraoDnkppp3U1gBCw	127
12075	2vc1tk21p4HY3TjqQJ4W1aZDtGKbq6paKFoPkP5fjd45GEpVrwLs	127
12087	2vb1vwS5dtXfC4FRn4mTNBb6SQqKQTH96WE9DPCAzV9CGgY9JiJw	127
12088	2vapQP2Sw2KrKpS3UVsBnrQtD7CmTQpDRcUd42VVkXrDDedFnDV2	127
12093	2vbt9D6vsyJUY7SK2TanQZs8iFkmdqnBYUEMR1pZYX4bPga7ARf7	127
12095	2vbLHzZsuSnC3NDtdB4jEbpczU2sMBfSDsrKm6XxGJyAKt8qf4Xf	127
12103	2vb8b7QDzptztqNvUaeKULYsq7Hs2BJqdSraVWT1uw4DzF4jiKoi	127
12105	2vaRFoSRGP4ecQCAojZD2zX6yNVuZo8ENE4gBszW9qtiPiNwkth2	127
12110	2vaCbqUhofNepUBQq3DkFwTxS6m7Nf5oCp4GUWfoRGLhi3KSUkVz	127
12112	2vb1Zr28tYDGRhxW3Rsj4mbRuphRF97GyDqtiqgwtpaRGaGhEZKx	127
12115	2vb7iV3XwK56VWF9xyiwDdJqWXX3UFu5LaYGoy5rBcsHGMgpf4zV	127
12117	2vbYScBgApu47SmgeuSV8EfK4BQcx26GN5LkXAdonHmp3h9foSF7	127
12122	2vaeTNBGy1P55Z48f3iK91BJi9ZKgrJgj4yDHk8LuEJH9h1oHhUh	127
12124	2vbsU5WUxCg1dRXtf4pgs5sWsAuMAyJYn8455LksBM8qcXNHwVwR	127
12127	2vau8pKi6xrm4TNTxeGLzWmgjAVfkzLiywE4EvzufwPmMJ21Nbc4	127
12129	2vbFf4jyjRhhYANXtVGqqHTKwVWCvYnez7f3yW6iyHMFGfL2octY	127
12131	2vb9DM8wnsYQXHDi7YVFQztKwJy29oQjn34ZqZoMSYXcqHMvVLc7	127
12133	2vaSketMfr6jP17aUUcfjAxEfAEo1JsCQL5TL6Qmt5FQuDazkLzu	127
12137	2varUQk5owHytukTrT35xcMoBDQzqjh6sEo1SLkuHNho4aYNBivW	127
12140	2vakCn8DzMBRUNk7Fc1ArmChkRkbMRpm72cPbYEcfshYptxAfp3X	127
12149	2vamjN484MfLpR9aGk7Hn955J1vKuFEmhKj74GAQ2wG3uuk7CVMv	127
12152	2vbxABPDWb6Ppw7kAURWtP3PmcLJYsLrqwrcjQa2CeqCcGi7dHbz	127
12154	2vbz97hRvKZGnU4bQMrcf61RPXNPknHFiH38ymtLTnTFfuAFD3at	127
12157	2vat4HbHnH2ANqrJeoEvS6DVf1WDUGUgtZmwbhy3DHZqKr7AyUde	127
12159	2vbPeARiLqdxLoZapXJvPbW2eASqBKGoTkhvj2umga8ES2FyeH3m	127
12162	2vbyK5XqgkyqvkedjDHerHs8W52FPRqtDvrY7g9TbVsSxuGneRdQ	127
12165	2var1rSxRoTiwMNuSSoWL63mivTuiURogEg2MsEi3nKM3XPMyskk	127
12168	2vbbub4zWBKVWyRKs669anjcnC1zrLFUTWNAhWFHCgjmpX7sPuwj	127
12174	2vbKRgrNA5X6wrKXEdUQsY6jxDoT1piMKCmbtRsLrWDSgGbvRvNn	127
12177	2vc1AharumwH726mA2S5yUFcvj6UqRDM3dLhTDMAZHorD1USKQ82	127
12180	2vbVp4r2N5oRzRd5tKgqGaXCSjB6JvQ52hJN9PtWUyNV98sxAbqL	127
12184	2vaLu43zmL4uhVgdYckCG9NzibQCvAwfjVCaZCod22XaBJjWnbNR	127
12189	2vaLZyM26ThMSkLMAF3sGEtxsve6bzpwP9tUWjpTsj2Sc5qMb88c	127
12195	2vb5NEtvApZSQhZrC2B1zPWqxsMajxpa4Tp1KcAtCQeVefxoDS82	127
12061	2vauJJyTizeEw78wbJ66Q3KgLsT7BmMssrtDwsGc6x53rVe2afXv	127
12063	2vbqCvM4SVcXbL8N5m6YQUCzMGnfuLftboLmGykQUMmwvBTva3mi	127
12067	2vaQLN9eCHxihaTjgUeMeJzuGsgUEu3C49nb3XpsdQN4QdPZ3yCh	127
12072	2vbDDm6N539F4wKJsZyRsYVGJz9Qew7NK9p2KDrK6awxYMEuGf6z	127
12074	2vafwSkCD5zCGRa84rVz7w2VJCTK3p8bnU3yXgR8e13jaWGePAec	127
12077	2vaATD6AzL3VNNjXVuEo3TFKwGFfj9NN2s4vdj25k62oDFTmbgcD	127
12079	2vbu5GzFePdHP5h9xpvYW4aWqZcxrRt1eArqSKQGkwc6ZVTZKdxb	127
12082	2vaeNJCHAfTtvVS2vuikhyc5WY27Jqko2eTrZppRqX5wMk61VWN7	127
12086	2vaBjibdaEZD3AHp9EM383G2QVJtBVRn952Gh5m8SvkAECRPydaa	127
12090	2vai36gyaUajSrJqAz5RcNhnAdceNK9TG2ibEKbzyYBWDGPS2uXp	127
12092	2vaERU4os7vRE6rv1UvRBPuxLxViH6DiHjspKRoHrkF7mq4bQ1DW	127
12097	2vbSCNgqznNUdGMav7wH5USorn8PYeHpQxVJXWZZgrjZDGsXCXH7	127
12100	2vauoAa3Lusfe177bPhyuFSEaEPApiG53ZvcRQfb6GB1q7CWt68o	127
12102	2vaTqP52uMS7eB5aQvTekfukiqynQDpjYCwtWAZ29mWPKmNgt3kF	127
12107	2vbVX1jYcumXuPXn2Wy4aDzFJ1jMSuTkwZGXWnVty9Kk72kUQLa6	127
12114	2vaiXg1cYbUnV3X5E83A7ThF3wimy799zefFnymwsTnH4DLUE9Sy	127
12116	2vbtM6KAHjAuQqe2UQ3ocnC3TSpn5ZccDwkXZVzdxDu1tLJ9Vu9g	127
12119	2vbVDwHqxH5aoUZ4NpVjQm6zbhUMaw29sYUuMfwfPDzaRiHkWcLj	127
12126	2vbdsH6i54yawmGvoLsLV71mSUJUWF5vLewDoz5Vv3REvDmFi6SW	127
12128	2vaQJ2ScMuSh7GufP6c6Yu5nppeT657HohvV4Gid4za5Lg3fVQ1C	127
12130	2vbU8jc7CNPZKzrFbmBHVSkjeBPj3YNvo372S6kLL8TvWJabpXGn	127
12139	2vanWwogsdpYppNn4i2L2Ch362YxXokNXY6SBJr4cBHu7HZn2U36	127
12142	2vc42NUHo9QD1VcNYA9smNUTTF2TGma39pZA5cDkfbSnBT5Y7xRY	127
12145	2vbSqo1ZUSqDhjhSE9LkF4MwGZtg7yXp6jsrmPhQHiFbBBEfDBUm	127
12151	2vbRJbZu4ke7kkMLtBcNpmCHTCopvk2iYZoYmyXzcir1YML34Vi7	127
12161	2vaEGDFgy8uHzK3Bm3utxfCMQk8GUethA4WktYUTbZ5LS7YJBXUS	127
12167	2vbZMNAp11JacEoBksuKAihJFX6XYtXqRf8DhAHr14vjD4PSdQV8	127
12171	2vbg2JqhndeaZue1aYnEZvKVuMHKBwYyh9uP7AsrepMUSktsZCfK	127
12186	2vb5NDAb3DMBHQbLza41V55QwG4xKQYNSAfSWq3UCXw5bcNygsqu	127
12188	2vawmme7nAHn3EB4pTSwcNMBC6gVCkfA1HgLWGNcuR9cNpRNkxBJ	127
12194	2vaJ5k7gc57k56R6Mcfp2qCqzAXTygvfKkeaviWE3dEXgK4WXgU1	127
12200	2vbzg4m4i2FW12DPYX2zv4dJpyXxjq6CQyto6LdxWqT8piqEeKWF	127
12201	2vabo2w7kPf399HGhpbLE6Jv1UxAmxPb7gRAD6devgD8VEpzzwW3	127
12204	2vaF2EPKrHmmGHb227uWQnEsU5YmS1jZpSMAB7VXq6NrgZduUFxQ	127
12206	2vbPpohvqes8x6cQqkyvLT1XQMdaeoPCs3mLw81Y4UB4Wwk3qGC6	127
12208	2vaoJixn5T2FsVQZvPRyHaRQhHSautNdW32M6FaoYUWE1EVc3vEJ	127
12210	2vb2dhY6tyNMb8Eu8cf1nGYngEHeaU2yTqBsdqt1GRBxT14t7vMm	127
12215	2vaWFbsDarXEDL3kvWRN51uPwx4H3vuCURKwBqMsAn7uU1eX8p3V	127
12218	2vacQ1XGQ26KYwbjPgHmY99TPnLpmgS7r5R4wZCANwYQLFhSCWE7	127
12221	2vbzDSGdrEStf5jLUp5xzkLVPZUoitaZvupkQVqDGYUWLrs2xizr	127
12223	2vb55DHRzLaeVQ2CNNQ2kLzJiR5gCDNyKKEz7oUQfJ1QGNvr7REQ	127
12229	2vboNZP7ePNZYqpfCcjDRgzkaaCdEGBDLjFiVvF4GmPdr6PPhSjs	127
12231	2vbiVG72tVCsY5qsedXPGRRS4wwDUr77PavQUtEKo2rfZQXfC8yD	127
12235	2vapjd8oyebe3SAdJSCQWCocahM6JmgzcJ1zEu1cU9bvshqUsYRZ	127
12238	2vapjUULNG2J9sb6eqGaav7eWxgdU7KTvXsRtadbGPbWQUneMsJz	127
12247	2vbtDj2qpZLqB6MetwkzUPnpjDqc4FshAeBovg3unhSXCULVPeys	127
12248	2vbUZa9zYH2uHuozYz9CQ8mqGqeBpSBY5JPJaZMTVn5RiSH1YbhX	127
12250	2vbFxkRmPzggJtKSHfsas9pRkow7wDb6e1DZLr8TZusYDnq1NPJq	127
12253	2vacpQQtjmsqtTRy8rwXdQ9EvBCPz5YsBS22A28iBkdHf7ZGGJmJ	127
12255	2vaSBVhYnivBBc9KQCosYwEqNNbWacbwrJTvFX9oM2EmxL2x52dR	127
12260	2vbYtatGFhhvkMDXiyAZb2WnT7YjqUpxiWVykeRPdUqn9FPnYY1c	127
12265	2vb9mxK24D9WWnd9S1tf3YaGMDfxSxvd1MyCdZQJo8hyMMu5BYo4	127
12267	2vbhzRfAeYtzt5bBydJ2Uk7dF4CZ5HQML2MZDkN5USagzXLJWjE7	127
12270	2vbu6VZvzNxAdDibYwZf3DyVtH3RAVzaBKbFfrAKWm9fv1GNnvvL	127
12274	2vbrQ7pJPrGJiwNryyzHLRznmCJ9g8F6mAZNAsjZ4Mti2HooyecQ	127
12277	2varqhAQoJ3MgiY6gHVW3PL4g7CEA8KcXVwqUZ7Zer9BrwXbQZtT	127
12280	2vaDSDvzPTNNcuquHj4Ur9CspJiLfXCXfLH3eTg1W5egtLGKHT1T	127
12283	2vbbXmwdP1Npdko28wZws8SXCpo1SSY4TkTcgCr6YGyantSYa6oD	127
12287	2vbtcCPhJNv9GEJtcrTMYxtusDrrKQtRZUr2TUkTj4YaXuzCjFuZ	127
12292	2vayRZbU2DHqPGfVNrqmDw49XpeosTZFcJ4pwupuH8YCsRyvCRtn	127
12297	2vbbiudHjWrWU4qEsaiQeotueQniqAmwRiYNpfg3vgLZGG9W1hN7	127
12300	2vaNrDySAXejF8KcfhHCeA6Cu7QBzVFMArMoKjdH5N948ZFRFyP4	127
12302	2vaNXzDRqvWKgkgwrsCqjYrDyL5AXZh7kGQ9yd3PnSKSmHYjSz1s	127
12310	2vbPwBz9WS1kPFtuv1BVUNzWQhqPxpS1eymmM9nmjKh53h16LxX5	127
12320	2vak8NhoeKQAa427kwTGM1go8VucWt6Z1AbDmhXwRUqCwRsJbzoC	127
12322	2vbUEy1gpcdELMk5ayy7zNFt96fqAFkT1KU28hnKDadgLkArCGNB	127
12325	2vaj9iq66notFLg9ssZ3rRAGojSCLVPjb4eMhEQzE6ALcmDHbwu3	127
12326	2vbRRMiw2nrsAmJAUkS1QBk21opZpc2MMDBpWUs17BZ7ReqHWc1S	127
12329	2vb3ncNP4Gu4AAJq3VR84MBTtnsUsHzdGemrSv5L9YPfzWFJPpfu	127
12332	2vaCkURDxhFxzyiQiMVHorzgjcZ4gwLc96fQbKmJPCEUhDVBN2Pz	127
12334	2vb5hG9KxcS5iL8uyKEnETifFqAb7AKpYgtvEe2eJqEdzGMGYPjL	127
12337	2vbEfZwqrQsUvpoi5nsmH1dXfUSZaSsHW36Y6fYvdVYACcTNYWGu	127
12345	2vaKFV1qFLd7EaZrNWqfMsSGfh26BcB6TdXKvmVBFiXKG9yY5c4m	127
12347	2vaYGQxe1Qzcj3yCRjbo7L3zBLEWeAir3BKY1CiM6q75rvo1ySaP	127
12352	2vayGQQntv1fskMwohLFabRbGLTPwJcyV84ERCijff1hmkfMtcEa	127
12354	2vbUQZ3Ri5QvnZfA1oxLhMHQCagqz8YEuvp5HCUnr6rS66nB4NNT	127
12356	2vbJ1TVHCzPiJ4k7wZuK6vapovuSMr7mjMjCPfkq2uxNEsnMNgYJ	127
12358	2vbAydYsKZg7eozN8DvT4vnABa2vDStgg4MbfV3FxHGi2SmReEKe	127
12361	2vaBRG2vDvYfwm9sG3mD5Qsnn5BQz99emAZ6ffcQ3MZn8b5RxjAb	127
12364	2vbEmCC7871XWZxswb3NnvNYAF31k2cPTug4Pgw9dKbJVmrnyCUz	127
12369	2vc1XDC9jMtYtZaAMr8hsE4vCPgmZ2aTy4DzVH5acH6Sc4AXxEKv	127
12371	2vc3Bppk3GaXsSXp87zX93PHfMsewB2W9ReUraqWdup1RBfLpeyG	127
12376	2vaxwAsqmFuremfAKSM2T8Vq6heQCPW9dyWe4GiqCav1nvPsmeij	127
12378	2vbPghQ2vzV3HuVm63cs4ifSEidLdVYT3ndbu3UD9vgnP763nePC	127
12383	2vaVKuGjKFHqbqDzMUxYRUtM1kHZgjDp2RvTnehYWNdaYZdoZknc	127
12389	2vayVyYij4AX8fE52mxwmaEqY85rdq2wGmsJ2DHLUCddARcRRVe6	127
12394	2vc2u3bXNKyWWkJ5cSQRFZtyuntwMr4NhQkM9YdvKpTVXcXy3g2G	127
12397	2vbZMmM1gpuXbsAiEaZ73SLKoDkTDxZx5UpBnkvDQN3YcpBfntni	127
12106	2vaJEX5YoDTPU6X32gnfx9411NRaqVJoFcij2zZfVHCmzHZTTbVm	127
12109	2vaLa9gDQBjG79kMLMz3jKWvuZGUmcnXXb7tSHC1Wp5ow2w8Hoj2	127
12111	2vaimrbehnscUwAdkNRdb3cFAs9ykd6Zo88b7PM6ADabMrpA6APz	127
12118	2vaS3k4K88J6p5dh1zEDZStZiVwU9ode9qXyByZXAHFt27u7WoqU	127
12121	2vbts78TLoZ2rY7Uq2awPybeBSH3T4Xz1HYq1S5VCTRongnVv6qv	127
12123	2vaZCMHx5kdNrRTHAFDTjiXw1ean7xNUtwvs22Tsprm3YdF1nuUt	127
12135	2vay5Bd2xGJqjk8Zbn2BSnU3d6PsmdQFqNTEfVUZ39VKBiTm7exj	127
12136	2vbDydRJJfXaCc9hRHy72sk6UYtU6tGhEWusMEzjusvCadD6X4Fs	127
12141	2vajpBdMdiQXHwVF35tSVffGnGWQVchPwZE8Hm443cGqjTwNTa8y	127
12144	2vbQZkwWX5dXaHgGw8yhZfS2YSb3mdpP2asZicPsqxZ81wgqq7Mx	127
12146	2vbo1ZEoxKZ4fsHY9VhjPuacZ59f8HvsmBTR74obgv9ewt4hwvcn	127
12147	2vaLokZQp59x9iVYUaUp2H7gfhXSockZ5ejddyUDkvkPDHV5Fkz6	127
12148	2vb2N2VB7UBfhgGcgF3ptVswr59APpdMsx5picW5EtfXkmvEWiE6	127
12153	2vaiD3QHsHMMuodqMxzmJiDb2iRBX9w6bCZGpNPyaeVUKLzve5pF	127
12155	2vbKB9sKjFDwSv6MoD6NpQEvcAseJmxNq52hL9tHRg5MvkN8j2Bn	127
12156	2vb2XijCwQwmVfYnZQ6FALroRdubTvNy6WS2GRzvgPBWM7NadLNu	127
12164	2vaBmJU2AU6nUS7hy289vK15iwSGR3kiujgP6YXnyXuHFB6NpA1s	127
12166	2vaDbQgJiJCXk6cqKkqiNwLjmyA2XZtdswV6B9Emw4gG7gsKKNPG	127
12169	2vadkS4efENyxsVVmd9H9wxa5CkYa9u7P4Sq21hbAFDBhqSP8zJc	127
12173	2vaMGwfXVxaNU4AXEYA7ANyzPsFDAJeAbop3GeEThovdCsfyEeaH	127
12176	2vbwXCzw5FhPbe2r6yBNxwRf8ihePBtdp2NUP2pZkGvxxLvm8nJi	127
12179	2vbjxdFVt37P6KRTWANjXXBmB38AJwAWnfEK28s5FiSi8vVbMzgz	127
12182	2vaxcQbE3yGYus8vX2tkHGd9o1SPhPsyjt9CNZPTJxFNpmAipDGr	127
12183	2vac1ZyX6KPLYrPeUayw49zgaK75PPk1TW5JaSP6M3qMV4jqpgEC	127
12190	2vbiAYADrMMVMmRLARCS2mdhQ9TXGyiqXRfLfKunQFd4Xi2SviE4	127
12192	2vbLtX9vqPRVTe4exy369mMzdP86cyMeBU7yB94FNV7SLSbrQcwy	127
12193	2varnYBHKyYxmqwjH98kdFdUPiprQYWjtD74meq8rTcD7hLY8eFU	127
12197	2vadrMDyEFWZeR7WxaVM3XAfAkxJkUHtTANUGsYX21DFZ5MRuLMc	127
12203	2vagWFVEWmQg2s7zULvxYGoFGSjVtNwNeMXhANuXSPHwrJrHRbVm	127
12207	2vaBD29cb6BWuA2y13SFaTiLMfH76MdPxHCRcUXs46LmFoxFiPKz	127
12212	2vb89Bi4bh6w27mtJcwEAZ7oNnaFww1zWCHtrVwyFMjZVfNVoHKS	127
12217	2varsuw8ML8p5XqbS1NA415ZbJd64rsw11kP5xb9Zzo7WHUsKvT6	127
12220	2vbyBxjUsFboFQacQeAs6JGAXBPbkdh3ohQN13cc339xwxZnFpHm	127
12224	2vaGtQQzZt2oJrNNkUxXHCdisnsXYmRLmdTGVYPvCZtqvyvk8QmK	127
12233	2vbMpzHzgqEdvCDX2mFoQWXuHzix7fidtZdFioidXjJmn4dEwHSq	127
12234	2vbEYyEp3hzZq2aLBnxmJ6aTzMtdoZxLc29FYnXvhaRwoiMB9SwB	127
12237	2vaDpXCfCni4Q5hJggXBU6gPFLwLRDidrTLqjMrLpfbjkoCNn58F	127
12240	2vbKtgbUx6zBYdcuNdhQXWZodYSSMm2D91e5gQMjMptcDNjrYwvW	127
12242	2vbtqnhn5Jfu42zte5VgQeykes4nnzAyRgk3kQNhjprq2zyoiAP4	127
12246	2vaGkbs96gRaw8i4obxszNWBbwnkRTG5y2qW2pk8yhY5PVbWjbdm	127
12252	2vafW6coiJVE1oZDzRR4WVRDvZuo9kL3vKFSRB9wp71g1cWcsTUo	127
12257	2vbaYLiGwFgGLipd4bsmysVZYdWDBz5ii8CvCUKMBgPei8WKZf1V	127
12259	2vbvsnPDhUwBktr46iTZb1emKT132zeMhTCCGQt7Rw6tZyVDMDSa	127
12262	2vc3jFAzw4eNhHC9hDSfgAZkx43ZfkmMJFvc1UfruBPkRaNcJ9pq	127
12264	2vbu34wqEEbVZ7bKqPCS7gqomJ3KEPk127iLMoHeSReA3FbtfmYP	127
12266	2vaubagogWt5ifpoPoU8W718nNuQ8GPUQUHLLsr1g2KBkRSbBSfz	127
12269	2vbzU3GzQTSPfnAd4HC5fqAyaaTNsHjQdfMBkJqCAChBYb2AQFRw	127
12273	2vbqof87TRyfpyo86ZFyQRxug9izRMrFyvJVjuRVuHNqYa97ztx1	127
12276	2vbUUbHpGdpYT7ZvAdyaXhQhBJuK4XYg74he3LDg9dyxnbrzybHS	127
12282	2vbnTnysA77Jdixf3pwi8agi9h8reYR5rwSrZnKyNrApJhTPLAoL	127
12285	2vb7ZxTpHHVYQmhLwZ6t5Pb8kWRSWqoizus7mX7v2NfhyPeKJ6xm	127
12289	2vbDRow7538FFPNhV1y8K5JjEMb7P73BaSzwofZQhLdpHoXqRmNk	127
12294	2vaC62X2TnMbvqWYvP2PhK921xNbnDar92gZiD8xNp7ebKDQemEy	127
12299	2vaBbC2nCSJngEmSbVCGDXjEBstLjsFtEPQRZnLi2VwdQwGaCkDg	127
12309	2vbDXz7pMpktSd7Xbp4Ri2LFATZqDQTcFyLgocpDiPu1cHKusVLE	127
12313	2vaW1QfRxr1vMpHYVsjG6VtCrj6pxNDDjPjt7d1bwMaDcBhGJceC	127
12315	2vaQtgGrvvwpxtvAkohGGndK2ABuM5FxLp64QaVb1M3CHpV9ecyT	127
12318	2vaWPtvUuLZ3FAJ6AYaBzzff5DCTALWZn37eaCQLwQctHPRqwakK	127
12319	2vbNAJx7WK53EoEQDSgPr452b6PRM1UNjNraip3xFCXNLxUYhvoY	127
12324	2vafB7HWNDv8Qu5DpJxjTgvdRAPqymDLY9LFpfzavfXfeQpvFKV7	127
12333	2vbjhnwZVEZw61i7EV927dFHxnuR7cPFQhBH8iC7vfsQZ8Tcmr9b	127
12336	2vaczyd2fmWCT7m7LtMeZbavdyB8Ya6hZ8fEdJ2VDHR6djxbAv2Q	127
12341	2vafKqXK56gMan9wUshWwUSBxvCmz5Rq6kFQufPDUaRVt7fa7wbZ	127
12344	2vaTrBgWpH4X1beEEVwAXGTEDZjkCVR2XXGpL14ehgJc9STe6CHq	127
12346	2vascPNX8dnfSMWYKJcPezf5JjSKnVmAnNJiMZUVSF5MvYuL5n46	127
12349	2vamWCFeKvj9u6K4MH1LhWZMyCAXsmVSVcybFmrKzDMiB9RWGpQr	127
12351	2vbHpzB9TPXLfSgaiDjqAEc436F5v12BfbAWt1DbmWg8MCSQDN1K	127
12360	2vamCWQut4J4kTQX5qMapnT53JKNd5QzWGFjKmh2rf1NR8GgfY9j	127
12363	2vb996BdEq4YoZD1r9cNdt8BnJkZyWvkzMsqP2ddbjEFqTUKsGWZ	127
12365	2vbzn7E2XVkmNM473bH6Se31aDJvPhCSpuFMPK4ZWyqgtLGiNTRe	127
12367	2vbUmsM3tung93KLuB2fET5qKF6iLGohDwC6e7Lb7kngQcoFJZ2J	127
12368	2vc1HVCrYEP7cBZh12WVfvqM7TWkVoeGZZxcxHpqP41NwCQiFPm8	127
12373	2vbMvYL9ZA1sA54pq2UkVRyNL3ntrk2eByjC9cDZifDwEXijuGBP	127
12380	2vam4X3pJcrLjehjHxNryyZsDmzZZUemKa59cDQiNYMUQicZ4zQj	127
12385	2va9FVNNzJcZx58UqBd4TTBrJnkWKEPsoiDCXYxniBHt1wbRnKWq	127
12390	2vaUV64PCGqDmuBWcCP3zPCBGtTiFkLBB4rBoWbseDLV4Xqtq1Gd	127
12393	2vbi8C2ThX4WaTmPYzwXYYbBR6e8pK7MU6Ur2HH6vBtFBqBvgtAC	127
12396	2vaD1r8ppust4R9isWQVk6koAwoDRjKAKvCB5NZL7uL6mKLaZdcb	127
12398	2vb13X3Dcc6RByscxT2ds2MeMgyQL4ue5xRhu74btwTXCTqmoZSm	127
12401	2vaXCWNA1kvNRdxAQfgxRZAxxCLVesHP6Jhs39WoMk9JNab7Zxz9	127
12403	2vbyvitcE1QcWNAHkH6ry4Wzvx2FkrMhQFhG1eAWPo3AfahxJdwG	127
12406	2vabznG3LKRdNG3Vh3gxfTMW8YNEmvyJ5jLRw1xWWfB35m4FtBzv	127
12412	2vbXx3q8oEDA2vyZun4iJhCYQ7HJ7BWU7WPyHrqPhPm5AfsGtLG3	127
12414	2vazb5Tw5oQPh8hH5mbfUgPCHKLb5YcLtYmVUW9vKJNvf7qfp7Xu	127
12420	2vbBuuxRvsaBKAAjbodpXMhZKnpL8PBpZ3SYJjEK76NTsoCNANNw	127
12422	2vbZZDxDnR8mWy9sqG6HsTD6pHHRRExU1eQ5BpEGwuv8KuXTsaJX	127
12428	2vbirjpFuuhv6hjbJ8umzXZ1G22vBTneboGLdbWB8QxxPLZNSPqj	127
12435	2vatXA6kp1B4yTZh8pCJ4Jx1GuSiR2mDYgu4js88kpkn528BxrCD	127
12185	2vaHN21JNXsxWhkHDytivw1kVCwFdvyUkxCvgTVi1TSaRHSMV6Y3	127
12187	2vaW2uuabcMT8Hw3RQDoWMQcWK11SE7xxg7H35QzC4wRYsWy92W4	127
12191	2vbjjKABfiwrSZRrtc5L1nTtUtmkdgWtghkusbJKr2Rjx522pzES	127
12196	2vbVFJMLyWyuKsioSbh3xzBsxpbJT1L2P6sYGGLp8sq5p8okiPo9	127
12199	2vbuo5s91q2MmmG5uTzKBdJSrpiMqMuC779DWPDVQC1aqyBPcMF5	127
12202	2vbiH7rb4LVDmh6LWo7TdAexFuvnoxY5jFTaVFNG8roVXrvfuzHb	127
12205	2vb59cR3u867h7ESLvav17bnA8nyqQV1VgytCVm8h2xWou8XjUXk	127
12209	2vbT7GDPrvGqrjP6obsJmXRoEnf2VigqYmJXNDVUK5kV2tENx3As	127
12211	2vaMCrPfGR7W6PhLs7jzEqpzr8oHaM6jR9GsVPX9JrkREzLY9542	127
12214	2vb7fWt4qb6wmD7YJaE57WoyckXeV76wDUfWKY8CfrWnv4bxB3D7	127
12219	2vaCUy55VvGWZYLJX9PCW1WvFbvs7ryNwaQKCXmU2FbUsut9vqKJ	127
12222	2vbZLrLrhpuWizEyH5zNn9j7coxnHbLp2hcFgDHJTeZuojTfr8Wo	127
12226	2vb3suoHGnJvEVCCeDhZVeFtzrxaoWgyUjADJTi3tRMwqPpAyQWH	127
12228	2vaH1CnCAb7BywwxoeQ3nQ98Ct1ZeR25NWWWmLy6g6snkr9zRZDy	127
12230	2vbXTaU5W683agwuPf6W1Tteukp7tU6BdabWC4DKFsK4gK9Su1AX	127
12236	2vaDAyTjQsvCt4uZ9gDKTvzLVCCpFgPbZXZpnfbXyBmeqmVfb5FV	127
12239	2vbsZ9ZdZABd87xnwGqTrqa3ftNByvpNhxEV3qPdbLF1tZMFkUFa	127
12244	2vbr5Ky5Za1a2ZSR1uujzGZJLQbCNdGiaJbK4kCnqPDysRzs4Wpx	127
12254	2vadE56QoG9PmgzQvkLLcYvBm3aeoqNmpCvJCJYFh1Vx4NPhUPgk	127
12261	2vam2VcUwGbRZioSk8G6EgmBwhRFzRJB6dPkAVjA86zcfqSpQuE6	127
12271	2vapk7A8UjcqPqr2frWUtATgWAKDQR7YKRSYYidxWjiVP9294Shu	127
12279	2vbvFRFvugwVeDUH6LsdGVwHaS2HNSgJ97p1DetEoHzKufPXbeRJ	127
12284	2vbQjtXUi8fdRsxsH57m8f6NtMHSL8eTNM3UmMSR3vw4P6ajXBE4	127
12291	2vbsAP6xew5SfnNM1UXRcpvhJKbcidjUS1Rq3aiMf7MQe66usS4o	127
12293	2vaCawo26CT1qnhVbuTESWuHfSYgJ3sti3NxF86UQdN6dH417wtH	127
12296	2vbsZ4Pn6HKmtKxTGz67grbhKJyVjMtM9NvKp6Qn6nUvfSf6Tk5U	127
12304	2vbb6urBgMy1fsZ3KyhJf3W51TdE1zwW7ZGHj2yRPRojiJ8SThrS	127
12306	2vbrTpN2f5DAa4fU6jAxjTbFBz8AB2NpiL9p44LU4GJqH1NBifxp	127
12308	2vajfn8c1qdDHvXSpGq4TBHh4X1V76DLgZRBaxPcRahJ1i4AMx9t	127
12312	2vbCuYLtN14vkTGtWPqjmaXh2fPtgr48rE7YarHMEFAqRQoxY2KM	127
12317	2vbCV3AT78t2k7xMdnErD2yScNGV7drZbKsrk6axTAxbbucoqyu2	127
12321	2vbrtztxjkVXBe9ivLQW1E4M7p4cMKv3CuWCozsAcxmxxkywsLfu	127
12328	2vbKPy87p64UMTknxLaRkF9sFvqYB8jfR89Gsk5Z3z6skDPc9ScU	127
12331	2vbiFnz3hW8b3RWvNbst87jVU8F26S8EN7dSU6cX9MWPxiUtt8ek	127
12335	2vaPSdQn6mFrcybGZ6KK9985vM2sJqPJ6JM8nLMk7V2w5ty5u3zi	127
12338	2vb6r8vfcjD5yAipG7d4gzct4LGmf6sgtANutUxAdKmheMhWsFS6	127
12340	2vb7isW1tKk3DjWJgqnfBDNZ1rAhZtujdphzLqTzX71iKGSqCJ3w	127
12343	2vaDMdaDwaWxUo2hKmCGnoqzZv3x6vE22rsNtQpVTRexY7HDuHxq	127
12348	2vaKGckdtm7kT1CX9sm96eoSQoC9FpuCjdeRQ49ohyKq1PeFfFa8	127
12353	2vbTSszxMKiv6rsZKTp2CQM6Y2hKEmzgy3rNwDZukYB4SDTE2RUY	127
12362	2vbi6sQoTLQpusjx9ZyysoBXBTg7QG7cAs9oZGVLfjPw71CwbwYW	127
12370	2vbd7a6J1m6F6uS1M7Z8bfiQ1M8SwuLttPYhH7xGY4JypPQeaNNQ	127
12375	2vbgPHT2t9PJQxrtwhxVqFmBp5JFnjS2k5pfiUiyF8JEJUKc455W	127
12379	2vbxRqghfJ1729hPR26P7P5TmchFBYvRhVsJyY5menQPWyHwZ5Yy	127
12382	2vbbUcbCJuoD26YD5bVDycLCkKzQeUAyqRL4R4HpLmmQphvr43yf	127
12387	2vaVxUfwc65GmhfjLGwByNxXtw1mcyqsNnQxge9HRkVRNvX5JUuR	127
12388	2vaV3A9S1wej5oVy49D1Wot72hpM8LXMojrpAVLW8HZTSxv7EzE1	127
12392	2vaBZFLwdyUVAjrTXW1ZguufbJDfqL3gySY7DVA19yUK7ZFrNNyf	127
12395	2vaKdz77GQhjQ49wSwU9Xuk4E4FTbdNkndrPgLTwuLvfDFrmQ515	127
12405	2vbwgqJkn6uaNh5FKzcg8C2Bokx3etAsV29uetyHugu4RNBDGcWD	127
12408	2vaUQCBLo63yNUwKzpbUGZX8C38JQohcDQ93ftyVrS7S5hLRr2sf	127
12410	2vbTj96HhAS9isT4HbS9N99wt9cRzzgjeyTxvVtFoWDtks9uB21Z	127
12419	2vbU3Z9ZtVqagT93eWy6FngWcinpyt9TNv96kTbL3WnVbzAsiDCP	127
12421	2vayfm93MZyhryaDDjsuLQeDFbKFxMCpAifkpSYnu94fkW5Sq9uD	127
12424	2vah89unBXnCQyNxwg35JkBNGqofPbeJZbR1CKzbjGGZmuj2DvtK	127
12425	2vbbJtTnYfB5pcE4JQnZyAzmBorV3Xd8jBffX6rHAHCSPBB5qMoz	127
12426	2vbQfMCN9XWAzpsZxgtvKE63a2MZgwz1KwJ58jcZgQgMfzvEdwqj	127
12427	2vbaMWmhSNHKVLY9achdYKMxs8LCpWXYak73YQ1y8tZRYr62JnaX	127
12432	2vbMVeiZBTTWZ16JAVQr3cQZcfhbYpsbMKu3JxNUebx8JRRxbFgX	127
12438	2vbvBPuamFv6nJiXZSsLF5gefUV2F3WWfRheDTZXxK2kUKi4fVWa	127
12443	2vbpepToAraxTyKi1r1B6ep8iZPvPnWqQAP2a9QykLX17UzwGWUc	127
12446	2vbEMrvaVhCPKfS1cMzFfaXXkEx2MXDxbPuiHmDqfkj7P1N145Xq	127
12448	2vad2ADCtYi1G1X24rN1aAJwMR9a7Cs6KcHcKcwgYUCSQx99bgkX	127
12457	2vbPtDPY7DjGYt7mWEGiAHv7PB5aqzk4E13fiMBZbfMiuVUMk523	127
12460	2vatrkngPRvobPUFVeCAAKGUmHpuSfX553kSoKXRdYtLxAcxiDRQ	127
12466	2vaNV19qK7qV62D3bVhJYtq4PQMN6PCSiNVrNB6nzYFvrxTXXhkU	359
12469	2vbWAYKKXeGoQXkZXN64zS5hLYujqabow86p31hqxsLJ8NH7djWZ	359
12473	2vaaCKVei3JoZSPuzTyNTYg7EmfE9nzFMYgZ1wRbwf9hfHrKMTRq	359
12475	2vaQyKbV5EHGrBV3JxtV3bSpnAcdQXNRPySTC8omCsjjH1XHzRMc	359
12480	2vadcrv9arqC6mmBKsxYPfkeCm7TxEFBjXEgxfTkso178KYroEBr	359
12484	2va9tS3TqF2ZjM4TbYkudU14NHhWZzJisgV31Cbx4Ws5cPxFkBsx	359
12488	2vau8ToydEgvdTLME33HvsjMH3SPdHE3izjkkS7H45BHD3vS2xSg	359
12491	2vaw3PW1jEBYHBpyXJqTcKzLamFjsLocYcAQHh9cAKeFi88wfGSC	359
12493	2vbXBZuWbuC8MKkvrLM6fndR5kUbd3ukFnc8bBbKDU4jfRpuQvoD	359
12496	2vbrZ6Z6r3YEvCXeXgiS9k1w4XsugWwp9nqVDux5Z6HacWcVAEm5	359
12499	2vbyFDTqbZxdZ2TWhW2jnb3kwX6GK7e1SGzPTTsMj8wBqYBhMVBB	359
12504	2vaL9bdqzat6R3wB9J4Mrer4sy1CLi4P8bkDh1in3HnrY3bT5X4s	359
12507	2vb2MW31aaPZ4SiEW2EHYAL66zuBCgrVPSSXsJZKh9hhEbBnNy7d	359
12510	2vbdujRu6u9KEResGvjUH8J1TdgeRgWJE13NvT311aAByBdAwphS	359
12512	2vbRUqdFNi7iTfcNni3JLhs1R3AoBqfd7TAcnieE6uPRgLuSjPzy	359
12515	2vaktYEZd8NXhdHJfGDd7jvpfUzdmN31sCfVfPhgij1SAihVC6Ly	359
12518	2vbzvWtmKxEVZdikhvYGRQp5AXgecE63xBpYrmfGZ9MUbnMU3nZr	359
12198	2vbnNatDHVKJgNP6W81yfevbPpmTkWizbobrVCiLmQw4mw4EpZim	127
12213	2vak4kSdVqEmztFm2VSyFxbET41wrMPjRRrV24npRnfpuTvgGeq5	127
12216	2vb92oqfajuNdRNeWSGHkxj55xHY6Cv32ntxFpxRL1xkcGZA8sqd	127
12225	2vbFJEujju5Py9idk4hAdmdHikkivHiMC8S9VwqZg8DxqrNHyPqe	127
12227	2vautDndtdvDjoyQbMddphdgk3mB9vP8YJX7DoXWmXXisBp7QvBQ	127
12232	2vaGydvz848saWVXV1UQBcs36hxtkDUbXZsLDCM3y474PKU6NpXX	127
12241	2vbgdzDmDqfYDtqvqj2PmXVNGAusYxfdbcNxychSio2pjBrAHC2y	127
12243	2vaqfj1gLc8fijHrA6gtmvsq3WY6o2wi571Y6FvQ1Af7Jc612UNQ	127
12245	2vaunn6Za3VNF7bdHg3BRB3h3BL3ikEzMSWYGzhd9AX8sGQLWg4Q	127
12249	2vauyZx5GwDAphTd6Yu5jrhwDfq337jt2EwFbf4FB44JmhTDaG5H	127
12251	2vaqsY1dtura2C9fxS12yRRa59eifGCwShUPejF7rhParUjTpadq	127
12256	2vanUMZL1Pf3moRAhw82vch9npJ1h4XYUh8wAHSWj3k5iw81jUKN	127
12258	2vaMWu9JTDh2rT5iTj9Uw2qPDw5FYgcNNzUbvUcX8Q1oJbYn8bgs	127
12263	2vaxVYvRJ5LZ38w7ym9zSRhU3mqaKayZ6L13Te1eMA8rC1Zhqnp2	127
12268	2vc4G4ye3tHF8CQ3PqKr45SBvTVQUPL4h4N9VFpRCCYZRdhGE4Tk	127
12272	2vbv8zRAhVxDNEGDpHS3gdwksWoKNUekvHMWKi7xYb3jfKK47Dq2	127
12275	2vaQJE3ub9gnUoqhWaNctvJ9edRziTZfaQ5YB7jSU11uV6CmTQ2z	127
12278	2vbMQbyC5mhyLCiQVxJq863wrZKWAg7JHEJfp98j3AxBCRe3GRgJ	127
12281	2vau6dkbcw9BXACrnVEGJx9WM1XqWcZfnEB5rpprCwTos6cSLMfZ	127
12286	2vb7N9t88oArtUFoc4CGtyXpBR9DNSVw5NQPtRBJoYtdEufaefcW	127
12288	2vbjBWV7CHbcrcswS7PAdWcJBfmAtSw1mFxe2W4nJgRpMkWgS2Kh	127
12290	2vbPuEn3ET5fZ82r2aRrT88tBoni2LMwaSwr5h9NUT3iFBBEdGLt	127
12295	2vb3pXnWdoDe3Dntkmj22JMeG1pQYGPxhvnA8HScDuHDKoFVjrN8	127
12298	2vbNsfZiY6NXAzHwrFTdYNadGMx6W98DLX1enZbgwpXUyFsKunMD	127
12301	2vaGQfV64Pw96iDP8wWbsiDiWmGtDnRgPrCJ5LJykZD4j426ECe2	127
12303	2vbt7s4txPcehpLZBHutXSxGUf6ZjuEMbD7XAMLUVNE72apSEpvT	127
12305	2vbdCZs8YDH22XxWjJ8aHvRu7oWsYgtmcyGsGWgoSNN3tu19j3t4	127
12307	2vab3RXFXnRfjH2mRxGukjB6qyqEBfDyCgFR19vmn1AX8Vmv4d8w	127
12311	2vaXToTfMgCRDjYeVmcLrPGYEfhZLXhHvY4KCEjpz3anH33v7B87	127
12314	2vb7E9an7DPrJckSvBSddcpr2hx9ZV3Wh82f2DGhiAxbKcWqGpJR	127
12316	2vaLswcZ2BdnbAEqnsRwV2uUktH1kEyUX2m8Y4Vm1MczyK1hcKJT	127
12323	2va9Ru8o1MHuD26VetHSGbgz2jEJvnVN1HHmn5HJBZHBWqD7G5dT	127
12327	2vaTCMQiGRjdQtwdpBxX6KAKTXB2ehFebDJJaV2QAZn57Bn6Ncsg	127
12330	2vamjJ8RP1hVAK4gSAZaA41jWspdxUVYqvcB65ygAtFPWJJjQeFY	127
12339	2vaDq99ggHuQ6zbvyBWDjudyPXmH88w756TD9u3fjnYYWUWGPiBd	127
12342	2vavsmjirXNBt4jKN5tqWPyhEHZFxMrK9sBRnqeHUXkZqDrySazH	127
12350	2vaTwisQ9WUu6nUShG9LVry62nmSLGJJxLbusoEkj5mkCcCuNjaE	127
12355	2vauRJ74BtTmvC4frbGkX9EaTgQ8UvapnsLtwK24QQWQzMz8s2zw	127
12357	2vbMd2J5wG5uzUZGShcEsSaE2ScPuW3V2niZxXQo9cYkS9J6Bxbu	127
12359	2vbJ5UCg25mLGJpWAGWTWQMcPR9B2TdATay7K8986cBeHbqv1x7F	127
12366	2vbUTyeV21hyc5ZKithkiQ5jPTLm8B5ZBQikHL9SdqDNZ9hWEW1y	127
12372	2vbSQ211f1sPa6TYBP3VC3TGbBfo3MrSQVh4QzXjm3bkaruZc4ij	127
12374	2vb8uTmFvs4vYWSmKMap8KpMyxEeFEvRC3W4sf2wqoYDEMgFyo1L	127
12377	2vbwUhH6JEQM9UcpStb5ooAiSXipNSk7kiAwqFnn35X6EcB5xSmg	127
12381	2vbz6tjwb7NUdoBM6xnFGUFAnqmcdRLsAPsY1rcHC2pgh8cmFw5Y	127
12384	2vbTRGCBo3YBubma1DH7gwdLzVVuxdZqRXifYoXz6eSQ4hoYXdUg	127
12386	2vavA6AwgTwGs8LhE466Yw7H7AdsS3hbmYuzEWrFvrftG9Cfyvxh	127
12391	2vaKTKWbU8nTh2rVkeXTPU8DrJAKptMpUt894tsUtdb8Aw6n6H5W	127
12400	2vb1wEPhhqnuBoEon3DQXWwDACro4rpqQ9auRbwp9o34CFBnt3mn	127
12402	2vbZa9ugpbPm9We1fMAHtcnQccsDqCLvh7PpWgbUTgoN7qFj9sJq	127
12404	2vbBqQLAwtcgZYESMPcUcGrvLyDzJEjaMQvAvuzk1rkYkxtd8cJ1	127
12407	2vavNktX4HCwJf7oe4GSRDawUNM8kfxgKoHGSCyh5bXNE8Dendv6	127
12413	2vbBgojjTsK4ZYfAdNJQ8dqXprfcZhwwBCqfTcZQizHpsezHhGME	127
12415	2vbg4nkw8975huMcumvZF7A8NbSzcqx6vaNhgaMnEPz1yfnaHsEG	127
12417	2vbQviBjm3DEqhEC5XZ2t2V6BPoZRvowVn8CkvFQHnGBEiC1C5ZQ	127
12423	2vaWuiEQjD3FtUZ5BynGHCkvsnP9QHf5Ughsqbe52ZX13kzjVn2h	127
12429	2vaqngDtSGy9UEiWa8brx2tmsfqydfRk6gPEoBPrj56duCc6v854	127
12430	2vbN5QryB6aAnjyVs2UEZxTrHgfauuivzYtUFdtz68GEttuafR3p	127
12431	2vanEaEJeshkL4VSP32QL312wdKU8GbyqMj694wKoFno1CoPMcx9	127
12434	2vaxqpkXfo2QUe1SeW3qKxD4QvtnaVQWETNY1rswaKPJMBQx5DqM	127
12437	2vbAtuXtW6y8suE9PQNj4v92syoiavS2yFgm15iCRr8Mi719i5ci	127
12440	2vbWARNvV7EjWJAcaQUWC3spVmkrCRcG2RuzX9RYmnVK2yaVE5Ue	127
12445	2vbyb4WUP18XKQDmM7GaAwWLpwchCdMH5sYabzKTLDGABrBEK3Cj	127
12451	2vayN21oWp8XYtpZAr37gv8rB9F7YgznuDh6ZRXf6FqKwcAPKDQe	127
12452	2vbtqyRhwwht9jtsqywbk5CiTA6FUE9RGzRWxoUaZvN4rowurCfy	127
12456	2vaPFBHh5x7J15JMBfMXTY68GanyMtaNRVkctvV9HuG1DK8SCBcz	127
12459	2vbm862pkbt3s5gJYvK33ehk61cVWYc84rZ3PwPwZ5hvSEf1pr4t	127
12463	2vaa9Qq8ks7Kv2BhVV5JdsV2d8XN34cJGfCohWMfgJuLtuJaWvJW	127
12465	2vaZhTD444F7y6Sp4rtx1q5hSU2o27b5t2crjb6yEAxwA8fsgKeW	359
12468	2vbnNjvnA4jYT6YJG3J4FQsjpUknAj9TCG9X65KGUxMzDY9cBfJU	359
12472	2vbvNsmD8qReFgmyY5Tf6SzCUMRZL1ZyGwxvneZhr8inzQd24kFV	359
12479	2vaoxn4cCdoigivXihrtqJ87KfaLAyLNeDbuDzUWLezDAcP1ppmM	359
12490	2vbuCLqoG7jqjLDKhjivzHsc6QPwVbp2VKYhb3UjtwhLLDRQ9Q1K	359
12498	2vaFcZe5j1j6XbJUvSpTFMZHVRLpSfZDmvQzWXK6waELUx7jZBHu	359
12502	2vbZxLiH4X47PsPEcK4DXEk7MnZ7Bc23uCR8LKUeiwhdMmJn2fUo	359
12509	2vafPkvkQP9GMHeJZjAXQvyZJXHKMsQ8KkCaaKnmydVfNhL5AQCg	359
12514	2vbMQsC9fCHbmFZXMf4kjzzh7AoHDwEDmZmmpfSHpKWfGcz8dYm7	359
12522	2vbqa9L9uiEHk3ExenocoKgQaCN4hZ3JG57GRw1LT7GTb49yJJPc	346
12524	2vc3yqYc2jSckdjPP4T4cYMf3RPXNfax8X622FKvd6ZbeSVpMrZD	359
12527	2vboMrYhz6sGPv9mFQuD7ApDNztZMCSb4GFMjuAuEH18c9JPZGbp	359
12399	2vbwAsnixHWis7TUZ85gpV9SXxej2CxWt7ZqfRHhFh4TWcz9TbE4	127
12409	2vaay973ScwoG3mjocLbZLJsNM6iEsp3hRfSVv8dFkq2S3oW1KYW	127
12411	2vbVjdBhJEjP9dzgCcHKreWAKCusdhSmVpod2289LRdXunKdRfCS	127
12416	2vbwuPai7wYeqm2DQCqZPzN4aAKCEU7bWGKZmeoTu1ciVKRDXZFF	127
12418	2vaxPvKi8BvA3ApNSuqk4KpQHPZs9c71cAFEsZG5d36bx1U73Da4	127
12433	2vb4nhPwZqHwrZVSEdDsBPjqdzpm7BgVFvDQjdyDPWKBsADPTayc	127
12436	2vaBwafq4dnt6TW2NtkCyc9Z8Q4uACQdUXpqg2P47wQoBkvGkkve	127
12439	2vb1uAYuUbVE4d5w48yuZWznFZtjDkRYn1aounco6U2azpTDCik9	127
12442	2vc4571JS4Znghwd64Et9fhABEZhENZfEf5iwYhT891TWooVJnrB	127
12447	2vaVBHTtFHRuoV4nKsD9S87Y6mTKuWH81Gcf9ttV1yCpC9DZxmth	127
12450	2vaMJpy21fHQ7tPGenWKFGeMP4Zu1xLRR8nxi6TvHoifM1VTtbeo	127
12454	2vbeHGHXfAuGU4fV8PvUmKNbDPvDjhRwPo1RpBw2vqGdPjTFodwV	127
12455	2vamJakcUQh3nox73nsE1TNBAASnfayjyeKt2BBnRXa1aXii2F5V	127
12458	2vavwRVH5GrGD2Rs5fy4JHmch8dW3STFruta8YCfmbh5eao3ysUe	127
12464	2vazWkco48h6wm7EjctzCita3ayRuFjdy8EhM8F5QhmdGxUs6UTs	359
12470	2vapswuxtbbDUyUQXSbJ6ciABALqRXWrQPxRkZ9taQEdFznA8PM7	359
12474	2vaowu6bo58cZ9LixTAAXgwbKBTM47wnaLAY7YLtYFaFZ7dKEtLC	359
12476	2vbzaadYwqNJ2wL1GwHU6KFfittgyMoKMFU7PE7zh9swZVr38utq	359
12478	2vbMz9PvYGdwg6j6rjBWnazHzstdERxhjPRX69848M9A3Xik6hEJ	359
12481	2vbTxTvQvBoiheQxKxp95nZdqd3TnEdXUZzhmnmZCK347KGz1enX	359
12482	2vbDYxr5Kr2UgmxePnPoYWajkjZ4jdsVSenuZYorynuUkSHZoWpe	359
12485	2vbR2tDqgzWcnF2mcLqkFo5vSFj23EPk2eFzv8JMqJXYk6mq3ptU	359
12489	2vbeYn4c973nPCPkFvVoxewCPE7yfEZmkjcgu5AmCp6tHQnnGYmc	359
12494	2vaQfmco4SnM3gfyFtGEb3KgVAP85uZKioPyaao7tHCfyxhmxGRr	359
12497	2vb9JoJJP2EjzhgcC8ywE3DrWZSM73kLLX4LtPw39N5Qs53rE5p1	359
12500	2vbRqAeZKiGEWNrM5JynTz3DjpyKaiopY7bXyBFpEpHAWeh8p3ih	359
12505	2vbKNxA3GTvcfAsV1oGgo2BuHNwPVERHYW6gm6QHWCv9JBzGNbi6	359
12508	2vbC3n9d5vb9NgQtMvmh1j8TtfYYhYBZQmZey2mjjRXxnXSTGZWE	359
12513	2vbaZHhprJNMTxktZwTZcFko5V8yTN9uDYDvRJridEAVf3HChziq	359
12516	2vbTg1bzgRTC6TXEwyjq9v4mfhdVM4uNTQaDnvKHN5F9PuCZ5R7L	359
12519	2vag4qfJ2r4Ht4vHxcaCf53XQwS4Nrw7vGc15gsQicR58x5CRCTJ	359
12521	2vaQVkQp7J87L4XACTdYUyMEu8QrJrhop4VBwT516QZUp9xQfeeC	359
12525	2vbQYNWYVEnbxrZb7xpJPkzWF51NvVbMcvyv48F9Nei7p79awp5p	359
12528	2vagdGgf1YNB5UBzn8i1xKGgk8BGV9PcrK1pgfQQBs1EP7zAzn6m	359
12441	2vbNeRhfZ55tJUJGVyqvpU5ewTq1Popd62yEk4jtMVjS8MaMRFjx	127
12444	2vbATjw3Taqo32PUrkVsx3hKk5JgeDy4Zw49BzEhDzyEFGDHw8ke	127
12449	2vc4JB2F7JtmRB9VkAWVyKjK5jWgwMpQg9UymAac3GcebMSdEfyv	127
12453	2vbctpVPoB2uNetyuuMrXZmWvgs5VAYk3gUTUpWnKt1KcuGGdPH8	127
12461	2vbUA5wjUEC9WprzTfygPgH7fbh6AEirSbX2mc7wQzf3xf3U5rHi	127
12462	2vbo36sN8RPAa8P2ztZck2SuAFTMDynzEm2SCKdXABLJ6Mu9Tyo8	127
12467	2vaJxgc417SE75wxFCJaJUudzLuQosYYFANZMCFeaAJECZvibiMk	359
12471	2vbQwhQfdgL1Z1oGPe44Y1DBPyRM91XD3VT8F8rQ2fs9eBbg57na	359
12477	2vbfLhzoV8zfQkssCU9tG6pTjZYimYFjHi9GeZhFpwV4oBA69CkN	359
12483	2vbtQ7phPUWMB4fb7Ye6bjrj2HnHDBmoovCLnMxW4tzEC5xMG5dP	359
12486	2vaPnv7u7W1RnqJggoghEkSqvqTcJHNzRy569MqmjoeqBFR3TYqb	359
12487	2vaXTQaB8YJuXPmC5TBrP66BVfwdvQHwn3tzurRXyfUQThThPbrs	359
12492	2vasnieFCKv4UHF5t3c1bePChGMACDYhfBBoLgK9hbPDmHn1bBAv	359
12495	2vayQTTmPcpa4TyPMA413qkNyyL4Y325hg5tkiGTmJnyN4uYWeHo	359
12501	2vbF5BX7Lc9k7FyiNTKuwhvMaNxudh5LqDhc5LHAEPj5RYe98F4t	359
12503	2vbPgaX1AW6Acmzf9A5nLcezMDSkXdvLGajiCacooCGyQruVawf2	356
12506	2vbkR5F4K8y1PjgG4ny8CCkesqwwAn7Hx4DXUSP6kgHEMqD7cf9k	359
12511	2vaxaUsYyisL9UNimzFrLJ9Y4nZuu6PTYACUUmSnUDNgiG8Cq6kh	359
12517	2vaQPVhmG71MUGWbamaZFbKoqTjfX3VohjYDMARsr2VBVHSREi7V	359
12520	2vbhUZeMDxdo8Gkid5qrrTS5Px4ji6YmfarDm9PW3Aj7ztpymjnc	359
12523	2vc3ZHt2XDF7zkJ4HCJySwN2KCemBP3m7aJ8dF3uahVFsxAnFAe6	356
12526	2vadjnKT88wr2SBKEAChWgracSYAjhm8QsbacJpLJWp9uRo9Tbo4	348
12529	2vbUUrGv4ZdMpkNxBuSBdrQh2C7zX77TU4YEREYbKZFNX5KfeMbK	359
12530	2vaqziWniNgah5xYTxr229NmGzvFQXSo3A8jpVj943k1AKnM46cC	359
12531	2vbQ8XmJe14kvUdgvgHeujpMQcEDnzSZnSxwkgGjZUo1zYCMTgaR	359
12532	2vap3WhxLCMh48xFiY1CpXd6YDkypy4wEinuis9EnhaWeJN7QPWt	359
12533	2vasamQTf9c1hoHU1FTKAFsHQHLubdznvo4XyRWx2ZLLUx3pdJ2G	359
12534	2vaqR721Vf5Qo2gUymC8Pj7HbQqzJm1KrvSQwrRhn5BCgsdssmtF	359
12535	2vbNdQNwwPJXYG49nD4abiHnHwKE5hCpt69HBvzzfGeLWJXvb6HV	359
12536	2vbAwp64cjfR3bzeUMni3nLSiLR2XtnpE6hhdGYHybMkEcrC3JE3	359
12537	2vaGPZv7bSCXJv4o7tCNLDdLFXJksC2ceSCpS95p7pzY6HBgpWVM	359
12538	2vaBiKr2nGkvBqpg6sy2bVmAoRBy772Pih7n1S4hiNjK2iZNJc9h	359
12539	2vbpEpUotDSE3DFgmhynLBwvggmqrvh3DEZ4pwFdVYeSrg7TovVA	359
12540	2vaswJyrKeKMLTfWYyMqeKqC4x4FuEopDjQpVVDrzMJX3mCCxGpq	359
12541	2vauWPbbhNdWKE3QmiGYsKaT4cvk9SeN6gRSs54bEtUgMTXYypS8	359
12542	2vaLn8GxJkvdmu7Xd6pWATrefErAZnX7a7xTRMMnhB5bjVWmv62g	359
12543	2vaSi5ApzcSUxnEVTr7QRGYe5enZhkaXwfhacPCGs4p6B7TzRpa6	359
12544	2vbcCuWXyczmgVqZoBrJDqwgniMxf6vALhDxwunJnBqPNTWHgTNg	359
12545	2vbz1qeoAFooSpzZqfy6CwELbuxXXqwMVQFevPbMoEZbshGiKUWx	359
12546	2vacN48j19yzMmJhWHU3rSmzWfArcq8xprdKhXphte1fjwFmvj8q	359
12547	2vamdTNuXjw7qVSoh57QoCzeoDvtVGejGhhsmcMgjfZPv8w3hAj4	359
12548	2vbwb45Zy2wZuwDC464or17WxGP6nZi5DuCmESrKKWdBhKRaWrqB	359
12549	2vbysqrzFFDduH5mpjUBHvEMh3ySpEAoJyjMD3XMq3PMM2ctXRtt	359
12550	2vaBYhBoAxfJ8oCnYx6Mx79QGXxLSLLxEHufJ3qAxRXKFco3Re8z	359
12551	2vb5KhDwaXAvDvfwm1aZTMQ2os55EGS14H1YAjdJpwJzBL7u1Znb	359
12552	2vaR9Yt3ma1kxEdnV6p9UprqD5Av3Gq29sdZC9tza5cZcRGitfgF	359
12553	2vbDELTmq6vyjxv4RQVu8z41RxaRgeiXmjZLJFHFvukQb8Syapz7	359
12554	2vaW5T5EGzh4B4cmYFp5UAxjKmShv67W4xG7Erf8W2HRuCtEagBR	359
12555	2vbWCDBGdz7KPGV4Zt8sN2fzEa4gWpfs3EzZhG4wXz74XYjDni1X	359
12556	2vbPwqpmMHcLETyg2pPaU7Ku3Yb4yTUo47p81mY5vxM6j76uXGZV	359
12557	2vbiLLr8gVW2JVbyDPuwYdJDHPcr8cxYfXRx2isLvBFaosyN4ewW	359
12558	2va9VGsBfemtLdSH3mBWVaZ6WC7g2k2kxWrC9F19AWJ464dGNebq	359
12559	2vbcNvq7dHf4r4pp3qhdE2xgh4cpbmciJzwTLBGCJau62Lm2AinB	359
12560	2vc5bsC94DNzRTZfiGnTTWLud4JDnEUcqgMFjQ1ioaQS8Cj9XZPx	359
12561	2vaq4tLWqFPkqzzvL4R6sUSrzJWU8yp7FTCMMYMY6KWFqEA92fWK	359
12562	2vbhmpugJbXz6g7zgqfd5NttxRJL3ov6fohevhwjJh62EXMb61DV	359
12563	2vb7sWvf2LeVjC4SMeHEsshMWA4LdXdPqL8hGGVDB3sGbQ3nveLB	359
12564	2vbtiPU1FWNowQgjgah21fN75BGJu6DpAZBcF5oJ5UH1fDUX1zcD	359
12565	2vbiaSj4qcw6txtxqPoG14TBJUnYXz2CD9RegJkRg5kFtxhz4aLE	359
12566	2vbC56SVJMTjUzL7y9tdxFerUsXp2saC8NPt3aQcoBsrfNMZwugJ	359
12567	2vbS3793bZp54YgVbPvRqi159VxFvfz8oVsmg88cXJjDEmSeFTGS	359
12568	2vbh4o2tpJJZiX3MjNHHkp5TdHeUx4gdYEnfRaWMZUqK1vGLsqd5	359
12569	2vaj34DZVkm3Ke3aXF7pUFwZv2TRYFCdRhY7PK7UXdJLm7PwwsD4	359
12570	2vbKrXRtAyAWDX3qtng2nj4KkE91mC9NxQUBGt7XmhE9doc6tBuH	359
12571	2vaX4L5Ud8JVNVMvaa9t4TH8iRTpnPvxFc7oUPjjSo4t9qFgncPF	359
12572	2vbv1ZaKFtoVNBzUVPzQV5M3hcH1sKo47CKeS3dnrjRSHA29ip73	359
12573	2vbpyJDKVTc5a3tQazS9XSNoZAjZaw6JjxvAaeK9QJFyizjns2Xo	359
12574	2vaanxwT3rGw9hyy3vkbNiuTS3zHYVDwXtAfiLZn3xWT8eYSjVrx	359
12575	2vazJquuGPWgeCpZXsbEnN8iAJiZf9QQhid3pmMtM1Q6nhJFC13R	359
12576	2vaHLcUiReV2LMrA1fw3aFxLLn3FzVjZbUG1ohsSFXj6dY1BkaH9	359
12577	2vaQyDiFNLNsnZ9rScgCHmgHF11aY4EgVUSb2r8vW9ja1LJcvFsn	359
12578	2vbAXY2efp6XYG9BeadF9Gpc7QjJXqocaRhs5C8PtbWPeVXB2SVM	359
12579	2vasve3oe7RtJcvqELQWY1jNq1SMC4Zf92Lx6Bo9dcKSoMAfeacb	359
12580	2vamnLL85nNVyQjpBDD3sM8hUNwmCq8JfFWwx5pq56vVrziFYVbY	359
12581	2vbQExS5znHkStLLirM84S6dVibvtUakw5BmJhHDyLZu1ftPk23E	359
12582	2vaQXihJuGXfPqYKvH9ocRV2EzbLkqhvQWkp77F62EWkkfS78azs	359
12583	2vbhuyiCVU8SbgkvqtpPDWRppE7VYkr47xis2Z9svtzpne24SVZX	359
12584	2vatstgB6PpqFVY91cfLQxsuA2f98xWefdEdbCpcgLPftiL7WZDy	359
12585	2vauEDmeuoRwQewp8xoVHvWzZPBc1x69KXB1YwoRYtKbzvZY3fRW	359
12586	2vaY7H2nt2rPL78Fw3Z6hedeA26bJkPhaP6NZRuVVcHc1Lzywxa8	359
12587	2vbLToj3fW7Af3pCBJGLci7pN45zUM4rvsf1SgAiaqRnSqjuiEpB	359
12588	2vb35WXY3VSh7QVrwjaYcLyB4Cxs5zs965m5sQhg8bU8me9QSiV2	359
12589	2vbatQopPKFxEt7vNfZnQaoTdEknvMoevDbTPYge986U4oBdaSGy	359
12590	2vahD7Y8tNHN4GgazT9ZdPrk4n8d5n5kn1QPz5pz9bkuTpiM3Qqi	359
12591	2vbxn9KUgTPHWS8WmR9tTwiE9c9p5HMVLAkqznmQFzNNMjjbE2gw	359
12592	2vbqzNAhRwHN73pzFqn2CzHpc2DCKoVrkZbKQTDHr926g6FuUiRQ	359
12593	2vbGXWrqnjg4A5rngwP1QByzXpxiU2PQKMVFs41SNodfbSqPw8qh	359
12594	2vatEYNFtsedJGzJgnb3wbr6VVuyPBZDyqKcugGAsVrXscrqkS9P	359
12595	2vbtinXwkTU3ET8gkwUUwcQKmX7ac27ddSr3sUK8zKhyPv5X2RCd	359
12599	2vboSsGjhjTMKLW56jcHNj2Mf4QY66pvyND5LUh9oYbWCRXFyG6q	359
12602	2vbmVgEDERyu221udT6WXsVqjDe6GMga7gRULTfRikKxXjQvDgZQ	359
12605	2vaFGHRq2WsvUDQ3d5kN4GDzBe1YSEpAZ9awaicUbx1vNLkvikCi	359
12607	2vaD46uRL8kBbQN6hSP4Rvtsw8WH6VG9hi71D4cMBzS6FbwwpSUc	359
12610	2vbf1ihrBEUqiA8ftyyDfJ2yYSk8thEaEe775h9DoDVDXP8YdWGM	359
12611	2vb8G5kMYuimnXNL5WNTLMsYJ1cHt4yWw7X45NtbBEBmrz1FS5vd	359
12614	2vb3rVEHPcLdgcrp2vKMCJ4utjSS8CtLbhZGaQ7We28kHFc9Z89m	359
12619	2vbCX5mjBtKKYznzAQnsxDapLyjKutQU1NBbXYv9hGiSohAbVuzU	359
12620	2vbTtfrRCTyTM7fACbpuvLxPEGagdvmCCrhGvsdtfCinbszmLhYd	359
12623	2vbmWE5ecvs3PdLajWhpWPsgps4n5Bh2G7ADh3n71RW7y6nGcQS1	359
12625	2vahAuyP5NxocDgsUdChg3uF55otZBPHtFsy7gqnTDWapgeYr4hL	359
12631	2vaPJeizNrNLKxg5AoaoijcimHbrgiLCa7vGdfXhep6D2Af6QBag	359
12637	2vbSZQAhTajUceegjtjsw4N6okEembQpYhdznE5cTYjCXHygghSm	359
12639	2vbKwy3WgTCfPUcrtxLR3ZQ6xRViAbWZb1WMpP8HMBi9wbg751rN	359
12642	2vbTLXTkKaSrwr6Kr2f5sxDFwy967ZEHu56wgx3nS5p1ZyP5c5ap	359
12645	2vbhbBpUi1kAu1owieEyusoHT4mr5NUQsXdUY6GFEAgLGWUCqYSe	359
12648	2vbSMoXFy9ouWXFT15GXgDv6YqxqdVWD56gPmNL2h9CHgqKH5Lfc	359
12656	2vbvobCY9zwVYkmhMXGFcrY3Y2dXXZ631qFEu1g9d4UG4oWgxYNB	359
12660	2vaaacUTqRi6KrQpQoufyo5zd4SWmia7jRWgtRXLUU3Ty9dBmkA9	359
12662	2vb8xssrMt8t6fKzYmr2wahhpDpXJK3k7AFeoGQpwx9Ch9TUNsQx	359
12664	2vaB6WcR9c8SgKwrWrhZtiWaftPyWcn8DPcFFbgbyPXSsdAx4DkP	359
12667	2vbGQAVpQfHmj3yJCcejQfDtx8kg2odSoJE5UnhrQNE9hSyDjY39	359
12670	2vaHJgU4YzJQpXmPpLXDqTn94Lxxi5FJQNsENngrYwLrW5HjmV2G	359
12673	2vaX7ZqjqXwRfT5FDuanjSLnVjWPxyqDRt3kwu41Jy6mxCwkV4WT	359
12677	2vae4orzYkQuzS7enBqqQZNqewGKayodjqmN1pWARug6v647ecTE	359
12680	2vaPwophmxFMSWZvvqowmAu428teNaFsZtRxet2YMy7V3ZVY94aV	359
12683	2vartGW7KyhtNA3mqeBJ5KmRoUU4mVBW2ZZDGpVWVpn9GAGDDMKb	359
12686	2vamvmvAs53D7gZj5gnGhtRrdLR21gjBE2HuYMSeEnWGJZuiA9D9	359
12687	2vbarzousBc5oqV4yuCQEiAfdgejYnyhsCFk5VnAAsH5C9T4tC86	359
12692	2vb7brUAixc1fcuuY94XaPRB3RjF8cdwur24EbKNfcLgdLQadSPD	359
12697	2vb8UpoddVeVBjNbmyZYN6wBH8EH8hqe8KrM1eDief1zCADwkkAo	359
12702	2vbdE37LbkTq5w56quee2xk1Gg9MengQ5TFvYExc2RjkzQdP7V5i	359
12707	2vaecZwWgVTd2nw3JxQAtq9Xq9YWVj7M5dYiqgDn5wvZ98tNJRX1	359
12709	2vbBpg7WXQCWbGHhSmAgYyjA6YcxszM7zgXg7DzpSJrd6DnsRmA9	359
12713	2vc1ceTiCUho6MCjagLHfpcMDyAifikyg5BSDAJruJUaLk3egW6V	359
12715	2varMiHXA9Rj97QomuZgnWRb6UxLsZBGW1MifEMAUvxujYnhqzCF	359
12720	2vaWe322jxTZohRNZaMvBqhHP8ixnePbeEqPqNS2zrUwEwJsxVUB	359
12724	2vb2TeXn7vT15129ZDR39LWCXBPMd6fefdMcyY497RYbJGwDCfPN	359
12726	2vaSKzGfcDafPNkbry7mBi3pddG7e6HKAiadB99sVwfGZmZrNWTC	359
12734	2vakrC8TUVonxaF1K1TwszDJKuioxtktrPjfUPWwPb5vNj79yxXQ	359
12736	2va9f6J7afsn8CqtzyxJfG6c9GkFVtXMYWeS56XGnQJmaamCTTus	359
12739	2vaHCXkg4q4WgvGzyovBXiWxwhNVPfm2TrFt84z28B6rexC2gqvY	359
12742	2van4JDSDhAVKVnYxYijaDtAFKftjq7qJcG9rhi3UrVE5RGN1c8t	359
12745	2vb8MXV1G5Hx2nmB17W5C45WQu5f4vKjd9ekHoiqCMo2DvNhBpkr	359
12747	2vbPmcEYu6oihRUwfX1q8hAXXctFdzRUo4oGeqAKNWYrowvtvWxa	359
12756	2vagGdGdgzExpacTBDb6smmfmxGrqHSEiMArMqsurnJoE59itbdt	359
12759	2vbfK2KPURFkJ8FYVRNah1NHAr2aDeqmZeGD88kJtGN6QY1WgMEL	359
12763	2vaBquwUVHTr3YxFWFNi7bwM3HT51AE2he8hd9fARsScDcgA8rGr	359
12768	2vaJC8WMFgBy8eHcvwKpTgPyx9zi3h7ukm6EVqatfCBHrwx1JoU2	359
12773	2vapP8PYHgtEHNDdeoJYzhP8h5sQjFYtxWkSNGhCuJjqTXecdgoZ	359
12777	2vanjJdbypi4cpH4MDtf8zmqzDcCY2bCys4zLfdHf4e5QKaBkfdQ	359
12781	2vbZNGKV7JS3rR3EUqnQsDesmG8a6Xf4iR5f8UcrEACaeeZBXi9L	359
12784	2vaR9D3sSzgBfQHfowNaaRh575EMMy8uy31NLSgYj1YMudzb6fst	359
12788	2vaivpG6zE3mMxooGnQ6BfLTY5hYjUYPtYEFHw7edjvZQXeNcWWx	359
12790	2vauS3eC5GPJ5c3rYrpn2FehMHYxZvWB4gdDFYwYxpbm7CX7JJBG	359
12797	2vanHtyiv97UkJA9djKeNnhenBPkvgCnVuuTj9HhYSV4Bt2SEcpD	359
12803	2vaBueJvUmb43em4SFc9ivb4AvsRVXNigM3m3QCdxXEUN8cwH8We	359
12808	2vbLq7xPs7eN6WRUwZZmRjshqaV5B6Zb9ERw8yU4E58k2UEvVowM	359
12815	2vbyKKp7r3Qr5xXbo9V1R7HfJwFNpsUALkuXChyuiBujagKHaH6P	359
12822	2vaSmeqCxtnhkLaExu4CGMcJYRUwfjEu5Ge6DzGJ4KrQtS8U7ZVy	359
12828	2vaQovKNFAF6eqWtsxUhF7EVHKBVqVRfv7cMipz4gHo7qZM9NySU	359
12829	2vbdBAVgphhbya9EtwdPr6Edcvka6GiTi2Y1YWyYk6j9PfEZZUy1	359
12833	2vaDPtQ9QVYgQzANxW2QBYYL3iJuAUQxLPUSYDKX7k1vPU61o1dF	359
12836	2vaLCgA1zQFhKA6ZTvfqXTQ6AzqtkA3KRVgiNTyW9xnBuCuyMZmh	359
12837	2vaUAN3n3rnbRQ8ik4fZ31g9hWscXvwtAyFcKe4rxFD9SYRspdD4	359
12843	2vbJJwChWKTTBz7fBqjPkpp92rS1paAwoFArKXmR5eLveTs3fSvn	359
12847	2vbexuLJuj8q55p5fmJ7SFM6ykUtYoVCz1CUWEaYEPLsCVr2BQR8	359
12848	2vbe2mkggRupZHdN4B5pmSKR8qirRLZKQs1yG7h2UVeHDgUL6jZD	359
12854	2vbZgjkFeyzdFE9wCTFr8sbu3nK6Atw6QFaapjiXz191noZW2UdN	359
12855	2vbUiG4FRLbv8PWUCMQJdYRx21pDGh47vsA7yKiVLgrX5XyVJLoL	359
12856	2vanHAhnMtUdhR7KLKooRSNNiYEaGiEWSaWktASbUuzr8X8rU5ys	359
12860	2vaNaMvSe5EBU8TPkxxrPwbGMVGp1DnC7YHw5Hw8aYKtq6RwKDQW	359
12865	2vbMUNnw2295hF45MDtBw1s17NVP8uFge6eUsEnoSzphk3cS1Uze	359
12869	2vaFseik9Jgauu5WB53HVJcN7J5CQRxhfknf4tDsFQgePYKcLKTP	359
12874	2vbu9C2nopGzQTAMkYQL2w8ugTuYQbD8joV61ontHuuRRVbPE8sA	359
12878	2vaZvRtwXjsVSJTYu8CAs6hGhrRhYSeU9QTeXBjkowzyCT4FhaVs	359
12881	2vbRAKmxiVgtWovsSSWZNVFPQpA27dLuho3renALCo4caZx5dffE	359
12885	2va9nGkwSzQAJ1Kvnm8swe5TgBeHpuUi8uRe8vAxGFuAk6bEyWDK	359
12889	2vbT7yAw5874Q3pQ2oirVdNeR8Vt6aYTcifury4HyU1TfYqTTrL4	359
12890	2vamMt9eTJJYE7f7WxTL967bLvCy3uioZ1t8BHcnyWbhmTN7KpyU	359
12894	2vac7rzfzdccptLVjgLNyKRkgFrHB1xr9RnATLeoTiwdJEH7DfqJ	359
12898	2vaqHU1GdU2Aj7Hu2B9ng4eQSDzRtK2E79zaWe8k1h6VFrXZd7Wv	359
12902	2vaxz929kHu5X718TDnV2jPkTK7EhB25cKGPMooU2cE9K4nsjafm	359
12908	2vaUUtr2f4AjsTbXxpWYYN5H2D8UkF6zLuLYruzBeLTuth5h9hyG	359
12911	2vapBgkfJyX6AFLMnYkGpNeaWb9436gSrosLm7LVVbNYrsH4n1cd	359
12917	2vby1s34Qn7sRdXg9BjTg9wDbFq47rdPHt48qTgBuh4CaqsLBsqr	359
12924	2vatUAfogfS4K6coTCvH44oRN2T5XGWQFdmKrcfPDRYBLJT5YgVF	359
12596	2vbjqfnH2VXPAxDVWVD4LKb5mncrH7ZB6djimbWS5Q5LEkKzLRVf	359
12597	2vaKGYwVh5sraRa1ShBNwo9U4ZW37NcvnRV3fAS5DZVvjBUxZDsc	359
12598	2vbtbdpNsxHFnZHX6buNZrvh3hkBmJjPvdGmtKfcG4GgyrwEqTbw	359
12601	2vaiWvG7cbwNGfB8x6aXHfeM4RgWC16E6BUWbA6sqQbCnFzMjAMt	359
12609	2vc4HiMFMcD481jBxDwEwAddG89sCZ7y1oVK5FR8YEgrC6351xuV	359
12613	2vazfkHcmWeoxjVBWV1Fj6CS7oP5bCuJdh4kU1LtmihnYeERcLBR	359
12618	2vb41xwLfeBAVorYTD4jRLagJcMiKF1XBN4wpXoQPtRg17d4uXcY	359
12622	2vb64MPVsSawAcSVK7JNNA65ruzARhu5PvDumu5hvEpPpVwmGK3s	359
12628	2vc5KEHxXU2jnRN5Dtcx3hfvJ8KNVtBpjDNtJ6LZpGnLeHayRCvy	359
12634	2vacbnzkGnkU5pnwGeotY9mMCiB4c4eWkrnV485T8Uerjaq5VRzU	359
12636	2vasqAChu9FPStGHt2o3vboZ4SEdGzuvTbDYeuaGbCzknGdzhZDf	359
12644	2vaSThPmeSd7T1F3BqiVY8ErNxRbxkVmrwi2bycNvogFemdPxban	359
12647	2vb2LB5WN57vFxhHGuJNTCDsC4Mo4HvJeRkFGb6zrmMvVrRy9xeR	359
12649	2vbq7d57ZKYrGofWyjtpSnRJYbUdaYQpwr4xmNUafVzzxrMoGZBR	359
12655	2vbFUJvUqHsoMBqsWTQjHSvuzTjEiVRdsqNn291obMCPV82ibQyA	359
12659	2vaHatNB58cfxTFbj8GmBExtGrPktRFr2FPcAHYqrPoG5X1LL8ER	359
12666	2vbXKUCe76vpxbjMQvSn1pLcNiBQqUPMsuLFXxGXqkt2eto1xUPV	359
12672	2vc5raTVPao9ANT4YSKaqvBNo2EgRAqvJ1rGkY6Upjze2mnw8KpH	359
12682	2vajA2yTAdTxmMXMReJcfow5sW9FLw9ATenEw6fjSm2B6QkB2TJ1	359
12685	2vabYotihtTjHEjmNn796T13JTxj5ZFfnjRfqZh9hjsX7mNX34ZS	359
12689	2vb8VLmJ8iPGk54PjwTJ4ehWgRXBDAAG4qyk6QikrV264frdqk5o	359
12694	2vbnCz4W1j5VG8kHxrruKaoJoZwLzW9a8GgWVwUd2sEwvX15TX5Q	359
12699	2vbwbsVVyMykEU2EDZya5tiK21fwJLzr6tjuGZhLExjM8Hwpjco1	359
12706	2vaD684dJ9H2F8BgXicd1DauktxjhMH6GkHBPxn8mP4PpNjjZ2Lo	359
12710	2vbYy6ANJ4qTbCTcGsiU6VufsXzTeGWSaLsD69Mrt8qHX3vfoqan	359
12712	2vbngsMjB5HhWY5GPDrAGWBWMHaLe7VAS9AtxnYRm2aze2bTppu5	359
12717	2vb1z2ajP4bj21hxMXZTGVfJQdEGX362q1HBk5Yik4VfcTs8dQgQ	359
12722	2vbuc6YtcpkppaRfcU59557F8oAzRKXxqcgEuwtDspTMytebUqiM	359
12723	2vbNM1CBiBwjJMNCboGw39A8Q62kPomKSRemAusbr2DB6yy3U7jE	359
12725	2vb2QGn2rEtAssFokWy5Djq7JddeEf6R28d5kjKHrCjW6UtSE2bS	359
12727	2vaqYiixYsxTd53HD5aVfkq2wGwpEf9naQ46UX77LMVZ9JCXwL6Q	359
12730	2vaCRrkb8f8HMhM1HyA1X728YDYay3sjSxjqtwnsJNq8p9sxwify	359
12732	2vbn6LoZMNDkQJ2F5GXGVwEb54gKgiLqdLkN4NwLCsbk3eKNWByv	359
12733	2vaqvfiyyAp3s7tXarNK7wNes8BKRkgmYQ4MVhyHjAd9fPekQ6YK	359
12735	2vbtcQtbky5eb9FtUZiKTuCopzNfJwwWAY37Q1a4K85gLrEnBvqT	359
12738	2vbmtobf8pYGgH1BNriGDZfXrS28Kde5McVd82Cgnf79q11DiiVY	359
12744	2vatvCx6MR4wAwCQjdVpTgDehq5KcJqXQnq8NcBFwzRPy9YV3QYN	359
12750	2vbn3QcdrENCd5MYyv1W7xt3H9KThYczFdYpmdgcu4CvyumojgfJ	359
12752	2vb8cD8mJa5yksB3A3EjXYYzc9NdRWgx3Cp1b7dSepWsqxkJvJMS	359
12758	2vbijnQWV5aJuy9GG3CtDQSqLB2r2rMqXPdLZVJECMbv4mDgKVBn	359
12767	2vao9XxPhK36jfjSWgBFGxMhSgDQHwhu6Zu2BeRh929mfw91QuuJ	359
12772	2vbYdNwmHCyFmP87nmf3UGf6tiFQsFgxxSGBZFpia55FYSEFP9iX	359
12776	2vaeVNTRm1aACxYuJpN9cGiBggY45MZg1v8kxgMkEx4uyA3Xjarf	359
12780	2vbZDmduDvoCVQx1XqdURB9Hp61g7U5Z2pNWquGvpAKE3XuEA8P3	359
12783	2vbi8ozmft5poHtX6prvL9Fmva8MYyVQf1tQcgiMUcYxTvsPnyDc	359
12792	2vbveGSgNQsJBk4nr8rzXZKjchePs6hSuNuQCmxbseHdQqHJqsMw	359
12795	2vbtyKnhNneqtC5FcgkUJCJrU4vY8MKsQJKFtaYXCQkutk5LbLpy	359
12799	2vaQrhKDVboEZBarEKXz9yMPz5RGnwzmN3mnVGUzMN2s6K1N8yg9	359
12801	2vacauWFWbXL9vmRha7EgZAZZNmeasWSQB87yrwegS59FjefHgXL	359
12802	2vbrTsJDNR7DSb2j8Cj6xXvjuZQ8bTbtXhpgsQq4K1YXVKP7EBG5	359
12805	2vbFsHBNfHPGQfY53yFSbaAjjajYSaazCPDDy9ZR8aonKHNVednV	359
12812	2vbeTm4JjeYEQNCHg8aM3UAenGW1isn6fXmh4YDDrTP6Sx6hCD3N	359
12818	2vbKrUHApVW7FcBrpBJKUa6eogBb9iPZ4UkJavwMQv4VED1vZ41g	359
12821	2vbHzsuEwtp42QZvgHB7hwYYh5oHJmFGuRRctA8L6QhX4ZkVSo8z	359
12823	2vaj45Bep2yskM7WkfLHdBwPiwBCUc5ZWr1T19ShECY2c3TrVTMG	359
12831	2vaXCpiMxLHXaUwep6ft9eCAGVBv7jmy4N25xJS4mJNnYaxsW2JV	359
12834	2vb1wrLfi2H94R1C1TdEG7C1drHXPf4FWRAmcN7ZUbb29ZCn6mRC	359
12840	2var9pBx1o6iDz2RKqGqRxPKt8kvt9GwWy46x65QpAcR1s3bo5KN	359
12845	2vbe8DsvCE63yF7HyYSPrfnr2dVyUbQ3ctyemnTqTycw73m8b9AL	359
12850	2vb5yzqiEqwCq5gcGBoGG4rc6EgTFSa81es4LwJdY92XUpLZCW1L	359
12851	2vb388CCHyerzykLtF6xuQCCWi6sJ7MDQTGnn2DiF9n8A4oQpSVV	359
12858	2vazTxCfakkDUfw7C8E1X2nrqjdLo9Un2icGi9udLHSF6heeJWnd	359
12862	2vbErqJi481FPUg3CsJY4XP5ocXfXKc2odNXjoXPZbVZobdcFcFp	359
12863	2vbPhkppFCYoJWcpxc1zKRtn8Qdr7wDRBXEeqT23HN2RJNBBZmvq	359
12867	2vaqSMAFeEvLFcyhVaWmg1VKGAkY9FLekEZfzjHaRSFzhj8qSZg7	359
12872	2vb8Juj3Vk9RMEhKXchyBjKz5DWEJuregE39Fy5NmWjQ9djESvDj	359
12876	2vaF7m8JwX1bndqNcnjLoWHofCXJ19qj75YsqVDU4UXxVZWbAiNG	359
12880	2vbdmR8PPdATSSqhPJaZ65VBA5KsANqbbvyjj1FT46TknZzDN2Pd	359
12884	2vaGX55oxD4Pp7mxcEmQthsZsVvDwpMYXLArtBTNamZTGor5xeED	359
12888	2vaSw2EaAz7uaL81QUEQfSC2EAgdGPhEecHSji7u77zrRQ1dLrCT	359
12893	2vc584VU3nddVgtnY1ygmPQf6m6GiwbhBCxqfRmPQGY2bC5u6uUF	359
12897	2vaBuZLGSALUKWQ8EpMeZY79TEkwJE7pxmVEDPj3V6vTHTmw4Nfv	359
12900	2vb68cgWo9c17G8B9HRKmRyWnsmAKKMwq7kAFP7tdQ1qSVEUPd3T	359
12901	2vaNGaN3rCJh3RXr9EHzQJQqbTB1rFiRj1VFE77TgiT4bCVJQZtD	359
12906	2vaqgsLzx66QfzZeLEwFkxVbdvZ38ANnWXKeAmvnrDe4SoqnPwwK	359
12907	2vaZPHmCL71iLLr4ALJQHDR1f6LSMk5iYSwQXBJ8YXLuLuXG4SSP	359
12916	2vb1UwzW3hMzamtM9m84J45V7ZQjs8i6DNjPTXaSunn9ng2zERXF	359
12923	2vabAWXauGPgVKGfDDvogY2JwNrgHiLeNdV6f7C5FfBmPJjenNT2	359
12928	2vagzyb9GmNy6TVnt4nVcbFMBG5L8H7GUNEaahL9XXZ8Hewm7Xi4	359
12929	2vb489YYCMtmz18FT5JL9vntNVkmUebjGA2M7BNdNwJPxhc9YZQB	359
12930	2vbcsyqewyEjPeZhxZ4dRFAHpKTov4BUFsCJ4EaVC8KPFWjcUDhz	359
12931	2vbrMTdJRpg2AxUNBETqRq986S1Lk9dM3mvJ9bj4ShdUQakA4hBP	359
12932	2vaRHE7zhQPaQXLjYLPztZSHYgKszUpjgJjNrQ43bKVXupJppC4j	359
12933	2vbryNzcp71Be9LFBtuAXAZvGrqmyAPfXr3Lk3xu6EYEzNZFEy8y	359
12934	2vaVntVC393uuM94U1fmsV6QauLnGLQm1XqesfgGwMDA3sotMJf9	359
12935	2vacbk56xgCfER48zSh8cbQ3f8BvFd853UadFMcLk3kUQXLFanN6	359
12940	2vaibDLXjLMstg76sZD5EBPEcBk1vLgqMG6GBNCkRs5oNTGUpuAj	359
12947	2vb29w6Kx2qqrdeoQLDyJXsDLDJTT3W3H2zBv4wJHRo7DqsAS52A	359
12600	2vbCGLW5A9zop6JwawdeXY6FsHBcybcvTt7vzyD65k4vL2GfeLBn	359
12604	2vbBkn6aLwJzxJLyk2TTdvX3usLidwDB3yqhadFqkrQQdDAgzfxi	359
12617	2vabDHvZaofEKnputzDAqmz7Bgn6rdvpcxdmXYNJv7XwJBPZZ4PV	359
12627	2vb3wyJDmbWoBHyfNyJLekcFQgGxxPntNApeP1CoVavqZjKCUAJs	359
12630	2vaWifYgcfsnNc59FXpE3xMUo62BJww3qC3ERNJecnfji8pKj3tT	359
12633	2vaNhNYd572tppeaXK7FApyC7Tgpj3PitRnqNe3EESsbMH7LyJzv	359
12641	2vapTcWBmYVYsWVt59DLR6z49Uq7pG7RxiTFQNd8K2Cbvh82U5uj	359
12646	2vbxv7ZDA6XbQWGPHXTA7MHqQRfUELvLimj2QxE6w4wU5DbELJZB	359
12651	2vbawwkPNQhWHYmGFETXt6SFvjdfSZrLWkLt8KwJQ28LknoX8rsh	359
12654	2vabV4it72mWHDu5ujqFGJ4R18GXL2nTuL7YZrdUmXSsgBwePmqq	359
12658	2vbPCmnDBCVDU6jLBPHMbLFhgvJAm3zhx849P6hMpteT8GhqJPd9	359
12663	2vbXgxEZvfG5fHC6U9ezRspvd86LfzW5fGkqb9nh5Ut5uopAxHBF	359
12669	2vb3XLSttYFR4gAJ82BZefJYFhhE5QUucrudQ94UyULfswpnbMqd	359
12671	2vaYHvQm6o7YF2fEwhU8st9qXUB98JjiT5ZmAok3iT61Ku23SPv7	359
12674	2vbHEMfhsLn38HYWFKopDKWsFV5VNsfXMYCAUunkiJ5oc31Z7mdN	359
12676	2vbB2idgzsdrBJzzsRSgyP9BLtPwLF2DTjv4yJ1YNqYfdyXqc4ex	359
12679	2vaVDD7BH6FhW2nvUVQSvVYigGix3JTiNVH8abugpni8uYvtBa6m	359
12688	2vbCWKfMJUo3TnpdZcWZhsdEa99p6kK9rQQVj4JFqqX643oHcjJL	359
12691	2vaBirUT2k9TJzCYdmhJHrwLYnUWYhSvqxqumibLfm93BEdxuQAp	359
12693	2vbSV4BJZnUJQHSeRM1oFKecbvGYFDXyUF8QZ68LUSUuTZczWeJN	359
12696	2va9wdqUw6qUKtwgGv9jhCQmyvQ8wafoov1uBhiT86yvCb9qQ39N	359
12698	2vbo3pndjE4R6qZNwZV7nYF7CpRuaRBJBzoijDkQf8pqo86fnBiJ	359
12701	2vbUpujM6GsFQ9MaFznHdBgqFP7CnHTNUs8UwkPQx35KhoV33zFd	359
12704	2vbZLuUnWBknpXH59c7mCgguD2ZGkqUcFEJ2Rd3bhFw3Xain7tVZ	359
12719	2vaGBWgcQufP9PrKsP6NurwRG9TyhutnoL5uEt2DzP9EmbC1doyZ	359
12729	2vaVxc5fm6p7P8GfuaPdHNBHQujSTSPY3tUEUZaoM4xuuMEB1qaG	359
12741	2vbHcRGG3z4Thyf29Wf4i2fAvBimrtjpF1YD2iq1JFu8bSxWHYHZ	359
12748	2varKnECbMio19iGtSg76BfNhMSx1ToUzsd55Q9saFWSWQ93BPdE	359
12749	2vaRrgFYj1NR5xaiB3x2ykUgp8ZPGPdS7AnrpQMsz72nkKdpinEJ	359
12753	2vaYB9nqUKvMUzDwctnoeba6ZLZ61q5kcE1NabqdRyV9XxMJiE7H	359
12755	2vaMN8erq8EGTcKF6VYZUyryP6y65HF9nCBKL28XTRdnaGbp5Rap	359
12757	2vbyz3oWBbYhmXDAQAv997Wq1dx3gxtqGS2kgLFMWgT8sWwcACbc	359
12761	2vaUuvFSMMT82vUHPFxDDMNMptYPWDEHhQp1xj9Cq6dKULkuNo6i	359
12762	2vaRHLC7we9Mpcc5xgTNctzHMDqzSR3J7Aa65EodTJMLeW7dKtse	359
12765	2vbDgaetT9CQZcimxKLqZu2qB5XXrTptRWLD8qRN6RB7JgxU9BHg	359
12766	2vbSHbnd19Bnuufa859JyYfGoi9JQaDrDtEWSVpqy87vecehUmeU	359
12771	2vaToDTfYbi1AcmamnPyYfnicfVvhzVLUW9B8kw7nStNh37tme5N	359
12775	2vbufsUKWodpjUkqsV7qPAHqcpohirapBE1gSBkwYiQswpJvw2Aw	359
12779	2vbmuUGXFHoquNaoB2trSmsV7j2ZtYppdHwRBCgp9V75QbMaTBaX	359
12786	2vaeKeV2wcoUK158qSVUU83R9Eu7eRHuzwLYURbjPgw5seKaRd8D	359
12794	2vbbmqi2qLRaJWRDwqPRYiQqhN4BVfuEXsaDKBA9apaaHmYmf5BP	359
12796	2vaxMZSrgk3qhnpz3BhAETb5W9CV4r2cLu9JX5iSH4KqP9nDZUEA	359
12800	2vauePjB8hrLW9sN4Lay6wR8JkgYYmaSLi2nMZWYFcdWErBkpDwX	359
12804	2vbV3594s48BGSxUGVDqCeXhtHqqedHERTeoSqQBBWX2nxTsv5cd	359
12807	2vbDS3NFdrKy6LWynngjsb9ntJBJFVTPBYCxA7ATH9HxJoPLnCnS	359
12809	2vb9tgunFUsso32FYUZEM5NY5XhmfS38oMyoVm3x136arLQMhpzr	359
12811	2vaujTjJh3wNNN9Coou2Zq7zkxg5M3rCt3FJsxept5GWS9wWXvub	359
12814	2vaGnJEoVL5RguAqfR9c1iQpcHWZiC2g2dZsxSAE1nzt7B84REMw	359
12817	2vahqc6jW1yatmXUPUktELhudWadHDe91b3qbAyaiyFvQsATvbC1	359
12820	2vbJuMroUqKx7z6NHk5Xx4cRFN6Kga9adi7bvhR8th8hHbeQxS8b	359
12825	2vatGNXhWMbMFhR2qpjKkMGCw1mFz51Q4xKP864F6wYVji9bHfHN	359
12826	2vagRJnpQA6U3VBzpAgbrsAa4yW369vTM85KnkX5Do16sbUubCLR	359
12827	2vaAiKartdXX6VmmowNdvSwWmc9KyJRjmdR95vtAP9zMetQF78K7	359
12830	2vaqr8DD4PiU7HGf44rpmBNXih8qhbnaTVuAfW1owJPwLmgbkTPM	359
12838	2vaJkZ2hyUhoPLXMYWY9JAnZYX9ZDfp62fcqDMyWdUQUSM2XPrud	359
12839	2vbYS7vAJxkdYhCfKuYdZRQBfwj9j469tTc2xh3f1i4T6YBfxVDE	359
12844	2vc3umkzxgzWZPvtpnYTfZENaFTYNxjq2HA64cosv98yxryGQz4B	359
12849	2vbCpEakXbhDYtr8KF1F5t2kkKTCFeCqvKtav9E2YE8of1tig8ix	359
12857	2vbpeUmFJeMbaAd1VsqGjCFdiJgrdsrUquBLwCUZzsKCsFYc9ami	359
12861	2vc2ZuRUbyL3n5F983K19QVYbUcgt2Zmof9CZi3XazqDv98NPYbZ	359
12866	2vapBuNnb14BqPiWyruq1UW1oJEszBw5vezXqBido4KmCKyqgWoJ	359
12870	2vbUYDzGQMhBXzJuCVcAu63vM3cKc88Fi9GoEouZGZt6CG9UJcYN	359
12871	2vaN1hmoSqycGvFoBihmYNyRc57tq4Y26T4yaRhMQm8AD8yRNKEy	359
12875	2vbt6EGKeJDNoUxCaULFaFXTVP4GtYBF9FoepQihzmnqv6Tv2dBy	359
12879	2vaSRr3ukUBehTo8KRKcsopKT7US9wC2qs5pCXx6QGpMjRKZGG8i	359
12882	2vaGA7BJo3wFzTUKDJrgsnPFcofd371CwSWJC2niihP2W61PNcSy	359
12883	2vah1tQ4bGg8wSE4P3BktD8KK2YkAhZtc9uQpHSuFhSW4QvgNUfA	359
12887	2vbxHcqkBFR3ZjYncUfupBpAshHaRKnegkoeMajsoq3nBtYrJ5V3	359
12892	2vaAVKmfFyTqBjMAzn3iXk5cH6rGbRm6NvLXwBgghyozi7bnKRRo	359
12896	2vbybyfVrcvLC7Nvv2ZuNCpwBWY768KD3XY7viG8s8ZkPdYEFZwk	359
12905	2vbPK8zaofTD63xJgaFa7XSfnMuBGDaFetFQCUTKrYReiXNhfYpw	359
12910	2vc3A3AgCwQTSZrGvz6pYbUASYmx5pL4FUfEc2bw6W7w5cobuDKK	359
12914	2vab5E7xEFGb979gRUtLcSHbevLDiVseteZwZCr9iNFNyt2pZkhr	359
12915	2vb7oG6tMiorWd9LDSC2C97aGBxdhZpDdj2tExFBBVAfozJgbEQ1	359
12921	2vbz3aqcNJP5yLxaHfNrU1GMHAfLpdb8BEovVvGLzqtUZ7CGL9pk	359
12922	2vbjdCJY6tRHMo9iGXTHPE2cPVwv8BJcyfbC7n6epGANjmivu1J3	359
12927	2vaZkRdqoqfSG8RxSJR8y9cfKs6wwmQPKKngM21cCAJ61M1BesYp	359
12938	2vaw5er3UFRi1Sae4U82KmG4T2yiE3navpLrR7CrHFvyHCXdA7iD	359
12939	2vagwPANghp4ftzQFrqS18FZPbv3ePmrtYHe66zai8qHt6CfZey7	359
12946	2vasqRWWKuWj7Q8RKvLftKVq5K1gu5mooHQFrL6EcrJnKUcCcTuH	359
12951	2vabyu2gX6Fyy3VGG6wJGiFtrNaT7gDpauEZLZGmLstTB8AYfS39	359
12955	2vaZPWpTDWzDgAH7fGHC7DsuncfTuV4xwsStQjYYY2vgUDZEzg85	359
12960	2vbnsZue3prQ6PXBpZ33ZGGSmTssNJpL2tr1oqa1ntZ11NphHt1A	359
12964	2vadTfRTh1nAkk6AnexLAgAeUxkyfFWrzZCyUAzYpCw99EFuMoco	359
12970	2vbvzAqu8vEyHSeVmakjbgro5yWanrR9QD2iJK91XvhWDY4hg6Xn	359
12976	2varzpfLoUMJH19kWi6bfiWvS9J5HPMWsaaNGVgLFHsepy2kNKz7	359
12981	2vatUNYTzctEJ6A2sWVNpvma6torE9L17Q6cczBKgv9FyRNWULWV	359
12986	2vbo16w7TLnLMRM53xcWHiAa5WEUpJjF3Fm9spYNwt4JkF7UfYaS	359
12603	2vbMUND8fp8denxhHKgtiSyVjJ2Nb6H9w6bXvsAeBAYaxDHW4g2C	359
12606	2vc3HHd7bBsZNDCfq2T6cewxeDucnmEZFyMadVa2RVvJP7ScYfYg	359
12608	2vba94LYdSXHQYNdm233RfHVKxP2vWjzeb2WnEg4F7fg3qz2Eser	359
12612	2vaymysVvVsQDoF9kY9JzBmdQAiWc2Tn3mKEAhMLYyjbWeorUAH6	359
12615	2vbMHTFvR6gnBQdHK6iiM3mj1LZQvMbwufvBv1F8bcN3fKdGXhoZ	359
12616	2vbhNgZRLS1cgSUqgcbbxhvrW951oXFPPJpmRcvmXATD65Acg9T3	349
12621	2vc59ES5eSvWbJA9XAmkwWN55yLQTPL9fxufgbkshXRnTjk9WP6d	359
12624	2vburT7iPJpHZ4r1TZtFcF8p5RBQpjDTe8g4SjzEhZAeP5So27TJ	359
12626	2vaNgSvgLncyCAdwCwLMkVbaE3wHVMdrVxFu9GBeAGzogQ4rDZu7	359
12629	2vbhQai6jN8BKeG24L3ZyAY83MzxdZMMXGqG1Pt4PihpHDnJv6ZQ	359
12632	2vaEVFLW1At7YiwARBxkaghA5aupvDeEwAgjBKveNQAZh77fsFXT	359
12635	2vanFevfcMbQuEVyYkWVRvDUFcuF6mfW49yQbufjcqTz6nfQsPFn	359
12638	2vb2Xymy7dZgAroNR46dSujWYjzDfbn6pv2xXXy5zrZYXxBvyxyp	359
12640	2vbtEgRWZvds12PPgnZQK6qCarx82EKgyLf4MBfmQ9AkypQFwoss	359
12643	2vaw6WWRPuuktKc68VaiNnTeRVfwYxwe4MWQ1bzZeyuwwWb7Uzyz	359
12650	2vapXzS9L3qU6uHT4u1Ykr3UzVgjzawNHYZanM6aKj6KNFvJTCKm	359
12652	2vaXrVQgVCG2svXFEWuVKkcMe434kz8RHwsyd6Jjma9Ts2zPDSaj	359
12653	2vam8HwZLFj7QUJw7T6xXXKLUzCWCFY7ehoceNPnmn7t4DXjcjAN	359
12657	2vb6nZazT6GiYc4Gj7ZKgaVAJ2rPsxFpoocA8PRwWtNWwvjRZhtf	359
12661	2vbAAHzJPP8jQxFcrpczuGTUWGTpLBoHLbxkep3n5fT1xCmvpD1P	359
12665	2vc4r5FxXfLS9aFaFkz3V8V7T2VABKfK4V6oX5ivW5NNKSqFb4yP	359
12668	2vbWE5Dnxoh4tTFquFvmcXTpcCwGHTRdCmLG8tZ1Ris78GmKzwjc	359
12675	2vbpKuBh1CuQ2R88kLZBR8XnPSQwd9t8H5GjgdNGvCWD1niFafTa	359
12678	2vc236FeULTEgS7bViT7dMHraKkHNPoAmZMgkYfULWDTudbZs1NT	359
12681	2vbMpeXn6fPRRUMLZp1DHGBKrBNtgnwuBUucRTNUfR66y9kN8WHD	359
12684	2vbasiaYsx3t9x8kYhZpPu8VzjsxW6xitJe2vy7Q7vy1UzXnTrZQ	359
12690	2vbxiXuCC9AAdzJxmbadTxhfEQj7GMPKJkpipM715t95jAEon6ED	359
12695	2vc1CcMbt33vxUNhfuu6fAJUurzCX68sg27ru23kySMLNAd6z81e	359
12700	2vb5zEKDCGp1WJ45VkNh5fucQYT3ysKS72Bun23TjhubAGfRUe7j	359
12703	2vaVp6ECo68EPxoz1ddDrm36gUWHdDaSWoK3sn5DDZmsvALJ8xDT	359
12705	2vc5maUZDfnpvkCiiUTK2ZvZsVZCL4TEDrFhgh41skeaVom3u4Kx	359
12708	2vbrBXvs4uubEZzkDD6nMCmT5rwbBvVMMPYtFyrTPTUGsEyFhdXu	359
12711	2vbQBzkF24uMZL65UZFi7AK3xpL7Hp1gkz7zxB5s6cd9yRMu8b6B	359
12714	2vbgKocDBEbiZenhmMdwULNBNtNzdTLBqA6SXgEJQcKUt3zjMwzs	359
12716	2vbUTZNEaWP4zJwRPdrMv6Ve52PK9t9STR3nFA5UZhS236uTHBeQ	359
12718	2vbigUkqjjC4ZsncrX9kRnujJQ6JvaiHtouteuiQYAEfZ495oB4a	359
12721	2vai4M98MF8fd9qqMt3sfCddeBQrdBkUSxCreXCx4iTmuT7kbipE	359
12728	2vbWTAjBiUpHRgX5TGHc1yynn1di7MHSTFRjN4VxDVoNkxnoPNZP	359
12731	2vauENKBjoS3q2n5CADQJnL8rYvLgdS9wYveEFey1TDWRJCNxbvo	359
12737	2vaG5pEJ9ycYPd3pG4gPGj2ETBcPgtf6iCCAEuFqTqmaTekeanWi	359
12740	2vbdadBd5htoZN9QLftTWbttZxyj8JB2v6twwtnyGhMbKRu1vMvP	359
12743	2vbLAKRrn39BMXFrNyjeF1U1Ry7qXUYrcQBHJWH1jKFKGmseMTkV	359
12746	2vaiPwBuM6xzDgRQAgmSB7JkFm1K2bMo54WGoMc3dRhXQSPoGJct	359
12751	2vakswXnzDfXHwi34vVv7Qt2b853cgmzjEkerw1EsvyeLBVLNUu4	359
12754	2vbKNqNPCf86Kx4kV5MbzhdAxEFRczYDbek8xUDsvEPMWC32xWX1	359
12760	2vc29q9fSgb3P6KGgi5vfRZbALvKaYfCoufvhZtzCSjmkeCQHrdB	359
12764	2vadk83sn9P1RRVWs4wBM1E2xy8cnGuAxYFAVVNms2MAsuZhiuiu	359
12769	2vaZjmXSuEx6uYXZVXEZwa1Az1Xi3vWFGgSCRyPxLEExjPK2bgvx	359
12770	2vbXqGUcGke8ttnyXxAQHukTSxPHBMxwPhriFofGb4HyxgGmNVve	359
12774	2vajte6oHCf1s9tSKyJAt7zKrZWVFrfMapgDNry11dLz5utdWRaY	359
12778	2vaiKzZiX94EqLjfEVjLz9Q5TyAp6t7dFMvW3MPqJtu5BQqF9xch	359
12782	2vb68vzgG5NKXKkNZRB8E7EqFPfKP8oExNr1EVKjkJVwFidEVTAi	359
12785	2vb3m1iJ6ktHaV7XsShnnush3L5KaDFzZWtPfTpCjzVAaPTXTC4W	359
12787	2vbWqU7rNckHx8eLEaVnXs7XkcdkS9NpEdkWbtMbhpnXCzsTrS3u	359
12789	2vb5nabE2oy5DcraSYVFcpiyF9kEDbV491N3ng7U1NUfqZLe8PaM	359
12791	2vc5WNi6nyenfixh6GC9RS7m2XyESHpstviwohj1DtqTpMCkUzgZ	359
12793	2vbfjUAiRsE5LpEN7indAY5W5VrxbNDLJeq2mZh2ayyA3TBXKYcf	359
12798	2vb2Vj8KDoceAWGBvFJrDAM2ufawbcsof1X117gnfSkutsxrADPS	359
12806	2vc3ts4qbCkMD81BKbxZN5g6g5XSqtM38gZXoddxqkVkdXwrkkD6	359
12810	2vb2T2ZafF7UnYQdZtB2AG3e9Ps1CErNqJNiq4nBxZAms45uYEJF	359
12813	2vbzXR4tgF3rggkKfd28ZAAtKBJdMnV9t87FGfiTCC58sfphkQRm	359
12816	2vaKkRocjQuDBkwKQxVcA7eEaTXAZRG64heeW45mBPGK5PfytHQg	359
12819	2vbBHGBoGswgfBKERWJ8CWWY6mZQyvTmVTTXRjN6ZUSuy73qCk1r	359
12824	2vaGrcq3dCghU2bgqzm4NFiQcujmxr7bcUEWFbWgJfUid4CLqECx	359
12832	2vaaYDSdL1CwaphQ7kjHjXGAfoJPSHwMMXu5adiVUKY7R6kTJfNB	359
12835	2vbCC8YCEsSMwDViU9zsjY48drjFqTtTu8cnZLJ3YLeqsT8j6Ws9	359
12841	2vb8w7cMtiasjHqKMk83NnoDN3KN7VhskExBicE3n1GYzrKjSRER	359
12842	2vc1LpUEELYLHh4oN5WjAoB7HQz8YqDQF9RkrbXrGiw8Tg2QnVkz	359
12846	2vb7Zb4DuWVHsY7XBF4ThezYchbqcnMhsUAueEzZHSR64Zu6SPjP	359
12852	2vacgoYoZ86ZYy9VRyEevkNL8LyLh2ntiENn2PWPSqdzuR49HEts	359
12853	2vbKLbjTsWxWAYk3aaPsAwAqTn5LjDqh4Ejp6VMMzwdyRyvsmxdR	359
12859	2vbTTJvnY6ReDbNcdhVLLAQwpDzhk1nGYu7ibZfmoMt1x6DYR7AZ	359
12864	2vbBm8nHqKc1bBpcTbkBFjunfPPUP6N1ruEvRym6SrG3W6Nsyx7h	359
12868	2vb3LJDdBvi58iaSNHmWsdqS6pwUGRuo47WvVPB3zz8uqpq6yAA5	359
12873	2vaNFt96VqtaA2Vn75iSa74ysSMGjpaYuhpi5gmLrsUVpEz4Qfoo	359
12877	2vbgVWb4a1mgZ5bwyyGSi27t36ofRFMDS9ZLvuEDZrGcmNNVNYxm	359
12886	2vatJWUKmJJbqo86u7dXYWNeFc5MNjCjVYV5FGSxwu5gNaBBb9CV	359
12891	2vc5WkQemjiZ6SQ9f2ZBY2w4pM3ShytkbC4Ao1HYdSt3NQNTNCkW	359
12895	2vaJXUaX3kX3UXBtBE2KBGuzPUQCVrLdYAX9sZapvNPXQsVavKcu	359
12899	2vbUK4KJv3nTfFEC1a3NwidhwRiL5Fcf6NxUta2pNzHLz3f3bfks	359
12903	2vanka5NfYyGgtVpT4PrNpapZauQnxaAmKKWcQf5vbfu9gxjMVVr	359
12904	2vbi6sKqGcvrRbrPB4yupFhpuA7TgjcwJaKgV3hjEEQtHrZJUKMR	359
12909	2vaYYSkxFCUs2JYvGjcRNa9VjRoXgXG93siNatFAgfQFkqYyLZMs	359
12912	2vae5ADMdvfSb2adksW9rUpJefkZhZJoGytByA4i8qB2whUAvKuW	359
12913	2vawLsXfaoZhBhF6E4B8AMNtackJbQJRATV6B4VSnVf8JzxU1kqC	359
12918	2vbBE19Dk5pqssmdkjqpKevFZxJoiseaBp3vvQgmexxtYz8sFKR2	359
12919	2vaUTqukiJGxBcaV4gW1zeV7Twp8Gx75zNUUejapuFLKasSZwftu	359
12920	2vaEPjeVMwzAv2UG3BVSadqpdCXn4VZa8goVR7PJbPqrQwkmhg8V	359
12925	2vb1qodbusA8rqXCHf9zK9S4NAjRN7gAsKvAEbf6VxF5LzoDQ7ks	359
12936	2vax3i4HC4ujxsbq6JVx9WnRpgAEgg2GEqufjAjQmKK2zoraNDZe	359
12941	2vbWRPM6frpAPZuEP9evgu7u1Xa9hS4j2Pv5dcg7r4vYEoMc4iRY	359
12942	2vbdrtRjwhyufmqtCcY8m9gvJAjgrHAo6MQZXNaJFPN7ikLodb8o	359
12948	2vc5dr1Czeo84TLbpVGLn8LTW5djnQ9s8R33KsTXE7sgee26DeVD	359
12953	2vbnuDo4NgasWWPMsC8Do8Epx7ciPYqahbHba946Y5nqL8L8sMyA	359
12958	2vbN4UAcmrW96Jtaw3b5FkG7czL4e91ty3UidJccb8qPwR6deLEc	359
12962	2vbcV28zy1YiNepi4Erc7bg96zaGKGDR4TwN9jNRKnmHW5RFtk5Z	359
12963	2vaXwh6z1yjUQ8NA989yLEWSqYoeWMddsTpRuoYEKdUAnUwgrQWn	359
12966	2vaSuNGGUiSCCA8CpjVMT3KgANk1EYjRxNfNm6kwYXxGGj9oBtqZ	359
12968	2vbYJkp3ZKAixMiHoPVV4zya7E1VhA1fWjNU4gZYRCsy7WsvGSSK	359
12972	2vapyY3rHRvU71vP6f7GaKrcxcAvHYP297StQUpm2wgGzUHuuqqP	359
12973	2vbJcFUXEPdrKwkq8q6vUjhEieFfR6RpEWxSwEdMoPf56XVF79tB	359
12978	2vbFbbudTUM5Qj9XJVJFbTNXwctJgocCmZJkjKAfZci1XTn2wo81	359
12979	2vbX9zhrL2MeaiSXT3DbyVJtuZmdXG1enBfdF48B3JRqAGbKL48e	359
12983	2vavVsXPUgPs63KXHtpMxPeb914g8JAs2fPZ9y78te2ESapVMmr4	359
12988	2vaWtWBYQYukN63Eap4J14uMX2VPySBZTiYYRWCU591DcuUQAjuR	359
12989	2vc4ZWcdNc4wWfAV6AkSbP1y3zZKDD1DynGZLEcqe1kiaeLwxYJ2	359
12994	2vboRKusHqCc3aJXN8LSPJ8njt8o7aPsrePDnYwXBGLBoQNXWyoZ	359
13000	2vars1ST4rBsVgCshQqVMyZEC3ABWeYqa258m5gUor7gthat2JVD	359
13003	2vaHSG6wfpy1CuLJ3C2sFF9yo8yaRShXgFi9tHXAJD2hCBK9pYKY	359
13004	2vboi5cJstWCM87KW6vzJDeLbsUiCmGoapximSbAr1Sm8wvJN2D3	359
13005	2vaVG6jovDkeksHidS4iaMJdL7JumTWLM9BHLMTFE8Umusor8RSo	359
13009	2vbHjdNKh9o4WcWHFgNTgSo7ff7z9LoWbY1hAhLPgrHNuAZjDZN6	359
13014	2vc2EHuUn2LvstUCJkfL6Br4AeCM7K4FqzJ7dEgbHLfefEmks261	359
13018	2vbwEj5vgAVVyu1RqGJ4YTkkKkkfnUzGdCRfpAPXJgk8mSz3cFtN	359
13019	2vaRX1PZdLS9ZPVievbhqv4SfB4AsVRizj2FNWqgFnrs2ruLCBUe	359
13024	2vbiRE384ZU9aWccsvEckyFUNiiJJ6X24ngHGpEZVkiPh5dXPyKY	359
13028	2vbeM5GbrnWzYh39FHRbTpGHZNEMyT2REsCBac8JeTpUYYSmXFHH	359
13029	2vah5YtBYSLEsfpqS44zf2rTJburbPzBLgfUV9JaaFMozGU8Mqkb	359
13034	2vbhopNNXQCSxrx8KLzE68siwadY3tgWZaYgxZqqky1Q3PnSEZr8	359
13040	2vaFrC4kGpMB98SCQSHQvVgGNoWWkdog5MPhHCrnXyNqvYHdgpF8	359
13043	2vbvwTYJZxnNgsfrnwzTaD6SggrZcTAqQ8AXwm4wtAVQErc8UXkH	359
13049	2vbZxoMHE74sRckjjgYokWvG9s4ZzMoMipzavGdq56gDr3KCWbrn	359
13053	2vafRwx8Z1tgijKpazWxB4zXdvdBcEksvY3JdYDVKrvVyghDfQ3F	359
13058	2vbM1c683CPnr2AhsnNspCTpaFES5zPfLBzpKjJgpaKCGxxySCFo	359
13062	2vbLPUsNEvd9dvFGbV27Ag9nd2dNEqibjwrQGSTEYLy3CnWC1kQb	359
13067	2vaqqJFu3AKtELBGBncYX5hBafTVFMajo5TWaCADhiSVc9NhBRWr	359
13069	2vatBskLssDUFH5TwBPam6CfrQfnMTXC8uwWs2kHJWpttJhY9Q7o	359
13070	2vbLJGRdALmp8M426JhKQnajjmLebf149j6UhYrCSgQmc7cT6YzX	359
13076	2vbp6XAMgKF2kAdYF9JurYAeD5zPDhUGfMkTVLLEMLutygbSo2jU	359
13081	2vb8Xt7438z1BxiBmGnJp5kbBhkWkYSD9RzZaE7UZpMh7wzEDNyq	359
13082	2vbgkmbSxBzMbF37LqUncarBTou47sSquiuNwt1Phpi4ndHHAac8	359
13095	2vbubMpYTPnVNJt4EhFvnk84gzNPdWcUqjbJcEokWkPGFMxziMPn	359
13100	2vb9HqRXySozLZVZagKTib3BEGRi2bPHdRsQStH6MzX1N21yoiEP	359
13104	2vaisY7GZzSqBAMuo4VBk6fbCzX6WjcxGx6sk4npiLkM2xjNmWB3	359
13107	2vaghLTU5pBVxvVqc2CQcYhTX1Vf3AHanfpHzifwKrWEgTN55p7j	359
13108	2vbriVtrHyABRLibgqfEGdwtcL9An2NUgKkzsG7mJQWusbnTfzCQ	359
13109	2vbsvdXMzBPgnK8Wv4m17bTQawf8mnMpfGSyh1rBRCsos65tFhNi	359
13110	2vaC7xAdeg6nPLYdKTmuwF6v1bqrpWkP4BFziX8x3TpL4kKxowAm	359
13113	2vaDv1uUtJitc5Y1KaUU8xQpTxGjpZ9yGkucoUokh438WVwNcqUk	359
13125	2vbX9gkn6eLgAAVWLK6LgE9QfR83aqkYySXGvxx5iyZepqQGbJTS	359
13133	2vacSf1sqZj7afKyiqzJ9QFBe9n9GWJr7CjfMEsc8kHbbpmQdMT1	359
13136	2vbF9mENMUYunTG6nz18vmAvqeQwrrNi6WY15ec2D1jew6yHnpZu	359
13140	2vaBhsspnFcKE63CdzoGiXvRtDNtZypLNDq4iejb8Ys3oW6XGGKi	359
13143	2vaGvXoJJ7YxqrniSxSnS5oJ8y68yBvDihCzYeg22e6sjDMTC6Cx	359
13144	2vaLQu7GjwMSD6sGogdgWjFFpZVtTRV249oRR9C1f4JsE94cdhvu	359
13147	2vboaADDEn9AEn61iZXk6AxziELDhFpmcoauavx4eie7WXqWL2KS	359
13152	2vawLLdT5RXX7WyVLSaCHbJQiuHGeomhT6ui3SW3Mu6yMLagPQKA	359
13159	2vaw95GipC6D4Qp2qACMT6iXiHEfGBZwY2zFreJmmJRTVaKFiA5v	359
13162	2vakRHnzd2YqtToR3xwma35KQSipHbNDBHKALiJfMo9GWt1ELn5b	359
13164	2vbbukXjAD3gNse3cUmfaqbHFR1Mf4tuNioTf34zEFtWWc5EZxdb	359
13166	2vbe47yuThBTn4VAvwuJ9pw85t3dae8Lu9GYQUA5ScytBcwx1E6Z	359
13169	2vbvm3bzZfNx8dTgamGrjCSrU7C93PLzorkbXQaWQNJXx3qGeysJ	359
13173	2vaVEP9hrhbK7VSD1mX8d7Ssn1TfyRxMtJbY883W6X2FeneNngiD	359
13175	2vaHkTznF7DLHs5AFHuybK7N1sCXDSUeRpvcFZfvkxFNfdLiodPv	359
13177	2vaV3F4wHb89kj5qFaynYHR4ChKXfavMTH75sEm7TZWJPUbeGhBB	359
13182	2vaGeTe8Q83XiqNAcqzFDBdzktdCKNYqLbbUSLY9bPRuxtnDLa2a	359
13185	2vb37HK1qCmapcD1ddEccQyoFckVtTxRakpz7qaAiU8mHfEgjP4A	359
13192	2vbHoGRGhy8tahfEYSKGx43F4Lmsxnz5HfCjwTqnB4bed824MxmW	359
13193	2vbpKV8YCHT7jSac6kYpbnQVbrTRB9KgQqXfptVaB52kCrb3vNyZ	359
13205	2vbeWvtjpXUR3KVbkZ6cg6L4ipWMmUFaRXwFnE6fSz8vhdNg1ykj	359
13207	2vaNhjuG6UgHkntfKLKa22ct5j7H1LraBh8ThaxRD7MiJkt2XAL5	359
13211	2vbwubqvTcrYwwvTGQQ2ZLCkAsiZVZCLUyBRBRubgaaGsMuQ1gYA	359
13212	2vbcaa6ZsBojWCBmmWMAZmHAG3tBAWzDstKRfNPDRr6xzJyHqZB2	359
13213	2vc4doWymrpC1yA7e2RJSJxbWqdBuHVvSag1TkqAuKwzvPEhMq84	359
13215	2vbnsLTdyaU32gyyj8VqyZFQ9RmhGZyhGMpznze6ppEJiuw8k4hM	359
13221	2vaFjz1cJuDwygmJr3hDQ16469yDieU2uKsoJsMcfzPpM9BetpxU	359
13225	2vaAp8Yr7Q6Wmgs59UBbQ3qFtSdSJvZ7eVytmnLV7jAEKSjikCNR	359
13227	2vbhXkWanZouNrYhXdQnLmyhoHuA7eHLg8z7cWEpsBETwengLAuJ	359
13232	2vaAkNVMvQUGfraXQjUz5DN1pKzcK649Q9kDsDLa6FS79wL2f7HS	359
13234	2vc4t7RkzfYkk8yRM1uvLacQPK9VgdNTytXBhwVryE99tkrLQJRw	359
13237	2vbietGVStRguSkuS93iHpgfprh1GNqah2QoTGsmyfDCBQykBEVk	359
13240	2vc5oG79qhV7BM1hw2C9H73Q491t73JQrizjx75KaaZwjJ2yEw8t	359
13246	2vapXfooepa5nXBVWFHEpyUPUboyHSL6Cm2WFfBfTzG6B7unQRZj	359
13248	2vbkzWwrj4JVNaLt8UADyTF6VmoxPBvMHCPZuEpSfQdGEqVXyo51	359
13257	2vbXmzLZKcEoWxMXd2TDcdiWaKacYJVvBL1CJbeaPFCyhW6PsJ6a	359
13258	2vbQXipztqCD753cMGhV13u3SRdbZof3paNj5UKnsnvVLoYsTkgJ	359
12926	2vaZL2Tfw43n5xFKXhn8qWJ1NRefGEZpCfbZHpJ2ybyuvN39PUJ9	359
12937	2vbFxo6iTyFVxzPiKzohqDkKhc4JoxYMzRsdP12VwnF2m2jgCY3M	359
12943	2vbKJoTFxprHb7S4FAfYqjKZUk12mgTrBroeb2oRHCrvo8MLs4rw	359
12944	2vaVZCrtKW2EYPFyia4CgbGuxM9PSr1iu6k1edtm4T2j9Zfp9wA5	359
12945	2vaDCB5HPbWRNgQGMS1gtN61A4S1ws5MosYBifmH7K2KVUYGafBp	359
12949	2vbPxMfCuKBbPFMm7s79yC9XXQdJWALbxJ6Acq9XcBvm9hGEd16s	359
12950	2vbZ7RD5j2srTjep8AcuB7jwkh721kba5HusZrX3mJKy86xsZ5cr	359
12954	2vbdUpmCB6jrXnqYH2Fcm7BtGacJRMcaUmfVvQxa4Wv7DEcKPcFP	359
12959	2vc5WWWVqBDSgr6ywpL6ELiaUAdaB7QbhPY8yR6FNwFvfJKmxSUf	359
12969	2vad8AzyhzMknGjKXn4MNYRZv7ZLWodrktggep5GCqyTpxgTxQUo	359
12974	2vbeEUoE9wPL4VzzFsYeXyHXVsjEJ1XzXx2Lr3cHktxicY7sDqhx	359
12975	2vbQkrBih9koC6APap6WCHfthnCVn3iU11p2XkdWJD5CDGac5S2d	359
12980	2vb4Qmahr8b5Kbr6eqwcq5TUu65qthFv6PbweeE9WzGWWHYnTu6H	359
12984	2vbmFLibh9dLYSSX3eAEJejQEmi1SFKUJdbabzft7DU7XhMU4s4A	359
12985	2vaBMZMYdVimMZpqdbm7b5KSiG23GpLTyqeQFWrWkyi2K6XRr2c7	359
12990	2vbR4jEXrMmsPU9xJ2H6yKdtdLqf92ukJGe2m9wjRQiMo846uG2n	359
12991	2vauH35bcBf661i3xgtLrWxqGdyEULfyhzT9U6MyF6EVfXcxtkx8	359
12995	2van6sprzHoTA51TGRg721JDkJDyNQXtbUhUTMM46nSTiekhND9K	359
13001	2vbNGvgj2cJP9sRFLTZ2cn8FaoKfL1xWQxJKEPk1rqp3mgkHHGCc	359
13006	2vaVNPGUe62GMta53pa6eTvFGUWAZXD5PV7MycfUni1Krf8JkF4R	359
13010	2vajZqSbU1UJkdwGF4wEEZk1b6hZQSbBNZRAQWNbio6y4FQZYytu	359
13015	2vau7ZQM2qbdF2FuQQGHKJAsWBVGrdpXiRbdt2zJwXfRmWqEzeMD	359
13020	2vahYn1Hj8bqLbq9fTaMmsUchjA8Yqqrh9rEDDqJrKqRMNnVFtvP	359
13030	2vbPPjxDM8tYGdQCkeV2NTqR7BPxq9M7rt25d3MMkChrEaknfobc	359
13035	2vbwaZYH1khFeL2fC7bXyN4qCDSTq3hynwt2kdotinkhGuiZaGkk	359
13036	2vbF2BP1jJHod88tepE6kiAuyo1pbDLeQJfJukTgXSj1GChyUeqS	359
13041	2vbx4GWEJY717tLZxU3FKXdMtVTEzUWErQs29LdbVbTzD9EmH59C	359
13042	2vbdSrAUyBN1BNnyvoR65vDEUSeDDY6ca7H49veqWGeT1CK2jkZf	359
13047	2vaekvgUUqhA7H2evHHprxt2SZHgFaZHqhKkbAqts2m3cGmX1rdM	359
13048	2vaUXZ4ANMBVzYK8DKG9g5jUL46MNhytzBBehwokgqMiweuGJQTp	359
13052	2vbaKxDgzdUYrk3YA6R1ceR9Rgh6hxkhJyTT3zsiFiTx4dWae8Xr	359
13057	2vagwCHm7nqM1x4JamGDNYKTr1uD9Ku622Ao6HUrVJLoADCUp1Zf	359
13061	2vao9YYtaNPEQcLpbsemNMMj9oByjuXSGmw463wBnsJJ5yqtXaYY	359
13066	2vbrHyiVe3HJScA4YuxB1QEtdhrRza4RiK42Mcah9UcqRkLhiEn6	359
13075	2vbyWnf6hSH1cuWtRkcf21gGSCPA6iLH4hzjbCkTAu9UZsgLxKHR	359
13080	2vb89v7DihGbcnRLYUHjidWdjaQotZdNh7ghuhtY8mdNtWYABEfz	359
13086	2vaRU7UQNEVGyp51AofcQrz8L3TcbwurzcDBsovc3TPwEft2A8CU	359
13087	2vbgrte6JjtZtCZBuXWkyCedscWr9Hy1kQ58yvM6TzRhbxAWFtcT	359
13091	2vb6ikv8efLuyKiP7RRZppRXVSSDvuRASDQ7cYmjtHDmngt8xYwX	359
13092	2vaYsrRocmjLDPYAoNcDF5bt7nUi5b8Pa2c8TyNFRUUvPic3eXeP	359
13093	2vbEPUn1dMND96J2bx5Rxtr5vKba1ydwJJEgqRmFDPQ2uG9wNp4L	359
13094	2vau6GthDpVjGvV7iHzhQHbjL8v3ijX3xsQF78yy4jWXVJMEzPcr	359
13098	2vb3Cz1sqxSfumosYpDS172txaFDr9EAXnSFYPx4sui8KMhHvPQU	359
13099	2vbxAMnBN5QWV2n1deLrVaGeMpr1H1dLHmY78Rd6buEJ43YxFSt4	359
13102	2vbcfKqCTDzEHaYoBxeH4Qx2u4BRuKxZPPrmQfLAcN2693uCVgTS	359
13103	2vbRLiTr9fBHKSCM6JGJ9NjdPh36jHV8NY19SPWYEHG3CNg2YaTh	359
13112	2vc2ZDZi2cvfwUTP8CB2dVPYSiP2g9SzukybhisGSuxgFSeYUHcK	359
13114	2vaaAfyiZ2MFTUv7pJHsUMVZaUjZsqKdSMZZkurW1hzniA81mhcX	359
13117	2vaQipiCABCwAeev3jMhHedF1HDCYDWZUR7K5w2YZGYAKAFLfvwD	359
13121	2vaHTKDVJXPty4edMG93Rw7kbCTbLf49DTkSBmp9W1RXCxuj9PAB	359
13123	2vb1LELG749oiM7pHZjgmvw9m1i7tatn3UT2uA66Mi4vruqsrvDe	359
13127	2vahKkKid95LFNQtRvsp3oooZJoQ5Mbg3mBQLRroH9H4bs35ujQ7	359
13132	2vbYyV7M9wo2gouguDRYEN7LXDvJrouQEAPLRxLqJLh6CbuFEa9Q	359
13135	2vbg3ShUQere6nzgNpBj35o64Fu6mCjAoVGPHenj4CCcoFiEm2ZK	359
13138	2vaznSSWuxh7QQyR6SKqvTVy6gpNsinsZSUNYJ55xTRjGGCytSt2	359
13139	2vb1MgEJ8hyD9p3wqQAszLHSxWpoQzYRvRuvhE5z8Wp694rpuLvA	359
13141	2vaCg6FgzDKpTr9kNkmmiPdwcSCuhd2vUqFrZkVP2s4LFjkba3PS	359
13146	2vboeN4UEb4WVAs1Z9XbLdYXKGdoSicHkkKuZVFvPhTFnP8f78tb	359
13149	2vaUZS4ajwvKm7ziHwC9cekXXUnWw8b52zaoBzxPh1c42yxZc957	359
13154	2vc4t8ciDBwMbcpdR7Btb7JDStJkGqdPFJFouMaiixRY7KbQiU1W	359
13156	2vaBDZSEF1y71T68BzqHr5XpUGsGvjXxQK736pxWtXYEW5zeP4LU	359
13163	2vbFRHPDkFTsiuVHtAZ3KjR37kteXHX3DwRPwsSCefWLtRUUyamY	359
13184	2vb6sKLV2AzRGo3V9jkJRsKBUERvjHoqJk4wXg54BC27mEvHP2MP	359
13189	2vbK88DpR4KBkHABhr7rt5BFyJGErFXq9YmwBTQwLzwTTszvnfSY	359
13191	2vayexFUqAGb6dGVDHoSegGgwcWQ46Y59GRTfrBQn1N9skfJ5FnB	359
13195	2vaTQkBK1Z2KNJWJKGWBUop4jNBLN763YG2iajWW8pwMbK69hSro	359
13198	2vbLUhrYVtFXVmZMgp7SoUtyL8LBCUJtRJF4aQRk7vBFzdCQ9aVR	359
13200	2vbb6VSzHe5MNjnLRv3YNUaRtUyaP9TKfBpNdX9MFLUtMKsnq64W	359
13202	2vaVbaFjL6y4fboJnZ7rKsVsygqN1TSg57vWpXerVf1YQwDdaBDZ	359
13204	2vbj85roKXLtYjvVAzrZL4CHK3vGgKsdc6yH1wP8ExEySXN4wRBY	359
13209	2vbru1Q2JjSG5xAn937ywaUWHmTgRKXeZj8VjdtYPbcJ82Eqm8Ra	359
13214	2vc3GcBp4jyXJA2y6RmsnvR66ehzLDYNEvGPopRApLMzPtyoSi1N	359
13218	2vbFvuPTnadmXqJ3JmToyyj8yUUCLr4XofXpM2uPWUvn8hvRY4Xd	359
13224	2vbPQS4GNjYhyxTfPiHzc9tU8RPcNAhknVF9Qs22rDRi6NwuCATK	359
13229	2vbUoK64HY17HGxCHds2LM9WM5wapNzzyPnxthrZPtBc6gbdNxLs	359
13231	2vbWwpm9K2eJFLhfSKnwEoG72o6HFZo8pimaAkEneHFW5ebtdx5v	359
13239	2vbdNR9q9NQZ9UGKEkZwxgatQfhDHvxPQ4abqqixiwMGcYexJVQX	359
13241	2vbkBWbATKyZJdVX7CHdnsJnUMtdjmUzxJRv1WmT7KPCPm1uxMTw	359
13244	2vaTzQ5GWnJPR7RTp1TwpkCC8zdnkpjbNQ64Weph4m89wykErdsv	359
13255	2vaSibnVFYsjVjPzfPpremweTc2jb5x4x9Q4HoxTDbdzqH8Sm8rm	359
13261	2vb2yNZ45FY1xqiMeTmEZWK4uDcVR9HvwmxDdmBHFHpwH6X8Eqvx	359
13264	2vbjE9DAmAwk5jPD3hhf6bU3TtgG9GmzgwstJFAD6uNEu7SQkHwN	359
13266	2vbngvqQiftKye95p3Wh6BNiVRZ9vV7zL9cjU71QQzwETjPtzkmH	359
13271	2vaieuWgQKp21SR3rNyJ16Q4ZTNUGLdv2acLPDDynWKN3c4Ez3VA	359
13273	2vbmCDAecQ3wb5RvMotSzi71YB1fs9uS8zSABCq8M2FwkU8FTSKT	359
13275	2vai1CDH6sVSg19cPfeC5TvQrFUEskjgudZHBms2p4zeupXLD9ss	359
13278	2vayrzBWJEqTawVXpdLQsHabZcPGcLnq7BcCLngSXwPqUXmwE2ZD	359
13284	2vbuUYTRZBXH9BX9zgSmhHR16pUFeM9R9LqtTuxPNyzyTqLtSosQ	359
12952	2vbErXBNdPPS8pnCYkoCsi34EtKGkgo3g8xh7Ui26od4H7S4Tua5	359
12956	2vb6NW8AGwZQQa5VuSNsHy54U9WXwYktcqNZZJs8c2ny6nHnD8Ed	359
12957	2vbpYBdy8nkmjdiWqECS1qjQGedzenrutSHJmsn4gvd3RXLXXsvZ	359
12961	2vaNXFZtm1U79up5tN7FREJDuRxPjjcXJG8M6CMnP7gFGaJh3RZT	359
12965	2vbHe6RZo8BqeKbGPBUsG1HjvdHsBy35eR69Jk3SsaBMFNxufGKG	359
12967	2vaH8Dza6YXYKzLhVqRYEgtEt4xazWL4pdYBtfrv4zhTqKjgkyM7	359
12971	2vaRrBPRZF5AH8ue3oD9M8LCasMYvcUitkN9wFLvNVLsE5ZoLQX6	359
12977	2vbiB89LV8AbwnuUwQNw7DVGPgF8y2yySMrGevVF8gvdPreVw8fe	359
12982	2vbdbRXWfocHMz9sYVFH46RJzF1XS6W1v1DFbaUWtN8Z9eMDaT1U	359
12987	2vbtNvTMchbKbNArD7mQQfhyyuTVP63mSAqct88WEysibKptM8Tw	359
12992	2vazr6Vhc1Y85fc2dYaZdYzimoCAPhnwYB64WYn3ScG4w7aFHc5T	359
12993	2vavqx4H5fe31ov23pi9qDEcnm3UpWn9GbCAKRKgq9d3FoyHizpi	359
12997	2vbPoUDXLkzyjQeqnbBM89f9y97imUWXxr8HkQKuoLWUZTPdcWL5	359
12998	2vbEtLSbxiJ598paCL48ydpHDdj7EVHdDaeiLdZaeNjV7gZWiSXr	359
12999	2vbveAiznbguR2qiUAVoVfGr6NvzbqMUT6fAUa5UXDQWP9M76egS	359
13002	2vc4WqWD1iU28tpN3WgY6WmDpgMHi3kVDPQVFJbhE6qnWyNG5Wub	359
13008	2vbncPXNxgxRQwCmPWNzu3oquwhGPZEnEZcvERzncbvAKuxqefwk	359
13013	2var8TkuFjA6GTa3UWPes8mG6at7NsyYiEZg2qaWDyRMa96UcnU3	359
13017	2vaWbojar8jgQQpySDe6wMqjMSK7GJyzWt2jVLCF1p7mPgeq8ZJ2	359
13022	2vb8iwEYmERf92UWQ6XeL1wssNu6dvrmtStE4fnWH78tkshU96up	359
13023	2vb8ffupCi8v9x1sAvgdBvPsoUMiCUU2yVqm1bKz4H62mNQE69GV	359
13026	2vbJjXzuMdAxTzQXBzZ6eo6nY4ruZH26arir7JpivgeCuU7wTX1h	359
13027	2vadS18c5YgWetexoToRXd4HoxPTxBh4ZW4Mi13BLaaweXgvAuDF	359
13032	2vc5Tt7PoKUaUZL9m3TQjLnkWoqYtHGjL16Hkt3fiQkPejCzRifJ	359
13033	2vbzfxc8igNUZmK7URna9gDcJXHxAuKuLNe6ryaS2dZjFLcEzVUq	359
13039	2vbGh89TCLpgAahBRjFYgGrocEG541TyQtQe7pSnoi7M8vtDNcr8	359
13044	2vaFPgcYG8BSpcbMi9KCfEEtQ23AgVZ5mfVTRFPFb9q1THkeXdrx	359
13045	2vbxR2cowraYdYdwVNzBYwgx3cTFuPwe72xhAtkawgEe8vjtmUWZ	359
13054	2vbLB7PnEJSrTFri77Yt2SKtn6AX3URPd7bs5sh92k4fffuhJxiF	359
13059	2vabNffXmndLRGUUT5uxkTkmXneemSZTSB9Ny2vKZUCKSApGSn2n	359
13063	2vaGWa7TNQAq9fvpv9Xcy85qUJtCwKa62bPKPRd36oXxQqUC75Hk	359
13068	2vau5CJ8kwzVK1B3mpzDkCHU3QRejvcMh8EAVwJjtj4cNxyNUv1o	359
13071	2vbLdpg5jt5VS1pYLjySX61UGiuBcCXA11oWivxB58h228HsQzDe	359
13072	2vbBt35yS3NHMm7EoqRu9YUNrzfhx8Es5FTmGmmnvPZx5vxwQigr	359
13073	2vbe2tiD6oXEzL36feuBFoiYEXdGpoQEBfR9w75MDUdhkr8GymSn	359
13077	2vbkMGC7Q7qT81p9LYK3fnomY7p6URXFv83vhmAATtVYdzkRWPZC	359
13083	2vaaZzzwCR5h9X4hxt6YTJPtHczmPEViEtuukZKZJyDnjK19kwdx	359
13088	2vacwbYXfrmz5AfnJ6sjuNfPfpTWJuPEZMi5u6GAxSFv2YWY5kwc	359
13089	2vbCemkNig8gLMe6TQzGTPDHC8zj2zz6DQAVubWQTmuGHKuAiBsM	359
13096	2vauXzuKcpqt9o22FgucSMaA2fbuz1byMLDxSjyeefgeRt7PtARe	359
13097	2vaj1zUUG18JPQXyycQbsPpUMvWWxhvnpmuWpDyYNBfkacLNPxe5	359
13101	2vbDv37jja1JXGQroJCPpjDquGnwsQRhWgZqq12qhHEPYU88Rykm	359
13105	2vbFDYkZ3vVugAQ2iRqP3BU62UWGnJLSJxhFsyw7cxNMkCGxRKtD	359
13118	2vc2dgGBQhVWa98usFusunprowjtiq5iRZstMESzEm36dUsi7CwA	359
13122	2vaEzAvCNvibcZHJ9LKpgWX1qhXrUP21ny8jbqMicvRJkqxuksrY	359
13128	2vbiRBZ9ZRw7crLmyuicSw136kFG57tCB1uLqhF9kL4NzMSK4MVG	359
13130	2vbm2h6QiuWn4Vh5udWiBDKLbYSApSAHQJFQeKTs2MyynpHehPgh	359
13134	2vc14iXp37zdNjSw4ofmZD5c1ugCyVLWAnYJmVo4tNyVkC651opu	359
13137	2vbabAMhiaTfo1u4V9E8ZUNRiTaWB4jZ5edmkTeA5MiMC5VKfggB	359
13142	2vaFmve4XdGWUhsEDWtHZj8e8KNDArwkzubXmqGfpfDRDgWhcB3h	359
13148	2vbDsxT9K2PAA1gXDe8hc1ULFQZeFrXvGhvUiEbf8ZuFANkWPR2n	359
13150	2vacfBzb16r3YhU6F4wLgRZ4QicjUHYN7LjqpwhpNJRrQg76bFkr	359
13155	2vbVB8kzLBur8mm7WhU5ovwLi5Nn9CDwMExpTBkMJPVniGKZBwvj	359
13157	2vaWEQ61SQ4SzuJKm8FWUH5Bd44DeFtEvDRwbHZtPe6oHppkdAzM	359
13160	2vbANeGAnLYMim5NBuf8fBDb4TDDmwYvPtHLio73XrkRuu9Gvtyw	359
13165	2vaojdNoMRsTU7vnAcTpPaYRqGJKZjF3TU6xowxRXYYVXvsHzmy1	359
13167	2va9LvyA72633dteoYo1N5j4g6WUCwedyqyc79ynVW5TWC6H7ciJ	359
13171	2vbXAuCpevDUnHPmY2VWCQutWjQZL1TLz8gEYgD1cjkvgbbAwvyo	359
13174	2vbs5gaV7tyGCkWmPVsadXqbC3iRSvhvEys2SKtEE4V5468JL6e2	359
13176	2vbeGEGWariko8kEcq5ZyXAxa1Gc4e1tLFW4amD48dWNeEQYL9Xi	359
13178	2vbqxCRMNeA9t8N8uRTJhmPYXKN9TqkdCEALF86iKYJa7QmmY4sH	359
13180	2vbgqqTMy7odviW7GaPRZFcajtXNwBSo1Sj4nty6TDbH6NVkJjAM	359
13183	2vbSPogyHcBiUAJgoxapDsJ3v4dDaPdjm81N35U7T13bd1YEdEUC	359
13186	2vaMWe9HycEQrRhVt18Te5gFJn3erRWY45B9m1Z3gKSMc7t31F9h	359
13187	2vbJsqFxHLVTMgG7TaMbduaYuaVPjFer9LJPNanC1ZZ7PJ54SKgd	359
13190	2vbCit17hCS5qstAG5eK4SHXg1o469xx3hywtbvGn6ZH45TryQX9	359
13196	2vbMZVrnnNb7SUWcezvEzRdWNGe2Rn4fzCWASfSAuDFwzrpM9fiq	359
13203	2vc16Sbj3DHAfTYZGbnbxUmrPNTzkFHpveBXWetTkYLyftBE19wC	359
13208	2vazMwzX42kXdX5FRXjybw1xpfgXnfFo7B1qiKx7sZMSfRGJur7b	359
13216	2vaQNWNxVkDKvSKjp4U8LHiT15BezTMZjVGUCRPLiSoTL2BBfMwA	359
13219	2vc4BbY8gtcgCVHqYsZoB8ZXwYyNM6E71ZCDumYtMryTemtmnEb3	359
13222	2vbGomxMtV1SjQCiTQsC68JeBqKbJzGmz9ayEL1fBa8QyRQJKhkh	359
13226	2vbeBpjhm5cdPkAK1YRRZ3ouawZFpV5Dtdr3mhD3K3VX6XXp1hci	359
13230	2vaqXc7R16HciSen19GjdoG6W435iwxMJgMSGp9Ncto8zbZqVoTN	359
13238	2vc4L1drEXstkytrRz99U18m7vcMxdtAA9P2hkXLHNsM8esS8Afy	359
13242	2vaXqxDnZCAZmpb1MJ7CWPUtNpiuZKZYLtLV8axJtjxT1wYMKwBo	359
13249	2vbbXqPhftgjn23KYsqKJez5AnmZmxtUFN91hvB1BYjKcN4ycn1B	359
13250	2var8nAsMppSqRHvWwWwVBxLxxb235MRXQ2f111Xhi4b7dwqcv9X	359
13253	2vbzHpFrXnMTJgKP8ZXVpebTHmQuLTpePZFUAeH588Wew2GAUSfp	359
13254	2vaM8EkadtnB1RqwJSpWLMX52EXj6gLj2oqpvcpJ5hpDv7Ltjk47	359
13256	2vaZwSGef2oHMtxvGT8HPodCnS23NnnWgqsbqBZVFbnCQTmtY5zT	359
13259	2vaASQmvcP1VioYJ6MZbkEetNSPNb73de7oLvzZKh8465Zro4R72	359
13267	2vc2PnPG1F2DaaAVYu787mLnQMECHfASX9ADYCmTeYPp72n6yqEW	359
13268	2vaMAbHwc5cmP9GRN4PxfvGjreshvd7RHrNLUnLhMMejfxWkBvdC	359
13279	2vaaJ8EzaAYrCWoHUPszVfyLRQdivPzNRMi8SUKsBZkJeLL7CnUN	359
13290	2vaPRcsXGFtXJqXPhUDM4U1uFBZXkyTcgoRNpCk6B6PrjxQmoHDL	359
13293	2vaMB2dH981wXHsJf8TbyQkKMoNTMTAftzTowNn5qZccqzg9gMdp	359
13297	2vaWnQTGSJqC6CUrSAj8SRzLxwvMCHGcLJW14xwhSgC7c8r8UAyP	359
12996	2vbfDRkqLwMccnoMzWhrRsLwxyUpo8EvrzF8Zg9JVptfosKMGBna	359
13007	2vabbdS9MxKYzFMhCxdeGLatoCP4AwGEotuW5ss7T84dP7caPh2k	359
13011	2vb28ci3uw58uPCGpm782MatngSqf4qZGPeB1xsCRQsLSVMkaPR8	359
13012	2vaQrbCY5XGrB7Wrs7tiYyeCZMrtVs68bp5L1eEz5J3KoiGtyBQc	359
13016	2vaghNpZDpnSSCjCr5cbdsAVkQfHoefdnBKjDoqcnEAMfjy2gH3R	359
13021	2vbLyg6U1r8EgAWXLpWaPCmFZ4jJfzEMiVzV2uY6FwUhFf48bXXw	359
13025	2vbRxuVDeohAcqDx4zPGAhKDiby15b7Pa6JcPA9wEXJ1KNDS7B9r	359
13031	2vbTY7Hr5z69Jc1yW5NVZzaWuxbTa8H7JLJS3nMxDRE3U4x9xbtK	359
13037	2vaaFJSpjw1rg2sbftgf5pBmXhRHfLf6K2Hehpj3zH4KyMnxMxKh	359
13038	2vawPbmyMQhin4SUFLU1uz7ttBukNQzjbsqcsEEVgFa86mUid1it	359
13046	2vc2L8WJ2w3ZDfbeVNvntEAmDofuJp7VMCwqvbbysZkVGctU7zyT	359
13050	2vbAvX72Cz6UuRS8vyb4jKB3fH2S69vWgjZLr8eC4Y4WESbxCg8e	359
13051	2vbDNt6RcQETmPFs2kAej2jYeRYjCWYdML6J1y5wsDYVt1akSCuk	359
13055	2vbZNkh5PY7uvcC7yusbefELnP9ZnH4zkKwN4FmseDyhjBRjzhg7	359
13056	2vadNs4tkC5sdyJbbYeLrkydBJrWYnvSvPHT4thkrDce4iwSGXnu	359
13060	2vaqnb5wNfRcC5m5HqaMuY5YjiMUv7HeiCTNYfLrpsScd2qBuaoD	359
13064	2vbXtc8AAKxT2b4aFXt1wSMNMuEDv1aPnivq8aedzJv4rLnMagtD	359
13065	2vaDUiRH2Z9CAUFYDvJtDLP1qPSSQPo3RhzAUMb96Ufga1h49J3u	359
13074	2vb5njxyPkB4TUcWhBpfgPQNvyw8HWNeUTUqugLuFAnJVTVvuorq	359
13078	2vaP1H7CKGuLUhjcXCwxEs4sZhpewBZHj6jckwnrQu9896NxoBhv	359
13079	2vbcHTePuc3MZG5CZMfKix9ZuGniD7vgG7hgvktYAmCDPxC4M8xK	359
13084	2vauXPtQCMRzjpxheGWMt3bS2R72hFn4AQvF2phRRoYHBxgA2hNi	359
13085	2vc4om3c1KMJdfAB7mkwTzLQdk9u1ufDQtAd5zy71nvhfobBcL97	359
13090	2vaeUPWQBj9G7TTN7kgcaQ5QUP8jE3oPyxzCJ5c29gukPU6V2sEL	359
13106	2vafGC2Yr6KPqk3YpP3CVwU1FQfBvTveAtTHktw1nvniTNyYk8Bz	359
13111	2vaBxr39EoqNsx2LgQMrRmNhykegZymJeNpywqfzgH8HuiCk8gCd	359
13115	2vbXKUkgxGZJooMCnu2uvm4MMJPtrNzth47DqYAHzmu3VAjYd2Df	359
13116	2vatazA1GQNuHmHFWG8sEwoy9LAac7zVP1nSbx6o5djpkYCDG5Uq	359
13119	2vb2WbgqtgkmguLcR1ax4HN9AghhYeTxTV8ZrAKsQA5SJPeY5YeK	359
13120	2vbs9WDuBKHy35HtPzZeaTpU3nFt2MyTnNPdj6kfFS2cTjkzJy8Q	359
13124	2vb71XAch1EzWzvd5b9RtT1FXSt8hBVnhxfvixrUqWUdU1egrEmQ	359
13126	2vaL36NEk66peVGqnATJRh5Jg2Whw6HoLwiKaDiDZZXEEy5SfaZk	359
13129	2vaCLmoR2kRbGtNNkF37VLHuMJU3nVTxUGdJdygURT8Q7mZ1wqC4	359
13131	2vab6EPRFKpdtLiPDNsb88Y2NigM11umB5FaVQoj3UohhwAj3NhK	359
13145	2vaw6AuP7AutXaqHTNnyuAEbkakJQkL1NazSrV7G4nYxDhwGRDFv	359
13151	2vbCv9SpJR527gyj7XYFcmqcB2NY3GxSEKvqEQrSRosBMtwC7o5o	359
13153	2vbQdYCyyiTDwRYjNuViHWCZztnzA14yVaoc8w7RFbkR4QksYjqP	359
13158	2vaFYTqsdHt2cYxQd2h4dLvRQ3zPnAjRSPNQDRHT4WEZK1LdY8GJ	359
13161	2vaV7XpZ7pyHnTn4rdUqo63FhKSAxfmDtZaSF1xCZ126hoGgGb2X	359
13168	2vbTqJVnYcKDRxuV7JCWgzQsxyEnHT63m9HkKVjDSyc9LS9ouP5D	359
13170	2vbzNx5QUJN9N32m6vWxsSBYyq2x1b2ZLAMeiUx14qXLhwiviDLk	359
13172	2vbcL74gs8bFLWPJVYJEzBQCPJuc9kxyUpmEqTBsHfJLN5Bn7jBD	359
13179	2vbPH9yWGuoc1ycRoGbWjAatr5NcNEscDwSYXGQgNfbmLLS8j3Zd	359
13181	2vaABKu3LqYb41DtcLCW9D3FrwoYvcRvzQFLKi9DfWoKkcxqR6Z3	359
13188	2vbqMaRt7vSNXuhkrLhHiyvGJjMFUpMc3UH8W4PpvJFiScsXmCTX	359
13194	2vaSGdRRRm7weCqYYGBFtzufHUFyENyEvaV5ZkdFwdcmXCxPVgo9	359
13197	2vb1T5MFkVxduMZJtoHJY1wMWw2GYuFLhZBGd7CockERHcWPoLJX	359
13199	2vbyUtYMrnX935grgewqbd1cN6vJBstYDcHKekBjrwNjtWhP5rrX	359
13201	2vaiV9kePM1gzn4eJCBKMdjBeKfjEadqSYvA3VZXZ33nHMLiYtKj	359
13206	2vb1HVMXV2X57mTungUXT7XVUbTqvTuVX5DKY1nCT2FSBexF7cSQ	359
13210	2vbKP7Xw9LBB9GTciNYzDjK12dzdUkkNw7ZMq8dGSjAukwJFRJoe	359
13217	2vbLArj86hHhCpqDP23jA21aqXgHF77BGAC8rMgH9D3foRDTESNE	359
13220	2vbLxRCXDc6AKY9DQeVupdsSc3jmLy6261WdLnQG1tXas7HxS4qA	359
13223	2vb865BZUcvKUFR5udzLmYtkDsuJ8A31cb1bMSTbsZUY82jh7JR7	359
13228	2vaUyqTH5BGWguzwJciT5Q6wo9wZp8opTT4QKY52ED7wYAKS6P8H	359
13233	2vanmm7BmprhWAFTZ6oXaj7Qs5jXYucoxrDjdhs6yXnCEo6jKPMN	359
13235	2vbX5EwkLV12J9Q6m9u5sJZuTVY1iEDiSym8RYzJiSBTt4siMAaU	359
13236	2vbFAXgCWxxzEGH6vBftwLwHWkZVJPUAoWVoSrumDyeuwke4msQH	359
13243	2vb8Dn59MUkGd8Xz37wdE4jDtZoqB2AcKgQ9aTqK2H3Y6eBfUDSQ	359
13245	2vbNPHr5PkzfC5iGMCd39p88nosPEhpX5JdDAiFYyT5rYFidYRcf	359
13247	2vaTFnK7i2LQp14ZuoPigkeApJTzhbA7iC1D6wAATUPtDKwXJNXa	359
13251	2vbVxGqFEb1wqkmUsJg2LsP7joSYHy9nkpzxEAr7fWPC31TeZ4zg	359
13252	2vb94L1WCVwCeZXv4afEZ2EviZCFwns51LYHkotZzHfCxgqUyJpX	359
13260	2vaBU1huTtjpcp1QA2V9duqHSSKu88FZBn6q7MxFtGWj6aQBfSg7	359
13262	2vc3i8zjN1u3mccrBZungLy6krLmpT9iDwviQY1uCjEN9mEhLgDq	359
13269	2vbvwNdgTAkiKdHkfpfEtecQrSbHcpZAE5JHm3JrK4ABnZTJiwUt	359
13272	2vaoo8hHp2ct9hNJCsU1myEe1bgPUN9hjQmyJLwvMJmUv4s6AEiW	359
13276	2vab7W3ayE6YWSyFZu7CnHiov2LM74XDfLa4yFKMbiLQyLSHt8Eh	359
13280	2vai6KQSZcXVXEqf7ngcvv383BZ26uZeY9uNvhteqRHJXA7LbMy3	359
13282	2vbMZotqGjEKLJJ726tK1JgPJSbjMTpgipLgUUe1DvRcyKgmkKmX	359
13285	2vampHmfnUBYadzyTphBjsueH1FDq6t8HQb3eqeLZkKkB6dRj5JP	359
13291	2vbiTzPsmS6xfJhBzx6tmGBfC2qrtZw3tTZBMftuXD2AVkRZDHQE	359
13298	2vbnMvPt98kHC9Qv1XZvMcQASrRpa78tNVzSBSvYD7zF9vrd7bLW	359
13301	2vc4iKYdFVZh5JXERVY67kwxyJRXkVtQ5k5YqscpiGf8SAaaVHyf	359
13304	2vawDQM7aBpHjJPMv8zxm2kW2KAGE2PpHqHLP5STVUAdmAc6ocxa	359
13311	2vb9S2CbUg9nj35uGpME86ry7YbKsxaGU95wMY6DL1Dw2YUC28qV	359
13315	2vbSN773iFiRnBDiQXsGb47V1gjhZKodnN6zaMwSV7KHDVEkGT4E	359
13318	2vbWqKPR2JCjJncMjswMDG9qpNsvYgAbo2wiaLMCWG3GGLjQdHee	359
13323	2vbchfLqvda4WK8tFctRETYZ4fbTJchzjh1u4pPX6WX42uQPsw9R	359
13326	2vaxnvhC83DqzwjafjEuXegpvUzEn9L5BokXGRWrAATfNj8GbTUh	359
13331	2vc5rwLhVbMXMxewNb4CEUs6pperntcAvwFiiNEQgFDUhnRnUWdT	359
13334	2vaRNBcx1Nx62jxjZ6dX81m1WRtJQLE5H516KA8azQ2hTjEA9hHF	359
13337	2vaJjuRXbvaVD6Um4FMefC86FtCwmVfhkbs83haBFc3i52rEQZBY	359
13340	2vbYKbrVAerEsS4HnWo6SnYU24USQ9W5csUHY42QBeVtgVSSexH4	359
13342	2vc4DMH6fhwGVZ9bp3A9T3qHH2evaAueSm8biAmmnoyNgfb63Hzw	359
13345	2vbPsWA3Kc72FaVcowqgkioPqkodgHGpAQ7dBM3pVZohqupQ4kGa	359
13351	2vakkeN5yQePhUn4ToN4yLGBougyyvwwuJcG2g94EisuCTvrmaGu	359
13354	2vbSabd9y6dHXNPTRww3wus7QQieEK3pJneRTNMTfZxNChLYXfyd	359
13263	2vbNH7UYQmLnaTCXB9NzF3iTxwQg5SkyXoGvrkqannfUFJk3R9Xe	359
13265	2vaHqJ1zxwfafXosDujJRkYcrjFMReqyGnwnq8NMctL4RCZczj5o	359
13270	2vb4s5mxTpECZAyoUoU35JNut5h92X7CZgKUnTvhcaYDYmdPEpJn	359
13274	2vc4bXLETHVRyxthb2EikJj13zyqAXMng9DtsMJEB5R6zUCPQEzx	359
13277	2vbQE6PNTk9rKjmMQ9Xr2zS6Zbd2XbxMQdXYX9jwsHXCqpJZJ1i5	359
13281	2vbjE7SbQV8zaxEbh8mYktQ3Yryr3sGsUvj5YJ7PYrx233FZjeqz	359
13283	2vc3FjhnX64A9BytrkyoJnpK7P9b3Wp4egpzmLA9xPYfz6YBjLad	359
13286	2vbEopojkQFWiaAzDsBTJfGLLvvM6S2Qn3qydLe5qktVTUFutyAs	359
13288	2vaE391p48Z8GEuMw2eLcE6oQU31BbZrn8LaTdbY6HnR6tqXj1ps	359
13289	2vaHGMogGpGRBBycwQqExA4oyzMwGiJUJDjc8Laqm5pBn1b4ww7G	359
13292	2vb6XLMQKYW4gBhHefi3BM67QfnaUAwpWkWRtjNwTnsdvdNnnUN2	359
13294	2vapJ5PYpNVPdDRSyQ3idg5ZBBbdWDVNMz9acggAiJXuXqHw41qZ	359
13296	2vc1os1wKfg52p2Avqry1ucrb3ttzQkAfRd1agCC5s58vjUfb91y	359
13302	2vbjCWERGzVx4AzDDodLq9jbUR4Ri9biCZBfEvx1xMT2HHtq5Nrd	359
13306	2vbz536WVvkQuXcDWcfcrbno8aDwHTP9mxK4mmoa7haF23fCv6BT	359
13308	2vaMWs1fTYfAkyNuP5ML6SiDFtXamLMxyTDXkTWrnu7mSBc2F8j2	359
13313	2vbT1XXGmNiWQJDv6oufgcfS5hgnNHKa59xxHbFR9BesErgnmEXH	359
13319	2vaCtX4j423yeqVkRHRPp5f5Dfm9GvXakxhoinrVrsuYNsR3rQ9J	359
13321	2vbHLvcDuJzrVyC7a9HfuSRF8TRBcX7xAvYNUkwjq3cpSmz1YsfG	359
13324	2vaMVseoSS5mt439GUa8MRYKUpS1rFKNGuNRBFZqJT4twDdbBzhM	359
13328	2vavRhSKVBjvocf8YDM8s78dYPZrCkPrR5ZasLZNs7DoiQNs1K8U	359
13332	2vb1nJHVzkYB1PcBYQEEGscH6GzabAvUhJEaPrrob4eZpRMrkaBM	359
13341	2vaLQU6sKqfBHBfRGsTGHfPRJAqsgnxXsfggZVKykMnnGoM9cvep	359
13343	2vbA5WbBVY1VFjJmSPLvL3pXbg3fVesscfk1EjaJYp9Mah98uh9d	359
13346	2vbCNSWQvvren784KxxxJMmZo1Bz2bCAMikHv7R9viCZ7LtqDyLd	359
13352	2vbdV4Ni38wQEoSW3bEebZnbDAZnVbB2DphHufVyDTwyFreaqFF5	359
13357	2vaVG6XBqXAnG5uveEiFqX9VdyLnQ8pCveZmiNs4GoQbGiZNQDyh	359
13361	2vamvcaC8JRVcoKNWtwsu7Wxci5aK51XfW9e87WTKisjNmWHDNnY	359
13363	2vaUpMHYo4iuYj55CiHphK2VJ8BiMi1HbhKCDHs7HYkJemKZPUDg	359
13366	2vaq33TeVWgZ3viZWpZmXcpAkn8XdqxrnXuEk9mYSmnntKkhqrsh	359
13370	2vaGB92z7WQWBnNshBPdkfGF1RSZxaJBjyZhkFYF1229s9KuUGAP	359
13372	2vbCHNWXMY6pF6fLoecKdu7CHqiSXsKQdhkwADCJGCunWbwAMBSo	359
13375	2vb3b8q211P25DPHyfirFmzV7tWF62SCz6Ft6VuF38UhgXvNsQU8	359
13378	2vbimp2qR87zNfeirwJus1htsUjT9TL1ztmZTUcCrcRVopwvPje3	359
13380	2vbDDdbpd8HHMGfZJ8tkboAMZPpPpAuDYyQzXVUGHBBsJkFsSLLQ	359
13385	2vaxBoaiiytAKyQcNUaao1oZwr1Y9QVxwf1XZsL25eQKpXiggzvm	359
13390	2vaSEkbuHmfuTZwVWVznr8Cw8uQDQfVCLq8iJLSEotpTeeP1Gcah	359
13393	2vaM5jTgP7n5UY7CeDyKjpVzRpEJSBi5kYsheciJNjH8upwfLj6S	359
13395	2vbvsbE4Q5QkCkG8rNEhmW7xK1WexNgjSJdB9aJbtf2VJP2YqYyM	359
13401	2vbTdtpf4dNTDVxoZdXAp5X3MkVYEZoJNbMX2WWD1TEP4wQNsZGr	359
13404	2vbdxgCtS164sEoW6XDFv3c9VrMnCGaTGcCEMVkTHsw11qkQg8t8	359
13406	2vbqetqWno7y1x2quxAptXda8kosLmAmz6jra9nFsfSvkrhSqjTV	359
13409	2vaZncuEjSBtznhVs5FEAf7e4kyjK1cqrfD2SRta9QBYtNn6pLnY	359
13413	2vaAWoG94bJ4LUBV3fhMUReBwYVpkD78pgR6hhmqGuGkGUSG3ui1	359
13417	2vbB7reYgq6qUbXtX4KduzHdPL1dr3mrhj9JrftX1Ab9zNKVAJho	359
13419	2vbavQEB5dsegN7PEX8UwhmM247mHyRizYn519veeTHBgxp3chdw	359
13423	2vaUddGqSnM9PpyvUes5GXstqvEQKjdVmf6Pmh7mkHNzWmvomrah	359
13425	2vaL3qH3PcbsieC6Ky1D2iqBi1TFZkGzm6QMNY8nmo7t3QCyx5Bj	359
13431	2vb17EhHG6nKfcUUvz6aA9AXmDKBnB7bJ72MjbL8SVfTcywUMnbT	359
13438	2vaoDpDFuM22zuDc5JGN3j5Qif3iM5hczN1kKdNvi3zBi9Apbr3x	359
13443	2vaqrtc5FA5eCkXwSZwZTszAjFbCYQYUEUB8Y1qRFrwccKSqB2c4	359
13445	2vbqtn7kvSUZsQgHYNapoKpgtiwW2ZmhQquPuWoYnmRC4GGv5sRU	359
13448	2vbNc49pBiwV9ZR3v1FAqFtWKNBpxCasno51q6ELrmF2f5uCohzL	359
13453	2vbdNdXxrPRmYraZediocyGLoex2oshnN1AWUg4unAQTem6a6F2D	359
13455	2vbFNM6Xw76zwPJFQNprX7sXKwDRPBySdmHzFiRrCGwQf2C5XRew	359
13460	2va9HJzBCkTBGHYAVDZTpWnASM4LaTQb8LTDvnDWgNzvxBqi9P1z	359
13462	2vc5dWmV1o8MchTxWhP4Md9mvpr84sqWpptozngvqZNo78EGoKBG	359
13464	2vaJXai4t6vnurHPuXCj87awo6xDbPg9wnVbYdhSqxkjnbt2WBKX	359
13467	2vbiZZFmxac6xzQoSYeg964BtcaFDuJ3z5bpPsfA1htm6mqUVFVo	359
13474	2vbkKrHgZuR4UePJeZuvyYZeghEHdgMwqfoMXxcMnGEyRJoRid6Y	359
13479	2vbKQ19fZCr5jtTh1FnJjG7LKHSw2CDcRTtkY7cTg3hNA3sW11FH	359
13484	2vbgRpdnX8DMcvEaHsGaYKDdbbQ5fX76XXjiH5zMVBBJ87CMQDmj	359
13486	2vbQGiba7koJszTDL2eFdR5eb16VvLJwTRMBqUx2SxZdUAzGmpzZ	359
13490	2vbtyYT9wDpijbnPEBBa2VQFH122pAqMGmYuG1uoP8zCK1cH1ZMe	359
13493	2vbj2GdUnjxij3gmgtN1RtxuXBLdzHZ5GoUKkqfAXC9VuyzdpeMV	359
13496	2vaKL4aF5aTDeWqUDUruhSRiUvkh1EVeY5ZScKmnv8YkZPzvrPU5	359
13497	2vaUyyJhehP9kgEfhMT4VxDqkMVWZ4rb64VtTFSCDsP7DkcSHnVM	359
13501	2vaEeT2AQWwnAx9A61QY7eMN3fncYw8Zn5aE2bEU9PmrQamfVngA	359
13505	2vbCfDK25ZtHSC9xRb2oDgoLfU128Ls5ZUR7bBTFYwWEczD1ZpGm	359
13506	2vb2hKhqcG6yVrwJkbUUuAK923qhDnjHbqvnV9MPMTvX88okJvPf	359
13508	2vbMCf9nv7pdhDNPRP8PBDPwFFGzaAnxRQ8s2NvDytYp6AUry3md	359
13512	2vbn3qzwJu7yqd4MB4e2DPFyFCtum1z9aQaTseHfiNUqFtF4UdgP	359
13513	2vbiuw2xEZB7GA2noEbhjnC3phPx1fdb4CgHN9Km8w7KNT9d5ZVS	359
13515	2vbdp9eVSMFoABbmMzfnjyfgC4JQfuAwTCaZd9kPG9sGSjSfHWvu	359
13518	2vaEHvo1ZejBPcs4LESpksATCb1dwVxPGRs3sLjjpw9xjUqfi3dR	359
13521	2vbupybyriSS1A99SKX2vkCf5wZDDmGFaX6yqYvV6WzXCu2rXTo4	359
13524	2vaX1cktwNRhLW5Wf9RqCnSCf5ZUUuwSAY2MCxdmqaCDBFtqPuBj	359
13526	2vc1Hs8CybTjUE3gXa3H7S7mLkVp8HV1wksKzFwoPuFZAzHzzsYh	359
13529	2vaJdf7cLUQ4FPcvZYHThGB2EfENm9sy5fpWRnzY9hFEcdwG3r4E	359
13534	2vaWeZinBkFkHEwyHKXVd2fnzWviHGxqHz2s24Boa78pWvmuDrcD	359
13537	2vc3URFACncF8cZZ8mfwR2MomKUephNq2JVBaUmAuFHHDcUsuxAx	359
13539	2vaNUyCWDWzFjJABRx3gw2TdB3T346nYT8T563ZLFD5o1GHNAfsX	359
13542	2vc26mtvXi4yBSmkC8o5yEd3dWFUFpiGwC8BEqEXhNHXoK6NBngd	359
13546	2vatsamCvSKLmjcTwvmMDhG5DEme2g7QoHK6xyxVExn73Kp1iAry	359
13551	2vaHun7rJt9fUtZc2JeuhpFZCidJA6SaMVNAnqx2gFLYQ9o5wJZJ	359
13553	2vaX4rgXgmqSC9HjBBBQTJG4e6ZL96oYB2uRwoTN75tAVDRJzHYt	359
13557	2vbsGmdHdXDR5vxVmagdMzkNLLAdXdRtQoSxfg3QR4nFAimoZfY4	359
13568	2vaHdW8PoVE3DaL2AhJBb85R6ZrFdyoqmKgbnFbbkeGSY6iLx4ib	359
13287	2vbkP5m98oeWd6Fp5LKrs81PJsEFatfMJPmkYs6aFmghsP8qZwJz	359
13295	2vbGBhYYraiXeaYdNp9yA321vMueh9Wft9cYbAijRXKdwJpcLKqD	359
13300	2vbYEMTteBdoLaQH3mpvoEhhDbzjWS5zFkk5B6fH487GCN6xX2wF	359
13303	2vb889J2HK2zND1MnQss27C9MrNCA7YkrFpZiRPr4TXf5gAPSBFW	359
13307	2vbcXYw2Q9H5BALtSfaQPizsGtkBNeyvoeWAk8VmQjteoW63AGut	359
13309	2vb9LYXJ4G8JWDcUFkRrofBpwbGBFSzUGVScubuMN8VAc8zT44kQ	359
13312	2vbHrQHPkAtSRBQuaBgQLA8L3MiHLDCKPyUsFHAUCtQUMqXzy1wp	359
13314	2vavFU56xsgoB1qWvy6ncfGw7cYoGmgPYhuJaayXrV3Fwnyp8VCT	359
13316	2vadf6BTfDJx6MQx3LLcsoy43DWnLUaWSRMAY8kRA5DrZyW9sAuu	359
13320	2vbMQmGpvhk5Z71do5SSKExBqJmTNhyuthLhWEmBcAB8q7Bi3uDk	359
13322	2vbS2H5EYyskRgZB4pTLXDMss4kPL49yFC3qoEx1w2iAiWQYiRGt	359
13330	2vawQZKkDm296QLapnUcGaqAXAh53MJkxt4ukCbn4hcShJ9jgYAh	359
13333	2vbtwEBFWtmeChKpCRmn4E31VZFfqHxBN1ygagGHvko5JqxvipMb	359
13335	2vb19L5TPrDb8UGQsqbqn1YPtBJNDRXXWa7E5m3XypTe3Yy8wNip	359
13338	2vaZDE7Fmt6Ro7pk6TuRCixVTziDwHTqn9Z1hxxWgKb5JNXTZyv9	359
13347	2vboASFXbhYhP6NdimoSBm7N9RzU8yhxCpsMBhXJPxKae5x61DYX	359
13349	2vbXdKPem3ABqGC3e87bNv3MiCDxfMKWjzdgmC73ngNaYS2m5hyt	359
13360	2vagb8jaDGtHk4E16Est3b2SaiaWuAWqDUhY3ddCbCCNodaVJFyk	359
13364	2vbPdaQG4UXG785JGy2rMTFm8EA8pKUNnWV3ahKnL4dwhs6bwQ8K	359
13368	2vbYqw1M3YDjnabjfPqsN7wtXJ8XRHFr6kwEvUdFKabKSTa7SiSM	359
13371	2vaARDSdATmFf7deDXBh2w4Fzac7GAQ2zz8STJPajSdGMdMkYUXM	359
13373	2vbM9YV59PHLAHyaxqp4hvPELWEM6EbVx53CeEpJQnowHfTY5c1K	359
13379	2vbJz5VsPbvshvSTwaSJFLWChJi6khsrPhv5JztYdB8qfoENbbij	359
13381	2vaPS9pBtWY9fdsjH4RjRVzEUSR2u8eaL2emohmbQyipUxfPsvxq	359
13383	2vbByVQnRR3hhKhYavciiTJGVmEPiz52J1NHmFsEFgNdEUim97w1	359
13386	2vbGq6thsaWChLTLHoXs7rHKvSHHQbTeHfhpNuYbCGetw1sHJeBn	359
13396	2vaEj5cJagM6Qg4yhU7P1foJk8oWcAGzukMu4BGGNMKfCkuEkgWU	359
13398	2vaVNYUAn9P1eJC7dymcopHepz5wZKhGhDQgfTViar8r85zNyXLB	359
13402	2vajBrJ5LB7j53BbinPc9F8Fzqircp7HBxNyZKYL1pwkNM7WJQq4	359
13407	2vbvxC3B16yANtANGFt6dbJngJmKMTyU7xQ37G1jNe6K7w7JLYZN	359
13420	2vbiiHxEe7keqnFPHJ9NjrQ2CdPyGzj1cSRssbMtPnsxGh57GSVm	359
13421	2vamgF47PNRf96kb3sHfxBkTQcNxEE7gfV146n6QV88V3Hqurr4Q	359
13424	2vah1HVAKyftb1uio1iakean7iiYrfPThB5jToYXmJn6ij1VUVxj	359
13426	2vaWYNRskSZvktKymAvPJCVdMKu8VBDwC4yMr9KBib6nt5pDgpHJ	359
13428	2vahuQP8N2wz41VT9R4H74q5aUBCtceof9LmCerExzM6GqF7wBek	359
13434	2vaEq5JTipoufXuGVbwuQ2CGpFeYqo3JWYXVuhQAhZ3EyEhGDH76	359
13437	2vaJbhhSpK8U4c7sPPASrrmdtMTzBLDGCxyxbwMcDiWXHV3eAMKD	359
13441	2vaZyox8ohUfDYzNjXTA7rtD7bYPe3D65n6XGY4KnsgpFP8kJPmp	359
13446	2vbHgQKbtZ4TDyEJFubbFiVHQkPVqNyhT6BYYiSzTQ28w3qC4ivV	359
13458	2vbw3wU8MVbFtGVTYQbvGuFNtzgmjJLQ57uvvojXg2rzdgZsnr17	359
13461	2vbnWsLGn1GbLYL4brG9qj6JDm3zzy9ZRSr7gv3JuMFs6EBZMAbC	359
13463	2vba3mBj35KzUDDG6MydM5JRMYae1qUW3v7xUf4igU85HNpkYL4U	359
13465	2vad482xWobT4w68BKg4hoAZdrf2HB6Me69UsoqivLBf22AZj3cD	359
13470	2vbBebeBQXSZF35FTFxnZPNmeWJsiUhY4uzryGu3YfbSrcs3638G	359
13475	2vaR5CtaecEsXG4QhK64QKrfTHiBdviZSiXf8zXV74LeUGi1LL2G	359
13477	2vbRGfsgQnVcwe8HNjGX8KUY2vN9xXr1cc3vjZ6Zv3Gxqy6s8URA	359
13480	2vbWPreB3MG5ptdkGcW5HYouZNqep78vzYs8j7zxAD5Lo82S1C6h	359
13482	2vb7HKkncDf9dAbGKTkiW1DMVkD9cHtKAvw6PjQ1xc7Tw1Hg4qEg	359
13485	2vaWAhZ4PUVVuKV39SzFRksdXKbQUFDoj4NMQPhJhs8YwsS3timv	359
13494	2vbmHkBBvJgVcU49Use5SP8bKPS5tPUfb7mdAVH6XFj68hSiedeV	359
13498	2vbMfM6EiLWVQb7E5pPEFVUDN1AoHChPi1LLpz5yyXmsgDiwBsyj	359
13507	2vbZp5b6Gjkq8cpb2SM1T1wULP2L7N9aNYhJryMDMNj8v6rkRce2	359
13509	2vaGKT87hmX8zf2q9WdEradxkLre1EQFhXGaPECk7AyZoirMzxYJ	359
13519	2vbeVscW6KZvRLshYXY77SECuKN5pQZ7JfrFmZ6G8bxJtdiFiR7t	359
13527	2vbekW2hLkUfBFPSNZLC4VdNrHTJZLmV213afi5z2TfXQZSmiCLT	359
13530	2vbWU48vYT27THGJbtEeCSHqq2YyaM3dL6ydNU8fBsPPwpmHdpqC	359
13532	2vc2FMqP1fxQmc2m9XyB6oV1QkRcPNYzDTQH7rDhH8DiHEm67JRq	359
13540	2vaWqhqeYvgkyQ9DzZrxmVZpCwZT1Kcs2beJVubUFeUMpbTVSKGw	359
13545	2vaUE7pdkez9KGfHiFmvPJBSCdM4s3ZrEKpBK2cjrSxNxr2DnkSb	359
13547	2vbxCdvbUqJjD6ux2atvdh74Kkk9KaaUsKKqqokcdHF4giuiSVWA	359
13554	2vaWRK6vGJ3YPhG56Fr5MqoVt9ntn2VrmEfJ5Mr2nC5zukb6uDJr	359
13555	2vbFhS36Qoa234WaFLudR1FE5eXrX1qcpKwdeDQGQJcpc5dhNxd3	359
13560	2vaC5EUQBJGMCWSRMwieb9TmeEvomgXfFNCJv5PTmrNEPgjvFLEh	359
13572	2vaheq1zx5rnMW6NTYpKNa4YcebG3XyerwT5KfnEpWavMcMN9zyV	359
13575	2vamW3s9yakHx783raUrh2C3LMHe1RzEiQatdYFmPgsEGvXHWKvo	359
13577	2vbr78LJ8j6uz1DqqpHQgTcp2jMn6UxyPMW1JMbhfpYUwfhGsRU1	359
13579	2vab2fwzs5oaaQK2p3n9UVUMRVLy9kVTjR7EnmCbNhaAjL9T2GHJ	359
13583	2vbfHtq4qx69JcEd4VGweNoPjtWCqeRKhqSa9wrpNSLf9yx4ZWX8	359
13585	2vaLxxoqUxLnE6rKgQ6ZBkjFb93LRMtn76ZACJf52zPnE6ZCusjA	359
13586	2vb4H5zzqgjjRmXqpfJWMrJVK5m5reQB5mCrSRCHMaVsTgNH4EAP	359
13589	2vbozd8diLPbqyoEpzwYgzjqEEMYk6eTH6feoEEcvfJe8WkoWQJU	359
13595	2vbBYTwDs5cBK4mv5ud5HgY1Edn8MjgmuEEdJQZBuUggXg4kkcgs	359
13596	2vb9uGfyQyGEW9MRNJrsSMxhfbwg26TxW7QyQBVCFjeSnu3A7zf7	359
13598	2vbd19apBCqcJ9JYnHSVHZfyVp6gjwPGUsZ6a1R8C7Xic5QFbLNf	359
13600	2vbFsJYKnCKLj9npLjiWmcrhiRRjeZ1qoJ2A4UHNzrupPeVfQjR6	359
13604	2vaz6Lb6E7riJnk7qkCrnoJuPXgt1c9nV7kcr1ov7CqpWSfoC3ca	359
13606	2vc5ncCB4QNAvYdKxqP9gaJwENwGuHUcmWzHy5CsrB5LxfVfeSQD	359
13610	2vbFCUDZ96PzBU3Qf57tiZM7toeLeDYht1gEaMwMpkWVpTpfgKc4	359
13612	2vbmegYgCTdHR9FjLdQ87jZg6r8MSPqSwukubpf71U36mjZx624c	359
13620	2vbAuDdZQUStbmMQZcEnEcFQhqhxeeVBFRrfMysop4SHQ1XrN1Q3	359
13624	2vaE76GQf4S64xkVBHKfAHnMfPNnLuM7dBPgirqv45GFgkjcs6v4	359
13628	2vbe6UeyWJi9evfMBRLvFAWCSkj3i1maBMKnAYVTxtp6RKDkF32i	359
13629	2vb4aooQn9gsasLaZWm7zkoDasi72zjaaCgJMifkjFXUT6yYiYwH	359
13636	2vb6njNTDZH2pSkBkefhfe7PZ1dUVv2Zu76z2SgTRkvE61dbbsu1	359
13638	2vbqEtj6vo2JjYdsHcKFimBgXycf9qhGbVjS522pwnYugrrnSFD1	359
13641	2vahpfwT1vmJvHiSqZdvpUWdjt8H7kwtnnMktKQL832CjTib7NPv	359
13644	2vaVYmptYBVAsTwgkvtu6t8k5KMgJasj5RCuZedeYKay6J636FyY	359
13647	2vbL3LaqPV2i2rpdBTVxgYqNQPdeK3jg4BmEyeC1VcBLDFDceKMf	359
13299	2vanZ4dd7KqN1sLbRzKy8SwvtgorWZnXVZev6euhqb45ry4CVbLP	359
13305	2vasHkhW7DGc5Py9v1W5kPFmSRNRtcDWeBgPTwcuVhShf3C61kY9	359
13310	2vaTPKYok9Z5GDU29W3Efb3fQMyqNsyxDqXRpfjNtZUxSxTq6AN5	359
13317	2vbKp31Hv3dRu5W8w3RY5UJUptKnsYfKGhWiQzQHHLGayTRTSEJ4	359
13325	2vaeDALsDBJ5d7GdGiGFZ6gnNVMfQfH2Rev9nFss7TzJAR7REWFL	359
13327	2vbgsCFzBiSZ8LwtQE1t1WqzEiB9k7gxkymok5zErXMw3zvnDnt5	359
13329	2vb3bY1T4fx4WaxKZKFfASpkFZHoRdPSdGHuSJYZDynmgxYbwpe2	359
13336	2vc2r1FJ9MkPQksS5YL9778tEZqbWJUH8eSVgbykFHrXoKvC6X3a	359
13339	2vbL8zaWMbhptbyeXHVnkEqtgxJGhAbpBqMiERyUdxAXgmX1S6Ao	359
13344	2vaxdQ5z6EUSRfkR5X5hLNfeWvriKAc5zU4TZv2fx4x5NN6jrEdn	359
13348	2vbupp1szcyGjbW8pnytFvRtsmLQ3zTX7qQG9TCGiXLncUstTjnR	359
13350	2vaLjeVntUBU1W2gJykaC1RL3HyYmFwmcgsTiGgrZnbRjVQ4udyG	359
13353	2vc1fT9iDhYz8ezHEEo5LTs2z9LjgXMSHnfb42K52qfaizboxxZ4	359
13355	2vbYz5dREqNB6HkQm3bm7Cugrru5VZEy61vJKvMCujCzhdRBFG55	359
13358	2vamNcbLZzMLAy2ceWxX6bSGYUTmCfY2owY352ns9NX4PcDDkb98	359
13362	2vbekcwbRy7w56wkzLAvqmC8wXAech8KtqC6KqBsz6uwfwWPoviA	359
13369	2vaqxcAiNaf88NBuKx6PgsW4cPg9eJCxAzRrqj9V9cid8SyLC7GW	359
13374	2vbQcUTPRqqnEzs2uNMncUKjXrq36SFSPbEkrFhsWta13KxVuZQR	359
13376	2vbcUBu47ZCgQKdkKvkEnGfb93QBSZq26SwrNQy59uryoettyUnD	359
13377	2vbbjFgRFntj7dgsjH1BUMiAGuK6GfjTukns1w5s6AiKbA5JMVkJ	359
13382	2vc5XMAHyM7ndfb8jeMUAK1U9BBerddeHzEbJs9wEScMVUnV4CtN	359
13384	2vaAF6G9cQHUZiQ8JybBPbQBwSniK7w3ieGvxhh4QdCcAFFyGwHX	359
13387	2vaCct1mCzUR7tYmy7gWRuuzPpJdTYbhRGYRnZTKyP5WqWgWktMB	359
13391	2vaEY9uajg125DgJSP4U8BwyakXHMQDy574rAfdMir76BijpNKxB	359
13392	2vbdVvyKW9v2MWta2N8EPHtDbY8vxj8V8vVo9KYv1qQTsbMYpZdP	359
13397	2vb5W5BLXFQ6rt52NPqZTX4F1Xgqvn3feV3A4tCr1H3jqx33im1u	359
13405	2vaqMHj5WcsHW3b7RCuAhZ9ChBW6sG2wUhaHVrv7puXaAVeLuEhV	359
13411	2vbLt26hRJmrU5ydto2DbJkYrSuQYt19t9YUfz2vwFdBHRyFdFNR	359
13414	2vbs63crD8Az93BWKPyL9KEW5RLwUTvzGdrBLhQ6LZw8NM9nmPe8	359
13415	2vbRf7RYVc411bhTCg79VnTzp5w3d4PT4KxdqzmEbWgUxUAnKeiN	359
13427	2van3UoujeYaq5sGZJ68N3FjAmZEDL27ppLDzrgS1QEe3J3Lsiw2	359
13429	2vb5n4Zkiwu3cvp1FD6uk4aespeKhXoGy2bqQQKqrwVQr37pyPvB	359
13432	2vc43zSDRCwpEzAntKf21SLsyBoZbPQEK8ixHyJ1gZebRwLLcFYu	359
13435	2vbbxHnLh44fvQj2nKuQvCpb2o9S8HKadVMECyqhRfhm5AefPE9h	359
13439	2var9offjYmzEHJGg1qpKBjGHgzp5FeEjYQVMEkd82Nn766Z6UMY	359
13444	2vb63ix78uHXSehWNWroLATmxuS3XTkvDtoB6igwfxrJT9EVU7jr	359
13447	2vammJ6njHAwxEP3E6XSTV4rWHZvsRwm39ntxpHWe4tL2rgquNQ2	359
13449	2vbZ23CEqvu8XLPVYT7Z67Zqz78BZcxKjN8fmMcqaGayyzVSYv7f	359
13450	2vadDHZK1XcZDirPUtfJEeMp4b2whW7rqZ8xFW27JHTd6nxDgB6Q	359
13452	2vbWx4JtDMeVaiS8vyxYWjPvXkJ4wuWrVkyefAyVVtSEXX2v5xvi	359
13454	2vbWzAm3vxR9D2TjErAsJEY5FyvKYKovZ7h6xgavP7EtN6jpTbtD	359
13456	2vaDzPQguYF7rQHYjEdYBuG3o8wqfSAajQwoeVJSoYv54NFzGWSr	359
13471	2vboxsU3ZJLJm7EAcBzkDHN4LmsNqLCkK4QyyxrNK1dwXgNykB1e	359
13472	2vavyZT36mNhfwNNKx6CUvNYeaMWbrRnyUVBN1tMonrEN2LiDQDo	359
13476	2vaeGFJQEjH39Ytf9YXX7dnq2SxxXq1NH7quYPQKWRVFVGtc6ZpC	359
13478	2vb7YvriaUPKk4FZ5vofisUjhokTZ1ch5cg7rmzMa91xWhLXynQG	359
13487	2vazgUbbDy2hotaaTNTWEwpVXZhu2KpTwLEMweLDY2ftFLNRoQY7	359
13489	2vaHyr1kBN5XHBbVWC5815EuHRBHveY8ofVegfujYE4AUprQgvtq	359
13491	2vc1G9mS9HgMuzZU4S46xpxP7RhSjHp26dyFE99FZMvAA3Tuag2m	359
13495	2vbdGcetAFJcG48ASteKQ9n8ChEGnzdHDiAsuiZCtV1YQ98zLuxi	359
13502	2vbXKKZNhgDunigiEtxuQqeQGqLmR1mjugGUPHfkqAKsqX8BkhvN	359
13510	2vb2m8xM7XqTaBZ1znnU8vd9BHcnpWsDS3SKvtMqDVPKWkRxxdN3	359
13511	2vaiFsK3cyoCcRABEkYBxDd8pdeiF5xJPao8QnKDVXQzuGsYF2MZ	359
13514	2vbMrXUohsjjoNWeLezD4RqUh9T6yfzJQ2ESjLxzbFZ1oJ8PpuGk	359
13516	2vanRJ76MTh9F6fqgS7599WYc1DXNUymuBKxqbHouxGRnuvMbSRR	359
13522	2vb32ac2bPxawrH4a5CxaAxkTsdztGQhHsLCkrMvJ5sizNnoGTsV	359
13525	2vbGkKLwcBQCjmrye3QZVVEanpLbWJHnyZu7PUwKLYDV4FAgvhQQ	359
13535	2vbHv9GfiNsTmJGvcBtg1TGvEa9oHTWsSn64fiueiuEHwVdFpt9S	359
13541	2vajaqgwJm48EX3goFvf8A1yiBTE3y81TXLcP4YQgKuQgoPGueqX	359
13543	2vaBZqvAJeHZGj43jVfEDdyD6vURaePRA3pPBEZ5Q2REqvCSd4n8	359
13549	2vbU1Uzj2vhv2UowW6drLCsdDKoEEd3ndy8TgxUfRBbcdSSTpN4j	359
13552	2vaAUjowJgAReRMocan7RHv6SMDSMBLGCtKgK4j8RQpdzQuw8c6i	359
13558	2vaxfzrn2iTsjTqQUTei8v2mCNWxVG58ZD1rM2hBxgr8TE3ytq3e	359
13562	2vaPk5a7SAEWN4mhSCodooFyfzVueeJszzLSsnGm5Rze4fYZijcf	359
13564	2vaH6AfD897tuimmgpBuviiSuVdwUEs1ruUpkci889TchQrK9C3S	359
13569	2vabgr1Kgks6DrfHsgrPrNHCaWxMWMogKN8vecjqzduQVKSYrCVH	359
13570	2vbo5YpBiEGTsYKs21sWSRNdNnPBXM2SmWnmM6fm7gts4XL99q48	359
13580	2vaoeCyTbnNg9BkT8KXsWVnPXsbBVt9EtKVzMYqjf7c5hYL8ycjC	359
13587	2vaFaY5RfvbN4XnB2W59dDoPk7BkgTVWZW2SVjuzZcRxcQR4Vk39	359
13590	2vbASKcPwqRTWL9ym9W8cD5J9kevrtiysczkWHhJNUWz7jpLfDwD	359
13591	2vbVktSZMSBymcHDiVyaspmJsDwZfsveExbJrgxanuUtaZCjrPaK	359
13593	2vbdQ6LUGdGRaJx7zSAWSZBTY8FbWTKgDK1zyc5NH64wiUTsVBHa	359
13597	2vaf4KfwZ3dDpfkxQhHBSmMzJBegkB4JNtr1MSvAAfZWUSLZ3cAD	359
13599	2vbf7CvysYAe7xEYK6tdjPd19qEfVPUjLRo8pnDwSw6Uok2ngkaG	359
13601	2vbPWWcg1WtvnQUpCFywhSc8uEUaMemfVHR9kVYmeeCahWs4JoU9	359
13605	2vbzrwviMJpxmtQ3BMTWWpKRRNFPWCk1Acxt3KcdU4bJPiggmEo6	359
13607	2vbQS57W2KZNxRJmkahf1zLVCjVrv7ZR37rSkmbdSe32Lm7rvHzY	359
13613	2vbJLHMxV7a66o1z5XPF2Goy13EEZC7UhVj5DXvcudtMa1Rut5iF	359
13615	2vbf8MdG4YYTFHXaoJZaznVetXoC2FoHfvj6g1PhavLeSY2WddE3	359
13617	2vacgkJPBbPPz8QB99eBywwHhxpEJGWwPR3L5CdNR7QncetRzcXg	359
13621	2vbFdSEJ3gC55jy1fqUtfo7Pk9QJsvtVZQaAUv5phaVFgWiJCT5h	359
13622	2vb9CrCLZz8iFSoAfX5TMpB97QcYhmtavtPMHAy9FLRjUb91iSeP	359
13625	2vawN8Cu4dfebVcqiAmF3dtR3G3k949oLwWEFCjAR5TU3gW2Xr3K	359
13630	2vben3X9HXwgtUhrZwa8s24bmVsBLN1D5JfXUSy8JytDBzVmdSeo	359
13634	2vbW3ZBqtohXGQM3A2hb8Xoisx4iZMb1SzbUhw1oWtcyo8Lw4Nwu	359
13637	2vbBLhwtvMYnasMEQ1HNcdx56Zg1eVi2yUxwa2XV5WaoyQuB3XnZ	359
13649	2vbJBrUzcyZiCkogh3KUTswgRqmChEmzo58doZrKeCEZ6LdxxHTq	359
13654	2vbmFczyUr1jMfUHF5U8KcWj1KCA3gcpF1KLMQShw7rjE2jtTfFm	359
13356	2vaZYjkXYBTTfD6PtL2bSeZdsUBKGyocPNcGp5aC4j2H5sCM8oVh	359
13359	2vbpePFahtc9cXRGJuVFxRLmoMsNg5nAFBtfUQ4BpHXYPAv1wzYb	359
13365	2vbFBGTfxkw4YLKDapDvWLHAUajZD3KFALrh3dL3sx1oLCKfsnUg	359
13367	2vaCNiCxjhmFq2M7oVnsTZLryJHAWk7qQEdKggaL5oMJ3NVGcJmL	359
13388	2vaqUiS7zrUvFS1dMxVE4WBa49UPs3rd3Qb6LRfc7ms6dYCnrdZW	359
13389	2vbRzGSiDKaLfabtUMgaryHVUo5Vp8QLbMVPDeNJN9L3tBD5jJGq	359
13394	2vaWDCjCjpp5ng6K1kCDyckcxrDQWN6fSk7eJbrYUBA1HaUU8Rqw	359
13399	2vabTdfzRbZWwT7AA3RKjZb6mb8uV7g1ZuiVMHCaWoYRXaGJuVkD	359
13400	2vb37MjjuZAqx23X5ewSF5Kk9pR1sYnhMLoWxtspQyL9ht3CP5TJ	359
13403	2vbyrqdbVNWo4cv9tmSsKqncRrsAhCZPGbGzjAxRRsfjzUqo1S2k	359
13408	2vbGbcn789wSf5bqYT83S92Fnh2MptYKuKEy2dwQKx96VsgNgNSY	359
13410	2vbyarwTbTTMhkH2NxH1Ra7ywv9S7i5FkHzhbVNrYeKyR5QuWCNX	359
13412	2vbW8gGghph4DBoecXaKB18wbFWL29Qq8f8sxLbPeeut5fzzey5H	359
13416	2vbvvXKsT6FADh4JhuUULGm3LyEq1zkEZxB2CXui8yBbYJBkGU32	359
13418	2vc13Ddg7WqETvgeDzT2e43Mah887TjVU2EJAahcBvQWTjhMwBzM	359
13422	2vagBdhDrSStn2EKEx1Pb9V7rnSjqhsqDsPViap7FTinQtodwky8	359
13430	2vancKspKDiNiEuh6dmhrRCaZRhX4tLrgbK5dc8UbNTFxf8acGbc	359
13433	2vbPJUAvDzTAFnXCYjTo6ERdsYR7j3vcMvNRAMHkzdWzw4awGJHu	359
13436	2vaE4ZiJwQbSnmPXjYV4WLrmsJ17QcsiAbWPkEdJQoRiAhjRTEYW	359
13440	2vavSNRQUM9AEQqut69Ps3PR5vcorGY2iwgkpVNZcmVTaMoCR76W	359
13442	2vbHX9Sd3RaHXTAXHQrY4MKKVpUJ3yZTR4WKZuvr7Cn5TrLaHU9c	359
13451	2vbDBPkB7daVbXcHr3waH2z9VyWtqi6eXcwwLJGiwHAwbxdkbU6t	359
13457	2vbHU9rDhvM931mqRoFjDDp14gAn86uXPS9rpxNEH1vgiUk9yqgF	359
13459	2vb8BE8Dj8K7BL5LEBGGVVG3vmeyE2be8vUFZzAviqr6dvG8nsW8	359
13466	2vbzk7XcdxjHFBy53vdnVTGj2XhKNCwjdXfqfo5FcxR7zZkodrVh	359
13468	2vbS1DuwFxrYot3Ly4xp8tBfdshNtinVk2gAjprdAgHCSX5chSyL	359
13469	2vaUSgNDYgvr1gjWuY6B88x945H6FUqvjyotuF7s7RpZnXAbA9Nt	359
13473	2vbQNaCd5QBtDbeao1GM8giToiRu6J9reaaAV9tpuDupUwuYjfPr	359
13481	2vbory94wiKcEifdosY48HH5Q2CyXyWV7ackk5Ed4SvSGqBGtwnx	359
13483	2vayCGnPcMQspiPAu2uaEMTRgYTrMK9nYtckcgSKQDGStVcFcuad	359
13488	2vc1XY1LiKfkg6y7qAFayRj48iERpbNHkR3fyPquBXFeJbixzWCq	359
13492	2vazbkCZfxMGedE56PQMJnWbyU4YikjV81SuCzfwwYhQivocFk6F	359
13499	2vaV14oFHavcmeJBwsovNQVAkz99WZK1DHoci5PC1qX2oBAGfZ1f	359
13500	2vaYskfzQUV4Nv19pqMxoNVyw9UJttuLRd4hWSj7CUDr7SbYWm39	359
13503	2vaaVhNUaNHStFz4m7W4tEgazwWDPkbLE121trTkSk1V7mtYexpj	359
13504	2vb8CTVCL2KKqDZFXQeyn4AHXX2WJQHzpAJoBasVyN2tHSjmmvzW	359
13517	2vaWpZo8HCPEJWdsg7v6C9DkXTW46ZtiQyLXn2SBWZc9AuwhLwHc	359
13520	2vbweg945tWvYnyggoYtWydJy1Db1FAMzPZTjFqqGtv89Rdj4dTM	359
13523	2vbiFsg9emL9TYb4B3zpuhpoirk4uAXFnxx2K4i4LkrcRQqbjbhS	359
13528	2vbP8N2s3CK93C45NsvP9S43EmuTguYicdbS7seBUDLKYUSMzXkb	359
13531	2vauA9goLPpSVkCxkGU53bg1GnNjwYaZok5nWnzLrNvxHQNX3oMi	359
13533	2vb7Cp1dYmrENqboQFfL1a6dbNoMfAxajXJsEAGCuYPmtjCUvhRP	359
13536	2vaK9TuRSKQiVZWUThtRHvB4ePz4uN8D9y5VxS5y7LdjSxVXmo77	359
13538	2vbFnXJwVoq3qoNEMo1n7phuNEcPqNdYU8r3V8Ms1Szugd2Kp6na	359
13544	2vaTV88oPMgV1t77fUQRvRJJD2gcqnYD7KW2f3j9dc8YzoQf42T8	359
13548	2vbTANA6wVWP3ds76NzFDma5tJRLd4WrhzzUw2rMtDBY4JeTVSfr	359
13550	2vc1DR76tezCYq3fMzoHBo1arHPzgFLGYscTESQBqSw5riaq7Dr6	359
13556	2vbuW3q9capSBRkxTKvU74VRwepjQ3D8jnXFQozE4yLrVNQjoyns	359
13559	2vbxNwoztbf63T1WkgvzHPZhiV8S8zrKJqG7pvKvAHwp4yX4e4Y7	359
13561	2vbZG7HiydNVUrNc1fdd3UhxSxFTGpYyWo3WNtYouBihvNUHqvuf	359
13563	2vaPnhTporUgBLCTFGAFTW1TjT1xqSm29FuDK3yWeS9hjaEdekqi	359
13565	2vam5wVqaamE69wKBBtPk6xqAFZ42ZRfqQZnuEzHgDZNXTyv4T52	359
13566	2vaE966XjM5nSxRgdtKCYi9hgWtw2zr8vFnt98RDrPeUmDU3pFWZ	359
13567	2vbbzLJxBJBfLAB5i7kEP9J7y8GCs7hPLS4AbcXGhkYJ3f81kDst	359
13573	2vamqgXWZB3Sx3yn8wghRDcvEx365SqmCz4NJxZ55o5yH5NENXJT	359
13576	2vbLdCvkV3CdVibtNtTvsxtUA9Zut1UkphVyM21vNk8HYYsiFGrw	359
13578	2vbKjVm5Q1aYJEdSWY2aywiyjSUPdisNjRWicEe2HQwCvyxqaWa6	359
13582	2vbCMUSPojEPuyAQWPpUaC31SVRXMPkVCKxoYq2PuyaamE3ftF9o	359
13588	2vbGUsYQC4c6xFFNYey4v5Ddahhd86cmUzwfiwgrxbGd2i9EH8tv	359
13602	2vbCtNsz9JzcM6BDQLyLnj89KP73jqUWWGAsXdjRadS86c7mVSww	359
13611	2vbcxrHLkND1FCosAwZ2SeevQCTJG6JoAzMjyUc9YpLbj2Xv6R8Q	359
13614	2vbkUV1254XnAqFF5JEqmvjA8zXLtuYd7NiwuNaEWuQr2AqsnLgH	359
13616	2vbY446w5UqiDbgkzrcET3B4FfQbr2SAEnr2vFz4pCXyjLhoZg5U	359
13618	2vbZYbDYSAGNXxgDqHzc11YWwoDrEFheUxKk5upji4vP2s8pEiPJ	359
13626	2vaZc5TnD8C6aXqmYGbFY9vUdRsqerJ6hQQhBS2yKEiZS85vDpGF	359
13631	2vc3VciREtaFADTF9BFadEh2d4E1CAiLX3QTFbMRTADuXfZfRrhg	359
13632	2vaQZMSeftLXJbbRTyZb6A9TirdjYQAAc3ggQHWnCwikDsDsNrjU	359
13639	2vbjP8p18o7sFWMAf93E914v8GNfEMFsncxKU5gQkfirE5nJbKGU	359
13642	2vbenPDCzXsgMBSCjA9fXJE5iUQMCFTL68ZRfC3EFfv1sMNpr5NT	359
13645	2vbFkkVkeudzw2AshTL2yTRoP3h4GNUAww3gkFYFJhwjphVr4Ubt	359
13650	2vaLFE1sN6pWxAbR9zuUGYCQSGEzMZ8YwZjj8DgRvT6LZy1EJYGu	359
13652	2vc45q5U6GJVDVatb9W3mT4RbJ3G8xbcuTQ7uKJSQgh9hbb1s5Ry	359
13655	2vag4NSrekz9DaPgvD9KxgEYyeRmZAFZCPFVuL1GjGCKVstDikeF	359
13661	2vbjQpxyMFqrhDbbuw48McT9i5z9y82voqfQ9Gymv782SfUR5QMc	359
13668	2vaYsjLF8mB6c3mUepanYiqJvtsctkF5VTQmFd8QWRu2Kd1YGq7p	359
13669	2vaEk474nZW6Bkviq3XM9TDfyFdneW1Jb9nrodAynPwLpk74qNsE	359
13673	2vbz8wUatMwCTvew9bdyThPZD5M85YUDDjc2PdGht9zK1TqwVuvp	359
13675	2van6TUNk96thS9aghAGNsChSv3vyfrSQKYG3dHnmudba6dfN1Go	359
13678	2vaLJakS8gN9VPzugkSwmESYe1eN29mftJ9vKcyXKRhPGaZ4Np6Y	359
13679	2vbtG8x6wgKmV1sLBHGPKA9aG1guqX9fdYooPjjUGoygjJU55tqi	359
13690	2va9w6b2tDWMEu6BJrP2nzwTa2vWwxFHwjVsV3h3sm3gYuLZeo3N	359
13695	2vaKGjtMaJuivpv3TRGtfM2VvcuCfwWDuRnBaBLfJVBDM5P1H3iT	359
13697	2vbbVeiCEgD61Uj6BfaZ7w88UVecTGn7o9k89pSX1gpRhTM1oe2C	359
13702	2vbp39uubeumZCVZkGJ77FP7UxWaUUKiG3nJv3k4qMQKyem4WjpA	359
13709	2vaDDJ9LD1Aq4PdvKu9pSXwomvTFqz4AmShsJd2U3AxxgfwqwGx6	359
13712	2vbdmXuzCWMHv6EhD8BjCYcLpFh3NbEUiK1N7GESZpmCwhyX93NM	359
13714	2vaS45meEtheaSyxYL8KiHwZg3BzPoR3cBtWzk4M9Yo3WnnjfbTd	359
13718	2vbUctwqqpA9CgFSG7LtQLKDCaepoF8uDyAWKv993VF7K8rhJKFa	359
13571	2vbumGTXKSKzpGd2Vx4VQj4BML2qcDoE6rzHqaMqG9pAdBDQ5o7U	359
13574	2vbbNWeb69cxNNXRx5mHWxwpywEvgsNCQ1wr7VjJZQhyzYBEZ1nk	359
13581	2vbTzs2TWXG7wvQfqaTUYWz4kw6vbF4djm9rv49YwbZs3Xy9nuiY	359
13584	2vaGEqyV33NVNz9GDsYG8QquaDEAcUKepXNiQBPMuk3cXA4Gaq6q	359
13592	2vbLK1opAdzDZfs9s1oN27JKb5ZzCEx8DzTnxWcom97raGdpxP6Z	359
13594	2vbG7rad6bpu1GpdTuRwjDJYb4VnZkVDw6LkRYLFeVLNW2bNk7T8	359
13603	2vaCkECpe5NAWBy2cijFv3zWrufUChL1vdAizwcNkvsqHcb6yf3k	359
13608	2vbo7eujyRmW4WzbkKwSVQBNWWQMPGBmT2jUQezYkmPbe5EdvMWZ	359
13609	2vbHmLpeVy3K6PqU3NNUnoDYQLNzwY1Ak3xyFXJzCREmUdJo9Pfg	359
13619	2vauwqWdpcxizpyFG4xWTtPYWdMK5eU9xTLa6E5ynsQuUFAMmQvE	359
13623	2vajfzco8h3EixKv65tmDBaRyE27unbgmvC2tY8jL6GXbJbXfy4x	359
13627	2vat4Lv74gVmXqCiVQfHcyF6XLGQodbHiswerSvDMvSzAwvY8fFx	359
13633	2vaoThLnhBNxN2J2hHgyaWF6tPFz74Ssikn49Wx8kpYASokSRUL3	359
13635	2vb9Zs55yARkMuZQgX5yTB3YuVWaxjPP14Fxczt5KFKETC4v8b7a	359
13640	2vbSaQK53RNuNd21BWUgjLhAkZpPLku83UK7wsE1ReyAsFqPKUTw	359
13643	2vb6iBvtjfZuKKSawdRHV4csiAQMAzXxuzAdr8AhkeU6aKZaDZUf	359
13646	2vanMgSbKsrswB48SiNAXmqxWgWRcR9Za8Yy4iyS5j83UJMvaE6Z	359
13653	2vb71pRkXF9XkcKVoh8TfgVzvJbpym3wTWK8TmRCYY4VQBV3e7QD	359
13656	2vc3nhR3Wg4dgC5n6sCJZ9wvRwoak1KhTR5cvsai3vspnapzX4LP	359
13658	2vbKtuVy33AM44to3wjzzuHZKKMBUn42hpRWA3vsY2M7753Xb6LF	359
13664	2vb3SPsZ8De7Uf3xjq3NYj7aRepF4NVhbRgf5Q7QeTFBMxdHbxxb	359
13666	2vb7wxJXThmGmgj71mm8aBi8yBAK4EaAyYQNfjJ1Ve2JkZqXCgf6	359
13670	2vb1T3zQVUNfkPWTf5ucwYKkcSM5LJxzti9Gz1sTsZyT8NaSh4nX	359
13676	2vaduQ7AFA1NM6fFUWaxwavXReVBr32NonYwaNmD8ZGZctMd1Q4Q	359
13680	2vbsk57aFc7SK49ZPHAtQH4w4Ep81ctUZeYLk1Y7hQNJ2vZ28twY	359
13682	2varCNFqcx4ynHeactk11B8Rfka9mgc8Y7QJPV9X5mJbNZqpfXrY	359
13684	2vbGCdWhTzKXriAt4TF58qgJhxAfYq21BSM9DB5EqgXRH3NiQtZT	359
13686	2vbg1mKfX7q88SzpSek5CUL917K3NaUk8xn4rc8XmpZci12Z7EPK	359
13688	2vaPi8iJNRfmEHE46L7Yi4SwqSCz4Ymt6gjGktKbyJdyLu3T6hx9	359
13691	2vbz3V5wNNUknd1XUHZwZbw9Yk7wYr4SeQxMJ1vSmtvFt5qvDGmd	359
13693	2vaWTMCWsURvFYx4rFPZLuSfpwVE2mtZvWF62Qvj4fRLPpQB1nee	359
13698	2varFC4KceAahgRb7XXsCrkCwrBSoSp1UHtfEjnhZ5beUggcsUzy	359
13700	2vbkAZLWzTe8zPRz9bBETbEar7ZUycPLMZnizsikWVMFRvLW7nmZ	359
13703	2vbz6Dj2X7752KoPC4EZtcYMEgBdwzzDuhSh5UUijwgEbdhmzfM3	359
13705	2vbZi7dbRiddc3DjvoxgiSdPxYYacE5VHGwgR7nSH5abx3wGxQpu	359
13707	2vc2KFEXF7xX7kPPNjqWAAqmd7XwfgZHD4tuijTUDrY6kP4AYoaB	359
13710	2vagN8QVDtKCK63zLjGQYoWUi2CQyrQRryasxLrjC59LEBZBwuqe	359
13713	2vaowDSrFZD7xTcnS52VJrDstKu9o17evyceQbcF2mRkfiFm1ZkA	359
13715	2vbGgue9vxP9ymR2YJffHZkWx8pV67XL8w5bqptKLvbAZPAXr8Wn	359
13725	2vam7BTPpSFuD1472mrN6xjj5A9Mz2nJ3t1YBFLKq3CQMFbBnZMV	359
13726	2vagqdHQMJKNoELbDsFSxXFXgtbTd6xJ15VcP9TZMyCUs6dSWMHS	359
13730	2vb2DZUMgfeJunwgxrGnEFQkCSLBxZy8rPmnuAKknvt4Cz6Ccjqj	359
13733	2vahYkrgZ2XHxvP1LFLjJTERqPkUWMkingvoaaPoaEBKoiRwxfSU	359
13736	2vaTQbGgdb5acQvURe9bLyX42VJnWwcDMmK33Gup9Ygmx3NuxbRc	359
13741	2vb9wtLLP1oAjkrtYaNp5b3moN7VSsMD5unFhbvPQd6GpEsxzQvp	359
13742	2vafh8uK4gSXT2Mi7njpUqAJJPrPQ8n7h3nRqZLqffXDhzExsAPy	359
13744	2vaSoMZuqNWZZGx4ro9U1gtzoMqm5mXkTR49WxQjtb1ipPqqmwCD	359
13750	2vbipKxwD9WJY9yKhog58i4A3eKFJNbGMvZrq3jCPaUstNXpPz6P	359
13752	2vabbDhuDZiCYXqYqYYaYTSgz595h68DRWn5ZeEW1Ns45hPNZWxm	359
13756	2vbcmG1XPyjwEktPFiukENegv3c9zVqLhfN6xzQwoNbwXfRPihYB	359
13757	2vbfGq9882Po5sdZ1w8Di3K26C3pbY5MVWNjQ9qv9iE5x5rpvfKW	359
13758	2vb6rkiTmjCncSBmJt17sELQ6Trs1UbMoU85Db9JtszoymMaB1L6	359
13763	2vbrt5eNCnRXQKuLBi65mUDnJo2P9WhiccPVzhk8JEmbtxyZifQ3	359
13766	2vc2mS6MVHCQXki4ep6AzY6UjY4QRocMh7jkmo5ET5bMPJ5hVGRb	359
13773	2vbUMcpLd5FHdhjfcLTR9P5a9TLDDbDhehV7qHpyf3Mo3Cigqq7N	359
13776	2vaM8sZRvzRGgEwgb1JG9g17U1ys3NMRdxWAVSmg1kYqr9Uz9o91	359
13783	2vbCy4SbtEEBJxNkoe5nXnTwuXmPcDUYSeRyRdVxFvFYmRmwNLrQ	359
13785	2vbdcqRsL1neCAp8km8pk4BrAyq9r97kZMqrM3vA1HXSbB5YTVjN	359
13787	2vadFzgr778nBdr9y584CHpLmYB73Ecr5rPkwJ8rUwLQJYzh7Ysj	359
13792	2vaJC8jFaqzjiBBD3GazPnqUvfPwgYnqXWoAV91G1suRJNKjWw1J	359
13795	2vbpeAnB9wPof7886NrfAVi7ocASNdiFVCYFZGTaziNB8NBxtXWd	359
13797	2vbGegDy3HxEC3WWq6hWPddgskDJkUiVe96Mp5LjZe8wG5Zrso8p	359
13803	2vc43wxxYhXMdZ72JYG66qNX3F61FHUCqxzYBtLigMBFX33hGBzg	359
13807	2vbahFgEPdfCx3bQpK6DzJvCqVoiooSeqReptfBCF7CC6tEoQJeq	359
13810	2vb5mySamJd93oPByrwPQmEAifvPnHMKJ2Dg2ufGnQmnYYLkPyvm	359
13812	2vazKyjJYBE43Uqvxrp9Bi8qMjmqQbFjiZ4jqompmoMEQoWXE1dA	359
13816	2vbqWUzsjmF8bPnWAfiUf37gm49F2w1ekd9ySS4jYxHjP7FAvvUU	359
13819	2vaE21QkUiED8fKUtju34qPdSgpxYq92RGTawrSsHes76jnGubXA	359
13824	2vahtpZwWNWaWipFmi1eEcYnnrSS4erPVHL61dD1pKc2GxrGuBYG	359
13827	2vaba6npL4JNVTE1NPiVH67Wpu63dvYYNLhSc8MaHbUrXtXfZpHJ	359
13831	2vbYvq2pApSsLgVfWybze4pEJ6NSbFSFRPBsXjEKLk8Ead3TSka3	359
13648	2vax55iqnF2tioGhgWjDm6ooYMPPzDfSdrSf2RPtwKtgs5oXof6J	359
13651	2vbvh6EMxMYPyta3Jj6X8FDRe8HjbpJJgLc6YkSidAohJtJi3YwG	359
13659	2vaMYq37shQzGfDaRBQuCgjKHYDh9xb6YQssvCA4EMfpLBDAQKcM	359
13662	2vbSdYL8hZHLr7y75HnSkf3iMBV5qZmF7xs7JfC9vwg1grGw8yhM	359
13665	2vaRT6SWK6wDxxSS59XC6f6EvJ7XRM3j4N4w4vLZRAFF5Hvdsehf	359
13667	2vbRT29EMby6md17rVyqFj7zoLBmJ1m9KpWXNUEcXpAGtKoFyx6p	359
13671	2vayxKTF3P2ixxxb3zxPjETPHDVd7rE6xTHch7x3WMw8XwDgbAww	359
13674	2vbQP2pm8dtrhv18yKHkoqdAmVa6MaJtt41SK8DGkqJsv5m6fQNK	359
13677	2vbSB2ZfxKti8LJWL6BgnpysQrXD5Tu2BsNzMCzznmyZVKuZD6Cv	359
13685	2vahj3cPC7DHMxvDqrf5oMzqvSDPjQGuJbtbJ37ch3FmS3zbC4wH	359
13689	2vb8AbTZx66CU93gZRFXevhSg6v4CmeJgY8mmwhhS7Poen6M6zSW	359
13692	2vauKQYfeG9KDp6WTEjDLbtvmnKwEwo4478MXmyeU6rNwnQ92wsq	359
13694	2vbgAaQCZ3G7dN3mf4gLQix7dkrUUE4viPZneXF3mknv7XrBN4sK	359
13701	2vbqkN9reWDa3uGUaWGETrH385pjpuweVpuBEmbeJ2wFoMsakqP1	359
13704	2vbhNc86DehAxyxoyZhxQCHyD1ZX56BXvNRrKCwhCjcTFvc4xyLw	359
13708	2vbofAM88HpxNXpMDf8Q7JvmwkJdeNEDS6wVQZp1TpmatpR59mcb	359
13720	2vaavRZoJ7dC6Cg79J4HyZrd2qVJrAFSTrRSSFgxr5uP6QHenkmF	359
13723	2vaYZi7owVaVCa2653umApNs6B62weTCSgg6FkdusybCEuxyRSjE	359
13734	2vbjFLDzHVrFCauR8DZ8J64wywBYMYrXMPCZQm3RGU93BGCWQS1D	359
13739	2vb1niDkQrGqmGsVep7uDJDMR8SA6jmJU4kC46KxyFToJ1phTAQg	359
13743	2vbV76EXTcjkacnnqU9Yqjkiqy31HYne8sTBa5EwmpB6fUvmS4Qf	359
13746	2vabb4DVTYabZx8vn7WMoAP6Vb97iDv1gMs7zPEARd5QVV3XHS5p	359
13748	2vbGNcxpxHfHAYxirJs9fqD4mu8RpBFY6u8N8mCN2SYdRK2Mb41B	359
13753	2vb2174CXoMcaF1qn5JJs8BCW2vYJ6nHWfzmZoNW8kVJ1msEm7B6	359
13759	2vbXRpHQR45jpy9RPjQyoZW6ZLfDsorwAM2cHYvcxJWCuajpgqoF	359
13761	2vahf2ZLLRHJX8c6GR69h8GLcVEw1gyWQwQA8pAuLdjoxeQJjqE2	359
13768	2vbPxttHxzzFeJtxNUz6CbX175SrjZ8JgGYU364G4zLwSHDsYch2	359
13770	2vbbgBwsnZ3TNPALV1nyb6Q8gcKiy5y94NQ6ahYkLtuHHcBCb5HM	359
13771	2vbMsjxrsqGjv8aL1zarGdTEUXAZtVU5iMXnWLeuKMWRembRMo9z	359
13777	2vbm4z8STJTKX5Z6DnQCiKVXTcvxKCqiV5up4xkT9ytzeHfENYeZ	359
13778	2vb7urjVgZMepMHsT1jdp46nCWvzMRgVMNm6b27yEDjMjZgfdP1J	359
13781	2vbjzhT34gppEJiSrgfTwYbAEBHenjs2y1YRyXDijP7S68p5EpkY	359
13786	2vayhoP63GqwfNUhm8D7TGDvT5muEKUxGvQu9h2DpGUoM3QB2LZ5	359
13788	2vazNTCBefgRQ2Edco9aHiEQTkj3TbfCxDKeHhi2gduwP99R1k91	359
13793	2vbsHyReQT3UAzjAkjGe3LiZndxj7mRVbn3baxyXdKr7YzfLLr9D	359
13798	2vbmCW66AMZQ2FpE1Rv4eruviH2gfABiF3aqN8BA16bckt6HkHE5	359
13800	2vbJbgVNcmMoabY1CwdZdFTk9u4u79iEAsCFTCoXpvjFkcsuKEFF	359
13805	2vauUdW3yeaWM68qF1rLRV66omxZvj3nfpgvf3j7RKrxTcG3JnGy	359
13808	2vaUmhXG96YnzztDpNnGNetsNRzG5Pmbh2arvgdmJf6GZdKf8zD7	359
13814	2vbHyttqk4Bq7VpjXu6PKGpkBDZYnPCgF384GHEkZFFXcc53gZz4	359
13820	2vafccSRGi72sX7eMmhoGe16VRgSURsX28yxrCrRvFcvnCcJZ9cZ	359
13821	2vbqbgZw12RAW59uocgXj1KJC7AiQYysArf1kasE94d4KgrHAmGy	359
13822	2vajx7Ww1XSFb6qKzTivdWXVyaMrmZKabTjAJy6JwmF669B6CMYF	359
13657	2vbJajkYoH4J1FTUa3wrbxw79iumEUwp3wqK3tHGFxq3SDbP5Hve	359
13660	2vawUxm6CRwKukJRZFsKjTMAVPfzPh2rBFwobRLBUb7pfYiU7e7R	359
13663	2vaJVEiuva9Bw27Hoe6YvckK6h3sCRCm1M3eAUGJeqXS8r7AwFEg	359
13672	2vbUHyTBXFFU7pp5mpHyp4ns56oS8p5eLCpBapedNESaMVt3YteZ	359
13681	2vbCAbCSwZUoGmpkTWM59hnSTV2BwzmVEaBPYdpTrnbJD2wX5sQM	359
13683	2vb2a7EihqQjA2K5bGpqrFn4Kz1SxqLgoDno7gA1XrEfy4tAixdh	359
13687	2vao2bw1SHYDY5auR2VbG3g9kBFkzEHxyQCRK7CwXosuEiTQNwdS	359
13696	2vbVroypj12PQZJAF4ArSLaMByWWsgoX7DcSseuNMvxYvcyi1rqp	359
13699	2vb3fGKBe2DmCXwAJZcwSptpxEYd5vaqKrEk1uqSi6eufjnKgUTG	359
13706	2vc2xjpHyDoEu6VGsCKgj2ZMQTN25RT1tPERPpSt7VCB24voWdPp	359
13711	2vauyhP3wRByQaz5WxCbnnUiZMs9gYGJdz9MCcsCdgh7LPxGp6CA	359
13716	2vbXYkL25hxFuJsKrPhN27Yx47ogJETvnJb6aSgNQnjxPauYaDa9	359
13717	2vbeo8RhfsM6fPcnTkv6jrTzi5x4Ydqhx89xjmbteHfEBEjrVf4N	359
13719	2vaczEaehfK9K73Rn1buetjprjwvdZEj1qvDJDs4whGWzUKJrNau	359
13721	2vbL7BDbK2aThDne4ks4u1dqktEc54PzghNzL2N2aVFKAAn8Bhm1	359
13724	2vbbzy5Jew7JzRpxfq6HUFduAsc4ajC6uEbgLSqBWtvbdp7rwCZy	359
13727	2vaZdRTsZspBawjzwdCU1v1Xn9VoVhjwmYTWSjJAQBGa7fbmuocW	359
13729	2vaVzdqSYE1L72t1LbdZpwJTBu1Y6GR2EpcYgM6yZhZJJiyHLdeN	359
13731	2vboigFM9gtsBSxBLCjSfYSXfZYDS7uZbPwUjZ86gT6mew3XTVnF	359
13737	2vaTkxaQDtkLGkW9VyuKVhUh3rqVgj2GzFQbUWz26smcJBMAbJ6K	359
13749	2vaZvwJt8hjQfAHNcAdLgeH346oZBG5fQZPodbRYPUcThpVXbSQw	359
13751	2vaoRTcCpjXqQPj6mLkDmVDx3fZ1D3ZEF2Zg2HCwZPC2oCHJppck	359
13754	2vbFohbMj2oUxCyLL14Yx3kmFjJTV3roefXmHgJErs21y7Y51tfC	359
13760	2vap5T9pjFiWULZNJo6saahGiN3JfbZg1a6qhuxXQ5r43ANrDrMH	359
13764	2vb47q7qT5YA27ngAMFaHTAk2iycyftFCrydRouNH9h5ujiF2B76	359
13772	2vapq1GqDeKbsxXy8Hhbbs4BegWGnvvxnrJUWrfiJFttZmuuy3Fm	359
13774	2va9c7o4jyXEmfpPyAp5YVLbroDWCtJYF3dpBpE8WMxvB7wmGgBn	359
13779	2vbrQUE9sm477zdUDQFgGvsE6yY2V8YxnTyK7B3XeVKTwA2ZbU1r	359
13784	2vaqEbVT5RSf2F8CNsv6aF4MmWZ35mp6FUPxVEcH69pZmbqpAG2H	359
13790	2vbqSRqyReyisHK5XQgocXtYK1Fvz4mUkAVjj9jNnvfZb85MNb65	359
13794	2vbJebjUtyDuLeVBYREmardJ36qN6WQFpZnnqt8PMjxWjcyAGTTu	359
13796	2vafzB4A84ihZWLVsctHYAJvxZCdswmJ5PJ86wEmh7U54Nv4kxtp	359
13799	2vayk7uQ8jhTeWDAJP1YYYRuSa9mgY8iDAx6KgaFRdvveDQVwJjm	359
13801	2vbZMG4ZyLddRWSG6tz3adxJ8G9JLFFWtYWiBUQLnsERP7uXKVYM	359
13806	2vaWyHKyHmXrs9DvRTktoFMYqy6Pk14PXKEprKUZtEPnZrh7L4sW	359
13813	2vaZ1shw4heAq5PT7G5btkF6f6whFXZ9tXtqz2HG6DFkTHztbuc1	359
13815	2vaSmeJDre2DdFkm5ZigbZnSTDCLdeZUsAPu8eCPTpaDbfAEuvH3	359
13817	2vbP2mPDEJPigEcdEwsR36Gii9F9rix6pa2fzApQ7BwPLdGFAgiw	359
13825	2vaGMEJtFMMChxNvbPgM9cKGb9nMAeQ5ZSGroTQUyy1muuZBJ6h1	359
13828	2vbqpucDR2USYbKss3Y6RAYuogxa2YKUUzepbWQmcGVzXuT2uqEH	359
13722	2vaZ4U7tmU8XuEbkJHWACPfqe75w5nVRHL1F1GLFCRqUB9rXhRvu	359
13728	2vc3x3ZqCbFoijraRN9hJYLmxxt71aoYTSwSwjzk56LMSARaY7Lh	359
13732	2vadSNaDPrJCzZBvUyBkT4Ge5c2YxDxLoByQ3mPyPXE14vDQ82Ng	359
13735	2vb94QnUthkMVGQD7uYMjNNeiAeDEpwLGQXB6xdwZCngoVKCaN4i	359
13738	2vbrUKJAiSThL1SfM1oCD4GiyKP2VPQ4hqTpxN3dbzuat5BXBDQD	359
13740	2vb2PyNR5hM5hmES7EVuZobYEnWBocTB2LbqibscGq6rDqYmJFxF	359
13745	2vbcYyesYJMG1yPWyzMGxSbXBVRnMcjfRfNB3LbzrMYKgL4H4kdj	359
13747	2vaj7bYqSHmfrWKGmYUk4DcDTxayaAMPxUjaTtrn7Q6n6kNaFkr4	359
13755	2vazAnwxTfFiPun1VaAVZtihvCKTwWPSCWofUd3bGZa7pvWPqSYT	359
13762	2vc4hyqvbyEGyVUvZeyaky29toDrHf1x6MWT1KLWZNEYR4Da7xEe	359
13765	2vayFD6amxF1i8u9evDidUPAKiumrQq1QsrJp1f5WoSpvczqDu7F	359
13767	2vbFVyHCnvgU4Qpin7y9q1VGvkEkk2eD6TpqFiEkA4ddTMwukiUg	359
13769	2vbmQCmjod3FL67D8ESMcLFzby4EKrqT9aJbGFx9KAAUa5DemV2x	359
13775	2vaDBPGmnj9exwybsCg96wqPpuEJSj3SLHVxHVgcCuS57s6iVtoC	359
13780	2vbWtFCcHYkNx9byotuUfMLPmUnvzLGvzJfhSXaNRBcGxnUEKqAH	359
13782	2vaWAWy4D9cQto6WEgKTKcZ8s7CnhYnMnf2ejrp5wk9vTDCYsaiG	359
13789	2vaAuQiWt1xPGLodKGp1HxGa5URqc2S4KEdCiWMhjzWLZ78Yu7U8	359
13791	2vbQKJ4F1YyYeGeuTtCs4foPhHa8iZmG9sAxBbB2wApoqTKRwejk	359
13802	2vaNP9NWSFDDSrMu7mNs7uD7KXPWx5ZDAVuwQ3rqAaMjFrVma79u	359
13804	2vaySjB4B2TCPXRmbTVgmA57Hat4vYjhNGaDArH9Je9JmbdrmK49	359
13809	2vbNTNvcQHENNPcTu2yZuX7dt722LR4neRUmeM6hBgCcRTgj6hTi	359
13811	2vb4PA3FLGxcRBHgMsQtg6yHLkXKQLygusKv49Xmw2Ak5sv8vd6p	359
13818	2vbCdGgan761dixszRWoDHJmnrATmgQNw8uipWUpG771QhqES3tk	359
13823	2vbjbV5iN9byDeZF4CYKD4rBQV8aoG3g41AEvsJ8pMobYd9LgQ8m	359
13826	2vbUyr1vBzhu1UpyKeTfVJbwbdb7equENPw6wnHfWMmNUCVLD8E4	359
13829	2vborENrFxFgkMWBmRHYZWJnbcqRxYs5EoVHgMjch51f9JAyoeT4	359
13830	2vagEocAawSUjAJsFFejzMivuTpuKVpGDFrEFbDK6rDGsx5whPd7	359
13832	2vbarokCjnr6V4dnpu84WLcHkFmYKnv8q1CZub9qeSZMZbo3qfQe	359
13833	2vbGgRdBmcYAxNJfAqv4iPksVmBQrRr1qrAPQQ4EknFMn7DrsRyT	359
13834	2vb6PAi6hFsXUAsXxyi87YzEQavgV7Vt9wxnVpg7RrREYhS4cfBZ	359
13835	2vafXciofm4MYNsXdLKKEQe8zvxHdhKaL5P2uco7x32RkWTuG1Ez	359
13836	2vbtBGRmq5ZE8PfLEeMc6LpANwsNeGFWA5LyvY1KPot1etg7Q8eS	359
13837	2vbjjJA2ZgPCvhiFd4TUs35YDT4PP7o9G4fFgq7KtzMGQXWRpH7y	359
13838	2vbZPRcwF4pwbPsc4WS3nh6DVb72XtkpBFqxnYX1yoRzs6XMChXj	359
13839	2vaMDQAwPQrwDcrUnAzeJ99L2YKRKVviNTrEpygS1aW5eRSNdUwq	359
13840	2vbRXmduUwVR3Wqnm71dsjF6UnFk1JSU4kDJSWbVhuR7LNwxsQFY	359
13841	2vbGJ7J4YPm9enSjDx4VGKruo98Ju7fwrtdbY8N8c14Q9oaicVMc	359
13842	2vao2m6tkidYoowWd9RL4bNscTJUMyJfzZz5fGHGqK2fyz1SuNsv	359
13843	2vbNngAZ1WpBda2XpCbkrgqd5gWBYXjZkJfLKNfPCnqorwnZV3Kj	359
13844	2vbiggWzbD42kLuckmvPiSWRs9hQrpkta3FhVdczinYdpyHhpXUR	359
13845	2vanGfjvxtfqCSLofXMbDUWsnNTMgYh4KH1ibXPQu8UvXizXvXYH	359
13846	2vaJ2zSXvVRVLbFbzcwHWsxs13f7PkNvimjyB4CXYr5oLwfFGs5p	359
13847	2vaA51p9ihrXGhWeJML7EKTmHTDHQfZ6oTm445QEso8P2zXJM3JG	359
13848	2vbuEAxXtUDzRa1SWbQY1C1mSeh8qwUGrfMLY4PxNoKS2YixaHKd	359
13849	2vbnvZZUtJ87UTqCJQb5dN7jrCib2yWysRuppMws9GbGiz873xwc	359
13850	2vbBvNcjyT6ZxjT2zm67wA2MPsZxMsHkGCCn7gUE8uzegTeaJYau	359
13851	2vbKzHpDcv2SbjZiPqyU6CNvACXzhEBujr4fFfhQCTj1dsAmue1u	359
13852	2vbTDxfVoFviXYgG4TGLvN1Po75n18QhfNLP8A3y4HaUo3BQogc6	359
13853	2vaTyMMxQ2GCWpb2bP2gHA41hb2QM3jbyg6dLW34jpE3crFUH7rL	359
13854	2vb91QC3eF4JLCGN85Kq2PXoNWrhQ2UUCAr8EGPZkUPK8YHaQx9Q	359
13855	2vbXtgyj44gdGbfr4437GAemtdqEYybtpbgY5Z3biHuokQessZv7	359
13856	2vazYpQ2rh95vr7KfkQxZXdiffKE3xhSkLjiYU5NivUdi4UiHNLh	359
13857	2vaCh5a5QdrF48QrtNkhVAtXmFrdvQfiErYXR7pUJb6Wp2KTicKN	359
13858	2vaopoyrW63HVHwjKNoEUVFeJNoimZoRaM3ebTzCxFchTGxBhitU	359
13859	2vaUkXXv5LfNrWB9kDVEKpA5baUEhLDPC3WLLpGG6UHNKYn7h4gN	359
13860	2vaMv64r93qP3qmGEB8H4EpAJ1SmEtPqcvfpv8wM9wGTQWVXw8mX	359
13861	2vb5EQMvJbQ14N3qHVtfRAjJYySdxTQUFeSpSk1PTTuWRxZCzuLB	359
13862	2vasbo1zyAPDWYaAZFctb6gepxqMaBkB6YPgdC7w1u1sVDauX54L	359
13863	2vaUBB1Lk5s3w26t67XAspNGJ8Aq4a9o4q5qk5chRDqtAg4qdRpy	359
13864	2vbp5QKrhRjZuGDYNbwUvP9d59geb94ar3qDG9KCLk9G2Zg9W1Wc	359
13865	2va9yXKJV2usgtJZqXJDrrHseYGR88wJWzgppviaJ1qRv1zEJcSA	359
13866	2vbhLcyiRkeye3FFrYaRh9MAWArQA2HNtH6iuavGdJiugebog6fb	359
13867	2vb6RiKGJTp3NhuhPvWUMQoSmSQC43aPN1qnZWJKqvfr4npML6NQ	359
13868	2vbAY3aGW3i5PsbEtef4q2QV2ZyLanmmi5RoBYvFA3dEGRPgxJmm	359
13869	2vb59cz4C3V6sBEHhP442igTEZ9aaHcMCXzbHqkSmFvx19fsqS5f	359
13870	2vbWVPMn9xx7oV2QaK1uUGnDMMsHJpfPZSqhTko889azfPZfraPK	359
13871	2vaQhCpQLxfKLnatG35Eqj3LvxnVaiyEiif5Eo8dqPiqhFciSKsb	359
13872	2vbsvUFx1Ad9G99LqxS2DDWvVjwtEc3fKAjR16tfm5i6BegchC4q	359
13873	2vaf2CpZs2gGUVzUFSC72uqjsywis9mGquRmkndreSuBnH6owdtJ	359
13874	2vb2u4Jb4Gm8kFP5GBmiw3DMKEmwxcmZkddDkGkyfetgpAYV23k4	359
13875	2vbZ8wsmtXhWx1YHynkkFuw6gZYUDsq1YvCCobGXpY55thmk7G7o	359
13876	2vaMeFhXUp9JzCxEzqgbpriQG5xTE3ggvfYaaqacMtMYkFv3Trhp	359
13877	2vaPFiD7PSgQZV7Yfbzz8764jDtp3rhdHzoM4u5Sz4gPqB8Xy93i	359
13878	2vbG9xUDH7AFcky4Y28JFUbZTRAzDE6YLcuepmp6Umn7nQMybRig	359
13879	2vatvER6WFYKr1MeCnvZ86CiYkemTBeY6ocPHE3qdv7GiVmHWUc2	359
13880	2vbPuk4qofyipyTr2kNhwEWyos63dagyPwBDhtv1raEUWFHNgZcV	359
13881	2vbHBD4nR6erkEi9F2TULhHkmx9HHgiueDKtbnWS56d6Ms9kehrN	359
13882	2vba7ZDggoeUqhYaaGZHp4ZXSHo4auRnTkwj3pqNhEWxEtQdLb3w	359
13883	2vbRaXWaoHZuFE7sCbgSiHP7qJaen6k4tPUBGw7PUYX1fiLwtZbS	359
13884	2vbQmibRwnSipYWMR9VByZZL1FvSgWDNHEDG25n2foKfHELu9bLY	359
13885	2vaHkyvi9AXoyATZM2PnvphaRc1SPsfdBz7HGJkuDFEcLzyAadb6	359
13886	2vazwwNxQGB6TRTbxdzJ9qcJpK9YhteBLDhRx1VGmMHqAC7zNA6K	359
13887	2vbaSUqLfqwrncHpCmMoDFm2nBZaYsuqq1ujBCQTiJHyqgw8FurS	359
13888	2vas5KBpakWpcZQNiR39xuZQ9k59FZYcdUXmcQLMekzsAvZLqJBH	359
13889	2vc1NCoTUrttZHcanhvTJy6trH8YVkxMSgGCqu3iGZxr525CGDX5	359
13890	2vaD4v1HYFqWCPEv2fAcRJDDfyT1kZBBCkBdZcAaLxTSvM3UdKRD	359
13891	2vaicrJxsfNjrTiWaT5v1vxXUqfkC28sWzdtyViM1Ff6XJPsvWcV	359
13892	2vbMp8nZ8nQxpteCcqMkGFRcYxed9fwHidzYP6go24CXEqy7RYp7	359
13893	2vaoFRexrQAyzwArvdephAgpDP7NA39aA3tzPwLq41MU6ZmH9TRC	359
13898	2vasFgFd4Q6X1n99YRhfw91YdHiYMpFnXwVKKGXk8hJ4QHnEwk27	359
13901	2vbVjGWUhaqpGXpQKZmGiBYzyVS8rm8qJr9vquvHKcdzfZW7xrNm	359
13902	2vb6uUprtnSe9g5mSSaZcqwL8vCUW3rwK5AZfqHjnoeBbURbweTo	359
13905	2vahtsHTcd21DtNBva8LQRChCKq3ak7Z3NmdaQmc4zrFvPfTtkfC	359
13914	2vapWMpcNrTgc4ZZGXpkeqf6dF3fHDSQaxR8EzbFeiBwaTNAapQ7	359
13917	2vbDdaAXzp1J8FU66DDRSE9xRYup9rK4mK5Kjka8PP2ARwP7kHKS	359
13918	2vbovVNobqsH89eXUC2mzwXD6mTrSMBxEkthdrEi2m23aKGiANJJ	359
13923	2vbBTg1WFymSUTJc4et6E9AKmLq5PDbfJqoqKbB4aFueQMXE87Sk	359
13925	2vbJhj3sbcff2wtZeLRzwCFEpTTQbKKA2qR1UG8hC3me9higXnLZ	359
13929	2vb3Zwm9SLaGKP5czfS8GnHvmGcfGB1PrYbBt2xSiqQT5hKdJX2n	359
13931	2vbW7yb3EF9kNyMmmQAtyeuEhJd633ChHk57jQBy2WXDoRtfvHpa	359
13938	2vc4UCY3zwLNzpi8SaDTrgAhTHkvpoR6gJjZ9f8QUEPpHRHhqcGW	359
13941	2vc1ZSXT4HzXdQgp3KgVigobq7uep1cDrvEDFk6RFbFTYp1rk29d	359
13943	2vbdUnoMgKVn319VuHMBYYSiqsTCA9tifZT4tvDTRN3iFsFFa4wL	359
13948	2vbgFQoBiip4nvZ9uchfTFhnrPWvMy3vduwukaCEekVaz8A3KzH7	359
13950	2vbDzx3vXNQCt9NLN4PaQh3LSqSVnuC6DKjrstBnb57RYuoN438w	359
13952	2vb58caz6joytfE543bDYC54rTS7es7s1zFKYfMciwmDHyAp2WcP	359
13955	2vaj2y85QrpS3jKxDsmQDzMojvZpGRFzYgr1rwe2NHaS5ykkrqtR	359
13957	2vc4DthjQHcTz2REhzxXsR26hMbqGzJxGDF3Uu8mDcwsV2jf3LMq	359
13959	2vbr4z7wxBZBwgsKCt73gXohKnKD1faeJ7sGiqfYx52SeFpZH88G	359
13964	2vaDnHYFu3vQzBtbVsYvhFFgpZXEoNUHaUe8xR1keQJ9SQ2fi3No	359
13966	2vb7pSmUcH1K6rj9AxKUQy1m23yaD11WgTHxGAiTQRJBx9A2tsjv	359
13974	2vbSZEDpDLnNFHduFFfrUEExhCphvedyUw4bWbvuNQWYT8gom3vg	359
13977	2vbnNovopp1qbgvswj9q17h62haCmPD1CyA859hdmZeko9oRMyGN	359
13986	2vb5Um2vBYcKNwk9XuEX3jwmB62iqiJaWy4kvYoWYpLKbP7aFVyf	359
13992	2vafRebXvoXBvc5EnWxBi74hsNg46HFqA85WT7R7oStkVyCbfeCR	359
13995	2vbpzUutTyfza6kks6zNTZXQikpBfhXyi3emqAjYARUTyf41m5V1	359
13996	2vbCRLwGLCXpKJuZFQtDMijXVJWjoNK6udjPjqhCwwiax7WwysWq	359
13999	2vaVkpo8SKH2moQe843MvrCKWgGMh5GinuwDinxBRPnQha6mXFWN	359
14004	2vakhp72ntU8YZsi7nf2zeGHsGHJiEXyEa8xhFAGYKPByKchfqTF	359
14006	2vaf2csSwA2xD2TbwRUNitqompjivcanMKFTYnu7bAJg21q3bemC	359
14019	2vbmi96BKqTRDxBAbdxBRfKPwHdZ4Npyo3d8MwVYQdAQqg6HZNUm	359
14022	2vbRG7yEPucVKHfT3fSwjrE4ZSGMa3pRhxcQtxmUpzMWGv6BVZBy	359
14023	2vbufK3QDpc29zaJWVXV6WmkLVm9fcyfTqrDuBwwCFtj2AjweMLa	359
14025	2vaEEksoWcy6AQaaVRL2ez4czkHpXHNQ4HNHA78ii1o1yEkGMhR9	359
14030	2vaJWTyT5UsKRgG5TdxZhYrTR1WoGMwE2HZxJ8hKLonAqehv7jry	359
14034	2vaySRujataLs3QABAn1xGpx9dPhYbfAZtLg5NAhbc2DX9m7YseP	359
14041	2vb67BJwdYoRdQLTCCWzyTb9GSHX3xj5fpKGvPgfnLCquEkFnznb	359
14051	2vbngYAzsfuggAseAcGS9uvYRUG5HgiSH9xHHVVNwHY82maDK5q6	359
14052	2vb4QThx7D6zz4bDdt8b1cPHJaxczte6Bh3T4x2Mcmp1hLwvM7nE	359
14054	2vae84LDVHBEmurqJF8pF1g3PkMBNbD9YnhtZmXFSiwD2dSWT6zv	359
14058	2vaYqvzRWW9xR1U68zypiG665n9dVmrNTnHofWqTFHA6NioWWMpw	359
14070	2vbNgWzE34mh6mh3wYSdAowPAvpn7QRYoujFMmeexNcMRkNkJkAm	359
14077	2vagmFuNrnTmE2zCdoteDWo9vJvJHLBkaAvCHerdbcsavu6D1cbf	359
14078	2vakVn844YJpu4YEK1BnBZGpDKVK9nmYUASmqYPbX7sreLwYhamk	359
14082	2vb2SJp7WRC2L2gbGn4oevLoY4HAYQzJtN8n8K1nh8nCUeMQDvY6	359
14087	2vaeSE4rwh29vbsmmwezMrSbsduCWL4Bv8AGxR332zqLiXbY6ojC	359
14089	2vc2rSBtLmuhQsH34e8qdHHRWmqHUS23LaUDDxqCScfvD7zNZAYX	359
14092	2vaASducw4F3oLPCojEKBLNLQPUdg3s9PfMZELX2YY8WfNGVz4dk	359
14093	2vaEzdiUfxpDEXfzFHBEAeoyrn1EmazX8Wsq7XJ7pLf2gXVQVGo2	359
14096	2vac5BBQYSMBJgnanHASj2E6diPKDD35fCb6pLs2kcmPSDVJcEgf	359
14099	2vbvrB2WMfdGtQogas1XWAq4d7EuXoCkU67ePibRrDUQvxccYEsK	359
14102	2vc5ZA7Aaorjbgoi62fkTNdVz1oHr9XwL8A6xbZvDrMCUDNeo5ri	359
14105	2vbtCUjfEGcArFodDEMRzHnXLCD8jtcBsvur973goEnmczEnqits	359
14109	2vaKpkoYp6tMbBuetMyMUNH4f8L2CWvGqUumV889XYiy2ggwVEX7	359
14111	2vaUVg21hTFDxTU85FUh1ZUsb8Q8KAuYdun96hzgYkZSwas8J4n2	359
14122	2vbfF7ZV5p33ASLiSp73WxQr9uDuQu9fWyQ9KSLwc3nD9JiUw1Gt	359
14127	2vaJGRxtnVY7Fh6MMhi51L5NFLxqWRvMqTrXcJGLsxUHhF6XpuYN	359
14128	2vbrhq2z2KNMRH1qLABC11V2SWEKecW9Fu8HsW2Rr7M3fWwDz98e	359
14132	2vb5PNNNVmocaSd4rAf8ovavcuzXWhWBc9ykcz3AChZ5pDC46xgc	359
14138	2vby2vyGA6e3nqbxUjdKn7FCCWWNcgSHWbKPJ8jsFb7EHUiVfBvx	359
14142	2vazXw6oXMD6wSGy72d3NgdCbbdX8jjtobyAXQbqjbyrHGHyRvMX	359
14145	2vaRYMPHEvw3kC4nwQ9FsLw1gAeBm6BSSqjH2qRV8MGyBQMjXrv7	359
14147	2vaXhDxCE9CRrSEqY8aKFNkjCzVfXrHAeyC7LtoMykUUb6hYiANk	359
14152	2vbECQqjsMxyHp1Kiyg7Wg657gh3ktbKyUPhRdfgpuejWTr1uED1	359
14154	2vbLW56XAgha5HrBPtnSaJrKr2Yr3koubsikwUNsSGmLNeKLyS6D	359
14157	2vb3HUyzgKkh23fHS49zYhH781PkG2BM8oXUU9igN42wHX8szo9E	359
14160	2vbpvd8reqnF8mXXJk33AUDK46v61VJziaGX1t3UPe2Nvb5RcFeS	359
14161	2vbM7Gyjy5tTgmREXpCXRR2JNSLgnfGmvXUsyHS7awzCbuUyWNYA	359
14163	2vaYoYsWiAEUW2VV17irTwJZNXf6Q2P61mAkjzBXEzRUy5phBgZC	359
14166	2vaFGnr3uJkTJQUSUpTQocfbJ5QAQJNzRVp5psTr91Kyz5Zvg7h8	359
14170	2vb8FrBTbBS1y27NLgSUbpzippAHBZMUsH6vsos12fndLbc1hFax	359
14173	2vbmE85QXc15Bz3hDCWVUfSLgXuvwJEcLcmYMREWeTtdnypCfFwN	359
14179	2vaqYNJV7pdfNbChb2efgpAjHvAdoycxLgK5VDAS8ga8dTYJ3BjR	359
14180	2vavUAcvxwwQLhbEH6Fe5BHixZiisvm71caq4c1KoKBpisCJj5y2	359
14191	2vbt5gEZ79b6G2PqJosfrt5jqr8ewYUe4JzmReEjdBSFpGUbyNJ2	359
14193	2vbxxyteAksd1oE35Sf9HvXXVPZf1RcXpfbj2YN9vG8vTydsL4PJ	359
14195	2vbHwx3fUpb7QFX2JEAURneJd2ofcwDJK53hJhSZX1NNA8CXoxGo	359
14200	2vbcGEa9So2W8puuA8yy7thKmkYhRPVoo1yjzk9QbYCSUoxdGgrH	359
14205	2vaw7ckoxSMD4HYsP7vnJZ8UGVeyyZs4QB2xN9yUfbeaAybH8qR9	359
14207	2vaKDFSvzsHKxyrgU38xPPdCVscecRpS8jHduREFLUec11bGfQ8Q	359
14209	2vaHGqHXV6fENRRewJvbuYAVLD3SHtbuvicVveBrbBZYT1ESxNGW	359
14211	2vc2RjdS6JEMkwsqLp6AJbTmfaaAoMKyANXdyHcFKJayZTg9cebM	359
14213	2vb8AL5Y9ai3sAAwQkPvC8FNaNivXjkd7HtRCMfrq5sh45kuERrW	359
14216	2vbzQD8Wfe3ixBP7UqjxdPoUmvYUDEavqyqBCR82wMBqkiFwZh8L	359
14217	2vbMj5LSnU4iRLMCrwoKGRtVPqUXUzzWCYtQmkjumMWRcLsDPWUY	359
14220	2vbonNsvs6RknBUJTYssuj8DPTQMRaycpYPfBC2zGi6VJQDm8dPS	359
13894	2vaGtSLbuu1oB63ZLFv6WbapazHk8jYhsbGUt1j96Tu74EhYesRD	359
13896	2vb21Ja8h7hbacXJbABpuk7d28FSjhRjH3qZ6g1Z8zyHJ86A3r7z	359
13903	2vamjo792zNb9aSXujmSM3T5ycuEroG8pi5wjzMcefWPX8dVCavk	359
13907	2vaVXgCJe3FTEMBb8dEnhv4pMdD6di6bfQ5DnCEciVUZqZjENzfW	359
13908	2vb9kWuKUNCrC9VC9K51AHayTbWoCMJPy7e1JZshfH9N7BhQQRfB	359
13911	2vagKQXNnrVtdcL5XoSEpZjMdsYj2UmUzU7dhh9qQ6eKCEc4wk5Y	359
13913	2vavzDed9UsFaq3kTSBxWB4Ec52dATqDAT7mukb3Ss2gvHwwNVKd	359
13915	2vbjUFvgD6fuFmsiymym1reEjJzz7NzPTA8Y4vDY8aRDf7qZBA8x	359
13919	2vbqTjKoPRu2a4HXAtQpWxJvHkHnn5gvHHuthjGR3X3TXAKPupeX	359
13921	2vb6STfA1Fuqhhjb7v3PsmSEMzNeujW2nFsovZsdchfiu4bsEWMw	359
13924	2vc4G49deRW47PYECFhEPL76EuobY2GLTSSQE4sXpzbj2Sqs1qAg	359
13927	2vazWk4zAhtvR8LrR12TkNbRyhGbrjUZWK7sFS4njb5ENYheerLz	359
13932	2vaYjoYYy46ZjBokSaFN7FChM3uVGaKqTK3t3rJVPA2uCvH88JCw	359
13934	2vaa25szfmnpB8iQJnhGzW5ZvjxWcLPB9huQvtUfMNTHCM51MA18	359
13939	2vbekqS8rrUmypmhfCC1QzwC53Q6uHQjdTMyVaF81JW4tntJLmni	359
13949	2vbazv5jmNsJFMYX68a1nV59oE61Sj26BvaUtHUvxb7tHRGKKWzD	359
13951	2vacPQ6EZcb9YvL1D1Fm7U4mrRtN5JZc24y4hwtQmsiQynoQx69H	359
13961	2vbzCLdLA9XsxgCgD6pPqmJCWyyJAyGt1ofr3hT4nPprWNJMyqoz	359
13963	2vaam5MkwLG86YupNEuyR6DrfYM5o4uBt4oj5BzyJUWU7LQPvjrX	359
13969	2vbVKWoozxx3SuAmMQBhjrFuj14QYJdS1BtgGhWoYiSXme4Ugym2	359
13973	2vaP8BzpAFE4cJfdjZXXeDehHgwhoTXEqxBp6ZkpQtgsRvzJiton	359
13979	2vbHLEfDXw5dPeccectBACStw4Ezu2obrG6xMyMfRKNuFvofgrSD	359
13981	2vaFkVE5jge2hCgDCquBBHomYz9F65AE5C24rfHWThT7vHYoLACB	359
13983	2vbmiNzNsg6gESEK8aAg4VEE6Bis5ozBBeG6tGUzqD5P5obETRmc	359
13985	2vbeL273HZfzhgRvMoyznhsLnHTwwbzCNUWiwMdkBgy5eRCSLkVP	359
13988	2vbxfq9HMnGCMM7MQKY7DUgx2zjTQsN3kzWKHBwnC9ZMecji7Xsg	359
13991	2vbvjXdX4FfdAe4unkedqh4aWrbToJk47Dqc98GRPfi3TWFaaG92	359
13994	2van6y6ip1gYfXoViMeA7udtNjki1q9MGPqR6i7hAQ4VzJPXyZ7n	359
13998	2vaxSQ4627tdxDqC3kSEXQFJZ6ubavtjYFM8HqUgkqeg8UyRiwas	359
14001	2vaeuzEsN1oWQmKpcXQVvVntH4WWXh5irZubPf7kAAPTwTB6RGF6	359
14003	2vbuYwJ3z52KCH6NmdkLiKNYJib56nw3cnKCUo6RQSkSKdFYCBAJ	359
14009	2vbc438Ppm3qZ3yNkPw2ecVMXJWC2Neup5MyPeBn8CuEMeDiHSkB	359
14012	2vavCiXJr5HQjEVn6oFFQ7QFwR3L7zbZTrvDLWVJt2LrVs9zXPDq	359
14014	2vaJAAX674bV2AJVQdKHq8CpD2Kfu5odp6xgns7pJGXXdKCoynsW	359
14016	2vbQtZ6WzG4ZZ4f6MHGKuZvbbJMTKzjr379K2LW5KoFsAGPKvirV	359
14027	2vaTTKuq6LN1xkXXdC5Hmqo6Qgx8sfErUE35nHb5mtCFA7j4rnR2	359
14033	2vbLkPfC3BqruMu9TFJjAjshAiQkfBUz3yqZPgKVA97GCgS1SeKD	359
14038	2vai3VLut87CMpRnkDTsmtNA4UDx9skEuJcQUe3DQtX1xp2umRmv	359
14040	2vaaaMuz1vehJVyhFCna33Qw4sbEKMLN9ds5NUzKW4p69FPgqRkN	359
14042	2vae3HvU6kAgWawuWY8Bo6HJrSV7aLwsjaSvPh5UQjbB1JxsBxgm	359
14045	2vakFyiV4P9nLSPXeZGuo9gmZjQYc92Vs8d7LodXfMdrZE5eXNbz	359
14047	2vbPMZMSX41x2r19ZPef9NucYvcaXVHZwueYkTJon912dKuAsX9E	359
14050	2vaRen1vr3foV9T852G98inDAkN8myiMe6eLy11DQwg792PsygT8	359
14053	2vbXKf69aMY8XjWknEuXP8iegcKrscfpwc6iRtcUXeDVxz9BsM8k	359
14055	2vbtepMroULNAvLrZv73Xdx6kpgSdcVJ8aDKY8VY5XARjT6AhoCU	359
14060	2vaNs9ukjZXG1LMVqJL52iNeiuF9HDSJimxMUitAse5aBjQK2qeK	359
14062	2vb7JZ6gQMGKsTbnu5bywMjcSQNc3X6nitmhkmrBZK1WLkgksKQy	359
14066	2vbweW9QAA231biEJmi5xnWr5FFtyXxiQsnHEX2fDAKvxm94SF8d	359
14072	2vayzcBYF7UZxRGBbFFbDVJAS66DwduMj2osQTPS83aBxbgpsUsw	359
14076	2vbje4S3Pj9zDexdHXjcsmiHRfiEBidU1MCrYiY9YGkrBo6YGKoD	359
14079	2vbjZ1VuDL4B2zu8vqFK4d4ftY3mn96vviBvtWG73Bj5e6HMm432	359
14086	2vaCACb65DL6vCsF6rHcR8gxqQBJysQwkngLdCnuVyh9Yf8fDeHd	359
14091	2vbyzAvt7meJA2VNeD3GP6gQo6KGWKN6mhHTgKMkGD2CMfmrmqBU	359
14095	2vbiB8ABJUo3Nbnz2qtfo2k9FRVbw9x8bkLEAAVKHYjvUUXr3TaM	359
14098	2vahh1RhDm9n85mQTwkpuTwo38SdpkuCTW2VAE4eKpbU8tgt3y1s	359
14100	2vaK6fPjEuNf6jVVi1MTBAsx1XgMoPs3QCU1bnbPu6eYAZgFpPN6	359
14103	2vb91it2W71GwCTuws69dxR972oAH9V15iamaZsF5pq1TiawLvW5	359
14110	2vbD5aPJh9NBkJaXLk7WZ4o9UJdgay2GKhp8hdb6yQZsSWHWvDKS	359
14113	2vc1XycQu57p6fwGmRZd6ktLJqR3JT3bDKXzhibe26BRp21p1GUZ	359
14117	2vbyZ5dwjsDTrKWFrcbEme3tArQpHCTb8hT4q7rVBEpgdQcVxFoA	359
14125	2vbFU1qLD32X2QCmah8RoDdHCjot7G5N2udHKauujYrm4SKWdbHY	359
14131	2vbxfergZv9923U4BNkD1qmCGNgAAii88WhGGreuHLDUE6xjD8y5	359
14133	2vb8Ya3R7CnUkkqw7vdc5SabZkM7EeP79pf4hjiPDfBZe7Q6o1qw	359
14136	2vbVK9j4Zmun8fEB4XfezKkepzLt2tfDREvUeFTv9hTDJu1wfQp5	359
14141	2vbpffVdvkMeihjuVpfmMwTADLjM9NncUqXh7igGhMTtPZzv9c3x	359
14149	2vbAhsXXqTe59QV4P7D13oqAuTkAteeERr2NcHkMepgBNAsHrjSN	359
14150	2vbaXRvR9Cj48YxxEYNuoLkc19hvseWd6G12KikuqjU8bEDAM1h1	359
14153	2vbR7CZysrCcwNBwE1zm9s62L5Gn9ByzpeLS3WPNpUm55dNQ5EdL	359
14155	2vbN5fkLBtbh6Q9NSxr5FZZM7DPYGWAaSPZn8NWZu3A8D1CWUfcv	359
14159	2vbQ1zuvvcuiin93sEBNZjbNxANidGyt7vZyjm653Lkb3NCdXVPZ	359
14169	2vauNsDeRzAuQNEZENddLepobVYmVGXW365HAETmjapvybz7Ut5A	359
14181	2vbJp5YwbHgLqT2BJSJKHFX6K8qeRPhqGTAotrUZzhN9uXZ7hwaC	359
14184	2vbDG76MdB5axHbquxwg6u6PYW4waLQX8SNQNoD6G7sZaCdEJqnj	359
14186	2vavMu3vek3dXZJRLWpmF2Qb1B4kGnCBZYWb2fH6nMLFtMbXKBbB	359
14187	2vbna5ahzJRngASvTC16XgeyXTzrGSovTSQ5NK8vY9er9co5tEGQ	359
14190	2vbaomcm6qvsSZSbQ38CMuFQEBNGSt1Bh4RK3yDK5eZm7o8DFoeQ	359
14194	2vahD5dMoFKQguTa3fSQ7Wtnix6xDec6K1a4RWNASfTPMua2bdBU	359
14204	2vacrQvR8QNwSyEczhijPBEp5DDh79MYJgYeXYrQZphfmxsJi1to	359
14206	2vbrSB39MZAwmxGSsJNCiNVbSfF3T1mDFh4MJAJghz3wZKR6LbzP	359
14210	2vbmSG3DtALUQPAVSzp8ET1Tyv7D362jxS9mkAAWhwropTtNYse6	359
14212	2vbQs7sjocxdNqq51rW4WfC7QaMLmo5uPy3CYtu4eZNnSB5M6Gd9	359
14222	2vb6JfzPtaRcmxAQSAQ9GbzS37459b26Z41E4CPDbGQ5nFUK6DVG	359
14224	2vabfzFxyXcKoUXm8wrwamEv9B3Dkz5B7BGdivrnYVtKpDVH87UV	359
14232	2vb1yHMqhcpX6ecouoxeJvwWveV5G8UbmhXXR3BEUdx9MHcfKjQR	359
14237	2vbRtGU5QYcvBLWmWETn714ErveH9my5henwbrSQ7axrFrqwk8FC	359
14241	2vaauDjVHDrga2uWLvdfR1HfZEx2UvpKWbHN7DexGXpD3fc83hDw	359
14248	2var1WrdBWEoiEewfqUHFsakbo6taruH8K6sPYXuUUJqE9egPy7C	359
14252	2vbiXBLKUSvCqfG9kT493JtQTwzBBVir6PujyVxA2xQiGtMvUUqC	359
13895	2vbRS5YQUNbizTB1PuPCUvmt2LYE5vFXb7hFHqvaDXQ1PQBr65R9	359
13897	2vbP6s63doqLnUhxvzUzA347E3NF9FK3kPu3qNPY4Nj3ev2AzYXK	359
13899	2vbKsmGyNrEVQFBjNjRUeujzJ7NkHYgMb8YyFGvgeKTxRUV8BLFU	359
13904	2vbZoo3bXTZWHqKThS5cVrBSrsjjqbGvQ6QY1php2vnsUBLgGuPA	359
13909	2vaddFDVrdp9wFYjNyZ2zfLmeW9NtfEu2srXKHMQz1hCap2YY4H3	359
13910	2vapXUHqbg3g1kz1BNb7DYB8vivN2jYYLrUto269nK97gRi2X7Na	359
13916	2vbazVELPRqMJoMWDLm4weXybbiPZvRRWx6UWF51nwe9huwcAmtD	359
13920	2vbpdvLFVshHBPGHoJw5tw4ZCAtAcxbceBPv798oc2NvZyjgV2SB	359
13930	2vb1v6DQ96vwQSMMeYJ9ig7d43kyJuBoc5bVpGunE43AZ8YsPLLf	359
13933	2vasMek9WMiK47gnbqZDx78xw4PkXFQHBizyptmQobm5831P8Zwq	359
13936	2vatAfMaBr9iMTAnAMDyxRwu6wnLoAwD9cTw4MEFjKDxbuH2Gzen	359
13937	2vaY5ex9SgfwyGFfhAZ93A3NKUSx38HsuxfP5gYB5FTNdaLXCGMQ	359
13944	2vabQEzj4Xzz2qE15ZJjdm1gonhvbYXwSMcj8MDLDCB9ZQBxsuHm	359
13946	2vaaekdifDvdpWGSfjfrpXZSScCJ1VwvJF21YRXDYtodPAtAJ1NV	359
13947	2vc4LD1GV5LW9gYQNWg1zBe6H2wSLpQQxXTyPBcTgeJCE6CB4syy	359
13953	2vaYShSKDF6GicE7uigCwTKU1zBPvpsuki5VjfiFXTHVoXwqqL9s	359
13958	2vaFn6avni4WyDNXQHxbm81uTDZ7pYdge7CYjeZ4E1jjJdriK1Dv	359
13962	2vaw2ejmJCQWuRns6Z53WxAJ4LHg5Gxuu883gTCyd3H25HhbhUhP	359
13967	2vapcToDAeJTuaQNr2N9DSnUsh6r7opGW4Ucb5x8RbEeXG7GGDMK	359
13970	2vaQkbDPJ3grM71KASUUZ25Li3C7d5k5SEZqnMCzWB1d5BDmnxYk	359
13971	2vaLvnB2EuzPD6WzdyFQgniW3gjqUWnPUczYzaH7CMFcGUemXA2n	359
13976	2vb8XARCQY9i1EybmLkBjoGebuZyRHCsqWMNNUiRtBSezt5bWeGq	359
13978	2vaBuHwywYi5uyhfhHhMCBHNSnuGueCMYKutMCwWEgn8DQLXPBfL	359
13980	2vbXnSnpBx5rHaCesVMnyN1BL8bE6gSMvSK7ds1qgkRTmHX6dxhv	359
13984	2vags7LK3mh4JoL2XtAFbketV5V7pz4nE1iAtL4WophGtxetmExt	359
13989	2vaCgkKJgT6xZzzsnszh1ehhRCAmNZQdiLjWdavMwQzAvxFi7VoX	359
13990	2vaUuUCxT3uahXiKzmkkE2Bu6Yz5upV3AZiuGoxau1Gqf1RFjQyV	359
13997	2vb14NN7EXcyy4iTaHLZrzbwt5LAum6LwePGHvEnKhujzN5MyJw9	359
14007	2vbHr5sYdhPkFNF5MzroHeQLfB8bj2wHz45t8xwidRVaq6HHCTDb	359
14010	2vbQDKBJahdaKq5sgEw18Coeq5BoTvvTW5XJwYM2d2hKtczKikjS	359
14015	2vc18diqwKXNV5mtqXqaLDsDednNtF4PARTR792d7p6NahDs8yH8	359
14017	2vbwaducCo9YWmcK6q34fg2EzpjmFHaMNMXmB76oAoVRwf1bdm5A	359
14020	2vbYd3wGDhF3dKTHD6vnuTBNorQa2FLA9LFKrM6LcRBUmRsTnQV8	359
14024	2vbdbDH1JQNgBBr5Gb6eYQjwmk2hgmeNyTVHAt1Cfk3p5TVCVD3w	359
14028	2vabKhq1nDkfgGKpe8UAjiSMr5pFH5ENXc2XeWmRxkWzikNqBpFC	359
14032	2vby4zzZG3i7pFvDEF9UvkJQ73PX1PHm2QXQgyx7dwxAtSLZfK9Y	359
14035	2vbGS8hw212ELLtxzmKsV9dqYTPPfcxrizM6NQik9KoSqDSsUU9J	359
14039	2vaBF7LGf4ZGJL97wLePfSRiaeqM3UTR6gnKBLsR2YYXExo4WNMG	359
14043	2vafnAxcURfMYu8r4qZr8AqDf4jquYUUdzqZh5YJZNz6msr9hzcJ	359
14048	2vaqQBuupFPui8nU9vvd7nGwkbeGmvf8jyJ4bEU4QqTTZw652pEx	359
14056	2vaexLAPGXEinSFVrFCxki9v9HE2Hqke9upysyu8GiJaN9rp73D1	359
14061	2vbZz1Ma12czwBUv5EtYNyRzwEtBSQbJHsfYjfdJb3NG5b6rekii	359
14063	2vamTxN5nSkbDuy4fnCeTvZdnJxbFcPUzXcpJvHTuRcxgXsmbWk1	359
14064	2vb5khanA8cgJ5xucVZpLb521i2V8WJaPuw3MwCA1ShgXL68Vo6s	359
14067	2vbzepavxb7baN1sumEZeBS5k3bBgLqat49ZfjKY5xHUHFcJ1GMQ	359
14068	2vbrGsrTYL2Yz2c1BTtzLNmncxKQvtD94XJKx8AH81Z5conBipT9	359
14073	2vbj5Ss9iebG8hL7EcuMvMtemUurSh43dfM2UEECUtQMhdobosrc	359
14074	2vbvUW1UTdW9Zx2FZAupZHZuH8oRq5Uex1Uc7FFuZvaEY1sJor8V	359
14080	2vbycUQGsJuzjrAkVZcjw56YFMW31mpdNejgRp5hk1wjywoMQUSA	359
14083	2vaz2J4NAbnUHRy9fTZJ7U2c9Yh52mnr48kEWS2FjwD5Z2BR2Rvi	359
14085	2vbpmaQTzKvYbZxYRpjVCXiTxkjqKBJQJARSVv2WtiTGgP11AuTF	359
14088	2vbSw17Rxf9i6uHrqsL7v8RFNSfA2dPyfNF5m77UgVsQUvGK6Q6Q	359
14090	2vatg69LHbXcAgBiw7b4oKFkbeHFZ5gQrfBNZnKyPAAB6NdqqARm	359
14094	2vaFrQYyD9W3oir9pNp9urVgd7aJHTXTdzuPj6gTv1rPwDkg2DPB	359
14106	2vbxeHGjzEJS8zUMd3o1j2b21hCcr2iEYee5ebUKPARcx15EwTNt	359
14112	2vbV6xmPv1YRZWhbogWMK8w5LPuycp34pSUzScd6YCsauVE7QDpd	359
14116	2vb1yK8uLKaYkVx2Cc9GXhTPS5gYVKFPu1DH6aZFwDpXeQtJxgzC	359
14120	2vagoFH315MYaL77B1jdg7KzUg6Z75gyLBVAy26jS8snfMXkH5ww	359
14129	2vaJc5iAN8eS6HZ5ZM66DT23GBG7aYiEYEu6xEvjkiDcwkZp1HzX	359
14130	2vbqkm77SCC5p5kUa7BwYsacg4Q2mRup6URctS2Xzs5CS261qa9N	359
14135	2vbP4YvYUhXVZjdFfzShrUrJXYUL31GCHHqdSeCtPUTikpsPuZ1C	359
14139	2vbtVMafhTCUkJUow7od1cDo8rufeDkMMCgj5eUuLw8VXsE6vWRd	359
14140	2vbiYAjYmFSHJ9GHcTc1VVVQgPsLm7PKJzYrZaQSd4by8TeJf4Le	359
14143	2va9hcbKzU6QLyPnhGLnkR1yNCZXLZk46J4v2Fn58j1JTq4dor8S	359
14148	2vaymAEuqNRk7tzx8FoPmjPDQQLLQnq7NpuzPigjaY58xyq6DpFx	359
14158	2vaJfZAP7ejmSYwZvBwT492rpBwRt9NLDuxJSH11deewcGMBMmzJ	359
14162	2vbeBRQdyCSp7hH8Wi8MQxKaisjXFbSHRsr2QZQPyCce555pGtq4	359
14164	2vawcCzBHKj38SvmiUhmukeeEw9stahp5i48xNq5iTm2FedcVwsM	359
14168	2vaDbqT2jS2jqSYZaKMSBqMpJqghWA5pnUPCSTJ1GNUrd513eLcE	359
14171	2vasr2m6GL4m1oS5Cj1gJyZC73vZvKNaCw3vCuMAscT4aXwAhdeS	359
14174	2vbdCnLZmXvLgEjfdGe8Tws6mFcyPypw6VmZLWc7XkfhTmVq9F58	359
14176	2vbSRbBJPRLss4EFuvgsviLTTY9NtVdpJgAHDhuuZr1GuSn95CYY	359
14178	2vaDi14rx1XxGaig35SABDTKa991JWGDjYQaXXAjYPMvE5Lx63aM	359
14183	2vaLFC7HGFp5SwL4rbZid4HNXKE6h95R5Gu5uYqWN16SEs6MrNH4	359
14189	2vbgM77KcNYAvVoLH3ugZRKoGsixdCYmNaJmmDFs22MXGKRrYuxq	359
14196	2vbX2KFPEREBftqvTqGu2aeNVfJfp5mXhxqU34JKYkvMMGSRZTzD	359
14198	2vb14SCP3RNDrUdxTArX6ChndCgx8m9zgfnjsdWPcoZ3Qpqx28dN	359
14203	2vaL4odawQsRGeaodJ1PET616PsMQdt6fAxYzXcjrATo5b4vsHKH	359
14218	2vbxYz2im8Huubi3VW58ZnWPLcbmsA91RCdRXVyFs2GmecaRUNjF	359
14226	2vb4HqyfCPz35nfk2MwV4TaB5zHQELsHM6DrLDHBHxW9Q2fXEwfR	359
14229	2vc4rs9GWdvXgryHngRaHC9V3dcK2CC3wNHVT8HsMtNEegfyFa4r	359
14235	2vaWVpVFvmjJS7qVxrcsbu3ck8w2VHgGmg85XPthQobFvbWV6uBg	359
14240	2vaYbtfVA1md1Wn1jpHVNyNHiJLBDCe9puM2J1TLxpLfKSokziSZ	359
14243	2vaFt5D3mQqF2BZJKW2oa25bWZ7hKZNTytwSd3CKH8Z8eBtHSPtW	359
14251	2vaWcMkD2AS9mRqMb2nyMxXCiU7yp7uBxzttfzmZzUH7rfA3LHy5	359
14258	2vayHVyDLVcLMBERRk2zAnCJaKRFrgWjjtPwAHC66mXZLsJWoqpS	359
14259	2vak9hsgHHeVdY7xLq9Hk9bceLtWjk9uvJi3nDb622WDYWPL9CkT	359
14262	2vbKSuVgwex6y2LJ3wfuJvpF89zdUzEEW37LrhvUucsLbDFJpdfU	359
13900	2vaNqhQzGKeSa1phRGH7UFSKJH9rvHywBEw5N9LvcTEEMCzCQUhx	359
13906	2vbVmDfjEdBoqpEBw3A1u1kv94NPYxQdmWM9249nBXjHmgQYWqT4	359
13912	2vauu6KBrrN3Mp6GEnUZVjFBYFFpjmpchkzhvamWGS7DDpQi78PK	359
13922	2vbkYcksv8EHsEnWbSTppQunfpr4yjnhabRwRjLAWU3Gedd1rLeH	359
13926	2vaVa9qFeevRNygpQVUBHteDacmNedSd5pFegV1roBtXZbJdnRjQ	359
13928	2vau3ni9Ty3faPSXyFoXiEgXnppqmMEjSgFs9SQHVQ3aADESXdXq	359
13935	2vbKANDMSY5CKMNxUS16HhW5eAS5sewCwRYnGpMmvC4P6bHbAz11	359
13940	2vaDneYZZ3Q4eFXcmQhhzsp3strxNFiUqRoDzHUixMZ6HHyW732u	359
13942	2vbHiucqYDuMgueV7MKLCmR24BQjLkcmwjWrVaU3JDRTY5XcMyw2	359
13945	2vaSRAfaQP99rjNehfzJgSrCdgM1KWsB683BwJtpS2xBt7Sz3a5W	359
13954	2vbb8toXjhHaz112GagRavgvPeyGgiLyRNrz2GQvxqbPuDTxtnHu	359
13956	2vbTZPqLGp3tL513XQAvZuCRKTAuZ5DqYHkWwPSnyB1vKnjD2VYP	359
13960	2vaFTxcSzwuspcgpSZX78TaW5cqbz14UxZNC59TduseBbDAb74TV	359
13965	2varoyFNTQf7BBnWyRLub9djWMVDCN9Y69JCCs7xPpdcgzkXCSHy	359
13968	2vbgHEcgwTL1CkxHHocTdzr8fLb7TS5nrrqFUd2ncyhfUamT6gqK	359
13972	2vc36Q4wvjGyWsiNhusyWLSkNBsNFxSfzaK4Lw93kZPjJcbY1pDs	359
13975	2vaHzr1sGUx9UhVxSeGJxD5UZs4gSfsLzGHyFgC5m6CvFjPek3b3	359
13982	2vaC59c1wCNc3Mg3LV1eePgyB1oneiQftid19GDppLEQzMd8jPU2	359
13987	2vbZwZGCPHvFpGMostB7PvxNociAhiePRzmTvvFiX68T7PpcNsLP	359
13993	2vbCowKRWaVUekYuMt4aMv7Cno2ToMFdcDBXBBoyBN8BXZa4epgQ	359
14000	2vb83N8NFpherkzc1idatS9Q9ZbX8zrhVATvhyQhZhivzDHrJ1Nj	359
14002	2vaK5yM8wsHJbkNDLrWJbfMRsCPBFBGcJBc4186dCkVbyjk2pNyr	359
14005	2vazDdoD34e3qDAHssVZCQL1mgu4tgJxyPDMiupDfh8hbaGkMUma	359
14008	2vbDmT4UekbB9YdbPVJXWgxwrH8qJyXtPptjiFkvWs4adGi78hpq	359
14011	2vbrWJgwh42YUz1SuyYGiFasnVJQt6CsP4uoWYKynjcidZxuVf7U	359
14013	2vaeN6kN8NXY7CUcQE984Hcu7rmqr8rosNpsPhZwYwBPBy1WP7nk	359
14018	2vbZyZwspoukym6A4NVbWSXQmtEdouHhdiYn1oZa4Jw7ZyFYcspi	359
14021	2vaSmPyzgFxzH5U2PGCPmdWzBM1sTyvq8honhhEJ7nkX3cdqdLHS	359
14026	2vbSAVr4fj2G2sAuVG2WnW6ukH7vN38SErpXV8GW15Gwa4HDAXrb	359
14029	2vbVw9cRgMRtY8EcJgQfWirgDehx492BLNC9cPBier9LS6MQ6Sy9	359
14031	2vbCP8SjBwHhzgqDFAq7T9MDgWiH4qbdhvUXt2GMWrjdK1g27LBY	359
14036	2vaQMpubuMuZ5qU5pd1YoN4TAAQYzdzPkdcYewSvhgQviBpRNzbJ	359
14037	2vb5UWgbWo8m86VoMCPpm1fXZFHRkbVsYNjiDp37vbU5DFugFkjs	359
14044	2vaKpQkHtfx6oijB7sWZpnoN2wjpLpumyrvBmZhQyUktU8fzE1Um	359
14046	2vaKGzyhX3dPEUR46jh6REiXhw9XMuCJn3CTWHp2JDQjKSmXZQr2	359
14049	2vaa1o1QgPASXPXjXZwKTTZGUQJxJgtDeM7yiFwvbJczra6kHbxj	359
14057	2vbzKyMs5fUQjc1yFSfAnmNFzAhvsmzBEAbKgaxdnrdf5TXrWmTb	359
14059	2vaZfqoHrCEd863VbmdFNJKx9Nue9E4fDo55jP76e8fziWK6n7Ec	359
14065	2vaB9RBSMB4bfmQt8EPhaCt4sWGTHW9tFSrXmesF4qwzm3SWbVQ2	359
14069	2vapwTuU9QbLPB5toqt2iTbYRcRUVDj6tf21gAENb7jcpcK6e7NQ	359
14071	2vbcrbd8DMXhdZMhEUcM2RuguYhMQGEDzVaZJqCyGcVPNDABB5JL	359
14075	2vagg8unhZcWRpz7wbVEEujiSt29Rq6nuRP9pRBEvBG9DzUtjZcX	359
14081	2vaATpPh8B1uVnW1ZexmAR1xm18QVhYVP8UW4WonE3Hub4QGcWyB	359
14084	2vc5nowbDT4fempGHYoz2Rez4tzV6YZjFFJN85SWTebr79hRrZ9D	359
14097	2vbrifVnHxfxDBMRXbiFfEvadyevytEC9hBntg276i4JqSeHRAoe	359
14101	2vbVk6qnt6AsbpENyaaRskebYJsewM68BZ1j3acrwuhxTpce8TR6	359
14104	2vbm1C3KkHjrxqyedNCCeaWSYtCyu1hLfhBcLjiTAasdg1WpcmqD	359
14107	2vbKFqbkDbmoGdZEpbpGQPpeYXTaYo6AneS1NpNdw4UoQdGyTpxu	359
14108	2vbkk9Mcz5c68vWWuQXXWDTHMitp938oa8vnyoLEWDdsNgryhVMY	359
14114	2vaDKToHZPaSPU6omtGG4ob6tCkv249fPyjgq3HTWdg79ohkm5js	359
14115	2vc1VMJJPjEdYjd2vjzt2nJQE8CiKgf89gdKH8s8iVAPqGBLKP7Z	359
14118	2vbRh1rPz5JB7B5Qmfhnv7yZ76qDbCupQ4VmYSvaVpbaYMkNAaUC	359
14119	2vb132RxWoJYJYExHZ3hTehoVG3Lz8jBz2ADW1AzShCxdVhivciT	359
14121	2vb7YWfsjjNeGGFBGG3mHJVMED2Gc4NJufAh4RQyPenCmgzA6ABV	359
14123	2vbhJKpQE7oGNZ5zdSyjUKy7Z8ZNvAxQVh4kMRsctqx921m845xn	359
14124	2vatAyyg68owncRhPqwfRcUaGEKhosaYnBsv66oxeadQzxVbt4pg	359
14126	2vbgERqPb5vYWMRXrm7spsVcNpfJbrEmmYXoUJSVBkx7Ws2YC9CS	359
14134	2vbYnkZDJCqbVkgcYD7kKWtmHunUPebMyn13QkeizwZGHFbUB1Bu	359
14137	2vasrKsZDsbVA61duMAA4d46YPP2r9SmSDSVmK9Vhu1ju8VbBhYK	359
14144	2vaz9E48vuQNTKiSwyPYiPawchhvkfS2nPvYVMXhGZuPfeMMvkAB	359
14146	2vbEE5c6orRXqfbbV16nvs4chdPWYWGcHLgTSRUWuiKSQvERC9x4	359
14151	2vaMoZhJDhVcWv6bq35j597zWiCaU2vVf2P4GKLPX4zois3oyr1D	359
14156	2vaQuZBWoEZDFnjTWkNVNu3wntNEGVQ1VW2p3aHo8uvmtvTdC2uM	359
14165	2vb4fgXFEpD892tJCNnUc11QvoJnambQmBCCR1we4zvdPkN1vciZ	359
14167	2vbUGTbD2gSJ13amc3smreJypkx1K1zzDF9ukxaLM5TmuGZNWoNb	359
14172	2vakvKf5n4VUpLaWqqMFvorKBNFN162EnxK2PVEJRGJ6XXZM6VMX	359
14175	2vbBEF5b8DeuK5G51zh2L61hKER8wFtzgttgqvtTU9p9oPsFC7uM	359
14177	2vaGE8urkUqvnyNr9BjZo7C3zAtExCf45spmfXSRxPMZYv4r6wjc	359
14182	2vb7jSzjxU8mNMAgxxjW82KnTq3JubNS6yzRmdB13mmRZCn2um5f	359
14185	2vb33RxzxBp49v6RsubEAHsfMPmyE1HrTykqWhmz8fuvkuxG4ghH	359
14188	2vaLuPjLxnQQC7W8nP7BpgSFuBDTgK32CNRqbYHY9aARPFerh6VM	359
14192	2vbNPutbkQkLaY4rTDV8HSmEuaMnLJmVrbQWFTAPk6os75vzTmEk	359
14197	2vaV7HZHVM2Ra9FLH3CiaYDJRqzv7iaq9JHYRFwy36UgkyWWQjLk	359
14199	2vbg48Aot4K5fhE29gDsLFBagwZosW683o8BpeV1s3LEqhcxKhMh	359
14201	2vbaUV5opUP8tFeAq6bToc6DGFod9wtJfFgwj4j4jTc3vHLSjA5T	359
14202	2vapzyJF2M2RR37exBWhvDFmM6oNTH4UuNzbprraNsyajLjXTz4A	359
14208	2vbgTtynWJGgdvHyhJyebaCPr5mmDogHNPdVQuF76iE8RQYyhPnd	359
14214	2vbBLzzYTuS69515Zo2PrqLB2zmsu4Dsg5wmUiefJNHN688GixMm	359
14215	2vbsGGkNAF5DzmSJcgTmxpU1WQKyzyAUEXNH4o9AVgbCWSnLAfQt	359
14219	2vadi8T5iTiJ51eUmA3s2rq5vQ77tusm47yFrUk9v8KaQ5MMBZcL	359
14227	2vaKMu5x7TQFzz3mtZcnrRvrP16KqaFYPaZWyudst9x8Uay2etSU	359
14228	2vagg85RFVMCpuDZ3TvRJvDpWh3KcAMPHzvJ2FvNpah9pTY8Pwx3	359
14230	2vbe36bDXWkFqGNxASdd8Ksn34v7RZa1cnDd97ECpqnJr6bPZmu3	359
14233	2vaJyypShYiPvZ6vEhEKsBD4uPacUPe3hv32brX6VGi9r5WQQ1Mq	359
14236	2vbBjvMgKCnBQ4YpTJqofYapsygU2QeGHVpWtzZbYVzUdNnoJKpu	359
14238	2vbMfks9uwCzSnHEMRyXeuqMmVDdN4gZuPuegY1iALCEsc7KXrK2	359
14244	2vbXsqj7MVEmGwVxn9Cqcw9Gmvxkn7asDP1W6P1BJGL4CnBNrP5n	359
14246	2vaAEeFUbWZwQg4FncSSQKfsataT7XzkNf1QPXF4SaHBxWwUgK4z	359
14221	2vagkVZ6sEsxiUB6D5p61XytZe9deUTTLyiGDtVCi1GR4L5i4HdU	359
14223	2vbTeYycL5DYHcidEhqBm1bG6aHsWyyQE7LpyKP3Ciyc4F7JszoH	359
14225	2vbsNKbBvugtSwWY1iYzCcYRi8QkdtzhvDNiAv3X3fqvnXrYsa21	359
14231	2vbrv52m6Stfw9ZkrxcQJ7fy3Q2MQdgyyz2owLRL55CpRnjo7LBn	359
14234	2vbvNv5rtKY3WWMrW8EEifkj3vKC4YNe3AWoHcokVVrQMNqRJBCv	359
14239	2vavX6KYfDb1pooaQhfvkYZ5x1tbFxCkvwFowWcNvcg37sTK75gE	359
14242	2vaXNmaq2ZULwwaiijDhEkAT1abqEX2q8MK5Y2dhJLKwue3VwXpc	359
14245	2vbkqTMf7rDhdmAykWJd4CQtfvuy6c3hoYJMPfkLuaYiWgaEfdUG	359
14247	2vaLKWm4PPHKPUtsPLgUS3UFvF9sS5wQKcZ4iUDw54KbchahPDiC	359
14249	2vb636tm7jpw6Vn8618PW9efsQ6dbnyj6aiQfTT62ujBPtMRWC3L	359
14250	2vaCgeNTVcRPo5QWLszyNad8L1bvprZBnatEezLuna1MzBMJKErZ	359
14254	2vbJcaHtxAHFUTbdDaY3nTZBUBL1U3Tka3y87g6EC3JAJskvPZKZ	359
14257	2vakmkKUTF4uTfVeU1uScmsZpJ7aYDg5uRyuRCMs7E25r1P2nu3o	359
14261	2vahs749xKrvmxeMfP2MdiHVF8KsbHPoChHZcNQYetv523sPL9Hk	359
14266	2vasyen9avEezxTTq1YaA6qGm2F6mbhMuMeMxUmpfvVu47ymNGvw	359
14267	2vaKzYUjwmZU45A78TGbSkgMqjPDTMLSi4EHM96MXwUAb2So5bT6	359
14271	2vaaMTcMGXEsU7BtEQSEGMnYreUXuELmQeMoKt1jMs6f4iZiYDMN	359
14274	2vababCvdvBpwZYJQn52ooYzXnYnibfT2ReqPFL6N5B8GcLx14HV	359
14284	2vaCP9ffLdaPLk2dL2CNf7uMSfAtsAzLNh4Mh1W2dr2FyhhRn5jz	359
14288	2vbqnQ4oHtDuKZnqAUnGmyKcpmqsdmEYeFkXmXA154dqApodzNf6	359
14290	2varekSy62tuMPyBDEsPn63E8mFCKsEgZJsZnoTevAA2GCUbVSYY	359
14293	2vavNuogvK3WLy5p56MzGD5BAZvdz12AaR1ChXNjo1umF2EYqUF2	359
14299	2vaWUhBSyKPPSf65Zh2cdJxZnTgFHpd9xnJ7BQYrcyxSNeFT2MYW	359
14302	2vaU42DVLQvPaqVNuGKJVBKoPuAx1J3uo6PvjABBsuiBYE6VmBqE	359
14308	2vbQkEPL8CvuwZPMq2FRkUmLb1eTUQRd9Jkgcig76Ri2itUEZYV1	359
14310	2vagcszA3BR53kzHxAvutvLjFdjkKq9CnjWAz547CTyoSbZrKEz9	359
14313	2vaiGZTCqHjf1th7duRVCzNyxjCMo8wWAbK1ud3ogQiewJwbA5Pw	359
14318	2vbhFmqTRrFXsyhW8A3J4p9J7R5rCPXfZFvGG5cvHGLXeoHS1uvb	359
14321	2vc1uT54wNYQgBMpz6nT1Mp4dkkFycDVja2xNTrxW598LHcpgmn7	359
14324	2vaMaui299HooirL2HgNJFcpBQdRX9wRJmG8nPxFPf3PS7fFGWMp	359
14326	2vbHfSpsweT3mAkajtQzKoxKttC8QwUfdmKFonVXfNDGxAscmY6r	359
14331	2vaENBSLgUF32QSXJyh196i2Qr7hhDDrW2bcqQSVnKwh9gFXoxcu	359
14336	2va9ZqmqNQbUivXfmiysqTwMVyXzZdNWsaAGoP57xLNRBAxZ2aLj	359
14339	2vaBWdPnj834d9QP4Wm8AYGsFJWQ4i8H9VAfz15B4WXKxPaW9K6A	359
14349	2vajAMNrBa97ohFUBYYVnZ4RjNpBzxfs7jvG9PvP8skW9hCNKSVp	359
14352	2vadg2SW7V9M7wywqDdVTsTe5FGTAAN3qaC6qYeXRbG9ihhDwnot	359
14360	2vb2Dhsh4EQ5yyPt7Sv1NVybvLx4269t5bGNLqWXB1opD5sDHKvq	359
14362	2vc5W9EvKpUERDRfFz8NkpnM29f6LsEu4vzken2niFer4BGvKybT	359
14365	2vavCKVgaZ3RghUfGiTTxPayAhxMJsQn7Zwwouuwpqp81jhHXnNi	359
14367	2vaJLEoZftr6YMYUNgAj96QRysrFb5t6B4tusnFViCH1AJppUcET	359
14369	2vbT9fkSaETEzPxqUPK4zcG5Zd9PPVBgQYu7jZYATi1z2UKdF63Q	359
14371	2vafxx7Sz1ov9w6srwkbGXKef6vdW1zidWS7TnLEHkccemzNgfXX	359
14374	2vbu6hXMb2VrepMHk7zE3SK8NFt14d8BGE7SHS2ds6G4ifviZc2V	359
14378	2vaZAvZqPf85kkUCNWkWrEfXGumMweFqzwNSECPAtFRBPZGhYCbJ	359
14381	2vbTGrfq5dmL9Eva5sN35xqCCWoxib2CaLGUJnYS3NyEjCaFRiLJ	359
14383	2vaPZkh4uqBskiEL2PfobT2xt4HuUv6rYvKdrg9Kff7DX4aRJUE6	359
14385	2vap2fzFiUEjKHJZRSBqbvoLHvNvDmF3m2zBaiM8Zvsi9g9yDeXJ	359
14388	2vadZh9Rxc8GsBd3pYhc3u56HEeM3SK45rmWMHnGKfJHPKjYT1mg	359
14390	2vaWecjcPycyMegSjbPiVxnFNarKKJHYFeUMA32HAnQayxAnjCDB	359
14396	2vag6kDGgAChqUChiLJiA3szgxckurGMs265ARygjpKE6BhrxQtF	359
14398	2vbMLzeaaCwYBEm12Wfs5TArcHogrBZqLGSbDT997vmWSZcAFbmP	359
14403	2vbk8E2ZDrnQEKEHMjMiZ7s7XZ4Bs2opafzFqmEu25sZB2Yf76WC	359
14407	2vaFKKPLgLSoJGiYUYVQvb2mGYt6zVd1Dv1daFtHHRsbRxn7SMd3	359
14413	2vaXvcx6MYjG1XPgXg3xQHdgpygkbwAB3ZegbQwR7m3EaHqV2EDv	359
14418	2vb88aKjZRdjfsxCGFHz6kz4X5dUJkkwE6mXUc8JXr7h4hmCNEK1	359
14427	2vaJZ79So2agfHYfscWazgeQNbthyQVvqyaUoWf2Cu4gWMzHh7G8	359
14431	2vb1UsqcXaZ3GKgqUMaathuAKeJpQAECnRuzNLQ6FKsnZGrLGjTy	359
14445	2vb2Bk5QgPxDLEWekxQYXvKQoyD4A1tcFLyMPAxxGf2nPH9iAk8K	359
14449	2vayfNnELbpDV1TZAJB3TN4QUZvTM78egYtFaVivKYkx4KMjyVdU	359
14452	2vbXh6ti1PbTVcaEwQzv15jSQkh65WAmjA42bcH3kfufFuZ7XntE	359
14458	2vbgwzoZ2MnwGrxj38DWvkm3tBnRibgWabXYKrK5HzNT2riX6BTk	359
14460	2vappt275p9nYM7MGyZnncue9LMjZUeeYfm4zmnzK6YFdr83zNyY	359
14472	2vajT8yR78uwSzt43KFGG1J5a31dnARQ9SnkoKGhkbmDi1ytCJix	359
14479	2vbqQ7TTKpbstvPezrbqGHx4ib8iXxFPHPsXsSksjMTYeENB5fHC	359
14481	2vaeU9dikv67zyhFkSnx5gbNFMq3oVPACZMytcBsLV33qYkNdSHf	359
14486	2vbN8JDjRRQaKo2RT5y4j1EpWe71uCm1xkbvR2rVfxkfqMFRkB1X	359
14489	2vbJEZiAhFa5ZgxYwXHMSL6zPDxTX4RdvebzwdbPezzXxviu1yoi	359
14492	2vboXeSgrGarseFhF7Q7dBNJvsffYS2qs4J2fiEzQUCDY4fw5VS3	359
14495	2vb3GY9ADc4Q7iKTPnPqyc6drHSQotRywgR4moicrtAQJLfHc6Jx	359
14497	2vc5d6c8AeeqqJub251GLky7g78ZULBES1zDgCAS7wwAqKWWmxSk	359
14499	2vaQM1oUvmtnTvysqrMUWYK3kJud9g3fytyf33pE4j35MaUYnBV7	359
14502	2vaPTXY7eKF9UXexC3poV8VnZHZZEnqQb12dMJMvbbKLVgra99hT	359
14506	2vaRA2x9mPGgp2T9ZdyvcC4dktVtpcG9arieMKxUn84becJij6ad	359
14517	2vbMeb12owZ8QAaN9eyg6LHU9LNK12oRhXtW8jqJPJsWPEsoBmv8	359
14519	2vbiP3sDmmGaP2FUzcjhGKJGrpmzMNzBCHhctscNPTtzD1DDGRWB	359
14521	2vbSwpULhcZva5wpr5DCSbc2pBE8MpdyQaF2UMVzd7jJhEVVMaTX	359
14531	2vasHVTiZD76d4Qr78AtpVboZ64MVKx16aayheBj1U6Y1PhT2AfH	359
14537	2vaMQ2mszcT7oMnACFNAZ1uxhZsDDsx2tTynBk2WV5JQZ2d54oWw	359
14545	2vaqQ5Em23PyGZaCpEm7ADCUz3V2XkCXkrE8D9aSNKif31E7qiwU	359
14546	2vaUzRNfKUNULWvufUpDzi8vcdFmLp71y2SHLcwVMsfVZQ4KahMG	359
14548	2vaFZU73AEaHqN7R2FKv2XidwABAsAJKJdkcRhQKvHaw8HpGFoT6	359
14551	2vb8eFT3B2BUjNU8rhLFG8iaYXFKwuGvrNwn8xxzWwY27Zd8nKEi	359
14554	2vbhppeoRSxw9xGoCBbKihyeRy6Uq4XzxoYaBmcu7ssBaKwV1yHE	359
14556	2vbeD2zm3m7742BDFcgtzpt5RwuBXuCcqkLjCsyxYc7xMc89aUya	359
14558	2vbCx1kMjjRDBmx3V4RpjfnZVBvV2FFh9Q9HFMBM1ZxYydVT3rX8	359
14560	2vbUqpUvKeGRdWN56GeHNpcaPd18adzw4edeRR9yHS13xLXhUpSF	359
14564	2vbdFjnAZm91U7XeWFDCVCn2jW2nYQUEoZn7xJQgityGhi6616Jv	359
14566	2vabM7C13UwvkEtZwXQatAxBW3McVys7qTC3RkiLeuR9rthkd77H	359
14253	2vbfnSKBcfgA8wnWSDetMj1UVNEAMVu5hCoZ1AaJ3QDLkbUKZb8H	359
14256	2vaLNeEHnd5BMdW3vpJUVHy95VzqHaetK22vGHcWrzj46EQGCs6Q	359
14264	2vbRYvDCG8pFHUejM4zFUZmNrS1tV9ZTeu5n8T7zF65msxouRpab	359
14270	2vaRd3UEMGdskqHvbZW6EmF5RRjXLCHKWGsUdQ2SuieAAAs8JDjJ	359
14273	2vaE2HXmr3bCGzktks8JzvG8naZQMeNYqr2g9iPGNFGRHSFqbKHT	359
14276	2vacixnvRnSfqmwMrVbotFLD2qU5yktWpsWziAZLN8QdiJoc7eUU	359
14277	2vagELKmYTgcBpPNgSnAF3JzwgozxBWrNgE9UMyHEN3ghd6oT2xx	359
14280	2vbZ1BAdozTcpbXerAKwothXzusJzzeGBLWWpoxx13DuTQJf282E	359
14283	2vadQn1Vq3U4Y6p92W3gcNiDPd77jmb4eDsYkui2wjioSxFzn48L	359
14287	2vbGpjgbZinUuze6UuFP9r5QDV1zuj1XrDu4xqkW7dD6viTmGZBB	359
14292	2vaKTTuMFZxcNXUJ4eowEzX8JFVfSXUByjaQRLJ3kfMaZffznBjj	359
14294	2vbmdjJsQ39UBxYbf1un3Ed22XkV3VvtNBMxgzj9ZcZkFeNaaiWd	359
14297	2vaT4ooNLdFtmr5eBF5PDjhRn2aRfCJEraYQYoGcFSuYhi5tDBTD	359
14301	2vbiRueLLoCvJVhSQbz353vZ83Nn5QSjibYdmCSdSUZ2Xx3BFJzX	359
14307	2vbcFvK2ybp1PKzkaXvCP1QVoT4CjbPWyXTA64wKmYkhez8n4yrQ	359
14315	2vasqyr2uSdwjePWwgmmjT6p6FveGdvnWfuHv3hyLdHjVxFWV2UC	359
14320	2vb5scD5jLYXoUMFALWaBCChbhM19AimxioGtXBHGo6TxsK5r2u9	359
14323	2vaPBw3aVbQ2Edvc4BaGkJ99sC7NdkDdenGPj4wxRv31DvPmx3X5	359
14328	2vapBGEWENysEVTR49j9YLTPHg5J17h5hLzqUAa7Wgf8uguqKHb8	359
14333	2vbi9LZyi38Zx8cTcTGr95xBkKseLg9PvMJjx8D3ppr2kYKeppk4	359
14335	2vaQN2MkzvxJKxGcfkgfhRrzGVTxPgBZaYioo15qoUoFTLSVFvuL	359
14338	2vaSb63xbnhVFUiJsxSYPvoq1Vmefd4n4xGox5SL8MM9X23zcTGC	359
14342	2vaMD5xPkyH5rGwAhi1ixDsj5HdprPmDvfTUSbU6RYozKB1Pgu96	359
14343	2vaZ87r4oxPuXpBwpX3dmF4pkaawU42DqJXoiWVc5aiVSbGsMmh6	359
14344	2vaDaANbw2z5WwCtS2vMTpFFqhfEAPDQxcPhfCecgBWG4sLvi9qM	359
14348	2vbChxHuwRMhJcBeGJSZHThjhPaqYb6umLmGxHkLscwirXwV9352	359
14351	2vbgtvy8zKFRwSbVaLxWwZnhNoFb1bHmesaJpLEyJ8WpPVb4ph8Z	359
14353	2vbv3qZzUDiwK1Mr7nqMu126fXjyMhu2yeAUfkrESJqf1CbEco8z	359
14359	2varzpUKNVhVZqSoGPmd1dVAoWqJgvbZPJN5JnaMyX5xwNow4u8D	359
14364	2vavo5uLXqVgr96RvQKiMcaVZCoyxEwvWNhmXyrygWekinoujXet	359
14366	2vbABh7o8yWMzJk8MBZHHopWCandPX7FwAYZiceGEUJc9XLkQK4V	359
14368	2vaVnuNozK2Wk6YnakcVvuy17JAcZoe6p9U8i6z7C5PoTjd9xqmH	359
14373	2vaegZjDTskkhTvmqmyTkfKCCHSvc1iGzRaUzyUMCRqnorve626f	359
14375	2vbxbb3nwsFRN1GeCtG7Gd7KfwHDSgeAUEPwgMq53x6o6VL2LYWs	359
14380	2vay4ANzh95xvPCDNKjjR9CPm6uGqHivBCn6WxrMcHvCuL3mG2bq	359
14384	2vbL4q9xCzZWpC35r9viUJq9w34gHSxkNak16HNhykAGNkqTvDa4	359
14386	2vaStTdgYtDo3nKoYP4GtsTqfcSDzDDbRJNLnqvkxXnG33p1CEvK	359
14387	2vbvrR1CFEUPeJXQqBaFkuKVbbELUm5ifcMyG4MKAxsxPLnT4kak	359
14389	2vbEGBTWfnFEZofuPhEHD9eFCYgdpjKG647WXZMijXghNCEhy1qw	359
14392	2vaiJ94a8dEF1cjRAxCPXqkE42TNc3n9wABHEKzeCzaS87YpC7CW	359
14395	2vbvMWf5QFjmV9B6zkBW5QSGpbJoXHEjQDaPBrf5SHZ3PBN1Ut6v	359
14400	2vbWFh5vWYqGHUGqHQivRZG6V9UmWNGEE8KoGmN52VT5JafEAR8x	359
14402	2vb6oDYtuSJDWoVjrGeNpXaGRxmVdZeKD3oxykEumpgQisKR73Ue	359
14405	2vc2EfHZvoPVXz3WGtSxLikPTPMnuvJcu9MBSZaRXim2hiVoTWru	359
14410	2vbh5PXsmvN7thxVdfvGsmQCAkgQQBUtiCGZRg3zjHLysdxR2EjL	359
14412	2va9RocWvGHSUruSBuYjNqpB7QRg7SCbdVW14zzUhFUrxNcx6vKE	359
14416	2vc4PzjN1keBtKdwUmgD2n957ZwwZ4eT9fJHdAhqmVf5nvzjRXeN	359
14421	2vaqS5edFv8SQK2791sZ32TTLQot3UcVqQ27Wff6YvF8Pd7D5d9E	359
14423	2vbeAnupMyJFru2HUAiVrMYti84dsSpd3DAh5r8zFCTZXEw7rDWs	359
14426	2vawGKYDWapwYGubMsM81iL3asnebdwTbUineA8GSLtDisiZe8UN	359
14428	2vb1HyGTQyerw69hr7RjEYrkZbHsXGJ9ZiSdtyQFQJN9fjmHBsSS	359
14430	2vbA7wkdmp45PRYjXtwXX1ydXrz6vSaE2YV2Nv7UT1yRERs1Ypqm	359
14433	2vbVevpesPiCntGsonMMasimTphvPBhvsvAk4LC5bM5x9QL6Ej7n	359
14435	2vbZ5vUNtUqZoCy91CFidk9iecDfeLKUiFnXURRm7g24XJ5KSsMR	359
14438	2vb48xGPWm8bscK6PjnphyVpM3cu1QF1wJQRfHZufNp86EuBjDij	359
14441	2vbScmGYdQp47LYdCYYxPoyX8PqBqMCgMmATftuVsAxbGat98X8T	359
14443	2vbitksy5SsSLzXHEH2Gkycuy773zCziDxJ22Vv8zVbkBo5MvJkB	359
14447	2vbFaA8kWZeh2j7edZBUBZogXCVn2vCpvhqwnymtqEJC3RegEUoM	359
14448	2vbJengWm3HhRuRT7cPZNNuf21VaKqWzjcZYjjQtTirqNbhfL2Fj	359
14451	2vaVfskJxtV1VtRifz3vgcyrQKqLuPJ5sqvirsW5w1RDFeSvGDRN	359
14455	2vbUeajvQWJfFaQ8uUHPeG7LQKkrF2CPbpuB5TjCQEwvaDU2YeZM	359
14456	2vbFvkA417d9NsWumVomCAx8dXfoXaNqJJkmoyC155kpFpWfUBkb	359
14464	2vatt3isSkCMM7ZiLMoRW5XqNkzmP9oCUJs2twdSUrPEkQV5Mwcw	359
14467	2vaAEaFdiuHDgABvf7QLLxS9Vip5BHxPenpRz5kSNBruHSCPNwsH	359
14469	2vbejPAnr8xKx3t2JUUHVP5tfPSH6q3g9kqkhJEWiLgpu6hrmFzC	359
14471	2vbpUokt4DG839xZSbb13VtwcwpyV3woqp5hhrNPSTeeKL9kQVqA	359
14476	2vbrCjC6yDpo3Bxnr4dqRjm2vuinfqE48TMGynBJZMwtxqAXAVrt	359
14478	2vbAGo88wWymXQRJwuPvY2ecjKuTH2mQpaGMqzYw1m3UURR3Xgxn	359
14484	2vbYZ1P5ikQnhMcPkEAxzbXH4d5h8v7JqqxfWrFVbNMkVzH9TpgG	359
14488	2vbLoip1PY4UuwbHuRc3wSHomVpdoBY5yctUk1R82jo7Zt9SyxEa	359
14491	2vbNN7jhRECvTSneGLU2aT61gNM2hAFMCqtLqciMXNWBvkhgEiTN	359
14494	2vb5NaVJD1ooJoQY4oBwvepB1BNKPU8L2Rvr7GQmryqdoQKP6arw	359
14496	2vazpsB1gzk2nH1d3tFiudWmueXatfpcrzEXmdeVyyZEqMyBWQyZ	359
14501	2vc4gkvnN99ArHcccHKofe8sttnBhdUsHiNv8nHhMX5ZZf9sghJg	359
14503	2vaG8Fc4b9cnoBCuU84zHQyZcqt7C21CGGrMjeVSJVWEMK1pRyuz	359
14508	2vaxQcbXJ1HXcYthkH9pwhxFDn5LtesRRvmRERw9aRCho4Xsxbia	359
14510	2vbjGqQWSNj2AP4VygZvNbiqky4BaPbFE18D11KB7gra6Q49x8gh	359
14513	2vbtMcNiXrjR6ZsPWtLozbYvDhWckJzTg7XdxyyKh5Pk4hxgGRZB	359
14516	2vaQSWiEDQzMcqyPmjS4R6nzN6AA2H4N7cdXVCFUVPv8zCmZoLDe	359
14518	2vb1ipGMVkGERMH5wvcsZj7soeHmyhByBxoeejNLyVWJrPipkrDm	359
14525	2vaCRWVn749mH3CzWpavGi6uk7FdcKUa2xaF2TEwExYhkCBzppNU	359
14527	2vat9urwYZg2JxHHtuRP1MhNYcxcBRn3pafw9AbgDZztreCTSGoT	359
14533	2vc2rctfRwoANjE1BPLJuHTNc1N5XJHLXy79Qsh382GGdo5JNHDH	359
14539	2vaxjQyQhKBfpzyAKEyJTSgmLMJnDMWEx8Za4PMC1Gi1ma9tVdsR	359
14541	2vaZFAWXwyGdW5nFqZCngZSaUG3pqQQ9jUPLBfQBZd4BKQzziiM2	359
14544	2vaU26r6BRnmscjCQXn11wuKvbehychgJYNq7X1dZT59QYMquUUa	359
14555	2vaFTmXymUHxz73wY5RsbsP1RBb7frmoMXfDRTQHd2SoYRA74iPu	359
14557	2vbqWNMybDmLxV1rS8eDS47FqK2ZMnmFymWT3uzRfhsQc2ZnGjLh	359
14255	2vahuGMyMyqS59SmENWJ26QWByBgu82MEcvMT1m3yCuarK6L5ZVf	359
14260	2vamByiU3kCVj1vipmvX16keeHdveuQFUWaRtL8dVeNYug4xG1yk	359
14263	2vbBrTxQBeB4Emx3orRSRVYx1Bm4rPZFyEe3Fe4DQWfCbNN3ei4n	359
14269	2vbz77DcbSYhJ9J4fDKRtJAKzQ6MEKtQTBuBit5YZ7hxPqwvJ25e	359
14275	2vbE3MHGwVveyBa6kZw6tq5aaie1pJTV88VMW5xkByH6VBJbLk3F	359
14279	2vaAvoneU3RYgnkA9J1afkJraTkM3PqrpJiekgsxtcrAE4TTTS3p	359
14282	2vbKdWqwqWLmTFiCFLzEeknqHxh5MBpQAHzMiC1AEMr8xiR2CKCi	359
14296	2vaHWyPrjbUCncnckBzjyRuJmni1ksex6jQ5WFRXK4ebs4U1uXAy	359
14298	2vbuesH5xc6EKdjA2f37e52XagzEpAqDeJ1oFkz4QLiqMCCdxibi	359
14304	2vbvLnbMQxf1kJxKrZ21cKmWeD7Hkh8Pg2qKGdLWSusACCuAexp7	359
14306	2vaSCDCkvRvNkkXNgk7Nb3wMbCgdtB6LLShPkzNhfUn6KTiQDtzL	359
14309	2vaPqLGUyfHWRuivCXoyEmCeAhpnEYVPnoNfVsK93LeFfs5ARgn6	359
14312	2vaVeFUvc1MqHQSow8g5EG9WXyWsC8eTo2zKa5otY8pbxoUywpdd	359
14314	2vbD4p3zaiE1WwmDzaQSGAdwtsEzEGijfeihuZBH7BdwkpS4fTsR	359
14317	2vaiq1kWugXusrLHhBZMTVZD4XLhKTfpHTT9DXS2pq3mMpB16ZuU	359
14322	2vauBZiJdd1k5YDeQKaHgEbP6RKoTFsmSfhjKoeE12489BGcUd4W	359
14325	2vb8hP5W6Jo5N8kcRWu7yEDkWfqzhYXSUGrnkxt9skooAZpScM7q	359
14327	2vbKfSNG4ySEsFSagCme6yhx2eNTMEddeTgUbvCNK4hBagsckFwX	359
14330	2vc1AMyY8TxGyNXeKrSBq1EWaG9Z1XNQREGkB8yQK1BUUhcEhx9A	359
14332	2vb7ywjXSGnXfTfaB5kNvi2UCTXL2mMa4vCJjpXAWMiBRy5nqrgV	359
14337	2vag2AjXG9RRge6D8v4Qmp3uEYAaksLSDrUoa9QhxqpWEQTEBEME	359
14340	2vaFm43U6LyuHvttrWbzU6YdVEQTBUTxhveqDF3upvhihGAB2ry9	359
14341	2vc4xi8mLLMWSbN4RcnKWFx4EPCF7gxxMrsz4uqrrtdJVoxGyvdU	359
14346	2vaGv4raXRMQdN7rF3EgXTW1gXBXfLvjcSEzE7VWBAVHYD5LzBNF	359
14350	2vaDxUmCTexva8yAHAKj6MSPqsjExe2stm4K7etn7hnwXK9MbDhs	359
14355	2vabrcjootaNJj42A6HGbZqSbC7SRKfjZ9QY9ErJSegXozFFXTty	359
14357	2vbjw8PzYWQEvgBVAUoTDnRfxLBVTLnSoaqhJo629PpgD1ZEt9ex	359
14358	2vbCgFgw3nsK6NE7MorQAt8Hg6f3zArbtfTAZ7aRyAANu4Knt8EM	359
14363	2vaMqFS6uu63UdFTBuT2GSZNcwucd9NFJAprNDeX9CSSkNayfzyL	359
14370	2vbrBRKcDL7RXSeZPXUh96vZidmmbcQGDQ8goTNG5L2bghGFFdiF	359
14372	2vbzzufNHX8wtW5R9E3jucXi4z3f7Wu82uVBX2CSuijL6jXQu6tH	359
14377	2vbrkLkGDkNsbWbmZvC4WHEaLg76gKdvpN4Y39xEGrSLEwkBEutF	359
14382	2vbMBQJXB7zNhAMHSNUeU2sc4vQJBkDvXX8Sad6gBkeE8PYRhiky	359
14394	2vbvMkMLqTh9TuvhFiFrKwkm8QbXpqWykojRFut7DbUHVJgmboQt	359
14397	2vaNUmAyoGkVB5J8ezPa9fsvLAs55Ba1RQELNv7Xhv3kkj95Gj9t	359
14404	2vauf9fndLXakwWNivdEa8mDoYLS1EKtpZcQhGzQ1C2xiBRhS5tG	359
14406	2vaxsfYmeKvLcArZWUgeCyxVFeNDr51wwhUGQQf27MuLsVDskkh9	359
14409	2vbbHPxmXAid7eZ5jY2n3QFJGLZCMNpYjQHjHDNPjm9zuiuJSKHA	359
14411	2vbC8r9kMbczZjVernohZ6VesbnwjUAA5koTHnt6vkVuvPfq4QTB	359
14415	2vb23e2LLzX9aaHsYzNjrL2Vwfq2QN9d2GLhi1js9F5Z6YdDAAqf	359
14420	2vaX5sYtKHgyMenwoTxP7YysAj3DT3FQYkVEs6S9MmZS4pBkpEL2	359
14432	2vc4YD7pbbQTnT2MvVKZFeBaS8Xa3h1fKXTxAhG7dgJFr45TgoDw	359
14437	2vb5CsiyvwTWoFMs3UFYERPSfmB8bHgU67EJcRQqjsbK9oonNbTr	359
14442	2vbmAM7XcBzhSHVsnZ9mhJpAQZJu4vYAp26Qu7rYZXxrp1r6mXNp	359
14446	2vaVrdndhHwAkWVosfzpVhTRiQbqeeVFWVXUPTs247FxQhdoDHxi	359
14450	2vaMRo7sspNbCMpPK1adoocNuRfuiRAiT2vdfktbz9esNn15NEXb	359
14453	2vbuvLLLdDWHjQSTw38NdNkpELwKxxtQvasCh1PfdF2cVn5AE1NB	359
14462	2vazG6NrBiKaXZhMyfAbF8wnFdMDCrufy9DdnzSH6aMYjkGFNjoH	359
14466	2vbiAdVox6j7qRwpkBXFbUB9WnF2CDUgWAHXTmd8akW4xxLkcPUb	359
14468	2vb5cimVi9mMsVgKXaATksNf7rk7GsGwqer88VPRi2LsBQgwUe2W	359
14475	2vbAzFaB6QfVk1jGk15enKZkNMBbG3Ca7xLZhX7JgTeP4JegyBKy	359
14483	2vaH3fM3EVTjgivtcPRJH9JEkFQjnsRdWMJ3UF9S3tVXWbBGKabR	359
14487	2vaLY4JpuE8VyFsbxXqwDTGv8qwF6cHyPCk66eJRSy3yDwTS312x	359
14493	2vbDRQzhgPVaCVB4HfzG5S7MuHr4VwnyaaKrW842qtFP3M4oL2G2	359
14498	2vahsHe8dgtqu8ZL5XuByN4SBqvtjtiwmtvpejuVGmftEpWUAFBA	359
14505	2vbjr5FHTWAx85Nx2qD8zH4D556S9qdTZZg7qKjLaLZX3Rtdz8zd	359
14507	2vbuCvPRgEYrHEAkgZWsCXH7rJBmr8XzdbtbPaj11g626pSPS6Tz	359
14509	2vaYdXVRrJQ1JhvHzdp5nMW9FHA7TSXAibZiH1UP1XmLB9GfzeUS	359
14512	2vaaSDEfp2Dms7WR3MLm8iQi767VFPj1bPXS2Uz5hPoNJKUSb3oY	359
14515	2vbGwUh81kBzvVtF7a6f33NryCYfxq1nfV1YTczv3nTj7Kp923mz	359
14522	2vb7Kgbbucjj9RGmPzWVCrwqZZDibee7RRC7VsLz5TJmfVEhv2kM	359
14523	2vbkdMFw7Y4r1LA1Wnm33uKVh6UatpZsceBxwzrn3Pr55VuTHUZJ	359
14524	2vafhDhd1J1GSW2fBvMuykA6LBqK4o14hSzj8xFtxWg2D1G7wziU	359
14526	2vaPJpAEkafyxEtPFstvR7wcj67r5ehLntLJ7Dtv221TjNgLNiDb	359
14530	2vaSifP9cbz8wSVu6k5Sexywe1Pi2WuMydns7TRpwhLDVGahntp8	359
14536	2vaGuzJr43YfAbPStrTjDi6HxsdinDKnWnc8hknrsxcXrjfduD55	359
14538	2vbhhCB48G2pFf2ruFnk9vUq3VZ2iLRBHW1M9kP3j1mnEPDxmRtS	359
14543	2vao9NGkDyMbhjAdKWAjqooHzj2o9j1aBqTKWhXRoy8A4KDyFpWh	359
14547	2vb8ePXCfyymRHba9xFMDYp96JfhyCKGXASqkBtoLsUiq6oZ5Wy2	359
14550	2vaaEwxC2mWgsmSVF3Mp97WW6eDPJihtn3qzTJ6qABMjDg1usgTQ	359
14552	2vaap8zzryUr6zgf4RxY6kgnn6hV4TnfbbjRXf4R3tfq29CCSc6n	359
14562	2vbBZcsNJSaqyXka1pzEAjydM4nKSGpcqKGQ6fV1EAKsHDVQPHZw	359
14567	2vbUdUctPGbxPfLWeDip75iXtakedJqN1gPcRfTnnmStL6cwiLKx	359
14570	2vbvpshLVTiHRcjzEnnZvYCDnRhqJkzZ3cwdzFr7iRBfnoYPWhAe	359
14574	2vbaCn3VWz71fqXFVuvHjg2VBz4Sr1YyjExpKR3uUNz7WTZbGySi	359
14590	2vaERxVn3ykhZ55TzyMYnpms2GSmcRzbgooPo6DNpXiA8hiJxA9r	359
14592	2vc4kxVnwd6Xwt8BsoJPT9xvhUK3iXRiNwnfdvged4ZsdorD5Qfa	359
14595	2vauUDX6DJhAqMwgZLaF1hpaZuTNkyZCYEmBrg71Q2dtdm85dbHn	359
14601	2vaZLYbGSghaTZfCMDNVSahWsBTLJgNckD9QU7xdjpWa73DeKFTe	359
14604	2vbSN6xkQZEDtUqfDXE346BqgW18xFKu9wiD9xGzybfmnx4ZKgsv	359
14619	2vbpkNm9kSfRmF3kM6gFwngB4F9D5ZZSv6jdBH7T9e9Agh6wJCPv	359
14621	2vavQ95gKezJ42mK5euU4azA3MznPME58qxzn6SbBdY2Gq3y4kcJ	359
14624	2vaJzQNstSVp5JbwVAuU9stpmJBZWrsoh25BURWAffyau2WpWkrT	359
14630	2vbyKNXsetLPPfm8XvXfBHiXDJoNQdymiVyUhq19XNKgcxsKcwYi	359
14633	2vaCBCFQbZjQo9b6RQNQ7xiVEeRJ8Qpn4qS2NEoF6rNuNuEfzxHu	359
14642	2vb55JRmoFDsgoMub6EHL3X1k2HnBqjJpn1Cgd7Yfn8oBLCUr35i	359
14644	2vbt2aKDJxXbaVrmuTH3MRWmT6uq4F148PHGvUsa7mhN9Avra7sk	359
14647	2vc2WUL72G3bEaQyvNMD2VtM7gYYnKjX4tJmuD3yUNFwWukx47i3	359
14265	2vbEnfg9VzX3yoexc3vwFhCz8mJMzEHx6WS9KnAx1dLM5uKy9d65	359
14268	2vb5ctrc4meFiy5pAiVfHUmWs9UVy1RWACjDEdkM4juVKwMFjfgd	359
14272	2vc1krqWQbiD5R5hwPbZ1S6Uo1SQfq4HjYXtqK9Q4V6NkDJRmAEA	359
14278	2vc3eY3uR6UYibjTKmPut4xQF1JsANzxPReULro8buGocCrQcj4c	359
14281	2vbW8162HtkXiw5pgbNUGSpQcbbmXNBrrabaaRPZCGvaBCPNCmwo	359
14285	2vaytAaFTcVnryFNJbdJx2HkycYxbayEXjJw48tnANjkgXgvYfrL	359
14286	2vc5WuYP73UzvDkuPaKDhmbFRZYBHbHWnMeXgJy9q5xhK7KfxrWD	359
14289	2vawx6ubCbZg8WPQpD7fMG2ZYnp5NUxVgZz9CjnzUDwwhT2DWbnF	359
14291	2vbJfgsE16RWeHExh83exEMhZeEwJyLi8oec9NvJw7YSd5MPChtp	359
14295	2varFTAHemv8iUKgMcUyNCMV9brd2xi6LkNLs7eYuamryuzfBxPw	359
14300	2vaHNkkZHK7iJiifLNvwUMXbK3AAELnHiPnBm9u7t51kx7AYrugT	359
14303	2vbiph5yUy6EQZS6CQm5UC2kcXbszsenkcr4EyJCtBNAakMA45no	359
14305	2vbpULa2oqNc1vJbNknMYeosUAUxjWTH1zsHxFvznhJesftD3Brw	359
14311	2vbXwSrb5JNmPDEfmxRFagGKA64D2j8AQTHaYQ9KbNu4ytDZYudj	359
14316	2vbRHkTLF6Qoc1RxRE7iseufdsG896vWcRCvsYuVraBBM1fwVAJu	359
14319	2vags7XDakBiUWvN4U19r1AUEFipRW6xN9EUv3GwrxZRt3DzZWsq	359
14329	2vbXF3AVU63mKs34YJBJno84eNnnbT2m8HN6ctn1ULzpT2u4BD4n	359
14334	2vb35SVgftXwVxoyJQUqF49Yd6YqB7PivtvmDUMqjCzggqsZzNzk	359
14345	2vaFiC7csZ3gNLrgunMtTzXzfPxH5USRr4C77YYMy5UJjNP3d8cM	359
14347	2vafTUUfKgksAJdsjrU21Zgpi5nQnbuPUWGCEYHufVNfQ1T8Y2iD	359
14354	2vaUzDZmAv99SZW8N2Nv1iznrYhqMUg9g1mADnPGAaJpAF8Rud5q	359
14356	2vbdDtNWzQvVnr3dqCST2Ay6c9QmWR8Ex84cocsunYt9TvQuX1LD	359
14361	2vaHZMkL2SLihhmrUuwuJqBK8v1oarJ1WjAf5uuD3PqVjkkMnBCo	359
14376	2vavbeApTKgZt4ovGrsBGCRRRunni5vczjh637DxvKFcapTp9yLe	359
14379	2vbCFWRcqM7fKBTZj6Fr6FBSLhcXgvczrrgqSuM11qUGtrsF8tmD	359
14391	2vbpc6CNfANXwNZTAnNkGEv7FeMwpqdG2mVGBmJes8UxLhSsAXnm	359
14393	2vajNBdeAw6UdiVSgWbUR7fCkoUiqz7NUXHB2922iSDPonYiQu75	359
14399	2vb3LrpY6kV97ogT7koca2Lt2k2y8Ps9tqiXvQZGGE3aWX47pP5u	359
14401	2vb677Ec3nyrqH9qa5ZjKLD9pvS6PuXR1jzrd5PzzQZBEXrE9rsh	359
14408	2vanaGHe7zVpLUpyWPbYb2kXFbDZeomJHYfGzDTzt3hptksbEKE5	359
14414	2vb5mS1EwJUUnCxU7X998W4za9n2TB73oDAEfciacMsnQzxDYDmf	359
14417	2vbN5HvqPxPiszLTxUrHRKwBbMHY25dFTJPLdfkWP1sU1NmUxoUF	359
14419	2vaA6K7E4izbwGNcfix6hPeZpq777oEyTfJvvKsrVo7Jbg9xp3Rs	359
14422	2vaXTstddPDcjY4ELvsQ3FDSuAxaTfTLQ6SdJq9THc9hh9f2PVd3	359
14424	2vaCDtEz2WpgfmwMkLV8KdaaPAWSLt4ZuwaPZ7GVHLf2akPLTcnT	359
14425	2vbQ5E71psPLeTLZojpXSRttJ94HuTjtdKB1Q5kgC5okMS8Q8xcs	359
14429	2vagriZB7tDnMNcuiduhD3XPwihBGoAqmjYdcFVYEjUwFevqz2F6	359
14434	2vaApJvQQULhpk5qLzzrnhpu9RTw6PyqErDhe68kC7nCD1J4DcKF	359
14436	2vasqZzM7Nebf5aVody3akj1J5pXM7iaB2DUyuiddLVTjRfB5JGV	359
14439	2vbDhQavd539b3XvmmPnrWjAqirVS8XL77BiSchvaWVQkD1sBsnT	359
14440	2vaQPtN93mFhwCnTptiznDLgrWQTEpnra1xmSYVGjcRPZnDQM47c	359
14444	2vb2JYB4q3EzLZoyVFmwvhGoE2mkV9wi4cWmPRRjddMnfNYSgEuy	359
14454	2vbJbwN5UF7mbdijDj9RQPJmpUYh6bEbYU6SBNvQHQuBRdBoksN7	359
14457	2vbyXA9o6YyYEeU7RMpoFp7Gim1h8sb2iWhbsHbidw42ErPjHg86	359
14459	2vbpq3qHqKdcXQgX248rVBSPa8BvXy4q46bi9jzuXThHvBaF7q3Q	359
14461	2vbRSTPrdL98czY4XSNBbRL4xTWvakwjWLAmZyCYfc578S9oBFBy	359
14463	2vbWdP7kqhFUs7WpikAuVk5hiQyDPvJyBWQ5GBZtsmm4bduGG34t	359
14465	2vbiSTArbWxJCK8EzyaWZivwbr7favs9f9mEczhV4ooKVANcTwQd	359
14470	2vbYx6QAFpEGta8jMy6ePFSAAGeMx3gWo7ZYxfr9Ac5j9Dyvi5XF	359
14473	2vauz9q1xrsSbZt1WoXkxX3Spsvsv7BPV2faWHMrrhVyB9zs8tRD	359
14474	2vbb7L9tNwe7qbohZ9VKRdTL2iA9RR6AjjcfsKg2eijVqxEeU367	359
14477	2vbzVPec6MdjhHTvYHJUwh2ucZK4zTAqLzqVvKvFwxzxqiFNwzKb	359
14480	2vbrHEb6zyyTGqgUvS6C1SBG1BBCTkoYVajtX2BQjdg5bJtCxtSa	359
14482	2vc4js1Vaq92hfZYnoYAFshhNkS85AE5bK6ezx6d32pQvhNay17M	359
14485	2vc25V8oUpQ6ugt7rmNH4qMCmRkWPQaW1Vw9Xedq5iwZvH7Zu9mA	359
14490	2vapyMYFK7qqKcRSJmaYe243hJCHYYyAEQNyQoD4jg1dBwj2gh64	359
14500	2vaUrsmFoLyzXjrdGDFumw4LXbzGxbE6WMCq8iS3dUsA6wM1jbji	359
14504	2vc5jYhMooXbNrEcABZ5fjWTiwMqVWTmnrjSPuzbb3YNA55S1okw	359
14511	2vbBPtebirKs7yzBcpiBc661LV9x7ve5B3ihXMn9qqTHEXmzkego	359
14514	2vbVDXDDtnA9vvQoCVix68Rui6XNkEtJh6AndLec1mp8o63TbW7v	359
14520	2vahRoPL7vEwrwcm1r3KUyNqKdekMqcThSB7Ue4tDV2UPYPzXXDG	359
14528	2vbToLamjKnAgftS2sadKayf5gTCyVdLnWQbPhzXL5MpETCApWFg	359
14529	2vbW6CGkPmzmfG3BrB6ymRK6Ery5kj1DfjKJdgeLfDnNBBJeb45E	359
14532	2vbuK3PqtX8BGK5kUskU83fcoVo7kJGjToUgDFnfPJvvf5GSh7oo	359
14534	2vaWHNKnE8oFB4Da5nXiH8bvqiRDjugmzwUAnhpC6ov6SqLWCQ6f	359
14535	2vaC7RBiYiy7oZDAKWCpyxveHzgkufVbfuYYB5svBS3UrrwR79QZ	359
14540	2vaUA6Cs21vL3fgjwXQwjHo4y9K1MQVTA4ByrbXdtPcVAjQeE2xE	359
14542	2vaKeYedUXtC3ZPeQL6ZhCp7z83u1zX8X4C9i2psn4ZT8N4fY4ed	359
14549	2vaEk4DysVZJ96zoPnAcHrRWgtnr4qYYNJnBuSuFkL9bxgW62525	359
14553	2vbFihBqFgxHiEnibvtL7Hvs8iBjTvjkWPHY4gcHGmK2EukHncKa	359
14559	2vbmv5RehJGkuEqL6cvXhSwXhVPwtL5VNsziV9EZXe5tvCkNSAg1	359
14561	2vbqfvyXyUPQnbGKrcDeg8r1TgKDCGA2eUVxHcy8kHSA4YVCGfrC	359
14565	2vbRWLb8HbNu7RUxYnytsp3rAVu791UPZrKNdGZt8SCS8uGgYQ84	359
14569	2vazYH5Djty6wqEQHjd5bCbpi4KVUokREk3W8EsaHaSN1R6vVBNF	359
14572	2vb63aHy9ZABQXdDF1KD79CMxfjHa73nNj8r6kcSwdeeiZgZntPb	359
14576	2vc5bTboLe861aSVHoHLkPyKKYidANv3mr4igscDAB1rYidcN15U	359
14578	2vbhCR1eLSYVtEHKhhUA1uh7rQqR5cFKjiVQARUajzvXWjeHeXq3	359
14579	2vaEwbQWeeZ9b88vTRxQyPk9kEfxgrhKLr1QTJyeydGE63isW9ym	359
14582	2vbpqKpMGsjBgopSFi1gktz4n8rKtEJvKyh5VMqzrhg2JDFVhwZ4	359
14585	2vb5t5RBegW5GLjwzDgCU1e4dR8j4HxJCtgmdDJAt1dvDSJAfdgA	359
14588	2vas5yKdNezzzwr2cPpHzQrbEjGrAnCKqJuWcWtUug33wjxC62Db	359
14594	2vaCaFjc7Dx1HFRdJQuD8Jne9A6yFbpkSBjjRs5dq5nnKycCawiL	359
14600	2vbPHeS9Yn2L3FGitsVmLEoqRquCRH1ZinsFVTaKaMmV1r4cFqMQ	359
14602	2vaKdsFAPDBLnk8CTGRVkWUsuBzYWcE57TosHGCAhKyfaCv3zdjU	359
14605	2vbd3cix2JQDTxPhauFhpwfXK7Ltd7MWfKNRsKiP3CiwCvvziGgk	359
14607	2vb5MpzQ5Bo48rUw58JCSYCDZGaJAzTEjtz518H4vVXV5Zg6mzm3	359
14609	2vaw1NtUJy1nqiKB39aoCey1Gw3wr1MTgk1TiEfRcm56rPQXxqD8	359
14611	2vbNFW1NwGsZZuMASRXWD6HBNoK76zWqxUm8xPCiyzQDD5uqKcQf	359
14563	2vaDhNVBXPNJL6MyDHxAbuGRD2EtUUoUcW7gzRCsYYT63EXvEjDU	359
14568	2vc1D9GJ6aCL6SHtKYw9ZyxTReLjD18J6zc8vZXdwf5oZf2uAEii	359
14573	2vb4pn5aQHuGdgs4Gf8u5nCLxWBdGMUAc9whC29AuewGUVAVqVAu	359
14577	2vanruR8hL522gAT6ZNoCwmSUbdaY5W76xnXsXs3fDTj22i5fs8v	359
14580	2vaFFHbTb4ciKEvkxYGfa6Jg2J2ew5rEqtUyawMX3yPqeMfMo1df	359
14584	2vbQddNTBhZTt9ABudqpjZwg58UYc8u9tNPmTYyG5swgvLia59Gt	359
14586	2vadZVbZGV5oU78SzrRh6rPFiJURRXfBwPyK5F5tscTYpW1gUshK	359
14591	2vc1nXAB2PkUQpLpeAMY1NbsYrmtUY7etghjiEk1e2H7VVecRbwt	359
14593	2vc3PkGD3iigbSCxN2UwZXGspgYZvuEecMVwkggxnTBFqSq84S7A	359
14596	2vaRJsjWuAPQ8gsaf7abjKpR5vbV8pP6ztRHgM1yuAFacA7XJzXG	359
14598	2vaUbmq94hCY6atYa6UtrAUS8HNyLYsXygHHHBHNVa6mNnnVqZUv	359
14606	2vaePzhQu8mGTwDikvii6WieG2qmt8fsnhb1DGnvvUSePghSpLX6	359
14612	2vaYP3sDDeR9x2kUjXPiLxADo9XMwmEqwkZpisH7gYxU1UcFJxLB	359
14617	2vamkPQK7BGCXAyXDdWYxQi4jUaZ21K8H7E8994WnoZn6uXCtyQM	359
14620	2vbfriLRFp4xL1J9nhsjX3Ge6vYonKPpfXkrPbrQXgsVhs1oqoNt	359
14622	2vbwbveDLAhzxF2wdqLDHhjfFHEsbgfL8Cqwfqa5iVxcreMXjV43	359
14626	2vbdc9wDaHeJ1V993AuUmES9t542qBXCT4Mws2zy1erzzPiGisHx	359
14631	2vb9ZkyUzA6vDxMxdWWytRYstytJa2TZfn6W2DMFN9T5dTYabUbA	359
14634	2vbRdg85U4swkBqK13wGtEU8e7Fd99pNeuqi8ZMrrMf5esNS4Co3	359
14636	2vab8fiouwnvYt8UNKLMJPYfSNEevWWxavo9EqNWKiZeYgnwCZsR	359
14639	2vaeL6G3Ab5rBHfB99Me2hUA5e5i39g2FAZPvV59qB6k1N43aMN9	359
14645	2vc2g4ZEzxgjuRRLPQfVfsDX7V5GDuFMLBBeaegabUsGZHMwT8QX	359
14648	2vaogdMb97KszVW3xLyqnAZAPSUEEG7VPADB1pKQgyXdBuRE2sH1	359
14650	2vbtwJ3GLrqLJWiYPnvXe1cHrhcJWavja6ps6Xui6XsDM2YQLus6	359
14652	2vbKxPJ2oqYwzNacyK9TDcsWbJdRHJHADWH6Rd7U9cjgzB7unqHd	359
14657	2vb9fLHdA1F8ytG9c3qnW5tJJZbK7VNXrgtFnyvtiPF9bCUcPqCn	359
14658	2vbfjvVrkPCfsD3mNzV16TqVivtvEg8kakSSbq5zNMaff1DaH3Bp	359
14661	2vaGF9F8etM2EwrKBSr7pzpZA2TKQGiBBzhgr9Tj3j9V5Em61NJn	359
14663	2vbdsjWyEBUV6en7RNt9caES6BedDncafrVJ1y72pmHvrpxQSs6d	359
14666	2vc1XsVZf4Xo8Khnq3SinHj6Mjkbv1dBop7uykQVRyJmnJRKmX7F	359
14668	2vbKLZus5y3XGHvogmd3DSpshXJP4Ds7kQzer1dJ9kwz3wbSxxoU	359
14673	2vaT9CFuZkSdvNxeF7EgywEegFYgzhw29uPYLpyzkPDNdnPHk2Lu	359
14675	2vaR43V4zaEjaJDpPSNuHuLpUzSARe5ZS3P4Z8ycPR1yYP1Z8LGJ	359
14680	2vaMs6mYonLJWYcKaBSj61gpKAe7VYyRNTsXXMozjWs9LJKxdSmh	359
14682	2vbTMLYAX7JyJNJac5AdwYnPDTfpCwPtP8gh76vYjkWb6UZmpNBK	359
14683	2vc4oMgoXct6Q9wnuyjuuxWFjviLQUH8c6LyjD2DWyyyWex4edio	359
14686	2vb4KoyB42vKARnvfTk4an8kquKkZi322jjyLuwYj7RZZu3uCYHB	359
14689	2vb62iPw7gVcPMkWcpzPdj349bW52bNi8TpFXXYYe2VhKXDQjUTi	359
14694	2vc24TJP8RTYn7yAUYr6ZpAE7KniSwRc6mL1nqDV4fbEmShDh4Cx	359
14696	2vbwvibLBq9GcsyAN8TfAH8hPR7pqetb7w3wZDYx5o93Pk6do5fi	359
14699	2vaewfXxCVrm11hRzMNCFAaWUU15DjktqGKAGKr8tg7SFd5nU37Z	359
14700	2vawCmemhUjNeZCT52gpGuvwTasqT6HBQrWkVhew28tgyq13DE51	359
14704	2vbSTGcGBurEYJVct2cxCeSJMmwrvn8sePnE48CZrzkBLCRqQ3D8	359
14711	2vacnYosppC7qpJHXGvd79nCouUEXcMKxPc4ztQccUkhN9cmYgFh	359
14713	2vaE3VDNy6nHGz9vznQ43AMs81dMUwfwg82gXj2em49waJgyuiME	359
14715	2vamHSaPbLXiy3CzUD3o2Qciy7xPmct8QgYRzYVnhBFY9krxyUwz	359
14717	2vaDfuCfsokisnkeX9mqNQh7khM2E757GpDL52HNcpi7981C4EgS	359
14725	2vam5iXvUySoWWHCsjq6SkbFbwhEL2VcCEk8LtfoB7nigoYvzCgP	359
14730	2vbAH1jQeFveCFe1rxfmz8926HTa72jpZQF3bxidj6zn2syTCrhq	359
14734	2vaWY3B7ej5W88evYLibWCCgL9QbhQ4fNNFG5rymBp8XfvCW4CBA	359
14736	2vaUiajd4no5W7WoPyokQFSEyMcuyLQaj6qAPuKMQCVhSBJa8iEC	359
14742	2vapFNeya9ZP9mwxWLupjFxTWWnAYiV71BsnHGXy5sqpxAJs1s4E	359
14746	2vanRzSmH1cH7a9ALiV9XtDiZtQhwDXU6JqRBqYhwyDMEkJtRzJi	359
14751	2vbeDRFEB2dLBoWhTU7CUN3PRo8s53d911eggovKgn9mLczTvF76	359
14753	2vbxYQGLq5eDk3B4qdwAgmPAKik9tn2LDqKCGi4UKUu2J8SYE42V	359
14756	2vbA1jPnb8aebCYXjvb2Wgihnxz7fXMM6vS4W9r4tMe7ErVjmTbx	359
14758	2vaX55xtEpT8dRQN9dyiPn9fS1eFPx47oDTLVU3ce9VBv9NZdZuv	359
14761	2vc5pFGioSfBXFz4Nmn3GBaXtpU57LysuSXnRrxt36fJ9DqLzUXr	359
14763	2vahPCW76EvRWiLc1b6uZp33WVW3YCzFGRipoaLMjGhiNm5XRTRP	359
14766	2vc55Dh6AGi9qZ4HSqd5xFt5bpeYTLjm6fwXysnzjpEhfkk2zvAz	359
14768	2vbkC1V8D3uVjTrUiw8XuNmRWzZYLH7A81wsKntp3tPkVwy94gv5	359
14769	2vavNKM77Hz8ocP5v3ixLzWBJph8GAQtECGZytcafFqUDzfQRqCm	359
14789	2vbguCCgj6o4fvtXtBnR7UuACKGRGiKdJKJzUp2XSSgnH97pZtqU	359
14791	2vc2P4P7qV7owFSsCYg69EHeL53SBZsWQqwSYmNwYgLPvCwQ4Zhd	359
14794	2vaS4c3aXxk5L1nyqhbEQ8F12ic7JzeLABF27fVfUpFCJxsT38b2	359
14798	2vapbK4S2dM8ke51oi6NER9tBLR9kqxQ1xpXqTstPUKscX4TJJLV	359
14804	2vaMEXZRfhgUHUbMGdquYnGEyvsEzJjSQfK3hPo8KvRREpYejVNa	359
14810	2vbidiUgSTqSvTX7TD7ChLypnDEa7gudtm3YBdCZQTtNxwS77TD4	359
14816	2vc24UAsH8MpKS6C6bsecy8Hj9y8dBoDukd85DycP1CvrekCyBci	359
14819	2vbnmixLnh2AZKAwgm26ByEbA9FvwMCWkLnosrxsruopivGekyT7	359
14821	2vbhVX4wVpU5m5yK4RjAzuEGgBvaZKwZu8J6H68HAibiETByS6gD	359
14824	2vbwC2cJ7saeZaPCBRn3NhzGXXXjx8KGpNeBX1qNGoVW1MhiX4qJ	359
14830	2vac7w46YLp7pG8y1dwrYtuNw1TiYvTYGAW2Q2vTgX3nSP8bY6Sx	359
14831	2vbBbELtTmW67nDvZENLNyGrY1hQ9aGsuAiqBHDtmbBLq1Vi9SJE	359
14836	2vaMU39HrknEEUz4tALSdnYDk7tXy88aXw26XDt97nwFG4wXnuqo	359
14841	2vadPiH5Jqbeh8gJugxyBNeRqM56HincSoZGMU4eMGzCMic2r3Co	359
14842	2vaatFN3nvT5QHXiTuAghcatLPjmgemWCAU5wWvM68fSnno4E57W	359
14846	2vbMSJH7okUWcECoztbbjZ5K4hcLhX95rrWPYpMPn5vwgQ9B2eHJ	359
14848	2vbZyjn3uSXqhSpiEZRDmi8CTFYcskAdJTPnFhpWFsUe8QC1BkCT	359
14850	2vaUiK81FYukoj44Bx3nDWMMmp3WVtDmd5T8X1qJEu6bn4pP1ieq	359
14853	2vaycS29L5vHCr5kWZTF1gF5AfzK1mCN5YqNj8BoHtYT6KdCFFhy	359
14856	2vbwNXhq1fGmkrzyfSkwHXnp3M69x1khX7kb1AqJgDTSQLf4SwzX	359
14859	2vaaZiCsFooXug2fvgMNUi5NTNNnM6KDYGCpp6xF1hPdkfe2zLNV	359
14864	2vbqnUEswCinzWMbr5FjhtwxWvpu7gn7tFt1wxQTbgfAkxkrNUjk	359
14867	2vbPj4J7o4vvHeXD1VruzCPQGmXd4K88on3TFcBidvTNCHqxh8Wb	359
14870	2vadWxQH5bpVE6D1w9DY5tqsFYA3CyVTa4dbCK7eKxhAB3YFYTia	359
14873	2vaA2GVgxaYoLAMtXJKCwybVmqdq1tdMJyeRbTMa4rCssZpRywcy	359
14874	2vbHD9gYbRHnzBAsP163rSh1xSNcLmTwiWxz161YqZYgJrxpxTTJ	359
14571	2vbry5Hz5vFZb459QDyt2C4UGpxmvF6sdT6kmi5ZVJuUkAnRonkr	359
14575	2vawkozkBF4aKcfba8bbfzzVYp336VPxu1o1iQhQgi5tf4yVNVrW	359
14581	2vaZE4Ye3bSNnFAzwjydgxYDNaobdbVKQULRLJwoGi2Pvr9vd8bM	359
14583	2vaD1zvbzj2HWLVhe5xDJRoiNT1AHS8Um8K3Xv9nwprrYBT1oCn6	359
14587	2vbH6EfsJiw1ojbrrUrzGCPf6Rqrs9BauywcWttSYRzpRaVuYZVJ	359
14589	2vbhWgBMDp9W2vvRTTymb9UzCoeKrbYWj4jBmPuhRTqkrKPLCGJR	359
14597	2vbAxF5nRLXD7CDuQbJrF6ZuGUw1ZLG5J3xJZMK9tKEVZPxud3RC	359
14599	2vbvmaC8ffLVp1XpUS3fLQcEEaM2HrQUcmfR7pYrccGGGcPgpt1E	359
14603	2vaVA798KXgvKpKL2jLq6Ws8hpYqnzro3bNK3cW6CgPW19PgtcEj	359
14608	2vbHgpHqcackjqdzYksT2W92RGsK5JdXX919xvNbqh4TmjBQghiE	359
14610	2vbCQtKm9STwgCawbJ4Xa6kzGfV4LfoMjjnU7cCztRQNesLv8nyx	359
14613	2vb46FPR5T8qnxXZW9PYSEatF6fgnroQPPftRtEGy77vGQW8PbTm	359
14615	2vbmadUJ9R5JsvUxqdyaxhjcytuuLX3VjSG8BfEUGH9ZomJHCtFh	359
14618	2vaxnZcjgCN9gcRKkvAp7YL2hoJidU2cie3gffmzcaoUGaT75sfd	359
14625	2vaLg4UGApiVdiPHjsUPcGnRcmnQy2qkju1o6Qrng5MtJhzJPuPA	359
14627	2vasHVzWJVhUYSDf6sb9HGWSHKrgyTes4iExExcb29X99pNboMxE	359
14628	2vc4vGQSkQpEJy634foWbGSq8Q4u1SpHFe3sJsx4pBBRt6UmPCrz	359
14638	2vbBt8cJwjcmqf4NjhaHUDq3S53QzD6SZwRASg47PXb5NVu1dG1F	359
14640	2vbzkehDAqJgi819c5mLHwm7ENkbkqfSUShji3mfyHuxsBpsDFae	359
14643	2vaeuyWeBfmCEgDKTMUjVEP7PbvqG76ygThKt2ExeeG8SaqmJFyb	359
14646	2vauushaMH54nhRC5pyvNokmAVBwZsbpH6cPFCqc818xdMTQMFMa	359
14655	2vaSHhik6zhUWmi9hGqgZdgKnEDPWP97LKXmnv8dhnkWa3xdXsKU	359
14659	2vc5j5ASEhu1bm8GyDYfn4c73W5sbHyFEdch3MQtfJrGXpbLiKUR	359
14662	2vaJ58QvcHNZnfSWPr95uXNXxX2wAwhHVLyEoMecfohy1HBm1swa	359
14664	2vacR9qYCLDqmcZkbLPR4tzABsMvGLKuFiPvQXsN9e6epbyW2H63	359
14671	2varVEjwC2i8mxFdct5UsinAvMkh8k74SkmE3r7zdVzZQGZgbqKj	359
14676	2vaQjeZUQQ3BmWVXxXPJ3UvThYYYYKiGHknfVr6Hqioa6MYRwLdc	359
14678	2vagPJwX5EkasLm9vNoP8Goftm1RaBPP88rKBj1xhYEhc4hP8yC7	359
14681	2vaAX7MGC8sLU1x7qkAxn2xEbwr8SDpEfpuiHmSSHNqZyTVspJhz	359
14690	2vaZxDXqCagLTU7UY3Lut9uZhHGTQzN4FixPfhSUTHJDDi8idHhd	359
14697	2vbxHzovg2KQKJVZxm73LeHqv6tQQkiUSA5wBB2xKnr8wVREzNiw	359
14701	2vboNhc4gLq95VNwZgeRe9YFLECwD32PqF4EPezNXBDVB6wpjCFJ	359
14706	2vb13r9u6fZrgKXtCA8CWkuDRwz5FPLHnbwro78b7W3ovwx2xxdR	359
14707	2vbkDQSd5CgmpBjhXdzRSKscyhTxzAB8LMSvsrnbR75DPXJGCnJP	359
14709	2vaH9bnHwygcYzcAX1kgewi569NxZxqTqiw67eKPTqj6YAXAqPyB	359
14712	2vbXbkFtqtvWyzwoes6FuXo5FYufCvKVKnHqWegE3F4SDG7Hvj1F	359
14718	2vbZVYAfLv2YFMRGy44G3nCnajZd97Fnqth4L5cTPwrtgRHVaLWD	359
14721	2vbMSdM3b7bKCLkAkNKqaMPurjANX5pRvQAGe55FL8P6F8ui7niV	359
14723	2vbMxDR5ypb3bJTxjfMykLAQ2nSrBNxNyakGYpvVk3bQWS5PhY98	359
14728	2vbHgTP48tLKV8AEQfMRb2yuRw7pDaKeduFKe2qZrZBCZU9GrXDt	359
14732	2vbnbrpqk1atjREazyfQXmhrRhxWC85DobF3VcRwNASqdzVoxaiv	359
14737	2vb6U8M2YcniWTHTMxGnqyUu5hF4wySnZYYVuonZrB5nU3qkbucg	359
14738	2vbE6oZKDguUqey2GLuzt177TQ6ofFyA6q4JBoRRMqb1Wgzi7vqL	359
14740	2vbQaYQ8JedNi12P7TEjjdxiCnA2sUxeNgzdYgD9Ko7H6r7kXRJ5	359
14743	2vbTcN5UDW4mxyourWETAeMYhSTLXz2A6yeMF7WtC35F8R2kYjGg	359
14747	2vc5NzRgr2GJrWFHGnPisUxxcy2aqRzrEitFUoADmNXxDpkuMuZ8	359
14749	2vaH5B1trxTSGKU7kyFMTgT4VrzP9j8Z2dArEip4vEQHM1duN1Qd	359
14752	2vb3mT8hrFj7RbGcSutBe8hto4RFyChetgE9aPNUnkr4mNL2fBD7	359
14754	2vaosAVKRPhS4zxBgfzSCpj8YX8wgqosPnrXjKsUzyJBRWygM1aY	359
14757	2vaP1NZE1qxANmpD2Uw6dzwTyaBTrxDqBzqXDtjN4geTS2ipH7Fc	359
14759	2vbapf4ta6fQebodpqcqBVn77MXrRpvwjFXidHThesHKVfZiDKTG	359
14772	2vbLpV548rvnuSkzMXFpbu5UNiCh3SGsnUz7aSNsGi5tvJCxjcZ9	359
14777	2vbTyu87eEHRNT6szpQGL63WM2hTYfidfcjzBWj2MTbFuYnMavKS	359
14780	2vaKjS3fAJRhvnnK8fb4WfKJ89bPSYijg9xshfHxhA2My4KNkaM8	359
14783	2vaPGYDDjgyVxw3hAzqwNtb8kFQsKqzd2QxnwqWLx8n7QU7vS16Z	359
14787	2vaXoBbLAcHw4FDuShk3cBivDQ6qEa7ofQB6R7SeKHK2nNPaqQue	359
14790	2varCm5mSMdTRdV2cjtm5Bh7udYLbEURLZHgb45M5WZD7PbL4WoA	359
14792	2vbSX8QvWFqbMoGkhia3WrTwsTBVpgprJXnhRW1sMTqnnLEHZ8DU	359
14795	2vb4ewt4ovSRxswvbE7mpRCn8qMZDSX1n6uut75t23wF7mzv68KV	359
14796	2vaRTZVGyYv7fAjGjS32hxQPrafduzWC4n9aTzckZKRnUXPSCWPw	359
14799	2vbCDTKhEUT4YsJx4wo5j4JaGsn3c6KRuVwVPXbrU2Ww57Mbp1Ly	359
14801	2vaWmw9aaHXYLz2n3BLE41v6hiKALQxFycchNimfJmUDS9zb4vqL	359
14803	2vaRJJeXoHs79b2Gz8SuwD7Lq476H2oMwyuykUnK1qWHMqKK86Bo	359
14808	2vbVRQXwQHos6KCFLysCwrBcL2po7Gga6GiYH6aW6ZzrZVZUfkQh	359
14811	2vabTuUpYNpTbfGwqWncY917pHa95dkEB1pjYPmFENGWzFxw3Wrg	359
14814	2vamMZENQVGJH9zw2qYHMBivnQTGP9VPNK3UL7UUp3r5AktXjaHj	359
14822	2vbfEVt1d6RE99xLm7EHa93YryFeNFKv92zxrL7inrGqk5S7HNTX	359
14827	2vbk1JvKZ5hwKjUg5nDrj8kaziEUBXRZzgqzacDzvnKTSB8PPU5j	359
14834	2vbDwKbaHySTmtus5Pao1JwfHmAQ1ruMTDwezTebJdRBc8u9FuMN	359
14837	2vbpCEtYR7E35YCp3Zzg3pqvouUaxvGj3C9wVfpofSDKXLi3NqkM	359
14839	2vbH9KrQpwsSoxzgn5U1z9iCQcUT2Z1xQ2z565u3WC1PoiWy4RUX	359
14860	2vavNuxurR1QvgaipA3nCA2tKWaM64nhpeU1hDJKPWvKqtsHKj4b	359
14869	2vb2UUbBdWg7qSHvufACyCnTzGeTrXby4bkh9aK7ETKNApn6SkGN	359
14875	2vb9Sixcrcd36bQZ5zJ8818RUkywq9sisDhUH8tHJQuBUKdE3b3a	359
14877	2vaZ7iMh2fnJy64mTwADEdmoRVYjWQLs11CMRpwaE3oX2ZKngpBS	359
14878	2vastoMySJCPhuyTKxsxDbsvugBUaCSLSmK82kqddmcNmF5aaw95	359
14881	2vaqVPyn4nT4ttAsZfjdxN7WDET4LXTDxeVvJHP7CkTjJQy3dZ5S	359
14886	2vadUCxrvnGTNjr6aAbPRMzkbykUaF3jqidBvBhGYC5F8dEkaUQr	359
14889	2vaE5gfqV6dxYeMRJ8LPT9BhSgCbakaBdHzWyS1LPXbSiJZ7tHaQ	359
14892	2vbgYRFRDq8hKYwNdHx89iaJ2NY93Hyq5UGGsDvCiPLj8NX9pRxn	359
14894	2vbn6QAJEveyKcdvwWHrCuFqtsibnJrvefzXw15YKrdLJDPymoCB	359
14896	2vaVErx7PNSzSMkbWEsZCe59222asxCLUGtzUCZhDBoPP3hLKJh5	359
14898	2vaFUwSHe5yQNh7MHWRBDXngzgNM5adecReALY4aGdhSEPATmbzp	359
14901	2vaBT3z23tgrvG4fiFTDJRiu16A43qgQM1CD2x4NBF55trVYxb7o	359
14903	2vbQmg8NEQh41nvsZBFMTQZYvCTDpNFoLxdiMwUSb4fBSAr1MhZp	359
14908	2vaYYZTq97uER1LaacWntkbqZUCkMiDBmu2gELDXtKeAcpcCrxLF	359
14914	2vbWSyxu8NBnq4TRdHpPshJC8rLBz7E1Zz9oVH4Mh3CLYYdifTBB	359
14916	2vauQEWEmFRCiJwV2N1uxHvxmyJWtCUwBank7zPbb6EFEohnPkQq	359
14614	2vaqjxEnJ57uzXBGV4auCeW6PFHFVCBZ1MTW4oFC7aLQXufCnG4R	359
14616	2vaXU6quSdt9JH5zLgNMBEXqkKE3Ntx8o3UH7VEUzEvyLZASJWvo	359
14623	2vbhRmWnUHjDgZzbgtZjFU1wDzAWPgVv9rmcDAg3aVwBg6gnVYQR	359
14629	2vamFUSkN4Mx6pSnGDCSJyscq5uzVbbHvUby14L1nBws8ppHANnK	359
14632	2vaiuD6vBtcCaDb8LTXQUDDdDAqGCckY3bJBBSo4CZxsiAL84aCM	359
14635	2vaAnHiS1bXCE9Juu5dKJjiXVY5DHGpZuUhtprHF8qLW52V4xE9h	359
14637	2vbsSZEATNGC8mjmLuMKBJA4q6CmVfKA68nLz6uhsExsn8xQ6r4D	359
14641	2vbfJ5GmnJXxmK6LqsZj7QbASy9M7ghZm1aTfCJayE2f1wTJSibD	359
14651	2vbmBzubKDm3t3SgqHGqHhedRY2YwrBZe9hCrhrbecYoUuEjREb7	359
14653	2vbq34iD7d5QUaV3FEvKzY6WUiQPStnapG3DedUUzzLPpxw7LY6R	359
14660	2vaxNdNiMisitiVSRkZK5LKqECQnVP3BnapsewFWyKFKHNxTRhwe	359
14669	2vaLsrbuf43ZQUdgd8ut9P2eqcckZzqZBvrg8kZe6CbPVEwtnR7W	359
14674	2vbfGcQf3GaTqH7e7xwcCpvDXJDWYXW4jHVkq8ESnGfnnv1WPBWo	359
14679	2vadErNisVpszMr1GAmNEv8eFdpqnRd4G2ac6UhdU9RpjPAH8ZwC	359
14684	2vaDxRCKKmLCGYQ7Hk3SP9Qsynbgw6bXCdVYr7cy5M5pekdRaGnS	359
14687	2vaES3zqkAJAgwfdj3W5ypdKEyeH3z7DEHcidFTcbefkobdAFqS4	359
14691	2vb6zm8DX28anZjnp4ybydWXNE9F45LfHsMb8smSux7mug2W6wG7	359
14695	2vbssiqwMRz6xsrJidEAgLZ9YSnthgL8KD3PqegWXZ5cgRmTfR1W	359
14698	2vaGW9QV5UqUpvYHWnRU5FE1Psf3T5Xv79d4XubGu9Fy8Hkui7LP	359
14726	2vbqkX4ZuNNw1VzpaCUHWjxShEkNyrSKTzZJKvn8rbG38eqYYRhK	359
14733	2vaqE2UY5hJiePmZTcuTJ9nZcQPHZ5ypg228d9QCYajFyXK47V3X	359
14735	2vacu2G4F6ewanh3KnBJ8ih9nFmUARUbG5BvTgTccGaVQSZL9xvd	359
14739	2vbLRCdmZ8xLr7NwPS2ZZueNATBcEdvh5WCfvps8hVJN5WKofXLD	359
14744	2vbdwBDzM44ffYjFupUfmJUSrHAoaY2mEBWWUuQ5twVfKfraWtg8	359
14745	2vawcW3zBr8aEnbW57Ube86hBrFtKEVT5KAJsPBmr6MaeSrkd4rY	359
14748	2vb33JbnWrJaDA8KpqkmwABZ4r22bU2cgcjboy22vZgoTUNDK5dr	359
14762	2vb2J6FeEQsFQ28x6VrpR2xgcaHW6HhNs8kYTf5xqZNaG7syozWz	359
14764	2vaAKAkqP6GWhgdXuqfspBN3wg8gdgekfSzU8QV1C8o4WaA3nUB7	359
14767	2vbJ9jUY5QEukdLtW2SijPsqxp8oghS72DGPo9LQXaFGYtHKGCXJ	359
14770	2vbzUoLsWfkPDsRddnKj8xzCp4YK3WRRivAi2YeEdKWvniCgyfw2	359
14773	2vbAnQAFwog2vQTtpUat2T2ezhahxS8cAJvBYXmvRt2mMSa8pyBR	359
14775	2vb35QcjAqvh17TnPUGLDmn4PYRFoF5fG48rChjonsezxb6YcZJa	359
14778	2vaBBtC3Z7VP2BjzN3SgESvJzSiz52zBSKi3NGcd5H9MYUuf7Xpt	359
14781	2vbYnWCqwXQSb5AVGh5SfK57k4FTAkiNxqZdRFezfgYkkRNwPk1h	359
14784	2vaYubNwMvzVzPzQZ39XLsYCLV4TPyAh79JJaZtnLYskxWTJuGV4	359
14785	2vag3itGW8suJsy5GkfXm3G8RiZAsg9E4mnYwvgCrkPYyoyqNCZS	359
14788	2vbq1cpDZ1F1NA3na57oMb7bh1JecC3nGZyDgBSCQHBrnu7e1moV	359
14797	2vanU9WXKmciyTUBXz1DRPmwo2do39ygU8tKEoXkJygmMFBb3uR9	359
14802	2vaVxveWw61i77KTf716W45kYwwj2f5ryz1XLYffu77AJKmaLVLa	359
14805	2vbezN1j6NNRbvMShN8ygKEhZ3BWMqEXTvpivNc8vfVYkhSvwtn5	359
14809	2vaEuQ7ZVNVZwgjXRCfWw7KXgqcg2Z6T8fVqkw6pbfuDr2StQzf5	359
14817	2vbhK2xneypfWb2iDPcPPiw57qTJbQA4n77p1qixYsK9Ae92vxX4	359
14823	2vbBxbX55LFPG9Ck938XehrLc4PdzyXnmfJqLjxmhTXqeLyPLZU8	359
14825	2vamNyd8eQVEnoxF4yyXaZtqKWCKvzKpSwCuLAHJasXj83Trsq6i	359
14828	2vbHYBSxgn29bhSvduJf94LPx9piFji2hhA2B4pNe4QpQHrNT9r5	359
14832	2vbjKo8U7Pf5Qx5VmgcnEXM97HqxpxsKPWpDVYY7pCXYje3bpQnE	359
14843	2vbiftxNDjJ6jUSexaHkTa9fVBnZUAVDGfmqXEpDvuXWA6Bk4UMW	359
14851	2vbckVGwaGGkX7HbFiwzstJEpiA1Tsvmvs2roi2unHdGd63spm1P	359
14854	2vbFXAbvEDg2N7x7pw2VyGu2cRTbAWrYijnjGFFt2ArtB21ytjwD	359
14857	2vaLMHMi8fsKKekfgi6f1k7fGfRJGJSmjAs2nRPLPhQ8jf9Ytfxb	359
14858	2vbbgFTya8iCcBzYGTKip5cWQKizFEDN4C8ZzUMa4TaGyMu6P1vE	359
14861	2vaknzhP52Pj6Fvh3M65u1oifvRVBC1ht3ypVJhFySrYRzt2aDGA	359
14862	2vaHpTjoNDgm7UHEHKZTdQKohcoM5XD8poBfUiTbuPfet6X85Dtx	359
14865	2vc1Y6TE1aJp5nFi4PaUAWCNfbTZbDXjM4GWT5aunjrHMMVN8jdz	359
14871	2vavw7fVvJhFDBcLtSHJg7C3YUJZSQHjhCGa5c79hqAHm4VkZcdW	359
14876	2vbyz5ekX3soY2P5wgDDtkA8v914rZZeJtEKudYzU7xUQQSMTKkN	359
14879	2vbdWSNvAFuAeUZkswu5gZ99GYKd7huetWWT6188h9zVJfgMqnZ5	359
14887	2vbsi8dUJ6rtbyyznRbhyWWMbHBw45mCQmVTHJhYWNtYMdGFT8zY	359
14890	2vc3Th34fRTnzSE4mQd356fNYzEbNpSUbj4KYAwR56WjiWczBRRC	359
14895	2vb2nrmguXr6xSw1j8BJrJ1TDfcLdqFX7UAy6fgDaKVmWk7q2Fyk	359
14899	2vb45898CVoWJHuYoZgXBtTuLMuVJx2SzcRt3Ckg7TEQc4AQoMRH	359
14906	2vbf5CNhwiyjDr3EWoKcNo5oZPPjn3G53m29AU6Cu3pe8hE3gNXw	359
14909	2vbYrP6CkNayQQHCepcVnrncjPgovkEy3jUgqMu8BgBU8yuym3Ej	359
14912	2vaAF4FCyecgxS3n88tqzBycytEgomBHTyQkjtWt6e6BdjHzFV7u	359
14917	2vb8NV5PRJTk7Xm3NyiFAodwNevhB9cYbrZptsu98rY4FMqWBKfp	359
14920	2vbbz9hjAT9qURT5Fxk9Bf2TDFy4BuaxgESFircw5aX9ufgdaFtW	359
14921	2vaid7P6piXZ9gVCRfs7yT1o4SWWTijaskDDfscnXwuKEk2uGYrL	359
14924	2vbPbe58je1geyF7vpg6DsMCLaqqQxLEJWYddLUadr7834AGJf2v	359
14930	2vatxDeNNrP2QKx4iWoWJUEawQJiXKCA7is9iFVS8svrDDLqcYdJ	359
14933	2vc16dZMCKeSK8doG6HHDtwn44qEdEMfrFsP3U4GThDPxYbYzAqu	359
14936	2vbR5vvEWn6Xn4XRnNenALFrG4bwmXbMS8Gzi8Muvo3KdnSyFdN9	359
14941	2vbwBcUzJiSXHUacrb7P2hqfQeGSZtMfFcwbnBdSWUb5URFL5Ksu	359
14943	2vadatb8uDzqxh7XXJmm2tAGgAp9b3PpgTFa6BbfDPoCtLiZwV8Y	359
14946	2vbZ1PcfiwFyMzxrxwtDJi22sWnBM8h8z8JExeyRmf5uvNPvmJ5B	359
14953	2vbnTW1NpzDJaZFr6Hrkju8hDAGsccK9E6GdaKwJKHcGyhuQvn9h	359
14957	2vaRp7pYAu7gB49oqZWo9bkUaD41CNMhKEUwUNJ36kzdhvRtNJwf	359
14959	2vbHpskv1f5rPG2MFcoYjxCez4FUwK3JLTiGAwcoU6PZGQTwtZYA	359
14964	2vboSfydmS2VKEgTxajCix7CXdnjBRGYm1yBYVuYyTeBEjvY3Mvu	359
14971	2vags1jaUjXvUS8gtuTZXAxqyp8VEGEvQBD68DXfbNxgj4ebyC1e	359
14975	2vb7av7EHkrfeJjMngzXHpZQCHu1ETpkSvSFW4WTDVdqLBzjBJkh	359
14977	2vamwPatihaQVLMxd8bTSSQ8x521HSV5rHMpQTeLAFLFX8tF8BtN	359
14979	2vbktJigMGRLApP3UU9FQiXZgtqPzusGWC8K9RpLwU6hr4wmJMP9	359
14981	2vb8JArJ5EjwBKQgNoVWwaX9iZa9JCi3e2dkV18eLs5N1DjCcsqz	359
14983	2vaWemhU8xgz6Dxcqhvs67uyVQEKus48LCa4fXXWSHb7dbvuhrLG	359
14986	2vbdZZoF3ESfRGE1Tb1gKwV4d2tbF7GMcx6Phrh58xMfQzdJrhhd	359
14990	2vbAyiQSrdwaRBKRnHhaMG2xcsiEJJ9eJP5suNgTaq1fDR1hFmSW	359
14993	2vahN23GSoFNqnr1v8cAkH7XqS5jPEvH2TdWfUbFSWjNXEs5TXH6	359
14996	2vaXn3BEqkpWDY7q2PC5uxtgQEwXCiJKcwTWUagQ6dfKs4aqQav1	359
14649	2vb8yohk6NTnQw4oHpX5WvtcPxb2NB5DgHwx7dYhRw7Xpxw4WXAY	359
14654	2vbxPaapiHFWUVEgJFk4389w8TQRXC3uRBMmBuK6FqkcVeiHYCyM	359
14656	2vaffdyuEYceLVg8TnaRfPUCq5j5Yq6Trx3zgu2dV7W4T212Ruqy	359
14665	2varJYbVaAYJeBZEaKnLbcCF5cKUC2Gdz8M5o57XmbwBFuDuSmpY	359
14667	2vakLY9f5AcyTVYu1G1NFcymqofgdzzWg7TF9qHhg1EnipeuEbZc	359
14670	2vanXeqimQLgaEPUAsNvzuFPfwvvW95RjW1fkMSeTT1hyU1HN48u	359
14672	2vas9hzbmeXdYwTjtfkcBeyjGnXdY4EYjfBs9WKBRmCMdnNmuTZh	359
14677	2vbyYQ1k8K2kxpXRNmkDvgrAa4YjrVZtpcRwCk66heF4qai6zHk2	359
14685	2vb4rn7XQaLwPvpGm77oKhxHqvfACB8rBXzZ8CNYxwkLGJhYgLub	359
14688	2vbT2AXn5vxV6zLNuv4qbXr7uMieNk5eUWt8f8pcmWW76WxQkoTg	359
14692	2vbMYwWiKB7F7KwAq1hiHUT5ky9cQT5zvJtVLdjGcfS58Ev5B721	359
14693	2vbvxW1dobaxsiwf9wxN7KiXKHP8rQ3LGZdURDaishKVosuKu3g3	359
14702	2vbHQkjv19npKLymUNcJ3K1aKuMaPhJQqrczgCgDztvK7bkZ8ivK	359
14703	2vc4uqPt6bJDwqqZHkSmrSFAyuDd1y2GwZFz4nm9GBc45ZzTMsU6	359
14705	2vbxKk9BbLcXgguoHncHYdoqobbQYR1VYUkTrrDPfKvsc8ZNW1aV	359
14708	2vb4ZbtiRb1f6cr52oRR7D6TvJqL3o6f9D6mtsBAsUy1vMJC9SHA	359
14710	2vaGeniGyraqvoysjVyrfbsNeJ9TT9xpjPiB9kk2bH3mB94xmuMg	359
14714	2vbyacFPWmZD1mATaV4vZnwHqLx7XrhqPXnARf5e3hPw1gzKkN2v	359
14716	2vagj8Eu9Y253ct3uJFc3nYysyavYtjMHeMf49sd4mDT8jrUvp6u	359
14719	2vb4VxK3RsJDmGwk2A6jzj1EYmjZUKmrmRGP8rTwDcUnT9m75DAQ	359
14720	2vaKxf9zJ12iQDE94R4ooPpsvkwMNCJ5UX3piqyig3ZiFHUo8kmM	359
14722	2vbbsTum8qpkeaAqhUhjWCETTLPh8BLA7RErvzp99YgWxqF7AGT9	359
14724	2vayep6xgmiJmouW3NhuhXP6sXY52k4STDbvQZQHBGe7axtugejk	359
14727	2vbh8TunWwEHbHz2wru9srFz9z3wEPZXispowFibrWs3T6nymY6w	359
14729	2vaitQybRm64Cm4D3qyzetnAKzEUThASkCfXqFrxFdkNHjVkL1Bw	359
14731	2vbdVwh5Q5WtHTmn7kgxDVHTh13MvJoYxLMmcAL6Mwsq1fF6mRhj	359
14741	2vatWr3ZVQTHMKefpbGa5EM4jB5qWZx3dkqcW9Y78MbYJiXAiAxU	359
14750	2vbKBZE362f8Q364n4wZ3oNPiZaxDfbBwUPjadEx8d5WD5DnrDXd	359
14755	2vb6xmo8nUJqMmidZFZW7oZEuRxjJbnhdQdAMciCVA8DjYWdSD7X	359
14760	2vaCVnCpYi8PTj3BqqRQYzhNcRFNh5PJKWerXjoXfAbiAcLtHKTf	359
14765	2vbFC25TPBt257kjoaUXJecQhuFy8xGQjoysemhwGc3XLc7cK2pp	359
14771	2vb7LarnXeqUFz3e9y1RQC4feBe6u1p7YGhCdwgCJCMmPaoAgdpH	359
14774	2vamobEM1WzZPCD7WstTPbBXACfc8yWtG8umLNib6jkh3BmJe3vm	359
14776	2vc4JU1XKbsrdstFDf2VtAjNfMe1TdXyLkZ8KFnEnJy42972ZYjn	359
14779	2vaskDJar1LXN9QQaETCkaBPoDqU7kgdnhENhwkFX1mnAtsznEBH	359
14782	2vamC14X2vgzS75N3m3eDvvXxh21BEqyMXXAcfQyU9eQHwfzQhes	359
14786	2vaLQXuTWgaC11X7Y712vW7UhvLrp9sNrZM7XiwudKCDEdtcUbaP	359
14793	2vbJaA3GVViZtjfGBHk95giPYQLYjzxTos33FJR2fM8B6wRDsH7E	359
14800	2vaY3cd52CLC2XyHpcwf3Wwd2V6G871eC9uiZ8jQMZGXLTDdmsUP	359
14806	2vadXdcNrDKyULJmEPYpjSaA8niRG985cuiHgYAQ3VqKxEmN2Ush	359
14807	2vasdkkTEiXa7w2ZRZDUwv8T3kmZo2FkcU6yz3KadnmAyUCQW7jS	359
14812	2vaXFd6ikwC5pWeBz7bEFLF54cSYzrBdfssnPafsoNEDsDr6YiPL	359
14813	2vaF1wRfQv3i68mfXTLXHzx1Ys86gZpeb8hwsVppxEiqfQQrPByD	359
14815	2vb3nLXf1LCkLfEqFb5KqBsx9TXmJfcoxV6Yp9nDtFixNoimsn2A	359
14818	2vbZis7j1uVDp1ZiyEmUnYuu7eEDrCnefiJuB8t1hGJrGmhwBEMh	359
14820	2vaxwCShpjuKAXoYd4kWyZHoB8AX7s4fmTRLU6yKsqasYcGpz97m	359
14826	2vbXWmgvwjSvFXyc7KD46AsqPrBnRWSsz5evS4smh88FxPRR8r1v	359
14829	2vbhyfvUnSmNwxuW99kBhV9J2s7yg888Z3dQV5nbqK5z6FsemGbr	359
14833	2vbTAckTkGy6179bW8JWJs2azHBvHygfJ3Vb7i49CwF36tQQE4XW	359
14835	2vaYvA1imuxXZMmf6x8kV2T3ZMhFuyi4tw1gRjFc5aXWUctQ2Qoc	359
14838	2vbrJC7PU2zz1qKDzc31SXfr3zp1LNhpGtqgc8TM9M6VU1yrhfXh	359
14840	2vaJHtenLQXfvHkNDsikFYUvC7zLZYCaBTu8Jbuy9ckLch1tE1ER	359
14844	2vb1Z4YYv1rQxH7mjQcJfj6hxF3RYAZ58KvrqoAgQoi5qNY7exDH	359
14845	2vb1HE2nbD2oscJS9aa5M5Cn59UriBp4SxCYiYSNdQBuc3EN3DsV	359
14847	2vadhrEpsxEyzJL6yDsUNqWmZBTGs9wS87ojASwASjwHbtiEAM5W	359
14849	2vbU9YMJwowxy9KPsECvZu7my7nhyBTPJ4TtGZbb32KmuRCPEFJJ	359
14852	2vaYyNRGLEVRbzcRvQ4WVDWpu8C2VPXpvHD4qFE18K7PHwvwZaVq	359
14855	2vbUd7o53d5XSPqeNMujt51X97uuJYR6qUK9r4GMoFC16q8U82eE	359
14863	2vbshczx3cohg75ctjN8ADa2tfcE48aKdqoKs3FkrYqDsPL38AvW	359
14866	2vaFjad1Q4Br5NiEEv8sw3Av2aop6R3Vf98eDxt9HCfLwcaS8U6r	359
14868	2vajeF8xicR9NYjU867qW8qYy6o1WsxMZNrbUQw8x7aBYYp6udkU	359
14872	2vasCnR8AqH31wde7n5TDYvJ8a4S1BUWLtTjSKKFedUFS5FCTqdY	359
14882	2vaNuhoh498DqayHgJSzA6JyYxHkCrsrSVxRNAiSTvWHTRfAkUY8	359
14884	2vbdjXzVgbeiYL6taN5rzsPAeobhAhBDbBRVYYUG3mkErYK21vH2	359
14888	2vaW94cNNjis5i29v1TX9rNeP2ngd54idf1H72YoYRFjDQiyTaoe	359
14893	2vbwysv9HQQPXWFxQ5oYERN5miSHGfTXwoJRk5cFPUuBDV3Up439	359
14897	2vbJyjsNY8jNdX2NNUhNj1fkzCAHbwAtbqhaSKv369pEQ4VBfTpx	359
14904	2vb48WFhSmMVxwt23UoUEeQntJjxXeZPxJJDgF4HeCjuXPff4cdQ	359
14907	2vbDS5z3DoQ7oykioLsR3vh5U4SLB3QFxQu87R8qYucW9KL8YvhY	359
14910	2vbfNtXfy91aYuf2rQnmtd3XAfzEZZmrn6X3H1Jvnxx6GeMMv8QU	359
14915	2vatEynNGYwsWcFzk31gXzu2bQsb2Z6HqnV1W5cgacmiTrJDb2PR	359
14918	2vaXju5sSYg58PEucgm69LPWqsAoqfbGYXKn8B6Sz2bBQy5WG5MF	359
14922	2vbVTxbT1Qub4SEYGiRatkYWEkMeP1rQD6ci5Js54XqV8xVkH2Mu	359
14925	2vbA46sKwnY9HgdUJob4UzJpk1a9B8ShJJQ7eUrmMVhEsMqnqD3M	359
14928	2vbcnut3YUt7QCovCCg96k4cffszvU9i71PZfqvDvRvz2xMc94wv	359
14934	2va9Tr7yqbicD91NutLDfQ7DPcRcJgUq5QZXDvQ8mHJTKz1f2niR	359
14937	2vabXk1oXF4rtTSg3J7fZEBkAc9yEFANtDfNzvwXMqmUHphZBZpK	359
14939	2vbTUhCt1xRg9LpWHqzhpVomVGQqEZz3t3WmDT9K6TGkfkv75G6r	359
14944	2vbjPffLqRxPKkH7g9aK4Pz6V7iJhRvQWDo5XACoap4UmwshWgCF	359
14947	2vbK6pkgLbzMKyWmLa7nxnksh8xakmBufjhBeDSqAbNEbcyQxKnM	359
14949	2vaXthfMgMbTD9rYpZNRzn8eryqYAXRkj2EeAo2wqjadQTj76UgX	359
14951	2vaTeP1RdA45xaVTB6sWeJsFxeVfnYT4949RkNjFafHbjJViN9Qf	359
14955	2vbekMKn7bT3JsHg9MH16Uwvh2fu4VoTC2UmMzNGHXt3x2UuDt9D	359
14962	2vc3rD7tTBamcvoZJ9HGFuRRXMf4V3BbcGcfCNnYVwP1e4ToNWSW	359
14965	2vbUNvr4E3ycErr5DnvZpmWUwuoFSR6SHM7qLcGzFfcyscDydtWr	359
14980	2vaA13feGFdoubgMeYEDwrvCHcbTZBRP6HzL83PLYUEYaTYbC91A	359
14982	2vazdQrThx2JcSss9HjAEZbkezyYKWrifh5XTjKQdeS3EbNYyy26	359
14984	2vaXRGqgomj4S1bWJBXYRTTBQWv5WbRY7CryMPt4CV61qQwHRsmQ	359
14880	2varRLjw8wP2f6RUdtG6syPaaTMTFjahkGmEt5qev2fiXr8Q6vtY	359
14883	2vbcHWjBMjT1XyycCsgvq2bZTPb7WvD619JSYg3jLg8KVs7G26EX	359
14885	2vaDSDTaRcPe1UyAER3zVLZpLmS5tKHtvck8EAWt8PRxjsRGdXTN	359
14891	2vbvUKZMLs49PiPrYNy2VT2QrazyGbiCs8Fwd2hsibh1QKTsfB3a	359
14900	2vbV2CxeeVHjPP4Yf48HhjZNftJHrDvyRGmoaQu783617y5t8RsZ	359
14902	2vbkqJq2qtSaiMrRY9JRr5c4NBtMqRSDsgt4D1pDRpzR1Th6e1uF	359
14905	2vat1scueM6U6JGDTQYb2zLnbQRro24zaqcUbTzjCg16HSmBQpCU	359
14911	2vay2RsL9u3TfcueMDFxJ586D6totZVZPHUPN4k2ZrJs2ayJSaN2	359
14913	2vb3fNXmn1MzfA5gqMWSiUbJnLPe97zUtwREBpUNy9tPkBZx7oMx	359
14923	2vb1KA2jdxjPPzks9WVgwGUb9a6etWkjuFXSqRSrFckBRx8WruSu	359
14929	2vbj4omVVZ8V2VHi5xau51kp11mtQBvMTxsDaKJpCWjpHxAiYg7m	359
14931	2vaUDN8qRZdDJNPxpRMV6asppVnZebiyvKSFMifSSorHbtsJckRF	359
14950	2vb2Lhb2oshrUrggxTJPVYkb6ptZ4oJzRoZFMyVzzkRo4yNtJuNJ	359
14952	2vajwzc3uZwP5y6BaScvX9x49o273NmvKdNgfzNS5xQeTq9zuXxQ	359
14954	2vbpi39EtbdZk89Tf8twQzJYJMCrHpJ4rFfPumG6gprQ4XntD3mb	359
14958	2vb1VLH4G5UZU3cPMEEZ5BqbT3aDYSq771QmDgGKZmzdYckJDG2r	359
14960	2vaNUpX91XGPeYqSAHUoXXARPdnB3GWohJva8breAE8dyiDSPQ7u	359
14967	2vaL6yWy7dhdeLh9r2dchVMaS65MMJ7bhcv7dTqzJWkLhbvWLBfw	359
14969	2vbrfCNoAPvZUF85STdLMtQqvACYsaNPopuP44U2J7dh7hZ56rQM	359
14972	2vbf85ee1gDeixdEGRn6fxtRL9WighQYENGTUBJuegHZ45BgGy56	359
14976	2vbzwcnofUy9kemkTi3FSzQXuERMLVtQFWKX92witDQ7fPSsGFDX	359
14978	2vbLr6v54XrqQr6QrYS2DicV2vUiEFSM7UtMZXmVPz9Dz5KKYr7H	359
14988	2vayZcLQdAkPzHEaVcg9BJNmJKe3nAjjN8QdKUVeW5PHULQdrPwa	359
14992	2vbU5i1XXLCJxMtoXWpXAmB6kbHDHG7G7srFNXSrX9qjCKJbMzRn	359
14995	2vb6MC6AVAEQt5TmCf2jTafmoJ5CZcWBqxHswqakhAS97JFJee8X	359
14999	2vbAAZp7o28jsE34cyZng1TwW9XeEiSRqX65FZKWTMVipHDHyntH	359
15002	2vbvhkvQkf9ZwbVh6u336XaQHSNeinE13vN3nBokpNezQRY3wFuu	359
15008	2vaVUhdobbyaX3m3ECaPWTHhNREuiRoanoqgTZpQyL5ndF2pyE3q	359
15012	2vaTDmn7F6rtVPzGH6ox9PU3BtFgRNQPyxrYm3tCg7vBmQG4ZtPx	359
15016	2vbxeA2H3uFvfjfv65Def3dbhJ3irpxp6NpjHztSobMgJZb1ruDt	359
15019	2vbnVppp154PwVNLnRHfPqTuDo3QC6Tb74VsnneHUBe8nuDXRpwM	359
15027	2vaLPJp2MtHwTnBvuFhbRFPxkYiMaFPrMzGkzEVpW7agAK4X3FiU	359
15030	2vbhypZKGcosufxKHdnBg2cm7uJy1xiiwyJmRAUEv357898M9EH9	359
15033	2vb6XVLfpQevquX5Ehf3hwnsXjD5MiwhTogb4pFRw4nmMyeCKok8	359
15034	2vaqW9VYHD5QNCVUASEoDEVkDgczXXS8X2yU8Pu8s3qQx9NXA55Y	359
15041	2vah3MSyiBu77vwPMjSY8cCGxt5Wm6GuXBRmiXhjrjS9Nhx55NFk	359
15042	2vaW7GZtTS2NsQwHFBBrdRJ63KL9iWXoWghKcJc5Gy1HYMCfKoCP	359
15044	2vbbzFh5bQD4cc4nkcUQw8NG1etsj6XcRKzeqq5qowK5UHCdqFWd	359
15048	2vbHEZwwH44HXCJbZia6tk3mQaS7VhzapfDAD8LutC2mwTAaWnUu	359
15051	2vc3JN2tG23Pv5BqBLD8ttzXzLhzK9VgZPMRbPtwp72iFaJev2C4	359
15052	2vbbmgeqqY1xKfyfcZev42B8pGPpkvD3qrDqo8JptyHizh1ZQieL	359
15055	2vbsfr2PsQYjYY4g4mpvqg1ZvKoWoMMoHWyKC9E7DwbpTZkDZVDL	359
15056	2vbWRJSSkeYoLRPqgYXpXwJFbSgAUdKcTauZBUYwtcNBTGN9xy4h	359
15062	2vaA4MHiqJMfnnPKvjLebia26x5Q3Cxi28KN8vwrMt6PmYCoqMYS	359
15065	2vaHKWpaSvXkFSQdcQ9H8XwS2QiFqNf5XehzhND2pksGJc9i149w	359
15070	2vam81d8XMuW8RDt8bEHRD7V2F17iDxTEVSbuoFKHgjsFQ4uEQuT	359
15075	2vbc9p28y874bbGon3fXjTCNvfJXXHfqKL1d4mfgLTwMcHLJgBen	359
15078	2vavKo2eRRS71UEDRUTyESygohVKtHPkut3ND8JtCXRQioSb4T1K	359
15084	2vawUP9e5ELSACUn7xEyFuvM3g5q86Kvge6CBDJD21HZAFqBBVnA	359
15087	2vbNYh3TJ3iA83eBB17jE7m94xAuFaN6Gpw7AoYrEGGhY6QBcfH4	359
15089	2vaegeooWzKgPK6oUpYKANYQes2EyP8Xd3kifo2aoQ8nXiHdLmXP	359
15092	2vbQbohqzo8DpUBvfiGVn8wEgoN6CPCyPALvWzxBNxMJCS8R8yVg	359
15094	2vaQ1hrruRTZTFQLe6hx7zNC7xfCbKRZVajTLcdnXaRh3D2dd1EG	359
15101	2varPCt3CFc4MUZ939dLFMFefwcozfEhjAKYPoT56om2W5NgN5ei	359
15104	2vbpcXmkSr7SmBMCnHcPmzyjLbZaZG1NfhJwVBP9Q5jC4BhhFTuA	359
15106	2vbjD5FhaHvZhSn4QJZ1ycg2VxAvswxc9qN872twj7Zv4axbdsqM	359
15108	2vbHmXWZdC43xGKPFtvkHiVz5aiMpk2KT86bPHnc9ARXt9Lf9m88	359
15115	2vaWSQMKeGWMcYxCABxYdV5BencLiNwqmrmydRZTaw99HDPhA5A8	359
15120	2vbbtKsf2ArosS39dnSE3Ro7Hgd49Dr4ERtFCuxH2BCPmigUKJeP	359
15121	2vaon4Aak6X51PAvttiS1d8EwLhFHG44BzyNYFNynEyMzsYkEN6d	359
15124	2vb6FJh1q1rZnTLcmz9xHocTRMaUgWyXn8Zha3EKJtcbfekQd5Tn	359
15127	2vaPd1ipr67zh2kr2HW3Ab4bNJp6dJ29xkhBTs4kxvPiox7ZyGRE	359
15130	2vbEjZ3K4kUZaQwsgXDZcA3yLUCEtBXc17jwrEzD8gCnTRJaH9Yo	359
15136	2vbq27CAS5xRhA6fZpCL6MYJPi3GzivQjHUBcuwX6zuDqboxh93q	359
15140	2vaHD7yi23qZBn6uigGGBcXMSkechahmSqdbZhj2Zbw92yFMiZqq	359
15144	2vapRFnt8Boj5mGTar4bfabAH1si5ryFjoVXL9g3ucSWhFpJgBeG	359
15147	2vb9ZtMCGX1ZNuGBRXxhG4ab1UJW3rAdTC5316qZmo4nuk8JRbMx	359
15150	2va9tCgkSPwupjuqhQ4rqVqYQuawAp1qQNzMZDW1xfmv5gCmocFG	359
15152	2vasvvtjPEW8Gtvmn43FFKysY9RNyKQcvMQvMWVZCa8zshFUtjLQ	359
15158	2vb6Mfnew1AzCTrGgNoau6pEXQz5X6dAZNwCaTDfCrEw7xABU4tQ	359
15159	2vaco7iqWBKFs7e8Gtcmr97rHyhg2fBN2jJhU3TrnvKZsnc4zgqT	359
15162	2vahybjvQ84FVNKgoZKtU72z5SyEcRiTxJUQSe3KRjzpjvgXMhFR	359
15165	2vad2eYxWJfHx5ovYmAU6YtDcW3dGmi4xneGjZPFZJjqn4hEtBxt	359
15171	2vafJgfV7hNotQaDnv7FwXqsvBuRSf2z1txJi3EChi4HaYoiyDTD	359
15178	2vc4EZqxQuyREAvRytS5iNAMouSuguMvDZ69PB341AzMdUEwtQHr	359
15183	2vahUdQH8FNAjukX6fMTEA9MpkJKz4wPAHxDpSoxHNoyrg4fNkbo	359
15187	2vauCsQwVpRm7KQccojp1MGS6Mjdv6CVuqq9Ka3FhjFyB7cnQT53	359
15188	2vaNXf8Mb2fYAJUQ7h6WPzRPrGMARH8sfiTkeAH6JgkAG3JZR5K1	359
15192	2vaNqFQJhf5cDWs5BsAkZpKbBhCrwfoUsta3doCiBnRXMzUS5ZXk	359
15197	2vaqqSNBh7xgeSRt9GQ9MHV7cvoVefGzNGhXCc24r8yAC9Czxuyc	359
15202	2vbRCc3cyjfL6hg6TohYc2Ha9cU7uSarwuR5S1GMVFgPjcg1XRuK	359
15205	2vb42VfnCe3xmf8Rtbt4FcYtHKe3URymkof4PVpFS41Vwhs1cFYL	359
15208	2vbFpkLwFPNTDLpE46rRecXUnAW9UzKsaDCTadXavmkxCzzCZ5xa	359
15212	2vbLmHEqzfrTZkUv7qQWNNDJKJdu7zi9F49Nw1taFw2ai6biqR5x	359
15217	2vaRpJ3AWbvBgjngJLtkvUEsJgpTx7wG7zbCZX1mSmPS6mH7JRuy	359
15226	2vbPR6Rrfni3tXqXHwxpsVWMCvSH65zT76muM5URQRFsnHMjenWf	359
15230	2vb8EwW7L3hXEqkDugvR57fLnjABQaWtZDNFQ4XzwdLASmFapp1L	359
15234	2vaMCLEgiF1d6d6edQUUBMvKTuxcCHpBihq9PVBNT2dtgWWYNnXe	359
14919	2vaeHzGWzVV1YceUvXrSXrAR2ofj3TMaua1m4P1XTAFREuWWD1Xb	359
14926	2vaGtwkNn1cbqtTCedNioJ2tvb3U9BeqcQGhm2p5N3frRocYH9Bw	359
14927	2vahq2KTcM4xqxgw53TEBb9x5CA23HXdRg7XGsHT43uLjS3FpreP	359
14932	2vbP7z6fAhqyufGu8vJtdfwfC8Pnp7yA15FhBp5nbcCHEFxg3NCW	359
14935	2vbLvoqik4pqAVnh57fVp14Ja2BwNCNf2J4mbiZgSaVhe4UmfKVi	359
14938	2vaucptkWgei1RHnmHvywm83ZRKQWegUp7sMF9xB4VeNZk81NZhU	359
14940	2vazB3AD8FmURQoikjyjYjexJwfV7gUTKTSunLdpBMTLLVDNfXYL	359
14942	2vbMb9rz3zMHQX7PPAkxPDX1cZdVo8phnwDg5f4jCZDQJKRygnBQ	359
14945	2vbasbcjxe4nh5wZWifroNCxSpGRUCycEQHx2eCR2jtpf92cJNha	359
14948	2vae9AZkzMT7YYjiP5QbVUNk2h7JqSNwQZZpjrw25jGsSkYAuVzF	359
14956	2vaDWMdXcufbk1kjXRCZPTbMWGWVanC8SfgrBx6ZUnoamWd2qKry	359
14961	2vacthwrA7Pjd28GnJSyKNKnLrvaJ5RGcRU93yuz89ZmD6cvaK61	359
14963	2vbQP763LULu92rv8RQL56G868AqnPj8jVZUPrt1W5YBTymFzyPf	359
14966	2vayLEw3sAm7FXQSExuwHjuDNeVcu4RQsGfUNBEau65tvj76jaJp	359
14968	2vb15LmDd8Z2d9ULKmT62MMUc7tvBsnmSGo45vVJx6iqhTNxjiNz	359
14970	2vaMALda8g66rqX9MCnZYUX8vT2LRUueAZkWximWYCB6DDn8ptW9	359
14973	2vbAEwbc9wwXBjXk7aqUGmWAXYyb3YSAJL9TAMdnaSUVMTBRAa52	359
14974	2vaGo55s9ZWAeft21S7aVMaePznDPYcQZSxz2uMxWGnhhtWvJYwD	359
14985	2vbvWfw9odx2zUijULJ4Dy33Wj3RgvomyugYBGT3n2Zobdwwo773	359
14989	2vb824sZBMbrqN1YSj4AV1J6NS14qegXcz3gpkwFJ45EufweVg6F	359
14997	2vbT4iYgWd2sP7xe7kghZN9o45NkVKgmpHiYGuCy8yMH4M1oAsL4	359
15000	2vaTSGVDDSvUt9QuzC23BeaPsU3bMPp7o3t6jx5uRVqf3mKW8JSv	359
15003	2vaXdHSRDy8ZQ38o7YedE1WchsZXPtznR5AKq9hdrSMrPyaHnm2M	359
15004	2vaJDaBLGksvEDU8nwZKYBTRbokhxWm97Yd8GC5AAadGDfQgnuso	359
15006	2vaAV8Bt23Ndzt5rB2FQg6DDtx4LpTJUoYA6sETvGjMnKmMjbE6b	359
15009	2vbQ4MDEmrjwebeUrebB7V37UCEqgfDdqFUPrfbMTknV5ctSm9E2	359
15014	2vb6ZCvz4mysjDHAtXXqnqty3fHZpq31ZSiEq1sVGpddK8oGA4im	359
15021	2vbLQca8ahKHnCGXL8q86VyuVqcVoBSrMkNFZnMjMJcoXcKoLgyW	359
15025	2vbETWuYuHQKcypfp4UWaohZAuHUBkUbJEDYa8rjSQishVTJbU4d	359
15028	2vaTwHrvFAoBofooRCJnA1q76SbxgvJUzzpq767pNBoet4HpgfGg	359
15031	2vao7KqhzBPDpYU55mTeZ7BbwjkeHdqqj3XgpawnwfHo7oQzFSC9	359
15036	2vbE5JVnvmahphLyVP72zNqLmxcvJFeuhPfEahnbo1THZeFkvVnC	359
15045	2vb68dyh3xXXmT4p1eBzK5tFpgJhWNn79CbKNsBEFZNmMkjCvMv4	359
15049	2vaebwkBQsLhpFQU49hmNynoe9tiD37FiyaP6PRNk2Asc8D7ejFx	359
15057	2vaJ3CwZfGJbyU2WfRncztm8aUPJkXm41rbcVn1uBXqUHtfRoQAK	359
15060	2vbSLCLQd81CwXHh9DvYrZ5Z1sccd77Xco4UYkAX4oxCZCsmUvEJ	359
15071	2vbo1KBvT919VdUTncRzVtmzWTtyUd3QQ99oxddJ82M3NcWXvgnj	359
15072	2vb5LZtaE4KYahbNXHd7526w5XvYwCJiTg8NB5SxeXuthWnb54qn	359
15080	2vbf3bYEULfqXAdjjzScGCz7GyJ1std9MLnAqhZxMEJERHi3tHj3	359
15085	2vaSYytYqLGF7NFfF8rvSaF7RLKd3gYLst2BJfmYSncdcdy6N1de	359
15093	2vaYRC3DhHnxPrFCnMfaAuYf5Ts3BapxtNwogy9ARajLgEVuVUc8	359
15095	2vanzT7aoJa7Mj19wdnoABMsgD3Nv3not4RYpZACvnWX4dt2GypK	359
15097	2vajHEAp4WTY4n5NnRDHbHNVhmJhNG49fV5sMm9ZgToUEX5xPuYs	359
15102	2vbDEmooYHGAz2c9TFLKFocVPFzUakeEqnqJ8fgEZoFNdnEXe9pe	359
15105	2vanwBY1qCeirNX8ksJ2W5TsKK7xnMErjgukX28uY2mdoK7kdKj3	359
15111	2vbXu6tyPduDovEFbiMBsRuoFM9KX52f93uDKaH8Vom5iTWQbLNu	359
15113	2vb6Me22p2ZmBFGvzAkfEgpqAWBjEUB4w9wK9g4NUvqBjXXavyKZ	359
15118	2vbJ53CvdYEaGwBTzXRShiwqrs3wGCFVoaXqMcsXWQYrcABMbr3U	359
15125	2vagXLTkN2sixW2H6tQ6y6ZSTgZNZ1nCjXCERrFYdfq1BKPqBePo	359
15128	2vbsTWCFPPUuhWsZcPGqUz5pEPCHEBewbiAEeL8oBXDV2oyZqA4z	359
15134	2vaweKp9M2VXFQyqoyQe3Kv61hNkwWLm1pVwxGFwvZvjqewFDArX	359
15145	2vc3LcYXA83ae9ofUyXK6JnWqHeNBe8dhaiD9phcfi2iMDH8xfo3	359
15148	2vbTwQZT7tpnS7DYbJ2spnRpchQTVkq4yfwX94NPcegGcbReKqLc	359
15155	2vbo2obzMe4pmucoZCsdJryrqtocvzz7AESK16tMVQwqHiSJ3gCG	359
15160	2vb31C8k2UffTR3ChKks1eVWjGRtqryem4XTwkfbQJUs4XcJ9rpz	359
15163	2vaa6VZzjbFrFN7aHK6xP3NFDCySVbg9GLsdjaWxHyhiLxhqZ9sG	359
15164	2vafc5GHCWsWWLqFNG6buDSNVP9Sa76WrNNGUSMjV31r8zJSd9Pf	359
15166	2vajmaiUFc7Lee44z54CYFKFFbsSCdBCKEsyjTGRtpFaNPjiEfbi	359
15167	2vaPpx7eHrfiTq53yKaAEJCdH679A8AxGD1Lz6y9qvvw3ncSzQnS	359
15172	2vb7pn8aWCKSzcPSexTQRUHBhBKfgygQDznW6VSZ2moYTjx9C8U7	359
15179	2vbVfaNe29cpo3h28P9oGTmXLJRyQRRD4HJfytKzWZ1y8Tfef7oX	359
15184	2vaR5WxmnexNYMq6QYkPifwKeTfCHF25mZi8tqZ7vaa9nFmWpw63	359
15189	2vbVn2LYeVm3yYas53gAfbsLPa7Qe5vzyQTmUWSaeRT7T6Ap2XzH	359
15193	2varNNFCudkzVTaRXFChDSLLr6UneziEn3b2qKiQX9tiaCmqt5zM	359
15198	2vc5kRysYGgocvvjyNysYkwP73mVzX82HNtNqSFFQzr96e1erkfH	359
15203	2vaQmPdux7pCTHBb7w1iRTrneK17SciozxT9bcjgd5zY6tnzBRMg	359
15204	2vaA3dLzsCfSJeMgEGJwTRwn31xrqHCNHGJmMbWPDSbwBG9aryG6	359
15209	2vapG7QP6egDS2QSgEcNi7UTxzbCCdhPiJJajb7bsBTdA7vtxMsa	359
15210	2vaMU77cmYQvG5HX8kxwTnZ8FqmrhESV2JS9yN1495wkKs4cPMSQ	359
15211	2vbAaywrR9urseGchJzqg4Rd535A2GJcZPBUEPo5SLy5NmcspY8W	359
15215	2vaeeSNGS7vSBUDfenEs3bjkGuTduMJ6Yv8XNdPhV5C4FSPQsNCv	359
15216	2vbybtnK1TyQbB3xxpCscWL8xV3CE1DuCmmtKgW925AcbBe1DNmY	359
15219	2vbtXWqRHDh49GgqHU4nevLzKAbtT6t7T4Ys6qTva7eM2tyZQxck	359
15225	2vbKR7Ntpu2pJzm352f5kDrnNs2jyXYX4yX5V9ZWKHZVizb1cWMa	359
15229	2vav6EW8tEUY4pDUGi9JPivYzx1LboUGiTGSrH4Zz65X92htR2N6	359
15233	2vbgj1hR3ASUKjjiBRtSgVmQLK75spMd95ZKn6auVRRkPoaixnT2	359
15237	2vbXa3fsdkr8VKY36ZDqrtnJbo3YZeiwK1t1gDHfxv6niSjC9pyj	359
15238	2vaNkCY4At2hi2iUJ7q4H4LS6ct3J8Xtf9dshwp4mWDbNSBWff8W	359
15243	2vaAPuixLjgGPXLirfUDGfysTjTucWNr5xUN8UwMNL8WpuRgxrht	359
15248	2vc2s2SMCF4GDPUB6PztpaoMcDqmoqkSjmj27p4wn1dN88PfPBEQ	359
15252	2vaZ6q8nqUJcz8SXRDQe4HRLV7xgPp6Aw5W7tKZvZqV1ciLZY2Cj	359
15253	2vaZMzBRVkMJFZv8CzVhZrhMsMex23ggrGnFxrLoCDyKpajecXsp	359
15258	2vajNzJ6uvJSt7LBQqE3hCBKgLBFDoXDNFr9by4XoYxcHrPUQfNC	359
15262	2vbK7YLvuZhQBCBst6yLd8hhKvYPn8FUbTLid7UmqhbjkNzj7gM9	359
15263	2vbjMVeXgb7LJCbzhLBVPMktUbGsdbwv1MftSAGMB7AiD3MxCsLW	359
14987	2vbmxrDWQ1RmtNtS7fWKV22X9P8jKBYTjKjaNKhFkX5CB9keWMci	359
14991	2vb86HpMrBMojT3UDXpwvhLmzYDeScFbiNh6qD5Tsi2s99eku7vt	359
14994	2vaYqtvGzYdTyp6hgiy8fwzaTx7k38jcA9Vpy2WQQDtRXy95ui3B	359
14998	2vaHKHnJgyTcybwr2MEUkgswfMX5jTkr15xhyxefpxnDya1Rg2GL	359
15001	2vbhdxqhuz9C8obWamx4AdkwCKaHQzN1mYVTY5HK4Vj5ipshrsCJ	359
15007	2vafvKAr1dHXKooCqbB9kqAAd8dJWy9S6d4fVgji7NJNVKhJAoou	359
15011	2vacn2eFQqEijo7zhVfxYPbYkVWniEqwG59rZEuFaSrGqPYKFmmu	359
15013	2vbTMUSUoKFZ7RwEtw533SrmkDLcHDy2QZFPMsVMrrt9PGPanqFy	359
15015	2vbuTvjC9Z3BbWpqQfbrNQvUuvYWuscd77XwFe1CwRtytovjHDgd	359
15017	2vb4fdy27GgHfd1WXGFcYbDXvjDvKtG2dho8Zc4nwHmMoNWWdAm8	359
15020	2vbY3U7rQgA1qgywSt54RhysavS9sWw4udDNoatwcciEqcFTsAwM	359
15022	2vbP8GfLY2bNPE2Vud7eDUToXnjLeTHbGVWwu3BZfqeaq28QY5BN	359
15026	2vbHhtK7dciasrXqeuwSSiraAFreHDjaa3JsFU9Rdp272UErURCw	359
15029	2vafwf6ksLpN2SYB5ZVk51hmwQfGeJhLVXyb2fSib2qnZbPr7CD7	359
15032	2vab3To6uJJsmUvL1W96hEGp3KQbhns3DHMprASfVcijAeY45Vhd	359
15035	2vai56XRu4rWtLqfhTDdZCVnQa9ZoY9dJJuhzYfdoLB9jWBizc3r	359
15038	2vbRKe2hMVRAQJ4WzJNMhUoo5Ke88pzg5PiEKtrkrDwebkyWqZfM	359
15040	2vbSWCfhziSjBbZG17d7ztq2payZNN2bPgUJ1EDLeAbuzzzGFEBn	359
15047	2vaCzjGRhEaoyhFRfrW9QaSaP1EVhNBUrgkNKf2pcjLLGx1owust	359
15054	2vbkD1vF9VaabchYADfMes4iGQH5mQZjZKnX8J27fJvMiCS6ABYy	359
15059	2vauPwSSUzA1ZRYEieZnMkV89Nqp8uXsVwDMCds8m1NRSPHCYKzf	359
15061	2vatmf5ZPPE2uFPd3yq68wDoLHEtxDTaXGnuZEMHDohDCjAC4dxX	359
15064	2vc2TaJuaddQQykRxc1RW3TnbfYqjArmtEZniPMN2u71rYNRrjHu	359
15067	2vbFJhXfJmmPd3zZMemfeAU78LnsbedLigSTQVGp2D18oi9FSnHP	359
15069	2vaMmn8dMKtXfg5tt9NdniJ2kXW8sfp8unp6ana5bjpweDV1cBqM	359
15074	2vaiPm6AfQ73CRpVdLCe8xxzQEhNhA3gGcMfWkWTWEBqDsicpgm1	359
15077	2vatRUykZHV7P6W2cD1zbdY9Uw31xiVwhyZ6aFKFLheqiJnZ2Qza	359
15079	2vaQ1sbZxTCnpiKUJkpvw6JbJTSNkdgtncVHpwL4quqBymZ6VFtt	359
15082	2vaj9FZdnXrmwfHprtMPMoNxGSuMNjX4fGJA4cazwqT9tN4MnffT	359
15091	2vbmHAjXCtRdfbG5YagNA3AwiY39htePrRaEEGRC3agijsbCHCVu	359
15096	2vbGyEvxgJ9v1xYoakmiWMjxKnhnMsHUvu2E3dwFWwvHhaBBWUoG	359
15099	2vaGGiorgrL1CtLMnF5RHUPAbk95nmDvgmnr8tZWBZyeAd1DRG3w	359
15103	2vbwAC5Qcb2k2beVRS21mHaSJmEx8XZntHxQz7DqmQEuucvLk9cj	359
15110	2vbn8BN4iCjAQoZKRGAc3kVv7KdMe3r9JY4qjZgkXipu8vF8R2bX	359
15114	2vayaciKsjrwsZXJdmfFtPZcQ27f6MEPuzhYrSGhagxd4ME4rm8Q	359
15117	2vc1gQ8XvMtWrr4kHJerwCSVCXWgNvsKti6xg13amBdrXXBDRFoR	359
15126	2vbrPBx91PnDeii198Gbx8QwGFGzeWM3PyJkyBtwQsVQQxPmXoJY	359
15129	2vanDb3Qj8zsJqNy9KVKr3ZzxTimLr6eFKDx6WeE2fHNvx8ghX8v	359
15131	2vbtoHCj52WXMomCx5nHaJV1CgZcqXv6M6HinZYBwvTKva5ZjvWC	359
15133	2vbMb2dgwikpGaxmyU2wntmTqQADCbFuykB8o8RPuvetbx3YjQ33	359
15135	2vbr2nXsFB31cvUk9kJQ469FXwVoqjbZSJazTssNpooMdcS5CAFv	359
15138	2vaBbZqmbUeVRYHZRo6neNi5DY2pa7PevJEdWHLkMLxUDJDh9P2Z	359
15139	2vapmpQzBaGyFd3WCuzn65Y5ERGNQKk3vRhhVB3aXocMX16MkjGN	359
15142	2vbKSznmsDLGwDSAacBwzkqpkqTfEHLLJoTmsW7x35AVKo4s4YNA	359
15146	2vbc2iGWffFn6tbDar9rD1JA52CYnJN9Qo3puNsBhzoCz3o5Jewq	359
15149	2vbcBT4KFEkimKY43DhFZh5QYDNMsQAdLqz15Ci8QskM52jBoewu	359
15154	2vbmqL7raJvzNaxEgzsQYwFGwjSiYrf8MRzS346dPrdjuaERrFTZ	359
15157	2vbzh6sF5zmZqAArnBeQNoy5heYYu2xzNHpCYD97wdtca1jFBeV1	359
15170	2vbWw1eCjEpJhzu7Lar1msuue9S7eumSWjnmhFQddXRxozomUPY8	359
15175	2vb7br4CgJndtMSRRPtJ7VdmSHoAxcP1Q5gQR6LYAss7HV4jCHSR	359
15177	2vb9eH4gKdPbHhHvbx5aFEVxU7ptyJwVW4Mws5o3QKLD5gu9V5zj	359
15182	2vaGfuMRtwkxG2JpHgCTUWUGLEp3Nj3mAPkLpm5e9J75hBVz9f8N	359
15186	2vbRJybJ2WZS7aafqCFJb8gVzaE1LbXwerZdxWzuBcmc2Tw2h3QA	359
15196	2vbe7j4wJKbjmLP6Ludtifv7hA5R7k8YHXJ9iBKtR8Wqzc4538DH	359
15200	2vahkfRdzXeJ6ZvHzkgrX5h2Dnbc8iuqygfiijXoXGpRW9753pxU	359
15201	2vc4BJvV9daqKp1JeCnkJsV8Zwg9ksK92M5JTMfGycBY9UPPdzoJ	359
15207	2vbHqiaDUGZzNcTheb9vUwJyeU29di2sQHfq8kuH2knAmB13obD5	359
15213	2vb6jEJzE8mxBqZsdMo13aaVWj1Q3vxqM4tJHvYFWwy45yKcZAMM	359
15218	2vc3E8KMGQzPLutQxGJKYY813sCArxiRBTLJUAoADAuHjRuhLx7f	359
15220	2vbQ8FCCR7mRxtADPvhLH93fzHV7ZEAovP7dFh1xCCFgjsuadkCf	359
15221	2vb37LAxvBC95gSn1o5G54j84zn6kfmGe4GXVzaen1mND8vUU7kH	359
15227	2vbxgsp51UTAs7RJdZUwa2UMGNLj6ZCDhzq2MGie8RwSV4XrQ97q	359
15231	2vc1V2k2UUNrEVFHHT3WKE419maibYqn8KbsNQYN6tYRfUfhoqY5	359
15235	2vaPLc4F58XcHVroHSMVPBMv48uFMZaqemYEW3bujNFT3Pt6uAQK	359
15240	2vb2UxishAGtwfbvAhn4G5ZZbhtr98AxG72qBD9WMD2vgqnEU4f7	359
15246	2vbLyQrBMCfy48g3N7f1Uu6fbGaBAWL8qotWTkVu4QGvWS4a6uSB	359
15250	2vbVWUmZxvdH6aonc9i3283ASSSVBbdJVh6wcBNTFoddY9PrvcB8	359
15255	2vaQ9p8FFDDzCXNHaeFeQdLtcYDRJvgR7CuBz2SvGdbaSYJi7drV	359
15256	2vb7oT77LJmruD29BovuhXdjp1zzYg7s78SuJUY2YrQBpVPqPNcC	359
15005	2vbzv6BcCpiZx7cCH2ijMaA9FpckRdMwnnw5Rtd8hKKcyd5RMuNB	359
15010	2vc4fM4f3VFUMzJWkReeNAVkkpdjwhgr3DLxRkw4NjNguL1XGwdn	359
15018	2vacHJMuzMuednibQoq1LUMbZ4gN2yacjrpmsRFHBXxkDLzsLXBA	359
15023	2vaZbaqWeB1wBAiDmgMLpTPCzai9Ye541k2duwJKn4bqngPEcoPW	359
15024	2vbEZnjJCPxtSvSVrKckwy2hgU3i4SRAwrfj9uvEdxSywcLMMDTG	359
15037	2vbdhcixxvmjaU3WUjEGuvQKHGEAxVdEAoyuaT2SZzB1AC2qmKFq	359
15039	2vagHLGYcaKPLDzfkzKtpRMbsq5mHQhdoHNNF2pk8sEQmhJ6qpWr	359
15043	2vc3VuzJjkc7iB6F7TGu6rsgEqkHnozyDxy6Gzs4fcdGoxfCHHo7	359
15046	2vbMuUfQatVf64g7586ZuU6oC25WDxuXNnXr2FChzLACg2wZ5cN9	359
15050	2vaty7xhohPsuyydbuegzLnfcArc6XNgDzyg4BPsKs4VDEkBCt7x	359
15053	2vaR49CHFgy9JZsoB5CNe86NHVyAWEFbQGZMwnTjzicA63mAEMDW	359
15058	2vbUBT1cwctFAae7KgjCTLwBcMp4Cf4PFSgt8J6cp9w9msmEUi1P	359
15063	2vaBkPjP6UaJfjbqFWL3fmwrCVVzza15kiD4tGUyTmnVufo3ANmc	359
15066	2vbVg3KDrn746vrXGgcSCLDbbezGFXd35r3xfxcZhT6z7VmcxtUK	359
15068	2vayx9SNjDF4FhQ8csagB5PXLtp48xqa7J2RTg9VVP4PwdrKH8Up	359
15073	2vbqckFstXZoFrpUX9aBv579o2D4q9hXPWgth6ZkLzYkGu5MFVwf	359
15076	2vaNVjJUt9QAchmS5K2W7oRTeV6gNgeqpCkbFW9FvuEK33ujuLtP	359
15081	2vbzdwY1sY8tTDG9CoFW8Y7PPUTb8poWv5ppK7CmLGeyVQjRFEta	359
15083	2vazdBjodemCEDCc7LFjboXCE6DUaaD9kYyNPtCqHBKW9PRvdWQr	359
15086	2vb3hDMjT1XSR1S753w42MS3YJ8hFmQsy6P89trCVhNgw9TyAMoR	359
15088	2vaQ8Wcq8Y5xGmAssu1qsAjTB2GQxGtcgt4eihWiUFEUgykwTYKo	359
15090	2vbGUA4cGrQdfZCdkzBtj9m2m9ggBqU12Ngep7zjfBeUcRsvvAaT	359
15098	2vbcXqCFDtRF4ADogo2euWV6DEfMEF9seNhiKV9kFGp4FNb1Qgp9	359
15100	2vax84kAouhGUQF2MKaor7Hg1ykDGQpQfqpETDvnCWAtpGXsAmpM	359
15107	2vb2X58MMCTWYRcuUq8PLEhTNw5AyYrnWA5eVU1KWjMmGdmcNUeu	359
15109	2vbupKFjcoP8Bsmr9qupjxb3TqKh5s9sE7nqmLRNaYCztBdgERQU	359
15112	2vawQGpERso3aAAT6aAaEwptNwuiHRFTHKDeKDmL76JR9fW64gAx	359
15116	2vbBFc66WA6AKMckByqjtz7QrrieWuzhDJPMtfZvThGk9BN3dAFg	359
15119	2vbgeyZ7Sar8MSaPuMwmZ1AkXT5VDS2vzcvL26xqZ3QKdc7tHqGr	359
15122	2va9UVdCz8BxQJkRnFBiVzGofdg4pfEopRHdZbJrfcWnQX2FhbhL	359
15123	2vb936TMVTcRnDqf2skVMdTCfo5qAetwMKA88WdH62fU4VS6oamJ	359
15132	2vbHDKzC1j5qyGHrG9ZvBaP76z3v5LwwCq7npAVBN4eCcA1Lgmme	359
15137	2vbEm322XtkwiT4h7i713jmuxYQhe4rD6dGzbi1uacPRLycq4rBp	359
15141	2vbnQn6KNE4RscMG1yxj664dtchBccoVopUTeJDZwF1C8rPW2usf	359
15143	2vbBxKZncuKsdB5SVMdQPArsQFHprHbwhTwMHnGt6UfzcxW24pXB	359
15151	2vbuWwuJwMkWBNv2ZufP7YBDgvWE4QPXjpE1mKTW7utmuFurDrxX	359
15153	2vbogbwCnQzGEBvnrFBbuUAbhDRHXXKHBeQ299iCd9zzoF2evQqT	359
15156	2vaBYmWkuu8PJjxYsMkyJJk6KHW6Pk7C4cdUioxsZDGGB7DiJPk8	359
15161	2vbTzX41CB2GZJnRnf6gBip5Yb4mA2jzQT8A2aBkieTyzCy4xZXR	359
15168	2vbcoi2j9oWn6iD7J3JcRcvu1MAXxfaub1ZWLW6GxcBGwhh1BxxP	359
15169	2vawW8mKPHjyLeZF5BpsbysD8gftQ2AePggb8VXcy5KiTNLHRaxH	359
15173	2vay1MQgL6Cga67ZiRdAkL7ckD9CsmXP4DNRvB1HHB39HWMdQ4cS	359
15174	2vajv8wiKHBPHnwzLEbuq4ayWgK5sBXPoo3HWXKbszgriU835Ujo	359
15176	2vbYNVs1ey5UL51trBzrrwf181K7G1wJ2utCESyHPr9iQn17pCNm	359
15180	2vbaVPg36Ltc86uHy3uhP2UireNRZb9JqG6s3ApVGKi4aVLpkwF7	359
15181	2vbH1TRhmY3xPM42aEggaG9Yca9qSDdcRLYiXsNcdehBXgV8QQip	359
15185	2vbXGwtMTipSDT4GexLmx8H91NLzF2afajz6D18yzPfAasMQwb4X	359
15190	2vb5R5qMdQRE88NKLR5jtArNZuccWLj45d5gCuxCS1nEQ63wBheN	359
15191	2vbX3csXfMM1r5Qd2D55EuKhb6gZ2WseDZzjFwE8csuhQBKfqbbk	359
15194	2vaLNEYCBkKR6zmDg3WELZGjcv7N1x9e9B4FZHgjTbYebhSYq3NH	359
15195	2vaxvdUuEXdnizi5jZncjcj57Lm1iTJ41meTMAscpqjRPLceBXrn	359
15199	2vbAVFQFs3GzMAB6zypiSZ3FhnNsHHbbPiuXCQ8mjDfKZj8xmVJK	359
15206	2vbpaU8YBaoJYZD8tUtff2keQY1hsVLv5kSMfa3Ktp6DYGcA46Rp	359
15214	2vbSsH65pQSTJP9xD9ubcXbW28irG7LGcQwsHm7GAzXstkuPH1Jg	359
15222	2vc24RfzVWEK5RRc6Z1FLZa1hw7UVxTkkTzHRgzEgeH1wdsNGjHQ	359
15223	2vbFBws3iyG5kQMR5hWf5hiacPnNaCVXytpdsvav5FJvFTW6Esze	359
15224	2vaosQSoCbsPF1E9wQEvhKR2u2PrruDwDMxLSf3i1g6Njf1LrV5v	359
15228	2vbvrrkS3DcJjTY6UBNJHhv88LnEZRFaNYtJ8ZPnSEy1d6zGV7Bf	359
15232	2vaE9o5BP5GCNvZdDhMcKAvT59C2U7xjyXUW6iRkSB1c191URX7D	359
15236	2vb64nhyYTqkW1NHo69BBF7pPLn7CPMJ8LDDmLHuUwAeEajJXKwo	359
15241	2vbbnZetUwDGLDqojEXVomd9SHwPNQVGKRbtj1znk22bXpQMnj7x	359
15242	2vb5CR2v3g7XsjbUZXvHxARq2UNm4b8rr3ZMBZ4CXk462RV5HDqq	359
15247	2vbdG76CTvDGGvMfEgxyiYCZMxYWRatEGxzhV145QS8aHkHUNzFa	359
15251	2vbNamnMBT61L1nbhR1YbGnv8JPi9qLdeGiUXEEh8YEWi43cftfs	359
15257	2vapLgJueZKGKgHEeZ3tVkDGRzVDjgsq7abxVuQ9NSfrNKEZB6DP	359
15261	2vaHHWBnVLkK6Z5GGRPbwLGnLxM66xNLe7KP4d6aKbZqbDfooyie	359
15239	2vaU9awinzFTGLQ24Ri98XF6YRK5URSLg9VaUrU8Bn4gWRUkwQuP	359
15244	2vc3vHLmDxF28yb3ohqz3Kugozm9HAyZSWS21Lp1a4D21m21ihpt	359
15245	2vaWNy7TCLTmMW6dBqFVzkE6xMwAAWUUnpnW8tdJAei5QqzVf1x4	359
15249	2vahsnnxxUeyTZNc3JZbe8u2J35LhSbXjyv3VV8Yv6beNP5GnUE4	359
15254	2vaC1M5be7RrwWgqa3JkjEpbrPKdoT8DuSgzjaG4p6keYLj9LBZv	359
15259	2vaoxahhpzKzfbbY2mHnedkn3t34spDgZmFL6fAUP7Zi6T3qvSgy	359
15260	2vbT5J7AnrjKnHoH9uuNPSH1oBe9DdfBmaDkbDMyUsfSqxt9T7Xx	359
15264	2vaBqJreGxn7F3BeBkxSvVAg4W3R9ukZWmodY4K9mkoypRqLpfai	359
15265	2vbEESEqYpqgfRoMdEW1pKaTojQFdeDjYQ8cbtMMRAAuzrNGUBK9	359
15266	2vaUYja6GkD74TJ4sq4qTNw2AHTeqnQ7SmMg5W4a9Xbmows5WY2E	359
15267	2vanPWfvHCs1a1tQyyKsNZLCPgCuLV9khsodsU9FqpGEFzVVQZQL	359
15268	2vavvQkDLX7vqPPd2BPe61ypkc5veBJ4vjoS954rdkprH6fnfyfU	359
15269	2vapvcpbyMj9WALokWgT2mKEmHCEntAh5fA7kBythmayWoWbSgLL	359
15270	2vc2TpPj5ZHHcmob7mMeSytTAHKhKL7XvRY1sRB71edSUTbZ2Cgz	359
15271	2vaGsXvg1Zm9yGBc4otuEEkt5ksSrFbfKruwuqxis61WEXcns5eg	359
15272	2vbUVRF1iBMLtLCcjdfy2nu5aL5mvm7R4G8RJnwWNy4tPgQN2KVT	359
15273	2vbTfEQFcaHZ9uLNAV6CzdXJcGiUbj5HgnRQ4NbVf7ix6KH6vqnZ	359
15274	2vbiy9kzftZ8FfAzQTU3W3ciXecwfpScv3xDVa1Za6kN3h3jqBvz	359
15275	2vaKM9GA2ZXopW6ZAGdvtXAkXTwd1MATwCQ7xgcNH9DCm1JLSeNK	359
15276	2vb5TJQbq4MG15skvnXQkL2N6pxmCqLBHsK3oDhVj5Ng1mYfB84E	359
15277	2vauQgkN4nug4hN6pqJBzUT1KZkXmRiHXWALsNCq4FFq4dsvyJsF	359
15278	2vazfadmurTiLUDP8ZxJVEFyfxjocxQZyRdzV3wiVnjttkjr4vcu	359
15279	2vaHa9YKddCPYTX9ZcB3d6i27EpsTwChFn1QL3VUffcesTZ4Mp1R	359
15280	2vajqRNc2czUMggzi2KSqaQ31D5vF8WBim7A2mkcSkux959xGczc	359
15281	2vb7e9AqCqkD1PhUxZgSMufN8gNi83vRJYKFxKkXY3f8aQ4FqYJX	359
15282	2vb2fcnfTE431cxSYBuQUG28rUAX7jv35GT9eSvBUvEWLXnmfXF6	359
15283	2vbv2vrQqvbPZsVR8R9CJWKNxGfcX9LxPhhaxiGKWmGvJeexFKLf	359
15284	2vbsiV9Fax86DL5hDLHvFgqfQ5RoAqJdtpXN4CPDFPU9ZsoSuAAX	359
15285	2vatvY4CZWSB1VN3hyxH9PPx1MP4Skh1HcZj73gpz2U6netCDkgG	359
15286	2var2DbEEf2yTQkXua7T859MU4w84GYZEtPyD5mhjyugWrDyyULA	359
15287	2vaWCGw2EhbcwaXJazyr9Yfrt3ppk2X8jbjZuZ2Dt9Uw4s4mKBjT	359
15288	2vc5binR69VBqjSMoaH6PcfWnKz5QZ7WT3eK18Y4cpfFSfQ4xDjt	359
15289	2vbMpN8ZUXMTcTHhjYdQ5KqjpbEiLsHuRYRVMXtxwTE1fgJtjxSP	359
15290	2vaWLKobDUwME71ter29JyJb1Xqbk3Djb388w8J8NKxEdnpkU27Y	359
15291	2vaZVz1PRUUNQuoGbUy9vqsxDJdY9Ta1tSaBF9rQAufdah2AwN8J	359
15292	2vazmXw7B6faDfVBi72j8NyqD8HZBnyPsAbrwrrdJu71rHZpiDPA	359
15293	2vbMf3M5T1FBJc4mpuQNL5fBwiqy735DevMDkKRjvZPj6ECkZNdW	359
15294	2vamjYEiPzqJezikBQuMF3Bmfu9e1mm2BYWjYap2s71mCiWBsFam	359
15295	2vaeVtW83wTeuN1Lka3oNim18NxbMfdpSY6s7e4dVyTY7eiSi92L	359
15296	2vbfTGDKtmmjNBGene38bmxFRSpUm73PGxy3ptCw8R3gniydSqAT	359
15297	2vaGuDKd5LTetK8emjHPVBpP9CHnPzyTvc2kQMjZ6bM6YUumb8y4	359
15298	2vbAXHB3o6BvwRBQwXrmVDZShont3t55A2xUBgSMxdC7AzizUUHs	359
15299	2vaG1QY91ZWxfHWw5rjLv2oHY1b8aunHXFt32BjVKuQESUGGAov7	359
15300	2vagShw9UphVRFnRwFW3FQaJADWidTwsFP7R85LPXZkYsZhtjE73	359
15301	2vbgCFK2CeCbCedLJAvHJhSA5gKADonZEvQsCJAGuJ678x6zFsTJ	359
15302	2vaak2AuQ2FhkjcTmTV5Smm4TSPfkLKAK7RDat38Y9uMv4RYfYHg	359
15303	2vafib477kaCRyQq9QRMdnfuVnQmQZEa6tUYUCTtfG6H4ZSvYmFK	359
15304	2vbxEkC8UzhohHrFPKqBzrQpvMCAmwwkPnDzw4ffdAZ2AD8H94cV	359
15305	2vbXcQ55kBr9MpCXN7ff13vi4ji5ZU5jbeKNEUNSCMHLM25gro28	359
15306	2vag9QUhEVvDbGKpbMMscVATx48C2V1STF5n7m2kmQEmYHGqNmfX	359
15307	2vay98ZCqHD79rVjSctWjUGS8uKf6NWsixaXr7dpzxedi9ynooqW	359
15308	2vate77KRFZ8DCMvyCY2tBc1TMMtiwbNfViDhgErS9uz61whoMiu	359
15309	2vc4KtaCgxMENmajukHmhafxxHUVyP3hEZBa9yaaJsXYuYDSqZgp	359
15310	2vbZZnqVNUuYpKu1fvb2buz72rSh2wrCwFd4RuqGACfMLMg5v4eS	359
15311	2vaGDHYN7Apw8vHKZ6JnzuE3k6HZJaECTP787jBvFhy2iVy6JX64	359
15312	2vbWySEmMijZzUSHCn9sic1Pynm38ooVwZjKNMdwtJhg2zFvnh77	359
15313	2vbv7zEqo5moNutKJLCrhkPtB1doffQvXRCXe8X3spmDZoWVpoL6	359
15314	2vbLCxyTwmHC6ZNg8kx4A87Byrw525dVqLWdabGCBfKk3YqTuo3j	359
15315	2vbZc1eWtD4DA725BmdrSNskGYj9ZQERCkSddSb5F9vsekXDqwu3	359
15316	2vbBcaqZ78EkALKATNghh36SF7BsoXz656NbcsFggXgtNxrytfhJ	359
15317	2vbGMM8ZVJWCsBsM1cSdQLot9ou8rnXZHTdfMEfZi5mbw5PeFAFm	359
15318	2vaypisJpkE8arCUAr5ZT2bdod6BVxM6iMKZK9kcHcVXFTdmUqrY	359
15319	2vagTJfrzxXPtPLbEEYVRQStbERGVGscfeFpjyMVWBf7RXr9oXLo	359
15320	2vb5Vxab1jjojTVTN8S565fvmo4yFCWttAYStkTNz3wr5YtT6TM8	359
15321	2vaLJ8oKEJXjfu6RvEZnHoauDDRXD2q8AgsoYkCY7UMfi8X4CZg1	359
15322	2vbwzhNFGRVnPquC31WJN15W7Y7GTCjMSEsTcwH9aaESR6D1giPQ	359
15323	2vbC4E6Ly9kvgiMzNzVtq172cBbKNP1UJivJPZkAG46dnr8fahvj	359
15324	2vaa1uxQUN8umggGfKs8qGuFqt4zDaHJfXjVE4qpZBC9sCgRPTqY	359
15325	2vbdEot4aKW5MNabQM4n4jXdxFfJsMzhkTdaWFRE9itx2rwPVAsA	359
15326	2vaLm7wKxn1AH2CM7568vQmXM9Xy75sojNsUqMorc8bPSR7B9Ces	359
15327	2vbS9xFjQuEjLP6atWi4KFjabpwNBS9R8TQDD3LnnAuRx6aan54r	359
15328	2vbStbfayPWCMoBHHfpSTsk36oe7K76VvBkf668rhE8CB1gRNKRB	359
15329	2vaMk64AfPUumSwF69vA3u3Vu3n3pKk1D6aB1asVR1GS1TWfgiZF	359
15330	2vafV1YYctMPwzbQgmXDMXKUYJdPe9epMx68etyNGcDWfgDzmZwi	359
15331	2vatoqsvMCcHFmP6KAQztNRbBXRkfjJKofHF2sXrTAY68qLiLHxu	359
15332	2vb3ZJgbiwyEkfpPu2mC7RAXxQZxzXBGZzWK1copq9pUMweCuGG9	359
15333	2vby1HQK3ELW1EUwcGL33xyXaQymbFiBdfXonHL3uUYdBvCqizMp	359
15334	2vbeYUtkMogJFGqF2QNjKXvQK7EiTtWLPxhjB3pCaNzj1rBqJ8ne	359
15335	2vafwFUrCi54kKkrsPQ3VL5KsTnZm4kpy7uddT2uxnyCq8UxVqjh	359
15336	2vbbZoXzV5K7Yk3HuKyYoDjBVAGmweU5s9Sr6zLS2CcubQBbqftS	359
15337	2vbvsjKUZJZZWixv77BXdD3GveL2hq5NXHkKWS2CEr3FZwSwbT6V	359
15338	2vbMGuJN9KMhZH2QRo2L7A23rYGeS57RhY4Jn5TdP4kKtBAJcS6q	359
15339	2vbRvy94dS285gSa9Q2BnHWb8qxRrFhS3iNigs26HPPgNyPor8Ay	359
15340	2vaSN912ZdbKDC3DjQuonKpJrFPMHnGws7n61RSZcBXHjELZxRVN	359
15341	2vbGr4Xd2Sxaga3vnhBmCtpLUD3NYnMSVmxDLRFRnwvtvBHTqgmZ	359
15342	2vbhXMsx13kKsNLZaCjFT1kyseRGfmgPVthrkXr7jpfMfN1hwvaA	359
15343	2vb837EU52aB7op9mT8FrXC3J4GwvkMT59FA2vD1UhNCXbX7ScJ6	359
15344	2vae1s5KhtWa4y7hrZ7kBoJLi7Khd5aVid6B7AKSYFeKzcM7rx5T	359
15345	2vbMKg3wDDepmbcpkZH5szNzrBjzJuFW3a69UWvzgCqjKVZ193sa	359
15350	2vaR3DQXmkmjqLoERAEsEYCt3nLmxNhaCGRXg4Pz2D8SDTLC7LQ6	359
15357	2vaFNFjLKY9CfH5UzjnjrxxvzaG3wKkAsATQLHZ9iWxZPgZEu2VR	359
15363	2vaAadSPNR4SFDMy8f4LB3b4Ax8jV6evDcX2Mn48SzX1V7EvJq13	359
15367	2vapbtbZBMM8HBPFmb7b5mED9uJbsKwek948v7mox3ehsazCmCrk	359
15368	2vbRj7WBqAHvbQuzD1gBgsjx3cXA5vnB3dinGC48Jwo11L3frzMY	359
15369	2vbeLro6xLvVE43sGkv2pTTVjBrPhNPu4CaGG1CxFdN6iJhLKRcf	359
15374	2vaDDMQtgC47wx4RFKUjkCQKCJcmuaxYY1qgH1PqLtFAbeq8vp6s	359
15375	2vbnHvWHStZjaWZrLTEDqchZNZ12o9HbxnUtmkaAqZZPXB6jaL7J	359
15382	2va9rBK7rfYbScoEvA2x4ztvvfgLQ2CwuvnBX5DqC3L7sTApVUbK	359
15388	2vc4VRYau19mmTFHyWPP3LHMUP7113bxkknYDvnQAE5AbA8yq1Fp	359
15389	2vb4y2ufgjSg8Z35VGi8KpwbsPRtbESxiH2RuoGYrk955TUEDn8U	359
15394	2vb7GkGDCVqM5y8QFKcTKKPFwDkmLLxBNww6HZ4cPajvY2JSeds9	359
15395	2vbYTdbwdv8n4WuZ17gDvriE3Sp1JK3J9Wkd3HEefPthdh1ks1Yj	359
15396	2vc3RdFbNLiVDjnbACUhCitLEtJ2wCquiY1FEwbqyEDxJDXThuo4	359
15398	2vbeUhU7yVHcVQguWipoyqtiLsPqzqefS7vPSPfwfFQ6AGooVrUt	359
15399	2vawbkdZFqZgMZc5bYWN9qzd6QFSGhYHkwhyL1gQ2ppqRA2B6vz2	359
15402	2vbtACgLBfeK5nxSNQuBPQnYeXeKwCfcACBo4zGyPJKdCcPjgPvY	359
15409	2vbyjEnB1BKm5zejatJQpBGL2H4Q4bsduvuGq94iky66wpRUkLdt	359
15413	2vbqSgpFvSp6V1Z2B2rpG7DUwSjYjji974L7w7PqdavcDLZWzeE7	359
15415	2vbgLSL2FreYbqmYeZERpv1nnSXVmdvEB5QorMsapqtFH5kCkMS8	359
15418	2vavWWeQNWA9iWQGZkUg6eNaQH3sTazAEUpN52Aq98HL5MDhtarF	359
15421	2vc2DqyXgMQCN5Ck72tMfEzNAQgpNsUEbKqiahQgt1uii3irhU97	359
15426	2vaq9CAA5uJpS1aQtCu1CfFfFWUZWoeST5n4oCZL1XtzYg1xo3Bg	359
15429	2vbSruMYnLsxK2YK6pgooJ144PuuvcrFnvqLhAKEx8PKrJZC1yV2	359
15431	2vbEntihTC9rQXWz16k3RRFRA8cfYja3pYG7HCy3nnghfytfAvL4	359
15435	2vbXLXHbbFQjFMwRGh8zs8eNQhw5Zy6iijcSPXTfNhVCkffjz5xj	359
15442	2vaMyvLA3seGxHaEy5azbJ2qfb9UqXo8HEcLRL6BCepYKYGZkyba	359
15448	2vaREm3zxo3muFaixm6yuipXSHj1djgXj14U2vCktf41FhY5TLtf	359
15450	2vaqXyhYqjKVUhoFnxA46Y5QY7DWzgXVZSVkvfQapvgPMhB6orVX	359
15457	2vaZ85xjVwngThj2fC9zvZocLgFyiv8qzR3AzRKGLZnnWrDG9iaK	359
15467	2vadRj6fXgWqtw2YosjtX8yYmpEif7kpGJS7rmGh5rrXgTgMam39	359
15469	2vbrnPNi83PDxDHCgfB7vuHYqSJbvXvEuEKDp8QKvsCmmtVDHhAe	359
15474	2vbD2pNLYKkbWxZUQMb6fYe5eeWx42hswou6vNTVkwhX2SQjZnKU	359
15477	2vb4VE5ZfhgnJSgJRXg8rQbshXgFYozmhTWoAg8upgD6rNjpeTmZ	359
15479	2vc3GXjA7S42UJ6L1oukCxWA6oXF5iCHebRDNpM3HmjFgv8EL5Cg	359
15483	2vc3rcEqTkSdkbEPRwhDBADZhFv8SWvhuod3ShhzArJwnp79o2Wv	359
15485	2vaHWHmrdE4Ck129Nvghd3y9i2GwA36uSERVdPJk3h5H7PF7GdfU	359
15487	2vbWDaZVrtqKv3T7tVr81Ho6wh1bXzyPXv9LuEJKbiJTWBm5i3PQ	359
15490	2vaf8nwx42GBP9wUK8rarnGJBvnwc7JAiJ8StgLhbra9d46Cr2HC	359
15492	2vbaZNKGipeJLkck16SdyLq6ZnN9tQAoMehdbxe7QmYN8kWuD5s4	359
15495	2vajJdKSmByWcM1uPNqiEfgccEMivzdjQNS6hJy4tEiZfYvPgeLq	359
15500	2vaCtJsuA7Jg3j2JVfcMRkPsAV4TZsJhjcjT7gaMLCQJSud5znow	359
15503	2vbCjqRCVGZTYoq4LmHAmzQxndkryyhc1Rf2zNvXZ3ktWps7iDx3	359
15509	2vanu9eAXAufpEBxJFpFtTF5Dp4UyT7QX4EyhYxznUAdzgQYzBqS	359
15531	2vbatmuNWpZ9SFa9o8i33gAAZDQoNMiKys9Qr9VyDu4F1STHvuug	359
15533	2vb3mEi8zCC1zEEN15HvsxqXQCjzNmkfs6ayDM7QPNbntMTNew6j	359
15535	2vacudUvEKygAqeqYui7kYYnKi92jzSbFHkq1ZGFG2PMSz4txpYJ	359
15539	2vazZf8LtSWar6v1bMDn2gNVk3rJqthZGhzANxkJBMuxxGPcrDHJ	359
15545	2vbbsRgRsZ6dky5GGTsHCyMSYLWAFk17pJSrmL6NhaE8BXgCbhsy	359
15546	2vc2Tquui3ArUZB6Sv4stHfmpt1m1tuYoxZDWRF5VkMi1jYEc64x	359
15552	2vaK2NxzvbVEjXgMoemEpdTQjBCKoB5ChPaP61PCsgk68QU23KKj	359
15553	2vbMNH4M7mpfFkU2cri1PLBHMpKq5Hfi3dAZJyNT5qYdR8uAHMH9	359
15564	2vbZwR2NUGADL29pexNAv1Sw4UJGLTGuyJUKSB2EvBUYa8asiDLT	359
15565	2vbmrsq7XBMMud5am6A4aUKWrwihH7EKvcjTUgynPrj8SYqKBZss	359
15568	2vc1bVvZnughPjC67pYX1tVhTGDweR8GN6Mz8EKJcJL1Vii8eY2E	359
15569	2vbq5nywh5JsRRdkJE587EavgvsM21FiWRSuhnG1zASB58xpTGfv	359
15579	2vaZn3k4NB6kFxScbB8cM9tBDpSjRnrsu7FzcFGjQncxw2vqGhb9	359
15582	2vaJKg576bXF1FGbw8h8oQfisLt6CUHx6HceeowLByZJMJSEXDaG	359
15586	2vc2TJ7wLufu31MSNb3LHcWDeWuRygZnKS76zUUdZxrZq4preBYD	359
15593	2vboL2uLP6mzipwfAgYxt5EPyeeZwBotkTmtphfCL7kYnnsncP1a	359
15597	2vbVWMqkTFkMdzcdbWpZW6w1TrxJ1ZWhgNv9p5vL4EBvaarBcnPb	359
15604	2vbg88DnWJ7ahceDzekhuQ7XPWySBMEkP8oAQYbP9JhpmaAtsJoj	359
15607	2vbfb7C8QVaudA8mWeJB9e66jpttr7X8r5rimF39zrX9QoToaZMj	359
15610	2vbs1sxMv76zj1NbLgeiNfv28LxQ1PDQjRYM1tuJ1u7bz1fZ6yPA	359
15611	2vbfcAvuHU4GvtgrG61tJU717tZ5BoJHbmqKXixiip2XxKAA4uA9	359
15614	2vbyku5GZ6rHaErGj3xYP6hhehcrqoJtNWAxnRksogeopupBQgJE	359
15623	2vbbVqVdzGv9a7hwXBC4RGo5krWbcQTNEYLonHybaPo1XMHd6mV5	359
15628	2vaGyxY684Mc4XMyLQDHghc4YGidZukqkLKizXQAqeeDBhbtCQKh	359
15630	2vbLYo57ZcFXhQX9NaYzFwWf7PZqA2M6RZdd8tq6L6YLJfJHhP49	359
15635	2vbWe2hagZaBqgsbeWtqmzSS5qdK9WCQ8XHGf4RmxbNmurUjQR7M	359
15644	2vb8ZFCqqFNRbH4mSUjJzAcYY1VF2Tsa9gV2vsQ3EB63QPdSi3hT	359
15645	2vaNkFMCNQVtAXKyuTzEvj65mzowSfocWgXspoSCrHiyUqhKddtg	359
15652	2vaS6rFeNmxPSw6t39rCiWjzqs4UjgvG8FikmV6oLQPZ4gix6aVQ	359
15654	2vbyj4A9ScEgk5V9gvMCZcg9EHbrF8pMqzzoRS2gJXTNQL4jL4eu	359
15661	2vbejGiAXFxKoYNjLJhvvZzWi8HYbj2ofzdQpSnZyCb7noephHG8	359
15664	2vaATJ9uZ9KiZqET7meZKboFjugeFB5s8Ss9LDiDTL8Y5XpkE5zv	359
15676	2vbN4o6vs69n7GCwbbhQw21QVSigP2WrD2eMeJoAvo1Eq3rMfHX4	359
15678	2var5eySbxKVQnwPcFUw9Uz2WhTzi57YMZcyg3rEBZpZN9WTsDhT	359
15694	2vbY76F6k1srSq8dDMkSkyRqkKMGaMBUm1gcFKDLUYdetoKtTBmB	359
15696	2vbXZcSzScon7LV5KmccZC9uauU6uA2fwHpjS4GQxHLy6tamtZ3a	359
15699	2vbygQAMCfGATdMTGhdYqa5nWcbbcbZyrCeREJTJdJzGT33PUZTM	359
15700	2vbX8qbL7o3ikBJSQGjJyxC6zihR6BaUrQzFnTg4cdEunZjjx6AL	359
15703	2vbX7MXJSrfPW42grfeHPPTw5p9vH6o2fSnBc1Nh4ru6RfyTrQrx	359
15709	2vaBfK3ErYxhP6z1icZZWbGhBRpMZJ5cTpob4op36K8ai7tDntE5	359
15715	2vaQZWnmsifxvU6xh4FsqYyeqcx1hBAd2ND9nEcAU1FjXDF6yDLr	359
15718	2vaMocACxLoKhvmsytgT4w3jUGvPCFoYqgVHHjL7gMutEYXeTipS	359
15722	2vaFN8zWwz6FUNeFG8iVEPxmhYTaAhrfWdJhKp3kJcRddznYER7d	359
15346	2vbnES8URMEuKx45bKnaLCW8gRKovfubN2vN6tHXTxj4C3t3CfjF	359
15351	2vaMkLohMVqv6Y4iBeSVwKpWUTLY7m5emveNKcbwsHnBecc4uWAQ	359
15352	2vc3qBc2CTkJ6eFCusEDEr4gjaU9mBzRjA3CxKy72Dy13K8nUju1	359
15358	2vbGBqKkab4rVcEayd752x19bbMRVKKR4rXSSXNovpf8FeUainvZ	359
15364	2vanQyMkBzb84irmpbgSGtrmf8KvfsXP6YJfTcN5o19sfn3FoXUJ	359
15370	2vbWkFf6jMypVmZiwbADaD5mZH2Emao2DKpyMWAQ9hgpo21BCJvp	359
15376	2vakWxdre7xqjut8Fge1ECZWRCcBb8xvnubNi6c6kj575R7WSyxf	359
15377	2vaTCh4nfVcGqNiena7ZS4p6qfUNLPWrrGrUKZoMn42iYNTPS4rh	359
15386	2vazsCeLdcdyKEnAucxHhGQqtTM68Wk3aSg6JicTirrYANhxisD1	359
15390	2vbVfTPQdvNtdLa7ibesgeJS7YTV4zWhGB2VpKidb794MUhz3uJz	359
15397	2vb5Vv4YJzEoUFnovK6b13iL8KytjsC5gTKBnyVv2DZxmt6uJ9E5	359
15401	2vaDDviG3AZCsM5wry9G7js1oCDxFNepPoLAmQPAURoRdaoUzGPL	359
15406	2vbSp71dVZWo4kyPLK2fYwHpz9ZvXVQHi1MwsyQh4BkDWE4tLNvn	359
15417	2vbi8Z3REfzDBqSETCtSxtMTgeNd5XVpXD3H9q68viGrbM7cK3zw	359
15419	2vbkYsZifDCTXyQigatdfDkUTMNt35jat6DQBkTwxZ2sxQe3aVX4	359
15422	2vaSrjVggJJo4A64y46DBeeNoHbQvE1MVZw7yb2CYXebZgu7gTb1	359
15424	2vbhT798v3JVStSoD2TUpQi8KruaGMA6z5AkAyBGFW3YMChpmfvi	359
15427	2vasLVigwj12JajRuBnH6jajigQXWmAtuaEHeiPSVjF4etHMxp84	359
15432	2vc2n79dHzaXzMxxeeaBUBeJ6qLJZZpmexpHuETUGNHt4L82f77N	359
15436	2vbea354erChwUXQd5FJkBLWVhuAMA6QnvrA81Wh9UURvhNDNsAn	359
15438	2vavinEBP628m7MenrP5scr5U2FBpDB3hoyAq9YmVG9HtQGuqbVK	359
15439	2vbx52Y2EPZwH8iBJiiAT4u623WWuVyon7WSAEv12ahTaGCj4LD6	359
15443	2vazneYX4kJb2RU9NqUjMsqSJr2ch1cESE6ENGL1bg8SWo34bZne	359
15445	2vbp92waKRaFWCPT7D4QPePzw1QvJBv38dUKTSgcSAREQ5rgXpmQ	359
15446	2vb6U1AEy5JdRCdmz6nFfkawMTLEtmLDWhiNYSpxdhBPnwJwwPGW	359
15449	2vbJQQ24k92wLpHfAHr2jiBWbN8Qi58zviqzrJtm9ZXHkFQ9Lrhd	359
15453	2vaz6jyHfTugyG9Fq3ZtsxNtCBAqcLAUocPfmiY6UawBntDjXXJH	359
15458	2vaTq8DkWNgoAeDv2yX4cJPYp16M6ojtNnkK15U3wyzDQ8qByy5M	359
15465	2vaNcDhqGVFG7LJW4Kq1hDCHhgTxKNWw1KuqZPJT5yrqjLuHXzcW	359
15468	2vaPaHiMUESRQ3R2Vt7avkxHA7eTERncJWyzNtho2CQnAk5ywKdp	359
15470	2vbYQ5zwBtavqGXQ6fttAMY7c7RkrpdRELALLyL8z3YUYwykh2eB	359
15482	2vaNRUyB1FkZjcnVvvPqoYEdL4NcUFuiQXPRXf3pdtNfhLTD53jA	359
15489	2vbiKxVUwEj9PPcm8YSrw1DVLmmSE7NpBRkUWrWBMHQqM3cHeK1M	359
15491	2vaBFpCqvkiDEaGoojEBm3mAwcPfEJWKyjrCF5yNfqr8GmHdEAVJ	359
15494	2vbtGq9y43WLz3AQsdex5c7zXFTgQpKYsGKvVMbYALxErskveH5b	359
15499	2vafpkTZeEsqTbkc2r2ausyPFCv4H1VbteMtHs334G5M5bmvANqD	359
15502	2vaYjSV1LcQ2PWR4ijSWbqVFQ4tbgszWW9HzUrxT3TMVFGnRxfSc	359
15506	2vbbYviMvkRJzK1wTeEfGuVUqwdrAKMf5VxLuLCEEzyENwPb7stQ	359
15508	2vc2bQhAeS4fgLaXKsMxpDUk1hjSqamQ1GStkTTAa9TzE7KkaL5P	359
15512	2vbzEejpPvd61KSfnpDP62rhB2TnLCu1PRoDb2ejrQH6XpdnycqF	359
15514	2vao4fXEkBNxp6Ws6CQ2mJE2HMEA4qEyBaU1r6Yy1vjt8pLVSakx	359
15518	2vbHPNcuGApbNgX7dAbhqri8BeL63C3v8GRUdTfTFfEpvs42oi79	359
15521	2vaf7kGkoEfUFQjZtpCeb1SSaZvtKzHhYXD7sRPoqE8GkZnfUiqv	359
15525	2vbDQnBYrgbwRCJUzaWknLuQUUxNyj78BvkdfvMcNceYESFAucox	359
15527	2vbjxUB77oFLXQyqJza1zmFKinqL5ZK3UuFiCdnUDfpiWseGq28y	359
15529	2vc2Ywy9xxrcFCibucUw1xnrsEW9rvaDMcvjKBC9hykKZevRqqgV	359
15530	2vaPQo7mxJtMcc9CWuyxvJbwMzdgyqjNHaJFeNoTjawBJJQfvBc5	359
15532	2vc56NcsjybKNWU7kTPWLCyrsEeHh2mngojjW5E42RMQ4SUaB19X	359
15537	2vbuC4RuGH1o8L9fuo3jsyAY5FEgdWKw2nSsW9qUyW2bCQ1aysu6	359
15540	2vb4gcp1hrVoxzzfb3LwyxwGsN9QWqiUPnnAdYrxrg7RyDYGdxXX	359
15542	2vbkUfEFWHTqqWKPBn2WZzaTyZQsFvjoYfEGAYau8rSvCseKrx3m	359
15547	2vbHJXPkufU99og3erCtoULDHyuD13iqkgbhM7uqaG9rFZ9N8gn6	359
15549	2vbD9PuT5EmaqDDDsbJPJXCoVDDMUMDTYD6DVZT4yUW8ScyWLQzW	359
15561	2vaGqooGFrFW6iHgNKnwE6NXiRmFR1LvLYprnwWoJRoYBGqkGduM	359
15563	2vbjPpT1YemiVbzL5e4J5c89fwEWPB7ibxNaHYsRQDJPR1KJ5oEW	359
15567	2vayo3tpjCEQ21W7Aoo5dpsuUZv8Rm9EH3cedni2pbrsDesLYVKe	359
15574	2vb77oAbkKu6w2TWmh4rGQWp5sqMSDcNoUGvFK9AthBgtAvEhc7J	359
15576	2vbjWhaa2rAphnU9rmYmyQejq6RDcGoU59CAigC5QUpoBGExPiBp	359
15578	2vb1AMiUjP7ATx9pa7MB2hGGfYa4FqoD5UqkngF87m7PKMa4mz9g	359
15581	2vaXEP4oKV3uLpNkEWfLDcjs318z5b6rCSPQk9izNFNWJ6SQxiLg	359
15584	2vb9v4nWFtVnrSmZPRsZ5AH3Rf4bWY17mCGjEUZjhzdHpiRDXewm	359
15585	2vb2VyHeZswKqaNirh9oUdB3yHCEBkKz2eure4vGjHye7hSQ2gcM	359
15596	2vaYrdyZohjfT1XpSMmLqwkpFggih3bantjuF1mNQ61eaR5ACkxy	359
15601	2vbwvwjJWjshpNkjv95Ng3VfrqK8fnkdNnM6jzpFFyHPq7zx7Ug9	359
15603	2vaASGjdR4gjjXbLoZcA7EiD5vrLDMuKsRx6aN58xHjpyCoD8RQe	359
15609	2vbc1pemxUh1ZDy4LYLnoTMe59gwhmd7xWQ9ed976qc6vwUb4pMt	359
15613	2vasH3fLd7V6nk43pN3izsSeERjynF4JAPuq7rusCvTsS6HriAzn	359
15616	2vaLFP5Ruyysrkb94CbZdGVXR2XvrAqMQB89bfPWRy6d7JKWXAYK	359
15618	2vagQhZ1JGXq57PKtmDZS2brU5C3i5JPHjc5w6KXmtgGa38Z9ZCD	359
15620	2vauBsB7mTvN2hozTxASjauasznHQRpRNhodGPzaJ62mrpZu7qBK	359
15622	2vbTpkW4Ke5vCTPNDDz2vbvs4MH77LU1vPs21kPNBkNauV1vHU4j	359
15625	2vauB2rEfbibKXmZvktByucPaaJ24MmxxPFn9oWwwhtTmHvZnfKw	359
15627	2vbW7ArHHg7sYQ2ihkFBsja7NeeVgH27MjrLEvqJpYNKbuHcSRNw	359
15632	2vay9MaH7Le81dvJn95mcDrAkjozzkF45qGHS7KQCW1qyBTD6Met	359
15637	2vaxCLv3tfsGMDbBxiSDBUPqaRmep1j2eFwU6WnjASKD2MJGKZnn	359
15641	2vb3Qxiw7tEoJeFyLKPEmbkbJnFhYEXCtQXRp5D6fm5Gg7qp14a4	359
15643	2vbJsZCPpmALgpSVLEfjrKSGGPjpog8zdxLtrWvpFNVSFmhQFHmc	359
15651	2vacauRtYsdX9BogTVSEX2PRk7mEVk7BwjV4J2sHuMHscvcbhsQf	359
15659	2vaHNRxbtqiU8rCZnQvKgdp1kmC2QuSjdHVsmBU3B31yBKt5bUYv	359
15663	2vc2NYCAibzRRCDKT5zErzrAtozzVYTi5A46u7BfpGath9aQ6mAx	359
15666	2vaT29DH3M4XKNegQKhisJ8kojyqVVE1M7LUXeriFczSVELNzGf4	359
15669	2vabuncLn7ZhRQKzAfpkNgjkHLJyLQSY24jpaKxNLEnNbcU2avwE	359
15672	2vaYMUWV8hd3FxhqKhatvjet3aM4SBNYjjuKyNz5Nah4PLDGkGoW	359
15675	2vaCH5GUNQX8t2tjpZJE9SYgm6yTtwr4wCzrnc11orjsyAJCZNSR	359
15679	2vbzBqMQUtYmbdEmb2mUN6MLQ4SHs4PrTy9HZSLkG6AasuBNX8r2	359
15682	2vbTvSNZDPRQayMUSxLr23WQd3hgBYeV2Wf1YMoE6mxtGFJAvg7b	359
15683	2vbBAZ6W8Gkvqkrb6iPFVSHN7ZR4dzHkXU9XGES45siAspMwYi4x	359
15686	2vbzkqngy2JQ9ip2fs8JQaqHcUe6AiFoVpuszMwxo5ZnyTei9D8K	359
15347	2vamZfMVBUpM6MY4f5sFaQLmWbLiaefTJW44awyhJZj4hbTxg4gd	359
15353	2vboeHZnE59Mqq8odqVKTwf2y19wFDxZ2VNcofibaoLgZ7qBdqsc	359
15359	2vaAEFfAzapH47AgvxVocTPZUCEBFYZMrpGRqEZyRuz2rGD5KR25	359
15360	2vbq2gcJEGnq3C2SzYTRXpeXULpVgV87qAsUwvqdqYDmW7oW7KEc	359
15361	2vbFJjbN4P2sdzU78UioFRpNrpSp1xZT57wLeaG9JLB41qZJRdyx	359
15365	2vbUg2HwKE9FqT8Bd1Y8YCjMQHMCRjwQjEFKW7pEVq8pazA3jBog	359
15371	2vbFAPWBjrc9cZCWTUBe79ha84zw2vK3LmgPetHEijyomCsknWRS	359
15378	2vc3aDCiq2pUnpvqj7LZ4ATy1n9s9vMzH7LvaV3HtjsRWB48LpTe	359
15379	2vayQbSZwSURG1sqiEeZWgAH7nyFF2XYGhRAsn7g7ni9R7aYyon4	359
15380	2varwkxvriTZQhoEiQZni4XNKwb4Gepc793uP65PrijHkMJwSzba	359
15383	2vbfLqEdFM5yScRDffkvN7WAfM7aX84m1CeyvJDeCzQMqxpyphPj	359
15391	2vbXW2JSgFjAEejbUZwa7TodiKck9qyCP6GCsSjt8hWFL7hwmZKF	359
15392	2vabQrJ78XLPFkCJGMQfa9hdzidfsjMcJuw2ke75fdGn8YYjRk72	359
15403	2vbgowFPThKizJ2qGv5MoEN7mSRsB1FSYhgswgSeLgrvGdpVZvZt	359
15405	2vbw1DBAKSijEXnk5gZxw1rrLfQZF4Ze6sn8PZwrSKrzuraGeSr4	359
15410	2vaoNtMjmq5VbmzMSPkgDCmLeUva51QMaJDt29D2DhhPqprdQGHn	359
15411	2vbj5XDFSrnfiJRuGESkt1o1yG5kETpnEjRFFQ3Afvn45rKzt1bB	359
15416	2vbxbGrj2yLkiUKpfuXf1xVhrVDStxDkuDnEJSRqbWeGwJfuBQjA	359
15420	2vairaCEFiNbXDGuZ9jETCdhbTtdnBrhSbcGCxD4FrZEyRpU8RM1	359
15423	2vah5xrkmz9C86hgzAjnhQiT4VXyJcbvKEJzKsE89zxTy1ooMQ4X	359
15430	2var6uaadCBYMxSAYKJz5xLnfXSo1569BZ5duiNYjysemZPw26SN	359
15433	2vaXby87U3vE8Z7XGXEP8K8PxX5kqLhicrw442gtZRQdczPEE72q	359
15440	2vap6NjdbdS4oefQEokj5X75nnrrLJMhZ5Hnv6bRWbaSyNxQHFR2	359
15451	2vbCwnTovWijCqjQPYPMRsVaYXRqYgefyrKzHt7z7Ba5WxZyH8vn	359
15454	2vavi4bnc6PkZyFPMjYqUbB79YQ2x88MXXKBMHvUQb8x9MbCu4pK	359
15456	2vbqLSpX51taTJ9T6oNSE3MMxASMACZEZNrfUfTtz3emZP17FYMq	359
15459	2vaPyDiCuyYTHsLNhzcXMLktHPn5BjbcxHmwzHzuL4no2BXEy1c2	359
15461	2vaWjGLWZRsEpcMWdNR1EkNb6TeMxnoUmJVik4zXS1EDkfdLvgHw	359
15462	2vawfyLc79nUKpBbFgpSdzxFcbFffNCgMGQG2wBfprN14SM3gSjX	359
15463	2vbL4XJpv8xHR9AkPLG7WP2RNUrgoV1jzk3SbBnzUqAEYTkx4ftJ	359
15466	2vanWn82aVFv2KtnGjRh2VXXfToLScgfWeAd6Gz9g3nVpm6qjyqR	359
15471	2vb6FcjcAxzq1bboRT5wg2seAnbGXmFdkahLVs8FywJGCD3Kf3fQ	359
15480	2vagmNaT1hC8U9NaXVqf2siTASyt1KoNEuoiBBtFFxhHsphRnde6	359
15484	2vbpUygLiuBtjodW2k54gYDPsBdYJAQR8675ri9dfnjC2hNn6u7o	359
15488	2vbb1ug1PiKWXjzeuFap44pqJFQC7gUaZTvkBPC1mj41TchqakHm	359
15493	2vbdNdfnopazohX47TecnEmZBJejCAxkoTE6utwu6fqqSu1hdpc4	359
15496	2vbfEkaQBv373HRNK6XbMwgdHPqGF2BRWKzJJ7NYi7kahsyDvfNp	359
15498	2vahefZ5KM1HwjLsmbrZeJ54fxDRXYCiCc7eecB6p7dYVyxAhEDo	359
15501	2vb52s1FQdj24onxMPzQbY27jZz8Fj8MfEBQRtKS7MwBsAueKBcE	359
15505	2vbfiWDNT5BofiV1ybYcxiLwvnb4NqWaeUFqovLmNPEDUjt6Nou4	359
15507	2vaWgVgTY6ah2hDRkb8cVioyfEbQyojaKkDZmm9myBHB2Bj7f9G2	359
15511	2vaAUoMfB7EGCqENGZdsofdTxTUMX2vshQDrpF3JxBntAogBfWj4	359
15513	2vbTv2cZ4FRRHkHcoZ6roBPr9C8f9GgDu6Q21LmNt1uGU98qqzkC	359
15516	2vai1djmEN6QX9EDYPxfEagfUFN9Fg8Ta8TT1vS5276DRdVq4jnX	359
15520	2vbJE86DZf1bpbcv9LdN9HUqA3JZMc5FTL3yR9W9vXnqFV1Rqmmh	359
15524	2vaueE8Ep6XfJtj5e4TfuigK4fDpW8qfecEkcBxznijgjdPGDWgY	359
15526	2vaWPzTGeduBouRXQrDsTDZoai2x8KLHELY6yRQ4pZEmSkqJtJuS	359
15536	2vb3h1KMy3dpjoTaC4qkbgd17E65YX8U5Xriwu7oc3GqSvZCLKb1	359
15544	2varrSLtmJbaEfgrnzoVGoSYJ4gTB4bELdxaAk8GEutzhrvj8Auv	359
15551	2vbHFrUMy8SsjScbHnkRhN8KKCAQ8f3HYL3DcxYTgcvPw5WbBfSy	359
15554	2vak9h3PD5HpYLwwv6MP6SQrTEhBpNuRr5GxFC9mfdT7g6XC5SRe	359
15556	2vbGJZe2Aec7Eh2RxSfMD7ZzfE9nvx5pcYP8bJgNay5aqb9UQPph	359
15558	2vaBC1wP2Gad2dYf92taiY1C5Sum5P6MAB8cWitiSGwFohhm2u5L	359
15560	2vbQnkyCFHHk2LH6W18WwFN8QVqWwYKoqXH99jky5CpPkSyemgyB	359
15562	2vbSBZWhWGPh3vqvcCGwVtjC3qDM5m6LnwSdu7m46XVvR4phwG76	359
15566	2vbDmHgad4sY4dDfundi3sEhktYjKwejUg3n7AcaGxLTCnZZmAjn	359
15570	2vbzBFGWmVq4VUGBQYvDi4NaJatUcGvNnLqQwXZvRSVnc2w5i4LQ	359
15572	2vaRzcDhdRK78z6SQH1gASbnRgeMxEMk1EHuVpV9X6SNJ4zT3ER2	359
15577	2vaYegFgBVQyJLWhiCdpQ2jUh9zpJGWj21wco1taahUkrWnexvWa	359
15583	2vbjHh2wEQT9vBfSJoLSiF9BJfYuszd28xxQoWYjxDW7and5zqGQ	359
15587	2vaetWWXqqKYn7JdAjwA66hFoFNjxqzzMWm14wdrBk8V32N5giYn	359
15589	2vc5gg8DTBsL1thAFiAmtEyKVx2Wjtksw1pi7KQHq8VBXMD63igj	359
15591	2vaFMYR7U1sBv7amPYdaVNzb1C5ycnbWKVzWUC16qc6ujPWCR6sD	359
15594	2vbkVn95ihhuF3sh1cvJvJNdpMqC2GcPWYNwts1zV2kY51PCgJ58	359
15605	2vavuJRHHo8SDz68qDHL7tu48Hb11VrbxumLoo8kkYGQRm1hkmbJ	359
15608	2vazEjrrAxov6WUy1JQjvkp3MwNcqUnudnXUwhkjxJize5v1cHqa	359
15612	2vadfzkFH1gtWodFEWUQHp4K7EKeuLmeMni5b3Fe9yDBFbH6pufG	359
15615	2vai2wVhvHFGfqPfEEQeCCuV2aEEqujZgwohwFRp96gHPoNVPvWj	359
15617	2vaGdRQfpuh82YMMtKmg82M7svBdJEKazboQfYtnB1UvZozL2ajH	359
15621	2vakbBwRX4nyhpcSteVjWt4E56C3n8swxQXKWVgwWXAoixStSkNG	359
15624	2vbknzyP1Nb1bVtqRjvByBoaUqWpfPN4VrpzfRy3tdZ5WP9SCgLX	359
15626	2vb2FS2d5Dt8dDuin9EsbbrJ7x5ws9FDG1DqZfvW3bKzp4Nto1Rs	359
15629	2vbF6sauuaqSaza11tKvCiWBXkM7exDqbk9FrvXtrGJKtZT6xR9z	359
15631	2vaV1k2CE3dHiM2ZEikCBQBxMZrzEDeAXzmja85kR7WLq2uvwHYh	359
15633	2vbGTv6hoDFoCBBnaNeNPLcZkbtcYrMG5qesh4CcHsksRw6ZCw8p	359
15638	2vbSyZRFgVRjvv1uqMU5PfGKo5GEPaV42ecToDh4hBEcYZeNr4UW	359
15639	2vbAxumG5Fwm55vqMhZt8eRqkoLVx16DjyPMQPNEUNy8pqusy2M9	359
15646	2vaUmLTs7MA1qQhmrj2GaWRFsFMyszG6fiuDG9R1uaPqSDGoTzvk	359
15649	2vagP7zRqhHWoUPxLpz2K9qZck7ZCKYEf7PWNjUPozT3uzYr7SmY	359
15653	2vc2guE8Y5m8JssCrJwQAJYFdBnETUK7pNZm6j9tAUxiaeWMsnoB	359
15655	2vb1MBgraJabKP6jBjvM3DkwZrF9EvoTnCh79QzP68bQJVSUzUaG	359
15656	2vaGikD2qHnnVAnJuFvdLqhJvth5rQF36qGgv5Tx5cVnYTuXJqLV	359
15657	2vaBcCXChwDi1nukuCNy88r3tDaAbbUU61uvXuJQpZry4dpTjo6k	359
15660	2vbjMuZL8r127Gh3mHY33t1uq48L31ua1VFq8DYf1q7iyMSJB1eC	359
15667	2vbGn9YzvtTN69LWRcJGXidWDvD9urz8AWYX9XyisTDnNtjyEPmJ	359
15670	2var4FisCkFPfagsiQABqy8En5qH7YE284SKwQZaw9SLrsEB5rR9	359
15674	2vbD5bfaX7Qy9AM2PVmfw6WiVSFyKkthnUpUCF7Sf7GK3py8NUrt	359
15680	2vbAx89TcN2RcvqkaBNvddZBPLnN72qUxB93bJorKvPCq2Gszf8j	359
15348	2vb5RRS311znvTGaS99nporZuEJoUqXNXa8JJfkcitQVPddWbTru	359
15349	2vbDB91VquLUx2BEGGWH8y7tuPQBxJF9fe7RbD4Q4SHqovccDJMk	359
15354	2vbmZiLoDxrNTU3kQirrY9iGc1xfZp1dftcTDoXUJMn4YEn4ski1	359
15355	2va9pub8CX7XGQS4tyKDyyFW84EqHqMegpmXGdABmDBdtSiDrBU5	359
15356	2vb1W7KmG7mLt1kSAna27FsjXBe82qcGKtBaAW7aZCD9RaR2tPH9	359
15362	2vaQNuCP3EeDvYoGDRPY9HpSLA6cqo5jcQfz4reGhCQeC3v3547g	359
15366	2vbifjpLUzPVafYR6uDTJdEdyHqPafz38fDzG5srQrco17ZzmKiB	359
15372	2vaE5rwErxak1v2gkParvzLJqn1UK6WKnUdzPAERj4ojmEeMgQwg	359
15373	2vazGTSeUFUo9KW59bjNtUkFH6ijmcZ7HhuJ6h93nc3cCHrAQcSn	359
15381	2vahMHU18u6HngL7s7xd213jBUCGpsvhxGdYQPwmR7J1Nfaw6ziJ	359
15384	2vaguJDDkfLbZMeNMCJbAg42JH9be48MRbB1dqkyeWNRgQJejpkS	359
15385	2vauEVWJUJkmT56H2Ek2aHk85JUYCtuzMnQkNVJEVtxiM7wFz5nc	359
15387	2vakgEt6TxzBnxphMS8Xk7iNFRBC6DfMYZn6N4fosnZZ31BD2NKc	359
15393	2va9d37XYjvVvbkbUpLaApw9ALQKvvyaMkaKJfFBXJJ35HErP3TW	359
15400	2vbywgCdcVKWQH9wTiBE9yhhDJe3B5TKfWdZoxVPwSC1ZUd5s4VF	359
15404	2vaRCLzv5jpXxyFk31SURtEBaKvcrBAT72U7JAHM3PXJjH6t2Ddv	359
15407	2vbBh145AEiFVwEUfQnsgp5NEFKkC1Yyrpv4LLTW3YWnTPRsVbsp	359
15408	2vbegJWD6i6HF7DBbW5LCmjmk16YsL8bgteco8ufjY3urrzbMZ5d	359
15412	2vaKxf3gXtCLzaTuw6u3Lw22b5vU8QvWsV7VwFuEvcQSiyyjer6j	359
15414	2vc39YgHeTmaxmAVTSFhjrTyZG3C3L8VsW8HhuiTWAFJYTdCHVBn	359
15425	2vaiAteocLhLmXnaZxkBsaNPYVf7sShDmEewJj27EmGusGXabQdr	359
15428	2vbkh6iKmq2kHGw1HKEQya3EtBrtwQQDpQW5bYNaXDgkqx71BZx4	359
15434	2vbmP6hKDYPftZ1QVZ2K1s6bYsJnAm5napJ13cijiAb9s9zy6CBW	359
15437	2vaMfeSEdkaMzU949coTZQDViCCewGi48B2Gj58Ncnkud1VdaCij	359
15441	2vaHSTGu6WXCrxRpxqD7XsPw1AZ6KaAt9249pJSZ4oTfRGce3Uik	359
15444	2vaRkpTc3ZTtj3K6hfDkfDUTWRk5CbkurtwbJjxYswyS7iYiYWxU	359
15447	2vae1svuYAERSgc3qgBseygzd9noLdcpmrsXA1cStMmiYqoVJe47	359
15452	2vaB3sZFzvzjN3SYSpw6Sn7CvLozzsxmgkYJQ5kHqNfmQoVt4UEf	359
15455	2vbMUswwyAfJunmhmzTzsDyW2FkjkJMtkZQRjxzqoB12SaoP6ft5	359
15460	2vbTJrB49krMvZ76Wf8twt45sck6dbaraYnp4EC5yVisrm2eJDHo	359
15464	2vaVwzk63P8nvp5J6cYnXNFLn5SmzneRHswnvetjZPRpVftW5191	359
15472	2vaTnmT2dspLUrazLkAP7vqe4EX9xnpWsNzJP8JA2vL3FgQ7VjF4	359
15473	2vaSnFNb3j8sB4CCxXiJJNsVzKpaf7EPhUJYCAuW6uuSEnSUgfCL	359
15475	2vbyWezoRuhgX1C8qz66eWPQSRV7ZwaQJzFHCCb2ZGDyHcmNGEio	359
15476	2vaHKjzkp8LjzUqubdDzT2HoYAvb3BeyvGomZmQxS6xF52DgDm4g	359
15478	2vbsGXoix3MgkfAFtQjYCKtZthhrZYdGB7i8PpL8T1Y44L5s6F5u	359
15481	2vbzypHjdtvkLFwVxka7kUDzsUHTCf8uaiDF9KevHMv7dSUg1KxX	359
15486	2vabuTYdJsqVvotqrASXg2LZqHtsoYfZ64JC8TMFv9ZZFgeJqnrS	359
15497	2vaLvAQ3qDVRyqpCXWJCnbeNJNzkrYgsiup17cFa6Kwf4NmzTdxi	359
15504	2vaq3U8CgxRd6YWrTzEhiDAvsQAKBinTz3UuEunNnPJgkhixSZ3U	359
15510	2vbSpDLwMirC3F9cHpE2D4aDTdnKkJVV5NV6bvXt6u2jUw4uGgjP	359
15515	2vbbE6ZmhktZSjmhtKMSVYPbBBRGr77aFADjGVkAWviVfZQxR7bu	359
15517	2vbU1xyFWS8yANg6V4uhpZuMhPf3CSfE4XRayDeBr6Uho5BjbjSA	359
15519	2vaNbnSZjq3GMjRt9zRb7Tyg4MAFqx9dmPFgRmh1qVyvGgD3sXXi	359
15522	2vaHULsV827QRvd7WmApPPf5MxxAZmKc9kYiudfQYXAaAYQs69QS	359
15523	2vbWpDP3UjcxdH4adp3z7xpA1Y5pkvGq2t7Xk19i9NC3Zh6eWJrG	359
15528	2vbG4HwHkmBQnFedNhnj7zD3sKMe5VWHrLFYNaqVcdAAVheQ9vBn	359
15534	2vabysStD4JCN8nWTCJDnSf2qxrKPCfxoLuK5PoryPnEP4JHyDxf	359
15538	2vbXP8Dp9Lc4XKDDxjSZpXKoHb9GjDEXmDdh9hp2Wz9DYmD7vt9B	359
15541	2vacbxmpnhYaUXHjjTmhmaZfreCdMCjVCqT3kDZYtzijeFS5WLAb	359
15543	2vbYZH5uWS6qApGCnZmiq9GQ7q32mtH32suzzPdKNCxehko3ZmKg	359
15548	2vaQkBNpSDVvBMqMBH4pkwnL25aX6T65SE3QyNuFf6tLUqJ1xmy9	359
15550	2vabe8NQWecWKUMDQkyeBj6mJBv4RoddXfxRZWwpsMnF1vTSFdwQ	359
15555	2vbcjCzDHWNBKLEKFoyde95bL1N9Pt1yTXqsTd8szGfpnZAwvn55	359
15557	2vbmbEEUHAvT9U8eGo1Cd3SEeFKch8yyUBESFVpnWagGLBxR1pCE	359
15559	2vbSnZ5Apvo8nHNwhfowAp27upABs2vJzzJChvbVscy9KGkwCNdH	359
15571	2vb64Cgc383zmeYdW6RXeE6nDojPgQSSCxR1RPFingxdrztUPKqo	359
15573	2vc3UPmGsFsq5BD79Km7cKpKmZSNaEwwZNbXhSuTJoqNepESzTYr	359
15575	2vbe2ykJH1xNMuejQBdV9UHs5Sjcu5MabZASrxQDZBJD2mJZ1cbR	359
15580	2vbrazCVthX4KURDAWW4Z39jbjFnf1B7tjuxxdv7nFCqkWXn82ky	359
15588	2vbVp7VwAv4WcvuB5PATN8LA9Cx6gB9MAt57kWmbdU9MEfXrUPDb	359
15590	2varfmSzTfU6fUJATw3CBx3gTwhqKk7YfXGG2W9u2jvSAhT9TJAB	359
15592	2vbA81HPML9wjSE66CekagRYuyqjmwk4qTmL9ZGvgq7LNA31Nx3m	359
15595	2vabZhRHGhRiDPMGz9Rc7egqfTxkUzD6GX6VpS1n84HrrHLyPYem	359
15598	2vbsXAG1CeUM79oQ3n4x6aG1woKjSLziM7QdgSYUM1MC4qtN91YH	359
15599	2vb63x6RWYsV9owjoZ86iV5FAgQ5s5KvAB7MDd2NfvfPb1d2ChZM	359
15600	2vbmQ863DfSgt2JrHqr5AC1u5w2tzMi5VsSEyyGwJHJsxY2bhgJ9	359
15602	2vaZCTpGiYztquoCSeCHqA3SKkthSFyaKbkC3BqUXXyse6biqEgA	359
15606	2vbe4DTkyDH38kvvFBSPGexYzVdAMYZiCCYoggCKovtYAeofGS7T	359
15619	2vbqYJD2CP7KCybdqQMnDwKbxjnxTdjhnetWzwssQBzECaZJr9Rj	359
15634	2vbqk4zxry22n5yBJ4H3CE58NA5BAkJ4oqnzxnEUkm537gvRe1B6	359
15636	2varYgfzCH6dwNx1Qdf2Y7Za1P2exAHc2Vgd6DnFTfvBG1mHCoMP	359
15640	2vbbpz6h6ZvzCZHKFuMRRPXReQw5yE3FCkAdt7fHpbeAYsF9kgvZ	359
15642	2vaG3uy8UCQaUY6aYE4MTZHnuWeZuCu3PRWxTeMgbZNL9rteq2vT	359
15647	2vaXNbgzFsyZ7TXGTAKcUy3dazW8ZUz8EzHZAXmq7jKzc97BXikQ	359
15648	2vbcakBQjsDYocpJDBsGRdzAQgeTCJRVFwM2iFp7M6RjkFkropze	359
15650	2vbCnnCBZ9SPAVtkMG8LWbTjvLe1oDKmxnGkETS2ds6Dmj7YS7fu	359
15658	2vaMBpDL3XGDQiBXvBPZhe3t4iQAgrGhwFJDYJoYLJ5DkuD65fvy	359
15662	2vbu67KubyEYVtGp4vcZrVHUcJfvPumK6cmvzDjGsyZttZbsPuw6	359
15665	2vbSErNm16vstZPCFiBwSvL8DLwH5rGGcso7yF7a7Rt1dTRKd7T6	359
15668	2vbMAthr28xuQkwR4x7c7Zw6FKENLxNWSMezYPywvukrLpuVvhZC	359
15671	2vamqxdu7bSwRHEV2QhMA2UadEzJEBgpxT55tDytyT4eB3kkoDYg	359
15673	2vbC525MDMdG4jWozUMWoKH1CMXQ1Ugw72dQqXVqw7mGC17Tciqv	359
15677	2vbWRoLwG6QLEGSNBBMjtEcR9s4uoVm7oaXJ3ruLecNUTbSG5Qf3	359
15681	2vakVDoS8yDMWTGSrABtLENEVZLfgFfCDkE2fmVKBafzLvCLjD2x	359
15685	2vbbwNnJwygUfeYkNvMu2N2igaUvD5FqVeF6xvk68CGqXuKdLvXj	359
15688	2vc2urwtLpgYpSP4HeApBcaN1Q8h5mTEvCR2bVgeuMTdWj6rdsnd	359
15690	2vbVY9rW69rGLWQATQDe8R9rpmaZ8v8EYef9nkJj1d2mVEBypd9A	359
15684	2vauvytE1ptd3emRreikutbosKwazYSJqyReVa5utnPyMkXa3jQS	359
15687	2vacX7o9UiX3KSQbp9k6R7UUdU6BDPpWYfKu44hVoeueYuH2mKYQ	359
15689	2vak1hDAPfQJ9gmKCXZemqJfJGNcb8XoEa3SyyCxk5S31VM6Vu9b	359
15697	2vbUtkkfsPaQWjZaYTG9kq4CJjpvDwYvdajLXPshZE2MVXnzLsVT	359
15701	2vboRQjQwVnibwHWFikkVJFXyizDQoqVYsCBzLJxV9QV99fg8Rx1	359
15706	2vbpATxDKcWrx3piLA1cKQmxz26RnaRm3qV6YGyz1vkDRJXv5bN7	359
15710	2vbR22yxuQRFLsG4hxzo1RMUPeLCYjieForKgvn7odXhwcnz7YVc	359
15712	2vc1EcfHDMjHwMgP1RcWS82kyZpGFhGgPxYrSG1t5ptQCtm9mnc1	359
15716	2vbnRb6eURwhaMDpUFbyxNSbpXyFkcUxV1oikpNYzdDhJqZo8eQS	359
15719	2vah4Bmy6RxL3aFG7X5MP1sMzZYxfFtJfZjVcz6zjGS8hdE91e5i	359
15731	2vb6uswYFfDGyLNVjwT8cDEE2gUBVBL4ioGisx3TwAHjhad7Huhy	359
15736	2vatBgRXe2KpuNnuXGZc8972UKtP74BhFWWGAhaQfSdryeyXieF7	359
15740	2vbcUMZi84G7cpMPbB6UnrsHS13Q7yxKmr1bR1U2bG3quj9wFMEa	359
15745	2vanRKQCrYC9soKmfSmREnboRPcrauRytJmqTaCQVzRhPajAKz4f	359
15749	2vb5UxKLMc8AM7xnTViksK4gBQcG4P9wXJjRqFk57dwi8iU8H7Mn	359
15751	2vauLQU3Y1Fijv5tsUTZL9afaRpNSNXCkZio7WCPTbLM2ZfpyCZD	359
15756	2vbgjxLjyFcNSLf8Xim4wi5gjQkZcx5Vs62rWJDpyaS7XFuWSqDS	359
15760	2vbWNc99B6gn3GZqRxWNcuZZxW4q12VLCa3W1Q6mgd68WNxv9Y1G	359
15764	2vb5npjhvSZ44qbUWhS5pCnv4vM4JnGWNrMKMJwYBZM4PNcx6y4k	359
15769	2vacdLLQC8Bzy5dcAoZ4JiKTKsVqfxwdZ5ji8kaYARHgZyub6fNe	359
15771	2vbEJ4nZ3j11UoBd3f71Lb8os8C4yMzzoBn2r3SteZzeyREAeYXe	359
15776	2vbg4HKEhnhAryCrMMWL6ZDA9vXsswaTLJ1ZmuypnbvRbJjh3bGM	359
15778	2vbqTCCzCizYE8H1XV7w5UpWUNWnSix1uE7Z59zd83qDz66eZAbA	359
15780	2vaEdH8ZeTagNVuu5B2XgmzsLcBRS4hryoZg7vFFdkVLRnh7Usuz	359
15781	2vaQG4jYF4nSC3ggzVW51x5i5bBycfhbo9wGKwQJ8cyqejrYUGz1	359
15787	2vaJxDc9ZeUL2eV7cWeHtKyRnvg5NtjTVNfYQcjdmeGRrrcAZTmp	359
15791	2vanEk4fZDpAXk5LvGQYHY8Eo9mMXtvdPsDAr63QW7t1iWUKpu1j	359
15794	2vbPCgxQAvqJ9FnoJ5roJenBLSSEZyaXsvaf3QzG3wo7AQz1zaCH	359
15796	2vbir662CLtPxuF5RXUFXhPK2AcchsPNEF6x6t6Epk5om1bFA9DY	359
15802	2vaGBvcpinJuaQA9CQF6oUz6wtBXQ8Lt1EQwFZbT3JN5P4ZRv1pV	359
15807	2vbJiN8mtDkeuJ5Td6fUs1psvJxpMrDQRxnRU3dseCTbR9sg71uj	359
15812	2vaGydD2Bt1HC59nKSYPvbJF7oQvowsnugMwBxeLSvGykTvipkSs	359
15814	2vaoUkiU2UNwS2eikPE4HQdPPLNYPsj1sy1NGEF3tL9j5dMmK8Bz	359
15817	2vc3zSSVCyGT8sqMb9ayq2PDZpawboRWc1vn4L1QoqoNCTYfqHHa	359
15820	2vb5nYiT7ZMwN2HtzQzYtGkSAfWY14EjWi6Yq3naxthxTjs35UjY	359
15823	2vaVi3HG9WMbHCoAKeEny48b4wZnpzjXmoTEaRUG3T7F1vGei6LV	359
15825	2varGjyCYMCfpu5m2pqJcFAjJWHRrQLFUaaCCUs91qupsT9DV1Pr	359
15828	2vboHogYHML1doTXcGUn8RWdUnvQfNT1xBPWL8L5i2HxnZVBj6s5	359
15830	2vaA8GUm8vqdrcWNsMRNeCPP4x3LH4jrTcTqCLXZMHjGeWLXBG1C	359
15833	2vc2gd2btV4QsGkv7JVszJcRwb3gMVFbwqVdv4n1Yc53NJRQZHfq	359
15837	2vaPLw8iwm3o83AbAXMZHmiH9PdjJ6PsMkbdBMiurAhzAcRQGvyh	359
15839	2vaJDK44AtEsGvAjL6YaaHsuvxHQhDt6yvS2c7mHL2tzgrxPx6tk	359
15846	2vaHGEQmUEZwQLzv3BnpbMWMUPcj1gMFZL7MDezB5nCFEZ5uYLJf	359
15850	2vboir5XAkCkk29W4zS6XwoJj2ef42TyATPyxgpbA2YNyqY2xx6P	359
15853	2vbjSYDjRC7gYiCqerEhjCzodTBUfjaNeARCCqu2HrMQY2f3u4F7	359
15857	2vaoReSyzETczLFp5tWf1aRP4xHjvNAeFv119ZbAum8ntjdF6FyU	359
15862	2vaJyZBNztzWAUc429DWbDnshh6MiGXSnQMTog2WkrLLg6unit4Z	359
15867	2vbbARQUdS4ZXjMbHT6z1ivSzuhfmTiHw8t9WW6nKNESE8WXkVKx	359
15874	2vbQeAKNar7MXfJEUFs1rZWazfEdDrSiua6DLinsvqY51iFkVq1a	359
15876	2vaBhwKS9gJW9gAA3MZySkxxkzvFmNs7jxWDogTsyMAYrZgoDFnA	359
15881	2vaKsHjbEtZoRoHJeYd3NwRy6JtbTAM6CtGwQZ533hkvKF6DtYnC	359
15882	2vattKHu1Bz38D1xHVDH96HcaGgkoh6HgWq55rY8qQX3wjTusRz3	359
15886	2vaD4FJWz3viD4dRRrAMT6VCjWtSoTbfLpkSv4JRpCEHanN18ew1	359
15889	2vbi1AzuffMCs57HxGcRLjjFyDpTQh9W637PVCmjs9u7aZMxbEmG	359
15893	2van48Jpcxh8FNRa1HtnoLbpU3GLJitX8P85NRKSn54R2NsSRv3W	359
15896	2vbmnXMgVbjAu6Gqz6w5hHRW98F3xxBecYRfb5qiQ1fnT5jrsQcf	359
15898	2vbKrtujqHkTWdqMrXMWJri7gBDGDmgraUAZbXC9Zd3cgScq2Vbr	359
15905	2vaL2V8nhsUxNkSA4hbKwEX9QBybwwtNyZ6yqYwyhJmxnP6ni7Fw	359
15907	2vbAw8tDpZxeB7xsrdQQ4uBHY6C8wiHZrEdnBdbqoFaiiPBihpsH	359
15911	2vbnYTh7F7o66VmhyDLqmoa8gQf9JBrJUbA6fWKBwEULTPScwmRa	359
15913	2vbzP2pKjp5X9BghRjDrBVJKUgzTyzenQcwD3P1rT5iFcsj2aSvM	359
15917	2vbdsQb2SbRYG5HtaAth61DXS9ranZpuUdk6cUfEzdLctfGak9xQ	359
15923	2vaYsagdL7ntMPMTHakTuGjAiyHNCbdpkwfxzSuApNKqMWGksC2R	359
15928	2vbhLGEozmPa6C4ttmwVrQ3oXhzYQNN57ptWFmaNdB4smqN4CdNc	359
15931	2vakHJix5yTsYC8cSM4WnQxr3iTY6NRNN8Cs3RgawngFuAiYuLzP	359
15937	2vamqQGkM1nE9QDJqvVCWT3sPn5Bf8GKHiEHQwWYfDw84QCBeJ2s	359
15940	2vbg7BorGNFkDPd1jgVowkGVhvH25Nm8jcpbnVziBUScC3ZU9TA1	359
15941	2vau8Hrb7V88pHvpTJ9WNs8LHUvpZaW5CvfeBKKSXSzPgm8zWbfg	359
15943	2vby32FbeTdd2RvrTteovfoQQJZGigpJuuSac2bPbBQTUkxVEwys	359
15945	2vbKCBWfsUNQp3bitBJDxAu4NUq5LGEcnL2sgiNom5ke6YymPzeT	359
15950	2vaNT2F3zGRoyLBPeABotecokbqE96xhRfRffVQfijr9T1hABSXd	359
15952	2vbcSDXwUeuRdbcsRjPGmfgWhspu1NqCqJV6hJXURekxwaCzRu7S	359
15954	2vaak4yk6bsJdV1moSibDrvxAQro2fwj38gXXHzxPFd5736pSYwG	359
15957	2vanXtYUJ25eA6csnaYTX8RM9G7V9VYR4rzZiZ6vjMuQg7uEEofW	359
15964	2vaSUEa3u9B1VKnZdmTKMTWqtXAE4JrgZfpWhUvFhMD1cMe3LQze	359
15971	2vbKfgpaiqsE4qa76kzESSqRxMmrQLEkomrv1bgw8Xz1HnEs4ZTg	359
15973	2vbJWizr5b7kSCwbwY7xYCdqfLzk1bNMG12WLgdSLJnMXxAQqzkj	359
15975	2vaJKY2akSYvG6kRrjcqP73vfsouKs1DSJ7j31DLkaJadE3GJZ4E	359
15980	2vc1z3MhKtDU8g3jFtuP3XMrTa3qVJMKaTGm9u8EPPEYsYMxZRMy	359
15982	2vbUdaLadCSh4wXiNteS7goPMcRwDFD6qeq1hLDM3nGnNQrNExKh	359
15984	2vbLcuFRE2n8pePHZHAQ6DpUYLsjwDPha7Rvwbw6EYuML4HJopRD	359
15989	2vbzdrL7uD1x7AM4iW8oXuLCJjqpSeYX9dneBTErJEQi9uycXf3V	359
15994	2vbedXAXtUFhGSQpex6DCYUwrpwQeU5qaLjRdHgB6eQyQHGYNtTP	359
15996	2vbDZHR12fmnMhAi8JZi6x7R25n8UwEnPKyc9P8sKYSDonyWKuU5	359
16004	2vbjS4YG3XFau6R7q5ptBCn77oNTp42JLQW2UChMMi6ms84izgV3	359
16010	2vbEbJf97hAgKsLsaVwPbfZr6Q3kP6ZyN6ZoxAMZMw4gxCsRypcK	359
16012	2vaAG6g56E3Xp4b3sk9UsQRkFcaa67q8zdx16LdHt9N4U6n93ukw	359
16014	2vbTXvrezZHPmKd7HdQExw7a8CFRb2FMBUYX94mSqRWetyhs5JZQ	359
15691	2vaZqB6VE7qJ87or5WCubK1qGQjvFNZRdfx5K3nRrF3Et6GKthih	359
15693	2vb3w3cj9FsCs8w8S4fK8maGbtCfimj6rDEN3xDGGBP5TMGncfTF	359
15695	2vaP4RSgAzwXMnz5rG99jUfJLJYFdyZJ2PiJfH1tov84afeaDqLC	359
15702	2vaZhPAGjatx2XqYGpKhpckJXJJ4woiDszTtG2VAXUbvozaJ3VMH	359
15705	2vaxejfz8XJUoJH3ToywKNPz56m9tK9MWVgXS26NnKqeXydroZ4T	359
15708	2vap3Bsizk8qwxTLURD7EevFDxcEeE8Kf5YCsDZuqsKGcGzFN3Ax	359
15713	2vbpRhA1EQTubjtXnf486hX6RC7Rx4n1dzLqQ9xS3gQaRMQ6zV6c	359
15721	2vaWbvJeguR6rkpjqmVZMukeewGXzzjZhqKGvT6KKdtTc7Ssw9Qc	359
15724	2vaPNnufwdTdnSmL1a7N1bERmFYZepFFHAMLZXhxnMTHZUdgmrbg	359
15729	2vbAJFcvH5iHdZYaaaQQpodsvUcYsNtfST3Hj3AbRyrsJX8tH4Uq	359
15733	2vbEaFUdgdLjTettiLNPA4C5ApcWwsuEKVP6aBnKPodFCTFHxX1W	359
15735	2vbvwzAX5EdbUP29zbozTffzMMYTh6rsy3KZqSVr4Hd7RnjithDk	359
15738	2vc4255ZdpatmPdp5BRyjWcjxwtuoyd3b61HXH8TQxB5eFq7ZVPm	359
15741	2vb3G2ShNB6wcC3SANMMeeviSovt21AsAci9pBkLcSp8VQ4AsByz	359
15743	2vbzybtgV3RSof8uQSdgT4r4upyLZmJKxRKz4roJwvrTE13kk7rp	359
15748	2vbcUwta3fAh7w7E9dyUwU73yBYmB6xhadGycr15uMvdcLh6kGdo	359
15755	2vatpGg6meGrAgCSDD3Kn9YxjLUbYQdmmA9fnc1qJgn1kMpVehMC	359
15758	2vc3e4To4jFPthCf6TGa2oosZz8euiDdPEGthM876z2pN8pVGoCv	359
15765	2vbZkbdJ6pFUqHsK9J9rKTp9CiEQFuTRV3Wvs8d9ws9qn6rt49o1	359
15767	2vaAqmZYyushCanBdoduVxwZxct55qLKfJtzx6UUh9g1Jv1PSBAx	359
15773	2vbp8jgvzN4gNLR7LQPUKpp1fvDLjA3Tyh5UbUTJnZrEffmCQZ3V	359
15775	2vaPhkk93GqBcUBaAMtmzJfVFvLd8fmw3axkDR42TRBP36THZWsq	359
15782	2vbSENBEYx4VNewSwjcoTsjfekUJnUggCS8taSGudgNiHGcULQUe	359
15786	2vaPv3Xh6Ci4JE3wCS9CSVd3LBVD2eMZGAsiqgxo7qwrQJUdqRfq	359
15789	2vbdqXXB3zUFxCwTJMykmyz4CKb9Ca3FG4a6dcURNbWb8Hf2QcDx	359
15798	2vaoi2mGDjjsC6uxS6T3zLgqvhsj7sgqvJJ27ZzqP8EqjVYaWN8B	359
15801	2vc4iBGgyZqKtH6gvcVM2WxaLEoxLuotNJ5jwZHHrguPrpi9ycih	359
15806	2vasqHyoEVUGHFcJvVFK23QdeP3WzATW35PbLZrg76nEjxKRBnj2	359
15809	2va9Cr2paCMdpkjZHDrtZdDHNbdPoQ6mjrriELvvZbR7CELuYj6D	359
15811	2vbxYtyoP16Pg92wT7gus8qXjaM6NhLn8cwhFp8Bqdry7WWPqMBB	359
15819	2vbiRbb5AzjbcwcjrF8mmUNxYYmTdx2b2jGXBtpfxzT6RpTo3ps4	359
15822	2vbxQUjRjnZ62BSk27frUoT5MEvbwNs15MgNWBMuZJoQQx3TZBLq	359
15827	2vbw5sib9wr32tdbJzPkcUYkf9wuVkFevgEVdFqs7xL6J5TX6ydX	359
15832	2vbhEXsXHsnLhRfewFKFsii8vbkxYx4uFuUqwurRJU32AJ7AX6m2	359
15836	2vbjopPawYynHGNohoyY9b9QN6nGYreP3FGU5oquasPaTeqRSMha	359
15843	2vaS9BooMwYAKfUU9Z8mN7hRMa5PpRxCKsW41yBmXTmZNA5Weku6	359
15845	2vawP2weXjM41bdFg6ov6k2SEHhTM8iomWXRBnAGWhyBAJFRSQta	359
15849	2vaDchgfLyS7kzxcDQWiqmsGFHhfuxXtBUwohC1S8XvSFT6BmCBn	359
15856	2vaPg3hHU5TrumKydbDeEYNiSttGiJrn1g3UFso8Rc4z7zwBcxsK	359
15859	2vapq3x8B5aJPbbfTzb3BXQr37tqzsXSGcA4gR8bMZfQLAUvZddG	359
15860	2va9FG3wM4LGZVDUJ57nRwu94CvU3Tw5xLFnWF9nksgWzg7m9AgH	359
15861	2vbbZd8xsUd5i9UbW3JLFJF9FvvWtc3863wLze43HowT7nsoCPsc	359
15883	2vb6bpX1eFjSNtQ9fS5FcnkiK439EJgP25vyxi7vyi5p7ZABPni3	359
15894	2vabEqP3weYSCaPXDUdiK3yt1KcZ7rSqwKBxYH4Lb3qu3FqYDdHy	359
15895	2vaf3uY6ZioN53D5D6FNgioMr5yc11pcixnJqQV89V7E7dAtbE8p	359
15901	2vainhCtHvTa7pmKqmFty3rvPnVD2Jg6oivGvpDMttZnV8WcXWtB	359
15902	2vaYFWs7XeLeqjZEL9u773pytgmbdEwkTvnmgWyGPTxaJkV5afFx	359
15909	2vbqQcNTjuCbyWiit95cXM14PetPeL96mZvN1AnHm32MQAw3i184	359
15912	2vbNQeyuurBueHg97HqqUL43VjanVnvzZhAiFP6cz4VA2gDBEm7H	359
15914	2vaBmixQcNUoyRFNkC648fWKM6VAU7iUE7eiZUfNDPZME49t7gVu	359
15916	2vbJnMs6jddx1RDqhzP7kLzbtfNEGcKVac3nSFnoM4TsrVsTfEzE	359
15920	2vaMeKyBxBBnWCycwiwioZ9bcqmgxpymU2bjnwrQwamL6agqCxag	359
15926	2vai1LzgqZdkB2FZL1s2qiSzfczh4LmxYx7XwZYBoSNAerbN8cWi	359
15935	2vbQUy3Tb1zKBn5NbQLEFGZfbQK2d6VuRGaF62j13FpJSFVj4ydM	359
15938	2vbtddVXR7iiHeMKyJEkSuqKAJf2LDKau132QL5cEshVFPjFupa9	359
15946	2vas4ss2zJFgpVrx8rkBXPPBQEUNSWydsdWkbgBHfuekheyyYQ1z	359
15948	2vafi8R8ScisXwcWRf5tn5UR6CYBWwohsutzAQnXBgvK14eTKtJu	359
15951	2vbqMqey9ihiuob7dLMDm5mBfLgo7599szZdxuto2BX8RDfNaRmg	359
15953	2vabeDixTrCqiFQyCgHnCZQt5kUPbeDdi8jjeTuM1e8E2LUw1UBJ	359
15955	2vbHFbaQEDNTwTvRBwPfMEdjZagqTWUe6vQsYgC1XCRNjLDnAKKc	359
15965	2vaKm5MvBbG9MHLerPzbHWvEgYp2hN8Tp32NGXxyihtAckJuSbRR	359
15966	2vaxW5KmSzXfhxAutrdvHMjY2DWge1wwfTUB7w5ZNKU622axk12v	359
15983	2vaF2vB2ViyWwSnv8GGPj3BDvAZ3wyxjNBUUEz88q7uFTFQ39x7V	359
15985	2vbjXWjqhGzwT95mKWsyaKzBJZUfs5uHdnERfsNM18k1t1cCrRTQ	359
15987	2vaAhjcT9yEmqNpAfhd3bN35e2EnRvmF8ym6MxJStq4re1pCjpQ4	359
15992	2vbzfb81BNGCkbbs7rDR5x3sY1CwfKvWuKVjtumScHc8UN5pCv3i	359
15997	2vbJxCCFLkihDjnoxdJoLahWcN6Rwj6mBhQxFSNf19kjyHQabCc8	359
15999	2vaymKWtKHH9iqfNSKKgPbEccQFg4iFf63U8FgCs7bQfhLyWdRQ1	359
16002	2vb1Rs1CmSAfohYDGKszt2fBeUGYwr3uurk9tatw2TG1rZDecgP1	359
16007	2vbvvMb57b56mNtqfC7KdxSETKvhnncemr35UzmZwYkYxB5nCXqv	359
16013	2vauGCmSk7soYrqoWjLQiX7Jy7Tf1RQfh7gmJVjyFiGFBeaTT7dX	359
16015	2vaAuN4yidsqfgLAV5tDCvY8DJcwDaDWFXfduifMNQpr8rckmUCg	359
16024	2va9zWPZmTLsUqQCEVQtNyFX4fMCQS9AvPK4bzsh6Rv94iWJmS5h	359
16030	2varDT5cuho4SLVco6hybzuGbVVECs9h2sDzBJNeGjHTpdfLtP2X	359
16036	2vbz25Vh8SgrSXMDwzKckt1hav83aXhGsqaSTbDy2YpwfQkAvfLD	359
16038	2vbG2f7t76vAagq4HgPJ4pZBFLLVPeh4g2SWCZG7Bro5aBNJxt9y	359
16041	2vaWdUibaZYZxV6cpWfKsG4AxmqmGK8xtH3RMmxh2HM8xbPxvkF5	359
16044	2vawXVRcQDT1ZGX9YJEbNJQfA4E8G4BxZWqmhmLKSchNzjmgYuch	359
16046	2vbnUae677xjZxo49ox9LDQjGhLk4sxY33mbJiKH43jS5ssBWMC2	359
16049	2vb2Ak3kF2anmAMXaEodFVvPdvi7GZoRU1dttGs8pPqarNvq4WHJ	359
16051	2vbYAsNv68VDsKJPp19zAvK1qGpQ24ivxmmFKaVKpmmdfV8moGcr	359
16054	2vbPhZfoHSD55QVqG2Lm2RbtJz4viFY5tw26tAaU9n4ACZsTwL7Z	359
16056	2vaJryf8iMf6TTqMAVsbxZcRtiUyJHN9KC68pga1yBzCnpwj9hjs	359
16069	2vaVRJK7qotAhFqjgpU9fvxwdVMDi8QNfVozswiRbcALkXzsSXme	359
16077	2vapvfc2vjUb86zCNP5y2aweibWLESCp3b1BBnnHRHgYQKtZjtc2	359
16081	2vaUjEFqRa21QSdtTTL5cNx5CHK7DSN1c4T5GVgsbxkH2NHLFrGC	359
16085	2vbZPHdyB5tmTLBW9wQKfVkorM3jN7v5Zc4xFzdeJMXTtMx5u8mJ	359
16090	2vc53gxRG51ejv3aqJdskAA2CnurW1hoWDdKEqjTpzRigPsbJEF8	359
15692	2vaBY9PpRcZ8k2faTuJEKR3xS4UwwbQ1YwFd3XjHf6WLJHfN6rpC	359
15698	2vc2WZJd1ioKzUFfZQmcJZaf1MJFxnTRcZFVywAEUgS7ctkgu2aM	359
15704	2vc4PDvcp1kEqGVMETQKZf5ERXDVuedDqsufBnRTExYrHZTxZVjU	359
15707	2vaWkbwqjEqHPLrkfS9Aa3mPMvZA4u1cQ9ELBhVj13C8h5KXGpmX	359
15711	2vbiEyYe9ehLQXKvV6xNd25jqsaZoZED4aUQAZ2SPmdk7uU25Sde	359
15714	2vbv9L16pCvFNugbxTBqtgTJ4GYu4FNLND9bh5Y87w8g4k7dwaGj	359
15717	2vbHwtsDJ9rKGoPMZ9PUHB2Qeop8QCBKUV6p9qXjwJoeXm22avBD	359
15720	2va9kAWZevamnBaQaYG1y7Wts1jkRopapVSLqjvKm1xaGmMrCeCW	359
15723	2vanG1dxPYxeuuAAmAHKrpygEzkFVSi2eqCHRUmSHHC1JWSHdjkP	359
15728	2vbhB31qvtEPTKj96zbZAQZVXHvo4quP5LS9BRnF9DaAa7sC14VT	359
15734	2vbkarzo3gT7Z9CJ8BgL4f8QkrNMTbQCexxCexyPUeQwGPgPzJzr	359
15737	2vbc7Qjr7kusRojbJ7QRCC1MArWJZg41aivPbXvxn7g5mfe3syjh	359
15739	2vaZJ67RLWMcjoUTy6W4sKCQoBGrv8Y7PisET4QzUdKvYvpyjuNb	359
15746	2vaHTtJvD3ZVBtnNCr6mtdCDrAX8FMGvWBPo7528DrL17HdZ83nJ	359
15747	2vafxxTuXfq9gHbhyv5orTZhbtre2fqGAe2ZL8ymJ5WYW565NS7F	359
15752	2vaKvH8RbjgYyZYUCijSBQ5kaNxdkg8sETgpSseR69G16HmDCmFV	359
15754	2vbot1MEV7yjBJJY3wgV7p2Yar5yFj1dnT6h7acJcNiMEiMvqnfQ	359
15757	2vbcRG66ZhrA3G6vjnSR9rB8JJFpyFGPZ7CSe9Rc5m7N7gNNpCeG	359
15761	2vc3UJsSwiUn8ktQuVDevHvEPWse4c3jcFMeFTzRvNktZVe9xBj1	359
15770	2vabsmpY1ptDJdb9eDAe26KitbYt1KcVe6VbqAkFaG6StH7oMxjm	359
15772	2vaozCeFbK9P3yiqa2QGZLDV7UgKibCisQDSFXTZZmeP4qqRaifV	359
15774	2vaLh4dPVFN6HcE6BzYZe7LnV6pynPHsToaNSKY6dGM4DaJj1r5E	359
15779	2vaNBpsGjpTPUjKGB27bBmEzM5Siyy9fq5W3JkC34WsNKcPBi3Gm	359
15785	2vajUMxLhFVMpiE6c8EHEHxbAY6AMFbcCKyGJ1TVyLDv24pJi5se	359
15788	2varzsJoszs8NhYPomuo8wsM7zyVcP5vr8sF5Lfhkt6pxQ6MgudP	359
15792	2vaZojNXJPqsQxC4hvZwyGGHCqzz1nEB8cXHpiLJR1KgoMP6dPxE	359
15795	2vaDZFQWvjDBw6H4YBPC3JvKoKhz2bC2rQ9gUV4kLex5HhqogPTb	359
15797	2vbENjL86TBA22oarPcozM9RECRAHot3XNqkfTBjouzd2eRjS6RL	359
15800	2vafj6Eer63TtADeeU2FJP3mi1N8yP5AE2mwC9GfxJSLWYrPiirS	359
15803	2vc2htvKxyCadefdvtYDZiu22LnooyyyySTNc2n9i2Z7qW33i5jk	359
15805	2vbgCwwcmjWSXn5iEp8Pn4YBcWUzPkFEasYCwqJ261AxG43uMTQ5	359
15808	2vbhgdFDXH8vyCUJzZxhwNPKicr32brK5tih2tjCu8YbrLh41bTc	359
15810	2vc4xGjyRdmG1ZM22hUU8mEUMdwahaBDEungsciXpKjHdZZifXYJ	359
15813	2vc3bwcbxBvmoyYxNpBCbvmgVE6rXNMt5jKZDL3RtJ2Fvr1suksb	359
15815	2vbdWD72GnTaMR7Dq1WFcnqtfbxE217MT4F4HBnukRBZtDYYduw2	359
15818	2vaRwJAXrH9DGGCYMXyHPzzL3CoL8Wi93MEL8N7qF82PkysmQpj4	359
15821	2vb6cYcE8LuSS1R5HdMMkDBJuBjw8syTCPjXhZk7UHVf8ZtaxAin	359
15824	2vbBpn5mYBsfzpeCMc1Dmt2NB6i95s5HHT1xWadi1YNm6w4g7fuc	359
15826	2vahWud3vbL2SHhwXNqjTPoCCw3TtVBM66R3FyQKaCKHDk7GNSb4	359
15831	2vb8tL94JkN3CjZNxaTy9shyyGxV1yiiSfwQEi4mQTRQUmpecRG4	359
15834	2vbZ7ZjJgCN9hZj4ejH62peZy14ZCfwYybEX2HvLwdY8qzW5SUzY	359
15840	2vbo4gAcx9udMWv4z9r8agPLiKqkHZ2974VJDQE4Um34qKyAuRKX	359
15842	2vbtLY43AukV38k6xyGPvhh46xv8EquWhPewNnGgmFeZ7EygyVJd	359
15851	2vc2iV6NsiQM6asAB8yXMPsZMQdHHaCNsQmDrUhZVFGq5bvuPvub	359
15854	2vaBjaq9qv4Cv8fbfdbjQY6HLBcNrhnhsmeJGKwe4rJzHb4PphL4	359
15858	2vbUq6xAEq7KYHLfs1C3NphiqFKLn2Hw1bfgKrJJX1FG8qPMF8aj	359
15863	2vbhjQ1Q4oA1DbDPiH8hzFnYTS74JZYMs7xWu5Ld9c36yz283w2b	359
15865	2vaPjFr2ynUg1mj2oq3F7XdStCYSqu9yaKKy7NDpfJX22KQf82jR	359
15868	2vaYWw5ZxqyykEF332De4W1Dd6e1pLXybg5hS5gqqauNtnq4wjXY	359
15870	2vassm1YmoESuTxesmBFLaYbPdQNA8PAXjG85pcx5KNt33zHQPgE	359
15872	2vaZafAz8FtViRAoAzhYerAHHF8sU7sJi8KHozgb12HW8iPxZKRT	359
15875	2vbxAg8hWTmEXjyVSoEugmyVRhLvuiVTfSx1LyMK6j8XnUdFMBoR	359
15878	2vbt8QzMsWErKdKGxEYkSQAAmnBusPJYxVkNfcx3J8FhmJhyHgkP	359
15880	2vaPAPamSuS2cxoXPiTthc4iBq55h69EQJNthFxDKRAPftJfP3s8	359
15884	2vbAXE1F1UfFPzgHmE8JuPsr4rp7H6A6WSRjiKToxdi9zLYRrgoi	359
15885	2vb3NC8uMnqyn9EbpWTKuVReMEqZtRgAsndRgkb4V8rvr4aaxmF1	359
15888	2vark5KxJBvzAyCUm7cNfoggiTAxt1ibhGRaepyZ9nETQiCBjKBQ	359
15891	2vbnW4tjXShbisAHzUMPDe2MFox9uNFnnLy64cLdmZ7onaMipztj	359
15892	2vap5L2Afg1MmoYeN8ovXfed7ixAzR7mY6xmgZ2s1rbGiY8msoEr	359
15900	2vadcA1snF6dFx6GGtfsoVUh8UBu6B1eNMaYY1UFjPbptQYjnfYa	359
15904	2vbS66uMK8uZYGTNT9hN3zBx5EatzgcyJFdzjB7r3458Jw2Rods9	359
15908	2van1uktWRG2cVxQFgMG8HivKgfZZnBk7tMit2MkkmBWTqRWT7wu	359
15915	2vamU6EKBrDBxcErVdDLS97oC27Wmom7NZYTcmCL7SSqNjbxNZfp	359
15919	2vbx4y1maUhbXgdiaq2qxUsefHW5DdszyBnHenXGWTZkVWpFLpg7	359
15921	2vb5B8ZHBm8ieaUpY6LKibX9L37KTXcehMFXUhpUTjYu34DkjKvm	359
15925	2vbF7KLM35fthnFDWmDRLH6UgV3a8tqU8eruH5pvK3GqQTzWZNpa	359
15927	2vbHtQPY6nqRBfuG7C4dg3qps4xL5Z1U34CFtA4iYrwiU3ENycmg	359
15930	2vaossGKv19PJvQWNwNA6V1Yw56PvzJrmvz3u5Dv99A849N5PvNE	359
15934	2vaYZTFg8zF6WmQxeD3J4PwuJq75A3PwhJaRAoSeGQkyBK8a95mG	359
15939	2vbppxSJjeQqmHwgaKnoDmSYovLw3bKon9wCmHzDtgv1eZCWsJqN	359
15942	2vaGaKxizUdtJqBXmDyELdXzys8e4QeX17yDNf1woV6W7D7HvZpU	359
15947	2vaavVK7ySGGieukyERN3kYPtpGFtYoGbhPf3UR6bUqNmBoKL4U5	359
15949	2vaa9aJcCpK3rzJaG35JVfEgjscYjKb56xZyA4Z1SAnFDomFN4U2	359
15956	2vc4HYe8DBRtC6MQuYBr6ax4bhV7kiJuquVUahV1qNTqwiPcgyCn	359
15958	2vbEEByEVf57aHyRLGfmUMJR3eXWrGpwRmQtXCHEH7miw8f1xhxH	359
15960	2vbwWsKgevTFUA5R8vzLM4dQuwQidj5J9a2Tb7PJZzNTJftni1Lh	359
15961	2vbeccD64wkANbGHoBnfCdbu8fJmYKrDrwxiirgd1T1QCjVwTTLh	359
15963	2vbSbi2TzfUhmLuF9ieth1qB7Dqgb9MmG3z8aUK27CbMJ1NwDCEL	359
15968	2vapWtuQW734LWumrjD9zdJA3tjsQks7iF4CADFUivy9w9AJLeTX	359
15970	2vb9RUTz4WuJfU8Bp57WVANvdyTjxEv6huMPgqZ4YZjzYBvMD9Kx	359
15972	2vbpSqCwFwWCZkbnnyP2gZqXJbRAHyc6H2ifeUL9oFVgQDiBK72g	359
15977	2vajvsHTvc1BcoMQ588hxU1CtME5Z9BuKJVGVu8dNyG18TYDeC53	359
15979	2vaD8icGxYUKzTmAH9c2vaKzKqAcDecP9W5p7rfWjJJ6DuWwima3	359
15981	2vbjbjragk46LfzkvhFHFFo9aFm5MbekzxAe3FeivcwNNcnHjPoX	359
15988	2vbWfLiyhoYhkeFqtYw8uGjyp8r5ZK2GmTM3RsLhsi5LCY5CtpAM	359
15991	2vbHhLKzdUrnP9HcHBwtae1TMa1UBXLeyvAMPVvFo63dFGmUUTke	359
15993	2vaTfkGCVzAhXrsX1J4zyQXiZ35saNmDNyD2hc2pVDb8aanvscjQ	359
15995	2vagdhgXK4s4iCbC2waYPhNogUw5eju1Ntcz7MWmkKBudVHaEUvh	359
15725	2vbY7rNKj1rwgJABGKGkoCBL2dnHQ8SamjpYS3B5a7sp4gUKZLZm	359
15726	2vbojLx1fZj8KY6NQMmCSzybGWBKgkyCPPBvy6L5ndsa49Dw21Du	359
15727	2vaHhnbVsUNPNAmnAs1TNVPw3DDvmJQqf47AQcyJYmdYyWij9gxd	359
15730	2vaPrMQxjSx7Cj1rK4yxi2cnkdJVrziNq864DYFPmWpsMzAhEAKY	359
15732	2vbAeYXxzt1xZZvtAHusZ2CDb7vpUzLABf95cMnzE84qo2uanuSX	359
15742	2vbHJHup1WnS7u38FoUAjf7xYqMG5adVzC3eoRZ7CzazpoAqf6fe	359
15744	2vb9XmHF324UTQaApRNhjDY6dmyaPHfN9PretLvqAaRxHHrU1k2S	359
15750	2vb9TaZp5txX5ym91D6BV1mSPdLoPQDGd7oTuhhogsadpeA75Wkj	359
15753	2vb4bpuGrRGwPiAkdYDtntF18KzDUTaqHAL3Pc7zLMpgHdR1bkJj	359
15759	2vbUgqaQkNmBC4v7XGgFVv3wfcP3MfKXBnmN6LrBthp7VKXUVZNY	359
15762	2vaHhdHZi4WJfCSGoLHpYJQyKQ3va4fKcjXZGkKaQHvz3W1vxWaf	359
15763	2vamkp3NMC5L8TRfuMn6LZbVjGXkjgW2NZSUGS2zsijZosvu5uT5	359
15766	2vaNRBUnnETLxEDUsmvW4TpCS2Cei93pVU4aoUBBiU4YNWQXdUrC	359
15768	2vbfaUJt2FUi2JWrBPUJ1piEGpcmD7arezx1W6EfqDqzGYdiojsV	359
15777	2vbpa9F4xqMCKZfTeVXRnrVyEveXASBBj5XGHfuy8fQtNMaSAfYs	359
15783	2vbnb3suwvFHYEV2VQN9qE1kz4u2g1HYwcZ5mnBRdYnuTDhpcKyZ	359
15784	2vb5aA4pLmAkV5QgjhyomNCE7U7qYegzYhmWFEE9YS66ZMrotyWM	359
15790	2vbTRR59KoVGEXHXdDv7dvfi2jaMPoFdFcLwNgmVXssJhE1uYsxx	359
15793	2vbmmBEH5UY6Q1ST9k9XVBV3JN43xEUtyme4Ezyte1ipA5EDQKDM	359
15799	2vbiJWF2p9k7bRWmaxTc7pw7t3UwAsADwoHxvjYAcbRYDR3zctr6	359
15804	2vaoPMf2v1otupv7JVHyPVuWKBPaw2dJBmkTKj4V4NEXxmUgvGDV	359
15816	2vaufMEdC2GQYAjfdBYGnoADcj4jRj5o89AizguYjoD9Rn6gpz6h	359
15829	2vc5q1zLMZb3CfRcmdnwMZxd3RkuE6s3WSWYMCkrqUXbSZeA5asH	359
15835	2vb1XjQuUKjLJgMJxxWUV4PCT3yo4nb7zYqUYtZPiUPAg49oDYGZ	359
15838	2vbb85ucDRZocdb8hpQ3KeEZbneCGSse8eQRCPudUBAviMMcbsTR	359
15841	2vbCB3zgAgbtAgJKzJZdru77PsZ5v4EM36bLSoYgXjanExYApA9a	359
15844	2vbs9fmhGYcpiuRcwPLhFAPqHHfBMTv6nkc2Rvd1kaGD6WB2bZ6z	359
15847	2vbZuFLzNktdfh5MCqkSsGAL2foVm4YSzqSeNsRfSX1w5qQNpJRH	359
15848	2vaP37neyVXoXxqeZrf4VxJ9B7oEVSuJgi7CzgQU6BY4iZkRAxP7	359
15852	2vb3saPiBnaUyxhFjwKTM3QeDVv2kKhiQV5VMB8UUiLVBq4L6mk6	359
15855	2vauvDRr6DKfnrb48LTeQehd8zH6acPARA47KwT7uj946u9FgsB9	359
15864	2vaH3C7s75SeEfx5CoY1Trgt36RVqwAs2QVLUdWwU6ZbyhfMLXiv	359
15866	2vbc1ZcJYPhzmsKzrQj46wjWENqfv6xfFnKccmBZjUo4v1uTgEk6	359
15869	2vbm5Mi7cwfNfG13ZBzL8FLFJq2Gj8fAweS7shwYpbWhSGyibTpJ	359
15871	2vbmBEDT61QWbSi6JLnLij87rMxu7B6KY3JtFvAwSVTNBPyqwsbY	359
15873	2vbBZcNMf6QKv8gkr4Tr5pS6SCohNgXJF5DHR11HxEQGaUcnG6KN	359
15877	2vaV2UEAcQT9J1VWVkb8hY3auodyeFrM4bQ7XkkHKGqnD6G7umL5	359
15879	2vc5LCRXpuSLaP9M5QuJCyFq6cpxx9nnF3GbWETaWoYFDBsSioD8	359
15887	2vaiSXAmVzx4Yy7GFhqS3S4c6YLKXtmEFAPMWL29dxzyJ8AfpuQS	359
15890	2vc24D3EYC71omJAbmNV69u7ErMemD2XCNDZXbUTRxp59e7KU82Q	359
15897	2vbkR8c8U5vxnRycTW3adMR9NKAhc753Ddh8Jx879HqifgHywtkr	359
15899	2vbVnnMJtC7AMhYPr2Ypq94PSwcjjePbrXfVj4j3WiHEgJ1ojJHz	359
15903	2vbKYYQYZCvvGdwi66intEmbK5ye4fJNgAp2CV5kvYqVrpW19mf5	359
15906	2vaA14Tg11Gyb2Fi5hyrLS42nLKtfW8EPc8uq5dBPTDbP33kn7pi	359
15910	2vbT2Pkxmfz6NMxex7ENk526WSe5n8zL2Jjikg92RodJ9P4RQ28B	359
15918	2vc5umQx5fqoLTWz546epP3VDKXqvo3x9jm8vWzKBVKKgWQAZgyM	359
15922	2vbDgMXML3nTe7e1PMbX7D6CUdfiWbz2PYSXiRphDFyCJGWxnBgN	359
15924	2vbEXEp9vQoDVb7EYppdcxXJzrcYhUNHbjAmVuyKLdX9rV8VMg19	359
15929	2vbBUkHb9W4QsJ1ipbiivagduMEZWC3jm4T5KKqJLsCxs9A7JYq6	359
15932	2vaJZsNVhKtzXZDaDp3nj8wVQA6LEpGDHQ9tS3wL5pXYvKoq3AQq	359
15933	2vbUTgJtWALz9e4GSi99AsPdnvyHf2oj3UqssBsKhJiyR7gqSNuy	359
15936	2vbnjJiffsmgsmV5cPw7mZvMJ9nG71vjVKzAwWzmwfYnRqpTDGiF	359
15944	2vaQD5NgkW9JhYXtqK91Rg9iV9jYvCGG7iRW5XtxZxqbqyc4c2tL	359
15959	2vbbSvkssQnR37cZxxLZ62ohWbBW2LR4Pr6pk3Zo4nvNosjP4RXz	359
15962	2vbuqmbFoTaTzRrCzD89PggynHa7vWLbmuaxJF2yq6zrqZyfxZk7	359
15967	2vbN2GP7MmnDHxXcc1faZgnoz54iEREGhCnAucoMjx2A3hvfYtvJ	359
15969	2vaTpcLeTyb5QVfRcH8knr67FNSs7GjJnre9EwnqbRR9KEXpGwwN	359
15974	2vaC8viDjim5imdRunuMYvaNvNRe7fmcT2DmQbJiCUJaiUoZz3Zy	359
15976	2vafSHBGD8KQURyeKu5FHeBbn1dMwX7kkdqhVLjc36ckuJxWMDwG	359
15978	2vagXj8MT2adCDdymNxb1YdLPqz5ehk33CT4yzmyVyH16EitTkYA	359
15986	2vb29riAN5qgy5houTkXPXhq1QFXAhyRVLJp5nxhVephVbCq9CaX	359
15990	2vb66drbCeR1AF7V6iPTEUZyfYr139dbfiV5zPYCdxAQ6uYwAZVJ	359
16000	2vaoeqVg35nrYDXrU5WUKFgVSRq5PZKuhcPs4WLgL8kLzcETKYoK	359
16003	2vabLLyDMSn3n7GKoMV7euStz7EBLwsvjFhQXxSD1ngSFZAKdyeN	359
16005	2vbtfdZvEf8HRZmQJnu7guEmfq2Sf2z96VqExhNKPNG9FmfhRZr6	359
16016	2vbeei4cBnKMhgfMwbocw1UBoNygAYkeAWKciPSojUQBFfFaqJwM	359
16018	2vbwFmNuiwSjry1uzB8ppUYDAkkqUx45U4gNX4LWAMN9oUNtHaqB	359
16021	2vbRGZuvAvYBCRQmean52j8pcq6W6RQ1uED4n7P5br3oPadiYBTQ	359
16025	2vbEnL4G5mNVJgNRk1MyDAgaVsJVAXcobgNC2kvQCgxrRmodR2NG	359
16026	2vac2zkiBNkci7QhdJ2KUwR71ZXzBic2rKooA8E9QxBqSLhwJvA3	359
16031	2vbLCw5f8Lx5Dt3YMF1H547PiSr37rz29Uxv7TXBsd6sFqbLcbfj	359
16032	2vaZaCGu1HsZdxnRnY2op8vin6jsqrp9e1ej4wQanXPEgJR4d9BS	359
16034	2vc1PBiHpxYkqDgCwpH5RvyHU3RMYXgifP3ahX7QisHmWK2o3pd5	359
16042	2vbDWLeNbGopd6GqWwu5uLVqv2xM8skQzSug2ue8KeuNB3L6m7PK	359
16047	2vbtSZzntUpqb5xQ9xYGQD3Kbuj9t68TgPX1S76seWms2ueLcyr7	359
16052	2vaSuRTNvRH8FfvpRba5CRB665dYPQ7b2dqF4U1AYehznzSbnCZS	359
16057	2vaJy5JXNbJkcBUj3phwMcpYcJwkbRG7uqpZjD2ZuBnsbrvRLQ5G	359
16059	2vbVGHSAuwznXom7TqLvr7dtedbfvAFEq3uMETBr24AoNZwQA53V	359
16060	2vaccMxLS9Ai6FUpMTnTSTZs4gMWABQ8i4jiKSbkuGzbkfGckBWL	359
16061	2vaYYnEHgQ3dxNFpguKvj229ZiFcvSWLxHNShcef3LdE4cCtV4Gv	359
16067	2varikVCgGToFnvNbUF26J9ySkzCNTFhAYrzDw8ny5e1MthDfmec	359
16072	2vaP491d6P4G59Pa86szKtuYW2o5zg8FJT3dKrVLEcCfM2CFwiN9	359
16074	2vaHAUUzREeoETJT59gkx5B7KN19jKDJzL2AjstxBHZPpJECxJp2	359
16078	2vaRU3xhRo6BqRDEtY6yK4kVZ2J9vgcq9qVS46o2WJ2ffTSLeCxk	359
16079	2vaJjd7UuEia8RSeqyKZPkWEvF2bLTcXkiqXFxgxWbDLMckBtmng	359
16088	2vbBHmpspAJt5pAq3UbdMQhML9kUAPFG6FvCfNwa3GVKDRPvwzj2	359
16091	2vbu3N8xCPUYLx1AWdv7Ks4ecwdNQgurYCyTmi4bKMx9BZkej7oQ	359
16094	2vauVqZ78upegcUjiRTsh4mBjnZmfkAtJ1gcsrZ5gfduvxANTrZm	359
15998	2vbXLkmYZbZz5ubiX5tBHQGdyAUnG47yfX1fxNrmkzVHwXcqWPb5	359
16001	2vaAXZi2CceKRpLduBz6aZQRBo49rNNgjbPQs1rNwP4dmBwqE1k1	359
16006	2vati8d5zvyHxKhUqdqtqW72T6FjEKVxLdQnUig32JaR59VpY2sv	359
16008	2vbwZoDU2Ti5wXz84qy3ToFymzxvhtmezkBjHNZ49maHh4FdpgXy	359
16009	2vaXkETGUqPbtUYYybi7ontKKDP9hwYEo4vehmSatWzqRq4CEvXM	359
16011	2vbnC1WG3GkHHPuE4ESuq7DTfaLNJu2JqHiA1LSpQg9PKYpju7sh	359
16017	2vbNCwoVfe7Q35LFvrtTVoeQrUXrKghx8mLSVHKQNBmafH1H1vJn	359
16019	2vbaTn9FQmsHtm1xKVb1YgHQdHLb5RcmHBm3hhGMz4Kp2BBpcvXe	359
16022	2vaaBK2Ch8Qcx16751PspzrASqH3uVgadaZuEaAK1Av3aYfgxKK9	359
16027	2vbGmbaZkKM4gtxEykZCygvQ4LvmqbNLFw3bgwxEK7VEWeroGKL9	359
16029	2vab9JdpNUxZLZz1SZ2gGmVkh9VvccCyMCpH3AQRc8mgPtw2Qtwn	359
16039	2vaLUoZGtRzb2Tj3P19gWST1Mx3Ynv82kXoAjfLVKSbGBdWXCKuk	359
16050	2vbyzi1EpDwiwMmJ6jAMGCuY6ph9D6QfGkv9Ke7WjV7ukAyhKNeL	359
16053	2vbnXGubi2uJqF1DPKBwtLoXUqFM8c4agCHSR2opQSiYeQ6s8YkS	359
16058	2vbLk7dJp4b2PNgy7DgvQu61AVabMaLbKAeczGu9nvSkgzdAYMzF	359
16062	2vb1i8NnjpToWT6iP6VvZ26Hi9dBymQU761b8BbFiM1HJbiLTFHy	359
16064	2vaNbvq8TywhfF6qSndPhgbTnEVxrNWFQhpNqJtsRTkamt29Z1Fx	359
16065	2vbiXerprgB6jTYvHky75hePKrXfXJQKtJcYXjdWmJgw6ntUXyZX	359
16070	2vb4bh7dMPRyRQi76jwwkyP5zoqW4rZUKgRB6CqPrHFRfqg7x1cX	359
16073	2vbXdYaHuc9J4dBt6WgkvzVzjxFqdWGXmBEGao96NomMUxDCtN1j	359
16075	2vbuyk1pM3DZFCQCGRnvuphP78cMNcadi1R83Anrq2VpFQCjqvTB	359
16082	2vbm99jfhEtdAkgPU2nP69dp2CHUKpQDFrRkT8QKZwYCUUL91Y5r	359
16086	2vc3fWcJyjQEMUtTQCVEGwSmhaKjP6kGgWEqRGPddVASKz8KVjLz	359
16089	2vaLs2kGmCV93caoYMop4wTz7NVvMFD491eZ2VCtbgHRjTAb3ZZL	359
16096	2vaFktyf5bffGv5nAmvks5mCyVjpN8KtNutTYYSmJwuLLnMSWHDB	359
16097	2vb5HbnBcDT6CW2RAieBAA89jSgDYyUffu5FsMoQNAMmn3bBEhag	359
16101	2vbYNdTNFGpiuQVixsVFmMuad66VThLoaB3bQkAuirFZ3M64hBoK	359
16103	2vaKDP2gnQPYSR59HVxRaNZHxxoG5Knf6CxtZ1D15KhGgWbxzWYk	359
16106	2vaKYGcjgR3AyNfQeMkK7HoVxwyu8Qxr5iqDgLtCBam23GHV7eZp	359
16110	2vacdpw4yH2tXwTKBJDoukQKQPLsumbubyNdD3DeSWKYXXgdj9Mh	359
16113	2vajBUW3QZjBYLCK2MJVquZP4XXQamykGanuddbpwAKEtKYp8uwH	359
16116	2vbbA43W5ppcuAsN8jsa9zCGBxN7AtESvLRE9GWENnSRi4piAcBa	359
16118	2vbtP9gKspyWD2TDWzes7A8zEc54Ra8WekFRrh2M1NSMBsfS7cqG	359
16124	2vauFDXfe9mcAGSWveDn2wfA3wf1r9V7VJahNTQ6EyeGzesTaJVa	359
16127	2vc2M1fp5DfDasfDnzjK8gV1HBuGLuSwYsRVBBfXiAnX1QMUMpYj	359
16129	2vb6c5jUUWEJustfGtJWHG1via8eq8kPguQmiLmyJG6HGjVi6Xxg	359
16132	2vaK2ofqNJ3ueYHQEFeQPppVoR8CzkwUzhNmwhxoZJ2Kc5nkWSUJ	359
16134	2vbDaKd3pHJKAX9JszKGqmCzj9aVuE8kCF7MxEefDzpZX1enB8xF	359
16137	2vbKmmqVUXYCpoidLqSS8XaGnEYxTeYkpqYuyWBdHct2gHMAqMK4	359
16142	2vawdr2d1MRUufvtScwEDZ4q4V3FeVzEirhZoa3jTzYxbiqsyX47	359
16146	2var488KhCQ8FGq56LJFgimpNbeFXh91dMXWq7jRbLQHLnE7Ut7o	359
16148	2vbyiw1p5JNhi1XrfykhZX5grUX47iZpB39NnXmcu5R68fh1Dtry	359
16153	2vaPTPGkFpc3dZtKSsQNYtGAB7u5wtYdCS3PoPrgWU61nwiPDc5R	359
16155	2vbqcHjUNK3TV5AdcRZbXtrYS3cPxWtbu9Q5okfweFRfPRRPwYqH	359
16157	2vbyfUPQL57NJbefp5toaXwzTYFLY2r3ZkzSmm82M8m4x6bkxvD3	359
16161	2vak43RsM8etsky3kA7eTpk4ia6zNLYr68rHFgtnmvtg7p5FapSt	359
16164	2vaKAh1XQNS2wDMYHwqWhmrntqLYGD4hJGkcSGX7yCHotMdnu5iV	359
16167	2vbpCQL6RvcjYRQa7RrytV79zfm4SkPvETrKLwF3HSsHcodxinnb	359
16169	2vbmnETDj3EvFwGw1iBcMid6Cbm6D7d5W5tf99TSX6dF1vPfuzTF	359
16172	2vaxwjUaSAVzbopeJSPVcR7BCfseAYw3LuuaWRdgjiPtBBJp6YqR	359
16177	2vaqqczTo5Bh98p72h2Nso6yK91e3sYQAhvkwN23rFjErhRRCZUr	359
16179	2vbGuSGhaj1MD8E1oUKFQFduTQpvLCvwzca4iiMA443xcCZpggZK	359
16182	2vbkp3BihWLknqHfBh92m1SWcR1uiLtRqKiv6AgYCWVZ2VutcSbZ	359
16186	2vbQ7HNeYNWExf92SVL1QiUvUSQYuSFN3AyLmE8QgQuGcXCndmg1	359
16188	2vaqzMJtQBHeTrHAwiXcuZST89mbYsdCY2CLj5xGj97fABFX1teH	359
16191	2vabUqxwmB2RJY2s5ohZCpqo4hk18s92RMNyoQtyDH7XGusJVE62	359
16193	2vaiDQqBgZeMREH474jS4zXNYsarmpsJRjvXiSR2ZEimgEb7U8Gh	359
16197	2vaHcSHvSrKRScQVBiCnMW8QkWRwLeY4EF2RLDEFjm67mvS5SDBG	359
16204	2vaFTJfmKMRC9JNAMwTarJqKHgqrj3iWwrFw2W9hRvqRHe5Nm3xv	359
16207	2vc3uTSxUbDix53acaFp8eNsXm896CiqMfuKfpXNbCRVmbcB2jZD	359
16209	2vbokDwK3RZi659gnjJ4TfhNGrk2VrWWLgr7Fr37WF1v3hw3UpaN	359
16214	2vbRKvSQXWRBFFB4JRDo7WMHgKyK6VEFTqrzfQFWTibV9x32W6kN	359
16217	2vbTEGs8akQGYZJcmHGtjiVimuS21JQEWvEeaajT7f8dguEHWHLz	359
16218	2vauQWrWwexhbUvvDKUtum2AGLA3XYGT5GMJa9SQ3VuWz4F1vuYG	359
16221	2vbHyyTvts25QPBHJZT1DFsg1YDRZtnRgRFFy2s4gtnDY28bKgnp	359
16224	2vbPSeSk2qvP3hgJRBj82Z3UVCk8Yh5S2TPXVK9kALZ1GWjjfai4	359
16227	2vbxWUKm4Spoqk563HMNNP17mEARSjrm6w8NJH5HEfrqbfAgPTKC	359
16228	2vbutUWLuN2QSADwTq34Qo9k59RAHwwQNx9EARcqeisEiGsnysEG	359
16229	2vbUW2FoRQLX2suwGThs3pMTTpryAT91Habxr9CirxvfA7RGZTFM	359
16235	2vaCv4SmWKSSyCLGazoHTNSUGPJBcPvyg4Y6EPoauqgEoa5cyTur	359
16240	2vaiyPJaEWfCmybZkdAPK74hiTvLSrfk9DvFcbY7kTXAx8q3aTpk	359
16241	2vbn9SHR68VUoiovtg5dt1pzQJPKNWHGRGw34okzs6rDzGkLib89	359
16243	2vb5vM1WM6kw9XfvsqHhQdpKCnNR6rk74oqJ22crFyZMKQn4h5Xh	359
16248	2vaDFJZ1v6Fnqx2k7ZAaWSJAnTbGxs4SwA5omVwmW4xsNWoizTdw	359
16258	2vb9YFjYbwagHqSkDUxZTvMMk3VhcJ8YxqYoK1VywpK9AJ14Gqah	359
16264	2vbVwYpwHuqSqcaYN3L2FP5ZSMqw3X1wkr6xHs3kKh6jUsVGu5zq	359
16269	2vaEZUibQkVsnW2iS6ReYPfieJMs7jCtXSZrHmwc4zy2dMsKgceM	359
16275	2vbD8VJQXiKbYA7CRMucsTkSLSV6xELdmGyiBhfnGwMNbcyxmBve	359
16279	2vb2P3gkismTkhiAoUrtE6YtQbfWW5qxqhUaDdr9DtK51veVY16T	359
16282	2vaEwkiCwvM3DrPnrcyKMJorxfwNjBbUzuSTPqcR46BHdV16KkYZ	359
16284	2vbtYHSnyuUrxfVjPqWdNCiTnUU5NVZejScneWrSCqi6MSreyuzN	359
16285	2vc5mwEzma8PhQa29HfFQUE7t5xNzSvErXgH2xZysGkjGk9d5pMs	359
16287	2vaeV5LHoZXJvMS3kfeGYY3qr6b8HcrERdstym8f2QjZKWmqbYc6	359
16288	2vaTKqSc6Cg3kkP7ZRDB6y5dosFj7qJLWDw3AYmghZAoEZM9JjgP	359
16293	2vaQ6yuWTrZZD5xciugFCRKbm2qu2H1jThiDwg5uk4L1irsJgKxk	359
16301	2vbBvcmVbEasCnyASQJTUN1o7Ufyz5pcgE9VK6CSVo5Yj3HpENxe	359
16304	2vbdXVhPBjat7iGJRNrGRAxPToUwDy9SBwn6EYievvi7x5HdKnDf	359
16307	2vaYN3SFXxaSX7KzLKhdudj5qJPJ124y6m4GP6z6scfFHc2Bjgzn	359
16020	2vc3QhVCLAGEy6UMhY319gVqAxmuafNgQTwMYLQNcCpLma6owr28	359
16023	2vaiW71sjhGjaxWcXFkqRkdaNgomsQUejuixjwafnG42icyXLnLQ	359
16028	2vak6wfo4cTLHvAS2dz2nmrLo5Gxbr1Nry3hQRUFheuaMJFXUSN9	359
16033	2vb8ZmUhefx9tvqVJcNjwaFRqFm2iBxzk9Txuc5YcqWAUQ5Z7gEY	359
16035	2vbyYRSzzz3VFWrgPzjzqdyXoXyWA871f2yvGBc7eunYcaMQ66b4	359
16037	2vbUcaapYwvMKXU5a38EayfBsZrMFBtZU96q2NmYYAJ6Siuzfh4U	359
16040	2vb5mGaMVpv5yJWr9i8bbfBD3cS1DecQyVJX7S97H2Jiv4XqQ2vV	359
16043	2vakbibGTs9eRmoLCkYBDNTb6CTb64P2cXAjhAckx1fLqocBkXxu	359
16045	2vaa1YVyz4Jaz7jwRVnUnqEcBo7dP4bL2etiSqGszRaJqtYT56Ep	359
16048	2vagSEt8N6prTWLptWUFbudzAtZRoYLdH7EzNYfWoyUqtPLqmgEW	359
16055	2vbyJ9EGMPf87rXfXoAx6ehcKAF3x1HERNqrXfxaYf7ZLXyzQeTM	359
16063	2vaankRABMsqpy2DX9Z2qT5TYezDxGGpFvGwn3orJuULu7RtV4qu	359
16066	2vc368SySc6cUXPR8rpQqBBZGWbSP65Udtp5GTvKto4LSvEKU6Vn	359
16068	2vbg9tsjrJs4fHx8ii3dMj3zwWEQzfWNhXocRUy18EPBzfjgWjwS	359
16071	2vc2PGHpm3ZNwYogDySGndC2PS7ymdAEeXBCZXFMS1JKqJmrbXZT	359
16076	2vashc63FovkpPZ2qhtJ6LAJao11keVauHMhAFbsWwqjoeNF4pts	359
16080	2vadmVsM1yXtfJVNdEwEChnoD5vRQBJSCVB6N4v5XYZNFQQEJVup	359
16083	2vaG5W4r291rgSFsrm3f3YxBeTCG7xdFs6eUoEVcLYmquNw6XN1u	359
16084	2vatet7vR69LWyWD5fyMRMG53JyVYEFpPN3MUZFx1F1GPNZxGCRV	359
16087	2vbWbExrontbEa7SMJJmJSD85XdHZYsrW6vBuJUx3qE2wycYFBap	359
16092	2vbLRgZBMVNmPyG8GphnjeWJPi5MYDpTtj9XmZGzMMvd5qyXDGr7	359
16107	2vb3n5zGAJ8L4RFzrRKxh3tQm4TzY1FxrEZomDpGhrFN1szEpPkH	359
16111	2vbNVX8MNeL6t4ci7y7QpU8Qf3QtMMpyK8hUQgQndtgtRW2FpSnf	359
16114	2vaSFygQbNScSLN87fFyU9sruhQUsiGrzYfizsWu7waycQJguFz9	359
16117	2vb7rHo6d4xgzB3Dhe838JQURXfNga69tmiXGVpuDBtBpw3EUb5s	359
16121	2vbLqDraBNVxnz5UG8mH4cUpJEiYhG7r1trqEu8bVtrcXj4ky1Zp	359
16125	2vbQx9kSHyG9XdKQyYmY8VEzBmJimva8oGuTnup25weKtGVruVuk	359
16130	2vbDiyk2USuvGsqxGLFHGnbJULVEdDbtGLeJhf3Ggm6CJHJJtG4C	359
16138	2vbwtDW8jkw5NPYhtffpJrqtdwMxzfScaGUAUMnVYHVbs3TkC5Qi	359
16140	2vaxxdxs1QaudtM1bwSSWifZfZ4C2eUfA461aPxEaN9HhStZhHNo	359
16143	2vb9ByWnMcpwfH3nQ8bNZYr6WMvzuud89tM18jMrCWgmgiEtyPdw	359
16147	2vaEYhyuQbQACmyfQXXGw9sqEj5eQp1zYKQSXDZ2sDExLJuWEt2f	359
16149	2vbwqCqfzoo8X1UMjU2igiFF8VNVH3L2QQfMhqJA85sjzUMeoxo5	359
16151	2vbWoR9RhiRQL5b3e32qErgKgXL1MCaVM41VJc22JCPyt5aW7BdC	359
16156	2vb99wMJoGZ2PN9qyfxsjzFqzeRRSKwFfhVfTzYvv9VGNqpFTVq4	359
16159	2vbcA7LxVrEDcrDjkjx6XjrwPf1fZGNSyq45nn85yxqnJs267UqW	359
16162	2vaG1LzFeMCFbXMBUZ1uN5UvCLtzpZ1pybSBXJT6pRyPP9hB4dqz	359
16165	2vbn8jupUUhasur5qr68eqJRWpFWSqpGfSuKnyzPRa4oKwc4SVZC	359
16178	2vaj9HJEW7bSUS9qUUobdoXM57QfRsRxPtJWmxe1KKKHbdgV6Xgo	359
16180	2vbSp2KvDCqSPaejYYk7WnCLBPcf2uWWWNNb5bJ5z3YKLQXPeRAa	359
16184	2vbmYRt2yxmfFbCCG7oSo2N3y7QpdTNL5vZNKHeseZZZBiFy7hQ3	359
16189	2vbXvmkiPeWHSU3xjYKMB8WXNNvtbm4ptUvdSTFnqxUYS7pPMw3A	359
16192	2vaKgwPcX73GYy357osrteTcq2i8cRfKtvNfZ4EUKhEkvJNp2T4t	359
16194	2vaqo42fCTM9VRG24WadgPH4pzj3ckwHhwVN7sFQmJZ6wuEVZeme	359
16205	2vaWyn7vMCS27unFH5F6Mw5pLZmj3bts3cYtS5htoNXY9JvdpTXa	359
16210	2vb7eUh6fk4ZcqBYzGdpveukoFEUp9iV5u36EWWqdvd8MyZeaVJi	359
16211	2vaNYJNqKb8Tz8BiKwQanzgD7BkzvB4rQKTTyWXVkxchyWFJ1juS	359
16215	2vaWbqKoo23qCt8xSxF6i3m4kN6tHvzSzFr3Khx8mHYhWFpTnGEM	359
16216	2vc4vqVW9E2JzRdMvT832c1TTBRsDF15pXicGGHvvp2YtjVDAgov	359
16219	2vahrRgh7ic2yFYTxktx9cwvrwKx6u79WzF8jAr7PJD11w1RXYhP	359
16230	2vbqBSQJKxCvDpb9c3P4PmqoYRYSrU4YeZBKQKt2qQjBJXpjiWQx	359
16233	2vaKpiupxBGTLDtKV6bWuRz1ytKAKmSiSwSZYTy5ve5yUKzfxhDk	359
16246	2vakjxQLA7fNPgR8ToPokwMKkFtrm1jwFbFZ7i4aW8W5Hyqw4faa	359
16251	2vbYSiUtse5y9SnxV9b7ssXy33N5Us6FsLNLNn6LbLYcAt2Jyk2z	359
16254	2vbnU1DrxHj6eDCMTRrRMeFVtiKzAQFBtXzkhvZ3WKPTK5APQivs	359
16256	2vbdjYmKcuQTLz7eNfdDycqubW7Uz3Ps668hkKTnGZrexcV2wobn	359
16261	2vbVzwuFzrbm8aCXeGSGX1pD7VKHY6NJ547USHtdNdmKHSqa6w6G	359
16267	2vaNKP4YWSPo29tttk2DCKtL2GKS8TZGAnUbXRHdaumncMGkt13E	359
16270	2vbyNWQG97BHvZor35GbhaSgbunA24HqGxfzATACQvPLSQPC1GfH	359
16277	2vaoVd14YF2dz1NJAkSDmt9DqywFfbgqqRMnSiMvCrm7Lj6FCv8E	359
16280	2vb1AgtZy6a2pQ67gqLi8MeSruvSBQZnr7dcyhNzJSpWVeoFRxi6	359
16286	2vc3VbW2RLp3Ceeecu81mVkzeM1Az3QR8Fycm854zvoPh5yrYPYi	359
16289	2vbpntUg15uFkyLg4oLkuL7cwEA1tmPAx7JNwcDCs6ehPQw4hddL	359
16295	2vbzkaEPfsp5Pf3VUnoQtPgs6Nh3YGUQGt8KXsyLgnfF6tuP6X9X	359
16302	2vbr2ShdXCdt4snRzTnBA3f8CAbBbKDnYeUSviVDBfQsn94C7ijx	359
16305	2vbwENSm4gZBTveJhssZ3BjfyPxdi7z1sdMWvXMa7sAG6jTEWa9j	359
16312	2vbzvXKCCCwWQdtK7jCz8QXnsFLyjRx6kM5hTP9Mv1QJ5LYPctmn	359
16320	2vbx5zKyW55yL5hgeiNwth2rRjdLhuczMKzmz1wTYS4fMcE1V5kx	359
16322	2vaztqDWd9ug16F9Bz2Fsz7zVV6fQpb1sPW9T99F2SUx7ZVYNxGz	359
16325	2vbcDhy1TjvhLAsEBY5SKrRhhe81KSQGACpUqHEcvMoD1T88ZSDq	359
16330	2vbCFt9aMrTKDRY2UNs5ti2okFLFCZTMSkkkZYnSY84Xd4HVsF2R	359
16334	2vbv1qeKsz4q5YueghtXiGRLok8JnquCuLpot5uN7RoU3BeJdQRf	359
16339	2vb6HrcwPMgowXsGYc5PGpLk7ZwdbYmNGUoDhudADBheA3yDHQLT	359
16348	2vb5zPUnNXxoCALtLLfaWgBk3wt3Z4MmxgwYHsdpPbzKas2DfV4d	359
16351	2vab5qJfDr8keRqAnEToNdDnYmZ7G3RfA5uxVphY1cgwT4MUdwUz	359
16353	2vbWDwjrEZjo2Jr1GtqwmB2LDh5jQNctxWtRJNXRvZYmZ44wAPZv	359
16356	2vasU73BMHjvz7f36NoWSEUyD4crHQqpTWp9uEARRQRVGKRw6nJx	359
16359	2vc145PAEh2A9NqBxbXQa1WkJt3Dsm45ZAUnC8sJszGbVkSt4jGT	359
16361	2vbatzZuPkuN5jfjug8NNkzJf365uPtnx31qXyi9fmdDk9osxazB	359
16366	2vc5qenV1Q8ZdbcHHSKjsAixsLmx3mdUKSj1tPx8z1zShwEDugEE	359
16370	2vac8CASBTdjMXDi3PjgGqnfV7cd3q4oa5t4oWfJ5Q8VukEJTzxe	359
16373	2vbEDwwNs3ZXsvrftQuGFexkY5Ai8qT62Fx6bckLRxKo8Vm48S6G	359
16376	2vbf2FArMTmaxevbPsB1CZyE7d1UfFCQwXLTffdW9sAjMDPac7bZ	359
16379	2vbehB8RhV9LDashSia629h7rG4ovca1ngRqspvPrtKGEZqRsSe6	359
16384	2vbbRqBv8GtMGpMazzs2Le9Pg3CcoSLghTQUarVKnj2mN143yHaz	359
16387	2vaPEvy4QsD3bXKyq4e2Dy7rh1Di45iXqGNAyFbHEaWELDK5eBFR	359
16390	2vbVqF5zEUURcHBo6QcoxDXYm6ywBgo7sYtsFNMhHqUbZM9YBVTF	359
16392	2vamLNgGBP6AhQ4wFFnkNbPfTwF56asr1WR5kwdUyonpBuWfxXYE	359
16093	2vaDS94b2qFq9G8PG4QvhZ2x5BAzKVD5pamnj7Usm3CY5yK4ds9S	359
16095	2vbutUaLsb2h9nNLUxCPrhZXHdyTE7wWcabVR8aVt5uGuNPQ1NoN	359
16098	2vb1MG7ABHXuHeZsZw1yDJsiDcDGTbQcSHKEZeRjASoh3YhFbwvF	359
16104	2vbAHGLMMgMiCFnzMccmXFVn3YoizvTcMSTVXWyncfqbV5uZyvx8	359
16108	2vbVdNQU2qxn6FfdFQSapD9nvz9k2Hc6BJZ1vBcKgNCLhW2nm3kk	359
16119	2vaEhsgdwzGxhVK4NBrA6qs2XSBtVte6Hj83QjufVBEKoFSyPnyx	359
16122	2vbjzQxxkYhTPQdEZK7FUPqdZDkwM6cE7AwmDHWAMeirNbLBxnSP	359
16126	2vbV8uW5nxPAvtqTkWxdNdLMrNPgLAdxX3ymmuwreUs7QoS3eoX3	359
16128	2vaW5ff9tdE49c2qmy1WY4bsWLUJXyDW7J9dnd5QtQUfwwPTfjhC	359
16135	2vafdxqt8tJMyNPqimj84FGY2fu2L3rBnxEcbsbfx6npr4T6Spva	359
16139	2vbtSefr1hfWfwSMpkszw62JbxjWuULn58uK3Mqb1B5SZ6uQad9w	359
16141	2va9YukxBbSQgYQ4ifJ79wJQx1VwDjY3mSJwYckJ8fA7CAnJA2yi	359
16144	2vbQDanmk1ZSMNEQTZizcitkEJdbqNpHfKtZtGojsbf3dJxa2ipk	359
16154	2vaqUzrBTAgxvraTdtWLZ69hZYAC21Eu6fxmzTwLbK3GwKByejTL	359
16163	2vav32JQtGGs1wu2PSKdWHgLWjiNSzvNi61y1CSkeJxSWBeBxvVn	359
16170	2vbGM3mnikYanEFhUSMwdeay88Ya39nQhMY8e9Bs8ZjoDSr9sKLH	359
16174	2vafucqoZ6y9WQKkTA1CqsFBgPgTvYk8sY9jqNwtaGJijSJbHGrR	359
16176	2vabHYfQxkbtP8f7vDN6yXwwad8HCE2E4f8eCSRj8bP2u7ScVY2g	359
16183	2vbtxuFKf98QWsuncQBM5WvKRCrafMdcLnZpcgYcAgbesT6smNLU	359
16185	2vbE2ciRremzKxWM8jz5WRf5qyR3ghPZ2GYxt8MdfJRgiU8BeejP	359
16187	2vaAFgAcsd8ocBdAshvDyekKjyHHeWCZa3XkyCBo6k9JEJh5Hh2V	359
16190	2vbWfQzpjnfaCKYqt5Ptw7ELbvwEvqFqg5ue9KuMza1fqPaT4PiQ	359
16195	2vaTESSVMLqUuvdcVwePfQH7eTg1TAtNDo6VsR7MSx84zWhRyLSb	359
16198	2vaG9LofUoCFKhqnS7db4MMgNaKWGraL3ZCaTZSp6zS3ypAjK3qe	359
16199	2vbe51E71m8EAvcFGQJ773Y212N8gXDv1E8rYFJETnds8EWZpSQ4	359
16201	2vbGjgVHjj8kgxcXbr4h25NtonKKgke7KzGGgSYjqcfMD8uh8aKz	359
16203	2vbsR5AarXQhkVGzvHBSk5XNDNZv5ivnLXyRafh1GgvEcrGtTSFn	359
16206	2vaqT3PoABwhw1buEH4Qkz57668DDKejCms2a691S1xn9KSnbso6	359
16212	2vbDGfQBqpvayN31AMuTiZuomVDZiZmEiggNi4WeYjFEpN9qdNJy	359
16220	2vbE1wy4cecFwGrKYM3eZ7b85rA3hmYfW9zUrfaKedWd6cGv9dug	359
16222	2vbkJZT4yVBQw9ssKJ6iistv2PKAdCHsTUkbyMk5HExbp5vs52Tf	359
16225	2vbcfwEQRTBK23JnKdfbj2Hw3uLRT5jaUyq8MtiZTxybfG5dEahW	359
16232	2vai7g8py4LVAhQDZQhAzYTMDocnFGKV3DsLgwzqP5arRKswj2zi	359
16234	2vaw8phUHo5gmG21mHqou3cX5mKPU8mTb2jUFzCbWiREAAvDzPTk	359
16238	2vc1V5dC3KVJSzTXZYiZYG3LUKFzdXPn8oxMQNtAA9kSogPwARj1	359
16245	2vaj1TEtzBXCvYfvADpJUh1ybo3fDaGRMuLyAg5gX7Xy1MiGwP91	359
16250	2vbfa78d8fY2Q9gTTYocoaoMQhT1cncPDgSSCx7AEGHV4mWuWe5i	359
16253	2vbm8Jy2amsG7S9Es8hEtQrr5TiJ9S4CWyQ9hn4PGkij2YVxLxMf	359
16260	2vamjUUCfRtRfB4dVWs434N7ounV416Q7cCjSzUp4WyGrjVc9LsH	359
16262	2vaWxPZuuyfZ8UjvAJUzgsqVxgDvLS45kQdfyPw6yYPBnAvUBndX	359
16263	2vb12f6WPtRbrdEvmGiW63hEidwtJvArVjwtAMCD7eksPQCbGdV3	359
16266	2vanFiah5yKCUyaFxTsnrLWC5Rb69rMoSLMqe3VxNFPELjeRkeAW	359
16272	2vaJ6dRi4ZpJEj6dsXSSr3HApemxEgFd8x74WWGpiQr9aVMu4zYQ	359
16274	2vaeVeAZxE9Lhfe4V8ZGoPhFBGEWksnfru5x2QazYfJwyCHJiPSS	359
16276	2vbCcGiAjn4JwLLHR4G9NCN6i4GuirtkYw8wyF9Z6Y9EAVdsSFbQ	359
16281	2vbcSyjFTsdAoXCPUXGJzqTvQDLccBKTaSdLjBvw3tD2qim4fSGm	359
16283	2vaJRWuAP4MgUcJUwJBhNk5mK8uGcUr93kW7bzNw1xUNRv712DTj	359
16291	2vb33mfRt8rHGZX2bccQSTzs238doYyLp9wERnwdck91hJACbcRd	359
16292	2vbcKq2MnQnfsim4sTP29CrbfmM66J1Y5kJbj2MgpKCJuPgsw2fu	359
16294	2vbFVj38uiGwVJHa8kLPR3FFKiEaZAbawaAyQJDm7cAL8fwatYhA	359
16297	2vaw5TCaTbQAaGf8Qg7DJqNadc7Exv3vF4EbJvzFyzwdsgvaWj2v	359
16299	2vbQSBiUfpv27tyKo9zsB19CXD287MoDrYRengJY3xFcwSNh9xb7	359
16306	2vb67x3JhoFCXRDAt8qd3ATutErdUmHQBn7NCxxPgwC54ZYS5ELZ	359
16308	2vaTShBe9TVSNYnYbt7DRJtPqB69Ky9kz89vGjVQzFzQWmVmFCu3	359
16311	2vbDjZoWyHpXrVviLkEVi3UkTXc6BzssDvhmU8rqdr7GmHvwJvCs	359
16313	2vc1utt6iwvJSpTYJFwvFeBpEtqv5grwK4AS4f5iTKmjy4RHEcKZ	359
16316	2vbe4262NK1rghdbbQACZsMctd8fzRh8q1YMCv9PR5WdAyTturpB	359
16321	2vaY8xFkQUbBWwW3DYj8CLPM3372DW6FYaJ3k2Vm9gASCuuRq8HA	359
16324	2vbVofTtWHYWjGRUoRWfobp7nfrdpycAXPHBTqpfmn1RWG4M8aLG	359
16327	2vaVH6poPohoPA9updGPDBN7wVAYkxbqGpi2i3ZrbZ5bFV3KEeHf	359
16332	2vavLXiZPpXMhTH8zSUsTLdAbhPHEAd5ZtaT991ZW5a7EE6udbVB	359
16336	2vaC6Em36cvSG3KZHJQUpNJPC5Q8P2isU4GmP9rTErr1UZ8eDuhY	359
16340	2vbJmvBGEkFRb2QHQPgJaxv8nFipXBeUVZ6TaVWyuMq7DHBUHpCv	359
16343	2vbm1CTZ1mGsSsMURPZ4LTHVALw21j5ET6M2xkNze9NmPPh8D7NE	359
16345	2vbfuoxj6FJfqqzJCfLWsCjDfkmYZtLqGC3DWSLB4g8yNcqsTSso	359
16347	2vahw58NPtdC41gLrXL2cvWfTYe9SdUShKRmxofgP19DENVqTyhH	359
16350	2vbEvRLa3WLib6U7mMRoZGVNmnAFgiAQW9s5xm46xUr2BKRmEFTH	359
16352	2vayyQcj1hW5ou8iRQkjH2xwQ6jadSrqd3cmyzGiWC2kg9LPcSKc	359
16357	2vbHWrsr4idjK3CWspwUNufK9RPu3L3vP5CtQ9BASZXYQkZrvhWz	359
16365	2vaLdoCdns2byjwJGj4nsxpnnVxbHK7wxCGsdNnZULQgvkr8QyNk	359
16368	2vb3G5ELT6rMVtTvfHgSPmdX27pUciXoH8Z5NHPkfipfn9LmTG95	359
16371	2vbeV9GnyR6ntstfhNfax9SxpqdA8bKqok9RzSMufU2CoeMD3jqm	359
16375	2vb4j2mTNBNAwVfK97jy9ecgZiQiWJ9bnWoibADQbmFG66jTq7LY	359
16380	2vahkTeKWainRf4mSpxxDgnR1EN8MAFzuV2aqKUmovQoMT1MyDxH	359
16382	2vb5Mm5u2sNvUvdojM17zGHaRsyP69dPBfezAxH9qGzck59i8Pjj	359
16386	2vbM3sVbiE4kdEo1qSAPchXuyVTXW9teUCniUBy9hcVotodKM5dD	359
16389	2vbNW7hM2qEjHTxe34zix9uRmeTm3dCKCNAik7byUZMQ3RrTcG6w	359
16393	2vbyefdecHAQmfH8E1QfWyrZXA5BhTUu8k4KmhTT4AwhzhsMiEGD	359
16395	2vbss8pDqGgcnRPVgdrzK9TkE57aSYZFctdpiDReDshuhMNvdwgD	359
16397	2vbtgea2pLq6cJspXywaTebikvhtRUbXncXmeqZc4ti4ZaR1bbKA	359
16400	2vaPndq7yGMN3WofuGxBFo7hxJrgfVmB9w2C84hCPdxNpMfywVGF	359
16402	2vaNVT9h9UGvQHeDdC5LE5Vd5qpK3ypY7JYKLoKyjkwf12diMW2m	359
16408	2vasvLYYBUhGTrjenNk6AANRvxfSwDLTuFHRLgax4abmEk3aSmn4	359
16412	2vbyysKiwwrRnEQv6jM7nnpLtyymxPecTiceKyDc19bQwaVT5aC8	359
16414	2vaHiGZqw5KSpo6BDKkucZj5iebSrFohKste6gD3wZuWj1QEa1e8	359
16415	2vbQXuzMF1Jt633WyG4DMcMZxbCQUpePHxLeL7XSdBdhb44Hsb7A	359
16418	2vbaAfm4j4WvCsrkbJa5XiUSakUiKZdHstDAkDQwt8GdcqQy7eHZ	359
16421	2vbakMPD7k54wYh4TdBovXudGaSGdevB8wZsd1bPhwtyup91PTvG	359
16099	2vb1bhSiTwPiUaW1rLWqEYxzs6bq6ahP99jkSZBQkSGfZrQHwTrB	359
16100	2vaDTXCETACrE5sy8TojyU5fKTL9cWc75Ns65in3RvwDCgnNAaYp	359
16102	2vacYqXaptjQbLjkASMYqcLxcBYJ9haHKeQpCoWYukWHaQXdz4RF	359
16105	2vanowg4zmKkR5unDeEEgrioeaEzr8978rPPLJk3uWWJjXEEX4uH	359
16109	2vbggMY4ubWAFRdiu8miXngXYaWwKX1Zs21XBPgwh37W6b7h7n9e	359
16112	2vbU2mn6zpy5CnAfajv9UCpJYU4vZMXMXGjqY7AnA8Ztk6qKGi7t	359
16115	2vajKwMCy4qCRxNtS9UNBSstajk1yr2hHgs7LxcyBMCXaDYJz7Wr	359
16120	2vbWoYBiHqt7WcPcNho3vBARbMpAqnGkRA1CmzJafAbWpQEBi2if	359
16123	2vasWJLALhQa6F1W8E9xESLXNV18qV17kB9bpvUmXJEaAQctxYTb	359
16131	2vbApNYksGhCoG7DBStLVusakdvzCT2Yc8u4ffHSdCt7qZ44ffAA	359
16133	2vaBokMz2cDRwoXv8dsXxNcMdFntBGiH8dKcAz9kq9hdg6LxPdds	359
16136	2vajTQmdFCdQrXFXtmzfWmMCmjpaip5pF68Vy533iz41K6FSVjqy	359
16145	2vboV8mJdcRNAHMrnAqLTKfFZvN4rpkR8JsH5PPFEWDjuaJi4D2Y	359
16150	2vaz4XYuqqCWHTguWmSBs96bTsjZzQ343P7TcNk9SdNzreVWVAQu	359
16152	2vayo5nc8aA8xj1m5ER2SyerstMCwm53sFDkJVpWQF6KkinoMfs2	359
16158	2vbHKkWggd1PeG2SFwbp176aursKcAYzhd2LTJV3A1ESoDDE55Ck	359
16160	2vaLsnyHHLfG3ZwtmjGGqwk89uXR5MZ5Ds2ScmKp2RBRwDPhcu1Z	359
16166	2vaqTfcK9PqHJWeSkYNyw3zucRkFrMK8QMApCxKommuTpAniQtU6	359
16168	2vbyLvRyg4e5d4bLWvAPpHXw5QjW743sU78WVfZgcBhWr7jRsims	359
16171	2vaTvCfboDZw4KuvDnJJX87dEx1VGLLQab445N38ZKLoyQFeaSEa	359
16173	2vaz8s8CV5VexibqwpMSwUHNo9Gm16CXKxazFWywBMmCCiaF9ewB	359
16175	2vbgH61n9TUf5Hag3ZAbCnDZPaEWaRaCdXjpeEQ5NxDR5CDoZXgz	359
16181	2vbXaGSFRUNPV4mxyxhYTBczVNEdMucRduStfMNxDqnaGnsQLnXq	359
16196	2vauTQSvJvGDjBGUjZ46r1SiLvrVomLpTt1DCHXv6e1Za7AdVYDp	359
16200	2vc4uVFpjmch7EQYuLC5VaGUgbgubtxE6jM66HDwg42Pn8jvAnRR	359
16202	2vaJ1zKF5dWtws99VkY3UsGu1tqbvEM6NFHa8VNdTWUsBGe5pu8Y	359
16208	2vc1Y3PjzKZj7PHuRBHJ216ZJicPR8cgkNw78stBokvL4w99VJGC	359
16213	2vbrmAuvpwS8syNEZFLXexzQ9ZpuTYoB9fde4ccSqCJoB5gDCyXd	359
16223	2vbx41WUvVP8Q7S4NXJTh5g7GSF87AGxdr7BgPLL5uiYifY9EbfB	359
16226	2vb2pTpeKSknc8APDZ3ufKDMGmeCNWhipeXaYwKLFowtofgw9wmS	359
16231	2vbu2o5nSpUBJCRT5r1jLKB98jVZtqHcXkMeac74zLHsk4Xah3Yp	359
16236	2vajCsd85kuPENU8zhcPRyXm4bwx6y7ruqbinSkabqSspcUqcRz3	359
16237	2vc4Uvn7LMrHov4CCMc1FUfchpPDT3ntwLce3aHXQ5BvxR7u4oZk	359
16239	2vaFYrzySVfrzSYynKPJKSJ4aQ8sGXn69feYyocbZj7CfN3Mujuw	359
16242	2vbeTYxJfdnYrPDa5tsGvCaHByDJktyhLkHJMhpBvJbfoxbZwPWH	359
16244	2vbb14ZwUHzvw9nLUvEeD7hQYv82nAuzj5qTXvBNgNqWuKWuLViF	359
16247	2vbL35UWMSUohrJpQJdog5KDaezYu9v6Bhme7femkLZGFyxDG2Hr	359
16249	2vaggT8rUsYAvAvj28ZeMBFb8SCaV9cQ6EDqGjvmxjeMRAzePVHq	359
16252	2vbiLWBcT6TbzzWD8egMeprQWBkfpLQEr7CskwDGU952CCFDVuVj	359
16255	2vaHCWiFaBXxLJ4vRe8b2eS6CTZ8W94ktut4r5sHq8Tdpbx7yYyC	359
16257	2vbBWvWTcZwmm7GwvZ2aieBqQt78Fyaf4dY3s7Q8rYZpew5v9vDp	359
16259	2vbr6AR8yQiARGKFHhJwErxW7TsPMkcLDcB79r2rQpxtsCUn2s6s	359
16265	2vaYCVXT9pdq2UhMUjATywxY9fLaRN5Q8LERLF5B58dKDMhv4MkX	359
16268	2vbLavZkFgemHsmhhwA4Q3Vp3ememRYyvSW31FD75VE5jbigWEsP	359
16271	2vaSuSw5FizmucFxbPzRxBm79CKKpqwRNfAPspxTPYV3ZCUHUTNj	359
16273	2vbMBEZmr8L8pi9a6eF3x4UzDdzznSBSKRbf1v4jWhkxrvWqkH5W	359
16278	2vbykp1iwZdUmkR9ifLC8Jg5X7jAUUpsNBAG3PBN2Eh5mmCBnEGT	359
16290	2vbHP8iqnEEds77t3xe1akVzWR2tbdYFkCeejsWSjBN1UMKEDddY	359
16296	2vap8VecDcig1rtyUz69jKjfXjUVZDdw1oR9WaG5ZFsFvww1cSrY	359
16298	2vaWCTTMpLjhtuwCPsoYbfSEV9agzEpSdWenNfZFDVqBLw7u5yZq	359
16300	2vaDsjhc9tuN7a72qBq7VitDBhCPHVjgdCgFL1JLfAib1127Nyud	359
16303	2vaFVrNphJiEsVwng1YGW1t5cVEin4VF2gyogmZ3b6G4QV55hJZz	359
16310	2vbVfBAGN1dim5tdNNh6bfuAmpvSnnUygjhm5FSRYGFzp85YKQcS	359
16315	2vakrkBT4bQgUsNmw7VCgCuZdJGDTwbnecmQzhYFgHXSg7yYz5di	359
16318	2vbbb9SkqEHWsnUJPt24y9MDrF3Yyzx9kNZ973hnRUbzbaJQ7Wen	359
16323	2vbQPDtNVyquKEqHbGtxwgLWdULzEXzGGoK4N8fCQS48d42vRqzz	359
16326	2vabUk4cuwmWdZ6YwhAhmoDDWyKLeH1Kwh9gVwwmiiTKpZTZEqUw	359
16331	2vasaZx8AoVwFf2Bb7xK9Yx1EyDNCqN8qt3YoRiitzUUPr2HQkMD	359
16335	2vbSKPRx1XSShysKLYX4RuVDkGtJp2bV18D2SN4XTqRuJmRw8paU	359
16337	2vachJ5DYrMbtKDw8hCNtwvyQKLBEPwvm3egEezwhB88a9D5RVUg	359
16342	2vbHZfuWhTWdz2hkgF7S5otxSmQXVpDHF91xLtd2uArnZynACYfL	359
16344	2vakrTPV9JB9n4wp2hvmCi5jn2wSNPVQLwsXPimLmZroTJcsKSTV	359
16349	2vbbKSJ7a7CDEsHMT6S6nFiaFaxeAjV5NLhCzU6AuhnvDNwSfG6V	359
16354	2vaLMJr1EmaNnApPmJzN6U5y9a45iH5QUEshBKwxp23usgQcpps7	359
16363	2vaZMagQbPMMaw1aDpYwSGJpmBnW45AdXW7jgvh5RGcFtJXdzEwi	359
16364	2vbfCxySFjP2Es16LozRjn6c1fxu2fYwmRVzHWdm2NgzwWywrFpw	359
16367	2vbXKmYGjuYuDZcKFD2uLrF354SzpCVUhWxsXrZHvWYp2icKEtfE	359
16374	2vbPt9pDh4ZaUkJnBthy86jiJVJGbR3i98CdmvNkVnW6WpRs3szi	359
16377	2vb4DePCqpqPqwgsfaQDak1sGduAqsY2VPUXF9v5zA6xs1UAi5fQ	359
16385	2vbVU2cfCrST8t63Goz3YMzyLGxcbEZtdsV7WMHeaeEyiuuLaQvr	359
16388	2vbS8XEPXPG3fDVEgcyUsWebtHMvhQWovUTKpgaWz8vPJRUWjhzn	359
16391	2vaU5hfJPTu46xJbdTRPDuCEWPnhgztocdqGMXdbCuCzJJ3AmiY3	359
16399	2vaRek6LKWc2vvRCvz4Kw3xw4Z6iTPiXqhDXzBVKqfjXQcTEYhtb	359
16404	2vaj4QTc4mZLKbcFhCTvn91D3n15yxGebZa4ohzJXdcseYh43ELh	359
16407	2vay3nbjaSjrSEMuebtz1jcK1apyPdZwGk82jZtfDq8vcMWj4f5v	359
16417	2vbNn3dxWMu84bkokGp8qBydmZvhfdnMVzKGeCA4WS5q7QDNDySu	359
16420	2vbe48QxUgP4HkQbMGVfseC3oq7XKy8mJ27Fv9BJxg4RhSuvBGg5	359
16424	2vbrWyk8TBnHM6vE5aMUnthJttNnMD6kSxCecG1iZM6xaB9Dkj1J	359
16430	2vaXmFGoH6GTGfzQzyXHc8KuRHRUsjSfMRbUA3WN42Z7mmcTNXqT	359
16436	2vbQYvKsudcHeC4hsH8MXUyYa7mUuBgkYnyi1ghHHQ5BQV1kmY2p	359
16437	2vaoRK56gBwmRCh2Lzy3XAnMwSrCDEpXyQiQh8G4wTsFWaFDzYAA	359
16444	2vbEHVqRakhcptcP859qPy57manLhsSJqKL8xTGu9Cc6aLJgxWhM	359
16447	2vbTDyTP3A5uLTLhqKERReipLAhLtrcpWuurV44FnxQ7TUdUdW7D	359
16451	2vaJM9CWkLDDRpEiy1fbSJZYbwtDXLrD4UuMmdewE82NxqhfVypC	359
16455	2vbD3wguA7DAsAMfjuUBxfBjmAMVBtfT3Y8tDz1UZ85J69wa735t	359
16459	2vbXDgaJehd5LG7ojdjvNCyrCQ3BkEJP6tB6v25qFnaWAA3PyWmD	359
16462	2vaSzoqkHtTzHke7qQHJ7U2PSoYLPESdBeTQMrdV4Nv7dQeVNVUt	359
16466	2vanbGdnCi3eSgnHwBiaMyUNQCHu3CDKYxYNLSvZaovmndyrSLav	359
16309	2vapHh3cLZqnZ9w83PWKKDM8W55pYgiHeMGxAH98c8TTJ7B8k5DZ	359
16314	2vbJDPxZUggcBSGpgVJvzgWjN7KdsZkePqWzcTrzqnCnv3Duizkg	359
16317	2vbFwd2wSrGv1AbYyYkMc1RhJbSsdYDytwCkhdSeq2CNA1Teph5c	359
16319	2vaQyiYsMFLPVk2S2m369NvjjaqERWyKMyU3gPqU96EzRdGuRZx3	359
16328	2vbb1EuWXxPUDrTHecwvz1ee2irUoDB6hguMTF2PF3FFE1EmA6jc	359
16329	2vb89kz3KJf5V3YdWtZx6JUqdMfcziL5Jm8Y6caLvusKgXYsZrho	359
16333	2vajL9ZBmsFmDWW8woEMyDXu6MA6z2zspxGxMKqeEjRfbkBfQXSp	359
16338	2vbuma8kbuRKKwCrD1rMEUibK3yUKDkukUxq7WHvTSULoNbxp3ZA	359
16341	2vb673kgU78Sh2EQ7PYcCT1ikdCBJkSt6tYoVVkco2NNcWPr9vuP	359
16346	2vbhh6KWx2GcBsFSgzz58jQKgngcjvganG49RdhQvwDDa5TVpxNh	359
16355	2vah6zBkV4HWek1z3BqTdymQmWEdg552qccAYEntWJCQCvA1QWFJ	359
16358	2vbfTCmMvSCANcXYDfgyVPgsnDGj94i5VRUagBHpPT8EDPPubfN2	359
16360	2vaRNccZvr85Bu8yVqjoFdnc5X2h3nmP11nerdYA1enPDWbHd1AJ	359
16362	2vc41eWzbdv69JmSvywBaLSuhu6bUWCvW2byWwhGFaTk7hYubfgr	359
16369	2vbNLrTaDfHU9A65N1m2DxFKCcqk8RLmTTpzU3JjSdtJ3GmV2Rvx	359
16372	2vafRhLXu3NP3XLxzuoySz5kGaebF12chbMLfmusGEsGyY44x1xj	359
16378	2vaVzRgfzRfE5nTWKjq6E7zof5LqpErvJ8ixyd7dk2ZrgHaxLdD9	359
16381	2vaGfm2eYeFkhTNrybCTpGpBBgUYCHqjjLL49pjDoXnqPkfjS45t	359
16383	2vbhrjDNUxfvrR4ewZRDc61ZfFXCQap9UR6RjxE7ZjDjqiNCYHut	359
16394	2vb4YcKeVrQayfE7KzDJwubKzFurb4VC9yTs9ha8yA2onoikdZtU	359
16396	2vauiCRBrwaWtjS5fJvfV7bjLvuGvBsYQW7qPqpiYU2bWZt87dZ9	359
16398	2vbQtTedZps7TuXYRteXT33fDtdetkMGPrFZY5NAupzFBW18sH7y	359
16403	2vbHdNYUvXRtYGkb1KhEgZWqMt4oygEgUpKVHCJyyNMzDcLTM5DD	359
16405	2vbM4JkCVynjzx1aKkBrtZn8jTh28B1Yv7ouPCVcsyHxWHXDZaxR	359
16410	2vbbKBwwqrbKnJ3VtT3N5th9Gi3WT9JM3c5aXCBzfw9X2SxkSuan	359
16413	2varMGnZcrHZWsEKk8bjaYHrKSLiwgAbVP9y2JYu699ZMc3sK6MW	359
16419	2vbWbBYGdBpVxa9jUda7R6roiwdfiLhFLhiq7fxWRK2jJpopQwbb	359
16422	2vbifyYZT6MFaCBCXGvswXv1x3eevhgrVFCRRTUA3ePJDg6oATRs	359
16432	2vbqyhsNQfN28eVL1SNWAUemBJi3ABDnkwctZo8qr6FhVQzEEyeS	359
16439	2vb7PHZMRbjHbhCJyxXRMiaJGbmaG7B24AzG6p6p3j2qx1q112bg	359
16445	2vbAVJV2HaD3yNLpir8QP7fXXUukJGgeXKTRSZCpnY9bmrGxZ1uj	359
16449	2vaRC6KPYUUAbzu18LRmus8kCtk1DYxzox9rCa7kasxfCssUAw4v	359
16452	2vaiQoRzcXVL37E2XwB3FpZg9ov2jYeF1NdsnUcaTeSsU2FjE6N5	359
16454	2vbLRutuJ8Qa8f5kFLXvGPNcGwAiWTVWU3gTNVBE4XXZBJdmzxqD	359
16458	2vbDQFPCTM6c5HarkUpztSGF1khbB3EbmM97ir88wEanyVNirsq5	359
16464	2vbJM2MJK4HWJRec6KxRvHtkJc9hX8eP9E2sCi7KNizj7Xt29pXN	359
16467	2vadA3vTnWky4JNBfC8utabowc6fAqNncSrGJQ2u4nGo1rBWttwd	359
16468	2vaJ96jE9b3HRWTeG11w3QJzcKc7YwqSnJx8cnqN9hG9HwSSwuT4	359
16470	2vaQrCG7sAn6tm8bibEay1iyTPdhuwFHuLhbkPPVxqEigmbUdbux	359
16472	2vbvZ3Txz9L1aDk6cPs22AKwPcygkaJfdSKbLBAK85FJYLZqMmh1	359
16474	2vaG7TZPueHZNG21XUgtTCiDtGi3WJasPT9PSiBaApMw82kkdvtr	359
16475	2vb1QjeZorbWztyjRsffJyBCCJcD9uiAKzSB4qReEACRoZU6o31Y	359
16479	2vakVzaon8arWGGbLE7tftRSDKZydZJz6aXDXgxb46v289eiq8Ju	359
16485	2vbQFzycoCYfkSBPxztbLysbzPWiK9HZ4VdsSHRJxiz82FqnG2JL	359
16487	2varuYSSGEsAxA5UuB92MoCg9PxgQSADCjopm8zJExs4Z63VpUQx	359
16489	2vaSV4iU2zExJs4BnFgGBNBFNHKd9uCnxs4sv7wUrU9JcXkp1Hiv	359
16491	2vabD7w6SuHf2PELbveXPuGP7uJj6Uj9Cbngba6dbLv3bDLDNc2Q	359
16499	2vbXtEtH4anVeLXzNmt6MPt2LoF6MWpehMcGqanv3riG3WqMEDjQ	359
16517	2vawLxiC7pu9iS6DJnsRwgb2gBsN8KXEaaiH5jK6GqzMd9vZPH1R	359
16521	2vbsQtjkhCagNbXQrh7MxtoiWaT1xEWH8Q2F7qnVxkzWFeeEZfk5	359
16524	2vb3SFEQ9smkvZqioJiPLGf7PfRf75bFFB9MnWx9RXqYG4eEs5Wj	359
16528	2vc2kppimtiy3kjsxU4Q7Mhhge2d42P7tW1SsVpZ5FsdXeeBP2Qs	359
16542	2vbJW3xQMDSFmWv1rs2KQSn1HpNRczYYcrdo4SknfNjuDNpVMz4K	359
16546	2vbCkxrDvriubF31KboSHBgmxXGTiiJGmEUsCbdnWqLBbHRdAJ3i	359
16551	2vbbEcA88QHjcXVTT1Tnj9T5FsXwAjgGTbkXFMqMFcwenwqkNgXc	359
16556	2vbx4gGuCWasTgMfbugoYCnkTEhzwyWxc2cr7j2kXY2Rf1tj152Q	359
16558	2vaVYfJAHbKvRBnb5USoQLvVSaJZs9n8heMacyJi2L9w4iL5wgbx	359
16565	2vb5ijTBPxiWtv8ofUGi9KntuU26ueHK1ttg52MddqoprWvvZebc	359
16567	2vberf8g5xVkfaQidT73UdNtbxyoh2rMAr32aoK6YiqyMeFkY846	359
16572	2vbHxV9W9h44CcbeFHAnXbk7t6C4WdeeDuNoo8rBqNcXKwcRxzza	359
16574	2vbqE9TB6ZW63MkoTyd5MMaJo2De8PS3zw4Rp9yRbwPtkNwtJ6mH	359
16584	2vamdzJvNUYSGE9sENc5QtyKAKNMMiUSg6okcX8iktAqKV4aWpZC	359
16588	2varjmrSUCLRkuxekZkpisYNuZCdDh3HxP3ga4WBqcqZJDXNV4Uv	359
16590	2vbA7nnBX5tWh9ZjE1wy8z7YPJa3mpkj82PsCLtNjVHnjgjhGXNK	359
16592	2vbGNigf41s7ry5AEd2tw5N9K63KWtxrx5Dm4vYQV3hB19nJbJ6G	359
16594	2vaGaJ7n2yiraLbP57wHciGEmBULgFw4ip9SjSuAJgBtpeXQdSoE	359
16597	2vag8Pa8NnMQZrZyff8hCfz74CKq4Wdv6VVfM3YSVRvUtApeeewk	359
16600	2vaQ6BNwi8JaTR94Xn58ByFVtDQgdKtPiLVDy5Xx2i9oEK6eHM2h	359
16602	2vbh4gjBSyHBGgA6ZKU5Qe27FkTWWj5kSnnyGz1yAF3nd3QPvxET	359
16604	2vbbrDctu9VKFBRptTRKG4MT6cueRRUA6QD286uo9gDmnK1zHy8S	359
16609	2vaPicQz2huEcN2gmHPhoqwc3zynRER9jYrMuVw8ky1PdBVoMG6E	359
16620	2vaonstJaoWkUJERH9VrCBGXUsHcJaaQutJQCAUKY93fLBkixk2R	359
16623	2vc288DkvUcrchNAc2kT1vQQ9P24FVDApcTMaiyKQfNAvn24Lwrz	359
16626	2vbjh1NXsMyLwtAS5C7r1veULYNkuGTzS8Y1KQNedWXeugmTb1TJ	359
16628	2vaHcXVYA96cACbgFxprAkDyxmLmkw2f8irq1yxfiPtf7z2epUad	359
16631	2vaJLc2oEVyUJeRB2mjBrHAvyEh7yW6Lhha2aQsNjTqMs2CNHxG3	359
16634	2vad6jWGdv93gP3KfNfEPeLSwfgCjfAtWpKoLK7NxtsUgBBRqYdB	359
16637	2vamTL5g9ve33uvd4p5HBEUQnLHjPnTxCksK9BhUMUADEFCMmm2m	359
16640	2vaHgJMfQRyMCgUD6rQp3nJuBz68EX8e8kKfPcWTPitiejmgyct2	359
16646	2vbGdEfVEfNx3uw1q5h69DgT2EUiaC8Q8h4fU6uxJND7oPT4PvU7	359
16662	2vagCNEN96jwywoZe1q9cajAPzdpT7SXwbbgkJCLk5WVGrUifQnh	359
16664	2vaMhzpLzLKyLaD26vazVfjeYBJMVrWdXYQv9192ynys8f2xPP4W	359
16666	2vbRMhUKkoRQZ16ax1V8vPivgcwDF4xzV3FEY3F6kMFA2yYu7FU2	359
16669	2vbhPdhM6mXaKgf4KNc9gcMG77w27JLLFsCqdNEb7XoxY5uuUNQd	359
16674	2vaCHZx2cBhyuTcjWCFPa8FPtXVL1om9mbhu9gexYV8aeuUdrwkC	359
16684	2vbMWbPYshtYGDYRCv4iZmTgfp3tgJLD9Q5tndVMAogGo6bCPcHB	359
16687	2vaDh6rM4k6auwE2UM39uYHyuuTpb3gDEWNRTDER8ozdsocE5Uod	359
16688	2vaw3y3gYrLUkporXvVYAFKsrUjGjN8gm5g8VVihE2CWMQERfH71	359
16401	2vbdJAvYvjsA9N6hA1Luj43hgN5YfbyX4JtrRQiNqdxn646aWPoY	359
16406	2vbatLv8uMJxapudPYL68VdwN1aC1MWwSGBw5ccv4bZ6fhWdnWU6	359
16409	2vbPfqeMpnCTS2qNStTP9PzW7w2Z5VqdSMniCKo5nNVdrpXdJZ8B	359
16411	2vbJNfeqv9A8XGStNnuinsDRHWHYebFis9XCYZEN81ARPgDEQeTx	359
16416	2vaEBez5qgMTgUabpAZtYHHm9SoNo3UdtM4zdMdLGyMbj12qLfzk	359
16423	2vbeGxAo54eWmEDdMJ74ZVxpkyn9yzmXmUvWNAwVvjywzpuazVSv	359
16426	2varzfC313mP5nAreEt5AjzX28rqkkEPaQGnCA1jszW4SsAEEMVz	359
16427	2vanbKCTyno23XVFzPJ8q39wqPr2rH6SCq3ojwmoLTCGsgekKSsR	359
16429	2vb8FtdPTXDqDSPHYkvckqrgAjwRfdx3J8qLGSFoC1qF5BAtykm3	359
16433	2vbazuYs6D4DTTB3aG4w6XPekpoTgZFnqHG2ZbMNCNFcvsNpQDDM	359
16435	2vaM4QGbc8TnuKdYb3YjazPsQb1hgNJRxqx1RRJMWyS82uvaA11R	359
16441	2vbaDrCxL5vWY4jHsFzZApZj2P3F5mqEyGFPoromkFu3ACKruBti	359
16443	2vacHUatRQcqQRs97mTYYJRfCZHP9DYMeEyFFmosrxpzHjoQE8cn	359
16446	2vadBCSP6YiT6pDqYHFALMwXRTHrNb53eCZWKhvnX5X58y3HzXZX	359
16450	2vbyNrwscJ1WCx5XnNCQB2rsLN9dp26sr5b5eUnvXFt6ZNqZxWzC	359
16453	2vassvEeBiMEH77rffjH1eYXa5b3rT1oaBnDRnopXuvjvTijC65J	359
16457	2vbaCoHxAmsiwpFFhdGecRgChR1nc6EJHQsQCDsRd5ifLD6MaUJP	359
16461	2vb1eaxPo9Aej76kUkX2YByc3qLJKnHCVeaYPZFEkG9mcFBk3P4P	359
16465	2vaXX7rwr68ZVqmXUmw8GqvRjxdb8SNPWa1YdwA3guK7qyB2cERU	359
16476	2vaveNLnF7gSA9cgvLyMqJFkBDRkFa3VHn3C3z9BbhP75vM8LdZk	359
16483	2vbaTqQpuQ8BdJnQjGDbajdJzeBpS4J7MzqC56w8nHDJPKX41rE7	359
16496	2vb83dGkZw9UwDMgnoadFhyTZwHzxC2phDQw4MnKhXBGoRmaCWBg	359
16501	2vaN3UBHP8CSjcwLaAQnt6fgHnWrC6oF22KvFTc2P3Mm6j8Nk8eT	359
16505	2vbreHLkyijMe3toZeLLPtzn49fyN9jgJ5w1jQ8x3PQYvfSHsf8o	359
16510	2vbaAxvo1jVtC8ooi1ZXVt68jWs3mnVRiZmAoDQmAmHGTFwpBb4S	359
16513	2vaXpp8hMe8RKuUWW1eFMBxoLvqge3fReDezQcnWhJF9zqRedYo5	359
16515	2vbUGfPoCsFAVviTi21hJ9U1CnHAuRmuvH2AoCk1yVU4n7DBpUhn	359
16518	2vaJ1ujFTBnM6LMYexa7qxLnXSvdXmXcMwqVfVV5rc43vdehcqzQ	359
16519	2vbSWgrkwR22gYyNYbXZFe2ozuWKhDVXwFawAMRNDsnLcp3whEv1	359
16522	2vbLv3tjT2idxGnQpBt5MGphMr7yTgsWY7QC77QwaHjqZVTERci8	359
16525	2vc1Jaw35bg91jYdTEJTXbUNmhzjAAJWYzcdnx7c8bY7BhYeCqsx	359
16534	2vb8bBZWHEfRQE35fsX2xancQS4hnfPQNsdFE2m2u9n7MHx3buss	359
16535	2vbUc5dXbjjuwJpHFC4ia9oyWK3Qs63e2j8aRkawHTi6saHL77Ut	359
16537	2vbBmF7mTRnejX4FS7P6zoGKuFgxt2zCMA1kbiPVSNrahLBHDWf3	359
16544	2vbqTHCLXnhiQCNi9RPUbdLPPwpF4pBKQwb6G35A5HFRCENAUaqz	359
16562	2vbcyhw7cwrvQWqWvyEiV6cPRMa8BgciYuEm7JT7V5KnvbfwnT7G	359
16563	2vactg1H2p3JANtoULSPjL1HeWkWLRTaqzdwyG1ouBqaHH8ghWg8	359
16570	2vbXSmRkfFNZAYrQchqTQHYL3qwZgJ2FwMkS6yPc4A1n2jwCX2TP	359
16575	2vbwPFPzHyYCoPZhnqtMX6LzqbeMLckXmzCFaLxVCcoykHf6QvF8	359
16578	2vaxMKMzhD3PEPbC2uRbwZWbnLuUBMmSmgZjE4CUAtPTesoji1xx	359
16581	2vbR7nK6VNkpoKs57z5jUfREZw3dj5Kw4yTFGovLpmNh7kUgchKJ	359
16586	2vaqpAvQR56qgFWHRBP2CNcCKsqr9XnwCrX7REEK6UtNbuy8RZpi	359
16595	2vaiXnAd9C99TnGNqeff39fGkUKfkpkUeEFCuRNM1m6fAU1UjZuS	359
16605	2vaog65VQ4v8QiiMYQ8cUm5bxTbwvKdS6LLduCUD5PJL98SGjKeJ	359
16607	2vc5ccbXgSeqHA7xx53ukn9uD6RWAF1QDWPbWEnDzUf5fXkx9nV6	359
16610	2vbEAmc3z7LCjG1nbaaKMkyDqmeZtaKiFWak1X6LLxXyUNsb4Yoh	359
16611	2vbXX1wtnjehQ7P9S8UBqKtJN4deiSySTrPBQqG4q6E3tonN4gNT	359
16613	2vaSvPqRvGfvzygYhtoRdMJFb6RuVW1fWv3HdFoyNojRyPVC1YY7	359
16618	2vaqCvNv4fZVirzF5VAQYaD9STiwUDbuWE4Uic2B2HeXdXG2JTP2	359
16621	2vaq1uebWVJTNE5WAhgdLQ1pZGWt5YvWPqP24M3Fw67kbJzbewuR	359
16627	2vbPQdVDk3ZWkHeAzwXdpZVadbu8fo4SQrg8uh6UrqwA1rnrJs2M	359
16629	2vau3NHw7dctgcrUnGqnVpuMmeenkzTbMy4PueoybTRU3wCaWzvc	359
16632	2vaVG7p2xTt9x65rjhpXmWeEm8wz5BFjxig6jjFKdgRLDDTokyCR	359
16635	2vboYq5WvMmfxpXG6Fd7A3UTiWKeMguJxdWF88hjDKNY2FbHmjpt	359
16638	2vaDBWhCQT6W4Wb74x2UwEftZuQist8UjvPuvTsUcJBhnmuQCzZX	359
16641	2vaWCJCAfiFYuQsFWWxPYScjZnmtWV3TaeiCG8WJKRuWYaRcop5K	359
16647	2vbRvmkuwVLWnENoYhrc244ADoq7cWGBoduARMN5hQuCzVYSSTBH	359
16649	2vateNZ2s2AbkcgqmNiB3vfb1xNsCPbhjdwu9sGHmo83DD1FQVH8	359
16652	2vbHMTNmarZPnSxn9d6UM4ocr4AWFzLVHb9Hemu1vWgnF1irooLc	359
16657	2vacripEKS8EqaaPG6GuT9Ssy2o24uSdkXKoediqpF2QNLTAxrre	359
16660	2vc2G4YhAb99jWNfaiYHZZ4QkQpB87rqSiZhi2JybQdhF9e81D4q	359
16665	2vbY5z6pmHWVpmMy3Kw7Q8HQDB1chMGNs1ZznjRCxE8NZkFmZv84	359
16667	2vbA3nNryepLRdenXpiPw7g3HNM1Z1YjPoJJcAZs8a9i8Mr9Jv6v	359
16672	2vbpfSaAkbTVmWYEUgEmqPX7iTDuQr3YrtewZf6x7P9MUsbV4KhQ	359
16675	2van5PFb883mH2haLfbK43cFpDk4Lfcyeg9orPXWChPwSzjBoWxf	359
16677	2vbBkhF1t3LwJpqHefvL9zyEH6XtPgkDPRDesKxxNFKDNeWFQEzP	359
16679	2vbPi2YRd8j9xYFGyzjK2JadxEyK4dPYq8Dd7N5XuRNX4VyCCaCV	359
16682	2vaqZufbYPVo7Xb9d5oFAiKxxuBSznZCiKemdtM12CxSTLQRaXzR	359
16691	2vbvg1kXtVafWsVzo43dUzAWqLaBsTgJAbcQpL7SVuHDkhiCnCaK	359
16694	2vagmsd4TCfDo8mU8BLRx42AngmUfkHLuiwdD5ZfgBCeSEhoSov5	359
16699	2vc5oZQxDToNb2j1HVFEAReU529xMTYz9D22dNTrnS3naTGxG3NN	359
16701	2vbxH1FE6uhsHdSsnP3NCSkvjhU85VmVZUpYZH7n6RGszDiC9aHP	359
16711	2vaPf5Hj9h4yYfEL8uZ1u4TUMPT9QZ4fj6SerWzLYVXtJq5HdstT	359
16722	2vboyTnmq97UJdJD6uQqmgjexFJu16ouFTgWnXGACWvUEE5425F6	359
16727	2varv8WSHA41ti1NxNo4jJQXGVzGiZb28t92sJ9gDU8vQdpVxHJE	359
16730	2varkBNijwyR6anxda5Wypv9wmKYXMviHsk7BwCQDijsrtRPEVUE	359
16733	2vbdmXFeeTuW9dMbwR3FrgGfvT45fgDjPMoyRUTpSNLopWzR6dpr	359
16739	2vbtkdxwBFBKasrMXJ1uxEaiagmv26rtFZQH7Bxg1K9uPwMvhGeQ	359
16742	2vaEkEQVzsJbB8UptoKW6XYf2t5SM2bcq2BD5cmrJka6eh55Uj8r	359
16745	2vazwp8QrQYAkubXWBDg77t8yB1JAMqMijyDJ3JsKr52SQ6cWkiV	359
16747	2vbH63HM4Tmn4gfFb2DPzBbRmwiGNTwc817KCLmSoySmoYnQu9qV	359
16752	2vc4Cu273oQTVMg2QrSbsPYi5QiZ4TQTCok8PdLUGfHC9b7yCCq3	359
16756	2vaJugwzLSZQzzCPgLD8UZ1oL27A7xPtVFa4TRXTrX4ca3Ujo3ED	359
16759	2vbztsgQmhmCS8Zk76XpLDASen9Dz9n9DQUMTodx1nQ3725tnxL2	359
16762	2vbtCzhWvTdc8tDGKehvTNQjeugHsZd7KTpMN46BCkNJ1j6dFrLW	359
16765	2vc25hLMHXUhbV8USN3Zg2CMF2d4gGpPdHhbAQyhj5fC4DphgiGF	359
16767	2vbEXjLdd52V33KLuAg98TCNk7frAY17E7QEoT2MEtPhpbjshFiJ	359
16774	2vaj6DA3uRNtiFoaurkuF5Jx8B3frGSWHRUW4HxCYceoxPwFt3fJ	359
16425	2vaZ8TYzpcyzNMZ3A7gusZ3juDG8Ex378opSLtkL4vZs2DzqRxnP	359
16428	2vaZ6qahNEPX9gSHnuSkdYaY3fDKkJazusAmc3mVok9inunNVTGj	359
16431	2vbxWtHhV2ijQeAtEbN8sApjW5Nbf2PLypDrUnNWPAkVoDkZJSy3	359
16434	2vbvDUHL6yFYeQtBRJZeXcvS3Hk3QUuBh8BvP1bzVr2Yz2BZyU9w	359
16438	2vb6t9i2HSrk6BwXywRFnr62U6DWYArFE64REZxPfZMSYy4SrRsB	359
16440	2vabNQLEJz6gY5ETZK9BMNe3nqUBKVkYfaJt4EiKiHHCmSM242yv	359
16442	2vc5BKVHYHa5hsKqkZX8tehYxWWDnitQxtJfde4uJZJKXYK7MzrT	359
16448	2vbQrU9WYHBDHjVbmm1SqKB89vrngxwmG6bzipurY12Tsk7eNfT1	359
16456	2vaHCdwG6YGGrgVczef8FAXUENGpNXAP9fnU5yBevgBTCqEpVWWW	359
16460	2vbY7zjf5VyrEpXLj6DXaGzys9TxyJJo5pf3siiK7YtofqYhXiKY	359
16463	2vbybA1hxUUACALhs2VL9RUe7HRMVu8Nnrk96kCP8WbTxYCHhSbs	359
16469	2vbB7PwgWRHcDFEDcRn82t3n4fDU5rU1mqz5jawSeWYXojQ56w5p	359
16471	2vbLwpB6agcewSDPPnPmkxH8xThy9VqZna83a8kePzm2LXiTAccg	359
16478	2vaGidcfJAtXmkzPGXcpJuc3G67kFEo7Ltzudztijhe4zCD5fBxV	359
16480	2vc56uMXf2ZyTK27k3Dugpwg7YC857ctTT6bcGmQWbYki4vJKF58	359
16481	2vb7okuWKNE1UrELJ1yyG83AXzJHri1VzZS3ZfYWyDvEE8JSGyAf	359
16482	2vajwqiDUpfDhLp3dURGtMGDUhxWbpBVoRe74mApvBHKHptrhZTz	359
16490	2vb2ge4853xYSKhJwT9yN1dGZrDe2b1T5zBgzcu87T5Apucw9tHd	359
16493	2vbc2rtSGZDLqauhFCttsXDbwL6ph5f3EUEVjU1yXSpMUqkmFT59	359
16495	2vasrfFq8vdKRKjLjRgJKoU4vLp1DXxFDrZFutRp2fZXo6Rf1VDs	359
16498	2vbAppmtS6bRPQvYi4CMFrmY81W42bRGSegheBRKbbVnbxC9BHQK	359
16500	2vbythp2MKwcR9w7bniCYV9isUMU3ABmU3rnm6hyhqbKDoeTzVbL	359
16502	2vaHXivj4TdNR9hksZQZ3FoBhhg7nTM6oSLJGgoUAnbW7zHKK5b3	359
16504	2vaZbr4uJfv2oVzpXprR4qCt8cGZSC3QGQtayr2Je9Amrbe9G7oi	359
16507	2va9jfY1qZin7cYQeMqXtzEHD3C75MAQXKVFXqsqctxsy3aHXPxA	359
16509	2vbwAhRUY3MCFQ7btxsbiCKhDRYG97SaebUyzM91haVqkdRKuNjc	359
16512	2vbPvZfLj7FUYK87YWL9QyjCUXfjEJvfF15GfRKBj1ZzTFGmJAgQ	359
16514	2vbq75phpyffx4Tw3uzw2YDhT6mkyoywbNqsMca85bzpsZvGMEiR	359
16516	2vbU9yaFExkUZafeaLGV5exTRB8mmThjrPCJ4Dd6R1U7jtUUAbhJ	359
16520	2vbMYNmyWa1rZRq83dARWowcwzfzNT1wyYxSHjWhumk88yk1fMR1	359
16527	2vbnTXK1RY3wCg7AyGgy5Rp7KvXVL2xGCmkUd4Zd94PM8NYEqtzh	359
16529	2vboCRybqbNbZxVf93m7JHyj9UoRG5371gT5B4YE1xiETo9r6maM	359
16531	2vbQuM77wf8JsKxN3Ky2gixY3do98ox9K2kfQiXDbkdxuSkh37xw	359
16533	2vbNzF98xpyyFoTbeQGJyEygVCSCehhAUb7hNpg91upv7SktDH2U	359
16536	2vbHwFQUhXWKCCnn3bX8sMfaUvHUjECJVBbD2QeasYxcVkF8Ruyt	359
16539	2vbMuCZT55RFvo3GyX2c6WCAsHQRqHaZFhD5EsgeRDRD294sw5tT	359
16541	2vaRpaGahYwzK5sKZdqV8T5W6NkYPXVLPRhP1N54Tj6osKsqRmhV	359
16548	2vaaRV3j5ScxD8uqRF3QzvYJe8uQBAkKqE6j7PoTWVBXvyJUW9eA	359
16550	2vab6QntsogHFxv1J9x2xrNJJELX7CU2Q342x4ShVPojiR2AWBEX	359
16553	2vaxReQGD7a6zP6F4GLa4y4GJ1VHaBxrcYJETbrGouPAVaV7z69P	359
16555	2vbDPjK9EZUBNXrb2yiPuiXomM9x7A8tMCnKrKMJBzKBspHDVjDb	359
16557	2vaq2RviYMrX1bpn1h1cDJHv7pbDRnSb7vzf7GXB54daqVoypb43	359
16561	2vaFoijEcByEGWypvCen6ujr3Tj4L6usu99LA4PDXx1xw1a9F4YG	359
16566	2vaXhQELeUKBfbwomLPtnmomd5GuFPvbLfamqG44Lt8WPCtkNCcD	359
16569	2va9oBrop6JriGBvqB57LpHkrMt6u3G5aagjkt65gxNkZ86c2VXm	359
16577	2vbrFf1mwvwuVf7xF1J9yMPedxZxSRmRv7qxmeeusNBY95Xeq68w	359
16579	2vbwwieHRCCd8PGT1dpvFgrKquvf6vxkeS9ePPAWGhhY415qSaLt	359
16580	2vb3fKF7Lr3snqJizJVVqpkrSkhGTRDn1P6eosgGsyndSU4NCzdx	359
16583	2vbtFVvJaR9A9ZRhD9ftxCRizxvr3sb9nCDYsP6SmBDmZSFb4zgh	359
16587	2vaX3fQFn4sGxEEVoNhrfyw9bYZLVJLMD9bJ4URFNr4BWAyw7rc8	359
16589	2vaLMXuh5zeAjWHdiRxJqkcjF5neAW32ReN2J2Nb3FWB7actN7Gh	359
16599	2vbkyCVLamSpVsZU8bM9fL2YdSHQ4Suh4bbA9APS6rGYFkWTNftc	359
16601	2vaD8DHDpqU6F8yy9Gc9pyx2FT91QswycevtSndBgB37i7UC4F3n	359
16606	2vaFHBr5Sb8R3fuY5oKh4ZxRV6JuqdFMdYhQkbrJdoz8AokaH84Z	359
16615	2vatXMnxMN4nKdkMq4RGgb3pF3R2R2Kc6kiu9zH2WrjSvJtLojvm	359
16617	2vbgowrXXHXgCH3XHUNxQPEj4BhFBocJmhmd7Wh8T6rqxD8PmY5u	359
16622	2vbxw7Lwnubx66Spz4yrc46WdM6yADCzrJ74HbT7Dd7j4ASD2Mev	359
16625	2vajBjgHvc4nSE5iK85KhjdrRKrjj3kpRcBPcWdJ5QDkDDXbt7Cr	359
16633	2vagL5kAT91AReg5NBb9asyb9r7UdUqgwB6q7XGGJTeMmAxDai2V	359
16639	2vbPDdN6LX1JZeShgRBztFMtoYAbAJYji6VvLRguNMVXehckFMxL	359
16643	2vbHBmdmZ72DrtHuagLqmBhC8WavTEUcdtq9XptFRzrpBqEwwKqP	359
16645	2vaWSMzauZYJsMbu7u5wTNHGPdkLyPvxR1zaZqjqL9T4jkK6K9q4	359
16648	2vaZZwKoJJx7TjVC9pa2i7bmpZZoNxvo3VbQDeDnTYgBJCmAHsc8	359
16651	2vamBbbTqbLne5iDrHCmX4QPFagdd8aC8rYmh9Lw1KCJVKCem7d4	359
16655	2vb8szWXRf4RtgNWtJnxafjUDtQs5gpshFctZw5L5Cw9yh1YwMA3	359
16656	2vaQK2SJaGYnnZgQzPuHHtjDhtX42PENR76uMSiGcxHMNMeH3QhV	359
16659	2vbdApSnfnk7tfya8CCE3AGEhhe5XkCeME8vNUEjTcTnhNfYFQ7G	359
16661	2vbt8r3CT8qtgQzPbu4n75hVXJNLwSsrkcE87ubz31HRftTGhsEd	359
16671	2vbaFMhUxeArURFGjTpEL9JdbwrgRJnqQy4URJDkfae3bfe3XZRh	359
16681	2vaciokW1iiuzogzon4AK2kiMMHRRb9yYGD1p9QmDeayBewV8V74	359
16686	2vc3Jybcq97bW24WUHTYBhCCdDJmchGyzTc9MQr9ygi4ju5nyfQW	359
16690	2vbbEhEJuXYjTC7N4Lfby3GvkfKXnUeffztb1JEjPzEk7RQqXMTS	359
16693	2vaAKn1qW2rqePBgpFCfbTvWvoGgzfMmAGEGfd9XgKH84SXJ7JBy	359
16695	2vbEJMbaTzkJMh8jLyQAxAQDvMqeCdWKCBgS39uGuQSpg3Vt1xVf	359
16698	2vbbL3iCyLHDDWvpUSLYD9Phguaubx5NgczXmPERFBgEYQvoCApQ	359
16702	2vaBoVT8ykghSoJf1742Z36HCC1svQFNnYBsiTfv6bqsL7DRk8y3	359
16708	2vaLWmg8HTNBkUjDEaJLmjTEGZ6B85x6htCt3q7iSxo1AamZUoiR	359
16715	2vbB3RaaAtDeTS6AeRt8XP7ZBtvNcYdSx99NEeeAmRTvPMAfN8EL	359
16718	2vbSMYR1x5rtcBzW4e8uJ76H7XNscbPf1PhCj41p3Tk8DRkokVnt	359
16721	2vbwBNj6SAf56i4t8xJ4Yw2SRTcDwhZQjwVYFtUwbsgnKWoGLKV8	359
16724	2vag5cWDBbrCFDbRDJULZ4bQJanWBGx2rneB2ACxN7n1SEKLLJeE	359
16738	2vbiuaAXxkC6TYZeNTkLzLUALQZWiKkFACvti7UYM5Dk1uWToNDU	359
16748	2vbmbUdq8HA5RDKWvYyCY85Pr1tu1Yo4YnGLmc5Ha96hZf64dxk1	359
16754	2vc4ErPGbwSPjGSMXA98tosebBUUg8qDAsrjaRFUvnTig7X8D5vc	359
16755	2vaScHEpiWKkXEY3pKBNrhahcmqC1oBUgodMh5z2xs2LVDsqQ3Gu	359
16758	2vbgto93XPmFcxAmXhjEDvhFUNiiQhtxPzeKrLxjSXc3ky9xG8pb	359
16772	2vaqVH9eYt6EZoqhHywysq3vtvdLQUtLMMw51KPowkgwuE7NFn1k	359
16788	2vapVfnWzFyTq6PAb2ePebha2NfKM7yxE3iztAxUM1v2pj1DTh6e	359
16473	2vb2Epep28BSjCYTzoNWe6q15vKYbuAkEsmh9yZmvYGSjiASJPb7	359
16477	2vbcnao5QPEQnUNt96tGJ9Murx5NhQBN891V47349V6J6NFt8ayt	359
16484	2vbnLCuPFz3JQpBFQDSjnxiiBtmcbS3Exhen2hM76iXgyVpm8Y1g	359
16486	2vbhPPeVfzTnThfG3PhgrsFC1ZTBxMaqocSS7LfLG2qS2Cq7Mi41	359
16488	2vafiVpwQ8s5UfBgsSRxYd3UeT8FXa2jQp4TyhzHLby2E92nE5sm	359
16492	2vbDs26jDkNG5UUeCyjkZrYuoiQRiSVxudGkk7vWo19wbXVNBXbw	359
16494	2vbzTz77R2LqbCVrUVSBGkA3zes1kHrgVaR13cNgUPwfxKHTDX5t	359
16497	2vaHWr7SJj7zfiEw6EUbfDviyPccRXvnPzJB2Kn8RbhLbRnEivFX	359
16503	2vbytDXMuzGij95Mi11bGGikSj81WU7C9dHNMRdwLih7UYAcxwcg	359
16506	2vaCtvvbiAG9ZzZaGg2y5RamdmG4YBpfHp6FKwRshgWcDoLkWtdX	359
16508	2vauKCejMo5ZDk26X1gMqR3idKA3vpQRDQyc5iqQQi48TKYrHRHp	359
16511	2vbVHsoc5Jac9aQth9HDGyXh3yh5fT7kjqNrFCJzuy872aQk769b	359
16523	2vbiPSrxwwybUPZjAXePJYH13NGMQnrXGygWUVovBBx1qooQ47ED	359
16526	2vaYD5pZfHQdG49yRW3j5SYmWde8rmY6eFpzQv9R1mT2dcj2RSPA	359
16530	2vbmtgesJVv93vdzarwUnMHQCC6zdqdyXusEY3Y64M6FZDiBTRmk	359
16532	2vc4bv6N66ALiMvsHNHbbsqaDV6uVZbrBo4zYtdW5r2SL6xUQfLm	359
16538	2vaLSLBPtmvGsU5q8xNhg4P8PxH3S4Q2QxxyLn9AEtJYrAdpG5yj	359
16540	2vbeDFDCAmwcgiNmHUorwHa3fPDwAXGLgTXqq7WsTCLSHLBmwRAD	359
16543	2vbAN7xQfTog29DKWGQqWHJKZTc1iwAJNRF1nHVthWjRkEZi2Ys5	359
16545	2vahpmzd2RxxYwSAxeDBacJS94Mc93T6dwD7KBAaBXYfAKZqutTQ	359
16547	2vakGm7Gi27tnVoD9YwQonn4m5XAgfX9EQMPXpDfAT4AihqXe59E	359
16549	2vbvRWgedXAsFo5vSMyuakuLTaWTGVNUi3SvZ8v8pg3JVdPSRKdp	359
16552	2vaQ6vtXFYTzUZA3Rjc5VkcNYdF47hTskyCRudj5Za8JFzF6wUqW	359
16554	2vbygFy9Mq7cA9BewdY381GyRPFgBJ7RZr4JvwFYBV1nVUVjsR2D	359
16559	2vbahXKjWuC66wdzB2CWScNXxFiQpncZ2X7PzwURQXGLgNA9ahQ3	359
16560	2vbh217ZMrKiNaFWd3Zv1SrWuPuG5obq2U3iNZspqmvteB5K9pDx	359
16564	2vbjBhX3R6Rv3xa8x2M6X3tECHvbF7a1P7386ra4vVMFy24kyGKD	359
16568	2vak2KGZb9dwNovTkCwFaSQWyvk1fp8SqsmbyX1r8yWjPEjJZMTh	359
16571	2vb8s3wEwvUKE7dNH1qbaHDASVjcnfsHkBjKJTeWiSHY1YbibQAE	359
16573	2vaJn5bdz6FUVhMd7YWhjX3rgiFojWQ3Dmmbmi1SdY6rYP9hALPx	359
16576	2vbiHQEN5qcLSdexSYQxnNXdzBjPAH2Xn3KJwFQqeCrnem2TmNbY	359
16582	2vat5H9AA8AKtYEDcjo6nZ6D7V3N8ZmRjXNV6HMiQiMnjkST9fgf	359
16585	2vbNpgu5vH9TFaLiXLgyV5298VoEVvyGnmD3UwUWXG7qixP83k5L	359
16591	2vakJu4DkQFhMHAZqcJQfk1JkRoZKH38V74b2pQXhUzFTbmcvF4j	359
16593	2vbEG85gKo2YMNCarzLUo61HkXDiedsoHuZB2SA5FHph5SoBpJtm	359
16596	2vbHZv8reaitPMiSXtjbM8niowsL1a9wDQG2s5BDnLq7QKMJGXcB	359
16598	2vc3UFAbSfJpMwNRvV5xXnoAXZEwwx8xGF9Qj45a629urkZuwviz	359
16603	2vaq41CqmaLVbVuSUEqKug4EMzCw8fAp1xa1EwT5i4YPWdqgjfXt	359
16608	2vbo1yaHcySDvbhZ9k1YRpyRr9cwMckcKGiGcWUhFaMLJhvw9xS5	359
16612	2vaYQ4aGHyGjkHshqPbWcD9yags1RYgtuuDMSjtVhCo2EngdpnVh	359
16614	2vazsUudaCS55rzuyKcLnB1VaQVEAg4siWwPHC9UdBBgLREVyDZ8	359
16616	2vbEFZGcYNLbm7UGYZuZ17755p8xMerzu8g8RMpVHY8cLFeBos8M	359
16619	2vbYfM7wQCcKzhLnLHpXDrBPPbRLkqt94a76BfEUCBYcpPwJJfoW	359
16624	2vaH75ZWg7Xiq8SgT5eXD2gQZDAEeUs7tDC48VE5MpF1ot1W4hxJ	359
16630	2vc2VcDpsfVJPAhiBS6CY267c1Q8jRd14o691BorLoY3d8TSJaKK	359
16636	2vbKhVyovaWooRv6VTrm2uCUGa89VxYoWM56K1vi1hfnTJYHWTdf	359
16642	2vc1DMzfygcVV1US2iye7WbBajgVPE3tmfswjoBB6jiBwHP8SzXx	359
16644	2vanyeVAvRdYo2Lk2gxAUiYCNze1ewvp5agaRuFEnBbFHhoZyngY	359
16650	2vaDg8FbV9y8beZKzmnWrc1qKTVPHi7KnE3noyqV4tgJhQbc2RnF	359
16653	2vbVKFbefnAZTg9d4n5xv3PCgjvL4FpmTqJ9g3rVxKtidubUKvqw	359
16654	2vb9Ubmm8JG5nU6asxPSb3TN4p8kW8hrMyZW3hk32mViPSpyGbxD	359
16658	2vbfXkjoWGpDyx5nn5sZwS1AmcAbr3ZiB7T9ihEx96cM8NTPrKEA	359
16663	2vbRgExzdrTtJCkGSJjwZX6QboeBFv9qQzsDNyoKVTnq3cDRnAss	359
16668	2vb2zdu6vvc78bvxHLRFCMCEGJb2a3TVvFdbqEMeF5CfSdTsxVBH	359
16670	2vb7NjoMXQhgNxGVQiRfBnf4kpsuhHCW89CPfk5Nyrz3dJwXogYT	359
16673	2vc4wKs74uKJos5D6FBKTU41pkhoY9ArTayS9xxMKhBFwUVFmnnk	359
16676	2vb8oCzU8FPPWtCYENUeVS2AoidddPHybwLarWVHScUqMztUztMM	359
16678	2vaf1QWgUjpVb8Q8eYDAPESPvPdYhge7DMbN7UagPcQtkJs6zVWJ	359
16680	2vayYobGTqgagdteUp6Nn8genXGz6mBkY8bmwxaS722XciiYnYUC	359
16683	2vbPr5qnqtYbZDwZaSDcsMbjywcxheLEpfJUs2n6fCvbCxAY2Z6X	359
16685	2vasBwU6DZfBbMBkUVttJAwdw8e6hHAPmwnMGaFfWwfqnh9gecVf	359
16689	2vbeEcnNBQxCZYfrsZAgcrKJA9GhyogHzo1deDV6MtKvAsjzf2VJ	359
16692	2vazoykYVLicbqVmFLppnyjXsuXPF97vLy45gR7APdLCN9M6GWrP	359
16697	2vaiXkv4eirYegnYnJnwRdS9HMK9SJ2XBbvj7XAmMa9xEqGPEWub	359
16704	2vbTcGB8wCJ4J7dLuZ8L6BKbzZ4srCmenPrnMtHmcvs8BhRehc9P	359
16707	2vbNcFzdio7VyduRWotcx8X1p21K1Cky3TFxPvihc7K8fQ7KTdUT	359
16710	2vbLmT9bph65dW9WifjWFrRjPitWmQ2FT61Rd4rA6m1oqwSfa3Tz	359
16712	2vaZAStcstSn1WhBncizPrvU2mRHB4AzJSpWTP4kAEcQq9uXsHj1	359
16714	2vaX99cecVKSnkwMNRtUb6MTK5TT5bgdvBAN5WrGL1v9n4PHNZBX	359
16717	2vb6bh92hkMpDtS6PtLSp9YEDpgZA1Pk1pkDpf9GZtLsG6aiAZMA	359
16720	2vbuB2XP8zQZipQYojQPfeoP83r8JWvtrUmciizQYBadTyDHNGsT	359
16723	2vbcMscxUkuin6KwZw8wUWnmX8BhL777kS3NPB9XnzbXrdzXNu88	359
16728	2vaBs3zH1fjejass1CpR8437Anw7eFEwEBQUzF9m1nLyGisX8EfN	359
16731	2vaauAHG3UqU3P17xiWNwJDC9vWKx7vQLhoooEJfpXcrXyuwHYS1	359
16735	2vbmCufUxxMHiry72M2jHoyqpP5Nf7YjjeL1FUne2bG289bR63cm	359
16737	2vbmdJVvgwrQFcN6rSv5dVmNfEcv9YUpeMj4Wp3ZxvMVCmdDRtzU	359
16740	2vc1ep2Qu2FnRoA7JKGASX2JSpLGep5hyZSmWqcpGCkRRmNJfEUx	359
16743	2vb9c7D3AmT7E4papAJjziS38WnPEnxf3F21dkXeu5xxKGUFh3MT	359
16746	2vaXCsoSYofZADU6wiSzbwCgurXUPdRQZbvWL7nyP5WqwbD3EoAB	359
16750	2vbdR4bckmJCP2RZMaRJqjCVkrFrQ4S86KPHMzuvJunNkfyGqG83	359
16753	2vabGGSyKnyzFUXkef8ZnTuknTXhDqsAeXkbtAh1EWyXdwCiLgps	359
16757	2vb2PXuddLDCqgEzEY1yxQdA6EF9HP3gbKJdJj1RUYMgQTmxG7av	359
16760	2vaE5biSkDZKhtK6TbBWhHFS5BtZQTvoxV7inQk75SNz4vFZxMYF	359
16763	2vaS9RkAYHCUNXckmwk8SBSEQEvky6E29ebt4vwSzx9qk6ge6NQ5	359
16768	2vaXAdYYcCe8kVQqTRiF2po9nJcfHzcQ5asaqqWAMZYg5g4AoLMC	359
16770	2vbeLREzobcVVtGGmW1S3BiFK1nRht9NNmegy3oWJQiyUVZPJfBZ	359
16773	2vaR1SsE4MExAKe47jBA2Mmm5C2NuBVqjYoo5Hh64wvEr8uNAxZd	359
16776	2vbziKUL95ezsTL7jKSoy5xPqbEjTYFP6Xf38AQ2T43ekTcH1Wdj	359
16696	2vbB2wdEyFoL68pm4DH9Z8bhxfXFnKf5xVBh1f7NqJN2gA4qd9Ko	359
16700	2vbs9FD5Jzt7fsJ9mrUjsojbraXAU1f2DCgThu7GZqhHauvz8K45	359
16703	2vbvMMqmGGtdYBQTiUixRHqvn8KJcu9gnpp25CaqdyrQhe2EGUSH	359
16705	2vbvFNiSLhkoRJnxS5gJbR19AM3CbLZc9rSQMXhnuUSbJjqMfLHU	359
16706	2vbApACFyFwc9hxCcVBnkkjEXhhG9gGnyZmNh1cfpoo1gpV21Cu1	359
16709	2vb4AJGTnKYjhVwjFPUXjbsGbC1HTodEW89eeYkDpQUPQVBki9Nv	359
16713	2vbRqu7qpv8exM5orj61z5gNeqs3wUbdSGNnRiC37GNrxM37F2Z5	359
16716	2vc3Ltrap3aeTzh6GQ9yM8aSRas8rHSUvSz8E1LR8JHP5gCr33GF	359
16719	2vbHj9QaCN9EoQtJWTjzDE7hQ7Wc69gPe2JTz3FPSgZ7rJcx1pYH	359
16725	2vabWHjiEREtiCbPA8XnueJMFGjuPErzkqujjCYyeyfqmVLeTfZR	359
16726	2vbi1edbFCvVS3TpbMq3NpUxmX7yqXPfJmYdrLyaHmJCvFWriyDa	359
16729	2vbfWHnNad7fVG4RHUrW9eVh7trLRN74FjYCqYdNxdZ8DXNQxoAB	359
16732	2vbxqKPM6h9YkScGsUj8hy9FEA92syVAajSByr9ikHBzfHsZKVJp	359
16734	2vbVeFk5cmgVP49oBPUMpK9cijLJnvbXQ9NYVkqU2ZunbBzxgBqn	359
16736	2vaszPiW9qz6eTnE8pkMGuKgzy6ByL2LFg49TLoeH2xEpDMnJR24	359
16741	2vbM5T4eBhKQwvAQhkwhRiG2dEi4dfcb3EaUGzXBAm5w9oreDxjn	359
16744	2vaNguB8SR4yj5CQ3Ro3CwyBCxbo4VanwkbdAb9kgJQheV422edr	359
16749	2vao3KgKwry3x74xp9KrASU79Hj2pDWwbpeEA2pBCxahfeiKwRHb	359
16751	2vab3NEHpKBu39zjcxgZpbAfshsFwFzz9xW5Fitk7VU67YLcbJiT	359
16761	2vbHjDWCoH2KESWWQQRDbC67rLW5SZ9r7Npjn4NjfmLFbYueEBtA	359
16764	2vbmZm3KPViRAwfq3wUPmAckx93sPcBziE52E5E1ggy1w57DjZ7E	359
16766	2vbxrt7CeG3evpBnSNvaA3pdGMZ3kURnSJvJtZPb1sbJsMZYpmvK	359
16769	2vaRoRGEUrELo97aC86c6vr1TzxosxhkNnp3wYCYCNyJ5fA8wzxm	359
16771	2vbtKHM9km3ypXS9YiqK7mNdZBHLzVpZXKav3pUngYAzZv9p38hK	359
16775	2vbfjEaXd9hxGp5Paw6jStYqheoooye8WDyW38tRdzMuiJaank7b	359
16777	2vbYGgxt6fPqVK1hhMtcMeD9vWDDzkXkavYkfoYot3nrM6pUPnyd	359
16783	2vbFU9n9GcF4MewJFV4J5BWiBzrLqvSRR96T44gadV3pQaJLn2PE	359
16785	2vaLXBfh26agjQKwShm5o676GVDaraMG3wryaCWScVMzjZ9Gq7c5	359
16789	2vbfLZ99569kvEe6PsSYzsJMRS4f3RknMcqaNwuViTgXcDjnsYLz	359
16794	2vaVD5LKFSX4Xeu7FdwpAenPGNb4oiM7EMmYm69JUREmuSoe7f4v	359
16796	2vbq6VG5gFmT9ZAsfZD2gWPersUAU5hegWbzj2PjqhPPdZF8MSPc	359
16798	2vaNqCjQ7pUP5v7GKcEr9Rk44C8upLruc16EmYCPQD35u6zy8scS	359
16801	2vaxwontLLgepuVuvocFSNoXP5RfSBCzigwixRr1mgJKr8gXrgnQ	359
16803	2vc5G7XHRZM9zigA9d8QXreD6afc4hrDmA3RGsHpeQLeRvnvbqmp	359
16807	2vaN4oLTXdQXikGFitvimLLq2magAASXhUt4gUTNQJMRcSd16PRS	359
16818	2vbApWCiV2nzyYjaXfVsdTjkssg6TfuswqwGjY2ErZPBKv9JSZdq	359
16822	2vbWL25k1N36YhoJNe3DpmkWFU5ezsamKAhgrVTAeFnk64jQqjpw	359
16824	2vaxxxHcCznLSb54gbSJtSxuyCxvUqDECzueLqjZRGiikRvfY8Rd	359
16830	2vaMPzpEmgeWxjmbm8R2FHoq9x6ywxckQdQfPSZZkf5pHThzj8rT	359
16832	2vaaS2Sb5Y3yHVmvFsnx6CK75zjzZj229M7wkarc16LgY7DEexTN	359
16839	2vbVaupebPps1ptqysFaf3sTivffiHcMEtS65kPtahcdxmt7jr5n	359
16842	2vasGyE6XhikWxSymyid1LNY4fZ5k47QgjUdSiPGi9zsNbjHVAMU	359
16778	2vaHpdXDPBmyADVT1sRvB45e694C9Uqir2qpTQJfnWCTbL1MFVdy	359
16779	2vb3BvN3cKvWbASM1CXJXdsv2HRjgdAdWt3rHcu32MKAUsG2htvj	359
16781	2vbRjchXPHPizBDNa8ZwithvM9jLHmQk6cscK1taAQdRLVCxjB8S	359
16787	2vauwGDqdfcN4sraZo7dauddjBji25Ev5ZRxbyJA5Pfw8sHRiVFB	359
16792	2vb3DjsEGLvoZi47jZsPA1PVtw1fNorusMfNDieGYpzTXs2WTaG3	359
16806	2vbW7FUsoHXWCWenQexihsSCE8fCe6pCsET1oFhkVJiG5SoujvPD	359
16809	2vbqhvieztUDnnA9EzE1v5d5PfAzuj2VSnBwim5HZnR6urAzgmrT	359
16812	2vbWEXJFa9Y5b6GmuHG9rLDZpbbAUic8ZML6YqCdHLbLnJjtQsqj	359
16815	2vbVLtXhkZt1rFZdG5s9ZPNNaHQQQWW8Kh4erDB47T28TpXT22ZU	359
16817	2vbAZdkdqwdWVBL9q883UudVzbqsx9jCC9R25J73jYxH9rigsoBx	359
16826	2vaQukZx1bMEtYoySEdmiLYQdbjCYJ6MkTKhYQ5kEV71vV2o55FE	359
16828	2vbAfKKNfECGQrUun3AXMgxEUe6c9rNKJPY7U7Xc8g3gHk5dbzxM	359
16834	2vbFpZwGskPSXfbXMwakVpCFXUjvm7FBhuiRfWKyuWCmrGxpxu3f	359
16835	2vaweesVM9SSAvgiYoAPYYwv13VdWBCiGWhwVYZrYEqacC4v5oAu	359
16780	2vaBufzU8Ev4W3HPv5cXCSaufbPqKLxRV2g9WRmF8Byth1SKStK8	359
16782	2vaGKyKFTKtKGWfaGxPt4rk5YAiPWmxuLdNUyWUitkt4fEpVoHGv	359
16784	2vb8U3MYXD1DsQsw8p3RxSracSm4X2CbwHrxtu78bnAQWbsNA8J1	359
16786	2vaDMuyhnFEBqWhiZXGPBSmf1bCkbD1B7TrrmYGtMW7cTFsf27z6	359
16790	2vaXdL6kHGGNUSCSdxbJ64q6pPpGgn6rJCQNgJTEoyg3396ofrt3	359
16791	2vavWmpiT6EVm5oZ1ytpVs4txS113CyNi83ezumHwx9EpbeeDocH	359
16799	2vb2f5jbGfAjYWDsFu5a6ig21bMK1dQpZudfJxAek1odPLKfLCJB	359
16802	2vbD33XNR9tMyYzbjB9Gx83m3NiGZziVjmp5LAPoSmxWEAa9bFEP	359
16804	2vaTBFgsQN6GTyfhLtUHHffizmGmmGXHCnz8NfwajuKyBrMuLCXB	359
16805	2vaBdniMMJ4ADDyaX97kfm4ip2WjwsbNXAN8YeR9gmaXNV3ZM2M4	359
16808	2vaMpAK3b8XjFEVS5Ume9x5xG9AbbLRHkEf9rcddnf8g6kg1eWFW	359
16811	2vaNwpq1x8rA2XoJq6LCfeYZ8GkJRe7SZEQbM4CewGrNej52B3qv	359
16814	2vaf5dcER9pazPRZ1fm7QkqJnxP4A7cdB5XEKLZyFSPrqcLLBAWP	359
16816	2vaoAEzynsm1UddMiA54wtvNWJVbHF8c1g7k9f4y6UwaLoThkPSR	359
16819	2vbH4yuhxwTHZtsKFrrsuyXSc6J7xCLskk82tJgG9tWTm2hZBhyE	359
16825	2vagy8DUd9vnojbGhqnVGmiaTrj1d8k1fYJhRvHKdg3WBjzLDgQR	359
16831	2vayB294BqUjUrQz4Gfb3LvRGd9UEQDHjvjegyEzrkCu4cmVZDtS	359
16833	2vbwohdaGkk1nWQr7AxDr1NqzBpDKmAFhwt5XytyKAjiB6FeUTLx	359
16837	2vbC6vWMC6151rry1oAbz54xKPyuUGsaJEgyREhyteNvZZZnwr6a	359
16840	2vbro94msSJ5zaaZUFUDpexvcyvsiwTMYxVLz8n5vEkQCPSuWuug	359
16843	2vbKtV6rHhmTnnm8LfL2Hr3xEu2pSmcpciT4JKf128zWmnx7dKUf	359
16793	2vbJfgjsesoSEtPTCH3ka1RETpRKpnsjkgj4T8MdNwvcSuWVvKsz	359
16795	2vahaMkHJUFnsxpLheVkteVhSpUdfpzFpKpgv5WkFWDLoadFHbib	359
16797	2vbRJfgh91NGaGJJiaZ9e41Y4Ff35Rc8rFqdBnvP3KUzxugXWYyY	359
16800	2vbXjcqJwpESr6gTYaxdJYLbMNydgwseKTFnSQLBmgz6BaQ4T4et	359
16810	2vbggQnARxN9kaWPXUeDoemaJ9vEfNqxWM3ukfcUB1YFSdoRD2jn	359
16813	2vb8DNo6y22XAPCWhe19CWsJtsyJKjam4sqhQe5WGRgDqrRSJDSz	359
16820	2vc1zhtrbc8MykzRq4sMniETcST1zfo9FBaypeC7EecNURo6tgwX	359
16821	2vbCZt44cLY8qAUdFGjJoWSJawqSbDtVmGzBnrCNUBBbPuLDM9TW	359
16823	2vbKQPKCfjnG6cRye7hXeQqnhVwbBRQ6XMphzKaF8VDUxTTWr5Zy	359
16827	2vaKxeDSeeVQdNbwWpFCVrHLd3XZsAbWqQXxvauPw3PRJxskeHcS	359
16829	2vbu5koUBdTxtLU8fC8nXpBeCV27U8YLAjq4TKwCDbYZDPM211Ts	359
16836	2vaYyNc23Cm1QzBjvLrxUy2YJQXbw4czHzaKYZavk9R5rM8ovP3q	359
16838	2vbinWhaWGoPxmyrAMsNrbgvPt1uwurRuJeyr5E8WhiHVRBuSPhH	359
16841	2vaSfNWxX67ezyv25LeZfZyKuwcyaoyE1ybCWvEgxSSr3kBoa9xZ	359
16844	2vaPVw9bBsNNNwd84dFuz1rAyAVsAzFz31CRjA5L494harnjqSor	359
16845	2vbs5YMvbyQUDhQaZdzogFgKYmmfgAzWSaDE7ZzV9NBuvrs79FMo	359
16846	2varEj4vG9m4E1R9qZUZ8yee9tosF4pFNWPFNretoQYJzLcS14tK	359
16847	2vbcbCbYE3fq1GqWWvLTnATA3t8w9QFnASsF7fiWrwzwdJseautU	359
16848	2vawsEYtavGoe2faSF8k99XYxatKe5Q3qPHY8HPzVeyfGPZajohb	359
16849	2vbKSA97wvnJUL6hp97jhyV9LqRJYLy5KM2Czzg8pFMyR9ze4DQC	359
16850	2vb91cZLctcqaCZA5hEgrHEabpM3yHfDeCXjSpFiGQHT6nEaLGf3	359
16851	2vc5pFp175xHVfyKRxQ8AVVstuUnEqXX4n4N5DUcvZFQi6UhnaTW	359
16852	2vbAxE2jycZFd5uHaeQnP9pebH7NRSp2nJdV9StX9ojvKkXbbqxg	359
16853	2vbY18DZAFjp9q2jE6X9CwER4FnizokntRCF8mjBt9mua4H7ycRh	359
16854	2vbfLXNR4549zKJs9i4hVrK59SMhVL31rnHoZqJDxgN4iiBtVhdY	359
16855	2vbZAtFApGDSujRMjkMCWToykLwSkiMoMGtMKmHGzQAiKSwz3akF	359
16856	2vc3wZVSQDNn2wT8ZqNN5sZrpeEewodPneaNonptC38gkGwNuAmN	359
16857	2vaRPxykJFmGoAGiAFHVTNjVxdax8HP2d3Qo9fRAXBGSqvzXoCXa	359
16858	2vbW4mHxFCyu6xJ63hPVEe31tQKSkP8ReyqGK7PVWaqra245dvnn	359
16859	2vawYR9bA2tyfJukGhB6HBtyqGkBob4ATuAJAkLL6DhumZCVqvC3	359
16860	2vb95wthmzjHhV7AeGK7NwvEQPQveBjJzoisaqTZXUZ1zj9GfmG8	359
16861	2vbh9b5gBC7WpcmT9deFyNTDYknfPrrMEPkYLzGjMJeoQ5BGj2pZ	359
16862	2vbtxK4fE7obg6eTRUDASWe4cF9U2LhWKME9iTgmv2J4vVDWLvXu	359
16863	2vaDZQowAripws3rUAGD4i1kfcK9zbU2xYgztPHqTeDR8BoPLt9W	359
16864	2vaSVC8wbpDKnDKjEwb43zZmkZcyavrDvNokz17e9b8pXzvyYegP	359
16865	2vbeX3dGf47Njsh8yTyFg3UsbJXcCqQJJPFUbmLLZ7dGckyK6Rti	359
16866	2vbzWJUdQwmKPp9aby3hjf8HQtph4guS967TYoY1LWi8msFu8jBX	359
16867	2vae2xbvB6zMb8enSX2oCYpQoztUK1Hn29va4SLWYXavaK6mPJ1X	359
16868	2vawBfdaGUhX3DPgsne1mHqBPmjLFbojC9g2dFrBWHqymfx7nkE3	359
16869	2vanY5H1REyhcHizJhZ7xPjKyuQ42wgCpEJVusiA9qBM6EFpFTx2	359
16870	2vaWT8PG3sJ5B3AeiBB1RNrmxJuj9619jUpbsKqL4HcRpQKrQ13g	359
16871	2vbtVjk11K92o8mPoVbYgMAPDW7McXRTMQt1baUT9DvspcRiLF4h	359
16872	2vaWJS5pjidXiR6WvoUg96fudUPoso744xn16akdCWZYvBRgL3Ny	359
16873	2vbW3BKHDAJG8RkxP9ttFJrsLJwvE7dSFYTNMjeyEQrZitTWNbnW	359
16874	2vaKJRA9Yc2hHEFH1aa4tJQ6zHtDiS3BZJdXG1DsY1iBJgfWsTbQ	359
16875	2vaXBgqvzgREFUEc3fvu1DNBGszMUE6YjjpS9jedQi2YqsuMyvN6	359
16876	2vaGtRMruKd8a3cquvkUrXmsLBoTzUuuwZe6Pnabt5emf7Nb98Xx	359
16877	2vb6j3yAfLT5ckt8YhWSM7fegUaCvutA7thWevTgZikzma3LsCzf	359
16878	2vbYVtjQjd7hDaaUYz19rxwM3gf3vsEtkwaEeynvVjMWBtk2Tpn7	359
16879	2vbdjvSM7iK1k78rEWc1jt1Teo77i8xSJTo2qNqAZE3KoEAF6Ksp	359
16880	2vaYbYSYebwiAZqQy2c9zxNFDsohdmQErcN6B7WqNYcohMDYfD5a	359
16881	2vaX8Pe7FxG1nsQwk2dhJRgQdPZCrPxc7kHWUeSBNc81M79xLYUd	359
16882	2vaszYaaEkRjbGJdvPZEnhE9K5hn27fXCeM4C5wQDJDpeSZEoC6j	359
16883	2vbGXQr2AvTSKZoQVFdccwvLwCp5XMzkdwNz1CS5J2TzF6U5PSnx	359
16884	2vaqiJ4UyHwxm4n7c9LwrD8wodDqENKBANtiKQWTE3BzruG7zQsf	359
16885	2vaXNj3dpfypg2Qm2SzPnsecauQHDv3tT7cuBDPwsmQNm3oLvr9H	359
16886	2vb9pwjC9gLndBbMUH8gEvKt7NBDtwDBt114ar3pBJ1qbrPetC9z	359
16887	2vaDScWJ6SLg3PgVy1RDQFdHvyn3X5AzYsbhSB3cvsVNjYEbtAeo	359
16888	2vawtj3LwDspf7Qcqgaizxqotsexx5LveqCEZ5JtGU8TQi9iNvKe	359
16889	2vaKxgtXBzS3D5zuaWrFRazRkcZKDj8UE8G9k984kcDhQjUddo2C	359
16890	2vaDxFX1K3GQsRFksesWMNuS6YQCv7fFWfqKUKrrCFAvdbuqnqfC	359
16891	2vbTz18kUGapCuyF68K8DaJnKhAkQVdr1sCDE1kkpyFALbN8N6hA	359
16892	2vaXSbww959rU7WeCdZFdWVHK12D9PFCiXeMp2hZqJcjdUAqb6C9	359
16893	2vaYHYAQk78xt24f9zXLH8ZDeAaXVauxP9abx4BC9jj3gWGo2222	359
16894	2vaQsZy4vwhtQnDHdieyXGqNW1xaSQ2esD1AEYxHzNNJLXxxjegK	359
16895	2vbmHwfRw3HyXBCsDh1bzrYJqZvft1usbHNvgqdWy6cP3uNwHHNu	359
16896	2vaf16m5EUX1szW4tDEHXMxcz5DKoukU5DWHxdm3ZyZJycYZQx4U	359
16897	2vbZ8CNUhp6VwFLTHtMEp7hLVs3dy8CETbg9zqQztb9UEbVkanbE	359
16898	2vbkHJS4PzF1Y62kB6hThq5DNoovhmH6KPMMcS7uTCWJbUgKbhRe	359
16899	2varaVip3TDXYvsBtKFgM852REgLDGvm6JE7YSqNs4yGPDKC2z7K	359
16900	2vb6fECGtoqLvLxRGoS27vmSy5TRnsEVRMu3Y1GYVLy3ccPhRyrU	359
16901	2vbukbij1GJRYT67wU8qRQ3ntZgq2K36o8cF3wdaipX5Txw5T9n1	359
16902	2vbpj1XNmAk4aAyqsbThbdT4dJbAxuTGrFSCTTM2XHBT7bYnf3Ss	359
16903	2vbfKuYd5kuMmSZVWmPDefAKHUKXbJtbVUPBCPskU2yjmftSoV8J	359
16904	2vaQzFXwtMaVZDHSysDQ5VyZFCc941hGcsn2Y56V8Gq9B5CrWb1K	359
16905	2vaSpgjnMDBeq9dWuTQipVEgXGRBhLHCT6MSAwwKErQ3td1uGFCe	359
16906	2vavmoPFuEcAtRXcuDHP6yXGZ6q65seZLKBMHpiCb5KAvQLZ9ZZH	359
16907	2vatHeoMS4qh5EnZyNz8uTSHAzeMdwrWQxTEymhgBuMxjcRbEDf7	359
16908	2vb9DJmmFLZj1MBCaRGJcrvQqF5uFa4sBS5JJikBesVXgw5XsE9j	359
16909	2vbnry2HKGt5vu2JPNBPeFDB8GbwJnxRF9g4Hq9kdMXGWiKSmbs2	359
16910	2vbuJgc9ApaBwq2dRT99MdjVkp5FWaSKQjuDfBHxn9eUTESWAgLg	359
16911	2vbakWEUFo8qEa8RHbNvPUAEQXHvCkQj3wzZWouJvZUprTRGsF6m	359
16912	2vaW6GakrR8zmJiiSSaXpq2iQU3Ci9xbaGCh26UVLEqVr73JLufZ	359
16913	2vb5YbdKBtNJSo2eEctfhDFbXhHTNU4D9r7yVk1v6yGzfi2Pcf5U	359
16914	2vb81WAgwHx6pvFZYBhGbyuBycgSVzukhzCbaNqQbXFM5Yw5vDx5	359
16915	2vaXsRv7dEGoeEhfoPqvG6uhK6aMXZU519tVp38K1Y1ZrGeYv69A	359
16916	2vbMBjiBfzsnSK2b5vDzx2DCi6e6Gj6vskTV1RCXxcrMjBakGUVS	359
16917	2vaDhJsZf1NdqzwP5qAhyFSPvcDXt1bYQpn721JHZas7Rdp3LnbH	359
16918	2vasjnVmLVKJjED1mAvVmbfirnxeUhtUXdsinqSJ4SRhS4wt81Cp	359
16920	2vaztZuTsLCefgcXF3JMFt6JrFBGLJmM9dAd9ZhZQumDUau3twVF	359
16925	2vaRypgLsuDJsPCpwU1umk7Vw9G9HFmuUtk9qg1QvSiBzDE2mUAx	359
16926	2vbu8C81jRuZ3CtdHgxXtTpTHKL4KxDEtGHbkqEHqhVNPbBGzmGR	359
16929	2vc2JYHZnGaPxex65mwu2nzRSrZeBp8xtpvTVMGx8WXdQitpNHL7	359
16933	2vbTu1MuvuVieNAzteTeAdJWLeg2wS9gqr9EbcbGWuPdNta5NPib	359
16935	2vagZpTConbR6G2tbF6sFBRFNLeP24EvNrAJv8H3633NQCkHoKCs	359
16938	2vapP1GZemsn51ULmBxFM29NGEQoaJoGyJo4kejWdUJUucAkoKbN	359
16944	2vbkBn3ZSjRp15xuerqU9G3QAZ9Lh8qyQhuScEqazNFdJCCwCDf1	359
16949	2vaDiAJe7qFSrRKr9Fj8kGpxdpJSauaeDNMeAu56xAbc7TY2w24H	359
16952	2vbenXnVCZqGkHvYYnLBzX5zSvrHEbvy496LxPU9By3Gs6wQBXBB	359
16954	2vb6LhPFrKC4xF7w4TsiQV7A1eWcdXw7on9V5qt47cqjSFSgFDq6	359
16957	2vbN9yyxuXZfWuy2MnVZwniS5tqraHqHV3ayQEwBu7jfE7hkeX9u	359
16964	2vbs8sEFVxBxbd1b84gsJPYexCy6ocuXZi4CmTrGbRCGPFpoQVMT	359
16969	2vai9wYgqa64LbjTPifpvkaDSRKq3EwskrrczbhQe54de6qYTbf8	359
16971	2vahyz183ag1VppNsPRjPbsVLWDvqknitzUH2enFA47BWrsh2f8R	359
16973	2vazz5mr1ZTDf3Kw35iSQUqXG92sVR4sGMjAafHNjrNt27HHqaCT	359
16977	2van1Q7SPqJfZY2mf8UP31N55BoYmm8BXGpZgK3sdvLeDJ4Ye2Do	359
16979	2vb2dEr2A1SzSUEmxTzxgmCZ1m6cLvYpSUUHX3Y5RHwLeqGuvD6N	359
16993	2vbPUsPoJMjDXkctQP6StAnKF3inotz9E8Yq4Mhs1r9xvqgD6cbQ	359
16995	2vbUUMwKhkemoyHiw4TaEg5gLQSmGDDazjEU56kXT9FKP72a1TXG	359
17001	2vbCxYNQUxQDdBhSTNq5rQFZ6Kfq1c4x4wWbvTp5nWo8KXtQy1Q8	359
17004	2vbJjmXpijV9AiFb7tPTzr8jGpWXHqN1GTSHeoSg7ryeoe2QqYuE	359
17009	2vb5MYSJjRcBxiZYihJ17rDVCCwav6iALU3esvDdrVWWttfvMAr3	359
17018	2vbSvkikoR3Gup4pR89Q8Er4NaH4GgZHEBQT1rcDPhRcUJsxWt8R	359
17019	2vaUvCFZVNkUeYhkB3Rr774RezdV7f1mvxUurYkUcu8bRHNuzaCT	359
17023	2vaDGuieGKx9oYjCdbNG97JHuhKzQsohsM29tEQFLHYTzQShLecV	359
17025	2vaZ1f1GxSEeH2qdUCsbo5CQWU5JTqAuNvPw2zFnVWfDWaqVMRmz	359
17030	2vacRyW6rWi9aKiUh5fZ27FQqkBce6euSvexAbfK9ay2xwgyk8ba	359
17033	2vbz4FvwF2cGe5tZq9Rh1NvMCPVQE4gRCqkZqCqHfd2mM5ioUmvV	359
17035	2vbEo3ZingSQTeUAWwUrzN3BWEaA2ZeYyZcLQ2wUiKd3SkDDbS5i	359
17037	2vaZwShAHce7YSF2FVVGxGoVap3g43UBg1YTPDgDMgaDmijhDZos	359
17040	2vc3Bjr84CkYyHaNhCNQKx9c41U7y82JdaFznXwCHy7RarX2K9si	359
17049	2vbAzNcgfjQ2E1jRUyX7CGAjezkdpM13fgPqvq9Tb4k4wUtpEQGd	359
17065	2vc3GSpgeBpWAAvtuQskLJDvzdV7k8LLjGZQyXvgkg7bLrYAxm6V	359
17067	2vaBP7VEs7MsFiWD9P1YG2t9D7dngPNC1MWnbyQ4KgeTvcNpNhHs	359
17070	2vb7h5Hg1M4V4YU9HX56cmQ7jSJT3hAMfjmyb3NX8F3FJZEtWQQD	359
17074	2vaRDXivhu64xac8x2NPhvgBavjy5FSiAB7WvtGWUQqUXDwEanax	359
17076	2vbjU2oiRcSAqjugRRcZNpf4uVmoVojvyKPt6o8XiW1uwHEaLHnt	359
17078	2vbAY663pGTPMpcBgvJt8xsN6JvoSm6Zf7UvSmzXREKaihQxe6Qe	359
17085	2vbmBcNmwVJkQ1ZFNef2gwNotQ3onLj8NiUofVK9W4zkcHyPAaJh	359
17086	2vayAp7SiYWqLCoBkzpYs1Wsaz937ipq8e9WSuEZdu7pHsthf74H	359
17089	2vaQVZjumnnfyAdZjm1euPrrHTQPMLf5odRfpfXgw6nC9Jd7A8VM	359
17096	2vc1vvA4hnBybhbuFXoGmQ7cucJSHm8EVtF1wponKGwC7cBTKKqE	359
17100	2vb16yhdeJJ56VAagkNb32XqawkPqeAFiAHPznRk8NakQnFqP9LM	359
17103	2vc4QEepKz3q8MSfVxoFN1bNQWHrwKhemrqwM2sZ8wcE2QWDrTzG	359
17105	2vaiCgMfKovYuRuQSKM2g7s2ZDM3PYkw1EQQcKz42BxeZGq1WQWb	359
17107	2vc5LD2HqVhSt5VyvZu8NneJmKTUCkUygW3PcL1E5gHoX8fsoQCo	359
17110	2vbutjXrbwKKMp27aaZTTaaXXd79ByZi59TVXmBZxJRqx6nqBD1n	359
17116	2vaxLKc2EHWTd8URXFYs2s47mrn7wLSd8DQXScgpEu1QLQGq6aQY	359
17118	2vbez55SuMsMpf9qGGiFb2Ao6HQ47CuVAsXLjDw8MdMDWHiCDHPo	359
17123	2vaq3wtZP3p4rcZTgBiPJDcuTG1oanqSZD2hsoVMDKQvjMgkMX34	359
17126	2vbRoQ6pSXXoRntehGjmJW4qSvuCHAHzc7So6recWVFxZF2meZaK	359
17137	2vbi2HbN44ZWoSQ6TwcZyLpqgtYv1ADDGLf69ADR1DGWpf3jDxXD	359
17144	2vaTyZ1HLMHimAk3f9cvyxW8m17GAf5McDCyk3SgDAMeh676hFwL	359
17146	2vaVSn6bqpHAjt4taXCvz9EzwZZqksyEicraGEXaL5qzmjUUKBEy	359
17150	2vaNBEjmjQ4CVjG5QYam56BkB6HLYzZc2niTGQofb16X6Ncfddmw	359
17154	2vbyG9EQSVPpLDRt1X22MFTVQGGVGd9j5YUXQYx9AyhDmcdNkqm2	359
17159	2vbFXLYivDvgRRL9Byx9B7GwJwu3JzQCEouot1yC6WFZBWFq76tP	359
17170	2vaawefCVj8TEWyhDG5KjdkkG1Zfkv2fTKbdzW1F6QtxJb2YDRNW	359
17172	2vaaaAKiBTv9mnySiJGjs1ntRtqZkbraHq5knMF7W5onrcadHKHw	359
17173	2vaJ9N7ya1Mebx5LKHt6pNQoXu3Xjm71hguHUUfpFYMr7KgxLTU5	359
17177	2vbYngdATeKT4Eh3DSRxHzTCzCZe2JQRe29E8UsPKrAFCsthG8CB	359
17179	2vbb7QtqpqFXXunxwn18xyyaLT11qNzLPNku5b7RNdQqfqZLrPxy	359
17184	2vc1CbS3J32H1PfGWXuYoj63b1b74QsZuJt49b6fhS8SLhQDJBKD	359
17186	2vakXXqK3RGKZ73KxeUXRnq5n3PgAWSCtuDLFJy9ejpJe48WK687	359
17188	2vaPF3jQ7d8Cqx4LSFLwpkDtwQADdh6QE2aGaQZLTS1zRPkgpAme	359
17190	2vaxsg6RumMupYxYwz4T958JmUHsMUjvFwPHwyNrhoaX2wDuXxzo	359
17191	2vbcapJXsxsGvgzUnNQJqrzZoSED3QXLsP1xUC7Hj8kJExb5WjpH	359
17193	2vbbUhrsjN55q7hduXzg8d5cHTpqgGYAP7DvHkqFESPGdtCT1HSm	359
17197	2vaEhQQLwoBnnn1dJENtvdRJ7QHKb64i8oRYmn1J2zF1jJvauPff	359
17199	2vaK2vevs3T49zxt5DwRtHcYd6kkwBsMZdp7UqVGdo9yBWHtxz8Q	359
17201	2vbHPzzYfy7B7G9YMsN7Twt3PrnTxW7JTdrG5fmRnXMCQaHaU9rN	359
17205	2vbBdu2AME5sMto1Re6NA9DhMG66sDDjQjVVr4JE6yf6fUuLfsCK	359
17207	2vb3Q1peTnLZVq6sSSrguAdfdeDbdkgtRqRDsaFKfDfdBWon1NVu	359
17210	2vbtbEqgETPQ4nwJKKCN9Bon4yTjvU8qo2oCCbwJUFxWqo3BGCRQ	359
17213	2vbfrNj6Dk2xgfrcsVyebgJdg4HPLunqxkXDcpU3A7ZdY8jjZKJX	359
17219	2vbdVEtVoyBmQFett7AvoXFT49nBRFqBB2vUXWuZmYeeNgoqptCJ	359
17225	2vb5tqvVDVDPoAqJy5T2ypH8cvn2DY5DVoJfGumMNTkqWoWVfbsu	359
17232	2vaSt92R9yWJE6fnvEg8KHZB4ExC1xD2pnEgNDi3vcEsJvoBMCHa	359
17235	2vaqbLGpGUrXixvdRJrK7mPPUg1k4wVykhDjKKP3Axi826SDDwd5	359
17236	2vbrsrL24eYVHCtpmVfF3MLW9FFYY9R5kB2wdvrM4Yb7LLtpMjhj	359
17242	2vaMuBKLizTDbouch7Y49bQBWPPoqg3txTabDx14HUPgiV8vC5iJ	359
17250	2vb2ESve5qfLjrcFGReiJkWZUVzxd9fjcpTWBBJkhyCWXEsC93D5	359
17251	2vba3JneF4hHXwGfoiUHixjqzGWmvjC3eA2RYEVYNySd1o3Cbsgc	359
17253	2vbbBwvkGMovTJQeesgo2pwmWwUZBp54MqqiCEbzQJruGiXf6jXk	359
17258	2vaK9KntWEQ3PrJU4wkKoPq9SL24oQFvSqLCrXPecFbKyAGw5Fy5	359
17263	2vaZcwQLwwK32dnYyDGeXpPoQzN1hW2T83XzWXsjcAPuMYaa5dXA	359
16919	2vaH5Y58WKk8P9ojHBoDjQRjYNX2f2hoyAKtp8TetoV4VRe4VN8R	359
16921	2vbHKK8sTCtW75tc57QWfhJS5RKfZVVZhZmnPTYc8kxsvx77nGWt	359
16923	2vaUph1FqDLaBjX2kgDg1ZCGowQkoXy6hb6igRVC6G4QFnEnj8Mx	359
16924	2vbDphHwNAPa3dGS6XNRUiLZwB69KBFpWmbRyfgZorPQDJBLquXP	359
16927	2vbKmFqtcg2LmpAYDVgfRSNXYmVD49NFxvirFewPoUor5cVAnkj5	359
16930	2vc5X3qKmyFcN9kj7NTGaENXMnDAsBGZwGaFsBrFUd65PvJH3Ben	359
16936	2vbSEYoZhDwYqvRZtHHfLCeAvfsm326nLQfxrzUAU7kPZBnqdE2E	359
16941	2vaRZYwnPrqC2dRzAPvkpiC68QhbTqKnKVy9UUyxpzVRizxKfEmt	359
16942	2vbje6DKZRTFb8mZx4cqb2hWQReZthYf8ip3o4MLm5sm8y4isoFc	359
16947	2vb5BB9HPi8GxSQwysPBUt4eEC4FWVXK7k74yHLrZeTaEnEhcvfa	359
16953	2vbRoUwdUw3sFsvN9yykgySHZbPAe8CgWSp2DNQDictCniYVCYyd	359
16956	2vaoZHrRndqG6tENX9rC2bArhFEodMx39ZuKqkxqzK2BFaajP5M7	359
16960	2vauNhAi5QhJiJNR7XXUzv4JPHv7JYfEsdYRPy9obFZiwnEWCnL9	359
16962	2vbkcBTAf5RL4bdXfNLVm8ACSroiVfGQrqwoytMMeLejgfqVn8rC	359
16965	2vbzdCWA3tjvzRsjM9M7XQG5KzseKL8Yk1RPTuAEkvorEyrTzzXh	359
16967	2vbsQWnw4PAMQtkbjAe5Poqipc6A5w3TfrMiUvM3deU3iivwLsBL	359
16972	2vbnKMJiwGuLc1oQXARisfcNGDk6UgmC3u1CAJcpjqXiM8ZyKvDS	359
16974	2vaPKC96d8QE9wFn9XZt2589ZzitQ7zXQNZ4bU42GRjxvQwqtSXM	359
16975	2vbDTTSi58HQJG4xqV9gXvKzks1PYJKxXfrHzLZqKcJXDrJpPDD7	359
16980	2vbGsjrtsTpVMAxEeoQWs4tVPe1i4vJv2UVYPb4NNCYhFvV9mtMu	359
16981	2vaWeSmg5rG5Yet45XpciZYurwPpRQNJNUmE3THfTkFj6grzqeFZ	359
16983	2vbhMXfnFaRavkrWKW3hH5dr5skGPLj6eJukEVZRAcBDmH6mVEx3	359
16987	2vaV9XckWzYT6L7DHE6MZcSH5ARwzNEYAsJX4YAhFpDEr84f327i	359
16989	2vaKoE1doAgiVhkruq1Cn2Usd5U8aAC2J7fCjLtwYnLqH2wM6saC	359
16991	2vaqerd3J7BB6UsE1nWzDPopv33YcbP5oWnTbv4HRomCqiBvJTKz	359
16996	2vavgLA8NGVi1hrQQoizkQnaHnbLQG8F6hafLwAD3uo54j6HzzMQ	359
16998	2vaM9en2vrBf6Bap1pPKcdeRCK3xNz79KadiCfjTVDPydqTmdcCb	359
17002	2vb2EtyXpRmn2VVYFPosLgNtJBQQSoBNT743fU3dTvqeKDjzc6G8	359
17007	2vbVRZYD7bJHcLz9ej3yHxhFVn693oZ5xo79MumP6qmwXPSXUGQ4	359
17012	2vakyhhKCRLGD3xR8zV8wfv1g869B7UMFgwo6t3b9WTZjBKCHR2F	359
17014	2vaCnV6gnUSaHyUPGKv1hVvguT5m1D62ciF7WbF1v3SwZGMFirmt	359
17016	2vb9M2xqwGRTSVLpZFbBB7CUBUEujUbud1tcoCgaifmDWxWbZEjW	359
17029	2vb7yd8dZ9kdd7ZiVMwWYnNVyj4kej2P7Rq1pEtkvPYj2FkWm73q	359
17032	2vavv4yLzMDZzrGQD2WYvcADn4EFXCTzz349mQpqpCxfBQHnNbMt	359
17042	2vaoLWXuv2Q3YmZfUNxu7jbifQhkTjM3jYZ9kcLZJriz3iJLoyaR	359
17044	2vb4qH8Bx9DkJ6zYSRf5pu75xoV2nnmxVkGMdcvGGG9MJB4m8KXc	359
17047	2vbeKw7k9SYTxJHWYri6RSCMYhKamYoXL7F9iSFRFt9SzPQF8Cf1	359
17051	2vaboVdjpMKbLyEoHPJ8iDLZJeLQEH6M5biFLJAfEKHYWCjoeyGx	359
17054	2vbSVPuCFsy2zY6z7SZ4pXxfxvUPkGxMm6ZryYwYbkFTf8648QhE	359
17056	2vahxoa3xUcEfHnzWz3jNaykLj73J71Y4p4mMkzX6yHtfrt8LDtm	359
17058	2vb5jY3vFsRuqqECKME3ovixFhkok46tUdJ6suZ3htmjRewWSxKw	359
17062	2vaa9n4wwg5pqjbt2RHQYVyAQ4acqciFTsQmc9qY3kTwCq2nx4BQ	359
17069	2vbL63Y5yfQUaBhzefCBL3F2C84oPPwQHbFYV9tcwZTSzKehixp4	359
17072	2vaN763qDin1Zs9aHKhYByoZrJigkNZySkdzM2PwBrENfomQ1T2G	359
17073	2vaGU1AtjzWAeAq2RYKgptEq7Ypj79DtWSCXbKb27MozMDU82SQv	359
17075	2vbKxDKWSdhrW9Aimib6FNiJfNGXj2U3CGK7sGkS28xv2uEq6wtL	359
17077	2vbAgqkprz8venkKKeWKv6sptuS4B8CPDJpwegLqvbLd37dyabKs	359
17080	2vaXg3p8E6StHCRktwnrZ81kG8PM8RBehw6d57gMTcHTdXLujceG	359
17088	2vaYbB6AemMuUhahEQgj5VnpmEqdUzMkyLxPCB6q8nWfDsnH4Ji3	359
17092	2vbq4RXS3Vj2hRsAaSAFQg4Ep52BnAyCgwWhXctQc47ZsTLMYEtp	359
17095	2vbcHokmbW2Q3G6profEANKDxSaqwyXdtp3T3uCXXRniTwsoQGcQ	359
17097	2vagvrrK48VAC5gA7JPnNoFac2N7T2bcxN2hwwc9YdSof4gtvGAd	359
17102	2vaiBK9pc44x7q2ySTwxCTvJWLmr6yjgyhNLVuVEZDMQCW9ST2VU	359
17109	2vajqBPzCNaP9ShkCH9w49pYDURsBNi82wpqrhPok124p2KqURnt	359
17112	2vaWDkQBoxatFGF4AnbowuqoJSAP89ay8W2GdcRP29dBFgDwCVbE	359
17114	2vaq2T3J46qchzvbFn6HwE5KMJoaA2DHFxpHsQuGkx5Q2yUQ2Cxk	359
17115	2vbfBNonJgLYBAxH3PYGnadcbwrBayPSB7XegcWBvgZCuXuaJZC7	359
17120	2vaY5W7eJgVNEzh4ebmqawHv2K3zZ13Qc9GZaMz5vxbFAJAUmKWj	359
17130	2vbvQABr7mGDa5G1KATsHeSNAJqtWzHPrgbmf3XGrUWJXBchXNtu	359
17133	2vc3WyTgGsoifZPb97o5pxyGaicDYZHQZgdooVmbeJiRqRsNueaW	359
17135	2vaF8NYdvrJzDUr9cY51rYuxVJUpoW5CwWAmQz9mBYwTB6yR91eS	359
17136	2vbD2bHC7P7cUditR36u1MgK3464XB1kpVRf572XrX5q8ZCVksun	359
17139	2vbatS2ireDADcKoTLfXoreaXwVo8TMhVXdjSu7vgWSZ7NBsMNPk	359
17141	2vawGZ6rGTbLM7R5UD8BjN8wbuQnf9eWTBbwTHqRngnVoyDcMqLw	359
17148	2vaaeTtKUMemg5REa3pDLygao6VuzVmptv1hK8WUfMms8sU6MAk3	359
17149	2vaumQsWi1FkueAfYKWGv8iNMBk8CJYRZCGg5vZHHg1XxbBCZRFg	359
17152	2vaHQhL4csP976VkX2yEr2cChPYhLSt9XjH1KoQSMgZmrrzTQgfA	359
17153	2vbgnEvQZhmkDMZZfMQRufGpJfFoWSZraiqMXRDMt1DT7JwoE5mY	359
17156	2vaV6GSAsKYdEaxjFF7QiUhG28gUnMxztarbsyka64x6fKpqxU4Z	359
17161	2vagUUkGvT4a9fNhcaQ3HggdMBbSAnFpmGaX3tJ21bVFbpGWR7JW	359
17164	2vbKGBG4ZBUkDgyS7PnZzzGrEAou9tYURwkf7n56dCMnsj2p8mMQ	359
17167	2vbBtMGTpA37vo2zRaZTDTnjQQ7ErsCD5MZSXtjQ8hFT3PwenzxR	359
17168	2vc41mv11V2PjrviqinCsgkgfwewJ6rthrHWTQxvvDfocfiND5uA	359
17176	2vaYZqKUzEgqSChMeSVagiEKPj15YspfVfkN3RkJ3vMke85AmVAc	359
17181	2vbhn5F6p95V4Tqb9pHtyUEZL9xdVaSqmML3HeonphqhLcyxsadu	359
17183	2vbLUTPiuFMwZSz6xmZJQY4a7TYsAWmbJmd9ViEaKuqC225uRbqD	359
17194	2vbxp5Cpaa3gqjY6ZmjKSbW9XQi1uzQ9zswBmbyycs9yKp4REQTk	359
17196	2va9EdLLhojHyh9ykyqgALUSoALK5VZ6RcHf8U5Cqw7xEdC3VEBq	359
17203	2vbMZmBkSjkFCdHKpwfenUHNkD5pnEDnKMg7M9XDN6N2AzFbQCvu	359
17222	2vbkMknTqh1umb4uowDMEVJ4y8muQpX2s1PCFRMATbHADE1ANXFh	359
17227	2vbXpxoUPxJ9A5CBUjT1VeBLfz9NNTrdckk85HuiUSH7nshTg85z	359
17229	2vaPGQXZd8BxCGgE3F5oiTyFVgAZU2mLgwXYQLA4JRsXhEx6mmJP	359
17231	2vb3XSMk594XzpLLZFsHQ26TDvVEsfa3FRZAWgKhehCT49VutBQW	359
17234	2vbJj94BiuHgDC8Qquu7X7Ry6E61N4WDgZrrjYrCajZyNHhJG47w	359
17238	2vahP6q3qnCnrCNQnJZhcfbkpLbrmEQmmRhkfoFdHEGKqZ9qheo7	359
17240	2vaEJY7nLuVRbTdLW2WDh2bH2RTtaqSju97jicEsJ3EsYXp9oJRb	359
17244	2vacyVp3a7Ni13qHx3bhaoxcHCvedKwn6nrJRAcHJF33UQNuQ4g5	359
17246	2vc14krNDaPR4JAKSZYmoUJ7boBNnRfjsU9mN69aE3HW2eNGbefL	359
16922	2vaFWhiRjH9GgHZ72CzFZbdVi7abpgotzwztB2Mh2AiKFb8GF9RH	359
16932	2vc5Jh2VBMeSeQ7PvEpgnXJKHm5eeux5GcWcfZTbgPk9pm9e4i12	359
16939	2vbJrAf2iNQLwvtLfUud63NbLoXhuL4RtazDEgRtCKm298p7FXQB	359
16940	2vaEjbvcYN7jGNc5V1nuLMMCAL7JuZ8ntaRRu7Zzb1f8V2yz6dtX	359
16946	2vaJ79CrmAxwiZV21Z2b5PvVExF6p1VpfYa8zq5ogE5YtvKfnpUm	359
16951	2vacUxd26132Ga3HUbgDMEt45WLzxbQAb3jbtKXFvhUHxtdPnfDb	359
16959	2vbUhQRxshLVCcqzZL7QisrqdiuToqqrYPGPtiExteKTdWy5SADF	359
16961	2vb4f8jjWNkR8pKJVmdMh6PbyDkndSSRLLsQFVMUqjuuqqJzMX2h	359
16976	2vasS6ZC5tkcAjNxBZGo8RHhNMLo88E3YgsjGy52NUigC9ugNtUS	359
16982	2vaSGfPF9YGR9TCAo3M2uzxJDSH31fH5WZs4fysmjejVXXuqYLub	359
16986	2vaNsPEq2xttwFQsEr1emG9bQfNbSPBJrQbL3jVSh1f9CG3yv54A	359
16988	2vapF71RZ6nYENLKAezzVebJo8z8AdPBRSWcCURLFsC595Z3rn6R	359
16990	2vadkjVW4SPSAr9L8sCTFZ7bkNsiaMCjJuSF4LEojnBSpzS5nAcN	359
16992	2vbS4pUzmdxsHf1TQT8z7Us95iqdj7VtTMAuGTwfVnoMnL6xDMo6	359
16999	2vaF2QeGeSTsFTswBh5hZHtQeMtip4da2WpHcfFuJDXtJkMknzXh	359
17003	2vbmCciYyyxEzTeShru8vTW2qYqjnhwdrygAo9iFPyxkq3hUDqBP	359
17006	2vbe3KezocMzHoNY4RYf5drqMufxcMy66cYjuyNW2rSLFgkFRQuc	359
17011	2vbwfGEhbZCHuppPPpJ6xXKZgFaBTEHUe6mgn6n5kVvJQDBfySo1	359
17015	2vbyAgrYGpu9TSrpTamuL5crVdLvYtM9DPct4PG65FkC7ra39RTY	359
17021	2vbytf6P36qNEApEasttaqz4ERtrZWAPcatBgJ6dPn8p3er1Ajed	359
17024	2vbC7m7CHhMLhUiKj1X9jYVXUR8t22h3rPzuHqUaHeudfadTbPMP	359
17026	2vb2ciDEoxezYFnqywvfSEqeDrrMW3MeUbqtF4iaGzsb3XXVsfQ2	359
17028	2vbPfDnGNoiPKENEqs9yMDkjLrsPYYjc54NMVv2t8mbTfeakbrzS	359
17034	2vaMx7VX3QgfhsvWTJ2Z2amStaU2NGAPBwJfDaMy2GGmcdcAZX26	359
17038	2vaYPKrWPS4JMYkkUTyLjW8wZCLAix7abPGLK9hMtG5Wrsx2zdp9	359
17041	2vaFoLXCyGnVf8TqDrxMvDGaJ32grX6FFjpQyubEZXvY4noTuLvq	359
17043	2vbRKhsSBuGDbe4SGf8dVTpf2CsJR7kSWWxbV92R33GBsjqew4bh	359
17045	2vb2PHbtg9fhCa4vcKuXUJQMmy3JtBEZAVp7a5chPVFdHPsKstHn	359
17055	2vbUqgdHGajicS3qci7YqqJoLvcjYpLz9tbMayrnrML9cE3MKoHL	359
17057	2vbsC8SZnAQhrF8DB3PTtPWvRX1qty4fFapKyGXVbVEfVx74eqPH	359
17059	2vaFBBYPERjVpg6TPYEoQwdBKzDv5AcUd9fQigW7H4fJ62RXgCon	359
17063	2vbghjK1TsRvv2Vt3e69ZGJzCDzCwhFbuJfpxFR9vpcKCgRrCc69	359
17071	2vakVks4Tz5oh35poHGqHG3fHkXPXN2yRokhs7gUAKYWSzFjCLCc	359
17079	2vbRPkURfCDfrY5D93hZFg1W26f8msSK5HKNG1nXr5jRAmCQzkgL	359
17081	2vb8h95eEgwpv8Spf9zw4aAGVqd8EEYZhnfFYEvSHP6x55Jxqto7	359
17083	2vc1NSLxDZwiXgpT3oULrxdURRpvjf5cjKbsmdmeHSwMtzyYWt8G	359
17090	2vapu5SZWRMN8aa9kQCzH9kMvQjrTgAM3uHZCXRLVrtFmASHrXG9	359
17091	2vakp1b6zsLxhzL97sWMmja5YJtiogXcrrj9EKhgboteE5vhh92r	359
17093	2vbE6WryXVMPcxt5F2YdsSdQWovDHLgdv4jKVy4pr7Z6Bqa9ati1	359
17098	2vbgjY5EDnj4ijBKcP8aC3VePFCuBoKgQKDKcxtezGKEssCjavwQ	359
17104	2vbbgVQB8LLwin4J8xoGLbQvKT5BqkFNaU3qfgYHRNgVi5Ua6XXH	359
17108	2vc1RqF6u9JW1JCn2Jk7e39jRvFn2cxQimX7tH139XaiZvV31c43	359
17113	2vbDfiuxck5YZYynNp7B3uDoS5cMKLf7bbC9hE8VomH8kkhPsQKt	359
17117	2vaSHCW9jQoKRXyn46RUdWsgvDvbDo94VqMZRFoztCp1nPwpkZym	359
17122	2vaVKo5knyHDoyPY8kTF2SZW7mr9Aa51rfn9hUmMgCnQFVFRiiWu	359
17124	2vbWWVCrzJjLJvcYrZGjagY6A4iStuoHZSgeLbJrgwJNgnxS1yPk	359
17125	2vaKBhLD2JSrop7AWUXEwCfF1Xvuy6hHteYW8SzsLdFKpHijjVA7	359
17128	2vbJ2SKtp8bcLTxCQGeUFsgVNFDHXP8SeUjUeBYb2RqpPFw3tcxU	359
17138	2vb3QrEVwmfKuJwkBsPv9ejzzZLU4BppskVTqh2PxLSTsoPio63q	359
17143	2vaNYYyAviAHAUGzUFkDbyAx8uH7AJjxMDY1S8WpzXCTASBVCr3e	359
17145	2vb9EYX9qPd4wj51eQoc1gk6YwkGcTmJs55V6zAmwUqDEYBrzgHX	359
17151	2vac6uxLU6RMjjUAfeqWuH6Sq8Kj7RG38X9giAZ8As2SoFKaPtNF	359
17155	2vbN9EfJHqk22BSX2X54xnjRCMrYHRPmDGooicFbGRtng1mP6pZX	359
17158	2vayJJRwFZ48iHnqrfo5WKuqFgidW4ypoQJAtEfPyqkpYr3k2WAJ	359
17162	2vc4jAmkLxh8gqVLoBYcVZVcZfFzsBvySce5ntH3DfXXCLoTRpsH	359
17163	2vaZ7oVcpaHNkmLCoX4BRaZYdsbbuoNN13Aw6P4BPWmyJ5LjaqnL	359
17171	2vaZeXWTxVyqgSEmW2zzQgbrkmrWqBhWwWXcmWUKPKgvw5xRoYsQ	359
17178	2vaCAmaaivZ4GkrkWsQQ5PjzsGt5KWmGoMvHqAYP7dymWGiEuGZ1	359
17180	2vabYb5BzKrdDSQdnZEdSqsG3UNxVkj9ijFR9CMN3cuZwiHocQkF	359
17187	2vbxdf4FZeUUww6w1RZgsYqdKtXWv5yxCpXZCvbE5xPaRQgHBpYz	359
17189	2vaxNvwEQ1GVhL3SGp7rKeLNrwWcDDo2YdvTZbhcZLuBG1NHAZxR	359
17198	2vb8vU4jLZfxQCwR3LfRJMBGbWvZYUuecisE1kappD8MWkpacYsJ	359
17200	2vbmN8hJ7gNZienfFaHmn5sJ3iHsuhD8eixQFiPirMEKS7sBNsGx	359
17204	2vafWXhJEVaZ316oH5MkZX1xPpthEkVLJ6jnUF7LaS3xShb7zk9u	359
17206	2vboWsrCMNnCNTtjt6qEenkTF7F6Mjx2EbqkwUVKMjuaHo66VMCq	359
17209	2vbWuvqsdJN9bdrfvi83vECML17HoGbAcWDWaVA9iGqy7WmWYVz4	359
17212	2vbof2Lhyh7S27NP9QGejm6XmzruF9ca56qH4pxSccQmfVyzNHJK	359
17216	2vbj8jorJA8xp96CrxAmUDeqLpGJG187cAbmCgZtjwQ5zFtH94Qt	359
17217	2vc2WRoph1x13mh5AuRBPdvqFs6YPxTWwhA2e5gSjjnSy7SeTDXw	359
17218	2vaJ5kJ5WgMP4EAPZUbMdVNSTGPCzik57VFJuRE3SXcAx8Bpq9tz	359
17220	2varbqfyEeSThu3NqZCk2g9YiMLB5QF4x65EfY2i8f5gPZ52SfFv	359
17224	2vbrfQUGQGVdb6PTb9Dp5sQ29jVLEX4ng48J8iHiKFFG3AF2nufM	359
17233	2vbJNYMhbdufpXVWJMVYFzxBeQxbuN5rBDdSmUZLyh8EnoPMNCNs	359
17245	2vb9YGtTwEYTSuV5ia5H6UqzhihCPym7jQ7PW9uEeQJ9hSK9JNqx	359
17247	2vbxZQXv9oEx4oGqYZ175Zbb37CiX7dZPr9SwwjmN4RddgGMYZCq	359
17254	2vbsL7n1ZS8i4jh1VSTPXxMMj8rGncxTC23bg9XCVtPfsc2ayrv7	359
17257	2varKRs3cvuCYjd15XJtTHnSxe2gibUszWFTDNhbpLVTfQzteFxB	359
17259	2vbazmmthoimJaGeD14dFDSJt9cLdoEK5naU646EtJdYScMgWTib	359
17262	2vbXDFPMwogQiehoBkJQjzmDqN9QJRu7uC2SuvDw5P9uwonsm7Q6	359
17264	2vbfyzUEVQT4fMvQE3c9CQCZsjNGw1ASC917N6HWjQddwHLcwHJg	359
17265	2vbzL94umVNMZUDP3hJ5S6K6szvBt1Z25Jqf5Z6vu5rxAfNv3ei5	359
17268	2vbC5PKs4XWjzJqbxfCvvt5pbAMCbcCg9777gCYupCjSGjzGJd5m	359
17275	2vapNvTJE4BXG9ZQ2oQuT3yGxx49dThszHq7xxZmxWUG8cYA7NX8	359
17281	2vasKa7rGzNMtCaabfqaqqFQ85411KJrby3WoHHBdVtZU7XsAADF	359
17289	2vbNGnBdf5212vfCGsY2kz3cKqYRUKCSK9WyhK6UWz3WfHbQkVx3	359
17293	2vbLZBCqLAfuXiRLqxp9udJnUhAhH7E5eXbSFCcLdFrHPtApZ7Uh	359
17295	2vbewHPu96qfDtbXsp9kVYqHdbwgkLyvZVYoM2DKiEcSDknhyVcG	359
17297	2vbr8ELYvye6VzWR41P44aGmYvQtWzAUNS8AmS3a93cK9cdJFVpQ	359
16928	2vbBi3ZfAtSxpBTWCWTBJhf5xbDw5jMES4j11EREiNqD1aEFDCat	359
16931	2vbSExXk6VzML4VwrBriU5P2VwcN6CRw4QnpnHJYi1S2frL6Daho	359
16934	2vaUSyWoLyGfs19UykMpxov1BqmUqFsnV8GSCUjhmAfvhKpnivvp	359
16937	2vbLFnWfp9Hc64PXEFqCLtgKEvKxGCUfTqBDyYkYKs8bTrsAt26j	359
16943	2vatwoLDrQCJkg2Pp1PLnRM9bfQYJ9DbCqrGa3WDqj8Bx9QhLzuj	359
16945	2vag3VAU9sem4cjDcdaaZUgnDmiuJSBhNf56RmAQnX1QKSBoheAc	359
16948	2vb7gp9fkpAUKvzZEnYjpq39KCsSYiaMGPuRSZHEFCNk3X88eFbM	359
16950	2vbXhVHnRy5bn4b4zdKM5oeT1BpREJj8FprKUJAkACT1LVz2cFSu	359
16955	2vbzDxbpwBQiJ9iJTnV7L1iqLQtwF7eNb4xyfC982Zo3kioubNyk	359
16958	2vc1sKdvQhWZmEgpPH6Y4tqKog31KgLt7iSYntm2FeXeWCXAF5y7	359
16963	2vanefq8KkBu5ZjLpqYLbLDkufzuZdBxR9PAqK2iBaX6prTQdwdU	359
16966	2vbqYXuynPtpGVARV8RqMHC3i2AxFNUrhoi1Dg2pHnZKSuDn5jGe	359
16968	2vb6wQhuMScwmCFAYE6aG7bzVHZVak3eJBEhokqa9Yjq8a1fVXEn	359
16970	2vbSaxm7TSxUru8XAm9Uaityj47pDKUNrtDa2pV64UdbakYp9SwB	359
16978	2vb7CaqEPVVYrAWfQ9bfTPg8xWnuvPZpu3S2E7Jh8Eu9QqPgJft8	359
16984	2vbFjbuCZHxx2ciiPeTYcvmnwT9tngcT1ya4JnoaSFoMroizpzxK	359
16985	2vaVRbjN5FQQZV6mvWmXnjwW1TqLnz1gRMj8JwaFuWWSsvqqWJTL	359
16994	2vaxLxQD6knGcSQaLLatBBj21MRpJCK4TFAYzwPt7vRypiQ3LXB1	359
16997	2vbgATAQ2GU3vbyNDebReJLYdoegT9fvfm6x1wJAem2bCHRoTiWS	359
17000	2vbUG1emtcyPESa4DSLrMhaPr94bZJLtV2XZgzte5okB7H6hZc7M	359
17005	2vapmL8iZLaBgPTAWSZRhahUNdgZhE8qhQQVNhNfhqY1mr38xv19	359
17008	2vaCoeQ7b9y1uqWdztVamvRVj57BY6PnTwriVCMCV5y1bZ7rZwhw	359
17010	2vaXsrb1ApDh3xXv3KKFFbE9Zfn4scHfuEm7aRbK3VHsebxaUaVr	359
17013	2vajn7tv4gDRakP6YqAFDbCqcVCa63oZeVwFLMAW1sjLqRDGrWY4	359
17017	2vbvh9s3WXWWf28HYNdxztyDaQGqN5UEDpqK8mAaRbUXtyKanS8M	359
17020	2vanrgHFfZG9BLnWQVmjSKoBR2oKBmsre6NaFptABC56A6Bxin9h	359
17022	2vb4D5PJW9vxkucBTbWuudd8nY1L9tAqEy3suaPN5kYSy7g4RBPK	359
17027	2vbttvCR7LaeraKsrQXBqme9fXDUVaMD4KUtnZf6f3MobEfCfAbF	359
17031	2vbdtr7cMLvT4aDgr9HupYvqrNMY6qmm7LLgU6zyqJi9AkqfVCpC	359
17036	2vbaqySVqYLGGRW6GFhavXh54ih8nZnx9bVNr39cBQSKGH4wAL81	359
17039	2vbfgY9Fi8X7vwFMVPuekNwutyWdbMn5gGxmMYq8U22iBN34HTQ4	359
17046	2vbBrfqHds87j8tRkQi7fj7XLBRCtfEkMQhR3p9ALxD4JGBuSLTq	359
17048	2vaCzdRnMd1TmS5EzTxGgryQN63baugChGFxhhLVTpLmKun3R5u7	359
17050	2vaPdYxo8HittFozZmrGQNyfkJEsQBTbdLYEfLqxugjLJmoPXoLs	359
17052	2vc373qJ4ysk8jhtDbSG1RngonUv1hCv67q7ssRiHCGGSNkzRvVY	359
17053	2vc5pauDAJXCKFFfEyedU7Zvzp7uuoTGFJnNFwZsRGeBU2iKr461	359
17060	2vbHyKuTxfSyGDgsu5KiKe45SPzX4MjJXFamFinY1hKW9WayTd7c	359
17061	2vakoapeEZtebaoGaEnggaeZekPC99e3oUisBB2UyNGChghmMSC9	359
17064	2vbkRGQ2uhFeafUjKz9Q1LQ9g71p3mWRUmL6Sx1NUNgw5hGh5Lgj	359
17066	2vaXjfEEfe5DGhqD5q8dzJBC8K8JF16KjwfaLJHmv4pAS67hAKee	359
17068	2vbFHcE7r4WsooY97CZf4gBjh3XuE8S7hJsdpv7KtTKoDEQ7Zfr9	359
17082	2vbkk8S387Z2ouFf39T7P29PQh3HfsXzdyRxygf5aFxE1LG4WASw	359
17084	2vaEKw4DFz6puUf8LZN4j7pVmzmVGKSirwBaC31oBgK9omZQL89Y	359
17087	2vaTf6rYXLQhzwt3g4XcQjnH5m2TMJ6WWtv2GZ5DSx2Jwnkicjxn	359
17094	2vamuoLLZQVicQSgD3H5AzkLfH9Kv3GY2FLowpdhyTmq2LxFPr4c	359
17099	2vbW4iAFUEAVHJZgBep6XnTerjqjd3rJ9mR1aR3J1yjtVvqNxHSu	359
17101	2vba64ULeqATTETpDNcfDNCPJbjtGqRiDkzHTU2sgFsuUgwtHowN	359
17106	2vajYq3LNhbaWCszfkmF9DiKTSsNrH6HKbQUuCwxk7zNRxE7PHSj	359
17111	2vaUVsTU5KebF62r4D7zruFo74ZwZ48mrGbA6HSC5sRVFPHVMVAh	359
17119	2vb9C67SX9YaKs7bvTFK3PXE7hH1wqe8XGzKEEP6Fndr2Scrqr5U	359
17121	2vbhyNvX3MUqxiQREBysCrDVfhbYVhhcG1rUeY49ucJ2gZWcGE1b	359
17127	2vafATf2KTbKrLZQ8CcF7Hqur71UstpYDaTfXFXrKZF4jdzBmvBX	359
17129	2vb7jsCfroG3hzditjUJcxrdsfxqJoySienTifNE7xCWLV75w1aw	359
17131	2vb23NDQc2vELxAmEQLqYm5UYCFG56FNkNS61X1kUbvbu8XUQWJD	359
17132	2vaNurnQbxyvVL721j5mDygmV8u7X8RDDK1pct1XeB99wuss5rRD	359
17134	2vb6JTDrnGJMze8TFu22c8niuwJpvGm6hCZ8yBBCDjsWWwhL14fE	359
17140	2vajeGqpfW8awHygJDLhgZS5fkVUhnWxxTd422s3q6y1ecLcb5tC	359
17142	2vbUEpbJuk75FAoAJVeyzZgipuz1E1dEDNXMRZsYvkpdVkzqwnfu	359
17147	2vadXyS2841KHx9PStrRCmJj8ef298bNgVRCjVtx1MKTg9KVHEeu	359
17157	2vaGhwVPnfQQHupPjeYKexRxajRX8bUg2BNnQzFrCVsJk7zUTUUd	359
17160	2vbMrFmJcffmKw8nrfZPCEiRpjnSGqS3PzeZ7QHTJULG7sEutj6P	359
17165	2vbqxFoh8HzopBA7L9hSbYWEDAJrniC5yNAw1qapxwXeCoyq1Erd	359
17166	2vazR6fGedApZb5QxUvqwsCzt1UKT66Vv4jypG3swyqf9pGTgQX2	359
17169	2vaszHaidXuL6NF8sWw5Aio214SLvFhJq7vEPDxNPPmsvDhphSZe	359
17174	2vafgadrtzk5Qig58AbFNCnDj3g3Mz9CemK4a3euscD6QsPjQ6Jd	359
17175	2vaafmqZbY88DjoWGcUPch6rAR4uCB7YjTtbFsCcuYENiXFeDKWQ	359
17182	2vab1KfUz7BczFa3VvXru7JNmgpWqWESP2TMnE6xDKbxUgdoqft4	359
17185	2vc39HW7XQvkS3WTudkFTTKhDqXK5RqtyNJeJdNHFHdxsf9p6tRA	359
17192	2vbNPQArBDsneR8HrGwr9hXcKzvzNaU15Ex1KcpxFKLgQVbzJdSV	359
17195	2vbSjSWveyqDZE55W2QESn4qhN122WzGQb3jBaNHpKTreXFegstN	359
17202	2vbEFcrN54EThHCUa63XAsqPNq8kznHNj5Qdbx2yCYAJ7GqCHtUe	359
17208	2vbRjJiFCNctw4ayxuWXAZBEXtSP4JibLb91KT8MHiNo564EG3Gg	359
17211	2vbgDbXcx2USSYWosgSGCuDSzNPrFUkJkWrQeTHjAuUSM4vRMPPo	359
17214	2vatAwsqnfpk6dqYmQX1Gso9R3ZxjfwxXAkdgv69WEGXHnq13HKK	359
17215	2vbpFqUCKDKYW3u7QhBNvgRCczzLtpeV9AsS8zPJtK3ANHH43y46	359
17221	2vapLcx4WymHVb3TG9kyH2fG8NkMZJAym1jdSqKwuGZzoaH5Anri	359
17223	2vagNc35KrEeei1yfmrDZtW7dBFTGvaJaofCLnWbzGyarxoSMoyH	359
17226	2vbZpLjRzvtvoTULvZiNDsvxyTNdTKc1aDHWTXH71nXhqEwLDryG	359
17228	2vc3TGuXh9wHziRsB5oq7NnWJbhJW62aoHKkPUoiZoBjQW6zaP3f	359
17230	2vbxMr2VatewHkNaWPZyvXRX4TPF3d7xWctvjZjVZrWDqgHfQv5Y	359
17237	2vaq5pR46W9PQJmB4uQrbUzX2VKdKSRtyxLnZSKxfbZBeJn38tHn	359
17239	2vaD4vnQgoSxxRxSoywuZ8F7gjeapUsVbM1TQ33dKWHv9SHW83o8	359
17241	2vbcLofhj9UJrowkc62fhHho4kucZG2FvGuiA1XpWRydys1jhbCX	359
17243	2vacSsXuLYm1NAE9zLK42iocVe3b1yQbiizitKwCk5iQu26NQRZt	359
17249	2vb4FX75gw1c3j1WBaRKeEQvww4FfMJkWSptgBiHUBvgJiNBR2jo	359
17252	2vaGJ3vGaEV7vTRyRP4Bgpj1RsE9MWUdUn3oi3AjsEZueGVRwEsp	359
17256	2vbovi4WmqwRjBY95hhWm8ipP6CuEsouQFcCdvmBCbLnhqG9nYpm	359
17261	2vazYUQs3wYXLQvMEdvfARZWZr5Ugbu3dKmvyM3ZphJ8YCRqyCmz	359
17248	2vaoqoJCHSQ4Sqcb93oFfqg56VS8Gxxno5oYDrE35roBhmkSk152	359
17255	2vaKYFzcc1ttGq7ETW1e144PFCapnZhdoMfmtPescbFuc7yXNSFj	359
17260	2vbxkhfeZija8zPPoQhaYzUNwZk68Ryy3GVcSBxwgBYasAdtuhGD	359
17267	2vbAtqo2RHFJQVxffpH2oPCLDdGibFiuUzMvKnLEtP7X7LaRxy6w	359
17271	2vai6yresCaHrQF6igfbQJxJsQL6KVxFBcx7oxvE5tganSzQBinE	359
17273	2vc2A3LQ6w2nTaagfuAwYCP7DnZMfEv6LbvgbPMZY8wxVPn6HLMB	359
17274	2vbtFJTyDUZp69ob3yyeSs7Qbhi7c1CfRoo2oF5LW6s6BPNKs7VM	359
17278	2vbq3biEG93jzkNnsCtD8F35Fwcg89FC3r39akpSC5NptVuy2nSJ	359
17280	2vaBjGRfWAV2ibGbDDSfZZ4uneQbZsbs9QcTew4cegmDh8ei4XoE	359
17284	2vbETDQVykT1Ke7UNkJBWzndSA3EQoN95PJJ1EbZFHtReWPvAkeU	359
17285	2vbL5Q71P5YBJDM3WAiU9ye6qM6YjceDkWEAgdWCekVdMMYNw3fz	359
17287	2vbHyTMQLpgRGK7YtPkLtVS5pYhoG4QAaZn3eSbaUBmsNJSrTeGM	359
17290	2vbLq43arHxd7cJnVtbgRXdSd7CqGwCChKceyBD8wwYU5kS2rAst	359
17296	2vb9GJJCsk63S659nWFD7dg5AJjNzkNvgZtiyt7AeZvhSAhsSq1U	359
17298	2vbxWsGXhug3rp2Y2XXNw4BJ14kLHEMRaJh7qJEEBCJstrJfPL4r	359
17299	2vaxGGomUaCuKTdQteGoH8PcQb8oPXTa4Lk8uJY8YEXoyp6UeeGD	359
17300	2vbuLzwoGMzay4rPaKbbE13tN9Aa8dLjLivHQkYxR2DCooGMSEdT	359
17305	2vbJ1Dr43euoYufR49Rmx1A8dr6Bkg851XzScjNLSuUfq9tH7Ycn	359
17308	2vbQBGndNCTvGt36BZw838nPDyyioykuCYRFEfS5Qq7MCiwBJf7y	359
17310	2vasntB58bHVXakzxtsD1kYXjUMYXHMDePrrM1JUvk9f3watorCF	359
17312	2vaJysCsqZD9aqeL5vKFyQh7uv7AEx8YBGxX496ioZN8ZKe7rsBP	359
17313	2vaiDQogLzwxZ8uawN9eduodiz3gXoo9wEJ1FZXGibN1NPGpycFR	359
17315	2vaeQiJT1dh8J5abDYTHPSU5JyAm522nR56KzuSE3WQche3n7215	359
17320	2vaUBoEthmZr2L1CpoxQvpbQGjL31GQteycw3WkF5SMiVJhaHrGP	359
17325	2vaRbqWz9ctZrhzXwE9oh8JqxAZrnjtobRH2BDpe3vHH4c53vRRs	359
17330	2vao231MvKHpL3dwSa8yDUvGQLPQswAcMSwAU7ULR9BZkv9tVp7N	359
17333	2vbc5kPJXfw8H2vTV7vXpR5Pi3YSGQbzAdUqSwskVucsGHHBmjz6	359
17335	2vbt8P62eGw4GbvUuvpBswfvYeHiQXfZ46ShsHcsf7GTjXNPQdqL	359
17338	2vb8MKQGPUhTDWgAxoTvWY1Ys8bMeDQFJrNr8S2jpeRSbsLgpXFt	359
17340	2vax6cXdFAzFN6bbv511NT5RR4QGZ89zCtse8kBkpaek9AoHHpxr	359
17347	2vbXu3nud1WQk8NGsZ7mxyRjE1MSRuT452pD86xYHNKTJ6u3Nfcs	359
17349	2vbRX2FGBXZG8beLFMDHiUx7v3wh9q6UfsWFvWmU2GDSSawHdjYb	359
17351	2vbwzm7TfUxX5JK1g8cAddjVEYcHDFgXSBaTmDLS7XJB2UsjhBZ2	359
17355	2vaEkj2AXuDcy7Pnh8jaLzVtcyjn5qw44nas7inNirqJ9swYt9mJ	359
17357	2vaGdXrTGVMHjhTa24spJXrMzebD9YLfYPNHspBj1McHDehASmie	359
17359	2vbwV6j2XcNZszxEvrBLxGc3HFY7ZoXmErvCgL8ohBrGEDbVtQY9	359
17361	2vbE1bMNfZxkU9dN7VF3mJTR8zw5HRTpTjPVm9XA72TpU6QzDnhk	359
17364	2vb52neJt5FPWy2FFTqN64895ZcgPTUsbhTjAFQWjhoRyQ78uCyX	359
17372	2vb7qtwem6tGLcs2AYX93nEdiDwGPhkaYA75sUwFT8RM9BAxMpcz	359
17378	2vbwcUy7iu6YwyxYiLk4xDK4DjM7Runc7qwnsDVkkHZuAwyMqx6v	359
17387	2vahvDjh6BsPZnqB7cRwi5NgZdAt6MdExBgSFA8aK7HYmWqsQ4TN	359
17392	2vb3UVMfj3uuWFLDBBF3UkhYsjhm72rko32vpiQCnSoptYh6bJXQ	359
17394	2vbsutCRNFEFRUnTGn5Fqmyrg3WMV2LifGNZeamr8vzh84sddrvj	359
17403	2vaXMcb1JJBy1ZdzkkmY3f15fPmovNTPiZtwzUyUQmScJLeqVY2y	359
17410	2vbYWwtUFekMaB45yUoQHQGgdo8mpaH9HNUjJCB1WQ4jeXRh14JB	359
17412	2vatsjdaYiZuKbUhJ4Qz5nv4QeRH5dg3mgVnM1DtaHyVN9YtTysq	359
17419	2vbp8BtcV6zvBgTsWciskQ1NiuukpqwYZaR7zoR9KMQtHKWTeEej	359
17422	2vao4nv8ueFeB8UQoSLCg28K1SkcTZ58XaqzaN4nCG8sdBqqpf27	359
17424	2vaqQPEChUHYpzFu6XFp6dEsotLQ7qVMTdFFNhZw6B6sqiw3p9ff	359
17427	2vb4ykPRjUFmT9xpKiZe37Lz1ZbvEQKC1kqFuXJxQAUKbLH1nuxz	359
17434	2vahm9xTLifcEfvY7pyLZ3LjLfU1ULR2qWpnX2vmv1dhcqBsDnTp	359
17436	2vahdvye3iaMfMYq8hYxqC1fcqguyqr4kGEv6zwcHmTnznFQS3r8	359
17444	2vbftznjMDTQ9JweqQf8TMLh4Qd665a3iya5aw7dzTGJiYxZoWc3	359
17447	2varamVA89J7WsqYkdhRmGsVAB5ZoABgZHG1msAomEpUFpHae9Bv	359
17449	2vagXHaP8fBQsRSPjG7VD4M3WmXyvq3cmL2QfDmBiNeSn6D1zx3k	359
17452	2vbNcrDYcpF9YLBvcyNqvWVaoPNpj4kiWcofd5LPp852WLbeeRKr	359
17455	2vaaM121u5TXsJdBtMhD3zrrLWwU6d2NtxRRGqky2zq4zM6u99tn	359
17457	2vaoApZC5jHYiMj8vS3cKSgfb6XGA35Jv2hfVTtLYtS2dzsNtLj8	359
17461	2vbKJRqSKKr7TWRj6EUrdf1BXWsjFX5L8n8UY64zNvp8qqHoiCnN	359
17463	2vazNtWpi69hvR2AQGCWF84gcwuKeQ1PsMYzhMkFG1hZqmzzognr	359
17465	2va9dZJat6KCg869YkS9ESGquuDe5BF7Lg1CPfkJStoHANzSDyPg	359
17466	2vbVDgL6hXuBGbVVqUjR1woRq1Udkak5tHYmJZCwj1WVpJao5w27	359
17472	2vbSQ9NpHajfNw2THNfRFkM8SG1Mmta467ZK5Q1k5psnwBNW2RHj	359
17474	2vbYmNKVQqv63XEnJpNh1zsPXCExkxPsb61juEaiWwThYesPVF3i	359
17479	2vbEQqYwS2mTt3SeTvuF4Jy1WJY1Df6hGL9XfZRbipjF4AvGR4QL	359
17482	2vbiCLxehoJYTL7XkzeoT1iDvLGuPhULParxvknJz2EqKpA7PAqx	359
17485	2vaDmztpvgKwFYxUqFvfiHUJsvbuocGUBpWPA2fn5atXR59vnpdm	359
17489	2vaEywwzYUAcyqmvYHQ22QEYoEkyhva3HERa879ZKhZPvRtvPMZx	359
17491	2var57HcnVMGjXib7PDLFU7hgNgVBcoPR3vegniDEWX46FFsXNpy	359
17501	2vbu8s1XqWE4TUGvRixQEis9jomtPt2XvuVdAs9UWp9DGzq8czYA	359
17503	2vaEsCQxWC6cwwYWGMeLhrQKuMJZ68Y3hSLcLrANThnXgR9DfLEj	359
17510	2vaeifCzQ2dgE3oV3T3YaZZpkJAEA1yNzukw6dSNawLfS5bm5HaJ	359
17512	2vbQzHvRp5XNYXyu9UH1p5oSr8tC2WQCijrD5UBgLpT1wymmqG2U	359
17516	2vaCqzAHt9eTip2PJcphSgU6MqSyCFJuNPWL2jGx3H3SsvUmmXzj	359
17518	2vbRPo1M9qr96NWCGZGGGNEmVXqXirovteWRxPSN3yZ3QknwJ4i8	359
17520	2vbaZST4HuEzLwkvZzbvrU1Hmo7AGiiovtSpwgyBG5sbQsHVyyXK	359
17522	2vbeYyqBqFyUBmNBdaqYtV63EUsFG3bbNcc4hubpNqDrVHxg5zoy	359
17527	2vbu3DDg1epS149MnabxcM5bMEYwDb3kew4n5YxU9MzcMhWg76Ys	359
17531	2vaJTdhjMdyAhzx2H3sXMTWFfcR6Ds9FQM7yDbWNEAGHnqokuA4y	359
17534	2vaMxyXnNdnA99ueQ6VCe7yibwyAzg3jagVxJ1wFQdUxai22TuA3	359
17536	2vb6E3CXmReeKym2FwPek1NhUHYP6cX8NQMR15DitcvLWTLFgFn6	359
17542	2vapV548p5nCenfB1UriZ8BZTFSSPcAJM2H6ze7fP5ag3qTnhREY	359
17563	2vbvkEuiW8ZN4SWiuzvrza6KafLhUdbfstcDY8V3M4zgUJRgDvHY	359
17571	2vaSvYfiMqPaDzkmLdffz6YH68hVxemAS9q9B2Jz55saXbT5rpia	359
17576	2vbkXkcbDMqis7xT7anu2UHScsU35opGwH1EaaMDS4WhNwvVoBEv	359
17578	2vayEtyMomMVG3YD1bFJg8P1oWwQSW5ZcyzTiZtQcQM4UEpgGBcn	359
17580	2vaZ3KLeFo4GoZJY4UyjpWDSoaFTX5yfTig4fsmUueSbdd6o7JMd	359
17587	2vbbHcNKM8CLMuk9jZnGwr84xEwEZjAtbm27fUhRe18eqpBxfWAw	359
17266	2vamyHy57EujDMsdmGpDhsR5Mru9rDDNv5pXY2CZL4C4Kp2B5txA	359
17269	2vathtpWVvBqCHAgUm9NKt8LtMMcswnWbVMx3jw9HQTBs7u96aRE	359
17276	2vbSpdBMcMaZ6NRzNdZ5jaSnxsqdDJMVWHm4rhkKGAT18aDabqN2	359
17282	2vbytm1hZHJ8iZKcPyx9StkkfzgTxKtdiXo5Ztyb4B3vKhJXkWeQ	359
17288	2vbs69883vtWfpnSG5z9DwrubvowLqKbqtfEb9Hq1oHFHPZpmuyp	359
17294	2vb6TV84MEuXq9NGNp5xZSQQUwQQWk5sEQKNVZkbMaeiEvhdAaUK	359
17306	2vbUPB2M7QmeJPcoHTve7h3XQJNQQEiysqwEWqFwGuV2WEUmDH8m	359
17309	2vaovyWnSi7Ar21mGwwSoefW6hrCBQifuzJTgPE4YyJLdwanFdbi	359
17316	2vaPGCDZo9MrMvR35dDBdgk2jivzoMyBdEFGF5jcrnq4MJq8b893	359
17318	2vafKAapjq3PYyJppDCUDi4gdiZyDGNZHVWmRk3KFSxs4qCDvrgL	359
17321	2vb6GWsuFEfsPVNMVXDezKX46EdDTJs1cTtS2SAdB3n647keXSRR	359
17323	2vc1dgQR4MCXuS7zsDnWMB2LxQFS5xYFDDZsXA2uSWx7gqDYh7Tq	359
17326	2vaayxVY8anDUyGe3sSbnA6VSmanxsFf1LHBFaBU94PJArACEY7u	359
17328	2vapj9tqrcecJdVFCYoYfz1ogtxi2SVzchmRuxpLB9nM1tMfiWwR	359
17336	2vbTA2tVVa34zRXWWnTq1AUDwRRk5pEBPZ6sAELL6Twmrz2tnPZN	359
17343	2vaFE6UoTrqPU49JL7NydkQuNc5qv4zDMbucKr7tmnjFUocJ2ozG	359
17352	2vaxeJpGpdbtDWudQghRnjZMRhcC29m5aekjUnDwn2cicLVYFV4X	359
17354	2vbmQYaNpmzhwuGPoo3URTT46xFfNEG9JmktfPJHzoKHk3phHqMy	359
17362	2vbRPtDwRs8qsfp7QMA8x4ZyA2CamZ8FYTcoKKhCVd9qgjAy9VZS	359
17366	2vb5qPqF7WTmJ8MKUKDxQsestAvrQc3Lrd5AHTJ2rdBN3p659Ue1	359
17370	2vaQeForfxZtZsB7AtndM8GhwV6gyDqXEBZ9VjgNnbBR3MKQfify	359
17373	2vay1efsgTN67wzcNLBX9DizQ9B6QFbeWLrTiiLMeoGbT3PFbxbY	359
17374	2vb521Xbrgkq9f9nqLE4cqHRYVhAJvdJmWNwANXdMNtHKP6Sa9sy	359
17376	2vaQsMpJSZpJDmgXoSTTs61jwdN3GwwKG9gZLY448uPzfz4A4oda	359
17381	2vahGY85mYyYs9UGr4qG3SJYgn6Xmiet2VVhRooR1YFpB6a4hPqU	359
17384	2vbvd4hVtDHV54MsyNfDu8G2yb8ALEcHwNoK5LdJkNvSEmHZXHbg	359
17390	2vbwxrAfSGN5jzLK5FxKP3ytoPgSJmjHQ9rDK9iuq6PLpxeFpafK	359
17397	2vbfSfMPJSMegp5QHciQoa8Nwfov4KDLcDLpL6r6gij1MF9ZFn7o	359
17399	2vb2QgqJLwRS2HboNawbYKuxSkNNHV9b4SpEjoPHZGkB72gFsZst	359
17401	2vaVYszBEyDupT5Q6dfSWVx6MSNFhMisQNbdod7CdowhmLGstD3S	359
17404	2vbeUiqi573Z71VqKmRYrgtPxb3RZqXTY8UbSgWHUj1o3Jq6Cdpn	359
17407	2vaXuoXHd1E21kYyvR4wJHRZRtdzzUMChi6npVNjnHPB8rqn7UWV	359
17415	2vaJh4yEKs8i5p7TtwTyNQojMUm9UdZUsgXfUS2jDbfh9NJQJAGK	359
17417	2vaDQQUNkmB2WoFcS1wDTau14oupjWw9xm7MpEdUZHUjw2mhJr7P	359
17428	2vbGFRByznXwfMCA6WiZWqwzZK1BUZArvhipG19DaJNGS2Ueut2e	359
17429	2vbW6yKptuRsXBBQCuJzPvCFSKF5rcZipUJ1WFapuF49EQcSmTrH	359
17432	2vbwQmaLZSEkLSsjDc5oC6fqxn8d2P34b56gb5ZV1k6Ve4XcbyzU	359
17433	2vaY2ovdaqoR15RTQeSw9BBfvdAXyB4oJ7wpywSEQMM3ChubWTui	359
17439	2vbWaTw7QYe4ZpYXqsHNDABQQY4us3uA8HGbMURfLki6umddmCV4	359
17440	2var5Kemsvphj4fPdfzKFmd2toDJgWLuEbaWpXaMCmgzdfzMF6TA	359
17442	2vbHUYVvPr3zwebGXx82fdgRr4votWCd2v3EwF1z5JyjY7FRYFi5	359
17445	2vbSSgLB4VSJhHJfiw7VXjeim85CBMo6MWUCgNKxDSJtt7EA799d	359
17450	2vbxhV2Z2LPR3q1Hn5EV66XDbsdhHZbvfQNEa6MWaU1gNtQ5MhdG	359
17458	2vb1daJwmzHkkLDMoZ97c933PRB3kGj2znJCGf7tC2h875oyX9Ef	359
17462	2vbueiS33EcPf4wiDRrywvDXhoULYsTHLcTqu6tMBfP685JgKoJ9	359
17468	2vbESm1Dr4PbgsFhdQmdYQ2JbgoWBzMZaK8U2TEr23GFPkYkjXqt	359
17470	2vbSji2mj489Tu6Mf46oF6fyZJ7vwU9SY9teJgivgbWAC4rwXvXM	359
17477	2vaPEne2di8ybDyDJ1vS9CikaUkggwhJv6454fmYrBMJz2opXQ2k	359
17480	2vboEzmwgw2zf9Ma81SdpTms2aDVmMMh4gT3eMn8wHiRaX6Agu6v	359
17483	2vb64MF2mYRNQ7tpbQPqmfMAUi1x3HNE5J5WjrUYLztaPo782a3p	359
17486	2vaXi7HxcZaryJqFjMQkPGEuUf1L2H5phjjMZnxXzn6MaEwCc5WF	359
17492	2vaSvt8TuywBE7rxuL1XtSrZiWSABCW1w8T3csW969zUpBfSTxdq	359
17494	2vbfYww4fxdhDe5xuH3UtX4U3rLyrRVX8tviAWw5kXLmgx4HaRnS	359
17496	2vbBiND4J63J55ftErybSwTNUXWbXmB6DHvbuiQsuvDsjC48P4ZX	359
17498	2vbcWrMy5zgkvxwLjiqoDLwEhASyW9eADtUeng5sCBVNa9QdWbAx	359
17502	2vainT1b7Xk5HFcnvrBx9vCUztLs2rz4HXivT9mvm87k43YLkerS	359
17504	2vaHaNPWMwTWn3VunbTaaUM23gLqkupSi7rZBURj81SaoZf5Xkaq	359
17506	2vaYebMrF56GemShEtXwt9kW9ReX47hsxPAJgXAfQeFXDM7WkPLK	359
17508	2vbxRhDAWzdY9akffVRavMjTG7pzgZNoaxfMQ5toKVXzapxnPf4m	359
17511	2vbBNTBxqtd1NctL41vdi7enHmUwTZN3DBhULZWdapRpN2cdXcQT	359
17514	2vazBjRpJW8GPdzyxRNHKhNQCxZXZp5UaaUdkFsMuGctYurbs4YC	359
17523	2vbx5eB5qcjSa6sBWUN7ZkLcxP4vegw9f9XwHrwUeD2T2fVg3ZMf	359
17525	2vbeg7uUkznzM8YHCdiZnB7ebWh9M4HuQ6Yw68RuZxFbvrMEiu55	359
17532	2vajU7Zw1dWyb6RmFNUawPebiyScRtX6edjBuxUc2EVjpT6AXbhX	359
17539	2vb8KTmXm7B3fsVWWhwfJXQqjvartTCdCb53496mJmdw5eq657pF	359
17540	2vbfJmdLgUBetwZsfuHVYihkdXCEztaaMSyvp8kpqytENX88kzmp	359
17543	2vbiCmh616KpF2xKy2op6cXM5Y4cmrvr7JN1Zz9QYm3yJR7Tcqj4	359
17547	2vbGCJgshqNHH4MHMgYFLRt3t1TJqxApGs5v5SaiuqQcJMwAFtjY	359
17549	2vbK5YhvkEgBFwxoyTvX6rbZBG8QpWSws5DmpUVoRWNKTjWkfAHx	359
17554	2vaVPNb9DZtP4JBaSMSLLutRAg82xzJTbKioJn3sWqAj1dZ3C38S	359
17556	2vbJp8ibiwPG1sD3H9vmqPD5CF57VmuL3vivQwBaUWE6BmaPxHt5	359
17558	2vbGgYVBJyoNkxLfkKxGzHmEdnX4xNdJtERnmQF63h9YHbLjVME7	359
17559	2vaKGxvjauJBaXUAiUiNpKzQLxv1vHGdYggSUvwNGiYJuUANN8Q4	359
17561	2vaVJCeDX8SyRQL8BGCTtqgEyPeQmAi3CLnbKUE5YQrq3hwWFVX3	359
17566	2vahcqmLxwSnEPXD1ZEPUiZAFUnCYcr3TMV1CvwxQHZsjzD3d33t	359
17567	2vbY44r7CCXcHju7VzY5ipi8kVsfgTysCzQgrGeSWZ2R7Krmjr1D	359
17569	2vbmGnLQw7vh6oBD8FvDpruJEmrLoMa7erdrcmPtyqGWC2nZDT1s	359
17572	2vajMtgwmL7RUvF3WyWdNdnzFaJGFgW9hLKMhrdkt1DE54TkQxu2	359
17574	2vay2WsDo44kqUdPgtuzGtWuLKT29Wk5fA7Dw7Zuqhsxyb1fYcN8	359
17581	2varZSpZgtNCkgGJVcYCM3XNJsadH9KczW1VJJEM4xFpY8AYYk4Q	359
17585	2vbK7PFkWuUK9LaF5zFmm1Nw9GNNNK7CLUVFm3rNscQnK6eKcn4F	359
17586	2vc5QAPNchz6ss5Nw4RpQJKBrsvJLCchpY3M9upxtTuRSSbe6ovF	359
17588	2vbBeyiaq9t5oWXKpnLe86YqGaKfYn8hq4TRvqdjcM8QghQrSnRu	359
17593	2vbbuF97v2Py2vBrh6uMxkCLYo9Y6D2duRKqNoofBjaNgXJQKV8U	359
17598	2vbGw2v6BWVvx9uQYgGqwx7UYb3uds9BA6tQ8RfF3M4uitZmw5PM	359
17600	2vaRy125mFcnQVDgmm2SfJ2zpBCbUTUUYmq1mmhS6VUHfGDLqo8V	359
17604	2vaE4agmjiKb6SmRaU2APXm24qsVHtasvGPAr3LcXRd2eqh7UTxs	359
17609	2vahyRyMZep9mGxPWAtFuc7CcNALtAYgKEaKsWkbGxYJVT5AxTf1	359
17270	2vbA9CgcFzD3mNqRnBXQn1vSyq64z4Tx2dDNYbZUm9jwx1o1ZVQZ	359
17272	2vacvwPQBes4U8UWjFirFKy3Vfrbuu3oSye5HbG41qxvVRcFxRjq	359
17277	2vbH1hEi7YrxaeQXQYu1u2GBv7yE7FLfsAt6YGScxUqDgNK5PfEA	359
17279	2vbdrFT34MTmqFTSDtyDeoVVVGJK5dRr3iB3Fb3Le8nkC7pEJXxo	359
17283	2vbEGn7ZWMGCqPuuKXtL6HKPF2aqEqYcfNrLah69au2t6ysHXTTn	359
17286	2vamBio2HkVHSfhDYZjLxHvATwGrYSNuvXxr72NM2XuGsM1NpPT5	359
17291	2vbeddNr2RjcJe4bPn8K6tpMzipx7T1d5HBiqCiM3CamgdcbP9Mt	359
17292	2vboiBiT6UnVY7RS37czMzioxhJLyCtTo1ygudoiaos2Fs7xEikF	359
17301	2vahQbZqgS9kWRX8mdwVhfPvhiiMQBWHP8rmyTBUn9Ur1LyyseQc	359
17303	2vacu9nTyQtmfi2z2Uef9V39619GpAHokvBpv9TSa6aVfjHsW4XK	359
17307	2vb6cuMYLRaT8cFgpnFLxqjanyoBrJ2M64pFj2fYnXMA9ntT8axv	359
17311	2vauvBLiihssDSZ3ddwFsEHfRm83Lk5nMhcCsditNPiCuvSsGuXX	359
17314	2vaxHtEsYfWFF5kEBDUSv9GmTz1yrZ7Qh2pzi1Gcb9Y6aH4fZVR2	359
17317	2va9rhGn6Dcc8ZL2qDjDqLcqZ1x3BfzhYnhgNUN7U5H8cm76YNmC	359
17319	2vbPNskAGNVAa9BqMAssn4QyRWHLLgusM4wGRNR6fVP8yYvR5Yef	359
17329	2vbnx3mgygkmEpFU4L1jLVYJ3JGLfZqqFnCmebjX4jByLdziNDL2	359
17331	2vapoYduCKUapHG8xE3dFYtYPShnuD7jBGPrk2XLa3QyEL4tXdSt	359
17334	2vaSfxaTGAHVd4JDYjAhC1SR5VwBuKPEjCKWJLMMZp6F2TWS9tZt	359
17339	2vay2w5aYKYLQbTSKK6yQAQ7qSjb8jRRbEmGvGEPBKKuu3QZwGbL	359
17341	2vaJzk79kMXXTHX6TCV6RXnKfo38jHTkXsvMRpEoqP8LGzW2HGAj	359
17344	2vc3kaGACXPPcrhb49rXBJMEAtCxSaXc6k97FXoaiUL2CaxYYkLT	359
17346	2vbfAu8M5yahsiWvwaCiMJoQWnGmwK991HJuQ9wfjyYmFqxRFAi5	359
17350	2vamKRFgCqshDSb26MBPhTHdTHnA2bKMdUAhMxbFqWFRUw5HSGhK	359
17353	2vaCpsTUPNFnArqW2eztFsFuAY2TAEUNbpGu7wBsKS993gjfKe6L	359
17356	2vaZWsnxRrw6ygpdRrsh1V2z6EFyEogdWYoeDdatN5bfFFwEE1ks	359
17358	2vaMNyAUWijREdYyEr4SQwvEYEj9B1n6j2zxyKH38ZVxVhAkRrsW	359
17360	2vbht2zhN2Fvn1KSXeGiLH8rotFY1dYmyMnNC7FhKJzVJUFKdBAb	359
17367	2vb73qfvJ3B4gcj2ScHWcY5tWkiKjyuRePmJeSSdEp7JYLCanEr7	359
17371	2vaPB8CQMZj6KSKCx6gUbofJ26P4F8cdGDYQE1rFktyMnH64755s	359
17379	2vbDAYbSvcuQWEwAVssdYodooKyiuKDHfViwdko7mPDxXuRbbDUG	359
17382	2vbqg8BFEVwVV7zJwBq4jxHG4Pq4R8FFRbcyxKCpqHYFVJB2z9P1	359
17385	2vaJcY2A5QUypM7TnEbdeY8TB7Jx9qUC1K9oDEsdBVHQ7xgqA3is	359
17386	2vbRQ1KgNYS5WG1wLfqFhCcnfhauQtMj1amhVf9wJBK7BXvFrfvb	359
17388	2vaR6zoAR61RJsDEzBvFuE2XMp8zaTc3Piyy4HudLZUV1DRJxGAz	359
17389	2vahSiMoNoAJ1ck7C2VaHsuKxz348y6yTVfM7MqDVCRa9Lc17mXZ	359
17393	2vb9cc7J2uS1PjxdHM9qHRxvPUq9jEAmrE5bNVktURb85h6r3bfs	359
17395	2vboHHEeCrpUhtdBNdLjGePibXwT6dPFeCqeka61HQ8bgbKWQn4j	359
17398	2vbet6op3UxfUk8ggFqwmtAiGXQdPYQkdkZsUcDwhMYcbwxQJD9Z	359
17405	2vc3L9EFNMNdGh4z1zJrVXpQL4UEukYFs6HuitYjwNf4e6UQJk16	359
17408	2vbXfscdgpZZb1V9W41mwbnpFaDxfAesbyNXRq1jAWK9uHotFLj9	359
17409	2vaxXW3ZFxs1jDMqs2jvmhRXTwcXmzFBQ6cBCTQv5CHvfvmcLdVE	359
17411	2vaRGAPkvEQsQVDGnUqNB4JeL7fNeCZCb55eJw9z1sW9oaDoDJY8	359
17413	2vai79b68X8SjvwAmH2wXyytfDH6hmBQpW425isKVG5TeJeDkA8s	359
17420	2vbsCCwRZHJRfPh82w5zzzMkBWpshTgVLks8C1Mj7cEq6YV8Edif	359
17423	2vbHqXyenJKubPkudTfG5LYEkUif7tXvPVtnsGe2KspVvfGEoALz	359
17430	2vayHqZdjVsNErZALCCJLK4SiV9w5eruVvCPGh4NYSrry3XYWzKZ	359
17435	2vb1yJgR7BQGLMRG1Ai9rjmtkdd6wDaAE1iQSRxPHNss7Vx9z6Yv	359
17437	2vaJvjoge8uo2WxCpYKqSxrfE8SXQXDKh5oK8zpgdJp3gJzAN2WF	359
17443	2varYgY5gzUzGjfnspKSs9Ukoba2xVXJxxiETnFuFVjjgALBoJ6j	359
17448	2vbEAuWAVTDbs3MaZJ8WksddAygk4eSVmCbPKYFSwsLosCRz63Ke	359
17453	2vbo76Ja55DmJ8EGa16zSUZipJSGvLTouNYVsixUpLmknZZaErr3	359
17454	2vb4mc6yHAfLPa2G14etB1Aky1xrUTfwvbr3oUcC5nduJpKzAHz3	359
17456	2vatEwicoWACMupJAQLK4Kd4Y9iMM5yXVnRqpMX9H3EyAFC2zxoU	359
17464	2vaev4dWGTUGzsCrLiJiaDvbfDYs9Z6fpSLmCqZj7KrFQhXTMwzz	359
17467	2vakpPfPTW9uSsCrDRkyckMyS6M3taPBCW9gTTEexY96Dgh5X6y9	359
17473	2vc1oX4rmzueCt6WUst6zSnXjj4cnArWsbC35oc5SEKm5xwP6Gkc	359
17475	2vaWhhU49AW9iehhApLeeWKqfTD1FcDTBnDKvzHLjG84omMNk7bd	359
17478	2vb1GWBEX4NLad7t7mtFSatzc7a361EstgFHnnaJACSyg3PdtRH8	359
17490	2vbti6TgeLvKCmPYUDQZKsN7ZFE4LQf2HvkKKP1zTF7xWeWSkNa4	359
17495	2vbUK3RLbRXFFBTCCikNrnj8M53VNzBMR81Hy2byEAVsCQU832LD	359
17499	2vaY8qq6gqtdw3LzT8e8xuDex4wfZVZbyNdjJd4R85LKvcDyUPiP	359
17500	2vbWZcVFwWooPZuhTLSYP9h34ntSiF2JdnsRjbqqqRJTn9piahWy	359
17507	2vbm9QjEcHzL5TMJib2c9taQb4mUZ2RG9TSBWrtz5HjGYTexRQw3	359
17509	2vaoyMLTpntzZkMMv91icHDr9EnJDFLDxmebhmVj53TqN81LPrwj	359
17513	2vc1f9vsjAxtDmQxzPheTW1kp7c1Lft2QoedSxHMMrwrvqGguofV	359
17517	2vbV1A1UGFrTb3n35JSC1iL3GZkhySdzgJQrsjcLGvrUx7x5KzNg	359
17519	2vbnuZpo52FBUJeCdQf3XjsWqSaJv1Z4uh5DHYGZy21VMie6pYA3	359
17521	2vakd8hXMNMsKnuf6r2CNefybtsNhfACocpZtJRQUCYm8XLnvZy7	359
17526	2vc32nbHcUu2WhxgKcsbXEVLcPjJiM7RPsGNta7unXLcWbjsCHrU	359
17528	2vb9BdY85djdhfEShfN1qj75wVd6ih5XPrAN7dkbCsG9bubMnwzG	359
17535	2vaifG19briFAC5eVxcRMp5cBzN3NAoqmW9JT4rf7AZ9iXGYNEN8	359
17538	2vbBaCVSRquYUsSbvZzdk7GasoSaZWmvnfGjr7Bn7gSTaKh2yAH9	359
17544	2vaJXkEajxbFRmQNV7qY4Y3r2UySidUerdk19iFewS1W8Sgck245	359
17545	2vbuWXDZtpSVJkM4SaAwysH7duoJFxjADVr4X2n29hhdUdSXcPME	359
17552	2vaH9iw2Dkt3HhERRJLRGFsf1ccFC68kVLZu5TibgbG5n3cURkwN	359
17555	2vbi49nFoiti6DnjfqY4MQ9DbFeT6umeS6c9HoaR8FEXmpQUrua5	359
17560	2vbRDoitF28PpubLP4nQRm9fKXbhqpcy6XRCMNZw3kSW7Rc4QqoX	359
17562	2vbXbCwwNM6HDRpX9uuKN5mZqic98ZLo3oCycQRT5c4qPPqAkefV	359
17564	2vbj7gknBprfRCihJyawA6XfhWcQop2TiLWSwuKR251Ujax78cZ5	359
17577	2vaJScXmEaoF2gitaK1fgTnHZmVhsCLF1Ep1K7fhu6dxsKD1x5uB	359
17579	2vbwgh4kCDKoB2VKmYPo1E75sBkz5ZmhSgRQez3w7nqCH9srtXwX	359
17583	2vampKhkNyTskPnaK5sBuLcYawms5rP4Noh2yJDw35AtkisEKfWE	359
17594	2vaaMKNTAfhddGn3gxEQCSabqfMrwqw91bjjs7x9u8uLLFpwzXVU	359
17596	2vaegVetwGNYPq2u6EGGYMrw4qa8KCt5Qe8eb9HwDJrae1Gs4T6t	359
17597	2vaTNBhVpFcjx2iRJqaGaMhzZemeaeVk95vJ6dNHxLiFt9v7ysY2	359
17602	2vatAqXW9XGmNcSHrgFMJh7g1CQ1XPjKxhiw8mzrSoBRZ1ZU26qe	359
17607	2vbXkg2yep73JSBQ1XsT26n5LybkbDMXhniNXyWvU1JgoA15RYiC	359
17612	2vapTwgeMcBfJGhn1SRiWdCZE3tMfewhJyNEa27kQwcq5Mc8smHs	359
17302	2vb1qRf7QPfdWaxDHiNZ3K2K2gQM6jLBNSDj2PjkLAb97RbteRx6	359
17304	2vaDtAKgEUpjPJbvtEKLqW43ZkPRVdsqiCt6CLqAdGzr5wCKVqPJ	359
17322	2vaxzBvYNtnEvWMYq4cN5BizKJAjJd2gZSeaXbJfxSc84gwUXeys	359
17324	2vauh4iciRGYiXmTPRz71FU2wpYEVKghvez9VXfVWNtCgC9X19Zc	359
17327	2vaVbheAPXApjTnVF8CfBbQ9jbG6sBNHWaec5TxiY2bauY6TREoB	359
17332	2vaDUrWr9L1BVAFiD3A2RZEgdfqkC1sJXc7wyNsdUr2Bw9DLU6QK	359
17337	2vaNTWnrKafeR3BBrXmAFfqrrdipG6AHV28noFn3Ex1ouBhJogd8	359
17342	2vaejvvLPUb1WR4Hrau1zY8pQQbhSr6V2sVpjkNp6A8JyCg1R4GT	359
17345	2varjZVsCZDNEb1JtwqbUePJj7pKFCEVeniQBgFX9gwRFwkHjsJQ	359
17348	2vaM1qkLxrxu457fykjYvW7w1wpxkSQ6J6w7GMfEyvL3ooV5tsfE	359
17363	2vb2oR3TrSQrsbw4nq4YpSKqpjqN9svNhZUkPzjGKbRcfda4k6n8	359
17365	2vbcreimdVZyAMK9oq6JKLijC99h9ruNcfEDBRjhqZd7Pfd1Q1p4	359
17368	2vbaYAz99d5Ts3hSa4JoUZiTBbm15U1qovbuNiU35WEngyWNkgtN	359
17369	2vatqxrc8MGDEj5yYwF9ahccuvbFT822dJZEMox8JZoeasAtMxWh	359
17375	2vbtg7bEumQfi4yLYRVeTz2rHvFFi776j6h6ekciZWqe1rLM3D7Y	359
17377	2vaocYzKcbFnhmpw6XqT1JysWJX6KAn6dVytX6GuapGUUpqtkrg3	359
17380	2vbN2537uzRUPVwjKZh2FrDnVFsMApMRnYHU377ECRz1qiT2AM94	359
17383	2vbV8A4R5LucbkXp57LW7ymbcr1TTHt2xVr5vCaQijMFfkqxU7jx	359
17391	2vbWG53toEw2Ty1RJdm6L9qTQprGKTNjMmWd7YhwBygm5RL9tWz5	359
17396	2vbkEUU9CBYPfwau17iQLssfyQDKJHPVc96SwDfhMhjAqW6Yeb3u	359
17400	2vaDLb1nZKaoDefndYgvxPySAMng988AfQZXS2BMsdeazYDSxAz7	359
17402	2vbsAjuxwJSqdSUXcQZobMDSW3xV7n3MwPEYdc1LW53xCb6Gxzvv	359
17406	2vb9RhoSEgnBwADxrjyxEFzD2Lsf9EiZyg8KgZg5NnJfESKJGPuw	359
17414	2vb8eCkFAobW4jnGikiQrcfFm474QyB3ArosoRd8MfTfp99cqPqu	359
17416	2vaMnn3V9W8Edtbzdka1f5y89YMLXk96UgrD6yR2xoAK4F3fRV4D	359
17418	2vaP41ycVZDPKVgM9ManxovMnxraRLHFm8tFkwEEnrfAa8fdniVf	359
17421	2vbQpya3mYCEs5Zj2HwPu7CdYSXbu8tMZSD6ubWRB9v95q9Uv8DN	359
17425	2vbqwuAh6UVDyNp4gGFAMnZNdXLYXwraoTLnTYSaq9m5GefHPYQq	359
17426	2vba21BJUEnrzvbpf1nNurpQ84Dzsag73mckxFXmcbSwv12fueHP	359
17431	2vbsDYc8hJRJcpHvDEd5eeCz1gw2m9zmYbVhDpbfE4d1atGoGtH9	359
17438	2vbybCH2EKu7V2XXfxP4ZwpXkszdKpo8z2HirbdAchNnxjUYhWFp	359
17441	2vb4hcAUjub13aicTZjQiveNrmWsCXKVP5aNQBvW7yraRHfPFB9C	359
17446	2vaRT5Wc5y2SvzvGDbgR8kFEGBVdsedyJDndmH8m178N5guDsjXL	359
17451	2vaHTiCbUQqv8P7KSYtMb84ggg9zwsYRjNLoH7EsHVQUCRzGhKen	359
17459	2vaRsWWwqD3hczD9hDSVYdKo9nPEjPnoqZGvCmvnBv8miXiFATp1	359
17460	2vb8Z7HKceJcDB4M4HxSfbgeXsy7EDz7GLHuTMX4CyQFvYSynG53	359
17469	2vb5LKaRjuK2Zqm1eaRxShrcSvA1JWvAPTQqJfyJVP5a2aMCjFL3	359
17471	2vaazVqkgAd7jWYoDAgq1so55QWx4AXBuZuQEwiKVEpNYznB7kGx	359
17476	2vbatpoD23KFe9LCf8Y3GyNALJVXzJM4oc2ETyNTWaZ6G9hNhByc	359
17481	2vbPMMANZj9fnfhTJCUw1LhYSzs4bqkLfaLECfgKjx2a9prBa3ck	359
17484	2vbJ2zunrYs5SiqNhqiJ7zpjkD5DHTSQWurXbcCRNf3pwzEHpLcD	359
17487	2var7LcMQWEiuGzoweQpcquY4kNttB39GcdVmaVyWgNVzEZZXH9U	359
17488	2vaR1scuQt2QWhv5kTnmrWk4nQ2Q9oDka4e1weUw25QjpDtse5TM	359
17493	2vayHPGcb5e7wAKonvrxdvBzkb7HfQt3XctdLC1iddKWDQYDSg3Q	359
17497	2vbWsZeoMMRfv1zxjydPTNuyEecHjjRFFe88t8uYo8HEDZ1sFthB	359
17505	2vbeex5xFb3JazH4JeSXm9jjLYFKbSCNXKAcuixL7eCGLDKbc1Sj	359
17515	2vba314C5xnPRhzCEPTw1bAmNdavjsHqgHB4VM17afhWgXKfE5Uj	359
17524	2vb8B3kSq4VT8rh7hYhdSPvPWo1rFNrH1a5prAcZu7hF1JPDm73Z	359
17529	2vbMnkYQHEDgTX5jt8rrryWFNzjJxcJcDG5uVzMAifgFTgx4fvmB	359
17530	2vaDB7MhStEyr1ShutmmbimoHFyxRtMNyeJYK86gh2ZSJYBD9kSa	359
17533	2vaG9JF6XD1g4CeiuHmWWw34e55kLoe6C1jgWLCsucSfQANnAC32	359
17537	2vb6BeYqHgkzHKicSbQFKaiQrGaExMwtUMZ2Qi8fJsXV6d8rS2PW	359
17541	2vaVtjfjRSrvTo7JR2qnpkLNVCiQy1CePpVpWqNB6MAgRP4JNLG6	359
17546	2vas5TjeNXGUqAKfpNf36V1SpGg89AtWNS24v6JfJFymGJiX7FDp	359
17548	2vavgjp8LKZBBGX7p3WoEKAvzD9GTcauqW1yrg3u7SutyvFiXZ52	359
17550	2vaCbqqzFBt6FLaMvcHnR2Sq3znziYkVovj94wUuG65CpKsw8ZvB	359
17551	2vbzsB8UbSmK11Uip2RLRp9n9B7XbUSonQGmGURyEJbCMtQug6PE	359
17553	2vaP5pZmvPb7YQ6Zs6yAyZrRfUuBnyHYoheKDS94o3LTanW8rhqt	359
17557	2vaUHf1qmtHy9j7iVQmbmTd7aJQ2djwtRvFU3DVWyLCv5oNZ3tyG	359
17565	2vazNGuHDihLcD7wXandDbPFDepEQLfkZRJBihkBhP1YWTY8iz23	359
17568	2vb3GMgDyzVfXGdL4EQ28gUh6MoHYBB6yskS4i8qDk7t4kk5tCDw	359
17570	2vaTMH4GK8Rqowa6uu7VxyK6f6Vohzvkvv2yCbowDqzHhG1wvaqT	359
17573	2vbaidWxBH51zHXQAcTyeGRA9mqDUPWFvniHHi4QYVJf9JpEC3E5	359
17575	2vbFc5Q7RYA9yd4ear4Ht5vB4oNGx6n9n7gVjgU2uYgq3ezH6Msb	359
17582	2vbSguzX8YjmxQR6ZxVv5mUkSwUGQZXNCJtGKDy7MDT4fBHnMEGu	359
17584	2vaXgswa4Q9HRXGTttXXKNsyMnwfQowsm9qGX3peF1roQea54EgJ	359
17589	2vaEfPkqbJ1ffQ7mVGoA8K3FJ4CwmkBXnLPJVVo2bWmXaz8vAfW8	359
17591	2vb3CLD1PXVL6avacijP6WQsEGMYjw7g2hqwWxWTQaByKe3yk3M1	359
17605	2vbJtgranH5oPFKMdBbFjD3WTmoxZK1mQgPoYYYSrQKn8oEiiDeq	359
17610	2vb8d1u1PBHqwJioanLWk8Gw4R8w8qhizqBz3THCtNeubonNBnu1	359
17611	2vaZrSPZJyrfFMt8BgWt8Z6T7U9GAPcEbeBLyFNCLwYQVd7RhyAi	359
17616	2vazqGEtGdTBSqQzwuUu1S3kuf928MRS3cC471BzNHtvfePRw2SK	359
17618	2vbDKoP83ZAN8jGdWdLwD1gvAmeeGSmJHSwe5A8tWffjBfgQTvZm	359
17623	2vbzVeo2otvB5koEjRnBizFi1byi1iWN3hoJHbrwSuifJo6RKGJB	359
17625	2vaWQoZrZMTe1SbPfwVChLPW8xk2pYRWxJZV5Kuu8uz7GMn79xFs	359
17630	2vbszcvNuUE2CcL3fs85qU9omJ25hyLxWRiWQ3D6rUR4XanSUjiC	359
17634	2vaenTXqitBx7NbEUsULAdyDGHBrZtLBy3Hp3LCKmWb5mkE8AW7R	359
17638	2vaCqxwMCV3uecyCbmzcEevvD2FngaXPRPdiBYwxC8C2TMn2beve	359
17644	2vbhycJetjdJXtt2X7n6Y7YAVfhjpdgFhdPkvX82mBVnWvn2StGJ	359
17651	2vaX3jutJ3dX7cvRiKuwGs9Puw24bHAU8tLfKUcENPhH7RmGbiu5	359
17659	2vbYPtR4ibMHF86us9ZWx6CvNu4HSzhXmKUPM9y2HrFHvC7wHDzF	359
17664	2vaKGi7PLwPQsyydb2dYvHQfKBxEvrQCFPpU5jKZSKT6zRB4RdCQ	359
17667	2vb66AQDJgsAxrrGKgDkMCQsbBcTvLvgrQTzXaR9YXju5XkqNsZH	359
17670	2vaLmtxQq9yWE93B3EPHE2qieGB13NBNqVNfiAa4xZ13wiZ7Pdxw	359
17671	2vaY5oBz9HtbRDyHiYYRWybhqv8tmMbQtw3uS6Rm17jvgwdgJkp3	359
17679	2vagrQeJgfJCc45Gi1Eq55HhdcwD4UjoGcekA3GWdPYzF2z4YuJE	359
17680	2vaYyLcA3dm8QFHvHiVXx4wfL45KaZ6EMmc69CRFDSiGj1Mcv2Hx	359
17687	2vaUGG2HaPyqtsSR8eDTfDWE5Fy1QCYrrvhbFRxGA2qBRkyg2sZk	359
17590	2vaAbvqamSyLF4b8Qwz2hteG6KucJjpsgi8vSoLrxsHYkGWjKyJF	359
17592	2vb62ryzqwTHBx2pyUbhASXybSDXrW3RRnnhnGSzYczampQqaud8	359
17595	2vbntHdfYbcwikC8UWAagZnLMq1PM9EdtGrf8GmmBSrphFMXL8HY	359
17599	2vaSaJwNMRThrMXgUb1P7pQYgikV56qDLy9tEnubmjNbP21px9bK	359
17601	2vamhfAzjmn4992JBhYZjRydGpdfyV3ohovrvJUKWMMisFJj3CU7	359
17603	2vbihfgJSNYBL5Nv9imyNsjckEipFFGTMVadrgSy3E2zEK5L8TNX	359
17606	2vbjzsdNbzbyZRvGfw2Dzq6Ma7B3M2Ne8cAXvNR8Gk1uLrbkzHs5	359
17608	2vat2mtM8rePUef7UDQzSqahiaBMwVXavYDQUrME2Czm2iBSNvqi	359
17613	2vatwXnXLDLbQdD3JqZF7b4qtTF1VCSLndDfFc9Ny226KXBU8rmk	359
17614	2vazAvqecyCUso8YzdKWkE1gF9v4P5uhRaGCWCApjKqc2exGcHMP	359
17619	2vbxNZ2JNLExeXZDPPhxmLv5Eoxeb3cN9nVYQdYuwiYSJrnif4qe	359
17621	2vaMiniaVvSnLQFXJBVoQ1hrb4mYDXr2eNRzYf82B91vf6ENvEUW	359
17626	2vacFVR5XrhH7C1Nvz8E6MS3fPPJK4V4RN56LAVZuBXzJAHHhMk5	359
17628	2vbFmuyRhp46fgEMKuYhdom4wmPC81sn9Q2RtNwMaf5STZK9Gwb2	359
17632	2vbDe5RRv2N9UpWjQFKT7kxDpRWL1b75Njuxm21tZYZqvtVGixrU	359
17635	2vbcdM2wTU6xHbpPtLEr5zijinYDwqRwG9W2xkdJm1oHihmn9VEG	359
17641	2vbtWGt6AZpxdYm5eFCADTeny3kyHaUYde4c72wWBXQxZK9sjFSK	359
17646	2vaPpnXtt2DGAJdkEyCMp3UPmj9tTXub5Ja2BGjC1oDRNnHaToyW	359
17648	2vagQfEVnC7dY14BPsY54teRd12P3qVHjzPuBJqp1NVjUN9gd8gG	359
17652	2vaHpKGtRT9Hr5BFdtynboTyVQcTPsV2q4XUAEgWXRyChitDxN3J	359
17654	2vbggWdyM8z8tbQPeE6u7xwMnwu6zH5rQXGV2W2ztTGxsdTPSjk3	359
17656	2vc1vN3XYMhw35WHi1mdDQ6fHzNWnE9f8CMEZ8acSUZ3UaMgb9SK	359
17662	2vaHjwe4XHYiFmQUGNXVmg5hXVuMqjheMu45Yqh7QGW7tLMX5ogG	359
17665	2vba34ks9YsR1uUt13jzMRXrQXsyDZSxMs7jgPpZ2ouFnvq2yPh9	359
17672	2vaCkBxbqhDt7EyRNoWGDt9435Xeik3bqTmHWaZu9aprArLedR3t	359
17674	2vaSJRz5oLMsrUFsbpm4ArgVLLUqXUbMUvXpZi4CoUcbXcRZ5WEp	359
17677	2vbzEAKKxNn5GyNTAuwvnQB6sY3PRac8e8KESZ1mJQ97L3WgSdGn	359
17683	2vb6eNQ7gturLscVBhAkcnMy2F4QbAf2trKjLZJpK2eQyN357thC	359
17685	2vbEucgZwE7nBAKpCyTJAcbX2SVmvPBJ8HwiDWt3roSXdnRKsNF6	359
17688	2vaL8WkgvMWgY5GcmQapNMueRRkAKM3we7Y1fZ5FMZBUpgeDYfLK	359
17690	2vb7qvXAz4p6CMDuwCMzQg5dKqtopofpFhk3XTCAbzFBrSnmsKDj	359
17692	2vbTu1UYiiEfpSV5Fnaopb4U6Hnx6njQ8LuhFL3QgFRqYcVXSwjn	359
17700	2vbSD95wimqiaP78dPXDVMmYmymmAcLn1dK9ZtspEmRnrXtk7otd	359
17704	2vbtDEZJDJ5nmjoRQt9SeKp4CQkA7vxP2hDGVuwn9kpehUCaSmMT	359
17706	2vaUUdQah89zo4YGcibsZym2WPJ39gEpido99ZMFaEeeaQSfyNBB	359
17709	2vbBH4zef1Q9jfDVv5iBr7AcLVXJ2FgRof9DLUZR6PNxusobqrm4	359
17714	2vbxgB8y2iTPU4qGMGdjsGyqBqVE4bYCxXgmT7MvdjkgL3sH2vWp	359
17717	2vaTEFhnAZ1FiULWQuTBF5wRr6ba4ExatGKKfn1ZVEyaQfV1ciLZ	359
17719	2vb5tShdVbJyb1k4hbYNjfnVfgcChYx6K6WVhQcZ2FeMxB6HPtnJ	359
17724	2vaFcbtRRx4DRNraJ7Jt8Dfse7Xs7bBt5sTHavCG7F4HfQQWD1Rj	359
17729	2vbN2dMGr1CxRyMwoX7fJn8FKkrPibMpahrr7sedUQE6AozRyZRK	359
17730	2vbVyVxgB83C2QeMqGZKs5SBz4T5CPhkztWivUdtfDBtB9TEBKdH	359
17732	2vbr759DS6JgJ12sRZbKijCHHayGeG1HCZpW798wz8GCXA4tvtYm	359
17736	2vaCmnXCRUmBkGoTohn3BTDAEQknFzn3hmxBCSzCypejDt2mGRu6	359
17739	2vbXSi8iHCEzMKTq51juWnkirJvymjyb3AGNoyUpU1XeEEP1K7Xu	359
17746	2vbnwVso9GDZ2tXdqrQafiVyiPCVtRnVRZVF4kA2vnWVRjujPR8k	359
17753	2vaMb1gCh5u6fH8UBpFucV5aoEa5cSQWTAkGoMBSxbFcZuX5Mnj3	359
17756	2vbTCrA2mTostBt63XyKoFjrM8kMb8XABmqBin6LemovuHJkr8jW	359
17761	2vaG4xZiMZZfdK5jt76mTrPBqYLjJdfAs6dFJ1D79Ym62EfsiDEE	359
17764	2vbgaiaaJJWxEh8ai7ptdJqS4xfR5mifksWJDH4CVt9gzTQHyJGJ	359
17773	2vboDvj7bxy9WTwRKAz4n3Pkr4C4eUmNekMYVs7ycggL5dg1PU9C	359
17784	2vaxkXAhPc6MsCwQQCQ5dBQnd7r7SAhqZkLBEBjpsJ27wub7De8A	359
17786	2vaH2jyxeThrPzft4p1ACBVRnwRXFuja9kMZYStDnxdm1dPcxAhS	359
17794	2vaY9zDJeFUkuP4LQ9yWJRTERiasTTApBkq9cn63JJvnZLAff72h	359
17796	2vaENdPACUZV7KAj8y4LXhMiHVLkUtoFobFMiVDUoYhaW1XSZfAc	359
17800	2vbj2dXDstwj9sY9LjYaczatKR1MYoHJ7GD4HXCnZEU4TY6eLZ1D	359
17806	2vbscSquGSjcHtRncZ6XPudTMRqrNz4FENtDUggArzMYLxakCcaD	359
17808	2vb8MGXRpTrfdpkHwe6ijpJKUwXcpXVxy5QeNhy4B9zUGkZSzAk8	359
17815	2vbGMR2PjMJgSqwR8i2w5joxsuu155sPSkiqpuz812h8qD1bkVAj	359
17820	2vamnXsgkNdeMJL1Va7VN9sgmHevpB6Fjmv3yF562wE9YiwEEQXF	359
17823	2vbiiCqNnRScfCsaoqWp8HMQMWJaHAHbWjF6ZhoSyFWYnLSQChwQ	359
17827	2vaduC9wVmNJ6689KDTPJkxNt1Xp1cHRuvtcLbT2uQDLmFHgPtRn	359
17830	2vasMiQP3bHQgntRj7t8ArSb92b6P32ffkGfvFezPJ96EsgGDfJs	359
17833	2vakHVaf2fBAcUitzXR2tWPtFKukFdS2o7F3k1uBm4uajDABcGPg	359
17836	2vaHhYW8CgYdNsezrQTrvkJ5PbJg6EdfcBFgkmtocRVr4B1TqhHS	359
17839	2vbyL9WJzoxHGeeQioLUogKBZy6TDTvcsrZvPM4uPfRL5nHVCmDg	359
17842	2vbtn6pdR4QvAAoTh9XKv6cq9arQFTQVxwCPyH5xUmq6eWrTh3Lk	359
17844	2vavKNgadnLtaTMRE6DX9mseXbrUaEmMhWWQoNY7QcYmirJjdAnU	359
17849	2vbzRwEBya2gBNzFeRsVoKZAAYAcmj5u6wt9qrZqeDTszm7MtApg	359
17853	2vboCwrTwwSA9b7HgaxpTgx44451fjQik9s3tvShiXmzShJzLHjV	359
17856	2vb8MraKwGPrwbUCuEHoNMP3oZieFS3C59LX5mxgovs99Xr2h3af	359
17858	2vc5gSP8xpaMaPugPv3dnQCDVc9xhTKnCq9T2bX91VACp1uyworv	359
17861	2vbJcVF9nckNTWu2npXH1cTkSPRDiwDnjEpaeUD6u45FxENrCSYv	359
17863	2vbwN6xk1Ga7tEwYPHyzRTAkWp9EsdrVsWnZYv21ejoTv2W88y8Y	359
17868	2vaJtr95ZwqqDfGFGgcTx5LetCF62119ARWXWpmRheio6yjVaRsy	359
17873	2vamyjcWQaU8H3yB22KNdKyHATqTHY9dTvKktCbgUVZdMGN2GRL9	359
17877	2vaD9PnbuQMb1ArBRbV2TnXHNfmqiHikCqZBAkU9q3iGfN2fABwX	359
17882	2vbYxf5e6STM4qMAVNwSiYaqWyr31o8JLc7RYDSde5Nw6xYRjhYm	359
17885	2vbG6pTYkDmxnuNVtQ1AJFPFQhV6EwCtFKaMRGioiKDi3468KPw4	359
17890	2vbanaLzpiwy4wBPc2aLv1W6jj68A8ZAzHTSF1PDZBtddnZTMoUc	359
17896	2vaSyZYz5hWnYq6rJLBnv3xRkiZVisCBnzq1gjjTipcRkY4CFqcC	359
17903	2vb51LstVwFsPoP5fPTsTQMzx86qtsnJzjm9jX4uChhFdu4XMpps	359
17906	2va9hCF4dP5o73JsrBWvfX8jpreJAubPWGC6TnEgM6ZDSZVqBmbz	359
17911	2vbU8ERbcMkiaFJWnwLPzu7KtEYDQttsrG7E97SEnZccdxa5KCdQ	359
17915	2vaXEv7AexuV6vXd7khAyyXgAHhdpHShfW2YbAimG9q1BJGgeRd4	359
17920	2vaDeY6JrZCtd8RW2SxwX1RFqVw7PZqfEZ4whFBoJnBpn14ifJ1R	359
17923	2vaaM28EJTLsuypi7PppK5KsdpTxRtghfykmRDxsBLFuBLKxaaua	359
17925	2vbNUF94JiUCU16NzsEe1M1tTeVtqxazeBfJotCSXv1DJQAmtYuG	359
17615	2vbCKNuLweoezVH4abwmYzELwkiHb1WAPF4LaQ7Sj8bRUCW7TqXo	359
17620	2vaEBMhVRBRJVXLJoex6B2egcVDjKL2vVHgQfq86XeEGKZiNjo1V	359
17622	2vbKdtbhr5tVqUt9AHNhzJMxt5bfGsmkeZM1j4FbTPRFPi4G8D7p	359
17627	2vbqEsQLQ5sHCtshPztEFeS2p9vbeujEmeRQhgSS5cAeEKNdxdJS	359
17629	2vaNyb1LtXUV3FuiPnrTuw9GBX4UfGFSSi5SqCwLCGHkf2gMhQCo	359
17631	2vaobVqcZQWBzMnVUKwrJhmhasoouSDWHN9XHmvHt9CYDSs2afVd	359
17633	2vbUhgQ2vSz3k163xZcKC1ZDKzUJajJZ8Wko6HW2RNcqsuVm7UPB	359
17636	2vags5Fsmkfk32SLvgER8XANdhwVKXWP7r56fi43sPJPZttVY3Qe	359
17640	2vbVpE9sdwdmeJGkmNvqi9kTLb1T6LRFRmsgXN3SHjaxWMssqe6u	359
17643	2vbd5U7i62v8jVZWvvcCqM6i7pM1Xe1iV5rd2AirGVuBUwND6kxe	359
17645	2vbfEoPQGydqyP4kP7EB2HUxrwB4P97uKsE1K12g3W3XcJMyhe5q	359
17647	2vbJRvjG6dYVrFRdEkuBhf1zWvhVweGZhfjXG48rXxWUz8wSsoYE	359
17653	2varbFZknpYY95dzANXZSz676R43kutf3yToEVS4Gs3VCgxr7S3z	359
17655	2vaCmCSuxPjSGoiBSasmnXpZ3KZH7xeiSJBjn4q1seZ4oqf7Jo6E	359
17658	2vbA3dZYsp71uH5x9qiF5NWdG1yBT84HJHKQV6d94gsgCcMYbs5m	359
17661	2vbFQCxxJsf4Fmbs2Gta5yhhQS6bPwYreuYsMDp1WGBjaRxxhdPC	359
17663	2vbTmpSBUp3qn9rjPjjv49MgX5zfEDdzuFnHAg5xprHoVZiCu9qz	359
17666	2vaTTCLMR4V3BK9ZiVY2VZ3967NJu2to2dzh64CpNgWDM6Tqnjyt	359
17676	2vaq64P5eeNpSYL5A3Wyb7txu7RjArPinpDtD4WEdFWwkvKoFCZd	359
17682	2vak3fCnrky38swUVn9nFttzS4dfhSy5118VHeyL3DwNQqgb3JPL	359
17684	2vahaLEhhePyC6jbbW13QsBDr8hR9SuoByzkLHJ5JgdDeZs1TUg3	359
17689	2vaECJ6BgodMM79Xo6pLHSMgU2RK5QwdD11xnNiwdJSTM5xcU7iD	359
17691	2vbxNYtJH6KLtGcBKT9SNjHfSDktJS54uf6oNeV1XZV5BcYcnpWo	359
17694	2vbe6dVkPnomYLwtrXMSqU5mPyZegb5JciSbx9FVWa13z8o7QPmE	359
17698	2vaZZia7syTnaPhD6m5gzDu156GN6FjKwXkgMhkrfdxseDgH7hNh	359
17705	2vaeDvSw6XVP9C8qYY9dzwfVLRmmPF2UV27gpWP6Lk8TKnxiBkA5	359
17708	2vbzna2nQswFGPQyej3GpHyEDE1pgMjFop7twueJr57uLFGge91Y	359
17710	2vbY7GcpYuECTZE9wX53TFi8pF5peVYbUw9VKDetMyU5fyrhDNgF	359
17713	2vb8xCwhpZkNcrmj6gQckZ3j9W8dECuvDU5Guf2AuDHjxtLFiuL8	359
17715	2vagSsuu2bevdpabToQpBFZA59SHB6sxiTLtJTXWkxPp6XYXSn1t	359
17718	2vavLU24LK3qfH92FjNsPfxn54C48PRgXa19m8scvbYaEzZqwYi1	359
17723	2vbQ7hSezRfwCdc2FhQooyUmpg8zCCWTgriFA1kZj3oCcyte6MLY	359
17728	2vbpFrmKWhbWeUgmNbkmtoGBs42EMH7XiV4q78RMt69hspvUHMSn	359
17731	2vaQbgqocBdUA3Px4F9FUFB89Lohc3SZsG5XvWsKdjyQDJJviGyo	359
17735	2vbAqWqNM9MvVUuYBVvy9Jq98Hu98Xoy1ktH9yYs12gEKGxidUMN	359
17738	2vbDz2JCdyaUDbgrar9GqgYL93NMgkUxKn9v7bZ1MCK8LnuQXZyL	359
17745	2vb9ZYgSSZRJtMHpYt4JPMeDcEFsXeFgp823jwsEyXELfnKDfW65	359
17747	2vbcYkDAxBrrf2uhNsbQSpXURCx95U5pppMyG5QUogfCkio59iru	359
17752	2vbtJhBdYGoQDKPHxGUekv8dHW3HkniFpcbGXS8TSJCzSuG8G6DY	359
17754	2vazqS1ABEPy2fnDJAcA8u8XNomr2J6Th2HbNpMnvwkAyzKbUA4p	359
17759	2vaHpsJySUUDTtTWDUxdw6pJ2LaPqjJtJzCEdugWyCdyPuHQHmQf	359
17767	2vaEvSRHEHh8SS6fbyBnRJb5zbVkmk8JeufBCGovptdnk6Lq5tFB	359
17778	2vaaX4n7NT9ybMdJdmsKXw1mXkp9kZss4LzkAAvcGCLv3byrwJT5	359
17779	2vaGqjZ8ZAwXBHMMMrvbULquPmHxbyeGudrAppB2nGv2JbpzWTec	359
17782	2vafLikmuRqNcKvr5DvFUBmUBRKy7zXzCUz1V7PHLYajq6kQSYxA	359
17785	2vaBGvn6XYECawVWUuVCodzB1YkNJwNuGksMmWEjc8RXKcmfLim8	359
17788	2vbvLBd4Lvs3Pno6QKq2UBVwT7ar4MrQyrKwU7Wz4ASZuRY611yr	359
17792	2vbPVkkMCpZrMVgz7sfVWMZKe8jnSFvFdsxMAkgQfXdxTRP5e3WB	359
17799	2vaYr9W6URbsqac4Lusc1opZMg4r7xP194A5kzovQFUm8wz4jDcC	359
17801	2vbrQZkpKSzxByrc8mF6HmV4FV1wFBxczTdNysbHwpMdq8zGYpuT	359
17807	2vaUL73fanorYQMC37mnNffnLAKZMEhAGSKziCsoLbLTrEkx1JK7	359
17814	2vamnGB4qzEwD6bvjNHjawCMDMTGuQhVxFHdmUm4aXpes879iVow	359
17816	2vbApJJTin3c2okvpvjojHz9J1fpYnEVTCa4kiZW71wsKm3u3t76	359
17826	2vaizyckJi8aCuApazuYBzC2iDwgCqviPKs3DB8Zo5R2ToUhGqF7	359
17829	2vaNFtFLyFt1m7UzvLnstuTuwtWmf64tYa7hNiidHMUGd8B8GTHb	359
17831	2vbtNJ79HNswBhSthz7Dpu2raCNES5LdhXwYGesyzVinLhGxL4qW	359
17834	2vaz415hfYsynx2tkwFFxC7D2Kim1eZx5M6apNnWEvKvratNbRUb	359
17838	2vaxQBabKr8udCFpypp9AeHw4c7URa2GoD9MbycCsrz8RXAuU7CP	359
17840	2vanazRn1sBqMTTNYrAeeSx3dRdDcFUhRUVmKEpUwxnmPEPBtJzf	359
17852	2vaKgD8odFZsWGU6oHQ5zQmgn8FuKZbgdyz7KSC5Mtj8U4JKzTAt	359
17855	2vbkHGiGN1JnoQDENHxBm5ozUEBBF29XQaBjFEiRCvKteps9iaMJ	359
17857	2vboC3gfCk7Ka1pAt9U4i3JCFn7zhD8eA3TQsM1NSwWh7yBBMr5P	359
17860	2vbqvssAg9JHDeRGPW4gshdbJm8gNAx7o1GLWT49opHhRpS2mcw6	359
17867	2vbkyPMyFmrNNVSBCmkysfNYFugXPrK1dz1ek64kUYBESv2o5Q7p	359
17869	2vaRWrswTjqzNnyX9KsuoXXUCoTyjtnpcqmBGpFtPEF4NMjzFWfe	359
17874	2vc5qWzNLwUCHN5Wjm9mJBvJMAgu2dQmE6R4FxZGoZ4UJUwBYSRH	359
17876	2vc5cYRH52SCAH32wkH8m2BoKudx6hdphqNojUd4aAPe7vi5ERH7	359
17878	2vaAvnFV7tHgkDC3nbuzf2GpUUyZob88Mxj22BZnLQYviVhRB3ti	359
17881	2vbiM2DBdKGSLqQXnDK6upBNdSkYDx3aTtrj8NSci7QEUdMnDqP3	359
17883	2vaAyHjir2rB6bNUHjxNtUF6WTkcBCQcfk457L9AzC8VvnteX2Rk	359
17886	2vb6vCysYMc8LVQ9QPC3Ur8WizNS2f4ihzzq1HsezMjuBMNLYgbE	359
17889	2vaePZiRjARw9cU7EWUqeDDEZNWCiw1xhuvzcX1kGJV1xhRkJDRG	359
17891	2vb4mY9Hyazv9gj1TWo2NRZsFHj5g5APrrm6rtoXDK9PRfqzyxot	359
17895	2vbeio7gd13QPYnTJM6mHMdoCafKgZ417EE56CLM5pXsspU1hi6X	359
17902	2vbPkk2Qr4ndK5ynkRnTFAotPVdtFYjotKe7PjjHMpn2Uo5L4S29	359
17904	2vb9TdiWNju1XPmErmLy9j3QFK2aGPpLFeRtGzATC6b7ap9U8KNK	359
17909	2vaXFgv35jssbdDXcM2ki1UkPgeCMhj9V2B4nGzRE7Town67snHe	359
17918	2vbntd1mMJE4hmjxYmwiQNqMC8LrvKQjnT9hds9yyGQY7Kgqn3hC	359
17919	2vbxt4zfxx5Jp8v4gPqSTj8CEr2ycHbrXggJm4i1NmkFLYifhNR5	359
17924	2vaNqra4uyV7Hvs9A4N8QScz4i8MzmwAZ7YJToHAjCpj1MVeJd6V	359
17927	2vaEGDWRwcQuAw9H9GrcrfBW2bs95cebLWXfb7T4WtUsAXYke61f	359
17929	2vbNmgdqCzWivGPQS42DyZ8JBxhD1UYNyLLPpaJ7PuGGw3Js3XWW	359
17932	2vbHaQEP3rMXpgm3sfj3PsR3vfHznz9sAqd7cRLhvd5XYiEcuqs1	359
17934	2vbhzQdhWWn9BpDvYZQEMFGriTtNhb21UQbVBNkxBG5kBL1nv7FD	359
17937	2vaTosA8BPitzuNo9Cnd2zzoRUBmaz5fm2vXcRyWPuyN3zM6aXN5	359
17944	2vbjeFUCvNo8RJM64MzV1MA8pdDeBbyG4iyVCav4BZS4ywFfEq1f	359
17950	2vaMDdYaj42J73wPffKTF8k3GCDY2HYUF2ZwKwHTmVmpZLVn44aN	359
17953	2vabsywWbvYuhfaRQVACA1PFwwzDfQma3KJ1nhXDBVB3Mj1dhRoX	359
17617	2vaKgHCBQvtG2r8vueYf8f4foPY1TFg2QBA3B6QejyHnCGExWZ9L	359
17624	2vbuh1HCT942cB8w3bgJGW6MJ7fAkpRL3sL4CEs82BGiMRrbmTzZ	359
17637	2vaQmsaJtXKXXRnoWQdaPowrVJSMLzWCpXiZP3GkB3TShM8wifaP	359
17639	2vbRHDjgQA7QkfXxTbuQEow3UCoG6KK9vhCjNrXyByabFemUcFZR	359
17642	2vbeUXfbJEHRXfgFWSFXnbjDvXAcXBaovX81NXHKFAmd2WL4N6iD	359
17649	2vc3DfbqEw5XXaAq5VbwdXcJTpnuf7F5wmPepdNywBPWoYmxtNjo	359
17650	2vbM1i1dNRwwmtv6uCJNWMbHbKNxxG83X96Ptd1Xmvq4XUN5ccCh	359
17657	2vbL1AavBK4k6ydeZTSfiEKsHQ8pPV9mYKQPotvfGnm2WJtqHxkN	359
17660	2vbFuX6CvX4ecdVpQ2mvdXvQY76kFkWZxRjtQjjJKbcY6BPdf2sA	359
17668	2vb3LQ4KxUFRrBGYqvkms4cXTjcW9KV2vcP6JYk1ZLnw6Aaw1Lgg	359
17669	2vapycoNTYjFKu6Ye1x6thP3G1LNm4x8ru4rinXebvLDfkbAX3sT	359
17673	2vaYgXzJxJAK7L9DmfPWaLAJhx5VeJg4bYwVE8h9dbsW1bQogacE	359
17675	2vc49m5zbMiivVmbSFSkrj9MNv2UfwWvM3ircm5rWaTgzoDLvbiT	359
17678	2va9Uy3maDFYQN1zo61msEb8bPaFiYEcpd9rkyNPGqLfNGwcudRq	359
17681	2vbF5ZiM9MaReT7pTjSEemRZN5h7SrXCkXGCRcUeGt9DqNuaNuZR	359
17686	2vc3VtFUsRi8EiMj9oRF2K9ca8yL3hqev99n1PLzdnEXVbqcvh8G	359
17693	2vat5FHgbhtdoeZXPesefQVTu9NgMd95vcYstq9s6tdLRwJcU5VB	359
17696	2vby2ZGBBFfSEQ5w1mWfiEEjUm3rXBtJFYiprpWnCkiJvpZvxFrT	359
17697	2vbdEbXzcmVUjTEYmeT7wLw9TZi8WbCGxtqyQisuNQKJty9BZgKV	359
17702	2vajak6tMuaiENV3yVNNKxEowfJomm8tZtFVXTXWZuVeq1qDaJVv	359
17707	2vanSWBMA6uVZFebRLbKJ6u97QpiVw6kq2DhAyWK5cLeeM2H88X3	359
17712	2vbnUbMctAyTkqJ84sgfZAzonJLoyn657c9rVbHkUfBK64gcNZ7D	359
17720	2vbGnejcYn5W1QGuXtMgCyvudHb95Udr8a4rHfegiqv9dXyrssw8	359
17722	2vbrmAGzYgQeVmTCErfTJ6AYqNfc3qj8FbyQUkuxB9YS9Wot8TCz	359
17725	2vamisjDY2BqemBP2ELdQnEDt46A3Y16RzpC3Uj5nh8SzE8c9iZc	359
17727	2vbYvpHnktv4S9imP4PpBM4zjQMCs3ffdSs7vqi5RLKny1diAtX1	359
17733	2vbvo1foFKzMB3RSTfS5hzHPwvMwtEfcWgs1AdDN3RcsNHybDurV	359
17737	2vbqVxRTNNt2quPcxw2Bu9fazANr29CQ8g3kUS2Tohk5AFot8UzD	359
17740	2vas8sGUWjskMC1KMeFKo6TpjKprm22PD5hUqTA3upofFWNvWzM5	359
17742	2vbv7BajFYFQU1PpPToJ37AdPXyedMmSBZdHm7nRkg3sMhVncQYn	359
17744	2vatUjepfaH6KaJZ2pWWbjL8YtQkovz2F2W8CN5TySPsaTDMsfdv	359
17749	2vb9a6RFY6qSgS8JUuDvgSpieL5UiGUczwAEwDf9LPZtdoaeJDQF	359
17751	2vaT86TFmmCyW52NepCDZcLzDXLbiXu7TR23L6WZKRQjfk8rXu9J	359
17758	2vbkWebJUh2EPxqiTBZZcbJf5rVnwGVBPVRUmnwRbm43hUfaTHZ9	359
17762	2vbdwtTbYnTymnsQm35RcWXGEVNd2LG2ioan6wApfPRmzWGf3z6d	359
17765	2vbQ23TuPQwJuqCqFU7aP451W7o36P9zp2wQJUq9JhTLrsySWH46	359
17769	2vbpwMNj4xbP15RDDTm1nmLAk1e7YWLSyezoCkvvYC6XGsZKQcst	359
17771	2vawJY9WJeawtDND44aFzWjzMxJktmQsh26UadQW425akMyKx1Nd	359
17774	2vabPa6CXEPVTTvvS5JoncDqz5qmS56cgC9iyYYxSv122BtDwdrG	359
17777	2vamCzFj5ecLCyQupnc3ux5dAPJ3KnVUXg5gz3XdP5Hm6o8uoGgY	359
17781	2vbpAsvvkhawZW4ykT4zwNUxFvHnZy4HYZtWub3Xw2SEGi7FaJhC	359
17787	2vaiABz57LKasgi2MG1AbNG6Ap3eg6rCXntgtr4C4N5riocYUMwS	359
17791	2vb9gyPSCVokpw9op1AE8kX29p2ZUixRVkuMGLW972mtwFGxRUuX	359
17798	2vaAPPR1t3FXCV5LghTqGiwFeubmrB3phjfmcYzYMt2P3YWcryyC	359
17803	2vaNLtnPg7XQ6pHZjZzsSd1tcqFZo3X6sRzXBPahTongSz6dUNww	359
17804	2vbjsFuXqypeNnxbMXNX1KKocGTmK4HgdRonTeYLSxXaFaJ8fVcm	359
17809	2vbSdooVuGFSWRehnUCMprCb1A5Tz1G2u1KK13UwszABRQU75Zun	359
17811	2vbNBrs2hUn38BUvie2tZ1qvV9wjhJUSFHU5cWYoXBj3dabRG2r4	359
17813	2vanw29tEGB63rgWXzyuNgk8eqG8h3hQCcRc4TRE23sjYoSfgzMY	359
17818	2vbcH3oSjGhMgfMJYn2DZxrj23aLjsAcYWruADYsbZqw9MKyNP8E	359
17821	2vbzEDSkyK6PWJTL6LfYJEVCJLyohvH1UJdomXX7Lcbs2uQuKSUJ	359
17825	2vaZ9wBGFtyzYyy4RNmgaUVX7qxybTyrWrLmUhLP7sBwuyfd1yn8	359
17828	2vbyNamrtcfFr2bUfESaiHW7C7BAnu31Ttopmv4RyGdoqhKQnGTH	359
17837	2vahaTaULYXViNzHJkAa6zoSHamy9njdwAQvh78NG4Cisbcf38Z1	359
17843	2vazEJCVdBqBXBA5ox1FApgBgaWqG8nbLTB1pTijLxrgUVrA379B	359
17845	2vaRqzZ7j8mVKBcyoK3omdn2ScXoPfFTp1B3eYnRvW86kqjnQgyp	359
17847	2vbC3jJfwgBaJMj2pLRiJxWvdYo8gRnML6KgccS4MJY9qQSFr7xA	359
17850	2vaheU3z1ZfMESh3yaeBinjEEsHRdVNDr6YFUoJDqwx8BzEHCTn8	359
17854	2vaNgdS7sJsYDnDFxLYQFYJPEGc4P8dWR8NWhxY5hDrN9wkVysEp	359
17859	2vaZXKR24pBisredrWEUJ1ii5H8HxcwrjZ1ZjGts9Gr7s1gRwrev	359
17864	2vbBnu8Cqspb36H5QgpazeNXdPsU8Po7qSANQBHu7mqHiZCXacdH	359
17866	2vagZ77pTpTt4xiDWPqLkCctTsMSrYMhRJqJCfw3BswjpK74pxwr	359
17871	2vbyn7uvEgCuaSGGZyJDywBX7s1ekm4YEUBdq366W8qDCDKBDJio	359
17880	2vc3EpFPx6Kjxi4CTgSmq5aWMwMuKahviWAYSXem88aWzehcmu8c	359
17888	2vaf6Ja2g4bnRCvk6ekNhmSWaa6UZHh4PEYvrkhM8Pr83Vjg72Vn	359
17892	2vaZgZcaA7hbZQQuYopx7cz1iimvhVK3tq2ZquKWRVU75MncYm2B	359
17894	2vc4iKh2wo9utsmo7tyPc8QBy5hMBy3i7AkHNAXyM6oiKULNhBcv	359
17897	2vbZoDGLtXjufHBVr9Uuv4PVn4woiixJLgn27LPqzHjZqwSedgnh	359
17899	2vaPgkzZ9YVjogBeX8NES9sfubqV8Qrr2WY53d6wYVrqDz5Ydy6k	359
17901	2vbLp1Bb5HXdBLVCK614Kz3FsNbamg83C69GNo4UfzQ3yMFaEZrA	359
17907	2vaV3eu26GXZXNphuapenC8ybDw2McDR9pNyQHjEFmQEBbLPiP61	359
17908	2vaWRGZhjSecJi7Ar1z4Fzonj9EkjgZ1HSXT1kNvFeGK17swyBf3	359
17912	2vbUnjckPFzxL5TCZC3TyJkCK5fs76xNGxrcrvdpVuVMuowMAeQB	359
17913	2vakSLZGjXeAsyBC2d485facdbDp8Tns1j3nsmuH4Js1kqFvHzuZ	359
17921	2vahjbffk96MJqw9aQvNKRMc1qWd1QDiPTLC5d5L1Fr96UBqwZzt	359
17926	2vakq2UhBtm2JGJECPifvcPWtvBC4bDnBtG3RfuRPWFxuVeQ2Km9	359
17931	2vb7s4y9GKWeobtaogY5rZgYDwChkorkD4vTSMVXMnBC4k2R25nV	359
17933	2vaLuybGyZUESS6aGom1p21UW3fqD3qHP3DPWw4f2fr47q4UGzPU	359
17936	2vaWkyArRAwa7FNJopJCb7LgcA4tDdLDpRorCiEKFmqP8HM6Ki7x	359
17939	2vbtJJR5A8xssqv2b6UfkKDV8F2HzFzd4AFBYGhVvC3A9xjn5GHz	359
17941	2vaQMbTEbnXRBLVnYL5nBBc1Kc3coS6V5wU3YAW6skB63rfdx3U1	359
17948	2vb5R78284CubYq9UNWshGxrRfJJRAj6kDnRmpXKDEpVg6aUYti6	359
17949	2vatkwQ6SR5KS2YBZ4zWnePuferYtFuTnAzLY8BwFJpwhezgXMUn	359
17952	2vbcVhiv3h9ekAi4wezWyH12gJxrvMn2cBiZNJ8KzysWTfdzTrip	359
17956	2vamfh9apcZq6wzpDW5ENTApX1Nr3b3ob2DhJiYVUCMWz6YLtaHe	359
17958	2vbcQiXojAo76W1BydUvJrMHWcUherjjpza4ckDXXw3aU1Vg2SGt	359
17959	2vaAhiUmmYnC9rF4JLRCfNd15wRxK9kURkpkKNraJ9nCgQB2MSkH	359
17963	2vbVXao1dkXxNDmSa1VY2JC61aG7T3rcpXA56cbPLEBWNXaw3mRd	359
17695	2vbd1dieVNGGSd6bDxTtfTAoLRYPzABqGtG16Z1Sk5n5R6t1FjPR	359
17699	2vagJHi1J8bh1CbTGVxNBpmkqCaPraFRQkLkPTqnjhPGaXhcZkGh	359
17701	2vbms9MNYheM6vu9pj5vueJZT19sxt4fQcrTQmBrQSAsNhR16Snb	359
17703	2vbxWUNZn5KyTF26tbkWhBzW635irMNEe1E5u5YE1VQQjw4uXAfG	359
17711	2vbXP3jAkHNWPijKNa1j2sX8gL3UPhQKvEfMP7mCW41fucUQgQQ3	359
17716	2vbFmsnmUkZXHRfnwjfTexutTuHPHrygLjviEfYFZqAuQvS9LivX	359
17721	2vc4xgNHvi2ZvCjqpxMPt2iJMZE5Dh9Wz121uT6ZpjzLKqZnPBYy	359
17726	2vbyZgYNFbnRyEnUiirv9Wke9j7YBr8NmX6Y2D78y2kRNp3EJ28b	359
17734	2vasesS9wbmUT7yvdy1bnmYxr3KEdBYeZAfDP7YyZ4M13HcEbJ4i	359
17741	2vaMsugrmy1CyKJppBqBMG7AmRmQMGZQxpsEiExZ3Azj5wgE4DRh	359
17743	2vbkvQFL8jHUds6WDTTSuGuybhaLCjxbYQZB6fGTTDBMqQot5o7K	359
17748	2vbVQxc1Am2dCRLCUh3fjbkRLGkLCZDR6MkpFEr76BN7Rvfy4iKh	359
17750	2vbkHDMRv4BEGYGkdPVKb6hHG2HR56MZtQhqtfMJAbzdjbPwK3dF	359
17755	2vaARbnBWoR6szo6uTQs4pbQFPU5KHP3uHKSkSquGbo2V36Rgp99	359
17757	2vbYg2BdSctC5bT9N5W2McrBc1jE8MrCUSD34QTb4ivUjAatFVrS	359
17760	2vbAQZUrjzUTKc1AQevcgwW5gqQcvRkJM2xYETYv2gfRkxFkiHKV	359
17763	2vb2QTzDkyzdbHNm8AykL67cec7Nym399eyquCTfxSjCeRJ4y6XZ	359
17766	2vaFLdbEgxxDzoF2GreWGXTXgyRFY3qGuzhitTwn9dyh3UGrPak8	359
17768	2vbGAukYa23U1uF6Zm1Dw5HC3Lz663EtHDLnMX7gLg7vEgf37cdS	359
17770	2vb46GsMdhvwBKLUYbmCYvTZHLGfCoP28yZbeDMxhPpFAF54FA7K	359
17772	2vaXxEzjmKNTiojDT9iRdsLyn6DYHkG7visEFE9SDJa5QxHEFX2m	359
17775	2vbbm89ZRXE9pRNh4H29U8NcZdhKTtsvygg6yH1reeckbMgFzewc	359
17776	2vaA2Q6UKzRdRKVPN6J7YaPY2UQ3qhZUCrza3k2H3i1WZJGj9dXV	359
17780	2vaPJYYKDGvb7XUgrGGLpZWCBj1txhWbxaDqchfQdWnrVGdvyM7t	359
17783	2vbwjuD8QVeZ8z7UfV1xNipVobuD9UY9gE9BAuUstnyuoiyuLBz4	359
17789	2vaauC3WN8joEPe8fpLrvn9ihggUuc67N7FttY3EhBEz6MFYxjV2	359
17790	2vayATLdFdN8yEhVZuwZS3z2cdcSUsciqEaURfk1pM3ZGH343uRg	359
17793	2vc3Y98fTiwDu4gk5QrUWBZxoWciMhxwYFF3J5qYe3iP2ijqzgMc	359
17795	2vbCoQNgMDkoUhaJufpFFQdYRhUGnxbnhXEQWpwh1qSeWEJSsSJe	359
17797	2vaZdh84tL89tyHZwZWpmSVPQ14aYvjtLXihxok2XeRxCA4F1rnE	359
17802	2vaxdCC8Ym3FPA8znVPiUujiXBY31PX3MCG7rjBfnwPUhVstAcpN	359
17805	2vaRhFPLC2zLTJFv4G2MnyWcFyH7KdDX2SeSVGJgmU8KXjPAJKK7	359
17810	2vaXSWRxHs2Y3ZWigWwbL9gqY5J4CmGWLqhXCTxRrpvWjPcqAVEL	359
17812	2vb9b76HdEC3Xfw14uYyK5UfEi1f6J9pLHprtrajofVgB59GVdWe	359
17817	2vbK243qpYGURPL6o4iZCgiVqMi16zqWXLzcoTjXX8iyAH2Qq3cE	359
17819	2vatnfwc1CQLafaSPfzgdzos6xf2q7zy7dsr5oSYBj7KbVYBkfMC	359
17822	2vabt9J5H2vQjUWLcqQpnks6Lwf6FnGnAG12cKhhYNf57VW7s47k	359
17824	2vc25ZrjzDf2mbFxsHeQiT4DbF37YP5icRWP7m87djfnyeuCXTbd	359
17832	2vc49aPni7o3dJhwmKBQkJDg3GLda65qug15hRhvghWW6L49H43B	359
17835	2vbHgNfJstK9kEjkPQLVBbJXNjQYFNEpq5D2QP7VexBi9RLdruKS	359
17841	2vbFkSr8DtMXVbHo9jGqoqDUThUVu4u9E1w8wECDBYnWHBq3x2Yv	359
17846	2vayg4Ev6ADKhSrF8XJNrJ53nQEBka97vLxRBWViBmfAW3htTZp7	359
17848	2vaHfKFXYz2tiXMnDejqpN57ht859QnCAoZwc4U3JyqAqPjaE56Z	359
17851	2vaszNnqdc5RXTvDnLjE9cthyZWyAH7YJWq6T6SYp1XXhJQ9ERuh	359
17862	2vc5FyYfABHbPzNifbvXi8xqZRaADC8fN8kprvB3NobHpzMN49To	359
17865	2vbVfATgPB3U7RBX8xjChT6bkcbtiB9fa1MWYxkS9esa3jqkov6n	359
17870	2vb2xxdN9W76kBghNyCRmRQBLpWRZEEES7RKKB5HV4XSuDCUu4pp	359
17872	2vaxpUn33GbCTK8dLpadRiG4TTkUDxgS7bowgqiWHh6jcD4bb4Mu	359
17875	2vb4fNV8giH1BPYYrSZ3DgejWbj1Wvb6EsvMyotbbpzGYJcE3vHq	359
17879	2vbnrNsnrLk5t8BhijhGRuqgwqtuPW5ggS5PpJ3BPbJa4AGg8Hup	359
17884	2vaEKoFAbDcg8zP3v7xipKf9rKbEgxQJ3sLz9iTJa5xi5YN36iC6	359
17887	2vbaARNn4zNyCgvmP4qLsLVT5uVmdUwkEsd6P2b8uPGnQZdDZg7g	359
17893	2vbxBf5BmyyVEFwktb8xaYzjZ5w1GfRnq8QwhG8HsVk2fjfuhAdr	359
17898	2vbY6DmaW62paxyQFRHbBSrVFrptxYvDsXUyaCKSodEg7ybA9uQo	359
17900	2vbKE8iNt2y5GdAqVzUyUwGG15FLHGU47m5YgPaaTSGccgH5bRE2	359
17905	2vc43VCUbcxX9et8thCmatgULWaAqJqA2LmGuF3pPntfLGhGTsNN	359
17910	2vaqbpLDbQHNfpHsaD949fi67dfTPRqCedoM6vPGUW2hzs1nmDzR	359
17914	2vaR3wvcrg3bbmUNEzukQ5z1LeZ6MPMxtbnkCeWXaycSJhxbQTTk	359
17916	2vbBapWQ9DfFnxwJ8sKUBVS6XokbJ3PYDqxHq7K2hUDdWpEuT9nN	359
17917	2vanNVZKqY8tBMxuzq4J5ysWpK7qUdDYQquh9La9ZbZym72jvdF1	359
17922	2vaYSUwvkcJLjo3yUTJq8uUsPDXsPha5WZ1Qmg5iu6uQnudM4Lrr	359
17942	2vaET6pQaHuud4koaVjG5pBqeSV7s9sGSBLEo9cYy5uSLaGK8K2Q	359
17943	2vbWmZE79gb2uHe87a3RgPymjfNPPc7G5vwa3SRQ4w1msk7uBYYi	359
17945	2vbNxcZpZ8Z6pXGm9WtR6WNcMXBv4CAYnURFpcaAusUAnGePHrhG	359
17947	2vbrVpQV5ogQD7ghFh1vLMNMa68jspA7dvevX2iZwVvp1YzYGoYm	359
17951	2vafYNo7tWDaBRYMtzSR4wPrjAueB5eirihpumEH2FPQ1QJibWNM	359
17960	2vbcabnwuUD2D9zJ7mQUJ9Bvjs2g6v8sNetbtJHBFsmjWPvnJDDb	359
17964	2vaK5fVHoxupYavvu9hBkJm5J7VNQjYhQxCryHf94xSsuvBJwTap	359
17967	2vaXGz36Zg9FnF95bsBJnunocYNrPYayo3PYcJWjcpM9VXREjeke	359
17977	2vb8VYAVvxxcv9qun9YzazQ5kCQvW28a9MWD8b4ZX6KYzTQ1xdte	359
17979	2vbq5yP4pqgL1zgwKm8FQ6D8m3FLjTDLNcvSX57Q7An4FnM1yeRg	359
17984	2vbD6XnevH9WedqXPUH9yXN3vffcHxmJjxr38YWp1aBRCQL6B4Uy	359
17989	2vaxwsffTRKsYM5BzWZ5mG2szTsWNDsjzZ4AptGPyUzVr3vBvp4F	359
17992	2vaQFzvEajDw5JLsZyZMEwhU3ruuzwcEcUTEWXAcE6WQmKL9Dc8r	359
18002	2vaZa6xgBuqZiDmeBmazibmSKBzjv89kWMy7dAwtSgT4c3uNFUY7	359
18006	2vbvC7b4JJxgBZx5XhDfnpeHvNBKSSPpfQFpihiPwgLzte7xiVqW	359
18010	2vc3VyutB1X3Dx7WHrBuaLqkTfxwRiBiSgyASejWWp1SQ9NMRhNx	359
18013	2va9cfvQqAwfE8BkbPeuJuua4WTkYt12uGjiV9oD5okkGUxpB1wR	359
18016	2vb4b2qAZrxtxjHJzu9shQGbgS2ehgXMW5xipKm7jAKN9KMHXxAM	359
18017	2vaphYzQDiVjBYfmCvWouRzHMKxp1vAhdstDTtS92PEjLHWAVE7Y	359
18021	2vaEpCDqyehNW3SrUcZkcbNeRvrLatYxtdgRuWB8ZSYrCpNjb8Wn	359
18025	2vbjGsxkqQ5okAAphMLBofStcGvE9YADT6w3othE7v1k5TPBhFMF	359
18028	2vaCaZKpgV87FxzubbvXTLmrKmtRxcJ2713TKopx8D7SCCaupzYU	359
18029	2vadb9rQXFkTWjKd4Z2HaZx3DJEVYLVDQAskhjzShn2t4gYrevmv	359
18034	2vbTKUm77UwS1SqZsej17MhtKEw4DFMb2nGH325XLcHTctVr6tnn	359
18035	2vbmy9UmpLvxTzhvXdPceb2XQ7vNuwKRYXTgmsBKkXRD8PCn8u9D	359
18040	2vbjF81Xj3r8vrZ8CrzihkacgnYCXk5wkaH8sW4gtZwMsVkgr2hW	359
18044	2vbWhDXrR1U3AR43e7QjH3gPZQf4EbtQ8uzDRXEedVj1wRDGJwqu	359
17928	2vb9qYkJoPrfYY31dabHymXfibKB6aRwJBBe69qg2Ccn76pZvLsZ	359
17930	2vahCgzLLThkjqNNH5tLjjM4u96XDKkes8ME6REqR6yDyanKLkZy	359
17935	2vacAXr9LxEo87hsTYd5vVGoPd3Lm3izy3nJafELLcXj7GfiE8qq	359
17938	2vb1tMKvBK3PWYEWg5vxEZ2tUShxYWtd8mhKfnvWuk77MqxdKCWL	359
17940	2vbEi511CUkznMEmN5PwxCKBNGugef1vVy8up9H629q8r6b1aZyL	359
17946	2vbtHEYVwm4tey6fvMSS6gsjNHS75T2YTWZkitie4oCc68szFjFg	359
17954	2vacqWDWkH5gkVD2oTLyxqDN5KYMFa6rX2UqtEj3hdxSSHQaPxa8	359
17955	2vaqMiFBqZ43P83uSQyRFgxM6bN711Un5ysQ1KFqyteqXMSvF4CA	359
17961	2vaMLf7FWw1kmRvXtXWwKcieBLDwgvJR9yKyZpZpJZFHesrVNmVT	359
17962	2vb7GLu9zS7x8a3RLqZPQ7HmNjNA425fKRMNpXYq8ykx1MJu8fMu	359
17965	2vahrsh3MPbMS1adGNiGF6C8X3PQ5iheWx9t4QSprUf4EhVnwdoT	359
17972	2vaxcZCmC7XLViGRYeDNNDHcTnHe3hC92dzZLedr6EXr6qvrbpfq	359
17980	2vbdPhRYB47jyTU55eqWBnGCKis9kgKQ1NSn2bvZcaQDPR4Q2nDQ	359
17982	2vaRKqRYZFr27QKUPKaVwjNM4oDW4v1mMo98DGnQiT4pxBtFKKER	359
17985	2vamevTJWqBWunHs9HS4hqktoyCbhieMnyUfwvEJRF8nJd4fAW6s	359
17990	2vbhrfBnW49Eya95UAa9dYUVedTGcHqxfhCP5swgFMzQRZSSswH9	359
17993	2vbepZqM41gErzVVBkiZa5msozDKWYshy7JAsv962BqWixFDs9Gu	359
17995	2vb5XA3V9NGFpKo19K8gZCLvmhLDqZCCS3VDqYXYR6mhJ8pPoK5B	359
17997	2vaA5zo7WzcPtErGE6YLxWccR2juPmWXzsQ7bZyiLnrRDJnJ96Ht	359
18000	2vbWCGWFx9QPMBU3QGqQnpfGiYEXrZVUrddoVvqBwRh4Ea3G4psz	359
18003	2vaAe9NmHheEDd4UF3jagD4E5AsbuDykxh6wsPtPQvSdkMsUCSZi	359
18007	2vbBQNEuXvsuvy6niAWTG3nkSjogeZn9chm5iEHpjGR3t7c8c6dc	359
18008	2vbL16eGLWnrpMzRrnj5p1hYrkqXJhAo46YRKCt43vTy9XN72poN	359
18011	2vbfDmQ6uydYWL1wgJByrXxsLzCB9TuYELcMpZRrgtPJjybZxFWu	359
18014	2vb8NDWKmjpdCUpPpWA88reZUyj59NrRmeTbMHQPsJDa4Eg3oHNM	359
18018	2vbiA5FsFQZDH39CnNztynhjSfqiwJGVeeZKuc91qoCrcSB4Ahh4	359
18019	2vanuTzbUDamK7TG8NaW1TsJJDnH3peuY4rtupRX2SSQeZcmmoPE	359
18026	2vajsvYiDKPoXhX7jwc27R1xdjFNQiB7mrYUEtnqmHBpSqAZn5Yu	359
18030	2vbYFjtwqfWJdPV9daUUoxJepQbDUo1PNrC69xkN3L7CCcskLyEX	359
18036	2vbuowwFk2HEtP7WDnDMYJZssFD7RJnCQiUwmeJEahL3tZk2iVBb	359
18037	2vaWWZVcLzCUumPgbumjr2u6gaqrcw2ZBXjwMZToZJK2Cd9xcs4z	359
18038	2vaohmMfjn9G2W14wxkRHHyBGwaCk2otmEeg3TdZLSL81zkK7J11	359
18041	2vasgmoSc4eZfzEhejvb9aTWCfNqHoyn29z56s7KkD6RTa6vU7XC	359
18042	2vayEpPYeFRpszxqCtvedFyXh9dq2tfHURwqCVkJ2Mv3s5r6YbyW	359
18043	2vbEtFqJXvmdzqcsvwc6wEyN8q8jA46ewLWHwyqSHn9obFsvWwYj	359
18047	2vbqufHBBA5nksPi9vPJUE38okGJEcJtadJyR5HsJGc7YdKS279D	359
18051	2vbEzsGV7A7UzhUAQCfGz8YHbfPhktCzbAWDEu6Cy649XByzgM43	359
18052	2vbNhArpmWBvAGtszSd1XQzEF9kQ99VKnkQMve254zrTsEfkJEz3	359
18054	2vbVQUcubAKtCMs44ZFYDjHa8wztRxSpmvucSAreweoiCSP6jL49	359
18056	2vc1PQuwpoRAFxxxB6RFSAj9zaJfKd1MYdDngWgVK6aNbdB2UWKq	359
18058	2vc3RVSGeM6Anc97n9tGqf3z2WeZvnY9kDhXrbK34jpGdft6xMQ1	359
18061	2vagbwEMvzL5oeE1y5kLVwHx8UAxpyeA3bsscT8zYraGoid55sTp	359
18066	2vasa7ny1McAVKk3zUZCPr1bRYnT9mNVQ7WEAB9krXsuEFiPd8JA	359
18071	2vbHPgLBWrpTuyzCzsz7pECZSuCT3cUfaxoFwiHZPmPWmPN345ED	359
18073	2vbBnLhayxLUUF8m5W2W2DMddPn1Tp3qK5aB6AjfUpP784ABeNiX	359
18076	2vaYifo7HFUw4Y1Q4DScFsygjBQR4cwpfiAB4mSaUPBFzrRntPSU	359
18078	2vbCkr9vLyvnMVvzDbTvv7BY32gGTZcZHM2ip6LedpTirRHWdEg3	359
18081	2vaoJSEjdEU7zpSwj1ZmYrtPiQmgHewwfGkfXdXuPM64ghPbcNCj	359
18086	2vaQHy2bVDPqxkYVHig3VrzDxuoTLvyNRH5PMoeDG8PdxhHQiND2	359
18089	2vb7qxopCNM5VwHfNgnp3ksnZRAorc1M1BDKBJyKHPAkR3YoTscy	359
18092	2vbPnPoaWvDoE6PMHZVdmG7AwwwoF95AJwanodTbsyLfAa5Pp5Vm	359
18096	2vbBaZ6Grk442JvrBgYUVggomVjBoDR9pP3MtgLYA5ZbfY6x6Ce6	359
18099	2vaTQMrRdr3yuSdFn9PiiPeVe2scwALgCEdUkag7fQJuDq4wfi7J	359
18108	2vavG7gJyKMr96cVAQEqKhPeEiUo3J5tGXqCUaauuvvFXN1QPUWv	359
18117	2vaeGa941Z9kZzxnhKLgknPf9pMawMwfJuYQC9JsUdQwESb7Yvzq	359
18125	2vaapuM1Sox54XzUpU1ERh9QTgX9t1JB8YpT6Dkq3w96VdzjA7zM	359
18128	2vbqHuEUXwL9SGJmuSTE2CpLeCgcXCSa8MnTJVZrrUeC4pTxAPQv	359
18130	2vb3BctdmEy7v12JMRxMVqb48gjDTSqv9SkYBpHfBzaKguMsyE1o	359
18137	2vbPQ8swSLY5XD2xMmj11NC67qzwKeg2qB8SSUMq2xzoAeDk9fbt	359
18141	2vayqUknvLU1fNztZ144Pw4NaMKAGFZ9dmMTBwupYXvvXNTFCd2S	359
18142	2vbv8TNkapMKDEvRdUkdreKnzzHdQbzKxv35vDZ3TxYGZmFAXza7	359
18147	2vapar9Gki3A99Q75v2fkwr28XyhFoGjmCVoQDn9TgzZuc6CQnDy	359
18151	2vbGwzRocgTcyqwSgZx4qdgby7rcEqzTGfad8Nf2miP9KBwSVfst	359
18154	2vbPdgHz9YWFgNiu4esYEs4Ancqsv3a6kPkHqrcX6p8y13yEeRaD	359
18156	2vb6yAY2XwuFV6HdchmK2VFyzCmYxDjHb5Ex2ohjGMJEQbc8nVFE	359
18161	2vbPdPKr1518Zpjuz5ywQHwVLsLZfDTK7JZ7ruwuTr4Y2VwqhcE7	359
18163	2vaWfZLNNge2C3TucoNiiVBNtRG3XC838sP9tz3dUYkE8b8QpdTF	359
18170	2vbE8e2WFCaC1cYoXBuBvS6rEQve5mjSqxWVHY6HPd9f7jt9sUBw	359
18172	2vbngiDbEGCQuZcNHhLff99RcuYiUTbXsE5vt4vY1Y885Vncmqrg	359
18183	2vabNGkQiaSHmFWPfYZ3W9Rw5JLHxes5ybgikPuw6yHTRUzB3gtB	359
18188	2vc4HAeCLXXaNhQKGQQTjakKb3zAVGCMeeutsGfdZbRVrSJvYqfe	359
18191	2vaBxLCpoqg5fWAseSEgMC7B12eS7dXHPv9YzSDRcWP8bhNxjeYA	359
18193	2vamE1gJhfYzkmjrPisbqzcxmJ6hShtDGpoHncNu476PUXrFa6xF	359
18198	2vbvKZDfkXqX7i17KUs1cvRQpEUeJ6umAh4urfjW7DMjymsJh1zV	359
18203	2vbxRWjAcojjXN7ZRAqSGnNUiNQYFmbKEbq4bGnQwri1SaJDd33S	359
18206	2vajm4aqiin3TqDGgbCiG4envdjDqPkWT9J3N8PXWRm1NkeDEHbm	359
18211	2vbaCG8u3u4LQ73MkRemr8yhfQbRGqDU4xoQwYDRPE6n42yw2MuJ	359
18216	2vbxPDBfYcsfkNQsLXq25JipQ3jRKFciXv12Fma6mSi2yAJoMuFN	359
18221	2vb4MyN3xqrmANjSazSDo99oHWh6iezcQSJyg6aeW6pFDiFGqJHp	359
18225	2vbErD5wZQ4iH77Ui78AgHG7rZb6LmpRjMs6EttA5V9LJHtXW84c	359
18227	2vaRWoUD4FiB9hvHBfv2ZNrTjJVjLKaoNyyNpqCfrghJsaCGEfkS	359
18233	2vaw9H8Ci2xFVBDG8nhG1RFByBpi3D3AzPQVesvZjo8AU62tvahx	359
18237	2vaCsmq6cUDSvJnRnJDhTXpGYDhKTfFhnLAUiotAseKYGxrdSJfH	359
18243	2vaXWPbc8PUDh98YCK2A7hxur1jvHxuuAvAdXM1hsC3mZdUyc1fg	359
18249	2vbiRPrMbd6FYrnXkKsREzAJkje66hXACrjJH1eubxt72WCf7rdJ	359
18251	2vaVHHvs5jsCcETqLF74Ro8z3M8axcg9WinwohEDV8LAwr9wU3fR	359
18261	2vairtyhnBPjGcLB4VYskhVbrF5kcafRH2LgbQxWDAH3ZomrvC2b	359
18264	2vb4wSyBZ6yzWT74bjT3N6GKD3ZJfyHcKrijRGQ1fpMKbzNsLE4D	359
17957	2vbUhuSBfeWCe2Z9GxBwsS5Lec79kz35cuAR99UwApFkckqMPA4u	359
17966	2vaRMK4SufocForLZB1FWXXjN5E1ELvXpBSj4uDWjP4DxWuV3pLC	359
17969	2vbvNtxPGVk9rRKsnpEzQ5wF7Hv73fpVmb3dHFcjYV8t5wB9Zs1h	359
17971	2vbGDyZsUZehTkFuMLvFmraZuu6VVDJmqY6coHaeGAbzJT9Rqo3A	359
17974	2vb8EQKtfzvVxV4CMahrxKw2t7qNL2mc3afns7gXZysPeLXuCHjH	359
17976	2vbRkSUmvNhCRskZKwq3gNGmS1tXK3iJGC2Bd9zA6HedLC9nLhyK	359
17987	2vbqyAwLULvb6pKe6uym3a6oH9VyBUqDiLVpyWFym8YPVexcJ2Lw	359
17991	2vbz2VDy6J661faA8koDngsKQdJG4tg6Nx3jun8LM84HXnFkYeUk	359
17994	2vc3rLQzaXBGUbY968kuTzy5HEnS9VsEbC5epgQmYfdwThkxkrtQ	359
17996	2vbvXjKczp1zuvkdLSAHcMh2sZ2jdLJjG2k6QQyGHiQTEEXMCT2K	359
17998	2vb2muLkaoqHtcAmKN8PY3vH9FpB6XsjhDQhgHL7nzEfdzUwHM2H	359
17999	2vaxGReZes74wFQamCjvo3ut2VRhq1JVKNwcrWB42e6JipGRawHm	359
18004	2vaZqV4sWN53RiQTJSmD7uoXFDgKQysPrHiYMjZvYuExYF8Wq3Dd	359
18005	2vb4RRiVzFyejq3KQRKwvhx7sek6CDBjHaqjDXiY8iAzHT26Uiht	359
18012	2vaskvLgR3dMBrbDcL13qRk33Gk6jNugwJUZA6FNAVn59fAsyG4i	359
18015	2vajT83fbCJj4aTMiV2yoVuNEBZ5dk1JHQVwyrR7dHFgtCMQJdFK	359
18020	2var3Zy8NtDyzDYP2nsvNkkY3v5sPD9rvDjZZAtHJsXCBH1XYx1p	359
18023	2vaNhHfGwYY5qp4XZJDZemXkRZF35YyQ2yCLEPDJAXr5iY8fRXPp	359
18024	2vaTWWjxFzwTgcKKvxppKLvkrnN9cavfrLEsnEZDdy6jXrB5Eimy	359
18027	2vaBCVbuERZMbDcofDafbKMSox19w3snW76t3FJeFNyZw5h8cJ8W	359
18031	2vbSYt2wxm3Cf1G9oF8ESavE8s1JbFHP7N89rbVAymGmrWMyxRFn	359
18033	2vb8j3J6UFPrcgjWzmS12u9zUbdk5yxBGquusGpKwNLnwhEMmkgP	359
18039	2vbqR4myZk5UUfnq3yYK42M6aiL4yfPg45PFRyTJe9axD3ETBm9v	359
18046	2vbUu8fRbBk75zqpfN7ZcMG3aAtS4BhG85ysuCsJteqLnG8So6wa	359
18049	2vbNkAgeJgtHLJcavi7pkUaes7EBwY7DwDKsFDuc98YYWCxLqTC3	359
18050	2vbxf5SKvSpWhmUPWeXokKAVuJ67HyWK8ovtgN4pYkxroq4ERACj	359
18062	2vbSC7MQyzm4miQyQPrTq7VSJmRvbLGcuqPJtx4KuxfFptGHTCAc	359
18065	2vc2mtHqxABVGjJWx9g4GwkivDZQ8euWUYsRKLDA9GgvCiUKLUTw	359
18068	2vaqYnw6yjZgDR5nLb1bHSSgwhxHawK6w1DzXmrQ5C8Dnp6UjJmc	359
18075	2vayXZatxmYYgbvzSP62YYLGDciWShr5As1hvCMeLwrqVJY3FraB	359
18077	2vawbDxsUhVSmV4KbuA6URU1DPeLeQknjzjwrL1MpyRcweY4ubqT	359
18084	2vb8AyotAbDv4HxoUuEapoCn8kz6DRkdwRr3kpZno6NQDMaMNnoo	359
18088	2vatZJVU7Hm2bJ2wHtAqPNsvkFNTEhMANSke8pNKAPwDtgNGcrXW	359
18095	2vapL1oCwqw9ZCBrUDKC3cyhSmT4wTuepMuahKKRs7zcoUBN6AbC	359
18100	2vaunp1yHpUSoVqvRfvZHnK8k5WtURT8iGbE1jaXz2b8putC5u3H	359
18102	2vbQaGUwqz2MC1G6C7PYm9u3KhSy4xLVozEHE7xY8jzPGeFscMcz	359
18109	2vaE5LxWZ6bvMYc6T9t8g69XLq3c92j3WbEAC6SWp9mFjhSynMLS	359
18110	2vbfXy4Nz9BfuhVFuiYbN33RJ2kXrxA6rn4s4c7QnLwP4P4UA1mC	359
18113	2vbb4njvGmLZ6SurcgBhGHrb1mtXEMY3C7k5mLr7ag9t2PWcn7mK	359
18115	2vapeYSDa5zxrejzaiZzjmrAXBKZu8atnwNrLTiTu6ZxGVrGCyAd	359
18119	2vbqsv9dQvtfEon6wKfDMNuQ1NTAGYfdrXk2yYKyxr8jm8Ywmjj2	359
18122	2vbAMywkpYhnKEau9Lc7up21bPoxfNLDB6rGRjD8o6B3Aw4q4sLK	359
18124	2vaEKL6q8YXeRok3YaFSQrzd2jzcA1nhEzuh4DTXfo85wqcMTyVt	359
18129	2vb8q1rv9dwQG7NrzQYd8SMtiHWGQy5Dffq8ENFxDeaMdjffFHYn	359
18133	2vaSwLGEyLViLBtejRLAAvSGNGoHPgxe8i7Lm1WAxFgoaJyMjeM9	359
18136	2varvPhBcSZtGEtfUxmrQ1kLsWc4EFJVoCs6AvBAv6GqYA1Y4kjX	359
18140	2vaTonVRqnRKLMwBoie6MWwecqf1zGYHgj3jXz8n3iZV5nEx4fZj	359
18143	2va9mdiVfcvFdRdG2vQ6RXgVAJgQKXjJEx7ChYCxvbpr4UDdi7BL	359
18145	2vaFWU1hoSsLCdEckLbzUre66jTty4j8NFT7LSuMxsBZKVgh2oh9	359
18148	2vbZksJxun9hxHtQ9u2eEcj52YX7GpP3YfWXnSG69t4E5KeTVe1U	359
18150	2vabBML2iMqELS4ATMZbp2tCMZwhn5VyqqRUvh2nwscGTQV1GAua	359
18158	2vatLhzB8nbngzPEu7TMbZMk3WZP6RKSaAJij6Uw4Ha6m5DunxsV	359
18160	2vb5fGjyjWTbQt47bTyfdiENLef3JSyKdyAVjKiYHfxKEHj9WM2L	359
18167	2vaQ2eFmXhseZfvwmUktHxH6o8wavmRLea7ZLdgZvTFeX9WUoeJm	359
18168	2vbrDiw7XyCPbyJvfsnqaCME9bSYCpfgsnh7xbBDqG9AB5P7jXJB	359
18175	2vbFinTFzh1NkTHuVCmGo4CPMXCXxnLy9eduFg4aAm8mqseaAH99	359
18176	2vbk47kBxG6PYYrkcrJJ9Ygr6VbhzchYejePjRqsgcczie2yKgbJ	359
18179	2vaHviWk2x9N6ZzKzboYy2a6Tjio7oTqaVZ63j4TqT8sQcKTpGML	359
18184	2vbbjxvSZrRParJ8kfC372VwdUP66AphTLpsaJxcUYhLb2fyKnLA	359
18189	2vbKKtvd4adZJBPNrF8HBFY6X8wcByGcEBFP9rPYjHvL2M6DWc1W	359
18192	2vbyT1Ve5uXgH8jhdncNF7Go4XvZquYMXH7p5TBa1nMsRN3uoCan	359
18197	2vbGWQWqHm2az5vcU97PCZxYi523ayh76ZCEZnJ8F3LBmQzXQ3me	359
18199	2vba4MVSMimU6CCaQus4vY3t8ctWdnQQ1tai2raicveC9DrJnbxV	359
18200	2vbAjzAj8GeiTNMsNSh7kkqGxu4eMHv7wkhuvfK4pSzrNy5PEMtv	359
18202	2vaTdNHzPyZReFtY8PkVbAKfvmCBXvH3ZJe4CaW9aj4BmvZzgFbK	359
18205	2vbKdiVMv6y6HuWU3vwL7ztkZDgKmt3r14r2sDJ6gSvKimQnas5R	359
18208	2vaN1z3MR2rkVdKxFxxAzhQ16ZfU21q1CNp23QKZrCEXCewP9LeT	359
18209	2vaJHjnsTeciJtzJBe28MDVWphRmstUjtrwrFEXQMyztW7CKDyZu	359
18217	2vbbTdSs1JXNPewGGkSrn4e7NZUVNv8UAUJNhWqJ1DgebgYXzy4q	359
18223	2vbhTo79RWcrhx48dNKQGTQakNpPoeVLhSdvLnaJvMhBieGf82rm	359
18229	2vbmoTesdMh1wBYfpGWAZtLuK7mp5UsW8oACMMNXsKihJJhTTFR4	359
18232	2vbcvEHmtfvrQW7waCQrvhxgKuXKmmLtbwzibBRsMdQXA7sikCaF	359
18234	2vajshYpFxpa53MCqfsmsWMHAvdU9Vmy292oHBhnV2gicvGEzXsk	359
18238	2vbB8NfKg3mxNSGddpvmPTuMkxBLdMNXUXATTb7jDdqXVsLm2PX9	359
18241	2vaNpKqGVNoGokDJBfob6FA1j4fL4C3coLbUFZZ9UgVD5sepX9gd	359
18244	2vbgqhLhgA2d8n8xB5ZwSGPXtPCeNvj8vADsWBiqnfLEVXojK6q4	359
18246	2vax39i1Fhr3iYCwPj1ghDip2JEuNCg1Eutg5aZFgH7hbPJHHENC	359
18248	2vaYT1teNv32UiEsA5RUFTY2iZygHRYq3yXEEqWootoWo9d6YnL9	359
18250	2vbUTjdRYEcWfNBuFXKfKoLwKjwuo8v2yXs4ytWDRpEfTZK9fQNo	359
18252	2vaTzKra7azbYqucv8RVpULqjXuKSCE9ZCFeMSFLqTLyMgVjwAy5	359
18256	2vc2C82ahji2FdbEMcZs8dTDTQq3xma22pkCpLCRuKTiCTMMeNpZ	359
18258	2vaDCATDJ1WUhKMe1zLKv1jaHQZUg14unzRDBLePvbj7ed84Cqx6	359
18260	2vbsM35g84rvQZYBTc3TRVje43skpXA3XeYh1yTfwGUcvVSj2kMx	359
18265	2vbzPDDLUJfFXLDfYGWr637PHziLwioR9UtPJ2FfWDXggdMbhVr3	359
18268	2vbfvwVJjxLEskp8UnR4YRAPRb7kXr8a7PzonHxAqANVsjnA7jZz	359
18271	2vaLEvVYhYXiK7B6Br3uqYsKm5xfe6Nym5ogUpVNbso3d9rpdYAS	359
18276	2vbE1kNAwBwK9qAKomah3BkJ9AvJD498yQ76FtxnyW7FRdkfi4Uc	359
18279	2vboyUEeiLaBQNmgBikVPE7ZMG4e9RkTQPFjSGoMegA9YsUqa4yX	359
17968	2vb9cQHLviLp4k9arBm9kNBUT4ibtAGambJHDJTRJfTQyhsivfMM	359
17970	2vbNSL8JrC9Dm9kKvUmN3ak83N6nKGme319cP8Fj4Xq1CGSFPKRq	359
17973	2vbH8wEUHtMWpjcavFJ5A9C6Dt9pe3TY7pHmrcb1Wmydn27XzktA	359
17975	2vb38dbWZFR3jBp58bvGkHzPrVz9wyi9H7cKpmKqhsKgBTgH5TjM	359
17978	2vbDXb9GsSqPq33x3RtCPqrwpLioUUHB74RbpHZ8imD2dwJkB6X3	359
17981	2vbpamjJJDbpL2MMvBoPuAXMyJkz3cR6TBD4xs6jKu9EqNMDPa7N	359
17983	2vbutsBeu5HGcJmMDXQDzC5x5b9TsdPJL4tdLxHEfzZaKajQ8hv4	359
17986	2vbnmxWnCat4xk3Y6SR1XjtY2ERNycDHFzksSqsuo3dTb2W8rTxY	359
17988	2vaJX7ecGthnfNTprVq7MefLjQNk7d4mWnPQcQA45MYHHwTgTb1x	359
18001	2vc57iXdPoQ9NNzyWHmSydWpVZ3GffcYK3yueTLaRvujuJBYH5j2	359
18009	2vbDLQtHkhANVvcin1wqe98jH31ZEHKxA4Yjy1d9GRauK2SUNEan	359
18022	2vc2VWspYXz8piStGAzaxXDjysedRovB35kLm6YzBLMAV8vB6TrY	359
18032	2vbQoYD6hRBjJcnEizFuFubZYGtmVJr6xZyzzF7j6PF46hKmreTJ	359
18045	2vb7ZQFFtspX1BGbNW7BbRZhxL6cCJeRbULxNWatdeLpnakQKFKK	359
18048	2vaNeqBwnFeD3NF1nydRBA47rtMMFA39LK1PYpXAqA3SAg2FqdMA	359
18053	2vbSR8sgjL72C6QEwDrXwZEyr6JJfn2BaJhLxE5WnNBLNaiNkTzT	359
18057	2vazyD6oACPnhVBe2uE62h3jcnuXpwxfN8bYoWCRafTXu7pCeTB5	359
18059	2vaPTCv1fzab7SwbYiZQ2pX5ay13HjzFVc9oL2NMmQgDZEyPBZGG	359
18064	2vaDJCaGrz44bZ2kFTNnT3YpJ2vpUgGpzD3jKrpZza911aieHQcx	359
18067	2vaEdgSo72BHr2djxbPd5CSickYjsJmtuTyXKtjSZ77Q8CaxQ4jG	359
18069	2vaFWUkXfsht5Bb6HWiCg51ed69rbHSd7BVwk8NKVtAGfa4SEvE4	359
18074	2vbQwKbcqPB9XPjBzJEauy9VePnXVQs3Q8S7XqRQtvV7Xf9hYEva	359
18079	2vb59GUcTNqLfTQ4rjwPWCfMnuoUzpTGa11BA8K367cVPPR9zwS9	359
18082	2vaqHDaj2CMKhd7goauF3sYrgc47hSRUToUrafiVdRJFqsE7eW2r	359
18083	2vbs79s967QGNcTQnCCczGCrjr591pfEA97e6mnmXFwFhK7sCimc	359
18087	2vbyuiecYm53WcXZPTb1QAnzYYWtpD2CbKi2hFSyf6XhSiFAmP95	359
18090	2vafqQYggt1EMRPRYF5hJr8CEQ1RsDByxWQw6dj9YLXUT1k9Cebh	359
18093	2vbMx5QJE9Ja8AT9HeicchgMsQc9j4AygMLiJ9ecZmXyPWEfwYby	359
18094	2vbBeuQmhDCFe3YjzQCmG6qdcqXWRtNRwPG6eEjk2pHwg2Ws3dQW	359
18097	2vbmwnF5p25QCAp7Zfdw6JxzYHv2uTMyPKwCMUBfQQgVCkQahTXd	359
18104	2vaTDVTsurtW9iwHYbDWsoDUuNY24V6GPXPwoNSADQKM8aUsLWRy	359
18106	2vaAQp5idnZUoLTM72HXAWvhy2j4rqsmB8CxGXU5ckGeKYkD85Yy	359
18112	2varrYAogwZeMmXBKAJEQ8uXUsYG5kSgZgrmBV2mHyduuqq7NnvS	359
18114	2vbSf8mPqoPEgfF4cuaeCLXiX1RR8ce6eESrJKu4G2BFRq6Tpe9x	359
18118	2vaio3r4FNpvjybvPyez4fteSiHP4VR1tzSoewLJvSoWJf87XZSp	359
18121	2vbBkNicYv1KtuAr2U48NaqHfkMJ5wx136aSoL78hrebt2GSAqKd	359
18126	2vbCM5K19RcgWneWj8MFXLaM5BjYL1Z65t8MeRJdjHCXwUPViCME	359
18132	2vbTVs9jj27YMnh2nvngLkv9ZwGPQtcquNYJ2ayHpv3CDRSt52NT	359
18135	2vaJpygovCYrYooPa1xXLU9RMk8XRVqKHEm6fXEnK9zGGCvxYRM6	359
18139	2vc2KVPMnuuhSdmDru17QSWdrFgEHQBWUGQ92PigVwjHfykupN24	359
18149	2vatnFqhtRMRdQBpo9gcSUimegK4Gka45uEQYcQgPgzMVxcr4TPG	359
18152	2vc5joQzMGoR1Sfy77pbZUFJkF29zFLL6KQcx68bGroqeTRoTmWM	359
18155	2va9x6JVLvp7jJGasFJnY9gGZNSZrqvZ3VwUv3hCxDtEEY5cB5bW	359
18157	2vaw9tHhA6czQru1YaqZPYagqitBZt43Atag83WzYyRwGkfopWWa	359
18159	2vaTh7ZD9Dhibrjod35AuEm4dkasCuLuNRmCToSJhcHxonaGconV	359
18162	2vb1kTNoA4jL1gdMj7QTtPExgwYSRC5qUqESQykCChP3os4PKRB5	359
18165	2vai2ymUjR3f5siHPfN1Dz4nCikiqgnTSFgYbQmAupUUrfa7aM6Y	359
18166	2vbhD7zjYWL835pxaMPbAaht5TqT1FBhe7EAbEfiGeoU7M6rnnSm	359
18178	2vbFVXk1P74MzRSVA8jxyLwvnJVtSiuTrN1PFA5iJLRjJ4z1wJTp	359
18181	2vbWCHw7162HSfY72yyzPVquxYKwq58BNocVMmtCeN9JPQWGnWtq	359
18186	2vaon9XcZXQRzgqqnP38jt269Y17fVvNyVz7q5MJsr2xLyEWkN6y	359
18194	2vc56sBvkzGfWs91VA6JsvNtGgRWS5o9gYXMCNTAqW99EyGMjzuy	359
18196	2vbtzRnGg3F2k8hqQrGQPNSnzSnYFgK1JZ1i45iWB3QgiHK79wQW	359
18204	2vayMp189mc6xKnadYDpckAEEjshMjgxTZbEBZ73sThiVAJgrnMs	359
18207	2vb83evcb9Wse3Pq4zeAhb3zkUuz2LMRVRktTp3fUg6PGkpyrUnr	359
18212	2vbEqwc7wNLNM9U4JxdT6bEeE35FSLxN4vQPsxYMoywXGXWjxQrw	359
18214	2vaFv8FHiU5q4ENXRWLLZzYntwLDvzFZhqJyxqUB7dSE1fvKfLi3	359
18219	2vb9Y14E9zGgAjEtrsaMjSmGXrT3mmTaWvZQkFLqwqVigKqE4AQR	359
18222	2vat7DRA4CyyHP5p2eatSSpWEEETo8if4n4SdNFu9MUAfmq9pDJv	359
18226	2vaK3ySTajMFfHM2YHZDjTBShHFfyPi1D56zXSXSjBxsjE4Faf56	359
18228	2vbhDe3ENRWpcEBHfuo4H5UYz1BKbFaUoht3EcEwmFvGU8QNXzm7	359
18231	2vbFVPMpmzNfT7whDxKVz6kuBF7VqHJAkN3SzgPfpsG34tEu9tVq	359
18240	2vbYB72dWe1Uff2R51SiQLELmWqdkeNWsDE3QLtiwuA2RM4PUnDY	359
18245	2vbnBTXvdPUeEj6s1WSX7hp2aeAKKzr1hnbW83guzo3nUhVgCZBu	359
18254	2vaiSYx3ZrLVXvJ4m1WCgYwLi6utVtLbsDbWPFLmZEfykZCYgPrD	359
18255	2vbszmjxptpEeZrt7m1YpiVqxPnRAd14mU86vzeX4smRCgUtNpja	359
18257	2vbqHDyoR6y6Dyq7p571wz7wQuQtJ9wM19x3m49UV77kHy7kTX2u	359
18259	2vac3GPHzWsYtszLmDey8dP3RP4irRYEmEMxCwEnv17q5pVRD5sU	359
18262	2vbcCQgEU1vKSXMU1yN5wwat8TMrWPkEseLef2QsW3dGLUXXiAAt	359
18267	2vbhbCbANvSD9xQZxxH7jeCDtPLQv7WsjXv6oAtSxpAGvfYXFsu2	359
18270	2vbEejpjNkys8vc15GPmSZEFN3o8wuJAbRZZE8WxjU3bwjEgHEUj	359
18272	2vamgFxfWhghQqv9xJXPbfxywr1hzu7WeDCNfQoaXipt97W6wyBa	359
18275	2vbpu3iPBdRuciBRXyrThNbZGehUzmph4sC84HUzbu1ZGH11zDdA	359
18281	2vamgYqwQAmb5wUhVyp8n2bWsiQ37Bbw7wL2tuEKbdF4BsE4CTnS	359
18284	2vaJ1J1P35VbVqeKCz6x15wMVCgyuq7L3hmxYpdtRFZVB3eVA6b2	359
18290	2vaGtTe7AtPXaiKEKUVaV3rkgKLAv6RBHn8AgeeKPJwH7gLGp2KA	359
18295	2vaCgudLTWcWXvhy5XVnWX5dgswkyF9r8aKG661d5RVK1i4iKch7	359
18302	2vaRq9m6LnFEWm365QpTHnswzxnzWkwsCy18JcfUEzMXWmXB1GL8	359
18305	2vbMwDWuHLrNU5DpH1t4496szZTxvKWcz4MegbdMHw6RUVtpCXpx	359
18310	2vbNsjgqJKHh3SAqbPbtzAhWp9vXTi716Byv9ACEteuQBBNZHSv6	359
18312	2vaJ88SocCTzSH6WGrNBZ5wH4ptj2gAUkxjTfaKkTC77tffYh6hr	359
18316	2vc24LFvJkSYvwUPyoLMvetASAjZZXvobo9ZBSNhADo8mu2oqi6U	359
18318	2vbzTDmXyh3JKsXdfycE9D4Dzo8bttGnQ56fcERvcSAh1Ncw2hZT	359
18324	2vadqXUbkXfMUPzMDwnrLYgJT92Ecqy3yPMRPV6WNJvXpYAbBKYW	359
18327	2vbXsE3DYcuqFgN4onJt7G1j4YQkiycQLCcnJTYpddDkcx6jxCgQ	359
18331	2vbo5xyktxd4VvtawHW9D2cZn2eU19gsane7WinSgAdZ1PAefXCA	359
18337	2vbGfLrr79jXHDwT78cUtmjgV9rP4nMh4y4LAkcFjiTdH2G3SVQa	359
18339	2vaX7uRFuUUdEJ1mfJ1rUrsvm5bWQ7nV6tagNMcoUnvqj3ayXKnb	359
18055	2vbNyKgdHxHnxQCNUaEBufqvoEC6KjahkwGnxF7ErcxnZU4UUV83	359
18060	2vc3qdLwbdudER2efpAJ7eVaUonrLBoXse1bie32p9d2nnuPrFM7	359
18063	2vao9a5keQwYZuL9aoVXGyxtxydVvDU9JxcqSCiDHN489yjZHSUo	359
18070	2vb9SM8fLnqjQGMWZtpgaTvFj3XdfaHdPMipPbwyVbopmidiGEy2	359
18072	2vbQK7JT9NtsGqBr5L6yMTveenfinppi66214638esX8hHrh2ACt	359
18080	2vb5QqmN2bM3woMpFHnSveGGvph4CLtvBcYPJgLvv5PaZsZaD3HP	359
18085	2vbUFN4ntJ8RybeQ4iTpwaDQYWp7bL7PZSRz7d5F69qbmVqCq7Zk	359
18091	2vaJTfXcTGwXy1F5Vj6WGSBtJffEoMdng5DNvw4id1jWfdHMo5Q4	359
18098	2vbkDGk9z9QsMTcXEGynm7W4oSUyL7VTBfzye48U9Hdxc7LVRC17	359
18101	2vaMXuh4G4AVRG9Cm8eVqCnxFNJcyC1Wxv5TEk6Rg38xrnx2taBy	359
18103	2vaBYidCmDqeG5pSPF3gPtGw2roUoZVffFQ8bWRxihwo7f3VGNax	359
18105	2vaNgRexz7xK7TMxCwRrH3WtaQjfqaSsGjJ9zZ1ydEFZubVhDfr5	359
18107	2vaMKr5uHNTpixKMjoH7YG2KJw3964CAii8MiefQhFECp3YGMTwz	359
18111	2vaJDWSo2HbsyXp24L3mfLp5xHiqYYZij6vvzNH5AWW7jjedEKGK	359
18116	2vaoE7r4b8TRxNWotrvsgdQWMQVbp8pLWieKjagSQTc1J2TbdH9i	359
18120	2vaUHQKYZPZrnQqH8UM1cKKHpjQpRCDAttrHyw7TcEefX5pAzKpy	359
18123	2vbtzu51T8dvxDDb6cjh368eitrbYCiGzhGbJ2ZreDa6oBq832cF	359
18127	2vbWL4PSBWetaE1G3XVdrqctYD2djE3Qz6oyUyX1hfDLU6R1YLfd	359
18131	2vaFWwSRzbsifQ2qh528SK43BBCnvvmQDB7qb5H33EUTF5McuNX5	359
18134	2vbH9S6iZMmh4cDa5xREpPkxwRfkNbrx8S7zhGqsti6ZJVxjJXFi	359
18138	2vbsyK2t8KJiBVTAFcQvzvBsJyVL4Vd8dJgXQaFyMEtRmsz29QLp	359
18144	2vbg6Srio41HrCzNJ1rgMhp85Ge4rFjga3sGUcJshDNXtqYcTPEs	359
18146	2vaUXT9QuYuVzV1RtBD4WYQ86Wo9nVH7KVHnZZAKdibg7hScbXn5	359
18153	2vc5dp6TuS6kwzPTcy17442ZaufWkaJs7P2315bwRhYeB2dn42Xm	359
18164	2vaj6H1wobvWhXkYVVGK3FQZtt3JU66GoP9RirPKA3Tu9stFLHpz	359
18169	2vbmrUmbxSzwhZN6KNuTCQyYGF4FCbp8pkv4pTqddZsQqo8B4rge	359
18171	2vaPkzfba1H9iYEdtuDgAPXWYSXTNSuw6es7Duq8S66Xqr9VicFf	359
18173	2vbmGAFqZycGvpC1EN1qYEaXtTWpGLbikhuqzNSLVgkz4ZvKnFeD	359
18174	2vboLigd82TBn7PdFeVjesw34ZEsQet1Tw3HwqCZiia7T9BgSD6u	359
18177	2vaqKGagsWBDuDvLrnXn75uducLha9ZYFjHpNEqjPpuy4XXPsg3t	359
18180	2vb4e3WgVvgcmaYviXSfmiUFdKrHE51B7cDpzPC9qnnMeEoWuY7b	359
18182	2vb6nZm3foLzvbyik4LHjMimjoM6swXsGikUQxQU88aFH565JyiT	359
18185	2vbmSASDXbpWpMymmryAMjxkRFcAng2gDjHH1Sje4j5LQigZv3FS	359
18187	2van4TkBez7LGhiPazhxRV7YXG18fcZmL8fuwtrtMaKdeuEsyEsk	359
18190	2vbNgf4ys9hXrxhCJhuAqB1bpK1UQViwaNZUcsAkXqsRttkc4vBQ	359
18195	2vaWhtgxrVQwe2xr8nkKmZrACYTcvHBVgW4LojPYKAokB8hVFBqP	359
18201	2vaCWWzbkxhoEKxxDeAH69yFYCzYYUEBL99yr9CbKT1xhSBCU9wF	359
18210	2vaQhh1sMDtT6gzGJsUjRdTtRPhFApS5ZnwjCa2DBNtZiJVYYSa5	359
18213	2vaDxZs4k17mj7zrJQ1mX5Us1QMwnDZY4wLVqGHFRbuoYPwqw93v	359
18215	2vazbZPgWnSWajVQtvEtxdxrrFf7E5FeujQXKMP2Zp5UouSFW6X9	359
18218	2vbnBYE71uhgPftagtx6XjXYMvTaNCzXjEDdkxANwGbv73amBVqP	359
18220	2vagQubnbngEk7MBxn4xSg1cpg7DmeS29XNnKHAbQ9a9nz1pzmGZ	359
18224	2vaEDuzw6joU2SQevrWyzrZJ9V1VGLJoCUxvmvx5P54QqwyBfFJ5	359
18230	2vbzVXudJrz2mHhXrBudGH5uktmfiF1vVvKaQLaqVv9PCErvMHcK	359
18235	2vbwS1cUz7CyHzUjVsutkG497P9SMbTzFH1Jtkn2oD6Qnrzz8sNA	359
18236	2vbAW3N3TwBTXAbmRNvZvzzHjXKtb99ppyyEX9tj7HVAhTcERUGy	359
18239	2vbFkKV9J9D2gubiKxxikKXMtopLmCN6FVSAMDQ5jRMBGAEoyGyz	359
18242	2vbA84gqhzaZvvaAnEnUj9C5rKGa66Nb7kPtmmkCUsL5AZo6sKCU	359
18247	2vaTQtNMRGWfccKgkPGezdFcuJEZNuBWktTNNsRch5p5USyztraN	359
18253	2vbo65xUN1BXeD3sSd9Ub8druFAro14WbuECosoNzZtUJsmMG2rf	359
18263	2vb5CbvtRHCY95DtkoLC16wFwALjcnAHH8ciEjHD46RGuxDPhyWF	359
18266	2vaetL91VEELhKmAQJb1drBhMez9qZHKpXjqe6UbH6R1K9hdqL3D	359
18273	2vbMRiq7ZhnB6yTx7voRcz9q4gYeWkbantkdhZg5Rm8k8pFnqxGP	359
18277	2vbrpEdsHvBG8GRiMosCnnDkBg4WPomTXnu2vCXEy6VF7f6u9hir	359
18278	2vbUi93smHKfVV6dM8MdhY8hCj2gtK7gmgBiZ7xT79oYqnDemh2j	359
18280	2vaBgASxFCCrJyENifwwkDxknhFzVc8ctpcAUMXKtzsbVBo5Mciz	359
18288	2vbqrgAWxwYBfvTFHvHK8dSiYwU9Qk6rXfkYbxW3YFrf83EyD3pj	359
18291	2vbFTGqMohk3aJKHybn9cQ7cnMsAH7zxMFTDis5Uygh9gu86XGty	359
18296	2vbqLioMc4fsVtvUh6PVzUYzjvZNjwZF2wEFtJMn5fMbp9Y1FSuf	359
18301	2vaQhDwzHeDiLhVs9mxWBJF4tY8hcXpvN38hLZARrqDW2DSEasn6	359
18303	2vbnNpNRoT3wvJRELJdfPumx9NQTmvCkrMnErFteiF6dvaL9FwZ4	359
18307	2vaXV5Hq7bSEKFCkbgv2xi4i9hinwxHcVP5PzzM5fsvezUJGULeZ	359
18308	2vc2zJ5J7XW7FHDWmbsUcBhFgLXRUz9CcMRNtCwCom6ePygqUWLd	359
18313	2vaRQq9Ce93kevkDHuDaT5huymk3LaZHa726RZdAdNNm34VZmZgv	359
18315	2vbmq1fdZXqbBeLBAvM23TdefrUwbjk7ToJTsHtHRzCqpNmyL6Y3	359
18317	2vbCoxwV7zL2GnYHy2FBqg2wPJRf1DpJH1neXJKyR2FUcH9t9u5k	359
18320	2vayyQ3vgkD5n5pSu74wiV77Fmx9xYgRPf8neCajyHgt6UzxSaAA	359
18321	2vaDWZ6iCiVXpKQPmaqkmCo6r187B6FtKbsJ2yA6G94F3HooM4mX	359
18323	2vbTjuBDvvcaR3dqbUJpRbRAafYczfHom3S77xe1HKTr4jcByxiU	359
18328	2vc39b8ThYxfgxTJCHJL2EiiHqigSt4FT3TBhTZZdzeUAjVhZMgr	359
18330	2vbtrRqzbedEof9HL6ZEJpjRpLdHd18krPvgrTCrZSWY9pZJcZYf	359
18332	2vaTB9B7F1aqzp8QvJ8k9U2s7JVMfqXjHpCZKWKkoL4AsyJXEZxJ	359
18334	2vbrhhSDAQYWGsNGvctWcep57eBvfUZcmCtkD3jt3PfSjkCzZXux	359
18336	2vajzsPbupyTZrMZ4jiXTEBFwPi9tNGVd4F2r8mSjiuBnzDqpYue	359
18343	2vaz9wVzTZMgAKpTRPbsXyx1fF9UkwnX1NNsWnS3e2qtoCMjQc5V	359
18346	2vaTS3pKUSqyRcg5gJJ6PxQabD9AccdVdJrQoqHMevM4e5kP2N8u	359
18353	2vbqNAjeKC4TRn5eUPgvCf1Cccp9fqPYUcKVt4YsbeiHyEPLxUwK	359
18363	2vapk4kXzHwFtg2dx3A127MoQtsFjMWxqof5JGiJjtu3THCUSduf	359
18365	2vbs7CgBZFiq1PAhWp9zaLvrkXZUa6WmGHjeB9pTMCgeAXeB24NQ	359
18368	2vb4uu1cbvArmYJYa2kGGjybywHgTsoCt4vTChUC6u8aczHbNGVC	359
18370	2vbrVmQRhBm6eNC18CgsrWrdCjP8ypGGLng6QLqJhLV9sTzd46cu	359
18373	2vbmQt2siAsfNjQEdsDrzj9yeC3DptRSpr3kuy97KJKmxCJU54af	359
18375	2vaom1iHRKZ5JEVxeFjH7B3st7ZQputaabRqTSHpCsu2ehiwWR2a	359
18382	2vaTFXSx4M1ao7qJjVMYLiZ22iiFM9egzghpBgk6UFLZS6Hvfo9U	359
18387	2vbDcwa5vXbYvQdQSTS9qyyCcWG4suQGrjuytxuU6WhqsqpKd3oG	359
18389	2vbwwKD5CVSxF5tPRZFkFaUyuuRuM62f1hCSPFidXWUApMaku5aL	359
18393	2vbc8Qey5Tdzgh3HxS8zkFNvUYJLZSR5YAXz2tGbuTR7X9WcpqA6	359
18396	2vaYTdbZTHBYASuAtTMgMw4xp3ydDPu2dYdGmG85JvUTPtsD567z	359
18269	2vaPPtdKV1uWPvKRz1LXY4ZUrKiifNQFoqcrHPHGMGPH1bXHc4Sw	359
18274	2vaZbzuaYEsShUwSHzMa4J6Z3sCLveUzAqrzpxVN5xyzkKuKSbg7	359
18283	2vbpHwb3Lx8WHPwS2gmJLsv8e679XLG4UP6GS2Jo8Q6LSfsnmcNn	359
18286	2vaVWH1j8faxRsiuvH5tkeNCHCsW3GksbBHKqhNCuK8QstUyxGb4	359
18289	2vboNCYDU3xhTzvbjEgWbx4dWdichRz8FGHXkTTX84Em9f9JoNGj	359
18293	2vbtdHav1ei1zHuoEqs5vZFm3DHj5wvBQSr6jfPqkWmgqzLw7RPF	359
18294	2vaGkvXvpj1rn1DH9jWZUpxrqGe56zaP6HhnKcSNk3dtevKmHp9Q	359
18297	2vajzFjBiU9zKDY68UCEEuy5z8b69zc2uJLeJPXnKxnSU3nx2Rrt	359
18304	2vb6EAAyEvGFfXgta9HpwnTo6hYEAhXqcdf4eLHHrxNyFDHihmsc	359
18309	2vc16QHhMAWPf5SLxfVPGavNeSvT9iCsfpJxtoLNvEQrSNsdDhfF	359
18311	2vbdjCWHaCXjUwAnaBGyCmRZwhqRdXSophfbMbNP4qis1zJmVsMa	359
18314	2vaTJ7TNWXooxmg6yiwLK7tdkLaswweBApJFfWmtcPfNyKuehzYc	359
18322	2vb5Tdf4cg2i8BwkoUDSN8B3ZX6AAEvA3a11TtWdcC6zQgkmFeM9	359
18326	2vax1tygvH9RodroGcCEpTa3xFw7RGgDif1d7k8BxzXRG8Ri8rv6	359
18335	2vbwmbMDM9hVGboDCxfNY1QGYHaBJWUoXa8jMRJ5qFLpdkxybMqQ	359
18341	2vbDaeh26tfMyd9k9QZncRK8TE2xMfNPk1ix87bH9KwnEwiAtdw8	359
18348	2vb6dC9M29yptu9ihocGs6VUpkfarvfPNW2oQZPKdutNgHaFPgxP	359
18351	2vaZEHAxc8Vfc759n1x8Df27Z1PcLBDVbD25SBrfRfe1FS9USJZ1	359
18354	2vbrgwtcMgnbg2x6A9DsXXkbxEdYLQj6QEsFzin6rYAcZyCdzV9m	359
18356	2vam4L3LVNp7q5LfzmoWHqte4GGjnoMqAUKzAF7G9XCUM3gppaxo	359
18358	2vaziY2CxVNZSuT6gxwbappcYNHW1JH3dHgdUMBUpmjwMk41ddjz	359
18361	2vbn959dtP45BCJWzp3H4JDizSPTFoKVm2i6YxjYt7BwtpfYdkAK	359
18364	2vboJEmtk4hoDY4jLBefwqHq2LvYRgRvzARhT1fyZaYNRsa5g1e1	359
18376	2vb6XtsCZVhYGkF8rxsSmzwW1VJkCAQLZYBpZbftrk29VK3GkM1V	359
18380	2vc3z8bVcaBgEHMHvJxzyEamyTPEvFzi5mTkBdh3vMKycjF1vckH	359
18383	2vbjXWxMKk3uXH7u9DwnYBzoDGj3tRpcmd45QzzDS6gHuUHSye3y	359
18385	2vbZoyeDRvR9qDL1W3xQBcbqKMchW2K422LdXHeWNYgvLLbXVH2S	359
18390	2vb83uZS8JAgyyzVgjL7hhY5pSd4NLfA9hbepX61xMtYmV35oHrt	359
18391	2vacpvY23NArwY55coctN8oDkQ9J3gm7kL3PzyH6MeYrHMotpXUp	359
18394	2vbi5c177GjiY9CEWqGDoWyngK6eZfYYDMJB9cvMuUZ8CAEJwAjq	359
18400	2vbc6gGXLCLQfB5cpsNJ7Xav6ssACAp7AhaGDZUyT2bYaeDn9iya	359
18403	2vbhJ9CdBQd6mumbSfgAxsTkWRpZdt5cDmAKyt6mdso9Jur1jTtk	359
18405	2vaNQrazPu4PR6ieesXsFBmpLE3QdRGJsvGuSd83mPHg3rUrDmaA	359
18408	2varvZJwu9Muwd2wAQeMNdpeDNNFZbj3ciA2ToPa7my4ZqgWApoM	359
18409	2vb6ZaVCtFe8q3jQ1DrLpTGmnRau6VAaZ6vJR3eu52H3Zxy5wQrd	359
18415	2vbhq1kfgK1bj2KRnoMEbjDBEbWPN2CcBJXdhCuyqZCfR93PCWmF	359
18418	2vbKjnPikxzC1PP6UKwWYhSLSMZTkVHWhi8LTu9mR3SEossWJaMu	359
18434	2vbs6D9b3qZPGqXQgri61XTUfeNL3w6Xqb242SyhwfdbKxZp1o5H	359
18437	2vboXPY52gNFN4ZuhVyvfqygqKXnpEEaq3dFsg5YvXaBt294ubD7	359
18448	2vajZqHK5Q16d9bTofzHPbZcMR16FbHXpzhVNFjZJbMoLqweGxSQ	359
18452	2vbMaYU8MHRhG1AUgBzQaQFpC7TDPZqSySJtPgEfAy2qfXrL8Cu5	359
18454	2vbumti6xwo6bjQoJtqwgTVBmBDtxzmcfWQfNHCE5d4Cq7xEg2CU	359
18459	2vaxNn9oDa1LVf9xLJ6oZ9i9jFqzwgvfsAntUnBSMihax7YVi7Zb	359
18467	2vaeSBwoiN4AM2A968zQy7tXu288BCqNRqiNBKtZWsafb6gQcxEQ	359
18471	2vaozZw4HzXF2YKCTVtPqJkGxPJxBYoZJ6sdxnSSsa31S5MnzQwA	359
18475	2vbFSurmpDNDaoXn9jDy9dcgFdW5yv8TLHukU6VW2aw1ueKoFiWy	359
18477	2vb4cZLzcUjuAzE1UR9xsjGAztgrKPK4cmdHGxBt2mVFuMsmJCir	359
18478	2vbyLAYrkbfJjDokG7m6b6bDKbnfreJyhFmTxZyrci5hoqGhHBra	359
18485	2vb9XrFdTAhzn8JLhTJeqSMpViLejfU6qwiLupD9NAsWVDY6cTZj	359
18486	2vanvaYhK2GxzmiZixDqp1FgH4zfM3WL46Ue1brH65WrthwfEjJy	359
18489	2vafXHixx1u1QEh2Ps9y1415DyKr3faRnQtBjEVriSMmDFREi1jX	359
18494	2va9SVfCLneLaRsYx8iaDRBnQ1BLqgCJS2F9cFRmREyirMZLZyyk	359
18501	2vbdHBC3ECbbj2T3mWHCfrci4NuthVvTdwmtb1mtFASirQtAHAdB	359
18505	2vabpvDRUYu2Qw9wLjB5XToxFgu3rtVvXg3m4pXqMPZcdXUSjpdM	359
18507	2vaew914fMvoHzy83XGPdUdn3qQpg6jZTiTkzd7FafPP5cnr3M86	359
18511	2vbqxkQBGpXeND2GeEk2YUuBdgz5BfcmCiwMBYGnrk6PY3dLEZJ1	359
18512	2vbmCh8jZkmDu51ERBRUHYpZGQRjzyxWbA9x9P7EcNB36fw5Ab1c	359
18514	2varNrMnbjwqs2SCwmWrnhaQeW8jF8wTbeiQZPKUkSXV6GWYVo3V	359
18517	2vavo4c8yjRKCanwPcWtDGbhAJWz1q8s8mZvmyejAo7jhWceDbWE	359
18521	2vas9EB1sviL5SnmGJZUKfjmpQRZDULtEn7NyB2VUzjpce1jK8zz	359
18523	2vbpYYpovv9P1TfYaZzFyzphx7f7KpjTvKUpC9McJwXRHvJiWTzR	359
18530	2vaf3qisbMYqQMCT69PSqWKs383k96La5fr4snBwkRpJzPJYwjNM	359
18532	2vbWMboWHJErb2pmzk43NiiBePAryT2EBQFN3ynqbtKJufAa5uQc	359
18537	2vc3A5kkDe5HNZZQFhzkq3prJBBpvpCrHv4zMSJkLe7ckVGFsM8z	359
18544	2vbZowrUokx2bGiEPR6DwWJG9HkdELzUGH2EfQMw1RCV8ZaWGFT8	359
18548	2vb3bGnKsVPRVxizz5XisFsknGGd9hsSHm5fDnXvKZLYdgF2p19D	359
18551	2vbR4JTnktRnjJqVtfQEBkovsp4PDu6Wrk9akWu3aSK13CE4Ynqx	359
18554	2vbRNbsV55ScDCuPe7gggVQp33shXWrwJWUVGhtNLSu1yrLcVwBV	359
18555	2vbyFAetSXPMBPxHhPdFdNdneQX5xzMNtpoHxu278R7sE54np33S	359
18556	2vaLpwFmBox2K7rdFjKXYnq2GPbd2agafpqZqYH55HPWkGAHYYDc	359
18561	2vbvpBs9HSF7qo91mnPpQkVq3q9WEbfQQXnMsqhXmDHtRZQXGREq	359
18564	2vbgdjRpfrrTvWB4eJBj3eC5BV6YwvMkwYQjgQubAkjc3PfGSxeF	359
18573	2vb4Vq98UBVz3jFLhCNPjX5vEs69tBp47xBt3ZHiuWC1hsJRM5LM	359
18577	2vaqRUEU7n12uY6uyry7j1smUBRwaHwbfRa87EVTYgHvuD7PV7bT	359
18282	2vaV3PazKuzTk2YkcZPupp7HnDbbC4AARqgi9bX96kJzWMAg1hzc	359
18285	2vbnWuY6CWap34koDpHhcyoEDmp3CrdPVK75yQ9YPfXEpepQ11P7	359
18287	2vam5m7Q1E8wGLK2LduB9QoN5V2Hmjt8SC3egqQX687SbFKf7nte	359
18292	2vamyWQnqD2s6T9WrzaS9AVRBy3ZFXTNub8zijwbieUgSh9jEpkf	359
18298	2vbxmbAbaLnnfrbneypxuqp6dqSsknnqv8dcpGLRLPu8jEmPUL1Y	359
18299	2vaVzszeqB6JxZuon9de3kQx7UAokTjuiDZTsB7F2aLSj411msEL	359
18300	2vbKHnF5kqRQQkYVSYojVYvWbT7YJmDm8GPk5cLEJrHDF46Dwvb1	359
18306	2vae3memvKdJkZZFunx6MGesxpZLCGfvNNbD9iNBCjxFbWREeZYw	359
18319	2vc2pvoiiE5cUPLdDqwHvfLYpr1Dr2VUSmRs516YWvWg5nt1a4rd	359
18325	2vbHHZKMuB6Yojs1pWNFW2d8HVdMXxmNRZ5NHZSKfyA4ihpYf7ov	359
18329	2vaT674xj8Uz4bQb7qYG5apptdVjQGqsBsrifBdcYJytCvmeF6Kx	359
18333	2vbPyAPpf1fHmCMoPoMqWKSbruX3RsNgx72TB7An51EaLhyVkkd8	359
18338	2vaZUYht78NUR1BiaFo44XUZ5AMfnsUarex6jeNmAjESfNsKsiiA	359
18340	2vbR6qaDucCWXDVoxcYjkpYG1LV44ZVukrducEtoDhWKFf1RQqbq	359
18345	2vbYHxcsTaZ9uhD7AxQuAzZWJkLMnQQJ844oiAKBcZeF6563zHcq	359
18347	2vacKJwgAh4nB69hz8m1Lk3bjFQxEZxTGVsjvySj2hM6hyK55hM5	359
18350	2vaBMpsfxsXeLMbYyQ22SBkitXLZTDJ974f8DDmW31AMnxTWNQPj	359
18352	2vapAGSXYrZVxviA9JRrDK6VrpgUMzZuVPBeZBBKzea79Ym1usy6	359
18355	2vbc6dotpHUrQdmWpgv3mJUzkw9r436eGnhYJ2aqh1qDhb1fHLgf	359
18360	2vbnyFEaLMurkZtU8aMj2VtLyJxo2xCscG7je13UT6f7ehfAC3Aq	359
18367	2vaxsxampAbNt6TEv4wWqDeUrKF3XM8XgLsEWUbpaR8EGqZ33t12	359
18369	2vc1bgB4Yp4MAP65LH37oZN27SNa1bViHqPLZPv2ewSrVbAk2Tfw	359
18372	2vbo4GPcRPMrNFuor7uBAfezkW7gxbEeTrm1aisoBqRnEnUSN23h	359
18374	2vbqDDYTM29PifVUwpJtJ8BSVEtXdHAS2L2S1EM8Q5vEHmAkKuzS	359
18379	2vbPYUfJ7jF8bWVh1wv7DseTsbN3Bz5ZcSeXwzCYj9VpHbAvPgvL	359
18381	2vbesQPgB5k7CGNs9x8Z49JNAwr2cMkxuPTR8rTXFyjvsxvYRMrn	359
18386	2vaBnjNh6VNcxsR1Epv6dpvAqmZ8rBfSZ3nTc9466HyD66qP4PrL	359
18392	2vbndVkoxPJpiJyru5efXHoKcJ9AApPFRYZWoV8THWvcVnwtWhJj	359
18397	2vb5GZu6EYWvyf45WcotUbVzZFLgfjFUADfDfKSChWL6qVJeYMRX	359
18398	2vbMEcVS1zkQqQwSKdR3cbiYGnS8wZL8vzTrpjdjmrpW4QXvXSVk	359
18406	2vbyhzHwtKuord2TRwp1fkUqmYMteHcLPQG9ct4UFP3bmPEBsNNu	359
18412	2vb2g9mF7u9a3ERrMAnddoCtZZtcfeXqSc3hGyKkoTqEanegRqMv	359
18414	2vaLKLSZaYdnD1mqieR2v8ondMmiM6tULQ7os2cBTAddhB391B38	359
18416	2vavzig9tHXsEfvhGwPMohiXjAEph6nkjW2dsho5WaBUudHCUcm3	359
18419	2vaJfQ8wga4QekSshQMSmDQsRvLQLQ6KYuL7F2GSc1WKyUuZhEM7	359
18423	2vbSf9gHgpQYKWHmLKT7bvDuTgc1YR1ErArsdS24w1WmcEXqUCU5	359
18427	2vaecDJ3vR3aumzJFzSQKzNfxDGkXXozonf8NSm8xkAffXjChceQ	359
18431	2vaDmG559XuzbpnDqzQsX1fgxQtY7onWy7G2M3EBddgYq9P5XsT2	359
18433	2vbtcyErFKPEyjkfFPQjLa3cf4GGyjAsbHZ3gzs3P8McW3NeFNYr	359
18445	2vbtWTJSmgSqH5eBNy3fiTSfrt2J7EsohK3NGdpUq7aofjZKsMBV	359
18449	2vaoqjziH7q9MWXiZuYVGQ3M3wJ6iE5STSMjT4rhYwGmcEJJ9Lvn	359
18455	2vaBjGcSViHh5RdbuTWmeGt5sCNwZaxFBTFfz8GvaJVfG7bdxdDm	359
18460	2vboJxhfRHGxJ52J69JZ3w3qBvvsa5dMGVEj9dMYY9T5VQYWCGG7	359
18462	2vbBZDouhseGeJDX8sawDwms4WvRQYUAmRCKSAUnnRJZrdhtTwsy	359
18465	2vagAToGcxDcxcwT788AqkRSUCp9uqbnWRteUV8fp9bAK7WDnEA7	359
18468	2vaL7afQru3ePMgDhUFFYGQh8763FftWsi9oKkXA5KbS3KkJC9LV	359
18473	2vbUFszRzUm8n82YstdxP8e59nythBph6sN76rxDALV23G2i83Du	359
18484	2vbgcF9sjXA3e1AfxvWuYAyGWVGdqYWLsGBSXT8mt2Nc4PGcCyBr	359
18487	2vc38ZfcJBDYzWbjE9MZJ2RZBpko1gQ3PcZbZDmBmKpc1z78NLCm	359
18490	2vaqaGV31ax2jkz439BTD1RzQ3HedxUzGpghqkFM2iFNGDJt4Tcz	359
18492	2vaqpmGNsAVFm68ktG5B8dS9p4AWDZv413VtTVjPUaGj7TEGvGeA	359
18495	2vaFBsKWpk8CKea1ZVrSczonyTJwo5hN3qJGwFUPvfQmbdnHFvAk	359
18497	2vayJmJMNR2Ags7wXJQDpuXLPopf5msGQ12q7uzy5MyVsSVsNkNb	359
18502	2vahN57LZhauPvqB7hc8tHp7V6zLXsDRHDRJwixN429iUW4p8sYV	359
18503	2vanj31sydcTSMTh4GsYc2xfGHFF4bQ7Rvb4YbdLdfvqwJdeiwQu	359
18506	2vbUSnk9477T5dRjBbsrK9bQLiBcLzq19JpAiS6gZjw4FgAACmK2	359
18510	2vaMjGEJsACD2jt65Qbxt19rcFRaiiJWoh8yZu4G6EJyRUm97CYJ	359
18513	2vbCNecTwn9nxdx9ZjB6xDG7qwbudNcnxCK5ieLErrLKx9hHixDj	359
18520	2vbafEgfb6XDHoC9VV1Hgb3KAKASmMXaWE4ai9Dr3K47JvxULFfG	359
18522	2vbqf4nkwxWL64Cn6bcZkjRFUdAyToekbC8PRc9RRkZRNZXMctb6	359
18524	2vagzx7a5JwiQHxCn6ruwvYpX1H6tP8dkQiCa16UPYAf64Y7VBWD	359
18525	2vayvTSm25WX18hYC8PiP5DqCXxk3FmNwUhQPX7KU722nSXW5bBH	359
18527	2vbDKboFobpnXNU17pY8v64zGcyihADeR5Vd7opnYuf4tiRputBA	359
18531	2vbcSW6S9rX7idLKUNmwoaotWBZZPFVD3JMVg3YK5hjJySCszmM9	359
18533	2vbYzXZgXxSz7iQADpQEiCexfKfQjUNKCNFqpTgyGuXbn6deicDK	359
18535	2vbHqVpBSKEAH8JbNDsmgpojVACyuZvcxJ5oMoUhEXWmfigipVVf	359
18538	2vbuy8p5RZpcv4cUAAP8Yop8NwuQatM8XMnxmLwDZ9Vxc4t9C3C9	359
18541	2vaLPvF8yWSHvMqYshVMEoKTVWHwiFD3e7o1RKjnSh3inr7SvZ8V	359
18546	2vaQ17y2LSRnRUB6s7eVxi1ybTo2fHcmf24ncDVRJts6M6kEUwo5	359
18549	2vbpNYWjH1j3GRdqaDYGj1AscPGuyHihXgE748BGZx6TeBC9ApGf	359
18550	2vaCS4QDMeRUaZxrnw7q44xGBFv21ptmjEh9XYjErx2QQdvcdDeW	359
18552	2vbKLPgYwdPXd3cGGEsBuxQpuVMrjnTEPud6GhgBFarz7mu3A1fq	359
18558	2vb2qNQBVBx4tYMf1UtkPTQ1jEdDbG2nHYpoFkRhCKVEbSPV7weu	359
18559	2vbSyVX3T2HoeXHkM2K6f4X3mYStVgJgCcqnmhqhHw7wpDpHanBm	359
18563	2vbChvWgS1iqfCU61aNUb2ppGcDcBZqoyZqoQRkcKmmFYZaMtoHk	359
18566	2vb4y5MbVRaLGiaxuUSLn4kGJw5SBru4R4KZUeDTvqb16UeG9Z4u	359
18568	2vbwB8zW5mUu4k2YKRCWPrAWuNomSwW9fEuGjfPjHTM6AedJkLLk	359
18571	2vbPJkTKvvuu43QyZtkS9oJWtq1wgodzD7hMQ1CvGKoT83TapWZp	359
18576	2vbUw7Y6LACJvUt95pAGTFdSMk8CoGB7YPzJqLiT9rYoGqyL61vu	359
18342	2vaG7GbYHN8c35Wq6HVDq3BYEgeGAJusAZm58eKzWfAnuUqbb2up	359
18344	2vbchsmtUsPLn9domBkBqGTiQJz7DnStXUmWpunGXF94imqc7NVv	359
18349	2vbvopachBGT8PEv9a8ZEgtt316h3mhV59GZroGGBzEd9Uxw6Qoo	359
18357	2va9aXkgVgD5D5b5ZNVszHGJuwopbxTTWoo6pMfA1tiUqNNidQW6	359
18359	2vaUQPckWMr4fkDWQxmtQry9auJnBuugRWCBdvRbr69Bu9bvvMi3	359
18362	2vatjxHH3oLvGWeXbzqYzmwF6Buquhuj6RQaUaL8VxArNNA9noH2	359
18366	2vah42dJweChN6mdHFyz2Q5Je3jCM5R7urnPYAgn64S9MZqNssg7	359
18371	2vbWxjKDfQkZRB3ymsZ6BqqxYG9SkPbVTgwqdx3LLD14dbxJgtpf	359
18377	2vc1WWbezF7PBJvTdNisYfDNvowH3KEY1x7DW9uCPZ8ofR4w2eom	359
18378	2vaLtm4Dm3Zde3Tsn7Gjcy8hHXgKT3DVCZsr27jdFsBrbAw4SvJQ	359
18384	2vaRzw2MZAY4ttccXAazcc5M1C3VFXNp7ebBJZ12KhZe29gZ7D2L	359
18388	2vbWDcq4izheZfUTqEvZntjfTvwF3EVKRhy36hc9e6ELxi2QmiWk	359
18395	2vaXA7bh8kvNeYUWfWihf4MdXuYRPpmyL5kdVG3sFuV8pqkWhVts	359
18399	2vaG9WsnonL7hF3Bgk6rGue8gos2G9VFnKTuJWzAu2AvayBDqGGS	359
18404	2vaTN7mzsZ6E4canm95uTyQ8BVUppfBZYutYDnjrT58xfTXki5Fq	359
18411	2vbkJ7foxwMXkLFWKtBkiaWzFdmJC2c1afFoAK11kW4JbBa5N2fk	359
18413	2vaTSXcQ61yw2Bfodb26CUvBiAjsUGGEqkg8ax6a1QtRR6UQ46jb	359
18420	2vacJhBPRVKQ6dwY6ZqqAt3DqzbuRYT3gDiCQVZTwSKwiHq8D8FU	359
18422	2vbabs92zKTK6EE4rAwSFAAQg5iajstE5LiRco3feNafoSrKZn6Y	359
18426	2vbhzYDdjn8LKMB97VTQKoB48csck2VRBiXnUe1Fy3BJnNzcAC9U	359
18429	2vaMaCVvktsA23BxEnA4k8yYukYKsZzohKdadqvfGJmE71KJoeaV	359
18430	2vabx9WKcsQEzkHe2HW56NVsSS5RtsetK3TXX7aHxd9kkqKVcXXk	359
18435	2vaao3LGMYiX28tBezVYuvStjGTunm58PcTsrDoxna3DywkaEYMG	359
18439	2vaQNmuQC99n8Ukj62dMqLPDp2ogEzLrR6oZKm3mBDgpwTbgF8AX	359
18441	2vbNaXeTDoK7AUo8AuNn1eQjea3HuCJsskpCViHEibp2j22e53fW	359
18442	2vbGW4772bcF4fTxvRQAgmFb2iV9w3qCVv58hH5kz8ZMB3vZKVLP	359
18444	2vbjEt23Ag11yYmHWorujZGxJfjt2T3T265df5kDoJ5GXsS66XMZ	359
18446	2vc1E951gX14LLny8sztnDmFZh7gFhmMPcFy1FpkNUhZy28msPqT	359
18447	2vb9Acu7xca6ZzG1uM9Hnn4PxB781dGZQ7eLAnmVQ7YvXcngcjoG	359
18453	2vb2Mwes6vS7uigwmHdC7MmfZUWYuPpqug2ZnAAwW2rrrF49r3uy	359
18456	2vbiF3Fv8u7BuEd7AJRAJsfBo4WdJg4pHmcwGHHfC2sfdAPkhcHP	359
18457	2vafc3bJQpfzkRGmCT7QnoqueozqTndnwtoB2icBSsjuEfmpy5Xd	359
18464	2vbfFbMSBfJDJu6Dcm2S4TAz6Ep9rfmtKa4M28Y457dhg9nK3N2d	359
18470	2vahNU9LoLzKeLasntnntgaTbiR9CDXv2jGj7eX9FvGnpY4tmQVZ	359
18472	2vaKnu6nVRb7GuGhhhV4to9P83gWn7tLYs4PxmdB4es8NFcM9iwR	359
18476	2vaJiKGmoZVFBRsv31JFCSS4s5irfX6ipUwAdtGU1Wiru38ftq89	359
18479	2vaK2gMp2r9XV1GHojMbExsm2B6p8UjGvvu33xezzdDqKgDbH3Qf	359
18481	2vbfF2UZS9Cwt7ribR6mqi9Eon3zqnV5awK4h3zi2t2czJziYmQk	359
18483	2vc5G7DvNbiVvPLQHk2S8nQR7F9z8rKAivEBapDXHMgXuU3yvSUZ	359
18499	2vayiqmMLUkPwwP2BWnBU19yWnSgVFAYNVJAm3KqMHdTD8GMQiG3	359
18508	2vbTSorLqMH57JP6Ed248iBxzBRH6vgUfxr6LqeZVgEvEAaBYpTT	359
18516	2vbi173xy6BZSWQ2ntS3fZqWkBxqWfiqnQVbJiHJG4t7b7H6fW85	359
18528	2vbxtVQUwS7HEtpDtjye9UD7bzmtqmDrRgvsvayn2q4U7G5giNtb	359
18529	2vbnVgfs3LYr9s2326zWvmsBLB3KF1EJNHkDpbbPSBZM5gjG6LXt	359
18536	2vanHL2kYwDJcdWj9ReMnEo7frx2pwk32rmAs1zgJzneZfQERVQs	359
18539	2vakMuziWgJzESorZBRxwKigepSyDJ97Xk7LH5Z5iqEoNPaG11zy	359
18542	2vaHVjsced9fUoquhTvEJG7eKFCjjbF5VUkgnWNPYZ3vbSsoRK5d	359
18543	2va9hmDq7SLKgowFyXbDmtDzFoQZdYgbx4RCS4rFWKhN1WPej3kX	359
18547	2vaT9VkkwZ84D1YvvNaDqdV7pTS9AdNohPwu8Z9knnGnXbixbYVM	359
18553	2vac8E21ZazyXQ6LLLR2z7SfqfRMiJndhEEU9mxA2CzTDEagpiNg	359
18560	2vbLyMXARS6KXFAGpTp2vyxNByxvMrtponzWNQxinxmgxTW8e6KH	359
18567	2vbih9mgYLwPaJtvGMpQEXBv1RBie1FfmHTN18oDoBBpebRNzRS4	359
18569	2vany8SWNLkcKMU2KX4MKv2qrhinf1MfdXMhiSNWewM2katmZxRr	359
18572	2vaZtG8nLWX4tAzRoDREBmfoG94dKSLHd25DYMMrhsKaBGi7sPvR	359
18574	2vbCPARn9qxuax1nByxiYQuqTRNwtGAQqqie11AihofvdNXoGtTT	359
18575	2vbfYE1pVDMk6RswjyAMQ3gYVMYMGPsWckua3LHPitPtoKe7Jsw4	359
18401	2vbSvKpBSSmQ1ifETtFkTbqUD9vT5MoE4AFETLyauZ9VAtEqxr7E	359
18402	2vaLW77WVRn2A1454xQqLUoqettM2HgfnEu65uxWXTtrV25XGUJT	359
18407	2vapRA2Qxf4DByf3ry73HMAxMnfsi5rYWWwP3sNFJzmr5ZUW2rzQ	359
18410	2vbbXSLFD6paZg7TTNPnudX7noGNfDuJSWqNM4dugDKheGebqZHj	359
18417	2vaKtCP2ygixcMqJm4eRpRQtf1txQazVCSNcqmbjozsvfHSkBRNc	359
18421	2vak85qr5brBo5RmQWdfTkWiAWeqjk7BzPRYwjzFnucg5Dao5UfJ	359
18424	2vbfvj7FDiAnQixVyJKxHxZi7tQCpxnNgUhPW6GgPyAF1jfjyLzf	359
18425	2vaE7oE9GTUrmfayscc1q66GjiRqMDwDh9VrQfmT369r3e8QK5cz	359
18428	2vbgSGoCiNXWdntVxWpa8NK1GkZDQPUeLfTVyJspvhLtEkPZFMHD	359
18432	2vbGmVUy5t45bPcuXZoMptP7XN5EH7RjdYuWX16FG8T755qArDjQ	359
18436	2vaNFE31CfnG5fzjX4iXqMTEyt3EVZ7wyVug9MrumBPFqnYh8Xbi	359
18438	2vb2h4o3ETLuZjhb1EM4KUawW7LVFw88P9MGGXvMGKhg8hzsqg1c	359
18440	2vbxUb8LBBPmqJH7GyXsRH9EozLiZTXdjjzSPwuwd1Nte7F1iMVn	359
18443	2vbwrXxCifwRexsjgbJpYEmvviYP9nNM4cJn7vQb4hGhb56hnN8s	359
18450	2vbb4GUQTWTkf4jp9DHVEpTmtipuGRWQ6wHECXJmrxVw5vDLYA3N	359
18451	2vbw2ypQhqeGsnmE6q6sGeS3pcsRg5RrBdksKDKEuQteG5doPaTZ	359
18458	2vbBmZ8jwZTTvXQrLUKEwv3t2wXrJTPgaKJSE41SHCtoDJNaPm4J	359
18461	2vbGFMSLMsrTXRvyE2i81RugET7mBjvLZdztUKbGTqNZorFMqn26	359
18463	2vc29fn4Mk2Yqa1yZSLhF8zGoGDRZp4UxJXffNA1RHPZRmKDryo2	359
18466	2vaj9ZTu7obh37sMmZRt8yrFGHpg9jpupt918w6Y9RP6J4HJLu36	359
18469	2vc1K37fKBDVnmWXv2jmJiG3RQX2DPG2GaBvKYmotAptnTkyiTQn	359
18474	2vbeiQvc79cXuWaVLfSU4vjY3vjUmpEkCmYFfq7RQh5JQPoe9NW3	359
18480	2vaA9GwHy8wUygNz9ZUW5kxXsdACgTN1uUYiNC1LxiHkGn69Ysms	359
18482	2vaWm45qLPZ64L7irzbcqssZ8FwVmeuvz8dnTN5kNc1qMCCMPoWT	359
18488	2vb67YKhgWtgwsEePxs5eBDd6bE9kXgZumm4QQKmSq9v6UyseWEm	359
18491	2vapigjdJBm1LJQJjX8hcgMp7X4ADZP3fs9H5ggsewYkrNeqbKja	359
18493	2vbPg8pXL43fKNUCybTRvhG6FPjvajt4ju2d3YLWUb6JKh85jLT4	359
18496	2vb78PdMgbKamyKKuJMB1vFfvdxhRamWxo2e4i8WmjiEM56QgkDY	359
18498	2vazwqXZey5QeK3WYt9y8s7Wh1eW76C77drcKmSjb4AURaKcT6mn	359
18500	2vbFisSDWcHR9NgXm3ipkc4hXqsMGWNiCSK4M5t2LQDjt5phFbSa	359
18504	2vaxNbsrBLKAp239r1Ree5MYXZnpNQUeCozNo4wbRs8GrZfXaLGg	359
18509	2vaV8k5pBGdSjKaEHU7eZrD5M84gzbUaqD6SBiYsT9MEEHLrUZKm	359
18515	2vbtaezcT8YEyUuYKMDKYo22K6ZvjkV6T39e9sTMBskGsLNCSd3g	359
18518	2vbpAUSCjBTdvwdHehVawSd4ZBNgyNQRHC1tsqrZ8GDsjssQChet	359
18519	2vanHwdCaKAfrvVGMgysawpN6mZuLa3CtSWcC2B9xzwvivuJVhsR	359
18526	2vaZu8F8ByQbiRezjvBybj2Za5aBEj6aKrsG3WcNFqXHJ15GxLVR	359
18534	2vaoYteZ5KwCqQKBNLXJArJiYGnwbpuBC66DNaLYDfPZRoLXrBCF	359
18540	2vbgo5aBwJHu1cmLE7D6CV993V8so4PDvbBeVXacrtCvhq4S2Was	359
18545	2vbRSFob7MQQEHCUyDzQMACdLmazdS91CXA57vdDijnpyWQyeEX2	359
18557	2va9F4oNWBwDnQWAznmNBQqqisCHDkhzJyhKs7EaptHwiFuNwUT7	359
18562	2vc4wascshS6gbVapjgTr7ztsHZUWg5t335rtL4K4KY4NnmsmRno	359
18565	2vaBCwgvSBasUXGHj4FvuwGGsDEY5vkGRdMBeVMXAM3jKWbi8EJQ	359
18570	2vbk54YAoGVsx7Wk55GR4Hi7P2rSnEzi6LKHBiT8xtmjNLQMBBfx	359
18578	2vbvVRjMJEAa3JTyVYKEyuVoouQDqyN7vRQCmLUWpjXNZHMSVRkQ	359
18579	2vbNtSzfKPry8zzxBN9sz946k3LYjibDxW6361pzS3AxRjKfCAvc	359
18580	2vbHoFtacJdmTX3jWvhcHQpBoS6jy79estgZF4R3A49wsGfDEf6z	359
18581	2vaJBdYE5KBu9wbXRbC7mV2urt4iHUxA9weHeZHzGbcLa4Nn2kpU	359
18582	2vbxpwgqkD1T2bZqc1cYKwhC2hNeSasBxYkHGC1DTqDZacXamyxT	359
18583	2vbVbChPCjTfjMhrmZirig643mgq9FVTTbfU7HUkZNGN8DsydRk1	359
18584	2vbDY57z6EhYaNtK8npCTY4QmkAUHXWFrS5SkDnPVMFhHmrKGH6G	359
18585	2vaau44U5itTEPfqPjx82PXdvsnYgU32shjKWhGHiQDeQwQNBphe	359
18586	2vaPfCNTcuZHLWrFmC832E3J9sng8mk4KzrePbErK8r1tCmsTJ4f	359
18587	2vbAW54tLTMrcGRaUWNwzvw8iTjwQQKhxvG569z1rQsJDHE1B86H	359
18588	2vaNBWXChEo9hpUm1Vz3Xt3rPzma9i5bf2VawszNdcLWQcbq9YnK	359
18589	2vawDfzqFPuPF7kBSEjdewhfKQ4aFn8WnvZqiWDR1AQEy1yLrz72	359
18590	2vafiV48VYACJXZgoq8qJtZMhPfkgXvxoYgJnrFQ9UEQP41xvoXj	359
18591	2vaMhybfDBuPwS1z1GpGxKpzGnX2YDuq1f8CxVUf4ga5xZcVw4x7	359
18592	2vb9yepEmVo2y2yuTs5FjXSuEwnmzsdn9sSio4q3fGBm6xVaxZGn	359
18593	2vbFyrFYPKUqT2qbFTpFBLT9kSTjWTwB3tiyD5AzoLZQMuFa7F4X	359
18594	2vbeQpP7De5UvYNweQUygdMnYPuqdrG1ADcuvMvUh1x4kLyyvamv	359
18595	2vaAyBDGM9hAzEpbxygtFxVzUrBLcf3rmCkAx44nXqCyftQNzejT	359
18596	2vbnEnX8YMJCsDfePV8ChAqVfyEZr4ZwYn5r2kmeXCj9yhi3adKf	359
18597	2vbs1dzhVDU5UAU9DcoSe879DTRVpY2sHtDM5faoNdFY4XxjqT2m	359
18598	2vaShZ71e4VJEeApuCrW3E9xvowKAMVnqj7FJDseUeNZ8TdaX1dp	359
18599	2vaKm6Sdk2SwRZyjSZGKbRqAZ5tYKe1auG499xAwv1XQz3g3rp6J	359
18600	2vbSbzzWtZkBtL7KhD155qa8xsAyDauCrzur8zndHwScF3UPz7U5	359
18601	2vbaD1aePTq467QqzvfBMEEEirEwYPoPxshpe8WXsYvUq9dQkhjb	359
18602	2vbpC2FAyzqWy1dpzNF77SeApCKnjmUxpg3zRRvAWjSj5cLwAMyb	359
18603	2vbkpu3yCbWfSGJYPNX4SnpRyJiVkryrXcaGjgJ3nzPP9fVNYAKf	359
18604	2vbizArfHT1JtP2xWBZAYzPtR455uApY4ud91VxZEBLxXwrZQBSY	359
18605	2vbjEtkH8EAop5hfvggqAPw85AezJBM1NjUTZh62QZ2f29GxXEr9	359
18606	2vbYDxnEmKn9Ws414bhnYWbL5mRKuHyupdVeWZAHpXtqrQkXFpFc	359
18607	2vbcVJYKTpU7bhFa2rGteHgmWEarvcmDUZWqLMgskEeCQhPjQS6z	359
18608	2vaKh91MPMVYpMPFdJcgNDhwV7rDKutyGg964FmPDHxaYN937MnG	359
18609	2vaUtatBCQ2i6eUmtZHhdjMyQ8rsK7QkV3ZHwLHqQqzkcvTWdUHa	359
18610	2vbgV6dyYo8ZDUp7Pn8BLJE9HV2fsX8yRN8Y4zPAJjDozAf2doPG	359
18611	2vajNyA5xW94giGHsg5VVYZzHhqQaBKJ1NsiKK9HLcYoTjh58j8V	359
18612	2vaULaZook6mFgpTp9n8hmhvGs7jQweasyEfvhRcZce5gN8p2fXe	359
18613	2vb58aAbrw2vhnxfADYnwe4qNWBbG75RTCKQJmJBDaqe8nVLDGxV	359
18614	2vaVBqGbZS7MXRSw4J4pfYW67paWtEe3ySaczpaD4KmB9BDf7v2S	359
18615	2vaHCGZ9XsX9pgdE5MdroDrPu7zXh2ZFEpQe88ZdMLnLgsncscd8	359
18616	2vb9rfafWQHtEfG2VsHTLHvNNMJPsXTZyVktDMjAr2fStQRK9orU	359
18617	2vbvrmKww9f4FMCdnFXEMCx7nzr63hutGGBKfvTSjo1Ut4WybYan	359
18618	2vaj8VFDaamJ7djbWSHHa4p1YyZCBBLGzEpPEhEmLXEYguvBboSz	359
18619	2vapzhavm9oMdQGNEsWGGxkSMBD7XkjztsokmCTm9MduwMoL4QCM	359
18620	2vbpqgw4hGf6QxU8wCieF2Ln55hCfckMP6Uk98mzDkeqzvxBMjo2	359
18621	2vb6DdQTyEm3XUGTzMNvXYuVKmqdgVXVbtixDe45EsnQSe2FkBho	359
18622	2vbExEgUaNebWgLuEg5seUz2BF1zKHuGvWJP5hiu1brM2F54s9zH	359
18623	2vahuEgEZNUJDVmwDfCF3HSyPEchtsoyHfhRjmBQ66zqx5eKCpb1	359
18627	2vaQW7BJFgquF1KTRgoxYgedqo4StHks399MzZgznvwt7aox4gzo	359
18630	2vbFXBacaM9BvbQtxtbJndnqwzYKmHDA24oQfDtrf7L4tUXqcm5C	359
18655	2vaiVzKCnewbgLft4j2Wzgn9jzmwpKbcu2Y5jRBiQzuYAsfadPaB	359
18658	2vb1aikiKRuRsKDuSiz4Qsf2KHffDN7Fgo9uygyqYgGsVG4yAmzZ	359
18660	2vc31HueV8c9FswSw2P48AxWfi4TaCrYb7VXTEUayYvHyF6GDm5h	359
18664	2vaNmSMMjNxe3D3sWwgCHyQpvhn9xVhpNLKgvQHQnwJmBBJHdBur	359
18665	2vboqc963njZ7czLfnspYKbB96NvENYtZ8SVKMK8yWxL8Qwemnqt	359
18668	2vbTVnRorRrM7TcXtB3KPLq7JMuMMu7xNDnPrsWJNkoPsZ8UoodX	359
18671	2vbCLmuduai3nonjz5S4KBMxKa4AWoGMzDKaieKQzbWLiE91f4RN	359
18679	2vacBxFwPJ5tH4nuimcGKi2Ca3JQWPk4F4TmrtGwL7di1u7dcPaH	359
18682	2vaPG2cYraFc98ijse687WPGP4g2J4YzY3j9uGv7goSM996CsJsL	359
18684	2vbtMjsv1yhZZQnEih43Mv72HAPJ5tsfKoyRkXk7ZRpdT1YkMHTJ	359
18694	2vaqJWeq8Zgc7ZqvcDEj6fQg9EmkdavW4WkVweda5tJ51unDJ587	359
18699	2vbZB57uRdEubVttcdgeXhLbWqjAYDKQPnJvBQ4LCQWvKfRkHP5K	359
18700	2vbvAUuxU4ePjmbrNVU4ej3UmP9emrienHr6RDXsrk1gGodgwKjL	359
18703	2vaqJQr36y9E5tadkLiokpBaHw7XABUWgEb3mAZWZBEoJW438fo6	359
18704	2vbHLWur2ZTfPEQ6knem8vepqME1RhHMfYJ7VhX22n2UimuRZ6H9	359
18706	2vbrbyuAf48cXkeHoBfbvy19McozjTnyo2qnLjLqXbV3p9P7xLWm	359
18708	2vada3phad1T4hKLaqnSrWdaoSo8pCcNPr7jPsPeMs2pNPZEZsXv	359
18717	2vaymwekQtH9fvNXSXM8aBti8cBGFrKbKPisp9c4XA7QVC3TaRfY	359
18718	2vakLgad65vmGsYwGMaJALbt2GUVL796dmQ3Mn5h26fFEnfmrGqs	359
18724	2vbV1CfD2qYyYzZSwGvNEXgXRKm3qUonQqfiqa3yHMRVypbETzKw	359
18731	2vby6eKvFd3jJgYQULwb1vPbbRmPujtmxwVTmJSaurvfLvMfp3iT	359
18734	2vadCnXx6mStgyhCUWZZmh6bGVhmMLayNh5PHrK8knLMmSTrVmKT	359
18739	2vaSNQLheF3hHFbHHoNvXQP58zxRRuveLtvU1wcy9YsWNmVXH1Xs	359
18741	2vbk78YRF7xM3Qv2r32HgSDCBMafud67LDUrp4fApVws6fRs2Yaq	359
18745	2vbkV6DjkvUkUAXJuiTbQL54CoFZiEukxuCGMX1eieK14mwwyMwm	359
18753	2vaHjHcxH2nf1MMDYBdie2Sn4qD1Rha1S9ZKWXMs6SeV79zxGjZB	359
18756	2vbrAfsa4MVKir4tZHRPGn6oksfXe9VaHqNw12uMyd1t2a69nrJX	359
18762	2vc1BLWCePC1vR4qe2fu6kbaeeAAAAwCV4MgAGvQ1pPNNun6oGnx	359
18764	2vb6sK1FhUmJHTKzwbKnFuzpJqZfTZ7EDhxWhzdF3PYrGo1tSva4	359
18773	2vc4ut7aghiw9JA2YCbKJzbnYCJ2b6THkgNRbRmvzNkj36YvbK8p	359
18782	2vbXazSgyHchrLRoKZXReCkAAP3bD4z5zVysJzERLTMHbhPBnTLm	359
18785	2vaLm3n8c4uWgLxeKevgBy83jxE81GMywRp9GKBtjMp64w3tAKKN	359
18790	2vbrhYR6r6gaUV4i72sJrjR3o1rzGPN2JPMoSS3B1ZwB31A8BjJR	359
18795	2vaxtGSG4mbRi1f1SyvhjZzDJw8zmoYWozyeAbWGuRtSA3i9a9SH	359
18797	2vay8dF8dxDBxFfWzjAo8B4AEHaWXEh5BFxYawEt89eY86WrWMRP	359
18800	2vb5R1y3Mk3Y23NVaVwaQQMNDuh76Va3yHJRKmgsoY3iTBty8HoW	359
18803	2vbc3ZsNtdvvHyqp8VZM4ZtEcq4p3f4sHFXWpbWs43HxxVembJYn	359
18805	2vbtwWJ9PmthtEF5NKLqoNU8ieqdAcBtvRQrkJJC2JABxH5fm2Ef	359
18809	2vaWnYz96DJQ9sRWpNGhGfZuS1SqmRqSW6X8RtrJLwa8CXei3u93	359
18815	2vb2LRMn43GdDJCLVCiaXh9zo2ZNXFcNiZpeNjHqreGiM8krUE3W	359
18816	2va9ggpYqVJ2j4dfBf1ncbqHz5AZeqmv7FHSCs9CDBt3Md5eHL6g	359
18819	2vaUs1ka57buhPYNVqNuLTkWBEJtoNjJSjthtoudnFEwNPeFVqow	359
18820	2vaGfW5FkMzRV2esvQtKudXtbMkjBnoWjNCuuMgnQ3ssAYFEEDBV	359
18822	2vagZBqPc7u31QcoCqqK7jE9odXzLXthqw4P4UGAJjCwemPBR1tS	359
18824	2vbHNnGAM3S6AZcupfGdqQhzYpL6x1NvafK4LEveV7v95szufkVc	359
18827	2vbtbFUgkJWXa3xXfDqBWZt6rXt1ULnLnb7JXqsagYeNFsSevQyV	359
18838	2va9EX4UBSyEbx1VRHx86cn3A2LG3tUkW375hRHxkzCPDDyZks5t	359
18843	2vaRQPMfTowoUUFxnNXb8weGbaKxdQTofirsQvDo17hsS116oM83	359
18851	2vbc4Ju5CdNSkVLjwGeZEZYhe126xTpDhjhNVs3SXopwR92Gv8Lz	359
18853	2vaxNue4CfcQRDUcToU6P6bHk8CosCuYwgTUvE84eqZijeQoF7kp	359
18854	2vaUkmyhSi9RHJtRcA4Dmx7LZ2fjoacGZsbzS7Ek6FMgfQaEXZQj	359
18859	2vbMwhMLjMqo7ALbeXTZjwuyBkFueMCgfn29TKY3HFPs8fuBDJtD	359
18862	2vc5Dh9SvNNRoY3F7w8tnB1Qm1vxHXZLPYVqMycMeptmRePLzseJ	359
18866	2vaZ8iCRx1sZ4Y57ABLes7bQGGLsu498DkGhns7g9nTpMNLY2B4Q	359
18870	2vaxiT5gRyqDNyvcbx26FbXxDoD8XRkCXXHfBgtrs6zuYrjibeTF	359
18872	2vaQG4ahHRodnjYxRH5ea7Xmnqo7XrcFGacJ7s12XJ8gnu8UK3QF	359
18876	2vbPGHUFYgesb8exXcvH9QevW2XaETaRoGF66fCTu4faAUtimFsK	359
18880	2vaeejM3GQbKcuB3o7RhryXcmNV8tD3QfEviNDBfuUabnounHen1	359
18883	2vaikZrMXLYMMRVix2NaZAeDLQhu6iNheiKnSdE4VVhS8AjCm3vB	359
18887	2vanbUfBJNmTTVuPiJtpLz2ZiuPxwV3X6aeE2iQrxyg1vzidGjmY	359
18891	2vbrTPqz9DazRsNpWYBfqTQTBGedKQVwWpudQfDdEuEZXVUNG2rZ	359
18896	2vaHowoJvY3TNfvHBbQ98LsUsyY7rGm8rewvnvVxRqRHhaZwvSGj	359
18899	2vaFGBJ8idtJpAMrWeGdPo1BmeyZMuHuDo8P1uySZpLFGwkfBsie	359
18902	2vb2SiPt7YjCpuDfAG1T6eQm1tm4uiZHq3Q6oMDkc98t85LVbAtt	359
18905	2vbxc9jdtm4yW83VUfQWQVi2WFZN3xwRitYSH2cfuRYqRtFYr8oH	359
18906	2vbm3nETAynSR7av58Z8e1xm3NqvHBciNpsvPPLRmqncxD5XTDyK	359
18911	2vbFDfPbY6XHhuDtNwNi7PsinZQp8kG2BE3sYTeP1QfWzT9VXEa8	359
18916	2vbJeMUFT1hSuSz2p3d38C2L1oz8HYFF9fvDiURzbRE3itERKZdH	359
18919	2vb5qLzc3VvaDzvM3uu2ZQ8WWNyKk1FbN2pQPHX1b6rD4vYX3ZoE	359
18921	2vbEdew5gGdn5A8p7J56A8HHobGk2HBNnkYHVaoYdkPhgbt3CnpK	359
18924	2vaiNv2A4Fmysu2TLG2nALuNifefsBZM1YLzsCKY6NmRcVsdmtNw	359
18928	2vbmCgY2g1tvqASBZ29nL1CP3XAEQi6dPm7BkydrBM9MizaFQR1A	359
18933	2vabMZh6VizmNxM3HHYEHihLQtHEXU6iqbFxwtS9u53CMnKLV541	359
18936	2vbbYzW9Pjrp9tjRpQawEX5D7th2adbLJQrmhZ1wPm3yrJK2qLC9	359
18939	2vaUMYpasv8abHPS7ov3TXBeNS51yGEcyLCnmT18nR2942bWr9b1	359
18945	2vagXdSEsgi7GZ7qXzVNuxx4Y7y3CKSsMjvc2AkBQPXNT5fV8MXw	359
18950	2vb4UdMCJxVALfetyAc3xQXVzRYfB1P8P9F3U3akhL7wvQAit2Pr	359
18953	2vbVdB3GLgn1srcHcmFYznDJAhVFuKpmr5FvdUQXz9yurbQVtDdh	359
18958	2vbwoeW2n4V2p5Kaek95NK8Bt93cUWYtGSVPL8eLX2FBmYDXw1QR	359
18963	2vaosPjyrAHN9BUxRcapmDu3Y4MX8Qmj4VEvnnGuHrsV2qdGQySj	359
18965	2vahhVHoN5fW2BbfkCFTJKjiyGSfe8GHevbbD2P2AVn4rpHJVGn7	359
18968	2vbW8Bz4HWWK9WNrDo8BHNvFk2KpE9YFZ6itAZJan2BCiUccHt9e	359
18969	2vaNdA2y3qFC98BqotzaQZAdL41hhEzqLScX4TGwHG4zjLt9DnEH	359
18972	2vagHDZmmgKTMV1RuwEYYf283JFKPjb3QrbkdWk8hJLnhYX3gMyi	359
18974	2vafLYumHvDQP49XQScJnPFqh977FdAsjhSrZbrtrXpiPsydG5Sj	359
18624	2vaVGK8iGPswhRm3uX6eEQWTUL3XNSGo8zK4pEiC5Ar2gJ4uxeqF	359
18626	2vbEDJdZkMfaPQHXaESJKbad3YD4XnQDhXJzSmMVWoGmK8L9rCbu	359
18631	2vadMCVzaGjhHKdD1dxRnxapnDQyJSquKWQyJoQdGY3656LvNtHz	359
18634	2vafb3BU9nKAp6Vx1Ei8kBDYESvNC4GWWM9GyVLR2bhut3QJv8VL	359
18637	2vaCCk9tbup3YCyAT8BN4XkQ1mn9w9KRcE2HzBrD4umxF9LxfHrz	359
18640	2vapNfmKQaNArbn6XZgvmEFPEBzZZwgLrTq9kMXBGM3cb6d9J2FP	359
18642	2varbm2pzGh537ZQ4qKke7H9isRoAJWKwt9bdgTPCAeuvHJb7R1m	359
18644	2vawr22srH5AEi2MxwXiziTrNE68Px8jTC74SHvBb9qc1G5vqzif	359
18647	2vaQA3UMNmX92GtYPk3amzin5SKMBnkRcC65pyQwn9XDMQ88Rkng	359
18650	2vbEPt6yzCvJfcSxJvYkkKU44Rp7cZSWCNTXu2fAweZL7BVZNRZB	359
18654	2vbdxnG8QgSThEwitQC54RV6NQEr6FWAxRduhHBZxwDLa5G6j9B8	359
18661	2vbENnppoF867zDHT7sEjovTjfmXaxf95p374TaFcU7g4ypatTDE	359
18681	2vbXaNKGhhyiGMWv1nzMkXwdDqfog1uX1VXA12hKLxSTBpXDRa7L	359
18686	2varfwTuguLGJ13fbYiC7s47j8t1qMZNaSzxAbh2AqX7hH2EiVaQ	359
18688	2vbUxxquTfUfYeuJVJKc3xHKxb8MdjMDPk5WWMS1iGA91pa296cM	359
18689	2vagADLX6cbejBnbwvDNySuwrv6YPEWwNpcBtSNEPy2mfFxQP2wA	359
18691	2vaSeqxQhgN4qn8KRrthPZdomkYsCg8NDAwfycVRvoo3VaxV9TjP	359
18696	2vaLoxs7seTuERB5SvJXNayaxBGTGp7Ss3sP7JS5JoC3GmydqqN4	359
18702	2vaFwiqiosxuXQZEHGCJUzfvfzFsUEqNuPVueDs8fgzkZ2JxstWF	359
18705	2vbAHwxRPg6WYBBfD4FwiDkQn8ooE9jSt4462idPa5BxpZCKchDV	359
18707	2vaQwhPiaGtr6q8ZRxCMoEZwHD2whAeabWrGEEJbsdf8vKNPQoLq	359
18710	2vbTQwu4DjcDYoymX1oWNYDVqkYKWWQwq2NhJnb4Bmut6aJyurRA	359
18712	2vaiHnjHCj6azUiWGJe7GrjoZvyiFAKW9LUP4vE3V9csjrYP38WJ	359
18716	2vbjx4fzUn1K4t9RsuXj2MjQ48Ko6AXwWvryQqGa73DhF9gqWiuZ	359
18720	2vaYHe51bZssWZiNRkFMsMuSAgE9v4t4WcJevn5P8wJZhoY3fzg7	359
18723	2vbr7GAntbBDbX4cW23pHkKMUwmCi7BUKtfi7B9KsSxpQCGYSrad	359
18727	2vaQSgL8VAAHuJTx9UfqpExmwR2EkCeinrADeauz8EtAz7RjvYmt	359
18730	2vasv29jsgnkFxMUZBjrcjY2kvT66tnRGuaPgXHWTseXx2bb6QHu	359
18733	2vbe7xT7v7jnz7b128YVCgHu1kPCw1NPySFCmQc5ZYsJkGSrvUr7	359
18735	2vaEyj5P1UnfAYYhoK8kYLFxLFpbtt2ZERpYyo3yGxEM7nsudesE	359
18736	2vbiCQVZoLPfgmDvvvJnLANzbWiCiNmvR7oYpkgW6Y5futCNnVqQ	359
18743	2vapgHyR4BFqYqvj1rbPNKos5HqnFz3ohBKHb29u1stGnq3kLJw2	359
18750	2vahXcYAfHP3JFYiMtr9YpM5Cxde3y55g2UVzPxEm3aNcu6RebUR	359
18755	2vah5NqdRWTqD9ESQUrZTYutLHvmtQniEZoAv8E3kspWfF1DC9yt	359
18758	2vaS1Z46L6GcpQ2T43SunGSLv4GLWkvXuYDBL3tSNZmhrzqucPWW	359
18761	2vbe4g7qqdfjZHCkiZ7SMoMMVpcsmg7MYscEVRmefdcGaMpavjjK	359
18766	2vbWNJGvva3Tzm2Hx4QCo1ZjkDyVcpYSkKzRjF8znERXKjQQ2kxC	359
18770	2vbXGLxrU4CTg3JmoF8ZhjzJ6Ejkf3MXMskXYGJRvzjy29SYyhRH	359
18772	2vbR9QZZedDvLpaqV4AKsTfwmVJQAdFBd64ACs9Zbigr7gCfZ1qw	359
18775	2vc4skAkrCzMNcNnhP618TrmKqHEmXoaxACkvjUhdPr9fHi36EWq	359
18777	2vbV2f7tqkiKGYHkfdKiRuHmZq5qKg3baBFbCTZEBNjKwHoZjhN8	359
18778	2vc1jdw6vvujPbjPEbYT8wQ38VXEPgNuFtA4dLEB8p2LRqrGATbt	359
18784	2vaubgUKDPaGhfzwnFVsDva3reUPupT32FKbCgfegFNrgCty266q	359
18789	2vaRJAKXTD1C8LdxCTrqvk6MPXVtgmmEnFPK36u5GF5aECN3yDiq	359
18792	2va9pSCjptD2UffjHZDcuXCNJWfzPfjLTm4tjLmxQqdhzgAZRfbg	359
18794	2vbNzJRB6oPCRny8Kbqt7kyn1aFvcN5GK7gxKRfJEDuznCeGFvaf	359
18796	2vaMe5US6vgKzeQ4TWuJU5Q5wKzEzanPQb7EbcKLrEoC1iG8TYYw	359
18799	2vaZC3yJpgsy78ajqkWu8HFBPFRL3w8R6HTyZvnWyjSh2ytPFuNL	359
18802	2vbArx7x4Av5p7BZYGq7uqAx2gGvSsEZjEfVk3HjG28QrMBYCbhR	359
18808	2vbvTqo94x7yHLAumbEKd1F6waj9bojN7GPAoJeX7QjSXfcSTeyf	359
18811	2vaiX18oWYKFqnH2eWF1QPYmUdguodunp4gzo859LMmz4wSRvVCX	359
18812	2vb5kCo1KnopCbS9jag3qDeHPViYq1KrLN2zgFDw4CFC7RFszYzw	359
18813	2vacSsixcKinra4d562jgxVkmcVrrPx8dngnWGYKwG4MMsiLPKVQ	359
18814	2vaaYamHsVkP5SF8GZhhg5sLaLaQC661ajfoheudNRbMwAV2vzRJ	359
18826	2vacZPCkj31qJKgitADyaecSzPQJzxwiY3vAUDLDAcLiVTcnz9us	359
18829	2vak8n1XdA3zanBQ9NAfFmjfk6gxoDtDYSuoRyVPq9pUeh1DT3t7	359
18831	2vaSKYpfU9oH1xaetgTcYHjjAUM6rtCNuxdNmHR3BPRjqpVuEnyA	359
18834	2vbW7jfuSg4uwT41LM5ghHEKsvKdKhhXC3kqK3JqZj2YqDevpR9t	359
18840	2vappqiwU8P4i4PTTCiiGVRa5HnHcqSSMvkg5uxHbEkPWJpgyzMg	359
18842	2vbaPjJ6cC2nFATYPupEtnP9hFavGnzbdXR1nwR4WaVkrQTBvZ5d	359
18846	2vbX3AvU1HjAjLwGjYfM6MLQ76krPNzVMxDDMBVwkA5QtUv5t9JJ	359
18850	2vbuXrKpxVn4Ax91f288GkmnqrGDgvxSF91q9h3WE9uxjWNGSCSD	359
18856	2vaz9aLpdSULFqH1PN7eoY5TVfcuv1WjNraD4Ex5BYDjd2YS9Apo	359
18858	2vaytVkGnhitr1j2Wa2u7tsK7JLJgUfQbu6MUm7vzYafzxcAKB2k	359
18861	2vbumYjdVitdrMaTjkesBWFWUuzAuzZJzuN7AABb4kvUvixYZDF4	359
18863	2vaWNTSwByugdSk3fJYuS8M5xqgjFs7DhuVvLKRjgTpoMPFhNNq8	359
18865	2vaAny2UG35jTARCXTn55r2Mvfa3smD5E3KmZFx2B834rf6m32Kk	359
18868	2vaYL9Nz6EE7TzFwntjGDNq2KSp5rjtsRBATXJfYBLS749k2HfLR	359
18869	2vbSJvBJTFVA6udbZPV2utwaTKdDfHQoU4DAsZu2sEe91JvQcZKH	359
18877	2vbvaRAjKC19KKhdFYrwNXsor6nifUVgfoBjVhmAu7kbypzr3nkd	359
18879	2vbkrzUZ2AR8KDAXTNaAAB3i5fYnBMwvPgPma7UFLfTFcJecemCK	359
18884	2vbMDrckTV5dDPKwJM5XCU2T8Rc1nWfFaeSJqCSAaxFevfSYMDfL	359
18888	2vc2BfQsQqypRRs5xrztgmZKHN3oa5i599tYiZL39u8kEHTN63WR	359
18892	2vaT27rnbXonm3Z7pmDHc9wshLRPbuanv4Z25n1F9wVJ7R2xwh3s	359
18894	2vbwRXfcn5aQzimPWdMWTJuE8VQcmtFcVeipAXk4ZrWLa3sxkgfY	359
18909	2vaJwb1tsBBGNKBLK7xNLyeYk1XVcsXfSxXDjiRLwYL6XZh7M862	359
18912	2vakUaA45UrReWPdu7bsKr7EyrJAeXNZo7Pw2DwkNhyNWiEWvjJg	359
18914	2vbhk2Jr9Vh4hpA3huLT5uAFN8TpiBxY9BYz5pcoe2iozxL4w9Ft	359
18915	2vc3vUbhVgjy6Z72MTLGTum2WfVJoDXGF9SwkizHDjHsLwH6uaRN	359
18922	2vbEPnLgN7LHgKqmRejABq3YNDFm6KiDXVH1raHpZPoYquJmUhxU	359
18925	2vasxbuH8jbgdpknue9GkFr6Y25RGxuVmMMaUEm659Vdqm22XTeV	359
18926	2vbWgZF1wGbvjpu4sH72MahMgVcnJ5cD8n3Eh3BRvYXQgfZcgnbg	359
18931	2vavHJafmNyFXbrKbWoYp8gPhnqoDZERN7N612kwBDtCHLKzTQ8j	359
18934	2vaGKN3kGpZXve7HSDL3HWNZ6ZPoXEUGZDsAF9KqwywZP94ujK7c	359
18942	2vagKugdr8iH2SvydUUXLyC44jUoeXvnSFgefWnZWPNw3e5VJuzV	359
18948	2vauPoRL9PgkcFvmQdEvLcqEh3pMoqmvasM2Lwun4fcoX6oy2W4B	359
18951	2vajLoemEUx96v8j83NzkSv2NB337shLxNhV8ADTxHYyxnrDaT2q	359
18961	2vbKJPhcxqXZtbDsHzqSntpAJGQAA9G1jH6EGMjSxwZrHfk6K2vJ	359
18625	2vbX6EKsHCbfN5EUG8anJGRdCbpHv9u6r6m39mYkVJZbmtx4f7om	359
18628	2vaVcvwoURqwm7vrARGX6E462SNJUrAJLJxFWDREcozPkXQoTFT2	359
18632	2vbjtqG3fkiMCuouc8QFzPmgrbvuvHWtPwyNrk2fEtajUjawouDG	359
18635	2vaUCrtaRjyLyPyd6AP1W5aWYHqqhqAJq7K9emvJi1toDYvBULJA	359
18643	2vbxxNvWiWgGX3sjpNzzsKnscsN3w1DvQdZc8ycfAFqBMAB4hMVZ	359
18645	2vaRzwzGa6ZGXexGcxe3eFcWBcNyM9fJFKE4yz5TffV6uiiphZAr	359
18648	2vaAkpnbBcb7xLeHgtDg7aZt6uFCzbPf23jjUqLWHNEVuY8TS4Ed	359
18651	2vbMg6CLiNVZQ4zs4pHfAeEZwFDsZeVc1ELh5F9myNy5JMAjWz82	359
18662	2vawWfqzh8A6MEVRreK5jeGsyuWJBe1ZRD6QgrunwSeRCVUEnqMH	359
18669	2vbmHLXj8CyjhPW7JfdcTr3P9kSpJX2ekiahzVNLoVE2P5z5HgNY	359
18675	2vbg2ENZguUWBcBqDX3bWdVgs7ZNQPivKSnBFUTezfU3VMsHjWVD	359
18676	2vaFYxmkCbn7tDf92WBkjxA8wwyQiUiRkD2CCWCFxj64xQEFtfwZ	359
18678	2vaUmRxPotbEdTrrwB59BKXGSwpiWbVGn1NNn7tYjhP6cPhosMnK	359
18680	2vbxeWePJyyK7S6jj4DEHyNCMLWpZ7pNqoMn8o1JjRwHvn8xzibL	359
18683	2vbWkpUDTt8Dw36HNeKpHYUt29zBnDLSfUAGt2PMmYb9SXEWPmYH	359
18685	2vao1AqXc91eSZSu2P8mTHxfRshjhnd7TMHLfPBjFMQ4JZDWKS3h	359
18687	2vc2KQYy67SAdwKdSZDbWXEyEHyTTR6UL3Ap6E7XbQaM99XuA2F5	359
18692	2vazcJiNh2Rp6UXxXp43zskQrC7HGgm5Aqo4NfKtbGcwXLcSRWyY	359
18695	2vbiHkVRjz5MhR866YGqB2D65nYazJc2NnEvuJcS73trGBCt9VaR	359
18697	2vbSoBKH1b6MbdETpM8YqJueFNAzyiHTNzwSQ4SXH4hbEFQUJ4bG	359
18701	2vaGcrBbfCVrhFSdjXrBdjtmd9FR91efSbBKgEjLr5XWfn189y8j	359
18709	2vazkpcx83ueyBw29n8VWrL8iedtXssVX4FAgV5NEpQcKbwWoVGA	359
18711	2vbWKKmgWg7rn5ZCmgTT9oJpN5i8iB6BjQdLPk12GUjNiGsg2Soj	359
18713	2vbfxSTngqj15W9H4WYUyPVyzvRfR572EBzHFTFakHGh1Viny4zh	359
18714	2vbMXxF8Jcht5rghukGZvW7owrUX66StdqCp8r6pkvYPU9jbd224	359
18719	2vbDeFwriWQ9X6v4A2Yi1ywCTsxs3S5PtZ6vTqm1EpVSVxmLc4BN	359
18721	2vahiQfyVSa6VFD8s7U2mGA3x7HYP3nZdc3Je6txrJt98udpZgDx	359
18722	2vbm7rmrLfoohZH8yK4mdeg1kptRnZibgEo11Q3997XD2Z1nrJBe	359
18725	2vbthCA7kbZMfo7f8uCd8JGU9vfk1vUC4BLQ9sDRE1BVUMA183WP	359
18728	2vaqRHFgcBAGeVEgpo5e3YgaUkPZZ7bHa9M4Yc1YCv3K2iZ58br9	359
18737	2vaaU2vvSPDQ5CSZEXMHnSSUR6Gnfzq25BpamvsBurHRxkApWB6h	359
18742	2vbwkYQV3WYiyexRRigM5mxRanpLswURkn4QeT6nJFLQhp57QbhM	359
18748	2vayWKG4D5d1qz9aTyZn2qKzRNVd5GKbT2kxHbTm9hCbfZPvs2a3	359
18751	2vbqTqcyB11AjadNk1M1zcgHHPGLfsCSuSK3p5TrrbGNrnrf96FP	359
18759	2vbM9DyFTzc62aim7qkcusRc6xLiia2Fxb9vNyx928rKZPuWdvnd	359
18763	2vbP2jmniMvQu3YhS4CjUguvDZUonoez3TckabWTDYArX3SXWGFW	359
18767	2vaYmR7Us56ajMU3Ae2TeYC3G2q3EfBix9cPVEzazjJexpYTqKBG	359
18768	2vbA53NpNL5amwpzyXJkxw46poBK8pF3bauGqqkjy9QdKLVKhiZS	359
18776	2vaomHGdePfBtCiubD52gQwufTn8DL7q5ZGQCt9ZhRWiuySA7Shg	359
18779	2vaRmm9YqVfpVDMJohCtnZ6oBMZEZszstAt86bKu1Ltqrz6Mx8Vi	359
18780	2vanL7hGJaDkdua9UWB3ikQqQhNYuaKqxNynpAaYRnEicwFoU3pH	359
18783	2vb5KppnHowtLLerGi6BBoWbHeaD3kP5M1TWzYcyUi1HFmbewxfs	359
18788	2vaBCrircmuqnHbDoZXUrsZJmFJw89QDhPukQgwkWxF7Xa5a9JcD	359
18798	2vbmx7JFkpPvqSUwuggVbR4pmu3FuZAPuE1ocqcKb6bpkEQMsWCg	359
18804	2vaEVqZS4B67XouAAFqoypXRrHG5TqEf1XTa9RQsVie2CvTAGbTE	359
18806	2vbopB1GRBdjex5NZePE25XB18H9kD2YRZD2faRiHyyLAthvSp3i	359
18818	2vb3dp7SoWBcqgVNzTzFKRgHRdo7chCg4x4jPkFJe5rP3WV7kEVL	359
18832	2vagjr3reoo5pCNNLtaSmcdviEa69L3UcCzSsjfvHstcurRjqPGp	359
18836	2vbbXUQLNur7DRS53SH1PgtTeNcQQGiWzrEuSbmnfjHgQhcWKpjo	359
18841	2vbYx4NPdF9oqis6JoWqULrXqhUUk7BZBkCZRcuSTFtVBy2Wh4f2	359
18844	2vaQUTgVDnaeUW5JEuPDZgUKsziFafyu59MWx81g8T6wSa95XxeL	359
18849	2vaXFBStKHs6SwthZAna1NTJjdptgzR3uMvtaxwHesw7SNBFc4aG	359
18855	2vaX3Pr9ehct52bPzryJ1aUY2hDkXRwsVKVN3uG7nSnE9H6naadx	359
18864	2vc44XKvpUGNyRtLarmRRnoS8BGWv8oGQ4Nik5uNqUtxCrbqskMm	359
18867	2vb2VcZYtYzm9Zokqa6NzbjJXbAnqB95rP85iUQnbedAPfRseG34	359
18871	2vbSwas1oTzqW2cGjicNmhDZkcTDiww6F6oQLJU9EULzJbgFQfc6	359
18873	2vc3RQXS83kUWqQT56q36QyiLXpFjKEjnF3uRmTGNUbkAzPqMnD2	359
18875	2vbLoDZyg2ugDoeF9RTw8ntrWCnSk3hkz92e4BcZzgdkvthmCDoK	359
18878	2vb9unmx7bhkDcctMwqHR41Pjcd4tBNJFbuyvik12aVEPCPXPRRQ	359
18881	2va9JA9WJ9sMJ6YqrVkckLPJUMcj4fHrtf7aHviSYsMY2Q5A3nmP	359
18885	2vbHrTACMdpLEK12AbMu1LWJQXq1jWHVANKV3LYBrNdLKmHH42zQ	359
18890	2vapjrugippA4yMBRCbP6qL6Woc9Wa3ZVSoVcFo9Tk3u7WUHqR7M	359
18893	2vb46Tg7Vo6o1sFi5ktTgperoMzyt7UksZPu3c8NbAx3agQcaT6F	359
18895	2vbukWpBZXsQ6ZAKowrg8ftx7TBGdTWuP8UuhVUHwFjUAX4vdVf3	359
18897	2vas46dDUReNxkzCxqjyPZJWpeFv6daLW91dRxyEEUPaqQy6GGf3	359
18900	2vbeua42Zz3Q6T2NfTzvgo24ozsJXcN8SiEPAKPuMS9c2fqv4jU6	359
18903	2vbwXMBn66vVW8YWP3r1J3mnT3fJS6tkiodWNCQ5oyn6HBdvXHFR	359
18907	2vbco8SQc2FZQNdCjdfzBKoGjQtat8tauhubo3S7gGpZNR2mze35	359
18908	2vbKRC5qL8SsQsgyzRKXWPJi22YXritzMZwvVwMcLTo2R53mdZad	359
18910	2vbzxRwM22MD41xx6Rk7jFPheTcNt4GpQXsMJuZmX1fx4AuwEQtp	359
18917	2vbH4YN2Mwr65BuqJ5LekxxGrQtWPVwK3TLNJVzBSpjnEMsVztev	359
18918	2vbqQm4tderEvUVdoHJP76rwCXNLpBTg8P9km2LJTYL9EjZnqyV6	359
18920	2vbzT2RMvDG7dYGDaax89WJHYJmKSXSjecDGK3xmyumtG4DmPja6	359
18927	2vaqswaqM5o9QCA5vfPEtvHDQjBeqxmtmUybzvPjE5N1WC1VrTnt	359
18929	2vajq8oWmzVJ1GQ2XnGxo3UKZAyBPTYMLrtgxtVibgWkjB6WFrfY	359
18932	2vbaJhv37J4ib55qNBzKxq9h8zRGK3ywwYDf35rRV8mkJn1Y95F1	359
18937	2va9q1LuNAFKTLUTa5Fru8LMgbSZxbmAZ3NMoLhHHA512wCDyPeV	359
18943	2vauyF2ckkx2QGJY3kGQq4nHK1mTBH98beiF79wg9DhWbqDLF3Uf	359
18946	2vb7kQeQjLAmiCXVdBB8GuN1SLkoRqHgn2uzV21mAQtKV3r7ZxEB	359
18949	2vahMWGTgRb9uHdGoL8FfJTJ2zXv2K3L6gzMi48Z2uXXriADLDtw	359
18954	2vaxdMXRioc9s3Z6nsQr2othqmDCSU2pB4sgCjbgC7nAMWCNHUDJ	359
18955	2vbiyZkoJ2H6MbwNPtZv3TkHpJSsSG14C1xwPq1kWwaM4TMNNezt	359
18957	2vaA6yHdmRTcajQve3vGkk5NeEaqNuLEm94ZfrUw8HNcT8rrSVUd	359
18959	2vbfQgvuUjNGKV6sco5sGoiMtwNrMzF82ZArj7tKszBgVVBLK21k	359
18964	2vaiXHtGnLncePrpDnFnc4LVLY5pbU79drScrhYbygCSMc8SxFbr	359
18970	2vaHRe3K4RF4HB9qyTaePSTskiHzky73yvV89pF75dhWSCNF4pRp	359
18629	2vbUdmNyFZFn5jzgnqJJYn8797px2mBfKDhwtZDPDtqHCiepUEzi	359
18633	2vbX9dPm1mMN2QtbXT9moiksVGbKbtRvE2Gd1oyUYEzwkhxVSeCp	359
18636	2vaJGVnHezCftvDNZSzhH9fRCwHbaHdCiFZ6GARsByDZBHKGeN1W	359
18638	2vb3PvYPw7f1HqsavwW1vG55TSmp8kPARxFGttVXvyV5sSqjPzRQ	359
18639	2vaU74HebFpvueLPNSH1RvZh8nioyTwyWwnzpPq3xMt2L4VQAD2x	359
18641	2vaQiJaahxtaEkqv2TowKE3MyXVtKjSzB4iSMxPRncRAWGGpfJz7	359
18646	2vbfWdETDNEJK2ASXdRYJLTNJmobHsqiSi45qZ71MELW7LAF91bm	359
18649	2vaXStYehtZajKkuS5kE5ewYNCSFdXnfu8zUUyNp51oxAGdh1D2e	359
18652	2vbyM1c21gZJa8FoSYkZc9iArJeEpJb7vcYWKosxvGwg2WX9GD3q	359
18653	2vaKywPS7eLG4A7acBpFAC78JH5BHujfcVa5Z39UmMyrL1VMPwHp	359
18656	2vbDJnx31Kw29o9q5kyoPAxoSdVSmMJWxTE6TnUyXLV2BSwqiEpM	359
18657	2vbiReeFimCNibGVQ4JbqWQC9xD7xLNzyVk79UktcZ2KTvemASGG	359
18659	2vaB6VKtSc6vtcvbsFshScAtG9pswE6NgNRhMbLYLu8sPhNSB15e	359
18663	2vaHC1szPkb37VHxNgUhDf1MgbtMTmN8e1ip8q9PXBD3Y1E3eEsQ	359
18666	2vbFv6tdDiwNsJovEbtCGRVKZbk799yicKBzbVqMQD6hGyGhqNvU	359
18667	2vbNJQxW7zh2yggcUUB58HTMUJ4gJeWoh7QM2rQSjhyKWx5AnEqL	359
18670	2vbpFzMpn65w3knGYZKHkVwXZYJWaLBBURFmyYCBzMop2bNede3d	359
18672	2vbYdm3g8KCKNPDtTejygdEGMJikhqbhetXpEGmJqKqAsM2A9vFj	359
18673	2vap6KVMtxEaRU57GehcC27jHcheoyjXtn9PQXvontCdaWNkMBxw	359
18674	2vaLDw3P2iwpFD2AgXxESg4kd6CxtNnKNSm374SRkXbciob8wVwX	359
18677	2vaM9SBNpCvYtDuEEC4fRXYo9p9NgWDaZVFoC75ozJRTsNk93hA7	359
18690	2vbQ7BscSjDVyWpFpgpuzVP4VGAsftQvd2mdVUPQ4uKTtjPyotAR	359
18693	2vanknRWfscJnjyv6aydxEcnDBX2VJ64Csq4kSdUYoRSbdN4B1BH	359
18698	2vbGMg1hruvj72SGYRYN1LiJ6GWnQycZn2J72djxf1Sx9vcguaZj	359
18715	2vaEYKFZv7cpagZmfgDVizeavCZbAyYGux6ZADufNwAbS5w4VrrB	359
18726	2vaVo76EF6NeaPpgsAYRHdrjRGTHP1Ma94Bd8ySBdYEguaLLG7iP	359
18729	2vbbeYTj6nNAuFGwSLF7tRpAuDUvo5LsxXFg9MxEatFYdbb91TL8	359
18732	2vbJB6g6raLAFz4ny39tZur4cgAQdpzZBSsC2CUsAvyrpg8YhmBt	359
18738	2vbdLSGvRqHN2H9ZYEof7UAHtZyoHb8SWGvMnN7giJ2cDu2iNC8r	359
18740	2vbMpvNUufJMSugVzzbCwD6Ump7ikQUhmS9q33V3bgoZYtnn3p3b	359
18744	2vbmoxqrHevmwuDS8qLTsRotkVdfcbuN5PkzDEJgzwhma6e6MKH4	359
18746	2vaKgNQq3MCBWX6Lu2rbvfgyT1n2fmRbuzY8grFVMYsXc5kGajyy	359
18747	2vaWoJbttE2ftBRZ5G3xvPkaK6gfEpMDnmbFBZntzUDshrxPNxtW	359
18749	2vbPRugb6AKm5vScNwTjQeyhVy5TDZ41moxM865ZzMyyRGFmriW8	359
18752	2vbJnP8woy3WxRyY1PfEZ9xK5SqpKeDCUUqJTjLfPYnvxpCo4Dg3	359
18754	2vbd4BUHt2e365na4qKTNtMgKUKFvPGHCwPcn2GQX3bu6PW4rMyJ	359
18757	2vabvmvJ8CX9JofNM9aErJpegBGZgSzCoj4rvrMEPbKUcmKp5PtW	359
18760	2vbdLR6Zg7wjDXSxLU7B5dbWvBd7B9dxiM13aL62jYNCXhWaxHeB	359
18765	2vbXZGt4sJRCMH5YG3gZxtXyvnVmouCFPRVqA5uAZatr3WWcXiaX	359
18769	2vaxwo1mU6k4V5mwdsv8ex6dqFCtNb4ZTtGGpYgV5hVNfNJe4EDi	359
18771	2vb62g9tdrWFbbzVAHYA9vSJArCTmxMReJuTMrDXkFgTd7AbkQPy	359
18774	2vbCsUDzJxvppULMbvst42pi7EuMrrrt3LKmem4AMgGVcpNiKW2E	359
18781	2vbZgDbePPB2Yu7Agy3TgUbABAGLcVSNYqKKeJUsSNSarp6ATbhA	359
18786	2vbQPqNrnekVuy8DJYME1bgsgEBV3Xy1Tx15SqA6D3kwWhEcSZbP	359
18787	2vaffJZCuMA6GpRytar94agNtzN6Se1TUd2iSdP4DgJ3mbJyVR9E	359
18791	2vb4TKeivEp8UVPrnvvgMToDP5wKfVhRUJwfv1V6tc3efrHP3DjH	359
18793	2vavqsaEkH4AYfWaonCukg7PH3ESvf6dd6TqF1zS4dRTPGBFdGmC	359
18801	2vboockkoVaTqUKThT26SP6ZayqZzxnr7oEd9WknLCohS5FzBcUp	359
18807	2vasUwhfyJHvt9uu6dnwTSBhdhXoLwRyBReorgQxyUBNk4813XWf	359
18810	2vbepZNG9ffVDdfJY8UhenxyirEnvZGtQ7vdzX7BCgkMfvUtPSag	359
18817	2vaA46XniDi1DyDXiy59PVCtRvkHjyuQxjPNQiVL8p2xt5ags6aP	359
18821	2vauqw3Fc25ZBfqU6jwCFRcju2KzgPUynNdC8AgGrKsKLbdPm4Sk	359
18823	2vaQ1uiNo8pptYPwFa2EDsdSREYYshBJAFyuKjvYyr73KSXZN6ob	359
18825	2vayMLRSLMMhUrfzfMN8KTuNZMsPFGFUqYYcgDkV24eXKLjnJ9J8	359
18828	2vbyv8X3N8JoULopwiKkScnxmj1RZexPuGVH2rcAbq8UVQX2uLG7	359
18830	2vafCZ5725HNQuFn1C2GUXz8Sde3fko8XChsPsm8swwZS891tvgb	359
18833	2vaRFoAk2FTm7Sdq35ceiAGd7hx2cLN6oVL7jzcbJMbuJ7Uupb4z	359
18835	2vakmRfeTeoPh6bgHar4zjHwQfxw2dstV5mJFJUDeR9nHRNTKLPt	359
18837	2vaWZ6maRLDDxhCDhP27mKVPV1P5BXTrYBJpa9MkECQ45FN6u1JH	359
18839	2vaKzqbmYiHdGDF92KQFvvKiZtNCmQE3CkoPAnzYPMcw3heBaq24	359
18845	2vbqjzAUHXFrN1sTgZHqzS6UXCWCB7XZLSs8d3UKE1wdcsWuCJzC	359
18847	2vbon39RbEqh3PepC6udMpzxiE6BV4UrMnajyWGpGyWW7Dyo4YnZ	359
18848	2vb1DTqBhBnCYVf1hchCFHXhfiwBzj4U2BUvpt1f9HM8843t4ycB	359
18852	2vbbfM3hv3CqATaUc6R6QL4JkNE71q3JmXMy8aRxkQpsFU6apdoz	359
18857	2vbxH21U7h24sqzN6VCpvkkxRNkwLa1oY1MbkHkRRm2XFi7jRNRJ	359
18860	2vaNZc3m8S8TwcdsRmvnws5uD9vbgJq2XvWobtwBLdxYMpZYihuC	359
18874	2vbiNdy7RE5K8Ri7N48mBDNMdq7t2X5schSUunCit851LVc8Lrvv	359
18882	2vbw6v5tcUP1v1BPfr4Rx5n4NfFfWnU7HCmgovzc3hZBXMcQQccq	359
18886	2vard4fZEMiu1oYnMF5Kar1UAFFPs7z4YbmV64f1LmC2ixziMT55	359
18889	2vbuQMU4cKnbsvtLZdyztEj29dkcUHot1UdoxUGuxGhSXc1eHkyZ	359
18898	2vbPrLtw4Tt8JEZdNevijEW5JpZj92TLebJoxjWcKTKA8BccGqHG	359
18901	2vaNUy5XsvnaFvUgmAwvhZNYgvpqumtxFP7mk2C7bJPny3kUCwb6	359
18904	2vamJsRU7a8PSSYtQBGW38S4HqpYHgjVf3EDaJz4pr9LTdUrLgaF	359
18913	2vbjRCoSwbpK3b1zjrKsRJ99Q6GwxcKhAk8Py4HCh2h3vLp4h6qj	359
18923	2vbGNjEJVuMgquKWcFATsa1uPd3iRZ9RVYKU3ysZ6SfFioZF539n	359
18930	2vb3mJsUKhk3EPQ2zPs4yxsxV2qBAAq2kchwkDX8yfLtgWRXbbHz	359
18935	2vb32HTgsj2ktnNLf99qqjSSANFXKmANJj9Thwq5yTQquYTGwAQc	359
18938	2vakdQ7rEBKCFW3Ky3zGD3E5kpZNLbCkEEBx8NWS6D6VeTyuaw9A	359
18940	2vbDWW5oUNTyHtbN7QaH4XXQJfg8WbsxzEsQJw9NGU8SqjS8qaaH	359
18941	2vbh2VGkWyQwE74CFAtHM6Zs6cRxTCftyG58JA2iMATAcSMpp5R9	359
18944	2vc1GG7Co7EYAcNDy4kwxr6G7ENfBvNMvSi9zm9pjfN3d8sacj51	359
18947	2vbw4gzD121aXUguQZuJcUsv16nBzGLj2teZGrzXsN7PUpCFRMUF	359
18952	2vapnTj7YkFmiVeKpBFt8yUBY6P9b2JwVKjrpyCQmyY8EpwBPQhT	359
18956	2vbMM4HuoPpCvx8DUGrAwcqCbe41VwLuXryjyWn8kG456VkjofPo	359
18960	2vaBvdk4c8itkd8d5n6t6vRsm2dpYwabwYuG332WFzvxiF4HyG42	359
18967	2vag2CTL5t9pwTiMdHbgVaLaBpkceEzxF9YGCeQXMrg2bQtdWsZe	359
18971	2vc4YBWYBHwoxADnWkaSb7UrAeZq1itFGH4Uin4MWL65BND1HNhL	359
18962	2vbURfTVqFmspuNh3x5svgFrXPswDzur6bzyp8aTLLktgP5Xpskp	359
18966	2vaBQ3Bw9e8icxqVtZgaZ34QcrkA5xL6tmc6MTM83adfDFpCMJwZ	359
18973	2vbbZjsujRDu7nEaRwwimEkijwTxZbL4rtG2MMvkSmzwUYYhYSbH	359
\.


--
-- Data for Name: internal_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.internal_commands (id, type, receiver_id, fee, token, hash) FROM stdin;
1	coinbase	1677	720000000000	1	CkpYRmaupHUoLHAeZ9v6S872Au2A32aY7R5jWB6bZXT4JYzX6ojbr
2	coinbase	1679	720000000000	1	CkpZNfEqaC99KyJVtUoh3JQQM59ox5w9o8q9V9CBEP8KZuXFVpuv6
3	fee_transfer	1679	120000000	1	CkpZTUHQiw6akH2nhGgq2w5Ha2CeKZmxYBPTRsb8W8XVmUWHCw9Be
4	coinbase	1680	720000000000	1	CkpZS1xXfPHw1VfUy5mdwZifcRLLz2pGPjo6o8zr8ovV3zFwsKXtn
5	fee_transfer	1680	60000000	1	CkpYQnxp4AVgRiaj625gG5Kw54ayD5Az7ix2BUCdWrEDPZuJeFYrh
6	coinbase	1681	720000000000	1	CkpYbrLChDdJ1fAFJLToY5BrkHD19ijqsaVfanQyrQTHn44dpgfF5
7	fee_transfer	1681	70000000	1	CkpYT9wVjnDxawQDkVJKR15YoErUBz3HUqshpiE94F4gfrvpSwSFq
8	coinbase	1682	720000000000	1	CkpZ42VHSG5wN2VCkWCXnwusT1D6V9Yc6nrRePViZHm6aQa9oK3aG
9	fee_transfer	1682	10000000	1	CkpYXWcQFXRVwML28uuc48azaLEPzkqWrdsV91L57Xoo6nRhjAE9K
10	coinbase	1683	1440000000000	1	CkpZMUyZGCwp85AwdtWyZnWXJ8HV8GNjq1DuXeXxbeaJbiJ8WGnem
11	fee_transfer	1683	10000000	1	CkpZPBZwJ3rr44wztQa3QxRtDzqEmbCrPuCxZwemVMFKX3QYJ5f1n
12	coinbase	43	720000000000	1	CkpYVKiPtfvfcGvbc91coZ7uCK2bK8ZpJBAvfve3XsF7AMgsxPKmp
13	fee_transfer	43	10000000	1	CkpZAUHEnzUvRsw84yHSnhxHJUBJtE3PqvDc6qvnfZmHwqn5zL3ae
14	coinbase	1684	720000000000	1	CkpZ321LdgDeAQ47VCbE7MmAfhmVEceENUJ7dP8iy5u4oG5pSzZeE
15	fee_transfer	1684	10000000	1	CkpaB6EvDeAhSarwTayqYUmjGcKY79BHpavrx6bCwMozKr3oB2ErB
16	coinbase	1637	720000000000	1	CkpYoVviYZmJQQpRuWo5EK7uUBm6ikRKUDLzAjna28UmtZeRQF9U8
17	fee_transfer	1637	10000000	1	CkpaHvFPHvPjPtkoaKZCoYfbu3mfPd4JrZ3oHNBq3xoCDxQzqXYYY
18	coinbase	1685	720000000000	1	CkpZJ6Wa5Q2qmnUvRvZdcm7kHxWT4JekwogLMD8UCuzr8AUnnohDs
19	fee_transfer	1685	10000000	1	CkpZdGSnmmKBANmTRHdvXCkrmcMNgKKtWmxAKeKwS7jYcjB3kfCd2
20	coinbase	1656	720000000000	1	CkpZznpTBzmCQ7xz9KvwojYbxxVG2qHV35XzfbtWnrWU8ECU1uj6Z
21	coinbase	1652	720000000000	1	CkpZAmsR7qBY8W6dfQvyxjWyimKKthgo8JnB4LDAYWv3WdMZCw62j
22	coinbase	1577	720000000000	1	CkpYxF2RMBZKmGfsrZdtUkjawpV78VaWD9WMMv8bJhvCy6jFRiCcc
23	coinbase	1686	720000000000	1	CkpaK3o7APCaUfMJzB3nfwu1rn77SDAxCuHEnN8hvtLnnsrWVDiPi
24	fee_transfer	1686	20000000	1	CkpZnaJymMZjvjAq9kZWi4znz5jtvo9nLQHTKEV983jktjPhoUQ8R
25	fee_transfer	1680	10000000	1	CkpZRTWf2y8n1K2v64vtvawE8M6PyYC9BNk39vUS3rS27EWgC2hvU
26	fee_transfer	1679	10000000	1	Ckpa5N98xk4KD2T3SpkT2iiTtdhij85Krg7d2YKqC58Vv4Qrz1QQ6
27	coinbase	1687	720000000000	1	CkpZhyJtUC9cknLdDCrR1rcbty7PC4X68Sp7fRiSyUEgwXkABNh2w
28	fee_transfer	1687	10000000	1	CkpZZWHTDLuWABEZMWzGtHMLmQvjqz1ndBduTb9TWZW6Lmek7y7Ua
29	fee_transfer	1683	20000000	1	CkpYw63QB3hUqZrrKi83UG6EHgKVAVXrUo5RvehP22fBUCRoZaZHt
30	coinbase	1513	720000000000	1	CkpYYm4mKS2ADerjX1NwbzbFsSCP6KQSGfo9vJrSUrYCo7MsvoB13
31	fee_transfer	1513	20000000	1	CkpZnLPHQpzBMJocZChwvCzEaYrD2Yh5cyXPZK3deL2t8PcLNbLzA
32	fee_transfer	1656	30000000	1	CkpZs8fza9Lzw6mg92bguPz6xayNPd8zn5NNcRngKRxd2wFuMqmsE
33	coinbase	1671	720000000000	1	CkpaFKiQPNuRLDn2kCiEC2u2q3QT6jrJXofcyGwU1LKrcHhrA26ws
34	fee_transfer	1671	20000000	1	CkpYcoyHXAX9tmkdHdGuUN6V7CkgPH2bSjC9cpMxCbs9nCU8U37fz
35	coinbase	632	720000000000	1	CkpZHBQkUJrBg2M7w6M4Tq7fKvgJPRsjMGN3jQCxD8H5AgLWbTEx6
36	fee_transfer	632	20000000	1	CkpZpiAUvBLppenHEddirBiv9cviSzax9NKLZ9V9SQWnpZ9M9fgZg
37	fee_transfer	1682	20000000	1	CkpZLeLtRoZtSSVSw9FKTEqBYsR7T9JgU5m4KDNNNpx8Eb2AtwBBF
38	coinbase	1476	720000000000	1	CkpZUc9u1aGuGZ8XLjUiJchza6JrW9E2fixjvrxUnwq9RBo3wrCkL
39	fee_transfer	1476	20000000	1	CkpYigm4SURwqqNk9wC3oTSLGTWFxQBDd9e19MRWigxhaRceoyTeS
40	coinbase	1688	720000000000	1	CkpYR6Dtrq3ijrGBvg3aCzBdVPqcMGPYkUbLDSzqNETThje1c2pzk
41	fee_transfer	1688	10000000	1	CkpYepfPk1HUY8uQbQ8hZtzBWYRAr1smndMZjGq6qB5ivy4vEvrmF
42	coinbase	1634	720000000000	1	CkpZcmzdi1hczBorxKGs8ucbivSRFwUA9vN4JfAyd9Vb35hqoPoig
43	fee_transfer	1634	10000000	1	CkpYsKadq247kLMbGPTkQauj5JKZCwTVZSW7bL82HA2ts5AGQuqo2
44	coinbase	1474	720000000000	1	CkpYccAdSrsTWkhBSh8JFJMV7ZPWWZMnN8gxy8UvRvdUJYuRdzMFA
45	fee_transfer	1474	10000000	1	CkpZVQ3gFSgMBNvmwRNwNvWTepVZcNcVFPBbBHnos9PusqSwW1vhe
46	coinbase	55	720000000000	1	Ckpa5c4bqc85ykDeLGJRaYimRzwTpcRQfHfWcEZQbZVVDCrdKJrpa
47	fee_transfer	55	30000000	1	CkpZYfpRGdijvssN3Gsv45Rq3bXg2ZRwHn1nPsA2tSFczoyRqfF8R
48	fee_transfer	1677	30000000	1	CkpYePgBvpCnC8mCwXarBfGTH7JwHa5nTcE9Luk9YKbQ12W8iZG3c
49	coinbase	1607	720000000000	1	CkpZMUxWtkFnyyMLhYgjnxC8APXN6Z95TZPA4fXAq9D9Kji3CCXVK
50	fee_transfer	1607	10000000	1	CkpYVsJBRMJn1WEVPUZVAwJtVKCNHFKFyLG7u77Ez8dZMor3FxB5J
51	coinbase	1689	720000000000	1	CkpZLviNqbEcY6CBcZeqkg6hg23mq3BiqNohjByZhndXQ2dNsPRpd
52	fee_transfer	1689	10000000	1	CkpYSSDuerTQiPw8jj5fxgafrwh6DrAzVkHJWTQjfXtphdmQ6XFAi
53	fee_transfer	1677	10000000	1	CkpZFyqYoKC5XnPHty4qufMfPiJVE7MLUQVG12xo3j5tcrKXMv1g9
54	coinbase	1654	720000000000	1	CkpZupKBtwGYReqXUarM2GUsmpD7bszhX1kC3cGETG1NhZKHRxizb
55	fee_transfer	1654	10000000	1	CkpaFKFVZ3vNpUpNMtoEnvNhDeo6h1B9MFg8yHm7zK9547RSpQuCd
56	coinbase	1690	720000000000	1	CkpaCVdn3toUFsxtEud1nvSowYaS6kdEBDsWsDFHSsdooFjmZ6XHo
57	fee_transfer	1690	10000000	1	CkpaKPzhon2Urf1kuT7cc1rxLDVqpNRMfNfUZv8sZdbAkfHJRx2cA
58	coinbase	1447	720000000000	1	CkpYikAUgYcx8CZX4ZCDJm4AjPhFEgo2nimaTBCjRTahvQGBd28qU
59	fee_transfer	1447	10000000	1	CkpYmU2nn5SgdUTE943yEZpKgxqNEZCK96arBSoP6zHdDJKHtmSvJ
60	coinbase	1546	720000000000	1	CkpZY5M7cjqSLdP52B51yp7XhfDA6oPWZMLjT9q3Yn6bJie1VsZ3x
61	fee_transfer	1546	10000000	1	CkpYeWxFEKc5qE3somTTQBFjWREN55kzNTVpCnrPxQHbCKCKQGihw
62	coinbase	1547	720000000000	1	CkpZ2QXE3PciFpJd5C12nDceFnjrWdE83sNhBdmnm5xMmWqaTB6Dy
63	fee_transfer	1547	10000000	1	CkpZhXcNSydLVBpbnZZSa8oYwXWoT8xRinAdrNws1oTD1e35reK6S
64	coinbase	1559	720000000000	1	CkpYTj8UjtS7XsuT7efnrCjy3AbPtFbkrFrBVMhK2aMSEs29ymKxC
65	fee_transfer	1559	10000000	1	Ckpa2FUBoNw7aLJs5EUc5Mh1rvcABrF2DJwS1uzRbngHRWKf28otZ
66	fee_transfer	1688	20000000	1	CkpZTeeEQw6UZ2aK4b7SYWk6yrZ9yvsUbNBxDrGnQXKax5hnJTZvk
67	coinbase	1573	720000000000	1	CkpZXFjbL2S73aCBoQSrAzktfBe4HNjQYUCd4hWwXaGt8VTpXN7dQ
68	fee_transfer	1573	20000000	1	CkpZtRyg943nczQEetLYb2gRaF6Ex3JjaHXgxmJtW1jVuwtezkKpV
69	coinbase	1602	720000000000	1	CkpYz6KdoVRPNh4SerbvoDz3zMbUj8wpoGejshFHdHHkSYfHhJLt4
70	fee_transfer	1602	10000000	1	CkpZMuZmwrtPL2DXDtA6yij79oTjR64qY74Y8cJqgJaHB96dkHZ6Q
71	coinbase	1691	720000000000	1	CkpZoNx7owPQvbtNGeebFzmCK59BhoTVaWFyYpJEexCv1qJ8Gg169
72	fee_transfer	1691	10000000	1	CkpYjcVLyPcZuxzCZHCUf6856c7FmUGGt7v18DXF7kEP2KyZZrr8t
75	coinbase	1692	720000000000	1	CkpYaNYP3EwSBniWemtzEGDxrRgxTV8Mq1YqZkNYNAP4pxFRy8dPr
76	fee_transfer	1692	10000000	1	CkpYUReTqqiRcKZVnioUvMFvx8Ly4xVnGof7bqw9nseHT3uJ1NVqL
84	coinbase	311	720000000000	1	CkpZ22NfKjciYxHZX5MhXRo6m3HmBPUGRD8o2xt1qtVTHV2tqKWGh
85	fee_transfer	311	10000000	1	Ckpa3k42RyDKq9bLn6YR4D84yU5928jWBpGcBdETdWuJdVUpq5Bpm
92	coinbase	1458	720000000000	1	CkpYVoEhMjJ7C2eKYsg5SNrGL2F1GrWtogKVLmptGBk91owXepXWp
93	fee_transfer	1458	20000000	1	CkpaEERJDMc3rRLSoiD5CQvWqwKK2JSeff7K1VoatRXVqgqEePnAP
98	coinbase	1504	720000000000	1	Ckpa66P6q1b7L64bg8YdhhyFWSz6xMbbKbhNWYieUvfYMaiYC5uyH
99	fee_transfer	1504	10000000	1	CkpYeRZSMakCSf8jFADw5CL1bQKMDdQoajJHeoMWCCvvj6cGNycJZ
100	coinbase	1695	720000000000	1	CkpYy9oXU6GHbGP3WFVSHjuaDFpVGusLQWkQjDsoqBkieq4LjWWk1
101	fee_transfer	1695	20000000	1	CkpZ68VbK5odNKwGRLTk1NrGK1GKYEm9FmhLDrv4RLDk6S2csjMWj
106	fee_transfer	311	30000000	1	CkpZE3prh3zQAfnEJg7uexxshaKdN2pPqLqe17MMnChj8tdmyn87F
107	fee_transfer	1623	10000000	1	CkpZcLTq62EVBzHLfEhETCjhrySPYfzfq3M4Cx8c6oE2M4HVW7kZT
73	coinbase	1587	720000000000	1	CkpYjFDSJDEZEcyYeHFY53FPQau2XDW4M3YsjTNZf4Jj861ZcKAM9
74	fee_transfer	1587	10000000	1	CkpYUXL7suvVuSpCxkg6hohvmsKfjjU83XHqhWLVahKNQzJRoJ6w6
81	fee_transfer	1693	10000000	1	CkpZDhe1DigbeQiH6kd8dGynCjedSsgeBTPrSE7pL7jnWQUeeCtet
86	coinbase	1622	720000000000	1	CkpZZWqdA87JmPxHA5NmFEQ3qh7pUmqXi9GBWzf4pADtPEHQAeH7M
87	fee_transfer	1622	10000000	1	CkpZ1WriVr3Rmhg2GXafYcCT7LzH8c8HaXaYTSRbdSTLatgp4sSEk
94	coinbase	1623	720000000000	1	CkpYTGN5HkaCBms1BfHBnWN9DpuTRSt1ioJAcKEvQF26CbD2ZWbYc
95	fee_transfer	1623	20000000	1	CkpZxSTRZ3bEym5UFZs4pcxwWzqtgfUvcJ78EU3YNNjQVP9DeB9LD
77	coinbase	1444	720000000000	1	CkpYfUsRh4hP2VmGWd3raFHNigJ2pNeXcFZNC7Pnicy8ZYrrRHceh
78	fee_transfer	1444	10000000	1	CkpZ8NXzGJGdVBS2YhiRapGHbSiMi4rwPgoe3PbrbtuxyPBHQTVcM
79	coinbase	1693	720000000000	1	CkpZA9YnyBFKGY68a4mPAmSC1vp7oZgSU9hAbMAbb5f9XuPbwMGs6
80	fee_transfer	1693	20000000	1	Ckpa3p6pdWkCWTCwHMqA7FrSQvmkPhF2o7MMET8ghie9L8mtiHzBW
82	coinbase	1596	720000000000	1	CkpZoojAobBbzDc7Aqogvh7w6e7qvaPXSFMQnYoQeTmdM7xb1i9jQ
83	fee_transfer	1596	10000000	1	CkpZKGMWrRoDBjr48i3662bxyGEC8UVbRR25kk7C6ZreYyA3nk1RU
88	coinbase	1694	720000000000	1	CkpZrCfgWDrVLq2KekZgwc64wTKs55PBJa7A5t5er6AxAqRov2CLQ
89	fee_transfer	1694	10000000	1	CkpYW5eRZHdM866PmCnDjBnSUvHHEaPJj4Bq3dw1y3GfSJyqyNhmV
90	coinbase	1613	720000000000	1	CkpZAveZDYnTDDt2Tw1n28tW3v36ncuWVDHB76kRKTVGXEnxzrtJW
91	fee_transfer	1613	20000000	1	CkpYc7LA4NetwkwYsSktndd9Gahyw6LyYC8yziKdrqz41ioZkXKeg
96	coinbase	1649	720000000000	1	CkpYn4J7oPNWUi4b24ZxEhLLg1FpcAtrAzmJUXxK8SgmNtWZdbS8q
97	fee_transfer	1649	10000000	1	CkpaKoqZ6BMX59nsXood3bWVQrsCdkpxkZfRb2CnApi72JWYEx2MT
102	coinbase	1696	720000000000	1	CkpYV9kHtTKdgbD3tWp1jJpGLx7PrgLjvj9ubX9BkFJh8MpARLihL
103	fee_transfer	1696	10000000	1	CkpZBbgKJ8rv9Qxij3KZ1S1qHAu8wWLdDuEBsvjxEcLf9ppJ5v5Lj
104	coinbase	1624	720000000000	1	CkpaFbDotgK86ZmZ9rcEnqoevd7RxcUCMP9yPEaQnyv259Vo1SeiW
105	fee_transfer	1624	10000000	1	CkpYgijfhumP53Gw4paqrsQkoyKTcmZdS5MXC4RV8XoLfMwz9hCc4
108	coinbase	1422	720000000000	1	CkpaBANiMpEnTXf33Eh9njdR9DVML3FaPFxXiCfePbSCywbAZKs8Y
109	fee_transfer	1422	10000000	1	CkpZMTAPdzVu1517FzjW4w9hiHC1GrmG7hhGiiBsbYp7MFiRzYsfa
110	coinbase	470	720000000000	1	CkpZV1FjTXoVMpwhf9YJ4TwdNpVBeBxYdvxN3UfCWpa67CCVYhFYN
111	fee_transfer	470	20000000	1	CkpYmkCozCG5jqv7qshM337s76JjdeL1vFQiCZnLH7PxtVf3HtnvX
112	fee_transfer	1677	20000000	1	Ckpa1jxDhdJZ84YauWD6tumigM9N6pQX1TuwqjAURYNZMdaBw7MAT
113	coinbase	1698	720000000000	1	CkpYawp6d3aYSBA5qbpmpkUbSKkbiABWT8xiBvVHXmhXHHCsAWuJ6
114	fee_transfer	1698	20000000	1	CkpYt2bVCWQGMxNXVRSWtu1pDcerPkBzwCc27hf1FzFHn6xoWRqAp
115	coinbase	1489	720000000000	1	CkpYhzeVC6Ak6yZwwqDD3gec3wniTCd1BzPM5FHpZwBEoxjTJTCAL
116	fee_transfer	1489	10000000	1	CkpZA4KcGh9hbYMqhoqsN1HtYXrjuZxGXq4CpQFqMDkHP8wSrC5Vm
117	coinbase	369	720000000000	1	CkpZR5ZznctzKKKryNyQkMPxP3dYRk1VpSfsaUtmNaKhxKjNubBRX
118	fee_transfer	369	30000000	1	CkpZBsNTJeb9Qvi6fzbADf61LxeHNKUoc9Nr5HMkAUDDqmKUDBhwb
119	coinbase	1699	720000000000	1	CkpZ2Gp4PnQshCXBQXjCnADn2dxySiZcL2Y5cjTfrhGWyueAVtnK2
120	fee_transfer	1699	10000000	1	CkpZ3kG3zzAjqeV94a8gz9U17tsx5zCJRcX2HSatTHBzwiwbTja4M
121	coinbase	1700	720000000000	1	CkpZcTMV3k9d94Z9gUcafFU892F1BmQpViTwN4EtrSpC6Bw8BioqM
122	fee_transfer	1700	10000000	1	CkpYbHnhnP1k1tinic3T4MvDcGCAnaLPaGpSkUJmbcm6V25Zj5y9K
123	coinbase	1440	720000000000	1	Ckpa36xKcWrr1ascDAax846ST5qzbkqYXsuTs49QUmkVR4Bmg1ugM
124	fee_transfer	1440	10000000	1	CkpZiiFnRUhnfFdVAjFjadbZw7BdkYgv25udySJKJzhZCPqyU3C9C
125	coinbase	1701	720000000000	1	CkpZB4gGUhgo8S64mH7GeH1J4truRLcdp1eEix8gajY6eeVoZJxdH
126	fee_transfer	1701	30000000	1	CkpZmVXM9UHYLSFLoGuPgT22NmRNPkcB1VYPVLAtJCJJeUttFs9Ne
127	fee_transfer	1685	30000000	1	CkpZ52FDVADisscaEXq3Wg4xa8ukaKFVp1gvYQH9c59TVHr62jjjv
128	fee_transfer	1688	30000000	1	CkpaCwTa5wuGdPaRzPWrEgK7M4sMzEk7qvVpXPWLQ24XDdz5jvXLF
129	fee_transfer	1699	30000000	1	Ckpa9944nGrECvtijKH9XqRwrFqYVx4BXwaAjT917JGJavGMm9Ga8
130	fee_transfer	1559	30000000	1	CkpZ38ooMCV4yY8meXxcmQDNiQjW3Uqvoh8meFP5HCuYesz9Y3UmZ
131	fee_transfer	1679	20000000	1	CkpYgcv34nYgivALfC6GcuVkG78Ljo4eASJXioJasq8QvqBJ9vNSr
132	coinbase	1419	720000000000	1	CkpZnh2wbk1AfovQz2pcazFnusPf1j898bfHj4c28oQTXDsKBaZng
133	fee_transfer	1419	20000000	1	CkpaE5jzWY4W1vSZBBKqWnhGg7vroAP1zAdR8m7MpEkpuc4CpzyfL
134	fee_transfer	470	10000000	1	CkpZ9fj6GRtR4dx8jhrrXMAkRU2zHjRF9xfBSW74yDxRKsDqqFM1a
135	coinbase	1702	720000000000	1	CkpZUg53zPiwB9pEgNPmnAhxmPHrD6r1fVx4xfRoq3Rn2ddcxC1Z9
136	fee_transfer	1702	10000000	1	CkpZ1gwbchGJD5fpT2zoJUtDNyN4cSWZCiUNKfYCQcm1Dztw6EifM
137	coinbase	1703	720000000000	1	CkpYwc61DdXYRoBj8PMtLZRU3g6PtgkgZSyHYEBn1hxYfDbHkp6bY
138	fee_transfer	1703	10000000	1	CkpZmoZTtdQR2S3yR89pFDDpFLb7oV15xs3fbDzbQP1HGaamGMHuV
139	fee_transfer	369	40000000	1	CkpYQf7d17F4QuJDRXVuPR1RTRK8U7t7wkPrbu621TWW7QmNuxddh
140	coinbase	1599	720000000000	1	CkpZEg7qUBUyjkAb5EgmMSAs5Vq5DjJxFJfH61yd2CQny8A6VqA68
141	fee_transfer	1599	10000000	1	CkpYeViwpDK4BrjHtfBm1rzhnYxFcYBtqBAmTTDnaVHx57gYoBkCy
142	coinbase	1522	720000000000	1	CkpZzSguK6EmTLMYMFJzp95Z4KoYJnFyoeqbaztDWmZTqGa1sEqYd
143	fee_transfer	1522	10000000	1	CkpZtAYQZ2Zx8JfdR9jvQRH1HRmZErqdRUEKqRkSJnk89iUPdnSHs
144	fee_transfer	1656	10000000	1	CkpZJcfzZSseXZVgDXofL8ArtS4TsSYG2zXyoQYcUzDBj3m5mMsMa
145	coinbase	1571	720000000000	1	CkpZqZ4ciAxMpjKsgXjPeLnHptqCfbxNJc3Qvb1niWqX5rSvPD73Z
146	fee_transfer	1571	30000000	1	CkpZTPwoVa15gFRvNZGfCGN19Deum4Fzar2zKiKdEhAaEGjnzb2TB
147	coinbase	1704	720000000000	1	CkpZmknvc36vhqUpJ7NccbmP92inro2xPTRExhkYvX3sL5ATsBrAp
148	fee_transfer	1704	30000000	1	Ckpa3AGDTk36ovU8jEHB4nLAnoEWKj218bRGVRPQ3jL3ywwRVc8XX
149	coinbase	1593	720000000000	1	CkpZd2tYMiD3sghEfQahv9QG3ib9NUV1wVCMshkX2g2EybFJWH3xi
150	fee_transfer	1593	30000000	1	CkpZTDNtGb3zcUAnz4L5ZLCyQRg1bBpaoJ1PNBWud1TTdNT2TGVCG
151	coinbase	1657	720000000000	1	CkpYz91hnUKbgvxEAFybzxHVohk2tC9Sovj7s64drwG5JDjpMWLqQ
152	fee_transfer	1657	30000000	1	CkpZ9NiVjed65YWbsAWozD1L4y8o7LQkureSeWemNP8B3cVKvu8wy
153	fee_transfer	1571	10000000	1	CkpZvyaKMvQg1YtJ87Zh8xm7fQgb3aGGJ4QwfzXBTinXaTNXRmfia
154	fee_transfer	1694	20000000	1	CkpZiMLjHbjjkxFdLzTfCiTWN6rMnXWYnGhx44xTFuGX2PLZQWUHK
155	fee_transfer	1637	20000000	1	CkpYyhCN9FFHWVgebj2KU1ioTKmaiHBm6FNtoJ7ZBxeSCjpV8QFqE
156	coinbase	1705	720000000000	1	CkpYt8xGkkXf3gJStBt7QpUKeAtSAJWRTA9XuT3AvS1BRJ4hGjdAu
157	fee_transfer	1705	10000000	1	Ckpa3bQALVaBsNnQ5fMTQ38eYd5DULGvQKTjz5JZBReLQxRF3S8rX
158	fee_transfer	1696	20000000	1	CkpZsG3h6WpNRRT94rn5SSfP9KhAjwkpKYYKQ3ivqoQ8dpmEC8HvB
159	fee_transfer	1692	20000000	1	Ckpa9qn2UDxPY4NCA4o6rs5Y8FPGSVsc6W7QLzF5VGSwj87TWcxTM
160	fee_transfer	1695	10000000	1	CkpZLi9oqHtK9mWxVPYPVWsD71dw7Q6DAqYznaDxdhb3wiHz1QHAr
161	fee_transfer	1474	20000000	1	CkpZzH8FPywJ5F6TskGbffP8iZunEUo5SkjAQ2S9qnQcsC6JdQFYm
162	fee_transfer	1559	20000000	1	CkpYeWfxC5vMGE1dfZQm7iCYAHiAs8VyiX8Jj1kwLhrP8Nxj1YGjW
169	fee_transfer	1690	20000000	1	CkpZbUpC2WYLdnw4UcUiCKyihwnxg97tGiV1qwaLxwSifawJJHPZ7
170	coinbase	1706	720000000000	1	CkpZjSKMAi72Fp95hDvrgvpmuhWctiB8PUAUQoBeJPD5f5oBh6ZHW
171	fee_transfer	1706	40000000	1	CkpZVyNHDbSNc5Baa9tCEopLUDn4hPq7FRMp4sGhuDo8PStkD9LmP
163	fee_transfer	1671	10000000	1	CkpYu2tLcNFSvGe3mshvJgag9Z9m2nVbaNR8GihdEeZQJME2RsqNn
164	coinbase	1560	720000000000	1	CkpYjPQDpoNUpo5um8eMDfeg9jvFfD7uPVfF8LMockeGaGMVuU74C
165	fee_transfer	1560	10000000	1	CkpYWmcAs4rsYPNg3KCmKKcb6CvzJvKPy3TfKVmKwszsBx4qRt5z3
166	fee_transfer	1546	20000000	1	CkpaDisr8MMXxin5PYFLupqsWHYYxD4aPJE1NKcTL4n8xuMyNRPTU
167	coinbase	1509	720000000000	1	CkpYWg4yzjGo8QEtuuJoU7QrRQG2Y25vSqMM3SiPEN3GrZFiZbhGE
168	fee_transfer	1509	20000000	1	CkpYfUSoFUxfMwSnyRbGaLYcTtV575rQFkFjgCRfCL4BMjMJCrdpT
172	fee_transfer	1692	40000000	1	CkpZcsfJZ8YjZeVf6S4UV9uEErpj6HMadGXzGVsDUn7LH9CD5Krey
173	coinbase	1457	720000000000	1	CkpZtdruzi2qzYbVVWQ1Br7yxcAEeBbWbSTs89zFfWAt1dKwDSTYb
174	fee_transfer	1457	30000000	1	CkpYpVvqiojj1nVCxgAuy5KgbpYLKheAYeuLSJPgdc1wH7bGFCDbi
175	fee_transfer	369	20000000	1	CkpZG98QXY5ZHndgCuvNZV5hihrXCmBSegqhRWax1jXzT2b96HbmA
176	fee_transfer	1652	20000000	1	CkpaFyGygi65vF8QXixp51sWaNbiLY1AmzdaVeMYPdHfjVvjxS84d
177	coinbase	1518	720000000000	1	CkpYpox13MYoDkySZ82WzKHVzi6bw7qQ1oeUkcp2HPsH85AqUcuMu
178	fee_transfer	1518	20000000	1	CkpZuYDocYTu6hE58W3JavMAWThtZTtUW6nXbumvUTWpZy5JNJ5b6
179	fee_transfer	1681	20000000	1	CkpYWnvNiCigVNVoHCatob4oyF3sMea1vtP3SJqoxeS8LYZnc69SV
180	fee_transfer	1458	30000000	1	CkpZ7M8QK4Q8qDQu1B4v3xPpDCdL7ebLeaczx5VB4NrMxQJwuwALw
181	coinbase	1708	720000000000	1	CkpYTCLpBWPvYKRPhA4droSWhL6a6Hwvm3N9q3CDeUYoUcoatzTMC
182	fee_transfer	1708	130000000	1	CkpZBK2gJK2g6MQtASzkFJXqkwjwwg5SEyfK9fbftor4QekzPv4S2
183	coinbase	1396	720000000000	1	CkpZ4Ps5ngGdzJVr4W1Hoiu11vEf6WTHBvp9keWZGJ2o939oGHnns
184	fee_transfer	1396	130000000	1	CkpZdasbx1GBx9FyhSAwaFEakWXi8PqjfdaQgHJB3nUAB3124SM65
185	fee_transfer	1690	130000000	1	CkpYmo98XfCh4zmT6Ur4VFJh1bppseMJaX9ibavpPuetbQiLxTu5Y
186	coinbase	1709	720000000000	1	CkpZFis8DS4dYHreLDFMgxt5jWyB58NXTs4hS1myp2HiYwSaNe8tm
187	fee_transfer	1709	10000000	1	CkpaChAEtgNiFjPwibZBNELwwEhLnbRAoZAbWeQhMSCgj6XAkuw3q
188	fee_transfer	1701	20000000	1	CkpZTGGkmqr9TEYjxx2EQK8Jc8btr9KyFhq1XbQEJvWW3NUE9eNCY
189	coinbase	641	720000000000	1	CkpZkDYcumuoCUwz4vc45Fvmx9tFCyzzWdqXjvSg5gYuKtY4A26qz
190	fee_transfer	641	10000000	1	CkpZUYKZFRFbCf34qQRHaDxVYPjg8wBx1VrtGbbhWbshokibdijwm
191	fee_transfer	1458	10000000	1	CkpZ67t2YH54zvmEDwGPeL2poXsRcd7WoQFt3hgd2AyBsYcbTyty6
192	coinbase	1467	720000000000	1	Ckpa93BgVy5sKHEBAgoSaPXUHMNuAjPg5Jx85Koo7H9nqRjVZCNyW
193	fee_transfer	1467	10000000	1	CkpZYhiPaRVKTRcHHn9arXf3i3k1oCpsYrHyVxrRqCb9ziEHTHovB
194	fee_transfer	1681	10000000	1	CkpZLEC6jtYZWmWZ99uoWsEwHPdBGajsV3MxAg3m5JRD79ALujzuy
195	fee_transfer	1701	10000000	1	CkpaGgx9yjniN8w9WhdEsFbQzM5GqWSY1VyRW87QsotQquXWey5B4
196	fee_transfer	1702	20000000	1	CkpYjFpYqQru1tX3xShCdWVhxNJFQE3wE1dHKPo3wpg4BKJ5MLMLF
197	fee_transfer	1703	20000000	1	CkpZ4TGGZ7V9ZsBEYigyFNtcpX241DoQZP5Tur3gWYWgJTL5koUQa
198	coinbase	1549	720000000000	1	CkpYeWDxHaJdPN7t6qhhGytZKT2tCvuJZg5sgY624FDZpuA5sKrcN
199	fee_transfer	1549	10000000	1	CkpYSFGLQfPYLmiFL1a3SareR5ozfXnXL1LMqcwMuxnf2iNFZpR5U
200	coinbase	1710	720000000000	1	CkpZgU1f1wniceFmFnyKpNQLnByirB5DEeJyMawn4KoSaX7fHaa8C
201	fee_transfer	1710	10000000	1	CkpZ8mZ67L4RWYbeeqrybvZ4GkBDK8v5Bvpu3XqEnSXcV8akMz2UP
202	coinbase	1668	720000000000	1	CkpZGsfn2WVtveuoJ2hERLB38fJ4u3LdU7tsTyXst6XZxVfSFArZt
203	fee_transfer	1668	10000000	1	CkpZ2hPj8ygH2NH9j85WVBxUrLcVQe9jSF195VtnsApSpqqy69ncB
204	coinbase	298	720000000000	1	CkpZ8EFtjg4iW3wUCdMrZuhCRPrkrrVGg4dSefTZcovJZyFnvjkVk
205	fee_transfer	298	10000000	1	CkpZE2ke3tc1KvL5Y32reijJJCDk24LqbGJwb8tvhWfuz3hsAi9jB
206	coinbase	1611	720000000000	1	CkpaJxpzqYCv5tVMimh5JXpZ9EA5aRuE17nk4ty9ZQjTNZGmFaqUG
207	fee_transfer	1611	10000000	1	Ckpa5Jr2sDfouW7nYyda7ifuCKzRmY7rsbfvi1gGWLKGd62hB7n1d
208	coinbase	1541	720000000000	1	CkpZr8Bdx3pfYEMH2Yp94pqaif5HGEdivs8iBUBLZHwKNXq9j3CiK
209	fee_transfer	1541	10000000	1	CkpZ3Q3Lr38oobcsgiaQii8pYG7UtxpRg4payV9MfyBapiM5271M8
210	coinbase	1711	720000000000	1	CkpZLrVGLifUZWTXzPseMJv6BQ3hwDiEWkgDr9ypRPCoaNbEFYEBY
211	fee_transfer	1711	10000000	1	CkpZSZTQwXnpeeMtoRyNhVC821SPZh3T2FHYkZxPJwRNjPsGvmuh4
212	coinbase	1506	720000000000	1	CkpYkc2PpDoL3i4dpYBzu4KDUU7Ej6Qgkwkhqu9jBVpxFFfw8gqFT
213	fee_transfer	1506	10000000	1	CkpYSNFyNtQeGkc7769RF4UQ2n8S34sPzg7UjzoMM4n9zQJVQ85Ec
214	coinbase	1601	720000000000	1	CkpaJrQGpn5sheuP1ciZj1963Mv1PuPVtzpptxpDApQU14CJh8S9C
215	fee_transfer	1601	10000000	1	CkpYrFSwF3AN6Ub3XKhi6jCy4XW8jBzgi24RPu4mkmScsqAwvBaWB
216	fee_transfer	1444	20000000	1	CkpZZty4UEC4aVyDag2fm9Eia8SRL25z6n1tBnNRxuZeqBMZfRh9e
217	fee_transfer	1686	10000000	1	CkpZTcFfN8uMGgZX9Z715mwgXCqMNbee1bFwgdMXvNV4PuY4pmEwU
218	fee_transfer	1685	20000000	1	CkpYoJsHJpX5dXW4d7APhiCXByizWDgnP5NLsRRftAJpX7dvVUERp
219	fee_transfer	1710	30000000	1	CkpYqJbEDvNRisWsE9GwAssCoQnWU6SYnrMyPnLW7MsFP1TES8Tjw
220	coinbase	44	720000000000	1	Ckpa19UGNenWSz8zpH77LuTNa9AzogeWNDuBAu8HDcCdwKKsw15oS
221	fee_transfer	44	10000000	1	CkpZbescwCPkhMj7ZtVX6KVxy3CQJpnrhdhaoRdLXUZFF32Yvk6mZ
222	coinbase	700	720000000000	1	CkpYs2Pgsf6ieDn1MLxqmrjXXQ6PKaueZsRHfVj1M4V7qyxoWeJA6
223	fee_transfer	700	10000000	1	CkpZux7xvHjTZrcGmqBk289B2Bni7gc86R8VTbDZTEaDA8odxyL11
224	coinbase	1610	720000000000	1	CkpYoX8GCF3f3D5v1VzXFHHKax6KUfZVgp3vSgjiPC3rvETmMGuYh
225	fee_transfer	1610	10000000	1	CkpZzAYy4Z3QdC1Rey8E948HkdJ334vKEii2A4ie1eoqQP5x5r1c3
226	fee_transfer	1560	20000000	1	CkpZ5771x7cxKcrUDUV4aUMB4GUZwdfAEBrQmucpqjq9cYkmVLjtj
227	fee_transfer	1601	20000000	1	CkpZ8qxakVWoQAf28BFYLsd4NvmLLkcArakCUsLc7ZAeAD82roTnz
228	coinbase	484	720000000000	1	CkpZT8skEse5aQpL7P3hpFay7KWPg3qVuQs4qn3m8codZiT8TgvHH
229	fee_transfer	484	10000000	1	CkpYrfiq4boyuxFgofCDT4znHWtVofLTyA3FJY6tRUENhXQWQEBFU
230	coinbase	1672	720000000000	1	CkpZNUuzpReQt1HATgTgbBB24zntNjR4PViHjdSZtnrvYqQjnhTk1
231	fee_transfer	1672	20000000	1	CkpYbLpVZXMHJFzr37712i2vzzoAjQfnV7w4n8fK3EFsXZpLjhd8o
232	fee_transfer	700	20000000	1	CkpaKMpoUurxdNLb6y5B7F2dmiYtvLZJJZ7CNaeMW3R7iBJ5xfhrG
233	coinbase	1448	720000000000	1	CkpYj9btdKFpPXqUN8qsQS3uy1g9SoEEGvmRRBWYa3mK18S5k7YMn
234	fee_transfer	1448	10000000	1	CkpYyEu9QdVmvCRZHHZ5aWwpwptLjYqNT1JBJFzjM9MeYETSZJ1FP
235	coinbase	1471	720000000000	1	CkpZ6nbG6uk2cSY4efuJkKUftDqKBwXx77NV39m4TYPWhXD9rfBZh
236	fee_transfer	1471	10000000	1	CkpYoVjDsCPy5RRkgt85aqsXEP73JPYsbnwZ4QNvEV3LAf4f51vnD
237	coinbase	596	720000000000	1	CkpZUPmTdz591S6EwQ4FWUJza7GiEoVGsQBSmQnQ6YcH5YKEBbbGV
238	fee_transfer	596	130000000	1	CkpZ7fB72LY1Bivte2q5QE4SPafJyAX45aY17GVwuKzgL3B7uriHd
239	coinbase	1456	720000000000	1	Ckpa8emzJFzAZDLgF2ySyqTSKhUn356NFfeHzN6U7E6g9N6bxkcvz
240	fee_transfer	1456	130000000	1	CkpZjQDHYWiTGsa1f14UfLfu2x7s1JLneegoAZzTv4JmXm5jFse2J
241	coinbase	1555	720000000000	1	CkpZLuBtucY3VjRrXWSMSWEremZ34Qci3CZkuD9GCKJDtL71dp1AN
242	coinbase	1714	720000000000	1	CkpaFEh3uvUMAcSCwJw5UuH9xwiQt9H8b2VzfNCizmjCLGLbYQyQ9
243	fee_transfer	1694	50000000	1	CkpYawfmqtHvRMkjhWWdre88zeTJZaAqa83hG2b29Pqu15DpDWbHs
244	coinbase	1633	720000000000	1	CkpYWsb7Un2L7DWn84MQeYAQrCGkLpJ4tAZ2LPvAQpxFxQcmdVKCb
245	fee_transfer	1633	10000000	1	CkpZ7o6NyPWyBxE7x4QSYjt77iUw2MAKm4QXR9VxGEfp8iVvz4N9Q
246	coinbase	344	720000000000	1	CkpZ12EYXeP9isuJgPb5kp9nidByVhkuMcwDAnF7T4c4hSwi7JCJq
247	fee_transfer	344	10000000	1	CkpZ4mKFLXYR35sHPp1qmuG7PuGh4gbJQvNkWxD6FX9bQK37BucTv
248	fee_transfer	369	10000000	1	CkpYkzyjx95czyaV8WLBx1qn8TZ7vdY8yJaZcKnWVUyTiA3N1HEZr
249	fee_transfer	1694	21000000	1	CkpYe7DtSbpN2XDuTWAPu8HG39q5DAZgVy6b29xed5MwAoz4g9c2A
250	fee_transfer	1695	21000000	1	CkpZ5JeVq3gbrDaMtZx7wasWjMXRZ6gBZh3AafUPcKHgnB73qae3V
251	coinbase	171	720000000000	1	CkpaDcfS9EFVyanCZgN8HsV9RmBtnZNuHWSt4BgXDMG5wm5pkzChL
252	fee_transfer	171	10000000	1	CkpYkwFNz8zR9paZv2u1ypKJb5tmFn55Urtk2ZZjJ6KfqYWwCxs5T
253	fee_transfer	1714	10000000	1	CkpZ76TyLttbw2sXz8vLnrAXm1QGuKK83a5vhhBtqxx1e7ehkkWPQ
254	coinbase	1576	720000000000	1	CkpYhUePNZ4UKkMMjuFQ7mx5cRt15C26E6UPgytfdNn6mcwR7s7Wt
255	fee_transfer	1576	10000000	1	CkpaAn7vH1wvn29hj28Da2eu69a6KAp2UHBpS2SJ6d2qaK98rNTeK
256	coinbase	1445	720000000000	1	CkpZspfJYvYpMA6kcg86aXc6q9LAR8TTA7U6xcDmsYkLeKFwmCPrB
257	fee_transfer	1445	10000000	1	CkpZS3NMZyY6t4L7NTJ1na6YW7uM5G2Wtp9fCEVZ3rBvkkf24QUiQ
258	coinbase	1455	720000000000	1	CkpZQRdFXJMyNWoXHF88mmJ5hETC85qm3jZhV1ZcECayo8ofMyZy6
259	fee_transfer	1577	10000000	1	CkpYSsiisNq7g2GEoCzCnejnm4aszVctdnL8hNkSNp1mrXiAp5fb3
260	coinbase	1715	720000000000	1	CkpYtESsr4UKgugEiJmF4nMMheXQumAtX3ZUQiGpW1aCBNC3cfQQX
261	fee_transfer	1715	10000000	1	CkpaLdEURsRawSu7pzvzkAuvVvy44df5pcn3Gm2bdRKVWjERYzmXz
262	coinbase	606	720000000000	1	Ckpa4ZzQBuW57QhMQsQxLreatTgaSvJdEpJ9qo3VEavDaZR7jTaPS
263	fee_transfer	606	10000000	1	CkpZyWRumBjUJGd1NBo9TK4dFyqyuRvc2xsJ18YJQLALMjQa4J7Tf
264	coinbase	1594	720000000000	1	CkpZhs572MwVhc6oD4vCT8btBHxRzv2ygzp1ZHCi5sE4qFCDBMf9H
265	fee_transfer	1594	20000000	1	CkpZSLRwDRWDcUjEWTnMgkXAbFAWqgt7UqY97QrWYpWWohdUnSJiS
266	coinbase	149	720000000000	1	CkpaJYeTh7ZURFsrM7Py9gqsiUCriew5rKNb3BJaek2dbMEfopDvq
267	fee_transfer	149	10000000	1	CkpZPHTik8shYWaWwj9FzL22JpzHTPijtAkQ54VfSvJPdN62Kqg9h
268	coinbase	1716	720000000000	1	CkpZ7xGLs2NxbZNvxqTiGrjqCnHN6vNiqERKPzqUsRyELmKBqkFeB
269	fee_transfer	1716	10000000	1	Ckpa2ycGLCxfeFqD6KeP3eNqcyBZMJxw8zCeWZV5pCGstHaAFGuA1
270	fee_transfer	1594	10000000	1	CkpZN3opqp468KmS8B14Nepe8X3LSLU7Q2jzQVA5Lz2UKrJUjHRbR
271	fee_transfer	1715	30000000	1	CkpYxPWt4xT7M3nNQvkbi9o9DHqYVPnT3qxYoVkZWANEQfjTeb75Q
272	fee_transfer	1693	30000000	1	CkpZFoyVGUDTcwhavzh9xvMT5PxtYkpJMAtgibVqQrv17TSwKezrV
273	coinbase	1717	720000000000	1	CkpaKiHsJmgFLEPgo9EKFxsPgx6AJgrXHtdDCdT2zbNZGRDUEkoXd
274	fee_transfer	1717	50000000	1	CkpZ4RzYNrWwnUVUajwL9SpBNL1aa77Bt3kRM6QVAHgrQM1JEgdie
275	fee_transfer	1683	11000000	1	CkpZRcngWLNbgsPGZFKvEmAbxBavG6BA4izkKvPNxNg4JMu8isX4T
276	fee_transfer	1710	11000000	1	CkpZQm3v7wXtcmQBYdtuByV8dmQLfsnLEWrLWfNLMzkK93pc8Fbps
277	fee_transfer	1559	11000000	1	CkpZm2QthQPeZg8qVMxELJhZW6Y1ztnW1nvdXnh6cWgfoWB6wVybo
278	fee_transfer	1682	110000000	1	CkpZw3m5bmYQEcuWprbEzytAYa3KGkY7ncR9fuQoLRkMYBHQacumR
279	coinbase	1718	720000000000	1	CkpYpVuszyWTa3Vbqk2fdNV4QPmH17jAP7ZXfr3MnTMokKCb4Nbd8
280	fee_transfer	1718	20000000	1	CkpZEKhpUs8YkpMsJQS2yt8CPKx3EGNn7cHuCnNK9n23b9zzg93Uc
281	fee_transfer	1555	20000000	1	CkpZPz4EUQzYKQM2tokfGvf7tva9iBSiLuh9JgVeuvzLEBsVmFtdB
282	fee_transfer	1688	11000000	1	CkpZXxPscR8v2c9BLophTdqFLjc7Li84Ef8CLJhBXK67Gb3S9pQ2d
283	fee_transfer	1677	11000000	1	CkpZd2ryWbKyFuu2REpR8iUVCseove33D5kquke3WSfUxE5ND6Ceu
284	fee_transfer	1692	11000000	1	CkpYqkeQo6hKbFadqCxx6Zc9KTzMWpF6XEQrddKK2haVxJSX59thq
285	coinbase	1719	720000000000	1	CkpYYC2u9EZixbs6P23p4A5ms7BdnZZcbheLMSSHQect54QcHWDwH
286	fee_transfer	1719	10000000	1	CkpZRKBTs8vedburKZjmrf8WCExDLpwxY1pcjQaJ5EGUsCTpevSZM
287	fee_transfer	1672	10000000	1	CkpZEW9vSrZ8rXRhKEDjJaG7DmeAa5vJaBZJBQcLeub1ap8Sb1reA
288	coinbase	42	720000000000	1	CkpaEQPKv5yQn52tLURmDsKSAxhdQ5qTGHSSmTEPz3kRKJSKu9ZGK
289	fee_transfer	42	20000000	1	CkpYcQVo1XKvxs4caLPyTvF1z5kwYveAArKck2jHbkyNT64UDL9ah
290	coinbase	1536	720000000000	1	CkpYhL7RUsgnung3At34usiGPqGXgb3u98w8EhE5u1cfLUkXNFpnH
291	fee_transfer	1536	10000000	1	CkpZVaCrpJpp3ZVf5Y36NKNfBkEJKy9S4os63b4EFtxhE8z75rqFc
292	coinbase	1516	720000000000	1	CkpYeXu6eFPGMrMVzCufzLtht8VtYu11wRRQ9aQWnftBvKr4PpckG
293	fee_transfer	1516	10000000	1	CkpYhw3d1kE1XAs72ihgBKDcEtDcmWLxUZiASenbGynSXpdbtDd9H
294	coinbase	563	720000000000	1	CkpaDU6TcGa9P2LyxpmW6UnBrDmsHJFyHCw6aYVh11SH14pnLWniv
295	fee_transfer	563	10000000	1	CkpYhL25VyqNrMx5vWwDvdbyWsgmiPqvYVADqe3KydGNvWpgzoKxQ
296	fee_transfer	55	20000000	1	CkpZxuCRiPQDpi9xxTznoVm2SbKSkYav8KwgrfMiS7Gh1rUdooHN8
297	fee_transfer	1683	21000000	1	CkpZgUmUWk7oEAji9KcsH5PrpKK6sczqRP7Tv6QGiQeRa9sTn8ezm
298	fee_transfer	1679	21000000	1	CkpZokYsqVxJ415d7uPymxWbB5M2DW1deXS7VjCfZLS7kQGAyRUqh
299	fee_transfer	1448	21000000	1	CkpYWe26vNUUCd9mgntvrTWjXPiziSTgwyMRYKEJSKqJLMi53J4gn
300	coinbase	1426	720000000000	1	CkpYy2s1GggXiy8bYszcQrLhGBZiC6sDL9naTnQU2Cv78ShhssbZk
301	fee_transfer	1426	30000000	1	CkpZXpUoeWPSAKt46QnAvTGEfo7n8AviwWtn2siebaZvaqyMzmQjF
302	fee_transfer	1657	10000000	1	CkpZ7zWcb1zhWdd7SREQYzc9SGMHBkamjtF9bKvyuQv2KhKLwqTgc
303	coinbase	1463	720000000000	1	CkpYbzcxuR8EUn1EyxZL4XCKZiV28EL3wDbptEunB49h96wTD34Kw
304	fee_transfer	1463	10000000	1	CkpYg91gaRpHsexR8buu14qZdetHejshKZhoNa2v3W8wjiZLJY82D
305	fee_transfer	1448	30000000	1	CkpaKihuy2ZX7jSwx9shkgQKdr2Zbrw925PX3fMdfwhJoYTDsbgNo
306	fee_transfer	1684	30000000	1	CkpZXJgy9tQUyW7qhUd7HV3SyTT4EZeaEXpC28VL33nxWK1tiYMJT
307	fee_transfer	1560	30000000	1	CkpYpXR5mwCUqsxKm5AczsyhqjNAo5MdoXA6FBWg594pQ2Kid8zUX
308	fee_transfer	1689	50000000	1	CkpZyqn16zqGhQvfdmt5P1Y8QAztkttQZzPY7D3DXEQVP9JNyr6jj
309	fee_transfer	1455	10000000	1	CkpZQesBSZKd41br7KMabhKjHgsqaepCt8ipxmKZY6ZMkjU1bjwew
310	fee_transfer	1396	20000000	1	Ckpa96YhXuhC9YjJxueXrekPB2jUJX8XbQV9BiUPBknzSq46hPe4R
313	coinbase	1524	720000000000	1	CkpYqYGh5yUGVQWz4ffPSNeWnKUxKPcD5wg75FzoTeuH42ebDyne2
314	fee_transfer	1524	10000000	1	Ckpa5KJvsc5fMbMvYKJbzmPLgN9ddJH8cFr9urYtK7qiKqvCLjKhy
315	fee_transfer	1679	40000000	1	Ckpa5TBZg9XHCLhu6VqCLZrjzVYHppDBwbcAj7FNa4LHvXoEF1sHm
311	fee_transfer	641	20000000	1	CkpaAeE2sRW38M8N4JPKGHKghhdo8WAKqAXeL8PqTz4U22bieGKuW
312	fee_transfer	44	110000000	1	CkpZLALfcvEZsfVXtZVL1QLftccB1DABvo1tvikCCfSS83d71hEFn
316	coinbase	1723	720000000000	1	CkpYvVBSUMpzxjVW58Lg5dS4bEjyqQQkRWYRgPM1TPg1aHrYkS3fV
317	fee_transfer	1723	10000000	1	CkpYiFeQYoQPs2LrQYAN72wMQA9poTjxFJ1XbgasFbSiuo3miNAq2
318	fee_transfer	1716	40000000	1	CkpZiBrZijo1iRExp2BqPvA1frBBjo9A2ojeYBaar92q81zeY2cRw
319	fee_transfer	596	20000000	1	CkpZnyPJ4wP2aPs6Zg3ib6Byt7qV4xLThsaXEdT5o1RZ7nVgcNpw3
320	coinbase	1643	720000000000	1	CkpYtrrWqe2SRMLcEqs9TCypvQodXieigbQC1FcsF2fbV8TsQ2kEb
321	fee_transfer	1643	20000000	1	CkpYgT8q6sVqsxPi8sZyMopHhoPGS7WzLNgWUvFWrX5hssdS8rLd8
322	coinbase	1673	720000000000	1	CkpYWhbTZZjRZybY2BVHDpQp444XNTXcjcdEDKgZzRqzqG2T8senM
323	fee_transfer	1673	10000000	1	CkpYtXEC52cfg4pwYifzh6T7NT7wYqEa9rvxsrnkLRv2gxoTjqGRF
324	coinbase	1724	720000000000	1	CkpYpx1P3c12rqvoADvK5FNRb9jAmiHoNQSVWBMSa4GMUMvdE3rXa
325	fee_transfer	1724	10000000	1	CkpYfKHaKL2DbWGeFcPRLuPLRBWGdit1AVABw2RSLNzE26RU3iwPM
326	coinbase	1508	720000000000	1	CkpZNscpFaXDRfqNaEVjjvwtXNaK5SD9g5R3mhua2ZjVsbfXmVVSf
327	fee_transfer	1508	10000000	1	CkpZzWeEq1FcSGqqeY1S1HV22uaKMKvnsZoERzV73oCJEqp3dtWbY
328	fee_transfer	1607	20000000	1	CkpYkdYBuazB6AxsLnqAvwwc4T9GheuLRCD9FkmnxQ7MF3wJ4WaCq
329	fee_transfer	1689	30000000	1	CkpYrpKbzakSkJUpz6ph5MrjwEwZf58bbpjoimLedDSG4tiobqgTQ
330	fee_transfer	1601	30000000	1	CkpZjhSpWQZucFfbBz5oPSS5d9pWs1tzUkvVNrQFHX2QirR9PnoeR
331	fee_transfer	1571	20000000	1	CkpZaA2mU6DSbPH7Nq69QByB6ft99Y8H8GoyLg6DUTTvYNgTdStRu
332	fee_transfer	1723	20000000	1	CkpZ9GnNjDxiYc6zk97EbC7LSiX7SwQ1yrJ4HiYKqbBf1U4gyeqKs
333	fee_transfer	1555	10000000	1	CkpaDjqtf5iYa3SQXLCzXb699FfxW3nVcsUn7X91FJG6mhUUZKAT7
334	fee_transfer	1643	10000000	1	CkpZqGTsQZFpVWwDobEgYeiEeXYJzqVj9XSwrvrdpYfEaKR2nKABf
335	fee_transfer	1445	20000000	1	Ckpa9SpykLmMPpp3gm2upRLDPUh17enxgrcANuJwpDHg5kEtRkAVC
336	coinbase	1588	720000000000	1	Ckpa9NbCvyjBVvCMxqFDRnNqN3cxgfkDF3NTE82X5NqzHaXtcPt7A
337	fee_transfer	1588	30000000	1	CkpZR5UGskhi4zJ2cHwLDZKE9mvCyMdXUKpLsFhHkSNEAMKRshMKA
338	coinbase	1722	720000000000	1	CkpZiGPQzVk8L2hYVS9CSUPFWxQrsp92sNWJFQgSLu56dkD3GdemR
339	fee_transfer	1722	30000000	1	Ckpa4N3jEMePatm2f5dGh2UPHYVD1Po7cxYYZpSYXquVozTEG3HHp
340	fee_transfer	632	10000000	1	CkpZvZhcKdxVPgAt49SMx7WrKp29bmwrWui6JdNiEjcjdJiYSdXL6
341	coinbase	1502	720000000000	1	CkpZm2hRYqCmUtD4gJXhc6howj6uM56W6tQtK48sFhSBJL9uQhkqb
342	fee_transfer	1502	10000000	1	CkpZL9rnqsJ7vmfcLFSxVbDDTNmikxKqakBD77RP4SQQdQxL92AQ6
343	fee_transfer	1596	20000000	1	CkpZm48CcNkUwNjHwPy4KiTQoSAX4KszBYnvHugr1B3suQ2Vr1M9Y
344	fee_transfer	1613	10000000	1	CkpaAiZXgjSahyNL4uPWQWmRXJ2HEBL1H4dfzLebYqLXESQgsskgz
345	coinbase	1616	720000000000	1	CkpZomsCcMCMtsYkuPop9Y5P22LoSuFoApcyVUUTK5qukp8YgWpd9
346	fee_transfer	1616	10000000	1	CkpYeAmfDHZqSCd9evzCp5ufScFwTQF9UKo7RWwakwT8Rp9hTjhH9
347	fee_transfer	1683	30000000	1	CkpZaS7d47NvTcmgsMZfR4q1rtn9w1jFeS48eXVUh6XoeujSZdgmt
348	coinbase	1428	720000000000	1	CkpZ2vYJVD3L614JWi2LVGkmCcVFmoWcgJxv37r766pSKhkCJfWkN
349	fee_transfer	1428	30000000	1	CkpZq55ThKe4bATmwTnJzMJzHeu9XooBv6rQchCzcQRaJtK1U3mnn
350	fee_transfer	1686	30000000	1	CkpaLic28hv2aVjD2woErrc6TWwieXrf6rV7nuqeVNZhQkZmCZN3J
351	fee_transfer	700	30000000	1	CkpZesGiPZEiwHpESk34bjEAKMk8goYn7GoA9xFiguR3hLJf4w1iS
352	fee_transfer	1456	10000000	1	CkpYv8ApNhSEC2nDsDck9XDGQpSmhGCwCZWH5PPdwzJaYV29d5p8T
353	coinbase	1727	720000000000	1	CkpZxZipdWfiWuKLQVFuYMKyvausm9dUnCo4UeL64WEWy5Uk7ZPj8
354	fee_transfer	1727	10000000	1	CkpYx1qEpwmvZnXoyypDkUAnpxRCk8ftHVEqZeRyZ9LETCxiawRmu
355	fee_transfer	1426	10000000	1	CkpZWyroAfJbwy26n7JEVdzBpBX8qZwhrYyoCMC9rPXEwHQ2J7LrR
356	fee_transfer	1588	10000000	1	CkpYU7gHmQVdhzXaqgGjCVn5mymzmw4CeMgynVHQy5h9W8E12RcXx
357	fee_transfer	43	40000000	1	Ckpa4QYr2FgXCXMesPgYfi5oerUmKzBKhqEVTBP6C7GXQn5oQfBfV
358	fee_transfer	1613	40000000	1	CkpYRXhYg4KGGwExAK6qkM9DyPGhC9pozTDXLJbEWGdTGB5B7rXRW
359	fee_transfer	1637	30000000	1	CkpYcayW9PQXHofmLi8b1TS4SSUX41g4wagL4SFauAiG99A24ZBXH
360	coinbase	1670	720000000000	1	Ckpa83REBQvi8rPQNXJzb2mvaBNUcf8k35bMkdDens1d95ELW5iDL
361	fee_transfer	1670	110000000	1	CkpaEozgM9fwsint9dWGoqk71cBQaxevcwHZnWchaMD7XfXn1BWWh
362	coinbase	1729	720000000000	1	Ckpa2APCcT9eFg2oNvopqnjAKkDZKAQ3VTCxVQLyuVVUdHoRFnh5V
363	fee_transfer	1729	110000000	1	CkpYtKu12Zj6ycXJ53s6RLmqXJLjLY2U3PoNHkJFr2nwstJEfgq3t
364	fee_transfer	1536	30000000	1	CkpYjrE4Knps9ix4QKxv651w3ZuqnEFj3Efc4FuyH1vVjNxa5Qbde
365	coinbase	633	720000000000	1	CkpYmk3ksRhDbszjrwqYADyLTbpxGXL52ZvwY9Vnr7rjzswbQ3ZJb
366	fee_transfer	633	10000000	1	CkpYy3TuYYGmnrjVe5oznJMTD2GFP7i7QnvRk2Rorm7UXpXErjc1g
367	coinbase	576	720000000000	1	CkpZ4pueynQ7R5e7JynvnXYkwCy2HCpMDud5Z2VmbQRSn6piSdtdn
368	fee_transfer	576	10000000	1	CkpZuxpg6qmVNrvZkgQqxpDvcpYjN8mweR3rtW98HPYPWVbkseCoz
369	fee_transfer	1656	11000000	1	CkpYiL7yaLyj1G1meuY1CjGkPc7pprTVy7ZuX9vwAGn5JAyXobyRm
370	coinbase	1482	720000000000	1	CkpYRGC8imyALhU9WVAwYqUbQC7tATuZ9b49gcKQCHcZrMXQEZEQg
371	fee_transfer	1482	20000000	1	CkpZCKrQuCUhR6VHb8MCYypXk3kDtWUrJp7afbhUm2AAy8mEDn26U
372	fee_transfer	1688	12000000	1	CkpaJwRGFVA89xja6jY9YmuijpzjSJDRrF1yTWvqzCsuGVpZAL1My
373	coinbase	1271	720000000000	1	CkpYvzTwMaWDmXZ1H7tUFVEBNAadp2hk4uTfFhUg3epd38rV1aKQR
374	fee_transfer	1271	10000000	1	CkpYkstfgTXDn8Aw3G5SLSMAMZc5fbESZGNoNKunCbiaAD6aB2a4M
375	fee_transfer	1623	30000000	1	CkpZ731ZS9kuT6RdMZqDECLDqLbiXHukBuv7mfFx91waMN4YX1ZGw
376	coinbase	1517	720000000000	1	CkpZwWPxiqscCieXQHSwqx7GSyMTzCfj1bmkdUyXELPBzSftJY7sQ
377	fee_transfer	1517	10000000	1	CkpZQTiS5yiDSAH4gft41T1WZk56g9Vz1roZ7zooWk3GS1YaqpBJY
378	coinbase	1733	720000000000	1	CkpZXiZdSzBwQ5vgAXpRS3VJ5PQjTfa1uHbgwAGZXmGaiMdS93x3F
379	fee_transfer	1733	10000000	1	CkpZGm4RRUYu3hD6YdAPwFsnKfgnu8Zkp9f1V6jJ8NYaVQREJBNM5
380	fee_transfer	1637	40000000	1	CkpZDhNSYgW5JFgThmd4Sz8vSpdHo1V4CdhH4guekH8K1yTz218JT
381	coinbase	687	720000000000	1	CkpZiscDQE21yo65yG2TpTcEx9aupfqzghrSFgLzSmdNsgy1Np1Mw
382	fee_transfer	687	30000000	1	Ckpa6Qw85p8iPyKpgacGk9dA9CqGeagoDfMX4MbUKzJkT5nCfdrG4
383	fee_transfer	1684	20000000	1	CkpZ672Pt1KfrGmDbEK5rf3GZaQxHAU7eB2LDpyHG5cWWhuiT27G8
384	fee_transfer	1440	20000000	1	CkpZWo2q9yNzzCbMz57QVZiXctezWFCrBug9dMnuUwqSEMLrXGGyu
385	fee_transfer	1688	50000000	1	CkpZqLYKb8a4fYo2xv1wskSR5MmUoPEM8xNRbXVA5WbFAe5gJupnk
395	fee_transfer	1729	10000000	1	CkpZQHHmJgMiJ7BxKKuX4Pbh8MrAJDJDNgCzM2nU3KEZou8atJXu1
396	fee_transfer	1457	10000000	1	CkpYRxFfbpBYvneMsvUp7JscmExBzstLHMuvivwCGpXVTtM1KUvTQ
397	fee_transfer	1691	30000000	1	CkpZNZpmUmZX4knBoqHrCevuURVNdr8WpZbYGo5TUSL8rroemUgC1
386	fee_transfer	576	50000000	1	CkpYcM77WAZPKRKyF1MF8yhhTBuJQWb1kFFxeyhH7pprvrJK7fPsb
391	coinbase	1402	720000000000	1	CkpZTnPFYe9RDokqyKmovnnyFR9MtcswuYPaQFtPZdh9DLWkdH8f3
392	fee_transfer	1402	10000000	1	CkpZRPjunDxY31MDJMhPu5P8FmwJUnKqq5865CRKPCx4foNA8V1nL
393	fee_transfer	1508	11000000	1	Ckpa4MNiNHiMYCKBT1bm8rnDE5jyJ8zgpCNmomhUkVMcP1YkGK1va
387	fee_transfer	1610	30000000	1	CkpYV6ry5fqHvMmXuEk7kPNpurX9wUZMHZXtV4kWkuhARCnv5BZVK
388	fee_transfer	1637	11000000	1	CkpaKC3pvVKfqHLHRQ7guczz8aeY7fYjDnBE6YFz3DL475uSACE4q
389	coinbase	1735	720000000000	1	CkpYyYFVN37ScHc2QxMQissEhMaxTQgLjdt5cgGMCMoCd4kFLUtSZ
390	fee_transfer	1735	10000000	1	CkpYV3cQHHfvH9wnUc7HdChAL5V6Z2GrWW4Z2e9UmYfdfVhMeAY34
394	fee_transfer	1573	11000000	1	CkpZxSnPE754xaWHTSvuJwSCZaZEJHb9biFzynm8PTaEB3UpKhAeb
398	fee_transfer	1706	10000000	1	CkpaHkGZLRs7tt2G8fk3npubRdb68WQVGDaGzheYmszkJt4br4KMc
399	fee_transfer	1476	10000000	1	CkpZMd9ciTodyoVfUFTiqXpX3ossvFTf1nkSYFAw3zWaxu317zLYJ
400	fee_transfer	42	10000000	1	CkpZdxtycsAEkRaQwqJiGBP2vMeWukEcyJqJnsfrpew99QW3T79sQ
401	fee_transfer	1691	20000000	1	CkpZD568frUxVDd8P7v2HS5GgPoGs3vq9KknwfFaig5CVhKcAUMDU
402	coinbase	1451	720000000000	1	Ckpa6quPBNRiKRWNhCMuYa3weK3mv5ePYu2zgZGgRs6ZRUYJ98tF1
403	fee_transfer	1451	10000000	1	CkpaDb9xJ7vsFHWmG6CoEaDqb2uNV7nY9reFsoFdSx5yeALdzJy1t
404	fee_transfer	1599	30000000	1	Ckpa7fUgDAYhWmxYfX49vijAnTM5ZLhXG3g1UdPzdmKz6F9GoDZz6
405	fee_transfer	149	30000000	1	CkpZ3FWNTcmMCKgX9oevBFsEr5TW2Pj64u7JeASf4nvxjv3mSUTUG
406	fee_transfer	1402	20000000	1	CkpaJ2u5HW6Dr2Bt96fo9cCPDBQXnwEFKJRnGVDjargduTmwVSy3u
407	fee_transfer	1705	30000000	1	CkpYgJdFaYJFHKBsB1ZUGMTZhxbqGmjgXEvm1YgxyESrYRUUZde9q
408	fee_transfer	1637	210000000	1	CkpYvQP7yEoLHJPT9rYGXeDcLAPr4vcjT7awQGeo6fa11wBiFRdKK
409	fee_transfer	1722	10000000	1	CkpaC4nFH1EYqbCQZAYAgpf9om7MKE51VmAk7X6LK9WfTQQov6umE
410	fee_transfer	1717	10000000	1	CkpYmDrkHfUs5fMpVs24kTvH4ukcnaV7aPX4KBVWL2vcGi7h8FDrF
411	coinbase	1608	720000000000	1	CkpZqNLvWWZ3vSmkDFsKqAcCwHX82eE7Xv1yahxc3yqhG9SMMNoxh
412	fee_transfer	1608	10000000	1	CkpZvPaVTyKCEYiQhusU1bruahvE4t5hPid8PDbGm7xg7M4t1PY22
413	coinbase	1519	720000000000	1	CkpZJfKyhLQ6ZMcTFmqLdQpEzfu1cE9SoGHfwrrMiE2QYxa4NKEGf
414	fee_transfer	1519	10000000	1	CkpZm5PaTqWB5vWHX6AT6gjCcYQCJHqt2R4LSWMHHaVQUVnnHzjMq
415	fee_transfer	1722	20000000	1	CkpYybgj8a8as1KGGYoHTGFvuFk2GY3nvRFB2Ej8ZVWfV45SJiorc
416	coinbase	1738	720000000000	1	CkpYhzFPw7fPoZxDefA35fiDLZnmUbXrJHrrv7jGRDq58jF9Fghc9
417	fee_transfer	1738	10000000	1	Ckpa4aTDH8njQirXWWeo2iyPpt3gEpEr6XjHh7YmQ9YeRpnQknzmj
418	fee_transfer	1513	10000000	1	CkpZm46sPhXJH8bvYufaDBaeCd89bpfvPQcEwz4VQbsE4oSzTeK9c
419	fee_transfer	1715	20000000	1	CkpYpDECjVjM2un1QUbvzHdVgDG16Gp1UL5JReyN1yGFadBEMU1aB
420	fee_transfer	1729	20000000	1	CkpYjENA6deZ65up1yJUiC5HbmzxSmtRpPEyTgXjChgM3A1hVBFH9
421	fee_transfer	1516	40000000	1	CkpYYNv9DTYYwViFwF2iRzLhhz4rz4va6wmmfjMZaczmb8vmQTVUj
422	fee_transfer	1677	40000000	1	CkpZ9E7z7s56YKdR7ewPyk6Ejp76qocApPHpSeWbD4RVqeiPq4iVo
423	fee_transfer	1699	40000000	1	CkpZMskeHGyoUV64um7MkUDbFu463Fo3ezfx3tiVT5MnARwE24X2B
424	coinbase	58	720000000000	1	Ckpa7F7XBaKNxLtimQv9RVgj1pQxy1YWe3yWD93DR4t1xRbcr2kHB
425	fee_transfer	58	10000000	1	CkpYxokaMWD9U8EBHC8NHFSZL572wqVShXVCPYmVktmCyvWDo8PX7
426	fee_transfer	1683	60000000	1	CkpZUM9LNZ8XB5tq2zY87fwQj8GgK8znsyNVxzyBCsZfVyPA5JAnt
427	fee_transfer	632	50000000	1	CkpaARMPvypb39hTppqPSPHiovLv1pk92UdvDbh5Lbd7a3c82kSw8
428	fee_transfer	1448	260000000	1	Ckpa5HrCZoji55Zx3ENKKV7xykrgxTZki1hoxVdANnNRbYqhESHFP
429	fee_transfer	1692	260000000	1	CkpaHU5LdzTNSJKbUfa2Lb6ua6J29KxRoHXGywGuoxwByCuRM7yh5
430	fee_transfer	1673	260000000	1	CkpZ9NbCd69obrm94DE3is1WAPekhr3fV5AT27YgAuzLyY837T6kH
431	coinbase	1678	720000000000	1	CkpaDmGikdqaVePLJfyL3cXUipn6ymF786mtLZfvsMQ67y7ohxubw
432	fee_transfer	1678	10000000	1	CkpaAarovSU6h7GKCcovnm2K7kuhnEnStMmW27CsdqWCauZWAsAcW
433	fee_transfer	43	20000000	1	CkpYcxHhGfvNJRzcCBPzqoMFA18JKgGN4PuuneHqLqiGL7eCNwAah
434	fee_transfer	311	20000000	1	CkpYdTrj7yvN6rQR3ejU6Ke3nGGn8XXZX2CxyvKz2yZbCfGcHrTUW
435	coinbase	1739	720000000000	1	Ckpa1qfXAsE83VzoNSDKpzHgd77XBJTRHELdQYcQxs5Le3vJ8FMJr
436	fee_transfer	1739	10000000	1	CkpZkAerEFYD6tBDkDhqXnNToJAfzT7RRtBxywe91uMPNSxrevDCW
437	fee_transfer	1698	10000000	1	CkpYdM6hpgfFZdGk9NczqJauM8bE2KGqC4x5zHRzj2yd7ipKDLa8H
438	fee_transfer	1633	20000000	1	CkpZCbWM6Jic7haa8Ya6CMSY48gPks95SDo16QMJNi1ssyFRpejsU
439	fee_transfer	1634	30000000	1	CkpaGyGAAXzeTVUc3WhdY7ay9DDWD4hS3HTKviZoMkCWgETTo5TeU
440	coinbase	1569	720000000000	1	CkpZtdWJ6ydzM3h6o5BERKVDjk5ipTCvASjQHuR4mrDoQPVUzh8y6
441	fee_transfer	1569	710000000	1	CkpYWo4Me7gXVukywTQAmXgu7Dkz36uiEgFGyZLibqaJZmV9iDgcj
442	fee_transfer	1569	510000000	1	CkpZJGdTjxpCWGXFTAa1uwRy7cygJPGz5K4pwwzg3ATYcr5u6pUh5
443	fee_transfer	1569	10000000	1	CkpZR6AwqHzjN9UHu4niM7xAPU5evmtvScvjmANoMMKbLURRjg65o
444	fee_transfer	1677	110000000	1	Ckpa2f51VC3mBaNDSiN8zJ83gM9y5C1FBEABwdZNTeGfRcDLievWN
445	fee_transfer	1637	110000000	1	CkpZNgxoyqu9sP5Joxd2vxNEvoamm46kxH7XmntPVGXr7LW7mEQKS
446	fee_transfer	1516	120000000	1	CkpaHXUuN7k8sMk7QUHwQcMYBARYg43TfKBEWRobstUCbpEtsJQhu
447	fee_transfer	1671	40000000	1	Ckpa4JJgjYmnBko2SW1AQYfknpHfcLBaTyMXhJkqtgXygSRexBz8Q
448	fee_transfer	1695	40000000	1	CkpZJRSuQT6xD1A613Yk8pjMb4meVZZa4oCGFMH6Mppw5E58s13xL
449	coinbase	1650	720000000000	1	CkpZ3kuAb3iUkL5PXCcs6KK23fTM3btXKaviWYE68LMRr5nPYsHc3
450	fee_transfer	1650	10000000	1	CkpZuV6XJWyi8mYxrgsY5BZ2Pe3BPoaQapJk5RW9VNrYg2fovK4FZ
451	coinbase	1740	720000000000	1	CkpYiEdAHeDKTwuk9MX8FyxGWRcf7ZhoyeSzqruf5GWHQ7gedioPt
452	fee_transfer	1740	20000000	1	CkpYe4FXcUxJu1DRNneRfW19g8egopSm7t8tcz5wvQDqhf4vH3s75
453	coinbase	1675	720000000000	1	CkpYiCxULpT7Z5yRoVGEX5pQz9DP9NkYCinNAsetvBoDbd1bXvRnx
454	fee_transfer	1675	10000000	1	CkpaLHkhdhxe7kgxLQHsR7VCMbquUoudcVLRLgnXU7EMpxrAKAC67
455	fee_transfer	1419	10000000	1	CkpaJHFouRETY7rRywz8hY8GGwqKopmFsmUNdRKLDdYWF33tUssNS
456	coinbase	1446	720000000000	1	CkpZ1ry6FWY7aDq9oYEEosAVyMf8qdWf646jFHFbcN1waMq8bh3aG
457	fee_transfer	1446	10000000	1	Ckpa7teccMSAwrj6GX6Pnm9Giw1AiCdTQHDnqgNxrvvoZnAkBY2e1
458	fee_transfer	1711	20000000	1	CkpYmeTzfgvyuXBUba9zuh8AE1NTMj8wgv3cHQHATEMwBzQi5vaCS
459	coinbase	1423	720000000000	1	CkpaDrCRYE3qMAFa6YP4qoanAb23pWG4AvCsvQSQEWxVF2Ty71wSp
460	fee_transfer	1423	10000000	1	Ckpa2qsZkhaKK123KKYgVy9LKgt7p85cUggMiMKiqgev8aCqJ5iHJ
461	coinbase	341	720000000000	1	CkpZeRFhZQCcxsW2nZi9XLjThQCJkR77JRpYJ8SSSfcqNsfFVLVM4
462	fee_transfer	341	720000000	1	CkpZrkrHqqVKUcyCGGC5ZwptVP6rxWonobuD7e9zM3nRi4CfaFKpB
463	fee_transfer	341	10000000	1	CkpZig45J5e1f8cFqKw9SwQXwwszUDWLfvb3B7PjUAG8p8VWyyeRM
468	fee_transfer	58	30000000	1	CkpYquuVBKHeM24jbQuucNqYdgG93wBoTaqAFXjuVNM4jRJjaGtWF
471	fee_transfer	1679	110000000	1	CkpYvbfxtNgn4Hf5J8Z712w7A9gxgYoDRHPMPdBCtpQGdBUoavAL2
476	fee_transfer	1654	30000000	1	CkpZBNbKjSo4vVMuKSawm2KL1yAFQchBLobjGwKxBJ3vpLLZUrb3s
481	fee_transfer	1739	20000000	1	CkpYkyoX9kyjppoEHaWiHDChxPpC7yUVf6dRPfAngzjNR85bS9EaW
464	fee_transfer	1587	120000000	1	Ckpa8bPfvFrA1U9G4aJX5imLv66C5WczP6QSk1z4ZtFPBa5N3gbNK
469	coinbase	1434	720000000000	1	CkpYxpoPGBFNE8zBvQcpqsT2yABVXMNyzvzU7huwmi5PNKNb1jmcd
470	fee_transfer	1434	110000000	1	CkpZPRZz7MsTRgK3BkuCKaXdN65Wz1Lsjif2qou5cJBgm81xXAsAL
474	fee_transfer	576	30000000	1	CkpZsiCPeC5DhwDoAtoXAeiL8FKxorm4qsdrFsi6nfLUmLuHTsduB
480	fee_transfer	1457	20000000	1	Ckpa8Yw4woDh74shCQGH6QV185hbLyep5mCZER5ahgDnpHRSAoFdL
485	fee_transfer	1654	20000000	1	CkpZMKS6ePVESJMzkk75KxSRD5eV6isAqLhgtrFY55Vye23sVmr6q
486	fee_transfer	1724	20000000	1	CkpYe4AcEgZN6Qk9eiEUaErSDAJHxREVwRPCVGaH5Xosdco1QGoAN
465	fee_transfer	1683	120000000	1	CkpaCB2WSE5uWwoQubDHnhDjis5X26eDhszigiTqj81ThG6pL2uUc
466	fee_transfer	1685	120000000	1	CkpYbGQtXNYZrVNdycBQ1zjtUJn1kFzwupofiBSpT6h6NAzSHXPvL
467	fee_transfer	1670	130000000	1	CkpZrXzrmHaCoCupGiwK11wU2BjB1pLf4FDh2wSwaHTu3HRS5mukr
472	fee_transfer	1693	110000000	1	CkpZqiNCUYi7Jn8E4MJSNU6RBNtLvSzZ43PV8HNZbzNBAurQgG9rg
473	fee_transfer	1718	10000000	1	CkpaJGjh9exJe44zLEEjk3kxFsZX4hJDHgEE2LBPXQzwddMUZueUj
475	fee_transfer	1690	30000000	1	CkpaCGZGLVx3vYFBhqPobDb8ssVx5f1ii5TQuDPfxVZ1eCEGR1rKg
477	fee_transfer	44	30000000	1	CkpYa75MfKhvRxDSPbGkMxcLnJiEjNyRK3APXqQT2YvxteGFV2FEH
478	fee_transfer	1573	10000000	1	CkpZqjbQxGKe2XJLk65bB9RQioLmFfVEgFTinGwNSPZZLsp8rx744
479	fee_transfer	1670	10000000	1	Ckpa4hx1v9228uTQXgXxJWiSajFXz83S69HwJZwvpNB5amrrpkU8f
482	fee_transfer	1649	20000000	1	CkpZhyfhEzAuvisuwEXsH2SYvqZHowsjJGkvgGnTwc7X3pZ6nsvi8
483	coinbase	1741	720000000000	1	Ckpa1ttRgYZsQeNUBZRJScDFHSLWW9WPJXttgpVRfgyrdtg5gUDDE
484	fee_transfer	1741	10000000	1	CkpYvigB41UCNJKtb73XYZSvcJQB5Wv8nS5xPD7Z5CWLGswALySkV
487	fee_transfer	1599	20000000	1	CkpYp1LdnGSyhU8rEwnLvrCmzg2pHWeMMTAeBSN2yZHiLaeTMkwuj
488	coinbase	1564	720000000000	1	CkpYh3wbPj7BzZuTZEQK11tUtSDnjQpu87VndFKDUCyQJBzLbXW8o
489	fee_transfer	1564	10000000	1	CkpZQMZSWC6jUzNbzDrFg7tV6P92BVANQ6EmmChMu5FnhQjwB2rjc
490	fee_transfer	1559	40000000	1	CkpYTrwbu4Y1uWdZQJGtzrBhC5eycxHBe58yfxGCPZFRwbo3RdkHZ
491	fee_transfer	1541	40000000	1	CkpYRQFxedx4ekUf15ncwEePPh5aQMFpr1VVnpHLAizteZkGbFnq8
492	fee_transfer	484	30000000	1	CkpZePZ8cmpTQRj5RJCmS4hC8nwMCtxffnRRTUsL2gvaFyfihYQuK
493	fee_transfer	1476	30000000	1	CkpYuJqR6Nc4mqidVt8hVucw38zwphWZ6CqGAbd9oG3tcPaKJz1io
494	fee_transfer	1723	230000000	1	Ckpa8nJAVrpU5bTXm3vpjT7Jb5DbZWWNR5kVGPvNgfBbY1BVgSZHe
495	fee_transfer	641	230000000	1	CkpaExf8NyWDyP43bfzZRqmb1VQDn6cuLuyPQr5w6LdHuduhQzQj5
496	fee_transfer	1451	110000000	1	CkpZYfxpnRjUH1naf9kP2NzNt77rKonDUZMYiJMK5BoMTjQN1gU3K
497	fee_transfer	1740	110000000	1	CkpZ47gEbxBQ28yEGpah3MFPKBqA4V81BbGmmeB1LmLRCFcf6675o
498	fee_transfer	1518	10000000	1	CkpZDFAF5eoyxd7KXKxZwnM9k74CgGMCnM5hAmegQKZzT7gigUHkc
499	fee_transfer	1593	10000000	1	CkpZNn8jTKDcn1XSktJ9ZTcvHestyofEJdJj8hWcVWQpYaBL6VsoZ
500	fee_transfer	1602	20000000	1	CkpYhpuoPENd2C9sSEFCeJx8qboJthUbk8vz4WgV5mZkrbSnfJqvZ
501	fee_transfer	1422	20000000	1	CkpYuhVN9dN6v2NHPj1NXsytkkEnJYTHCQ4YMkbpbxckGHZ9pt4MB
502	fee_transfer	1516	20000000	1	CkpZ4tRvTof5R3tjiu5PLtQWkba54PWrFi61dL5CseHUCZgHbkSan
503	fee_transfer	1402	21000000	1	CkpZP4BF6nnFFQhcL1Byths9naVp8zAwnw4McLeQy5qWXqPcZ7YGR
504	fee_transfer	1536	21000000	1	Ckpa2vqgpWR8xHaXV3866Wdy8fFr73QotsFsqHcH4gx2mKDXDCfDj
505	fee_transfer	1715	21000000	1	CkpZ3HWFFqT7u2zJtGYxQ6rB4LdaDGpQbU1QVouvikRkfZih7QCCu
506	fee_transfer	1706	21000000	1	CkpYyS7Yjm6ythQeSKLWrKhyWvuhJBHHxHgbXGK6RhSJb8rDCkRfU
507	fee_transfer	1448	120000000	1	CkpZVBxrNP6DAxR5d75W3H3UiMpUZjzdNk15tzKd3VQ2cHCcwAoEE
508	fee_transfer	1610	20000000	1	CkpaJuJF5zr48iKij9gH4SJqDBbuUQzTE4P5AXDxDRno8L5xeXoUW
509	fee_transfer	1622	20000000	1	CkpZECNHQ5pV1PbFiNSaDiGS4sKQS61Do3BWzBB1pcEoJXWidWimc
510	fee_transfer	1670	20000000	1	CkpaDSpz9pKEMW59h1TB7v9JL6emzbuQ4DhsS5Uw2UNVG4TXaYkx6
511	fee_transfer	484	20000000	1	CkpYtz9agAZt9Au4q5J2iajStXC4zQrpMShZLV1kk5fGayjRua62u
512	fee_transfer	1560	110000000	1	CkpaA7VPJBwYdbG4t8wk5bsHbHcDRTC4c3knk6qCvkUrJ778tF77H
513	fee_transfer	1549	11000000	1	CkpZuLJRyM9rPdE7mRaztb4PRtPGKsr4XWvbYQ3Pz5ADrUMNnKXjN
514	coinbase	69	720000000000	1	CkpZrm1NpN5tao8mBMXQtpF9QnKsT2YdEGEw1cewTxkVMCd5NA5cE
515	fee_transfer	69	10000000	1	CkpaF93Stn2PwA5zNtLiVcDBS7ET7LGBjxNmfAAwRNRLTXckuCXhg
516	fee_transfer	1704	20000000	1	CkpZCuWLPC72jSKToDSRokFqX2J293smZZkWKwRoZYSYiUqvkBuaY
517	coinbase	1566	720000000000	1	CkpZkFZEbgeaiU784TS25NFM3t8nFMdRnKPvgzutqFeVR7KWGnt3X
518	fee_transfer	1566	10000000	1	CkpYdPvix3mF5sdPJrpYXjpWDS7X892Lxg4y5sdDhnxQxAmvJLzdX
519	fee_transfer	633	20000000	1	CkpYvxrq57131GRjYmBC856E3z1aVbXRKzuRKaSUNuqs4jvtcNShn
520	fee_transfer	58	20000000	1	CkpZhKK3CukkqRELQZhMsM5hvWNZiUxcGVfzHdM1DAfjUJ76DWdYj
521	fee_transfer	1509	30000000	1	CkpYcSBfQJy2izDZTuSQxECoHJLkFMHmN3boNfP3G6XMEnnnH7QZ1
522	fee_transfer	1688	60000000	1	CkpZo7gkaC7GyQKPx2EErQqJoDsaNG8koFh5q4WgJrUDomrMzRVFh
523	fee_transfer	1677	60000000	1	CkpYtDRJzBECjpn8KiYKCyJXpJWRxy8CsvTXfzCJb3ND3awtJS4YT
524	fee_transfer	1689	20000000	1	CkpZ9hCtWG3C5wswR886sR788PP5tVTFXxMuPkCNXsr1H8c2BFzVN
525	coinbase	1640	720000000000	1	CkpZ7g8KHPHkm9TyxjcuqhCEf367Eoe97McxnbyTsVsR4bzJ672b4
526	fee_transfer	1640	10000000	1	CkpZR7HJqTy52bP2R6j9MqmSxRDoyUyRKs2SAnZ4u3SXNqied9qxd
527	fee_transfer	596	10000000	1	CkpZYo8vqc9QWFUXUwhCyjHZEnD7KSnaXwyY5XqEPtp11BjchUyu3
528	coinbase	1439	720000000000	1	CkpZXsvc9EVxxgxjk73SuTdCRnoZB2X3rsiDkorH2GMrzS1NF8QmW
529	fee_transfer	1439	10000000	1	CkpYvPiNMXx3bGPdukFEutytnzW3inXZQCfQrs9JFo1fDPh5wdmcm
530	fee_transfer	1708	10000000	1	CkpYnCceiJvDf4tpu7Qz2cvpTp7EeDPrtbNScdAYvAKDjczejMFFs
531	fee_transfer	1678	20000000	1	CkpZvQr2cYKw5XMo5fzGYq6M9fttw34VokA53RVHJZAMfwc1BhLF2
532	fee_transfer	1671	50000000	1	CkpZBs6qfsAj1hhwLhtC23UHYpH3ZFe24ppL2dEEoVfKXWy1HjKxx
533	fee_transfer	1509	10000000	1	CkpYeM4NxQodFo9G3MwxiwKP7ShWxkq2ts8vmiG2eQQuxHKf2Gphj
534	coinbase	101	720000000000	1	CkpZqSyMp9LH3DNWWq6duqSwkL6t4MqSoWzE7cuhHsooK3gytWFsJ
535	fee_transfer	101	10000000	1	CkpZR6gucdMqCthjwmWDFPfWGTfD7HT8YeUkFDerNz42H9zvyf1Xq
536	coinbase	243	720000000000	1	CkpZjxkzALLuCXVFkGKnrAQvMRNXxJY966pNjPeP8BbmqZPJRhRv4
537	fee_transfer	243	10000000	1	CkpZZaUZDMGtPAgUH8hWGkEqddnMgJXso9eDomB1Zw8PGDpUHiWJ8
538	fee_transfer	1715	40000000	1	CkpYhtGTVR555J9ZMKHMXdbgpJCbFe6qkhSo4DAadtPJ3ttZaaZ3Y
539	fee_transfer	1402	40000000	1	CkpZAqcSeXdUx4kFyXqNRkhJf8CpyHnkjY1bGqDhsbajFF5qjz1UC
540	fee_transfer_via_coinbase	1449	24000459	1	CkpYX42ZtkXjpvnfdPwe4Hdr3zqwbaKq3X5ZyJudGnLq1CjGRACQx
541	coinbase	1683	1440000000000	1	CkpaGkWqpXU8aQ3Qa8N7rxhKMWBZ7viDJL7atKBz92XMX69RauLpS
542	fee_transfer	1679	90000000	1	Ckpa9JsoSz9Brv3PCAK7BPNbKEnTzjmoZbFySLhjhVczwwYts2vYm
543	fee_transfer	1685	90000000	1	Ckpa8kCQYNN8hS7NHXjRxdHfFA1qJxP75dPWgWHLsiVCKPq3h93VV
544	fee_transfer	1467	1350000000	1	Ckpa5qHDpcUuyszetJDzZtS8t7kYysWwzoYKa7uV7rsWXJGZwjKWu
545	fee_transfer	1622	1350000000	1	CkpZFGL8yvZpPjwSnzmD4E2vVghW4dJCTAW1ZMJrQxBpYvviSFmB6
548	fee_transfer	1677	170000000	1	CkpYfSWqEjgeQVFP4ZHe2o8uuiz2rzh5H3trLjHeVTvUbZCgBoZQE
552	fee_transfer	1690	160000000	1	CkpYr3HgWimiBgTVRC4NanrBUFHvyFBQoQJ2uURLBzpaZbbcpoa7d
553	fee_transfer	1439	30000000	1	Ckpa9rKjBqLtuzUJqi8A7GQqJaa91YHvsaaSERDWN5GoMQAwuLBJ2
554	fee_transfer	171	30000000	1	Ckpa3z7nntp1ceK1gJnvxjZUe6o2YLyyeC7JzfqtD4SQwxesaUztx
558	fee_transfer	1679	160000000	1	CkpZKkgNKhJg3hT1nWPLoBFyPDffRBBmHbAvfX2Vu32HR79DzG5Qz
559	fee_transfer	1489	90000000	1	CkpZQTmq7e99asHAcYEumRsrPRRrx3jLpth1iwnKvXk3a6e7sqwj1
563	fee_transfer	1700	100000000	1	CkpZPzfp5AeRim8RhGJ1DNHfsTpEFXXGiPbi44EG8vUdFPcEcv2bo
565	fee_transfer	1711	40000000	1	CkpZCYSwmP18v95vwaRADvFnmyBBYSeL5zoFwGbwJQijRGkh3AKGg
571	fee_transfer	1705	20000000	1	CkpYybHefrua8Q9c3aJVRLCYwaGTGih3vpJg68W8CmRRcXJeFaaSm
573	coinbase	363	720000000000	1	CkpZEuDVd5o6Ryciqmz7KD2XhbFGaUPPpdW6m4vWzLg1aAyBQXE4r
574	fee_transfer	363	30000000	1	CkpZjKKrrQfbJcR8aHbJEZzKTeGCHLK4qij4Bqmr6VENGuhoK8jcL
575	fee_transfer	1536	20000000	1	CkpaKn23pAmGPBFVnns5vv78PECEJRkqqrDQCRnbgu43DETYo2ouB
576	fee_transfer	1657	20000000	1	CkpYwdBZ5xzPLVkx348QS538jhrFZUV6iH24wtj3s8zSx3iP9TFSB
577	coinbase	1552	720000000000	1	CkpZSq47YWigSjV2Vvwaezm7GrDgy8GJ7tE31aNACCeZz6wzKd8Px
578	fee_transfer	1552	10000000	1	CkpZKFeGHT7CQbB7faBjqDYGH3sZFo1oN2Wt4UxeENChd5SJPYdE8
579	fee_transfer	1680	20000000	1	CkpZRsanTMxfsbyU8ijvEH662ZXMYaRyFGAEbZrQAV2qVqB45nWi5
580	fee_transfer	1694	30000000	1	CkpZhbiMsVsnDx7nNsP83XH1y8b4TAt79pntSkQy8FMXJirq7vZrD
582	fee_transfer	1608	20000000	1	CkpZaYpyPugNEcDfxLRoH6REvDVFDYDsiLeADxV6ybBmiry9d5Jzi
584	fee_transfer	1740	10000000	1	CkpYUwvEPRwbnKg54xoQz2mocFrBSJHwPgiE49aX9oPsSissVhqZp
546	fee_transfer	1686	1350000000	1	CkpYqx2iRN5ex3HjP4nwWA6XKFPVZ3oAGk7aYWZALZJMSJeEymLqU
561	coinbase	1531	720000000000	1	CkpaEEUiYcw2qduKhJbRYi9FxWfKJQMicHP2wPbZu3ZWxAtYgnL4E
562	fee_transfer	1531	90000000	1	CkpZR1UNykkWjSgDniBsHia23UhaaoJfwD2eheL7xhRWd6XaRDBor
566	fee_transfer	1506	20000000	1	CkpZ7Cq3XKXwQxBqHymZKpukkmWCVJqvEjNA5ZbUJRKonrMLfhp3G
567	fee_transfer	1680	280000000	1	CkpZD7j7R2jhJmkPpfCJJhAk7wxeHShMc65qck54qoVc5PK6nQFEg
568	fee_transfer	1680	420000000	1	CkpZFFXB7fsE6iikadHM277E46hdsBKmzMhkq7oCWW3hSmVd2Yqpz
570	fee_transfer	298	20000000	1	CkpYinGotE5Z7oEMHBdn1xUtZpNVPiUuY5LdibrmVccnzZA88cSWK
572	fee_transfer	1679	30000000	1	CkpZzphHLjy8mb9wnVrMayD9fiEFnND6L8ch2anRXbz2hWWkGosdK
581	fee_transfer	1402	30000000	1	CkpZBJuhKxY7VaA6D5wPV6yYGQ7sN239Y8gBjDoc9CeCckm1P3LVp
583	fee_transfer	1650	20000000	1	CkpZY1jL4C6kuia1BYMmb2zeNUjYvrsEc9Gj7AvkPChNvbfdCqt5Y
585	fee_transfer	1455	20000000	1	CkpYnTwQCSfs6aSf7VXN1BYZSFNA5rdHCEGTe1AH3xBHuRqgvXaMe
587	fee_transfer	1471	30000000	1	CkpYpS5wVCPnFwcZBARydbG8PMGdnY1wUTjvKFXVjrJbGaXLe3XEX
547	fee_transfer	1704	170000000	1	CkpaGJSWsUeNMtZfAvA6Pb2D5MqnQ6C3ZQCDZqkypJ5cqH3SztJax
549	fee_transfer	1709	170000000	1	CkpZFNHMj4B6jkApphbmcfRTAKzMKSYewY62PHEundrvyMyKkxWKJ
550	fee_transfer	1704	1370000000	1	CkpYv8dtsML91cWudYbt8F937AHX4dRqbq2imeUtVprp2e3UGDeeG
551	fee_transfer	1704	40000000	1	CkpYU9MeVfFMuetbRCRw1zpLHfdEoGexcG7pQqUkUavSj2iRdhmdx
555	fee_transfer	1723	30000000	1	CkpYuXJkDVEnRcz3vQaaGUT9MARtduN4S8pG5RtX2NK6e7Q3vz6iD
556	coinbase	1495	720000000000	1	CkpaGGziFaDvMaE3mzmBTHSogLMDdiFuT9YmdsEkLAkWaAUSRq1YC
557	fee_transfer	1495	10000000	1	CkpZADRzkTg1Lvi52aH26198phRNBESAQTnkwmyv5xTKugZk6R1mB
560	fee_transfer	1489	80000000	1	CkpZRW5jTt3Tw4NvsEC2bgWp8bjtLrF8jobN2rn3tubkG7iEvSohc
564	fee_transfer	1688	40000000	1	CkpYWm2k1aDjGkVygSm5HVT5kuFvXWqr4aV5oryUydiqHNci7LotV
569	fee_transfer	1688	110000000	1	CkpYjFazSU6EGsEpzgazygEwYrPWfQ6sTuSGWsVpfrHe6VfojfAqC
586	fee_transfer	1717	30000000	1	CkpZumd1n8bZTWp194wQ7o1jfrLpdEboePWu19HWCW3ApCrF9VxQK
588	fee_transfer	1684	40000000	1	Ckpa1L2QBe2XCSvwqqBCwXDhrXraCFNHQSrhddXqQDzKhq3CCyRR5
589	fee_transfer	1693	40000000	1	CkpYxxm6xG6akSMRqwGf8WTesodoQdrafuWyWxcmwdZDyDQWKp1Fj
590	fee_transfer	1685	40000000	1	CkpaDMgrwrQywPFM8yoZ7rXxxP5zvateEqgwcXwxwYPNB2MPs8hw4
591	coinbase	667	720000000000	1	CkpZ6GMPY81GHk2QfmtsaJXRdKPSe5DP8fnysM9TamtunmQk3hfDd
592	fee_transfer	667	40000000	1	CkpZ7a948TZjHghPpUzKVjogUHEpYwrez3ifnoRCEiZhgi1NsK9kE
593	fee_transfer	1690	190000000	1	CkpaAW5y2mMtPACmAGavGcFtRGjC7AKo7fUdGFzjPcJgAraRpsMBd
594	fee_transfer	1602	30000000	1	CkpYevSy9H9Nipzaf2xkK7xUozNSZwTudi6DFRr1AtNzkrib9jzQy
595	coinbase	1746	720000000000	1	CkpZrfMwxNhxqh4YQEWheGxDuXJfe29m2HSuy7W7ZzWc7UY9kJJGa
596	fee_transfer	1746	10000000	1	CkpYzf777XSXPbi4q9oVWgtXfgbmGrsFVH8SjjF77EJR4pTdn4nJm
597	coinbase	1747	720000000000	1	CkpZRJ4R5PhX6hKAEkPpJ2CPfTYjXrhMVUhfHCpr1Nq3D8ZKRyctW
598	fee_transfer	1747	10000000	1	CkpYVwBreTPZxnYTdZqRNLNE3dwEgkypqsQv9zfUVxGwdnhjpJwfg
599	fee_transfer	1704	10000000	1	Ckpa2Jnhhz5SFBm5GhEiBQ2DJpGm9oPnF7R8ibYhUZkjo57Z4ZnJa
600	fee_transfer	1683	40000000	1	CkpZN7uf3TgPDNaHB3DQz3j17WkQGyGLjohzvC5VRtWY9zxmYKxiV
601	fee_transfer	1694	40000000	1	CkpZoLuK3dSpR3BCKBHmEz5gNFhKpbbVPTNGrXs9gq621Drfr5QBa
602	fee_transfer	44	40000000	1	CkpYw21RW5D8xyLYLDGrWfYjrkLniQW18XFD4zNUc8aggp5ZCXKZQ
603	fee_transfer	1724	40000000	1	CkpZz3ZG4aeuu3R7NvC78AzuKMEPentZg3t7AMas1cKF3Db2sfpiY
604	fee_transfer	596	21000000	1	CkpZB8G6QfBkfgSjJwaVeMA8mEokct3BEtCqRAJ7oxotuXKAQ7Apd
605	fee_transfer	1649	21000000	1	CkpYnFHL7J3QUidP9HjcHq7zmK4ZpKdzECbN89MmQRL81j5T1UDZg
606	fee_transfer	1516	50000000	1	CkpYdk8sVe9fcmXNkM238ZtNSaCAdYzLBWvw6jyAVUryCjJTXjFfR
607	fee_transfer	1489	50000000	1	CkpYpyxUBSvQqcixTotSf4XfuzahqHYcxeYpZo8HnwoATGc3xKEAX
608	fee_transfer	1696	21000000	1	CkpZd3uQzGg8bFE5pmfVkHSun3TSZYcshnP7eniySnLozbdQoAnU6
609	fee_transfer	1685	21000000	1	CkpYQAJ9vqCUQH4NL8wiSEfPyZJtKsiB3TC3m7v9aD5da3kVrSggx
610	fee_transfer	1716	30000000	1	CkpYbBNkbkWdxdrurPKtwYhxL12HskzrwTEAVHF9rh1pWFRVoZU5q
611	fee_transfer	1690	350000000	1	Ckpa7tdCDYcTPaZFGuRE5rjU52KWhUJd8Ht6kRDyQdVZe2wJLMxcL
612	fee_transfer	1690	163000000	1	CkpZSRdSRRGw2hrhQW4k4PqYdXDdCqUe2cx79DjewQnVGgDaPTKM7
613	fee_transfer	1439	20000000	1	CkpZZvHxEYguWenfL6dreuWouwF9Kocav1GEsLkc2KSt6C3wHetXD
614	fee_transfer	1402	31000000	1	CkpYmuP2ho8tr8n5ta7WXvf51J7Jv2C54HRJBWoovjtNtdM8K514m
615	fee_transfer	633	11000000	1	CkpZHTWcaqcdfW2HweETgFs2j2jSBA56dyYwqg1RjDCMjxNUphfVu
616	fee_transfer	1693	11000000	1	CkpZRMMvZQBB2TsHWLFgKWo2WKWc2TuLFhpAeFx8uNNzj8eWGM3tU
617	fee_transfer	1724	120000000	1	CkpZqVA1ZFFh2JFBXjc3BhnzFVj7uz7vC8XSqf5Pmxncsjf9N8qfb
618	fee_transfer	1690	341000000	1	CkpZCXmuQFqv3NGhNHVhuML95w12nBacxcL1qkVg9yANJTGTot5to
619	fee_transfer	1687	20000000	1	CkpYSsGAtG68kfDGPVqmYVhnTYSo8QLbXNaZZUShyzkNB23pzwVLS
620	fee_transfer	1714	20000000	1	CkpZNz7VEnUcRMRruo7ZX7oUs6WjZgbXxhEswx8CcRkPoztRfNcG6
621	fee_transfer	1709	60000000	1	CkpYf7rvQAcBXpD4S4cHhpYNJfh8z28Gm9yjedxxe8Rv9yG8x5AQu
622	fee_transfer	1711	60000000	1	CkpZQ947hpEyCsE7gxpzvFi4rpg2dL93vQM1qdjaP4abEs9W87dzE
623	fee_transfer	1694	60000000	1	CkpZnZ2gtUy3W3521xSkLWyseYNjKaghnQh5hTSWmgiZwmEewwuSt
624	fee_transfer	1699	50000000	1	CkpZPXJ7dh9pqL8MNhsH4eYuNhPWwedQ1QngkScXEEY3N9dTGteXe
625	fee_transfer	1700	20000000	1	CkpaBkgRfJmtuvJsN8T2rA6jPBtVpdHUhJ7Gvbq7Rcjp9LbP6n4KJ
626	fee_transfer	470	11000000	1	Ckpa7ogmGXDP7UUJRrv8me1DrSgUzaDBzuu5JGS3GgDxpHjUJFHdz
627	fee_transfer	1467	30000000	1	CkpZoxs1h5or1EWwp2aXeff8YEfU9oqkugiXpJZk2NEk9S9G2PRKY
628	fee_transfer	1690	541000000	1	CkpaF6yJ2kBoqRDgPogJWuAMDSbbAGeM6NAZ3nhu4ZVv5c5wwBiwJ
629	coinbase	1486	720000000000	1	CkpYo34Kan2tJWycvhSbT1czWdx7hkNCrXFcsJzT6txpzHqTCH8W6
630	fee_transfer	1486	20000000	1	Ckpa6hjwXsMsxJp9RriGPiAqyDntbFhBj2fSjWv4tRdpg9AXF34S5
631	fee_transfer	1623	21000000	1	CkpaH6ybgnKFW6RWadTd4zhpvVH5unm1vQa9DsFCHgkUV8bHj5xw5
632	fee_transfer	1694	45000000	1	CkpYuFQZgd2G8hKnxJAVU49hvfqfZho15B3AewFdX8e7D2WXdQJDi
633	fee_transfer	1695	11000000	1	CkpZFz1bnVDq38z3qGsQtpYFwK1RAa1koCvkZqDEeir7ELC9XLHbe
634	fee_transfer	1555	11000000	1	CkpYW2iqrn1N9iGFPWQCDZeTqh7krNfiCZUYQKgQGx8vzAZ4adTXZ
635	fee_transfer	1455	40000000	1	CkpaGGAk3SJdgKSmRCjJz4kZW9j47b1YYDA76ymaqnuXYx77erGoS
636	fee_transfer	1489	20000000	1	CkpZX3a8rthyoBvKi9Tsq8JA7HnZpK9N76h7qX1pZqXdP3SM7zREz
637	coinbase	1751	720000000000	1	CkpZWXvbme8k1pG21UpbgnVdTo9nGQM4W5w2xAyZw9fxvbXWqQXM8
638	fee_transfer	1751	10000000	1	CkpYRucXrPuiV3hGZspwiueSBqsPapWPGJbVVRR42DQ1aV82oELT9
639	fee_transfer	1690	125000000	1	CkpZtk1KHcmfsp46woiGWqw4FkSs62ymXb2DWRJcTPqR4t1kFiKyR
640	fee_transfer	1690	121000000	1	CkpZKv85iWPRAEKVAJBfej7kLq5kFm2UE5ih5UUTvbLomFNzcnjgY
641	fee_transfer	1693	50000000	1	CkpZF5b1Dz6voWKvroimizQPiV68kSNuShKTiK76vwpN9bKt4wWqC
642	fee_transfer	1716	50000000	1	CkpYauVJVj6PQFHeLZPeg8kqfV6Z7NcXLtgnKytMR5fGNswjbpCrL
643	fee_transfer	1546	21000000	1	CkpZkzZqmVbR2V7sTQEfRhxP41mKNBeDhtcdrFCdyLqTYk6sePic3
644	fee_transfer	1722	11000000	1	CkpYccq82aZSFbbcj6F22RzdFbp6Qi9ApD4VBQKt14FNRpm1VuFRm
645	fee_transfer	1687	11000000	1	CkpZj3VsXRfHirAyvwjcy8gi3v65H1ZXQFZ1RbBG6KGEafFAuAqWo
646	fee_transfer	1650	11000000	1	CkpZcnRDBTZBJ7yJdxdHGrSitUmHVu4jdMptjRya6V6sBTyZg1Wjs
647	fee_transfer	1690	250000000	1	CkpZFJcceCCWjPqRgXYX7w1qwhzc2aUq38SGGFmABRgYgpZthSqws
648	fee_transfer	1689	40000000	1	CkpaFZ4do3bJ1Aescq8dAQ91CuRZnTkjZ4bMhYCERdwWfEQQXNoNi
649	fee_transfer	1601	40000000	1	CkpZF6RMFaqSUk9e4hvLDhRGoVumARPGhLxSCxswQ3m2ztAVDpJpV
651	fee_transfer	576	20000000	1	Ckpa7221vbbyA94uDxmCx9RoMo4o6iQmWp3RGEFNcv5gmPFxZRMcJ
659	fee_transfer	1541	30000000	1	CkpYpUubgB69DR14NVkBfiukr9xvhGQRdzwfXAv6EHnktzPu1wvBj
660	fee_transfer	1422	895000000	1	CkpZ8jcCDTtDo4wZwSMVoJkFGRrztUSrbBKgWSS96DkbdfGEumk5k
661	coinbase	1422	720000000000	1	CkpZpWCbjbHBYj6kZ32MUmWUNnQZKEEv5QvBemnStnVT8FKHoRynL
672	coinbase	1597	720000000000	1	CkpZ5jsyXdadG2cU4tbT3Ssv395iaPav47DycCskNVaDjJtchqinU
673	fee_transfer	1597	10000000	1	CkpaHUnZwELkCQak31PgeQRQto1ddnC7hPGoLjBZsYwPhkGe9SRbi
680	fee_transfer	1445	40000000	1	CkpZhAyPCHnFsi3AiVQ7sPUbbPdmhkjWXpsYLPJiK4Vsn97JQjLoP
681	fee_transfer	1634	20000000	1	CkpZsZH6ivBL2HVaopceVg4AKHCZ9wwR4TEWYdmdKQXavmMZ89kvY
685	fee_transfer	1656	40000000	1	Ckpa3BHUGoxB8nxRi4KAyMkxpWgo61CPDLTKPCSKgwtcaVQoNo4rz
686	fee_transfer	1555	40000000	1	CkpZyynxwRcC8YmH3tUV2N8fqiPbHYV1kTTxiqVbDedeJMCRncind
694	fee_transfer	1678	721000000	1	CkpYVfGXMx4rgB36soBm5VpxcxqgYazLR8MCJFHFeMS2w2E49ujn6
650	fee_transfer	1686	50000000	1	CkpaKmLx9qEHTHXR4ucoQgzK3zo8A95Lk9JjRhHotVCmWmhcRwy45
652	fee_transfer	1690	400000000	1	CkpZx43mGqAZMQGCKHHXwepQb1znA1o9bdFkDVZgwKG3UYoB6PhUk
653	fee_transfer_via_coinbase	1667	10000000	1	CkpZeW6K2z1jooq4H9Cn7jZusv8JR78bGrqAbLoBrzrsXi8WeVDGY
654	coinbase	369	720000000000	1	CkpZVy1vq2AjR2ZerW9meBYT689UnDYPpeT9qWVCfFqNee6WefeZ6
655	fee_transfer	1711	30000000	1	Ckpa42pCRJrxXJHLUvDSxgrnitrNgRvFzeDR6XCmuPSiRtFWGsEuv
666	fee_transfer	1684	110000000	1	CkpYWtVJomqAATg2fucmZwJEWZpwH8oESzUZyoc8BYkjsi3mBYxdc
674	coinbase	404	720000000000	1	CkpYjuzq4SFfch4czFuy5XigSATEMG8A2sw2s8EMtyJWHm8EKMvRh
675	fee_transfer	404	20000000	1	CkpZbjccXq4qG3dLkfv1r3KBxMJ15cwwVn3q9c3rJAFhPjMij6BC2
677	fee_transfer	1690	50000000	1	CkpZxBjfUedQzLxRThk2ohicaaW3to5CruYFaJ2DcapnKDfTQdotn
682	fee_transfer	1724	130000000	1	CkpYey14CGEyYp9wzVDAurWVJ7KJLTwP99XgDDwBcKCWkEAgf2uFc
687	coinbase	1420	720000000000	1	CkpZCiQ6g9kZxqfpVcKSmPTDqom8mbUPU9NHPdac4tHEwNMjKC9L5
688	fee_transfer	1420	10000000	1	CkpYg4X7XZJP6sZc6dh5FwVGzthzAQsMkqPwhLdTSpJwywCjsYXGf
690	fee_transfer	1724	310000000	1	CkpZcB9nS18yMjEeGKC2wm6hX5LbSc2Morn65yNV3rnNS3mVYrD4e
691	coinbase	327	720000000000	1	CkpYfNwpgiDGDZvDv2Y8eE1MSzdX6Z8w7UEexX49qYGkAwu3X8gBL
692	fee_transfer	327	10000000	1	CkpYQXrYJnK1HCEMYrrTKJsjkiSZdP8nugUPRDV7KqWpVNnaBvA9q
693	fee_transfer	1611	20000000	1	CkpZuzrdkbc2uL3ifC81i8noxiy6JUt5dLt363983GxMxxcNcELjh
696	fee_transfer	1709	20000000	1	CkpaFm9ujU5g6EMcUTeuDcT5bDw2dr8bJXtiRw26xxiHMLcoX9oCb
656	fee_transfer	1522	20000000	1	CkpZyQMbARAcJQVTMuNee5o9vUXpamwyBqpP97YFRpLWaSLagBTCx
657	coinbase	519	720000000000	1	CkpZcy3XW1BPi6CGyYJpGYVzYt1zf1ab1JHdjdeq1ZVob1DJNufh6
658	fee_transfer	519	10000000	1	CkpZs34gLt7n3EwstLU7HRjPhUeqmUhoG27vyFNrNu16PzePvha8d
662	fee_transfer	1560	60000000	1	CkpYZLQnVmfzKztMLkTyawNpiScqKvucVo9uL13acWMzg4SMFJCBS
663	fee_transfer_via_coinbase	1440	10000000	1	CkpZiiFnRUhnfFdVAjFjadbZw7BdkYgv25udySJKJzhZCPqyU3C9C
664	coinbase	1560	720000000000	1	CkpZzLAuKQovxLe7D8fm5oBufzE1g8JEpNgkc3x4KVEq9oaSEYqzT
665	fee_transfer	1447	20000000	1	CkpYtXCojr6LR8WEPGypkCoYcjz9FaG77Dbs6vr59ZPtyVbGDGeh2
667	fee_transfer	1678	965000000	1	CkpYu2Ws23rcwzzb9ivwDBP7m5qRBUcCVPSRgJm4fSvZedkJNdDxw
668	fee_transfer	1678	300000000	1	CkpaCrZRtnBSPDC5RBvvosxMimdLixQCooZV4bo7mqjL3wYrzuKE9
669	fee_transfer	1422	40000000	1	CkpZQmaCuTMbequfkYFpHosx4YfaRhnuKnD639GpAiWqNBzEUy8xa
670	fee_transfer	1681	40000000	1	CkpZdcM3ZA7eDLnxLGJfc36yCwUZh8yaRYAKxuwN15YmSN7a3ACpM
671	fee_transfer	1690	430000000	1	CkpZRu1rmVnJpCPLaUJXvxGk19zbRQ49Yk12dmiQd9oFXSFzGM3dF
676	fee_transfer	1690	120000000	1	CkpZtSRHAo45XXfU16Xn5QVgY9PHNLSvsVdd5FHQ4FdCcjH6oFwkh
678	coinbase	1662	720000000000	1	Ckpa99mQMNuW7rMPz6FTZG1dPrN2zpyKnE1Z619cJYrv6TP3gEBm5
679	fee_transfer	1662	10000000	1	CkpZm2RM56v6jJaQHAanDZnSZHmFav2B4gyDv3yhmioNmXt25dq7d
683	fee_transfer	1547	20000000	1	CkpZNW3KyKPH6bBx7XpHiaRxUTbyUpoujtPvLFyv5BMB7fBgG7sp6
684	fee_transfer	1680	40000000	1	CkpYUV5PEAedDvLxFPwydUKZ1ovZY783BwBYBHQeji4Dta2m25njH
689	fee_transfer	1690	80000000	1	CkpYa3CsKCRS7ZPeMEELgfRph9r8UB4DTfmuvCTCdobi6g4XKz1Pj
695	fee_transfer	1536	40000000	1	CkpYY6pjBL78ax68ZtctwZbVPX5eDWXHavdXnbZcQStUQkKWuxksm
697	fee_transfer	1593	20000000	1	CkpYWQkUFAArsMZYcySz9Btmhj3LxnGfw15Txwo456M3kzGhAA4hX
698	fee_transfer	1724	110000000	1	CkpZceKACPStVgTEyhviAFegrgnXZE8GqTPecjZrJTVzR8tQt4FDm
699	fee_transfer	1698	40000000	1	CkpZ1Ed8Eg8wkefx9x4Yj77jZ9GJna3cpSLK1KX2rbqhUqutyxF5p
700	fee_transfer	1724	90000000	1	CkpZD9at6Moq8Siyfpsvw7jWg3VbKb2Vkd4iQ1F7Qg3zwUsELht7U
701	fee_transfer	1735	20000000	1	CkpaGZ56YgjC48V3JiDqGZYXuLAnq4CUcww7zvWoPn9LGAqJzXR2o
702	fee_transfer	1656	20000000	1	CkpZZECzGW7KfsTEZUKUsBnH9xnP1ArBAkZYzninSwtYmDMQUZUcS
703	fee_transfer	1587	20000000	1	CkpZzU9bXMcht3BxiZ3dmdC5KZMZjKgtXE89JbfNwupt4DWhUsBmu
704	coinbase	1755	720000000000	1	CkpZeA1E97Pdgkfup2ssuCZqbSbvyB1GGUtE9GtEmoZNQty3ww2SJ
705	fee_transfer	1755	10000000	1	CkpZDUsUgccF4dwbBhBYDT31t3ErvXyotEvfwV2VjeRY2tHZdpX7a
706	fee_transfer	1426	20000000	1	CkpZR2x2v83ew6hSW2ZmCtrp2Zzmcx1oV1xkPAY6Z5x8uS1jd77rS
707	fee_transfer	1637	50000000	1	CkpZebfb3szQhLm1T6oiS8SQqM8a32Y4yqE6CogE6eEjCkpb33wJe
708	fee_transfer	1722	260000000	1	CkpZHrrFNW4xjP24Vfr8AwU8kyM5qHV7BRzCH64SpD3VGXxha7vYx
709	fee_transfer_via_coinbase	1505	50000000	1	CkpYWGaADPg4nrxBJiaecaiV5MTRNP9pUSnM148geYhSn4Gn89nvR
710	coinbase	1722	720000000000	1	CkpYYbQ3GSa3HtLzD448pVSbJBFRp61fT9uXPnoCegVYGHXThin9d
711	fee_transfer	1677	120000000	1	CkpYyXTHLjYB1vqMXBH24jeRB9SAo7JYqe5eZsnDqtCbf7PeHjHpp
712	fee_transfer	58	120000000	1	CkpZfQCMsHwvyyynQnMmc1BNLAXCzjUfbhcAC1SremRugVxVPWQaw
713	fee_transfer	1692	21000000	1	Ckpa28imjvBrD9qXch6H3J26vPmJpx3qgutho2VHm4XbY6kwx5VPR
714	coinbase	618	720000000000	1	CkpZz8JF2sWFmWR7Jd6xstrzesAn4TeLncnE8EVuj7jVNCj7mHZdC
715	fee_transfer	618	10000000	1	CkpZmgv5JPepfUbYbuEMrageh15y9jVtKet6Lg33vpuVwqxARxkYX
716	coinbase	733	720000000000	1	CkpZDSGJRSmBCVvGds2EuWuhUCz4cHpdfXf2gu3fujZPjcSALngFN
717	fee_transfer	733	10000000	1	CkpZr8jUQFoFpHT8Qem6SBpP8pKHyHpQCEbuidBxjXhpozuKqwoEo
718	fee_transfer	1706	20000000	1	Ckpa9oiRqbyizqzgLmreaYpYCKCF8qcPZHecFF2y25qyBRsejDWFm
719	coinbase	676	720000000000	1	CkpaC1jFLHHnhxi8anzzYYbmq23mGgPTWZ9o61sHakxtkb6KLHRXd
720	fee_transfer	676	10000000	1	CkpZR9B1qTF6hPzDn7Pi7W4js4mxV5RVT5fEh7FXA8W38r4ByeG59
721	fee_transfer	1622	800000000	1	Ckpa33WtXP3hyS3mVdBeVZvangkrbvbNaeu3EVACcN8c3VHDtASNY
722	fee_transfer_via_coinbase	1449	240004599	1	CkpaLe8DeJao9yaw1ZJZG8kXpQqMZZUcEXENEXRZPmFv12pGzh9H9
723	coinbase	1622	720000000000	1	CkpZ4ZDsXsDSXVKTn9qY3JRaPD2bA8S95ZzcwrvfcWro3aNxeGWXr
724	fee_transfer	1708	30000000	1	CkpZjFSCvZLvfyZg6AikRVVjFKeYRfBv5NZ3PHf3CmaH7eioqLjnU
725	coinbase	510	720000000000	1	CkpYSefkaBnP3WgCy6yu6jqWUPyA3f6ytZcVs5PBHDpQkkaL6t4ru
726	fee_transfer	510	10000000	1	CkpYhiXtghPxJeg4HMBmywyR15sq1cHrLiJmNgB2f79wJ5h7euNVm
727	coinbase	1429	720000000000	1	CkpZYewPeXVCUS9y59r1cFqZdMWVDt2UYh68HF2DHpvmhhzoLtz8i
728	fee_transfer	1429	10000000	1	CkpaKbv6yAqKiVYMFwxMiXFrYKGGbpkrzrYBtHaqQmBSNiRhFKXoV
729	fee_transfer	1564	20000000	1	CkpYtycbMmCZYGsMZaF93zvtcMKz7aMBpuswb3kx9wvqR4QEbYhrt
730	fee_transfer	1719	30000000	1	CkpZ3fgwQvtXb74R7Gdt55h46jESUhfbLU79GpKVuC62DPPQA1Grz
731	fee_transfer	606	20000000	1	CkpZwy1W3GkPaCDQpp7caH1SoaektQSfc9UfaSPcTuuF42Szbm5e9
732	fee_transfer	1489	30000000	1	CkpZpojdS73WMx2ciiyFWiGhmPUTqgMsk4ccZDHDeMScUvmaSf2QK
733	fee_transfer	1522	470000000	1	CkpZb6FRkZLrckhgEZrVpXkCfnvfdZiEpXJYDWz6ANzCeVQ4aT7Bo
734	coinbase	111	720000000000	1	CkpZPfWbkh26khpSruXKR8kMQF7qy333vVBAVDvqunsREDVXTyX3b
735	fee_transfer	111	20000000	1	Ckpa5GxcBeCqARz6121ofW7ugpJFWWCZPkBZ5zg1xQJAMb6pgGLac
736	fee_transfer	470	60000000	1	CkpYh38f5MEWKpbZA9URzna4iEoZRgvS9PdLtnADLWVp2JLCFdwyR
737	fee_transfer	1724	420000000	1	Ckpa9y5soAVh2QyEqZ3rqUeVbyW2QkRArR6qsrNUurjpfARbq6KoQ
738	fee_transfer	1724	820000000	1	CkpYThnEdGFifCUwgNoVcY6bVvrFmiKRp8YSdY83Ukbece7R1bSd3
739	fee_transfer	1682	30000000	1	CkpZmpPiQNETv59ahKYbQAcQVmu8AguZq2SfYbna36Ci3bu2Aqvhe
740	fee_transfer	1588	20000000	1	CkpYvDaoKbwiotns4QgtNiuCE5gSX7dwWW8Ym5sYFdWWRiashTcim
741	coinbase	162	720000000000	1	CkpZgHBYfZCkgGzr8LXb13QH8ofFJBEYdZSoX1tmE6ZiXJKaUv13J
742	fee_transfer	162	10000000	1	CkpZXJNwWPviKWT5oya1NLqdnH7JATbXNtk7SW5urjtun76wCYftR
743	fee_transfer	1643	810000000	1	CkpZTekkfRb7ZXx31sFJiJYv7xavXL1KUXzZ3X86uh38CKYu5fYX8
744	fee_transfer_via_coinbase	1737	100	1	CkpYWUTrd2YqdSodDUHTNVU68SMZsjYWqaxQ7Bgs71Nbix9UMHUhK
745	coinbase	1643	720000000000	1	CkpZghxqaoMgWqZYmL4v1RjGukSQtfGgbUADgQVvjAg6ASYdEQ1xM
746	fee_transfer	1549	20000000	1	CkpYitQzAw3FBfiHBLxpQoNb3JYynVNQUApndLjNeWQHRgw8nEb7m
747	fee_transfer	1508	20000000	1	Ckpa4wCS2krPYYbiZE1uDpBjd4nMr3wAYiryaomwLAPEpFfnKVVBY
748	fee_transfer	311	19999990	1	CkpZLUVZ2tjf4vJtfqhb96RPit6M8aybGCEn6WWevcxMd8HrUKrWE
749	fee_transfer	45	10	1	CkpZb49YGQyQLnwpo3oNLc7nqu8zTdbPPKJ56eQcSV1j3jyviFrrG
752	fee_transfer	1623	130000000	1	CkpYQHSXdxA4R2ysJgamK3vg1P27uA6NKtiWKbuJdkfhHCnvVSTcV
753	fee_transfer	1623	350000000	1	CkpZeauVJQkW8mmMuSWkPs1uFu7MGZDSxPJQ4vRUbxrsayGjm2FYN
755	fee_transfer	1727	20000000	1	CkpZhkwnBCsiWipWtahmEQXQriZcdzfZiEYdzanEaKUufB2TPxPnt
756	coinbase	1757	720000000000	1	CkpYpV7b2mXKS49wmhn2xaWTTLmxxMGsB19RewK7KKPW6xHDT7NDi
757	fee_transfer	1757	10000000	1	CkpZS3o2uRJ7vznrN8fep4bpmmHByoabJPF2RiWSiDsp4LimqUijt
760	fee_transfer	1456	20000000	1	CkpZbDAGje8XDF4yNp4buP3Twd6jRJDLrpAHtGfZAEPfnV6SnqDwa
763	coinbase	1466	720000000000	1	CkpZT79s72bEwERHrmu6N3XzjWbGSpUYeHAnwgyNAdqtdo1WU76gJ
764	fee_transfer	1466	10000000	1	CkpYiUqyxHT21yxP4RPsFNWk4iKQE7Mbic4vQFMdHGv655WL1QN2m
765	coinbase	1521	720000000000	1	CkpZzFxLR9X268Pq4ReQqfQrr1JEmGZe8Fyh2qGz1c6hR1r1siYNE
766	fee_transfer	1521	10000000	1	CkpZMdBSysJgrLQeBq492g7irQY5oaHNcHkE4oFRvdn9smMEExCN3
769	fee_transfer	1708	20000000	1	CkpZ2Qf3kEcz8srGrh6yBWLF8K8xmAUCvTftrV72PinM7EAp2tR2V
772	fee_transfer	1746	110000000	1	CkpaL82DChBKHwYeEErY8W1dLZLiHhh2vc7s3DuZFE3gS9bFecbeT
790	coinbase	554	720000000000	1	CkpZVKuyV8PSaPgEF58oyA7b71WBXnEDnuYbhmpkXzq5vhYfzktSB
791	fee_transfer	554	210000000	1	CkpaHGoHoLSsjpfqPUJ1wjjmC1qcD6qtgqvyTPjXCVEeSSXjkyCP5
794	coinbase	1643	720000000000	1	Ckpa1gGWQbUWgFyKghTjV2sQyQpszrGrFY8xMWRwgbmstxdKMsGks
795	fee_transfer	1450	30000000	1	CkpZRDD8DqfMRWkC3zRjb2sbS3GbrFHgLwp1y3qJ2gTUCYVbJBKYR
798	fee_transfer	1675	40000000	1	CkpYT9ikxvynpc2nPkvfPqjMwDR35C9mNVB9rZkDgvadmfQWCxAr2
810	fee_transfer	1596	30000000	1	CkpYnvCgrBhNiaxMNrLLRGr3TKs4XTdDnQnVGY2qGgsbe5w8vnge7
813	fee_transfer	1746	30000000	1	CkpYXhn5mR15Hi91AZSDT2CfUmvhDEc846NvXpwz6QGmQrcazbTQK
750	fee_transfer_via_coinbase	262	100000000	1	CkpZNc4AkYUbcXXg95bAS6Y3kniqU4mex45EJrWZvJwZ4JKMPysM4
751	coinbase	311	720000000000	1	CkpaCqB1N8FpcahoyXnsyafLvPjdRr8wtpAfdQCAAttVP6o2dBZwg
754	fee_transfer	1506	60000000	1	CkpZHBYdPekDytEJgpsP8XboHe63Qqr3Po4L49CbW44ZbQ9MJQKLt
758	coinbase	336	720000000000	1	CkpZ49nPe3vUp9U7Ef9MkojZUhZY1WTP1bYghXpkVew2c6WMf9o3S
759	fee_transfer	336	10000000	1	CkpYh97GoMMNod4nYqv8BAZ2AyopCTctUCyT5UuWRx6wMXj3gRwCJ
761	fee_transfer	1740	1010000000	1	CkpYSZNWz2sw172T7RKYFaTUdRMHh2WpUyhe7QFeWLydqhw1wrSxX
762	fee_transfer	1740	240000000	1	CkpZu64FHAGvYm4vXGb8MPgmDDugvGbCdC6gb9mmHkfThax7ZNoQT
768	fee_transfer	1746	20000000	1	CkpZL88iexUXk4dcFJ3ApBUPLTEXUaTgsfjbszsd5cPuQmd31pyjL
771	fee_transfer	1747	110000000	1	CkpZ6ojMmj9jAg4hsHM6UdyBYShKTRAUKLUhnT3P71Xzoe7xS7iXo
773	fee_transfer	1423	30000000	1	CkpZzqAgBcv7dE9ijuxdDRCui5wsXPKfADzaHLAMU2NQbX8eFuELs
776	fee_transfer	44	9995100	1	Ckpa74jZ5q9Rr83BJ36MaYJQBEWY2wKN59jVpwPnFMCnjQkQQqo7s
777	fee_transfer	1514	4900	1	CkpZHUpn7Miyk6QV4STSKUt4AYrSTcuBGb3q2MiqHV4SzBGYguAX5
783	fee_transfer	43	710000000	1	CkpYjZwMMvdJ9memQJFCFgKZGwTcaweHWQ7GFNMCG5N4mRfRfKQPP
788	fee_transfer	1722	110000000	1	Ckpa4oqf5Ztqqat1VQpb54ariGy6rBUur6dECv4sZAPoEYP71hk1K
796	fee_transfer	1450	10000000	1	CkpYQUpsnVNEzYx2KMxiAwdzzPkLfQ6oG2znvKkCXW2UXMn4HDjxk
799	fee_transfer	1737	300	1	CkpZUDdLv6sZdV3bRfkMzgo53nAysyKgfzUxxoaa6fvmFVkXSc6Cg
800	fee_transfer	1643	84999700	1	CkpaE4pRStHTx6sVdzcn8fyYbwKkj6SBvxH2dV4eP88csiZJ2rp5P
801	fee_transfer	1650	25000000	1	CkpYzG34pdEmD6E29M61eTwx5EHMG5CvBDNFwptDybjRmQ2Pf1Mqc
803	fee_transfer	1643	40000000	1	CkpYhS5MuKmsosAC5yfUuGzWysZpCsrRDzpcKg5VKFv7NG41KvAs7
811	coinbase	1622	720000000000	1	Ckpa7kedpeM1eC26Y3KvZiGqzsV8U1LHU9U5zTnJD5Fun4de1ZRXR
812	fee_transfer	1668	20000000	1	CkpaJJNwh8GvZyCYPUNASHMwBkvYJXcA6H7CqYiEsQbDfahn2gvzC
816	fee_transfer_via_coinbase	1580	10000000	1	CkpZ1nf6bXbhKgf46UJbrkFQnUxwFmWd9xHAPBAz752hbN9geCmcA
817	coinbase	1679	720000000000	1	CkpaBLFmpyJfYsk6LwxVHBFTMfHr7JwTKWEbi6a6kS5HUvZoVEaCc
767	fee_transfer	1747	20000000	1	CkpZUDk7ztnFQpHNkguvaRPn31kMNwLhQYam8Ra3RykPvcQiVWTZ8
770	fee_transfer	1704	110000000	1	CkpZXXuvwkmoMQdYNeL6RhWUZx7UQ94p6pFQt1bUMf2d9rwAdBtE5
774	fee_transfer_via_coinbase	1537	10000000	1	CkpZVTtLNUMe3MuB51TSVPZ2Tnq5wQb31VcVYPb9E5NSuEaoWBR7Z
775	coinbase	44	720000000000	1	CkpYqYkx5WL3bxFLAz6eRXK1jT8wqpNLbMK5ZQDRNsnm37M52WEjy
778	fee_transfer	1698	30000000	1	CkpZtVe7RjNPV2sLR3ezeCVn4kGkWEw2zToA9b2BGyhDW7DmyH4ds
779	fee_transfer	1737	1100	1	CkpZHEQA7hgWjp7fS2xY1Sj4Pb2W6PXic7Y66fJVfNeHe5QW7dnf9
780	fee_transfer	1643	119998900	1	CkpZMJmEtNPZiDCeqtDJAsYrQZggnWuN5a3M7pAq2txCkgCUahe4n
781	fee_transfer	1650	100000000	1	CkpZtgopHKfMHjfNzoHjZ3oujNKxM3NX8qARRFCZhamd3i4z5efDg
782	fee_transfer	43	30000000	1	Ckpa8cPVa2vP9j9kqRRgxAMLAU4FFnXM4yMj4oY4rBK6LuhEuNzxq
784	fee_transfer	1506	30000000	1	CkpYRKf2WbkJaB2jaHwt8UFQsVGeXR2To3Khd2H5eNMpGpMM5pLfu
785	coinbase	1618	720000000000	1	CkpZS9qY5e3nNjA9b1gSuFqugvYFhSCHNaSiLwPYypew6C6M5jhDm
786	fee_transfer	1618	10000000	1	CkpYicUmLYcsLvKCq1KhThdocJhiuh4BB4cB7UJfv2cyBeyyrnDy1
787	fee_transfer	1685	140000000	1	CkpYqxdpBVuJZAmDa5bTL3WofB6yDx6kegN3MnFxRazGfQYqFbPMK
789	fee_transfer	1607	110000000	1	CkpaF68sVBk6MrV5hnHMw7kppNQKvewqpYxuKDJGqNSDgGA4ruWaR
792	fee_transfer	1683	110000000	1	CkpZzEoiYzzSfdjKtbW24uHqzEtp3LX3aYJ34XMJLUtVfyx5BqX6y
793	coinbase	1759	720000000000	1	CkpaDcN9Yp3LHpXYBtXg3dcFq5RAfvmY17kX6KerjaEtfRE2xBXFX
797	fee_transfer	1643	30000000	1	CkpaCAXF6Rd9ot8cA6aQpoUk2PtvaRVDXqtUUT6YQ9YkJewa17ZE2
802	fee_transfer	1521	40000000	1	CkpZ6ZL5Ks8isBjNTL4CmXun4KgRiMDzhJP1QbWoSeHb37jTVuUPy
804	coinbase	1470	720000000000	1	CkpZYz4QKLX2qpFtnoTikjbBFyjFRLM4jEquwXMJeo2R65AEyRB2z
805	fee_transfer	1470	10000000	1	CkpYmUCLcXZbDhF2RDBrvcT3zzvjjHZsiFaJD7Pcs47Br32qHtBYH
806	fee_transfer	1555	280000000	1	Ckpa98xWbHPTvazSdW5xvvcGQyxowQMeyUgr4wgkB7f3uM4pFZzKq
807	fee_transfer	1546	1030000000	1	Ckpa5DTh7pDo5qpRSncFkmPpA1zw5zXRuwyPWMJmo4FAL6Wk1kxvx
808	fee_transfer	1546	400000000	1	CkpZLWwson1sgAgXam2BQXGC3wrPGdopkDhTJ8M69oCCi8htRh6jD
809	fee_transfer	596	30000000	1	CkpYVprkqHgC7fZPGX1m74HBBRDUbZA2KuEnMZCF65JCpP7xK6DrG
814	fee_transfer	1419	30000000	1	CkpaCcysJTTTFzx4eJ5fTPNgToSh6WtrNNezyS4uWtaWuELUtjp8a
815	fee_transfer	1633	30000000	1	CkpYr9E4co942X6N4ADgwW8g4WLToXyetpELQhqB4pPSMmcTuCWc1
818	fee_transfer	633	9999990	1	Ckpa4sSidr8rcjeZxJ6ZQSzvBBUBvaGRaWLQtvSnbBAZSK6yBLbfp
819	coinbase	337	720000000000	1	CkpZ3UjkJ5iaGFGcJQ5qDj7mrLvRk1BTcByKGje9YEPuu3HqRzbsT
820	fee_transfer	337	20000000	1	Ckpa4k7v8QDELKRPpmV2Z4FvE3d61r9rWVtH4VZgm6sGhHH9pjr7p
821	fee_transfer	44	20000000	1	CkpZTDnwv4p7dbSctKai8Xp1D6Zmx95GmGEytuxbKBSRL2gXonAP2
822	coinbase	441	720000000000	1	CkpZzFmgTKw7ccuToJwtRYi3gBEoRcqRzL4ar841g8tYLZVEKZDcm
823	fee_transfer	441	10000000	1	CkpYQ4pLUgHepYtoEZQd7V7tz7j5uGt2GGRqhNAtvbfoFuk5amkGC
824	fee_transfer	441	490000000	1	CkpZWKV19HrMTD6eeLy6M74XjUXnNfmsFzCoeQu6XFTcqiKKXgXrf
825	fee_transfer	441	940000000	1	CkpYU5yrpoR3xmrmeiwkMBetqJ9F6vhQBS1UsDvwxHKvzFnpbTqmN
826	fee_transfer	1740	30000000	1	CkpZxCuSGvNAKTZapaWFWnGASHLQaJEL1Hq7KUnCCkoCtwDE5wGtX
827	fee_transfer	641	30000000	1	CkpYSbJsnwP9JhGQP2ieZKrfviEKwMpdESvLievjnbgq3ipjzKHGu
828	fee_transfer	171	20000000	1	CkpYQ1XnVDrPJsCaq1C7XZ3mkTRCUaLkBPJP3GThDRZfLYHvd2FNg
829	coinbase	1606	720000000000	1	CkpZwCPX1g7YrcxPzarNoaZUZ3ktnZfZDRQxtGq674E8kssUVwV2o
830	fee_transfer	1606	10000000	1	CkpZ34dtWGwPXVqw6MHty9YCiucuCM3XzW53n8EArEHSBpAA9NkoM
831	fee_transfer	1700	110000000	1	CkpZ9b3GUhGCDsyyPVRi5PnfEAKnSzB7USqSLmu8SDfakNKaMP1Ej
832	fee_transfer	149	40000000	1	CkpaFC755Qzw2bwKBzv2YY28DxF9LL5S2gPHQLWPACfiPBePijXnn
833	fee_transfer	1673	20000000	1	CkpYknsY9a2yzQFCuDGXZNEYEot9GvqE7tKeo7YbE19QMQu8fukes
834	fee_transfer	1649	30000000	1	CkpZ9rT656dg24CjPvCMXfBcJXPBqFBXab3XrmbSmQEzXB4igyync
835	coinbase	64	720000000000	1	CkpZbu2RtcixeKaMkbEbFSCyEkbUKPGm8QnFnRE7k8GP1dCoZqqL3
836	fee_transfer	64	10000000	1	CkpYxkddANEzmK2FTbVmw5RxpRpQkiCoYrDvk6hamtquDDqJZYeBv
837	fee_transfer	1422	30000000	1	CkpaGVMSZ6PsuvP9Hsxwb7DYDvsviQdz5bojZr5zayfsQ8MC7kLyT
838	fee_transfer	1467	20000000	1	CkpYiNGAPHznFzGKxLswbF3beppNiyFaEaMK1bmhHe5cowL2PpDCF
839	fee_transfer	55	10000000	1	Ckpa9YFqijJT6JUbZ55SgLB9JJ5b1dvhTjtQSMFjaoHdJ5tjFUJ7X
840	fee_transfer	1715	50000000	1	CkpZLMijajX1c7UHzTyzmtb4smjuMU46WsSaQ8ogEGydsYAR3ekjC
841	coinbase	1762	720000000000	1	CkpZwcVempV65ZvgsRh4UJVJoJtvsUxYxcEH4ea9RbHtyoDaar1oY
842	fee_transfer	1762	10000000	1	CkpYrHeQLkzyfeAb59L5ktqgKDDKWQGru3scHw7g778zy2tTN1fdL
843	fee_transfer	1716	1070000000	1	Ckpa6E9LjUBRXaCiNwcU2PmHqEKyPdzSRXEEighbRqhYsFgi21VPB
844	fee_transfer_via_coinbase	45	10	1	CkpZb49YGQyQLnwpo3oNLc7nqu8zTdbPPKJ56eQcSV1j3jyviFrrG
845	coinbase	1716	720000000000	1	CkpZ6k4JGzoWwP4zejvUPLGXNyUgJwa9ysp7Ex11dPR6XeGSRFZzu
846	fee_transfer	45	280	1	CkpYT3t7ygQNFEdjkBFJvR5SWRkz4U5x5aPHEJ9yeW74t6aMEskdu
847	fee_transfer	1716	39999720	1	CkpZkkkFPaNBfTaeE1ufugKRGHYB42fomZAbka7bvrqmViEYc88yb
848	fee_transfer	1700	40000000	1	CkpZAcJqJtqqoWomeneUpU56Lmrq5sn6systS5mvQ1nFF9NUvvrFh
849	fee_transfer	641	40000000	1	CkpZuxX7mFjaLVQFfmRRFZM2hqGrjQoadD6fuKhGYoueyRs3HX2oE
850	fee_transfer	641	690000000	1	CkpYnVR8gmfd7j8CAK3XFFgzk3TYZpt2uPekGLMPttHyZ8fmSQWAf
851	fee_transfer	1719	70000000	1	CkpZrkxzEVpgGJtXRAXHwAJeuS8TzRhCNDkX6Av1GkjqTNarLHLee
852	coinbase	1764	720000000000	1	CkpYnDwsKXZb3Naak8PLgoGiLU9Y4a9JNZWLwcSVwT7CzABwDSGUV
853	fee_transfer	1764	70000000	1	CkpYUm87AnCxEFviGzgK51vnGKQCmvLw2NK5RaunNVvE1BdgWagcx
854	fee_transfer	1541	20000000	1	CkpZxVQFZPWKHTaW7tHUAPehfhoPwY85nJeUJHBHUCPTFRDGnwyov
855	fee_transfer	1717	40000000	1	CkpaKR4yEWcuGjkfBoDjkqqp78tyFWqqMPuhTga8WuRUPCF6ChvVt
856	fee_transfer	1708	40000000	1	CkpYsj4AzbrhJ2rtpqxxmyvnAFS9bf4Xjq2PDJ4qjiQ6Baw8pLUH3
857	fee_transfer	1692	30000000	1	CkpYjmeWuUJ8pUv6kece3ugFps2oNbru8oScJCZm7yJeZMzg2f7Q8
858	fee_transfer	576	540000000	1	CkpZzoEevjo4D5hbjE98QDA4Ypi57BXBehp1Cru2aT2Qro7Kcjov3
859	fee_transfer	1737	200	1	CkpYVVQPjb9FMKFbmPriTCLadziyCzKuSp9H7MkfLqDA4K3JDsJaC
860	fee_transfer	1458	2798540	1	CkpZUFqPfAppMBEjFvTYqr9QHDAweT7snx2i58VWLvEAFUtqFPtKg
861	fee_transfer	45	660	1	CkpZfPYaHTcHsJAGVgxgXmUjxZqyr9AU3y63ZACK8ESRr6XLLRk4u
862	fee_transfer	1515	4200600	1	CkpZ9fRxT3xUN5NKxWX2uCPVh1xUcsfC4tB7UoRUEM3ZWEaLLN6X4
863	fee_transfer	1758	400000	1	CkpZG6naMZhwYm4QAxzwbJ784vqTbxvbWRpoAXGLXE2KqctrX7dLX
864	fee_transfer	1492	12600000	1	CkpYcH6kCepDh7hvcfiBgeNWnoeCSAYkoPbW9cYrHFhbdaYtWjzgs
865	fee_transfer	1702	110000000	1	CkpZ4TX6ufYVeyWN4wxseLRYWs5nSdfsRHGnEmVdrfSfG3CfUKCT1
872	fee_transfer	1518	380000000	1	CkpYnp6GGqdaNZypWdivFsF2xsiHDujftn1ucGYTUhwgkw6w6yMiD
873	coinbase	1518	720000000000	1	CkpYXfXfiXcP4dhT3bADrnVbpcPKpUQZn82APKzL7hfV98RW64FTA
874	fee_transfer	45	20	1	CkpYtPAe3YC5NEMc64nTV44CqMhxNKiJxJVG6M8FY1qwZi6XLLKbt
875	fee_transfer	1518	9999980	1	CkpYfRtAJjkzc8vXTDx1pVy1KoHaGZ3Z49RDc2nXVCvJrWdhmD3rE
887	fee_transfer	1710	20000000	1	CkpYqdhgFB1JfAwLG3HTAopWdZrWPx3R9NoMdefb9Ch3YPUY3TEHV
891	fee_transfer	1699	20000000	1	CkpZD5Jpu3KpbqQWifcqh6cjvh5SPj1FDM1cFeMRAMCUKeLyU2aeQ
894	fee_transfer	641	50000000	1	CkpZFLUSg6GY3EfMVYqcQ9Rpn65VrXYFs1fTve35DPPepo4uyZW4N
899	fee_transfer	1710	40000000	1	CkpZKPy7zCrUsjSnugcbDXwsy3LedtdJ7CNmp6R9YnF8A9agU77f4
905	fee_transfer	470	30000000	1	CkpYj9M2RRgZtzg6nt5CKhKsTGgTSvr3CAwxGxpKUP8FqHmwsS2tL
908	coinbase	1768	720000000000	1	CkpZ3X5ukCrpumLawhUNWJDkWW1vsUuLCEwW3MjqhGFwzMUuuKzax
909	fee_transfer	1768	10000000	1	CkpZ5QAhamjFkrGsA9J6wJoS4se8BzQ1mxKVG5pGd2pVLGk9a19VK
911	coinbase	1639	720000000000	1	CkpYjbutz3aHUcrigPeBDDVz3BUZWWcg9jMPYdXEFBPg29kg9PEGe
912	fee_transfer	1639	20000000	1	CkpZwJehZj3BN3kD3QpRQ8q3ZAYgvSCYxryLETSaQTNdeuZWv1CtC
927	coinbase	1540	720000000000	1	CkpYkGYGHnJn6hGTGrzxar6Jyvv4CsSFLgRaoqRww9GEoUPpnHB5A
928	fee_transfer	1540	10000000	1	CkpaE8XeD998fD3rqRJEaZoaW7DokvqgmUEfXXpaesnxeMfWDS551
932	coinbase	1716	720000000000	1	CkpYfLuAnz9T9ZcgoKkauontwyEtqZUAMCY85hYQfXWzYHy4hgRKu
934	fee_transfer	1656	80000000	1	CkpaJDZ6Aammq5Z631VCuSY7bR1LZsD6jW1bUDvpNGq828ibH7rcN
936	fee_transfer	1455	21000000	1	CkpZLZ1KWLdyGQk5c45RjDJSm9swwbwSJ3DLPQG57eoiTBEzLSiam
938	fee_transfer	1271	21000000	1	CkpZWhAg9SNBqYYsRtjg9cTrRahain8oMUxqJX9hAmNyZAHAeKp7a
939	fee_transfer	1724	1000000	1	CkpYQyBDCaUkzQN9jYkfk5E93JNANekQ9vut3TJXZE1RNE3m13iyJ
942	fee_transfer	1687	40000000	1	CkpaKdaUk9nPUQsujPNEUpjShTaYiwbHdWFf9a1zbXc3rXraNLgCQ
866	fee_transfer	1703	110000000	1	CkpZVE8CJqhJrTzA1kkpvkcGJYiZCkrQDBsm1QGkY9p4N6izkoGsF
868	fee_transfer	1688	800000000	1	CkpZbHjDm3VZqx17Jg2JCw7ZkX3jBd1WEcQBGXjiUTMfYxkC6mGFw
869	fee_transfer	1688	120000000	1	CkpZU4REREc3vYaZJdVQx2WG5j9D77tfZ5Uz9ekyqq547tuEEeXZt
876	fee_transfer	1672	30000000	1	CkpYnXRcsvLb4BZKQQyAL1oHgLAx3ZPJkhqEGmN2SiGRQRk18c5Ms
882	fee_transfer	1737	900	1	CkpZ6LHwrmu7qRsJFCdMN6tBdw1rFtzns9LgXqRb96QFGY4BxoBGr
883	fee_transfer	45	380	1	CkpYh1fXu3z28MtaSCpwPh7U32s4CLjpS4BETc4WB75QJ8CYCLZwk
884	fee_transfer	1515	8402800	1	CkpZG4DSWF81FD8CDdgYnRR3iWVeqNmgPCRSDzmVc5eh4RdFFhyzV
885	fee_transfer	1492	8400000	1	CkpYrZVHXEk8xvEUyKUh2ChQsrD7Kgpec9XxGrLCBSafDdx2yFPwn
886	fee_transfer	1681	3195920	1	CkpZqAxtMB1tzKeH1g1jk61zNHL4pvgZtVdditNbtkbMN8AwuWbdz
890	fee_transfer	44	50000000	1	CkpZMuoGLsYegcHjgTHZN1coY6gxeqZ9GBLksch5qMxx5Pb6JcBg6
902	fee_transfer	1675	20000000	1	CkpaJumJXdnfwE6ttWAtCqgCSRoinHA2gHtwPbD1jsh9qdvkQgM35
906	fee_transfer	369	280000000	1	CkpZpQQLKbxt7D8T7ngFnhoAWfnYrQPpHkrFWtUH8EzJHub9T7Cs2
907	fee_transfer	369	640000000	1	CkpYUouYcWmG5sjQRoegvcS8ArehLXCWQvJciuxr3WwfLL19yE9E1
910	fee_transfer	1448	20000000	1	CkpaAAb9Ej2PunQiLHqk4tL27xXAXSbfkTP8v1yMNGGY5tMpav9eV
914	fee_transfer	1686	480000000	1	CkpaERe2ipb36wqeYoMVdeMpisrJ4DrA3Z3pvVyu6aFWbELGReyr8
915	fee_transfer	1686	220000000	1	Ckpa7ZWdKAhS5VTse5vH9upWXf7xvhXWZ2HpVqre5LRfP9KjDqjwR
916	fee_transfer	379	23000	1	CkpZfFWSC4qgZTY8et19RcHQwc95eqrRdxt9rqpimmZr2MMmizaAV
917	fee_transfer	45	110	1	CkpZcFiEBisnHBhzmtXXCze8fb6fbEr63faRBGK9io4pTmXWbVzFH
918	fee_transfer	1580	160000000	1	CkpZuqaEajTofHmxry3pn4T9Xbj3xBncLPabDnUJjbqtKd1UYW3bH
919	fee_transfer	1716	471396690	1	CkpYdgVoLjr75az192yufLnPLAt3g5ZRbj5BZ87osSZSvkY5ynUUi
920	fee_transfer	1725	25180000	1	CkpZpdAT5wGnzEufDwsMv3HMo2LkhuKtDre36Yo7meyPYUbHgRrKq
921	fee_transfer	1531	300000000	1	CkpYUzGwGi71SA84Nm18ZLU6LBvoWvd6i1wUEPPNsntoXisTEX6uM
922	fee_transfer	317	325000000	1	CkpYx7hHs4nro7wiyriHbkY6RANF7wMEunXX21a29VJbq5capL8kD
923	fee_transfer	45	50	1	CkpYTeHnpqCUsSqgkzYkEufqXsGFMMTwZheJ6RPo65feLMFMLMqmU
924	fee_transfer	1716	39999950	1	CkpZ2MbfDd5qjj5HhVGVYZqk63ozSpbLaRbxyEEUgCDJNt71rbpgm
933	fee_transfer	1649	80000000	1	CkpZjdeF67ySHVyd5frpgoDxZCJHovK7wv4UDTmSMP5qFQeEARTvG
935	fee_transfer	1679	31000000	1	CkpZAnLGj4QgcPF3XpzxGUJZZDGC8T9cYj6K15CefbKbRzKccGosj
940	fee_transfer	1474	30000000	1	CkpZLw6WgH5g3u1FNrbcJSfWBz6Dt2JzxhduLrmGWLDBDCrcU8zHe
867	fee_transfer	1686	40000000	1	CkpYix3t69Frxr4yC4xg5pqMbjy198q2sTE5Jx2BtiLfabh89gkaL
870	fee_transfer	1698	500000000	1	CkpZDcCLuv6rW3u9YAXbvWDbNxp1nuVp91YR2Ri278956zhue7hTa
871	fee_transfer	1698	50000000	1	Ckpa6yZVk8Sm6V8ZpmTCyr82UWAbow172dzGv95brTpnz2zc2dBxc
877	fee_transfer	1613	30000000	1	CkpYbRSkKJBq1Jp8qZYMiABq9XLSs6RNLQPvaMf2gqpekjhjGzTzf
878	fee_transfer_via_coinbase	1766	1000000024	1	Ckpa7c4HKWLA3V98wxthtGnd14GoyUXJc4SSSSWN8ryXfEm2BiiTg
879	coinbase	1518	720000000000	1	CkpZrwScpvKyrsMX6wBASzcQ7qzegCviWHTaQJ1RWomohRGLLHqjv
880	coinbase	1767	720000000000	1	CkpZEjfNA5sf7SLEPwim6C6mrbkxiEWNLrafXsQtXzSkkMFLzZS1Z
881	fee_transfer	1767	10000000	1	CkpZWdsTvivnBoUQBPf6qBuPtfoxbAsqRQGqq9QcLvVdvXxhihrdF
888	fee_transfer	1698	310000000	1	CkpYzeKHn5EbrLftFA7wcrCm2zZkq2CC6wL6wxvXQjYbkquB8rUK4
889	fee_transfer	1599	50000000	1	CkpZ8c9dsDghiyodTvW7hznzUZAoXycULLJWkPkn16LYqvDFis7nc
892	coinbase	525	720000000000	1	CkpZMvnGQYydsYEXPCjCSCWoYkwFcLTovC4sBHYokRoNFFoWMEcM7
893	fee_transfer	525	10000000	1	CkpYjd7pK7SG7V8meFkMeTUHCwWy6cy9Pc35BoagSdQA22B6XJ38v
895	fee_transfer	641	480000000	1	CkpZJtgKbGtLLbDg5DjJFraVanNKanMCG6xZXm6hzVdYxrdzmgALc
896	fee_transfer	1721	180000000	1	CkpZzLZPYC3331VmKAq24GAPs5135AKduHp31N3rZSAZ5tDLbT1oR
897	fee_transfer	1420	94222222	1	CkpYyR39W1isdxAAUywCmjZ37uhRtzGXccJEJLV87e9YS8J8Buyc2
898	fee_transfer	641	225777778	1	CkpaEeRaUMt6G16JcxBvVUjHBgpptVNRBjutAe2yLqgrNGG9dW6fd
900	fee_transfer	1762	40000000	1	CkpZDKvwzktfnbiBjUiL4wUF5FZ6NGwmUv1cgqZoVtgM9Qk5WV4uh
901	fee_transfer	1643	1060000000	1	Ckpa3AazdFG5mjJZXVRw59cBoLWtnLnpLDEBXA5CPVEeaz9C78dbM
903	fee_transfer	369	400000000	1	CkpZLBnRrigrrMwSbfqV1PQ5ZsiVzz778rg552cwPVbFSngcoAMqs
904	fee_transfer	369	969999980	1	CkpYyGb5PJRgLkBmQ9V9YiwS1BFEEJCcwz16aRgYJor5MNnK9mZHL
913	fee_transfer	1764	10000000	1	CkpYRmbiaNaZ6vCNAgGCJCXkhsnnDfcPFfEFGuwxyrkpjH8WGY6jT
925	fee_transfer	1482	10000000	1	CkpZEoEhPtdTBVTuk3yitvuvnyuVLioZb4er5uXnrG1xLd1jfP9fQ
926	fee_transfer	1673	1350000000	1	Ckpa9ikvbfvTDy8UQodDrUZejfm6fHQXhRL4EsNFHZiX4C6YMdxrm
929	fee_transfer	1541	1300000000	1	CkpZKgPpRZtEPc3gZZ8YiFEh5w3FR8GHjcPPNYrmXH9vC2Xxi6r9T
930	coinbase	1598	720000000000	1	CkpYhsLb6qADiXkDH9gXPRmXUheH5XEEFX1J8j8ncT4kPddhRN84Y
931	fee_transfer	1598	10000000	1	CkpZcz1bYDfYWetW9nguCvaWGjPqazcvkuBNDUA26n8jgxaJMCCGF
937	fee_transfer	1724	21000000	1	CkpZHdoNazcfG9hYZH8qrJhGRLMAmRKc7pwAnp8iUvnqMMT9S9wJX
941	fee_transfer	1467	40000000	1	CkpZfU1PAqMVHLUAFLvkdEhyi82d4nWaoCqQE6rEeED2wZfuXAWny
943	fee_transfer_via_coinbase	1744	500000	1	CkpZSY788xXikyiLqUX3qZdnTzEBEpMABxb6XmtT5Uo8KsUuxZ52d
944	coinbase	329	720000000000	1	Ckpa8Fg1TmduuxNmw9ERyF74RHj1bCxpwAGs6qgPzgToq9qTQfTzG
945	fee_transfer_via_coinbase	1744	500	1	CkpZNsBRmSTf2f3xNAV6VeNJRkJRuY7mAqQBsnbqPLX3CTw5CUd1y
946	coinbase	329	720000000000	1	CkpZzy6ke7jbqCRmkinbdiQfq8VAndqoJJZybo2CQPSyhoLt8ohek
947	fee_transfer	329	48499500	1	CkpaAttPkFVm5xdMXRchxNAk8HTgGukxAyeN9kTMAandzEQJFYxoB
948	fee_transfer	1744	1500500	1	CkpZoayG5DT9PLSA9Mm2MoeW6vCBTbD7ZroGiqbGgKZXvuPW5SbQB
949	fee_transfer	329	510000000	1	CkpZoyriRtJjYJQrCQ4BmSrhSujmrSet9h9iXaBqt3beQTVejeaEi
950	coinbase	329	720000000000	1	CkpZwpku3DpX8Eu4K8RNtfZiRFbHSm1eEv3Wnx7FbZTLUprWEdFHM
951	fee_transfer_via_coinbase	707	150000000	1	CkpYQay95eM3JAgdDhd7udPmsc7vGkD8yHAvAd315vBPm8u1qBoPG
952	coinbase	329	720000000000	1	CkpaHK8DemzuYqfp7TULVUhJdX1c191dzXheQ4JQCbzNTZLcoSQ4P
953	fee_transfer	329	50000000	1	CkpZdRpkvCXNqmhbE15WnvZzFXALAXuE9T6gheUUh14UdTQ8qp9Ek
954	coinbase	329	720000000000	1	CkpZJLcSig95mMrrRfQrFjCqNnaP6vdejpgtUAm6U64BepUuXxGTb
955	coinbase	1509	720000000000	1	Ckpa4Zw5C6LWCncaMKQTY3qkN6V63eX3cSwFsSk2TjQKGkprWvbvr
956	fee_transfer	1744	1000500	1	CkpYk1tXfVmPeWzKa68z25yUcfZUeXzorCy3eoEqbYiytcyXBTSPi
957	fee_transfer	1509	8999500	1	CkpZHExJKcYCFnjJsrsUuDV4hpzYCitiZBPXhPavtBo3EmnUCu7ZB
958	fee_transfer	1705	370000000	1	CkpZgfVe1Dj8qgFGjKt386azFNiWPEzBYFny6rSNzw6U4sdn74sJV
959	fee_transfer	1705	880000000	1	CkpZFzsPZho1MBERSKH7Ge2ot93UmGvqUULyM7gKSEEj4QNu3hR7Y
960	coinbase	1462	720000000000	1	CkpZRwsxzvUF7ejQzTZkwU8fHM7UKhMQJa2CNNHbZgywh1xcyhreF
961	fee_transfer	1462	10000000	1	CkpYTgvukhdaoLRptWR787YRGMiBwgU2NreWSiwo9UxwshpDboNpq
962	coinbase	415	720000000000	1	CkpZkt8QUZqNiERzoUV1RkEeHfSPchpTquvB5YPkbn8hgu5mKoPaP
963	fee_transfer	415	10000000	1	CkpYb3w6c8vTJNb5FwGenspXJBLeythFQj4KKxKcYwAdjSowPfgqV
964	coinbase	1496	720000000000	1	CkpZRSseTJskKSgdTwhMbCtea4gKWv1V6Bha5ccmkVM7Sk4nNXxN1
965	fee_transfer	1496	10000000	1	CkpZhtn6Sg3VhFNdGJSvm8wxQLrPvwhhTLzqzRh6Ldf3knPkRJ7p2
966	fee_transfer_via_coinbase	1501	100000000	1	CkpZe617QLPENDSJCuVdxm6KdS2WBZG7pmCnsvMAoAqcs8VSjzgdX
967	coinbase	1677	720000000000	1	CkpaK3f3Yx8JHSPMfsRWpJVbCsc7JTKGZXgcnbF1Hxf8i82TcFdsn
968	fee_transfer	1677	100000000	1	CkpZHXBcheNNqHYtJxCq9ngEU6wALciAPqYxzRaKV6aiqdUY8bx4K
969	fee_transfer	1708	100000000	1	CkpZDdSE8QLTcm8y7cCEVtVHtQySt4wb8meNd7c96PhFikJG868By
970	fee_transfer	1706	100000000	1	CkpZ8ydbAaiKKw9Dbra5NZha9wGu7KopSZeJitSrkw7uxLWfcxZ14
971	fee_transfer	633	430000000	1	CkpZLDzJoYXNX8cN1ejij69Cs45fRSckmHRWxuwL3deQYsmJDfxSt
972	fee_transfer	633	339999999	1	CkpZaYLxA6SvX3E5zJyq5TphoBmiqZUZqopyTJHhML4XqYKuw1TUV
973	fee_transfer	1520	1	1	CkpZSBcuX2QnTZ5WpGyk7jHm66gMxZe8kzZ9GJvJpdYLX8Hconco7
974	fee_transfer	1703	160000000	1	CkpaJVmQacchCSdNB7k8krfxbt1rrB2fmyNKr6yPDwcd2rv9urLVR
975	fee_transfer	1703	270000000	1	CkpZUVthA3k64EfyWCbJrE2veScXY1oYnBKdxBA9zaHwZGfEYCyr2
976	fee_transfer	1594	120000000	1	CkpZ9n6wPG9Eaykk8srEzVJCAAixRvbdNxubthGcGkae7Xa21cMaD
977	fee_transfer	1643	100000000	1	CkpYSui91VuikxSZNPUb7LakhHb8vHLa42wtMRN71Mqxrpvm9QWb9
978	fee_transfer_via_coinbase	1550	10000000	1	CkpYm9RUmFgZ4G6DhQQcvNLECyyex79chhxyBgwRXpbeQev3fp9Wp
979	coinbase	1688	720000000000	1	CkpZDARbrDfn6YVYHwULVkzrUugXyJ8vQ3SYE717mEvJG2yF5mUdX
980	fee_transfer	1654	420000000	1	CkpYh8JR2k8YNpbSdkPpqiLWPSyGpqd6eYieBSUVGFpR5ThrSrzE6
981	fee_transfer	1654	1010000000	1	CkpZwxf4ywRokvVpohYe9gPpVokGH9Pvdk6e1ifsKp44GyeMsCexy
982	fee_transfer	1703	330000000	1	CkpZxykMUKdaapgfXNCTNW6Rb1UR7EgUnKmYMwj8DNEYPXErHWy14
983	fee_transfer	1673	1440000000	1	CkpZqP8evDF2vueS6W4ZWmUqUhHQeEwdwzMhj8LesxMHBojuCxoAa
984	fee_transfer	1686	80000000	1	CkpYgAehH4Y8ejHkp5qXS8czpD4NAACxRzDFZK6dYJFjicq4VTX7j
985	fee_transfer	1467	80000000	1	CkpYhfHfehsBwsXm77Wv7tZwdLM46dT13y4ku2V9cqZVddYXXPuRv
987	fee_transfer	1668	30000000	1	CkpZA3jD9PR7NZVwkN1NWMiTBNLf3ERtyR3RM8CG5Sbf6qZHD45iN
988	fee_transfer	1768	20000000	1	CkpZ3PwNDcHBf6XxLfGcuApADtFcFGuWkpHizv13AkWQw3zetCSYM
989	coinbase	1568	720000000000	1	CkpZF3kQNWwFP8BcwYVmj2J48dgXKVL48QxZC2SRRi7kHZm1q5Z2R
990	fee_transfer	1568	20000000	1	CkpYugFNB6uFSSesj4FgZk3XGEKngAkrfjnYmA6ieqTkS4aixBbLV
992	fee_transfer	1700	120000000	1	CkpYvCk8gSZVyfV1iyK5iqgd9ozJmnfRTEYrhKDAF7npUGDg9nk9D
998	fee_transfer	1683	50000000	1	CkpZyHyjMY8GMM9CGAXVpi1vknh9fLxspBtqyZakGVnbjGeL4dPtT
1000	coinbase	405	720000000000	1	CkpZcgLHBhSdrM3CsMj7EJTzrxKh7KqK3AjNxe4qbrXUqN8EETu3f
1001	fee_transfer	405	10000000	1	CkpZ8J5q35jxWwpW1ikn7q1tBCZq81Ndj6to2Xi6YtevEzswdRCk9
1003	fee_transfer	1593	70000000	1	CkpZzMFSx77419B8J9RLe4KFQKGxaTEByHggKMd895JZUUUuCnYhf
1004	fee_transfer	1703	720000000	1	CkpYT6BkqC8AJzt6SK2KSb4nexvfFfMj3qyx1Y9NscrwKkdWrU1tB
1005	fee_transfer	1703	530000000	1	CkpZExecBxmzD4dsgQaFGfXSPk5hF3NYaRntN1N357E25dGLn1QtX
1006	fee_transfer	1739	220000000	1	CkpZdb6mFc7NvWmeVxbUSViCzpdyBvgpp6fNkY7heEvTUWQiYzJkg
1007	fee_transfer	1634	220000000	1	CkpYghn7GVpiJ9YAs5sdXJSpytA6wT3hiQD1bRLEXD4ZQcdRWMTrT
1008	fee_transfer	1706	220000000	1	CkpZax14v6uUidzQMF3m5kx5uzEJKKrVKA2QN9T9RuTPo3HVMgcaM
1011	fee_transfer	1509	40000000	1	CkpZjS3MorF67DpaNLoNXMSFke2g4QfqqRfMS3LxUbFrd1c393hHa
1015	fee_transfer	606	40000000	1	CkpYuSKepF9sW1FbHyZANypDQ36dhj9vPuMcSCikhDW4f1ZurXnoW
1016	fee_transfer	1677	180000000	1	CkpaHgY4X8cnXtZoKpBsucgmyVpB2EwaJeDfAxHLKftTywtcR6Z1U
1021	coinbase	1756	720000000000	1	CkpZ8b6yTW5mzJWshrRNGcqkGDzrW77fRC4NRarQkMFoRLcfBCEqD
1022	fee_transfer	1756	10000000	1	CkpZApRr5816QqtDVUzovUXvjaJLWGgeQybicexG8bTYjnfwogBbq
1024	fee_transfer	1723	40000000	1	Ckpa758FQjFu6UJGy2wDXCDjSoJ55TJdTSze7ooJzU4Yv71JLMm21
1027	fee_transfer	1768	80000000	1	CkpZw4jaKf1DeBhzYsrBAVVkCbsWrBkfVmyyfWBcidF7mkBPvcKqU
1028	fee_transfer	44	80000000	1	CkpZU6fjkckdSvqHbuUpxMzMPnerxg84Hou7C8XS235sZyhoRMd6Y
1029	fee_transfer	1555	130000000	1	CkpZmthYTFybAs5s4rJUPzJn9UrHp5s5e1nxVWCpa3wSppdvfkTcr
1035	fee_transfer	1587	110000000	1	CkpZr75tvWmdth6pzTvqb26pYGx6JQe2LDP3Ekf23YrU1Rjh34F1e
1036	fee_transfer	1677	90000000	1	CkpYc3d4BXUY44jZx9HnsrweC2hp4wtTsuPRYHcEX41BCTERoBaq6
1045	fee_transfer	1637	21000000	1	CkpZNSDEXFMakyW1we42vyqKxfSc73pTxheU3VsGPySyfEkzZsQwK
1051	fee_transfer	1701	41000000	1	CkpZjM6PRtWQJ6VyUDFgFGxtriwX3cmagX6K6bTGFhV5UTnZVAwhK
1057	coinbase	1653	720000000000	1	CkpYZTGCb7rjmD7tRGsqJBADmA4XuBKcGDvvVHsbWMU4amN12c4mN
1058	fee_transfer	1653	10000000	1	CkpZ8fVKfJQn73qkewdWf5Z1hRc4f8n2ib6B5LbCVwM9A3XV8XC5N
1059	fee_transfer	1476	860000000	1	CkpYXwSotkK92JxsYasgBp5z87ha2WSvB4hoEwaeV6AaVGsFgmvjg
1060	fee_transfer	1679	50000000	1	CkpZqVBWa7AUtn1cN7QjcGSR9yM1YT2sGr41iD54pR7rzgYipNLZL
1062	fee_transfer	1506	1060000000	1	CkpZ9qhw6erDKsvirFGnG5ZKuYz4DQ9z2ZRVigTrxQ56ghNEyP2Q4
1063	fee_transfer	1506	550000000	1	CkpYyRRHgcM1vLqCkkBhiArTryc4jD2J6bNkoWuie9AQkz4p6y4Yh
1068	fee_transfer	1764	30000000	1	CkpZGYPjA3DCoyLqax5KHHX2mNHmzfhUPQoiup3P4av9izNBVkmtf
1072	fee_transfer	1706	1000000	1	CkpZjMNpsrTJZbHGLaG2ErfSBeM5wZJkWpAtGmkPUnibEXaxEzWcs
1077	coinbase	613	720000000000	1	CkpZ3LC2GHm9YcJWeiFYmqVRXfiCX6LBEGHcsP2PQctYj1vNttp7S
1085	fee_transfer	1677	1000000	1	CkpZ8p8omZaBpN6pLD4fZamW3kdeXmT7fRhbAt8CWMxdfjiFzqbAz
1089	fee_transfer	1686	1000000	1	CkpZsST3aHrzJW5roDFNAX96beEKKDrPxW9nxnNnss9qYFUGmvZdq
1094	fee_transfer	1682	101000000	1	CkpZ7T9Hc93ZVvVnH32kzYY3iCd6XL3DJ74LHmEKPtKeKXC5V9wFn
986	fee_transfer	1559	80000000	1	CkpYaKbcJxpPNfDSY77wNzB1ELEPid34kCDfna1GDZVLoW2VxePVW
993	fee_transfer	1587	30000000	1	CkpZPj9AM1yT2g1DBrs9CfQ6D12JVE3GLtfBnxgs6PP4XQLBHkV6S
994	fee_transfer	1610	40000000	1	Ckpa1mRwesBRqyCDJZbXrEdCtREhKf41LBqjBTK4aap261HUeB4jz
995	fee_transfer	1643	130000000	1	CkpZ82F1skgLoeg4oygCWbFzs7ujEBn16Upj5CAGj9BokCauB4r7g
999	fee_transfer	1611	200000000	1	CkpYwbVxdBLNKHSgdEm25AftMXhfMwBv2a88NGtR8pRtRPJpetdBq
1009	fee_transfer	1634	130000000	1	CkpZfVF4aqgKNysubSSPemSzcbTuV6kip4frhCgKM4jGUHZnQDcct
1012	fee_transfer	1271	370000000	1	CkpZnW53M2y11hLvZqv1MP8rF4CSkhxqDzmFpnW5LDZwPGM4k9BMp
1013	coinbase	1271	720000000000	1	CkpaFuP85tupP6QJHkMN6kjTouDXQkMVbANxH1MPagBtcvGDqBHfZ
1014	fee_transfer	1402	80000000	1	Ckpa3oyH3iqS44sRgFHhvojHrRs4DxoGZEfuvzZskw8VRR86Qv6Y9
1023	fee_transfer	1643	590000000	1	CkpaELD2eMAv7Q6qyJP1qyZTZoqRABmSbTmhWCpQQqJ6MkGwthPEG
1025	fee_transfer	1650	30000000	1	Ckpa4m9y39t52RbwULo93VpSmwGNoj5vwSTJ2xpisACkGSrnWDKtF
1026	fee_transfer	1711	80000000	1	CkpZtLGyM5mHt4fnEFByDgBRFbCSX9r6nv4g11f6cJfEYqmnkvekW
1032	fee_transfer	1768	40000000	1	CkpYiREno9xpBRC8XiCKG2hftk5AHNnCCB8SW4PUM1rHGFKEkUWZ1
1033	fee_transfer	1683	230000000	1	CkpZ64q4T2icHd7xiisovJ8PpiQdxgkizcCLhKMBHpaehpKkNPpuk
1034	fee_transfer	1489	110000000	1	CkpZqkiTywexbR8uBdSDhH8oG5PFKNY2RU6Tc9WhR6NH9RaKs7BmK
1038	fee_transfer	1637	190000000	1	CkpYc7ffyxpkj32PXWWkizBWknn2otiTpSB1G3pHm4hTWS87RiSo5
1041	fee_transfer	1440	120000000	1	CkpYcqDqd9tUThBHn1XR5ZqzCsCFsTSnMs4uhJ6Xt2E4Pny4JS4aE
1043	fee_transfer	1444	30000000	1	CkpZ3WFHXRMWHLRmGhpjVykYVgazVbdMq2cCR7JiqQ995qPBcXztd
1044	fee_transfer	1522	21000000	1	CkpZ6MMhpg17wBaXifrfbBRTbhYx37tvgQqhriRvtUmHoG74pwRVt
1046	fee_transfer	1457	40000000	1	CkpZMH8WHcXwbPXSZVDrdP71zJPpQQQs3iPhi5pB4k8Hj9wrMBDx8
1050	fee_transfer	1740	41000000	1	CkpYtMYPfwMrP1cZgRToicJXK6XpfHVXv3EYRVoXfeMPKcS2hod1S
1066	fee_transfer	1426	650000000	1	CkpZhYpAKshRx4GZKLBNUvzKhmCK6xB2j48uKUDF5pDroFv1Q76e9
1067	fee_transfer	1704	80000000	1	CkpZkjJw9LzzCVovW4b3BbW44WfSpoNByVGXMJfxtCZQh8qo72QYS
1069	fee_transfer	1735	30000000	1	CkpYRzjH8KyrofQZh4tX2X9uyhaNpV61nGbgvcrQpEbXrTJKNTf2B
1079	fee_transfer	1650	1000000	1	CkpZ3y8MWgKj6xm9FQRJJJJNjQ2MsbJtKBCiNUaETkHegrmEGTQhz
1081	fee_transfer	1709	140000000	1	CkpZetNG6r8QPFTrR9tg7Bker3faVcq3LF5yKDgLnoXxjcdFbcBNg
1082	fee_transfer	1515	1	1	CkpYaHA6Q8zU8QHpyjw5wXQzNRceTJ1XfwC6nfh9aDvoAev5i6GGs
1083	fee_transfer	1709	414999999	1	CkpZmNb7K9N5KF7uqx5tRGSHrHLb3xH5HT4F2WdWnF2Wgg1wEruc2
1084	fee_transfer	1645	1000000	1	CkpZntEm9QqBGNnDHKVSRcx5Q8wPzjuxSJ6t3PHQsDrjNCRDGqQbn
1087	fee_transfer	1637	1000000	1	CkpYeC8bG6ZDM7KYWUm1BhNUCNjKVAWNsUS5U4RyGjz1SFtaDQBXX
1090	fee_transfer	1634	24000000	1	CkpZhZrhfF3D9yynX8kLwnDF8XrtXe3dppws1W5J5n2WTwK2fV7EX
1091	fee_transfer	1679	1000000	1	CkpZVUH1HKze47UFS6hBorLYzP7TJ8TB6DmnNXkdUyYCBHYgxYjFs
1092	fee_transfer	1727	1000000	1	CkpZBJrPzbTkWfMbmvQMw6vy7AVzgQquFQPxk1nRbKrZom6rRrTjC
1093	fee_transfer	1439	1000000	1	CkpZnCmtQA58oNYEm7jeC7tkmv4bKvqNd3GEyWajqCSPLfa22sv1w
1096	coinbase	238	720000000000	1	CkpYSdTWCBgZzwkw87637Q19vtMwv9US6NYSWbbtTtVNQmfL8dZk1
991	fee_transfer	1717	120000000	1	CkpaF7Dbk8CpGbWbupou9EmdUUSy8VTVXB1PjQ4dnAyTVdiKyDLDw
996	coinbase	349	720000000000	1	CkpZzVevAdcLpbdk2A31yabBkuGp43sYom1EYpvZVKVUnKsYjVEKj
997	fee_transfer	349	10000000	1	CkpYorTFdQzkgGiEbCJTJoLmkQVU8dLZGPaDNLYg2b4qyTZHtcG8Z
1002	fee_transfer	1694	70000000	1	CkpZCvWVrbb6hkY5LYePRtCdcKW3HDRbRZX3RRvZDgf9G3mDMnQF9
1010	fee_transfer	1637	60000000	1	CkpYwp6NJyQV5UwY5XwYaW5Fzuj5uvWQVhe4XYcn9462gNdHyJsAW
1017	fee_transfer	1637	180000000	1	CkpZoB9hTFbtMQDTGM51A75aJ56DFXf8yQVDMs9TTa9ogSbEFBaNa
1018	fee_transfer_via_coinbase	1571	8	1	CkpZkxg8YXLMotkXUsnvn2dNuYsYxGBRR9VZiF6jdxffWsS2otmsK
1019	coinbase	1649	720000000000	1	CkpYVAg5dxzA5BQd7SpEQrUvhM794sVb5xR7FySDne3sJ3RVnRkd6
1020	fee_transfer	1709	750000000	1	CkpZVEjECrWRwYyPycQTT2TMuxkXe4iMMhswGsSDUhRZMqfMGthGy
1030	fee_transfer	1467	50000000	1	CkpZG4ohoY3mxL6QVGeuKhVm8zUUF72wonLhCUTmH8RF6xphEaDmv
1031	fee_transfer	1678	40000000	1	CkpaCLvA8dDUj1GeomN4z66rZ2XHXm3zs1Xqc8thf63LgBjBLJgRi
1037	fee_transfer	1698	190000000	1	CkpYerbtotGZJF58cd8atbRMUd1fe4HPqvgMxjtc8Q6BBa4E3JtPH
1039	fee_transfer	470	50000000	1	CkpYac5D1borQEz5LoEtF874nHmEQqyr7cognzLLTSM7Cj1QntPbG
1040	fee_transfer	1679	70000000	1	CkpZXn4vofcY6Tp31zTRVbWdcT9YGdbbUtJS6DuaA21WVgq9At4dM
1042	fee_transfer	1513	320000000	1	CkpZhEXJZ2PxxSKs8UQcPjAtvryzbZnpeVP1jMSASrGStjRKA7DMm
1047	fee_transfer	1756	40000000	1	CkpZ8bobGrGzXjWg3PYUKy6URRt3j8QScFZLHwLAVwSqn3yYGBWha
1048	fee_transfer	1756	20000000	1	CkpYzYeeFbjvHFN6znV3Tc6uK1KGbHSjLVxnqbtvLdhT3qKQmqPfE
1049	fee_transfer	1607	100000000	1	CkpYXS1t3jJtn5Dj3bh2DfJUqAfi1zuuQy5BaAxbFh2dJ1LnDUaKC
1052	fee_transfer	1611	1150000000	1	CkpYzfFK3gW8x4DAZTLHsP8ouikGimVfvzZQLx11aFA4JSLS5CVDC
1053	coinbase	1611	720000000000	1	Ckpa7cim5omZjGgRog9pbGgLr9x7qoPVF8K44GnLTXWoRXT7VRaKa
1054	fee_transfer	1504	270000000	1	CkpZnfaSq1WAAKQGd51H2oMEEehsjYBRUzFre77xQ4y1pE42w3BtZ
1055	fee_transfer	1458	840000000	1	CkpZY77jpAq4AFkkiDTXLw4xXxvMiv9vgkeGSpLX4aaG3yXZerRxC
1056	coinbase	1458	720000000000	1	CkpZ2cQRLpfNa8PDgUFiumzWuNjYG7y7oiJ1bZFtgYQDtzgvtkKNG
1061	fee_transfer	1471	20000000	1	Ckpa5yttEJgRsniKJ7Q4WRevJ19oHvjL9RShqukU99nCVEPRFVKAw
1064	fee_transfer	1704	300000000	1	CkpYpc78FcUPvtBddmNSZ6xP1Gn5cbEhj6ojcYHGHPcqpam5WyhAW
1065	fee_transfer	1506	700000000	1	CkpYXNx5eZrWscEqhqx7ESkfP1JLr7M11GY9Tw3GW2sw7z1qc3XeE
1070	fee_transfer	1709	410000000	1	CkpZRP4sgJwSL6nNwHqjAtUNL7yATK7otsoXLTXmLSgLL2WGgefTZ
1071	fee_transfer	1709	1110000000	1	CkpaEEiimUfU87i8MyT5NEeQ4kTvLg7eTnACBtgkTom4E451AMawD
1073	fee_transfer	1706	950000000	1	CkpZbr3TVPVmq8hG4gpjWYdcEC7ggy1SXR2NhNptEEQfHWqUQyhRp
1074	fee_transfer	1706	159999992	1	CkpZm5B9pVqgP1KcqL6MvySSKp2c2BTi7rPhN8AZyxYGrCsc3W2Vy
1075	fee_transfer	1571	8	1	CkpZkxg8YXLMotkXUsnvn2dNuYsYxGBRR9VZiF6jdxffWsS2otmsK
1076	fee_transfer	1506	250000000	1	CkpYRwDKCCCCmR3TKRq4ryGpxv9Yq7hq7s2An8VLzjjH7ESBe9LPp
1078	fee_transfer	1458	1000000	1	CkpYtGAycMGtU5M1b9tiN6CrAG1rfQv86WSA5n5AMHTyXK3QMeESN
1080	fee_transfer	1709	1000000	1	CkpaG8KL4d8jkmmwg4NLKJyyY3hhc9hfHBbET8KhYoQZKYham4LDH
1086	fee_transfer	1607	1000000	1	CkpZX1xsVaADds5swuE7yRiTWTjQ72XEJPRGf68y6tHupzmRm7XsD
1088	fee_transfer	1690	1000000	1	CkpYiMLguxUavKX27gWKMYMtwoRKvjgpUETiMijqpYYpXyrTAag1H
1095	fee_transfer	1768	101000000	1	CkpYyK5zXjuzTt8RZK86g96PJChKHjAw72uDPurNbueE46fzZS7et
1097	fee_transfer	1513	153000000	1	CkpYd8FHUooAiW6Yq4MtWm9kCm9YMVyJCvsFUMvNSSki4BtmComeo
1098	coinbase	1550	720000000000	1	CkpZUTzYCpGgwHj3zVtAXcwTuBzL7ThYpNh1HUbBhQiQhTevbwcLY
1099	coinbase	1614	720000000000	1	CkpYUZWhrDDwJmvcnS6xXaRmyg1S5LEm11zn4hQmdGsUgbz9fSmqu
1100	fee_transfer	1634	100000000	1	CkpYddV2cf5M43HFt7y2JKNiD25URJ98rMA7mXnGj1YitiJVArJ12
1101	fee_transfer	1681	2000000	1	CkpYn2CcyAZKxQeAFAx7FiEoWPb7rcjcVeKt4GWPynPwkd7ta22Ht
1102	fee_transfer	1698	1000000	1	CkpZwAUPd8ujSYcgLaKafN6xDnVSKMCk34LE51DFgVH4YsvtYezRR
1103	fee_transfer	1564	12000000	1	CkpYWcscAy17GFp9isR9gtNNMmrNkvKU2q7tbhcwKkhYZPKKnmza5
1104	fee_transfer	1682	12000000	1	CkpZ7LgPBnMsHCep3TSGzUWTEWdcQgU66hcLujrfrhWsrvPwofYkx
1105	fee_transfer	1673	12000000	1	CkpZYuP2et4wCznD1ghaX3zT9BSzM13tdxmxchVKynQGSBCSG5rpB
1106	fee_transfer	1513	14000000	1	CkpZY8oZdpmbzs9NZfkD8VND4tY7bynK9sKJ5YG3sQBEZqWzN33HE
1107	coinbase	1544	720000000000	1	CkpZWstZnjxVSY3qZP41h3EbtNkPKtomK2jjffRgXCqVY6vrumaeo
1108	fee_transfer	1571	11000000	1	CkpYVcYzsHKuvtpd1i7hDBXJ1FpXo4mwqB7JSV2BvTmaBgayP59Qe
1109	coinbase	1749	720000000000	1	CkpYTzfKzmAETmwDjrj65aVFLFNxtDi3ahXRzyxR2GkeeL3MYfwS4
1110	fee_transfer	1601	21000000	1	CkpZ7iU3tUxrbMTErUqxVhS1yxWLow3Y8eqsrrP2R3RxgGu2S1bZg
1111	fee_transfer	1749	10000000	1	CkpZGYHPv8XYnsabWrcLCfyn33v4CdPTMmG6iNR1vRvgy2mPCqhr6
1112	fee_transfer	1703	21000000	1	CkpZ9Wg3aygXhmiNTqyAYDTVqTLXXLSCdXL1nF3XrbMFdyHSFWgdT
1113	fee_transfer	1702	21000000	1	CkpZEKpDAtCNLFWidqtKNJipBs5sHG3MV9MThHfMGTBreyQahLXCC
1114	fee_transfer	1677	21000000	1	CkpYjBQ65wN1yizGJLWR7pqMJ5AdSjZyfNXt14SqhEThvCXurMyS7
1115	fee_transfer	1489	21000000	1	CkpaBcKkZ6RBkvYqmyGQQknYRv7JiwmuUesMTfjxYzV6GBEbfi6uS
1116	coinbase	1458	720000000000	1	CkpYprFG4FDXTSQ47DbcKBYKaQ79xP13K66P5sK8YT9fNVmmUKnjp
1117	fee_transfer	1458	6100000	1	CkpZ6mT548g4XSQV4oS4euFFn16MSZ2QshDWwedxk8xeSGxgiR6de
1118	fee_transfer	1460	3400000	1	CkpZBxG4gjWCPwNKH1NjvYNmRBjtTcanJuhLGpvwc1tAcM4tiPn6D
1119	fee_transfer	1744	500000	1	CkpZSY788xXikyiLqUX3qZdnTzEBEpMABxb6XmtT5Uo8KsUuxZ52d
1120	fee_transfer	1672	40000000	1	Ckpa1K7c3qVLSEL8BaPergRHvhgkjaARvafjHGcErArfGKtFxgVcq
1121	fee_transfer	1706	30000000	1	CkpZ9vdF1b8TTx3LYckrfkdtH7DaHyB2LqAdYdUNVgzMtiYk4yRFA
1122	fee_transfer	1706	80000000	1	CkpZ2UnqfDyHMcZaYoweavkrJhj7u8uQZrFLGo8HSumrCYuAxsgha
1123	fee_transfer	1428	10000000	1	CkpYYSy6Z3YQg3jgb2PRhN3Y5U1wvEGJMQKGv983Le2inzeQfmk14
1124	fee_transfer	1560	11000000	1	CkpYheciqTEKPRhuWKviJisdnDnsRxLf4TR8YTMNrz3j6ASZxUHjr
1125	fee_transfer	1691	11000000	1	CkpaBUiiMoAkoSrZ3zPuD6Spsia3WbVBMRtgw68c1P6rvvupB5Hcx
1126	fee_transfer	1693	1000000	1	Ckpa5CedTyemD6ZPhK17rUhusnvJ4j3hmYzE8SXTejhxxiZkWRwq9
1127	fee_transfer	1513	11000000	1	CkpZQnabWpRVihtQxfejt5ThTZ2uKLSJ6iGhSbfmBW3HzG29gk2aD
1128	fee_transfer_via_coinbase	1506	10000000	1	CkpYSNFyNtQeGkc7769RF4UQ2n8S34sPzg7UjzoMM4n9zQJVQ85Ec
1129	coinbase	1513	720000000000	1	CkpYRcyN2itUftJTATxsHATKdMNqgo5c7ChamDws8s2UXyLNEeWGf
1130	coinbase	1780	720000000000	1	CkpYZuBQxoxCx7ZcYLXejJuHAdRtrybKGk9G7vmWRc6zDq9VEbpc9
1131	fee_transfer	1780	10000000	1	CkpZGVvLG28fQiAriaSp1rYc35ZzhPgZ1FEKiby5mbAF98eUn57wk
1133	fee_transfer	1440	40000000	1	CkpZq1pW6Y4i48X39QYtjcGkT1k4ZjnayJQZok5tKXQfPTNk6P6rr
1134	fee_transfer	1522	30000000	1	CkpZm6bbhkKxopq7MCZhgZ3G9684SdkcWGAsPmidFpRcuQqjBWKZz
1140	fee_transfer	662	900000000	1	CkpZB8BDCgXVCsWVgjDvf8tUWSvLg6EhZ3VgNgCkE3VqRfrDeh9xx
1141	coinbase	662	720000000000	1	CkpYe8fPCGRUcnT7XmffQzBipT2BeyrMrWWk86HFWFJvdr2zKL4H2
1142	fee_transfer	1613	250000000	1	CkpZQFowFbX62oy6qUa91mbcbobVH8G4zF2YRrHHcGU7sDUzYkMbG
1143	fee_transfer	662	50000000	1	CkpZL3ycrNHVXSPJ8qqJFVJ3aW8cFezDSZNtZkQi3Av3XyFu5TaeU
1144	fee_transfer	42	110000000	1	CkpZHFtPjHbzWs9GYgJeXSQovGLTqCqyr3nxaXtTeL1sx5JPNL3Sd
1145	fee_transfer	1690	40000000	1	CkpYhZe9QrZ9pAxgTfEHqstDK8ZYySVLeTsc4CTfMzoy3o4raTYQP
1153	coinbase	1605	720000000000	1	CkpZRCxEUmF1vrVhSev9CkFwt48ZpPLEHnX132CcgHASy5xYGap79
1154	fee_transfer	1605	20000000	1	CkpYbnvAxQMnqgF1zdsX8cQVdoNNk3hQM2vQ14G4wpQ7daaEp5Cw5
1157	coinbase	1449	720000000000	1	CkpYxAdC78vnnsxRSpr4G24VwqAuGYWXNMECDW2HzXxyC1GuesNW6
1158	fee_transfer	1449	10000000	1	CkpZ4CDfoSqiDZbxVthcRfHPKvtU1FVZY72gh4xVTZx454GEtFfvp
1160	fee_transfer	1643	584000000	1	Ckpa9J15FbXU9bmfezeFJWthcAzKXBoeTnVhfrLijGTjg8h6149eo
1173	fee_transfer	1711	110000000	1	CkpYymiRC52ngKf58Fj8F3U1F6FwQz5WGAGTLq6ofLDLck3NcsvyM
1176	fee_transfer	632	110000000	1	CkpZFBzq6nbvdpfDLP3eALTR5MDvxDJe1CMxDiuhR28B2kYeHQfZc
1187	fee_transfer	484	21000000	1	CkpYbppfnBTL6DLVzRgoVU4xRoMmoJWQSDn2W7X4MJUJchkewS5vk
1192	fee_transfer	1688	150000000	1	Ckpa5GpQ5obPEPe3LRWm5LtK7djPWuvMqZ7CAm318TabqA9KyeiCY
1195	fee_transfer	1688	130000000	1	CkpZ28UVGQB5s7FS5RsfqLcSMjscVwtJZsRJxLJ2LzX6gnk5jPdZL
1200	fee_transfer	1683	450000000	1	CkpYqWwo5s5KdvAr3Fn1oSXHLwmER7UtYBD71ShnfnkuWtwBGdqWf
1202	fee_transfer	1445	140000000	1	CkpZQBwubt7y9WKb4B7qtUmKLcmWMZQtDRcbpkcW8mMvS4dUViYjf
1207	fee_transfer	1706	130000000	1	CkpZ87uuSfYzFagUkgSDEVFGZEj5wAuqcJ89EdHYynaMGhX8W6fPA
1214	fee_transfer	470	110000000	1	CkpaGXbfL6WdjAeJay7HnW3CsYsfJ5gKLibrqrRMNuQyaKaxjRzWi
1228	fee_transfer	1695	110000000	1	CkpZf7hJstfpuFutspg7MkjSgKxX5PDzNGkEhkAEy5xv5TRdbDnyg
1229	fee_transfer	1426	50000000	1	CkpYf2ESGCvQXC1pnwBCaEUexyVjxDtbBPrqcTawwZ2qgFfv6C2qS
1231	fee_transfer	576	40000000	1	CkpYsSPyj649BtjZ3v4DHJagjUVCd5WeDm3PRqSRXoS1xRaiFZw4x
1244	fee_transfer	1688	100000000	1	CkpZUzJy19e9SdMMCtvCCKXHrPx5BXQ76BhvVETmVLf7EytiB4Gro
1245	fee_transfer	1692	100000000	1	CkpZpzNWBFLSUhiC5CyNfbaxtLEX9BvtFqTdkEb6nzuXqwTbSAEqJ
1250	fee_transfer	1759	110000000	1	CkpYSgGM4EpYkTuz5pzXqmSKSPxQ1LvgjoLrPK8K4gVuncPJGwoff
1252	fee_transfer	1729	130000000	1	CkpYpctamy6Kj68MfNQ32rb5aMANH9U7KL9JwK9ueyeneBNwffaEa
1256	fee_transfer	1573	220000000	1	CkpYRUwZNp7HW5hwveKUVjyDgChRQQawZd4gzAX9GwzqzRNqF5AQP
1132	fee_transfer	1444	40000000	1	CkpYqAgKGr4KkJTGEfFwLejxzw4adFfcJmnJdngn3L7SQePLigwEN
1135	fee_transfer	1714	30000000	1	CkpZVfB1Ciq63pNfrJoSf7rh8S5kKus9P5yMB3U2fqhureknoRS3c
1146	fee_transfer	1643	900000000	1	CkpZrHYuKfRnQV1jvQ197B5qn7kY5nmfa4jnqHSsE1sxLB7DtPp6s
1147	fee_transfer	1643	439500000	1	CkpZif4we8rai5L5F41CrWTZYfjSxn8Sisfgr3L8KJQR11opaLqRn
1165	fee_transfer	641	105000000	1	CkpYR2jKcpxZmUmD6jPYv4uMWn7UgZCdfVd5yvDosSviTDjG9cCpM
1168	fee_transfer	1693	21000000	1	Ckpa6rrsfYrQRGn873qXV2kJ1BH5CDtQUr9g1YHy3dJxrsZkkzBR4
1171	coinbase	1615	720000000000	1	CkpaK93VhYhdVMcFF2ChuTCf3fyKHNNCbQ53VTC4h53LffPJigPSZ
1172	fee_transfer	1615	140000000	1	CkpYZPT8QfkJPneiqDRC2Vyy2x6KnX7jZ3mo4f6eQMhyqRKpdYgYX
1174	fee_transfer	1685	201000000	1	CkpYt3fPWthiyjtg7d2ZkgKNQXmkuCCrb9ZVbMZyhorFhHgs2SukL
1184	fee_transfer	1710	839000000	1	CkpZSKaH93q9asfCpapAb9Sds2cdyNW1phe8p2NadWRTPYrnFSKfn
1186	fee_transfer	1685	415000000	1	CkpZECSisz5oRkYAin3cs5iALHERC313MTS29tkyovjxgZweyEDUC
1189	fee_transfer	1688	220000000	1	CkpYugqch7cc2bk5XRPrK9zrty2yzQRP3Qco3bDe9GuQy4W938xjy
1194	fee_transfer	1677	130000000	1	CkpYmT92qNcX9suvUAtAqoz6AULcqJsKermww6XEoHVA2LG2JzHyW
1197	fee_transfer	1700	140000000	1	Ckpa9EeHuoMvooHu4mHJoEM9X2CTw8riegypQ58kfPiohBZnDd7Do
1198	coinbase	1431	720000000000	1	CkpaJKo5Z6S2Vpnrbw24kvv2JB64rGrfx3bNabJi9Md2nRZLcZgsF
1199	fee_transfer	1431	10000000	1	CkpZkSDRKGiRoGVVbEZ5avwQy7dvNLV17xPnqxKNG6qXJyjjvXPkt
1206	fee_transfer	1444	130000000	1	CkpZr86EA8TcDefXKPeZfR4JcpwmtwMYnDyXWJ3Piw2esizHpGEvt
1208	fee_transfer	1716	130000000	1	CkpZksMHAA8QdH4unAowiUJwBRUhqfCh5DKRmo67aW9AEr96GNMTt
1217	fee_transfer	470	120000000	1	CkpZ8HysqAdSX1fvQWJUJmsQ9Ga11F7bziDWHGm3QqAihE8od8ki6
1219	fee_transfer	171	200000000	1	CkpYy5WsDfpCsvm211WV28RDAuoU2w3ryNkVUmWkFtAHMw2GsegGA
1220	fee_transfer	171	2039999990	1	CkpZ3mkgB5ua67v9XqPUG4UgwqMq1CZVemEuZDBZj6arWspBo5MUc
1224	fee_transfer	171	1230000000	1	CkpYd9TVwEzJVgysJvk5y5guCrR2TLz6T2w1cLjajXoEZju6UaX9o
1238	fee_transfer	1471	100000000	1	CkpZUFQXB2kJYPyjGSBP7YA5YgnibzuyyaBHnboEr8DuzvryQ1Whs
1241	fee_transfer	58	100000000	1	CkpYdoEBJpqtReZ3RwW74TobDrX9kCD1D2pSWsFtQts8y3M1nHyWS
1242	fee_transfer	369	90000000	1	CkpZyuTvMtLbPF4Y9JNeadEHxz3ogUaWgdLWAnpUStRnYvaqvwNzK
1247	fee_transfer	1677	63000000	1	CkpYaKMTSM4iBQXBgSW7qbWJKK1Lk6yaJ2v7i688tBzkb1r4RXe8f
1249	fee_transfer	1759	940000000	1	CkpYpGBv1iBfK44SvQ8qEv4UNkxnMsg6w5bue68JKvymS8YDSP66P
1251	fee_transfer	576	803000000	1	CkpYYxB2fBQDQ3Mszu6MBPQetYUHQGejNrYXB4gWikBYPfZrWsGNs
1136	fee_transfer	1759	20000000	1	Ckpa2b6Hj4J8DDuK3GWmoxBpDRE1ufWBXzNWMVSTGqj8u1AFM87pX
1139	fee_transfer	1549	110000000	1	CkpZTnkp3USZ2HHoxHJpEazaAXMEkc8zzEX3wgm3tTkne9VbtyQAZ
1149	fee_transfer	1668	40000000	1	CkpaGAheh9y3XLW4UWndXc9g5VEiAWwyfvrwkkPtDcpeJNLPYMbyn
1150	fee_transfer	1759	10000000	1	CkpaAguob3AmpBMCcPdotbQgM9gir5ucZ2P7iYXyBGWppwcFEQpwP
1155	fee_transfer_via_coinbase	1603	10000000	1	CkpYhsw1Nxnd8UvyNGXmSgxs8GoCExG5zxGBoZbsjpJdrxrcbs5Bk
1156	coinbase	1610	720000000000	1	CkpZ9ZEZjMzEHALMYiyDsm6twvZCWm3aDBYCTTmJqzitFkYRPmJB5
1161	fee_transfer	1762	20000000	1	CkpaAvtdkU4TVyV5wnpFyQzsTjxU6HPfQnquoTKQkUcXgKjgZNebF
1163	coinbase	1666	720000000000	1	CkpYkRekLj2uEVJ9R3PgrmWRSsDxxwQAvjtYkABJyCKAaFKS6hzNd
1164	fee_transfer	1666	10000000	1	CkpZdKJNhZ1J1xEQ97ebp9LhrS2mxDjtznoSANoauArRebek5GDe8
1167	fee_transfer	1616	20000000	1	CkpZr1RFRZb9RiTD6FL1viUzBUfRqCPkX6xiSN2NT7ZZFaoKs8uwR
1175	fee_transfer	1555	110000000	1	CkpZygNQCpAEw44czAHo5P9ztiAtBRDprTpv4MhNMDd8Q1ahcbarG
1177	fee_transfer	1710	1490000000	1	CkpYujMHNkEPDXoW7kmryFJUCSFNkyRyh4v8zJeJPwxKXV4btcMxc
1178	fee_transfer	1710	120000000	1	CkpZtxCxnvyaywDtzWiVRJRm2g4uVYz1b844QmeXQYW6g4Jvjm3z6
1179	fee_transfer	1729	630000000	1	CkpZDSmgLjdkSmQq6NEGAv6nZnEkhH4uyrZDBfwSKBMxGPrYmDNxx
1183	fee_transfer	1607	11000000	1	CkpZVJ86aQa6vNCrvMd4K7xr6ECQ2pUshoGMddjLz2DWqEBHSq6HY
1188	fee_transfer	1690	21000000	1	CkpaKJHNC3cWWvhSUSp9A4SNNrXCZDMb5esMi5ZapxxDrPRSq5e9P
1193	fee_transfer	1594	150000000	1	CkpZfpzTWBPxBybjNE3RzjBaANPNjehTTiKBFEXPPGdtjcZSA5GRU
1201	fee_transfer	1684	140000000	1	CkpYVVQafN9BoCQ93xSfhmg3qjLrZJV3gAXjWw6AuSJ7peXbs1ENW
1204	fee_transfer	1599	1100000000	1	CkpZC9HDgZonqn35jdZh9rFdnzw6gHQn7FXDxnntNNKScw6JBS3HN
1205	fee_transfer	1599	105000000	1	CkpZxZyR7bWQNmmoMqfdagmW6sEW3YFpwBHqsRpF6d72kRzuXsBbU
1227	fee_transfer	576	110000000	1	Ckpa8RCMvzH7igysDETgqTD8z4fmaJRcDspyHAYcLzyTPTf2P2bfw
1230	fee_transfer	1476	1220000000	1	CkpZ8xNHytQGxBwP6Xdq9x3YjTd9ZSftcrcmsu3p87mkZXSVLkvUx
1232	fee_transfer	576	80000000	1	Ckpa3j5NfqKCNCFpF56hwDmhh2btTK9f5EgAgrhwhVjanFaoqrPhV
1235	fee_transfer_via_coinbase	1443	100000000000	1	CkpZAhsUSLvEGnPjEt1ZDnjdrneNVuzNvnajEvveqQdMfiSxK9zUv
1236	coinbase	632	720000000000	1	CkpYc8NfvoTKccGEp8uwBjzxyzdsN65eS2RKdT3bain59DfCT1ZPk
1237	fee_transfer	632	100000000	1	Ckpa3QzyFCJTawawj1gujxq6xja7TVqwz6NEF963zgLYso3tymbgd
1246	fee_transfer	1756	490000000	1	CkpZNMQ96E9tcmUDcsJtZVk3AHPfCDjYcNTYjSxysWAkNVraZaK6Z
1255	fee_transfer	1649	220000000	1	CkpYqxoLdzndgnJVy9vuh1nZUhBwFK5GNv9SQZVx5uHTFArsDoK2S
1137	coinbase	1630	720000000000	1	CkpZwoVAWooFvzv2ZerF3WWhymfkhx7bsrsSakyNk6uW5gwkvqPmw
1138	fee_transfer	1630	10000000	1	CkpZjEEX3iCSWGjxXjRgxGPd8oXZz1HeY5qjvcjhJ3nYkaUFkosGb
1148	fee_transfer	1451	20000000	1	CkpYYVD3qPcp24B8yuL88Dhu2hrwzSy4XXd9gMiLrYxpR9sqSnpMa
1151	coinbase	686	720000000000	1	CkpZVcicAoZUTZi2NZqo55hJNdXivZA5y1xCyvcv5dhfCe4umidFB
1152	fee_transfer	686	20000000	1	CkpYVgSgSPjc1jjzJp6m1f2k9mKXSKPm6NcYC1VeHXGDF9WxyWM8G
1159	fee_transfer	1717	20000000	1	CkpZW76mnAakQyo3QhYMXCiV6ezkaVETXRHzwRBL6jF5goudNTdAZ
1162	fee_transfer	1677	14000000	1	CkpZLav6juszhg2sDEsPiQZpiDqZdXxbnRctfUYMa4UKPYGmctE9Y
1166	fee_transfer	1602	110000000	1	CkpYx4GyU8ytPNtPacfrkRoNfn5CTpXPn13ek8uL8mdNabaDP4RRb
1169	fee_transfer	1759	30000000	1	CkpZmb7RPaPfZXWH9vYWb1SLWFi8gxB3fL5FoctyEY7FeNdfqBcf2
1170	fee_transfer	1673	140000000	1	CkpZTZbSHKJaN8hCQcCpLYQD3yhGjyPxRkHjhctsr6sKx1H9QjkCb
1180	fee_transfer	1671	630000000	1	CkpZGzWS234Bqi7snYp6ZxCKmZiFRV5MVzVFTQ6Jh9zDGYkDaUnop
1181	fee_transfer	1522	110000000	1	CkpYifbS6rjdNNid4561T2xB88YTjAUbSk218P8stHmwtn8XYWUAe
1182	fee_transfer	1509	31000000	1	CkpZgTRat38ZmxuZgjhtzoLqF8wrVwyE8j2Txu57wgpJKwf4HxrR6
1185	fee_transfer	1701	1000000	1	CkpZv4WSwyd5UUsejwf9ZYbz35tZ7SHK2EtRYMPFYPXmxkB5tXxyq
1190	fee_transfer	1683	220000000	1	CkpZSQh7xjugcJ4E68ygF2avFLz9dJRJPAj26PXhdYWYXfPemjaFb
1191	fee_transfer	632	11000000	1	CkpZKCnhav4JnJdpg9bcLjhLo6XBYTuJ7vAvX6nfcuVXgmxMcdG5z
1196	fee_transfer	1688	140000000	1	CkpZ9ArNVGqyr2hHzQpGUTuMemk8ZWC5284aK7p2pkqpzPHNo7cXH
1203	fee_transfer	1685	410000000	1	CkpZTVzPZSiQuBm3vdc3UzKHGu8nnnBNS38dNwWJM41XSSY1wRcr6
1209	fee_transfer	1687	130000000	1	CkpYj9NoVuSYoE14P6D2ks3ddvXziSfBouHifUWXa3vvGxcQQ2BsP
1210	fee_transfer	1559	8299999	1	CkpZzWrT2BKRm2Wp7WobcYJ7S1mk1LXnDtCZcDFamdQTJ5xoBHUGw
1211	fee_transfer	1761	1	1	CkpZ6kevYPJhaCkfgbr9JuNzJHVER9pM17zw3CwmSkDeL2goSCiYH
1212	fee_transfer	1460	1700000	1	CkpZajbjxw64jYd2PKm21PiDpq1TAvuHbmHzhqdWVwdMhJbn5oym2
1213	fee_transfer	1426	110000000	1	CkpZCGbPKb2Mgvgx37WGLYisuwjRcm8mSXxPguJwu4v89u4Bm8Ev4
1215	fee_transfer	1710	820000000	1	CkpaLWQWj4BFfJHtcgPbpzAMFr5uXezqs48VK6ZrpyyaY1uNtrPqP
1216	fee_transfer	1710	393000000	1	CkpYTAPhE7WTSCX3n7Q2jgzubSkSZeiouVKSDaFxE7mUFQ1VHq5Uh
1218	fee_transfer	1686	110000000	1	CkpYckPooc47SnYpJ7RobSRdsj7KGeJKZvE3VaYvuB86FnJxePCUg
1221	fee_transfer	1434	10000000	1	CkpZDBTjP6vvA551yNGTqQSJ3bZCyoHD3kiUvPQvGva28v8JMeZs6
1222	fee_transfer	1685	110000000	1	CkpYbLtghaRMdwT6YNkhbgWQLrKHy8taZyFXQhZwSqRtHXPSYktwN
1223	fee_transfer	641	2856000000	1	CkpZ8xfSyrHDHyyE6i6Q1YNeueHRTS2CRTzkrZ9Qgyqq33WBT5Lgy
1225	coinbase	1801	720000000000	1	CkpZxWfZ59L4sKbz4yNz18wZFfzAGMaHM4DRFHC2vr92hF2JhKFvb
1226	fee_transfer	1801	30000000	1	CkpZyERbhN7FXPbpjUXXXCC9dw2uENdB33RcWAzC9veFcQusqRZGJ
1233	fee_transfer	1677	50000000	1	Ckpa6sx6ADmmU7dT7yXTzvmUPwMRxDT9VfiCnoFWuC8yDbvb5rK1p
1234	fee_transfer	1686	60000000	1	CkpZnXxZmmAquPNT2oFDNveZZqbGQUSvVjCA42S6Yy3bDrPwAZLmA
1239	fee_transfer	1683	100000000	1	CkpYTJLRRU5ZBHbAwAs3nkQv8sGawLdRJEoHRH5GcAkW28eBaLi4E
1240	fee_transfer	1672	100000000	1	CkpZWCNMXbQcEWa61Gjqf4z5TZGyKTaEnc7VtbxFYpFQPa2PAv5xV
1243	fee_transfer	369	1760000000	1	CkpZbJCjWK9212tgdwzZK26PaWzKJ2ukpdBecMJc28BNb3CYcvpaR
1248	fee_transfer	1560	63000000	1	Ckpa4kKj4B9v2yw7aAZz5SVivD4sxyLPph6jqnHs6cDo6R15JkWyJ
1253	fee_transfer	633	130000000	1	CkpZWsjAUUt8rtXz8qxfNhn66HpeoVwfdC1Cc8ihkEX7Pns4p5WRe
1254	fee_transfer	1677	220000000	1	CkpZSRyX2FD62BF41qo1Nj6iL8h8Lbp1dfjaHttuLfvcK2FNA5sMY
1257	fee_transfer	369	11000000	1	CkpZYaoDKibiSKWfie75kjKAZAnpRSW5byjGFtyyHM9iNfVRpRk2m
1258	fee_transfer	369	1050000000	1	CkpaGHxwqAkMfwQAjX9xs4ytexVPqxfWnum2CybZjYiQbf877J2ut
1259	fee_transfer	1601	11000000	1	Ckpa3rkhAkXtsQ4YTihdtvZBctqcT7ZJkBevto6p3ntXxZwAY5bhj
1260	fee_transfer	1689	11000000	1	CkpZNp67baT7FCum3NzhCMCti4NVorFTPk8dMYPXtyx9XgGKMPGjG
1261	fee_transfer	1649	120000000	1	CkpZ53mkxRwdaEcJ7cETnAXBeKog5qUGkvAMCJ8MkCsNsvkwP8o76
1262	fee_transfer	1440	220000000	1	CkpZxbEqw7TdAYpG7KhtnRYEdEDajKH6nxQaNHCzACTJ22Uqnipov
1263	fee_transfer	1708	2550000000	1	CkpYyDqsDQLw4EktQywoywsNc7T16X7SPaf2dRhezKdjHisoGHRYC
1264	fee_transfer	1708	500000000	1	CkpZVM7VbB8XXoawmQsR9hKBjJn6d24TJ5fUfA629Eag1kGGubZBG
1265	fee_transfer	1693	120000000	1	CkpZAW2LyoRe1vFTfqtXM35DZC5qstNMDL1Qt6txndKnnpQNNL2oi
1266	fee_transfer	1599	120000000	1	CkpYVdkJdKSiNwZhwQxAs5Rr4LMHgt5z3VpEQepjKfFnDPF7pNH6j
1267	fee_transfer	1684	60000000	1	CkpZt7Ccz3Q3xix1TMxedR4Z2xFzRGWcXVWDTxZNySY5i9ps854eS
1268	fee_transfer	1727	100000000	1	CkpZeqikojZ6G3bRUuvFLHr9a1872w6WxS25opyUGuCmtmyFi371b
1269	fee_transfer	1474	100000000	1	CkpYnbcJiAFPrh6gLARNv1qzV6JgX7wxisgz2P9XfFPXKrkEiFrGG
1270	fee_transfer	1687	30000000	1	CkpZYcmCbyE6huEK8qLqQSuZD6azhPWUgHwKKgQCsMHxNUwV7LzJe
1271	fee_transfer	1476	140000000	1	CkpYw59wSYhaP3sS2poNCH1xpZ3DpJk4SDKnyRguHhDeuRtJyxYWx
1272	fee_transfer	1675	140000000	1	CkpYiQi48KVb2pALR7vPJafJ6njme2kTYfWhk9C7tM1H13xRGaa85
1273	fee_transfer	1613	981000000	1	CkpYqFD655zHhWhh2SX4Ki9R85uahaC8SKr5nsc2US9FahCwyu6qU
1274	fee_transfer	1613	50000000	1	CkpZDkWvneTeZMLiMzDEZAgtwB7611tUS5QQZvvifR9jZULfpapPD
1275	fee_transfer	1613	80000000	1	CkpYtwQLVAjx4wwSTCBEhh9sdXPrKYNvpp5B3wECa5aXigkbAcW1N
1276	fee_transfer	1719	20000000	1	CkpYe9LPkQ9vRtVw3P2TQsDzgUJrhZRuceBixEqHGFmicoaWhhEUT
1277	fee_transfer	1698	110000000	1	CkpZAsXS1MQPXdc6virMKPjKLWGV6GeC7CLA9g6dprTSYRZf4bhHp
1278	fee_transfer	1623	110000000	1	CkpaA8A1eA3vDnuAPogWDPZRjPP2M4UPydjPpjUVYWkC4ZrSxa3HK
1279	fee_transfer	1623	500000000	1	CkpZVAEF7mFtNSQkqtt9vU9EMjA6xSVGLa6GVkQyzaA5nYXxdVkXS
1280	fee_transfer	1567	101	1	CkpYc4t1WEmE5BUJvhspyFMn4W5YrvGkVVTnDBhpQiTmGJn5B8Dks
1281	fee_transfer	1794	100000	1	CkpZDQ8nq8tRnxCowvDqVLx1q4Wu2oSaaCvLsnzPDsk9vYxfZiRTG
1282	fee_transfer	1623	629899898	1	CkpZw85mMRzWnhRhZRdEvDLxK1Ke76zyc9PyqCg2YRbT1MrDM1W1D
1283	fee_transfer	1587	500000000	1	Ckpa2odQfpsiFweoECLx1YptJz5VGeBSzTyzZpT5yRhYA2nEDoUsz
1284	fee_transfer	1587	630000000	1	CkpYcm9j9ZhEyNGQEzCTXtinzmkDBHouGG3TeeNSd38NiBUwA4xUJ
1285	fee_transfer_via_coinbase	1420	2422222	1	CkpYdcBUXTCyQBX7y5UkLmH91JLFtWBPky772aqxA6Buk4hJ1kKiV
1286	coinbase	1682	720000000000	1	Ckpa3d39b2pbQx7NTsQEEMq9rkXRa1H4vJLd7mnuQ4F5bMKDYso9L
1287	fee_transfer	1693	500000000	1	CkpZUWQmAZzJsaBYK9VJbo5FUz2qdKmu3DTx9hGkx3u5VZG9yTeKu
1288	fee_transfer	1693	630000000	1	CkpYUQUcnQkFdgCU7C1xHMNBwkctRAuxmAGQ82yWxNAZwEuRfexyb
1289	fee_transfer	1682	500000000	1	Ckpa2cjKtJ5Zh4wgAkVuvgQVEU3xWXJgHYbN22nXhx57ema7gPJ4k
1290	fee_transfer	1682	630000000	1	CkpZAfksWvNZYD9196BJALqKUVkWzJKnRGsmYzdFMzZKJPqivRw8E
1295	fee_transfer	641	3560000000	1	CkpZKokvqpAaGMD1VZUtqcaVpPfSXrHFtbsHvnrmsH5U28cXLQbqg
1296	fee_transfer	641	390000000	1	CkpaGieRKnekVz6yNe4TQGQNmVRJR67e3Wj5JDYUHnH8qZAxDdj84
1299	fee_transfer	44	140000000	1	CkpaHgDGWQF2dh6qZxoGvK9qr5hNufb2eWM11ApUAorwCjj9uLkYf
1303	fee_transfer	1708	1943000000	1	CkpaAcKz3gLkJq64E4eDWwvJ32w7oqx74jqyCdzaE63thqGxCeT6d
1306	fee_transfer	1541	120000000	1	CkpYxfFQ9PdHYDQ1xZ6TRjmxnNgrPaxeRKeXjmbARXGCQWYc3CFzi
1308	fee_transfer	576	2870000000	1	CkpZV2ag5EaF4hzn83MZCbhCtQjk5wxN4ueozLowH54if5wo9GiKs
1309	fee_transfer	576	450000000	1	CkpZ4Vcgk2SR8QdCWajFp3JXCStanKyQww7BTdhQFdycyVFYw8zzV
1318	fee_transfer	1708	230000000	1	CkpZxR4cFHM7KcWGX5U2jQKsfcbNzd16tT5WGfzoUf3nWKCboKrKu
1326	fee_transfer	1695	1280000000	1	CkpaCSsepmLfW5XGqyBV5a9xibVFVqZBjMkvUx8DVT5UTmihGbjR1
1327	fee_transfer	1695	90000000	1	CkpZirk6NHseCiXrmgZCpAiYC12XAHzBux2N5ZckE8nWjYqW3cTKA
1335	fee_transfer	1692	110000000	1	CkpZbS1ZxrLSm1J6RVX5h7Jy7DBJoKx9bATQPzdeShtqyGZoDeq8D
1337	fee_transfer	1719	1780000000	1	CkpZjsSq1pLYvHr8xUbWVNUeSbsrpxkWMSByxdyHJnrFEtJ6Ayk3H
1338	fee_transfer	1719	230000000	1	CkpZRSgP4ate1CPSVyxff1Y2ReFmYZLd5bFzEda2G91uCmFBg8Www
1347	fee_transfer	1549	30000000	1	CkpZxZeo681g2AsPqBrM1H77CQK9opAKupu1EoL6QLyYAw9JgzHcK
1353	fee_transfer	1670	30000000	1	CkpZ4bpZ11NKeQkKQ9mrg7fWNYUoiQDraH4cSijccsuvEs9f4oPnE
1358	fee_transfer	1447	50000000	1	CkpZESBFWWeczdotHVqCdxHDrvRzXN3vHmpUWtsmRBuBqh9TKo8nN
1363	fee_transfer	1709	40000000	1	Ckpa11Fgk3B22mob3dQRReoiD5cjU3yEVXDJw3H8VNg2ezVLzCoG2
1364	fee_transfer	1608	130000000	1	CkpaKA8joUhhu86LE7uxsQ6KpUBJrY8pxL6GY6M6GJ7y5g8M4ccRf
1367	fee_transfer	1402	110000000	1	CkpZ6XKRX2PUf3i1ZgexaPABaogRFK6gqfwZvvvfuy5D5KEmDoRKo
1378	fee_transfer	1451	40000000	1	CkpYrY7TdjBoawrdQ78nKovy3bWUWbcZCo3kQ3dnFnYZhSJakazH6
1381	fee_transfer	1402	11000000	1	CkpZ4UL6B1eWsn4G1nvDk8mueT8Ue6wso3R1WDSfWBpA6ZgQBhzXc
1385	fee_transfer	1688	750000	1	CkpZsPpkN4jtiPVGmyBYn8eipZ3exzVhcgMsGV6sx86BbAAog7sWa
1386	fee_transfer	1646	9250000	1	CkpZ4d5TwDXqJeLqWe8Y1WdETfcwRAywUud13KwVx5MmNGPmw6S1n
1392	fee_transfer	1668	110000000	1	CkpZZbBzgLi4sxNkUJChZBGEuEdiFVW8WoH2KL5JqL8vpufpeQda7
1395	fee_transfer	1786	1	1	CkpZLNnQ8xdi1kbyzNHtTWnwj74Bn2AWx5LfXZmiHbByQ7DAE74g8
1396	fee_transfer	1706	1499999	1	CkpZRRFWM3wQCdg4dH7xd65QfEuPP4yr3mZ6QZqwPf4sC2EL4s8mi
1397	fee_transfer	1646	18500000	1	CkpYhiVrXcp25ZV8ndFwfKfHMTNi5qTgnUZ8fYaDiMQcbaJGXqruh
1400	fee_transfer	1673	30000000	1	CkpZsStkGW728Lnd8YAsUW8vnd2oxME8AhcuwdrPJtQcrVLo5HGyL
1411	fee_transfer	1521	20000000	1	CkpZiPhCu2qk3Cwy2Hg3g7XwaD6cGBgA3dqegKaQNioQpzYYFJ3C5
1416	fee_transfer	1683	1000000	1	CkpYomVM8uH1HV57uuFjSZ51Cd3Evnfqgy53XLGjafjqrj5NN7Tkr
1418	fee_transfer	1448	1000000	1	CkpZbWeriaCYqcAG9gr3jEKpTqrZrb1DcZzgdfdYQYo6zRZKGYGxo
1420	fee_transfer	1402	1000000	1	CkpZQC3CrRJiWP8PnKghXiTfvQDLa6mrUX5eXA8txyDwx9hQQfeWf
1421	fee_transfer	1684	2000000	1	CkpZgCMTgYefejqEVV5mD7XHSQnqBcsLEqnPQDyyLmY1FGkf5msi2
1422	fee_transfer	1716	1000000	1	CkpaCo29yAr66PXQainP4Uz9nUvqv8Jb1tNJZcu56wVaqFxWfW9o4
1423	fee_transfer	1419	3000000	1	CkpZAQYiG2p7UbeBEFXQ2qAAZwcBHRVtRyMuZD57Ysydr7WKgkVYk
1425	fee_transfer	596	1000000	1	CkpZ4ifZxqyDwpsBJyW6k5jbLVWxecvFbuxp3nUviNeGnDptw5PZf
1427	fee_transfer	1692	1000000	1	CkpZnwSpEtPQTh8GCFV2XEVa47nvAsoV9Zwbb5MzPPJAsvogeCeaU
1429	fee_transfer	1677	390000000	1	CkpZieGeqpUZzYiGLQEYx7ao98X3aGDsE6azNoMyh9t58s9FZmpM1
1431	fee_transfer	1715	700000000	1	CkpYTCLwCFNVQxA7NbRZtdEzwKTUX5SMTqtbr8pdVqeZS2GKXaZvB
1291	coinbase	1493	720000000000	1	CkpZjp7q2YLiBsv3RYAN2ZgRX6v4CPjfZqdxCx2MWJEKRrJd6cVH4
1292	fee_transfer	1493	10000000	1	CkpYqBgERgEkLwbenyYzyzB7ju5umHjM6Lirq3cRqJvzDKNvx4NDN
1301	fee_transfer	44	2500000000	1	CkpZrAbrGZjM5eaLcVhXJSh6ep9cYwBswsv2AvnFLUsjZrx9xqQx8
1314	fee_transfer	1444	110000000	1	CkpYwPugeKgLxDtgkXusyvi3ccX1aPqipcRwt9YXkDA9YK58iSDYt
1315	fee_transfer	1607	2850000000	1	CkpZFuFtrHr634fDaCaLARzPVsmPZYsAzAED5K5B5vwN1Pno4riD5
1321	fee_transfer	1458	31110000	1	CkpZkqrSKW4fYFkYq14sz2vxnQfEpGw3jU1pjN6rp2dXJfugE2VCa
1324	fee_transfer	1564	30000000	1	CkpZnHLepBwgxqUgRaLV6HmK5Ezz5P9h4BQqnFFMzpEHtmCjcFvaF
1331	fee_transfer	1650	110000000	1	CkpYx8Zy8ngftWARvWzEGUpKZJ3tnUdzvN8nGDJR8WwyGAqn9jhmg
1332	fee_transfer	1768	1790000000	1	CkpZfrpYfK9w3ScmkRjUdU3goHSZHABnB7UTcUWCddbB6AM4dguj4
1333	fee_transfer	1710	110000000	1	CkpYhMHfuaTHwmYRGTr37AAJrjM88nNGRegJGpRTcidj3SqVBaUV6
1345	fee_transfer	1607	1499899898	1	CkpZTRZfezeVnmBpWvwVKKpX4ZKoG8ZhvWRtcxEYqrfe8jFtoULUh
1348	fee_transfer	1671	30000000	1	CkpYfyu2BGByiwQukxCZjaPakD1Pduh5H8a8VbHKWTDfnWHBRbRRa
1349	fee_transfer	641	1040000000	1	CkpZuFG1SUHzEVggXD6o1HjHC7Gv6pW46Cx8TzFUcGLi7NypvTtuw
1350	fee_transfer	641	170000000	1	CkpYcHmDFB933Dc3ZucsCgdF94NSJYrQULDxbqUCQ2ccbLeB9ZFku
1351	fee_transfer_via_coinbase	1584	500000000	1	CkpZ7V9obaT37ZUTX7W5JyxAUu3DVcRxfsoWyuwseL7AGMT6NxG66
1352	coinbase	1740	720000000000	1	CkpZbcoZ4xwpDyJB2RtRidK7TtnPMJtj6BHQipnX2rLad3PRFV4RE
1356	fee_transfer	1768	21110000	1	CkpYTUZk5DCvDKfLSgzjViYq8g2n2hMGpt2McBDYKYuRh4MPuyt2b
1357	fee_transfer	1622	1201110000	1	CkpZtaJnotw9j23iL7C8cjxQCACG2fxbprQAaQWGb6nBagXXuwdkj
1365	fee_transfer	1684	130000000	1	CkpYU4bqTaAmnX9zyka3GXnyBw6g5bWoepxjTgYqFFegBwYjfDrKE
1370	fee_transfer_via_coinbase	1613	250000000	1	CkpZQFowFbX62oy6qUa91mbcbobVH8G4zF2YRrHHcGU7sDUzYkMbG
1371	coinbase	1711	720000000000	1	CkpZcgZGzinKqdqFmzLY1PZ1diAaC5mvuysSbqLwTJ6SrAbsF73LH
1382	fee_transfer	1601	1000000	1	CkpZ4UiRSZDYT86eAkTLt6RHAnWpp4jw2VjzJeX83czhVzCQQK76t
1383	fee_transfer	1688	1000000	1	CkpZ8e9AXs33DUbLSm6rdzhutpAPEmMrn1pVmCdKkx6CkbMZAL2F3
1384	fee_transfer	1724	30000000	1	CkpaAR1hXzAhmtWTgFu8j9wC8r5U4pRUvZRzFw7oTCSwJfNKnqoKM
1405	fee_transfer	1560	120000000	1	CkpaGswtJJrCFgcPKwKsNjdBdQzfdVagvvYAmfniqmow9ZdYVdnHq
1413	fee_transfer	1717	11000000	1	CkpZiqYLeGKNbJitLHUthstobkxcVwTB2rKWFuxedQBZqyMaBT2kK
1415	fee_transfer	1694	220000000	1	CkpYqZAmosBQ4xDsfNJwcf4b3L1PgAyWaVnHDJVvTxLDPsRkMKuRE
1424	fee_transfer	633	1000000	1	CkpZaFtxybwq7v3LgmCi2tnpf7Ha2u7w3bXvuNXGctiuUWbZDfktN
1428	fee_transfer	1559	1000000	1	CkpZG8sgCEbKyk3oFAwSHhjrVYATjo2aBLeUWksDu4RFEgk4VjHuB
1430	fee_transfer	1607	700000000	1	CkpZvjrph7o6cJMWGYonHsycaGJGSRJ6vA5LPW5YK1SVL9TLTsezK
1293	fee_transfer	1610	210000000	1	CkpZrPS9aRi6xSWwwJECLbQrcJu4z44HCiFnpJ38NSKkiFxXs7ai4
1297	fee_transfer	1682	140000000	1	CkpZMkP9q2eaAQYSpjZiNE4j8FZ1j2BLqLTm72p7z4Nvfig79acRF
1300	fee_transfer	1710	140000000	1	Ckpa9Jor3fAKdk23CvfY77WXF4R69ZnUDG9uDF4j6gbpwaqLfH619
1302	fee_transfer	1489	40000000	1	CkpZncA1K4jVa2QPPG1dRkDByFJvHk3ogNGRDeU2KPxTaNH8i2f4q
1304	fee_transfer	1598	20000000	1	CkpZh5U7Jv4K2UioPRJjerkZP6PFd2oXb5TpbdPa7ahUXDev19RZY
1305	fee_transfer	606	30000000	1	CkpYkPG7cbqUeeL27FdVM7N4k4XhnadeJjuAKyVy2EMSFyuDx4CX8
1307	fee_transfer	576	120000000	1	CkpaCnXxgns8zZx7zckS54bvicfZTZaThjjvckirzPCisoanFkuwe
1310	coinbase	1665	720000000000	1	CkpZwSAxBvDkE8wB6kVL3rEJVZ77nHnJwSEmaVWpkhqJJdjqkKtpg
1311	fee_transfer	1665	10000000	1	CkpZucs2j7uTgAUiJhkqih2m78tkVKb7Z9mxosiiHHj2BSGU7hjVB
1312	fee_transfer	43	1800000000	1	Ckpa9ezmsYdLjvTsz4HfqcsHD6AEC4q9A16YWAv6URG58mtYTGCCr
1320	fee_transfer	1762	330000000	1	CkpZDZjjj138Au5QbEnAWDrmDMENzuC2kGVXxah2TDymNoU9QH98f
1322	fee_transfer	1706	31110000	1	CkpZGBo9Z6qAVM4XP9ujJhL9MjYJW3pvB1T1N3G7cKLug9BwqCkZf
1325	fee_transfer	1764	20000000	1	CkpYucKJ9ecx1VRKowYFaWJ4sECmRquJb6v7rjvESTX2g9FTMy7PA
1330	fee_transfer	1723	610000000	1	Ckpa22oKTZ3aUnyrnnVqtQZZ2PiSdQ1VNEZf42jP5qFfy5iBqwjXo
1339	coinbase	1632	720000000000	1	CkpYneTx2VNEfHKJEDWiFuxoQAYVdhQVEmRbL7ZzZbHqTsVvgogdK
1340	fee_transfer	1632	10000000	1	CkpZ1eKFYX5pmX4quFtimmWtcezEM9xWjfs42Kw4Dn32WGUt2BUuP
1341	fee_transfer	1719	210000000	1	CkpYmUkDaCiSTpjFRGZpA9FXrDpnqqbRicizd2BSxKTwfEQxKXP86
1342	fee_transfer	641	1890000000	1	Ckpa7CYU9gsNoeriMx8vs6si9ykt91V5rpC8d3wQgujpi2vQZJnyB
1343	fee_transfer	1608	2010000000	1	CkpZCESLJNnGqmBozxorZmRMRqXK8AswXN6ghtYnHszJSqagHoz9F
1344	fee_transfer	1608	50000000	1	CkpZ6yNJp6dpB5JHN7kyPLzpvmyQCxMbfoZEdPqVJaz2x6LzMoEdi
1346	fee_transfer	1700	30000000	1	CkpZRoxuTyV1AbJj74WQGBsMQqRbtXmun6PYg1HY97wopWMkoxSnj
1359	fee_transfer	44	120000000	1	CkpZhMYjNd1PpX3YrsYQLh8pmZp6tqBpBojWM2A38v2EYFjQcjKjf
1361	coinbase	1629	720000000000	1	CkpYtcuwTNCGByJVRHb36Nf98mceZcyExUV7Z9HBKcxQRH3jShGfu
1362	fee_transfer	1629	10000000	1	Ckpa63eDbpGLyArfXfZ2WHSoErD61a6YKQeWs3rB7LcTEtUNXNiWw
1375	fee_transfer	1508	30000000	1	CkpYUCYqpK8UeRHCwRXQexKy2oTEZXpcgN2t23DQ8G3YiE7WLmch4
1380	fee_transfer	1706	11000000	1	CkpZLTFDkm4cgdM4UMG71So7LA1Gu5DVgf6AcR3Q9LNx2JBQzAvpf
1388	fee_transfer	1696	30000000	1	CkpZKAdNiZswPUxteYwm35pkBhkBNEajvybUj3CLY3ieC6Fe2gB84
1389	fee_transfer	1749	40000000	1	CkpZPuu6FSxyT3Afm2izt4PtyBuXVZPRxx96zh58JSsPjhjMyXG1M
1390	fee_transfer	1696	110000000	1	CkpZ21gA3i3KxgC8VbwiZutGSe43PX6NyKcTkwBpF1da4u454v6RW
1393	fee_transfer	641	110000000	1	CkpZAZ75VMN1rs1zbbxFeshvRU9BhpxcxkJazrHtnYcb7Hvn6kdAS
1401	fee_transfer	1675	50000000	1	CkpYWPQYKKnrBBRKfVXBcALCTYrzoVH963okxVxq6na68pZ3mp1wL
1407	fee_transfer	1634	9899999	1	CkpZj9FuzPBagGQrZp9Pup8Qrno1b5hGZ8ccPi4XL7sWnmMPV9hWS
1408	fee_transfer	1791	10000000	1	CkpYnp2ZYLubStRMik5JCWzUT1yoaCr72JXc6ofEsPvBYaMDtXeLR
1409	fee_transfer_via_coinbase	379	1000	1	Ckpa5m7NTE9DHbbd94yZtUK5K56TTMmoUUVWW37GiMV1ku6NaaFQU
1410	coinbase	43	720000000000	1	CkpaESyxNhYi77KVmAyvm65HXVGWyBH2Rif7aEfedkTNKYgJiAMYS
1414	fee_transfer	1518	1230000000	1	CkpZ9yAERDxttbrn3qgEuWJ5pFeXR2PZ2gacX7DWA5D16P81naW85
1419	fee_transfer	1694	112000000	1	CkpYxmMRyKETAb8cEezzcNHJXYanWXgTaaXpw3LMZgy1YdSAaUJmP
1426	fee_transfer	1685	1000000	1	CkpZCB3kRZGWFtoMnKJ6zm72QP9WRauR6UJSK9Q3xJeodu67y46b8
1294	fee_transfer	1610	110000000	1	CkpaJKMfaXVcJJQGBLVLZdV9sXYGAZXRmdGES35q4KNUExfNoTz5y
1298	fee_transfer	1683	140000000	1	Ckpa9tyXNpxrcZVfwaz6eK4jCL1suEqQnsfgdDUbUP75RDK6zsT3a
1313	fee_transfer	1705	70000000	1	CkpYVsXamZRaBoAkcmjWmeYHKDi5xRVEMwFoiBH6XXfWF9x9y4bk6
1316	coinbase	1580	720000000000	1	CkpYZUq9MrugB5L6vQkwN6hKnimiJKh3C943a2NACqNmAhBSpwzjz
1317	fee_transfer	1580	10000000	1	CkpZ1nf6bXbhKgf46UJbrkFQnUxwFmWd9xHAPBAz752hbN9geCmcA
1319	fee_transfer	1513	30000000	1	CkpZkHvukaEreQipGzJSVhK9iGAe9PyszZoYqkHszJdYZkaWcMZHZ
1323	fee_transfer	1489	230000000	1	CkpaGpah68gCqZSWqYmiq4pApYf67KRmxanZUz3t6wuraVh2NLSnW
1328	fee_transfer	1451	30000000	1	Ckpa7tF8ept9MsLV2RAEyD6YFWmHNDTSr9NqprLtW6q1bfYQy9Wa6
1329	fee_transfer	1518	610000000	1	CkpYZc27xrjx4KPjbCpefr4fV2sc9vPoSvUn8vESbRzrNQDNEPaVu
1334	fee_transfer	1694	110000000	1	CkpaJ7WaQw2A7AUF3Ei1oYbtk2aNNmjrJ23iW5QubKezDzBY72QBA
1336	fee_transfer	1677	70000000	1	CkpZbSKEwcGyLr2fTW6CkPPDJSJ11DqhEYyHCKa9chQk28EmFMgYa
1354	fee_transfer	1698	29900000	1	CkpYpqfAEzufPuPwkk6FgS5MysBT1UgANouR8c9HNoy6viUSJPix4
1355	fee_transfer	1568	100000	1	CkpYxVj6WKEG4BcaQaNriGdJbKqEmQ4yQNaTtDnHPf2EyCdTDtB1m
1360	fee_transfer	1463	20000000	1	CkpZ86NF52AiCNXhnbRqM7jaFJKQJRZrM6xAG3SAyZqN3ErhEYvMa
1366	fee_transfer	1657	110000000	1	CkpZsDn1obj1Lr4VXoaTkGnfaZNMBs1kjkRcV6gJvFrw3XsBmUryD
1368	fee_transfer_via_coinbase	1791	1000000024	1	CkpZAuM1ECDYccCtnTxqSDXeQfQdesiBjBkYUBdmFkuVrBv2qn3rz
1369	coinbase	1622	720000000000	1	CkpZoPrQcCsFqsxmnDjWyameMNFFBjNuGCCDow53s9WAG5sSUwzN6
1372	fee_transfer_via_coinbase	152	10000000	1	CkpYr3VnHM7TWQSJh2cVpvVqSUp9BXCrzwg9DEWHKaq7CPLFXbz8S
1373	coinbase	1671	720000000000	1	CkpZDSXWBQ2bc2UiuvrV9bEKLmabLfA2JRkEHov9kSitSKV5Mcu4i
1374	fee_transfer	152	10000000	1	CkpYr3VnHM7TWQSJh2cVpvVqSUp9BXCrzwg9DEWHKaq7CPLFXbz8S
1376	coinbase	1511	720000000000	1	CkpZpYcYb8jRGyAAUWiut1dpd1aCL33Z4jzNekT6TVAG7FUGfKFoa
1377	fee_transfer	1511	10000000	1	CkpYkwfsWJxPsFZGJLZua2qvZLbXE7LEHM4NZ5UXNEC3Kvd2E6d6K
1379	fee_transfer	1593	11000000	1	CkpZAgHwXxUjg3rh5aAp9PHXBZq6FqHKxKcwmrv59NGvoZM8yaJKv
1387	fee_transfer	1716	20000000	1	CkpYXiwjKKQWmMkLfCJg6qjEuLrbHPqJaBpTi48jrTQxBKoCN3mwQ
1391	fee_transfer	1457	110000000	1	CkpYxccNgATwNGJwi8NK1Sgq5oMXeREATMtTU5DhYCvaDp8BX8uxP
1394	fee_transfer	618	20000000	1	CkpZSyKUd1HP8taRUtSszazxRSs8gVRWeAi639q1SpqEdr7cy9Pe9
1398	fee_transfer_via_coinbase	1527	250000000	1	CkpZ88s4j1NqbfHRJ6WVEYfnWWXCxjj7GMuffkNDP6yNiGMKTtnet
1399	coinbase	1427	720000000000	1	CkpYuDPtFqgvH6CSYFE5LeoTTgqxwGTyypixdA9rY272vzxxEUNKp
1402	fee_transfer	1837	10	1	CkpYqfoHPHdzH7qTQcjZmHfCqibNsYzEnh2iPHcsNcxzBGFyjnYv3
1403	fee_transfer	1675	49999977	1	CkpZSEgJqqXggTxa5LQtShCanYeSJp73FmtpJisaZCUHwpiTMCiAe
1404	fee_transfer	1831	1	1	CkpYdopUpWHsmih8GAmiZxdmMa3s18KiFNquz5oPQyTZe3tDhy4Li
1406	fee_transfer	1747	30000000	1	CkpZsMDZ2LDgcHeBYPvyZpVfshkrTM8ep2j1kLBTtzSjM1coyvXUA
1412	fee_transfer	1749	20000000	1	CkpZM1GXbGsdjpx8ADet5B37dVrYJTWhiXs9F383cA4bVK3pzA83K
1417	fee_transfer	1717	1000000	1	CkpaGodGetnVQHLuBEFaDTBMbY3Mq3nFeHenmUkocHfERKQR9fhsU
1432	fee_transfer	484	1000000	1	CkpaF2Y8TpVVnTBiVFwTPRcvomV9vAxjeSVLW3EXFdDfH6pnM5FCp
1433	coinbase	95	720000000000	1	CkpZmrSH6GXrtnyva1JiMpsBj6hWkCAQRmg9d1YTv4fkf98yVkmTr
1434	fee_transfer	1693	100000000	1	CkpZWHY643QkDH8V2bLqxwnVqoDcx31FDu1oUbv8X2Rbsinu61eAk
1435	fee_transfer	1426	1380000000	1	CkpZ2eghpSLcvsFVJa8s5r9YEBW2SRYTSXjguTFtFrJH1jCXJe7jA
1436	fee_transfer	1637	100000000	1	CkpZXdqdAgvrujw7YPeceRGwrMKmYAqrKJWVDAQrgmU5Kkq2y1MBq
1437	fee_transfer	1762	100000000	1	CkpZGD6ntNJupV7hB7fsZQDZsbBvNMVtUKXK5AQEyYvG78psPUAZf
1438	coinbase	1562	720000000000	1	Ckpa9mee9JScDUBqH9Ahsvs3zkNtmZ3KJo87DmBf9eSMcJrsCGJ4h
1439	fee_transfer	1727	911000000	1	CkpaHqvcTVj5TjsUaGnZ6abs7d16rYzK3WNNskgvJ7KDmK6Rqzokk
1440	coinbase	1567	720000000000	1	CkpZakdbCwy9u4qKQRyJg3DWaLcPZmGcB8je9BmE5w11qTH1Zy12N
1441	fee_transfer	1419	911000000	1	CkpYRDmDcsQHQPzCVQBMSic2FG5hVwgfjU6QjvWtWkBTq5ww954AC
1442	fee_transfer	1419	900000	1	CkpZL7xZMsP7MCDz5fVjMr8zKRRRbp9UwRZ5WjT3HeTmFZydeTdCF
1443	fee_transfer	1735	913000000	1	CkpaDyd3owuxrwsFeiAPjuapGbeqHaB4GBMQEPZaXbZLZq8AQdixX
1444	fee_transfer	1509	100000000	1	CkpYpmxmXzy5ybN8FtSdkXgZPjJvLo8Drh7JcbqaCb7pg8jU28MPC
1445	fee_transfer	1727	130000000	1	CkpYuh2pp8EYCLFN9DzvvNPqHsN3mAtpyY7kaVPK4LiZ7H8GS5hV3
1446	fee_transfer	369	200000000	1	CkpZFa6NRLUKHCEzXCsCk1PBqijr3mw1BW8S26JctBDU8ffh6H2rj
1447	fee_transfer	1637	200000000	1	CkpYxM7zvFaRZNSCKEKwQS1ddvNZBsE5WdipbNvN7Z8EVSKgnSKGu
1448	coinbase	1528	720000000000	1	CkpZRQsV3kumTVwsFDNcUk7552nSBfixT3KUJh2TrtEDe7MQ6L1sC
1449	fee_transfer	1528	200000000	1	CkpZnDRFvdDWWtBD1pcWBEtyC1tJcSRVbYfBCfckgwDMYYemcA5uP
1450	coinbase	1419	720000000000	1	Ckpa7J8UXgniWJQA7ssNdQxi58PD24UNsssudWPDdp5YBXtZAkZP9
1451	fee_transfer	1546	100000000	1	CkpZrAK8fAMLNv3mCDvnxas5dRwJPdJPbLZhjY1ttTMuvpdv2Ndsg
1452	fee_transfer	1675	100000000	1	CkpYnWLumAKsLKxYGo2qqqD9YYPht7jJKrCkQaP1fyiFYAQvpKHZh
1453	coinbase	1464	720000000000	1	CkpZ4ozatRPAj6f1Vg89iikwygfXQbDrQpqgiadUBu5ZTShD3W3GV
1454	coinbase	1398	720000000000	1	CkpYpNm3iMYGgZYectJEy2yj72jt71jMtnvXNAF4jMvtatnhPqMRh
1455	fee_transfer	1398	10000000	1	CkpZY6zR23z66qvoTYh6jCMG3V1WyQQLv7hukSSB1T33E5DHs6Jhy
1456	fee_transfer	1739	30000000	1	CkpaAuAgLePdSi5wwAjdwR6Unr6CsS757tbETfUthgMQ3rbTodmVx
1457	fee_transfer_via_coinbase	416	10000000	1	Ckpa3ASG7G8K8S9dqrAv377jF9nNiahkJupx2w4Lza3TryKSaqCLD
1458	coinbase	1739	720000000000	1	Ckpa8DvHCR8FGkv8kk6Nch5P5GwSkFXzVCLGWVoffsz1qgV4eRvqL
1459	fee_transfer	1805	5000000	1	CkpYVrXoY2Sx62QUtokkby5X9PpbNh3Tuca8tHR6fPMQF2DWymHkH
1460	fee_transfer	1470	4200000	1	CkpZ3Bfh3j2QedtJj9jNxLicZJWco1xCka6RVcgcfNY8jTHA7vuoY
1461	fee_transfer	1794	3	1	CkpYtvLqVAfuRzvuRewNAXFtBHN2Xz6VmN3Gf7AzMnj2LHmXJyLUy
1462	fee_transfer	1637	10799997	1	CkpZVHhEEFeSgyqJd4iCANYJfUwMe3oXE4qRGS1xoN39sXb3J3RWu
1463	coinbase	623	720000000000	1	CkpYUL2MXHLJjtp695PYswue8kieGUG7cq5GQvNhKFpdXz83TnRY8
1464	fee_transfer	623	40000000	1	CkpYvpvL9Uo2w2LYXyh1fSUgJjsFYvM29CpDuAJBroUFbMMa9ocoM
1465	fee_transfer	1724	900000000	1	CkpYafNERDwPzDy9cxPqNoADUUzHDTbfiNnKv7vsjv5ZemD4wZV6N
1466	fee_transfer	1679	210000000	1	CkpYrViMDX2TzuMX3PeokgeHGuGqhPZ4vuYi8siq3mNDAMaviN3hB
1467	fee_transfer	1688	210000000	1	CkpaDDmDTdaWwX4nooSHxCTgoBmxKp1zqAzP9XDeVhfJuUZEcgMpT
1468	fee_transfer	1402	210000000	1	CkpZxZKwcWaAT19a6WW6NpRwdoBC3bjtxk7kprLXDhFmPkFnrtFGX
1472	fee_transfer	1726	6	1	CkpZM3DGAXPctBt6x67VEZB2gpVp9xVvkVyaKVtymUy6VUBKhjmBs
1473	fee_transfer	1688	28099986	1	CkpZAPW4hkXK6kAnZFub4bdBQHfoRWzXqxTQr8STBwqupikXienpY
1474	fee_transfer	1758	200000	1	CkpYTyyUSC9anuxrPv2EpSDe7mCY5BtXgFwmqgRA4ctRCNsaf9xsu
1475	fee_transfer	1831	1700000	1	Ckpa3HqfQEMytBMqxcyN1jchUJyfBzEbkyM2ciGqcWjrpLpNXkQ7d
1476	fee_transfer	1794	8	1	CkpZ1K4KC2nwKmz9XTAQGDbuBMofz1kWAWPLr6u1GaCfD6EsanQVK
1477	fee_transfer	416	90000000	1	CkpZofPBpxBiHpFeCHEhXdodZmQSEbbYqW7nKmwdjohdGHZWb7of6
1487	fee_transfer	1678	50000000	1	CkpaDEFUhFUnSoXNPHmaNMtZmiW4rggV2ofAZ4E35Nt6fT2MrPGH4
1490	fee_transfer	1611	30000000	1	CkpYz4wxDCmK6cweU27uDoPYaUyBge6ZfVDvd2WwA4F4bacQKwMh7
1492	fee_transfer	1451	280000000	1	CkpZazpHVReQwMs44VKx1To1dzhWSix9kg1ZUn6L8bDqvjdvBB8cR
1501	fee_transfer	1662	20000000	1	CkpYSX21yBNAU8WKL3ScCxc8WQtaPALzKXhg3hfm2xWwpdA62DzHw
1502	fee_transfer	1687	160000000	1	CkpYmq1qggBffZMzTmqrWRZuqtqAYyBzugsTSj9KagvFXrZMYUpEC
1507	fee_transfer	1445	130000000	1	Ckpa2QUrChR1G47kF1yGr5YBvv4TDkSqtrt92YU1agGcwSE3j6zpu
1511	fee_transfer	1402	50000000	1	CkpYzxde8w24h42tpPSqWsMV8uKcPyFzsY1WMZbQXk2iLgKMUQwL9
1514	fee_transfer	1703	210000000	1	CkpaCPbfYyeNi4hFQRjf4udTMKf2gtsdXyV8QHCfuvVropRaQdfoi
1521	fee_transfer	44	130000000	1	CkpYTNxVsbHuBmbWNPnMBC64yyHKpVR87guoA5CnTDpTHaiQNt5dX
1540	fee_transfer	1571	2020000000	1	CkpYnzHgkvBRv7trioBMWBMXiN99ejzqJeKhjsuYdKNqzTqhiJ3do
1541	fee_transfer	1571	670000000	1	CkpZpBn3428vPADKrftnCdmXJC6H7oXFYa827Mky6WzbG3gyNPnE4
1542	fee_transfer	1571	580000000	1	CkpZZmncXoY7YuNzWQGoCVAJ5NkkFwqRQAvrFofrWdBdtWDbAMP94
1545	coinbase	1871	720000000000	1	Ckpa37BbjgZUXqiheQXrt8k2UAjhQvi38dM4RpQt47CD3HTgZr2qR
1546	fee_transfer	1871	10000000	1	CkpZvpGV8MdpGUavkgDQ52AfNcj3RCpxwDZ9WjP6E5AJ7SARaY96A
1547	fee_transfer	1547	110000000	1	CkpZqN1zhcBfmPfjjKgyg8ZXCjBSdLatGRHP616r4nCeHsz7Ebgti
1551	fee_transfer	1849	1600	1	CkpZxV9pCgRn6XKLLo9d6kGVype6Pb3fdkDerf2SjMJocR1jnYLqj
1552	fee_transfer	606	24898389	1	CkpZpudYkJcJhKLukeAYadqDTMZSi4Yv7hNnLDv3ZdUicD9sQJobM
1553	fee_transfer	1831	11	1	Ckpa1bwTHLnfGxyVtEdn3QpYCpoEDigTGXnmsPgMQa64gXqsgTKTt
1554	fee_transfer	1460	5100000	1	CkpZrCtRRCo4KuYmPjGhPHUWGrDmX8uCbKvP6AbN5nGDd8Cu8w14N
1557	fee_transfer	1704	60000000	1	CkpYc6T2RnBsVb96ScvXwYkAZbex6Bva6UKWGb3qLD26es7A5GFpc
1575	coinbase	317	720000000000	1	CkpYwzGZMDqxKfuCCqP1hU7RpZZqsQ38FACAS898DhjsQMWqgrEki
1576	fee_transfer	317	20000000	1	CkpYqnrCtAnGjtwYG3psCz5Rdac3fq8Fgwxs8NuLhGsKMu8ra2JU3
1581	fee_transfer	363	20000000	1	CkpZWpPnc7zQmWGxdZbqhfYi2y1vmc4t9TvyZhfRP8vEnGJdk2XmB
1583	fee_transfer_via_coinbase	1509	10	1	CkpYZUFS8fEG9Lc1mo2JeBCER9G6iNqnbcvpGG68jb3w4DdJXs3Jc
1584	coinbase	1692	720000000000	1	CkpZkWbfPVrxFKPyQQYk6n4QcwCzswWzCnHuhA44nqg7VPeUYWpyB
1585	fee_transfer	1692	39999980	1	CkpYVKxgSswSa9oJ3a2L7T8eyPG7SUFinEUXknku549bFzdt4LpLm
1586	fee_transfer	1509	20	1	CkpZejZDkJYxZNvTYniyy6rWQTZ2G4JFGLSHZ83PxKn6tJJ4CPTpn
1594	fee_transfer	1762	60000000	1	CkpZfGGLKBEEyfnX3HjFj8Y4r9oJ12JqG83UczqvqEwi8jdkD4yxk
1597	fee_transfer	1444	70000000	1	CkpYkrzXhByoENR9ahsXKXBervvoPCqYvXuFdAmbZF9cicvui1ATt
1615	fee_transfer	1647	20000000	1	CkpYYGr6QoCDa58zYnMaA9aeHVyrjC4ekVdy5KnTWb7xs44BrZDYK
1618	fee_transfer	1685	25000000	1	CkpZYn1car2b9JFLcAmHjUZL2Gz931toMw9Z3bRirJ8XHTCt7kFx3
1621	fee_transfer	1623	2320000000	1	CkpZ9HM3CSJTRNnqP21YLwQqLA9FoeYCubrRsr875PXR5AUWTioad
1622	fee_transfer	1849	300	1	CkpYfYyomSdRk6Jo8hX8Fusx5BM7r5FyziC7WVJC84xUBhurLYxJd
1623	fee_transfer	1831	5	1	CkpZvgMqSRTyMKVAW6A8sAiYPFVVZehXuANop5zQh6ang8in7cwuT
1624	fee_transfer	1623	199999695	1	CkpZ4uHCutDVuntkWd1yzUx63tutAAnFSybGqhkhsz5a3SrgFdQSh
1469	fee_transfer	1690	210000000	1	CkpZm12GcWgZaBx1QMF7hWtJDzdKGDWm9gG5Ltsd6kDABGpWKmW7X
1470	coinbase	1850	720000000000	1	CkpaBpzjJB1vyHNnZMc87u3oHWEFmSCbWiXetZXzZJqgptYU7tTJy
1471	fee_transfer	1850	10000000	1	CkpYohf9SHxQ5SxSkZHpVSPtYBBNKt8BEFsnwV7XMGXksKgNFpKaG
1481	fee_transfer	1474	120000000	1	CkpZrKHwnrgRQHBvDwSzKrB66mkzZVUADNaiad3v2EgdU72EqjNTg
1483	fee_transfer	1677	300000000	1	CkpZCgYHBqQ1bHP4NiDRm2FrWChZxJYrodWMR4URbLF6YCok6Qe1a
1486	fee_transfer	1611	50000000	1	CkpZ58SdAj29KfGdJCw3LzLsoGpuTWAvhMBsriuzXAdUvpduNddTt
1489	fee_transfer	1573	30000000	1	Ckpa62dXsJULQvfcbzmMjhRn8fQXWvVUt4r9VZMhS87zHj7RoftEX
1494	fee_transfer	243	20000000	1	CkpZdjy5U3Vz4MPjChNyGtYgUQbFpFudUcxc2u62qqrfxMN8zript
1495	coinbase	1563	720000000000	1	CkpYVShZdBoauBVUHvPfSnsoXyuyaZkzNrzb2Jyn9dDE37bcww5JG
1496	fee_transfer	1563	20000000	1	CkpZAE7pBS5K4U8QuCYCfVNAyhdzUeyA7BJGgFm5oPhb7ZS4WWQaY
1497	fee_transfer	1541	50000000	1	CkpZPghSY2619P9AqVkF3B9L1TYV6Zkyiyb7GbqxQRdA5vN1CrWrD
1499	fee_transfer	632	30000000	1	CkpZWyRDTeDNdALBE49bjXFFLTcm1eupXnt4VBRpQhfxpEEyPGHxp
1509	fee_transfer	633	30000000	1	CkpZJbz6N8FCoE4w98nHF9fghBvAVeCaMQZ7xPQy4TpkuyB6ddY1j
1513	fee_transfer	1685	50000000	1	CkpZnZw2vMMvZyQYCTapte93ws5uHtvffxMDP5Mway7kjhY2qaZ2o
1515	fee_transfer	1702	210000000	1	CkpZjgsD6Q7yddMjdH3kvSHAxyyWEkxoFoFuuN4KufNesjLWHxqw8
1520	fee_transfer	1522	820000000	1	CkpYj5iiLumXxpWH8FSsHfLZakUEdzaf3Zuz4xt2qbopo8KUzK5Di
1526	fee_transfer	1476	560000000	1	CkpZQMPMchxwmnEFjpbbZjcgtxbBmKCZa84xxe5Rh5urHTS66mQsB
1530	fee_transfer	1746	40000000	1	CkpZeCJCQ3stVkQkN96piwtSrHuzbMzxw7MBZWA6UAAJmzttAfBwj
1535	fee_transfer	1649	230000000	1	CkpYwHfx5HYEZ5rcUAyhaQwT6QLZVT1SY35S249L3ukHjjG5bvrkK
1537	fee_transfer	1601	230000000	1	CkpZm4ZGSp4bRChHWSLfz7GrKdhMDZeTEGaa8Wtf3D6zde8hFy9Sb
1538	fee_transfer	1680	30000000	1	CkpYhzyMsu72q7hmRuof784mS1Ggpn5ntyFn9MZc1JdZ4NULT34Eh
1548	fee_transfer	1705	120000000	1	CkpYw9U95LP1mFWGx8pHr2R7dmsmKdHhJukaqCoeKSwQ5a8tLrfBg
1555	fee_transfer	1623	200000000	1	CkpZ3JHPtAGPhjdSuaT6z1XqMbvHgC8LJ15Uekxdyn2UqbfsostJs
1558	fee_transfer	1756	60000000	1	Ckpa38xGEuKsDpJ7Hn7vkq9gFbCf3U41uLiMsw6Ak3m1JzexdNZ2b
1565	fee_transfer	1850	20000000	1	CkpYwqobE6Q2XcMEVbpv3MpVDX16AKwe5UTq71GFhjEZtgaCLewWg
1566	fee_transfer	1679	60000000	1	CkpZYjmXXGPVX6bk1GzUaQxwrVWk6YNYw4tYNfaBSfJFAUM8DvJdd
1567	fee_transfer	576	60000000	1	CkpZPZS83SWaDbaEE82F3nGE8Vxxtu8Xq9iUfFgYWiKg2KSqf5M8S
1568	fee_transfer	1506	40000000	1	CkpYsyL6zjknEeiGNj5Cq7P1yufWzXNjf14Yn1DRhzWkQ2Xd3hwQF
1570	fee_transfer	1727	40000000	1	CkpZUc52XCpbWrH317f9LQ28MVtrxK2G5Mn8QqugUvoNp5wrX7TJL
1572	coinbase	689	720000000000	1	CkpZNEr69stkLiZCCs5yA6pQwPUS9uJSdBAnUyDQYPFbUVqz5o1Wu
1573	fee_transfer	689	2180000000	1	CkpYafbQBBRfCLtY9Z4b6de5FAdBQ8kP7vptJSNLkDyehG6LFR2n8
1579	fee_transfer	606	21000000	1	CkpaDh7zj2rv7W2Eq3cVKhM4CEgjZL4QCYQLLLhmhHFdKePAGsx1y
1580	fee_transfer	1739	1000000	1	CkpZCK1rFA67y396FvmFBtQ9CYqEbZgn6UjYPNZc3A2fMWwfK4qmF
1590	fee_transfer	1506	81000000	1	CkpYYNfUgjRNpfAPztLLzQ2eS4ejgaoVkwu8BadiHtBhicx5NopsD
1601	fee_transfer	1564	60000000	1	CkpaK59EKb62wRMdjPqZbuxBzzYG5iEXrvEnQEZHnfuWYnFzzTahq
1604	fee_transfer	1654	40000000	1	CkpYx7P1oMN9omcUNi6qdjT9GCqLTwYzfCh5q69Rk467ttC6dKogN
1616	fee_transfer	1673	40000000	1	CkpZzzUdYLWvaJCfSR8PPdmDjyJmHu3nEhsWUJ9L7ZNSVnKfubN4B
1620	fee_transfer	58	40000000	1	CkpZrDS25m5ad5rRF2ZbTwjnWt3N52cm1xiLyqFtWeJ9A8hVmAnhE
1478	fee_transfer	1726	1	1	CkpaHpypi6h1EnKhBdAbjQ3bodpKeDo9gom6kfQVycQ2tteUN4E71
1479	fee_transfer	1474	119899968	1	CkpZHxbwwrzd8LUXdoytCcp6976iKGAc6KSadrBW35hWFDe8hour1
1480	fee_transfer	1794	31	1	CkpYargY1HWPjqXou2bSAaX1h2Vw594Yq1kzFbtgXwfWisCBPWCBH
1484	fee_transfer	1708	50000000	1	CkpZBQHVjSJ8z4zYCYv3xeMacx6PUb6jhGsMetiDotesDMKw9ey3p
1488	fee_transfer	1445	30000000	1	CkpZ9sivwhP36fZPhSKorXjp8dcQuSqX3uSSX5FZ33G4D1jqZnJ3C
1491	fee_transfer	1757	30000000	1	CkpZgmuW8EbM9rTD2oLs3meML5QNeXfaw2473N8gwV7WxJhbjTC3s
1493	fee_transfer	1546	30000000	1	CkpYp9NBKo3cSVZ8k3yHpkzihPBHom51mkU1EKdPcnbPJeRKpc63n
1503	fee_transfer	1675	30000000	1	CkpZ9pryaZM87u2xUsxdH3MxwRXFhPasbT7ZHRMAXZVtYUYpPGNbP
1505	fee_transfer	1508	50000000	1	CkpZZAX4wLoV8gsnnwRo6HG6ve3PvJET36pcTZ462VqHfmVMVecDf
1506	fee_transfer	1471	130000000	1	CkpYxu2g9h8Di2Rp27c6mvaZ3wAeAQsUKSP8BXJRPKwLfescuTc8S
1508	fee_transfer	111	10000000	1	CkpZAUde6VovcgY5bERP7DhAAsfpQri89VMx5VifqWPvVLeZCVQcb
1512	fee_transfer	1656	50000000	1	CkpaAWG2mKMy2F6v5MvM6PsEwSVZwy7GmkzZCy6xLHGzsNQiMNRWo
1522	fee_transfer	1683	130000000	1	CkpYgLWW4PHGfxGccWvrYRbqRZe6Edrx7fxUqubcFAUiMC6HLeZ12
1523	fee_transfer	1588	210000000	1	CkpZ8i1m2iQ6155pYNX8pFKCin5SP4SzPJPCTWLRTcTezcKYar33x
1525	fee_transfer	1695	130000000	1	CkpZk1nmwnhj4AcHcRRNttpSKAtKKvmYzQFHGWAco6vMkTooRbKUr
1528	fee_transfer	1508	1010000000	1	CkpZzH8u8qKHHTwrfR573taziSLsDNzhr3o3ZRdH2TZ7q5z8RN7zK
1532	coinbase	1408	720000000000	1	CkpZaBjxcQKzRWYS7TKVzR48zSitwd7XY5XR2GyJPnSvDCyTSde4g
1533	fee_transfer	1408	10000000	1	CkpYcHu1hp5ZUNkSz2kgqGqZ9vgnYtuvm1ZZT1KQjxRwENF4SwvUY
1534	fee_transfer	1508	1000000	1	CkpYWqQkdd2tUfuFazMFRLcqDiMPDhWivF4u6pRXHcy9HY4FC9Eja
1543	fee_transfer	1756	30000000	1	CkpYrU3AReVUwKpKm54F2DKTBAdLp31N6HQML2kw4Xw8VvFcFZtKu
1544	fee_transfer	676	1001000000	1	CkpYxiyET1YXK1eiNbfZHVPMwYyoPNz6mU8BdXzZM7EmESMV4urSZ
1549	coinbase	96	720000000000	1	CkpYWByK853BYYGMsqZGjrNCNMXtHLYiE3yRyPkQ5BnJkmyqNuykJ
1550	fee_transfer	96	10000000	1	CkpYg1chZgmqNKpshXZf5VZKkXLF9T6gAGGtCELUrTrDzAgqQ1Bcj
1556	fee_transfer	1746	60000000	1	CkpZLzGqaLnvrwnKwTeZRNEej5GYao5G1ci1kwxvju742qeqC1sri
1563	fee_transfer	1623	80000000	1	CkpZN5NJaAYCW9vqMeBqgySEkR3ybqFRULNNdJw9qjJH4QzQSiN8R
1564	fee_transfer	700	40000000	1	CkpZMbnkcvf6gRC7Kuq3uwVGQrjdzEXJJk64NbGD2ZU3Nu8rENkNQ
1574	fee_transfer	1650	40000000	1	CkpaCFqTYZDxAgiucB9nvf5GW3zk3fPcgk6uEsshW3sztavs7NKjA
1577	fee_transfer	43	60000000	1	CkpZmDvhGWWjSao72AscWZgfb4pxBfEp9GtFHWJ3yuJjauAkp43S1
1578	fee_transfer	1458	21000000	1	CkpZdmifZ8fDmN69brzRjcKC6KufDKkgxYpnBC4ju9YcFVGc47LmF
1589	fee_transfer	1448	50000000	1	CkpZj9gTqjSyfrWGbb5LPno8us1LFpcpto7CDqhx3oXYrUjTFRYDt
1593	fee_transfer	1489	2000000	1	Ckpa1q6DWhyam3ceYYqETD9EyH671VZVQzM32dhssqmd3rz6pjP6o
1595	fee_transfer	1607	40000000	1	CkpZF32ttf2RKSE3pGacaLNzSYxSjRHEa3CiLaWqgBAXNhQqn3ZNG
1596	fee_transfer	641	80000000	1	CkpaCHy6P4YLXyYhneQNdqdQ8i9CLh3Wwx7jKEpReMFo2k5EjdzHP
1598	fee_transfer	1611	70000000	1	CkpYWk8E9nGfmHXsp9KBo5QpHE4JQPBXMnuWh3xKZfHiuimKq9VVG
1605	fee_transfer	1457	60000000	1	CkpZrqHjw5xxTQ6Mxck7tjuvFHvz35h6RHpTKJp4ZDrbpsae1pE5S
1606	fee_transfer	1547	40000000	1	CkpZhHg4uCoJKsZtDpCdW9oAwYH41vgETCW21qqpLkbAYdBvYsDqy
1607	fee_transfer	1470	20000000	1	CkpZu47SDWd3AjNAUYWSLNegVwHf4cwgrK6rsHiMGYXVb4atYbHfz
1617	fee_transfer	1670	40000000	1	CkpZLTwF5Nq3XDmkBgJuv56fRZnxvUzCEpp4JrWPaNJfDNCsW9LUB
1625	fee_transfer	1650	400000000	1	CkpZufMM7Br5VKwcpf3mQ29hfhSmroQ94qpY3mZBn9deGQ8ZzGmte
1626	fee_transfer	1650	813999990	1	CkpYq1LU1ZVwUroUwgxq5DWghQJJgQpjaxGYh4XwYy5izQkcUWH5G
1627	fee_transfer	1854	10	1	CkpZqBSFC2fBJRbAyRjkkbVpTKeBxvhkN9YHaBNdPNW1v8CC3jdFP
1482	fee_transfer	1724	880000000	1	CkpYj4hpv1Az5nTJcWyG4onmJoEamfoRvSJpd1DSdmbzLCdY3C6K2
1485	fee_transfer	1560	50000000	1	CkpZYpXiBodK3MrY7FkpC5sqNmiFeYzr3UovCQ7eDTkKAQTebQuQy
1498	fee_transfer	1508	640000000	1	CkpZGSYPYh8AdJiG2CyLZpyJ2dJTD3QnihzNQpvv2DvVewLxRkzxm
1500	fee_transfer	1440	30000000	1	CkpYxaxJJz7x53HVATCjXmZN1SujH2vBQcuXK2xACmbEw36UNtZPQ
1504	fee_transfer	1271	20000000	1	CkpaJLV9NWN8Di8Rcio6bqZEVJk3mJKFpq7GPPEFMsN4zafo6rU9n
1510	fee_transfer	1657	40000000	1	CkpYZpN2DNWYdNUn8cwV1H5r3fQCHDH3gvSU4c8RLNfTfHk7Uy7y9
1516	fee_transfer	1573	120000000	1	Ckpa89CUtUZmRVoMwbsRuZzq9i9jgXaWKjdoJVKbSW2sh1f6BXdHx
1517	fee_transfer	457	25000000	1	CkpYigtBtbJnDSTiavQ9R98ZFSN991nJQQnQhzyWrBFq6KkaEf2P4
1518	fee_transfer	696	25000000	1	CkpZgzyYokHxrRkAvZzu4o6nE24affGePrwcmx1e4BSaeBiFkF1hr
1519	fee_transfer	1683	770000000	1	CkpZeUAzvBAraRjgsMrq93ULVhmqJSiwStJqHjGU2BnAXkz1X4Zqi
1524	fee_transfer	1683	210000000	1	Ckpa597KqphbacjFUo9khmFMJqC1SKgFqU5MELZz1xt7LzKte7W7r
1527	fee_transfer	1727	30000000	1	CkpYrGf29hvzwRoTbqPfegpa51FmkN6z6Lty7NSzaRQY3eNKL2Hid
1529	fee_transfer	1637	31000000	1	CkpYVTWqig78Pi1XKwM5yTRBQFNpXsX7ksZJUYrRgGTRJ21Tj4p7G
1531	fee_transfer	1747	40000000	1	CkpZHq9HZvZsJAM6o1Tgi45366B4woMsrVSBiRrVm7qQ5GYTXRbrm
1536	fee_transfer	1610	230000000	1	CkpZMHPQRUwYK4PDTKTvLcfkD6DEEQYdYZGsX9FecBPoDBVDJCCpp
1539	fee_transfer	1508	200000000	1	CkpaCvr6s6jeFnnAnWRqw29eA54Z2RXp28oyg4BHsfy8JUMWz5BSy
1559	fee_transfer	1747	60000000	1	CkpZZDakQBgQ1ZBipUYMKaCPYrNw4wCQV4a6LdpuvEa4pD9B5G7Xi
1560	fee_transfer	1571	760000000	1	CkpYYHLtU1T6dD1PUmevn2NwgyrxmK3EywMJzLLWsBJCFZy5QauDA
1561	fee_transfer	608	10000000	1	CkpZTzUJeUjacprjpATk1NMNRfvTLME82WR1Ni36UUJYYr4KQKWSP
1562	fee_transfer	1571	300000000	1	CkpZcJmjemPr1a94z3mvYi8vThJsiMGK4AMW9tDi2cMvg1TSivL8Z
1569	fee_transfer	596	40000000	1	CkpZ7x6PtNeS3XVcWDSXVsarvuXLpZaHWdFjRaswBmCYFzBAfeQLq
1571	fee_transfer	1740	1220000000	1	CkpZz6aWLxii364EXfPf3oir6YmoCRZZuu5Uqz348kUrfV1u1YhsH
1582	fee_transfer	1560	40000000	1	CkpZzs7B4RC4PuPVJzJ5cGfwVzQeyx76HWa8Xa52ntTP7gNDSRZ7c
1587	coinbase	1877	720000000000	1	CkpZmSN3Mz2s71McL5Qk7Yp9X7j2rYg2ZoBgo7iFu7pRE2CUJCjFN
1588	fee_transfer	1877	20000000	1	CkpZAwDXC2aXEG2wVzTXcWHGMvHiZnfzmyrAWGWRR2p69v9AoEw6M
1591	fee_transfer	1759	81000000	1	CkpYn1kLPrup3Ps3o8jmBGDm1gQxWPWVcsqiGFgEUXVigaYXeq1hU
1592	fee_transfer	1622	40000000	1	CkpZJrxNekmB5xV8xDRcBkKRLnq1FXkBzT729A63asDm9Eqfp69Ns
1599	coinbase	697	720000000000	1	CkpZYe6aKqVHXkn7C82CrpnVuqsfcVqdx5v6h49qTDLwbJe6T3UJ7
1600	fee_transfer	697	20000000	1	CkpZmE6ZkHeiZZboDKVyNdd5eu7oxV5B8pbaC4wevP4tDL7nt9pkE
1602	coinbase	1879	720000000000	1	CkpYcjeR5SSFEEDhh5w72w7pjK1Va32bB6YQJDiMja8aaWpuhSn2D
1603	fee_transfer	1879	20000000	1	Ckpa3kuckvVxsNHmzH536WvstnZB57tfMKALRssHHzsk6vzyyW19K
1608	coinbase	1667	720000000000	1	CkpZEWCpS4YNHeXVgqMo7v5HeX4h1zpsQ6cwsA3vjCs5UH15J2g57
1609	fee_transfer	1667	160000000	1	CkpZcL3xGrHb5Be8NBwZKYL5Q7SdEQzjLa8W62anLdnX3oh4bbM7p
1610	fee_transfer	171	40000000	1	CkpYqfP4GpDHNQbVbzBoVr4YAVGshrXur4L4eLhMjguUGqWY13pix
1611	fee_transfer_via_coinbase	1867	100000	1	CkpZ9esYuBfzgogM5NjGskWV18n7E49BaeksPcSV4Zz9ahD8oC81q
1612	coinbase	1687	720000000000	1	CkpZJrcpNUDCANuY8esRn3XAoLgbJ6VztModU8eENEEefdJvspQMw
1613	fee_transfer	1867	1100000	1	CkpZkitQ1F7kB84ReYXzNDzwkkGNQJCqjs3Q3fc88BnAYc1emozfy
1614	fee_transfer	1687	28900000	1	CkpZgWvLQTr7BxHuDEo2okbh1qSVYhsx7AEMXfHNzEPbGUfv5dPuw
1619	fee_transfer	1683	65000000	1	CkpZXq6cBuWVoBAdwcyKMb81P59rW215yWDFNaNFSQVj7aBzZQYSp
1628	coinbase	1565	720000000000	1	CkpZ4MhpeffUchdu9XSGrf22mdB3Y6otH4L9aE8nFBhEStWCTLZc5
1629	fee_transfer	1565	40000000	1	CkpaKnygr6jie6z2RffBsTfMhTprMmKBP7TjcNEYRNSvps3e7sJb6
1630	fee_transfer	1714	60000000	1	CkpZG4FNyM3Brec8EJi4uMdMSHxJDDvNgbGXRqFY7649WPwbcg4zt
1631	fee_transfer	484	40000000	1	CkpZ9vEoZqPgKitk6crNm38XgiC1uY3dEyUmXBynhZDhRK4aPmFiJ
1632	fee_transfer	1724	1229900000	1	CkpYXhWQEKxQV1vykLpTQNkBSbXYVY79UEmHchW2dwAdrhXTgjVjb
1633	fee_transfer	1673	60000000	1	CkpYsHPxoPKHebKCms4rksZqBTviganVCu4de2KUmth88FfgRgt9p
1634	fee_transfer	1739	66000000	1	CkpZVCEYrNvMtbNGDzcqZ8RXUQSFxTVmLjL316QyXrLBXtBKAswkv
1635	fee_transfer	1419	40000000	1	CkpZZESADev6nEhYejtNL8cLFq1PG1EfwMMHaehzbTKkA3H2xFu3Q
1636	coinbase	526	720000000000	1	CkpZ1xdw8gNdGucDsREooWJyyaWFnfx3dyb6V4cCykr83piAg168D
1637	fee_transfer	526	20000000	1	CkpZrGZFyY4wYrJATyXi9wGsesYJqENWyGM5UVLXfs29NVFNHHonV
1638	fee_transfer	1508	40000000	1	CkpZvpgWEsXSFn4urMNksaZ5CfgRnmm5zRxtp4NAFrRoWLzDkhT1j
1639	fee_transfer	344	40000000	1	CkpZC8eANgiodJbq18kER7zeiDSrx95dTRTudkbFsxoz9qaQYjQgT
1640	coinbase	1644	720000000000	1	CkpYe44FrhrsRk9jnHG4vuvB4jjMkBRLrtJ9hnMBqnFZMnv3tyn2b
1641	fee_transfer	1644	20000000	1	CkpZQT2oh4CUETyro8YVL7qauViSS7GcNURVgrqem2Nq57DTqnfaV
1642	fee_transfer	484	80000000	1	CkpYUcKUY7fDtfK5RdgRc4awSm9AfY4An2qiVXBURcy48qgTMDe2r
1643	fee_transfer	1672	80000000	1	CkpYofbsLbd4qMJyQpVCnWsKcSeUHsotV61gKnxRGrAtCY72GQD2N
1644	fee_transfer	1764	80000000	1	CkpZuUQCTb3JMP8JXADypRnUoRMXXYzZHJa4GPksYjAQcshAvYZXm
1645	fee_transfer	1683	320000000	1	CkpZEX6QujDgVFTkhW3tAG4EPzpBsvCYP8QULzGUFFGwacio4r9Ah
1646	fee_transfer	44	320000000	1	Ckpa7QijsRch4DxxRt2iLcr4d3PEAhq7KRaKeTqZXAfsDnHbBzMAT
1647	fee_transfer	1764	120000000	1	CkpZ7Utc2a6CvMJNvtCpE8eP62GZC97SdDVaMFLBGWpFAAA8H8c1z
1648	fee_transfer_via_coinbase	228	10000000	1	CkpYvrSPR2UbLP3mqVgmX6fukE5X7dRwdpueNJBq4snfx93KrkrRh
1649	coinbase	1688	720000000000	1	CkpYU8Xgdbp6MoLzWmUQ1qvBdtTPLJe9xSU65kZ4mRzLaumzRicSL
1650	fee_transfer_via_coinbase	1761	1	1	CkpZ6kevYPJhaCkfgbr9JuNzJHVER9pM17zw3CwmSkDeL2goSCiYH
1651	coinbase	1455	720000000000	1	CkpYc29ANpLC5i3FUskMv1Bt1f1EKZYydV1eQuyyPrXGRG4agQhNR
1652	fee_transfer	1761	5	1	CkpYxa4zzL5zfX8NjftpnrrVqgxkZcp8FcSAeR73jxar189jy1hEA
1653	fee_transfer	1455	39999995	1	Ckpa2ZnWpq5syoZdnT6KchYTmbNbsBHeGWjSbaT4kFVEWxWG4U2pm
1654	coinbase	115	720000000000	1	CkpYarge67rmGXbcR2WYeC5g7ngUcNjrGgTmfuGavrCJ9zniLg6Ji
1655	fee_transfer	115	20000000	1	CkpZ5C2MaXefA7237PVwstF9aKZx5tbeKcoWxxgt2LdAA72oMfRR3
1656	coinbase	1499	720000000000	1	CkpZeojcgddTbteLinaHrLRJ8nUmv3UV3kQJLkv7jknfkX4r7f6TD
1657	fee_transfer	1499	20000000	1	CkpZx8TbhJiRHdjRdAYFWUvYCccwL4AUDUvuRW8iaskdfxv6XeM23
1658	fee_transfer_via_coinbase	1884	10000000000	1	CkpZziyQn3rHBmpHbkqfxLNZJvb2iQ8dXk6ocnKHMk8VZJV9kCJRk
1659	coinbase	1623	720000000000	1	CkpYigYnC11fT9jX7sQ4XbEu3HSk5LQ2p2u6buuCLMKzS3mNeFnBo
1665	fee_transfer	1608	40000000	1	CkpZfTNS5oQkFGXqxifuCWXEY35C5pKLTpig6CXwpd3vHuLbsN6Me
1666	fee_transfer	1723	220000000	1	CkpZdD7vWs4YHwgtNd7hUBC39nFdx5t4QaPFTR2C2TcxpkzKAMUte
1671	fee_transfer	1671	60000000	1	CkpZu8XorGaXjonHAdYhiiTVfuyootva9FrxxUpev6Y1D3G7tUZnW
1673	fee_transfer	1649	180000000	1	CkpZpTDV5utVfE49f98hGQDRtx62uFoBzjLjm2sAq7DwCsaDgqBSU
1678	fee_transfer	1654	21000000	1	CkpZN3iCn3ZfFwgCqY6W6iu3rYjBjvW5RWtWML3iPoaYiPeaQ2HtC
1680	fee_transfer	1747	41000000	1	CkpZ3ohaukwBwRzQKbzv5eA6vPFVsqysMKyesXDTkvhvVWdkYLLWx
1684	fee_transfer	1749	41000000	1	CkpZjas2HZC7g7XxBnn51ViHK5b7hZCQ6DDBh9hxn9qPBnSzR4thn
1686	fee_transfer	1564	40000000	1	CkpZRAx61JQneBRQuG5a3G5HJCqtZG4Xbr6kCNt5NZ78K16FNwbaf
1690	fee_transfer	1637	120000000	1	CkpYbFTJx96mKFTtoM1uyYwP4wmwomu8qpW9RVq8u4YCQSfahx3Qg
1694	fee_transfer	1680	90000000	1	CkpZYta7MStsRkq459s3E3WeUG1GjeKwx9U1vmSs6YFFuPbfBhFJS
1695	fee_transfer	1639	30000000	1	CkpZfvck7ZR9mhwrCCX2R2iFAvdPaNFXUFd9rKV6XjoMsav1czGsv
1705	fee_transfer	1692	41000000	1	Ckpa6dHorPvHnueErRLdPjMUEQJsmmAH1RFGP1NZv6Mv4dzUjx67a
1707	fee_transfer	1610	60000000	1	CkpYY275dTuZwhrVZGjgTSc3Rf9CB2jG3xNXsihE7wQ1AP6SBsZEr
1708	fee_transfer	470	40000000	1	CkpZYnuyKgftFdvYT14Zr1n3Cg1EMKuhxbu2ZKBqS1rLpHhp9RCrc
1712	fee_transfer	1426	40000000	1	Ckpa1a2xeRCJNMiuDgqCMELuxaNsshhcp6DJNLsD7Bgx1sDx7GPUQ
1722	coinbase	389	720000000000	1	Ckpa1WrPdfgXcmHBXuyJ5cyYYqH7L2c91f62dGksEUApF9zmf2KNC
1723	fee_transfer	389	20000000	1	CkpYvPPdWKRAinudhaUSreHijqkirVgABJ1Ds6smfdrAVoMw5qPeD
1727	fee_transfer	1764	40000000	1	CkpZd9pvXjvoVzVD7rddCp9mVCXxk2JtVbnxaZDb8NJNxthZhbu1W
1728	fee_transfer	1768	110000000	1	CkpZkFh23LWUtDLixuynFBAvFRDsraHZjUUE3ZA9oD6aM16FXkvLZ
1731	coinbase	1663	720000000000	1	CkpZ7pigjog7rE9rqJGzPcuLB9dK1PAganuNZgkP9NohPwAe5BTXG
1732	fee_transfer	1663	20000000	1	CkpZP7sVLVcrm6BMAaP7Mxi36jnGSXqsNT7qgurNCn68xSqEiQGuX
1734	fee_transfer	1656	110000000	1	CkpZGSWce6Y9jE7qzzoNJvqgKSGKGX3Xtw4MoUDTotfkmQj8NyXCU
1735	fee_transfer	641	1240000000	1	CkpaLSfY9ihFYbaMGhmFEZNukhDhDq9cDpGMZwo3g98mdNj4vjDWr
1741	fee_transfer	1567	10000000	1	CkpZRkd43PTX7aFLLnNLKQP4SeVs3ZffDMbGrUJJGXca7rkoNsNTc
1742	fee_transfer	1593	110000000	1	CkpZZRdNTDThtDzX7ZTdudiNq5QHDvmRLBrQJMLfS1XVKSGeGsDi3
1749	fee_transfer	1696	50000000	1	CkpZuhRU6qYiCyCXLjntwgVDbkT5xY5tSW3WNm2rW9kL55QTaZyt2
1752	fee_transfer	1703	40000000	1	CkpZnJZoTh7Ay9hNmkZ6wj8vtyK7HdjsZtN7Efi9ercCggq8qzycS
1753	fee_transfer	641	150000000	1	CkpZki87haMNJNDkxNUt1m3YrfcdWDcdTZ8EVGazW78oEKtzP1Bka
1760	fee_transfer	1739	80000000	1	CkpYxD26QBZmS5RzGuehZaMgySV8qLfnot9EMnL76EnYmn9PDY8qW
1768	fee_transfer	1739	180000000	1	CkpYrDpQ279pAdFLKTjHeQj7qAu73PuuNB3avPubZy1wbNuYhjfN2
1770	fee_transfer	1536	90000000	1	CkpZYfQHjz5p2JYeZaLCp39hVF6fVqgFSkABaoJaS47aid9ji9NSy
1774	fee_transfer	1451	70000000	1	CkpaKxspgpdkn6FmCVjZiXRK75tCFhTrDzc9tJKBCij5qyDYGu7Vv
1778	fee_transfer	606	60000000	1	CkpZFhyn5dt6hRvccQgoWoxkQPQKr2Z78MqhYqDy692wJJR8UY7yp
1784	fee_transfer	1717	5000000	1	CkpYaFGXTPjtY9Hg2oeYyWPkRNcPdHQUBJfs1ABSFwwRVQEmH8e3x
1787	fee_transfer	484	345000000	1	CkpZAeELJXkWZLJDVR4Tw6D3UFHhum5GKi29WXcPs4ahhXwXUTXDR
1788	fee_transfer	484	1100000000	1	CkpZQPA5fiW3XXq2sRDw8e3tTSp9ve1zEyR7AnAigeyzyrtrhkpVH
1789	coinbase	679	720000000000	1	CkpYYwfPuH3A1B2hvuTBZhxwVjTK9bUCSMrVnsuizNoeNPnTWsbxp
1790	fee_transfer	679	10000000	1	CkpZprSC7YRRkHcNbBCqV9XJAaXsM1b7ooF5mVCHT56aprNdXhy82
1795	fee_transfer	686	10000000	1	CkpYehSYcksAzzSWgLgV1K6khUFotcqz3swVFAgYkytpVX1jiRSRC
1796	fee_transfer	1423	20000000	1	CkpYvdDquxMuc6aiB28fHDQkF3spKtKpmxQASN9PPAzMz8fJRBGVg
1799	fee_transfer	1607	750000000	1	CkpZN8bT7EHQCZ3f5544CBZiRHtJjf9Bueq5hLf9dWBM1SChKkz8S
1800	fee_transfer	1607	562000000	1	CkpZSuRrn7LexHHFW79BmAS4bbJK219mya9mByeab6PGKKsZKqPba
1803	fee_transfer	1633	445000000	1	Ckpa2MyuJJT6K1VfgFf559cPbpABdBvdQn8n4HQirnHmcMPDqSXUJ
1804	fee_transfer	1633	820000000	1	CkpZQLS5TkwtMxk8MviTyycXvZHgQcoeeAVbkAdAyApB6dvdTCdCC
1806	fee_transfer	1445	11000000	1	CkpYXzCEMDdRSpMr1hK8QJKC3TfDCiqyFSN8Pp9MYAycTnRM2ZafQ
1810	fee_transfer	1654	517000000	1	CkpZcvFc6Ls5Uq3FgJFACN9TFyV4g935ER2o9DeCyUiQdQ9XqzCSn
1812	fee_transfer	1716	250000000	1	CkpYWG7HMf5qLNRujmZTLKc5fiCE43WeKamdFjQQjQRVGuYPEfvfQ
1813	fee_transfer	1607	732000000	1	Ckpa3jqV4avXeKjJQjKgNq7i7SZmaFVTW5ptKpnQNqM2RMVZ7UYj1
1821	fee_transfer	1518	21000000	1	CkpZguUhA5hopQ9uKJHvoz4CqQyumxhBQFA1nYf4mCXxzNiWD3mTB
1831	fee_transfer	369	50000000	1	CkpZmzkVe9vA1wnK4pHxcwsxVRnrU2yK2tMmLKDe8MdfQUsgriZNu
1837	fee_transfer	1444	35496980	1	CkpYSTgXje9Kke7Xe1aCJb8NeV6ZweEhRpBmVq556gkPzzbyE7MeD
1838	fee_transfer	1881	3000	1	CkpZgyp6XwpdSbiVfEaqSwrvThwE1TTdZUPgNaRGPoM4m4JVpDJWs
1839	fee_transfer	1817	20	1	CkpZ5fKth5bxT6zLMPoAB639zgvNdjBb1XSw75UWo8kziTDKnnvdZ
1840	fee_transfer	1744	4500000	1	CkpZmn2ms7DfmUVVFp36MbopA8x76BYveydY33y1qV9EWh3y5XPKt
1660	fee_transfer	1447	40000000	1	Ckpa5H48gqnMXpwu8fsfsvfEcvTECeH5w7poyKAg4tJqgqJpCADfG
1662	fee_transfer	1714	40000000	1	CkpZmMX4Z86qcZdedtpTS9pRRxcmybNgu7szmKyeN1DWhdYfSAr5F
1667	fee_transfer	1513	220000000	1	CkpZ1wUTsbChxK3WyuAjzoedRq8zcD3NWNvbTHJcRR6otCK3ntLZw
1669	fee_transfer	1696	80000000	1	Ckpa7QrwGbBFhH5awugxSUic5RoTZsM5J5Lk6ZQTaLzE7mSKKSJTu
1672	fee_transfer	470	70000000	1	CkpZ2K9t9HYCiNfnTegH2dzEkoUw1BwXyHNwVNvzf6hgtZNKmymix
1674	fee_transfer	1679	180000000	1	Ckpa9jkAWtfmkHatfqvVvbM16gioKtAD1bAuH35i4RHXvPbb2fDPu
1677	fee_transfer	1650	1570000000	1	CkpZLdH9jnP8PXdZMJZ1y1dLviHrtj6Enn1t9pdWL2XHrffxBVF2e
1688	fee_transfer	1729	40000000	1	CkpZdyome8xBpTejiZXjE9sVzwdkVrxUapKMB8LRdcxjtGzTyMDRr
1692	fee_transfer	1541	70000000	1	CkpZk2qqVDNDvYH9rEEHYEc7P561w8kpiF8Qvr6QrKz21KQ8VDN92
1693	fee_transfer	484	850000000	1	CkpZQneHCfdBWM5YzDpu1FKP8iGie7NbozMDiwk6Cw9rp7Z8rDX3k
1697	fee_transfer	1790	100000	1	CkpZUPEtZMYjbe7s4Ye9s4X2Dc5YBn7k3AiDWRe3m6Pz1aHkUcfim
1698	fee_transfer	1644	176300000	1	CkpZY6WsuwEyrpT4E3cPCYMkcateqHUrGRPmn3aosyJLLjMoWRXHV
1699	fee_transfer	1758	100000	1	CkpZLXnwXYPZwEZB8fV4yyEbm7XojvBEBuQzoR9wmqNJJGPBttLut
1700	fee_transfer	1744	3500000	1	CkpZhUFX1c7LWn6nKN34edCimzS3LSTNAQFWEygrUE86WFTouSNFv
1706	fee_transfer	1623	40000000	1	CkpZA7vrYAZk89ua6vFHMgDvgDCrnhRzEsDRf9oXTJK97X1zv6YWu
1709	fee_transfer	1719	40000000	1	CkpZpQ7Qon1E3P6SMMe2KSfRTwxhAVezuye722zc9ADNug43iWach
1721	fee_transfer	1602	40000000	1	CkpZCE5P821s5qkswLWgWsvuKD3dE8cDaE5dzosiSioDvtW2BW66f
1726	fee_transfer	700	120000000	1	CkpYvm7n93VuZmxS9zFhy32VXm5fnayEncBBr18PmkmfbV777zH6m
1729	fee_transfer	1513	140000000	1	CkpZgaC3tmmPDzTgGWocWqWZbTJrZLUBL5JmFT2ePA72sMFpMYm8K
1730	fee_transfer	1599	60000000	1	CkpZexCojYUpoz8v1dvUW6USuLTziFcLcTZRNcpmxYuX2A7MH8DTL
1733	fee_transfer	1850	30000000	1	Ckpa1SqfBsLxbiP2XJFDmFVXQwdg6LiBp4shjzZd9JPgXD8bmM7Z2
1738	fee_transfer	1701	120000000	1	CkpYuhPgnnSEZ4DecTA9irzdRTjfX8v7Mn3xM4HWuuSr5guukLz8T
1743	fee_transfer	1474	1020000000	1	CkpZLr61SCfm4NC5ymB53CKBQxNpbzCASdTTpDmumm1UhbS2t9Gde
1744	fee_transfer	1474	400000000	1	CkpYiPD6DjdDcbNpxsq5avFs4NqT1G6tb4NNL7iPCr4kuRMPP5Fth
1745	fee_transfer	1749	30000000	1	CkpZpi9krN73VgZaXhdFiYS9fr9W923ujYwKyJrhHXUsYYnAEoz96
1746	fee_transfer	1633	700000000	1	Ckpa31DksJ9Fku9GuQkp7Q5co4q1xMpLSRheujbbmfYBtDSCf8j5c
1747	fee_transfer	1633	910000000	1	CkpZJiC63qqJ57Nkoumrdt3t5kuA8NqqNCeBPtTixngY6zSvDGvEU
1756	fee_transfer	1672	61000000	1	CkpZrwZPzUpTp5nfoXTfRWyXmvE3L9Z6SzTE96EWCaD91YwXMUy4V
1758	fee_transfer	1694	100000000	1	CkpZ7GuDPm1f3YHCrumcVvkhAyfXQpPRhc9PRmc7rouV9uc9363JM
1761	fee_transfer	1749	80000000	1	CkpZDdrWXTkqP3DKajrXM8fymj6HdLXTDTts7X3fYD6wkBmogkLhm
1765	fee_transfer	1402	90000000	1	CkpZcSBzG1TNYmAoGTjnhBeweWs1dnd184yVjbz3wSwpjwgk2zNUe
1771	fee_transfer	1711	90000000	1	CkpYxjq77pw33f3JqMQrjAuqY8hGRUnKRqhXybcB2SnL9PfuDDuiR
1772	fee_transfer	1683	80000000	1	CkpZW3ZK3ZeojP1kSZtxE82s3DADCTThMfYSRm54xv3KRVsqnyVdW
1776	fee_transfer	1683	70000000	1	CkpaJgpxcyjmXYidBgHzgZhBbUXoSnNkmyKtTV48U5f3ew24BYzCT
1782	fee_transfer	1588	260000000	1	CkpYvsaZ4j45RwqD7ThHMBjDWXpPhLSfN4BwmooQRWvdaCTqwrXCF
1793	coinbase	457	720000000000	1	CkpaAP4QJcNBWbFZvtm4mTD7rfVkWG7q3VvrDdtVgq4nLL5EaaonK
1794	fee_transfer	457	10000000	1	CkpYibdYy5MmrZ5Xe1YDMu5d29RYozexnomdsx8Cbd3QU6og6Ss6w
1797	fee_transfer	1607	35000000	1	CkpaDFqHkwpoMtPTkCnygZRz93Z2LxvhtVaGUv2uQdzMSCsB6QaEz
1801	fee_transfer	1677	35000000	1	CkpaHegQEkXimjfdhcBm6o4G7xeT31EZLFLRT3zDUVZTa8r5bn8yn
1807	fee_transfer	1560	21000000	1	CkpZ6uMTPDykBTZUX2kip3RfkaG81JtHSeRikFm14MfQTfWQYjGZe
1814	fee_transfer	1683	170000000	1	CkpZQJkKa1PjyXioY4nTUxjn1aiLoUNxXuu55sQWp9cLWnEPxNKYw
1817	fee_transfer	1702	30000000	1	CkpZYwqSDaK84cG2fAV9ioqCbytEpyHmTxuY6vVKdgYid2EYwDCxE
1825	fee_transfer	1476	90000000	1	CkpZUYriRDhyrATAWQhUNjyNo3DY9L1qcmByqd8Qstzmc7iRV5rN4
1834	fee_transfer	1709	30000000	1	CkpaCqvdmLwRuMUtwPKQftg3uLCt6SPjXHruoPzxLydWBdhWtMUAk
1836	fee_transfer	1448	210000000	1	CkpZqLnhMANt9AQ68WLeqr4xdo47LdkE1yd37vcyWRQQ55MRuWPTa
1661	fee_transfer	1599	40000000	1	CkpZw99KPsKm8E32kaHfday9kAAi2krJcS8rjRXQZEEq8diCSah1W
1663	fee_transfer	1683	150000000	1	CkpZWWiZWFyZhMDRgTpExjf4yJth1Z69XkYJiG26R2vcv96eAoHYD
1668	fee_transfer	1714	120000000	1	CkpZRsUdWw6e4G5RMLNLqWa1Nb2J5k9z7CcSP9EZpjVY2gjpZbgu2
1670	fee_transfer	1419	80000000	1	CkpYcVUfGLeaz91mMqMAiC8XkNLqCePuJmNVZR2kSVMjRekxtdBvB
1675	fee_transfer_via_coinbase	1817	10	1	CkpZtTG2Xj3Zc1rAk39rTYu9tUWY5dop3FS9ianbwUk9dUDBiE5J5
1676	coinbase	1740	720000000000	1	CkpYnwFN8Z9e59wQhGrUo1xNgaEdifeaq3ftu5qx76YQuYyTGiTzo
1682	fee_transfer	1746	41000000	1	CkpZrDrLx7fnHNZEuT5tdtm3CsvgbvAptZW6WT5mnyYe1s6K5f8kZ
1683	fee_transfer	1749	21000000	1	CkpZEUt432q3SrHyxBfT3hAcTrhWnZmoNCmTKn2kMxRicGi57paVR
1685	fee_transfer	1685	11000000	1	CkpYxC3yEEPXr4gQFBaH42KeHnh6QBKcNN7qXziujGNUDKhaLBenJ
1687	fee_transfer	1546	40000000	1	CkpZoy7oSYT6ZEkA7oqiddsAwSpguceBVPFevooeFvHJAFqtLRgqw
1689	fee_transfer	1448	40000000	1	CkpZ32iagGxWmQG8keUkdZfCjtePMYbMAQgiZP5hxoesnHaMn7okM
1696	fee_transfer	1587	40000000	1	CkpZh4Zq1mPJGHgZzVUEMxxbJWPoBC2wJ8y8eMWqYMHCHU67sGfUs
1701	fee_transfer	1644	180000000	1	CkpZtrJtKUNi7sK9muVp7YMrQqYmrSCKsitSy5qBvtrWVxsp7tRpJ
1702	fee_transfer	1649	41000000	1	Ckpa2teowzEA4X9heGa5bXKH7dNhKCTF6TfcGMJLDVp4YuG7JzmJd
1704	fee_transfer	1419	41000000	1	CkpYgZNUCenXWQASJ6pa4aqm1PBvmYqExWGfs4iWbxqcCpLx1Puon
1710	fee_transfer	42	40000000	1	CkpYjiphakiTsBzE8Bmom3dCYfEdKL1BmvbJqCKSkuwddKkbrmwVt
1713	fee_transfer	641	120000000	1	Ckpa4B61KKVwBCTCLgs5zDPebdU3CzzfKeCfKj57U8mGmanh2H8Ab
1714	fee_transfer	641	620000000	1	CkpZy9MCUjAB1L1yFr7zCpA8byKSYxA3QRxi34scssNH8w8SdhPTm
1715	fee_transfer	641	280000000	1	CkpZDuoKFbBX3mhzdyGAHiRXCNS2P4V4wtPdN8YNSEfKRe94M2KLv
1717	fee_transfer	1447	130000000	1	CkpZu9YyqfuVPYqDSqnLGxqfQSqrDE6itYMh3kjsWwu3ye5vSvqt4
1719	fee_transfer	1474	1220000000	1	CkpZm46Tw7NnynLY5Vb8SfDbbUjXvcGxxRw9ticcQPLzJiiMYjVCK
1720	fee_transfer	1474	261000000	1	CkpZ9MXcwM9BHAE1sSuwoR9Gdpu5r7wZgwLMqPDXYpjEznSPzmas2
1725	fee_transfer	633	40000000	1	CkpZpxh1LibW4qRE7iDzMZp7qEfaqeqyMMWqf4EFaq1K1hbj9ytx3
1736	coinbase	350	720000000000	1	CkpYReKdE8H3tYgCSyL3BgHaF5LJ47yKsNxis6Bvkhi2BhpYNKzWY
1737	fee_transfer	350	10000000	1	CkpYWtQVga9iEQi5HwpttodZ1RW5WTjY7bCg4ceKXp59CUQUgnLdD
1740	fee_transfer	1607	30000000	1	CkpaDrXbbSgDgeMyXXBgXcPKwvdokvw2u3WYXF8a643yF4w3HB6DB
1748	fee_transfer	1594	30000000	1	CkpZk8xB4VWFrU2VcyD457L243VZiTvuqUX5r5p47ma7ZYizWRBsz
1750	fee_transfer	1623	50000000	1	CkpZWpqhPBn4X1kaCHNjERzoPbEeiBBSML2yX5kVWQddrcmR6Aowc
1762	fee_transfer	1426	80000000	1	CkpZ9u6bkxJpDDccZUuJY7zT6sV4V5pmP8uRTh3mW3XRTcVQyuRHk
1767	fee_transfer	1708	180000000	1	CkpYUnyzYMmbCPx6Ju68UMoNjSNwvbq8Yv9rZU8YW9wgmET76hxbN
1769	fee_transfer	1684	90000000	1	CkpZhe5uKVXsFvQX56zGKaBfC6UDR1eKWrkxjqvV3YqLNpGU1HjnW
1775	fee_transfer	1573	70000000	1	CkpYeHpRFacsE5JVvPXhjLwqpnFVUne7pYVyBMmrYCHh9eh1N6UGa
1777	fee_transfer	606	70000000	1	CkpZkpCsbk6W2tbXJELuzsQCn2gjFdcCSi6KbqkqBKKnos8hF34BQ
1780	fee_transfer	58	305000000	1	CkpZytGLKR4eU8jCyS6DRBMATZcuZYVQkPg9yJWHumh7goDLqfw7q
1781	fee_transfer	1607	50000000	1	CkpZQyrB7KaTKnoXw3QLVsng2xXUH5K6tT2udz7gE5eyZs1upz5B6
1783	fee_transfer	1694	5000000	1	CkpZZePvUoWrxmiAx1x1rakJsgYr92u3vXi3ZGwxHf2EFCbgbDLqK
1785	fee_transfer	1684	11000000	1	CkpYr2SiUFgBafG2E8nzhVWfV2quu3kRa45U5VZ8S4bXMAJifH2jP
1786	fee_transfer	1684	21000000	1	CkpYSVp5V2n36UeuF8Ew6kv4HRv9yU4oWKdiGxLMpgvwfcBCGV4aH
1791	fee_transfer	1673	215000000	1	CkpaAHo1FqvpswGQs6S8bNtggHyMbEw1CF29ze4NTddkYV2ynqH2F
1792	coinbase	1480	720000000000	1	CkpZfHpj4gHvEPHBaPeHHaTd6L8EvK8JuEBN9VE6EkKF244phjkQk
1798	fee_transfer	1683	35000000	1	CkpYXr78kYCP95GoBbKLnjRCZyk9hLNBweRTYPdL9fuatRPg8p2sa
1802	fee_transfer	1573	35000000	1	CkpYfCHQixjqoVVRDfruBYv29X28iALgnhXBXG1rjMqAGY3Z1m3aS
1805	fee_transfer	641	865000000	1	CkpYb1CbmRiWmq9qYy352PeoHUYaFFiskc3mnzPGH6UkE5nPZGLxa
1815	coinbase	1543	720000000000	1	CkpZjBNHfcvZBs3Zpp43hfCc4u1JCt8qjzaKJj2ajxNzJmGqFec3C
1816	fee_transfer	1543	10000000	1	Ckpa5uBju9heGAGBZMjxu5MksbrfBdH2X1XV5JfG12RzRZtE9o8Ux
1824	fee_transfer	1607	90000000	1	CkpYXgMmGoVwj2JaM6W7KiqoztCh6CvGs4i3Z2zwfh7GHqx9jwwzZ
1828	fee_transfer	1607	80000000	1	CkpYkVz7bGpABd2jDLFuxmTP9h77UtquSP3CnprrjRohUhskczPJ5
1835	fee_transfer	1439	280000000	1	CkpZXbJdZBJaHL8ivpVnzKGjfwAjSKkxBGuLJBAQ8FJnrgo5P3P3N
1664	fee_transfer	1593	40000000	1	CkpZyWYjWXW8Ch3y54oi66SRt5gK3mxB2fkRiggzRKMbMNjWzbz1g
1679	fee_transfer	1654	41000000	1	CkpZaNJ24QRxjp2RKwGmngtXuX9gX8it2qPBvn8Nb5D89q5aXVDbL
1681	fee_transfer	1704	41000000	1	CkpYxn9N4RrzD3bR3Zyuqman2W6PXxwVUzBLqsUcdT5nBqs3MPqHi
1691	fee_transfer	1402	120000000	1	CkpZinZ3cWhWL2vec4EZK6DicuuRPts33nQmZJZ7WcK18SJMTcC4c
1703	fee_transfer	1672	41000000	1	CkpZwPsmersjWuYhNqHGgVpmqdNtjaDVc53PeiW3gXCdn1361rRBv
1711	fee_transfer	149	20000000	1	CkpaFV4jaTsTYera5NDdMMwuUepNH2CCWWK22QDAcmf2i6LHkUsMQ
1716	fee_transfer	1690	240000000	1	CkpZ4w4pjjcDFpfGZ6kthS3grB9CLxh3p5A2Qe9MU5L3ugUPeT5JK
1718	fee_transfer	1474	130000000	1	CkpZepNHTyTxg3dDyG4P6uk3KuBs6N9JhTdDrmiyeGsRoqj4Jkmok
1724	fee_transfer	1755	30000000	1	CkpZzXYQoKDoaRhxrWFpx34yBJiDnDajicXP7qq55aP1mH2bShe5k
1739	fee_transfer	1593	120000000	1	CkpZacD1jj62iV7Kmmme1Qaorg6odBLu6oiLf56LL6fitw41zrzXm
1751	fee_transfer	1678	30000000	1	CkpaLAb4634zEmgKbewaqsQEFeTn11uoFraXhVWVzJ4CEboUQq3bA
1754	fee_transfer	641	1030000000	1	Ckpa9meW91p1bKHoD8Y6jwoUHE8GewevgdC4xDD5x9XaFCe7244ff
1755	fee_transfer	641	400000000	1	CkpYqkzNZNWWtzkMeQq9R8RwHSm276aP81R3K3qE4ZNqpasGMjgnP
1757	fee_transfer	1457	61000000	1	CkpZyBWu2piks7wnxLR48xP5FW8GSfyk9fn4yvVFTVABkuHhBMwtD
1759	fee_transfer	1709	80000000	1	CkpaLKWpE6QeYcQJEmF59VhnrfvsHBr4BXGUTgUvt6wGbaBgdNRUf
1763	fee_transfer	1426	440000000	1	CkpYkyBsG8X2DRdPK1a3TVMRQcc6E7BEpNx88aMwF3R7fRXRXRUMq
1764	fee_transfer	1426	131000000	1	CkpYU2uaqciDurp3TkmU2faz43wcU6ahyd4DZN9b6Xe9HsYFUP2G9
1766	fee_transfer	58	90000000	1	CkpZpM4noRXvp4EQbCV5U6TN6WSe2roxu3HY7QAqaLMamWSaVqFEi
1773	fee_transfer	1687	80000000	1	CkpZR1m6m4kWW8hNFPDVToH7gjCKT6XRs5xeuMqhEBAPNMz5UFmej
1779	fee_transfer	58	315000000	1	CkpZxdcwL1gStJ71PXyAr7K4VngiDi4jqV2xoJhdaY8pyHBFzRhjF
1808	fee_transfer	1560	31000000	1	CkpZ36x1F4RXpMpYmv4uiyXMcLCeRvSUkrSokCg7K3dWJHrjScFrS
1809	fee_transfer	596	12000000	1	Ckpa4xDX2dkjt8fC8Z66dpf9iL4ErVXXT9NL5qfas6sbrGMajBEfV
1811	fee_transfer	1489	250000000	1	CkpZfv4oWZ7aiHxk1YWq7m9javhtJwTHz6spCima7EP3vWCMkbmWt
1818	fee_transfer	1703	30000000	1	CkpZQpAA1Fiv7GDtLQ4VkPFwkNx1jd3jd5rxDv3V9aAUfRWVZVDAc
1819	coinbase	748	720000000000	1	CkpZqs51FYmfNG7RmaDufDxCaoCe8a7tfXZDQHgfbyiUwgL8QWXh5
1820	fee_transfer	748	10000000	1	CkpZurzru8zhZu78scmRBcQJnX87jswuvPZE8j24zYe8jFGEFUaXm
1822	fee_transfer	1610	46000000	1	CkpaE4jzssgUx297f74ZAcPbbbj7nVegSC4Gi2aoj17VkzrqBV3y4
1823	fee_transfer	1850	90000000	1	CkpZ4ojBgAjDugZWv5E7PUk8b4mnDTyWtm8Gnx9dfvR8fBS9F6QeT
1826	fee_transfer	1607	190000000	1	CkpZ6KuzXJ1TYEJNfQe1cUjdE8PsrV8ChUo1jnBSFDye6mmZEsm3t
1827	fee_transfer	1607	351000000	1	CkpaCgZWCsXvpHACt8ZbZntA7Hx1kAvkAgMgQoAyw8nZYiMsHECYH
1829	fee_transfer	1596	300000000	1	CkpZBP2akHVMJw9fcka9Da3emvDaCx39v3RnjZuTuVuzcjMjdN8A5
1830	fee_transfer	1705	50000000	1	CkpZDtQrinV9Ve8TkBBEqjBrLQRqMi5x4SZMeyPNEW9419S4XpJTC
1832	fee_transfer	1692	120000000	1	CkpYiERLjX5abruX34sQDRkzyqoK33M4AJuTmxD8c5x41E2KJFYYv
1833	fee_transfer	1613	120000000	1	CkpZazwe8reEvcA63Jt69HkhW5LM39vR6NNBVwktk8vRNSHEHch8R
1841	coinbase	603	720000000000	1	CkpYvgqe9xsDo3iqRB1R1mwgjQvHMSwWBkfBdD46EyCsxdQJWnCqj
1842	fee_transfer	603	10000000	1	CkpYQRn1oxVhBJqqzFZP7JkU6gk8sNjWaE6MwSwpq7v8FoDt8gqk4
1843	fee_transfer_via_coinbase	529	700000000000	1	CkpYcsaDoKQ3X4UGJHK2hPHWyao7MtjgsNgRtPbTgei6abQVVCqzZ
1844	coinbase	1724	720000000000	1	Ckpa9fu6jbbyCfXKnFy9VZ1jBXVzGagEJm222F7pPGZmm7c3tZTxi
1845	fee_transfer	1702	60000000	1	CkpYzsa3A8bRKEtZvSumdwuHhdA6L1k6au2SRDMztqc4PpKgPDZ4n
1846	fee_transfer	1703	60000000	1	CkpYr6CsB1Js3jC8ozrJ7v72jnSnSihxwuXsTw9qZ39GVEW8PVy6U
1847	fee_transfer	1696	516000000	1	CkpZXsGT2YNWQwsPt1DGfAcDwzi9ULVCfHyKtZ8AGbY1X5uWqibAp
1848	fee_transfer	1764	21000000	1	CkpZb21dEo8DGonW6t8j4tu72vyQH4rR4fVmiZjx9kXqqKCL8SG3i
1849	fee_transfer	1448	11000000	1	CkpZfCiPedQpbtRWgj42iPgbzddv6qxLNHqDtQaLSUS1a3knRAbnq
1850	fee_transfer	1709	11000000	1	Ckpa9pHJ4x74snvM3EoXKcB49dWApD5gyWNrEQXPoGJ8GBzz26gj9
1851	fee_transfer	171	11000000	1	CkpYVGt3WGXnCwEBwZo1Bzyg6dSfxU3vyhUWs9c4qzYm3XWwdPy7Y
1852	coinbase	1430	720000000000	1	CkpZ1Luogmbt4Pra7ThY9ihtMSVAXZhDKovnpFqyHD9JqEoHMrGoA
1853	fee_transfer	1430	10000000	1	CkpYV2TsdQuAF27jWY8Q6xE8t3mAKLQXk8WVKihAKBA9NWNP55EGz
1854	fee_transfer	1727	21000000	1	CkpZXTJYDEPu1rpvpCmprp9G6zDvczPn16yx21myPGD7kwpN9gGS4
1855	fee_transfer	1439	370000000	1	CkpaGV3FQ9Y4n4Gm4nyv9mzwGPb2BaMm4ZHf7UnKECWoKdp9kvmWK
1856	fee_transfer	1439	1060000000	1	CkpZofGSHkXkRjxbQJHiEaokRcL2wKLvSXCTQwmpa5nDpD67HUw8t
1857	fee_transfer	1476	40000000	1	CkpZrfFgBJ3oMAPdQYiXJaCjBfDQmm8qRwEH9AWzMoxJWX3r1WLp7
1858	coinbase	497	720000000000	1	CkpZpcNjwbQ9GbjD6PjyF1hRGHA5zojurz8a7CmT2niiBWvPbfkMT
1859	fee_transfer	497	10000000	1	CkpZrunPy18GEk9jfKNUzhqj1dtpdeR6bjkvxZg2biKauyJkfE6FW
1860	fee_transfer	1439	292000000	1	CkpYku2Xp1Epkb6VfgAmRHLGLgP3cqotF6GJ22cUfY93aYFZuZPtN
1861	coinbase	366	720000000000	1	Ckpa2CQ6eeeuGUajcCEwHFq5JgRevRaUeWhxSQss3Yb5n2F1JnG3H
1862	fee_transfer	1559	50000000	1	CkpZvrsxoWgEzg3EeuVKf92MN2nkMhyNGRXxUUKBkEtF1eMZcMGSF
1863	fee_transfer	1684	120000000	1	CkpZRY2CgGRSQ12phqiTcMuzMPNJNjdMqTqxor43zj7EmzQJWTubD
1864	fee_transfer	1756	120000000	1	CkpZSpMniDdkvnf1LykuMVaQ2hsHrqYCfS6X96zTcFscQEb9d3w72
1865	fee_transfer	1780	20000000	1	CkpYvP6Rai9b2LaTeDNZpjqwGZSfQWNCDmsuGW1xDNo3guzfhKYxr
1866	fee_transfer	1673	11000000	1	Ckpa6fuxWThQfguhPuj9TSLBP5zam5R345R4GzNngheoQxMAzKHRg
1867	fee_transfer	1733	11000000	1	CkpaF1pvELzJKivQMaMGjBbNeJYzUKr9kKqXa5o4egtXgiQKqssER
1868	fee_transfer	1440	11000000	1	CkpZJdfbSjW3AHW9kA8pLb59QWGJDSpocfvTbGZm2QK47yMRhPHLd
1869	fee_transfer_via_coinbase	631	500000000	1	CkpaG4ResueXZmF2RR6yJ5mHrbqrmQgvyRiXFMP3VkPV1ChsDLo8m
1870	coinbase	1747	720000000000	1	Ckpa8nuAtpDE5samWXej6JmemKcwppi7ZXjHopRptD8REKtL2DbUY
1871	fee_transfer	1677	660000000	1	CkpZ48LL1uQNL2RpBLTX4Pa8VtSe6wonwM4crffKRDrAmVx7dq1dX
1872	fee_transfer	1402	660000000	1	CkpZuej2YxAjHMtJjX3HnBg2BGVUR37wNgS4b16f5erVEAWD4Rm5K
1873	fee_transfer	1508	660000000	1	CkpYaksDQemZNyh56EuNHXKi75CaiA6VMM4D4ymQcSczjksHNSTjC
1874	fee_transfer	1711	11000000	1	CkpYf2QoH3khAZQ2FqtsKXqAbiXRaWofRndFW9j4RHEuM1cPkebaZ
1875	fee_transfer	632	22000000	1	CkpZny9xoZtenvK1XyCk2QKudvWSByRMZ5YVtRug9d7mYmG1PSw9a
1876	fee_transfer	1657	22000000	1	Ckpa5X4gK7cWtHvnHW9CThjyZfahwyqBJfzJNTpjgAcNQZu97YEBu
1877	fee_transfer	1444	12000000	1	CkpZYho1Vc2sern4i6CZAYvwU6DaHV7XAPEnU1LQEKrjQFjBNKoFB
1882	fee_transfer	1692	121000000	1	CkpYiv2QedX6KbxqFgfXEsZztZ4Fc87FyRNZh6SfARZRbtJuWstkk
1887	fee_transfer	1271	130000000	1	CkpaCHF8MVFXfSMHapcENWrQv7krdGx8GZTsa9SSR4LbcCXMaqyf7
1893	fee_transfer	1699	210000000	1	CkpaC5qvBCrdKiMeAAaMoyAW4rYcScn56Jxf1DwwZ1FCkZia1UuyV
1896	fee_transfer	1850	110000000	1	CkpYQwdvQMZ38SrSatPokQahBpMUyRVMUrrh816sjVuVi19JdsfUq
1901	fee_transfer	1684	150000000	1	Ckpa6F2us5UYFRWKwibZerFkNP1yFavVMEtg5retr2RC5tsSud67Y
1906	fee_transfer	1717	21000000	1	CkpZDBdASP7oXrjW4S1wMX2gryWEB5NyqChEBXrEanDLhNdFxkRvX
1909	fee_transfer	1536	11000000	1	CkpYgvTeaHCEnxyWxcJxzW7rqfEasQqyN1cTP7zYEcTJWvkQCKzKd
1920	fee_transfer	1680	1170000000	1	CkpZbcfKJSADWPCm2ketqsX9Cm32DTdXjUHr6zVbTCfX9FXik8XPc
1926	fee_transfer	1684	1000000	1	CkpZKJKS94GffdkK94LFoD55G51otx7Gfp2TnTqAXYo4GRzyGdNGD
1928	fee_transfer	484	120000000	1	CkpZ9d82EK95pYZsWr6paM9NXSnXi16QUpVhVhtc2pfaCdknRTEtY
1931	fee_transfer	1656	21000000	1	CkpaKxQoQRaJLrUcLHUpD1BBidEMvbEBY7FDjxw5YEGGCErfqEbay
1935	coinbase	1592	720000000000	1	CkpZ4fqCTL6pGUbktBW8VPXtgdcTVUTgeQshXN3A5FoSM6EnN1NLd
1936	fee_transfer	1592	10000000	1	CkpZS2DfvbW1DBCTKKd9pAsNaGVPKdmyJ7rnnRF9oKotbuG84yTUD
1939	fee_transfer	1711	229000000	1	CkpZPky56oTseeGzTFGw1UH6MHoKtG86qm732Vq14rHtKA7J2niWX
1952	coinbase	1943	720000000000	1	CkpZdGFprzqLscPByRp2ze8wosAvmWoEomHTE2d9FW51eajht1PTN
1955	fee_transfer	1596	120000000	1	CkpZfU6jtvhqreqDTVRuvrVa4cpFmcDLyH7QfGG69bFjFWqbkf5Rc
1956	fee_transfer	1850	210000000	1	CkpZGSrxY79Rz4LuWhmKQJaZYcR9eZ6zUrmeSzzCtrJzhFCevwNus
1981	fee_transfer	1547	41000000	1	CkpYmjnSqrsDHbZF7pAHDFh79ZmFsujfi2CVyQsiGkYSTpVXDtpcZ
1983	fee_transfer	1755	730000000	1	CkpYam9bFAJeuuKo8s145S8KrixsHqY22tfUjSyPEoescFGmNcv2Z
1984	fee_transfer	1755	820000000	1	CkpZv5rUTxyErCasx4hkTNsRSU5gGHMgDQB2HWWx6XP8WXpgBH7Fa
1988	fee_transfer_via_coinbase	1520	100000000	1	CkpZdwcENb4jL2CKCVXUwBCzD6djix1QrBCSKiGdhzLVhu9wqgmQe
1989	coinbase	1546	720000000000	1	CkpZPSXD3p2zTehP4ANxmxBgciwhRgPxunvURDG8oqtqSQZSMYcpi
1993	fee_transfer	1598	60000000	1	CkpYd7KwRp1gp36pZqUq7HQEehYfEK5yryU4z5ugVg1sjKezsid6y
1997	fee_transfer_via_coinbase	255	1000000000	1	CkpYzkmzN2BGedbdpMHEf8U9dTojJ9NgLTckviENbrPe8XNVD47zs
1998	coinbase	43	720000000000	1	CkpZ2xjh8vibYteuXHBrkaWHkPC9FAPUsZu1MqBKuoUyW4MwudhJR
2004	fee_transfer	1938	4	1	CkpYbfrjPgxyWg1rMrR6HnCjNvfERpHwXzfrMcfvkfknzFfbgSVou
2005	fee_transfer	1474	19999308	1	CkpYXzqCYsMf9VUdFz2NRKknPU4HnpWGmx1UUnmWqfVhvHTq758Xf
2006	fee_transfer	1571	688	1	CkpZhsZi5qrmaAFf1HkxxhATmBRAaN3jY7oPQX1g5TrgNrh9eiibP
2009	coinbase	1690	720000000000	1	CkpZCBgbDnfyH3NVcymZfgyRZr5RWkrX3YGXyfRwyZanxTTYpWcYh
2011	coinbase	235	720000000000	1	CkpYnUm1YB1HKKtrEJhcTJZcMrBViFDjZ3xcsNPS4Ae1wCMCx1HdQ
2012	fee_transfer	235	30000000	1	CkpYuFbQZVi9y5Tz1zWbrR2AhcXvnYNZvxx85eovyMVBbqtKEwdiR
2017	fee_transfer	1691	60000000	1	CkpZFPXZZecHaRiTbkjnBfNVE151ZbYsUuk9xYst5tv3bHmyvA3Jv
2021	fee_transfer	1677	285000000	1	CkpZpEJkcABGLMe9gkLoj11wnxfMxEvbYkUknzamWQW461cLpbjPb
2029	fee_transfer	1419	60000000	1	CkpYQ7xRba7VrFbbkF5PVdapZFbMtNB1SULxCSaeKye1bjvoy6Eao
2032	fee_transfer	1933	20000000	1	CkpYfMPMb1i4pWYYq82wgrSREzT1xdZha7dWXqXLCqXsp25SzXN1J
2035	fee_transfer	1695	50000000	1	CkpZccXdt1pPu6T4NcTAbnw6R6rvGTBJ7aQ9kV1NTUepWxUDssQwy
2043	fee_transfer	1623	2000000	1	Ckpa3c3MnZncAhq4T5vWXMb1nq73Edd4d1zymmiQCtQDLqS3CjYPR
2049	fee_transfer	1709	1130000000	1	CkpZphrEQhcxj2PxajXyLwbxhAE1D3JeSwXogxnSYbfzdWpPpsh8t
2050	fee_transfer	1882	70000	1	CkpZg22Sru45Q8xzZhnr9wLHKWcMuY8tNCXXUumbp28spLZkLtMQv
2051	fee_transfer	1709	579930000	1	CkpZqk56qafSTjw5ZNuNKgdaoqyMDTfNDDfS2NvmKNMoLRbrkkDev
2053	fee_transfer	1691	41000000	1	CkpZjmDkvSyku2tGJ36YMF5P8EXfspviNm1wmJnDvrT7JJNWSYuxJ
2061	fee_transfer	64	20000000	1	CkpZUKPCcyHCWYmKSagTRV41z8YYd4Ymp68eHrGgC4Fa1P4PLUUCV
2069	fee_transfer	1948	5	1	CkpZwkUFBAykRGUpnCAhbcrkiFQJEc7ySc2XpvDMhCvkd6QyHqEcZ
2070	fee_transfer	646	40590000	1	CkpYzHydnyd4bx6VxsPmibzMXatqDG3zJzhLyP5uuSt5PW5kyrira
2071	fee_transfer	1687	309990	1	CkpaErANm9SBrkkWinnD87vD1Tg7iXEp55TZT3FZySEMf7vKyrtJt
2073	fee_transfer	1687	41000000	1	CkpZKK8DwhFhRv1HLF3zUUHdi6UufMAzuneFAZqfXhTq6CfsA8rD5
1878	fee_transfer	369	62000000	1	CkpZ3msYiYsenstJSXQght6tdmG5ir4DV364BkazPF3usTbC6TWyt
1879	fee_transfer	1699	11000000	1	CkpYwxiwWtx3r8Dsgo6gfEqdp7wwDdXy1fdFjQ61gX6KTxBNgYEsL
1880	fee_transfer	1547	2000000	1	CkpZuh6j28Rebo5iFZYjcQ33rNQpNY1QNg7ovBgs3irCciQEbg1t7
1883	fee_transfer	1879	10000000	1	CkpYYVxjdJqT3SzRpZFgNbhnQj1nvbJve9d52xQsmKyoFtVvbF4Wp
1888	fee_transfer	162	130000000	1	CkpZHH6sBAYZLPrX2kmtciNHeEtaGoynkLKXSw9hQ4ucmRv2Eg91G
1889	fee_transfer	1657	611000000	1	CkpYRu3aUnLF4MSev1NDXuTPBPkZAhJEg4YuHYVAqgvNGdwbxr17H
1894	fee_transfer	1764	210000000	1	CkpZL3xyA2KEHfm1VCCDVy4TA4BkDd2TUXgPm2VHRQHiQRkvqts1P
1899	fee_transfer	1698	11000000	1	CkpZ3aFJ9haDjqhGth68uMPLzQuFU8tfB2ZsErW5mrKGjFvFAciUJ
1902	fee_transfer	1637	150000000	1	CkpZeLqfPq5g6KCfJVt7khWbD95wH4zTeDN4obrff8E4GdJJ3bZFB
1904	fee_transfer	1715	1000000	1	CkpZXKF85CZLTNdq6QEo54Jxd7CTzhnHQe5Q2xFewbskr6TfvNx1k
1910	fee_transfer	1474	11000000	1	CkpZKtgR4ApsQs9UzT9k4RT8kmWTA7aWCLcC2jNTCipHdq1T9DQWS
1913	fee_transfer	1607	21000000	1	Ckpa1V4egfrQbBLjQnmPwkYnT8qrgJnztDMGuBh2M5db2FXUd44SP
1914	coinbase	1933	720000000000	1	CkpYx1PXGztqZLSJKov3nfiyBxDKZkPQKGyFFSAWJKmbEDze74sYr
1915	fee_transfer	1933	1000000	1	CkpZJXY9QmfBqtC9NtiXwqpEGH4xek9DFQNeN3hax2rB91KAacNKw
1917	fee_transfer	1427	10000000	1	CkpZn4aCZEWhFHowXg4RYbXj3rBnQVTxfW2xbuvjAzWbeK9JFn7Gv
1918	fee_transfer	1680	111000000	1	CkpaL7Yu9agUzHUUGWQgj6s5b3SGvTXbqFdGfZM2nJNCzyuzw434v
1921	fee_transfer	1688	21000000	1	CkpZZXoxEXKncGH1zm3Mpt73oztuvnnes8jvfYNXBnEYBGhkFyr74
1924	fee_transfer	1691	131000000	1	CkpYZ3B2Wd9TigKorEPBPfsxfunwrAKP7d698YtN6sqDoxCaLWfDA
1929	fee_transfer	55	120000000	1	CkpYnnJdfj7fTtLo4ejHVkaEn8J6q8TtXNXVTCyGyWiCXRkmFAm95
1940	fee_transfer	1699	229000000	1	CkpYog6x4eRapRpPEj88ihhzV3D4dCGwQUmUQ8Xk11akJpFtHfAJr
1945	fee_transfer	1634	15000000	1	CkpZQmkW4jbqTogc2obkyaA878XFtFUNG79gJCaz6Pka5bqVW9Esd
1951	coinbase	102	720000000000	1	CkpZfYQLQxuuqRmNgNPiCMAxH6DtF11YJJzzNRjotNb43Mcfby6RR
1958	fee_transfer	1587	21000000	1	CkpYm89ASu4YZvXTj5mpdqtCzvhXkyZsdiZHMVNypC1SMG1kGTwGm
1959	fee_transfer	1708	800000000	1	Ckpa9bn44mB86BshyFLu7qpgUbqcJVbknnxpsFirQY9je34pDLBD4
1960	fee_transfer	1708	562000000	1	CkpZUm1vxfAqqa5Bq9DSHrq9ws1R5rACquzxRHvgo68Qheoqrzb2t
1964	fee_transfer	58	410000000	1	Ckpa934CHpJe4G7cy4uCCrEPnJ2vHAsBUZjKvgMoV4gFARxbRFkj7
1965	coinbase	1882	720000000000	1	CkpYQed18v5wBkBLiRrVuGf47KGPQvxgWNjBdRuKxTcmMD6jJBKrH
1966	fee_transfer	1882	10000000	1	CkpYZL4YKWxdCoKeSte8Sv2sws4M8vycPhZ5iPSxYf2RwAJbkGQvx
1967	fee_transfer	349	20000000	1	CkpZUychdPwiBSGDJrouza8zrkRHBdhskurzkpwhS8kLL5VHFgftD
1974	fee_transfer	1729	1040000000	1	CkpZpugsUv8rdYCH6SWgxoj7ybHyafabLaThAGTBUDdY4MFG4Fva7
1975	fee_transfer	1729	270000000	1	CkpZz2LQyrNdJBDZ7yZwau2DVSBR99VxSx5V3uFQkqPu7Zi2vag74
1978	fee_transfer	1690	112000000	1	CkpZhF552kkryRjXpUQqjLtrkBoXM8aEnLe8MhkhgRPech179o9ej
1979	coinbase	1690	720000000000	1	CkpZ6AaTDy5ktnkjVkNqozMXC6hQ1BTcb9f1mesHSP87GHUGpn76t
1985	fee_transfer	1755	20000000	1	CkpZ2F1UnYDvR8Q4pQS8u9TfZdj637aswwhy956zfGGsFMtCESHy9
2007	fee_transfer	1474	14999008	1	CkpYda6tgraqhRSE3qciBteWkLb1whefE4nnuYDWqvvqfFv5BJtAg
2008	fee_transfer	1571	992	1	CkpZPsfCB39mG8t1XAfSyG1yQvvKcg7ty5seP6vaDRFzuE2PEXn55
2010	fee_transfer	1718	40000000	1	CkpYWxZc8XEQgCsL7w8rMmQReZtxWHLrd3f8zXvgyVBizwYPFQi1J
2013	fee_transfer	235	10000000	1	CkpYkVx6Eds9m4LpsG9CYZ48vf8LF2wvKpPs9qDaDsxHb4QViy16e
2014	fee_transfer	1608	30000000	1	CkpaEdyVPPrBgR6DCBMYbbjC99mpfV3NkpUEEAxkwjuu1K3XSNFNf
2015	fee_transfer	1447	60000000	1	CkpZBV7AptWrgRUPhU5FUuD2SgnhnXwrJ6DhcmMDbsP2NkN4jxpVu
2018	fee_transfer	1623	60000000	1	CkpZWjKNcXE79pu73FoAmzk5tCAZgksdgTrtUX6HHSqh3CBPnjtsY
2022	fee_transfer	1423	285000000	1	CkpZTprBJCNFBsfZ2U3qWLUMAfKZZt752MDQLUhTW4GtrSruoLURo
2044	fee_transfer	1668	270000000	1	CkpaAwdHbkkHLmdsRLVdFmeS52KdQtPnD36E4hYVzxN1XkCoD5mx6
2045	fee_transfer	1559	100000000	1	CkpZfYFEWEWp1MEHSvNuVi3vCJTP3keUAjAFenFdhdSApaFye7whK
2046	fee_transfer	1692	140000000	1	CkpZypNdk76AgJs24SP2ocaNVNHFXeYJrUGfV9Mw7tPqWqchV2e82
2047	fee_transfer	1683	1020000000	1	Ckpa2qLiRR7GfuEX6kH4t8sGXXv9EcKyM126gr82JF4CK5qsfwFEn
2054	fee_transfer	1623	1000000	1	CkpZ2THWe6TqdFHtviZMtKM8oX2tejeYraakGasAohVAFawCHspja
2057	fee_transfer	1683	45000000	1	CkpZUP8maA48DbRuSKvHrMvamLcnZjNHfCh8Ux3dGiNda4hqSqC1M
2062	fee_transfer_via_coinbase	1831	1	1	CkpYdopUpWHsmih8GAmiZxdmMa3s18KiFNquz5oPQyTZe3tDhy4Li
2063	coinbase	1850	720000000000	1	CkpZcqRFg6kLJBCoNpuTLiSkedsannpaTJg7t9PcoCFnaw9miKcF4
2064	fee_transfer	1515	100000	1	Ckpa51arquisKmidVKEHj2dZq5SojbXhadJkAexyDaGJJKePL3Wme
2065	fee_transfer	646	5940000	1	CkpZWWqtJeNUg192YDgvnE4RD5usxajBwiFCNHMyj5iGE6BXD7JKt
2066	fee_transfer	1850	9960000	1	CkpYxGEAscWdJEEkWpyHbYbsQDbfD1JdWss3RcfPF9Vbo1ecRFNTL
2067	fee_transfer	1543	25000000	1	CkpZHsPDLXPTAR8niDUr6t5z5jHMaZdPr1ZDHkxJsYYHYwFuyE7n1
2072	fee_transfer	1685	41000000	1	CkpZQkiSnYnPrzQ6VzVSBFZDyEJui9SMDK23wgvk32kbvJr1oGoBo
2074	fee_transfer_via_coinbase	646	990000	1	CkpZSpPNxQkTqeqrnm26gLPgt9BgXdks4UD9xdVkH4p2WYnDY7h82
2075	coinbase	1637	720000000000	1	CkpZdK24uTBmEoSK9oihTEFiiNFdWDXtvb5VSFp2DK8HGfnuv53HN
2076	fee_transfer	1637	19010000	1	CkpaCp6mkZ4ktsGbiwuRfjf9fX1zUUPBkbWjsLs9AVDxWXvbKQLnf
1881	fee_transfer	1683	121000000	1	CkpZvAEZZ8xsRNrDWZz5tLe7PXugyjU4mUttJQRiSjZN3JWbqUbVL
1884	fee_transfer	1715	61000000	1	CkpZpc1SAj8WqX3x5N4RdhUdLU2A22tTzMFodzSFiD5Sis3whdChh
1885	fee_transfer	1610	140000000	1	CkpYWkyY7vpzNVmtiuU9USRg32E8Z7UykvVFRTAi9Kdcz8VC7bEpN
1886	fee_transfer	162	101000000	1	CkpZAP2xad9Kz1vLRLmMGVifMqzovdgqYCEQUPhGTGXE9j3iBN19u
1890	coinbase	1432	720000000000	1	CkpYQZe5pe9dTX5JhtELCSiRHH7bsQ5Xo4v42jwhqJnxN1uaCmk6M
1891	fee_transfer	1432	20000000	1	Ckpa6NHYq7kPU85396xTydEQgWcCszEHobWTmSjk9y964WFdW2Xsi
1892	fee_transfer	1654	210000000	1	CkpZ96aAZ5WU5VZzEkMPSsP7C5QssJpdLNJjkzRJ5SQEXhkDMxzJt
1895	fee_transfer	1684	830000000	1	CkpZn6Xnndjd5oDWiPQAnjd9PBJXGAkyMgGkQrwifRxN6Rajn3pYT
1897	fee_transfer	1689	110000000	1	CkpYsGfTUTPXR1HXKXYjCxhQiEPKEgKgDxeb2CfzpSNhnYXSG4kyq
1900	fee_transfer	1723	11000000	1	CkpYn4s1CbgQWZH9cFUZtXNm8Jmx6UzuyFXdy7iGiXbHfKzmPzMXJ
1911	fee_transfer	1679	15000000	1	CkpYUZaimVbXwumfS5ebvP92CVKLHph4zS4fRs4BzbRhH8Ef8ATVe
1919	fee_transfer	1727	111000000	1	CkpZNxVGhVw4zYvhQ5Lwzky1Vf65BdZWTtb7YfXpiEG5UjfsdackV
1922	coinbase	8	720000000000	1	CkpZehWKf6Dn7cxqJZMHQwKwve8Sm4EHDSuV5b3EBUHRCDd6iFqSJ
1923	fee_transfer	8	10000000	1	Ckpa4pihWrwHkZAs3FwNLPDeGL7SUntREPpphX6wUKmH48ssQ7AZh
1925	fee_transfer	1559	131000000	1	CkpYxij4bcDSBV6VQCgvpaYowKTt4HSPiQycnbrCE4DVTjYoFavya
1927	fee_transfer	1457	1000000	1	CkpZoR6GG8Ac75D78XquL3XcAZfn1NFqAwr1VCQkPxmDPyABSDBeM
1932	fee_transfer	1513	21000000	1	CkpZxCwfwymCJWtDEmkPg653qPCrR1Sm2t1hRBBkzmVD4bTzPkRCL
1937	fee_transfer	1643	11000000	1	CkpaLVwa8uRa1kvg82ViEe1nqJtqwGeR6xsFXo6BrHDGX7eqLuRsZ
1941	fee_transfer	1649	229000000	1	CkpaEcXjf5ep4jVg1qBubo63ks89bog9k17LTcz9h9Yz8HZGRevsA
1946	fee_transfer	1683	15000000	1	CkpZTnKntzq2KYuUfwvWTBmw3xPLm82Wub9dt8zykiLfgqWWVdogY
1948	fee_transfer	1677	15000000	1	CkpZYxp6TdjVbuQkTUeBX2aRpyQ55wqk3LDpGzkZqaXR6G5yxXZQB
1949	coinbase	303	720000000000	1	CkpZjAUVtvLzLpyNY5PdsPDR1JWpHd227HKfoXMm8Q64YDpA6dVDp
1950	fee_transfer	303	10000000	1	CkpYrt57GZrWVxa3mKEnbdeRjwrtjkHAeT42BfjbcjiQ1nQ41s9bX
1954	fee_transfer	149	1000000	1	Ckpa62fWQ4vcFBjTFTUSfJJyP4RHe3WzpmX9Hs3hsx2zZ3fxgsqpf
1961	fee_transfer	1740	70000000	1	CkpZWNJ1V4ww8EJbyBu1htgBwUQvcw7zYRFxhp2tmcaQ4N1rvUbYL
1962	fee_transfer	1740	19999999	1	CkpYie9LSD3zXZ7NNPFiZCGqpXQMe164y5TKKKqgRd5mwZMXVzdn7
1963	fee_transfer	1708	231000000	1	CkpZ5gWxoUW6iCXvEMSArbANmnt68Fw8CosL3Bz6HYcJ8NWLJVk3h
1987	fee_transfer	1560	70000000	1	CkpYcD3x98nw5mQ9NLm683djpbrgDvJEzmdNbehLP1Lgh6sovPdzz
1990	coinbase	1677	720000000000	1	CkpZFNJaxrqyr1ofPEieXjce9i4AoRwE65LziFL8T5VjzrVkvSYBk
1991	fee_transfer	1677	19998100	1	CkpZwt8UNsCm8ANXMaNpaea27smtHi67KyRyr3M3iciyma1oaY2ZX
1992	fee_transfer	1514	1900	1	CkpYcUjpecYrqh2QzBiHv1SNuRuzhAi9QTQx8XBK3DgdxFBupzKMC
2016	fee_transfer	1474	60000000	1	CkpZAmTtteCECnkd8YLSmoiHxaHCQxnbQyu3Y4iu3h5WtT2uqaDEj
2019	fee_transfer	632	70000000	1	CkpYbCeAE99MzA7RaK7Y9PiW5S8CsAan76JDqyetB54PP4MoXnX97
2020	fee_transfer	1611	60000000	1	CkpZUg7K4yZVs3WfzAg9rQ1zmkhkfFoc3uQEom66wyTu74JsZ4f46
2027	fee_transfer	1692	39999999	1	CkpZGG7rK3TpsuSwysww8LQDSPMNXWrrbZNdQPkHET7uegf9itT5B
2028	fee_transfer	1934	1	1	Ckpa9ADeMvGMpUv1H9zwHFYXpo6QvCYkoGFkA5jMayuGaMCMAC4c8
2030	fee_transfer	1633	60000000	1	CkpZfjB7JxdRXQgVg3eszUPpBzd8JKieCuQ4tcfD7mXpck8KMJvGK
2036	fee_transfer	243	40000000	1	CkpYSukXF4ZaeS38cn1otLvYtCByBEuixhhDW6wfN6WPGLc4e2xLg
2039	fee_transfer	1700	80000000	1	Ckpa84n5C2xHGjb6dHWKfZa8ierv1AqYYi82txH5owtoiVZspY5Ex
2040	fee_transfer	1509	41000000	1	CkpYvS74BPh7NwCLuXyYA7H16FWA5wFojpiTY9KTQEEMdBDw79KnU
2042	fee_transfer	1683	41000000	1	CkpZZPtKhaMNmbg8aZzJf4jXNzYrK6KBKMWLyYBPq524cqmfYGmtU
2052	fee_transfer	1677	41000000	1	CkpZb6LndLoMfeAatEaWJiaHiA8PWFkxGZNGQyyUtV216MMhZHN8A
2055	fee_transfer	1649	40000000	1	CkpZFcP1Q99CVi2u7uyYiNoxu2G7oAYS4RGxD6wyos633Ta5QNg5y
1898	fee_transfer	596	110000000	1	CkpZztRnuw6RqwdiQ5MEdyUokuJbB9ze1WykgVJ2WCrB3anvGHEWu
1903	fee_transfer	1426	21000000	1	CkpZeet9jfzEgj5zsiV6Tw2dXTDk8pvsgsk2MxMjfXPUbzCv8xu2P
1905	fee_transfer	1689	1000000	1	CkpZo4KpSbCRNwJZ65CX9f3oUR1nFszsMRc8enGQPRgYvS3Yyan5r
1907	coinbase	1427	720000000000	1	CkpZJUpwCGJ5BqxN4EFYry26wSRckEkech3LnZjztttpuJKqXtrGp
1908	fee_transfer	1427	11000000	1	CkpZuVVWNK1V74HPwmBqGiEfuRgt93KNv4tKHiSPSvGKEtpYtAVvg
1912	fee_transfer	149	15000000	1	CkpYjMUBtTQDR2ntkxP2LDSS2isKCmN7bhgKnwAUrQpJGh7Up9yjP
1916	fee_transfer	1933	11000000	1	CkpYdjEZNnN2FJ9fkRMjTD6Xm6RfZTopZTHyxXBYsC2L6q6PxExnk
1930	fee_transfer	1694	510000000	1	CkpYYrVWXSXMsbKkv2hcK2vNUx66paRnqjx7XhRuWeNfqxAQDuTtj
1933	fee_transfer	1677	31000000	1	CkpZjNc4dxdYUFMRpXQqASU4wKRXSx4wBa4BVregGCCJCvFd1C4Gg
1934	fee_transfer	1511	11000000	1	CkpaE2mBxfYpspz4ymUTqbUVmpkd7tmh634DQvJoFJoxLx3yCGYKu
1938	fee_transfer	1683	229000000	1	CkpZcy1xBice1zpjPHXFM5ZBA3rYMA7atzhHyk7e4qAjaGne1wYXq
1942	fee_transfer	1677	229000000	1	CkpZc9TTwjnU779Wqwe1J43RmVub2ZAxMqZx7QTvHXh5e42jspJhb
1943	fee_transfer	1549	45000000	1	CkpYSHJmafAu4EEb9iE9ew8fCbwyiRC9MqDYUkMwuD6SoERaVa7ux
1944	fee_transfer	1613	1980000000	1	CkpZjHkCW2TqKPS5u8ZgH5PLiUd3EBi93kdk1oqRSt8PA62oGbBmi
1947	fee_transfer	1402	15000000	1	CkpZ2XMSc9Ewfpnssjc5e4t3jeYHLZEdy9qd5drJ9nMm2SwQtZfJW
1953	fee_transfer	149	100000000	1	CkpZBsPBkqiVyS12uKRLYi71Na1ryLmCxCr8jomk854LBTDHMFsKv
1957	fee_transfer	1686	210000000	1	CkpZoDtBxAQDUELPw5i21KbEqg267u5TyCoyN6xcx9xkHd7zTrDJx
1968	fee_transfer	349	280000000	1	CkpYxhwqNG9TRoSwC1f2MK1eGkvbXtgLMY5hA5ZWyDR74FkMxCD2m
1969	fee_transfer	1938	40	1	CkpaB3AEGgpsLZC6642aEaftXQoRfQUuSwQKfu1TehgCyKLzSiy6G
1970	fee_transfer	646	990000	1	CkpZSpPNxQkTqeqrnm26gLPgt9BgXdks4UD9xdVkH4p2WYnDY7h82
1971	fee_transfer	1761	2	1	CkpYdHU1KnR3THxR4g8PDu2cxyqfHfgJn9AocjiA1fcW4JuQgKfiY
1972	fee_transfer	1855	1	1	Ckpa8f6ofwucHZLMcCvuUSCqDtfsJrTWaF113XU5uz2YAd1QoENPb
1973	fee_transfer	349	1309009957	1	CkpZH3RUoLoWCRmnCnDfgk1jtNx7bmNewyMXPn5dy6TdiZDtqqcsM
1976	fee_transfer	1768	420000000	1	CkpZQnV29hoYaaZhRfcDtWrL9bau2yEWwMQVZaG3fXLeZfUvw8gh6
1977	fee_transfer	1768	351000000	1	CkpZmqhK5eTyr2kofYVjeDWeFPkg2VhimbGz1gEzMAdPNN9Qn98x6
1980	fee_transfer	1422	41000000	1	Ckpa7Xb4fuonfiNUSgKTTZx2ZLJwucVqVM2nMz2eBdVBjhrtnWYo5
1982	fee_transfer	1677	80000000	1	CkpYfLdPooqvAphrQHk7Xm5ZNjShsZzNWbwcbw53qozoun7rZPvEG
1986	fee_transfer	1759	40000000	1	CkpYeW2WsGPt6YrfW4k7AF9nR8ezfx2KGkeo4wA9Bz8rk8M2C8Fjo
1994	fee_transfer	1689	60000000	1	CkpZXRoNRFsUp1jRkRKcAJEEdstbXLxqoGFCsfUsV9QHwKMUz6BEp
1995	fee_transfer_via_coinbase	1420	110000	1	CkpZpobAj3wFYRPHEyqTv8iFdoM9RDjSp2Ljmt4TWar8CZXHvYz4a
1996	coinbase	43	720000000000	1	CkpZco1GXckzH5ZermtvKHEGY62AraiVBLBaffjwz6SvuszzgbTJ8
1999	coinbase	1718	720000000000	1	CkpYeP4wg94WEawh5MfLLYbYjTJzXas2Un2GwWai5C3fCj2xXHsv1
2000	fee_transfer	1420	110000	1	CkpZpobAj3wFYRPHEyqTv8iFdoM9RDjSp2Ljmt4TWar8CZXHvYz4a
2001	fee_transfer	1894	5000000	1	Ckpa6GHrrPikUNF69x8qG6PbMfHu87791C3zVCdr2qi72bZLm6ftb
2002	fee_transfer	1718	14889016	1	CkpZjPTUdBJA8rmUw5vXFQNTUnnzQFvMEnBGGK5z9MUCWn5sfiW5N
2003	fee_transfer	1571	984	1	Ckpa9WgytoJopiNubFKsNag9EDVYgg8Zv3oz47Qk9ce6BCqfxw6su
2023	fee_transfer_via_coinbase	1938	4	1	CkpYbfrjPgxyWg1rMrR6HnCjNvfERpHwXzfrMcfvkfknzFfbgSVou
2024	coinbase	641	720000000000	1	Ckpa9WUqwpqf5FUV4VrVJWgugwv93Wxd8f29Lx1pJ21rn39evZgZo
2025	fee_transfer	1938	36	1	CkpaKw59yABSUawC4cP5Lj4qY2DTDVtgupQ9xhVLMViTtohnv9jif
2026	fee_transfer	641	39999964	1	CkpZwjor3xJNcXb5V3rNhXGrcuJYHwpsc7DKhgq6Wj12dMY1J4zY9
2031	fee_transfer	1933	10000000	1	Ckpa8Fh6FBcwpzgtVUkPKHA4a2t7tZ4tRxFWNCqrkGWJV3zCiPEYy
2033	fee_transfer	415	20000000	1	CkpZ7kdDSFXyQkpzMnP4Z9XKQQbjbSUdc438pyo6Jykiy6x7W1XF2
2034	fee_transfer	1623	90000000	1	CkpYXUuQvAwN32ugReH2VNqqwcRtCkFhECjM3aiV5FVdnMas5gMz3
2037	fee_transfer	646	1980000	1	CkpZJCZAxvc25Xt3kcwV4E2XnF8DaeB2K9c3MeoSLJUuJoJJt6cFw
2038	fee_transfer	1692	38020000	1	CkpZd36QHSgC4ogLrT1nvpkusfjvP4P1UdFZyP7EZK7Bn7WnbnyZD
2041	fee_transfer	1689	41000000	1	CkpYYSnBKnJfdXc5YbFMWq1CHTjkw8nHnMXLd4616VUA6KeDbXKDp
2048	fee_transfer	1623	1100000000	1	CkpZnXnaoKPbRwGLjnuEy9PNDuqt45RkodufH1GLMJaLgxLTDxpuN
2056	fee_transfer	1596	40000000	1	CkpYqgudM3ooeVKstP8oe3CuppHRjCEePAyZXVqKfZaHkq6jow3mv
2058	fee_transfer	1519	45000000	1	CkpZvPbPuyuwU8QdRkFFWGumd4XsC1WoU5hPHbp3GS7PymCZvz8he
2059	fee_transfer	1675	620000000	1	CkpYuks9sYzhG42CVL9FUH6aSAcHKuVPD34MXScZziv11esPZi4z5
2060	fee_transfer	1675	420000000	1	CkpZKbQU89sG2swRsYRCteNibiNHLfmLe4r46yGL7NKETaYrJ2KNA
2068	fee_transfer	1850	41000000	1	CkpZXjSsgsa3wgw2UUFEJKJJoLtwVyuK2EgboC1D85FN18ab4ZDF7
2077	fee_transfer	1684	45000000	1	CkpYeWRMnNWZWepwGyxVtSW3DpEyrTugCbHkvDQvN6LJkhYRLHAGF
2078	fee_transfer	1599	45000000	1	CkpZJJqEGeKqfiuojXUvJpP21ZGN54qaz7vyXE9XsvmCh1CVGCVBQ
2079	coinbase	411	720000000000	1	CkpZqcnHbfvaJzrtkQ2iC3vDyyWtPVnScKGpfHnhGBbhNs7LXHmwu
2080	fee_transfer	411	20000000	1	CkpZZyQQYjctEDmJbEXFtQ6jJPhSwYWaGKsRxzqcVZvuWVapqQagH
2081	coinbase	1532	720000000000	1	CkpZNiSUsbwMQH9N9dVfBQ7ZT5cCdrprmd5De8HYjWejxnbgEEhZk
2082	fee_transfer	1532	45000000	1	CkpZ7BExR9vaBCcgfVhZCPuaA3xHN7RU5hYVag9jCq4hDz42yCyNa
2083	fee_transfer	1762	30000000	1	Ckpa7u4PB13nBm2cphsVPfXe72qQTdsLGra7crrmGvDTRmMD8VkWV
2084	fee_transfer	1467	100000	1	CkpZXqPa8YxA9rdhcFGjCL2R1D7QNgTjT9M9Bxb7gXwnivdUuWsaQ
2085	fee_transfer	1893	9900000	1	CkpYtVfritR4P4fodJiRarUATuJJpiJYeg9cT4kAuACRcKX7nNMDg
2086	fee_transfer	1696	41000000	1	CkpZERum2xhkf945cUgrEtAajSk6WVn8ebhxkevJjCjAjC94sxvK2
2087	coinbase	1690	720000000000	1	CkpYuiTWz8o5ueEPC5k6WjHiy2URy3gCyQB8TxZNGNtQuwCAAUj1i
2088	fee_transfer_via_coinbase	341	1	1	CkpZqs1gsC1dGjB5RuwNcenmbXwHcVhjfSTugyAHibs2dDwHn9jhB
2089	coinbase	1690	720000000000	1	CkpaAzdAt1bwCYDPzBczUFaNYrMCHvgYuasYXRY4cpBeW2MhPUxuC
2090	fee_transfer	1501	400000000	1	CkpZHDeLqMhdroGC1T9gpBgzi5duGuADwDQS291cfrpqQRrzhLVGp
2091	fee_transfer	1439	40000000	1	CkpYzTkDGQZCPpHAHTgLStficCvrFmpDEa7NDXsqstKBtBm4tjHbw
2092	fee_transfer	1467	121000000	1	CkpYSsqMpmsZPvzWjRRjVhpcs8jy5z8VrJx7eKow4ChNq6kx4FBJN
2093	fee_transfer	1677	121000000	1	CkpYcU4zVtFCvh7iryJa4u2482usv2ZpkwXtwYHiqqaphkCSK4ANS
2094	fee_transfer	1555	121000000	1	CkpYtW4nUUCrGX7TZT9HrDAMuqocwfEf6dMqprVArER66UEnmw821
2095	fee_transfer	1474	41000000	1	CkpZ1U29XAFLK9h7UrnvHy41rH8Z9ewMWwMXdFDcfbfyWRsUoYQbA
2097	fee_transfer	1508	41000000	1	CkpYZhJHYZW6yNB6skigfaYkuqz2SpyxHf4zEmj46QZktJ3m4D8j8
2098	fee_transfer	1457	50000000	1	CkpaHN7SYguaYt1boCCxBxFz37ZbfPtjHqrL16xqdKXk8PLtCTNZa
2103	fee_transfer	149	11000000	1	CkpYhh9FQB5CEFTRUoJGksGRgWp3hACvtW4LaJLcNHtTRcSjPMPEH
2108	fee_transfer	1654	92000000	1	CkpZfiN7Jw3r8C9wMwWEPoeDQDFLDixKmeAMYcdYJtvX7UgeBLcSQ
2117	fee_transfer	1643	50000000	1	CkpZ2ZMxGeMBFMKbSLJiiPX8nW6WmoWMskmRU2HvL8EpTvVEdTY82
2129	fee_transfer	1451	41000000	1	CkpZqiM42PUnH2VRA1gRdTDgRnuw1j8ebtqu44KykgwTDkcCN9vHo
2131	fee_transfer	1709	760000000	1	CkpZfTSPCSawUtTh1WHhj5XhJhkA1W74MCaNy2aZfd5d6hawJowe9
2132	fee_transfer	289	50000000	1	Ckpa6cvSrykrBtbtvZzkdjvbDnDCiT9wW3DaBPCjnaGi3wU5WdKLL
2133	fee_transfer	1447	9000000	1	CkpaLhTWxLW15sreXU71FGm2KQEgyQT75hk6hi39cNh1tQAWEjan1
2134	fee_transfer	1709	511000000	1	CkpZmZ42MAAvQJw7csejsGDv7TSTzaLYXT3G3bB84g8Ev6prS5P9L
2139	fee_transfer	1634	40000000	1	CkpaHXFkjSLbzpNjHdBSxz5ANubv4zNhtCWA3cTXmCdZCVGcrreWx
2141	fee_transfer	1677	200000000	1	CkpZ65ZUSWnUJKW9h3Z36GZWMPdUbKmKU1vxCX99xMP3sEAv6P2GN
2156	fee_transfer	1685	108571430	1	CkpYtSTu1hvjkoUF3UHB2F4zPmH6ZqWK5SXe4aVqSKBuasp8Akm3B
2157	coinbase	1689	720000000000	1	CkpYXxYAL5pcvJBCtFnkgm5aai19mepybrt2a2dwHBVZ7LLPataFM
2158	fee_transfer	238	20000000	1	CkpYwbg6m7PA6H4aMxg3jUpHsbZqVWFAwS9LFtRJrxa6putQwXouM
2159	fee_transfer	238	250000000	1	CkpZUTqRXwZabr7dJxBfooPdAFaFBKqNrNkLCTUjFiVSWjt2hbbtU
2160	fee_transfer	238	1090000000	1	CkpZ1t5rotCp2YuqGaAQM7hNjv7EeLpbiERXk4TU9LZNW4YTUBYEw
2161	fee_transfer	1444	21000000	1	CkpZSQ6JpYdrhDFeK8WKjjnRp9kY6JAjdPY3sruFzdUDCbdukmVfT
2162	fee_transfer	1705	80000000	1	CkpYUyVRtqmTbHhkzWp9Ug7PTs2ZgqTibQJxRkyHTjYSYAF7fZh21
2165	fee_transfer	1740	31000000	1	CkpaBmv9ENqNQ7K433Y4HZP7inkwu99fHPq1qxo4EQPWq6dhSZvGy
2175	fee_transfer	1693	31000000	1	CkpZ94rcyaXVMzMRNAxa4us72LWkrN7Zj8edPcj2YrqkogfVKBWf8
2176	fee_transfer	618	30000000	1	CkpZKC8ZcB7fQDBq4fv8NDLe3xwktRNSZEjcw7BNN5xoEQaAJoEHJ
2191	fee_transfer	1547	11000000	1	CkpYmmrmYgmWyXuKrscEfHHTgNhVZqh4vXkw6BHcCLSjRNhKntP8D
2201	fee_transfer	1688	160000000	1	CkpZnfnM7Qx1gTkUbsJigbXkrJfgXZnDHYPNpo7eXSvJMwL6K7JPF
2207	fee_transfer	1677	270000000	1	CkpZXZNQrxiGKgYxPJojQhXMAED3kZaApW7BcebVGvLjYjKb3fUQ4
2213	fee_transfer	1708	41000000	1	CkpYTuaLXhrZtnjCo4EakEjY1smTiJLdzyecCsyE1c9rzLdEigxiF
2217	fee_transfer	43	120000000	1	CkpZ7td6bAfWsNUZ2YCz6ZusReP3igrEq6V79eQkjVKVDcWKT1wgu
2227	fee_transfer	1749	90000000	1	CkpZF214rJi3NVw7SZFbBxHbMyCpRziQmkLyjdELddQmcRGuWiWgC
2229	fee_transfer	1688	310000000	1	CkpZAT3PoEkQeQzDPpAX94rPpLsBkfB679PLJQd5jCZjbbQRqtGMQ
2230	fee_transfer	1690	70000000	1	CkpZVJjWpCa9kAebyTTigEonj9MY25FBQtypmQqfPBfzY7hhiW9Vn
2232	fee_transfer	1756	100000000	1	CkpZAoCdGdFiVqcPQiXxC3PsRV7w3ehiqr8kZyXv488gWgmSrNoeD
2233	fee_transfer	1471	40000000	1	CkpZ1VjujkQ6A77troVndeWNidsKJPYfj341Umm5J7BjoGHnoR19r
2235	fee_transfer	1402	41000000	1	CkpZnSsy6PrPe4MUMG9A19DJ5fujtEQgmV1mURtr9brttsDjj9sB9
2240	fee_transfer	1643	320000000	1	CkpZQSbEGbNxpziSx3b77H6eTaM1SmogqhNRJvqp3a1ixTxJuzRXj
2241	fee_transfer	470	140000000	1	Ckpa8QyiSURcwSJxSx55V5wbGA2uheAvmAhiH1YkRRp4vsqbfPwrT
2246	coinbase	529	720000000000	1	CkpaG7xpxUiu197ApaBenhKFv19jviBKTvFQt2tDt8fgdVF2bqkvv
2247	fee_transfer	529	30000000	1	CkpZhCu2URAkNKms5vkJjbMELVpGbDAmpchNPE7i4Gnsvq2F1VuQu
2252	fee_transfer	1677	51000000	1	Ckpa2eHBQMy9hh6ZumXvp3oafCjwGUhijev27ZJuoHkTSutsc14Eo
2253	fee_transfer	1559	51000000	1	CkpZgqer4DALv3frjeAB3Tc6kPHbjWZkJHAUSAcUzHPo24KaKcGS1
2263	fee_transfer	1677	162000000	1	CkpZxEuJsQQxJoMLo3XK47oNGwdjdFaQb9bsrgB9429VoCL7FYpnu
2266	fee_transfer	1717	400000000	1	CkpYryfxxsxPnQeG6b6x6N9GMXW9zXHpqhqW4MpcnWxuTWZq79iii
2270	fee_transfer	1729	61000000	1	CkpZwy9nivgAP3KciSLyscWXewMTFKbFosZfuQkPxuFrbCqC2bugw
2280	fee_transfer	1704	65000000	1	CkpZuSWLctqjZV3MiqEPxRnQhEpKyxKJFppSbUgdgi8kxmQAWBxEa
2292	fee_transfer	1656	22000000	1	Ckpa3eatP6YfN3NkCviDhwYbVAJp9wBbhjneWynivfmXLiL3DKJ9o
2296	fee_transfer	1688	51000000	1	CkpZPjCyjLxLBGXSKRvebJ1sKgg45nZaZA2pKrTEpk9TB2C2uVDah
2298	fee_transfer	1679	51000000	1	CkpZADfDNk7NonzBESMxJk1vpNA4SViDwviZsmMshsXj9iFvnPCzh
2301	fee_transfer	1685	27000000	1	CkpZtnrCNfBr77229WZ1ZeT1tyWwc8jYm4kwQNWkRXWfZ3HVuAWRP
2302	fee_transfer	1685	13000000	1	CkpYUWQLGjDSabxoyVHjAJb6vQ9bYVQsHzNugJboBw1fwDME3z8RT
2312	fee_transfer	1943	20000000	1	CkpZYW7VyUQsByvVdbSVNtFMAacetQiEWhHTXcVpGJnqKnwYpaEAL
2324	fee_transfer	1549	60000000	1	CkpZfqBvTWmmBWzv8YNbnXPd6yKqRGJU7g9eo7M3ttNcUstVvHu6R
2330	coinbase	121	720000000000	1	CkpYUWoBNBAdagFHFSihEPo3dFLafFAzb7oPdwr7vy7qZSDW8s6F7
2331	fee_transfer	121	10000000	1	CkpZ3zBudVFVUWEia8mRtn3o3138LCSqUuHeYAihZHPYdX4s7WAp7
2332	fee_transfer	1623	41000000	1	CkpZsUYSNkPQCvx7ZW7NZ5AJqXqd4mn1J66QgEq6ABpF2yuCV6wfb
2096	fee_transfer	1559	41000000	1	CkpYuhJ9fCZtSXSVFiPdfzWpnC1pNUQxDyxSAmR6mu2a9JzoYQVMh
2104	fee_transfer	1611	440000000	1	CkpZzHNNCxyb8cx91yYGrNFN8U2GpgGZv54EE6otoGow9UaGXVgyw
2106	fee_transfer	1536	92000000	1	CkpZeRBCRLyFG1XZetiKMPUUEU3VFDpZ7whBNFzrDLxiPBYXrqVNU
2109	fee_transfer	1637	92000000	1	CkpZngFUC2KLEVCgkLqDvYGmZNVij4HKBN3rcmJH5fPiog8LJQydb
2110	fee_transfer	1623	206000000	1	CkpZoDxvTcMesFjM3GXdVso7VTucefKghv3nm3pufnxLhLGBCBgMX
2111	coinbase	621	720000000000	1	CkpZ3nFosJ7R6LXwNpbNQYkicMMQkyMpRHFmY9kRrYpruKKpYAtrQ
2112	fee_transfer	621	10000000	1	CkpYd842SLsnfSKGkx4XtvrpPiEFyjB7iy9R6PVfWkuRm2aBcnDwF
2114	fee_transfer	1679	8980000	1	CkpYfGgoqSjVhkdQUQmE1QAbJq8JQNw7ZHEE9dYsM74TdPpyY5gAU
2115	fee_transfer	1804	1000000	1	CkpZPmQdN1qATNjpnM5GUVTJJv2RZEk9eF7MopK7hA5fTRk5mj5Q4
2116	fee_transfer	435	20000	1	CkpZzZDWaQqr51XmD9eUxVU3SjbfihyLqSmMWXuN2iyEBUPhFdfM7
2118	fee_transfer	1719	50000000	1	CkpYYDrzd2S21W5bckfeoiiDh6VCYMVNWeyvvnua6PXuLVBNCUVhW
2127	fee_transfer	1691	40000000	1	CkpZW63eLtVgGgUHk7KXQtYoM9rjbWpFQe42YWsCx7cRMRotKvWUG
2136	fee_transfer	1650	80000000	1	CkpZGTviG6x97AtWF1ierB8mfyH6Rhng26FauwxdYjPAfTBjUWL3J
2137	fee_transfer	1594	40000000	1	CkpZbMkDkNe7rJTBo7NDvwzyZgqv9N5c2Yzc8SLrSKWYtatENdtRT
2138	fee_transfer	1601	60000000	1	CkpaKPyFNQGu3bjsoYyHQ5YJkgtkutbjGQWmxUYHkwndfVHWy8Nfz
2140	fee_transfer	1681	30000000	1	CkpaFvbinz8xMTEQnm1LUJRSry3UR4kkfEKN4aNbn97FWbbiZofU9
2145	fee_transfer	1683	180000000	1	CkpYqhs7tSSGS67JpevRFxvHo69K21kjrhYUgaCyo3ZLi3yR4XUS6
2146	fee_transfer	1719	430000000	1	CkpZffWrZViNYChdZBPEuruHXmJRv8DD7FzMDcgM8swNWpf5v99kk
2147	fee_transfer	1719	820000000	1	CkpYrmQYNeK6V1adyLMhpJEccJsgEZxew1t23QocXoHQYjbqbN17T
2154	fee_transfer	1698	80000000	1	CkpaGmaXLnmihWmsj1KUChvGGBZsLjsGd7xmedjeNRyaNkEXXTuFD
2173	fee_transfer	1688	61000000	1	CkpYieYbTx4RNUp7mddS26AQ2GSsYAz1CjzxYjrUcXkfvxWsvbFN2
2174	fee_transfer	1623	150000000	1	CkpZwhUR5e9KPa8twFFoR16rDHn32tunBK916nAiazfYjtxhmjouR
2177	fee_transfer	1719	520000000	1	CkpZkpFsFADkZGzGguKTC1vc2iBgqKfSphaPeqJfk9qhGZXcivGJk
2178	fee_transfer	1719	819999999	1	CkpZ1rtvB4D4zSvasRZPv35RWRreF4YjydwZombAuAANgiYy9ouC9
2179	fee_transfer	1870	1	1	CkpYb1NzTcRYNgE9H97NqC3GfJtqRtTUKjtpA4k7nASgjojdGiJNN
2192	fee_transfer	1688	41000000	1	CkpYQCfGAFciCZquFBM4x8BVg5jNtKHWqxEcaYVRNVqNiRrnBKaQ8
2194	fee_transfer	1440	252000000	1	CkpYvFx3hwxkkT3mcP9uWEtqB949on7QC2PtGhb81gegjN2zdeUAR
2196	fee_transfer	1764	260000000	1	CkpZuV1nDDcwKvtTEk8kErffniTCzLmyJDkDXKD3JDEE6vzDhTzNN
2202	fee_transfer	1683	160000000	1	CkpZrdXq4M9nottJ3zuSPfguHcdV4ib4Dbc8aViRDv2rv3xPfirRu
2203	fee_transfer	1447	290000000	1	CkpYkkHdgXC2Cma1NEbuK4MmB1mJkEVqiYK89g79w8qyKpeF37Lxz
2205	fee_transfer	1746	270000000	1	Ckpa2sNFd75qh5FFgNsNknHg7GouNbp7VERKSLdYu9S1ndQtSTVN3
2211	fee_transfer	1474	150000000	1	CkpYZ4jvqP9HUnML8fz9HYscZPmAdoYv6ZxFFxy7BHPbmVomBQSn9
2221	fee_transfer	1688	42000000	1	CkpZp2FrBYyqLsyieNG4B4hcqTPE6fcrXBvavvQUSg8fRkBQJk4pZ
2223	fee_transfer	1727	23000000	1	CkpZWmq7HXT64fSKmLhA4qS8sXRJR6n15tSTHndpp6mSikPXMkCwY
2225	fee_transfer	1705	90000000	1	CkpZAQuRFq7husN6kZ8eWAT7FC3VtUQ4HqSCqBgyqCz7g783te2ty
2242	fee_transfer	470	170000000	1	CkpZ1LwawAv48DKgcn2wKxCzszoZZxciMbqyB89YXc6e83oQ2wKQE
2248	fee_transfer	1982	1155000000	1	CkpZsBMjpeycmipSdFmH3n3VHtdDWht3sN4CDmk1k9WFshJRLJTfo
2249	coinbase	1982	720000000000	1	CkpYSrTskWYC63GVtq9pZuK4T3Bc42VZtBvH2oC1DcBnNEyLTUhjd
2250	fee_transfer	1982	41000000	1	CkpYkxGZCKnuSBENGFmW8aL2YFMP7B5JoG2LcfpVrvKqxRgZLUF4H
2262	fee_transfer	1688	162000000	1	CkpZ3xJ8pj4D7kWZMGLuzAZwNE9nW28x9zgUfznXp2tCuCRdNrq8X
2264	fee_transfer	1467	162000000	1	CkpYxeQcmkkdxvVN34zJZ319QcKouEeSD6KHyavUGESrhB9YcDUr1
2265	fee_transfer	1677	400000000	1	CkpZZrfgEfb9BhSn22zNnYz7ysyWeMT1RiDs6KsKYTxfrpZA8zj7w
2272	fee_transfer	43	22000000	1	CkpZLPbME1XihosC1qynpvHTfGXNAA6aUL2zsqtNdcY2H2JSV7QUs
2275	fee_transfer	1440	1000000	1	CkpZww7pQUCGWDAqzQ79hg5HYJwa8DyFCeJ16VWuRDJPBt2yAnrkh
2278	fee_transfer	1747	65000000	1	CkpZfqDibRZzNLAfVLcEe56wPsRuKfjo47q3tjsUQgecKQLbammz5
2284	fee_transfer	1587	13000000	1	CkpYYWXUzngKEHGEVUMESWuyJEMm2dCd3fwjnQpLunv2JrdYXrq4H
2285	fee_transfer	1588	40000000	1	CkpZtMssUA3Ue6aReu7EqnA3m3yviMx7rK3v9W2uJhzNZJvb4JDdW
2286	fee_transfer	1933	30000000	1	CkpaLAfHXosZRu4QNbjHr5Z929HpwqiZ7aWjctMeQ4rakQApP3pUs
2287	fee_transfer	1933	40000000	1	CkpYhTxruPKcSowSzCrdWxM1RCZJxmcBxdLNGaR5NPhv5quLgSdZE
2291	fee_transfer	1684	22000000	1	CkpZr9txZrXnoELZkABdMzqDbprcUmPwGeKX1iB3HhUFzYPQi4jfp
2305	fee_transfer	1692	14999999	1	CkpYw2fbATQqCHBW13hrck4qY8Sfhm2q8tsfvb9HDUYUcDe1FkHYh
2310	fee_transfer	1692	70000000	1	CkpZQUXajC1Y3YfdThMhMGFFesJvaVnfhBz6aapq265QS5XQg9NCZ
2314	fee_transfer	1688	70000000	1	CkpZfXwFvWEyFoZwrm3UpYnYo71Lx618v6uBM13NqSWsz6S6sf8ck
2317	fee_transfer	1700	21000000	1	CkpZzxpvinNYi1uiZJEVE9YpgLNEe3CchnZUYbQxMztFAgJb98VT2
2321	fee_transfer	1594	320000000	1	CkpaLQWQLA3kvijfSZiXPsMJXP5boXJ1zWtPZWFt7UZnRZiVBvp5d
2326	fee_transfer_via_coinbase	152	100000000	1	CkpaFBMwPQF9hQXmh6Kn7BUAQ2erwbWGXy41feW9M8DwzfTv83Fsh
2327	coinbase	1637	720000000000	1	CkpYXxABhQLdAA8SsP7Vn7UaWTKrpTfDNdp5rpCYqFSMN817BzRQU
2328	coinbase	1584	720000000000	1	CkpZNY98Ct4XWaFBhhwiCe4EBKS7duas9KcsXAYMBuGTA61k7VptJ
2329	fee_transfer	1584	10000000	1	Ckpa18zD4fh29pRXYDPS6Mue3xXczdAvmYF2e6oVU5uNbEjkJR1u2
2333	fee_transfer	1637	121000000	1	CkpYSbFKKECC2tbZmKzfomjPX5ih7uuD2g2R1dYUDXbfR18kRaeQj
2099	fee_transfer	1467	110000000	1	CkpYmEMbvD6Ja9u8gw1P9sePozkXGC8AbVxUfhw86Dick3SqkqjVg
2100	fee_transfer	1728	9900000	1	CkpZq8c25pnibRDc2vxJZozGnt7NLT9zG5wVMV2hMVTqyBnmjPGq7
2101	fee_transfer	1764	30100000	1	CkpYbVuA5FYVoVM7f41NYiskmbz1HDt1fGY7XCic1HU6mX8WKfZTs
2105	fee_transfer	1762	70000000	1	Ckpa13Fqb6dKtKweYHYAPWBmnrWG5gfb9FnuwXbodhvVkcigxdXUF
2107	fee_transfer	1683	92000000	1	CkpYbdNLCrDqnvUDYbyKmh2czaAK12q7JHg7wWwHc973mrngiq41S
2113	fee_transfer	621	20000000	1	CkpZJrcjgSjFY9sq5FKaw62HGFjqt2yiPauRKbmADo9MTjnnJQbJ2
2119	fee_transfer	1684	70000000	1	CkpYwTkUENufLrKeqCqnFzQdiStGc6hrwHpW3TQaYoXUamCTvNcZ7
2123	fee_transfer	1690	60000000	1	CkpZmJy9VGYtNHM9otP8ifcdTzJKK13FimEp84kMsqsdsPsPsddbQ
2124	coinbase	1723	720000000000	1	CkpYmxZj2Je6CSBj6wQZGurQQVkNX5VVuzcbRzhtwjnR79uLGquqw
2125	fee_transfer	45	230	1	CkpYRagbgvFL9as7tdHSYN8NA2hx9jSB5N2MyrLGzZvESTk1RjHMg
2126	fee_transfer	1723	19999770	1	CkpZxNZ4pjmYAE1EvKdD1CueAmymiyHibBpvZBnqjmZtTmbV2Ai68
2143	fee_transfer	1608	60000000	1	CkpZwPqbo6xDWw2gSkbpWU36pLs5VwEJJjuPsB3fC6RFvVqpvZCBh
2144	fee_transfer	1608	180000000	1	CkpZokpg9E3TwPjiso7P8SNFeZctoY3Mh47KmpJd3xDqGagGvv6Zz
2152	fee_transfer	1654	80000000	1	CkpZ3KY1ZG2Tx85FGK1iKM9wajXtzJp4Wa5ThRnVYXRp9q8Wqp218
2153	fee_transfer	1685	80000000	1	Ckpa49d2TRkED1PoDuou1LoHS1t2adSXo9DdztuJYPumNNioSXq9A
2155	fee_transfer	1686	90000000	1	CkpYRKbSbtgypGgkvSWd7D9Fy9oBip8gSdCQHNYiKwN5uZTeGvuMd
2163	fee_transfer	1643	80000000	1	CkpZsqgYHgr6ApyhDZq6zaatFef2u9BjLUmi2sqH1HxzvMDmSdBpP
2166	fee_transfer	1440	21000000	1	CkpZh9GtAtvkK3MwKMcFACochvsrzuS2PWkprUqXXPWTutk3tokVm
2168	fee_transfer	43	31000000	1	CkpYfDirbWnkTxGdUcLTpDgCSgwbuyuhz8poreJ3zZtBJXQtfAA5c
2170	fee_transfer	1759	19999999	1	CkpZwBHe5FtHWdwqrA2yvidL8CPNMTNS1Y87V4dVE2bTPMcjn93fP
2171	fee_transfer	1807	1	1	CkpYrsyt61uavNV9VdZrNjQMA1rboe7fJvCngkUsAMncgDM151BUo
2180	fee_transfer	1739	40000000	1	CkpZJEYrNuNCZJWMLN1VSN78wTzNyZX3Ev3tvp8Jkhte4iCmdCPe8
2183	coinbase	1625	720000000000	1	CkpYhmXAf6MdA2kBN8EkkXB9mbpfEJyLNFGEPnxCtykGBH136Ao37
2184	fee_transfer	1625	10000000	1	Ckpa6LCQyJ6Rc7hnjmKarnyj8hYD41PRwHpe19njAKLq6rvVHDKdS
2197	fee_transfer	1715	270000000	1	Ckpa9rTaLxNMSkXjHtexi6YeJoFfavysbT8HD7mHC5b5aZeWmMXz1
2204	fee_transfer	1611	290000000	1	Ckpa1k8UdUPGWqhsBx7Wti4D1Pjxs6JPUVQDMtj9DjNzneWeR24Zv
2206	fee_transfer	1680	270000000	1	CkpYcpNUb8MNeq5CauQmSuqQJKunNM7Tdh5efKyTqLTCzWuhvTBJC
2209	fee_transfer	1747	270000000	1	CkpZAQj4TyZ7BP4jS1wxbfxQNWpwEePtu718s3bR1cYr4HVNc9BWN
2212	fee_transfer	1768	150000000	1	CkpYxhgxeSxMY1QfubDEjH7FT1nbxjtxT1s7UhHdb1iAPfBmH2oNY
2214	fee_transfer	1672	131000000	1	CkpYkF7tiFfCZUPHP1A7SaQGLtE5FQryGNhsgqqcz3bfzSpEYmmH6
2215	fee_transfer	1451	140000000	1	CkpYQHEWCqUL5eVeeAkTPvww2j9V3YTVWy4rfKuorgh9iTkSG7snR
2220	fee_transfer	1611	81000000	1	CkpZUEvPAMdSgiPuH3TxayEf2P6nnho4AfeHNGesABEbapAX1Gt9G
2222	fee_transfer	1596	42000000	1	CkpZvRxK6rAUvdhMMn12L7NDVKL2q2BZ4WdTCR5C6No3crjchx8ev
2224	fee_transfer	42	23000000	1	CkpZ4ocQJVuxN38Cqq8D5eqisimbNm1vktEAF7oxoW2r52rsbaVcd
2226	fee_transfer	1474	90000000	1	Ckpa1CpQSfuz1N5dugngNvCPUpb7MD5jUjSgDgmXKRWhgRUrn2Vi2
2228	fee_transfer	1623	70000000	1	CkpZ5AS5eQrk2A5rPz9E6wuSLihmoabDYQhNqDbhKcUX3qYMstjwH
2236	fee_transfer	1759	50000000	1	CkpYxUQXQbq18g2PHM81U8maiCC2vDdkZkaHR38jysTrC8QWe6FPJ
2237	fee_transfer	1708	60000000	1	CkpYiw3SeHvRhwpCv2aCynwGCRbqepfSTbtFyezkUeUm2Pb7s7vrQ
2238	fee_transfer	1749	60000000	1	CkpYpniirh9EyBGfKkKmypkLLfW8uN12aVxHhcboZWsZCQSMDmHpJ
2254	fee_transfer	1467	2110000000	1	CkpZ5GhgHwhx7uK9kvZQ6xQbkrkncJwDy4ARYtCgwnykxun1W2hB8
2255	fee_transfer_via_coinbase	1949	1	1	CkpYbZWmxfHTMPuTgqxwMivgmQeGwyWmBaHoJ374N16vrMEa6j93H
2256	coinbase	1467	720000000000	1	CkpZPCgYtBTM6o3UL7qVnE3vEJoZyNa1sehk75Wxy26dtTQse5rac
2257	fee_transfer	1567	13042021	1	CkpZMWucNfYMkSQbmi92ngBPywZLUj8JwXicXbvVt7bDH5B6fDfin
2258	fee_transfer	1467	3957978	1	CkpZX3PHPTooomgCZg6tdwQu4KUkpWNCJn18hn7rGEcPxpqgTx2iQ
2259	fee_transfer	1949	1	1	CkpYbZWmxfHTMPuTgqxwMivgmQeGwyWmBaHoJ374N16vrMEa6j93H
2260	fee_transfer	1509	2000000	1	CkpaJCX9cPPUqL3zbQTgJL7EVZ8er5mKnXwRmKTDyJsL7Tpwaet2p
2261	fee_transfer	1681	1000000	1	CkpZJCCUy8CHSsNimjWLWVnXnc3QkAXRxqYhscoCopWSboZGxDJrU
2267	fee_transfer	1594	400000000	1	CkpZWLgZWwhkL1ZHbftJzDnp7SSnH6xuT48jGqE9KZSHdix61y2gE
2268	fee_transfer	1656	121000000	1	CkpYrdNRFTLYJv47B6dqDiTSEHNkTe7Y5ZuCCL5pJctQHkCMKNcUG
2271	fee_transfer	1419	61000000	1	CkpZuqRWr2msgCUjpRbk5jBJXJNcoV88wpA898yoAA4EWuPoaoRBq
2273	fee_transfer	43	61000000	1	CkpYSY8AuqgufDtWdV7zuXjy866Jzvs2FKg1X9cTFcGfZDpPkdSsd
2279	fee_transfer	1746	65000000	1	CkpZ5mma4Vx9ikrqZdemqUP6it4s1iXjrUFuK1DVvSzG831esZY53
2281	fee_transfer	1637	65000000	1	CkpZ77JR6JxMHaDf6E2D74r2RNL9WjDmB5expsJhmc1FytZxnnfi2
2289	fee_transfer	1637	590000000	1	CkpaFdrwW4gnZRgmEX1Z5ziVEsvg5LQ1QLJ8G8uuzeobgerQbhMQn
2294	fee_transfer	1440	27000000	1	CkpYyHRuhkYWqAE8kxfLgXjvdjro9x2kCFrHmiaqbqbwctnUyhJfy
2297	fee_transfer	1402	51000000	1	CkpZdiDcPpBksfuwmYWaZFsNNE1F4yEeSAdoyiAy7eEvTmkmP8oX2
2299	fee_transfer	1439	27000000	1	CkpZeemX9bcpmf17Xd4DsifmBdwrZL5os2WMPHAaUvwrxx4b7vtA7
2303	fee_transfer	1439	1757000000	1	CkpYyvPG4z5Xzzn8qKkQKmAnXcsXQcKNvSPm8FHeJ1aA5CoDSpa8t
2304	fee_transfer	1439	44000000	1	CkpYXWXsbNmhHMqquSyqhJGFUZrX16AFVSQ2ziTopRSsH5heLGJR6
2306	fee_transfer	1688	149000000	1	CkpZRoUNGcBAgosrWfcvSb5Q2XZkqCMXR8CJXZWfouGRKm9HbAms9
2307	fee_transfer	1693	161000000	1	CkpYp3MVy2ZS73Ri7EKMBoMqhuWpbyc1gQNZVhcibcUfqendKNtoE
2308	fee_transfer	1724	1286000000	1	CkpZJaFwUpbhwdJDgJHhkSzpVoyaBsFb5qNwxJD1s3e2NxNYGQaW2
2313	fee_transfer	369	70000000	1	Ckpa53goiBHbYhpX4MRCgURkxUCsNeB1y5hkCGo8ja98KLgB2QiCt
2315	fee_transfer	1702	40000000	1	CkpZxRjaoUySk5f36THMReLF6toxMK25gAfxszP2t5LPxJJFoVaZe
2318	fee_transfer	1564	21000000	1	CkpZecRTwMsVcvsweTRd3XUmwoG82SzvZwU2coYZQNS3kjs968dmo
2319	fee_transfer	1762	160000000	1	CkpZFD2zWLWHaup639GVRxw7w127ZSXwQ43MnqCYJ1W2FcN848FvM
2320	fee_transfer	1596	320000000	1	CkpYRgCyCkhpeRmPiFkGj8JLEmdGoEzB5dLrrmsgNcjqLfyvsLzeD
2322	fee_transfer	1670	70000000	1	Ckpa714idM9wfrSr4cFNyXQcgzWR8K85NLZv6PoW4rJ9TVUwjM7bm
2325	fee_transfer	1715	60000000	1	CkpYscmiDVvRGaiTgM1Aq1Tdu9NHA3aWmDVPvHMi9XnSZqPvKhV4h
2102	fee_transfer	1457	11000000	1	CkpaJzWHGbtMbZA3ZfSzc7qaHNn1ajNGyngg4gVYjL8UigEk7MpRL
2120	fee_transfer	235	20000000	1	Ckpa54pjRnnj71YNgabswJPoNwVe6ZEDCtxrffGkfh1qmdV3PkSW2
2121	fee_transfer	1723	80000000	1	Ckpa2ZM274qsJQK2tHKS8GHoztW8tB4w92C6Pip7K1EB8mzaLa6Vz
2122	fee_transfer	1555	22000000	1	CkpZkKVV1w8Rm1tDPKfndjtscR1Q65NCZm3rSPVVkHBrQ2uu5D8rL
2128	fee_transfer	1623	3000000	1	CkpaADJKZkdUuRpBc4WzkYsVEXiDRGvZSpWxXyR5wMAiufEMHhLWo
2130	fee_transfer	1709	41000000	1	CkpZpwNrZx4q6qav2Tcin2zeJnGRGugm9M6UcwRFtySEHcsTcSFPF
2135	fee_transfer	1434	20000000	1	CkpZB1wDGJ7V6h3sqtrrYD5QyA4mUUyWP4fPEPCEgFNNS4aq96haV
2142	fee_transfer	1729	160000000	1	CkpYTaHvSRRfsjuAZEwVjJmuPgBTfTY2UbYUwLGa6n1ZfDDpjkdkv
2148	fee_transfer	1719	60000000	1	Ckpa78o2Va3nzgagyxJWXNe15dpdD7WBC2eL8BFN9tLYfAfjf9pJD
2149	fee_transfer	1719	180000000	1	CkpZRvc7D1kz1V8p8nwwpEEnipquyZ4upfqVSdRAUeWvjeL77WtSW
2150	fee_transfer	1700	70000000	1	CkpZJLLrCuxFFtofAek14ejeW6wy2b26Fo1q2uUdBb5LuzcqLdtwt
2151	fee_transfer	1679	80000000	1	CkpYUdwA2DSsc5Vrq6BywowF9oyFVectVPVQtS2sAXp2vfUBSUEs4
2164	fee_transfer	1607	31000000	1	CkpZ29QkZziiaM2b6BLfszoPy1Kv2VcUxX5SK9TnkDBug1pdqNzy4
2167	fee_transfer	1688	31000000	1	CkpZd32AxqeCCNaJvHrHC7V59SnB83MQ62ApJ9VUqMYzzEPktY9j6
2169	fee_transfer	1449	40000000	1	CkpZMiZqu2skoFZNMejnAdgiuK92FVRss2warS6zUQMpUSaV2re3n
2172	fee_transfer	1708	31000000	1	CkpZZM419xGfrjxU1zCHZ7VwQ997Q2SXA3KgDeGd3Jf8YjuYT75Es
2181	fee_transfer	1633	70000000	1	CkpYdpgWsJxY2FKwcTHAk7rnguMQNyouPGvr7BukKqtMLbK11qAcA
2182	fee_transfer	1685	100000000	1	CkpZPet89uBGXZCebVAWu1ojJDTBWevQiiGLz4bZrRwZcbuDE57Pu
2185	coinbase	1603	720000000000	1	CkpYoULdbBei6hq984xGMnYjwt2aosjqPQxSp19nGNf72Z7Mxi3Lq
2186	fee_transfer	1603	20000000	1	CkpZXH2cBqXckLybwtsTqXGBiPNbtsPcMX1FshzRt3w8G6kp2Umxk
2187	fee_transfer	1625	40000000	1	CkpYQGmu1WQJNWG5Rx2iyQHNBRVBWCGboig5U7Gp13KJnvxiFFsL4
2188	fee_transfer	528	380000000	1	CkpZVNXaSVrtoFg9mWmzWeHcbW22Qb2fhXbq6EmfxdhXr7CQQN7iG
2189	coinbase	528	720000000000	1	CkpZmi4a55HhssRyJhhaQVY5kkzqQCQJntC6j745GsJgJ4FZGyuaf
2190	fee_transfer	528	50000000	1	CkpZYm14WUD8fcFfxcCxSnSYBbnD6ju38hyKNA37zp8Si1h49Qizu
2193	fee_transfer	1467	2000000	1	CkpYfJRZ9v44Bj6ALt2reykdXVPE7We3D3o9uA27qutZr3rQhdzc9
2195	fee_transfer	1764	270000000	1	CkpZPwcYPgNzU7wYgRNYgN215czw6oibSD1Rm1WdmtPsDajBfvPmG
2198	fee_transfer	1513	1000000000	1	CkpYZn4PXvuPmZgLmJw1jWEBJyP6wueb3rjZkFPm9FgxZVowdScSn
2199	fee_transfer	1513	580000000	1	CkpZSYub1TJmzgoJZr7TkyYZmuewyGC17tAfMhaQApEtM6pKqsYJ2
2200	fee_transfer	1718	30000000	1	CkpYsBQLrCFtDYXFtDHAqcRuRibPuqLAQGTPM7GUKutHaJhRDdChL
2208	fee_transfer	1704	270000000	1	Ckpa38wjbdF3yGJxUAXRm5tfDzciENGUSim9wroi9LfCohroVny4g
2210	fee_transfer	700	150000000	1	CkpaEc2wRgmXNvpMLnw6tsubKRsAc6NmfP8kA994eombye6cEhdqm
2216	fee_transfer	1447	140000000	1	CkpaHTGjxqL9rqRbZLXzsuNEzrSFDC4GP1jjK5GWRkZtSr8jpLB9D
2218	fee_transfer	1688	230000000	1	CkpZ8wpRcG2jGt7E5wLK8E5VwUAnxwg7KfZgnqB5oCrvyTBYWeXSJ
2219	fee_transfer	1422	81000000	1	CkpYWsi6oasPiYT9vjsTUNCs7Bn19fKJVP9BPwZkt2PNybo67VBmR
2231	fee_transfer	1650	70000000	1	CkpaBLADvZN8en8KTa793A52Bp2BaVnxegA83smFG8PfgUygG14XB
2234	fee_transfer	1447	30000000	1	CkpYRtb1JtDktcmE8E2Aw6GwjukDuuyywHrFD9aERB4m66HezVKVa
2239	fee_transfer	1649	140000000	1	CkpZm2gihMJDFXU7poqirMAaRoS62xRoEcGroVRcwePkUst9VD3Vi
2243	fee_transfer	1634	80000000	1	CkpZ5tRj1cWSjwoDcmopKpUiZp3AEPgmL8Q3o8VEgGvBrDT3j4XFX
2244	fee_transfer_via_coinbase	1539	1000000	1	CkpZppxUkuN2QDiQ5Uy9Brv6egDzu8y8M6gJdy5ErgWdTS6hY3Sof
2245	coinbase	1634	720000000000	1	Ckpa589cREJkFaWZNNH2DNzi8bzBRyFNi7VbWzwQc8SbHByme7CVE
2251	fee_transfer	1719	51000000	1	CkpZ8i3JGTKYibeQw6jRrFn8cWLN11tWS3azXjF4tASZTSHyafGaW
2269	fee_transfer	1564	121000000	1	CkpZyfdS6fVu2mFELpprhnPe44M6ZEiwWhbQMruzCK1qjtJ7qRaZQ
2274	fee_transfer	1683	61000000	1	CkpZdLTHCEmUD4NjTUnc2JUfzeNoqHYnwaTBcXg8sgfTWjxCnDFWD
2276	fee_transfer	42	70000000	1	CkpZxgTiAtK8d5QPb255dEYzCf7pKJdUCzosDKS138Tmad4FmsFX9
2277	fee_transfer	1608	65000000	1	CkpZdoTNAz8sG8FeNU2QJeTTrAsLgLWgNUzWJXs7mqoK4waeMoSu1
2282	fee_transfer_via_coinbase	1500	1000000000	1	CkpYcG5jVGdPQfnRunWd12PvisYcjr5X43C49UCABAfNTkHsZUyqU
2283	coinbase	1467	720000000000	1	CkpYQHbcp46f275tb4kZ8vruiTq9UhzKtCbDQCj6wR5dpLtGtGrGR
2288	fee_transfer	149	80000000	1	CkpZy2CJ3cVJpwbK9Td8kBewcGedfwNo3YDqw3QPoFrJiPva6KkNc
2290	fee_transfer	1672	21000000	1	CkpZahwB8N8bRHvF6vBjwZz4rwxVGU73NZcpdsUKZWJayD4baSMo1
2293	fee_transfer	1668	22000000	1	CkpYtdbVBY4zTeoVBhqAQqaoxLyDoUvkPwCSrTKujnyzQbm22jhrt
2295	fee_transfer	1692	27000000	1	CkpaF3NWb13GTdmu66kGYGcT37zHy2ZAZH7AQ853k5TAebBQZvbCT
2300	fee_transfer	1683	27000000	1	CkpaD5AkzwLJQMg2n1FjNxnXzdJAwxFhFy1fKHNnJK4FE1WV8uH47
2309	fee_transfer	1724	81000000	1	CkpZr8b28LVgwjd7p17ztMLMdV9viaGYzkWGNKf7tVdKr6eX2m9fB
2311	fee_transfer	1680	130000000	1	CkpYQTKBqzzsz1MgvGnadJWGW8A2mE1AUegSyWcHY8N1i7ML52hNB
2316	fee_transfer	1571	40000000	1	CkpZPUEKMprbnyV2un8mbrdqUVFJ2ku5BnWmVBNffYYx6jzJgTXfQ
2323	fee_transfer	1546	70000000	1	CkpYVS6V7ikV8ZM4kUDN2Xg7ZKTSt9YB2LDzJ7mWpAsLL9vfWdv4X
2334	fee_transfer	1593	61000000	1	Ckpa7a9frjWcwQHK9BGwUenPVbk3Dh3KmxbPM49uCdBoFdXM2jAvN
2335	fee_transfer	1593	71000000	1	CkpZSFuob5g4M6FMVUDJnLjfhhPWsyf7JPaiSJ1HjCwwp7nihpFHh
2336	fee_transfer	1714	61000000	1	CkpZbtJ3LVcQ2NhLL1C49n1h2TxqbQ5JCDkhDZY13y4ndsGWBTWPV
2337	fee_transfer	1508	1335000000	1	CkpYfbr2DcwAzCeSyRV1E49YLBG4HDmRH87XWhFEcqHwHpyx8N4Lf
2338	fee_transfer	1601	50000000	1	CkpZZRWTTgdTL2p6WxuxYh2vLhYhFZUHbr3huacUksgHbiJ4mtjLa
2339	fee_transfer	1637	262000000	1	CkpYZ6g7qNvCaECrWZGbU9tSsAZt9DYBgYtTiyV8vLcenpm9m7C2e
2340	fee_transfer	1693	60000000	1	CkpYtWAtoXRqE91Kkj1vm3gNVMrNttgfF4PJS77RnWWFWko6dRTJT
2341	fee_transfer	1701	60000000	1	CkpZRp9oGZZ2rfAhcwnETmBb876PJL9eS8SQnHcgtoC6eioPM9e4Z
2342	fee_transfer	1685	60000000	1	CkpZe29YoSHpZ6HMP5NDZuRVgDTEcQZxYp4YtYnYWpTt8dRJq9sA8
2343	fee_transfer	1654	51000000	1	CkpYv1GD11qJMrz2wsftDDm6YUgqebw85CkwWQXTN2EZSBoRmpNEW
2344	fee_transfer	1727	321000000	1	CkpaE6LaZPPf1bSR7cmhdrFPDhywraG3sHeA5zPSyCop5iuwKt64S
2345	fee_transfer	1643	1710000000	1	CkpaH7pGEMRkfsNPoDuHw77CSuHtqVQ7MezNW8dLY3AhkRhTrLj6L
2346	fee_transfer	1643	1030000000	1	Ckpa9bWbxUgj8M3aMYc5jJwKFpqcxvmAHPhX9W1c9f7Q6VxsgdKEQ
2347	fee_transfer	1649	11000000	1	CkpaFHmFpLzSntEtehFXJ6t3iXcGZKfLF5yLdRa36fLGLkjjktq3X
2348	fee_transfer	55	11000000	1	CkpYybGeK4ynEM2Fr74jz4zAqzg5DSmMmsQBWbvu6u7mw2suBDmwV
2353	fee_transfer	1656	60000000	1	CkpZ1Jkdm5X8ggWpseyfsdKFNVW86RF1ubJhFCHNMh2bFqmtXRKWE
2356	fee_transfer	1708	22000000	1	Ckpa7X1dxEGcSaTm7cpnRjZUPXVmgeUNsDMrxa5mkqhxGKdCFPEJG
2365	fee_transfer	1715	23000000	1	CkpZGcQEfVvSCa5PjEmXWBYBvnKoKG3sveJzqgJ2cesLAkuUJwLev
2370	fee_transfer	1599	140000000	1	CkpYoszhtuPGmJbwxbVJ3ygzk6bUYZq5K8nt6nNa5kFKBQKD6JbHq
2376	fee_transfer	1398	121000000	1	CkpYUGKCmNejGThexukZPTQch7bS9JzH47Vn9AtxJupT5eC1xUwPv
2385	fee_transfer	1448	211000000	1	CkpZfroL7icKBnFpFdUQdcjWkAKPkFut3tkuqU4R4iectFQH5upSa
2401	fee_transfer	1706	50000000	1	CkpZpxupE6r7W2gaqbLR1TFf1ktv8RCQ9htRzP393RkE9wwUvy5hG
2404	fee_transfer	1593	74000000	1	CkpZw41ykDimAL7Ssawy6isfEZiHFr4rzWkAxLdmyMiVwsPN5ngUr
2409	fee_transfer	1764	490000000	1	CkpZzdKP8Ut7y2fa8g711MA1AC3pPdfnSbyPg2DZ3hRUfNnqE8Xpf
2417	fee_transfer	329	20000000	1	CkpYx29VPQ6BE5v3MynmRpi2kzwucbmk4Wx2mBkgUhDxtFHbAJZSd
2422	fee_transfer	1643	1480000000	1	CkpZk1kyu3eHyhQ11EVVnCwyJinXUzF2HncPKihmiZQcAPm8k2qn4
2426	coinbase	2009	720000000000	1	CkpZVCUAoRbW4u1x1CmNsP5ZiPqWXwpaPQAWk8NnzKNiTRuzh8Pgm
2427	fee_transfer	2009	20000000	1	CkpaDFqavSdXjpPbhEhSFwVmQAiCMdZv8XmF8dKG4MWboyDFxSujD
2430	fee_transfer	1506	120000000	1	CkpYeNmCycFAL3DmXFT8BnxxtMEZLe6WXQVzEe8Ra7tDJVjZSEngz
2442	fee_transfer	149	50000000	1	CkpYdRahdZaGXxg1jyju92chi1Ph3QcMX8sizmQz9cPpr6nStW26a
2445	fee_transfer	1692	60000000	1	CkpZh5sRXG8m5p23JqYrCcuZJKa3BVxdhmhGkmTBQq4YnAfDWYNpj
2454	fee_transfer	1467	230000000	1	CkpYVpqkvdURdrRbyodX4M8B7o67U98MPPSDSrRvwPoLkwz8WnJZx
2458	fee_transfer	1672	50000000	1	CkpZzyt2wbtFpLSpdoyP4DzNBGMAbEiXsAdhjoB4cojFAHSwtinTT
2464	fee_transfer	1705	37409880	1	Ckpa34QFrrzwukTEg3VTjKvHLYpftNAvmA13BwPztmFF2PbNwoWQ6
2465	fee_transfer	1571	120	1	CkpYyRgD1vQg7roNSYEgueMzCFh1ci9aBUnDJwNgPJjxW6Fwamsn2
2469	fee_transfer	1718	60000000	1	CkpZir5KYvsJ3q8Y7GAr2kq3yo9T6LWmpC3L6PexSnuAD2xdieP7N
2473	fee_transfer	1602	60000000	1	CkpYiA2QBUKTF7iBPCcpya6Ytgf2Ybn3t15pjLbPhLQYbMjKGbwNk
2480	fee_transfer	1444	15000000	1	CkpZankdYAYp8mknPCHtVZG2bPvxnUv2yYe72TkA2qqhcpPoTpdux
2482	fee_transfer	1559	320000000	1	CkpZ6g8bmYhTiWezeKDWt1hFYuqWQkLt6Knpt8w6Tg5SdXcSVNb3T
2483	fee_transfer	1671	70000000	1	CkpYxYjdUhMppM7M79Mz5AenKRMfBfqcrEvU28KME2w3dUsr7Ukq1
2484	fee_transfer	1549	40000000	1	CkpYXmfDboBwmvrpSujkcniZMxBxpE5NHjVdLiVNeEkw658xK3PWx
2492	fee_transfer	1564	1040000000	1	CkpZoEazZnKkPK6TZooSqsUaG87E2xVQiefmSQXZc71WbG9s6zehh
2495	fee_transfer	606	460000000	1	CkpZ9BD9tzX2RNz1ZjTko4L12eNYwJVWP8spea5zrnApFAsTQor6w
2502	fee_transfer	1677	9000000	1	CkpZ8HMSUF6nuL7VUAEz9wM1UGDMvbKXJzi8DVYhRP5dTKEfR2oGy
2503	fee_transfer	1509	1000000	1	CkpYUJpEm6yxj3mhYaatef13bK1vUadW1SjTAkEnK913AfJApZaR1
2506	fee_transfer	1685	70000000	1	CkpYV84bRQjDabZtteuW4skB97n3RiV3F28p7YqzQka6QRAAUt6rv
2508	fee_transfer	1706	120000000	1	CkpZ126RAaLcMy4kioNZ9RYGc8iF1s4qaPn8v3cg1dfYmcVtvheRk
2510	fee_transfer	1522	40000000	1	Ckpa5rJgWdBo8rJDFSfNxbBgwhjTqyKMpCs491WHCptsg7S1PJZur
2513	fee_transfer	1489	190000000	1	CkpZfP4Vs7LdgFC2zuuz45QDMqreRq6Mz9MsvYofB6bW12NoavxTQ
2516	fee_transfer	1696	120000000	1	CkpYU8NY1acpK3tSQ8BZuEzxEAnFHSiSdM6Ud4S83wvJpu7imhpEC
2527	fee_transfer	1675	70000000	1	CkpZCkKpgMixPBZTMEw5mTET5hJyhZdb9aJ8PTXT69GJ65DuGu9En
2528	fee_transfer	1701	90000000	1	CkpZEfPQYo1GXLL6vHsWXu6JrtHA7HiG1SbTbKKq3oprWrHreAicP
2535	fee_transfer	369	220000000	1	Ckpa91cebm1MGXLecACG4Mf5ZF8HFwhPKy6vjMCyM31ci8o7JKv2Z
2538	fee_transfer	1691	90000000	1	CkpaHazVNW5XkMvERMqVhHF3ZoQSd6hmkFNSp6SsNwaPDqXayB75M
2546	fee_transfer	1633	80000000	1	CkpYfc8sxHGiFxMwQTy9uFkR6ZYJ4sRkEckYPt6vVinVbzwMNnWp8
2550	fee_transfer	1700	31000000	1	CkpZyvrBCEhJugKdAhD2oH3wzPnKew647MB4jmBuW9Dbn2jqeSJoW
2551	fee_transfer	1610	21000000	1	CkpZRXVPLZY5D1L6DudsXCVrNeFTzgLHkTHyhvhuq7yLCakrP8YaL
2572	fee_transfer	1471	50000000	1	CkpZf5mxGsw8xQxgir8nKu2vX9Erf4DXqe9eHfj6rBoMwhxcDFPFw
2574	fee_transfer	470	80000000	1	CkpYz3ZsnxLi6nKhXToK4AwtTK3oabo2sj5twMuFYYev6AGRvvMxK
2578	coinbase	1980	720000000000	1	CkpZUVEYjGLrqQRRQonjkGzweqL9A1Ggnd8zkJrkXKRSE9P6xBY6E
2592	coinbase	1472	720000000000	1	CkpYirCVW2e5dQT36mo6Yg1KA4qP7e1edMUzSMZT8AY6FpFQLzj8F
2593	fee_transfer	1472	20000000	1	Ckpa3KxHKhqhtAT99u19xTxWn9RZqsfPWY4sjuZGAm1MafWssA35Y
2600	fee_transfer	1690	31000000	1	CkpZ9pbAmi8hDAVApYdYCoQ2KzWsU2oaTiYij15Rqu4oWJe5meEfU
2610	fee_transfer	1692	90000000	1	CkpaGJmUFt1FyW8KBmYNK5PbWKaPBU1widoYh1hrqfswebv3RA3WF
2349	coinbase	564	720000000000	1	CkpZmHKbaK9jYMsDPa5e6Aq5bE5ffvJeaccD2zq6hBPiGRyf3AB5F
2350	fee_transfer	564	11000000	1	CkpZ34wKyLi2hYjJGPtxFjgKjapnjbLGVt5YTJaTyJSRCPaBnXr5E
2359	fee_transfer	1447	57000000	1	Ckpa5NhGHRm38ysS3m74Cxow3o5UD3MNxjrpBtPD7YJTshs8KpWGH
2360	fee_transfer	1689	22000000	1	CkpYqfRRwnuKpsDGERL162fdZU1pu1W74JZebvwdvQosyZoFZmBgv
2367	fee_transfer	1729	30000000	1	CkpYQ5jcokiiTns51341a9Bpr2K8zHTPb16uBqBsxZmDEXb43aFUw
2371	fee_transfer	1402	140000000	1	CkpYvzy2As6TNGRYhFDNiFL6egQw5yCfG6VmwBtSfWvVPXcJ81mX6
2373	fee_transfer	1593	170000000	1	CkpaKFfGjYExc7kzequTDrr3rDp8wo3peRzAghzohMZhBE9wBqj79
2383	fee_transfer	1426	260000000	1	CkpYfya4PEuoArrFCwTHmbkLs5nkQYzKum8MU4rEw5vodyRTMqrXG
2386	fee_transfer	1677	211000000	1	CkpZfvQ4nGV6fmtdJdqiB2KiFVtc59HXJRfoK9ndQRrfhsFoCKLZW
2388	fee_transfer	1444	210000000	1	CkpZbVqcwdq2bAqGQq9znKZsrXX3d5g4nyxJMXYKnefmcYVymBVF3
2391	fee_transfer	1518	210000000	1	CkpZNnTReoxRHm3MstfkZtBaR3e2FA7srqstopvSNrLae6jfKxbZ5
2394	fee_transfer	1542	100000000	1	CkpZQhcotkix1BLzUgtJuyTuEuzmK1KN4vfYCvmrg5nzF28tUgvEH
2395	fee_transfer	1696	4000000	1	CkpYfnvJKFqsUsb3TrqGhC4EB922V9rKXV16XZUMBzM1H7yvS6NQs
2396	fee_transfer_via_coinbase	1425	97400000000	1	CkpZJCcyqCUS5v93MKocrqCXfT4fm96ZA5gbjPDRaFbzqGhNuBkLK
2397	coinbase	1594	720000000000	1	CkpZnrN5sadWQKWPiuLfGGM2R6PorJCHU2Ye7yXWP8XJoShqnnTc7
2398	fee_transfer	1594	310000000	1	CkpZL5pxp2Vs5VP9pCTPaUqRAm7qtwNfgtxtbfbmrGQv4CcQXGugW
2399	fee_transfer	1622	190000000	1	CkpaKLSf65Xgm5spQr6CJK3Un8RNNZ3VthdguVpvFw4ravo6P64Zf
2402	fee_transfer	1706	1770000000	1	CkpaKrL17pQqS9ahobDQjyUiqo1YximYgWhJeeXLzH6Zk1annE7pt
2403	fee_transfer	1706	110000000	1	CkpZxkBD4qnu6dHjiLv6cm1f8MqotD3ExpkQDMEheqRcqoh5pi5U6
2405	fee_transfer	1683	74000000	1	CkpZHCwkrFheBMDL9xjLn8EWwn3taXaT1Wx7kHK25CobEjECbbEup
2406	fee_transfer	1688	271000000	1	CkpYhzauab5VdbZ7hs4p47pGrKj9urKnFjAR5W37E77gKgqKSDSTn
2410	fee_transfer	1683	490000000	1	CkpYZTfWFuq4HkVnVoWJv1WQo7bygmUUZMAhC2tJMdxgZf3f3wuyF
2412	fee_transfer	1761	14	1	CkpYZfBtLaFE4sEQwb4iqCvhG61rpdYAvYJKptQMBfVrX7uToBvox
2413	fee_transfer	1706	11899864	1	CkpYxmLzz5KrHnzP6jkmC3LHLWAQWA98fuBP2j2BAzhmLEv5tJSwf
2414	fee_transfer	2000	22	1	CkpZaFy5NXYqaGQqHVuvzu2wDCfZJzw28KCwDnSJVow4Uojedv4Gq
2415	fee_transfer	1935	100	1	CkpZYLUiwgVeNW32U2PCYCbDY5tk8ZLuiTJbNAoRto8PRPqNHyr7i
2416	fee_transfer	1804	8000000	1	CkpZykPm8tccaXWcSTjwK5qQjWhGicJzEbSxU5J9j359C6k1SDnQA
2423	fee_transfer	1685	150000000	1	CkpZjHwrKB45KgdYoWhUCqFrJ4W3bB1HzvB8wY7LVPScDQUpiLz5v
2431	fee_transfer	1690	44000000	1	CkpYq1QKXLwvZ1VeRheNxu2Ejg5hQmRd1ihsYnDco1KCcpUxJTzWP
2434	fee_transfer	1790	300000	1	CkpYZAJvi4d1EfqE1XYyZLtgT8g4HjK31auL1gFd687wjw1tvmwix
2435	fee_transfer	1796	1	1	CkpZcg4RcygGnCMeAksTYzXfJ9zmPCuVQCBp8ekFYBBKpAViP9Dac
2436	fee_transfer	1567	39126063	1	CkpZxomNga8DaYJJpduTzjd5y2HpyShzi4L54wUoaqPQXJqSgHky1
2437	fee_transfer	1761	40	1	CkpZipSNQ4hXaSAHieL9mudXyNsAVjhJZ4jd2KQLh2RBeLZRYa2jw
2438	fee_transfer	1508	573896	1	CkpaC81G3q1LAkCUy2qTYZBDFHYaiGJMmwmWn8JEjAtrYDGAou2Pa
2439	fee_transfer	1508	15000000	1	CkpZbbZytu3tLj2KfUoNk45ifLyTPd8LmzD53nn4bnVbapMEGCAE9
2440	fee_transfer	1508	29900000	1	CkpZteqv6ScQ7VuqxCqBuJibdZ83dUnBnX2Hmo7wceTyh2F2mpj9N
2443	fee_transfer	1573	40000000	1	CkpZ3JZ6EhiBieD1uvLAiVrWeDC3Q8RRF3v3gbLnt9Kd1qUU89hYX
2446	fee_transfer	1643	310000000	1	CkpYuquNjyH5DieSCRc4s3AuwHx22zZFp89mVgqy4hotxb9gLEVrA
2447	fee_transfer	1643	355000000	1	Ckpa264Ww2apaA8eYokJHyqJXbvuakVjArmyrg7reRJMXq3xyfGrs
2451	fee_transfer	1656	120000000	1	CkpYpZMwGz1tYCCN9Fin2rfPYC3gZSmrtJeFdbg9ZYtLTjtC7mdRK
2455	fee_transfer	1698	1720000000	1	CkpYuBRzJ22pYyTCUMNLBZZhDMpg77FRVqwWeUkr2wS3vG1L52FPD
2456	fee_transfer	1710	70000000	1	CkpaJCmwSaQFUQWviRpbnxFRZ9PfApnkscegkNjPcgmEknETWk3Do
2468	fee_transfer	1703	50000000	1	CkpZNkPKBv3JYDHQmzr99qmF6iw5ysX2DgYhSWSkoaXZzJXz2hEZV
2471	fee_transfer	633	50000000	1	CkpYXppEQxEe31pTYSyhH32aFb15UX86DQ4ZnHktQ6Wreg2yySRsz
2491	fee_transfer	301	10000000	1	CkpYdk5AVH1vkBu3ZsNTCsNaiGg8c8TJ8d4U6KzMgNudjs4iVsG2E
2499	fee_transfer	1615	20000000	1	CkpYX26EQ9XS3dEwsf7YL3UAYnXXtdhCdmbo9XtubFj5tboGWvgEf
2500	fee_transfer	1440	60000000	1	CkpYSZcDjucVWF1ytDa4XrMCB2XUFaRufuuY35im5MxMaJAnWZitW
2504	fee_transfer	1604	800000	1	CkpZPdaX13vWjM98PXRMu7Z839m86MRxz52p5pHYmt9LE53MLSm7X
2505	fee_transfer	1718	9200000	1	CkpZKdBrVbbxymV5fNWcUzjW8yktgmJwSUMhTtdAWzdgkHfeCYmnD
2507	fee_transfer	1622	50000000	1	CkpZPc7RZKfBhz1S9g3TUEkTgjZhYgSzR3C43T546sfi7YoDKY3em
2533	fee_transfer	1447	90000000	1	CkpYZVKwZWepwJ2x1HsDbue1urVAgcRiZq78gWHFY16ddmCiDabc2
2539	fee_transfer	1717	90000000	1	CkpZwz65rodZSnfUsEyuyDJiH7HdwMMejDQg44b482ThYUijd8rDh
2541	coinbase	495	720000000000	1	CkpZW2Z5Y2K7ndoZmqjkCDPK3jaUkBA96qABMKGMQFDbihM1AkTvm
2542	fee_transfer	495	20000000	1	CkpZpgFjxfqQkJc96wvdoNpqhwengiGmSbfdZQ1hngD5uLRvoBdEw
2543	fee_transfer	1705	40000000	1	CkpYvXLVDWpioG3EV6g64fwxwphCNYBQVjtVuSEEXbsjtta2unzsC
2547	fee_transfer	1587	390000000	1	CkpaBq6YCDvjTg4BEebFuA3Cq5fzrWKQydSBh4AiYSZiEzJUCMXqW
2555	fee_transfer	1549	70000000	1	CkpZjJYxosA5q9b5PGmpiQRRsS97rQHRhMEkxFakpmrx9rLAjcZS4
2558	fee_transfer	1467	280000000	1	CkpZ6BfoiSeDvpynAWdtZRdicDw52NH2CartWD2mPVz2fEDj2hnHn
2559	fee_transfer	1467	1150000000	1	CkpYrJEn5622TVKWPh5bys9emBrMBW7dwEKhdrfEc6Po3hbicsYww
2560	fee_transfer	1449	20000000	1	CkpZfpe3YPnufVJ4MaZjpx7JdpJpYrDtNeeKL8p7LdsVc12veidgX
2561	coinbase	189	720000000000	1	CkpZ4QZF9cyAXd66rckFKQv5eb7DXUisRqXPMmY7uZgZW8JZWLUcr
2562	fee_transfer	189	40000000	1	CkpaFureXVZ6NTAwyr6TGitjqcjoCjsfB3qu35miPZaBtWbajaBRG
2565	fee_transfer	1710	21000000	1	CkpYoMesXwja4XQ5jCiBkh1L66yc1ubJtsidCdcAD7NMc6ghorU32
2570	fee_transfer	1654	22000000	1	Ckpa5jVrg5cXFjv9DwvspdVjoaePS8y55fAgcqVFCHyXArHV4eCnY
2577	fee_transfer	606	42000000	1	CkpZjigGASPbaJQWYZGj5ZFsuQTJtJdjxZGrbBVdPzVxAmeXujdJs
2580	fee_transfer	1448	72000000	1	CkpZbg7XAqhTLARw1AKr85pxJNN7qfBfmwX6tGBzZDhreQbHsAvD1
2582	fee_transfer	613	500000	1	CkpYo2uG7hqpT2f1X4mtqbNm1NUK57TGTHWhoLgxHDEkisGJz5BEQ
2583	fee_transfer	435	10000	1	CkpaKm4kqfUqZ617qQ7695GM9wZaXw5Pm8p3EiRuyVGd6mtq9mLSd
2584	fee_transfer	1508	69490000	1	CkpZ41pzNDuRqvHm5n4MU9u2WysXFJaw3WAqze71x8jA2Wgn13jmD
2585	fee_transfer	1508	81000000	1	CkpZW8XiuyTVaQqqCdfso2UEAAiiQ3Zj8dqc6jWpAGWSpB7p9kXGu
2351	coinbase	1992	720000000000	1	CkpZJfixYTTmxrG2XJHbELiquSeYJvsAhneEB6cxHXBmVAMM8V4kj
2352	fee_transfer	1992	20000000	1	CkpYhC4g4CeC6JTH89FfnXX78bv4dK6pSDHff5siYc7gX8GFhoFN3
2354	fee_transfer	1739	23000000	1	Ckpa7oLDun7CaDmhACygqUUR2pRoJSiyv9EkmpqVwHWLYkGARDQ1P
2355	fee_transfer	1637	494000000	1	CkpZ7DAysPGWbzLyu3Wc6exWHMEZ7kJvyUwrUsx6MFyb1oik8bQd1
2358	fee_transfer	1677	57000000	1	CkpZUsR6isLMGQg85M4JAANBj6eEeLv26TZebYfzEMSruMdDALZDp
2361	fee_transfer	1508	149000000	1	CkpZBn8aQ7i7P361T9g2aqNTJeGb4ybNHiPUTkbGZ7KgMPwNqoTmL
2362	fee_transfer_via_coinbase	1509	1000000	1	CkpYUJpEm6yxj3mhYaatef13bK1vUadW1SjTAkEnK913AfJApZaR1
2363	coinbase	1508	720000000000	1	CkpZNestvAnpkiaECC9f7H9PVUiPqZwEtmjUdmcD8baqN7iarNhS4
2364	fee_transfer	1675	23000000	1	CkpZa4PP1Hv62LbdGfsajEv4dV6qBHWjhALd1ZzSCwyr5LZTzXZhD
2366	fee_transfer	1729	60000000	1	Ckpa1JLD5cFsZ1ri9qS9Uv3Rm3RE5DtK5Kns4GgkLMpJeACDgHvjF
2368	fee_transfer	1726	12590000	1	CkpZ97UeFyfFPYo3Gr9LkC2DQB7ztNaUdjcWKQBb5Jrgc3muaguxU
2369	fee_transfer	1439	850410000	1	CkpZQFcLJw3jdxtDuhQYMQb83qSApu3gDrp1LYfZWCSVTFx49Q7Xh
2372	fee_transfer	1679	100000000	1	CkpYygnCT6uDyipsotv3J6uw8Z52PcfJNNVQKrGGnqed6Wsm9rkqb
2374	fee_transfer	1593	21000000	1	CkpZxbXwBfFtBRTLBvHanVCKtRkMqpZSQyvLfoDTbnKZRB9j4Fp1E
2375	fee_transfer	1657	212000000	1	CkpZpGQL2jU9iuRCTUVVNuc5pNja6ZEf6zbzh7Tfsypu71dp8Mkey
2381	fee_transfer	1685	51000000	1	CkpYYZrQHdfTJDy4uv1tadfRyKRULsPwVt1wewweFNQeHyoMFRj9v
2382	fee_transfer	1677	23000000	1	CkpZspmKLBfmgtVMSYhtWYKtpgH3GSXH7ghdkbE8wKbvdv18w2FCm
2387	fee_transfer	1685	211000000	1	CkpZ8xGYfLnEiWKio9WUSoZ9jFT6XCwScTHsnQw6ThPcsYZdEkKTy
2389	fee_transfer	1698	850000000	1	CkpZtcbscXaWvQVXP1M8tBhL2r63HQ5Nbq5TS3M4v3w1umzQZw61Z
2390	fee_transfer	1698	280000000	1	CkpaHC5yhTDE5R6d13kwMjp6oYr4YBBXB1HuuxqLYtLCmfj1eN5ym
2400	fee_transfer	1444	60000000	1	CkpYbdryBVtX3BVu9etpq6gCHBTpc64RSHiF8yqHzKVQUgmLZyRgS
2411	fee_transfer	1706	1680000000	1	CkpZjK61RrB7xsADVfB9Bk8btUW8Nn7A62LjGrbD7xqWUQ72Ue9BN
2419	fee_transfer	1426	130000000	1	CkpaDEiRPyo77SN8xGAmLXg2FDUS1hvJGfev7zDqGS116ZsQpriPs
2420	fee_transfer	1727	150000000	1	CkpYVFK3LJgrF7TCwCY9UBGfbJX7nmMkyDbzb5fnMneGCaAY2Cav4
2425	fee_transfer	1698	1700000000	1	CkpYf95FuZEMJyj6kq823PPn3D5MSnpQo79H94oUbji7yuNR3EQTr
2429	fee_transfer	1429	20000000	1	CkpZAWwAqxxdH8c9EYeH8D6kvB9SjwnkhkPkHsbnzoWR5PmadRnjy
2452	fee_transfer	149	120000000	1	CkpYc5F1Dyydvtpd1MsrSUxT57Cg6T83hBjBfo79dw1fuugZ8gTth
2457	fee_transfer	1607	180000000	1	CkpZGwpKJNZoVJxqvtoxpGj1JkCncmejJXURKJY955mde5aFFY77e
2459	fee_transfer	1547	50000000	1	CkpaKW8XpMzLpvtTuabDwebTDdPHcTNE3XkZh9qsKtxznFe7HJBYS
2460	fee_transfer	633	440000000	1	CkpYzBZVxcjHfZsY7PwaewvBF9cuFtXNwgynYbj56EZ6kVsg2xAfL
2463	fee_transfer	1458	50000000	1	CkpYzL2Bma1sGRj6f38QsaFbcHXNPf3nLHBTr9mzAUzrtnEqZRKGL
2470	fee_transfer	1593	80000000	1	CkpaJ12KWXwJ5GbhguA2FEuzvG9D78dW3gcTgtJrLGdpmYW2Zohbu
2472	fee_transfer	633	60000000	1	CkpZXCE2tirki7ta8UxXgGzfyayXYewxD4v5pbDPcK6N6MhRRViBC
2475	fee_transfer	1458	31000000	1	CkpZufYEmncAv6zEscEHWGv6kC5PiwyYmrLk3NvtRfRAZNcmsnJcT
2478	fee_transfer	1560	39999999	1	CkpaGUunFgbzYnsAYGWj1kmVgV4yYVoqxingwSVWGHHNQRvdf2EJJ
2479	fee_transfer	2000	1	1	CkpYkBk8E1QkcW8TJrpzdFgU3iBYGg3sDvXZ3Tv1ohiBAXDDJQpy6
2481	fee_transfer	1679	121000000	1	CkpYb8qnAHJDtzC7V41vPhDyBsqC9EcGiiuWspAsZMApz8eHm91QC
2485	fee_transfer	1850	40000000	1	Ckpa5YEj69VSwMkakofDmhGkESGSzEQYBjS9aWvgdncfdKcer9f8q
2487	fee_transfer_via_coinbase	1604	100000	1	CkpZWGJEFBU3RfvRLpgff7JDfRMyh2okFeqTtUQkFH69RPMZkWhaT
2488	coinbase	633	720000000000	1	Ckpa5M8y7DPjVYLywjhCyTt3fx8rpmUngypXwmU14tmLXUeaDkea3
2493	fee_transfer	1690	81000000	1	CkpZr5eqYEZuUn78Nid3REQxZmw5dNinqjvUUwGPZ7JaVrqSHqPUo
2494	fee_transfer	1657	460000000	1	CkpZe7ZZXNJJmRYCcR42k93VhkfSkuSkHuT6RdmrvwV3sBm48ceuP
2498	fee_transfer	1700	11000000	1	CkpZ1B3LRQ7JaB5eZxkpvNRMq3bPjE8boo6gjV5tsbvNz8j7vnt5X
2501	fee_transfer	1633	40000000	1	CkpaCk9AKdcDimwbNNzZ9J964cB9PkMqXN2wZdznXFJvZHvcC9B4r
2517	fee_transfer	1696	110100000	1	CkpaAX8mkTVSDtdz36a7hG5WbkLqrYtsN6ztqrBw48iwNajjDXsRN
2520	fee_transfer	145	10000000	1	CkpZEZ6KMDsn3R17kXDQaizmdFGz2qSaajYGZbpN6tTHLjiayQS2q
2522	fee_transfer_via_coinbase	2021	700000000000	1	CkpYpzwQr3h9DzBcaLZGui5aLg1z8t2bMeb6marjNVqDqAcmmWTeY
2523	coinbase	1457	720000000000	1	CkpaJ4MGH1xnDNjV8HxbqdTsngGL122hZnZ1qytLYwAY7e2y1jyaf
2524	fee_transfer	1457	150000000	1	CkpZCkthDdqHp1c1g7uWmYiLACAcMkYDTakCmyxPjBU4aYyY1mStL
2529	fee_transfer	1683	90000000	1	CkpYcrJUVqYYK5PQHLoNVzvok4uc2oaYZBjh8L2tB9kw1FMPjLxzw
2530	fee_transfer	1693	190000000	1	CkpaJ7AVAZL6Too3x2bFKtKhf7voKJa6BEPuokgnJYfq9K3WXP15C
2531	fee_transfer	1650	21000000	1	CkpYj5EMi5X4tRM6SLXKU7vxpBz8bkecCp2xsLdtnSoVhZi7SMAU5
2534	fee_transfer	171	90000000	1	CkpYoxANYcWJ96nEuHFjz4ZrUcd7iUnSZQtQYeV7rVnrtwth6FsMt
2537	fee_transfer	1594	110000000	1	Ckpa8hZadCnvAai5gzUVf11gwp9mFWJGycK9bpAFCGxchr1HxwCW6
2544	coinbase	1556	720000000000	1	CkpZuMQVHXQeeJn61sdT7ywoZ6c1o8q7tcdqhUeVQ4DajYjYRp7CH
2545	fee_transfer	1556	40000000	1	CkpYbwV7fgQ6QbFNjgjFxVmNE7E85jk3CzwhV3FLVZ8bqyiF2MAzm
2548	fee_transfer	1451	22000000	1	CkpZjMru7PP9vtzoMZq6j5K2xNJZvqMnkip34NE6PdqJtVYPQEkqo
2556	fee_transfer	1587	70000000	1	CkpaFApYAPjvbwWShsd7wscyPFJDR3G52cbgX6gwhgzqJk3RpU8gJ
2557	fee_transfer	1688	90000000	1	CkpZHJRPkca12bJ98gRgtGkd1FRZzggqHVYYKMk5GsXwAzujaQ9hy
2568	fee_transfer	1683	22000000	1	CkpYcqapQdnBTM5vkHJHD9HTPNxSiu82FvDwHsMJD6o27MHeHPhin
2571	fee_transfer	1992	40000000	1	CkpZDLeY6zApWP92EAeQK2mcXLJWDwUfbPhm6rN3AJ21p21zNqmmB
2573	fee_transfer	1739	50000000	1	CkpYgTCrtzagkx5SuXX7wshpSKAG122WrpZ4F3Ku5uESTVHUEVMAx
2575	fee_transfer	1637	22000000	1	CkpZMk5eRXdgGveS5mDew3KRmwgidi9k8c3aMUEskPhfbxUnwCsro
2586	fee_transfer	1555	81000000	1	CkpZv2DUUSmrifg5BCJ41nryTXT7d7jdWGsD4WCQcK3HvByHLCd9u
2596	fee_transfer	1622	30000000	1	CkpYtXshmrjsNvn5UnhHtAgCQvKusmZqq7sovc2tacRQbN9UZ1RKt
2598	fee_transfer	1633	1160000000	1	Ckpa9yqtoGtmXPceougiB2G5vU3Acg5bAw161VL1KRegfJH8pMGzo
2599	fee_transfer	1633	130000000	1	CkpZqMoqJ24LzwJyXVudfU9y1NDuL6Y1UBnhPZMAJv2gB7ZEYHvoP
2603	fee_transfer	1633	1210000000	1	CkpYi51jhX9gJs4RVY6xLMxn94rJseHpdF8ZAGyDrtmxUfpxSLaKG
2604	fee_transfer	1593	350000000	1	CkpZRhDn7Y4XNo935cuqPbbVNuSqd4VUY9dMPqkUX9J7pJDBzN4aU
2605	fee_transfer	1593	1020000000	1	Ckpa4XiTB66Na5jqYoRS7VcYRQW1ff17W4EgSKK4m13q2wToKgtsp
2357	fee_transfer	1692	22000000	1	CkpZpNvr746Hsya7ktTnLeUMbFnYYdmLrBaux2VH1J2vjC4FGKF5x
2377	fee_transfer_via_coinbase	1515	5000000	1	Ckpa4A99ncx9JSyWFJdpxbnbPWhfmCv2Y5XzhBLbT4L9v6q1pH1Lz
2378	coinbase	1677	720000000000	1	CkpZKfYou85orEkq735GJDgUPxqySF8vVM3tWdKkpg9JyquhZ2maS
2379	fee_transfer	1555	50000000	1	CkpYeFJR324AHoKCyT1bYaUj4MRMoJFiNyjPq5xuhsh7b5ApTKdkc
2380	fee_transfer	1673	51000000	1	CkpZbfcY6EdaeuwskpJYBkg55rWhScQzejn2hePacvUU7Wzesx1p6
2384	fee_transfer	1679	260000000	1	CkpaDjkagZnfXynbXpUkdsLupJCtSwaaJJS8FTQ9StHsUzSfNAa6k
2392	fee_transfer	1696	340000000	1	CkpZKyrV1xibVYusmqiSma3fTDPFHXBzYDYduVfzNT2H2j9pN7xCx
2393	fee_transfer	1696	104000000	1	CkpYn89o4QHKxMq4VHY7vbAVM7TS84YguPb9Z4S3KHxPwFhfyHm4D
2407	coinbase	1660	720000000000	1	CkpYzjP4AFQknCn62mC4mfWcJ3AAKcT6S3HyVxnS1y1hUpVK5LhzV
2408	fee_transfer	1660	30000000	1	CkpZQtpfUYTM5MZfR35VwT1bAsN74xvT2CF69mwbGfrwbyw2fVb8Z
2418	fee_transfer	1426	120000000	1	Ckpa5XQkYwnhxgLVinj2f4tquU4ZLCo8CSrD6YuUVim1XDoxXicCc
2421	fee_transfer	58	310000000	1	CkpYRUUNTH1qDguebwyM2Rvpb5RA1Rdvk316ZPpusjkXAHFz2YpZm
2424	fee_transfer	1678	310000000	1	CkpYmiotHM8cpuWEzG2UFGvLJkS4wYPTaqfyNhY7LrgLiTwDrVcDg
2428	fee_transfer	510	20000000	1	CkpZTJ1gKUFLSnT35gvZjecG8KK4fWzog4i2n5tEC5n4C7h3NZomK
2432	coinbase	1435	720000000000	1	CkpZXJrBwExWgftmY8ewAz2NrxwWDFV4iQhohShx8D491VKEdpnon
2433	fee_transfer	1435	40000000	1	CkpZ8DkpbWs31xKf18uUaxdVNPukHXP5XAjq7xASb8JTKypLdKne9
2441	fee_transfer	1593	50000000	1	CkpYXmjZsNDfYGXsTif45X7xPEyKTjH1CLQyG2rs8Bzt3r3czeLV7
2444	fee_transfer	1699	60000000	1	CkpZLzAeNSg32aD6vpqMSWYQ8TyyZS72wTQsT4S6YADtF8tq332No
2448	fee_transfer	411	40000000	1	CkpZ94ZUF77ZRVdLjPYuyi9C37ht47Nzsd9e6bZw6xqv3VNKHqpEe
2449	fee_transfer	411	1800000000	1	CkpZcbrZgVNvzWUm1wFycsNt8PFtqLMHHpK38cCpL7i72PLbLUATe
2450	fee_transfer	411	1790000000	1	CkpYuoBvrqKB7yL67wBfpKdNXY3454dThM9xv7eZHJ2uRqj7DLuYT
2453	fee_transfer	1759	120000000	1	CkpZ4i436H9wAt8B9biPjontNQXZ8a1NqhdtSvdtYVXhCGfsMLYyX
2461	fee_transfer	1688	440000000	1	CkpZFjWGPhDtDPnHRHUc9L5nBF7yCxMS29Zoq2J4i8yomSLyJzJgE
2462	fee_transfer	1559	170000000	1	CkpZd5BCdajf7cqchHkNRKW6JFNGxqh21NKV5em26Jst2Amj4Kr3v
2466	fee_transfer	1423	25000000	1	CkpYeH8gz2bsBptAEY3NjFRvoxWtdjrFza15Noxtpn4Ksq2LE77Br
2467	fee_transfer	1702	12409879	1	CkpZ8AB1Q7sbTTB9u1HNUVjqyuQyQGSmsNBFYMVbZUdrPx4mvwqH6
2474	fee_transfer	1602	50000000	1	Ckpa5gVe5nEG8y38RAobwwtdi2zaDzdJphkVYhzKFgi6MsBpJPXkv
2476	fee_transfer	1699	41000000	1	CkpaD7R4d6p9nc7MdA9DJtbXTLfGwymXjq2Z1a2VJySDUrifsmQwG
2477	fee_transfer	1700	90000000	1	CkpaBNfjFv3iV2MzCnkbd6AyfyYyZd8XBsD7cFwfvrJhHipf7K6vf
2486	fee_transfer	1687	110000000	1	CkpYkKuJKKCeXGGQ3RR5cNWGY8yjwtZw1SiPMuNETgbm65wfRdzxN
2489	coinbase	301	720000000000	1	CkpZ4SofHtisjeD1VuqfBhdAkB5YtUuJMKeDokCs1PvvuXvvjsHpm
2490	fee_transfer	301	20000000	1	CkpZQNhtE6JqGiKp7Ak1MdqYkbQRgs8jMuG5WAg5tTvmdjzXJJ84C
2496	fee_transfer	1467	1940000000	1	CkpYxsHoM3SruQfxquT5KfumK2W7UbA2GFzPK8syCEt1Vc4M7wQGs
2497	fee_transfer	1467	1739999999	1	CkpZdYHDau3589q9ySowq8qfpM1HNELTxZzS2xEH3bWTZkJjEm83n
2509	fee_transfer	1419	150000000	1	CkpYkoDWCfXTecgySBMX4zVKAJkFyiXtVGWtoHNFYUvHrM83zfA96
2511	fee_transfer	1657	50000000	1	CkpZBxWd1DJC7E33NeowPfmE8QoCCjutJHxKnvUUZ6MPm5kW9YhPu
2512	fee_transfer	1602	190000000	1	CkpYfahziA2QFuguf7BE6PbzchsFp1gE3fMWTbtrRc7MHWnjhfT2g
2514	fee_transfer	1489	4340000000	1	CkpZgncgMfHHDGiY5W599qbDeRAYxANLwZB7FC8SEfNDGNyW4u9dW
2515	fee_transfer	1489	510000000	1	CkpZSjP66PEBhekZaAUMvFFwcAjNNVKQt4S6kpWxhfYmFBNkkFvHW
2518	fee_transfer	1696	110099998	1	CkpaDQeLgKizopGLphYTxzqPZpMb2Zn1Q2z8PLRfUxfjiWQc286Fi
2519	fee_transfer	1964	1	1	CkpaKj3hTProVFkshbNMSUPYhYDR1nZoaiFoxT95sQMcgv7XuikbM
2521	fee_transfer	1740	120000000	1	CkpZmFTCPF6Q3AMjwUcUhNCfBGnjDN7Fe2bdWotpFopNdQLpv9tpx
2525	coinbase	1719	720000000000	1	CkpYw1VZzKKj2jVnuWfzZbn69cUEyAqQdURtdU3uvEfgZpJBqM1xq
2526	fee_transfer	1719	140000000	1	CkpZajvacqbt8vsJprFFiZBfqB9se1LUXjzTUtzWWTyJ9KNpMRvBm
2532	fee_transfer	1654	101000000	1	CkpYeNxzwcAiqAWyAcb2U7H87ST8FFnfq4phZacNRSpGqBwRKPSgf
2536	fee_transfer	1611	220000000	1	CkpYrwRGnzPpA7ru4SXyfUkjxzZykRECYStXfYGunDtRKcC52KBS8
2540	fee_transfer	1690	90000000	1	Ckpa2piT19ijhucJSqkWzHzNKUKr4eCeNKCNysW188j96SdWvBwVW
2549	fee_transfer	1696	31000000	1	CkpYThjQ5BropjjWCZddrd7PGPDJwge35yhdsyqHBGsLJaWhgYEyf
2552	fee_transfer	1678	41000000	1	CkpZDaZcERD3Q7iu81qJzwTEESuXhGq8Pcz97Y16DXKTugvx5mmH1
2553	fee_transfer	1587	320000000	1	CkpYQuqqEMDRD7cHuZeCZ8KmuYAfkFQCqSzbbBEdNowG1w1NkzQbQ
2554	fee_transfer	1587	46000000	1	Ckpa7eatFQGkq6Zes2A3ve5M46fFHhpMLeWXLBmSfGxxXkYaN244s
2563	fee_transfer	1467	100000000	1	CkpZnhqkk4pR6kFE5FsaissukULZSDySDehHCs3EJF22zCa4ZdqGZ
2564	fee_transfer	1467	240000000	1	CkpZB2LpAdjkfLhuxpBuc8bWjarALB6FRxaE7bNQB8p45eMgJXKka
2566	fee_transfer_via_coinbase	1655	25000000	1	CkpZyPRJVsFgBBG12Ltg2FrSRyQVJkCwkRZvWMq8gjm39aveQimHi
2567	coinbase	1457	720000000000	1	CkpYdhaJ2scB7PKphw4Nfxporw77vQkGxNoFK5czeRqhnax6BjfAP
2569	fee_transfer	1654	202000000	1	CkpZ1uy5o7qxDVreF52XemmfNbzSR61AGvzAHfbkEvYJwJ7QkNvFy
2576	fee_transfer	1622	22000000	1	CkpZQT19Q63ytYjeeYhfiLLf5WjmTt6Fo4JKe8ikCVcA6oeCufVA6
2579	fee_transfer	1683	42000000	1	Ckpa5EJHV9XjK5M3LPfpYnqF1cyUPTnEcecvvLELGAHbWF9mPHpwV
2581	fee_transfer	1508	72000000	1	CkpZdLxSjBG52HiTNLMHn2mnBKn1PBVE5VbKxQLUpk6cRurty4fs3
2588	fee_transfer	1690	61000000	1	CkpYkZ9pMD3MKDU7chPZ5s1RY9pUHRLE5cQNizeyG6Mum32L17DC7
2601	fee_transfer	1672	140000000	1	CkpYwgE79qNqpk87WiAEbtZ4i4SGZm5mTWmj8Cz7hXWoWSBFdUAMp
2609	fee_transfer	1675	90000000	1	CkpZgWh7xbuUxwo8HBUF8KvJZ9YnwApvdQPyraE91c7XTFJGcvKuP
2614	fee_transfer	1623	131000000	1	CkpZhhwPdDaugBSQjioKs5o3VSHwxASv37CBJKDxQDZcoL8xr2Sam
2617	fee_transfer	1670	50000000	1	Ckpa1ouCynM2BdyEaF2oYSGkBqrRpVxKJ9iCbTAXo4sv9rCPiNVb8
2587	fee_transfer	1518	61000000	1	CkpZLsCFgMwgAUNt4pRXUjtdrQoA797GzE1dskekUks46RwuwmS1x
2589	fee_transfer	1593	240000000	1	CkpZ47SB39vbSpMFRdUq73tLRXuYGyDp51VNVXdNZeVsiqNUC6WNQ
2590	fee_transfer	1593	1019999998	1	CkpaEgrU3kH2Xub1AsuAea5cgFE32yFCC5MtkHDtG3PGUQj3Yyy18
2591	fee_transfer	1683	83000000	1	CkpYULHxWHr69XAiSq5VpUZfGRuZUrzRzPrfjkzGXZV8Fnp7TkH4k
2594	coinbase	2029	720000000000	1	CkpZB4z5pxAMfGLGDPo8fekBN8JohdCfEhFXqTdhfEA4uhdRwfc3S
2595	fee_transfer	2029	10000000	1	Ckpa6B2sgfEFMpq2vepBe1WC8NhS5kLAxhA4i1U5ovZieBwJ5tndR
2597	fee_transfer	1543	40000000	1	CkpZU1jSMz7MGMceWN8mrohphnAGp1H7oRXQQm1tJ6cMhSFGHLQ6T
2602	fee_transfer	1564	140000000	1	CkpZxE4WiYFuC9Ng2guZFZbfrUGWwRRM9STnkzWeh6T1HH9rKtQKj
2612	fee_transfer	1711	70000000	1	CkpZL6fvYmYjidCe5K7Tp6YugeTZdAdPdmdQNhTM1yUWc2UhTQguJ
2613	fee_transfer	1603	50000000	1	CkpYcBnVa1hr7ZE6QLn1ACzG8PkYBFRZ5kfCxRu3vgV2KMGv5Jo1X
2618	fee_transfer	1670	481000000	1	CkpZbmf7vUMDZ8BaSdNvAfnYoKcaQkCs4dN42rA3h5Eoxd6jaPaCh
2606	fee_transfer	1439	73000000	1	CkpYpCnmXDGayHawJuky9DHmgGBo5ygVK3UXbBTiDvUh3en1N5Vy4
2607	fee_transfer	1458	40000000	1	CkpZVXriYzGyYoo91fSLTkzXq2KFeknyDgYMfnsHwo5CHVToVJJhX
2608	fee_transfer	1850	60000000	1	CkpZeHa1jrmT7DmuPWsigeVo4k1RghnWm6EHLf4LZPZVXkENpat4Q
2611	fee_transfer	1402	160000000	1	CkpZHbbszJMeu6JfnDhHPJrHXrPkNkW9yyr78vVX3LG9DwN72KD2J
2615	coinbase	1575	720000000000	1	CkpYSZPAx2BXQgvPszjwLAe1tjk6QrRDpduE4XhS1uGRRBwQH1X9H
2616	fee_transfer	1575	40000000	1	CkpaKdVqeTWKe6rMMQwgqAaqHD7xEwBs1i8VSYhkmfhmahBe4ETKM
2619	fee_transfer	484	50000000	1	CkpaA3XrX4ibTBbxmRFZZDCYQDqBUgntUTWirf44BatjzE4yhj6Yw
2620	coinbase	439	720000000000	1	CkpYW5fETQLYbiDRpxoCaJ4EgECw3xpgyzkKYFu5LU1mme127wQ1n
2621	fee_transfer	439	60000000	1	CkpZVMbEaZzkYNGZUQSGxpz5bPDj7TiDm7QmkegqboXRJpXAQZmJD
2622	fee_transfer	439	50000000	1	CkpZvxpC1VK5DmnjVR18PEY1VCrEEhiCyL8DTsdtc5q4bvA6oLAKx
2623	fee_transfer	439	40000000	1	CkpZBQx87xYVV4bwCwGqmxYZBwG7PSRD25s9JWZTnPtnVR5vGe1av
2624	fee_transfer	1451	50000000	1	CkpZ3BtswVJfnmKE2MgjC4YUtovSzXiL4bGu6mGpqq2m6xTVNNgUR
2625	fee_transfer	1685	460000000	1	CkpZnaHrUhUsqBYgMCABJfCTpjFRcYharvNapVT4WX5KoxEsYBhbc
2626	fee_transfer	1980	70000000	1	CkpZbVkWi3iWe6BZPbvafUZDSx1gsvmPCQ4cK4an5AXDWHdPN6Cwq
2627	coinbase	1638	720000000000	1	CkpYcWTDh24cEhsnnYF2E5sCRVZTjd6KUWkhyLLbko5cLPcvV9Zda
2628	fee_transfer	1638	70000000	1	CkpYd8umoZCzppFNhySJgFTvfcxAAvLN1HpbAV6ifEuswUinzQ88h
2629	fee_transfer	1657	150000000	1	CkpZnKrRwtVtXhQoWbpQocWQLn4RovEvBmmcGhZFbG3etXbNjjfcr
2630	fee_transfer	1690	270000000	1	CkpYZ5J3SewL7kDfcAo6SgJgzArVWDJCCBxwZfM4udNqUZLWFeMoQ
2631	fee_transfer	149	380000000	1	CkpYyvzCnc1kj9PxEESruc7efG9kj7sarmDQSf3AKQ4H28TZowTXG
2632	fee_transfer	1546	120000000	1	CkpZngibySfoFYyXVqxHe4xeGHQNxT9tubG5CBL5gvFF9TnZKw9wS
2633	fee_transfer	1685	240000000	1	CkpYg4FgHZyC3wwz9Z3dDwDoXJ92e6qujj7jWng1PrqEQceLgu885
2634	fee_transfer	1685	850000000	1	CkpZNNVN9VJ3Jsidgf1inMftSrSDHsxYp7Q1Axp9Mowrc1WSog7ea
2635	fee_transfer	1513	80000000	1	CkpYwDVYQXVtpfctbTCdMDcVsNVEC2dYnm26DzYyQ75nNbnd9bfB8
2636	coinbase	1991	720000000000	1	CkpZRfdkiQP8Xru9MD5cJwnc9BnFfZeLz4CkWxLNcWeeNEK6pT898
2637	fee_transfer	1991	20000000	1	CkpZBsLaCusha15DknfjPYUjCgMDdvyhcGwvh7JKbCzE8JdKk6eU7
2638	fee_transfer	1559	19999999	1	CkpZZbsq2hXLUe21DQmcP4rZ5yNuie3pAbjNFWj9D2afaJpYRZrwg
2639	fee_transfer	1759	999999	1	CkpZSXB1HGASKcLHmbo1iVqvoULbptaghc55UtL2U4AdZiU2oSVsQ
2640	fee_transfer	2014	1	1	CkpaE4NZmqC96rx6TGqJHuAfuQtkA7KrHr7ZgsjpAM7foyxBCJ5yJ
2641	fee_transfer	1509	70000000	1	CkpYbxWiZC83H6s2W8kD1jeGNHTxuLUB9Kbv8HTydiQQmUknjCqGB
2642	fee_transfer	606	71000000	1	CkpYdqaL6sKKjG2NEs6bxM9szcJbzXaUTP2kGHzz1uhUs2Q8BaTFJ
2643	fee_transfer	1702	19000000	1	CkpYrUaKnUQCLTWrBvHyfNyX3CNbE7MH21yzoLG7NBp9E7VPRFTmv
2644	fee_transfer	1759	12000000	1	CkpZYERWqumFJG4ojgycAJt88tTz83y9TiCBGEYXJXbcGe8nMCRHf
2645	fee_transfer	1509	8000000	1	CkpZBNZDG8SdRTaALtTJfgz7Fc1jsL3kjTuyfE5XtF7jLd6fbGv8b
2646	fee_transfer	1571	190000000	1	CkpZVKpQMmVDbmbmUi4TdDUtJRcmpGAE2fUUZXt1kof231YmiXive
2647	coinbase	2041	720000000000	1	CkpZdYC9mMjMA62m14TxYdKyZTTE4tPwAa2ZetKo8pUwfN5BPM2jJ
2648	fee_transfer	2041	340000000	1	CkpZ1jWHjFh9cYXRQVgxjWXGpg2q4NwbgeSWfmEmuNmkk76KFnToR
2649	fee_transfer	632	340000000	1	CkpYkhfTD6duNBVEijykWJpHtGUzc2Hi8xVy3Kc8hxSYa6mQayKbN
2650	fee_transfer	1705	31000000	1	Ckpa7hd7Heyx9TzfMoUh7HKo2G1z1sfXeefNsyistX4RiXPjkmcRP
2651	fee_transfer	1685	782000000	1	CkpZkGf976bkimxu6xJYtbBcwKhzokffPVemqRccJJ1K8pZZWFhq7
2652	fee_transfer	1687	120000000	1	CkpZSToQvyoMgFNWwACe5GennBFghuseTZ7PAaGswSCMP2DhAXeiX
2653	fee_transfer	1693	650000000	1	Ckpa82mds3MWwzXv4my2hYDXG8buJ92UYmk3NaYWZA4T7M9ZZU2xV
2654	fee_transfer	1679	650000000	1	CkpZysis9A5rw1jhYJJSYmXDEWRxby1bbTQBgAyXQtZA8ur3GUDBP
2655	fee_transfer	1714	650000000	1	CkpYjoSGm7io1eboDkDRNkh2hoHXLzkyj99PVYKSjRHrUBhMYmkvZ
2656	fee_transfer	1688	320000000	1	CkpYjp4F6TSBUd7YyxZtjwNovVmzdYQNCd11R3tmoHRPJ6zJ8KbyL
2657	fee_transfer	1673	21000000	1	CkpZpeWm2j7s1UL7m5crVyDD3jkARM87ES3XiR9o8uNHdKNrLn2hp
2658	fee_transfer	1705	21000000	1	CkpZCxCaQ5otKRPzAKYvoHgKPjjM6Mdee7bpkRX8zfof9BLpU9zL4
2659	fee_transfer	1992	990000	1	CkpZAN1DPTp1KZdMyUz7KJretCzK3xws9vRohou4Ec2ZmU6va2QjY
2660	fee_transfer	1449	10000	1	CkpZs8P2RENWKuW1DdysDzh97PzwBuKQS8XvjEgXmnsXRTsKENDmQ
2661	fee_transfer	1509	39000000	1	CkpZwfXAy8gXjXiKzt13X1fhEfyJvpHtCMfyMCYMbAvxWM387EKvp
2662	fee_transfer_via_coinbase	1567	713000000000	1	CkpYRdeujztMvqdKcukN4NFyPn8SnZ4YcyUeVNNQdrFcFd6nCPdgA
2663	coinbase	1762	720000000000	1	CkpZzWCxyidr16jcJtWf7HfTUJzY8hB7unHWCH1t76toFn9VgasGz
2664	fee_transfer	1762	994000	1	CkpZMcaNxui6w4eqPJkfb8Z7mnu6gEkCYZFdPgKwhJFnL9kdgBrvN
2665	fee_transfer	1449	6000	1	CkpaDDo1HWZzzMm5Fk8zJ2a8YNxo9JdT4mjLQfzgd9K4qmoh9qCdy
2666	fee_transfer	58	150000000	1	CkpZaWFYNN6w7mkk6UEFFMwvAJR3HhzMPEFoeZkEexGQCeZgPzdPG
2667	fee_transfer	1458	150000000	1	CkpZjmQFJZjkqcpCR3riAHU988fqnEEg2XGNMFPk4B5GAxMGRDab9
2668	fee_transfer	1536	420000000	1	CkpZVXpPuSGR4mVEFNKoJa39jxKi79eSHYvQyyJZcXNxCPJ4VS8Zf
2669	fee_transfer	1683	580000000	1	CkpZTdVRSEvxWwkxEtBkYirEqCgi85Yxms1qb31tgkMjxaQnPexsU
2670	fee_transfer	1711	100000000	1	CkpYVemc1eZdCK4bAhtyCAntc4sWAB7o8ugJyHUG4UCNPrk7dPGVf
2671	fee_transfer	1506	100000000	1	CkpZR2b1E51G4MYryFFpYBkKSKQwmK7Rekk1QSF8V5nNVnbWH2zST
2672	fee_transfer	1723	100000000	1	CkpaL6Aax4qxeN1qUazxs5QXDwJRBc1eUNcbokuBiwYtE8s1fpxyg
2673	fee_transfer	1685	1630000000	1	Ckpa19fy2aRjaPCK24fKT7m28quZ46iTmfVB4L6QMnJPerXiQc86S
2674	fee_transfer	1485	1000	1	CkpZeYrwAHDTNfvSQaSb5cBvpxXHdwGfN7qW4i8crbp8RN3i4dXNv
2675	fee_transfer	1685	759999000	1	CkpYQPB3aUGBm9RRhoPzuGwUAZJKSjuA7CPqD4pTnGgPePLbGSvsP
2676	fee_transfer	1447	420000000	1	CkpYX1dcJdbudzxrHGmeo8Q2frcUpvCA5pS86TMbdZ2Ecc5WDiRT8
2677	fee_transfer	1449	1000	1	CkpYypPNFQGdbFzAt125brijCKACZCEhzGoeFy1zJhDpWgJeRMYku
2678	fee_transfer	576	39999000	1	CkpZFpi6FRfk9XMcztYThZXRwUvkWsZzzhcBAkpRBBwExUupHk5uU
2679	fee_transfer	1687	60000000	1	CkpZb9owY4D53hZUhcHLnGkaQQonC6Lo6TBfyYXAKbWH7k3PC913E
2680	fee_transfer	1402	60000000	1	CkpZi7DVzjD5LhVS8r78Lt6er1qUUULNHmRAuicGScruMSTeqTCws
2681	fee_transfer	1695	1210000000	1	CkpYnkCF9mh7Mw7FqozrD6whMrb7xbg6wFAJ5K66YySz5TdcyGD7z
2682	fee_transfer	1695	780000000	1	CkpaK69AWpDuhCvxEr2P8ccFr1bNpLAqdUJe3uBSvm5RENKyVamek
2683	fee_transfer	1455	30000000	1	Ckpa6XqXHxj9zUK9ce9PaJ89CSWdC59C6NSk7v2BMs3kiVQf9YNqK
2685	fee_transfer	1602	90000000	1	CkpaL6s2CjXuCxtycgGr7pscLnrChqkrWdga7vHtepGmte1fZWa3v
2689	fee_transfer	1684	50000000	1	CkpYycsaDUGLygyUaLPiDsbTRcvYRWDUHQzDr5giqXKLYtBpmNmTq
2692	fee_transfer	1740	40000000	1	CkpZSQ1Nk16s4MfDBZPgoWVHTLo9hma48Wjinj3DZXdy1FcHsB3JM
2695	fee_transfer	1426	60000000	1	CkpYUbKLm2RTfuGRsV5EfCAQMD1L7J7Q2Av11aXUygHyRGCC9kzEh
2698	fee_transfer	1629	20000000	1	CkpZ1C7FbsoCyuBb2oLqhsivWtK7HJg4u7xYtsRjXdkUiJxgk1AiN
2706	fee_transfer	1704	141000000	1	CkpaKc5GVqWT2v7Umb4rKpgACcTBDzcAoVe1o1V4SZfYmc4K38uFb
2711	fee_transfer	1719	100000000	1	CkpZAhdxFww9dCAjmKj6EEqXZDypVuQDrYdXQBeD2HFfrwMV9tCDJ
2715	fee_transfer	2009	23000000	1	CkpYqcKwUwvToay8W3hXGdayaBVpqansMmS4z7sgNcSsrviR7boiw
2720	fee_transfer	1684	33000000	1	CkpYjstAhqLBVG7b53z6FvWKQxrdmRKLKmCQbKEmfwqZ8Ht9cosB3
2722	fee_transfer	1702	11000000	1	CkpZnKDUUcBrnaPye1MA8zMhxKSeFXviBahnT5nZP4h3dyJgr8pb5
2727	fee_transfer	1690	41000000	1	CkpaKnk3cFs3pQgqNCdUhMxcpZjy1gZHvxpHZdYJTZMyLjyqec73a
2729	fee_transfer	1402	61000000	1	CkpYcMTJVvFgFLHwvnGtbzwWN9k6PT1VsDctxHYNreXkx8Gn37GCi
2732	fee_transfer	1683	213000000	1	CkpYsNBcvWjXK5PCgghoYzqa6UgBaGQrhcVGMxGWHDM1WcqePzKu4
2736	fee_transfer	470	92000000	1	CkpZLEmy2cNrMw7mVH8n2KbaciGQZXk9XrdNXLUwrEJBxqakofsVU
2738	fee_transfer	1596	61000000	1	CkpZdNnaXPkV27D12UgAq8m2ijC7An7mc6MDUQPi25ZAhguS4GvUP
2740	fee_transfer	1402	71000000	1	CkpaHBggBPBNwN4ac7ueMzodX8qD4cDUTcQGvMPwUUuEe8v9Gj52h
2744	fee_transfer	1695	559999000	1	CkpaBjVx2bEdNSV9rjm5CzcDA6N7byKj2AEwgXUuho9Zx6huYxFbm
2745	fee_transfer	1695	360000000	1	CkpZRtpx7sCyDmLd8WLMoBg48RnvPAcdZSQz47DNRsa829vYJCBuo
2751	fee_transfer	1680	11000000	1	CkpYyvs1FBSietxU8z1R1i9rL3cxHLdp3kDpbhXw3MExaLjdQogzN
2756	fee_transfer	1419	11000000	1	CkpZEvXuYrjLQg3GZm73aBHRd5vkWEaHZhicnK2BJBjnYj16unbtz
2762	fee_transfer	1474	21000000	1	CkpZXPwkRu8T8ZCDAwpPDPLDHCiWQ3s6gyjChSL5iA39JMSNT94m4
2763	fee_transfer	1458	11000000	1	CkpZGvwpshMuB2EwQYC5QXAvSAedENLbAGcDoTmCGDFVAP7hPTKxU
2765	fee_transfer	1439	11000000	1	Ckpa3B3AjB9wuyarUC6G1mwxZX5acxChhrGpUhBprU4D14u5Dsdpn
2770	fee_transfer	1683	23000000	1	CkpYubppx7XCKqe4JgAihtgee6igUr6ZT1X6KEjJc3SER3iLRUCqn
2774	fee_transfer	1762	22000000	1	CkpZXdE2EHQWAzgGqX7UC2u1jucHeDESbDZ9NPrZ6bD4wRw3yP4Y3
2776	fee_transfer	1691	22000000	1	CkpZraiT3VtjFXZmgX6rp3ZVgBtoaPpiZQ8TpaENfU1gALV4pN3Ai
2779	fee_transfer	1703	33000000	1	CkpaEq538rRWmX4h4PHRDyqcjkCCEPKYAqd4QRtGXjvwSsxFP8MwC
2782	coinbase	2039	720000000000	1	CkpZF9abgQUCCA7eQUhJxfmuQKBd415abFRmMC9a22uEydEsvttS2
2783	fee_transfer	2039	22000000	1	CkpZcKd6oeYw5CM6ozsVshmMousSsb5YVTZZX6N7TW8a4ir9tC82S
2786	fee_transfer	1426	11000000	1	CkpZrZRbBSoHq29BGDYQhvrGzmCYtwQ62eBxmqKm45rNLZ1x9Tkvu
2798	fee_transfer	1850	22000000	1	CkpaFPUrTWGqkvMi85jLAHB5XHV39FSkJBXyjegTnYRGQ5RQzADMi
2799	fee_transfer	1694	11000000	1	CkpZERT9dA2jNKP32ifkCpaPDfbB4uknXqetnCBF8MtDW8YuHsiF6
2802	fee_transfer	1472	11000000	1	CkpZNE8oz189BEMSucoJsWthkJ291gLV4zz6bcBe5RyAi3eDreLnV
2806	fee_transfer	1608	22000000	1	CkpYn2uvU2pEaSz5TxQcRCsmg9DYh9nPEnSeHM9HRUJEak5CwaFD4
2815	coinbase	2049	720000000000	1	CkpZDP2u8CLCCoKcr85YKqaWccgXD1tjk1mog96dD9GLutc6wX32x
2816	fee_transfer	2049	22000000	1	CkpYY5tBMJQ8uXksEzvWZBtNfyuauFhSaKQDfthxuEEDFfaKTXNeq
2820	fee_transfer	1656	32000000	1	CkpZPkUkwBGfpGzR4meDsZHiFz3fGyfqx3dDjb5n8dQ26XNH94tXG
2833	fee_transfer	1768	650000000	1	CkpYrkNScSfdMUnyiKquqRt3btR4BYSQJiCnckUUTG2Gw36r2Yb2q
2834	fee_transfer_via_coinbase	1994	250000000	1	CkpYcreWZuJY64hxXzXEu9Fk7JGfjH89EwkNjkZhQfcgo9u2dq5H5
2835	coinbase	1768	720000000000	1	CkpZkBcAkk5ivxgyhUEUaoLXGnJU9wqVbA2cn9yDkQxYPqkyECPkH
2843	fee_transfer	1705	22000000	1	CkpZtGtXzZdMdFLw3msQUnNrFqhhLVQM6kGN9L1cuxuZEFRcUrJb7
2851	fee_transfer	1509	23000000	1	CkpZRy6nnoPUge5NeGsmtJfAgFeNqDbdjqYD8zPji4ZVwUXMpFeqv
2853	fee_transfer	1447	11000000	1	CkpZQ1HeWBbVDHYuNSX2ah5CY8GDzQLTzfPaWW6L74KsL1XfEJmKD
2858	fee_transfer	1679	25000000	1	CkpYemqDiU5NVJ5TmkopftLFA8kYHraBe6nc6rg4kLL37YqL8UGiW
2860	fee_transfer	1699	12000000	1	CkpYsG52gAprQX3v5jxuB1t6nKa29j1zJP6z2CPB691XygfkMu3zL
2865	fee_transfer	2039	23000000	1	CkpZdp6LvMeRfUhCRqHEMUqu5rnR1jv7RyD15PcME2pJdjdvEhuXR
2867	fee_transfer	1654	44000000	1	CkpZLM8p2QnPEgDT2KTXDFjMA29czkDVDQkM24rbNH3Ea8AWheVZE
2873	fee_transfer	1729	11000000	1	CkpYtv8hvSgtPLqnTxQp9Eah6tui8nrD63fFAV11acyeATuSDDg9M
2880	fee_transfer	1711	43000000	1	CkpZKTptPqtKBZrMRwW8Q4QVy5HmpiSkXdtG2akH5b9MU3Rn5h55w
2890	fee_transfer	1622	2000000	1	CkpZcHxiXU69z6769zgnyHtnyyywaHzBTKfYSvMCRPHyM8HhyrQ9j
2899	fee_transfer	1649	1000000	1	CkpZUEokAAXxGTXLyHy4VNKCX7AMW9FFZTXuVPXwyG9eURX6d3gYL
2901	fee_transfer	1476	2000000	1	CkpZLDYu4XMSFfKS3grYSQLPftN5kHqpHiGWJXXUdsSz52p4raLCC
2906	fee_transfer	1476	1000000	1	CkpZS3kujGodbYvL2kYXN1UqNVgLdgv4zEWnu861FeaYtXn2deN7i
2907	fee_transfer	1762	1000000	1	CkpZqKX5qf8E91XdSjB6mg1J89bsXiq3PK6CSSHDa9QHo3kHHFPVC
2909	fee_transfer	1426	2000000	1	CkpZo9Qf6HZSDdi2i4NbDt4NcZZqSC52rbKjgtRkep8rEJeJiJvmA
2914	fee_transfer	1690	2000000	1	CkpZJbaXaCgYUPpGNTr4NYMmrA5YZm7R9ktSJtM1fYd9YvoS7JymK
2918	fee_transfer	1695	2000000	1	CkpZLTPeCDLeyCtYpUmdq9Rw7Fet6uBjvT6D7hgwo6jnttJZqSKzN
2927	fee_transfer	1419	2000000	1	CkpZPcTgdfvPhB2WgrdkDaEEMFL98pB6qCqFxgZ13rLy35anuzaPk
2929	fee_transfer	632	1000000	1	CkpZGXRVPmjFTU5whhVVATB6xNEj8z1qVybDpcLAzCHVSSV7jqbAB
2684	fee_transfer	1657	100000000	1	CkpZgCxUudqdA7bCadRfHkCHABERbYA2KMyNrxcCj2PKUQ2hmKiJM
2691	fee_transfer	1588	50000000	1	CkpaJPCMvBs5GGjZ2URVKAxkuD856jZ2dpPjjDFN3hL5uXxKCSiSC
2693	fee_transfer	55	780000000	1	CkpZpR1xg6Jz1oUL5o3iALa31boJKSm52fFLD51jqxaHNoFgFK2Nj
2708	fee_transfer	1701	141000000	1	Ckpa3apqYY49sBPdcQHJxvBvfEp18zdSxyuJcA79c9eMLnMKsmaUt
2709	fee_transfer	632	40000000	1	CkpYVX3aanpUdiRCmxVbc43LBn6Lat3SkGqCDh4ksjBNbTrD7k3Lt
2712	fee_transfer	497	20000000	1	CkpaGWMegRBSKvGs8gc4cdWFU1vwN9n692YJHyypKbSRRkF1yLDUg
2718	fee_transfer	1683	33000000	1	CkpZGEb3H3p47bPZCMLBBfXwV63FZpavrdDnHRpYJegXGqquc1uwY
2721	fee_transfer	1703	11000000	1	CkpYqFFewD6VDKxWk3dnC1fnSYfDrTwYrWog9awat95XLJEaoZ1jD
2726	fee_transfer	1447	41000000	1	CkpZWU5UDJBNaJByu7cJ3wiqgUUVqxPJSpFyu1v5DLXJkvawF8ac8
2730	fee_transfer	1688	71000000	1	CkpYgyb3nChiuF8pv5baxy2jkUGz9DaM4HhB6d6poWkSr88N3r5mT
2733	fee_transfer	1564	213000000	1	CkpZ7fHddkvdLJ4ickTL8nVv7Ueu9fQSyhJFzWrK9sw6nZyK1cX1t
2739	fee_transfer	1693	71000000	1	CkpZbtjk97b5zrup5XW4g67JnC8aQHk6fwdgn5JDLvtapSwE1anQL
2742	fee_transfer	1677	62000000	1	Ckpa7DwS9QqaFiLgFDN47ah6xaFnP2A4aQxcDskHgMMDbD9SXeBM9
2743	fee_transfer	606	11000000	1	CkpZsr3DYRXxVnqFbNyUPLbGQfKeLzCSjsxefzgQ7aJmwL27tmAwu
2750	fee_transfer	1681	21000000	1	CkpZedsB1aUuX7o8PhSunsGrsVWd4jGCQBHUVhUwiDoB9X1JNAdyq
2755	fee_transfer	58	11000000	1	CkpaFfBC5HnDS799uSHpndTpTFtQD2LRmWeP2iMn2fWvypwXgwq3B
2757	fee_transfer	1471	11000000	1	CkpZb5wPshRjKPRQFj6kG18otbxPUpEy7NHtyBACspiDq8ZoH4qUT
2759	fee_transfer	1536	22000000	1	CkpZisZkK5AjWnP5kLWcAw33nBVF2odnoGmc6v6r45RDVzpjHRHvt
2760	fee_transfer	1451	11000000	1	CkpZcc16HYGNq5ceyLXykEmCrXJNMAWihx5svFf1WRMWxAmgYUnDQ
2769	fee_transfer	633	21000000	1	CkpYUH9hPReQ4nfG4ietrsvQw1JFA4WL5BW1yoogujqzeVRbJ6DF8
2773	fee_transfer	1611	11000000	1	CkpYZ8ToQdweBB6oaFrusK7kMCuA3wcdsXhEz3MQNsZhGA15Jkjyg
2780	fee_transfer	1594	11000000	1	CkpZz8eo4Ls4fsrX3czjwSZMfB5yzNYFvCGiRMdyb9iSpK17MQxAA
2787	fee_transfer	1694	55000000	1	CkpZmwTVkePy1xgrdAUZSshmEiemxSKdd92AxhQBKW21hd27B6xNv
2790	fee_transfer	1723	22000000	1	CkpZaYennLhKqiDnJxHWR4KKF8p4euE64ezm61fateMLz72xX4JMj
2792	fee_transfer	1599	33000000	1	CkpZAiAC5JvPxqeoFEJWA13JGxffuk56aVTznEx7ZPsABXJJc5rpW
2796	fee_transfer	1688	22000000	1	CkpZnJ6BWp593EgHxtcGVyG7JZbouZL49oDFVf8W2N3jmFFvDp6k9
2797	fee_transfer	1489	11000000	1	CkpaAm9WFk5DR1Ea9utRYfht9nge7RpPQPZNQmGb2RSAYrYPxovUC
2800	fee_transfer	1716	11000000	1	CkpZvCnQZGcshnYY9WN8hivvpDRnv9yampiK44aoKReZ9qWQB9MHG
2801	fee_transfer	2029	11000000	1	CkpZbAcJXoY7yKwBAgeAWVCWrajiCx34h4F2ubNUfu5doAJvhvjXW
2803	fee_transfer	1649	12000000	1	CkpYZDTXBt6TgVYxcVsu1TUB8eLARqCYLJDvkDTpiVokCWz6RcDQm
2809	fee_transfer	1749	11000000	1	CkpZRpAuFXP9C2mXDEharZEWSDenG9TkWY5jZZWnQQeGYq1Qhqz9r
2812	fee_transfer	43	21000000	1	CkpaF9G2V9pSYRTSTSmk8nLoYbJcrKVJa6k8SpTFk2dzsHJvsjjKc
2814	fee_transfer	1677	22000000	1	CkpYpuoQPYtrELRgUcpQszugF1kyGQmGCxEL83jDf6iEP88Z7Erkx
2817	fee_transfer	1699	180000000	1	CkpZ584oGHs2dGSv9Tq6DVdp6C9mBE1MEYE62iWVNv5aYtbBpb5Gv
2818	fee_transfer	1699	889010000	1	CkpZUsh6wFMpShi35b9KkVJUcLDKZgYn61rMW73AGU2mCGTGtS6n4
2819	fee_transfer	369	32000000	1	Ckpa35pc8XbfaAwMsPQBpjJutN7VTu83TT4F8QEWivZd6mxMdmLr3
2821	fee_transfer	1634	22000000	1	CkpaCREjMd9uRgpKzZRHymkVcPcngjxu4nda8Hna29noUUSKcybem
2825	fee_transfer	1657	678000000	1	CkpZ5JjYV6VyVHb4oeJHhxaHymBW8ZHWGFyNCZcwCZbg6QreUdH64
2826	fee_transfer	1657	41000000	1	CkpYYAiR8fVZP1PNzSahJg2JDDCvkX4bnt93gJxU3pTsYoGwTeWNv
2831	fee_transfer	1435	21000000	1	CkpYiUHpCgnP3XnPNT1V9QvuULqvuecRNJoy9bVrqU2JWzQtaGBRs
2838	fee_transfer	1675	12000000	1	CkpZZ4tb7c3gWyJg1qiYDXvubCibASL9K7ee2rE2Ta8PeVb2VwoVu
2841	fee_transfer	1402	65000000	1	CkpZdFcJgX6AgN4UagFT2z44VD7vkwu52a4mEvS2Pz2wkhySRmCum
2845	fee_transfer	1992	12000000	1	CkpZUe421exLkzpzJ12HhmVkcD3uTJSZraPGzA3hz6aHvoRbQZCwY
2848	fee_transfer	1723	21000000	1	CkpZ7vmVpuKXmwxiUQjMYKBUKfuUXNNkLBPb12PodGvbreJK9f4ro
2849	fee_transfer	1723	22999999	1	CkpZvQj49jfAX4ARBNcwnnEs6wduGKgWysLLMZ7oNMLrQ4gZp6dtM
2850	fee_transfer	2048	1	1	CkpZrfa7Jkg2wKVHD7jDgjbRT7dFRzpC5wVcvNGC2NJobKszbkHux
2852	fee_transfer	1681	23000000	1	CkpYkBHhmUu35vhVJeWN9rJ7pk4XX3oUBhM4ahpbz32wFAzorLDrN
2875	fee_transfer	1749	31000000	1	CkpYTx9K19TLy8b1avUAowuoqq3hQTRa9q9MJRxjCXAs1FRPWgThr
2882	fee_transfer	1518	43000000	1	Ckpa2apRUbWs86eXBoMLoLj8uAc9TigyodCPivGyRZ1U8fozvch2f
2884	fee_transfer	1727	11000000	1	CkpYQtqzRUSUyzV2b9NCWv9CH5PPQQ14FUjCBmipEvWgMM27ws1Aa
2886	fee_transfer	1670	1000000	1	CkpYSR3GvUbAuE9ryBGB8MXCtLutYwD4JcpjXLACAivMWyoW3njmJ
2887	fee_transfer	1683	2000000	1	CkpZwKHNhbodgkbTimS44Qi8r2Dx5ZjLXDrhho5gWVs9U83FsMisH
2894	fee_transfer	1518	1000000	1	CkpZwUxDAQzZBjE3MDqxcT6Duv7kugRzZujjm6qDyYWHWSjy3RtKQ
2895	fee_transfer	1695	1000000	1	CkpZu8MN62angNqzZx6Wpbg64oAoc7b1hgGhoVLVpr2J5b2tLokeJ
2898	fee_transfer	1708	1000000	1	CkpZc62WyMhq57RZmAUWLRrxN6UnYBCUA6Uhf1S7EH9LE3r5NyHRT
2902	fee_transfer	1701	2000000	1	CkpZQj31XeHwc35fikTYNhc3yknzDP99ra8sbxCSDEk2Q2bNVAzLW
2903	fee_transfer	43	1000000	1	CkpZLZSG1AZrmHU3tSDGEMb2q7myDuntPwv2rhikqxaFroWrC2n1b
2910	fee_transfer	1599	2000000	1	CkpZKntsaoNk7YdB57Zi4rouvhZsccfavXYgH6BvuCxpJG6caxJ6B
2923	fee_transfer	1555	2000000	1	CkpYUFQ6iGfahDpLdF2jvJjsLjdxhFsJFFWmw4BiZ4LcVPTENYV8s
2686	fee_transfer	1657	90000000	1	CkpYdmdKjLsCSXW6wCPG7GujudwFgVYoFAR2n4bYhUAmQDZNzBdpW
2690	fee_transfer	1692	50000000	1	CkpZoR7bbE3CDFTRHHzDaNKkc3F7c5vpsZLLLbhdkxbdF2rHUPQxu
2696	fee_transfer	1980	20000000	1	Ckpa1wCYq5992NY5Z2mm1mNrVZp3A8FB2SF6jonH3t6LPSh8tjdEc
2697	fee_transfer	1455	60000000	1	CkpYwX7ZZzCK2MNyYWiTE6B3tLtsfoZahSWpAwyCEzCaazsKzYR4m
2703	fee_transfer	1547	30000000	1	CkpaJ2pJ3kHcbNnnVAyZCSvWLVWftNPfBbhpWHGyBo2zwBZ21C39P
2705	fee_transfer	1747	141000000	1	CkpYziAwtoVj3GpwBTgiu1YyoBCDWEhKmouYP8JLsrTRMQeor9Eqx
2714	fee_transfer	1688	23000000	1	CkpZDWiwWNXyD6kVo7N8Co8cTwaHGgVu23e531m6SBzY6Uxu5sYAQ
2716	fee_transfer	1429	23000000	1	CkpZ8CTYYWvpAZFHrjXDrbBJeGSuv4Kvg437xwLP82fbned8brHV8
2719	fee_transfer	1513	33000000	1	CkpZZyobi8d8EvcqDLvc73CajA7eSeaHNXm9xr2RFy2ceVyG6Fr4L
2723	fee_transfer	1677	33000000	1	CkpYwsFvCSaNFNPFxS64aPjCJYyU5cKPrUAURSBSosrE5Z4ES4YmL
2724	fee_transfer	1727	22000000	1	CkpYZekp275p9ervJR9BfyAF3rE7CsVtDEUTzdVXrfs2UbHkJxXYf
2731	fee_transfer	1677	71000000	1	CkpZJWsTqncMDN6qiRQuFwv1Qw8iEJmm569j5vaMzso5qDUc9uoFb
2735	fee_transfer	470	82000000	1	CkpZkqrqgzh3QoedA6cseYGAkZqkd9TyTr48PxwzGiLo1QnWvzJJU
2746	fee_transfer	1420	396000	1	Ckpa73PSocWaAxoPRTxAiNqF9ZqcySpSDCVUpSWuPCY14driRFhEa
2747	fee_transfer	1604	700000	1	CkpYhacjLam8iokwAaDsQ7DPW4XGtccQ1hrmbE34MFfVA4a9wbAAn
2748	fee_transfer	1560	19903987	1	CkpaHggyaik6s2MdbpAGKb9GycQtcWw3vSjYigFtbHYGWTabag1GE
2749	fee_transfer	2000	13	1	CkpYp4jNrxZCRtMzt58b5epdtXhuKFWgCgpTuCqGobFXeeWR9wz3T
2754	fee_transfer	1992	11000000	1	CkpZaS4uN3UreXf6HJBpYMDk9yDwjrrKdoAmXDQK39w3QXnFRetze
2766	fee_transfer	1587	11000000	1	CkpZegQHumZgHaHr1rrayrBhcZowUfnkXT1p55bBoogufx9mhP3dd
2767	fee_transfer	1670	11000000	1	Ckpa3ukGtGppJ5sxBM7xeDbY9zSFiBWYBjiRhM3sh5xknUS1HZaHV
2772	fee_transfer	1678	11000000	1	CkpZHZWZcefJMmAiiRgZ9DbUm9q776a2M4PPAFPYHHDMp6eYmBfQU
2778	fee_transfer	1702	33000000	1	CkpYtZjJfJxFHEabsQfVoiwKBD7KPC4Yx8gBHJL97ibAJ1CxrXMyM
2781	fee_transfer	1447	22000000	1	CkpZWayA1VfSt9u8VJLG2UN7kDdXbkGafY7EgU1WNzauGecnpHfNa
2784	fee_transfer	2039	11000000	1	CkpYzCH5rGetiqbaMtBGVdJDXvERe9wBB1PqzcsJbMmijCFWrBLh7
2791	fee_transfer	1564	11000000	1	CkpZPMYPAchb9eUdyS1PjW5KLY23q6W4JKPBdYugQAviGMbXAFh6k
2795	fee_transfer	1690	11000000	1	CkpZCwZpxUUTKnuWnU8FWHZckYtouAwN8gphw91eR3fJqy2ruqaQz
2804	fee_transfer	43	11000000	1	CkpZ1xd2MW7VZH4G7bt4TPXCisE6uUry6hAdaQgydVGD2PpfP8Ykq
2807	fee_transfer	1729	22000000	1	Ckpa4G9VKuD4wUH4MS5vRzdCBKwusn5fBc9s49Yrr8xs7RHPQP8t6
2808	fee_transfer	1724	11000000	1	CkpYqGzr1GAZPh1oZfWjQL429H1vA9tF57LYXGBbGGp7tmWUYDCT9
2810	fee_transfer	1739	22000000	1	CkpYR8uFWgEBSf99DmH7MQx9fR4KnwL74KGB3SXL8eLW5VJdbhaXd
2813	fee_transfer	1610	1000000	1	CkpYmBNvRSqStZtcnvEPybMRKzQfwP4vgKcEkN8cLUEdSLZZoJJJK
2824	fee_transfer	149	22000000	1	CkpZmhzSpfTkFV19rqUtE1PiczdZMSciGCy3JDES1tR5X4YVM9xch
2827	fee_transfer	1587	22000000	1	CkpYSFhQVDH1pppTYJdM9n9rjytDWU5j5Cce6SsQVc8WkYyv77pPo
2829	fee_transfer	1549	1000000	1	Ckpa5pMWDtJCYgS8VWKR2Jffi6V5haDdVFKDZUjTcpevDWTMTYc2c
2836	fee_transfer	1991	11000000	1	CkpYQgLaTCZuRHvWbqpvGbT3Sbjemv4V7zp5fCJKDMZpwQu1AUjkD
2837	fee_transfer	1991	12000000	1	CkpYkhkaBYJkeWcjJScFJ8p8W7k45QRYg2nYe1zGDWnkL4eDgxyAy
2839	fee_transfer	1714	12000000	1	CkpYqb6PrT6Z8GTo1DLtZfjV8A6rvnDNcKt8aVTQ7dQR4FXZwaXeg
2840	fee_transfer	1980	65000000	1	Ckpa7BiBqfZG2iEX4sMdEnKU9UPRY4ppz9R1BKunxpY7VBEX2t9MS
2844	fee_transfer	1656	12000000	1	CkpaHUyWukPFNRuRwcJuwDDvWx53CxULLgfkki78H3ybyesK4p9f5
2846	fee_transfer	1701	21000000	1	CkpZJpYiKg3gQKfbTr1Bzs6NGgxV7vCyuk668fFwPae4sCURfXTMw
2847	fee_transfer	1701	23000000	1	CkpaBMnVQwfMGZYUSzPUZTkJwutWBtQYBRtTvpyKTZTeuPqFzLZYW
2854	fee_transfer	1657	11000000	1	CkpZMZ1VQbk1w5ATqHQgi87fB3JpMhx1hUPLDtSwt1rLf76REeSW4
2856	fee_transfer	1440	12000000	1	CkpYQGbxpLwHAA84tVYwhK52dg7hcgVjVMQW3d3Y3V4BPkJeaaHzJ
2859	fee_transfer	1692	25000000	1	CkpZVmQJN39AnkLbXBYo8PckUnPutZdtZ3SnPnYWsceabJY3wLiG9
2861	fee_transfer	1699	181000000	1	CkpYsY1G3gX2XXb74TCqTmDGHH1u9AWArwG9KE7K67VVRDhXjpcQu
2862	fee_transfer	471	100000000	1	CkpYVjZbHCRV2gCzgkeiELp1YUj4eLqfrMSRACwgWESa746jN3rAt
2863	fee_transfer	1699	100000000	1	CkpYXCErsyBSwKcLCVY3DN1aLJEvJFhepeaNw1JxndXK1mvRokejZ
2866	fee_transfer	1458	128000000	1	CkpZLf1LKAhX6htxHbSLGWdXPBxqPAeMHpGHZEBujZtr3heg32XuC
2868	fee_transfer	1654	77000000	1	CkpYeCyw1w3QdeMtNgjKZ9oLUS8m2CgW5JqmJ3gyworbz1FKvtGtS
2871	fee_transfer	1601	33000000	1	CkpZtfq6fwJnZL7UVz7qYifmDX8mVbCHpuUNBts1GERQ8zVpCrn4q
2872	fee_transfer	1764	11000000	1	CkpZp9R4Tn8suRuDTfJyfwg1m5SBXEE6f7cWuCAeG9gFEFEcfp2bR
2881	fee_transfer	1677	43000000	1	CkpYt3bBV47Det3ybhmFnGifQKJ2mW7ng4RutHquA8UYESymY2s7G
2885	fee_transfer	1687	1000000	1	CkpZysL25kC9TR2AcJgD1atpyviW7eGHKDP19nLGpEfxhsLQfLJba
2891	fee_transfer	1673	2000000	1	CkpYQcztNNP98JpuskKuYsd91S7CAmDruqyJR6HhQUCn4EZQWM8xj
2896	fee_transfer	1694	1000000	1	CkpZwG4hg9R393DAeMNdnh5KBxB6jVUokhvxhH59DkCCVnKKJ1Edq
2908	fee_transfer	1489	1000000	1	CkpaLM9ULaMHd7cGiiPaBvQR89K11FJ9yufsxVEgQspAuT1AuUg2H
2915	fee_transfer	1573	320000000	1	CkpYmPzoBUqVmUpGDv3d7dQfkmHTXRKrGgxy2YiuZ7ZWs68VpJnuq
2916	fee_transfer	1573	919009999	1	CkpZLJRSVb3LpsttxcSbF8t5VdtiBFa8uaNfMEGqi38Lb9JXTQYDe
2919	fee_transfer	1607	2000000	1	CkpYv85qafpxJtcttcFPTuj28Eu7QiRqBF9T83Btndhq76NhjFso4
2922	fee_transfer	1509	3000000	1	CkpYd8HiCBRf1rwxaUUdx5RrVxZydU9KMacmWgSK3F8Qun5XG7d6k
2925	fee_transfer	1992	1000000	1	CkpYcYeCCrg5oK7sLKpj5pG2wB5mS3kRoff9M3PsF4Cp14V54DP9y
2928	fee_transfer	633	3000000	1	CkpZKSNhbjjPZvoyqyUaLouA7z1L8tebUxwitDqr7EDA791pGqDq1
2687	fee_transfer	1685	490000000	1	CkpZ4Z47mEnhCxFdQFg5eQSUZY1j2rU6AYCAUFGXFeYJMCVfTBaz4
2688	fee_transfer	1685	290000000	1	CkpYVLgbim3Dcu2zA829xf6w1rZaKy9CxSWkCa9j9m3DVMafp8JWp
2694	fee_transfer	1714	600000000	1	CkpYQzpQC59KV1XmStizQt4eB7qbYR8EfoJHL6FZ8sVT3F7GWTqqL
2699	coinbase	1479	720000000000	1	CkpYYcG59gejhJg5rhmLXnNP4GfHnyts2p75XvsCDg42eC7S56SVy
2700	fee_transfer	1479	40000000	1	CkpYS5oyefcwDHpPXjKuxUEc9NL6MBojrXhZRkAyr1FbDtUKe4XST
2701	fee_transfer	1756	3350000000	1	CkpYZYRs4nXFguMwJV8rjTvzpBpHw6PFdQaj8RNuwMpzUVqWnsoJL
2702	fee_transfer	1756	170000000	1	CkpaCESuPvfSCbfybghGvTB3mt16XXymeSUeHefW14xwGNvUym3U8
2704	fee_transfer	1871	30000000	1	CkpZeajc97ssNmeLrpf6Q8Uq9tsm5xGWwvgC9aFhDcUESa4ZuahrF
2707	fee_transfer	1746	141000000	1	CkpYn39BG99rM59ty7br77WCkETUcF7jyJthZkyaSgdpC543rwHC3
2710	fee_transfer	1729	120000000	1	CkpZbBd75byoTZNZR7YqaMheFkrmG8m3zTxRFr8YyFRzuYzU4wNwC
2713	fee_transfer	1564	41000000	1	CkpYY2zuUQHMDtKeT7ZsrRFghUB2jBBvy9Hh1xf56g51TTWqtzgcD
2717	fee_transfer	1419	23000000	1	CkpYrgheFYmxGJFdoZMqTssu6Zw961vfhSRsjYA4imVxVLfrkjB9M
2725	fee_transfer	1455	22000000	1	CkpZWwdRyDdc7B72hEiJxd9hUU9zBoZ2eFdLvJSMp8wRAi3tN5VTw
2728	fee_transfer	1587	132000000	1	CkpZhsHjHLVqrXPhC9GMeHRBE4DsS9unoKPMjq2YPfeMGmbEUd7tM
2734	fee_transfer	1650	61000000	1	CkpZsxcYPrKA2CXHUxwHcF3rwsT7eyReFJzhRLVVsX6ywwDqdWhw2
2737	fee_transfer	1509	324000000	1	CkpZhJaaQLx6hvLwfx4fNAgWeGiJXHsK9ocZ5RZs8idSvFd1VPNPS
2741	fee_transfer	1611	21000000	1	CkpYdczfGp3d2EjxUiKch6MEA7wvFkigfd8C6jpMqvdv8bSKMArsd
2752	fee_transfer_via_coinbase	2000	1	1	CkpYkBk8E1QkcW8TJrpzdFgU3iBYGg3sDvXZ3Tv1ohiBAXDDJQpy6
2753	coinbase	1680	720000000000	1	CkpZLchQkYrgWBef9iRFm2BXzLzsZFPNdynRkpu5YMF3Ct2qrYggS
2758	fee_transfer	1693	22000000	1	CkpZNPiLQxhvNoDjrA7tj3mfm4kgSAaCKQAkLFfCVyKtwJ5kHSsdb
2761	fee_transfer	1467	11000000	1	CkpZWj1H3T63zdnf7EBQbPCFBVXFYBeMNJWMitGc6McXoGM1TCqSF
2764	fee_transfer	1668	11000000	1	CkpYeZGuPdrfEfmEeHVKciH4dE5E6Gzms2bZzLduEfoFYAF3PDtAj
2768	fee_transfer	1714	1000000	1	CkpZAZZFo9cjXo14GeUaH9fk1aoRzBBbEgB1HGofK6zXiGMdRprYR
2771	fee_transfer	1546	22000000	1	CkpZbUijDh9XKA9PmQEbkRuie9mK7jksegv1NWG4mDGpkSBQrjTjF
2775	fee_transfer	1587	1000000	1	CkpYccW9ZsZSpRW9ZvNimMBZwsGraHo2CJUSpmqN5Fm7GbUyyCuMb
2777	fee_transfer	1688	33000000	1	CkpZ3txvk2FPmCVrNAWQGMuPYi4ido2oS7q5Za5z8dq6Qfez6seet
2785	fee_transfer	1710	1000000	1	CkpaFyjgMBMPAMncpmChhPsr6M1b2xCspF2X2Ucz69Hxj6o3H8hGA
2788	fee_transfer	1402	55000000	1	CkpaA7grXaUFQA3TZd4YfuGzqf8UwwoakYXpR3FpYrG7xNKWZcCYH
2789	fee_transfer	1679	11000000	1	CkpZ9JQaM6nDwdCnBu4eap2DyMNBdYChaUVw2foQLkVb9rTBf5nQC
2793	fee_transfer	1673	33000000	1	CkpZcqE1SdMPoTKJ3TAQTQ4DbDBQRS9z2f9sKWB95X6a84sYuJcgo
2794	fee_transfer	1623	11000000	1	CkpYeEwPaWiwQitUpkKM5HuUjh7qV2Kpk9sR1LGosCWUDckU6PPsd
2805	fee_transfer	1681	11000000	1	CkpZNu4b7aeBxSB2NdbpNNvWvSLxBR6BofmLN75DdJN1AmZc5Zgz4
2811	fee_transfer	1710	22000000	1	CkpYw3xDkYZWpc7nS4Lkxq2ZfTEKHmHLdWuh1H5w9ZYbP73VWotoQ
2822	fee_transfer	1671	11000000	1	CkpYvJdTb2g1yiSexLEMfrvicWiPkBpyTc9y1wgKXrqU9NoVAYnMr
2823	fee_transfer	1634	1000000	1	CkpZgrcWeD5X7N8azpRw1tL74gGBG3LgutbSLSu3CqLaurFbPKqFv
2828	fee_transfer	606	33000000	1	CkpZfkH5dxcTQrZ1AJ14SBsf3TjCqAwxUuFHZZMnGAMXb22LCP7UE
2830	fee_transfer	1679	22000000	1	CkpZr49ZWzgp3R2wxecjDmfDvi3oaPYK1sjiiGJkVtQPBwz5C6pbt
2832	fee_transfer	1768	11000000	1	CkpZqQZ8uX87EfAh8Jn9DBYaK6XqCz4wVC7vwTmvCd6h214gP79ts
2842	fee_transfer	42	11000000	1	CkpYnCvDfFEqM1Y5TARrDs1TG9CMqVBcfzqDr3PFqM9LHvqPzFpoe
2855	fee_transfer	1657	478000000	1	CkpZRTimoWe7ZmxHrnBYpSJXStizudpppc7ReVVZe81nQ32FLzRR1
2857	fee_transfer	1673	25000000	1	CkpZuB9Y2VEN7g4Ykxha1xtZLnTEzBEJ5E29kvyLtSwyJYwA5mtQg
2864	fee_transfer	1623	12000000	1	CkpZrgi9Gruvr33LNvPVvojKbeGcpsuNxa6dXmh9suFKRX3oddJEv
2869	fee_transfer	1571	2770000000	1	CkpYeYiMyUk4uTgGWipeTj8yS2LYzqwSzTdksefdpXpXYChnyZs5n
2870	fee_transfer	1571	270000000	1	CkpZU7dSSDMXsVSEr5Qzvy7KoczmA7NLyZHYmukhr4V97eu3M8F9a
2874	fee_transfer	1608	14000000	1	CkpYyMpx5VZkL6tWf2d2QrfB3dzJbUCKmKV5oo3KmfwurkBKEXdcQ
2876	fee_transfer_via_coinbase	2048	1	1	CkpZrfa7Jkg2wKVHD7jDgjbRT7dFRzpC5wVcvNGC2NJobKszbkHux
2877	coinbase	1711	720000000000	1	CkpYyQDKTDAVJV7hpY4fEQfx154ZosUqx3qRvKMaVaUjt95DyGH86
2878	fee_transfer	1711	42009997	1	CkpYagwZ7LFw3T6XdPa6T2CWx41nhUKcde3FtSeuFLENikXvVqjHc
2879	fee_transfer	2048	3	1	CkpZ2ydhyPP74JjnPzUN8DKhUyF9HRoj6tdEY2eGQQvxfz7ygbwDt
2883	fee_transfer	1564	43000000	1	CkpZvSqAt7zFAV43DLhEu3yKFkq6r9PoZxi85iC89szfJBCj6oRGF
2888	fee_transfer	1271	2000000	1	CkpZ6WRXwYcfhATLD1497mrRCVkstttYLE7uKZ2dCguQLHTeXGKj9
2889	fee_transfer	1451	1000000	1	CkpaFt3W3RsBsW48doeSWes9ZpjWnw2kWz1QFb6s1EmVc6MtYcqnU
2892	coinbase	1525	720000000000	1	CkpZ9W4pwneAkcc6yHnT4rkvR67ccpw2tZA8kUCdAX3KvuJQqgLQ3
2893	fee_transfer	1525	2000000	1	CkpaDtQC25nnTmdwUQQ2ZpNzc9tSYryfumZ2tDjzC8bsiMiDbc3m1
2897	fee_transfer	1613	1000000	1	CkpYtFq2xKQw6aVZBRTujJXvMovKaatucQEvWzBHuzJ4kfzMe8WLk
2900	fee_transfer	1611	1000000	1	CkpYaoXntiDvzavZG19yNQg3MX3ccVsEFnLNz3Qap8hpfFYaMQtvP
2904	fee_transfer	1471	1000000	1	CkpaJgXHV3uaa53FVoDnwcyBtVz5dp3BVizCzDe9Qzmy8Ntu8Yx3r
2905	fee_transfer	1767	1000000	1	CkpZUHrKYJLDd56n7fQFova2bdqK9bH3DTbVjd5ysjWkHwUQ9JryJ
2911	coinbase	1599	720000000000	1	CkpZp6cjZz7F9y9GfZzrRgrjxiyHSe7ChosjPct7LjEMe3sC2QaFC
2912	fee_transfer	1599	1996200	1	CkpYoASNCy3u6B3tHy2jTuUaaCVGCqAGiFfnZLAcWDVNFSDnKVv74
2913	fee_transfer	1514	3800	1	CkpZkAVi6i8Ljh3PxUGEeRRvVm9yT958Bk9H5CvdFTwAgor6K2duo
2917	fee_transfer	1683	3000000	1	CkpYwDed5QoBMzXDWFD9hBEEGFv8g1cHrBrswW3qfr8tKMVEvBnZx
2920	fee_transfer	1602	2000000	1	CkpYUM8QFkCLQU3AWpi41gcfA8M8MapidupSTSSyXSH4rU6TdF7aN
2921	fee_transfer	1637	3000000	1	CkpYqLzw4bU1umuCm692tWsxDtsLUTyxmwTa7cC24HHG16JRn4cAp
2924	fee_transfer	1723	136000000	1	Ckpa5MikeAm8tfgfJoeiHJ2siFnaYUjDyNQnN22xVAJBGdbEgVA1D
2926	fee_transfer	1711	1000000	1	CkpYYYTbx3u94icJoF1xbJhBrUcCM4SSxM5vVEZfYwP22twahgtfY
2930	fee_transfer	1677	3000000	1	CkpZzfC5tVejTuVSXGDfPHdJRLadQZegeHJBbn6kVJwTuYTnCmwKR
2931	fee_transfer	1513	24000000	1	CkpZHBDF1XbcUvrTtXBGWBSabcpkXQj9p3gEKvrfGkMRt2KbEDhLf
2932	fee_transfer	1678	2000000	1	CkpZgxdJyTuiaYXYexsVMoxaKjHsPtoRjEAJcRtgxvi6hWopPsWyH
2933	fee_transfer	1668	1000000	1	CkpZN3jSzUYzquoPWk8UsLdapko3WTq4Qkcm23TDjWxhaV94DJR5n
2934	fee_transfer	1444	1000000	1	CkpaHuao5LeZjJz8vUeDSCPHDguV96AujZbqLw4WvSc2QDYq7fqmk
2936	fee_transfer	1447	1000000	1	CkpaDyF7ktuHmRSBwTqXAyaFYYY7MCW2n1VqkaPhWNPGQtgpBc9kw
2937	fee_transfer	1458	335000000	1	CkpZQv4JV4mSnDFLNkHNBspAr8ozoSXWMFSoJg6DMnQRNr592Y5kp
2938	fee_transfer	1458	28999992	1	Ckpa15KnYxzrB9mobWZ8DjqNXw9PMXBQ9L6Wya53btVopojSH43Lr
2939	fee_transfer	1508	4000000	1	CkpZ9N3JA1Q6YRRd8Wc13JL4pYHuZHpeizgs2P8DHr14VbFv42jhE
2942	fee_transfer	1649	2000000	1	CkpZS1WmL8ocyPaKgw577wP454i4YRMYRXeAmbiGNi2ZatYwESbKK
2947	fee_transfer	1747	2000000	1	CkpYggzWzpNsSvzKthGN6smLXF7b5VXCLh1cv2vCxv6RWCuo6S8R3
2955	fee_transfer	1508	14000000	1	CkpZqnEqihthXFz17xSTSpEKjk41Zo2FwCPpaqno3fj3NQUscxzao
2962	fee_transfer	1588	144000000	1	CkpZnsNcY7mBjAGeiJcjbwERS8LaJFHAgvqbRQwzg5xAimAAHepbV
2966	fee_transfer	1402	2000000	1	CkpaFLQCMx5x9gXJChfZFtXeT9JW8fB1aSRiaW8wWv8isg5wnYGAv
2967	fee_transfer	1622	1000000	1	CkpZDx8NmWjaydMdSNFncDhH4a1QtyQAgPwtaz2UdWJFkappvqfKg
2973	fee_transfer	369	170000000	1	CkpYRdC5hSFpVd72uGCYRFwbtF7Lv6D9VVbvnmv8PCXYopoWd7Efb
2975	fee_transfer	1656	1000000	1	CkpYhn1M1jLkV9uRNBWN5d3jy4nBuKxWXXX5p6imT2CVkjkn6TBfo
2982	coinbase	532	720000000000	1	CkpaFXBn27BcPQynUhJtc6gkhetyLgg5M2HnkLNR1M2iCqxJiKaUk
2983	fee_transfer	532	43000000	1	CkpZ2szf3xDRzkMaehXv3YaETHHaUest8MAao1XZ4upFBt538Rfci
2990	fee_transfer	1679	2000000	1	Ckpa1AXkGMB1iYEA1MBSFVnxQPTaZp9XFYAe7ivKzig7uJYmXgP7w
2998	fee_transfer	171	1000000	1	CkpZTPpJG2bCRH9qnpCKvp8AmFijgXiV6PyjoHV3zn3PNNTiqLATh
3000	fee_transfer	1724	2000000	1	CkpZSkiLvEFsPC8PPbWQR7Er68KuAdig7cZQPQMNgVT4nFjb9Nh5R
3004	coinbase	2055	720000000000	1	CkpYTHpGtixXmkpE9JjJWfrjoRwRGgBqUduV4p7cegTHFm7zqvsxZ
3005	fee_transfer	2055	2000000	1	CkpYgektAuG7ERjSafDdfnDuNmeRZY6g2RtA92HRVDvnKxxkF4H2N
3018	coinbase	365	720000000000	1	CkpZjjsbc29cxfz7RrrmBk6Le6tsGNaUgTGPXGxteoPZXzC3MfScv
3019	fee_transfer	365	1000000	1	Ckpa5KzbANLqzbBrMYyR6WyeGpptT7GwDEQDUsxtQheVNP4McT8MR
3023	fee_transfer	369	1000000	1	CkpaCgFcoA5fUhz7g1HffgpYpzH6L9LGbeEGvv4AihTaXsxnbXxuP
3025	fee_transfer	1768	2000000	1	CkpZyDGTzdewoBXMyoJZAfHrsvouwfs4L82YTMArb4qHNZo79M9BA
3039	fee_transfer	1613	2000000	1	CkpaCdYDrQABiTeZ36EcCNgZTcZ7TJXNozYK5egN81fuUodVV4V8y
3042	fee_transfer	1654	541000000	1	CkpZpW4A5YR7B2NDMzBMTR86YY4aMfimUujXgSgo2oKvJFvE9Uxax
3043	fee_transfer	1654	97000000	1	CkpZXzninH86gUWhfSq9BzwUogh3kJNeB6Aw5JMbpqXa8CuXfE9yz
3045	fee_transfer	1610	3000000	1	CkpYjAg69kNuqMb5bhC5aP1KN8LTnFavMmKiiWh9HjrmzXsHxzbCe
3057	fee_transfer	1455	4000000	1	CkpZURkJDeo9m3z3HHGSSaMjCGvXVCceKrode8MgfhGF4vjEFEckp
3064	fee_transfer	1755	1000000	1	CkpaJJvEkiHcggsuWycZiewvahiUGo72TWnh7wgXkoNgFnLFMhz4z
3072	fee_transfer	1593	32000000	1	Ckpa5FcJyNHHzvbBb7TaveCJnR3JBpQiX5Ah3hCDMtk2DB6N9Qs1B
3076	fee_transfer	1764	5008000000	1	CkpaDec1NSKqjUnyRbwqr1LpxeCb7ieS217YxtbRNpJKZAV51a833
3086	fee_transfer	1422	20005000000	1	CkpYeCqYoW1zeYDGxjvQfJts8Y3PdrgEZ5dTNn8W2Y6ipPEmGv3LN
3092	fee_transfer	1560	1000000	1	CkpZ12R1e6xeRMqFP4ehMmy2ZGPgTg7bFwdG59XDQ52mqvJkJeURA
3093	fee_transfer	1705	2000000	1	CkpZDrkx2myKq8AwChWwuvCeKZjiro2XQg2qvokTMGZu538KXF8KK
3098	fee_transfer	1700	1000000	1	CkpYWBeEcbD3ZNiaR1Fo3dHBuuycc6SaKiDM7Si8CKmTAM63RzSfA
3101	coinbase	360	720000000000	1	CkpZDnQH4NeUoDw9nQb5fGPMmrUHPViiXhAdrc9qurjJwNLkcF9Uz
3102	fee_transfer	360	1000000	1	CkpaGjDGcGksUoCxKDqbWCkL8y81yAUknLNnJH4UX2V8hZFvSoqwi
3104	fee_transfer	1439	20077000000	1	CkpZuwnHJu5zvuHoS7Cf85BkwJTCzDE6pYDpnm6ewAHwST6pK4RQU
3105	fee_transfer	1439	50999992	1	CkpZA9q3ZnkvwtSz6VkT7oHUebNX7Xy26N8rT3eYM78bonFYLegH5
3106	fee_transfer	1439	20033000000	1	CkpZKLqyrGn2hPp4LxEsQdw1DchCsVdFoJexdv3iStLwrJyq5ZsQ5
3107	fee_transfer	1439	45000001	1	CkpaHF2SDRgovunqRWvkhBhfnLBDRdxsuJ1C5WPpkPhhJtFxJqA6P
3108	fee_transfer	1527	999999	1	Ckpa6J7EqmaDmUbcuamooAuWsv2596tSsAVuq3ypcoFskEdnNq9wR
3111	fee_transfer	1656	2000000	1	Ckpa28xasqY3i4ZsxyxV3cAJqgdo1RSSWauHB1qdgPaqThxDvxewy
3114	fee_transfer	1680	1000000	1	CkpYbhhp2ME77Kgv8KCpNU3PcqCKnLpPj6vrdSe9dDk7XTtRkvRfh
3115	fee_transfer	1723	1000000	1	CkpZEyGztzgpWWdPCv3t7JtVLt6ZajmwPco856TmvfNCNjDrVCiYb
3125	fee_transfer	1593	37000000	1	CkpYUNZHbrKdTfBmS6wxpP8zMtBG9w2UA4s7mSe9T49TaXSRv53Xp
3126	fee_transfer	1593	68000000	1	CkpYauiKQLGBSuemwhAJDNFLY3Ag5YVRnLxzxdU5iHm4p4eEn3DDe
3127	fee_transfer	1690	13000000	1	CkpYgehVxcx8wRKSYZaL6czY6UzZJy3DqYVLwAYxEEUJ3hKzjYyvE
3129	fee_transfer	1679	3000000	1	CkpYR7kJrDebG91RXxV9ZRjnT5T7GUzTCvXK4n6g1JFmkRzKMWL6x
3132	fee_transfer	1723	2000000	1	CkpZNz1tYBDJ8zrrioNLPeqEtcRTAZUY2ATFMG2jaWAYWRD1udXJi
3135	fee_transfer	1556	20256000000	1	CkpYTrm56ZSKKQE85hQsDsPkRvh4Abo8BvfAXyxRR7xDSeJJnmv8S
3136	coinbase	1556	720000000000	1	CkpZP1yCx1iy1Jo7U5kCx649mTwMuxxf49VFTfJ4MWVgFhPsR2osR
3139	fee_transfer	1692	3000000	1	CkpZNSs3LeUrApcLZURRo7Yw9tBnR4AQSi9kfJ9vD1jp6ogNqkMgV
3142	fee_transfer	1654	1000000	1	CkpZNszfT7YhyPmbtyFYw5h43XEKKX3apDPpiift72KB2qQe9uWME
3145	fee_transfer	1420	198000	1	CkpZ9CqixX6dL2z2JUBMk54voH4hSBTdcFkkQqUkNL8w7ckhjisNZ
3146	fee_transfer	1716	1792000	1	Ckpa3pSL43rDiLN6HY3oZP3b6kmGvMgByCWNGoPyue7Tct3A8tmv1
3148	fee_transfer	1683	5000000	1	CkpZY7e8WeudA7SjScZ7zgbAcisu4KDvXmfuankLency8Kavnvt9n
3151	fee_transfer	1629	5000000	1	CkpaKj4xEzFfmBzmhBGNcZwRHNdB7w1JM8bgpMegF6HcBk1CrcBdk
3156	fee_transfer	1739	2000000	1	CkpYuxkQKerTt2cqNR3k97bFLk5yJbFXWNKVFH5tMkZPCQgukCR9G
3158	fee_transfer	1546	3000000	1	CkpZdi3A7yw6R4sf8VQqKcHjkEZQ4A671cZPp9m7TBdJDpmRJtcSu
3159	fee_transfer	1607	4000000	1	CkpaAfuXNKvtu7NqkSCUKDzzHiysNYGLUKxNhg4KBUvL6hM5uEFEq
3164	fee_transfer	1687	2000000	1	CkpZPiy94zA1KgwzF5TC7V3DCbHsK91GdBkcfXj1QYijo3DzVqyJ4
3165	fee_transfer	1716	3000000	1	CkpZkHEUgQRvU4m3kTFwaZ3BFRbVtRR4VYGY2hwkHiibXxAycJg4V
3170	fee_transfer	1698	42000000	1	CkpYp2XrVVj9owqp9kRrLnzATXnMq53znDrM2WRdmirWHjYDcLDT5
3183	fee_transfer	1599	11000000	1	CkpZmnCrrQ5VE5k2VVsNQgx953UgQ1BkfR32xynd8vSbbmXvN8wHU
3187	fee_transfer	1692	31000000	1	CkpZkM9PnteeqyErjNb2Q4oioD2xVABzKj1K5q7wyF8VcWLwpfbUU
3192	fee_transfer	1457	3000000	1	CkpZGaqEZCUFup8fLxM1wDyyNtqqiePbZnrcT3KYXi5ikDcghBzGV
3213	fee_transfer	633	802000000	1	CkpZSnd3Ag7QEkBUrBQ4eJ1jEFdm8BcZRvNNzwPjwtBqvSa2GGxzs
3217	fee_transfer	1448	101000000	1	CkpYt6VMVq6ypqsgkM8Jyhjm76meMnmpbkwAMxiiG5JaLpbaFzey5
2935	fee_transfer	606	1000000	1	CkpaDawA4iE9sgPdexHUBJrSV8gMkc26xiSwHmSG3ipZLu6APA6jb
2940	fee_transfer	1718	4000000	1	CkpZXitsRdsmHejc6KXdsZPgSUVrDyCZMsfbJNXqeouQFN5xeZ2mC
2943	fee_transfer	1670	2000000	1	CkpZpJ2dmBz76Pn22bF3T9peXarSGg4L96RcC6rAmpugNq4Uxoz7J
2944	fee_transfer	1467	1000000	1	CkpZXdd3HVp8wAvgPWtXqG5tckkt8FsctzYmwv1U5R92Win1nn64W
2946	fee_transfer	1729	1000000	1	CkpYXfQJffza8K2sQ129hNWfTGuotCWVezSZJHRJLEtX3L3UrzAxh
2948	fee_transfer	1704	2000000	1	CkpZPunfFcMCqfnbKtfCUWYx87NdA6HkLi7DvFXHoju9wstdxqDXW
2949	fee_transfer	1746	2000000	1	CkpaE7Vm5fnPecRdeABmt2TLwiWDaeWxV6wPpyrYRH5oHaywM4cHe
2950	fee_transfer	1677	2000000	1	CkpZ5Ab9XXTkGsrzmTcXnax5V9JBfBw9MZ67weSXJXf4cKqxdPZ2z
2951	fee_transfer	1596	1000000	1	CkpZ4aXeCTpQZq2p289fA2gWhKTr8oAcvCePDxG26rfShsW9embC1
2952	fee_transfer	1536	1000000	1	CkpZV9gQ2P3bk5kEjr6hqufzWQwQ4a8cceexEemsgQjZJ6BA832Tp
2953	fee_transfer_via_coinbase	1485	38000000000	1	CkpYZvr94EDPUufCpBBdHAbwYEihJGXBpgi1mAPmYLBuFQKuAtK6P
2954	coinbase	1458	720000000000	1	CkpZaESx5CrLb4hB9gx5edg8BidS47JQxBKry1ib4rW2d4FjruS2W
2956	fee_transfer	1747	1000000	1	CkpZ6UintEU2VF24njGR3hzuEvk55VA8AjTBQrvBk6suq8GgV3Qy9
2957	fee_transfer	1704	1000000	1	CkpYnBF8yckQn2AyWdDqhvBPsKSVogUP1gNjYySYCwrXskWzNhXMW
2959	fee_transfer	2039	1000000	1	CkpYiPg89vJuzdozSrHbWHqkmVHsvYBV5dsPEJzArpkYuVt95Ty5Y
2960	fee_transfer	1633	1000000	1	CkpZxWo8J9GTJSB2q2HusZeorDuPdKYFn1gzTJk33gNNBmCStshbY
2963	fee_transfer	1593	144000000	1	CkpYno9n98L2UgukRoJZk2UT8LwAxczmZ9BpuFYtUQeZeKZGUoZtP
2964	fee_transfer	1705	144000000	1	Ckpa28sGpiGhtqpBDBXBcC9v8qzF7neCM62fhDhfRxGinXYypHcPk
2968	fee_transfer	1673	1000000	1	CkpYozXb3oUeTujqiLpSzsqtfpytKC57vB9ahEAchrDEtZHiRQAgJ
2969	fee_transfer	1608	1000000	1	CkpZ2bndveuVPWNWYBgHyS3XCophv2g65jnfjZamVzny6JfYeK1XP
2970	fee_transfer	1588	1000000	1	CkpZHqBXTeA3RCWsnCAeTeChuQYaRtfpLFtCnmLpvHmZQign4hMnR
2971	fee_transfer	1749	1000000	1	CkpZa1Bi5fe94ekx7f9dFPVyC17wxYdMQrwqSwe7Vf6fkomE3jz7u
2972	fee_transfer	1759	1000000	1	CkpaF5zvu13stZqcr7Wn9khW451a7wYfnPH6BcUQKBXUfqB9AbxP4
2974	fee_transfer	1637	2000000	1	CkpYQS8angrRJTx9SuzNrJgKX3d1KprftANVs8FsPsD6XKSxZLdXg
2976	fee_transfer	679	1000000	1	CkpZRVdn3G2YU6XNnEpgoYvTHLSopHaQ49vyQzJ5Es3SNpWonEk4V
2977	fee_transfer	1506	1000000	1	CkpZC8aBzYKNuDrzxr684c2J6jwHhWmmaTgEm8zms22sEt1YKJhZ8
2978	fee_transfer	1693	140000000	1	CkpYuUhpzkuHdFB3kqzU177CJVLujt9QEfuJ8CLE1bypr6q1di6g2
2979	fee_transfer	1601	2000000	1	CkpZ6uTVNxic4jbCDYjEW8BNxmsqun4CqTfdQjPguwxDQazPqWPkz
2981	fee_transfer	1724	43000000	1	CkpZoXiTeH1EzbFcxRd2oP6mCvgbaioaVYdCxb4B73HpsUWY6sBKX
2984	fee_transfer	641	14000000	1	CkpZ5JnC9Y1a6YptQ3sSrnG11k4Lkk3RXGcpeTZQE5x24uBi5wVAP
2985	fee_transfer	1593	1000000	1	CkpYpM5zTTtVuv4UjkQXU4VYF9HnHJTrbwyNQjjivSn6aZDzYXiMq
2986	fee_transfer	1706	2000000	1	CkpZqwwRnayhXktAUjHsTtWdNAT8MwjDvZvm7SYyqVUFMKLuQfyj5
2988	fee_transfer	1608	2000000	1	CkpZFy6BF39tthZ9bBZsRvhYTJbHvYCciyXfr2XLhRBLpGhK3He98
2991	fee_transfer	1564	2000000	1	CkpZXQG4aMFkyGJ3LxwCodt6Sx9QHGURk3oHhi2XuwcxAR5G836aB
2992	fee_transfer	1426	22000000	1	Ckpa2NBVXXVc8umLMda3af4fw6ybXN3r65UJVGFFfFDhv2FZTWNru
2993	fee_transfer	1723	294000000	1	CkpZooqdHMQcUYmtXniGm1tr9NKbv86AjuL3ppzTPUhxdbQo7Cbae
2994	fee_transfer	1723	82000000	1	CkpZq4BDDrmTXuhtSKnwxt9FfpbPuVCofGGUbaeWJGR51USrc5wW3
2995	fee_transfer	470	12000000	1	CkpZ5du9cKJJxTaL4211RLsgSwP33drPnkMETYsy9SwwacFPTi7hT
2996	fee_transfer	632	2000000	1	CkpZTXGh58eksB3RQAUDFjyvgVHdbFUWn3se1YuLydxx2mUVvBPCn
3001	fee_transfer	42	306000000	1	CkpYyp533BdtLqVdaLDBxsSpEqUmLm9GX4kpZZUvN1WWdt6dT3k6y
3002	fee_transfer	1501	50000000	1	CkpaEkoR9h9umgTksqiBfKTgFBPkUZQvHLdNPQAXzwmkSmgK5pcAt
3003	fee_transfer	42	12000000	1	CkpZVac41ePfDumwfSqwGnkimScvVCHfvgKUy2rie5NQodyqosKnF
3006	fee_transfer	1672	2000000	1	CkpZbsHDU9kVrX6WXhePTEzzNjaKtmhrLjMKMaE4oBND7UwBRMTvR
3007	fee_transfer	1559	410000000	1	CkpYgsVQ1x8reCxJCTJmNFLG1yVutQxAqA7tFmZuFmYDnk3myEwuM
3008	fee_transfer	1559	282999976	1	CkpYqPmzorEMpC9xmJJjGsN4ZuUsvif1a8dg9pddpkYvqiYhQLGba
3009	fee_transfer	1571	24	1	CkpZ1vsU7zdm6YSGC5ZtmjnZe2Sn1tJN2gAXcKK38Adat6adsJf8f
3011	fee_transfer	171	2000000	1	CkpZzyN5kj8txJvyD2yEGZ9PUtC31DzPxLWqycT7E6srikzzdwtEq
3012	fee_transfer	1705	1000000	1	CkpaAEoVJFHTJ2xGtprHNfWvwmUyhysCxrtse6R8faHQkcxZQviYs
3015	fee_transfer	1656	3000000	1	CkpZz9GCP7kWyvE4EaKFJYwg3JFx3LWZ6NiYhPYe4ssJYrR7SsivV
3016	fee_transfer_via_coinbase	1988	10	1	Ckpa6nEbJ2nbq6fY4avp4CUNxvtczEtYLaUKA7XizPRPHyXVMPmXC
3017	coinbase	1656	720000000000	1	Ckpa5s2eTWG7SHBp2wFcon8gjU1JFjDNz61YJryxVpUB3oBqs3maX
3020	fee_transfer_via_coinbase	1919	1000000	1	Ckpa8TPtxUvofZfNjwxiXsGEZcKh64G62KXHmjVjMqD7rPpLmputE
3021	coinbase	369	720000000000	1	CkpZvm73GDnPbDmJyi9kaNjHkpGEuF5KTSrPGkbSrGLmZDHmGM6uk
3024	fee_transfer	1610	92000000	1	Ckpa3asyEJtJ8V7BSa7G5fYvj3ssvYFfcCVQkPk4ouzWHArvAgBFa
3026	fee_transfer	1594	2000000	1	CkpZiR7eYg4dcsewpAgDR6ybD7PLH1h1ZyRg4rHLYxPkoHqrbtxE6
3028	fee_transfer	43	2000000	1	CkpZ1tzENEYru4QT7Mdra8opSXPnkpihZxXW73YvFx1Z9AXqjRie7
3029	fee_transfer	1679	5000000	1	CkpZoFsBRK6wAebiaDzSQ2ZTqPzk6CeBtPgeH2F7bzHR84H1SYAdh
3030	fee_transfer	1467	5000000	1	CkpZEpYUW2ZsZGNMFv3vrXkmZfHEdQHdRFPGrsT6KtVf8CBFX5vyF
3032	fee_transfer	1683	4000000	1	CkpYr9EWDuoGvxgEsFujz3GyRgUP5w3LSRjR9zkxZAgdzSz4qLAmW
3033	fee_transfer	58	1000000	1	Ckpa2m1rAhJSHqHK5RoDmDxid96VsZS4kMHcXprHZbf1Cj35ZKAC7
3034	fee_transfer	1688	2000000	1	CkpYwZa4dWW6ERok469rSUrsoaV4aaQqmnLHx7u1RaXHqWqVMhogj
3035	fee_transfer	1691	1000000	1	CkpYt4sTD3rmg4aEfNqTZCDvTshY1nBojLP2pesQfdhAR2HvdKfya
3040	fee_transfer	1587	12000000	1	CkpZmjyMgERzp5JH27yhak7kMZBFUpsUtPvjd3KGZc2okFYGuqHpv
3047	fee_transfer	1439	100000000	1	CkpYnaj17yJdDApdciVwUYJJfNGjaLeGN7WiVTAwEm6J8dmRvMBdN
3048	fee_transfer	1786	10	1	CkpZFdMSgmtgntnf93Nwf6AicaADPQRMiCzTUt5BKCweKW4hkgVvp
3049	fee_transfer	1439	92999990	1	CkpZdL78ynDi93eKFRLydTNTxXPwDgNtYpuokSeFurstz6DRYVYrp
3053	fee_transfer	1696	11000000	1	CkpYUBRSrQVdHy7P6Dh5HwszD6vVBi5KNmpvqbzzJfWSoBkertaxX
3054	coinbase	1696	720000000000	1	CkpYSLmipbnGqyX2bbv4Lf3nkfrfiMSSNAa8ZqXM1UcVfXKx3HpQs
3055	coinbase	1689	720000000000	1	CkpYrZAPmCjubgXqfnqTspAr834EAzWDjv5UgXXLDxbgFGqVowsx7
3056	fee_transfer	1689	4000000	1	CkpYeY2M3cFVtY5CwLLFS4T9JsMp6f4Uax7qs7i8ChThYAtjXdtD6
2941	fee_transfer	1594	1000000	1	CkpZkA4iUoCcfeC6UermTy7Bx8WLVzXfxc9iYvtdo33fGuyyFDHZx
2945	fee_transfer	1764	1000000	1	CkpZL6CkgRtePC4LKN3D6ZSEut2xtHKbUwBrApi6UsS6Ke8eTgV8C
2958	fee_transfer	1746	1000000	1	CkpZ84WPYsrPm6BWZ1FkjrSZyWEGmF834yfay1xQGfpSh1PQTE6DW
2961	fee_transfer	1749	3000000	1	CkpZ7dLoYxr6hTVcz185yMST5Xmm3xw29WqAzL4332EeAnpTBoqSM
2965	fee_transfer	1677	144000000	1	Ckpa1tcEA75CGH7ac72TuqxGnHgxsC6n4ibPzcK1u9WkN2RJbciYL
2980	fee_transfer	1513	2000000	1	CkpZFUyoB8Fv754F8vBwTUaoAa2Gz5fHgdwfMjQHjs5ggAiy2SzBt
2987	fee_transfer	1448	2000000	1	Ckpa9uPzGs249tiQgGmCoZmssF6BsDjpFqeYDfGUQAZSUkGnuQpZj
2989	fee_transfer	1692	2000000	1	CkpYv7kSPYg7ed4ZTaaWqjo2rmYW3ViuTRX1idHyqEDsL38kepUZo
2997	fee_transfer	1474	1000000	1	CkpZBXTqZjTjKmYR6abKhKVqZsQTBgVJc6Hrwu5WvNzrMyorRPtnZ
2999	fee_transfer	532	2000000	1	CkpZaDzVeJpoG9E4t6v3e3NmN1tvFkxiFuwVvpXBbrJxEvu6gzten
3010	fee_transfer	1694	2000000	1	CkpYxcsPJW4GjQPbWiyW5bo4faUFLyY692S6RzBcHRbf2G1MMMpwy
3013	fee_transfer	115	1000000	1	CkpZiZZnDFE57bTA3DLjhQaq1kLmrHFVw7S9SAFWB6zd4RYbKTxMy
3014	fee_transfer	532	1000000	1	CkpYQKemx5SwUddcdZNccuHkfQmLz6Bq3uH8mNkCCwsufb4MT76wZ
3022	fee_transfer	1422	1000000	1	CkpZ9uayqu3M576eqpLBn4ffb3oqm7cfCq3i3xxR5jXmxbyChDZJS
3027	fee_transfer	606	2000000	1	CkpZUAygrUQykehA5j7LZYUQNGjWSDfV6hx3c9ZVpi6HvEbywEkqt
3031	fee_transfer	1637	5000000	1	CkpZbxesYPEu9bxf8QHdZzFJPitCA6X5qh2Rw9FFVwc7fr12RAo4C
3036	fee_transfer	1719	11000000	1	CkpaHag5y585h88KFo3Fe86AxyrriKtEuErdMFfBJh8USL1dvBE6t
3037	fee_transfer	1992	90000000	1	CkpZLkduFSxXeELjDpe3Jdsxd5Zc3v4PtWBu7mcriRTSULvPZpN3L
3038	fee_transfer	58	2000000	1	CkpYsJr9qyJcvi2hqb3EDRTDGfML7TNFgY68ebiajQvoBYAGNRQZC
3041	fee_transfer	1654	12000000	1	CkpZixdTRL6N8XYQXnMBmrLMdzsTRyaYSx9a8NajWqAxcVRkG4j6Z
3044	fee_transfer	1741	1000000	1	Ckpa7FABjZo6pKQ33n5UH9VuyF7LQYZBg2tSdWwGoiq2qbMHU37L5
3046	fee_transfer	1657	12000000	1	CkpZCmfWYXM38p38Kdzk4USTCUE3emi938hSwp22yNdjzTcQphuUr
3050	fee_transfer	1696	60000000	1	Ckpa8vgC67Dxs5aRW7oaCmK6K8kCx3VTqoNQRDYEuUNFise5Kd2sP
3051	fee_transfer_via_coinbase	2052	1	1	CkpaFK5vyLsQssc8m4vznii2FYRHXvKgHPjAfbqMUDN1n3kqW6ZXQ
3052	coinbase	1696	720000000000	1	CkpYTArjnijaujfvyKyBYVtXp45PB2RWFvrKgCR21RpSw5P9G7evi
3058	fee_transfer	1643	1000000	1	CkpZ4ewKF8NibNC72m6YUtVHjSL7SUATEApbJKQ4fKg6de5pMGE4N
3060	fee_transfer	1458	2000000	1	CkpYisQ8PTivuAN1jhhuzZCKZZAUy7qpg2jELeESrzvyofJhTvwBy
3068	fee_transfer	1709	2000000	1	CkpZFGNdunCt9iB4uiS264PZpJek7C8kJZTby639BmhdE7GbfwCeJ
3069	fee_transfer	1599	1000000	1	CkpZwKW5vnQhJY4oXVLCcNRd71RPUB9yRSAhKounn1NYPX6pvGw8T
3070	fee_transfer	1506	3000000	1	Ckpa14M3Ystx83cLeqLyMsKfqXqo6yc9wWsNA3BRRqsheVW3ZFAJu
3080	fee_transfer	1593	20020000000	1	CkpaBxh9PfB65atPi6bnFtRvsjsAYrJjLqhKPjCJiQh5yjjx8Vynt
3083	fee_transfer	1610	2000000	1	CkpZQXyZoGpdjgpZKAjmUrFSMBhPbVrm6u5cgJxhQPJ84j2tNboja
3084	fee_transfer	1549	2000000	1	CkpYkJQtg8GLt2akxZvc3UZg7347ELo6Jutck7muudzzXAZtrEgnu
3087	fee_transfer	1672	1000000	1	CkpYj3Rv6Fuf8UBsRshrF22xEgNysJYUpQrF7QL3gUWeAcC52aix9
3090	coinbase	607	720000000000	1	CkpaCf3iHe8re4GtZoDNR4ZgdyvNj88UWdhddWwQNmZVXUnKf8WCv
3091	fee_transfer	607	1000000	1	CkpYTqWbiLMjKarZq5FXzpbn4GNdCwJ5Q8hBYCeu4zE2qL38ETy71
3099	fee_transfer	1522	2000000	1	CkpYmCpVXV296u8EvytTxYfKHAJGuTqoCduefpDi5AGACX6YkrB2w
3100	fee_transfer	470	2000000	1	CkpYRDyPMT2Y4KXjQMmwdHvfYbEd4e5Uym2BTDmKa1ru93oSsPPF1
3103	fee_transfer	641	6000000	1	CkpZ94Kps6GpMttjba6iYVVoHg8jhDzsYZuhuuWuUCbP973ahJh1p
3113	fee_transfer	1422	3000000	1	CkpZZD9ZZ8Tv7Su9hnGDfs9fZLorEXYyrmM77KY6dFnsGK8xxVDNv
3120	fee_transfer	1440	65000000	1	CkpYXQX4ticDe5agG8xNLKL1ECs6jjd3pdeNjLkt62Px9sXb2Ww8X
3121	fee_transfer	1440	6000000	1	CkpYpV6K6ZwgjvbTj5PADK2MzwQgPs4DYgiwCfuCwtMcNMGoxhNDn
3122	fee_transfer	1440	20123000000	1	CkpZZqgL1WFaiuBxb69ro3rvNRH8tp35prbf2rs7AvfyXGmoY2SLG
3124	fee_transfer	1623	4000000	1	CkpZ7BioSeiTUkz1PGbeZUsY4Sc8TeBAkcbseoB3CBMBJ5Qw86y7e
3131	fee_transfer	1649	3000000	1	CkpZCm3pbXvJimL7TwMtAyPHVUkHn2yajXkAtQg4LuEv9o9j1uTLw
3134	fee_transfer	1727	2000000	1	CkpZfzcrraciWmQVJUAQKueHxBV4upjq1v2kS275wXJ8ja3zREEHk
3138	fee_transfer	1556	52000000	1	CkpYnhb5WoRtBbbWu7ivAkkHcNhVZywNZiKLqWbZMBwzyUD4Ttj7k
3140	fee_transfer	1455	2000000	1	CkpYfKDXPxnoRVRbN8zDXfKhko3YtHxd8iZGvyoe998fCjkzxtcCf
3143	fee_transfer	641	2000000	1	CkpZQZpXLkvQAdFFxSZHh25nSKxt5p9457khF6w8o88YJ9K1KxQ6T
3147	fee_transfer	1716	1990000	1	CkpaBBpy4f5fnhE87xU7upM37t5Jjwmf4pzjFC3pYgAwD1S7RBo4K
3150	fee_transfer	1610	11000000	1	CkpaFcKyNu3DVJtTB7iuUB8CpHSRjRSanN6KGd69oSkiF9EbHHXMh
3153	fee_transfer	1623	5000000	1	CkpYWjUepvh5V71m5B97pKnbfAjes4NCkH41aWYGjCWxd5NdUF8Qr
3157	fee_transfer	1622	3000000	1	CkpYfVK2dmp92BemZrUyhQY1tjB9eRenWhNRBDJvryfXS9DvZZCvf
3162	fee_transfer	1593	84000000	1	CkpZZV5d59cKqbg4zMwfv3KQvGMs3wQqZZuVaJ44Ej3vmM3P2oaHg
3163	fee_transfer	1593	45000000	1	CkpaBS6v86hDpYRtfTJvm5JXRV8wrRGg2evYUwBcJPtToh529aix2
3168	fee_transfer	1426	1000000	1	CkpYXpPeAZVoCSz9jt7xtazo2cRnQPmeJyFx7a9tRAEZfwDQ8arD3
3169	fee_transfer	1683	101000000	1	CkpZYtqiXWanpbuY6u2oQ6Z42uUm1r8FsQHyepV9gaqZWq8gouNu7
3172	fee_transfer	55	190000000	1	CkpZkiuYe6eExCmNQcfsiWL69zG8ctSux29UMahB2EYrYHPNAfgyN
3177	fee_transfer	1423	20342000000	1	CkpYo4JfcSJm3jYiScCbLXZG8BRDBN8qybwMbTD8BNEJiAnZCV13g
3178	fee_transfer	1423	12000000	1	CkpaK9z1tjdaJaCzdkuSJheRWaLtHPBeSo34Yi1tmnQH8CwYGcdtT
3180	fee_transfer	1693	2000000	1	CkpYmvfjUVHPxAdFAqvcikR8cGpXamSumP2DEFXCMVW3zo3p5SiJk
3182	fee_transfer	1513	3000000	1	CkpZiWrrYyA1ijuKv4svPkHSCGoX8X9Z9ymhtrEoTd5MrqNG5W1DG
3186	fee_transfer	484	12000000	1	CkpYXNh7bvbLE79skrJmGWudPf1pqav7EfHRWvCUv8j1XixF4DYKG
3191	fee_transfer	369	3000000	1	CkpaHSVxXPrsFfHGNTHbkfVoUET5bLagMy38vYKki56eWQrKxPMxo
3193	fee_transfer	369	312000000	1	CkpYgzxYNo2P5UVBqNcHpp9TnBwTgnCP16RqcJ8aoehZXQd7LTN7s
3194	fee_transfer	1799	10000000	1	CkpZF4hhukoyN7VUYLz7vt2jUuxA5VL4xwhYhBKH9VateiepH9QPE
3195	fee_transfer	1420	99000	1	CkpZqc8s61NghH4BkxdXeb3TWgnxbT6ATN4RVU8SuoRUcyNBtnxA4
3196	fee_transfer	369	93891000	1	CkpZaqexcfiNK27Ra28NraGZaorWsgXDSmbFcqNuxRJHr27tfLMJq
3198	fee_transfer	1988	20	1	CkpZW6GEngKzHZ35YnyZwuJpPvkE1D1DTLC7NvFGZnpBzT5Ykb1Ty
3199	fee_transfer	1447	9000000000	1	CkpaHFU5vDP36s3CM1fsMBpdd97Ge28kX2ryPkUKELxHPyJtGARXU
3059	fee_transfer	1564	1000000	1	CkpYTfCh8AtAAKJDLee3nnJDMfSzNtHTy9mWVda9cV82ZjqWNDwWJ
3061	fee_transfer	1458	453999991	1	CkpYaXfqMSskLUu8HwUXb7rKoDRoPUBncnkvgr4vdFKCqGN2k3pL8
3062	fee_transfer	1458	39000000	1	CkpaGQTHf9LzaeiArg13NwAvBJupefBovTJFrQtp9KCySThFms3FU
3065	fee_transfer	576	2000000	1	CkpZKTq3o99sF7Vj7YCFG2biLixvRH6qMDoRPycq5b5kSSFLUh6to
3067	fee_transfer	1693	241000000	1	CkpZXrguT8xe76GhV4AkVtHkCnQ1NHZBZ3gRR5hLApnEWzmgmebQt
3073	fee_transfer	1657	1000000	1	CkpZRsPJPi4Uuif9Asn73TfbwdZVmXNAAvqnSbwZ57B1NfkewgqnU
3074	fee_transfer	1689	2000000	1	CkpZdhdc9rLBDKUR4EJKmsqaYLcJL5ubeeRyKRvycC5Uj4uioxotg
3075	fee_transfer	1688	5008000000	1	Ckpa9ScoV6hw62UckGVkd5nr5f1YVSAksHZHLoXbykRcEt1FXCoct
3078	fee_transfer	1458	19990999992	1	CkpZdc5Tg8EZyCbAu9yJDcP5U7skBcKaLYYL6PpDgKUoZyhaKfAB9
3079	fee_transfer	1655	25000000	1	CkpZyPRJVsFgBBG12Ltg2FrSRyQVJkCwkRZvWMq8gjm39aveQimHi
3081	fee_transfer	1649	4000000	1	CkpZVcAb6po5toLtEfZaoAZwRocgH5EZtpMgF3gMZWkw6b3J4zsYj
3085	fee_transfer	1560	2000000	1	CkpZMgwRjk13qbCEYKfwtdtwNpXBeeVpayyN6esaKsDTRLE7SCFcM
3088	fee_transfer	1702	2000000	1	CkpZMe8GqkFYYyTXPRo7VhdrVfNMNzHviQouUiBeA9AoK48hsyZDQ
3096	fee_transfer	1678	1000000	1	CkpZidsgS2Kxv8WFYrBrZ1rjBB5Qrkk31A9baxbp6iq89Fwekwpas
3097	fee_transfer	686	1000000	1	CkpZ4Jn5h4SbPb9WqpN94gZMmdUpsgNDKk77SpLah2DcNNqRTrxY9
3109	fee_transfer	1710	2000000	1	CkpZzk4w7kzbSwEeyfoAZVz6yCD7MeHJVPbQEtQb5m9U7VhPgn47s
3116	fee_transfer	1419	1000000	1	CkpZnhpcCUK7bZV4n6jHhGhi17AcMqMMRRMa8AspLK3envMgUXHqU
3123	fee_transfer	1402	4000000	1	CkpZqt1CSE4dNywESa63sB2suVWwzcezTPZZs4zLqbZFFtHSAeAMD
3128	fee_transfer	1699	1000000	1	CkpZCXYahgnei4LfK2QdnbiaYDzDE7JeJzo1D9gyahEtNKP7mptYZ
3133	fee_transfer	1675	2000000	1	CkpYkCDsMu6t6KNuXZS5MZSZU7LjFdXzqewk3zAAdMdTwr5VqEw1j
3141	fee_transfer	689	1000000	1	CkpaDsYwH4TLfAXomLDmXAMA7LZthH9UWY5oAYt9yn6PgA54LUYsg
3155	fee_transfer	1596	4000000	1	CkpYzfSkYrNYFKfaYYLvdCU79Y4oEsmphtYmWcQjsMd5WRkKqP5ng
3161	fee_transfer	1426	4000000	1	CkpZyqh9XZpbg9JKEjcye76NLJRyanR7cG8ne8KNCtRLmdL4UT5PA
3167	fee_transfer	1518	37000000	1	CkpZEVAJT7RGTHGLjYLB8WYgX2a9owRBRuXuWtcS4gYFDNm1mKSd5
3171	fee_transfer	1513	1000000	1	CkpZGR8u8x62e6eVykPgkjCKrJf5m4V9rPiEdNZ82M8zdwUbEFSgn
3174	fee_transfer	301	1000000	1	Ckpa95igpGPfMJrotMf28swXqeZnxzv8cagXyyGRPMsEBcKfzzSrJ
3176	fee_transfer	1536	2000000	1	CkpYmEix8zVXc7yMk3Ls5ExjdYd4Th1idNTXW3DQvY6GE4EeYoavf
3179	fee_transfer	1457	2000000	1	CkpaLPed3DGfJLYeqi3qEZS9v9ex2ucMwdDB1xUyewCrtsxwVBDLd
3181	fee_transfer	1549	3000000	1	CkpYm7ncT5x1RVGMxqmDLNWSkrCazqWGSfUpejReMLAv5edBjR5Xf
3185	fee_transfer	1992	32000000	1	CkpaK9fcd2aC7a1K7Ryz85oUoyLYbW7kPJwjKKenZddKcX8pcP9gJ
3189	fee_transfer	1686	13000000	1	CkpaBoY6YyiQqRGhZorRKkWdGHeLt679NLTmzBT5mFD9KJ6zZD2rW
3207	fee_transfer	1991	1000000	1	CkpZrArsZqJzrc6skSwQkPYHjDpz6yfnP599yGpnjKbfTMeh5djsj
3210	fee_transfer	1458	260000000	1	CkpZHifesLxW2M1GLn72FgqKJciJSC7pFYMnHpTcxiKbHhCvvxRc4
3211	fee_transfer	1458	80000000	1	CkpZ9mEeiX7h2kY93bMuwf6rwcqJu6FZ8pTTMsCThHxvoaD88F3dM
3219	fee_transfer	1522	112000000	1	CkpYaQd1YF4aWSMqU4rf12yY1g4WDBWWrpR5gJ3rAmxrFq1wgxFCC
3224	fee_transfer	1980	2000000	1	Ckpa4JfMqF9ne4hsCekYneWPan8Csv4VVwCTYCeD6ipB3pr3rnCCT
3228	fee_transfer	1447	2000000	1	CkpZ3rheWEFJ4dtGEqag2jMnhAfCjgdaVTbQpTLWm7pn7hgEvXas3
3229	fee_transfer	1679	4000000	1	CkpYRwALxb9t1VZRxH4jxvKRfk5Yh3KTj5G4FjW9BLygKvemo5wkv
3238	fee_transfer	1439	2000000	1	CkpYrNH3KdKzMLbXpw4NAi4r81y32Hqhh7UNHCDNy5d3mr549MUBQ
3247	fee_transfer	1688	3000000	1	CkpZGFsSLnq172CBdCbw1hC4CtZomLRmV1kfQrAQQYrMwUPkv1TPz
3249	fee_transfer	1518	3399000000	1	CkpaELDFBd6YFb7Tjhsf81ZAAuyQ1q8A9JZLyajKgxDdxN81GhRuA
3258	fee_transfer	1447	4000000	1	CkpYbooDS81CrrKUgtyHP4NwMDVBTQK8FXGXWXaLbnE32S2QFS9KF
3272	fee_transfer	1717	75000000	1	CkpaCsC8EPD6UJCUViW1BKGFraGAASvBY8829Xisz8csH2hM9hoMj
3063	fee_transfer	1546	2000000	1	CkpYmaqGXucVrtyeudEu7nrm93DhFqGJX4s5uTLaNpfbmuraHZJLE
3066	fee_transfer	1573	1000000	1	CkpZvCb2f6VUagkq8zsUUYYWeYgChmPtKQFa3MkF9e8P6bSxLBCZh
3071	fee_transfer	1673	3000000	1	CkpYnvfkn6AfnDpJ1yD2Qf6on18tP8gBDiRCLVhgpAmoGJSjUN2de
3077	fee_transfer	1458	20005000000	1	CkpYaHNtsesez19wsbGfa38KggL7Gu2CmpZwfp2z3b4EfqLJCiHNq
3082	fee_transfer	1684	4000000	1	CkpZ579kEEbS8yWt3KE6wGiiCBXnDWDBsrtpFsqBdoBBu98KefcBa
3089	fee_transfer	1703	2000000	1	CkpZ3qLnbMdqKX2151QpAfFFWrXS8rtobkhSBYMkY6zmWnP5SoZoa
3094	fee_transfer	1555	1000000	1	CkpZ5n2npb8ZUh3Pn9dhaesmjT8KMGLgNY94ZoBBdFT1bRXAtUtc3
3095	fee_transfer	1675	1000000	1	Ckpa3uQkj48SUPbf1yhbk6UVVFxMMGxodMUPLacK67TCDNfXUv4Pw
3110	fee_transfer	1718	1000000	1	CkpYxfk1Bg1RLsfNtYtYk3PbhiRR8NPpWUt88McSxqAGPFcg2M1Yw
3112	fee_transfer	1719	1000000	1	CkpYu1vKfCMm95JJ9TPhTFNsmYXo1PKAg3Z46rmbZrSMwHXQNAfsN
3117	fee_transfer	1522	1000000	1	CkpYcWdMv46Dh81aBVCvxKb9mSLPi8vzhACPcXBTv8XUnGbAFkGgn
3118	fee_transfer	1637	4000000	1	CkpZLytyquQNaPVPuKyBgeHfjLqKNj3BsT7rEkrucJ74xQLUdKCpR
3119	fee_transfer	1671	1000000	1	CkpZFXHtPDbpZ8gQJxo4FzMemXd3ufrWGXBU7haZ9RGmuM8xVWShw
3130	fee_transfer	1547	1000000	1	CkpZZ4AGstAJLZKCcusazuyGTXphbd1MJKWVfTK1huGruSRZNDJVc
3137	fee_transfer	1556	2000000	1	CkpaLaPaxg7NagfrtJHGXtwVPJVAe31nyxiSuUCTDqL4wz7VUD3JQ
3144	fee_transfer	1698	3000000	1	CkpZPBYetvqZf3j1R1UBdv9Cmkh7B1VwfFAZJ7VarLgfn4Nq7Z27s
3149	fee_transfer	1768	1000000	1	CkpaBWMRgcgXWDAveqHkXsVXpiNb7n4gkKUgNYLxZGySaHwPjUsnV
3152	fee_transfer	1705	5000000	1	CkpZrpmpRMnUYkA44CWHUqSX75iXoFfLGcCrBQoWjXhmyiPyeeadt
3154	fee_transfer	1677	5000000	1	Ckpa12p64d3z1T77EQKVFckco9YdsJZaKqq9514Ky4jjmeNACBekD
3160	fee_transfer	1729	4000000	1	CkpYr85nQjAEgVNC5EgaBCBe9Cm5ZNNo4hvPvHgUjF519p3sP7nPz
3166	fee_transfer	1518	3000000	1	CkpaFd1cwBzbDCt3iL5Fkcu6AmQRenPkMf14LxGn8Y12mo3Hw4uvA
3173	fee_transfer	1683	12000000	1	CkpYt569LAVqaowLSv2EK169mgWMWE6QndN9Ed6PHwESEdCk8KvJB
3175	fee_transfer	1423	2000000	1	CkpZhkLb5pg5EHKcW8bBrwjg9S5XZrdkj3b6XMBXdcgtjhe1w7YXS
3184	fee_transfer	1715	11000000	1	CkpaDL3CDFNNZzpKu9kpUvJxq1HqJonRkgpVdPuNJXJcpzPEYyHdF
3188	fee_transfer	58	13000000	1	CkpZGRVrm7BUHrgJWUzHw31aQaUR9Vd25zW2jVrJoPoPmrMz7quR5
3190	fee_transfer	1686	71000000	1	CkpZDSdTfycwkD2DUovV2LLT6FXjooVam9xaft9MsYU4VFqHAwvr4
3197	fee_transfer	1696	1000000	1	CkpZYKBRJks4yQWYSfom1UN3N5LQnXtWxyeCM5NxQdfJcuVwNJ3bZ
3208	coinbase	1520	720000000000	1	CkpYvkyc1jmnrhXeC1NZrGri7WVxjoshqmf7ERQ98AbupVTGXYLrR
3209	fee_transfer	1520	1000000	1	CkpZmBa2prkqwMgxt6kiNATXwGVJ3qgVnTrF4NgfduridydK3a2K3
3212	fee_transfer	1623	102000000	1	CkpYcpCyhif9WtwTL3RXkwwA6tZduQk5co8xQkPmb7B5uK39sNtDU
3214	fee_transfer	1672	802000000	1	CkpZY55aJWLXw4dvVLi78EMkVSoanV7XWu8ygLkMDxmQoyW5uU8rP
3218	fee_transfer	1419	101000000	1	CkpaAEah45fDSJj4EwxrPo5df91SHeWdwSstcQFchknCuxiiJJGgb
3223	fee_transfer	1560	101000000	1	CkpYkmod8qMRgKxs4EQB7zRPqaHg7VRRxur7iHmdggTiX3V1HCpA1
3225	fee_transfer	576	1000000	1	CkpYqD7t8Gfie5AhEbnQY36iXbBZqJBaKgE8wMNp3ssWTvkKcf2Zg
3234	fee_transfer	1692	1501000000	1	CkpZjqkZ7bHgXeVJaAowFzJ3FwDWC26oayFwBz3wtQTtYH7qeuoVq
3235	fee_transfer	149	2000000	1	CkpZodynZDDGadVqmW1nWg7egmBADPA1QxprNAyfhrhw8W723cLX5
3245	fee_transfer	1708	2000000	1	CkpYo8WWbAYAUL5aFh5x3ugc3T8Zv2vJtfGnGNi49CfNtAVsmyB7a
3246	fee_transfer	1991	3000000	1	CkpZPnycGGsAX4fPGVaL2N8R5KsDNUTtw8rCopmQqs2KorszXEN29
3248	coinbase	75	720000000000	1	CkpZ3oQynB2Npvm5NRRVWSbdEvLYVL5XCxNG4i6kjqP2i8ZvC5h59
3250	fee_transfer	1458	1600000000	1	CkpZLL8c7uPQqWKnKqXpEAdrzt6yM7BnTHxk1hs6Gy57HDa3BaGUG
3251	fee_transfer	1447	1000000000	1	CkpYtpPvuaQC8Tph13ph8fLfeqW5dW1u3YtVLjGFYeLaQrfpczM42
3253	fee_transfer	1546	16000000	1	CkpZkYQyM6ff9wMF5KJTnhLYmi2Bz6MSeo7riAwfU4CWwXqhn3BSV
3254	fee_transfer	1546	19000000	1	CkpZFLUQ92LmT8GZgUpgXMtPvj9fhthWfRvVf96NoTNT8pM7ypitG
3260	fee_transfer	1740	1000000	1	CkpZEWhNnz4dqXj59hSQbLorrT4tqdZZZ3H57YHU156SHGYuVnigb
3261	fee_transfer	1703	1000000	1	CkpZU616oQvkLRF41BRT8Uema4qsoN9yddNsJPJd56MhkBuDQfE1H
3274	fee_transfer	1464	22000000	1	CkpZzDb3NNLQQaZnzeKjHApoUcPRvNiWMkPtMA1er46c3KSXYuGr7
3200	fee_transfer	1696	10478009978	1	CkpZKCUPcPcY5L1ykUhc3M9ciCYLsPqgGNBQT9TJRBvJevexG3Dma
3201	fee_transfer	1996	500000000	1	CkpYYVnNK1xttpWECwUJrC5vNdetFxyPKUNSerKoqce7ZTVWmAWkz
3202	fee_transfer	2052	1	1	CkpaFK5vyLsQssc8m4vznii2FYRHXvKgHPjAfbqMUDN1n3kqW6ZXQ
3203	fee_transfer	1460	155000000	1	CkpYopP4VcXACjL2ikVJS5UDzFy6F8jsWvnjmUPmoXfyg3BMVwto4
3204	fee_transfer	341	1	1	CkpZqs1gsC1dGjB5RuwNcenmbXwHcVhjfSTugyAHibs2dDwHn9jhB
3205	fee_transfer	1603	1000000	1	Ckpa7at3vaQWNHMDvdTdHQYAEAwoJPjZRB4VbaFoqdS3xHiarYeDS
3206	fee_transfer	1692	142000000	1	CkpYdMuR2pUvpuxgdrV55Pv4nKiFQY7PY7WsHxUVrUNMWDxvU8vii
3215	fee_transfer	1677	202000000	1	CkpYfkXZCwxqDWiJE16CDKpe2zZFTJDK9fEGQcD4yrLbigEoZH1gA
3216	fee_transfer	1690	101000000	1	CkpYxWoPcKW3RF5u2fdHQwhRuURGQQPHec4dkYCj2wgU1ANNdAdVU
3220	fee_transfer	1596	101000000	1	CkpaJPZYVU2VAAcqZ7K3Et5A22oBB5uuJMXtwh3PKwpTUsJa3Qek6
3226	fee_transfer	1686	1132000000	1	CkpYWyTXVnC24bDNJpqbiMqDV62ibMSVFcywoAapzKwcfjcRQmsym
3227	fee_transfer	1686	5000000	1	CkpZ8nnRmW34QLkcUocBJNRXmbQXj66mAba1d5pRckp2tppbVrdPv
3230	fee_transfer	1768	4000000	1	CkpYgWhomSV8jnAs9odxbQWtJ9SPsAFooWyNT73uELix62r4FJydT
3231	fee_transfer	1422	2000000	1	CkpYeUrDEqzS3cocnbdUMDtDaLpa1BZWGcWyezqWG9fDz77cqYnbW
3232	fee_transfer	1991	503000000	1	CkpZJRtWpJY8eDWZMNs7bWNcnS1tkx7DRz9pZP4bH2Y6dvYYEXgwX
3236	fee_transfer	1759	2000000	1	CkpaDAiefTZ6sypGTsEUEn61xhBzXuTQimmK9AL6Z6CSE1Foqpf6u
3239	fee_transfer	1439	3222000000	1	CkpYjzznSDuNGUSvyk6H8ybwgtA1ryBGGjz2J3EhM5uSgX24cUt7x
3240	fee_transfer	1439	64000000	1	CkpZgWdxXmkjL3S5gnxgARq3PQRUuhbiTVGEG73k9dx3m7oNtYBVS
3241	fee_transfer	1455	1000000	1	CkpZr2eVdugrvs9ie4MoDoLT1DkTWoyATJ1y9JhkxtkLGy7q2ZzYb
3243	fee_transfer	1587	2000000	1	CkpZXm3u3sgVGyWLUKXHK9iVm1yF9caP5yfKyikCoZStxiG7RG3rU
3252	fee_transfer	1692	61000000	1	CkpZ2aCzfaC1q2iWmnt4i8RCLWZbqHhk2GSnA2sJF7SDxgtPg8yco
3255	fee_transfer	1422	21000000	1	CkpZ7MxU7zQLSUik9DNT7UNksu7K2pFpHLfUeDZxSCywPpRhKh9ya
3262	fee_transfer	1702	1000000	1	CkpZri9NXJPr4KvQrU97shWVUVQbE6yZWrUE47wGa573L5sJzfqMh
3265	fee_transfer_via_coinbase	1527	999999	1	Ckpa6J7EqmaDmUbcuamooAuWsv2596tSsAVuq3ypcoFskEdnNq9wR
3266	coinbase	1688	720000000000	1	CkpZY6yJMy2VqmMCjE7bTq1nnuGqrJ9ZEFVubtqwPdnBRp4rhHtUv
3267	fee_transfer	1688	9000002	1	CkpZJxKyPoykpS6rCzjjvdfTNgC7gQuNA8rRZiuptUfLequ8f7Xs2
3268	fee_transfer	1527	1999998	1	CkpYU5gUEy7vSk6FuhhkibyZdzy9RuLhNQFRYKYzk1xnNe4HUS5a9
3271	fee_transfer	1700	45000000	1	CkpZ7tPTStc8AYPikfyvwhxe62xv7aLCjfVPdP5di4i8YMv2mgaoc
3221	coinbase	631	720000000000	1	CkpZf8gaxuq1Y6gPi2HqLknzXn9Zt7YpcEFcNDPZNeCWYnZvU32Xn
3222	fee_transfer	631	1000000	1	CkpYgqY7e2qT92HcifE9MRqBiumhpSpcXUGn7FjP1uBAn5X9arHVH
3233	fee_transfer	1723	503000000	1	CkpaFRfvGDjbm5tSYScg8rRuTu3oCV5LRXabf56MM4D7U62fkEgh8
3237	fee_transfer	1594	3000000	1	CkpZzBR6pB14Rb66UVRXu3yZAsPS8xJjwViuKT1KSKRjMrMVkZBdz
3242	fee_transfer	470	1000000	1	CkpZtPnmbKtScheNk3V6vgtfMtN48gX9cb6oAStmxPAXdHpWpCAFE
3244	fee_transfer	1451	2000000	1	CkpZtYMiNfHUPeXz3RX3GJtFmB5Noedp6on8m8mJPWn64Tx2GespH
3256	fee_transfer	632	21000000	1	CkpZaG1jedvQsR3Wt5JuivnQCjsNiGyBXZv9b8zJrVxta4oTKKJ1L
3257	fee_transfer	1759	21000000	1	CkpYU2kd3yPtHQHkEhZmS3DwPc7UYy7ouLV297Vj4EvXAWoppjjXU
3259	fee_transfer	1690	4000000	1	Ckpa2NEK7Qa2aQJWdzunLxZdzJvWwKk8VR3nit4eifeSsaneSJP3z
3263	fee_transfer	1689	11	1	CkpYxRNK1LZ7nxWa3N94fwoUaNNg7PQdsoMqHumexkLP1xvxy6q7H
3264	fee_transfer	1527	10999989	1	CkpZYzHSAXzZasMPURu2nkg94jEpLNVCo1rLzxw6Pk5no4CFYKDfr
3269	fee_transfer_via_coinbase	1895	44000000000	1	CkpZnxC2N2bb9KV46G6dEUFmP6U4XjdeMNyvx7EnRdNCveffFxMyw
3270	coinbase	1700	720000000000	1	CkpZKcnBRvQc9zYA17Hfqd13oRznUb6dtdyCxKpecigubaqZmUVs2
3273	fee_transfer	1549	22000000	1	CkpYhpCRGt1UmS2QEz23yz7VKZbaU1jAXAAcXuYBqYfHP9pbQHYWu
3275	fee_transfer	1455	11000000	1	CkpZw51hXK9xEQFFLVKddQJfQw8bF3DgaCCCCzmgqjRZYHrpuSYag
3276	fee_transfer	1476	33000000	1	CkpYoGPwbcaciuWUVoYbVufyyiDiCkjnGsFFA5Xr3Qf92gmZTTf4W
3277	fee_transfer	1623	33000000	1	CkpaLZ4dGcESmhBfDSPns3TGcFMNKKsqbtUMQA1wDEDG8JrKC9diN
3278	fee_transfer	1633	21000000	1	CkpYTyEA9xBkLDJjEg4jWXQVWNsaBSCHuhbdh4pDQ3m9sJFBPVq7N
3279	fee_transfer	1605	1000000	1	CkpYtJxifSDihZVGruGBGJQ8cVwW6PNZW8d2g6AzHTcFNhiTqceCK
3280	fee_transfer	1709	23000000	1	CkpYt29Wt3pLzPJriV7WRMZeHrVuEkBLHkSJeQgP7iRWtnHyT15R6
3281	fee_transfer	1610	22000000	1	CkpZNzvfVvzwS9CT12RDEUydxevQfeHuNGKwbZbBDgRr8VHTpbBFD
3282	fee_transfer	1615	22000000	1	CkpZsV7ZFqpEcw1qHwDFYBknZ7jhhQbBG6kG99K3AQ8p32S6CrvNB
3283	fee_transfer	1588	23000000	1	CkpZQeKhp8fmLy6HcCLz5qsxk72n8EBGxoHoTwvJrqWX6im4TUTTS
3284	fee_transfer	1467	23000000	1	CkpYxasSBKmw1AUAUW6eb3EENLd7BZUJBFqq1e7FVex8szvy2S9Cp
3285	fee_transfer	1746	11000000	1	CkpZbHhEqtNnbYSiCo9csSxZ2qXjBF5wzirhjnXysEBBrLtt55FFj
3286	fee_transfer	1747	11000000	1	CkpZtLY8joHJznM4wjWZ4gqxCiRwBbBG55ggrMBNQnyxUMeURXzys
3287	fee_transfer	1704	11000000	1	Ckpa7h6v6D9WHJb12H4VvkvrcZ5s3PTaXuSQtX93aRG32sRsnVscD
3288	coinbase	748	720000000000	1	CkpYowa7keb5gBmMRPQtfbDkxt6DVD4RmUJwdttiSDuKQH2FuTiU9
3289	fee_transfer	748	22000000	1	CkpZvHDMiUXroTemwSgWABw7KGzjP8kbVozj9jyJNZUYiER9Ge2Pb
3290	fee_transfer	1613	1500000000	1	CkpYaV4E82JQos4SVLJnwrw4jcDtiHkT6c3GWWxiD9egaYWhbwBfV
3291	fee_transfer	1613	1017000000	1	Ckpa3aUy5TVk3k8EM1wBPRPqrxJBbRVLkNLmnGzd3fnqeihNjRZAN
3292	fee_transfer	1613	33000000	1	CkpYgLAN8C6inTcJttqvLko6SRESafZN2qYTaYqcyb6XZjx5ExfaN
3293	fee_transfer	1419	22000000	1	CkpYuMyebrQvSBJpetwBTqjRofudNDPpQ7Epxg7acPna8bCo8PNbZ
3294	fee_transfer	1675	22000000	1	CkpZ6xFik9emEasyweS4rmRGTANYvaTNavm9VvhraFiXERAwLyZiN
3295	coinbase	300	720000000000	1	CkpYcM4ji3TomyvQwuWTruzZhwoGDG16JUv6btyCha6BZ3NCiq4jm
3296	fee_transfer	300	11000000	1	CkpZZJx1pD65jTyDBnJxfKSCxHaq1EDudYEAFNVRGFVWMAnzZMzoc
3297	fee_transfer	1701	11000000	1	CkpZwEa1ffxsZkGsk8NCvcer1v4cdRudTfcrutKZyE6E8m4qQXCsX
3298	fee_transfer	633	22000000	1	Ckpa2xF3yjZ2ZaT8tXqbrvn4wcGqrKfkpkkg9sH3dwgT1jssoCsud
3299	fee_transfer	1686	51000000	1	CkpZ2jTevZTB8hoDZ1pGumxa9QgcijRe9CdTLfjZwgjsNJ2CVD2xz
3300	fee_transfer_via_coinbase	1472	555000000000	1	Ckpa4fz2xmRYPPawVAUmaEUw81VAMVTq16XUErrvMB3SUtzNVyWZp
3301	coinbase	1686	720000000000	1	CkpZK9hPzHGAsAD34mwJLZj6Ctswdv5rUMV4CbWiY4N8FjKzhK38y
3302	fee_transfer	1687	15000000	1	CkpZ5t4ZbMxs2Qz9rqfAwM9hAY3Znjz4SaHARj7Y3PdwQhUQciMPy
3303	fee_transfer	1692	15000000	1	CkpZyR3sD88H2h1e3J4yaqhWoJxeL6hJtm2FC3745xDbGcLGK3vUA
3304	fee_transfer	1723	44000000	1	CkpZoN3GjSCLzKfXuv9fBcGuTPg3GuPTFq9vc9JVQPHvtgq7tNFV5
3305	fee_transfer	1643	22000000	1	Ckpa8w58V2nSppJpycM4SdWHAdPsHKSq3XB8jpAEYaL2tihVcux52
3306	fee_transfer	1672	88000000	1	CkpYfzubjYtyRs8Q3goPTDnvVN1WowqWywv5SSw6xj1eRm1M9SK1J
3307	fee_transfer	1672	11000000	1	CkpZjLjA1TQGhpWQYM8db8tBX6JKVnsrmj5oDTfjrGCREXjNvfSNr
3308	fee_transfer	1633	11000000	1	CkpYm81jbjPiFAvKUd7Q2sx7yd9n3DQtxbhNWo5hwwQnfrQYjQ5cf
3309	fee_transfer	1719	21010000	1	CkpZ8aTXeyZLi1AAr4mcwo2gzrJ98HwnCBfc7t3Mqp3vZ1f7sow6R
3310	fee_transfer	1634	11000000	1	CkpZ5vUL4Ak5WSSWJyh7PvxqQDK4drYrmTM4xGYgWuWeYrgCCPbcx
3311	fee_transfer	1634	10000001	1	CkpYToPPoAUsk6ykZYc3fhQB8Vp524JQNHycq9XHWicEvywsQooNZ
3312	fee_transfer	1506	44000000	1	CkpYQ1pvMF2g2GZLafwbACdhFu71xnTWAjiREEyGosXwyAie9JhuR
3313	fee_transfer	1708	11000000	1	CkpZWM5YAY7hwa2rXzEdQcxahr5jrAGMULivGRFfqpvGZW74DUm1p
3314	fee_transfer	1509	33000000	1	CkpZP4QhWENs4vhCfTTZtuKbkybcegBGkzJ5v77m6MKVcZzgvCSh5
3315	fee_transfer	1564	33000000	1	Ckpa59J6sTZuGWmtasknLfc5MJhnuVe1U3oUse7HFx45LFMSf3b6v
3316	fee_transfer	1762	11000000	1	CkpZ71jSyHKNebD2m17vTXro93LuxBwNm5uPHwnVwB3YfaZ2maUoK
3317	fee_transfer	1740	11000000	1	CkpZqkDtUDXADaGXLXnnXDFBtseUTAMW1WXXxH3d7jKPe5hYSeR7M
3318	fee_transfer	1716	35000000	1	Ckpa6S4Dee3D7L6r2CgdH6xeyRUQyNosjwBNQ7KRiPNhzdpee9wLh
3319	fee_transfer	1764	22000000	1	CkpZtpiYfWDWqW929TNbUJv9Xo9BUKyKjY3YgBRU2CAviDksRC28v
3320	fee_transfer	1681	33000000	1	CkpYRub9ZbPTvPeWG3MTWR9W3L9m27GPoWVdEcd5kMv81kovvjQAw
3321	fee_transfer	1622	11000000	1	CkpZJKsVocEY7PXc9v8eYi3baBwmAkFsuzYZx8Fn5b5p55NPHpuvC
3322	fee_transfer	1509	11000000	1	Ckpa2bYME1MkUpKDdcTEaBnSAPfzeZD8VqSkTsSETmiiN3qbXWYWo
3323	fee_transfer	632	33000000	1	CkpYwMk4J4X4zSuq3GQVsvN62mXQTxuK9cRouuyFGpErafLdJz1dL
3324	fee_transfer	1850	33000000	1	CkpYaGCJQ5h2uKu9bR6Qh8umzAQkP7nypzdw66hm2hkZnKJJPYPJ1
3325	fee_transfer	369	33000000	1	CkpYhx3AMnGm68jxscdfoX42VrWNvYq6bduAevmEPPVeMenFHWKHx
3326	fee_transfer	369	3240000000	1	CkpYve4ZwKDRLC2VzehvQPyy22JV5VbwENZ2mxQ8BftGsfttnk8pv
3327	fee_transfer	369	870000000	1	CkpYhgJQka7iNSEoRvxYJTiXAnLwKSBh5q38KKhzQ4kqDa3sKFKz4
3328	fee_transfer	470	21000000	1	CkpZy4SETPf4pJRVb9oV1RTgCkvbyas3XhaL4Rz4J7TQHN2sL2vqR
3329	fee_transfer	576	11000000	1	CkpYuRfDeGn9ro4WVBcswLL1HQg3AD7b2MnSnp7HiWzXeonWm7psU
3330	fee_transfer	1677	34000000	1	CkpZzPdvzpsC8JVcKw4oyae7YPFaDuWHsuJaqKJeXTtjjzBwz4Z1s
3331	fee_transfer	1692	34000000	1	CkpYo6hBi66BYVZC9aCn3ZbJUXBnUMZgNiTn8cYikZv35tDDwcUFi
3333	fee_transfer	1699	34000000	1	CkpYd4HmrhQLgzTs2dYnsi54qSrDysDgR8FeZZez1kzg8xyydskWS
3340	fee_transfer	1422	11000000	1	Ckpa5y6LLa8hLhNErfA8Q6BCBSCgF6kVc8xPKTQFiMif6qfpCvbVt
3342	fee_transfer	1671	12000000	1	CkpYZFwefSRXnpzMzXXnLUrdYSFw3EAzKDmtXawqCLh2HHUmHsJT8
3348	fee_transfer	1611	22000000	1	CkpYYoaWyEwfwqsoK8DD4Vi2wSAMgeMzeW73jmkakjFHWF9Qt2cfr
3351	fee_transfer	1654	11000000	1	CkpZx3Jbxymah25h8RFc8bW83Pxb4d16Tw6cEHkMYWka1ffQFVHxv
3352	fee_transfer	1402	22000000	1	CkpYv655CNbAbUVQQdjcHS8i6iRTNYakF1EvfabgniePvYha5vsSn
3356	fee_transfer	1701	22000000	1	CkpZXwxdDdugccZtQYwZ6D5QKaKDGECwoEyXRsMasdat9j3u8VBnS
3359	fee_transfer	1675	439000000	1	CkpYkd42sroq3woYD3gLEu2PCUnGq8kJFmBFCsBctBRVBorib3WuW
3360	fee_transfer	1675	64000000	1	CkpYiYythRgKytuo9DKw8GvaZP3HPYf2Y2mbd7z3pQiiFS4LBsHwv
3365	fee_transfer	1729	33000000	1	CkpZLYpRBqcw26dCFj4E8eK5GNoheYDGbwbcUrVhXSHWYVN9kQKXr
3368	fee_transfer	1850	11000000	1	CkpYRtaB3xAAwZvGtMjZqkBP7KAYGqQCvnxCj2WV7LtZQjMKEnKj9
3369	fee_transfer	1637	24000000	1	CkpYVxRo4YiRQi9xi8R5wYicepsBD51pUpRnq1eVhAb2BFUoUqY9w
3374	fee_transfer	1850	31000000	1	Ckpa942sm2APaXvf35nKivX41gSe4kqZhuArsZSZxfmq76AexWwKz
3386	fee_transfer	1672	13799960	1	CkpYpSn7gBkVxibswt2zRj1dTAaF6MRAoxdCk3ubvihCWtWWrgJrq
3387	fee_transfer	1761	100000	1	CkpYv43ubpcggJGpsF8raMSZYTAiE9EwP7Fvo7j59MfgDe8p9NVSq
3388	fee_transfer	1571	40	1	CkpYSg16hcFtRzfZTHGvCiTe52fPVATt2RbtKACjvCuYATSgaaZqt
3395	fee_transfer	1762	45000000	1	CkpZGJPLEDY9cRkf5goL4Rxmjhs36pfhQfcVoK6y6TNQBjbHmrcYh
3398	fee_transfer	1690	15000000	1	CkpZjHSkoGPFsQ17UwqookZwnyDY378Y9s2bKXGxwkzUEUWGWXQQB
3400	fee_transfer	1588	12000000	1	CkpaDuhdrDLwvYdnrnkJNyWU4kCjYicUp6yhQrMrVGvmpxpdBHniH
3403	fee_transfer_via_coinbase	1761	100000	1	CkpYv43ubpcggJGpsF8raMSZYTAiE9EwP7Fvo7j59MfgDe8p9NVSq
3404	coinbase	1471	720000000000	1	CkpYZ2FL1RXW4Zj78P8PDgxRqeXwkXEMUxDovkPasJsYfJoGoRzHb
3405	fee_transfer	1790	1900000	1	CkpZ3QEpPbz2hb4KFp2kVyRBfzNWLVxjhAhyUUCmtzTMCZawUk5TH
3406	fee_transfer	1761	8100000	1	CkpZesd2XAQCmmxzCw5BFix8n1DD9RGz4qnUao51WFVsY7JVfjzCv
3411	fee_transfer	58	170000000	1	CkpYXnKWgb5DR6utUuWiQT8JCcDtjNPiVwhofLa36eS9q1aYSDkAy
3412	fee_transfer	58	405000000	1	CkpZ42cYXGd6yd2jbMUb67Mr3wMBixYLxnjQDorGTA8wdfNXeNatp
3413	fee_transfer	1739	11000000	1	CkpZyGANETjttMDiwvfa4SxjoxctJxfZ1Ue5nNXwdvV8YM7Xihc6b
3415	fee_transfer	1690	45000000	1	CkpZ8jcHamwfCtxvHku97H9ijgMiqcyKuRLqU3hR5mR5NXZDnjam5
3416	fee_transfer	1447	43000000	1	Ckpa2mmt63Byq5469xySPX55EXLGYSjktcwScRJwLHnp36fLp6ncE
3421	fee_transfer	1719	45000000	1	CkpaGvVigNrcizucLhmksDWiaxVVjH2UKoXHtiBxzzzxuz54u5v8B
3425	fee_transfer	1714	11000000	1	CkpZhaoaPUm9LwR4vjoh49DzWfhkgy3Dpn37PjXjvbRTZvPg1aQfD
3426	fee_transfer	162	11000000	1	CkpZEcNdK2mM3KTuuwxWQfJ8eQAEQHroHSxDnxMpQZ359eEtE2JDF
3429	fee_transfer	1673	22000000	1	CkpaFAWkHYjtyRZ3N6MQfZ9brSURGv6uDKLzi4eYbPEvxZeAtcK5E
3431	fee_transfer	1546	44000000	1	CkpYfvrPaNVRw1Fsg4ToU53vDuVyB3UYEC69AQ5PmZNV6KANnT1Uv
3440	fee_transfer	1634	2000000	1	CkpYzzdFFrcVzRS7WFEHSArhQssXgNSY5TG2fsGE325yis2HscKy2
3441	fee_transfer	641	11000000	1	CkpZWCpT4VFJ8CuSncWGrABSfu2oDWmtyYCwQrG3eyeAQcxDemcVJ
3443	fee_transfer	1686	11000000	1	Ckpa3Ne9uLPp6hykvCw1nMQ3inTCSetFMrygBXjWsoftNtwR6REPf
3453	fee_transfer	689	11000000	1	CkpZW2KGNj7mLeKPwSvRZZshzambLEmv7qJ2HpjEfoPNyUuby7xTL
3456	fee_transfer	1638	11000000	1	CkpZvhqUek7JAF6BdfJ7Cw7ctFYhUWLktto9y3MgDHQMGGZePwYig
3459	fee_transfer	43	122000000	1	CkpZcCLtTXArt5zXHGaq4Qp5SAfvfgw5zVUrivbsm3sGnL5gE8t8z
3468	fee_transfer	1688	81000000	1	CkpZg9nWRQCBoJ5o7u7yQDMVH5o5UJijC6q3AYmfygndTW9AUrMLf
3470	fee_transfer	1546	53000000	1	CkpaBz6Nni2ECX5C87ndi4gSH4sseLeVVNc23s6dzMpct4RP83gfU
3473	fee_transfer	1710	62000000	1	CkpZYRanFxzaNoMHVXVDN3agSPcYJFHgPtB5gjxR11AMF42iZfknD
3478	fee_transfer	1547	32000000	1	CkpYRaQb1rfCa5ao26NszgdCWUUQ9dciMm4NJUxA4a2GsYVUscoWs
3479	fee_transfer	1746	124000000	1	CkpYpvub32W9VcReM8JtuGyYFZDStcd56M6q4ARfVDQSX9k1msBJL
3482	fee_transfer	1637	124000000	1	CkpYa7hStyLakULfy2hAPJ8XEbQo6Eofu9shRmW2Aws1L1C9tgCmG
3483	fee_transfer	1489	12000000	1	CkpZ8NUAPAPEDy2nJsYjfdPpvZPxsmA737d2LSkSsK9dHPNJgzLZx
3486	fee_transfer	1474	13000000	1	CkpYWGqz4WtEKfUWB6bVR6F2L5sRCn1wDqhgV21yqEzaHpYpCykmR
3490	fee_transfer	1683	125000000	1	CkpZBHHMuWh1cG3rN3ZLMHXwUQcEpboy8fnvHsxVLPeTXquxaoLdt
3510	fee_transfer	1679	13000000	1	CkpaBXMoae1kV6Y2SicYTafobzH5TGnuD4FYtWCck4vKs1ChB25D3
3514	fee_transfer	171	12000000	1	CkpZgsCH8c6btUXWd74dE8HHjAWaFhq1rnw1sHFhM9QJiLXwdgH4n
3516	fee_transfer_via_coinbase	2084	500000000000	1	CkpZbe4qVsia5WwZSJXXbvmaVLe7P9S4XKGBJhbg29JpLGPDga7L4
3517	coinbase	1455	720000000000	1	CkpZZYNuCZuGJbvc5NweKfu9jQWoYAjxRY1rUSkzVAZz7K462fuqZ
3529	fee_transfer_via_coinbase	1790	1000000	1	CkpYUe94WYD4UYQcVhRfSBqRdV8C1BsHSv7btFLG5BhgUYKx6wAqL
3530	coinbase	1739	720000000000	1	CkpYhHvoan4WNDUQ8Lwt7dLx3hT6wMSobz2EapExaVqbZuGMyXGrc
3531	fee_transfer	1739	13000000	1	Ckpa9FtSX3bxVyXBDMBDusdDHv38fWYKKrUULA1S7p1NdHzePrfKF
3534	fee_transfer	389	26000000	1	CkpYkiWdPf4izWKcL8P3YmdQ3QQ4v7kvYhqDiLa5Gio9YK4SjMQv5
3536	fee_transfer	1711	13000000	1	CkpYx3gLMbvNMiuNDHkaTSztM6u3tLhfvW6TmcUMsjguR5sPfiFX4
3537	fee_transfer	1420	39000000	1	CkpYxAXUuscV4dEkmg7C3K1MSy1pNbGiEEqjszKit6RSveMpWp3wi
3540	fee_transfer	1710	39000000	1	CkpZxF2FSZrNncjFk33aL7HW5RbRBveVqHnHWeDRk9iEy6np7QLA6
3542	fee_transfer	1690	28000000	1	CkpYzb7QssbpfjxRjgpFwmumVbLFVHZr7RQJDdPdQneP4udNJYe4K
3544	fee_transfer	1513	62000000	1	CkpYcR6Btkk5vFgtEebesjBBarfK9xXH8wC3fBayRtwvbPL8Zimod
3553	fee_transfer	1402	54000000	1	CkpZNKeNMfDUw2zKeutpm838k3EL5RfTEcNdkZfXE4Qy689uhVRmm
3558	fee_transfer	1402	14000000	1	CkpZy7bpf1YXETBQokfj7LrDTftAawsnTbU8VfjPu4KNQqK4nG2Uc
3567	fee_transfer	1594	55000000	1	CkpYWgo3zhwbAxBrfMbwrCkx7TXP2z6fzy1kgnURYP5tb94JSqh5y
3575	fee_transfer	1447	24000000	1	CkpYxpZeiuAHjJgbHZCeDqhGfC9XJSZgrMudfLCrVLc9Aow2NpXgB
3576	fee_transfer	1594	16000000	1	CkpYqHuEDtPKoTenJErS1acfavWZjND2YYvLteRUJa5xwaCmDFEKS
3582	fee_transfer	1677	6000000	1	CkpZR47GmrA71x25vxfxMxPKgM8MgFuLqurn1B8AddX7xc2Gt1W9C
3584	fee_transfer	1739	24000000	1	CkpZpPodTH7Q9LsM7T5L5uBEVG8U1XzY36ssD147GzhCYYizSzAXB
3587	fee_transfer	1698	24000000	1	CkpZaTTz5nQCZUhdnp2je9ctwXE7XyPiQEvUTSoSnr4gXXk71Yphj
3332	fee_transfer	1588	11000000	1	CkpYsdBHjEuDGdjCFfYAMTH5EymaGextcG68MpiabyzshrVgUgJto
3341	fee_transfer	1693	23000000	1	CkpZFeeDR7RjhY8a9LQspfvn2mejrjcCL2yubfiG3UPqHxzLLFVTk
3346	fee_transfer	1703	23000000	1	CkpaLEbGUAsk5bWaMPXSY6qeLh3kfxWpTGs5xqN5qxTZxaVMbvSFA
3349	fee_transfer	1677	1998100	1	Ckpa1TdEzgPrXP9dVwqiYVHe737y5KQp5WcjddaGTAiYfmKqKVAPD
3355	fee_transfer	1601	22000000	1	Ckpa6pYLafJJeDaFCDDBBLL1JTYff8kSPUaSNSjgS6dEc7QAFsZLo
3358	fee_transfer	1675	33000000	1	CkpYqTV9T2m9KYiS3zMHSewJDBXsaSxayv6uPWu3SWXiRJKECzkWx
3361	fee_transfer	1692	33000000	1	CkpZWXM94HmnD6xb5cc88n5XimMw8boHbVU7xDpsvY8b2L5W8oiKk
3367	fee_transfer	1675	86000000	1	CkpZdLpVBHhFqeJG9QWchLwLHukBcT2TRCjQNqT1N1vci2vuPfjGt
3370	fee_transfer	1608	11000000	1	CkpYV5kwCNRBh7yzsfQzuN9ryNhXaa7YgdNBnF3MY4btGSXTTx38h
3371	fee_transfer	1729	23000000	1	Ckpa7JLEKyp6YuUsEQyaSyBtkMxyDprJ8iWw33GUdKoBPkEn7G2wt
3372	fee_transfer	1729	21000000	1	CkpaHxeWr7JxzfjKwkkbEW1h9BqtTNV3asKUZxshXm99hjvURAX8M
3373	fee_transfer	1690	32000000	1	Ckpa4oihHicatpsymbcMYzvhDjAgFqNxT6wiMJhwi7quQ9qTbDSef
3382	fee_transfer	1451	33000000	1	CkpYoR2q4Z59XG3m52WmE6MLFteq6bnhqP5EY4gBpZN5WwHZX1wdn
3383	fee_transfer	532	11000000	1	CkpZPbFvN8vy6vJ99NQHrqxMM75hGMajaCPGg3NH7aGzm2ZiHJj5x
3390	fee_transfer	1717	22000000	1	CkpaCh4aScfjLD8vvJYZjtPyp971v1itwKAUmuGs1onyB463egn2Q
3393	fee_transfer	1677	12000000	1	CkpZc9UpxU45YPWbLiGQGxaLTEQTxSUhZQ2bCcZeZf3pMEJMNkMNZ
3394	fee_transfer	1762	41000000	1	CkpZvreMDC57unHpcDwmJtj32BXzgK1jc5Tv18MmCLRhpc25n9hNR
3396	fee_transfer	1680	16000000	1	CkpZDJiDmFiSmwvRDXAhfrBvkaeCiQJyH8qUUcVrcS3qJYPUdJ7Yu
3407	fee_transfer	1471	9899991	1	CkpYe26WsjzdPhGS4aDot5PxhrDspUq6oK9gwVKJonEPV16iv8bd2
3408	fee_transfer	613	100000	1	CkpZ3LvijTudrLMinkbFpc8PGzNukYdLhqNUFFZ2HPgJUj9MKgsNK
3410	fee_transfer	171	31000000	1	CkpaLY7gZoPUr7YG2DSvPMCiNGv82Wh3K4bETWJ3MbyHnZNtAuixS
3420	fee_transfer	633	44000000	1	CkpZrdxvjHeqTD76eKs8d8uiaovCjqmC5FNqmx7hFBTrAMb2SxFeQ
3428	fee_transfer	1509	22000000	1	CkpZEdNL1csojZ1s9bwQFr7kZHK7ZeKdPC1UvmvpXT2dfCmm4aynE
3436	fee_transfer	641	22000000	1	CkpYrSfrtzGbUqxK6jitKwFUWQuB5yvrrTVyGHhTyPnELB3eTpW3E
3446	fee_transfer	1522	22000000	1	CkpZviFEBZnFNGS4o38VLNdZ7AyWtBJKVJ9Cta9HM7vqi1Ag9182C
3448	coinbase	1536	720000000000	1	Ckpa9vUhQUtdPnTac5SpMRYyB9ZtTpCrcSUy6WMKAbuQcNFTjFKbd
3449	fee_transfer	1536	21999960	1	CkpZiophBPGtbSNCkQsNeuBJqJu8VhzoDtsMXWxztQk9i6D5HbGjC
3450	fee_transfer	1988	30	1	CkpYnjbxojYqCvPhcTkbZXaaB8BTTWZtPgJQYPMh9CdcYFyFvJMNB
3451	fee_transfer	2052	10	1	CkpaGNzRQgxEHPKqfAcgxTiCAvU1NiQGNcoyv7x9uJa8mDoFkPKDZ
3463	fee_transfer	1992	22000000	1	CkpZpByQVFbvae7HpLhbYqpspgdr1wLijmFJ2u5t9JWgfntuZ7sQx
3469	coinbase	1402	720000000000	1	CkpYXD8mRKtjKxtdHu9ksiGecbnwiHsCdauVGimjujMp8cDvgr1pp
3472	fee_transfer	1688	123000000	1	Ckpa7mvkADasAqXtMiDiuTnskq696QVbRU9h1GWSSvVaqRgjyceHS
3474	fee_transfer	149	12000000	1	CkpYsWPQ7w2HFM5W4LUAE1yAQ6CAPZcVrLFxbfYSrq7pzeaPSGnvd
3475	fee_transfer	1402	32000000	1	CkpZb84swn4RWCQ8HQS7Ri4jVrqvyt7JaN3aoFheDtsnNDhfhgzaA
3480	fee_transfer	1747	124000000	1	Ckpa2xYgTCNr61pwEuuq61LyUCqxVxgcWEuFJZdc4yhGvP7qXt2Md
3484	fee_transfer	1678	145000000	1	CkpZm2EK9oXGgaZMMfLwkfcsym2fJWhTQAFVojUJJgsaMidzmmj5P
3491	fee_transfer	1654	125000000	1	CkpaEwhkiphmzfniibpJpAKaX3qjLiX3AjXiahP2eBJbuo7pit54X
3495	fee_transfer	1749	12000000	1	CkpZijhS3zAGmMRCfdAL9hRP1WnnaA8d2g7afZw1p3wuwkSYnxEUg
3497	fee_transfer	1686	12000000	1	CkpZg6Ucyhg8cDjDPzE7GBe624pP8VucggDPUWnXw1WFe4Yww18qK
3498	fee_transfer	1684	13000000	1	CkpZPyLHDi8wp6A7o9p28aVR5BT6YjzX251umuvWFekU2dxyJFrQF
3501	fee_transfer	532	13000000	1	CkpZCS9KVFA9Jt3LQqskkSLpvbKZ6nuZPJPqhbSjHxE1Kbq1yqiWo
3502	fee_transfer	1718	13000000	1	CkpYys2an6uwdKWNuxTNRzaDYfFLaPxk5otFWdR6hWX1QwUD2pxzi
3505	coinbase	1895	720000000000	1	CkpYsKtmbMRQGQ7X7ER7iKUJLAtRfomtHUAXr2S1KzAgSeRd7EoZz
3506	fee_transfer	1895	12000000	1	CkpZeKioTWc4Z9anDfSsYr1AzPj9MVeBci7ogutN18pNXrxYPxRyC
3508	fee_transfer	1596	13000000	1	CkpYdcp5rdLt9HPGt4oLrbqErt4fB264VmodaX8BJfjTS8n43KPVR
3515	fee_transfer	1649	13000000	1	CkpZdNbVx7ifG1UH3yKZNaYKUqB7ZDzS3kk8tmsueub9ogTsudYyS
3518	fee_transfer	1699	13000000	1	CkpYwdd1kJTtJYwaBDxjH1YZqprL66nuWs2z9cuaijy2AnDAbmMDh
3535	fee_transfer	1610	26000000	1	CkpZHESHgaPwoz3QWpwYkVcLRot5QwiUdb8pwgy9YZXYYgZxGWc1U
3539	fee_transfer	1711	12000000	1	CkpYa2MLbAx68Kd2UP5gin6td8LDnLGi5LEoiMk6mz3mpX8FzRBeU
3541	fee_transfer	1679	39000000	1	CkpaK6P2KRygBCFJwGeBMYrtoyTiVLPEZBhQXw6SnoSLPWd6Sv3HX
3546	fee_transfer	1637	13000000	1	CkpYbPnHLQ5m47uZPVWWdM8kDrsZUmGfkazJNffqB6Wopy5g3dou2
3550	fee_transfer	1685	23000000	1	Ckpa7LxmUfvMRsydayo7NF2hcYRr2Fgaqhe5opPZYrCSgokh4tgLS
3554	fee_transfer	1506	24000000	1	CkpYwgXnM6N16ddkUx6trsG58VBMt8v2M3E4FMR1cGGPgZNc6oKRf
3556	fee_transfer	1690	22000000	1	CkpZpJ7QkrtfERLWPSMDU1gG87iFZkzLjXA7rmHe37EduZBKpEHLi
3557	fee_transfer	1471	46000000	1	CkpYyez1aJaYBqPgvh99xm1hLu2f7epxes7gkBexAe1XawB93Lag7
3559	fee_transfer	1458	14000000	1	CkpZLPUFdednoQatbeWS917qm2TnEa9fQtPokCFYV1UqVsXNfgjjY
3561	fee_transfer	1509	370000000	1	CkpZJPBCZr3A6d1XSaVmnAdmsyn3cs4W19E8UNEHpwMhAdoG9sUfN
3562	fee_transfer	1509	303999992	1	CkpZQK7zHqCHTnAneFzvEYp6JWEufQewnydXjX1TGKjXjnXn64JnP
3563	fee_transfer	632	12000000	1	CkpYU1D8YJWiG8Sg6shtHLDWFaHTvkwtnHN1tEzQuiUyrWDsNZTwZ
3568	fee_transfer	1588	36000000	1	CkpZThYD4jnCCUZHfvUP3wqXZo29uCk5PLBcaCeCN86gDFQuiC62p
3572	fee_transfer	1696	13000000	1	CkpYtNGhi9QSsQ6ai3QnpGoYhcpzHUQgdjxCUo43i22voGvUnW77u
3577	fee_transfer	1729	24000000	1	CkpZqb2aq43eNnTDwfo66QhxQpkueEP489t4LhWiLXCJ3MRVNUDvu
3579	fee_transfer	1749	16000000	1	CkpaA7eTKDmnaGGadczrSqZjfg8ZjTws9eVMmaEKVcnByJ5bJhZTb
3588	fee_transfer	1657	24000000	1	CkpaL4yjHVwzw3G3bqiq5u7Zh7L1R98YMzzfyGcCAAdfiPgj76cRZ
3592	fee_transfer	1683	14000000	1	CkpYxm6JT6FiWEYuN1rDrAfNGedgRe7h6NsdXZXAyoVgVcteXeCyW
3596	fee_transfer	1608	12000000	1	CkpZnhhTE5EWsYBQsVm2uRC7ZvqDFHzQktJqJLSh2uQFHyyHhmUV2
3599	fee_transfer	1683	24000000	1	CkpZE9TzNMXtrCPR79cAYw7PeB6ceWvxuoURC5SM3VdQcFAPMg6v9
3600	fee_transfer	1593	16000000	1	CkpYWQjB4K1VDntA8Pmb9yDjwt8e8A6t4J9YXXedtvJTK3mmXABVr
3620	fee_transfer	1698	12000000	1	CkpZF5nNYzUsJdSEWKmAtx9pv6XgZM1euGXRKmZCGycLktDD8q41L
3623	fee_transfer	1723	24000000	1	CkpYZAePKCaJNagwEHtBieWEUCGNP4Zvu7PLSH9zEc4TMuX5WvMec
3334	fee_transfer	1402	34000000	1	CkpZpq4qN51EmGLAb7YKacXyKqhG9QN9PnS6qJeGYg4ayid6Nek4r
3336	coinbase	1510	720000000000	1	CkpZros51trcmUtZtqXWaWWn9D8ivCF6ga3ynDywQVY3thmV41KB7
3337	fee_transfer	1510	12000000	1	CkpZi8MkbUFm4bhbxmxvC4VWJGD9qigGKvEvB4tP6HTh9gF7B7Nu7
3339	fee_transfer	1508	12000000	1	CkpZ1vpYPRqim8kmAxzq4mHgNJ9v8ZnkPy32Lnw3pDbsQWQRatoQT
3343	fee_transfer	1471	12000000	1	CkpYdvxrLHPWwwNEbPaWFCj5WeKWPaiiYeiS2RQTdWcKqkScQezJz
3350	fee_transfer	1602	11000000	1	CkpZGGioVSJWQpLsEJR2k6YVJtJozGtfshmq6rDNEof8d5AZsAjKN
3353	fee_transfer	1439	22000000	1	CkpZ6omHmjk6T1Z9QePgyaq37zZohXt2H95RTPfXC2CdUhAeuqvXq
3362	fee_transfer	1508	22000000	1	CkpaBAufktDY8SjieiQzhuw3i1QjYxtjzGahf2p55aU4Ms91hvtq2
3375	fee_transfer	1850	37000000	1	CkpZYeo2BkfVafCM1cktPJV6B1h28aMTJ9NbNpM5srZ3NsZyJMC3h
3377	fee_transfer	1677	65000000	1	CkpYjT2n3Wx49nCaAkJDRuuxiRvsVfnNsNsH9esBQ7B8hxnBMqhbJ
3378	fee_transfer	1588	22000000	1	CkpYe2YeszaeqQdKA6MAjQmP2NEPwg64cTYTvHNSLACYoD5sgaUB6
3381	fee_transfer	1688	13000000	1	CkpZgXFxQyMS4tMPDSVn4kW9q9bjCupYByw9yNfUJyCeWG2KR5SHF
3384	fee_transfer	1877	11000000	1	CkpYStmza41CNiF8XYBLwxqpfL2YZuF76wyNM2G3aSdwGLaZv5x75
3385	fee_transfer	1560	12000000	1	CkpZK5KRCKc8ZX68wxwT9JY6Xpy9zdKsQgfEvdSq4gV4g9dffKoUg
3389	fee_transfer	1672	14000000	1	CkpZHwg8ZtRYHkEepn4tyMBbRZ1XPNoTxzbjRzKwKPUr5qbmTaQKj
3414	fee_transfer	1596	44000000	1	CkpaFDtv2RfoX7gLP1b9QKkc9BSH9aQP4McphRa9Fv3ntqAW32VdG
3417	fee_transfer	1723	43000000	1	CkpZGC1ttJWojTC3DuRnwdS8AJp8UxVeSvciaqhWSrfTz9yqEip2U
3427	fee_transfer	1666	11000000	1	Ckpa6LcuJZ9fnfBkbtqRsfegFZzw2P56kQLZEpLN5UyDmcMfyH21k
3432	fee_transfer	1677	44000000	1	CkpYwHyXnbCapFFHdNWukuoGN9JgaZsWv8meejWurRbSWa3oV6KK4
3435	fee_transfer	1613	22000000	1	Ckpa6RnrMBczxJNfLikXKk9ooL5SSTZAVyiqokzq7mPqvbSSCQPLr
3438	fee_transfer	1688	44000000	1	CkpZoWS3BEqdrD5EKQvsSxx7ND18fsG3AnerGsCbtfA6xDUT5QLfV
3439	fee_transfer	1692	44000000	1	CkpZvVNNqF7iE9Dv4vdrSJpoh2yDKHhKNngdYfrgYcfbieMdXiKrh
3442	fee_transfer	1613	11000000	1	CkpZHJUcpsmkx9KSmcEU2QsLqbrxUjojb93PqcGuzdZdTodmfSvwT
3444	fee_transfer	1671	33000000	1	Ckpa7Bt1RGCGFULMLKZwxxpmftcF9HNoSi3fM8FCQC4Z4QoAo2VF3
3445	fee_transfer	1476	21000000	1	CkpZJjLzk7AJkksULqFXMxtRRu6NKhNG8ouj68ZBNrUiM41DjJRtr
3457	fee_transfer	1476	12000000	1	CkpYjpQfgEadcFsbFgaHsXr4DqtbJxbRsSSh5C5vh2ARdY6ApFg6Q
3460	fee_transfer	1601	123000000	1	CkpaHRY3Lww6GkdTfScLUKhCD4V6SpPoWAMBYuFmf6UAvXSCtUEvH
3462	fee_transfer	686	21000000	1	CkpYaQNVCNB65SC4idPU9vUdpEgbG2YPGSQUGGqkELaubf61rXroD
3467	fee_transfer	1455	120000000	1	Ckpa22rfdEcmVJmocbY2Vx6rv4a9Rsa1f3bXt4GNswLpQtPZiCepX
3471	fee_transfer	1677	53000000	1	CkpYT3W9sRSJG6j1vzb1nKxCh5sYS1BUpHfqyra1shPGVhL7h8w2m
3476	fee_transfer	1991	32000000	1	CkpYhjQFwwEP6y5rooj1sW4Hvjc3TrfprmPZtxJXNA8jErq9HXHPU
3481	fee_transfer	1704	124000000	1	CkpYdCFjvcrWfbP2GwkBwnHDgypBgBGHmT2kHVPmpJjWJCbP8ygTT
3485	fee_transfer	1654	145000000	1	Ckpa78yJVCkTtuHE1HT3iGrew7Hs9onX8GqzYZmL766HxZMickMqy
3487	fee_transfer	1681	13000000	1	CkpZNgKck98HAJCbsPBP1Q4RVx4VSBWjThrFd84WYWKTjHDB9mgQw
3492	fee_transfer	606	3000000	1	CkpZ8nHQmvGzTSqU419zwEPcM1Jn5Y8jRpC8279wEFuKZjHu6Nfn1
3493	fee_transfer	1683	13000000	1	CkpZA7diEMhWYUtFBptqRG26yDc82e1vuNivpHW2dDLFxT7Asfw2U
3496	fee_transfer	1601	12000000	1	CkpYtoXhsYnH7Yd7Gq1s2CfHLZwnvhaP6qsDFMKmudzSa818hYs9P
3499	fee_transfer	1657	13000000	1	CkpZF2PD6pnhS4QoCo6664nGeHePGf5gcsb3sVQ4dcU88WXdh5KcR
3503	fee_transfer	1688	35000000	1	CkpaHbE3pUZqXs3zG71Ac9WW5UibTR3nz1AEKgys4vCfBz9oCaYm7
3507	fee_transfer	1654	15000000	1	Ckpa2FgvF7oo5v6fmQeKwLyrEXD1iXtXooVnS4tSCrrNj17L1PaR2
3509	fee_transfer	1768	26000000	1	CkpZz8rmC92LDTrLEEtAAMNPKjdo9TfmUzYc7P8wF6heC5aQcrjUY
3513	fee_transfer	1670	13000000	1	CkpZrfynbbfP2294hBZZxqjQi5SU8c6aWpkfiTahwhX3ktQ9SSESM
3519	fee_transfer	1508	13000000	1	CkpZq7gTbKLtcUKyLe963J4sZNeTrRSAfFGLRxFGNixtLJYFoxmFm
3520	fee_transfer	1740	24000000	1	CkpZW116go6cyZYPTvzsWXtAAKUAEX6KWvkTPUWSHZU5impB5wQE4
3532	coinbase	1689	720000000000	1	CkpZN3UANhBJo7tJZnzE1heA1KQP5jtkBuvDTRfZGiip2Z8sKToAE
3533	fee_transfer	1689	12000000	1	CkpYv4uhjZ9i8e3FfP12PvYScKzxiCTwy8D8H3GC6QiiAsYeUSZgx
3543	fee_transfer	1690	16000000	1	CkpZcRNWvDhiAPmevFR261D9m3zsDCUQhDESxEQJfARruEenUa77G
3552	fee_transfer	1768	34000000	1	CkpYeeiXbZcWiNbrp8nqW8eCyk1tC3tp9LN5RY1JT4YNyZrmm3otP
3555	fee_transfer	1768	24000000	1	CkpZNXL7Jjboyo8zERAxsBFkvZ3mHkugp5n4og7B88MnN4HRHcYLr
3560	fee_transfer	1671	14000000	1	Ckpa9UXqmTXEsqqrhv7CJefd6AmAnx6rNwqqKG6ETBXZhFFJjpsPy
3564	fee_transfer	1602	22000000	1	CkpZoB4m6nNjViQbxG1wkf88BUJ4vU6L5DLbZBFSEC4XARXhYMiJ3
3569	fee_transfer	1622	36000000	1	Ckpa8gLxK3nFEXWRJ3Ey5HVn4bBvitLm9F8po57qu3ykiwStvWAub
3571	fee_transfer	576	36000000	1	Ckpa7su99wnjLLYwi8ES28zK8RzkLASd3WX3Xn3QNeRupyYphKdqh
3578	fee_transfer	1683	36000000	1	CkpYzvktkmko9U1McXHgCHMUM4m7pjbPJHqJrtvHj2FAPhKJngqi6
3580	fee_transfer	1749	18000000	1	CkpYeJtPzwtYiEFoV6TqH4AXjfXndoRpsgJfjsXk8aX68RzRM7zA6
3583	fee_transfer	1560	24000000	1	CkpZQmvp4bpKku2H91BxBBfpYogVj7nt6kB4raGE65fsSgJvbAUsq
3585	fee_transfer	1546	12000000	1	CkpYVyVmuF7EAxgspE2JJbZVmQxGCHpD2T3nqSSt3oLVY7DWXdMXh
3589	fee_transfer	484	2000000	1	CkpZYMwYERQVPhXXCWtcxht1QD2taH1HM8XMgupjy7ZpvHYR6XKXr
3593	fee_transfer	1447	999000	1	CkpYUNJ4EJqM4hiatjonN3wqSWBFD75nyMtuer1FaZbkn9w5PiAUS
3594	fee_transfer	1677	9001000	1	CkpYVoaP6BbUQmZo5GLWfCjiacMjBdB3TQe33vwDdEd8HWEfG9kpT
3597	fee_transfer	1696	12000000	1	CkpZ6iM8cbiwQmuhGMPrELWLMcg81nNYrmmuZFrgXCbe7UYQmQAdP
3603	fee_transfer	1610	12000000	1	CkpZQEMBpmXiz1AppxrKEAa4zptvx4ADjkUVvHpMeqWj9Zjgc8A6Y
3611	fee_transfer	58	12000000	1	CkpZYEZJovfP5siQ4meYKQLaS4N4J6xpBzfGfDvFjH3257JoBiq5k
3613	fee_transfer	1555	12000000	1	CkpYaQJMxR2tS5CzPVK3Y3WA3NdbkVCGSvraokrwyNy1X4xbyVWcs
3622	fee_transfer	1471	24000000	1	CkpYtcS7wppU9wmxb46BVgxhS2NBhhSkib8szGj3VZ7GejrrX4Vod
3628	coinbase	2087	720000000000	1	CkpZ6PbX7YYg3zPidB7rnQuazyJBn4VUrQG93wg6aNWvXZmsMU9JH
3629	fee_transfer	2087	25000000	1	CkpZ5WG2JrHLFRVd4uUTvgFK7TwJ2dCqcgaCd7Fe6MskYcyBg5g5s
3631	fee_transfer	1474	12000000	1	CkpZvmNRUpZdwezvfwSNbUaHj7SaWzyAtSEEE9FRxC9aj8netSRN5
3638	fee_transfer	1717	12000000	1	CkpYyXdBdMdCQ98qZrP52qodbQb3MLbtVCLgWzmF4ohX52kjCgq5p
3641	fee_transfer	1718	12000000	1	Ckpa2PN9z8n4X83WU5DiSMSKUGLeTBhM151hb9dTjdP2psdDMVBc7
3335	fee_transfer	1683	34000000	1	Ckpa1qfpkrn2344GGDALJR2iqpPj52gnRmihHkH9jTEQ9qbMWKVti
3338	fee_transfer	1710	12000000	1	CkpYUvpBSSTU3QA9nnYqPjVxhV1rWQCp14AQCmo8Tk3sdvnG1kLti
3344	fee_transfer	1547	12000000	1	CkpZNHjb98oAaEV53HMygM48TuabpU4FCEn9BhR9kjG8jdNST33bh
3345	fee_transfer	1608	23000000	1	CkpZ7iVPJ34xZkCvVnxc4jifFs296voaV8pU5xP8wLmyYEXcRPobG
3347	fee_transfer	1702	23000000	1	CkpaJHNKK6TvpwPV6HnvmdDWHz418AVFMHfvL5XtqU35Dy1mY4VUD
3354	fee_transfer	171	22000000	1	CkpaEmQguwn5HYbTqZTmVHRCv4PWtdaCYCjwM87sxoEDz2CW55vos
3357	fee_transfer	1762	33000000	1	CkpYQd6sVMAmXGciGUvKYgMdss6ZXnMDcygUQmA7gxtSz2sbXf4ja
3363	fee_transfer	1696	350000000	1	Ckpa7YYxtW7PfMCWbjAfazBTeBmYwwThDsQUUGvvEp4q6pqVteHY1
3364	coinbase	1696	720000000000	1	CkpYhwzgzDhmpRzKbpJTKAiWhWLy7GaPQEHtjhvQwtvLdEgmosDXi
3366	fee_transfer	1675	11000000	1	CkpZ8bZxuc9Qv21q4QFTcvJsD6B8YgX7igfGotfvTaJoH7ixYvL3f
3376	fee_transfer	1613	37000000	1	CkpZDizJ3SXPqTw7HTFi2pSCA4yLRNWV64RjFhQLhJPxLgZpfgeQy
3379	fee_transfer	1687	22000000	1	CkpZmMvzBePpMrgpipZnhWnjg5xMoqaCtpd1nWbTfxbT7Q2UQxHAt
3380	fee_transfer	1448	23000000	1	Ckpa4i8cZT534JiXr6mN7h36TkURi9EfSvs2jBDx3HA5zRzYZkupt
3391	fee_transfer	1740	22000000	1	CkpZim2SNttGSonycTGkzKD3xkrc4JRWoiTPLXPrPUvFZBpCL5mU2
3392	fee_transfer	1596	33000000	1	CkpYYRqpV4gEsEJDwmvUb742XDF5qEkF6PV3rgBaTU5t2izfc9VkY
3397	fee_transfer	1715	16000000	1	CkpYfKP4ccshP4LhRxshWTmLXmoPDRnLCeTVqj6u32qLGRiPxZNfh
3399	fee_transfer	1715	12000000	1	CkpaLXNPEqofJnM5kKw1qhzP7Sa4mNAJk9JT9owScLLUqfTu79yvQ
3401	fee_transfer	1596	11000000	1	CkpYhmMenAZ8Wew9Ry2d6MMeZin1meXTgfj16j95Cu5vBWkgQ1HzH
3402	fee_transfer	1657	21000000	1	CkpZFk9bfvHyRtFeUWG9q6oLpj3gwLs8gMYA6Hxej3Nt1c8QFSMcX
3409	fee_transfer	1451	31000000	1	CkpZDdkMKBopsmagacWenZYB2PEZjWxhxPcsDrqdMQ7Hu9EUKWutB
3418	fee_transfer	1690	33000000	1	CkpZAoB3hnoA8mPFP2g3xx4A8qMMNz3555CuhRjRYirFPCsY4wqz4
3419	fee_transfer	1467	44000000	1	CkpZ4B33evv1XDjqnHbutbkDMWCgMrZ1Cm83j5dvRXSSEhJkGAhXC
3422	fee_transfer	1596	22000000	1	CkpaBKUoy4sXXzpoNkcZUXppi6Nyo54tywt6cxEhY9rSrrWmb42KJ
3423	fee_transfer	58	332000000	1	CkpYWXNZb98DCEqVZDRAWtuWQETiDRdqbvsGLGyZ9CtwUeoj8UeRx
3424	fee_transfer	58	9000000	1	CkpYUAKZB2CfBPCjqgwKpRUZQDpKDaoTdGcDcFYbk3iATqRa3VCaS
3430	fee_transfer	1718	22000000	1	CkpZaVp9nnqgkPbnECp9kXtQBKpFVemBmiEzPWsPnuibVHUR4NZXy
3433	fee_transfer	1560	150000000	1	CkpZMxnrJSah1oGDUJjYtUMkNCVhgWvLB8RBske1jEZkKnTLfvtwY
3434	fee_transfer	1560	82000000	1	CkpZr3JhuXx7XBvzXK9vXFRsaL8T9eUDuTdDmechNRNRucZXAPcyx
3437	fee_transfer	58	331000000	1	CkpZ82ZYof8HGCcX5Ukpo7bpqFXvBPjyENWz3vuKLDmGUF16s3iDv
3447	fee_transfer	1633	22000000	1	CkpYQKkFtM5k171seqtGuxZ6qeN9ior6AfF7XKttVkd6jco6QeyE5
3452	fee_transfer	43	42000000	1	CkpaHubFyTSUQMR2kCBmFnvzMQaTmC3FEgEPrPrb2qAs3tPUmAuhL
3454	fee_transfer	43	32000000	1	CkpZWSH7ZMYbJ3gAkFm9xUDeFtbxt4Q2e6vQX2e5TeCN7Ysa8p3fd
3455	fee_transfer	1637	32000000	1	CkpZuYVLoWzmtBg1f5Vbvo8wAZZBGZsc4woga677cJUojxt39Xfkc
3458	fee_transfer	1588	122000000	1	CkpZj5BHGipiPWrk9WfHcDYXwoQbG7DtPDRHi8kKg4rjzgNfxjPp6
3461	fee_transfer	1711	21000000	1	CkpYi9JrhkR5QWeDqk22LFJ4XmnaQzDYYAe48tKw5qrVhxXVkLCzR
3464	coinbase	555	720000000000	1	CkpYz3S46C9Yz5XnoWiQ3zDvpNrDq3HMK6Bay8JZdRPEcAE3LBSue
3465	fee_transfer	555	2000000	1	CkpZkPnTF5fPujQe6NnXwqetqQirZm5gUtsrh1kKLXNBxWRWdS5LB
3466	fee_transfer	1467	43000000	1	CkpYiUDRkq21aeYJXV3gETcmSLTBTk9Aa69po1hfD4hUm8FQkNLLy
3477	fee_transfer	1683	32000000	1	CkpZcADPiMyPMk9h5gok79sqsQjq6THzA6CTViJTFaNHKhi6xqKVE
3488	fee_transfer	1768	13000000	1	CkpZ6ebHVmRKB3mzAapLbybxSrELCrMPMF8CVj8TKfUfaygARbTba
3489	fee_transfer	1684	125000000	1	CkpZJUmNdmrXY5fT12CFb5FVTncERy26mpcqjyyLYdTN4FV1EH3sb
3494	fee_transfer	1992	13000000	1	CkpZxbYf6XpUkEYLqvWiAbsxnMStjjHEBySxPW1QFLbGS468Bb43h
3500	fee_transfer	1724	13000000	1	CkpZKvYiZeMj4mjD4TRjBpWHy1PtKYC17QazJ4LRTDX98nEPHaDEq
3504	fee_transfer	1739	12000000	1	Ckpa6rJtdiyHEvu2wNa6i4KXd3KzwR7hkrp9S8NScDyuNG8SVwkSQ
3511	fee_transfer	1611	13000000	1	CkpZW8ZvLmi8mcP3mBJYJHz1Xq4Pn3iaWCZZsWJmYyieyGPvUPhQb
3512	fee_transfer	1714	13000000	1	CkpZqnmMsb6pPi3gPoXP7pVUZr5JzHDQyJRpHEgGeDvN1Qj9rRpgD
3521	fee_transfer	1402	24000000	1	CkpZg4maqfXpVpGw2GtFsvdLKBDcjjhaKjkUwazLP7vfqXB44DCDt
3522	fee_transfer_via_coinbase	1964	1	1	CkpaKj3hTProVFkshbNMSUPYhYDR1nZoaiFoxT95sQMcgv7XuikbM
3523	coinbase	1402	720000000000	1	CkpYw9nmQdfDtWEuPxobHVaKDdzyd9dbBaT6x4dEcVEz2BaSUh2cW
3524	fee_transfer	1402	1999958	1	CkpaBMYYiu7FQJrN399ffzjn1qhMD93HvK771YXJwwUquVWUPp8SG
3525	fee_transfer	1786	40	1	Ckpa3ip7oUgfKCX2HEcjhyS6rvZzq7SqV34vLkqExgVDRnJoGfqip
3526	fee_transfer	1964	2	1	CkpaKb71ZR9GLPZMdMtGo2LE3MayCtnUkVrEwt2BUXGxk6CxjiRzT
3527	fee_transfer	303	24000000	1	CkpZh2A8fXDmK8S5CcvLM1sybrijzVyUDDjkEQYj5HcK3T7uqmFaL
3528	fee_transfer	303	2000000	1	CkpZP49jrpGCrkgSANLh1d5ZSDaYsvUoZMwoGXzWzzg5qtv9VwyCk
3538	fee_transfer	1518	13000000	1	CkpZ1WRyzH5ehcRj7ikfReb7rqoEmx53789ecdYzkmjxm8DsFWEzg
3545	fee_transfer	632	13000000	1	CkpZ8eAJqzSgWS4MGtvU8ZWtCGup6ZfqMonsVMG1GhGaWN9H89qao
3547	fee_transfer	1759	16000000	1	CkpYhBu4pprnHBtrt2dF3DdDmzqw8NyJLfHNPupW11xdvwx6fubkf
3548	fee_transfer	1679	12000000	1	CkpZdR9U3QmuZf45qCZjjpPAcCPHXaoFh4wRiXjse3FctYuBAj4pe
3549	fee_transfer	1690	84000000	1	CkpZpyoyJfPvS44YWMQZQ4YtCioetikiW333qNtkWFpZmbTB1xTpk
3551	fee_transfer	1690	23000000	1	CkpYvTAsg4WDhyv8RERpHyhvBSMd3wP8ZHL1o4jPt5TPtbSWw8xHK
3565	fee_transfer	1678	22000000	1	CkpZyuu9nY3eP94A5PRvpsjKuqgMGnCbtBRne7PekZ7NkcHmU4Vc2
3566	fee_transfer	1688	55000000	1	CkpaKMeG538P5wSQCbXyHvkUhVHftKaBZRCUKSJLWnS9sfbctwVj2
3570	fee_transfer	633	36000000	1	CkpZhrfrbW7AENR9ckBr8q3qMowv455bcpiuAZoGhSfiZMNho8Srh
3573	fee_transfer	1696	780000000	1	CkpYtXUNMFoxw91QptHW5yL1zqfEvPfjbqE8cLY1MzzXmmXMLYx6y
3574	fee_transfer	1696	2000000	1	CkpZXFBwjzpc72gYBqVweWXpo3Z2NHyp5WxjJLcE25z3KhUNsgtcR
3581	fee_transfer	484	8000000	1	CkpZDisiaxp9pFpkjKXHM5PLheiCBwpZtqV16qTHs9xDTDBNUjY5s
3586	fee_transfer	1670	23000000	1	CkpZurQthqNqkCH7mL7HrUsqdrbDykyozzKBRCESRT5z37iLpcUNt
3590	fee_transfer	1271	12000000	1	CkpZRErbejbYG4DvB6inFKYr9o3kH1MW3aH7RCqhNrkhFetncRfBj
3601	fee_transfer	1549	16000000	1	CkpZXpPXwd64TJj9kq92ETiFyPeFv7YF4k5S4vBDPFngjsRMzRniV
3604	fee_transfer	1762	12000000	1	CkpZjFfLa4mwEsQozxodNYN86ytJg1ak7mp3K49Encwqoa5yGFAv2
3591	fee_transfer	1768	12000000	1	CkpaDGxAfLf2VQ6Rc5GeSfWWfoCm3Wx1FFXDggHs3UJ1hvkTBJiut
3595	fee_transfer	1688	16000000	1	CkpZEdDDiSgxTGGjhJbw4QQnX7PhT6vRDj8V3Q2MQjFb4X7UqVNtv
3598	fee_transfer	1696	384000000	1	CkpZgFksTQaAtnL7GG5CgkYd5ewZDpY8vSGposmH5AbKGXyFqXncu
3602	fee_transfer	1670	12000000	1	CkpZPJNef4eLpfv8yVGeG41wo3QNvauB78qLY5uewohmPUJRRYqit
3607	fee_transfer	1573	24000000	1	CkpZcLUUzymCoM1DTQtMaWvW38NhXqdiJbfkGqyNCgxfdNKsoc5D9
3609	fee_transfer	1696	99900000	1	CkpZEQ9YsVRHVMhoTZ7VmurDDD3paceYAEshx64JYDLXSeR6yWykX
3610	fee_transfer	1599	9110000	1	CkpYnK6HMXHUyBfLTcDuNNBUq8gFgBtBhyuTc3o1Kmyf4ViKEBAvi
3612	fee_transfer	1764	12000000	1	CkpYirgXd5BxtPErwY2hvsarLYr5cwFKt83p9UNQhKoyfEFoaDwTB
3618	fee_transfer	1759	13000000	1	CkpYvBkNt9sexETnw3hgkFuSRygQFvPmnXhRTX4E61zV9nTL1GZBS
3619	fee_transfer	1444	13000000	1	CkpZCQ24cHFFwJyzpYM9z4fLRYRsJ6giRiRJH7Td4eag2Bb1oRsim
3624	fee_transfer	1679	23000000	1	CkpaFN14M7PqBkWHDTdi4LtbedAy4pDa5M1qJqdZKcUiqetKKNkUd
3625	coinbase	2086	720000000000	1	CkpYoRteMjW9wCkfMrBpPhELypNehtvgZxRo4XKEdbKjzDJZQxNRw
3626	fee_transfer	2086	25000000	1	CkpYTTqjrTWNe5HcKTs7vqk4heJVYWSGEyoBML65porriakpDXA2y
3633	fee_transfer	1703	12000000	1	CkpYZ82MYyPdApEcNhJrsnRZM2vrz3nwDe3gpek26TPLLDjhk7ygS
3634	fee_transfer	1637	12000000	1	CkpYUjoTjGowe9KqvdJTYfXLB6sFjL1WJL9nYfJiHuCug85DJJJVd
3636	fee_transfer	1637	36000000	1	CkpZuWGXW3KT5C3vfX7hfQG3jicFD6EdwYTtwTonLQ6b2z49njrcv
3637	fee_transfer	1933	12000000	1	CkpZoj6iB9CxcUWgYR2U5Cuqdw8RiYdfvJCSpGHvFf8zMymgFqK67
3640	fee_transfer	1513	12000000	1	CkpYb4rRxbBvNxyF6ATkuhSoSLQhRWGa1i4K2WdXZeyMPdxrqcYNR
3643	fee_transfer	2087	24000000	1	CkpaJ1iKFL6sdf5Z2QxygaHs69PapwB9XqFMjvdxSpqHkAcWMCLXq
3605	fee_transfer	1610	690000000	1	CkpYZwQ2LHtFkGuBhvVd8gg1ZbxWdp5xsKufRHP8op38CDt1dWWsv
3606	fee_transfer	1457	24000000	1	CkpZKjeydp81VtdVkagMhKcXK8gBc1L4aqHykU9t5TDo14QaTqKFS
3608	fee_transfer	1573	25000000	1	CkpYg2KpxhNw4bJyKcX8GqjAYKfakj8p5VuhnP1f7VW4sqyy3KQgJ
3614	fee_transfer	1457	13000000	1	CkpZgWpBJ5sX9c7ngiNwQVTanrip5wJQtrcvAuRSQNkrvvTmbhrow
3615	fee_transfer	1471	13000000	1	Ckpa3pBEqNRXvt4G5BGXBtTeZTgSbCvS951hSTnMu4b9ysGiRbXcE
3616	fee_transfer	1506	11000000	1	CkpZ83qwAaNm8eFFYuoZpsikTbxYZ27kYyf7EvFZoKQE2CKz6deMj
3617	fee_transfer	1991	13000000	1	CkpYrCZ7yvu3nivsMCHkNKzQkz4AqrVJH9hknokD416uMWzcnsdzw
3621	fee_transfer	1685	12000000	1	CkpZBNtRz54QdWVy1UCxsCSHdoc8RtvNbaa7MhUd8evyBhPga4xsp
3632	fee_transfer	1594	12000000	1	CkpYxE8sJqcAuxj3EnvUpUhf1LaEgTSkZHUngkZgCrX7X5EzcftpU
3642	fee_transfer	2086	24000000	1	CkpYeEK4SLYupGRd7U94cD6ypHpcsXQAdADhpVeehHBHaeD84LQtY
3645	fee_transfer	1634	12000000	1	CkpYnXcC78uU5Kn9zSag7vCE1Sb1dgG6etZhncm1F7cCQYhwoXjzH
3650	fee_transfer	1679	36000000	1	CkpZCH2deqweQyvipNfRMU5Yg4Nc7fYe3r4Dxgwo6ABsJcao8LAQL
3627	fee_transfer	1699	35000000	1	CkpZ2yN628WCoc9BnXdaRXPBMApKKYDSiw1wxqRuhJNMcL26jYAWp
3630	fee_transfer	1702	12000000	1	CkpYaAtSsGYf3c8PQqHbtcWky9m8eJqk1QJaWMXYKqPCvQouGviDA
3635	fee_transfer	1536	12000000	1	CkpYoWNLcHzQHA2AezNHjkQcmXNDKowPVjSmVpuTiJhPoXrzQAb6k
3639	fee_transfer	1506	12000000	1	Ckpa7RMnyuHbhsMHGQXon92xG93Uqx5JCXsLTEY7n8VRcCUPitp78
3644	fee_transfer	1699	24000000	1	CkpZQCZ2NDiMqNnrwFQip48tHDdpBx4wZZhLshCrk3VsVYQkH2FEs
3646	fee_transfer	1607	12000000	1	CkpYQNqeJnqguYZPyZmLepCft9xgAkLvX3fopPfwkNrMdvC2yPVbN
3651	fee_transfer	1458	24000000	1	CkpZv43mFQogRoFoETfYAVUNvGRTk9PVvhYsQLKdpMSsmrwG846M8
3652	fee_transfer	1693	12000000	1	CkpaEnfMVdhqusPkyyh7PHZukoD8HF94zLKuN8qvNSv642AbKNvXk
3647	fee_transfer	1458	70000000	1	CkpaBFmqWqB7bAoceGFMadYFRYJZUoYt5bWQdpiRtBNiHy331Sa91
3648	fee_transfer	1458	339000000	1	CkpZiNBbC1HWHnZJaBaonYv4dzuhMv2ULevrv3ZezRzcivT7Q7qUt
3649	fee_transfer	1715	36000000	1	CkpZxnkGyY1YS8Tp9EVVtKW1UdKk5vRY2dbghDhuhQPeHfHTiLkGH
3653	fee_transfer	369	12000000	1	CkpZNH6WHCoo9Bk5r4JcgJfjFadFyjfwD8w1JAT2xFc57meRu7psW
3654	fee_transfer	1746	12000000	1	CkpZkatadfWRj7TL1cyFg7c5xBMBDbg8HXpJy114CrxksRV1ZgNke
3655	fee_transfer	1694	12000000	1	CkpZD296GSNHPMkuobk4mLJNwNYjiZrY9XWQ6xf3ewzSQZg5wrfbP
3656	fee_transfer	1747	12000000	1	CkpZVjKxUSe6izPSn2ZUDa3p3fPMYy8hJQop4n2CmtGH2hbb3z1vY
3657	fee_transfer	1704	12000000	1	CkpYhmyyzoYxWxBeCuTVmqvLV497KnqavPuvF653agudzBda3yX1X
3658	fee_transfer	1729	12000000	1	Ckpa6W9pHgMLdfsp7JtcVQbonjB8yjm3WfmmS7Trz9eukGdkY2E9t
3659	fee_transfer	2039	12000000	1	CkpaK3Y8vtD8Yah6Cfh8tzu1j9h6AAcfwGC2DhChbqHsmgibDfivc
3660	fee_transfer	1402	12000000	1	CkpZZJjuyEeqjUTfUB3LCr46TX8Bbunbz2HWkbLdqRyiKUmGqBisy
3661	fee_transfer	633	179000000	1	CkpZ1R7pFdEME4g9n3sKJNHBYhdLnaJRp2txEP8uhBLzouK1wqQEc
3662	fee_transfer	1402	25000000	1	CkpaLWCCx5Wzzt8mPPG229EEqLaf1KV3pytihuYBnSGXzdT81vYWa
3663	fee_transfer	75	100000	1	CkpZSaoFr53WJEbudFWwnPpbkvHN8PQ4rnNTDr9nnZyz7qL553kRt
3664	fee_transfer	1690	1063800000	1	Ckpa6EMLxN953W9T6bWDCE9AmxWxQsF7hCqub97YVqKw233Sawu9r
3665	fee_transfer	1447	12000000	1	CkpZB65on3pQYHivbic7hjhYck33N7gaLBgYSvA5mbsBEEpZEK6Er
3666	fee_transfer	1740	13000000	1	CkpYVBg6aa6C77uacVkEfv24zSzte3m2v6ynw5hHp2thYJ9UCecfb
3667	fee_transfer	1689	32000000	1	CkpaFBXLoF4zi5CWmQgU1AMEni6rsLPggPVDNXTa6FJoRspt8Y26g
3668	fee_transfer	1602	21000000	1	CkpYoJDrvcnwcvMa1xScFErMkbNCJJLf9iz1U9sDmDu8T52HJgAgR
3669	fee_transfer	2086	37000000	1	CkpYp44Fn82FBiQMVpd5A4ESPebSNyLGuNhiyj24RWRbTtrw7LeTF
3670	fee_transfer	1699	37000000	1	CkpYx7iMHyUYMZCW3xZrpeJVCdooiSfck4RWh2ukK1ETmqJDhrhx9
3671	fee_transfer	2087	37000000	1	CkpZQ9znrCTJBVta6kTUfSzgXrD1yKJEVeQKWENgkmghw9Uv3myjb
3672	fee_transfer	1602	37000000	1	CkpZ2kgvDj2mEiuz6jr5AgRFrSLNKFRVKWHkBiLYxmdtgPsW1eCFv
3673	fee_transfer	1668	13000000	1	CkpZBR74VMtJJ9VANqjBgqgukDhow63JDjsCDz7PSpCeWShFwNZ3U
3674	fee_transfer	1719	13000000	1	Ckpa6ySLQ1W94vy2LBxkDQmQ3GFpdhcTGfND77dS82gKmovJnTwEr
3675	fee_transfer	1587	16000000	1	CkpZh1U6hNHoeJy6oWhQEtkzhPid2RPGGKCPaCRnpHvTwvseegjaz
3676	fee_transfer	1683	16000000	1	CkpZaweWgS8zCqT529kbMtvWBESp1JdWEfcGA3KKU4EugVrXK7kvq
3677	fee_transfer	1698	13000000	1	CkpYe6QFyb4YVaj7XU7ANQxQu5tzJUps57HpPaBMwVxjQWRUjQiCM
3678	fee_transfer	1693	13000000	1	CkpYk244W2iUmU3vZoxfD3s46o1qCrAf3Fe6y8DBy1bhqFKZbPhoG
3679	fee_transfer	576	13000000	1	Ckpa3deGVB5Mu4yNCAiT6hxj9UepPpUZHQhMUx9i2ZvhXzRaQaGKj
3680	fee_transfer	1724	14000000	1	CkpZ9pRDm1ManDJ7J6RhFPmwrCcBVbTNmThnJQHF9RfXaH31s4VRY
3681	fee_transfer	532	14000000	1	CkpZY5LHFdC59LdVc45zbKocAgVb2RJQmVABNpwnkfqrQT2kqx92P
3682	fee_transfer	1693	16000000	1	CkpZUEwm6oNyQVF5e5Pm9tmvY5pd5gcQbpR2uSb66PS4WFtARaNHK
3683	fee_transfer	576	12000000	1	CkpZPc9XqWc923KVD3L8v3vNiPC3fteYRa9ozoKhm2J4obYpG3dgw
3684	fee_transfer	1594	13000000	1	CkpZHWEn1XbZdo6GmtwaVjdwd6RDP2qqJ3pq4wYRG3pFToymMLUYk
3685	fee_transfer	1654	13000000	1	CkpaDDVwmz3JKEU2avvcHk2Yss8cx2XnNphCxKpGojZdpuf8JXv25
3686	fee_transfer	1708	910000000	1	CkpaK1s7K6sw2HQ37EkrsQcuQHaahdqGwNKZJEaNCDdLLVvvZCn8R
3687	fee_transfer	1708	340000000	1	CkpZeZqD34K9kzLeHNU14kM4vpS6qw5eHHcxBiGW81mkaHJ2V1eFi
3688	fee_transfer	1739	15000000	1	CkpZQQBatJp6FbLjMJ2x5cd94o3hAJK2yTfSPd9UMvz54SSNYw2Gc
3689	fee_transfer	1569	85000000	1	CkpZJ2Fo3CRMamiVo3Y5ZttkUD1p2gUU3jYAwytYcikFWEmABkNZN
3690	fee_transfer	1588	25000000	1	CkpYdgqmBQNbJ5ztk7D29X9k3pFXnSGK7xKGmhJjswGFGmEA5GLYt
3691	fee_transfer	1569	25000000	1	CkpYrHmyzUCvjLCpf8XDjqeXJLfbZeb6mdujjXgtWJnm1yeFnErhQ
3692	fee_transfer	1623	26000000	1	CkpZBStH7qzqApsKWiU2n5ZusAWMp2EWzsAvX8wq2rx3UbheF6Kc9
3693	fee_transfer	1447	1998000	1	CkpYg8Dtuy5n5ZN7cqriyMDy4UD6ivyx5cWRkqDoo6Vft2RL4CggL
3694	fee_transfer	1690	38001992	1	CkpZo2jcBi41bFG87dcDGZYAvkjax2EXhNSH8GpLRcGCwSGfz51Yh
3695	fee_transfer	1687	38000000	1	CkpZJmJVgwrarSCh797NUrCvof9WnUUYbfkcKwv2on3cCuwNMiPDN
3696	fee_transfer	1702	13000000	1	CkpYuECWafXxm8RC18w2CjZ4PaT4xggn4NhaM7DTSgzBjHkMXVGyD
3697	fee_transfer	1703	13000000	1	CkpZ53zxin8Lm6q29LwCDk5d3AdAvMRGonfWGznbc9WwYVoC95EAb
3698	fee_transfer	1649	15000000	1	CkpZXPPdfxp2hdiSAXY2YTQVJK4YcyqtUhNUMa65YoJi77otQjY86
3699	fee_transfer	1457	51000000	1	CkpYdYWaA7DFZLLXPC7MWrFd7mHoZwpdd6CkNCvEeDAhh2LwR46Yb
3700	fee_transfer	1991	26000000	1	CkpZAX1KtAYJ9btBPdR6Ee6nssLVZjPaYxiGdeMkZDMYNuYkUhYkn
3701	fee_transfer	1693	26000000	1	CkpYikxj8SgwZUa1ac9dBrqW2Amwy41igVTUZGeGQH718NuD6c54r
3702	fee_transfer	1439	26000000	1	CkpZq55moi6ySBYpSQzzHdaddiCdQCeauAW8rfY1WpYsAsLifvHsF
3703	fee_transfer	1518	12000000	1	CkpZoiHeeoyxCxpFEfu12qcn1mJtYyJqX8zYnQs8WJ69j4K5SRp6X
3704	fee_transfer	1448	12000000	1	CkpZsUXKMc2ChTMJeJanuvE9ZYDvUNV8d6PRP4BiEeUtYoZec89tk
3705	fee_transfer	1683	25000000	1	CkpYSZyuCYp7TkaGAE3tut2eqES9i4eE4o27z3Kb31s8XcSenCH6e
3706	fee_transfer	43	25000000	1	CkpYiSiqs3vC4URsbL6M7d8AxZWYzGVJgu7CTJJwn9PxV8kp2AAS4
3707	fee_transfer	1718	25000000	1	CkpZ4xsTNZSVcvJsaNwH8FHS6rt7oA3d6snJFWiMm32AF1zFM4XFB
3708	fee_transfer	1518	25000000	1	CkpYnT9R6yqzWtp9NVHbpP9G7ucEUwkgvcuDdGjjSDAMh3WuXiNGr
3709	fee_transfer	1419	25000000	1	CkpaHcvk8mGgvHsTd14bjHA5iD25QuDEfsfJxGK1qeHBS6okkSbE2
3710	fee_transfer	470	26000000	1	CkpaC8mwqt5A5x5Eu1yaTXEw9CptfTe8XgjKeERcbVRjW7NBJYpRQ
3711	fee_transfer	1602	25000000	1	CkpZoKujcFXRDBgvTX841e5xfSYR3Rgshg6HUf5QUivvBU2r5Kwe9
3712	fee_transfer	58	24000000	1	CkpZRSKb9TvHf29eyLMXAASFGz8W9nGhM5HogWfvJorsFDHuJNVVX
3713	fee_transfer	641	24000000	1	CkpZLLwHcFuXaY3D4giXpGMfD7HtNVvTC9S4dFB3swxjHYeCwkkeK
3714	fee_transfer	1687	21000000	1	CkpZX2ABZZ1fJEMFt5JaGxrc3izPX9H8znJH1NnHf5D7ZZN6pbENP
3715	fee_transfer	1687	24000000	1	CkpYipMqRgD8Fh5LPnSdjtJnvST4L494JVJekHm6cWaAJUEU2Q7no
3716	fee_transfer	1419	13000000	1	CkpYgVwqWg5GQiBhmpMiMCTZMWQ9uZFLMB3FW7DRNDaBLRVWVKXr7
3717	fee_transfer	1687	13000000	1	CkpYfra5vxhNNVGGD3YgNjnmWtWbbohccF2vxSHKLGovLQUv1H8cs
3718	fee_transfer	1688	26000000	1	CkpYyGXjoNiBoRrH8jupv3GA59kAw3UXs8VWG7wVJ6cEFBVzW5dkn
3719	fee_transfer	1759	24000000	1	CkpYttSxT7g3We5aMnCbbqLRC8YsiGq4ZkMNp63wMtukFdJdLnUeJ
3720	fee_transfer	43	28000000	1	CkpZwKpmgy3Uiy6D2eWLF35t3f8FogCSJnyvjtk8i1k38tUkXDpBs
3723	fee_transfer	1447	27000000	1	CkpYTCjD97SjJdRN5kpSzdLn89S5by4b484dm3vqAuiwcLkkdBYj5
3725	fee_transfer	1601	19000000	1	CkpZiDRBvJbNBu2EPBytjwDUxRC1ZpaqCf6v64afenAWgJW3PRNDN
3731	fee_transfer	1613	13000000	1	CkpZvRqMZVJjVJoQSwCFzyuDsYWfQPRck8euXsDWUE24T21Bmkbpi
3737	fee_transfer	1702	6000000	1	CkpYgyin9kmiKbwm2x5UVPTDEoAiWQrNcpMnusvLjJ7whsfvPbD4Q
3741	fee_transfer	1768	3000000	1	CkpZRQbv5x2is3snfnULdoPywJpsW4JQskWXWbUposqJjRNoqJb68
3746	fee_transfer	1622	12000000	1	CkpYuyA3my482zM6P8oajACYEAB14L8xJwhaSJcoNqEZj2GPSkFkg
3753	fee_transfer	1724	16000000	1	CkpZE38PsZz85V8ppXR2xez6xAPqFrsVuocuDhV87ZXgbiZBf1GE4
3756	fee_transfer	1673	36000000	1	CkpYUoRZzYQcz41dLP1Nf8Ph87pCLnAqgEKR1EqfTK2232wH7yafA
3761	coinbase	1687	720000000000	1	CkpZeH3uVPXQWkcQX2No4FtpBhTejBsDaznkzHt2A2cjzkMmfy88u
3762	fee_transfer	1687	10999992	1	CkpZXe5sChGjmT3bgdRfWXzzNyVS1cvJEBx8j4kZ4KnRDNY9sYY2x
3764	fee_transfer	606	36000000	1	CkpZrrB5riUWHNvioTgujyhX2JxoudBahby4U9t59gtFER4yEsfPs
3766	fee_transfer	1727	12000000	1	CkpaJgQvV6fNaZm1R6DWnybpB1DcSJK7LwNrDaNCAThF9P67DA6y9
3767	coinbase	407	720000000000	1	CkpYWKjn4VD86KP2A1K4454UZ7jJvge1Dz1eYBtAsHyRqcHsyTY8v
3768	fee_transfer	407	13000000	1	CkpZPh1Rv2HXyZNsWCqddUvxE4B1eZzwkn5BqJtbDoKZh7N4vJbsk
3773	fee_transfer	1768	431000000	1	CkpZVDma6jgkdFum9H73uqW7q6f3TDRK59QAahYrmd7pjfDxb48f1
3774	fee_transfer	1471	3000000	1	CkpYr39PYr1Dnu4WRKFvUwaXaTE9Zu7avZ7VhXK62wj2JcDB3J7xv
3777	fee_transfer	1717	13000000	1	CkpYVM2ZPmDcghF6ZNuBVyaXxee94AzZ6WHy6eNfSun8rRYv2T7J6
3794	fee_transfer	632	62000000	1	CkpZG7NHMf4HgMxyZ3scQ8THoQw68vquxrFCbuF2XrK5vktcGDH1u
3806	fee_transfer	1610	13000000	1	CkpZvLVBQ79mFXWW6H1v3FrMH2eA4EQYfn4HUTHCKiLcy24BNFqtM
3811	fee_transfer	1723	90000000	1	CkpZJnCJJmmrvKuokbzvL7NQUhMeNbZb86iRRqhpsLr5yStsBHhuR
3824	fee_transfer	1643	13000000	1	CkpYzR3GVXAdKj2a81Hcn4iyjz7QoppkfPhgcVgcPDeqYPr3oU6zX
3831	fee_transfer	1419	32000000	1	CkpZrHazyn3c9kGb7eba4E67Co5Af2sfQDHwz9vynVMgPrdgtGq2q
3848	fee_transfer	1727	58000000	1	CkpYYPBuMREwo2ZzVKmXxehyb3kCS7NdLhGhLHwhxNpMVGhwh3FEo
3855	fee_transfer	1692	12000000	1	CkpZFbEnvzqp2dE24GRXdDMCruVUDDZFZi3wgiynzmB8HM7jLtgpg
3861	fee_transfer	1471	134000000	1	CkpZ2GDucEsxeCAwbBRpk7JqRKiB1Ua99Rk8sXvRz2a9SCwvhxgAn
3868	fee_transfer	1741	13000000	1	CkpZGDpiixaeBSzpqXtG5xoDTyhmjqYxtbSn4YWH8s5hUHoCrMz2V
3879	fee_transfer	1670	65000000	1	CkpZuBszDgDFqefeg2BPgioxxkdzzLAVg3mvZu5YjV3Nef1sRauz2
3882	fee_transfer	1684	25000000	1	CkpaDwj4jWawFrPsbQ2GqHLjjaG4EmkkuVtTedMGRD3ycP5gPSoDX
3887	fee_transfer	1691	13000000	1	CkpaAYGtyccf2CdREwD371hc3uFsz47gVrNTw5k1cK676gdYcfCDs
3894	fee_transfer	1546	13000000	1	CkpYiW5mjUBn5Z9yEd8NwKdjHBPd88ZctjtdcN2kecj8ms8y4uHY8
3895	fee_transfer	1467	13000000	1	CkpYmhiTwHk1qAn2L6GPSU2Q9ZXNqVvMDw6qvj7ubk8HrKQVU4217
3912	fee_transfer	1719	14000000	1	CkpaHypv3oXY7EdbGD64DkqG8sE4PvZK1KRSVSZ5VXTUaqQvboyWv
3915	fee_transfer	1677	46000000	1	CkpZDx4EFCYshwCFrWAVgWmAVa3zSy1tnJwPfgoschBFTGeJKYsVK
3920	fee_transfer	149	23000000	1	CkpZbfcC6En6kbUMhCG6cZcZ7yMd767oio7dzRmiyUGc2NaHNjo8B
3923	fee_transfer	1727	26000000	1	CkpZwRtau1Hw6Eskazk6a5YkuVqdbn6C87cSYfrvPGo8LzE5yYY8p
3924	fee_transfer	1714	3000000	1	CkpaEppjr438RVKkGpghSgLWPu4o3EaMuufpDJkgnS6mbasC53dqk
3933	fee_transfer	1678	12000000	1	CkpYQ2XjHR5jxsLeau3oorfLFr8Vh6itn8PFG6HZfviEkXHRyaNes
3940	fee_transfer	1560	41000000	1	CkpZrWBRaL1J5cqhhbVWaCTFmGUMSYajN9LKcMffBtyAGT2G9Jf27
3947	fee_transfer	1588	13000000	1	CkpYwhedtRkgTXoJVmFYXym9zZQdCF3fc6MfgcroY72k4CbUEptJs
3948	fee_transfer	369	16000000	1	CkpZKv8Fa2E8TaNiM8jdPRH9rT1Ffe8d14yaYMefPkGhNL7nwKC5Y
3949	fee_transfer	1723	19000000	1	CkpZkUg3Brx5sgiHVmYkHMq1fPauytBcfXNsFb3RUDd6fcjDTFF9M
3954	fee_transfer	1672	13000000	1	CkpZTRVez1NmksuzpQ11bVsxom4vVUs7U5CmjphLSVnD7dEHNPosR
3969	fee_transfer	1702	76000000	1	CkpaAiaWZMfuyVZ6XneMaPFYTCV8VEbpvDggPTMDyJ3h9PRRxvYZi
3975	fee_transfer	1689	13000000	1	Ckpa9NCJ2KnD53qAp8f3NUd8dHm4M6GgLkVXwKZGBXLts1xqkKBqV
3979	fee_transfer	1458	13000000	1	Ckpa66fRsXzVdNV69sNQqztKN7js3Rxxqfm7u2Vs21X6habNeEvL1
3986	fee_transfer	1678	39000000	1	CkpYYocjwXJHVt4oNmjaPPEnW2Lz4XSLyTsweseMMYD7P7tVSHWF4
3987	fee_transfer	43	26000000	1	CkpZbgqrucfks2SdyAxpxAqsQ9gwW2Jo5YFLtVo8ApyhoxXhaR9Zu
3989	fee_transfer	1474	31000000	1	CkpYkrLuhCwe4LwneTobm7rw6PRvGd2igVWL897s7rFHSFZGg9k7j
3991	fee_transfer	641	38000000	1	CkpZxBKAqhFhHr3SUjbNxknddcnbz9WnZcM62qSr1EZb9p88B5ExN
3995	fee_transfer	1656	13000000	1	CkpYn5AxzBRmyVikwMw2Ej3DTTBY1BVG8xj8W9w9uHqmoN32KqdfF
3998	fee_transfer	1607	17000000	1	CkpZFzr2fUdP4jgSPPKsxZsUzA1SSwujsqrSiiAk7YHwoJ4WiQzsM
4003	fee_transfer	369	51000000	1	CkpZyfLryCNpe5WUFmfF3yoUXUoXYrnM5GVjVo5znpEgo2vR4TbAV
4006	fee_transfer	1593	15000000	1	CkpaBafkvEbCLgPJEkXXkNJFyJdkcEfnYcVndxDNVxFFBfRBiYJEL
4015	fee_transfer_via_coinbase	1796	1	1	CkpZcg4RcygGnCMeAksTYzXfJ9zmPCuVQCBp8ekFYBBKpAViP9Dac
4016	coinbase	1980	720000000000	1	CkpYX5RFtyVkGUKmLL4veoe65ZtXcKKyiAgUnY1sPHgQ7iTxJV56w
4017	fee_transfer	1796	3	1	CkpYWVgNhzsWp2Gy2TuyM7FNhMJCXhZvY9sFzJAVndAo4vDaxTaJZ
4018	fee_transfer	1980	995024	1	CkpZrwaqvpS19DTHesDL3npcNLBxcuNhZepXTt2iFfTgjUfsfoBsu
4019	fee_transfer	1449	5000	1	CkpYsuVXpFy8CkU5usTctA6X7xwBuMe4AR5q25cWj6rcQV5NSqa49
4020	fee_transfer	1527	26999973	1	CkpaKDTbznxaFQEcScPdjoFUzsho6Ga7QjTxKWkjZf3YCNncXhFKw
4024	fee_transfer	114	28000000	1	CkpZbdQGxibAeLQ31s9PTnKZE7ZceuZH5viBSHr8Yv6hSYvPGm7Ly
4029	fee_transfer	1692	26000000	1	CkpZcq6EA7dPdndpkqzTrr9XeeSGfNvG9zTCzRasqcab9da1uTvyr
4034	fee_transfer	1692	14000000	1	Ckpa49AKgCUaQxW2j7mdisqG98ApwQQwSyQG1NrLdF8J3fiyRRLFe
4038	fee_transfer	1649	17000000	1	CkpYqxEpLvqjvXvUdS1PfWXrhWM5HN1CvavCsQtQqnp6qUSLwpVnV
4040	fee_transfer	1593	13000000	1	CkpZgmNYoSxyhRCDLR7DUD6FBqMU3q233hPkCefbuQXDGCAavUva5
4046	fee_transfer	1764	36000000	1	Ckpa5387a44vqnLSvcJHEk4TMM36dVHn61LByg8xNHaX9a4v8mbZM
4049	fee_transfer	633	13000000	1	CkpZ64At8oaPoEfTEegs335FLLnPeeG8vwpFYbjfyAtkQGpQkVtMB
4050	fee_transfer	1677	18000000	1	CkpZA4ahFNWH2VH21pMCA7398sKKqX9JyQNfBAB1kzLbnwnjjoQoF
4052	fee_transfer	1622	13000000	1	CkpYYvXuE2BCYc1LMHHoBpbFeLDka7usDVcSrUkDXp6MUtirPi71P
4055	fee_transfer	1650	15000000	1	CkpZvZSrgSXABzXzu6bd6C9U6f6HQAW6iYZEezhKNcHnZDH5tEsow
3721	fee_transfer	1711	24000000	1	CkpaEMPrnmNsekxyp7wyZWG9BacHhqq3kWC46hE8mGMhupANR4ASV
3735	fee_transfer	1597	15000000	1	CkpZJgQrg8xmkhV11h8LJH6c7DFBSbwwQvGcigM8zGyYa9K4nwo92
3742	fee_transfer	1762	23000000	1	CkpZbwpztbk3t8Sxz8Cxw7sGgHEwNsbu1HgUoCVthSaQJ7yKbMABv
3744	fee_transfer	58	26000000	1	Ckpa3w8Hfw5R6oMtWZjWEvxMHUL2e4m7amfawiJcJ2cRZxhHrvRXf
3749	fee_transfer	1573	12000000	1	CkpYQzVLX87P372QRi8WXRVUiZxB9gk78u4NiT5pwytmERnKhAyFW
3750	fee_transfer	1649	25000000	1	CkpaEDDqEUVCm4wkxCAb1FUsUzcMSuoqnkYKp9r6z3AXyjqomAirF
3754	fee_transfer	1634	63000000	1	CkpZgiijq3ZbFm4FiBGKVkKYVfuYrGoZgKtxfbXkoiRni8Woy6vJr
3760	fee_transfer	1709	1999976	1	CkpYuip21Gtbv1QDTA1TWv1kuZ72yCgCTVcztE19AxbwSPuSuuP9x
3770	fee_transfer	1691	12000000	1	CkpZyU1xEQvSrGzEGiwaHgUJoL5kFxyuvPZgLnYDrUN5GdKoxthSq
3771	fee_transfer	1547	46000000	1	CkpZqUeE4UpKyFAE12SCaw9CSw571zDvn1SffDc4TKZJphpfRm6se
3772	fee_transfer	1768	70000000	1	CkpZdwym6uQY1TkQFcTPGZUeVXpNgrxXBWSnkY2J1prEp7s95C2pQ
3782	fee_transfer	641	12000000	1	CkpZmGw6DpcyRSvCZwo87xtyRDaCPrhvcaUAEvKbCpaFJ3UJy7UgQ
3784	fee_transfer	2086	12000000	1	CkpaCLdgcisqyfwRRgFRZ3ovBtZkuRF9trHmY1voTWaUSrRq8ERFt
3787	fee_transfer	1654	14000000	1	CkpYme2EVrV16xE4s2cazSqeQ6cLjXRgxuxY31hAPiaYvybpbBKLD
3792	fee_transfer	1683	62000000	1	CkpZZxGVPQz7weXcD3F4Xff2zxD9KKtCAb6TSEpEwDG1dd7iVVXNg
3800	fee_transfer	1649	32000000	1	CkpZzL2d1JGZBSY7rpZi85BNhApMioUGnnTWkdhRczj1bAhKn1iQQ
3801	fee_transfer	1649	7000000	1	Ckpa9sAbm6g7agBE2LbkLhwkrtqCpFJcHRkVu14bv3PEWUhXvw3S9
3803	fee_transfer	2087	13000000	1	CkpYQ3f3vbqVuapsazX93JHCiToiMDtBFwxLhkwkAGS53vFVFXA9p
3805	fee_transfer	1508	24000000	1	CkpaJ9tbSfb8JBAPvkVqsrijfwFgy7k6yMbDZpYiUP6wJoPpVTr9e
3807	fee_transfer	1601	13000000	1	CkpYRPaSYvibwcB1u4rqfELemZgJeQkBBnzgEtQWDyttSyjTsmUy9
3815	fee_transfer	1716	12000000	1	CkpaGLTnjaXfLpPr8CdFa9qmazb4Q9T1fwDkj2fNTSUKXtwPjZKAG
3816	fee_transfer	1749	13000000	1	CkpZJrJnUjD6o8Xr12m3hkQZpyoB9DhXUxsfXtWi6VEcSVqkBtJxG
3817	fee_transfer	1685	2000000	1	CkpYWphZ8JJtBZWeJcjsjzPcRirHnEE3uX2biCY16jqrwejBQnUJh
3821	fee_transfer	1599	13000000	1	CkpZyPBsup2pkEdZzvFWbHivRmXjpcWhRD43TjBj7WuyitGtwfCgp
3825	fee_transfer	1696	39000000	1	CkpYtSb5sPJqoqXENjvUq8SMsCHwyJfho79H4yPdDBjDxFoPXXG9N
3828	fee_transfer	1694	52000000	1	Ckpa4n5vxXvMeMkmNE6EA5eiavwwMg7ukUYLUv6Dz82ECF2a4D8P1
3832	fee_transfer	532	32000000	1	CkpZinBWZE98PDwuDrKrBtWhQQ92GThxaQPW4uCjz1dFQ2dZDReWj
3836	fee_transfer	1695	12000000	1	CkpZAGYvN2mE7kHMbj6MiN5fVvR5qvsesSoUrnTuMTEkNYYWgZRPd
3838	fee_transfer	1850	12000000	1	CkpYj339sgJpvRtRR6mgJ3D4V4KvVrqiAReJ5Ed3Hp3GeAf4vc3WX
3840	coinbase	1677	720000000000	1	CkpZuQf8d8iMg5AwqEeDUujuvMGJRPNwrmquuiDRMsJ7D59P2oHFY
3841	fee_transfer	1677	1999966	1	CkpZgDgBEg7UN4iYThKoCRyVk3HpvUXcqt71TX4t9EfywrQAQPdqa
3842	fee_transfer	2052	25	1	CkpYxawXGXd1quv1CcBqtpcwek36RuM44Wp6J2QrTnswVkwwWoRLC
3843	fee_transfer	2004	9	1	CkpYy9JUGPrcVPQWR29mDenGYzfMXXnZHpc1HuNqQ7TD5wTzgKgbp
3846	coinbase	1646	720000000000	1	CkpZzCC7SX2MZJTGG8EtpNNJeJhCn72V1oznY4ECcnniFjVfoZZ8x
3852	fee_transfer	1670	88000000	1	CkpaCRcTdN4a1otzW1XwsTYhw3Mb5KHCkPXjdegSSMmnqMQgUTGAD
3854	fee_transfer	1466	12000000	1	CkpZcBA6njyLtv5S7gcaCxM5c6gzcAyaNDccVqQru1Gdpq1UumJA8
3858	fee_transfer	1564	502000000	1	CkpaDFo8pe1WfAD43bQqwvzUGMmnA5jqooGiv9gcqcJN9qQHJmvWP
3859	fee_transfer	1564	470000000	1	CkpYsV61K7HJLsV6ocLJRcVbGGaQ5hhhNW6NMRUcnXkcK8Mvfa2sN
3860	fee_transfer	1423	11000000	1	CkpYbm4yG7gsEiyLa1nFtz8dtkzP7TtJbfhyEoiTyYUpKsm1SH2nx
3864	fee_transfer	1467	126000000	1	Ckpa8rP3S47rGHzMuXKuZntQe2s9g4m8XRtJ4PCnXNh4u3cA1T5rz
3867	fee_transfer	1571	13000000	1	CkpaAhmzwKuQgUKqKueoB7iomJYypiNBHiK5g9zpU9gJDc11b7TNx
3869	fee_transfer	1423	13000000	1	CkpZ831oZDu9xeF146Adqqzc1WX2gqQbCJkQRRsZHxoitW8tVoZUx
3874	fee_transfer	1599	16000000	1	CkpYwwG7d9zaa8GCZ7Az3VgGEbVACsDDeWLp5gKKZWvF313iKK2T7
3875	coinbase	1591	720000000000	1	CkpZedRd1EqaMLfpEMXQo9D8swhpvqXeVRNDGkrfvxECByqWTokAU
3876	fee_transfer	1591	13000000	1	CkpZmsm8mZXQESuaKGZkc6awUig1rcHVJoPxtvci4dJsTcf3ZSoUq
3878	fee_transfer	1746	13000000	1	Ckpa3VyFDKpqANXu9oqnhM2vDgAh2tuuHdFqsYb7pRwVN63rsuFKG
3883	fee_transfer	171	25000000	1	CkpaAEAxNdLTsNWErW7Y84wR6PEETmTVqrYSFLxbFVnKWssi3y29Z
3884	fee_transfer	1696	16000000	1	CkpZzKfVURBaAuCSZsEmNdSdYUBA4mLYHJn4NvRtq5zLKTsgATS27
3889	fee_transfer	1683	26000000	1	CkpYgcYkjjVXPeArAUVfwtwc3mxVezCdUeWeDXsMkfS7FJtwhSKCn
3891	coinbase	114	720000000000	1	CkpZphJHpoCCt8QSb4T5PMQ3YWknvhe1JaXSWL2KLPoAm8cC7ht29
3892	fee_transfer	114	10000000	1	CkpYtJkg5d9ogwg3349Uk5RtzP76qw26H2AV9KsfQZxffiBvEjYPZ
3896	fee_transfer	1634	13000000	1	CkpYUzq695o9BjYyjWzQ1DCANnYChLQkuuxbgkxDop5zBz8cMBfzd
3898	fee_transfer	1683	52000000	1	CkpYQSVpCmjz6fDKwL63a5ETaqguaeaUUBRLPUs1LpEDXt1piDueB
3903	fee_transfer	1719	24000000	1	CkpYgE8GSsVfnSNHF14f8uBkLA2xu6v9nrLEi8BzLUB2e7SQLHT5k
3907	fee_transfer	1694	23000000	1	CkpZPuDsaYGjAMY8QiBUaFeNvmuybufuCyN5YoFVkpNoNGmTWVdsw
3911	fee_transfer	1559	13000000	1	CkpZtL2oNgnBzTepxZxoXoJ5rmWYhFJeeRmHuHpmj81QFyG3dRFSH
3913	fee_transfer	1402	13000000	1	CkpZaA7wXyQKTdgaJ9ihFtmzaFwYV84AW31siXpWgvQvBUi1a6QL2
3916	fee_transfer	470	23000000	1	CkpZ3sbHvWznJV4Xb7CVPTe1xgKgRRF5NLLwnkupAFiHVTVVYx1dx
3918	fee_transfer	1649	16000000	1	Ckpa87FEmGWMfeQEbhaCDfzN7RaiaiqVHQ4haKpGDnHHDvCgPVdrQ
3921	fee_transfer	1633	23000000	1	CkpYT82B7roFaaGNhj27cPQiKn43oWWW95VVrcLDYTPZTWPfMJyPM
3929	fee_transfer	1740	39000000	1	CkpZtt9B8Cbdep1uQrG9g1V14qtBBafhCo4ijSHNKSGwxazNK4Tf6
3930	fee_transfer	1690	52000000	1	CkpZExQ9LY9XgrhnDKafrMNF8q1xnHr7HCPMuqw9Vr5ghAUc9Vc4x
3941	fee_transfer	1685	52000000	1	CkpYbhtHJzNswhoHBkUAcusPmDmD4ZPc7nXic2wzHbfmHsUMJQ4ka
3943	fee_transfer	1458	16000000	1	CkpYRTSLR66o4kcVybbLknh4mqYSfvTkNZ5sn9LHbZFZPmt1UPqDT
3946	fee_transfer	1677	26000000	1	CkpZUqABAbhgcT7AR4Rta2c13ZM9sQQoVPdV7rwf3gav5hy9MWinQ
3951	fee_transfer	1677	16000000	1	CkpZ2kXdM3FP1EfD8if8LhX1U6M5LFau2YFvFt9qh3FY2C8WR8EyT
3955	fee_transfer	1656	26000000	1	CkpZFJcHsBmxRfMs9Q1G4nFZEfo4KdE25YEb4V1CeYXuK9SHDqkox
3958	fee_transfer	576	31000000	1	CkpYQVyZfuc4TngoAF5SKnUHG1Ro2AkVfUpqD9EQTPuDh9RicY9Z1
3962	fee_transfer	1455	32000000	1	CkpZu9etUFwsVZWPniNP91B45EWbD6uXg9M8UXJShCNcVkU7HAxMw
3966	fee_transfer	1684	76000000	1	CkpZ6xptsrTk9RHA2stXFUZTZoPTexdoYo6s4HnuxGKqFnBiCE7PG
3722	fee_transfer	1709	21000000	1	CkpYgKCiRR9SFU7cQ4VAAbznwbtAnGmsdAyQQoaBwL5EzJueXJDKe
3726	coinbase	506	720000000000	1	CkpYuwBCNgB1KpySKwFK29giBczpB55AGFtVWhBGQTxYaMDvCWkX3
3727	fee_transfer	506	10000000	1	CkpZavKmaJHGoJTMLepMMLKfSnF6GDxZkRyqCbW4rGn9LC3XrxPbb
3733	fee_transfer	1747	13000000	1	CkpZKLrQPaeBniwaB5kjqZZsodKwfv2krDjabTkUeqRqEF4Xgv9Lf
3734	fee_transfer	1683	51000000	1	CkpZ6cnwiNSXTUj4TSf4CpoqfN5oWo34vVnE4TeNJ5d1XnK9uXv45
3743	fee_transfer	1740	23000000	1	CkpZZZQZGRKrPuNJEzJdkwZvRy66dhRK39csanqseRWJwUw3bXTrF
3745	fee_transfer	1588	21000000	1	CkpZ4tj3ojHax3tVDRhWtWAP3mgZPqybr3KC5iVo8szGNbLcSuLhv
3748	fee_transfer	1509	328999993	1	CkpaJ8EtJWWtKwy72N2M5UnVS9pZvbzihZ3xJKBZ82Gfkr3EyidQF
3751	fee_transfer	1607	13000000	1	CkpYvBvBUzzLMAE7UR6v1kyEXX8HdhKQxKRDm21AKbwmw2u42uR2Y
3752	fee_transfer	1448	16000000	1	CkpZVCKxkcgcHVT7hehno5u6c6iCW6pcJaRmiiL6fHGxDmP4h5i6H
3755	fee_transfer	1447	36000000	1	CkpYuDCxhvWwiaw2AVHSvGX3gqDKESB3y6B15EAf9EroaQoJywPfo
3758	fee_transfer	1693	36000000	1	CkpZDPSEUhNmFXHzDaftv7VzPfsFc912ZFCjhkQF7wL9ZAF2Dtn25
3763	fee_transfer	606	32000000	1	CkpZBJM7wnT4BTuAqwMtdPBjXyDaL3FCnFRPv63yFD1QBf4Wmta2m
3765	fee_transfer	1474	36000000	1	CkpZaoyokvvGx4KkRGCdhW4dkjcLFRpRgBzCNqkSexb5TLtJHyxr2
3776	fee_transfer	1695	13000000	1	CkpZYuGJgNPSJnFPuvnVgXxWN2c71fEQbZBGk7ExJXbGXkSNV1odQ
3781	fee_transfer	1522	23000000	1	CkpZW1sXxbJYYnas1qEc7o1KQANq3hsD2LVj8CJ1RsNbqoa1qHrUV
3783	fee_transfer	1696	14000000	1	Ckpa3VNG6wsFduSsnndBBsLnyyjKT7GbF22mnKm5BCFD6xcHtwGjA
3785	fee_transfer	2087	12000000	1	CkpZcycbaPEv4qgSFn9pL8Fi8AMBo7cVZPd9ZnG2ShcECvGcCCQn7
3789	fee_transfer	1747	16000000	1	CkpaDqLTK2YXFFemdAp1NTrEmtfw6cKA2kGqzhLdf3XuqzxvdRUQp
3791	fee_transfer	633	37000000	1	CkpZg24vpu151o7t9G6cP7YCVeBuRAUbkddCcgRsQxy1C6Y3oAqn7
3793	fee_transfer	1695	62000000	1	CkpZ2jWuVX5nUrozHJLaJs5BModisjWXmrB47ickaTKssQRya98ct
3797	fee_transfer	1768	312000000	1	CkpZXDxBPrwscbpx6H5U5NvNQQR954kGoKC4E447dW5MKMnHc7ie7
3798	fee_transfer	1668	36000000	1	CkpZDaoBZpgTfVFBVyFuasbG9uFLfUbaNuViFenBRpTT7G5wzatyq
3802	fee_transfer	2086	13000000	1	Ckpa2kb3fsETyngzk6EruNe1xE5UmauHdFZ68z9pE29xjBuqmjHn3
3812	fee_transfer	1671	26000000	1	CkpZwtmvN3HLWrzV6Z3pXGnTUvHzz8N8FgRHiFz5ybNSPHQ9pXvpA
3826	fee_transfer	1419	39000000	1	CkpYW7dfw1VvGyoet9FrhoLLxUXnALVPXPb3i6dTyx1C11peNeG7j
3829	fee_transfer	1555	32000000	1	CkpYb8ZiBX8Ro5CZ3BPz19wzrnrutR7zBEzCnprhzxVmGAyEnHvtd
3833	fee_transfer	1708	52000000	1	CkpZtHGRTUbfez7a1nYFHRmGUTbUq9kF6LyHeym1izv8MUcWK4YEe
3839	fee_transfer	633	12000000	1	CkpYxV7PxnKjw72LNbZs194U5FRWqcLKg31oyoaWSejZHorAu8Nk6
3844	fee_transfer	1706	772000000	1	CkpZ64WhmCVFrVfxuWNQMrBBiP9JVzo7CfxwHKiJtfTFh2nfG3hjf
3845	fee_transfer	1706	570000000	1	CkpZnwKuiccjRxYYSq248U9EbdURuPgMYpqiw8G48d2c6CBzTKsRB
3849	fee_transfer	1616	46410000	1	CkpYxt1HEwfeowYnGJDwyq8amFJbku5RYG3pWRGJkbzvtNobfBFE8
3850	fee_transfer	1670	89000000	1	CkpYc9pgTk8maiAqTTvgpuS4hX6krzXL46V4uZSPRA8vsgWoh736Z
3856	fee_transfer	1683	43000000	1	CkpYWFE3Wx77pDwQXjEMAF8h1zzXnBBHR7Du52diT72jLz7WE11uL
3857	fee_transfer	1457	22000000	1	Ckpa9bG7dRz2crq98YLHchWvd48NxAVDJuNpJRwf9wwf2RQrfSCmH
3862	fee_transfer	1649	126000000	1	CkpYpz8eJcgPF4n8JMp1c7W65HEDsiG4aAkiregZX8usMjPe3iiKs
3865	fee_transfer	484	27000000	1	CkpYud4Rbhb2CjwNorktowVnxiaQrRHCNWSirYSQ62zuawbPBCYy9
3870	fee_transfer	1670	14000000	1	CkpaEwsULyuUm9NXmnf7u7qioea56v1Z6sNNhSYGr53WgfDBEH7um
3872	fee_transfer	2039	13000000	1	Ckpa9AnuJPmGucTv7Ejz7UZUBUyz2JDJFCVuxGDgdEA52ZM53TxFV
3881	fee_transfer	1646	50000000	1	CkpYhUB13LaY6VoWTJSFC7EwBy1pP8thDbZ9ST7yZmMaDJb1Niirh
3885	fee_transfer	1596	16000000	1	CkpZMu5mb2v8UowUYPjd8QXWvJAw5dM7pypfKCQowqdVCdShFpgcn
3888	fee_transfer	1587	26000000	1	CkpZPJxbRh7RPfqSwt1yqFA9GmwybjfnenrRpDK99q7Xm8ERi8NNk
3893	fee_transfer	114	13000000	1	CkpaE1cEMjScbASTLR2c9UhEY96JJk5PkakPvtp1HtUKBUwHUWUfc
3900	fee_transfer	1980	770000000	1	CkpaJj7QU9JLGSCXKjQwez2SfFBXiMisMzmsJHTmNe5FxYar5NSfR
3901	fee_transfer	1980	192000000	1	CkpZpfrJHuNjfXiRaoqpp5y5UNeCte8SuowEKUgJ4xE5RWcnG3HXX
3904	fee_transfer	1706	26000000	1	CkpaKiMgZX8gg58JSWDQqBnoVwQpUBXoyUm6VVZAegXGqcHQcuTrR
3909	coinbase	1583	720000000000	1	CkpaAcJ63EktpZ6K1p9emeow7k4XMzwRPYzGLkvLFb37Y9nTZp6KE
3910	fee_transfer	1583	13000000	1	Ckpa8cNuaH2yogbbsFpTZJxG6VmDdNjbj8fysL7KNf4hr8dEvYDxd
3917	fee_transfer	470	24000000	1	CkpZbiAFUrovxRj7HgKHHuePBo46BHu2KYGua1xkU2sHaiSS5HYYc
3919	fee_transfer	1673	16000000	1	CkpYyGRS5v9jWTQsFXoCpE5pXPcq1Ka5S8VMnZh6DT63hXJ6xKUz5
3925	fee_transfer	1673	52000000	1	Ckpa8kKN6vo2XW8zGQhgLVy3yCs4iavXtbSrNdmgKtNkcyYxdroCe
3931	fee_transfer	1702	68000000	1	CkpYngCrusxMvJuygrruq8TPVXb98EdSJsgrQyb1dBVJYyzDTe5Xn
3935	fee_transfer	1740	567000000	1	CkpYgS82n849J1myg4tgw7iC1C4TqRdnW8N92RMFiudE48KRsuHA8
3937	fee_transfer	1685	26000000	1	CkpaAfumLxqaaNVZaf1WJNgrpYitu5SPsmyGDFA62BjNuo8Em5f7x
3939	fee_transfer	1560	52000000	1	CkpZhqJbZPUg6wohoncdma12Xwbnbrn3PwW7c5vPzB1qtfWiEK9ao
3945	fee_transfer	1692	19000000	1	CkpaG9M9GNFmCJMFGiWPTXdFxtYBStcgBrDi3NbFZnrHSp7EPfHhn
3950	fee_transfer	1522	13000000	1	CkpYrNKJvXyZU1Xzwi3FZ7Wr8Z8Smzz8pj518Sy7h2xXoHRqMksRp
3952	fee_transfer	1672	26000000	1	CkpaGCCaYdMS11mYgd8cbfv3WsuPF88LDF5ZDK7PskqUivEBjD29G
3956	fee_transfer	632	26000000	1	CkpZMeRkhfB9tY96XbTrSuo2eVuyBiV9ZWeGKhPwXZ3LwqFSt6BYM
3959	fee_transfer	1692	13000000	1	CkpZsJmTkqvJGd8DbUFVW7J7QHY93iboEDSRTTSYvmu5kswsPGr5g
3960	fee_transfer	1643	16000000	1	CkpYx8cVidhesnGJuZEprRN2v149cpERrYyTkStFigrPG3mSEEpQL
3961	fee_transfer	1672	32000000	1	CkpYqUoJ3xa9hpRSPQ8fw4JysvQaWVnhB7yY2iEe63kxYNvfz7LfS
3964	fee_transfer	1685	32000000	1	CkpZFWrEX2C1UDmiV631PymRXijJLhWHdAPphr9pCyP1SJ1NUo9eA
3965	fee_transfer	1677	76000000	1	CkpZDLYcZNxy1trC66Bo1C7SvHMv4bcgtmRob9dhPesizPMDHn8rd
3968	fee_transfer	1696	76000000	1	CkpYisWvYwEQ1pyuwbj292mYJymwAoXLkL7ryfQWXydf7DnUjrSah
3971	fee_transfer	1608	26000000	1	CkpaCJkMdgmNyFXpSWHLSvkLCXWQjYnwxYqfeuFh3LJpajg8YQM2H
3974	fee_transfer	1683	29000000	1	CkpZBZsexdHXBZ3AtzsWqWv4d4eivAVJeJZ6yGfhLjc6MgwQmzHdb
3981	fee_transfer	1571	16000000	1	CkpYwXpzK7qtW17g2eypAqGyEnrLFo44Y5foFY9EHLt5u9wtjGDfA
3982	fee_transfer	1594	29000000	1	Ckpa8V3tFqri4Ew9dAj5ZSBhoVgSeNhW9o6rss4A3gyUa7Cg1yRFv
3984	fee_transfer	1991	85000000	1	CkpYqfTr15EVfs4Mg2VCayjrkhSaqt7g2rfRvtG2RFxrBKQeMgAbS
3724	fee_transfer	1709	27000000	1	CkpYtDwbxtoLfSfir3Uy5z1GYYn4JqZHsrKkw8zbnBELzgrpXaL1r
3728	fee_transfer	1715	13000000	1	CkpZxnU7XDkbccZNdCv6ThZLdchY8RmE77ZwwTyFbk3KRBnPKjS29
3729	fee_transfer	1419	12000000	1	CkpYxBS6pr4jVzKdebfKNsrUpSmt5xyh63fnVm5YYmCQcLtQ9WUca
3730	fee_transfer	1683	39000000	1	CkpaJw4ZzConXqM2J7RzyJiowZr3aYrPs1TLLpAq9yB2mB1SegPpu
3732	fee_transfer	1506	13000000	1	CkpYekPSKYWiQvV9BBifNhHMD6YkkxBVBQ5E3XYtHmaeBR4GcQNML
3736	fee_transfer	1729	6000000	1	CkpZNq9tnnfw16P7WPbJarq1V1smTSVQHaZYKniQxgJpxX3XLyCnN
3738	fee_transfer	1703	3000000	1	CkpZ7n5fHbucvDB4AsbySHdLQaMQvF8JErxRBhphzfgRGybbfXSJ6
3739	fee_transfer	1703	3001000	1	CkpZcGtoiVD4sNuZNkrfYbzSC8hdw4MxAbEfbnYnAM3cDma37o1ME
3740	fee_transfer	2069	1000000	1	CkpZ23MbQpwudLYnybwzBENFjKpnTc3gRGwF9Wo5u4pV3Fxty89yN
3747	fee_transfer	1426	12000000	1	Ckpa66MEczsQFkQF7uvWzESHQHJvJ3LzDS6y9oprRc31PDVfFCTB1
3757	fee_transfer	1506	36000000	1	CkpZMM9WK2BzDnFiuddS7evHpyzQhYEZb1YHpL27cPrdzx6V9QVb2
3759	fee_transfer	1709	24000000	1	CkpYywZoPDZT8XVfHnSNP6zqzwQo6bz6a2K27km1WfyUA96oznVd8
3769	fee_transfer	1762	24000000	1	CkpaA7EEcXyUANy97mCoHfyxTP6pyZ733BuKJ1PhK9AC5FvCQsgjR
3775	fee_transfer	1448	13000000	1	CkpYUpwxwdB7jRoR6pcTBZczdprQ9qcmVUdzCAXTunrZYuQsq3Px9
3778	fee_transfer	1633	13000000	1	Ckpa8DT9NkTVzQZoemfe4edgMTgXqRwLAKYvrBBdDqWQNyoBUcvFK
3779	fee_transfer	1685	22000000	1	CkpZHZtQ5J7EnyPknyLVwHzCo7SRWaWjFNEWM3NH6cmfZa4hCK7Zi
3780	fee_transfer	1991	23000000	1	CkpaKcTof1fq96WDRwL4mGJMSrz4wRUiiP8TYXQMdwK9LvvW4e2dB
3786	fee_transfer	1698	14000000	1	CkpYtgPtA4dnsGxtZEHFznxK329VzmvhhuwhGiwMXaEUFpPt2QWC4
3788	fee_transfer	1704	16000000	1	CkpYXTKEYgA1EeJNQBTD1XxQe5M7YPWzkNUNEeGZz3SNC34j5jFU3
3790	fee_transfer	1467	12000000	1	CkpYskdiXQcKRqLs2stBsrj2iToWUDdRGcJsZC4TCxGMpPkJvX7Th
3795	fee_transfer	1564	382000000	1	CkpaKrrkHidaKVX9R7JqiMzuRf8dWYA4h8xURUriibajcYGfKdeEL
3796	fee_transfer	1457	12000000	1	CkpZghB2srYKDdiiGwrTKY1S7yMUekHgtH8yBXpju3dNJA8bRNmra
3799	fee_transfer	1764	25000000	1	CkpZQLxKRZfbnCP15Xyw5CTuPGBLJnGXSmS8GNLqwhdEohQVcxLh2
3804	fee_transfer	369	24000000	1	CkpZ1TGfjQAoCCjR1hx35KuQpnFWyNQcsL2hCmThMjupZY42hAAca
3808	fee_transfer	1593	23000000	1	CkpZgVqzpotYFMSFJukyqQykMqgN7mhw5pnUge5gZwohx3Buh8r4y
3809	fee_transfer	1694	13000000	1	CkpZzPiWTYeBHQ26KWBNQSP2QJYPEzASckjKFnG9woEkWSKfgg5Em
3810	fee_transfer	1426	90000000	1	CkpZwPkozVd6fztpokU8pAiAQu6EEvN3CrBGRinQNqX54qkbP3ogi
3813	fee_transfer	1850	26000000	1	CkpZ4wjXdgqdZ7fQiZcNbTpQASnLUSjPM1FigSstc3SFdt5KmbjL8
3814	fee_transfer	1656	126000000	1	Ckpa6y3xurf8nEheCH9DqJAsQnEneXghYz317VaojbwVDLbFW1JHU
3818	fee_transfer_via_coinbase	1423	25000000	1	CkpYeH8gz2bsBptAEY3NjFRvoxWtdjrFza15Noxtpn4Ksq2LE77Br
3819	coinbase	1677	720000000000	1	CkpaKjn1QaRqNv8giaraLTTUcnA5HRm8tjaQUquANdCz8YhyHufMw
3820	fee_transfer	1677	13000000	1	CkpYv3LxbRaUremKWtpUW8KE2bm6uGXGbfA6R2HDUe8jgJayTyvaS
3822	fee_transfer_via_coinbase	2069	1000000	1	CkpZ23MbQpwudLYnybwzBENFjKpnTc3gRGwF9Wo5u4pV3Fxty89yN
3823	coinbase	1692	720000000000	1	CkpYrGSKqUcuMnVUorZoTX5LNejeruaP9C4MTJGSXmh28prnJM71B
3827	fee_transfer	1685	39000000	1	CkpYxJUXRAZxVhABsgoXFNAYFu4bkaLwvZedHgXNFs6S6Zwtn3UUN
3830	fee_transfer	1724	32000000	1	CkpZc1mm5uLAC2V2CUKrQFBnYjkiAKpPm284Ha61ez4yRXhqULkAm
3834	fee_transfer	1677	52000000	1	CkpYjAav3YRqfWTmNCtBZWTWxwAX237K8pr8AuRzPFp92KrtLYQEL
3835	fee_transfer	369	13000000	1	CkpZYduZacEzKZ9uxcf7gnoC38dJDua2hnCn7FWw4mkjxQzUNcy3K
3837	fee_transfer	1680	12000000	1	CkpYm8FfMn1PGPWsx3VrQdx2erPBjR9U9YqRUASWCvzP6SmEFQsh5
3847	fee_transfer	1683	59000000	1	CkpZFs5L9f3UqoQpr7VvQa9LuQZw8nAh34pu66CNYNZ6bhkDWeHTA
3851	fee_transfer	1727	89000000	1	CkpZVVXzn4CkFgfcQcHi4JgEdzjTKSN9NZcztiDAUsmk5oLSxtLGH
3853	fee_transfer	1444	11000000	1	CkpYuRUX4EPoqydbXktqYWcHh2LhRtncZ2o6xynGZY7rM6Mo4ETSS
3863	fee_transfer	1701	126000000	1	CkpYTwJNzkYCDQSQN9N66J8iaPnyYdy39J92wfZaVjG3QuYpufJDS
3866	fee_transfer	1723	25000000	1	CkpYVUUYoYrnuU3ZpxnZ7gyfAVJbtEdUizy62oJ93aVXmos8ZfXF7
3871	fee_transfer	1467	14000000	1	CkpYhNFBjNwy9941LJmqKUGcesepHe3LFuieugvZuHLJoAMHHNbJN
3873	fee_transfer	2039	10000000	1	CkpYSxDwjZMMwKMXS2ai9yziPaysW3zNvmrW1xwc5iqDhWyHaP233
3877	fee_transfer	1704	13000000	1	CkpZqHXvZUnrE766BJ4oCMEvjLbKZ9KLG3VV3wVo3j5jyGXDDRRw2
3880	fee_transfer	1706	65000000	1	Ckpa8eLbaVBXBs7xyMMnoCS56rgNv3CYj7aAUiZkahU2WHawkRs4U
3886	fee_transfer	1762	13000000	1	CkpYQiNMdEEjyGXc9KaxY9sgAvBdyB3sGixzP9JhdUFB23DXL26yZ
3890	fee_transfer	1560	26000000	1	CkpZPEVtnDEFeEdQCtUvhyQY1vx5tFDyzJ7RuAeFSTeFyaYNK7YnS
3897	fee_transfer	1716	13000000	1	CkpZb3R4jGCTwKBVqQv1V2n9bvDFXVCEFrAAGvjei2C3VEqGZtzUh
3899	fee_transfer	1522	52000000	1	CkpZTaiDncQp5Vrxv3RBmwR8LxvJwKapUEAFMdQUmAFqfa3Vehr4y
3902	fee_transfer	1980	13000000	1	CkpZBopkJMmGuCaR63axoo29TBjFwastYvHa6aBFAwP4t7NXP9CJ3
3905	fee_transfer	1622	26000000	1	CkpaGEdMysEqFrCFu4aNf6mWmy93T33tCnRs8n9naSrMBsLr7gPsW
3906	fee_transfer	1633	26000000	1	CkpZJH7FvZJjH6eB5iZc9w6f8xAu4J82ajv9xtTEBMZGiZozCACao
3908	fee_transfer	1440	23000000	1	Ckpa33DdeTY9mV86BMv5urXWiENv3vbctcRimBoVaF3C3m98cWxDM
3914	fee_transfer	1679	41000000	1	CkpYiTjh1kvdVUALfDPN1tvGUCCN4XtgQcfFo7oXXpBzkFk3d6CvN
3922	fee_transfer	1402	26000000	1	Ckpa1Q2CC2KPxMMuPwxP3QUGT7P5waYjyYMJxi9835Y3wDQeG5Sd9
3926	fee_transfer	1440	52000000	1	CkpYewEy6fDYt56yFAa2enmh6UUyNVTd181wZUVTWrWherTUnvuVj
3927	fee_transfer	1402	16000000	1	CkpZH4V3QF2jaLhjkUDCqkAraT168J6Md4yRK2wLMaRELtfviTVZ7
3928	fee_transfer	1692	16000000	1	CkpZUWkUQawV8PwmhGa6H5vtsSuwDhDn2HzUnA2P3H1wkBCfYvs4j
3932	fee_transfer	1703	51000000	1	CkpZZez4jSuqUpS3hTkoH8nWTshkrQARSYgke5CaTAW2Pbam5QxvM
3934	fee_transfer	1740	12000000	1	CkpYpwhyi67Cn66Tzt4GUAt372CDr1v3e9YNeuNx2ZKksFg3Zxtww
3936	fee_transfer	1474	38000000	1	Ckpa36vH691RZJYsipyFSX6XWfH4d4sp2txU8XQGWekwPWW1p7V8U
3938	fee_transfer	1605	6000000	1	CkpZSmaaeLzYuKUXNGzTyxH9Rx6nBnvDfvW8xDM9x1cyXsw1Pz7wU
3942	fee_transfer	1513	25000000	1	CkpYSE9vhFAGwLAxEDq4EWbWXhGPzPnhaGdUbx1JhHreTN9QLYCkr
3944	fee_transfer	1610	19000000	1	CkpZU8BQ8TySJWJ8RNYvzMG5pM9PjDY6ZPVAcuGZ6H3esEpUFm1GB
3953	fee_transfer	641	26000000	1	CkpZAFYtvqRjmHvwHLTD9KyQwPrDzR6oBwpuRKSzYYi1tE4X2QLPg
3957	fee_transfer	1729	41000000	1	CkpYSYHf1n16Vk112kauUQCTY3zYo4K4ofdZDfjrMuuqFqPmL17mj
3963	fee_transfer	1719	32000000	1	CkpZ9kSowpmmF4MQasD2vH6YRQe2YaAVgWQirTfPVj2jhjM4B8GwS
3967	fee_transfer	1684	62000000	1	CkpZBnEEfcuEXsesH3Z1dmwgVyM2g2CLTMd5aEd9sqLNDmBQXwUFV
3970	fee_transfer	1703	62000000	1	CkpZc1iBGzq9JNYwvzDCPN7RMDK4wM9CBBVnK8sLA57YMgUAYwyRa
3976	fee_transfer	1643	15000000	1	CkpZnkJq7yMtZiDg4at2JQ9oozN46HMW88ZTUVkcFzny8vbMtxuEm
3980	fee_transfer	1991	10000000	1	CkpaKoQfuH2Mxw9N4Bw7j1sS6m6FUNZDkhga4DNLAU2MnLfE3efAh
3983	fee_transfer	1991	101000000	1	CkpYXqKKNMKhE63EGuwUwHTEt5kRg1rxWaCDfopzU4waS9YgqEozF
3988	fee_transfer	1271	26000000	1	CkpaDoZ28EqLoastLAae54KiAcqXpxLg2W2wpCCyoUmfd9otruLvM
3993	fee_transfer	58	21000000	1	CkpZ9FgUhAkKe4yKTaUV2Ft1122GM5eEjAi7nJnF4Ba1D52UV13TD
4001	fee_transfer	58	43000000	1	CkpYbBgcLhEeLn32ixqDaVZj48Mu8TmPkxHAcxQPBrApvYnA9C5XE
4002	fee_transfer	1749	42000000	1	CkpZ9RhEwzMeXwE4Qc4Seot7NUaUCdW8y6585TTDukwmbKp3t5mVp
4004	fee_transfer	1513	22000000	1	CkpZEGLnzLa9fADTQDk27FeTaaWrWqi2ZXKELBULUuBfDQqFqQnHS
4008	fee_transfer	1476	14000000	1	CkpYWpvcRCkXaHrLWdT3winNy5oTVixKCZ5FJsB3LyYWrDYtBk3WK
4013	fee_transfer	1444	27999999	1	CkpZkmtD1ZF4bSDWxMrEuUArH7UcPPmJfJUPV8Ho4ujMPc5drBzvU
4014	fee_transfer	2097	1	1	CkpYah1WARoVEr4sUrsEZzYW7DD1QF3XSi1Xg5w5g6xsa7bitWyLn
4023	fee_transfer	114	27999999	1	CkpZbqZzG3614NdYip4EH24DgMA62jXYhFa2EKF47namfDFTxnCkY
4026	fee_transfer	43	15000000	1	CkpZC6KsABKpL6xWvuSWunsGM6FE3cnRAAopBqMQg5oWxJPjbgwC6
4027	fee_transfer	1560	15000000	1	CkpZMHG32zKPnq3yqydJ4QUJYVFWnQD5KzWEWLzDsC2hUffmfH8g4
4028	fee_transfer	1509	12000000	1	CkpZ7xqzJxP1q5tZWRMwnT1dVXYEh4TwZDKbjGyZLzfTyKpQKt3m4
4030	fee_transfer	1513	26000000	1	CkpZEzf1avsXf8X4ASzM74P1UN9Stp47XxPRurdF54REgHRQLGhPS
4035	fee_transfer	1474	26000000	1	Ckpa4k7YmAXDMnxFPihgPVqHz8YhRwvGVkT4e8ryDXUzWU8wsbz52
4036	fee_transfer	1719	3000000	1	CkpZdQSDSkToxW5UGYvzBRfZSHBxhAe7MNonFyKFn4t255SmwUoz8
4037	fee_transfer	1587	3000000	1	CkpZ6BzgqkVoHJwP6L8F7hsLWZJPrtpjzkoeZdhX46gcdwVpNYXh1
4044	fee_transfer	1764	33000000	1	CkpYkk7auLJ4FQhvh5cCnGug3MyTdYcMGhUmRv1tnmVoMypQy9ypj
4048	fee_transfer	1509	13000000	1	CkpaA2aJzRWawcfZiC23LgmDK6jHMhLX1h72NAsxVtxkRzMxGTCom
4053	coinbase	639	720000000000	1	CkpYS7zLWn3bBYExjs1xnngPkwmM3W9rWiDBRbR5aiWwaVhrpiprm
4063	fee_transfer	1693	34000000	1	CkpZjj4X1CXyri645mmCKNJfqBYSVYJTxcZPBepCpqBZrf8frGQ5h
4064	fee_transfer	1693	4000000	1	CkpZZ2USJDfV1tMVEDFPkHzebC5rNUyf6A36E9qYCeZJnXogWmZZj
4066	fee_transfer	1749	34000000	1	CkpZWod81v46EWk3e6C9yNNu4BYpoKJoZaGkSXapbH69C7TRqpqZH
4067	fee_transfer	1749	4000000	1	CkpYWDz7A9rWMKZmiD5jxjQx8A83DETcoHYvZRxnbn5u2pkkqkeCz
3972	fee_transfer	1444	26000000	1	CkpZ1GY5K9WRzgVmCSmQbsjjhWRJSRc3mCHWG1UJsDHhuiR1NysuY
3973	fee_transfer	58	3000000	1	CkpYjFSykF9dp515E4xXAN9tbRingdBQqVJePMfDKNZx1HUgexPwH
3977	fee_transfer	149	38000000	1	CkpYvXzMCPLaZuFywZDT4Yk6gyNbRwcAG1EgDG9U6SAPP3vixXLzW
3978	fee_transfer	1672	16000000	1	CkpZbMsy2SS5LzaXmAPHStRp1yuUevkt1jHyceBF7sbTqD4dmES3S
3985	fee_transfer	1654	85000000	1	CkpZBefnLYWrcFAaK5iSqyTnBmGyyKxCrpzaCUAWnLkr1UcaZQdrD
3990	fee_transfer	1513	34000000	1	CkpaFKFeYxQANexzjyHPAGkdzAviWkyKjJNuieEqjmvWZQVgnjEhY
3992	fee_transfer	641	13000000	1	CkpZAsA1T6pvgHV33kKHG3hKqRbXWRPCPhjq4Zo3FFNKnfJpBF89R
3999	fee_transfer	1688	14000000	1	CkpZXzcLGz6Pvde2qg5CgAhMjq8aWEBnnHC7WCdRTPrSbVqa45Do1
4007	fee_transfer	149	14000000	1	CkpZLy9aJQ8Ufn8hu9awRSCSdHiYeEeMvEW6rfDdJqNvMD97QcSqA
4012	coinbase	1634	720000000000	1	CkpYWpb7T2at3GjeodT4wZQWYKzZkd47b6QprShWeYK5ZdiWcskjb
4033	fee_transfer	1691	14000000	1	CkpZRTN2zaneqHkhsMrt6QouD5vktkBtp96NG19BdKwMxYn6exyKY
4041	fee_transfer	1602	13000000	1	CkpZ3JbrwAZ4ZGXaTwq5RHiY5z8g3y8Vn7Xqo1eDNX81GLwqJBEJy
4042	fee_transfer	58	44000000	1	CkpYWYnCMN2WmCihbJE4XVhHvw3dQubfcswKyNUreuB8KU8a9Uyvf
4043	fee_transfer	43	13000000	1	CkpZiiSJtE1Y2mvaqQifAbibhT3PE6gPi66MTMYaNUUQsQPkrSkTL
4047	fee_transfer	1685	36000000	1	CkpaLYxee7TU9SHmARSbW7K94usznKeYtoVb72EVHHhvcMbKnpVMT
4054	fee_transfer	1594	15000000	1	CkpYthZM3UeuLFjTzkeK3KEzsoW8acQJ4CdGPQeRUvmHcqJoXJQvi
4056	fee_transfer	1701	13000000	1	Ckpa7TwxYKGGaQ3TWtCS9pw8vTagsW2CR3efJHRCRGULxbWz59d4v
4059	fee_transfer	1547	13000000	1	CkpZAnTaBRXoozc5ELeUmymLMpBvcjfPJ7NhdTxV4VeqQrCGwp2Yo
4062	fee_transfer	2039	34000000	1	Ckpa7ChzjmwgfnTHSi8UhVNiEvpDMXqwpECbLmitead44iaZvHXUN
4068	fee_transfer	1451	24000000	1	CkpYTgmKxFfHHXFz1xLffoCd1Q4UGihoUysDyahVCM25VXa8Nob7V
3994	fee_transfer	58	15000000	1	CkpYzcX9no1cT16P6MgNrxYRSnAcj1CF4Q1UkucPfB9ZQtGzo6tb3
3996	fee_transfer_via_coinbase	42	100000000	1	CkpYjjJT8EkvTBuMpSU3bHnsbQbvoeuFe96hfSjvGAUNe5dnfaR8j
3997	coinbase	1670	720000000000	1	CkpZxX1dKu71DNNUukxHBWQcr1p8Hdkc7HpEJSNrptgeMHumXVm6p
4000	fee_transfer	58	5000000	1	CkpYyDQ9xfgr8HeKFS1c9zSpzhVQW5Y8jFPERFjUigGjKJ3pfhdHx
4005	fee_transfer	1709	14000000	1	CkpZ69c39xPAe1HFBLRB19pKCq4j7ofjaeW8uNSnq6v5XHrvVkWZ2
4009	fee_transfer	1476	11000000	1	CkpZqHKzCkmPK2WtvibDPfXaK3sTj5ELzFWVKTXFzptZvwYJVP6am
4010	fee_transfer	1685	14000000	1	CkpYckoiETSv4MNHLfdMRY9qNyKj9A3xxGoL6CVbLXyzTufhEcWDs
4011	fee_transfer	1650	56000000	1	CkpZdqrxMWvhwDsdphdZKj8BDbfWYfwsp2xYStRRV5jLnAxX85BVv
4021	fee_transfer	1796	6	1	CkpYaSfZjfAgsEHit2VhxJeuch4KNfY3spzgH8fqFrbgrREuFd6QV
4022	fee_transfer	1980	995021	1	Ckpa7SZaP4qMKthCZgQ82YdpaTo9atERUFx1wr54kP6vV2gNpgtg4
4025	fee_transfer	1634	28000000	1	CkpYRLbPDW6hmqwDSX3Rj2PCQVgaK4qRTzrECXAmvPizSLc3VtsE3
4031	fee_transfer	1506	26000000	1	CkpZvEsTuHgVFm9Ba45B5b3h6zZXUkMJcRErQMdVLPATeYoPKW8bs
4032	fee_transfer	1634	27000000	1	CkpYdkSqtdQn1tSUwaFFvWrudLW7W6VDWquPbixwNRRYsL4YDHqdg
4039	fee_transfer	1522	17000000	1	CkpaAfjj6zuF9F8UQwYbQne9vpAL8YJcVbzDeKu4MJSvXNQSLSMCC
4045	fee_transfer	607	36000000	1	CkpYVA9mjmNPopmkoYTFQQLSHa7DyJsEF1RspZ2Bb2k9RREggQEhx
4051	fee_transfer	1683	18000000	1	CkpZW4SF3DBHdskzNqS3uS2tVpi952xWmccDwFnrz3h1GyGvV4xCF
4060	fee_transfer	1422	13000000	1	CkpaBibygoo2yzGi2wdqvfpVsrVELUAKSgumxaUF94pN9kGLnw395
4061	fee_transfer	1683	106000000	1	CkpZxGjw9Ci9MWR7tCi8rp67SZETTVZc5Sw8CiYpDFrsz7SrfojmU
4065	fee_transfer	1677	4000000	1	CkpZiUh9shneJVDnpaPn5bcvx8YfqkCgMh62AwCQayUhGHPWmo9ZR
4057	fee_transfer	1559	42000000	1	Ckpa9EmzgRn5pS5N7CfYN1rDxEWoGs3evNXT1hJnS3afRMASNkiSN
4058	fee_transfer	1708	13000000	1	CkpZthbBmgN43trUxReypm3CKCyJ6frqFDVUGewUpANWG552BubCi
4069	fee_transfer	1451	834000000	1	CkpZkHBmKPXGeHtCb2cV22qeeA3Cj4r18uRcqYBRLqiHRT1CfWA9H
4070	fee_transfer	1451	420000000	1	CkpZ1Z7YuQuDsLsNdgqWHLbiAzga1EAHbdQg9UBs5QsRqVRnhrhgv
4071	coinbase	1539	720000000000	1	Ckpa8RqSRHcNNvE68Yj2cTb1ihJ28YLnPjsVmiuiPypFE9Kwjn5xs
4072	fee_transfer	1539	24000000	1	CkpaJ3dtqGdHyKQoD6X6H4bXpfMw41eVZHbt1YsmyiPSMhzfuoz8f
4073	fee_transfer	1508	36000000	1	Ckpa2dRKPBRtvYVb4wdkRmzTPinMxSQiCQt6uVPA7fk1r4fzDC1ps
4074	fee_transfer	1613	12000000	1	CkpYpEUux2EhQhzfaGft3HpScj6AaTGEmLRrKo5gBzUBxZaRKEPxT
4075	fee_transfer	1633	12000000	1	CkpZMVaayYuRXp7e7ER7YmfdXcrcbEmTosSKcJFhVgTL4MAnRwBfq
4076	fee_transfer	1759	26000000	1	Ckpa2HZmHmeMMP7ZibEqMyDgv4qndcEA8dRBpQkJHq6nfZEQ8rgU7
4077	fee_transfer	1451	12000000	1	CkpYkuJYdXouHaMskRymVBFvmB9zUzvfp8JgV439HViLyJJqbhJfi
4078	fee_transfer	1768	25000000	1	Ckpa1pckDnwPdkd2PKMTHVwKKx6ozddqrPQ7onWEsMfbajeiCPde3
4079	fee_transfer	1668	24000000	1	CkpZmKwpasUUKJsGoDFjv6NLwQSkk2zQcYNX4FkoBUN7R3zgDC9Jw
4080	fee_transfer	1689	28000000	1	CkpYRVP4MKQeBpCYh4UMfv9uutK4iFsL1nHcYrXpa4X2xm5vEjYS7
4081	fee_transfer	1524	13000000	1	CkpZRo1HDNbTMwb3d6KmDLX7evAN4Sf2BFvGfqFWAoeSd6D3EvfCS
4082	fee_transfer	1549	23000000	1	CkpZqNogAaCYy42EVtxrz5TV7cV2BUTpinn9uiQuZu6m8Aim4bSba
4083	fee_transfer	576	26000000	1	CkpYahSV6AnhoPA5tu5RnyyvdW2VcXWQzKbe7AUQmqM556QpW7eJU
4084	fee_transfer	1602	24000000	1	CkpYdJtVWHjhn4JiBuUnxf6uaiZQFCNvy7mu9p91Mc5he7DmhnsZg
4085	fee_transfer	42	24000000	1	CkpZCEE1G1BztxjP2i3FP2YkkKjD1L18m2Z9ivX9jVcaQZbNuUGUQ
4086	fee_transfer	1599	24000000	1	CkpZivRUvQBF83d9qPStojF6vJqn1Ppp5tqzpbjGyJ2xTB4LKrwty
4087	fee_transfer	1476	17000000	1	CkpZCcrjqxDxqkQ8pi7V8Sp6v1CNfR26wTsjSKD8q5fDMEHeyUFbV
4088	coinbase	2106	720000000000	1	CkpZjoqLSE2ha57puxZkRg2obWHNngwfhZS3vsJ9ZsaTzVGCGfC6M
4089	fee_transfer	2106	13000000	1	Ckpa6shVC3aBkP2EwK6VzLxa7yWEYeLfqMEvKkUkGstmr8aPmGXTw
4090	fee_transfer	1440	13000000	1	CkpZe4e1hYWdhrdeJ9PuDYcMVK2wad9d1uUFKBhAcQyYz4tbC6BpF
4091	fee_transfer	1675	24000000	1	Ckpa1h1xh8dg1wDx4FyHwfuqw8NFQUd7wjGUS2rZkn8HNs1LqQBJi
4092	fee_transfer	1678	15000000	1	CkpYcYaRTjzM4AZHfjQthUaZaF77bcFGZreFnKnmxXnxRVuWmuvJa
4093	fee_transfer	606	26000000	1	CkpZ9FmW4jjfqANU8Ujt9HeipWyHRyhpiPT5TZr1WLmXTJV1mv9N5
4094	fee_transfer	1723	18000000	1	CkpZXBsQ2PciStkXcH9HgSTZjQHjeREd7jr1tDbNnaHigQep5u3uX
4095	fee_transfer	1513	13000000	1	CkpYV3VTeDsi3MznjP2n5LZpgNFxUdqSfMh6VX6mqEhvTJ7fZjMwu
4096	fee_transfer	1444	89999983	1	CkpZT6bYpUaZWqYpoXkBPb7T9exDRKsDmK6wUYXPhxNwH1BvoBekp
4097	fee_transfer	2004	1	1	CkpZw5k1WxfVu6dT8KWSme5MUkQ1dPH2fEuRWrCTAMEpzMdP187Fm
4098	fee_transfer	1571	16	1	CkpZXfphHvePbG5Sm78wjEzgPG8PjNTXZU3usB8E313fRkCymfrDF
4099	fee_transfer	1700	13000000	1	CkpZtH2SdAFV3gYW7C1dBFbjcbU8HFs4XUZizMub7ue89NNMxCZPQ
4100	fee_transfer	149	13000000	1	Ckpa1F9uGBBzv2JjW7v6gcNrDhg8xweDtGfpkBr4VFZTnb6fMfJ6F
4101	fee_transfer	1683	38000000	1	CkpZ4tatKJB4FFjyyHZZikpwAvvajEC6U3EnNrWL3gpwyTuc2MFcK
4102	fee_transfer	1690	3000000	1	CkpaCzTeVPYCouTwKcBWbEQS7ajTc34KXWXmTVELrc6B3xnSAYUjR
4103	fee_transfer	1637	2999999	1	CkpYbXNg2Y4YuzHfwzZkHydvPJJwiLMYA2Qse4yWH33zSnck8mexM
4104	fee_transfer	1688	37000000	1	CkpZJ2onGovxtnAPDZtPQnJPw9iH9n5wD2nayA46CQ8TU1s5ABKqK
4105	fee_transfer	1506	16000000	1	CkpaCtWniEpX5aUn9feZSJrbCgDnQd5cZe3CtqUCqYy499xQ8PyJ5
4106	fee_transfer	1593	6000000	1	CkpYnELfVetcLQJ9gdggrnSAEQWdJrHwtw6eeDGnrnsruFhz51Afd
4107	fee_transfer	1402	36000000	1	CkpZRnaKTrNtjGzJAZAnMRQ4C37KvodEdyDBGSU8dUEqjkDxiWKJn
4108	fee_transfer	1675	13000000	1	CkpYos3ksLCGmKbKYxaAgqsGMsa9d3u39WDYdXt5mpgufEpyoig5g
4109	fee_transfer	1690	12000000	1	CkpYr44fkUS4MWgYcYWTNDSXDpXVrAXwX1rY8pL6UgrenUAxYUzGd
4110	fee_transfer	1518	26000000	1	CkpYw3EQQr6XbtiAjaDySnkUuNXMMXKMb641YFQPZsjaVRwx6V6Lb
4111	fee_transfer	1687	26000000	1	CkpZqzsu2aWbJmSnDkzKcUzb3gtQVtxDY1isny5UN7E5aY9GU4qZn
4112	fee_transfer	1613	26000000	1	CkpZtoW8G1fbpSjJDB34NnZuhcR9vToF8WYw36SZxmCKqXrYDMU3M
4113	fee_transfer_via_coinbase	2097	10	1	CkpYQm1dzx7T6n1ri7SPwnxDZF2PUiPSBYFEj1ycM1uyaz3Xciiqz
4114	coinbase	58	720000000000	1	CkpZ1rL9w8bXWBh4BciShNg5ERuhDsGY8eSbDNcALm5oKSPiFRuwy
4115	fee_transfer	2097	10	1	CkpYQm1dzx7T6n1ri7SPwnxDZF2PUiPSBYFEj1ycM1uyaz3Xciiqz
4116	fee_transfer	58	999992	1	CkpZoKZC6Ak9kLfgC8mUpPkWCxsm3xGJBbmNU8UWU6eZENwX1fPny
4117	fee_transfer	1680	13000000	1	CkpYdDnsaZsZtc2ZQC3kmNz2Rg92FNkGi3PUAHibPLYdfWmgcWtMS
4118	fee_transfer	526	13000000	1	CkpZnFD2Z947Xhbgz1cRpQzdzdzbhac3GAXdJKeVsE72uxv2f7Z4x
4119	fee_transfer	1474	982000000	1	CkpZvHYNAapmiWcHSmCBRD5tjupK6Biz6fzc2TteETrTPxFjCb4An
4120	fee_transfer	1474	16000000	1	CkpYqXY3DFdoJ2ozhf5TmU2H4Htw82Cs31AJ5humBWZ74eEd8WXRM
4121	fee_transfer	1426	39000000	1	CkpZSNuFnL1ZfduxZBSsAhN1WhEbLJ4GQvjkyWPL87eMYp94zLYPd
4122	fee_transfer	1677	39000000	1	CkpYSPHsdgHiT41JtLnXbdPrBDqXdQUa3VMFmmuKE8VS1r4gRCsv7
4123	fee_transfer	1422	39000000	1	CkpZFpr2bQnfsFzDCvyR1G8kNQiCGffgnnV7AP12q2EWvDj1Bqugk
4124	fee_transfer	1711	26000000	1	Ckpa2mBxD6XVhGsXZRGBZL3v58sFYjJXqQwLY5auMsbKzFTM9TwZg
4125	coinbase	1534	720000000000	1	CkpZsGbbfJwJ65dARdiKDcw8g8jYzCL88V7EJ3GyFgm4Rr8dm5phE
4126	fee_transfer	1534	60000000	1	CkpZcGupPPYa5h8oEYLszLLpckWT29KzWbteozDig3CRCpsx3bQ3i
4127	fee_transfer	1694	66000000	1	CkpZ4NfhaQoTJ66k29ELu5kwJ9uepWo59MgpbmVBSvHryNNGjK886
4128	fee_transfer	149	19000000	1	Ckpa3MM5rXagrptzMN11H12mrV8fGACFJ4QScEV5Z6r8QDU3ZZYZ4
4129	fee_transfer	1599	26000000	1	CkpYzb5YPGnsaPgiSwFQ8kKb8eXyS1mKM7wdroLqfPPrH58nb2qTb
4130	fee_transfer	1637	26000000	1	CkpZz4vHcdFE32VhsGQU1vL8D5L62VBqridNqnd1oACcqBZMpEXtV
4131	fee_transfer	484	950000000	1	Ckpa9KJvkrfa9burfYGWFKUbGbqwvRJpEddspwvEcpYosEMLtuphk
4132	fee_transfer	484	162000000	1	CkpZ8izNsp768RMjiDS3xF3qu8eCHfs51f8BtzxDiihUTcdCUKCQD
4133	fee_transfer	1729	32000000	1	CkpZyMQwAZsx8dfJcyFrTLYef3G7ciyddRfCQPoTM3kaRJSGYcURv
4134	fee_transfer	470	13000000	1	CkpZgEDmHF8UmLjNP5VcEryi1Jb57VyMw2J2KyAbVkoFBCcYWCCKQ
4135	fee_transfer	470	15000000	1	CkpZ1iPqMda615QdPAFTvymdDjA9mbcszifqZrBBGMzja8BtKE81J
4136	fee_transfer	1677	25000000	1	CkpZyqRFcZRrYBkzbXaTcvWCQYDvoHLiA7W2oM1SxGenP46Egfzea
4137	fee_transfer	1708	25000000	1	CkpYa6xpd3CfSKhBvow8E4XpHVNH1ovaVEFB2N45Wfmf4XUtHw3eA
4147	fee_transfer	1509	25000000	1	Ckpa2VDduARtq3FHZPFqPnwMFNq7LUf8aozkptWm81JwRL72ZaiCD
4148	fee_transfer	1706	12000000	1	CkpZfCP3BMdM8pR3NJ8552xNyieKi4dDFnTeua5TwUC8yLxHGhFzJ
4154	fee_transfer	1729	16000000	1	CkpZrbFL6Q1AEaxqmHtZAnSayghXWgz2Ho7MnbNJSWTCbVJQyfwgN
4155	fee_transfer	1536	26000000	1	CkpZ9AMs7ETnqdFvuUaZis2uDAaVC2MFizH98oWbKpH2Q9j9TuL2W
4160	fee_transfer	1764	51000000	1	CkpYxfthWyqbzXfNf8MkoA5ixjE34rMf88RvYAyCnJj6ttncLVza3
4162	fee_transfer	1764	13000000	1	CkpZV8AiffVNxZahLsSUW4JD3b4CE1Ruabn61NuUp5ZB2jxYMH8Pq
4171	fee_transfer	1422	12000000	1	CkpZRBMobaReW3JxqBfoQUCSPUirDJuqgiJBP1oVAaaBy1pgsn4id
4182	fee_transfer	1672	24000000	1	CkpZ3KFuVGjWmUP9WXbLNwaMCtX33x9PKaVUiEk8w3ZdhHGhPYyrP
4184	fee_transfer	1708	12000000	1	CkpZrQwwznfWaApLkRpGnEbnfx7EMXNoXEL2sFLGfdu4SoE545Uia
4192	fee_transfer	43	51000000	1	CkpYvzwujLsmELGc3EXgyFJbNyLJs8ojbZk2vtaMUG7TNPsbTc1nt
4198	fee_transfer	1715	31000000	1	CkpZr1rbinBX36ht192gYsaMtWnxPgxgTMja5a9ZJ7caVii1FQWQM
4200	fee_transfer	1534	12000000	1	Ckpa7LLC6u5MX7sDfzHEaXVaaLGfVxBxe8HPmSbGBAEnmMAUUvozA
4206	fee_transfer	641	450000000	1	CkpZ9bDjv8WH8Y41N1Gdbxx3oJ88sE796mWSTud2kHGyfokRNHRhe
4210	fee_transfer	1426	26000000	1	CkpZKREEFvscjB7JZkZbcafYYCEcKA5QvnHjdmtCp7X7F4LGNfw5K
4216	fee_transfer	1671	6000000	1	CkpaDULgUbL1p3WASWry36ZY9wtukXPYTUWhJYtZhdhAGg5CVzfN9
4217	fee_transfer	1559	12000000	1	CkpYwsBnxgYiSC76yTLGawAd5aTmEbazCuZRMp2HEY6tjj1VfVdeC
4221	fee_transfer	1613	52000000	1	CkpYddcKdJL291AZcRBJhgmDBKPQsebA2TCbuYZAgev6etJP3ZdQV
4225	fee_transfer	641	41000000	1	CkpZrVEW4y5PxSfJSrzRrWmd4CC8SYshLdk2hjQbuQ3dzxRvTXtRj
4226	fee_transfer	1688	39000000	1	CkpZDxW8YwG63cvzw7a1GnFbMJVGis72hMq5JHmnQ8LpNT25TLw9o
4230	fee_transfer	1555	26000000	1	CkpYWXx4rygMm4iHx8gLyvxgCfqeqzSgfnqao7sh7DUjgJDtMGd6G
4236	fee_transfer	1764	2000000	1	CkpYpK5BpNfPi72JKMJyYKQXyKyPLe31GCWuY11uycafoDJrPNtpe
4238	fee_transfer	1693	35000000	1	CkpYsei11e6Pwns1dep8Z364cvH3JfhnDNBsepyaFrkyS2wbWU5jL
4244	fee_transfer	1622	15999991	1	CkpZGDxCh9Ra14y7J7LVaKm4AeBjurc84fZPqa7UTa4PvWJiKdzNQ
4245	fee_transfer	1448	24000000	1	CkpZTtJdTaisHwfVACNifFG91wtBQoNzxyWJ1G3wVMKbWCAXoUwrn
4247	fee_transfer	1394	11000000	1	CkpYRdwWfa8xHQdst26UWRtAqE28WV1RStNg4dMR2em65cPZC75PL
4257	fee_transfer	1587	24000000	1	CkpYeukM1qLcvkRgVNuwxMfwf449sq3ngg3ivgcPZ272ifBPTqeDz
4261	fee_transfer	1555	136000000	1	CkpZXA7FmouKZoZ4u2gFttLh3nuuh7qdSUzQSHB1zGnkPxFiUVBRw
4268	fee_transfer	42	33000000	1	CkpZkm7FPfVfmtVYaZsa4NSSFnsAH8jJ4FmWSVUpqDD5nk8GWm4fg
4270	fee_transfer	1534	1000000	1	CkpaABrTtULYVRcmLC3sVo57uQCSXCvWVLwx1xHHVWuFoezWNfrDF
4281	fee_transfer	1740	36000000	1	CkpYfVtwB5Nrx1MKqWC4aEjpRenG1vX7YA5dgT82r9xk5PEU5rJcH
4296	fee_transfer	1644	23000000	1	CkpZN7cntqyZfvdfutr8teHkXAT3p1n4g4tCBLR4QzUmLY1sTLWvQ
4297	fee_transfer	1394	51000000	1	CkpZPVGv9ScTngz5PdVjqwq3ByMohJ1FnwVbqxnpbZY7pHgvZuhnZ
4301	fee_transfer	1649	72000000	1	CkpYvs6kvbQuVjoK6GUvnyM1fKffSdi58HyhErBfmxBxfmza63Fm3
4303	fee_transfer	1419	213000000	1	CkpaK8ZMTPoAdRTN1ZGkmf5mtoyfmqomxrSPLzKCvEdb3kLLydzE6
4313	fee_transfer	1675	213000000	1	CkpYyLH4bp78axHEqvn7At1NHKCnyLTRcHAsizzWNMBTS1gZTCyey
4318	fee_transfer	1394	72000000	1	CkpZHdQi57PsSZRoURUoA22XHRfT7fRFiiEdjjH9v7VMqfv7FCpum
4319	fee_transfer	1444	61000000	1	CkpZ4thPeZUBups7m6VntQtd665nePr3R1tLn4Qkm9HY8xRBaZgcp
4321	fee_transfer	1727	51000000	1	CkpYphjvW8MKFiora3ZRdEx8kUhb4Ch9v1BkbYmPjzMK2bM5okFdL
4330	fee_transfer	1670	22000000	1	CkpZu8LiZboBxj2cMWtfoFbomhbaLvRmCsD8izuVXqCMcCZeEN4aa
4333	fee_transfer	1394	32000000	1	CkpYekgfsE3e6QWi9uuBmpLUjVrwTbcQ3AJacLGarx9w2Pc2zhWqM
4335	fee_transfer	1634	320000000	1	CkpZMFDdqYzAujjefcJ8bBfrz1BUxufnv5qTVsnHMq3AgCmQ8PrxL
4336	fee_transfer	1634	1020000000	1	CkpZi2CaJuu7ocW4ia8XzqmpkdWfmK6az1FkNQQzNRZg5vU1ZnbgH
4339	fee_transfer	1675	55000000	1	CkpYzkFAnYYZuNeAckLFm9mS1FHGogM6XaESTFNYLha9s1PkGyF5Q
4341	coinbase	414	720000000000	1	CkpYqJUDEqvzYaC6AMX6eZru9UERavmRbHrs9LxHSkk9xDg2GEAeF
4342	fee_transfer	414	11000000	1	CkpYbcvMwvJ7MWA9gAUaEKNTbCSWh8Vrib6CmnjQofuHfL7Viedmv
4344	fee_transfer	1716	22000000	1	CkpYSxQ4BesMr9U7oXkj4RGn5sts8sGKkvnq2YkoWgNdVP5xT1CeU
4346	fee_transfer	1671	44000000	1	CkpZNFed3VV27E1WeQf4xzweYG365pcurgyJW6MtEVAxyGDDVbAu2
4352	fee_transfer	1703	22000000	1	CkpZc2KUgZ9kimX8eyNXG6skKGegks2A1UmKTocFuy5HCsw5axHnv
4354	fee_transfer	1623	540000000	1	CkpZmFPrMxQKXXHVjLKVT4pxgmBkJ91B2taDpwNEC9Ny9if4eh5ng
4355	fee_transfer	1623	549999984	1	CkpZzQiHBn3Wjt7v7oW9pwnZJ8LZgViDAiYHDEnrEKLwRpQTBSRqp
4357	fee_transfer	1756	33000000	1	CkpZzrs3Ft41ZRBnBpJB9c9xixoLwfPt4Ut9tmEWvoC1s3HSyorw2
4365	fee_transfer	1395	33000000	1	CkpZPpKkaknXBZwECAWa48ZNP9bWimhW13cQPyBjuFUS63uKCSQ32
4368	fee_transfer_via_coinbase	1886	1	1	CkpYum9kj2tV598ZnWkxLVJWHy1eWkTD6VK7tHzzFLvcRfNqVHmon
4369	coinbase	1534	720000000000	1	CkpYgHvQDqu9iPUfjPWt6VaoaWYhqB6pFueV1BThbU8DnDWZmxZSC
4370	fee_transfer	1886	3	1	CkpYq1QgAgbL1n2Z434eyM5ptHYRcArjHPgbSHSzmRWhnGLhc4CUu
4371	fee_transfer	1534	19999997	1	CkpZkM9ud55Cz3eKh12v283DgMqTsTPD5s1nxKv7JR3ETm6zWiH1X
4373	fee_transfer	1699	22000000	1	Ckpa3Eh1KFZcUmSjwsPpWGFYU74KTPpNgZG54QURmLdjXQdrWGSDc
4377	fee_transfer	1680	44000000	1	CkpZJkfhjaYSCQi9EswDHWJgWB5A8RDYdYURuY8rH6nxh38KYgKMy
4385	fee_transfer_via_coinbase	289	10000000000	1	CkpZrwKKuzBjHKena2by1DnkVvz63BSW6vNQTxPRviV2roduZykSq
4386	coinbase	1419	720000000000	1	CkpaEdjKCo5v9pqoQJPb79QyUTvBxDf3a4rfczNJLB5CVJCsAUEh4
4392	fee_transfer	1689	14000000	1	CkpaBv422e9Cd4P6jJaj3m29mqQ7xFukEg4ms1ezjf5sA4dMQf7j3
4395	fee_transfer	1633	53000000	1	CkpYZjNyhSiSmQmDJWYMRmY55L5ZHCMVT1k1tTn2gGde5Nkt9Zndo
4399	fee_transfer	1727	54000000	1	CkpZ3qq5Z2ry2Pa9vPoxjhNQViczYjuLMwSTxHcCaddFhPQMVr4C9
4404	fee_transfer	1685	6000000	1	CkpZnEHvJhs7kxuDKPRUBsWQDUXdJGPC3dtKEsF8Uw8GaPgC7pKUz
4405	coinbase	576	720000000000	1	CkpYdq38ALhjFwxGroG3uTradYiDPCiHXT6wVjQsd7NxunQLxs7qA
4423	fee_transfer	1738	12000000	1	CkpaArZew4san4W43TCvpAPgdz8ZsCFmw6K9msXjZFUxfhG9yzuSg
4425	fee_transfer	2112	12000000	1	CkpZdSiRZEEHpqZAcGzuZnCKZs3a4JeT4CryCLqCxVq82HAVthfkQ
4426	fee_transfer	1673	32000000	1	CkpZsDHYdNs2LhGaXPL14qKoUHMfT8LsLKNosQGTd8h7PwrmEH4qN
4432	fee_transfer	1756	11000000	1	CkpZpr7EDo3hDAZAe5xu7VCDTgsunQiPEKy8PZRvcpcRdLtFsQNAy
4138	fee_transfer	1694	3000000	1	CkpZdSSL2QGwCq6aVyCNewE9BZ3udRornzKmk2utuNzRKD1ug16j1
4143	fee_transfer	1474	397000000	1	CkpYn3N8XqQp7oUeuh2B9HqfoZwgxhBRtZjCB8mVqe17D2Kxsv5bY
4144	fee_transfer	1474	25000000	1	CkpZsUpthpNZh7cUtMyUMY4kJanzH13qgsdzgqk6rucbX5g93AE6k
4150	fee_transfer	1690	35000000	1	CkpZFW2zERj2NMAYnMirDvcPecW5pLk94EhRYoKTuGRddmAC2Pd1C
4159	fee_transfer	1476	26000000	1	CkpYqEcSKX3ytZsB6BTa9BXSY4o6q9MkecWd3AFgWzmJUL7wK2kWr
4164	fee_transfer	1549	120000000	1	CkpZJYTMcr6RrmH4mtCpwCqDsDFMJ6bztGPF136HFewHVDtJ5Lodt
4165	fee_transfer	1549	1130000000	1	CkpaHjwCh1jNLcL1qQZSbGs1YD3rnJzBVcCwq9rByRhKVs5LKvfV2
4169	fee_transfer	369	22000000	1	CkpYkQQhP8X2pCEXav9LzKPiZoXF4Qj4hErYUeUYWjET3cUDs48Pt
4180	fee_transfer	1685	24000000	1	CkpZaazCg3YpCjVSUZFEwCTbHeRG4k2dphQ3PahVu3ySek4Z7Cj1A
4183	fee_transfer	171	24000000	1	CkpZ92BFu5NCTuEEt4CUaGT3zD9Y4AEzRV7cQmYNkAmosUcjG7HGh
4185	fee_transfer_via_coinbase	2110	1000000000	1	CkpZVeaAcYq83YffThayznLpUK3rsyfPcppgGzT1cDVhNYwzRAcVY
4186	coinbase	641	720000000000	1	CkpZgzUEd2BK4bX2VxdfKCL4ygoUoRWonvnx9Wf8u4s3gUpmohH5P
4187	fee_transfer	1650	51000000	1	CkpaGua9WkcPsA6SmWpTPN4kbhiLmuc6ADEz4tZT8u9pgJuy4JUXt
4196	fee_transfer	1395	56000000	1	CkpZf7ypxpr89C4NgtfeBiexj7ukj8DihN3D6hWbLvVAbxzqCd6WU
4201	fee_transfer	1395	10000000	1	Ckpa8zdsdMEjsUyStbfuxSCuXg2mDsayiXdBUPcR9hwT7Z1bTTRYT
4204	fee_transfer	43	12000000	1	CkpYvdwohreJzkfmUg5vdgDAsg8VTRuu6bQoncKXM6JLxCX7CpYFy
4205	fee_transfer	1394	13000000	1	CkpYWjFPKjbgrfFmMDSqrXM2iVNcr9ygnye5UkEVrdKR6TVKc64q9
4212	fee_transfer	1717	24000000	1	Ckpa7Le389pmKmN2cbpvQssD8Qxey5SqnmnEuCvxTFxVPq5G31FbV
4214	fee_transfer	1455	19000000	1	CkpZboHrzr3rfbMHJX9BAY9rEL2ZrPFaRxmRBT4R5fPEzG5ko1jEX
4220	fee_transfer	1695	26000000	1	CkpZoxAtFxUkn41JZPAWuLwSFWPZpA1NRNJbypw4JdmLkjLEg6ukA
4222	fee_transfer	1701	46000000	1	CkpZuacTCRDBmRqqTqHhbPDMzomfxW5GD2A63SbPpoMiM5pDwXNH5
4223	fee_transfer	1701	5000000	1	Ckpa3wswUqvRB8pcKkL8XsBcZe23UCCHhFQKJHVLgjoSLLLoHjVGf
4249	fee_transfer	1723	12000000	1	Ckpa5EXPhKKeU66aGFgS5FL35rTj1zLgp8WT4PH8bkgXCoUgy7BB3
4252	fee_transfer	1395	22000000	1	CkpZvMps7jktnN64JEuTe4ifTDC51r4apG2dnqAfHb4w6hj9nYnCN
4255	fee_transfer	1688	24000000	1	CkpYd4bjgCrhQ8qB6pJqTn2EtR3cxzq2EFxf2AaB1wRVajrFjRBru
4258	fee_transfer	1672	48000000	1	CkpZcttVkejHi1XDiQCBuDb3XaSkMo2bjwMbRW83DjhrA4xRoM28P
4262	fee_transfer	1439	12000000	1	CkpYxuJEkcjSD4Tj83Fx8zk8KYjew69SawjtQuzejP6byp6q5FWum
4272	fee_transfer	1684	12000000	1	CkpZHAvPuPgDhD3GTPzHnpWi4tAJmaX2jk8aezrU1PTiwQYNjHqeg
4275	fee_transfer	1395	12000000	1	CkpYSaVmecCsnPynzC5jCyjNQ9Y2Xo86SFisTpiEDa2mKiDoHicd4
4278	fee_transfer	1594	47000000	1	CkpYZPGQSw54QgzmWqTko3N6HNUkJ7gApxLKss1QxtiYkLfF4arYe
4279	fee_transfer	1723	36000000	1	CkpZ4EnHQ45taBogPHKFaX1aYPsE3j6Zhgy8VnniM5ZTTZhYqYxmB
4282	fee_transfer	1719	2000000	1	CkpZLVXfa5Hv2zqTYMMurzDBu2DmeekfWX2GaLxTmdGdZsUNDnJQ3
4285	fee_transfer	1395	2000000	1	CkpZyHFeAoXvtwR8ey9m5QddgFBpL6NV9qTWTvL9uq4Y173GNaunT
4293	coinbase	641	720000000000	1	CkpYR2CMhnHyybmdDr1Mxt68tk4nZcEo53W1teYwvW7P28EWVAe7h
4298	fee_transfer	1394	71000000	1	CkpZ7ocuZi893at7YAVaADHdtWq4XtbQT5pB8PxJmYhUPeruUh1aE
4299	fee_transfer	1394	213000000	1	CkpZksDR4pZ2NyyG6PgXwsJs95Zzky6NnymDDzX5q87G55zvkxgRk
4311	fee_transfer	1675	330000000	1	CkpZxjycNN6TaT1sUNU1RHmgta2TXjg5gGE974TQxwuzpMJ1ipg4U
4317	fee_transfer	1729	72000000	1	CkpYyK9mT1XZh9JKwEf9vHZt7cMDHRLTMjww1EmWbJHMxwdbhC2jU
4324	fee_transfer	1739	51000000	1	CkpYyamgVJdmh8dJXrHgbBnKbcy82yQS1eVnAGbuQnA5bmG8fgNZ3
4332	fee_transfer	2106	11000000	1	CkpYoBBxKTZRf1jQemaKzfrzydk6urE5wjiwwEyPpqxPw9xupBLFo
4334	fee_transfer	1634	33000000	1	CkpYTeVZdnvft8kQVAn7WndpxhqFBGQqqSTwzAJbmhvQDt35WT4qD
4337	fee_transfer	1455	450000000	1	CkpZPY3jsAKCaf415Ea4qjfSoGQPFJrSUoJ2W2pe1sWX1pcBreTdB
4338	coinbase	1455	720000000000	1	CkpaGTipNcEuAGu7BLiDFkfFCt4cSDni1D16pSdVmLNm7LUptw2eW
4343	fee_transfer	554	11000000	1	Ckpa3JAPFxqgWyehA5YrNWLLFBvJv6NaEamqrKvmqp8iEUPstM6gZ
4360	fee_transfer	2087	11000000	1	CkpZjgnWpxCibsAZqvJSi8ami4eMSh1gDXqw4iCS4git6SivLexcS
4363	fee_transfer	1759	11000000	1	CkpZ7XZPBRQFFHzh5Vx9maS5ZCQ1xy44hTcJ8mopzsRuN8fiu1BKV
4372	fee_transfer	1534	54000000	1	CkpZQp6ZTjMYd8MfaNorNmXafUKP6K3sXVJHzNnLrJqwHyEFSzM9E
4384	fee_transfer	1419	14000000	1	CkpYQq1KYdStzPLgBGXhqEuVdyx1EnKbY1q5FAJnAioaVKXE6Dhad
4387	fee_transfer	1680	14000000	1	CkpZpBXPykf4ojmMthiuTRvTaF1P4E4UGxmkse6gc9YdpyX9E78XE
4391	fee_transfer	1571	14000000	1	CkpYTQUj3FCmb9jvT2H61PSwPqwv9EEu21Y7YmdXSBSjguphDj8tq
4398	fee_transfer	1422	54000000	1	CkpYgeXiWdgavxJZMw9Ksc1EM5bdLkx2ioZPMw1Sz3jNFstEqBXJs
4402	fee_transfer	1688	66000000	1	CkpZdAS3S31JUS3tb7tQN4tLNmxbmdijXqxLhVvnfduf3TZeVjtdF
4409	fee_transfer	1455	13000000	1	CkpYrayNU3BdUpZs5rkfMpCCxKSe7Z4oFgQm5P9aeR9kxLbmCbn8J
4412	fee_transfer	1678	23000000	1	CkpYXRXzRQ9Ukr1J5S7kCWy292j3AX5drLCp4xqvkPPiBJ2qD2wV7
4418	fee_transfer	1522	11000000	1	CkpZ6NGxxp6oPsi2fkjitecRzXy27LSfg4qUiJnCqa4RHtDKZyhDj
4420	fee_transfer	1764	23000000	1	CkpZXYTmd6shfvQv6wAd2R9PQCdbHEVKUHtkCzSBugYGWpbRPiaim
4421	fee_transfer	1718	23000000	1	CkpYSz5dV46BKr1Kt8oUppGPMfx7r1VqDpdK7LTUGKhLwp4yV9hYk
4424	fee_transfer	2112	10000000	1	CkpYS4gBArgFyb24uxWkAXv7uqJj8dUhkyEVuy7u6xRm6idHR1kmr
4428	fee_transfer	1740	1270000000	1	CkpZrzLGz9U3gNq1qDj4SFePbxL9aX9iom3t8ZbvbQuJfQmcnrXPo
4440	fee_transfer	1395	21000000	1	CkpZn5HmWMjMfnUz4CzPnbC3xhseSjxBMmhmFYpbAikNzPBedBuyS
4446	fee_transfer	2087	31000000	1	CkpZDEc8tEhj8u1igwta6eyTKtCXCm8CwGhpJ5p8N1mRcwex9V4iY
4448	fee_transfer	1756	32000000	1	CkpaEotErZCbbwGgay2wsog5fwLtKhBXKU9ndAL4Quqooo3WpEojy
4449	fee_transfer	1467	21000000	1	Ckpa9jnPnoFbSrbobbFyjrJiq4Uw5c3y4yKbVJt6hZj6kcyphfmvA
4451	coinbase	1526	720000000000	1	CkpZR62xfhrenSvEZQrz6MyyHYkRuLKnfMY2jYH7E4TcJ3NZrsjBZ
4452	fee_transfer	1463	1000000	1	CkpZ3RoP4LdZjsPR5TtK5p6dkAnazNg2oepuGGbQ7S2kPPs3qpwEy
4454	fee_transfer	1759	42000000	1	CkpZ4Y7fKoW8JJsLW9UEoGB7MMRc4VNiTEHvVnjdg98To8a1aSCjF
4461	fee_transfer	526	23000000	1	CkpZyVvjJXaC5RdJnSw6CmJKijtgWkmYGW7fHYoMH7Zr9bF8Y8rHz
4462	fee_transfer	526	1000000	1	CkpZwjcNGpyCPQXCGabryLeGVnQTG8n5NtXxjyEZLgJCFa9R4qUX4
4469	fee_transfer	1602	100000000	1	CkpYnfxVh13rtrjv7fEJNbDpT22QhFwq2tEUPVYcTeBQQ7VXUVPPR
4473	fee_transfer	1271	51000000	1	CkpZabx2tzFm15FnxSVLxz72MhE15K8d22teiw1ubqGhT2oVyyZMR
4139	fee_transfer	1673	27000000	1	CkpYZoEhhERRobpHXbJKBYeEAC5XLwVAiG55r5iTCgUHnyRauFx48
4140	fee_transfer	686	40990000	1	CkpZCfBB5MjbegdfLt2hNPNsfYxHUfwoLKWqSLgSCDdgfRk6EMJiY
4142	fee_transfer	526	39000000	1	CkpZ2bWPu86Rb5LqkoLvYiMbkMhDXefb8wMFHLeu6P5sfX54FfPcv
4145	fee_transfer	1749	25000000	1	CkpaCoGHL4gDj8yx2svbGVYEyv2psTYCTRGZFiZJ4CguNPcAMztTX
4149	fee_transfer	1599	12000000	1	Ckpa7LPUN4NXsw7Dm6Myn4RcoKZ79QHDoS4qEacm831UWwKdiR8Qb
4151	fee_transfer	1573	26000000	1	Ckpa5AyU8xDqmb1x5kyXmH4jUhQgQx9t6LWgFKXn3f9tDmajEk229
4152	fee_transfer	1560	13000000	1	CkpYe4LdNwCPyq7urxpaXUtK2WthSkrKuDAqV2UZZGRyzQ7zPz9Rq
4156	fee_transfer	369	741000000	1	CkpZ8r5pcpotvD8ku1iyQeQrgH8N6XRyLpNuAnixPDnzb6p9SatGx
4157	fee_transfer	369	510000000	1	CkpaDeFWn7RB1TsQSERH5cqYoqA7uEr1GcMgKCbk2jrmrddPK7yi2
4158	fee_transfer	1540	25000000	1	CkpZuM2sJjkEqXbiegMHexPoXh5hshvMuZXdeMViiuc5t9Z7xUnL3
4163	fee_transfer	341	3000000	1	CkpZd6hQfoAbHXJWhuhjiPJJgbJbLcBFpYyt9ZvJmkfs7TBGpNeWJ
4167	fee_transfer	369	614000000	1	CkpZB24KmwY5brw53qJbwmyh28h6Xtju13LKjaZE9cnGeATpe5fE1
4168	fee_transfer	369	78000000	1	CkpZFQmVSaXwvxYrYY8UTgEzWPuQTcSjBEJJ9weGjArEbiYYmcxbr
4170	fee_transfer	1701	12000000	1	Ckpa6K7vQy1tYUQPjnuxdc4bCaJTT2hTs4C2FjxHPwov5B3L1wLC4
4172	coinbase	1395	720000000000	1	CkpaAaauPgRtoogqNqesZc6oPoPWKE4N89oqR9ALsmRiAVLYXXvTB
4175	fee_transfer	641	384000000	1	CkpYw45RZnRNP7rMRENKZUzfn5Dc43m8TdwKDCVx8htrGEpbn2UcG
4176	fee_transfer	641	279000000	1	CkpYb3PnVnTF8nGaz3Yu3ryw1ZEtoHs1rBrxwwgnVJLQNG1Bx8MDg
4177	fee_transfer	1919	1000000	1	Ckpa8TPtxUvofZfNjwxiXsGEZcKh64G62KXHmjVjMqD7rPpLmputE
4189	fee_transfer	1593	12000000	1	CkpZm822Eq8vDwWPUmB7sUjzjZNVEgkx4nzuErvohqUDwTwLGFGN1
4190	fee_transfer	162	12000000	1	CkpYjGWaVMR4Jfh1T8Eo52Nm2iyj1y3WCioPq8KpLG6E8YBK1gorq
4191	fee_transfer	1395	11000000	1	CkpZteXzfKsyax5XZ4yFNQWSCJDS1ucPpbURcpd9TpDEFKZ2BJGim
4194	fee_transfer_via_coinbase	2111	2000000000	1	CkpZ9Hzvyka4zkRgf5fMMvBWL4EtxoFpMNkYJ4e4YdsxCs3waGZjZ
4195	coinbase	1419	720000000000	1	CkpZX17Jtqnao6R671RAs9KXfAQfVB3pV89V9VXGcS1dAn1UL4snw
4202	fee_transfer	1394	14000000	1	CkpZr5SuhGYk819wrJEd3sU5QfEwVGLDhBQgaVZQurCtD2KxSrC2n
4208	fee_transfer	1687	113000000	1	CkpZ5TZgau3VCmt2hcppvu73pGreuwvAuiGZZf8hPhpMwrKKBNP4v
4209	fee_transfer	1687	112000000	1	CkpZ3SfeBZ9N46icYWyW3xUctp16JQkrsrd9F4jDcU3dYGwPicQA1
4211	fee_transfer	1394	12000000	1	CkpYYUFiWZ6DqrCYgTaR3y8JLBrsAWdzAkw3XZ6MJ6yybRKxpDHc1
4213	fee_transfer	1447	13000000	1	CkpYRB55hkunzPhR5dvN3LuHfP7Z9XfGKhp71T93JDLJthcQmy2PC
4215	fee_transfer	1711	3000000	1	Ckpa3vjZHcWLha8uLsHjwBWikFtFm1sVCzXUeo5TahbU9U6DmRMCa
4218	fee_transfer	1394	26000000	1	CkpZCyaN4naSsCgr59Ny46nKc4FRbioqeWRFDpBR1Wkv13WBsVVra
4227	fee_transfer	1623	53000000	1	CkpZfVmGpFCEadKs6LmLoPg5vydNFjQeymg12uWq3NuBFJK2bDYQd
4228	fee_transfer	1727	52000000	1	CkpZE7JUXwm52wVZBeyQbokZRGUgJFPSjQdxrPZNBGeCsH517brwt
4233	coinbase	2112	720000000000	1	CkpYvYUuAiWK7DroU5GVVKc7stuyW4JUzJn4nDoHRjXCAVKJjCS2b
4234	fee_transfer	2112	13000000	1	CkpYmhihreGA9TWVPCYDfW7He7dSkcsM4YPMzRi8MCbKKzBa7i4T7
4239	fee_transfer	1439	55000000	1	CkpZVP5KG87Y5tgnEzQGsGkvseR5HyhYRKLHtqTZYRZptPwTikcux
4243	coinbase	1622	720000000000	1	CkpYoEUmnZS6zZrg1soVR2oxQz8veiNgwNCHDuEdsT95ZSHW8DUkK
4250	fee_transfer	1394	24000000	1	CkpYoeqAepnNCdso2GSqMy2BkyZxqGh5ywQFrcdN67DFaUytSn2Hw
4251	fee_transfer	1594	22000000	1	CkpYr7vKYmQxeT5Yz7jpjh4cKgu5RfTGY2fUsXF66d3F9GsKWDFPD
4254	fee_transfer	1522	12000000	1	Ckpa68jKG833yds4QXKMiyhXv9ZDFab36FeLM7sXHUnxHdDZRWvwa
4266	fee_transfer	1506	33000000	1	CkpYzDMu4g6mrdYahWbr5UH9eLh2FKf95t2MecBEfwtGbaQHEGn9R
4269	fee_transfer	1646	11000000	1	CkpYjYepShcbhMk6y9yJhD4MkC2V7bHH6uxpG3yZf18UtLytTpKs9
4271	fee_transfer	69	12000000	1	CkpYub1zSJm6aYUBDLc7FBucZRRXeRkzBDuga925UMxJs1kmxb9zR
4274	fee_transfer	506	12000000	1	CkpZeTVBZGc3KUGdqnqc2x9zQE7b3BUVMyzwkSh3RiR27fRUYmSdK
4276	fee_transfer	1764	101000000	1	CkpZsFo5c4XRb8K2bqRwH6KarUcKPwczYnk72WVa3R3xBELE5vmvC
4277	fee_transfer	1458	47000000	1	CkpZNPddf6eM5Wt3bN1XSQA4hYnh68dR4wUV9Gr4PARnaiGWy1jTK
4288	fee_transfer	1691	23000000	1	CkpZDQ7U92LFEMEVwR5sDtz2VKUT6edg59JxuFUStse88qHFRurW7
4289	fee_transfer_via_coinbase	1420	9900000	1	CkpYjCFnDzidN1MuxPXLcsXSpNuePPTJPke7MEv7rwm6GAKi1oLpS
4290	coinbase	171	720000000000	1	CkpZiGVGyNejsSrJW9avpTVdwsRndosf95QLj3DNX8xk48ZJNZy47
4291	fee_transfer	171	2100000	1	CkpYeA86FcTLQPgzUYm7hiT9mSQtZc263S77xXjq78EGpW5qxuPtL
4292	fee_transfer	1420	9900000	1	CkpYjCFnDzidN1MuxPXLcsXSpNuePPTJPke7MEv7rwm6GAKi1oLpS
4294	fee_transfer	1709	12000000	1	CkpZCzLUKUF45Px9sLMQr2SUcqDjdE2Z5FKyuNEzkAzoZeS87pqxN
4304	fee_transfer	1679	213000000	1	CkpZ61ggfqUAXS6j2MmM1C1MQuRLDfkm58Psr6iYCYvo6fwpTiw8P
4307	fee_transfer	1796	2	1	Ckpa7x7ovXvm4qR9Tmb48TUZpvdJyEmdj2Snq8VWWUWPmLrLYJbgx
4308	fee_transfer	1654	112999798	1	CkpYTQKfpNvbha9JNpXotU3PCV1UrTjKsnmL113q4bcA6NnYCoDjy
4309	fee_transfer	1596	100000000	1	CkpZrJkM4wK1jUygoWd6e7LRu4MZ3UWq8mgGehaabb4UYVe2tpCkB
4310	fee_transfer	167	200	1	CkpYrhUrnZWAkVFurYmUMwceYhEyc2X95fbhJp1RjgXSd5cEKEetW
4314	fee_transfer	576	300000000	1	CkpZPBuajVbf9Qic6aTnPNtCiZnH7ecK9MUHoMicp3RhSKJAgG7Ay
4315	fee_transfer_via_coinbase	1996	250000000	1	CkpYzLDqHfBWdxBzM3sK3AS9fc9R4M6eba82hZNzQ9j1XGSWBaoUQ
4316	coinbase	576	720000000000	1	CkpYtHLa6WiPcP3br4eNPgx9txKCdBndUAAPnKTsPBbbcF5pGDXBT
4320	fee_transfer	1727	61000000	1	CkpYeKrY9j5jAhj42SNi3WrmGTwruRvgTRQRjkSXMCKmc4gT6ibsb
4322	coinbase	1535	720000000000	1	CkpaCX7PWzQyHkXa2Z6ku3kpoa6Y6y78S8SSyqBpy8aC9krKQEJdL
4323	fee_transfer	1535	51000000	1	CkpZS7BnCMk8DFNLuQBi7dznrdipgW28xgXWo3wWMRULWokHKqrkj
4325	fee_transfer	1980	11000000	1	CkpZ8dBme3aQMRbJfchYXHT9HBTpQBv8LqNasBhfrhgicJdLduyn4
4326	fee_transfer	58	22000000	1	CkpZtwFfSgkkNaY1yk1pveLycnPhiLoxVqvdxGYw1PS5kMBRcj4Km
4327	fee_transfer	1764	680000000	1	Ckpa6hT8x76pWLNWCHrLu69gQodzZYP12mLENRtCcFGCZvFf18teY
4328	fee_transfer_via_coinbase	1791	1000000	1	CkpZEy9EshhqB34H8skRCSDEA8h8rXRR36KSF3Aw3njWsekJjU4QL
4329	coinbase	1764	720000000000	1	CkpZfeDS4KHtxjnW9ZwRfSwviZQ5UDcJUBqcHNYdw1X916NLYaftY
4331	fee_transfer	1394	22000000	1	CkpaJVYQGkTziQibaVxAbVGbDZp3vjgG34LrTmPVoXG2P6quJkNYT
4340	fee_transfer	1547	55000000	1	CkpZymMaqAtP7ggH8XjcsBXCxWoaaUo6TkGhHqJ8ZspGiL8DW7bVR
4345	fee_transfer	1560	22000000	1	CkpZiJ9m4pxoSRMpL7T3T8tvEJr3TvdQ24tvpwL6A3CNsoG986kWn
4141	fee_transfer	1716	39000000	1	CkpYQ46TmXMb6S751auHWgTWkrW7DmDy6mUNxbuCCPx8GuAEuebTm
4146	fee_transfer	1686	25000000	1	CkpZGuafJScb6dugYRoGtYXcVmVVpVGetZAohW91p6YBSo8Xn2g8v
4153	fee_transfer	1719	16000000	1	Ckpa1RPH9h7uFSpzAec7ZBq9Ym5KQEiLLuvRvdTNGHJTQLRmkg9yb
4161	fee_transfer	1549	13000000	1	Ckpa1bVFogaSDyXUNkMW1Y2Xoo6gBqw7xvYMt3aJTU1gzxUv7Sxwx
4166	fee_transfer	341	13000000	1	CkpZktqs4xonuif1pazCZ63YnmzNgkD7WUhd3LFtR7mRGySRYC2P6
4173	fee_transfer	641	1160000000	1	CkpaGDQz8kbDvbEe6T25ZnXZUq3DKTNiQDbUHvGxxmManUq1ysnCY
4174	fee_transfer	641	90000000	1	CkpZrX9UaJka1faFVdtQmpE7MxwSiNpLmssTp7yQjsijNWB8YQcCX
4178	coinbase	1394	1440000000000	1	CkpZ5jFtkyuZ4oMnCnDeHMnF26YccAjkqahBMPEv2UUCXqEjy7YvT
4179	fee_transfer	1394	40000000	1	CkpZBzhQtS4Ny8fwKj9289kteaz3wNhjetTKLFzZeNZZKoCJ5oPij
4181	fee_transfer	1672	12000000	1	CkpYSqM8CHWoX5atbAFjTHo7gZYqPmsGxCvGUFjzRcddFKAniSkSp
4188	fee_transfer	1673	59000000	1	CkpZvd2gPM4ja857BnAJ7p9AUpqh9PbjFiTmZML5t68RSJKgvnF5u
4193	fee_transfer	1506	2000000	1	CkpZzZ9V4eChaEYmFY8rmJYReeLDqokeaaddoN9yY4R3jquqRWQAx
4197	fee_transfer	1395	24000000	1	CkpaGE92c27eqU1ZxLuNR4ggEGTk2wgiBsBJGZ1ZyyP7t6yWYsrhr
4199	fee_transfer	1708	19000000	1	Ckpa3hzsvWHnJpLHF8WVvuc2Y8qv7pxftJcEyv8hrM87q9tJXiUUV
4203	fee_transfer	1687	14000000	1	CkpZre89xv1hj4N5yfUKuhepZR8hnHgMUDiLk5vR5UjKLsMKq1bHP
4207	fee_transfer	1692	29000000	1	CkpYTfcUH34qSgHTb6pEYEZDvyu1p18fSDknaPaHDS1kYweeT8U43
4219	fee_transfer	1395	13000000	1	CkpZqwkpkeccxv1b5Pz34jNtggNk4v76hfHmenEvHDCLL6S2Ufcoz
4224	fee_transfer	641	100000000	1	CkpYfzu1tDhvoVJKaPj7JdFLVGoyNQZHyZ557va8FkcdX9wpEDPAY
4229	fee_transfer	1549	26000000	1	CkpZj6HadWLpYjrZuTyHpzekuwPUjztt3X8qDVQbow5oJA7E75uSd
4231	fee_transfer	1549	210000000	1	CkpYdHXebvnBsCU6SQRooRSxDBetHhyEKKV1CjZFQym76TeWW6nzQ
4232	fee_transfer	1549	330000000	1	CkpZwGHj4EpZT83M8FCY7N9wntBi3kuWMBKd1ogewwwDSTzV8RjiX
4235	fee_transfer	1764	102000000	1	Ckpa3htqv5BRyoiGe9tYvTaAGPpzaPWFe7MwUTsmE4Jz5nb5HmdNE
4237	fee_transfer	1394	35000000	1	CkpYmwHvhVeReK8V6QEDgbM4vMY8xiqyTX7d1fT1h1JEjRm9mn1RJ
4240	fee_transfer	1637	23000000	1	CkpZyXepxREpsuu4G2t7B2KMrxMraskMDtni2DgyGYsgJX8QU27NE
4241	fee_transfer_via_coinbase	2004	9	1	CkpYy9JUGPrcVPQWR29mDenGYzfMXXnZHpc1HuNqQ7TD5wTzgKgbp
4242	coinbase	1637	720000000000	1	CkpYzRDAJ3QfneRNeLc2WvBADUdtXvqCnBtBQGMYfA5rCP6HW6XxT
4246	fee_transfer	2106	24000000	1	CkpZ9ZK5guxpmTxHMweFGGHowHRUo4cpKKfgu7FUo6ekMZBCevcix
4248	fee_transfer	606	24000000	1	CkpaFK35sF3xWjKebzAGu3isfwtLjyQoUfibNRGaDEqkm7diHB6gS
4253	fee_transfer	1693	24000000	1	CkpYojNKVvK2nC7ehNAC5URebVWiPPQ6kXm1PqdBxsdre94ss1KUp
4256	fee_transfer	1708	24000000	1	CkpZy6JNSGsYsBDqRpxDiFwxoE3J16ESkWmfmgE3DK2itporPq1i6
4259	fee_transfer	1690	48000000	1	CkpaLUkLY9hs2rLDtpX5XYjfbn9rTS1jr4RJRLdS9ivtAy6vH3f7c
4260	fee_transfer	1546	136000000	1	CkpYW3MTJ34JMLE4cvpXtrkg6nZjvwoKi3M1sYqXFQxzvpRPNg57c
4263	fee_transfer	1549	12000000	1	CkpZCQiKW6zqz4yqdMPNkBNscASpNVXsCNV5Mzdhpwp5k358CXdvu
4264	fee_transfer	1613	340000000	1	CkpYfG9CGXgyLDQkKDT9yKEnEj94jX9KRvb1QGEuWpKTD8RAa9rnN
4265	fee_transfer	1613	523000000	1	CkpYhk3zwVwd5CqqwSyB9ob7XUg5zveQbeP7ggaMP8inWQitC1oRA
4267	fee_transfer	1588	33000000	1	CkpYwf3MLJ8NUoD8xZosLBsxaWwqXub3mJnt9Bckp6VhGba2DxSZy
4273	fee_transfer	497	12000000	1	CkpZpSr3BjPNFJNPEjmTJxrjRE67oADrAJtMuqM1Xyj21GYPanv1J
4280	fee_transfer	1439	36000000	1	CkpaJijP1PCTUj7qeymAX7dEektJaFZmt77tgbbCqDHB1UkPX9jYp
4283	fee_transfer	1601	810000000	1	CkpYTE56ZioUzcWBBhp3mzPLH6iCsetWB7pBDRsMEwT7USj44MdAQ
4284	fee_transfer	1601	620000000	1	CkpZNQAAgPts6tXxL7AuWh8VYJACbiae6WKXG5dCjXnevVN7vacWp
4286	fee_transfer	1601	261000000	1	CkpZvw767rVvWLttc7DbbcsXSgQFUoxXq9Z1mAisULPrFRqJiAoRb
4287	fee_transfer	1601	62000000	1	CkpYj4rVZFnocDcJgvxDtUgMj1fJXnmUJpGQAk3XL7WAKidyCFarh
4295	fee_transfer	1705	23000000	1	CkpZLTH23J6GP6EyHDJjK6WGN89zSMjGWMVYmAjDjYHR6bBUsnfyx
4300	fee_transfer	606	72000000	1	CkpYrU8bDtcuCzDz4ivfFi2seevmCbevNoxF5xGygG2DQ1xNWCE5g
4302	fee_transfer	1426	213000000	1	Ckpa8RVSmRrdHxLXTxudV6rq2k4PNU3NnZcGcG6REW7ZKMUrWjfY1
4305	fee_transfer	1451	213000000	1	CkpZ9RxeHfpGmbim3Lg89yEZekgxq99KtbR8W1tW7MtVnA44vKSc9
4306	fee_transfer	2039	213000000	1	CkpZWZGYMcmFHU6v6jdtiiej6hjqdg6MZdvLJyDAqfNViYKKYfC9J
4312	fee_transfer	1654	213000000	1	CkpZYJnHXaBcYZc5bir7zSWfBomdirEDhFmf8YXWcX7n2NKpSitbV
4348	fee_transfer_via_coinbase	1596	100000000	1	CkpZrJkM4wK1jUygoWd6e7LRu4MZ3UWq8mgGehaabb4UYVe2tpCkB
4349	coinbase	1455	720000000000	1	CkpaGCYjs59yJUHMxgxEYUVKuAbPg52fp65KvNsYtF3pSvotT1j3j
4350	fee_transfer	1675	44000000	1	CkpZWTk1jaGA99np4iDSPRdQ4fyfDkbC8cqU7qKYVPjzkgdf8f1VE
4351	fee_transfer	1534	22000000	1	Ckpa9hyjQHec7vFmUNX3zu9KF3VcMPDbcjmJkGiEYzLFTzhAG5WDj
4356	fee_transfer	1700	22000000	1	CkpYzjFEn9M8gYRyjrHmjjMB3Fx3WUnLWUaubTc2iMvJjoCzBa7ZG
4359	fee_transfer	2086	11000000	1	CkpaBmuT6V9yBSWPfcYxcreCfZXEBovyaB9XHWceJRLGdwkJAgRK1
4361	fee_transfer	1402	33000000	1	CkpZgMA2SFhcyE8Je5CpFMiz1Vah9CSdyqrA5yeFtRFQ682kkv4CN
4374	fee_transfer	2086	22000000	1	CkpaDfvSVsdoUo5GYHVTxXYSab9N7Y5WGQKgx71RwapgkGC9ZNfxC
4376	fee_transfer	1602	94000000	1	CkpYRLLiaTsYa2yq2pTKDaTL5QVoqG7vfatXDupnK6B7gKS7fHeje
4378	fee_transfer	1756	44000000	1	CkpYaE7mSAwsLoiWBBDuz22T94z4JY8PBYMMoSCkEWHxjRsFjNdEh
4393	fee_transfer	1467	53000000	1	CkpZDsAVqmiWzk3yACtrJJ27LfhREXxUcK4uxARiFF4f8hfAAN3K9
4396	fee_transfer	1394	25000000	1	CkpYqMf6ywFGFsKqUPsjykTdqH3KJtnjunmFvAeZzUTQizGkCFv5C
4397	fee_transfer	1688	54000000	1	CkpZqYuNogZNmpuuatmzDHjkWS4ShCh17mcz29qizNdEt4CDt1Hyz
4411	fee_transfer	1394	68000000	1	CkpZHUnqZbDNYNQRiThgJ3LcigKxStwrB52Sj5Hcbr4sKE8MavFN6
4413	fee_transfer	1711	23000000	1	CkpYbC8Acou5CGjPsJWdewEhh6DbEVqgZV8pd2ryrfEmnxdPfX6we
4415	fee_transfer	1395	23000000	1	Ckpa7j6mjVgTBcYR3XGsanLwWFn7CJFbxGsXLWLy9ae3PUZHEu9m7
4417	fee_transfer	1611	58000000	1	CkpZcADCG6BzSwNtTC32ucJNWTBqA4KXtAzT6VFPt6pjL9AKEpAT8
4422	fee_transfer	1547	23000000	1	CkpYqkmAs6QgXmqqLv29ZpN5cSSVptENiqtsG9Psio59yQ7wmd2WT
4427	fee_transfer	1440	32000000	1	CkpZLBuyKRPZ4XngTTSvWHskEr11i1irFNmc9Yj3vQmSmKrgMMcnt
4429	fee_transfer	1394	23000000	1	CkpZgQ5qt1ketLNLmNQPM8BgUt3qaFDs54vp9tvDNHCLHjtzSNBba
4433	fee_transfer	1685	46000000	1	CkpYvGu6a3KWGr2wTRXzETmQBLkd5Qn92ZihS8RHcAeJaDZvtQbrh
4438	fee_transfer	2087	10000000	1	CkpaKbxbgFEX1m3qvb5oZ6NTNSNbZZQ2qjvUUCRTvkNruxvtmCm35
4347	fee_transfer	1395	44000000	1	CkpYZZJakGSBaSLCch8kdev47V6RZ6SHoLocuVu4uQipvuZjSU76R
4353	fee_transfer	1702	22000000	1	CkpZeVbPW7cKxJTzR8Z4L4pR9HjXWsAQ6syk2fqgsmfJvCD2jaxTN
4358	fee_transfer	1394	33000000	1	CkpZdKs73WjCQvTj5Hsz2TddRBSVME66JrUEAuup8JQwmUfccqaVr
4362	fee_transfer	641	33000000	1	CkpYejerwCfVdGFpJvFoGFYRaF5eNtPs467CKB6yzUXgUfaNcNhL5
4364	fee_transfer	1714	22000000	1	CkpZHgwi9MtBd5FGBhPc257HNweBEEAy1oZNMGkytEGgoG2R4cqpf
4366	fee_transfer_via_coinbase	471	100000000	1	CkpYVjZbHCRV2gCzgkeiELp1YUj4eLqfrMSRACwgWESa746jN3rAt
4367	coinbase	1455	720000000000	1	Ckpa52R3SeY4NrEMnsee4bvmVCPDy5oYMWmCDkszYquRUq6wXgxUt
4375	fee_transfer	2087	22000000	1	CkpZ55cnnfCMLf1D2x48J9VCtBmr2ky8PnXpo9FpFfL8dutW2NX9J
4379	fee_transfer	1637	44000000	1	CkpZnRQxKKqNqRAQqAjdKGwHkw3xwBoqY1AQGk9cKivGD8dpvSe9B
4380	fee_transfer	1508	760000000	1	CkpYb22rJdcDK55a4ueb3HtA3hPJTMZmc7qrC2JkYaj5UCBAi7BLU
4381	fee_transfer	2067	5180000	1	CkpaC6KqGHq69msgyK4LcdmXwpGQhVYXbXL1UnykvtSPkcVxtCrKq
4382	fee_transfer	1680	1820007	1	CkpZqY2mxi5RX7XN5HhmCGXpobagRJxtY6tRW3MCSUe8AftygTbBS
4383	fee_transfer	1527	6999993	1	CkpZWnGXYSYSmqv7732SpYqzYnyLtX4FXKdPQwAG1UuCDoXx1UpTg
4388	coinbase	1689	720000000000	1	CkpZDoegzqpR4fHDTBXqaoLGu3F3F59bwGfx1EuJB4NzsW1F1qUEZ
4389	fee_transfer	2067	2590000	1	CkpYpzL7geNswz6Q7N1Z95sSTbWCJQuiaWCwrsA1d2d3p6KSgPRNr
4390	fee_transfer	1689	6410002	1	CkpYnoy2wYsygczeuJaR4EEob5VGVaDuGDt8FpBicSaSWUzRTXyPd
4394	fee_transfer	1688	53000000	1	CkpYcT6xvCMjuQ611jW3uighXLQPnF7Fx6tD7KUagaPHgWzEksvGz
4400	fee_transfer	1695	14000000	1	CkpZmv8kSTfixvNjN5BmGhqtmodf9y6LbeWkHxLggrDzY3uB5iexA
4401	fee_transfer	1455	12000000	1	CkpYjFJz2BFfqSE2bSXq8ZqNgsBAfHmM3ACSoLNaQau1aVPeEt5aS
4403	fee_transfer	606	6000000	1	CkpZRvsNhsF2ZG2yX2Ptjf1mdmq8LSc4kHUDtK7z8xL4UfCBeW9v9
4406	fee_transfer	1758	900000	1	CkpZD1wBf5kearHjrRjoWzM84WUYfGG1erXnQz5GwykFLZytWWjd4
4407	fee_transfer	576	2100000	1	CkpYb6LCD19Qa1YHKoiJvPz8RXyoWbLaPTdKJEPD9Ss8rA6oear2K
4408	fee_transfer	416	10000000	1	Ckpa3ASG7G8K8S9dqrAv377jF9nNiahkJupx2w4Lza3TryKSaqCLD
4410	fee_transfer	1458	12000000	1	CkpZhNBhXLaNKqKrp8B3BKFFtRDi1ieM4YDeMmvVsamVeGUf2EgaT
4414	fee_transfer	576	23000000	1	Ckpa8qDWtk5uccPQkHCCR78FzYYSijShHg1fybL1T6cBDTjoReQpB
4416	fee_transfer	526	11000000	1	CkpZyLoDdMpWV3i6kxUjSsexnhr2wGEsqt3bKBBQYJsztDw1jszhr
4419	fee_transfer	1610	23000000	1	CkpZmKwAGQizECZP7XvPGgVhDdxCa3ZPVKPfU2SNESWkvTje2jEu7
4430	fee_transfer	1700	23000000	1	CkpYgmezzWuxuEia9o9jxzjT1w3exyuEMcsrRN5a6MELujVMKWMXQ
4431	fee_transfer	1980	12000000	1	CkpZVr7QzTWvktZH777VHJ1LHTN96wgv7Lstzzbhq2gMygvzdx4ha
4434	fee_transfer	1633	46000000	1	CkpZY8ESsuSSwbhPZaDotx2jogjqd5dGhJr9gEtrhYBHcpq27Jbih
4435	fee_transfer	1593	215000000	1	CkpZa55NoNJBnJBiE2q2797M97h3PFgvfMhceHf4KgF6EwEyxKFac
4436	fee_transfer	2106	23000000	1	CkpYeH2TbpmSj8BwkzasGG3SvWbMaB9TBP2wZxTgCfnX9WwmPcR6V
4443	fee_transfer	2086	31000000	1	CkpYk13VUV5hZiaex6yUbTQrALSiLyCBAasGbvgLSPDBTxFoHBYtU
4447	fee_transfer	1715	32000000	1	CkpZJnzMMyDYSsYDkwemnKVgkbsc8BCTgzqmS5CjzwvBTgBXaNzQz
4460	fee_transfer	1394	1000000	1	CkpYkV28pw9TGEtrf7WKJxVfxFnEa6v79nSyKmYcYtay9MjPbo7FQ
4463	fee_transfer	1474	23000000	1	CkpZ7LVxEcToWJWhVazmp1Di2DaUSFN8iCWodM6D5sv9azReZxS25
4468	fee_transfer	1394	112000000	1	CkpZ7CT8Ysz4FcGWDtcDdVtE8GcVYZwCyxpTqL4BfLPAiBGGxUZsT
4470	fee_transfer	1729	13000000	1	CkpaFq7u3xxambG6hYN6sDM24DVKWMyXxoPK9opwcMmiex3XKQmLk
4472	fee_transfer	1613	51000000	1	CkpYUoASPfCZWpVTAuh2x8pjGWmvMCJAXLXiudgz4hko1Bp3rRZsK
4482	fee_transfer	1699	23000000	1	CkpZc4WGqDrmvLj6dGfAzWXyAvAUtSjzykJq2i9QEdn5pVTNZ7FHL
4484	fee_transfer	1692	23000000	1	Ckpa4zPo6ZU7h1TuRzs7VC7cma3Rq8w3cAknsPN29bMPheSN9gpWk
4494	fee_transfer	1395	46000000	1	CkpYvthodZDSDQg4G1TBayjepkQHP8cNmoyUdHoPzu252rgDwBAgP
4496	fee_transfer	1719	12000000	1	CkpZT7Ct9nx2YAHo4S3aWQF6G6KxinjURCyAqZxSob5bvHmZ6MpNQ
4502	fee_transfer	1509	35000000	1	CkpZmhWiiDBtQq17rmfUnWhAM7zx8GXeNSd63ibCs3qjHkizoHAni
4504	fee_transfer	1637	34000000	1	CkpZYgyicLvFxYsfvXAKyHL1HcuhBhevj8qtSQMLbqXS2AoANo8aD
4509	fee_transfer	1394	34000000	1	CkpZvygxVYeVxPFhovjSSBiDuwRqr9qPEZtN6jGZFUJw7JdBz3iFm
4515	fee_transfer	532	12000000	1	CkpZ3qTw1NcCzsVb2pofixkrpGW2SiMWpCTdwqnnbCq5XHwKDvqX4
4516	fee_transfer	1724	23000000	1	CkpZNTTUCcC1UE4LxxFGg1RHdRt8FEaVyG2W4YnLTeDwHu4qrwjq6
4520	fee_transfer	525	24000000	1	CkpaL5tTitwCHGo6opQJSB2FT6vFG3AuzzTnY4P5yNiTkB4MoydeC
4521	fee_transfer	1680	34000000	1	CkpYnAkpkeXU7jt4TrgJZz8dMnU6MhM6r5gpnL2TgPjPudhxjfMG6
4437	fee_transfer	2086	10000000	1	CkpYTmizstDNXwqRwsFLzMNU1mC5XfHAeeymKr1rrVZj4F4AKcPR1
4439	fee_transfer	1687	382000000	1	CkpYykjiLek9jiYBfbLDmazbxikwBKRQWAPS8aQn83mr1RxrEkQ2Z
4441	fee_transfer	1394	21000000	1	Ckpa2np6jm7GFycfwuZS9HokPhED6v5nPx49UQdAbN1SF2ccZRmrQ
4444	fee_transfer	1671	31000000	1	CkpZAxDHgEtZW7mQNkRMu5dbWF3nm1WtyZ4HDukBgX2z2t4Jv6sGY
4455	fee_transfer	1599	42000000	1	CkpZ4awJPvos1GTK5CsLSjkveKmqG5L74s1AJJkMQkWBQ4912zCRP
4456	fee_transfer	1716	21000000	1	CkpYjqoUa8LxCyjwj8ig5BbwFGvbhWsUNB8JJFn6ScJYfpDmFrn3A
4458	fee_transfer	606	170000000	1	CkpYykuoKDGY2A8bXXR661XowWRvY8FgUwE1QNzvjdGfwDAhhUTSD
4459	fee_transfer	1685	43000000	1	Ckpa6BQydmr3Dp4s5Xw5nu4hYU39ZXs6BRib2FTFhDLTXsGeb9cwn
4467	fee_transfer	1534	11000000	1	CkpaCZUS9CE3ZcF6gWcoh3CDdUtgp1WCCmAd65fPZo6Bjg6ksJa8v
4477	fee_transfer	733	12000000	1	CkpZ5KFkkuCa878uEBLSTV152jbpwZfp7cyU4fkXTiD26VpQsfwui
4481	fee_transfer	2086	23000000	1	CkpYfJPJiX3c2Yz7rv8b3s1q6yyRGawT9GmWonbsP8AsGobrj4BRq
4483	fee_transfer	2087	23000000	1	CkpZg6EBW49oJL797VUBUVMkUoHxP5AkfiBECtaFjun5mCe1KWbXk
4490	fee_transfer	1541	12000000	1	CkpZtf9SZodCcrFPusmcJ5By2skRnsL4h8eX8tGDtEJ16eT1krJWK
4495	fee_transfer	1716	46000000	1	CkpaFjLAP2FnQtha834TuiWC3dq3ZBDkzKwRCuHDDXy7zG7QpDss1
4500	fee_transfer	1395	35000000	1	CkpZ9HFiNLvweaxRtZ4tS63mgeNFFt3AjZTww41ptTFk2ZaaJRnPX
4506	fee_transfer	2106	12000000	1	CkpZkkW8CVZT1WajD2ZsV9byEjdD1UZKzyvHSFqbVrdjCHYzUQCf9
4512	fee_transfer	1690	34000000	1	CkpYnPHZTvx8fXsAPJ1A7a3Mw8mo76pbVJecWGjngeEcSJSed6nMf
4513	fee_transfer	1696	9995100	1	CkpZZyKzJdcL9mWcNRQzeFnRGrUK5qfD8yjp9YtBrRHxW38tK63xb
4517	fee_transfer	532	23000000	1	CkpZjTPnzUfm9VY9G87wGvJduhb4CegrQpdmgx6UvPSE92R9KnZcd
4524	fee_transfer	1541	11000000	1	CkpZysEJS6KPLecMmnYaAynPrji9cb4KsheTzJaRWh5ccC3evkUBM
4442	fee_transfer	1699	31000000	1	CkpYm3aye7mtiNMs5kUQ6repNQHgBgmut7TycxkECgorxvvt3Net9
4445	fee_transfer	632	31000000	1	CkpZ8VyvYDuymczQiwtq8dvBB7Ui5wkQVVe8hoff1mme48QPSVX92
4450	fee_transfer	1394	10000000	1	CkpZQqoYi7USVPHBXxdKPQ7wdnCAgNR1tiFS8StpwYSJHV6UPQ2gb
4453	fee_transfer	1599	53000000	1	CkpZSPVUPoZHkWy6q6tcX46o2FJzqdwzK812qJspuNXB2kXRxTaA7
4457	fee_transfer	1489	32000000	1	CkpZpWGhXt2VDK3B8mtVfSEjvcyqsdn6PBeZnmqRedHrBCEXvoVMF
4464	fee_transfer	1601	8020000	1	CkpZQnVteB6vej23XoV7zDCz9mymGqLGFFP9RXXAQ8ezhxtk4P2aU
4465	fee_transfer	1420	1980000	1	CkpZgXGQ7ZuCXc3gEvLR9vAXddutLksseYNNJRMtdScgggeB9rsKa
4466	fee_transfer	2116	1000000	1	CkpZK2aVmLvvzMFDgAERuNbXq4GBWzgAv4DomQkeq7fYjqTk8CAkj
4471	fee_transfer	1700	12000000	1	CkpYYQ8Rj8i6RuwuYccSaHRkCxA7yNwtHbCcci1bBAtJ7FwZcAhSd
4479	fee_transfer	1471	22000000	1	Ckpa675TbzP9iby35qpWWUkihYMMi6kaLJXWhqGGpynXKkWk8pbD2
4486	fee_transfer	1673	34000000	1	CkpZ9qYkTt22tg9UkQYGH21zCt4BxeE5MYV5APejZNW1o2JPa2eJe
4488	fee_transfer	1688	34000000	1	CkpYQ6aWGSvY3L9quDifprWVjHEgg2gSPrSF1be3vEq4jqAypigQH
4493	fee_transfer	1739	35000000	1	Ckpa44xUMWtGUyQStNgfmtz7riXG2WTSt1p9FvP6wvTZrES28AbF1
4497	fee_transfer	1588	164000000	1	CkpZJSuqLFPs1GjyeaiPxKJbwkjyQJbFZoQ24oPrSX3TNxj9co6PC
4501	fee_transfer	1509	227000000	1	CkpYmJ5ep25NUHArK52nvHfiH8ySojrxA2ehjsLWLRwHMxswdtvK3
4503	fee_transfer	1717	23000000	1	CkpZdFQ73UUGqdkksKCB3ZDrJSJAMWmuGAJGefk4xdhAE9gk9tXz7
4507	fee_transfer	1440	22000000	1	CkpYjiKTAMfk1hNSA7r6WBTGVwGKUaJEocEmQkxCg7yTtY9GXXs1D
4508	fee_transfer	1691	34000000	1	CkpZU1goaGhgPTFgSAbSRQ7FqeEgXPfjcgA76NVBqnd2JgEcrGf4A
4510	fee_transfer	526	34000000	1	CkpZ6X9dF6pDvvVKHvVM3vfhE4U9kZgNmfd4bRRCJNsrW9Qvhb5ez
4514	fee_transfer	1724	12000000	1	CkpZ3TPHtnqB48WXdAwCBBWXvPBUAXgJdpz5xQyHd5kQvQ3pXv2eh
4518	fee_transfer	2112	23000000	1	CkpaHmn4rG5Yu9rrUUUkDhnj5PnJkcvzoVCYg6uBVbjF2adSGisji
4519	fee_transfer	1513	148000000	1	CkpYzsKvugzpCDPMuVvjQYRGhaXpYoNui93PRTBijgrWqX7Br4kUb
4522	fee_transfer	1680	101000000	1	CkpYqPEjStroJjLsojCDjCEzzvF9jjBs4kcEQzmutAbRQ2sZjRaKn
4523	fee_transfer	1943	11000000	1	CkpYmha3d7qfmkWSG7CByBwnVZV8APrQyAeR8VjSXjU9feh6cw4za
4474	fee_transfer	1395	65000000	1	CkpYbmcndPqVWLvWGg6YUTKg56VFcLLU1MqUCMJ14ZfFgxYqsjbSH
4475	fee_transfer	606	440000000	1	CkpZzqRgnGbcB5qH3zLe7oEFnNRiM6UrjZiVjvxSrHs9igdtttztF
4476	fee_transfer	606	59000000	1	CkpYXX3w1bk6g3cT2BZq8p9pLhguEkQVVUqcQTpCvr6rVcfR6J9fo
4478	fee_transfer	733	2000000	1	Ckpa1jpL3shsaSESK5UTtijkhrq3rKPdcUgozBcLuuYna6ogxwXzn
4480	fee_transfer	1696	23000000	1	CkpZbD3D3hJkmVkVR5UE6qrrpDz56FbLWuEktpiZFfoy7Q2j4PAft
4485	fee_transfer	1705	11000000	1	CkpZuAej4TfZcWKaRU1BeBsG8UyijHrCYnCb6nTiZnPV2S9p8Qnw1
4487	fee_transfer	1451	23000000	1	CkpZdUVtqYoXMJnrXp9CZ4g9hGPY9wD8PShAP3kywTGgYB9qG2D9i
4489	fee_transfer	1762	34000000	1	CkpYfuraJkX9RkpT2gnmHwqYACwi5q9n57gquLMi6AidGvkhj1HHX
4491	fee_transfer	1719	1	1	CkpZPndv8Tt5NtKLGF3yfTDmwqpJZhMSnAUTVM8yzQc7CcARNbNMP
4492	fee_transfer	1671	23000000	1	CkpYd5d5TDUy6kbhfro6DXfFfLZJNHTP6pGgAosGPpUWuUMwUNfCY
4498	fee_transfer	2070	100000	1	CkpZtfoEirjjrJTp2nqYg6b4PCmfFDFjuRipnhdz6xA3Ff4STF7fj
4499	fee_transfer	1509	30900000	1	CkpYjqoQfzJnQE2QtvPyT6hZYKQScmqbMW3MG13DAYcQeSzmaHcse
4505	fee_transfer	1596	12000000	1	CkpaBpRPqtmV2svcJnCMBJimPXWouKAPhiwRAJ5ZDV1mFyPCy716Q
4511	fee_transfer	1474	34000000	1	CkpYSuCYnBoqQcegiaUr3oCbuKXytfne9LvwLUb7DKPLJuvYZvAmq
4525	fee_transfer	1718	11000000	1	Ckpa86PkbpHCEQxysVPGVeg3rTY6MdK4qC6spU68czEf85xvhzRSE
4526	fee_transfer	1602	23000000	1	CkpZVxFZNuAnscp3zUK5Z3yeBXKZM6mtgADrvyax13rdUPZQjH5Mf
4527	fee_transfer	1394	2000000	1	CkpZ4siNyVR1tCbR7GkYaLSSvk89mogWTcW6nKurXQsHWCtHNZWCn
4528	fee_transfer	1643	2000000	1	CkpZZuCPFNRfLi1ZmNwo1k6dMubHdhZbzKttW9RHYHStzjKcY9nQB
4529	fee_transfer	1476	31000000	1	CkpYteaKEEFrdjveq1dNKVsXJv7JWsdd6KJr2fAvSVLxnyLRvbxUk
4530	fee_transfer	1668	31000000	1	CkpZwWwNqC2TowcdVxgzHCkkvy5HQGv5NN1snnaMQEJZRhwv4ZMiX
4531	fee_transfer	1723	31000000	1	CkpZianGmXZPF3xMw5G88ydYmRyW6rz6JMpxY3KWdvFY1xBFxKdmG
4532	fee_transfer	1675	31000000	1	CkpYipQzZ2UuoFWw4xiDef1sYh6TGDrwhRurY9hU9yGWD63BG2G13
4533	fee_transfer	1680	31000000	1	CkpaEUPRt2nHysckTKWuWuPZmzaGWVZByfxRTmRHm8AjWpotbEEWs
4534	fee_transfer	1992	31000000	1	CkpZgz9xH57FHXpPtp31mHjaSrLgy4yzBPvDXBEd9yZoSvUNVuQeN
4535	fee_transfer	1749	22000000	1	CkpZPDwSSuxNkoN8JN4Krsj5vJcN8yhfHoeMZhSs57zesjnarNbD9
4536	fee_transfer	1602	12000000	1	CkpZvjFFTrHLhWvfEyiPq1fnuXt1Sf8d7daNw7W8p5fRgoCfVQMn2
4537	fee_transfer	1395	34000000	1	CkpYV2c3Y56DzMPaaEhMpCtaLfbj1kVapA4oPC8JcswgKL3hPBKr1
4538	fee_transfer	1685	34000000	1	CkpYiJ7AmivshS2Y7JPEYHWz4qB6VaK2H9n3n82ZJrLGcWMdoDFVr
4539	fee_transfer	606	23000000	1	CkpZsttBEwXy8nRoEePCy6nq9hSsvgWVnHsdHMs39CJwydaP4UuTD
4540	fee_transfer	641	23000000	1	CkpZKuKBYH4wkQAqDekbNzteARCiqtAR3e9FAQGbD5pF4BEvpNxhD
4541	fee_transfer	606	136000000	1	CkpZmkrnw7jtvWca6MGn9x51EJiyk5EupqZuiBL4wqb3MNxPFAvED
4542	fee_transfer	1439	23000000	1	CkpYsVqZ55AB33TevfKN9Uw8FYAQP2xCnYwmtANzE1VobwXNU9aZm
4543	fee_transfer	1668	34000000	1	CkpYUydjUvsxpqCXjNvSCVUEsbgbMVewZCywpuXJSfn5Hs3GAmTWp
4544	fee_transfer	1546	11000000	1	CkpZaimCXSCCTLJmKMp22P5qHUBPBUFDCjgB6fR7CajLbDDBGLA6v
4545	fee_transfer	1509	160000000	1	CkpZHE4NpXm2t8zpKm28mZMPfBWBPm4DS9yjfez7KvfsWwBNcbUNj
4546	fee_transfer	1509	919000000	1	CkpZyBqE1WKZMzoQnfdkcwwtP96qN8KPXYGn9Fb9WvPShmfs14M2z
4547	fee_transfer	1623	23000000	1	CkpZWYKdHqbB51c5N7aUKTez64iHazy7vvuJeAoJdnqPWEWCqH22i
4548	fee_transfer	1749	24000000	1	CkpZHt3Mi1u9sGbzYSw9NSd6odtoFjiouxjiSGP9bPqQ5zvQwisBY
4549	fee_transfer	1672	33000000	1	CkpZjHLrM8mpvZALaN92zZuQSEjUcrQMpJNGPkdNmwJ9XgBPMN5Bc
4550	fee_transfer	1679	33000000	1	CkpZCqJDL2HST2XdLXbpghHLr8KrStDi638GWdApYN7BZB7wLpMzm
4551	fee_transfer	1756	12000000	1	CkpYf8PUosZxMjckSUvxD5SSXmajTSbCoYyzJnUqfKjAjf19BnCnD
4552	fee_transfer	470	22000000	1	CkpYfKaA1brP3LGX5Xfj1oyxUqFxbv2a7g7fyjArNbchWeNUCHN8s
4553	coinbase	1715	720000000000	1	CkpZzcSJKvs5hVLfN4NocvPe99L1fMNcTnT7TvLWokKd2LYhVF3NX
4554	fee_transfer	1715	20000001	1	CkpYwsXhAaqr6AaK34vG6YzjgQ8jkdrv7dpbG78Z1TbKRaSuRBS93
4555	fee_transfer_via_coinbase	1517	100000000	1	CkpZa1kxqWLqK7JomfF3rHPH1DL37ZsWTQqPaZpdfqiCnTzCydZ66
4556	coinbase	1670	720000000000	1	CkpZyuRf4QZGguMuHYeLWhxK1TgD7ugJY6ydkdjbpVEKaEZXmHfTJ
4557	fee_transfer	1608	34000000	1	CkpaGmbmVoGHBTvhpiP5iwwiRT58t6hfS4Qupb1bLi5nK91bJ8fun
4558	fee_transfer	1711	34000000	1	CkpYpjbZH67i6NxMyZ1bP372H7eZMDB5pWAKr1M8cES3PJhtNCBZe
4559	fee_transfer	1419	34000000	1	CkpaB2589DeetunnoQJ1w7s7K7VB7BnQNgaDPUFmcjDAdqEy6HUSi
4560	fee_transfer	1670	33000000	1	CkpZAKr9F1qhSVirx94yFCXMMHnzxCX2gnsic8ARQEoNTvMiJjwRm
4561	fee_transfer	1723	45000000	1	CkpaLiPdMdfGqPDksKNicSdfKgoGRP16kwjez31YaEJ5TcKQrZaGg
4562	fee_transfer	1714	23000000	1	CkpYXLpx3tU9zZF4mEqjBMBYVimHJH22fGX81pM6RWjW5pt7rKEVN
4563	fee_transfer	1395	18000006	1	CkpZRXbsn2tZmbjKPR2MYjDoD9CJ5C164h8mazG1Rxp4de2cdnV87
4564	fee_transfer	1686	23000000	1	CkpYXK2AJP9jvMf5BFnkrSmz5fjvsbdNnMwTS9AW45PoG2pdT8dsG
4565	fee_transfer	1684	42000000	1	CkpYofmexyNB4vfdAboHaX9rKeDmhQSuJvW8xAUVivNracaa964ZL
4566	fee_transfer	1685	42000000	1	CkpZ19hXbgfTqE782ieV8beS4a8Q972vK4gMzN8dY6tYDfo1Yb4Ty
4567	fee_transfer	1555	42000000	1	CkpYVmKF3NDCrVv9NZ9GPZdx3KosFWRD84oPjuYXGPEX719EA6hve
4568	fee_transfer	1710	170000000	1	CkpZZzG5Zu7obVuyYfJG9q5jqMroEnoaXhaPcLNst1JyteC8pdV5V
4569	fee_transfer	1710	1054000000	1	CkpYgvbhte5xMxiomMZD1ftGYrdYEYXLXbV9txdSHUuMLQBLL2pct
4570	fee_transfer	1394	60000000	1	CkpZLdmK97etXMEiAPumpoL8cWuU8uuyekFHu9wGaxUiTF291rpK2
4571	fee_transfer	369	150010000000	1	CkpZrUHWvfCaBAMBNmS21BbwhHTxC4H2V37HRFqGc3yKqjo6RH2j7
4572	fee_transfer	1426	52000000	1	CkpZM52U8Tt6ydKVSK7nxUpBWaBxhsAfWXsGuqJA7XUfLzD4os5sz
4573	fee_transfer	1457	33000000	1	Ckpa1M4uRvocG2vgaiPLCyG9U71RPmR5Zv43WEbs92QvHqFLGebCr
4574	fee_transfer	1506	22000000	1	Ckpa5jffUzr3RzuH8QHZVpyQvfRsWtH8ADeuELRYVcfFsuRmQhT3N
4575	fee_transfer	1646	2000000	1	CkpZ9t9ByELRUtQTvrdsKXJNRoiPfTzdv74gbryrbPcPjep7V6hfe
4576	fee_transfer	1714	2000000	1	CkpaJ2Wo8fNy1TaayZfYTCmJB5iMnS34QwbZfUNqcUmU6UJjXqvhX
4577	fee_transfer_via_coinbase	2097	1	1	CkpYah1WARoVEr4sUrsEZzYW7DD1QF3XSi1Xg5w5g6xsa7bitWyLn
4578	coinbase	1395	720000000000	1	CkpZYjXAALGg5T66FTNMMAAQ7h41uR9nF1GMyEAhEMWnVhMgtPgcK
4579	fee_transfer	1395	10999999	1	CkpZqr5xH79twTt1ZKPMVvCZiWLM1NVpqjTiUXGqsuDAavc7BHsxh
4580	fee_transfer	1506	23000000	1	CkpYqKE5axh9mt93h1UaPxAuZhXdDBc1sDYqdZFUmnzph8J9GkjB6
4581	fee_transfer	1569	12000000	1	CkpZi8UtrUZNUJgfEW1ZvvDWiq1QdcsWBwtMxFakLTcco1iMq4fwU
4584	fee_transfer	1611	12000000	1	CkpZFTCd2dmCQn1JDkQvh4FXBAmZXCy5qtjHvK3cBiRR9263V5Tyq
4594	fee_transfer	1705	12000000	1	CkpYREjiyCjUYGeoKP3DCQ7PUMaAKkc4phB1G46TGyFVXw6bhXEQL
4605	coinbase	2135	720000000000	1	CkpZP7WKZFigo6w6zNd8dE5ntH8HGaufWvtkYJgyYSuwRinyahY15
4606	fee_transfer	2135	37000000	1	CkpaAFrvFq7p24tAqo1rmGW9P8HPV5NcTSKKzqsgfPt9BGbZJj6Wu
4610	fee_transfer	1455	35000000	1	CkpYWNdE7hXPXBHdQh3yLKtmGfbxPgzAfFroKJpR3EnsLYxU5qpKD
4611	fee_transfer	1455	3000000	1	CkpYyzKbMohAcDyMLP1JUVy6VW5GMgutsgbdJ8gK2mXSfjDQXmYY9
4612	fee_transfer	1711	111000000	1	CkpYfeGXbtoY8hYWxc1F3d2DdGF3jZeTPxmpJxw5yd63tV8FmWj63
4619	fee_transfer	1696	149000000	1	CkpZMH2s3Sr85L9SFrRc1xCqHUac4BZNwKTvNu4oNSWd6BGUcdUxD
4628	fee_transfer	1692	46000000	1	CkpYZhTvEJLNZMBREUW7uN4CxhSpWq1fTXxHvTK9wfUqpx4ht1r5d
4631	fee_transfer	1740	17000000	1	CkpaDnM2FGVrvQebpcPQeemkx6oSCeD85j2sAghozpz76PFLrwaUv
4632	fee_transfer	1686	24000000	1	CkpZdehHCd31VNQrVM1VUHuCN6ZnAfCjUmu3t56h3E71BWtgqTbXK
4639	fee_transfer	1727	77000000	1	CkpZLoFVXUmNY5wNfwdAqqBf3KtwWMpUWho8Tyua3xJahQ1fHcuqu
4640	fee_transfer	1719	77000000	1	CkpZktnTkAvrzUHjUEiGm8967p6W9HResNxe6XrXdjZzNjh37G7ja
4653	fee_transfer	1727	57000000	1	CkpYqB9WnDYAXaZDRqvk9tPThE9zw3saSCZSD5oyLjsNzEJxgJ9Vp
4658	fee_transfer	1688	43000000	1	CkpYdcdRLqHByGHBQbC4o71xemqCSnkUwZ5kEQZgz46TPntqZkBXU
4660	fee_transfer	1594	42000000	1	CkpZ8P3mee6Wd8CPhjjcw4raBo1ur4XLCcwmYL8LJqrjzKYePzywJ
4661	fee_transfer	1637	89000000	1	CkpYnXCKu8TPQS33EHwBHyg4uRiii4aBr49qBoqsmzsDUhLmHuwCQ
4665	fee_transfer	1394	37000000	1	CkpZrEjcsbbJu9yf8EiEYcpeYwJjScFcEgxsNhAujT45SGahwmksT
4668	fee_transfer	1703	112000000	1	CkpZkfEx9FSMBpwVbp2cwkt2oyvnxMKNvFrVhQunqD1vGVdMb8EcT
4670	coinbase	568	720000000000	1	CkpZxmE3Af1tCYRMk9NFQP4Rut4R7qNXoGppqbPUP3QUok4XE2mrX
4671	fee_transfer	568	12000000	1	CkpZic5KMuK3QL1MDAkyxKTMYb5nLDtpWdv1LFu7ya65BfBDLiswU
4674	fee_transfer_via_coinbase	1489	10000000	1	CkpZA4KcGh9hbYMqhoqsN1HtYXrjuZxGXq4CpQFqMDkHP8wSrC5Vm
4675	coinbase	1801	720000000000	1	CkpYZ9YqhcjoWMoAjXShQzki66D8ESxmb4e3CpAHRgEtHRRL1LtZz
4676	fee_transfer	1801	13000000	1	CkpYk5ptZKhHE6AN8rm698rCnsX9QYmPie4ALxtDQZcQ9ZtDKra9h
4682	fee_transfer	1394	36000000	1	CkpZDimxKWrKv8gFbdCGAvxCyRroyeuaoTdUxngvWiAvkssM298R2
4689	fee_transfer	2135	24000000	1	CkpYgfi2JXCQ9CdLdU7VVVETdaqvBQAfZHsQSX4BCLn8ryj8GqUvC
4695	fee_transfer	1504	12000000	1	CkpZQKHgcetCSwrbMXKdVbm19iEhgNDoq5EnpEusyf3wBTyENx4bf
4698	fee_transfer	1746	24000000	1	CkpaKJ9wbLKDCqT2Nb5J9opGoYvuPQbcnd2BB34haNnK8zihQBjty
4705	fee_transfer	1702	46000000	1	CkpYdEhbB572sEEZTbab1WgRcBA9nZEH8R4tU2Jx5rvdFzFoSHJXg
4707	fee_transfer	1693	37000000	1	CkpYUSrjN7XmhNgCN6MmJfcggpEtD3g65K5yvGG2yU5nGc8FQrT2C
4717	fee_transfer	1688	15000000	1	CkpZaLvXVSRonH2ugjTp4tpjk72T6K4p2LPmMbY1pEon5tyLE7zk8
4720	fee_transfer	526	25000000	1	Ckpa97ViYucNKPkKtz5NwUa3PiqpwnURgKH9qSzMX19y24SeQKNjQ
4723	fee_transfer	1637	25000000	1	CkpaD63DL7fTcG9QqFKehq3psTueaJJdyyLeF4GKjKBpESFEuuBgu
4730	fee_transfer	1685	49000000	1	CkpYmiLas6DGzjS14ycwB8Xw2adtpqkW8Y9g2H1btRUSShGEMLzJH
4732	fee_transfer	1709	44000000	1	CkpZBfbVMgzWSM21aTcGuxTZFrYeB8RZszoLKvbyKrCqsZPEioQhP
4737	fee_transfer	1593	24000000	1	CkpZevqy2pAHcmYPeXXYfKjCAwpLo8gtin4mgVjPNzVV3Ke1nt9tt
4742	coinbase	2141	720000000000	1	CkpZHUDEmG5qR5JXsfSA1ywmh1Si33aJhwvcXxUTaFxN3x1ACTNcQ
4743	fee_transfer	2141	13000000	1	CkpZ5VbgEWk3Vzcnc4NtocXxRQar5MiKWPc8xsqay9LrvLxgjWDkK
4745	fee_transfer	1695	480000000	1	Ckpa3fuq5oUgd5RegirAgmz2JhAQ72HV1RkaiQQh6oaV4Mm7YSvxY
4746	fee_transfer	1695	68000000	1	CkpZiTv6NLe8RAwpCiXjZL6gcyE6kpFEoaa219PMgxQ8sLPPnbEmP
4750	fee_transfer	1598	38000000	1	CkpYf8enPxVQZ2U5gYqUADXA6pScBrjx6EguaZkkprxb3wyHzka5U
4752	fee_transfer	1756	13000000	1	Ckpa1p5J958vwnrmiSKsxCzSrtPBEt9MxVrovPHHw2PkZMC1dV6x9
4754	fee_transfer	1727	33000000	1	CkpYx7juTq6nJox2bqWr2PPcNpWcaACKKdfo9dbXq7TAJxTdnv3kp
4756	fee_transfer	1719	56000000	1	CkpZRFPFMnNdWp3vcdtJADSH99RyPsc4pcaAELc54YEzPjyhtLGyV
4765	fee_transfer	1447	37000000	1	CkpYcYkQ7VoUCMvTiEegMcbPKABg9BLdKFFRPfeGtYjkgW6QSP17i
4768	fee_transfer	1511	12000000	1	CkpaJLamZ9p7gpRrqM5qNVFyvtyzQVm3YQV7uVpyjWgLeiW8MejYW
4776	fee_transfer	484	11000000	1	CkpZhTz8U5wUswSKTht8g6EojQYxk54YTe5EtBBMT3BQNTA6RedGw
4787	coinbase	2148	720000000000	1	CkpaFDQK3tAgoU58cmfz65UaB2tmyzyj16GrCUKs4APhRq6DLyWZM
4788	fee_transfer	2148	12000000	1	CkpYygyoqReut6ED7zGF4v8gyFHcZqja4y2a3SJqvSWgmZPzR9pTk
4791	fee_transfer	1690	25000000	1	CkpZ6o53fRqVeFcmC7ADtV29kcyb1PNQDcTMCirs57boVcudzssbx
4796	fee_transfer	2106	113000000	1	Ckpa97Q4ApUoRgu98fKFKzqNM69VNpvkb4oQn32sRjtPxwMcQwDUa
4799	fee_transfer	1448	113000000	1	CkpYe6aZEbqP9GdHNiMBG35PUQDNkR9opGf5RdYaPfLgfkDGpVqj6
4801	fee_transfer	1716	24000000	1	CkpYiDY9DVyWSgQvSqRoeLsM3AeBbsrac2oAAAzroyAPBgSq2zpex
4803	fee_transfer	1395	174000000	1	CkpYdLSyMyAqqzNiKTxUhx6MWx4r4aupgBPyTDxJvLv7x1tB7uz5V
4808	fee_transfer	1740	37000000	1	CkpZNBAyFLSnpb9jFYzYiHBNKypF6ySBLbBeKg4W5Bn9NBrXqx6uf
4811	fee_transfer	1941	13000000	1	Ckpa31cdsR9N7gtd87kqKtxyRFq37VDWmGQhnjVCdBWHZo91qTLKr
4814	fee_transfer	1599	326000000	1	CkpZnubwwee3aMJcZ3HCR5Hser4z3hvoS77neiFuLq69jEQ4yru4D
4821	fee_transfer	1643	12000000	1	Ckpa8hpY5w8X6XYKFw1s6XcVyExskFFMfA7RzutXmSUHB7ZYhXMZH
4825	fee_transfer	1679	24000000	1	CkpYmfxfyohc1nsn5ohqzs3Yd8rkKgUMt6xkGK1iG2GNx5HhRZmmL
4826	fee_transfer	1695	25000000	1	CkpYj2E1BWgS9k59bVqTGtL2rwNXcVtb9E4j7BDDkWQqsBSKvucp4
4828	fee_transfer	1694	48000000	1	CkpYg96vY89NM2F2ckcaA1JmPpQSgSFTgTqBwSw5Ds2p6jQaLGyJi
4831	fee_transfer	1402	35000000	1	CkpZge6TouGkZmLnqvCwtkwe2GiZ4hSNnQyRY4Lt1G4gqt2Uv8qpT
4833	fee_transfer	1708	310000000	1	CkpZQzCvV2evVZHDb3K84byHMRwb18sAwT2VKHjyyYF1HGFWBAKYB
4834	fee_transfer	1708	211000000	1	CkpZe3U5R4UkAfsshBFizGnUqshyYcpv4XqVYXrTPWAENtR3CM9qc
4844	fee_transfer	1489	13000000	1	CkpZbEjjfuSJFNotespJg7CY14qB3DWpKgM6K4viV4fp85FD2Vbxb
4846	fee_transfer	1618	13000000	1	CkpYcaspjucMw87hbnYQ3hNCuX54mR8whLmJhBKr9Jo6g4qKKHhdA
4849	fee_transfer	1613	25000000	1	CkpZLbEvbZk73knG4kZFCaQAGeTDruVDeDN84Ni2EvME8Xnv2QjD9
4856	fee_transfer	329	13000000	1	CkpZJzN7U6ZAzr9smDBv321PFUgjcHyDzFawXJid9FtrTzDmGq5tj
4861	fee_transfer	1571	25000000	1	CkpYqc8GNhHV6M2kHz1S8K9usfDVFkF4yHxzcraSqATzR6FhVFBP5
4582	fee_transfer	1555	13000000	1	CkpZTxgJoya3KZwTu4GAgw7TDzBEGgQLyQS4PkeJGTXouykKTUxuo
4586	fee_transfer	1555	23000000	1	CkpZHFJhmfqiG4Mw9hCimTRPgkTicexvJ9YpEEN3JrqDGEGSXKqUn
4587	fee_transfer_via_coinbase	1786	10	1	CkpZFdMSgmtgntnf93Nwf6AicaADPQRMiCzTUt5BKCweKW4hkgVvp
4588	coinbase	1649	720000000000	1	CkpYnBkPgN85sLym5T5qEfc4fNsFd9E1qLseBeXxQzwTVDxLzoeyN
4590	fee_transfer	1759	25000000	1	CkpZEZnPaSVUD4rD7g5wMbRwswKKNavwjjFTmzqWGEDKGaCWPRjGC
4595	fee_transfer	1709	25000000	1	CkpZsBksLkdzHCJzjqJNHcBemz9W9z5DUktToAS5T25WCCB722YDL
4598	fee_transfer	1724	15000000	1	CkpYbshHQtKbZprm788jZxYAvxrUmgdw86MU4TC8fy4DgzBs5APsX
4600	fee_transfer	1637	15000000	1	CkpYruWD4Bx9N6GeP6heocPRjMABXcpN8L1rSh2w6r6HTN7jhmySu
4603	fee_transfer	1710	160000000	1	CkpZhEQ1fZ8gyhqRsnqv3VYpfG2HxE1pX3gze8TrpFnYct6CNdmw9
4604	fee_transfer	1710	838000000	1	CkpZ3Bfnw5RmZi5gZy9iru9sgJ4V2k2ndqALJo3Js6JebL3znqdqi
4607	fee_transfer	606	13000000	1	CkpaGk4YG1F8o6LpwK468HdbMwULsECw3Xi4G8kgq71kXysCqd24i
4609	fee_transfer	1668	26000000	1	CkpaGAyNtiT8fVaqutSL8zPULNTJqtc9Us9fgQxD9AkaeGXQYkUAv
4613	fee_transfer	1546	25000000	1	Ckpa4UosjvSThgBktkriq2FrkegR5GAHw9kv17B8bnTXj6GWYH17G
4615	fee_transfer	1444	112000000	1	CkpYn3dNtBqRfvQFAUYAR1xcvPjF6fmhDZdh98C1wauCRsFNkEX6Q
4617	fee_transfer	1518	34000000	1	CkpYkvKefxUkJKbJvVRwCAWqJbny3dDUBvj4iAyqoP4DmF4hGsMLR
4618	fee_transfer	58	149000000	1	CkpZqWWAu1xFNbK8jtGRKUdbzwAWfYoynu5SFFmkekbRuqtcbytSa
4620	fee_transfer	1633	149000000	1	CkpYecrrtmVm6gyN5ZwoczuL5ocfxUXkVEzUDDuHs2pKHYLv87DwB
4621	fee_transfer	470	25000000	1	CkpZC2bMCg7WAnaKD7YjptJaDa6qKH9H36KBssC1zwsRgg1t1GDwd
4622	fee_transfer	1587	36000000	1	CkpZwrCtNkZZH2V7KkFxbJfQMRgsPXT3s53g2uoH6NcAohMYRf3H5
4624	fee_transfer	1599	34000000	1	CkpaAegNR2ksNDW5zLqeG7hLCd1rA6WCavkStDwypmAe9rStdXaTq
4627	fee_transfer	149	46000000	1	CkpYs3oGZuKyDBCcqVXTEjz7hPXvED1LMCmYA8pV6YJNfAgAA4Txz
4633	fee_transfer	149	21000000	1	CkpZRaUQUWKSK7fwKgiLV6LN8H878vfWrun2X6Pao18uza7216d4D
4638	fee_transfer	1746	77000000	1	CkpZhCZCceF8MRvMWgeUMWSYyeUFdJv3vW9pUMPUgfnKRujX8wxDm
4642	fee_transfer	1719	74000000	1	CkpaDiekXj9ryESBzYYDGKQzLEwWMxaXiCWh96yZ6XnJ7N7r9e1p5
4644	fee_transfer	1395	32000000	1	CkpYbtaMsnC7WYCfrjo7hwqrHhG2ff9kyVQgDSqYNkcp9w2gw9Zfw
4650	fee_transfer	1506	70000000	1	Ckpa6u2btKU8ATskHA88cAzU2esPQ9SXKGiJDYhHXKX66jjThzWkf
4651	fee_transfer	1506	57000000	1	CkpZgyCUJyMtjFR2npyXppUHpPUzSmCB5r7U7j39R1o4hwH6cnyJQ
4656	fee_transfer	1685	12900000	1	CkpZMAeJLagcau2gARRe4SAm1Z8KoYpeVkZbDLkBo4SvdiWAxiBEm
4662	fee_transfer	1689	37000000	1	CkpYuGRk1vPPB4PBuEfCrqDf7TUu91KKqRNmFgKUpr4MfBPbE2Gun
4667	fee_transfer	1714	112000000	1	CkpYR3B5wTBAynWteVUKkNL1az1FYtfpKQrH7e5joMNLkRwWNK96R
4669	fee_transfer	1467	24000000	1	CkpZeCVYnBqEiD3gWzWFEuwCCoA2Q3ZHkFH1RK7CzJsuh4dDQE8A4
4677	fee_transfer	1623	13000000	1	CkpZoWmkWiySzqbFCfUc5f4L3SpUZzSEWxijN2vvQrM9khynHkg2c
4680	fee_transfer	1706	13000000	1	CkpZVrXj24CXXU4q99J73gAzw2fyt2k92ukHCRfFGyp1m7asJHLUs
4684	fee_transfer	554	12000000	1	CkpZYU81xhAUBKowcRKywGksiAWznxy96uhiMyboDC22n1zdZpaYs
4686	fee_transfer	1700	24000000	1	CkpZmzXWJsw8oPGqqyunzogngfGtya6L2PV85VkU9Hqe5Tu1kvCf1
4688	fee_transfer	2135	23000000	1	CkpZN83AGUYHXMVsgWdi453Y8fKRCsUEqEUocF7eWrhoJEedHzS3b
4691	fee_transfer	1756	24000000	1	CkpYePF3bMEdBptea1e9qFkWCpA8UXsQGstT5iR9pBxAB7Qfbd2os
4692	fee_transfer	1694	36000000	1	CkpZBEcbuqw2YEc1zAKN4kXDnytXBgw5W4fsPEHafB7CmKuKQJWfz
4694	fee_transfer	1692	24000000	1	CkpaGtctcjS3D4ou84UBMTJzPrwyJQKa2UJLskiqUyS5ExEw9oD7M
4702	fee_transfer	96	12000000	1	CkpaBTNEf8ncBP1ARBXb4aieXbsTTxogx53X2efHEUVH9izogVaTu
4704	fee_transfer	1703	46000000	1	CkpZnZsZ5ryrLJgfztruz2pfTatZweaRzqTC8iJqNFV71yfexte4E
4709	fee_transfer	1451	61000000	1	CkpZ565h2Fv83vJJKeF3Q5NNcT3NifCeDtrKuCEMwSWfK5FZNGkfh
4710	fee_transfer	1603	12000000	1	CkpZGZKCtaSQmzLi3Qy1KcpsSitEzqYXUtL56bT6SLLfy8jf55P9q
4712	fee_transfer	1688	36000000	1	CkpZ2LZAvnQ3uQcCsmxqrVEWNrzSKK8UBs9sytq8YZEhahe2MjpL9
4713	fee_transfer	1467	25000000	1	CkpaBAs9BDTkQDnSayf1qQtV2uKuiJhF3oMZzsXRbT9LL6fAq9ymz
4714	fee_transfer	1656	25000000	1	CkpYVC7iKZhX1jesdPP3GBCRZnTntQYB6Stz5pXwvNRiRbrqkRUYx
4719	fee_transfer	1701	25000000	1	CkpZMCmY9gtqE3TVZ9w9w7dxVfPKG4z4pbyNYNtGxVaHppqEgMA4T
4722	fee_transfer	1703	25000000	1	CkpZNqbyqKQHx9CfSB2DLcxqsLcvAQ63ApmXthqZUqpfKdb5V89iz
4731	fee_transfer	1451	13000000	1	CkpZoyv8ScqucL6aJhqDhxHoFzjd3Xm98iyqpCgLgivcPMebVs59f
4735	fee_transfer	1271	24000000	1	CkpZu5yq22QPJvmMaiHGxL1C2hTX4evuh4sr2mUBJv2UA3hRgyWUG
4739	fee_transfer	149	109000000	1	CkpZHA1jcqwzZ1mVmAqEF7eQHXn9vizsYoN6Kjz9mn98DBsiPEbEy
4748	fee_transfer	1746	38000000	1	CkpZ63wMjM19RKqdhmY3YNrtHBEHJAPjdd4msdeehULs2g57gEFFc
4760	fee_transfer	1650	12000000	1	CkpZL8ERMCNrPqhRdULAPfLm5Dz8vJ95XvWHwfBuigGwRS31H8vSM
4761	fee_transfer	470	4000000	1	Ckpa1U2nATcP8Abuo4kKTUPVHBPcbG31edNLZ3TE5i3FGr6hjxViH
4764	fee_transfer	1447	25000000	1	CkpZ8j2Dban6pN86vbLnCm4BrTHBjvXRXbmV22cmp6FSNK7k1sWbj
4766	coinbase	1941	720000000000	1	CkpZ6ezRZR39zCJ3utiN5TwGZXeJNNwWDBvuHpD5nDnx9QHuYPCn8
4767	fee_transfer	1941	12000000	1	CkpZWgun3UiGBpJ1zXizdWQt7dUJcw2pjyvdiXdApchV4WJYQPGGr
4769	fee_transfer	1455	64000000	1	CkpZrQhZ3Mh88LwAGvkJLkg27HgkpDkSMUswXVYjot5FmmpubCyMz
4772	fee_transfer	1547	19000000	1	CkpYf8SP3yvMa75vxUgH3ANUiJr85diywr3Tv2Stp6sqAgtJq73ws
4774	fee_transfer	1476	70000000	1	Ckpa8igyoe1FeZkegbGvNqj4yvdrYAvFHvpUfqah6Jia3brbSbWzX
4775	fee_transfer	1476	85000000	1	CkpYnTNqAAS75Y4q7CiDdMANdd9tAkSJMmNtpNoYSdcHazWMBeNAK
4779	fee_transfer	1740	540000000	1	CkpZR6twDh83GPRBKVT5iLBjfrZcnJFnZywt5PEXP98EQUhEmzRcH
4780	fee_transfer	1740	710000000	1	CkpYvcwDS4GLQ3Ap7M4g4k9fBihgxq1jNcDNDz3hNdMDfGoMJQsm4
4781	fee_transfer	1547	25000000	1	CkpZVQonrQSA3Nc4xrvsvryNqcGLbjzfECQDJDwkxSJQpH5sFntAD
4789	fee_transfer	1613	230000000	1	CkpZYPXdyQWsimSXsdKF3Xpw2YPUbUDBhJ4yrCxkgpHsFzmisxCuy
4790	fee_transfer	1613	126000000	1	CkpYUJSMYQ3gQpPzkh5Qp3Q7BLJpLDi3vu2P52G7PkV4rzGK7naCM
4793	fee_transfer	1691	25000000	1	CkpZDKXreW5k52FVwdj6YQYLBFjzovry3QStiMT7yDTRjR2brWBgN
4795	fee_transfer	1980	24000000	1	CkpYdQznQdvGueNivUSba1Zrx48vucpjjvtZfkixEHiu4y48TYm2c
4798	fee_transfer	42	113000000	1	CkpYo8uDztqvax3tcADZiHwZ4CQkcSc1kP4FUSW5vhioWkNoDVH7G
4802	fee_transfer	1394	174000000	1	CkpZeF51Np9DyRyXMLqCDY6T9hQM5Fi6Gb6meTGwxkpPtwpDHb7ii
4583	fee_transfer	1448	62000000	1	CkpYm9khKXvsouxW7eWWaAoxqVjo7TvhaM2x5uLTRbGVhJExBBGLB
4585	fee_transfer	75	13000000	1	CkpYWzqg6hNHuknFmMYH8ETCBTfyrzN8j6dZK3mMEfRSXHLuNhku9
4591	fee_transfer	1706	25000000	1	CkpZus2kd6k9cUiUzoDGgWFkYh3veVAMijZKmymbNQqZj2HgkgifV
4593	fee_transfer	1646	25000000	1	CkpYmouWkGNsZvzctFYc4RHmJApdjkPXkUvxg5b9mDiJsq3bHcSkw
4596	fee_transfer	532	10000000	1	CkpYsYLHE4QxvYNW4qBauymQGi2ntpwpjCzZ2YnrLqcWEPfuTNHgu
4597	fee_transfer	532	15000000	1	CkpaF8WCT4gevuqPrsZXDc3pjtDwSfJMrMS9gp8fzBJTeD9CUvcnh
4599	fee_transfer	1696	15000000	1	CkpZLeQ4X2DcVpBfDra7RG9ne7wjRbgoLHjXQM8yeUkaCLAonzTWa
4601	fee_transfer	1696	18000000	1	CkpYyT1GsmajkzA6VqxQGV5LHXsRN8oNE2omQfpKraDfx6TaRZYRV
4614	fee_transfer	1395	25000000	1	CkpZK8iXFaV3zHChszfFL5EtCS9PfpTKRqQh6uKhSknYDPo6encZs
4616	fee_transfer	1444	34000000	1	CkpYTVS5yZmMaETiiYjxPGhm4VcrwQcXqhaihwMT4K7fD7xY5imtK
4623	fee_transfer	389	12000000	1	CkpZWjBpHw1Rx6LQAdG6C4tZkF3U9Cd7K1JP1usozMEtoGy5Z5D2V
4625	fee_transfer	1686	34000000	1	CkpZwHPbcjYqCZsVPzxYu2ALovTYJMU2Yc5UroiDsZhPCyHz5W8C5
4629	fee_transfer	369	17000000	1	CkpYyd16XGVCUcnoZFzmFV9F6bLqKPkcjgAjbZpK4naqxHtmgu3TE
4634	fee_transfer	1395	14000000	1	CkpaAFAJViucnGpmq3uiA9h2KTDZP9RFLJpFc2cZp2ELaRg2TiERy
4643	fee_transfer	1980	127000000	1	CkpaEQzbQ3sGVoAw5xgzvr168x53vEXhmyDvb42CAkvCzzRkoSXmQ
4645	fee_transfer	1692	32000000	1	CkpaGYpQFdP8wMYG876jZ1Sq2fiBp82pZHVefcH1yw8r2ZtH8XeU3
4646	fee_transfer	1395	67000000	1	CkpZ7CXrjtECr5aPDjYFBJgEJVj6sWZdaxVFPqYEDNp1GecxjQqPL
4652	fee_transfer	1688	57000000	1	CkpZsrecQTteNEQ41frKoc2GuwkX6pRikk9iHYX3aKhx3xeVzDDzY
4657	fee_transfer	1623	32000000	1	Ckpa25xgTDV97X3a6pHUmbqSxU9TYuAj7TCtcyk7YPrv7t5iariDo
4663	fee_transfer	1395	37000000	1	CkpYzNE9VMBN2uVFRAkTKHdc2oUhBZ7FW9Bcn7DJN4SSsysgMJe49
4672	fee_transfer	1705	25000000	1	CkpaJUisUm1GWHTrcerowDDzbFFnBYfNKYyyM3izu3vy4a8vn2aVN
4673	fee_transfer	171	600000000	1	CkpYpPDU257atgXkRBJ8qs4CDnXrEykuotThNcsZ59U9AhE9qAn64
4683	fee_transfer	1710	13000000	1	CkpaA47shL92u6jSy2Y8CJJ6rESmko5Gv6jFvFseWnrzfLfdPtVKs
4685	fee_transfer	1692	36000000	1	CkpYRGvUHbAgPRzaTmSqFNAN87djEEcqe4AQxFDWFEcZhYpsCJ9zT
4687	fee_transfer	1764	24000000	1	CkpZTEh3vTXC1ucdLTDsQmC34EkV6iUGQrFu8gheR3GxRtDXdqqWn
4690	fee_transfer	1419	24000000	1	CkpZemTcAK4aizYg1Hqu9mj3wpV14YztF2GisXTfbbpJYS8a1VfcK
4693	fee_transfer	1489	24000000	1	Ckpa6cJ2xTa8vFh3rCG2moQwwhjdURifNcQ39zNqecbdY5qX68jN3
4699	fee_transfer	1704	24000000	1	CkpZMatbfdBnTTJhAj3FNk6JJ2tHHc8JaQAYaJiVm8osBTx7hp7Dm
4706	fee_transfer	1451	36000000	1	CkpaJgLJjndcJEhTji9Nd6dPdjq6KscJQGZPY4THNtLyn4qEao6WV
4715	fee_transfer	1599	1098000000	1	CkpZGBxvLvj6am9Bbr21ZpLgkhMNsU9t1HUKWBYryCdR1ykgcETG6
4724	fee_transfer	1727	13000000	1	CkpZ7kYVvULs2M438SaZcSj7zxbmCuUgEr6a3gL9hy7SQZR771oVw
4725	fee_transfer	1394	76000000	1	CkpZc6v2fogeMgQf9Psqqpffp1wNQ2b6rU1oeVWn4qV4g12Zzz3cr
4744	fee_transfer	1567	13000000	1	CkpaAUubP5rV2ETJZGUtfJcxKkZgG9htEkJW6CYg3AenocHCCtfda
4751	fee_transfer	43	38000000	1	CkpZMAvP6y873ai5a2sfoW9mgQYbKQEptGFMQRmC66YJnKTZvAsAw
4753	fee_transfer	1596	2000000	1	Ckpa77Fus5Ph38JrDFYdsnvESpJJmuviEqfNCAiaifsLH8vKneBQJ
4758	fee_transfer	470	34000000	1	CkpYYjdfKS1vYx4PF8Dx8D8aewtPywnLZ6JUg1osGVcXKTKd14uUv
4762	fee_transfer	1650	26000000	1	CkpYqNAC4z3SPMK3sCFULqH5JZkMcw2ZTN1CXojWPreWY7MqNKpDM
4770	fee_transfer	1426	18000000	1	CkpZNybiPC24oxpk5uaESFJyocC8EPygBgENtwKGRXqQVDZHpE9Z2
4773	fee_transfer	1547	431000000	1	CkpYTcnuq36gSf6b8LWJiqZ7TJZqs96pVqrBPEgjMFejna1MMFkBV
4777	fee_transfer	2041	12000000	1	CkpYyNEVmRcLnA9bzzfEohzrBgJhXeZZ2wrutsDhse6WsHHpDzbRo
4778	fee_transfer	606	12000000	1	Ckpa7AEExiDqGH8zqehB1F2Nd2sjXMpsyfrw5vYdJ1VZK3XXesS3Y
4783	fee_transfer	1519	26000000	1	CkpZZwyWtKuabKFmFV6zXC4cDHFbyxQ9GabdRuK9FNUJH4x4ZbpLp
4794	fee_transfer	1740	25000000	1	Ckpa2aXbRWWyNcungxhbokuMRRjHsHPsdrnMUguJGfB765GKnJYuu
4800	fee_transfer	484	13000000	1	CkpZwRbmdbDVD3kDinTNcZCv1mphRoozRqDsFQobFcJUsmUqZ8XRd
4804	fee_transfer	1394	123000000	1	CkpZUBbCJ2Pa7n7TrvmGj7SFMnfwFvqk4mXDfWUxKXsF28oQg2DGx
4809	fee_transfer	1440	24000000	1	CkpZfXqjSkuXuUAaF5Hy9cBLMtJsDhCXHmp785dvdUEq5C7qLrUDm
4812	fee_transfer	1680	112000000	1	CkpZsrKMQL8qyaaJsLWqpsY2TcyBrBPABwWtuhbBvJz6eiqRvAERa
4816	fee_transfer	1513	720000000	1	CkpZq6sk2MTkSGG4wGt56LUXrwJfHxQVdmAcRhxCPjJtP8LPmTteB
4817	fee_transfer	1536	38000000	1	CkpZ2U1eLG7sz5xjiFiJtMLjhaMxxTSzeZLuKSnoJ8BBZZytqy4JK
4818	fee_transfer	576	37000000	1	CkpZa4VqxZmjjT6Mj8rLxYViE2rcAvtBe7yqs37zvarkBTR6wjJmn
4822	fee_transfer	1597	24000000	1	CkpYowaNxHhDYtmPo337hAaq5Ci2SkXTca43YRNUGkeEht7v8tspV
4837	fee_transfer	1580	12000000	1	CkpZEuwpsDj6xJUSN4nk46Aokh9KrYrevwyQJYsKnfqb7Uo4ZKeKz
4838	coinbase	1515	720000000000	1	CkpYoBtUwT9WExCzAf65mZhLjQihXU4Q9HRQztZ4kV619XAvEBcxj
4839	fee_transfer	1515	13000000	1	CkpYpj1YvvtSMS3ot31Km8kV26tNMuQ1jMQTvgihYj1x5Wc9dZXbq
4840	fee_transfer	1394	30000000	1	Ckpa7Cqr5zfy1ntmkCKauJ7JpEQx6YzhZo2xZhGeNJ9yS4srXBPTz
4841	fee_transfer	1394	29000000	1	CkpZhEwaaUfYwt33B23GUmWu2rSWXQKFsWhwwyHZUWv93FMc7BCEb
4845	fee_transfer	1610	49000000	1	CkpaHkcMrwPhhSocuzGgrF3eUmZSuv3wf6zEAtcnGjD2RbaTGmZRF
4860	fee_transfer	1634	23000000	1	CkpaHQZQrXjjDQAmUNjvYZazNDRPRPkMmRLMQuLjjiSuvhp1cpPtG
4866	fee_transfer	58	59000000	1	CkpZNwzFnv6cvP885g7deLbnrT1ZTTSV21rz9oC64XX6L3BbQu4n4
4870	fee_transfer	1616	24000000	1	CkpZhXwwn1Y5b1sD4Azyf47NVJEF6sj9t1nVLACheF6x7GagX1nTW
4871	fee_transfer	1688	59000000	1	CkpYUGPg1G6yNRZrQMghu1LjP8nTKQQgo4MhBfCC6qkWhyqhxq2v6
4895	fee_transfer	576	257000000	1	CkpYpex3aB3qRjomcrj6TMKg8jE5cg5EPmxs5vEyJ3vKTAiwjugqo
4898	fee_transfer	1668	25000000	1	CkpaBYb3LAbkbZRRy3sfWrZbNZKKytz5gxkyfew9XB6e6y7nhLeLL
4900	fee_transfer	1547	37000000	1	CkpYQAmvaLzqx6atutuMnAfi61ZLhqi5ZiHxMsYhSEfFhUHM78ikM
4905	fee_transfer	1422	25000000	1	CkpaFA2d8V7YU3eVVfpzd9zUKm9xbpZuDPBbGRPB8NQQHD9TambxH
4908	fee_transfer	1571	12000000	1	CkpYeKfQSK7RsyLEXhQJ7Vjmto72CWU7bCkfsDv2syQLpRLLS8uio
4909	fee_transfer	1727	25000000	1	CkpYZgaTNsHvcCNwqUFtSMiMU9x5gtPF5Cr3mAfYEJW85Yo2qFoJ1
4922	fee_transfer	1654	25000000	1	CkpYg37VRcto1vDqai75ZKVZuT2BkMNWnyotvGd7qsapXTXssDzvK
4925	fee_transfer	1717	160000000	1	CkpYifGtSsFbW74KR3mkz2QQUfqFTkf6C57HcCtMd6P6krAcz65AU
4928	fee_transfer	1689	23000000	1	CkpaF7tViKK4PHoJv3g7BrGyvXTiDDNekwMA83MMEXw21T5MtLDkF
4589	fee_transfer	1715	25000000	1	CkpZTSV1SUhun1fJsMvfga9rAYpNqGVYExyCAaRAar4dV9TMfND1e
4592	fee_transfer	1714	25000000	1	CkpYuavwaNAwaypVGBbiH4UHFthXyHX4LxsfrMCBAUCYjQpo18252
4602	fee_transfer	1690	37000000	1	CkpYeRA3y6nP1DwaVedeptoK3nngVpzGHKscBq3M4i5V8DZYJo258
4608	fee_transfer	1633	25000000	1	CkpYaJ1nLic7vcJzhUNnGhyBmu3KdoLxx9iYV9WZGDmZ67gaSxTgE
4626	fee_transfer	1560	14000000	1	CkpZS16AHqN6hawXk6xf2k3kLrcz5TtVnUW1JfKpQsq84YiGyedcX
4630	fee_transfer	111	17000000	1	CkpZep6ZU2ma8o6CwTzymr63mb52cByoLCkThgMgDpJt2i4mQYF6u
4635	fee_transfer	576	51000000	1	CkpYiwj6RApRoN3TFPzpBz4svap29whzgPFgYDRsbVH1WxbgaXk7V
4636	fee_transfer	1687	12000000	1	CkpYe4TFAQdNhR9pn2djmf3vLjDpu3MbjJM5MYu5ARWSqqpAfMwag
4637	fee_transfer	1747	74000000	1	CkpYdF8HQkMbzpSnERegG69uLM2ty2t4RKT1REdaoKt9ZCePbLvgy
4641	fee_transfer	1704	77000000	1	CkpZBVSvWLBxbAgip4mwaQRypE2cLsexTtCry1EnMYbKqAzHBY8n6
4647	fee_transfer	1727	70000000	1	CkpYZer8GDwqeiZXc5C5UcSaqHk7yN9B33KgwPj61irawQToGGo6p
4648	fee_transfer	1727	12900000	1	CkpaGXRtDkHA3YPWHS5WvUKho8vYVNRm7yfUCDbpCfcGBdYXpZPyb
4649	fee_transfer	1509	44100000	1	CkpYtK9XPg3hvJNkMsPwtqqa8NqcDSSVdCTQuYM8kkQbDQSyXCT9H
4654	fee_transfer	1508	70000000	1	CkpYTBE8uStBSYcU76zdyJkdkQjAW58EZ97TSfCmitaAgDEde1iXt
4655	fee_transfer	1508	57000000	1	CkpYdH14xC4DQ9K6tS2QL98WCZ5yP9vQUJazfYgJBPqU7eu7E4Y4L
4659	fee_transfer	1394	43000000	1	CkpYvviRwF8d8Nj69zKsiU5xccpUd17mPM25rXpT4xtiHCndBXvhK
4664	fee_transfer	43	37000000	1	CkpZiBXkbNR18qLsDYVHrawUG7Cc1m5mgP7vALLftQ8S6iDcjsojG
4666	fee_transfer	1702	112000000	1	Ckpa9iEtW1rpzHbVLkcrShux1jnqbM4XHSFN6izm7oC4yxTiEtBXD
4678	coinbase	1918	720000000000	1	CkpYgEVa9kDJdGB65EKnYuw7f7aRVLGJEvmXs7cRTfo7xLABXpwhm
4679	fee_transfer	1918	12000000	1	CkpYetMctvDhskCMnxrHwdMGX1JCzk7cZgKXB2s5L7UsW8aJ82hik
4681	fee_transfer	1601	24000000	1	CkpZA5mEw7LSobhffbHadZypsMZq67JNbu44eSjcfPbKvrEV7u4EQ
4696	fee_transfer	1623	24000000	1	CkpZMnPwxy4FCsQK7Tqwmfy1owFXL8mnREKSkWfsT4APeYrQDgQuU
4697	fee_transfer	1747	24000000	1	CkpYWmGj6mJbNECt6KAuJbSzz7358p86h625Z6uhrBgdVdaqtMswX
4700	fee_transfer	1573	61000000	1	CkpYdCmFtvGH3VcNRKzNc9RVdurfG9o4eNcrmKQBdVFoqjfHyeAFx
4701	fee_transfer	1710	24000000	1	CkpYrnFRGPGwyNLpJQNRtgurtFWVGsfa7Zu28UEtMFFnDW2essv51
4703	fee_transfer	1690	24000000	1	CkpYyNC6tkvST9NkREK7RLit96MpsmjDFcjbBFjSEFrjgXoj2Egk9
4708	fee_transfer	1394	61000000	1	CkpZNvBPPten6PGgSZa7fGNWCR65YcaqoMYNgpaJ2G7En3En2wfSg
4711	fee_transfer	1992	2000000	1	CkpYSpDHsbumWRDJmBtfzUVjzSYSqPHuFmzRj492UtVMWvHRhsqBy
4716	fee_transfer	1680	25000000	1	CkpYsAn98UV7RfGwqVFiWDDKK4wWogCnA3DdgqwMimstKaZxF1VQK
4718	fee_transfer	1688	25000000	1	CkpaLF9tYaLUMCuwTABeXCWXVL3RuoKBXMaow8DipuhY4CkNn5i9j
4721	fee_transfer	1702	25000000	1	CkpYiqAUcJ4eJJE8dWZx3SsFmbM628s1rf6F7mg1vNQy51ybgejJR
4726	fee_transfer	1980	76000000	1	CkpZTYhZC4Lxn8HsDuLurpdEsFCfW25HoM9bxTz3rFPUXraeMybHn
4727	fee_transfer	1695	570000000	1	CkpYtghxU3Ny57zFt57LKFJ5JscbyFyMj8upNnsfC6BNx7MyLLgBM
4728	fee_transfer	1695	140000000	1	CkpZpYcDTnn7pgKRH8GnhWBo5UgTu8DY1rxRVzoM3TzTALwwwE91n
4729	fee_transfer	1564	25000000	1	CkpYWJVRyfGW4oh32qmuTw6JYSubHCZKdpXSpSRJa2PyRsVLJsevk
4733	fee_transfer	1709	13000000	1	CkpYrkZxY52DvGXmVLjJdYKSFSko2VD2a9pES6zPqXazTu2Ym3g31
4734	fee_transfer	1689	25000000	1	CkpYatkij6zxgbS93xWd39CqA9uM26tJvrWmvf4vj5KbEYjJfw8Yb
4736	fee_transfer	1552	12000000	1	CkpZgbNCTsbs6QBinPEpaWP5RgMqGHq5bxMQhtAmRuwhKvTmQqJjy
4738	fee_transfer	1691	24000000	1	CkpZuowotRpKMMbXihhrquvWQBv8CyfMQctakb8cNcRBrtGkK7mWJ
4740	coinbase	2140	720000000000	1	CkpZuoiPEkJqzcHHWgg2fz9Hh93Dv3kNfGH5QHoEZYKb8MusvMGWA
4741	fee_transfer	2140	13000000	1	CkpYR3KuyW1vRkwyECE3LdmeXNwYMP9pFLp16eL5Yy8BFcDVCdx6m
4747	fee_transfer	1747	38000000	1	CkpZvJdSTmnxYzWXbVnMx2YQ8Qk3xZaGpPByQLgDWeKkUSrxvzhyK
4749	fee_transfer	1704	38000000	1	CkpZ3mz2XAa1wFKjJVa3mZ2o7txmBEfmgTmMjKixVNf3UJqM3Lqcw
4755	fee_transfer	1489	33000000	1	CkpZFheAAL6LnV5Pq91kSDYcSdD5RWwe2n6rSGvmYSU6oevUgbBhW
4757	fee_transfer	1509	55000000	1	Ckpa9eXHj2jGn5bkHCZXYy9TxvjFxcDbqgXuyABoFmQe1f8tUrUeq
4759	fee_transfer	633	24000000	1	CkpaBKjTjNCe1uhEZR19wCdz6Epq9kxAVmSwvx5sdUCyxQYowV1rJ
4763	fee_transfer	1616	12000000	1	CkpaEUN12pYJhVzcwC1wje3Pc2LcstMHNe7PyHM8FoTZkvXuw5uCa
4771	fee_transfer	1476	19000000	1	CkpZfrbdx49rRbJwQyjq7oFF6xfL5Tgj2pzaKsKSry77Ythzy9r17
4782	fee_transfer	1394	49000000	1	CkpZKiZrZCVinfGz3r1y5dt8FiL7WPt5qV6QyDp7HqSCVJK1gaW9r
4784	fee_transfer	1681	26000000	1	Ckpa6s28b3QyGJBXhK6fb8WX3AQYpfRswM1wmjj8cvjrub2ZPdXGF
4785	fee_transfer	1740	388000000	1	CkpZpkh199eXSGchyFwfhf63DpJ8YbB8NqMavqkQ2PKavgxgERPm7
4786	fee_transfer	1740	71000000	1	Ckpa2as2mnLCEDtS5Z4BGUYYCjFUKN6fe4Z95fGa68iEpZjraCmM5
4792	fee_transfer	576	25000000	1	CkpZBrnESQRCDeVmsW1YsmG53RkSZyBEjFjrxDKB24Zvo4NuR71oy
4797	fee_transfer	1457	113000000	1	CkpZkY7t5s5Yz4w5EBmMQEKhkLCSK75KWK5rYUBGh8z7xuZx52bYv
4810	fee_transfer	1511	13000000	1	CkpYz3dPcP5eEAEz3PTv5dgqQiZQ2oDKnYXwHwBbteop8s34oddbi
4815	fee_transfer	1700	2000000	1	CkpZwQNHgPBe6TcwaD7F7YkNv3ZDY79iPi8CF24wKieNFCUMby3qT
4819	fee_transfer	1611	37000000	1	CkpZA2insVP4d9mp1cMFTwSfdR7h4EsmSs4NVfbPT6L2z38QTBdCh
4823	fee_transfer	1681	12000000	1	CkpYivW9d4EzvFoh4ZknSvpfKGQGyb5ccFkaf5LMKWNDnDcWvKL8k
4824	fee_transfer	1439	24000000	1	CkpYRJqX8Y8RqCXHR4bSqbrHZWyCUuue4rzAE5TDmkdZQKdiiihv9
4829	fee_transfer	1549	37000000	1	CkpaBneyoNxhwpbAtJHrxsMKL8HRwL2ivJRPbfkGTQcxVDQnmyUAV
4832	fee_transfer	1555	35000000	1	CkpYzxBgAnDX9oL1Cjwkdnb5uFzLM3jgN531xCBernVNCaDEW3X59
4835	fee_transfer	1637	37000000	1	CkpZpH1pUXUD2qyi9hHgjoYcgCHAQMUuWfXiPFd4CAXqAUuqgjJwk
4842	fee_transfer	1849	100	1	CkpZe3SFQCfrjB9rRnsniSVNQDtvrvVjbiEAJxSGTnkWbMwcF7UYz
4843	fee_transfer	1850	11999900	1	CkpaH33aFDWhhTEaNQCMMGgsrQRvPxvPkQ3J7abrJiVAMQ8HqrvbE
4847	fee_transfer	2148	22000000	1	CkpZSS7Gz7shpx6zk41P7Uk5QJ6EM8rHZjUAtgP4jB9712T3d86Zv
4848	fee_transfer	1633	47000000	1	CkpZcYQzV1vnPK5toCf9irTavy6MUbkRK4PiEFJsjUjXn5qEJy7Rd
4850	fee_transfer_via_coinbase	1849	100	1	CkpZe3SFQCfrjB9rRnsniSVNQDtvrvVjbiEAJxSGTnkWbMwcF7UYz
4851	coinbase	1693	720000000000	1	CkpYxrPEuox2cZhT2bB2jRbnvHZEUmhPwwK9CkUUfN3RDakvXmVtG
4855	fee_transfer	329	12999900	1	Ckpa4o55vVmFDQqeXCjq2st7PjjLyxAmm6i3CRRuftLf6zoB1Uv6D
4859	fee_transfer	1513	27000000	1	CkpYatCrVtTujs2Mqn3gApFNrsUDkyUR6ykfbsrDzyrGKaJ72tuKw
4805	fee_transfer	1394	87000000	1	CkpZ67Dd6HYDfCEV4kgaTfxeZHYdK56yiQjkiaFzcWpHQxoDMnyts
4806	fee_transfer	1671	13000000	1	CkpZYPRYU3UaTvWuKcV7mKheatW8GTSsTb6zFyCvjBPEL1GcEGo9M
4807	fee_transfer	1701	50000000	1	CkpZvPappPUdh9i1RAnkXLcMGwu1pdFfvfJw8jjybzKLB2DpevuVk
4813	fee_transfer	1688	326000000	1	CkpYW72fRE5Z7RdFZGjNjAUVdAvRtpfBWfXcyvfUpSLSZjrTsRmrC
4820	fee_transfer	1447	35000000	1	CkpZ6WJRae5Tk487SGA6C2Z3VpMo7hx9nyZErfAVpVRqUgNbgXkXK
4827	fee_transfer	1643	25000000	1	Ckpa6KEHH7hh9wbSRKPHpNBx2KqkTe2d5Y7fcjvB6gkofQZkoZkXo
4830	fee_transfer	1687	37000000	1	CkpZozexR73XEBmhhSTya6tv1MWdnQqLBJbgPEQZzveEwB6rvT1YR
4836	fee_transfer	1580	37000000	1	CkpZyLwJgkrbpDM6WjSfJNVDLbKKM4QyHwvBeyRS7P2bXHECdeg2p
4852	coinbase	329	720000000000	1	CkpYaPbYf8WgFxgktWYkLmZWxedhkJTBmG4t5f8U8uz6T8ETqoioC
4853	fee_transfer	1849	400	1	CkpaJkcNvNF8n5hePb5xTbKEW3J2CQ7X7X1KaEMiq48SCqaNR2QPJ
4854	fee_transfer	329	12999600	1	CkpYYvUv2uZDL8jNSdpGuNSURYPfB8zFoq8hkLyWvfkQKe5AKitMy
4857	fee_transfer	1668	12000000	1	CkpYrBv5MqFuZzEqKbGHADmMx6e6PteWt4Hhn13Y7VXY9QHFy6jdZ
4858	fee_transfer	1608	13000000	1	CkpZHr9PHjNpJtrcJREpgYo7Hd4Z3EQtSfGnRorVyCtYvU3wCgUNz
4865	fee_transfer	1451	59000000	1	CkpZgctirFMfwaFk5dKBKxr3LRaevNFTarR7fx79KxTGgUe5913mn
4869	fee_transfer	1508	263000000	1	CkpaD463M4CuhVNstLT9U3Me55RDK79TbbwvLhW37WMrLDP91CFsQ
4873	fee_transfer	1455	906000000	1	Ckpa3dU4DWDgUCxkVTFW4LHX7coGebNc3yMuS5r3kBKtHkqqtGBHg
4876	fee_transfer	1727	24000000	1	CkpZrDGYMxtwQKyNrkKewXFFquKF5PXQBMEWrTzb9Hm7acggk52zP
4878	fee_transfer	238	1350000000	1	Ckpa3YCCR5CC7Q9QzKzmdbVFGz6i8Y98DEapbbiTGQZSmLRdCThVg
4879	fee_transfer	238	620000000	1	CkpYn3kauMG85jrUdv8DZfCFBDVGbXpBsPgL4voSVuLasY4iicohi
4881	fee_transfer	1455	80000000	1	CkpZZ3ncxCHzPNo4ChHUezQcqQ8DStXdoYcEDBiV69SufU2W4U9z8
4883	fee_transfer	1727	203000000	1	CkpZQdezHEnFEUdvpRmBewWYyr9pTHxaArT1fPKn6syouuX9Sp82y
4887	fee_transfer	1508	539000000	1	CkpYTpRgJjaxW4XdH3nnrRuHRzvMYMuDMWdcdHnRbj6QXsKnXAr7K
4889	fee_transfer	1571	72000000	1	CkpZPFEmDDpbL1XBSzyQMoVpRg3F1nzwfawguzT3ixVnFJtGLTgMi
4891	fee_transfer	1699	25000000	1	CkpZftTrjyLe1hHhZMfcxuBbzqS2QQvovu1NHfVXkEo7UUziwFHs7
4892	fee_transfer	1718	36000000	1	CkpYh3UabjHrnD4a9Yb5NaQsboBqiah3zhGqxYnUBEeamm3EG5MDF
4894	fee_transfer	1643	36000000	1	CkpaHscAoBX2PQeAP15RLzpBUDxpXrfsQwRMEa57mkbGv78pNqbHj
4902	fee_transfer	1457	23000000	1	CkpYaU85EJHVSAUwASWDeiE98idpGuRqvjJtQRN5pjqNMjwze2XSC
4917	fee_transfer	1471	710000000	1	CkpZGQ9E5TqqEcbfJU8DpcrMgZCb81JRx5TxH3fzZqduphoCk9qv3
4918	fee_transfer	1471	377000000	1	CkpYV1bJTLwNGebPgQudVS1iRbwFGbQQJJALAeShGQTW4hXyNRgs3
4920	fee_transfer_via_coinbase	1886	999998	1	CkpZFCiqi1F6FYyrvA3wsRmjeVrkeUGDCWHVSGNqTNug7NfvcTkxv
4921	coinbase	1560	720000000000	1	CkpZyDcp73ka1sMEE8KLgziM276YxNpyQn7QGhWAdmMkABMcBB5Sx
4929	fee_transfer	1747	23000000	1	CkpYzJZy7nPXg2TP7WThYbAjnYrXQmcyUGDAfw3jsmTC4T3MtygMf
4933	fee_transfer	1715	35000000	1	CkpZUTQuuPSDYwbnk6Hk8fad7pc22uKPhY5RbTqEJwmoFgJfmhQDf
4937	fee_transfer	1564	779000000	1	CkpZ77e4UeT3CQaayKP7axDqaFvbrEwaD7nryxWavSQYvgSx4mDdV
4940	fee_transfer	1395	3000000	1	CkpZJ9zG2RjQyrCqYxK8RjA4id2hDA9EpQXEASftEUibg1928KRAB
4944	coinbase	651	720000000000	1	CkpZdHGrsifM8zRDiJg8FZsjsXGprb6RQfEFfYnaTgYX7qiGcWjkN
4945	fee_transfer	651	25000000	1	CkpYfLmrL45weXemmm1w12CPgYJoF5Xrrbqx8ysJms79n6oBPrkGP
4948	fee_transfer	1694	49000000	1	CkpZwvFaBMnv61YnAFfYdmJtELCF3icAqh5P2k1GbDAA816dxhDWX
4949	fee_transfer	1694	25000000	1	CkpZFPaVotgLTvF7ict5p726VrFZgv7Yw9ix7A83zc8tGy35imtFA
4964	fee_transfer	248	70000	1	CkpYnaTaKbXCMgcQZduyfNxiSV1QgjR3rQgy7WheBAN4vizsTRhu8
4965	fee_transfer	1749	37930000	1	CkpYg9NCXj9euQ6UVsJ3aMGCj1hUuiV5Wc2zVTPxE1nLm1L5rK6Bn
4978	fee_transfer	1696	38000000	1	CkpYsGoMC85jJCPTb4441KiunBUH8szCp1BxL7SqZWybE2Vr9JSaG
4983	fee_transfer	1992	10000000	1	CkpYSxDJVdQkBJCbHkzKcXpM8nXDjEXADgaTP89T8d5TTYHNHkT5R
4986	fee_transfer	58	25000000	1	CkpZ4Rr4VEvi1YiweGWz4dntALqMZw3Wgq6VknQFJnpRRJtbWaDM9
4988	fee_transfer	1513	48000000	1	CkpaKTVjV1LR1YBpxoBeWaCJfKC1Lie5MqwJBqJJwuuccJKW87V2Q
4992	fee_transfer	1711	661000000	1	CkpZRCPJEDJBa5gRMj1CPmjCCUP7dfnGYMQpBrVEBoNbPts4tj8ye
4993	fee_transfer	1711	22000000	1	CkpYyC2CpkweNp7QrqoPvQe6ozBAfHEQJeQ8jnWQnGsFEKuzewrnu
4997	fee_transfer	1693	33000000	1	CkpZeRJWc3Q5Rf1mhUr6rVnvAFN3bps6WyTTYt7nF49vBaavbLiBz
5007	fee_transfer	1489	293000000	1	CkpZEE7pnqYTphbRQkV8bKrKhAiuf5CdXeuD8qd5JDUUbYpAdPHiL
5009	fee_transfer	2039	24000000	1	CkpZR4TWsBGZktxa6j3wPWZL8b5774r44ydKRz3B1R6jHrZcd2ifg
5014	fee_transfer	1508	339990000	1	CkpZomsFrVw2jeEb1CcdJ9V4CkvM3df2uCUfv7WAPxVzUgdcofT9Y
5020	fee_transfer	1727	38000000	1	CkpaKtz7oxUMyPMrjLn4y3AtVxTFnGLrWbaB1Brxm9bmmbWv5EZFg
5024	fee_transfer	1596	23000000	1	CkpYsecn3fzjB9fgE6MYEM8wXp9gMUGZXZP7ZSb1ohgXSpQGX7qwX
5027	fee_transfer	1489	102000000	1	CkpZ1nD15pniGTj5GVTqrrdv5jXEFR73uciKopNVMgJmPXXPMSdzJ
4862	fee_transfer	1440	2000000	1	CkpZLAVWAiXaMUM3rhxvFkv4F8ViusyzXGm33NFPf5oB2WzLQsHCM
4864	fee_transfer	1394	59000000	1	CkpaHpuEVjWkCtu9df1c6h4JMtY44LMPefa1mGzhVqbghNR8yjxaA
4867	fee_transfer	1611	51000000	1	CkpYyaJg25RJ1yac74JLDU2bdTm6zExrms2iL2PHDDb91RSSUtc3E
4872	fee_transfer	484	35000000	1	CkpZ3CSEppDadL2NXBXpRwSAGDUtCKCQrmr6HxbCmeF9r6bf45gtj
4874	fee_transfer	1692	37000000	1	CkpZPT1p855Fp53YupNFkJEzx55L2YuQcpFpZyK9yAw9zXo6wSvPN
4875	fee_transfer	1426	24000000	1	CkpYaN4454cieEcTW7KbLgB5BP64uWYikNUHdTjZ27BK7fPhycJQN
4877	fee_transfer	238	26000000	1	CkpZbxXV6MpHmZkzTfsUqCxsZb6TDFmcaBrskmMr7mKT8FrKBhkZ4
4880	fee_transfer	1719	52000000	1	CkpaBfsuf5Q7LcEq1RdHqQWmjCktxd79tM2StpQ38pZvonCgLNZFX
4882	fee_transfer	1649	33000000	1	CkpZohJ9MgC94sDoRg3zwFwXZ4HZNjaputR1WWycUTMXepKj47vm4
4884	fee_transfer	667	12000000	1	CkpYo1BTivL4i3a3pKZnfQAUoxQMKCYLD3GwFKPwm5Fxp8gGJQPtS
4888	fee_transfer	606	34000000	1	CkpZzikTHnX1zisvBY94MRkQPr5DSWmpcBF5rzuiJecGpKneQn9bD
4890	fee_transfer	1637	48000000	1	CkpZJBsGwJJMdvpVYQC1EjJoDg3evRgR5miHEgeG95fZgqZjcRgYV
4896	coinbase	1635	720000000000	1	CkpYmqmuYiSDKW1SXgvKXnuAe2UDFnj9Tu5ro5MeHHSXvJQmV3WzH
4897	fee_transfer	1635	12000000	1	CkpZdVthpbcv3QSx3tTVkK83zsC34grinpNrcu8QQmXaJDiLwiRim
4899	fee_transfer	1439	25000000	1	CkpZa2qHbQQX4h54jFbyMggJxVPxLWZYkB8kUEBQY7ttCqzh6U154
4901	fee_transfer	1395	1000001	1	CkpZDSRCfKLVPtpQV1RrCwib5dkDKr1vBjWPcr6KsnuWCUUEQRE28
4904	fee_transfer	1933	61000000	1	CkpZpZoVEPQMGt7spcuimrTpWT4nBrjJQnoy83T2WuF8yVkD3VhaR
4906	fee_transfer	1698	25000000	1	CkpZwhBKffZ2Ziba2k5SjSQiR6BrnDGCpZbaPBpxZzHd2RVd2fABJ
4907	fee_transfer	1555	27000000	1	CkpYqHVcxgvchDa2izM6Cv46zLvfoXLDm9ubAB3NbeBefbW4u8zrD
4923	fee_transfer	1654	640000000	1	CkpZz5831YbXXcuEpEUkQ7k1KjbweKUbsnszFwh2V1aUb3n5vHXX6
4924	fee_transfer	1654	690000000	1	CkpYbucZ7Fj4KH36zXgDSf8LwvVczDmsGpfVUjCJMLesduC3675TY
4926	fee_transfer	149	25000000	1	CkpZEQC82xf5fuX6jM2HhfTMtpxLNvunRNYmGZTUGuhvfHMwrLVwP
4932	fee_transfer	1704	23000000	1	CkpYtCEdWPJ38DGZkNtCydxkGTDnJP3GrcFzUKBxnkXeXrgzvWrnh
4935	fee_transfer	1430	1390000000	1	CkpYQx5T4bJC3PJqaj3ZyAKwbqXztpAmgihWaxFaXBBmm3TFd2dFf
4936	fee_transfer	1430	570000000	1	Ckpa3FtPXB6juQcoMBijv7TiXQ9WBxom25WGvunLQWhLwv9wDN2cY
4939	fee_transfer	1472	3000000	1	CkpaHQC2BXShgq5H5LGxXJjHeN1tN8MS6gvUSJtA1nP7NxqKdD3Ji
4942	fee_transfer	1564	69000000	1	CkpYfbUSP7TF9fGA1n63i2tkjvZhp5MfVx2ppAxUWsHGkQPhAC3ap
4943	fee_transfer	1432	12000000	1	CkpYRv8faX3or3GjxBwEWvpN7QkU9ZrW3ZWfBemd5oXvPT6YC5ZxH
4956	fee_transfer	1680	164000000	1	CkpYUGxQ7XDP1tJ4QsJi9sZpuoCfpqCZRemz6j2ovKnpERKHgbmDT
4959	fee_transfer	576	152000000	1	CkpYogqoTHp1NkyMQFSQfN3o2ayosjgVFoQpyPvQ5v5uYzmLFVRjM
4960	fee_transfer	212	1500000	1	CkpZ7EcsEgTt2JQLpGuYur2E6und8LLXNBQQkPSfXje3eQGm4QhSr
4961	fee_transfer	248	210000	1	CkpYgmm3vEwbJZVcMxis79VSykoEo2x2P8S5SDYZqwoatNSXMWYd2
4962	fee_transfer	1749	6590000	1	Ckpa5kknjqcmoqBVHke8akjwidJ13FgKaazAt3W2xcp1K2x6jeR8Z
4963	fee_transfer	2143	29700000	1	CkpYZDLzXBR8KrYKJ7RPgTXJJ4puFNEnf7BpcdyRBqsigYrxihgcA
4967	fee_transfer	1271	11000000	1	CkpZTT79gNXnhS1NV5X5CcbxM1aPH8eaHekePCdJ3mthHyEJmuf3h
4968	fee_transfer	1706	1214000000	1	CkpZPKRZpEE9kJ6W8cHJeLdJYtP1Ev6DpN7vFvu2ftConcykAog88
4973	fee_transfer	1471	720000000	1	CkpZsgZzBQgUTKTnEQgbmaqWzEbKMvSn4yvjuTtceMMcUp3AwRmgW
4974	fee_transfer	1471	341000000	1	Ckpa5vWHDtMb4x1ttWLMNLU7BsBY3LVb6wrVGYTy15tN7HWdvtL76
4976	fee_transfer	1471	48990100	1	CkpYSDYLYRY4EKBC3tDn6WE6XdVQDJCxX4nwY9www5SfKyb61a4eS
4991	fee_transfer	1601	3000000	1	CkpZCWfJYTfpV2UyDBPTgFcWFVWxj5ySuf2z6jAFv6hE5Uq9BSruf
5001	fee_transfer	1573	22000000	1	CkpYmZqYVEEzLpH3kCU251cpQg3iFmLJwLJADqXDBTdML1AkDR13b
5011	fee_transfer	1980	460000000	1	CkpZqQb2Sz1G6ZC46WgD4EKTJambkUvj5ea6B8XN3Lj9ugVFbDg7i
5012	fee_transfer	1980	502000000	1	Ckpa5kzPsPpZZ2hpMhdJ44sxvkTgvDXsZMF5wGEFKQxadaJ4WesW3
5015	coinbase	1440	720000000000	1	CkpZDk3w4Aur1yVbGwKEaPRAciQk2rCdnu9oeGrfSxHAweDS6QWxt
5016	fee_transfer	1440	999996	1	CkpZfT5Njtck4niej27HFeWhrZwN3j6X5jX54wqi9GM932HLEB9WB
5017	fee_transfer	2052	4	1	CkpYbXxvRTNNWiNe87T1kTiyZR3cVdW1vtZrsm653dZsXuC8DZtf4
4863	fee_transfer	1444	59000000	1	CkpZGhewoYhthyiwRD2Qwr36FfFtnXtEZfzFGwSst1DvJiqFVpDtg
4868	fee_transfer	1622	49000000	1	Ckpa13zgo6qmaigbhMawaupLDZYsLLZJHAKQJkWRyz3WqNW313SSY
4885	fee_transfer	667	880000000	1	CkpZp2CCgj7yYZ677u6FWG4351vw55P7eDSVh62ytQKy7d2Bq1YCc
4886	fee_transfer	667	80000000	1	CkpaFoXMRzYsv5oCSrWrpvj9jRSaouYmHKarT9ZZhBr3Xd9sfAuSm
4893	fee_transfer	1541	36000000	1	CkpYxsN7N6xLmB3cU2qmLnNgRewGmW7aiZDAKcGS6cMS14x7hMeDx
4903	fee_transfer	1564	1270000000	1	CkpYrHRm54XCTU1RYLLjb38wZTcwiEwKQFVNpMn5i7MgQhnQ8QB3B
4910	fee_transfer	1727	230000000	1	CkpZoVjbbyo5Jkn7qdSftZnCzm25QX6uK7qjoQTfFYhXo6rB2xN9a
4911	fee_transfer	1727	443885200	1	CkpZZkVBLkyGiWYZ6QBW28YFCyV1GJfydguTn8u8UDUCe7acCjXpm
4912	fee_transfer	1420	990000	1	CkpZcpeG3j2hTc5VZUVMA9TdGSXboUnNpSErmDdD8xr9Sb7mHShad
4913	fee_transfer	1447	4995000	1	CkpZWRpERbXXW9WoTEpFcB8GMxCM47EGxUu8mWYZ8SKf79qbM73r5
4914	fee_transfer	2095	10000	1	CkpYzZuc8Cu6jobUUGDnrLLCpWMHKe6p1cMTRmjGyBobXpc1qbbxC
4915	fee_transfer	1514	19800	1	CkpYdt4kS3An4v7UyXsieNiPXaz73q2S71MgWZZFCwPPsSQphpHSc
4916	fee_transfer	707	150000000	1	CkpYQay95eM3JAgdDhd7udPmsc7vGkD8yHAvAd315vBPm8u1qBoPG
4919	fee_transfer	1685	37000000	1	CkpZKHp6UGUuDsUEg4ngBhD12zuZoGXk8Rbpjq9xUvNaMp2d8Lq8q
4927	fee_transfer	641	25000000	1	Ckpa29w1bY8rCRZpPn4LpRHHU7VKvdEfvwxCvA15WTd3RP4tXRANu
4930	fee_transfer	1746	23000000	1	CkpZiwxpf2955P4vzU6Mr2qagnu6yJWU51efApRheosAUEguyMvKB
4934	fee_transfer	1571	35000000	1	CkpaG4kWvXimWff7shFmJVF3KW41PtAieDki6K7XyCkeFeDPb1XnG
4941	fee_transfer	1394	3000000	1	CkpZuxNB7H95rXrdpCtRFWSrRSXUFoJU9g2GvQymCkjRsJR8CvtVy
4946	fee_transfer	1508	25000000	1	Ckpa86opamAcB7jXQk8fVidTLQoTG2zg17gXm6sCJrWUQ84x2aApv
4947	fee_transfer	1508	1066000000	1	CkpZsQ62R5QxpmfLADSdDZUyQctKPmFdMrRvxapnLRmZVQM8RiUu2
4950	fee_transfer	1727	10190100	1	CkpYvLipSfWJXSXkhyxpy11TyVWBiMTKHz2ZRcyX7cis99pdF929u
4951	fee_transfer	1420	19800000	1	CkpZAmHoG37bzXhG8P35vjE8DVyVV7EPMbJqRBdhTsszFdfEzQ4er
4952	fee_transfer	1514	9900	1	CkpZv4n8kcxVNjyd6URr3kyCayCsuW1YCaXAmJjutNuCYaRcSHwQ9
4953	fee_transfer	1727	305002000	1	CkpYgdXazmWa93TtXkXrq9pJeZBW22QnHMvX2bThp1ELXVLLNrJ7J
4957	fee_transfer	1394	164000000	1	CkpZP7vvu4dUVBWYusUpBGi15FsTBHZPvsdGUzErU3YsSEuHSSb4A
4969	fee_transfer	1706	430000000	1	CkpaJHfLVtpzQeLDRtynCXSdzRGVqqZtVAmx5FEsC8QLMoECUXAHC
4970	fee_transfer	1670	25000000	1	CkpZ67fa9GjFjTgX21it6agGq5e8CypC1BAZYguq5G39vUKCbaqtL
4975	fee_transfer	1471	49000000	1	CkpaGdgM7GdLhDsVAkiwyf9CE6vCVNPrmdw4YYrFd2GkT3d11SDrG
4977	fee_transfer	1395	36000000	1	CkpZL4LZchsVEpBpG9q64YFKGdk5S1RD9j9zU1VpNuxUouiXxE9b9
4980	fee_transfer	1711	1120000000	1	CkpYrqqNMQsvJ4AFdfbYK7eJapf7NzwyZ5JLSWVh7Ea5VWy7JUr6X
4981	fee_transfer	1711	220000000	1	Ckpa3wNu6dmBxXvWGaZNZvvZyMAY7AEjzCkGhzXCGNVB1xp57CZSa
4985	fee_transfer	1709	37000000	1	CkpYkuGdUJW9ZXniWVCrqoWUTgeGwi1uRrUaddsovvQjkNv85WCmN
4987	fee_transfer	1555	25000000	1	CkpZ9LpcVVSbwyw7fcWo6RW9ZD9vfbCRQrqtkniDpJWYKgncP5Qjc
4989	fee_transfer	1458	48000000	1	CkpZPqf7j26VbKtV7z3UzZYoKbfs5xVhamBHAMovW97xABWef2QYp
4990	fee_transfer	1601	84000000	1	Ckpa2q94q41wTL9GXGiByKnzfnAsS5F4hwBcsD2JGk6Y5nPkQ1ANF
4994	fee_transfer	1560	23000000	1	CkpaLG8xDLPabc88WPH5iLWMXL1Bt83evpitdaewrjmCSiAzcRqtu
4995	fee_transfer	101	33000000	1	Ckpa94tTNeLd9xhQgejGRw6vjjT1jtgNW2t7c9c6KHw56Ay3SdU6T
4998	fee_transfer	1571	33000000	1	CkpZ4tqU76MeGybkpQLFKEBrmnsgChgZuAooPdg3oHpfMR5X1nQmG
5000	fee_transfer	1599	23000000	1	CkpZcRiiRYKP7M9NgHDReFt9miBAuj7TqhQYwWPxh6Frw1vvPxLX3
5004	fee_transfer	1395	1000000	1	CkpZfJMvoAfpZgUmrGgZYgcMd7veYDu8LKFCxBsRGHNRzvBBPXRsL
5006	fee_transfer	1740	2000000	1	CkpYzGCMjnzyochb4GvoGX5Wk2nUoP6XcbRW6uJ1ygRprz6SAqWx3
5010	fee_transfer	1611	2000000	1	CkpZ2L34wa1aLXuhB9zS1qoAShC6mUe1NPP3r8sm7Kkh7dFok291g
5018	fee_transfer	1440	49000000	1	CkpZpTvrNXEokc22yB3LP2vLvaewg9bU1YnHiLyrG7PP41wcsC1XJ
5019	fee_transfer	329	12000000	1	CkpYotTTM2ah6JGLFEsZgxgXg65FzezDQZ4Dxk5SnGs5UPRkinh6f
5021	fee_transfer	1564	22000000	1	CkpZcStxa6zejFy8zZ7ycV3NYJe2KLecyrufXXiS5U7Qe4EQn8Xfd
5022	fee_transfer	1489	390000000	1	Ckpa95n3bX8tyPDaqG3UR57gVh8DuCHmwY5jr6d9w4TCktncC9DBa
5023	fee_transfer	1489	122000000	1	CkpYXEfcUJhgY1v9kUBrGs2q647JJMjBjD5Wgr1vMzQffrBVvZ1qF
5025	fee_transfer	1489	23000000	1	Ckpa6Tu1Vk9NfiGC4iWmeuVscsECvWaoLbZHfvm7qoJiG28jeUDad
5028	fee_transfer	1513	10999999	1	CkpZPQ86dS6i3QBjXT4HkCQiEFr5zzm5Xh472LmFmhXPUykkqt3Rx
4931	fee_transfer	1587	23000000	1	CkpZvm4HRWodYDTc2UFKJx3WN3KcWaZG7mbzvfM8dpbtkuswp6LK8
4938	fee_transfer	2029	3000000	1	Ckpa1KDUPXYRh2b959hfjHEcbYYhRZFxiS5iNycHJWLR9CJnR1gr7
4954	fee_transfer	1513	224000000	1	CkpYSJ6nxXy2grFhDb6b9pZa6uoqN1z6feCHTS8WE1yUM2R9c2RxK
4955	fee_transfer	1693	112000000	1	CkpZJNih9RdCNDpDoBGHoeheJdLxkpp6eTVB9CYbSYp39K14pWiAN
4958	fee_transfer	1690	164000000	1	Ckpa3VA53m9kQ1x58gsH3RZmDYcg5SYov85cmH3QzntQV36GCUSVD
4966	fee_transfer	1749	38000000	1	CkpZfctGVmo7vpWWCVCZ7HPqRf5Yxr5PV24CwyUqErjy8FLxJF4br
4971	fee_transfer	606	190000000	1	CkpZu2hEehNTG7LPyLXV2nswd9TjYF5zTPqNqAhJsZrEVE26eK4kQ
4972	fee_transfer	606	124000000	1	CkpaAhaFQKRhAdn8DXRaGLuUst9BuM4Ut7jcGsYbJC4UGcNvWrPkL
4979	fee_transfer	1717	1098000000	1	CkpZ8VJtdHi7hxpo6iTtwCo4FHTZ2JZsusw6WyQpPv3MDQyQX1RyT
4982	fee_transfer	1457	34000000	1	CkpZCCkrzx7viQqJ4LEeaV5F3vF877Cx22nZpgkMD6dRc5wcYQ9is
4984	fee_transfer	1992	34000000	1	CkpYQL5ApNh42jchMARxR9DpM52U6p3tbac4fZoVdRKNeARkeg8XL
4996	fee_transfer	526	170000000	1	CkpZR7k7gRWY5uewqKBqfmNqR9WdhdZNsRgoNcjm2ie5iignGibW1
4999	fee_transfer	1474	33000000	1	CkpYwhKm3ErnPqo7HX2zJoGfcaR3aVfvxGtqTEezXwYLw62n2CT5C
5002	fee_transfer	58	23000000	1	CkpZ4E3HWimh4ZQUY7ipSoh4ob2NF9cgshvtoeyfivjJ4t9Szwie1
5003	fee_transfer	1610	25000000	1	CkpZcWGcrG8azCTXBNw35E4z3dQvH1MBrZc7XJyqQVcWfwjRiB1MA
5005	fee_transfer	1623	25000000	1	CkpYxAqZm5sM7ZypTdBrhG9XGSRg94LQHqZfHpPfX1Wkmib3L93eX
5008	fee_transfer	1593	2000000	1	CkpYy8M1Xe18GW5FSgU5mQ5dcsfMbU4ScKCGLDwViQHfqivSRykpM
5013	fee_transfer	1696	22000000	1	CkpZim1Jz9SwkbF2wccibRBte53bmCPu34itfC8Fx9PZRqhJaJ96s
5026	fee_transfer	1657	23000000	1	CkpZvFpPXPuzh5ZX2snMgy8beLiinjNCH9Jcb8hQQcSvphFRSTSBw
5029	fee_transfer	1695	31000000	1	CkpYhmvDSiEhCSLKwkQChMY3TZbyXAfn4AgqerdzwyPuUJB6QWZXv
5030	fee_transfer	1719	22000000	1	CkpZvjvjpztskHBCDVNgRpKzWxTj2NCp5pP6MiCvpuUV8zSXv2yyv
5031	fee_transfer	1695	22000000	1	CkpYTFnfasdoUdkhEM7LXiLUV4XJ7JP8QN9DnCEztjrSPaE3P21Qi
5032	fee_transfer	1633	3000000	1	CkpZHRGZxN7c8vmypvkv9bf66QHYgiXC35eB8NpL5SmERcjsV2zxE
5033	fee_transfer	1610	363000000	1	Ckpa9wxGzYcMjjbcKuUcwXtmjCZGiCCUs2L2Jy479L4XRjsX6zenc
5034	fee_transfer	1489	70000000	1	CkpZqgqya44vmeeLVMbnS46qnnjaJ8C8WsFMCNrMjH5pfHWFKuH37
5035	fee_transfer	1489	100000000	1	CkpZaLhmU5ugseK34TEu6t4HbKmyUWnAzRFdK3x3CWn1VodG19dKz
5036	fee_transfer	1850	21000000	1	CkpaHPf1ZiFxNNfqcctZGSZ3WoTwZRngtSvMysre8hGLhfUZNihck
5037	fee_transfer	111	12000000	1	CkpYRAitV7xZv493UFosQXP2C93SWZvKaHtqmCo4Vt5hMaaNYQYUw
5038	fee_transfer	1689	21000000	1	CkpZ2GU5sXjtvd1xeciDeAdnwzNo5kGiDxpnW4XNxHQdX9Q2b15zw
5039	fee_transfer	1608	36000000	1	CkpZWkXsHhcmToPpAw7EtSRx6BCUczSXPcTYoMZq4MyNrNvCcaHnH
5040	fee_transfer	1749	23000000	1	CkpYmmhPovTMHn5bJXiaGfk5KjXLZmWaCT1UkeVqrWUdWmZLZWrZR
5041	fee_transfer	2148	13000000	1	CkpYfbLcMLPygH7Q9TDviRgTyHWgo3B8PVcLoVx47SGyYhzGtZuWK
5042	fee_transfer	1471	1010000000	1	CkpZoUtfzAmC7ebY6DxMbEq9tLWkNLomqn63Z1Yd2rr5zQ9LvnSy7
5043	fee_transfer	1471	195000000	1	CkpZHkMRjnwiXM5mKfZBSRRh7MTyYmshPcQdYVXGc6L1kUtaAnYkw
5044	fee_transfer	1564	37000000	1	CkpZAeHsSAHJgdiar7CPphwPuccpvQDPV8HD5xZQks6DfMEaCy28z
5045	fee_transfer	1455	37000000	1	CkpZjXxr1pz9uSsaLykhrPAiVMfhmULokQiU5TmZNogG8ziaQWRMa
5046	fee_transfer	1593	124000000	1	CkpZvVz2vHv4k5tSpB4Gw2EKc9rLQPJGUzBbLc5dyKpq9MfvLgMxo
5047	fee_transfer	1711	124000000	1	CkpYyST18ZzXLXQSp5WR56n5ho1MvWEb5nSCff8QuFedr56E72STj
5048	fee_transfer	1448	124000000	1	CkpYiWsiZ5KYcmi2BPnWcvxk8xgCyyWDYrYxDEeefjpAb3wvVP1Yq
5049	fee_transfer	2106	124000000	1	CkpYUwY3K5KqVCu33dXEp2qZuZBC15Rpfupq6uFjua5h3XwkuJAK6
5050	fee_transfer	1419	37000000	1	CkpYif6GGdVyQaNjosZN2hJNPBnwChLYhrkWqtJXPQabyJAzG4WJH
5051	fee_transfer	1571	864000000	1	CkpZdSTvKtzEzKBV98QUz4RppknjW7D2TbsF4DGQGAc8wo5pGkWCu
5052	fee_transfer	1596	37000000	1	CkpaJa5yJ8oQLMnNzw2k9iLBgBeYvAubkCay6kqzPigTqBjeXtM1G
5053	fee_transfer	1426	92000000	1	CkpZJWbzvAibgJws2ybW1kSxwV5hc44HEVt4mJXD1hszJd8634e4K
5054	fee_transfer	1426	25000000	1	CkpYW7LNoDK4ZdLj6bVf9bNCkGUdF4wZpka9ZJieryjUZQW6xLrSh
5055	fee_transfer	171	13000000	1	Ckpa6ngTkiCW3n1MZGYvHzrhzP5cLrzdQ5jUSTMHa9wy9FSfxMAdx
5056	fee_transfer	1599	15000000	1	CkpZ1sQrs7gaysdYLuDdv5E5DrXMGFbcwom8n9Ge8MFgZXCtm1rVa
5057	fee_transfer	1698	15000000	1	CkpYxqR9Aw6NsjngzZYDrsQnoffn83mrrXXD9eLkBpbkPBSazVhrk
5058	fee_transfer	212	4000000	1	CkpYuLjKKTtPw4AuYArw8TTU6Y4YxEG4EnE7o1rRKvQGQ5SYYaVcG
5059	fee_transfer	1440	49920	1	CkpYwtnwXfrDfTfX22yTR2Y3GMjLQzELFVuKtrQ8tv2mV7Gs7T2pM
5060	fee_transfer	1420	21780000	1	CkpZX5kdNRr92iHbLqCNCF8L2qnLVQWbV33zBYrsACQZqbnian1Jv
5061	fee_transfer	2052	80	1	CkpYS91HvSMCfxUQXfr81mJP3mMboowZoMB86geETMcpBPFS8VdXs
5062	fee_transfer	2095	170000	1	CkpZZQc5kaY4qCaAZxZFauDDDZnsnaMkS9UMokuaP3XhBottvChF3
5063	fee_transfer	1440	36000000	1	CkpZ6Cy7U5HfBixDor8wuUiveaNdPRzTJvJzDD6fE5Qev2xjM2RN1
5064	fee_transfer	526	83000000	1	CkpYfiNZHexY6PWUfzAru6jhaTGtyYdWMiJZ7u6JxTUfSQqXonTNL
5065	fee_transfer	1762	25000000	1	CkpYyNzWmwcAtqPd5J4w5SxwmtFPCp3UKqNZgzMbRVP6Sk6Wfp3Zn
5066	fee_transfer	1509	24000000	1	CkpYrA4GLCVTN6AyEToR19TTZH4H8WbeCoiw685j2NR9uPDJSTX9E
5067	fee_transfer	1681	24000000	1	CkpYcM7Ght8b8kLyeMfRqbBwwdqbZTdMTrMe6QGUCXCwZE2cvMxHL
5068	fee_transfer	1451	5000000	1	CkpYwA8cB8xcFPuEmyU5kKF6ZXqaGauLPnRVrBW2hJt6xHyTxH6nd
5069	fee_transfer	1395	20000000	1	Ckpa7g1niqYm4vFU7uazm7V8w5QScVKRKtbrRxSiZKS1fnnVC8pKY
5070	fee_transfer	1395	5000000	1	CkpYk63edStrCqEbkam5FoC4pN87Ev4JmLpMYuzUM43BqPqgx3kMq
5071	fee_transfer	1476	25000000	1	CkpYkeSoYZJHTHL6wQ1bJNyfY75hMvwqaPCBtmFEt4uLkPdA6p831
5072	fee_transfer	633	2000000	1	Ckpa2fG6L4eEj8fJ8uQdxPcNp439sX6Ernvp7XgzdikCvD1PkQRi1
5073	fee_transfer	633	1060000000	1	CkpZHZD7vDYGJhFJTDdstcFo7p216RmP8gBJRDekSuWY2nn25kFWF
5074	fee_transfer	633	190000000	1	CkpYrf2MMhrYBuwiq75YCWZ9EqkifBBrfZMPbwd3rzeWPLyAMwF9F
5075	fee_transfer	2148	24000000	1	CkpYTLvXvcddh7CsLSEni7Te1Cc3uxebqq6eyGccfV21eUXEpdLx3
5076	fee_transfer	1768	23000000	1	CkpYZYokr4nd4JRCx3FJJU92pCvATnTDqqBPaUgdEPghRZdnDMNwC
5077	fee_transfer	632	25000000	1	CkpZwBXShzWn7pde9ejQM6mpvbM8WyNztGBiKm4szGLUeMz7y8yRm
5078	fee_transfer	1649	24000000	1	CkpZVzvhUz4qkpsrmdtUMvpTaScQJKdr4VgGnqzsexYx8Mp7SSLn7
5079	fee_transfer	1991	36000000	1	CkpZsWzY3g8skFW3vncyRhn1ANNwt3aJaro62GRTZWcTaeNdGHfH1
5080	fee_transfer	1991	24000000	1	CkpYjM19mhcDyFxqCXaEPoWCVQshhMgQ5zqrRQ6oNK1DPoaD2itFN
5087	fee_transfer	2112	1000000	1	CkpZFpPaks7jokpozGc9zeDBJzcycX8ahQq5mdkNXXGb2qn4b8dZy
5089	fee_transfer	1394	124000000	1	CkpYwfp8fj13GBN1QbxiC9f1p8Wakk5ZpjhAJv6kcsMFF61ESS3sU
5093	fee_transfer	606	377000000	1	CkpZBn6ngSrjRyABJFfqqGfjigUVPsNP4pnxpVgWkE9r3DqvUxq9n
5094	fee_transfer	606	5000000	1	CkpaA2d4ba52jfsMqHMAt416KcfF4jFgi1vxg9evXCQVXhAigCRHc
5096	fee_transfer	1740	812000000	1	CkpYkeDpMvALopi9d5qVC4psLtv77brgbHfMpM3nNtXzhVDiv1GMq
5098	fee_transfer	42	22000000	1	CkpYTa3LuckpgCbdw8fAMgcHtcEpApZ4w2qcoRmdAKnNWw7omCSEV
5100	fee_transfer	1764	35000000	1	CkpZutrHVqaBo3zwMY1JrcWnxQdzi6G2GiD4eTfGG64mb4CBy8QwQ
5107	fee_transfer	1588	180000000	1	CkpZC3iPCFqQ8vhNDvDWdMYTCYZsDz4YNKpFzia6koZ53zkGJa6Ay
5121	fee_transfer	1489	324000000	1	CkpZW9dvhVzVjcVrAyBJmzS1Tc3wRvFGjuHrP2hEHL4cj37RR7inA
5122	fee_transfer	1671	22000000	1	CkpYTUf9jpVNKkjtVumy5atBbKHQHVDTx6yhC5GckSZ7cTrbh58PJ
5126	fee_transfer	1395	111000000	1	CkpZRTKzk8Exk7qav6NcFLAV6LgpqYNb56X4eFAv1BvW8gWuw4JFn
5127	fee_transfer	632	234000000	1	CkpYQEVKzxXij5kaLbqp9q1RGS3X2PrbcTAbNknzD3eDuUCmCBehR
5133	fee_transfer	1476	62000000	1	CkpYg4EDcYoMqFzhSLidut2Qfv2NZy7FZeT1cRhU1rmdGVwn386Xv
5139	fee_transfer	1850	72000000	1	CkpYfVeT9qJxXsQof9pNnUCSuBjxh3kdrPHtWr1S5Yd3F8csJKvUK
5143	fee_transfer	1759	23000000	1	CkpZNsSgxnJKVndZJpsRGaX1ohWYrNtYcTNUuPxvWYovDesnce5sU
5146	fee_transfer	1471	82000000	1	CkpZDfL6BrMvQoGpPCv1U1bPVcWSbrQY3ueaaUxY4yY8Yz2p3cV9y
5148	fee_transfer	1508	236000000	1	CkpYTX1jjNdpR3Xuy4Ht9UU4CJsvsYrUk9VDmA2peyXZpzRdBiLVE
5149	fee_transfer	1594	236000000	1	CkpYU49W21GbWqiUvyVU9fQ6dLUXnMcoX2pGDLMirwZ14LJxkyXp8
5153	fee_transfer	1573	62000000	1	CkpYvpRoRa3jRpJAf5b816eoHJ1FKpYgvA8yTCMFF51vsPXhpyqrJ
5156	fee_transfer	1747	62000000	1	CkpYQMrReTKtb4GFkFCSENSBrcThMnTMfMQW8vh9Gr1kZPx9Ly5MW
5158	fee_transfer	1704	51000000	1	CkpZpFp3wHBZbrXJVB4k5dd7SkUAXGQ1FHPPLXLTZwCMNqSUB1irZ
5162	fee_transfer	1402	63000000	1	CkpYgYi9K989G8CUCHzDW8WKrixxtd5o9P14U9tdR31YV4SEogsrY
5171	fee_transfer	1509	36000000	1	CkpZHYU6gFbobvxCr5YmMUEwaHwVqn365tAFsZbKrLgS3tQvY2ybL
5173	fee_transfer	1690	36000000	1	CkpYfDESCNbisfZBJY9cTHQwVLFyS74v8qNuohs65unhfQVjV8FfS
5175	fee_transfer	1637	14000000	1	CkpZDCCTcCMmhXoeBNUYdce3tTMRy12RQtMWximK3cf7ao1a8dVdN
5181	coinbase	1740	720000000000	1	CkpZ46d1NfeyFkFDCc64XX3WEpFpHjfogrsVQMserEzqXzA8qZoCr
5183	fee_transfer	1559	24000000	1	CkpaDL3fEkFPtjHQdXd19oZCASVnLCj53Go3nDshdibn2tJxMwU5L
5192	fee_transfer	1513	530000000	1	CkpYaRhcxMSdjfHsGcXKkpuGfceHRggdvrBAmq4dJu6fmAxeN5yq8
5193	fee_transfer	1992	910000000	1	CkpZgRsBxgGWxxAuGtEGG4yLcZ18xPugJEAUkeCziTjsGmgJXUqdD
5194	fee_transfer	1992	430000000	1	CkpZSSYi59fPviDgmyMiEUWuxDgZZW2e23Y9TKa2iYE2yS7HbQDRj
5199	fee_transfer	1695	530000000	1	CkpZTJAvzDFKeAVu56YcyvePdH3GxHYSFoRSNfzq1Bn52TQdcsVKN
5200	fee_transfer	1695	900000000	1	CkpZJ7jQ5aaNtBuvM7gvdw2cTpur8XzRetq2VsZoeiCYm3s498seV
5210	fee_transfer	1394	52000000	1	CkpZEgjkGUpwJs79BCEhLjMvu7ie4JaK6Kzp9dYifFKT6Ty6nS8Ks
5216	fee_transfer	1695	350000000	1	CkpZp2F1vyYvzD8dRNaZZNBhwAcrgq8K2gyG4VEVuyz96Bfdr2Kti
5218	fee_transfer	1933	55000000	1	CkpYru6rp2ci5MyvvGSH5UDaGkP97m5pTtXjASqwxdcNPvc9pLeVi
5222	fee_transfer	1564	88000000	1	CkpZPxgKMuYXjAA6A96apHVwDJuYiUCrQ118TBbgTSrHDj5kftDff
5228	fee_transfer	1672	34000000	1	CkpZHWWsKivp85cA6mHrRMXfvaU5vHkvfH3Dn7Jp82MdvahBggHzV
5229	fee_transfer	1759	34000000	1	CkpZTxJjK71u8YpvGuorQRUZs14y3X5CLzPbDvKFN9ytRF9EQdx96
5232	fee_transfer	1637	35000000	1	CkpZdnJATWFLnajeNUbeTuB7QnkHZz8FAJMqMVYQ2rFa9QnrJ3yo1
5235	fee_transfer	1692	47000000	1	CkpYQqS13n55tXkJEy2khKzfpKpnDgUDvvWK54xhCQi61JPcA7jQm
5238	fee_transfer	167	500000	1	CkpZmSPV3w81FqFiZubvR8Ms4zAtcF9ue7gKZrU7B2HJuBhJ25Dob
5239	fee_transfer	1724	1500000	1	CkpYSANKFPKJf9iZGMuygFBfKw5P6xnHsTL5ZwpiCFd86Pn5iLxbS
5240	fee_transfer	1724	23500000	1	Ckpa1Jye6w7VZbxZmovJhsPpuEmSXzYAoE2epzEasMkzZJCqhuknm
5246	fee_transfer	1602	48000000	1	CkpYrbUX54oeete35mKV8EdueUKKmyEoWcpEEsBQ39Vjg2aG7XBC2
5247	fee_transfer	1455	25000000	1	CkpZf8J6ZrWqhA4KaXCdpKTvdzbpWRePZK9yRTu1PcYYNQuBjV29J
5249	fee_transfer	1395	51000000	1	CkpaCZitFxwzs9NvQwmMwc3eYM4FJbxBLUak7357PHjnN36VXt2LX
5252	fee_transfer	1608	24000000	1	CkpYRGpfgtetc33qy5wLpbqpxTksjnXq4UBCAxbmzZTxWJANFLNEK
5253	fee_transfer	1540	12000000	1	CkpYoXaw3PdgDmxKV6jXZhkdYbwKJ1gmH4G42iL3N5oDvTgY3C8R8
5254	fee_transfer	1716	25000000	1	CkpZn2PyCdCpi5am9NT6gWp7ARvqvfxxHB15PhQZQraqJuHozQjZv
5257	fee_transfer	470	16000000	1	CkpZ8Ys8oTijKLv5xoXyeMWV8HovLMRMFF1DN5ri5s1EMS6Jovmum
5276	fee_transfer	369	25000000	1	CkpZ8FVPb3K5oVVCjiHuc2Uik1VvuWRL7KpdmnfoehQgwcQ6bgeQx
5277	fee_transfer	470	46000000	1	CkpYYcXhncE1KNxaYGWJ8bAXAMo8jzCfhRizvX3fTGrmHsymabPXB
5278	fee_transfer	1395	15000000	1	CkpZY4EtGc2ZcCXfdxGbD62pbYTkwSCjeaCafcmJR3UpcMbkezMYo
5292	fee_transfer	621	24000000	1	CkpaA16Kffj7LBPeyrccXvQbTrwz17vH13W5jHpHQwfrxsUjnDcoi
5297	fee_transfer	171	37000000	1	CkpYeUvnGffqS7wCYiEAgWZNFZPmy9w7bFEszE3iXVyWdjFpfv3DL
5310	fee_transfer	1696	25000000	1	CkpZhb8p1w9KcjcKxMU7uFxi193zqLqKmeYhZpGBb5h68VeGabhzD
5319	coinbase	599	720000000000	1	CkpYr1Di6NSeqEw3uHyM7uByPYYByoMTbYi8hVBycxSuuqi7dPmDP
5320	fee_transfer	599	12000000	1	CkpYQSMLh4UsfGdN4PryKoTCF87eMhDbfqevkzn3qvM7qFDM66FBs
5325	fee_transfer_via_coinbase	2123	1000000000	1	CkpZgvxQAZZvbguKdK285pUUXgiro2nPQgVaZCniyN6HbShnzdAYe
5326	coinbase	1637	720000000000	1	Ckpa6pqRf4hvZXpcT4fQXFmG796cEiWQfmvLvDMTmC7qjxFqZmuXD
5327	fee_transfer	1560	79000000	1	CkpZub9UkTzKBh6dWsmDPgzr1SuPzFVHsb8AjDwVqUuKLGa8EAJK3
5331	fee_transfer	1555	454000000	1	CkpZ5bpJS4yQZfGKza36NQAVyEGCo8TUPcKLR99KaUrtnqVvWS292
5350	fee_transfer	1688	21999992	1	CkpZd9ap6jC9t1ZPmNyQGpQHSkcUXovpaFNHzcu6bJtehauPVucwH
5352	fee_transfer	2145	1000000	1	CkpaBbFJg1wYbdq3tTCGEfP5qhEe2en5sL9QixoWsr3JofeZ8bHyL
5353	fee_transfer	212	3000000	1	CkpYg2BtXny7FSnNq6ki5VQfQXjuSo9mVxYasZZSTTuJ7acYS1Xdp
5354	fee_transfer	641	13999809	1	CkpZRp14WqDQ12MCAR1qYTukrsn34M513pgQCPhLdiT2qQrLJZNey
5355	fee_transfer	2116	5000000	1	CkpZ7Kx2J5iPnxHJmcj39TB2L9hv1jAKZAgr4cgsmjubETeuSHApV
5356	fee_transfer	2097	7	1	CkpYcZiZ5S3EdLVQCXADmRoTGAweKSJGfey271uUpQRk8PTKU8FzW
5357	fee_transfer	1964	8	1	CkpYy1hj7mbh9hV3iXgKPd9hCfjhArntAvADKAwVpXUVJcSCnoNUL
5081	fee_transfer	1455	36000000	1	CkpZtufHvKvrPEFrhibYeQk9Cx1Y8Qz9ekXXTeiUJE8ZCHK7F8pAR
5083	fee_transfer	1394	48000000	1	CkpaLHMhTviLRGYXz6AUBxLiJJiTBoTbg7Cnc8MwgpFE5mMtPtqGx
5088	fee_transfer	1546	1000000	1	CkpZVjqJqQNZDkZ8cqLoDzqYjkr1zk8EnFwvobxZLqf5dbkHFBrJK
5092	fee_transfer	1749	124000000	1	CkpZ8XhW3XmcaMVZZYfzaYsrvVH3hLvxJjAp2gHFzBz19h8RHduBu
5095	fee_transfer	1419	812000000	1	CkpYkueXbuehRDBrpgrmmS7WL8RxR3YheZUB4FGqoDtR3NWjbMDz9
5103	fee_transfer	1719	23000000	1	CkpYgroDKEzaJB3yonEMGvnqA6UCCS7Hhjq1GTrn8LFmPMyoTqrFM
5106	fee_transfer	1588	55000000	1	CkpZAuBYwE4TQN3kP1eR3EYWYkJRwZ6VaZfqsqtCH5aCT9BmUpV4H
5111	fee_transfer	1727	32004000	1	Ckpa81pNdRRtAcwq3WhGyYQTkYcKCaiK33Q8dXR1ePxDF4LoLbEGe
5112	fee_transfer	1447	3996000	1	CkpZN71WxwPpAYQ7HWjPLscHddQrPVuKBx1VQLYuKFgDJYnUYuxe1
5114	coinbase	498	720000000000	1	Ckpa48uHxXFgkDb3ii3f2eu6XC6fgdmGhRSYwjXSPDd7TuistqeKi
5115	fee_transfer	498	2000000	1	CkpZLTe6h1JVrqvnWnGtnHKLY4wFQcpUkGcoTQBthyo8ZK4fdXP2C
5116	fee_transfer	1559	2000000	1	CkpYiotrAS1oL6z2fhF3aiM6rr1j26pzJ3bwhH3tuyLPaMC8r4h3N
5117	fee_transfer	1718	24000000	1	CkpZ2P15Z7UHww9k7CSPUpK8qoUGSzPbz65zjSWWex1AR8wBYD2mk
5120	fee_transfer	1508	211000000	1	CkpZckFn6X2jcbT1DMhfdyUSx3SpurdGD3hCRf3HG75s26esZi5J5
5123	fee_transfer	1671	380000000	1	CkpZi7XhjgoAVQXru3UDM98ZXoAg5DrHSYMNKgSMi1RC57Z2q2eVX
5124	fee_transfer	1671	625000000	1	CkpZ99DmmAAMrvrniMgX9uTjPsYk934jCTAwkXMnWBGa4vtrGTzuN
5125	fee_transfer	1656	111000000	1	Ckpa3pPtV5gXBSUHUBRsEu2MW7WZwr2qEfnjLXVUBVFy8av8J4czu
5130	fee_transfer	1593	51000000	1	Ckpa4NbQWyPjahLTh1LWqsLCXYJgCSx5BkhK8eZQ8XuCaizJxnEks
5137	fee_transfer	1679	288000000	1	CkpZ1KwajTDaZ3s919HDGAsYjV3Pynjk8DNgaDoWxoMBjvDmyDgqF
5141	fee_transfer	1850	196000000	1	CkpZm8JFGaMRWg3mgGXdyqb3eCaNFvui2ZkHtJSbAp6YEnVzL5Ws9
5142	fee_transfer	1759	90000000	1	CkpZeTKoFagA7tnHTkJZLETaRbN3pVTrH9sJdBA58fQLyPfCfzmS4
5150	fee_transfer	1679	54000000	1	CkpYkj4L7B33vUiZNEXhxJ3wKeuDFBqifMMAKfHAKcNc3KfbjiUq4
5155	fee_transfer	1704	61000000	1	CkpZVGUFd1T4SbRcaaLwWWNoHA6V2XL4ZK4DKPNYGJisu8Qi1nwoG
5157	fee_transfer	1746	53000000	1	CkpZYxoZf5qm2nkwc6AMLccSuoD2rJxveiyfG3p4KWqjhNnq17XjY
5164	fee_transfer	1687	62000000	1	CkpZg57YW2vEnRCYmiEVGYehy8CvyqiLu5WiEDhnZSrxHix1Vzqmq
5168	fee_transfer	1650	24000000	1	CkpaJ7yUvivEvFmj4SpPeckiL6BdtKpvcUvKVuU6g371Sa6mWP7H1
5170	fee_transfer	1850	59000000	1	CkpaAKTtcr5S4cyBq2f1hsSXUCGGyuduWCWbMDH8E2CQAA4ZVHPFv
5172	fee_transfer	1686	26000000	1	CkpYTUNCGm27xM688uoGzTJDxNaGqdNnEkDEw7kfTKxwK1932E8UX
5176	fee_transfer	1672	43000000	1	CkpZoLPQDDfJGy6nXvWk67oXauoHVLxZPuDug56bDdJQ1RqLYNRmQ
5177	fee_transfer	1672	5000000	1	CkpZmejhkTY9vPuKjiqm7sKcM4u5XYampodvkRfyx4UKytTQWErjo
5182	fee_transfer	1541	23000000	1	CkpaK9617K814UsJ8H7cPAYKhtyLnqshvCnNsNQNVDSFunuDMyh9Q
5184	fee_transfer	1871	12000000	1	CkpZMozcU6PqGT84L6D7CHsfNtD1sHy5mcQG86o4JSae4VZjcjZLk
5187	fee_transfer	338	154000000	1	CkpZiX1VVLE9Vndq3s2QSG9uChxyPvTnHTvsiPNEUkBHYxF3qi4rm
5195	fee_transfer	1439	29000000	1	CkpZHkaXu9nTBSzZMpkLTkCRYRx9tnXNHksbr81gmAnrgvxLRETqo
5198	fee_transfer	1673	120000000	1	CkpZ31JXQEv3YpjTBq4tt6RMH4Fucg7xrV9i7oM93gKpY6FF6zJoc
5205	fee_transfer	1611	24000000	1	CkpYrrXLqfRDA93wasbToxxG7FzPM4TFq6AW74dW5ufgN5d5UKSKV
5211	fee_transfer	1457	52000000	1	CkpZWfoBWCoSzuGKhe7eZ5qqp8Mq1m7T5253C1gpMMFZ3GqN3EC7V
5215	fee_transfer	1474	22000000	1	CkpYRzFzWkt3BNveGmjp92iG2YgdXz51ijwaZththqWDM7iNR8jHm
5217	fee_transfer	1727	55000000	1	CkpaCPsS1hTdD2deMqLqv2ELdF6fxJgNB3PyAZXW5yfrJB2pBD2z3
5225	fee_transfer	1759	999890	1	CkpZhfbzACur8XCAabQ2PuhwEbJvXQXp2St7dGH5MjKqihLLnTr4q
5231	fee_transfer	1535	25000000	1	CkpZAGvnPb5xNowxNM3JjTJMh3q11EG77Yx4gSFNki7ASnRNqWuws
5245	fee_transfer	1649	48000000	1	CkpZcPgJ2ZbouUnxHM9qc8NrCdRRjHTrZnzN1sMHUHKCDrtVGgJN8
5251	fee_transfer	149	37000000	1	CkpZvVo8Emh3FRXMXuX8tb9X22QpprfDDoEbs642E8CFCpTcQrFoH
5255	fee_transfer	1593	25000000	1	CkpZBbjPDR2FbTDx7vJEuEPtJHDB2viaio1Qqe2GR4V1iDpmvzAin
5256	fee_transfer	470	14000000	1	CkpaG75ZHbVzUSvQD9xDAWyDHdg4D8qHPHtUNJB4wpzUUcaE7StwX
5262	fee_transfer	1694	22000000	1	CkpYoKPuE2G4xMTVd9rmGPomUCMMR7b7oUni2eTHLgNcfBx5hUjsE
5264	fee_transfer	1704	190000000	1	CkpYbD4XZobnsEtmiZfLW2eLqm6JDxwyyCbv5KAedUEHy1ZtsFEeg
5265	fee_transfer	1704	1060000000	1	CkpZVCBq7P6GE67foLVomY55Zyi4gVAHyPkZzW5UifwUQkE4magyC
5272	fee_transfer	171	15000000	1	CkpYma36DE3xGWdDjaTsSz9pYjYPVnc8BVgCedfDje4eefEB1XiPv
5273	fee_transfer	1740	563000000	1	CkpZZwyqRinkq1MYutrg5kF8PsPcxPaLw3ZDP1k7GLdBPLZRd348C
5274	fee_transfer	1740	21000000	1	CkpYguct4dz2x4KexabjaznM5LZWGe7VtNtXppMsm9JixfxYHyNDM
5280	fee_transfer	1623	15000000	1	CkpZ3Yqbx1SqGmZiZip1eGuuJvWjgD8dp5kyNbCBAvo986KAsvAis
5281	fee_transfer_via_coinbase	1460	155000000	1	CkpYopP4VcXACjL2ikVJS5UDzFy6F8jsWvnjmUPmoXfyg3BMVwto4
5282	coinbase	1513	720000000000	1	CkpZZyrD7mURNTzKXmMszeDejrLms92Xztcjp19Hpi97WgFLMKd3d
5283	fee_transfer	1693	12999999	1	CkpYxj8CFGUutgymd17SFtRvGRhtBaQuuoKYSrpMcYg5ZWnbstysM
5285	fee_transfer	1672	25000000	1	CkpZaZjSX3aVTgUvzLnHyQeprrR2684EWpkw8xhcprWaDioqYzhRV
5287	fee_transfer	1687	620000000	1	CkpZBAKnNtgFoZwxnsh5us388fPGiNwN4kvAAo9XRURmswuuh8ZSy
5288	fee_transfer	1687	207000000	1	CkpZ3gzJ8cTctfy2eWpzt94ZE7PNVXXmjkSfAH6ossopvKzEoVTfc
5298	fee_transfer	1602	17000000	1	CkpZQLW9HdMWJnGc5CfWCFhWBCaSqQZQtQLJgZPtCNaBwM2Eyy9Hq
5309	fee_transfer	1675	37000000	1	CkpZYj2gB5HeRAoDwS3tspwhz9csMLywWZmwc8VE6KnFCRooAyAxH
5315	fee_transfer	1462	21000000	1	Ckpa7XwyQJc5yEztALnKuR9fE9gtK9JbeV1xQ28hgTKxMVVuhFh1p
5318	fee_transfer	1685	33000000	1	CkpYXCZLrvMtWrSpycnHyYwyoDv2oeySh752jiWtTc1TyTcawPrWS
5321	fee_transfer	686	34000000	1	CkpZPpd7VuckRDSum6hSivtJSQDqf7JiYdEjHvSX3Jm7Rt8Foknon
5322	fee_transfer	1547	34000000	1	CkpZ6JSLxNeueRsUNdxvp5ikVJ3EAXdJzu3dafErZ6E35xsgk2cnJ
5329	fee_transfer	1690	56000000	1	CkpZ81F6G5dmdUDuG8C8KduH3fwyy5RXLCLDATC4H7zMh2pdxRxqC
5333	fee_transfer	1709	220000000	1	CkpZfwCp7ttdj9czGgcWW3VvwDwT4XW45wzVwGf9hBV4yiyYtucw1
5334	fee_transfer	1709	71000000	1	CkpYR33sKARbgjVhDrrMupTMJwdN2Yu2szoA4uSg2DfqyMg5xKciZ
5335	fee_transfer	1564	23000000	1	CkpaL6vjBZSWCzCbR69CgVHZW9udBf54vTotfRJveT4ZMfFn7RyfJ
5342	fee_transfer	1599	51000000	1	CkpZcAxZAePHCWDiDuU1czqY4crzkoyU4PVF2hzzYQfJbaewt8zn5
5361	fee_transfer	1625	11000000	1	CkpZ1AKp14EonQo2WPySyKMf4pV2q4hMrtufHZiQV3Bh4Z5U5kZ4a
5082	fee_transfer	1684	36000000	1	CkpZPHEDZtVRuyPhiM3uQo89M3jsDAkJ17MRgVTpqGCUGNHn31UK6
5084	fee_transfer	632	24000000	1	CkpZpVmqDfqsecp5A88X1ZXZkKgut6uZZFZfGTpK7GqHQcVPhQH36
5086	fee_transfer	1696	24000000	1	CkpYaCCThSNtJip6YfdLCSadgNZBbFTQ1XxzWCEs7LpFWDqNHbi78
5090	fee_transfer	1596	124000000	1	Ckpa1QaechphpEfPZXxwdARpQMYhzNCGrwprhcNoG2bsYGexnj1Wr
5097	fee_transfer	1715	612000000	1	CkpZwcsnxrSKrhubSBfUNtTxgyw8WJJ6mCQ87jag6b2K2BdzGebPS
5101	fee_transfer	1439	111000000	1	CkpZwqK4j6d7op8LonZdFXMW7B5QaewSedLv9T38f6bgYJPYRH9vp
5104	fee_transfer	1587	34000000	1	CkpZxRSrYTi3ECsYMQWyZK2ZVqASfnqG4RGPe9FUEtgYp95HNCw4p
5105	fee_transfer	1588	680000000	1	CkpZF9NVzyaquaNniPUJJ6k2sXbgpxuZDryEcfvcHGWhhAV2UAGKW
5113	fee_transfer	1471	23000000	1	CkpYyL91pCgYL7TDVC9qjqokddwErz2GbBS2NekT859hsQXK5eDqX
5118	fee_transfer	1541	24000000	1	Ckpa7HZCHPV28MeYfdZJ4Qs1eybz4Urn167nCecrwe2FHfue7TuvC
5131	fee_transfer	1546	61000000	1	CkpYet97Jn8iQnVmKDSTvjwwBptx6U1rXL991XgxALwCrzVr7yohW
5134	coinbase	1494	720000000000	1	CkpZxhYN69CerwL5CzbEdpx8ZA6Eaf4iihj1BvDDRu6Jaq3peY92d
5135	fee_transfer	1494	154000000	1	CkpZ6TKznpZ7iBnja3hP3Uqe4wWUs1DeShtgxPhfPNykXEhkdfBsE
5144	fee_transfer	1759	530000000	1	CkpYiz2GbcZnZUTJXKMeDuQRiA4iJvt3drqDLnYKyLwNvQZFjDLH3
5145	fee_transfer	1759	900000000	1	CkpYwcQmuEbBWNom8LzLfXujVRxUjArfLkVToBnQv5GHS5AncQxJP
5147	fee_transfer	1471	204000000	1	CkpZiBYQQksa8KyfhpAX7zkjqATRwJXMaUJP4r3p4L8q7RyjrcRtR
5151	fee_transfer	1678	62000000	1	CkpZ5Au9WY6y2tX9D7RYSSQme4XE9X2NxaWuxd3p2FF3sdAx9whkC
5159	fee_transfer	1747	53000000	1	CkpYWuNqyNoCjwkmX5zRpg6RjimvvdJjxeWBBK5Du2tjtpNf7fw3T
5161	fee_transfer	1687	53000000	1	CkpZcNDk6b7pA8i95HLkvSsjuS5ZQB2nHeAGa1WFu6x2UNZnwZ4xh
5165	fee_transfer	1395	62000000	1	CkpZcfPpUwocyfpkT9tgjcJ8FUeqgwTY7156sPdfRqgCoaNwuY1Kg
5166	fee_transfer	1692	4900000	1	CkpZL7s584hH21E9PFfDk3z4ocTE3LCxDry91ChRo3yY8Ywm4aR82
5167	fee_transfer	167	100000	1	CkpZym2xgwptN8CHJ6eGKuLaEqxZw27ieLmGjAdVFpfk6agVQQWsf
5185	coinbase	338	720000000000	1	CkpaJzRGufBaEU7yiSs6AymxbRHAhe9USBNyP5jeCC4C5K6X5Yd7X
5186	fee_transfer	338	24000000	1	CkpYuae77X6fPQYu1RffrqMPzhYBWBq22Dj1dTcxorpCmmTMnu4hM
5188	fee_transfer	2148	36000000	1	CkpZBHmb3RjsTAjjETquUxrXq9Dbf2yrJsetxvgxj6hSgDFBBnft5
5196	fee_transfer	1695	270000000	1	CkpZWsiW7kiEJMdQQm4JuvBd4FE1qjM2ZLGtsaZQLAfM6ZiHaEFSq
5197	fee_transfer	1695	30000000	1	CkpaBNFBY2esX2zdyZ6QCaFz1goMTTH1wwiLAV1CigxYakK3zCf7w
5202	fee_transfer	1394	41000000	1	CkpZwchxtkovX2CECKULzJ2AqeP2AA4Y62UWZGcP98b32TSzWQRre
5204	fee_transfer	1654	24000000	1	CkpZaY81yvfWjjAda9WpFKWd51tnXmWtiE7vaUcUqYyRZbqTpFg5V
5212	fee_transfer	1549	52000000	1	CkpYZdj2S2CfzcqXHHQhdHUSzX62sCRmhWPyMN3kB3ZWKEZbnb95K
5220	fee_transfer	641	72000000	1	CkpYts936TyY4ApvHJQGqZoeLc8SjhLkjbfEMkJU2Xtg5o9YotRQf
5221	fee_transfer	1571	71000000	1	CkpYUbYDvGY8sNePJtjkPiLqUXy7vM7SvtgaWT9ouKRJqPTLcqZqz
5223	fee_transfer	1705	88000000	1	CkpaB78BEW5zv36EfKuTjW7vPtZNeooLwuFNx94USrGjVw1ULFYJ9
5230	fee_transfer	1271	34000000	1	CkpYRix5rnUtXpY1GKrEethaq33g4oJ7XQmGzkugTeuuS7zA2DqBu
5233	fee_transfer	1850	34000000	1	CkpZKFSVVGUMiwFUiLEvZ2izBZeeG1Lzi3WHoPk4VAsG2rE5tiN6F
5241	fee_transfer	1724	24000000	1	CkpZ5mqrYWubv6YBePL31NTmnTmy1Zungxo3rhxSQBReVjyhfcTu6
5259	fee_transfer	1476	3000000	1	CkpYxYPxuUhtXiXN728WzQodADadWRSrJxXuKjhfwpFL3R9nnohQK
5261	fee_transfer	1850	25000000	1	CkpaHdGiL8scHx8McnTweZyvFwnK9YYGw3nwPsncwu5S5ehYJqjRf
5284	fee_transfer	1671	25000000	1	CkpYiYydDmU9J7Smtr8Y8yxvr17trC1Hntz7PiMCCaUkDKsRBMLfN
5291	fee_transfer	1756	113000000	1	CkpaDiqJPRMwobvR8AkVgzmVZ5Q8tvNnj96rXH2YZG13HJFWjXfVM
5296	fee_transfer	1679	37000000	1	CkpYtCzTP37uxkBEGv1fsam57BQDEPwhsTJMeWVNtZD5bXRuEUfTC
5300	fee_transfer	248	10000	1	CkpZQSnknL1DS7RxeqtMBTyp1Mv4AzjZP5bgJtBazqusio7bANv3E
5301	fee_transfer	1602	16990000	1	CkpaBEGTR2iomwsMyy2PxdmRstq3FDFH1r7f5bfRkY4Q8ooJGkozn
5302	fee_transfer	1692	35000000	1	CkpYiG1NhvGZ9YKCZUX8vfc1PiYKnM8LAxQGFaAJFiyWYzZ76dTdK
5303	fee_transfer	1623	35000000	1	Ckpa3wVqQTnuY4iLLqDW7LP3SzUd5HxFzReVNATeWxjJRqa1rBiNQ
5308	fee_transfer	1657	23500000	1	CkpZK5hGvVFPtfycnX4im6BrkGDtSnE1VW3mJvo2xo2BT6aiacDmQ
5311	fee_transfer	1715	24000000	1	CkpZ4feqeMxptegNcF8zJDffaPJAz7wU5tgEGZU1V79aZx5FQH2he
5312	fee_transfer	1740	105000000	1	CkpaBJNb2QjNBw8Ywpsf9a3tYYTUFjietDGpr9u4noZwdHc7cYc4a
5314	fee_transfer	1991	21000000	1	CkpZMmHYDYcKHvLh8GrkzSiTjDJQ3M7HywGqsgZCoQoFCZM22RhZK
5317	fee_transfer	1654	33000000	1	CkpZoRzjLgvw9rtDLxMXGP6z4NGTdNYYWFZadt5pgQ6mRRDcncodn
5328	fee_transfer	1474	179000000	1	CkpaBaw3CvYbv3dwgoCiX7pgsGwpHfWM6CjBv1DNhJEnve3uphjrU
5330	fee_transfer	1402	56000000	1	CkpZ2kqkFig2fcRLg5noFfY8zY1SQqeK37mYsGUN9jnkJ4Zf27LSc
5337	fee_transfer	1419	558000000	1	CkpZdpV3TPtsa5cgcP4wg5j1xg8Gnmi7oDqRtjSHTQVGE5B4CjJ2d
5338	fee_transfer	1419	62000000	1	CkpYrRLna9giH6JgTvrrmPqkNrHMTBzovuftDB34cPFwc6SKAXBSw
5343	fee_transfer	1650	13000000	1	CkpYWre4STkM2e2m8VoTHQ44Mwib69Nb5iaMmv3YoxaKprnv8aZGq
5346	fee_transfer	2148	22999923	1	CkpYiQR5qofDF64xgm6VGDjd6XaJGEK73tnZ3GeeC5iM5oct2pYbG
5347	fee_transfer	1964	4	1	CkpZ2kRCiXE4M2Ni7u6LSCEUuLE7DxmebjZUuZ7ASu5rwLcuRjPMh
5348	fee_transfer	1571	72	1	CkpaEThrRD43gfHsKWGKAkdkYSCKU8EtDCxvpwvzJD2qGUZw8UsUp
5351	fee_transfer	1933	23000000	1	CkpaE3HkCZ6okiDw4tCmHwyPXaBWtsTeYPfK9c1ETzkZsu1Wxhmq2
5364	fee_transfer	606	18000000	1	CkpZr3Y6io6bC5UxouqXEM8HfN1GSJwVy9WrKJM4xkGur7kaBrGvG
5375	fee_transfer	1705	34000000	1	CkpZiwRcZLvW35wPpcsJC1Ht1XXBwZYRqXtEmk3ZzaqZBLuopmTAB
5379	fee_transfer	1599	135000000	1	CkpZGuLbXTLBrFTzr5BTu7ikkfkibp1jaMNLFDQnxN5ZBS8birJai
5382	fee_transfer	1710	43000000	1	CkpZEJsfdEZ3QLdHERpp5JX4QcwNjUpCe28hRzRwaafMmjaBYPuoK
5394	fee_transfer	1596	31000000	1	CkpZwJttuzCkZkAjYmiLuEQyuSbk2kuHdYssmQaq88Q7Lb4BpEohA
5396	fee_transfer	1746	34000000	1	CkpZWcctBzzuuqgYCREiycy3M9d8NaG1a363sUJfpgooxL7fognGc
5419	coinbase	1548	720000000000	1	CkpaEstbZZCNyGEiNdN7fgV4WDoB4wca4fnUiC6XKUaBzoTJeoBPb
5420	fee_transfer	1548	12000000	1	CkpYgaEGnD2aE4VMaUKVM7XMQ6WsTWReYcAnHKgo3sBxN7Yr6KAyi
5422	fee_transfer	1649	47000000	1	CkpZUgakNzRu4LQ3seZwemgp5Fz4CYdAuTuaH2312KPuLCdyMpGq8
5423	fee_transfer	1649	26000000	1	CkpZa3Ru2hCm2JVouTZHVKShTa9LAm4gyqTBy1zTVPS9k81WHVHaV
5429	fee_transfer	1633	45990000	1	CkpaKS4ygtvc46KXZHUDSUgj7UPNSsra1wAg2gqxK2xpFueKxGx1E
5085	fee_transfer	1696	63000000	1	CkpZkujUrAmfasNHn4d4GTWW9QZJ8ST9o1TqwNwrFeytkXZjv7u3j
5091	fee_transfer	1634	124000000	1	CkpZjdaM5hubbzPGvzc4JNiN6rDkh7fJafMHajdDwg5jHQidy7HRr
5099	fee_transfer	1672	27000000	1	CkpYpzCnSQvcS5XrVk7DHQTiwts7dS3h9i9ZHBHnFkNgB983YCNSV
5102	fee_transfer	1706	23000000	1	CkpZ2SB4jNAmjzxEBkfptfJMrupWdmN3EywCuvgTy2Tjo3mnk5bxx
5108	fee_transfer	1678	31000000	1	CkpYq59w39quZy2KHLkJftDezoLqka75G9EJjVsmdvRypZUJET8gp
5109	fee_transfer	1678	5000000	1	CkpYbmJFioesWXUCGEgeHouxE7d3tqJVt94aa8Yj8FdPkL1Yt6Xie
5110	fee_transfer	1727	36000000	1	CkpZ8ipqL6KsnbJcDSdojJjUAMFv9mtCSoKrMjaVB6e3ocGGCnUK4
5119	fee_transfer	1689	211000000	1	CkpYTapDaQsoTcrfnFBftXUmXRDFfTMTXqDZsCVY8fvcPQzi4bBzd
5128	fee_transfer	1980	640000000	1	CkpZe1vLBdtVaSYVnqAD2oNg2MHbKYdDqu1PLLWEa2opE8gYhaRKn
5129	fee_transfer	1980	790000000	1	CkpZ878QWWLZcmxAYYyvVZ7oExL9D2M9VGBwpPXH9LeYMbEp4Yq9H
5132	fee_transfer	2039	61000000	1	CkpaAwDNvNK2cwbAxmD1CPis7ZfFXHVcjxiad1GdXpK8ff6MJyCHN
5136	fee_transfer	1711	288000000	1	CkpYyZ4drjiUodWYbJ7cVeN9WbWgbDQfvBnixdZqWjcsdpQRumUUY
5138	fee_transfer	1711	134000000	1	CkpaCr7n3ogu2YuqXTVTsSCtYP1KyV6gzsR3187bcf4JYRVXbzaJ6
5140	fee_transfer	1850	186000000	1	CkpZVeCoeTNhTxCWwMfQas9CrywVTkXiv5ZEkzUVvEDc4U7DP9V54
5152	fee_transfer	1608	62000000	1	CkpaDyZ9PrWPLHxuLoE3LTkqUBhNashUF32BaBNDZTUFfCfV7YSCv
5154	fee_transfer	1746	62000000	1	CkpZf8iAtKeZZbQuNj23Aw5ZWSs5fiCo7k6jRR34zaovRhhPNktf4
5160	fee_transfer	1394	53000000	1	Ckpa6DcYnpPtKPnWgzvaEqFcAsevJaiCTUyUbm5KRKBFjRoD8XRD6
5163	fee_transfer	1688	62000000	1	CkpZwzpi8uwgnawz1D3X8M3W451gUNbJZ99xQ3aGFXHMTer2bQZhK
5169	fee_transfer	1850	36000000	1	Ckpa3CauVh9vLcTn1ACQ3aGdp4xDnazwmfZsfPkKwvqBwVvwXJX42
5174	fee_transfer	1423	14000000	1	CkpZ3m96a5e1TBbF8LGmBGvEDQwAgZvWzJndWDo8T3Pq7MG6rRuti
5178	fee_transfer_via_coinbase	1660	597000000000	1	CkpYx1Yz9ApGkrWzvRxMCNCfaRzeQxNJBTFNLvMw9iZhsQKhNxRFe
5179	coinbase	1933	720000000000	1	CkpZvHTVYMvhTooLJ2fANdg1BgH4qmiuKvwtGwzxwzNKwaknv2u9k
5180	fee_transfer	1571	3000000	1	CkpYu1Eo7Qm7doFt9bzmWSpadFYqrH5AQ6bTYd8QaxLJDjVujank6
5189	fee_transfer	1702	36000000	1	CkpZn2kynxUhKCVFGqDL3fxvrnS6psaW9CkYJaXKHAMGbhJ6Rv3JM
5190	fee_transfer	1703	36000000	1	CkpZn7wU7TzuXWoSRggDfA7U2PH87fB2kFnJEivYynidG7q3To9Tw
5191	fee_transfer	1650	22000000	1	CkpZ7KhBNPgynr9y5CuA53sbEhdbwZsXGuES18XAxh55JDbUpiZMv
5201	fee_transfer	1719	36000000	1	CkpaCo7xJdDj5FfrKrgcGML7X3PEEpsBhJsiwb9Xrb3327Lhj812P
5203	fee_transfer	1710	46000000	1	CkpZJ2DxGjDxceRHJX736qYCsVp2XMAZhGAjy4ysh4KhvhaNRwvHB
5206	fee_transfer	369	680000000	1	CkpYokyuau7bZbnKFrMXqyKDcBhRzsXTGR8C5oFYp9q9JprHBXoFt
5207	fee_transfer	369	750000000	1	CkpZcuAuhbWeUpMvP3bpxi4bQFNHzamYaZ8JmsZeaz5r46EQVcMpM
5208	fee_transfer	1613	200000000	1	CkpZTabsKYc1wfzAJpB8U2kLVd5QQFbGrZsLAfv3f4TFpGUPrQsjv
5209	fee_transfer	1613	1050000000	1	Ckpa4vBrbvFZfzw8gg7eYPhGxAgpjWkDjB43G77FHR22udyqxQrQ7
5213	fee_transfer	369	500000000	1	CkpZDCRSPRxFgFLFnkKSn3uXtnSomw6Uh7VGE4Ak1upzCDMFEDPhS
5214	fee_transfer	1756	51000000	1	CkpYfovTguonfZVryVPqH2VK2QgxMTUYpCQuurRD3aRU1dx57mbXA
5219	fee_transfer	1709	51000000	1	CkpYstyaoLue86FK8CSu7fdvrLdjjDS3SnSVLotigJEMMpHjbkezH
5224	fee_transfer	1759	10999980	1	CkpYvuZpkWyzvkrFQvfWEALuW5FH7nQx3aJ1u85zya2xPXcQEWiic
5226	fee_transfer	1633	5999900	1	CkpZzzfCqztohK466ho8ytLUzKXRcY2fuZkU9Q1NDmJiA4MkCybz2
5227	fee_transfer	349	5000000	1	CkpZZuxH6WBeo4sQ7vcDCBWJhCvbPNMcCyeoMXNsJ3bmf7rhL8kSC
5234	fee_transfer	484	34000000	1	CkpYyRcJQDDqgSzPz8Ba8fmag2tx8v7fnqVWHbXeb75YJ9kPCFiBP
5236	fee_transfer_via_coinbase	1633	10000000	1	CkpZ7o6NyPWyBxE7x4QSYjt77iUw2MAKm4QXR9VxGEfp8iVvz4N9Q
5237	coinbase	1764	720000000000	1	CkpYQrmfk5cWGcjP3LcCSP4cffBxAYBH6g1xcqAS3wAknd1D4erjC
5242	fee_transfer	1673	90000000	1	CkpZJo3meKi8bw6wPG3jQFH4wMJVBZNjMGBdWiCskHm5zYDD2ss8U
5243	fee_transfer	75	50000	1	CkpZW1Bgvwz1wDXosu5jdUPsewFDRquhsJVjQnQFuC72PyRWFonZS
5244	fee_transfer	1673	599950000	1	CkpYtL9pnCusGAJ43VrxSxuXkg5hkiQ3L2Nz6xvBJ58R2Q5ssWgJp
5248	fee_transfer	633	25000000	1	CkpYaoFVswdYGuNwU4sFVHvXCgZnXsP4d9jiVbsKuXspmks5ZBKgt
5250	fee_transfer	1692	51000000	1	CkpZeFc82uEPFyudqKtArFu4rAYg2vi9AGd49RKN7jpb3N7vjZgWV
5258	fee_transfer	2148	2000000	1	CkpZ73tm1Gw4LdSvrHDeQKfGE9DVkBPxAL8kikhc7T2aSfcrx4pPW
5260	fee_transfer	1708	3000000	1	CkpYbr3y3mopBZ2X9pzd8bphshN11muxJegBZFdQeftC4Fobdmu1i
5263	fee_transfer	1694	24000000	1	CkpZyVqyJB7pLRQABdBFotEXNTMrGMY6y1cn9A14DHhqWFpR83Wqz
5266	fee_transfer	2055	12000000	1	Ckpa7F12NmeVM2d6mjpGNUY4mw62Nkup1jsmzzFu3Mn4TkhDDLGiW
5267	fee_transfer	1573	13000000	1	CkpYrTQhT3UENnG6GibFdYgNdsQvZRBPazZqEZntR5mxorZ4otN4s
5268	fee_transfer_via_coinbase	2171	1000000024	1	CkpZDQXQjzXi4yScGgm67bbDUDUxR567GhFud3EKoefUTPhVGmSCX
5269	coinbase	1571	720000000000	1	CkpZoKgeuLomyGPUTx4tvohGLHSGZWVSSBs8gCsDose4pUYN938pi
5270	fee_transfer	1715	37000000	1	CkpYajo8GatbbYyLU9Y6qHM9SrkcUG1A6LsPxJDyxDwPXJeu8KXqi
5271	fee_transfer	1670	15000000	1	CkpZtn71EFoKUGTX4Jn9CrZLvitvoXndHkForZovEJQ59UtfxwRz3
5275	fee_transfer	1668	71000000	1	CkpYXEJHgBenASrWDteLTGdS9wEQtBqk2nV5T5oeMSkb3YLe4TNCA
5279	fee_transfer	2039	15000000	1	CkpZJjGcMWU8GWDtkRKdU3t9N65vTqUVC4vfcs61zxpR3mXL3zqVo
5286	fee_transfer	1559	25000000	1	CkpYibPHzYAHx3RhmPzEYQXXzQyBPjYuyc2tnxDigXFbQTcV5hfFy
5289	coinbase	2176	720000000000	1	CkpZxwNvSeqPD1fcKWy8JmAvGEz7EmFHMNtEJ67eHUdKfag1Pe2So
5290	fee_transfer	2176	12000000	1	CkpZshpUJALqLUi1QnxwMYou9FyuizJuZwz9cM1538iTpY7m28QxH
5293	fee_transfer	621	148000000	1	CkpYZpmkLYeXKktTNud1nL2EKZ7k3xn8KJeXjx38oEcL5ZPRt1qx1
5294	fee_transfer	529	25000000	1	CkpZptUrWY4Mk4KonF3KKtn3vJT8n8xuSksipMbLCWZpFiaQcHCXE
5295	fee_transfer	1991	37000000	1	Ckpa4CugNW5GWHt82dkbfjBRqeJaiagcrm3HqQHZHW5Lqu72G4oCg
5299	fee_transfer	1698	17000000	1	CkpYcSveFmhYasVX7ReBDMkZAv2WwZ3TsgweXLgo1c1crLiw1oczV
5304	fee_transfer	1394	57000000	1	CkpZmbzmX3qq7PWX8KSrc8uxgV7L6PvdgJQKKpXmSSsy7wgRGSUUR
5305	fee_transfer	1444	200000000	1	CkpYqCbKAyaSzoJ1wagGE2Yy3gjoZfTFZU83d7VpL4paEr9QFBaiK
5306	fee_transfer	1444	221000000	1	CkpZhHQLmQTpXTc8bBNe5LKPiH1UCaqxT3Jm6ydrw5LqGu9VrT3jB
5307	fee_transfer	1657	23990100	1	CkpZ9nLLW8SLsYTWy7qTSEMfnwwBKcdfwp5qJs3Vg1gRiWWavWTG6
5313	fee_transfer	1739	118000000	1	CkpZ8kt9cfhsDtbycSdYSh46LHgGCQ1AnZPJtoa5orLQ16akNCa39
5316	fee_transfer	1271	33000000	1	CkpYuMEh7G1GNSjUJFYq6Bb9HtVHWxMNjt28VCrLQsAhcSAaKr3tK
5323	fee_transfer	1694	34000000	1	CkpZm4eVr1dPhVs4VBX9cQPTVs1eWsCQyBWoBXhQTgwo1aj2wxXMH
5324	fee_transfer	1687	414000000	1	CkpZK5GtgoZWirdD3gMNZJa36zaWFVjAK4xHvuJcQnYoVHEEYx6sM
5332	fee_transfer	43	34000000	1	CkpaGXQ3TQfFThbQjV4Cr9pvb2WZDBaQZT5d8maEAmoqGT7JEbALj
5336	fee_transfer	1675	67000000	1	CkpZGMRrXUWAzRhD9thRAhiV6mUJgvKFVTJ1ceMYdoHyvsKfTvsSW
5339	fee_transfer	1419	67000000	1	CkpYUKZMJ62U841wvCWN4seU7SXPuqrVtQerifmd1wqDKL7WCmUDh
5340	fee_transfer	641	149000000	1	CkpYt288UNJqDbKucAGSApg9DDWzRUwoVZjbBiGPKX3Paw5StUfnd
5341	fee_transfer	1571	24000000	1	CkpZ57WfQnfEBcMEWnGS9K6bp6XWwnC8WABfYXAgr5G6jrrhmXDkZ
5344	fee_transfer_via_coinbase	2102	100000000	1	CkpYjvg9CJQWC96EDrpkhuoeEURELBoHQmFKG1qANKgHhF3741KQj
5345	coinbase	1756	720000000000	1	CkpZxXJa4UdwtEJczNwuXd67JEFpvfkoHHPFpFDM8EzfdtvKdoqzi
5349	fee_transfer	2148	23000000	1	CkpYn5LSaakFwc1R6doQLqu4paQQosk6XBstnF5iWMMqjLTPWdivs
5366	fee_transfer	1719	55000000	1	CkpaD7k9VkpeceHL413U38oWx4xBrqKJGQ415pnsUkFnw8YPnoVnH
5367	fee_transfer	1740	55000000	1	CkpYt55nueMGYJXHzVruUWnaiFNR8gdgaNeWTSo2CmxT126kkZ9WW
5383	fee_transfer	599	11000000	1	CkpZ6wVzDx8dDoyqUiWtkXsA474ytVk3huV1cfc4yERPrj7FGEurp
5397	fee_transfer	1447	16000000	1	CkpZZSWAbto2GxZ7hKNDZn7az1fcwXDJ7VhgsnZM3CE2QMzJbS2Yf
5401	fee_transfer	1555	1150000000	1	CkpYZMFnfCBWEasi32LGzYyXVsH7pYEPS7s2Rni7JYmsFmagfFdXV
5402	fee_transfer	1447	2997000	1	CkpZ7c1QcPxH8AWhp8dExmDnR3WVw7bmyHc5k2BVFqopYewHanyni
5403	fee_transfer	1555	806003001	1	Ckpa2XSgQsFXjUaf6AQ7Noo5aLcDnX6UVGqHdrbDA62kuq6FjdrGk
5411	fee_transfer	415	11000000	1	CkpZ5oXDC3fEnpcVyM6vumQSvrKQ7PDfKq8eTtKJNyMmb8gAUvfu7
5412	fee_transfer	606	37000000	1	CkpZo6ae9JD39snTofFCXJhYQZnpT3msffAms4Nw31nKPTYaJ6wfM
5421	fee_transfer	1719	514000000	1	CkpZXsdSq9HBdbVRtiwtHSp22e6eeJ3CyRxsxb92KkqDGAB9z48Mi
5424	fee_transfer	1699	26000000	1	CkpYeaozAyWVqeBzaTke3onmDA1TB8dP1ZZfq8ph6KF9XKLfkQ9VZ
5431	fee_transfer	1695	17000000	1	CkpYztuURY8bod8guKozMWonJAWPHg1UtHmqDgoaHsbDT1ocVzDcw
5441	fee_transfer	1395	61000000	1	CkpYxhtcmmnUNUxa4CMLHTPS7XebnxyZkHU73s6RJ8ydXCAbWiC4P
5450	fee_transfer	1536	112000000	1	CkpYwFsnXLccAfj3kNYSSGEqqRD9bHkf1Zh2yFvgHtdSuFGkANdrv
5451	fee_transfer	1440	112000000	1	CkpYfZDEhjkqBVNiFaapAJXzDr9K8wZ7sMvxkPJL5wLv11fGusrVi
5459	fee_transfer	1679	115000000	1	CkpZZpGmDPRgC7Gn6QPRRyCzaVbZ8bfCmyZrwJyC86scbPy9shnCv
5462	fee_transfer	1402	23000000	1	CkpZieUSCdxZaCZJb3JeFC5TvfjwQpNTVogDMKn5PAG3hjjuTwNrq
5470	fee_transfer	1593	89000000	1	CkpZm3NWqS18Q2YJNiC9pFS6kJL8dt6cEaMTK9Qw4dqBVx3MCm68S
5473	fee_transfer	1546	23000000	1	CkpZM3rUfx1ExrNQjypXYT5YX2bA8DqaHSMKsHhUzbZRWaWGFBNUg
5474	fee_transfer	1549	35000000	1	CkpYkcWmKgnkKqiAZ52sz29pXjB3C5EzfjumqM3H4kYzPTFihFFZu
5477	fee_transfer	1596	223000000	1	CkpZ2kskC4ZWrm1vnY5FyHctVRTj7g9PMGb2q4eyTs4mRJfh16y41
5481	fee_transfer	1692	439000000	1	CkpZv4GngEFDUuqjU1ZnmrHg1UAmNwtfyYEbYVPKyBba6V6NwjDq1
5484	fee_transfer	1547	21000000	1	CkpZx2h9fBG918M76nx59iXMaTdPiJ5jvDSqiETA8eLMHWDf9NAQp
5486	fee_transfer	606	56000000	1	CkpZMxD8jmZ5KuZ34c1avGJsSLkpnc7ywEsnWsDm1D4DPfBZ7ysvB
5493	fee_transfer	1610	34000000	1	CkpaCRSSjvcgXhocrhRbFvUTsKTNkHgFoUyGDcRwDdarsdE4WNPo1
5505	fee_transfer	369	23000000	1	CkpZ6qPU8iYYpyTEWWasCoQdgU9vk4UUqjeo5GTSroT7L9QN99jhJ
5506	fee_transfer	1688	111000000	1	CkpYabsVYa9fQfr1Kay5ftQNTEripTr53oTeCMf5ZumTRaJqcgdaU
5508	fee_transfer	1687	5000000	1	CkpYnafT9DTUV81sXo3NuEHi4HEfCJWC8MMxYhtxvRoi9J5JakYjd
5509	fee_transfer	69	11000000	1	CkpZtRc7Ne929PTt2djZv6tuEwXdX8qJTh1zsgr73WjNa4RG8wnuj
5510	fee_transfer	1759	3000000	1	Ckpa77gnVJMwGvyG8nXCtbmf5iu5VUhS9ii868gAAibuqoJjuoZZv
5512	fee_transfer	1637	73000000	1	Ckpa5gUmTnJWnZGfcPa7H8GctHecpN3oysvpJyCawzBbfxkx6Aa47
5514	fee_transfer	526	12000000	1	CkpZMZuWZDkSXX3YDumBFS7aaHQsA3yL1aKpAXFWpFEoNCacTQDHB
5519	fee_transfer	1714	21000000	1	CkpZFfx3RZEKhbQK7uBSRu9vP94ny1GAxamsMmmVRm9kwZFCfQm74
5530	fee_transfer	1560	361000000	1	CkpZ9Hh7cSZSqqgUpugSvd9XCgRQarht1HbM6uHe4HNL4F9XmNiwr
5542	fee_transfer	1623	42000000	1	CkpaK65rsbGAHJrqGTBJn8HDb6bQaXf1mgbpscqrjcteB13dmrVDB
5544	fee_transfer	1717	41000000	1	CkpYwxT4X2KFUMjFonEdUatUnPGhaiHxvFm8YX9RpoCHt9cbKm5Rs
5549	fee_transfer	1395	110000000	1	CkpYvwhgS8By8iqquziSrw22Fo8vFZQ915wTMTS9PD4Zgepc1hcN1
5551	fee_transfer	662	120000000	1	CkpaCXcgwZYsSFVgNP2HMMVfBxzm668PqDSdSKkJJ16uJcGq3Z16J
5553	fee_transfer	1723	62000000	1	CkpZGJbNgawMzYUUuPEojzMzR8bnJJmu16hpwuUKBM28HDq9eBm5c
5556	fee_transfer	1740	123000000	1	Ckpa2ctXpHr5WZAPFFkdMu6qKssSKRs3iraZFBFAZLeWk98bSkPRZ
5557	coinbase	340	720000000000	1	CkpYTHDLi6WvnHHUPE4RG9w6By1JaF5wk8zftgrZjLuc8ons2oxXv
5558	fee_transfer	340	24000000	1	CkpYTt2UjVUBnbh1zeJznmmvKQocTM2yZ1qjNQ8tabRiVEqci8Dd3
5560	coinbase	2211	720000000000	1	CkpZ7LRtHMsTZ2c95AhKAgNk2dLuR6VEQZie2yrcapLvipBxi8hR1
5561	fee_transfer	2211	33000000	1	CkpZDVmqWanvFhgRpRghhD2sHzYxrZozQvFpSKuoVW6Bw2odPzkoU
5563	fee_transfer	1762	144000000	1	CkpZXbvsWrQbnSvwaeHkAxpTKEQzzZasg8FoX77ua4KWyswX8quiQ
5564	fee_transfer	1571	143000000	1	CkpYbQQin9uvqTEeFZKBhb2RwUHBjLSJ2HwJNjJd2fPCKFfZaiL3g
5573	fee_transfer	1706	470000000	1	Ckpa8oxvqqdAWtQrpGZPdrEdFwr6PSXZsdAk2vQUstNEu7i15tVM4
5574	fee_transfer	1706	667000000	1	CkpZPKfSBsdibAJAeKfMyEnWDjidjABrJNZAU918CMJXKBfG8f51e
5575	fee_transfer	1509	112000000	1	Ckpa2RryigAjo37ALv46tcAg9CVGKHBqLaNCXQJVf9RjvmGwWy8tJ
5579	fee_transfer	1688	125000000	1	CkpYziqaQ51PiqETTf4EPqiFTFfoueaoFiLSQSgbxpJikAnwPT8KW
5580	fee_transfer	369	760000000	1	CkpZSpS2Nm6tg5n5GVSfH1D1ZzS8VpK5tacG9u4HiZkSbhohWWQHv
5581	fee_transfer	369	670000000	1	CkpYd1xFn7y3Z9cx8B1fTMEJsss2wu1ny6cGSEebWvb4tBautKvWc
5358	fee_transfer	1571	176	1	CkpZbm9wHPDvrLcgcFmjeaAqCHqCrEXBv9cukgjLsPJmcjMc4yp1x
5359	fee_transfer	1693	22999991	1	CkpZZvzEpUeERdnDKdUjz3aJptuXA9iHjfvhnhkkk7QbYCmFyaiTK
5360	fee_transfer	1693	22000999	1	CkpZC7ubjCb1pZvhaJNZ24iZGWdpB2K6UpM6TXJ4Bux5PcPFbREsj
5363	fee_transfer	1698	18000000	1	CkpZpNY7oa8q1U3vLH7pNV8skAfxK6jNtRp55v5HTftfTHNvsJfAR
5365	fee_transfer	1395	18000000	1	CkpZ6fn1tVw7xnzCfs16wEzf2oZkBZ9jR7FGwnzpbvhuWMHLfmtTx
5368	fee_transfer	1717	14000000	1	CkpYVBLnVjHSdt3z5nW2ZuCWQD9SQXVC8QmFQ8npfV913qBHCduXH
5369	fee_transfer	1739	71000000	1	CkpZGqXvHKGoERqsahyXFxdHdiXm3HSMeMgurbAwVXYGkyPf9qZxW
5371	fee_transfer	1850	130000000	1	CkpZoGo2tnSb6m7eYwskMD2cTn9izbBbn9Aagkpeyzg7LEzqENExN
5372	fee_transfer	1850	466000000	1	CkpaDP9cBJ5qnsiF8dHftfXZdbCs35kFkfWvSfPPQNCn3DMc3MvF2
5374	fee_transfer	1668	23000000	1	CkpZmnEiUYwjGHY9v7QtXbmKkxM5VGftw5AUsbuvj1xnrNVFj5Jxk
5376	coinbase	1679	720000000000	1	CkpZoh3PtNxiWbgN8H8Nu9Hvx2WdzdGVVL363AGN3s69xLxiqVUyT
5377	fee_transfer	212	1000000	1	CkpZJDjD55M174i7mTPwvYS32orCmuQuoFevfvh5PMqGkFmiuWtxm
5378	fee_transfer	1679	9999992	1	CkpZjmiAXpoTvhbmovivEXrS3WXfDLxgZ5tqKvW28JTidmkN8QLNV
5385	fee_transfer	149	460000000	1	Ckpa6TPMh2h51VoKGAwGtvtKeFhpNhypum3ABbScU25vqSHSEbWL2
5390	fee_transfer	1715	35990000	1	CkpYtvitXAQULuuL7d9sn5Q27yT6SEMGtjeJ9fQjNiWiuoiBJAkRq
5391	fee_transfer	1693	10999800	1	CkpYrrfMu4QSSYzGybEuN26TGd9R3bBuPFMpbTVT9xY2rS79kRypF
5392	fee_transfer	1849	200	1	CkpZ4yayMj79HBqiwsWuwAgSZU5JRrziAeyPiR4r4Synwp8ktVehg
5398	fee_transfer	1476	23000000	1	CkpZPeAThciYGUubN57jRYKSu6P8jPVvcrRP35TTTbTnyqKwMMZfM
5399	coinbase	1425	720000000000	1	CkpYQCjHoP3DbkhUghwwfqZzL54hdhR9oDhQ5rduHP9e72kumLgAQ
5400	fee_transfer	1425	12000000	1	CkpYwA26XdpoA6cndiJ8s1L7dAxYJWRfCGPGv1Kr6cXJzYL2pXdVv
5409	fee_transfer_via_coinbase	1447	444000000000	1	CkpYcJnVPwg42gUT7zhCaFdH7vekYbBdX7VvtCwau71a4D9M9kEAe
5410	coinbase	1739	720000000000	1	CkpYiyDQscJWVgQ8JMLoWzMU88bWy7cEDTZtdrqvGW64eP6gmYT5g
5417	fee_transfer	1419	1440000000	1	CkpZbLhukU5JAXri1Wdhv6D2nss8sEGT67CXyZam6UHufxzyH3NPr
5418	fee_transfer	1419	620000000	1	CkpZj1EvfjRvL3nQBdEfn7NwkPw5iPkm6seu2xUwnPA9BceR81rBq
5426	fee_transfer	2086	26000000	1	CkpZvrmwdCFYB3MEvyapXBgAWboARmihq4Cnzhfco6yBsURr2uZ97
5430	fee_transfer	1756	17000000	1	CkpZdfZHxyxMtq2WDt51gXookfjjTsXN9pvoUJKm61gVWRR9ok6ZM
5432	fee_transfer	1718	17000000	1	CkpZooFcvmu6AmFoC1PdZcaXfrVhfU3MUYXYNE1Rqy3vL7cyVi2Hq
5437	fee_transfer	1723	13000000	1	CkpZUzDGzv18yKbdqKQsQyVjLTMZpCHvsiQofwpFatEqKpRZ1efFU
5438	fee_transfer	1592	25000000	1	CkpaLQ7nu9nQfpJ9Zc2Bno8xvJ89cXjt8hi3bABggJLZGEGxzEZ92
5445	fee_transfer	1710	25000000	1	CkpZURSiM3jmoiFhiSb663n6wXeKgNGNq92ShLRssFf6tgWzHR8X7
5447	fee_transfer	1673	13000000	1	CkpYVujKdVyYz2axSzHwFedEVe61N1EMA9Cb5pCQjNJwxm5KxASeu
5452	fee_transfer	1623	112000000	1	CkpZJ1sWnvck9rkaGzkAUTEup6SFDBnBMUWvj6kCNFXVwBPp5F74C
5454	fee_transfer	1395	49000000	1	CkpZrH1kPjmXqdYDmugZrKxTZnNPsuf72W59uBKcAhdmG7G6Z29oL
5456	fee_transfer	1395	112000000	1	CkpZk9MVusw95wk4QWP8EFYxCxCF2iSjLovbPnQD1njwY86J4SQwc
5458	fee_transfer	1719	115000000	1	CkpZE9X7v48ucSUUYXjdgVgmgG865KdatwPofkJTnuN7bS6GS1m4f
5463	fee_transfer	1679	34000000	1	CkpZbkTaTWWNRnPaXPLteZK49AAyDLiHtwYa5igYAV57BBoSDTxa1
5465	fee_transfer	1622	21000000	1	CkpZcEaG7sFyvxfK6JjsKsJfKJbCj1g58YnjkWtpB81CJrYf6gtah
5471	fee_transfer	1463	12000000	1	CkpZuro5vqhBk3APP3Q9BcSEdGWdvmWHWGjm92MVa8Vh5t1L2Vmno
5472	fee_transfer	576	22000000	1	CkpZ7HSo9dqsQEz8LVCoNynCZXkvwMBtLaX23THpVv4vpVT5BsgEn
5476	fee_transfer	1395	211000000	1	CkpZfKwhFJ9686t7ZThKokHd7XhPhdRogx85dhiv8sTn8EhauKuhb
5479	fee_transfer	1686	22000000	1	CkpZ8jhJa6AGvXp1WNh6srbvxQ4UXKHQFSq6zX9WhhiboLu8poZ1u
5485	fee_transfer	1700	41000000	1	CkpaEexRjqdnWGKhMU4nSnaMbMSsESA1uYtDw2tGJemt9owhpJjmG
5488	fee_transfer	43	999900	1	CkpYro7HcGB4aaa5WQccrcCWe4K8NPxXUu9iYGA92rUDH5GZsKi3R
5489	fee_transfer	2052	100	1	Ckpa5yYFCAzwHq2n3X7MDu5wr7euHuow3gwbY6HUBM4JkPKrLDkhQ
5490	fee_transfer	1610	7019950	1	CkpZkHnK4T6vSN8BzskXnFvqnBbvJWGa7MpkzdaSeFmxTE9PUT6Ut
5491	fee_transfer	484	25000000	1	CkpZYnQjLzVecyYTBBSB6gDmAFNDjmu1XxjKhnEDmx49Q3NRheNLV
5492	fee_transfer	2052	50	1	CkpZgeNaMZ7Em5EC7k8fadqfBQ4q8GjQgyHkfGk8gHAccvuEHpV5M
5497	fee_transfer	1444	22000000	1	CkpZ68Qkg4naqtE25vvTuhsZxoP64GhFe3HTVzE8XX42zJk3tVdEL
5501	fee_transfer	1768	30000000	1	CkpZ5CnxcUb2PWgBG2HKi2rgWVmPoh4BzJUiyJBdYRGvBVFSNYcbM
5504	fee_transfer	1649	23000000	1	CkpYvFrFjSGcN5XCmn9ychK3CC6A34eBKLmpgKXKpZkwtBfGA4E49
5516	fee_transfer	1419	21000000	1	CkpZcRk4xUrGbdipcf4Y2e5qYyyrtcCjMZEU3XopKCdiUTmB7cs7Y
5527	fee_transfer	1603	600000000	1	CkpZqL8eyLqvEoskaLBidEQuWWkn8xhDMWgUFSF2HJnT41CfvSSk6
5528	fee_transfer	1546	41000000	1	CkpYdcPieW9q8hyWj7CVuBx2QCnoNjh8hqxv6utYfZm2BNC5VL2hf
5533	fee_transfer	1593	31000000	1	CkpYSfT5NJCrXNJycYAFaseN2MCV8coGubvuZfib9UK2ZctxEg3p3
5537	fee_transfer	1587	219000000	1	CkpaKV5KrqxMFYp9uA6Q9oSQHntJBLUhXEyeSdVHb8cW1ZisT59eT
5539	fee_transfer	2112	21000000	1	CkpYTxgkuCVkbHb6EMq3Xc1uyWMaAkDUXvnbSRQUWPLcvPVtrdExY
5541	fee_transfer	1690	42000000	1	Ckpa8DRd9Dmrw3Mz4Wks7EBoDGwX6P3PvN8CcFMy86yLxFfvh8tUH
5548	fee_transfer	1688	95000000	1	CkpZvePyBVuBjNZ9vWcQz1YeVKH8H2doXzSqhTTgRMRG72yDwZYXQ
5552	fee_transfer	1680	62000000	1	CkpZbsH7dW2AhtzPMz8WaJ79YY3L1eGnoiSVvmNaGsUEvVu4HPNML
5555	fee_transfer	1895	24000000	1	CkpZyh5v1daQVLU6MLPwea3F8nJ7hpocdaFP2dLDRtLE2X8cAcsV3
5567	fee_transfer	1508	64000000	1	CkpYRohYBuahrWe7mgigv4ef47JZSpfuh4ZYwieVCRcr6jJR753uB
5578	fee_transfer	1395	125000000	1	CkpZimJyiWHbP57M8pr9cbJ1bdZwpfutAi1F93VS9pvFkrnvsh5vZ
5362	fee_transfer	1564	18000000	1	CkpZSGQzf9bU9JZNfpKftPRXJL5zJsB3C43S9JjZPFTDiv3RqnCWp
5370	fee_transfer	1560	600000000	1	CkpZJVNVKZkUwLEFn6m1egEs9N8zgZzfLdM98AZoysyWV4xUC46JX
5373	fee_transfer	1643	519000000	1	CkpZMPfKReuZ4fZxHEnYdnokWyiJc849Ni11ywopwf88SaHHewd5V
5380	fee_transfer	1654	310000000	1	CkpYvkyikmxE6rkPofp79h6qMwTE6UTbwNnokCG1zGf2WwTXwJwRL
5381	fee_transfer	1654	83999992	1	CkpZRQhzzh3g41bsqo77uMgifdss7SVquhgYXp1uSGnj7P27MzWB6
5384	fee_transfer	1688	460000000	1	CkpYfQf5neeY2VKaByZdU14svQH5mwREDWAAr9ZXUxhAWYrybbqW3
5386	fee_transfer	1634	460000000	1	CkpZdUpSwKUf5FzpB1CZ7CenByKySpHt4rKVyG5bX7XCKW9ge1uj7
5387	fee_transfer	1654	641000000	1	CkpZyYb2aRQ728AxXNd8nt38abrrX7f5rYw1SVjNtqp4Zg1vwGQeb
5388	fee_transfer	1711	423000000	1	CkpaHrvBGsSjzDeBMqCPpHcp39dHzk8nhXHKBgf3aAWRiB4zTHN3C
5389	fee_transfer	1426	23000000	1	CkpZzzhf4ZjnT8wyHcyG5AdpCTzS9u1ewRUAXmc9j4P2LRQmEoofS
5393	fee_transfer	1747	34000000	1	CkpZo4nEieLe6jcYdE7gEXtq2VQGCv1bBzbSzBexL3v7AqFB2xqz8
5395	fee_transfer	1708	34000000	1	CkpZBDvmq7ZrZ9UhQKHSU5oiQZLY1rHd4iTrxg65Z28hbmuztknin
5404	fee_transfer	1599	820000000	1	CkpYhvn1LZrqUHxuaE5xeoLKnfuXbmuJ4H8f9DJSqh1nhYHAfzxcA
5405	fee_transfer	1599	907000000	1	CkpYnmSUBpoSXbvwxgzr6wPySmwCJpjexz63ayQTKfYrRskt4d1mg
5406	fee_transfer	1599	82000000	1	CkpYpmx9hjHUwzQv6QjsESa65buPtfKPWMts1kj2M5YGEQuScjXZY
5407	fee_transfer	1599	107000000	1	CkpYjyHQP1d3aKTKW63xteESvYUHAMQSZMB9qD3shnazJ2rDD2HLq
5408	fee_transfer	1508	23000000	1	CkpZLtnrgCqSGWsAYNnjMJrMhi1BJWKDQqMG9G1iUpZaXe4cG2fD4
5413	fee_transfer	1675	7000000	1	CkpZY4zqcGRVu5xcyHmC3vSxDDZDMqpkGADuPff2se6Dmb68EwSYq
5414	fee_transfer	1716	142000000	1	CkpZco79pNLvF1jfBZkptEuKxjrXLTuUfUMmBFAUbZzZram5nUafv
5415	fee_transfer	1740	225000000	1	CkpYrzGXKDNgm4shSSc8TcKmqDXFhT2qUz9njtriJvPNyBwuMj3fs
5416	fee_transfer	1549	25000000	1	CkpYXiVA1Ce65jSeTdTWRvhj9pLmk9jhsapAyo3MpQK9LL9hYdNtb
5425	fee_transfer	1708	26000000	1	CkpaLDYYETdhaohcjhnD42hmtbMsxd2yWiBzaiR5TQny36s1J1sX8
5427	fee_transfer	1724	26000000	1	CkpZoFzemhhWWkZhCsTwaNMbo8LJ9obJyx2NGpBwxGtLoDzpySAdm
5428	fee_transfer	2087	26000000	1	CkpZZdPmDT1N2RMAUjwbBYb79W4YzWexWWMWaA8Y5LriS4BcP2c9J
5435	fee_transfer	1850	850000000	1	CkpZJLycgBSRRs19UfJcekouQ2HdRymy1vDbVd3LodGrFWtmtUstw
5436	fee_transfer	1850	1120000000	1	CkpZBCKXY9VUDgswaXpJ5NMRaTtBMF5CydBH3PHPAx9fqf6cvFiJZ
5443	fee_transfer	1618	25000000	1	CkpZ3eR8zpZ5JBHR7M8zE3TtddpduEk3HaqHY3eequUun7R6PQ9J4
5446	fee_transfer	1637	112000000	1	CkpYdkSLUfTHfwbuFBUwCjaUQkLy5hqmKDs3D7QcBy5nD7QkzsbVL
5448	fee_transfer	1679	124000000	1	CkpZ7sTE9uq8mKmSFvYGPJnHxsM7McTGffur7d5YohQM1vaeeGqhh
5449	fee_transfer	1634	281000000	1	CkpYYtWATgp62VBRg85Sm57kMY9yt4AebBaD2U1HpmrDVVAxnVKx5
5453	fee_transfer	1688	49000000	1	Ckpa8S7WZVNYYKQqXexnjndcppVwvae8vtHrAbQpmThjhEM9bSquq
5457	fee_transfer	1719	111000000	1	CkpZf6o8QH5favsp5sC7gZ4YKj4unRXewZ6qh9aYcwTsKyTH6hBB5
5466	fee_transfer	1471	21000000	1	CkpYa2Df3hN4SFe4VdMSXeRRrgWVUUYsJGiy7nMqnUFTxFnjZzUrE
5467	fee_transfer	1471	2000000	1	CkpZrZN5xtPPCgUEYhCDfaPG2WBUy8BfRgKBFYUG84y5wh8L8kYQx
5475	fee_transfer	1571	211000000	1	CkpZSDoc2QKHN8RQ9Ktu2DT9iCChifJheiM8xSrNKzP4j3UAdPFNK
5499	fee_transfer	1684	46000000	1	CkpYyerSGGozfCXnc9Ff59iCp2N8xcHK5f3hs9jbFXTBmqyXbBsNP
5500	fee_transfer	1593	22000000	1	CkpZww2jsXBWgq61B2Uj1bK7AdxbKcBsR6kpAsbd5Dd8JPA8iFbyH
5507	fee_transfer	1394	111000000	1	CkpaHaJ2bJpqpK1Xg18G8R79TMbkvjhKjy4YGNjYzkUQpEJWNvNMu
5511	fee_transfer	1524	11000000	1	CkpZfSrsTEjTFTfzMGJFTVJp6Vnvec1auAKWyacxmDyH5u5VeFCtN
5517	fee_transfer	1508	21000000	1	CkpYWKFbvf3xWtBqEd6bYhmSMxWpkjfUNZZLeHVztuzH5jZaF1VmX
5518	fee_transfer	1980	10000000	1	CkpZyuxqw8kr63tn2RtkZJbBZsw59Cibp51uBnyDmnEpzU9nvu6Fs
5520	fee_transfer	1560	350000000	1	CkpZkC9a7P2bx5f7M391Wm3KoPkerXKXru89r9ToB5BwrsYMQEPDK
5521	fee_transfer	1560	189000000	1	CkpZuHX798nKi8oDNtnxKazaHNJyS6wE9dsU4dVkTN9ens7vLeXd9
5522	fee_transfer	1762	21000000	1	CkpZFwtW5PUn1jBE2B66oXRweGoZEcCb384xbJAz9phiJMc27YVGz
5523	fee_transfer	1765	1000	1	CkpZuuu9Ck4eRBLDhmnT6PGYoGaxpWw9v3HW5pnpzRcGP7qDSmXmE
5524	fee_transfer	1695	10999000	1	CkpYRLi25mCfMrAtyDw7WydqCEccCuaAcvWYbCF22RQ5xgyrH9foF
5525	fee_transfer	2112	20000000	1	CkpZ6ceBevJGnVYPa6wYVAVqd6QHr1uzVZs1oq6yFAh5ERjpUqopa
5529	fee_transfer	1394	20000000	1	CkpZFLZoMXPQapzF3BVVkvFonBmTqPSzmm7tASt1F9UDpbkR3puT6
5534	fee_transfer	1395	31000000	1	CkpZnRGuj15EFHTp3b1rRYV2jx4SBSmr8n54e5rfi1ksT95PVBvon
5536	fee_transfer	1601	41000000	1	CkpYcpkqo7xqiS88Qm3ABtvQYKP6NT1Go34zhn77XacS4J6b5HFZc
5540	fee_transfer	457	11000000	1	CkpZL66TxE8j8MKw1jQiveD5ArB24LdgSAhw25nWTcq7J6TJT8yFF
5543	fee_transfer	1739	31000000	1	CkpZT9NYmJ6TtunHCfrpxefqVkA44cSJJ9AenxYDop3yenDfoTEKw
5547	fee_transfer	2148	95000000	1	CkpYcErvxNsZMSFUgaaoqqDDyvT3CxVQfFLzMb4868fZaKFvcpNFB
5559	fee_transfer	1714	44000000	1	CkpZiaytb757sFsJVVeRA7F2baCrp4YXektgGvnRKbRkr2d4CU1YR
5566	fee_transfer	1462	13000000	1	CkpZEzEsZsx2BxdfDtuDhgsFnJHpZBaufpJgX8BkeQESDrKGtAZSB
5569	fee_transfer	1710	3000000	1	CkpYnhdFdbretE1wekUuvp3jsht8PWu6eABthpzxZQuJP3cfYhaaP
5577	fee_transfer	2112	11000000	1	CkpZGdy3UMun2vt5q7jWSu5ek8G4eBcZk38RASeAsPp7mDFkadxHb
5433	coinbase	263	720000000000	1	CkpYezAsokKZLwsZ77vkb1Km1KxHx3QkdqvnzXctBzSKyAC1f2AxZ
5434	fee_transfer	263	12000000	1	CkpZC57KWkoW8i5SUWp4rPywkvb9GZc9hSVregd57dAPWj9tV5xsN
5439	fee_transfer	369	2000000	1	CkpYcXomUc46yVZigw7T9rQq9AKUdTbLXk9jgVKXQm559JNMGhQU3
5440	fee_transfer	1670	61000000	1	CkpZVkxG7YFeCVD9212HYydgevgpXr9fahBZPcuWiyZAbnN8MzeVP
5442	fee_transfer	1675	132000000	1	CkpZmN5pHkMmn9imxXUxVJY2yK8aUEjA5ynj26oeVfaznx63bmXzD
5444	fee_transfer	1675	4000000	1	CkpYj6ihsWg624Q8DXnhUMZyXih6HdTm9JT44znu35xpWvwwMciin
5455	fee_transfer	1610	112000000	1	CkpZpwUnWAjzfozu2KfbDDibM6jXXu9mQw1WEtEgpaFYFEkZFv1WT
5460	fee_transfer	1637	111000000	1	CkpZ7HMqY6kcXxFX69EYMJwmLvMA7jpfgpSDrcfCo1y7HyptDgw9u
5461	fee_transfer	1670	112000000	1	CkpYW5zgG4MdQBLfSMfYc9qaWq8uuhYWdv9Qm6xrVpp9bjpZPExnp
5464	fee_transfer	1625	22000000	1	CkpYVS45Wcnw2d8ksHxxitxPzwgj9yKWw6Q9WbmD2kZtwYSH39NLy
5468	fee_transfer	1596	21000000	1	CkpZkJjUTJ7jDx6MRFR8SC4f1jcHSnwq8HBiHidA6ACnYF9mTz7Xh
5469	fee_transfer	1509	89000000	1	CkpZXodzKUUekCHtaHZ9nvLojEeC66w3dX1cebULn5sCakmpPaEr8
5478	fee_transfer	1650	223000000	1	CkpYfBfocjMV8Yk18TqQf8afPbKHaD1HTGymL9HhVLyV7WE7rnPkT
5480	fee_transfer	1594	24000000	1	CkpZ3pCj1H6EpBaBW339kqLU32JPptfXwa9KEiqm7udiHX8kcwiVZ
5482	fee_transfer	1506	1880000000	1	CkpZF4Fu25BaeUttRDMPWsLzjdSMdkXGwvRaox1ebJmeYgSc3tMr2
5483	fee_transfer	1506	460000000	1	Ckpa8oAVfnVP87DmrK9wfZn5N5VB6V9BuLj33xbSzcXit9HrnMMSS
5487	fee_transfer	606	542000000	1	CkpYvwXEnB12yfMqWLT8R9TPy4wxPA3eqvGgRq4w5ikZABeDr5PHU
5494	fee_transfer	1563	12000000	1	CkpZzz1BVuu8Mc1TfEkD9fZVDnNXFqqfdcyRmftpR3LF9ftMWLaTZ
5495	fee_transfer	1476	185000000	1	CkpZgqnbe6xn644cYaMusGgmhfUmN769FCcMzSuZk3Rmq7gaXf1ik
5496	fee_transfer	1476	5000000	1	CkpaHNa44RNiKeHuo2BSAD2ktbg1M2tcYKWXgikLRzGFNnz63DNHS
5498	fee_transfer	1634	1206000000	1	CkpYkCCPDAJZej8fe36ihu6znQ2P2zoDCbVPvvP5VtapnYmyW62AA
5502	fee_transfer	1601	34000000	1	CkpZE5XZjMKdGSGcf3N3cv5g9BkP8A3S4UGo1ANgiDmMFLe8ftvmb
5503	fee_transfer	1691	32000000	1	CkpZtopTbhmot8DgYs316TsvjQnaNP3td2fPRxreoqHdbNgG7dwT9
5513	fee_transfer	1623	73000000	1	CkpYZxNi8cZg7YMd9D4j8eoDxvXEac5cTccysPoHcbnpN2bGZCeAk
5515	fee_transfer	632	32000000	1	CkpYhomJdEY9M3NKzipuZnzLtgdBt6LeEYdbZJcWiKd2wVfqGjria
5526	fee_transfer	470	31000000	1	CkpYuqLY2GxJmJ9tn6BFBp4nDuri3JFUvL55vigEwN4jSsD5AZcZm
5531	coinbase	2199	720000000000	1	CkpYSVr2AppdBx9mbJpAoEBee9zJ8xA8S8xhbmr4fQiNnfATVGL3b
5532	fee_transfer	2199	10000000	1	CkpZ32wtUFTtA7GPymD3y8nj4m9cRNwvfrrddWEGfXHY8DHDMTBzD
5535	fee_transfer	1680	21000000	1	CkpYns8duEsdFKAGvap9ghojyK5wMsCJdMMnunAxPAdnwDRwEMFXf
5538	fee_transfer	1649	22000000	1	CkpZ9hpHHzhdYN2wyxzmDzaJuEKtdJ6aqEyvGLTT4z7GALoXWTuY3
5545	fee_transfer	1513	41000000	1	CkpZtcA1XdweWJRFJN6gzvTEEVbJYqTwarYbi1pG1jf5KvetRgqb3
5546	fee_transfer	1422	51000000	1	CkpZTdmUpCP2zLz2ZeKgnPggcXnyr4QasCBp2SkB2B5LxPp4Uxpzi
5550	fee_transfer	43	110000000	1	CkpZbVQuctFRxP1eagggLnpbSQSwYvE14U3iHFSmoCnEHaSa8SUss
5554	fee_transfer	1895	308000000	1	CkpYU8hNJVxrjHoHqdJaifYyC1yxdvetDRF1hbVrjBVXBs4ntE125
5562	fee_transfer	349	11000000	1	CkpYc1ttQvjyTFCvShh2FASvA8zGwuS6iYiw5CpjqMU443NgHQqAs
5565	fee_transfer	1549	24000000	1	CkpaFTHbbBAzbC9GeF6LbDL9SGMXALCVuFG2LvB1N6zSfX3436p72
5568	fee_transfer	1444	3000000	1	CkpZzJEpNKxos1JFPPWLDvvdsUKgiKHmFDeAZ7SQYxpSriz8dc3QU
5570	coinbase	302	720000000000	1	CkpZvp2zdwVgugbnxDY3k5MHZQaMTtVvV7DSEw4SzwPGVbaj8ymFV
5571	fee_transfer	302	12000000	1	CkpYfRXZP7r57BwrDUAhPteGo4K7jQnKBxmpE8mmqCQQGZ7JKihaR
5572	fee_transfer	1708	77000000	1	CkpZj1wR1tXG1BjbseGmb8z1ttUYUWnJRMm2tEbPKfpvh2NNpTRkF
5576	fee_transfer	1560	112000000	1	CkpYmxgymXUy4PnNfGn1ugJhV3g6pPm4xrNhabW3QDYoYS6P5HFXE
5582	fee_transfer	2112	25000000	1	CkpZRCjryuUQfZCYBQyrUeugk7rwgmyohZdEpnQP41TBMUDWry5ey
5583	fee_transfer	1455	24000000	1	CkpYx2jSDJL8LMgFGLqVsGs9JMF9kNcaL7M1ejXsiwwh1ELw2ThXu
5584	fee_transfer	1587	62000000	1	CkpaBM9s4WUmcMzgyH6ff2CTB22PjSKu8DRybP4URTyH1LaAgxHBD
5585	fee_transfer	1489	74000000	1	CkpZ8xNCwxWo9tUJoMGqUvdkEJf2xfdM7ifmyYboJzAyKactmqr59
5586	fee_transfer	1489	68000000	1	CkpZC6yH3us5E6erBRo9Fnbwq2ro89jz5FhbjS38SBaAM1SQoJ7PG
5587	fee_transfer	1688	74000000	1	CkpZBBcsrj4dEikcq8yxnTkW6H5MKZzN9CoY9qe4o3k11DKhpqqDP
5588	fee_transfer	1536	34000000	1	CkpYgCiEazLP7ZUPbCoX1nnKob2ovpSPkSDD4iAuNg9gDN2NeEc25
5589	fee_transfer	1536	3000000	1	CkpZHEQCeT8nZs6UPjVVuLRKccb7qm6fdc7tsA859zSemRmd4nyvo
5590	fee_transfer	1724	34000000	1	CkpaEwZDWxyShzz5jCoB99VkEA8BmdpkBHvqyUKntP4bUSQSx7vCU
5591	fee_transfer	1724	3000000	1	CkpYXqRerUTH3ZFf8eZWfhGcmDQ6wriayZoyzfUsf8FfdcXqvQNvy
5592	fee_transfer	1991	211000000	1	CkpZhD2aJM7eVLoBVYJEMA93tNKdbUHQKJBcHt8CjGQ6PcbBunmKr
5593	fee_transfer	1718	2000000	1	CkpYkRYHbkfiRp2ntFqt1fBDQhXTaj3Chqxk3afoxzWN8YYQuTsZf
5594	fee_transfer	1982	12000000	1	CkpZaqZRQ7VxmMhy1sw84sv75bMJvA99LgnoeEnz3Td7uCjHLARxo
5595	fee_transfer	1681	25000000	1	CkpYT1HoYyfadsdZtypU9RtvjjzPXWYMv5LM8xci4dbhp6MJhUUfL
5596	fee_transfer	1673	26000000	1	Ckpa4ttxDjM61Cr8j8AQxvvPrrRnSY2Sf73GCxsgR6nSAHP14cxwq
5597	fee_transfer	1643	26000000	1	CkpZWaiF9g4FkPp3y3Gm4okdqJMxrfjyjzf6BbSCwMGDUjMdNoS7G
5598	fee_transfer	1271	438000000	1	CkpYnKqMDHAkLLwsoc1yP8FpiZ6V3smQVXFpkNyAAZ895Ff5yyQbP
5599	fee_transfer_via_coinbase	1855	2	1	CkpZ6AWdYHxfHXdwNeKjzSe6kToUUgxSa1ZB42bmxk7FF17M7koQW
5600	coinbase	1271	720000000000	1	CkpZ54UugAFwxjTr4xH9j1h16Fr2ENVBLyR7V6BFq4hN6uVLJUdYs
5601	fee_transfer	1988	70	1	CkpZhuVptEV82nNWyN4ghhYEszWC1cb5enDX4XA3ky6iTH5ZpbAsW
5602	fee_transfer	1271	5999930	1	Ckpa5xGKdsVRGN6FYE2xv7GEPTaud2fAafVDbakohpGvqGGQWEmcx
5603	fee_transfer	1992	37000000	1	Ckpa2Qyv94uC7vo1fRGcfK8zyxz6HKuc3f5SyVKQKXw4YYRkDkPd7
5604	fee_transfer	1439	37000000	1	Ckpa29puLSEGEc7rmgJKGHw6FfQtxE65CHCkmgs9APcJQA1Bjz1mq
5605	fee_transfer	1749	61000000	1	CkpZvgWVYChyBrC5coagVEeZhY2raSxQtC1KQwQPfFumTbhYx9rMX
5606	fee_transfer	1564	13000000	1	CkpZxN66ciHgeTa16a79uKNRn5x3YiW1Do2e5d6XsvsfUpQjBuPsF
5607	fee_transfer	1571	22000000	1	CkpZrRsCXBhZ9MX4FmrFjkDfmReffKCS7D4wVqWQ5pkH8wdUMmadG
5608	fee_transfer	1623	34000000	1	CkpZWQhsFVEibuxr3zA8ubqKfQxhjZAnqEFtqsnX1LGo6c91Jd3cu
5609	fee_transfer	1599	62000000	1	CkpYsbS5igT5yHPsR7MB5kLgTDk8Vat8Fbku37rpeTb38zbmUTAE2
5610	fee_transfer	1394	62000000	1	CkpZfi6QqUtqxHNxk9PRbH4mAauCF5QzCBp8m3txwrEusrWbrGyzk
5611	coinbase	2100	720000000000	1	CkpYQr2Fgh7zSiW7aacSt7a1dC6mKEVNEm5KjBAHRZykGf9LKNit6
5616	fee_transfer	1696	62000000	1	CkpZ34T9Cq1DQvJxgP7ZRDec1A8TnAHnjU3NtiNVS4TqiwXi4QxiA
5618	fee_transfer	641	519000000	1	CkpZJTqqXiXL8aBe1fYiknxBBHNPcg4ixcSAwBz7sB4VXFqPhhKSt
5619	fee_transfer	1613	115000000	1	CkpYz8aFuYx9vhPYCN7VxBakfhRCW5By1n5fGeGzu4UxK9deb3Hys
5622	fee_transfer	1394	63000000	1	Ckpa1bM2JBVtC2c4LueEYNzn9RsftrGVSn8gDf3YzyWJvJx3xnc4d
5634	fee_transfer	1451	28000000	1	CkpZoUKUkL5rVs8rLLv8TaCbc5ZEYidUjJdB9tQ41cwq4JCs1CG91
5636	fee_transfer	1637	28000000	1	CkpaHH8Etht27g2pxoaAFYxVxzt1APBKHoLZ7AoYLE5YZ8ChhkKNL
5645	fee_transfer	58	78000000	1	CkpYkzBA11bceTiMixKqzMXRRV89AbhGt5VSv4c81tFjdD15xDaMD
5648	fee_transfer	1684	23000000	1	CkpYYysUGpUw4Q6fhVd5T9G5H5jm2p937kMB1TjQ6SD931C3Na1FC
5656	fee_transfer	1476	13000000	1	CkpYnWajhXjo6VqstN9wC6Z5xX8XJJYd5Dph2SMucB54k6XTt2Hrj
5658	fee_transfer	1717	2000000	1	CkpaA5A5PMRWmHAky2sVVzQgSrS44yCEc1oLTdTB99qomMcZ8yX5P
5667	fee_transfer	1394	136000000	1	CkpZvAsxaAgiXHyVrBeMB1Q5aAmytJMP617eSZcPBaS21bU2vgEis
5668	fee_transfer	1522	26000000	1	CkpaCWrKodqWfqgzm47D2RKZTwndSFPe8DW7huAHQnddQNseqjvsr
5674	fee_transfer	1422	14000000	1	CkpYYk79LgmaQG2FUrzxxs5NxKF8fogZW6Jted9n3C13ApxUwiEsy
5677	fee_transfer	1444	14000000	1	Ckpa53kRJmBRVDUa1vcApo2eRCDLJbkxnWzGEHuXR2uDduqayPi7z
5679	fee_transfer	484	22000000	1	CkpZJ8VXA8iQCMRB1HKTrHEiSqHw4TENN57E9LuwmkqNx8Ta8Z7Uh
5681	fee_transfer	1687	25000000	1	CkpYm2AjoMQDvAKp25NBb4JAg9n6n11zD7zXo7FDmwCYYrzPWLycY
5683	fee_transfer	1672	37000000	1	CkpYzLiNtYRN2xYHNA2v1L9P98xETeHxS7jsghJf28zzgW5PdYuD7
5684	fee_transfer	1693	597000000	1	Ckpa6thFT3FJL88v3S7M8miCpp7RK9yPKf5jRoY4cRcU8bKfjXH73
5685	fee_transfer	1546	65900000	1	CkpZrqZaZLpHfM5QG2gaBCchUPgQp6KXpYwRFwLUfEAoaxrm99KcB
5690	fee_transfer	1508	37000000	1	CkpYS36zcB3aeTkchBG5Xh1k3mPLKDps8dpLbwZ7VKcMYPvPGcHpC
5691	fee_transfer	1556	137000000	1	CkpZskrMNBK3EK5fKM8PSedwS37NRATfHHfapjrsKwnMfStDuenUe
5696	fee_transfer	1687	36000000	1	CkpYtLCfQMxjtKrG6dTFb5usiaDEwZc33u3P7RF6H4MaA7Ldgpk16
5704	fee_transfer	1546	6000000	1	CkpaDXKyemzp29tZEZCKKVmnmfQsvmbCb1T6ETY8QXsXJCqdrwM1g
5705	fee_transfer	1546	473000000	1	CkpZp6LX6TkAwDmR2UR79uzUCLpeJ1oM8a3zgPaunCkZnY9CCA2MC
5716	fee_transfer	1489	82000000	1	CkpZqdFd4xSPa8rn6TN84D5BYnjgw4m9jqfvxu1CQEY5f8N6MMWJo
5719	fee_transfer	555	41000000	1	CkpZRHr7Jun2NiAZw5e2tCJhA8ffz7tPRqiTfxGQi1fgjhG2SwgiZ
5722	fee_transfer	1560	144000000	1	Ckpa6nzggsEDEvBkNQehzo3RhHvBqzqxGw4jeJ5AkVWUUtwpZ16qQ
5728	fee_transfer	1601	71000000	1	CkpZWraNnCRoTND7MndoQHDeEx3bTVs6XD5zy3ngAAcdFHRYVAKEP
5735	fee_transfer	58	72000000	1	CkpYdwWjjaCY44SbSoaFENY8JjWJysmSqf98GKTNG6SFFuQL9fTYF
5736	fee_transfer	1680	72000000	1	CkpZS2Nt8gszde5pMkiJ17bKoAEbYtBJraVUJ5xWvyb4XRmw5PQ7w
5744	fee_transfer	1419	72000000	1	CkpYhUbLtMuzzAdn28w7jPdf31aJok8tPPd4ViNWjkBaPRW8GeLWX
5751	fee_transfer_via_coinbase	2128	1	1	CkpZT8eYQsUVtnU4TwvyF6SNUPAwAo2CuWyUd6377c8SDSYcdJ6WS
5752	coinbase	149	720000000000	1	CkpZeuWeygQBEw64Yso2JvPhadbCFvr8f7CHXnDPaGEaNPZcPPFoL
5753	fee_transfer	149	11990000	1	CkpYa8Nr28xunT2RYwgyqw9a6m8zsg3BerunKeTny6DJhATH9jREs
5760	fee_transfer	1694	310000000	1	CkpYxj9DFzzRkKxFo5dsmGDez9CwL1Ss3EtodxYsrkjQ7QPqD5V5H
5761	fee_transfer	632	345000000	1	CkpYqNzLm1ZCzwcmkJ4kpAgh1pMJfhLFXxzi1rjeRuHXaG29in47X
5764	fee_transfer	641	347000000	1	CkpYkzP57rkjC4dhqZJrvZK1FaCsPngR6wR7cCn4FcstjJs1RFpw4
5765	fee_transfer	641	7000000	1	CkpZqcm55z74b7nKyabtveiuJwtyrVaRFJWr6jR1diva1D5Z3sqcm
5766	fee_transfer	1476	36000000	1	CkpYRu6QpaQw6VBWKbPDz1srdETWD3c9tzuUDarEHjBp817tng99F
5767	fee_transfer	1622	25000000	1	CkpZN2a2xbrHNRCbdZyjwVgknUnqE6HnCePbPdJoeMzA2poAsJnMt
5771	fee_transfer	1593	413000000	1	CkpZPq8zcuucDRBz5jaqZuhXq192R3AD8ebsWJCd6h8VhyavkUJR9
5773	fee_transfer	1699	413000000	1	CkpYV2aR8YkStZKgxx6FyAjmUgDKM3kEUxPYUPmh6zri7tpQj1gR4
5776	fee_transfer	1693	46000000	1	Ckpa1auwgqk9awbNXCrMLJbNs7KghrqziypJVoyhh848sJ8zo1S55
5777	fee_transfer	1515	22000000	1	CkpZneaZWM9M8EZUmQ1sw1KaVfNp29tYSKrSGrR54EAB933RpqBtW
5780	fee_transfer	1555	401000000	1	CkpYa2GjCS7NMcTzhvH1Y8ebVhA4s3CdLesE3PiFAhDKSGXhxJ3J9
5789	fee_transfer	350	12000000	1	CkpZAV85SECS9FNBLqVMSfUYgCtf8oysnFm8FAeTK9jchZZe6ECay
5790	fee_transfer	350	2000000	1	CkpYZoaZJbmsSzxgmVcQRWsLj75PfcTn27wHy3hv2EXLCbyc9BzDc
5798	fee_transfer	641	142000000	1	CkpZgg3njeGHo6iBshuNGGaoHLnNekuwy3N82TUxVVRmcizHt4Ljs
5801	fee_transfer	1694	65000000	1	CkpYqGQm6HVk7o59dBGtQSrgcyqsVssZF4HnxJkX7Nt2QUftMGLNP
5803	fee_transfer	1850	213000000	1	CkpZJ3K2CqYAMDvj71Ma1MCPsBPbQcCdz5HtD7TJKSQzEmMqCkcrc
5808	fee_transfer	1714	34000000	1	CkpZxgmfB6mDqR6hRWjepgbFpTGJu6omxyWcmBoAh4j4NQq5ToGSt
5813	fee_transfer	1717	87000000	1	CkpZfSbJnvgDJJ1o7JFjDGdroT2tEetpKZXthdpkeZPTV7r7WA7Xs
5815	fee_transfer	606	49000000	1	CkpYWvZhQDfYscfkSKHQadQF9HH7tBj8eDJybH46sv6NxME1qxBAv
5820	fee_transfer	1747	25000000	1	CkpYa7xrVjS84AtCCR28J2EDRLoA9oLWiZcuvrXQgD14vyApB3J8Y
5824	fee_transfer	1680	36000000	1	CkpZow25C7J1vZc8apvAYmuvjXH5bUdjvApkDNVxMHu7tu14rtK11
5828	fee_transfer	1394	122000000	1	CkpYymi6cPEwZgiyp78VK1oXtnUdhBkwgMzYPokS1FzfmzJ7pWdXY
5830	fee_transfer	1675	113000000	1	CkpaDVGX6dWakSt4pW5pCMu5xobyE5yGv57aGpAm5QgFoK9tYwZwh
5837	fee_transfer	641	122000000	1	CkpZcbEVGG8fyP3wXYEoQUebYB6iw1wSfYeuntoG2A8Re1uZQrbz7
5843	fee_transfer	1549	14000000	1	CkpYXQd82Vy57kbVf9W86mY9ymMwT7e5hnkpSgEBfYucyy5ywDoZc
5851	fee_transfer	1690	548000000	1	CkpZwTdc7nwCDAiwEPdqaUsKvia91iFn1Hzxqhbp9CrB3tMJMnrR5
5854	fee_transfer	1394	42000000	1	CkpZqoLYVLY1vyfLZoHK1chRQ7k9sinFuYQ7SLMGqdntsVRZDxEsy
5860	fee_transfer	149	318000000	1	CkpZ8U6MLVERZFjoaNEYcAzQFq1AgFnxKM9pu5xPjxGiCRqGVjAm7
5863	fee_transfer	1691	312000000	1	CkpYUxebppULXyhwYnXvSUrQWZ7yZ3ccqSP2M1yL5gN2r5wRwRnog
5865	fee_transfer	1692	163000000	1	CkpYuYvy2R6mUYXJZ7tUuiur2iWwaJduD5ZjLdWjQJMnkaAtae4GN
5870	fee_transfer	1692	5000000	1	CkpYZwebJY3fuVw5h8o15oMeiAeZ7sApPgeQVLWU1Wm4Ycd1Sh5ki
5873	fee_transfer	1991	74000000	1	CkpZaUvauKnMikLwm3pnLPXcMejaryFrWKDqH9bTZcgdTTSVZRvJv
5879	fee_transfer	1536	13000000	1	CkpZXsNTMQpZZd3SAdUDqec7hGD2mtMkBV7f82zDdeQ9ZBVfQK8r3
5891	fee_transfer	1764	137000000	1	CkpZDG82s8Ad3oX4oD4JVamPNS3rsz84FKfB3xUrqTmnCBTaQcKeG
5892	fee_transfer	633	24970000	1	CkpZMCRehK9Rhz9Nd3hsYqFeWcgLWU5hFhuRLQTFPwnsHvuyLL8tx
5612	fee_transfer	1634	106000000	1	CkpYm3919baFvKbRmqDXyVmzMHfCRfmbseUmnJ2NchjWPwd4xq363
5614	fee_transfer	1690	106000000	1	CkpZ9mM1VuUxg245i3NTTKMcMGTMmD8xiqoSYHQHuyvrDgigiQEFN
5617	fee_transfer	1455	62000000	1	CkpYztoALZHz3yjKko7aCesV1MYkopudGmGoWytQ2i6GR9e8HjzNH
5620	fee_transfer	1613	36000000	1	CkpYadwWJKyzAF8wxSqiRkXRcCpYcWRZCnnj2ai9qsA5KLp4mcgFM
5625	fee_transfer	1394	137000000	1	Ckpa64exPAiAZStSqkzgmGfqcknGQhZPNXfeixjxZEaNEAA8d61iJ
5627	fee_transfer	417	40000000	1	Ckpa1yf64gXEvfGnyjos7B56uLNvv1NLHGDL7tN2uAb4r2LNKtVxK
5628	coinbase	417	720000000000	1	CkpYwdBAcumzWq26KJMiRXqdH2B39zNyegZe3xrWmRS4yYR8iiBuK
5629	fee_transfer	417	33000000	1	CkpZsoBGYWNxpWnfWLdpoCuQeZvTRp7WSAVmrRb58nJJLhBdDBhZZ
5631	fee_transfer	42	13000000	1	CkpZmpFcZa7NeFxyDuWqie9q51EB7eWDT8TRa2C8snAXBnTwWZkbt
5632	fee_transfer	1692	87000000	1	CkpZeCyxVCMNDhymVuwMqXZxCtdPX5nSZEjZfyjZYxr7C8udFvzdT
5635	fee_transfer	484	28000000	1	CkpZZVPDREM5wrkt5JfANMcBaJn9eay9cvxcXLHKvfwN5zBaQtycV
5637	fee_transfer	1394	28000000	1	Ckpa54QhnYQMZLQ6zzGSmnwVGfFSwXfGod2ywkftTDieVhwefTbyj
5638	fee_transfer	641	180000000	1	CkpYrecVLJcemLdJa8Rkb7CbvBecvfzhPU2srYqPGhiKRt3mZWw9a
5639	fee_transfer	641	74500000	1	CkpZNjxxsAH2jHYzmJbbv5gLxoCamp7CmndkvvAm12ABGRXLQjcbf
5646	fee_transfer	1700	78000000	1	CkpaGYCUAL1jE9RKqF5PcoqgboYyPAYsxKqweXKfd5PkPSie3mSMz
5657	fee_transfer	1455	23000000	1	CkpZADMGWwDd7NjocwANBfdF5UZufunWx7rT3myXCehNr3G2kaGAq
5660	fee_transfer	641	10000	1	CkpYmdHUJEezhhMHko57jPEZyPLA76kqs1H5jQ8MDa9UDaTCSa3jx
5666	fee_transfer	1762	3000000	1	CkpYngBiMF4Vq7bML27PoNyXcf7YczEsHijLNYzr2cfuZGSZs4Uwz
5671	fee_transfer	1476	63000000	1	CkpYwxD8cLvTBhLZiYiQUfGQrJipKg6u7A22qGS44BNPpu3ANB1Az
5673	fee_transfer	1727	22999999	1	CkpZz2mGTy2w7t6bZdH9HdEQgRFaCLBuXEgcVqMjHQ5gwCro9rrXq
5692	fee_transfer	1556	25000000	1	CkpZN328xhTSZykFkxA3CZcFXYSEq9mHg2jftvvsRT9ZMV2c4SaZi
5694	fee_transfer	1555	36000000	1	CkpYg8AwkcRYpJo7KPj4uE3PcKzmTEaWvfPrvNKCec2vSQHGUXnvH
5697	fee_transfer_via_coinbase	1855	200	1	CkpZEJYrpJtt8ZPQRAd8H2EnJtoCX8bAr3hX3haGRS8PPPx5wqXTG
5698	coinbase	1688	720000000000	1	CkpYWxegKazYXB6tP6n2FZ9AvU4J9UwxmazhUf45Zr2qxwueq2cXd
5699	fee_transfer	1688	5997400	1	CkpZaVZC89PuFRVWjFqhfBpNKsrt4ZYRpEjXPXFzBiP9JTmHPWVXV
5700	fee_transfer	1855	2600	1	CkpZZbs1vRDVzcjL782TvdUWiVHjvvoPNob2m879BQjxvSiu7JweB
5706	fee_transfer	1693	25000000	1	CkpaG6ggHkZ4kSE7pntCaosv9M2EQTrwgu7kD8Jfi616MfgdPuh5N
5707	fee_transfer	1613	49000000	1	CkpYi9Yi9Q4Mtg6vrEfUpGnztqqh6u3P8mVbAN1F4wWLyChLwoPGQ
5712	fee_transfer	1694	320000000	1	CkpZBwMv8RNVYJRc4txtX6kbWtC9UuD3c3KTeg9uC4aLHoKLNLibM
5713	fee_transfer	1694	84950000	1	CkpYhsuVcwpXX24uXD6fvN9BiQyik6ACP1EHKrV1Y3gqy6rq4A4f2
5714	fee_transfer	1536	41000000	1	CkpYoqWfSrAQ41gUuEDjhTmWRaPSsH27LJrVASsrNweZowhhJ3dXR
5715	fee_transfer	1691	82000000	1	CkpZ9WoPK7gHtuA9VQjgTvgrJDL7Jdy8VM4ubnGcgRFfALPqLPB22
5721	fee_transfer	606	144000000	1	CkpYtuT6wSezNaxRmmCem4VHELPf9TM3nG1dMSoqkjkHma8n923LR
5725	fee_transfer	1513	60000000	1	CkpZcZqTGcvfrYaJYsdaaXQP6R51cfZGukQR2d71E7snFt2sLdA7G
5731	fee_transfer	1690	72000000	1	CkpZTR5yRx152zhhMasPLEHaKyW85UPo8oBrLvfsDfVa4Bp6rTdB5
5733	fee_transfer	1680	82000000	1	CkpYiSEsa1jfFd8dCZC9xQZNaoW1AEvYNFEtWHFTeUNXKS7sNrDHi
5740	fee_transfer	1694	62000000	1	CkpZd5dxs41ifA6qvSgpaZHqWVEKvR6s8h2tmMF8vRjBCUCy6ro4m
5746	fee_transfer	1448	810000000	1	CkpZ2QAY32grzhAVXCbG8LWQ456ZqU7foSdHuWYLCdh4GeMGCDbMP
5747	fee_transfer	1448	440000000	1	CkpZB4Ayq4LG1DvhUr6SU3noqqxJGL4RisWRz97Hm8yo9Z6UUd67h
5748	fee_transfer	1422	24000000	1	CkpZ2ZVTNJGoY58Pgfjv4uWceYbAjfuAjkcw1fyivwsQRbLtCoUEQ
5750	fee_transfer	1439	32000000	1	CkpZYGNifMTBicNJNmSDMkuAVyz1Tz37ZGeEHEsARqDzQkfExwr4s
5756	fee_transfer	1706	45000000	1	CkpYjigby1MM1PHnmKmeskBSwMJLashK8CacxncXACKTFDpwNa9c1
5781	fee_transfer	1696	3000000	1	CkpZkgW8Kst4irRSJtJyZJqyBrBPo5FdyoQDid5QtN2ZSqMzqyVHj
5787	fee_transfer	1695	15000000	1	CkpYo4HWbzkjxrDw6UEK3SXhuzLE1BSfvg6hfE3CdjXGHS6fjSQ96
5795	fee_transfer	1759	92000000	1	CkpZ2MfQ8nmvYybkpV1ykWZWqcQeakUm6gsCoUPAvnEofBg6ozvtA
5797	fee_transfer	337	11000000	1	CkpZyrjxzjrJk7e6u8uJhDLdkvDrvD4zN4PiGVc2MBtwt3HtKDaWE
5806	fee_transfer	1688	32000000	1	CkpYU4eWen85fc3VooHRHdnbyrUGY19oYeMpzX7N1kXvssvpLiue7
5810	fee_transfer	632	1250000000	1	CkpZaL9S9o7BqL82EY8uysg5P9Djdyyf6RWtk8vfBq8hkjkHPd6sY
5811	fee_transfer	632	900000000	1	CkpZ1XvdeXjcRXWesAn2e2kUuF5bUFdx7airYjwT5x2zxcNGHK1ud
5814	fee_transfer	1690	87000000	1	CkpYnYWDfF8r5p2AK3pYHZSMdBXi5puew6hBk5YsLr3ybf8k12Jz5
5816	fee_transfer	606	41000000	1	CkpZiQ58aafjykdDEWXvtvRoGbYQeW44uhCcF67bUd52nrEc2t7op
5822	fee_transfer	1471	25000000	1	CkpYzKeGuj1SVV8vYWt9S5kCwYmpeWCuogtFBiaSWv1AiYLh8nSCJ
5827	fee_transfer	1768	135000000	1	CkpZn4ZzZdMD82oZZxc6QQbH9qqJo6RoZyntdFTpNn3uVN1mMTjKS
5835	fee_transfer	1684	32000000	1	Ckpa96wjAdh6mmjsoGow7YjRjhRMaf5bNPuM47jT1HReRETexLfPm
5836	fee_transfer	576	122000000	1	CkpZCpSf6kXwtdBeCzprow2pReiH76iDe95TRy18dYQFvTADU6pXd
5839	fee_transfer	1764	122000000	1	CkpZosGQTcYbYR3njJocTNS1jhCZiGVH2h2KgoSaZKjms159RxBw7
5841	fee_transfer	1717	15000000	1	CkpYiAfGvPHBkbp9GQr5WWJtWsUYPQRVgVGXUrMAvtJjtsqpdDWVJ
5846	fee_transfer_via_coinbase	1607	666000000000	1	CkpaCVLhbrBs5b6fqThuihj2aD3x5K8ZCZ68W1XKuTKLArTrA4eV5
5847	coinbase	1560	720000000000	1	CkpaGziiN2YEWaU7AWctHERGvfskHZAkDrZiSRtHeET1nuHAzWJRF
5857	fee_transfer	1850	63000000	1	CkpYw7YCJDDsd5yNyiEwq8Shp9GXCcHL4nwAs4ddRcWmasGrVs3EN
5864	fee_transfer	1395	163000000	1	Ckpa7j94DKAsrYGtsPUMcwNAMHmXRDn8nGx8tFuPCCoKqNZutjtM7
5867	fee_transfer	1547	180000000	1	CkpZAvLWhKaiADDMLpsovSAHpxNz6Up6bEywDXU73CTHK8Kk1h6y9
5872	fee_transfer	1439	347000000	1	CkpYdRN2qx4u8Vq5gkTUFNw5BupRvJVyFbTRGtNSeKXRaXeuArePB
5877	fee_transfer	1440	63000000	1	CkpZxQVeXmrZWN1HqfTSKhqDocWHTnkaBDc9UYLmbbd4xfn36ad7T
5880	fee_transfer	1395	43000000	1	CkpaKM9o3Kegi77DRbH8euRc7NNgyWJG9dbUaBjeX9bEW65od8TtA
5885	coinbase	2248	720000000000	1	CkpYgTWMHnyJRxr5ZhzLT6w4yesQGwbQxWfKaqAkUUHS3URNu1224
5886	fee_transfer	2248	240000000	1	CkpZwg3Q8uVtFrJNQdih9g5D7mqyjagEZ7UdEXiTUX95HvwyYa9wf
5906	fee_transfer	1689	24000000	1	Ckpa6atwkmW2kmu9BaRtqXcBP85pfzYNWXw11Mj23K5t8j6bkKZTj
5908	fee_transfer	1395	54000000	1	Ckpa5RebHDY8q2nSAcDar2KdV7Kj3C8s7E1cnQBcGAY4CmHnY6Hpp
5914	fee_transfer	1992	46000000	1	CkpYfS2J35SCSzV5rFXb2S9KEqzMrgjdPUvqjxf2zLxrwA3SYZge3
5613	fee_transfer	1681	106000000	1	CkpZ7cvU2f66RtRF6QN7WpDnfQjBgAAD5rpRu15AXW53uS4iCnPmD
5615	fee_transfer	606	65000000	1	CkpZBDWBUQ2vM6qeztGUEcZUYwzBNqzpUv3sNaP2cQ1yJPNjGcoPu
5623	fee_transfer	1395	137000000	1	CkpZJcaeGDdqp4DNYU1X3bgRQUC1qhNJLJZuh9tHR8xHrCmdeFK9Y
5630	fee_transfer	1573	33000000	1	CkpYsxngCjypcFUcaFomejBRBs2P9iD4Y9sK56ebfVAuQHRocqJEw
5640	fee_transfer	1688	48000000	1	CkpZ2xC5SeQckK9rSBn5bp575cMe3aJw3QjQqEzaTa69QXyKF3PaS
5641	fee_transfer	1444	78000000	1	CkpZQq5Lw3KCLM47MRL2VTx5xrDr4aYdjBcJtK9qFkeowzLuq5kmi
5647	fee_transfer	606	78000000	1	CkpZY24JHcgEnr3GdRw1xTLUeXENWPoEtBGpGqz9uELdEvqcjoM2q
5649	fee_transfer	1672	1798002	1	CkpZCKwKd8uX7nYr9eS1vKCy52LeeqiXBXMjUfVCR9EWfZurZ3ymM
5650	fee_transfer	2221	100000	1	Ckpa268bwoN3fsGH37PeRKWPuCGMTHdtYJjh9kx4otqBDmBD1Yg4q
5651	fee_transfer	2097	1998	1	CkpYuzG8Ux6DE7H15jSgdPmD3xDdDP2Z2yu1ZDsmiDHwBkxHavnQ7
5653	fee_transfer_via_coinbase	1447	1000000000	1	CkpYtpPvuaQC8Tph13ph8fLfeqW5dW1u3YtVLjGFYeLaQrfpczM42
5654	coinbase	641	720000000000	1	CkpaDw86B5iNHABFs9o1LqKi95PfNfxfFDL3obXNWhsVDJpGXXJES
5655	fee_transfer	1850	13000000	1	CkpaGaAUEkRJRJhZnjVffm9md9P5qL6YGyhv7X12VpxrSa7yZcRnj
5661	fee_transfer	1694	1170000000	1	CkpYY2AhiXnGGZsqMbVBroP6x3oYwKtgkM4jh5PCtka5DopZt6cUi
5662	fee_transfer	1694	270000000	1	CkpYnXLHwnLoJP6wQ24CyeNAUHf1F7ckdZ5YeVete6Te5PXPDfDSU
5672	fee_transfer	1419	63000000	1	CkpYwATSmcPvBpWJKrpQD7UfEvty5dMJJXaV2eN8WfN3mgAvy3ABX
5676	fee_transfer	1489	16000000	1	CkpZtmo5iwdhr1n4Skc5nMMBz54XRWs2NSrBWDdkbzEbwhMeiqKpk
5678	fee_transfer	337	3000000	1	CkpYSNf65gfQA9ASN51hKFqEeHBKT3bvki9zPA2LuWAGXRtkKnXRk
5682	fee_transfer	1546	135000000	1	CkpYkp1JQjtxBaP893uscmkpHWE3ZetX91ZRvWS3wc3wo4Ee1551P
5688	fee_transfer	1759	22000000	1	CkpZm8ktuLfheghKnWcrVQCMYuaazbmCaRgMEY5e8aH2VyZjwA5tz
5689	fee_transfer	1439	13000000	1	CkpZhJozaT3EwLawK8dojhJvEui1weje6Msfumed8nr7t1rbQaQzD
5693	fee_transfer	1556	154000000	1	CkpZPbK19JRQsrLkdXENTuRekoZNXXrEVncGVy1f5oPPJsP2TnrUo
5695	fee_transfer	1489	36000000	1	Ckpa9EK3nZND6M3327J1KE6Kmi5ZNpLHFANqG7byJVEtLWjy7DfMS
5701	coinbase	1546	720000000000	1	Ckpa3yCrvBbi4oxJyXXDSnX237Lqnk399D9hBswxJP9qB27Fp18Di
5702	fee_transfer	1546	5996000	1	CkpZZJCYyuoFKvxdNM8Gd2otfQyiGxvKhr4XUdTuJiWBG9mwCrY3X
5703	fee_transfer	1855	4000	1	CkpZDhrT8ufDKK1ecm3ZNtSTQ6REQUnaZdDqx6mxfouNmY4KmHnFu
5708	fee_transfer	149	49000000	1	CkpZt3rgV2MrWHPt19AWZpffLqCk1y3VHDWybRgtaakzMnC2Tqi9N
5709	fee_transfer	2086	140000000	1	CkpYno5zUvQdSVuakmEZK9tQqpSZvQdzGDF5u5v8WQMJo2Fg5awi7
5710	fee_transfer	2086	117000000	1	CkpZJNuc3B47LftfMJfCEhb5R88kLpPq5rEv5S2NeEyZ851VHK7s5
5717	fee_transfer	555	62000000	1	CkpYk7YjVyy1uBMpPk9MQmBvyN6EMarK2K6axoPmh5kYPh4SnirBt
5724	fee_transfer	1759	144000000	1	CkpYb5M1wyQ16djp5HRCwWuonfANe5LSnruG2oc4i1FUu3MG4GxXf
5726	fee_transfer	212	10000	1	Ckpa3LrgFhxpxKfM6Au25zWqmFBkN7hVrUJD6XbmYeV2yeSuym181
5727	fee_transfer	1601	71990000	1	CkpYnQdp3jHeWkBttbexEo8UdLpGNyhKPpY5j9zidQXo4Qxq1EMcD
5729	fee_transfer	2086	73000000	1	CkpZyCiacfsdKw4yrJ8f9p9YnKq66cR5bL6vz7kEybXcxSRDTd9Mw
5734	fee_transfer	58	82000000	1	CkpYmhMvfgG2w6znkqF24Um7hVuLfTMFWXe71G1uqSfPvBfXKM2n5
5738	fee_transfer	1680	61000000	1	CkpZiJ6YVopga6AoQ3YmGpXGcwVHTAJPKBd1mVAWeDqpvz9SacfsP
5741	fee_transfer	1564	62000000	1	CkpZ1T5qQZoXtcdgm4fLWgk5YhY4EefDMh73QHfzEnP83yGwNkJHz
5742	fee_transfer	1694	490000000	1	CkpaCSp4YSci4KaeBgjmMrWESr3FN9XbecBTyrAVzUhY1uPTGqe1j
5743	fee_transfer	1694	481000000	1	CkpZQw5mr531q4SnvfuoeSiGAJp23zZp6Askpu3Dwzo4h7rQQPZcS
5745	fee_transfer	1701	134000000	1	CkpZzW7QC5h5YsbF1UR58q8tPweF5pocQebS9xhtSmu5yS6z5UiVn
5754	fee_transfer	1719	1090000000	1	Ckpa8k6LwpCYTHfZGR1zp6jMGWuxJAynXSSBPfAxQfhnDZrHMgjNy
5755	fee_transfer	1719	160000000	1	CkpYoxkjTzZ9VxMoaJcjMc6euX7oDFvmJtLkwzwRqwSXSaC5SQDU6
5758	fee_transfer	641	48000000	1	CkpZUz6JL6epEV19qVb2sq8vTdqR36QwXCu1nPmErvw2R793QoJHP
5762	fee_transfer	1991	19000000	1	CkpZ7SkFqnNQWyNJJ5ZUfXunrevS8yMGuB6q4Ga2Z1UUCAQMvsxLU
5763	fee_transfer	641	19000000	1	CkpYnb9NZL6nQUHcJp5EUKjgJquzyVEqQVXfFQVXuzBBxfrsbxqbE
5769	fee_transfer	1605	11000000	1	CkpYyL9RkxYfboGrm3JgxtZomMMCCADFZA6GfgC7mDKoyXeobdHHu
5770	fee_transfer	1605	12000000	1	CkpYhZ37uH3rT3SoqeNkHhYKyEGyE44BMN6wNc8pxxDGEEcz2ZnwZ
5775	fee_transfer	1467	46000000	1	CkpZq1rzUpfwj8WabKpe2HQgyV2MxnUMuxvyxmkvP8fPzWnrzFagJ
5778	fee_transfer	243	12000000	1	CkpZaERWfkSqsmFewT9QYN2uPanURA2xxuvmiMNE2vJsnvskvRad1
5782	fee_transfer	1423	3000000	1	CkpZJpKtE7QW1iwqeLrKYHKR1ivv3AFm9ca1iqzDs2nehkRhC4phP
5784	fee_transfer	1724	25000000	1	CkpYkamnZ376HE1mtYP99We8qXDodCBdbBfHvADEPnFGgU68PYCQy
5791	fee_transfer	1440	1996004	1	CkpZaPF68eH8cnnQuBhqSTHPGZyTbmLW6o1PHZ9e86pSReZmwcBRv
5792	fee_transfer	2097	3996	1	CkpZTLvNUKYwtkj5G1BpoFp8GpSqCseEsTFXjvhbw7bfnYvdbM8hT
5796	fee_transfer	1764	92000000	1	CkpZK6MoZRWnqJ7Agi5pmDDNaAF3SANyaA2CEBwSC2VnZKyXMgxwE
5800	fee_transfer	1688	65000000	1	CkpZbcEve36jzsr2fqWKubHyurRJ8Aij3AvtijAZAWMgeRcz7dby2
5802	fee_transfer	58	37000000	1	CkpZKNgoSfGNW8qSBwzSBbm5RNGFGsK2SP7znzqwtgPupxfpe1evn
5805	fee_transfer	606	112000000	1	CkpaAC2CJhJJdqKYF8RnrtCTVmfybndX3ddRAcYKYaAJ1kLB7N9Qu
5807	fee_transfer	1670	34000000	1	CkpYksqSuDuHG7X2cf3EDRmdwkBLPotW4nK4mUjREdsBh6ufSyCTC
5809	fee_transfer	641	582000000	1	CkpZUWd2MUwx6CFxHYtnoEbNqN5FQBrAdN51QzAZojkPZCbdxTcpA
5817	fee_transfer	1547	1120000000	1	CkpYiWkuhSwKoCm6zCZY5LjTgCGWJKqiUYPgoF9QdxHmG9PUFyw3X
5818	fee_transfer	1547	1030000000	1	CkpZVMDGaCx3N8e1qYAQ5DaiAyxF6WUaNwnxsV1kn2gDcTUMtjpHN
5823	fee_transfer	1704	25000000	1	CkpZ38eaRZhRoyNa3QebJ21JD4kHg34bW29Zjcch3ARfGTuprtmp9
5833	fee_transfer	1692	113000000	1	CkpYxKSaLXzGCqEwLizFg36jhoTZv8jd5NGJKMgisJo1BjwbZDiVZ
5842	fee_transfer	1457	28000000	1	CkpZCSsvJm16cPZ7VEytrFgygTDtk26pyE6owRLibaNtc1KZFeDyb
5845	fee_transfer	171	222000000	1	CkpZFV6SxRKWsPhE281awMxHR88X58chPoAqYJDA3E2T9ZGcExHFR
5848	fee_transfer	1610	152000000	1	CkpaDHW82uWdJpGjki8JMHv7jgwTZKvMUBdEgbNBEK9nyD6MfxfhA
5849	fee_transfer	1681	280000000	1	CkpZPcEqVFekMLrofRHHJb1DcuYNuM5cvugYBccTR1FtsWCqgGcLN
5850	fee_transfer	1692	42000000	1	CkpYiY73Z7M6sEa8yFZM832K9k6WgpVmSu9ZU9ip6ee8NRiAunYMc
5858	fee_transfer	1489	63000000	1	CkpYrs5rBJGidZtyJqx2a7VQwMiAfBYg4hteAYDUEoy8hiqkKtEi3
5859	fee_transfer	1692	102000000	1	CkpYacyNL9p6F332X1E95nJWGMvS18dSQhxhju9uLkaQT8t2Fb7XH
5621	fee_transfer	1637	63000000	1	CkpYoFA7kH2FGqLu79JrBFm588CYurueR4hkZwwuzhENDJmZyW372
5624	fee_transfer	1719	137000000	1	CkpZcBnoJ4TTqQn6LuV6AKi1AbETjSJwDcCgqLr5TyWVxFKsYE6g8
5626	fee_transfer	1692	137000000	1	CkpZ9MjTJWs2STcSBkYeN8jWekFtf76ZFStpJxrqsw3Aedj8Ebm9U
5633	fee_transfer	1588	28000000	1	CkpZxqBSSqpRzXPabRwrqoHbjEeCrKck7J17Cgmy3rimyDGSutXp7
5642	fee_transfer	1444	151000000	1	Ckpa6Nx6h7KSTPqxNXBnTVCgRYhr1JsogMAy4MhL1AWpBsQsifDwo
5643	fee_transfer_via_coinbase	1758	100000	1	CkpZLXnwXYPZwEZB8fV4yyEbm7XojvBEBuQzoR9wmqNJJGPBttLut
5644	coinbase	1444	720000000000	1	CkpZD9i9uBU3ZpMSzRzoheyREmiRtyC36EHFEvjPJqzPrWEPP5QLa
5652	fee_transfer	1992	25000000	1	CkpaC949Jd4AgF8e951pBibFjdsz5zbiEWD231yqPkgV1HirmxbWw
5659	fee_transfer	733	13000000	1	CkpZCe3JdyiuzREd1wD2uwyN6dTHNMr722rE5Syfmn61cBsuDBkE6
5663	fee_transfer_via_coinbase	2150	100000	1	CkpZSovpQUkWNSZhPu9pTr3nGhHgFa9Hswd5ecR5YDZdgRRLHBC6w
5664	coinbase	1762	720000000000	1	CkpaBBChHAjoVDEMiHrDqo4HxkDcHRMy9WpiVBNiQV3QoGV4mF2om
5665	fee_transfer	289	200000000	1	CkpZVchTKiUXsX2RY5Q3mPoD7725vUpp7StnVq2M6N15EKao2gocD
5669	fee_transfer_via_coinbase	176	100000000	1	CkpZ4m856YJwhBA7ZXoPYkuJkAnN6dCAxaED63CDpUHv5aAcZx9ky
5670	coinbase	1271	720000000000	1	CkpZiqEmXxb94UJWUZxQ1SV9suKNiePX2TeEUY93ZuZkHMrnJLemg
5675	fee_transfer	1701	38000000	1	CkpZ5UB5cpDhjDZ8SuQqwzh1YcWaotCAsNCteHnR3yRM3cnmfqkaS
5680	fee_transfer	2039	17000000	1	CkpaB63XLLHBWxHyHRpfEj3kfSt6n7782UvddTzHnuSH52GDnf6dj
5686	fee_transfer	1451	950000000	1	CkpaHpyJi7JXNrgTEcb5E9i3BFeqKbZHPbhESwVQw9eMb4Q4gpa2x
5687	fee_transfer	1451	93000000	1	CkpYrG33AJcxfk4on3P9XrGWsVDCaSJsvowG8yWraQAqx9MrmEgdi
5711	fee_transfer	1560	25000000	1	CkpaDwtpKJ99Hmcc7tnffxgCSmeP8KU348QjFBfZ6ATQtfqPfxsb4
5718	fee_transfer	1690	62000000	1	CkpYqFN5SVUzeNaDMbEU5buLxveg2EFc399FKo5qeak55pL3HFvX2
5720	fee_transfer	1395	144000000	1	CkpZP69DvDJbE6NXS77UgnBUEcd9RRjLpuL87fMQdQwhhbWXhQGpR
5723	fee_transfer	1394	144000000	1	Ckpa5Xgz6CcDEzRvLuUz6Lx4ou3nzL9tbUGPfpbawS4qLB6jwmEKB
5730	fee_transfer	1699	72000000	1	CkpYQvmB4pnFPVi3c4d7CAwUfSew81Xbt134xBquhZ6bNwNgxhw5v
5732	fee_transfer	2087	62000000	1	CkpYRzWhSdTbuzNTGPHwqSWps1XrCJxfaFDfjonDsamXZFbwyfLtW
5737	fee_transfer	1601	82000000	1	CkpZYcUQiARRGvKATzcqY7bP37s5cHV9ruDRcqNQN1iF8fgv9Ph7p
5739	fee_transfer	1768	62000000	1	CkpZfRnKMwNkd4zHryLK8SVoqGEGmqkrdksSVNt3zBY2tCgeCt3ut
5749	fee_transfer	1458	32000000	1	CkpZzafDogvqYtoUwsBMBMyPGGzMdNE4wof9WXZQHHEyrDY7Q4mHz
5757	fee_transfer	641	951000000	1	CkpZzrSvk5yrQAdWqfQ7CXMPDkwg3SaqTyEWm4PjYArjBubewR6bX
5759	fee_transfer	1271	14000000	1	CkpZTqW1gA88q4y59Qu9f5FdxLhWMrmfgfprx17CPbCw6k8ppNUzz
5768	fee_transfer	1458	25000000	1	CkpZ9ZntfA2aSWVDmH9t5M7Tws9oa3Bf43CfhncP7vkpRmE3C3ZQ4
5772	fee_transfer	2086	413000000	1	CkpYeCJrV4NVtcsvLWQJQjHNe4jr5L6UdSA1VTPTY8Sh77pycGbMt
5774	fee_transfer	2087	413000000	1	CkpYdGhbixDCCLWzQtvPmzuKDQLBNmjuXKmPHHxXU5eMrUUu547PC
5779	fee_transfer	1698	34000000	1	CkpaGTB9yKR4mLm7uCq8jVGRQW5LTQui84Efj5JcgHT6h2ziB3ocC
5783	fee_transfer	1663	12000000	1	CkpZAUr9BkicwxrCJhCiDAJ4BV1qJdfpvFfyvoCdvnRnHpxdsewPn
5785	fee_transfer	1724	610000000	1	CkpZEA6kMZAyE5cf7hg4EBDMR8TWEYRpaZkuZbS5gtTgiQcxhEed8
5786	fee_transfer	1992	15000000	1	CkpaKZuAfcTaVZYWnzb2mmsGGYHzsqgPR5p2mKahtqsuYtgo7SxNP
5788	fee_transfer	1670	24000000	1	CkpZ8AMqEF5owsdn4v6ZHFZ2LRGfNxuBRL75AxiQqwNUbcUQsUGgx
5793	fee_transfer	1394	21500000	1	CkpZW5RpXQ4nK8QnKL8HKc7ie7m79exYgCSR38nRFiUT23DjufoBU
5794	fee_transfer	1471	92000000	1	CkpZPCwDeuwsWUUjLVdF8S1DQVNkcF5g9a8Kk7EPmfBT8WqS4T1hi
5799	fee_transfer	1560	555000000	1	CkpYzjNF7FgVZMQvtjuvvUvaFMLsHknLaKr6VzN38VDzbrM48bXhZ
5804	fee_transfer	1471	213000000	1	CkpZnmrpKycJhWTVBU4PLv3AqXvHDQgF5jr5RRM1weSaUSk8GqTZJ
5812	fee_transfer	1719	25000000	1	CkpZPWtdrTVQ7Emjofno7eBFMdRRe6ziqo3fLhF5yD17iSsdUFV2L
5819	fee_transfer	1560	550000000	1	CkpYrzQqoSEgGzMZKFhKR79cAnKug6aLaZ8AfEpe5Mza9YYM5UjEs
5821	fee_transfer	1746	25000000	1	CkpZz7ZE9MszCqqAahCyExhw9CBhE4jegmkEvtu8s5KqEN5oGGtrc
5825	fee_transfer	1680	35990000	1	CkpYiTmbVbP2F8Z9KCPi7s4poTrqqmkWKFAZSaTLZ5oqiyAuXxTpe
5826	fee_transfer	1768	138000000	1	CkpYbT6hXxQ3tU6pL3UqTAuGR4PRbsEvL6WsGhTJdeWjshZYXkYyT
5829	fee_transfer	1513	122000000	1	CkpZrhCsQVPp6frC5vWKfNCYpNiJhiLzuUMjrTPPvVpSN67w23ZfA
5831	fee_transfer	1675	591000000	1	CkpYkye1YQmKEcifnJbYgNcCwuN31jHqo1hoirWdcxgyzgFx2Mmmt
5832	fee_transfer	1675	34000000	1	CkpYjS5HQAkTQ6XVQ1EZGxT2ngUM47VMRKTSEozMUbhy7rmT8HMYx
5834	fee_transfer	1679	32000000	1	CkpaBXpEVjwy7p9EeYQhB4hoRL5zB2i5b8UMNagaWRtevj2qzzKym
5838	fee_transfer	1764	112000000	1	CkpYXv1A6xVfK67hzwUtVczYW4nznCuS22MZqzoS6UDz4JMDibd1i
5840	fee_transfer	1740	155000000	1	CkpYRJjuMKEPH8fTEhhec3nVrZJVRsacV6tjwV6MdijnfVLzQa5kA
5844	fee_transfer	1588	222000000	1	CkpZceMY8KVqVhpeqpiG7tHYMc7UxRgh1RLCzqsxX2e2HxUMzZffS
5852	fee_transfer	1756	21000000	1	CkpZpYx59amAYjyCqx4mBYC1DZVibdG9oHCfXEpgDEEXrGge2FAbZ
5853	fee_transfer	1688	52000000	1	CkpaEpezPfspGcHNhoZJ8BLHBeq4gEEE71XDc9uAWEW1Qdui4Zy8B
5855	fee_transfer	212	60000	1	CkpZFiR5pcRU3Ym4oRYGio9jut1MtFEtD5FGEx8k7Hahrv3wDAzMD
5856	fee_transfer	1850	61949999	1	CkpZBcvSW2idwf6i7kRCLbPyTGghnHh64jyJdGW2pXJHRjJCw9A5d
5861	fee_transfer	1573	112000000	1	Ckpa7usMp3qnVkEQ3LyX6YtWDnnqyCx8DeEhgSCd9BwkSW9GuLFkk
5866	fee_transfer	1547	134000000	1	CkpZdMX4nEpFU2wj34JSSx9WKYAzduun73cJuDY2UKNGfWMyjrXpv
5871	fee_transfer	1602	347000000	1	Ckpa4F76cFJDRrBK8KK9X7ow6xiT3efepeKe3iUycYqYxy4ss4Rtw
5874	fee_transfer	1394	74000000	1	CkpZFQKbFSjaWkZGA4Y7b9TzEqmzcgYg1awBXFV8ztryKaFzrS6m3
5876	fee_transfer	1395	63000000	1	CkpZ2Ste5XKGg2txYBoKUMGRgnGZaNJvPdAfGi8muTp4kyVetinY3
5878	fee_transfer	1759	73000000	1	CkpZYgq8vDHff57jubvAQJQdRKMPx3DoYfJbyqgxwbzgmvgmbZEJA
5884	fee_transfer	1643	125000000	1	Ckpa3tVvYtvVhMENVraJVSUJqNQ9kvNvsA7cQsZo3v65o9nJHzn2B
5898	fee_transfer	1637	46000000	1	CkpZK8fJTx6JUnQy6hNoabzbkFuGaNyBgrSYF5jRxLw4HQrR3WGeN
5899	fee_transfer	1394	232000000	1	CkpZRKJJ8QstiPFtU567JMjgau8x1iVxBLtC7fcdXDxyazNNAqRLW
5902	fee_transfer	1395	132000000	1	CkpZVSvBHvUbSQDM62FBxc3wtfAkRhAyHSZjgnADyKn2BLPD2Ei8F
5903	fee_transfer	1714	132000000	1	CkpaBvFPyuUkqwTNX5TXFuy5Q9KWepytyYirr8D15y16PrfQLNhQG
5905	fee_transfer	1499	12000000	1	CkpZwEEm64AjzAT98jb4PAaXD6FNbFQMgWc5tafiRWs1MBq6opip6
5907	fee_transfer	1717	54000000	1	CkpYopnDY9jzwWKCjiJVpAWEw3AoePSBib51tTfsxa9B16fccvASu
5862	fee_transfer	1571	402000000	1	CkpYbNBmX37pX8K3j4q4k7Rvjd5QsvwUnCxZdpP78CSQhGNSxYR8L
5868	fee_transfer	1476	134000000	1	Ckpa1ZmKHubauCvSCpGVDZnmF2bMQ1xgw89Rxhyj5H51r1qHKN9Gy
5869	fee_transfer	1691	5000000	1	CkpZiidAtrkAHqHKnwob7hWysKPD1LydBkm63qqfm9dzH3TanRpEN
5875	fee_transfer	1991	63000000	1	CkpZYG53E3aotQSzLiMbTgb2bKRNoshCLFFMoGDgdsmWCiyACiPWb
5881	fee_transfer_via_coinbase	1886	400000000000	1	Ckpa9y3wS2jGqkagkW8xRzi5Mk8Q2g3qb44miMNBodFABdqVAgFrb
5882	coinbase	1724	720000000000	1	Ckpa8vsnMvJHb4HbC9NcQg4WYYTgQR2vUVnW6MkuTt8VuDC4AxykM
5883	fee_transfer	1394	125000000	1	CkpZjbadjAELj1CxzpQ9QLMq9mAGzjkZjVoBuA29PuRFnXZSacX2p
5887	coinbase	1659	720000000000	1	CkpYT8LCh2HnJy3mpzw6frceXCEKjvaxziBS6H6aD3vjtuuKqLdHb
5888	fee_transfer	2126	50000006	1	CkpaAX4joFywNHwhxKw32KBzwu3bz4Pmg8rUmdCYJKKRYSeNFVS6A
5889	fee_transfer	1807	3	1	CkpZ6vEEtyuoztq9Aa9YG27BP3msZJzcEYKgFEeuYjzM7gKUAhf9L
5890	fee_transfer	1659	83999990	1	CkpZVpdpp4M5RxKYcKwAjCcH9KBaYgCQNb7TmSva3dAVBHSLx83kr
5894	fee_transfer	1422	42000000	1	CkpZRTVRv1VLDff9kQLxURD429LPcFBF7aQBNEcQnMYZFFEV7nqHB
5896	fee_transfer	1671	46000000	1	CkpYfjq9noJGCcCGqA98BxpURFmZCm24uTNVTMZ7ZuPCWM8BFpNpP
5900	fee_transfer	1394	242000000	1	CkpZTyH8ppPZmsvyWpo1u9ZjXzyLCWtWZ561QPKcNrD3FTySjAyn6
5904	fee_transfer	1714	1300000000	1	CkpYaN9V9g3wrqQbJWkcn1YgybBfEYGsPzZ5Zr3gFCAVKfP9FbgSS
5911	fee_transfer	1693	76000000	1	CkpYkSDi5ThKoytsX87nJgqZr2KjeBn5U86sqEFhFr1vZKyzYRoh3
5915	fee_transfer	1768	5000000	1	CkpZQ5FBAiNnY333inC6E6uE5SAAVqeHnmNACBipVw5KB1273u4UF
5923	fee_transfer	1549	33000000	1	CkpYYzj8GEstMib8ysTnXi7tR1mhgRXzwyabE3jsbYj8UXsHWS6Q5
5935	fee_transfer	1705	13000000	1	CkpZs7ghYTx5qDttLuaAEXMt7kABkc6eFg921qVfHi4JADjWMGwcs
5939	fee_transfer	1943	24000000	1	CkpZpAXUHqUcyC7d4Hh4ALkPJtNRYUswxzsbbXkSrKYrMZfv3SA7Z
5948	fee_transfer	1448	25000000	1	Ckpa8yxKXAhymGc1119Da3taykvitbLNvpdzRBc4JZzZgJSkDWZGj
5951	fee_transfer	1601	25000000	1	CkpZdgCCdpfkpRin5Vca4FjFf9kM9BToSZYz2Vbuni3Jqy9QqxZmd
5958	fee_transfer	1762	15000000	1	CkpZjcXz5LC1gQksuX7QnfHrTHayEZFTraNjodxtN6EpqAuDXmAuK
5959	fee_transfer	149	137000000	1	CkpYWW5c9y7se5Ji6rH2vHNxvqL9tDTNvuvhdk1PZ54a2ELCYWWYo
5961	fee_transfer	1395	499995	1	CkpYQPhfGGeKFcPrTj4XshZmGQ5uC2eGtVKDJrcuMjnHAVF8jnUX2
5962	fee_transfer	1520	5	1	CkpZf2SP8GZevWU79PDktWZg8kz6wyUTBnkspe3YnzyCY44rKDb1g
5963	fee_transfer	1509	1500000	1	CkpZV1HsX3KoPPBkfyW4dTbS8rqJfpd9giWfNiaKRA5RxaWDXQqFR
5965	fee_transfer	55	24000000	1	CkpZBN3vB9cTbEiXkPQgagXw592cFZ3yJKeV37FoRazxvypWn78aN
5969	fee_transfer	1739	27000000	1	CkpYchWiEqB881Chpks61suxGcnZRAooyJBzuKMfNc7sertBepHhU
5982	fee_transfer	2148	15000000	1	CkpZJGvdobAYP3bYmivAgvQ2hwwEKHZauBB1UxEuvUmNnGKv1vr8r
5984	fee_transfer	1396	43000000	1	CkpaGw1rqtonUXd86rV1ccxdT7tXos79dLDDRvkUPMjMxYe3KTQVP
5988	fee_transfer	526	24000000	1	CkpYTCsvesSn82aSwSz6AcoA2TKKc6njAHp7f39vvL39gLjMdispS
5991	fee_transfer	1709	26000000	1	Ckpa8Cu5iYr3cieCcWXGJB9Rx7q93uBwNEwUPLnMpogudQRqrmfad
5993	fee_transfer	1693	14000000	1	CkpaBU1ro3rKW4ZxiTmv1ne2Wuqww7QHTQ6PY3d4BZwQfdeJ9fkEm
6002	fee_transfer	633	165000000	1	CkpZLLRnxA2U3LvJkcNFnumwmzCwZkwftXunNxZqL6TRwUv7kHSpC
6004	fee_transfer	1451	178000000	1	CkpaDWqJyUYXoJrMSDLW4x7XbfXybgCgJG4BJ5tEkEd5eqE4Pd6XM
6008	fee_transfer	1675	240000000	1	Ckpa279ziEELGB4mjLMnK5deqSQWk5kp3thbYTd2sdo3ox8yXC6QN
6009	fee_transfer	1675	1050000000	1	CkpaGqrtSx1BWarUrs8RmcHojFyWJ1FQHjTrtaAhbZainPfL98Nxh
6011	fee_transfer	1394	56000000	1	Ckpa9aWoToDM4UERs5o3gP17wc9VR4xJHPhQtJXRjbXDz45USSD9P
6013	fee_transfer	576	24000000	1	CkpZUyVb3tYCd7VGtG7BBd53Cmn11PJDdFG1eGfiVhQzNb9NZjNi6
6015	fee_transfer	1685	35000000	1	CkpZdm9czyHow6PE8M74AhAvugBrzYJTZA6t6PPtnULd38kLZDMJz
6016	fee_transfer	1634	32000000	1	CkpZwcFD3sQdrjo5bBFiNrahN72JYTyDt7tG5pQcAzxtic7Cqz993
6017	fee_transfer	1756	52000000	1	CkpZtd6ao3mMfNLhwem3mZEkrtWauaucgbtaGKbKyJK3jiB9AZ4ga
6031	fee_transfer	1394	113000000	1	CkpYzpsyi4CaPX1RXamcUPPZzs9T6kd3ZPA5uVhTFnJ3AMd1CFhLM
6035	fee_transfer	1422	35000000	1	CkpZGPeVMt54XBnSKdbi5koECxts9aZtj8CN1XgqXVLxsK4WzqMsP
6042	fee_transfer	1455	112000000	1	Ckpa5dcWHMqa1Hp4ZYwZaWfZ9YAyqbL1995WWZyUuQevFpX7jGaCV
6046	fee_transfer	1419	740000000	1	CkpZdbKYGeytPZ7aYUw7Uz9jfqeLwsBHWXjrV2JVNZErKEXWxStSS
6047	fee_transfer	1419	196000000	1	CkpZsJ6RSFut7y17m8YEYnxeRK8fe9hnT3GQukPgENrzU1ERA1pHd
6050	fee_transfer	606	82000000	1	CkpZnjniyafe61FAUPHRPY5WNKQ3AJbSQXo24dSeMgSD9rzL7q59M
6053	fee_transfer	1458	22000000	1	CkpZNd75NRU6KB42tJmZrka8tBStUn2e4jxkooQ6iyfY9bF94qj7A
6056	fee_transfer	1673	37000000	1	CkpZV8cVvJgJzmR5kZhZNAu9pERshDZZHVbLqNhufKsnHK3iF42Bn
6058	fee_transfer	1555	16000000	1	CkpaDKbaFeuF71ADCUTyy2v72N244XYobvN4LtecMiFncWYdZ91rW
6059	fee_transfer	1698	5000000	1	CkpZwfDKWKcdxdMfg1XmEikV1CktCn3XW6ZTVogP5zKai3Kn6Ue9J
6081	fee_transfer	1918	111000000	1	CkpYdyX1Bt3MTszgUN2Enfacm7bj5cbKHpVDKGA6wgH1PER5WJAXg
6082	fee_transfer	1918	11000000	1	CkpYXZkCZK1JVGUro5C1q7gcUukemnq75iBHFd4o715zvWoj53dSQ
6088	fee_transfer	1693	372000000	1	CkpZxjZFR2c333Qw2gWvMg9eTHmtfNvfCsCpH8Un5BBrdYeSZ5uSt
6094	fee_transfer	1474	35000000	1	CkpaHDWMufoWofbH9LZQJjvMGvGjyBs9iPhjvrDjJdumdzPhtWQZD
6102	fee_transfer	2106	37000000	1	CkpZvw9iFd3Hc2jFaeFvUJs3hsNVsXzKwtcqre5PR7XwgfSH3Qgyj
6105	fee_transfer	1613	64000000	1	CkpZxCQgVQ2C6xw3PxPjTZpQGFU9T7QfzoLoD9iv4T9CtWHdAQwgV
6106	fee_transfer	1705	43000000	1	CkpYzVtrZuymvvjWXJmeqLgfvKoWiANQCEVaYfnEc4g8Y4rnkEYfZ
6111	fee_transfer	1506	42000000	1	CkpYoejugSjiVuHDBY1M3Yx7C4cSeZPDt8nM4W4ynpJCrwPvGzj3h
6115	fee_transfer	1536	14000000	1	CkpZcH8UqRP4sd3QzYPZCX815Z6bJ6ev3cTb5fwdKcntAbyY5zHCS
6117	fee_transfer	1638	717000000	1	CkpYRtjoRnBkPihK8tgYNXuH1s9DrCS98Y767rfio9Jw6mncqLyc4
6126	fee_transfer	1638	174000000	1	CkpZ9JGNwWchnCA9XvaDiCaXzVFDfMkLRC8bYm1qXtkXQzDWMqRAE
6130	fee_transfer	1439	21000000	1	CkpYzcePMm43HgHuaxm43Ap8NxMmJ74gRs2B8iU74cev9stPd3gBp
6134	fee_transfer	1474	183000000	1	CkpZpJGVHzvXCEYYfNM7cykBaiEbhLCaV8ywjDErMDSgveEFxpkk4
6138	fee_transfer	1549	42000000	1	CkpZeEKWwMJzgUJFbx4WwhBkLkuEAqX1MEy7ch3L4j4Rovix835Yy
6140	fee_transfer	1508	1090000000	1	CkpZqQeQjC4MjcDLN45Av4Fb7xvU3GFZb7c6fvABSBMVBBJun5CPc
6141	coinbase	1508	720000000000	1	CkpZud4kbj5KW9xzSQT9b3fvCufyGSfayYqfYD9kpPFiMY6yDpCBU
6149	coinbase	1574	720000000000	1	CkpZySTFHBbfotXnk69HCrS5DBicL563rLwbr9CRfVgA22mSg4eTN
5893	fee_transfer	212	30000	1	CkpZb12nSyhEqtJiVvStWNnooj7kaYcjLdjJrWZ2gDk95d9ewgVS2
5895	fee_transfer	1637	42000000	1	CkpZwfBZuKG3CMnKuaU1za68tQvkQ18vb4g2YKMkppMQMU1A6GAtc
5897	fee_transfer	1394	46000000	1	CkpYiPWUk9JojKiWiaGu9JxbjzEY6RFYDb4RRHbJvrCnnxDsMHuiQ
5901	fee_transfer	1440	132000000	1	CkpZQKgYi8xoyUzo2jWZ4qNPcCihhL7PQNEpNgZ56ARCDy3BtxBip
5912	fee_transfer	1602	76000000	1	CkpYckaxDeoRqfxhGkr2H8CxN1UiVMA7MGiDjEmLnYspXYwGXkQsm
5924	fee_transfer	1698	22000000	1	CkpZD2qL9TLDt9NoUdFMFwEfmdyvXewZqe6UBgcH8qVv4xzBrSjvz
5926	fee_transfer	2248	12000000	1	CkpaCNJBzYaPvw6U7bYttCP6J5nYdAhoqD5iJZ3gL141XNsY5Cx5k
5932	fee_transfer	1717	37000000	1	CkpaBEfSyCQaj5LyHpVYyc8o7PT9tmE276KW1dSZY8NZ51T82N7bX
5933	fee_transfer	1656	24000000	1	CkpYWBddbkaEKmCTdf15MpghMGwW4vDX9e4iaW29peq8tihBLsUZK
5954	fee_transfer	1681	47000000	1	CkpaH3o6m2CGoP43fSs9NXTFHKk1zabkygKUuivM6eMCm8hqAVxEC
5964	fee_transfer	1571	2000000	1	Ckpa5cEWNPTzTURjshLb8UM7fRDhAhC4Qw5Aax5ZpXYN5a9Pwewe1
5967	fee_transfer	1691	17000000	1	CkpYTuioahtJkm317UXm3bAL7Pgxn1eQh2RA7YZNR1b8LsrZqVxw8
5971	fee_transfer	1419	209000000	1	CkpZ9aT9uLue5YHy6uWxfREU4sRTsdCKZJo2bbYzPtUAeLLEtTopY
5972	fee_transfer	1509	53000000	1	CkpYk8dKfhU5vPk3VscdcvMKvJfH4pCuJVCUHySCPbnNEpyQTM4ik
5973	fee_transfer	1992	36000000	1	CkpYQYTfVnW9vrMqR5vvz2WjsG1PzXo6kU2dhTGBo8JFCZvc7sFNb
5979	fee_transfer	1698	48000000	1	CkpYvAMLtCFdvpWNJB7BdSm9QyePgmVotNkUHkNydZCAm4AY9oryU
5983	fee_transfer	1671	15000000	1	CkpZmj9gd766j2QsgpmFvPoReE5tLUHgNbUGhETjtGwAXDLQ1As57
5989	fee_transfer	1474	24000000	1	Ckpa6bgU5Erh6bvBtvp7f3ZTgit2bDXXN3f6Qbkf5HpLVCSPKhFhi
5995	fee_transfer	1540	20000000	1	CkpZt9mkg5aqnhWj6P5wbN26wrwdYTxgkNneVCyKR385ygciqVEAm
5996	fee_transfer	111	11000000	1	CkpYygwTqtpuguYurPcrB7tyhQfMyoy2FXdWhivodbqafCpz38C1G
5997	fee_transfer	2248	24000000	1	CkpZy9LwyNU1jnbgVEs4PWRJp1Yev61KBVTmRTCDuZngHY9xkYz33
6000	fee_transfer	1419	579000000	1	CkpYRA7r2NU5qxHnd4itPpRXqrvjDjtTRiUgk777KRyh4Lisqk34A
6001	fee_transfer	1419	59000000	1	CkpaCaZmNTAuhgdFeZ4evuy97qa2PzuLhZqWpcd9xUp6j4fFm526n
6006	fee_transfer	1476	4000000	1	CkpZrwMBAha7Y3AVVfMkHGHoVbXqbMg3xgHa7ouErGUxgBdCUTnaT
6007	fee_transfer	1681	36000000	1	CkpYaGuFQPeoZwWVFNaj64uPEmevnTze9og8HhESpYsxfMgJmYxt8
6012	fee_transfer	2086	56000000	1	CkpZDxh4aSV7iDxWQjYvXz2q7xjVdzUoDJhdhApJG9ouHYJtpzGfF
6018	fee_transfer	1657	52000000	1	CkpZDnHmLfq7nvEMMDbPVL77dtznMhVkU5cQGGxnShUd1ENiSMMrx
6022	fee_transfer	1444	25000000	1	CkpZHzgzko5u1FpjG2o24KzAGkZvPJP5SYj3PyTWsxoR4nbXwiZSq
6032	fee_transfer	526	2000000	1	CkpZJsHgvGy67AAYRfjoCn2YDySMPDrCXuJfkiSUyiY2Hka2d8xsD
6036	fee_transfer	606	35000000	1	CkpZj6JuJctT46upZUNcMJXtvjxLqPR8aQB1YSKC8CviWJxodZTD5
6038	fee_transfer	1700	15000000	1	CkpZped5rNf7h9dRaJCPiA2XEGFiqgcgYbQnpuvQpx7Y9sbqnaLCi
6043	fee_transfer	369	112000000	1	CkpaLHAxiaFmqYiZAdTuWy99TvgR3Uj8hLVfvkrUL1ZSMrRbVk3ec
6051	fee_transfer	2039	82000000	1	CkpZrAYRB1LpJsWLeyW3gRD39aA44i5b28fegPenwvBHTfExfzspY
6054	fee_transfer	389	33000000	1	CkpZCcztk2wZeTQwP1uAWNE9187Y5NYzJRUhpDHUfYqESEKASXakB
6055	fee_transfer	1593	719000000	1	CkpaKgX8ur1VhDoXVfUKBWXiaTb1esKH6dwR4cwqqX3z3zcWSqyAn
6060	fee_transfer	1698	158000000	1	CkpYYsDQ9k9YbGsCpqN3XZrbywnRfKy1cHNbZs3enmkGejozSM4Bi
6064	fee_transfer	1419	16000000	1	CkpZjRvbkcSCWYyQzH8Zp1gtHntJGkvtT3qyRRTsK25fbv1yaYP2n
6065	fee_transfer	2248	14000000	1	CkpZMaDmeEYzh5sg7TNA34XTobx7ofpSXYCxh4G3DpQhTXTpFYPQn
6066	fee_transfer	1687	39000000	1	CkpYwc6Yt4EMzL6ZYEpXjEaNJTGPaCiuTxGgNB3xrCfBSTznb98R1
6067	fee_transfer	1943	25000000	1	CkpYkRSPVhqYzhacawpNqkn1fbkbuXZHEMznKiNwrpWG2WNF7FjRm
6068	fee_transfer	1395	423000000	1	CkpYxFpsurycZL6yB5crqcNF3Tk7w3jLLonzMkxVUFm5ph4BzpYYv
6069	fee_transfer	1685	174000000	1	Ckpa4DSaZj1NStus4bmPjnwsiXKzHGPmHgNpV678rUYpG9S7VxfaL
6070	fee_transfer	1671	353000000	1	CkpZqo1ayGLJcU4TCkqcmXnMAByyy53fhkmpZeT9YUkogP7MB15Km
6077	fee_transfer	1699	49000000	1	CkpYqnt2hE1EU4pYvuX6xku1Hbrg2pfKocczzBWo3En9pWZdCSnRB
6084	fee_transfer	1395	145000000	1	CkpZYAxmcqSTwKGDBLbjhKZrMb2ujapWXsMqN7jvUwC1VR9ZMvTxe
6089	fee_transfer	1654	372000000	1	Ckpa9LN1u1yKcDQy9jJwnRiJpzEE9bCav4YFPXiaVn3CU4y4QW4um
6090	fee_transfer	686	2000000	1	CkpZYfkeGXqZ69eJ3WsaBobNAF2oy5sNtsCoyMti5RbGzFRjiKYJ9
6091	fee_transfer	1691	35000000	1	CkpYeCxaHhRsCWxTxTzCruYndRywvRZuctBAcRsLQkytnr5X456mr
6110	fee_transfer	1740	43000000	1	CkpZ4vkY2AxSeuYU4pM1zoik9rchrLXLksjrkaqtjr3KSoDr9EhJa
6114	fee_transfer	2086	14000000	1	CkpZpy1tcPw9j3tR2Zsb62U6GxWTZgJLkd7VDLPQApcpu8xpNCSQc
6122	fee_transfer	1633	320000000	1	CkpYs4d6MC8E7Hc8Yx22kwNsgVgeUuzP2QtsZxttAQaWzbgsk7TX2
6123	fee_transfer	1633	189490001	1	Ckpa7dDw3bZURyMSvxNQJKhoWD4vAKRppEq7zZrxcRg6YwQnX5pZB
6124	fee_transfer	2097	9999	1	CkpZ12Lo2AM2XsX8cAnAKv64pQmVha7S5jT1kbYr1JtdPPGsG31v6
6125	fee_transfer	1509	22500000	1	CkpZeLPd9daHkmkYZv7mYncct4HH1z8M5yz9hB1vu9M7HBkb4uYnr
6129	fee_transfer	1633	284000000	1	CkpYq2NkXwUp3xY49HoHiky6P3ouW8uXh5utcew4dVfG4XbcezXX7
6133	fee_transfer	576	183000000	1	CkpZM9UppTExxbsfZ24gDeNYaLgxxaWRJn5TL8njXjoMAhFUxKH9y
6137	fee_transfer	1943	23000000	1	CkpZjw4mZdN4rvHhBL3E3LmuL6ZyV6XSppW8AGQUe3Vfx5ad9UGt5
6142	fee_transfer	1422	22000000	1	CkpYU96eVHpvuR5ajPfWXHG9i4ExA8m9oH32gJrZXus6CKFerM4me
6163	fee_transfer	2148	32000000	1	CkpZ82wdWKzkJxuNMA3jX2ZhWNA3r8u3EjU53vTt2c3CGsF3oTrEz
6165	fee_transfer	1587	42000000	1	CkpYQx5SxWC9e9bCdA4bEcQkvuNxgdAe52WxgyTKFkh4yUGzyXRTA
6170	fee_transfer	484	260000000	1	CkpYQF7Ln2Zme7aBSEnGhiRx8hb1Caig9oAsiXfy1xaa9PHEXBL4L
6171	fee_transfer	484	248000000	1	CkpYRwNytPnaVi7DbwQqGzLdZY5BSrnsP7cY2Z2XEUBrWcET98xrH
6172	fee_transfer	1467	22000000	1	CkpZba3kDNbSC2i8mbCsNC9FnJ15ugk4ZjPXZnFhxdHGXZwZaASfb
6182	fee_transfer	632	103000000	1	CkpZdvjAs1ERrRChewqzuYBtf1fa5vua2qe32jcYGJwHsAUd5VVkg
6184	fee_transfer	1395	131000000	1	CkpZgFuv5GLUaNcMd1CBcGf9PwCjvswTDfZoji4JLCxnELz81jeS8
6186	fee_transfer	1588	212000000	1	CkpaBYT6VgMBkEVzffKoZ6PHgRoSAkf6314jFdBXybV5BEThmyr7F
6191	fee_transfer	1489	41000000	1	CkpaD7kyG6o8VaPj9NdSCTkh4tPmB27for5c5U2qvqmMJbhz5dZDu
5909	fee_transfer	1690	2480000000	1	CkpZHwworAD1BsujMRQ8eaUUvDBp9c2RAahfw5W1P4cz2iEsX3hgs
5910	fee_transfer	1690	149499992	1	CkpYxvWXLGnffcFgTf5EMwaq2gCGRw5EaL9jp7EAoVKskgYJwgaqc
5913	fee_transfer	1675	708000000	1	CkpZE98FXeKjCPnJQZBQ6NX4CysFmnVYGzysRyXHfYhzp3wnZak96
5917	fee_transfer	1690	763000000	1	CkpYxd3amnWLd8wKBFhaFcJqwhcoPnii88ogCWkXJrjvc157fiYwY
5918	fee_transfer	632	2540000000	1	CkpYeWQiod1aMEgxa39f7tf6sngZNEcT4wQykitXkNbFb6oTAgkgu
5919	fee_transfer	2128	1	1	CkpZT8eYQsUVtnU4TwvyF6SNUPAwAo2CuWyUd6377c8SDSYcdJ6WS
5920	fee_transfer	632	889999991	1	CkpYtstnZvXwVVWyKCv6Cv7zwBVM9M7fzoD5kkzAjVW6g2AJU8KS3
5927	fee_transfer	1439	309000000	1	CkpZMuZ2j2pi9Uh8dVUnqoSfErbSAQpWWGaxR5JsejQjYZpmarLYj
5928	fee_transfer	1395	26000000	1	CkpZ2avbMGieJ89V185ppxL5pmXxh2TfVWTcEuTPt4C8SnA5Jgfvq
5930	fee_transfer	1710	37000000	1	CkpYxuCnnny5HSNJwSas6SgRS5P3ixbKVRwpQL6yRhmhs3MK43BzA
5934	fee_transfer	1489	42000000	1	CkpYqUPR3Lw3EhWG2BieZ1dpkf8cMBq3zAAUsSbkvDwA4om29j4No
5941	fee_transfer	1695	49000000	1	CkpZ6RBCZ1ULkmQLaHL4yW5LP5wuj17TTUg2k6Jy2WFac854kbPUg
5952	fee_transfer	2100	11000000	1	CkpYtKsuCM64VY9mYa52P6Y197yD9ca5dqnMHeaH6RfHZ35fk58V4
5956	fee_transfer	1643	873000000	1	Ckpa4yWokots221ckSdFaQiVy2F8oJnuNYwWkkcUCV1Z1wLeWAcya
5957	fee_transfer	1643	34999992	1	CkpZbL3Cb7hF9ZVZQQqBKRPZGZb3Rianw9Hchg2BC15WZrBRycDwx
5960	fee_transfer	1457	36000000	1	CkpZSpLbYYWX4ct1pf3BkuL8qepLsymqHLsT9pxvsTksUkaKW4EYB
5966	fee_transfer	1419	190000000	1	CkpZtwWWxHB2mAXjfNYptdiVcEy1WnggvhHjV9TqezRamx6cprc1a
5970	fee_transfer	1756	25000000	1	CkpYzFy6v8yDvyNpDTtt5N7ytw3HTjbn1ak59ETH3VyMqVTvGbrJS
5974	fee_transfer	1701	36000000	1	CkpYtyd1Wx77VEci8xNe6n8ts4YuASkkPvLZy1aUU3isGvk5qr1C9
5980	fee_transfer	1596	48000000	1	CkpaJ1fNTHnMsTD8tbg3casnEdZiZeriKuGtisyFsUMuyVPPhzLC8
5985	fee_transfer	1679	28000000	1	CkpZaqyrVYEKnv2jSQdeuz3kcrwXYxLvAF8Kn7heeLujQZQkCVbrM
5987	fee_transfer	1701	14000000	1	CkpZW2Ut7XdAtMfS3GAVPAhWN2fGuKLyiwBuUafnZ4ckG7eJxXHjS
5992	fee_transfer	1693	15000000	1	CkpYkf1oDtyGbACcAAB2FxiZBpBrWALVYiwTWRgWABLECU9VWAYLJ
5998	fee_transfer	1521	12000000	1	CkpYsHBAQfZs3j46eZCqT8hqFreJVJFEKgesLfGnwKyN5fraThcHi
6005	fee_transfer	1476	24000000	1	CkpZ7GLBA6GqCS8jECxAgU4TK2PhtP1hGbKBLuesSofxAbJYabWuQ
6010	fee_transfer	1699	56000000	1	CkpYxDDMEMH1Uu8my6hCHBLyeDe3dB8E3uypWXRrLLAuvbdHsB6Fg
6014	fee_transfer	632	76000000	1	CkpYuByo2GPwNYc4jML41Rz2XPxrdwruMDiGMzNX9uAEa7RHirTrN
6020	fee_transfer	1643	290000000	1	CkpZsDGwaF9pT3KEEMkactKoDqxPUKZAVVsWobxtVfdsSDgDZwZmT
6021	fee_transfer	1850	45000000	1	Ckpa4Em789Mx2PhTaNyAzPKjyZCuCQu6VjtdiGjqDenDnT3j8AFPL
6024	fee_transfer	1509	220000000	1	CkpZLVPERr1Jzk6u4NA2VYkX12Ho8ZfCAa2Ypiv3NXKLq2X8Jy5RE
6025	fee_transfer	1568	25000	1	CkpZDJjoBNJmBBpMqx8bgkoz98aFa9Y17WT3DnwjQVDc7ZReBonX6
6026	fee_transfer	1420	2970000	1	CkpYnLFRzafw1gACgwhhpfANsAEaQuUm8Hrc7F261dFR53J63kWCz
6027	fee_transfer	115	2000000	1	CkpYiXitbRd1f3Cr5jMcHKySLttQPcNbJRoQPieM1cSQfYGxjEwXP
6028	fee_transfer	1814	100000	1	CkpZqAtVNstD92hxSpFJvQCTT2D2ZGvKCLiwaZxdJoQATZaosR4TR
6029	fee_transfer	1520	4	1	CkpZhD39vDTy5ixHTR1AaMN3HdCP6dXJ4G2DurhfyNNMgc7hCUw66
6030	fee_transfer	1509	149904996	1	CkpZbMeBdTQbakaPKxxzHmUfHfkbmivNg4cP2owed1nYhwvDkaj3V
6037	fee_transfer	1451	35000000	1	CkpZd8iKdR8MW8zswWzR2LuC4PQW4ZePsQrfhCNAbGEb9KAGdyjZ8
6040	fee_transfer	1451	777000000	1	CkpYTqg7vvb7c45meRdWfqMm6oZH3hWGzxAJUkgW9TpVDFnqzTPpj
6041	fee_transfer	1451	9000000	1	CkpZJ8RyrFrcNHhLoy4nCBk9W6GKknM8tDZjhAinXoTDcfvzhck8A
6048	fee_transfer	470	35000000	1	CkpYpB1GRn4ENH6bG7cfwogfQ8FxTV7ZZ1wSHkhTrWAPTBtzTxzmr
6061	fee_transfer	1657	5000000	1	CkpYpovMn1Y1bjDDBexReVKeSFMEmLkbhsfihNK4nGCWK8zcAurTB
6062	fee_transfer	1708	16000000	1	CkpYwhBoyaHR6V5JzavzhhRgGN5Cfv57gJoddse4EaKmo45ooEwFC
6071	fee_transfer	1711	353000000	1	CkpZxzyLYFBMsRdyFf4QhtHzEBTxvgmvtNGxHHWEULiexTRmCPtEs
6078	fee_transfer	1426	49000000	1	CkpZ4vmfjGkmKuVMyvpgaeNXjM9DumLLa8YkbYPFaCcoNsidwvvhc
6085	fee_transfer	1690	145000000	1	CkpYeGpBxwcfioNRaiYDHgaLSWzui6EEP1oknWxCFgeCUmrhJLtoA
6092	fee_transfer	526	35000000	1	CkpZ51SCQAgkiC6REMTeYcKvwg6aZnDfTniyG57fibNzo1e2qh4JY
6095	fee_transfer	1705	26000000	1	CkpYYcd7LEV1WYuXU4ALqn5pvFYc4jEqNVco55WAvNqnAMFY5LsKp
6096	fee_transfer	1480	11000000	1	CkpZ1Gmse48GAcMcTcsP9e8wRUq3ihAcyYnsJ9BQo2j1J7EVETPNu
6099	coinbase	1458	1440000000000	1	CkpZpRpvofaU54ZxjWEdwVndmG35f4cQXEbQbdcToTemdmv26N6Pn
6101	fee_transfer	1448	37000000	1	CkpZWh1kCzNGaVhouormqiX9pV7EjG9u4VDcqoH4ZzHPbbuXDBee8
6103	fee_transfer	1457	25000000	1	Ckpa9oAssjCVHji2D7CKEWY2xLkZ4gGw619mZKLcn3Ku91UNscW86
6107	fee_transfer	1395	42000000	1	CkpYqKeQR9XcBXWDDPrCKkag9w5jQa8KKCN4qVJiauYVCf9i6hKmp
6109	fee_transfer	1610	43000000	1	CkpaJQW7LK7qpBWaJb1Vq8QHKrHCZsXzDtFgEBqvikvFVgGtBquvd
6113	fee_transfer	1699	14000000	1	CkpZM2AgZrsgB96tG7PTBHFbEPTLjkVQozbA7LtZYrdw8Smg2NEMr
6120	fee_transfer	1708	1170000000	1	CkpYctrWb2uMPcd75vk8V3WkKrcZrkVUEVXUDHHy3mhv1WjgghtcT
6121	fee_transfer	1708	99000000	1	CkpYp2CfSB4YxjBfauRTL8LSkRBebxwqTPErD3Ni6tJDwJnpg6Xfq
6128	fee_transfer	1587	41000000	1	CkpZnRnfgHsaH57K51pHPXCsccNfffKEaphwSmqggWb2BWGccAp5P
6132	fee_transfer	526	183000000	1	CkpaCkXo1Lmz8HzgRxrxyERrnUoAPfKoNeP28yLc2ErfsRU1HdTyg
6136	fee_transfer	1943	33000000	1	CkpZtDUS1jGf3MoZuTrNWDVPpuhLY6wCWHHVM8aprm8V8ndmS2qDz
6144	fee_transfer	2112	42000000	1	Ckpa9PM1xWDqD6t7t6yKCBkiPkzdmajnefccn6hqjPdaknXt3ZsMG
6151	fee_transfer	1696	1290000000	1	CkpYaC2C276eCpWLNCd47gkACnaqHkDR5jZbeBVP88Cpz4e9xdmei
6152	fee_transfer	1696	217000000	1	CkpZV81biU6iXmr6cXQdCeFoPfqPFQkGZqkTefMSFJantxtX1kDTY
6157	fee_transfer	1717	32000000	1	CkpYnDRSZFRL8WyTxuaATXFinSXSNAXi11eNzB8oaH1PpNYVzxGZy
6162	fee_transfer	1699	32000000	1	CkpYwzN1sohadRyj2ru8L2xBB7kyF2jR8Cy53QEwm3pdihsVR8xpU
6164	fee_transfer	1394	89000000	1	CkpZcSPRL1BH7PJoKR9QEDY5f4mWLbCTj9fpWPr2rCP94SKj8cGaj
6166	fee_transfer	1687	587000000	1	CkpZG5Jb9piJpEsbf6zY8DLFvwKdRt8tc8mxtbusy32329hprBK2g
6167	fee_transfer	1687	19000000	1	CkpYuysA378muK5wqmKeDSZ7F4mmWycrMX6zSgDKnqoQpMkMRKqvv
6168	fee_transfer	1671	530000000	1	CkpYfiAZSssiq1Raszs1iyQRiA5xTkidVxpcfLhMcZoCXSjQ7YV7Y
6169	fee_transfer	1671	53000000	1	CkpZrACLxiXc33K2kf1YUK7woqcEszwJ6TZHT9H6cFE9mrB6NKxhv
6177	fee_transfer	1762	32000000	1	CkpYigEGRaSgDczvnwc9zLS5zb2dzTAA8ucPF5heygmeBt27sWECR
5916	fee_transfer	1700	1602000000	1	CkpZSUy5NRoT5hsR6rdKReyfqxbPe2hLPFLv7tPLFmppxZd6WsYkN
5921	fee_transfer	1719	37000000	1	CkpZiwbzhgC4sthuNBcgH3ywT4aDWPGmjrkbQ2N8iLXC2EGpocBP6
5922	fee_transfer	1654	36000000	1	CkpZaV7qEZ59NwNgyMgRwq6PJcsMGtNwYAi4AquXKQS6oyyZCfdgP
5925	fee_transfer	633	35000000	1	CkpZiXarCuJ9GJYXPkQPs6nZGhtWQR1Tfc8sgWJN9YyA3vwZGVE51
5929	fee_transfer	1723	23000000	1	CkpZ5eYRbCKT91N34kCaTkW8tNUSb3GCv83kcWANiPMBv18okWs3b
5931	fee_transfer	1560	37000000	1	CkpZeNjZPjo92wcfFz5vYDBChe5gAP5J5e1hdQXZMjXZLxMaWHe2F
5936	fee_transfer	1439	208000000	1	CkpZKBxMKWWSGGHu4bUpRjaZc8KJ4sUVxjJ5ssCs8xtyM3d8prrWY
5937	fee_transfer	1439	16000000	1	CkpYzqCXLYFYGQmrVmUr2bTkajiUfMtwBmYPDgeEGt3ZZEJmRaz7Y
5938	fee_transfer	2248	45000000	1	Ckpa5gzWuG3XCThYSDZjJs64c2rPF1bVoXrof4WjccmwGXEhLAFeP
5940	fee_transfer	1711	25000000	1	CkpaLTxpNpqYsDXRk9yXb4fowQLLoFXuLsM6WnBEhvA6dN9b296uG
5942	fee_transfer	1694	14000000	1	CkpYQwSLjN3e3ZoUhga6ZqhhXzdiJhzsLeAFDqJF6XwJqK8r4oepn
5943	fee_transfer	42	3820000000	1	CkpaHf1jxKNW6PUEs2f36wv97zExf8nMKrNRGPBjR2cz6ShKxoxZh
5944	fee_transfer	42	520000000	1	CkpZJF9uz2gs1kpu6QvDQRFLEftVZq4Zsqwc5aouMGXowLKtLBnVT
5945	fee_transfer	1580	24000000	1	CkpZ3uFQ9wcvJtzQcheRqLhHNdxHKz8ogg9QMTsfS6w41eahEUq5F
5946	fee_transfer	1685	3000000	1	Ckpa6txPPQtie4mT6aGnqbdLuiQnsHeZ25r4wQkcRVTEEozeN8WWR
5947	fee_transfer	2106	25000000	1	CkpZmr6yndBrxKkHRrvvySnaa6iY1PsdZgqYjt8XM9WSrgvX6WA8j
5949	fee_transfer_via_coinbase	1429	555000000000	1	CkpZ3eKmVTpMqDXBnpwYsTCQkAoTnrqPjZ9bjsxF7srerJm6UGjxm
5950	coinbase	1448	720000000000	1	CkpZWcPPfiwFkQzZZenvqNfnvrDRSKtDeQGtx6ZFmA1rJUDUVWx26
5953	fee_transfer	1681	44000000	1	CkpZuuBNXwmCDWVNJirnDTam8RbS75QJ5E5sRcgDurSgY4dQtfb5A
5955	fee_transfer	1458	23000000	1	CkpaEfQBzkP4CYeDuXBLqq8WL82WnWrn1iR6ysrVw1BWhgWELMs5v
5968	fee_transfer	1560	27000000	1	CkpaCN15SGXix6mqqm8mN2Y84QyNGPurGmDCGLfHtL6GWj7pqx4v1
5975	fee_transfer	2215	1	1	CkpYXiNGCEasbQdzCWYfwe4U2mBQ4QqEPC5RRwdCYHboCCsXqaWsN
5976	fee_transfer	1643	572999998	1	Ckpa6ALpscBkXhnsMXTArQL7VZpJZ9VBt1YyeNFQaGGcdLcwQdbfC
5977	fee_transfer	1643	35000000	1	CkpZDCmJqJ1Q3WHj1SEzWjrVm9VcsbneD5eaeAk7cWPUraMZMhfwm
5978	fee_transfer	1422	193000000	1	CkpZXRxoFnhSkXGonCNC8rkBrVkpm2sjyWCJcLk3r3ApqoJK5SH6V
5981	fee_transfer	2148	14000000	1	CkpZjsZw4Mgk9RkFrkD2eQ3LfKXAK3d8WibF2RprYXhXsSLcg6sDL
5986	fee_transfer	1476	28000000	1	Ckpa5KwEp51sgkp6rRVNQdTLCP5SdYb69m9p6HmqfZhDEbYzuXXkK
5990	fee_transfer	1850	1000000	1	CkpZKLU3Sn4qjQfD7EzrMABE9uqk9nmrZZFgmaaNViF1bNo7FVuyE
5994	fee_transfer	1540	19000000	1	CkpYhe8krwTGm4sTC13dXyqCEmgaoZK624SXzSGX8dhQGFL2zX69c
5999	fee_transfer	1695	442000000	1	CkpZxGYmHgn1PnS5Q8rRMjpgZ6WuMWS7ok9Cw7eZDkuYjXARg3kEw
6003	fee_transfer	1673	23000000	1	Ckpa3LW7kw691mtqdLELioUR8vdHD9eedXXCRs2YLbG48M3JEBCSH
6019	fee_transfer	369	52000000	1	CkpZBFKeUySbfKGBECPQC66ixk5LF79MznvifBr11E7wq9Z3NzSqk
6023	fee_transfer	1509	113000000	1	CkpZQN4JSGX9yjmRcpuufQHHD8z81yBBrUzvPKZ1PGs77CDBfLcyB
6033	fee_transfer_via_coinbase	2126	1	1	CkpZQWWkgvdt6js5FLc6BwKE5DPuHm5UqgkA8VsVyp5EDZSRusA3B
6034	coinbase	1422	720000000000	1	CkpZRavcZoYc6AHUVFFQVysVaY7hgU3nFSodbQUY1AEycvWDXoMrx
6039	fee_transfer	1700	35000000	1	CkpZaVZUQbcEvq6rA8N3KsLV3XE6pLcjzpuwVRttA5q9zgJ3z4Ua1
6044	coinbase	2261	720000000000	1	CkpaF1XH6G6PhqwLFLgcrr8Dx4GiuJaEuAM4zhjgo8w2pgn3b2x9g
6045	fee_transfer	2261	12000000	1	CkpZPkxPNPNq1xwgM8xDjQ36Vq75NVVibMM8NPs1MwFR7ZqLXriRG
6049	fee_transfer	1679	82000000	1	Ckpa6y4E86pQf2UZzUqJ3NMybeMq5s4cdCkvDuAyUcVxrr4bp9ULu
6052	fee_transfer	1458	33000000	1	CkpZ91TQuSZQ2mwhZgugYLMrwb6jy3MUJ39NTccqszL1e8U8tRS2r
6057	fee_transfer	1426	14000000	1	CkpZCnbQyYK5LLTEVGBpp3xpPWyXDTDcf3mVJ9RJywuH51E2nW5HD
6063	fee_transfer	1708	234000000	1	CkpZTD5nm96Ho4K2WuCHe217Szh3E6YeMc9vuSx51wTjWL139p2Xk
6072	fee_transfer	1508	1100000000	1	CkpZz3p15ZSgTEak51bWk2ToKcpqyyeuJJ1MvjXH8vavCkrR6iKBr
6073	fee_transfer	2179	100000000	1	CkpZT7Di7pVJ9xFrHYpnpBmCYXXNrMhRC7eLSpuhbLxDspjxBd15k
6074	fee_transfer	1508	156000001	1	CkpZF3VgHPx2orihYkP6hfH2wV1adrvC21V6Q9AmYCzCUkX3GnRvt
6075	fee_transfer	1764	1500000000	1	CkpYZA5gSh6VNPct5XAU7ugdVSjpweE5QsgM6SWmRaaqPcmUBDKHQ
6076	fee_transfer	1764	510000000	1	CkpYS3yYxb62FJ8fcadFyeCv8eKGSUzYT6WDrefPXgfxwTQjdcEWX
6079	fee_transfer	2086	49000000	1	CkpYyJ7AUBf1uqrBP96X4sFQM7zBLNVro67hz1TMxuKGSBkvYJ1mm
6080	fee_transfer	1670	36000000	1	Ckpa9pu6Z47csTa8t6kh9JmVbeJhDyvmyGJYe1WdHBindSbknQ6qF
6083	fee_transfer	1708	1279000000	1	CkpYpnt1PncEv5RZFLrCuEi5eNWrbdZ8V3GGrEouhHjtK4zT3gvhf
6086	fee_transfer	1654	1470000000	1	CkpZRrXs3aRwyGyYnJdXFeHVyRYiZinCXTjLuPFgVnYNWC61BhmTA
6087	fee_transfer	1654	9010000	1	CkpZrS9oSjfs4xdGDcCmxpFSbuYRPas53Nmbj14kBL1udK6fBV3TE
6093	fee_transfer	641	35000000	1	CkpYpkDBUDD2EMoxr7WdiJ1LjFD2Xa22xATqGG5abKpvpDCgt1maP
6097	fee_transfer	1643	819999999	1	CkpZbNRyg4G7ULwmm3cBVyr8HfT7g1GtkfzwLw4H5miCxnvjV6pdt
6098	fee_transfer	1643	109999999	1	CkpYcoPrMsBcHTWHfLQ8ED8Q1bR4qhB8r1EBAca5Fwm6yxy2XvYtt
6100	fee_transfer	1458	976000000	1	CkpZfXqAH2TndFtUgu52ydFh5yskWEDnUKKdZaQocUrriaX8eJ5Za
6104	fee_transfer	1395	64000000	1	CkpZeWeQKHJrJM2XtPGrzYeyC4bu7cQUTnvy3x2c6aoxGN8hGWZmm
6108	fee_transfer	1768	32000000	1	CkpZz9feDmMUik7E6cg7mZLiMbbYPU2eJasFDbH6e8EkR6dquemAT
6112	fee_transfer	1850	62000000	1	CkpZNcfsyw1CxWHwkuApzXsy2PskBsA5DaEjcFPSDzt83ZdEuVipV
6116	fee_transfer	1650	42000000	1	CkpZWCagT7eRBpZ8fAxf1jZ1wRgFwpy8zz95sahHdJhrJGRjFGg4B
6118	fee_transfer	1708	275500001	1	CkpZSjrEGBZLpZHffFSWBhughnyzDQ9Ax2ySZ3xKb9xPd8M8EpYoz
6119	fee_transfer	1509	7500000	1	CkpYbMy6nxnGyMfXx7udJgK7sv8grwfU8R49AGg3u5PtTa8GyFKaw
6127	fee_transfer	1395	151000000	1	CkpZMvK6hWoHGxeZJVFSH9svAn3LAioGAPFKofM5wLBQwC5B4zqGv
6131	fee_transfer	1394	183000000	1	CkpZ741hpEhvrUfEUfe9AwSdpyX5khgyS1eovbRu3MkoxXh1RNUkd
6135	fee_transfer	576	123000000	1	CkpZS7ZcAyfRCp1LwkSyHJpgr3iYmFGx3MrpR4tgLPVo7pJTRZw2Q
6139	fee_transfer	1762	42000000	1	CkpZAQZDtBdLwnssZ43aqs3MThrnimfEFDAx7WairjFBrqzoqsQvw
6143	fee_transfer	2112	43000000	1	CkpYeVVy1xPHv6JtY12R5jFNoJeyiNqnY6yavDniPFStZUyfN3PnM
6145	fee_transfer	1634	34000000	1	CkpZft3qMS1vGKGMjKUCun4DHn4XmHoStEBPwZmbV9jX5k1HYmiZ4
6146	coinbase	364	720000000000	1	CkpYawsavGoG4x8DfmCKMkHQZUuiyvJoh5pdFJbfim8favqKdF78d
6147	fee_transfer	364	12000000	1	CkpYy5Qawr3dNJ8hY9g8mKj4YmRCZEZF6jnayKYoZc9sV2LZvKhCZ
6148	fee_transfer	404	11000000	1	CkpZCoBH7zsgsyop9sBTchQ7MgiQHjYjmFzxNmDd5mXYU3Zo7xdvh
6153	fee_transfer	2261	1000000	1	CkpZE3BETYochbX7XgvjjFU3SjdKQWfrKaVv8sPPkavdVKjPDJ4vC
6154	fee_transfer	1633	274970003	1	CkpYUuSCGuv18sCUfEAYPxDov7NqLT3w9BBPioUmimGXYov11c6dt
6155	fee_transfer	442	200000000	1	CkpZ4BsJfVPuyXbHQf7t3katRkDsvNx6DG43n9eZd5QdTSoEix3sd
6156	fee_transfer	2097	29997	1	CkpYmXvxsRdKKY4JFtFZcvqDsn1gw85vh9DgYRhbmD383NuPY5pYh
6158	fee_transfer	369	21000000	1	CkpZfWdPXdSLzYrkBrfF3yupW9p2e8zu5N65QFXVVJoKDo619L5XF
6159	fee_transfer	1633	32000000	1	CkpaJkZ8EybuZRjLhAwjfgXE5RxLkJknAjz4qJNMPRCJMGAPmhj4F
6160	fee_transfer	1426	65000000	1	CkpZshK6mAKBbBNxUPCSdGf6cC5382q5ysQR8QCXfKtbS2XajwMbZ
6161	fee_transfer	2086	32000000	1	CkpZVjEEMVk6e41z6XucZ69QoVqimpa1zLJvTBdKGS15BnLZDYQJb
6175	fee_transfer	1514	660000000	1	CkpZ7LtiXfNhf85ff6xHTe3968p1CWGt1Yz38DHyoJfFkhtpWgJG9
6176	fee_transfer	1514	190000000	1	CkpZ1FZPCFqhBBN58nbPe8aSCqsgr7YGLJPJMNh5U3rJtpMZ3yZnG
6180	fee_transfer	1680	103000000	1	Ckpa6bFaYr8cPUbpjvDSLdTTDePoPrHosv5hVmzdJUkceY1UhD2NY
6183	fee_transfer	1587	33000000	1	CkpZ9Hj2HuT3SSx76V6L1VnJWvZg91MTEnsC2dyhR2d6rrDChswqr
6192	fee_transfer	1764	41000000	1	Ckpa4BS7fkHot35LvfFi2WgKsishrFCaTVDSHdxiAKwL7jLXC9h51
6150	fee_transfer	1574	11000000	1	CkpZhsWvBsqmLk4ehN3t9fZe2YLehuw1HbAXojq6KiHak8tv4xVKs
6173	coinbase	1514	720000000000	1	Ckpa12QgnpezgcZFnWL8EpDosVb6cKMaGQe8YzN5K39WEtTPtCkVY
6174	fee_transfer	1514	11000000	1	CkpYV5VyJbd87JtC3y6LdcmVucERAvzHx2zjTvVgKqcFZuxnVfGJ9
6188	fee_transfer	2261	11000000	1	CkpaCPAUGMiw9UwdbUAH4ocG4XAssW4pJSZhLWxBWd1x3GLE7f8aL
6189	fee_transfer	1657	34000000	1	CkpZuF3tVWV8TasAcyNu8Lv5pQQuGkZP4PaqRFV9i64sDRUM3uSS8
6178	fee_transfer	1711	42000000	1	CkpYSH1Nu32tDKRrnQDwxt9DSAuu1Rvo7X4fVhyf7tWyMwuYmXXp4
6179	fee_transfer	1711	2000000	1	CkpYQWp6SeCfeaUs4bYzcEKwgR7wZXKmF2UkukFAD2MdCUsNQTVJk
6181	fee_transfer	1850	103000000	1	CkpZiCXoFL3aqGjhwTvov9RGMvaYhB7drxsHqCV8TDojVJqDscDCs
6185	fee_transfer	632	212000000	1	CkpZ8R6bhCqMDaCaNWJvPbkZVoHupTDicjsXYUisn2Td3KTvYvKTg
6187	fee_transfer	1594	34000000	1	CkpZmYb3EpkJjg2QSwLY7xpTAiH5rBukGkFWNFWG6HYq3GWGNpGyd
6190	fee_transfer	1768	41000000	1	CkpZpG8SWNSLMD6CDMoqWatFCMyaFUNXaKxVmMjNp9ewf2i1BUeHE
6193	fee_transfer	1650	41000000	1	CkpZjVoiQsYNk8UbCzjvXHtser5Z81V7BUcBjMaQc8RWtsDfPvErd
6194	fee_transfer	1457	330000000	1	CkpZhLiVysWuhMFbTzunPQbKgCAKoZm1VgVkZDRULwCyK3Q6Mvugi
6195	fee_transfer	2221	55000	1	CkpZY3D628zQUKoo8v5yP1mHV8wo8hw2hvw16o73gHNU6UYp8MQPk
6196	fee_transfer	1814	800000	1	CkpYWPx5PhC3uKwFUcv3Mz8tE1hXdusvPK3zEhcVFKqf96Pce7xxy
6197	fee_transfer	1855	2000	1	CkpZZbTgjHa1PkCnn6mzipumxzGYG8bfkEByimCnYaBi3N2gs2JkW
6198	fee_transfer	1719	5142829	1	CkpYUVA8hmHr2WqRPYJ5YNZBTB5E39ibzatbwPzUyTBBKouGSqEtJ
6199	fee_transfer	1527	4999995	1	CkpZYckTYZBnJcDke1MNrFKzurSaSzQfThfCbkgwWXobEEohYJ9Ua
6200	fee_transfer	1719	10999992	1	CkpZhaPWCNxSmUeNvDdyYaCWeAJACnL9WFz2yyxyL6DCz4WvxhTgG
6201	fee_transfer	1696	160000000	1	CkpZ6zL29gSqqrfJUMRCRBtXZN3TNkRGd37UGg8DDd9oJVzs75L66
6202	fee_transfer	1706	42000000	1	CkpaKx4Su1BBNjHB5emXnnXj54nSzCbUo5pAA5pEjPfxvYzvVCTT5
6203	fee_transfer	2039	20000000	1	CkpYduhxA5XciRfWewTMRAzJUhSnM98zfaqeJ489G2bbZhgFHntW3
6204	fee_transfer	1547	85000000	1	CkpZb3RJtsNZFtLAcHzzpJP6pDWkseufe4DxLFLRFcFQVC1sRLWfa
6205	fee_transfer	1703	85000000	1	CkpZHvS9SxW3cQpZVtc64L297ZnDSn99JoKkCjCQQVfZfWeEDmDEp
6206	fee_transfer	1702	85000000	1	CkpZkmNtQxL7R4Ye5JjS9jKu56f1u5bZFdHPu93VBbPUsuboUzz6k
6207	fee_transfer	1547	530000000	1	CkpYc4V6pDE4Truuuea9dJbfY128UJpceuMcQepY4MD22YMM4SgAJ
6208	fee_transfer	1547	485000000	1	CkpaAnBf8Rpc6WhJ93EcejwLYRaBKHcWDQKEnR4gSuG9CfSvzGgXW
6209	fee_transfer	1458	1490000000	1	CkpYqv5SoNQqbVvLnRVXU3rkaxVaDgLZRrS4fx5bvqR3tNURBbeFP
6210	fee_transfer	1458	300000000	1	CkpZKmwmHCf28wZ3v9zXbgieJhYg8oZXghdUVMgb4xo7SU92LZUdJ
6211	fee_transfer	1571	52000000	1	CkpZBkYjw8qro7ontE6KUdWqb5dw2dAdNrw5BkZBecjkAddVDB3PB
6212	fee_transfer	2248	23000000	1	CkpZ4S1mrpjat4QFQ4urwG8RXpV72KaE3gv6g3GHwp3jn31ytvSux
6213	fee_transfer	2112	33000000	1	CkpZeThKCxMBgWAQKXhefmugqrMHLeeuVCXwNjoD3Fxq4t7pGa1ez
6214	fee_transfer	676	11000000	1	CkpZevdA7sS45Ttjv9ViSszvVW94WjaFHPh8im4Jy8mzkxyndz1Dp
6215	fee_transfer	1444	23000000	1	CkpZVDP9ENUXkrax14WnUWJxkUWose45JNeuadnrgayf1kX5oR5SE
6216	fee_transfer	1688	121000000	1	CkpZePV7bBA77Q1sjyqJtij6rjxM8poKXKVsJ3HPUBzZy1yx78fRR
6217	fee_transfer	1593	642000000	1	CkpYsK6ZRi2aKtxHqHXSyYiyEpNBLojVQhBmZ8StzJ7fXH8RCRzhN
6218	fee_transfer	1593	172000000	1	CkpYXyjGZxVL6pni9GGLnZAdpN9JvDK69us9YgrCxAnQhT1mi6Zi4
6219	fee_transfer	484	830000000	1	CkpZsXRCNx1zhRiwJRYPrN7DpAhAwVaB6eL7B4r97yauR74G8Ua9a
6220	fee_transfer	484	680000000	1	CkpZm719df1R69rR3Wc4AjghnwM7pZ2zjCsjho5pyEyu2LVEiFU3w
6221	fee_transfer	1637	33000000	1	CkpZKfqx1sK7ZCms4i2dwR9ue8pgyLDpJ4y3LmSyjuJgr87WEQdVH
6222	fee_transfer	662	23000000	1	CkpYxE9zckMK5Gmq69Le2y2c2HZjqTB5Zbz1J3c7DpHMVP7w4F5YH
6223	fee_transfer	1451	150000000	1	CkpZDiwDwPdhErR1En6nayhCb2XBDMreejLz8Pz8squVk6QxT4kPA
6224	fee_transfer	1747	22000000	1	CkpZbSGUTcWZfbPYBrJ28LPCFkKSocxUfAYphq1PMStf5UgFmbxyw
6225	fee_transfer	1746	22000000	1	CkpZj43u333aMD3oNk4Rt53oddFT2HsXdtByHWSRHBXP7bn3TNV26
6226	fee_transfer	1704	22000000	1	CkpYmcNdWqMqHD66Tn6EDztWgU5iEmPzyUHoY4uxyG4Qytw6bbfzT
6227	fee_transfer	1446	12000000	1	CkpYrcBei8aE8hXpykGpozvQ4eDTFWp19hrzz1ktm6HpKgYsSbPG8
6228	fee_transfer	1681	22000000	1	CkpZwxhrAN9r49ZmWreo1iZk2BgQatKQmEojoZtFVWv1anRRon6Lv
6229	fee_transfer	1705	33000000	1	CkpZNoNXTmhPnt5h4EWxB3YQWq3f2NLYP5HQawjnRYPogp8jWrkh1
6230	coinbase	247	720000000000	1	CkpZbA1zduPjSttajLyDkhZrzNpJv4wDN5CjNLVKyu7VLG91TuMPr
6231	fee_transfer	247	12000000	1	CkpZ957UTvPy5bHzYGSk6mrAyiHm2BEX8NXY4wF9src4Ct5DtXDM3
6232	coinbase	1441	720000000000	1	CkpYmgzHWfuVtjNgoPCSD6X32borrDWUCFN37s82MxqMKpjwA7rTu
6233	fee_transfer	1441	22000000	1	Ckpa4BirZzQZqJ1EcCEzSGi5vatQRwNZchmqkPRzJ4cnWqUdhjind
6234	fee_transfer	1671	980000000	1	CkpYchtYtvXkLggiMnwHjUATha2ELehrmBAgE9GQvQ3YYbAxUxyJK
6235	fee_transfer	1680	162000000	1	CkpaEqChpcVLBiPFVqWF6se2oZUn2vJp9kNEeVapUCpR7kQFSkseT
6236	fee_transfer	484	570000000	1	CkpZF4nssodhU5wKK6FpTRxY8kGaX1kZBNQSodhXrDbp2i3JA79Su
6237	fee_transfer	484	500000000	1	CkpZAQjTiSagrFtWEjNE7h7XmdMPHZqbeQtmMNK1noM8DGc8cdidu
6238	fee_transfer	2135	850000000	1	CkpYjbNffhTv84QXZPkzDAkqDF2QVyMubsvokYYD3u8qShFz8ULSC
6239	fee_transfer	2135	490000000	1	CkpYf1YpTsq9aCJxVNSjwnJh8m3oVBViURRkB2PE8E9zFCxpw59n9
6240	fee_transfer	1394	44000000	1	CkpZyZ2nxcAu5Ri6WBi6UuV6VUh7n3DnnpvJpSm9VeKtbBA3eUxLN
6241	fee_transfer	1685	44000000	1	CkpZUZG7yVPkLU5X9zDyHUYbNfQWpYA478SLE85bZpoCPgrdgXtkd
6242	fee_transfer	2248	13000000	1	CkpaEuXLMQgH6VwaNA6HhPesUFnhvzDRSCvH3eVEqMmBzfDs3xJuM
6243	fee_transfer	1687	1320000000	1	CkpYVMiwu8r3gC1ntERwZMoVCHe9aiHbXXw4L9jEQXXUgCkhbitMR
6244	fee_transfer	1687	190000000	1	CkpYUZvYnNghFZQHVvNBUn31DY4VQ6BtciF9kcX89EvRdVB6aqjJm
6245	fee_transfer	2148	11000000	1	CkpZC8ZBEHadfobc5davwE1vg7zhiNcTixERR2in2euhhV3DxTf7X
6246	fee_transfer	1552	22000000	1	CkpZ8m7nZPE31m5xPMmiuLJpSpYYT82fUgEWpp2r3wFQzHZjnYNMT
6247	fee_transfer	1680	47000000	1	CkpYRznh2G2BzrZeAi4YJ21txjxyiRUG8EuZMReXNY4mkbhxQCR88
6248	fee_transfer	1680	55000000	1	CkpaFwZdJz72NXqUjXbDKwF8GVQHdgrD441FHnHpnGENBu9YeQfLk
6249	fee_transfer	1764	55000000	1	CkpZj6w4HgrJYijvp3mW3twMfXyihLyEYC6uds5DkWygVQ2esRQsP
6250	coinbase	1688	720000000000	1	CkpZcorFbsYZF28n3HUwEjF4dHkfEYcf5eb2581412xTNtuDYz8f4
6251	fee_transfer	1688	999950	1	CkpaFFTGTEDt9jPbiorELZM4R1X8vYkAXeRFwMsr8vt8i5pFXC9wy
6252	fee_transfer	1817	50	1	CkpaDKzGoMLciLiBKFpvRHzyukDTWoybcmhfixGhKe2M4YZZo97Hs
6253	fee_transfer	1740	209000000	1	CkpZ3MXvP2VKBU5dmHCojwWdjqMKDf3UVW2ncFJQNuh5u5oMm6wG1
6254	fee_transfer	1547	51000000	1	CkpYzd6oLmgGGJnEBU2vyaAba199wy7xiWJm44xs4J22WCCHbaTaa
6255	fee_transfer	1672	62000000	1	CkpZBx9ShnYXJb8dFHLzwP8MmUwgma2UiiBpaCToC7zwBKLwNpMxA
6256	fee_transfer	1724	62000000	1	Ckpa23uMHE4Kn2qoemzB4uVqtM6uepxRPaaa86zpmkkRnFtQQqq2L
6257	fee_transfer	1670	44000000	1	CkpZCgt4u5Y3ZRTuxN5nrsz5xuLeoLRHTmwAZ81UZ8PghPCpFvQKS
6264	fee_transfer	2261	24000000	1	CkpZta3k2RMZhBFuNCLp1DsdgovkwY7FCVKf7PKx4ZK2VSKMrkxuh
6270	coinbase	1740	720000000000	1	CkpYS7nTBrnSyjzu2ZGvFx1tmSBBufP4KdDXMji9S46eBUG4pxCww
6271	fee_transfer	1740	11000001	1	CkpYXBXDMvbmFF4uUFjQXN6U444Ug1V6QZkx565WUiYg3okDpVCDZ
6272	fee_transfer	1522	213000000	1	CkpYQ5pbQKWsGmDXb4T4wAKZNzJTEQtTjKb1CoR6vauELc519MXVA
6276	fee_transfer	2199	238000000	1	CkpZXFuuwDueSPhTTKsHmr63XDJ7DQBWsYX4gJNS8Y5VnnJuCRrtf
6279	fee_transfer	1402	73000000	1	CkpZFni6AQGLWuyZ95xfaiA8Z8Lv9DYx2x4RkHMoJ2adzdzpnNCMZ
6281	fee_transfer	1536	1059000000	1	CkpZjtwL1iix99Jb2mKgoA5QqTdgfPitQz7JMXygFqy1NDr2EPf8m
6282	fee_transfer	1536	12999997	1	Ckpa5ipiRDTC5Xdn6eLhXw7surEibH4Ayk4Wvh9FTY4XeGYZHeiFz
6283	fee_transfer	2221	2	1	CkpYSaznmKdNyhQw77kpTSjN5XagspGUbqpNUU9n71N1saN2YXxGD
6284	fee_transfer	2039	57000000	1	CkpYcU24KL8ZjBKZfY82ZBzXqi59uKMfNUu3zEt2x4p8H4TtAbacf
6289	fee_transfer	1395	52000000	1	CkpYUqXMcTUCt2oHimFpMNbKsitKz2DJtUWQJLxGNZm9BH1zg9gWQ
6292	fee_transfer	1549	64000000	1	CkpZ7zR8wMoYFq3NsNswxFwTuG55okTLrMPFWcYiAH2D288hPkphB
6300	fee_transfer	1685	213000000	1	CkpZynmHPmGNgiDRU58E6ivb6GnBgJG2QsHZAP3QKR8qPXzPYcPvb
6310	fee_transfer	1608	33000000	1	CkpZvJ6UTvLCMbTGtUYUPvjJm4sfS2PnobvfGNJRdUaghcS1qEKyq
6313	fee_transfer	1673	24000000	1	CkpZhhRXeEW3pH9sPsT8yzrjuahUH9T9wESB1GVudGw1yupKQtXAB
6319	fee_transfer	1568	200000	1	CkpZ6ffvWT353MtHVSR2Nj2Nd63ZNbja2EbM2JWwXExPpYhXcwqua
6320	fee_transfer	2097	259974	1	CkpYjsLhzGmKFQ4bXpFzmktuqryFN38EhjJdW2bXV4tKYq4dBrtpS
6321	fee_transfer	58	6539604	1	CkpZYYTPLLxrtaVbmfqjFuRS6oQbsWrC4QehKWD5W8cPWYxsXSxcf
6322	fee_transfer	1571	424	1	CkpYrxSWsgCHo9f4ToBC3UC4AD6oFS62UU11YJvWKiaVACbEEHhBx
6325	fee_transfer	1613	1254000000	1	CkpYVV3dhKss3FiSR84hq7GSAySCwaK2Wu4nW81uNQ4dEHgWqMwMa
6326	fee_transfer	1613	17000000	1	CkpZMnHt5NCdBfyzYopZZsqSn3C4TjbDD6M4s5L1sVC2FBpzCEDbg
6327	fee_transfer	1402	7000000	1	CkpYvnnt2W4zy8i8XJYpR9RzYmcYJsjyAZSxXJm91wC9mmXVSzBS3
6331	coinbase	326	720000000000	1	CkpYx386aARKDmKtxusjA7hsEVTqMQe4Hfao9kE294KnMaLUyyHhk
6332	fee_transfer	326	12000000	1	CkpYr5BEgiGfpKpxZvK9VgL5H3r6ohZkBjT4MvziHXCLXZGXHJ57w
6333	fee_transfer	1458	29000000	1	CkpYsdo8HZzjSS7sko9oYCbWziQeYPb6zg47mtZSUpPzS7V7CuBFn
6337	fee_transfer	526	1880000000	1	CkpYpKMXbT74X7cNKDJf9Xe6ZYhjmSaYvZqsCPEafb9Vr9pwxSAxG
6339	coinbase	1443	720000000000	1	CkpYetuHh7CN42G1ZAK1g4uHQqdrnd4QrDWQLhWdhepdFhYmf31WN
6340	fee_transfer	1443	24000000	1	CkpZW7UavKQF7HvKiFKkPTVqzWvrpVLPpwgQJJGzN2ZQkTWFktZdy
6341	coinbase	1536	720000000000	1	CkpaFAsh7CcgBDC31VpaPaSNejQ5nDfCKdkBjJZXoyAMbZJYNHWaw
6348	fee_transfer	1593	41000000	1	Ckpa8SgwzHk2SSQwG1VmNFcyNvrpNLNaU9hkvcFCu8wDocVtGTHB9
6360	fee_transfer	1756	22000000	1	CkpZ2tpe3GCgwbx4Q8HVRXoj3LnD4Gq2qi8TUEZh42q2er6gJgAHG
6364	fee_transfer	2112	24000000	1	CkpZad7WspCja2RKmeDuFGXdMLyL1srqHnSPRCYKYMKfDimmwp259
6378	fee_transfer	1693	125000000	1	CkpZyqAyhWahwVZi7ocm9FGuWJNjPCA3YHjUnx1bErLReGReXWZ4m
6379	fee_transfer	1536	23000000	1	CkpZfqwRaBotQbP2n6erQ1YsjH96nrKtkFkC9k6chkePW8b4S1qi8
6382	fee_transfer	1402	482000000	1	CkpYciiAqqk6LGZWKnw1azAHu73wB2vVc4t4LnyQbtHEeafP4GBQV
6383	fee_transfer	1402	85000000	1	CkpaKKG8pphmqzswpP2EGA6bSxqJuXdVaeVaB8z3ZKSJ76EWiFGFh
6384	fee_transfer	1599	9000000	1	CkpZywK1AK88a1wcoAYjGrUyM1J8cntPRHVCrZiRBiz7tXn8oqCjR
6388	fee_transfer	1703	24000000	1	CkpZWX3vyUUg1yMhpkGagGbJWV9qb7znRkeuhW8VGApxSq9MQUpht
6394	fee_transfer	1546	24000000	1	CkpZnfXAzWEecLA4KHtCj4987vtKXbH4nurmtceXYzMmHkorStS8x
6399	fee_transfer	1394	16000000	1	CkpZUiL8PFtGkpKPt6hWYvmaZAas1DQRmdkMKUo6qbfdnUkAQJhmP
6401	fee_transfer	1623	16000000	1	CkpaFuWy9jocAtsQkrNZ48PioLMeguazHK2qs953LUAN6x9bQbjqo
6407	fee_transfer	369	48000000	1	CkpZ78Xu8g7BsFuwSxe4C1bWUp3WiSY3w36iSYUkz1Kp1Ea54YkXc
6412	fee_transfer	1555	24000000	1	CkpZzicHdLr7C41ZeXTsyR9aR7j9MqSwj1jy2RSUKskDJ4XuV91Lw
6416	fee_transfer	1634	688960082	1	CkpZHMgS2UvpY1NVcDyPUvN4GLfMHJBYV8szdBwkiRV4HD9EogMo5
6417	fee_transfer	2257	1	1	CkpZSMQoKfJWPRZDqyhjBCapkrs8kssicfrDNfjbvYLZtrM3Wab6m
6418	fee_transfer	2229	1	1	CkpZwSRfTQb3Anqqv51ucbDCzDrXvgPGqHij1psPguj4iBofirB9U
6419	fee_transfer	435	30000	1	CkpYUHRttuVcCV51NWkTDXUycJDzfMm5XcqGbFhpCkpLJrSvruiSZ
6428	fee_transfer	1423	22000000	1	Ckpa53hKGcUsMMtcjKJ24sgt4JkdwNT3k2dJNTo8HEdwKsuZ1r4oP
6432	fee_transfer	1686	84000000	1	CkpZEKpSNJYixjQj2Qv6vvduUUxGgYcc2TyyX3Azx3nEEbwqxh2Vw
6435	fee_transfer	1724	4000000	1	CkpZBGzUV4zKq43i7zK18sB3dZiWhb4FeLdVmC9tmrke8VyKMtmWv
6443	fee_transfer	1638	13000000	1	CkpYfEhWr9gkHDhy2hoRMb41t3ppLGyeNMMpPUqnz17ape9Bpmr8H
6444	fee_transfer	1980	50000000	1	CkpaGjRycsnnSnbNSxNZccmxRjzZsmREnqZG3YUKvVcGVZRX2D2Z3
6452	fee_transfer	1747	42000000	1	CkpZTaadh6i8hqWmiK1rkFU6nvphZbiZkw6BgJ2ZXGYuHfmpGxXnA
6462	fee_transfer	1690	378000000	1	CkpZY6gVjeVUaXrqgpFV4p2mMLiCc3rdCfAtph34s1cVoLoayNs85
6463	fee_transfer	1690	14000000	1	CkpZs4xsJHcG5YAUoG9d6vtGn8UHqtqQFMHD76Qf9SxZMtQGey3TR
6464	fee_transfer	1474	37000000	1	CkpZvMdpUJpmdRX3eyY1eZxeK8G9GKBHKcnC5A1hmq2gSW2PKqRt9
6466	fee_transfer	1547	24000000	1	CkpaB6djCaFFRpQLTpngW5BrtUK7eJykBktNRcda2GCehqRQ9qLVx
6467	fee_transfer	2292	13000000	1	Ckpa8JvP7KyFQ3m2bsSvnudefekLmfEqTc8ECNN7mgAXAVAmtKTuw
6481	fee_transfer	1611	413000000	1	CkpZrsyaezmBMKrX2SPGAkMxMMHDhjFXc3uBZtQ2PbdMFxABLTnAZ
6483	fee_transfer	1991	25000000	1	CkpYgKXes9qVpU2qwdhceWvNAgE6dQVi9421A3ezXdrUdeakY1C1n
6486	fee_transfer	1611	5000000	1	CkpaBXEamAy7YY5yswD2YtJ6tCbLwMTAL7FZWZDsuQj8dbcxwLRAN
6487	fee_transfer	1608	25000000	1	CkpaE5BDTm6wihwyCY8i4YXxiD3LqoCKGPUgv6PdFHNmvGbaGcphg
6489	fee_transfer	1756	54000000	1	CkpYknscDTfN1E18B7Wtui7SbQNmmD9UNZE4j4VkyjSeMWHtZN8oE
6490	fee_transfer	1698	36000000	1	CkpZH3oUYYCD3Wd3U7w3R1RQrY5fLxZHEWrUk7ZKf2cwX9t4X4uXf
6493	fee_transfer	1611	112000000	1	CkpYvkjurEFbnm8TZ7dEkVxgMEUqSVCgHyCUwu2L3MyUVpWdH9Q3q
6494	fee_transfer	1587	14000000	1	CkpZRzkM7sb1cL5SVFinKwMM8h5Ue4Zi1CStHKUX5V3jxvmVQYPAf
6497	fee_transfer	1619	14000000	1	CkpZw1v1tLiSHQkVnMkb8DzH4UwYD6AHactetAbXVX3MzFdBBmKg8
6504	fee_transfer	1522	25000000	1	CkpYhSyMjdK5ULNMEpA9xhSeL7bV9iarUEdbippkjHn5ULxkhjA3K
6508	fee_transfer	1506	1660000000	1	CkpYx5Arhj5nxhz5gfGEfJGv7bocUb9Z77osLdzff8jDZpoVRUtVk
6258	fee_transfer	1522	44000000	1	CkpZinP1MRKEUERSbcXCw35KAWxNc8BfTEcfxJ3VN4Z8fUBZZ8sRs
6259	fee_transfer	1476	22000000	1	CkpYeLTLmnJbtxMwZVoiVd6AB8d9ffq3ciJPH5gpBXqt4DsacnVst
6261	fee_transfer	1681	54000000	1	CkpYhUoQ9nB8YisKenAHK659Qx8c6Zx3T1ELeBHzPeAPEQrtgrVnf
6262	fee_transfer	1680	113000000	1	CkpYdStA9FcRJKqyhR4jnSqUMYdVFB3DT9j6CSEPUrN96tJdHvpzM
6263	fee_transfer	1451	200000000	1	CkpYdSyoWJsTWMNCJpc3GwRC8SNkHTCr71gMzDBsTDUZFRHAvQhiW
6265	fee_transfer	526	1150000000	1	CkpZTKZnBvBtRpCZD1kqbEKT1fyEJMG1QGrrZtmjAt3FStuEK9gxk
6266	fee_transfer	526	190000000	1	CkpZvM85J1NgLJzopdYFLD26mvWGMGWovsRgk6896SSgyDQT6f9d4
6269	fee_transfer	111	2000000	1	CkpZpTEo3ZhpGbee84P1xFc23rh8D4v6gbVtyi2GUgK67EmUgwaSR
6274	fee_transfer	1594	212000000	1	Ckpa168euE6faPVYk2iH6NzWMwmhNwEZ5k4acngZLhLqzQkxpqWVk
6277	fee_transfer	1684	24000000	1	CkpaGWqrpx7eRysBYgMsnAjgiTuzmA942dUFJbjdas14womowL9Q6
6280	fee_transfer	1611	2	1	CkpYnCnx3aPqfGzGG5216VtEKQrZxmsNr75pzHXw49YhHDHMZbmTX
6285	fee_transfer	1471	57000000	1	CkpZMa28PyQYkABUFNmmiLC1L9rkkZrfnTyAXSTDA5fKzzYxBcbLp
6290	fee_transfer	1408	52000000	1	CkpYofrXx8EoJ4mP5YYpzFFvfW9jSue2KgXwmZ363zbTvBuZ8M2Q7
6293	fee_transfer	1657	64000000	1	CkpZsHYRiWUwRbTGs4ATpwXYd5JSAAZygXDPp3HhxbqdfGuCguT8v
6294	coinbase	1657	720000000000	1	CkpZ2WxMkoZbhCfmW6s2GfiEiXeMh81q4NYHQKQHQL3M54oGvNGZh
6295	fee_transfer	1758	3000000	1	CkpYvMBqcxfLiMgrL1cxzNYySLRqZHotzHm1CoNz8c46rRcFxV6sn
6306	fee_transfer	1402	37000000	1	CkpZZXtFe1LF2nkc2uXn8Z63RwGQGKG7r9vZcPrRboKMuDXm8sxtz
6314	fee_transfer	1440	1662000000	1	CkpZoLS1UrJePyB4bMcv43qYtp48tHayg7B1i9hrBRBoCCGMFSoMZ
6315	fee_transfer	1440	16999864	1	CkpYW6uwyfM8XEB9yXBNKdbDA7tjMWwgs4eAZksExy8kJmr1qy5as
6316	fee_transfer	1571	136	1	CkpZKHart2mobeA9SMt9wCp35WfTVoqzJACg1k2gHeTZsGiiWGNpa
6318	fee_transfer	300	12000000	1	CkpYefaxZW1oigPZ14FvFDk3pZ1pNyr9XpZbf7Fn73KrgvTettcWq
6329	fee_transfer	1602	1150000000	1	CkpZ4YBMiMb4PwCfoccVHuDXuWagoc3tAMdzkHWgCZU87xa3WAxPq
6330	fee_transfer	1602	160000000	1	CkpYskWgCjcQbNxDGT9NjoMopinoYbSSFchRqutQzVidYL82yGB23
6347	fee_transfer	1419	35000000	1	CkpZNMUKd1ZAwCeWeAWbb89mCPY8mfHUxVuUk624kfi8Yp2kWuZj3
6349	fee_transfer	1593	42000000	1	CkpZ76JeBXf4WtVTruCj78KsGWpfXaaD622q4433mUHFaNwo8amED
6350	fee_transfer	1426	13000000	1	CkpZeBSBBaYqQinW6iF8hpfskP2YQy49qd55Yy4oCHnhGkded4Taw
6357	fee_transfer	1739	1730000000	1	CkpZrmd5jutRc32qRe6Z4Bhp4Uc3Md23KnzVzLqnnzyTa22nD6HfK
6358	fee_transfer	1739	340000000	1	CkpYhPvnHrWR6z4NBoyAeGVii4sbjLWtHWLwnPrHtLKAgY5NdAPnq
6370	fee_transfer	1675	32000000	1	Ckpa51p8Kb5kELi2KhrbC6kLeaooF4F73K2et4NBXVTpSuSxSZ9Fm
6375	fee_transfer	1634	54000000	1	CkpYm6HPXMfFgqNsDDxg2LXGUJjHz2rcbH3Q4d1RHv6hc35rGvuTc
6381	fee_transfer	1619	2000000	1	CkpZG85KDULrn1KWEfj2r5RAKhDG5XTys5UxfgbQvN7SEEjtE2VQH
6389	fee_transfer	1702	24000000	1	CkpZPjeH557ZujV5TqjGJLoAqrRBCTsjV1NXEC87qmStEBtdyucwX
6391	fee_transfer	43	161000000	1	CkpZUQ9W277kNattq19xhdaVpL915HDXRDzjfS9vjS7DM5ip1tmY8
6397	coinbase	1613	720000000000	1	CkpZfnh5KEdKHTS8tUKDj9VK4Mfi3TrAjBMxyDZH7uLfhWAHHvvqt
6398	fee_transfer	1613	11999998	1	CkpaB6o7dfBzTUgXkBVo7SSDks8KddjDgyHTpHDCDZ15ggUAgAUdh
6402	fee_transfer	1695	490000000	1	CkpZyUWjBGLDPGzcxbES8LV4dXxnCoLfEVRP4CSbRdHy7oZtMiJmk
6403	fee_transfer	1695	707000000	1	CkpZJosmis8ciGgxCEtpx8UNQpE3SLH2M3UvzQ9g9H3UgrF5ZfAf8
6409	fee_transfer	1850	24000000	1	CkpZmnweuZ8kRmNRsmvcwy2EDaJGeR4A13dkhrnhV7TLyB6Bspunf
6413	fee_transfer	1739	1010000000	1	Ckpa5QZiG9K11Qg9WsnCLbARBBJLsJEeRNn8kLq7iZEdBhxhLS73E
6424	fee_transfer	1471	35000000	1	CkpZFzmdSMEhapjjAVaDuvqN5WM17JTijKrH9UJDm4EnhYRNhtYjH
6425	fee_transfer	1749	72000000	1	CkpZBxEeYe268JswHL4UPbx9vVYtoJxuwuSGDtBPztMDNoz867uCD
6431	fee_transfer	1762	4000000	1	CkpZAQBzCJeqXuBp2BbepJLaT7wk35uKcuPRpBa139ohYCaGxM7Ne
6439	fee_transfer	1701	636999992	1	CkpYTW1Faax9xYcRaqjLgQ54NtzwRYt17k7n3HrwChf1HXgkQqKq3
6446	fee_transfer	1550	12000000	1	CkpaAjYNtVQTeDrzfmXwGVaV2JwoDNA8VpnvjHwYQSquLUqw8MikU
6447	fee_transfer	1656	37000000	1	CkpZch4hg1aP339fv3YJrktZPqirDkExbVJbEYsv5ZxEs86yy8v59
6453	fee_transfer	1673	42000000	1	CkpZ8WB4DXxh7FUYxqNFX2oQJZwaXg447d4eea8pafiXhqdqkjjRc
6454	fee_transfer	1690	285000000	1	CkpZj3wk4EQaqCb2ksFT6WT4gycYYFwHNWEFUtAW3nhrdj499Pogx
6456	fee_transfer	1686	45000000	1	CkpZZEchcJAz19QQiuFVckM1mceDLaPeoxpjK4yJGDjqBLD7hLYAm
6458	fee_transfer	676	25000000	1	CkpZR8oj8fMmtFURRuLXU1U4n8RbgcNpK9VHLkrecNC2BAg1Qqm4M
6471	fee_transfer	2049	13000000	1	CkpZMAoZQT1VeDSzusbFMDcXT7G4wyaKooQq3jTzxkei4H9fApzSy
6472	fee_transfer	1654	37000000	1	CkpZ9UtawaM1miGXq9xyDqA59WRLLHZdzc9iGh8gJP7UbPWwq1FUs
6479	fee_transfer	2148	49000000	1	Ckpa2ekt2cEPQEUpC1HfWP6KHZhaKFyNHyCGrPBzCBu7DUNo4GK8R
6480	fee_transfer	1457	213000000	1	CkpZDZLzRm11DPjFav1pYtg6PcAF9LqXvBaba7K6XeXDAueMqscGM
6488	fee_transfer	1756	704000000	1	CkpZFhN68qDuU8wFgGyCzobDEBq71RpYNFNLtBUfAwy3C4TFQqAw8
6498	fee_transfer	1705	24000000	1	CkpZjDaK1c7Y8YCyCYneXgLneVWjhKZGkTu65SQoo8C9xBco8YUZR
6502	fee_transfer	470	52000000	1	CkpaGP5oFXKm1YrZM5zCECJUPLPdA8qv1HhEzMQgBUV3NzPGgFKga
6505	fee_transfer	1686	38000000	1	CkpZZSDXuUhEJpXuqjLL6w5ufAgtKWgHek6nTdzkjoYUwEv8FxFSA
6507	fee_transfer	633	26000000	1	CkpZrHfYbgNtVVhqhgoGtum24u5W2wbDY56qi1amTUQ2KAj91MHVr
6516	fee_transfer	1394	4000000	1	CkpYSBabhCAYJ178txE9EscwoVcYhSS3gQ2rpSTsDmBz8SpBEs2xv
6522	fee_transfer	2112	350000000	1	CkpYo5fYrf7bjFqV9hvzrUhKsSc6s6BjnSFm1yNc6qwzFxV2Yg6h2
6523	fee_transfer	2112	32000000	1	CkpYa6afTm6NmXH7nDsy4uGtfckaZM8ejVrUsWAY9UuwU2yTU5xrR
6529	fee_transfer	2260	20	1	CkpZvg1e1eVsb1VcLSSKsZdfLJnzby8fBKZZVdvJtEmeaPyeRcbWL
6530	fee_transfer	1501	3200000	1	CkpZX3hyC81JsChqgrSA6KJamAb752YGTrcFRkWHWyrPEd2rthqeR
6531	fee_transfer	1688	799980	1	CkpYyhFBPA4kQqHLxAzD8BGGgBjSGvqbHqNX5oMiGiV2yAY11ZJxk
6532	fee_transfer	1501	7200000	1	CkpZM5xySv1z1gpHjJfutHtRWJkRYjup1XS6vo2sUjPJrXGU9Kgxe
6533	fee_transfer	1681	15800000	1	CkpYQrCHRfv3DQUjkHGK9vCoo4eUXNC4Abuj1iZPyorH1uoAVYAPR
6537	coinbase	1649	720000000000	1	CkpZie6dJacUtwkU3KT4dtuKcyUh1S5TuEbwvJcEBBkNZSpjYiaUk
6539	fee_transfer	1701	28000000	1	Ckpa76sNhRGFJ1BaSuG4jgDcJVDWYfQxERwx7q934VVe3GRgiZMmQ
6541	fee_transfer	1708	37000000	1	CkpYuMVBtWHevwpv9aEegG9o4Wo1s1Q34tMfBSqbTKt8DbxSGFPto
6543	fee_transfer	1700	34000000	1	CkpYsVzGFE9czetksi6TSofB4ZVQjqPR6r8jMqGMVZXXgJuWXibQX
6260	fee_transfer	1740	28000000	1	CkpZu2DhqSMbgE2oKoAHSi6jHJ7jw2op34Zc4PSgHAY6rCYnF1tPS
6267	fee_transfer	1506	720000000	1	CkpYmK8bTeDLApQ6CksRCnnmd4HmHmv148FkpzsViN85xjPvFCJR9
6268	fee_transfer	1506	790000000	1	CkpYt9y3WTzeuDRQg7BerBvDvN8kG8a88DUddsGR3pHNjatmPm528
6273	fee_transfer	1522	3000000	1	CkpZwR2iB9QCD9LmHnEni8JtpLX9KcmeXKgConeTU787MQxjeSfev
6275	fee_transfer	1690	412000000	1	CkpZsNUP9Jhii4ZJgmoui4SvBjqknEke4bUCqXRfp5JB9fw3Ur5HR
6287	fee_transfer	470	57000000	1	CkpZyvPPmME7yYiTgNvyq5JiJLzqB215phfLSMPqG36d3Qrx6NneZ
6288	fee_transfer	1402	44000000	1	CkpZfeswtRk66hTnQ3FjEaXnEcqbHhidwgzag1AsTjDFadQwvRQA2
6305	fee_transfer	1599	37000000	1	CkpYS3wy7gooHCP6WYxNvFUmig8Dd5B2Agx6QCvHG4aUeEy8ADxbW
6308	fee_transfer	1544	11000000	1	CkpZmFVvYzWyKvJAWRY4cLdV7pbvcThNNkfz1QQGUxRWYDF3RKX7s
6309	fee_transfer	1696	33000000	1	CkpZDiG3vgxkVGQka57wb4CJiwPbK6zEKDdQVZprgoA4FGbz9CPC8
6311	fee_transfer	1541	13000000	1	CkpYb6PGpJS3EPgJJP6heMftPtYpQUXE5vyqQbP1q55WBXAYkJbfN
6312	fee_transfer	2039	25000000	1	CkpYiEiSR2r95kRtTyBmXaRjzWoyhknNFvt5EHQuGogf8xkSgvsmL
6317	fee_transfer	1506	1280000000	1	Ckpa7DNe9f4kt1NiNwGyRr5HFgmSPCJXYtTawhEfXVathsavW2LXh
6328	coinbase	1536	720000000000	1	CkpZUi2UHheF1SLAaYUtou3MLRcJxH5DqGCMUJbsgDmuWMpkeHvEp
6338	fee_transfer	1474	3000000	1	CkpYewavJaj5KuzzTxTLR1f8zkgBduUhWzcbtBcZ4LEynqND7wrXm
6342	fee_transfer	1714	14000000	1	CkpYVJou3EVhuEVgGLbSXkZNT4gAQM1Vxx3TkoqPBT5QJUgjwM5KC
6359	fee_transfer	1708	36000000	1	CkpYttfdxHwZ5tAxQnhkHf2DQNFgQnq5bNjw8rG9FFVC2K4RWNmet
6362	fee_transfer	1560	1710000000	1	CkpYz7znoBiM5nE5r4RcuVPz2rb645jF96VFGng9b9szAwN14M5gX
6363	fee_transfer	1560	360000000	1	Ckpa5VzeGHjhwPMcFW4XZ7sXq1azaupadnXXadHMRfxLYNGiBhK6p
6365	fee_transfer	1402	400000000	1	CkpZE8ciQW1Pm243J3fHkQnWA2qykXNYj8bKKqgcGk77u8yrCag9u
6366	fee_transfer	1402	310000000	1	CkpZXS8zTxNajbkbxMK1ceUp6W6qnZcFpL43umG2HknaXzg1VssJC
6368	fee_transfer	2087	32000000	1	CkpYpg6aqMvoGmTf1cBV6UmCqPv5NKVquThhNnX6taxhNNsAx2wyT
6369	fee_transfer	2087	44000000	1	CkpZGemRwopoPSoPN5mW19ktSHuVzamhscehQmyr3gtJH2wxJX5aD
6371	fee_transfer	1593	54000000	1	CkpYRv2kA4iHeUosMbByktXc72igjrJ2XcjUwNfm3h9QxgdcscPp9
6372	fee_transfer	1593	1999966	1	CkpYZTRdApjWLek4dTKJ2hs4drUTKw648b7Z5tp7up1QQMXoFVtUM
6373	fee_transfer	2275	2	1	CkpaHrG9fBJsYuAYJLz4VtVc41CM517pNVurdwAQXsjoiAJUmi9vk
6374	fee_transfer	1571	32	1	CkpYggGkGsagP6gdsPbkvQ2RdUbpE2i8Ut7oGjQ8r4ZKYvUE69UEq
6377	fee_transfer	1693	122000000	1	CkpYu1zGepfNqfzzN33ins81WPQKRE8o1oq6qbBKwaNmE5qEYZsqo
6390	fee_transfer	2112	460000000	1	CkpZi8EkAKfpMutTtHJSMZzE1m8mtu8T9ypjjrbpym9eF7rbuxAVx
6392	fee_transfer	2112	36000000	1	CkpZ84rnCT8Ud3ueqtcwdTSD8kS1H1wXtcceRJT22pqiN7ej4F8hp
6395	fee_transfer	1402	238000000	1	CkpZun4E8VTUtA32ySEhTSECTxGoaywQmAQsApJkn4MT49WXFKL75
6396	fee_transfer	1402	29000000	1	CkpYv1oi47ARC2W3iPpfWMtXoe1AMqZ66CZjBPcsTcDpMMrpBwd7e
6404	fee_transfer	1695	296000000	1	Ckpa9Vy7sjPzqD9GxYYBWcCAYubfjokKmwwmvXc3MWQVKe2PYMLfL
6408	fee_transfer	1395	48000000	1	CkpZrUsodsmdNxZSRtFGujpqLWgiddpcdBt4N2rQrnLLwQPF6YyoW
6410	fee_transfer	1476	1021000000	1	CkpZ7HoojRuvnWFf8RiNzmRxmvJddZ4Voa9sDpWn2q4h99f5cgJSy
6411	fee_transfer	1476	5010000	1	Ckpa73Tib2rU2WeENHkwJfVvcn7HBgXvaUhghaNRCC6TxH6y7P8uM
6414	fee_transfer_via_coinbase	1438	99999999	1	CkpZGUTYQipLzZ6RgEFSGodYQFYaK7BbnvtKptWuxXjhSHyGNeyzx
6415	coinbase	1684	720000000000	1	CkpaE48oz3tFaWp37igszWrZk6Ybo4ykedmLeQutyRrE3zsiBnmiE
6420	fee_transfer	1634	197975001	1	CkpaL3bCrwtR5RrhZ8wd4fZsGjake1c1Au7ZRxYuRHJBqXutN2spY
6421	fee_transfer	1634	209999992	1	CkpYyEqcDt8cWHdNBtgDZZEizj19G4qV8f7ZcU6fU3an4vb61qacB
6427	fee_transfer	1671	2000000	1	CkpYTt8VYBFcKNBFUg2ZPkM7TtRFxWsSQXeGMVB1DrJYURSQGDN37
6433	fee_transfer	1756	36000000	1	Ckpa7HJUrrNe54NjNwdazA9LEhndoZaSCGYA455mBaabhLnN9GR2Q
6434	fee_transfer	1714	36000000	1	CkpYw5hy1TccJz32L14neH5eHzQqvWzWp4ohCYLrKd7DihKzWzG9T
6440	fee_transfer	2248	25000000	1	CkpZ23rXgiz82QM97zgWjJ1afd8Twzfiy76hVJ8yLpwmpoanbzBvy
6441	fee_transfer	1670	1170000000	1	CkpZtMbdJ74caivL4upaVL4y4gdyxJdCc6fzaqpQkyayJ1T4jE6M7
6442	fee_transfer	1670	180000000	1	CkpYrU9Qgcd5TyB7E5aVVLZbbfS2ztPsk9uRiF4xt6W9ZRuvpXrj6
6448	fee_transfer	43	49000000	1	CkpYTea5UTe9QBFHRk1hGCB3dhzpT8GqZjRP2dZEqnPUZgLmqx9rk
6449	fee_transfer	1746	42000000	1	Ckpa2Xqmp2ydX5w3UVR9FKVepQuuMMcdkhuJotiS1ytJb4guAyucz
6455	fee_transfer	1613	23000000	1	CkpZ7TFjTd9hF8THsP2AoJRaZnmgiDkaUtwKQNHZ8cSsqH3PQMRSh
6459	fee_transfer	1509	37000000	1	CkpZ1sGp3VDvY3ZsURekCiCTPXxtiM7iMEzYepaEk2KtGueaGFVTd
6461	fee_transfer	1679	122000000	1	CkpZhGKMLZjNzDWZLtDCdznyg9LYmw9uwEzr8gEzrqmEUqCthsPZJ
6469	fee_transfer	1850	38000000	1	CkpZPFF37XPXmzcnTkowQHK6F8X3c3MBeyzw84UVdU8F5jFZ3ZyJv
6473	fee_transfer	1664	10000000	1	CkpZapi8EXS1H1zPzMYLsDCoWJxb37s7iZzkga9ze2UiVsCbRhM8Q
6474	fee_transfer	2052	10000000	1	CkpZY8SBKu8BdnDTBt3eYxxWM4GhgkDM5R4KHbp4wNs8LKHVeGGUp
6475	fee_transfer	1555	8000009	1	CkpZ4roNiERxZgL4kdngjhEtVXvTeEUrcexv6VPbad2rbVD42sa7S
6476	fee_transfer	1527	8999991	1	CkpZgHJeipkdzEnMXqUMen7Pyr2Q7rpnVvHh1ZwYgzQBvgR43WShN
6478	fee_transfer	1555	37000000	1	CkpZWrLst3Yw6cbH9f8V3NMVQ2cqAvFY3xNeeBxpCXq8CRyU2KxKz
6482	fee_transfer	1717	612000000	1	CkpZokefm21sMSui6ovhHM7Sgstk3H7HEEREx9PAKbe17niViPb2i
6484	fee_transfer	1756	1000000000	1	Ckpa2wX6XdKnvJMq6Htwkg1v2uRDcafxLpJRwMmSWQ79zY7ErDLGv
6485	fee_transfer	1756	1460000000	1	CkpYZkXrtXz9ZhbuUbVstsJ4bNkxYzYDqaZK3wpsBjfQjirEZbdTX
6492	fee_transfer	1471	5000000	1	CkpaJ5QjaujPjxiremadesgC3vnNF3iaELcppmaFnjKDFdidGnZBq
6499	fee_transfer	1701	44000000	1	CkpaLDZUjYEwcEkHFcgsd7h7TjJ4rTvYx1PPUsRXgTxG56TSRZwbj
6501	fee_transfer	1764	44000000	1	CkpZrH5E5PLKhDyeQFKf4dk72n1LCGw1nLc8gRkXejK1dcu9oWAZi
6503	fee_transfer	1705	62000000	1	CkpZRWjePEhCDDWZY63yM2a3GXyPqT6JKNo8BaGpPtaEkzAuriATw
6506	fee_transfer	1980	38000000	1	CkpYcKY3HaFnxvXdfKc7tXqjW8MiNe2TmTfdfLGDEkTikHMJukZo1
6517	fee_transfer	369	4000000	1	CkpYVzAzCg6SXyTXVuAU1yREYBtU17VsRiUGX5FegPatKDyn5Vghr
6534	fee_transfer	484	17800000	1	CkpZmHMMQ8pquF2iod6HMr1LhX9nWZb4bwBLQEjUC1SSXLPHtvV8R
6535	fee_transfer	1735	25000000	1	CkpZMTfqTkRNCGDAZ4kEJmyFgwv241qJYSLQqoY6D7RQa7hFXYEQ3
6540	fee_transfer	1536	25000000	1	CkpZyuxUsT1DDc54s4Q4wVxNPMhuGLXegQLbakmtqVBbGT3joYfMn
6544	fee_transfer	111	25000000	1	CkpZN4mNVRtM8xAQdrB6hqQ2yfQUehxZc7iwLPj73y3M3aDzHTjUT
6278	fee_transfer	1685	803000000	1	CkpZDdJzq7ivWyg4nZpW5RXogteSLfYoBvgjx8q7XU4Xf3DAmXHF1
6286	fee_transfer	1724	57000000	1	CkpZQ67qm9gVN1PwucwqdZnyy43t2f9tQEtyqjPEHnV3Fh1zjQhFf
6291	fee_transfer	1687	1860000000	1	CkpZ1ju4XVUfwmc7gTnzYdXRfmD8srPaMBRWzWJaffcVHFivkox2m
6296	fee_transfer	1657	73000000	1	CkpZiCcMnEytHEAtFvZzz5Lgjz9hh6AwHKcqxDz7opDD18RGZudsX
6297	fee_transfer	1657	4000000	1	CkpZMSk4jtMihD5g31uet33cJrht2bZtVqQq299s4WnYNXmaoZYdr
6298	fee_transfer	1695	33000000	1	CkpZ5vwjUunz2WCN4nL4hSAGmqPWwwhEHK3byBFtpQKvQW7Sxg4yR
6299	fee_transfer	1719	92000000	1	Ckpa4UaKZNJM78uErq1uQt5pvyGe5uYWJ48MUsC4EhjHToG9qjQpP
6301	fee_transfer	1680	1042000000	1	Ckpa4T6mfKpWnrQqCYBaWVDf5bmsCHPivZmKPzjrDFX8r6JVDuq9U
6302	coinbase	1680	720000000000	1	CkpYq4rmq6RiFid5wnm9xSgtCUmQUA39KoJYRDKUUJPzHFxgrU5h9
6303	coinbase	1619	720000000000	1	CkpYV6fVnhY46TeWKsux7DeejvQ3kHUv817AhVd45ufyA7aVVfohZ
6304	fee_transfer	1619	12000000	1	CkpZmRrg1RhtBjx8tToGT1TGLsdymbjtofNPWtkj55TM7wcucSgqe
6307	fee_transfer	1698	32000000	1	CkpZU1L5omZtUtcnP6KxsVVtAr1GRcnD7e5EJJynAasSUSQp83oJr
6323	coinbase	547	720000000000	1	CkpYy5FoJfYPPyFPLHxqJZtJSctEQm8Nfd8xCDhnwbkYLV8ueebbU
6324	fee_transfer	547	10000000	1	CkpZVUGVskTNrP4B6RA4h7hAphQ4nb3daezc2hPdDaKCs8NbLNGbL
6334	fee_transfer	2148	29000000	1	CkpZW8R4KCW2bh4ZMVkb4suYzD63nbAHwC28UHPsG1ZxuCkCgsbXp
6335	fee_transfer	1568	50000	1	CkpaGqtoB3pXy9zkKqfc68rwzdwXEhq4Z5trMYZs27BfJDoJ6eBd3
6336	fee_transfer	1395	449577	1	CkpYpxUnx7W4wwckc3YA2L12dD3KXs2NgTfoae5NNfhbUEakgbKQr
6343	fee_transfer	1564	680000000	1	CkpYu4cS2mk9EBM2oPoDFmeVuTZUsCLsKnqK9PEEBhNivM6hvikrP
6344	fee_transfer	1564	630000000	1	CkpZdEq6nDN1VrwfiFM4n5uYYoRmNxjh3cTyPsYwCE4xBnt9VbYT6
6345	fee_transfer	1670	656000000	1	CkpZepo2CCUvW6MEgno1GBPbEY54VcJ5M6E3wfAC4dGkDpaF4QgJt
6346	fee_transfer	1670	18000000	1	CkpZYNtQ9ZDyjJ1vPhU5hdUqcZWUPtR1fBddEmQD6RELYyVdk9Eyv
6351	fee_transfer	1684	14000000	1	CkpaAyy2Gnmro4FWc3MuDK4ie8rsMz3TLMdRbjorVExJCsSLuzNu3
6352	fee_transfer	1444	4000000	1	CkpZUb3RHoYe1kqRtVBGV99fypU3tArchvFZ2iy2VqDrHRW9P8eHA
6353	fee_transfer_via_coinbase	2284	500000	1	CkpZTU7SnT6mqNxRNTJuvaVFHRrCDZ3f49KGBADjH3poBjFNMwAj9
6354	coinbase	1696	720000000000	1	CkpZtVXBc8zj2gbMX2AqBSkSDhoDH3assXEX7NT11Crey9ULUHVbf
6355	fee_transfer	1696	8000004	1	CkpYiBMYYh2zyssWixxRPLvLXSoE6RHi4HgSxwtytc6dszB8NMKsR
6356	fee_transfer	1527	3999996	1	CkpYZKEEYFaKdLg24EsmG8BjSQhZ1sPKne45EtmDmNDkyMicCyXLt
6361	fee_transfer	1680	22000000	1	CkpYWyqbGuyASAN1FEj9vgZGxBWzVUGniv93bkxuthKcu7sQoopLD
6367	fee_transfer	1686	32000000	1	CkpZ2Q3bjbmZeWdFED4Uto57jpqaq7HnS1XAYgn4rXS73YhSYH1Vw
6376	fee_transfer	1679	14000000	1	CkpYTFJfuGg5RBb6k6bWC39Y6DuGH728tqMBvm3jvxNQubcd3v6UM
6380	fee_transfer	360	12000000	1	CkpYWdadr7AkN81ADG9BBZMUWX1hHFXjCCVn4m6dpn6sKQDkHV61C
6385	fee_transfer	1594	9000000	1	CkpZnNmxLS2zHbV63AwQ9jraF4c5nqfG4Ah3BzwGvUpGUFEnx7Yf6
6386	fee_transfer	1564	720000000	1	CkpZ5AS4PdQdzsU5mUsyWDaVZsDU98nwbhYkwxakxrE1ULy19TKS7
6387	fee_transfer	1564	629990100	1	CkpZqKTB1jDhK5LvJrpZfrxjTxni7gT5WcUq2LGxn4hFMhhoogiyn
6393	fee_transfer	1428	12000000	1	CkpYo1ddKfx21zMPGQwHq9HankbARFinPJhhS7DPYdtzuqe1AcsrB
6400	fee_transfer	1701	257000000	1	CkpZP6Sw8wAr3sybZCmA7Bb4zJkN9guVCdKUXSbjHa4QQwUpn1L5z
6405	fee_transfer	1560	175000000	1	CkpZs9jmDZEPoW6hvtoNEk4rCyXFRiMUq92Gnrdm8R5YAYffzXdee
6406	fee_transfer	1633	24000000	1	CkpYmj4dLnfd9jfo1VHBpdewfcTzj2w8ia8XXWvCs4GRFnueycgF7
6422	fee_transfer_via_coinbase	1567	130000000000	1	CkpZjBqpaYqijEDL6ZUwK9UZmq96FQC743SHaC4BFsYJwSrPPnxUA
6423	coinbase	1634	720000000000	1	CkpZPmFi1bLc8CtdqZvHiW4wRMQ1AhzeqaX3MxuA8USmfgWnkbqAy
6426	fee_transfer	1666	12000000	1	CkpZVp1igh6WLkm7yfMpbzvRq8LzPi3SEv1uicBDNzhwXefrBEAkb
6429	fee_transfer	1701	769999992	1	CkpZ17Z7tCrgTWssPQu6DRAudX48djt6BDo9P37wXf8YpSY48KFJ1
6430	fee_transfer	1458	5000000	1	CkpYtjmVDiwRrLYjWiL4vuLPMm42f5puSfGYvi8ZzELCinMVq2ZQG
6436	fee_transfer	1522	740000000	1	CkpZ2QqxPpE93QrceDMenFEo75GVvfrqEbqTcAvK2pQZHgkGpt6nV
6437	fee_transfer	1522	610000000	1	CkpZ4HcqBEeopknyKo399LzzHnwhJ3RjNgmwUmhXnVKifMMHKPVWT
6438	fee_transfer	1619	24000000	1	CkpZ842cAiA6BSnk8Uzh5gUSSyvM54a3EHsHNr52bkH5SJtxtGAoU
6445	coinbase	1850	720000000000	1	CkpZ3RYnSnaNwsAW5MPg4Ji6ESqCUnu7r3F4Jvu5GLNwKXr6iSyHp
6450	coinbase	2292	720000000000	1	CkpZPTbUUHpxmXyHDnq9zQyj7uL8WLFbyCHYBFPSQEAHJufvVdeB4
6451	fee_transfer	2292	42000000	1	Ckpa6qzegx5HtbHV9HDEqaEuQqnvC4e2YGfiB5iExeKjssP8Xo6vk
6457	fee_transfer	1980	25000000	1	CkpZbvXDMJgQRb29soN7fjnmBw5GnBiP4EAzK7sofdZgRn9Bx1aAo
6460	fee_transfer	1705	35000000	1	Ckpa1oJCmrHo6n5XYDLrGJ9eJ3WfyLVMX2sqePmkpRPsTY3XQQaZL
6465	fee_transfer	1432	13000000	1	CkpZYMvaeRbPPefhk1XKyQmwxCy5VV9d2ocq4GwgRz9yXeWUCDMJ4
6468	fee_transfer	641	37000000	1	CkpZPUhdDYpJDYWKLYRXK6CKpSHyQzNh6E2RGvcM3w8dFEXaqFFVC
6470	fee_transfer	1426	38000000	1	CkpYyTaPKveZyTXguxd1JgGyga8KGc64mpuN493qRpdM6NhTgFQcN
6477	fee_transfer	1615	37000000	1	CkpaAdCpCjGcYx6Nn4iUgiMFLpEZweP977gRJQMN9kftKdrSXY3CM
6491	fee_transfer	1599	17000000	1	CkpZcUVGPgaKGt3QtTqh6HyN8k2K1wNLgQbTpywg1yWRGGk8xuUm7
6495	fee_transfer	1619	299000000	1	CkpZNku4pLsPVQCqzRY2m5Myb1UCWYYDpMsyvCwgW31drT78Pj3pq
6496	fee_transfer	1619	22000000	1	CkpYywF742sQaZn87Qr9X56HWHoNTmkKwbvVpU8zsnqtNRs77J73r
6500	fee_transfer	1422	44000000	1	CkpZcWFVPygDEnu1hpJhgpvMxBMQanWVwwLhsK5XG2W8zeVQ2EjnH
6518	fee_transfer	1509	720000000	1	CkpZA4xEMChnsM71anRYHqyHSg1QfC9ELZTi5g5YxktDs9AtCZLC5
6519	fee_transfer	1509	683000000	1	CkpZswX68YHt4AtRNNinAGPjJDXaQZtvwETth3zyd48k5GXwqYL7H
6521	fee_transfer	1467	47000000	1	CkpYxV5WruxAkzuTJd82pioaWReHJEfaxWasQhvuhJVqBt3wtgWxt
6524	fee_transfer	2261	13000000	1	CkpaC14iToeF2PGaWzYSLZTxj81vyoMjXwjtx8vA3VR7PhdsU7DM8
6526	fee_transfer	1706	48000000	1	CkpYeVyjMiGZ3xtYVngJFUp2TfKgT89JpBQGuJkumgbvc5QZhJPju
6527	fee_transfer	1420	34000000	1	CkpZ9SuoSVELwGxWmBpkJ8eTYC26uZjrnuDiTrKK3vMd7uUvdyWCa
6528	fee_transfer	1420	4000000	1	CkpZ3fqpMFS6Lowr5hYH9VUrEA9hKbNQwAkjzfmUCARmnmJNp9x1y
6542	fee_transfer	1700	37000000	1	CkpZ6fhRBB6hXAsUcThYaHgAZwqtHcN48DMdPZHFWweyx1Vh4yddQ
6545	fee_transfer	1588	27000000	1	CkpZKc3MaEZDSqe2nwkVFJBjUkK3xDkiZerXZ79sfSYbv7FVfjwKv
6546	fee_transfer	1764	235000000	1	CkpYp3HCAzi1ZDsKEY6ym4cs1gMHjg5ZUcxKfACTvwzmcXesBrbtu
6561	fee_transfer	1441	12000000	1	CkpaGT3EemhsE83QS2VNM4uZDxzhNiZEdMZVGxd9qYpmMYCcTvi2e
6509	fee_transfer	1506	800000000	1	CkpYcxVrrZBP2ywcSd2Tw9411MRCpGJJMGMvNZydTSZ8kgz9xv6UK
6510	fee_transfer_via_coinbase	2260	10	1	CkpZYasftgrCqZSoozP6gAosnGQYrZJ9KkZct3oMxbTQDVywWy9yK
6511	coinbase	369	720000000000	1	CkpaG8MvrXRg39XJyjMMRC42coCxg4xRj8wUzVpWQqNNyUXkGcJW1
6512	fee_transfer	2260	10	1	CkpZYasftgrCqZSoozP6gAosnGQYrZJ9KkZct3oMxbTQDVywWy9yK
6513	fee_transfer	1501	800000	1	CkpZmoFxstwb6ALzy9NZ3eGQnC7kAFTj8tSyxZhbsBkaxHWH5PvYG
6514	fee_transfer	1604	3100000	1	CkpaEcRMJp129o7d2fjo26JJuVcvQpM2bfJob64YXX8t5SYPqxYQX
6515	fee_transfer	369	99990	1	CkpZi7rArWE5hPss3KSKSX96QSmHMPPBcMmzHfZmkTaifpDXg7nDX
6520	fee_transfer	1571	50000000	1	CkpaJomgx1r2F5NWSTznr4SNrb3aWxVwGsfKxKSg2ePMkmcZRoX7q
6525	fee_transfer	1711	35000000	1	CkpZCbG3R4KhM5soR5q7f8YpAZadeFvZ5Vj7CuqMTX4ea7nHX8xdA
6536	coinbase	1691	720000000000	1	CkpYVXwtcTvSCCjHRP1SWK2kQS16w1Ynqbmq8FVxciK1q9sA4jvJ6
6538	fee_transfer	1611	38000000	1	CkpZzDNoFvAhdT1jcTxfqgpdDqTgfkvhs1N6uvp7hyrwoHAWwE9Vf
6554	fee_transfer	1696	37000000	1	CkpZGp3ieE4naYgNibyfnkLiCDWtLLDHdTZCyMADB8uttuj4k3upG
6555	fee_transfer	1714	70000000	1	CkpZVXKGk3YRoZF4PhomRWADBEofX1zA7DhaZH11dJXPju3EqHw5B
6558	fee_transfer	1601	26000000	1	CkpZKaTuY4fb78kHjRYnGeW3x92TjoL2JonEPSfUvvnr8pQyqqqdE
6571	fee_transfer	1394	73000000	1	CkpZ1vGrt99RH8P5zC2mdHKC3WAhYTBsmTAhgyqG87SPo5WiJkKNt
6574	fee_transfer	1681	72000000	1	CkpZjaLPowoXAofFPyor9iV2k6Er8DjHfEcMHfJKzwBb6e4ctiYv3
6581	fee_transfer	1718	72000000	1	CkpZCQodaTpo26h89oHfjBnFHPyoGbkqvftBZVLr1wTGwv9eSL79H
6582	fee_transfer	641	143000000	1	CkpZZ4RWe3Bd8yZyKwaoej3UL9y9ysuKV1MqVThxm8meM9oCCmJp3
6589	fee_transfer	1394	103000000	1	CkpZy2nMczEwaD5SLF5ujr3MfzN1u52sonWs4oqvv6ScgJe7opiHB
6591	fee_transfer	1685	72000000	1	CkpaE76X195GenKgjnTcgFRyR7z51dNPFS7ENiZnSx6c7Lr5fEKRd
6595	fee_transfer	1656	35000000	1	CkpZDcz3amvx3DiMeb6tgr9ihNCegVesZdg8wiQBwABxieRNsSWXk
6596	fee_transfer	1685	57000000	1	CkpYvihQtuWzCy4RtsUcJEvi1PrPSAahARamehK7QKE3R1igbsLkq
6599	fee_transfer	1670	49000000	1	CkpZbmmYsqbM6h4eBuXeCH7cqMX5H5BfcEvCN1pX63g1Fnt7WEneC
6600	fee_transfer	1444	24000000	1	CkpZQQGA33gKfsf4Fogh6YpyE4A3j1sPff3hVG7u4QVbJQhFV875z
6603	fee_transfer	1395	73000000	1	CkpYi9KR5bQqGBWcdd6SRFm2SDDcuJ3nZoGW3SamSbgUPn3yqDeGr
6605	fee_transfer	1596	107000000	1	CkpZs5gPowncBSzU7BbPebS7NxASeWja1cWNx5W9UbJdr2pgau5p5
6607	fee_transfer	1714	38000000	1	CkpaHXHagMEArzRbdP42CCsQn2JU5QuTNvf4SNSN5DrT4map5YWPG
6612	fee_transfer	1543	612000000	1	Ckpa8eqzrQJECwNUpKHeXWHWmCxzVos68xDWQnLZyREvrrX9poNWh
6615	fee_transfer	1691	43000000	1	CkpZWqn94kwjkK6ZTNJgTtJM1J4M7GzcfmKTwBoJkyrsWstRWqZ1D
6620	fee_transfer	1639	60000000	1	CkpZcBMCC5CZYmGYYpj1yD3B7utSKmyUhGNu4LoDymA2VqFwTaKQK
6628	fee_transfer	1395	16000000	1	CkpYhi3mJ672KchbtYrLnEQV6aWTcuCH2caEFwDrnwzkjEY4g2mZL
6636	fee_transfer	1710	53000000	1	Ckpa8XjLa8yECkc4Kd2osyEd4RazJ3TsQHqeKN69YABjoiubAkDbs
6637	fee_transfer	1458	15000000	1	CkpYZM7jUzU2o5UosFR9tabqPPRtvABSf52SYNZDtwFpGEC2crehH
6639	fee_transfer	1394	45000000	1	CkpZBeSECEg1mna7R3LJY33uLdqBWh9chXFYhS7KWkNh4FQAbZqsc
6641	fee_transfer	1681	15000000	1	CkpZKD398SasxKMKiG3xRC7vG9WBKNN21pqpBaT33Mj61Zm5EsBFy
6643	fee_transfer	606	22000000	1	CkpYb36Zq82kjBVFs8296NYCd5QHrvfL5X8K4cXPVL58hhdBgstmE
6652	fee_transfer	1440	14000000	1	CkpYfQzgeg96zMiVJNvndSj6qAnboafzgwSvUzNBPfZud2WNLtgVc
6654	fee_transfer	1688	75000000	1	CkpZXg3PBVfocCqken5JWXjq48Y8LyKncTQapvd9LUwAC55Bvj5d2
6656	fee_transfer	1685	75000000	1	CkpZuqL32AHF5KLkRiLpg4s4myVDFSHMxAMnjGiiqtR3iUPM7xqXW
6658	fee_transfer	1716	34000000	1	CkpZqYMM6T89RyS61iD44mEFGo9jXwPrQE3Nrf1j8ygsH22LbfjBG
6661	coinbase	413	720000000000	1	CkpYViSQkk6rbfJLxaNr5kGSXj8vkHVWQhmG1k1F1R3KBLHYv2bGe
6662	fee_transfer	413	13000000	1	CkpZ76nosWRPJDvsYyh3ST3J5ZTnZc3payDRB4Xzz7Dwz2JCWmxUD
6663	fee_transfer	2148	1000000	1	CkpZEPEU2q8EyNH6uingHBYNvFpTwNprpdifNoofVhHHyjaC8hKvC
6674	fee_transfer	2248	22000000	1	CkpZ74QA8fLax2dhYfsUnJYWia92SW8JncPpo7FzksuQc9sHc5T9Q
6676	fee_transfer	2039	14000000	1	CkpYojGTHEXdcNV6588tY9rwEwRDykJE8N6ZPL7MEpXY1Wc7cXPfc
6680	fee_transfer	1715	4000000	1	CkpYqhMDU5XgFYvnhbhTvq93G9bsgTS5cuXmv4DTKe1y6GKrPxUzZ
6682	coinbase	1686	720000000000	1	Ckpa388YyboD18p7165jFP8gotq6cjkSoPFA6D31MN5sgshEbKLU4
6683	fee_transfer	1758	1100000	1	CkpZETmMjMUp36jmEMMzvzmMAx6JBACasQVH2vZvuTk5qTdoNBgte
6684	fee_transfer	1686	1900000	1	CkpYicpW1aMHQWpN1CsW5hhMNosDBzazV4eWSet7hQqtExvjiNzzr
6686	fee_transfer	1474	2000000	1	CkpZLALnw7yqVVUSY4ozbachWB4eQPiwFVZDAQDBFWYccMJNH6YMc
6691	fee_transfer	1501	6000000	1	CkpZvdS3GtW3cBN9rp66x7hBNEueQDLXa3nMjgKUhTAhsRb2m9qS2
6692	fee_transfer	2250	2000000	1	CkpZRh3W4pE4E69yhxA6orpQyacp6BsKFEZZBmat18ptS2F44smdg
6693	fee_transfer	1520	9	1	CkpYfnNoEjPSTv6mFizMFvgq7YYUyiia3pEiHditUDKnaW1GNGdPf
6694	fee_transfer	1569	3999991	1	CkpYbWwJaLNe1iR9SqdnSf7cnRsCsUXDUFycdGZ8K27qNq7piXncr
6695	fee_transfer_via_coinbase	1520	1	1	CkpZSBcuX2QnTZ5WpGyk7jHm66gMxZe8kzZ9GJvJpdYLX8Hconco7
6696	coinbase	1569	720000000000	1	CkpZRSFNy97pj5CCWsRsNV4QoHPKtmFkgKDHhVyZtU6zqKotufRVR
6697	fee_transfer	1501	1000000	1	CkpZhpoWivcFRr2LBiDFkfPiF93yR4kGfuHgzVYnmc6XEdZhxstgR
6698	fee_transfer	1520	2	1	CkpZ5qkJCpH63TZ8WkgRtqsK6G5QpNQdn8GxjUoLmEtciWvLyffr8
6699	fee_transfer	1569	8999998	1	CkpZ5A9mPuF3tFzRuqf2ZNMnhjvAi6Anephjz5mfujW5UFxXobC6y
6705	fee_transfer	1560	61000000	1	CkpaA5oZXp65gHfeezkHWvCpnrtjp3EHcKtrHvR9mQAXRQ5PdBeWi
6715	fee_transfer	1566	11000000	1	CkpZAaFm6edhwEALx9QNcx3V4BVZYxUT1ssfbUS8STyCDasELA6Pk
6721	fee_transfer	1467	32000000	1	CkpZ3knzmz5f9QAFBhNiYxHWsaAaoqCFwsAVzQYabD7Rdumaxir79
6725	fee_transfer	2261	26000000	1	CkpaEFEipyedp93Ze2XzzGJfEMnkAvBPT9zwPWpmkTf8MBjb4QxGF
6728	fee_transfer	1422	38000008	1	CkpZYxuD3Qb4hUNLMpDG2kjcMPiabkRWsDwrenCFqbj61JC5wgbb2
6729	fee_transfer	2275	3000000	1	CkpYvahnj6H6vhSq8MZbLD7xvdL16QCsJCuw283qEypHwqi6ba3hq
6730	fee_transfer	1527	7999992	1	CkpZP3zAmNrpSWxd4s9XSWy57eXMnorCGmvVys1UGgh6VdkM58Ugm
6734	fee_transfer	1634	37000000	1	CkpaG7UambvU8x1rBP4TKRptmaZkq61h32qKrBSgoJH7RFLFFwbdL
6738	fee_transfer	1751	2000000	1	CkpYVD5d17R14mhtkcuS48MiPg2JWkpC8gCEYSUSVaxAMUerNumeo
6739	fee_transfer	2306	13000000	1	CkpZbXGLycSf5jU8zRKoGEsFHYmnqNmB8WcyT2WTK8h7P3wuV4oPH
6742	coinbase	367	720000000000	1	Ckpa9NMDtmWqwuxuEfgoejXXDBhbTYi7JHzqWddyVY26X4LpaHtgA
6547	fee_transfer	633	46000000	1	CkpZQzLPokTQ1jNahMPQcp5af36hsiYwh3DAardkdLzVYcdPQTUFz
6548	fee_transfer	1419	36000000	1	CkpYrHmQVjwu9m6yDxLTNXSRTZj8jLJvyRSK3WYfVn3uoAav9RCRq
6550	fee_transfer	1608	120000000	1	CkpZ72du4UEmfozDYxYcjxv49BCaMsp7fHWXFkJgdFbjoa9pKYMsU
6551	fee_transfer	1608	186000000	1	CkpYVg7owHPQTyNhYpQ7HYu3FSDG6dvmCFpEWHJZSTD47uXB7x8DZ
6552	fee_transfer	1680	24000000	1	CkpYuau6jz4Th8XcrPWDXbq53NtdynyK8enu5iQ9pVw4gS7CdKwhe
6553	fee_transfer	1608	98000000	1	CkpYzRgjMD5rpqKKYaUPckSUSYmqcVwNb1WceHyLAjuhvhWpihDKU
6562	fee_transfer	1509	630000000	1	CkpYhPZhgdo2vbGbTy2PgUCizc6Wnf1bLjENWUvMQVF1p85wfJsCF
6563	fee_transfer	1509	539000000	1	CkpYo9FLF9X7B4H4puqZSsQgMNqP5aBZaLcWMeY21KuRR2k474wmg
6566	fee_transfer	1723	72000000	1	CkpYgpqrPsZmFiQmxnewuVGn9Za9JR6xB78SPv83qDhzk9c9jMa2f
6572	fee_transfer	1541	144000000	1	CkpZe9M3RK71gP76gQcq67Khuy8BddreNpSqQQuF3NohAcZFV99Sx
6575	fee_transfer	1670	35000000	1	CkpZjRZQMeDgLs1jwoMGKvthqGomgtMozjXQCoQdQgKaixvpVMCRo
6578	fee_transfer	1439	3000000	1	CkpYekLTQqrMUGvjSB6RKwisPATXrMKWzJeaEGr1vboTbdjqRdwpN
6583	fee_transfer	641	145000000	1	CkpZ2hLfPyyeQG8mef3BYaephWnEnsYkzxo667kmTawYrFEh2xsSm
6585	fee_transfer	576	64000000	1	CkpZtQWZ7KSj7AysE7mzpKYcWnY7EPon8GaJoEVfz4XpbaSkUoR1y
6588	fee_transfer	1395	72000000	1	CkpZ8onqMV6jTxk7TWCrhH4dq3yz9TdKQHuwamz9ckBUjVqcfXVpV
6590	fee_transfer	1637	103000000	1	CkpaCBjPYHQ66YssRWM5s4DxDqmfeywzRmAZdBG1xzfx63DL37g6F
6592	fee_transfer	1394	27000000	1	CkpZVMsfpaWzGQNQuC4ckYLmSVXzwLtLEtBbtuTACTkNbmC3vsxrD
6593	fee_transfer	1703	27000000	1	Ckpa2DSY5rT49nyEvR6sgMoWsgzSVveBW8cxPwtDhkJDDSgyKzfpf
6597	fee_transfer	1759	57000000	1	CkpYanpakDV7SXmWvVBxggx3FZuCDF6xEpKCnzUWtM2jUMYNciJtY
6601	coinbase	1669	720000000000	1	CkpYUshAYiZjfHMeqxjm8Gw7a6X2dPyZrMgV4knVP6BTLZJ3JQauL
6602	fee_transfer	1669	12000000	1	CkpZzYWj9pRYnJPwEzuiJLM8GDXwZmx63hcNGdkeRFN3Y6LvyZn5A
6604	fee_transfer	1555	73000000	1	CkpZv3WmJn4VEgfvq4yQTL9ffYvLFQHrc3TNkFM4HwvgHYeXM9EXF
6609	fee_transfer	1601	580000000	1	CkpZV8wW6zSD4Vq9mbBTUjiczhu22PSh1fwfPmdweCK1XzUkcAvpT
6610	fee_transfer	1601	760000000	1	CkpZb7yE18ZRc7ukhNVJaLVG3yVnP1w5BM4mkUQryF8HW9yJ7S7zB
6616	fee_transfer	1451	203000000	1	CkpZveBEh17DanP8nLmkZVUEHeDZ8C4fzdJPqnquqML5VRNvq5xp5
6617	fee_transfer	1451	1999728	1	CkpaFegdEg58mTN9rLRLUg35C2z2bKS2i4jQpuUuWemL8kF7PyTjd
6618	fee_transfer	1571	272	1	CkpZLdWQtYt6gYHrA78izBcSFHEHb4nKQRMWbAY2tCbPuzBKwAXYs
6619	fee_transfer	470	32000000	1	CkpYivYKe2CDu9geu3Hk5xas7aEBoCg5GWsEBoiY4zdfCCCuHWWpD
6621	fee_transfer	1639	56000000	1	CkpYc1BNcTwZhaK7BxH8WngqJRfRJBotECAxw6roQNuFKbg3qwLpP
6622	fee_transfer	1613	15000000	1	CkpYUjd421rZux9wZU3PgxXCa1s9f77kn7BkkyH1TvSLjrf4unpvv
6624	fee_transfer	1706	34000000	1	CkpZbLu2cxZKPF1koPzjiByqxZXAnKbCLQoT72t1swiQ7GfnzDgQ9
6626	fee_transfer	1850	15000000	1	CkpYe8S2dKLeigr8hwFuydnFeq6mxDmTqQiunS9EMqmuBZR9qYqch
6627	fee_transfer	1991	15000000	1	CkpYp3FDKtndShxnxcnRfabMYnNjY2JRF2tFqFK8pPfbzYfYRvm9k
6629	fee_transfer	1685	16000000	1	CkpYYxK2otNouSS2Au23WSGDdbaMcERrFmNhMCiVDFDGngCJ6A8sY
6635	fee_transfer	1587	25000000	1	CkpZwYj821Cr3M52SQ3BxyDe1E9TFzTZH2SD9DhxM4tcMAtDfxE5r
6645	coinbase	1551	720000000000	1	CkpZBBdsQqNkpeqRo8CSiT7WwJXTPBGG1ADNa2c4qrR4bcwcNVciA
6646	fee_transfer	1551	12000000	1	CkpZ5Kbs943FaypYZfCdwDjaFezzRHiEKxFpEjffSBUPhaG2u3y2T
6647	fee_transfer	1513	50000000	1	CkpYoku1CQTTJEeZasNnGsiTr2HGQrVJeZCswQJ2wS6JgYF1Xsx1Z
6648	fee_transfer	633	810000000	1	CkpZasV4tQTuD152riBpdcX6qVwy1gmnuqtUrZvm3Eef8tgCA2omQ
6649	fee_transfer	633	390000000	1	CkpaGYJeoHEX3GWUKRa9kXowxQ8KjkmJRALhXPgEizFBEDs61QvD2
6653	fee_transfer	1740	14000000	1	CkpZVufVWRgrj6nXCKmJuhaB4yrNvWfki97Z9T8v236c9xUiHUY4P
6655	fee_transfer	1394	75000000	1	CkpZwr48MHzhT9C2QzAMiSAXCxMjy2EmDWJct5KHXyXog5pp6aZ3F
6659	fee_transfer	1675	3000000	1	CkpZyNXHHtkWgyGxAuntohHT741KvuvgvNSTKBG1HBNS3LMbkq6Y1
6660	fee_transfer	1394	19000000	1	CkpZJTnXrmFNt6BcpYZfJub7oNnATdaeBYbQcnH6Gfjocsaa5gV6X
6664	coinbase	2299	720000000000	1	CkpYccx93UNxUQWV3ZUEwCdHcVtUjELnNrogWH49DaBj1hNeDn2Ma
6665	fee_transfer	2299	12000000	1	CkpaDCAqvCTt4PUM5QG5QBDw7PZF7G11vstXV3xVhaH4AntLX54mw
6667	fee_transfer	1546	9800000	1	CkpaKpbaoi1uUHZwpZBRkMJbtDWgeNXnANfmktpXwmCUYvkFW7wjG
6668	fee_transfer	2250	1000000	1	CkpZnr8N5cDR8w9QgAgtP2DmyENa6PzurQv79AA9XAvhZABDi3yej
6669	fee_transfer	1758	1200000	1	Ckpa1pC3u9HyKB485kMm4JWuEhbH8ojGwM8tTqKpq657sfUTH9Qty
6681	fee_transfer	1768	173000000	1	CkpZg2TjG432SdT4N8jafuGMfnRCJb4b8D7xYLjDo4mZZPqRrgLbw
6688	fee_transfer	1593	101000000	1	CkpZmPuQT56Jjd5awNAJv2Vf4uVexKmervafiCpenonepqLg54nsa
6702	fee_transfer	1675	340000000	1	Ckpa2kQwDqkcTsaLhovGi9zKyyMbypXuLPNiQUmJCT3G36EQuhKY8
6704	fee_transfer	2112	6000000	1	CkpZe64A6ucuRR5PLRzBYZnkVYXTUMT8QXKTXTdJjD64uH1yapkHZ
6719	fee_transfer	2112	46000000	1	CkpZWjFzM6hZGeisNRNkkjR53MgiF9J7rmJxveLPbxEhfJ6v9c8Wv
6720	fee_transfer	1439	33000000	1	CkpZtTv4gQRGLZyUw6vvfsYv9xs2CkEro1nMj8U7fhLUHEBjUmE9Q
6723	coinbase	2306	720000000000	1	CkpZe5rkSjaw4v5MpzGXvDxkcCbUomUVzUAjH4y9dMw28kgtGVvPm
6724	fee_transfer	2306	12000000	1	CkpZxznhPbe8GSbNj9nep7jFDhHNNVyFcTRF3dUwpbRQvGkqrK3hs
6726	fee_transfer	96	26000000	1	CkpYqwKzKhCDisZdoYQx2kA4qfsdzuTHAwPNgggdsHLq6EHj2bjoa
6731	fee_transfer	1422	49000000	1	CkpZA3bH4gv8q9npkYq8MfZaYhbU5wRRxAXJ2unVYwcapJ3aqiTfr
6740	fee_transfer	1623	270000000	1	CkpZzasErXSoG31u5JYP73cVqbouZvps5vPHQZQqbLtmnaSZjEhPS
6745	fee_transfer	1602	14000000	1	CkpZnuVZ9D63Ega3jB66VCd3zKXRegVUmm4o6cVGVSKerZ2eiQn7m
6747	fee_transfer	1758	11200000	1	CkpZiHDudtUmcrZxA8j2ofVYuGR4D6WeDkPtGJeb4GU3cRATf3GRS
6748	fee_transfer	1686	118799996	1	CkpZPHv8BqjmJnbi91nL6vMujsEChEpU8HAAVfPwDWr8aWZhMRqqq
6749	fee_transfer	1686	1899998	1	Ckpa9ZRmzKGpcLXAMbDgsfGNigQgpLznfahLFtvymRB2F7CPsZyCK
6772	fee_transfer	2275	8	1	CkpaEyPAEgnQQ6NbFGX7Hk8dUDhTNq4QHW5v8fw9oWXWCYDsas5iv
6773	fee_transfer	1684	11999664	1	CkpZrTdHcQ1nvMMHsYGMXqT5NWpUmkLk4DSS8uXyExpnyQk1iEin6
6774	fee_transfer	1571	328	1	Ckpa8Hxo6G458PEjWxgSSQgJEGzj8qCWxGorMDwfYjzARSi2DegQg
6778	fee_transfer	1680	880000000	1	CkpYnxveqnLMequhhJPxZmi1DuU3oBiS1gSRM2j9xAHU4Jq6F1iLC
6779	fee_transfer	1680	370000000	1	CkpZbv8kgTqAVmTxxW6xFZCGmxFgz958znGom7NmANSp1dn7mypWD
6787	fee_transfer_via_coinbase	2275	1000000	1	CkpYfBZYbBZPsX5716xXMfS7YWy7K77qV74kwY3Nz7ANRK32nfZVt
6549	fee_transfer	1425	24000000	1	CkpZC8fYqwFTKwrK35CSm5qh6U6wF1C82uz8QoULqqMq6zSD6EnPx
6556	fee_transfer	1850	23000000	1	CkpYknj5UBhvfqeMZpEcDRx3amkJuXiWjxCQndN92QvXHsEUUKArP
6557	fee_transfer	2112	894000000	1	CkpYwmXHYPJY6JUeDKxMjKqYWXPVeubCCxYoXCN5QyJZN4DmFwcRL
6559	fee_transfer	1601	200000000	1	CkpZZmpoSaM4UUo4Mh9s6LMy81MBHMhHhvgdpLT4r33LN5wEqx3Uj
6560	fee_transfer	1601	157000000	1	CkpYx5bibcCvSD5kkhyZEKJMqhz9koaTiAjTxbr2C27grgrLkbXBV
6564	fee_transfer	1547	71000000	1	CkpYpDfhEv64xDXYg7MRvJNd6TRHe5SWSMQHRET9j959ZjwuWfNck
6567	fee_transfer	1513	120000000	1	CkpZN1CDdBWxV8bhQHS5DN6gRy2mRoUT6BPLBd9KfBN1LuhTHjesw
6568	fee_transfer_via_coinbase	2296	1000000000	1	CkpZVQy1uBzmz9hVk4hGySrPAZUxp7hRKfaAA9w1c67RNavDy9gqJ
6569	coinbase	1688	720000000000	1	CkpYje4Ks166vnaBCtfRb7vDTQ1CqigdcoZywRg9dCAGVPoWrNkyB
6570	fee_transfer	1688	72000000	1	CkpYpzWXUwsG5Jfotuuh9Qg3JH1KbaALnJ6ut5ySNvi62AacT7WAQ
6573	fee_transfer	1718	144000000	1	CkpYuXkD7ZsuLnaMhDmPEN949oe3brd2BxuMHuhjnFohRcd5Mz3e2
6576	fee_transfer	1991	35000000	1	CkpYzvMfJEE7QEpTqU7Mr12tHh461vGUsHbmLJ83HqVfApzq8AtNH
6587	fee_transfer	1657	51000000	1	CkpaKx4ZbPVwEX83defjNm3EFPbAt6nZK799a5kGcEY8Fzq752CHw
6598	fee_transfer	1710	14000000	1	CkpYgcTWPJBM9XoKrFva73GNPHtKyWKMFJsJSGkpMcUFp4x9PiHhd
6606	fee_transfer	1444	38000000	1	CkpYW9sxL8CKmHtn3CrcY2p74hSJti5BYRUYwSz6TSCcgeUNie8RV
6611	fee_transfer	1395	312000000	1	CkpaGXQXCYGewSomSYncMJMYzBTNBtGv53bDJk63museYwuYq7avr
6613	fee_transfer	1619	612000000	1	CkpZCT1d5scPkZV8oFcGn7xTSnXLnnc6YYQKau2mj47WNhrunyYAd
6625	fee_transfer	1706	37000000	1	CkpYuypupyyg6ZawYn6CPYmuMQszyZh1bEB9wD4FrJJHv9E8KZwvx
6630	fee_transfer	1624	2000000	1	CkpZZQnwDUBwG4Rm6UPfY48SxEnyJ1kp3kWCVs7EsX638bkK8q2Zt
6631	fee_transfer	1656	23000000	1	CkpZA3WrghQhWsJs6QSk6dANpMrXA4cxdU4mzuCRXkpTPhEHypqNS
6634	fee_transfer	1422	36000000	1	CkpZtGXQ972T2X3pRMWbz3hFhByvVcfQHD1mhx3WjEkLd5BSr19sX
6640	fee_transfer	405	13000000	1	Ckpa2aVhGsuU5JrTy1KKUpZ38rmcy1fR2nFNVQbx9C4G7kuGZw3tj
6642	fee_transfer	1521	34000000	1	CkpZG94igESxdibx385NGcP1zN17giSh99wf9war5QvoLF8DV7TR2
6650	fee_transfer	1758	700000	1	Ckpa84XQcNzsKh5hcfDtPAHzy9YXHsDfUYwGp1e53xLhw9NKajD86
6651	fee_transfer	1637	1299997	1	CkpaAXJpLdKbxw8CMGf7C1md4LmdcYo99qKf3Wmy1imJZckgzXmvq
6673	fee_transfer	1716	23000000	1	CkpYug8oRCQkzigiTBR1mSSEpxXfrDs7oTVrit3BASEA7QK3qUo2c
6675	fee_transfer	1506	14000000	1	CkpYjV3kGdx39jLPRXMTHgRukK56KgGqtxx5grvU9s36RwFymT43z
6677	fee_transfer	484	14000000	1	CkpZDUir6PM3QGxvw3YVyFQHZUUGNnAeWbKEd5brtkSz2Lvsyccgt
6678	coinbase	1818	720000000000	1	CkpZmGdHKnUPRR1mQoWyChKMDsqT9MLWsWnzbukRuwT6T2JGEjEHB
6679	fee_transfer	1818	13000000	1	CkpZuEEjp5ys8wD56wiKvHrUJ4F8dipSezujq6hvq9RQcFrQrHhUm
6685	fee_transfer	1419	42000000	1	CkpZD9MacGyC8dcm1byHSqKy9Jr4J47tDm7RP7WFLn3Ep5qFC8b5D
6687	fee_transfer	1271	13000000	1	CkpZ1bSJXqCT5K6n7oxR6YFvSCHjdFCePcajxm1Jhi9j7jJWSkBDA
6689	fee_transfer	1569	47000000	1	CkpYvbEw1KNarkapgwrnvqNPXZv9KkvKX5tNKmqsp3DTkefMMtTRp
6706	fee_transfer	1508	480000000	1	CkpZVymEP7cpBdbSUEH6DAV6DdAMkFeURx2gMhwTq4wqjboyzcQNG
6707	fee_transfer	1508	770000000	1	CkpZ8MxxeLturUq6Gvk1ZRhWEVx21DzDtEiCJK2b8uS3deH6Cen29
6709	fee_transfer	1593	140000000	1	CkpYvofwRPfCq3VpGoePmfQ8A8t7k31Fe9ziiEdgSMe6eLjBte6Mp
6710	fee_transfer	1593	38000000	1	CkpaBTHY2wecWHkuoHwwVQDBRj5J595qgUeoz2aKqpNXzivBAPZyk
6711	fee_transfer	1675	112000000	1	CkpZnDXT66mzXfr6GEwqPDQVq9CgiYkdSxxfFKMCCoy8H1nzWZDvc
6712	fee_transfer	1675	17000000	1	CkpZpSp4U1JmungXdxGNMPtdC68uf5qZSEMRsez8Xz9iaBEKSKFFV
6713	fee_transfer	2112	2000000	1	CkpZhESAtRQaNPUxkL2CEj1kLkYgycjbyMTuACnsWKL5ZMU1S4iNL
6716	fee_transfer	1706	1002000000	1	CkpaHio3pBQ9s2rJcuyFzvbvrEcKeeRqDjrJtZ9PFFTGz7nPrjJfX
6717	fee_transfer	1706	18000000	1	CkpZRj2MRu2ZSoY2xd6vB61Ju9xfC2obY96Bu3z1uWcAyJXsB1eL6
6718	fee_transfer	1650	34000000	1	CkpZvHEjWv4fSSv5nQr8UuwxFQAxYPh6ArugVSTWRwu1c18xfj5au
6722	fee_transfer	1673	31000000	1	CkpZZspk8uhkvAJMcQGEGpJpkBVosJbcgLh22oQMY2r32KEzU79wS
6732	fee_transfer	1593	499000000	1	CkpYx7H93hf7ZdwfA5PZr5xDtYg4W7MQeY4GWoH6xR6PUGAPhpPQh
6736	fee_transfer	1780	12000000	1	CkpYq5KubF9fPAGVszRdxdXxaqgQHWGB4ViChRQ92o9mEcVDZwRS1
6741	fee_transfer	1637	62000000	1	CkpZWot8eaiQPuzjZDQxNuuzdSmdjDqR6cAc5NuPbuGEr3buyLWNh
6744	fee_transfer	1764	37000000	1	CkpZGLzzoGo9QAor6tHHtDdtt5EwYEMYSxb7PqhPAGMaB25sJbqVo
6746	fee_transfer	1686	14000000	1	CkpYrBnvUQoeTp1CYMMsuPEvPkkG9eqm2TyPdyHffkQEin7kutw2D
6750	fee_transfer	1759	14000000	1	CkpYWnBviHhZsEKzyq1RTAyr8Qtn7qhds1sCpjETCF8Z7zgRufyCC
6751	fee_transfer_via_coinbase	2252	100000	1	CkpYbMT4Cx6D28XW8JZppzKKWKKqATbefc1aVGX2nDtfgCJBVpZ9o
6752	coinbase	1684	720000000000	1	CkpaGHYz8CQFcLMFte5VopVJMm7bsrgQMMLyg3n36AJ4EeDsp2tfW
6753	fee_transfer	2252	300000	1	CkpZyBuCax4SeSCuRzatBiT9RMThGEF5ckp2yhHFiHrGu2MP56T2x
6754	fee_transfer	1684	1700000	1	CkpYe81GKvkCQNG65V1vtnXHphFHkPwgaifY7MPJXFNRBSjbTawUP
6756	fee_transfer	1444	274000000	1	CkpYQufr2egPrtHtnhmWXd2wqzRu5jPdWhaVeeDAxfWKJ1Rd2VQZB
6757	fee_transfer	1637	27000000	1	CkpaJrvaN9vKkyoD9wgptFFaKVNPnm5LnFaVoP5U5KennJpwQP6DU
6763	fee_transfer	2306	11000000	1	CkpYUBELmiZERyeACDwPqZaoo8HVn32GCaWbUNfEwwpCZZ2Tm5iNG
6767	fee_transfer	1520	11000000	1	CkpYzqujprFbb7ByTMytU68vYQdKvZShEqGfTnQHjLLdhyu11Bzat
6770	fee_transfer	1518	557000000	1	CkpYmfN9idu3tN9MJpMxrJaFRU9ARfwRXjnzL5AgWQ8Up2fd6uWwd
6771	fee_transfer	1518	27000000	1	CkpZtunqmTWfeNTXgrHpYUvAeGEFTyG68MymnMpNwN4ZdnUi6Fi22
6775	fee_transfer	1684	17000000	1	CkpZDuCVYvZpjaErvVzTJNH91rBE1DyZsDSJ3wVxHbeknfkfSBReP
6780	fee_transfer	1679	16000000	1	CkpYZAfJZAAc1sbLLvJ431P1LNynwmJ48JkzNxgPmGsXjpJmdJGVv
6785	fee_transfer	576	302000000	1	CkpZfQ37zsnxXaBczmZ5CC5yJ2dZBHArjv4rfnfsYwALpAYekYzRk
6786	fee_transfer	576	35000000	1	Ckpa5eg1q8G1WM1aaZGHA26zG1bP15Cj5aA3KbeDukSJZJAinkcJ5
6790	fee_transfer	58	122000000	1	CkpYtUzzbKtPS7CKeLxyUdtNYFXvDc5rmwZrwrCpFQkQ7r3WRVmJC
6795	fee_transfer	2266	30	1	CkpZmvVLTGAf1KcSSEAVio3mLG7qkE4RoD939SKKW8bxurrKXJReE
6796	fee_transfer	1656	10999232	1	CkpYh58ho8xXrmKaGFfSjRA6VyNtov4Soq2yVtRT7KRZ2ixF1qaTM
6797	fee_transfer	1571	736	1	CkpYbnQ72qsVSniAWc4xxTPyCjY4NDxdeYQ1Mhsmcg5iQn5xyRcKf
6807	fee_transfer	1680	970000000	1	CkpZ33RUto6yNQXA7Gutb7MDTKJc2pKLEL5TTQb5t6EPcQZuXkaat
6814	fee_transfer	2100	32000000	1	CkpYuQSTsR6F5vY9XdnV3jWN24pGamu6N9uqB5S2kC8tBaU5vj3Ht
6565	fee_transfer	1547	72000000	1	CkpZqSQzRXZzf9hvUyerB4uQ7Bwy5jwHEUDNnm5BpGHChjvKPKR8d
6577	fee_transfer	1684	35000000	1	Ckpa1uNTBFHuLzPUKkGbhPWd7egCenPX3pkm1Mr4mVZ6rsjKtnVN5
6579	fee_transfer	1395	217000000	1	CkpZLXL2c8qS3BFzUoGACau9hXS3dXUDyuLjUq5orcM1Q1Xw4Ht2o
6580	fee_transfer	1541	72000000	1	CkpZzgasZh1WLD4K8jQyiLXZYE3A724QBtruoRxCBb5LckRU8YKyg
6584	coinbase	1688	720000000000	1	CkpYoFmhzQQbzzLmYzm3pS4wxUxRY9JRaxfF4FR558LrbUbHbhqDZ
6586	fee_transfer	1555	137000000	1	Ckpa5xnTpfgyMctAa4c136Vdr16gm1FCyvGW5vDjwbUCuArQ8uBXX
6594	fee_transfer	1679	85000000	1	Ckpa4rN2FGULiEcEhf1atp9YnWobxXoFkgw3hwf5s9jzZr2ny5HoZ
6608	fee_transfer	1601	112000000	1	CkpZvjpESJ8xDVTQ7ofVBPG9K8Mf4CgsvJtisgB3WpqZC66jxPdRd
6614	fee_transfer	1693	612000000	1	CkpYVWsrM8Wtzhw5m7ca2eYfDVdAWebudGEq8juQ7EqioWtENFpht
6623	fee_transfer	1394	15000000	1	Ckpa63uzh8YXo3xL9kg16tYHC2SAq3e8UWZZpaBd73K5HeqFdTwVn
6632	fee_transfer	55	25000000	1	CkpYoor4d9BrcftYazHi6p79GxHrtTALqjBWBkGJ5WfNBkXgA5v2n
6633	fee_transfer	1649	37000000	1	CkpYucPgmeKoyw8UMkadzUqmFZpdTZH1DcqqK2BozX9rmRVudQ4PU
6638	fee_transfer	1685	15000000	1	CkpYhhoNhaFtwj1243finPQg9zbxTvsKtMb5kU4WKWG3vxB8GKtYn
6644	fee_transfer	1623	22000000	1	CkpZbvUXjpu4yKPCWZr5YopFee6ziuph4WNU7aENJgK84dspJ7NyC
6657	fee_transfer	2248	34000000	1	CkpZmXFEKZzZG6vgZKPjBRunT3vDz4ZGyeh55sPz99Zia52qn9bZE
6666	fee_transfer	526	37000000	1	CkpYt8vb1d1EmHkPNkPP6CKceVJqdRiE7oQnEg6KBv7DCnVjhRfgd
6670	fee_transfer	1546	9599990	1	CkpZzfa4jDQ1AXgicAyPobkm4f9TsLuitUgqk8QQAExNMcyN3wXtB
6671	fee_transfer	1758	2400000	1	CkpZkMigwDmWwafEgU5vfqfU84Fg1meWbcgToNb7fKVVYzwDogjFj
6672	fee_transfer	1768	22000000	1	Ckpa48LSF669iWZxgJQs5EZ9WwGbADf68H5yahiva92FNSsAkQFUw
6690	fee_transfer	1569	216000000	1	CkpYQDFNXiWpek26hf5nDv6b6VMEuDzqM7HBrJXopL4XvwGaPe1yx
6700	fee_transfer	1520	11	1	CkpZQhePChJZDNzSbcLsrzeLNqYR7Xy5xAQzTcuE8dFx2fhCbEkAp
6701	fee_transfer	1569	3999989	1	CkpaC9xxSS6JevyBBJ1GUiV4Ngmif55PEwhHLWkye7wwaYoQzDYqd
6703	fee_transfer	2112	26000000	1	CkpZd8c1p1Bq9K87uRusksHVJW3Y678NJzdM9p9swk8rKpmGfqVc2
6708	fee_transfer	1690	26000000	1	CkpZWAmstQYwNg75qEEHyuaBqoiK93RhoUEg4fSd9ktFc35ECE2GC
6714	coinbase	1559	720000000000	1	CkpYjnzeryAMi9wgRCZLfiC87XDyNYms129efYZ3ZyEpYhmEHfQ3G
6727	fee_transfer	2261	25000000	1	CkpYSBPd1jsXd7CafP8yguGf3Gye4Z7wXA8VMauaD3foDQd1eBt3z
6733	fee_transfer	1701	37000000	1	CkpZA6oYdaZkf8vr7yj61cTfrcMLdksjCXrS6iQzUjEqR3Dg7bQvm
6735	fee_transfer	329	37000000	1	CkpZjWfdhKLzAf6xvhw3NpLvjZ997LnT8CuLDnt1cWGLTMtzmY52V
6737	fee_transfer	1522	41000000	1	CkpZSmKaAU7pRKBaqsjem4iqndJC7tG3QxtwGaxL894eLQiqtEMoP
6755	fee_transfer	1684	5000000	1	CkpZ73QsXuVaydhoNx139sKzkD5VNH7Q8bF1YKp5T1YoaQ1Q3hPyK
6758	fee_transfer	2261	27000000	1	CkpYsRd2ycrUrkcHHcRYVVZXNkViw1RY6oAg4FArcSjhYxR9hTxkT
6759	fee_transfer	633	323000000	1	Ckpa9rgUKAod56MLNydU8YjDxnczS4PgHASHx2rqYpcoH9yuj8mK2
6760	fee_transfer	1444	157000000	1	CkpZhD3DG5UTSjpQVXoYq5GQPR3Db7MzvWJny6QcCjYwTP2dxUzji
6761	fee_transfer	1444	16000000	1	CkpZ1FXeH5b5nvneG8RbRSWCsnvRLR58f9g4sLRkvnFCqAbj2erzZ
6764	fee_transfer	1513	23000000	1	CkpZzxx1NZnUXE92UWf7ZRDGWTpd6M5uUbh6VKL1ZWtBbn9s4m8pi
6765	coinbase	2307	720000000000	1	Ckpa2MA5ym8gyktrVJwhmqzfQDQBMG82pPuoFkCV9Ew7vNLh2NCuu
6766	fee_transfer	2307	22000000	1	CkpZ7vUCnZVADxkvXVKtCQwh5jDSZni6L9byS68L7n3GvmqpbqA7p
6776	fee_transfer	1394	17000000	1	CkpZ69PYjFmiF4tArBGaMWfCDQWgGGRRQzYMcVxjPUB9CyPT4oUJ9
6784	fee_transfer	576	21000000	1	CkpaKkgm7uHmyh1HXvh2Zo17QirANv7XEUgu1Y8dsKy1YZZAppXZr
6789	fee_transfer	1547	122000000	1	CkpZ274yYJvoG46SnXQG9catpxodCiiK1DjMTbMaviC1LaoyJ7RWe
6804	fee_transfer	1716	33000000	1	Ckpa5Db6iPCvdGVnJ8RdBgS8T6FujQemmwVqjnPdrUEoHkrtfhKuJ
6806	fee_transfer	1672	22000000	1	CkpZR1nP6DTx39hrUBJHyeLmFg6mK5hbUnZqA5VQiyQo2eeFQ9nu3
6808	fee_transfer	576	675000000	1	CkpZvMzMh5BdrWQ2Bd5RbzewAxZUXcFcnRGmbiu1Jo2f8PdVZxEh8
6809	fee_transfer	576	19000000	1	CkpYna65HhMtyRy4L6q8tZk3BVRapuNUcPkcuXAXshbsCyHzYmZST
6815	fee_transfer	1680	26970105	1	CkpZS78j3gEA4gC3PZ9ktJkMoBhmDiCApe9HgqNeUxwALLZicNzzH
6816	fee_transfer	1520	100	1	CkpZ3Nh2YCyJL9MjhtQZLj6G1hT9BgfZruVZz8sq73AahUWkUbMc1
6819	fee_transfer_via_coinbase	2223	100000	1	CkpYzxXniv8jPTEuv8ddE5q1pg8PB3dUsRzvGeG3apas2nwWywmva
6820	coinbase	1271	720000000000	1	CkpaHKxp7t9J1KfhX26VFfkGLoNca2JWjKartam4kbKXV5BLU2fzk
6821	fee_transfer	2275	900000	1	CkpZgJenJQE6XmuKzssjio22FZXJPnFSysaZ5FfFYCPVKSnMnCj7L
6822	fee_transfer	2223	300000	1	CkpZhRFx1R3ai2wTKQgSEZb99VZZTyPwTEAZy6oMYNVzyT8XbonWA
6823	fee_transfer	1271	6800002	1	Ckpa32X7ZC35nXgZgtmF48UZ2xvMQLwMF6CBikQ6LFfqKsTh5zLCB
6824	fee_transfer	1547	22000000	1	CkpYQHKrr7FMGGsL582Jf9bZyJPAyE24tus1WooVb3gWe4MU6qHWX
6826	fee_transfer	75	66000000	1	CkpYQ2jh78hXkc8CvpEaGpsNrjbmwHyk6R5g8aGs2Cexc1nUcgGTG
6827	fee_transfer	1599	22000000	1	CkpZNA9ci1ubEWYG7g5xaTvYbJFvxTUWbMPNLXfmmLtaEwXUBsAeA
6836	coinbase	1587	720000000000	1	CkpYZSqjLe696TW8kS6N6LvVJbc3AxvnKyghZ6oa4GXkYNam4oV4p
6838	fee_transfer	2248	11000000	1	CkpYcMdSD8WLEJWERudmuy8fMCoaNDfwbBaptacP28uk7rhQnTVoN
6842	fee_transfer	1693	79999000	1	CkpZtTXJuzWx6Dub3wPZwP2vrAxzA43njzKxNmzbNpwDEd4f4owSp
6843	fee_transfer	2076	1000	1	CkpZmheLb8e2KHseeDFYaNEoT8apvsf4FkED8dcoYEhpr1ti6xpno
6845	fee_transfer	1444	629990099	1	CkpZe7yPEbqtpDvmABwPzhjAYpjqNq9znEshNbtydaXPxdsQiesw5
6846	fee_transfer	1444	3000001	1	CkpYbT3AEE6ZKf55HeqJQFrruav7rjAaBjGKk79TNgyU2nKgRt2xK
6847	fee_transfer	2292	12000000	1	Ckpa1DAWgUfubAL3ppj6xMhoNDHymUNGhDXLwrJmuxZt98EhAVkt8
6853	fee_transfer	1634	25000000	1	CkpYbe2wyAhCy5r6f1Njyzhvz1WPWVP9r9VAQdpxSxuiyx7LwQALj
6859	fee_transfer	1749	87000000	1	CkpZznevKzEGTyBsKJQ7vcay2nnitaTxePv1qPa2Z53EiaEZPdbBt
6861	fee_transfer	2307	25000000	1	CkpZr7KjoaXfpdQKbeXs7D9Nmo8VGBEfoDURvKiCPEoEi2DudHp1t
6743	fee_transfer	367	12000000	1	CkpZ92r35annJKdwRKQxcYwfrA73FLBgXbDu9hPEQE25awWLHtm4N
6762	fee_transfer	1649	34000000	1	CkpYYhp6pHG3KKe6Dc8sFubQK5P5cfHeKEgw5opknZ19TL7EUhFP7
6768	fee_transfer	1588	670000000	1	CkpZterARNQtkGhNqTxkPd2SZDE2Wi3hJpMJhCadc94e2RqCQg2Lu
6769	fee_transfer	1588	580000000	1	CkpZp2bKm1aeXLTJjbgR4W1foPEPYgUkX22KhWJXX2LmYPNQqX1Wn
6777	fee_transfer	1680	17000000	1	CkpZfTsSVzrZXccyKY8DrvchXvqkuTGefEtch2E121tmBXSG2EGy8
6781	fee_transfer	1734	100000000	1	CkpYToF8NVhw346CyxbRnUenwBiiKmvA5aYz7HeyPGjtiLGsBUqVa
6782	fee_transfer	1623	227000000	1	CkpYr7agfD2u1HK4e19HCbqhhr8eCCxQf56Esth4jpDnXb3YPw3mr
6783	fee_transfer	1749	14000000	1	CkpYX82bpWTEMrstAJpzF4xud2SsDMpfX7AgMF4pFCoawquQMSa3F
6794	fee_transfer	1489	22000000	1	CkpZopeX3UrNwrvGZNcpCELco8NmHmeFtEUHgaVc9jn97djKCEYmN
6798	fee_transfer	1611	115000000	1	CkpZBGF1SHtWyv7SFDnCtkssmhNenPPEmM5ofCC35ZdYcLEnxucvh
6800	fee_transfer	2307	33000000	1	CkpaEx1oyPUVBxFLyvbf5oBy8mt8GZBGG4BWoBKS1YT5d8hAtiDKN
6802	fee_transfer	1623	482000000	1	CkpZ37Xvzgbt9ujVjxwrEhsctBW1MrvEhB5FL7difsLnoZ5AbrQT6
6803	fee_transfer	2248	33000000	1	CkpZc725ChuNRz6z2mnfJo4tmQXpKHHfhCyGm6A5ScWHptZkPq6hs
6805	fee_transfer	633	863990100	1	CkpZywieeMY7Q6opWYMv2vg6bLpfHDLZrQKn6tgukfZEihZumFpYD
6817	fee_transfer_via_coinbase	2076	1000	1	CkpZmheLb8e2KHseeDFYaNEoT8apvsf4FkED8dcoYEhpr1ti6xpno
6818	coinbase	1679	720000000000	1	CkpZHf1covhLavwYp6EzqdGrNbGuo5vByuXZLLS9EDEcxqx15DZyB
6834	fee_transfer	1444	1180000000	1	CkpZKUGXn75DKgDV9WAteegkbbtaKVefaY4b4x9vfVG7Z1nfQW6nJ
6835	fee_transfer	1444	160000000	1	CkpZM94SPVapAF8rbsKTKffD6mMtKihYiMjC8dEvBdo1CZKuPhjpq
6837	fee_transfer	1457	176000000	1	CkpYYyhndpoVFgMQycUFnMxcvMzJjAqGmx1fifQ8TZMuZ2G2rE6QZ
6854	fee_transfer	1447	14000000	1	CkpYRoW9Qg9imDGCpP4DgG5DUnXbyZHT9888SpvgobJXPRwpLjmT1
6860	fee_transfer	1708	45000000	1	Ckpa8AUuB92AMUBtLtqwskLmn8UDGUT5zJoHC53PqH5xx375Tm94v
6862	fee_transfer	1706	15000000	1	CkpZGGMF5a1umZZhQQhDLc4NaVygDwAA7myXbYscy6jgLRzGFxLSp
6788	coinbase	1271	720000000000	1	CkpYvEQ8VjKzVxZnkqcqNW3jYHYiJx8JTKQuBFZhEwyrPZafpLgMB
6791	fee_transfer	1547	1195000000	1	CkpZ6enQsWKqCRryd4yCh3h7Jf2bfreVT1tpZoZ1U7hrZN5JqsfgX
6792	fee_transfer	547	11000000	1	CkpZABANmF2kqTuS9Ravtjnd1cQmW4N71ojLYpBkHBtLWUmtn68Ug
6793	fee_transfer	1685	114000000	1	CkpaDWcjVDp9mGP9ke4ViYD7hUCMFRG12VuPqRwPSoTCBN7pNGXYw
6799	coinbase	1637	1440000000000	1	CkpYo8BBJf3H1z17hFxm7auBY523pdtAYD6EkQoSe4QUZo4Y92WAE
6801	fee_transfer	686	11000000	1	CkpYqjL3CKs2Nw8NpvpyVHMfdZLr8peFQB5P4UMgxNGnnuywG1x3G
6810	fee_transfer	1458	950000000	1	CkpYsUyUV2mqQBVGtQ4AmMFP4DLxbs56iLXMHeJWu23W2X7ndBUXG
6811	fee_transfer	1458	120000000	1	CkpYxnv7riKqj6G8VM6e3aQAFt7oVzB6pcNi2sMNr88JXWJpSK3gA
6812	fee_transfer_via_coinbase	2044	1000000000	1	CkpYqrH69kFB4dC25A1e5BqZCpkqLLEAze5k8pyE8VgwWx1bUhQTJ
6813	coinbase	1739	720000000000	1	CkpaE1DpHi9x8XZoTDuukFLYhSV5fLGDUeTCNGJet8Z5vZ17eS6mH
6828	fee_transfer	171	121000000	1	CkpZrfqtn3Zw2sQbZgLuvkW2FYnC6R6zJFqM5FYQBd44mPoADT7YA
6829	fee_transfer	1395	55000000	1	CkpaLW5oousnk8Kyf1sn3VixMJgDFkzX2LosFuHsctEzKmJrjq3z9
6833	fee_transfer	1559	44000000	1	CkpYnNS5kVXnLvZfFhFyfrdPbxhNd8ZQQA2NUCryETdbjMXdRYywD
6839	fee_transfer	1693	208000000	1	CkpYUck1CZL7o1w7phYTzUXY1RVK2JqCf5mTnvQpxHNUz7XA2Do6k
6840	fee_transfer	2039	44000000	1	CkpZQXiPexx8etc9vErnBqn7MEQCxnrK8tGWN43M3dgrKFKN1ySeQ
6825	fee_transfer	2292	11000000	1	CkpZwgTAZxYQGfwGtSj1ESVkjC3GovoDVKJTssTPADrakV7sy9HGG
6830	fee_transfer	633	737999990	1	CkpZRL118va4dWoFy5SVUyrd4qmGH1zqUxpCu1QSgji8ddHfJ8LUP
6831	fee_transfer	633	14990001	1	CkpYSbUvGpYtfqSiyMShn4ATcb7nXkmzyDGMKafssb4WWoCkYcm3W
6832	fee_transfer	1695	44000000	1	CkpZcwBUskx9MVtfi256QvE74yM1SxHVCmCLjAnqejaLUp3UcuZjp
6841	fee_transfer	2307	11000000	1	CkpZzSj6p7nedByCvYUKBbKACg5N4dfv2vaTFciqBc8h5DiehnNte
6844	fee_transfer	1684	527000000	1	CkpYtZYmdwMtWXVE4qmrVWNGpUJ95xzVhm75rDmbentfXifQEEvcU
6848	fee_transfer	369	37000000	1	CkpYmbYnwsC65t3hPRwtuRvZYgjkyfZKRyWrVJLu6a1xVpPQrSVhk
6849	coinbase	2300	720000000000	1	CkpYqKV6vuSYsF5J7TWqiCutmVeXWJZrEeAyqQqdtqQ5zjpvsHWPr
6850	fee_transfer	2300	12000000	1	CkpZnVnZ63uHSktN5AeJcLEPuxhUexXvquvUbCARe6wFWxARbQ7n9
6851	fee_transfer	171	26000000	1	CkpZNxq3UVCnd3zQJAf2ag38j7VUracyCgZVWUnusL5e2cdFa1Eku
6852	coinbase	171	720000000000	1	CkpZrJQe4ojRj3urJbtXHW59NkPYtt5AU26kKcQbL3hdxWwSm1DS9
6855	fee_transfer	2112	37000000	1	CkpYR6uZGF2pvXLdmWU9r5uZ268KPEjJpnEAYfgjuntzfDQQeuRUM
6856	fee_transfer	2112	150000000	1	CkpYrCcy3nDyswM8PMgk4TDdSAvj4MQDnLopMEaiD9Jy7Jx7Pwx5j
6857	fee_transfer	2266	20	1	CkpYXRHdmWjbLGFGLa2UEBKFFPrMZLFDJgH5atCsK8mojtT4sB5Kg
6858	fee_transfer	1749	86599980	1	CkpYph8R7PHcso3ecbwpkxfLpxYR6GQL12y9HRP26oPtrmg4sUeQ4
6863	fee_transfer	1668	15000000	1	CkpYiSHoQ39MhNgwG4E4RFHZuTw5t5Xp79pQJEmDsFFKBn1NuCb5S
6864	coinbase	1436	720000000000	1	CkpYagkQ5xHpZ4Ek25T3gfNMAffNRMn4EL5QHjZfCYd1xhu9qdHDP
6865	fee_transfer	1436	13000000	1	CkpaA4gjPwDXnmW5c5bKEZcuVhi3t3Wjr3XqWLAyaQotgZHuyjazu
6866	fee_transfer	1709	22000000	1	CkpZAQNWE4sugvqDgDmVzKAGZBQ5S97xmM9muS4TDf3CpFgXKEjzw
6867	fee_transfer	1992	24000000	1	CkpYiJdsgSDiS6p818dTzdX9sHrMxDPARswAsriKLj5SVnYJphbNv
6868	fee_transfer	1992	49000000	1	CkpZ4QNLXEt8LqBSrtmPD5Z5rNRi2TTgSZabAPsZHkhcSkycD7Leg
6869	fee_transfer	1559	122000000	1	CkpZyuVsxKaT8Tu7DguWjJtf4WGXr26mEcN6S5aP54YfG2bey6grD
6870	fee_transfer	1587	86000000	1	CkpZTsdHB4DgMn3tsWdGqKEG3P1Q9PRQv52waspU4TB5APW8qmLit
6871	fee_transfer	149	86000000	1	CkpYqXDu3vgZayhFX84CCQDoY3tzvxjaXVKFbtVo3ZvtT1yUJvdc3
6872	fee_transfer	1546	36000000	1	CkpZ6GEgQtUtxPpdzPZ1tSQsNBrUUcCBLDwD8aqB7PQGbeu74dwgM
6873	fee_transfer	2261	39000000	1	CkpYxtwxUs6euwTp5d4giQCmezWGZgezF8k6wme9VdLoPrVH2fLo3
6874	fee_transfer	1546	39000000	1	CkpYwQcniDpc6W2P2aDamgA9J8EaPyYBtC55nC649tVJN5g3XUbPv
6875	fee_transfer	1673	210000000	1	CkpZojBAorpj5B5fE67wtuUJzK49TcMC8H6aYDgAzte1WhdLzSyU1
6876	fee_transfer	1673	843000000	1	CkpZaJP2fU9tM39JNc7Ed4XJUQJy6ezZG6WK9xeEHzm1w1bCuvFFq
6877	fee_transfer	1480	12000000	1	CkpZEk3FJpDTvw6AU23iVuCHrzJ3isQwRw8JoVhsVxTrFb8QxPdSR
6878	fee_transfer	1552	25000000	1	CkpZ6ZZqA1td59n8fSVehQy54dTqpDYjAfGt71GBbU5EvNdwKDFYB
6879	fee_transfer	1549	27000000	1	CkpZNKck2hpiM7DrZpsMdeJi5dUpWMQ8RiarV2C5FDLsSLqVpyi2h
6880	fee_transfer	1633	27000000	1	CkpZsDfYv9P2LKs2JAnQB3wby8aQ8PUhufVnifTHTQL6n1RZknLbh
6881	fee_transfer	1992	400000000	1	CkpYnEsqHGwMycTu3sth2yFTpr6uFZMS4TCv31NMYPS5z9GrEpdCW
6882	fee_transfer	2266	10	1	CkpZ3eCANh6cVfjBcbuxNXJhjXeB8ess2c4PvuiAdmcduSXCrySeU
6883	fee_transfer	1506	11999990	1	CkpZuq1Wkq895kBQmXK8m63BPoFWCRWRc1cavGXHw4fn1iDd7Tj5V
6884	fee_transfer	2307	12000000	1	CkpZAuBg51pdy72snN1ksg4xWqT8b2ThVN9eKxXpzQPAKs31h6fHt
6885	fee_transfer	1685	402000000	1	CkpZf9HyKo1jmcQSCqMThkUirwQBbXmLpMRM1Q1X6nGxoPF4ENhZd
6886	fee_transfer	1780	13000000	1	Ckpa9m1utgBXmX8u6NHZWmJz6Tvt6pgpUdTob46ZyoHxrDSaqaXxq
6887	fee_transfer	1571	26000000	1	CkpZdbULVYYh1ZFshNLGvooneuGqwUH68SLRQ1KR3AQtASENPCfit
6888	fee_transfer	1458	26000000	1	CkpYeu9DZrqDLJk4xEErv5f1J82JBUepkTQ7DdHhsTDkC29UfeDJ2
6889	fee_transfer	1536	27000000	1	CkpZyuf2F73382MuTCoFXQh9asMXQvnXcafscLGVK4Krgd2H8wCpU
6890	fee_transfer	1678	3000000	1	CkpZXxZ5mMKGeg2YxgaYXWKuN4hZod2ULMM9ahLUPR1PQB7rcbMQT
6891	fee_transfer	1693	38000000	1	Ckpa8eabVyaQPRKxvASabh6PaB64RHeMq8G9SwLKxxsNa9c81DqZn
6892	fee_transfer	608	20000000	1	CkpZXwfcBcWq4e9dP1eCQZuWBxq3GsuMr8jmR5TcnkJvJueBN1tgc
6893	fee_transfer	1602	28000000	1	CkpaEXTdvn2xVhqVur1Hw4GRm1neCrx97CjbbjwcyQwh1YTkMkJDr
6894	fee_transfer	1471	26000000	1	CkpZjyXzife1WB5ioJea7Z5UAEPaczgDaQfVhMzMfetjbgnnc81qy
6895	fee_transfer	43	24000000	1	CkpZ9udYrkXrfrNMkNe7CPBuE1P3KWfL74FJD1zDueJmsHAspYMy4
6896	fee_transfer	1675	25000000	1	CkpZBBh6K2yifL6jT76bzRSHLuioJQ8S1d8yck1kWcnfvBSH17Bfc
6897	fee_transfer	1588	24000000	1	CkpYjHhxhtnqDQTFu6UsqxVpknyBDeydEcqz9pUZteEUJQB23rmzU
6898	fee_transfer	1455	1160000000	1	CkpZVrCCVyHpJizsiJXksEJ5ECt6gN2vdFHPTJa7oBkoGVGKxytVg
6899	fee_transfer	1455	344000000	1	CkpZMxpWsFs7q6Vp35U9sSnz8iGZyMWbYRgn2zjUZV6yKxA4UAqe4
6900	fee_transfer	1708	14000000	1	CkpZKnSh8ACGnKyvL5B6h9zdkF8sNWJpVJ6tkBoW5XBYSJmxHUnYM
6901	fee_transfer	1448	15000000	1	CkpZbmeVfthsYwhgyDfL6pUBP5hpnPVwKoDerZbU6Kp9heK8XpzXA
6902	fee_transfer	369	15000000	1	CkpYwHSBC4L3ywpPQ3AjWWAz83DaT87hHAXggTAyPFTPAr4q1xxPC
6903	fee_transfer	1458	86000000	1	CkpZxe8u9v1vseo8FbnNVNH1FGHejSvPNv8YwoiyUvf9WMPNzaqL1
6904	fee_transfer	1762	209000000	1	CkpYfJREeGKjFcZpab1w4Adf9CFFpvB1fxQoX54bjw5s2N47CmUcC
6905	fee_transfer	1698	961000000	1	CkpZZkF5ZgY1z3eUKFR86EeJf7oybJNkMGPPagb3adD7rc7tdoG2F
6906	fee_transfer	1698	342999991	1	CkpZSSNbuFs2KR7taSrv9kcseEfcY2hgCQXyQcmirjmJpjKNXQKg9
6907	fee_transfer	1455	215000000	1	CkpYV3raSvB6BeabNvi4V9k1Bd7jiWjZ7iCe9w1yXvk3ifJ8VEQ1q
6908	fee_transfer	1455	45000000	1	CkpaB9W9snis2fGW1E6LHHvQSfbiCkwoJ5Rng22WBXNhimhFi173J
6909	fee_transfer	1593	772000000	1	CkpZjRHEurzKGEcdYtAe3adqDBxz8fHiUhLmx1eTii4Hs2vzf7ASU
6910	fee_transfer	1508	2000000	1	CkpZbbPxa1yLEWhgCnjZXbQesHRRQR3Cnxaqvp2RnsmnXkJA976wh
6911	fee_transfer_via_coinbase	2253	100000	1	CkpaCG1fCzyAZfwe8qXu4BGivkaaAqg5WDnHs8jmb88kay5i7uyN8
6912	coinbase	1693	720000000000	1	CkpaBFnJpMccCGUx169pGKF4X7wMyfAhKVQAN1GUiJccS1C3yxe71
6913	fee_transfer	1693	21900000	1	CkpZJzsgtydt3Swxfg9jNfjtHDJqEGoV9qtUr6u7QNYusE7SWtCDc
6914	fee_transfer	2253	100000	1	CkpaCG1fCzyAZfwe8qXu4BGivkaaAqg5WDnHs8jmb88kay5i7uyN8
6915	fee_transfer	1654	2000000	1	CkpZraXW5hfLcVMUTWKvP2q6WhQwxusfgDTAH2ThbUvVLAd1A8Psi
6916	fee_transfer	42	25000000	1	CkpZjQYFYJsnQqLmjPzUtZ9Vnry1zTgRMc6LRLE964vKhuuP8fRpB
6917	fee_transfer	1602	263000000	1	CkpYVz9a5YDdqapo3SJh9dxG6Vtzbtp9Gmqra2vzEhvWLAJ6jyefs
6918	fee_transfer	58	263000000	1	CkpZjAGn8phdHzTkAyHVZZwURvNXtB1y566YaDCZcHyK2abKPnP4T
6927	fee_transfer	1457	710000000	1	CkpZxosp6Qh92ywZnuWeKYBR4D2aATXn32G8fp4v5fT3EiCXSFbP6
6928	fee_transfer	1457	1140000000	1	CkpZk3YFSaHTFBWPuwFcVf7oEYbb391iKi4sXTjUSeE9w1ASss2L7
6944	fee_transfer	1599	38000000	1	CkpYWdA9LXCx2eK4o9Yhn3Qpm1rBzeiaA28ej1EycywZw5hmN1qg5
6946	fee_transfer	1394	31000000	1	CkpZgkK2L2YRijJwvVjJwzfTJqoGz8PiCSD67T8DcYDvzB2mzG6bw
6950	fee_transfer	621	12000000	1	CkpYk3EjCNGrvZVAyruXdTGdWFiBqumDjuGDRRk5ZpvHNVUVhsu18
6954	fee_transfer	369	34000000	1	CkpZLXZ94x8U8jgSiyQtLVAV7VKsHrS6qpbRFew5oqrfsjrkyMFT3
6960	fee_transfer	42	2000000	1	CkpYWGzQG2PrkAfKFaaKgoPSoCQN58Twk29C2TqG8Vrc4zHqPRNYP
6966	fee_transfer_via_coinbase	519	1907000000	1	CkpZaZCCcAtwDBynSwixwWHHp8GtR5WKWhkc3Cs2Fn3RK7uvA87iB
6967	coinbase	1719	720000000000	1	CkpZhQ1DbZUWRHzYqwjpNTEJ3DzynEgBVuwehDgnLjNQ5hgM1qCWH
6968	fee_transfer	1719	42000000	1	CkpZCDJc2bYuqUDqb8FPdCbGW7r2Rb4pGAaU3RpijbhZ6bpwzW3Dt
6969	coinbase	1686	720000000000	1	CkpYstv21VggYZ5JdXT3iNvc2jeTxAjiqpetiQB99YzPajpzpC1wv
6970	fee_transfer	1686	42000000	1	CkpZ5GBzb6u3t9um3znrxZR8NCa2XdGuMeDjTejJkqRjpwTvq9RfV
6975	fee_transfer	1448	22000000	1	CkpZFaoTrp9dgojtdfTakQpx6xmH9GZtFSnQNq3xptud8Yr5hffCq
6976	fee_transfer	1434	11000000	1	CkpYr289XFo6awhDhdsUKt5uMKVmn8Ax4c3EfLRpWGB7gPduG9oVh
6977	fee_transfer	1657	568000000	1	CkpYi9Nry6tspsevsRZDd1tAAPGVN7eeyJSm5pyjjXwwt5srsi6B4
6978	fee_transfer	1422	33000000	1	Ckpa1kfvc4sfNHdX8jmtfiCgdUDJ9DF49YLDQh6pSBCD2Nbqd36tv
6980	fee_transfer	1746	44000000	1	CkpYpcFQwj9JiXwSjA7FMCsnNrRacdovBq26mhGj1dLZLo2tP6byd
6984	coinbase	1533	720000000000	1	CkpZr2HHGeh6kicLD7yJuBtoxYzPn9hJqqmURwEVkwYGxzNDsoh8L
6985	fee_transfer	1533	10000000	1	CkpYb9rJnun6NJXBVCs9o9db6k6p3sWSpSAGeCuNWcC8SXasJJMhJ
6990	fee_transfer	1593	1049999984	1	CkpYnSmA9xVS7VVSU758dXje6RrhcdRtKrdRLjJphwFDQtBGRmNtv
6991	fee_transfer	1593	29999976	1	CkpYbVWjK5ZmFuXFWmLBD51RYweibtsVXs85LN9k4k7GWjdkmYjUf
6993	fee_transfer	2261	10000000	1	CkpYUv9gT1AyV5MyNsX3Qeca7ouoAEPvLQdFnp52VGUnqyGvQphig
7002	fee_transfer	1709	112000000	1	CkpZVR4Btzx39FXictLxtiGbFfi1cXCtJ73VWsiqaxzCCRDowBKBx
7008	fee_transfer	1623	49000000	1	CkpYxUpAZghdk414q1s9X2gzqY7oXJUFMiwBaYfwbFSExoLJPRUME
7010	fee_transfer	1522	60000000	1	CkpZm35fdnRtcmmAP1Q6AZ1YTD8C2ZMLMWR8DZcuyAxcBrkmq4mTV
7014	fee_transfer	1691	37000000	1	Ckpa98C2je2ojwu2p48yC93sEak4Efh2WZUMDFEi3aoDr9abPbmib
7023	fee_transfer	1541	49000000	1	CkpaBUF2dgPtw23YrQaZfzcEreUP5zpHnk8wuSC91kuDppfuSQ7ni
7027	fee_transfer	1746	47000000	1	CkpZ1Ag8hQoyUaJHh7Rdop8Ei4m3wfSUt38S2nkJh7QPaazBkUXrv
7030	fee_transfer	1705	47000000	1	CkpZbtjWC2LDWPQhUPUCgP9N6Jkn6oEKZGFWQqXQpJsM4fVPDBhoP
7038	fee_transfer	1759	111000000	1	CkpZ1R2FiujQwAVYVAV46HDtyVgBRSzXZ7QUZ5Q3fx5fG67cq3GUF
7041	fee_transfer	1508	34000000	1	CkpZaJjLy6G3nt5skEq8Qv8oNzjfavp63RpvtgpdiMGZ99nx6g9jF
7051	fee_transfer	576	34000000	1	Ckpa8Qoywyk1q5hPXkBFDDw9jpU1vmxNeS6nAVetEDJyHo5X7UEQv
7074	fee_transfer	1541	33000000	1	CkpZYMecidxQ1r3nnt7jyz19ayzm8mAsqmSdZSKH49ELeojd8iCHL
7076	fee_transfer	1654	1170000000	1	CkpaAwxyfoKfgr1XepqGus5s46sTwahncyffqYmUduySQYQCbMNsx
7077	fee_transfer	1541	45000000	1	CkpaF5HV6y4xmcWibUmCmh9hw7ykb5Nt3zh45eUFxF9MMQRJ3jckK
7079	coinbase	2303	720000000000	1	CkpYhRumDeijuRSJH1xpWAb7Y6ThWducSY3i19PENiJaq4JwU1ss7
7080	fee_transfer	2303	12000000	1	CkpYphpYMZH1tX4bQRGSr5X3JawrSckHUXHTETsweknwoEj3QRuke
7081	fee_transfer	1684	134000000	1	CkpaBmf1FFjrgqe6TomfAUkaC7EEE8fqXJqUhhmqjHkawdM5xzuzN
7083	fee_transfer	1613	32000000	1	CkpZ6YvHHsmXVCRrN1qEK2RkN4fXrPETWXrymUjC3L8f5fqXJiux3
7086	fee_transfer	1549	1999998	1	CkpZ4ifHH79P6zMgSJQaLTfiSpHd4QRX1yyTWXwSMba4vVgeEUqPz
7091	fee_transfer	1717	34000000	1	CkpYnj8evwyDkbN1DpgZCRa2g57CHbK7kLKp712m3uBnqPsYqkNWA
7097	fee_transfer	1693	3000000	1	CkpYbuSRdJsG5PFgpBbUsTp4xstGWADYhxcf3PVfE32ihCmjy7PQu
7100	fee_transfer	1489	62000000	1	CkpaGFw1pXVYtA5b52ZLJF3c8fx5zdEa6SSCeXwoyqZkVajZKUP8w
7108	fee_transfer	1549	112000000	1	CkpYZzHWDRn4p6jry1cmA9Mnk1vKw5VoWWKBhVm2niXUqpcvTzgcG
7111	fee_transfer	2307	112000000	1	CkpZuTaw36kPrT1aKz4B5RCUrSgvFcB7UNMTXwQWMCj5yagocQmYC
7121	fee_transfer	1716	32000000	1	CkpZ2yaxJWLKuKbTfpzBrdFQE8aPgdV8cMeDx5HboaoyPAdWWvbZ2
7128	fee_transfer	1696	73000000	1	CkpZMvvUz2wuduHkR1ankMaxz8AjL71nEHpKkBnGXUTFiEDy1k2dM
7132	fee_transfer	1439	52000000	1	CkpYVtA49Cqvqw5CrNgPHXtmvaRzAraPk4xHsza31yjpGT9eFKPDR
7135	fee_transfer	1637	51000000	1	CkpZbyupdceCofCRVTG5QEB4NGiLcEJ9EPHpBp41mWDdoTyomrux5
7140	fee_transfer	2039	341000000	1	CkpZ89ZgQAmsKZQ9LrPRch7XCJZHnVFxxALg2YXuUpBaFjoqZiJSp
7147	fee_transfer	1588	53000000	1	CkpZuwk8X5bEv2ZnqgtaEjn5H3mrTv7CEJuGUpTX1pZa32iCD89hR
7149	fee_transfer	1671	35000000	1	CkpZ7dsTBSMYjZVmzBYQHD5kHWUVo17JW7nDfHAk2PghgyZQuFgmW
7151	fee_transfer	1544	13000000	1	CkpZvLjgfsjyzRXHz8mqUB9bYgZ1kmuk3rZ1S8jGGdgaYrPdBbDNj
7157	fee_transfer	1623	37000000	1	CkpZR7GmWmjDoK9BijA1Km4KE8nhWQQ73aRTVR38R8C53WKj3NFne
7158	fee_transfer	1458	37000000	1	CkpZYQn376GWLEeezSYpsThXSHHKZZWNKe4XVd15jvFyoqkmDSoZY
7165	fee_transfer	641	712000000	1	CkpYnjtAKrS2eJeabwgkeM3Z5wxnturQ3zHYuu6qxKfhcG1eks3zF
7166	fee_transfer	641	43000000	1	CkpZH6od82MH6uzmGvizZN8ppJg1GcmjNpBDmzJn8r7QQaagbL77s
7173	fee_transfer	1619	11000000	1	CkpZoVeP3hPHcJ4HCHJwkFR2jLuW4EgwLUN2UwrtVH1GWXhm5Fz64
7178	fee_transfer	1395	4000000	1	CkpZKULTyv6yXa9iR645k397z6byer13uTdLgEGiDRJDe7yAdAwSH
7181	fee_transfer	1549	80000000	1	CkpZTfeWQmpZzU1sTpYhhtLwSBGGPmPjkr4FJAQ8MGRNhSFGpegDx
7182	fee_transfer	1549	31000000	1	CkpZTBVtDbwMjMQg7JzXQQ1SkMeuCijY73UoWSSdsT34LxyDuJNWT
7193	fee_transfer	1740	47000000	1	CkpZs9XuFApfStwoGT17VrjYUPDVFLLNZo1VLH15nuHsek1VkN1hH
7200	fee_transfer	1547	26000000	1	CkpYreySb5YAbM5nNXMjFx6ukS44SghVx2GbsnsnMECMNxtPq1cBd
7203	fee_transfer	1702	35000000	1	CkpZtMEYrnEWTHoi8pnUKAY8hbd1LC8Aunu3o8ABx46k1fMgHJPim
7219	fee_transfer	1709	3000000	1	CkpYUA1ohqu5XtfFZBbStQpqNy3CaRQLxfScmSGJCXstG2wfU6pU2
7220	fee_transfer	1756	34000000	1	CkpYnY6gMKbP5dKSSJaaW5pd6Qbocw3CYHJVAZYK5J6eQ4EvQqQ61
7222	fee_transfer	1705	49000000	1	CkpYr66L71XckK2WG9djnM59JG6xoGBJof4xh6LJdbvFK85pWkjxX
7224	fee_transfer	1596	24000000	1	CkpZoDhVWBxGeHtkNh9hUtrmcJw1kEK8Xgo8S6jN1pLwpDjE9dJwe
7225	coinbase	610	720000000000	1	CkpZo71Nd1hasutoRpFXQk6Qve6wXKXhNZnnkQZn69stDaC44kkNH
6919	coinbase	1718	720000000000	1	CkpYyFXvQCNtGmVdhGpRN9RHJAnwMBTYMa9gXKbdZLqpkhH6CGeCb
6923	fee_transfer	1447	26000000	1	CkpYU6jNhjMkUmbMjHVbdxrmQ8fmr2feiNnSYPx33sCrw2FqXxUeQ
6931	fee_transfer_via_coinbase	2097	99999	1	Ckpa76653unPuN2gyNio1avS7gzNZExjQVd35irGTvMZ2VMeJkJG3
6932	coinbase	446	720000000000	1	CkpYgTVsvYtTgM4zLrgDBXEAjKfLTTUyewQmbHoYwftR7ekyiEz5P
6936	fee_transfer	632	641000000	1	CkpZxMQ9fyGMPMQxsbQpZRSxaELaa2pvEwuBz38fL1oT2Lmbi6STS
6937	fee_transfer	632	667999998	1	CkpYw8oxGdJqYr9Cme3x5Csts65VqgucZeyw31f6C3J9MuNHSiVjX
6938	fee_transfer	1538	10000000	1	CkpZ6EkKpE6s6xmF1gQryx4Jm6xdPQAFzoVR2HPBiy9cv2CeN91Sq
6942	fee_transfer	1455	1040000000	1	CkpYRwJ8CvXXGoLFmcXQz4G8vgwbKACtY139z3phSDiYsFRUmtqhu
6943	fee_transfer	1455	168999991	1	CkpaEmzD2gLbnQ8ha7uzcYH64JNSEwec34uGg86X2CCLZ7UT313KE
6947	fee_transfer	1671	37000000	1	CkpZmYLfxGdHt5JPhGxaLP4FB1d3kNS6JumXsULc6pXp4zgVyKiZ5
6952	fee_transfer	1447	15000000	1	Ckpa2TVjbVnWieXthA3QiTfet5GNPKDNWicKAzvqHcFzsYK1c7AZG
6959	fee_transfer	1756	73000000	1	CkpZZXNbRY1DBJnup7DCSMMc6ZSMTxDntYxNH1KEoQgv6TmAiPe1j
6981	fee_transfer	1747	44000000	1	CkpZ1hLCGtn4qnU3ZnZUTBZj9SePr9fX1BuU1Du88esnMrg3gMFc3
6992	fee_transfer	1657	520000000	1	CkpYb9kofLG4Rsk2rtTdGfSNPMFVywsFL7i6PSNivzszrTQuqWJkN
6995	coinbase	1613	1440000000000	1	CkpYVnyYTswoprHbEBBD9YBeDnfUGqZXDYrsR4xqZYd3nPJtFAQU7
6996	fee_transfer	1613	44000000	1	CkpYfDDjvDaPqreqEgBfKPhgNHevSoP5B72ApTspFXP55xftrAUqL
6999	coinbase	646	720000000000	1	CkpZEaJwCKXyD8VVGaaNGzbWVgco3R1LZac82d7ZgMFvGuhfhURmb
7000	fee_transfer	646	35000000	1	CkpZTKJBwL7cTLi9iQuZEbaZiVsqDzkrQT4Koaajf3YaYLMjtYL48
7003	coinbase	1439	720000000000	1	CkpZjHmVwoNZkJzKxYKkj6o5iUgH36vq4Mmr7jwpnAWrzGWZkUJdn
7004	fee_transfer	1709	6000000	1	CkpZvci8mbSwkmYZHJQUaxYz76x2Rvyfom6fdGZuVMt3GTpvfW4JK
7005	fee_transfer	1708	49000000	1	Ckpa6WCmYaNGUmreE9nthKwpJXHNURPHXokxmiVxhWqw1jnwk4HfG
7011	fee_transfer	1634	60000000	1	CkpZygpmJ5Lmzuo4dmkH92EcYxQJvmfbWbJgAfFdErf4fWp6FhbNM
7016	fee_transfer	64	13000000	1	CkpZKda2fwtawomRGpfv2S5ud3A45mhCAf8rojCgbGv3CdYwVZk3t
7017	fee_transfer	1668	21000000	1	CkpYibLzQHzaWS5PGn9a1iEMDDW7mdpzh7joU53pCNwmiTZdRVVDk
7018	fee_transfer	1668	4000000	1	CkpZbJDbB9YdhTsQtWGopJDd2g5nPFq6YfPTg4qsH37PczgJerntv
7024	fee_transfer	1718	49000000	1	CkpZVHMsH7VASvB8Dh5a3NBHYfpxkacwtgUwkAXzV8Um3sdmbmL2U
7025	fee_transfer	42	7000000	1	CkpZXhw7Qxy1NedmGiYpasZzmFxffvLtdZn8sdsE4QFuSkHfYsktm
7028	fee_transfer	1747	47000000	1	CkpZPzD6Mo1LBZEwHHS85vR5kx3GnH3RUG7ZqAaBGtqn1gKhf8Mpz
7032	fee_transfer	1685	122000000	1	CkpZVdgmz6rZ8AkoP3qUaqVMDhe7bgW8NYvrmx5BPvG4ZcqCugE6E
7039	fee_transfer	1476	435000000	1	CkpYuqKWtMMmPhSr6djHbDEPNskHrVwFN6DfEfe5ToTxgyggEkPbH
7040	fee_transfer	1684	34000000	1	CkpaCFgEW8fBqcyycs7XfhiR8Z4W9hWqsoRjFrpFRye6eWkiHoYEu
7043	fee_transfer	641	21000000	1	CkpYkTPT4Enb5hd2vCvMPaULsx6VNb8TjCYkv89MRTWuVYfLjDwrZ
7047	fee_transfer	1559	1190000000	1	CkpZ2RbQ4ZPdpmMnMkBDapLpr7hAvU9iUJX8rm7DxuqnKdsHNZ9MQ
7048	fee_transfer	1559	281000000	1	CkpZEq9GD7NEQ4bZShk27hYVaeuvAmeSpgw9LjYiZv7gBkNvKm84A
7055	fee_transfer	1855	380	1	CkpYkimNVMfyzURWYD8uFy3hEQP96LaeDTVghRBAYYbCpUb1aKiNC
7056	fee_transfer	1419	999620	1	CkpZXseatf3gytCuKPxdr43Wn3HJCX13NAVU7rXnhyr7wM6PFfhyU
7066	fee_transfer	1675	750000000	1	CkpYRnjboZXL1AmUhotZjKYJceG9oURMUsoSLgDtN4A6ZMNa4FmJi
7067	fee_transfer	1675	860000000	1	CkpYuGWFojxmjy4RSQ7sLgzDYTd6UDeip8UV7s8dDNw5cREqTXdBJ
7070	fee_transfer	1681	101000000	1	CkpaB4ufiyxhgYwcFzJta5nvCxcANaAJ5EHFt8JxwvNwwV79n8WSG
7071	fee_transfer_via_coinbase	132	1000000000	1	CkpZ2bFBZzqnWSsqW2RFxkYyZi14HojZ5Aj36RY8XbPVW49vKm8kn
7072	coinbase	1688	720000000000	1	CkpYivYppQrdH5JswpFrJWymh4uDLReW29D2XdKmuSsgxK8Z75eff
7075	fee_transfer	1654	23000000	1	CkpZ4MAuxivhgJFkY3RgmLdyLV1N6jXtotDLuVFu3Bvq4fDok64Nb
7078	fee_transfer	1718	45000000	1	CkpYcWEv4LasAhmiJfD3sWca5SnTvQmc8XdbNA2UN6MrSBoZPEBhb
7084	fee_transfer	2306	32000000	1	CkpZ1k2VFdPjj2uovX6icGXSntWA8W9AqDFZGcLRK4jzYPCQiJVo1
7085	fee_transfer	2306	2000000	1	CkpZsodwHLNy9H2r3U7PzLPJ6hayBuUxyf9paw815qybvUhnAFtCe
7089	fee_transfer	2148	34000000	1	CkpZ2Nti6HwYXrMYBLwHwUYqSEkjUQz1UtLQsuLpiArGbdWgRyZ4m
7095	fee_transfer	1723	127000000	1	CkpZNyon5xJReWBqAEenA6oqC982F2qH6kcHhR8s6X5bmcYEqxXMZ
7096	fee_transfer	2039	123000000	1	CkpYuSiKihzn2vc9Ny3xQprfxUETwyskv79W71GnZcQw3JRxkGQak
7099	fee_transfer	1549	62000000	1	CkpYWd48atejYrJf5TMiDVizWQfxBecexUifLmHcrLX3girbWy7HL
7101	fee_transfer_via_coinbase	2067	2590000	1	CkpYpzL7geNswz6Q7N1Z95sSTbWCJQuiaWCwrsA1d2d3p6KSgPRNr
7102	coinbase	1489	720000000000	1	CkpZD69Z8YoGVAYbvyNhwmxJ6fJkpC8UL3E88f99cs7nh64C2BtDV
7103	fee_transfer	417	9999990	1	CkpYr3LBRKDEqfUT2LzvtzgJKb23XKsbno23jpqMXRyCGLvBdJ4gZ
7104	fee_transfer	1489	52000010	1	CkpZN1FBZ7dApNFqdddmVHNE8KNRXqLzt9erD1tXoXizWPaSDzXCi
7105	fee_transfer	1489	1280000000	1	CkpZreZCvJV525EwBTF49DZNGFP4uWHk6vpwWjoqvRrTkeERM78tm
7106	fee_transfer	1489	600000000	1	CkpZ8cWpn1kgsga7NfRzokoMQkbtxyPNV9Nzh42Eygj8G5n1w8VyQ
7112	fee_transfer	1723	225000000	1	CkpYvRiCtC12S4SY4sYGj54SUij8k1qAuzGAVC8d34LKbeoD4vgVf
7122	fee_transfer	1685	62000000	1	CkpYfeNuhcJFa1kcrQmKMDF1nYYYXj41y6uyweKCRYPujhRUGXZ99
7124	fee_transfer	1394	207000000	1	Ckpa5mWbQX4qJhn1GWvfuMoahcfn3KDTtGKXEpTyTyqZau29YwLKr
7130	fee_transfer	1395	60000000	1	CkpZMXejUCguFjjB4McR75oYwRyKqWTbGwcV3A3tL2odQW7ZdTDTq
7136	fee_transfer	1679	62000000	1	CkpZFKMGnwPeKMTTvm5RGGic6uyYwQ6aAdoD5JuJnF8YEDN6AMiQv
7141	fee_transfer	1395	30000000	1	CkpYmqYs9s7JFSjdyfT33LTE5j248gu9wdx6UiyA1jFYq1RR67cX2
7146	fee_transfer	1471	62000000	1	CkpYcqSptDPohpSk39F5ubaVPLszSkon36h8BTNo5jAMaeqwHi7aq
7148	fee_transfer	1564	53000000	1	CkpZkmumMrKdNHuj6aJBckRKyLi6a2CxDs4q8tGJ5ijJ5WsY2LTaY
7153	coinbase	1693	720000000000	1	CkpZcHKVo1AE63WncPzpCMFoTGptwn2v1nC1AwSC8sCTWXFiy5ykg
7159	fee_transfer	1668	42000000	1	CkpYccosAtmsTCJkK5Re5j7h3BYoXTKisyCBcoiM2eDMX4i8Laq32
7161	fee_transfer_via_coinbase	1966	112200	1	CkpYuXWms9nVTANg1ckQUDdtgvzmdWBXbv61wED5FaCxeRXACoR49
7162	coinbase	1649	720000000000	1	CkpYafV1XzZjSKAV7S4ycGEkkBCegVSUFYQGz4shMMajAjzgMwa55
7163	fee_transfer	1649	1063000000	1	CkpYY9S9VBY1pcRNeJyaAyyFAmPzhFG2SNZfFNTC9GMBCyjq7EEWc
7164	fee_transfer	1509	57000000	1	CkpYoPAG35fEe9x25Yph19Yb3ijjjuG78rH542AwmDahhyBW3bDWh
7170	fee_transfer	1457	26000000	1	CkpYTnw9vuZche7zjaFDzrnVsf9ZTxMCWi1LWsXGQ2K8yBZZ69g7A
6920	fee_transfer	1541	25000000	1	CkpYjx4fAB4aoB2Q1zf4tE9zaepxzAVKB8zB4RizCw8fa3KWKvbFr
6921	fee_transfer	1447	23000000	1	CkpYvbDuQAt1bvXNS7xuvz1UKeCF9bKiLgamB16nc5LcdUb6gN3LM
6924	fee_transfer	1471	250000000	1	CkpYyqi6YHkXvaoyBGZqSDRCa9BK249Uo2bsnHPiYVoefrLvgKKQS
6925	fee_transfer	1451	15000000	1	CkpZhuEkQ5q2fksFNgG39g2AQ3KkD1hc7RyjfmDU5smEPAxPusb73
6929	fee_transfer	1513	1660000000	1	CkpZdf26Rhioq91PcwQXU5CGW85xpgNNg9AeE6hHevtm9kCAJ3LhA
6930	fee_transfer	1513	190000000	1	CkpaAyDkQgUmKipB1TafKBcW1sN6PtmqnHtJCRNXBL4KT3wpRQsBF
6933	coinbase	446	720000000000	1	CkpaDMCJ2WKk7r5a4HTSW5z1FiChdHETshKW69ZMQvkS5PLdLdgHM
6934	fee_transfer	446	25000000	1	CkpZAYejopNPbCdChnQvkg1EJDn74vJMKFA2cUCmikf1VG6xtYpjR
6941	fee_transfer	1719	48000000	1	CkpZCfpUuFhzMbSHtYgpE5VstpQYprZzfzC3DH2MapTq2VsyFh3gT
6948	fee_transfer	1706	14000000	1	CkpZJwUniKvDRmUeBve4aq53LBkN1fwKJ8gfbPFU19fhCrxvyGEuE
6951	fee_transfer	1701	24000000	1	CkpaGA26ivZRf9ATBwD8MmKBnsxY9uJ2xcSx1SDnH1zCTPNpvjuPC
6957	fee_transfer	1394	121000000	1	Ckpa5eARwQVmTN9GdXFFGqNHDqEZBMxU9ZmBmSvcMXZMKGHo6bDsn
6962	fee_transfer	1709	290000000	1	CkpZeH3VkQCvBV4rV7EfBAx6TvH8NrHBNCqZXjEdsWAe5k749Dp5Y
6965	fee_transfer	1717	36000000	1	CkpZdn9kJhDFRRobfkCb2CZFDxjGTDb1PDPhdEPe5ybh6s5jTheQm
6974	fee_transfer	2106	22000000	1	Ckpa7mAqpA7d9Ut5oqzNzq7pp32PN53gmm9c9UKquFNhhMViF5KWq
6979	fee_transfer	1818	55000000	1	CkpZkgwaNzwuAJtcaX6tGE2iQnNXYQves3cEPtfHKAtAujr5xnKkH
6982	fee_transfer	2292	44000000	1	CkpYzUHGHffwLNQa5rftHQgKfikdteCGwwEDWJ1HyMUnJZngLyLan
6986	fee_transfer	1688	46000000	1	CkpYyC1EB2pQs8aPhEmfggwqazwqrm4u4Dx6RhPq9YWbCrWee1hyo
6987	fee_transfer	2307	35000000	1	CkpYbvK86MNWfeMjHJXqBtxJbE6A1X2sVJRp2Gk4M2o5ozsqDmec4
6997	fee_transfer	1687	23000000	1	CkpZMNuYS4KADLr95tECnTEyCvVutkREjCQupJYeovfcwcjBZAwxs
7009	fee_transfer	1756	61000000	1	CkpaJELEXzrjNqCGJgeeJEDxtUJNVDxcok5BJbEYvnxWTXrCfG16z
7012	fee_transfer	1692	62000000	1	CkpaCzSST8MAv8UhRkXGyz9xvbGgjeFHWQXiVjVB8CiVrpcMi24FP
7013	fee_transfer	1768	37000000	1	Ckpa43kuY1F2nnudxPU8DtMRxdgSj4Km9RYmZESdYCV9VTy8LFW7X
7019	fee_transfer	646	2970000	1	CkpaHEFspaD6EfDNERbrKb2HN88cq3RN78BbF7r6bjZA9xKaCbTMw
7020	fee_transfer	1668	630000	1	CkpZc4As7kS4t6KqoDKsXRvYLpCvPidzqTCo5H7CpGBhvUaEwXCut
7021	fee_transfer	1788	400000	1	CkpYYZ8DVSmjeX2eYvimz6MYMVhyuT1F8PCKzoir5H7cjw4xpakho
7022	fee_transfer	1573	36000000	1	CkpZ2t6PAC33KoEpbdhQisA2Qz4pz4159xTXBFBWj6x5aZzAZbzhB
7026	fee_transfer	2292	47000000	1	Ckpa5iZA3Gj9Bwm45wD4qNe8ab5kfLsaAvxnkr8TE4MvzUFRxzRFc
7035	coinbase	1623	1440000000000	1	CkpZT58PapMziwv5y7AmxJpuXQqCprLN9tBTYYQT9vrgGp573sAC2
7036	fee_transfer	1623	134000000	1	CkpZrQHT5yDv9eAt86G3pF3ghrFqgoAPNwcqyh4aXb7mywVvy3v2b
7042	fee_transfer	1573	682000000	1	CkpZGtBxzKQkiVVtHSKiTjCpMxAMRv5EqDnP7RQ6qvDkE6wJ5r2pm
7045	fee_transfer	1559	110000000	1	CkpaHE663ydzR7gp14YvkrTx6tz5UGh3Z78H4Qv61P6U7Xa2fvtT1
7046	fee_transfer	1559	108000000	1	CkpaJggFytXfeYGLPhuvzdsxvBYJZazauefJnnLMJjVMEjyT46xXs
7049	coinbase	1582	720000000000	1	CkpZZn8ziQBtryj5gyF8SBPhrUL8jsaUz24eo7q3VR9NuxsNigiuA
7050	fee_transfer	1582	11000000	1	CkpZrioisnXeDsMXwxPoDRhC6hVSonjxmGnVxYy2i4xGFSfCM9xbv
7052	fee_transfer	1740	414000000	1	CkpaK1EfgxDSAX8XKfE4PrUnXHyrUxsNjvrgFcP4vx3hnkmkEieeM
7053	fee_transfer	1588	62000000	1	CkpZFSGAMfLs8XpoC8uHKBFQRFoYZzG53vhHYQD8NtYhrFabn2xAP
7058	coinbase	176	720000000000	1	CkpYUzCpNYSU61QqR7BdivL5wc8dTqiiFmaGMaVwYzdUMSGF3RVBX
7059	fee_transfer	176	12000000	1	CkpYn8hSzw8NQHDCWGYAHr9tZ2gj9SMo3tfqWNzaDb2vch8ekvJ2q
7060	fee_transfer	1654	1570000000	1	CkpaGCTfAfDdFfWTwcJPGBb7ivN86Ke1q9iniPjJbosiJ1Ft8FzVq
7062	fee_transfer	526	900000000	1	CkpYyJhzmLYkYFxdSRw9MnTm1cLQvS3iujzMXeDfwtW2X4PzpDjng
7063	fee_transfer	526	710000000	1	CkpYo4raWdKxWMniVa8QhFswVMqZnsxwt3jQf4N8q4rB3k6CZopWV
7064	fee_transfer	1709	584000000	1	CkpYifjmg89nG4ckWpfqPFVG6VSuauMfKiMr6bZZSJvzdXFoXe3X3
7068	fee_transfer	1458	169000000	1	CkpYeeN5djMPpzxnv51Z5LTeJ2rVmB3C3dtN2mt17v34Abss9o5BJ
7069	coinbase	1426	720000000000	1	CkpZP4CA7ejqL6qWWkYws1YVKoQimkgansyRPRQCbHUcNc9EzZjnE
7087	fee_transfer_via_coinbase	1501	398000000000	1	CkpZXViXPGhePyGyLTSkNMqJPaF5h2bMFMYHsA4exuGvujABJHNjF
7088	coinbase	1426	720000000000	1	CkpYa64tAM8K3hrrmc7ZycnLXWWRgikrxmrQy8i6VpRYHmbD1XToG
7093	fee_transfer	1402	62000000	1	CkpZ84HgHF6HhatrHRVvPCGg9VFD5F3RUGknhBhHF8cL9ZNy9BjSo
7098	fee_transfer	1649	2999992	1	CkpZVBatwxZ84YVorjoomK7fjAwevTwyAQqaCmbMaBKPogDX9Sb2R
7110	fee_transfer	1506	112000000	1	CkpYZ5h3ky3FJ3GQ9jettQCY3j2e26rpgjqw5bDW3nk8HbxvZLFi7
7117	fee_transfer	1692	6000000	1	CkpZVT9wvYyuWpBp8SUzha8SDzPv9Nm2gF1cGBj2AhV63FUdUC3hP
7120	fee_transfer	2248	32000000	1	CkpZUKyYimyx7dcXBtuJxn4YWVsGiE4f6oAUSMR2JkAUBLWyABxCX
7123	fee_transfer	1457	207000000	1	CkpZWq3gDyMVdAEjJkGnamoq62ZJ83nxSgT3cwrMzAx7pBABmZ3n8
7126	fee_transfer	1716	207000000	1	CkpaB2yhjs5qWN4SwpfswTwuXC3VfxYnAcKAhY9GAgENVsry5MSuT
7127	fee_transfer	1419	52000000	1	Ckpa65xFVRkTFW5x2qRVXcEzDf62DWpVyxUFyuAPbLtm2SUivwTNU
7131	fee_transfer	411	52000000	1	Ckpa1r46qK7kxGvVqZqhwCAeUZwFKsoVYEVzV1frgRxjnNnJAyxcA
7133	fee_transfer	1476	52000000	1	CkpZTkm2rDqv82AtNQ8qHeW1CStjbgoGyr6J4nep4XSUiR4RP5ffC
7139	fee_transfer	1594	341000000	1	CkpZnRS9WQxnoGQ3caEg367KiVH3idNxwVQqUxDZL9oaaa6YWMUyi
7144	fee_transfer	1419	135000000	1	CkpZReYJQdTk2EPKSYYR4ngCFkBTxzyELLsso5HN9hNym3fS1BJgP
7156	fee_transfer	1698	62000000	1	CkpYaGuA9XQ6WehRkvSJwPweWdtXaXhALZKZrUBwCRgcZML545ryb
7167	fee_transfer	1394	50000000	1	CkpZUvUD9ZakBSRWaasG5Vey3fcwjjP3Rnzjj7euvjCN9XKg2sCjs
7183	fee_transfer	1549	98000000	1	CkpYggkQZSJwdhpbHkxo1u7WaaJWW7efjG7qUeffUjx5Lcdfp1VNG
7190	fee_transfer	1762	2000000	1	CkpZfwF3wsNyx61CTinUqNimQbQ8RmaJYTvwEb5a83VKqAovjjY7Z
7192	fee_transfer	1679	47000000	1	CkpZviXysLVoM7ufFaGCt9WF1GeZBmjFoUax9US51vjHTioY1dPKe
7198	fee_transfer	1649	110000000	1	CkpYiqRSVFfHeY9Bc4TNMryKKMyjYxRRC1B21ZMtH7yKrUJNb4mtp
7201	fee_transfer	1588	35000000	1	CkpZ7zUqpKu1nEhbugVhtPYR1Ay7a4ADoZG13EyyxXBZoz9xj355k
7209	fee_transfer	1560	45000000	1	CkpZtaLAepQ7Dq7FBR1yGxiDPhzBFxDR3BSq2KVXaNAc7PriXrC2e
7217	fee_transfer	2307	13000000	1	CkpZiyRDS9aizn9q7yDJsQkpSYFTMs25gvWiD5nMkDpRhh8KaAa9z
7223	fee_transfer	1539	13000000	1	CkpZcYjyG1YCVP4ERVv4ufVnnbtc3vQXeJAzGCPYm2XBQ2LRT1nxT
7235	fee_transfer	2292	25000000	1	CkpYiTmQZ3nBovp9Y1tNc9dNFVqFJy1sx6id5W8QhZ3RTiVA9Bqc2
6922	fee_transfer	1762	26000000	1	CkpZRbs6wZyxaHpKGqRRfJV3FTepdAbgwHZWc1qzSaUH6panGdWj9
6926	fee_transfer	1709	15000000	1	CkpZbX8jepV44ZJoX9K4nZrhjrSwg5YrZpQyyDH5cmNMJcrqsD17Y
6935	fee_transfer	632	74000000	1	CkpYzW76UCPu9i5sRoeomEqLe9q1tG1BZ1JENnKSDDYRYD3DcNZAE
6939	coinbase	362	720000000000	1	CkpYWaJ6GnEbCE32t7soQ3kwTfKxFGhvuk2NdW85yEj4Wmn2V2wj8
6940	fee_transfer	362	25000000	1	CkpZDsVmGweJDQGfdodDejq8mxXWBGpi3TueXtHedTp4WUt4v38HZ
6945	fee_transfer	369	38000000	1	CkpYwVCReXyEDq2p8qL24Qj4Vt1xWAQy8uQhqmmwW9pPpdjQ3gXNv
6949	fee_transfer	1471	14000000	1	CkpYyBYv6FuMV1wX7nJAUgd5Fizfw7iG8caspiNSTJ5boptvEgXJH
6953	fee_transfer	326	15000000	1	CkpZBv6o4WpxcJi9NWFifvL1ivrwZteQruAQYQbNWzryECUDzYxw5
6955	fee_transfer	1593	1290000000	1	CkpZSCJEXAMQwjVoXBJbp6J27BQmYE1Us7g2DaNGSkHKBdKdFYMud
6956	fee_transfer	1593	200000000	1	CkpYytmh68mvSXoBUkf1cSV5uDhEKuVMnyLTi1HkFb5e379KD5bdw
6958	fee_transfer	1623	122000000	1	CkpZn9f1nmoULbxVR3ZFCRb4jyHRvJwYbvzGgin3LYWMMvBmX4bcG
6961	coinbase	1422	720000000000	1	Ckpa4a1nYFdoifUbo8ucqqi5RQ56FtVgciQBiDX21J5EhuRNnGPR9
6963	fee_transfer	1657	892000000	1	CkpZ36YWjZ347QZGjp32ryS97qeyrbWk9HsbSMBukx9WyNMYqs6Q5
6964	fee_transfer	1657	7000000	1	CkpZDx1dmYrLSFSVMM9nUebwhZP1VgGwu9WFDwivN24pPp3ytAJ73
6971	fee_transfer_via_coinbase	2012	1000000	1	CkpZHBjqGTRPmQ8CpyBLZUB3CKTcCbhbnj2KoEMVeuKnqZcjGzks4
6972	coinbase	1394	1440000000000	1	CkpZH8giPvRQYTTkZbzj93d4sRRfjeg2aT34LeEAeCkaXmaGmYWqE
6973	fee_transfer	1394	84000000	1	Ckpa98Qc4WibAjxWwmCLiB18RSXHCqN8fLYoGZecvQteiCJoDFyRJ
6983	fee_transfer	1992	44000000	1	CkpYfnFRbxZETGPLYVbNpWvyVYVed5gXRiH1CmBNAN6u2CvUj9Uxe
6988	fee_transfer	1506	35000000	1	CkpZzY4cA8XaapaRS49fJhPZjMiQoKXNv1sUTcwgJDvwSim9brY4a
6989	fee_transfer	1602	33000000	1	CkpZG9ZDRg9oGNc3ceQPYnmAz27ykyAvioy1fYEExANsG4VdAgXcr
6994	fee_transfer	1619	23000000	1	Ckpa367ZBr6T5PjQegTAvs55jFVofwZhVmYPgutBvtYNQesVv72FT
6998	fee_transfer	1594	23000000	1	CkpYTSrK2SxSV5xY64W3AUvB1ViA8NpdgySLWviNHdRPGAoFzrV9J
7001	fee_transfer	1680	160000000	1	CkpZm5b7ad99p3UgSNFmoA1JDhnS3Ms2UCKwDzQzEoKsibtGwMzYa
7006	fee_transfer	1762	62000000	1	CkpYTFHmFvuXo2SxVLu77HL6UyhbK9uRdiT4zZZqu5rJfFmmEnYiA
7007	fee_transfer	2041	49000000	1	CkpZfMiyUCP1fqCjmbt4GS5KFR4kawg3yqpKntahSbAVZwyXfMLjR
7015	fee_transfer	1594	111000000	1	CkpaCFk64GVNCAH1FzbzY6NibNY4tuBy8RLzqeLs8ojuKvvB6TLZ8
7029	fee_transfer	1402	47000000	1	CkpZ35XYMUvu7femf3B79dvhFpB2peegVhpyA5EsRQfFohvVbpQxA
7031	fee_transfer	1536	24000000	1	CkpYmQ6L2k7aeDTfqyYrxibhA3hM3ivsA3fgcwM5MXYe8KrSUtuVB
7033	fee_transfer	1762	123000000	1	CkpYr7CpLebHvmBeqo3MiiQJNcDuAsncco8QDZZZvCvPUHarSAJyb
7034	fee_transfer	2112	134000000	1	CkpYQVrWyVsxRZzdVFqdQ1SxMszENH3WQzNaXsxEnut3Pz9csSQVc
7037	fee_transfer	1476	111000000	1	CkpZoEmMF2AYF5tDcXiG3ExRAXm3F6YKVhoy8a95uUapC731Q4kc7
7044	fee_transfer	1671	34000000	1	CkpZnXJUdjED3ZC6A1z5cnzmgQjUbio2HqUwpDWBMB13nt9J95zJc
7054	fee_transfer	1980	22000000	1	CkpZ39vrRnoUwfEijDZZuYNtVRqdaw6UJHnhjuFwbH4tgm8ahgnGw
7057	fee_transfer	1695	23000000	1	CkpZ4XhJJc9Pakkk7ttWW2Dtfm7bRhjwSPyKT1Wn4JKPURUEFEfgS
7061	coinbase	1668	1440000000000	1	CkpZPnSBdwoeU4TAUH5yAXbMxUm8AUtBUPyJwAPqzC4Tr1qFTkMEY
7065	fee_transfer	1615	11000000	1	CkpYR4rJMQdZE8sYRe9wDphy9tcqmqwnwDxmiyw67eEsMD7G1PPpa
7073	fee_transfer	1718	33000000	1	CkpZmd16PQUPR5tvoMgWiSB2nmPdZCLFBXpYW72zhiQxLQ1tfFzKW
7082	fee_transfer	1549	32000000	1	CkpZnk8EFh4Zxmb428wLegjkaRn2FPMkKgq8gSQdBJfhrAQ8HzMSQ
7090	fee_transfer	1426	34000000	1	CkpaBViETKDrHDhxY6FW2L57Y8C135rjKrvhZLCvyXXYmXyyTy2GB
7092	fee_transfer	576	62000000	1	CkpZaeZ2swgQjeTkjzwYur2WWa2F5Eft79bjkdVW373AQQFbD5Gwp
7094	fee_transfer	1740	150000000	1	CkpYasruC2d3VUXoiWRkgu97M766kVj1Z1G6svb4KmMC5MTT3LuRv
7107	fee_transfer	1688	112000000	1	CkpYfTdPRoC2N2oApNtxkpSPKNQUa2eCRT5Fos6ajYBRUTVqpECP8
7109	fee_transfer	2112	112000000	1	CkpZjNhuNtm8UrTus7ptF9yuRywSKfpQ6JZtA8rLEScQmwaBDXwut
7113	coinbase	2313	720000000000	1	CkpZ39z8c8JrkVD5UDyJvAoCTEMtnsvhG63WjwV5rJ44U69AXu82Q
7114	fee_transfer	2313	13000000	1	CkpYbb3NUnU3gTyzyyqf4in75ahtaszzFMgEPU5reANV5gkYdLWCq
7115	fee_transfer	1668	39000000	1	CkpZs56GsaeCXgYyQmuj3yniViREKLKk9UryUtuwjNbQSJTPL9K5L
7116	fee_transfer	1395	6000000	1	CkpZhJ26GpzcddfTeiziZEbBP7n5R3phWZH1MZd4y9wztzBPWombC
7118	fee_transfer	2261	37000000	1	CkpYhKfb6Ub595QFKaiaiNGHFvqkPtLcmxoeumqnUWcTDu8UDHHop
7119	fee_transfer	1708	32000000	1	CkpYkVvgHiitMqdwcKakNWWgUL8cNRegwcrmqciq4yMHHG3L3inQT
7125	fee_transfer	2248	207000000	1	CkpZYcaT5Ck9p1aSHwrSA2PeZtyrYuVUikd5bfx8NMrSKun4tsL2D
7129	fee_transfer	1444	2000000	1	CkpYk96opfmYubdhzcYTn8uGqhPcMcycYu1oKsgBsFcDFG3ktiF4c
7134	fee_transfer	632	52000000	1	Ckpa5cwxDQ1bmjSgNuJjBTetQmNsKXsgLotGGb7JWorVe5Vkaqdmn
7137	fee_transfer	1536	62000000	1	CkpYp6cvG1QgFumjP1eryzhyWWSBrD5K29szMW3cu6DCHccGjHRi6
7138	fee_transfer	1693	341000000	1	CkpYyVoVLBt8gXVxo7iuNji36MtaBAwRv3rMzyCTd3eGGTNa1hF92
7142	fee_transfer	1613	62000000	1	CkpZo8SoYrJ3a4XGJpQkaj8AEoAP1Ub42vFXJVA7YpmnjAYWmhpeB
7143	fee_transfer	1601	135000000	1	CkpYY1RMHrvccNLJ9AbQAukAMybofad9sRE2xdRraddB95T42ViuD
7145	fee_transfer	1555	135000000	1	CkpaHSLGH1WrvTv1QUGo8n5vHQpAH8T6gT3Tovvfq21j9nSBrvimK
7150	fee_transfer	1687	35000000	1	Ckpa1VvDkiNBGnamSq1KFwvD6qtwuZKmUcDE3A84i9r7sJM46EyND
7152	fee_transfer	1599	64000000	1	CkpZxXaDupnrq1AGryjF6MsU11N229aSsAN71s1GpfuFiej3RVb6g
7154	fee_transfer	1458	860000000	1	CkpZxiD8BcGMnm643c13xeH7947Rsw1VuLD7UeTcEstL1ZbeZTPzp
7155	fee_transfer	1458	320000000	1	CkpZtQ41fuSpyTo6gWd8mLpEgKrrrEENfmyqqT3UF5GUYG3CtwFAv
7160	fee_transfer	1723	42000000	1	CkpZ1NfNsB4XBuckBDwokesGEvcc9sGR5gZ6PAPCXsbZmjuabgRYb
7168	fee_transfer	1467	35000000	1	Ckpa7DQu4jXmfJW2nYvCKcAi1aTdH2B2jCuAJ2TX9XirtUm9zqmhs
7169	fee_transfer	1671	112000000	1	CkpZF8M5ejhAKakEfUfLkayfGRrJaWhcVZox5Dj5DuXJkAAttXWmm
7171	fee_transfer	42	26000000	1	CkpYaDyFuy3SCtWEgq7zrcbxWSVGe5SCMX8xbudYe57ja2Sh2Rr5q
7172	fee_transfer	1634	14000000	1	CkpYRzobzKgNSycb9QmSKx2xhQs6N6NZghWGpAXKg9tKv9BirU7c3
7175	fee_transfer	1594	60000000	1	CkpZ6EK4TtY1nu6gh5tKEf8JE5sYA9nWKeL8dTj1Z3Lc2YvLMZMe3
7177	fee_transfer	1540	34000000	1	CkpZGdoDBoFooRbsx7ogjnuCookZ3bPq2SNAAik9dCcAgdZX37Zit
7185	fee_transfer_via_coinbase	1855	100	1	CkpZCTgDzvLQUxTMwYinN2keiumTSX9Xs2EFPqXV3W4NKp5YXSnbw
7186	coinbase	1394	1440000000000	1	CkpYd83ubgTGX7gZSLqsqrnX1HEEe2CfoYKgX3tJm1sW1XC2yya3t
7174	fee_transfer	1619	1000000	1	CkpYU3tDMHx5FUYQkYHhoJkheMMujjacXXGoD138uQVaPjYYDAoRx
7176	fee_transfer	1610	24000000	1	CkpYxjM9zMeymhYzsxVxJcptEUQ5iGuFtHcN6TyjSbdC1uMgp3vdF
7179	fee_transfer	1508	1260000000	1	CkpZfZtseEJiTsSycX29XZFgg49C2ZMrbeSKqvGp7MCDhusXosB66
7180	fee_transfer	1508	9000000	1	CkpZdrDDtfYHmnKA2BPReLrqA159ydFL1BW59A7HirzXaeWk6UWWX
7184	fee_transfer	1714	37000000	1	CkpZHpp7JESzZPmk5YvhXQtTvDFSSYs5m31G1KUH8XGPYWnLqJBMA
7191	fee_transfer	1588	26000000	1	CkpYrtgUhmXTTcjRRNyast6DzaW6HmYemgVsm9xvCbjfQucEMgF7u
7194	fee_transfer	1740	530000000	1	CkpZvRGK8WtuKeCBkXMuMHnwU7mWFydjiwx9ihJAyqUa5hM3BSt82
7195	fee_transfer	1740	63000000	1	CkpYczd6XRj5LUV2ZubaMcPbw935WUUx3iF42YFZjcap1hCxFHxL6
7196	fee_transfer	1440	37000000	1	CkpZDuRWe1s3LkTS1nR264coJ7o8tHR4obj2vL7Q44u4bP1VD1B3j
7204	fee_transfer	1594	27000000	1	CkpZxcGiN3WycCaJCvBhGaRUyNc7WPpqnUgYdayRvKq3EhGL8xEws
7210	fee_transfer	1560	34000000	1	CkpYZP1wesuQMPzYHxPQMbFnZo6no25jAyemHMDEx2ZrBUfWmsWb9
7211	fee_transfer	1738	11000000	1	CkpZmiYnUBJZF7uRoUufsfi4ArgqCHL2pMeqHFijreTHLJ7JmG3eL
7212	fee_transfer	1522	45000000	1	CkpZg4rQ8HKmoSskGXq1EK7PKUpM2SUnDpaR9Auzq4JfDK2brCAbN
7213	coinbase	1522	720000000000	1	CkpYs8qA1iG7gJVguJkVeB4VzwyMHdFwHQdToeJ4P9o5jawPPvLxY
7214	fee_transfer	1522	6999200	1	CkpZcbxY987s52gszUiri51wr4bFWJr64YQXj3Dpm37zRVZF3ugWy
7215	fee_transfer	1855	800	1	CkpZ51Vzvtb24CnbH6sVYSqyMwpgCpszyEbPbfpZrbTSEZJNQ8kA6
7216	fee_transfer	1695	24000000	1	CkpaKXQhJtMnBwbLVfPHpaFyb4fjfn3aqZ5fmPSdL4FVa6hDySJ1W
7218	coinbase	1467	1440000000000	1	CkpZaeXbd5BHRU2EthLXwx4gvSZpYS8zMbFEZLdqfHqtEYEzKEZR7
7230	fee_transfer	1680	3000000	1	Ckpa1XKNVnzf3eEL4F8KhbQhvDpxZHbibLVg9K7zz2zUMxkCYkoU9
7243	fee_transfer	1622	14000000	1	CkpZQPmGeYgokV9vQFdRng4c5HLMxxJwJtRagVKFvE1QM9dFTQrmK
7245	fee_transfer	1716	111000000	1	CkpYbbmLFNtzUfrM2v3fo3CbFXb5oJPxnJfjah1ZS5m1nLXSUkCAj
7247	fee_transfer	1716	38000000	1	Ckpa3KjbrAKFXPchxzNDuSgJu5G5kNb4ZCcKs2YT8ktuAieXvhb53
7259	coinbase	1394	1440000000000	1	CkpZzoUWjk5cahpcp6UiLL25kFFKik79AH6T3YkyHamsHkfi2R3Sw
7266	fee_transfer	1657	25000000	1	CkpYvvGF6miTDeFQqic96Zr3vp4vZQn1F7SRAJMbip22eXqBpvfJ2
7267	fee_transfer	1747	130000000	1	CkpaL9e3PUsfRa9Gnbyhh65phB7SNVeHguDym8yGFMZ9u1Zh24ABV
7268	fee_transfer	1747	267000000	1	CkpYbD4QTMzSx9zfAm9StfeVBehh5Ef8Xf6ie7HxtW1yveDKEciAe
7293	fee_transfer	1643	123000000	1	CkpZN4ogvPmGyhgQUoHix5ymz9zzxpxYMpto9FD88cneFroBuBXAz
7294	fee_transfer	641	1000000	1	CkpZEd3JbXfis8gpBX3B1MsAig7VmaDNJJi5FbRyCDqGxUvviETGv
7303	fee_transfer	1602	115000000	1	CkpYzGhFscD3SeUUAe8NHQaQwmtu3xneE7VHj6J8hykSQxC1LLTgH
7305	fee_transfer	1724	115000000	1	CkpaBGkQ1iYAGRo5CPDomqHwKQs53FLftGb4puzJb13CuPgnt6inZ
7316	fee_transfer	1818	24000000	1	CkpYZ7s8wV4ab5q6D7KJ9c3ye9QZ8GZNBwEDxgtehGSdwa349KHoo
7322	fee_transfer	1741	11000000	1	CkpYQn7hJTLXpwZAxBJpkLqMSACq7Gs4BigAQ7a5URvGWPSV6WZPa
7328	fee_transfer	1602	36000000	1	CkpZakyGZiidX1w5fndcj9JUeeSNAFM4bDAtJ9YuC8m9UagFmy8yd
7333	fee_transfer_via_coinbase	1791	10000	1	CkpZsjWRzocLR7TL2XASY8qknGHJwFNPFgziCuDJgWxKBXTJUZerW
7334	coinbase	1613	720000000000	1	CkpZf1aQuP5zE1p8Q3s2i65R2fpy1PAFCUUUh4u45TtpDf3CMu8XE
7341	fee_transfer	1440	48000000	1	CkpaLedWr2dfWL2PCNCy8fH3fUP3ZRqPtfmYqSnPzPsjcq5J1Zog8
7343	fee_transfer	2306	24000000	1	CkpYwExH3wPYSSntu8LbvzxpdXyP1mA7YDfsMWtV57H2p6QRTxgiW
7345	fee_transfer	1643	46000000	1	CkpZA4iCvs2rHbPfnbQjsbXEqBkiCSQfGVtFkPbaHYfjFCagcdbMv
7349	fee_transfer	1555	690000000	1	CkpZJmYJo1ueQ55jc6oazKppeMwJsubb5aMkXNP8JMBFBsZDA5o4P
7350	fee_transfer	1555	25999992	1	Ckpa8DfCWhrRANyaGFpBrZztm99kVLxSnP2b4zhbnFbE58YDkDJAB
7354	fee_transfer	1520	10	1	CkpZajBrum3vSYWmJ7bgcdCq6FHqdfwHzARbnBtR9MyuxrB4g7uLz
7355	fee_transfer	1746	3999989	1	CkpZ1ef8uRJCxfUQ6qcMFx5iRgpX6SdjMDWxXoJ7z4m6u8VrzUde1
7358	fee_transfer	338	11000000	1	CkpZvXXoek9EsxbRAChpyqujuaCiUNemJ2MnF3kggoLDTWLF8Ak9k
7365	fee_transfer	1509	1999950	1	CkpYxrNLczHe5edUzuegKArxpgDqxLqjdTjWrUVaJXXkL2x8w3kQQ
7367	fee_transfer	497	36000000	1	CkpYyZrQAHYW55ecwS668iWqnB47JPjAahz3rFqe2UQHhMy74kkao
7371	fee_transfer	1419	4000000	1	CkpYYurZ7tGx471Xr6ZZdNLHgCNe1LVKGD2x6NsVoB36ELCyPFkY9
7376	coinbase	685	720000000000	1	CkpYXq2jpoobZDjurrYUrLtkQ2DS8eSGN7jvwaZkcbreyhKZv31sx
7377	fee_transfer	685	12000000	1	CkpZ1S562sKWwZmEcPwsAwNsqRfZsWrL6um9Z6qRftJ49WaYAjz3t
7381	fee_transfer	1601	59000000	1	CkpYYF84Zjtjpd2SGQPQq2oLrZXjRVahRjsrrTrEUKAWdG4sesByh
7384	fee_transfer	2148	25000000	1	CkpYsM9xDDiHyRkTpxdL9Ty3mxfCQ6u11bH5eZZxVGqBZ7eUenWvh
7388	fee_transfer	1706	24000000	1	CkpZ6mN1yE4PoYRZA29jXXyeSWsn8hNPgMpm6LPwkT7fSAuPMxKLS
7393	fee_transfer	2039	21000000	1	CkpYYq19MnHj5QBk7Pn6Snm1aoiF1Wxn3ZzTRd8ACKV1Gnqh9oT5z
7395	fee_transfer	564	34000000	1	CkpZZF4tYrBxhxQFkAks9PTZZv235t7DwD3mUc5TTqrPQ1TbsZqML
7397	fee_transfer	1762	43000000	1	CkpZaqMiteQK9uEd15pazfZi5ZEzqHaXpgq2sWgzYw5ZfWBuc7ffh
7398	coinbase	1762	720000000000	1	CkpZkLzvStugF8mVyLXsXdpbKspFhawS37TtN2ocer4KnbJZKDkwh
7401	fee_transfer	1801	2000000	1	CkpZ7qkn56aTkAoja6MpaEwjKFzcxXs2KQrgrkzzkvReGvmx3BhgP
7404	fee_transfer	1521	22000000	1	CkpYwnWtGJEy7LjoQ7pyHYgUFFdMhqgjHUk6JRguAGsFaVU19Q89z
7405	fee_transfer	1573	21000000	1	CkpZ1NtVmh9Esaj59AqiTbKVmjvyPeZZwGN3z4BjVXHHLXz6FoXh7
7407	fee_transfer	1709	33000000	1	Ckpa4gnrGkta3vsjRjZSMNT84wwbYWeEi6dBkVvpF6SWjz7ddxhJV
7408	fee_transfer	1423	850000000	1	CkpZrGtyPCn8CdzSoQsodcqPi7vggc1BX4vDvMy6iaRUR9wc1C5D5
7409	fee_transfer	1423	400000000	1	CkpYoT48E523Z1QQsPhixZJw5Fa63krETDrGNARumfAyjr4cYpVfw
7410	fee_transfer	1671	640000000	1	CkpZUczCFNGg6uhJGpkM5pxAWQ6rxmz487LPzv6Wvyqv1H9LSNXuH
7411	fee_transfer	1671	610000000	1	CkpZDYcRnw96Xjuv9hBCHFLEt5DJTzaw9mkgMmKY23xfYQRh5hG68
7414	fee_transfer	1685	65000000	1	CkpZMYq2DeESFGGrJZnzZszkJnGM6HdYPsvLFWUZCEnMskKzHvzug
7417	fee_transfer	1749	91000000	1	CkpZzotmrqpJMAcmkfNBEin4LFHfsQ8wr8E5DSGvAGLKZGXNoJH4q
7421	fee_transfer	1564	123000000	1	CkpYyT3WkTd9djGrGcS2Z13pfxaK2H9YMJHVdw4SmrtUHN6H5FWKC
7422	fee_transfer	2300	54000000	1	CkpZX3gtKFkbH9MJVvjZsGJHTqNW3G4Gf95sW8LWLYPu5ZSQHNJLP
7426	fee_transfer	2329	22000000	1	Ckpa3Rr7xhfLUYX5LgyQRCZBrh3n3VeVqxXyj7NyAyAxVK1EgrJ1V
7427	fee_transfer	610	10000000	1	CkpYxFJu3LXwsytYVhfvF4CX9V5nBo3Qb82MhpU6BmAmdfiM6Bf83
7428	fee_transfer	610	1000000	1	CkpYb6Pgn3ac977WsAcqcMCzP7sWQaZwmGhipQZD1vp1jh6xvQ6mX
7187	fee_transfer	1855	400	1	CkpaJXjMRRdhpuseqXv6i8wjsR88EqqwjNBTEsxFHRAkVAKTjEmNn
7188	fee_transfer	1394	940300	1	CkpZG87agqQSUn9HA2hVu5QuN9tvmC1G3WQ3zcEwnszvxDGFjA4bc
7189	fee_transfer	1514	69300	1	CkpYw8igrXk7CR24F6fAzKmLTZpEbJKG4ezLh7NPFePn4tujrnZmB
7197	fee_transfer	2306	37000000	1	CkpZjrqZJMuxzpazEURM5tGYG6Gq8vaWzARJLj9J28UBbYAXGnFea
7199	fee_transfer	1649	97000000	1	CkpYTt5813y1CE2Hpys2ByrC2aGe6igYz5GRbSyaMXczV78m5q5nu
7202	fee_transfer	1703	34000000	1	CkpZewA8eCQwPmm4j4whs5qxWqwmn2fYhQZSrRzFwDaeznfWw2jXL
7205	coinbase	1623	720000000000	1	CkpZoHVibiY6BdWBG7TS4k8tjJqPtkJ6LpnU92wcbLTMm2GuGcCJU
7206	fee_transfer	1855	1200	1	CkpZJkdisSbDUR9dChGk6ZvQT4BA4rRqWDLzQ82UDk3pZBSnnX9F1
7207	fee_transfer	1623	998800	1	CkpYwVn4pXP4QUWNYuijw8DjDd9MgVRWuPEsdZbS141vLxofTq1kG
7208	fee_transfer	1439	45000000	1	CkpZyGtnd4JRs9yVjUbDxyvmNj7T38mALSzMuTahMVosL8nzc4m2G
7221	fee_transfer	58	49000000	1	CkpaG5P2F2VftC7eEfMiFfgqNjS2dstoUNSQHj1E1JzhXH9jZxGsB
7227	fee_transfer	1474	172000000	1	CkpYS3voWY5XdZ9w6zt8fmqnm393GRcC2dpZLxZPQfmsbTYe9o1ak
7231	fee_transfer	641	909999997	1	CkpZye4yRgm56qEbfhVs8PZxhbNd1MATKWdroYmcRpSD3UFEArqN3
7232	fee_transfer	1520	3	1	CkpZZpocmFtQot49naKmEGHff4PqZeLQdVpVsKKsJGpiVs9cjMtox
7233	fee_transfer	641	419999984	1	CkpZA45a2UyAFbSZpbKceHk8ES5aeArNc7euPdr9Ny39gGxHeKBho
7234	fee_transfer	2275	6	1	CkpYk22mAyQEQiTLsNkgcBccXTBno327DoLuG3yc7xSqKTa35iFxY
7241	fee_transfer	1622	4000000	1	CkpaKfsHKRJzU3qRM3opMZ6fykjxFwHoig21vNYTGyU4XXNgBn7bp
7244	fee_transfer	1271	25000000	1	CkpZ32twuhMC6sUodykJzB1ieStutAURkM5pqRyw22CZXHJt6khag
7246	fee_transfer	2248	38000000	1	CkpYS2gF8MHMgwYiZ8rgsGu93dMQcBSpyCyNUEzj9YfeA5eN9AgNA
7248	fee_transfer	1714	8000000	1	CkpYohcwZRF1UQHAi9WToFHwYyMzzwPsQspiGa7wwsk17nsvMeY9B
7251	fee_transfer	1670	3000000	1	CkpYT2HfuiZs9nZvc7KV7pybhEcD8z1EqjN86HcqKuNdQ7Ng8ShS5
7258	fee_transfer	1657	14000000	1	CkpYUgbw7TuT3kbeCX4LntTLAxYzHMgUHrtdYBAzCFK2fcfxm71cC
7264	fee_transfer	1471	37000000	1	CkpZN9mdGxNa9JnEvMLS1Zac29GKSohC3Sys79ssDNeMfhRQ7x2Mj
7269	fee_transfer	2292	24000000	1	CkpZK3nwnQXHDwFpkf9o1pmmeXvj6kvGZxUJHtELBsN5sK3Q8nCuU
7271	fee_transfer	1509	128000000	1	CkpZzWzLUiJouyDAYa7puX5QE4zmBCdcXMr7VtJmEpshqinbwT63D
7272	fee_transfer	1464	12000000	1	Ckpa66dXKSnsWb3ZC5oz5AAyrQcyVYmhDubSvarYvA3Ux9MBqyGXs
7283	fee_transfer	1610	14000000	1	CkpYevXpzkGdKW3ePZ2cxxKpEdhzPeb4e3q8nrF8vpLBEg7DyiE1u
7284	fee_transfer	1594	14000000	1	CkpYeHveyC9BXi7a3FXSzx6vBsVhzmwsrthw1VEknUoMykRTaXxqB
7286	fee_transfer	1698	112000000	1	CkpZEYwzqwnPfA9BkZd942TGeL59TenSh1zrhipLxan4EYrp6roR4
7295	fee_transfer	1685	112000000	1	CkpYtnEm6SXYdfHXUqonv9coLAfMDXyC2VtJJWfxQe9wfyLXXXPNr
7296	fee_transfer	1807	2	1	Ckpa8tHV7vwWJGKsPEcuzf6y2pngp3NdDueYYLMgXYKjD6WBEpuG5
7297	fee_transfer	1419	999998	1	CkpYwxT5BhxnfciLa6uowVj7ErN7tNiJmCMY7FfkrKqHRfQf6LEix
7298	fee_transfer	1768	112000000	1	CkpZBQN8p14npNcUpjrNYrQCwdgvhZVyqtiPVpuyVuhVixQbG2RpL
7299	fee_transfer	1688	113000000	1	CkpaCH8wewo64N9FpnpsWSBWXXubAGwcbZBTzknERXabSZtmdvGRm
7309	fee_transfer	1768	202000000	1	CkpYauffA3e9xR3tmCGnh3sjBhZYPduzf83ytc9hMxvmhgMToxFXa
7311	coinbase	2256	720000000000	1	CkpZim83gCrVYgCEwYaBTyCsrvrbUeE2RwAC6Kd69gNkFjZbk9dEL
7312	fee_transfer	2256	25000000	1	CkpZXr6UmFCtqarg3DCT1jMPnzbJT3fVAnV4p6NzrciC3Vh7tm7XM
7318	fee_transfer	1608	3000000	1	CkpZQGVHCc6gdUZBQv9TxCGStsFo25utdKy4scG2ZkhgSAofs14Mv
7321	fee_transfer	484	36000000	1	CkpZPAGhMR5xoLScqrGrxar9ypzgg9S2ubnjGrCvAD9JenFWYxxbt
7323	fee_transfer	1555	283000000	1	CkpYuWzWtCQ4F1xjFDooxpnvHJSb4inycYUoVq2d2romuvvgqRoSS
7324	fee_transfer	1555	29000000	1	CkpZSEVFUPkVtbLS1Ldzyb8N2sPo2361jLxh2Z1BeEfpXVqPQjWiL
7326	fee_transfer	1546	760000000	1	CkpYgzLN5bZtFv8pJs7EU9HgHCVb7jhvcxET15jt9bz3viiPBtWyw
7327	fee_transfer	1546	31000000	1	CkpZooDRybGkFzt2dxC57fdfyipSVq5xxdKvUr5iE538FxGEEzZor
7329	fee_transfer	662	36000000	1	CkpZHZxqUGwA1J78rWZgRMiazS2mz5hXMxVTjJmbhDnvi96efi7er
7330	fee_transfer	1671	24000000	1	CkpZam4NreQZNgdEfJGjYKhAKJXtja6k8ouScop8Q2crw6rEcGiVB
7336	fee_transfer	2039	30000000	1	CkpZUVQvXWnXPLysti2ju3g9TydiPSJ91k4RYzYMqfarsveStingf
7337	fee_transfer	2039	6000000	1	CkpYdVhnsjj5T51gBByKXQYePZFYdPhScwVLqVmLAamojEnUuvZJW
7338	fee_transfer	2096	10000	1	CkpZ5iQKHfB7oXoSKfExkvPokAzg4uv9PtLNKApXFhUZwcUwxs6fs
7339	fee_transfer	1684	5990000	1	Ckpa8z2jAyUadtHakSxB99aJyjScMkbGa4FWH8wiMx9CxEFx1H6rD
7347	fee_transfer	1764	48000000	1	CkpZ7nDhWc5qbQ3Pimi3Kqgj9jjp6ZRSschp5oWBxYejErvDHdpVL
7348	fee_transfer	1614	12000000	1	CkpYQDtku2FUrmBcELmFPt9mpFLS4TdC6hjCck7n6P1GYtvp2vPts
7351	fee_transfer	2292	20000000	1	CkpZqWcD2hcbx8y8nGe1cDTx4rA6fn4yaspF3sDLBe8bMU91SMncx
7352	fee_transfer	2292	4000000	1	CkpYaCRR98isT3wyFJvYtojokFkwbiwsSbdhcpdcLExceHXFdfJPY
7359	fee_transfer	338	12000000	1	CkpZZyqM3t7gHcxDKgybX8EqeUGmo5HoYrMLsYZiv4h2zGAuQnqww
7364	coinbase	1740	1440000000000	1	CkpZ1TYvczppkYGmDrtijMfCghVpEKvU8JLu3fHWJsd1gByPaSMwy
7369	fee_transfer	2041	36000000	1	CkpYm1h3pS2CDQsHDHcBeTPW2WrQD6etuFS2MQKdmAZPWdmA6Mbzk
7374	fee_transfer	2106	10000000	1	CkpZjb9BsAv51cS1Cbq31CStHGpjxWcKhHWua9ZWVSSYJfBqcfJod
7375	fee_transfer	2106	2000000	1	CkpZX6QJMv5D4sbHxjo6bPEg4EpwPT9U346WEX9FxJwMPFDVFhYaj
7379	fee_transfer	610	24000000	1	CkpZxALpdBPv5R5qheh5LnAfU9NW9BQ42LZYxi85riZjdB2RK1ZUp
7383	fee_transfer	1598	48000000	1	CkpZW3pHUuJMt2LqNGatyST5iYTXiuAMtCq7xTCDDurwTmL2hPgM5
7399	fee_transfer	1801	43000000	1	CkpYq2jU6MsLZS7BGWiFgR6U9ykDmvxrwWzVLCjWNYCh72AWCZUHR
7403	fee_transfer	1521	32000000	1	CkpZyLTiLYTwKf5ZZJt7PSGdqrzaivhGxxaWCjw6WFc2VwbJzTJYU
7418	fee_transfer	58	51000000	1	CkpaDKgBZwVra6ppvCkgFje5TBLdayR6ptEfFCPq6KRmVrWg7xtw9
7420	fee_transfer	1509	101000000	1	CkpYh7pCw2dJULciTy5GmeSnFxrb2pZLGxmTyBX4svajHwGbzuy9T
7425	fee_transfer	369	44000000	1	CkpZFmDbBa4cmpPUQbzc6ndWjeLG8ctdwtaBU4vYdek6MKVvbrWBt
7435	fee_transfer	1506	481000000	1	CkpZqzt3DNnBZhSJVs8N3JGMYnwCCjQVamb9Q8UmaQ64HbHHbkrX5
7442	fee_transfer	1593	14000000	1	CkpYmJjLzHabNr6mgJd28zJb83FENPBtn12ju8MKCEZgQGPdxpAN8
7446	fee_transfer	2261	50000000	1	CkpYikSf9DpMBzErGqwyu5VyLx3uCSgCKrGnbDbZ4oBwbLCE1M3Cf
7447	fee_transfer	1455	14000000	1	CkpZKbRuu2HFpLmtL2V8yZTLAUWQAW1DR758dyJNTksUv9dwREW2E
7451	fee_transfer	58	14000000	1	CkpYXwH4kmiN5tDVj2W6kKqLtZcw2xwzzHTfg3NboNHGA7Tqx22w7
7226	fee_transfer	610	12000000	1	CkpZiceJLyhf28LgQfBcSQCJgXDTNkL8ehfewe6yD7D8NHyy9bpBt
7228	fee_transfer	42	37000000	1	CkpZ5tMqTUzdWMnQxhG53m5QPLzqrwaKbQ23CgYLy6tj7RfpRKGnK
7229	fee_transfer	1474	19000000	1	CkpZwRxPtSiegVQPr9BPo86z69p7rxS7sruG61LZN3Tf1aKYUYDS4
7236	fee_transfer	1596	2	1	CkpZeK3Yc4h7Fp7byaJcZEohM2Q8fiNy7W5DEyQrVVjkd17UL2i4d
7242	fee_transfer	1439	14000000	1	CkpZ4o5NTj47D9SDEbukfeZME9TsS4kAMtY7gcZqSZ366mtc8ucRs
7249	fee_transfer	1670	500003	1	CkpYXUNfQxPzcpKDZnXWEf9gb2eDXzfddErqYaxqZSfQeTvR1P3UF
7250	fee_transfer	697	499999	1	CkpZyEL2HANa7hp43yHpchuDD1NToFm4sPa4gkU8gx2Af3a1t7FCa
7253	fee_transfer	1681	112000000	1	CkpYxzwRpgGSHCFQKKbszrWeFMYAu95Niv9KepG8qXNQYSb3SnqB8
7255	fee_transfer	1715	15000000	1	CkpZSAuXNarARJ5xpM4NdUFcZ1MhhKUSPbWt2XHGQpr2oA64mUAft
7256	fee_transfer	1992	14000000	1	CkpZWu9SKVGYqzDVYCLnZsYzQWgQwHSPgRmUv4F2ZLkQHwzmXqiVf
7257	fee_transfer	1623	14000000	1	CkpZrCFaCSu6Mz8ZMSkbiQV2s1Z8F4GQTMwuGs2fgk9fLdXgrb3B1
7260	coinbase	1693	720000000000	1	CkpaAgp99miux28A6bCZUs1U3cTzdH26TQvZHcZqSZUa6AczTH5ho
7261	fee_transfer	1637	591000000	1	CkpYfPsugoadm9FWwXfQkEcEKY8PWE83EHJhEVQe9eSNiUrZQRdcE
7263	fee_transfer	1700	25000000	1	CkpZd6HmzX8vVeEvUVChAF1TyGMbdNqwncn18k5ZCHKCLEeiV7e1r
7279	fee_transfer	1807	38	1	CkpZh5XK2acic1xmGdeF8fgUmuDgUdeBUXYsZ4E6raTvVxz15xhMk
7280	fee_transfer	1594	13999873	1	CkpaFvWXDmPsW7pnRLD69Gp7GHEjVRagZkh9nxcair96Vx8iZ9eRj
7281	fee_transfer	1571	88	1	Ckpa4dJNRdjVnjvRFNbbEFomFq6eDqeT9XEeeEiUpqbBRDu19X6rk
7282	fee_transfer	1599	14000000	1	CkpZTiMDqfWWsUFCbbV4Q3dAka2gaStiBvgm4cotBVSHqQSh3uND6
7287	fee_transfer	1692	112000000	1	CkpZPRDU2wXYykbL8JuNZj3eSHk78fWE2WC1Kv2tbJfNiKrnQ21ZD
7289	fee_transfer	2148	123000000	1	CkpZE3S1CmkMEuPZJ7vuC8zWzHdJJ2kRMKu2LcTUGWnbEZChGoFB7
7290	fee_transfer	2148	125000000	1	CkpZVW6KaJYQWKr9UV2pii1pPRF6odyULh7UKDyBLpiMeiwjby4R8
7292	fee_transfer	1980	123000000	1	CkpZpW2BhRkFPsGb3SjC6tjRE49xZWhZwaYdyBVZ8yyhbJDweFpPx
7300	fee_transfer	1637	849010000	1	CkpYVZCHE8XGqdw56y522tx4cUvSLmrjhPmVmZLyzps2iQ6C3UL3K
7301	fee_transfer	1733	12000000	1	CkpZj7SYK8YieRppja8VVxcRPh7LTwL2nV4YsjJSgyzZp9ZaAo4LF
7308	fee_transfer	621	13000000	1	CkpZE4JmiG9hQcVDimAkLu86kbKy1pWX3o7fysHBp6jM6hUjkFrzz
7310	fee_transfer	1596	25000000	1	CkpYt2r8NWBVLfJD6SY2trPnw1YnHDgLchJmNRBkVVPscq5nonCUA
7313	fee_transfer	1739	34000000	1	CkpZKkTSwmkqncaur2hYiCL9qhAh4E5ibCjdiAsSsvWVEDhfxeAtA
7314	fee_transfer	2112	14000000	1	CkpYqYVngVRcyV1UvxR4en1oUtpVSg7jkAh7QuEftnN1V3YTjwaHA
7315	fee_transfer	1419	103000000	1	CkpZHshyru8VNbviekLnsRxEk5QhfhieM2aqD9a6xkgboJJVKkEqQ
7325	fee_transfer	1564	24000000	1	CkpYbuyodZ5obKFhwNxPRRF9jNwoLYvwtQrhQyqogCbLG4vXh59Gs
7331	fee_transfer_via_coinbase	2275	9800000	1	CkpZ3kde998w5DnfrY5iYt6LDJrgpMtVpbEBhei54RJkabPjERZNZ
7332	coinbase	1613	720000000000	1	CkpZFxscEPMEuHGYDmST3WRz4NAQitTePgvQ8Qvyq9xhpm9AFafdU
7340	fee_transfer	1440	102000000	1	CkpZxTUWnLpXnf3agHxCWbajcVZYbHXLYtQvtoJuiJD5NYjkZDAMQ
7346	fee_transfer	162	48000000	1	Ckpa8KWov1zGY483SuFxVJmFEuifWcXnCULoQQJXEotDKjUyW7jBk
7357	fee_transfer	1622	24000000	1	CkpaA51ks6xq1svTUMZRMuZ2dBXTBT6C2BSNic1Nqh7YBF5CXWu6A
7361	fee_transfer	1686	33000000	1	CkpZqCvD6jmhdENW1Fuy2F3YMoM8tu7YLsc34yPRi9P3GcYi5S3Nd
7363	fee_transfer	1610	37000000	1	Ckpa2RvNNY6wX3f5mDjgfHHed7dC6wcFYSooZVLZmgM3rAtxqVpE7
7368	fee_transfer	1520	24000000	1	Ckpa1Dr46NrYe6MAC5MipCv27k9WZ3T9DxBshLbyyv6m8c22WrUzd
7370	fee_transfer	369	14000000	1	CkpZoxtZHMNHK9DgGzoK9ytPvoZNPHt5vq96qq8BHDiicuRm43KXw
7378	fee_transfer	1506	5000000	1	CkpZgjcRn1CR3L1jEctTvm585L9Dx1zmvYFQnUBL2PqYyZzYKEcUj
7382	fee_transfer	632	48000000	1	CkpYt53BcEXsrriGHw7CGgJYb7o9cmeHA5nFXg5AXTS8cb9RcgrS3
7385	fee_transfer	1513	8000000	1	CkpYXPnvuA9jkyKNG5wa1qMWAoXBfKoftDShLRNxJLasTzjRDrGua
7386	fee_transfer	171	35000000	1	CkpZUys9J9tJuBRFd15jxQ3CyYuoqd6yN1TGGF3cn8VmMdiUi6AmA
7389	fee_transfer	1657	33000000	1	CkpaJ27o7aiEV1HqgJuavcXWUeCf6LGRkHE4UWSsAdExVdeHvYjeG
7390	coinbase	1395	720000000000	1	CkpYtzkyTYuGH7RLQLVibpVsXzAKERoHTk3UBS5ok9DyUHdzmcJTV
7391	fee_transfer	1395	37600000	1	CkpZHGf49PpuLkDsDTTupkq5JGyGSGpmsLmhkdb2AgqpUmUjMRyHK
7392	fee_transfer	416	18400000	1	CkpZUhVoigyEnP7XHc6Y6DFNt3Z6rdP7dd3nB3isLsD8yax9tNidW
7394	fee_transfer	1708	21000000	1	CkpaHp8fzAGGkV5t5PHiS2ERn2DJmEPzLc6ULC3xDxVbwxehEkCrJ
7396	fee_transfer	1715	22000000	1	CkpZdGYoYD1oQRyYyJPhZcUBDnHYm6n44HDE3purNvFgSfkbPwdsA
7402	fee_transfer	633	32000000	1	CkpaEknW9rQTgDn4TVwz6bMBQEvts5nz4t5iSLktkjoLizpaXLdJp
7415	fee_transfer	1719	91000000	1	CkpYRksqYi7WwfPqnmCdWAsYU4x2vEgtE7wAhrJupU57ps6wg7mde
7416	fee_transfer	1439	91000000	1	CkpYWpNzaSCMYWNNpVkP55AmpxDi8tJx1wwMokxPSX1J6gVZDefuK
7419	fee_transfer	58	427000000	1	CkpZhZCbVhjXSg316fmJHNQfooGRJkrx1j1fvzNapVAkHRTPep35g
7424	fee_transfer	1643	42000000	1	CkpZE9ucY5FQvRMNVMoSgNRhcviXnRQqRdXp9Ht2bmsiPnweF8DNx
7431	fee_transfer	1675	920000000	1	CkpYWqPhykojrT6pM77qm2CMEr8UV4VCVKi41qyAfaRjGYxLDqk18
7432	fee_transfer	1675	159000000	1	CkpYvNnLmWwuAgyLipM9KFfhPSuZLwdWoqMu1WqeJYoBNAd6c6p4k
7436	fee_transfer	1991	22000000	1	CkpZjZ19S9P9udmeSCga94CJnFuY2CwGVtHsAwFrXFwfBJMiMJbg5
7440	fee_transfer	1489	10975000	1	CkpYXrJpcZCT2dmv848CmYC9GLZEuyEgXUVj7oUEq84Yak2g6s8v9
7443	fee_transfer	45	120	1	CkpYoJgwwVMzCST8JgTUZeJ14JekeiJeKvkBNB5sAgDF91D2ShD7i
7444	fee_transfer	2261	49974016	1	CkpZX7FdKJnJ6uYtt9FTbu6Wf1J7b6XnacXsmAmxjpk6cLxFu3dcd
7445	fee_transfer	1571	864	1	CkpaHcJhvwNgez2WLPD5FQ1sEm7DY3H6keJLawjrkK7XBvA6DtkJS
7449	fee_transfer	1701	1170000000	1	CkpYybdsTtNEdVLRasvHgRiRE6uRdnJUdNvbp9V2ZpWrkLduGq1YB
7450	fee_transfer	1701	80000000	1	CkpYr59VU1MBjia5ocLeW8tXrvWYjFjgfyBWy9MW8vkgrtpJo5uH5
7455	fee_transfer	1701	819000000	1	CkpZMUNcXLPqnfzaTYKMiBcrYgj9r3ifvL7148QQTnmpeF8wBBrGU
7456	fee_transfer	1701	8000000	1	CkpYrH83aHMYHePW5TD3QiQRhyr7VNJZgJs34piKFsbEnqzpf1A6Q
7468	fee_transfer	1739	760000000	1	CkpZXKNK7W8Fwy41UrheqjxyhtpC47CDXDDDPRu7tZVJsGbSgft6f
7469	fee_transfer	1739	490000000	1	CkpZw4uwDcaqmsRptgBbYYp3PaztNaPv7AEU8ctbdKAYkTqXTCF7c
7471	fee_transfer	149	34000000	1	CkpaLaq4sE34gobHMt9RZ7T1p3Nuh2XKXgNuTx7wu8YmWdUDnfLvH
7472	fee_transfer	1394	47000000	1	CkpaC4xCG8KYWcWKuo4sp1j5AeWHKoaG791QMBr1heV2D3oSRPY4E
7481	fee_transfer	42	1000000	1	CkpYXbu1y4wmYsF4Re8CDJdPvtTmSeuaZ4CFQ7wtkmVsBqWVuwGLD
7237	fee_transfer_via_coinbase	697	499999	1	CkpZyEL2HANa7hp43yHpchuDD1NToFm4sPa4gkU8gx2Af3a1t7FCa
7238	coinbase	1588	720000000000	1	Ckpa52ToCZM82AwXPDuHniHvFMMdd6NDpBdsupc4iTQSyF15GUzvn
7239	fee_transfer	1588	500015	1	CkpZzAXZiZijPFdmmAzCcDtvujUxd2rd1fphJX6tQmVjfdU4cyv9p
7240	fee_transfer	697	3499993	1	CkpaJeSh7RQFHguLE9KFZW4BXoXdEif3bKQJ7d5PgqMURYEpRdhHY
7252	coinbase	1709	1440000000000	1	CkpaEZnNeaNXDzJe3u5fwgdAsL4CSdxvqWbXkkwCESLXgTEnG3Xdx
7254	fee_transfer	470	704000000	1	CkpZKptRf3Nij5wHFZJmGeh7yMaJ3CFa7dd5EELbDFfv8BjmCDZSG
7262	fee_transfer	689	25000000	1	CkpZfqPAtVdCuQP5DrPndayq4HT6xcX8bzAg6Po5NZ1ciKmkQCdZq
7265	fee_transfer	2148	62000000	1	CkpYwDXDUNtds7LU46eq9JUiNbe3P2wUmFaAGKvBgLNWEj8qZk2oE
7270	fee_transfer	1637	429000000	1	CkpaHqqPaiB2vYsFBWHrVEU8S8pLPtvFzjnYsBqGkXvvmHjPUuVux
7273	fee_transfer	1747	21000000	1	CkpZKNziqzt8ssdVvxJ38FNSW2KeXCtprNLgsqVikiPa2SNzvchYJ
7274	coinbase	1747	720000000000	1	CkpYvYKzn1pJadyBXiPkw4scm44VqAZKyxKT4nVbjZT8kKqsNWtZA
7275	fee_transfer	2292	21000000	1	CkpZrNqahxZ9ddP179D6PyT6qbgNcpHf4bUzegX3c9oQzrk8g9Jkp
7276	fee_transfer	2292	2000000	1	CkpZbFc2h3rYxe3nyRbVwLZQv1sCahMCCXUTokcqRGCzdh9SYNapq
7277	fee_transfer_via_coinbase	1807	1	1	CkpYrsyt61uavNV9VdZrNjQMA1rboe7fJvCngkUsAMncgDM151BUo
7278	coinbase	1395	720000000000	1	CkpaC74uoaq7BBof7HNdyf3da38ga7UijJdhoqPnTdnRkGZcQbvPg
7285	fee_transfer	1670	37000000	1	Ckpa7Bdn1krWH3dKsGHAzKwjZL4MeMR2mNs6FwZuybJSAm8gRWiD6
7288	fee_transfer	1395	103000000	1	CkpYV3fd6bMJTyKv6KATB8d2NH5vcggX42wZbx46rVzm1kqJN8U27
7291	fee_transfer	1768	125000000	1	CkpZXmXkawiaA6UYrf5PF2vo7V8xGeam9aHHBXDz7XMJmAwdnHbFs
7302	fee_transfer	171	34000000	1	CkpZEMNEeKwDVjrqMtbPMydxEr9QpG3CvChthSFzNqkVhEq4YoyjY
7304	fee_transfer	606	115000000	1	CkpYWcEZKPdPsu2sgVkGkBX6y4X9AwSBCAX5uNEZQYH56ivRXiqfA
7306	fee_transfer	1724	902000000	1	Ckpa9gUJVmqzwvBzqUqFZRU61y2dX4gqPRmD14xEPc3ZaA2tHZJwW
7307	fee_transfer	526	14000000	1	CkpYYQgEBCYnxDmqJAjcDirBmyVvDndBGY77PYVKDzY7nTZEjYmgB
7317	fee_transfer	1671	3000000	1	CkpYQR8YncHaEKRVbqywKuHX7zvSQqRTZZmr5KZehfahr4pHgmhxP
7319	fee_transfer	2311	1000	1	CkpZWPoQEWbQMYZxj52YPqda3uGQJHMdswS6eV4GDdjhqYMuGYyHN
7320	fee_transfer	1555	2999000	1	CkpZRPZNs7q8uzj5mpmFWt5HjHaqq1TPYn2HLsey9D7GTJuk6DxWD
7335	fee_transfer	1684	6000000	1	CkpaDfPwoLtyyzZxbgDczfRD1dkaCr9DoHjhHxQ5hjiJeVV4aEsX6
7342	fee_transfer	2306	48000000	1	CkpYdbKmdWJkVbyXKWwniLUHoA5oLED3gPf5TKbNbkzA7jF2CyJZH
7344	fee_transfer	1706	46000000	1	CkpZGNuizEU2ayCjAT6zB2LL8dzFNde9fMrYjTxdqkZaL6oXMTVTA
7353	fee_transfer	1747	4000000	1	CkpYsU7DUcrBiDqGkdddB6R2rV9MDdwBeULVmw9vhiSg4HhiRBmTg
7356	fee_transfer	1980	48000000	1	CkpZRP9TuY1C6hGti8NoVsTbxfKKfNuycD7hyu83VXGCgwStmKALw
7360	fee_transfer	338	13000000	1	CkpYSxA51Cfc8nFK5o2RsfisFnnKBB6MKapDNgD499JfsYmdFsEKY
7362	fee_transfer	1686	37000000	1	CkpaCqdZUaFyLzGLaHZGynkMbw166r1bRAUjx2SsPeFVwXM9Yquhm
7366	fee_transfer	58	36000000	1	CkpYpSfZMDLLcNrqk8MNHVkYDC8xhDdjRvLupwEL4MMNiet8PRabq
7372	fee_transfer_via_coinbase	1791	100000000	1	CkpYbjknU4Ab9R2n3vvNHLBuDXnYYwLJFUMcDTemukMQ68MowfSaw
7373	coinbase	1690	720000000000	1	CkpZQHPuHq2ZY6tLQH9xnBTFn4yqJqbXi51DWu1z6X45BuTyA5Rd5
7380	fee_transfer	1608	59000000	1	CkpZyvAWjmbcKQkxk82w3tr7LnPQhty73QbKcazdYWPSFvvM4dH1C
7387	fee_transfer	1706	646000000	1	CkpYz4H1g57uukQFco4GaxzELQJ6KvtqBygnnuLtuaNpHNfRDa7sN
7400	fee_transfer	1768	43000000	1	CkpZ8vKLmx3YDM9d9YJaMM27gj2AMc5UTH5J4jURt82QUghpYupSg
7406	fee_transfer	1611	23000000	1	Ckpa9SWjPwfVpcMqLeY2oHoij2DYrF6toRXwaTYEDdscZb6ikU5Xd
7412	coinbase	2329	720000000000	1	CkpaC8GUxqyYrckPx7rgCUEeNY3UhKc4ygZ22vzd2hV9JWtZAgf7F
7413	fee_transfer	2329	20000000	1	CkpYqkf3KukMcurovbmFkWejxQxW77GiiKm6gKk3m3tPCD4MAz5HH
7423	fee_transfer	1692	54000000	1	CkpaDh7wa1rVziJgu4DCTSWDXedhznwmoWkLK1XnQFing162ShFvr
7429	fee_transfer	1541	1000000	1	CkpZpeFU4PDE3EoJ7bZopWAyxSoJ4bMw8EJQfXST3QqU6L9N2tpjK
7433	fee_transfer	1514	22000000	1	CkpZ4fZMDrNS7aCvzdNcxxXjrxpyv97JVvxgQGFvVst2ZQjdaqN4f
7441	fee_transfer	1992	147000000	1	CkpZLr9fiEcZEcJw4kgqa6E1xDdH7ULCRAJcMGUyc1grQRgMjxjmd
7448	fee_transfer	1992	280000000	1	CkpZy9paMFKhVdSK5JtyP8dnz7PVYr9wJJ3FE83pNXo6hmdwhVcMZ
7452	fee_transfer	58	1200000000	1	CkpZFusJZ9WdW7CZdLGTVHzgdsS5oAZYYixiiEJbRrptM9AfUfQ35
7453	fee_transfer	58	41000000	1	CkpYonPhSDoYWhJD95ez9985zVqrT9PLLxyTDtfabBWnD76LV4KpF
7458	fee_transfer	633	87000000	1	CkpZDHBCJ64kXQ2Eau2r6iPcerYptBhaKesQMCMLx7FV2eKxcFdmT
7461	fee_transfer_via_coinbase	2330	1000000	1	CkpZ3h8G7Gg3HapuCGnWCKzSskEt18tKh94sbdg1dt1CYgnE1rjpa
7462	coinbase	1684	720000000000	1	CkpYkKQwU5GDJavzHQ9xfjPFME4Ey2T8mfRsrAUbMz2b1y9huJj31
7463	fee_transfer	2330	2000000	1	CkpZLDZFRpRspVSvebbV4qHJTuHSPaXbtbphKeCJ9MtAcSHgFTkwQ
7464	fee_transfer	2333	1000000	1	CkpZ8mwmYggPpwmt1etYixsh6ACAtXwT2aZUtCE1xe9ymFMGhho2V
7465	fee_transfer	1684	9000000	1	CkpYscvPfpvVwhMfykxaYGf6vmM6b2CUQLY8n48MLGxf3AqfjY6hG
7466	fee_transfer	2329	12000000	1	CkpZajiYJuuNt644y9PmpBjob5ufU7T6hFARmAfWDFQSBqjCxAKm3
7482	coinbase	1765	720000000000	1	CkpZgwVtCCbCe6AqQ44uFTn3usjJSKbPYziR1jqgd9bU4VpnzVbPB
7483	fee_transfer	1765	34000000	1	CkpYmmHEwTHdAUFQ7MecafYvKpaqft9E2jxjTokiVrt5VeowH6XQx
7486	fee_transfer	1439	15000000	1	Ckpa3epo9GwY9v1zZGXCST673nQbNmERUmkpiD7dtXEKhtdQGzJXp
7488	fee_transfer	1467	26000000	1	CkpZqwifmfoyCAW3hnRQpcU1mMN7aRmd8rEiQE13TtswGpLCLAbGH
7497	fee_transfer	1546	15000000	1	CkpZ3P5LdpBsR41aeGhSojxV5q9JTFJoWAbT1P7DkLFnKcFSaTYTs
7501	coinbase	418	720000000000	1	CkpYVrifoXP8FRjNvZTEJbKtDFQP3gbK9iJ1TiNUcU1sVvR9KrhnH
7502	fee_transfer	418	13000000	1	CkpYkvcFYaWEo3w1VGUxY1QrK59jNAiikpSh7hJ6i4z7ge7iq19BB
7507	fee_transfer	2329	24000000	1	CkpZc5mWvU4yN8KCuJJG6V7odaLEvt73ARC6MKH8NFg4vL7aYZV4Q
7514	fee_transfer	641	394000000	1	CkpYsYv1D8afZWVPrnBLSv9MetEypffgatuJD86kkkzhJN9xjpJh9
7518	fee_transfer	1423	15000000	1	CkpZ2dTbk16QhU36qG28X2qopbWCU1LTJLxe65bmwBs1EehvUYc5g
7534	fee_transfer	621	6000000	1	CkpZxb9xjfUyqb29HDp7EzhP1V3yajWP7MoE2fRycsmiVxwvM2Xrf
7542	fee_transfer	1716	17000000	1	CkpZiTbQqLPeKvewuYyi8GVXRXSdrAiE1mQNfsL7e6B7LuS35FrJs
7549	fee_transfer	1850	2000000	1	CkpZpYrQ8JFYaMQsi8VDeRqcYbCoxttdrocgRe62EUm5HF8YDzdQK
7550	fee_transfer	1746	36000000	1	CkpZ3Zngv6hFcr9c3HRr9T3B5cSbFyukkWkXhGBaLSkMCjYrTmJuZ
7552	fee_transfer	2292	36000000	1	CkpZbzp5EpyDqpwE6bcpBr1uqaqpedGfioQs4qmvm4Dhyi7wtbLeV
7430	fee_transfer	2329	11000000	1	CkpZriePiNeDSr8mP7DCdhLHrNz3nixgnAPBe3EZt2r39S5pBQmBu
7434	fee_transfer	1598	22000000	1	CkpYfV1Gxg3cijcEfhhEJcPctLYjK6W9JKFjWrcS2G2Fe2JRaLKV5
7437	fee_transfer_via_coinbase	1568	25000	1	CkpZDJjoBNJmBBpMqx8bgkoz98aFa9Y17WT3DnwjQVDc7ZReBonX6
7438	coinbase	1423	720000000000	1	CkpYsU2kDCUgs4ncCkemux9pnSRmt2KHpA9Lo2JWByX6G3preNSQA
7439	fee_transfer	1423	10975000	1	CkpZZefyM9Uz7kVrnnVY8SePD43MBNr8sCshyoS7QJhsrRSB4i6LC
7476	fee_transfer	1716	6000000	1	CkpZFVMiXZ9vnLSZzLTpdYxFDbDD6RcP6rsBedxQee4TQ7TkHZ9iK
7477	fee_transfer	2336	25000000	1	CkpZUf68fsBdukK9ob8ofPQH7hTseXCPueR1Wgs8VteSM35g1QLuR
7479	fee_transfer	1670	21000000	1	Ckpa5LQGgQBVzTQvvUyw4iBh8zLJ9tb14Ts57WivNMHCZ7X95ahxe
7489	fee_transfer	1619	13000000	1	CkpaBuhtXjGRXLo1YKdS1xDcVZwmjMaemyUswqETeuTqNaMyGutQ1
7499	fee_transfer	2329	13000000	1	CkpZV7Dx2x7PcLMT8bhDtQfAfSjUuEKsBRwKQuhdYQCwAFLdoAHyN
7500	fee_transfer	1610	63000000	1	CkpZrf1RVNRCYbkV2SctAFFDXLz3kehD1J5VXcnnUhUsgPmBt9nSr
7503	fee_transfer	1694	83000000	1	Ckpa1zNebT2mFx18uuXgw47CKcbwWqHp2137aePqfKgP3GkvQnFpQ
7508	fee_transfer	1765	12000000	1	CkpaAV1ukVeJJ3vJMpACcF18biDLbRMwfnyggRyv6fQi3hRHLMEgR
7519	fee_transfer	2329	14000000	1	CkpZHqJUYWX5ZyZD1tWMGTgBMviu1CJwQzo1zRtHrAtSv6E2dNmpu
7520	fee_transfer	1678	25000000	1	CkpYp54PU1MANJsrv38V4GT7Ks4eLQkG4yJxRA7NyymSB5ov4rNmJ
7526	fee_transfer	1685	5000000	1	CkpZC3r8D8xGgaP8EvoLFkWjqzm97hDgTTCgbgEF2MdXwrGek2ohJ
7530	fee_transfer	1588	2000000	1	CkpZNFAxayNoqjUb7w4qJ9id8MSLDbvE8VQcVm9zZrm9uL4zfSW64
7532	fee_transfer	1622	39000000	1	CkpZf5SCHCTLf48nwAxVWyLTEePGoxFmvKK5iBYhWuZPCm59MbJzF
7537	fee_transfer	1719	999992	1	CkpaKzWrvqx3eWkj6U3CiscbsmRjNqALkdGT8gJkAVNZWmyGWjapG
7540	fee_transfer	1395	17000000	1	CkpYToftkAs83atmRVpQSehwt9Sai9anhHZGd7ZsjE38mUFPLhBxw
7545	fee_transfer	2306	66000000	1	CkpYhNmSeiygH7AtnPKB3ge7r6Q5omu41H7AmA9SKwk7DkNKpXjah
7546	fee_transfer	2306	1000000	1	CkpZdy5BwgHRkFXFZfcCBwTF5xCktCfFGgbv8NchjHWrgTvBoPUsv
7548	fee_transfer	1680	18000000	1	CkpYkT1L8trHLJCqQyBDWQJVrJoWjSbSaVuMpfFsJFmkrswu1k6EV
7556	fee_transfer	2329	26000000	1	CkpZxpYbd65tscwh3VhwedSFRBa4yQkwmHi9xVvvfUjSXJ4HGva2J
7560	fee_transfer	1668	5000000	1	CkpZbYZhwdoHTa75DuaveeTpQj6SCPjq7jPt74FjrJonuSXHvw1Fp
7568	fee_transfer	2329	37000000	1	CkpZ1quf8Zano14iq86UjkQFiscymnh11zvdVEvwdgRMvKCgAwWhV
7575	fee_transfer	1522	38000000	1	CkpZbMA4xUaGg3JCJhBtYaJe4my8rhXg7FEzsNGVudv43uaBFRR8t
7578	fee_transfer	1619	25000000	1	CkpZ2uokXACr5oiMHx946qHS5oX9EWzZS46EJVWLZnTSbM4VExnQf
7582	fee_transfer	1422	37000000	1	CkpZrWCwLgALkwrwikDW6ASr95W8ajRSyXACL4nk7QJGaiKH5w4x6
7585	fee_transfer	484	24000000	1	CkpZdLACrSVBL5ZHhudws4T6QvLQ9L3T6CSxFeuzQmgDciVAcQNyu
7587	fee_transfer	1666	24000000	1	CkpYfu7VYSYwFzUHegcwcmZ5S8MhBA7ug4GCMZgasDGMcD2Tj7kcz
7588	fee_transfer	641	850000000	1	CkpYcX9q9yjqmi4EPP1gE7jwL36uKjNfdivkrfiFa8FpTJvPBny4k
7594	fee_transfer	1546	37000000	1	CkpZUTJKS1ypJfjg7dLNkhpbK5SPufNDEF2JHG6bTsyf57EntwARV
7596	fee_transfer	407	690000000	1	CkpZapiD4VMVPMd2PeWirQqCkwT8xGr3gTBweqfxUthYXvvpfXpLm
7597	fee_transfer	1619	37000000	1	CkpYvWxYYpD9oL9V4jFvRpAstk5kGSVh9T28mV4TUDzFFEXFAHHiT
7599	fee_transfer	2367	1	1	CkpYuDPGzoi3JKrGSMNeVWWaoK96tGyiY8maM3PcR7rkM4BM7iWT3
7600	fee_transfer	1688	24999999	1	CkpYzjzXxria41vTGAyMRAr9Zmwd6FjxMTMg4njmdeKGQ3nhS4Fmg
7454	fee_transfer	1489	14000000	1	CkpYvYzCViMBydU2c8bc9SjejK3bWaeL4wqcW6k2rgtDHTCGcbfyM
7457	fee_transfer	1599	87000000	1	CkpYk7KFrBS9X432k3RdpWpbCxi7CsThLDFxWTTwefUwexJcme7Pr
7459	fee_transfer	1594	25000000	1	CkpaEEhrLbHw6iSQB99CNJbaG14nCr4KoNK58F1MKqJ9iDdauFzah
7460	fee_transfer	43	23000000	1	CkpYbMkBYPWwsVjeoMmYyPPRTUtwmN5ukjPf1wSKwDzNq8h5NF9sV
7467	fee_transfer	1679	1999999	1	CkpYRAzWf1mJfbijHbTQ18s7PKsQp9eZitvXQn3bpLmZahLq7krkp
7470	fee_transfer	1719	34000000	1	CkpZ2zKmLcW2gNigKXdsrvb67RAeqWo6LL2bbHFYZ8WvBpLBX8MYL
7473	fee_transfer	1688	47000000	1	Ckpa8SyeVbjBHyzniM5ZE1J21Bw64TTUVLM1WG2mykbuy1mNWmn5K
7474	fee_transfer	1980	23000000	1	CkpYxrv4sThbUjdfTpWG73Xom6rtXgHeQ99EsP4jzpDVJPDMtwVYf
7475	fee_transfer	1555	39000000	1	CkpYszZNJU3k3BCyuepg2UJTws7mCnsnRBcL2QV2dvpppQGnprwZg
7478	fee_transfer	2329	23000000	1	CkpZw5qWZPWmfzTN4xBbCwwYUJ6s5g3GAUEyno9KUYD9QPY6hmK2v
7480	fee_transfer	1619	21000000	1	CkpYkHerhDvZqthokEihVfZuD8H86Te3Ubi24FMV7YUFPyw7CLgCD
7484	fee_transfer	1694	770000000	1	CkpYjksf5FjrTWnEyL5xieL4Nrsu6iVT2MzivcZmE8LwDUVc8ef6n
7485	fee_transfer	1694	480000000	1	CkpZJ21UvkrLataLEYc7PFLWPVEsmXNgqABPbfvcSrNTdDaKR4LXE
7487	fee_transfer	1684	15000000	1	CkpYa5wC4Rg1rn8nauHXBYbzp1R7oMdFp8tGkZRtkGf7UYrHoC5pS
7490	fee_transfer	1602	77000000	1	CkpZY8aSEkFoSmX4uXfKx4APZ1HVn74ZVAju6mcjomAFLwQDfwfNo
7491	coinbase	1602	720000000000	1	Ckpa7qfbK6mXYXYm6pESNk4UTQbdH3H5b5vjtum7xjB4re84gn8E4
7492	fee_transfer	45	60	1	Ckpa36R4QLNJXnCBdvK2Vawz7ez3o6LqMCRJDosbFvJpKEtJhk7SA
7493	fee_transfer	1568	250000	1	CkpaDmiNzXo486FDuF3RquPH2mRX3MaEBXHRdxdpk9zPBV9GGktGg
7494	fee_transfer	1758	600000	1	CkpZm4nxPtMpa7VokTiEq9rQh6EryCZA5j4bnCHL6Vw2hQ6tYDYAG
7495	fee_transfer	1855	1800	1	CkpZLbnU7m6NMg7ifZck2NeYLKwUTgxHzy3kdHZBfkRUfs7TcHBuc
7496	fee_transfer	1602	37148132	1	CkpZeao6r5VMw6cPDpAaVyY16uJ2znLwSzbZjotRTq2NkBAV3t5tY
7505	coinbase	1444	720000000000	1	CkpZDrftm4FDsVG1i5CJWuhgBysWufaXUAUg9m2rENvrooDWWd9ij
7506	fee_transfer	1444	23999984	1	CkpYSpdsbni97xRjppQWF6RNzqPbDwxxxsBexVQaLE8CPi17CMz93
7509	fee_transfer	1402	302000000	1	CkpaLaBAsASK1BZhEpyJBRrYU2861BbvHgHAdaLAZybSaJZm6n9XB
7510	fee_transfer	1402	19000000	1	CkpYfw9QJ3Uzbamh1FZaMosEYBi7tBMxUZWg3ocg8bp1mgtZUhVPm
7511	fee_transfer	1468	457000000	1	CkpaK8813fKfi8GfSCXfstXs5GUfz8kUZC4mvysn2ekw9ZEAZHZYk
7512	coinbase	1468	720000000000	1	CkpZVLCzyYBSnXg8DXieJHEQdsWav9KqAJFpJ3HrozhY1KYS2THsE
7513	fee_transfer	1468	1000001	1	CkpZMgEp4osT9HofmycBNGL6AVbYd6f9pTa1CidQJcMZCocDoCkvt
7517	fee_transfer	1654	26000000	1	CkpZvQHx5pfychX8H6DRTWdG1LhEGveN5rhH7byqomTCJeWkZyaTW
7529	fee_transfer	2329	2000000	1	CkpZS5aLBurhnM7dBnxXnmZcucP4XUA6enfCR7XoyBc6LHGX2pSQo
7531	fee_transfer	1402	790000000	1	CkpaH3w9HWiiYuGXPP1AHBPoTpTRrSyGaYae1f9xFmojvHECvM3uD
7533	fee_transfer	1394	39000000	1	CkpZyw1eKDMo9BRvgApb7SsjUg8yh6NhTJroGdQZdV62PNHRcrxjd
7539	fee_transfer	2248	17000000	1	CkpaCcQ7f89esjx5T7wvpFyDYMPwk1RSpwNyDiabic6GXBDYysq5g
7541	fee_transfer	1619	17000000	1	CkpYckV93Trx6ju9jRPKLsFA8UhU3tCdRfnjJy9mpFWKpr5NBfPSA
7551	fee_transfer	1747	36000000	1	Ckpa9hY9AkxemuQKcNL4phzfVftmpD8HkSXbdLveG5Vb9FEyCGof2
7557	fee_transfer	1764	26000000	1	CkpZzx67YQHcfyAgAB9m7LPTshHZKcfUGCzGYqB3ZkuKyHdaeQoGL
7562	fee_transfer	2087	20000000	1	CkpZWwd8HCB9PnfyhqgTz3gvqUY5NxmU2K1nXaUdjvSwcuZAZpzBA
7563	fee_transfer	2087	5000000	1	CkpZVVBRr8PR3gHePu9uaTXcRzPtCidzcCBY7vi8UCbFwPJmQVkr5
7567	fee_transfer	1596	26000000	1	CkpZVy7KqsGeVM6B6gJH59eHv7tbibMniobRcX4g6U3hUKhZNMhSY
7569	fee_transfer	1522	35000000	1	CkpaLiD61JyyALjxdSiDhCsorTP4XkoEEtjkGgyMp6TpYAxgE9bo3
7570	fee_transfer	1655	1000000	1	CkpYYRGAPCTWXAfsVRzvNVPscionyKfGWTNjorXRZ3as6ouiWwoLF
7571	fee_transfer	2336	1000000	1	CkpZuFbiprw1NDyN2eTv7qxdsPbg2A4SAbNf2VUvVhvatcvmf94Fg
7572	fee_transfer	2359	1000000	1	CkpZQeuBgeAM6xDxGA9xnmrxALT9m8fyhE6StV8wYFXYN7g2gVppa
7583	fee_transfer	1422	34000000	1	CkpZYuAZJHoFE6j2ZFhqr5cj5zgEUuBdbBEbziMpmHdruW9D4P6Pg
7591	coinbase	640	720000000000	1	CkpZKNHy3godHSY5PbWE4yWP1p2UiNQRs9AGsDdFnBhep2z2JedCK
7592	fee_transfer	640	12000000	1	CkpZMtprfdANUWcQPvhvsaBjUt19GfW9kN9VmHk9UjoL7Z9aNrnPC
7593	fee_transfer	2039	37000000	1	CkpZmrzhKxzoaqyv1xXz3r6qxmuYshGemXYexU9M8j3Vs43HFoxAh
7598	coinbase	1474	1440000000000	1	CkpZj72o7jr5CspvpyucCiQUiTCmzXThcY3BGMe8NJDnwsbdDT4Ws
7498	fee_transfer	1691	84000000	1	Ckpa8QUMg9qhKQ4bhCMtnsY3mnHcqXmCWjXt64SNdwHtCLT873PLi
7504	fee_transfer	1419	5000000	1	CkpZZXkFTBLpC95UTJBhQXEMqFyaTPrY1epcwoL4fsZHxdfikwjW3
7515	fee_transfer	641	560000000	1	CkpZXbUqxUUeDNMW7Spw83Do3Z9vPyCAMDUWyuvSFScAF17YfvoAy
7516	fee_transfer	641	348000000	1	CkpYqbvuGowCD3DSxNokrPp12G6yLU7Kqhiisf81wzx3w4VTCDLNU
7521	fee_transfer	1691	591000000	1	CkpZbtHjdCKYr87NfUVgXEAGfqcpZeFDJTKT2snsDQMNxdCdJw5cM
7522	fee_transfer	1691	29000000	1	CkpZiAwx7geW7pdEKc6H3jKcnNpFR14W5psYJwfzNPNTFeboJsNeo
7523	fee_transfer	1691	204000000	1	CkpZnAVVm6v8qtVzhr7daQiuQ5K8LZDr2LyPn8URTWK6T5tVcxucL
7524	fee_transfer	1691	8000000	1	CkpZtBuZ5z3Ewyn8TJoRB2rs8KXGk8keKYAaf5d5uBhiYpYNdHWtU
7525	fee_transfer	1613	5000000	1	CkpZo3V5Dk7o5FEd1CyUpqib4eTzX1ajpixF9PDdtK71RaxKMJLbt
7527	fee_transfer	1565	12000000	1	CkpZayE9VG3jxBX4ute4F5J1pK2PUf41fAS9ThpPVAff2wXygVhWK
7528	fee_transfer	2329	25000000	1	CkpYzUsZ1cFEaebF1gKYLiF2BYguZLrLurkW18ZFoE8CMa5pBy5eH
7535	coinbase	1719	720000000000	1	CkpZfFFn9Dyan8mnhuRDeLhsuY48Tr37gCUZXarj9ad7ewjw5ymdM
7536	fee_transfer	2252	1000000	1	CkpYiJukQpTqto6rknqxuRUmVjthv7UhDtnTYeEVhRAaAntvvMRw8
7538	fee_transfer	2112	22000000	1	Ckpa3LCN5MPFsBERJS77qRAAq97cCxjAoT8AFomyKE1Q6zbvcdjzz
7543	fee_transfer	1594	17000000	1	CkpYXX8nethWEWSMV6wR2QxjVY43kNRpfSq6bM52Sy76KJg7Dd1uQ
7544	fee_transfer	1440	66000000	1	Ckpa3fA59mMB4rfV3BsGcYa4cPrFkgABZnsK2KAs1FYrxchkpxocA
7547	fee_transfer	1394	66000000	1	CkpYbnFX7FBHAyXpyZdWCaaucdUohwVYKSc8kwAmeKug7QzizxYuS
7555	fee_transfer	1402	629000000	1	CkpYRckYGqvrqJ6k6TNKrGQMtPmUtqouRzcjfGzFPXjzxeBL2uSRJ
7558	fee_transfer	2252	1700000	1	CkpZSxaFQ9VwU3ERvD7erTb9bYGyxUhc2zxd6cEKBS7uWTuXLqpHe
7559	fee_transfer	1668	3300000	1	CkpZRQdErxS3pvrUj3xTqSmoHuh1CqKVgKy69qbqDLr47ddgQvqS7
7561	fee_transfer	1699	5000000	1	CkpYsQ1h31FQrhWB72aWNE95L2m1bndBpD21EE44J45z2pGtBnXbC
7576	fee_transfer	1476	580000000	1	CkpYqT6aePyzJHa6odcipTo1vocqxC5bGo5RcNPiHnNZaFBMeaVA4
7577	fee_transfer	1476	158000000	1	CkpYUajkRZVPbZY7AuCn9qrPk1mHpwf6dwNaA7K4qxyAW3GSLERBY
7579	fee_transfer	1434	13000000	1	CkpZM43w82FwK6qJqdVDKXt5G4hZw8hVqzSA6dCQnKzQYkGFy8jrc
7586	fee_transfer	2261	74000000	1	CkpYvZz5Ar2pB9sDAnVNp7jrc3Kr1h241QNQPBcQRh3sEbjeEZNQw
7553	fee_transfer	1681	18000000	1	CkpZi6CZEqSa3X47SquvooneA9FJo6H1MmitUdGdwPWTHVtYTbJsT
7554	fee_transfer	1694	4000000	1	CkpYzZA3p9wmfQe6MxjctBfKV7GF6kwNVwAfSRz5mauWRMf7Dsiyj
7564	fee_transfer	2086	20000000	1	Ckpa1iQEm4oNj3aS3Lq89Nnr1dkzLAPPoQ72eYnwpPjkVt45WVye2
7565	fee_transfer	2086	5000000	1	CkpZteFZMZ13pywJibtiZeD2hSnB3HvH4yy8rpUTDdbJsTozvUjja
7566	fee_transfer	1602	26000000	1	CkpZPjkPjh86npJ2yZfK2i9drmXP7i1Pn8pjx5ToEnHjGsdwfuFBz
7573	fee_transfer	1522	380000000	1	CkpZW4b6zBuMsfxX9SvMnLk5ZBWA8R3WHkXjfbNJHdZcjLJUWgTjP
7574	fee_transfer	1522	870000000	1	CkpZAiZcQtDKyA58k4EYH8pVcRfFUXN97TSTXZymgNSe1nsLdpqcs
7580	fee_transfer	1654	28000000	1	CkpZvfKRMCni4M2ZaTYaJJdAFgXAwfqMMVM7Wd9sdXdb5qy1FhZJP
7581	fee_transfer	1613	24000000	1	CkpZSsPnuHjsPr2qMpoSuHWwwN2R2Aj2CDMHoWoeFjeUjF9zVxqiD
7584	fee_transfer	1643	37000000	1	CkpZK5YQUpXiEwJrd6JqrtJ125GXwuwY3jU7QJRapbb8ZvYDUjgUg
7589	fee_transfer	1395	8000000	1	CkpZdkAQHbFaW4vzZVN2YJ8pMc2fN4Kg5p3BCoGuzQhbEaUXLFTdM
7590	fee_transfer	497	29000000	1	CkpZvD9cVgrj4t1sc1ywfmVyWxMSRUGdSNYL7hfL2ZKNs9T6oo4cB
7595	fee_transfer	407	22000000	1	CkpZq3p8Y4HsgzJBv2zbcDmzT84YMhT61eS3KdU8XbYbaP2JgvXct
7601	fee_transfer	1690	607000000	1	CkpYW9zaAEmMwYg2LrcAB9CZoJKertMrLiQB7dD7Y4qorkAR3Ez6M
7602	fee_transfer	1457	37000000	1	CkpZBXNCXzX1DjtTBwxQy8zzFuvQ4CdqEeaKDRbpPF2aHZKDNC72i
7603	fee_transfer	2112	547000000	1	CkpZxV5upZcBtRdadBnY7ZgHLatDxr4txbMb1mRzNEydJtN9qZeSS
7604	fee_transfer	1639	13000000	1	CkpYhmswJn8Hfct23EMjpFdN43EXKYD7ivkhTG2SRgEfVQmtaSJvv
7605	fee_transfer	1690	211000000	1	CkpZJ3s7U8EzHBk2x3hMXDmNsqXvzjjSRMb3WeBLacaa7tMB8oEQE
7606	fee_transfer	1657	37000000	1	CkpZk4tB6H2KU7JLTXnH7nLCRJLV27hkpedYgTr35UKJSxWyz85LK
7607	coinbase	1519	1440000000000	1	CkpZxFhQCaqWnc4oj3BzoYHNBAiunX8DstuoU3QmvPJwk8i5Vgmpe
7608	fee_transfer	1519	13000000	1	CkpYVQf7n6FSZg8xMNkthHPeqMW6uYtXdUsRkC9U2nhnqWb2rHVi6
7609	fee_transfer	1678	13000000	1	CkpYpfuLapcRwkjKT2TdqhUvQ9oCyeo3ohx8zgRYjEs4xBr54QcvS
7610	fee_transfer	1690	97000000	1	Ckpa2sdR2FpoY8fJX6szywSHGpRZSHVuCYjQCvbjSyYu1xG6dypHs
7611	fee_transfer	1690	13000001	1	CkpZLADam8ftbU4hBdEpeeiKW7gsDV2enRAhaqZUfybU8GynhEX5M
7612	fee_transfer	1686	36000000	1	CkpZzLMj2YPDcch7hFVr5VYyMK9HxJb6DDDTsQqXggH3Dx8BZRTh4
7613	fee_transfer	1444	47000000	1	CkpaGftyEsk5uVeYCVoxbcfqt2GA8BKk3Y3bouxvjYyCvVwmajAzB
7614	fee_transfer	1709	47000000	1	CkpYecwPaS7UVUhXWdF8HCjyCo3N9Fk8bgfZufEiNpG3QVBEHFoGG
7615	fee_transfer	1690	287000000	1	CkpZdmpJrZKvRvjgHEvkj6rMLxd1CjxrLJUohdnZ5vWsMSQjKsfQr
7616	fee_transfer	1458	35000000	1	CkpZpdGpesJZDTxMKy9K8nMoeJEe9RqbC6gfvih1vFNWhMAyCZ5Z6
7617	fee_transfer	1675	36000000	1	Ckpa3zmpcSbD5fRGHvbjWQGpDc6Vqj5bCoPogwtqvAj1FWr9YbhaJ
7618	fee_transfer	1547	3000000	1	CkpZP4rgFd6yEMQunJZEAxivh2MJYBdKnR43UGFBV1kefeLYgHnEj
7619	fee_transfer	1719	26000000	1	CkpZMSckLQcrs5MjVhodNtWbxKTqxqAhmwZ3adYw8UZFU45sAjHqe
7620	fee_transfer	1708	23000000	1	CkpYqP2SDGw9AnbV9HR6Ni8JVZYFAUHUZcQivXAJ2LbEpGz7vNSaH
7621	fee_transfer	1506	111000000	1	CkpYpLTkM6pVcFego4MQdw7pcDCAGXLHXavj56iM9XJC3tohKj36m
7622	fee_transfer	1506	23999992	1	CkpYwknek7M9iS6iy5Tzdo8EemKdmFDo97JsMMFW5whjV6WazuwES
7623	coinbase	1693	720000000000	1	CkpYi6XSdADHGx9zzPu1jDFeERJS5186dBEW3FjAwBtdYpcWPV1SU
7624	fee_transfer	1559	36000000	1	CkpZoVTD4Df5wtBpcY5kmw1KoDgpWhxsLcijMcSug8eemNN1aY4DG
7625	fee_transfer	1546	35000000	1	CkpYwk9aLoqs5Y3pgtjfinn6reeYHE8mNPkDPhvqNw7KKAxV3vT7J
7626	fee_transfer	42	35000000	1	Ckpa4E997E3YBZGp29hWjFr28UAf9QBJGBtsgtryrpi4ENZ4jLdcn
7627	fee_transfer	1756	580000000	1	CkpZeZnTKyDcuGjei8G9SfnvQSvNNSdAWKNf6PANMZX4bVpsBgmKQ
7628	fee_transfer	1756	230000000	1	CkpZmX4FwxszAr4pCX7ZysT4vjh6PHwaE3MqfPaJJFfVeEVeDfDMh
7629	fee_transfer	606	168000000	1	CkpZXE5EeGjrT4Npzgt5ek3aSUjN8p9VqWweiAEwanF2EKysTVFe3
7630	coinbase	606	720000000000	1	CkpaKdJhExJtf5UhNMRLF39mc1d51BXywY82Uva6r2oKoxJRuh9dW
7631	fee_transfer	2306	14000000	1	CkpYac67JJBpYZ1U2yMFnvQ8xA7GrsGnUhYYu85RtEX3xa99XgNTL
7632	fee_transfer	364	4000000	1	CkpZofMM3qJWGyZHhSFzheeMFmzjg6UNqnP4mYPD9ViHeATuVNHwc
7633	fee_transfer	1690	380000000	1	CkpZ6Zh8eCQ4G5YCkxZL935wPabj98Hu5Rc33RZ28agoQGocQWCPT
7634	fee_transfer	1690	19475000	1	CkpYqSf3othdTdQfasb2EX1SoB4pdfN67bqLqYhHLmtJg2wsufQws
7635	fee_transfer	364	14000000	1	CkpZzq4vRqzdKoHLCjGXAjEVe2pmQRiYL6Ws2AgPhQje7C2MQH2Z9
7636	fee_transfer	576	33000000	1	CkpZCh7xz2D2mxKRTT4W1v3FBygXY2XoSeJC4iCfNCacAmaHSnHyJ
7637	fee_transfer	1670	170000000	1	CkpZDo8U9SP7VQeR9HC2dms1VsswFeSceq7p9BhPgfecrU7vA4ZZE
7638	fee_transfer	1717	17000000	1	CkpZ1yEEkJGPio6fZaho5CYsAe5FAj4uEsDxj2DLoUtArutj2hjb2
7639	fee_transfer	2307	10000000	1	CkpZAmbPZzqeZXmrEaeKMAbfMRXYke6wvQzYC9WgvcphNopjyPYPq
7640	fee_transfer_via_coinbase	1744	5000000	1	CkpYstwLSAPBHSgrq2TXxMySwTYzedsDy3d9nJNJyoF6yZxgdfQfC
7641	coinbase	2307	720000000000	1	CkpZckonpzNbEEhrnvc4NjrgG3c7R4UDHnZZdiVicWhXFGeLLNVDc
7642	fee_transfer	2329	10000000	1	CkpZpELSVn3Qn4M3M9rZtV92HuVQUwDicurv1Y2f6eLinrykbsSd1
7643	fee_transfer	1506	101000000	1	CkpZmDnaJB6jDf9TQ9CmZdfDMfDaZDNSDc8hysBBYWeFxxFGBohwU
7644	fee_transfer	1506	23000001	1	CkpZ6JSfsVDobxmsSvBfDFnKKpTMRcctkEtR5bhxatRigEV7Bkjcw
7645	fee_transfer_via_coinbase	1737	100000000	1	CkpaKQ7EQ2Bpz1h7EEMBtdNVCq5vGYQzX3kXUzremi44Y34G2DvhB
7646	coinbase	606	720000000000	1	Ckpa7zBjgwVfh7ddLSH8FrUZx2Dpq1HHC9p4tPeLxuoFFDm5fM4PM
7647	fee_transfer	1672	23000000	1	CkpZWh3Nb3irQ9qMz4j9RgVYdNkJh4gNW3pkYfS6odUVKEXSbkL3x
7648	fee_transfer	1623	360000000	1	CkpZcFS7zmMS2hxieEsYV4GiAmti4ruoQuvYeCVXKHnz3TDXnMx4q
7649	fee_transfer_via_coinbase	2332	1	1	CkpZstNThnZQnkuuDMk4jhvVHhHXByeo9QnUK2wFx8t2Gpj7gDfhM
7650	coinbase	1706	720000000000	1	CkpaKpEvpLhkMAs1qn1B5sfMertaz3J568gteYo4SpN69FihNvL1N
7651	fee_transfer	1756	517000000	1	CkpZWG7doLZAotp8df2e6LtPbsqgTyZbiZ966vTaeszm135qBdGYQ
7652	fee_transfer	1756	67000000	1	Ckpa9S97p91iZ4jLhkBzdnz3w7StwyGGuNnAS4dkRQg2q6aZekBoV
7653	fee_transfer	1522	36000000	1	CkpZ892DTeTc8M9ruHAJeeub8hstYhxXGJxAGM5G9YBQECTgZKXLD
7654	fee_transfer	1749	2000000	1	CkpZ1oxmgHoj8Brh8LAF9ADs1ejuDfu7EJPNt5AMmGy6mKuqCnfMX
7655	coinbase	1670	720000000000	1	CkpYjNRjDzLMAwTvj57RHARp2FTtDRcDXzjdfaUydQ2HJHz3xfdXP
7656	fee_transfer	111	35000000	1	CkpZjT6UCVJKAZcZLyLtff52zwXgnU5xVvLEmNSUwQm9c2tNd4xPW
7657	fee_transfer	697	12000000	1	CkpZBDbUCwhdnKbQMHHYHW7X5VaAdRFtQtVufo5MLWyyqAabyhjWM
7658	fee_transfer	1692	2199984	1	CkpYc6U1emukaVRLdooBrRet4Jr6mRb4GsPhZiosJkiu68tvps9fz
7659	fee_transfer	1604	300000	1	CkpaEMskUqE4qGioRCMV9diE4iG2CULJ5oceoqCbT3AdBNguoimbg
7672	fee_transfer	1756	219999999	1	CkpZJCwn7YNJTqoAJmSJtyqseCRNaECKytmX8hLQdXcZj7jeMQLvw
7674	fee_transfer	1395	84000000	1	CkpYpWMpadbbkqQyNoU5cdRy3bRePLqkLJJwoEcEBTF8chZ3WjUCC
7679	fee_transfer_via_coinbase	1514	980000	1	CkpYVFR29FTinbQpXgvEwjJ3tXriRvywoihETHjiZjp8kHAn43LYu
7680	coinbase	1670	720000000000	1	CkpYzFvsLNEXuzqDgYcHPDxCQDAxLUei3Haq3vcVcYtBjVts1xmEL
7681	fee_transfer	2250	3000000	1	CkpYSype7wySeTQZ7HhLzGeNdUHzoNNnb7etkvsgnfneV7Tpvc6ba
7682	fee_transfer	1670	9000000	1	Ckpa6YhhAJWEVS3VknfkDq3kT1dCnKTXtbmX6DdgumzzW5FjyYgAN
7692	fee_transfer	1571	36000000	1	CkpaDyQ5zXUqLgheQQth7JAH18CDNmgmYPTZKqmCX1iHk225gvezE
7695	fee_transfer	1271	970000000	1	CkpYaTfB9yRupppXmvGDqHVKzNbW4XVztjiY9WH4fpz3C2ehJYd9P
7696	fee_transfer	1271	134999983	1	CkpaBpBLJnNouzTfQWhChCQxvLz88LqQRryPXdrkwgVGXVLxo9NGE
7701	coinbase	1759	720000000000	1	CkpZxMu6WDUK2KRYE6QzWZKezMsnH1635why91esFWyuzKkRFCwiX
7702	fee_transfer	2261	36000000	1	CkpYpuHfDqtubREMmygZfXhVJhUba11cSzJtjxhwPfBM8jssm2PtE
7706	fee_transfer	1634	36000000	1	CkpYqGgAj1JtKcaGcTBSVWPVp4jYdLM5SgATUpXe6vtkBc4BWdpqw
7710	fee_transfer	1448	36000000	1	CkpYrWJdrWZXCe3FwsEMvrtkVrt1m7ybrUM6pDttuSKfsNiqNcNyy
7711	fee_transfer	2106	36000000	1	CkpYpbNfCNNibJ1PVUa4xgD7SXHDhNHmXmQA1382rXhKpCi9R917Z
7712	fee_transfer	1692	10999988	1	CkpYkbDMmJTquf65ZPnfLxApeBrgRkgDoKTEMovLMFjztr9Q6YzDs
7720	fee_transfer	1394	18000000	1	Ckpa9924QThNQfAdJ62iSZx7R5FR8FUDwZzikA8cEZpgnnwFCLtkf
7723	fee_transfer	1599	6000000	1	CkpYj9kHhBGw7ZBhuTrsbuGUHua8eeD4bt73qEusCWRWkj48ZTo3Z
7729	fee_transfer	1678	7000000	1	CkpZvRSnpaxt9MnA5hhKqEb2Wq8iejVNbmBhbfVsa2f9bGuAaoyyH
7730	fee_transfer	1451	7000000	1	CkpYuUXFTxfbEpVZ6XUePi29DuG7NBT21egKqg4jxhn7GMsxamUbT
7735	fee_transfer	1402	17000000	1	CkpZNRrQLzfjvTYjxPG7hcn2cQtEKDrZDKQiCyuo8to7kYywS13BM
7736	fee_transfer	1649	28000000	1	CkpaHjpaW6GqNcJHNhs71TeSo7XhST4XVJXi4h1PfQR8UPdUo5Hqc
7738	fee_transfer	1693	2000012000000	1	CkpZWKoTR761hgUL4otyrjRpHcBnuzk1qQZLSkkphqxFt6nmissfT
7742	fee_transfer	1499	100000000	1	CkpaJJbNXYYotrWmbpCv1TzeyF1vYdqVDpHu9yj1FaDQhdWynxCTM
7743	fee_transfer	1687	638999999	1	CkpZQ6rTkif21wzEZzEKxUYL1r2Af9ez9tc8bxqrY9AftoiecHTdr
7745	coinbase	2384	720000000000	1	CkpYidrv7arM9FrFLqJoK2e8m5YnVbjLjTTEZsFXT8JFwo594ysx1
7746	fee_transfer	2384	34000000	1	CkpYvhHoz63R2vGsu3wXqnp3wLRNF9zVe7wGXL2d9WQv6UzPtSyyJ
7749	fee_transfer	1714	24000000	1	CkpZKbynKRPfWqACKbMgdte3N6zpW7Bx2jtwBGuWZuqimErSQ57Aj
7750	fee_transfer	2106	15000000	1	CkpZHT7tm136AkTmxN8p5G2CeMK6a4RWPig5Gv1PCsKEQnz8crFM2
7752	fee_transfer	1724	72000000	1	CkpZjg9ZpkfQKn2oUbTYy5vrbYqXPyg7JojAAp1BvvTgk2XNmMbyj
7754	fee_transfer	1740	72000000	1	CkpYUGsrnMxrKBSeATQAaDVCBrMcEgExrNFwPV8ggADt6AyFUUjPV
7755	fee_transfer	1724	48000000	1	CkpaLecX1tELvq9xvmuLHX4JMNaicJm6NJcn2DWNwyf4TBu3Jq9Ph
7765	fee_transfer	1675	520000000	1	CkpYuW43ogbzwBbXxqjnFSwRzuniQe1asSSyiRu8JUQaCZ19R9Gh9
7766	fee_transfer	1675	208000000	1	CkpYzv2gsGHXh9HXWXCXdTf6k18n5iW3bb78phDNdgo7WU4tJLnKC
7768	fee_transfer	1675	196000000	1	CkpZvgkbUnmTGTcnqmAmggD7BmnCqGBQPFcfTMNR9N8iEZpDutP6h
7770	fee_transfer	1718	34000000	1	CkpZZNBxfphxqc5EQG6ZMBJVXiwRamUP8kaSPeF4avJafYVStEuQd
7772	fee_transfer	1611	33000000	1	CkpYoNHvmfrhQJNpNUwAuG7pChMsg2DA5qET5NhjARZNaR7TMP9YB
7776	fee_transfer	1613	700000000	1	Ckpa6LqrB26XduRko49DeZWBcQv8nzWnLLW4AWv8sQj8zez6YHGTN
7777	fee_transfer	1613	550000000	1	CkpYXySwjKh9BWxfpHDebwjTZ4S3R2swvHnTY6tMCLXaya6cCAGso
7660	fee_transfer	171	620000000	1	CkpZnsFVHuY2rrVvDUGAjZHLakL1NH9HGTGrYzLmjYr25HC7CDaYn
7661	fee_transfer	171	630000000	1	CkpZkT7jTVsRaNTMUDu8NUKUq9teoNd9wmPFVMVuj27snXWGVk91N
7662	fee_transfer	1425	10000000	1	CkpZLVh4u7Aasu4d7vtZVPUE2H8mQe9FSzczDVyPy9FCVUof8b7Yn
7663	fee_transfer	1425	38000000	1	CkpZJ2vpGzWGXRgqJV3UrFrg7Frekuka4b5UEkovwuGnqGdGQCJuc
7664	fee_transfer	1394	38000000	1	CkpYcnwbexo7oHKiezJbHohj55jUzKoWWd4UgCEfZPDEDTB9HEGZv
7665	fee_transfer	576	6000000	1	Ckpa9AL1tUBpVf7ChpDsd7E1ehuBDmqs8rLKDVmAVPwbQvcoLYzFL
7666	fee_transfer	1395	13999999	1	CkpZwLQtmjPc3cJYf6PFAd5aKJa9MK5n5MDgMLZA4tp2geYPx9BLs
7667	fee_transfer	2332	1	1	CkpZstNThnZQnkuuDMk4jhvVHhHXByeo9QnUK2wFx8t2Gpj7gDfhM
7683	coinbase	1546	720000000000	1	CkpZ1VoTPGHSHhx1qhTZ4Q5NjJs2zGHLiQ4horkvjUtTBTk6YF5Zs
7684	fee_transfer	1546	7600000	1	CkpYdV38hHrCVdeEKvpp22UkB2DVQv89f9ZbU2CrXUrik1Pk41Qkm
7685	fee_transfer	1449	2400000	1	CkpZYmZPncs1fQwubV6ALe1cS3HuvxdHyCLDq5sg3T2oezLnC28N9
7687	fee_transfer	1687	790000000	1	CkpYUGSFTk8tnNRJ5DFDd9gRZodimk7cMB1sk6ARyYoWFDK4ax7jm
7688	fee_transfer	1687	145000000	1	CkpZ1kPpGmMpKvPYmUTJipmtPKkJCaAPYGNpLRiYBmaMSRPpDtmgg
7704	fee_transfer	1691	36000000	1	CkpZYjWWES6RbQP52uYF87tU6a6H9LbJwv56CV1EDd2VWsYbiuJJR
7707	fee_transfer	1662	12000000	1	CkpaKWEDwkxvHf2Ksrtbjd8Apn9FMruXWJVR8ru8DxZAJ9Lt7RunM
7708	fee_transfer	1695	36000000	1	CkpZZ29UZDQdKTi5v7SZ8vAF1BCJ4s75feTpmVEQShjarrg87xF1Z
7719	fee_transfer	1685	18000000	1	CkpYYoHcW2HzdgvMeaZCxH5zxtFNZeaHYEXoFDXi2baqjw7YmYZSK
7721	fee_transfer	1599	18000000	1	Ckpa8tnQVEXooi5UP9Aohiw4jhWT3m64dThhX1VMvt9UHcXLbEfDV
7724	fee_transfer	1426	17000000	1	CkpZWq88D6EKiLbc5JKYp5tTM4gakwB4BoZdJBz86xcc8bx5Zh934
7727	fee_transfer	1684	26000000	1	CkpaGxQkKfg9x18bKCB1qWNzjeFFTVKUzybxCWJVVTfuoDNrgho1F
7728	fee_transfer	1394	7000000	1	CkpZ1njmW5CTYSxWRUu2tDCvUFZjd21Y3S3inGrpuUpPhBXDZjjWR
7734	fee_transfer	1695	51000000	1	CkpYcVZ3JtYkJ1hSEVytdPurS6GXLjKuFEJvKCAecVrFjw5mGnjGj
7737	fee_transfer	1444	2000012000000	1	CkpZF1eYEghAZNKsavMj3MXZCy2iurizQGoB13JN5TE71XQPiios5
7739	fee_transfer	102	10000000	1	CkpaGsJT5Axts92PLdNCgaYjS4uhRdszvy3GTP4H4PoCGz1oZmZRG
7740	fee_transfer	102	2000000	1	CkpYVNXMiUQxHDSSekAzo8DEpgWsa3mJZsjXHEnKyJXrBiFwXom5M
7751	fee_transfer	1447	72000000	1	CkpZw1KHpBcLA1EA5wf9ghxtZnLTHvNDMTfbKABCZVuCycWqrPfox
7758	fee_transfer	1547	190000000	1	CkpYvDmaLWCWvUq2zoM4JSLeRdbgBe4qBQcL8rRr5TXmV51A7Gdyk
7759	fee_transfer	1547	599010000	1	CkpZayaQ4rqh1gwPH2eXrH8VzMui9FRwJDiWcsmWQfouDzFU4U7zK
7760	fee_transfer	1719	44000000	1	CkpaK4avTDD8MJPYXaipU258NRr5146ktHrTU5MqsNaLCUpdFTA58
7761	fee_transfer	1506	48000000	1	CkpYQgnGVnx5uogKUPCWTAsXBTnscR2f6phXgCxV63kLPu2cxFEqX
7762	fee_transfer	2307	48000000	1	CkpaGAfr5X5cF5bW48bmadf5XB4D2tYDX1HT4owDG3FotXv6nAS83
7773	fee_transfer	2329	44000000	1	Ckpa5XYcoqWBRWKLXhn7rivE4DbSBURHvTRnjLeHsDBYodxPivNey
7774	fee_transfer	1559	73000000	1	CkpZckcyuWrviMQ4zz7jmQj4S7eRNY6YfAY5LFPAdGm5JnmQafmsB
7779	fee_transfer	1499	11000000	1	CkpaL4GiPFJFsjoq2deadQHUKTwu7YJsFcNdxBB7G2WTXZfA3oqvb
7668	fee_transfer	1457	360000000	1	CkpaD7THz5BjQXchg6vBKGWmhAgBzwKiQL2bU5ZkW5DzmTXvnFVcq
7669	fee_transfer	1457	170000000	1	CkpYo6vHE8WoXAGPRRraT6R4VPgPdaDZoJNiQ73wEX12Bm12SoZsQ
7673	fee_transfer	1402	84000000	1	Ckpa4RoSj36rYqL6JS5oQzQUesarVmpyWwVvhgXrshGHtdMfAXrjo
7677	coinbase	2301	720000000000	1	CkpZG65PPVZ4tHAiTEtR5fhJZAiJaYFrezRpHuLyGrBkDCJJsSzfy
7678	fee_transfer	2301	36000000	1	CkpZLdWQKSTjzKz3ZjyjBZ6AkcqoZyCRcV5kFTWx6BYkUDWGZsHpp
7686	coinbase	2261	720000000000	1	CkpZfzKMT9RyNSjfbk5nsfxfauRmUYbhxQqrag8uXohPVtBRn5yy3
7693	fee_transfer	1692	9949000	1	CkpYgZZUVfWhGJTqMGBWyNX5NM9e2xu9aScAcWrDndxGWdrrHenp8
7694	fee_transfer	1449	51000	1	CkpYfg6m3KuYwChsfU1pxE7SruV944PnT6s5MXc5FLsRVHVvp9crg
7699	fee_transfer_via_coinbase	1432	1000000000	1	CkpYZncQsevmhJTYE4BGbeCito7j3AWV6cyR5PpWvaufnr6y9rr2p
7700	coinbase	1508	720000000000	1	CkpZo4C3kdnr5EgMQqPzNSvrcLppdD6Jhg29HGYkuNnSHkzoiipPc
7709	fee_transfer	623	12000000	1	CkpZ5mQqU7xuyD877vyod3XgaKnjymg3KEwa16oBZiokwt5scDvaR
7713	fee_transfer	1506	25000000	1	CkpZNcQVGdLBAiJaPKM56Tv1bHHVQL1c4Cg7BehA3inStEfyvSzNt
7714	fee_transfer	1568	75000	1	CkpZeRHJuDnygRrRPaXJmG937hFK4sTt8J66Fjfdn2joehqZejR5X
7715	fee_transfer	1708	824599	1	CkpYu3CHxyCzftTpZwSQnWJVvTMcQ4NGS7FkYB4BXsUSEACT3Z5Nt
7716	fee_transfer	2333	100000	1	CkpZgRMojWHiryDeHCNt318tBzcnDQUtZfmobxMNN28ypCXnRWHkW
7717	fee_transfer	2346	1000000	1	CkpYSPMP5kwJ8krTFyNM7jNzErTpkniJDiDtc8YNVzF5YkKjgJb32
7722	fee_transfer	1419	18000000	1	CkpZDxXjHkrqChq63HEopvSDsxwLKV1jtBpcATJKZeEDX7WRW946y
7725	fee_transfer	341	17000000	1	CkpZg1W26NcSi5Erasf6eAoHktDRG4oR4MtUzRHVPxc2oynCooFLw
7726	fee_transfer	1622	51000000	1	CkpYRQZbmZGypoY3tQDLfNtKAmWmeHBXWDygUs4VAioWaN1kHFxxs
7741	fee_transfer	1555	96000000	1	CkpYtDGcgzdS1b1sahNqydPrD8QRVeCMhaRjDWJ6LC43kS2ry1ZYM
7753	fee_transfer	632	34000000	1	CkpYXbA1RiSZAo2WBKozUdrou6KVeFBjWNThS6eQNSPzz7ib1sa1Q
7756	fee_transfer	1547	550000000	1	CkpZQCPXUmThcyqHBKqhbCJUEaQbYWrNuYUqjMSzEYH4BHA3v9dMM
7757	fee_transfer	1547	673000000	1	CkpZPZ8PuExagZuncd5Xq5YMttcXvTQyXNFr2Nnn7p4aMbYgH5Dpv
7767	fee_transfer	1650	64000000	1	CkpYuQCGqhex9Vi9VAYBb9zmeJmDhV9rMcU8RacfkkHZEqq7u6q9u
7771	fee_transfer	1700	234000000	1	CkpZqnj5kqtyPpdMs6gRUKDDc9zzDJMv9e5RsbERhFMrLv4xHPEXr
7778	fee_transfer	2039	77000000	1	CkpZnESNv9Qmv9fE9kzrETTnd78NG351PYon6DVGzg88zT83fCYCD
7670	fee_transfer	1633	14000000	1	CkpaCSXioavkS4CY7FBf9u722oJVVD4SknRBc6Y7PaAt6Nckt3Taw
7671	fee_transfer	1633	2000000	1	CkpYippcAGgtX7sugtnK3vMKp4Gwvu3Te7RPKBM1ex73PRNYtdAXg
7675	fee_transfer	1457	216000000	1	CkpZ1kcYBkLBSDpkHUoLoggYM1UfrRrRSJW786xCAsej7eiSMhPA8
7676	fee_transfer	1457	32999999	1	CkpZ8BgNkaLdiZv2h8rL1s4DuiybZxbn51wXcvHywWwn9sLGRBhHm
7689	fee_transfer	1692	11899987	1	CkpYR9MPycJZ54f1ad8sspAv5XocWmJoVnTKmxxeqRv2stmSsErM7
7690	fee_transfer	2252	100000	1	CkpYbMT4Cx6D28XW8JZppzKKWKKqATbefc1aVGX2nDtfgCJBVpZ9o
7691	fee_transfer	1514	14	1	CkpZurEKcD6sNXTJhSK7zR45yYX3P8ryKtRMZFAauscqYFA2TqCMa
7697	coinbase	2302	720000000000	1	CkpYU65Qv77mnoYfYTP574Cm4HzDX1F3Xqdrb1YrqScdTiNuoQk2K
7698	fee_transfer	2302	23000000	1	CkpYqvNz5kqwLAv7SZRAVgTuGCWLgRsdaAP7pf7XYn1QLH2tqmdFk
7703	fee_transfer	1619	36000000	1	CkpZF7tgTg4XiQQaH6AYdv4s46XftodGoe16XftTqVQUutPJDjSAY
7705	fee_transfer	633	38000000	1	CkpZKtR5PyXJb9673YCdTGxPCqpXR9kT4QfyNSEWmsE22g8frMTE5
7718	fee_transfer	1594	32000000	1	CkpZWnvoeWq6gzLbvSBSvQBkp8R7pT9SU1SxFCWNuaZs5JMrLCTsn
7731	fee_transfer	1444	53000000	1	CkpZAFdnoNBifBgcn3VR3GLuJnJ9oThFzZPNfbxvABZyZuHy8dot2
7732	fee_transfer	1610	36000000	1	CkpZowWAUuzkSvuJ9VXWY8LeMP4cux2hM3eF5uPNLwExnCWEH1aug
7733	fee_transfer	2112	15000000	1	CkpZKprVSHbqwJpJtSzGxZxARcj5qwK5iEpZy4QCUg6dhdpcLayqG
7744	fee_transfer	1546	34000000	1	CkpZJs7ibvB3nnPZs8dvqB9mAbrYffzUm9DyXoxuwh9Sb2XB5Q787
7747	coinbase	1451	1440000000000	1	CkpYtNHivJXUT3x9b42SHRLYaRwFVMKAKZaw2o9MUMRvjF3QFb9hW
7748	fee_transfer	1573	2000000	1	CkpaKa1GpgNW9PXuafEMT7rB7x1HVZ9ctLqJ4uxPfPPfTM4CvgVPP
7763	fee_transfer_via_coinbase	2359	1000000000	1	CkpYsE6xdQ7E4QgCcySxWUHgB48MkJKkKsWySgn74JiB4LUSW2piR
7764	coinbase	1687	720000000000	1	CkpZ5mw4ZgdLLiSjBxgYgze5xBQFB6xg8i8EFKnmxjAeN46hunHWV
7769	fee_transfer	610	33009990	1	CkpaHGtPs3Et2y3Arnfdc5wZwVqzMLbX8S9iziUqyBGTviV5LhWLa
7775	fee_transfer	1546	33000000	1	CkpZu7aLSzJRCyLpinzn2iPq62pdJ2GVzestPVQWH7pgzmQFBHozr
7780	fee_transfer	1701	55000000	1	CkpYhyHcBm8L29owHWWLy7z3tjAYLJUNR5wqFiUVPhF8FXQmiuEHj
7781	fee_transfer	1686	55000000	1	CkpYXGGN8fisQYNRr86XtZsoABa9jPrjF4taxSBeGw3HSGLLgcTDG
7782	fee_transfer	1699	21000000	1	CkpZzj5YZ9JjLxMPgSB7kCxHMTBKvH6xA2WFW7to1c73okqhnxuYB
7783	fee_transfer	2087	21000000	1	CkpYpAnqWjHP6zKMpUqAx7fZN3biFz17rGQyeSbTqsQf5qkDKmaKM
7784	fee_transfer	2087	1000000	1	CkpYvH23wagiGFftjxQx3g8PZVbB31EjWXp4Jhbjo1nd4RXhy9yjR
7785	fee_transfer	2086	21000000	1	CkpZ2d9XnsyPN5vhfe819vuTmexSgrAeYW2Grmw44WZZ3cLy69jaZ
7786	fee_transfer	2086	1000000	1	CkpYsuP8bpD8V1vQ6fySZULLKEn4oCangKzn6cjwo49YVDPUwW8Lh
7787	fee_transfer	2039	43000000	1	CkpYmEAz4RRwcR93HNCxPtzyxoaVvxo8CoM8bccSbKTQRfL446WH3
7788	fee_transfer	1622	23000000	1	CkpaGotgo3BjfjwvNmM5XEJWhHM7CfRXAbEGh3FNZ5M8TpSqv4nsd
7789	fee_transfer	1536	15000000	1	CkpYgXPScy4mhg374UG93TAcJdqh6MnSPmHAkiJRQGdDFGz8dDH3H
7790	fee_transfer	344	48000000	1	CkpaKBgdGeEBLzCYJHTTrfGZCL1vF3LQ6jZLQsjQittHRCdu3btPo
7791	fee_transfer	2329	48000000	1	CkpZQQUYNdDyKsSvtE3TpTH42LKsTHH64ok5n2yBuADwsW1rQEr1A
7792	fee_transfer	1598	12000000	1	CkpYTJS5pNpNvbA5H2jrnk1hRfidBnUKkm7vs8FDoLfrSBGtnSzaQ
7793	fee_transfer	1560	460000000	1	CkpYjYf4PvBmzHsqsFhmdYPwBGCRBZwUdAsUuvvyvx9uakLxsU9SJ
7794	fee_transfer	1560	151000000	1	Ckpa22uEBZbQsVHqmUt5UCxYr25dQ1Tk25GNRM5jjbMHiAzXo5Bu1
7795	fee_transfer	1980	26000000	1	CkpZ6efgTfWJLe9A3RWz4jdmwTUkwm7eQxJymY7sazCtqSn8GuPTx
7796	fee_transfer	1654	247000000	1	CkpZWgffHjzkfLfkr7fyUbrriEqVLveq4iZwBoMBf6jZb1p6YDAZZ
7797	coinbase	1521	720000000000	1	CkpYZVP1RJmeaMhLDKMQTHXo9TodXdNPtXJdKCfc68UWjbR7w41vg
7798	fee_transfer_via_coinbase	2250	1000000	1	CkpZnr8N5cDR8w9QgAgtP2DmyENa6PzurQv79AA9XAvhZABDi3yej
7799	coinbase	1521	720000000000	1	CkpZozvRHBPWPLNdwiWH9mw4dBQghH12gNFZimvC8VgvSmQp4HCNb
7800	fee_transfer	498	12000000	1	CkpZqzGaMfjq9xvJELawQFx8353aGJ5GkZnX7eUs4hA2PamRPas4w
7801	fee_transfer	42	21000000	1	CkpZ7ViPW2S5D66oq6cdkbynsTUgVe7hp5gzRhjWbKat974UyAgpg
7802	fee_transfer	1634	21000000	1	CkpaD9zt9BH6n3po6ExnCKKvnNQ9nybHSTTSDzjJfYdc81LYymhVr
7803	fee_transfer	1634	3000000	1	CkpYhoaiwHSGjwSs26x8XLbwW9GsfPLk2hxXWdEMhic2NN1AkRsRT
7804	coinbase	2148	720000000000	1	CkpZya9Ydp1KnCyd1Xeu5eMUzzKKLo9aUik5vLdspNyhbQRyFcvxw
7805	fee_transfer	2329	30000000	1	CkpZEfMSKVNcvfUB4iLVm8KoaxoatiKFEkbaQo9jztnn7swGzFnVk
7806	fee_transfer	2329	6000000	1	CkpZgDpj9mAW4gkLhmg4uwz3AMRQHbLERd5boBFSqdTA4B1L8DX2t
7807	fee_transfer	1395	40500000	1	CkpZcdCPDTe1D4LQB5TKQYKiJsYtuPpM5mRwcGR3kVu5bDamcpMg2
7808	fee_transfer	1630	13000000	1	CkpZYudUJH3TnuUkBBscMRZjeByb5xiXWAXKnsphcoRqBX7xEzhhZ
7809	fee_transfer	1541	32000000	1	CkpZ3wWtM4T5dNzjf3MWyUFdy1zFxLneoHXbkJXBpLLWQs1XZ8eAc
7810	fee_transfer	610	34000000	1	CkpYZZqyAUXKfDEv2YLVgQSMxdkj5HkL3BR9kUSRNMtvHaQjWsZR9
7811	fee_transfer	1633	38000000	1	CkpZrvD8izDbHkZkQ17im4AaATQcV94nJeUo3dLMQFkvhbea3Kphw
7812	fee_transfer	529	22000000	1	CkpZH5EGYuMday9JbFqwj3nWpJJWed2utnnuh8U9KAuatn2TCHVr4
7813	fee_transfer	1423	38000000	1	CkpYSVJVWsicjxtuh5paHjVD38cAWMi9gCYxr59vSJAcL8d8fgPDn
7814	fee_transfer	1588	38000000	1	CkpZ6XXEDLqyF1U8umzSLDAM14MB9z8QzwMKUSPTwowy8xKj8xf5K
7815	fee_transfer	1395	38000000	1	Ckpa6Fgmrd8oGjCUT8DZxVw3Tsr6nJwKMbixMjctQKHKS26Qhq9Ns
7816	fee_transfer	1439	38000000	1	CkpZqrFu2vBTKRrhBMn8HnM58keyeyfRocvHXCP99kt8WwxyLGoCZ
7817	fee_transfer	1560	457000000	1	CkpYVk2v6Nez7cW9zX7D383zLwpD9X6byorzSvQshiyHMaUryfaZK
7818	fee_transfer	1675	26000000	1	CkpZGAv8L63MNAmZ3xCjhniyVvRetFCF4n32h6wEmj8bo2jaBbSta
7819	fee_transfer	2248	36000000	1	CkpZFiYsvHqe2NWGNRfXv8poTNPrpausR4JjMjKg3e2AoaWnBYMKU
7820	fee_transfer	1716	36000000	1	CkpZDKT5s3tnrgRwGHoPxmZvu3uAjfZp5wLJpKmUFvXwLGP1xaEtX
7821	fee_transfer_via_coinbase	1771	250000000	1	CkpZLEuKn2TdUBmtsac8LnyrLMbgNitQDPfrad8Md61vPmsnCXuio
7822	coinbase	1549	720000000000	1	CkpZ2TgCnWnJokUXNVxbWPgpU6iZwq96GfhLFbDiD1xwC9BrUpgr7
7823	fee_transfer	1705	14000000	1	CkpYyBf1Yt4eDkbr4neU4ev6oANeGQpimo7Rd5wBXZVHg7NaD8qRy
7824	fee_transfer	1560	235000000	1	CkpZu8VZumDUCCKaPLWyeLM7eGLA2P7Ubxp1xdNgpg31yr41aEaeF
7825	fee_transfer	1560	38000000	1	CkpZK3Mtq28v18xqw4JMTWc6zsnSWsCsTjkktrMuN3ahqy5Tn7RKU
7826	fee_transfer	1528	12000000	1	CkpYdkh6sHX2VxPUSrRbEKagUHjr647mdadLjzfc43CwPFqxgPNoK
7827	coinbase	1546	1440000000000	1	CkpZGvsRA42jvBa8rEWHxq5fSatBSrbAyy8EMJNd7L1qTCpDpVXMD
7828	fee_transfer	1564	230000000	1	CkpZdn9msHhTcbr7vBhJNfG6Da9PXc9DEtv1CHqNAiKnW6HT6P8KC
7829	fee_transfer	1564	1020000000	1	CkpZ4Brb7aFqKvf185cvzwCCGjdErRPkGavFz4gHZeDeZc6Wfhkvu
7836	fee_transfer	1623	91000000	1	CkpZ4FNKewejywMaEMqidm4ofySfSZHt72HrAE9ezyKfBXhVaWPzq
7841	fee_transfer	633	630000000	1	CkpaAHib15qjuBf8ictvaK5krfKEhvHVzZ5wt7coX7LiSPUjpPcsN
7842	fee_transfer	633	620000000	1	CkpZmcTv7yAwnvpuc6dDmqzvU9YRaYPVYgejf36weujyJzYeKLLuS
7843	fee_transfer	2329	21000000	1	Ckpa2XNAhKoiR8VJKgmaE9B7r3sDMsU91Z4wWZdhQESFSmYMYXCgZ
7848	fee_transfer	1657	2000000	1	CkpYpFJ9PWHBFfmXY73umkrbnJHkoTY5fyZV9b5THguQ8Qpr3nDPA
7851	fee_transfer	1668	28500000	1	CkpZZpo2N6Fu27MztjPVPRfJjmKBjCyzTqUMCnWS7cRTagNZdGgaN
7864	fee_transfer	2306	98000000	1	CkpYvEFURcrGJdy9KmztgccTtTj5vXeNkBaHdbmFp53srXJp4dgjt
7865	fee_transfer	1690	17000000	1	CkpYXfRvLbaF1oRPbyjTXUkCPw2kPExR87TbAvd57FMKPbSLPhyUw
7870	fee_transfer	1509	44000000	1	CkpZZGsYGPLjfFBm1E7C8qP7VwuUQSESgeUZ2uEG8VwEYgxDG7C1u
7871	fee_transfer	2148	44000000	1	CkpZ9YVsnpBQ27dGfDTcgP1my9qVvzAU8F2epd27Gr1bNAmUvQvyU
7873	fee_transfer	1724	35000000	1	CkpaAJa3t6FvNRxv2W3cXt97BCYU7wVQxFdft8ktc3j8pN1tmN3fb
7875	fee_transfer	1508	69000000	1	CkpZBGpnuaB8N9CPwdF42hufCb7gkgamz7j9bNLLu3ZbaRLKGE6v8
7876	coinbase	1508	720000000000	1	CkpZ7iWMhc5tSHGYXCEpq4einFYREk2vki4WmBr3ZLDiwrY9SQZ79
7882	fee_transfer	610	11000000	1	CkpZobjgE8HRzSZXL1XQ15kKKuyQJGKEEQ6nCiMQhcv7jnL6Gc1S4
7883	fee_transfer	1768	21000000	1	CkpYQvpp5U1tVRCtx4kGhhT9xsD4zhKHxiRhb2fVxwLEytpUbf5qs
7888	fee_transfer	519	11000000	1	CkpZpsqaJaB9TDZex8kbjbUrA5UJ9tUpxgf7WusjC17xU4i55f9zQ
7890	fee_transfer	1559	22000000	1	CkpZyGoWaTAqmkgsymuBfaMxowaWFVSoB5ZpxHPNtN7gtNQhTjhAX
7894	fee_transfer	1541	22000000	1	CkpYrz6jYVvW9yw3EhpRBgJzjy2t1pMZdbNj3t3St5jtpJ7k17mbU
7896	fee_transfer	641	16500000	1	CkpaGkmPTgP1y3WFKXXG17bCUfnw22wt8pPUGHyk2BYJCatpyiYtE
7898	fee_transfer	1402	36666670	1	CkpZEJLpBp8H35giW1yyNsDM6VzKGssTWhVVqe2UYK8wQiTTXc17S
7900	fee_transfer	1506	36666670	1	CkpaD81pjGUk7Cb7js4SVXm1vVVSQmLoXr4ByiCn9hpaaSVgmJEWK
7903	fee_transfer	1656	263000000	1	CkpaGDUhY33nh1PpJ2bpy8brN5Dswq18vWM3nYF8jrSXRgZmNWBMc
7909	fee_transfer	1513	33166670	1	CkpYcxuC2qyKe8K7EjpKeHABdwfubjcHpPUf5LjM3io1dep2iwBWk
7919	fee_transfer_via_coinbase	2052	10000000	1	CkpZY8SBKu8BdnDTBt3eYxxWM4GhgkDM5R4KHbp4wNs8LKHVeGGUp
7920	coinbase	1690	720000000000	1	CkpaJv9MYpyP4k2hTYQBJf7YQyUsJafuVyzvSgA5kScPBmf1JQNWv
7922	fee_transfer	1541	54000000	1	CkpYnuG3RbYu8aJXFnBpaSm7t3AMuh425LEgmSBSc2XGM8UEXqYfz
7940	fee_transfer	1593	33000000	1	CkpZ9sBXTvYC9RLwLwTUfM6RJG8MrY8iw1u37mvmzeuCWpsxA6diZ
7958	fee_transfer	1724	520000000	1	CkpYY49gY6fo1gKBVG3NVWgfQohcKE1RbmDEA5PvKGb5szDEcASCw
7959	fee_transfer	1724	730000000	1	CkpYQQBUhgFqcVf5Dsoq6gBWbbY8GEQvjBnFGzHwvjTa87xrYu7vE
7966	fee_transfer	1434	12000000	1	CkpZAnr2UEHyWpFGhgAx5TtHMrXDggRf5BtAppDNZCg5hxNVgRLhy
7967	fee_transfer	1709	122000000	1	Ckpa7ysuDAsYVkwirvUjvfBwesr5FBfWr777R34Z1VR7KGruwkw43
7968	coinbase	1709	720000000000	1	CkpYnAh3VcnzLqAQziJWfidwwEe187pY5TncPvi2nPaWag9LSTAMo
7969	fee_transfer	1482	24000000	1	Ckpa5CtErDxSSaNxn6iAzdaApv3KjeVhBfFJz6thyqQHmftnGUXHh
7981	fee_transfer	1991	2000000	1	CkpZPS1vkVbjZvEetXC4GbJswcE1uFppVBGYv1Gt9ff1n4wW9pLDF
7987	fee_transfer	1395	274000000	1	CkpZQBD9fidqSVFCzwpNattPsgyrzRitGUvi3oWVB4Zow6JNaa5uL
7996	fee_transfer	1877	12000000	1	CkpZW9XT9hjjLmfJkodm1gRVPwigvoeUKXkL69dNMi73TJftjCbh6
8002	fee_transfer	1564	35000000	1	CkpZmX1SWB6Z2XsTmGgismZBxKYvFEaRasyCvuUdws8cPEc3RnMCu
8006	fee_transfer	1633	48000000	1	CkpZivkqn7PxU92GcYH3gC2LkNKfRwzsa9qC8QRbkzoVKqQ3dcGsz
8009	fee_transfer	1633	37000000	1	CkpaB7RBSHTkH5u8MebpLyefao1D8FYh43T1qfUk1m9oUXFN9udwm
8015	fee_transfer	2086	2000000	1	Ckpa17zrQSE38FUMCf48FDejgHae8T8VyDbxCc7yFUVhKVqSriKRe
8019	fee_transfer	1576	285000000	1	CkpZESstEVkkF2McHKL3utYJUv49aFjUdAxnaLX8UAa3B2Nv1bgHE
8022	fee_transfer	1592	33000000	1	CkpZqcpmsNzXriraumyYF35VoD7GFerfY7YL7gpvym9au39msqV83
8023	fee_transfer	1592	2000000	1	CkpYjYQej28RCkHyeR4bNdTHC2oMJQGXhbFhfdaQNv7RtBCbjRuzR
8041	fee_transfer	1717	48000000	1	CkpYtAHyq5WqMcZdQ9bWpBeRve3jtha9nC4QYG9oHoBmQXwp97pkZ
8043	fee_transfer	1474	48000000	1	CkpYSYxsKEvghwYvErJtyYKPYqo9pwverDD1ppKkLPdKRUAfNYQuw
8044	fee_transfer	1691	730000000	1	CkpZbosdRmbWoNYUtJxCb2gjfRpu8UGfsrYjVFkcn9Pr19aoqBYQD
8045	fee_transfer	1691	610000000	1	CkpYcrbpQUdbPZnssoGfFxvu4tYZHc1WfpxLJKK4KXRH9ihRiRBtZ
8046	fee_transfer	1756	393000000	1	Ckpa8fBJ5Z12RmTrVxhN26HjmqfFVJEU3k9PX8bsg4DSqjZWrjvPi
8047	fee_transfer	1756	39000000	1	CkpZKW5d4V6JDEdfNZv4xjJfb6MUixZKTehpmrioTvG7HKnP3dKAN
8052	fee_transfer	2306	23000000	1	CkpaADj4TDYd6VLK7wsEWjox7dCtjS5T9hLLjkQAfLtG13ojvascV
8058	fee_transfer	1705	39000000	1	Ckpa5QWvFw1orhz8p5GzQDffjBmHjyR3UCmsHepF1ACAiZixr51Bq
8063	fee_transfer	1739	108000000	1	CkpaKTh9XPfAyifhDVbSYo8dAzJtJJ7dARaUf58jFyJ824tcjDCZJ
8067	fee_transfer	1587	19750000	1	CkpYsbKEV3hc6yvUxM7qxoiLUKxi2bgMwcxS3tYHUcAo8FjRY5oVV
8070	fee_transfer	1422	16937500	1	CkpZJzGN1REYubiJ1gZxxshUuZYqYtCgeeDHVCDDhHpffigPepyUU
8071	fee_transfer	1445	12000000	1	Ckpa6Q23kzdiAf2QFm2TUzLhiiwUjCkBjGEbRC1EwHJvebVsNB3hR
8072	fee_transfer	1768	50000000	1	Ckpa87ewF9ofm2Hu8kxBQx3LbhctPBbtZzxpcQRAGq9amfPuXiiBQ
8077	fee_transfer	1694	262000000	1	CkpZBM749A4bTXRvoD6f3ZeAXb3ZwiBzdGauJLJXTzjAt1sU4wkoJ
8086	fee_transfer	1622	47000000	1	CkpaJv3g7GnkKs4CSA2vkskpHD8i9PNFJSpqfyfd1PJ8XUqV6Gmt6
8091	fee_transfer	2329	4000000	1	CkpZVTkfqac62BzB2RueAZ3KsLTUyB5BoDdEtkrdWXKmZWx2caXjS
8093	fee_transfer	1695	38000000	1	CkpZMxNRSeBcqzL6pb11vv7Ed4b2jvZbkdeQXL7GmZLQc8D8YDqiH
8102	coinbase	1664	720000000000	1	CkpYuGhKzEDPNuA3mt2Gs3v3KQs4caisF1XHnZ7KB9zX2LRUZbTrS
8103	fee_transfer	1664	12000000	1	Ckpa9v7LWk9VWdSxuPMHzfX33RJWrrYTTVX7rxdmaKGuaRgx9yiUz
8112	fee_transfer	1436	12000000	1	CkpZsHHAPh27cvKi1AC2r9DB86Dvdg92FFHs2VSddtkYENM7FPQ5q
8114	fee_transfer	1668	111000000	1	CkpZAFUBbLrjYqs89f8vpsognVY1mXjbccpRiVXZrv19qVwRy4NpF
8122	fee_transfer	1402	38000000	1	CkpYZaRC1uUoz6bLmUaAFTwo3PBcGAKriGNaXyftCaRuXDUjJuj1x
8126	fee_transfer	470	136000000	1	CkpYRgximwWS2yLjeuURpuCidCYMAzLrq2XFkrjCoHjbW67mfr11j
8131	fee_transfer	1573	147000000	1	CkpZ4BqnMp9VHtTK1cYMEhUzPUWt3qXNJ7fKQfkv5qaGu4t7y889p
8132	fee_transfer	1573	18000000	1	CkpZrwqXHXgNUBWHbuLCVARCMq76CmAaw73t5ypbBZkPL5hXPtwbn
7830	fee_transfer	1520	60000000	1	CkpYvBJBRMwDkyJtYuJySWZ99bP5PCCTi78gATs81sfkfpXs3Kzpe
7831	fee_transfer	1622	55000000	1	CkpYuNz1yvKjUVkxXPETFFf3wBj4pcPXzaVgZFRRpBivfPZwU1Eoe
7833	fee_transfer	1520	5000000	1	CkpZvLJDmV8NAMpDzx6vjpiuY2K9ZEDYNpF9tnEJd4XP1onVXhXAY
7835	fee_transfer	1455	91000000	1	CkpaLcyuJcGEqHmdrQjr9YcUDbZLKN7PoteDzDmPpVXvj23JhUywh
7837	fee_transfer	2261	30000000	1	CkpYSy1BevVp6urYMmyTGi1i9969cELeRnF2MShiMwDTKCmmiPJv9
7838	fee_transfer	2261	7000000	1	CkpZXskHshoxZb2ffVT5pGCxCQQKSoP2V6fMigmtEwoGbxmxZpkXi
7839	fee_transfer	1604	100000	1	CkpZWGJEFBU3RfvRLpgff7JDfRMyh2okFeqTtUQkFH69RPMZkWhaT
7840	fee_transfer	2087	23900000	1	CkpZcAQWAfYu7rmADbTy53Aw1xQJieJJfjCPpKTE47kfEU52V7Hc9
7844	fee_transfer	1271	22000000	1	CkpYSXwWBuWpvHygLCFUJUQF8V8MhRVEaFshogyLLfirN9CnGugGH
7845	coinbase	1271	720000000000	1	CkpYawxShxA6fWrmWDbd7RQyRkQyJqc7FSxRitkzMeMPbx8w5HgLQ
7846	fee_transfer	697	999998	1	CkpZNTgmhfQaRUd51YdkRkNRqLnGvWUVTx5PCpTVm6wBWaQFNCQ2R
7847	fee_transfer	1271	2	1	CkpYemX5WyUbLsKadoPrZsSCxGKtVhbEy1eZ63dTd6A4e81KmBGWe
7849	fee_transfer	1599	21000000	1	CkpZySJSBPGor9wxAoNhNCTZavSC2zFbjvgHq8YvHjvuaU2vf8A3t
7853	fee_transfer	641	34000000	1	Ckpa4Ymdv9UHbqnT6z8WTfGNZaKXvwaXbzbnCnLJpqN8tGgTaSUJV
7854	fee_transfer	2221	100	1	CkpZPSUkPhUESgzwT3NwVUepQNniWXY7dKQDpkrNj7QS4MwkHgK6P
7855	fee_transfer	1509	10999900	1	CkpYTETMCNPRBbYYyC9MWCoS44Q9CwJ1Abx4PBwo9yNDLhaXhutV1
7866	fee_transfer	1532	12000000	1	CkpYs951Su8y22TFELhYtAhmwiYuAsM7HAEfrigGvh7hsqefLNkhB
7869	fee_transfer	1536	33000000	1	CkpZJ1cFp5kQMB6ZFFwHc8gguDxtQrpYKeM5jR4RgtivSsCAsr32o
7877	fee_transfer	623	11000000	1	CkpZa7ob5GzDZohLeew9hTeCxvXCoRWqA8JL4PaXRdUgR2qsMYSLQ
7880	fee_transfer	1506	21000000	1	CkpZrS1yVea69kHUvRPSFyfd7rjsMopxLV7m44XMLtoDSxqrJrEWM
7897	fee_transfer	1633	16500000	1	CkpZ8HYwNQYEoRgptJM8pKdPWdXGpzsnN56i7zSHbZomomJ73mD1Z
7899	fee_transfer	2307	36666670	1	CkpYgbiz6WqjPQ2CQiV3WYCo9CFaUdobeYTB9sULTzpBsY2AjGZK9
7902	fee_transfer	1462	14000000	1	CkpZ3WDdAL4n7zfJQT7trhaNmEDC3uHitPV6jWbXC4H8XJc8JgHh5
7904	fee_transfer	1703	263000000	1	CkpZfpGPgcHJMWdLdG58zETt2HBUzsLNJNjSyt2NvBe8xtTKFxUjD
7906	fee_transfer	1616	13000000	1	CkpYszw4HVQYCtBKgDumnAZ6PfowPeEbVyAQikayYT9Ad7jU4w3pX
7910	fee_transfer	1616	14000000	1	CkpZ3pPtBtxXjmawpg6cUkJzxeLU5daoDRZuCX6X8hcHF4fchCsx5
7912	fee_transfer	1711	36000000	1	CkpZwefc682h149mvGrcK7UAqCTJHAgNkm1sfWXnPGv6QzVgfXSUW
7921	fee_transfer	1751	23000000	1	CkpYS9thARigR9JPNSEJ4SzrCAcL185mxbh2B7wzRJbkfuNERHnMP
7931	fee_transfer	1619	48000000	1	CkpaHPPsZxL9kgCfyTfFqZtS6jGvpiWUwK4i5sKVEqrFsW7SaomLm
7932	fee_transfer	555	11000000	1	CkpYzEQE75Y7yKbCJ1Er12zDrXsoGbzhXubyLnbo6rynC5F1mTszg
7933	fee_transfer	1426	352000000	1	CkpYmYwYgARVtH5t8x383ZeD7mJBAKLTTFyyrVYoVPtD25KFURQdx
7934	fee_transfer	1426	7999715	1	CkpZnnZUxAb8AkPDRD5rMiP4E5Gzop3MPLpjFYnWaFKHfAaB8myBg
7935	fee_transfer	1855	100	1	CkpZCTgDzvLQUxTMwYinN2keiumTSX9Xs2EFPqXV3W4NKp5YXSnbw
7936	fee_transfer	2252	3000000	1	CkpZK7zygfydjBiNMWsMPeaNAUoPhkrmaS7NgiGDBkmw44j4r6x3j
7937	fee_transfer	1744	5000000	1	CkpYstwLSAPBHSgrq2TXxMySwTYzedsDy3d9nJNJyoF6yZxgdfQfC
7938	fee_transfer	1571	184	1	CkpZnCgeNLJHUeQrRfhKE8qAwC2CY8srYhRyVRgJRqyUzeXCJoMSW
7939	fee_transfer	1740	4000000	1	CkpZQFT2Kw2tFwh8bGEELeR6K4wtbP6JEyidPv7hcqxc2FJR4f5VZ
7942	fee_transfer	1740	5000000	1	CkpYT87QrSefqZcgZUJJ6XEFKbT4CK7zyZA6ByZKtDUJE4knrvL5m
7952	coinbase	1602	720000000000	1	CkpYmR5oLaronUtzQAxgD8DcMrG32JWgE2kMcjuzrCVhxuA38EFH7
7953	fee_transfer	1602	6000005	1	CkpZ9N21RubRGigSQEyLQswFrWhc68pT2wBng6DTuoPNVrdXPx3Et
7956	coinbase	1649	1440000000000	1	CkpZBfH4gDtVwn6QDZVTVTC6QeKEvwrbVFQZPskm2NoBWMm9MddJu
7957	fee_transfer	1716	2000000	1	Ckpa1q2nva7xaBpRpVMAveRvAZGUQCn4khr8cG2EbEDYi7iTfXCun
7962	fee_transfer	1746	16000000	1	CkpZzxMZM7Ayt2mrUXhqmrVkYPe69GQ5LsBfrV5FshBzrak485QVv
7971	fee_transfer	1532	67538460	1	CkpZXrASqPN8wA1NvbvS1D7KvSBSS9uibGYyXY64Jcf1TPVkyikSC
7976	fee_transfer	1455	182000000	1	CkpYkhNkAkUvw9mx6s2UVr7HdN6DW6oTctePxecoQVxakFQZgvXpX
7977	fee_transfer	1458	36000000	1	CkpZ9NgP9PUr2tE66SQi9m8Emsu11pQrrCZbs3TWph9YoTYin84tu
7986	fee_transfer	1402	274000000	1	CkpZrakwA6vfS7vdSotQYDo7S8tGXnaqmqF9JpbTNh2Cu3XXYhRGN
7988	fee_transfer	1471	681000000	1	Ckpa2jdw1635quws6TWvFpmL2CMCfPu95fxE212Qcf4HmqQZpMY1R
7990	fee_transfer	2329	254000000	1	CkpZPvgm7Dqx5wnhT9bXbHwBRMnfyHGLo1bwAXf64z9PcFSYA2gcZ
7993	fee_transfer	1522	34000000	1	CkpZ6th3bQe7wcJrEUF7PkKi7fqfQeZ6AExRJWk3PrF594fXcrsfC
7994	fee_transfer	369	36000000	1	CkpZ2XLh5yxcZDHUcPSGCbB8h7DMTB5ZngEL48TZAW4a93btWcvAr
7995	fee_transfer	2148	10000000	1	CkpZ5nyKooX47mHnqiQhDYRQWxHXPu3w4dWdBSadDThWKxUxjeNZJ
8003	fee_transfer	1684	971000000	1	CkpZf32ViWfaWr85AMy1HuTisBbJuxG7gd6VKNTWmW1LZMmnadoUR
8004	coinbase	132	720000000000	1	CkpaGeUew318GDHZR3fkd5JPv5wXoUhgr778kqRpxUZ6XXUJtc6on
8005	fee_transfer	132	369000000	1	CkpaGXxB9hPCGHVcDkvQ1Czj2q6ETkgTQZYmop4a3zKoMNTHFW7Ug
8010	fee_transfer	1601	36000000	1	CkpZi9N3cZ4w6uVyWD3rRUbgn8xbQcPgp1S3seTZv39rCsqaqmran
8011	fee_transfer	1740	446000000	1	CkpYyYhp7dNuGKzxB7tuxmvVfMDovANTLVxLDEg4UhSwkpQrSaZfV
8012	fee_transfer	1740	12999998	1	CkpZkX7wykzUkwJjPn8814AKcYWBKqC8Ld9eYe5ekSWqoDL7rz6hn
8013	fee_transfer	1449	2	1	CkpZvxFgQXmuQdac75S37fgfDu6kQi4UcAjFXifpwZ4zCteZtBm7S
8017	fee_transfer	1546	32000000	1	CkpZRfxQ5LTVMyQrd6JHtFcW7ZLCSVsM8zUrA5ekRtXU3ap4kgcXE
8018	fee_transfer	1668	35000000	1	CkpYmGyxQctjnLEa2QHTE5aqPjeFpX5kF57fR7zAJLx3EFkqqyRWk
8021	fee_transfer	1576	216000000	1	CkpZAiQo78Ksyf9DKkzDz51mEkkSMezvJVsAAFK4Y1KoPYRB5NZPk
8025	fee_transfer	1746	15000000	1	Ckpa8Vn29dKBUhtSV34MaPoeSaqvuzN9Jv1TsyJ8iEhDfeE2n8TRh
8035	fee_transfer	1613	11999972	1	CkpZzACNKrcRSyU5Kq71s7GG6KxeTwkVcP9Vvc22CNEThpF9DWHm4
8036	fee_transfer	1807	28	1	CkpYgN4jStTaRBsijMVTuhHtoVJgpPbDAmpBSCYRiJUgyms4RNcM3
8038	fee_transfer	1623	48000000	1	CkpYWWgKdP2ZvmkVfK6Ru4hgtPWt2HywaT397Cj2ZUZ7k5TGMrpQR
8039	fee_transfer	1739	41000000	1	Ckpa2NazFeNEeayMRWMVTWvjJe2d1ABZk6nZmx6N8282SCcL7RNKm
8049	coinbase	1471	720000000000	1	CkpZTrPd9qnRrXy9Sbuf2DSA5pkUpv4JXko8KtAyVNRgKMMXEZh6W
8050	fee_transfer	1471	1999830	1	CkpYhDKFTbEfxYM5g4SnUTtFk8Y6vk1bmj8f8PegoiYttxxJPMui6
8051	fee_transfer	45	170	1	CkpYUJz7UgmsjrtcppcNgHCEsiQ5ncBo6b9fbjUq7usZFUzD8G4vG
7832	fee_transfer	1622	60000000	1	CkpYo8Xpoz3dGmjLdW23Lp1fHo8hX6kce1wfGJePik8Sdjo9uNuGa
7834	fee_transfer	632	91000000	1	CkpZCbrPGdzm5J7RAp3DYaftCv3zgQMTs4XLKezC9WmFGC3iYcHJK
7850	fee_transfer	1751	11000000	1	CkpZnsaxSn94KfKqYVeLzr3EcXgokoBEggW4uaqyBgsi9j5ZKWo9r
7852	fee_transfer	1420	12000000	1	CkpZxs41THvzyD4M666pPcaaSWHjxKpgia8cp6Hb48WeMb57ucRKy
7856	fee_transfer_via_coinbase	2348	100	1	CkpZTRzX9HuusNYE57YSSa51qjYwxyCX1FzjgC22EuvVPiaLoXBKN
7857	coinbase	1513	720000000000	1	CkpZxin51gbLrXyanckpEH5MvekBwZQGjqc1usYXA4xTjBmpPEySo
7858	fee_transfer	1513	53400000	1	Ckpa3iFL2EwJZxaqWeisrDJX2cigcxocKaNuW7rF8mYVqCh4feciW
7859	fee_transfer	1604	600000	1	CkpZapfHVQsYEnvX5WF5diuWC3w8ewG7AH315FFbwtRbJLCZujr9z
7860	fee_transfer	484	23000000	1	CkpYZjYz3FzaPtfgLzxhp4NsWM7nb71icjjCpfy49kCRBorwkqfNF
7861	fee_transfer	1526	11000000	1	CkpZkMtvfwpWFfBfzw9XMeBtcmFfgnQnnEQk4DAfzRD5Rj3Vvnipn
7862	coinbase	188	720000000000	1	CkpZv4SX1tsjs7UKzjRHd7Bm462ACMo2N6fdFLWyhPvCUEN5Xrffg
7863	fee_transfer	188	11000000	1	CkpZk9Mnhk8yJe5Qm24j2Z2HFkU6zxUTGvAK1uDAMcv22ndd3PFyj
7867	fee_transfer	1698	261000000	1	CkpZP77oiAWZK7zRFhnkPc3YRGrnNcqy58g5KM2govi6FrAXogWDU
7868	fee_transfer	1685	31000000	1	CkpZshLX6Kh18LyFgotPGEZc8oahnRg5ohv3eW21j5QDQBn6DNYzn
7872	fee_transfer	1696	35000000	1	Ckpa8CEc2NWfGqR94H58SQ7EXU1M5on9Hwt5PSas4h1N1zQymibGW
7874	coinbase	1509	1440000000000	1	Ckpa11TaxDRH51MFWee2BepF8KzwJ9MPs49AQgE8mDwYKeiGgfdWy
7878	fee_transfer	1700	43000000	1	CkpZse3xuPDjodpN79sK2zWtudDM533fmSeuD7H3pCdv7Bi4hGvHz
7879	fee_transfer	2307	21000000	1	CkpYtMkEgvBQbP2Yqy3AeNB8n8hRZqdpHAa1DYKfZqbnjdaCf44m9
7881	coinbase	1696	1440000000000	1	CkpZTt5JKgikaWSYYTCckvnm2ddGySo7gRjYVuzYjdujsH5Q2t8BZ
7884	fee_transfer	1608	21000000	1	CkpYuEsEjJGWwCpxnX2u54eCtQJAbtT318fkt8YkyxJurAoURPSHQ
7885	fee_transfer	1509	190000000	1	CkpYoGD7Y5V8ZHw6vP1TFfHaPTyAMWJ1LgYsK4RXnVHKcJhuEZzfu
7886	fee_transfer	1509	48000000	1	CkpaFoL2ihyLyxPgknPFw4Ga2Fz19Z51ZJEDGsv2DB8PKyuVAU7HN
7887	fee_transfer	42	32000000	1	CkpZHD1rNj23TebUN8LqYCJ1R8fM4kbXPzXQjiiF7FDVHzoBqvaqF
7889	fee_transfer	1559	27500000	1	CkpZsLpe3TreMw5JKBQgxGtkT8kGioDCb4vEHfwajpkb4s4n1FcrH
7891	fee_transfer	1693	203500000	1	CkpYx9zqBFk85JxYxEgcEthQb2NP8kV37asAu4V5x9TvuVLeRW3Td
7892	fee_transfer	1513	86000000	1	CkpaEiNM9svpGUgcYntztYJo1jVdNQHxtH2TPYkdpeQ18z9AaLsue
7893	fee_transfer	1656	27500000	1	CkpZPv28qvX2kLq7CJtv7Tkc16SKbRTGZmC2HAuj22GzdkGmxD6uh
7895	fee_transfer	610	22000000	1	CkpYaYJafN1X2hpPexfYFHMXpYJSjDaK8gEXDvDG2PXvU9FqPW6cS
7901	fee_transfer	1426	73166670	1	CkpZEEZB9rcGQBiBpRq8P6y9jYs1bydCCTimvxoBnnKKBCeUbrWKb
7905	fee_transfer	1702	263000000	1	CkpYnAXiNoiNzGU5TNKdFJaVYs661QL77rXJXcGkmhSyj3CdRE5SQ
7907	fee_transfer	1395	275000000	1	CkpZicrnpMh1g3N1DtvtQMU64L1zUipLK8wCdoNbJS6Wm5An7vgbN
7908	fee_transfer	2329	1000000	1	CkpZPQhK9hpbjkhMWQafhmWBGYbQkzbPL4k62KNUSxAu8ZfXQFhZp
7911	fee_transfer	1700	36000000	1	CkpZKcRX3TRL5Kzk1QN9po2i4KJqnxXNpLqEsxKVYEc4rpq32aZfb
7913	fee_transfer	1690	16666670	1	Ckpa6L2SrrR7AEtNrWxifTtPrJHw1CVA64WKzN5UUNHK98ki2g5pV
7914	fee_transfer	1604	1200000	1	CkpZRnV7537HW78hDdiaY4zMgxwoM8MWD9ijGB1Qoi6v93z6feZos
7915	fee_transfer	1964	3	1	CkpYdwieYXadJAUgAeTuU2rwr326Cz9GvzH3r6eb5AFUvQk44iMpv
7916	fee_transfer	1690	1799992	1	CkpYsReXft4oYFkJ7zgD8wZ5rkrBt8CnR7ZQqbxeiSUhjneGa1d9U
7917	fee_transfer	1610	561000000	1	CkpZqBE5dwFgSDSGUxJ6ypmsfS3VZxzxttGGFXJrM3GfHUtAYgDK7
7918	fee_transfer	1610	295000000	1	CkpYWyxK1WQ6fKCZ6VkUP5AGwseFGvVX34pa4RErUqcNwvenzwtA6
7923	fee_transfer	610	54000000	1	CkpZj8uJAzbbvzMYxA7kG6bTeXTGoDhCoLtEcp8dJaEpKB8AYa6eG
7924	fee_transfer	1718	54000000	1	CkpZAc1xW52LB2YkMn5tzdR6EnDh6dtaxRt7AN1sx6fTdpZgTA7UH
7925	fee_transfer	1740	62000000	1	CkpaErAxgwiYAmpMR15ew9hWtizHpBNzkYNy1oZGyCPQQccQc8De6
7926	fee_transfer	2349	10000000	1	CkpZNJVVX4vQpf1zw9RrYUbfCTBvDGpNWURT7WyLYtf3MUcx5xMhb
7927	fee_transfer	1604	2400000	1	CkpYrH1iXSLt81zEwyLJ7BYdGYt93n8wHL8rQKVam1EpcUbkTZfxv
7928	fee_transfer	2052	20000000	1	CkpZdNdMW1mmbRrpjB3cADSJ6N4kosNyVVQWGwxHLJyfAbT2How7R
7929	fee_transfer	697	5499989	1	CkpaHr4SEyYXAH9gBf275AuDUXPP5qmDv7BK17yAbXSBh8EaZL7bC
7930	fee_transfer	1690	2099916	1	Ckpa1jm85ZqtWQbW7Ttbs2qsGKYvkU47cPa9kPKxeXsYoBvFaqgSY
7941	fee_transfer	1719	33000000	1	CkpYrqqXJ6kxYWfoPTh91df4W4hGgvXcs1JWn3wqPhTuS1QhHznky
7943	fee_transfer	1623	118166670	1	CkpZC7d6nvkph3rs5RfjYbv3PLbzbqPGja49fdy8kwbAUCTeRU71e
7944	fee_transfer	2252	3300000	1	CkpZPktpEEY4v8xM3BfEq7GGkKTbVDh6oSNxmzKjsXSwNtwiqh7hg
7945	fee_transfer	1623	282699875	1	CkpYRJ2LbdGMjBaHChXER4YBpWfz6t4DjYEWg5pbDH533LR2nL5fC
7946	fee_transfer	1610	646000000	1	CkpYWz5PPNqDzHZf826eP1CupdFqCcGWLjx1nRUhPADM7C1FZxSVc
7947	fee_transfer	1610	39000000	1	CkpZWCjJTwk3dbhzrpAuV268SZNS3eHXvqG5YCH1VymDQd27zERLr
7948	coinbase	1687	720000000000	1	CkpZ6dto2AC48AUVSJz3Chn6Ts9HKokCEwRSA8u8PqSyCutaYu6bF
7949	fee_transfer	2252	200000	1	CkpZZMiSya6DYLx9KpFjKwnekiSrdWvqGoUrtXRXcEXmhQ4xrRPJx
7950	fee_transfer	1687	799984	1	CkpYo7ABXdMVwVakRj4sLqaWsbwqN3uyQFWMTwW2D9tLwEbmG87MT
7951	fee_transfer	2004	27	1	CkpZCQST4HdinYJ42LQP7Ydpsj5wba2aF8BBmZgkHbHJToCkst641
7954	fee_transfer_via_coinbase	2064	717000000000	1	CkpYfoA6XcEDPmycVtCfJVVbJkQRryCh9PSdCQHqUQDg6tLCEv6Jw
7955	coinbase	1489	720000000000	1	CkpYu1qzJ6pGVavYvyN84DR3QkihXCi5ArGraNjWo62vnofZWMAA9
7960	fee_transfer	2292	10000000	1	CkpZicLDH8fEJqYa6LtN3HHc3KNUiTgpRQh5nmb7bPnxNuPkTLaCz
7961	fee_transfer	2292	16000000	1	CkpaDhKnNGyKqV47QNTtj8cL9gpsbwjDa5v35gH9S5v1MLyidHKeq
7963	fee_transfer	1650	35000000	1	CkpZjoXfqFDLmpx4UciKwDuTZZxpe59wtVLVimb4MzLBmeN8iPykP
7964	fee_transfer	1559	23000000	1	CkpZgjFUWGFWRCwyDWbrVCzfoVCE2zNDqmqHVozoUGYd1XTArd2DH
7965	fee_transfer	1489	3000000	1	CkpZEXTePHXukRipAq4G9ycKDv3sgZy51Gux4UZ6nZF5UP53Svg6V
7970	fee_transfer	1540	24000000	1	CkpZNTmd6xS3Lg5HTdbCJDyHZhvS5ey7eLM15QJ7hgoEYw5ToBS6X
7972	fee_transfer	1395	67538460	1	CkpZuGW53FdTjmTbuZ1FjCkx7GqRJamg1uDokrL9f1zZz8DKW9Dq6
7973	fee_transfer	1692	67538460	1	CkpZxSotpfmYVV7VYKZ1f5S6q1ooF52qcrjoj1cn5YcWRPrnDw7oN
7974	fee_transfer_via_coinbase	1813	20000000	1	CkpZiEHPSBjFgSwb6qJV6VVHCn55tPUYXYfc7N92ma7uWDSfySXAd
7975	coinbase	1394	1440000000000	1	CkpZGesmptCUYtazzX9W66PqtVx1cjdd2yCa14wRrRL3pXU69UP7k
7978	fee_transfer	1650	233000000	1	CkpZSZJDZLey2VKP8DYNa2bPD2JQq2EmP2YFDXMFH3dHsFgBRWET1
7979	fee_transfer	1650	19000000	1	CkpYzi3uH6XCDFKMg4nAdjdA8jddu4bQckGmzDHCVfXRRkyEB29bi
7983	fee_transfer	2307	23000000	1	CkpZ8b7H5opHgRumLrtpNNkseXaBtWiGwDCPzChxoq2pKmG86r3VN
7989	fee_transfer	1471	11999991	1	CkpYSGzFAR8ZesAjdZipqsVXjn9vmozMpXKWCHSrzLVcNMu3sQMj3
7997	fee_transfer	1724	33000000	1	CkpYnXirPhLKJdzjzvSBTgwh67BhWAWZGrYPuJQHAukFcxiXUBs78
8000	fee_transfer	1611	748000000	1	CkpZnVRbHcG7LqfVmPZAAhvHKhsmEHFxjja8ZF37RB7Zp92StTTS2
8001	fee_transfer	1611	52000000	1	CkpZna3dZPsp3kqsiwJ2i44BV9kWTyQtmF9RwU5P3tsrfMDMx4Bxm
8007	fee_transfer	1455	1270000000	1	CkpZr6KZWLRHfZzwW6bSAtyQMeudNjgk6g9Ks6jd9vfJA8Fs44Fof
8008	fee_transfer	1455	220000000	1	CkpZ3Us3cYf7vna4NdZNx7ZGwSbk4typ9ZPeg4zk4srxJ7hVqGYjf
8014	fee_transfer	1455	493000000	1	CkpZRsFTeBgjx7ucCYE7BVHAdFtfxRDcMq2JMuh4unqpon6jR6p9p
8024	coinbase	606	720000000000	1	CkpZtmvdS1M5hBW3gZpBuEonCzw6LVpLZqxz3NPSpq4v9ME2NmjCP
8026	coinbase	1747	720000000000	1	CkpYiufBL4jxcpQEvRMLD222TQTuKbv9w1T3ZdEYAAW83ja77vKMD
8027	fee_transfer	1604	200000	1	CkpYfD8pSSaUdqz7J3M5fSWUK6GfzqcEzgzU9uYkK99h3vFTpDbZ2
8028	fee_transfer	1747	14599984	1	CkpYyVsyGs3Mf7To4zqyXxNEYPG31LPwyexF1W4UkqsgegLkSnZWS
8029	fee_transfer	1807	16	1	CkpZT81zieGZeiXUSpyebqTG4zmjp4obCWY5NRC5s2mnJXy3MFzhg
8031	fee_transfer	1513	542000000	1	CkpZgXz4BCf1xqoypK9xenhr8dYULjWpoTUkAA9yuj6pe1cd43odc
8032	fee_transfer	1513	42000000	1	CkpYy79HcLA4KuekBorGxUzZkDrvxJA9Moyx2W1znUrBE26Qh1U4J
8042	fee_transfer	1455	200000000	1	CkpYeCsp4NMgCnzqubX3ViUx1VrCWiYSQvjKXdu4ESeZKUNBjSJ1Z
8065	coinbase	1991	720000000000	1	CkpZubbobe6uNyFE6vpVyrJp51cwSqS7UFr4s775Q52mgoHKQ8fzE
8069	fee_transfer	1710	19750000	1	CkpZJzeTxCuacU53TeFSQ4y1ViKanJqy82AXkJfpAyGy2CHy5LUyW
8073	fee_transfer	1395	50000000	1	CkpYr9LUBGH4eU9B5Qcm1Su6xawS9sMBjHNkFYnTxKWv7FrAEV6a5
8074	fee_transfer	1698	213000000	1	CkpYZ6PvRTqMU8YdDTp2eRybFah2dsomgXjikorCv6GZFbduWTBQE
8078	fee_transfer	42	29500000	1	CkpYtFAagYPjbn4qkfa2vYFbyPnAcDb7LGEoBmDirwjfNmiySbM6w
8080	fee_transfer	1718	29500000	1	CkpZT11PbmwQGsgRruk325B5rQXFuKFDHWExWEGMSWVEKwLUjbQf1
8085	fee_transfer	1596	34000000	1	CkpZE1Z3fMBKPeaTv6gkCJESAiabpE6vr6HHsg2ktBDA6DwSoBqo9
8088	fee_transfer	641	47000000	1	CkpZCZb4VAsQueS9yoTx3Wvhf3crTVeXtj7D9cnaw47q4GRnjQWPA
8089	fee_transfer	1611	25000000	1	Ckpa5M57aG2BU31XRwYRuLsktZ8N1aybeE34wGbLsBNCDQ4hTqGbq
8094	fee_transfer	1608	1450000000	1	CkpaBVrEcXYSHypM31vGuMrFKVPH6nDPSyffLF6cAH95rwjdj5Dkj
8095	fee_transfer	1723	26000000	1	CkpYvuH6vrxo1hN7bNARqTNYPvbf1EERb2p2VS8kcdNHaotr4KYX1
8096	fee_transfer	1513	1340000000	1	CkpZbhe5L5Hczq9cgfRXoaWhFNoSc69YJgeVcF8fZ6EQdBxEjd2R4
8097	fee_transfer	1513	420000000	1	CkpZLzwvWwMt7NVkSDFdMGivhx4oKn3FUomF7mt6FSa6EL6vzexcQ
8098	fee_transfer	2384	15000000	1	CkpZ3Q4Q2KcLwRYWx1pJZDTACCeyeFumX4u8VYxzkpAEZvuqCgwf4
8104	fee_transfer	1599	56000000	1	CkpZndj3L15AAyNZK5d3vSYRwF3bdUhyeNvruWEsQnsH6ftCfnQk9
8107	fee_transfer	1693	48000000	1	CkpZK7BsnXecKB4JiJWyic9YrYoKyDYcnWj4mNqzyfLYrTYjJSs7s
8117	fee_transfer	1654	45000000	1	CkpZufby6NfLt5bKZ4MFW9GAtcFN8SF6gGwFVYFE6xJtcrKg1gaFu
8120	fee_transfer	1692	26250000	1	CkpZLgtjknGS1a8NqUtRKPW1XzAF2jd4SVPqTDm7aeLPyw2frujyj
8123	fee_transfer	1690	38000000	1	CkpYtqtVqix1ct1LWb3Yb72uQmwCfj4fk4CyUxtHrYh6gkUFoFwFv
8135	fee_transfer	2329	32000000	1	CkpZvYb3ewf4UoMhxkH6Rtb1gD88S7AXfJKTFLHYan5m82uviD6B1
8148	fee_transfer	1688	129000000	1	CkpaGMXmw2Yug7exfnyNaFHZAfcWEn8rGwqge7bZKwJqvM4vjUGZq
8150	fee_transfer	1633	129000000	1	CkpZ6PafCRAbRfR3CehPkotPuS8Pm3bTrSpzNktCy5E996zuXijCN
8156	fee_transfer	2261	3000000	1	CkpYXWyosur5DeZUqupm7wu2KJH5bSVCqAbkLU5J3ndgsm3s5ZUBK
8158	fee_transfer	1509	18000000	1	CkpaJ4Xw7Z7GZi3kof77WFZmgQG2AJsoeHEk3MZ8aoW4o1oyoot5w
8161	fee_transfer	2329	16000000	1	CkpZ2tTBBDcywGR39Ke4fdjpkznSFQseMhRfR99XdxgRP8rD4H5Vc
8168	fee_transfer	1439	18000000	1	CkpZn6LhnwGgm7KgFVzB4cQ6atsMpYb6HnU3C3yuLEtgwCB5BpetZ
8170	fee_transfer	1980	39000000	1	CkpZbkR38uiantZQ2EY4N5kTshVNApVwRW4zNQgbH5C4SDm84Pz35
8176	fee_transfer	1444	64000000	1	CkpYusBPBJ85mJ5uZk7tstZRrFVworSW3jFmU2i2MPeWF73DENFJr
8188	fee_transfer	2261	43000000	1	CkpZrAjHPBMiNoCZ6s9HWH55UXdSwidZxCoqUjzwRUqMyNBLoiTQF
8193	fee_transfer	1703	14000000	1	CkpYjytkThpDwu4fMVpvghRuSG9JhSSanZRytMhiyEXC4Snj6VPjF
8206	fee_transfer	1733	23000000	1	CkpaDGD7srWc5GArXgUfYXbZJtqzW7CeYTbUXZpyBcUUk5odQY48r
8217	fee_transfer	1623	48999992	1	CkpYmYKbA8JZhqi11cuB2ru7gSg2SqfEPnT7bonNaduW1niarMmjj
8219	fee_transfer	2367	400	1	CkpZ5Ct4nuzTpBcQaUVB3tRaQVGqbkqfvBeNwHGeo5bQv1SBFkHn8
8220	fee_transfer	2221	30000	1	CkpYq5fc1c29BiJ9zAhAth5kYwK8aLufhufspMDgxxi2iS5Atuhoz
8221	fee_transfer	2126	75000	1	CkpZ9axZTroyEFtbat8aS3GxjPC1MsYdDZQtbJwp54AZU89cXGJCZ
8222	fee_transfer	1964	6	1	CkpZzkkqg3oHP9gMzFsrHnPTUj3pjq5q6UWZjSG4iGFRCZCvYTvLM
8223	fee_transfer	1419	9864941	1	CkpYYTQV6d3NDkzWkPbd4tVZLDCBBxWn7x1No3q2m9PG2pY1kf2u1
8224	fee_transfer	2332	300	1	CkpZW8BgFAY7XdPEypFPitLsJTYo1LeBidXQxtGxpUDdpds5yxUwj
8225	fee_transfer	2004	4200	1	CkpYec19JfbAfybxe9LwXbCFuSX6WW4tHG2gUhZkK15S8eZ6jRGxG
8229	fee_transfer	1650	9864941	1	Ckpa7ec3UBa4icTBNmZvzsUQES8xZFjLfJLq2UiyZ3abGyJQ5bsCN
8234	fee_transfer	1714	95000000	1	CkpYQX2vz9dxj62jJVTrvbg1KkdCY43ShXPviak9VhfAcwaKcBP2c
8235	fee_transfer	1796	5	1	CkpZAusD9e5v5FQyRmaC8e5Mb33V6bZUzjabxVzSbK912hBWfXBFU
8236	fee_transfer	2221	20000	1	CkpYjD4Wb2KQDBnMNGURqv4etKLKpH4fKQrDYGzLSMMboUtJhdW7S
8237	fee_transfer	2126	250000	1	CkpYWKcUtSYDYnkUmWp1McCGxTZr72DCyckj1mLdkA1JLd3kDfh8R
8238	fee_transfer	1714	9725363	1	CkpYZ3gDDhfNHqx7ZLGrqGv8ekPD3zDjFnF2NfRJFLtqVvMNb1PAb
8239	fee_transfer	2332	400	1	CkpYbvsgxXRSFZqedBPW5gvNQ42HcC4SNoee12py9c42nqxq8RKgx
8248	fee_transfer	1622	18000000	1	CkpZJcL1z9fHCq9XcVj6sHyMcTMxqBvyUrTJtVzm1HjDf1bFLTXBR
8260	fee_transfer	1698	28000000	1	CkpZr2TNw768uvAbrKqfyGRCLsCTuGABS6aSAuYY8HX7iFy2ayZMj
8269	fee_transfer	2367	600	1	CkpaCQfymjS6jTQHRScaDAU2GHeMdLKtASsMTrGARQuGgar3UVw68
8270	fee_transfer	1688	16589800	1	Ckpa9V8HDnDuqzDi5dczwwhJuoPruH5bkySTp2xaaGpUGNLNwTXEq
8271	fee_transfer	2126	200000	1	Ckpa3XWn2RYcs8veo7vCY7kJLFG8QU7R3yEZ2xUqBk31zqqWrwPbW
8272	fee_transfer	1571	80	1	CkpZLVBPtyyfxAhgL3jaanHGq9LrXkWvTioUNiosGEvsCzNzeMbqe
8275	fee_transfer	55	14000000	1	CkpYR4wWr1qWF3QkyUZ3ZvRoLaGW9mPHXMawgmrHFXYhfs4PQ9kUz
7980	fee_transfer	1700	6000000	1	CkpZQVj4U3sPh5hcZnNGrrEjhGiJV93gGSf9A75Bq47NV37EUDdGM
7982	fee_transfer	43	3000000	1	CkpZMWAFy1BFybMmW4MfhweVC7F7N3iSLc1k8x8nYc7FyjyE3KVQJ
7984	fee_transfer	1711	37000000	1	CkpZkrneyAvbUzRqKv1QcMRid6LECcgLD9Pxb5eyqdAgZbaoymYWa
7985	fee_transfer	1708	17857140	1	CkpZ3dJRH5LMTro1tccEMU4L4seSMkWvLVUuPJCPz8NEvcfBNiyxR
7991	fee_transfer	1659	13000000	1	CkpZ3JMygAS7JmK3FZRoZrSxvzWSCDZKG5RmLgx4K4HmFChkjdS4N
7992	fee_transfer	1547	124000000	1	CkpZMLjMt2vskNmpfvSmfmeZjFg6tvWgH7LorsKmHPv223hB757qv
7998	fee_transfer	606	250000000	1	CkpaLbomNCE3WjLU9J28kr2zN2SsKSTuqmp2XRZGGbcLNggxW7cNH
7999	fee_transfer	606	73538460	1	CkpZSt3Kj6E2jPCquTHahgWJAMz9myLyce89vYC528QboGPNcuPsc
8016	fee_transfer	2087	2000000	1	CkpZZeGCQVeLtGnLC4a7knGabKV5BsX7jqRdTLoPogfmjsmSVgTEZ
8020	fee_transfer	1576	11000000	1	CkpZ2ZVMEjhyokPso4NUnqVGzAkQcyMdaYyPzk84gq2UZe5ayMgnb
8030	fee_transfer	2292	15000000	1	CkpZn6kTrPX4x1UDGUeXkELUfjS377hq5fr8KfFQjyBJxP457tMqY
8033	fee_transfer_via_coinbase	2330	1000000000	1	CkpYkkdW6r5J58L33k3VRyUGUwZvNNjLHME29bNXfLzuPuYXiaMN3
8034	coinbase	1611	720000000000	1	CkpYyWNN1sk82MfQAE555xJbxzfNL7whB61mZm1WuKmucDxMuekJU
8037	fee_transfer	1679	48000000	1	CkpZenkF6bCaejxYSRqACq6VqG7E7eXovL9PVwb9m5Q4qPKT34wQG
8040	fee_transfer	303	22000000	1	CkpZ2JvawPH8Q8GKQvDJmMHYxhCFKxouMvGZs3q8oBvUgZ48hMBsK
8048	fee_transfer	1471	1999879	1	CkpYoJVe6z6r7e1vx7LM4qV6K9UGYRA8Lsbu8g47xi3FEmVLvstzD
8053	fee_transfer	519	13000000	1	CkpZNYVREjdBKQ6C2mED1bYqPmmWY1KWrgjsxdv2NZJL7DLe5aKz1
8054	fee_transfer	1691	640000000	1	CkpZRufXsJHEwjiF3d861uPHfXZR4YWUhRrtAWuGDzFcUYNjFGGBX
8055	fee_transfer	1691	295000000	1	CkpaADK4HsUsWr9KqKMoAtMLE7j3FEzxf48mh15uUfs3HHpKxTjco
8057	fee_transfer	1419	35999999	1	CkpaEgZZGo4TWEUqDvQTVm8RAUvLARcqawQYvCicno1Tyk8AgAMzo
8060	fee_transfer	1756	788000000	1	CkpZw8HkqwNgqKm6F91NACP1ArWo3GZyS2jWN8a1W9RovqxjF27Q5
8068	fee_transfer	1692	19750000	1	CkpZDSbAJDCgVss7eUyTHpqznP2FyEgEh1msrTgjeQA3rckj8N18N
8075	fee_transfer	2329	36000000	1	CkpZxkUrBzx74FHaQZyTGWAEHJFureccBA5QzBGy97RoF272cNR6N
8076	fee_transfer	1564	262000000	1	CkpYb2oTr9hab63822nPTwA2DX8xTwtMMdTRis3At73iTSNZsewmP
8082	fee_transfer	1705	44000000	1	CkpYYTzwYgffARZzCpYweaa9VETgSnKNPnunHhZph8ceCxY7SQCbK
8084	fee_transfer	2329	38000000	1	CkpYqRD336aMKnhj1Xmc4dwqtMjmPrBtnwcrQhnpUJxdPQYpp4ewB
8087	fee_transfer	606	47000000	1	CkpYcaDuaPAMZbn5ZQ8iWpvQWB5YPMTzyvjxF81i3vJfi4MJg18E4
8092	fee_transfer	1672	4000000	1	CkpZCTxLDJS7ZG8YPrwbCBWsCCJtqddZBNH3eqwZACk4tWzomd3vJ
8099	fee_transfer	1710	346000000	1	CkpZm3tvVZKMrSBKJSLuxCaQd6x1NBq2dGkjhLqr6RmGJww7k54QF
8100	fee_transfer	1710	63000000	1	CkpYu8uh2dNAQJCVvscTSTaM2kZZL9JwGQFb5wDKxK9Tny9DWLdmd
8101	coinbase	1588	720000000000	1	CkpZZZHuSc9KDGpcVfL7BJNgYvvr4uUQsEpcHP5nLf7eYLLnu3aLT
8118	fee_transfer	1506	45000000	1	CkpZokkUPnpduskhh9rzmLSYSvGSAoADNeeweFQkPyFeBiQGziaMb
8119	fee_transfer	1649	26250000	1	CkpYhrHX4LcpVSH2Y4s8WtjvN4mCCjaSfa6RsXWWjANpwwkcUHjWF
8121	fee_transfer	1474	49000000	1	CkpZuVsL24H7HFLrxBpTyNCQAKgPSHkgrTuzQ15VqGak9NxEdvvNQ
8125	fee_transfer	1716	18000000	1	CkpZkpik2gz4aiifEYfPUNtZEVgnEP68vdpZNofTgJU82zhFKPtTA
8128	fee_transfer	1701	16000000	1	CkpYVZzt6E9fbcoG9v4CBLb6Sxerd48PYYBkdx7aRRyesKNSCVWcD
8130	fee_transfer	1679	236000000	1	CkpZ1Lp6zL9pE6AznHbXDcoCRRs9de792is82agQZrDSgbqu1Lw8X
8133	fee_transfer	171	9000000	1	CkpZfTM5VL5CuQr63ZNuq2Gh4mDTL6wgpjho7yr1g9QsRvfwhLpcP
8138	fee_transfer	1850	18000000	1	CkpZ9QeFFA7DrcGBN24rGiMDVypLoE6pFcDGJYhK11w8PpZ8F8iqT
8147	fee_transfer	1610	18000000	1	CkpYRbBZoynwPkCURRaaeR8sTPCqra2JL77UnLwS7RYP6viaQVAf5
8149	fee_transfer	1633	126000000	1	Ckpa1XWZpniinZjoQtrgTmdT47bfX3EHtKogsvAevK9Xd11iTBbGf
8151	fee_transfer	1395	11999992	1	CkpYQx2gNzHMZxxmxPS62MHzW1ByV7qh1gdjDg1DJrGB2vuzUmyWE
8153	fee_transfer	369	19000000	1	CkpYV1VJ6mjkYVZwumKXrr9PyToyUTwewraqHHv5zyPD8bAff8SBa
8160	fee_transfer	1714	18000000	1	CkpZNfbcBWxufeMXynAzJRM24KChCKrpgfVrWsmNkxL6wTnru5Pzt
8162	fee_transfer	1696	49000000	1	Ckpa1FhpfZKptzmYhjj1PJPG8Ua5DvBCncZ8vfijzkPJNVFnpbWwg
8165	fee_transfer	1593	57000000	1	CkpYUTF1P51Z89Hgp8KvYaDwRhzByrCBPKctDkzivMAuATBpGogcN
8175	fee_transfer	1444	67000000	1	CkpZQqRgKVibSbw5YBFHDqgbn4hVvbtMp4CWgHq4XM7tHsmRJgcqQ
8177	fee_transfer	1559	67000000	1	CkpYtULCSSdrowWCCyWxTmwgSt2vAtTM3PjnnWaP7Wti2UZMtFxgA
8179	fee_transfer	1654	18000000	1	CkpZmYt4katLC4UtD3ZTRZdPrTEp8k5twhBeMwnRSSHhUyKaUw6iX
8183	fee_transfer	1764	18000000	1	CkpZ4WCapMxKyr1gfGnuYhW6orQsHRnemTFYYsMBpC9wLmp2wism4
8184	fee_transfer	1764	15000000	1	CkpZiht6w7XSRpT3EXMCygEgXmJ2RQosL5V2NSh2s1fTRJMRYf4VB
8189	fee_transfer	2261	51000000	1	CkpZqaj6mKXgchZXr7aieorvvc3ChshhsZ5Wb6KKrC54zAoYcrpCn
8190	fee_transfer	2261	32000000	1	CkpZhTNzB7eLbtfdjTDznWqfkPfjuX4KnZtigfWo3qmwJ4c6gZGFo
8208	fee_transfer	95	21000000	1	CkpZ4FXz7EPJZ1QRXprPckbZrLyrJxNfnwGa2B54RiJD8R1i1Juz5
8216	fee_transfer	2211	48999992	1	CkpaKKFMZrt9PxGnjjF5B5sx2KBx7d4cq1xGiZ7yowdQLJ8qi4Qt4
8218	fee_transfer	1532	46000000	1	Ckpa29fnziy49PgDemXkV6DLqf5SoSrNQ2UyGpXejHrp5tJUJox8u
8231	fee_transfer	1419	47000000	1	CkpZ4ZWNbZkRzkF2XdZJBuzzWzXYzHWepQYcWUNQV24bzTSu7Mu2H
8233	fee_transfer	1618	22000000	1	CkpZ6Uc3DRuKWGLU3aYqpncu6iiXGPuEw83azDEbdJau2yert53mQ
8240	fee_transfer	2367	700	1	CkpaDMWJYep8AC1rCM86aLEMnsSTFGjcTGJQnpRaC7FtB6xMmJqst
8241	fee_transfer	2126	225000	1	CkpYU6LsJgMTCt6sRHPRjo3hQG84WbBJKtmnDGvMSnGq2U4AZrFP9
8242	fee_transfer	1807	7	1	CkpZDXUxWasyv8j5W3w5X1qN9mPwfWGaXWw7r5za3zPEKuEJmwKFE
8243	fee_transfer	2004	2100	1	CkpYsGCTfVof8RWxGRPbrawRbtAddAhagVSTsJC1pGbvDQohfWUMx
8244	fee_transfer	2261	17641890	1	CkpZZbNtwg2YUXhiASXyG2dJVwqkNUBnxeh7cYcgk4fmj8V7WjTqB
8252	fee_transfer	1601	29000000	1	CkpYvZUbFfsgyKXXzu8WRkMaizEMtsMnkqBNmJzcU9PYwAr9NMzK7
8254	fee_transfer	1850	56000000	1	Ckpa7oYMtKqcdurf1rQr6XNvxRNxvx5QgXwacZuQL9jrBDpnKnBFC
8261	fee_transfer	1701	19000000	1	CkpZjA4PbMDAoKJUu4HithENQSfQ1wSTZ6AkqbiLwzkeu7p8tdZNn
8262	fee_transfer	1684	18000000	1	CkpYw5Rd5YKs96h4pk1FXXhe3EhwEHupSULLEwuSpeZGP6HhYzBxY
8264	fee_transfer	1699	29000000	1	CkpZHQFp7J4ZEgGtQmtYothjEGLdmmygdotZqNCvmRNCMNYvjdnqV
8267	fee_transfer	1706	35000000	1	Ckpa9zbp5DZEtoW2KtJ1t6V2fZc8z4qPjyqsNg8Q14HEXgR9bXq7b
8268	fee_transfer	1850	14000000	1	CkpYorhg9JrxWKxyKTpih2usErik89jgy61aCodZcyYpqEee6139j
8056	fee_transfer	2112	3000000	1	CkpYgn5v72hq1vqmSbzRTjZafksC7nkhdVk8hNms7wX4W1KGtuLwo
8059	fee_transfer	1684	39000000	1	CkpZqYdVQFsmWNCdSp4DgWVZKqJWhGL75pNZoiVpo3FWNbtY5Au2w
8061	fee_transfer	1678	14000000	1	CkpYxtp9vfdgJLnbr3sXVR9m6ZKBxQunp5acX6xc6ekvksW9rLpKD
8062	fee_transfer	1719	123000000	1	CkpYr3CXkU4JME9QZihxnB6Lbo9kKcPnxFwzUzNr2xKdAcToPKZ97
8064	fee_transfer	1991	137000000	1	CkpYzW66C9VLyynJwHtd1dU9d2qDMZp7zhU4q59rMXoAfxdKTt34C
8066	fee_transfer	2301	29750000	1	CkpZ847sRbspNFPMgiXKmqrVj8eFsSpm2gXuj2d324ormrsgR8Qtr
8079	fee_transfer	1596	29500000	1	CkpZDNSPdTezSzHv9uhVHr4P8ZctCqTFG14CYdmVLTQNhad8o16AS
8081	fee_transfer	610	29500000	1	CkpYhgbMdMDUuvevFP5GJaeZtGoHdqSDY5xaScvHGXR3bSDsAGQ59
8083	fee_transfer	1693	18000000	1	CkpZePqkgcBdbeKN8AwJpm6jBKPod6Hnh2D3KQWGGWpKyWR29EfTV
8090	fee_transfer	1439	4000000	1	CkpZe65vXu3a7Y29Dssi3T8fETKVwEnvYkYsD9cAnrVqPygPB7KrZ
8105	fee_transfer	1513	920000000	1	CkpYoVqeL8eyJA6h9j9rhb4zyJUca7t9Vsx41WrKJSVPDYpXDoWXK
8106	fee_transfer	1513	130000000	1	CkpZVHiSthMQY864CEuMQwRZ77DCiQsxLru2ASEJTW1cGBS33dDdV
8108	fee_transfer	1613	14000000	1	CkpZTLqqzR1vmR8aGwobnHHx5CUj1sTFqSQYWHQid776uZRTgXv85
8109	fee_transfer	1710	539000000	1	CkpZK4NsNy4XDazbRHpvtSMby2RJVd8xpFU4PXLfLRXRJxTgtawED
8110	fee_transfer	1710	60000000	1	CkpZbbcxjKRD8b9KJXvUkWXeehVWQa16v8E3phvLSA8ngZSx3kubx
8111	fee_transfer	1445	13000000	1	CkpZAWF8b1EdP7KoG8CmbhDNeQhrrNTXYM2p1p4bRKTwG6RLcRSx9
8113	fee_transfer	1588	111000000	1	CkpYS3i5wJXCCvb4JpUqagf11KHEn93vEgCtATNqvpMha9ig8vZeM
8115	fee_transfer	1616	49000000	1	CkpaEjyAD2cq2zQArZgbLCNo22CLvL3pDeYyTxR4wNPUim7GPCv3h
8116	fee_transfer	2307	45000000	1	CkpYYqs4TkaMyW3A6MatKKwzcxZw6t5ompYUkVLmZj3pCH2pBPh7Z
8124	fee_transfer	2248	15000000	1	CkpZY2yPE5uHPaNsy4R6ju6s6DNsiAUtWpZ5jCLtMe9oPK6Fz6Xzd
8127	fee_transfer	606	16000000	1	CkpYfqxvSErSXSZcFkKGmQBNfWo9sn4mcgFc3TkqG1cvJEq1NbsSq
8129	fee_transfer	1740	16000000	1	CkpYVuoiMYecgWtVmAEHQJLdD6Yasdes28ExZzBdXGjH89kYfMAjp
8137	fee_transfer	1679	17000000	1	CkpZZ2pwUS49kjFrfPb6JzaPynhCmPWPcw11QtzsrchX3UGRaenba
8140	fee_transfer	1688	254000000	1	CkpZASPWJmruu3WjVrQzaa5HJzekFBsXNUb6SdwjgQuRVEyPqPYNR
8141	fee_transfer	1656	18000000	1	CkpaKVzZbcoSLvCeaZz9DQo66RjsgbgMCGM55L8VHsPYyYNQxSzQz
8142	fee_transfer	1759	18000000	1	CkpYpGChczKbUuWexNJbBwZCYQAURvVDr4f4cKXUe7pSwKBdjKSrS
8144	fee_transfer	1440	135000000	1	CkpYRQPh6ULpJtUujbrxaUBjeewAqRmYATg6uu1r6PtD6K7kqnhYG
8146	fee_transfer	1394	28125000	1	CkpZ1p9FrXeQDuAVKBCEvtgj1Ko7SACuvXDX4Nv3jwTTPk7rCLuAZ
8152	fee_transfer	1679	19000000	1	Ckpa5wsbtkNZPJ86upjgYP73fTYtHHr86C1hEiKwebs6QTekxtHNZ
8154	fee_transfer	369	18000000	1	CkpZkeGod73P56jYCHMCnsuVqYT6CinQYVJofTvSB2WJ7r1cYHM5k
8155	fee_transfer	2261	19000000	1	CkpaBWA2ZSQX76g2R6NTKnqsM6an8Q7QcMT5KXWbSvzNbq9FS2LKY
8159	fee_transfer	1509	15000000	1	CkpZdvXbdxZi2uxnFVaU9XWcYcW9Lr8fhdzjvmPYVHF9M7uBBR41i
8164	fee_transfer	1696	57000000	1	CkpYsYyG3cnde3ktR6TETHmuCybXgr3nBKB3Csw2L2Du6L55AraxS
8166	fee_transfer	1593	970000000	1	CkpZ9L2NcYj7owVgk4pVGpWgVZR5iz16KARvixJj77WFNWaD9kQ5E
8167	fee_transfer	1593	1000000000	1	CkpZi1iEavE68ZDuDViLqBAJVxnMSubFNUevQr9A5jA1PUXKWi2Pr
8171	fee_transfer	1980	1880000000	1	CkpZFdpCtmcdrH6i8PKf3p8rMyhez6vu6gnVLLvTUYhNZwzcTL441
8172	fee_transfer	1980	600000000	1	CkpZqF9Fz2j3g89aa4wMbVCUnfYBQtYWZfVcVtHfyQeuivMyqrS1U
8174	fee_transfer	369	67000000	1	CkpZJrEW1aN7JpdUwXWXZ96HxMLrpVMPk8oY2zLR454DrqyP7qX3H
8180	fee_transfer	1422	16000000	1	CkpZX9qMZ8SgB3PQRpCwksUvEuRERkSGYXnUFvRXRMpoKaxBvk6aJ
8181	fee_transfer	1547	16000000	1	CkpYjRWmMMauVCezrRSWvNuoDS6fq5gmkLdZLww6vLUWyPEs4KcrA
8182	fee_transfer	1764	16000000	1	CkpaC4hNbNg1v5gzAnZVbodjbP1BEL1DGyLX8q92w5KnAnpK5iRqB
8191	fee_transfer	1549	17000000	1	Ckpa6NAyFcBnA6r96hwAKPBgYLsrB8JVCrwaXheS3xp8Fcqxhh4vK
8192	fee_transfer	1588	17000000	1	CkpZHJVd9AFsmA4huU6YAnqzJdKGfYMSsCWaAg7tvbRieRnHP3wzf
8200	fee_transfer	1759	13999779	1	CkpZ1YifQdhtjodyqgNTraWZeHCEJETpSeHeRjJMHpXzjU36ZvteG
8201	fee_transfer	1807	12	1	CkpZEFzKwWb1E4rYJoEvCNvyrNzB4KeknDZ7miHrNSi565VKzNe96
8202	fee_transfer	1571	104	1	Ckpa3fMhyP1UU1ZF3ZSWt4SYwTLA2GW8A5YBNbLHYUc46F3r9Sz5J
8205	fee_transfer	1701	31999991	1	CkpZWzgx1prkT4wu1HiPmivfYUmap9KrrYS21NXJ4dECnGcx798yY
8207	fee_transfer	1733	20000000	1	CkpaGRMcorsAQ4us2m2wyuHUP6BaDYwjpmWwvgUL4mbg8c6beLMHs
8210	fee_transfer	1807	15	1	CkpYf7jmKcLoZcFG7De8fiKEY17vZDGPPTmzzqFqwjTJuFs7eJfda
8211	fee_transfer	576	20999841	1	CkpYn6DWxY95fRyA4AX2DiEEWYMCTirQpvLBHRfAVBwBZjEAEy64e
8212	fee_transfer	1964	7	1	CkpZ9E8vkZdyCEmB4HJzdsMSsXFwqji84aWSbEJfMNxQK6R984aAw
8215	fee_transfer	1467	48999992	1	CkpZFGRxLSKvgA7jYNgN4G5bRPGXUKU2gLYL2Dv3AKUNDcc3nUSfV
8245	fee_transfer	2261	16641890	1	CkpZU7ahW1D8EkS1LCyWxJZbij7UP7hWF8JhtMBAqaj1c65efBVcz
8247	fee_transfer	1622	15000000	1	CkpaJ6YHcKMUSLSSgPy8ndzVPiMQVTgHaTcQstFRx6STvUCYDE2qC
8249	fee_transfer	1768	15000000	1	CkpZ5sfg7YBRejZXbGQwLgvEtZFqR2mXTzh2cJqpsXo5sJqihj8aG
8250	fee_transfer	1601	388999919	1	CkpZfAF2iMF8G6VQCf1iSL5jJPVCxz5ZVDKTp3P6eS2XWBFDnd4yV
8251	fee_transfer	1807	4	1	CkpYT8nz9A46bK6UcAdsfsmz6E6Ktcj5fcAnC14dX9qBoUrFiC85G
8253	fee_transfer	1850	27000000	1	CkpYrQvNPgUaC98xxrf5DG6TA5Wgu4H6cQ7STEjAPzTKqkCpSEBY6
8255	fee_transfer	1476	18175114	1	CkpaBJym7n4kvPWGPEMbmPeQWTN7Y48fFsArzXoDjCzv71CndKsdQ
8256	fee_transfer	2367	300	1	CkpZF1Sd7f4U8Q6Sga2PKkpzvQC8cfL7TeLt86Y4MDwtEXEycPXRc
8257	fee_transfer	152	200000	1	CkpYuRNiV6gjPWncJLRJyomZrtspoTSt7FkvKvuQiGKZ4An9y8XZe
8258	fee_transfer	2126	400000	1	Ckpa3HnpkAMAcjK4CYkKCLUA5Bq8UNxdQ8fpKJdULHRXhwXCyCM1x
8259	fee_transfer	1571	64	1	CkpaDYKLjhbgh8VEYtb6Aq957SDQsBi27bnLT968jzDNYRLHacSo3
8266	fee_transfer	1610	15000000	1	CkpYxwJ4rMHLhXs3qzCxLXcQkWiGf5EaMVjKxpu1yqi9dhQUaSFsB
8273	fee_transfer	2329	41000000	1	CkpZNFAapX57bLhGDusHFKtnCoQgyiheMjP79EaRLV1iDAgs93h4q
8274	fee_transfer	1622	9000000	1	CkpZrM9KpeLYbzxpeQv6ajeHekkK5M3CBFES8ktyukoKSwNcV41jj
8276	fee_transfer	1688	27000000	1	CkpZBgKRZek6WkJznbHmUXFbERcqn3jwU9SAPaHhuPb1Hy1JEpDgg
8277	fee_transfer	1688	32947694	1	CkpZv9EXX9x91LDXtTXvHVyXBjLidQE2erov9Hw1RvnuharHbnPg1
8278	fee_transfer	2336	2	1	CkpZAF7nwyztuULM6wypSiJi9gJxtsE7JYXe8qZtfLWpjGm1tYDJa
8279	fee_transfer	1964	5	1	CkpZNPqnRk5ggPySTPHddotNxXG4opLpnWyKYAL6kUUAsuo1A1iQz
8134	fee_transfer	2329	40000000	1	CkpZ2vGkEaPqcEnpUnF3PLiJNvEcxfLEg9qmdTWjSwJWzewSkUQ6M
8136	fee_transfer	1594	33000000	1	CkpYi41Bx5wJXjqGVzb6omNc4ida5uzaHTtetLgh6juz4vtojNVkP
8139	fee_transfer	1602	18000000	1	CkpZZQ5dusb3Fp6dRsYi8LD5ButbHADPG2erAWJwdg1S8z2fgtuzD
8143	fee_transfer	1671	135000000	1	CkpZHddncSv49j8TA8EFHZHPji2e7KdJqZ12hFGcJvxgC756VqdP5
8145	fee_transfer	2306	135000000	1	CkpZm52Dcw5xEmRXk1A4GhVMYPQXS1dRHimVRsVR75NXyzyZTbwpg
8157	fee_transfer	2329	18000000	1	CkpZQHq6A9SB5NG52rV2ip97eZkmyg6yqu2K9BLsWJ6rKGjWo7neW
8163	fee_transfer	369	57000000	1	Ckpa6QhfiZn2JnSgLZ4Zg2LRoragBkYyqGShf9rP58qMSuozG2vcL
8169	fee_transfer	1439	17000000	1	CkpYcqfm7tcKbUu2jMt3nyYzCQkB8T81TfzTyUNu4dQCeAAkk6ZmF
8173	fee_transfer	1471	67000000	1	Ckpa3UFwzPFSiX5KjupNbrsPDXuXkLcGZoyJ5C8kCnmb4Je6mtX95
8178	fee_transfer	1613	54000000	1	CkpYp9gNmEFQyypPZb13BzJFUY4RpE3UhyeXFA4wtB4bjbLJAm17Q
8185	fee_transfer	1688	18000000	1	CkpZkJovyMxM3Bs3ATY76dGbbwu1XXAT9u4HqXBPwvg7hNakeq3q7
8186	fee_transfer	2112	30000000	1	CkpYbGpDCVzomavfge7pxkxoHi3tA4gQWirqf9jZSpZBZGR2AY9ge
8187	fee_transfer	1623	36000000	1	CkpZbuxhKgpvJLRZjVqfTdhBbs9SB7tdtwfxAPgUzYJEjPiZ52uD8
8194	fee_transfer	1759	13899624	1	Ckpa1ogqyCtqvZAXgZjQWacUEWLioKFZZNrUpkbDEDGbdz9yUAH3K
8195	fee_transfer	2367	100	1	CkpYgF1uLmky91UQiChq4ctjiTViv9JYkXmnJdEzhWFBQJwJGyQ4k
8196	fee_transfer	152	100000	1	CkpZFeug16CXSQCZCifvicv5z7fRo77jKRzGBmqQjFNrbXdHkFRwf
8197	fee_transfer	1807	10	1	CkpYix6hT6AGGi4qRjk19gCiYCZCRuUrvHocZqqQQ4U3NaRzuxDVV
8198	fee_transfer	2332	100	1	CkpYVMiMz21uJ5ABdP8R11Sy35x81dUoFTuzrxiW3EiV2XNSRhucV
8199	fee_transfer	1571	160	1	Ckpa1vjb3PVmVzH9oDLyM9m83GAQiw1MryCVVdU5esHMPQWHjYMzj
8203	fee_transfer	1759	31999919	1	CkpZe7LdHtDR47D2mUsoeTzpJrpNNEhAhRhVD1yb8RbucEw1ejZcc
8204	fee_transfer	1807	6	1	CkpZC3zcoU9854uEw3kdoCqrvjpamt2ZJBabh3VoFzaLeyBPCFxkm
8209	fee_transfer	369	35000000	1	CkpYYDgG16Nr7KBnfJnwssgysSGZzSLWPvMKuzWQhRhDZMbchKE2Q
8213	fee_transfer	2126	25000	1	CkpZrN5HgjhiLFSSSPSbAA1v6SqPGtLbW9WbpLxyH6pKzgA53GAzJ
8214	fee_transfer	576	8974841	1	CkpYajgs2T3GnPdSbPecqcwsVYDCNG7kG4qCdoKWUMpF1Ud6FhrQ7
8226	fee_transfer	1807	5	1	CkpZf1CW2ap1WAkhAE2HJAiHC6fFnAFw1pdRkbSS2sPMMNfpa1jMG
8227	fee_transfer	2330	1000000	1	CkpZ3h8G7Gg3HapuCGnWCKzSskEt18tKh94sbdg1dt1CYgnE1rjpa
8228	fee_transfer	1419	222999855	1	CkpYyWftirTPjsJ5tbZ4epfphdFUKZ2mzpQqMaiVi3MHKwX9TadHh
8230	fee_transfer	1546	47000000	1	Ckpa4eaDF7NDsqfqkN6CbWKKBJCbCrBm3cdwiT4FEfpBYWj4hDWZt
8232	fee_transfer	1419	26000000	1	CkpYY1jskXnmaodjWsexGCBpnv9Jdm8bJYJ1QCskfpPGgVdvEHPoW
8246	fee_transfer	2261	335999991	1	CkpYYbe9cxkjjG4AkruE2ZjnSpf6LrTjg7wjBnqgVz1AMVDuTwCdd
8263	fee_transfer	2086	29000000	1	CkpYu8GKZ7kCRE8ZePexJ3EbsNE3T8HPUB5KFvCp5F9UVkEUZjVnA
8265	fee_transfer	1596	18000000	1	CkpYv1TKbuuhNn4KM4b3gprs14c1Fx86XJ8dxR7Ysyx7oNmuJR1my
8288	fee_transfer	1471	18000000	1	CkpZN76GLDc9dEcTm2vCNMM6JjbusrgsiamLeTTyRYkVYR4MDgM6N
8290	fee_transfer	1992	19000000	1	CkpYtC3wJ75GNUJVfyZJmnGyiPXUZcgv91H9QFXRHQndJDt6EdzA7
8305	fee_transfer	1699	28000000	1	CkpYf1M5tyxkj1se33JRNn49FqwvzpMTJAZw4qbaGCRsR5MMgNrJt
8309	fee_transfer	1439	60000000	1	CkpZ55AvZvDELvYzAiPKQL2FCig87BvJt82AMMqyhqEAU7od4Ui5j
8310	fee_transfer	1568	125000	1	CkpZuw616LVjtoWfXx2e7rBo8U3h8UirimNzyG487b8sPcFBb9GME
8311	fee_transfer	2126	375000	1	CkpZrdw3YuU2DiTbSmGNt43Wx7rRNXag1X3kGkvtwkXoNx3CtkJB2
8312	fee_transfer	1807	13	1	CkpYomBYo2AaztDp2H68ZdjaYiSho3s8kpJfN4Ks6vqoLKyhp2qqd
8313	fee_transfer	1439	427477974	1	CkpYk6i4GUqdi5RQQV7QYpWoxULUiPs1qkb5oGdo31o4eZuuYExPq
8314	fee_transfer	2004	1400	1	CkpZJQZfBYYwWz2ZKfmiEjxWip56Gc8KiKoV3NZPZ32rwQnDmviBu
8326	fee_transfer	1762	17000000	1	CkpYT4upstMPqvSTS2wYNheqqAcvPn57HyP3ydaicdKHqJ1rQXdEa
8328	fee_transfer	1699	19000000	1	CkpYpqzox3vzoZrMctR66xiUDFs4ifwa5gK1rpVCvdAMSZ5R23jeo
8331	fee_transfer	1395	118000000	1	CkpYrZZMaDLqNtTprFAsJM5Kp9ZrZGYrPiR21VqmwnyzF5Z2xVEY7
8334	fee_transfer	1764	118000000	1	CkpZqGJMz4Jqy2KoUz6oevJVxNuEDEQBvhHymQuR7Sgg4RhfSJ8Jz
8337	fee_transfer	1675	17474693	1	CkpZK7R6ETH7FS2qvtskSgyxZH618RPCqdb8GPRE3ysbijwmU5sbu
8338	fee_transfer	1451	4000000	1	CkpaCn7LXhA7t1Kv4ADYEF6sGHhk4d4jC1ZoXogmWgoghKJTCBMzX
8341	fee_transfer	1419	17000000	1	CkpZS6S6vTL2a5JQYFNKmaucheYiwcES7hUvRQffjGFWJkCtCG4cG
8343	fee_transfer	1419	215000000	1	CkpZbFGMTqitarxMuUKw2ZmrYvfsTxPhmmb7xRC6R2Mti9d4Pinvn
8353	fee_transfer	1719	17000000	1	Ckpa2ADwW8MSmg58j7HtsgM1ZMQ9JUihVq1ihPXwXmZXmEraY9T8T
8355	fee_transfer	1684	37000000	1	CkpZhMU4vAYatz8zZEUx5Rez2v7ZbmeyHK5ahQvEA6jW229ufAEP5
8362	fee_transfer	1395	28000000	1	CkpaAhwz1mmqahFyGLqLmsqj9YwPSPgxbBkgizkquBr33FzgE6A3M
8363	fee_transfer	1547	28000000	1	CkpaKptMMNrH1jfKaDEHv9FscPapPUKsmEK31jTkLJyKUrYUF6vnW
8367	fee_transfer	1547	14000000	1	CkpaEwHrNdwMzEzefygx24xEhhdVsVYrkhFmoTyqxPPDVU7mRxNui
8376	fee_transfer	1672	19000000	1	Ckpa7hisQvDSNNJcPjCbB55m7thc9uUspXh9VtRDYvMBoTRCP6LCx
8389	fee_transfer	1522	14000000	1	Ckpa4yJGDKUqvEzSsBMftYzahGdfTCPVPRne8HVJ8PiB1VF7PTesE
8395	fee_transfer	1673	18000000	1	CkpZJkWj2LnHLECxtGAcoShUrhR3NZh7qmoTRimMHehCg3qT8Nj5p
8397	fee_transfer	1992	38000000	1	CkpZEmdobQU6zQVqMAGCmSVmtX2kqjBMfMvt9QkU4tqFMLRzVA7LA
8411	fee_transfer	1705	19000000	1	CkpZt5CnhxhqJSmHK5TY7HzQQCD5PS7ootz4S8PY6NEMtRbsLoceg
8280	fee_transfer	1679	27000000	1	CkpZTYK5EihaQ8Fv6PxgrmbA8hUzBEMP3Cggg8CUwBgMPoFjWsoWf
8281	fee_transfer	1679	27947686	1	Ckpa3oqxsdDs8LQ4mFLEW1TMq97uj5pVgx9xpJnytUbWbzAKrjZbw
8282	fee_transfer	1571	96	1	CkpaGpp1ywNsWNJfiEYcCJiQVwxtYgmWfxkXtKyCkSX5CxRppywji
8297	fee_transfer	1402	18998999	1	CkpYunBydQpKWvfmyq1DbEazb2RLJkZpKQdxKFFhVjHMWC7RMTnAY
8298	fee_transfer	2367	200	1	CkpZn1nXnSijQTAMRSfU5PkHdsyiQHwFmxYRyL3zpTtwZRHSJX67W
8299	fee_transfer	2004	700	1	Ckpa8QrPiNNyoHzWR6JgoyHcTE72mk3BATYg4Jxzeyjwn8izyLASM
8303	fee_transfer	1690	18000000	1	CkpZP5cGMnW3XZAdwL6GaSVjuj3jCVKVE9xw365CXgiqvASDxDgXT
8306	fee_transfer	2087	28000000	1	CkpaJgfPkQstcnFTPSVotMvH6YCgW1pAsXsJvnZv5JwrDvJGWw7BA
8316	fee_transfer	1756	937375000	1	CkpZmMU37vRKg7xxVVSN1mci1R7pqiY46mhBYbq6XmLJ7PpzERBKf
8323	fee_transfer	1702	38000000	1	Ckpa3UgkDXueYz7XdBhxfXh8wRUt2JHM1iPZp1BawdJ8VtEB3Xw1S
8325	fee_transfer	1762	18000000	1	CkpZ6xh5YoPdMBRB2yYeg8EZFCxAo3rtiRgzvFDH5sDU25Co7uo3w
8329	fee_transfer	1602	19000000	1	CkpaJfUyho8V4GLhKKuRjYCjGr5CFwCAfYhMe83mZiTwUgVdZ1Ed4
8333	fee_transfer	1992	118000000	1	CkpYb4BJx2T7vmzwy6RrLtM4kTx7kGRx7FsrRBMugzYQc2ZfGHmSx
8335	fee_transfer	1764	116000000	1	Ckpa1HzSwVL2dUV4pd7qHXoJzB8WeFzuJAxu8fH6dPRG6hvG119ba
8336	fee_transfer	1670	17474693	1	CkpZ7CPaLJwFeozvG6gRPtvi4FnrkcMFXkY5SfV4hEwAoxEfehprx
8344	fee_transfer	1613	16000000	1	CkpZnMsk71ZjCeXZ1YXa4q9xKBTiLdcANcoLsrj9tnFCetLePdRb2
8346	fee_transfer	58	19000000	1	CkpaCHPxsyyjgPKZ2eErZD92Ktmu46UVzRk3688Z342ZN71PueyTW
8364	fee_transfer	2087	95000000	1	CkpZ5too1ZoMu56VJcNLwQkYcfQtKsSC3YNq6Vizse2XL9R9evciG
8365	fee_transfer	2087	21675436	1	CkpYdtKc63eXZAQQksZQaeYU6FBG2y7wA8ssdggS4PXWDkAwQo8up
8366	fee_transfer	1571	56	1	CkpaJTPrRCLxeEt5psMPz2roaqpvBcfWAinHxccTrHNEB2RSdenNs
8368	fee_transfer	1672	15000000	1	CkpZ1roanqArWSMudznC72kJH7GjLoMTsDA6t1uS1q6xXL1sm5S2h
8369	fee_transfer	1710	7000000	1	CkpZmeUX8DfLbPpSyKvWwGuSWfSQDsrbdTwF7bVuzxXQS96yGwkLp
8371	fee_transfer	1670	29000000	1	CkpYoUQBSYxy6iRajPBger4PAFBg1GMpMWivpoqGgnGJ84gjGuzGf
8373	fee_transfer	414	29000000	1	CkpZc9YWkmxh97U9hz4j1axrJVrBpdSqQuj7neurnmnZERqC5oz2e
8378	fee_transfer	2367	900	1	CkpZH2bshN1JaVJf5aMuSAt1HNTPtJhjub19jJEaby6YXH5wAuGwP
8379	fee_transfer	1559	7792800	1	CkpYwHq1xqYMJXNQTRrM2VhEh2seZXYhqUdMDsuiqVRXQMRoBeHEk
8380	fee_transfer	2126	50000	1	CkpZwzhyF4TZY2UppmmH1edp6Fhgy9tRbeRS2d91D5DjDs5wQQb27
8381	fee_transfer	1807	17	1	CkpZwDH8yajFrYRD27JHXs8oDHeUi2e5c6c2wWmQAJwDXwiugvm1t
8382	fee_transfer	2332	500	1	Ckpa4nGMk4y6LdfwHfxev9HaSHJJF7UoEtyfeq9rFBzV7EeZmTovu
8383	fee_transfer	2004	727	1	CkpZe8HPd4ukGPqQjKC8UzHdjhbtUH39yT4PxML3ViuukZzSKQD6u
8385	coinbase	1394	1440000000000	1	CkpaDBr3ZmK8PN76rRcBPvmWvA1JEXwr1qP4xbjuJZvN8tEmndmNS
8386	fee_transfer	1394	14965000	1	CkpaFP1wTLLBsujz5iZADrUV1x9RtdCgMNiKXeD1wM7M5EfZsryk3
8394	fee_transfer	1679	18000000	1	CkpYtTBESSMBWCxGRYfSsmYPJGY72KEz3A327KPvTk1z4Ue8FkJQq
8396	fee_transfer	1560	36000000	1	CkpZWYvNSwcTdLowZDC8NA5NJxgh6JuKma7VMWuWQdXJ8cV88hB2v
8398	fee_transfer	1980	21000000	1	CkpZWUBtusrDtWcqA3cB9wUottjDGYiQYipAW8QRoHDw64ZSuap8e
8399	fee_transfer	1980	15764171	1	CkpZpWopNpAzsNKiE5u6EvSWfv1NEKrCUcSAsUHRjuPhJAQdfEA8B
8400	fee_transfer	2126	100000	1	CkpZKAxXiPCyErBzD4thtiaYbBUwvw1RsxK8nVkmvEXukEFTsvapG
8401	fee_transfer	1807	20	1	CkpZb7KaydcSPe93URBBYFT32bHXXGyNVqWgs3vtaPBNezFNpo3dZ
8402	fee_transfer	2004	36	1	CkpYaVVzLVinFSKCCAjGUk5R5Bd2xRfbjXPrMr18Mqqhi8JbGr44T
8404	fee_transfer	1476	17999991	1	CkpaKuv8CNcMgyvbsjq7vVdh7yuqajEKkDXYdV4HFYTAHw3hXAxY1
8283	fee_transfer	1395	17999794	1	CkpZkChKAwGd5AgeLnohBcruntD99YDoXYB7oxfGaXDase3LP2sST
8284	fee_transfer	2332	200	1	CkpZTr5ZJhD4VG2FjVoEbuQK4sUEVxERhLRhUMueCWY3LGQW6o1pP
8286	fee_transfer	484	59000000	1	CkpaAPAhvx3BE7gyzDzh72pk2fSjTWC9wNLP2Y4rsCYH28YSDvJWx
8287	fee_transfer	1451	37000000	1	CkpZfum7fohamLc5w4HkoRNwQigjhuKfXQULKpcPhutJaeviwJeNB
8289	fee_transfer	1395	19000000	1	CkpZKhMs7DvHYquBJqyDjeDXGogrw4xC2h5ioWs5wkioKXkb3ZEWR
8300	fee_transfer	1673	18998999	1	CkpZ8NxrVEfTpen9mWct6Mx6HDhATLoN933wudYwSY8bho38BPvGb
8302	fee_transfer	1715	18000000	1	CkpZRtAAzp9bFsuBBaqXDydxq1hiJYRehDruHcmzKJgptNNTfdJ2R
8304	fee_transfer	2086	28000000	1	CkpZeFqWzUSeS4fPzLAxgkBBQ2UhtaK13n1yW9Dj52euue6cFyJJN
8307	fee_transfer	1422	38000000	1	CkpYc5FFcy1KcbYd56UY32iDQgbFZ7mechYgHGoC7kVQG3fzy5ehu
8315	fee_transfer	1588	136000000	1	CkpZCnxpD7b7B8gSWn5T3ezkB6DmXGau34ht8AcizdE8Eo6D8UBC1
8317	fee_transfer	1568	175000	1	CkpZXoKJWMcuRARXvuNP24oW8kPyR1micavd2bnu8RTMHSSZ4U2A9
8318	fee_transfer	2367	500	1	CkpZ8tPT5HyWPy1Y8SC3xrtcps3rUyUwG4xah95Ub4wKsYfa2hdoh
8319	fee_transfer	2126	175000	1	CkpYyzyEForU1wBQ2F8szmEiqw4kgL8F6h4AaTKsiTAee5fWREHdZ
8320	fee_transfer	1394	7605000	1	CkpYrx83iXoT75xna8xh2M92hYmhLub2Dt7zYZnYTC45EgtFCWEaz
8322	fee_transfer	1547	38000000	1	CkpYjrcddSgPYNSWAKXfQ21pApMC7B3winGaVxYWQwMmHdaVSvaPZ
8327	fee_transfer	2086	19000000	1	CkpYvGPVQgujnb5vBJ5AyFggosQtbnEDq2mou42yntRNp7ZBi4h3c
8332	fee_transfer	1422	118000000	1	CkpYoi53adDFfbVnwz5WsxNrjz7CaMWBA1LZWuaFBqeeNNR6BujLr
8339	fee_transfer	1451	18000000	1	CkpZhakygqvm1AXHGddySa72EvnjdnSwqUTNndsuFSZ18FL8Gs9p9
8342	fee_transfer	1685	19000000	1	CkpZ5rPe6CmZe8u1vSyYgvAiD1FHvSCwYzjpyvKobt58TwC4vzqHH
8345	fee_transfer	1613	19000000	1	CkpZPcRCXZjmrPKHGLqUZKh4pXgHytD6j5ZjhnoCuAWfepiCafWPt
8359	fee_transfer	2126	125000	1	CkpZNjwZ847TwykoaKa7H6TW62ohaV3voMjKuAEP5b4q8uVkDkYQC
8360	fee_transfer	1684	32675024	1	CkpZKXwJk8UxWCr6tRd4F6UFaPHr6keGYo85KX9whmxtdwqccHxz8
8374	fee_transfer	1622	37000000	1	CkpZKgi8BUhQq2htqnWatMcdSnMPC6iziQNw2HkuwyqoFMbFf8As3
8390	fee_transfer	43	14000000	1	CkpZ3qJXbpKKPiTH1kwyMeyaJVahFWNaFBv2F3N3zizSS1zY4QCnn
8392	fee_transfer	1588	18000000	1	CkpZQ7LwaPkvHi7gZcfGCypWG4PEPF5oxgJGnVoGhaY8hPj3heCP6
8403	fee_transfer	1394	18999991	1	CkpZDR1vLXexHCgf8bJ9gsjf5htyr9fipheowJW8bvsu9etm3LgBU
8405	fee_transfer	1476	18999991	1	CkpYu7dzAUdxQ2p5XVcjwMaJ7JDV8YBx1ydbrPJ6nPopWEfGyNu1V
8406	fee_transfer	58	226000000	1	CkpYv3vNRwrerbksoTcM2b1QuPcFRFoVri7WWeKnsmp9y8nj9JvxP
8407	fee_transfer	1807	8	1	CkpYyB1NpWmjYx9mHrhPZhJJffsZiJpcppjeoCtvuVAryXWiDjxQU
8408	fee_transfer	58	74747634	1	Ckpa93L8ePpgXKgmy7hu4dY7zHC8qi5WuiP7waW9Z7GD86j3bmGD6
8409	fee_transfer	2004	1409	1	CkpZZyWF4dkfQReX8tsRLxnJE7Rf9qdwrTtB8fkXMvNfYPNPdHJ4c
8410	fee_transfer	1571	48	1	CkpYo7xNpuCocXt32QKNKkuFK7QkmxXkEGnMBUVQkWUhNe4rCyg1A
8285	fee_transfer	1394	17999794	1	CkpaE4zCjHbbUpQMViFVrrfxhAwChddMa28FhVpLrMrPjwuPSgSRG
8291	fee_transfer	1426	4704350	1	CkpYReTxrLyFSrm9bwWBHB2QKJEmhvdFCV6Ktc6KtoSX4kgmyZLh6
8292	fee_transfer	1796	4	1	CkpZXugPcSY7Rzh7GudpszR5dmZGYWD7GfYkTXqTZQedr6xYy4nxk
8293	fee_transfer	2221	40000	1	Ckpa5PFbgXJ9kEF2VdmxFUrzENJmnCo5tJUwWeZrGkew3q5MJGG5r
8294	fee_transfer	1807	23	1	CkpZ8QsHxoN2u8JA823ZeJy6p2t2vw8oynMG2KN8zpKgHy4MPeUWh
8295	fee_transfer	2336	1	1	CkpYhWLM7wE3EghTAeuSJHmUdcsQtvk4Y3xfAdgWunadNTePpSJx4
8296	fee_transfer	2332	1000	1	CkpYvXcxFijLvHyqQTZDG2Vjaz6BDK95aCrDxj7kaB6hXJ9gnaGin
8301	fee_transfer	1724	18000000	1	CkpZq3U1dwdqpK4XZwZgM26wD6WvBLrn5Ce1JqPCCmkjwGmDKSWh4
8308	fee_transfer	42	19000000	1	CkpaFPYAZFEYHMRNEcqTVvjXt4YpPtrSjJBGFgDh4LYQtqHGKTBgs
8321	fee_transfer	1559	7605000	1	Ckpa1ZAN8ytWqa9t5mbzvUtbp7CuUYQy8VcbepB3rCBfGg1gdx6sa
8324	fee_transfer	1703	38000000	1	CkpYprRtDwdBrBzBYakuWCHV8BGjxbrP8tj65DrP5LsnZRhUaCG8B
8330	fee_transfer	2087	19000000	1	CkpZuqzVJtkgNJWihNoMDHmphfBsub1zC7mYEQwMpmten38a1UPZa
8340	fee_transfer	1419	19000000	1	CkpZsxvFCrCUxczZvacPTFnDsHur4BufrSfZSu93Gg2GM4dEJgkuy
8347	fee_transfer	1593	83000000	1	CkpaApgXbnwuH81A5D6SMZKfdHUJYqHWtSo5YYCAYXuC1dvMtzepC
8348	fee_transfer	1593	65307906	1	CkpZJ4AE7DEduLv2KWy1pPFw9CtN51yzw7yzSFrMNDwdub7GTMM1n
8349	fee_transfer	2221	10000	1	CkpZ7432V4qact1YKiLJEM25cuLe6qARmrvHmLsSty4Sgv3C14Ntt
8350	fee_transfer	2126	550000	1	CkpZHg45uXgbp4o1nKSquCAkPL59gJ27ZYtFLamakxvb24o2KVxdX
8351	fee_transfer	1807	11	1	CkpYyAemusJUKCZ8Lsc2cyN83bW2gFAQNQky8AAxz6KmJg3u3kaHu
8352	fee_transfer	2004	6300	1	CkpZd6U5aHRMbSDMpr5ozJH91T6MRpcUfxFDCG8NzVyT3Xh3FvMy4
8354	fee_transfer	484	37000000	1	CkpZFiTf3catL2aMcXfdvA4cn1enRj4WpmZhoWwgkAYUoE1JohBwL
8356	fee_transfer	1709	361000000	1	Ckpa4dwyY9kFCis835yjLkNLpMPPX7RKmAqNLPzN4MxdjtkB7ZJ41
8357	fee_transfer	1709	3670962	1	CkpaCe2JFMQPG4Scg7AEBZPRVRU7N359n1eqdPMQJKZxosaPMdjDz
8358	fee_transfer	2004	3500	1	CkpYtFWQrijVmMGUwQqf3GvemokgwLj44ayvXYJtN2tB96UhZUSc2
8361	fee_transfer	1685	32675024	1	CkpaGquLEuHsewUra2nXshRfZ94yyBDmxad8QRAVkuUzF63MBeSv2
8370	fee_transfer	1723	17000000	1	CkpYX9RtxYNj7mTFYQLan1sWPzzMWdsKuz7ynv856aN5iMQs9Q9ou
8372	fee_transfer	1670	28000000	1	CkpYVfAJpUf25v6rHeDEnUybVozFSJqXuH4tkP8L2VNdtjbZgYE2g
8375	fee_transfer	1649	18000000	1	Ckpa2Yuot4jVjDpAZYyXAundNmeE61YsYuYXqzi1NApsbxgoPAQDd
8377	fee_transfer	1690	19000000	1	CkpZ9E4MpiZDMkRfaQrouKRo4yBffKYPy23UfWEJhmCavh9WKvnyk
8384	fee_transfer	1685	7792800	1	Ckpa5U4M3qRRxqHMSpNiAzP3tQLc9b1cu1WB9Lzwk77oZiPS54fj6
8387	coinbase	470	720000000000	1	CkpYVWcuhMqYSQdRx5CFRcesG7PhLd3ANyegGkGkRNqRgV2esw6Vw
8388	fee_transfer	470	15965000	1	CkpZpqJUPK3KD1JzcZyiVkEdViGQc7dwbirajPynHSKoKYT8iW6pB
8391	fee_transfer	1688	28000000	1	CkpZBUY8xxuNE4uKaAZ1G3FYsMdgW9FXJ9AdPm55XjnuCgGmJHiVs
8393	fee_transfer	1686	18000000	1	CkpZBz6agn4FfmEhGLqaP5Q12GN2RSTtwpL3myqyf8LYUB49wuwe1
8412	fee_transfer	1656	16000000	1	CkpZEdLPa5NwtZN2AB7BmhUqwiqKdLFAri7BGrsuxoDARVETddVN4
8413	fee_transfer	1678	17000000	1	CkpYaMCPjhzhGzou9KRUc3dhp7vZnmUX5TZGMcgwggB3hQXB3wA6S
8414	fee_transfer	1671	17000000	1	CkpYWiUipCcaHTJaQpzmHp4Qe5rgsFV5TH9WMNNdqFgaCv9vYuFK1
8415	fee_transfer	2004	90	1	CkpZA6YMwARnoxdrQqK3RVuRhuDkoTCiNMogBf798uH2sMUECmLKX
8416	fee_transfer	2261	11739338	1	CkpYpbNey2BvFKfz8JqBxS1zrQTLGY4ucJML4gKdGkANyaYbr9qTE
8417	fee_transfer	1690	11739338	1	CkpYSjSibZvpZRnTh2hYPMHoZ53R8RqyXNauNTW6jpL9hJYZQmsFd
8418	fee_transfer	1593	18925000	1	CkpZecgPiMoPdCMWpwmhMvQLQz23N4R6m46m3NzzgxxnXgZ62WLic
8419	fee_transfer	1593	431974896	1	CkpYwyhf4buhikGUnJ1kwQmjvBCVJebUFSF5Uo3qnWNTqKpqpEspY
8420	fee_transfer	1593	62529388	1	CkpZMkdZRvB8QF17csse3exQawxQ5ab4SVUNJpLHzEuufTqKFUb3M
8421	fee_transfer	152	1800000	1	CkpYejLLETYUJBphzCfp1bV2UkobszwSr2PtbeNuegSJJrM6zUWNa
8422	fee_transfer	2143	400000	1	CkpaHB17EsbPkuKfa2a6L69hsNwHQMwG1RVZmik235FwWzEypd8TA
8423	fee_transfer	2004	4900	1	CkpZ3GdR2iXKYz8iTmbgRiH9J8KNumRqgjGrD1qVteMzPtPvcseLg
8424	coinbase	1602	1440000000000	1	CkpZzMFk3Jh1aaJshjmGA4uVxbJLikm9ZsE8NoiTXTADNnPWDSkAb
8425	fee_transfer	1602	38000000	1	CkpZwTRFSwzYoXXmMVPPXVN73pJGKFahenyPRwYbBLGP9aSB8NU5N
8426	fee_transfer	1688	38000000	1	CkpZuzpAq42LEgoDCrRn2xhKLHiZ48cz4jMKxbg6DwyXXZYAyveqc
8427	fee_transfer	1709	18000000	1	CkpYgtV9ccJ6HYe6xMCCbafVqH94mFfXdyFMXuUAkX9eMRfNQNYHT
8428	fee_transfer	2329	56000000	1	CkpaDjUbcNBYefFye8s2pf7zp4g96woB3Ek97ir2XgWejQS2MSiVQ
8429	fee_transfer	1807	24	1	CkpYis1ogVyoMd1atuTDVCfZaFwyaqgmtQdD13rjjsRjB3PayYFit
8430	fee_transfer	1394	17734016	1	CkpZYZU6BLeidPEufjUrPGm8YD84d6eYmJoP2gGYAM6cx2AAbuGWg
8431	fee_transfer	2004	18	1	CkpZVbs1Y63T6SFopJGnuL2K6N9eMq6nX7w29AzdijrAYEk5eCXBs
8432	fee_transfer	1672	57000000	1	CkpZBb8ZzxBL5HCLKHs4fXgFvHVgMTtxDthtaXMaQLwe4KVTYhiE9
8433	fee_transfer	2292	57000000	1	CkpZa8KdFZrNKRLHTBhrzFf8YqB7CZQHwrfTW2R2rUDf2hchavUDL
8434	fee_transfer	1747	57000000	1	CkpZunN6sSMSrVW9zPoAodzfnCqXZG9c88sE189oRSh8Fd4TpMJaN
8435	fee_transfer	1547	57000000	1	CkpZeVNdk1edLWcXAMxqmoV1XNjzWLbfenva7e2tRUdKQjLk8nJMy
8436	fee_transfer	606	17000000	1	CkpYQtgJk2EqoJwUqUdA3o3cbHAHQR5gPJn1eZz3iLTzimfkKfYaB
8437	fee_transfer	1608	15000000	1	CkpZKCmiMr3GKpAdzVRRzDy9ShjBA1CBH8QWr8pvybFijJFkisYEx
8438	fee_transfer	1688	13894559	1	CkpZdfkRQUuYjia5cj8SrXwkHyad29xqiQrJZbMBvuScXJCFyrWdN
8439	fee_transfer	1622	19974800	1	CkpZ5jD1bDRnCGuvdSoZ8jC9LTn7L9N8RFrV579dm9Zb65pSTdU4i
8440	fee_transfer	1419	19974800	1	Ckpa2qYsHvkgmaYJWafjthiKGMnKDSiVM7s7uZEXRVekp8sXvZkbz
8441	fee_transfer	1688	19000000	1	CkpZdrdS3DRBWyxFNE8WC46ZH8kMsAoEFUGGgYjgGPitY84TLm7Kw
8442	fee_transfer	1719	19000000	1	CkpYrMPmWJhvHC3fprpaU77eLBAbC6hBXzKdebCrSZ9L1hpmszkb4
8443	fee_transfer	369	49000000	1	CkpZ5LoVhD7HHR5zy8UJG9UCVAJagG486Hoxa5cgdEAtBwwFV4Nog
8444	fee_transfer	1719	49000000	1	CkpZwFcbn6857re9BngFuaWs4vn9hCJE6JQmrEqsX6cFhXMiGHATB
8445	fee_transfer	2329	49000000	1	CkpZrtBfbPGQNdR6vxtPFy7yBFA9EqeNRWx4A4BPHwW46evCwoPnf
8446	fee_transfer	1708	39000000	1	CkpaDLqRCM3d48K7rdnPGzGARZeEXx8cd8iT9DP7gDFrJfpb1HARg
8447	fee_transfer	1694	39000000	1	CkpYZTsh66UhFpAhRpVkahSE2VBFqxDhWokbaAgP7w77xBzEDuHLH
8448	fee_transfer	1684	38000000	1	CkpYmGPcTRjYKUjvDBocFiFeZDnfZgdRJYcgitRUMw5p936UdU2iv
8449	fee_transfer	1723	38000000	1	CkpYp3rxad62cCBqVa5mBsraPkCamXAwNK4UXJoDTWJ31veBBU9B4
8452	fee_transfer	1394	34854742	1	CkpZKKVsFoBpzWVNyASTDv9BEM7c3uP7phyMiKEdjPjDAgkfhbUSG
8453	fee_transfer	2004	45	1	CkpZwjvoiqz2Awf3tWKx1keSeF6tzZ6zErv6zFKBs7oiJ9FrGS7Ek
8456	fee_transfer	1549	38000000	1	CkpYyBcBimcqkb63t4gpKXtKLEfvVDxTJj99tzHsqVQnubXKyDvvf
8463	fee_transfer	1471	15000000	1	CkpaF3jB8gw1V17KxBhQBDg8xHK3dWM4nPqoZrPyvbnHDpbF7LuJQ
8467	fee_transfer	1549	19000000	1	CkpaJsLY33wHbmCub5ME6NfvsQnQakR9wcAiPooHD8yWtKEGBF3jm
8468	fee_transfer	1395	5749639	1	CkpZQDyj1o3TjYHEQX65CetgKXJSBs494Q4FdHcevjfMGgRfdQxu2
8469	fee_transfer	1684	5749639	1	CkpYR1TzimGhWoCJDQpTdwtV65sTC1CnNxN5qQkHHg1qMKME21xPM
8477	fee_transfer	1668	17000000	1	CkpYtivr96GhoPKCwfAZfHaAMAsYWTsD2KDXAQQ37HFj5BhW2XnzC
8480	fee_transfer	1560	18000000	1	CkpYyoRXwAj3MzfTDKBKhNNWHY8w9zTRFWLkBfPwdGEo9SoRFEEJs
8487	fee_transfer	1395	41000000	1	CkpYkCPwka4mf3uTWvk4KoHoxgiDQcF5PEm1ZmANfzMojneTn41gq
8494	fee_transfer	1547	7000000	1	CkpZmgEv8AR6HHwXn4vMPHFNvuZRYfYcXedkprccwCoUNKZ3PDF6L
8496	fee_transfer	1440	52031580	1	Ckpa4nVJjE3Be7RADYhV58DCUG4LQR6C3xd8sfEuwZ953squwfm1p
8498	fee_transfer	1668	55000000	1	CkpYhfBCbfwKvNaYwaoptEmHAYfUdxuEmP2Hf7sArXeh4ovLasKbP
8505	fee_transfer	1608	18000000	1	CkpZAcpbvzQ43ue9HiGCc31DKQuMhNvCotErrHTEbTZnRsNCJXT34
8507	fee_transfer	1509	17000000	1	CkpZCAZ4Ew8pt5FiimjUXUvGp9dqggdjuLg7EMDTj3895W5yXGHpV
8509	fee_transfer	326	17000000	1	CkpZb1FHgDYTS9JiSL26m4r7qZCRAweucMhBh6PFKdfu6Wy8k12JX
8510	fee_transfer	632	19000000	1	CkpYoeNxc6j6dnVhVPG2qh9TYeK7xkVXJghGdahJwY4XtMGBwUX56
8511	fee_transfer	1657	93975995	1	CkpZmbT7WcWp9fDJwpkVqrJLr2zPsGxbAz9cREXikFMkknDAxX66Q
8512	fee_transfer	2336	24000	1	CkpaKRFM6CPEEJdoCC2pMRNh3XNySmBCtFYLHY2SMnZxhxtWijUJ8
8519	fee_transfer	1509	66000000	1	Ckpa3nqs1HQdnUSvWHPgs1xC4AumeJLzy6y6jfULQDoaBhSV8CMy3
8520	fee_transfer	2407	1000000	1	CkpYt87VPtJ8HxpBMAEXA4KUs4UNpWp2cQbqCZk35vtsMZGCyQjDs
8521	fee_transfer	2126	500000	1	CkpYhW2tvZKbrvptyiAFAKgPy6vKZgMMfiu38eqwHAosodpJ7PRm3
8522	fee_transfer	1509	7074796	1	CkpZzShpE1QXTPgpXy1hhV9jVUwmzXcqanVL5NuiUFUbZW82yjW4B
8526	fee_transfer	1678	17449717	1	Ckpa6XzzUsADwUG2scpEktWTb7UBiubqaJRrCrXzqmWgychvjd9c5
8527	fee_transfer	2004	72	1	CkpZmvbnofhkohi2VA7UakpERw2Dt3ag9cJFbBvaiWAXeZjpsmMnf
8531	fee_transfer	1746	17000000	1	CkpYbd9GpAiQuWVxmXvv9VSHeG5zUL1LCB3iq3QBvsZfWpZ5nZN7b
8535	coinbase	1756	720000000000	1	CkpYaej6933NrkjYw5oo1rW4M8ckDu1NdoTsK3ji79ifKANTi5R3Z
8536	fee_transfer	2336	6000000	1	CkpZNwCby37qZ4UEv5VojPhaR1BZfGUxZ2atKkdRLJdZ5T5QYoZkZ
8537	fee_transfer	2252	500000	1	CkpZatroj1qaew1kYATQ5JDpeWQeFsVBkBNvd3P4WWXBggpMyA1aj
8538	fee_transfer	1756	210531580	1	CkpYsgMGsYmDpt9i6NFaAP92iSKx8AuDUJ55oF74guvYfoKz9migT
8539	fee_transfer	1693	28000000	1	CkpZwn8mBTDmWz1Kv1ohW9jYTY2kiYisrNpQ46X5fDNA33e56V2Ti
8543	fee_transfer	1634	1168156580	1	CkpaJh7866RLhaX6YMtYRuqzNYNaK5HnBZ1two5hN79kv8oYiehXQ
8544	fee_transfer	1634	13300000	1	Ckpa6EayKweD2X4bNWgu4Gud6zS4XEnin83Bb9cqXJPzH2Es7Q9oj
8545	fee_transfer	2252	700000	1	CkpaGtFo9vUsZKioux2H4Dw2HXZMEBzqfCzTXtwnjYsh3mRYMxC9A
8549	fee_transfer	1690	29000000	1	CkpZ9W5o6TdyCdasMSdsmAZeYoxc7FKx9JauaPKa2QhskEXWRCyaB
8551	fee_transfer	2329	26374898	1	CkpZBjPDyyDfEdYje24zoQ39RSMuhJieMnuRMzfCpCFunMD4UckrX
8566	fee_transfer_via_coinbase	2443	1000000024	1	CkpaB9zhBa5jcHepakPeUYDoT4nu2rd6XEbqHn8wk8XFnUdzSCujb
8567	coinbase	1634	720000000000	1	CkpZ44BCP4XJFJmxHNk55kCP84mY64VbPfaMhTkXJB1P3nnPPia7j
8570	fee_transfer	1719	46000000	1	CkpZEo3TjRB3T7HhshPKD6hdHUAoeyvNkR2XyyX4fLAs6ttgiFsdB
8571	fee_transfer	1719	11624587	1	CkpZin5pETnWk4uGVBBERTJRBpUi7zHFbUemc4422F8Chx7jnzLfr
8579	fee_transfer	1593	17000000	1	CkpZCDe1kRdmJ4TiZ4Rc4foH8DbzsATN62jHFQqdEtDSv6EfpWzNV
8588	fee_transfer	1693	19000000	1	CkpYp8KY29xuARxmMphYAtkdbnAAUNLtsXFHT2WNWUPEDSPxukLi1
8590	fee_transfer	2329	19000000	1	CkpZnidMnuykDrDJf5tgumhsBwxH6798kVt1Y3o2FmcfArsF5v3Xf
8592	fee_transfer	610	19000000	1	CkpaB8GhUaJejGHrz1ZE9zGohpNsPvNRuyi9LkZvg1Hqgfx4zuJZ9
8594	fee_transfer	1402	9399671	1	CkpZ6jCuNawiyY9ACd9tRgoPkt3PgmbSLQcKQdmiuNHd8QYMwKbBb
8599	fee_transfer	610	20000000	1	CkpZ9dtBWtkbjFibPcGMMJxpV1bWQTKJwTaoA1Q6njp7c3HCXKe99
8600	fee_transfer	1573	19000000	1	CkpZLpktgt7LrJtgtzb8mg4Qopi1VSPYJiBBBfpGK2Amj55hJS1Yf
8606	fee_transfer	2148	179000000	1	CkpZroc68zncsEW7Qef8mjZU9pFbH5L35F2B9oo6ruh1ajhUd8WQH
8607	fee_transfer	632	179000000	1	CkpaGkW5qy14PaxRbP7coQ8BdNpySxyZNxUZyvzKCGKTqyqt8gRiY
8620	fee_transfer	1602	59687500	1	CkpaJrYuoFj6bS8rKgXrGfdZ1CNgnnYhNCdLNbMvsBBc9oXRa58Qf
8630	fee_transfer	610	15000000	1	CkpZMvAWy9344tBkYDx5zcBDuEgFTAhB7k9j84BtaQ9u1CYZQwKSK
8636	fee_transfer	1746	113000000	1	CkpYZXxj6sMRGnPLZ8QqVm82mp5HGBdZvspTQwU111PTcFB9MBaYv
8638	fee_transfer	1747	136000000	1	CkpYr9jdxmWffPqEZxAWh85L628ThuzF1v3AUS9suSpbRDuMrU8CQ
8642	fee_transfer	1690	939967	1	CkpZ32pa3Ew8zUxRQH936qivqyhv1tHgTAszoXLbTsSND4Sk9x4DQ
8643	fee_transfer	2332	10000	1	CkpYrbT9qHtxDNNQ4wSAjyyBPaYiYWgA51mpZXS1BfKpxcB1CTkBZ
8450	fee_transfer	1768	19000000	1	CkpZDdU7eywNkGbKbwwEMkmR5wKUhbixStw8cpyxHRueAe15CpS8d
8459	fee_transfer	2112	1964479	1	CkpZjwV3X8op4yCJ1d9V8L4x1ePg83WcWpUftzYpDmfqR7tHVseie
8460	fee_transfer	1807	9	1	CkpZDsoG99hxSKHH8gKPFoUojsUhFTmeRsLhir3hpwgwJ5QDUjHVy
8461	coinbase	1723	720000000000	1	Ckpa53jdQxXxNM3HxToi3M7NLTcNg7wmYMbb4xUxt84upYFkn3V7d
8462	fee_transfer	1723	17999788	1	CkpZj1iN6EPzZoysKcRa2PipUrkgK8rwmCT9QcciZZ5nK8nCaTPxp
8465	fee_transfer	1672	118000000	1	CkpZg3F7TrmyQBrWBVsY3gMm2MXghg7V5yf9vMW2s41jwoKdrx2Lt
8466	fee_transfer	1547	18000000	1	CkpYWSjNBjS3n1JHEu6XnZMKxnVCjuwrnsBMYbhcUs8Jy7vdt6ua9
8474	fee_transfer	1657	18000000	1	CkpYjkxNSmax8hSXJzuckby7Zyn88x7fVKnFY8Q5eLdozf3xwMper
8475	fee_transfer	1694	18000000	1	CkpYWZRvZswpSATCQZrMUTzsDbqsdhyE1SV7nnCWyCY7Dx7GhwjKe
8476	fee_transfer	1668	18000000	1	CkpZ7NDqV98ZoZo3HxabxsjhjQ8CJrCJ3C2V6k6QX7iQ4UuAb3rgS
8478	fee_transfer	1717	761000000	1	CkpZ7L6UYXCwr99DHFzAXwbi8cqPEKwABgsw6Ues6T5aDWuQUsKut
8479	fee_transfer	1717	25824351	1	CkpZmUwwkiQSf24aABGn3SvyBUVvJRZ47BWUytiPKubhAeUua7yRf
8481	fee_transfer	1702	18000000	1	CkpZyH6rYWCmX63QjcXSENueUobsv2Qo8eQww728Qz6FmFA2xnzQQ
8484	fee_transfer	2393	43000000	1	CkpZCPGZsKRTRgQN6sYVC1e9e7YsGnhpctSiGSEpQt1JF19XYrQce
8485	fee_transfer	2393	6000000	1	CkpZ9wxWWoWjUqSrV8jqmDjGZronkRiw5xay88FrgaA66pTmFPEZn
8488	fee_transfer	1679	38000000	1	CkpZRrfjmwgJcWCLtSUMH98JiRt7z9eNWub78AeB5GudJzWjvErYT
8490	fee_transfer	341	38000000	1	CkpZwf25vhd3Loz1trk6oaaLpMb84XhwmYahoX7cKjDmYQxUEoZ4g
8491	fee_transfer	1905	1000	1	CkpZhgTxujCUkZYy9YaDgxrAwkuZMWH4PMLf1K2FYV1je2mVYTXuc
8492	fee_transfer	341	14999000	1	CkpYiuNPxKbigTJScgMGubnX3CSMMBL2PKbq7EyZGr1zPnxPdZrdz
8504	fee_transfer	1719	21000000	1	Ckpa4qhGrQdJM7Pjx96ezmgi9PGoHCjCwv35JnPmtQJgjgyMXhgiB
8513	fee_transfer	1508	93975995	1	CkpYWtoXQTDhHpRdTo3C7Y71WKP9fWqD9oZwF81N5G85ubJrEni6i
8514	fee_transfer	1670	26000000	1	Ckpa2EMBuzuAsw9Kwc5U3T5B4tz7XmcBuhkzrTueRwgSWFuZKq174
8524	fee_transfer	1599	66000000	1	CkpYvQSrdnbkDY9UqVsmsizEX11Zm6A24QA6JVCQtcyUh1ZfnTe1T
8525	fee_transfer	1599	8074695	1	CkpaH4ta6ytE6UFrdNvUJPFig6ZCKwyHh9Qtz1CbouuN2v85PJ125
8540	fee_transfer	1444	17000000	1	CkpZJdvxQc21k7UH8TD2SLibDqUDK58HQLu9gHYS8HJ1c3yveDdik
8557	fee_transfer	1714	29000000	1	CkpaGyPvy2mDypC5YWvTvFm92zv2XfkTQTBvgzqKbj3TgsWqqJCXh
8558	fee_transfer	1680	63000000	1	CkpYSY92g4qeAjiShpYcFNFdH5VgxWRytHDRirfmY1hDy15fzeZR6
8559	fee_transfer	2148	45000000	1	CkpYbba2t17UhFfZwrmFUhZPStXw62wT2bSTUCNfsYeHCqF6zMuQ4
8561	fee_transfer	2329	45000000	1	CkpZkgCTdNoGAYecvyxVPNpY1PTWusK3eAQS1LTRD6fBcQCErimGT
8565	fee_transfer	2148	26000000	1	CkpZFhucv4kcpqUkMUiPwKgqeng6GLJgvyT1RmDkRGHsdryvQw3Db
8568	fee_transfer	2221	200000	1	CkpZU9CBUoH9o6PL8ekduoBgj1Nxou6yK6pjifVVCnQ7iMaT62hpx
8569	fee_transfer	1394	12624587	1	CkpaHFRmsvcyhaTmLMKK5CC65CwGKNBB3W6NRrxa1Cd4ZZtRCCU6h
8575	fee_transfer	1747	26934869	1	CkpaDnFnaGVkRcSMsg5ryWAY4DVWtkcpeFyEdkJiv3szSWX3ZbC1Z
8578	fee_transfer	1439	26934869	1	CkpZ2DKv8KwV9LZiERnkEaeTbJDzH2oTw6g4kMyHHoRuK9z48xk1F
8580	fee_transfer	1593	570215204	1	Ckpa8t19QiNUagTjXJvRfHJyUkFo18JfAYE7FGbfh9Qy3wZMR4DJm
8581	fee_transfer	152	300000	1	CkpYzW4CEbgP4mBj4e2AurJCQSVuVYxMDvh27XjqexRykoUA9uQ3T
8582	fee_transfer	2143	200000	1	CkpZZ1RLUjkPQPP5PHqzCCSmriCCit6VQpfFaJcPw4S3EbvEHbAkE
8583	fee_transfer	2407	3000000	1	CkpYWknrPMYMCEQaQ6LDiJtq2mvUDgWP5RmtC6GRdRuafGD4obRAn
8584	fee_transfer	1593	322054008	1	CkpZiMe8oPV24SEz1TNQxsn8hxrYQ3icP7np5LuUYD67MuUNdGK6s
8585	fee_transfer	2143	300000	1	CkpZDr918vkgtoo7QqSfQvUnHRj15p3xa4uHGebqz7khrrzgj8Dkd
8586	fee_transfer	2358	13000000	1	CkpZc6pzVB4YHYYJnu4QsSgok3EN8ahmS7kUYA7bKBzjPXBRDQpzZ
8591	fee_transfer	1619	15000000	1	CkpYp1T5cTB2GaCqMrgbdSrSE2qYmtHwz7NqRNCSEceTm74UBErZ3
8597	fee_transfer	1670	9999689	1	CkpYn4KZvXa8Hd8PBx7iJSaitMeHsbCbiTAr1LjBJDiXeDXzF6Uyg
8602	fee_transfer	1673	35504653	1	CkpYv9JF4iKpRFZ1S1J9dA34b13zcFJ6q4pkMduzPpq2wm9syRfgp
8603	fee_transfer	2332	20200	1	CkpYV7XsBnuSfyVBDEyfvEVc7ZGjrTW4eVsTEu9hg6nUwA7gF1scB
8612	fee_transfer	1467	41000000	1	Ckpa47arHbSc615oXHrpZvrVmcfMxaqV9n5PKXGkoAHAVWMB85qdH
8613	fee_transfer	1467	18849857	1	CkpZHB9RyDq9iicSNK4MjREqk9Avke6365P9fBHbJkNM9zzXq4pTn
8617	fee_transfer	1672	31899790	1	CkpZqfAYWeQVajtdzpZuj94o7xcPygzQ9Me9XEj6z3TqfjCqnQ5R2
8618	fee_transfer	1711	20642860	1	CkpZDVki5tJ8zcE8QTi8JvSAL8LUavWDTVi35ffJGX5nSfbm1jSyt
8634	fee_transfer	1608	16000000	1	CkpYaifbx4jdhLWP2oyEDjnTreRkk77vizkp3UN94Yms3LcdXmXV6
8639	fee_transfer	1395	136000000	1	CkpZ3V6tLj7CT3MVyk24ZFSBM7ZySyo6MLF71kUfHg3A2ewsBDyon
8640	fee_transfer	1608	35000000	1	CkpZ5LFb1mpUdAWnCiWUgqhxrALiSA4MrQyCGYG6xB1AcPcs4WZUM
8451	fee_transfer	497	19000000	1	CkpZ1fGE1ahJxn1ezPzFDysima1oGdxLpnb4QybDpywT3puz8Y9RR
8454	fee_transfer	1549	34854742	1	CkpZYd6BkruddAVEEe9iKeWpCTrYiHuUbP4XGvBDka97uzePq5fDu
8458	fee_transfer	1657	59000000	1	CkpYySzb9BfcrLzQ9pa4jSbodEj31kbHQrSrkTWvfhmpxDH9N7RyX
8464	fee_transfer	2329	17000000	1	CkpZU8U2RtBG8d4ovyamxNJC3zAwZhZ6jVUw4oKC3WaaUkrjbLr9K
8471	fee_transfer	2126	150000	1	CkpZbLcC6rwZ7HdYgfxi6Q5VJouLMLHv8T1JVa1TCXMYMRxbCqqtR
8472	fee_transfer	1684	3724645	1	CkpZisqrSFriwZeiBLMo1THYxuQezoCWgcwbV5XtjdvpEPUUbzg69
8473	fee_transfer	1611	17990000	1	CkpYpcZFT9wUFjCfqe6fz7ZBYg4o4hQ6c1nQCRthjzQyqZh734fVB
8482	coinbase	2393	720000000000	1	CkpZiuJC2PZsd7588MhBgytrcZz3a9rYYyaXSqGMe9rDqtpch5ktB
8483	fee_transfer	2393	30000000	1	CkpYpArpQhuJ2WqBscbrntQMRjHxxSxkHpQ93bGqboRE8SbphWSge
8486	fee_transfer	2393	19000000	1	CkpYy5bY95bfXXYpeNxV5DQYVujogqnTTGVcweNRX6oNaQFvaDbvR
8489	fee_transfer	1476	38000000	1	CkpYX2L6qG8jwPoun1Z9QZxko2nKHLXfAg92jBE69DqMQHpuDH8Rr
8495	fee_transfer	1549	52031580	1	CkpZnfRpmFo4pTB7JNS3zPWk8KMous492J2PbbRCq8wu32UZyNJmV
8499	fee_transfer	1395	27699564	1	Ckpa9Pqw6NXDk3yegenVsNBR37kn6XRY6JVVk74MUjLXkuwB35bWT
8500	fee_transfer	2430	100000	1	CkpZsq1JyKbux9S7RgtGX5wEEgJK27QNewH7Uojrk3kGmsovXyAek
8506	fee_transfer	1594	19000000	1	CkpZ7idVW69CRF4C31ew62YktcBtkbVUSNXZQ3zavEyC97M4Epcz2
8508	fee_transfer	1457	17000000	1	CkpZxq6CicQi2Vx6yVxcucrphb6vjKbt4FRFNDFAZP3Py76vyooKS
8515	coinbase	216	720000000000	1	CkpaAP9w6Dpq3hfiXhrzUQW6iKYdPsH1iwcC4i7W5o3qAaA6SamC5
8516	fee_transfer	216	17000000	1	CkpZ9jtGoRG22byXkyirxYDtbzNq7e8GQcdG3wXoe8G94gV15ZZ4Y
8517	fee_transfer_via_coinbase	2358	1000000000	1	CkpYW2ywoUuNj3byAyKShC4EJRqFEoZsxRex6rEa28p9ztNz8kMf9
8518	coinbase	1756	720000000000	1	CkpZzdskq7mqWq1jG1xMsyVKgCuF9hZizZjy6NEwJVP9S6a1weMJn
8523	fee_transfer	1509	8074695	1	CkpZUHFFaQgvAXJRQUtKrmpN6rB8eMACpqsBw3FryxrBVg3SaVf18
8529	fee_transfer	1587	17449717	1	CkpZg4S554nRAKWjbzduHhKeNzGnDov4JsS69QayYCpqomScuxJbq
8533	fee_transfer	42	18000000	1	CkpZDkD6kSu7V9PduZp8AYHuQ2zo4TjodqQgN2MkVzunbhp9JMp59
8541	fee_transfer	1749	17000000	1	Ckpa9HkyZFWyt8YbxGawAGAtTz81854wbMU1K5dVrEfvyWD2ZtAeE
8546	fee_transfer	2261	33000000	1	CkpZqMuPb3VBb8ubMtSRNSevramQe3763c9PK3k4ntGcTChWDaFDA
8547	fee_transfer	2221	130000	1	CkpaCTyqSA1UL4gU7WMBv9eizLPPtATsq93vcAUezABZZrmHdPVNt
8548	fee_transfer	2261	3604546	1	Ckpa6cQuhX9WWu4pea7WFhd83FG2CsjFC7o8ipFCarSRTWjsCUJzh
8550	fee_transfer	1395	26374898	1	CkpZ94e1aFXRFgs1LzGN4JxgZF5VBGmTn6xVkNH7U5j7EybkYf37v
8553	fee_transfer	2261	291000000	1	CkpZJzsTXorSS1tuiujkmuhZHqyP7LHFG1QuR2q53hXXZJdhgh8YH
8555	fee_transfer	1688	7000000	1	CkpYth1swva3YEqP9DAChuYkJDQ56KPTWLUYtBfsckYvZKMzLPjYT
8560	fee_transfer	1596	45000000	1	CkpZiBYXzVF9P2zEFuXpHErx5ovVNEuQjSxuPxuJebFVy8F7e6AzQ
8562	fee_transfer	369	338000000	1	CkpZ4VHFLaJof9hGdZps45gitHXyQGvBYYtBwX2SPmSV3RcN8s3YS
8563	fee_transfer	152	400000	1	CkpZeygMmYSaC8jVTSw3M5hPeFCcoPcGV5K8pofDiAVVaq9zw2KAe
8564	fee_transfer	369	416234645	1	CkpaEg2NUsybw5STu4LyAbBKWTmh54xv7rcPoWf76ZxfZXPKydEYe
8573	fee_transfer	1746	26934869	1	CkpZ17mDqV3q6jdUNzyzpzJm8ygtWuY2PG6KckNJQeNwJAGGBCuvL
8576	fee_transfer	632	27934869	1	CkpZyDzuyh1sezPwSTvSbMmXGdFgSTpUn5U73q9WP894AtJWdipo6
8587	fee_transfer	484	20250000	1	CkpZqZXKbAFNmNREK1bu8UVS7dDLSCJGSJkpHgii9nozSaGbPhhhv
8589	fee_transfer	1718	19000000	1	CkpYVhirHKkwCMihBiJyLx4DxnhrVuZPWSQbY8Y8o2AG5wEaobMFj
8593	fee_transfer	1693	5000000	1	CkpZXGd5sG4txfK4jEtudSXDw7dfGQYdkQEzgKUinavTKdwu4wj8y
8595	fee_transfer	1670	15999689	1	Ckpa49vvyWTsJFM62uPFtcSZJHAW9iCZ3yEqXHF1Bx8EYVnkypkBt
8598	fee_transfer	2112	16000000	1	CkpaLEkkKgNE5cKjxkSBbkqfG51mSupDvttyPoB87XAX8umm3zVUZ
8605	fee_transfer	1394	35504653	1	CkpYrYKXzLQvyFPvNu1vuWMU581CbvJgKv4ZyD35JPS418U8qzKxy
8608	fee_transfer	2148	104000000	1	CkpYruMbsBxWfCZfNK9fB4fmHQ7XLWhzUa5DJoeUMMSWz1oHoiDX3
8610	fee_transfer	2148	87000000	1	CkpYyBhiztV4XkSVEPEX3BqeLzWCgDce9uZeUTF5gJvUbdKr9rxcM
8616	fee_transfer	1672	40899790	1	Ckpa4Pdebp1wGfNaqdAxvzCBazcoNXJZdxLeM5NiV3VbDEQNqr2sE
8621	fee_transfer	1602	76687500	1	CkpZL5k3X89ECPnGLhimfZWHFzzg2WKRF6gkiFc6FqnMyP5H9UjFb
8625	fee_transfer	1679	17089975	1	Ckpa9mycMDTziyCHTMgAVxqQEfPhxX5jsezck7PfMvfNQRkWUZyJD
8626	fee_transfer	2332	20000	1	CkpZbvmn9DjXwpzws4pqdYhWNWv6wxYTjboqjhboCVQ6U7MtCgXny
8629	fee_transfer	1718	15000000	1	CkpZNW3JMRRbvGWMr8oXCNj2DCasgnt7JbqcJYQjBXktg8Sofk67J
8631	fee_transfer	1610	31000000	1	CkpYTpPRQXTw2J92znYUeDJFURfgv7z96ScJedamJjakQaUZrTGW1
8633	fee_transfer	2329	31000000	1	CkpZdxRBNiYRbU6j4AhutM7y3pLbeyASESju1X39mrR4rMWcMMXDf
8637	fee_transfer	2292	136000000	1	CkpZVrhYKGAyEBt2yzbgKxKYFkYQQvmtTvWK1WdAgUXkzMzg8KxvV
8641	fee_transfer	1685	17000000	1	CkpZAP2gNjHwMozc8VHjwuFUSDt2EcdMmDhiX8rS3twLQb2FQHp7Z
8455	fee_transfer	1680	38000000	1	CkpZf9X8gjaq6aPZ3Jo52o7L4sAe9icRm8FfHwxrBUSrVW78jEq8Y
8457	fee_transfer	1657	36000000	1	CkpYqRhtDPFFnGUL3fdqKPKWTG9PixriFYsfwjrYabUS9c1yUS8x8
8470	fee_transfer	1688	5749639	1	CkpZBxP6oEp2GmzmvEFrkcwYWyyb1wyuJFwo15vN2cFYVASwVRWXU
8493	fee_transfer	1476	41000000	1	CkpZ6LZ1bLGqekaT47fsbKJkHoJEPEovtixCnUKdbiYSJcjTqcbVj
8497	fee_transfer	2306	52031580	1	CkpZgPi2RQsDmcNefNUsY4HgauH9a6WxgegCrBvvdRQSr7i4JGRYr
8501	fee_transfer	1602	27699564	1	CkpYswbpXVL8vS6fjvspcJfjJY9HnXvJeopw42Hxa4fMkyRbn6MA7
8502	fee_transfer	1680	15000000	1	CkpYrCSnxekQnNHwtpWyAGvuSbKJVNEYQtSnAZegiuXBv5N5Qh56g
8503	fee_transfer	1619	19000000	1	CkpZnmr1PjgtJ11kT1cARYT9pEWSu5twZyfURxnjUmbHtkhrGzJ5w
8528	fee_transfer	1701	16449717	1	CkpZ3uVrriesGG6m9eKrzWrCS2ksLWsgvrRkojKApENZxkKeXaW1K
8530	fee_transfer	2292	17000000	1	CkpZjgv5WYDYevPFPr2wo9D5RtCqZo9i7WXtJV1LpZfZYeygKKePR
8532	fee_transfer	1747	17000000	1	CkpZNB9GRGSobXqhvwG1n2xbVNNTrjJSXV4WXhyNQjwfMHBNdqcag
8534	fee_transfer	1559	18000000	1	CkpZJYZTw3smeUVQkokzMjohCe8zBWF25aVNQGnZbWiJb96eVcFXd
8542	fee_transfer	1610	17000000	1	CkpYsvCHdtHmwB6z8BU8K4zWWzaQeHeK6xzTKGUpeNiiTWArNHa9b
8552	fee_transfer	2261	303000000	1	CkpYVtzBM34UBYuh4T5tzFCgsxyNRVgeSrrosSooEWVYVYC6eXNfs
8554	fee_transfer	1692	303000000	1	CkpZcxMoah6FUYYAN88SsuAMBZGrfhoYzfqdSEV35jZ5TximifXvT
8556	fee_transfer	1684	29000000	1	CkpZwEeCZhtD7qQbbs2vqyy44GvrU65Mvbi9rReT74QkuGdDruJks
8572	fee_transfer	1719	12624587	1	CkpZ73Zd5u6T3kLwpjfMYTSSYyqE7692EHFxUkH8ACmJVhoMWQwxj
8574	fee_transfer	2292	26934869	1	CkpYcsos5SR6NvaYDDqskPeihFrVArqmsq4NZxSbybz7p5SfjZVAK
8577	fee_transfer	632	26934869	1	CkpZY56i6vNzJh4mfZ8avfvn4Ydg1nzFSkaVtZx5jjKn3Q2MmURY2
8596	fee_transfer	1670	11999689	1	CkpYcicXCE1A9YKTBSD5bMQJapAMudvhwtg2Nvd3aasftEiTCg3uo
8601	fee_transfer	1457	974789	1	CkpZ7cF9twr8WseZ5VevL9HrsBedmpRmhdyESeGeSax1AyS5fuN1j
8604	fee_transfer	1564	35504653	1	CkpZHCdw9rWXx86qrwrBB6tMY73FKWTDf48SfByCBcmW2gVrYnGjx
8609	fee_transfer	1402	94000000	1	CkpYhbZ8jLLQEskynXZRxucDBbSmy6MfiAHu24E2aggX3tm1KWqgs
8611	fee_transfer	2148	50000000	1	CkpZUhQk9ikf4GbUNYj4wMx3BpJfpjLRmY3LYdkWw6RBkcizAE7wa
8614	fee_transfer	43	1585021580	1	CkpZhWhYXoWW98TtmMZikziSzpQJToZ3KV7K87icnhkWtYjfM8FPw
8615	fee_transfer	43	7974786	1	CkpZ7D5QoPokQb54y8eAMQ7qYSrkxVB3DyeSfuXPpvgk1mDFNYDsn
8619	fee_transfer	1623	20642860	1	Ckpa44wZ9Rka5EhjKRCcnc1zkY7jxrnakJRs8dtaW8bpxGDNXJC6u
8622	fee_transfer	1705	7370833	1	Ckpa5wknoPq2iW5mStSWS738rcqJjnTS51FTgjAwQsLzTPy667UM5
8623	fee_transfer	2332	30000	1	CkpZ4pczmHJFBhVt7v6Go8qy3vvGKQd7Ui9gCbv62SdoiAGc6F5bn
8624	fee_transfer	2004	54	1	CkpYzJxweHjk2PiV7JSpb2TYuv56VZQXcnicibRTVSKPeWA2tfttX
8627	fee_transfer	1686	17000000	1	CkpZAHkNBigMGBFMdRoobDSYH5hP57rPtHtEr96axwZbC13WVwcFd
8628	fee_transfer	1716	266330360	1	CkpaHuQybYLbTRpDu7g1hCxpgmZ5ogskqjM43DgWJTwccs3QbpP3R
8632	fee_transfer	1471	31000000	1	CkpYmcM6zBHA6f75tVsEL3PoHLBG9eJvwj85jJ6rdHEdMKEJEs1oU
8635	fee_transfer	1455	16000000	1	CkpZt6ra3kzEHNrTzRyxccz5XMdfqme7Sn947aKKKxjAk3nFktnMC
8644	fee_transfer	1587	939967	1	CkpaCNtYHx55rj2Q33JWEiY8TAqnaLDAQa8cKvUxtWXGkgEHHuoMD
\.


--
-- Data for Name: public_keys; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.public_keys (id, value) FROM stdin;
1	B62qmqMrgPshhHKLJ7DqWn1KeizEgga5MuGmWb2bXajUnyivfeMW6JE
2	B62qmVHmj3mNhouDf1hyQFCSt3ATuttrxozMunxYMLctMvnk5y7nas1
3	B62qjX1zTYtJqCg6c7VHYjTzGTEgzzYxE1ArGZMZQpoukrGXaDFq5aW
4	B62qqDJCQsfDoHJvJCh1hgTpiVbmgBg8SbNKLMXsjuVsX5pxCELDyFk
5	B62qkbdgRRJJfqcyVd23s9tgCkNYuGMCmZHKijnJGqYgs9N3UdjcRtR
6	B62qqMo7X8i2NnMxrtKf3PAWfbEADk4V1ojWhGeH6Gvye9hrMjBiZjM
7	B62qnbhwgpyQzSSo9Sea1wEbEMjr4WhtzeQWRzAfA94fjros6UbSiF6
8	B62qpPsUkaaWC2VPzY9MBnQtUxYRFCCKHf9uXTZri4duUXGb3F3tmX6
9	B62qqwnvUmQNkVWwmz7Q4DEK7frPYMU9wCawjrUmA39Af3FtaVz1WzY
10	B62qqomhidaLc7wbYPeaHkGkzXVNA9z7pqf8nL7UjiSZKmLmVT1mPEB
11	B62qkYyCBSWdRQPkC1C3KdhNxvoVDxK3sUjVBMkV3GZ13daCPszYxJ3
12	B62qnHA8SYctwuFL11w1ZQ6MPyxCE7a44mqG1wk3DQzwkE9uzCGk5iZ
13	B62qqnZWjM68fMq7jVR19fGDnrigtYX9WZ14enXFiLZkE13WDe4aLy3
14	B62qoZ1MjrwCCGgq6AUSxb9dx23FzoS6rABLtmCxKh3TuNaymR9Lsnj
15	B62qrMBmbcHLZbsQsmdt8TjJAxLzAohmMRmoBweq1sXw9oBfQRd8ayV
16	B62qpFzTCTjEyTi1xRsyuE8aJD4oZvbWVmC8H6jpguHZuyoXKHZpd43
17	B62qife4P6rHK2iTnqYDGdnbnLBDHCWRcUBLPt4hiKYCxntRbSggo7k
18	B62qmC9ypxkPz9pgwxvrUPL65b6yNQTUWpUgAkqN5R7UurwuSaUV2r3
19	B62qmoWgbRAE4X5GyD4kMs3CH2wj39tjMATZLWb7zjg4kWn3Pp1QuiP
20	B62qrMi68WSSWpmb3Yfp7ztzAFx6gUyF26VAzPNgYEoYKRASRj2pqZK
21	B62qjWCpSvwkVNub2Cmbwg7s15RMK3WpS4zCyGTjacCcLeWx4JHdCf1
22	B62qpR8BVdV86jgnzCzHebvAcSVnKb4yWigJBrUWmdDUZy1qsHtHUrG
23	B62qnx5hKBFHZFUFjpEXzh2du8wRegCHrp3kL17gY7qxMBFQcBycJM5
24	B62qoGasCeX5M5HyK95AKLh6eXK92tBgAfkVJPuS8A8NkATuMjRxSbF
25	B62qj1zaXZxuRGzYfuq2KBSWvoei73uGZw4yqzRNTW6xiff5TGy6VJe
26	B62qrzgDHmFmnuq6HSLBd7kERXepvfKcoBqTRS4JcBCMETcdFk4rwG9
27	B62qr5Ckko96JXfECA79Vp1TNn6KUYLQ8x6m1QVk38e1uNgupVK1j1v
28	B62qrJBx8f9rpna3QzJwpuFX3Jzb1DmdVJxyXof6nDBLBrYryR8Kh4s
29	B62qkrhfb1e3fV2HCsFxvnjKp1Yu4UyVpytucWDW16Ri3rzG9Ew2cF4
30	B62qnzyWXFmSALrg5E5mSrYo8o1WaYEcFZ2bDDMxNUUyP4y2SCsQtB8
31	B62qpnYDuvSsk8tKgDxnXEWySd5zuyj7tbTc2qzPQ9eU9mjJnZEYkeu
32	B62qnxw3GS7TPFiHydSwH8qd2FJ6tm9j2qk3xUFi73DvP6H6LWteRAh
33	B62qjZD48ymWaV9jra4LyZMhLUiJa4XbXpH5JxD1pFsrg1pjXfbcjRf
34	B62qq8Zswd4JHeoTkWAVs5fSYDwywKcZDnNiZpyHSDJz3HqD7A73Esc
35	B62qraStik5h6MHyJdB39Qd2gY2pPHaKsZFLWVNEv2h3F85T4DmtjC7
36	B62qqfnfVegeAMKRsUaQX4zUrPttA2ZZgZy5fX8uw3cfRMh4HQMbmvJ
37	B62qqrn3yzWRDJrUni6cRva4t51AcnY1o1pM4xpB78MfHUH3ajZu1Ko
38	B62qkUQyaxfFNtoMXoZwa6Ar9pXPzhzeWCEsvvN1Eb6KfDeP5PgXJFv
39	B62qndRjyGhBTS1GJEmSX1VQr4u7zcDXATpgqddoLF9SSScjcMqqoB8
40	B62qogNhfVvpDE2mXJMjJ9CT6DtVAMr6Be71xFS7b7sdNYSfvaQBAkb
41	B62qoB8RRURcit5keJXvq7uXzYkgN4Lsz5GFaVpGYdA9vAiASy3iBcD
42	B62qixi4dP7DcKdTNcK8jobtv9qKFjxf7ZgZVoQcJXVXkeAULe3hT5E
43	B62qn7HrKKt5ia1dvGYHuvuFGLdwNSXUSAERQgvS2yZbZvVaK5biQef
44	B62qijDC2gCTtcqYGnUAc9YgH2Uw4fzr8xEKKL4faZmWyAypgEe3oWC
45	B62qmdsqUB7b3GYTWmCTGSioxMKeSesj4JrcRQRmmPRqwTtTo6xdYDz
46	B62qqiV28EmAXco2BuXoL4wSz3UHCv7zG387FnqYoiCkwNJWRywJ3KQ
47	B62qnSEkCtGJcTD4eJJvSHnZNsqP8aww4kdW3GGfYir4XTnXTjeED34
48	B62qpujwq2HQtwJnjj9vYgjDq8hJyXnTdMWSMyZxHBQQqEoEYfybL8x
49	B62qowpMhZ2Ww7b8xQxcK7rrpfsL5Nt5Yz5uxaizUBKqpeZUqBETa31
50	B62qo3mKb7LGbJhT5f1SqeHThWhYeQkQ7RH59S5imK69pa9WeTMudi5
51	B62qixNMEVEmPMMgt4M4FDdDHdUyj5ZaZtpN5cTzPiWFYubHaUUs7CD
52	B62qmG9DytrgGor58qQaxhSwdCzR5skbZtVWs3GsY5ywXdAoDCqBaNf
53	B62qmAkbNGBdaWSM32cqvKWA2nzySujjJbKPxqNfs2V6es8rXZDtsjv
54	B62qrdiTDeX3AP6aHn62WUsQ3dT7mH7zA6YUGmJ5R9FJDTac4j6DmPA
55	B62qqoBaTeqq6K5kpPEBh22HHq2BJ3ukegb4csDDoyoaFzdpgKLidYS
56	B62qqrTPrFvi3bvcGrM7zCgc7YWug74PhzRBGzBr19ao5teNQNigxSZ
57	B62qj5tVzR8JEoLWYYE95tXaACqGD7ew7vk6TnTCVdEfCo6nUtvggbV
58	B62qoXQhp63oNsLSN9Dy7wcF3PzLmdBnnin2rTnNWLbpgF7diABciU6
59	B62qiW2BLxkiXcjVrhuhvxH8QTMcFHQ5HKs7yfuqwx2pooyZKsjq6Ei
60	B62qoJVEF8K9n5Vsqm3dtuqSzxAFC5ppL5zcdYL8gJJFUuedQoLTLbK
61	B62qpYxXxVozLf4QRhxfKptR5Pz2nJoCoPVwiDjvJGAiijf8aHDoy5f
62	B62qo7F5ccXnDoeH5tazsr32uy6cfM3qjjR6AofCMBb9axfA3EzSgP5
63	B62qrJb5c4yaeL5fDCrEU5tGsmJWbcfnkdW1pMQbGT1rAnnA2JjAP6h
64	B62qjwAoLA1iT82EQQidZDDovQND5PeJtmcZXq7USbNDGEqgYnBbKam
65	B62qmbNN5xihYm7Z6b5sEdJNzAqppJ3jnk15QppaJUCuqMuWfMP3JNX
66	B62qjZfVCSKPAeFp1GZBZFPp6jP2fdAxLQiGr4NrhCk5trGPRMHFthD
67	B62qoUaRmzxG3atakF3bnpHT8enYCCq9UaUyAV4JZXyN16GMgJmYkHC
68	B62qjYqfAWQPikmwLARjwG9vpaNgCYEFT4RaEYjoNEsmXCVXb3HWonL
69	B62qqj1YzdmiHE43B3CYXbi6vU7o4x5ZiwVWnR2WQiUxfx1CNDHnzg4
70	B62qnj6wXxdvbPkas4Fxrz4cbncpE2yMPiMfZT8kmDSvGScYpT3AsFF
71	B62qkvWArUfzfzQYorVPSqKUbv45BHE7FWYgSgaCAFRVipVQjbZE7Ss
72	B62qnEoBEjGFRb735UzzoGAzpQgvUK3umJu4aZZsakkr1E64MVC7ySK
73	B62qmLP83WABda9CceWg5RjbzS6rNiwFg8FzxmZyXKyj5duSGhE8qAo
74	B62qkDvSJpbRh7GYq7jwuKaRCbQ8ifw3syWyVexJRu6KtZNbTpNTR5t
75	B62qqpJCDYAFpFMgm1FSCwvY1E4r4EPmoH7bBJkuGsGJ3hm3cpFLGSE
76	B62qpmq5XCNpv12G125tnrGtcJJnMD5qEQ8Riw9LLEtjxAQ1wNjywYm
77	B62qnXPppCEaxMQYSqYPNq1nYWFSYLJvmCsQmuD79F4L21sBmUoT34N
78	B62qrR8VjjKrijdZ9HgUg5D33CrNCWhDdJr8gvmdFFCizCGgaeANhXT
79	B62qndKQurk75DGcgVb1ZLv9NGfCtAAP9g7JtoB9rAuaT93WkE55rbz
80	B62qkd4tZQGe9mo5tK3wQi5PUoMdtUGtLWps6Se9o1qWdwNwuUtdWdr
81	B62qkBgrQRS47DadYBiGRpo4y9h4wCiYmRzwgCbHbidN6ScsuFViVuh
82	B62qrAJ7wiP6sJwjM3RsZX3Xzp21BpfkF3yXA49TxPNBHAKrjPLbx4J
83	B62qnmxotgbGMHt7NkJBNFBoZC6wtHhBvoV472SfHzR4RmJsRZAtc1S
84	B62qj5TbymjFWUsjHnCDNfzbFbacKzXwnHdgDJDoAZwcs5GD2sacGMc
85	B62qmD4V61qQ6FFGEB4dJ7Nn3VVSxzdpJXRnevBJBMhTTphP2DrounC
86	B62qjM1iHPTCF3MDqhX5xiNhUHYzuxDKsk5ioKGE6AwvhAWSeYF9p6W
87	B62qmYVkkqtgLRvizHiqpQdBqQgiKv2kyaeQKJ2JmzbNN3J7bvACKpC
88	B62qqS5kLArkb787BAJD57Q69VB4MAJp18rrxdZBojPnd2yw1ULsYbX
89	B62qrYkGp44a78p3t6uifiBq2wwctJw3k8u88sKLLAgdAZFK1G8UGcH
90	B62qpoiUSB7FaqZQ2tHTveQ5rCS1phjByQZkTVeZzzRZXcRC8cvB468
91	B62qoWeaz5bDeo7Zt7ckkXnWEYTdNRUGQGgMNofUJ3hZcAG1KKbo4Ky
92	B62qpuQzCRgYUH7Ehi8gsLdRWVc75uKHwTUmsbsqTUMeMF7DcgpEJbb
93	B62qmdgx2WFkeWd1eMchRQUrhW426RFMZ6ZZzgv5itAiQfsjYcpC8FX
94	B62qrYveCMCW2tr5J8gu9T1rh817zsq7j8cjc9mHEecQS2tRMnoNTsy
95	B62qpYmDbDJAyADVkJzydoz7QeZy1ZTiWeH1LSuyMxXezvu5mAQi53U
96	B62qphjuHHaPY37THFRMYRQsVCf1JgEE6k512cV3S4RmkmdutMhzZmr
97	B62qkNThcughFM7r3aaZZFoZEyJRJiQY5tpFCRQZNRrb4AWEb4kFVmk
98	B62qrPt73ni9xPW55gBova4hDKyhXBuBo9yWBT2N94CC1XAfFmXxLsc
99	B62qmgDU4ygtzV5ZueVWgSFjYtkatqjSTmj4z2jbjN5XjfLMrmK9zkx
100	B62qrUCF3rqUMTXxjEWpmLprwJ1y9fyN2UgJB9DLQK36iHfcv4Voequ
101	B62qkqN9V4TQZWBCzPW7QiYh87CTUJBtVxUHze2cWxAUviZtwkWvZg6
102	B62qo23z1xZBR34du7GUtN6yGvSV9sXXWp2VHUNaCQVuasSwx5mnnXU
103	B62qrzTgzDJ6n1UojoypnHx4P1onR61r3RZkFaqFcgQ1mVUPY6cJzSr
104	B62qoK7sfMMxbx63h8Pmn9fCCSDBaW3WNyhniC2pbbB75kYZc1Xsk43
105	B62qrN1MZnXy15VXkh3D5XiNPQVKQLr4UXqBPFv3E4NHNFrzANC4wFb
106	B62qjW8gnXUWZH4zeMmHGgj73BRPt7bYkWQPcw3VG28QvfDJC2gvQvn
107	B62qqoY9tz6C4QafDyUGsxvJTJonnvJ7iCLyzzMLcDAoCAAE6nzEyGb
108	B62qoSqKkE5B4HPxWtidWGDty12o95nicTb81fW6HbUDPycQvDBs1cD
109	B62qkaDe8abFe8HpTgnc85LBxbg5pnoBvFraxePy67YBXmymWeW2BcE
110	B62qpCVgRNPxcoC5eQKDXJoHRRfcNSRjzq2YHymp6AFciH1bsRXkkf9
111	B62qn61vkYgxbTcxgbv4U969wrn97BZCZQrH1tUXFCevt2gXZENX9jM
112	B62qj49ZC1dvWzGNMd5VVxSVQhZv4rzoKd7TdsVSUAsHZ7x4mHXAWjH
113	B62qouDi7P2eXT2fRYji3a9rGCVQ6BpWt2iwb8y2yZnHL6VdhXtDcCm
114	B62qiWir45GBE9PWWoySrVnB8ERdL7QiykkfwjyzytuDSQTbibigSuw
115	B62qqDDZYhfU7mNcQKJfWHDJ3JjVTi6dG32oWiWY3KrrX4mSMLdEuUj
116	B62qnbxW6CVKmmRnwhYXc2EprVZXFBQVJj31W5FFLpSJgELsAkuU6jJ
117	B62qk2k9kWwdJ1C6H7QmxgK9JWkXNRZkssTvaUnNStLuwuo2NyopLoD
118	B62qoimVsUrBatqSRFuzGCWUHHSA6F3pA4hjX2Eb6QKDdrqV6oJFru2
119	B62qiVpQaFZer4iZY5n6TpmquHJtkvNhJWmR41XiWGZbmhQqGvQdUjE
120	B62qrkCaGXGWJC7JWzdg1nJv7Y1opgWDTDi6XknSYwTdrkMpTrg9AXc
121	B62qj28AitWwLTU3HAhtoW34nJ6LkyHU7XKm5wC84q1RtF4ho1yEgGn
122	B62qqb9QnByFcRQ2BGY6LjogXvsbknCxUPbBzhbrB1rpFoKR9Ys5VpE
123	B62qqLH53Wv45FVdA4tP41kqsCaSgJwe367qzfPp7Kxj9fGaQdrE3sE
124	B62qmy9tB4Nf9vVgg4ZJsiS8psBvxoSKZrWPmXRFX9tSQMyWRq39Kyw
125	B62qoSHqhByDDSMj85436DyUDRm1HDayaC95Gh5GinNANJD9EceHQkK
126	B62qoqGCXRr2yJRyRpRGhLZEP8a8B6rpBiMqxdwf2YxwYwpB3RoTGpM
127	B62qmLHunUCqVvXShJD6Qtg353wtM5fvDnJJu3F1AkeiwEMmbrnhVjg
128	B62qr5X78ew3GvKfbUUV3QqYiSK6vgUNCuLSdfMWCQw5pjp4L5TZw9v
129	B62qrLc7FgHVZ8dXyUzKHsL87E7Q2dRZRgjJcD48Lrnyx5FcyH4jLtd
130	B62qrNuUMrV2yBaGCWKqxYJNEihwjYxAZi9w3z2yESK8XxZs58aSB5y
131	B62qipAVcEkYgwwJfGsZ3TBhNKG8QU4J5JuFduWDzAUrUnUTR2C1a8L
132	B62qooos8xGyqtJGpT7eaoyGrABCf4vcAnzCtxPLNrf26M7FwAxHg1i
133	B62qoa7TmS3zdF2fqTsuDzEybrr86HwofCs4aYxeioeyRhQXaJQqK9J
134	B62qj9PPXDZuviJRDYPY66b7Jz58Qn13feGm758GpbQwJLp1S7oi825
135	B62qrYRkV2BKxoH6Nwuz6hMdZUk8U5Pefo7jdRWD8STdi6UL2MMaTaj
136	B62qkqCoR4oFfaEURsoG3z8EYuy8jVRoC6Lz5WGRNx8siQydG5y7Syn
137	B62qmFxVhebAGSspFQMdctwQRynupZH4dgZb3bxedcEumyaA8X9PzJP
138	B62qmAgjG13dd7gH5HZVaFRXZMFsLUVhs6qyqJdzQbhFs8SU9rycSX5
139	B62qjAijvK54GbYNLvZtva5tcDk2BbZAvtF7aBU7cm6bpxxpLAopJqt
140	B62qqqYnBdaqtR9LKfmXiQEdtdaZrFbh2P7YLi12u2JsmL8XHuBY5CA
141	B62qkag9ybmAzG9areQNg5oFNrsKjMc71q6nVnRDRDVo2XBxBcuzrA3
142	B62qmEgp5XSe6jsrJjuTkNS9fpvcUSZDBzs7uqJ8vEg5vgJ9BSVYDXm
143	B62qoX5oLk4m1wDmtJak7FHuEjxbGhpeARaVzkrn5gCHwPS21b1QEXz
144	B62qpRFS35fkGa3a7LEWhN8kZEQecobt1SZueunGXcxffcqFLKzgXHi
145	B62qkpma8whukuHBYjqJy4qNq2KoADVoyxccrkHDcw7332ifwGSVL56
146	B62qkes2AXQFszcXKtS9ZHVofoPRZJXiXzSfYVpH48vs14LVQXPoBfY
147	B62qosavysGuVW49xaiyvA1EaUPEA5zXdQWBrJp2XUtW9x5i49zL7yX
148	B62qkyzCG3cZhEVNvtec6Yt3MHxZkXhrKJeDLrKUVNPEpFZoa2gM5gA
149	B62qpLST3UC1rpVT6SHfB7wqW2iQgiopFAGfrcovPgLjgfpDUN2LLeg
150	B62qjV8B1C3nbRqKXEiREjNQCLuCL4Y75PPpwcFqWBAvFWN3X2iJJJD
151	B62qpxWMmCV9Qgx8EFQ3a6cpofDoX8DVMWrb25SCcRrsMqb19kuC5Ue
152	B62qoVopcNoQPFydweGWUBnJJbrokkebVDiWGmAzYoaLysrFfzNCbya
153	B62qnizET2q8NkKB3JfNYugpzq6Yddpufb5YvwWNgoxpTHUxMpVyrcc
154	B62qj8oSkVyBfVim9JWehGAa8eN43Q9RU5HQdzPSiy4XmS5uVAG7dJy
155	B62qr5UCVcHxSvGikJadNpn2bX7rvXRKzXQppPf2boq3eutzwxnTnkh
156	B62qriyGf54B65U6gZFFYzSzc5goHg381HRkYmgXnRqg9QMt1kZo7ac
157	B62qpk6VZxMqJjpYK89DFpj7SA3aE7kVyNAEw3G4TTxsK7NwEkqeMyB
158	B62qkKecntugWPMLfArv8cQqQsTGU9NG7gUakJzAR1cFTfG19QTfzbD
159	B62qpyhbvLobnd4Mb52vP7LPFAasb2S6Qphq8h5VV8Sq1m7VNK1VZcW
160	B62qktcFUDAniQGBamMXRabimiT3igb8bpbxok5h2yf3cSyw6PDH1BG
161	B62qjqVBKhE7Y3Kb6U1PqFt6vjk1uAFWwzeyDB2WD8MMunyHmBu2s64
162	B62qqvN7pFGTSzQgmwgxVV3nCAjQSE1mTpwHfQabpM3kZvKhYbhTRbC
163	B62qixTkfYwADQSS9SHL9NRBoNKvmfCYxQAPhoLiZDA5RsrzqiRPLHp
164	B62qkN1mBrN8GvxUSLxRHCvpLba6QX9TXgCLh4TcgxD1Bstewfnx8ff
165	B62qmbwRekMF7vGprxsSXT6XEPYVQcYN4dMdRZeZmAkPWwq1g4zV33Q
166	B62qrsEeZGxCaCKpMiHoTxWtT5Z1wrRptdh32xV1nr4GJHz5XDus5bj
167	B62qp6RfHVKvyLaA4Nf3NTQ96cxUTz8yxpTuZWAAvzdt1vbxqzxRGjF
168	B62qjTanvKuhcGC3vY9H4SaMsn6m5e1PGf7td7UAXZbRzVsmiB9oM8E
169	B62qieCpKu6W91BrH9vyjbHGrs8PpuRFkHSh7vorLJnCp4akJecCY6V
170	B62qrXo8soPBcTi8G2EHAUxJk1hpsQKqBoc2oXsHkwczxheJTeMzrCh
171	B62qjok2BD2jB6TArVM1oGDSo16xk1SYGzTwZSjx63WbtZy4BuzPBDj
172	B62qiwhAyp8prsTLatm4EUp6XvDEVAWyhY3YEs5RwTsi4wDVd21SfoU
173	B62qrEpQMYwujaWHNswuY3Gud5i4FLkrRwds5RNYPVyh5FwZJXgsfPV
174	B62qkdWpePqJ8XWogMvzt8kHWG8LGzG9gsYEuK5gbWePbFAZYohAEzd
175	B62qrop8ZLmVpu8AD3a7Hsqi9Yp1D29RJ7tfqWF4rVpAt7bUEZCsWpx
176	B62qjp6bK1jLdWVUXvnrhKmfuAuvLSMtCyysKEKVxewrL315BSPeMP7
177	B62qpFW3CEiqiVi4bRpDKf7ZNq3qNUKbHKhxQ68EUQ8QeeK5pksZVsE
178	B62qjb7gJQvsbEnSTLTft54LbT6YVWTAFL9zizzb8wAeSFudP5j75eW
179	B62qrV2oyYf84jZbQHdqH2TyUndafsL134WMpf5yDafmQ6ZGMxUiTmF
180	B62qqL6UUFFPkM7m3j2mmuEfjQvQdsKSGTu2CqYeYftb4sr5ji9DiHu
181	B62qnr5wwBn5dTuYTRgKobVujZYWLNBYA9marvg3y1e3yfukRmwqZv2
182	B62qpjEJn5boKL7nqM7G49V4zY3jeE2M3czqG8FXJEbAADstvfF9T7Q
183	B62qoiEyq2QHR8m3sw9eLdJxZzA5ttZ8C4EYfRs8uyE4Gc7Bi5rY1iA
184	B62qjyBDHWZfC2WX4sT7n6oLyexjzd7AW3o8r8yrbXFyjJnzwFDrGHc
185	B62qmyp8L897rHk5qwb9XVbwDge9e6q6ENYAH3sPkyvwA3cDXrxvV3r
186	B62qnAkxbs4gqZVnqzpQ6vbuoAD4VQSzYLydjt1d7eV9na7kXky6vV3
187	B62qpkiJW9ZCXtFm9WeY43ajhgwxVn6QWaeQiy75Jhpbv1hiaF5zswU
188	B62qmxHeEYE5fYVUVeLKHV2MfLcRpJMhtpsUaTeXmuGaw6UjTUwpQ5i
189	B62qkZhutQR8e2ijgAyChi7Ba8MEhRnnYfEVG2Tp9qsAff8HFgWgDHD
190	B62qmnmynER4sq7nV7i5YxhbcLaWQcqnZJhriVVaJgsmGzJt7mQq4uG
191	B62qpH4BktZFp5in5jKcfFrUqAYKbpU2RhH8iHmLKdraVWxjdbUMbpG
192	B62qiV4rtGrXstynn9DFMaTmQ9BB9C3kxLHmjsG57dyAKHxoqooMZGS
193	B62qowSjKkwtESnVZtaZpvuPJFbkygn5CZo5Ym9AKTHX7hMjMEhGGKY
194	B62qrJr7qJF5VJRrChgJj9QsskoGdJzVNJoMk6dEtnEBNKci4faYWfe
195	B62qqz5V5wjzg24v7HUCyJUD9a2Xk5gJrb75qyLwE4L6Rbo9XtTZyGB
196	B62qifMfsFYqLJ6Cf1KbwPCxsNwFA4qqcMeqWVvAZi37W6oRDnHRyYz
197	B62qpwsWhvau9zqmWvzXoHzWbpk6dXEx1UXP3nLQWmnFAuZAoMCKEYb
198	B62qrnHPpAF26JphstpLvPPC1L9sZZD4g8R1SNhCQuY36fbuXS9jaEK
199	B62qqYPMx7tRYqSMHzXrEb1HSTrLmsTpdDU4GnqTcP3egMwVH4pdi62
200	B62qjHrPXCydF2R9Vc2Gp9Cmn55eodSKUmhW7fQ83zwkXkMR77MHk3e
201	B62qmmjvVdhd2VBRyh5PJHiQkYkqLDgqa9uq5nfC2dM2MdfWt4ennHW
202	B62qnf4ieWyJWjLhL4GGXE3tLTLofHfgLTK6ZCPrrRnFrS4KEZ94m5K
203	B62qqWqjKKD4BBJVbPG9T56rStDcveAjBxoAWYGTfY75wyV3yQ4rYRH
204	B62qnyBEcf6gcaazmQWCPQCjizwBeBi76398k2VQCQ7mH6QzeLHMyqt
205	B62qp7Poht74axa1BJMWmN6MzAwEAnr2uRhi444YDvE4KAm57LEBKET
206	B62qpymA2yno7Qawq6vaK4aXtnNttAcvG4Nt23tFvbMPyG5yhEKMUSu
207	B62qjwh3KGD68vYySr2V1jcpkZ9uZZSoJJHzNWCgQQiLU3DAoab5NT5
208	B62qmRZKEwHnmEDh9Ywxf3be1AGrkFQnPES4FMKhDR7APWwQ1ouBwof
209	B62qrqi2dnGJeaLjULNxSFRqATdFqWetY3f3d7cHwyi6qdk9Y2MJPyS
210	B62qptxgjmuegvWsWgtjsWGyADwm3xx4sSydnV3iVNJHqtoYnWfr429
211	B62qq1xGN57tke8jJ3EuJMgFmgWQRoip6kKoBsTuLxsGXVqQXMN5oVj
212	B62qkf8bdX6AhgD7jR3Cs1YdWFkQpAaLAjWxqGijXG2memeU9o8i7Z8
213	B62qqVJQeDg8fxvedBP24KMFWcFB9m21V4tuLcJH9UQNdTrXxKrGrvD
214	B62qq9XP15kBmNexCELYxduoLr3HZKqRDQhD3mBx94rYPjjCZU1y9fm
215	B62qmCh5jJAJKgDaNL62rYcQuERxAm1q2bXKAFuCvKNH1ogZme4KES9
216	B62qrPLQL66L4BKeCFeypQHcAmKCcjtEr765o78xUJE335puxC9NViD
217	B62qjBp3TgwngdrKkK69NjrhTFS9KSTriLFiv2FKvnhGfjbYFFZCT9M
218	B62qpXuwSUQhfYfiu3CrZLXGzrCrxzkMNQAUZTu1bmxn8rsGH9zv7aQ
219	B62qj8Ld7mfYLuVramqiG9UWVjeLp5gsNy3pRCc5eF1heDMzkciNpF3
220	B62qjj9qsR77nCaqbQ5Q1XE2321gCYophTf1DfYi1uzQsCQvTFNsExg
221	B62qjwkotonAhcHsdGh7TsshXjdLXZQdJkTY69E5rtG8vCEVePraF82
222	B62qrQTNYpC8xQK2r1APUksrApXnU37YyZFhFtpWip3x17zXnGuPXcS
223	B62qrB51a5BAUn2TDX2y5RdMFmu7ytb1phVdKM1PjMjBPDjdzrHPp9T
224	B62qrrMKTKBGUCPstWDWBHAey3VRkztZFZPr8FfoX7qxdPTpwinMedN
225	B62qo5HvEcc98R9N1Y19hpsvkyvHbgFc2f4Dg3EnDAaFo1N3MG3xWJx
226	B62qrCmbqncUWGMDo7uEFzf4JSE6kSSuEuMMQwxAWxp8wYbVE8rdX5P
227	B62qjVX9MmfxajW5kBPjQgkTcs32MJHtydXfVdtCs1qk28bEcT6ekix
228	B62qjd92F7SH34QN89c2a27G7H9UM7EdFxWMtnmCVKh7jSW9WBq1fLV
229	B62qjzaoqL6ShpuMrpseveR2wpsBe6WfeEpc74evonStZebJg3Qu6jG
230	B62qkEHwUWrwMiToMX7fnRVtaET75RiFHvkFhd9up9bJhneipecEBx1
231	B62qnQsZYqubnj2tQ74m664TQ7CRmARquvq3p9pzaS2dikjxPnpePt2
232	B62qq9WWQBH8Zy6uHEfQakYGRcCAruHRdaQU597WFR5qf5T99Cab3rE
233	B62qoTCCaXTdQwiN3C1JYZkgjP4L8rKQrrrqpnGWhsSHjvSPzYVqTWR
234	B62qiksZ9WSGYb1pg3AvgzoQwqQy62F4pao1X2BNfj8hJFjovnh28Cw
235	B62qoSTXoK57i8UQ8RecMv592EkTjNQcSWpyVvJ6Ck6xgpBzvUFc6CG
236	B62qmNM9wRYRw5MdFfjwHCC8egn6aYayeuhVy4fpqFpahb1Zo1Rz3xn
237	B62qjDdeNBAc1AemCQ8fGYcLTCuqZGimzGUb4pXdzYws3wCmYFCDTQe
238	B62qp5dgv9tGSdD2DJDgJC8m5K3ah3mazxVagMm6pM5pJzX5QuPp8H6
239	B62qnLbQjbgBwQgPuLg9A5syh1Q3hwT8ecsFZ5dvwdtWRbsLfjjUH4D
240	B62qpwAqAJ5HaJT3iJgoFM5vC9gSJ1u2b9tvpRXx3Ns8mVoZTUDgGSL
241	B62qoPXEf78Lc2DG7GA7oU24Cd2986VxsCosABomT46JRMhYAmVfj5M
242	B62qpJwpBqDKDHFvv9uRDXHX2Tczc93zpNhYFcZAVXWm2KrSX7831Hg
243	B62qj7tJG5rxdy1hxo2tPo8xJGN3qDHwQdPqq7UMH6xGfhyfUikyKV8
244	B62qkoKSs9aAJLYPUxeqnRS28DRzTPfLkSonNjViXxM4bWQhVhYi82F
245	B62qprj7x2ByZHbVAf8r7k4fZKR4f745ysQA3fYgZh3gSdPoWXCDry7
246	B62qowREyBtVMpp8RVkbmfvZgxryNUzcJnRnH9LRs5xgAXkHhLyBEyz
247	B62qov9yv8TayLteD6SDXvxyYtmn3KkUoozAbs47fVo9JZSpcynbzTz
248	B62qmr9wnqsmhgThnSHvNKM6JtpWdJM2iQ4GPtUJk6ZjySeNiEyJmvk
249	B62qovgqKTuLjiCuzkPgVS56ex3ygxvGn3m9Wvwa9w1ZUo2EpuGdS5i
250	B62qk1oVDgqaoURSd4GY2KmENSYu8fnx8b7fuZSyVfruQF8gsd28D36
251	B62qmVkhfGqvfYrybuY3pgGjbLifcC1Wy1hLC7VtKHmvypuhancbueR
252	B62qjNN4wmuSdk6sS47Kpfi7CzdSEsf8Qm3HtmNCyxFhE8zxufycgQ6
253	B62qikyGBRHnK3Gsho2LzLTDXUXjVrQBm3StqasyWKsTNHexaxYzpG4
254	B62qmeYkyQGyqcdyjagRt3M4rpyZoJLoBK7Abv1ia4LBDumJfDEF2nV
255	B62qmMGz5dWhmrx7JgKtnmb4mqu87tqXsMr6wcRmnGzHrd3Y43iwhG9
256	B62qpgov22FLzdo7XoG2T7fz2CyxYqQtCBJ46SBscA6Vsv54qVD1oGy
257	B62qkd1a21WXpBc3kUrD86yty2VH3w24vC451CwSPbB3M6vStSBDBZi
258	B62qkMHhGvhdnDHYrwmCZC26VeZWwv18kn69pZzvXCxhi2ZiMJ8fEF3
259	B62qrQD8tyWsVArhMe42biJifujSr3hNpw3tRVtUakuUtRiBLmczChc
260	B62qiVNpFfuhEQyYUeQR82fxe1Bp3RXvc53JG2vedVTNSMR9Q5srxdh
261	B62qndynjUPACSp1Y9T6RppW6CU3K34wYXarR435Shbm2FD9un5AZjg
262	B62qrD4yGS7R7SutQnL4QqG28uwnRvX6hxAbyyAKiNn2HTkAv9x1BYq
263	B62qpnRWfM1SYB3z4tXbobpjQC2Gk8Kr33xQmk1vRpeMsfkcK4ButNb
264	B62qkTvL5o8LqNb6AtVR84smE4qgTJh2uySj8ufQd8cG8Qy4rPP1UDg
265	B62qmERM882YuYsXyGqnC9uLUZ3fS2U94QxcL43n3AdApti4pDA2R2Y
266	B62qm4AZDUA99AekfUfk1jufXR5KnaY7XFNUhd5tdV256voGdvwPFGR
267	B62qnd8XmGgeSWZ35bdbpKeoadr5vz3JV4rgZ9dZqu81o3K1npGUHuu
268	B62qqZxbrmjDz3ERbroPuHrgYZVEbWxoJxhMxmb6U9xcngrN98p5KyW
269	B62qiWVHJ3AxuSqK4hzkYQavBpnHBydNFSrNwyLWXizSnE4vzL2XTmn
270	B62qpNeSeFNHadM5LXXRZbQRUgpKXUWoVond8aoLpEVTnPG9zun2Gm5
271	B62qmcoErjsDd1XNsxpjPC7GUDYug7ersa9f2Si4jdD9Yom9N8z6578
272	B62qivKQokyen8VSDaaDaCKWx5BkBKDgei4yk8c1GTeP3b6C9DgmuFN
273	B62qr129iT5tEPohSHys28XrytPysFGFNXLFn1ETjGuZzTGm9wdHRey
274	B62qkeoF3PFQn7g9U7XNuyCvU8xqNxCA2qDgAkiefRiyNTZ7dzvjLvz
275	B62qmvmCN8qzDBKAD6M89hvGQeundPcDHhq5DrU57orGGKyT8NtrrRe
276	B62qpybcoHEEVNZUUciKrfMMtVV1uWq6HSjbK1jSo66LkMojeTDHzhD
277	B62qr2CgfiqKX2pVNkKTBKnHK8SAwqhHW1KUcszTp5Maivq1inYhRea
278	B62qns26Zzs7njXiz17AbJ9pvz3YSWa6dvXXN9vtNcJ4BTo2ZHSWQwN
279	B62qpiyGNhmLJ6JmBUqTaNJgHwkRkjQJ3PzarAmHfn5JmELY4RNPHot
280	B62qk2EsEpHX55gnZc8iASSekm8QYjh11NjZf4FjZNp2egdLi7bL7np
281	B62qkkWqU99Tk3n7voHNREo9KAtioaaYa4s55tdvEWHDYZj1wxYEvaD
282	B62qjFSKy73vyxJALB8DZLjXky1hqjpSUAMpumm5ZV4mMhT5gs9Mgcw
283	B62qou778MhEYT3qzuUL6LhsmSVMpB7FQn9ZkWPsYcHNV6LgCLDHcoP
284	B62qijd97DPQUp72zs3AiLo4dkUonpZtEZpK18oMK7G6xyX9YQdNJyJ
285	B62qq8itrQ9vYFGoC9orJWspS5TQ1BT2xtQCp5tmradoHYX3G277FYm
286	B62qkXTjDCwsYrDx9k65KEfXEn62ohVWNK895Jm26VQxt8nBhXcgr9B
287	B62qp8mnjoN15msN1LqHYXFUtqRGWjMhoZUysC8Bm49dMmNhhrPQmJr
288	B62qizN5gwSDjQXX1Ef3EXYEwQitNggDx8hdz9mqVCD8PDYvg7q7qKY
289	B62qrr4HsyQDc8BHf875XHizovkMqfXYKFxqxdcLPNahHnz1GZqCmXL
290	B62qpQeu4Td4CiTFU2C8bQXFgCefBc8rvvnG9C6Wfb2cz9YcQWaxomB
291	B62qqyn8atzjXyihkgRc9kMkKU6hnXtthqyM49Yz6FncyHqxkoLNkPu
292	B62qkEp3uw8fafP9koMTpxKLj5dEBvGRi5zWCE4hnvY5RBqHoJJwg26
293	B62qq1agJKStqQZedzMkEN2Bv7sTMHZprd7QJV8b8QAD1VuStCwyj8u
294	B62qrX53T6oax316MjjywtpTERrbRpDMxanZ66YEFVQeyvi5LH6LL9n
295	B62qopUvFqDi7UHtMtJyVsBPGGUKSmsaVr5C7qadxFQB5PJNxVan9R2
296	B62qpwieQeKnhXA8MEhsWAZnqA6qR2X82m6WfLqgAG82M9wnVCCsDNM
297	B62qqnCYD9sL3VjxeDW6z241xBr73bvEyX5TjGnrX9cad445Ut3vaZV
298	B62qns9cPvDwckhJXHpWZZ8b8T8oUgoF4Enpax5zNVBYYMtQwHf4Cmp
299	B62qkDvMb6vPupuP6qXKH4Lqw8fLJui5NcP61sJo9a9GKpQfteUPPt9
300	B62qryDkRZFK5r6DtWFiNhQhXDMWK5158MvoRhH8HSZuBLP2HLSqWZG
301	B62qjJPwZ81Z39Sg2WJ5tNPcCFBqwSeYZd68w8579eggnSyhFgGscuY
302	B62qoZ2J2WZKrNDUvLqKszzHSTYa1G49HE33JYf1Ux3U54LaLLNThhX
303	B62qnoQLkdjimCnRMsFZMA1GSgLA8HZGzBKxLsVWjRoHdtipcqmH9Bw
304	B62qiWSe63weqBN3vpnUyagnMkYmvRwKKQJ4dKckuJFsojUAYY56mfx
305	B62qp3NP4uGMRwBLBcr1JP8yzF27Wsm4QhL6yijJqo3Po1gZXWHiZxo
306	B62qs1fcaLBgAudDzGoTW9DYDw5U3BZ8MwbGAQ2gPazPrxtAemrKCPR
307	B62qksHfcCxo5gstt7aUnChtRTvuaHKW6EXJbEnYrJ6rikiYfLq1qrg
308	B62qpHpeTCVYbnuhZexBqz5tCSAWKT1izgCFHs8n9EqvrLzppLGKXqJ
309	B62qid7mcNh29WVifR2qWQDLJ9dRu94EUcbsgrTr9fdFMGsPQzWv8Qo
310	B62qixmqCUR4GPHbbG27BpjNstYfYmfB1QwEzWVCaYs9TpSugweiVvX
311	B62qowm5zNjGsDzC67eTc4zvjXwdkPRUKHFzeSDRjm6FBojzqmNfNhH
312	B62qjKEsfg8hiRVUEcUjW1RstNtyhMes6hb5wfcgSZizfXU26SLk4cT
313	B62qj2AqXEq6hdzaiFQ7wNSQ9TrzHQKS5WRnodXvdM7w1pRDc4GsgMV
314	B62qoXS5hZEidS6xdqAFMhY9tttfkevmsoZAaKbpJCq427CVGreGGcz
315	B62qitncPRoGgcufdUJdbJ1CooTz7fQuttqxBM48toKiq9ZqHPJyLpW
316	B62qoPwGzCmaAtHYXSKPSFyDU9R2RS9LiAEKJB66KwBUXkepBfMmWPS
317	B62qq3WS7BeAMu8PtfJjrPYNNz9cJpa6EJTfTkn7pQS1pPddapn2yDV
318	B62qrqeuQmW7F9RV8Uuzj98zj5LkYATmSenTvPP6ZmdsXK4scMYW2oL
319	B62qizMCrBRUG9keWLbDFCJBJbDY1tRkeqagsD2bLPCno1zxhPVYFNq
320	B62qoo5DaMn4iZeVijjm2XnoiNhQTMCdWixHtNMGaD9kcGd1z988toe
321	B62qn88ZcEijJNNRAimr6AQVa4jJPuY48dLzuLg7UMcKfmaTQFkeXXk
322	B62qpza4Xqp9GTDcsdjGJabz5M682oy7AudCD1jkqsMWHuzynLMfcKz
323	B62qjU8FUq5CmJ6MWFFEM1KGVb9DfZSvSmDCD1U5vgxrpDxAV3JZDrj
324	B62qksK8pRH8WtH5iNzv9KPVnY3E7KnDHFBLZmC6MgP9DBBJBxtKMYR
325	B62qkfCnyJpqtHmE53DCWQ15KHJXd36GazCaPrCznrmrsXoUjeSyurJ
326	B62qqgLQoPgy9YzsVKwB1KBuyB62TiQJYawDubnhf5gewKJo9qrKdnG
327	B62qj9MASPt6AcfxHawZcwkjFEfQqRVTn6HghdBmtEKvudWuRnhyEvG
328	B62qkNQ8SenMi1kYoHMHwbK7q3i26yLSpPM84wxiqsDvxFBHwna8Vtn
329	B62qr61ij8ZPW5BX6GMs4UNW1Ry29Cjbn2Z2LVyLkGJH3JgXJwx2jiC
330	B62qrCsLRjBPcr7pN8wRaSsw18PvZrzc3W2JAFrpt7K3YuJtAfMe62U
331	B62qj2gPKXJW6S2Q5qZQ2FZiL5jcMMvHdZYx9EWJnNDeRkTKPURSSPG
332	B62qnmuq8SMKR3JFBvkdDEuAGQnCQAC1cH59KJCmqG5NksGmTfxBE2n
333	B62qq3JeAaCrwa4XRtmjxmpXox1XZSgcSUXLPcKtcb4HnN6p5MzzYzj
334	B62qkuJvHscWoTsvtAYfzvGgsbw7YRXZpkFXr4r6QL4fspkZvjjh8Y2
335	B62qnSEt8wbrzWPr6iipnmTuwkNBMGB3e4ayg7hDkGXNLEzq3BMnCnk
336	B62qkkjmwsCMeX42PjL9DNPssKAupBojQT6Wd2ZZYeBq1EF7PTwKV6x
337	B62qid146JcZD6eSrDt2p9iqrQC6eTxRxYB5HUyg5XpTezsqP73WWRR
338	B62qrcpCwQNeFJvUru1fdVBWCfTWae6n7WcAacgxKE7W5gKAXyTV8yv
339	B62qnkCQqXyeXvbMavAG9U9cZ8JJi5XB7fwKMJoSEemzhqCWHQxpe5j
340	B62qmJ9xkQTANN7g1MENQtWFb5GHisESewUGLP17P6gPc1aentpPknd
341	B62qpBAw7SPHqDJyWDxfXCwQzJJ9ddDVxXNPckF4Vz2GKjPEZaXZpHp
342	B62qodJCdovJawjWjeYyttgjqJXfE9cn4UqZHqPtj74N4zrDZB4X7Gi
343	B62qjz89NS8EiPH5dM4HrBEDdKUxn2h3xAurQDXV2rKZoJiizkRt5eb
344	B62qo5tnoVeYMWW7EwNHCeUVvBU6ffxog6zJa9CZemj3XBL3adbrQTp
345	B62qko73kcCQVCk3sZbxjCNeyB7Npxf4NfNdENUdfu93YLAUJ48JYTL
346	B62qm7PZqTRPCJCzxfEhERiT15SobMmcEFUYEXuUMn8w6esvYwbLfvJ
347	B62qo3wqcK4DVFWxGe5tT1eswqQzsE5kbT1PGUXjcenBQ1rNbFZ7GZK
348	B62qn1WvJwssC85DFfCn3ex3r91oHZbaUSZt8npGBZ2XpVdM1LRwpHB
349	B62qjqtLRExnb2fyMiBpv6nC1ckGuBrCY9mXtTTcf5x7GD3CG6sU3Ad
350	B62qrkPTrY79TGSUV3E69gMTpfPjztPzTC6TZxwEy9P5d4nU5EVgxQs
351	B62qjCrpAF3n197SVLwY8UsugdxekMJhjJ5rKPYNsZ8XTAs4CBeJnjX
352	B62qjmwNZgQq5s757XqHqtQxiXWQECqan9bUFAQaRVFYP8tnFKQKRjY
353	B62qodH3aWczywdoKsgixMBcMEmsg3ruSfFjXNYR11du727MdyCDuW1
354	B62qngpchppH4j7gtkHWnZfAzRm2ak2p2mBjNHtWssoEvhK2Ev4u167
355	B62qpJa414g251R6eWAEw1FhEzfR8YjQMrhbVtBQ1kMRz4C7hVeRAN2
356	B62qqu7KbdrtYdGr5f66RvNRG983iKvVXgUUfsRc18ZCPLVw9naVLe4
357	B62qpZ4Pav4t9e6ir4UAuJdi4JEPwvvNfkWMjm39rkXZMDgAidTpS8p
358	B62qmax52Wd2AdXKEatbX1cFYecQYsgpXwzzejAiJUw79x4wAGucDyY
359	B62qpNLG53NfZ1HUJUtNxTCJonDJmj9Q89wFWorsuNszQarxRqdcfMS
360	B62qkpDyPDoGMWFdnvH9QADDnw5ixb8LUu57CDMXQNsDaUdq88Pu47A
361	B62qknJSP3q28HrstZ8trCWQR3DGaSWzYuNQSi1JkZxgbyuxGdp3Fw5
362	B62qkr7ThcgibRwBiv6u556iBi134e2CTnSvQC2xNMLFNTqJWL3Dmob
363	B62qrawWiZbmyrJaB94CVpi8Fmd3Lxw5m3tbXo97hKJkZPkn4dHe6G8
364	B62qp2gg2aP1dxg7FPXVemWcgP5zaPBJoeeZAC3EgHtR4sTibD3Eaoy
365	B62qjgMVvo1JTaG6u1pBFNzvPGivGTUeq6TtbauypeVybojD5JdWjvW
366	B62qqS4q8Lk8uCWBK6xsJcHpXSqpabvgNWm3gHaXAEaFGANU5Eqs3KP
367	B62qoYEmT49GcVuhEpLiU8KBVE2fPENG7qdNRZkDjjBfYoD6XMDwAUa
368	B62qq5F7VB8sSDPDs1PHhmbmL37dtR427EWPmthtt7YpPPdy4fXN8e9
369	B62qm6LvKxET3xCAW5JdNWAekCjyJJFxJdYYNcpGNwvhe15yyddYife
370	B62qjCZxxdKpeTSXzxCUfcVmvDnMeUkebm3XgLLK3AewfawZkCkziZL
371	B62qmKeoHvaJL2MtoQaSUogTyZyFMKDeno3Rhc7VpxRE5kCa4EwJwH2
372	B62qqmgjAjoKRgt1ptEdqnFN8LTmBKj8YdSEVKxnAxcFtiRXYeUV3pD
373	B62qqAmP51fjPJ1FFVXP8i48f4zhEyhRr47v2X4iVfSVtMiMG489HAH
374	B62qqmRRU7WmBLegW368k92xdtgavt2NRKKFeneQN41udU3RJK4RypJ
375	B62qpBhnHWtr4sq1sRcy4Nd1WHA4o47fV3tu21e41vCZ87LGcCQCdW8
376	B62qnYgvJNeUwF48YyYMh2WDpnV2n69sr2KW7jDJQqRtPU4vtchiB4M
377	B62qpoqqu8Rhc6E5GN1McsT6VxL5i3DGuQkt3k23JVKZrNWxqGM4mDn
378	B62qnFz5DTg4Keh5x6P9pnctAzvgiHZyarCdEx7GYRew1H2Kw6G66Ly
379	B62qkUcq8Tt1h5PMXWoc9n4Jk6zsbG1YZoTeB8jQzS9JLrtL2HP6dyt
380	B62qqVDmmLafLcJG6bkXCZfmEMcnupNLoud3sVsxCn96AzjmJKXwqS8
381	B62qqdcf6K9HyBSaxqH5JVFJkc1SUEe1VzDc5kYZFQZXWSQyGHoino1
382	B62qkBMexQj12N8fYEeXMz23qVYpPtXwJYsnmRGsXJYcprgie5onhdz
383	B62qreVP6TddxX5CySuko7gqxVwzRmQyYzraHp85dzYG9g9ixPbVL3D
384	B62qm65cfsaBjb8GkDAmRgBLS6bnypkdUL2TYhEL7eAts4aR7UhtAwy
385	B62qidnhLeB2P7AiF8GtETeM9PEfCvWMajFxDaYWsxkXiajT1T4CUMP
386	B62qmBArXh34ZoJEXutPgSw8N5z3YgDm3vX2Vwfo5k1x4uZvqbQ8TYS
387	B62qoewSfNiLeUQUsmXQMmCGcD1pkXX7FWq2bD3EgsBojq2UaGG2Gzv
388	B62qrhxaun9CinfJobHb3uGp4vEXd3j2kg6iNhsWZnhDYzUyEMW2cdF
389	B62qqy7DHHzo4ryzUYdycH9jNaPYGj1vMUPZxQ2VwSq134EjHKeYiGt
390	B62qpRa7iZ64Ws7aH971V32TRmDAcLBfuxppxx6s4CAvmC3NZfBjxeq
391	B62qowXgtSfrWgMwvP6yxe3Z3JnpRHKZhsWCRLETNvMnT7ezeT6rA4c
392	B62qp8TJyLYVFR6FnQAZ4A3aBKCMkEZzWBo3VSuGkyhBMdFAgjhTtE9
393	B62qogfTBYu9xSbweoUywdPWxEy3wZGhmrv5fGydAyFTXTPnGY6vQPG
394	B62qpcGGx2UxNMgxqM9DrJuzkoB8Q6KrGifTVT6hdq4pwMUAsEtduQJ
395	B62qqa9zE4zcqLx2emeoeCp59f9iKBMiLtcQRDpBsqrxGvhrVciwB7G
396	B62qrUdqiAzLuzFRsBcYEBzvcCtSFkydyNcpyHj5Wu2umSDAztFnbRX
397	B62qikygSmv245hJZQzAhAqxfqeNiyPDZUS9MME4HkP9oFNhij85XUp
398	B62qjdxqhiaRQHExFvnEDGH2prnAU8xtnw5urmWUNsK4oc8AyJSDwNU
399	B62qmXi6YMzGmKhw7CK1M8VAybRyErq7VytkXULkjTjiB1FjTdoYxX1
400	B62qr5Kat2je68ni2TyEZiaPCf5iKPxCZPWjsEgdEJh9g3ZCB7GLWXs
401	B62qqE4CAyjRqdYXa4Q28dA1hHmtKBggmk6ufEWe71tXbM8DWpUwVMi
402	B62qjYZCaRMB7cXWvCowkhEHiHmyhwu7AnDvQhHeDUfuaZ3c6y4JLgF
403	B62qkPMHeYkG7q7uPefcU18CpKPpisST4YUay8dg8sZAKMrxMQpADPB
404	B62qrqVYXRsroeuX7oTLSXEsXg6DziGL1LmJJ4TER4X9rSQHsYBobMn
405	B62qmBNz8jAeKVm3Avkdqs9V796r7cXSLQ37RMi4ECswgqERwn5P7Uo
406	B62qmhWsLASA4x715y2FizsvzjggcsdDkTcqxHu1WkPuoHD2EnFHZiR
407	B62qo7NFdpzFbTyiUj5Uhks5TB9fapKc6jNDNFnFYtqCyyBNiFMhsET
408	B62qrUAu3VZ2JUA2Z8kbFVWcd5vGehomxCnM2LptvpKbuu3y5GNxbb7
409	B62qpwLQcUpYcn7RqDkDHGxAoWwy5AZ9uSab9s5YtwBXcAow81nLhEk
410	B62qnZG3J8PBwNrx4hLsgDmt7JHzFwTSJ7H8peJwRhKcHtsVsa2Ye7k
411	B62qrLFnh5BWLjHmsnrX9ABW9QVRDe237VKXQ3EobeXDqsLyY2iQD9g
412	B62qpc6JFovnLFZAa8JEAs9QQMxh12H2Xj4NFFjpyE2NZpoCQXRQxwZ
413	B62qojCVaJ3dKYgBUieccF3A3qzVEotn4Qd5k4tNU8QPNgVhZTpLwit
414	B62qpUXHbTVzyvZT8cs6fS3h8g74PNa4nFHTC7rhK29geJECWZnj1EY
415	B62qpW3ndQTvtcCkRj5jyPTbDFzM1wu5TiPNcSiya9htTzrZwuhExJL
416	B62qnucUMHz7Dw2ReNgWhmR5XCvPeQjJWPReuQ8GwPyY4qj1otGBiKr
417	B62qnRkPAoX5ruTEcRYPXZgynj7z6eVRcpozaLm4ixXhYpEbZc4jW5S
418	B62qnJ6gLytERFTXgY2tsW8cP3xDPhpJxuQFeFRMq6vz1JbrDz968Qt
419	B62qjRDJA1NUddVunp1iRerMg7Un74E3xPUwFX7NhLx1spgct4REDGh
420	B62qoa7ihzF5PiP66kFYctKKqmBy3JyVFYfHkaXBHJ1xKF3XdjvEzzV
421	B62qjGmBJWG5oP95zVCik6TZJ7HfoZpNLuEY2Ddy2ZBGWXsfm56zUqV
422	B62qjAiHpGkwYMVUpNFWsM5qFZKwcQ3PVch84RSGJLsRqgjHae9ypmB
423	B62qo4K69EgaffcsRf7DzN6nK83h161wYVwcGwxYSHA9CWfdDNCL5UK
424	B62qm8JTDW2YjGCJtsSSxeX64KXzU7V7MsFdT8hQ9oHXQgMfh2Ev3xf
425	B62qne2bgd34Fayvg6JjXtqULn1YyuFYfPWRqounqx6DH9Ju9Q99HRX
426	B62qqUQ3A1c42mv2oZydLGi7GhjWEjVCtkoA2YwvCqsbTKPiEECw6HL
427	B62qqWtL6b3WiAnyFoMHWARZxsp8k5p8UvJekFRc9szrAe3DzmCMJLL
428	B62qm1GNZwmdtE4pzWJxw9Tj4TLrjdcDkckuK7ZEezC1zE8PNaWjN8U
429	B62qmcMWELkk4nXNfMYZo5a2GtR5F12Ucb6NRYwUWEZKzAciTYu8GxY
430	B62qosqyp4hdQvgU9RQ4FjVDuEiLET8NZNqQir7PyddJLSAAx6PGrHh
431	B62qqLYkYxxiC5XKZqH7kFmMU8yULC7ezqGh117ZhGnaHQPuHjBhuJR
432	B62qipdnk7eq72uKjKhGQum7pAuJGGjgxK3XcPBN1LGN2bqLZXWm8XF
433	B62qpKVMtHa1z3CGBHX6JKtnRfYsYn14CqfCuKkYhuaU7mmynGPyGSU
434	B62qkV29d1NensD3yqtkDhp8M2ZuWeShpsvyv9qGy7bsF5oHKkErb3a
435	B62qpcENWiR5VKkrHscV9cWfPwNs56ExFeb94FDiVz9GeV2mBNpMCkY
436	B62qp4kr5TN9dPQcMCXVNCnGf6GoWA5SJnLCJaiYkeKfErLN3iNYKYb
437	B62qjY4qgqZLcD9vJSB3B4We3C5N7kjKa4cfGat2HsenyYuTgPJ6fkM
438	B62qm6XTALQy15eQPvpdietiVAJ5QBU5WGRugAxRpsvbiXn6iSdNqzu
439	B62qjw8HBV8mb1qsvZSA3x4JwyJp5SG2P3cdmNXSUmUhLkzmXi8H2yL
440	B62qphi5eyyXm5wbJ3uLCL18E6BzTdTmi5AE1Ve52mHiput5E5wEH7H
441	B62qnuHogQxCbENFXYJdhyxz6dYCJDVVgjkvGxQyzxTVFN71vAyJGYQ
442	B62qmzaPsEf79D6oBr3hxAK4zYMcCRA2soTFchoPmH3TV825Dd3Dvmd
443	B62qofdXQKEMyb1CzTCHopwZGWQ2etmhwvF66Ukm4d9FkzHB71qPUT5
444	B62qpcAVHZNHsScDZZLkn5KcLVYfAZ8kdVeTPV5t67gReqS7aN3CNrD
445	B62qmsGq63CNGbBjVLdQ2hcTp5UfeNXx7tmxJbNazQaKVxJ371NkJFk
446	B62qn2545en8u3Q1UhBpSABFn1Pq3W7psprDHGxuAxw7tUeM6Veoz8A
447	B62qogRBqMKjWk9cYkCiyQVPC1J1eHBZnVbUWr8kULPmsdF5DzmKuin
448	B62qpJavug1VGCBSttepmXr6nh8fvXY5SigbN44ttYDia65vwbTEcq2
449	B62qrhwf4jRdSi4rgU3B5C5eeEWixBVbfMBfv1sEVPdrMtQsSNEdycV
450	B62qpGALWoNczLHTwTwhgxjj2qjNqdof2wzxFoZgxqyX1uaccnQ4Hnb
451	B62qpQgkdbR33itJqeUBGdyYLyi67rRZBSWTuPrBbn7TQqSaBX1c7xL
452	B62qrKhDiFPNc1VgfVVvmxwTa6oDwv4DPXNwSxC1kvY7nqYDc1LcZXq
453	B62qkmLi1Th94fnNgqKYubXTtdbcXnNEEARgMcTNcyagCm9Dx7pUbHy
454	B62qoUAvnbwKgsf7SjX1dpog1v4BdzxDxgfaVnBPAg8cRyTRvPeB36b
455	B62qmVohHxFPyF6WF5tnc6uvSBvJ2fbn79N8kRzM7DwGwp4zNtuxRk9
456	B62qkc5MQcyVGnZReDtarjR6jYa1w21EET7UfSsztKimSnM8MYdttAq
457	B62qnXy1f75qq8c6HS2Am88Gk6UyvTHK3iSYh4Hb3nD6DS2eS6wZ4or
458	B62qmCvy7LUqfZ6uZYPn6MY6pofWJntJdjx85RQRmL73jaEKpqe1Jv4
459	B62qoCnVDwSnjaQvdnSom57iJxQSeTdQQVpqV2iYCTjPEpgXpKMLFSZ
460	B62qkkmP4vNLCsYej6oSFnDCfoFAL2mwB48t3feeAG56yBKYcUJEESK
461	B62qpALMdDZqjgQEPcZhD6nuCCETJdkdmMfic6wRxJqyMnfq93vVUY1
462	B62qocryrZvDmkE9pCGQU8A3mPi1p6ixU96fgpV7yJ88QoUJbxdfi4e
463	B62qjmEiV5kBvHy2iM5NeGdCArux1dS6G3fYjy1STK1FpnpVjFf4HwU
464	B62qmrqg9A81KNuUy56eKiCQErdX9eFHPysnjZ9aMvogY2DZmGrabP4
465	B62qrg8GsvUv2GTMwrUDrWpYSxPJYFUJKqJeZo2Wf7BCodcaqYr9LQa
466	B62qq1NRi2NFiMq5T7MgAJLRzwEHYewFn4zL7gDYQVLayyZmm2CWooN
467	B62qn7Rmq7wRpMifvvXqyrnhoaajP8gkKTKEH1ippaHCn2ayDpW778F
468	B62qoCaohL5p2QTfDvPKJrPXeyJbgyBWdQkQwbVfEWYQsWAb6GaoWiV
469	B62qnreXhVb5unrPNGi2dxuJfF2NJtmbgiWPXSVHUVvi59nnGCENAYf
470	B62qmWbgvGV1MwxS6rJEG3BSbT2T8b5DP2Theb2CaBduBXGJz6qfCqb
471	B62qrAz62mfgyBUWVYpZ4ufYFgvPRqLv3vCkwnxkarG2dfZ9GCUCHgV
472	B62qmiudinE4ZbpxowZkADpMDziXs3RTgxjmiByrFmXiXBbZpXsamjq
473	B62qmNFmA2jSxynSw2hrrMixh8GYKaSgw9owhXCWo9DgStnDzSXFZhh
474	B62qnEeb4KAp9WxdMxddHVtJ8gwfyJURG5BZZ6e4LsRjQKHNWqmgSWt
475	B62qp7QPNJJxYcrR7WPraAm1zoewxS9mpNNAnYYP5WZkEdrvyaLjod7
476	B62qrjuyRWQZr89rDA7KMCtfjAx1VttWcdkGtqdmAqcMoc9Lm1GULyN
477	B62qpwr7Mc3aKFFLTAvTscaFx4sddBWSDX5my6YEBbmdHgES755moTK
478	B62qq8dC5gi1n6kxEhGUZriFe6VMkQqCqtobSUCb1x9ziyMcB1wXuDu
479	B62qpg6J9RC357VQejtdTGFwXX1t4q8XhttKGk6jMKPm8LUotLjM9Yv
480	B62qjY5YR5P4DdCa5UzCb5MaWdye16ie4ZBudZs8bsx5PJiDzS1Efvo
481	B62qpSsTVvVXnt9f8tPor2fLNZD9bHtpUM4NBwdDVSPoC4HXPaHREyQ
482	B62qmCFFVD6ynjYwjxBCUyvXbio1afrhePpB3PkhbRfu7mQAtyogNoa
483	B62qrrA1PHiXL9VnrezybVjz9CXVkJS625w9ivCmMKzKvfqADVqseDQ
484	B62qjaE41RVyhm1mcLNUwdpBJPSSYAr6MvfnWKCrmEfPz5BPRDj4GSQ
485	B62qrhLkLMHiGtiRnQkr829WuNaZRtka2Q5CxwycN7h9LV4S21kcNKd
486	B62qqx1wg5QZRmCv32jmyjRdNj6yaHYmQL9Qqubkfs2Q5BxSW3zjZeX
487	B62qppuL9myXiUnueDK8E7LNRr7wPiFKSvzb6U8qdCkETuLwd6rAs6N
488	B62qnA5mNFbeETE6WW7tLsxmFYXkJjZ9hoN7Aa4EJBwK6qjsWawpLNw
489	B62qr5FbyEhbGEAZogiGB754Jdh6iGDPcs79p8hPRtNauCt7MynmrvQ
490	B62qpsYZiJXs1fdtFKao17PJWuKJGE27nLXfKqM5jh9oeMSMnUkTi4M
491	B62qj3ZYhcFKf6rTpYkziKvzMKuMnC9QHXE9n1jovoif9rTK5HNHogx
492	B62qoL1ikYHPbSv1Z2DacVb73cVLbhjYzfyGGx4ES3y9nWSCjaTYacs
493	B62qjWj5kLFgNTyThrCdgPrNZ4sLvmZsBYKCTmsoSGrgG4C2A72U4WX
494	B62qo8EBdkFSKqs15e6Vt3PwzeiM786PmPzgCeP5k9jWEqRMYtRxec7
495	B62qn9qnWVHV27xFnBqp5Mj5f3EctADmZXTxTnPXzkvYUyhg5FkjCVW
496	B62qrTTLH4VxCJy1nNYZMV9XhXAtopxnQ1KXZbrBWj8zLdzWSiad3gs
497	B62qnE1JLRhrYRoqvuwkCdNui1LpcRj5H29FptwbUQvau7xNMEAcaf5
498	B62qjYFuUkb1D8xgwdADbiZ6UUr6KA6x61BzzE1K9sgemawDbytmjTb
499	B62qqja2YnsyBoDvMrpkHFCwJpSjEn47biEhm4QKZEUVFBxQZYZmv6w
500	B62qqRtCkFNBtAzB9D82ay94iFxU1RCtTXYQ4miqH6xrTiwEJ25T8sR
501	B62qizFZP1uW4PEWii46T74kMEmd5J26fQgKs3V69CNjVeH4cWk168D
502	B62qpaKdUrK4mw9BFk6YrEtjkuZkg1yJ646XnD8iPsSkV3FFGBjNdvt
503	B62qoj4NpnbGSLV62tu2UbTRFV7Ec8kYcQW6H16BfNYhHstBMiahmbi
504	B62qrP5fybkeKbRpLRf2CFmnAjLEnZf36DT5CT6h8fMtxTJfYCzXqiW
505	B62qm6SbSHyyHBd864eWQQn3j9XPLUGQgM745oyaPBesvQbWAAWZShZ
506	B62qkfbG38SMsrVyMpFb5KkDiSLsgPiYsodKZ9UuAkmNfBe8Gus4Hsw
507	B62qjwMQC1yLPcv6Cyog1j4qFiynFXDgpvFX8fjYaFR3UJtD6cN8ErD
508	B62qkxwU5ePDE66ChRww27pGA5dmtXK7prFaebVc1bJc2ttnTw9Mi5k
509	B62qjLzQz4Sc8yu1Ykv31T63XDCAYLpzQg5tLeHrii9zQ3LcDgSW3fS
510	B62qkzeJK1ou1LtGxq94tY2fTy1E4uoovTzDpSAJzXZLfaDLjUrcC2x
511	B62qo8no6zXZa68SmhqtwtSoKtztQ35oT9S6maRPocuu6jkBr7JWMJg
512	B62qp4H3V37M38xgN2v1uTg55KPn5piTZbfRv4yugp859ognNRd5NxF
513	B62qnrx9HSU5Dwe9G8PopjFBdHf1c6rxG4niY8P4CHfnMo8bJPGo8jo
514	B62qkCj4Tg7CNecRfDryTUBmc6gwFQgvBD7Ea8bz6ELYTiTmuJEEf6D
515	B62qkZf4qaDNQSvA3qLDHhUEUyrPUyB7wB3uNafWc6a2CctakqxQRK8
516	B62qofSBi53zHx4dLsZxh6bcNu9MECsUBdZH96FrDb5kQWNac6nQ9Ys
517	B62qn3eMx3ZxS1FQ46wepgTpX7JG5ponY38f2wovU9xGqDzdnBD5kmN
518	B62qkAubK8h3D8zG3DC33n7W6u2pPot8HBHYA7oemdUGq7o4v3gE4DR
519	B62qriA1rqpkBS338FEgr3Gd8jL1tqxj6d1Vgtr5WH9n4YRBLrstE9D
520	B62qjQ5cHbShm31do3N9wmRu1AVDBV1AaAQnxM9VoKq5aV8EERtnYB8
521	B62qmEmc7wkUTTgcFEN4JUr9Up439hb7QZDPA7wBhHF83fAcCuYkoCJ
522	B62qpNawMqmLVq6Gc8FnqCYSkzqVquRigZUW9VNKPc8CEZxJeus9c96
523	B62qk87DbSD239zGYdh1sTTQunnfirm6H4TjDxUm3gA768H4XSLctAu
524	B62qmff5VshnR73TZ4V95zPUNZbNNnLqsG6o3SYLSAEuoX88TfYdtCs
525	B62qp4Gwy1ZxVA6EhqFPJ7oZphYKhuJYgVdYNkBUQEmwhY2J7d311Ys
526	B62qj74mCpk5sbvHWobuq3Q2ybZYvyNtfPcSiEMKds8HAbwtT3UhiG2
527	B62qrxQZJQq1kgcKC1QhhPYvfJD6rizW9vFc2yL45axKRDnavjpUY7q
528	B62qjohg1jbbiTpQNzAgi8NLDnS3L6H9Wsz6AEuWVdRCBDNKNKYXHmG
529	B62qjJAwwbXg6kXPYHzMTKBA2bG4RtiYggvYdCJVQTCB1ArMerwtzzh
530	B62qo3VjJHcjPh8TEzWXajHfC4pXCHisnHEaAajkHEeMTQ62XYY24KM
531	B62qoXNSt372178kswdiLjr5BQZ5eUTx7dzebbCqKzxVjLKEEEPkqxm
532	B62qq2PGvsoNC4u3uxthhs2ztXzuXRzqoWX9pWUDo5xdC3vdG7DQkjU
533	B62qisVmXEHZy9gjmCBrpLNTPp1Va1tYyFby1xV8hnNQvUZdZpq9Gmw
534	B62qiwepAfGCvyDBMx8acQ2wTwEDLN4ZkAK4VEwtuDqawKfvs2Y2Ej6
535	B62qod4Qzz1215F8LfFz2tmAkWtT1S1rmrfZs8283NYm9tYPuLhPP5d
536	B62qqNTecEPfa49JE3XLTVTvvzDfkqQWCLc8TVC26sGtmwQkPModRrn
537	B62qrfRjSn7Wz1JAyM66rd46Zcf37sWa9tobyXh9wfZubHEfozW3SAf
538	B62qph32vKvKjNDkpYdx1aUGDnM2ZT9qJ8d1vt19EwuL7yKyaLprXCG
539	B62qrGa2DAehUxo7Bhsk6hfoSLWL4kBbXtT3hST168hRyUkrEZwbCnf
540	B62qm8QwMLApni86t94X2WmHuxspzs3cbB9BaBb4dqrt2gzMEGXhjQe
541	B62qm49T1qENZyPSJPWPSc8wvpWMb5JjkChECazSdcxkE5zxXuv2Cd1
542	B62qnqEqsuH7kST9ZrbksRzihXD2tgHfvq9TF73XKAMj47gisT9xsJ5
543	B62qkaumutxogA7B781qgAYaQdXwr6SLp9dwmEfKj8KB3LsDtWhpXhm
544	B62qo463EfezM6wEYX9JVMT787XezVCszhTg5f2Pb6TbSds7jyPg5vd
545	B62qmMd8zb4Wu2MjQSCZvGB9VoiZNTXHqy7aQp58AhpiE6wTRRpAQ1H
546	B62qpu1rQdxNjwhXQtL2BA1JefpMHQqfmhmfh9MbTPVpijK3qYmGK99
547	B62qkYdFy8bJQYJ5JPhpFYuQGPwEzH6zKcpFyKTwQaTHPMk8Tmu7J67
548	B62qjPo8EuvgkS1HuDLgE7k9WWnABYZJXxTsMystpVktR8pDpSPDxoc
549	B62qoJgo3ZwNZJ1CJfQa3czHHnTESM1njEmcwuUzudMspfbY86TkV1f
550	B62qoJBsUJkxSHHhooLdgmNUZS9ihA3NXhN1KtXY43U2uX58MNqRK3u
551	B62qkjHJXHXpqrdVsoM8JPQ9CGjimZzZzx73Wth8MyNyqmdkEMdGAxo
552	B62qjtckRzJvbYjn59snWWakxvuBLTwvEs6YyNxUrFDm5NuTggpXaKX
553	B62qqy81eScdUWUvXiUU92d8ZpBdCKEo2oCEKDqs8yPwKzNUByf1Uo2
554	B62qn5eK8hgYRpkHAQcmfxbbvCsXk7tYAmGiqXBHK5dzRN9k7uL55Kv
555	B62qnGfRHkjXCF25AguH3EUJZzDNXv4xrFM9Z1Kd9a85FovbR25js1y
556	B62qqUbtYZCczK9pF3f3XtmAceSiD1tXwkjwQCT1o93X83tFU7rcrz2
557	B62qrYD5oqNfvrFP84wcgEx31bSDCib2yyx4S7oy1ZQfB7YuhpPeykL
558	B62qkrNfQtiW9XAo2yqscuJ9VVx9n9RquwLbka7KetHEwp7AifQLHqE
559	B62qr34Toyq8idNpPsPBR1dhgjUdTXKAvnCBnVt57eh6wDQ956aSPLh
560	B62qnXGNL44878HmkoTvkmjDHRxReHPFFjBcf4qjWDjUxjMoLmuJVWw
561	B62qr6nJMF7Abm9rsW2motSJqwmuu5ZeAHJcESgfnTXZZKJXzvMFM3p
562	B62qpdPvGHBe2ceij4GEZYAarqTdrWEi97trdZLRBoJHLxu1W2mqBG9
563	B62qrUXUnrc1tR1XN44eVaYVyw64MYD7p841LHsxzuMy6yERkbkzS87
564	B62qrAWZFqvgJbfU95t1owLAMKtsDTAGgSZzsBJYUzeQZ7dQNMmG5vw
565	B62qqom5m5YVX2dGpJV2pVPGQP7HKDCnXBRd47QKeTewcvgAFfjs7ay
566	B62qmTYWQUM5V1r9HT5wVPVYgWpotezECEgciGAXJFFGJKzNZpzH3Fz
567	B62qkUDWTWF6jZ8DxaZZ64JrFRbBgdNrRmfKricno68TmFjkxMGearM
568	B62qqSBUwbUxVdhKvVNtkWT1rkMFkjmd8cGaNGTrgN4mRgUqN73HjBr
569	B62qqnTQYi2ZdDaeePDxmrgcporgoFMcTMbxPmzpwQn31VSXMHawzyU
570	B62qkqNhtDFa5ZDYGrUqn9CEB6aGrgMyj1JLeEPX4tmM6cdWnrH6rRo
571	B62qisRXbV3EMYm4aVEtxevtG242pXpyzgHnxMhMKXdRZkJViRyQ2EE
572	B62qprCAep9orCrPMxQ7foJ6yP2bip14DbHNnzb2ia3aA2mQ7uVhrWp
573	B62qjzTb39cVFyaKmswTGBnGGKi8y8DFGP3KCoYVzq4nSFZPZdjoYqN
574	B62qmnWhJ5s19tza9eASRaFNasysrFKcmWPq9FJa5NYSe9V78FUuVSt
575	B62qmzcyCKrQ99WsXvG5MbvM71XveUkg7jVcoMVVwTbcQWmRx2iYvH9
576	B62qp4jr1PgwK42Ah4HG2qNHigTw5riKFr6RprguAX6ms8ArDcdGv7a
577	B62qnrW8QqY2K86HTyWXWyNzCUggHCbyqcU8DyUSYNoL7TirEFeBrFN
578	B62qjjXbygJnetM7hm8kC5T6rxTCZHzQL9SSxDaQopS6fVLwJUNYUan
579	B62qjvYEMFyGVaHCXbfRXpvr3gboQzQTZUpPQunEJRpgLd48pNX56QX
580	B62qncFkdax9ZsbePo2H6wNB61ZVrEQfiBszW2KGrnGP2QQHj3kJmAH
581	B62qokFNLPLZsP4dS1ama58fuCdqR5eVqSVYhAqixM9V1eS1nfeJmqQ
582	B62qpaiW37BtfN2LF9mnLwUucc6NSERb4g3LwAM19GS2Bg5eKWYRVpi
583	B62qn2cHKQ2B3yMFm3nPGZtjjybLyNV4M6cPJhU5qwJshboM3v1gGjL
584	B62qqn71PnUEPEd5dSVqLhF3ybFkrLs92Zp9vqNtzSChozgQy9LvUbr
585	B62qpfNHqWHttFwaQCoG56SFsTNUkiq8ZSCDh1dUHBjEQydvnGrps85
586	B62qqWpBYarX9Ly3YgQVr4FCmfNJQ5h58tB4tUeWk6ahzUb1JRQC45m
587	B62qjhfxnFVwmeeM2sQS6JFNKqQQjU6vh6aRx65rj2kLNYctTwGNZ6e
588	B62qm1aBGdqZBX978CTRL4nXsZBL53vEVN89nWXNqD3en3GTkBdrVt4
589	B62qnMBhchthufETXtKFcmruhGth4rKpishTyEthEWDstkKpYv3js1E
590	B62qjB47C7qpPBEa9og3QcPj7a89ossecNMkKkyWJSYNLBxEjAcjT5t
591	B62qmN3QcipBRd1izGrZqRHrdCnrXLLGW5RRoNNG2kCFAf2zr9UvDUm
592	B62qjcaDeZdy1SdJ8DM5EazXY7LgFYumPE1yWwwCTr18qhYJmJ7tVcw
593	B62qpGyTotKHjKuT9GNb9SG2gH44RwkdpzfFSpvrTLTNx77onpvwfpE
594	B62qjET9m1YnNPcgdFZCBiacwGAo3nXZY7GdLdvVsa6cNCPPk5FTc9d
595	B62qr8FNc8n4xa9tJwy8jmmahpzzmNxG5HoEt7RnJNw12RGTVVbQpBn
596	B62qqgGAQfpFhX8G1iF253C37CMsj6ypn77C9fr3Y17iU6B5Ft4XjPo
597	B62qqkkHiZBewA4R417fKmS3RjehKszHLWQeMbB82FC1mzaQC8Ug8eN
598	B62qpuwoWLnPxHTvziz5BXWFN1YHEMMsgvzxs61Cfvp86Ug1Tyg8cYk
599	B62qjREKDBtm5KBteU8RibX6P6JLnoQifWYL3KGvaRLJjUTb2WM9hjf
600	B62qieizHWA2zusWh8y9eCzqA6dvgGNSs5RJGHPmAGcBtdgr8BRSfEg
601	B62qnYnbEvsgp6XxhniNMSJWA43S1KhWFTa5yj8eNxesUT4oy1SC7r3
602	B62qruUAtiAwgCWccA8ar6GRpn42XcveALEFLqFtZmhMcv7qMgypXZJ
603	B62qiU5Mc96FNQJQwv8JrE9LB8RkvummZ5MKnWTPCiY2E6KHnVppujV
604	B62qovmdQfDRrVH8M9VcjZtzDBQZLMs4hGUHa2mTD9AqUBrVdhbdXxC
605	B62qqUbgYoUXC8kBedrGQCkJVyVc4dcS83wnvnwfy7hrcKhp6tTuij7
606	B62qqpujuZ5W9uGtEwJv9R9yP8475hjFd93D4fVXoVPi9tmAMsQZBhn
607	B62qqSvXBa1cdTsARTVZrnJreCDdEy162q7axsf3QfjWzZCKfrU6JoM
608	B62qofuCX3tvb3h4TCQtRpVkm48QagKxPduDqGeTerYrfnrqPVHJnvH
609	B62qjbquAf4aYaSDycp5LRghKFgcHN9iqEVF58HDToC3khxeWH4Sf78
610	B62qjVmBp2KcF8ZNwXWrmhLuUPmogYuQBtfHEhdoaPZee5BUTJEWkku
611	B62qmQ7bj2w7PsKUkhicKKYCP3FpaGRExYVZm1EPLrniABscEELzgSz
612	B62qnWVQwpWWygmtRhdKwXqLoKrK3NgrWH3tA4E2EqUxw78ftmeG54s
613	B62qoWWs3NfAPtVKRnZF96gEF3MWbptg9bzC254AQNswpk9WwTFkjS4
614	B62qjsX96RP1X57eLLFWtZ7KwLonopTQ7ha99Hbt4wkyreFHkh7niCk
615	B62qmLxegnngeCpHk3DhZ3o2NKBT6v3oFSYM5S7ZnVHgTx6RMcEBJyX
616	B62qpYeiM61GB1NSuPxLyiqnXQSJCN6tLzkKuD3sr6Vs9qauV67zNiS
617	B62qmMmwbzrAD7EUmGSHJmwxhRBXkDxqRbudLf2p1ediX1N5zcifWpY
618	B62qoa1oVv1uEUUPyPHDc4NHxSb3Lw3XEV7GPcwwuYd3vVSmVV9Jo9P
619	B62qou8psL2pgHjKtNaXneRq8FJWjjvbxHKZVhR5oQiu9ea5MPpa9QW
620	B62qrCS5D3bvY9rJ7QLfkkiFF1Gq3S87q7qa72d6VbCwC1UjwxykHTF
621	B62qji8m9VLx6nomDdE8aiMokRfe7U4CM2wnbsVQjnuVKzjE4rscboL
622	B62qnUwVMUnPEjqLyuzoTgyUF7pXZaYYahrkchgB5mdY2mc6sbq3aP4
623	B62qmHTypp7EXGMJnZXYRpHEmRGyZCTpDgjSmkpmQa66GQqR6eaGode
624	B62qmkCaak2xES3VorJkREWQEGiLVSJJxZp5sCVcRXpvPBzudwcyjRh
625	B62qnhc3Ms4pDmgU4jR1GriwCdWvTeiKcWo1ghvAinQn1kmjqMXFpgn
626	B62qiiCieHKamGw4VWafNQuS9Dk5vRpVV4hfTSa7b5QY8DAHd8DsTse
627	B62qjCk68N2Bru3X2qKnGbzSXeAcaBRKHMQ8AFtjzsV51U2ZeBgsMbV
628	B62qjhoGN4uGjHGV2nuLys5BegEU9ogzk5M93SixvEe9YWju4r93v5x
629	B62qqUCg4rwxdbgHPsZ7Y4CViYsFPXqdNheEv3PG1AYuCtDmp35gviB
630	B62qk6cpqWZJ8tAk8pWJXovNNKaxsnv3vCiTtHSr7SCTfHvYtesLWyU
631	B62qjmReWEeTVAM9btVNBvzs4XPod6SkCAw73t1pJnLddrUg1cP6FaP
632	B62qp6qMf3Do4q4aKqEsLxVpVuXJaRCijtyhsjZBvDSEFUBGXg8Z9cs
633	B62qkbNu6GyDJ7uxXkfYQiVZHfomjtqN71sRcmt16Dg5VdjWBcuvJRK
634	B62qpMndmJbN4GDzfcCs4Y1Qk7Ss5ggB3t5JujqR2aco19erjZuwTSS
635	B62qnYNUymzFsd2Qn2ofpGkK67N6MHySGyVNK6c96nVAtqHptrt9Xin
636	B62qmW3eMFnZkFPEkqz35KvuRfEJdx4U5PydcUmbs2P3ioV8c3qZCuR
637	B62qqqEiUWc6RsMyJAyjzao4Ba58nN7mb2ETjNNWpWCQtEzsd7sJwoy
638	B62qnzzyo6V8Tp2uxgGYJ5DGZ6oKV8JWV4NgkMJrqqCRwqEu5dfPaLu
639	B62qn1QgqkzTVXYqE1XVy24znjMuNgixJyBWQiFzEjPpRYHaJMsQK7b
640	B62qqF2kUvSDw9r4XdukwST3qtqXE1S5oVfMidV4JBr3BFHpGQ3Pd4d
641	B62qjw2PdqLJYNTr6cNDXEmnc9FLNoaqVMHMqiTX7sqLYJRpd3mshFA
642	B62qjS3YrJ3X55jxEqVjC5CbKRp3XF7SpzNvW3VENGMFcXzdEgSDx5P
643	B62qqJ9zVibqkZob87KoGUuXtHjbJav87soLvUWmDbGpRsfYdToqYgP
644	B62qmG9FPKEZJbm6vE7nMNj8pvTzN8Rra1L9rRNhnwV3VJceHzg4SVA
645	B62qjVQXeEbmiToTf1ipPd3c5BDgHuqjzb8GCxdgFuaDV5EGg1yMBZm
646	B62qr2mdhKQAJb3nSwHJsvubaexz6S41PHTtuDbvqCgp7d6Wx9C4A5z
647	B62qptcZgqZFFwkkmbhvjFiwac6xj8ysCbzWkVTYzT6NckRKTpi7KH8
648	B62qoiUvWG5EpEPHTqP1qdxmyteyu3r7ogbjDyAjntWofNGVqfFzznU
649	B62qpqKh6G14cd8HdnXw8xk5kZhRLywjJkPChRBXh16J69dtkWhtw1K
650	B62qoADxfYFK8WytE3RK5vH7uYYpsJ6Dz63wxB9XFJjJkzRBctb4UzD
651	B62qrnPdz8HpsDJfGHirDLpVrN2VeyeitdaTKBaccWtHpeVW9Hgwi75
652	B62qjwTD8QKpffkzNEvtJVqRfK9gT1APcvAu6PkV2nD4PLTbvzx9KTM
653	B62qjJ8mNz65hUKWTh5wYbaHDa9nqfhz21JbY4ts69xBNYhTQxbQzCJ
654	B62qkwXAkimjPGatos62oGuy8hL6SgPN6uwnts6NHMjJt8xREdFTgEh
655	B62qpE5W2YYB7M8F7SPUPG9BZiKMoYXpv1zNFbgUCvGFWXTAuxdFwUs
656	B62qrRKJoUsaKzv82QgkkrVcq1iPCprxMACryScmgFkL4vQLeseoLQv
657	B62qkTNiWzgNBrnmFXVobwrQqASFfWkVxMGzWH8NL1fDc6Ckwvf2oG3
658	B62qkaLCKizSR2XFYFK22jVPuxSjJKXPhm8b9QxsGmW5K15eYFq7ZNH
659	B62qqqhi6Sy7StZaT7FGFn4DQaRANEkiQfRSdnisCoX5n46HD9D9tZK
660	B62qoKgbZLxduRtXiWrfM4zhmkicPQwsNtd4eqcizd7WPwD18aDH5hj
661	B62qneDu6K65UhAuf7YCXADJWtgJh1y9xk4nEtGKggLaTr2M3Fbj3iR
662	B62qiZwdQ8Wdk8PuGtdCNzWrK49zmxLFWmogt2xXNS3y9eKS7o5qwxr
663	B62qrGdW3pGKhs8BRGrjom3WzTFShfAobatkyKwqw7Yrn6NEYDDpH9C
664	B62qmGqivW5t7jsKRooqzAroKYSA8vxmsreEeMgxMWzzjdjUtWY1LYx
665	B62qrotmFVdZMGL1pbSX7PZUWKJirNg33bFURd95e3rpxMZkg8f2T7h
666	B62qjygKzKjrqscEqYNygB5HpDpVHBGP4QQ5uYar68riyYiJfg9FvyG
667	B62qqJwQJuDAUEcB6gjj7cDDhG12G1xwQcNeM8fi4wFG3GgSrz2WyL7
668	B62qqg8tqdhUx9K9borozHQanZpRs7zGPsRZYt3tXVMuuMYjUtaCvU1
669	B62qqrzb7RF35uzzoxN1aGLVmaHpF8MfoD8wrB1y1R8ve2DXZtVHhAz
670	B62qqGW3z7MPqw4jDQrYhUHtq8JrhFWDghAyERWteu5CJWzHkTkrQ7k
671	B62qoLPVcqSf2pKoc9cZnXF4mcLh9Zjtk7rcayvwsgWuJTGxiSWtrhy
672	B62qmGV3ExCGJhDJRH8eq55VsSAJoQPBnMt5rmG1SUa7voPLeoLbBJy
673	B62qrQVEMzZSpnfZsDoTXtFNPcbrAogL22TS7pLam6Ex9sDNAG6pCYj
674	B62qmdut1usji2NFZSn9BrywhjHakYtAvL7Mdy7muyjcbrY3hKJ688Y
675	B62qiZktgNut9AdNXZLcLQSFioiaWH4grePCtfsPnmkcxfg5q2MjZK4
676	B62qpBGfLWyBN24kRB81tZHQ1n8PLgdvABemUDGJU2Axp6WMY2zBYUQ
677	B62qr6SB6kaJAmAiRrWkFoHN9htKh2j7H7UZ3uyTGxtkMXqNqhTEZX1
678	B62qooHQvsHsqfudGFU6wcK2YfCz7EuUd8cUT9qxfkEbt5uvTA4481Z
679	B62qkHSAjmBUWhjqZ84GNX5rnWFyVfdtBtfeeKm2D6ANtdUvfFNWQac
680	B62qqBjKoZYj1A7AAigACJZjwr7Fx2wYLGwc4z7a2WpHhsxfLu15mzH
681	B62qkkAEbwCPAAPMZz7qKP33yZpUUr54QbKs1HLVRkykoUj7SqLdfuY
682	B62qnPR78Ki1fNeANn6BBhEJByghyYUMBDiQbWVmrUMMLezPo3VjUMV
683	B62qqQ7Ucs5uquPTFgveJcN1fnHCRehxnWuVGhV5GjNzQPdWsWuH7Nh
684	B62qs12XTUTSiWuhyF1R3MfXB3p4QaGxv6JFZYoMUuG4DGCEhzn39LL
685	B62qmcuVwrf9CVBf9AfEatVG7PHr4YRYV7LvQt1GDu1ZAf5wUxvG6aB
686	B62qnpPdwJVRbyvvLkPAWYGUbkA7NUZTVdiqa1B5oEd8ABSf6YDhVXa
687	B62qqneFCrrHKdvQg6tdKGjgpJa28Lk3basrGPkyZfBJtjgocd2eabi
688	B62qogWqDwAcZVwXteX11RTtBqL9viVed1Uot55QGeoMx5dUnCVcrZF
689	B62qmf4xKkMvEA2jqAEGe2QSs34KZzSdNHXuRmduMNy8ix1MWYWacme
690	B62qqkhvx6FtK5D5Z7K1x7ebVjoxd28NtSCRacYTqueWCWQERqtEDPb
691	B62qknwJHQU7EwT9NcvUbqwq95oHx8fFMQiGpEeiq2hKkfKWor3zdnQ
692	B62qpXgAyh96eymS5ysvnCMyuQYT4WcGq66NsWgPciwE7GgUYyCibfG
693	B62qnnJz9t5v9qwLnnYg9js11RiHBTZWxg1KkJhmnAJ1iBoU5MDkDNb
694	B62qpaDKrgPfyxZtxMXZF9CpsYcVxCFMofG6dWm5cQtwTL5LzpxtHHy
695	B62qjRjKBtAr38kh8rVFytHcWY2dRRyF23ego9UjKeqkQLX76sB4FAQ
696	B62qp69bsgUNySCY2wEYDCrRN3gdMB6cDSZGBucTzc9vUUH4jUoDSED
697	B62qrJ6V72vUoqTnJUsXwBFbCU2cCk42To4mmRRY19NiGMZqJuYLLJP
698	B62qpczQrxYHA57A2eSmeSPZf12k5uFZhzrkNZgViDwjfnVRDkdnpC6
699	B62qqAq8DqCN342Em3FfZXZV5g2dK3tgtgpt75HvAyc9sRHn3q6wM82
700	B62qjUaGVZqZ8iri5r6rSQya6a1jWqyYAQt7JSicLf1sQs9BRCKdskT
701	B62qmT1gn5equzmv5LtUSR7uW1ST1d2mCvpgeWcN5DKGAJedWFVCSN5
702	B62qnr6wsfZxsxFk9xEZvsgKTLTmFmd9czVieRpEv4YnQmHUaVMMDTa
703	B62qpJPsP9ef7vbgtwcRveQJgAsWKZduzL6BAj3k39qSpfFr2dxB2io
704	B62qopxMBgKZehZ28XCa67puBLdaFJcetetQ5Eqzsov63t9G4frjJQe
705	B62qmiHLHuXxGC5fcy1QqM185VeW8CN3MZm72d2PraRNFxAzzcQ3K8c
706	B62qmfjBQ8xtj4MfcQA5kd65VAp7usta45qmowjMeNuZhvizAxYnoPD
707	B62qoyHpeJHELgZGhECbCQ6tn5gHK5MJY8RYUi4UYaf1B5oTTwjMjb1
708	B62qitBtpsUFVthx4w8pWXTMX33iYm6hRKEjsN43QeRuieUfwk52SbD
709	B62qo758VUF9BH7kdmzxvchdQg1e4DfJNaDaLubdMYTwjtKU48NrTsU
710	B62qrAjwKEug5bXehb1WoxPrDf7heb2VSy8yEmKHVp1dAfseYHhBmfk
711	B62qrSiA6i3HQRDS2boxepfMaXQeof88YLTJBEr3qjCNZerNfrZkEYs
712	B62qrHQbB4jYT1oCtbX3V37GvMSwPSw6oYmYFPYnjYNLdc7rpSdkERD
713	B62qreGujxwhvS7FM3yLHfHVUnkrj5KSWyQPkAz2B5sYkFBacvboE4R
714	B62qqP9XWKj3xMTxXrjpUR25d8k5ocEh8fiGxp8C3EszYHLuXMUPCgc
715	B62qjajZHX3V9boBnG4gNupuR6EYbT9racDtJC1GHY6bThdyHe6GGU8
716	B62qmpK6T59DvNivKs3zDXNcR7FRMQJxJVW7h9QimNjd3yegAPxjknN
717	B62qj5xvECtvu1eWdLWWHkUUULbkazUL2kRJZm1hkgwv7N8KJeE3GsU
718	B62qr7KAAzUrv7hkKDgnSzz1xDi6BuetvDrckQxtz7GNh9PrENkiH1c
719	B62qkoKSrcJms7W8HNvFteypzAYLdGMoe52mGjzx1pvNRLQLX6ZCqRh
720	B62qp48Cwkd7MpGfQBbYkUqpeeRhT5dDfW7MUBYH3zgSuwWQPpBMbSP
721	B62qoSKy5LTX48VRcvVuCfWLMeuHNqsqPZXXeYwHVkxshneaeW1rKPh
722	B62qrBcgyttwueJWQDiYA6r8PQ3X3Jh3Fkn6Y3k6XTDehoR9L5kQ4zG
723	B62qooudywX15CbVbZ1KA2ZVMJ8aWqCvYKgYnE36u8qDqZsXkS8psyk
724	B62qqDvzvGP798vcVLeGczsY3sKypYTfhk5zKk2sNyCPx9kWBkh9Emx
725	B62qj2hYKc8e6ehN7V2x4TPR1M8NjKaJZRR68fHLRh7D3BRNJSXnNKn
726	B62qoYG6v71VxyYiGERuReb4V6etLF3vdzryEXQUHWiCSz8bsaA2qZA
727	B62qpSnqVrNamS2jT9UJRxUTWajt1uzamEb9Rp6AztWiXnMEeooP5h4
728	B62qp8dFx9w5si4QzcPdMmSqFd55MPgNJiAsxtsYCzRYLGvV4XDHXXu
729	B62qmDfmcUqZTwxsomFzMBfqFisLS63VSsfyH8v2ezwh44sZH3KkEHA
730	B62qktozdEL1KySmBrr5kTZVyjcpoi74mzK3tshi2qXptqeuX56DY4m
731	B62qn519rweP51hpDGQYqCZ8JRPkpxHd2JzDoBFQcupGppuwkpGBHp9
732	B62qmEorLV4gifAPeg4GoN8PpTWEr7ytx8Xejazc1skGepEALxEbENH
733	B62qnTdTtkepo2yfBXCeMp9afk77oo3EKWDNWuvLzEHSZz2gkgr5JHj
734	B62qiuqZjBn29vKLHgDffoyYCzvn3iqciQd1LqtMKKii6VJgZfM4cTm
735	B62qnjzqEn9dxzz2e6PtoRKipZWKToySCQbKaMTjuyuTdxdmMCHGjLD
736	B62qkkNzkCjbwhhEtu1HJ7SuEezuEzpkdUCfBrvo4vtCVutiTtECS1w
737	B62qrUS2A6sjnk95D83g1sjAryRBDwjBWhBdzPKZJbgoeMaY1YrHnzQ
738	B62qm5HhL5ESWzGMBRdzjVkRGD5ZzAf8YYErcXYyDbSy7o9EXUXMqnk
739	B62qkwrHj3YCKgQsXRktpwhVFij19RiwYDgMmiwp7iggNBi8712a4W4
740	B62qk2bwhv6KNHyaUjC4ab8XPhAvDDUByaR4dGXqvR8d7duavJVNq8e
741	B62qkx6oy3qGwxaYYTeh3WeUZemaLo1Kqyui9io6Y5wxeJPEWHEVey6
742	B62qobHLtqcoUqhpmpjsJQNXhfUTbKyV4Ug5qJWV8mTqtbZbJAmn1P6
743	B62qmtWtBjJjBoTrCGdTop1uZqmf7b3nnY1RX48hXUy9XkNNxj6o5fH
744	B62qmAuxm3DoE2Mp5doamtmKwmD6TGmeA3SPuh57bvH6LUcZspbaF7b
745	B62qo1EYgARevAzQyNDxhNmKwZAdHg4j65Sr4JnJwtoLGXt6ustog1n
746	B62qoeJgVm3MzkQD8GiHNSFmEcGYRT5WaAQZ16DFYjcE2R38nCsXc6A
747	B62qj4odmzXgncnBCmBQ5CGoaD7y6rPTQC3qNezGrw31sdDqxbTzRab
748	B62qm8BBqTFCc1KKiDU6wuqjZf6n65dasH8jAHSrLZiNyzhQJLZUizQ
749	B62qjHdRfaxSdUkta6Qqa6oiXQ8WnRGkMa3rDuX1e9zZTUHwooQ9wHy
750	B62qjShUd15Mezic2rixrzAfJ9HRDQKbWqSoocLMUqoLrGVv7avL8uq
751	B62qmhF6ip7xWbEoUSUUtuvZno6itX4bTfCPoAfkmjAbv14XJfsUMgZ
752	B62qq5W8QExpM1qgMitciWQghnEQc5Gy6y2v9rEKEbxfBSw3Hh5NgHW
753	B62qjD5F3fYFhRUbdfrvUzuEhouPX8zgxDmRKL39oEWppJMRuhM5uGn
754	B62qkY65gWYLm68fqW4nKj8URcr5BTb8BN5UHo65Dkh35tDMrgPeyeH
755	B62qqdTvDUeXvUSAUiNQ12BthhmgLDpXUrmxzYdbHxLz3dUNM4vEt4Y
756	B62qpeTWsqipUEyG6nQb54SfbDrCrzK5zBwFoVqggexDNrUnV1aXAdo
757	B62qorPGKrHgPAkt2FM16N8JttM8CrYVwL15tBy5oigLESPFYC1SyXh
758	B62qqhmvrqpBEJ55rR6v42AFnh59KktBsXBqs4i2fBVTb7uBqBsUNSy
759	B62qrLdrRjY339ix4YneW5hQwXcaPFYbL4y35VEJUKoUugrv6x1DAFk
760	B62qo2eh5weVKJH7AtwBJewA9rKKwPYeScV9y5QgJWPJqMaYuc6kQ7T
761	B62qpV2bk8Pge5E9D2JrMwg3ZTjZ7G7YKH3k5Bmo1D33yhiYgu92Cn3
762	B62qkL5VU2iDpUgr4rqkGiu1PaYspDnE266618gUVmpVnARaXbd7iiB
763	B62qpW3zh1yMd6n7bkXuT4SrWjEp9bZeDTkY449DMBYBSjEX8wJTy15
764	B62qmfZo5Hbs4iJ2edczgFJsbSnTunDPPaXjR1AtJVX1e9DHuezeKXg
765	B62qqsDZB9aHvRqLGzsvMzC1ZHewLEkActsP3VFRBBdGabAdSrgMrnD
766	B62qnMXrsM3J1pjdiDuwcem1dZeRtn3aDDyr19fTEcAbyaxwyZSWEuN
767	B62qn4BzvXMoAxWPpRf59yjgowibyXBhcUzGZJmCJ7RRUaDwDdxpq7G
768	B62qmQ4WrMAxMV1tBjANXZiH1FbCwhhsR2p3uXWcVbRQaj4bPTH7fGj
769	B62qqoDxUHd2E3g5Ngm3HphxN474YzRwdSVyYoNnUo4um5qGxLxtZ9K
770	B62qmVHYfw8BGCpw6ngZcM4tBo9GFeyRw952N2WB1LNaGZEtGAtFBFS
771	B62qqCFf6pUfES9zA3h3t7qTezP3RJvYkb1Y4szDNkQj9LuYayXtkVU
772	B62qmT4DxZoFZqJgfKYpZaHyV8KBfkmYCuGTKBfioKd9Lddd7HgeARV
773	B62qjVUmgXQikmcey3JHSF6fVqX7MoQGnDfaNu2AQpka8YiKfTmggZe
774	B62qqDR4cmdfXz56KDVG86TDvaa2To1gDxh4XPXEcPE5SEZJTawznVA
775	B62qo76fFxJPC7zGT7NwpZKDVuKHnLYURfnvHVXzWU5zgHRCagRyZfQ
776	B62qr2ingZ5sWoyEPFazcQkYYWx99mLqs84pPYSdpWkRCKsg9Gz4kTz
777	B62qjrj3SdfDoWxS6WvKn2Tvr7mdA3EtbsHioUuXGL73ckHu7iDcfJb
778	B62qq7uLzNiVPAsnAzKjkWQ9dviqCH1FbNZcSz2Gi5gnjoVoVApgMdC
779	B62qjb4fDewKhourt5S272F1WKzrvFVBvCz6dthVErR3bVHpfNL3Q9r
780	B62qj4UFkH3x6rKf8KVcbuPjGQhxDrwcaqUYiMNJk7Ct9DB49X6pMBP
781	B62qrBYNNHZSLNZwaY4FZVNkesEPkFbZfq3YUTa4ZyqRkz1aN86BUFN
782	B62qjuZfx77kQYKa8WxE11MdN8kT62gJcoZov68wTwTn4rizgCLqtwD
783	B62qnnpwVapFcMQmADmxEEP7FLCQJFVsWFoszPa9j8XMANR3bdBpDyg
784	B62qk3gczz73qX3JJuKhovf6kV2F4jucX58P3Jgiz2wLB4THjgGMfAg
785	B62qoj6Fa45LsKrCiGRTFCuUued9GNsRc5yhy99Du1i2ujk58qUL5Gu
786	B62qkHLU1L6hu4kFvewrczukTf5xLuT9nEushCbJUdjiaUUwr8PKE8X
787	B62qpb5mxHwJGQZt9KvY9m8NB9Ys1noCZU9zVjYmfdEezE6dVbBdnjd
788	B62qjy97FSjL6v6WwLBgvkMqwq6GriQqwdcsw9TWGUt2heoxLYn2fc6
789	B62qiodFFAVHuB6jsP6SWJFFqAMK5V56qXtX8FBdgszAzPTspasiVcT
790	B62qne6iiLkr6kCJxrmPkM9FL3BoWzo4Q4ojmPAQTCPfzKCkQ5w6iP6
791	B62qnT12nXfoEiupbqQY3jRgjm5c5ss1QLLwxhHUy82tTVjofqUNDN5
792	B62qpzWsX5GPqtKwr4FUGprtcQhsSnZDTQvBswhCfK8A1YQkFB8dFwg
793	B62qmmVpWiTAeCU2LNHotLGjRehfujKfgSDxjgb5xfdpGzcNUcdYry7
794	B62qjhFp97dHayikjR9DiBKcoXorthYwU55v3BpSB7SLTGd4wrVfx2m
795	B62qkN4gn3hMKL8f7kY2kvL1DkzpTBV9kaFkkpiZD3rdMYER3LhiWVR
796	B62qoYDE2yrQoVJ2kf2N9Nx2D21Q74APsKd6DbAQKekCFEUq73ioHw2
797	B62qnrkfmfeoB1wXjfcTFmF4gkvi9BJRnzcQnsniMc93RVAAiU1HfAD
798	B62qqWTHw1LzB52Z52Xu9TZmLgctX2jWWuvKsSuaPhjmgAmDsjNpGdh
799	B62qphYQ4tY5F8WVnfzXW4wQmE3o2ucRBBtSDW1mp5AZkdUceo49zkt
800	B62qobj3DXHb3w2D9eZAMj8b2axbeRbJn2Xnrddv7AbSky4DJXDVewD
801	B62qnoWdBv77cHsd5ZAuNyAXc7yh8sXQtHynacN5NZNw2zhq3afBQbH
802	B62qnQEfUUDVxUEwPRM99J13n8TNAszcMHpxgSNm9zjfHJgWjgyZ4gb
803	B62qmxTSCY41R7mQT7H9s8SJZpvLrFHLDpAoSwuP8ghWsH1Kg4U98Ej
804	B62qnYZP1LaZ2pXHCRgbU6vUjMH1s2b8pjNfrof11o7xBLL5M2xHnZT
805	B62qrq96Nr4fsJHKr8Xp3jo64JfqrDgD57YmrsPzCb6WWx2K4KjGgRn
806	B62qiUsYoPyakMZx3yPJisMgz1DpbsW34u7XbYrhw2dQ64rjp3CH5hH
807	B62qiodvWNzk3h4hbXkPgWTkJ4KBqFo4VBBKh6fNjk6eeHWsSURBSvu
808	B62qmPQpB7QLG1ozmbPkHY9AfD64Bg1JEes4T7i8WXtXnAVnKgrJNBZ
809	B62qnxnXm4rHZNd3SaPW7AN2m6JWpDqW7pxh7BorXsuq3UL3GFbNesE
810	B62qimDqNEaG5VGaekbm2sa38ig6C3XdRmYAnJMeCPaopuv6WuVPBkG
811	B62qnMo1XRuLgEdTkBmVwP8xG8DuyUDud3RyPeoBoFEgopEHQ5tKrk8
812	B62qrL6wp7iLQ4UzneLFdGas3pNoSXksNJHDUEanWCxfBD2fi6xXWez
813	B62qpgbBf2GU6cz2uzgBzYxt3AjRYTrLDmsu4MyN46i66whUv49LfCD
814	B62qrZCAKA2YwZ3Na6Cv9VdjF92y2G4oCud1JQtWwDoyvfkjZ6PCtTV
815	B62qoY2cuwsNXaBE3yUwSqwEaovhwRqmGWjBhNL2AH5vCeeRgVsaxCG
816	B62qnDczgqibMNMnATpdsv6wXWtF63AdNz2bMncXwxo7i4QcMMhwwL5
817	B62qoUVGV5aZZsyaKyzA6wRejAJbXaRHCxLzPK5B6s8M9Yp9VAB2p24
818	B62qmk8Mi1gykq1A6EXDKWJCe9Q6AGexJhkVq9f5k1yDLxC5Tsb9B8z
819	B62qiimDyKH2c9aMwzb8pnepGj2ySQMGLctdVtLVLd3KC9z4DU8a14T
820	B62qoVwywhEnMWAKegSqMgP8pmdPeF35UARyuSnq1M6CadpcTAs3dbb
821	B62qjFfENgQq2nRqBy5Maok6DAL4J499x3FUn2uJAVn1ngy2pCAj5sz
822	B62qjfxJWzG3iQtzBX3SGYA4YKPKduJdFDwcJFHCQL4JmWsBNbXeELc
823	B62qpmwejvd6PkaFsUmvGN4KwL6vGKMdFHLqNc8ftQTdfnuKD7QqM27
824	B62qjpLh6MJqKkrJxtfVuqcZ6nkPG7oKRaqLcuwLEf9k2SSgtHgcYh2
825	B62qkXRYVPK4uCnLrx6dgo6jSpGTf5F2z1VrXqDvSK1kksEkkZCrFRc
826	B62qnaF9jEEe8pxpwkaU8ij7SjXbm89PQJxKd4zFu8WEutrihCtbU56
827	B62qkehW659cVAECgC4xFWkbAvoApuGfKddua9ZVrNPs727WmG1wLah
828	B62qpw1rpGnDK5N56eG2uxxdM64dqqoWrq7rCgn4JXPNi2k1P5YycAt
829	B62qks1zLMdgBEaVegEfejneFv7apcQ8iVPvQamtVS97ChZaaWzAiKa
830	B62qp5DTw3dw8ipgSCCDBGextDBAo6FBDSWVwMo1xLRJrH9L6UMt9d3
831	B62qneKBE4uvxZ9LN1Av8Mn674J4yemHcob6pPHLCoHwUvrTKGt47Zv
832	B62qjeTDYdaohKH2Ztb8Wiw59HSiTxzMiiseF347BroJaMnUAfpgVUd
833	B62qjeV5Kj59aJM4qCQ8ZoUmoMH5ANqtgdmZXY6FhXdNwUn3y4NnvNC
834	B62qmYYSw1qctf682uNtc5M58Kc8RoXk7V8P6h938gi7k5pbWPmeVtD
835	B62qrzeAiJZQ4DnFaiDypcprKpXgV4vac8PrmP4rotUHRz5U4JbTy1E
836	B62qkKUkxK1Rayys8oTGC4agJKnpZygNK3WKauCJcyzRThdZqEfcrwi
837	B62qrA9qWwACb4LRFEBQsjXnBZPw11D465L4AByNoDunzhCDntgJ9Lr
838	B62qii9M7moTAxxcG26MfdCuhWajNiKFLf3t5cqvy6eWuEAX8HexWiD
839	B62qj4gpC5Pbh6nUDBg7Xi7DbfDBLd4wQaHT1dodjdEK4pLBi498FZ6
840	B62qp3M2wZGawSgdqY4ysiRDnSEVqfrHVZcBucPMaS7EHEPoVeEBXYF
841	B62qqKV2KTVR8Sic9Yq9P7Z1sb819smRBaCqWi7UuzHgiagLrSRmi6P
842	B62qkUgRDxfBF9hMhPk92haUbMkUuiW1mVC9VbTEF9mJupp6uyQ9RDK
843	B62qkpKnTJ1uAR6ZQ7Z7DW9UwjDuzSZJkTPDDKUGHgBdi5bQAUJ1gG2
844	B62qjQ8dr7xNdox4e5xTGK3rVeSSBDSUfwQYCihRePqfRXfUfDurckV
845	B62qqrJBL4dJcHBRCxXRkCbYfBXqhRHRPS6dnPtbumAeKhMmWzQ3c4b
846	B62qjprTZdUaTRW9g2RMLs5LQ37BiHmb6hoh9kFAwq4jp9mrg4fLJvK
847	B62qrN3hZPxTuAhZzuB534ejuF48KtmfXWFqMLa31NTVcuAcui6oTDw
848	B62qjeR4SzLtURfPd9XoYQ6p389iWCZxwBqMasyLgwRJB2oWwWtnski
849	B62qrYufgatwTD8UkM1tLnW5tfnSeWYSPtbBYyYvdQ4dvoA9KBeWfcH
850	B62qmzFTUsRqK6UAQuu1aWdkyhaM29WrCdGoo3wUm8W1A1ahCU5iBsY
851	B62qq4qohsvmTAJmvJ5wSepyNHKsh1wMPf1UjoHLKEuLmgH2RdAa4zt
852	B62qpSarkCiM2BtkyxEYgHXVPVtdghrDRoTKjXVEdVMrHmpe4Yqc3xS
853	B62qoA478cjzLTGH3JqDrNXGjQNGQJeKesjnS6o9aVv875epCMtrrsD
854	B62qj2JEHwhtaq45YYudYUEkcF34xdukLYaHreXginU3ddL9haLC15A
855	B62qpk2BRXnuxofXRU1z2y1LWRagabiSLoBuCJjDSv9ebVkzZE2zXnp
856	B62qqyxmcGrRFNDhE2rAQFeYjse5SNJBvxjkJDqu7gZby56w8gyioB7
857	B62qqhTWoZineudzfT9o4YTdruHTps1yANJz9z1Zw3YnFAMgCky8LFS
858	B62qpsMxKCoRQnr75yfsbHAsGn2Cn9YcHYRvXhgzURkGdYTnj3xufsX
859	B62qpKUqR97dtt9n7CSrz1yPjfBHg2h7yksQ1gRiyB9oABZcXfurTzH
860	B62qq1p5NS9N8D2jGKQDZkd7UrADvK3EeysJMRnT7aXUi9iWEwupNiT
861	B62qmCwouxG2UzH6zEYGFWFFzUuSv9sbLnr96VJWDX3paSSucX7jAJN
862	B62qpoHJA7xwPegQPSQ4xa5vQEd15uhat5r5XRrrm9wUhMPbdF5CC4b
863	B62qn42hMGBuo5UGtLMDvfZ5eBLnkKVHTXwnQkktfujrLVtco34WFqx
864	B62qnbCsiNKmdj7GYaMv3Zf6jTDhpNbMTAQYBZddCctnrxrkG76qNeH
865	B62qrPH1SqnVrh92QART2N8sjmjRqnidtp4my5SAxstpurqQheNAR9u
866	B62qqoZx2obVArX2Azh2D6AduLDv3BpPMzJaBTKNyA8RpQ8xjJYcH7E
867	B62qmtcbMEVVKN2guoyVEqmiPZtbvNhz4VUvUYvxesya3WHPkLiBvdK
868	B62qjdxMGGRmQ8W7tqRaEuVFQgSPqkiYqFDUKPkJ3Ks9d23Mwmzgphx
869	B62qppJosj13spPS9ZvkhqUfqkTRH9LHYHcUZR3Wivayjrs1tZcZxXq
870	B62qr6JLYwR73PNJYVyRgsPACXduQtebRGUPshKjeJB26pHmF3tJWr6
871	B62qpzxtQkkNdCARWbcFhrQnB2cc6ybjDHhFK4zuBm63QgMadjnUTSM
872	B62qr2cpHeCn7XtQA5ktqKMQ8gmi6UT79SoGatfvinNyBih13tr2SuF
873	B62qrQW1u4635tmjLjkz7pdUrwE9QhmYP8rPb13SpaNBeHa4pGidstk
874	B62qkpgRQcmwDPEt25g7CoBSE9wY8HWCzVsmeTbvgZ1757rKAtUAPWc
875	B62qm3hoUHCPWGdKfrSK5Ek9STvGfwjf6L1uewvgFQHCVY4Y48DT4Qr
876	B62qpLv2AVt8zikusA8jkHinfWgCtLnfnZKfxrzitDBoqozwo5pSSjH
877	B62qiX7wCtUbpzgJavPKbfBcLJ6nyYB88cWjfwjWZiyZZLS7weCDxwm
878	B62qouqyiJfmysbVqgXZJy7rDvh2ZT1w5vmEQXqKAkpfvk37xQePyYL
879	B62qiigQwvLyyqUsAL3SmtjP43iGnUB1s1mUYrhvyZCc8PVFaW9ZQvd
880	B62qoQg5s8EsT3wL1zNT3sjbsJkGXUnBSfukzB9z1MnNUo2DQD24vus
881	B62qnbZcyj5U8N4nqGyt8gf67qsGitf3LFfjRsNZuXV6c3XA84V7p1v
882	B62qrAFo1P6wZoE43hPKcRWodZrC7wZFUFGHYwFgh8zyrTyos9ijLSf
883	B62qizxV2Z1Lbf8TFb4Jzf3uJTd8CDBSuJ5ypkJdw9pZNKzW1Rzxrwh
884	B62qqNrAYrDKKMve6ECt3mgBBj8g9M6xKR4gdNusetisrAhUTgpHiV2
885	B62qjUNbZhrc4vYKfib3kfL8HRAg7ozdis2MhTXA9tobeEbwebdBfR3
886	B62qie31VMdCUN9VbJMP2D9EwzcdcF6iYjBzYeTXPiuZzbLaBnYkJ54
887	B62qmru4aEDszwLFvH59BtZnU4QLC52nrSRBJW1EfdAp8cD5drg8QFM
888	B62qjpDZTY6ZXsGSJpMvZycBJqv6VFQTStdrEARwh53qPBfcBVuMSRm
889	B62qpz34iGX2eaRDyHmHbq3v1SnUgzounhudGZRfNUDh79JuTstPNy1
890	B62qkavJuPZs1bqRTdzmACy3Qf1o8FYRbh43qRPvkB6tQconwjFuAdx
891	B62qjUut7tByYkosrfLDC5aKLSLQ2JxTbkBcfF3em3HwiyNkEsQmwfM
892	B62qoFS9tDcqaxcatXcr8jdTECpTXwa1vMNfuDkEdp4tc7uwn1z5ELx
893	B62qoUiAHZZ9xY7BibT84iwMtgQidQByE7tCuNhn6DmyKhUPAzpnJAd
894	B62qrQMPSJpee1NnxVb4cr1qBtH3kMNpXaHVj4oVxNhqadCMBk6wELy
895	B62qpMJkbt6b6n97jhW9iWfvmseaqaiUT2KViBUKUHtE2MbxVGSPBnc
896	B62qp78FJiBUMordLumiKQMewazCwcH1Zee2GuK5MRrEsqQ2NdGHsWE
897	B62qkK29ScnXfTzrDkkfASepKoTE57CT8SA4r43EQCCwwJXAsP5TGGN
898	B62qj1ddvraTFJVjVVTpDCa8Cs7TVhZGjqEomQrpahrJ3hdag54cGb6
899	B62qmEo9HSSLLM3DtUJwcNdeqqQ6zoNUMqXauu9ySWKdpo8W7T9bjR3
900	B62qm4km9z5EFAGe2ByVR97gvnbbx57FQu7VQWEviPQHtaSeApBKjQB
901	B62qnipPgHt7ajPdMko2STLDAxWW1M5q6sZ8V578khR2KMQUbhxtTPN
902	B62qnhoXZG3BqKWJ6vTmRFM192LqvKZYDt1UJP88gi729USiio87AtK
903	B62qibGLxx3ECjWgU2YSJ2LZxXkPriLyPHZEb6FCdMNMPzAphSFZnWo
904	B62qrGcX71YGYbgik6onTADgDSkk4huovAhjzJRZMdUZLJRVZ4wG8dp
905	B62qknoGUuTS2MmtZMrJLX6SumUP5BjKJVhyPTKjSBH5xyenxZ8dTWV
906	B62qmQVRztGMtwamypY858BbGPRNmoJTrqMrq6xb2BtGso81bEzn8bR
907	B62qjWrka3sHmyX9E3LLk7DYwTkD3xpVxJVWeC1jWesvUCw98jzwLEb
908	B62qr11GnajdtFtYHLB25VfR2HisWw9gQTtswLT9UDuBDupwxnP8Qtm
909	B62qog6J6WmV7EG35JYwCoMjXGQKfMzDf882feobdM4XSTvd4TM7o4x
910	B62qmQAFPta1Q3c7wXHxXRKnE3uWyBYZCLb8frdHEgavi3BbBVkpeC1
911	B62qkLCr6WNbmpwmV3zLUM99J46WGpEJLcBbQEbQen2oXV9MKU8f9mL
912	B62qo41tpoLx87ag5BcocFD8QV5jQB18qw8jnNqKGz9KDXna7PT3DLi
913	B62qjFozcCaaeMNaAWrRT21JUsSaq47PYW8DZdySviwath3Mg8nyfCw
914	B62qk8QpsgrR4d5NM9gxiiN2oiZSNznfeDbr1V5pFWa82nZy6iwKhfw
915	B62qnJ58vM1du7EkL83EPtjN8wt1MXKC93Sbe6icpRhfLVgDg6xnVgA
916	B62qoERQaxigi8r2cjyUuQXicjcPbGZfjRkeUn5sedzYisjTBNtEddh
917	B62qpBVRzjqFcbzMk3JAFdjruMAoqdHyHiE9XNyshZ5NjGo2gY7CxZz
918	B62qrr1TdC3LeN5F1Bgjxb1v4Pdxt6btzKL7sGTyLGNcydmagjsYsQi
919	B62qmanR1vreSJgKYZcHSiNrov8jvXShfcjioaBLpCGbr7vrt3DxZq9
920	B62qjCoLPn8iXHXq9ukNMhAfqn39o1MZKsAx3VrWFdu1pEbZZezJhJe
921	B62qkZvsPhMjgYTiXLLGXWaFUCFGAexpR3v2z5ymXKEuZGVhub5ebNk
922	B62qodbQJ5bnuY7j71eaYiiiq3XqYDgsBDJxkAhtzqBNpxAgskKdTc4
923	B62qm4UyivsseKABrgJxS4AnoK4SX8b69o4DWrR9cJ8HRYGrNq65iEG
924	B62qpcJd5eVzs6z4hs47nMQipXJdz3nEaEqbLStc8obzecfNPv5vAnV
925	B62qo8FPFHTQ2J5eaCK74yfsMRBFT5bnr2iPomWLv61iGpaufBop6Si
926	B62qpGX4AkMb93fusVyC7CDNju7FUP1fFVbspw8o4sN8xbmsiKxgy7f
927	B62qqLBQFF3oRGthJGnbZB9PEF8pvoxGcfBNUVtgXtH88VZE9KBoGKb
928	B62qnQ9R4djFcZtgUnEASzipJj4Liwdpt5WjM8qnQvWH9QZZMwPHRJc
929	B62qjyUJF51Rh87LkCzFUrWFBC2oSqL55dw1bHMkPov6oGpqiZxd2Xc
930	B62qq6YfopW3J9zaw9VEjQP8tehZVzewtH8LDrPST9FtLWnnWhnoKJ6
931	B62qojvcsxDKjfx2UKTfrsrQ4XYt3x9gpUfijNtTyNHjMyKigubEL1Y
932	B62qnem3qr442rQCJ1cmj8kLqk48Hpi1PEJwPXrMUNyiSymQQxSJspn
933	B62qo8yt9f1eQAv1kNUocT7jWKcHBTEcMxkSCmK5FSn9eKUfy6mZpQc
934	B62qmXBgmuA4Zo81V5Xmhmr5opdAbbddfyVxsdvJuQutceSHNQe2Scb
935	B62qjYCD9rCC9mqfqdAi929GRuZBmNfba2VomgfRVtZQzPa14YguZd4
936	B62qmSLcBAgGJYa14CUyGdoZywpKuztSKWRJsnKFSxg3oeLAYaotLFv
937	B62qmmvXhqFc4KpY8o78Nx1N2gusT9zC7D4pairouAZHyJmutVqApJ6
938	B62qiWWh6F34fwbZiv5uGKg15vr4C3cxKDBxR4xypdgQErk4t6DBn9k
939	B62qqMhtDSFToxQLzPjZ27PVtSCZR9rgUrjUDcjytWSsDZtPFiQMrnK
940	B62qqUrqjmVerAGWSk1TByCBQxzH8u9PRnKnMu2YH7YbhyS9CzMnYRq
941	B62qmiBiazpFUcs4t2ccJ2vEzh6i4drnyLQfNV3dEfgZfKYYjAbu8tC
942	B62qjYKFSc4DJ1g1PGuyooe8BGXfQEiTUb4oLH1jhntZtQpz9aV7WY3
943	B62qp8no6FregychSQusyD56DkRrqvg9bhBF3R3BQckQzQoUY9piJ74
944	B62qnWqVhYZaSn9xHkpih2rkbZ45MV5Q3CktwGA9EVbZtrGGjSr83oj
945	B62qkeKupTi7525nWMQfWgJ7EhrxhyFdnhANKrjSo6LRCZJ28yHw1yv
946	B62qnNmzW5uoLMPEVhwfL5xW1jCALVRfP6CEm4wPbyuu5xxJEoxBbue
947	B62qkDGi9CVj8Gu7wA3Tm6R1eUa8ZxZSUeFoQUmAjqE1diaXYcN769S
948	B62qmij2xZg5ZLmMUy3Be1Av54misfGR16ywRJAsPhMvdUWpzhKfxD8
949	B62qrYfgf3JNvWRCrWWH7T64ForhkYTSRbu5QM51EFxD1Q6wF1wzFNU
950	B62qpKeaQG8uJxYGdMWkhfff75YrFwoxPwSzhxrWxUf7STrpQMMVrYB
951	B62qnBRYDxf1EG23jnJx1QAMvARTZgdJzYoAE5LoEUJbLiPsUzYfA98
952	B62qqkKscGbufYJ5qpk3GLWenaJCgK5TgiaRwozsH5BmdqXGbttGYSP
953	B62qrgWoTX6rBSPFyo8ffBuQzkkVN1yWi4LD4a1u2EH3bXJY1bTd3Vy
954	B62qoHY9jb2WaBK1t4HgboN7vCq71X1aBGfdaiQdryuyDSfsgCDtd5A
955	B62qrxjaEqDqq1VQXc9xPXU4DiJM4nBMYesWs7whmNyFrPr6Qo4GRzu
956	B62qmFMzdoZMdhvU8Rgvnk6cLieaAMYQbjNumWj9cCMuNVLmDXKta5d
957	B62qkCuaxdGJGKjPvYa6TEFqmBGc7p1CmLwAsYJuVA7iu3VTVZQDR4b
958	B62qkQJjJt3PL89vVXoHir7cCFPgpdJ1JCmhqHrfwjY7zpGYhtC2xHH
959	B62qmnPjiwSKnff1qMUuYcuixn12j251x5fKKaxPtWDajf8KgaQX6yU
960	B62qs1inqycyihVap9Ti1T4WrmqoZ2aqZ49z4peRYM1cC8Gk3brdHk7
961	B62qpJZYLwCjH5Hafi9YiCGGgVhuoq9j6A47MxJG3qzH3nzS3pZZcnn
962	B62qnKSBegBU5wkkYQfKEKPenEsEttY4EVSuizJNrZdsdrkk6xSmb3E
963	B62qoTdpaj649XnqLxGq8oY6j3pBQdujD7ftQpq58AqypTMcaZePfUL
964	B62qrxrrtdZGk1icXvsEes5DBxHuaoifF2MmutXzFPLjsuSPouUbcEu
965	B62qjyY3c1FNPLUir8MBoECUNAP3CiDFE52uc4LP8B5miWe441e1VPo
966	B62qqJXC6J5UXVNW321LiGtwFR2WTGULFwZzrDo874BYi7QGdrkpqFY
967	B62qmQQ84vg6V7NwizyZzsWk4z6P6GdXrpvN44h19TRL9dsa9xZ542H
968	B62qmPfMY7HNmuvGnQQ5kF1UoPy2ipNXAF4MtmZvLipAynggd6EWWBC
969	B62qpqgV3MoZEtfPiceJ7tH9ngz9o7a3EtkdFr2a9KnRkQGaxEuW4iU
970	B62qnysDggsacPKduRXXMzCgbU6ggCSGUywBhhrGX1c8W4nr5oSX1Jr
971	B62qpYG5JSiR88NHKPbceqDDs8MTnhmvzoDWbqbJUWEXGnuVjooaUPL
972	B62qrMCR9BPCLY2ZWMXH7ueNJM6ZCa7X5cW2NboAfpXqaiDadbSEoim
973	B62qn3jFiBMx57Tqw1EbfHPtVqaEntjZR1uihQ4jH7iQLBFS3hSPKC5
974	B62qnzTCuHo79TU9chKbcGLudHS3fU3NhLReJG34MhUVrFN6nA7Pjik
975	B62qrNpfSTjKyBiq9LEU8wNSHPu2YNPiv7sgS2yYhACKjeXWUmLvAJ2
976	B62qnFpSPGZveVRzoABYjsW6dwAXjcGeAnA6CsBjAsG86ZthTGwy7TF
977	B62qitq9vwHhBXHwU8Hu9VqPGniVUs7C74RbYz8v8EtDTnBkcLC5t83
978	B62qq4x5H4WyTJHywAZ3DzPCeUcSz1Gh7TqMP4ydANeETB68Mrf9X8i
979	B62qifDaXL1vTRa88w3w1ZcUUtK8QT5nUF5CEAKNFrftEQMu6afkoDM
980	B62qrTGV9jGcZsxDbahBPPheUd5MpV97yzAn1QrYyEAtzgfbURC3dMa
981	B62qmh665K7crtbKv7JfNQgJcBKh2bZN5vw3mz3ds6vVo76M2K7byvy
982	B62qjUVRD9YVQ8Mt5fmtjCt4aUzeZLDMSop8yg6Scg5unqDXiyM2SMs
983	B62qoTaYnDYrtmver4jnkgJbFU6iohjtALTU4ebf4yCKrxFFHd9Dimh
984	B62qoreEwCN4QMSJBcrEgDLzmygNKgMkshRxKGMZfswK9oNpoZC97ZS
985	B62qjRNvNj7EJCWSRfhKNosEYnjTCZVbMdiyymV2QxiYpr8QQehgYB6
986	B62qnsoomKzFNvmJcWAq59TLtidzYwD2hcUCrrFhBNWys2npQTXpGmu
987	B62qrh8V1qvJhQx9D6g3JDgVg1FYR8B45V7EFFim7aLPLss3kD2aAXR
988	B62qogpwsY84waaousZTWkonka6EoajHey2S3cfi9qzSbynbmGiqaUN
989	B62qiaQboSdk5JkHTNcPWUjDwVZZK96u5tGac6aLA9yCqVm8tZLsZZm
990	B62qquq5R18f5sQ1LPF1MGqwwxy1jRCeMEUsMuvjgJ4dAajdQgjcye5
991	B62qrzN4SfQpxV12YcSW4Crb6PY21y4sgpq7e3v2qh7x5UEd47RpNze
992	B62qnto268cEnV1cdZh2bRS3bMwiAT3tRxsPrfiYruHaxXERAR3Ec8b
993	B62qku85TZbbwZhuYr3xMsUJ7KndwA1wHcCDVvawK24uUtBjQDa9pye
994	B62qm6aynoQs9WmAbkoKvSn3eMDo1PAZi4jfB2MnbUWTHsq9TVKYZVJ
995	B62qri8EQAMZbZiwaYXtuh3fs14MRPJ7x3ePQh25SmR7ggKRtnfJ2e2
996	B62qmq4EksfssuNcoAvFhebPiBry1uUR1bwLEiN84EByVPAcVh2Lvib
997	B62qrFQnjeR8FesCFUJgNmJkfe6uzYMGSverRyDVjfQxDPgkr8mzjSq
998	B62qjtHX7MLXn7cNM3cF7Eb4b7cgwrk6STeUjCtPktusxFQ75T3BMPn
999	B62qjaKD4AAxb8UUQypqysaFx3cYhp5bSjzgkQobyjca3sRJKho3VA4
1000	B62qpDH4cXswwo4YYmdS9apCeRQUXtAEXuCS95ddMCFhNbzxvzZ6Nfx
1001	B62qpJ4Q5J4LoBXgQBfq6gbXTyevFPhwMNYZEBdTSixmFq4UrdNadSN
1002	B62qnNyeNzkyccsgwogTg9jgqBYfE6KnjTWi9QxsVkQ2NKgW2i5fDj9
1003	B62qnsA7W5yWUr8r27DwmBoyHqYE5FMpm5NxhotqppmbL5wxcBDZZVT
1004	B62qn9zWo5HcC2RRRi5P8278Hq5RoKgQWqFvXRYxsbVQeDCsAJP7aop
1005	B62qqsZBMoFs1AmiLxekCDUta2GPHPyZenug2DM4jrVrrZqUHi5PEsY
1006	B62qqhHF6ZZQEQ2dNyjSSMy1uSqy8JjVnoRmN4k2q9VPfAEviRpvype
1007	B62qqSy5saxH3Ago7obP4XT2M9fYkRLMfthRhgCw59jr7EvHitk4VpK
1008	B62qkVtsvZk4sMHJETFDeqzukb9vEbswirZFY4afdKYMqcAEw1bkGej
1009	B62qmBXLrMyUZ7HSTcnSpUG2DFcVTGtVFNR5sSkMzshTjJyk9nrJRTD
1010	B62qiscckHMmaedeqpSokpjidB4WQW74tmWAzXWG8rW3DgTfEfXJazj
1011	B62qmsgdnJagaswVUo1KhnQNGVF1y2wS33RcR4kS85FkAsJ8xTdNuit
1012	B62qpGm7Ubs2exzhPZuHFCmsCRrhBKigUUoY3p4gSBq2koqfYRFNbjX
1013	B62qmm7feizW8hGKBBzvh5gpdDbqhMac3zLh1hVcTaj3BbYC18Eivi4
1014	B62qkwYTYFzemJK9ozx2K2fy4YsvFx4w29PTBdwP3khDfax8tUP8rJo
1015	B62qm4egneDvLXYCwzJRLBQoseGZezZ4LUtJUT256phFLm9TQWGmFYb
1016	B62qo6bK6jBAa6QR4EYYtH6MWeGRfWUWEWXPjbYsci15ecXTafkSw6G
1017	B62qqrMW5HUkhKDPuNLToVyxcc49VEPRMaRFzSbWZysAsyPw8nFAu4T
1018	B62qkTViAbMfWGRFJyvtWT5dBrfBUReHTHsA8PWT1dBLB4ctPHRf7nw
1019	B62qqsvgiixjji3CX7whzuBKVupvwgBS4Dao6wDwkmWPi79TNcwZ1tB
1020	B62qmtxhr1gQ5PUvKnNRVfhuuVs2Wjn4xPBoXMWujaYi5D77gShXH6Y
1021	B62qm4TntJySX6ktHD1SsYumBdvSTp8pLdjMwTVjBrmA3ipkWejBdbe
1022	B62qo1mUFu2xFntFTqPhiff3TEVyhu9ukTKvp81vqzvBUDs76DYTGuo
1023	B62qnfJ6Yqn8FKmFK5YfiskzD1axjxSJwP2jRtNrDUiH9tN59xz2KgH
1024	B62qjVi5acmgHpTe2h7Kqw69xRXtc8KvJANmAnx2tEVUz7pSpfrLFXr
1025	B62qq5MpA1CzLTwC45zADGS7rRGZoQ3kmnf1nrYQzcnETfoJvU5vamo
1026	B62qpJtPWEqXnDcXLugqf3C1m4ftWf2DaXLK8J35Ka7HoZSCxKBDWbP
1027	B62qjbRyvwkiMNwAvamp9wfFoUyhwGsQZ2Np2j1i68HdbYLqviS7hfw
1028	B62qjAbb8hxvgGfpJLULvEA3A5yPXmZu8h7VkEMX8wAwpGWEcAEQLvz
1029	B62qjeQmtThR9HKw3z5oq58RHfCtdvyJb9chiA2R4NReipEu4nrbPHw
1030	B62qn71s63yywMUCcFhP4iCata7HpgyrvmGjpKa1D9544vGW6FBZ6a1
1031	B62qoRkPZeEekdcQWRYCrCTwcYicVyYRCiU22gggFYUTatWBNHt1Jk7
1032	B62qkaYsXdwZ14UoLMtrXAp2Up59uUFZyY4KpD7YbvXaMo3ByceyxD4
1033	B62qid58wzxcQARBwdYmAYc3dVLFirx5SRGLdHUqMkQb6hVsRpUzgiu
1034	B62qoGbqv395zDfi5Q9yPTxLgvfcLtFwJdmJ7nJ3tLKU2M7CjRY8kCa
1035	B62qne8eYsgx4dFc1pBe4efuwamHUuKz7p1Jywyyk5v854eowD2dEMY
1036	B62qjdPSYuVpB4uLp9V4Pw36GP4CgqKWeJExjzHAipL8KbrSa16uvNw
1037	B62qipFGtaHAJpvGSJdYdVxJw6Fg4SdRK6Ldu51o2rVUGJF4JzgMqna
1038	B62qo145pgATYorapx2boXn7AbhhwMTnWK27phLBkYwQJjjpCYXxNUP
1039	B62qnAwsnwgn8okBLuEr63egNYFyJqZAhWwpyccbTZfyxMJgyDGcVGx
1040	B62qniwr9y7XYbjy26rgu3UCFwHBzsnQocu5gnd6agwbZU7Gxtu7WJS
1041	B62qiZppGFZmWNLcGDrPp4wBBcEKCRhSzY7VC6U8XL97ybesV3GECLt
1042	B62qmQ68xVWawcdC3WAXCDiw7JevnocVfzdV5pq3gBiia5RydquLUcp
1043	B62qkxHjXkxWcdnep9neiFpa84Dywf5B9cUNrmrMEJ2hMmw6iUeFieD
1044	B62qrJHuDFWfuWStjyboPejGaP4HZqFRPQxsQtWaxhnV4iJBgfcH1cb
1045	B62qkBoe9qNqxTiXBe5euvRvZi8rCUq9TgHfM2BwmcED7ADJHFkDQJN
1046	B62qrdVeRr5u9kBomM18PQdGh89oTthxgsy8JTjSCFtyzGD8RWwUjme
1047	B62qjpzAChiHvZZqchLWcv9SAc52p23oCerTPPrZzFqksLTgwSBo8Ax
1048	B62qrxhjraNf6uXqLgWBFVAhsZqXAfpXAPm1ASZptnEhLZctRTzykzM
1049	B62qmuzvR64h6vEt87ijpikVsVeoYdnYGwM5NFSQY98j3CSKw2i8GiE
1050	B62qnpc2JJrKj5gash86vodGFsLVQawaLSiJwbUtPgLs8dcp7QyBzYr
1051	B62qmXrQB8jpxHZ2i576MsMCiLNorggtfz9b9zVSwSSo6bdaimLMVpK
1052	B62qqARg6wBwTwt1TQHkDuLqHHyYzPK9APb7vhEdxsUmCKaD7cQLHbp
1053	B62qpYVQWpALzvtXLhBLcftFbSLv2bhDJYwfctSG1DKjE4by2h3Z9Fo
1054	B62qnXfMmiMFkkpyiLejZgMuYYJuptdu2tyXKun1VPCS2xhFrwqvy2p
1055	B62qq4MsguV8i5recmWUuYFWXpPW1MWZBjjjwEuChaFRuTioP8VUctQ
1056	B62qmwgXnydnYAxhFLbyZ68zDQsF2yxDR92UUucBJY2i2Mr3U4Qw2KG
1057	B62qo92C9siz8nua4H3mopoLxbDVV6dsoavd4AoimHAqA3ojM9pfh37
1058	B62qrmk3L8KdNb96SqvohxCKZuhRVGRYYTMAgrKFhAD5T9terBwG63K
1059	B62qin1sCKU7TQbkZ6Z5ka2armpaxkJgrWSWgUmGWG2qWBTPyxtqtuL
1060	B62qp3Pd3QM7HXMYMdhWTjwTYbWZVZe5s3vKxdDvTV2YPSn4GBQ3M7E
1061	B62qr7ncXwHeBXyQP2dThpWNwySjkUDCNagFkRba5jn4LyB5cSUioXK
1062	B62qovenu34m8jqnnvxq13NTmpBHQbTodMAAErSXNzshZiTQZcCtjNs
1063	B62qiUXLM7UrRFZxSKg3pLGRZWnQzyhLa1jvbCrhWUtfDpUCwEdyJz6
1064	B62qkBU1d1gVffSCVvg1hsgFLwfG8WAkfrCQwoNbfLosBQMz7LFxF2E
1065	B62qkPod2ScW1RBFtwUJxA69eNDfE1qKRsj8wc9Q91WQZdoTHorfTfm
1066	B62qnRCUTA8azwS5yrsduiwY6q9M72ghdWeYR1G7hvmmoJk81XPiU7Z
1067	B62qmLLeHwVNq3ZYM7ETt6n53s1YHRv69WHzJ1NBMDGkCVcHbUThqFe
1068	B62qpurNfxgxGDDfhaX4VR8MTU8tEBwRtgWFYUiM7xiLm4Nqu4vHKbq
1069	B62qkTfWwHvCvcEEr8i7zNgUT7FivBjWmE5wQu7yzeQxm1AvPr63g2z
1070	B62qpNyjUGZyRXNpRKmVyPezie8AbVaTVfjHbFbUBYHYfQTynfd2mzq
1071	B62qnQAEgB5zxKCz3icKgpjJ5BZwsTRE51gED6sJgRzzuSxhkdKSMeN
1072	B62qp5Tbn8gW2FKSQkrqhVtGxhhrN5KQsCYC4rdASHjgUxn5vVezMCP
1073	B62qjkpzsDcW4w4V3SS9LFuzFiqpydVvJoJYixgAG8qpMDPpaRnTpHE
1074	B62qkhoEckV1fEZUJwD7ghe22ZGucu1v7jjMxqhCA2AwtTAQHLSFqVz
1075	B62qmDwvqT9xNNwee5gZovcj5E8Vox2STA23x7SYRsiC1g7dKo6UJvx
1076	B62qmg9tWG7RYemfvWtXjAVquUNGuJ2jgM1TkFokD92rB6yLSwLBDJD
1077	B62qqkvZbFoWwAhZiAJmrHGQWY7q6HAnhPhLMs9jeZkDKFRqGgXHrQc
1078	B62qmvq7k39ZHC3t9yBKXs3rkYBPAKXCWpvewjLJ64prmVqJWwDWKef
1079	B62qmfGmXEqtyxmQQUjZS4WGdc7gbB3aNsuo39g5S6mY6VVr3jwnz29
1080	B62qkoHmyjLDFzm8zcz21QWb3g5uagqUZBpssygbitYUMpd9S5sd66B
1081	B62qnBCL2nL6u38wLVqPWQ6VagvCBcaMAXRiBY237h1NJpubThKs4Tk
1082	B62qoWGif7FBbK8igStzUCukF5WMJZCqmFgdsKqHQSBsLdB8vWZrewf
1083	B62qp9ZP47Wxi4v6GCHqVpbAz5PeQ3kYhB3WXy4AJvGZ95gEeveUPw3
1084	B62qjeBcbRunMkcTmKTQ92nrMZUmoFKMccLBTUvnD43TL7e7Z2PMARR
1085	B62qnVUKhkfS6aXNaynq9X1xLgdBBF6RHET4byPsqWEenj1dK1P2LUg
1086	B62qigJASqWfLEfeWU7UPfSakDYrdyAgWHUuyX4kh2nsgLgBeRxpn1P
1087	B62qpH3jQdvyx6BWJTPUgZHf8WXFhEoJRSmAqTNh5XNtBRH1fjkf1gN
1088	B62qk5fAkq5XDDVGTcB741M2pJ9Wnq7srbmCadRWSkC9ne3Nubpgf5t
1089	B62qmQ8ncnhsQR4RqBMcFiwnUcmuRHC9kYJDZSiuJ13tN5aAVLUQX45
1090	B62qk5eE7w3Jqu6wGgXTcXt6ScVv3hCQ1kZZrWANwnbwttmZfYZLW4Y
1091	B62qnTQLp9uHwzmxKuyDa2UP3QHpPZD5KiVGPegB1ZLWEC1DWC4h6kB
1092	B62qmNZb837DtnkPEKo8Ph2CiA8yGCuG1Hab5Zen1AoEWqUjCVXDiRV
1093	B62qoX49KkvYNJt5VQd9rUAgWJuF9UqpbeVKwitzLDC5XdwnbYdHAi2
1094	B62qqy2yhUCw3NFqA5XjcamuUQYXADNU3FQzKbTthSGW8P4Cpnu49Gf
1095	B62qmxTFPg2u55SEbookmXU8niMu9B5vLrybVW2STdKUb5tj7TtvabW
1096	B62qphNw62QBjfwsoSRxeYb5sVyde16WdxkynC2V3pUR9yuMFoqHDUE
1097	B62qrZ5r827VT3if6vgo6UaHy7sfhRvVyRsqxyswrEZ9AwfiWpjy4Bq
1098	B62qmRapzi3nrctTihmaeH3CNbsDkpAAmf5osj9SvucNTU7jteFchhZ
1099	B62qkvch5mqkErUrN5AQpXS3MicaCdUhScBVjHqDfbsbP5i42okjcL4
1100	B62qkVHBqMkm6zmvBE5UHn4591dfFk8d2JLysx7bvmBUgwQt796878j
1101	B62qpWiEcSPE4cf1F7UaWPt4JJZvme3B13e5S39tKNgqu86pszn5scx
1102	B62qmFuBwy5JUZ9rfRFX9YDxEj9xAP8fszK88nYRwxs1zzfVG6hPXmf
1103	B62qp1MrxFnKMUEgAcWq2AJscVJTVzpSZHVJjgf6GGS2fcJTDU5LhVS
1104	B62qo5aeu9qezh2Z1qsKV47jHwgt8MvYLbKVWUSoi6iNaX165bAtmT9
1105	B62qqxHGzvYKYH3nCK9fdB8Qvc53rF6VTDRDz1sSAnNTJtP2G9G6F4U
1106	B62qpNBeLFvo8dad9LX1hp4aJa833b7C8RUnAP4EbQpQ9KhrY5roxWa
1107	B62qrP66ehjMUjSPV4ci8scX7qrLYguLDEmDhQxsq1TS9BvarupCd71
1108	B62qk64MQFspF9kcsU6QvmhCX6knqYRmUV8LGWKfNQWSf1R8snBPaSk
1109	B62qpsfgietkCzKKfqbjdUmWFPjJRTykEabpx5U5A6jWdESh2eDqBNs
1110	B62qmxDvkGqq9HzcPBWMxykMzNHEHuVyP3gWmNSy2CPT4hNQHzgpbxP
1111	B62qp5A9NfjDjtcqy4Ud4FKd9vEs41Q7WPdSAzu78NFK5o6vbhExkSm
1112	B62qoLLCQiB92VKj3bBpx6hUvat4bYh44cPNYWVPRqf8g67D7QPSRqz
1113	B62qpyJsdHDj9mftCE55BX8JAsXh2MJtrHkPusDoMC8fUcmo5EWLvY1
1114	B62qp9RWhUJt949SZKJNWq4tJpCEgEjFHD9H4JWLpxC6CkCgXQumCA1
1115	B62qr874z9GXC4SiHeiX9cikUa2NUf1ZnL8bvmQ3rdq35s3fRYWwLTc
1116	B62qpPFVqxDmJp27sLQzNB8MnkAcFTwA6QS7C46dMyVYcfq4oUyTY9n
1117	B62qkMBqD63AvYC9gcvJLPcdVbNAG4wwjHsqB5wpLiuzbSjXiL9qHwj
1118	B62qoJWcACRGWgcd7NBwnfY388ghN1dwoF6FXXLJtwsCQtgxUD3JXMJ
1119	B62qqdFzNt7f3h5GQZWmHZhRi85r1F5vbcikoFPB14KxsytuukfZ89g
1120	B62qjusyo8pPwH5Ho81j4CPEKkVLQGeQmcGsn2ZaEJLxJzV1EKsWYrk
1121	B62qraZF2Ep3WheJdmtfQ8DG6JURv8giNdDThFV7eNXL8smFxY2RNiL
1122	B62qraqoNtsxAVCpmVSZF3DVLzmM4uo63dvomBSogDHaGLJRqm7aC1D
1123	B62qqt8AE79NdNDBPSrRb8HzpPqC3hTgWRuRtcbT7nProHH3Gcv6tZa
1124	B62qq2iUH5cE9b7Gjbw8pDvuKpEzmqFiXxsDazHqiN2tw4cKoomvjBy
1125	B62qiaGV9Mtk8ZMGmph7WiYPzuZYp5qvbWj1Re479rvGeA672gmRbME
1126	B62qkkvP9xAwiCsh9SqK2nSEQxf6pFG5kkZ5K9Vr8wVzQR4uhynpSFw
1127	B62qoRg8wZPkeTL3bhMkay6Fj8fo1hJF6iZtanxrwE3LektzfLCtSqd
1128	B62qksjpcicN4YAXFsvojtARRNyDHuSJkYS1tVpspWfxPQg8sdGivnD
1129	B62qrey9e8ZsaaJv2KwHHowBhn2KvTcdjSiedqgD6nMQoh6C1F7K7Zz
1130	B62qk5QuT23z9F958QrRcKZ1ZWiXWmwj36uXDdoNGSiSxw1hNgn9R97
1131	B62qifWG83TzBDNSbqsDkmmYybQx3umZSTNeqQ47t6mQcpJhCHtU4af
1132	B62qkHVcy87zYztXYmRuPZ2asSMqhxkpAHwGfcCToB1R7DLHnPAvqrv
1133	B62qph6BZp2veywEtbtULgepSmDvnXz58mpj34gvBL1iQj5stHpavd8
1134	B62qpJdCFAoycomY7LRfNXZDHvULj6ug8bh1huFVGMGzX5jwjQ7JQ38
1135	B62qrXCnHQrSf3XnAnSb1DCUDka3dZVWB2XqH7Axr2vg2KaFXsX6G5R
1136	B62qrnLPoK3bsQvrCM5mFH5SkkaaGBhYabSKb7zUdvDY2F5nb46HtWS
1137	B62qmHpKBQ2FzUQijFi9UMRU2txrLb1GuQMr7vUCzLqnDJexwTdgKbV
1138	B62qpe15stHjxU2pvRDkM9hp6J1hWD4Cf1zmKGCtzsg9awuVK5GxcUR
1139	B62qpMzq4vHG8RbUpEVuGrYG8tJP4fPEbUwosGLpwLQsBFQ7d5WKdzc
1140	B62qmBKWg1Z8cCQoDGXCZSqVopP9yVRfYcSSdWBcydG3f61wYxZJPMB
1141	B62qnSdNzb8icjWPiSsxgKfB1RvD47wLf9aYfVRd3HYTk519fhG8RUK
1142	B62qjNiMHpfrTemjZe3BYDdLfeFP9GGtyv3dnef7Kqx5vmdZo44mbJC
1143	B62qndvr7iZsJeFdeYVGYXP6oJY64T5BHjPBTSrfdHrwkxuEYCfa1LF
1144	B62qovdiupo2b2UxNhASffHV4CKE5abZD4TmSdSJZzf623fkrgLvouR
1145	B62qoFmrHvDzz1H7qztEkvkaqNUbGUCaZJJJjXb8xMmxVotSaWDmyMw
1146	B62qnkYYpjAHWvWkYsy7ANo9omZSQ53bwhKgHXUk8g2XANkjEq4AfNS
1147	B62qjMbmoXjUXSjqiR3z9zn8uSF62kExrbQ1mQq51w2ztVbSgEZGUmH
1148	B62qkMiKSD9HWrAc3oFqYbup2vVXQFDSrSr76zjbr6yExZarEJk5jUc
1149	B62qidGPfiiweETgxgkTrWRY7yPTS7MV2zz8M7RdKhuj3sAJGFDikfH
1150	B62qqEV4oP7w2jLQGckvZzdWjfdLKySKHJ3tNU5niRjpPD7beYumWTB
1151	B62qpTThstAYrb77DYCDygGW7vi1vgQ7mWNskcVRZ6kT7yfmHSByzxt
1152	B62qnMQ4Jd5pzu1XhiCXQBTgLB1HixygpaNAgVXMj6DajQNsEnEJx5S
1153	B62qmCFjyTQ3m7GhCcdJTrdggMvdbxJTiMFrsFeZAdoyWQk9DsAjNQw
1154	B62qrVyhLi6qSyAs2wzdcRB5EMvZ51cn9WQyQtM2M3igu3QKsTwGJqd
1155	B62qrVoMR3KnkvRwWoPhdmKJgegUwBoEnaxSpCiMeeSZxZ2vWUpxFgL
1156	B62qnTX7QhTmAHvbSs7dXa2aQNepP9raeqTj9fVJd6DQb7SJCGsUf1p
1157	B62qmojeHVL8iTWyaXiFEAoN6rbTFCUpP8FoVSW91P3WHgESWepbodz
1158	B62qo7fTZ4RJBJZUeHEBCmNb5jdShrcLPZVs6YFAYvWQxb5VamMHMH2
1159	B62qkwKReBsmE38P1fbWopHTRXBspPRDLXFs7pJEKZKDDjsrYhZAjHd
1160	B62qnwztbd73arnJBo3Zjqw8adn5xvcc2nZX9rWbGRucd2a3rUop2M8
1161	B62qqxBaYdaYHmqEaUvdwGzjiZJsDqySke9FPDr5xBxk5xUHfTv7buM
1162	B62qobkdtpag6cZzbkPBCGMxawPjHcBB82ja854Cz8qS8rmy2GMVns3
1163	B62qjz4dmTHSvMHzDShvrBcq5pJERKvZFqmJj8jUGiSAvNiDeApnTHF
1164	B62qpnWSJDnXHLWU4tSnmsGPLpcJRd7iT1uMvfByy4Xa3D1GcEkzVRC
1165	B62qopfSgwEn28YdwZHh4khMy3KEG9dy8Jfrv7cveUJw2sHzSCnWoqA
1166	B62qrEcZfLWiRe3WuCxvmm7oBZSURzBKNyphXMdiEPEEViq8JjXWHNj
1167	B62qnPhXw9uumnKzcC42zigqB8KS4LXRUzSNKR5EfFc3gs5ZVHmYgTu
1168	B62qni7tpQrD2w6JoMSMKDTa9wXR6KkDMpCXDSh8h7ki1afVmkrnvno
1169	B62qpNpan4tw9yvUXvjN5ScB8Sm8T8Vwf4Vc9n7o6T67jvM2VMTynAN
1170	B62qjDRP6nNDtej55V9tdmWhMtyjXuTFAHHEH5L2MW2nQ417wP4a9Zq
1171	B62qj7rKdAf1JfwV7PkU9gvR7fjLjXuEomU41coasvPEyY6PajPmrLP
1172	B62qnkgx9qj5PGBxiU7e6uHqEbKpW2AncbHP76LbYFd38DQK2YagZ8V
1173	B62qj2xi5jHnwJGFVnB99PKJGHibvd9XgrrgyXh6aRg7HkXsJ5cZemS
1174	B62qrFq66RPg47pcfMTyLFdBYWXRJaSFBfHhW5Q5Q8kzvomnJ6v4da6
1175	B62qqQc9UycySBf3ivyEaFh3KzFvLFjfwnKQsVne6VwSdAp8nEjst8S
1176	B62qnzD7DZ5jci5vHrKCuJhmoHjwrM4pAhuAiKtQBD38h3SRKgixaV8
1177	B62qmQ2n3jXzMqq3rwuqKwJXWYBRZYZoWJP1RCJjJbwxMYBMRNyM2bQ
1178	B62qqbgxBFE8zptNynKQANv4XXahadNZFAFpATzAoQYFZ6UFaKdghk1
1179	B62qiYiBh33hw4cVuP1RW7RVgWwFkLC2Q4DRphdHkaigQSJdneCrUAs
1180	B62qnDCGgbS3RwyV1EqGrktyiirSKr1WPpGHz4kA7EXXNgmaK57QWrL
1181	B62qp1C4ed4d4T9Hjy8ZGtZBoy2a3mubM6Bxf9o45LiLfBN5pbTMu7P
1182	B62qpfLn6rojNNJdbg4CPpVbh2psKRUf63A2UHyy35PxYF5gBAbaLEN
1183	B62qnPXW32xnngFowoZJRQXZviac2QvecUzfTfWdZCwTZthRzURg4wM
1184	B62qpnwuE1EeQHNd3JtJ8HjuK5VLo7E71J9oj2V3UCh37bjC8xc1kKC
1185	B62qiZv8fWPqH9oCUruNLuJaranpRAXeYzBMpVfZWA8Ui4bvZiGtQdT
1186	B62qkrhver9hVfaAU8hDgCqqtk51h4km4LwzSpvfxSpDWPQqk6nhdo2
1187	B62qjS6saLcoHU49juMzdzYahEsVAu4kd1snPmCyJ5yrfu4zzVgixZC
1188	B62qnyMshbjyi4ZrnX8SMKSKeEq6zXMDgnsmfVsoHQvSi4mT9jfpGSu
1189	B62qqoKGQqxvrP3F8JQDubvLednJJs51oJSkHPnJRZPuwL9FT4oyN1x
1190	B62qp1RJRL7x249Z6sHCjKm1dbkpUWHRdiQbcDaz1nWUGa9rx48tYkR
1191	B62qpCFiMgogyN1XAkRiS9R19GBShquY9uv3WK5AhLGhrufvdM1BCvd
1192	B62qisTrSDcz6mEtrzgHN5KxPJU6pf4G1v9vb9PMHAmnoRTWWqrAAxh
1193	B62qnAbmwZzX5HHHWwCaFJRahmBs9BT6Kj79tvd482X9eBAr9M58PrX
1194	B62qmadAHfyiiraNwvXhWC7g5q9qT5bkjA4FU35kycMrhdrEJjguJnq
1195	B62qrcVPyssX2RkRPMoD9PiKW3g3yVdAPaL43UpoT6cvXmNqzdwvLzQ
1196	B62qmNSqURW1RVAaKKuNtVqyrT9DcBD7PUrXuUivfcYhNA94ZVmeSvx
1197	B62qmJMuRKGqHt9ggz1ms66QsgVJT4b5bzA64EPWxUAHhztmNhGsnLD
1198	B62qnTWW4LjADBLy1wZZALkzHrMMGHPLu7qbGNgFpXyxUpRNHTc2Zm1
1199	B62qnz8HG7Z4VxQFhL1XakcCdAmz8CH2bx6YQJz13kcQrDV3W5qag52
1200	B62qnNWzsD8REZADYAEPZrgGaTdGnSBaNDi2HyrjcQSoGfRbBDWhWk1
1201	B62qnSrLh5JauAapgnfjqrB26Vh1BQmddaWpv1vXHkCjRTZFh6p8Qpe
1202	B62qpYqGMW6LJTduabsY8TRVbkmkh1vCNdVuyx58vvTnvJHYSjXV8Ci
1203	B62qpix6rNZVY7qhMDnVmMjCGuA55TGmco7TFuEPuMWrxruhWgu25HZ
1204	B62qrenUVqQeRTNmeDAmwJcvZVFfi12m3nt12PkHce1vgm6MMfoVPuH
1205	B62qp4fLmc3ZAZxUEp1PFkiepktWS6M2UcKrLqhUmLr96BBfPK7DUdo
1206	B62qrSbdso96pKAHdpMTTe1AC4QDGUYvW87vaEPdyAjWLdhryZivTvv
1207	B62qpKBNFBCXaFYFyGNq6PcRJFnkeqt1pBTDv5es1JWy6EFqpDDRWfB
1208	B62qj92oA1YvmddEq3MTSQSMPumQ3PDwhSaUQJQsib6ZFaGpWhwHsKG
1209	B62qjojdRSc4L9z1EpqiHAXgktyzSpL5QTUdJXLHQ4Uaj5hDpScbsMC
1210	B62qpAZLBaYoBqyQ8fqBc1JZgHp1KgAzDPiYeQv9gPpfPFw3hzPdZ24
1211	B62qjNrEEk2fR2T7TjtnFKpQYmZPU9uCNY3Cf5dfcKf2HjzsvPe51k7
1212	B62qoXrSMa8oXoXX1K5rYJuzYNXwQ7wksCgDRya1J57HfcxUdTMb35F
1213	B62qiw6FVYgc41gJJmh7w8CTQH8vd94uVR7L9j88xNrhGvZJ5vS74og
1214	B62qqBvBTSsG368YAxxiHui5KKSd1NYkGjXnCzK6Ud9Spnyp9zoWw7t
1215	B62qrs3r78SahLdnu5RpxNVMY5ZYhkMwmjcsyrXrWbAMMSHjC5U9Eo3
1216	B62qqpnUBrffgQR5YCNUM3L87jLCMJ98oxJxvwkWcBM2efdxjjGgca9
1217	B62qnbYZLVFnvcJQhTUT7moJGfRqKXG2Tu2Ve7jTwZ67xBa56g5pbPe
1218	B62qm2FvPP1X44GPT9cpZSRtmHkNRGWYFapWzeoj4u4XHSm5pNa3iFi
1219	B62qmwy5M5fyZ7BQmu3sh34gzP7nAoQrhqjaQnXd8aRqHHAXk7JQUga
1220	B62qnjNWCVvmLezFUdj3aRCxKp8HNbfbXtU96cWcvNkDTkG1ownsgcZ
1221	B62qnQwyE46zHA8FYGVkuyoDJa1S5sLprfGyNUei2RHs9YU6m954p3U
1222	B62qoZh57V4rNQ3FRv6tD1pc1MKQDmVGwk6R1qnKWNV8H7sygCVC7Gx
1223	B62qnQCf7ccbb8f39jDzKT8kRNq2939EpPaFGpaQ4agUuy5ozytU79a
1224	B62qq2vc7VoZ9vGxze3JfekNZqfJuE4Pc152EsiLYf7xvYBQo57rFJN
1225	B62qiYNLfwY6qLvuKLEAknPH26uTujWagSnDfGVfzsDfk39dmnRRW3D
1226	B62qrnd2kXPYFuVaBEQPApirUvDAGfdswR28XsXK9P5qvAkGkRbxBbV
1227	B62qpUDNRQosRHsfJBsH5MLRkbJ8kRbPUHKQBj8Wu6Z8VUeSRKJT25j
1228	B62qie4xN5VuLntjGz9Fk518D3ExeeDtvhbJcJsSBfTMQZY7sGMDRKr
1229	B62qpdXgX5zgSthWWNGHieRp9oP5R18GS52mfFsCz83tUrb6YgMVQ9B
1230	B62qiTY8rERRoGZwfVDxxRSyFBJCNht61Ct3HpTzfm5754gfPqE5pxx
1231	B62qmdFb6jKiHqzf7h9B2FQsdtdqvJJ8uiWV47YKgJQ6bTAhNWUgGm6
1232	B62qorY2JaxNFKJDSCUUipRSAA9Jha7rw8RzNxj9zRPHsChF8osV1kg
1233	B62qqCh5YcsZgofmiUdHL7GH6SSgKq3xFFafu8B43vE4kBo1ni8qset
1234	B62qoakPjhxKKgXAJ8TPULPP8rQWQFjAcBotfot6Dy89rzsCKUfme95
1235	B62qpVvFhkeTtSSAY7xjWAx4EjQXZsttbNCSdrbPsf9gcuD1JqbRiew
1236	B62qmAAFyvjEEdogSJAU5kxnp4ckdfL8ymcBmg7S8KmtVAaMMXbWGbi
1237	B62qkjmv4ZLSL1nDp3EhHqTvsey8qk8UVb6pjERkhSA1JtrRihqw5nF
1238	B62qppXNdhrxsDKu6bLguRAzrAWaEUYzPZeFrbXAwtGuz3Jb4sHMXMz
1239	B62qkam5V7xGsozwyR3EJoHQzGF9oMrWVryPsyzkYYfeDbg5kEWdpQC
1240	B62qrrLTwkCgPNmVqiAnjjkwfu2CxzQh8dgxH8Xp2TdwjpdsFQqX1i5
1241	B62qjTastRs5hDSMrFvic4sTxKdiQ9Dr72MSg1DnSVpZitcyGg1uVcK
1242	B62qj9YhQjWNN38P4AYCxABa7bYziNA8xoLQVDoSM5ouNhfksQSZrTV
1243	B62qiyrmLzu2Ad316mrmG1zw3wTfAQ2ZaTxA2JTb27kAQHmP1hjvAQW
1244	B62qnXpiGdQQ6athywiijFWVesiFZdPw57Wbty4CfFPhr96NLooSKSK
1245	B62qrKpENNvYAz1CJZbkBTkJGN1WGnbYPRgLN1aPXUPSEcHVfzrEJYK
1246	B62qn1svyav77n4ZvEc5uo1oHBaVVXbcV4vML6pgML2mnSi1VCQQN7f
1247	B62qnZ8ngDoptzYHQSoEMYjefhcnmSPBdEEnAzeztndLELwQQmjKrUK
1248	B62qqntBBqvFYWPJibxQcY8GQ8d5HKvshegCyyioaLcHAAkNT3DeXvC
1249	B62qmLunRmJHYE1N7B1xACrwoYcazR19uFSGLij2xGUqfyEhTQno1ax
1250	B62qm9rEzibmu1XJTn2CceCJhSzzT3nK6FGHkyEhuNUsRkJsCgYnqaz
1251	B62qpPQiXis4sTGj1vHqtwJvRhVWXLZtDBem8bXJBFGUr9nS3CV12Bd
1252	B62qkaxz722NcaLjv5VRihiEQrLGbn7CJMdZe2AKut5mLx1UKRhdMEW
1253	B62qmPGYt6QM5SNTmTfFM4JtQXhdEnMpo9joAe9vsEV1ipSU2t4BP9H
1254	B62qkDDA62kx6nVUJyGh9nuz86wmYHASu71dnrmeBMd99EowgJ9ZRFK
1255	B62qs2A9uHKFAA1AQPv113dReKHduJfQ3Pg3WDyUMYQmgk6pYBYGTfS
1256	B62qqLmbqTN7FkEs8dP2K7gX5pDUHJcwfEeEDdfziXowCrnyqpYEhwM
1257	B62qqvoG1UMgx2rvwBwFX5bGQmt4zLhcfBLB54Gf6YMbhDi2XzzqfMo
1258	B62qryctc7Uq5cq3S3HQfLM98tPzBVU52eF2PpxEYyEoHxDtoBGSs3Y
1259	B62qprdWQZJDnhBmWeSE8TNqSZYV9oYRR6YKwvabSDPJuZGD62gmu32
1260	B62qoGGexxYTFQ2A1BurUMJQAEF1ZbzxtJ84iVCooRTn8Hd4q48MPcP
1261	B62qjxgReuj5FKdrMw3i7d9A4yjwTvu8mr9roy9f6AUAt1orHEArLhC
1262	B62qnGgJ1AmXjzdSWH2327MFSAWKPuB76L7yk5cRqNS3WC5BdiiyLuH
1263	B62qpn33ywugMMhgCfMz13JHotUtq1XJme426v1Ud7DatcRrKXQgGdp
1264	B62qoGveNQGfVkAjvZyjAdQTddvdKVFuS49dndZMzBZLG84jYuLBV7s
1265	B62qp4sJA9R2E7pqCKf4LaC2UrWVrKXAWcdiNZwofZh3XqFFZs3MVFe
1266	B62qkPLhMSTJ3GXa6urmWQZf4pr3387k8cUsLdhDqtcPRiiLZbV8uCs
1267	B62qre4CXp2S1DDnzPdULW8Z8qbLyyNvYYm6jKmKHQmFRDf8rAtm11X
1268	B62qmFMKE2uti9wcEfR5nNAr49x6QeeV2nhZwHAYsFXr53GDqT6faNo
1269	B62qrmRJosdwWKwFXjfLEA7fNaPDkAiSkGmGDLiPQkphCcnC7agyYEZ
1270	B62qjWT9QQ9LGZoLqLoAXjefPKmLFXd9hQgEt4wUrR1Xmqy5oJns7ts
1271	B62qpziYULs5tfkWNdkHcDXd4UL4WCSXwfuDh3pwMFHzmMoGXwUfpbb
1272	B62qri1DwUjHPGLc6XHR6VS7TZE34A91RYQHkH8KocpjJUMRRc8MUhW
1273	B62qpXyX1z8kE8pvJgfDoSsY7r8yimEqWzvvSEw9putVG4TjFrdATZT
1274	B62qmEcfvLuJYd625PHZUov3RiMEt7Mayed7ywkXoByCANpGPWVnCLF
1275	B62qnJfcBL26QpmiTeMx5p2m2zzyJi6CfBnqLbsBRfxqE9zxZFR3sB5
1276	B62qmsYXFNNE565yv7bEMPsPnpRCsMErf7J2v5jMnuKQ1jgwZS8BzXS
1277	B62qkpvmmCAXozUrhGaEXm5GMVtsGb3jaBPjTtVEcNThz3QjxZFqneo
1278	B62qk87jq51vzPGrwafSpPczAYGZJii46PQx362AbqYcDAtG33DJVgS
1279	B62qknFbTU4AAg5htLM8Jm3UmodeZmNQUD18Gh5ZPCpN6w41xhPt1PR
1280	B62qm2wh99cMx3U94SnNKPCo6yPnZM49A2J6ad9i3HX2o5TucVZJEGq
1281	B62qiWMgGFfnWnNS2XvCJhxmaLHvWnHBXr4EK3MopXKzutq4Uu34QXB
1282	B62qkNm8jmhLKWhP5Qr5LL1RtzRz54rhZjdLxCX1nxcgzs6EB21jrdV
1283	B62qmDJvagQNBeQnr4D23Wa68tZJG2qniicGNTEaNuv9tm1ghxJpUYa
1284	B62qkSXoeyA5TxWqb8CFyrBf2yYDwRssGYxpuYzUJSL3ttDgpxDobLs
1285	B62qq9vZuW32TxPcWysNkYdDgFFfoLoNBFhdNsHU8ZzgLToYAbFFYxs
1286	B62qox5t2dmZD2DbUfHLZqgCepqLAryyCqKx58WJHGhGEkgcnm9eFti
1287	B62qp2ZguTDrd4zqZQLCS5ZShQQNgWwAGBn3kbcgjLX9mqtP37aTpGm
1288	B62qr1H1V6usV2pVMP7L5sUzFxFyAfNnXWzGVmwZj2puLdNW68fwEES
1289	B62qmUcnbr7qd6UDdVnZutKPFagDQDyEB7NTbEFJTV2GZvWquyMgoQq
1290	B62qkw8jyHCeBhWDpGXVw9yKpm9BxBSWWqVBWyh4XTHoea8kayfKhzp
1291	B62qiap2uo2Kt8RzoupS8jqCvAKiUZZmiXZUJM9gpmc1zq8KdFtKnYb
1292	B62qnPcQT5LEny2S7LoHpPxQvKfo3Ua15PkQ4tUP3CSteXZ5yiqaP37
1293	B62qqYKsXdpf96KhFvJpeHwDCNE5iUZqcPtxca3WxL5HZQ2HyTj2g6K
1294	B62qqttd6WJbThh7wFrQThWt4PCNKWnAyrXz2Mek6hwz2aT2k74NzDE
1295	B62qr4TM91FYFCk4XqLsgaHrmaNrc5FojZhWbssRsmkGT5zycZhhyUY
1296	B62qpaGDCfgmrUhDGQcdzRGCtCcUukU8bptsDp96fdovy68HnXeg2dw
1297	B62qoBFvWZADREXjtmGvDyyeginMBNv9W68wFZkwD5pfbphjyfo7MMP
1298	B62qkVsDvq1wNSwwi5ic3UN9zxUekQizbXCccoCxxTAJUWJFDCPdN63
1299	B62qjGWAiMSeL4HqeWozmHuVKjhP5ky2iWKv934SeG53jTESBJgg4nb
1300	B62qjtd2hibm2T4oi8yqVtZVt9LZi4KvH1CQX8eArTmJumjpZVogMJ6
1301	B62qpaoBemteDmFY1Usjj1PQUnerArwa2bdpqMednXbuD4aHT1ryHCe
1302	B62qpG8jpefptAeT9en6WoPzaW312rMJLwoL8pRmqcS8FCKiixRjofg
1303	B62qo8J84nSRhYcZshZGDtewgb7R1PyLz9J28PFm8B9ovfh7vu1fE7N
1304	B62qku2Fq2gbLmFPi1JxWxEb5QvX4Qy5bwxuiSG2BoTRgz8MQKEpAUt
1305	B62qmSy1QA6Qbg6Pi9KwudDLFduUGt9dEFkMVuqJwzcherG2fosok6Y
1306	B62qo3N2wRdhBsCqgGYJ83Pbhei9cEvMGrUL9zr6NNbbMq6wiu2jHma
1307	B62qnwLbBcpuP1xFPa9rZte2mYAKLijUtxnhBqNh3fxDifKQj3T3JYD
1308	B62qqMrZUfkMKB8d3i3Wiu8CJzTaFFk84um32QfwuEG6odySYy8D74B
1309	B62qpYri5rQK1u5sjVSh9kNbDRr1AbHNsEQTGd1bEg44UJKByLCPnuX
1310	B62qpXM7C7RW2PsdJz8EEYbGqTXhPvVW9RQQ11Ctc7wY8DbhAjyJJGT
1311	B62qkH5oH847YezFUPiPNq7LbMaNDpZ5SBp7Wp3maPU8DaejgCG9V88
1312	B62qmKY7C4nK2rnjQJcxMFJH9fpPkuAZxUL8opGzqKPrZnrnaH14hd7
1313	B62qpB8GXzKSK4ASmHkpMS8UpvyRB3FbMo8Mjhpzs6SPXaEtGnv5Qti
1314	B62qmq98UH2tX9NiDw2AZP5aGiwKfxLnVTkRcozgbRZ3opPSPkuXvqE
1315	B62qp3kfaMpfr2TB1UizLUBv54BELBovJJWjXjVMfFiJfY7AuEZm6yV
1316	B62qjk4cMyZCGhftrDZh1tQK9w7c86bQ8m7hRULumwhpC95Tz4HaaiY
1317	B62qkV6HMEh7SYKuLzdpCpx9syw9VDVNGR5SBWVTbQJV9bwWZ96iP8u
1318	B62qipscEVdb7J3U8ig46wgxc5jVtaqnHrCQLnnvkthYLFiw4MPvQxY
1319	B62qobGqxagMKDMP2UiKCHWj2dZovDyBtdDiYYiYGSg6TQ8Rxw5fXBj
1320	B62qiv5rWc3VMyMUP8yc1BN7KZFT3MH6TUrRVMHUZkwveYTiK3YnxfJ
1321	B62qmurvwu5wPC4X29DGAnTTys7CXpca3qTkJKw3qh2F2PmdCFkVcQ5
1322	B62qnEjHVb5sFE8Uh8TXs3z7vjdsFr5B63in8kkBkCp5uA27qtiiYCf
1323	B62qkR9hUHJVXxitqdVAF6bgefB2iCAXqMsudA75mSr4VMY6JSEGLJe
1324	B62qjzN25D39t1RRCZe48NuhcmHXGg3t3ZSDUm1K7tZ9cBvkdULmhRv
1325	B62qjq7vHyZM1YdZsQo9C3oW2QfdP1494iYD2Hs3uB5DSqGbk68vgCc
1326	B62qrxHA9WaYLMCMmq89Knh6kbm1uDX99zD2U6DvVAH3JEXYqy6eQuQ
1327	B62qqFY2G32WGjvu4hDDHFzXgJbdvCbQQmFjraPnch4uMW6eFX7qvLe
1328	B62qq99djC5HtNVdiBFZ3UN9a1Tn6THZJUcckEtAJon7jJzQMKDU61G
1329	B62qjKzYp37w9XyFea8TA87bGNK1yXRsrZxNJqir2WTorTHMD9Jkh46
1330	B62qrjUz973gGZEpJwqQJ6MiwWscqx8k7fwiezoEdU7VBnGQ9M23QPU
1331	B62qqWHppuoryyeeigDZu8tU3xbse2sut7o7ar2vh2X6XUnfaDn6yph
1332	B62qiiuXuFzqpRaywDot8irDtZcWK1PY7wBsxHn8jPzqHGMCz6C7M2J
1333	B62qqSHhnQr8mnbZmMnwgPfQT4PZTH9xupA5a6uRKt1Zdf8nRx2U5kF
1334	B62qmQ8943HETz4i2PFsc9EYyNAVrtFYJPAR6QMjCk9hT3DPgQmNgJ7
1335	B62qqLFzJe6GjhBzVmpm4VHvFWwFk4n4F5Ci3h4DHVQgfJvkWoe9sYv
1336	B62qnL1ks6vwcqdaAUSXrgGEy22kZDoKZRFs2NhkT7SuKMzevnCZUVG
1337	B62qjpFbzR6FX2YJzsUcimJCTjMsozchBAyrDgBGUZnmEwCAj5zciYn
1338	B62qq8aDzB7JSJvK4fKAKZpMfeNBkVVdgLW256cFDEWxws2gdCap6Vt
1339	B62qjfpVTExVXjaCDEkK5un2qUWxE7QhD1SiYzMW6SED28WDfXsoDi8
1340	B62qpxwBDbjGQtQHdjBX6SkdM4BvcoS6F1U6hrRa81M4acLoNPMkjYT
1341	B62qo6JMHe2uf5Cf8vQeLRFdufJYxNq3XHW7rRuTVriKNTpWpEkbpok
1342	B62qkcf3fkdzyw4D7GoMVwcEbYyoV2xd32iYfcK8iLWs1o9UD9oHyQ1
1343	B62qpFfHEARyRrdFLowd7GSkw2KTnZBZS8zWkpFMDxAy7X6Y86VGU4a
1344	B62qpoonGkkt3p5B7YqiuaVD4tr1LSoktxLxQd5UmWrPv6qbZ2JvQgv
1345	B62qjduxMjec8JnUk2P5sjLWtxuabDPFvyrbgwvNZ6Vg2T61ZB6sa5g
1346	B62qpxNPYzKkCiXKN7UNTx5MG1Vaf69YMFBmzFCU8r6YwVpbLrqBp3V
1347	B62qjGio44RPhEjYx1btYmPhAnXjromtx3NgTdAchx9BuaVyT4tQieJ
1348	B62qrQwEGGVZszUG5taKCYxdM1yf9sQLiSzNtur3u5hJ53osezWP7V9
1349	B62qkHHBnLpwcg1u4jgajoUUoSXHxMFEfZ9ji3JRbzftY6gTmuYZAxH
1350	B62qnhrUFMCj5n5yiPuXcQYqKh9d22ZWMW9LNxGdF1FkhqAT3B8KmgQ
1351	B62qojV8copSeupvVFup3Etn5cHWkTghYkSDjYzrge2oXQNc1y69jj1
1352	B62qo9nA6D6qXLYC8NP6YonkfaaFHufaa19MJvCNL5vEikJ89WtQ2ZR
1353	B62qjkhkXBPRuQ8eLEvoXzEHegQm7LoRSF1CksjYKU8Vgnzq5qZh2S7
1354	B62qpZ5o59hbZ7oMhTSiNBj1cz4J5SsuHa6hbsgtXsbudFiDsAVrbzz
1355	B62qrtz4HcUf5M1DY1CPyGcRsKmrusriSKEzZtVXJGKCtWPX9AmsMxw
1356	B62qniRCXGwymuWvRKe2WBWNVrx9ht8eZrQNCzGdtW4N7Fqj6iUfNqJ
1357	B62qkRewwZc4NgtjBS4HwQTfLt7t4cSCaBhZ3Y8TQAgHhpWZpKuYxA3
1358	B62qmbZejY2rjWcX4nnk1Nsatx1JnTybwTPTzCBNXkgewtm9VVZR6DD
1359	B62qimSXq2Jp9Fx8HGg3nStk5UCAQNKhpbB8M8QR787RRmpHKGqgZ3P
1360	B62qj6WR4x3YBiqq6mXwxEtg4EWYJ2ELzvWe9bZuuQ1m6sCpjNv68rH
1361	B62qnyqqC5NCsFMRRYyKkhwqpxcmCLUSmpsM9vGQhFRU55Dosnt4ryH
1362	B62qrYQpG9xQxD78Jd9BJfNRYx9xmrcZSnCgY4gC5aRr84hQo725NCJ
1363	B62qmKJxgh6h4i56hTXmkDL2Xpesm94NNm2Ev4ySSA4rCE2Z3JbfZhc
1364	B62qnYqMnurSMbTWdD2BkeQLudy1RMm3eRc7DeBuG8QykyJ8gZ8Gdv4
1365	B62qo5AuWQrpYPUckr6snpnUm2TJxPjMN1wBcJznJH1dzYmhbHsbj9A
1366	B62qkVvzN5z28sYfyr5TzrMhH9qTsnNQLttjpJjzSTswNUZgrWkjbZR
1367	B62qohPAx6tKFDmVTLGepyruaJNjwA2k1mfnhBbQ8Tu6BeH6Rts99jn
1368	B62qiUXwV5V9ptLxcEerkYr3kY9EGmhJZUb1h3ro45BGgForJSSmknZ
1369	B62qodkoaX7oEbwfeCYfC7MrWCLgD6w5f1HXcWa51RZNk1Sf68w3x8i
1370	B62qpDQHkdbMPvWzHgUcrxtJXNsuEg7tpCL9irDMNZngAJJR6Vsnv9T
1371	B62qoNcRg1LV4JqCJ64NWLwPsThRg7GJJQgvBiPAWuMnLDCUXigXV6d
1372	B62qjrMUVbWBQSPL8BgiJe7QQJ6RvtBSckxeBGt4C1YpHdHcTGjEgj1
1373	B62qpsKUHUnJfmEBWiAQLevw9dec5fy11oeoDYvRVrRjrJkjovrVDWy
1374	B62qimoHcDpJQk7onuWv9kco61Uyg2qTridyS3XMsp6DMKAxRq9uLa4
1375	B62qnQ1RWPv6Zu8W1XUSP5tKuxAQPaHaZY4MdTRt6KGZzgvEquz7yxK
1376	B62qrd6hgek7MF3qEb9AbZp9Cjmsd58xSCB1J2but4F1vmsgeQ25N2e
1377	B62qjc2RhgiL8WQomzjsWkwKstX78Fvkwp8q4HLgRvM2tVvxc7nxLvj
1378	B62qkYD9MA3T64UQ3aibcuZyWYh9M5AvWScjhTjxZ5viuY5N6wrG4Cj
1379	B62qig8xJD2GVHzJM1ChEXXMUNYwoUz62TY4CPTv8sf6MCDqgz5Wt9s
1380	B62qpTmo9FwpqAdRGJgQY1kuoSahVc6HwPyPQy9BRYmZL7G2HepTAt1
1381	B62qq2sBv1DpDtFueYmcxw4QP6i7ykKJ8eMQvHHMLxM2D9nh49bxLok
1382	B62qrnhMZtiz2P5AFEjyS8XTn5mQfJLFRQ9NkZTJhDZTAi9ERDDHv9S
1383	B62qmZFJN86FaPewT225BQUytfvncvJ8kwbF4zjbQHvXoa6o5YeSykt
1384	B62qqL6fuqFgufJJ6xU6waiJw1xEQugPsBJR6zhVHLtZ9Hp7R3BriTF
1385	B62qmT7Kd5rSF4kW48L9xnoXTUwW35VhsCS4wKitBHMRCmvywYE7iy4
1386	B62qqqbrKMm1aF2pgeg4YcnCuYTahsR4eMhfbL74fZmo1f27Bhi64hL
1387	B62qk9RQQsLpE1i1CJjkN6SuoRefXg5X17kqvvZV2UMysW4hr9CCoFw
1388	B62qqUPRmvN4SdX2XAa9z1amQJjC5apzwtmwweqVWFxKFHLTf9b4HVW
1389	B62qrFTdexNZeedkMCGSEUDtc14atEyevSj6Bzix1UUacaXmiKLsggw
1390	B62qpFjUdtZSGzXa6pYJuSv1R5vxJPorZLPgui8Gfg4YPrYEeL5pyz3
1391	B62qiydA5hjPMZ8wm7WkmZvcJWGio1A3X91Cu7PDP6WqqipQXEZu1gH
1392	B62qqNHRcLYT3HvUHyQ972BeaZi9Nm4GCRWj4uUbB9iAHhc7ZXiBmFC
1393	B62qpbZkvpHZ1a5nsTbANuRtrdw4YraTyA4nvJDm6HpP1YMC9QStxX3
1394	B62qrusueb8gq1RbZWyZG9EN1eCKjbByTQ39fgiGigkvg7nJR3VdGwX
1395	B62qq8sm8HemutQiT6VuDKNWKLAi1Tvz1jrnttVajpL8zdaXMq6M9gu
1396	B62qopHVr6nGCsQgrvsBsoxDm1E5CEdMkDSN3jneRnxKpR5iiXnTbas
1397	B62qre3erTHfzQckNuibViWQGyyKwZseztqrjPZBv6SQF384Rg6ESAy
1398	B62qoiM41U5gBnjujQRgeewfkK9VmgVT8ifrRRwAsqBUM6pdxi9ywk2
1399	B62qkJJpeGWtxZtJQFXSrM3h8TXMfNNNuG8g5mLaqU22HfWQBNENe8Q
1400	B62qmM3q3Lzur1LyRy9zaw5C2KWQGqpv5epRHFz4t9C9ZNJGZEhAY6D
1401	B62qp8Vq6n4VHq1LUm9Wd5QKjpKb7umoZ2oU9gpJYuHNUc7t2HGhGUA
1402	B62qmFf6UZn2sg3j8bYLGmMinzS2FHX6hDM71nFxAfMhvh4hnGBtkBD
1403	B62qjCuPisQjLW7YkB22BR9KieSmUZTyApftqxsAuB3U21r3vj1YnaG
1404	B62qjYbjZC7DBP78LheCLjD8WRWxku6YzqarNVK2er6t8SQfXyk1ybc
1405	B62qrecVjpoZ4Re3a5arN6gXZ6orhmj1enUtA887XdG5mtZfdUbBUh4
1406	B62qqhURJQo3CvWC3WFo9LhUhtcaJWLBcJsaA3DXaU2GH5KgXujZiwB
1407	B62qrxNgwAdhGYZv1BXQRt2HgopUceFyrtXZMikwsuaHu5FigRJjhwY
1408	B62qndKKWw8NwfxbiQBu9u2hrDr2bRZtULC9zNs9R7SC9k47yGZQZ2d
1409	B62qqvSxj9WncbMkekiXKZscTkJFdLdEDJm2xQGQapDhmDJBXBBGBcc
1410	B62qrg5t4eAupYCF8d3TzVn3rooxCWF7bWySVmnyytjGTPT8ttLMAxH
1411	B62qnxC2WR7YbTg2sDpYudYTyPPJKHDy4PTNEF1DKHJ2Pw6E9YhKciR
1412	B62qpTdEzGyefcZduxfHQxLpvBUqVbxMGDjJA32nRN26UquTxPostRp
1413	B62qruGXezzHqV49J5e3qWfcpcugpP2x4Zi3cGQdCe6txLnLubJTaM3
1414	B62qrgdEGEKerCmJsAdPC8WyfLP9p5JtCboQmv8b6p2xQ2hRZYgFwQ5
1415	B62qijk9NLY7cqcCBA383RqqB52kPF5C7eeZp2NoFmJHZkndD9SRwSV
1416	B62qqXAGfDrLyEfz11N3DrFdHojimo2Hy3g9uUcSsPe7VCJscaJrS85
1417	B62qmFGqsBsaqfYGshobBGeGGYGgB2SjcoxVZZnLRQJdUPZdMvGaYRe
1418	B62qrV1D1bezpJjYrQkWc1QvmWwyATtmuhT5AEeKL9heLztnLbM4GFi
1419	B62qs2Lw5WZNSjd8eHBUZXFYyRjV8oKtrZMFDn1S1Ye62G71xCQJMYM
1420	B62qr9jmNyuKG9Zhi1jENgPuswFRRDrkin3tP6D76qx8HNpjke5aUMs
1421	B62qpZTtpZL7QobzPX97h1f2CNFchXoXc4NJUZL1xdvNqTdwR5NCbkZ
1422	B62qjBpH4zeWgy4d4p59qUXDA3DtYeCyBrRM286sdXZFw4A8SiswfBh
1423	B62qqch9XkiTS8BLUDSM1sayfXNAtnYnQFChktYG1bfCJkDMUqs98Xr
1424	B62qj1B9sNZf8cm44qk8v7LRAYyUVVPeqrMF5ETmdQ5grZ8NM9ingCx
1425	B62qjXTW7dMAWwRTnJD4U8HwN4ii5t17UnGANbhtzenJTBWSDESbQEw
1426	B62qq6FzjoX7GCqDY9aUP7eFm9QdqHpFJ8Aa5xB1YLj9GuPtsvG6Mp8
1427	B62qqc3eKfNYpdRByoN4V3BTjoPRgacLrqtx4WkBQgnVcQ1MHSWTyWL
1428	B62qne38nSn1gwHkAn9vPN5SZntgXg3cM5pfuad1zQxFRuvAQmKkGTi
1429	B62qpwXadr3bwPsV5M7NSTZUGRaED3FPy4Ju517PqTZWWfjS8h2dy9K
1430	B62qrvWNDUE6HraKjMNFDEZ8eYYaiTCF75CVNUXMsL7DTs4DYjfsmEe
1431	B62qqzq7hnj6Bm3pG5PG7ugGrTKaNCa3XBuU6yDV1XmqBffpyb8s64i
1432	B62qngGSkaZCutEntH6Qu7V2g7waodEDfjars9VRf591oAxvpUW9Mzd
1433	B62qnU9faP18C3nQVwGNxreapkp65v11j6JHQVMgZWtEMJcQW4x1HsR
1434	B62qiZi62RK552P54BGEb7saNF5mSVRCFcxULPvGVi64KudP1s7TSm6
1435	B62qooTeMvVnDWWMQW7wdDmpEm9ZRpre4fTYwr5JZE1yN7sBLERbMyY
1436	B62qnGLiPNy2WEC2QRxJq4neyPKScUnQNEV4pRaMgYkgf8PcCKb55y7
1437	B62qrRVMpryecmWaStfobX2dxRLuWxsbd54jfjZm9DAdBycDic8Ef3h
1438	B62qjceYTwKGRigmhy9A1sPZYsvgAxSYmVfkgqC1jUkbpLCsoGWHeXX
1439	B62qp7J9DJWb4y9BsXiixdRQLGvouFmrpyiv1fmF2vPSV1tXhWuTiyD
1440	B62qjBsp2zWgyrbaSqVMcduz7A5s1sT63epFUVGFRjCfjCzy3zwSVaq
1441	B62qpaqLZv6tca6KytUsgkBoQxCRc7cMRVkVYCWjyUFGegS9cwD676v
1442	B62qn8JN3sLVja6GLETxWdnma3hXuUP2WfUARkcLfs8jWqW4FbuGuCU
1443	B62qpsMTL1mTaQUQUTQzVM1qvyGTCLVAhr8whJc7tUfmnPEuZnanzUe
1444	B62qiWcbScnq9W9bhk4oLi53fyH5TL8WxzDG5cqMhbz4SUhz66v7izL
1445	B62qpPqw2hzqjtcqpEwvckfsAENgXUxgJGu8y3Z6Fzus7pRH6UaLLp7
1446	B62qoNBu1CV2UFJTvT7gfG5r7c4C5pAuLCw8yf5CSKs3qkswSQa6JFn
1447	B62qj3Gzxgb4G4M8CwZRXZPtmVwGJtGfVXVbpMrACNDSqQLoXzSQ9HW
1448	B62qny4snW5cBovDvVFLSipUMaDiu7xwYMrfbTscDLDne7enKJyGkbh
1449	B62qjWchpjVwmbEazciy3VSBZhJNVF28RcDQirLFpH2rvfmDrtXL382
1450	B62qqTGc21K1mJo9adVuKwRddiUD5cQxocu2BxaahQGfrQzvWBc7UYv
1451	B62qoRsqqfdfDb3s4nTgTVUQGLep77ZcoKjjWoyxspTn4CEbtBknDek
1452	B62qrgnUUduZy2z7zT8qCV8ngTJfSS1rK3Wh22SHUmrse3Tfqvrhx8q
1453	B62qooQD2NzgGaiHHmbdo4C1c8YcQi5uf3ns75p9xfKp2L9FagTiFcP
1454	B62qkueeFHtVMTKbwr13eWEMZmW5gYgeKZiGoAJM1qTs6oxAZKiNJTT
1455	B62qni2bXsMfr4HnT1RSYob5x6Cz2rP1zUr3sKuMSqrqt9jtJR3se4y
1456	B62qnVMHrtGPVRN3SrwyDzjbgBQhaFSgv16SAAFe5ddm2369KKzRn6d
1457	B62qrafvvcSTkGMpFiprxzDN8JXqoiyHSUQwUsKbRqrvTK1khb1HJyC
1458	B62qoJuLTSJt6fqkk2N2yntcPKSEb45C8HWKr24Wi7atzCzgeXjg5oN
1459	B62qk4VDCUCnX1TV7RrmBnSmEM2L415ucaAhyLBJu5xYNZX4Jx3Ksdh
1460	B62qqV16g8s744GHM6Dph1uhW4fggYwyvtDnVSoRUyYqNvTir3Rqqzx
1461	B62qoEAhsEqJLrLUNapSiS4hKXR6N9onXceLy3ma7JBkFznzXWpyPJL
1462	B62qoZHCPoNTozrDqDtj6vjY7MmD9ZEakVMxTR7btNnqjoKzUqp4EKx
1463	B62qkxZba8d9MWL9nXRvMaGJXESxHbkLhfogtqsCXKs8ueSZkhJNboQ
1464	B62qry8iJF3X2icdxsCzFz2qEXPUiu9HkR1wBde93bqgjvFzcRcFnti
1465	B62qmAok3N8kahogApB18ftPKLjezt3ydrHUj7qjxDVCEQ3YMvei4my
1466	B62qjodMvEfFUfs2ciXUekPF3f4ePhH3uRfwoRssh5hWF1Mr8xHjeEF
1467	B62qqKCmTdo7JJS6hP2YsiMoXvkpo7rcK6EsxBns3etbQytnoY8b49C
1468	B62qkfis9ADewoBbMAsdGaswbNUhAbbjJw91jxjH38aUriQv2dKL4xy
1469	B62qrgTTdsWFGQoPUFgKn64wX43ycCPuBFbf73M4oHJYHJfef7dvdhY
1470	B62qpe129AcY7gPkiNdStKxNtwQC9Y2ZyZCMKGKn6taZGCdTdBtuBYR
1471	B62qnMmqkKptkyQPvYmCAAEnbNxjjRkpFZJSJLBgAuDL2bURwZgXe55
1472	B62qm5ESJuFWe5JypXPQMyuw2BzkVXGHFgNBgeuvBnfiLKRaqYRW6rX
1473	B62qp6HmxzW5XXwCMiyZiJREoJ4b7omkNuCJiThVLNM1P3u1s1a3qzp
1474	B62qmMkbajiY3bdVRjv5bx3yxjp5sBHHQuu8M11sDdjtBy5VdgWdgTr
1475	B62qmPfsVAZ1bFqNM6KAKZ4LmMmyxoN6FhHyMdwSusZV891yvQachZu
1476	B62qpL4ZdJw8dmaD3DJQvKG4Ewt82va36rYK7BkkKs2SnkxzVZR5oBk
1477	B62qnYBehkVZzgJBCC5yhFyF2L7mMRPsVnKW2xpcWFVuQYRVgoqwDCS
1478	B62qjBxeuwxjcC2XRqw6YQnC5BHt8v7H6LS25iW6D4CKFwGYvCVqTXq
1479	B62qj5W8VBtyVC9j5cgGC3NTXGnQzZt5VYBCc7kMC3jDYciuiXYAngW
1480	B62qj4b3yw7bqZd2AKqYFedyL6sx4fF6GgCkzG7QWz394nPMN4EKLv1
1481	B62qrLt9obuWhsVgUsrFyC7AzQXfrsPzYtDrDZi9TJ8cvv2oDPVUZsn
1482	B62qoazqR1ag2hDwjkSSm6qV3eJtkiPvVPKhfVyeea7TehBAWu4dWJ5
1483	B62qpge4uMq4Vv5Rvc8Gw9qSquUYd6xoW1pz7HQkMSHm6h1o7pvLPAN
1484	B62qmHktvgpH1Kbkato9MCWmH4TPKtHWc8DC4FhQCJ5TpuZ8CXazczB
1485	B62qrLf5xV1fdE2RikXzzogaJYhPmWMf75GGSpJSG2yLiE3nM24C2Nd
1486	B62qkCk6fo42qQXowuAuaEjwDhSeJsgw7ZEohNkJacLfeiCikUb5W88
1487	B62qmLRLxC5Fx3cRmHDwKGq6psCbmXAYE1UsS4Z1foqrXCTtJuvTbbL
1488	B62qkXQoFvTuTH7ARfihY8XmsUi5AfCpZgjmeQnf7bj81oTdT4GCsh9
1489	B62qoev8sKidbnw2RmSAJ5w4SFdPvn88UtqvZt8GxHHd3d2P7x2Etgv
1490	B62qidz67vVjRUWi4QWBhE6i6JAs5i55YP1CuRsSNB8CjM4nttrRS4q
1491	B62qouvr8ux8uJcnZ65gLXy9ZkH4qS3a85mBn5kuXATpx6kSdbWfuCq
1492	B62qiYicQcKtuSqdDZwFkaMzMCtkPmmFuaPFy6ufp8MtpG3UsHfe2tH
1493	B62qkkAapgA9T5CqRDNM5X5xPuceWsZNdVYDKc3MgMyBvdjivTLDmvy
1494	B62qkoCsD8drVyoGsd7y31zBPnckxNjhDdiFMh3vHSm9kww82ohpp9s
1495	B62qrC14RL5ASE2Ep6sWmP7mb3dfTWy3AyFJYAduxDnjYYVFiPME7wk
1496	B62qpuNrv6pWhSyvkh3mCQQw2WcjEVRFnyGJGcw8QBZ7BexRCmgR8vw
1497	B62qojbGyQY7zXAwezuZWw5HUAEdsF5JnMeCYZEB33uvUzpenuTQCSe
1498	B62qmM9KDeqvu3TVpQStGJARgg7KppxE8UF3xMdtKV9TDc33kSUGug5
1499	B62qrx22PmRx6jXfvrS4amPCGR22KX6SB7NXvFLTuw9eDZYgVtymid2
1500	B62qik2auL1VbkX6fijdzwT6fGgjpi8caKUH6vbov573DbdT2UbQkDp
1501	B62qkDxbJZ1g7iER3Pv4Gid19m63wp5DKs7Jz7ELxVerWqWeBwrr2dT
1502	B62qqhZioGPLYePnwCFUqQd7WoHu3TTmZVAvwoh61xnC6VcWNqLMsCp
1503	B62qoTASPAqsxJb1kmDZtYhxRAuuegWG1WhzkxqmZVD3BmKLenPa3hx
1504	B62qkZuTU66fez9p4qwx2E68zggQ26etV6WDcnSx1vizfaLt3Xu4ST3
1505	B62qkG8Z6EVvYEZCPcvtNTTguKLnYk8fSduR5q4sTvasCB5k9bqpDW1
1506	B62qjWwDxk5nGMXN32ffuMpMSp3wPa7BLB3AXHH5EYiczcRxDTF9uP4
1507	B62qkxMXa9JorkHdS1iinLn5WwMV4dgn3HT63osBoFgQHYoah1MdzKw
1508	B62qocWXdgZV7hC7bDVbLvM2fAKZTFjVoqVP3ppJhpgeUV37Qem4PSs
1509	B62qj3fTBMfpJvoHTXPiKymxQcHH674jynkqsRjUw1bR12t2VCrW8ch
1510	B62qmgmWNyKRJz6m1h5EnEPSZqiUf4HNHWaPsH8XEUVs9whBo4okwyQ
1511	B62qriV8kQ9FzSRuFPXAjtZx8JcBhY5gmYkFd8VUxPVVSBpSb92V7T9
1512	B62qnUwCFGxywYr6rxq9Zgktbm3Jc5hdTChnwbjM2goJ4XLctZXWwp9
1513	B62qpAmXkj3fPExD9ASLbARWBos7taNoviawGnAeQWgCvNNnvj9Bn4D
1514	B62qnR2AHmcnyb7v3cVvuZWriEnArx7yMkXBcnzpFQXCmGxAAv4nJSV
1515	B62qs2P91UjdhngetBJ57C56HQ8t5V7ECAYWBvpkaC45ovXNgnzqfG6
1516	B62qmXMMTUuKDEwY4THkgX6fvDtujGNP3FMdiaWwSHkMsMM9NzwPXZ1
1517	B62qkd9DEVB4G5AxN2siEXVCgs6VFigNCecmU4gTizTber4hHexwid1
1518	B62qnvKLdq3j46nuQML7govR1gNqfBjHtv86FzmfrAU9NPGd9BSzooh
1519	B62qicXxuEer88smMkN4gPx7WdsUf4dNGh3QjfprXtB1dPs9ZARY1ba
1520	B62qqYv3jnSjWGihWqqiX482rkPJ4MyXDtGF8Uz2zh4UewKapdHod1P
1521	B62qq5YxMfnoC9trqNzXDrM46zheg4Jq7qv9WBUtrqMYedgtCP67XCz
1522	B62qp17siioFbT7ugFCJwtfcSn9SHFsBNAkUAxKjaFtorKqQ2Z46L1G
1523	B62qnSUbgFfPTsZGPhFU9hEy4PerBLCHVcTCYthU7BUN75nHiZQPg6r
1524	B62qnMTo6ii49AJa83i3i2WeG3bJN6WHDYh9K7BvKb42aQHC3Pibvxp
1525	B62qjPDyavWQPQEPE4V1kZo34gvffu1wU76XLrVuUSRMyDvrHxEPMf4
1526	B62qksN97EtNvQGzH2RAgnDR8zLAawhPNE1QzWCgPRcknyL6NJ3CCgJ
1527	B62qkBqSkXgkirtU3n8HJ9YgwHh3vUD6kGJ5ZRkQYGNPeL5xYL2tL1L
1528	B62qj2tZS6SxPMfzFAvVxR6ZMfryVotdhMUwPx1C3EAhgqFEJAAqUXX
1529	B62qrGX6VyP6BmGAMYzrvhyq12JDuCQHpuumme2St5K5nWgPiFKhwMS
1530	B62qrL6Pps4zCkefxTemCQMHyHKYRZ7DiAR8AxLrzhAwaAyJ6mqYocT
1531	B62qn9Xw7796dqjdmPRxzj9BHKjUwtGwovYpWXZ4EsSADVJrBee2pxd
1532	B62qr33YrdZWpUw6eeLji4nKB97VgADHekHjyCmb9oGDrashXMPawWG
1533	B62qphpEdBwSycpN67XFjcXSEY9j18chmttFTXYerhTPMX4JkXubWkd
1534	B62qjhiEXP45KEk8Fch4FnYJQ7UMMfiR3hq9ZeMUZ8ia3MbfEteSYDg
1535	B62qmPATxsWneeArMm7h2JU5og1vJafP9Qt5VFmMunnGZVR2DTC6ztM
1536	B62qipnm2igSVxVw6mqSdhU55kwwXDdE7mbh6FSiDj2zQFKhQ8iezwe
1537	B62qob1tGxx1BhychEzzah7yvdbRH3E7SNSTrEtkuSZzR2UBezMChg2
1538	B62qqhHs5hGXumEBYSAbKvC5edPKT6aUzf6XFRsANWq1XHwpJguYosx
1539	B62qs2JDc3nv4LPr4sW5oW3eAicxp4T6EQbGesAoJrcaoeEiynubHoU
1540	B62qq6ZYPG5JsjZnGJ3pADmRn6hU6qy13EhraTSymjSgyEDwoDR9Gd6
1541	B62qrr1gkgYvVfRb9JjstCcjDTKYYXFM61dD7oqFaEjc5VkFvL8zWgr
1542	B62qn7dN3hhEyqEYLG9Le1KwJpJfcJQXfiBoKiB7sZVrwYvT1NyRfDr
1543	B62qjSytpSK7aEauBprjXDSZwc9ai4YMv9tpmXLQK14Vy941YV36rMz
1544	B62qpZQ7xcNpv6zcY75D2y1V4K1DHXVpkbCJAYpPNHgutXAb6o5QSZE
1545	B62qiariqVhC5xzvUMsvtc3hxNBtsfb34anvrreAQA7t1647dZbyPjo
1546	B62qoG7mge74phWmvLdgMTrewb3Znpkvt3LYbtiKgvhN3v4kjVx1RPc
1547	B62qrW1cezZ24Dn7DMdb7WPVVpCcE4s9BhYDDz49rWyVeMinHb18bg8
1548	B62qoo7juS8X4i59TJ2iV4p7ogHqBwwuMC9VfsQFSNjZgZpNmGw58dJ
1549	B62qoKueAUixdjxSokbUN6LeKRZoXMHEhU6nD1zpZ5EDh7zNTaDQeNK
1550	B62qnxHx2ZXjZut1BnpCRiLinjQxH6yLgwGgB5VyuQYWdeum9p3kE3b
1551	B62qrE1TgV5jegA2rn32gi7FkHbFSvo2xRxKwhYykAiAsLy7ib7Uwnc
1552	B62qn1jcWzM2h1f2HjLku6hjS5dAJ4pgjRaV3PzEHBbPTNtqKafsdhR
1553	B62qjJ2eGwj1mmB6XThCV2m9JxUqJGXLqwyirxTbzBanzs2ThazD1Gy
1554	B62qrPbHUhxVqe17VwkzTyUmEsFwVry8geJEb7zfBVa8kocYAs2j4nn
1555	B62qoi7wVz5NDCYa37usdATKcvMVcbtXYLjn3KiELXSEsG7XcbifC3q
1556	B62qnFs1Hb4TQdDFMrm3LaS6e6dxfXPTXH3WpjyiQQxuRvVtBiZ2fx8
1557	B62qm2o16xqCCqV5vkfqYEHNNqFSsMx6VK835H8uszpd78bnsTbvQHV
1558	B62qpM6uZJgwBf6ahjkYNMD5aJEt3LBHe3wRkNHD5LoxR5EHPKV9zwN
1559	B62qrQBarKiVK11xP943pMQxnmNrfYpT7hskHLWdFXbx2K1E9wR1Vdy
1560	B62qrQiw9JhUumq457sMxicgQ94Z1WD9JChzJu19kBE8Szb5T8tcUAC
1561	B62qqEbM64qqDsLzefbkavB3RJWy3oZUbZ9HikqCKRBTvqbsbR53ogD
1562	B62qoySzFYHZ96RZFFc4CRYeh2gp5xF53XxLXJ3XFmnzBxXsd4KRikA
1563	B62qn9aR9hkH43oXtW7mMcvDqvCBwVguCf5QyN89sHmBVuDEkuEg6yE
1564	B62qqPJmQCXeRmjSj7jJPXvgshHVBfbeXmNW2uRBf7pwVsB7pzbcqFH
1565	B62qqaGu2Hz6122My8Ddxj5WPgQd1tVLmXXJioxa7Wm5m5VJPzoZdhc
1566	B62qrF464XvEDcs5yYa6FnZsz1RhW79HQCyvfQLME7w9NDuqrdAgfuD
1567	B62qqvDf19E357mwCfM6fHRhuBTaNcwnKCJbaNE3waGnQ8uNZZPU66g
1568	B62qmrsFZNeW2ReoHpTafy9hy1oNw12UuR1UdGJEUqTuFZ3LPVccDTA
1569	B62qjWrUQMud5mWVPSeMs9t41mrXdWFPfPA23a3nsEbGWBTEiapipqH
1570	B62qozyeUmdsCUP3kCJXNMDwCENUA6SA7ZtnGWiZbSWaB5yeuMVVJF2
1571	B62qrCz3ehCqi8Pn8y3vWC9zYEB9RKsidauv15DeZxhzkxL3bKeba5h
1572	B62qm3iPXvCBATaBTVt4NyWigBX45JvjGqK9PJj2TjdtdLaipUt1Byg
1573	B62qo3iHrCUfCtxQU9hcHT5kehJsQB32fE6JwMAadSMML8Cg4eTPBpe
1574	B62qjeR6fS4Z9dyaNt1UWPh8bHWm4euq5ksKnctfQdwucSzRGh9cFZV
1575	B62qqK6M9q1eE8MNnmeGytCUhgY3nq83hMxstjtcyqiEGuNMTvjNDHW
1576	B62qm4ueLWLDXXfKCuKXL72rwXtiLsWRAKGJXH7jEGPjjbzR41RqVun
1577	B62qpEMj7NwUbeWyyPrPUHtJDqJb1RkPxJtm6JxHrXUKDFMgJYp1zzT
1578	B62qn9vwCUbefEmPsj6g29df18TmAQ2bSthrRFGvWG1jKDEbi2wJT15
1579	B62qjmUyv9D4GQ35RFSDrXjMqgFYW4VtDkuv1q8TnxosPqxSJcbdvzG
1580	B62qipA4mZXjXaKHv6GSakqhjpoAa9wZnAKV5X4HyFyy6vz6aqCNYeD
1581	B62qqE5R5pJDUjPrKZMtTkPKUPL27kwNZ1sHkZaowxSLosZvLudt3kW
1582	B62qoahjAyUBNcXBn8HTb7Rk48sBzfZnjDa592MqjCnMXeWpFkGS6zJ
1583	B62qkXeeeerxc4YMtV8qBki2bTQc5KBZ5CCZk85xsjTBh2iEQ2PJmce
1584	B62qmPxwf3FTtb62toALY6k6q4HiCWJCUGP8xyxpDFsgwhFCnHBEQvp
1585	B62qpdKVxef96UTWaEPEbGQ7FruwCSbEckDHDGtpAQqxUfDmHR725AV
1586	B62qrJreRSCNusj6uYVanrFESuaaBu13Ri44djV6k7HkYNcarKEJBKu
1587	B62qqMU2Es9QPPYj7Vn54aJbbW5gibDZYu38LhGLGSjccSxJRQ5NkuK
1588	B62qkLn4YDsHjoiRus1G2HmUKUutGbQGTVEtRT6NKaB1RRMYCN2d6JM
1589	B62qnTahyoiqVSW9qbqiTBczA7n1wim9d7PYwGxWZP2s6mgwMn9AoGg
1590	B62qnR6HKx34NCyDkSeRcJ44KATjUCs4xmQYDbwTXPJPQ4J6ebfeQe4
1591	B62qjcPuh2BcHqKMFEsUAshFRVvDn2V9xVrrRpn9Szarx63NBmehJPP
1592	B62qo74q1yCcNhJ17iYrNEpTWEJwBPdDzs72hFDDwm4PDWVihC5jFbG
1593	B62qkoSio33qzxjsAuY4KVYmjw784KuyDSxbRL4d8UJaLXmdgVqb4N4
1594	B62qnzLZyeTiesV9EvUxUU2AHqyWfd7kAWEWL8QqJm5Uaadpmwafrj2
1595	B62qmeKQQvdH15JDyFWYhm8N6mpuV3tbZzqkZSGFsMZnbXNVqmsYvvg
1596	B62qnvzUAvwnAiK3eMVQooshDA5AmEF9jKRrUTt5cwbCvVFiF47vdqp
1597	B62qnAZCj1kbyDHpxo6Lm9yM2FqMj4ffJTQzJeiPhgkzpEw1S33caCZ
1598	B62qmQ5ufDZUTz8tm1GVQvmNrn4Don4hXPJ5GFMJpP8VEXkHJCZ9ySW
1599	B62qkHM9NT3nDefqUvSMe8qnfEfeXipqkzZrvoBXpfaC9m2BdYjWVJA
1600	B62qpXqPzauUXLnsAQFnYHMCiV9pRqG2wqbJ4pL936SVANHa66zkkQj
1601	B62qpkF1Yrd1uQNLpun7d8k12ggHEXjXHknLCKh6Hom7Q3Ba3oZg3nb
1602	B62qmpSNd5voNiVnyM4c1bcbRC53wdkEANwYZaA2iA5rgCv68XezSuG
1603	B62qmiJsasogL3iTj2HhSE5AyhN3y5x2GYuvccCBdT1xYB2bpuSHL2P
1604	B62qjqYBrf5erL4LHSapiuvcX9TMLCVqCuyzYYGC2sGZfKxt8tQ67Vz
1605	B62qpy6sXLwATHek6wjWKqmDukA7m62rtF1ChoTt1ZMT2po3a4hTW3R
1606	B62qnwWiVgFTCEvyo6buKUnexc4LQX1Sbuw87iwvanNmkPyP5zm43h5
1607	B62qrae3PEBj66KV2obWnzVxMjDCMuFWnyzxEzvLkQutaKPmWtfUPm3
1608	B62qktmhyar5294GEBpPfgYrSEBxkAcn52273bdR4CiGELoVpLtaC6c
1609	B62qoQjPL289fYLgcPzDmZ1Dv5kqNYANsicix6v6epSHXUW6H3XUTL9
1610	B62qk5RNZP2c4xbrefavDjRM9wLP63kFCVdd4TRKfmtKLXEimdDrKNX
1611	B62qrVGh6mx3DQBmXobnWidM265mxSD3aisVjR7c9KMyZV5FfXqywST
1612	B62qrJowiiRAYWQUrhyieAdFuDJgQ2MoyCqTzotP2ECRVptb63f7bG3
1613	B62qj8KB2fk59NkV4VuoTkVXHjw8VJzC3ybKrWo7zuDC9xTiWXPygEe
1614	B62qmqprUwxHxG6uGDQe48Xys9diJhunEqQNRuFC5a1KBUNsDaNADgj
1615	B62qkhfgERAi7TUjujZ8gdwSbA9TnJxvErjwfZTeftKmpdjJxWxGHGT
1616	B62qk2ujo9BoBxCs9BFQUsv3efaJDzbJeLs4YJdZMJzJoVj69ShVdKs
1617	B62qoWcd3dUzbjMHTdpjf5Us88x1otEoJmhSVRX7FXf1Dx1zT5Hp3ZC
1618	B62qpzciXjUdvgsKcstj1jKLnyPCtWFFuvtwr54xakf7tRucz3CgHB7
1619	B62qoeKm4p9J6Q3hYWzb82Yo5uP163MqooBX4ZWjp8FpX3N6Y81QgFc
1620	B62qkVjzzRRXe7FA2P6Dv5rJkxYT5u8QWYAfuU2U7b6yZpoRfgQhCSy
1621	B62qkJdU5HYtzLHfc5T8U9SompB4GBxA9Uhjy434qKHRQBbLhPJjWuc
1622	B62qrwBEB3tjGvjZNNr4h8N2iHGvcgRa6bb3V7Qs7Z15EZVWnyJBpXR
1623	B62qq3tqfdj19hqaVCozJFM2q9gT2WezQMaJMKD6wxyvK3fMpHiP9va
1624	B62qrBRnUXvdMr8eGLBsmdpvFnndinDZMowqoMUYRJnmGKpdJv7TMRj
1625	B62qnwfauXg2i7e1CYGdJjztyfdJ8CiESr37hzm5X5HJnYwp22rBpSD
1626	B62qjmhssErdKxMjXuXaABYjTnhWjzbtdm63XSpjNb9ddPNvtfJ2JbX
1627	B62qmQ4pFXU4tyNwdzMY7uCdrALptYp8SnthWJMqPPA3FgmxebY3H2P
1628	B62qnsWWJEU7U7XFNLtqH4bKZAMcPK9mr5CeohEuufkV1fT3wgNSV1T
1629	B62qqvZh85mfqj7mFhKfDnC1n6aCxw8Ey876Vw2z4E4tnCkRpcHTJ7b
1630	B62qn2Ne2JGRdbHXdfD8wkA6PTWuBjaxUDQ6QuPAmggrcYjTP3HwWkF
1631	B62qnbx3HVFsNCd6v7TJT16nxB1UEekBKektHy5WZ8GRotwTEqAtJsX
1632	B62qqjvE7v6Qrf1h7xtn4U57eMq8m7CPpkgwS3aCY8w9jQgnzAoPoUp
1633	B62qpGnZs3EZ8eYuxn8ANNwcexMhYqjjSLKBer8KhsviXGdEDwi63St
1634	B62qorXXHv971Kvnq91TkvWsRAvMCB8yszCX6yUhpyZseKcibSZSDSF
1635	B62qmnouVrbSqDevkjai8WsetJZSC1kR52vmz94WDRj724KyqYJ7MBJ
1636	B62qmTSi7ZMLJLGTNADvhg2NSL7roR2AxPW3JgrkY81nFB56AJGTcN8
1637	B62qknBg1mTvb9uXy9exbBsxs16BXgMQiJ5N73eEFXmWBLaRetqMvMb
1638	B62qpVUF5PXf7vh4eH8cZ3om3mp23bQJPDqwE2iB8BaE5ZUhaCJdU8L
1639	B62qr6owPPGkPVLVFcXnQHvijQxH4TAVqXhJAcMuKWvLXnHCtLZyxPZ
1640	B62qpLeuZDL7PxNsCqsJwWFPAmnixi5ay8Kz9NcNGBQU8jK19VpJQaY
1641	B62qotPF3i34VMSyp3A44ziyME2R7MRN2vH4W2Yen352MW3JW4G6hq9
1642	B62qrcFgyk8u1NPaTvw9zZE1RVYGAeURojHds8WMjEpzHakU7BefkMf
1643	B62qqUD5wTz7iVVrT2axj7tVY3kybSPZBJBDXRgZTPgJJHm5eD5aR1b
1644	B62qj3tjfzAhoLX9ymWvPsTZTK3Pm125SLSSGGfPrvhc3zbPr1D1A2y
1645	B62qp4Xg1zuAkTc1cyG8N2xQrujJaZ9uesm26Jy9sr2w65XUnNaGEEQ
1646	B62qm4QbSnmQWM3x7SUiQeWAjb6iiooWNd8iaxtDvsne7YP4nC8Nh7f
1647	B62qrHzjcZbYSsrcXVgGko7go1DzSEBfdQGPon5X4LEGExtNJZA4ECj
1648	B62qqJXzVcb63kE6zFEXJn2GsQ4DTjygTE3ymjYSsyHRt61qVoUBZyr
1649	B62qr7o47ANtvCpSzdVXXoweGkaZkwWnq2mZ6Heg7KQTCuShF4KeKFS
1650	B62qiwgNcH1uw76xgqJMb4V1nuD91qbxrQGWay96u9TBkgPb4HxRJeX
1651	B62qmpHMDeuGL1KAkneV1RTKMez2ZNcDUJKNAEZgweJna62xuJQ6Mqm
1652	B62qoDCpSv1cmWiXgYvDud8L4dk5oTwC9JkyXyz9b13j5uFKiEFjv9D
1653	B62qq6ceNHCu9mSBvczmHS5JzHC4zw5U9KLALuwZPemeksx82AEfQSr
1654	B62qim7EVe62u3wDsGzAZEMGMaEuwSXYWTCH1WsNvWFgfvz7ysggDxf
1655	B62qq3Lg31BG99W3DfpUNUr78UYhxUEEQdjSURViWhopsNHPUZy5CqA
1656	B62qmRG3THXszPjfJXDCk2MjDZqWLXMoVzyEWMPStEdfqhMe7GJaGxE
1657	B62qmBBEPcCpWqvMhParohskEjDttye1A7iSxwmMncXXgKkgjQ9PA7y
1658	B62qrQMvZrta9QjfQAmC9JsUjyUWDXX3h18nRt4FZm7wNgj9YPKwM5Z
1659	B62qj1EFvWbmmoUw2FH1AvUtRSP6av8MFYTiqsB7SQbHPtqNT2SWFEg
1660	B62qp8PCgNSzawdhooGXPQhULtZ4yhNzMb4UVSd3sTLz5tR8Btdtqn5
1661	B62qnWPnneWPobbir3JncBDVnj9dGvT1RA713xYVxJ9sBYgYHiu68Xh
1662	B62qrzoBfFuUxJg2YvcBkBnziVtAPziP5uAPcCPpQZgtjE4LTxXvVSJ
1663	B62qnr2iUdADcgeYKUVjjvXaPy4qXXz8gmYUYu2WbHA8ZaieWMo2r9s
1664	B62qoQjc9zF7TrVeLP4vUvYXfDoWGFPn5Q1jFjLDWwB6ocA1VXYyTPs
1665	B62qpUXyywHB2yRbgwEfmoUSh3KwN66W8a8QoXqpoTiHJkoQMcgJXbu
1666	B62qpzWppkJex4Hx7Y6rSq8yH9JMaGc8R1b3nkSjH3mk3aYKNyX6DKW
1667	B62qkQCXhzstenWTCwbGqRgdvivBQEE2WDNRWLRo4gAXcnkQKZ1FAta
1668	B62qqKoxyhPfHY9kw283dafk5jztbbKdH78eDXpNCyj69cmckC8KZqs
1669	B62qopE6unCuyENJR7qzj5NuJ8nMfj3dD214AVUpUeYbLyarawUvq8N
1670	B62qpMcYjgezccPk8NfaSto4jyV3uGU8R24D9uSShMoqr8JdpAv4RKo
1671	B62qq9CY1jVwTNjxbqUxNT4qhAy24woM1uzYA2HUo4QEGpkyUDXt3YF
1672	B62qoERu6rA6UUxk6yNYN9CfrvXwNB7tBF94TQucZNRkabQNiDJoMiR
1673	B62qjQ3k78nzaePyXhg298UEVnwbCeqQUcNwZRSR4VK1gVJ6mer6M8V
1674	B62qkVNThXvoXtZERUnkGYSoDbSDwnXntVyE8anpNSGLSQ7DejZMtMe
1675	B62qpFJeY8uiLwzhrmwFGthQS7yjZonyUACq32G4ULkZcRB9W3WVFgE
1676	B62qiy32p8kAKnny8ZFwoMhYpBppM1DWVCqAPBYNcXnsAHhnfAAuXgg
1677	B62qqa9g4CFfkSuX2j22S52z6UfcDcS9tMTgQrFKZ21v7GrEP6Zu5Tc
1678	B62qjYanmV7y9njVeH5UHkz3GYBm7xKir1rAnoY4KsEYUGLMiU45FSM
1679	B62qqSUUCnoC8Vehw5xwhrnaNxhk6Xe3FcBhngoxyXCbJBfvVhiqia1
1680	B62qjZXMHQijyxLPJHNk4QvXwYqgTj3V7X59o82AaD8TqjZm41ydCVM
1681	B62qkiJuTwdJBARAPGAvStuEa37kZVZPyDrQoUCuM7WQUmZZydNBmTf
1682	B62qpRhxHAcWjnWZZSUScrzzKWgP7uXrLi2uE2rkPtapxRCEYhLjm8G
1683	B62qrdhG66vK71Jbdz6Xs7cnDxQ8f6jZUFvefkp3pje4EejYUTvotGP
1684	B62qp5HTeTCHyYuuxEECdDNiehDWuK8o7JgMqNpaboxSZB83sTxzbEx
1685	B62qnXMPtWdK4hRyaemZrvNoDGe3pMQNeubQemMZVXetuEY6MfgYszF
1686	B62qs2YyNuo1LbNo5sbhPByDDAB7NZiejFM6H1ctND5ui7wH4PWa7qm
1687	B62qoBXv2eZ4P1yD4ZMXrAo8YQSfZ92ZAAGKb7cZT5nFa9cN33YD2ff
1688	B62qoSuxNqwogusxxZbs3gpJUxCCN4GZEv21FX8S2DtNpToLgKnrexM
1689	B62qoNMm2MYD1eA9QqhyjXsmWpFwkGUdjpJmxTeivrJWG4m2GG491VZ
1690	B62qjA7LFMvKuzFbGZK9yb3wAkBThba1pe5ap8UZx8jEvfAEcnDgDBE
1691	B62qr73SWPgL3SywFHZph2RbTusZyRCWjJNbwaqizLjX561H2KoweDx
1692	B62qnYVcxiHswuEBZjAkkejZU5ssqemMLY3VZkXXHzqUeEVgoZiktbs
1693	B62qk9WYHu2PBYv4EyEubnVQURcwpiV2ysuYYoMdwi8YTnwZQ7H4bLM
1694	B62qoiQhNWjwFkfCVBpkDTYytifftoYQB9qJ3z6X4d58ocxmiwUQY8U
1695	B62qnFWGc3e1FKvgLdWr2viz7WXsrWNZU4ezXDsQoYB2Zg5hMZL7UUd
1696	B62qppPSnCA3injWMQZ2ExBuYwcQwEbtjvwUUFFAcYNv5xbT8u8q16b
1697	B62qpCegcfvogh9pPzYSR32GZR2vnQc3hiF2uZJmVvJL9xjj2bRWkgK
1698	B62qoTHkMLRXsuSnStQWNbM8Ks8my6BNGbeL9U63aLyQuRMrWdbbnbb
1699	B62qoigHEtJCoZ5ekbGHWyr9hYfc6fkZ2A41h9vvVZuvty9amzEz3yB
1700	B62qmvHQzJmT2rKE1F9RemenGRG8BfXT1Kurve3eT4iC2HMrWiaVG3H
1701	B62qoaMj7u1JzuqXaBByQBL5jzqLguK8e7LHVPdY9LcvvLXK7HPsusD
1702	B62qmVSEM1UXW5pymtCBPhmoXgvxgDXwrfRbCpR8eZCy1FLWgaGzcNc
1703	B62qoUsaSTG3Ck7FnxPrkLVXtq3kLkjCW2j7S6DzW9C9eTqNw5CnmBm
1704	B62qkVjmbmdGDe4LvCwTGRCfTmENWWnSV29NW92WEE5YXrdX8L3P7ce
1705	B62qjx2U3xmfSPai2np8kT8sjiMJiF1QRzULGzCEMSX6BVWFqKk9Cg6
1706	B62qquj9jfmsFr3mZwDGt8RB1aiaewgtnNrpdfmVw469Kbo7p8uiiZX
1707	B62qqbFSAx9TGCandj7LK52rJyUqLYCN46gQSF66mj9u9zHqcrdEWGo
1708	B62qkVTL7vg59YSB2mKvFqPE969EnbA9XBz2JEVfPDYrFHokDhsmGHF
1709	B62qou8UgLnmGbGScLTK7xeUEp6zmHxWqzWZ4YNhZMArNjZPF5EtPWP
1710	B62qix5zYPi2gNqcNmoWJhqPUf7HJoaDpjtcPf3inf3D7rh3qkjdm3A
1711	B62qrPqwpLZ6T16Ce9CbwNC6Vfkzx87fUqY5R9rYhR9DxQHgPWSwUU2
1712	B62qmHf2rpunn72L5ukkCZESk5QKtUcjApxQ3nXsHhRbhe8pvJ4jJti
1713	B62qndJi5mnRoBZ8SAYDM1oR2SgAk5WpZC8hGpJUZ4e64kDHGbFMeLJ
1714	B62qmpQbytpsLD2mjaXmLzk9j6QpaHsv7VXnyZFmW4DmvNBmfrvQ5eB
1715	B62qnH6TzZYc8fokBWAn6h8SLmiQV3DpRhUmGk4P9n8r95Q2dNF1m4v
1716	B62qkwaUeADgrn5zcBZ5gKYiGtp38SB8NtuygtRHxmJ4WM1Zo3ExJHw
1717	B62qq9hV5AifoUy8DSZPVpGR5nNm8sVVjjbq1C1R4G1SSRgdeFAKNbW
1718	B62qmkmSCiTvayykE34nVjvyGdYDvFhx1iHV94rHgkESSNiApTzixj9
1719	B62qmbPb9Jgn25KqNPwhAM4AomUj2LR3AM2U3Jcc5zDRm9qZDGxcfEE
1720	B62qp6E4Y2T5pdEuYWizSFK2Pm6yT71MZThsVSUCit2TJYs9EVoujdn
1721	B62qipHmwhGetJaLt5nQ6ay2mvA3PQi8ic9AZ7XMdLpoRyRzyT8vjsp
1722	B62qieZHH1wHfv4PkSBhyttENUSV34ywjBP1LoedSiaz6sePMqy6ik3
1723	B62qpyX7tTKzTzFaJ6w5uu8PgedH9eftfKzE4kXGidZDPnJ9XLjGbP2
1724	B62qkP2wF1xfiMy6zpdaJEsDojjp6stmpAn6speYW57iaFr2bUthhpA
1725	B62qpvEbqegpNsPLdc1MiHXsKLfm6jDTJPfwRwAwExtsRYQjbZgJyrp
1726	B62qix9vooX5NqJYo8nT6xWqCeQu5AJoS1ng6FRnUpVAra6PAZZ1CU4
1727	B62qpxakXZ6d72APV3AV78Rk5g1aqgxqkWLS5jHEf8WRYSXGvsUyHgW
1728	B62qpJvSB8A42sQjvpz2bbXYvz9kbLH7w7sxAMFQ5eK2LNbMx5NGcAC
1729	B62qncg6H258KhR5RzcRLmn2aGd4V2DowXDLtxJtHkGA9WA5dcEYJur
1730	B62qjn3FwzxYTYWa8yZmsGXfa2CQtKvHvgzME2fypVvDfKxWLG21U9V
1731	B62qroh6RLAVUmepY6oqFFftKzuFM9cCHrzjUCsfLX1onMGQRLgqzuu
1732	B62qqZcxyBkzfuvATNj2YmbvMZxtwefwgBVzArEwzkgS4atocFxn5T4
1733	B62qomQbvXy3uKnsj9xow87q9WD6Q5sL8ByqRzBMRb39M88PUMo5EYC
1734	B62qiUpqtRRwJ6qcou4f37TTjBYFQBsFcTL7o14dMs2KVz6zNZ48Nth
1735	B62qkn8VfJNMwfWooqjWRvFEmMfeajG9XBwejxvQi7H27gTrvgPLB4H
1736	B62qnQYmsM4r9iQh1LN89UYtz1QR83ccH2kkbDDQ4nuXDyhyULQvsUp
1737	B62qr1yLuknMwcNYeqXoqUeQBpuMKVtHiQz62qP1eZDgLTcU9jrYfjQ
1738	B62qksdy9aiX4PGnz8J6FpXvyBv5NecbSvZevSYP5PGd9PfoGuRgWfn
1739	B62qke3BiDQQJHjiyugZ6BrBhe6P1aDHqUeS7EGM3dXH3UMUmeuJjr5
1740	B62qkFa1sHgmFi5u5kW5oG4iPvycp6komoSNLn5TT8uKGfsmh1EnAjZ
1741	B62qknU97rYs4UC3i83Xkj6fJxeNs2Ud2uwTgfxFGQeKaM8dxjhKnzq
1742	B62qou5BnHyuMMsWU7yNacS5dzCPq7HLszHDQUAv1GqetwwLwgFa6gn
1743	B62qkSashvpHk4t7UL2tMtYMqX1eBUxS6ekx3JLbBPKDNKLjV5mHJZM
1744	B62qm9oz1xi85sd3DSuomARHe4eJgiY9XENTrR1uF2XgxsPiggNCUd7
1745	B62qiuAo8eZmCpYCgh79BHpimLZiAWxhoVCzpcSWxkHduHN66UfRktC
1746	B62qqxJbhyZzVyuvpxrHGVfhkBcmF9hrwY2mucCSghVrDdBTqLDV7uu
1747	B62qmhcP6E3NctvZSWW5ZeUGakgyyxk59E285wymE28KeaMTuDynNmc
1748	B62qjDZQUmHBoFPbUeE2Kw7zkrz8nVMoQVgnvQPnAFYtm8HK8rLbHd9
1749	B62qkGVCPGHrLHV9r3G9NqD9du2Wcb5uKBfDvLwbxDKnyjMppHoN6gi
1750	B62qow7ooWaAxjhwA8RoFMFjv1rAetMFe8CD4dgmZGdfKaZsuFzYsid
1751	B62qk1iAMVGJHR2usTsvxV4ehxdrDKYSFNJjQjMSYYDdFTtnyHpB6wg
1752	B62qoGoJ9tSnPehar1UR3fhSSXKpoNXW9ZGottoCeHotyyKqJ1R5tam
1753	B62qmerzAuZt8aD9qFheFQ9fPqtpiNJJKLk5QagP3Lw9M44nniwaKNF
1754	B62qjGuAFtLagXc7qv8Jj9T9kKNNbfQmd5pJXzFfeHrjEavRFnEDfWV
1755	B62qrHXrAyPaXxgRKHg4zfnFa6zxWRo9kPRseenPZH27T5oA9mQwKWQ
1756	B62qkVE61eN57HzwZEwoAgJYJGpDQ7jvXk3ZBsbNWBQQv1NBY5ftoaP
1757	B62qifbvKWjFY2VriPsVoScjJgcQMrkbB2mxZdGT478c67bMvNxTvK8
1758	B62qoYVcxsGQWVuPuvU53jCHFnuJ4FLePM8SwkVYNfxboJU5pttpyMf
1759	B62qnYVJSEPGrVtUvECksn4cRDBa8c4QhLQ7dzoHxqB6kPcAZvY41ui
1760	B62qrPAYA77JESy8138uNfHaGnM6g5PAMptPK1sUVhSpaZrd8S7UfVk
1761	B62qpanxZjnQLtZHQfY8VGgCYyE29aDcG7BL2KwkQJbDzaSxwwZqT7i
1769	B62qoQSggXskw3YQjTCmi24Yh9HuuiXBSBKDKzgyxg1G7oe3ng2r4jo
1772	B62qrYDn9gjvt4PGN9rPjnHiGnstJrYo2oHtJ7tbWYNsLtWk4WLZMXt
1773	B62qpRMMLBrU3TEwtw1Fbaz41LcgX7H8y6JYH14MaiSFWzhbV8wVunu
1774	B62qkDUHnU6bam2V34VKtReoLSQempJnbdtYNLivX2iLCjHUpDntVEi
1776	B62qmt8gdmBFGV7U9ZsmnaGGjpKwCFMR4HCwzh4XPP5v8hWQeJ5L5Jq
1777	B62qmd1EZEgVpDi1xSuHbPnqZroPVG1fbD1GMpsBF7bA6Y3TcT9BTWA
1782	B62qoa5KoGq7G9JBgyRisUuraxgK8DbK7RdxSFFryq1eKSWer9FpS1b
1790	B62qigLWBbpoXjsxDQx4zFQofz3DEnfspxX14wAVEnGryv4jg7sPWcF
1795	B62qrga18YWfHqsEZzsVVWpZetPCRUE1E59G7fgJas9kzKSBHtQ5xvp
1798	B62qpiiHSDjNM7Z9GM3uM63NLmihXrPPstbLA77mJa8cj9AE8bEuPYa
1801	B62qp5ZUGs3HCAG6aaJSH1cfJgN5fXf4giMe64d99FrxEanE5erCw1B
1807	B62qoUaAA4bfUaA7F797qFEwWJTJak5wSUqujHiyevtLYHDwt6hcu55
1810	B62qjhjPvNGyVs2n7ve3gaV2TEheCESVW9JJH8NLDsrJw9QjzkfxPwg
1811	B62qkQJWnnDeWaqmBHsJ9ikLxsZfcdCtNhhRtrUnDfCe2Hzsqsu3RkV
1818	B62qjmomH4dhgPsvLtSXRnrRyRmcBhvM9uCzG7n2kryaMZTunWvGxQC
1821	B62qmaatVU8sTcRTYWr7vmhYjCRWvNoKVf3Te7Cks6iWJ3ZNpjUwcVK
1822	B62qoiTh4oSbWQ2KNnXPCKgtLUio47SoXb6ACx3MYXWwXFedYFvsX5c
1823	B62qm1XMKjMwVat7gQGp18Sk8f9zfiJKYwysELpxWaXkjLudYJ33RsW
1824	B62qjDDf993B7gGCCBW2So7dYAudc8JKNL7ZKXYErQdQPML6awsFuDw
1825	B62qkJehvL58EE6xxrr77qwocrSSKAnDeGtSGNxwGH73WrQjegxsMNk
1826	B62qpJR6R3Fs4RKzDFhRs7BSE5uqQKvaqZ9SPmMhzQ7vCozkSAVcmjS
1827	B62qjbvqk8bxbAxTubszqowtwE41uAdvRkNV3otDTFB37XiepTQndNp
1829	B62qr62jw3FKtZbKfs3MjWuiSw1j5N48BBNiyFusThUAq3X2EygUgN6
1837	B62qitpkSH8U24Zj5V2oziG7Mv3xTyGTyqPkrJ9C4tJaAjKWzLpdyhT
1841	B62qiatrW7byfZQWJRZSkpYNuV5WCywdtWDz867GWoCuMJ7Bp3fnN1m
1842	B62qr5ahww1fnhBe1BCvsJMFynoGfzgmJaCJz1px2AKd9vgg4dHbmSs
1854	B62qmbFAECu7faKPV8stYbMav2QvKLq24Cu9eNEoXaVGNRnh7qWsjXn
1855	B62qigBkbZZ1UM3BpFsuy2qwAZqiNa3WbyHMAVFpQXo3ycEc7K3sRKw
1859	B62qpMmebS9fNA6sR1HAZALfBBdrbWJL6tpkXu61iteBZLsdKYwaAtz
1861	B62qq5SnXbxkXL1ayVR8QrxtxJVZUbFwp1KZRB46rJLrLFxB9xBkdy6
1865	B62qijNcg7kkzdEuXe75gMwUY6GVdwGTVtJaMuvsxMjq5BZsSUQ6Kdb
1871	B62qq2JjD6R8c3zAts7Gj2gifHw6te3qk8vRmk5EciyYGobKAuvBjPZ
1872	B62qprKV2kK47mZWky7qCDWb7AUE3uTdbDQe9VAncTDxpUA7syrPudD
1880	B62qnp1rm2iEEecxrCDPGCt6cu67Yx2gPykXWG13vAEKTgQySnyk2e2
1881	B62qqCcWiBhHLA61zJx8vcYqLpAYLrouAY43GEhEYARdC5j9WBErpBR
1882	B62qnMzCM4N1P9GeXjPRMWegezzqzaTrDprqvrJPuN4vAn555fgtHj5
1885	B62qrXynZY4AKszEybHwcx1r9BkrroueBU6nGc2idCHnw5tQEjvpAHi
1888	B62qpyoNjVz11TTntVphmz8CAqJ8fqUH8uQkHsd4bhzsZjXkXV1YzEH
1893	B62qopJnUq7VZHA4FvgcwN4Jy2uANe9pFE2ejSCjtW1XHtdBCdPYYZy
1762	B62qjDVQZWZi18UGcbpfveJXXDKWRLeDBoUwTE6Q7Lfzw9epEVfiQ4c
1766	B62qosgrkqtMDoDBdKrBP27nDPJWMHToUw9uF1ZyKmCv9bBSYu3Rvh2
1767	B62qnunKkg31CcASd5P97suoz2fsWyyW9udeet6Agi85ESikW9JM28q
1775	B62qjb83kxaq8QEKmCqGSPhBi4fPW6zKmgkvYj47gxzGDyDsGvX4Trm
1778	B62qpzJgthynVQcXLePPDnKBAWc196b7fforhqeHCYncafYZPTZJfik
1780	B62qjCfrQX1KAatpjFj2jAcA4QMiQ3dqJTDGehpJEe2hwts7rmtHmXk
1783	B62qrEREDKjkkLjRfSNixjLH9s4G2QjihNvV7UaMEKockXWdBmoL4Av
1793	B62qrJpTxPME5XzkveWVezqD6nnSUrSuNfDNkT7asYGUajtGPspnDU4
1797	B62qo9HaS9sGLrBedgLYptnZ832WAQPmy5rKTo6RkRyt64oRDBtxgXc
1803	B62qrv4nE63JZsDVswvwZgPqZjGU66DMXZPrGAiDFjuFrLsr5YAJw9o
1809	B62qmXxt74GSt8TDooLdApfBhAwapBTr9Tscee15Vy2WiFEe9UwgMQv
1819	B62qmp7v2GQwFwRRe5xd4rT8RMcuCbzGwRsD11yRx1DGmiMpKH7zACx
1832	B62qqKr6erPDbxSaYY4GchHRnehkjrhaew59zHnycUqu9eDygmUaw7L
1835	B62qoqDEmZYb1qgUnBj3PqxbQYtdi6EbDpyYAq6enrnYJJHGEcpAM8x
1836	B62qnw28YA69bYkQmcw1nyHHvrTEstpanBkMLjDZyjJE6x53CZ5KmUh
1850	B62qn6jGmGFYPSQa6hecPDG5BASrvdwTajzQWZiP1ay8iNymjVYBEXS
1852	B62qkeEkEfUH5NbqMN8xDMsS2ZnCGKkhNLfLuZCRhwUTwj42rGGouSK
1853	B62qjxt3swDrDtuWZHwhERtC8xtpfhAN4m6aaNZErGse5MjzREEaicM
1863	B62qrobthxZn86uChAyYHn3tQaUDLdX1ujpwvdfdchVJ3RRvkiRPFU3
1864	B62qqCQJb1BpDCttZXJ6pVsXvShp1hapzrP37XFo2kgsBzy334YC8W7
1867	B62qnB1UB959Uwoik88ioMqR2rJbR9ALLLYgfHFfU8uZr8PXGMjqvPB
1874	B62qmWdrzP4KE4PB7oj15XYpFYWKBz9KVsj33u4BBzmZDWJKvwDnAw1
1875	B62qrRaX8dHZZH7VjGf9qWVk111X9Xs7Zos2vSGU18YLzgWqqdxqXMD
1876	B62qqG5zRcjj8sSXXPvLTmvF5qsPG2rMkwpa5Lz3KpybiF4meTjLX8n
1884	B62qrSugEw55tMPKuCAoeYz1yFnnM8nHPd2tJZTMneSQBEyxosFufZh
1886	B62qkD1FnaKbN8zVvs6YZT1nxezNv7854YhqeK9YNWjV6f4K5izhjHq
1887	B62qpMuPBNuLFU7DTRzmiLY1L9PEGW32P2wiJR4vVrFySRV9pmvfQgD
1889	B62qmGL8rK6KFZGh3khrqbqcPbYeuuQ4qiZggyytSmrZdmqc1DNUe5S
1891	B62qqc3D8TNxXKi1biL8RXYx1W6aANQHcmiUWhGWcrZnyEfhsaLdTdT
1763	B62qkfkruxhtgugV6wKGnWqx9zjtHCMyyEtwRqQPSEaF11Dc6zUQuFZ
1764	B62qpUpEH7ivz61Sxo3PuTxntUNswmiHo2jwE2HvqmSVYW7q8xoStkx
1765	B62qoHXLV7QT6ezrPai2fLiS2k7eA4dDecW6hkDjXeuKdgjsTDATdNi
1768	B62qkofKBUonysS9kvTM2q42P7qR1opURprUuGjPbuuifrPyi61Paob
1770	B62qrZ1QQd2HezQ8hoD8va7Z2e1KJkc4gSsLoiBqyWGesoTrcCQeGAv
1771	B62qporxUMjspEFzM7uSJzB8PkgEPH5r9yPgyF8v4FWPBqwf96ZmkWr
1779	B62qkoE22CeueBMRBBa6BmjJwAapYsvqB5hZGdYKmQCkFxt8tWHpBK6
1781	B62qoKPWmw6VGiTrDuAmDa5KgLSu6Hw9nUuSw22zUUZJgjXwXB2UfAS
1784	B62qoMDLTNkJ1ksL9NXgKCiUkcEvyAqZb2gAbaboQX77dZrZZ6ndXg3
1785	B62qpuk4hJfkefXwaP342AFE5gztNKuLe2sZ8girbpSHHYk9bztqdrn
1786	B62qpNRrR31Z4VGxwNYBnaHsptu15GRScjFnkMcWn3s9mtb3VLt2i1b
1787	B62qn79vup42ZgTBS9jvrss1CpWQsKQdNAuq6n1eXAgBz9NfvxM2riK
1788	B62qkcoQXWTU6YBbsApX338v1Hzucu9qvKMqtzWBQnPbxoL1HQzgsto
1789	B62qrTWJaYnVq6bgvSqVFfz9hisLq7BssLGDQhwxSb618nqAuDgVQav
1791	B62qrQ4m3KNeNBsC86AW1vyXxEs32NbG2pDA2mdvCq5erxLqftVyZTj
1792	B62qkS7SKGwfD18HYw6rytEVvrDsA1N46tLeqBU54BKr2x8VDwGQktB
1794	B62qjEGSN5BUPT1x6uKJMLngzWFs4p4vZUAHnbPfgsDmg1DyWrrhLoG
1796	B62qnd1rPUp4aBpjVjCJ3XLXk64WxuM9ff3UkfZoRCkBF8vcyFnXNTs
1799	B62qm8vP6CMgBw7CCUchjQDUd1BAiyqGiSmsgDohsnoSV3YfdzPG9w9
1800	B62qpqCBExtxzfHUPkmrrfmYhXZyg3V7pSmwuxHMzTi8E6gBbopauJS
1802	B62qnryrCahSbPFYNkTDM4KJbdpm7XUkS7shFtixFjkfGvawCd9Ycma
1804	B62qmBVAArv7jDvKKcWv4dhdPrqcti4C7XUM93ThCfaHdnfemXfHYTx
1805	B62qnJjx96oDkfA4rcDog7whcyHB19XfG6yYi8fekgXge9N9m9uax6U
1806	B62qn5C7NAV32CFFdETsytiPJWDC4itnHL7CevEV4Ffn6n6ZBTZkGku
1808	B62qnH9tQe9a79hu1YxtDaSVENVznuKrgMtLfXmVdfPJhq5CJjbXFzR
1812	B62qn2nei1YkLnTQJ3N69zZj1JtHdv6LciSqAyu2Uk3vrijc2ph7RoU
1813	B62qqzuwDk78ePpqDT8AUPkpBEjPHB9EaPc6A4a1WehFSURcxnd6j8k
1814	B62qjBK5JNBudTVvXA873aCfn42oUq8HBLE2gt7QAuFx7XZN9mWt6CE
1815	B62qpT6NVZCNYnEw1pEfP18JkEvK1JUdzBF5zriH5YWXyrmdYSdQygx
1816	B62qjzJvc59DdG9ahht9rwxkEz7GedKuUMsnaVTuXFUeANKqfBeWpRE
1817	B62qkpKVXaiug9ERVE4i1CU6stjDYybvkwnrNmLGcimXXPMFT5x36h9
1820	B62qodrktQKGhyUSjkEPLJc5mADG7saxDQiPTJeJMFPUsWHRX17ysXg
1828	B62qqNgFsGp4Yi97PWweAqABovoqkEcJeDjEmHy4TufTqz3mWnwEq1t
1830	B62qrigQeBAmyaG8dWXkmMsn8irrPj3c3SKuKK4EAucQB4hc3DxzpSa
1831	B62qqQSeAh9dG1zmNQY7ngCkcDWDkGH9ykEHBDhE8B1WXexy1uq6eoZ
1833	B62qjba91UL7VitD15oyBMD2XYmTjam2FvZ6qB942xWrCDrChUscLGb
1834	B62qo9y2KRGygTVBiwwJL9VyXKQsya16hNhV5VbiYcwTnaMzvoRfZnm
1838	B62qpHPGtHAy9gFZcur2p6rpDzZVZTWjCUUhU2BFErwtsvukWLkZPhb
1839	B62qmjQw4kbwYqZSsJ1HMgw14f7vzbLaVHxUozyUjeFB3PhHYtUVtNK
1840	B62qrxD2j2XHCMdHT89XdiwnWKp1bwHwfpvZKuWXc5NiaPUuZjBUtN9
1843	B62qkPnVJoYjB6AB4hXg5LA3LDxTGJKJJfV8HZDu3SdJbzDvGUBnhDm
1844	B62qkNJPMFTJdgXDxb9YLgAvGiRSrcoU1TnQTQYKMh8wqZ2rkUynns4
1845	B62qig6vbNg3u4dXZccqrSiXiwhomUKKWcvqTnJA4ANy4aUh1Kgd99u
1846	B62qmkH2Xe7PLf77eMB6Q9UM7KAoUZUMgBosL8JsM7AMHsD4rXCo5LY
1847	B62qkDTKBQD8npu6NZ9ZQyFpqXh7ZKDgnQWzmkqygqev54NrwTSABsA
1848	B62qoQzP5tqAtqvo8n8jfa12shkWgnZ4MuYpayidabVCkKNWfcyXS8Y
1849	B62qnVcbfXr8E47LbyEJ8bYUstdSZ6W8T5aEggM3L12JbVVu4P7nBiv
1851	B62qpkai5gFEuik574QPLgo1uqmSFi6QG7gwMcXEDDsH4BrvwXv3LJy
1856	B62qrrK6nwZaCQAU2eeaTdRhp1196oRX7xTapqRd789AJ9PiRL2Ej9u
1857	B62qpgrCAbHRjU5UxmGp4VHx7NLqCN3NyNqtrwTMPDFuc9kshBmSUUf
1858	B62qnqwQ26uuk3hjG47bWnoscnfcjnRPxFnf3hWr82a8ThjvnSUWz5F
1860	B62qjP5eNaT5Sf7uuQQ2n8euirdJ6i899LMNNcBf1TRpe2gzAteQQL6
1862	B62qqQzbNa5iV3KjHZUZ5Q6xKU34Y7E7Kvb31129G8oE82zAdnTFiBq
1866	B62qkajGVuoMY9gc7wvnHhjgCab2XrCaphS5NDfCgMUkFZif6Q37EtE
1868	B62qjey4q2AVPVgyJSPvXLDpen22V85hfm8nEdcYzEzmLQLL5smbkfk
1869	B62qndsSXgFNxHojXwXjZRmzHRove9ZR52aC6joHs41BNvkf6qZhyKs
1870	B62qqKtG6JZ143hmezSJFLP7Nfrk2JnoLv5hJ6fmWBTp8VvER76ne7r
1873	B62qnHEFCMMiqsNm59WhbiFABS5AUJAD8Qa732xSfkjA3z6ZBDhCWjq
1877	B62qoQRNj6b8RzoRKDq64bFS9f4zU2WQJAMnHyabZQ3BzP8Fo5t7bQk
1878	B62qj5HQ9Vy552YqmYFGvbCeBXf1dTQ1cASDDv3VkK1cpn9eaC3K1sf
1879	B62qkXNpMFSfyonEpGLT3vSfUyc753XcD8WkqNJeCJsfNQTrV4Zn7Vy
1883	B62qkXNkRLUJj91VcFBFgCctdpgwfMXPe8fUHWDQtfL8TqRkR4TkdDT
1890	B62qpubPxC71s7XLrimmnoHcZyzdQghR6xTsPZbZmBUCXaGATHVCA5B
1892	B62qqmBYC9gsGAHL5WEmaZYY2FmW2NDkvbY6Sh7HmCitbqp3eZrGwuv
1894	B62qqyBD6cBATkdAa29tNAEJvJfkMTzwfuWyaJz6Ya3dJ76ZixfUter
1895	B62qpBn1GBBdjCXqr7cB9uKaMrRSfGzXTZypRfQzBedEW6GVvLXxzv6
1896	B62qjjsz547WMz3ikhAFuStcB2Gw1zoS4AKe2zEPa4aGCMRPqbu7PGy
1897	B62qpHGpuK62q3MvPVsDkLX41MVGwRzDX6A5ZY7NnfPraBGTL6ajPuW
1898	B62qjLBy8wdjuCiDpA9psAbyNNZWFi6Tr2UY3YSSYNpBRr3KmMq339i
1899	B62qngnfmiwKuaH2qRCCQ9wmYHXRZnrGuVwSmgVcFNCdC1FN8UwfoBm
1900	B62qq43TNomycQX3WR2v2KRU1xV2HUx5vPQVnPXonR5M5ps9SKKXEWB
1901	B62qkj4gQPZiAu9Dde1CZ7Lh3CnRaSebL9H89AaYGk6Z8reoeRCG2K3
1902	B62qo4g9i5mRxUQ5ix2vU3VW9XWvxDTazihEfuEDM2mTyztTAp4ky7j
1903	B62qn36pXrcefvtvQtX1GKMLYwHfxfUSHhLgD4gyHQ8oCsVkGCs4zjP
1904	B62qrugpkVZoUjrncghWf6inwKjKaPBoibBJQ9D7Trjpn7Uk9wGj54C
1905	B62qqoxMkEPB2c6idJs9crDb3Buezbph3xsnvm8pQyfwRKv5B5TXhoP
1906	B62qjcdMKDGdwUcEqxJtEZKTcsSBKSGAweyUfqGnGAnNNyLjPgXeUdu
1907	B62qqFJf3xdQziEJdPJV7C8rzih2C7tU9tkmvz9MfL9MaSkzkdNKLiG
1908	B62qpBWm2sCAdq7zYx6AQcRTpxgioVH3HdYzpKnnEPBg8DrEAd1kHTr
1909	B62qoS4mwVU76GavYjEd4dVvtEEa43WqwY4SqkyuHbQgtfDNYRZp9zf
1910	B62qmbjCtAeeVzTcZbBawBYMCeHhGzcApLQDc2fTu4Zu7ea3YTGhWey
1911	B62qqrUkE6hrZWRWjfxY7TrLrAmFWDsz15V8jmAAhFLk9HFbCmKyrbu
1912	B62qrrAydGEnacA9LTQfvWuowfkGMHLynKjQcA4XoU94nQ3QzrXSFtX
1913	B62qrG4BUepqBchDAxP8Ak4L2xrZeJ1vqh7Bcr9o6UZogL1YQL1rvqm
1914	B62qk9XaupQV7mfFNN7GXas7mMHza2aDM9aQ211KxuQRckprDNrw8gs
1915	B62qrfuwLpoiN31Q9fsEgokTQFZwExKCffukv15opcbBMU7cLsvik2Z
1916	B62qrFZsgoTanXgborweWdFT1AVWBqJWBGhwj7VtjwRmpmNpxCN8Y1g
1917	B62qoe629ZcWpsrAKZodNJFuqWJLqTTYkeKjAQ28TsvprKMTJwiCTWH
1918	B62qrTMQLpRPF6viYPQnD5ED7yMiX79ZEeUNovxYEdtrntNttpAZHhn
1934	B62qrrMbZwJW5Nka86Q81xwq1Tx21kcLWqqVUPwCzz4GdasN8icD4Gs
1935	B62qpMfXLyzkmkQ8wZbVqHMurvfeQ2CQCUXqofrsBqKvAzwe7Vw1uS9
1936	B62qkewMqcvUbBfrskh6wQuyz5v7SY7U7ExxxLEj59QFcfVb99UtTEi
1937	B62qmkpSUQuLUxDXqYPAXQzPozp7SMX5LcKjEcFrqzx2Adf88Nfymz1
1938	B62qrsfciLho6retD6azKM9F7ZKRwp6LbJGSmGtkewstnK5YGx24RaM
1939	B62qpu6wKspMgAx7ZvmyDPuFThSwadNNoGU94ntDEyRmoqdu1u5GdSx
1940	B62qkccaBQWRbRD7r298fWcuxQAwxtiShqRBxf6He9rXG1tgH7ydvnK
1941	B62qpmNPZ6M7pxHy6tVRkRLGU3Cj9VKPpz3dSxE7J8PSbtGsz2gV4NV
1942	B62qoURK82zFYTpX5aZ7x5LMq1FB39uuCYEmHNwiuJsYsAsLkn6XPfj
1945	B62qj3vGsgXo9LXoNEbhpoPQA6TkkTTxuL3Ly9Vz7UNQyyS61AMweyM
1946	B62qqbKy7DDf3dsDC1ynyiA8u5ua5a7rHYNPhFwNCPUonKuxHqAXM7m
1947	B62qryQ49JRAiGuGeBzU8Erzcvt9ofoZLoP2KZUVPztR7nVssJKbexj
1948	B62qn4WWaZHnG5qMoBbugs1xtEdDw8LoW89zYwiRCRXyfz8wXB2dRaN
1949	B62qqheA3p57XhNRYaKuEyhp6yNCAj3byDPuNPfFQiNkGgTX4e6iwqp
1961	B62qjE4MrihFWPiBcm77JrbrQrycNwTbV6vv9utJFiMhBktnAQY2qUL
1965	B62qquPa5qJih9fH92owVvL6hemZ8C1QLJxXFQy6NraKmo9fhx8dUxV
1980	B62qqvHJKZJwzVXhBTJyRXCLkjQxWcK1k5CmhAVJFkdTHhNxKL8kB7k
1987	B62qpfwHyejtpn5bXsmaqULj86bJYeR7PzvTcrPRjhNc1auMNCzQJHQ
1989	B62qkABXQgQAEvhVmwBwvxzr4ADn9yi3qSGoyHGSXYDLjJuwQLLQ6NM
1993	B62qmK5tj7VajoTdnbh2TMnaiEzPRbdM8BaXyErsBE92WFvRdanncsX
1994	B62qoSsdGFSqkftRo2irr99jWhWUd3k3rixehWtHayL8TGPM4cqaFxr
1995	B62qpvsSnPVqGLX77eVhgRPaEzpk7YB2DDDsyMDAXsWhREbjS64HJp7
1996	B62qmdn3TBoKG3jjkEsokTUTyQG9sWc9fvZZH83irqrfeshbwsDAxUo
1997	B62qn3iManEM84G4sKRoDUS5Faqgrg4rvL8jRAqxz1kmPKqpdzpa1oN
2009	B62qmJZD44acynLzxERnhUkbVjFXSqphiRfT6tUwfACYCaCw1xhqoBH
2013	B62qooMGsVDpjLtJEawrogEkxenNsg6pgnE872ZEeJfz1yYMSJtVASX
2015	B62qji6Y4EEwd2LpyEpmrANFMYVqowux2P35e83V7P9wbkVZAYKN6RD
2016	B62qkEAGKnmev6yy9DEUg1S5WQ7XimLFK5yn24b4NfNMfarBry7hCKm
2018	B62qjR2B9KB8pXNcQBAq9cgHFeuwwvMT7tA2d3K8WEUrktJccU6C7Qt
2019	B62qnr7H3fB4CvQdJd2XrLDNL8nea74GuX1wwnkwaSt2PawxBk5pSyk
2020	B62qo9WtYp8aEPUeDiyE74QjFTPRueMCeRdaY7eDzXYcQ5JjNA5QLgx
2022	B62qpnMwuYfQ49BdvQYKaoZJ6B5iLT5SNj3cK9uZvLchk1mK6wnAj1B
2025	B62qkoam4EsvkuG1dm4tr3AbcWnQ12i63LXRMUvSGcXmHG5zB4H7H2J
2026	B62qpDqowv1aNpxoWxQvUCQJbrSctBTWyKzFHYAonMB993WtK9voDvb
2030	B62qnXJ6tkvQzBYar2V9ovEqSroHuaVHFdkGVHXz4rXiLHyDRFPSaLS
2032	B62qkzPdsWdPETD3PCg1TEK3GpLeHgAoi4Lz2w3oVLUeaTsmGvBLyL5
2044	B62qqD9f8CGy5QeFj1h3nsit3Zp2GDBntjEoVCdfj4SPQuubRW1CYXp
2048	B62qqEXqn2eREKY1748DNKoZdxNrsWAzfcTKArL1QDeuemPrEdifD2r
2050	B62qkX35WJrsGRxD7t6Ut77nth5GFbS9uRaRexWTJjapuxxg2EgZ56R
2057	B62qrNkW23Q3KeiyPDNiyZaZ16FYhg4zmNSvS7zGNzoQ4Fju6hPtFGi
2059	B62qmDpDKCpx2R2bkyCFuBymXTmwss77ejQ9DF7oN1EirAanR2R5pmt
2080	B62qj6sBguZEc5xeNwuQYfHMe3sLav4xNhpxuczSkwGZRgRT9mHwG5J
2081	B62qqgYzT67iGyBudDH5V8w8GowkYG5hjgRdW6xWb4eTyQnTDJQbQJY
2093	B62qpaBQWvAM1AtLABPk6vd7Mf2rHVmdvbA4eVnwenekna99GcTvASN
2094	B62qrziEvMYiHFbNwDdGN6pdDMQi3gRsS7UzztfFUScFrCAhv39g9jB
2098	B62qmnwtz1MHzqLiPgvtTFDeZUAQY433dcz6Fr28BsyxH43BDjg6xki
2100	B62qo796MaenhLn93Mie4mX2LsWheqU8H8DjuWwDt4HHrN62BP9ZEWx
2101	B62qq9TYt22XUS9xHz1pJLyzxpSEbnMCqWgDsLBPA173hg8cvix23UW
2102	B62qrGjLR3RJJEr47shf6rHYPFmmLDqxCvhdBBR3GwSRpoQdQ3nNzM2
2108	B62qqe8M6mPEytJ1t8QKUwR4TnbeNBzB8NY3m3AniDDjiSEhBQW4oUq
2109	B62qrtWfgE7HwWRV8AYNKmMUbjywdQ2Mb76T4wmE5UjsnaPBx9F17t8
2110	B62qpUeFzDgvq2LX4ucHwqLjwBBAWzy2gK5a2BSLF9oAfCTBazW2Mwm
2127	B62qmuSSAvuMuTD59BaTuco7MgpDsCaA37Tui2cL6fMhFsA1YqsxtDS
2128	B62qrdvbJHZw6XSseuwzjRuaSUsmRdm6nvtY5nmZafGU6PRw3VyAKB9
2130	B62qox1MBZiBD59GtFV4HhbKmzhENBH3wRiux3FVAXSXgKjWFXzt4Za
2132	B62qqZei3kq718y2yUsJz5CUsJs1cj96DUV3kM2XPYvhQG6dcEe7jZ1
2133	B62qktYjLR4e9YBeC1LYF2S67g1sxyquh51q13tLuaJTHNxQ5MCs7U6
2134	B62qmMypEDCchUgPD6RU99gVKXJcY46urKdjbFmG5cYtaVpfKysXTz6
1919	B62qm7A25Dq4UQUtcXK1YntH4THoANVbW3NxnubqqmUnDd9riBPreD7
1920	B62qrnTQ7kMaZaVzbsPHmXC1EvT9gfK7qVaaDdsfzieMBtAoJrtMJWW
1921	B62qkkHEer6Je9Te9xQao6d6egM7foGG3NCzysBW4wCUrZNbagDtJrN
1922	B62qqUMmVp1B33YwWcifDGs7fScgU1AKmE9FoikxFeWzctr9ihVUq4o
1923	B62qjq4PiAu73qvvposB9zBtDdkv6k56yeUrTVvgHBifWp2SQBhu7J3
1933	B62qpn3hY83x3acuJ4XTFqZmbYfAim76AXjfduxbrn1uEJv8YGafNz2
1953	B62qpVNZuJkijxcHLbRnwSYv4SZUYRT1HbgzKTRLK2Mk59mZe4MBfeC
1954	B62qoEDUZkBVq4K5YMJU1HRMmTwFc7d1E3KAeX9cmhxMRq6LBmmUMXm
1955	B62qofqwVRXFsHc3qw6n5sMQuukS8fatHXQDoqdopqS2vfS9NeWoWjs
1956	B62qmak9tRyrRdmGssZPuEAnk1YjhrhQW4KSLUbhVmeyzBdkrdhdYNV
1957	B62qkoh7Qx6gKffrRoEWtbTFHDxs4DkJruykA8DP2fYNLZsRWGFenaJ
1964	B62qnzEf9uy89SQwquaNJDQQKKfnwVGMbtrDajie8fiNxeVzgmVHWMT
1969	B62qjie4x6xnW7Hv4xqMQeP1kZEGdjb2zpuu9LVNduXWLuhfZMftWLb
1972	B62qmt4SqMXTa21iWkxfgy2Dd89HSWTkWpdRzWNrUPLQTCBbxtdhw9X
1973	B62qqEd5LmnmtnG76c1GNFW1cHZFqF3VGMe6yGMFG2UggaNoZCTEf75
1982	B62qqgycUT6vSgvqzobVeqfqdcscw9QRbY9gaa538sLSaJKEBceKziZ
1983	B62qnACQSm22JU9bGNcp8JBUt2cGrMLTgn4pitFjGTHJ4WztLpNH1gX
1985	B62qrup3K6XXvHC46n6FdHmhUNJL5qL6MztSMFNptCE2VUCpG7ca2jr
1991	B62qiUYSjLkQuvgouQ1HarLdtBLvwtoueTZvRWP3hm7UDjvryWJydb8
1992	B62qiVr4Wy6yKhxNV49Npnpr2XF5AhsFejFWWQpWKARQpTYsb9snNZY
1998	B62qizhhKAoUxDtcLaR3QkhvPx4UPS1Ez9TDh5KRFins7Q7ZpNZ7rra
1999	B62qnG63BqGxWVvypQ1tDVXEfF9G8rQFKM813qMGmKJBBhi6ie12Zbi
2004	B62qp347ak7H6T1PvZB1s6YPsLLFTUjQ8McwSS4mQxLRLfxAzAt9rhD
2005	B62qogajGaGkDG9PCJj2LZkS5QEGKK1f33ZiNwhDXXGJB5Mg7c9ToCq
2008	B62qpNa9hPxoQpEpzNDmCSef492jfh2epfzps8NSHafDpQLHwCSTwae
2014	B62qoTA6zhHaxeEfKDTLWLbotcKzDR1186KemeAvFs99TjchvcXCRQJ
2021	B62qryLSdV89jBnpGKu7ZAYJuy4rMcWis6QQsoXMi17tnnR5jrvr7U7
2024	B62qjEXVmh3ZKzqc4Va8iLP9YWV1HFc2Bs9fjFCrxZm1Xvtc1eygHAk
2027	B62qnHzAUSe9gogqvj9YcmEtc6v3VrLWCMqKe9kSsfFeXbuPVkGp2zU
2031	B62qnPoTgjcTShzWpHHKWitN6XNroMYuim9QPujJB4zJDCrmwR3MkRU
2034	B62qrdb7SBs3BtZRQcb76ZseASgq4nVCQofJg6FCYfEd98yLvCJ86zs
2035	B62qpNGqChEZYrfDin4vbATAWSQwr8DsRiUSmSNg7jPTPTZXz5GcQLa
2037	B62qmFZntkkSapm3aM4jBgVJuwEG76gNm9izY72RMJ4sE1KZwEJHoTR
2038	B62qkobcfsQdmH5WGXtW3MrwXxmUoexUNidydR1Vpuz6jTzNL5QQ2Ev
2039	B62qjEYFz2EZ8taPdTx597U9dpCfEha6WgTQwUqwN45NrmRoiXrYvrp
2040	B62qnSqMtngvR8yjgNq3hnjwhYPCyDSQysSg1gWW9jAAhcWT3gQwXiC
2043	B62qmLU6FSaYw9VapsQvUt2pbwxiq8NGudTVHP9CEy412timPW7pxgn
2045	B62qotyJNayfi1ohMVQCgmLtutq46oMVzKFW59FVjrABqDRoeA13bG1
2047	B62qjRSQFmCe9oNUPXLBWmkQw7XGdT7xSQnjdno3b17F7LigPNtBBPL
2049	B62qmPbC1i8Z95gJoeETYggkXwMWAnszMV8kSFUNUkGE74hqJaN8ahK
2054	B62qnGEY6nV4JWKQoiGPtNVNEjoceWD5JRGJge2Dtu5pLmW87RLKzuR
2058	B62qismRE8v8sPKR8hPSUzdyHLwXu1nCXZuGuWDWsbb6ZDxMLWAAnnk
2063	B62qk9Vxn44SnxpEh9AnNjBHoarVBb53mCjZq8goiqWRqU4gWJ19qYF
2068	B62qmuke2gkU8hTpm9wst35hngu3pJoyjj9FUCGh2rH54dLXS3gfbPE
2073	B62qj5pJ7ZLKauDhhviYNpV8B6BpmZ3a9mXBjZMVJNNsQy3rpmnudoN
2075	B62qkBLr1DPC5bv9P2HKaewmekeT5TFA96dcLf5SMe3iL8rTNe9kKBN
2076	B62qkAJ1fTysBUA7ZDkCn11H1Uj5yRwqK9SyQkrPrX7egeKzWVT9VbK
2079	B62qn5cKTSSG3X3BMa6xXnQKxmg4kNnR34m3bAWAgtBimwus1uj1TJY
2082	B62qn2H9WhvP2K6EhknZmceV2ZUUyFxbEgDJ4QcJVMKgd8UGCac6b6W
2096	B62qrGteNDjBoYqjwXdJpcUBuL4grFjMRtEbhe3EbhAbnzeDW8jjsMh
2097	B62qjWaGC8zauCVcwvBdzm8wwNrr8t5wxT1r1MXxGi2pq7gUGDwrX7n
2103	B62qn1tpEukmcedsD8G7sV9nK87PHjhBYNR2VsFQ8VTxxJqQofPD2i5
2104	B62qou8aK1NJ9y3hsFhuHq4BEcUsLr3SmoBfuB647gnrhEQH9njbgky
2106	B62qnp23m2yBji2kY8zwH1AGRT8ofdWGM5JYgJXbLB7JJgWNRQ8GnpZ
2119	B62qjrNteTPA2h225Zos7Xr1z8SXBf9GdtTh8NSHZiT24a6YpH2zL91
2123	B62qoAQaeZwpJkyKpZqUFtkqqBLJqkLHvB1A7TUcbDfMp59A2KhE1Nb
2131	B62qja8uuDLumKoP12KJMt9pLJFkiyhXP19iGqkX2ByDDgg1krjusAs
1924	B62qmpXjgcCjKesRueXkM7KsiZNQWDop6LrD37TTQKm44REz8ZuYQsJ
1926	B62qjGXKTmoJGPPZuzYDzJwzdkjeFN8LvWRVKdEiMAGP4UoWYRs7AZx
1928	B62qo4YTTEW25FunXQbgspAe8ppysEnRPzwwKioTy3Bwvqct3sVb8gZ
1930	B62qnb3213nABUCcMzbAxA1o8Hvdim9eWTvj3HFM946cosm56JPFDar
1931	B62qoSW4roeBDPxBSuuK3JjcZCtiaaF5ZQyVNsK2MJ6c64PhbqMuJys
1943	B62qoU3xZa6dzUijFNGWoHnwFXoVtaWHAobbVcbYQLNCp17qqZNSiFq
1944	B62qnvdzEyZgN6HpzeP26fWi2zZXwkULG4suepuwvoNuWzW3Y5u28Ud
1952	B62qo5HSvcyaQTDUBQn7tdLMkqBXQHUkzH9aSV6aUK1YFXXe7ETuMGK
1966	B62qibgmLHgsNEkSnkUUKL2nNDmwq5oF8e6gn52m66XJRbFgqPf2r6S
1967	B62qoV3nXK5krEh4stzpR28YGwrQrJov8WsxAMXGiS1s9hKjqJs2FtP
1974	B62qrwpHTcLUq9epwFLbhu45hUjy7wjSjkwqcXuChbyGSBtHu5Ah5GY
1975	B62qrZc6nnhU1vq3uA5xHpzfBhkDdirPXvgHPqL8mAa8DreziWgh98k
1976	B62qnfgwdc2HDBeK6TFkwvvypCAb7vjCChj5YZJERUBGmkdHn6rFgpb
1979	B62qmW9rZ4wKXuCq4T55CYUviTqYZC7kTWJ6bfxo8YQC8ASuohr4caU
1984	B62qoUFfpadvrXWqmb7EjZpaGt6XsQySA8WkjcbUXwR2vb3JJbJsv7g
1988	B62qpGd5NJe6oLytAypn6gWD5rxeB4TCatLdDfD4k8KQN8NAD1huzMp
1990	B62qoSgA8gPSbooD4BBWXe1hNes7LWBzFVz5ksnU7nWQpiDJ5SaBgAY
2000	B62qnD3BjmwCYg7aeFqBmxSTdg9VA9zFttCMNxfPUEiEfKmgTNqRZxs
2001	B62qqJPhfmmwq41ydS8AvyNJtirRStnK2AppHykgHXYKpizWMeJb4f9
2002	B62qmikeLyqKvHcLwD5ZqwpcnmaX9cAjQuX5iZwZ5xjJpAsNHibcRyB
2003	B62qiefFsu75RVCL8cBjz1iq8d1p5X1wbX8iddmEUsq9UwuDrimPuo5
2006	B62qnEn8w41jaBHwVnQe5dK56L3VH7jLp7oUXFwHxuQvBpKEFmqmv8v
2007	B62qk63gVpxBwMHDmMqJ6aNnN1btL8XU9SucD7zZjA9MVVykMXwpn9D
2011	B62qk72JPz6sXmA8k2R4An2hmC58mUHSq5tmkGy5HLUEurYXM8FZy47
2012	B62qr379zCS1AxEPZbovr7kcGsURqAKqEfpfgF275NNi5WHozWUMFRG
2023	B62qiU9KxfA1LpeLUSckw9Z46RWx5JcxkxkHTUosthJCYuyCJknXVBR
2028	B62qp8qsUVcMwz1xYWh1Ed68MwQVq669CQR288Br7Cv2o3xki3XnPdN
2029	B62qovXrgzCnqtSSLHQ5C8mjyX4gMTkRj45cRjB1osQ3KUq8UHpC8hc
2036	B62qowcWy4KA4iXTMMssHRwS2zBRV4eBsoqi5Yii2mJEKcoPbp9UWiJ
2041	B62qmshRuMHKN7Pf4AMppVbh9SzM8Y7qS95wvAtboneoPjDtgehn33f
2042	B62qmEgXFbK4YS4aAwkNPLgTQMh8HgTMfoMnyXteqfJwRTJk39H4ucz
2046	B62qmka1W5zy7uskyz8UN6B3gvg1pyhX2muSKKVFHGJSn2KSj2KnJuC
2051	B62qkZz3sLuNCNGmAsYLFgs2sxWXFiaunVpM7tgEoaqRjFfrxPJZe63
2052	B62qmxpfA5po66zgUYngBEipPsg8nkQ4HjF7frrJWwUEEuNCq8TTNSd
2053	B62qjyaV1qV1WSqPcvAkFhydLWgmNb4mDqC6DTAwAACRNha7tsMpuEQ
2055	B62qoNRSJwu7D7ZySo4WRbgdqay6mD1B5RyyF5czsdbC23DuU34aFZA
2056	B62qiimxmkKhYAjw3vWUJMxbDyrfT6hiqWY27fgTzatL51wW84tKuzr
2060	B62qjNK63FYijC9cgrBipgMFXMzM3gSJxc4VJ3powsLXFCW6o7vGfFf
2061	B62qmKqDRmbie4VYe7YhezcBcwo4RZDk7Q7eUVe5jK2LXVTKXMQuvTr
2066	B62qpzgkFRzpjhU3EESLYJZ9vX4YM8FXgbkv2sZvJRs1uqSvjn2ffnU
2067	B62qmStQMUHCTiCKuj265mXu3ijynY8Fc2EvD4ZgK69Qr5rXziRq8wv
2069	B62qmP4BesZatttcQcFJzSQbmZLt8JYwh3wV4ZTVYN3ukGFSPgvNSK2
2070	B62qig6zfSb1NuyHkhaMT7UDhddiRoY8boizZzSXcnNzYCP5vvddthA
2071	B62qr6bD1BcXTePnEgGQNybTgS842xRCV44FuqvktDo85Enj7AvBVQT
2072	B62qnTd3svLTn2PtUqyLacFLowZHqhDNCuLnAGCnGxHRA5gDZsw3uuA
2074	B62qjHEuNn6pN5BEzQkGddZxExGqRisRc9A7GindNrFXUE4A8yD7tfL
2078	B62qnVc2wA9CWnragB64ztC3tjSt26CVUmZVVyhvqnNEsLza1Esd8KD
2084	B62qmtukMUNYtYpRPf5PDz2KjVhkLrXNK19YHWMSeRH5DReKyBt6GiA
2086	B62qinpqDF7ongjhpvJLz7QBsExP1BkpceED6GuThYYbSVSbk1nWCvh
2088	B62qjsWBkTwH1yXwjJ4M2KBRuu4aF3phSmTg4MnavyjrV2sRvzHNbC4
2089	B62qkBrcTbf7KRPf5R37waqVxN84Liia4u2uhDDvrJhVvpkFCurXSpb
2090	B62qraUTTo6Wdjgkg5RNLo5AJ7dPbjgJqXGKJaDnxm3BszrhspCDM1q
2092	B62qnimiorrnmwjAfVQZGW6xAeN8M7HPb5Ucxq9rFnUhy32B6Qztayt
2099	B62qmm9xRxV5cui2pWU1dj4NttGkcMdPNvPcUbRDnbqUCF8fG9WYVoZ
2105	B62qjPRhYDRwTbSwUHpQovZBwNK7FG377xSinoeJDkNByKC19z2Yfj5
2113	B62qkWGRm7hdwLb2UhDksGhKuKvumN7oVVNDC7QdRHDeAQftXGaNpzS
2115	B62qmijyoDUqSGdovtao1mes7XzctDs1g2FedJAPQy2VdL4j1eyHAR9
2116	B62qpScK28kE2CfNgwYQAC4MDKFxVBNxK9SfoDDBdTTwtvt6MCXq3m9
2118	B62qkSBhAfNNgJS8NJtbGjnqH17SC7zXyUFJivM8BCDscwRx94JMb8P
2120	B62qoxkZwL6MMq8SpVicdA587f9F6kaKrjrDzV8Vo6Fcjk6tyc6ybR7
2121	B62qkWc6dWa6bYmYStMgZ9c9DXAovikTBgJmScC9y7ymUr6GY3ucJDq
2122	B62qpygpgtwwihqinfPjLMC3u6WzRAZR2JPHwjz8zWy4kXKRmi3o7rU
2129	B62qqA6TsQdKBNpyS2mkAb19eSFf4qmkEaxxK4KayenFW1sCvyYfr9G
1925	B62qmjKfsyWRNVrvDzsfVxXiPRvv5vTQTs7Ym7BACgJB1uHn6MRxpr7
1927	B62qq2Cstm71ZXgurrEkiRsebH8K2ftZhLsxDEULSFEw33kfJVC6mhU
1929	B62qouoMhfitj2CAtg8RZG848bVYoVxpsVrx8yHjjvfUpxveo6rx3Jk
1932	B62qkkAJBhcL3wtXVAEkKj6JiHxzqDYGgM324gxRHrsqb2HeDuSw42y
1950	B62qjt5GzHKrNZNx5gNBn9ebrAhHRQ62BmwvS5BvcLRUb2R1zqch28s
1951	B62qmRtGaa4HisAfEhqRTbjcqDu9jV3cmhXtNyZoWc4vtLkUygc8mm3
1958	B62qnwwPAcDA9TLcjVLoyCcGmf7tWgfRrFk1TTC4YWJJsNQymNEEZ1s
1959	B62qkWFmcKbDwNM35ZRphHJjSBU98jUuWApXc34h6YueWkjADub7cRq
1960	B62qiYvhok9dD1yXQXcmVPZZ8LjB8jrh6WNoWrVBtubcMSXN5Kas8KN
1962	B62qmPxdtJAufkMVG5xtNNmkrFoLH4Z1P3itV1SBAGXHnHexgozX4bi
1963	B62qqWQ1NLEPPP6j2evUrV2CdQfDipB83doTtJVGR4HvLtrCKa2zA2f
1968	B62qrgdoYb6pXJbj5Y1vvuaubjrBge8MVWThQ9VywNMLPF2SehUG9kK
1970	B62qpuj3Gd7ttM7VD73phKsHydNtDEVJBzGzZNcBMDvp84jHhxHE4T2
1971	B62qqUNeSat3jkC6WNoRFKsHNtM14VcuZdrDXVSV3xozDyxgasL6xD6
1977	B62qrjHvWTkktmM645tMtc5NSFcxuVWRSpZRmAXNkSJdHDvTsR92cxG
1978	B62qoBpxByoHrq8v1SecYeDPpRRVF7LwQ8j1F3HwAdWtaT9udkCiwcC
1981	B62qrzbn423zHjKxhrmEyQtFtprG2XdVtsjsJ8atCvb9eqQYy8iz6hu
1986	B62qidMZyFso15bt7Bat5uhfwbwG3cagF7JRwGkN7oRBDSeyRnGJwDq
2010	B62qkvFDisGQD4nJsVRxLbHngnBcQ9Qet4HNZQRH2etUyCNDJ1Mg8SJ
2017	B62qpDBqtnDJT3jaC18ih7SZgbQ3BhNZ2CNg4b4fr2viLuGua3Y6ix6
2033	B62qkJUNzzm4e4ieRMQqmbRPU8qTxidjzNKJppAqsJshUDbUBPUd9SB
2062	B62qo3SDY3KAFkecdu2FE6ir7D4Nuaf4B4iz7RF8tfKJCwia2c7EpXf
2064	B62qnjpQq2uPKSsRJU4ivYYvECnY2RbkSDVsoKJn9nFkq2YPu7XazHg
2065	B62qk6saEVVccC1MfuiyGdzDoEzPHcnKc3LFNzBimaUn3JN2PuUHFnC
2077	B62qqAvmj969gumuo2tWQpBfZwkASi6Wchgi4E2WL8zv1qYEeCtmiq2
2083	B62qo1QzHKFpUkNQoBhovazgHM1D9wVSj6jJB8RwPMsidvK9b4NBnW6
2085	B62qj8wH9YcKdzHu6NXbZpWqyZrYKYGeATh5o2UFZxC45KNYcTMvNoY
2087	B62qqyZ86GsrRV96xuiStZhJW5D9fzFZvasE6aAToRH8PP2bU2TsM8V
2091	B62qkLUBPK5T7D7xWDR1Eu1m4iv1MzfTRN2tu9WZpWhTvSt6uM1ZNha
2095	B62qm4ADTv1iCFMjqAbfWKj5FzThonbsEZ1riZSwqGhAyYjZzFUrZAt
2107	B62qjDdy6otVScKCVycDuRmZDvkgZyt9iG9BFtESSdKDQF5MeeeDgJX
2111	B62qnWWPzcaTPSL8fwMpDZtUohVS6RX4k9FaC51RX5xE9NSeXd5VkMr
2112	B62qkVqyeRwAPfRTRTUTPTvVjP9EgAz9rHA7bP4RcagiurDDi2hsFic
2114	B62qqPQUBA3aWsHcvnFuMbFuecrvvtgBgGLnQ26HhB4QieYRSzx5Q6o
2117	B62qqMiasKjbhhHWSPEQxBsP3M7JoUKocmNzKDsykYMckw2SwKycsc8
2124	B62qiVYm2txgD9nVXbUF5UAw7USSMdbgiwUCAgzTW3xkC6q62E5wCHd
2125	B62qipDBP1XqNb6Ca8KZzx72M51Ge73RFUwj2mdo2CzMs22gYM8ivo3
2126	B62qjYAdgiAp92xRDbR9r8hyddzYZ3t9D2aYfpoUdUCP6LLKG1Dp3BQ
2135	B62qpA8s9wbazMmXGFENyR952kKgCofTGG6QX584Je55A5QrpqPaahW
2136	B62qq9t2nqDfUNL2xUjXpVDQjrf8DHJ2wbRm6Ndn7ALEZeJph2HRyDq
2137	B62qnheJMP5HNzgyfmRksyomeXRzewaxzrFyoUXAESdbdJEuLDBcVdA
2138	B62qiUby6BGwWhLJbGvA2iGy8MP74G8zmFEMSTg3U1gn5Rs1bqYAyJd
2139	B62qmT4iat1MoEWS6jmDrJmZJE9qx3KEXyMzxdx7gwUUHHh2N59qPev
2140	B62qpvkY4ynRcGpa8vs4zHJ7eRD5DDiSBkdmuTcXmJSGjxrJBeABqNm
2141	B62qkkmizJFb6LnN4g9zHHj6ftjptA58oo5iogPz7dyiB2WS8i1ucf8
2142	B62qqCJP2ktY8bZUFr7bRoT2kDpnEPRxuCHaQ9Vqxx1VitXSojH9Fj5
2143	B62qm8ZLQtkMw6k3fATYWaFjeQeie1sY6k2fpqzGpNP1VymSrdysWwm
2144	B62qqfJoY4TdtG6L7TdYXHjTZQwxpLEc6snrkEmdzCXGNViUJpdWG4P
2145	B62qpgsBxnNsiEPAArCNV97SMaFa8C8iEUXzcia2wLfy39j94N4jez2
2146	B62qrkNMmZnBHYhbiRxS8NpwKyo7NH51NC2R1uv1ecWdNRbzys3mQQi
2147	B62qkSLiTdjcqtcrdnKjNF8oTAVnnodQc4PhWmdQ2xu9CYaZDMmE5RD
2148	B62qrLfafrjfvBuGngrJj689ZwuxWHXfTcq6URME9jScxGbZer6ChpN
2149	B62qn9Av22qKuvvksYE2jyMeaUNZtMwd8aodPhwCurJoiz5n1daioQ5
2150	B62qjmbfc7d9NwTnefuPuQ2YP4F7xNoEc6bx7p96FzHuWQ4SrWD1Jqz
2151	B62qptdTu4AQFhgMa4T86bhaFUa9QvLARf5MA3BJRmmZqw7nKXBhAsh
2152	B62qrGxAKDzSoVRTDfq5KBPwaUfoxmzFKVUpWhx1K1ZkaVC972LLqQY
2153	B62qrcQDeAfg2qSnZhdF8wQ78G9QmKNDqpESVt2SL43F97kF3Cyv32a
2154	B62qqndeyJZupbkDyGiBevauyjysafEJimAyFB4Mn8D1N12seKs2LQB
2155	B62qrHykZSUQaQrDz7t2xsWMzSPzKuXNSM7BeVDi9xTnHx96bEPDFTF
2156	B62qitwBaAcXeytS5kMCW5HeDx6BgAYaz7NKRHZeL9ozWTTGBFN1MTo
2157	B62qmYgRXPrwWmtPDBHX4RMtQfuaieKJCb6LonwHZz7WgdhrwTsQiiZ
2158	B62qkVMUsmXF5LVdRQ2CsUgH4GWLDQuPH1gycL1dGHgzkfHLZ3wQBxW
2159	B62qrt6SHwxc1Lr8nkvtRfC7NJ5YFmtbNm1kp2WPbQ8y9PnXMUMkJt2
2160	B62qmi8GmU1vYkjgRjqgsd2NC7cNv63HD5FQ3VdYAMDPcCE835vhmS6
2161	B62qmm6F7tdRg17rVLxpRUZFGThAWFZNYVaeX5uu2pyME2YLbb61zEA
2162	B62qihX4MsXbU1er3fu8EWqbyLBccgropv2kQPtWgLRNpn55t8m5QEa
2163	B62qjZBFstncJwSJ15HQZXfY9agDMs2uWiFo9dATRBYWVGm4ffJ7MRE
2164	B62qkd36WgsePzNcxN5dnkdpupB8H7BvfnZ7XMyGgWEBHVYdHcNYeb6
2165	B62qjNxZ9Lqe3BdZxtCD8rFzRwkiw2SG2qpBteVkeij1VEEbiLHhoHJ
2166	B62qosYKGkVbE7oDMgLHr4qSEB7nzYHoLLmuP6jBKSFjPCuJvUxTFPF
2167	B62qisZkjVZyMm4fkqxVmDRGEjzNjdekVZG7QwrHCZMSo6KmaiochhU
2168	B62qnED25tUNWUkPtDFjZCkUcRw84a8B6zWagk9Na1kyJXZe9YKuvoj
2169	B62qo69iKxuRHiJHnBH648VdvPWs65z9jxg7AQfKKB3MFWAxtsiPUqe
2170	B62qnUuajcSR1W7XDUR1SqGTXN7ZkdSRpSgXCHFJKjwdFfoy6BiKVNh
2171	B62qrokRxhF4D2U69eP1qnQhFsxSw7YR29KgmSJXeFXF1PnDjoEzCgZ
2172	B62qneTvRN68XUGgsAQnXM1PCiUFV3iJkbcAnszmLKPBHxk85DD5ryp
2173	B62qkJuYFFQbGHbXjKYArNRV6MW893K5gmHP1nLarX3FQVp4rA9u2GZ
2174	B62qq63ipcgNiwTq276qynfR84uEc9KvMVjbgJDNjtdgwJtE5qXxmp4
2175	B62qnCVS46VTez1mbVcwCZ33zvEpuodQT3YGV5qf6zXQg4PhtxPyRUQ
2176	B62qnJ1qU15ySPogWTQnT9WJpTxAuSs4tQvaYxhYfNiVrFuo8VgYXb9
2177	B62qnhqVYSaejVP3jYjcFuS8b9FTXeV471XRdbwteb461YvVSpEndTV
2178	B62qpMDo4uU7eJ9maN6exARcHq81oXRBJPPNNFxWN2Hh2Khz2GRZafJ
2179	B62qq59mQV7QPq7QE9hrbdd46kSVciT2otWjfA7vgQiFf3WdKCqwFaY
2180	B62qmaGsWHvxnFDEX3p1eTNetLhRCXgVVmjYjShjsnQjsjipGTZufYK
2181	B62qq7jDazmvSkXj8WWsoW2tg7fMm1zwZXKnNEmMd9qZ4t7nC7YGKcK
2182	B62qmPPaY3aJ5gu4WFzo8G1Gt1aEFWreEq6PcbVzCmch6VAxrWEg2tG
2183	B62qrDtE96Epe5MWiy4uCbNhFCg2cAnKn6HfjsdBXMVDnwCZzkses7r
2184	B62qqSambmB1K4mBW4HKUHQb9e76ipgfMWGqWMA1MVQS2M7tcX1uxsD
2185	B62qmLaTYw79BfY4b5627AxxSqWF4XiRzupEmF9mnfzmBwpwcPE1wSz
2189	B62qmiX2avSMaNqpbE8t1xXHHjLo5EeKDJFNhWduwSZKZ8Ei3uBWrjJ
2199	B62qmXA85uRv9D24vKPnw56cBE8LMGYP1WqoEG5CidXUfFBjkQp8YnQ
2226	B62qmRqAfYV7tUuTDPaPXN8ETtvkWQ3Syqo3bWfsS6utqXdhiLpb9eN
2233	B62qk1TjuW9PjMFf1D4Wj6EsYJmZgtmN3ndQrjvFSmr7YMRmULPV8Em
2237	B62qjSckZssZ9iFJdTm8KJwco91xysqrmwcMibaQu895719sdLT6kcw
2245	B62qrdz9hmv8ACy5NKxn3RBa7vnHZsx8QE6x283GVJRU6YXZiskMdnv
2247	B62qjuURfaLA3oFjSyBooqC1hHQ2PKMBTrYAvhodP3z4vKCfWqXiXtJ
2254	B62qroBzE5d6ZiTu9zCmfHQjbcTyX4SSgAfthhbY2JP58zDVhewfe6u
2255	B62qnc7PeQ5DSthQ2wiYiwtHJDNsTbqg7tVnp7JmvqkrX9Cx3kqhqtp
2256	B62qkUCzCdJzVjQYgBcuzSDbiQkSidXc1axn6TGvRFzhCR1bSeYfkUn
2266	B62qoShNTJW5AsjAc94XHxVGxY4Lii1uTpMvqxdM5nESU6iWkUwWh74
2269	B62qk3SZheQgsdB5Xs163ZeZeNjPGThpbRrtrGNdJRgf9RjwHiP747u
2271	B62qoWwgjebeJNjUuGLhqkswcGA2rLqSjj1ASMYro9PyQrvpA4gWCxe
2275	B62qns6oZnK76hKoTAqbh8WJ8RCaHtJm3LHwJM9PqhVEThwzMsxV1yM
2276	B62qrqpudFHnGhopUVL9m8n7L2MSmfeRCqV5XfWCNpomB1MmS9NWz6b
2277	B62qrQbqbGoX8QaCZtcmFshf818gfk5Bha8vDmkMjv5PpG374HqM3JV
2278	B62qnpTQgwEU3Qn3x5ZgTw1kmXVo6PfyYQZ7iWaehf6jkjY12biyKfD
2279	B62qnJqYbFyZTyE2t89ZCvDA4zcJfk2TAA8gh7QvPNYcN7eEc4zokNr
2291	B62qpoqQHEwyrUrwXjNH4ifPWkzUsidnSaLedqhUtDrkqAsVqnw25qV
2293	B62qkFjfsbLKvmUB2uiXjdKdibs8gPHXQ2boLU4UGLwBmXwoch6mhRD
2294	B62qoEXhyrQGiQRJszxVbK19hKFM4HpAJVMdt6jN9j5CPvCSozv7iXt
2296	B62qqzCefTDcN1AnCrLiEzGD21s6E6pdFrexbjXfuinQTrwCgb5gAy1
2302	B62qkx12qeftf2VCKUKobwJAXpXBbrJSHWJicVs12oMuuwQprK1PNL5
2304	B62qkqrdXNejArVW6ZUEZRUhUxAEMoMeGJLdjzSEDdmvitktc4ZdkBG
2309	B62qjj1M1JdKHyrbTj6Fk2BhG1SpLnBbaKfiQMTRPR5FSxhNT1LLUCK
2311	B62qkkPvTLfyypaVtMNGCiUVfL3Dx2VSZh9R9skGLSDX21yiPBWsX9G
2321	B62qogaPmwzwr3fzD3zd5ikSFTu9Ri1C4nR9PYD4u7DS7CLiT7wwQqN
2322	B62qip1McakBSHpgQt3XbJtT7JqFJ94JgZmtPq4Uprm8mXE6xSDKLg3
2323	B62qoGuvwCnAfSYKpbBWF6MSoHgJ1K1SDa1Jz5t8AmhUWbsCwTUwjiE
2324	B62qqy6iDbg9SR7NhR8Ur7RqyzvUJDyhDbtCkA3ay6A6EhycBkv5qQv
2332	B62qqyvaakwp9QM8FUt1nT3aEXELZjZAJbTTqf5HJz4Mjy1cFQfBVww
2333	B62qmNBDmw5SHf5j76hws5yUJnWxuoLJLo18qKf1AbLEe2bxSBBqSDz
2334	B62qoWJBVBW82eEy5iQzFtVvx8fGovKmUkREBNoDGFJ2HRJvRkXCuK4
2335	B62qoPhH1rdSdsYW4hiNdsg6XGGYd8n4P7Ywkerw8fJGP6dMdgp4Ag5
2338	B62qkY7W1bs87iDm1dgUXDCvKJQWvXg7Vdh3zYfCqRDuKRrjDJZKEHD
2349	B62qnckfyCfbG1THZzik4icaW5RFmY2NhP3t7SL9bHjJMjhS7ZDtdye
2350	B62qpRee6By1yY6McKRDeQFtB7XmTovfphsrxxbkvvTKAwewy39xoPr
2353	B62qj75JEjLmp7GCEN9Umzk4r6sUJ78MPxkf3UygJermyAAr4RNji58
2357	B62qrh6VesZPmQqeHx4NAG8CY7XHUbMfz3tLhQfqF9psUeJE3EPReCm
2358	B62qqqqn8brSuZPwMRAPdaS87zeR47jTvn2DhWh7ujd5MpMN13hWFLH
2359	B62qnaNZ1ruxs4aVKRHtB27FmVW3eDyCPwJQQa586gHtM39j5j5KpZV
2360	B62qkUsbgEAbcqyVmFr8cAhCHswoqXduGEXpxrp6ccJRGfcpDMhQGdL
2361	B62qpw7qJWuvnEXXDZ7EwCs7qrARCLYA84LY9XTKGvQnANkVANNZeNM
2371	B62qpqv3rth3GjZwTshnZXBdpifvfca7RATfVoRd4xwNTusDCWcz3nk
2372	B62qizMVCEvVHqnwvfbWiHBLdmR6twSyfuNc5n24JMTme3LqeBagXS7
2373	B62qpiwb62dE5s6a2FeUq8nKPjXoD2iv2MWQmySQxfEDE7z2v2UXHgR
2374	B62qntdpnRQPJRzAq4eMbj9mfBcN9ZFAdkQLNSAcf11AeJNQbdBEKby
2375	B62qpw1a41EiHs3cdv1Crddy4nARkbgDvKCPAcaz2fP9xxBQXnLefnP
2377	B62qqPyE1kH4rwoHjnviwoKnArqMg9ZPBwVp5scDgqxF8NrPUzVtUA7
2378	B62qqCuuRXy69sKa23xarRnFfvzCsLqtLizYzGzoJNxaZFVyEs1RDq6
2379	B62qqL2n1ZfHXgCQkXmzb77QtgQio9A763uqDicbYy5k2ZnyUFyCqv8
2384	B62qo85u3qL5J3oivYyMRkk21DMCkw5ijRq2qJwMzDZr25BMUNEU7Qx
2186	B62qj7JFWbvroTA3yQvt5C4Xr2xS6RcdkPakojAmF5yNeM8Si6F7p51
2188	B62qnbyCt7LeyHmYJfUuM1fBnXYuEe3R4Q36TUq9UBd4eKuoiQAmd9s
2197	B62qqJwhSbsXxWc7GHhy7JsyHR5315aAzFkA3kLTkJNAcPDVuaNXLLj
2201	B62qq9KRiY6xTPz7zYAXkiJMoDgi6wqJpQJiNzjPSng2vYjRtYkezGE
2202	B62qo9u35famXFh3j31JrXexF4t5XhZBtQoovxbBXhVSH9NzeUE4FzL
2203	B62qjdj88dX6wwcmtMd4auEdv5Ck3GvVeAxmaP5MNnhhP2NtecqWZhJ
2204	B62qnh6aJQ3gDZ4Q899uvfzMS2WqQdDgu9HYZ2ZRJCddBZvNjgprTL5
2205	B62qioDwzFaEihdAh4GnxzcFhp2aE4E6YaypJX6XFx5jxa1gstNKKuJ
2206	B62qpgLV2xuVrt58vz79NEMogTZnZmGRSrD9RtaBKBbj153Sgb2EMDA
2207	B62qje12sDsYBLV9ohN7sUqGNpVxURAWPZjPPvjot1NKoCRZzpfNiQf
2208	B62qpRjbpEJBB5Ks7yvEXoqd2RqogS7TspcTZhynoVkWwD3qoxSCt6Z
2209	B62qqqymeaaTNE7VXn5jgqz71Dk3q2AsChZYnGHheNdV2WuuaySs9Sk
2210	B62qj7SN8U6UckUEmwK8B4DQ8yTA6573F4E9uyhhrS1rsLpsUnAmUuy
2224	B62qrQg7EdDnCR59vRHhzd1kV2QpCqG17wSGAt4td9h5M6otgPAvzQC
2227	B62qrhgtNEPfijQFV4Z11GhzCKtyKRzeoyBjMhr8Nra7peEZnRTTsL9
2234	B62qkbLpGszR5vvivVgJiaN539cxELhn3Eaw9sLZRCG8MwaTCmCaWCz
2236	B62qpToVdsKhd2H5CsNj8g3gwhF1wWv8pueASKUgCqjCwoY3NgkXtDJ
2240	B62qnWLrw5TdZgKjnAKXUjNrXYvHaFeJ5GD8fnbYf9sZin7gp9hfjFu
2248	B62qrcYedNNf4nt9d4RdEXUTRYsQiCbsc9RFz7cABFgVCPgaEau8Y8Z
2261	B62qqwqdGTxj8ZmAoNgSxmAoKHptpdsWAY2QJc5NjGGZ98mDhuQrEKD
2292	B62qoryMTkdMWzGosiUbLUwcyzgfg9WdtsoqkWgHkgzoqwcMossuZWw
2295	B62qoM9SJD7XqPKjW997sUjVA3yLfEhw1woy44CtMuZBm5HnxMPU9sc
2300	B62qjWhNnXqNV9fHC9ipb1gT3SxaeDfquen82epKdyMzsA9UZW7uJ9v
2305	B62qmhUojNL5K3i8ds2p5Dk5TL3SoWRqhA3a1DnKKpUrwSWTGUWHo7q
2307	B62qjDXHqgVsa3Be6Ca1GmiC3wJSWrcLKhev1qNmbrExoNK1t9yJtVn
2308	B62qkZMGZbxKWACT4zzM5u6LrL13pAbCTFscz8VV194m8DK1N68seUx
2310	B62qjuYU7Dhd3DVeWZ5R9mdU2Gb5C5A6nrNueqFmCEsq14Rv7vx2z1p
2314	B62qkGVQSuxQuLN2dJx9JdWFWHCSMLWSq66hfvxxK7gWYYdZdScJb7D
2317	B62qnHNpJznWvjaJQ4VNtDZ7nyDocGvAZj6Rnut9gmCCowJKZcW3NFJ
2318	B62qnP7j5Tsv67MYRGcRT9L4pyJe3LiEH4g7j74qwbpt9xkt3DXGJhX
2327	B62qocNBz2Fw2kQ8wEUvuCAT1PRUhUtYWYvUugwuQuhBZrhREb4Xg6D
2330	B62qrZnqAJkuTD3QVp9vHSRjx2fhE7vnCeL8BzqrXq1ksoJSvJPtHPh
2331	B62qqHASskyPQ4DRyVMz89KZhX7eU5Xp3w8ASBMuH2CGMgd8FotdrKH
2336	B62qoW9DqUPD9drtEE4r66Qxe1DPpTkTrQavJGztFoUY48JjPv6qd2N
2337	B62qkZrLGvi8g3cFPTPFF8NGg1WwQXZWwxSbQ732g141wuGSJQtGjUF
2339	B62qm1zuXxuzVUMBBm3Sw2chbps2EdX1YLzUfpSBrHKJFrvTwnYSSjZ
2341	B62qqyPtNsQobfVGuzVJZjRFjc3uQMESUth3y7XaJQGcKjrZZ7XKQK3
2347	B62qqJPuprJjt97CWibipjJUf7V3QRznbYoKfMXYe4RipyRueJdP8w6
2362	B62qnRkQsuqdSHUG3XWDJdQjpAGfSqsAFsQAFoEwernDAwZ2VvzW9Wz
2364	B62qr6ww8pvwSn8QHAoJAd6BSVzzbL3qGT7RtyWWT2d3DEuqvxPtHTy
2365	B62qoaUNAJGMSArhgKQenJSe9DwouNZjVAk4EymFuNhhfdojNzCD2ui
2366	B62qkeRxJij91bBWJaKsWMAaAhEZ8zhbfLnzuTxm7KiDnJ2kGoE85Nn
2381	B62qojGJ8ruvEzk3qNRv4WfwWxBaFo97PNgNb2gG7yYYMDdYESsogkm
2382	B62qo1mxHoM8zmLWU3fjKEnCwnZip6zkp12TrVRZYGZnWGGGibNubaM
2383	B62qnSKh5RV7gY1Z4pRFqoNTcMuPdFNZefvM7rad6rvA49SAPWK3dRJ
2187	B62qjrTZFZ31TqaastE3ERkdhiBLNbpSyYc7wYu61ah2tVci4af5V7j
2193	B62qneNG41Tk4N7gM62nUGAiK6du46ht5Ujn9EZCdoFkidDShi8FwKX
2194	B62qoRmDPKuSxRJKozbj2nGhtwSTsvozsDTbGNgrmaX3B7iqte6if1F
2195	B62qnnTX3xjXUeZ7wcsz8UjZWexM7yHk7W2kvXi15vryR6AWDwfoCGg
2196	B62qrNqGpoFpyvexkePHYLMrrdiA7ZSbAEGzSHLQScw4aAcoDZvRJ7k
2200	B62qmiabNh66oiBZ7H8WyWrSxW4bpasPzrPWJuTu68Qo6F8LRAkkWim
2220	B62qjYAPVbU8Z6n3JoXPC887xWy1ef4dHHVQUNL8FNqwCuqVfA4JR5V
2221	B62qooYG7rR5ijCH2kuzTaL7h1Zn3jLUS4ppdb9ERtyyDuxGj2hBMmK
2222	B62qoFmU3MbQiGpttbsJp4juN856N6qCPDQhVr2uJnR7A1nSic4YBAB
2228	B62qnnZzhJtPpwc6QZKUjkLcsvD1hFQNEG3xdycsPjREg24QCnKLnRw
2229	B62qngUjXWbtbbPSwPgx6Am5WnbGpajVcMBZAvVwYXsAPXjuDcUebBD
2230	B62qixn7VPgbUTaYmF2R837PzTDjPJUNVCgEtm2kaGh9CwymNBxP3mt
2231	B62qkwFyK2M1tAQekzrfrF33bboqR3DBKo2PfHXL6mgRtzA6sVSSWdb
2232	B62qrAMfKzzYVe3nbao16vjoLLYYNREg2uhfir73vfA2rqjjNDmTrPy
2239	B62qqUoC4cA4TqWWWXP5DcrX4JyYC6B4swg3g32vTBzfY3QRFKtSAwZ
2241	B62qnQqtD7g7DbhnmzMS4iM1jyvZ3bTE9AkX79tBQtNvHRQCMt1j9uc
2242	B62qqNZaLF6JcS91UXqq9S4hJLXzUpknXy8ddnyQTQKnBBkabAB972C
2243	B62qrFSo9NUDpeRBmJXtJHQSshQ6p7U1rCrSn6mY9qgeFiMyUTQUe3m
2244	B62qjmS3fXK1zJtHc95yFyCqMMPhA5XJ9XjqN8nx8a5QmqDMF4MXVuz
2250	B62qrJD6G24muG9aaKmQLynhML1TsJF6bUxnBKkgvEqagpRVXZwrYUK
2251	B62qqvNt7VWgA2Zrpd5784Qe252C9prx738iEbB7nLodbMPZMg8ZRnk
2252	B62qiizumZvdQ95wgdjQSmMWmFqY4rUQ6rC59vhMU7fh3iweaNkbRhK
2253	B62qkxpWUxC5ptZJAgDH3MH3NctyWf3wxoq76Tjanbxka2cZx9gRY8D
2257	B62qnEBktdKjoQzQZypNsBQrEqjnLP6cDy9zKbcyLRwgLorH4udibBb
2262	B62qp1ekNDHr37RMgGyeVXcuDtTAgmcjkeS2SCsvme2SiJjS3S9xjm2
2267	B62qqHZrtdAhUT9jL9BKdbhTD18TfLBFfRTGeUCaeVXrcPBiQA7KEUe
2270	B62qouKQ82drftw9oA494YRGrV2SxRxnJbczFwTWFqezR4ntf98ExsM
2287	B62qqwCPPUFZsHyYZhncvoiWyq4c8FonAL5zvL5qAGReJog6TbAvBev
2297	B62qnmoXDcF4X82pyozed2uo3oBfHiejuUzkNiB9sR7zP2vpKYZSrKf
2298	B62qn62D9WA9C14MMU9vxaE7VspFNeVDD6BtrZ86SzzwYtRqk9Dcsir
2312	B62qp11RxBhZZu648hfKyjYmnBEUTPRrTNzV6VUT6MQqR41tznTAWak
2316	B62qme3NSDUxrb6KU47AQkrCxEp6vC3kMXHi2uXg1z9m8U8cQ84UAJG
2319	B62qmxs4ipP1cqfJPTxfK197se4HpRVP1mXoiaSU7YbECFHTH72G29H
2320	B62qr2868PzqFbRkGYxyh8pNfpk4GfLjdf9TAArMBN44paMFUouk3Fs
2326	B62qq21zrHMrsvJUrEqDYnD4vUnJNCbb8MU32ZCdwuAQoNYYKqEZgew
2328	B62qmX1ypvFvTMdTibvyJudJkLYC7kNDUNsandi3QyuefH3GCAnJmko
2329	B62qqoCMCrMCJ3Maw6RcKz565cJnapjiAXwXXjBYfH1oEuv8xND94zc
2346	B62qjkP9YTQpra5p4ujQ5AYQ9hHxgAmbNTTtwrLSoV5Ewe1vejY2jwe
2348	B62qpPw5Yu4zGnCerh51HWX86MNWz1V4Kb7f8TUZ7y4hPCwwz9UogWW
2351	B62qipZRLd721ajkGwx2cHSpXoAzivYdZvesSBfN4GZmBCExUoBgAnB
2352	B62qmBCYtiXq33YqW2rTTG8qAPKzRe5Zz1pc1aHkMmDLBU4hJSegyW2
2355	B62qnX6nQQuYzgvuvqdxsUpTdrJfXYcGg4CYweeETcRRJ5thVWcDNWm
2356	B62qiXa7zUP1YizSAowgUyBXQ9hZZkofrdFm2GGX7zjUvR36T7HSjwR
2367	B62qpBprcbaz47B4tXk8ouEYT2uWNwWMLUhiweJhv9Uy5tKCZvFTWu1
2368	B62qomFK7HYUaNsNp9M8rzAVfkC2ZinP66AqBw7AKyZ7HhADCRqv8w2
2376	B62qmmnkUhRPfuRdy5F7KZZmBTcyHcMa7CvaySpzd7UjMXeiM8FSsfg
2190	B62qm7KyQ8ocXLuR6nQTDFfwkoEfgmJGTbQoaezi3MfY174sGuX8gBa
2191	B62qoomi9S7pkzDMuyz66wJ2i5NXwnN3Ntm4iYfusP7RgHopjz5KsiT
2192	B62qjziDvun76ZNzXjrwoeua8SCNmczAww9NEWBED7trsWVryxpJT7u
2198	B62qiaMqRUdpSvX632WZWNdEk1xcAS5bwn2XDpHrZVQNZuRfUo5bsGv
2211	B62qqE4vX4yUgQioa6r2Y2xrqz2CHw5DhPK9AyrZs1jqYCwxUbUYgSG
2212	B62qmN5ySG6UAWG58n1u7nb2HQzcRAkHqFh1EquzRPSvtJmNAhrsSyC
2213	B62qqAaqe1ha2g74P5vLpot1HUutCbH2oNwi7JPArC3TXtwWSGcvubs
2214	B62qr3sZquA435QTmyQJW5pYqT5yM2tWJH8tTg59RWi64GrQkSA7yKo
2215	B62qo3DeaoniMhVd2Pdy6NkErK5SiGurGgrNWkELvknwWMX1i3TsMiB
2216	B62qmVQVKoiSNg5dxMMugXHkeM7dBecB9v2t5Leedyqmik4BkrXfZNV
2217	B62qjecKaMkfXfMUb2gvNz72ixLnhK6Vc4PSmHSQgUFebVHMoAtdbaQ
2218	B62qoyCVn3ZvhvWLXX63AoQ2bw7dnu9VrBASDYD2o6vqkvYXPeqvWat
2219	B62qie4QXoRshYhRi81eYxGAdh1UwtB7zk9ga6ec1iEqDKuvdMLeRML
2223	B62qkGT3VBaGQRKfJVhyYf3ydcd6GeX6QKUWrD5vR51c1mLbCV4aDju
2225	B62qq1UvKuyvQJboyrWoSnR3ZxYtdK2fY9H71T72TyvrBkM2CC58xFX
2235	B62qpy8BMXe3tYsFeaTPRNW6yoG8jqaZfqreBXsaDGJ67Cxptn44dSh
2238	B62qru96dEQVY2ZTFVp4dW2KefcZnbPk9PBK6aNjtwK8Te4FfLxTB88
2246	B62qq8xd9W4dxos2sjgAfJE36cW9PYhi2dqoPTAPc27pb8SCsWGPtn4
2249	B62qovoydiqs8rD63Hg3ST3WTKBoUG15nDcXozpnNsDRrcg7MAWHgmP
2258	B62qkispYAjphXDKyx47B4M6PsAh2o7zhkqqoLFbKhLDq7wtLRNkSE2
2259	B62qpDxh64LnSjGeAmmUicPHU5QveTqg5CPjYLZCow7oWWnQdLBBdrU
2260	B62qqKb6hSurPxudgR61HMKsMQytyTyFDvSAWCbNp4F5tVhYuXkARpo
2263	B62qroYMFfTSfRXDkHmcbgXQXEoLeGPWGAfzEcve7TK4ikjcEKc6TdM
2264	B62qjd4aKyDUXvtYfMSxw8CsAEYRQYBENm6aEhY9vvJrgED5CZm1yve
2265	B62qrdEuFq1GyQhzZxTm99RoydSqJdN4b5JyEqa3ScsCeMXVrW1LzeM
2268	B62qq83PfjTpUFGz94teypvTk3jf972WqmA3ZCVv13U3qpt8pxgo2By
2272	B62qmH4R6gq3UhP3hTJqAcFSW8D9Eu4RZCtUFFeaFy8B3RdrzqVaVeW
2273	B62qq4isMY46Nnc1D18brK58ozTbpuCAFUkUAKGK2zVWNnzhjTyUNd4
2274	B62qpkWyVR2wNqBnFPrH8mJY4RkGFDf68xou5NSaS1R3bUCqzTURFAk
2280	B62qm7ozMnKcoBv8rTmDywWVPkoM1Uhss4CqFKWiZbPf8qFF5bEHk8V
2281	B62qp7RmLTgwtp3d468hGZM6uqGGvxg8MgJMMvafELtT47zxqzDPwWr
2282	B62qkAnTYHV4x1kjeHMjj8WQZaMjBeFEDB3UoLEnKwQkv3eW6MkH6Ha
2283	B62qrtc5b8QaC4wTEyXxFCCT3F13sgeeHAnHSsH67qHYfEHFgfuAS9B
2284	B62qnBc3cgaHkndLrzmimXinmXCC5SteAtDcZoPqaHDGYX883ADXPQw
2285	B62qoP7Ttcrt6WR4vhFkGEJzhbGQo6AbFqqiNKYk56QJzdb7XmnwXSz
2286	B62qnHcJVasqwoc1719ooV3vCmDzMSg4GRCX4JDx2mWtCRGPpSs5VaA
2288	B62qj1dzrkApiRonUU3Gnwxx8civRq1pi6WJbEg3Sboi98NhQfob7rr
2289	B62qp89J68LeMpMjZC4aLCz6ezbzbmHqVDo21eFsqjJ6QFv8oohdfkK
2290	B62qq2fw1pedfv49bdfmvJWqiMk5r63uwYtrssRoMG8cXxN3kNbJTXE
2299	B62qjTpUa1bKYVsYhHKC5dqgQQnBNhg9s8sYFLowB7PVX3iHDxcuNj8
2301	B62qmkVBvrfsmwUWpUVVTNCRYpk9uDvCxt2c8wwvg4xWzWRnUDiFUTB
2303	B62qie7pATAM6SLkFMR1HGR1EDUKUEvMKBpgkFV6EZ5ZWnFozx5Bocs
2306	B62qmQGZPfmtoNLPpxnYUiF7dSRVGEjFjHhFiRCFEsu5zZDrEvqx3mC
2313	B62qrkpnPeHN75SgrxSaU1vQBc9dRpvzbdzWJiSgYxoMavKzvLntKbx
2315	B62qjcs2JttjnDnm4RtKz8FAfXpBXh1Go42LXyJMd35smT6aqjYo58s
2325	B62qnKuQoQfBmFD9rY7ytsALXHQH3qbS4C7M21yDTbUX1H3nVFX7zK4
2340	B62qjxpt41fAb1VGsFzLmNsjJBHWJoCz2XonHjJr8amNd7HfrMgy1yg
2342	B62qrTiFQzcQVCgLcy9kyNNhfu4wYRdyNzfRmibbFPcWpMQWWm1fWHd
2343	B62qkMwbeMZkjd48VNKRGdwnyTUm2pVrBie7DjK6nxYmWnQ69eFDaqD
2344	B62qoqW2jhKpTpJMt8mT5pkWATV2rLE8N8CbHnMnS8ecBU2J2F6g3ua
2345	B62qmbmQki4GeAB7PEvAwhuS3TJv7xbdfNZnS74jiERRb8vbaMYr2BP
2354	B62qpGVZXaTqNFF5zWaDHsK6eLJLE95JtsfxWcDEy8MdkaDDay5RFHb
2363	B62qm7ZtBYMaPbEgkiokiMi9VPVteqofXdPiyVGWTt3aRVSw8vxprdd
2369	B62qje3KxyHAVdGG16dhFkMpkzrCziwQ6gMgPMvFa4aJ2kdJRGkJCZi
2370	B62qpX5ArbCv24VVhV26V1jvWjQ5kSEPR7NScFFZHzWYWMYMoq6XZNy
2380	B62qqcxAvY4cP9QE9XtQtHpwbaReY1rvMvUzjRp64qy9TqTSs9C1U8S
2385	B62qisBgzyYKFofg4bhK5kfdUt9eJMrDiCzvPkeDH6bjRZDm3pttwRA
2386	B62qnZdraERndTXCtZZb9BQVJSxSJsDozPWWyS2gADiyTtXoAuuisYM
2387	B62qkNo614WKBoEAUZUfkXBeu6SNppFdxLLPy7WSD8w9vkkMaU4dNtq
2388	B62qqjdXKyj6aU3Q3WMwH6tmJxGbqGXc5uB5ykQVQg5qWwJkt78ZcMX
2389	B62qosbV92skYv3pVsLBKohw4X7HZdTiPTnBTxqiEHRy3TG3wRynNTZ
2390	B62qqJECN6pw3TWgf8u5nnnboGpbuWwboypySnSkkpL9oXYgjXFhYRn
2391	B62qp6nFKMUaf32bY1zMrPftjS9xXRMGFRhKZWxAbHsPGSHKRwgkWsy
2392	B62qmj6Tu9V32PBSV6ULbnCSkohC1QniTzixyxKYFkCWuthkEANH4fD
2393	B62qnZAB7ZKCq75SC7GbrdzBvQZ1drNXUBR7jqKKTD9vWkzugnhofJQ
2394	B62qnD3fJnkyPk5SAB3FgN4nG9dKbPgHcBkrB2gbJG7cHdF3eHUctPQ
2395	B62qm2wYABKcvvNPuY4VNL5amFDM8QQmjzsihZ5UbGGGEgNFDgwYCfy
2396	B62qoa3viqZas6fqFP6p3FRmCYomqnReZERFBWcoWTqyuXEkbNrpdRk
2397	B62qpjxUpgdjzwQfd8q2gzxi99wN7SCgmofpvw27MBkfNHfHoY2VH32
2398	B62qnduvRE55X7FKXSE7ysUCepxak19BS4swravJWD1XJL6yShC9eLk
2399	B62qrFePrUqKrWPz7TYTjqxx9iHZbHEKvbK1KfZbuKcc5X5x8cKgBFb
2400	B62qpQpFH7kareBRGimGy4zQcTRDYs954bzsWNpUkFwWTgp7ThCpT6U
2401	B62qrKsdAwpW33PQxYzfu8JDCzpZUtc5pDMHsVtz1CoNnze6tosomnX
2402	B62qruzbadY3TZDvcBC5RKuXc1RgdY9jgY88AY8jWjrUMyWCwDsKzgH
2403	B62qmdQ8VwCh4o2WFJUtx4behatPR1bsTiZqZMkpfvLL5SBG6cF7TEE
2404	B62qn9orkCADRbYAnQZ3gozzhGncLiTvbiHGXHLoAV7zanPVakzomnw
2405	B62qk7Uft28tU2ZJEpNVD5noG2kCAAytnDjikHYKva57Lefymby2tad
2406	B62qkb7UBS6NfoQJWUxkkmSPK5SyEnGVYHrGYCMXN11sQSRFLbBoUEH
2407	B62qmc2SW2QhPvg8cxPQnWKcwfM1YSsfo13sg9SNStRicH7v7MpcmhC
2408	B62qrYazpXTRcnjKBZSAFAWtYNwUtk6sS7xtKAs8U7pFp6Vgt9JsLzu
2409	B62qiiCYbwt7BhrEsqNHk966fRye4e3DNFZmEA1PNToitrK7HCJT9SV
2410	B62qoBrJRvyqiajPgcFg7tCJwKm84Utrn2R2Df8px9Q27cJKMLzqwZr
2411	B62qnZz9WWq4d8LA2hsT9PZBAsc8zLXPq2ejA5q6zUMpweMVaMxspdL
2412	B62qoBtPZAJ54q4JiCwSkrifeGFbkhDe7AerNTjmyF1yX8qYj5JFjL1
2413	B62qrWhwRATTVfLCpNU7AoTBGc5hyc1G57Wapj9mt4bCw8Dgm26a3Ho
2414	B62qn8rw57DdJcGdR1emNV76TjSXjDQ4W3SQHEQVS86UyrX9as11Vqy
2415	B62qqb1jZ36qMpyuJpLgVfN2vLdrF9pBNC7pE9Z1sDvDcpB4bPgerKg
2416	B62qnLbQbghiGKG5uTHaB1sBYpSXFBaXZdZBfgDDLErQZhgnqi1wevb
2417	B62qnXSsLz9sL8crnJzGMCcFVUfCkfAdRZmbFLEMxBgJrNKvdk1SifF
2419	B62qidZE4iJVC2uyRMKRCQvmoJ1CVLHomZqHbJFuhCFLj12L4P6Fejp
2420	B62qn8VrEwGSXF83fxZBVqqxE35BV7m2d3D87Bp5z9sSauCtr7T68Ec
2422	B62qiisNJwgW38tmdGJ9SYmYUjTr4aMJgeH2Lmb2bUnPNGV3sZQWGg2
2427	B62qnscvS1aEt2BVYvurRMQgMqdkJfqipPFoj4mYFapKDRpWbZ1PRxi
2428	B62qo7b12Z2VNzQv5YFQ4vMcJg5Xgh3z52HCmsaYsLvWTDifAsxuKYT
2431	B62qkhNNYDtcN5ubeD2R4L3QYEBAK4bjbxfECWgUfNMD9wp9V8szhxF
2432	B62qkNjqN5GWWP9BiwiSLspTmeUZ6JAW7WVmkzG9H38WXVxuSQVsNyQ
2433	B62qrFYD9HaR1nbzn6B4akW6b5WqNMbbDyQZSi6ezDo7dYiohtKL2HY
2434	B62qnpXem17QPHHFMQofGhbVg1gVwZBgPDA3vQQGfj1D6sX1E3LRWv8
2444	B62qibmqxC17mK8dyJYtmQWzrrkMqam6hNDXqoXiPuxhnSrFPowoSvJ
2445	B62qrAyzVQgBMu8Am8KKkZeGscCMFhESAKQ9qXNn5ZygFGa8fuTujeY
2446	B62qqZPhjESixzqVtxDXFTMA1rPGxQ1jg81iqAaLUUMsxuhJAqDv3Hh
2447	B62qnRwqrjxFedwmcatVHNPBdSkrMvg1SQGwvGy9Eq7YcNJthkdmyZw
2418	B62qoxNwWSXTTWv7Ve3rGnQ3bhzV42pZy5MXzoGL1GmEPzs6zAbqvMT
2423	B62qnQ2k8rrtV3pa3yoBE6Ko8WUmcvKvVxjMhjoFrLdTxerbej1y2QP
2424	B62qibeug2eKgAB9TLhcGj5n3R5cn6e3FQzcsDCqnAt2svjSLY4bHnj
2425	B62qpz34NSWJAJeEtcfkLQncAzwYGiM4godUewhgxcbEr9AVurDapNR
2437	B62qmPKgmRkWVq7pVKwW5kgevyz1yTT72iSSGxWSuK3gJ9MBkAhJFgV
2438	B62qmNCHxxitxbZahp56Z1t5yX9fgzvSBTKzvw2us4QmfQLVKLvUPHB
2440	B62qkuFfJZ4u9qRR16gicTLLvX9kv3EQ1oRvmTDYmuEJdpKRiorxeZZ
2442	B62qqkDi7RYDuBx6erYqNk1KH4Q8MHxkswMwhyETNzpBiMvswADwG26
2450	B62qq4QHGLT7Lcv5BRLN92iUWeQKSUTLDvNik1EpiaitSAN1XMqHRxx
2421	B62qmkii92EtNN3XBi3Q9tiXVdaU2nigKYbWQE5mzMo7JkPV71BSwHW
2429	B62qjCCNR93CmndMdyUAJE3fqidKDJDWPTf9MDRTXgurmE7489NQSUk
2430	B62qqVZYkZM8b7TkdGBEvmEtbAwsHShhxzVoiDVewzBE3qpRoXwd3VF
2435	B62qmyidDu2VCs8wtD17TtJ79bLCaFkpSXmugK6bqT7Rj2z2GtSZXGy
2436	B62qqysUvMRJ8Pyc135g9dRPj5CGDrcGTpWS4KGgH1Nr9yp12i3VDaa
2441	B62qpUXNBm6Dw4JsTAEttcVRwZfuxUk3ATq5twuFfLhEqoYcGib7nBt
2448	B62qrPibZ4N6MJb1zpH6i5xwv6LDK6T5yhhDQqge32WoaLcdX8dp88w
2426	B62qjWBpvcCTqcC2Poiibw3bQQz8xW7yohaPi6CGoB7273Rcr1cSeYi
2439	B62qoWFzQ1hSxVkp38AfHrRuZnDed9qyXuZMuen5deVNLY9ebeQttmZ
2443	B62qrVAos1Xwao8dhMZozpJQRwHf9isqUMUbC5Bjrctk2a5gEBhKojS
2449	B62qpKcCVGJn8vG9eb5F3HmpMwk68Y7tcPoCv3k1CPfnHr83v86ygFc
\.


--
-- Data for Name: snarked_ledger_hashes; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.snarked_ledger_hashes (id, value) FROM stdin;
1	jx7buQVWFLsXTtzRgSxbYcT8EYLS8KCZbLrfDcJxMtyy4thw2Ee
2	jx5WHVfqJJUk7SpSiHSEeMw3PSKge6rFhvx4AXJX2m9Q11K9rSb
3	jwEPJ5Y6oRmeDzbHQgdkLxzc3aFdZNYp5A3bHz5U2kHvVUnZPFw
4	jxxTSJfDB7uQmjAHFM9UbeieWooMAPVadSVHCSWcBsZmPgPnAFQ
5	jwZq4cAmok39J539GENxQ7Dyw5rurDgPgbQ1HJ3m886omemyJ6a
6	jwdmeRSLYXsrAYLKnPWqd5MBjtwQHY2zUFgjur5DixiETVrBmB1
7	jx6Hv6retXNrMo2qYHLmUADtapezHoLCJ8B7xf23iZ34ea18PQk
8	jwBtZg9nseQk9ZYoKcjFnmoLLrzKECfaa119Bu6t7rY4uH61mkH
9	jxZRLUk9BscdxSpCTVUBabwqMGkDnXhs3w8rjPgV5axkT5Jouix
10	jwAouDZrXuisKvf1tV4mYUfDa7nsnCh51ECe2HmWoDoh3VUAqhq
11	jxRoVqa295hPdVxmg8k6yTnDD8ELtRtMako3pnxc1XgvdNHRhNE
12	jxcnSmcnQ5L1enTDiHfhCBcdfLzGEAYascN66dVdLA1HR49UUws
13	jxRx3BcVBbLGkUpUH6AiPXPVnsYU2kKASmAWemUD2Djg9WzAk7A
14	jwX82KZ496YaaXztWPxmRCYPfWpzkv62ovDXMr1fDK2Lr8vxkYD
15	jwvKjDco4pKLSkqk2NHkBrzZCayCSWGCu7PMuEmQiZg5jYJq5P7
16	jxPy3Xma596nvYpeJmrdhyFJ5bfSvuZw7txZMahKGDyxdPZhaSq
17	jxYyryhGxuU6mApkJU5LCCorHsdmdY97LqUtrP4wPEXF4EVqrdt
18	jxBHaK4Asrw8dx5jQ8KVKmAMnB3JinHZwrJresVRQgr3dm38wTZ
19	jw9hFd6jrYVumkQQ7wS77mjxPbGNMgVYF1EFNFDDYY9nMfXqyNK
20	jw7HLJiXKYaGKfGq8nZJ1wD1kvSuW63XxThBg9nbYyNe1jMTn5n
21	jx4BoAVVBfTriA5cbzFEWuXg449z6TLyyfTdj6BzL4xNz8jkurx
22	jxsee281f8dj6U2DmATvqRBYzaM5Vo6qbXYLoEruNsohMPqQZAN
23	jx6KGmck7UpRCW7tWptrQpW46QsYqixB2XugMj2QHouJ6oiCZL4
24	jwTgAqnE7dqfxP4oYDcTmsegaHFDm3fVoBtftRivdmJYk9BuR5Z
25	jxqumMumVf1asvN6VizbWZAbDQaKKt6kmpv3wEjZbtikNdQpe7L
26	jwAm294RPtb7aZLsGDUrdhAKKy2mFHJDKCrtH5y6XW242bK7sH7
27	jwY4oQaPTQW8x9dx5XbAXn6B7LoM87za3m8i3An9aPGdMWgmhT6
28	jxHUr93rYspbMhCr7WqCpA23Qesbtn5uZ3CNzpyogkZSsfz8x3r
29	jwfALzpdjTCsoGUrW51u9DyPugZsBRRuo7Q4iR8SYZpQbEwyeQ5
30	jwso14Naq3NgXMmyyjvWvgFkYsBXVxpcFB6YDM4GTw4WX61b3yY
31	jwkzvqVj2WCVLfRAd7A3Pmq7d1tUAYGwj4mLjkk99iy4jnWgPzR
32	jxcQb2tMajo84GwkLzmF6sz85XwUGa8VP95epyqEpAiH4mfXbx9
33	jwEMNr44pRjdvdQZRhCbdyk6gyMEpg16FJztEpq1zvvVZNktvcR
34	jwUXvtspmR4AWVgKmbDoRsnCs37YtnZAK6bZ1tVdCoTjA2JgErN
35	jwV6uy6cper3U9ETcsGQXVUiC55L3DmJ71jf47KaX7uBwZ3SJ4Q
36	jxLjcXzML6xeS2NFARN4xgpQxzQKqhC24mfozekvaSh3B1GKm2J
37	jxo5e6yaTrzJSm5EiKjpS6GMfjPt4VGXeZFFwyZXoysDv4w2c3v
38	jwKmGrFC7Yv5N4qoTgqiwT8cFCKmYM2fgnPg88MydRhd6oZb6kw
39	jwC2GikqzPvAborRYJmYhoFtoXiPeWD93XWxnndh4LF61NkvjQ9
40	jwQHnJueTcRxQjsnagTzH3hJJBLFd1xD5Sdsh6FpscSJoJ7hjcz
41	jxbu6AuDq3Hv6wpSwDKbe1ttLKTvh58W8FxAdyAgYKJ7i3eqEmF
42	jxXuzRSDeYsXACDgkM9GszmYChTocLcFFoRQdamwFokbquxN4GB
43	jwjEVJg9yZoAU1VcKYNsMnR7qjdr3qvzs2W7oesXwufNdBoVciZ
44	jxRuY57g6851mTjxoswNoRFTT532L6yZViAhmNZEZ6dyNTduB7f
45	jy2FDWyrutPtxDTWF8TG9yxhUnEvFcVzS8X8uwA9QxczQGpiX4y
46	jwkh4Wuc9jkJZeeQ6ykrYR6V2xm2oGbM8kgvYQLKfdmyFy2RubG
47	jy1GPEgXDPFUHXeYkXq3kzB7ftZnH6HsVLzimGK5f2swcSM4aiz
48	jwmGiaNhseJwVUwWC6zJL3Ec3G9LxsbRQL4Jcy871RAZyQbBsa5
49	jwJx1vrMvfCkMuPnyVVdBvZKMAgPSrWGdUMGpoDxTwwzjQc5pCS
50	jwtQd5jCpvgetVZNRtaoCBjDX7g3ZgxkSAkjzP7UWNRjYRAbraz
51	jwYiXp1nc4DDk6K95h1MirgGhyEBxSvDcexHJQu9uvZiEHbKbJJ
52	jxEMdGKgJfZwHuCJFUBTyggty8qQ1y7bHhaG2ivL8FK89CqEPgn
53	jwhJG3sth238X7Qji9dJT736wicJLpjiDFEgY7wZwqktirSR9tC
54	jwZyktkY675iyZeuti3WQLy4W7E4c6ejP1JMY6sTscFZzBChTRL
55	jx9pR2KpKnbX598quSwxSKmZw12b5KNaUNPNmecW5dieajBzzyw
56	jxPSSofxzG9GGUAFVtAtSGhR9H844iB9EsooHhgjCXZVWe5sEAE
57	jxbXw9NW28dwcTmQRXPEGwho5HwWizBh6z7WQmKPkGgaE63K35L
58	jxAubdnmvjGGQQYVdkaQud79KpDj5PU9Bz4jRNzwrzsRQ9pZo9t
59	jxcwDoWw3KW3MfqDoADqk7MJkQVsyynjTm7dPDwFhKjJCQmNJWr
60	jwDkFMueyu5oLqZtBQSr3Ggarovd7wEpFGb9bBfw33h9QHaC4Gd
61	jxWJYKSEM79hbY9LV1U8gGhtyVc611vVdtxd9XnQ5j5Ybu6qYkx
62	jx9jDTCyogscfyBFbjD38ZEdoCkdmzKuWf6m5KueeFmGKHEv7ZR
63	jxLY9aLNvTKdNaFcUzmUPTr2wpPYJZZDVLwSRKXpPwtq88K9mEn
64	jxA5oswqVoBbVWVBz8TtScrisAgpENchusTVQmfZNa9G7WTVsqE
65	jxk6uUELMnFSdfRrfKtxTnkCtNapjNAdGpFLSAxbCNMgU5K5HnM
66	jwXEFEyEHhuP4jZnJdogPCZn9LAJRkAHUMnH4RRvEeebV2veXm9
67	jxSSpfYN7V2eThTeLqW3r6CTSFGBxnUFfb2hbfiSXZhhMKArX8s
68	jwoF9bduQ3X819veVcqa4SdepTPXqgGctAtY34tNUwXHkX3o7hS
69	jwkhTTokd34ujnLC22sV558zNgzkWSXQPBGCvEX3ifqScpUhqSs
70	jwZCziEqoNfqVzaXYBnXkbBck7xxBUxByU33qz1AtNUrGbp7yW9
71	jxbW7v4U1WAcXUixddYex7AfrfPhdkaT8nVbLrCW1xZVkPsqP6U
72	jxnMQVcmr3iQ5xMaZXAAVeMnVCVkBEqdvGdCX6Wi63VJJTju7Br
73	jxVFDeH99NFTHeHhwvuheCZhok2BbfAGG45TaTQBFEVcnEf5HPy
74	jwyiE3BwB7PDuZ6JhcmkP9W39bM6wtJDBVrNeQAdTjARQZiZ6An
75	jxudVBPMncioMK3jxkzfRgsAbCXMbxxgvMKbaaBqviiLcFz4GXX
76	jx7viv7xZ5Snc9tpAayyEDe8YPoN2XTgPZT56xYK9ZQRbusoorW
77	jwKPoUacoovgtp7CiehBEDZjvN1HqtJefgepVuqPpgMr5bXrhw7
78	jxbxog1yv7QMCG7z4dxiz7rP3o1KJQNGB2o1GanBDw15SpkhfJc
79	jwUYtANhTgoDfSzajLQFL4ZTMrms2bLtVTRH73bsUGdi6XWsRkJ
80	jxfz9X12gKCbt3HgHj49BVcrJHghDo6AYyM92ZHYi5aKz8fbMMV
81	jwSiQ13ZCxXbWZ8ZrFeAooDVMJmHtNzJpQ4B2hGEGT3n9QHfUX8
82	jxpkod21qJidPpRgg57d64fRZXiEetPgoquyy5h69FWnFSUTADd
83	jwQMuEy52641hLotBYoTLWm7V9CKR6x1T2TFXngXx2QnPh3Ftnd
84	jwqhqtZx41KLH33ob698gfAisgqgWmgNLUTrzD9nW8xxb1iV9Wx
85	jwgTZYqseFBqMwN8o8bXNeJYtHmRR64hhMPQvVmRutkndM8J5VS
86	jwrfh1wkfErTDCNvdczrrbNYWMcjQkxKNP1KrBgMyg3hjZWid3n
87	jxHKD1Jji2KoCWE7bm7YVy7TefimmzVG8hmmGx6cbUhtPqxXkdh
88	jxHhKaBAj8NcqnUhoqYPXS6g5bnLpQHGTLYtr77SUaJ6978UcEX
89	jxdr4QW3GgMq9JuvrGyauMusz3SDYDkMrKvU7wjkEkanVAiPo6r
90	jxML9o22Asm7s7UtoNYtrfLxku3nMsPbKUa4XNqoUuqjK1dEw1h
91	jwALWwSfGfEur6NfPz3BJzxaepzpdGd9GzYJGjbmq3n7KehBh7X
92	jx65PksmeU8g4fu1kQ7SddmdPNuo1sYReVfSALbchMtfCejDEFn
93	jwrLfsJF7AbmaYncQyMHKSJeAqQ8erx3jxjx8SywXAf1qEQ1EEH
94	jxp7vEctz34ngxwgref6MocSaYiagod8aJk5Qb1wUkvqwJHE8i3
95	jwcRsaFjtbxd77SixagbegaHuczy69VvrAtWszPFd6oGqtAmXCP
96	jwfS4p8MHncCtFaSZQ6dHsUW72UVcMfdvXiejrAqapCEKGrS9Mf
97	jxsHGDMJ3NpgTHvMvGh1tSLMkPy5s4rPEJE3ytPJo5wXYdjzja3
98	jwndv8sP5dtrtLLcVrzrJhkjhbWZgM6FbocXLTpWkLdbhqBhtoU
99	jxGMNxGZvh1E5Ag24CNtUDu9rag7SUV6oSZ4b52ARne8cHBciT8
100	jy1SMr7sy9QAsforJoPzNJaUdZRbFEXfgyGMdYqVe9fXxaXBo6w
102	jxSxSW2UHURGoeWfD4qwTupPAR2osVKxLXG8R5hHK7RDNQf3Nc8
105	jwJgynKJFa2185bk8qYyvjdZoMjevM5ndknEJcGSCeMHYUASc91
106	jxiRXkLQT2mhdmTM2DoZ1DbJLL1KDRwjYRhxdX3zvpaKjBFB8Ls
107	jxMvVWifAiEAFrwQuFac3x8ThQ6yeUvdYyczpmmwkRCZEVYMykM
101	jxmyuhLuKjYbj33sr3hVBRx1pT6ePmesWdDxzApMCKzB2K1tgSn
104	jwEq5i7Rp3YcYhCHNG4NEXM7HSY9pmppTCqCSPVuh5QPxYVhFMW
103	jxCYQJdNHNPvXpeUiSu5Y7DTh5A5umSTHsPs3RCFbtGcuxVSjvA
108	jwvWterDkuW23iPJfKFdDNNfPZqXWAnyJuvpPMC6whaTtRh1HTf
109	jwvvd6xMoYsh3YCu89hB3Yrn66Yjp6FN4pSdVy2FjJHic4T77QV
110	jwFq9hRwBKxpsL4DduchMFXkkZiLp4xmW8fwGqPDRZcBnt4YfRk
111	jxRB9pJMvJmgj9xCeZv9oQohdKc7MPdRJwZEKiHD3gn3pBQGYE3
112	jwFvpWmZQpm9u35QZSVvmYcPdoVxF5WFTNWdqNG1zTgc3Ad6PZd
113	jx1obrfdK5zczX6bKZ8YkezJRq1PENhCA6SYbTRCdvpgsaJbSEN
114	jwZwovJFVmYTDTBCS7RJqc13qgGT3pYbd13FB4qQ4sNRwrpmqzw
115	jwHrtD6xiNdEry3kZ92ykEbsoveEt5DfM7sMBcyMN7eizSihmEU
116	jxByh7epLbUxkc1xUJP2LaiaxzGTt66749pQV1pZiugttZqsuv2
117	jwfSB2RmJxR337XmbG7i3pNTu6KwNxGtNfctbvJ7Su4LfgpNqUg
118	jwCDovxbpptEf37R6HYbxLycUh8K37vdHQV2YouJvQJuBN3bE2s
119	jwzxcYQ1Db3v13Yu7UcRAnKpFWUoB2UUbEHPiRCxoqPVchv3nyP
120	jwewmvsBgwJHWwjkKRxeLkxLrVkzq5BgoKiHnkJdF36Se4WWb9R
121	jx4XcYxdqztHEtseaSsEKEst1TJR3UjH8uxozgTUcqfUtCFMK8P
122	jwM7Zb1ExUNWzjB2c8uHm7L3Hbjk8EnXUtG3ncEJpjpG4TqAQBr
123	jxN9Di8be29XExdxnZDwEkH49CanYHvzqGLdBo3yt67B1HxwhQy
124	jwt91BWz9iobVKWv5KPjNqc6hDKzuG5eXdU5B9z6Fgq4dv4XYWH
125	jxw1QnUV5j3k9KTwRW8EoFhcrHA78ZiZQYe61ucgAQTaXYtKb7u
126	jxnsEsr1u8KK4ecmfhiBAd5QVyFs1ztCxYsNoaWZNyw1czdVssS
127	jwAAZcXndLYxb8w4LTU2d4K1qT3dL8Ck2jKzVEf9t9GAyXweQRG
128	jxrcYVSBxwgHMLApR4hLp43fczsWX447PG2QWSxGpGbMJzncNg4
129	jxyqZKCVo2RgbGnwzjHb72tPkyuJun5PjLMb4rxyqgxatS5EYjk
130	jwP9FtjhryvhVU21M51SjXCjMwBR7g7GDbJtw9kKNbuAF1f6X3p
131	jx37ags31UMf9aUn2yLnQr8K4QrCVkCqKApWmCNvmfKL3cuxhvB
132	jwBD7Y8h2bqcedCfpcwadb6apgvRCHXcyxbsonfhitiXruy5nqs
133	jxrbQRp7eTD3sfe2ugnmwTDRfjzTxEumXZ2u45Wiv5GXGGM4VjX
134	jxCy2bhcdMDTiv1cqq7N1QPKHGfpkC18vkBVKNWapdZ883dKcFZ
135	jxPmh5r5PRmBpVdEfZtg8Wf1W55HKo5tt8qLypqRgy7aJHXGAMQ
136	jxejdCzjBFiaKf5rkm3N3sAzLQfWLfyjx6Qn7C9YqB2X1FZ9t3v
137	jx5BQcjMEHNS1ZMua3Ct2EhVZfEAcEYiJiPBkCaxe8CeP8iHWc7
138	jxzZcP1fagyXE4pT6KJYZi3Qrx7R6WGZpaYNAvKHVwK6Hi5DNRJ
139	jxXNU6FttQ9GSWFSeBurFFQ4Hw2WcUncZfutVBKz8guX8yvakEP
140	jxbFwnM1FXY3DJ6E7NcoxxfT6kpWSGK5geEmFdQMXKrcTp7es8A
141	jxFFfb22dYi8BV4pErH6JNjoC2XN2ejMkwsmR1r32q9PtkgNuNb
142	jwmfNHTGU2arhqPMbvH7fVbG96phw5uEWugp2nCuTBimiqEcezw
143	jwHcMhghNVX5DAusnmSbnUhheraNMFHo9jjVShjyEU1qLCmYgbe
144	jxNPSG6vSCYmNCZ9TBKRvZF6jR7AyUKBXqiFrWwm1syZGdqdpgF
145	jxsbUFkceHDR7PNYkcCqnyk3vUkAmVBvF2JrJ4KFTMBhKSVEouC
146	jxR7cgJfshtT4PXLkqtZD5kPKNe5amE3TERkgmjqFKhxysED648
147	jwhMkMzB1WoFCBPUNChB9jufa4HDTSJxt7L5onzEVNmhRnMNCvy
148	jx4WN9PaKCzHCbacu7rBwBtuQEJW2Zs6b7KeQ768nk19EENoo5e
149	jwmeV8mTD3NP8mdkHdxCP9DzVqwP5nmPz36NuaevHm4f2DjsMP5
150	jx2ABGRdpKJT37cXcqdwtdfC57snkw2GubVth9e5vFafMdSF3G6
151	jxKMpnna7X6Ety5RFMBA9jBfnApwMdybzSbbrU3FnAEy7s35Mok
152	jxuq2mfoAdX5KW4LLbiYzjKwzZFJ3Pyb4nHhsgusU6nxyB61QRo
153	jxfAt6W91RfEQZWbRQdDZk2fXzcxSniKq7aihfgz1rwzXCwm9Wg
154	jx9AErRq4jFywGHq1keMEdcThrmjcrB3KH75yMdSsBTCeEuirjB
155	jxxGycggjfHHVWNs2eQtsLLfMq9jm7AuMiqy6F4ezJymVLxSPsc
156	jxAZuR615zA7jkpwxD46Qp7iGiUfenPS9sQnCoZjTb64wqb5osD
157	jwWpzYEfbJemtVV7zdVkxDfmrsgPfRL4ZjdAc149JGGC8GnxkDg
158	jxgN2X7TBxP2cqpnE85jEPwJ7CKuKyMWJi1wcDGj4J5cwm5K568
159	jxKFdvARqmxKek3K2FgUDk2nKj7obRU8NTWq2dsLUsvbfdt4TzJ
160	jxtgENMyMTpShmGkXHWrFQ7pXm8zrvi4THt8X27JAkUxY9CmVW2
161	jwLsmgRkqjNsibvTwVJdLAhrR17LQGHrq3q9sXXxyZSLJfFcq3Q
162	jxX6cKLm6mXyn6cwawjEwQFjD2TYACZHbvyaHGYB8cboyfSeNkN
163	jxLUfJrG4BTKTGUifio5Qryhj4nhY3Za8UejAqtSDjRWDHETcZZ
164	jxKfvbpz3Pshd3tXBr1w2E2QJzmdi2UzFQcs83xE357qn5bNY3B
165	jxotM8JxbGc2y1tPeZY1A4CxUVuzRyCRb99Z9NX1MmPMz7A3Q7J
166	jwmjAs7NhRNYWoVc348WRem9FaBQ6opg2tZHxEWBKGRxcmBpVGP
167	jy3EtFht3g8JKhCw6PfWwNR6dMUHSfmeRQRy1JzCL1dwVWLU2V4
168	jwcPuCxuPkntFXsuZ3VDopLFnvYyJVsvb7vFGmDsr48mDfvg5hw
169	jxUU9r8MzJMEWKwvnZnHXu1sXX2Wuk1KFhZ1NAFioJpcXKpSK4n
170	jxdczVXwqGvU2zY8xkYqFQY9v59MjuoNtkXQbgivjnq4aeRGXr2
171	jxuHoa5PtECt7mV4GC7Dr6pXPxJ6SmvpFnfoiuj5LqUuQfMLHDW
172	jxSnS3NBNhivi6zEaGJ5FVDfkkgnHbroXhYjHGkjaFrbVXCNmgm
173	jy137qYs2e3hpFidxd5jfMjcnQBDA6oz3F6XcAxmfsCqq72MUaU
174	jxPPCRJuXRQh6XT5yyC9WasJu3cBLcZYG5dwEXPjkszN1UXvVMP
175	jxNrxENJH8KaV87Qo3pMDurz42yhhR9wHUEktx3BLruqR4r8RKK
176	jx2NPnzoKghiiyUkzo6KHZNxuUUGLNTLYaRkFPGggiuESHeFeLz
177	jwERkMfdfJiVpcebNJazJ5TSHvEmb2N4cWs4QroKEbFuDbZgBg9
178	jxmxiSNJ9Eb926A5dT7WLNUXHqbTzuYsLre9xeJfFwD8Sbh7mZ1
179	jxWz5mHtNLcbpbJnwqyzrmV1H7EjnxA7KttjzZBxQkah8rNsJr6
180	jxjHffXZvpYikovKPjFAirkdbq7oGr23tJR5G5GSDB9PQzSDSBv
181	jwDRbeSF3bx9fSqNu8Sy3hWC4qV6rWxM5c1CbNXKDYX7QwUahYY
182	jwucVwAmrz8KaP7BXGGkGXdsvCwyi9vKQfsKbH7aRGzCHPfsqLk
183	jwSkxV81ES1sAKNBbNWT21X6GEzuLGkLxFCAUS2svKGfaDpNpqD
184	jxwopXa5Y1jFq9HADQfQyXCAfDML3bXPcJPpP8oeCtm5wJUZpEM
185	jwFZJXJfMQ9mDsBHK8QYGaoYHEQTFzUyW7NyQ9sK3TRHvL5DboN
186	jwvKyZC3way7jyXiDaKo7r9Bp2SSyU2fTJZpjPuEUFdoC6qi1nf
187	jxiUaqZMCu8hWERtvRPv2buxQvHHjB9kFojM6qD3HcBaTbdpXyT
188	jwF4UQ7PY2gMS96JVQSQGjvwN38GMg1zAaTatk5PsCC6JqB23kD
189	jwHSp5SQTSVf2Thaz1mggWEWpW3m5sSnxeivU6yYSWPUa45TeKb
190	jwhXztdU9KiUwm13oASKpPxKj7G2BeP1WMEcS3vSPKdF3eJoZaX
191	jwykZNEvX2ysWhQj6V1TLRc9cVjo1pMNZUymxw7WFpNU8rPpAjL
192	jxPuHWBBpq31Emb8CvupXv4Yyva3hrubntgVDasX2Vmg686tC3U
193	jxD98UrCfY3uqxfMiaKKMyCsiQLd1BBt8MsTrrRNPPunVXEbkiE
194	jwXpb5kpaaxWC1L4oet8UinnNVZ6EAaEq8VKn29JvhXQ4PmxhwE
195	jxo5vjTHJPGzyvq68NKstPhDKTCVBsKdZfM2f6huoLrWmR1BX5k
196	jxtwWNzo2wbw7ZzcqqMZFqSzfp8DBxE6cvJ8RTcKH3t5wpxZ3T2
197	jweyZ49f1aFhG4ass8ePnwxtus9geW2ck3YNsAqRjDiHPaJREHk
198	jxcUyjus6hnrTvifh4owekmBEEMDvfpeVzPFBTMD3ptFtyfvKmA
199	jxdeMDXuP1EMS8phh2Fn2FfHBcExd4N6Py25KFm5CbdiH3Ueapq
200	jxJFmtYaoMKvRi7iYGy5vRyhTZELkpdcDM9rsvdu4f6i58mSCG2
201	jxELg2xGJV6336wuoowa5MZTMFJuptq4rC1yq15MeASny4N1r8S
202	jwWm3aFF8AzFs1fT4kQrmRxJQqUDZrY6MXp6atBAe4PGLftDxVT
203	jxd9X191om2CEZcdTHR2PHd3EbnJicXanVKBSHdkgf6hQfdeJnZ
204	jxF8NiEyUe4rnysWfqFkjY56jPiuvMNS2ewo8KPd4yqg62xRKTr
207	jwKCoN4qCvTGduQdfFKRc3Mkuhzfm54VgDE1arEdZcMY5L8SnBT
210	jxKdLGRzgHaT3fGxPGsKtPoZpssrWbCq4SKmojjMwLoaA2NRHMp
211	jxcSJd6gV4KS8Srgky5W2X1QLqzJ5tW6J8vTrySVY1mNmvu6aaD
213	jwg5jSWCerVtRzSvvYbmJjPRnFrVKUxWAX6VP3vjqpfuCbMppX7
218	jx4F92x5ydkCW7H5kLzhaJC3Jh9o5UHS9xh682frhNut1un8jjS
219	jxbTQYwaobNAGqkKad88pBuUbcs4M5unqFEd9MyeZQufJXiXraH
229	jxWfk9JuU4Rq4utcFqhGKB3oR3zS5ZENUirFYXXPv5o2GsUbsVd
231	jxFpBXHc4b31zSWWhaELCMPTYcmFEcFLFLYR3QmsonEwemZ7HtZ
234	jxsxos26xzmBLRWghFGxcAaQranLcRTVJPxzeE8iYScdW9Dt3Ro
205	jwLQeHUgbrcrKkoxXwvD7NPQe4vixTfojSjL3qSLitFzaQERL1n
212	jxrqkhbbKnrKkqXFcQTMTvQjQUy4ScPR6k8hSUU3enbHYcGUQbB
224	jwPzCCnc1jx53RdmqoXJwqVJMv7ENbgzyzW2KnLzzxv5cJafhzT
225	jwXy69khxwLgZJuKpYyHp3H43GsHn1Cc2vrUXqRtmrsL3NTPpNb
228	jxfhfY7EvYdxuvSP3wC1VpoPgTR62DFJNThseWDkfg9zfQEK2JE
235	jx2VrRkfhsG4eBzKGz7zj2ffKgQoPWocFjXBR276nuhYP2orVdz
206	jwC8Nhnv4bN2Wirs6djtZnfWASYeREPmB74WbGKF2xYCvk6WhEU
208	jx49XfezdZhJaKeNEPVADk2kLwWYsgDHTLifnFQLMn3cVM3pPGR
214	jxaoHScyrzVS1kTGezQzgHpBXBXCiXszX6nzB2DvUUU9yZKNCkL
215	jwpmss25tXF5ZSuRngEaHF7J1EmqPSkJU98YrHF2P2HKLGhvWec
216	jwgfPDzUAmSTciP8EmmCKpp2KEvEWJAbdNLptuRAtDpekYjwKuc
217	jxb8bQLwvJW4fcRoRcpyjEWpLyDgVfi1nhNjywFturzyUxQjH6J
221	jxB3kstsjVTS1TCtjCLBscMvcanRtS24fu9Zc2rxdwcuEcdySSf
226	jxqamFFEEY9xRVarT2qXjbVVNDM4DvmevdDe4ZUWBwzecnQpgWh
227	jwqSb1tZ1BAkEFvFjwVcYLmsynyJzEze75Xdh4kSAUNfsRAhWgS
230	jxFFTDpUByuyvH6ZUkC8Kcps3zcPQ6ybgSb5uBg3CS6YjPFE9Ro
232	jwL5jyoZf8svasNCzE8DC248qfsJ2zTsX9VVDLHKVwDE3CDAMtq
233	jwhsd4L1nRPoX59aoJ4mJDAeVp75TR5mTn6K3o68yv4oX4fqCs4
209	jx73KzUrqoVaKZURspSM97hCWxDvHTVDKA2bwV5isDSi4Xo2sFW
220	jx4j1ZrCpN9sPkzSe4bcmpupwpmGZVWXHsCwLaSNjpVQMuvP1gj
222	jxM3a5KzFxBqoHD2kM4GA4AN3xnispE77EQ9AsoZkqunrcAJdFc
223	jwrkbt9s3fJ6DtP1FDs5fgYRiPBUFfEQtov2ZvwbEYC8YWkMF9H
236	jwwk1DyiRFz4MpKsiAeNcQLtgCJVXt3W6UdTQKYeBFc9byjQppX
237	jww52gyeBpfmGxPHCpC2of2WndDavc5JPWuVz3hgPiQbd7DW2xT
238	jxZbYCJTNzDApx13MSVbbdyp5AgRhMtYKfwpTfDG2XRu6LKntzP
239	jwVSvxN8BGRJTMPJZKqMNfmGXYQjiaritVVWSvzDtTu39YPHikC
240	jxM5zgA26KGXPtJtjn3Qp5wbz3UagoqUBFFsmfj1oT7gxpHJ5Tk
241	jxXHrFcPp2w18as79g56BAso185YVfgwUUKk69PhYKND3XxxfTn
242	jxv8pQnvvP3dHJtjPtRb2G4zpAUiat6SEpfDiANxeXGRz6n46TV
243	jxqvJYQMAKXW2UkbE6QJLn5bQ3X2xMoho8JHpTXAKncPu5A4kGq
244	jxD7A1pmiB7sBDVaUnmD6cigpoxiwiRfqGGyLjWTG6zuDFv4Dqx
245	jwxaPDu48NHmqz3pcMAytnHLex5PjeqfmdVacxTNSzNp7K4pSWX
246	jwpsVgSY8TE7yGPzUpUoR8Fytkz8fNncNJxWtuD5G3uHzxaZP9P
247	jwYqUtsiHJ6i7EVh1yjTX6QvzQVC7fU5CbBFoH9cfWK7nqmvPbv
248	jwH7kayqtTbAqXXoG4YwhEqPWMzsMJUnfGv6jWSPSy9QUEsnkii
249	jxWtjetxXFhybu4Le6pBPKttHBFzeRnBmTrruFJgsy1ufxSjpdb
250	jwBQwqWUD3Y9ky9X6LeHTa6KiMFQyUCeBHh5wTW9dV3SbQBSZqB
251	jxHznJDdVKKepkx1CxpPZfZ4yvL48xjtS6kkhULYTqXLNLh6oe1
252	jwPyh3GvfM7pjH1W2FwFV6QY2osvGydQDPb2k8QPTR2Ccs6iUQc
253	jwrg7qVC1jRY7UPHJEM1YkaAogj5r6seEvbaCShZ7YceNEuMiV9
254	jxikStgrj28pouQ3AhtajBNawT6cvmZ6Nx7oZo6mfcQK6eCXu7k
255	jxb4T3WhEBiWPma2nvtvTK3SSDKXAMqRGUjC9VB2UipEwPQ9ay5
256	jxozNdoX9TEKJh29Kgez8B5PkuoMyTeWf9QC1smLYDv9bS9Lo96
257	jwSbQgdWdrLA1X5Zu2CveYSgsHj5XapREjy3BkUjrMEZcsv4UNk
258	jx9SU9en9kDwbHZng5s7p9vFbRitdvhdBp9Hj9QEVo6ZPBuPRGE
259	jwtduyw1NqKoz8SH2tHtytztUKoRm3ud4Zcok5bqjt8hSLvVo6j
260	jwQ2AXWuJTFpMDCuUZJsZNUmf4omwq8Pj72Rf8nELfX493rQSPJ
261	jwyMcFkPptSgXpXBzNNTZzJhFt4EdFN9WDUBCydRoEDfkbhVCTy
262	jxVDt49MGguHDZpmF6HeNS28LG9KHwRdrEgaQfNLEf6T4NkhSa6
263	jxc6wmJWzychX1jr2xZUk8eZcR8tYhvZXvfwRmFnZxBANKmVaPz
264	jx2Qg5tLSKLWrZjoUCt3BnfVaCyzbKta7fqo5qsUmtWmbT7RU6S
265	jwn4LQzr6L5orsCc8hcuPXBxf1P3MJZ799RuEPcnk8AbpMs7REb
266	jxoMfpoLLFBJRhHwCU5ntBxxUqSppw27xDAFR2m1o8SHnPJEzHd
267	jxfxadVWyaUwc7VhzRoLgemd2T79AVKuAJaKHe9dndrhtdgMWLE
268	jxLfnKKJVhG5Yr99HdqAvxwviBAkEKL3f5ZNB6CrTYbfrHNh86K
269	jwhXHzB5kTLUoXz4S6TKFoJuzaWVUaLRpVURRjwcSzvdscwdjqf
270	jwYF3NJhy15NceW2zz2uZbuhMQHJg6cPX1aVHyYuSYSBMPKgsrf
271	jwnyTuE1yEkMf8qpt7YJSxts28XP9fgY3n3K9PdnotRgKwHqBaL
272	jxoCFYvRbKYb3SgH5G7yjC6p3bmnUrPUDAnYM6SYUZgABegEJjh
273	jwYWTMqe5TGRh4GqoNnpN9TJeNER1DtpDo2mW8G4W6vGaao7LAt
274	jxnx3hsgWtYg18oXJT1LsZgMxTk6KWuZmWPZZ6q7ZdFDo6GLXHp
275	jwpnJwTZkNk92MaF1EepWANdniQ94W8qQgPPGdMF85BtL4m7btc
276	jxQHsF6YYmrwJVvrNnBFnDk9eEQBMdbfKrYgKTS497SnHfNTfvV
277	jwTEJCq72Sbv674A3VuvYSYvoDMCKBu9toSMayD83zXzACTTWy9
278	jwgZdWPDtW6bS9XvFbc2MWdjtEtmiJSEqMPZM6gk9Hvc5uaBFFA
279	jxQv9DV6eaJ6EN3yrGFBFW6vb1MybvtyRaRc4jG5Cxtohw9bX7x
280	jwiFnexUfsvhdEanc56fkg6XCXiv7bnTUdAg47G3kbpxx5ypNWX
281	jwWpSLbbMwKaNFua7oM9NSofuwNLJ9Qn3SbWRTZX8AfbcTPVg9S
282	jxpkmh9no785SKwYe9pJFPEzt2jbr6ciSjzMAR7r3BjFCXvuCgT
283	jwNiC72AnZJimaMiHzdyHovf9KcZ1kjYL4k5GTXDSiYo9FEm6av
284	jwBqYUh9QUwSMJXranpueULM2LVUAPg5QH12tC9djaAiWvRsbXd
285	jx5X4rKAazitPF2PS9NvkBzy7LAhPwNWpwcE6Q5fLgaKdyVXEbA
286	jxF1jDHXwtjRN7odvK8F7dJWRaZxDWptU6ppn24TghccygQdkoM
287	jwkgjZAP6eGx2EPNfiradYKgH6yssa7gJrLvmiKptJwm425o8iL
288	jwM5aekpEdcNLZ1B4CbKyhY9ax7sjPcYqaK1cRQGJGskN7puGdu
289	jxcpqva1oEmD4StXX3zeMhM3ZFLiLVmK2opccnqqyXe5s5gCb9e
290	jxD9hEGAUtVStHnQJsxyCrfbxj9mgDyRK32mu48Tywh8HJkAbBT
291	jxUuXSyYg1JqNKDC6PoD2oSYjhoDaBJytRRb7uZYmn4yErMgKXe
292	jxscuHSNg3z6Q9tYjSCrG7tpRwHeN3nkWebHfLGdUEPpzV9XnM4
293	jw9WwH7o38VzAgX5rJjQnVeKPWtuMKM8LJCNfZBXCwxtwEgnjjd
294	jxMU1o2wiKpMxF9WQ8SbegCq1XvHCvChXAY2imQR3tEseccJhrK
295	jx6LcyJt29QDxr6j3b59jDZ7NZyY2EBsRZrV3MjoySkz2QUX8WY
296	jxv5TufaJXMvF6J7gYxxrPtuCndnWUkp5NJpws4ZC1LBJdG5RPC
297	jxdUACYFDWV6LMbbWebWXRAyrLstimGmFUXFzg8rHdxqxjKhMDA
298	jwocqMQ5DAFVDWmB1AZWFwQ6BzsbQhVdrFpChFsyx7HJsrJay5P
299	jwHaRj8mUnKkrpxS6uUCDDVpXEjH2TSggz2aUSPgadnJCASko6g
300	jxabV2psGtT8QogGRPdnSkLD4hoif7kPnMduL8Cex2abVczsFLW
301	jwCQN84D9sgr98kQn57PE4wPfemDe73xXUgjvFofn5kQsrKKSeB
302	jwoaNg1b7jfgZkrqaow92xhYM8YBAN7suQkxeKJMuGvQgQduuwZ
303	jxeBRrAH8SQw86mt6mpNSfnQb5XdS5nRAdBEXxmg8av5PYgrxaS
304	jxBmHi8rt1gKhCd6E3n4zsQrEmbwUHdXKFjMaZJoENKNujgGCfv
305	jwWhNiwpKDLm82eUSQfu1jEiH48zgxQD2NwyVunsXMNq56gJUfR
306	jwH6EPqwP5Veefkoriok6WKcFwEWqVUdH4hSUc34HduVceST7Mw
307	jxAJ1Ak3MHH5RSoHKeujJn9ZRpbWXmag6HQ5jQwdZviuJKdowAo
308	jwdqC6eVRFyghxHeVf1Hx1P9jaH9xZTqLU2N3YMQzZiyFvpXSjA
309	jwGnJnHoDRz2DTkD4yPmWisVXzDWdKNVcS2QKHphEeRgfNqpi8c
310	jxHFKFsCcztSoFUiukRtXVugcDMeMMTwDGawv5GbErSTtBwfBNT
311	jwFyTho1nxyK1vK9f6gEXTLp55HVg6FxRustoXMux1gSjbohQbH
312	jwfyTP7iQ5AKxBC17w1MkninmzweeEp43ZxjvJd4LT9bLdBgWVL
313	jx63cidp3njevqFps65SF6GhnXKfuGGojHfD5ajB9z7XwXWcniM
314	jw6n3N1hHaAWf9rjuzrEsqsJTgXeqzcrh9T16mk7rWvfCBBMxQ9
315	jwcWS5vxBcnCMYC1MiLdxjAkRDptUcfEDwLRg2vmMrJ75QZbRm3
316	jwgDt6qoBcgL2WNVu4d6an3kw7zAVmkb464MhDZRnJiaHD7AjST
317	jxWMY6NicBj4PyyWzRg7AmRANSJprSYTRz9DuHYzi3a1sUkzuCp
318	jwjSHdzkkZr6fJGcbeFhBdkH9mQY25RjUDvke5nCvujeEN8Dem8
319	jxuhdKZVFV7ikGs2sKtwD2BRyWgUeVHCHvHTyL24gTo7rdXdvB4
320	jwhcxeS9LLFq5X7B3mhkEDjmB3BN8FxLmDiJvznPniJvfPotTyK
321	jwjxwA9U89GUsDYAaNBhNPkgqhajziojctM1mwWkpXi9iPfTmm6
322	jwSmkB577rkjw7c2wuytLttTehz8pgHGdTAwQcLEQjtzkqJbwc3
323	jwkLWvVxeovdQLhLUZggRCZH2EuaWzKaooXfCUZVNJc29uw5Eao
324	jwrX6VhbT8rY9gvPKZVumT4Uio4J8mbUJWxYyimPpW8bMmBg1SF
325	jxW7o5W9TCzqQDFafJLtUDfSb6mJAkS6Ati2QXKNRqU3d4FiLPx
326	jwFpD4Txre54Y3GbPoGFLZJ2kKx72MFeGWJ8txs63gbfQ4kGVti
327	jwJtGuGW8WTSBq8iuguD4CWPfpbD5nEpfZLqPnPNHS5F9JJFc2T
328	jxaoECruUxEDm7uFhwireAzvv5n7MzgR7uNhCfVzQvMiMT6osXb
329	jw8gCoRe5o5ychf2uL1TvrepMxciAFBusegb8gjZeonMf2Btvj5
330	jwyzezaLpnVmXQddgcxfX73rPVzsrJdFCgmkPeFnX8b1yqD8Xop
336	jxsyDgy39qty8vaFcMaDHqCSDHzEcAT6hnbjtb3uHVdWiFuKZft
340	jwFFTJzyk8rn3Gav2ofPJz3X1e8c1sQVwfQNCb8SAVuNttVTkKs
341	jxmJMeUCwoWxpZ3CTpdnd7X1P26P9GTxEsVrBS1q7GAvzX9MQFq
353	jwHpe6RtQAYkcTV9gapcdXvT5SWseeWhw9AK8QtruiPCDzVjztp
354	jxDy8tALuKYZdZz3YaDS6dPiEGoDxfxt3es23bNcyVb2RvSwcQd
356	jxTRZH1nYToHqmvsjNCMArWi2YYRqx8HFt5b1fExmW4BQTA6RmR
363	jxFYyFfH13Uzg4CnYDMFVGNSonEG8hnYX276PUVvahzH5SPmnxz
366	jxNraLZJGKRXSJo9Kvt82F73eeKzVyLFKS6vQnJtpK4NLrYPPQc
382	jwB1dsKj5XA559jfiqCDjQFpjvKv5rF2bTzswvL1ek5D9zxiFGC
331	jwdtiRUeT4i7ALA71XmKarMeVvFGpQ7FmYVfZqyxkumdr5sGVFc
332	jxqr2oPKfc2o69HjvSSP2vrj6q4nKYS8hCYYLcpoHYQPpc3dkbp
339	jwZPdDg4vThU5uPF6hwft5oz5qGM8ghCUzEuRszzAod3fUU23gC
343	jxnB197HzYT3XT4RNCNxfvPmDXcJUn9BrTcxVTrh6bwHGNRKYF4
344	jxqxdu4S1XX2XbNyGHw5wpE63ggVwNfxePDEZiPCpHByKKSMf8d
345	jxpYZffaUniBKMPZ7N6NTgKqtiXF99MN9aCprSHgnrGQspMZyae
352	jxcDDMwi95FVzkoLo7kJM9P75oS1uVTGk211nrfSqKCM9N7wGSK
358	jy2jc8rs2S3CpVnBYgkJDEyzwppMYNvujxHneZ2qrC8tk5ncfjD
359	jxRySSfk8kJZVj46zveaToDUJUC2GtprmeK7poqWymEzB6d2Tun
361	jwMbk5jxaTCFMDkywHhjMEonprHE9W9iSdHVHBMr23xRCfngPPy
365	jwq5TcXBfn5pUEL1Yh6CsZMmXU9GeyQQ4s64oNkqr6N44V3XMYC
369	jx8XSUuwehbnEU2B6n4xEAXn8BMjaD2YhsDNcRWfTYpiVGUAU4X
370	jwRdBGHfP8M72dEPRPB2xEr3MMzdEEoaVkeCS5ZK9ZddWm8YATa
375	jwDVK9NP2hnRzVxt2QxWqKfP5UcP6T2coDw87c6LmTM3Cjb98LU
380	jxephLFfNjk9gwh7WFuC5ZLmFqPb4CovhhSujqaH9EBRVrFX2U2
381	jxJWHcvWmpM5n1G2Xr5ZGzAzKhRprSFHPnXKbbeN6RaMJBGQLui
383	jwaGHxKaX5gxmSPbi8ThwPWwF6DEXgPWoehDVreQLFu4uovB6FM
387	jwe7xgZviU3jwoAv8AmyfY5VXZMyuStSNkbnLuhM8qimkNhbxc8
390	jwbf8KYgPQFG1C15BoChphTtbeyoZBBGXR9ndMiBGpcE6VgLWhs
333	jwUQpF72hacYgQ9p7uMy29oq3uq3YKGBmLx5FLyXTNSTH1mHSuT
334	jxCtRyBjUQFfu1ceEHC73AW7tNFrNiqVczWmdEhFWhqeyeu6RQR
337	jxbuG8fNqRWDmpSoMBH4AkiejCGArqQ69pz4ARD8jVds1Y7HMP1
346	jxdBkH8u8dy9BHmyqdjehSPfbcoSXaU6WfoWXFJZaAtu5gp7Sew
348	jwUPqD4PeuoNbyXDBAtE86YzsqeBMUs9zpufQbbEZDwGK4z7N3u
351	jwcnYvAxpJybHDMJr4UtJ3xH5kYwjKpWjkBrx2rgp1MqJnb4N8s
367	jxbcGBkASp3Z4NsDtDqgdveZXmFXT67kWwa7WUCrEdJ5Sd9ot2X
368	jxUKnTjoTaJgcDt9vH9XQUcLXpLFaKT22ZkyUkgSBdmmJt6kEfQ
371	jwT1sYu75sfKkvHnGzB67ZgLoMBZj7BnFXQT79TTCCTkgJ4Z71Y
377	jwSzmyLYBieFKczRh2ANpu5po47naHFuPggCpufXtfapzyxdnab
379	jxXx318QRMJ1LLnuCwYA6kgntw7CeSqcUwtm1LLoMCv2q4EAnJv
384	jxsduu9cgiV8FVdmXEFh6vK4X761jVxUPdFrBE7FJYb1BNkXDwZ
385	jxBPYnTWLmpg9BEjZDrHdLcJ3ThkfMbsxsFNpX4w961iMHoLFit
386	jxWyzJYF5HrYorzQ2PW8xFtYUZDejBSt5iJKhacDRRp2PMSuaWQ
335	jxm6nZBmmNukd4khYhwD36UdvZR18kS2BrArLSTNtXULpg6Z85w
338	jxkKoJj7X3GLPLQ4aFWcdTNcBk6WCkVJaPNwkfKGHDwfwKUPxeY
342	jwCoXfRK2oSBnjaVivcsKj9GwPdJa9w4gKWGXqNBqDNLjddjVhM
347	jxhugE72JwMnaoFs9NQurfDZHycUF7HdtsRxcupA3DKeHAyEPBe
349	jwwaWoeXLGWbH5FPmBiRaehAWQfx64QYwzPd3hi8h8SmxwSZv3f
350	jxYeLmv54jG2oEihS8CBqhv9MTjnEC89MSTyepcoD5UPc8MaYJF
355	jwneCT4fB34456iPozxxSgLWaCmsxa3Eki5xD9as6RnD8wrSptv
357	jwX6zycCsS9jwZCkSRxCDaj6z1HiCYQddkbAHs6JrSeq7RHX93H
360	jxX3n7Yxb8EoJcnkhxnwGE4QjhWxo951dqe9fL2krh688PCtES7
362	jxosoWszzBnHZtMjDf3EwpaNuBrH1ZRpJq8iM2st5FmoGo7KthU
364	jxa8rNEpLNMfqh7fv5a9LrJYxpHrb9a8CwHbWdqPfVw68cWYhhP
372	jwGQcHUxe6Xfw6YcghCv6PAxwh2rC95A12XiJsyZWLCAWG9NAZd
373	jwaVR17CN6tcUSC8b5ZYYzJNyfTkNdBMbG7jhYoYSDW1CcAUmxz
374	jwLrk4oMDRwoXSV3AUP461gm3aZR7Wycpt8nQscMWBXjdbwifSy
376	jwTAzif2C589q9MAh6PS2sxy5hDUKRWpUcUdHAfaR4ec1Kfwtjr
378	jwtJMA7CFLxa7c1NriHWquPjXeFEqdriCg16DtCZZ85fYZmXCFM
388	jxVnrsKhVwXFoJZxrCt6Mp4ZxGrsqYjBTwMYjyPwrn1a47DxZ6N
389	jwTE2dBJxJGwdrfhtXHZqp9Wqsi6SScZ5cPdnSstnh8n66ppwSH
391	jx9vXVzVge3Wtv9HPRvDFpobDvk9EkgxLAuqmFwC4hW9xtwbizs
392	jxbPNkRG5HDAz8RDxT2QGNjTL3gAzaGZVvcVHyrcs4g9sDtzhac
393	jwcg7ZC6zc26QmB31uN2JvZ8rcwfCKxDeQdaufSuXo1pY3cDNBs
394	jwgGiZypxVsExptBvxDrwDQhDX1RwfQnyzDQiryDZHXDbWQrLJ7
395	jwkAy3CXRgEKGm9gKRXqytrisg3P3tTUbmEZ9Vq7QquE5R4rdaU
396	jwKjec1PmwQYygoq4yB8gpSGbUUJMRHZn6DVULdLzNHMStMbxSv
397	jx5XXQvGGxmmbK56w6C6B3TRS7p4tbX7vT6ZJhVm7Pr7GGwcRJN
398	jwECMnWH1w6fejnTPoo23yQQCazEDyNmjAh78ZUnoQk5Ko4QWfo
399	jxDBMgFWLQTjroix6tfQkxxUvgbHjjQq5cnb7TmK8w2bgQ3Uaot
400	jxTcGmRTSq43YCpJjL4JQ5tu91E8VpgV6d9DUZuF3TUsNZW2T6P
401	jxckBo1PBzgBqufbqKeMSnRu31EbCpRRF7yFE48h1637X55woWF
402	jxzy1FFzti21JFN1SuS7BhMKTKoezUJ9XVQkojhRQb9cHyH7Lyn
403	jxovyvXJTk6GvcWJLjKDosYDQhS9utd7oejPwP7xwy5TexKWoC2
404	jxFwn2a4pHa7uaMo65NfKjGusG8n1nd97hYhgNhtxvPR7647Gx7
405	jxfg1qyM1wozQjrwDXhwaS9kQoK4JmN6gGh4WR2H2mRnwxDvJ7T
406	jxu8A17chD6e6v3qSszS28a5Zw2jd9AtevSJuTdLiE2yDCUqP9c
407	jxWYPnaT4FEFMJiMn4osWLyP7McuFojtRXi9k9rSbWQod1NcaJo
408	jwtoADBG5LHQNgRPXukiCjD1axFB4x4YrQX3FcK2dH4jYf695Gw
409	jxXpLxdgEWPGQFuC6U9dd4hefkAhdBJjaeEto4WzUESfWdTFQ7F
410	jxfseJgX2J1gQXwwKaTbHMVbYNVPLoa6FBwQ6zRFy8b2wXBoine
411	jxoWXdVSYzmC9tVeeMecoK1Chkoe4P85xzzeYczDPbqTmuPvHh7
412	jwFbNaTNAZVbgVyv3Zoss52zEght3TT3cSobUtibxA9S33Yqhp5
413	jwHxEHKTMY2uWBzzYgdrJP9MrduvUXL8VgNZ6jrzFfKQUhg58oM
414	jweqHHq3A5WLdfDfKVjjppMm9Dn1xKWBfyNBqBEAxknZry6pKg5
415	jx3aL8ZSLtr64FYMxXFMtwDSiGEu75LX6x7uLT19DgU2KMrAUtB
416	jxaT2Pkck36mQquUG1p33Danmmvs17igpVVLUHUDZxhj3gRgK6u
417	jwzoKeQhqBQJgvXx4LFygWdVZN5ktHuwc825i1Nu3cvcsEVmT5x
418	jwTJzwXEuiNrWApUs7Zh6c69VjNPRdNNQYyqUgGtcHkDqUWxUHM
419	jwHiGWnXnDjkmwMRkArhTTYuoZYm119Wvk4RjHTXYLjfJWT3Gv3
420	jwVQ7CZ33fCo6o6s8xDvjKTjW4UTWnYm3ah2oT9iS95ZWE7Uvxn
421	jxdmAjbZy29UGV3gGy6f8vLyAe5dn2dDiR6NeeCeFqirWu6Cznx
422	jxzgf2tUNWWKRkDS8nUweXX9aZfDjjaHgpgmSMbxhTRst8hZu9T
423	jxzaFDu6WUVfQmLS4VGM9PHd4kGKc9SoUJ5QXxLQjRRjyJpkc7q
424	jwXYewRpjfh1oQJxCvwEFyNAaessWzvxVo2636KuDvAYoHCPGS9
425	jxxvhvF8UHQwCqmZWF1PgS2QVkAypjBfnV9ms6xDtCDsaZjmXzQ
426	jwbHYwGJnjjW6fws5LUxsc3TbNmXH2156cRzAEgpTaaonQKb4DW
427	jxVNyftpRWaaSzAKWwbxNV6yddU8UZMqA2kZREwiT81GfZKzDoH
428	jxAT515hv6R3sDfQgC7nay7NTnNAVvmvjSBjG69mVvBmHLsSYxP
429	jwjyzb9HAeyNnwN61RAHhcd19vWbjLde3rgaBekGB229VGVggfg
430	jxAgjNb7yrqs2jvawZ5qWTeRkxgefgMPypnjLrkxiSMdTG8fzNs
431	jwmGsBYGLJARNhZzb66jNiPCkby8WtjKb3ifn41oDzA4obS4bTa
432	jwSWV1iyrA1WEVVdRNJWx9Xa6XRqTHEjX4toJVKQUuoBEveeukx
433	jwxVyDFog8mgxvUzhhLRGGzYSkFVMCNgpThVTXcVnoLeNMDWKSW
434	jwVLZzk3RJymeREjjETBsDmfHepQ4LhSFVKLw4VyAYXhmN9fCZt
435	jxdoZ3dJcT4Vq33zFQ3Lu3ZLVgaaoUui13AWL4igE1bwP3VtcBH
436	jwMQ3w1AoCQ9LvmmdCMC9w1L2jt5iNYRfd7wSH4CdajP6Ljav7R
437	jwGxaXvVdw3YFQwMAkBoGrDNj5Vjsqf8ryYhX8So2kSDyV9Ur2Z
438	jwAeHi89Pm7yKJTy4PwiTWzGEmJcHfyKW26vXgFxU6JL45iC8UC
439	jxdeEhwLFD7dX88MLU6oMabkj9JDXzCf7emjibLsWJqYDw8CNCj
440	jxa7dkwwFpaG1WfKcCyMpsdKVxrxBWZhT3cpGgaNy9THqspnksz
441	jwvrZH2wNji5xeQj1wFYR1VQd3BbJw3u5mzLWURYvPitc9XSjNh
442	jwTWDPgmM4Y2ZgG57UhxqxwnYYk2JRz8QLFPKQ1CTKascc2dmoP
443	jxxE5WNPkdfP2fjTmoKZbxkrkFFURLq46hD99zcUuWS3adwev7R
444	jwQ9fBUGpujhku4rD8pUKGSz18zhfUcxwY6zSGeANFFQzJ55mpP
445	jwvRo5QKP9vwvp1hjJzMJNuoEnBuqGE2ytL2t8Bk1ztWH6qDvo8
446	jwJqsGGDsdEn7NdwhUwbw8TrpX3RKvUS3nBUQLL1UT8cYMtn9rN
447	jxxd2GMHrwaq2BdfNamZ69HXdUXTCoTECJVPiHFwWUjieUkPXZy
448	jxzKV9w2mrNzhLipAsFbMP8yURNDk3N2W6ajJBeCTrEHzdTbWQ5
449	jwsSVqSuLYDnAdzkExDFVKu7frQ785TQkAtHZipb79ctdTSDyop
450	jwZB5zfnXjV71L6PesjEBQhqcawU1FdMej6zjWP7aGnyBxvNWSB
451	jxEMb9mwxhb58ErvwHMi1Mx98aYZuFjD8LBNfLovpaJgS8g1CiG
452	jx8J1EuwCAhknywJyfP8sKLKsdAHyAcSfcayhqCcZqPp7kEu3xC
453	jw8TQmVEi8Yi6GzB3f1diY1t7ULcLDoswm1pJMaoytFqHHFzK1j
454	jwCLvQ9fiYYKXzZdgvTAziciTrUwSmuuDs48Ja21k4y2ux1r8VD
455	jx5swDXhhtPnirqz6QM1H9RofZvzz6KJgkygtchvxKSczsdm6BL
456	jwxFhwwyttkhYJ2nu4QybrwssyU4L9Dq8DQ1n88QThKbcsqpHpr
457	jxiruQckZJhqsdaTpxgqQ2CAt6CoQNqrUSDgnKEh1WaJS4wai8b
458	jxUfCpSa6f8cmhwRmhc4BggzXfdYQVD1fX76h8ugo2dkcWFNDNt
459	jxbgqpGYpZLxqKDjUtp3AuT5APjVjSjRySjjXUpQ8pj6G4PwSTm
460	jwKHK4X1rjsRSQgkptwFSyzW2jwar1HcNrQkn6jXCz36d9BH3xZ
461	jxCQMjmQLvR93k4rpXFC4W32vmrKyPwRp1T5MXcdh8HqTXyq2vW
462	jxmbZPP7Qqjq4fkPs5zMtHKSxkMscEM5R6kPEy3K7nUR7U2fpRq
463	jwyviW33UJzbNSJ8BdyT2auUr76o9ssT9ZHynSkXZyz9Emhgdqf
464	jwVvtvnhrsfWWSi23bGpoVWeQAZeHDHyVnVW6DrJVuQS3tgSNrc
465	jwtbSehy4hdP1w2vXAvo3cVoKoddgC3dtxTbEoMPAkFLeUG85QF
466	jwimWTPJfhrbKUAJ4DegXehCJKBDuAW3UJi3VXFNDdEXjBZdx4r
467	jxjpwsva5u7wesHKsKx5tQnkQs2ByvUr4nQJyCx8VgHuWtp6AkS
468	jxwdJVEzemtVVu9t9Kge3GmRzKyawYDV4ZSqvi2ZpuwGTmaphBw
469	jwki1i3DyQNtypA3MJNf5wLR6Y2hu5h6MRQwkhadWpv5RZbnT42
470	jxfYSaUArqHHPHQjydq5TuyiPi3oXP6WMNScLTmxyRNdwpDaKbY
472	jx6nccfzCQLL2ZVtXiWsNXxiiuqaSPVSUhuYQxETdSpw8kiJ18y
473	jwpPGbzYJMhRpVMv8gtZY6x1eRrFRWMfjyytQiqFuw95rEA81JR
478	jwGRry8va6QfSWvTdihM1QQzby185wUSWNZvyiAAhPaCaHmZGn9
480	jwcekdMhPsLu9q1v5iZE4xAQUJnuUtrWgeEELpJLDFajUX7ukNk
471	jxpXr3JUXudRgXXV1ybQgUH6tuViAmZ3Frn14GQCkvYTV2M3VZT
477	jxHp1nTyXsmK3UYkMHePP86ok7o6mRoQi82Rh7GDnbdXJsBovkL
474	jxnW7VXcdLKYZNS2e2uTnwxWyNyHdTUMR4xAB6kFuVyVWmME3ox
475	jxhMaDmmEPkiaUTPq6TmpFqbkz2NbdXZJTTiDQQrgeVdxuHA1gX
479	jwhYys1jQSC6Rt8QAMDXYzZiG6jY18VNa9ms3GkTN6qc7jsghML
476	jwocMu6bwTpZqy9SPdtehQTrEVm3TEXmqecQQkY4puSjxQZbk8i
481	jxQjE75enjsm35ecqFiGDea6yek63fp3d4HXQBgZNSDQLTtdPxV
482	jx6jY1x7AVtrZbdu28sw3sUHRpZebac9ytbLqhCZH51ZtmAYw8o
483	jxR5Cxf8hJLSmZaPf8yoDB9EL8djzZFnTgYWAZRJJteNg9DMnyj
484	jxZc1reKzEgfDNeWVebjqEAf8p68rAwPsk7cAx2ZiYYbZAKf75s
485	jx637VFgVtMAMPnGyoVEzTsNzGdT3nsLhHXyJM1WHjyF7Gn6NoN
486	jxEdaNv9iRen3up9sFc2xtk3cdGnKAXP15UuTABxQUXtN9mhfGP
487	jwEL1eAhgnqDRNvaraq14LjnCLr3Hcci81CG6wtGf6qtQPCTCm2
488	jwcymvcNNCNMT6eH7UQrgfcdwi8Z7teZ3FqqF7YPJYZYNG5Qfwv
489	jx6WCsq4pfWFAXuxoYadWTJ21UFfBGzNNzWDmwuNhN5o2kuXTfQ
490	jxD4EZ5RZhauz8hmF8MiZVj8GmPKRdKbVVixeeryetb7PCbvFRR
491	jwNBR9XKajwBfYuqJxLFeDggFK5gPGK7iYjHTc4VDwLe3QR5HFc
492	jxHJu7cTdaxJAFQFxRxjCk9tumFFfKLDa9C7CD5NVL6sbDJTWPi
493	jxGixkkdxfXmWn3c7WRCwPhVFzxZkHWmkwZK3D9yG6Qcwn4hF2X
494	jwHzfSo3YrHwExfXjNwv7TJDZjCih8CwNTmyWNdExA3uouNbCb1
495	jwxqJsUvsfPhZtH6Ek1cei7ML6aNRHZmuZEgcjd2hgiV2GhGvk4
496	jwrkUeHxQsatbuEWJi55DJvHS1pRQzjg87SBwYMm2bDEhM7gm1o
497	jxf6PpACu2zLk6VjDjc8ctMRb4DBMaevdXJwhajKf8LrTpUKdPf
498	jwyP4CqWyLSSUH3saKdYqp9nWRCpD93qHVbyuuAnLVt6Up3mezG
499	jxRY6nWteCgm9hk85gj3G3F21gbUdqsx6z5MWaTkVZnfzZ8ip5a
500	jx3uZwR4Ja89fVZaXoJBRQPVj2B2hgnhHbANWm5vpewcZP5qo38
501	jxqpo8tdBC2JGH4UFQnFuW9jZvsmJRP58uuuP2HhtvD6cE4WaH5
502	jwT8n2BZcJbyD4NP63tXwPxubmuhQMmcZKVHW5mTzYAknnNvxoe
503	jwLScegvDzhGqxSVmc6zK7hBE1ci9yfjZqK8ZaupkQycHETEkmE
504	jxUHnkBXAgzyx26MArQ7Gm5mBokGKCzieq42HVDaRYfo39wgtmo
505	jxcsZ94tvimnQFouNsH1QX1HvqwnuN6sUDbxxCE217x1jDubaCv
506	jxMKhRbc4pgqn4ESsbzniDQx3cD2VyAooXi6GUEQ8QQpX5aZ4X8
507	jx175qxCqf3VReRDXeiBqJePuKe1SfEZFXZMbNBupcEaVwKWUNG
508	jwA5isRxiUN9LmSf8bXYDEqrUtAP2wMxG45SFyDnHMD3x1ZmwHv
509	jwru3ZwcKmb64mtEthpzxrWKZDfTkrzRDg52CH7yMyC3xxWQMwZ
510	jwMJAXDhLPMgBc5TYDPF1Nu7EnPcXVPZewrPUMwZRo6Ky6vBsXv
511	jxxpiHo9vj3MCNb4RMqzx8HpidUWijfLXcx6X8psgrqTntpVNiK
512	jwKrz77GAnM5x3uGQzDbBqXMiiAh4hPQgnRik7MAVZuiiWduPpy
513	jwcRY1eukhsMmsSGvbwbeBVry5uPnRUQPVCVtTERtPT8qac51Ur
514	jxXRTGi5t3u2BHe9JJdnRjgEUxQEqvj1vfwnm2T7BBdyDNXEqY8
515	jwQr74P3KNgc94j5LZPufUgs9MB14WTRAfrY9V4FdxkNiRjFMSo
516	jwmYpxsBbwM5yFfbtiZcxEhywFVNbEiqDGW2w4CzvRSSF6xCRHF
517	jwwJCrfWyv1TJRM1j6LdZ5XD8MfZSwvgpats6iiMXs6TVz4XV8p
518	jxiTk5QpdN4tRRVNpfbW1qmhh1UUkoNeqXCo7GRSseckryjJLwS
519	jx42MYsMM21YEVKNQ278gn17qjavTjSbBhc2x9Vwmzz1TVoviAC
520	jx1JWegiStQviqnfHKpLXT6xhvBjtu22VMVMJMRQAeou1awAcUU
521	jwRwmJqNSQcQ49cZwWh4xzw5YkEySf75QL7s8JnnbqpWhUqTKzy
522	jwWhyssV9Nw73phNrzFqQyzBBq3j4Msit64E3hnvejDUNdm4TFh
523	jwtSDyJbZjF1YkNqFbks5JcEsgKAbRGDS1GQMmQRbwWdH8cBkiP
524	jxHc1YZ3p7uVzqP4TWB3yz24GcpZDodsMATKyochFgWLdAQAkVh
525	jwwbPts4kPoj4xaZFDFicEo5yoe4JkhKzXfskfDD6KbtbsShdue
526	jwfZvdWG4B8cB5hxF9YhN9xMQmTbXrYVpTWP9R5d8iVGqxmj1KP
527	jxZxFw8jfLZpBQA283rFx1asbWJ5po7XYU8PtZkCyqWyZs49Adr
528	jweJWuZ17chq9SM5fPxZuiZ7kvGznmqeCBbUwubXgWNF5LQT8ia
529	jxWU7mAp5UCrYMjjBErYQeWE8xiJ8ATvX2YmXAjnTFyqoNqeSPN
530	jx5JB7jvwsHp1cpwHwwrMGtBVPvg9fu5WbeihVyzj4h6EFUzVor
531	jwYbLCVSem39nuwfWyGMji5stzDUWbkHKyQY8pnu4JxtHV31Yp4
532	jy3Jru6zLRaxeQxx6iVzRALJgANqeBJnQ3fMcfwLzptduQDbByh
533	jwbJTQNrAr31KomaGi2TJnMjdAhN4mD9DZSWSsThFUkyxWdhay3
534	jwxKizBwd2tEcZDfCEd9LgbX9x8GZoswHy8F7q4q5F12TLb9YQo
535	jxea5NYDgbxGoPWc48ZdYNQTZuNCKRcbN7Edxw1CFj87fCoNJFz
536	jwH5FsCT5RGgvUbrVM3rGW5k2y3hbLzyMEPAK8YhhzypgBD5PFq
537	jxY4ewT9mb2aQgwq4HczaPmRoYYGzcGSijehgPEsrSdLu55qKRb
538	jwboKaqytxsv6Vi4M8BA5SM5rxWxYyTg6UFHjuwNwV43ZDD5X1E
539	jx6tVznmFXuMkJsRSzh4G2AK2HkhcT6NVys6D6XaGKvwFh9m8LC
540	jxohUyr9CRYbBbZD4BYVEE4dtShg24GoE3A9AQm3hPbZmqZ133j
541	jwEcBYsxr6w9vp8GXRPMYXpgHopVXyWdv7BS9q2uPN9Kv3L5pzq
542	jwmhZ5g6w8YBn8ESymfevfyLLvgUZKKFanS4H2d2pbtN4S1wQeY
543	jwozxcSNgsghYxZUMsyYeGeNECHQrV2BDqze53xdXdMkunqaBjJ
544	jwRxYZ8wU3mEpBUE412jAvqFy5wp5iqjW3uxEUoVcn8nMLiugw3
545	jwLgQKDwfyCoxUBw8PPysvFzr9Coq8zdJmoPfg4ZL8ZvkUz5RR8
546	jxhoXG52PudRq7VCidX1mKsZtcq7cVLh5aL9rJBJo6XdNPpQANz
547	jy1CRmYRHcEtFvCuQK3fRTV6EGDbd6xk4ebMcri3M2jZAnDL3bS
548	jx2QvxQp63GmukbZLXomd1k6UZRUTVsTAtPews8HMWaFipeQaVK
549	jxourkN5WoCAou9XXxg2YqT8c8PbMTw6uUQmym5KTAwejYJ2ezx
550	jwBDyCQo6hhqyF5wLTstSB3sBqzrbwYi5CfS2ew3ss6RfdUtaG9
551	jx4q55HBBqCLnwD3WgrWjMc3UtYugR3Hxu6o1teRkgxK8anhadC
552	jwnSz3BGnjas4KvHmnkwhsbofCJWyLqaGQkz2EskSBm52Fzivaw
553	jwkScH8iydP7jwTbMgjmg9kGv6kyocLRjYqZq24M8BSnDK7M7kb
554	jxzjotVwNpPKEpSu6WK5he6Qm3TN3iQ5iqL11sAPPa65Bi8qDMK
555	jwmhag88GziRyiudKC9HwLv76XvEWyFQTZe8puzhSVqQS6cuHif
556	jy1hNxZXetchwbZvvNivap1hWjayMYMngcFdYYj4b7DX1dnkYa2
557	jwjm5r7Jx9BzsTMVpVpXwsDZiapz6gxnPPXeH1dRRGmwA7WwtXi
558	jximV1akw6tyW84MuCeM28ZY67LKhV8sMAwuq4L1k5FNmKgePWz
559	jxhp8nzVWQzLwSi82xQZed4uHK7VvUgdtrHzWruStuSjPVySd9x
560	jxC4w1c3Cs4Mb2oe9iGdd1neKakKReN8CUWw7brZaTSdhjpLifj
561	jx14VuJHV6B4bA8uYLqGST8UQ1azeyb2MSKXHYcvrgu8cnn2abD
562	jxRqwZ42D8Wtn8zMKA6sccF4bfstBXRBpsdHMus4sGZwoR7phf8
563	jweh84pktWK8P4EVzBHcyUdbFLtSFvtbBYEwzkDfpVsGBThCezx
564	jwYr1adWuoaUe56xUhmF9XMJJhaScVEn6hd1ZkGZEBgf3QyHJ5K
565	jxFbfi14DokK3ANfJUyrDBNuNKq6CPBaVn4P9g7YP4t32NA34aC
566	jwsHFKzGBsFThMi3WUmVB7rQWcHBifRAccZ8pzg34vNaA2FRyWd
567	jwEPGNxSaQaBfyyLf4pCmynCTPiQ6xyWef2YLYNTZ5vZePN86Vj
568	jxrYr58GTvmvvHrN4ahW8ZbnDz4FywRCpvNTYnC4wZ8FWVG3Mhe
569	jwUrrrvHZRvv3Jpa6DLPhVXN2G95Apcty2XGci2CoNs7pRMdYYH
570	jwnixvANHGUGy2hsvYws8zBDSQT4yyTHA3VAXcDFEQTXryx8zBw
571	jxkx5EQKZgbX3CBnisAZkgRXLBCieh7G31EFLuMNyeRqbqBx7KH
572	jxH2B7BpojpUnQ5mKF2yhnqbVfVm4DxeVgPNQeY4WfzcDF3aDMY
573	jx3KRDm14w8pLpHNvHrRCvCvyxWqHBJPCYFojd3TRWcR1LFBkzb
574	jxZcHUgGyPtgsP8QjmaXMvq6c5WCJpY9zQXKUF3RNcjdXyqWet9
575	jwLGkjgeadoHrG1ReDWUvVFYzsNYNfRGJhyQkGL5rW8B5nd4cxT
576	jwwqrLeZtFZj1GvWAtPmsvYTqwTQUwAtX7c5KY7gqS742iCBUNf
577	jweEuDHmEHvxBk79QaMv2sXr4rGNiC9Ukr3UUS8RwYS2SZidbNc
579	jwTjLNMQ7ZFS1tou5jVaPPeeihX8Xbotx4aupxqduSRe1x1YKEN
578	jwBQGk9PFa2c3MgEDNFgGuER7kbz7WkXKN3pDVDLy3qtxPGJEXB
580	jxNSqwzAQmh9abvU47N8VbQcVVu1EEQ8sxpN7bEb1eNoZjv4Gvj
581	jxyPqW8HhCqiFrJnt4hQEXf92BQWubK3AbzRDoCWYMimkFaVkM6
582	jxXcbhTzq8uVuz44qpFYqkkgeHGPyWVFAWpMbhNJNBSFKybBFMa
583	jxzREivZm9HiVFRe7es2nybPp2b4dFQvmLswhBxPeafLvX1e1Ph
584	jx45TLK6gz6YXm4G52tCFzj2N99QZKAonGt5UfJu4RDjLdyTVpD
585	jwotgPEG8agCS6pe2wbZj3TtDGkC3AU1Nuy75oDuW3V1L4uyYYd
586	jxnGWrPF442fH3JXMGxq1Ccy5LfyKNdhDW6AxrqGXsNZE7oWRe7
587	jxbS4TB3XQSrF4bDRZ1gQn1etM49mDHukjFdmMxqaUJuYFHikmg
588	jxqVKnnHBgmfppBJ8cRDHuTbEVpQiYCytLRCaGUff4B8bB7Tfhs
589	jxpfNJzBCdWdVMwazCtrVMxiJFtHbHWGvDAXQ7ebLQ3GRfZYKKM
590	jxcAPRzGMZWW9GjLfaPVAiNV6XX9cyPWQ2vz3XrHV9rQCQbZyPL
591	jwZsk8NpjVM2A86j1apRb1Kde4bx5FbkAtr3BpVpY2P3jZ1oZY6
592	jwMuKZw9RC31jJiHRYZpkeusGo9TGkX1piEDk3HubU9S6tz32cC
593	jwwxi54FDAzSbDSd1ZT8T8vnt9L9ad2NQbQzF7RiVKSVKZH6m2h
594	jxRo8kEE7QYP8z75rSrpXuY596KnrttdpDgN5gMbqogmfNSXXbV
595	jwzmmbJGie1KuqeXsnRh1wG24MPYeceQe4Q1YPEMXWWoW9dEN8N
596	jwvidPchWb7aoP3J3ghqCanKUJhMecTj4N4mmpEgcjWWh9RWmjw
597	jxskLeizVRCsXQUHvmRKw79XVCPVRjwVLZPEVgF1MArUHnh6VLg
598	jwULV5Sew96RsiF2NLgPhR4eiNrRkwZejprYYLy9gicLzQQurB4
599	jwxPrfAAPoP9RCWGCxYbVrmhVjCWbvBsj6zBG2V2tYGpxqqoMcg
600	jwPxFQBUni5ZxUUoiMf6HLuAwBzmukKmL2tbHGCzYARqEUcX2ee
601	jxXKUuS3kX1jkLTu4Ejk1SCmBx2QWHp38n2iPs9eBNHJM1wKg94
602	jxrLiTfG2CLF2VzdKhwsbbhY9oAAmK7jj1t6JoyczxvL7Nfkahe
603	jwBxcvAhEP1oSGYM27vnEZoL93Bf5ghH2ckqiruPuKft7nBdbuk
604	jxAQ55SD7uQAw9paTvJUJxCpiYmAxULi4cQTS9MN3CcYcKNU9qE
605	jwzwVyEx3aR3FoFS6ef4PBARzcyx6jzf6oyxanZbfdedandbe16
606	jxwm5TZ99MRgdqH47yirzqXBgiQVuyDxoBrseAu8u7X6ZP28Z3n
607	jxmYdpaC5GoAyKTarheY5op4Qrxik6rJACj74isUvd67CErTweJ
608	jy2MPSm1tANMkCFZa29KiSznsxYWP3mjwgupuKBZmtFiwfq43gd
609	jxYciHV36CU9RxFzJTjeU6tPAVNk4T8SPjNCT4tQkVnRKS6DbRZ
610	jxZc5uLAet4VZDxxqRTBtqv1zRMPJoBB8z2dcHPYC2GkrjTXJXS
611	jxmrA2rf1xEpa2GP621dG7ufJsSyQUFBmadMJ9J6pbUJ2QkJZaX
612	jwP83Y69MkrRoaZXzWpgfZe3t4ZLNtZZ5PiVPSNcExXrEusACAL
613	jxHtaHVYVCw7KHX8ZETHBEAbPTDSLXFQ7eX3tDHUgdnZ83afJxR
614	jwiJpE9ixQLZKZrPSk1LzCGjLk6kt4E9sCV7ti2dcdF9MfmrMkw
615	jxfMFrmHkwtxUwNcoX99sNZocfAzEZzwrLJV9GY4Gtag3q814rw
616	jxB18FpuocHBeXtPcrd1TyUrQg26NBCV2BpGSypwHmGGCTT54rQ
617	jwYZinZPApiQmKStkwCFJRa7MjY1YjjSa4QjjSfdWp4jin19xad
618	jxpxMEn74RyAgLxcDVKi9ZjkZcuD5uvEEoNPGKq2FjNarxkU6aZ
\.


--
-- Data for Name: timing_info; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.timing_info (id, public_key_id, token, initial_balance, initial_minimum_balance, cliff_time, cliff_amount, vesting_period, vesting_increment) FROM stdin;
1	1	1	372093000000000	372093000000000	86400	372093000000000	1	0
2	2	1	230400000000000	230400000000000	86400	230400000000000	1	0
3	3	1	145418000000000	145418000000000	86400	145418000000000	1	0
4	4	1	148837200000000	148837200000000	86400	148837200000000	1	0
5	5	1	6697000000000	6697000000000	86400	6697000000000	1	0
6	6	1	32558000000000	32558000000000	86400	32558000000000	1	0
7	7	1	2326000000000	2326000000000	86400	2326000000000	1	0
8	8	1	10233000000000	10233000000000	86400	10233000000000	1	0
9	9	1	32558000000000	32558000000000	86400	32558000000000	1	0
10	10	1	32558000000000	32558000000000	86400	32558000000000	1	0
11	11	1	4651000000000	4651000000000	86400	4651000000000	1	0
12	12	1	2791000000000	2791000000000	86400	2791000000000	1	0
13	13	1	4651000000000	4651000000000	86400	4651000000000	1	0
14	14	1	4884000000000	4884000000000	86400	4884000000000	1	0
15	15	1	9767000000000	9767000000000	86400	9767000000000	1	0
16	16	1	9767000000000	9767000000000	86400	9767000000000	1	0
17	17	1	32558000000000	32558000000000	86400	32558000000000	1	0
18	18	1	4651000000000	4651000000000	86400	4651000000000	1	0
19	19	1	2326000000000	2326000000000	86400	2326000000000	1	0
20	20	1	26047000000000	26047000000000	86400	26047000000000	1	0
21	21	1	32558000000000	32558000000000	86400	32558000000000	1	0
22	22	1	22326000000000	22326000000000	86400	22326000000000	1	0
23	23	1	32558000000000	32558000000000	86400	32558000000000	1	0
24	24	1	930000000000	930000000000	86400	930000000000	1	0
25	25	1	9302000000000	9302000000000	86400	9302000000000	1	0
26	26	1	49460000000000	49460000000000	86400	49460000000000	1	0
27	27	1	10000000000000	10000000000000	86400	10000000000000	1	0
28	28	1	20000000000000	20000000000000	86400	20000000000000	1	0
29	29	1	7000000000000	7000000000000	86400	7000000000000	1	0
30	30	1	6000000000000	6000000000000	172800	1500000000000	1	8680556
31	31	1	1318605000000000	1318605000000000	86400	1318605000000000	1	0
32	32	1	73627000000000	73627000000000	86400	73627000000000	1	0
33	33	1	10400000000000	10400000000000	86400	10400000000000	1	0
34	34	1	66976000000000	66976000000000	86400	66976000000000	1	0
35	35	1	19200000000000	19200000000000	86400	19200000000000	1	0
36	36	1	30000000000000	30000000000000	86400	30000000000000	1	0
37	37	1	65328000000000	65328000000000	86400	65328000000000	1	0
38	38	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
39	39	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
40	40	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
41	41	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
42	42	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
43	43	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
44	44	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
45	45	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
46	46	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
47	47	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
48	48	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
49	49	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
50	50	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
51	51	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
52	52	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
53	53	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
54	54	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
55	55	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
56	56	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
57	57	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
58	58	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
59	59	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
60	60	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
61	61	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
62	62	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
63	63	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
64	64	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
65	65	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
66	66	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
67	67	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
68	68	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
69	69	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
70	70	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
71	71	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
72	72	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
73	73	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
74	74	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
75	75	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
76	76	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
77	77	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
78	78	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
79	79	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
80	80	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
81	81	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
82	82	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
83	83	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
84	84	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
85	85	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
86	86	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
87	87	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
88	88	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
89	89	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
90	90	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
91	91	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
92	92	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
93	93	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
94	94	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
95	95	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
96	96	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
97	97	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
98	98	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
99	99	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
100	100	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
101	101	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
102	102	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
103	103	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
104	104	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
105	105	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
106	106	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
107	107	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
108	108	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
109	109	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
110	110	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
111	111	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
112	112	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
113	113	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
114	114	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
115	115	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
116	116	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
117	117	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
118	118	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
119	119	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
120	120	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
121	121	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
122	122	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
123	123	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
124	124	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
125	125	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
126	126	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
127	127	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
128	128	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
129	129	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
130	130	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
131	131	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
132	132	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
133	133	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
134	134	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
135	135	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
136	136	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
137	137	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
138	138	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
139	139	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
140	140	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
141	141	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
142	142	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
143	143	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
144	144	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
145	145	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
146	146	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
147	147	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
148	148	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
149	149	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
150	150	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
151	151	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
152	152	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
153	153	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
154	154	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
155	155	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
156	156	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
157	157	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
158	158	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
159	159	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
160	160	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
161	161	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
162	162	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
163	163	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
164	164	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
165	165	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
166	166	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
167	167	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
168	168	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
169	169	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
170	170	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
171	171	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
172	172	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
173	173	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
174	174	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
175	175	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
176	176	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
177	177	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
178	178	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
179	179	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
180	180	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
181	181	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
182	182	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
183	183	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
184	184	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
185	185	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
186	186	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
187	187	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
188	188	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
189	189	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
190	190	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
191	191	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
192	192	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
193	193	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
194	194	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
195	195	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
196	196	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
197	197	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
198	198	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
199	199	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
200	200	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
201	201	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
202	202	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
203	203	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
204	204	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
205	205	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
206	206	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
207	207	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
208	208	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
209	209	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
210	210	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
211	211	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
212	212	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
213	213	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
214	214	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
215	215	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
216	216	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
217	217	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
218	218	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
219	219	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
220	220	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
221	221	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
222	222	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
223	223	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
224	224	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
225	225	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
226	226	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
227	227	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
228	228	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
229	229	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
230	230	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
231	231	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
232	232	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
233	233	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
234	234	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
235	235	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
236	236	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
237	237	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
238	238	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
239	239	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
240	240	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
241	241	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
242	242	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
243	243	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
244	244	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
245	245	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
246	246	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
247	247	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
248	248	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
249	249	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
250	250	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
251	251	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
252	252	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
253	253	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
254	254	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
255	255	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
256	256	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
257	257	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
258	258	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
259	259	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
260	260	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
261	261	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
262	262	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
263	263	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
264	264	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
265	265	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
266	266	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
267	267	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
268	268	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
269	269	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
270	270	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
271	271	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
272	272	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
273	273	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
274	274	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
275	275	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
276	276	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
277	277	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
278	278	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
279	279	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
280	280	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
281	281	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
282	282	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
283	283	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
284	284	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
285	285	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
286	286	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
287	287	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
288	288	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
289	289	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
290	290	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
291	291	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
292	292	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
293	293	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
294	294	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
295	295	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
296	296	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
297	297	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
298	298	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
299	299	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
300	300	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
301	301	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
302	302	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
303	303	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
304	304	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
305	305	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
306	306	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
307	307	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
308	308	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
309	309	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
310	310	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
311	311	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
312	312	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
313	313	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
314	314	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
315	315	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
316	316	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
317	317	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
318	318	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
319	319	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
320	320	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
321	321	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
322	322	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
323	323	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
324	324	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
325	325	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
326	326	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
327	327	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
328	328	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
329	329	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
330	330	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
331	331	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
332	332	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
333	333	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
334	334	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
335	335	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
336	336	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
337	337	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
338	338	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
339	339	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
340	340	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
341	341	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
342	342	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
343	343	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
344	344	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
345	345	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
346	346	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
347	347	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
348	348	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
349	349	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
350	350	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
351	351	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
352	352	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
353	353	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
354	354	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
355	355	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
356	356	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
357	357	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
358	358	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
359	359	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
360	360	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
361	361	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
362	362	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
363	363	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
364	364	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
365	365	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
366	366	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
367	367	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
368	368	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
369	369	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
370	370	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
371	371	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
372	372	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
373	373	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
374	374	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
375	375	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
376	376	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
377	377	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
378	378	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
379	379	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
380	380	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
381	381	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
382	382	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
383	383	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
384	384	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
385	385	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
386	386	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
387	387	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
388	388	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
389	389	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
390	390	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
391	391	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
392	392	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
393	393	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
394	394	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
395	395	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
396	396	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
397	397	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
398	398	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
399	399	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
400	400	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
401	401	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
402	402	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
403	403	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
404	404	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
405	405	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
406	406	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
407	407	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
408	408	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
409	409	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
410	410	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
411	411	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
412	412	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
413	413	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
414	414	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
415	415	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
416	416	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
417	417	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
418	418	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
419	419	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
420	420	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
421	421	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
422	422	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
423	423	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
424	424	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
425	425	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
426	426	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
427	427	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
428	428	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
429	429	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
430	430	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
431	431	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
432	432	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
433	433	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
434	434	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
435	435	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
436	436	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
437	437	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
438	438	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
439	439	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
440	440	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
441	441	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
442	442	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
443	443	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
444	444	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
445	445	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
446	446	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
447	447	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
448	448	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
449	449	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
450	450	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
451	451	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
452	452	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
453	453	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
454	454	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
455	455	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
456	456	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
457	457	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
458	458	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
459	459	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
460	460	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
461	461	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
462	462	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
463	463	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
464	464	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
465	465	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
466	466	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
467	467	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
468	468	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
469	469	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
470	470	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
471	471	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
472	472	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
473	473	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
474	474	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
475	475	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
476	476	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
477	477	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
478	478	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
479	479	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
480	480	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
481	481	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
482	482	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
483	483	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
484	484	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
485	485	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
486	486	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
487	487	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
488	488	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
489	489	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
490	490	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
491	491	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
492	492	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
493	493	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
494	494	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
495	495	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
496	496	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
497	497	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
498	498	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
499	499	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
500	500	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
501	501	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
502	502	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
503	503	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
504	504	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
505	505	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
506	506	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
507	507	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
508	508	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
509	509	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
510	510	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
511	511	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
512	512	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
513	513	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
514	514	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
515	515	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
516	516	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
517	517	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
518	518	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
519	519	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
520	520	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
521	521	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
522	522	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
523	523	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
524	524	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
525	525	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
526	526	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
527	527	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
528	528	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
529	529	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
530	530	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
531	531	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
532	532	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
533	533	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
534	534	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
535	535	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
536	536	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
537	537	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
538	538	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
539	539	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
540	540	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
541	541	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
542	542	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
543	543	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
544	544	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
545	545	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
546	546	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
547	547	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
548	548	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
549	549	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
550	550	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
551	551	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
552	552	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
553	553	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
554	554	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
555	555	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
556	556	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
557	557	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
558	558	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
559	559	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
560	560	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
561	561	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
562	562	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
563	563	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
564	564	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
565	565	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
566	566	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
567	567	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
568	568	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
569	569	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
570	570	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
571	571	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
572	572	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
573	573	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
574	574	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
575	575	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
576	576	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
577	577	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
578	578	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
579	579	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
580	580	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
581	581	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
582	582	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
583	583	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
584	584	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
585	585	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
586	586	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
587	587	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
588	588	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
589	589	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
590	590	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
591	591	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
592	592	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
593	593	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
594	594	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
595	595	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
596	596	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
597	597	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
598	598	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
599	599	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
600	600	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
601	601	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
602	602	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
603	603	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
604	604	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
605	605	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
606	606	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
607	607	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
608	608	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
609	609	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
610	610	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
611	611	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
612	612	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
613	613	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
614	614	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
615	615	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
616	616	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
617	617	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
618	618	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
619	619	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
620	620	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
621	621	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
622	622	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
623	623	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
624	624	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
625	625	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
626	626	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
627	627	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
628	628	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
629	629	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
630	630	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
631	631	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
632	632	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
633	633	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
634	634	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
635	635	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
636	636	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
637	637	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
638	638	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
639	639	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
640	640	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
641	641	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
642	642	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
643	643	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
644	644	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
645	645	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
646	646	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
647	647	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
648	648	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
649	649	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
650	650	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
651	651	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
652	652	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
653	653	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
654	654	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
655	655	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
656	656	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
657	657	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
658	658	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
659	659	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
660	660	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
661	661	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
662	662	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
663	663	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
664	664	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
665	665	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
666	666	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
667	667	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
668	668	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
669	669	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
670	670	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
671	671	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
672	672	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
673	673	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
674	674	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
675	675	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
676	676	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
677	677	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
678	678	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
679	679	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
680	680	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
681	681	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
682	682	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
683	683	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
684	684	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
685	685	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
686	686	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
687	687	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
688	688	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
689	689	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
690	690	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
691	691	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
692	692	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
693	693	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
694	694	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
695	695	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
696	696	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
697	697	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
698	698	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
699	699	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
700	700	1	66000000000000	66000000000000	172800	16500000000000	1	95486111
701	701	1	85000000000000	85000000000000	86400	85000000000000	1	0
702	702	1	44000000000000	44000000000000	86400	44000000000000	1	0
703	703	1	17000000000000	17000000000000	86400	17000000000000	1	0
704	704	1	10000000000000	10000000000000	86400	10000000000000	1	0
705	705	1	10000000000000	10000000000000	86400	10000000000000	1	0
706	706	1	10000000000000	10000000000000	86400	10000000000000	1	0
707	707	1	9000000000000	9000000000000	86400	9000000000000	1	0
708	708	1	6000000000000	6000000000000	86400	6000000000000	1	0
709	709	1	10000000000000	10000000000000	86400	10000000000000	1	0
710	710	1	5000000000000	5000000000000	86400	5000000000000	1	0
711	711	1	3000000000000	3000000000000	86400	3000000000000	1	0
712	712	1	6000000000000	6000000000000	86400	6000000000000	1	0
713	713	1	42000000000000	42000000000000	86400	42000000000000	1	0
714	714	1	2000000000000	2000000000000	86400	2000000000000	1	0
715	715	1	2000000000000	2000000000000	86400	2000000000000	1	0
716	716	1	3000000000000	3000000000000	86400	3000000000000	1	0
717	717	1	2000000000000	2000000000000	86400	2000000000000	1	0
718	718	1	2000000000000	2000000000000	86400	2000000000000	1	0
719	719	1	2000000000000	2000000000000	86400	2000000000000	1	0
720	720	1	2000000000000	2000000000000	86400	2000000000000	1	0
721	721	1	2000000000000	2000000000000	86400	2000000000000	1	0
722	722	1	2000000000000	2000000000000	86400	2000000000000	1	0
723	723	1	3000000000000	3000000000000	86400	3000000000000	1	0
724	724	1	20000000000000	20000000000000	86400	20000000000000	1	0
725	725	1	15000000000000	15000000000000	86400	15000000000000	1	0
726	726	1	6000000000000	6000000000000	86400	6000000000000	1	0
727	727	1	5000000000000	5000000000000	86400	5000000000000	1	0
728	728	1	5000000000000	5000000000000	86400	5000000000000	1	0
729	729	1	5000000000000	5000000000000	86400	5000000000000	1	0
730	730	1	5000000000000	5000000000000	86400	5000000000000	1	0
731	731	1	2000000000000	2000000000000	86400	2000000000000	1	0
732	732	1	2000000000000	2000000000000	86400	2000000000000	1	0
733	733	1	2000000000000	2000000000000	86400	2000000000000	1	0
734	734	1	2000000000000	2000000000000	86400	2000000000000	1	0
735	735	1	3000000000000	3000000000000	86400	3000000000000	1	0
736	736	1	2000000000000	2000000000000	86400	2000000000000	1	0
737	737	1	3000000000000	3000000000000	86400	3000000000000	1	0
738	738	1	20000000000000	20000000000000	86400	20000000000000	1	0
739	739	1	10000000000000	10000000000000	86400	10000000000000	1	0
740	740	1	5000000000000	5000000000000	86400	5000000000000	1	0
741	741	1	5000000000000	5000000000000	86400	5000000000000	1	0
742	742	1	5000000000000	5000000000000	86400	5000000000000	1	0
743	743	1	2000000000000	2000000000000	86400	2000000000000	1	0
744	744	1	2000000000000	2000000000000	86400	2000000000000	1	0
745	745	1	2000000000000	2000000000000	86400	2000000000000	1	0
746	746	1	2000000000000	2000000000000	86400	2000000000000	1	0
747	747	1	2000000000000	2000000000000	86400	2000000000000	1	0
748	748	1	2000000000000	2000000000000	86400	2000000000000	1	0
749	749	1	1000000000000	1000000000000	86400	1000000000000	1	0
750	750	1	1000000000000	1000000000000	86400	1000000000000	1	0
751	751	1	1000000000000	1000000000000	86400	1000000000000	1	0
752	752	1	1000000000000	1000000000000	86400	1000000000000	1	0
753	753	1	1000000000000	1000000000000	86400	1000000000000	1	0
754	754	1	1000000000000	1000000000000	86400	1000000000000	1	0
755	755	1	1000000000000	1000000000000	86400	1000000000000	1	0
756	756	1	1000000000000	1000000000000	86400	1000000000000	1	0
757	757	1	1000000000000	1000000000000	86400	1000000000000	1	0
758	758	1	1000000000000	1000000000000	86400	1000000000000	1	0
759	759	1	1000000000000	1000000000000	86400	1000000000000	1	0
760	760	1	1000000000000	1000000000000	86400	1000000000000	1	0
761	761	1	1000000000000	1000000000000	86400	1000000000000	1	0
762	762	1	1000000000000	1000000000000	86400	1000000000000	1	0
763	763	1	1000000000000	1000000000000	86400	1000000000000	1	0
764	764	1	1000000000000	1000000000000	86400	1000000000000	1	0
765	765	1	1000000000000	1000000000000	86400	1000000000000	1	0
766	766	1	1000000000000	1000000000000	86400	1000000000000	1	0
767	767	1	1000000000000	1000000000000	86400	1000000000000	1	0
768	768	1	1000000000000	1000000000000	86400	1000000000000	1	0
769	769	1	1000000000000	1000000000000	86400	1000000000000	1	0
770	770	1	1000000000000	1000000000000	86400	1000000000000	1	0
771	771	1	1000000000000	1000000000000	86400	1000000000000	1	0
772	772	1	1000000000000	1000000000000	86400	1000000000000	1	0
773	773	1	1000000000000	1000000000000	86400	1000000000000	1	0
774	774	1	1000000000000	1000000000000	86400	1000000000000	1	0
775	775	1	1388891712964990	1388891712964990	36480	1172841890948210	1	32150271133
776	776	1	15277795509265100	15277795509265100	43200	0	1	70730534765
777	777	1	1388891712964990	1388891712964990	36480	1172841890948210	1	32150271133
778	778	1	15277795509265100	15277795509265100	43200	0	1	70730534765
779	779	1	27778216210792	27778216210792	36480	23457160355780	1	643014264
780	780	1	305560111648051	305560111648051	43200	0	1	1414630147
781	781	1	222221235183807	222221235183807	36480	187653487488548	1	5144010074
782	782	1	2444431453699720	2444431453699720	43200	0	1	11316812286
783	783	1	29861135198413	29861135198413	36480	25216069723104	1	691229981
784	784	1	328472200515873	328472200515873	43200	0	1	1520704632
785	785	1	222221235183807	222221235183807	36480	187653487488548	1	5144010074
786	786	1	2444431453699720	2444431453699720	43200	0	1	11316812286
787	787	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
788	788	1	611120223296101	611120223296101	43200	0	1	2829260293
789	789	1	238889081587303	238889081587303	36480	201728557784834	1	5529839852
790	790	1	2627777604126980	2627777604126980	43200	0	1	12165637056
791	791	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
792	792	1	611120223296101	611120223296101	43200	0	1	2829260293
793	793	1	1361806307764150	1361806307764150	36480	1149969771000840	1	31523294161
794	794	1	14979856312075500	14979856312075500	43200	0	1	69351186630
795	795	1	55556593519694	55556593519694	36480	46914456749964	1	1286032257
796	796	1	611121995373765	611121995373765	43200	0	1	2829268497
797	797	1	277777828703501	277777828703501	36480	234567944238512	1	6430042331
798	798	1	3055553449073490	3055553449073490	43200	0	1	14146080783
799	799	1	13887863656181	13887863656181	36480	11727529309664	1	321478325
800	800	1	152766366894607	152766366894607	43200	0	1	707251699
801	801	1	13890433103666	13890433103666	36480	11729699065318	1	321537803
802	802	1	152794630792275	152794630792275	43200	0	1	707382550
803	803	1	16665388062455	16665388062455	36480	14072994363851	1	385772872
804	804	1	183319108699404	183319108699404	43200	0	1	848699577
805	805	1	111110295403134	111110295403134	36480	93826471673758	1	2571997579
806	806	1	1222212182776490	1222212182776490	43200	0	1	5658389735
807	807	1	27778296759847	27778296759847	36480	23457228374982	1	643016129
808	808	1	305560997686882	305560997686882	43200	0	1	1414634249
809	809	1	59722270396826	59722270396826	36480	50432139446208	1	1382459963
810	810	1	656944401031746	656944401031746	43200	0	1	3041409264
811	811	1	107500086714286	107500086714286	36480	90777851003175	1	2488427933
812	812	1	1182499921857140	1182499921857140	43200	0	1	5474536675
813	813	1	500001633334793	500001633334793	36480	422223601482714	1	11574111883
814	814	1	5500013166670880	5500013166670880	43200	0	1	25463023920
815	815	1	2027778894047020	2027778894047020	36480	1712346621639700	1	46939326251
816	816	1	22305548367855400	22305548367855400	43200	0	1	103266427629
817	817	1	55554024072209	55554024072209	36480	46912286994310	1	1285972779
818	818	1	611093731476097	611093731476097	43200	0	1	2829137646
819	819	1	55554024072209	55554024072209	36480	46912286994310	1	1285972779
820	820	1	611093731476097	611093731476097	43200	0	1	2829137646
821	821	1	27778216210792	27778216210792	36480	23457160355780	1	643014264
822	822	1	305560111648051	305560111648051	43200	0	1	1414630147
823	823	1	1725001865185760	1725001865185760	36480	1456668241712420	1	39930598731
824	824	1	18975003957038700	18975003957038700	43200	0	1	87847240542
825	825	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
826	826	1	611120223296101	611120223296101	43200	0	1	2829260293
827	827	1	83332079192342	83332079192342	36480	70369311317978	1	1928983315
828	828	1	916652071128441	916652071128441	43200	0	1	4243759589
829	829	1	333333455649436	333333455649436	36480	281481584770635	1	7716052214
830	830	1	3666664812145190	3666664812145190	43200	0	1	16975300056
831	831	1	55556432421584	55556432421584	36480	46914320711560	1	1286028528
832	832	1	611120223296101	611120223296101	43200	0	1	2829260293
833	833	1	400013579074275	400013579074275	36480	400013579074275	1	0
834	834	1	479991629337776	479991629337776	36480	479991629337776	1	0
835	835	1	3199985304837430	3199985304837430	36480	3199985304837430	1	0
836	836	1	1200009905283630	1200009905283630	36480	1200009905283630	1	0
837	837	1	1599992652418710	1599992652418710	36480	1599992652418710	1	0
838	838	1	599989536672220	599989536672220	36480	599989536672220	1	0
839	839	1	2399988978628070	2399988978628070	36480	2399988978628070	1	0
840	840	1	1200009905283630	1200009905283630	36480	1200009905283630	1	0
841	841	1	83287416647298	83287416647298	86400	4627082404291	1	321324895
842	842	1	83287416647298	83287416647298	86400	4627082404291	1	321324895
843	843	1	155277777741667	155277777741667	86400	8626550109105	1	599065472
844	844	1	155277777741667	155277777741667	86400	8626550109105	1	599065472
845	845	1	573333333200000	573333333200000	86400	31851877325926	1	2211934052
846	846	1	573333333200000	573333333200000	86400	31851877325926	1	2211934052
847	847	1	185138888845833	185138888845833	86400	10285502053164	1	714270371
848	848	1	185138888845833	185138888845833	86400	10285502053164	1	714270371
849	849	1	1149647999732640	1149647999732640	86400	63869384413947	1	4435370161
850	850	1	1149647999732640	1149647999732640	86400	63869384413947	1	4435370161
851	851	1	2227041666148750	2227041666148750	86400	123724635987893	1	8591981332
852	852	1	2227041666148750	2227041666148750	86400	123724635987893	1	8591981332
853	853	1	245567177026225	245567177026225	86400	13642631859998	1	947404188
854	854	1	245567177026225	245567177026225	86400	13642631859998	1	947404188
855	855	1	129895833303125	129895833303125	86400	7216440956655	1	501141309
856	856	1	129895833303125	129895833303125	86400	7216440956655	1	501141309
857	857	1	327530402701608	327530402701608	86400	18196148040329	1	1263620321
858	858	1	327530402701608	327530402701608	86400	18196148040329	1	1263620321
859	859	1	144537333299720	144537333299720	86400	8029858273866	1	557628574
860	860	1	144537333299720	144537333299720	86400	8029858273866	1	557628574
861	861	1	452395833228125	452395833228125	86400	25133121952488	1	1745354213
862	862	1	452395833228125	452395833228125	86400	25133121952488	1	1745354213
863	863	1	95775333311060	95775333311060	86400	5320856107296	1	369503583
864	864	1	95775333311060	95775333311060	86400	5320856107296	1	369503583
865	865	1	397152777685417	397152777685417	86400	22064060855980	1	1532225150
866	866	1	397152777685417	397152777685417	86400	22064060855980	1	1532225150
867	867	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
868	868	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
869	869	1	258666499939845	258666499939845	86400	14370372604058	1	997941697
870	870	1	258666499939845	258666499939845	86400	14370372604058	1	997941697
871	871	1	109739583307813	109739583307813	86400	6096648394416	1	423378002
872	872	1	109739583307813	109739583307813	86400	6096648394416	1	423378002
873	873	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
874	874	1	2418750000000000	2418750000000000	86400	2418750000000000	1	0
875	875	1	212013888839583	212013888839583	86400	11778558802816	1	817954780
876	876	1	212013888839583	212013888839583	86400	11778558802816	1	817954780
877	877	1	203053166619445	203053166619445	86400	11280740503443	1	783384094
878	878	1	203053166619445	203053166619445	86400	11280740503443	1	783384094
879	879	1	134374999968750	134374999968750	86400	7465283748264	1	518422043
880	880	1	134374999968750	134374999968750	86400	7465283748264	1	518422043
881	881	1	582291666531250	582291666531250	86400	32349562909144	1	2246495521
882	882	1	582291666531250	582291666531250	86400	32349562909144	1	2246495521
883	883	1	89583333312500	89583333312500	86400	4976855832176	1	345614696
884	884	1	89583333312500	89583333312500	86400	4976855832176	1	345614696
885	885	1	63454861096354	63454861096354	86400	3525272881125	1	244810409
886	886	1	63454861096354	63454861096354	86400	3525272881125	1	244810409
887	887	1	267369520771154	267369520771154	86400	14853874148154	1	1031518164
888	888	1	267369520771154	267369520771154	86400	14853874148154	1	1031518164
889	889	1	224442381892249	224442381892249	86400	12469031191453	1	865904210
890	890	1	224442381892249	224442381892249	86400	12469031191453	1	865904210
891	891	1	492708333218750	492708333218750	86400	27372707076968	1	1900880826
892	892	1	492708333218750	492708333218750	86400	27372707076968	1	1900880826
893	893	1	306822916595313	306822916595313	86400	17045731225203	1	1183730332
894	894	1	306822916595313	306822916595313	86400	17045731225203	1	1183730332
895	895	1	143333333300000	143333333300000	86400	7962969331481	1	552983513
896	896	1	143333333300000	143333333300000	86400	7962969331481	1	552983513
897	897	1	64994499984885	64994499984885	86400	3610808443360	1	250750374
898	898	1	64994499984885	64994499984885	86400	3610808443360	1	250750374
899	899	1	38742999990990	38742999990990	86400	2152390610299	1	149471444
900	900	1	38742999990990	38742999990990	86400	2152390610299	1	149471444
901	901	1	116458333306250	116458333306250	86400	6469912581829	1	449299104
902	902	1	116458333306250	116458333306250	86400	6469912581829	1	449299104
903	903	1	114218749973438	114218749973438	86400	6345491186024	1	440658737
904	904	1	114218749973438	114218749973438	86400	6345491186024	1	440658737
905	905	1	418802083235938	418802083235938	86400	23266801015423	1	1615748702
906	906	1	418802083235938	418802083235938	86400	23266801015423	1	1615748702
907	907	1	502777775000000	1000000000	691200	1000000000	1	0
908	908	1	502777775000000	1000000000	691200	1000000000	1	0
909	909	1	502777775000000	1000000000	691200	1000000000	1	0
910	910	1	502777775000000	1000000000	691200	1000000000	1	0
911	911	1	502777775000000	1000000000	691200	1000000000	1	0
912	912	1	502777775000000	1000000000	691200	1000000000	1	0
913	913	1	502777775000000	1000000000	691200	1000000000	1	0
914	914	1	502777775000000	1000000000	691200	1000000000	1	0
915	915	1	502777775000000	1000000000	691200	1000000000	1	0
916	916	1	502777775000000	1000000000	691200	1000000000	1	0
917	917	1	502777775000000	1000000000	691200	1000000000	1	0
918	918	1	502777775000000	1000000000	691200	1000000000	1	0
919	919	1	502777775000000	1000000000	691200	1000000000	1	0
920	920	1	502777775000000	1000000000	691200	1000000000	1	0
921	921	1	502777775000000	1000000000	691200	1000000000	1	0
922	922	1	502777775000000	1000000000	691200	1000000000	1	0
923	923	1	502777775000000	1000000000	691200	1000000000	1	0
924	924	1	502777775000000	1000000000	691200	1000000000	1	0
925	925	1	502777775000000	1000000000	691200	1000000000	1	0
926	926	1	502777775000000	1000000000	691200	1000000000	1	0
927	927	1	502777775000000	1000000000	691200	1000000000	1	0
928	928	1	502777775000000	1000000000	691200	1000000000	1	0
929	929	1	502777775000000	1000000000	691200	1000000000	1	0
930	930	1	502777775000000	1000000000	691200	1000000000	1	0
931	931	1	502777775000000	1000000000	691200	1000000000	1	0
932	932	1	502777775000000	1000000000	691200	1000000000	1	0
933	933	1	502777775000000	1000000000	691200	1000000000	1	0
934	934	1	502777775000000	1000000000	691200	1000000000	1	0
935	935	1	502777775000000	1000000000	691200	1000000000	1	0
936	936	1	502777775000000	1000000000	691200	1000000000	1	0
937	937	1	502777775000000	1000000000	691200	1000000000	1	0
938	938	1	502777775000000	1000000000	691200	1000000000	1	0
939	939	1	502777775000000	1000000000	691200	1000000000	1	0
940	940	1	502777775000000	1000000000	691200	1000000000	1	0
941	941	1	502777775000000	1000000000	691200	1000000000	1	0
942	942	1	502777775000000	1000000000	691200	1000000000	1	0
943	943	1	502777775000000	1000000000	691200	1000000000	1	0
944	944	1	502777775000000	1000000000	691200	1000000000	1	0
945	945	1	502777775000000	1000000000	691200	1000000000	1	0
946	946	1	502777775000000	1000000000	691200	1000000000	1	0
947	947	1	502777775000000	1000000000	691200	1000000000	1	0
948	948	1	502777775000000	1000000000	691200	1000000000	1	0
949	949	1	502777775000000	1000000000	691200	1000000000	1	0
950	950	1	502777775000000	1000000000	691200	1000000000	1	0
951	951	1	502777775000000	1000000000	691200	1000000000	1	0
952	952	1	502777775000000	1000000000	691200	1000000000	1	0
953	953	1	502777775000000	1000000000	691200	1000000000	1	0
954	954	1	502777775000000	1000000000	691200	1000000000	1	0
955	955	1	502777775000000	1000000000	691200	1000000000	1	0
956	956	1	502777775000000	1000000000	691200	1000000000	1	0
957	957	1	502777775000000	1000000000	691200	1000000000	1	0
958	958	1	502777775000000	1000000000	691200	1000000000	1	0
959	959	1	502777775000000	1000000000	691200	1000000000	1	0
960	960	1	502777775000000	1000000000	691200	1000000000	1	0
961	961	1	502777775000000	1000000000	691200	1000000000	1	0
962	962	1	502777775000000	1000000000	691200	1000000000	1	0
963	963	1	502777775000000	1000000000	691200	1000000000	1	0
964	964	1	502777775000000	1000000000	691200	1000000000	1	0
965	965	1	502777775000000	1000000000	691200	1000000000	1	0
966	966	1	502777775000000	1000000000	691200	1000000000	1	0
967	967	1	502777775000000	1000000000	691200	1000000000	1	0
968	968	1	502777775000000	1000000000	691200	1000000000	1	0
969	969	1	502777775000000	1000000000	691200	1000000000	1	0
970	970	1	502777775000000	1000000000	691200	1000000000	1	0
971	971	1	502777775000000	1000000000	691200	1000000000	1	0
972	972	1	502777775000000	1000000000	691200	1000000000	1	0
973	973	1	502777775000000	1000000000	691200	1000000000	1	0
974	974	1	502777775000000	1000000000	691200	1000000000	1	0
975	975	1	502777775000000	1000000000	691200	1000000000	1	0
976	976	1	502777775000000	1000000000	691200	1000000000	1	0
977	977	1	502777775000000	1000000000	691200	1000000000	1	0
978	978	1	502777775000000	1000000000	691200	1000000000	1	0
979	979	1	502777775000000	1000000000	691200	1000000000	1	0
980	980	1	502777775000000	1000000000	691200	1000000000	1	0
981	981	1	502777775000000	1000000000	691200	1000000000	1	0
982	982	1	502777775000000	1000000000	691200	1000000000	1	0
983	983	1	502777775000000	1000000000	691200	1000000000	1	0
984	984	1	502777775000000	1000000000	691200	1000000000	1	0
985	985	1	502777775000000	1000000000	691200	1000000000	1	0
986	986	1	502777775000000	1000000000	691200	1000000000	1	0
987	987	1	502777775000000	1000000000	691200	1000000000	1	0
988	988	1	502777775000000	1000000000	691200	1000000000	1	0
989	989	1	502777775000000	1000000000	691200	1000000000	1	0
990	990	1	502777775000000	1000000000	691200	1000000000	1	0
991	991	1	502777775000000	1000000000	691200	1000000000	1	0
992	992	1	502777775000000	1000000000	691200	1000000000	1	0
993	993	1	502777775000000	1000000000	691200	1000000000	1	0
994	994	1	502777775000000	1000000000	691200	1000000000	1	0
995	995	1	502777775000000	1000000000	691200	1000000000	1	0
996	996	1	502777775000000	1000000000	691200	1000000000	1	0
997	997	1	502777775000000	1000000000	691200	1000000000	1	0
998	998	1	502777775000000	1000000000	691200	1000000000	1	0
999	999	1	502777775000000	1000000000	691200	1000000000	1	0
1000	1000	1	502777775000000	1000000000	691200	1000000000	1	0
1001	1001	1	502777775000000	1000000000	691200	1000000000	1	0
1002	1002	1	502777775000000	1000000000	691200	1000000000	1	0
1003	1003	1	502777775000000	1000000000	691200	1000000000	1	0
1004	1004	1	502777775000000	1000000000	691200	1000000000	1	0
1005	1005	1	502777775000000	1000000000	691200	1000000000	1	0
1006	1006	1	502777775000000	1000000000	691200	1000000000	1	0
1007	1007	1	502777775000000	1000000000	691200	1000000000	1	0
1008	1008	1	502777775000000	1000000000	691200	1000000000	1	0
1009	1009	1	502777775000000	1000000000	691200	1000000000	1	0
1010	1010	1	502777775000000	1000000000	691200	1000000000	1	0
1011	1011	1	502777775000000	1000000000	691200	1000000000	1	0
1012	1012	1	502777775000000	1000000000	691200	1000000000	1	0
1013	1013	1	502777775000000	1000000000	691200	1000000000	1	0
1014	1014	1	502777775000000	1000000000	691200	1000000000	1	0
1015	1015	1	502777775000000	1000000000	691200	1000000000	1	0
1016	1016	1	502777775000000	1000000000	691200	1000000000	1	0
1017	1017	1	502777775000000	1000000000	691200	1000000000	1	0
1018	1018	1	502777775000000	1000000000	691200	1000000000	1	0
1019	1019	1	502777775000000	1000000000	691200	1000000000	1	0
1020	1020	1	502777775000000	1000000000	691200	1000000000	1	0
1021	1021	1	502777775000000	1000000000	691200	1000000000	1	0
1022	1022	1	502777775000000	1000000000	691200	1000000000	1	0
1023	1023	1	502777775000000	1000000000	691200	1000000000	1	0
1024	1024	1	502777775000000	1000000000	691200	1000000000	1	0
1025	1025	1	502777775000000	1000000000	691200	1000000000	1	0
1026	1026	1	502777775000000	1000000000	691200	1000000000	1	0
1027	1027	1	900973465000000	1000000000	691200	1000000000	1	0
1028	1028	1	900973465000000	1000000000	691200	1000000000	1	0
1029	1029	1	900973465000000	1000000000	691200	1000000000	1	0
1030	1030	1	900973465000000	1000000000	691200	1000000000	1	0
1031	1031	1	900973465000000	1000000000	691200	1000000000	1	0
1032	1032	1	900973465000000	1000000000	691200	1000000000	1	0
1033	1033	1	900973465000000	1000000000	691200	1000000000	1	0
1034	1034	1	900973465000000	1000000000	691200	1000000000	1	0
1035	1035	1	900973465000000	1000000000	691200	1000000000	1	0
1036	1036	1	900973465000000	1000000000	691200	1000000000	1	0
1037	1037	1	900973465000000	1000000000	691200	1000000000	1	0
1038	1038	1	900973465000000	1000000000	691200	1000000000	1	0
1039	1039	1	900973465000000	1000000000	691200	1000000000	1	0
1040	1040	1	900973465000000	1000000000	691200	1000000000	1	0
1041	1041	1	900973465000000	1000000000	691200	1000000000	1	0
1042	1042	1	900973465000000	1000000000	691200	1000000000	1	0
1043	1043	1	900973465000000	1000000000	691200	1000000000	1	0
1044	1044	1	900973465000000	1000000000	691200	1000000000	1	0
1045	1045	1	900973465000000	1000000000	691200	1000000000	1	0
1046	1046	1	900973465000000	1000000000	691200	1000000000	1	0
1047	1047	1	900973465000000	1000000000	691200	1000000000	1	0
1048	1048	1	900973465000000	1000000000	691200	1000000000	1	0
1049	1049	1	900973465000000	1000000000	691200	1000000000	1	0
1050	1050	1	900973465000000	1000000000	691200	1000000000	1	0
1051	1051	1	900973465000000	1000000000	691200	1000000000	1	0
1052	1052	1	900973465000000	1000000000	691200	1000000000	1	0
1053	1053	1	900973465000000	1000000000	691200	1000000000	1	0
1054	1054	1	900973465000000	1000000000	691200	1000000000	1	0
1055	1055	1	900973465000000	1000000000	691200	1000000000	1	0
1056	1056	1	900973465000000	1000000000	691200	1000000000	1	0
1057	1057	1	900973465000000	1000000000	691200	1000000000	1	0
1058	1058	1	900973465000000	1000000000	691200	1000000000	1	0
1059	1059	1	900973465000000	1000000000	691200	1000000000	1	0
1060	1060	1	900973465000000	1000000000	691200	1000000000	1	0
1061	1061	1	900973465000000	1000000000	691200	1000000000	1	0
1062	1062	1	900973465000000	1000000000	691200	1000000000	1	0
1063	1063	1	900973465000000	1000000000	691200	1000000000	1	0
1064	1064	1	900973465000000	1000000000	691200	1000000000	1	0
1065	1065	1	900973465000000	1000000000	691200	1000000000	1	0
1066	1066	1	900973465000000	1000000000	691200	1000000000	1	0
1067	1067	1	900973465000000	1000000000	691200	1000000000	1	0
1068	1068	1	900973465000000	1000000000	691200	1000000000	1	0
1069	1069	1	900973465000000	1000000000	691200	1000000000	1	0
1070	1070	1	900973465000000	1000000000	691200	1000000000	1	0
1071	1071	1	900973465000000	1000000000	691200	1000000000	1	0
1072	1072	1	900973465000000	1000000000	691200	1000000000	1	0
1073	1073	1	900973465000000	1000000000	691200	1000000000	1	0
1074	1074	1	900973465000000	1000000000	691200	1000000000	1	0
1075	1075	1	900973465000000	1000000000	691200	1000000000	1	0
1076	1076	1	900973465000000	1000000000	691200	1000000000	1	0
1077	1077	1	900973465000000	1000000000	691200	1000000000	1	0
1078	1078	1	900973465000000	1000000000	691200	1000000000	1	0
1079	1079	1	900973465000000	1000000000	691200	1000000000	1	0
1080	1080	1	900973465000000	1000000000	691200	1000000000	1	0
1081	1081	1	900973465000000	1000000000	691200	1000000000	1	0
1082	1082	1	900973465000000	1000000000	691200	1000000000	1	0
1083	1083	1	900973465000000	1000000000	691200	1000000000	1	0
1084	1084	1	900973465000000	1000000000	691200	1000000000	1	0
1085	1085	1	900973465000000	1000000000	691200	1000000000	1	0
1086	1086	1	900973465000000	1000000000	691200	1000000000	1	0
1087	1087	1	900973465000000	1000000000	691200	1000000000	1	0
1088	1088	1	900973465000000	1000000000	691200	1000000000	1	0
1089	1089	1	900973465000000	1000000000	691200	1000000000	1	0
1090	1090	1	900973465000000	1000000000	691200	1000000000	1	0
1091	1091	1	900973465000000	1000000000	691200	1000000000	1	0
1092	1092	1	900973465000000	1000000000	691200	1000000000	1	0
1093	1093	1	900973465000000	1000000000	691200	1000000000	1	0
1094	1094	1	900973465000000	1000000000	691200	1000000000	1	0
1095	1095	1	900973465000000	1000000000	691200	1000000000	1	0
1096	1096	1	900973465000000	1000000000	691200	1000000000	1	0
1097	1097	1	900973465000000	1000000000	691200	1000000000	1	0
1098	1098	1	900973465000000	1000000000	691200	1000000000	1	0
1099	1099	1	900973465000000	1000000000	691200	1000000000	1	0
1100	1100	1	900973465000000	1000000000	691200	1000000000	1	0
1101	1101	1	900973465000000	1000000000	691200	1000000000	1	0
1102	1102	1	900973465000000	1000000000	691200	1000000000	1	0
1103	1103	1	900973465000000	1000000000	691200	1000000000	1	0
1104	1104	1	900973465000000	1000000000	691200	1000000000	1	0
1105	1105	1	900973465000000	1000000000	691200	1000000000	1	0
1106	1106	1	900973465000000	1000000000	691200	1000000000	1	0
1107	1107	1	900973465000000	1000000000	691200	1000000000	1	0
1108	1108	1	900973465000000	1000000000	691200	1000000000	1	0
1109	1109	1	900973465000000	1000000000	691200	1000000000	1	0
1110	1110	1	900973465000000	1000000000	691200	1000000000	1	0
1111	1111	1	900973465000000	1000000000	691200	1000000000	1	0
1112	1112	1	900973465000000	1000000000	691200	1000000000	1	0
1113	1113	1	900973465000000	1000000000	691200	1000000000	1	0
1114	1114	1	900973465000000	1000000000	691200	1000000000	1	0
1115	1115	1	900973465000000	1000000000	691200	1000000000	1	0
1116	1116	1	900973465000000	1000000000	691200	1000000000	1	0
1117	1117	1	900973465000000	1000000000	691200	1000000000	1	0
1118	1118	1	900973465000000	1000000000	691200	1000000000	1	0
1119	1119	1	900973465000000	1000000000	691200	1000000000	1	0
1120	1120	1	900973465000000	1000000000	691200	1000000000	1	0
1121	1121	1	900973465000000	1000000000	691200	1000000000	1	0
1122	1122	1	900973465000000	1000000000	691200	1000000000	1	0
1123	1123	1	900973465000000	1000000000	691200	1000000000	1	0
1124	1124	1	900973465000000	1000000000	691200	1000000000	1	0
1125	1125	1	900973465000000	1000000000	691200	1000000000	1	0
1126	1126	1	900973465000000	1000000000	691200	1000000000	1	0
1127	1127	1	900973465000000	1000000000	691200	1000000000	1	0
1128	1128	1	900973465000000	1000000000	691200	1000000000	1	0
1129	1129	1	900973465000000	1000000000	691200	1000000000	1	0
1130	1130	1	900973465000000	1000000000	691200	1000000000	1	0
1131	1131	1	900973465000000	1000000000	691200	1000000000	1	0
1132	1132	1	900973465000000	1000000000	691200	1000000000	1	0
1133	1133	1	900973465000000	1000000000	691200	1000000000	1	0
1134	1134	1	900973465000000	1000000000	691200	1000000000	1	0
1135	1135	1	900973465000000	1000000000	691200	1000000000	1	0
1136	1136	1	900973465000000	1000000000	691200	1000000000	1	0
1137	1137	1	900973465000000	1000000000	691200	1000000000	1	0
1138	1138	1	900973465000000	1000000000	691200	1000000000	1	0
1139	1139	1	900973465000000	1000000000	691200	1000000000	1	0
1140	1140	1	900973465000000	1000000000	691200	1000000000	1	0
1141	1141	1	900973465000000	1000000000	691200	1000000000	1	0
1142	1142	1	900973465000000	1000000000	691200	1000000000	1	0
1143	1143	1	900973465000000	1000000000	691200	1000000000	1	0
1144	1144	1	900973465000000	1000000000	691200	1000000000	1	0
1145	1145	1	900973465000000	1000000000	691200	1000000000	1	0
1146	1146	1	900973465000000	1000000000	691200	1000000000	1	0
1147	1147	1	607904750000000	1000000000	691200	1000000000	1	0
1148	1148	1	607904750000000	1000000000	691200	1000000000	1	0
1149	1149	1	607904750000000	1000000000	691200	1000000000	1	0
1150	1150	1	607904750000000	1000000000	691200	1000000000	1	0
1151	1151	1	607904750000000	1000000000	691200	1000000000	1	0
1152	1152	1	607904750000000	1000000000	691200	1000000000	1	0
1153	1153	1	607904750000000	1000000000	691200	1000000000	1	0
1154	1154	1	607904750000000	1000000000	691200	1000000000	1	0
1155	1155	1	607904750000000	1000000000	691200	1000000000	1	0
1156	1156	1	607904750000000	1000000000	691200	1000000000	1	0
1157	1157	1	607904750000000	1000000000	691200	1000000000	1	0
1158	1158	1	607904750000000	1000000000	691200	1000000000	1	0
1159	1159	1	607904750000000	1000000000	691200	1000000000	1	0
1160	1160	1	607904750000000	1000000000	691200	1000000000	1	0
1161	1161	1	607904750000000	1000000000	691200	1000000000	1	0
1162	1162	1	607904750000000	1000000000	691200	1000000000	1	0
1163	1163	1	607904750000000	1000000000	691200	1000000000	1	0
1164	1164	1	607904750000000	1000000000	691200	1000000000	1	0
1165	1165	1	607904750000000	1000000000	691200	1000000000	1	0
1166	1166	1	607904750000000	1000000000	691200	1000000000	1	0
1167	1167	1	607904750000000	1000000000	691200	1000000000	1	0
1168	1168	1	607904750000000	1000000000	691200	1000000000	1	0
1169	1169	1	607904750000000	1000000000	691200	1000000000	1	0
1170	1170	1	607904750000000	1000000000	691200	1000000000	1	0
1171	1171	1	607904750000000	1000000000	691200	1000000000	1	0
1172	1172	1	607904750000000	1000000000	691200	1000000000	1	0
1173	1173	1	607904750000000	1000000000	691200	1000000000	1	0
1174	1174	1	607904750000000	1000000000	691200	1000000000	1	0
1175	1175	1	607904750000000	1000000000	691200	1000000000	1	0
1176	1176	1	607904750000000	1000000000	691200	1000000000	1	0
1177	1177	1	607904750000000	1000000000	691200	1000000000	1	0
1178	1178	1	607904750000000	1000000000	691200	1000000000	1	0
1179	1179	1	607904750000000	1000000000	691200	1000000000	1	0
1180	1180	1	607904750000000	1000000000	691200	1000000000	1	0
1181	1181	1	607904750000000	1000000000	691200	1000000000	1	0
1182	1182	1	607904750000000	1000000000	691200	1000000000	1	0
1183	1183	1	607904750000000	1000000000	691200	1000000000	1	0
1184	1184	1	607904750000000	1000000000	691200	1000000000	1	0
1185	1185	1	607904750000000	1000000000	691200	1000000000	1	0
1186	1186	1	607904750000000	1000000000	691200	1000000000	1	0
1187	1187	1	607904750000000	1000000000	691200	1000000000	1	0
1188	1188	1	607904750000000	1000000000	691200	1000000000	1	0
1189	1189	1	607904750000000	1000000000	691200	1000000000	1	0
1190	1190	1	607904750000000	1000000000	691200	1000000000	1	0
1191	1191	1	607904750000000	1000000000	691200	1000000000	1	0
1192	1192	1	607904750000000	1000000000	691200	1000000000	1	0
1193	1193	1	607904750000000	1000000000	691200	1000000000	1	0
1194	1194	1	607904750000000	1000000000	691200	1000000000	1	0
1195	1195	1	607904750000000	1000000000	691200	1000000000	1	0
1196	1196	1	607904750000000	1000000000	691200	1000000000	1	0
1197	1197	1	607904750000000	1000000000	691200	1000000000	1	0
1198	1198	1	607904750000000	1000000000	691200	1000000000	1	0
1199	1199	1	607904750000000	1000000000	691200	1000000000	1	0
1200	1200	1	607904750000000	1000000000	691200	1000000000	1	0
1201	1201	1	607904750000000	1000000000	691200	1000000000	1	0
1202	1202	1	607904750000000	1000000000	691200	1000000000	1	0
1203	1203	1	607904750000000	1000000000	691200	1000000000	1	0
1204	1204	1	607904750000000	1000000000	691200	1000000000	1	0
1205	1205	1	607904750000000	1000000000	691200	1000000000	1	0
1206	1206	1	607904750000000	1000000000	691200	1000000000	1	0
1207	1207	1	607904750000000	1000000000	691200	1000000000	1	0
1208	1208	1	607904750000000	1000000000	691200	1000000000	1	0
1209	1209	1	607904750000000	1000000000	691200	1000000000	1	0
1210	1210	1	607904750000000	1000000000	691200	1000000000	1	0
1211	1211	1	607904750000000	1000000000	691200	1000000000	1	0
1212	1212	1	607904750000000	1000000000	691200	1000000000	1	0
1213	1213	1	607904750000000	1000000000	691200	1000000000	1	0
1214	1214	1	607904750000000	1000000000	691200	1000000000	1	0
1215	1215	1	607904750000000	1000000000	691200	1000000000	1	0
1216	1216	1	607904750000000	1000000000	691200	1000000000	1	0
1217	1217	1	607904750000000	1000000000	691200	1000000000	1	0
1218	1218	1	607904750000000	1000000000	691200	1000000000	1	0
1219	1219	1	607904750000000	1000000000	691200	1000000000	1	0
1220	1220	1	607904750000000	1000000000	691200	1000000000	1	0
1221	1221	1	607904750000000	1000000000	691200	1000000000	1	0
1222	1222	1	607904750000000	1000000000	691200	1000000000	1	0
1223	1223	1	607904750000000	1000000000	691200	1000000000	1	0
1224	1224	1	607904750000000	1000000000	691200	1000000000	1	0
1225	1225	1	607904750000000	1000000000	691200	1000000000	1	0
1226	1226	1	607904750000000	1000000000	691200	1000000000	1	0
1227	1227	1	607904750000000	1000000000	691200	1000000000	1	0
1228	1228	1	607904750000000	1000000000	691200	1000000000	1	0
1229	1229	1	607904750000000	1000000000	691200	1000000000	1	0
1230	1230	1	607904750000000	1000000000	691200	1000000000	1	0
1231	1231	1	607904750000000	1000000000	691200	1000000000	1	0
1232	1232	1	607904750000000	1000000000	691200	1000000000	1	0
1233	1233	1	607904750000000	1000000000	691200	1000000000	1	0
1234	1234	1	607904750000000	1000000000	691200	1000000000	1	0
1235	1235	1	607904750000000	1000000000	691200	1000000000	1	0
1236	1236	1	607904750000000	1000000000	691200	1000000000	1	0
1237	1237	1	607904750000000	1000000000	691200	1000000000	1	0
1238	1238	1	607904750000000	1000000000	691200	1000000000	1	0
1239	1239	1	607904750000000	1000000000	691200	1000000000	1	0
1240	1240	1	607904750000000	1000000000	691200	1000000000	1	0
1241	1241	1	607904750000000	1000000000	691200	1000000000	1	0
1242	1242	1	607904750000000	1000000000	691200	1000000000	1	0
1243	1243	1	607904750000000	1000000000	691200	1000000000	1	0
1244	1244	1	607904750000000	1000000000	691200	1000000000	1	0
1245	1245	1	607904750000000	1000000000	691200	1000000000	1	0
1246	1246	1	607904750000000	1000000000	691200	1000000000	1	0
1247	1247	1	607904750000000	1000000000	691200	1000000000	1	0
1248	1248	1	607904750000000	1000000000	691200	1000000000	1	0
1249	1249	1	607904750000000	1000000000	691200	1000000000	1	0
1250	1250	1	607904750000000	1000000000	691200	1000000000	1	0
1251	1251	1	607904750000000	1000000000	691200	1000000000	1	0
1252	1252	1	607904750000000	1000000000	691200	1000000000	1	0
1253	1253	1	607904750000000	1000000000	691200	1000000000	1	0
1254	1254	1	607904750000000	1000000000	691200	1000000000	1	0
1255	1255	1	607904750000000	1000000000	691200	1000000000	1	0
1256	1256	1	607904750000000	1000000000	691200	1000000000	1	0
1257	1257	1	607904750000000	1000000000	691200	1000000000	1	0
1258	1258	1	607904750000000	1000000000	691200	1000000000	1	0
1259	1259	1	607904750000000	1000000000	691200	1000000000	1	0
1260	1260	1	607904750000000	1000000000	691200	1000000000	1	0
1261	1261	1	607904750000000	1000000000	691200	1000000000	1	0
1262	1262	1	607904750000000	1000000000	691200	1000000000	1	0
1263	1263	1	607904750000000	1000000000	691200	1000000000	1	0
1264	1264	1	607904750000000	1000000000	691200	1000000000	1	0
1265	1265	1	607904750000000	1000000000	691200	1000000000	1	0
1266	1266	1	606464750000000	1000000000	691200	1000000000	1	0
1267	1267	1	93600000000000	1000000000	691200	1000000000	1	0
1268	1268	1	1000000000000	1000000000	86400	1000000000	1	0
1269	1269	1	0	0	0	0	0	0
1270	1270	1	0	0	0	0	0	0
1271	1271	1	1333326000000000	1000000000	259200	1000000000	1	0
1272	1272	1	11666659000000000	1000000000	259200	1000000000	1	0
1273	1273	1	1693980637751650	1000000000	345600	1000000000	1	0
1274	1274	1	1693980637751650	1000000000	345600	1000000000	1	0
1275	1275	1	1693980637751650	1000000000	345600	1000000000	1	0
1276	1276	1	1693980637751650	1000000000	345600	1000000000	1	0
1277	1277	1	1693980637751650	1000000000	345600	1000000000	1	0
1278	1278	1	1693980637751650	1000000000	345600	1000000000	1	0
1279	1279	1	1693980637751650	1000000000	345600	1000000000	1	0
1280	1280	1	1693980637751650	1000000000	345600	1000000000	1	0
1281	1281	1	1693980637751650	1000000000	345600	1000000000	1	0
1282	1282	1	1693980637751650	1000000000	345600	1000000000	1	0
1283	1283	1	1693980637751650	1000000000	345600	1000000000	1	0
1284	1284	1	1693980637751650	1000000000	345600	1000000000	1	0
1285	1285	1	1693980637751650	1000000000	345600	1000000000	1	0
1286	1286	1	1693980637751650	1000000000	345600	1000000000	1	0
1287	1287	1	1693980637751650	1000000000	345600	1000000000	1	0
1288	1288	1	1693980637751650	1000000000	345600	1000000000	1	0
1289	1289	1	1693980637751650	1000000000	345600	1000000000	1	0
1290	1290	1	1693980637751650	1000000000	345600	1000000000	1	0
1291	1291	1	1693980637751650	1000000000	345600	1000000000	1	0
1292	1292	1	1693980637751650	1000000000	345600	1000000000	1	0
1293	1293	1	1693980637751650	1000000000	345600	1000000000	1	0
1294	1294	1	1693980637751650	1000000000	345600	1000000000	1	0
1295	1295	1	1693980637751650	1000000000	345600	1000000000	1	0
1296	1296	1	1693980637751650	1000000000	345600	1000000000	1	0
1297	1297	1	1693980637751650	1000000000	345600	1000000000	1	0
1298	1298	1	1693980637751650	1000000000	345600	1000000000	1	0
1299	1299	1	1693980637751650	1000000000	345600	1000000000	1	0
1300	1300	1	1693980637751650	1000000000	345600	1000000000	1	0
1301	1301	1	1693980637751650	1000000000	345600	1000000000	1	0
1302	1302	1	1693980637751650	1000000000	345600	1000000000	1	0
1303	1303	1	1693980637751650	1000000000	345600	1000000000	1	0
1304	1304	1	1693980637751650	1000000000	345600	1000000000	1	0
1305	1305	1	1693980637751650	1000000000	345600	1000000000	1	0
1306	1306	1	1693980637751650	1000000000	345600	1000000000	1	0
1307	1307	1	1693980637751650	1000000000	345600	1000000000	1	0
1308	1308	1	1693980637751650	1000000000	345600	1000000000	1	0
1309	1309	1	1693980637751650	1000000000	345600	1000000000	1	0
1310	1310	1	1693980637751650	1000000000	345600	1000000000	1	0
1311	1311	1	1693980637751650	1000000000	345600	1000000000	1	0
1312	1312	1	1693980637751650	1000000000	345600	1000000000	1	0
1313	1313	1	1693980637751650	1000000000	345600	1000000000	1	0
1314	1314	1	1693980637751650	1000000000	345600	1000000000	1	0
1315	1315	1	1693980637751650	1000000000	345600	1000000000	1	0
1316	1316	1	1693980637751650	1000000000	345600	1000000000	1	0
1317	1317	1	1693980637751650	1000000000	345600	1000000000	1	0
1318	1318	1	1693980637751650	1000000000	345600	1000000000	1	0
1319	1319	1	1693980637751650	1000000000	345600	1000000000	1	0
1320	1320	1	1693980637751650	1000000000	345600	1000000000	1	0
1321	1321	1	1693980637751650	1000000000	345600	1000000000	1	0
1322	1322	1	1693980637751650	1000000000	345600	1000000000	1	0
1323	1323	1	1693980637751650	1000000000	345600	1000000000	1	0
1324	1324	1	1693980637751650	1000000000	345600	1000000000	1	0
1325	1325	1	1693980637751650	1000000000	345600	1000000000	1	0
1326	1326	1	1693980637751650	1000000000	345600	1000000000	1	0
1327	1327	1	1693980637751650	1000000000	345600	1000000000	1	0
1328	1328	1	1693980637751650	1000000000	345600	1000000000	1	0
1329	1329	1	1693980637751650	1000000000	345600	1000000000	1	0
1330	1330	1	1693980637751650	1000000000	345600	1000000000	1	0
1331	1331	1	1693980637751650	1000000000	345600	1000000000	1	0
1332	1332	1	1693980637751650	1000000000	345600	1000000000	1	0
1333	1333	1	1693980637751650	1000000000	345600	1000000000	1	0
1334	1334	1	1693980637751650	1000000000	345600	1000000000	1	0
1335	1335	1	1693980637751650	1000000000	345600	1000000000	1	0
1336	1336	1	1693980637751650	1000000000	345600	1000000000	1	0
1337	1337	1	1693980637751650	1000000000	345600	1000000000	1	0
1338	1338	1	1693980637751650	1000000000	345600	1000000000	1	0
1339	1339	1	1693980637751650	1000000000	345600	1000000000	1	0
1340	1340	1	1693980637751650	1000000000	345600	1000000000	1	0
1341	1341	1	1693980637751650	1000000000	345600	1000000000	1	0
1342	1342	1	1693980637751650	1000000000	345600	1000000000	1	0
1343	1343	1	1693980637751650	1000000000	345600	1000000000	1	0
1344	1344	1	1693980637751650	1000000000	345600	1000000000	1	0
1345	1345	1	1693980637751650	1000000000	345600	1000000000	1	0
1346	1346	1	1693980637751650	1000000000	345600	1000000000	1	0
1347	1347	1	1693980637751650	1000000000	345600	1000000000	1	0
1348	1348	1	1693980637751650	1000000000	345600	1000000000	1	0
1349	1349	1	1693980637751650	1000000000	345600	1000000000	1	0
1350	1350	1	1693980637751650	1000000000	345600	1000000000	1	0
1351	1351	1	1693980637751650	1000000000	345600	1000000000	1	0
1352	1352	1	1693980637751650	1000000000	345600	1000000000	1	0
1353	1353	1	1693980637751650	1000000000	345600	1000000000	1	0
1354	1354	1	1693980637751650	1000000000	345600	1000000000	1	0
1355	1355	1	1693980637751650	1000000000	345600	1000000000	1	0
1356	1356	1	1693980637751650	1000000000	345600	1000000000	1	0
1357	1357	1	1693980637751650	1000000000	345600	1000000000	1	0
1358	1358	1	1693980637751650	1000000000	345600	1000000000	1	0
1359	1359	1	1693980637751650	1000000000	345600	1000000000	1	0
1360	1360	1	1693980637751650	1000000000	345600	1000000000	1	0
1361	1361	1	1693980637751650	1000000000	345600	1000000000	1	0
1362	1362	1	1693980637751650	1000000000	345600	1000000000	1	0
1363	1363	1	1693980637751650	1000000000	345600	1000000000	1	0
1364	1364	1	1693980637751650	1000000000	345600	1000000000	1	0
1365	1365	1	1693980637751650	1000000000	345600	1000000000	1	0
1366	1366	1	1693980637751650	1000000000	345600	1000000000	1	0
1367	1367	1	1693980637751650	1000000000	345600	1000000000	1	0
1368	1368	1	1693980637751650	1000000000	345600	1000000000	1	0
1369	1369	1	1693980637751650	1000000000	345600	1000000000	1	0
1370	1370	1	1693980637751650	1000000000	345600	1000000000	1	0
1371	1371	1	1693980637751650	1000000000	345600	1000000000	1	0
1372	1372	1	1693980637751650	1000000000	345600	1000000000	1	0
1373	1373	1	1693980637751650	1000000000	345600	1000000000	1	0
1374	1374	1	1693980637751650	1000000000	345600	1000000000	1	0
1375	1375	1	1693980637751650	1000000000	345600	1000000000	1	0
1376	1376	1	1693980637751650	1000000000	345600	1000000000	1	0
1377	1377	1	1693980637751650	1000000000	345600	1000000000	1	0
1378	1378	1	1693980637751650	1000000000	345600	1000000000	1	0
1379	1379	1	1693980637751650	1000000000	345600	1000000000	1	0
1380	1380	1	1693980637751650	1000000000	345600	1000000000	1	0
1381	1381	1	1693980637751650	1000000000	345600	1000000000	1	0
1382	1382	1	1693980637751650	1000000000	345600	1000000000	1	0
1383	1383	1	1693980637751650	1000000000	345600	1000000000	1	0
1384	1384	1	1693980637751650	1000000000	345600	1000000000	1	0
1385	1385	1	1693980637751650	1000000000	345600	1000000000	1	0
1386	1386	1	1693980637751650	1000000000	345600	1000000000	1	0
1387	1387	1	1693980637751650	1000000000	345600	1000000000	1	0
1388	1388	1	1693980637751650	1000000000	345600	1000000000	1	0
1389	1389	1	1693980637751650	1000000000	345600	1000000000	1	0
1390	1390	1	1693980637751650	1000000000	345600	1000000000	1	0
1391	1391	1	1693980637751650	1000000000	345600	1000000000	1	0
1392	1392	1	1693980637751650	1000000000	345600	1000000000	1	0
1393	1393	1	75000000000000000	0	0	0	0	0
1394	1394	1	0	0	0	0	0	0
1395	1395	1	57617370302858700	1000000000	345600	1000000000	1	0
1396	1396	1	0	0	0	0	0	0
1397	1397	1	1440000000000	1000000000	345600	1000000000	1	0
1398	1398	1	0	0	0	0	0	0
1399	1399	1	0	0	0	0	0	0
1400	1400	1	0	0	0	0	0	0
1401	1401	1	0	0	0	0	0	0
1402	1402	1	0	0	0	0	0	0
1403	1403	1	0	0	0	0	0	0
1404	1404	1	0	0	0	0	0	0
1405	1405	1	0	0	0	0	0	0
1406	1406	1	0	0	0	0	0	0
1407	1407	1	0	0	0	0	0	0
1408	1408	1	0	0	0	0	0	0
1409	1409	1	0	0	0	0	0	0
1410	1410	1	0	0	0	0	0	0
1411	1411	1	0	0	0	0	0	0
1412	1412	1	0	0	0	0	0	0
1413	1413	1	0	0	0	0	0	0
1414	1414	1	0	0	0	0	0	0
1415	1415	1	0	0	0	0	0	0
1416	1416	1	0	0	0	0	0	0
1417	1417	1	0	0	0	0	0	0
1418	1418	1	0	0	0	0	0	0
1419	1419	1	0	0	0	0	0	0
1420	1420	1	0	0	0	0	0	0
1421	1421	1	0	0	0	0	0	0
1422	1422	1	0	0	0	0	0	0
1423	1423	1	0	0	0	0	0	0
1424	1424	1	0	0	0	0	0	0
1425	1425	1	0	0	0	0	0	0
1426	1426	1	0	0	0	0	0	0
1427	1427	1	0	0	0	0	0	0
1428	1428	1	0	0	0	0	0	0
1429	1429	1	0	0	0	0	0	0
1430	1430	1	0	0	0	0	0	0
1431	1431	1	0	0	0	0	0	0
1432	1432	1	0	0	0	0	0	0
1433	1433	1	0	0	0	0	0	0
1434	1434	1	0	0	0	0	0	0
1435	1435	1	0	0	0	0	0	0
1436	1436	1	0	0	0	0	0	0
1437	1437	1	0	0	0	0	0	0
1438	1438	1	0	0	0	0	0	0
1439	1439	1	0	0	0	0	0	0
1440	1440	1	0	0	0	0	0	0
1441	1441	1	0	0	0	0	0	0
1442	1442	1	0	0	0	0	0	0
1443	1443	1	0	0	0	0	0	0
1444	1444	1	0	0	0	0	0	0
1445	1445	1	0	0	0	0	0	0
1446	1446	1	0	0	0	0	0	0
1447	1447	1	0	0	0	0	0	0
1448	1448	1	0	0	0	0	0	0
1449	1449	1	0	0	0	0	0	0
1450	1450	1	0	0	0	0	0	0
1451	1451	1	0	0	0	0	0	0
1452	1452	1	0	0	0	0	0	0
1453	1453	1	0	0	0	0	0	0
1454	1454	1	0	0	0	0	0	0
1455	1455	1	0	0	0	0	0	0
1456	1456	1	0	0	0	0	0	0
1457	1457	1	0	0	0	0	0	0
1458	1458	1	0	0	0	0	0	0
1459	1459	1	0	0	0	0	0	0
1460	1460	1	0	0	0	0	0	0
1461	1461	1	0	0	0	0	0	0
1462	1462	1	0	0	0	0	0	0
1463	1463	1	0	0	0	0	0	0
1464	1464	1	0	0	0	0	0	0
1465	1465	1	0	0	0	0	0	0
1466	1466	1	0	0	0	0	0	0
1467	1467	1	0	0	0	0	0	0
1468	1468	1	0	0	0	0	0	0
1469	1469	1	0	0	0	0	0	0
1470	1470	1	0	0	0	0	0	0
1471	1471	1	0	0	0	0	0	0
1472	1472	1	0	0	0	0	0	0
1473	1473	1	0	0	0	0	0	0
1474	1474	1	0	0	0	0	0	0
1475	1475	1	0	0	0	0	0	0
1476	1476	1	0	0	0	0	0	0
1477	1477	1	0	0	0	0	0	0
1478	1478	1	0	0	0	0	0	0
1479	1479	1	0	0	0	0	0	0
1480	1480	1	0	0	0	0	0	0
1481	1481	1	0	0	0	0	0	0
1482	1482	1	0	0	0	0	0	0
1483	1483	1	0	0	0	0	0	0
1484	1484	1	0	0	0	0	0	0
1485	1485	1	0	0	0	0	0	0
1486	1486	1	0	0	0	0	0	0
1487	1487	1	0	0	0	0	0	0
1488	1488	1	0	0	0	0	0	0
1489	1489	1	0	0	0	0	0	0
1490	1490	1	0	0	0	0	0	0
1491	1491	1	0	0	0	0	0	0
1492	1492	1	0	0	0	0	0	0
1493	1493	1	0	0	0	0	0	0
1494	1494	1	0	0	0	0	0	0
1495	1495	1	0	0	0	0	0	0
1496	1496	1	0	0	0	0	0	0
1497	1497	1	0	0	0	0	0	0
1498	1498	1	0	0	0	0	0	0
1499	1499	1	0	0	0	0	0	0
1500	1500	1	0	0	0	0	0	0
1501	1501	1	0	0	0	0	0	0
1502	1502	1	0	0	0	0	0	0
1503	1503	1	0	0	0	0	0	0
1504	1504	1	0	0	0	0	0	0
1505	1505	1	0	0	0	0	0	0
1506	1506	1	0	0	0	0	0	0
1507	1507	1	0	0	0	0	0	0
1508	1508	1	0	0	0	0	0	0
1509	1509	1	0	0	0	0	0	0
1510	1510	1	0	0	0	0	0	0
1511	1511	1	0	0	0	0	0	0
1512	1512	1	0	0	0	0	0	0
1513	1513	1	0	0	0	0	0	0
1514	1514	1	0	0	0	0	0	0
1515	1515	1	0	0	0	0	0	0
1516	1516	1	0	0	0	0	0	0
1517	1517	1	0	0	0	0	0	0
1518	1518	1	0	0	0	0	0	0
1519	1519	1	0	0	0	0	0	0
1520	1520	1	0	0	0	0	0	0
1521	1521	1	0	0	0	0	0	0
1522	1522	1	0	0	0	0	0	0
1523	1523	1	0	0	0	0	0	0
1524	1524	1	0	0	0	0	0	0
1525	1525	1	0	0	0	0	0	0
1526	1526	1	0	0	0	0	0	0
1527	1527	1	0	0	0	0	0	0
1528	1528	1	0	0	0	0	0	0
1529	1529	1	0	0	0	0	0	0
1530	1530	1	0	0	0	0	0	0
1531	1531	1	0	0	0	0	0	0
1532	1532	1	0	0	0	0	0	0
1533	1533	1	0	0	0	0	0	0
1534	1534	1	0	0	0	0	0	0
1535	1535	1	0	0	0	0	0	0
1536	1536	1	0	0	0	0	0	0
1537	1537	1	0	0	0	0	0	0
1538	1538	1	0	0	0	0	0	0
1539	1539	1	0	0	0	0	0	0
1540	1540	1	0	0	0	0	0	0
1541	1541	1	0	0	0	0	0	0
1542	1542	1	0	0	0	0	0	0
1543	1543	1	0	0	0	0	0	0
1544	1544	1	0	0	0	0	0	0
1545	1545	1	0	0	0	0	0	0
1546	1546	1	0	0	0	0	0	0
1547	1547	1	0	0	0	0	0	0
1548	1548	1	0	0	0	0	0	0
1549	1549	1	0	0	0	0	0	0
1550	1550	1	0	0	0	0	0	0
1551	1551	1	0	0	0	0	0	0
1552	1552	1	0	0	0	0	0	0
1553	1553	1	0	0	0	0	0	0
1554	1554	1	0	0	0	0	0	0
1555	1555	1	0	0	0	0	0	0
1556	1556	1	0	0	0	0	0	0
1557	1557	1	0	0	0	0	0	0
1558	1558	1	0	0	0	0	0	0
1559	1559	1	0	0	0	0	0	0
1560	1560	1	0	0	0	0	0	0
1561	1561	1	0	0	0	0	0	0
1562	1562	1	0	0	0	0	0	0
1563	1563	1	0	0	0	0	0	0
1564	1564	1	0	0	0	0	0	0
1565	1565	1	0	0	0	0	0	0
1566	1566	1	0	0	0	0	0	0
1567	1567	1	0	0	0	0	0	0
1568	1568	1	0	0	0	0	0	0
1569	1569	1	0	0	0	0	0	0
1570	1570	1	0	0	0	0	0	0
1571	1571	1	0	0	0	0	0	0
1572	1572	1	0	0	0	0	0	0
1573	1573	1	0	0	0	0	0	0
1574	1574	1	0	0	0	0	0	0
1575	1575	1	0	0	0	0	0	0
1576	1576	1	0	0	0	0	0	0
1577	1577	1	0	0	0	0	0	0
1578	1578	1	0	0	0	0	0	0
1579	1579	1	0	0	0	0	0	0
1580	1580	1	0	0	0	0	0	0
1581	1581	1	0	0	0	0	0	0
1582	1582	1	0	0	0	0	0	0
1583	1583	1	0	0	0	0	0	0
1584	1584	1	0	0	0	0	0	0
1585	1585	1	0	0	0	0	0	0
1586	1586	1	0	0	0	0	0	0
1587	1587	1	0	0	0	0	0	0
1588	1588	1	0	0	0	0	0	0
1589	1589	1	0	0	0	0	0	0
1590	1590	1	0	0	0	0	0	0
1591	1591	1	0	0	0	0	0	0
1592	1592	1	0	0	0	0	0	0
1593	1593	1	0	0	0	0	0	0
1594	1594	1	0	0	0	0	0	0
1595	1595	1	0	0	0	0	0	0
1596	1596	1	0	0	0	0	0	0
1597	1597	1	0	0	0	0	0	0
1598	1598	1	0	0	0	0	0	0
1599	1599	1	0	0	0	0	0	0
1600	1600	1	0	0	0	0	0	0
1601	1601	1	0	0	0	0	0	0
1602	1602	1	0	0	0	0	0	0
1603	1603	1	0	0	0	0	0	0
1604	1604	1	0	0	0	0	0	0
1605	1605	1	0	0	0	0	0	0
1606	1606	1	0	0	0	0	0	0
1607	1607	1	0	0	0	0	0	0
1608	1608	1	0	0	0	0	0	0
1609	1609	1	0	0	0	0	0	0
1610	1610	1	0	0	0	0	0	0
1611	1611	1	0	0	0	0	0	0
1612	1612	1	0	0	0	0	0	0
1613	1613	1	0	0	0	0	0	0
1614	1614	1	0	0	0	0	0	0
1615	1615	1	0	0	0	0	0	0
1616	1616	1	0	0	0	0	0	0
1617	1617	1	0	0	0	0	0	0
1618	1618	1	0	0	0	0	0	0
1619	1619	1	0	0	0	0	0	0
1620	1620	1	0	0	0	0	0	0
1621	1621	1	0	0	0	0	0	0
1622	1622	1	0	0	0	0	0	0
1623	1623	1	0	0	0	0	0	0
1624	1624	1	0	0	0	0	0	0
1625	1625	1	0	0	0	0	0	0
1626	1626	1	0	0	0	0	0	0
1627	1627	1	0	0	0	0	0	0
1628	1628	1	0	0	0	0	0	0
1629	1629	1	0	0	0	0	0	0
1630	1630	1	0	0	0	0	0	0
1631	1631	1	0	0	0	0	0	0
1632	1632	1	0	0	0	0	0	0
1633	1633	1	0	0	0	0	0	0
1634	1634	1	0	0	0	0	0	0
1635	1635	1	0	0	0	0	0	0
1636	1636	1	0	0	0	0	0	0
1637	1637	1	0	0	0	0	0	0
1638	1638	1	0	0	0	0	0	0
1639	1639	1	0	0	0	0	0	0
1640	1640	1	0	0	0	0	0	0
1641	1641	1	0	0	0	0	0	0
1642	1642	1	0	0	0	0	0	0
1643	1643	1	0	0	0	0	0	0
1644	1644	1	0	0	0	0	0	0
1645	1645	1	0	0	0	0	0	0
1646	1646	1	0	0	0	0	0	0
1647	1647	1	0	0	0	0	0	0
1648	1648	1	0	0	0	0	0	0
1649	1649	1	0	0	0	0	0	0
1650	1650	1	0	0	0	0	0	0
1651	1651	1	0	0	0	0	0	0
1652	1652	1	0	0	0	0	0	0
1653	1653	1	0	0	0	0	0	0
1654	1654	1	0	0	0	0	0	0
1655	1655	1	0	0	0	0	0	0
1656	1656	1	0	0	0	0	0	0
1657	1657	1	0	0	0	0	0	0
1658	1658	1	0	0	0	0	0	0
1659	1659	1	0	0	0	0	0	0
1660	1660	1	0	0	0	0	0	0
1661	1661	1	0	0	0	0	0	0
1662	1662	1	0	0	0	0	0	0
1663	1663	1	0	0	0	0	0	0
1664	1664	1	0	0	0	0	0	0
1665	1665	1	0	0	0	0	0	0
1666	1666	1	0	0	0	0	0	0
1667	1667	1	0	0	0	0	0	0
1668	1668	1	0	0	0	0	0	0
1669	1669	1	0	0	0	0	0	0
1670	1670	1	0	0	0	0	0	0
1671	1671	1	0	0	0	0	0	0
1672	1672	1	0	0	0	0	0	0
1673	1673	1	0	0	0	0	0	0
1674	1674	1	0	0	0	0	0	0
1675	1675	1	0	0	0	0	0	0
\.


--
-- Data for Name: user_commands; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.user_commands (id, type, fee_payer_id, source_id, receiver_id, fee_token, token, nonce, amount, fee, valid_until, memo, hash) FROM stdin;
1	payment	1397	1397	1678	1	1	0	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirFuoLVVab6x2ry4j8Ld5gMmQdak7VHW6f5C7VJYE34WAEWqa
2	payment	1397	1397	1678	1	1	1	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4WE3wDRJ4CqCXqS4dqF8hoRQDVK8banePKUgTR6kvhTfyjRp
3	payment	1397	1397	1678	1	1	2	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeG32dVJUjs6iq3oroXWitXar1eBtV3GVFyH5agw7HPp9bG4yQ
4	payment	1397	1397	1678	1	1	3	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1u12zrTuEttp7QktfEy7wosHrPV6r3DJkq4sA9f1yKgEqmj5k
5	payment	1397	1397	1678	1	1	4	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbDiRtzF6AUVrny7VoJKTu1wStBHDEsG9W27UFeoeDwMP8VAc
6	payment	1397	1397	1678	1	1	5	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK28AEmzhB8AjsfT6Dd1cKdR5WF2gQw4xqDu4f93ozDX2jekTq
7	payment	1397	1397	1678	1	1	6	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYaPLcM3JKLySyEcPeeANEVwQ3aTNYzJ9oFxqQamW9kZnFuPU
8	payment	1397	1397	1678	1	1	7	10000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZBvLsgsPnndQKkysZJDJ9gNkSR2oeaTp9grBpcCBamGsg7hV
9	payment	1397	1397	1678	1	1	8	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9pjDC5qqpHJtSaA6WpoT3GQPNYZJkCLxkERqPSb37brMTAPy
10	payment	1397	1397	1678	1	1	9	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrxGwdxH2CL8wGTF3B9BgJcc5xyfiF8iyzNvTYMALccvmNcNSN
11	payment	1397	1397	1678	1	1	10	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbNmcxmQq95hZppriz49UQciCw5XybR89Kr9Rna3QPrZwd7n6
12	payment	1397	1397	1678	1	1	11	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZME52rRdLoVDUkEx1vK3QUu86WxUQTV5347cUj1vnJaZSovN9s
13	payment	1397	1397	1678	1	1	12	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6rHwLM8iJwBU1ssm1tdMzx9rdyDEhpGU8aCAionzF1k82d5N
14	payment	1397	1397	1397	1	1	13	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTdKUDFM8Nsq6noJ4pP6esqP7FeJaHiisGrXSqHYvidfvukDA
15	payment	1397	1397	1397	1	1	14	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCDcYefnCjZSD6CY8NbMxAZ2idsxeZ3duF5bSKzNT8aZDqwZX
16	payment	1397	1397	1678	1	1	15	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5Pb3RMrCpyRARFU2ZeoHPYt2PfLoGypjAn82HhoAE8FqfYrD
17	payment	1397	1397	1397	1	1	16	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Nrw2npxR1Uqqw2DUoV7n4xSSwmFUkV7NryWUfz2d5q8ShbHF
18	payment	1397	1397	1397	1	1	17	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi83oW6HZWhYrqpkKrpwjGat1VSXRPBcjcTM2jWDo4BWdkJYJ7
19	payment	1397	1397	1678	1	1	18	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WWg2irdypoygyiNWMFWYAurjkqA8MbDwx17zYLyvptZeLxxN
20	payment	1397	1397	1678	1	1	19	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3P9RkHVHoFr5rYFwHwTJqVHQhcix7ZUvhctSHaLmGeRGEG7m
21	payment	1397	1397	1678	1	1	20	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTntUnbcVZZ6Cf2vEgq48XtALb3UWimNJsMbQPbWbxDJuG13Kx
22	payment	1397	1397	1678	1	1	21	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfq8tLuUErt6u1RXDiWsBCYsw3VWH62zJZpoA2vVBHj3zMmqF5
23	payment	1397	1397	1678	1	1	22	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyxj3gdR3goAd2uo3RrdeQ7PYx9QNkqDZPWZC1rpwxSM1TAdL
24	payment	1397	1397	1678	1	1	23	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ479vRfrxo6L8pRPEfUkt1u9gd9PPn1yA2v4dDKzgaPh4nsnC9
25	payment	1397	1397	1678	1	1	24	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFyHuoDdSysZzYeAvPm37Fs8YLLgwnVsKUGFRcUKZ3mghCKBd
26	payment	1397	1397	1678	1	1	25	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpDx4R1ne7kzFHjZn6FuJV3hM78EcrTAeFWjme5sdhb4Zfnkj
27	payment	1397	1397	1678	1	1	26	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYUqmZjtnsovBoW1DtWaPbb8pGD68JsWS1ZTPMNPGyGZDVQ5a
28	payment	1397	1397	1678	1	1	27	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8epNgyUiBUEJqm8YQeemwPoKuyZvHSLMGZNkD5FacYEHispH
29	payment	1397	1397	1678	1	1	28	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsccgXvPbfGTsNH73CVS3UbfWEmT6THuAxLntXGx9LRsFoNri
30	payment	1397	1397	1678	1	1	29	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaeHbTYYXBQeaPxVJMk534uCTVg63aUqZf4Ak26cEDFbdTMra
31	payment	1397	1397	1678	1	1	30	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQEegfQCrRACVWMXyfq5q96kCgtBsV1ZRFBT11egMwzRGYn3V2
32	payment	1397	1397	1678	1	1	31	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8eiVX1w2RG9B3aRsrgg3mgqfedUwt42HUoQBCQDWLjkeobjq
33	payment	1397	1397	1678	1	1	32	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqgk9MvvmVEPfS7XzWcXuJqDpxQTt6pEh1ykjeUHHrgFfFyKe
34	payment	1397	1397	1678	1	1	33	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38Y14bsL889279sQczYbifo8v7y53hpNvmFBXmWF1UA71Kjgp
35	payment	1397	1397	1678	1	1	34	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRW7Gm7Qww46jmWqtjDftVMRSSkE6X4DqWc7QGYk6abveWtxm
36	payment	1397	1397	1678	1	1	35	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3S5mFYeMzsH6F8vQ9ZwStwVQjLAXej1snBM5eZYsaiZ9bUQzb
37	payment	1397	1397	1678	1	1	36	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFV9SFfPw85H1VEgyUqEtuoRFMv4PPj6WUQUGvTgz5wyecU7VS
38	payment	1397	1397	1678	1	1	37	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLd2QVVvR8v2QjKbsHnmAcUhcVaecXjERkxzUvkSFq27x7rvHA
39	payment	1397	1397	1678	1	1	38	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXjqDHCk6eph6yEaYTG8i5pvYTR6iBgmAezMZX82LNt4z61Nh
40	payment	1397	1397	1678	1	1	39	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQR5bL84VbBdSYJrfdRH3fE8d8ZqcPd3kvwjskn4gCp5RpBrQU
41	payment	1397	1397	1678	1	1	40	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBZLhy3eiPuNe4w7XS3vPoPkuEvk4ZhfAz4RGsef6Z6zcyhy7
43	payment	1397	1397	1678	1	1	42	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2yQheMxn1MAKeGJTcS4PDBo45o5DaauxWg8QTQE6KMpWnnvm
44	payment	1397	1397	1678	1	1	43	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpzCkFEET5AutjVu4dfAPpXstqU76Us55h85qKy6vUewEY32p
46	payment	1397	1397	1678	1	1	45	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gCPQkPDneXRwWiHiqGtKjLT8MocYrxBsdCpMmPZvgAdNLgzx
48	payment	1397	1397	1678	1	1	47	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mSZrVwM84pFseim1aznNuqZdtkqjbaXnnt4hqoQTDkbdvvV8
49	payment	1397	1397	1678	1	1	48	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhP95AnhewK6xzdEncny5mNyLPvPtz6swpoyXdqzqgPoZMG1E
42	payment	1397	1397	1678	1	1	41	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVj8DLuMGvxeDhc2nsHUfZXPoXXbwTAgDbT7AWiec6jn5BoY9
50	payment	1397	1397	1678	1	1	49	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbai6qHEoF53e8pFHdiWqhT34sPhSgbUVdxLmfzAZ8oMpKDuK
51	payment	1397	1397	1678	1	1	50	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEM3sGhwFbWpsdpCLrEJ2ovqnamsvfRfChZ5LM4UUaEBnG221d
52	payment	1397	1397	1678	1	1	51	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXFHFBbjnD4yTjcVJ2yD5W8k8rnA9XXbkvnH1r6BmKmbyADsp2
45	payment	1397	1397	1678	1	1	44	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXejdztBNgfhdcx4Z5ob72r6bXmUg9kjoZr2ZniZ3QgBr9841k
47	payment	1397	1397	1678	1	1	46	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJ4NWNGx5tUXQq3BaRWpgiR8kKbcCPFJKmX5GZmjBhiozHAxN
53	payment	1397	1397	1678	1	1	52	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokvqj7UNGKXEX9uqix6ipN8xhAodrecrZPySAnTa1E8JCEgAn
54	payment	1397	1397	1678	1	1	53	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZbjbC4o7artS7gU3ExzJ9gT19mLezWnYM9wEUyLJxMuMTdf1
55	payment	1397	1397	1678	1	1	54	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv92jhjBCvf3T62qvpHsdnCgLBTBQ7BucpdcYhXNbCW9jRdMDp
56	payment	1397	1397	1678	1	1	55	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMaJqfQDZVrWKnUiQyw7DxzCnAze3ZCjiGhk74tkMA684Lo5v
57	payment	1397	1397	1678	1	1	56	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsJsGdprS1KHwU8inFVWBHQkbFzy4rxS1AsNW8ArTp212Aiqk
58	payment	1397	1397	1678	1	1	57	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWT8QzLivh9dDXtibBr65GMRmhVuXhHSuhjvdqZtHsVrLhu6K
59	payment	1397	1397	1678	1	1	58	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jyXACaSTnooeuMLVgQfndNzqqMXAhAHFCLN4zL1f1tpcCAaZ
60	payment	1397	1397	1678	1	1	59	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8JaVrVR6HAAmzaumxs8fw5gyJSp6tP2ax4rushuGf5iacPEij
61	payment	1397	1397	1678	1	1	60	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBLFVjvp7Cfw32KLHJsX1w4KfSyWEa3pBhmA7YwJiyYfLrmCN
62	payment	1397	1397	1678	1	1	61	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwy4QqWJpgTg5Vcapce9ryR3Ti87xcWebaD5Zj8sgZuTJTDfJ
63	payment	1397	1397	1678	1	1	62	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXs3jtt6pHqqkGrLPwPjiPpH2gmQmTPT5hLMH9Rg29WjBLwjqH
64	payment	1397	1397	1678	1	1	63	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG82n6f2HVz9iyZoiRmP2moe2awmb7Acb42r5wkZubWcXqFWZz
65	payment	1397	1397	1678	1	1	64	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRRoQeHYM39naDHy31L8VZcV5SPrB8Ni7Dn5sLwzNUmxx9PM7
66	payment	1397	1397	1678	1	1	65	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3byjK85vnhY9CfphuTcMKrSvndjLvAxnwXxSv7XsBiQV2jeKE
67	payment	1397	1397	1678	1	1	66	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5QiWjRqEcGgM9tfczT4dCae4J63g15g9e8vx9Jbf4teK8Gnf
68	payment	1397	1397	1678	1	1	67	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdM83NKsnpVYF35jChzYdUnzkaqH9mnCHGscCZoRuvpEVfZSRw
69	payment	1397	1397	1678	1	1	68	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfo2PC9h6sP9ftCx4fwcfSy8nfJ3es5UUTwvyXH4bbUSg9ghi4
70	payment	1397	1397	1678	1	1	69	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9CMNSo1fgZqGfK3wMVCD6XXssuHqpRpPjDFR6JmFrzQqzSEd
71	payment	1397	1397	1678	1	1	70	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVuXmjEAqDjfjyQURBR6ceg56FpH1qUCmGiPAmaDJkdFEJLkD
72	payment	1397	1397	1678	1	1	71	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaovhbYcQzQTdKZ1Wxw2UwJAwuzaypqWjEcDAGuLJPjvzVSp7L
73	payment	1397	1397	1678	1	1	72	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnN9McUNPoyNkudwEmQ6S8EHdPBAMC8KFB9GybkJyQpm5wjZcL
74	payment	1397	1397	1678	1	1	73	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirE8S8YButq7SXG38LnwQLWrg5JGjb2VocySwoAC35tXmxrxn
75	payment	1397	1397	1678	1	1	74	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVadwtr1CPFvc81EvCgGVJZQ5fWG3ca2JsrU7eMYgsyQkKReL
76	payment	1397	1397	1678	1	1	75	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjNVLadk61ZhYnh9eaLc9g9yx19KqmLjJiZRqtavHsnvsKsnC
77	payment	1397	1397	1678	1	1	76	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZudGtrzA6g5GJ1CxY9HiTHwanhMHpqcvDkyh98gYZYjFrUTtan
78	payment	1504	1504	1697	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79MszEYSVADe9mxo6yEWRqxKLs6qwe3kShm5xXfSnaVdyj7jk
79	payment	1397	1397	1678	1	1	77	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfVEHKrSUq7iV5pz6pAe6achsNCWtSY5G6vMqDgGoay2Ey2i2
80	payment	1397	1397	1678	1	1	78	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGEp8AWC3qAkaWX1L3SD6WD29VqoV1yXUmPGen23eDjuxe1ga
81	payment	1397	1397	1678	1	1	79	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NwgG2y7nVzZ2FkMX8R9JvP9ZA2goJkyuucR9uvk2GLXAkJFw
82	payment	1397	1397	1678	1	1	80	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EzeQLT4m3mLUwyKFdvF3cjvvFGUzR9jug14E8bFryTpTsxYz
83	payment	1397	1397	1678	1	1	81	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ7YAQAbXSiRnKWBjY4gWL4AdXTm64swLfSJXbf4AuMf9XrtV
84	payment	1397	1397	1678	1	1	82	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHCiaU77YYMruYqG8u3gv7gHvdYtpD1CGzGhchTLSH5TDg4vK
85	payment	1397	1397	1678	1	1	83	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQEX6ceDWQx5CrHK1HJNgAUHL6SRZURZ19egTp3L3ES4rm2SW
86	payment	1397	1397	1678	1	1	84	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1gMwy5unMRDcPXWw7kycmyosF21fc6dTYSMRjxsBewkPxFpC
87	payment	1397	1397	1678	1	1	85	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvQmjf74636x27UcaTn8MjA3qcmzFQ3jxnyphpQXZvocsWDPn
88	payment	1397	1397	1678	1	1	86	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYax6m2eFX9KNRuRUTkjMTxv8ieMR2765D4vdiK7RDXSmUk99Fy
89	payment	1397	1397	1678	1	1	87	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoehRK6RyCuviGCBXUVjZmu5pAVKCmKjHeuShPJyuP4qwQ3dTN
90	payment	1397	1397	1678	1	1	88	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseHRAZXPDVbNbDibgTcZrWL9nHLk88qhxsu4RyvpxWe9zFvXk
91	payment	1504	1504	1697	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFy25b7aYiLNikXhCfedDCfnr1mhDJ7cEhEDGFs2HCmjC8KpR
95	payment	1397	1397	1678	1	1	92	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpazBm4N4TYp5iu9dUX8zTib5PfwZCeU822sf6qgGGArqS5L1
96	payment	1397	1397	1678	1	1	93	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9cvtGzqRcfwPdxWsn8qFzfR8fAzRffttLGQo5tx1vDgPoGmi
97	payment	1397	1397	1678	1	1	94	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPz9AXguv8wyZSHdGVLhifTNLgjwFgP4BFEDoC7AQQKjvWwX2
104	payment	1397	1397	1678	1	1	101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1yeBvxN5NCrfZFA9L7fa8ZQQG4ngUd3GzXZrvQpCnVRdwW8y
106	payment	1397	1397	1678	1	1	103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitEkdG2fNtdvWnW4h9DKCTUL6AMseqKXWAPTwqxDANuai5kNw
107	payment	1397	1397	1678	1	1	104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvK3tbGYpcY1xEfYpD7GrABoGD8Q5ZQRquH7V8wZEZtDPCU1qc
108	payment	1397	1397	1678	1	1	105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrz9HXkwWeeVggHiM8xbQBztF8LjjsfR7jkoZp8Y9Tuz1kHxW
92	payment	1397	1397	1678	1	1	89	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMkfnnx4nz4qVQ1L5nXwZq27tJgVRpL4seehA6aRXvWRi5ApF
93	payment	1397	1397	1678	1	1	90	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvp69NinEq9aPPdGqsFKhjxWCuvYVTZHxG59D7gJEdehDtnMpe
94	payment	1397	1397	1678	1	1	91	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWMkWEuYm6yZMkkPPFAKQNmqbeMTkTWHovLSA8DqjrQbzPG3Z
98	payment	1397	1397	1678	1	1	95	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPK6cUajDKH6Q3CCfCrouj3QVv9fAUepZ8AvjRuwb1XkcAcewt
99	payment	1397	1397	1678	1	1	96	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSmkGqjJ9ass7mWadRDoQSji9CxBeiymAbQMGSh3H2pDtS7Y1
100	payment	1397	1397	1678	1	1	97	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUD79TpWPSzFEhAFnnWm1Cx3jyo4d11dhqDzm2H4hUpXic2v5
101	payment	1397	1397	1678	1	1	98	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrgRwhipA3gAC9ABPnqGnmxzNrWTubvmhhj4JEAtaiz6DtbGm
102	payment	1397	1397	1678	1	1	99	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpyJrwXhEd1wzBBkmcLDX98gyksj2EShK5BGc4Dz8rGHULZBu
105	payment	1397	1397	1678	1	1	102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyYpaBTjYe5HJqu4dFMvtAsZeFHK42zAFdWZ7TYQrzduG2RSk
103	payment	1397	1397	1678	1	1	100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazjAgUFPLbYa5jqtYReqMF3ioMRkf7zbFzbx9DEmTZeZFpetH
109	payment	1397	1397	1678	1	1	106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFFtwJVUraYnUL9RPG9o4n55w5Mckbnuf2U8YqgsCHVNTV1u3
110	payment	1397	1397	1678	1	1	107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXERvX3mUKAPWEpQ2SmcjPsMMhHBZubkNAsGEfh31PnijcPx9S
111	payment	1397	1397	1678	1	1	108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuEGFrQbaQ3Ky3HYjpECr6AeqcMCJJ4C3LhGUzJfU5mof6TY85
112	payment	1397	1397	1678	1	1	109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7AQF6muZZTq7gzburSZ2w99YJkUY5Xk36xcoqBBwgB3ogMFb
113	payment	1397	1397	1678	1	1	110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCZ19GNuN2xM3cNYKYmKuAsEuizuLyU2kDBoVxd4ZDqHBKeri
114	payment	1397	1397	1678	1	1	111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTuTZ6RGryWbPHCvrEoWi3zWs8Nw2jiUYAPV77yM4Q9BHDfH5
115	payment	1397	1397	1678	1	1	112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWqwWTr9WFwwQpoR61CZrEhZthwQ3u95iDkXWhX8snGdF5yd4
116	payment	1397	1397	1678	1	1	113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQeKox9Uviy168nViCu7bucPV1CExx88623uFUuTGY2WeEsbhD
117	payment	1397	1397	1678	1	1	114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGF6iu6ChmE7RQRkTZzXsRZZeXPKyy1M3rBwb71pPKQnrd2ny
118	payment	1397	1397	1678	1	1	115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQudJ5gKjY6YuUSEt8AxVvHrHQ8kVM2ki5J65k6kPyVh7fqxM
119	payment	1397	1397	1678	1	1	116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydm2vQWu6K9VWFQyquYDpbKeGYV2hdkKMvVzs3XNDg4W9xXP6
120	payment	1397	1397	1678	1	1	117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmZ2GTxvoBzNzXmibjvxr7sGjRfTU7rb79qdQW83BKx5HE5tP
121	payment	1397	1397	1678	1	1	118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDwSf7HximSLVz2zB92TJmxqZvouH7nRXzTEZUfStoWXGU9ib
122	payment	1397	1397	1678	1	1	119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztEzXsYwJkRnsaEX8NBDWMK6nB6vuRj9n9qzRsJwKMFCJzqbu
123	payment	1397	1397	1678	1	1	120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwvZTsoZXzmFZcC9eeSC4F7eVeXDnnwdb8PTqnHJHUJWbWaFb
124	payment	1397	1397	1678	1	1	121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjYcvWV5qwJCnx9QdNXeJhsYJNAy9a9ZKFuPkGj68UUzDHQMf
125	payment	1397	1397	1678	1	1	122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZmSmDenFbUQXYuFPqwq338oXsDNNtsgXQFMNaFLPoqQCcuW9
126	payment	1397	1397	1678	1	1	123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7co5zE4vcUtL7HPofhF6vTx7r9vKtxuGwKXs7rPUp61xRmWcs
127	payment	1397	1397	1678	1	1	124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuKiuZjvJZu82hb1inJshZhLsUgiD32A6FBab5A7ku4f34Fbm
128	payment	1397	1397	1678	1	1	125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNyCbn5XYi61pSZsqZZ8Wm4m7WjitqQ1gshAXn5qN6Yv28yyV
129	payment	1397	1397	1678	1	1	126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwQRDT38ThLKL7azWBTkoctGVSkwTesFsGKigQ8TTvSFT2Hdt
130	payment	1397	1397	1678	1	1	127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJb8GcyrbGYjGeC7aUtwDq3m6yxXSBFhuUVy4Jm8FVvaimbioM
131	payment	1397	1397	1678	1	1	128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkePDRfsrWHxpGMMxVfWMy5xnSCjYTcsqyAqgo7keHwWThb8N
132	payment	1397	1397	1678	1	1	129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjA1drWdBjmkx3QtaxwQG7JUwVwrxAokW75u45hXkz9YKjYqV6
133	payment	1397	1397	1678	1	1	130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCqx1g4E4QTHebUjnmstXmNCgAxH4sH64QKB4heqSeBgF4ayeA
134	payment	1397	1397	1678	1	1	131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUiYHwgZ5Fm7NtfBMjLz6b7mY32zjr3LRTPCxteaTp1szAphP
135	payment	1397	1397	1678	1	1	132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmtuzymGdJQZApLobN9Amt69jPdtTrkapiHkQdn8P41zNnDrh
136	payment	1397	1397	1678	1	1	133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpyG22LTzEcvmgaYbeU1pmGRuiH9eAiY8g3eykEMZepd1XkEtP
137	payment	1397	1397	1678	1	1	134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXugYdhYPxdJQybACPFf7sSLSM5FousYHet12KYkjTmq9TSdku
138	payment	1397	1397	1678	1	1	135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKsEekr1L99mS5EhKSnquXxc5i2sssPreEACdCHFB2nE2krccq
139	payment	1397	1397	1678	1	1	136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8BMCMgxEajFWhiW27ovvh1JW4ZLUeP5XTzarGdH2yEjuDiR8
140	payment	1397	1397	1678	1	1	137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9KyALF3HiCxhLcpKWZfj7ufReUR3ypyiNr6ZNU5NkwY9fUwp
141	payment	1397	1397	1678	1	1	138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZtaDCDsXCF23bUcytwKxEMM5i9xcKMRTVSUzqjjo2ZM3mqwq
142	payment	1397	1397	1678	1	1	139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDke3de25Peph3L7WShQqXF9hfoZ4bwUq1n3SHiWSENF2f539v
143	payment	1397	1397	1678	1	1	140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBgcbGKGfpKdVEu8L8xfr646VBtYbiYJLjkHwEvPJKKNWPdTe
144	payment	1397	1397	1678	1	1	141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYpHmHTSgiQvkoBPWdAoRFRmvtMCwi3ErHm5d414mR3q4GjkG
145	payment	1397	1397	1678	1	1	142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pfcmCzvveqjsKL3bQyDEa93ich2ajQLe2vRGcGakF2wp9KTW
146	payment	1397	1397	1678	1	1	143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTgbRN6w7vaxRWZbgd4GQuJV3vTqjuACkDNLURyEqhXWbWVT9
147	payment	1397	1397	1678	1	1	144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFpf2q9syHb6dmufSNUii4b5iHvPyakoWgNzKnU7AQ68fzY1P
153	payment	1705	1705	1707	1	1	0	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAYgxDvaZ9Ni5YSkdVGBi1V8fBdz5UpG4HNreKWSjScibBPF7
154	payment	1397	1397	1678	1	1	150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHY7yTfWGdFDdkGRTmQvKfJzExDwuJvBpQCUVG5bViAyuVBD7q
155	payment	1397	1397	1678	1	1	151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr89GcwKuP7F6S8H3axPYyRR1XGqkFqiXNBfauQk7bnoKJ21Qm
156	payment	1397	1397	1678	1	1	152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFeNFxTESevNZhLhahXVcs88YMskmTtriCuMXzT4AkQwQzHda
158	payment	1397	1397	1678	1	1	154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86a8ccHmZQw4UUeNcxUEM1NR9WFzR6MNDwUFXCjJq1Xr62XZa
159	payment	1397	1397	1678	1	1	155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYje1cgV8hQgSxmo9sTkN9t43A4NxSwWAkfwpCubEaqQDoJt74u
164	payment	1397	1397	1678	1	1	160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHVQmyM4nayuk7Wg6UsvSafMByXKtG9swz7mef6nWB9PmVE6R
166	payment	1397	1397	1678	1	1	162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3iQqEF9MuPfptc9F7VYp1yxre5dwfJBnWmRcj6cvrMY6uH3jf
167	payment	1397	1397	1678	1	1	163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTn9HHPL2jijSYPr7xvsjBzCTaPKByQ7xu3Bt4umSVZsssgUK
148	payment	1397	1397	1678	1	1	145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7s3dP7qQFBxPUSexYkVGbxRxcJf6HzGuPwX6ncAdeyvhY6VY5
162	payment	1397	1397	1678	1	1	158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHKTN8LAfNkJw9xgFBQAksrSQmCwnajixjNmb9rhbzoabZqVj
168	payment	1397	1397	1678	1	1	164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoESip4xRFBzBdQzPy6Cxgb29rMaUBk7LaaxDJkPGU3gThPif
169	payment	1397	1397	1678	1	1	165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgDnGoiF87esvMfLefUxPRu5uodt5NmU27fQiU8NnHp4EJB9x
170	payment	1397	1397	1678	1	1	166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGgMEetFp8CKNGnxQEdyQW8JVinA2ZC4rDU6iqAf3tv4EHCmF
149	payment	1397	1397	1678	1	1	146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAHbp51HSkoH1GTcxvRQ1A1vgoZTm78yxy4ozgi5y75KT1hgh
150	payment	1397	1397	1678	1	1	147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXdmnWS5rdY3U7hKd3Trf5Sid8L3YMRkry5swftJLHLw7awTp
151	payment	1397	1397	1678	1	1	148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqQDQnwp5CLYW1owhnDLd12McKsj8nFb5JrUoYmuViG4fLdmo
152	payment	1397	1397	1678	1	1	149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsCnm3uFdZbbyPrsrzjZuiXPmkbdhvrzyimcv1zh98uV2p8Z2
157	payment	1397	1397	1678	1	1	153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qpD3iwN3GnE7xXA5HgzNNKfStw47nHwHxvroD939JeSGVaVc
160	payment	1397	1397	1678	1	1	156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZk7pdxyp398FsWxamCUesmbNtfqb38q5TKnLHk97LScndtRrF
161	payment	1397	1397	1678	1	1	157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGBuRTY7emjeRtJdiEPKt82tpXVhsnQxqAjA2MUDA8zrdyR38B
163	payment	1397	1397	1678	1	1	159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLBGTf7xbo8dUNp3b2uX3zR5YkuJzRicncjd9UUtcMpwrtTFg
165	payment	1397	1397	1678	1	1	161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4qrAdLM6Q5idCiDsMhTiDHH5HYLNMtdPeHAZicxpoWxw6EzQ
171	payment	1397	1397	1678	1	1	167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7JBUN1BAbHj986j6dk62D4H9dxkEmHVcBk1psiHUwJU6CnxF
172	payment	1397	1397	1678	1	1	168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkg72JYAa8HiXeJAhMF2jaVoxkh2h1epSfD9YCocvHnUVTPpg
173	payment	1397	1397	1678	1	1	169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKUqR2zMj5zAXGKWZgET4z3dQBu36aNrd3pgBxR2fgTGcdchg
174	payment	1397	1397	1678	1	1	170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTY3nFHZjd9dvZ9huaQX4m1iv2nyxXPy5uCSY69WWjpvkmwXa
175	payment	1397	1397	1678	1	1	171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLS7w9ovaMW1DXeRKME8iR9vh4cjN5CZdw75VmS5srbDkk9VYR
176	payment	1397	1397	1678	1	1	172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NCxcDNTwkRY28D93birxbFYX42FYjHvzWYA61AcbJ2dL4vik
177	payment	1397	1397	1678	1	1	173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXq77ndUnjYMMKshieZgDMpYrh9CF2uvJDX4ZgmJWySPsVzvwK
178	payment	1397	1397	1678	1	1	174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTyy6TkBZUMfpCn7NSb1HZr8UcFkXJFDN46tYWxoS6qeazdJp
179	payment	1397	1397	1678	1	1	175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9DCZstYboGFmnkzGAmGS7otSXriFwyEzZSUaLdZByVqA2Jfk
180	payment	1397	1397	1678	1	1	176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreaWRNr1eANhVYLmi8vzRrwkoEwdNyk2FyUa7M4ZQVnA752wL
181	payment	1397	1397	1678	1	1	177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUT6xyn73TxURH7QHgNjAc5KS7scKZX5TmtfxCfxXSn2bHmDyN
182	payment	1397	1397	1678	1	1	178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiNzYpyutyebprH1MchZmBB9rg4qt6khmedwZLfQA6nNr8t8kv
183	payment	1397	1397	1678	1	1	179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpiKHhgLeWQyjnx5GsZNZDKsdwYU7jq8AZu7fjopyDkMJys2m
184	payment	1397	1397	1678	1	1	180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJLSSYPXQnLW8UbWeMhdjjsxxoyr7tJhZNZCgKejgckAvdi69
185	payment	1397	1397	1678	1	1	181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCyofZDbSipu7rnAXJy8cUN8wEVgoom8cE15k68JUfEpa3w84
186	payment	1397	1397	1678	1	1	182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrftAKcdQz9SKuzCiBz8RxMEEougSCHYUNU2R3hF4EcYuXUuY
187	payment	1397	1397	1678	1	1	183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnY4RuCJVwZgLfQ7KCkvD687WWmc65e2URMDPouH7hnC3CdoC
188	payment	1397	1397	1678	1	1	184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oDbM89yTfGkc7L3MSQSNbaAKnouDRoUQ8GmEBD7jgei2fUpZ
189	delegation	1571	1571	1571	1	1	0	\N	10000000	\N	E4YTmeovYUFz4uknBcuvjKkhYCTCAFg3U6fUoT8WcNdRWLHxvHUzS	CkpYvcs1BXptgc73YD6KE7rALQFkWAz4fvnAemCYHsLP4Y4ZiCemT
190	payment	1397	1397	1678	1	1	185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1KXtkhg37R1CkWsvh1nzAtmR8dHBSdyBmNoyTLeMwGHi76HK
191	payment	1397	1397	1678	1	1	186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3SjhXwd7g2oLPTzMnn9KRAFNad7nuEHt9Vh6uf6EjNY4Jhes
192	payment	1397	1397	1678	1	1	187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKt8Ev3CtFSfhvq1vDqCjNd7tufbX3r7CAwmskPLAtzeqwx3N
193	payment	1397	1397	1678	1	1	188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrSUZQn5PJ91sx4dz9jYLMEDevBKPRT2eoCKMbb47V68JcprE
194	payment	1397	1397	1678	1	1	189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vtVduWjxncHqW5Hzb6vLBE1ZiSZGdAGqaLVn4RDT2gnwDyRX
195	payment	1397	1397	1678	1	1	190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JYY4xMFUSYpwSxwXW3hPq9a91sxN3dnTdrrq8dKGzihcQs5G
196	payment	1397	1397	1678	1	1	191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sYqHaKac3L15vj8SCs6BcX8r8Ahg9Strf3MS6K5GBi8JpzPv
197	payment	1397	1397	1678	1	1	192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Fvu6VY5fVSuKTPXbdRvijjYn5jh4hfBm6dxCgmf4EYWR4yZt
198	payment	1397	1397	1678	1	1	193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnJS4udzJ2TNpKLqinkhbYM7RzA2npiZRgA7oJZQBPAf9wNkw
199	delegation	1703	1703	1651	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqgr7PK3CGVEPMay1CmartJpFVvetsXeoA8qWi8pw69t2vjhr
200	payment	1397	1397	1678	1	1	194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJ46iGXhHWbhXN3Reitk1544i9Af8P8PwYaMZeCUrKb11tY1Q
203	payment	1397	1397	1678	1	1	196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7awMzrQMYBuqLtgL2weX54J6kqoS2ZVAU3yxksbwE8v6LSpC7
214	payment	1712	1712	1713	1	1	0	500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbZnm9nJciSm4Uq3CbWfys6855o3ndMRtN4w7seCjntf4UL8R
215	payment	1397	1397	1678	1	1	207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR5wmgGWx16fn3i1o11tqyVUrDKBf1kc7N8bHL2atu8b5vheXq
216	payment	1397	1397	1678	1	1	208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsxmghd2TG3CaS1Q4h7A33gH382zuBDmWvJ6A4ZdtkTQVejJC
217	payment	1397	1397	1678	1	1	209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzqVfQdbbYxUywfztSWXUPfYciAfGgQuWuh71ZsNkDL7NC9Jm
220	payment	1397	1397	1678	1	1	212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5PnbTWfNUNprwn1Mkgf2dH4DjSJX7y62AhyE8xDzUcS5sovc
221	payment	1397	1397	1678	1	1	213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUBpWkFiJxAUZAzDEngyi7zbWdmQxhmuS6FQ5Pig27xac9bfx
222	payment	1397	1397	1678	1	1	214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6qfL7u3fN26vQy7B1uohQQEhrRzDAVufU5EMQYiGmPgcMWn9
228	payment	1397	1397	1678	1	1	219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWp4TwjHbjNn1LWC6aLfKX63ixgYyDzRRnGqiMF3N8FU9S6JFB
229	payment	1397	1397	1678	1	1	220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRSfHmS4dUQuZVgLVDGTBma5Hg8qB3nnkqQVzmaq3u3Cy9ono
238	payment	1397	1397	1678	1	1	228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNV54srTtALjUbVgccowr79rDbpNyKdAxWr22NxcwXNQLuG52
201	payment	1397	1397	1678	1	1	195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEGPRjKgPGCSZbA5wgyjGGxsT1F39QFcNaoQPEDZzxMcdwHuX
202	payment	1682	1682	1712	1	1	0	8990000000	10000000	\N	E4Yf92G48v8FApR4EWQq3iKb2vZkHHxZHPaZ73NQNBXmHeXNzHHSp	CkpaD2Ku46oLfQ6Nmqd59mGH2qqf8emuvQwE8hG5uFK7WTytBxTvU
204	payment	1397	1397	1678	1	1	197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YqBE6z9ghf6DpYNtgD4bymgkvnCVTgRgXzRjYcZ5Yxy2XDvu
207	payment	1397	1397	1678	1	1	200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMokH83oRBPTU5UNQtMM8wgY7Ed71zHUJLdz1ipxjNQ5jS4Dr2
208	payment	1397	1397	1678	1	1	201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpp59vC3eQctYDYUPT6nkeVVDAfMrUpmfv1ZN8xqa3Q4S9qeue
209	payment	1397	1397	1678	1	1	202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNfNEDwq8U24MUGYcQZfndeYyrRPFCNV6r4y341jSJFpH73ah
210	payment	1397	1397	1678	1	1	203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWoQDBeF3vuh3AbjqouTUyYdWyTnoMdaHLd5SLzwtvXnFwxvH
211	payment	1397	1397	1678	1	1	204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTdrSajYuQ8SQzFeXoMiyVLcy5SZojkoeBnvSCjpcsjwpCKBr
213	payment	1397	1397	1678	1	1	206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1QhXwL1pJPXpJAfeQ8vF87No29akteCfsdnNAjcxKCNq3pHu
218	payment	1397	1397	1678	1	1	210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhtpb3LkcF7ZTNrSNDLBsF8CzRxPH1FzuXrDW4ESvuALWEQLU
219	payment	1397	1397	1678	1	1	211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gaQrULDt5aHtdpFGwix3c8k53yiYkvEnL8fefdjhfJdUK4jJ
231	payment	1397	1397	1678	1	1	222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEvimB3dsnA7VUQ8bjCwoojgBZ2mxzaBCBoVaCVDWXLTMPERv
232	payment	1397	1397	1678	1	1	223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZDB3D9WJUyPhuVHPpcgeZbgEZf2t6t2UY3W2GSCqtGbFkPrE
233	payment	1397	1397	1678	1	1	224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRYr2fZBtEv6a6wiYeKEZKJCWD3toMXELbDXmnqzjqXdVLUYy
234	payment	1397	1397	1678	1	1	225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gou1yt52bobezkDWyFjFD8DsWFScg13Aup1sEpCLQn9mPRHU
235	payment	1397	1397	1678	1	1	226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtMtqeVzW4B8qzZcnxV79uV84rxHwct4FfAWZcPTGUnqUTz5Z
236	payment	1694	1694	56	1	1	0	100000000	1000000	\N	E4YhGLt3mKT739LgxT9zRYWkAF164GmtY9trhuGAK2z1CAgpKeZ8p	CkpYeU57LT34kiRourSaPyNWL7aEXZTQRN1d2Bp5BzT5aqKx93Bay
205	payment	1397	1397	1678	1	1	198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkjyZKsNvR28CVKnyqxAv5E4wgaorZy2TgUE7ji92r33Zs61X
206	payment	1397	1397	1678	1	1	199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHqPhwA1ZgpE3vtXQTR9n99jYGGwMLecZpAXo8Ueqq646CFgx
212	payment	1397	1397	1678	1	1	205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVryXzNtHvAi9x6Eu61uXDkxDSHZHasA3ZEijXKHTtLgdT8xm
223	delegation	1701	1701	1617	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dhTGrbsct94vCbPTTWpJsgyMdfxHErZHr7cL6CRcZ8hS2qRv
224	payment	1397	1397	1678	1	1	215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy56KxVM9GFwJmKVwDBoJVsKWEq4eTRssGGMvXzNM8WDiNSkwc
225	payment	1397	1397	1678	1	1	216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3H2z1WNJFfVsTnGa9eSUbqtB1XgnruWWfXajekwockbh58egF
226	payment	1397	1397	1678	1	1	217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6j1CnWQc1rCC9t7Vqd1WfGj4bqQTwAG9BV32aetwzzm8fFaep
227	payment	1397	1397	1678	1	1	218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8SaqZqUQRLWv5aaBZ9dQS7pBx27vy8HJyG1WNUNERwMFZ4Tv
230	payment	1397	1397	1678	1	1	221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTQGnFUQqy6nzBMnopqz2ENbZZ9gQvPVXfK8NsiZBbRPrJTQ1
237	payment	1397	1397	1678	1	1	227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoW5FUpKFFbWoG17RpZ4dkjTy9KCQsh4vEWZBHnWuPG1p382jw
239	payment	1397	1397	1678	1	1	229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD7deUyZ7BURt7PLoPfHrpMBCtJFpkBH7GdMrKVgrsAZM5bcX
240	payment	1397	1397	1678	1	1	230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUHvpy1ChtzbbmLxV9REv7gCUmAvh5LxoE4arKHqfYKursMWL
241	payment	1397	1397	1678	1	1	231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQNiLZPEktuRXgwJ2nQ1cz61V5BHC3eB3owo2MosQh8coufi6
242	payment	1397	1397	1678	1	1	232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLmRupGshUAkH8CwHNmcQWQtho8kNxQGYkf7vCZSHikkdbUSB
243	payment	1397	1397	1678	1	1	233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFNgAmmo2s3eUj2hG6rC7gd8y6Nsw8x74fg3RsW3e9kogxmX4
244	payment	1397	1397	1678	1	1	234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFpRwag1WDzM4GX5AhGNNUQ1VAvKrJsG6tQpXfo6KU3ED4D5h
245	payment	1397	1397	1678	1	1	235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLcdfAsCHCR2DVvpwnV7q5y6tgWdDAe9TLhmZEXzkPbwmTyGJ
246	payment	1397	1397	1678	1	1	236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZwGNq8uxKyRUN8Qse8zdwnqrHpmLpdDKbmjCpv4pcoRbA2Bo
247	payment	1397	1397	1678	1	1	237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfjzpeRi5NK8wNbuyXriQK7kaNrC9ft1DsiyvSQMMq51AcBF3
248	payment	1397	1397	1678	1	1	238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhokrk31N7HvWXme2e4mnbaCMZAjHVxNYnGX5BYQPDn5Gz5rKa
249	payment	1397	1397	1678	1	1	239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSzJBxK4EG6zdL1ZD5vXwNWHD9xChAxobvWEUUnrULutRwu9z
250	payment	1397	1397	1678	1	1	240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNMubuyjf1d2TaKcGd7Bc5cqYSQhGP9Wmn4mwYCMHyUb6SgmS
251	payment	1397	1397	1678	1	1	241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33v8hpMY5TfaaPhgXuntLW9xMEdD6JaVAgzVRdxQ4yfE7ppVz
252	payment	1397	1397	1678	1	1	242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7M9L6voCbyKWX89ML82r3WcEjqUxDjtH8QwE4Jjd8t2CtUUf6
253	payment	1397	1397	1678	1	1	243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMGzjH8EwFtowcnsGsqQtKCpL1sNbZVkbUMsNFuPzQji8KHD9
254	payment	1397	1397	1678	1	1	244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kznixMvu3Qfqrti57dVnF3cVznEkzsVYK13MzCUiy4wzBoFh
255	payment	1397	1397	1678	1	1	245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2prJkQoxXsqqwRXcTc7DLcEGb2EJajfg6nLp5efzox1T8x4V
256	payment	1397	1397	1678	1	1	246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6qiC5chocYnKq1m41KpgjdAb1mFKHP4CygGBiLhvAJ34J7hT
257	payment	1397	1397	1678	1	1	247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3eAkvFEWhGKpq8keTUsSUHMZRoionKZghMrY1hyjQTb8RkTG
258	payment	1397	1397	1678	1	1	248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SepNDX1gipH1kwW3vRsagx1w4j1T5zSgbhvstS9Dg21DTjxg
259	payment	1504	1504	1697	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxCQvjBPTu6oYcqfP9aXmPMd8C37zcbQiwwok2yWXgjvbZD7W
260	payment	1397	1397	1678	1	1	249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMS69xA39gi8k9vKc2eXVR9jKeBaM22He4AoYgm9GQVeZiap7G
261	payment	1397	1397	1678	1	1	250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6eAsNsF1Xx3MAMyVEwtFZFoxUfHGicFyJdj1SFNYhhDKGC5p
262	payment	1397	1397	1678	1	1	251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRaPVu7FgDQgCw3XR6mmc11VwWTvo3NQW2Ba9JwqyGQW2iCtY
263	payment	1504	1504	1697	1	1	3	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzBGiJU7fqQHRgZUedsMjFLi2UdiE2Ba93TJc6RN5aiSaqxg5
264	payment	1397	1397	1678	1	1	252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2MAheVz4TWK2ZVgG9cKQ1c4yYGHazv2UskPrBfGXNzVCKKQB
265	payment	1397	1397	1678	1	1	253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pf8VwdaZVUxAZU7tMA24Z4uaGfg2yEi5FXB1YMqGt3A3McYE
266	payment	1397	1397	1678	1	1	254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzAbQb6ypQPAkv2qtMW2LQKCobKosHSMEV9SWZmCLXETCjfFX
267	payment	1397	1397	1678	1	1	255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggpJENWTSBawBnWQQp5FJ9zs7VxQZMuNGeW3VE1b6HTv2LQ8v
268	payment	1504	1504	1697	1	1	4	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2MyeMEgLus5ih9s8opge2icEmaL2CSuDNp2mSoftoYrxYqDo
269	payment	1397	1397	1678	1	1	256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NESycoeXu4NGEUEreTVgSxo2h5uKcUWsSdVW1vCnJJS9XPTN
293	payment	1397	1397	1678	1	1	278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbpEra4KQsC5qrytdkgf6nukDSJwGFdNv93ZsUErjU7dwN4MD
301	payment	1397	1397	1678	1	1	285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwvq9gip5v7H4avsFZ2pPogDzdwoJNkxn2nUbm1GMjZ7GBCLr
306	delegation	1682	1682	1503	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hnAeKSC8KwB4WbZRWqgJgs9jquv1nyKf2B3Pr1j2z4eZwffP
307	payment	1397	1397	1678	1	1	288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXerTJJ5pGqbBAVnU8LjFg3WVT1G24h4s2c7TR6miw1T8MDET
308	payment	1397	1397	1678	1	1	289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUStN5DU4tbLJPfkB2fjTDmEqu8AMPDY6CP9GkcFcHeYNLbdY
312	delegation	622	622	1503	1	1	0	\N	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18U31pDTuBMcFgNMgAoBREiBo5ADpXS6S32nkhhTEEn53RUfi
313	payment	1397	1397	1678	1	1	292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpezahNjHV7EY4S9RuzC2oSdPK6DdjcJ3j5Zc9htTf2KLavgvo
314	payment	1397	1397	1678	1	1	293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxC8s8cjWG94yxQCMi1eW9BDgwFFHG4RXdXUbmYnKXiiv2arC
315	payment	1397	1397	1678	1	1	294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5Hfbq1nDNRkyv6pkM97zoh8HpQjrjixzGvqQKD7zo6LZC2hz
270	payment	1397	1397	1678	1	1	257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeXZ8qHQHfEEkahVYk8mg2zEFgg9qgh7NffmkmCU1X3SrdUEQ
271	payment	1397	1397	1678	1	1	258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWoy2PdujeXJrsFgKjRLwBfq3DtPxs3w66uSxRSwVrDThMvWZ
277	payment	1397	1397	1678	1	1	263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymoufAu5CgkypzieDPD1t1GghAtsKSrDk2FWELLrMfhNJDqAW
278	payment	1504	1504	1697	1	1	5	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwY7tBbnqFZVXVz8EEyb7KRCVnY8hGJybFQs5gXuUH99x7AZ1
280	payment	1397	1397	1678	1	1	265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEY2dy4yr7Jcp8BfLSJgDD79Ekmqp9FrTdKGXBiFKxea1TomAg
281	payment	1397	1397	1678	1	1	266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNv7W7nGFCXc8yHLig62QwXnszvtMYttA8PqZx8ktcykLCJPJ
287	payment	1397	1397	1678	1	1	272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrs2mi4q8A2iDGVS1pVG2pEjSKUFyuZHFdByVb9XX3bM2p7mdY
289	payment	1397	1397	1678	1	1	274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6L3eDVsAH6uVCBoS5HT9aTiM7rUmD8d5Y4aN1wKSuUq5jx4fG
290	payment	1397	1397	1678	1	1	275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Euq6YgzfoLqvir4z7Bkt5crcEa44BRx4MyH93PmG7em5RMno
296	payment	1397	1397	1678	1	1	281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FMAuVz3pawnddKzsqn9gXPQUJFdfyiycSN5m8MCxDE88azZb
302	payment	1397	1397	1678	1	1	286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNCQaXiswMue3SDsu3QHx38ax9FbNnmNFgfwqG3eFAb5g6soj
303	payment	1613	1613	1720	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZVuED65TLTGtdydZdtvUw4Bwzs2FmCYmj6CjNrDRGtbkP7ME
304	payment	1613	1613	1721	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkziPAjzEU2AsuRBCVRHz2UDgb1f1Y7CZ3XApXLpfcqgJ2pPY2
272	delegation	1695	1695	152	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsBVvTWjHKPXgxJF5L8foTHDj9rHrkNdH8TZexaCn2vsB5eRY
273	payment	1397	1397	1678	1	1	259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcWt5orCzAPeLGh24goiHy7at8WJidLey6daJ3xi3yv2ZZQqZ
274	payment	1397	1397	1678	1	1	260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5dcVUzCXKQeWYKVLmKyHMHvLJNidVxtKpVRzPQoccrYg3Cw8
275	payment	1397	1397	1678	1	1	261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsLwYwE4ZyVNHbforY7ujSBMBWcKHPLF3fDrhnvMKH9M9vScW
276	payment	1397	1397	1678	1	1	262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuthnGFmTrVnjaCtD6UCrsSPTVqKtEtqSDBjbaLx71Bd5ktAfN
279	payment	1397	1397	1678	1	1	264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimcFKFHR3VVVJ312cQjrLNBDrmxSSoCUn4CpkzuNJS3w1Ns9e
282	payment	1397	1397	1678	1	1	267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCAaVxooVuawvxdwTr6simxucGhCCyuqjdKdizYWp6d6tyHAZ
283	payment	1397	1397	1678	1	1	268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabAa7h7yyPK4VFsQPcfiXc4nB9pFU6HibLEj6iq22B7AZCTtL
284	payment	1397	1397	1678	1	1	269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapNZ9MAzzw23NxdWcdHv4CzghWopayqwnCrJYXQFwwYRHsbzN
285	payment	1397	1397	1678	1	1	270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6r8NBsnTf4hfDgXN8nN6rHR48VZdimcsrRVQMAhnMExDpR3o
286	payment	1397	1397	1678	1	1	271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf9816DevTVTwYjnrpWAMax4wUNKCdk8kSG5TP4Xj8iGhNnxD
288	payment	1397	1397	1678	1	1	273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPqCc5DRtyPQP2YLZZK6KAu8J4yqEQ9YkwhE1wWS1mUvxWTyU
291	payment	1397	1397	1678	1	1	276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhXy9iHjqvi2cCnqUdrz3mhSG4CLijv84QKFZThfBQutHMouE
292	payment	1397	1397	1678	1	1	277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5rxpmX8XegRUF5316b7ZFCLfosMRErw3dQt98Gr4YpZALvSL
294	payment	1397	1397	1678	1	1	279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9me4MsPwy2kznrsLRXHEj9Rj1vjTkusHhCwcGtCWpHQYNnDz
295	payment	1397	1397	1678	1	1	280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeG7q7SrjbF5dtJ2UygvLAzh1NVwqMhgTdyFDUtwTAB42A3nEh
297	payment	1397	1397	1678	1	1	282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTfgsufgiTDFbDZ2bhL22gxF3gGch61J5jP629THvxD5QTY3j
298	payment	1397	1397	1678	1	1	283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfdUSAmsXNrThedYSGUoVHDZJE1Wr14EUscQFaWE2dcnjAqdR
299	payment	1504	1504	1697	1	1	6	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd97kuQP6j2E39kTxEWqUjPEah1eUtS5C11TwgaFomUvgo5tuF
300	payment	1397	1397	1678	1	1	284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2sFbFa35ReJ7ZctZPUQUJ856GBnT47XBbEAf7J2rprZsztxu
305	payment	1397	1397	1678	1	1	287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYye2Ube7YfVUfrTXQ2LMvmp5qciDq5VXhcHfrJfFq3N5PEU8XZ
309	payment	1682	1682	622	1	1	2	2000000000	10000000	\N	E4Yf92G48v8FApR4EWQq3iKb2vZkHHxZHPaZ73NQNBXmHeXNzHHSp	CkpYmzGMKR2PbUgSUjSQn83Hyif6cro16ns4ePq8PpEycAtXKNqco
310	payment	1397	1397	1678	1	1	290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHPKLegzQ86sSKYbCGATPWHZkafpMzeBRLNeyJCAJfGDomzra
311	payment	1397	1397	1678	1	1	291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZja4Wa1dX5t24YJSC1h47y6TUEkKDqMwA1cbV7eDZxuzgLfupD
316	payment	1397	1397	1678	1	1	295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAykJjDfrVXCRou7grESsKmjs1CiBfatySKrJ5dsW1fJSTRaS1
317	payment	1397	1397	1678	1	1	296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegKKNj9SsA6uhKxNAsN6BwbYxBQikkhDkgNKKJhcirNwnvhtW
318	payment	1397	1397	1678	1	1	297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JhJYYgg8tFEQiHEvcL4cJX9JhdZkr1x2FQaiBQSA4t2jwS6P
319	payment	1682	1682	622	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vko1yZiobznkVvBXkWEYad9yykQnQjDDYh1SUfJiZFei33bK
320	payment	1397	1397	1678	1	1	298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmv8LJPmTZJhrYxuKtaPE1sXUUXB4Ppgt889iGissasuxrzzV
321	payment	1397	1397	1678	1	1	299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQYcqojorhFDJPLndi8dDDTwj7mHxYrZUGQL6YmnMUTWBLJHi
322	payment	1397	1397	1678	1	1	300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ovcifeFxJXVK5aETA3RvVogwnVt1UyWRfAQbthQT976FUH8N
323	payment	1397	1397	1678	1	1	301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8qrRc1fKuREUFmgx9vPbKPcw99dabTyLKjNsQR136ZaUsGsC
324	payment	1397	1397	1678	1	1	302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTNeA1QmHHkByQhCNmJMbvmLya1QhZPKUHujfVPvECcFYcf2H
325	payment	1397	1397	1678	1	1	303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7dX8aUi2MNmRhREkb374UVbQTiqZdLWnTwEwMWLSyAt8oZy1j
326	delegation	1710	1710	1507	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYYKbnbPbQAPMwKEkV581ZZFDnrRLYXxjpVnfzXkbX5k88CQE
327	payment	1397	1397	1678	1	1	304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5u1netoBqe1y1s8qNgNzdXqrSVrhDPXMpXcL2wV15uypsSwmg
328	payment	1397	1397	1678	1	1	305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFozVfFgGYcmnxsB8ktcq72XwwoxeBySvvExTzK9Ak1A6aSujn
329	payment	1397	1397	1678	1	1	306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWhXeTk5sBPik9szRLPk8ec4FNzgX87RU8i7eHQyvAJCj3Nik
330	payment	1397	1397	1678	1	1	307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJgXWwqwJGiweiLc35T8EAcUFz2NSucm8MYreuByZTHnc5yEQ
336	payment	1397	1397	1678	1	1	311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTPHbyhzypzZ1mot1RbVDXjEcDbV8d4yyjLA93mKtk7Z9HXCW
338	payment	1397	1397	1678	1	1	313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcgTsDPfHuoFqtrmhh9fxkRXDV4VTvsnexF4RjuRau1YRsDKA
339	payment	1397	1397	1678	1	1	314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVa3uKaEKkj4LXZyTbZVYXvuqsarPcz29Ttb91k7GPeyXaPXi4
340	payment	1624	1624	1722	1	1	0	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULiQbik7FciQejqPwiuPQnSC9H7cqet7M6MnxocPApzzxRWmB
341	payment	1577	1577	1722	1	1	0	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvznVMVSKJFgmmDtCXxVoenseDbZQRboeu8h9oxjULJb76WFa
342	payment	1652	1652	1722	1	1	2	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZrhDBYygq9TVcytJ3KgujeXzgq4y7Jei7Reg3QergXiwVm8U
350	payment	1397	1397	1678	1	1	321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQD6UBhDfvk2uPp6nF3BwjGEDh7iHEXY9b81n3WPhqFf6jyvEB
351	payment	1397	1397	1678	1	1	322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWYeBjTejthck3eegFcCsdMpnsY2rYWn4QCuuPRD6vnKav1xa
363	payment	1397	1397	1678	1	1	333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPfc8fMQF8KadKobt1jdfgHZjgzvt1Z7vtWSPDTMcjmXkp1cb
365	payment	1397	1397	1678	1	1	335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMerX7YLmvBBJQhGAZAFTagE31ZoTpbJjkX9TnMx8RJsaXYP3Q
366	payment	1397	1397	1678	1	1	336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiW1SB3x3PD4pJw6TGxfUNhh2HAHgEwo6o9JLiaxjEpPCDwer
379	payment	1397	1397	1678	1	1	345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2M7FqgPQXBtsmTQjthsEwWyvk5oCBpGhnJnFFc7nsqyYiX6M2
382	payment	1397	1397	1678	1	1	348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDjER7QFyZohmJkPJBW4ZSjyyxMwirkxk55wVFUcvYT6XH5aH
383	payment	1693	1693	379	1	1	4	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYUEBUFK4CQhLXeFB1r6B6eEM94Ejt4aHAyDmHNcarzBMjpTJKR
384	payment	1397	1397	1678	1	1	349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaTFENdC2PtZLM8AJsCBztfCMTUEog6LmBGzgeVCm1DYyrcop
387	payment	1397	1397	1678	1	1	352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NaUpUSBcMxjK3MAYrDYQU2e8HRypYSfSHLG3XSiU1TnUbuze
388	payment	1397	1397	1678	1	1	353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnaBgCTxkaGwNHdYUa26ShshZuSm8S9GYk5pibypLCLmhrXWd7
389	payment	1701	1701	281	1	1	1	300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy3jttA5davJ4zRWE7EbmWbtXyedXtmjxpecbZBQH7NpFQZ49
393	payment	1397	1397	1678	1	1	356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qgtQs9Bktrfja8uYtjtY4H67Tfqdfmy1P2kVSxBCyHR2ePtT
397	payment	1397	1397	1678	1	1	360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rA4UnXDrHW847eiC6HLLVK1PWMXa6NfcHDMJ5LVLtFXSLsi5
331	payment	1397	1397	1678	1	1	308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6GFiEAkgHqj3bMxmwo45t8Dwcjj9Vf5j26AKA59bQzKKp3B6
332	payment	1397	1397	1678	1	1	309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8z5ns5dhpjR9YEn6SqM3N1Y8J4J3ijfhnD1ct6FxLGsMsxVT
333	payment	1652	1652	1722	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpLWuj3ojxcEkzPDxwGSQP6Fz9Wp22FcCBgU4kVYxSycNkJTR
334	payment	1652	1652	443	1	1	1	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7z9T46ZyzjoSrktUsDbghpdYog6eT9yYLW7KVvxt9RdWGPWse
337	payment	1397	1397	1678	1	1	312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKkyikhaBStZTYbAX3Tev6sHMmchw2X1jRTr6ugQwWXekjWKS
348	payment	1397	1397	1678	1	1	319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhoL9X131fLxZz3nLNiaaupLcZWbDtEyBUYGymvLcKsK6KpGi
349	payment	1397	1397	1678	1	1	320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNWVMFcXz8Yi3k1tHwUtrVSpbr9i5brTizC2M4H5o6ANkqi1X
370	payment	1397	1397	1678	1	1	340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ29YL1mKLFwEFcSwTaG8gTEPL8Tycmf7X8B1aPQTQjupdwGbEu
371	payment	1397	1397	1678	1	1	341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4W3nZmZL2a91z3VwsMpZt6F4WyZtBPkTucrjQpbd6EGMh3i1z
372	payment	1693	1693	1725	1	1	0	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZZioVQcGArFwD2mhBSJbnAnhZG2d2CVHTeGdYJkQGDxs2DsFwi
373	payment	1693	1693	1726	1	1	1	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYYvXJCsVgLsb4KLsk8f58BbndZ6nxkY98VEa7cvSdGBZvZxpAn
374	payment	1397	1397	1678	1	1	342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkLYrsfbr6oz54VL6QGkQHVE8bZEo6hukYF5gnGNghcVQsEQJ
378	payment	1397	1397	1678	1	1	344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmac7V1PnitQL4GuUyxbcbYfMf4ku7qZutSqW8jndk5WmXBSsA
381	payment	1397	1397	1678	1	1	347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGE4etk1J1WzEnNpKzyokBBssxhEh8QXtaZsTyDmMFnFPEmwt
385	payment	1397	1397	1678	1	1	350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfjenx3JrkhF4tmbbVD9ykFnqRMg2d69iRizPSZsBDgdTHr13
392	payment	1397	1397	1678	1	1	355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJEbuMshdXYXCbuJ4vc3KgL6znmMr4NNp3VNtnyavTXq1JCSJ
335	payment	1397	1397	1678	1	1	310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18z7ep7ATNcHqmGM2eCwpoSxCfz2xXPpAoJ9xHR7uiDGbtCVd
343	payment	1397	1397	1678	1	1	315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcvAV5fdsTeKT2Khv6i698ZSkSfcTCtCdY7RvLJ29mkHRL1Ur
344	payment	1397	1397	1678	1	1	316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYX2FTPG35qLnCKsVdU5AgrHUvAuh5Q6BP8nMb9sBYsR7vuvrk
345	delegation	1722	1722	1652	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFc2yiX11v1GUeZCWiCGhfAaHqqEntvD6o3E9yGdBRjrWZTW2S
346	payment	1397	1397	1678	1	1	317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCq5PPFBkBQXXGeu828vSZBrcRCqpJzSXz6jGjYhe2zdPntq5
347	payment	1397	1397	1678	1	1	318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bgFNJU3NzN67aTgVb8cbgcMv7JLt7bRTcNcwb3n88CyAmPFw
352	payment	1397	1397	1678	1	1	323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetgHvhB1UZGuvyrNPnfu92dnpUVcw8qvpvfiZz1VXkSf6JTKf
353	payment	1397	1397	1678	1	1	324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtiogHrgRAeTT2EZoyP7kgQmS8LBTEREbhyiQ5HHUScrkXHkF
354	payment	1397	1397	1678	1	1	325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGNiQdcq8iTMy1XEesC7QtFBMzBRQPWhJHa2MGDUK8gMn3p7R
355	payment	1397	1397	1678	1	1	326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dmSRB6b4oeyrht3emNS8CWLHGAQdoZ9UW1t9JcucoacTFznR
356	payment	1397	1397	1678	1	1	327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjzfGX3EUpCfeag2xsWiPQUxDW9JZYNCJi8bNJyGcvwQU24cd
357	payment	1397	1397	1678	1	1	328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBnrZY6oAWyENSVNLh5YPPW33W7WQutRphD65zPffqL7MvjqM
358	payment	1397	1397	1678	1	1	329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AAQ12tQ23SYJvDs69TnCoGyu83nBMVtintTRYUZhwqtLouSt
359	payment	1397	1397	1678	1	1	330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbNjCNp3Hnwp74cqm2nwCYan2z97zMBDnQH5CZD7wt4xHGsmB
360	delegation	443	443	1652	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa35FutJNMUZ8LxFgvYeSYriiq1cHx9cZNvsqtFMNvmaoTattH
361	payment	1397	1397	1678	1	1	331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtAs9jqd8wr7SBd1ykGc1GvPFRJVR4cvrQnYmz9bHuCx4SDKw
362	payment	1397	1397	1678	1	1	332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgEJsd3Q9MLVrPt7xQZkQBYmD2jZ7HBKbnYMTt3gU1st62CVu
364	payment	1397	1397	1678	1	1	334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfLyLF5sihRUs7vW3kQt2kqAuTHQmk4gM8DjBJjpRVKAPTqTN
367	payment	1397	1397	1678	1	1	337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsVyzCv7Z2JLuAKVHeXBpyA8HMNmGYgGa8MP3k8NJRnHtG2AA
368	payment	1397	1397	1678	1	1	338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3Gp1jpzidR9DVneWz4XNNZWdiJ9ZjZejd6Bmo86CctgbqcYt
369	payment	1397	1397	1678	1	1	339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TyWCBA9Q5ChGoKNBcuoUvWycdqZ44AHZ1kbobDfTjiiRxxiC
375	payment	1693	1693	578	1	1	2	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYbdSPmcEQ37vL6AGtpvDPmKuaSZLz6VzcK9y6qr8XeAytL5a1E
376	payment	1693	1693	394	1	1	3	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZ7v1o2P4D5zG73bqYtp5xBjXhhnepTok6tpbWMbTG858TZ2TKk
377	payment	1397	1397	1678	1	1	343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmgVdh34Pcw9AC9i2X4Epo99NcADVPCY6ACgDT7QzsQYaZ1y5
380	payment	1397	1397	1678	1	1	346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJXr1UAFEDqLtKNYm7eCYnycD89HuPngyHV9w53F2R7AHETi5
386	payment	1397	1397	1678	1	1	351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgv9QJQigvrdd3kcgEBhXdtMJohB5UH26KTzJpMraQoKEazBg
390	payment	1397	1397	1678	1	1	354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLDnmpnxsMnmHwXck5DNhCRXa4UJyKJGhFZnYeF6jjuEzqob2
391	delegation	379	379	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpwQD1yxFP4g3jaivdKfreZigYiJN8G5W38yeHqTZPTPmzm2a
394	payment	1397	1397	1678	1	1	357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoVePuqT4uTWE8t2b1wGfVWB3W2PoMEYpmPD8Gk6s2zcxob6e
395	payment	1397	1397	1678	1	1	358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1QoQgNHfUCDTLiLXS913BCw8rLgbDwiaZXp9aMW1LRXo21gH
396	payment	1397	1397	1678	1	1	359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHirbCcoGDwawEQ7cRU2kb8tjArNUKAaKpJVS35YvpcykgD1CP
398	payment	1397	1397	1678	1	1	361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8R6TgCz6iwqHrFoANyb7DtUBqhu9zeddwLXgwvdrhupoD18K
399	payment	1397	1397	1678	1	1	362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaBXE22qts82De4ZqmmPMZ49HtxoSyjU2LAY2y7mC899sdjqk
400	payment	1397	1397	1678	1	1	363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyBLwJGqz8RjZonKyiG7HhzKksnqWyQ8HBA3oX1e8Xdr8Z1Kn
401	payment	1397	1397	1678	1	1	364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPq4YB8redmazHwciawzYW9TbX5wAAU3HeS1ytUMSy6TBweCJQ
402	payment	1397	1397	1678	1	1	365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvgAMh7rEffW9eB6A8qvRqiEPEWd2LSPoBJMhFh7EPuKG6Ztq
403	payment	1397	1397	1678	1	1	366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbr9xZoUru58LHhBTgpgYruPij3YovWSJigewtxmt2y7V1Dzb2
404	payment	1397	1397	1678	1	1	367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMpoJuxTzc5m5EcfvRD5pmgNabpUwjDyMztHWB2rkt5TzkAdq
405	payment	1397	1397	1678	1	1	368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9zrNzY8m3pmPyA4GyVeh5sCeY33hfxcutbSMutAEasr8R88U
406	payment	1397	1397	1678	1	1	369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8DaEnPUquj4UtSM7cqRvwhNZsdzZfUg1DEeoGxYxCevhe4eU
407	payment	1397	1397	1678	1	1	370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SdpdEAojfNuQ29kcXgPiFMi7WWp7rZFFP9hmtG7MZHd2BSJ1
408	payment	1397	1397	1678	1	1	371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfNE92Yp5tzJ6HtJHZk3Q4J1uGkwKyNz9eLtHKzfbDxhzTVmc
409	payment	1397	1397	1678	1	1	372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKuSqnnRbWDrSLp2dVpwKPUx7D23eN4KXZKGwd9JynuwoY6UhQ
411	payment	1397	1397	1678	1	1	374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsMkfgkRhftoCkqxxYAuh354Yw3fP93GbkABt5Bm8zk6FUzv2
412	payment	1397	1397	1678	1	1	375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hs7NEc4AzaraRC2DA6qQ2mMwgzMu6K6CMcYX6qCb2tqLuEqX
413	payment	1397	1397	1678	1	1	376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yWPY82C9C6LXEsGuZWVomvt9nNTdyPSJ5LQ6dSYYn8aaCWhv
420	payment	1397	1397	1678	1	1	381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBReVwj1nBBynBHT5FZUoYLfm8PK7Fi5bL9adUNSHUwTQxmn6p
425	payment	1397	1397	1678	1	1	386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCKoQtqjnsMGU8vrduWysQQjWniWh2esw5XJCHVBcjVnwtnnc
431	payment	1397	1397	1678	1	1	392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtN7ab7wUc2q3C6MsanJy5FoNiSRcVkyM6Le94E9zBUZ9VWZxb
432	payment	1397	1397	1678	1	1	393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZah5ZyWmpHBjJMFBgFAyL6ERCJorYw4SkmZdqVyqHEjDCB1kue
433	payment	1397	1397	1678	1	1	394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxWvA5EpLrzrEGAgTYhHeFMSVzGK8usFRmWR66vinikedjg2R
434	payment	1712	1712	1730	1	1	1	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCi7RCYt4sgbf1DDjyq9V1qiLkxFEK6uqorRkiiTiNPYQ2CQQ
456	payment	1397	1397	1678	1	1	414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fjszommkQUarGhyLp842sV7zZFjEnfQDXLugrq7ytzgj6dRu
457	payment	1397	1397	1678	1	1	415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyv1FvhvfK1xaWRMxPAfvfjRzfX4BHurb6MtmQUMcVaEYQ1Df
468	payment	1397	1397	1678	1	1	424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7MGZ7aJHbdvZDoek3JV8cbPHEhjTkPVqrNpeZvgh6oXZHkzg
472	payment	1397	1397	1678	1	1	427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpZekQFJUN6bFCsy2fdKwMM9iSBpKGCcDjVEo6V9CegUKoMvS
473	payment	1397	1397	1678	1	1	428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeY348xeRTqFw4iDgxTHfQ6VtNuoSwf6QytTXkSiU8iHRL3oXQ
476	payment	1397	1397	1678	1	1	431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcyCM2xKewNuTbN2DFCwjni4euPyCuuGaNmbMP3rHCKMMHg1Wy
478	payment	1397	1397	1678	1	1	433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptriBwRmYmiz5YygNmcw2djH5TnztkhfJwq889hf9XKeLL5pj
482	payment	1397	1397	1678	1	1	436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTxLpuPgxnRUozPg648USnKu7vuWchWFvdhEapAtE364tzAMU
483	payment	1397	1397	1678	1	1	437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuEjBjvcj184TQiaF3EWQpDo5xyVvy8SD8RnpZzQmnx27rCT8
410	payment	1397	1397	1678	1	1	373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiW7XAvBFsRX4NASu65MFKBQ4FmqZCrzB7BuEMTJc5UqMtVrka
414	payment	1397	1397	1678	1	1	377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Q286Akomwkq9LtenjYhxCf5xymbtHMVNDHz7kTwYBVEqH85a
415	delegation	1699	1699	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTrLM2hz7uPJ34adaTf5r2ZEkT3RAXfPzDqvDyjp7bvhBWaxt
416	payment	1686	1686	1728	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZgoGs8GsJsLwHiHrqx9xrdV7kGiHL6kvnNoyFCVnrZMd7AK1
417	payment	1397	1397	1678	1	1	378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfvUcBBJj4GTSQ8VahqkSodnWdh1s5PVHfUsozpTwUXhzhydL
418	payment	1397	1397	1678	1	1	379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkNpkUk4zNvfEdrjjt8qtk4z5pbM2QJnz3jsHJc6RrT8d14d1
419	payment	1397	1397	1678	1	1	380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzVcW8c8ydKrZ3Qk9qYbXqWbF2dxAY6tRvqZfx3D562rDCvXy
421	payment	1397	1397	1678	1	1	382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSoqsWGVTqiK7sqc5yeTEYjZoh5YZf3nn8gCFUf3VYRUpfjHab
422	payment	1397	1397	1678	1	1	383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwGDejFG2Tg778wPeHHzx6S5WCSGF793JppCHfbGE2Ua1pQxu
423	payment	1397	1397	1678	1	1	384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCak6TZXtxJwJTXtBVna3wDEzKKCScqQL5vWDsvrXoBxiiDqr
424	payment	1397	1397	1678	1	1	385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAi27gNFWvpfpR1TV9wG3j3DY99Pc3LPJsE21P2As5Wszfz17
426	payment	1397	1397	1678	1	1	387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswvfVV7vFBk2crceTtNajvewXLuqf1SZ4VXsSxyQBpAixSz4D
427	payment	1397	1397	1678	1	1	388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GhSBYKzNCtuVDSQoBijdqXBRNxENXqXuk2okfd51yjpJG6qU
428	payment	1397	1397	1678	1	1	389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvo6cUMEK8bAX1YchEAAAZQB4ASGu92iPsrzo6HE7XNTkKLby
429	payment	1397	1397	1678	1	1	390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YaGCPZ3UY6DsC2V1awqzFu8yKRXzu7a7wiSehYEniL7tjFoN
430	payment	1397	1397	1678	1	1	391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HLNdRx3kAgqAQjqfHjB5axbCunQNFrMoCfDowbdxjx6M9rKr
435	payment	1397	1397	1678	1	1	395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa8TksoZ35z7Ucg8AjkxdTQtZydLdRHciS8s2NQoT4qFfYzMW9
436	payment	1397	1397	1678	1	1	396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPsBKsvH9Vu9HVcLiNbLgd5XNVLH8a5xv5uWARZktuFwb8grF
437	payment	1397	1397	1678	1	1	397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbCYWeKoXLK3DZGgym5s2fY2ryGpCooHtYXmiLWjNEd6AoT3p
438	payment	1397	1397	1678	1	1	398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dJGh5A2KZy4L1YLuZMs4XyY68FyBuNjBjd8MHjLCYokJqEUL
439	payment	1397	1397	1678	1	1	399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvJfWQ3ZBV6aohhc5NWnhypXLNChMk9iE2sFJrKeZLyzo2S1B
440	payment	1712	1712	1731	1	1	2	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRnYTeTbDwx5o8CF23BA2MdnM2ccFkvkvXyN7k5dAQERWZxBZ
441	payment	1712	1712	1732	1	1	3	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc243YbE82DAxVBhcwLyitauU5Z8QnYAkvhYtwTRdxe49wdhe4
442	payment	1397	1397	1678	1	1	400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmMjeyeeuAjGfpxbDZiDtyAFCuXt6gHN27VNdpiYfacxoELYm
443	payment	1397	1397	1678	1	1	401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13pZ7MgSZ8cGatvd7bZJoTDrjXpvXsU5w2E3WWDMpAM4bnjuW
444	payment	1397	1397	1678	1	1	402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwF4pyDkH62W9zPg7CqfBD2wUeiJb682tZUKgg22X8hNNGaSRq
445	payment	1397	1397	1678	1	1	403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBp86cUbsy4Yeuwb7PApVqSPymhtVrHneTvFt8w7i683gZwZT
446	payment	1397	1397	1678	1	1	404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDi3a1kMP1d3UgNddTzY64pHCt3gQ3ueuJUZR6u98G6rbefETi
447	payment	1397	1397	1678	1	1	405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1a7vcsBqp9oCAG4cAveHoTo6bBgAwn4NGsszBRRgUk7QccdkG
448	payment	1397	1397	1678	1	1	406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqGMQxyQ8zvR5ou5C4JJXDrnPgYviCsCg9r2Y5t94sbifQwu4
449	payment	1397	1397	1678	1	1	407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgcHP27LFscCxGdDpaSGNfheaUR7Vp3aqkmbPm1gSCSnesmuL
450	payment	1397	1397	1678	1	1	408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gP6H1AnJawRqdqd4ei4TkMtsNqi757xu4atYQvCTF2E14hzG
451	payment	1397	1397	1678	1	1	409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2WBprEYphUp7bf3U3dxwt69eaW8fiKkh2ABVmvvaUBo6z4bu
452	payment	1397	1397	1678	1	1	410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagJd6Vn9CANCoeS8cjw1zEhZReFYKAcSYwcsqxBz7Xspv4Cp3
453	payment	1397	1397	1678	1	1	411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCX6k4xuei4ViZVSWecDJTQDG6Sj6vGCFE7nUw4kdCDN1t9d4R
454	payment	1397	1397	1678	1	1	412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHA4mR3bxujVDMzAD1HCCnKFg628Sn78BLVrNosZAUiF1okRF1
455	payment	1397	1397	1678	1	1	413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5RRhTiGWVS4Mj2y4UMnZM4VmnQ2hS84FwjS4WANrNWU9MVTm
458	payment	1701	1701	885	1	1	2	300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34SUD5QP9C9JJg6cBycawBZFCNZifD71PKE7hQJaHy57fBws9
459	payment	1701	1701	886	1	1	3	300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Vm9pR4Wz39Xtjpn9JimDwvtRn6kGgufKxD9AAPbDcs31H6Wu
460	payment	1397	1397	1678	1	1	416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvtV5ATQzJQAiCDX3i9cJMK8dAGJk1XDcDZzNuLwojQXNr5jQ
461	payment	1397	1397	1678	1	1	417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEuGiqd46WEw7tLLgq1PxbRwJfxwxtwo1X7WaFteNaiBfYfBY
462	payment	1397	1397	1678	1	1	418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQmHWwgbbaeLrcY4U3hmtyuUDW7GkJas2MF4zFWmjr8Be9UhX
469	payment	1397	1397	1678	1	1	425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8D1yB3EgQw4Voq9iDQ1MUr6C38njj9yzentNtGBNM2jAV8zoB
470	payment	1397	1397	1678	1	1	426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsa8LhsLt6YHA7dp4RVGsz25kgywRtWKB7PkVPCKmrHUVPFQHt
471	payment	1712	1712	1734	1	1	4	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtojnrRAZPFasJx22uyuWrK39atp16wac6S3FXXZkY3a8ZL7zD
475	payment	1397	1397	1678	1	1	430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYfQGNWABT2ddr5iEV3hhXfUMmQc52ccp1ZRgHtBSdwpzH2D1S
479	payment	1397	1397	1678	1	1	434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1A7vB8LwCTNnnc2oWx8xfK88pVhpA6J85H5gYtzZrRGFq1NU
480	delegation	1725	1725	1726	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4w8cvkJXxsUw2pp73oa1cEg6kW9bsdZX1HeVEwjziCJDmirE
481	payment	1397	1397	1678	1	1	435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQ4LVY3JQHysr2q9TEobtUHydRZaGVw5CfqVMgKdJ6zK5DwSA
484	payment	1397	1397	1678	1	1	438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUFn87toPLZPjWvsQi1QYe4j3RXqAJ3WqppVC1faB1rdnusz1
485	payment	1397	1397	1678	1	1	439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GoiN9ujmsQhqC8TjjhFcgjN5VWUo9Qiaw5ho9tRM4zvahK3J
486	payment	1397	1397	1678	1	1	440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNnTrp5jijU8iGXLygbtmRH7cFZijohTdsmoe1UvSYWKvuX3w
463	payment	1397	1397	1678	1	1	419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDJ2ADwF4X57XdRev1djD39xZQ8UkPvRqpdHKTrT6dx1ELtq8
464	payment	1397	1397	1678	1	1	420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp43r2maQxQ2RWqw4pLD2fvKmiKCZppbKzFM7FjGduPXN7L6wM
465	payment	1397	1397	1678	1	1	421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxm8RsRwNWCH4WZMqeoJRUufa21Yak1ZfKJ6CPETBfgXG9GpS
466	payment	1397	1397	1678	1	1	422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JwFJvNCTsCDHZnXcd3f1skqw5eV3vm8PrYd6WrGYi4xmWFMT
467	payment	1397	1397	1678	1	1	423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qWLQZzG2PraGeDCXQTP1s8iWXuhj3cvfPrhBvkGPNzsbNcXu
474	payment	1397	1397	1678	1	1	429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmrxSWqMbRBaVCLQ4qckeRwJ7GBCQUoTFSTGw2HTh8K6wcccH
477	payment	1397	1397	1678	1	1	432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpQBnCS2smtWbZdut44mFQpSYD2KZ4XDuaJyRhR7NBp3552Q4
487	payment	1397	1397	1678	1	1	441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrRoywM3TiFHr1THyNLBJgQ2wrrE7FKxNs4hD16Tv7BnkwHGz
488	payment	1397	1397	1678	1	1	442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafHjuf2KZLm3mmfZq63Wdq6SDf8n37WjPho3PgCspzz1SAdpk
489	payment	1397	1397	1678	1	1	443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuLEtyqSEnmvKxusG8QKbxrP5dEtKzTFJBurPmwFhfBwm9SRA
490	payment	1397	1397	1678	1	1	444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VqK7fWKKGio7D8kFMnn5a7tTwpzvgJhun69hy8pMjRhJwuyU
491	payment	1397	1397	1678	1	1	445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASYfLs57EviWC9qqU4uaLPseQ8Y1WnNTQjmAsnSAjYC2hpAGi
492	payment	1397	1397	1678	1	1	446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSc4ZkMXFBnTKsYcMrnqi7KJNHnb7voPXY2vhRMURkdpKnJ2L
493	payment	1397	1397	1678	1	1	447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzA4fyfftXDjiTjSrxxZuEjafhsHyG7TRb4Fnn3VfpkEAJs1x
494	payment	1397	1397	1678	1	1	448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mF6JMabqgrXZ2Sqo7Sn8NxGKKwrqD6zhEAnauruohG3YjxY4
495	payment	1397	1397	1678	1	1	449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6f7iobdGTyaVJHhPb5Qyxut6jNqjcuiBb8HL4mP8o7ABrYeE
496	payment	1397	1397	1678	1	1	450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1euRCMnT9D6hFAoMphYk7hBYsDaWfNgp2ktpR6V9jrCABaWHN
497	payment	1397	1397	1678	1	1	451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZsuWEESz1KZSACyEZ7Bb1ZjVcD7PwveCXL9aTmCeg6Wez3V6
498	payment	1397	1397	1678	1	1	452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbABu3pcDWjZFHcLy5xdKEZpSnGipT8tqD9ca4K81Fb8S8BUe
499	payment	1397	1397	1678	1	1	453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGoHSgNzs6p4aGbtaeU4hkvAJydhzaYS8bR98WG8GjP4PJQQC
500	payment	1397	1397	1678	1	1	454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieV63scAKQ4cQtLxFGZ3SjoRgdSTTJdSvc5Ge7yCTTd3G6t1T
501	payment	1397	1397	1678	1	1	455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrx6EvKQJU6T3P2gvsorpL1wKxyzERtvHQJS7sbTTYH4dEb6TL
502	payment	1397	1397	1678	1	1	456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBnXmPgcJm2oRgdYe4DmgfRyR8EiAiSeHd5WmcCiuVEpumC6L
503	payment	1397	1397	1678	1	1	457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cHMgpaTGTGpno8opP7PiQ8p6B4yTadT8WQTeEj1WhDupEbKX
504	payment	1397	1397	1678	1	1	458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRq8B43ec7PwZvRWMdW6ZrNDKXBqH93HeNyV1sa2WbVzAyVts
505	payment	1397	1397	1678	1	1	459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnx2rKQ7inqFbSxUQuib5koge8HYo3HHfdw4cwbDqrumAw74k
506	payment	1397	1397	1678	1	1	460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuM4ZeMrVvXnzcx4e9PKP6kKdcnPuiaFVQjAJJ5n3PA7gZiUdu
507	delegation	885	885	1736	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7StvcKzLbd68tVAtmJsAmYp37evgjLTfNkAGUrbqNPLoDcL85
508	delegation	886	886	1736	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBipeJqaHhcFp1LCKsP1TSePPpCpVCFaw8CDdFxtSmxhUsgGAg
509	payment	1397	1397	1678	1	1	461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbqVKsBdP6fwt8M6Z8wQwY84A3Ahv9TG2ZWu8vVaq27Fe5Bgn
510	payment	1397	1397	1678	1	1	462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVCf6GddXD4crB7i3mXBYQBT6jFsb9VQHydgJ9vvAbRoJr1Me
511	payment	1397	1397	1678	1	1	463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wFUPvNYv9TgAi1xaMGMGnYDRESEvLbjPqp7E1apEWu783HUL
512	payment	1397	1397	1678	1	1	464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11mCqtaQogvKq8ewrhuRKK6qx4tfSC3BFfjBbzzhTTMavpbt4
513	payment	1397	1397	1678	1	1	465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EJ5uvpM3dvv83Sx7M31a5M1DnF832FFJyxAkjQZFELA9sRJn
514	payment	1397	1397	1678	1	1	466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQKFeGWi6Qe9sJReEsJv4i3RYMLpZnVaGGsY2jUvQEPAKyC1E
515	payment	1397	1397	1678	1	1	467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQduHdsFDPBANTtktaPGVgc6kgpR7UawGo857BnxKwh6KhLQnb
516	payment	1397	1397	1678	1	1	468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMiqG1cDjBBRDvG7EVgZwGRkJnPK5qV4o5bSgFx6Nso64oYhA
517	payment	1397	1397	1678	1	1	469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdTpkWu7hU4r1SPQxx6xk8MKKcxce389GvHQv1HyDyNfCMPiL
518	delegation	1714	1714	1590	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGWe3M7Z769qLJNN9AoXy7H3HPqAtx4DPoULTD4q7vUA3gbSx
519	payment	1706	1706	1737	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAX2nPN8uwDwqeCUuuUKznfGiCMu67QGeHtyinAECj26MWPAia
520	payment	1397	1397	1678	1	1	470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YdwaQyKqvZANzeog5SWArNrSQDdsxmqfkqGNwkxJamfYYXDo
522	payment	1397	1397	1678	1	1	472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXPMWPZYvpG38UYTa9TaJRwtCPoUezJyJGHcLHBxwoukjFxdj
523	payment	1397	1397	1678	1	1	473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoqQPEzpTq8DCCCGJeeoqSoHixkwH2bwsVsv7geRC9YZKNyWX
524	payment	1397	1397	1678	1	1	474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxtVRHyPAkNcFtRDXZkNQGZDiro8amLG1eCmuTu8ZvTEstrQZ
526	payment	1397	1397	1678	1	1	476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8cUxWp7LEfeazxYHuD7gaLTQdg2UHzrSDJRAUdubj4KkGo3mD
530	payment	1397	1397	1678	1	1	480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCsq1pv4e29ce6epXhhUCAKVFWY53rQKpRYvzdzj9jYDbYr1o
538	payment	1397	1397	1678	1	1	488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWRj2YCCZMuKZffpci9j1fRsNKtocSEjMLHSUHGf6w81CMs6F
539	payment	1397	1397	1678	1	1	489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWj5XRm8CSb72TLhwHvrEaLTpBzh8V6DQeX9EyjbGZvb3GRkQ
547	payment	1397	1397	1678	1	1	497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubDeuF51rccom8ExBmrwR4LH2mgyes85fu8qZNa2n8KFVn19E
549	payment	1397	1397	1678	1	1	499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGgdFXkDBe7UonpG32n4XydX9i426ktDtT1HeR2c6drQGjSHn
550	payment	1397	1397	1678	1	1	500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7eFCTzAC2sySFDpf4RmigzZ3ufLsmYgbwo6Nb19BmXyadQSG
560	payment	1397	1397	1678	1	1	509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBVZUh6GnPi7Anj8EATaPT9Gi6c8TuDJw7mfejdmY4JY2Jwjo
561	payment	1397	1397	1678	1	1	510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzh5HE7H15CgLHtLbLHXH5pPSnKK1hvNVVwJN8yBGW6TFpLhB
562	payment	1397	1397	1678	1	1	511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJhtjMQDSSx1D2R5PGUd46JuvC9mSR3NXVyaCactNTUomEt8y
569	payment	1397	1397	1678	1	1	518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1PZckQQG5n8u1YDxusPt6fic1WzGLgJZk83gtWKbt53iLDgN
572	payment	1397	1397	1678	1	1	521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6p6NUkSW3Y8LBt8mxT2aUSxAaUpDDxitdXLbNLcLAS5jmoVo
573	payment	1397	1397	1678	1	1	522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLn7NBVrHkW9q8x9yiy5qpXUmsC56AQKpMvwcJVWBoQ26KMVk
574	payment	1397	1397	1678	1	1	523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKShCZUTTNLYBkPEswcWWSe6iX6XtNnYdEnYzk5dk8r1dY4Ta
575	payment	1397	1397	1678	1	1	524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsJ98Fe6pu1qs7mLjQif6qR2dAqsuxwAobSysXQxQrq6UUqPw
576	payment	1397	1397	1678	1	1	525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnA9QhbeMLM61634tz7EtZBhvrLgu35nLYXFRaQLJsFaFt9kc
577	payment	1397	1397	1678	1	1	526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJcXdkZtBgTBYxLFV9Yrogxromnt22qEwnvcvtmZoV8wuXRV7
579	payment	1397	1397	1678	1	1	528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSu8TgBV2V5vGnFxJdxN55MfN7X8JqdghLL97v36ZpWPag4xvR
581	payment	1397	1397	1678	1	1	530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSeh7eHghePMjeBshWBVNvRdgEYaKtP4WKrjzqiLBRDx9rSCq
582	payment	1397	1397	1678	1	1	531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbHUtgjT21gKkRnrVb6Phqr9o2aSZDD3GDAaAvy3Pps6WoXDM
583	payment	1397	1397	1678	1	1	532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aqqcAr1abMDCGpvc4AJdZQA2CGo6MzH9bpBECP7C4ckwEiqK
584	payment	1397	1397	1678	1	1	533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4tTyGZhHum67Es9nFFNAJ1QnbrQqpE7tPz5dLqnfYdpK9DxZ
585	payment	1397	1397	1678	1	1	534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HzPZZ7PQoNWzXtQqdjdB3AkSpQLMwMQ9VUJ5DS5Rz8dBAWpg
521	payment	1397	1397	1678	1	1	471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHg1p2URuqY5cNsUD86xJhFPYiUxDe3Y4aQMehe1XDRg3V6dV
525	payment	1397	1397	1678	1	1	475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevyTn6KujZWfNZtYunKNqBm5Ut82h19SmcxKP8bRzekqJKv1U
527	payment	1397	1397	1678	1	1	477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb7jTzWKmr4adX6mLRVxsavgmTQYs8wVivTPEfuFLcxWahHby2
528	payment	1397	1397	1678	1	1	478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3krbJcdGtxB1ieAPGridsw32qTmet6scPM4Wm9ks5bJQNizF
529	payment	1397	1397	1678	1	1	479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrhCaP5Y2cPcTCdLdBbCTiwwdT4mTpbFhy9ERVbtkqqnrdPMej
534	payment	1397	1397	1678	1	1	484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikgWjU94VNaEQPByo9a9kH6SSi8NzMqVUchH3K5MC3eK9y9pV
535	payment	1397	1397	1678	1	1	485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoCY78y8P16iNknyB7SQqj7iPvAc4gVv47sgLwU7xcsbABpeNY
536	payment	1397	1397	1678	1	1	486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctWjezirWfzMgrQSX7sNqcwycSVVJk851eu1cRy59gqZc8DB9
542	payment	1397	1397	1678	1	1	492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z28ddETvFDRPpqAQGGSGTc39MKhtXGKxMWhkv48YvM4Dab6a
543	payment	1397	1397	1678	1	1	493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAA2CiGemKRQ823uLRbw5p6LAZaKSLF6cP9UM7tW1Rs4RxZQCq
545	payment	1397	1397	1678	1	1	495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTAG4UcX37ThBK1zXAZhh9rVJCaE93QMSL1yTgndX6mhYE4do
548	payment	1397	1397	1678	1	1	498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DnzovKKLLAKrvNQDcsd4xTq2vuH2xEopVkW4DsuhwpqmEkq3
551	payment	1397	1397	1678	1	1	501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXDPV2JL2QnRZgQ55nT6RD3W2ZXMkjV4nieWbxca1S3HkuNrB
552	payment	1397	1397	1678	1	1	502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjx55zeMspZYdGrX5HMaFDQeqDWdPMKYuXR32EEfNxjprgdjB
555	payment	1397	1397	1678	1	1	505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmr2U5G5x6UXwqwvEMQT6nqzTjYiRcBdnyhg6pejQ5f98Hff3
563	payment	1397	1397	1678	1	1	512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzux9xyUS1HZFjDoJ6QLZdugnhDZJeZAnUSExrrT4aniu55r3t
564	payment	1397	1397	1678	1	1	513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnkPYB4d98GYX1wC3aFrLnFbxpQgKedRaJnwFh33KgHmP536m
565	payment	1397	1397	1678	1	1	514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzhHduZ4EviSzjMWJuS4ErNqGYghM2a6gXoyb3aSrpNZmJmm7
566	payment	1397	1397	1678	1	1	515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4mFQV32nxamZZzaBVK7pNqHWYN4Z28KWjToW6upNdeLfnWDi
568	payment	1397	1397	1678	1	1	517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqWrxtjtA7JQ5x1cqRbnEVRStmuh4VdEBwjSnbwGpinjVPYMd
570	payment	1397	1397	1678	1	1	519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweuURkfKRHfMZTSWhacjc95f4vnjqX16L9uFFK2Cn4xvf3T6d
571	payment	1397	1397	1678	1	1	520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzv2ZzTDEFfHAuhrXRx9ZRx6VbdK8oKW3juSAT63SsKArrnSd
531	payment	1397	1397	1678	1	1	481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumxcW3v2rb7PKm9xPNyxBHX9fGnu9GPc9QfaJZW7Lj4AfpVjz
532	payment	1397	1397	1678	1	1	482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnngwQYNhWXssLtmggAzU3T9qCuNCKxzWfJaC37Ez8LAHQQLpN
533	payment	1397	1397	1678	1	1	483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTz9r76iAMWWXX1Qnzv3GCVjs5FKLQpsHya11yoX553Lw5iAra
537	payment	1397	1397	1678	1	1	487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtxjZR4ifdvzs7Z5fNLkECdxEAkzNAgQPJj5VHHNb6RXN18k8
540	payment	1397	1397	1678	1	1	490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWPMnBdPe1c1i2u842bTYGXeVMyhchzz8P6PwQmdpcmqpR9GF
541	payment	1397	1397	1678	1	1	491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQq66NmPgM3BfEAMfVUM7DBMhvxbUGSCGmc8iaBbnrNnm2LAcX
544	payment	1397	1397	1678	1	1	494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZxj16RYYoCShdyRP2vgUk6CnJ4vfBjgrhYoDdp1iq1zEY986
546	payment	1397	1397	1678	1	1	496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuVMmUCgXJaEX3Z8yEzb9egZDyk7Q6rNibCn8Bks59t9imsTW
553	payment	1397	1397	1678	1	1	503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVD9ZRnr7G1nHK1M2i2a964gA8tFKVGT4fnUToRkc2wqRKbpb
554	payment	1397	1397	1678	1	1	504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibTnLfn9JAQP1BMxnSXtoehvUcuGhQC26TyyrhhtS71DNmMt3
556	delegation	1681	1681	1477	1	1	0	\N	10000000	\N	E4ZMqZAYzJDQSyB4rD75zxVLcSGBp45pQC9LYp7EhekNmPt1btodA	CkpZBcS4i5VbxciCoeRMaP9cZM6imtVJtiSTnNWEStoHwfD5JJYwZ
557	payment	1397	1397	1678	1	1	506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKeztN5TqcnTKCA5u6aQi3CUGJyiw5cxRiAVScRvqZ1nMujNQ
558	payment	1397	1397	1678	1	1	507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59JJfHmZM5yLEqfsqCToXdHUzn9TzutKnkYLEC8de62jWngto
559	payment	1397	1397	1678	1	1	508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS6oE4rcbkEmfpRKSR4afiHec71ayub7af6df68RHuhtSYNYM
567	payment	1397	1397	1678	1	1	516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmE8c5jN9bM3vydFphUf6nBTw6frVdZ4mMqxSNHZ2jwiRd7pz
578	payment	1397	1397	1678	1	1	527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLy2HzR7LF3oyFck5T4RURDunoTnzkoMt5LqLgcae3miQGk7R8
580	payment	1397	1397	1678	1	1	529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9afKtnhhCjmHLaDxXBfuYzbYuPxqEMyQRw9vgfGbqA5WEpEKT
586	payment	1397	1397	1678	1	1	535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNNrr6sDXVVjByuisehznAbp7sxrhs6hCVGsz1H1HF9VVBYzu
587	delegation	1724	1724	532	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaYtRvSmH59PtR9wLghA1N1jSTcXb5MDKXgBwirgaRiUAEby9
588	payment	1397	1397	1678	1	1	536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZ4TXF8zbEWQHYeodTLFZWTujEevVa6WA58SxNUDyTDBHnXHs
589	delegation	1724	1724	532	1	1	1	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjzJx9q9mRBeKusWvB7vnd1k6NtoaNL6k1aPJausTcGNGJjCe
590	payment	1397	1397	1678	1	1	537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2476xf5JQ39gYKZhEj6VP9nq1oZdzV8HSiPMtfbn3svbXttN
591	payment	1397	1397	1678	1	1	538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkG7jAHTkwc1EYqTUxZE9bde7br56a5XWUvrPHX926115ntQn5
592	payment	1397	1397	1678	1	1	539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmx6K2wHsFFHx3j4UipNyTT89F55L8nVN7L9mTQtuMVPXuXpjC
593	payment	1397	1397	1678	1	1	540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZobRFZviBbPJXPw371Yk4tFuXtLEAcAFRqzsBp4SvBSn2KAF
594	payment	1397	1397	1678	1	1	541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcj48EMo2K1YpCp41LnZ3ukDZqPRZ1HoHdB9aihP9NTmpsnAG5
595	payment	1397	1397	1678	1	1	542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfUQQcT3iiNhNu7n9mnXyfz9jMpeqCVnYLzYgUCtMwE6KMYcy
596	payment	1397	1397	1678	1	1	543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL51XhrRv3ngopZW9frDqK5E9oQZDZBcLFLQBVrTeA8gUsRevu
597	payment	1397	1397	1678	1	1	544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHB5DFwEBQSKys6aFZXtE6mc8yjUqm4J9Zs9GAA33f6fd5VeMa
598	payment	1397	1397	1678	1	1	545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrUHUhh4ETGXdrKy221SiBTBwxMkowkUApKUCXRbFEuS6kaAF
599	payment	1397	1397	1678	1	1	546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1UjP8nRak5Y1DbfeAcgA3BVUpag5BTLb1iYZvxLek6oeiy1X
600	payment	1397	1397	1678	1	1	547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cChfPoozA9CpTNWpuYMsXLbPq3Yj5D1ndokvyoH918ZQxcpo
601	payment	1397	1397	1678	1	1	548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXqnzsxyxLfaoyEEVKmTRqh711Gmmdkd8drqCFgX4WVe88TLi
602	payment	1397	1397	1678	1	1	549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW76GGG7Sd6447SCMGt8HYDNrnJDfri6adLLKGvALk5FXBhjr1
603	payment	1397	1397	1678	1	1	550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfirVj88XXEzH2UkBqoP8dCT2cZ9rC8mAALYx8K69xBR9fKqpm
604	payment	1397	1397	1678	1	1	551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TZmS98V1W2cFcnuiomjKQHDFVi5iXgZr4qcuaUEcu5tUWyn3
605	payment	1397	1397	1678	1	1	552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRgreQjXXCy7xKGzzXp9BFeMaACqj3WBu4qckf3A4imTVdbXU
606	payment	1397	1397	1678	1	1	553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6cAu2GHF4NRANNrYDQUx8zEXcf1u9i51vZ1WdHkmP3vRohCG
607	payment	1397	1397	1678	1	1	554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMMvTfWQvRCaYnPWAMLBtdckMUD8cRzCRnq82E7GojLzxv3Pz
608	payment	1397	1397	1678	1	1	555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZGpERn7jt24sHLSDkojgHF6DGT9RVoJbpc9BPwysA4KDhdSP
611	payment	1397	1397	1678	1	1	558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhFZr71VMvkxt8d486XsTZzwdFEkx4XNQKJhSwf69jNSnFr8C
612	payment	1397	1397	1678	1	1	559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDhSrZXh1v5dmyg6p2QcrSwKp7JWmmHVgSWqw97dyzAACQwUU
613	payment	1397	1397	1678	1	1	560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPqykRgkCzcgmw5d4gGHdwQoY5XwFb11h17WfmXBvPjj9LiaR
617	payment	1397	1397	1678	1	1	564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBBQMQJwZfz7sftyrEStJag9KKBpxaFKkPqpWyynbdrgYc8hA
618	payment	1397	1397	1678	1	1	565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtPuUWwqZUK2fpt1muREbubTtPCh3qHpFmx4P6G4UzGR1Y5vB
619	payment	1397	1397	1678	1	1	566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PReVmdnsSTpqwcfA6zYWW7cEBf3HY3oJX6gLwhn1zfUzxCTk
629	payment	885	885	1736	1	1	2	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ1dw1GTbH7vvZPDE1vS7S4Jq7YFvK5uaAUCHVCZxQjwZuUSsg
630	payment	1397	1397	1678	1	1	573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPE2znGocwxRyaAJ7dQpvcDFTWeuGNgRqcMhi9XrxNLZpJuh4
631	payment	1397	1397	1678	1	1	574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuFssXJ6EHKh7TGnRzsJJ27o6AkicWk9JaESAHggkRUEQM3dW
632	payment	1397	1397	1678	1	1	575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfNXpMY7DAgWcxwcErbKmn3UvejrwCLe392BjetHT69diRX7j
637	payment	1397	1397	1678	1	1	580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2drhWz9HWqHPAwECpNq9N4JxQZvw3DuEGesUfLDYM3ZpoeRD
639	payment	1397	1397	1678	1	1	582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19U6WKTs3BNN6rRoUMn5kAyrRbKPqfFbC4869kATi1zYYThgi
644	payment	1397	1397	1678	1	1	587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQky45cB6f4MJjYdtUcPiMWuuzTXuFHCuk4nECfXPdfhfTRQR5
645	payment	1397	1397	1678	1	1	588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSkd9osw9yLsXrJCdnV5tpCdAqT319wdKQsKZZw2E4Y3uYgr8
653	payment	1397	1397	1678	1	1	596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SbGiJuWQGw9JuQbd5APmRpPMdFBWgN6RTbySZGqbuatFNFHy
666	delegation	886	886	1736	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjtYHKAa6DL25DVNypakvbYnW37oiMXYVo6zMhk4JNYvC6uVV
667	payment	1397	1397	1678	1	1	605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHBjiNWthLXzSRyS9wjBvWKLjhtuXns9nCUhL5KVbxpgfXzkQ
668	payment	1397	1397	1678	1	1	606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjSVT26ZyF7DEzrN6paKCFt9LHMvSwrJkA5jS3HvmEyRT6Rtn
676	payment	1397	1397	1678	1	1	612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfLSVAHJSsHLCJ7n3e1wvvkNCuFBq1Jd4QriRQm9wjgU9QKZk
677	payment	1397	1397	1678	1	1	613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLQ98ZRyKKQ1uTtFqvCWCxh2wiapKra5uXsQJY4jEst8zKaCW
678	payment	1397	1397	1678	1	1	614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nx1YfTt78WTpxsnQUDzjnbzxHu5xi4ubYVqQWuWgEu6bBTkU
680	payment	1397	1397	1678	1	1	616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudVwL6zntPgSvPXTJcbRdvAd9w9tMMcXTJ2wdu14wBpnivjef
685	payment	1397	1397	1678	1	1	621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZErh1aLj6dNxLhgBEHwY7LkwSJa9yG87HcUFbtJUcTTfJgGm
609	payment	1397	1397	1678	1	1	556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUWqn4krrzk9MGQv93u4xWjkkqZcnjmn4SmNUYqou47giX9eV
614	payment	1397	1397	1678	1	1	561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5q5VtgUJ7HhvqDnkh1fMxg59f98PC21yTL6qPNeFUEZtaWG4Z
615	payment	1397	1397	1678	1	1	562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEGKburjvuCoW6AEitvSsuP84ZDmexUeXoYf9y5FnrYNQ1ZNR
620	payment	1397	1397	1678	1	1	567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhB6Ek529pyeCAhEgCo923mHQS4YpvnpptKVLrTxYE1zDB2TKZ
621	payment	1397	1397	1678	1	1	568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEaRiJpEEEqzRsX7xAeiU3STzCPPHE6HokhCdr8Y9xJb8M969
622	payment	1397	1397	1678	1	1	569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSLwGyvHLgAHQqFaup6rgcN7W9zfEXCBBB8wuCLQuGa7xPP3ve
625	delegation	885	885	1736	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyc6shKurW25L5dDyuNsZZqNwoZsA7xbQE3suzXvn874RaaNS
626	payment	1397	1397	1678	1	1	571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpoPKkFJ7S6sZ6HLhmax2f8haPQc2SqecTAT7M714SFafjqSt
627	delegation	578	578	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpHpRjzidqX63cSQvFFLWHHdKsQvfRykm2QJowLFbzsFL3m1k
633	payment	1397	1397	1678	1	1	576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JVj6btAZe3pX2bDVEkt8m9XbqEQFz8XjzC8m3zjsxc49AJVZ
636	payment	1397	1397	1678	1	1	579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSF1hLsCvSFj5s1uEEd4jKpdfXPxV54T8mvds7BgZ4zVrAeyA5
640	payment	1397	1397	1678	1	1	583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziCTKcQ91EkxXzTTZ8H7Dv8CZf5g7vQ2RpPPVLMqWLCShM2gt
641	payment	1397	1397	1678	1	1	584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSqx2kHWxvzqoFqiaYJNvqxhV49QXwximCyfp1N3Z3YAaMJ8W
642	payment	1397	1397	1678	1	1	585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFiNyECGPY4Aq67YMCNBp5NkNYA5jNZRkMBP5gfPvWzwHoiti
643	payment	1397	1397	1678	1	1	586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKfSi4Bb7UCaicyYPjrj1dEngfuqVDzuK9khiMV6KoPZ4Fwpt
647	payment	1397	1397	1678	1	1	590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqKuExh14dMivkYR9DHSEK1J4iNtbGySgdJG6PRJaT1ddcMS4Z
648	payment	1397	1397	1678	1	1	591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJHK361VTJ5iNdNoucdqVXeJFzMoQrUF6BnV1QXjeNiXaByrr
649	payment	1397	1397	1678	1	1	592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsVZdEDAbyQ1Q7jbKC5X28zMKkMtyJe5z9yt5J4kbcVqt8KJS
650	payment	1397	1397	1678	1	1	593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrzPujzuxZ4tM8KGuCroHGQV1uZdKcUVxoH3VsqX9snNiiwCv
654	payment	1397	1397	1678	1	1	597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZD7cwSH7LqY4Ggu5pPz3pK4d3C66nmL7DWCE754Xajc9yenj
655	payment	1397	1397	1678	1	1	598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBnrWSkoRsBjiH8Pvp53CzGftgAd35UwvmRfNaoPpWHqwC8xr
658	payment	298	298	14	1	1	0	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYgeaoxCuKYvpC7DfYfW3vTrMkgUr9HDRGGpsPNV5KLwzxuHV
659	payment	1693	1693	1736	1	1	5	1000000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYydXnnWxrWbYQmWmocVhbopzEJi9MfDjDqcDKydydDPFDLYiYP
660	payment	1397	1397	1678	1	1	601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGdoeFmHSQG9fpKF7rjdi3z4y1yzfjBYpzfgWM2eFkp8xZvS6
661	payment	1397	1397	1678	1	1	602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxy4BJMjws7oDNG7hiNhRtFrkdrsQGWNTYZHca1EvuhaVKsjv
670	delegation	14	14	298	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8YB2gn83fya8aGDXjgwMMEwqX3mCgmSZtQAEM54oP88KRuS7
671	payment	1397	1397	1678	1	1	608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKXTKPBMGhMg7Y4eBJkSz1hTtxSGAGJnpwiiSytSBpt5akqCY
672	payment	1397	1397	1678	1	1	609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PNiGS6rswxmcAwY12Eq8i3yP24x5FS4Dgb6HQ5FRm7yh3oZW
673	payment	1397	1397	1678	1	1	610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEXtPVka3GCZKHQ8wmENYTbaqb9d6fUf1HV4NKDwmtjupQ146
674	payment	1434	1434	209	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUMWZshchBJ4An1kCw5SoYoyWxqhQK37KY159TVN9ALLsGZJK
675	payment	1397	1397	1678	1	1	611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PA2W1aEzLuqDGSABT8rwopHzMqWCMmdqpUQDRbYERB53pDfH
681	payment	1397	1397	1678	1	1	617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DW3yZpGWDCE4m4sCRaDjtVjyQANJk1T8BVfRoL372Cci9dTk
683	payment	1397	1397	1678	1	1	619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsYVJqq3nqwDZhsvqGPTpojTkDnbSHqGSEvkeaAsLruF4ZjFN
684	payment	1397	1397	1678	1	1	620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAi6AZeFcYGVTmgTD678UkWP7pJ4LdSzY46ZBn7m3vS53yBAa
686	payment	1397	1397	1678	1	1	622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNgP2YBWZdfEKQbqMzxrk4wdw2NhSu92Ev4MNjntuU8CyfY5h
687	payment	1397	1397	1678	1	1	623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqwM8ukZ5Ps2WU9kdh3xxm92ActRh43Qraj8MACk1ADGqhuPC
688	payment	1397	1397	1678	1	1	624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qJDE4Xe3eiutAYBwU4rbb9z7xDaT6ncYhNz4qKdHfkmRrfkb
689	payment	1397	1397	1678	1	1	625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzw6ahKYYUcAd5WLjQFtZvtNBMnvS2WBP3JwVaRnEvmoDfqN1R
610	payment	1397	1397	1678	1	1	557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TZdawFymGRaJhn2qqMooaukzQKxcmbLHrUTLx1ZVtLSWGu8w
616	payment	1397	1397	1678	1	1	563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWx4rgQumZoYzdMpd99RFgm6dTz9zFczxYuhoUk3Dw2mwmEff
623	delegation	886	886	1736	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uPLEMkDNbcp6GgdymBmMsaDKoYAzY519ramwp5rGMykPdXHM
624	payment	1397	1397	1678	1	1	570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacxvJzHd9K45Hga4yNmgiQDQUN8wLBqRYzPdfea8WDjFRCPGq
628	payment	1397	1397	1678	1	1	572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmNdN1Kbehx4SqEN5bqgG62Zg8dc6GiqERTfSJeyGz9cMnZPZ
634	payment	1397	1397	1678	1	1	577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9pU5Aq6YYP6ZTuxvBxkZcUe6V7b7RGs13ejyeSfmUywR9f4J
635	payment	1397	1397	1678	1	1	578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAA9m99LyjLeNqFuf2UXgpuwJPs7LEGw6CftB9qN9Fb5FCCyXp
638	payment	1397	1397	1678	1	1	581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXPSxba1VdzX3fzw5fJGMtG5BVNVJJALVHm3bRexSpCm5nzvH
646	payment	1397	1397	1678	1	1	589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dEfvw9m3VgjYnmXKoG5WRUqGBFJVpc8qRGc1JuvTDMTqf5nG
651	payment	1397	1397	1678	1	1	594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGufxUHFUkEeuM4izArLe2RshFzq4woLzFmadVswLavsy6R13
652	payment	1397	1397	1678	1	1	595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2CBUfJDGKxr1QNciZHqqmyQm4WMTCg4uKjXLk3ARHoASGVRB
656	payment	1397	1397	1678	1	1	599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXysTNrNwRTg9Z8RcmaBAu3PZnfYEAn4Xor4DqbYDri4yeWx9
657	payment	1397	1397	1678	1	1	600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKz5iv6tkgeaDNGqnDDfcHqCHqaeHcW6UfSkYycosXgd3MPhA
662	payment	298	298	30	1	1	1	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdquTViDThrqbM5SBeBw2DfEf6UmSZoFB2J8AiSAZoDEwcX3T
663	payment	1397	1397	1678	1	1	603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPA3Wf6oDMS2qFDtqmpxsgvbEMkR3wFG27finK2XAPRUzLDin
664	payment	1397	1397	1678	1	1	604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzkfBchc5Njgb7uSz6LDhwWSioZcW69P7Y94aqXRLqfNoGjwz
665	delegation	885	885	1736	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKjw2t4ugCpfvte8FiPE8EaNwVhr5koTC8W5dUN2RQUoXMJ6y
669	payment	1397	1397	1678	1	1	607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoE6dDKwFrZ6hG8acZaDxB1wDTvzHNVBP9R8Kn3emuBbdFckw
679	payment	1397	1397	1678	1	1	615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxcqucbTG6EB5pnQLTomqGuR6u7pDkSbBPY9Nq4pDuezwPyK1
682	payment	1397	1397	1678	1	1	618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5Vwkaxw9BP4PxeCcb858dPnJc4EGgpiFdR6BNXewvsTXJi6Z
690	payment	1397	1397	1678	1	1	626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGKH4T9rjUh99a5aVdeDoPpQsPjttcbGai87YWAq4X57PHh5t
691	payment	1397	1397	1678	1	1	627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjk3oeoq7pgK1RyHQAPp7D6RuQh6vfEdCtz5Gn7qho195FPKH
692	payment	1397	1397	1678	1	1	628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTexqcDN1iqE2UJ4szQAEEPKEkMfs9DM5si6cBjiGhGKvKmkr
693	payment	1397	1397	1678	1	1	629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFobAhcL1344VoUPV55cP7oeaLuEkdFb6SMTVsqc4KmxU5jFf
695	payment	1397	1397	1678	1	1	631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFh7pj1c8yD5Kenu7jweUDQtgsWabLSqxr1eBAAjoUNbibXN3b
696	payment	1397	1397	1678	1	1	632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvA73ca7Si8AdeFgNdwvW4pnhnNMBFX9Aue8JWKeY8zavu36z
694	payment	1397	1397	1678	1	1	630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYZo7UdnGbevHBhECQbTPQzVQc82GYysoyqKYugRmehggWMY6
697	payment	1397	1397	1678	1	1	633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDaeibNU7GBSEizS6ckaz5nM2LmbHW1pFHw6qrCHFdBeaYidH
698	payment	1397	1397	1678	1	1	634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfDT1bqs3jJfx1sZ3gJStSWtz3XPjDseE2wYaN6kbVdwgbKhd
699	payment	1397	1397	1678	1	1	635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaaj9RpyS9ewXexRKaqjiCa5RzdYDU51is8KtRp6CTWnSeSFx
700	payment	1397	1397	1678	1	1	636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFAh9DLAQexzyFMct9CBvEgs4DT91aZLveCJdJC9gAiFKPWdS
701	delegation	209	209	1434	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZnVKUQVDgJLQ6N2hcKcxLZY8MfeAiVd5u1K82KoFkMgZXZw7
702	payment	1397	1397	1678	1	1	637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyvaspEAm2TRvArhf4XGTETnjQczA4hHMyD16DQ7DWQ4aeFiH
703	payment	1397	1397	1678	1	1	638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsa6d3QgAJNYbuA59JvsY4nLfmQ1i3XGAdysJMqy8T7HjDACW
704	payment	1397	1397	1678	1	1	639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxoKxDyD8GtzqkyJH6FXHg1eRca9HY6gZxNusnyPMhXKUH9QAT
705	payment	1397	1397	1678	1	1	640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSk77WPn1SoBVzbirAbVV1rF7QFg5iPSgE5WPcGJW6HnX4AFek
706	payment	1397	1397	1678	1	1	641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uzazWhEzzFDDaTW2bvTEMkqax2254QUrkbf1C2jhfr8EQkr3
707	payment	1397	1397	1678	1	1	642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESsVq9KqgqVMwygj7r22RETqMm5g6iFasJsfHy4d8axYJoAnD
708	payment	1397	1397	1678	1	1	643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4NNm8Tpk6oNs3z9Pzq1uGjLTx5MtCscQMq5XhweuogBiEh34
709	payment	1397	1397	1678	1	1	644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMddfx745UyWwmrAP23UdBqujT2KKYYnuA8HL7tDn9RsWVnC4A
710	payment	1397	1397	1678	1	1	645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkrFgauEj9rH1Hpt3nG4T3nvt3vEcyGw5jnkETnFDcPiVRUyB
711	payment	1397	1397	1678	1	1	646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJVMP1tTubZcS3baJV8eTyqMRE6MZyEDJ5aMfiCqsXyV7DE6v
712	payment	1397	1397	1678	1	1	647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQ1Rprf4DiTTy1HYc3q6AAK5XWw1FAyfG2eGi5n9jK7vtTFxN
713	payment	1397	1397	1678	1	1	648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXT4RQfjiXaGUP3LPjDwjuhfE9y7aYy8Sy3ymNwD1cLkhNFx8c
714	payment	1397	1397	1678	1	1	649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiRr3mcWJzWLR1hPs9nrfPPyqpS8zy7qvdWQZUWyqWV62RXyE3
715	payment	1397	1397	1678	1	1	650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspSSwb16Ls9zyttwVs6fZoSbfxhg2RPJhu98vaZhsjT5ajUZq
716	payment	1397	1397	1678	1	1	651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhcVNMXzWZLgi6q2Q8Re4UMa1cj32jtn6y1CxbCaPfcEdgXee
717	payment	1397	1397	1678	1	1	652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6SxRcMt3HRhtm1vtYp4Cdr5hGtmhqi2MoqbN25vuejyiDFK8
718	payment	1397	1397	1678	1	1	653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfExSTLh8XJsAhvnf3K67njtjTd3zs1RJiohStqs7hoGZbxKd
719	payment	1397	1397	1678	1	1	654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrd7GTJ7w8ep44r1oLggpSqYCmLYa2KE29HdwqEqS89cKCafaP
720	payment	1397	1397	1678	1	1	655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvkEWwkQzdTPuM4GaRxCTVmeth6hsuCCkFsv4XwN5ssvSMBVn
721	payment	1397	1397	1678	1	1	656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7WByUeKhTt7rocNDm7BDTRgPjUME7AYK8fJ9hdN9MmC4izec
722	payment	1397	1397	1678	1	1	657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpwQosxzBQYQq7Uiw1Dmpk2tu9s4vLwZfLuvhzKKHmehSJBs2
723	payment	1397	1397	1678	1	1	658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHms6EZDXpBtXgVV184KYBUX3589dR5WjFySmbSTbzgcEvsbRe
724	payment	1397	1397	1678	1	1	659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkw6bN1RuGTyKsUz9w3ww8qrN4waPQz82RFgW3ro2UTbkJQYjK
725	payment	1397	1397	1678	1	1	660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaz8HxJpHMBqMvqykv7FmsGYXsz4v76pwiUsFdgsK7Jx83tnbF
726	payment	1397	1397	1678	1	1	661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJq7BtcukXNEjLmZs34tXFuK32CKuQfF2wpDQYCn9cyamzX1G
727	payment	1397	1397	1678	1	1	662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrMoK8iKwWyXdY8dfTmWQY2RrkxQhjMcKkcPgqp24zeFn8Jec
728	payment	1397	1397	1678	1	1	663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4sA4KhAjPbGDi3crNt3gXiS8P7gsYASc3ty3rvwzT7rrRe4o
729	payment	1397	1397	1678	1	1	664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUo35BuyXSYy7Z8Uc4Wcf3rSKYfP37cDPs25UfBVeiEfyjJWa
730	payment	1397	1397	1678	1	1	665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8m6WG9xRbVVdUshbTV2ruXkEMWePicVe5dpXixdCshhUa8Ecu
731	payment	1397	1397	1678	1	1	666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupVEPjZkBTc7JzamDsEuB1rXt7c9PYWJdVe6ZA2p3Vqi2pyFs
732	payment	1397	1397	1678	1	1	667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJ7RUToM1qVGAjhD6xEqeCCDfuYvXUT9z8BSKSgUCTobChnRs
733	payment	1397	1397	1678	1	1	668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbvhioaJ42ih32BSk1Z9ENTZkvhwD3d1Sy929zRVLijjZgBmW3
734	payment	1397	1397	1678	1	1	669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ybFNvDBv7mKLvpVGQYrUKWLdZLtCUwFJLsqAfM6XH3ZKnLu9
735	payment	1569	1569	485	1	1	0	719000000000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNpAmMpUdGTdbUHzn5rpDuH9oqf3GxsSUadS7QGzEofc43AUL
736	payment	1397	1397	1678	1	1	670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtM15uLbdtNWEaUuP2FbMeM5ZbjGSroTJMzMyikNHwesaSQQVh
737	payment	1397	1397	1678	1	1	671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EEioyVcpw1CMzFNgbDnKomo9cBJaRpWVMg4YG4XMit52SrTL
738	payment	1397	1397	1678	1	1	672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidKmbqeAggyNkj68qZd5otoLFKTLUamNrxu3eMpbcgNjAyT2G
744	payment	1397	1397	1678	1	1	677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDxDdBoz6fvt7eV3kX6oYzfK2FdNZeuUrYULpEJWdhsRFY33v
752	payment	1397	1397	1678	1	1	685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDV17UW1VLfo1LiG1AAwvb6A39ZwcnGynyepq751t2xPwT1oMf
753	payment	1397	1397	1678	1	1	686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sU4JzVqFD3h1XTFTzw96eDBxvAABDMWHgxVGd3Z941Q2thUq
754	payment	1397	1397	1678	1	1	687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbXh3T2hxqyG9ucQVUjfb7J8HaznK1roL5xUzqzRiawdDridq
759	payment	1397	1397	1678	1	1	692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmrefu4Ndi74zRwPZCN7yh2ctdmWpoWmgp619apZNsVbVzgXR
763	payment	1397	1397	1678	1	1	695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3jAw2GRjHAMQkQhafRjH3o6cCo15WqzSTS19TZypJp6rAfH2
768	payment	1397	1397	1678	1	1	699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsjDvH65gASzeS7biabukPojWYwtUpBGHtRfQ3fNNQ63BrneJ
769	payment	1397	1397	1678	1	1	700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdn3nMBJuFQWWyaC1uBA8HmHqBD9wQ7f2X4Zt7uASS5wLi2ahP
770	payment	1712	1712	1743	1	1	6	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbCwWcKJ3kjJ1NTwRDrdxd9kVXNazhdgzjtGRVR56Rnj6bDBdG
771	payment	1397	1397	1678	1	1	701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFZFnP28zdiY2y7Tay7fteGnB7e94E6KcDMaQaxTjg6dekr81
772	payment	1397	1397	1678	1	1	702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshNpPdmWagjzJsWnALog68PwUUE548W3iHkAVztZmJhhsMedi
776	delegation	1698	1698	1578	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJDCoUY5R6GogeEEHXV6wsJ8p2mcCpmMogcETFFwMmTjuy5Mi
777	payment	1397	1397	1678	1	1	706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXiBa77xo5ALp9U5oz36dijahdsPiuLhqF5vNM28Z1LBjc3Z8
778	payment	1397	1397	1678	1	1	707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWRUWCk8PpfxpcwvxkmrBVeDSvPYMbp9Z7dNQp1K1HuyJTR2u
779	payment	1397	1397	1678	1	1	708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJnN3mdRn1Qf3UNENdF7poNf59sayzFuSwNh2juJiGLy8kFPG
780	payment	1397	1397	1678	1	1	709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8NFRkUERPSoNbkrMz6ybZEzKgFtDoAQ2eJu2U6rYgJ2Ym7BZ
782	payment	1397	1397	1678	1	1	711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgN13aCdwLKqyWob92at9K2pxG9mouXgtmFJtkq8rgyzvmerwN
785	payment	1397	1397	1678	1	1	714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqcG1XGhCMQdBpdUYuhQa9WKyCiUqwrjtxBybCWyTwuuYXyWQ
786	payment	1397	1397	1678	1	1	715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcDve2n6Qi4nEG3Gpmg887zCKirgzmmt4CRjSdq5jvfc9Ufh6
787	payment	1397	1397	1678	1	1	716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhkyna8XbwTGmBJ4hPWYJt1wvY5XyBqprfQ9e2q35P6BbDe1N
790	payment	1397	1397	1678	1	1	718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAVucbjGB4aGVMZ549gGeL4Tcmun5NWABsxrNFa8XH9STshSQ
791	payment	1397	1397	1678	1	1	719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEFwZau4tk8xGHZoT9BPLgx44dePQeCsy7kQzHjiYqTRRYcix
792	payment	1397	1397	1678	1	1	720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNDRvkKP9V7hg5AMhhMU37knAeg6ipT27FZqHxUVWd8keVEKc
793	payment	1397	1397	1678	1	1	721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLas5Ui8Egqz7G3jtKjFkjCCMgM8QHvNizw5DcZRReeKQmqxU
794	payment	1397	1397	1678	1	1	722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzG2mt4EwwM2Rwu38x48wBZoJgAmsaJ1j888o4LxHjK1Kk8tu
795	payment	1397	1397	1678	1	1	723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSNedstvnHK6UrGvYofzHcF5BWS2s2LRw42ZhipnQ6dAaQouy
802	payment	1397	1397	1678	1	1	729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCqckGisJZEQN9unnJUsGjFH1f53B2tvwA9grU3eC7UTpN887
803	payment	1397	1397	1678	1	1	730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAjYDgzctZr2ekfccHEzr2KbgTprcbynv51WDMCSpLKwtiQLUt
809	payment	1397	1397	1678	1	1	736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvVFTcB4rTxScFJJwwNoQWz2b1rwwU87Dx9TegTCSk18YtCAQ
810	payment	1397	1397	1678	1	1	737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkzkCAfHXAhfNnV4Ryq47jboWsA4RenfKZTcowzqT2RGJta4r
811	payment	1397	1397	1678	1	1	738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL92m4PkjFPtSZDhMNgdgJhCSdcNZRW3z4gSoH2sQHMP5QqA6R
812	payment	1397	1397	1678	1	1	739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzNi4kP36zchL82xgxBv2XBXU2dTnoUSbLb2ojgditVCbxriu
813	payment	1397	1397	1678	1	1	740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNznzohRjuLpteDCUFcp4mZXyfh2yWX4YMmxoiTwoo9Q7Esag
739	payment	1397	1397	1678	1	1	673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6Fp23oZWdf8ESReFgvYsLeVQnRASB1txA2pcRr84PytrHs8W
740	payment	1706	1706	1737	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYivG9vjKmuzJtK8ZvmxGHQJG47Djj4W6m96HgaKe9mHJyZKAsC
741	payment	1397	1397	1678	1	1	674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRn5cKQkiPczs3DYdb7q6N3qvq5XEE7Hv1RhqZfuV2gNaL7EZ
743	payment	1397	1397	1678	1	1	676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEGL2LZG5odKR2aLv2yd6HQBAtgYp7Ma4zaPFQ1ezGpHwxRBK
750	payment	1397	1397	1678	1	1	683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMPNZNPaKFjKqWXNWfLgxuXttNjHz3j5RBwUwbMjqiZyRbrzd
751	payment	1397	1397	1678	1	1	684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMkDVUtRAdSQiR2N61LR4nrBuJNGZapYbNMMU36VQCVuhZLpV
756	payment	1397	1397	1678	1	1	689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQ3UQQPBJkssfwykZAW6fp8LTLgMkZ5Z8SXcc3cP7eHKqgJWk
757	payment	1397	1397	1678	1	1	690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkynLDpHJqZXktN8ZPZybDvKKmk7G8UqXBxDw59wCWMJucrwa
761	delegation	394	394	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTcqUyLBR6SxxNfTRRLu9YVteu7gKmtu2d9WeA6VVHS6iYUUSP
762	payment	1397	1397	1678	1	1	694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgxyZFb6mxrSKeNHzwbrY5HrsYdPex9tRNXovQZR7gHHrstus
773	payment	1397	1397	1678	1	1	703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggQK3RkJNYDLKmx1kTYi7McBQQHTtj1HFaC3w5XiWAZKJeR6w
775	payment	1397	1397	1678	1	1	705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VbymBTpXoP8GgFxXLAx5TxF4JHChaBatR8LHS9W2j6DWeJTq
781	payment	1397	1397	1678	1	1	710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiyBR9rWbANdNKrpSwit4cS9MuezvizzCkzKHCsge6AwfZ9Sg
783	payment	1397	1397	1678	1	1	712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSUERmkiGeDdaZxXHvyQwZDRygVFzsoADbZCKjXkPw5zZQoPVg
784	payment	1397	1397	1678	1	1	713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1VuJ3DVihNChZ5zJGxA2jLTRaQBk6QePvgFf5qrerUxvdnvu
796	payment	1397	1397	1678	1	1	724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6KUk5FpzLpSMTdM8Pn9uK78VLinrMNTECiYg9vF7ywPVEobe
797	payment	1735	1735	1745	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1zojT2Fytn4oEV85YcTGjpupdSTVYiSjkLSu5RjZhRu6Z45G
800	payment	1397	1397	1678	1	1	727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpmvDz2CNCNbfkejT4cmsoaYQsvxS1bCZEjQ6uT8TD4KhKFvV
806	payment	1397	1397	1678	1	1	733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFP9hgDUDhwzLoXzapAsp7CXWoum382WVrJdXenZ7bJBcpsnoM
807	payment	1397	1397	1678	1	1	734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBymLiNmwHJy6W8jgrBJNURu8F3VEK9UxXnqjsZDX9SxXan86
814	payment	1397	1397	1678	1	1	741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9av6gCmEgogWFkiMztjcPXBF4gkJtcQ3M5Eb2mbgt2XZbLUjG
742	payment	1397	1397	1678	1	1	675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuFmRhDhYTq972vvfH5DCRsnKzTBZhXQ4fvsQuHL33va9GJua
745	payment	1397	1397	1678	1	1	678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvYYos6AvbHMcz9rXmVrsSP58ai7S9opS82on1ez2EoGSYim6
746	payment	1397	1397	1678	1	1	679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhWcU43kuSNxtL6miJHix54Y864wBzcLB7PFZye5P9s2fJvfY
747	payment	1397	1397	1678	1	1	680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgw9J8rHfcr7JQimZNm4XvKXGFzXFsYDeLBSH1hxj78j5VL2d
748	payment	1397	1397	1678	1	1	681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgzuXbjs5vzb5CVeSP1be3Ni3Y7cB9hN7fBnu3uf1bvSE5s6d
749	payment	1397	1397	1678	1	1	682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvWTv6Lj7j6MoLdpLrAn6aQTRG8YEX73LPsHpm5Yvhw9KMFe5
755	payment	1397	1397	1678	1	1	688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCT7PdpALdEm8eRiurmuhQyar8pr7J9to1HmyrvcJDbGi2y5u
758	payment	1397	1397	1678	1	1	691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxGbEBS6KjbLbZ5m74wqBUa7FP2zqaHHAKT8beHmYHu2Npx37
760	payment	1397	1397	1678	1	1	693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QgVBu8BU8r7vPtg5DgUzYpj5poJPRAG5ePzmT7eQqSW2WSwX
764	payment	1397	1397	1678	1	1	696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PRhsydGbN5J2Zk1saAa6UyKyaPXiv96oyG4GXbiv2p1uLpfK
765	payment	1397	1397	1678	1	1	697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcWHwo8QJmN9YmUKTXt2ei68brAuuiUEAbALt2X2Rry7FACZe
766	payment	1712	1712	1742	1	1	5	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMpqzEuNV56mZsBhY6kLyxU8bB6hToryqEytk7SqiPHFRgvs3t
767	payment	1397	1397	1678	1	1	698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFFALQfappQYWtT2jahKbTujGu5mpM6Lo7aRuNDSudHR5ghyi
774	payment	1397	1397	1678	1	1	704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2zs7KKAiHpo8mF2sh3oVcYbuSbhywnrJ112Qqgp43nthygaPF
788	payment	1705	1705	1744	1	1	1	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLEykMtKJxmAMUtFgYqtL2YAGdUFVM8U8bUog8JnrCtioW9ra
789	payment	1397	1397	1678	1	1	717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWYS4R5TdSifVJNNc2F4dzNAYhjQacGQUErKCVeuc68LztQmg
798	payment	1397	1397	1678	1	1	725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3s6tNMdxtgjzJbncY5c7Lk1NDw7GrAZdnHPbBoLaEYJfAxDK
799	payment	1397	1397	1678	1	1	726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVj9JbPSJR1wjcv39S6Wjan1qNYgS7H6Usmq7JKuCyFonKSum
801	payment	1397	1397	1678	1	1	728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wTYcjVhmcHzewZQGHMp13Lxj5PeM3mKmDbqb4YmxjDAJb9br
804	payment	1397	1397	1678	1	1	731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsYTT56dV8K68uRkDoDrZ8MxToULCpyQaYjK6JgvjktxBFCjV
805	payment	1397	1397	1678	1	1	732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63HkEo6hFMvihQwUPkKa7WEvq1nmn4X8ryMbqY3ALyfhHbSA7
808	payment	1397	1397	1678	1	1	735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LTj87GdjZQCrJ6uvALZPfPxE6zjNenUefhkZ7qmTwMsQy5yT
815	payment	1397	1397	1678	1	1	742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QTmW1p9gBoPcasSRYG3oFTDL3x7ak4E2Q112B7b7dMxbSrHc
816	payment	1397	1397	1678	1	1	743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHVBivzzLh9tqaXQWShg7p44KxfMJKfe5m6bLUM4wM9REynyj
817	payment	1397	1397	1678	1	1	744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFhJsU6SuyRS54fGq4yeMmG5cCMYpgoNqBt514eKzzWmhrukTP
818	payment	1397	1397	1678	1	1	745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RdbVcPUsHA7m8L1ktojFGvnnGKqiexKBNyyy115cu95qqQEf
819	payment	1397	1397	1678	1	1	746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnSkwY5JVavRKtzVvCfTajtQoEwZS8BwfPMjvZcuJh3kgyAqy
820	payment	1397	1397	1678	1	1	747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKuEVRRk3zEfKMxsAVjwc1597w1wxBsUipbCw5Skcewj5uf6b
821	payment	1397	1397	1678	1	1	748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyDLyyAPmjK8FCxeNCvS4L4ru54DXdLMBWxr4jj9JSUpPHekU
822	payment	1397	1397	1678	1	1	749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdxyY98PJqZbhahZJBBwBVbd7M84XPiGgaLa2c6YbTtkx22TM
823	payment	1397	1397	1678	1	1	750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyqYZPzYjY2FpwTBrV8GDRG2CcjqjTpJkCPJ7gq2PdD5qoQpg
824	payment	1397	1397	1678	1	1	751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrko4n1RkhS4Lea8RkNJrTemeHdNqQJMdrHrfqNJJQuFajAEpD
825	payment	1397	1397	1678	1	1	752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusBPFhSehN3BRLzHQhiM6By9xxRAR28kSiU91BmCPTwCHDGY3
826	payment	1397	1397	1678	1	1	753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdG8VYqrvi5kz2GLhGrraiXEemNabV9CmjFbKLfNUjQ6FC71oM
827	payment	1397	1397	1678	1	1	754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGbDrLC29W21aPFPhVJpqMZe9tYSyjUJhnU5n7VK1StQJZcfh
828	payment	1397	1397	1678	1	1	755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEFrWo3x78uPpu8CY7H6BtU7jXUXR19Cdv3uHNEnkKyCytaLSW
829	payment	1397	1397	1678	1	1	756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7z4ZFKtuT3MbPZMiu7o2cX5pgTV2iV4qwAF8sRN8QxjqTHrwm
830	payment	1397	1397	1678	1	1	757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLiwVWQZQG4e7PQbmG6MEjgPars7vURaLVqYNzd7oU2B8ZxeD
831	payment	1397	1397	1678	1	1	758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvFJkupxQTsEXQHJ51ZcK53UvgHy9Yaswr2ys9eEnyXuk6jo5
832	payment	1397	1397	1678	1	1	759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEfRC8UTPSTXp1pUWqQ2KQ5cQzedPyMAGdywVaq1jMnb1gZqh
833	payment	1397	1397	1678	1	1	760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrELPs8dJW19eWfjFwF5TDWXDGQe5yAhL3Uf1xXCAihkBfzWv3
834	payment	1397	1397	1678	1	1	761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xUa3DDNQeje9AfUYPhD4XfAGVzvVHcjmUKdib9eibc6Pu31i
835	payment	1397	1397	1678	1	1	762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcroB1LYvCv3qbw4eLiu9qcAs2Yj5ksxKSRptWXT7xRfpCyYor
836	payment	1397	1397	1678	1	1	763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHNDyxZH54Avey9rixfE2LU5cQMCvVvL9jd1RPYrLfVYRqhqV
837	payment	1397	1397	1678	1	1	764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEb1CYDkD9emtJCrr4TfuVSh6wnexvi7VQLsQhVbMfSPp8qDjF
838	payment	1397	1397	1678	1	1	765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHq7xgc1hibZvaeQDFsYfCNPeNRWnvi84g8tUfvReXeG1oHCVx
839	payment	1397	1397	1678	1	1	766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ESfw7Bd5nSqPZhkk2jVWZWdFqSierBqEG1QjNYK5x7jhVBPF
840	payment	1397	1397	1678	1	1	767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDiCQCQrHcwGQpdDuPkcmRaZi4oQgyeydhSbUrUMAyQTGLTxxD
841	payment	1397	1397	1678	1	1	768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCXuogJ7SkDUe6rqSAQymgAawf3tF7jeVEpfKX4Fjc2tdF1XD
842	payment	1397	1397	1678	1	1	769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZscesLGFcUZguLXXDhigksDv4SpxBMUf2xdgeyDyci7tYQfkyH
843	payment	1397	1397	1678	1	1	770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbnJTaBYWDA8qbuVQA5jxx37NWseovAfMZYtm2wBb5A6WFM1W
844	payment	1397	1397	1678	1	1	771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQBT3M56ZzV2kdKDVoozDveiSuhCNzGVipqmJ2AousaTCZtXM
845	payment	1397	1397	1678	1	1	772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyg9T8AU9ATGssPhPBuvcWNXoTm1wWv1p4VCkBW9KqtMxdWNEJ
846	payment	1397	1397	1678	1	1	773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumLqTg7UQAb7qLYBoT4Uo9Z8sP3NQdUAjiAwCSV4qiXc8fCFd
847	payment	1397	1397	1678	1	1	774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYiQQTd2y68nFp1xs7MYkpLqNwFAEFcrBpuczx1SsoRfETo17
848	payment	1397	1397	1678	1	1	775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59uQppahpoyX6AQQwjHSeWymJh76g8S1uBPpDhLLToZ2MEzX6
849	payment	1397	1397	1678	1	1	776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qno6Uxd7Gw3GmxMiDPWvJZ8Y2i7mfex2CJqQk4TsfwQHTBrN
850	payment	1397	1397	1678	1	1	777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcugxH1X5jkiQVvWuPF3txusGG6b9Eru6nLDahzRkTP6YtppX
851	payment	1397	1397	1678	1	1	778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTX5nD7yKySY2RPZNzDHQaqy76d78QP2qYrBNA3w6GzvKeRqP
852	payment	1397	1397	1678	1	1	779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekcHLC66VSCPFstvCzW1juNS8s2iEfXG19c74jVDTygk2FNpC
853	payment	1397	1397	1678	1	1	780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjoRmepD5SivN8zAqkCeNmhN6xgsrzFWNSNrUUyDpzkCYqA3o
855	payment	1397	1397	1678	1	1	782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pzVBXqzJNEPdYrYr74LRVM7YVukMKoZUED3o5GAjSNW2bAvh
863	payment	1397	1397	1678	1	1	790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo46HDRNHFhHiXVNswRCoek9Yoh9j8uaN3ka75pJoeDCCWVsR
864	payment	1397	1397	1678	1	1	791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWogd1LvJwZT8iBk3RJW1vTYRnaFXc4Ackh7zhn8CdbrtnAPPo
870	payment	1397	1397	1678	1	1	797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm58Aar3KeTSREY6wKfds8vX5PaCxRcsnsS276duCkSPvACSp5
874	payment	1397	1397	1678	1	1	801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWByjDya2LXTUddt8Zfnu3HKc6vJvw8bAsVshAGjmtzr4KTcxs
877	payment	1397	1397	1678	1	1	804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGvKHq1HHBcgB9FJcAhazSMxXkj9KGf2sTRgQybzQ8zvTASqS
878	payment	1397	1397	1678	1	1	805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCDTY4DfjNGHMQx5drVSMBP4TpSrN1UTYWfkwgvmo3Sxx5qWv
881	payment	1397	1397	1678	1	1	808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzQoPD5GHYBT8ESPq4kfBHicFkYeumhAkz4fm1Xjrj4kX5zuJ
883	payment	1397	1397	1678	1	1	810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAF7wTV93ZdhyrVDxhTXWGxVv8c2QcDDEerMKjWWX8Zqg3ECm
891	payment	1693	1693	127	1	1	6	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYqKKCC5m6WrLMqoqEbdpCYzVi5MEaxtW3Axhm9pD6UQMh3F6Pi
892	payment	1397	1397	1678	1	1	818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB9ozpp7DawtbarVjGYSibteEVEt2mNeaP8tddnDDfMypKyKH
902	delegation	1696	1696	1542	1	1	0	\N	1000000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1vQLohBksJ3Va3c9Bcnyyvh199Skzm7hikhMmmPW9gavAB5k
903	payment	1693	1693	304	1	1	15	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ2ykiokk1t61FPXAeM9xrmCFTKghPYTr3JgsbD8tUq8NRE6HZo
904	payment	1693	1693	373	1	1	16	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYcmu7Wxy7zQhkBARffTtKDGX7XFCaq9nfA7WapGRZcKEx3HNDQ
905	payment	1693	1693	402	1	1	17	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa2Eo6GqdXH8vnPwRbqXk4ZYThMz4jybrvXmCrWvJBrvgbTvemf
906	payment	1693	1693	690	1	1	18	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZwvPwBwwwB2bRWFzY5SQfrAfXR3GJTL5hmQMtEcGNfWAccYL9H
907	payment	1693	1693	731	1	1	19	1131327550	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa1KjqCx4goXqiCGBFt3AbyLRcTRRUvHFFUToFjPEkKMeEpLNis
908	payment	1693	1693	877	1	1	20	114859821300	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa6BXbbxd26Dv8SBoDrDQbiGyM2ECAAhogixZgPipk6QgWTikox
909	payment	1693	1693	191	1	1	21	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa9bCakW4WHhntcEhFLZbdVtEjPF3zjHEj7ogbp7edifpZesuXr
910	payment	1693	1693	122	1	1	22	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZraUcEdFuqCBby8gpcvzamvL1gTzkgeT9X4jGYH4QpFZBS6W5R
911	payment	1693	1693	5	1	1	23	3788250312	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYiEvBkdhKUPsMMwqbUShpZTFSceBJ9nzrgBhCbXeF2LyKa9L1L
912	payment	1693	1693	91	1	1	24	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYUVNynh1DBbmxucgmeGDpi4JceL3j6MkVjdAat64nPBZM4TPQP
913	payment	1693	1693	99	1	1	25	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaA4HYFgiUK5xLNdGq1Nm2b3yMgFwWzzjM1UV8TUqDGBEDcUJBh
914	payment	1693	1693	339	1	1	26	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYnks3JrjSN11oUg9x4UD7KMHyQA2inRkJiqPXvCPyUkqGvaESm
915	payment	1693	1693	420	1	1	27	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYeZVpBDN7c8TEmuVL3ftKf1up7ZoQjJT8At1Fd5KmZ3MpJffMe
916	payment	1693	1693	408	1	1	28	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaE8mrE7nwNeEbtc57G4sKha7kAF6LFXXZMcJzeCfcYLnr7viDa
917	payment	1693	1693	206	1	1	29	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZAgjH7Gtrwba79WVntBGyujunc1QE6teXtP6PaKn48d9NEFyZ4
918	payment	1693	1693	397	1	1	30	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZAb8MSMH8pnCnSxmwHcszszazBoZn2YRg293bxadGLBUMffRYo
919	payment	1693	1693	534	1	1	31	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYcWB4F7ejSeyZVvgiseo8zKSWCg1yXHD2mpR5r324v83bUZRE5
920	payment	1693	1693	570	1	1	32	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYSnbE5ioN4Tq8rvAGK6X5z4a6vFXcBiYMJo32nt4Z2ttDV24Rj
921	payment	1693	1693	894	1	1	33	173558610075	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJHJgnESQFv137BJmF93ZWtxEBXDjDL7Y6CrPsSdgonmKpnCib
922	payment	1693	1693	106	1	1	34	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa3wA33hSPRc8UqaoSxAnHbi9cro8HGXPRbLQ4GxkmEm1cpwtWT
923	payment	1693	1693	146	1	1	35	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZnj3isVaCNJ7289q6R8mSSg831R3RM71PPSN25mmKvsKd5pGNr
924	payment	1693	1693	251	1	1	36	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYtX6aQwLUUNFVKJZM78fhLVYr9LW2oKBYouhkY6jkEZckBzH9p
925	payment	1693	1693	89	1	1	37	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ6eU1PdYPxyobC7aSDNpYbhEjasLVxS2YxoH5RX9sKkGDCdnXW
926	payment	1693	1693	29	1	1	38	3959646441	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZhfuoAXd92xBVEhbGeYtMpm4Pqu5iKNPd8bhVjsdsfVJDrNrih
927	payment	1693	1693	84	1	1	39	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYdG4Vuxi3kKtrtW4xWVBE1HkkhzaMzDwytjCkGZigdNjw9Ywaj
854	payment	1397	1397	1678	1	1	781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RY9LLkbWZ6HuUu2NYKaZrSNovbPA2Y8yh2gvCcjx1VGwxWZr
856	payment	1397	1397	1678	1	1	783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19LdSQ6FefFWegamXtVKSdVpix5NR5UAxnnjSu2DCj1xMPoRy
857	payment	1397	1397	1678	1	1	784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhzhyVqq1TURUW4UupAHRnMumAAgcrtDpYrr5QDudRo73dDyg
858	payment	1397	1397	1678	1	1	785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTdoUg6iicunDbZGMzrfuEbroH5YycWxXwsdBL6eqetMLLTak
859	payment	1397	1397	1678	1	1	786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUioHJtfXyiFZ3UpTHBguXAMrvg67eg9t5q7a4Yp6rtwR5ENrv
860	payment	1397	1397	1678	1	1	787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5StZPcSfiHM2UG5PgEjcPcYx5gDbctRGT94A975cNRYzarjuh
861	payment	1397	1397	1678	1	1	788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSc3T12AaM21XMWR9gtpMgJ294XTBSQdWtPQchNtG4smxNS8tw
862	payment	1397	1397	1678	1	1	789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3VPCt5McaoJozGfG6bDWK9sg5Pyx87gXN6jp2nX2NmW5LNCH
865	payment	1397	1397	1678	1	1	792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WLRuS7WaAPaQC7DLhLfp3WZ6H3sL1c8GC74qV8ZzduS4Ft6L
867	payment	1397	1397	1678	1	1	794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4aEGgiX5oB4CNZpFwpewsTFs2vzLeqJ58SKd125m1AM8HEBu3
869	payment	1397	1397	1678	1	1	796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZkUXqH2XZr7eTXkxk6nDpgbUFC5mSqTypB7q1bRe7Rk9zN7z
871	payment	1397	1397	1678	1	1	798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7LgdiSc6SCxTMTHpvwLCkEcg2yegp4HJKCo7sUTewfptAWHB
875	payment	1397	1397	1678	1	1	802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XkzrUfGNQp57NnFdLEx33RXXZwM5VGFfrVis9WQEuA9kWQ65
876	payment	1397	1397	1678	1	1	803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacvWNdCAgcxDWjnqZSRcv3URbHba9w8nAihxZCr73zDSaYz9u
880	payment	1397	1397	1678	1	1	807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGPETvoPeDSbZsdamaVcWTFUCsWfJESosSEUbd2NNMKMUtHPw
886	payment	1397	1397	1678	1	1	813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSLj5hQHREeh3SdZR1oqX2wrZq9RatcMCjBKKQ18BvSjqmVXv
866	payment	1397	1397	1678	1	1	793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuSekXb24AMqPR2CHmWPX6bfFetQMwef98jNTpiaB4SBBaDbN
868	payment	1397	1397	1678	1	1	795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76bnPcoZ3DcEKA2TXqQWr1MMdC7vW4xS7fH7gMsr8Jm7Dqgqy
872	payment	1397	1397	1678	1	1	799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJ7E8pfASP4c6EkmDmT7WEYSSt7LSM9MvyAnXQdEMpEEaNs51
873	payment	1397	1397	1678	1	1	800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVzHqdH2L7Z19XoCWfYet7P9qktxuw1x3rkk4LHLVCvMpuRXM
879	payment	1397	1397	1678	1	1	806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQXVnu6cKEYxUu5wSqe5Q14gkrtdztRgMDYFFmySJDLrVy8Go
882	payment	1397	1397	1678	1	1	809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoPdbjqp13jDfKqYWdmDD2GdjnfXQimyzrQiTjNidiUMpwbqS
884	payment	1397	1397	1678	1	1	811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgbGbGLP5iHe4nRYZLp4PyKmpXohwYthwpdetN9LF58gHbENo
885	payment	1397	1397	1678	1	1	812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDXo6XkpjaLufDCjRVN9Wc7YCEaYRMyJfW6cDGaHdJQZG2x1kh
887	payment	1397	1397	1678	1	1	814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJ4iVU1xYqEqUJZ7kUYVNXMQA4dyXzmnxmNzJdXeanmspNcix
888	payment	1397	1397	1678	1	1	815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbPWxhr1TBZA6xs2DgN4oq7HNaxsuoXNGKwrsEuiM7j9f3XuP
889	payment	1397	1397	1678	1	1	816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxef6JnLXtXqoY9G1ynSHmFS1ztYtyE7sunaxsAhw84mY4aqD
890	payment	1397	1397	1678	1	1	817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6A1W7vmRyaG5eMqWTRrLxETvPJNeQHX6NZ35hsCiQbGRXgvyF
893	payment	1693	1693	309	1	1	7	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZz1ZkLqDf676C4bhDqd2fW72DgnJbFLtTaBVY43WY11DjQkDz6
894	payment	1693	1693	551	1	1	8	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZdKtSZtEhQMm1Buc5vdrMAszVcPnkLLLjW1WKMomVSgtUjfvsx
895	payment	1693	1693	217	1	1	9	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZLLz6gC9dYCJ1rafcDQ3xSptmNQkYfiZDDRmjtA3eHZtPH5WS7
896	payment	1693	1693	1030	1	1	10	509630166225	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYmftLTAgmZyuiFT6rspx7PDw4gJEuTBhYSbJZJXL7xfCw4abaf
897	payment	1693	1693	205	1	1	11	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZTuZnZnZNpXTnFsiA6DUF3p5itv8um6TGGa7ja9Ue6N6gwh3WR
898	payment	1693	1693	138	1	1	12	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZAzaEdVm6HS7PaMHpPKYQ8VvBcxvLcoNcJxQdKS4Rc7TPS4U1n
899	payment	1693	1693	275	1	1	13	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZpdA5TuCG9svQgTWo8NNLV2mfuP8H5JrSkVB1s7iMsLy7h5MaB
900	payment	1693	1693	225	1	1	14	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYijDWgEtzTYtL4tbSGs53TDaXom5YPFG2fW5d6TGAkBL3u4yaz
901	payment	1397	1397	1678	1	1	819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7tgPv3Dd2f1u4DQ1vRsaLvD3pi1z9CghP2xnizNYCqZujmuT
928	payment	1693	1693	92	1	1	40	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYWfyp3xY8bYYmCANfyBwNFgacEu19YSvDzu6dyNogfoxdi6feo
929	payment	1693	1693	395	1	1	41	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZEc6vSjipuyXoFxBWJnpp169W7XmDQTbkm9WiBvgmva7auyNXV
930	payment	1693	1693	587	1	1	42	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYRxZ9ATMuMPysKjQoxarYeb7jXAzdsJnBqM1jU6Yet1xde66eW
931	payment	1693	1693	611	1	1	43	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZt1bndmDWCVrJ9M92476cmAKDio9XhMH71WUQ6T8NBWkM7sPsW
932	payment	1693	1693	438	1	1	44	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZQsVL1j8b424BVXnj9ZGuM8S5krocR7PHzqRYee2dPz8vrLVSg
933	payment	1693	1693	710	1	1	45	2828318886	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa8EgeGSUn5AN9Rt9QGXgUtZhLzAZDacn3ad2BDy1YrZrxfQhbz
934	payment	1693	1693	399	1	1	46	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaJBzUVgfjLVZX4DMfhoaHyUz4NUc8uFNNrS3xbaDQeWsvRoRiP
935	payment	1693	1693	322	1	1	47	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ4yYX4qa4Pio1hr5pGQG5zgNNhjU5WWfKxycKHPFcFkuoDVY2d
936	payment	1397	1397	1678	1	1	820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKMnNgm2wQ8NucnjguJETszMFqH1DNtpZKqToWQUtJGXXHF4fJ
937	payment	1397	1397	1678	1	1	821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRU2YpVDMkzEmFLtCySfvacZHmtgxFVYRFiRMDpXrE4vFBCPB
938	payment	1693	1693	910	1	1	48	284393193579	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYx78fdpQAmyUKkRgxboiEjiBvqpfuvM1jsKeDAFuUextmHqoAZ
939	payment	1397	1397	1678	1	1	822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQK5HURJ5ycs7eUsfUrfu1jPAuYMeQeWVsSE2Z7oGkaNGHaJoy
940	payment	1693	1693	105	1	1	49	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZgQqCenJAMA2ZPkWo6ooQDWyYjGmVFwnKZ9tzNvXKakhrBADVp
941	payment	1693	1693	500	1	1	50	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZbcHvfMxBdrK7sh9J9uXa94xqatrtMYCdZXLVtd7dVZZtVM3Cm
942	payment	1693	1693	721	1	1	51	1131327550	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJ5pT48qWoL5YrvG47WXJ7zu7WPbNVuWDNB33C1o39RZ9UTv2S
943	payment	1693	1693	560	1	1	52	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYfxhbEor8cBiX5NNptbhFArampQF8jqFfBdbeaizrp77V9Kk5Q
944	payment	1693	1693	392	1	1	53	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZhWoWKnNRikn2o8WviUnGMTbjj6zodp6KmcLrFVVcisfVgdVkF
945	payment	1693	1693	194	1	1	54	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ97PgY5qeGvUynGQ6zkGyvHTGsExSSBB7HYgjiQgfRzRhCAnT5
946	payment	1693	1693	678	1	1	55	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYmp1v88oTLtx6KXzoroUEEzxp3NhN3ngkfHFZAGA5NW3mEAVM7
947	payment	1693	1693	320	1	1	56	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaESos74v47t7gwBbFJw9AjoZeXKzNPTwVNGzjZQt76UptPpJqG
948	payment	1693	1693	295	1	1	57	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZCJ8vZGcsSpLhN5qzYR7Ui3xsBtdb3iSTCo9JNf75HXSjAA8Ed
949	payment	1693	1693	78	1	1	58	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZQomq6pJComPqHjn18bPuPShx4CmxmUfRJtvuVbbhQx9jxVseD
950	payment	1693	1693	54	1	1	59	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZaj3QapoFeM3bHwMVFfPgxf7QyoApeMxTXLJm2W3YUEL7ceXed
951	payment	1693	1693	594	1	1	60	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZDQvPsJZa1XfuhFb2YeTdkLRuAeLruQy3Nad8QC48TfmxCJAVw
952	payment	1693	1693	37	1	1	61	36953683265	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZ3wDhLzBtU3eyoruYZo6EEfs1ZGuRwvUKnjosNpXKpHzmjUrP9
953	payment	1693	1693	1150	1	1	62	343857628251	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYqjaf6DFuerxMjp9jX4qcL75xpy88oswkTG7uaubdFo19aGyod
954	payment	1693	1693	163	1	1	63	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZwyhbhxvbPNNEDHKQFxzaFMtWGFEGWuXe8aN8e13cNzkVVSqgb
955	payment	1397	1397	1678	1	1	823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZytm9NZHQnVyhv6VsizsEb7FoALWXuiLWCrGpGxic4oNx5Vc
956	payment	1693	1693	452	1	1	64	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZXHDrjo2PzA2bcavq4EaoG1fkWdYxwoUvyURBDVACE4CbzQUpQ
957	payment	1693	1693	739	1	1	65	5656637772	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJRz6agRR7zF8r5VhLNSwticpDQQudBH3Z1ARbDy7wDTGjLigq
958	payment	1693	1693	893	1	1	66	173558610075	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYiYx59U6Xs4KAbJgf18ZuWmcTCBCdYxdynpErVDqPV3iF3oNZi
959	payment	1693	1693	150	1	1	67	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYYE5bjgizjRupd7G7QFKeGk3iX5yCNqrwSYLdupBAwXMzky2b1
960	payment	1693	1693	252	1	1	68	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYmpVghJ44VAmVu89W1XLtQD2Qt7NwEapczXkpr85ahdu7Gk83N
961	payment	1693	1693	450	1	1	69	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	Ckpa651C3TNhy4PKTggfJpnZRv4AXVeNMDz4AjicosNFRM8X8inQo
962	payment	1693	1693	620	1	1	70	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZskqfa9hQXkAargwV8AHW9wk4iuHo1nrEX1BmDR1yvDHm1nkvy
963	payment	1693	1693	245	1	1	71	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZJNUpZeSzAYuDDfYdQnFhC8DmqBLzP71JNZfeApBje2agWB5R7
964	payment	1693	1693	421	1	1	72	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaDJ6oxJJEXnrpvTKSecWXgyiB4vwYDVMPNSBC3k9nRCY1Ym9mp
965	payment	1693	1693	520	1	1	73	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZWc9fAGdzjorrdmqxNypMzLdfgjn2RDEETbUpwP8hgNTmiX5Tc
966	payment	1693	1693	622	1	1	74	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZhNgweQZrMwn7G5NDPDugSYRN4n2x1ppbs5gk1nJGfVH2GUrDX
967	payment	1693	1693	652	1	1	75	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZXswS6X3qT48S6xPCuTQ7sERAZ3HQmA6ZjqUK2LKoyDsFFGQS1
968	payment	1693	1693	1276	1	1	76	958189855230	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaADceDeuoTD9Dt5ZrWG9rfXRVSBi1c4oYr99BMkxyEfnUZ3a28
969	payment	1693	1693	108	1	1	77	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpYiuhwqowno995tDWqQdkwWBnp9M1X3QGcvKEQ7DkDjJFu7YNqW
970	payment	1693	1693	180	1	1	78	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZdBcjHb5u5DU46fb7oYZntU1Jp9EYmMAXkyQP5bEDFqu7e4UwE
971	payment	1397	1397	1678	1	1	824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3wpMnuge7JN9mbfbASsYspUdPWetXrpLSVvbqC3KuZ4po7bR
972	payment	1693	1693	353	1	1	79	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpaL1o7itmqHyxkV9tWJKwMU6TmA8yKGBbFF8efbfN5DifpBrU3f
973	payment	1693	1693	390	1	1	80	37333809323	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9E1PDa6EMEnqxzGZ9XgNCW	CkpZVaCTxLhMh1YCm1nEvQzC1XcEv3hYUMRFsfSuox4PSGeqaL5MC
974	payment	1397	1397	1678	1	1	825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBYdLrg2reHpXj1aqG37ojZaMY5ow8CuCtNsNsVgBgW4fw2Pc
975	payment	1397	1397	1678	1	1	826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWywUVDB9we89H7xN1CeqcCNRkjPh498e2NtKoYxemqry9RAY3
976	payment	1397	1397	1678	1	1	827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBuZ26kwrhDcRyP7CiCReMWnLVmBU17opkaMM745w1CDhCA6s
977	payment	1397	1397	1678	1	1	828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPea6rpzBMDgtVTEYjdLbXR9rGFHzGvVp2DDRftrDFxpVo6nf
978	payment	1397	1397	1678	1	1	829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6njB6qoAUT8BrRVMSrbeWFaYHeQMbPYT5usLc1sLfYSadLpr
979	payment	1397	1397	1678	1	1	830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZM3hKTiGr9XaLzp8USovn7nYasFvNkiRVwvtMv1jMdz2JhEzu
980	payment	1397	1397	1678	1	1	831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnyyRygzEDfLY18iqdWYzkffWwVqeeuRxsY1ASvsrMNDvJeLC
981	payment	1397	1397	1678	1	1	832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWA9xhLowWFQQvXSzZHe4uUhL5GJJsxPTGGPGdpjeEw3ec37A
982	payment	1397	1397	1678	1	1	833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcN1Jrew96mmRqbf1d5JE7DKTH2fmgDzcGoZGN4qwvvaYjsRV
983	payment	1397	1397	1678	1	1	834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRR4UKA9Bhjc68vnGpatUWDeSSFWTAyDHZJBWJXCAddtS9856
984	payment	1397	1397	1678	1	1	835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRfZDSJSboz1gmNfEt76r1D5DjqPVE5QULYeFczyujkXu9kxm
985	payment	1397	1397	1678	1	1	836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkV6i9arWDKsBv7RNWkp5vWMiYWDypES6vW2ycDZmG5VQqeVQX
986	payment	1397	1397	1678	1	1	837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9JNjTksF8buAWM7Z6NKot8gW8pU7i12uneQWV5CYdiUNwvMH
987	payment	1397	1397	1678	1	1	838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTnJhDJgDg95ZSUFoWCZ8TRSbiXb9Cv61EBk3f6hWQ7X7Yvhp
988	payment	1397	1397	1678	1	1	839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTySKsA7JFbwbScnBag7j65qmeTm546i7dhEZFjafmCh2ueya6
989	payment	1397	1397	1678	1	1	840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwRMySCkVXcAoiQYrqqvGZHhsHrSfHRYaX4FcNU41D3S4ppCy
990	payment	1397	1397	1678	1	1	841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSuZFqvWy8DhVjgiaEb9ErBHKG8ZF5unsHvF3xmeMEoCtLoQo
991	payment	1397	1397	1678	1	1	842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoopfzhK7xadWn5dJ3cdcnL6WubyE3p32fPWrmTSZDa4EaDRK
992	payment	1693	1693	569	1	1	81	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYiziXroTM8xSfwW2oVDHaq9VsDkekjoryy5Gi6zP3juMsj9gGh
993	payment	1693	1693	745	1	1	82	1131327550	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa3DGuLEx8PqueRxfecvsr5spJpkRFxWYDgYHJczymqfD6ib9ia
994	payment	1693	1693	41	1	1	83	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYj486qBz1vUirrqfP5WV8gP58a4VfpQPojd4eENsheC3S6EBTe
995	payment	1693	1693	308	1	1	84	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYzMzAARrpFjL6sQFXBCFuxNbNrM1zty1KcmziLuqZdvoKS5Yci
996	payment	1693	1693	878	1	1	85	114859821300	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZmfDWxHyWEgnzqnJcvPRvLp11ND7U1R45RxY7JTFzRha9kgwqb
997	payment	1693	1693	186	1	1	86	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZHecnpqw9UXYBCQtkJRfZAc8VtkTN9yG1kaiEj7XHGrKQ6fwsA
998	payment	1397	1397	1678	1	1	843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qeokzB9NMpfqPq7xEx8tE3axt4NqCfj5N7gYxyTh7sTtUNDQ
999	payment	1397	1397	1678	1	1	844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVULdHXmKxMdN2yjVYziJyLVhQGaDwRvhwu5Puje8vhwU2Zfr
1000	payment	1693	1693	49	1	1	87	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa9d93AsJQ22iFRJU1q2cijWxiBSsuze7XUa2ffnYpL6N3TEMnT
1001	payment	1693	1693	112	1	1	88	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYq1ExBw43hLZTeV7Zim3RqHGdVLh8Zp7kR6QuMA2xy4AnCovcR
1002	payment	1693	1693	383	1	1	89	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYt48UfcG6KHGB6N1cZiFg2aXjWrbfYfLbTRwNshe8shhnDdXYT
1003	payment	1693	1693	663	1	1	90	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZEzQhuWbMEYXw9MxkFkJcy6SrqkTVuat2ko6aq6svnEnudaKbn
1004	payment	1693	1693	499	1	1	91	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZbmchK7NCFNVkdfVaC6Ptwrvx4r3hMUgR92TbatdcocUuAUMPS
1005	payment	1693	1693	35	1	1	92	10860744526	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaA8CX6Urm7tovRJVL2w5FfphUj21tn8koSiJZcUT3D7ytU9mCr
1006	payment	1693	1693	453	1	1	93	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZgNZHB9rwUuxBQ7LJPTdjHF7a2oP8CVdCpCzXmsWjM8xzuFS3Y
1007	payment	1693	1693	82	1	1	94	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYrPfKHotsyfqni7a7Nd4W7mjTGBo8Y4yMmMbmvQcpeDnoc8SiR
1008	payment	1397	1397	1678	1	1	845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWGTjUyqnoiA5f1PNgLaNHqtvuKT6EwQP21NSgALjpBUqtdRe
1009	payment	1693	1693	201	1	1	95	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaFjdesUBxrpUEdEF2uh2f2Qd3FTTJBaxxGqcfBQHd6ohJ5aQ67
1010	payment	1693	1693	103	1	1	96	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYYhE6BZSizS5UH4nohuamg6rMUpEu6fKq9rHVPMNHfGTTS1ENe
1011	payment	1693	1693	261	1	1	97	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa9PghrnGHza5f3NBbWYfb2pqH2qzQo81w9UeWGW4wpXa4NFg8X
1012	payment	1693	1693	361	1	1	98	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYgBNUvzzzqaAqmFyeoFf2RvgJg9Rq7BnDdRPNj3W1Ah9vKKvBa
1013	payment	1693	1693	680	1	1	99	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZuBmRcSjebVgjd7uRgRuLpuBAaxgNkxZJ67BwDYmgqA1GGfmVp
1014	payment	1693	1693	63	1	1	100	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaCbwSd9pjZjwPdty7uC4uDRugkHLz2osvqr1zCQqkcbDvAVAmk
1015	payment	1693	1693	377	1	1	101	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYm3X1aVxfuHJPA6BQ1NUy7kbSXSTBXyVQhVz3nxpuxe1rEm2La
1016	payment	1693	1693	266	1	1	102	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYrdsuupb4tjhuVGTXoGguevBDJx6RPy5RWXTpY7CnfcJCGmB1F
1017	payment	1397	1397	1678	1	1	846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvkt8CP8ZfsRz23XyrVaFtavUGdQLHQ9XTsh4HBYEewuX7hX9
1018	payment	1693	1693	600	1	1	103	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpaAb9JEzqjgmzZo1wkJjotMQG6yqAgbHDzTEeFoSveg3VFyAH7P
1019	payment	1693	1693	691	1	1	104	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZYae4upDjrnYaoSbeCDLTETqdRPc3Cbwpf2iKfUCSANncYEqGP
1020	payment	1693	1693	352	1	1	105	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYQf6JRmTxWahKwwgiBEL7HcXmAqAN3HfPYudtNzLswYLuAXK7u
1021	payment	1693	1693	601	1	1	106	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZwkR2wb73CvZRbC6PWQGQ5uBnjJ6cmzNmB71Cp7mmr7bqgvsin
1022	payment	1693	1693	504	1	1	107	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYh7gbS4T73MW9Nk8VzogRQT5GmeYNCyziJyBQRHUxUVULqiavJ
1023	payment	1693	1693	658	1	1	108	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZuCXAyMC2k9tajmy3ipVxEGga1tiBgKdaDFBcpJhNv9E72xQcs
1024	payment	1693	1693	6	1	1	109	18416881266	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYdLznMum8NSJKxJPEiLD9PnP9g7mU1B5tZakrBEsWiPrqLgVLE
1025	payment	1693	1693	391	1	1	110	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZ3kg54NCVcoXQZuLRd1W3yTMkqTjGbMLqWJkR9LCnKPATnLeQA
1026	payment	1693	1693	660	1	1	111	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpYTJoYTQ2B1hohvSNksBXAXEK5smR79SvMoKei5UEq8vqQ86Gnu
1032	payment	1397	1397	1678	1	1	849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfm1QbaFisewPXZ2dchnomVvcHZpsxs5CUuVqMhUAN7Yb8HLUH
1036	payment	1397	1397	1678	1	1	853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZ3SnSouo6isGAjdQpaqEnFxWhK9URCih9G5bWJBwkjuReT8x
1038	payment	1397	1397	1678	1	1	855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Xbgv1vLkvC4QHocrWYnumy6Gr1fAH7YS3Bq3o5onBCMgMTav
1039	payment	1397	1397	1678	1	1	856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFFp1S4DVJKwFBzYa7LERkQNS6KmegcsWc6NXryrAKFEEeaiq
1040	payment	1397	1397	1678	1	1	857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmstVYaSyqMjxzEhXCgZAzQGxeX9qhhGzGFydmh93TXaWTDYA
1042	payment	1397	1397	1678	1	1	859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jvnApWgebRmWf7nLERKvy6SnRo8VjSWVrbauPfeGvZc5J3ss
1043	payment	1397	1397	1678	1	1	860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iPrzmCJFRLkmKcKSNkBjEeBp5kye6aYXaQLVkBvrUp9GzRrq
1053	payment	1397	1397	1678	1	1	869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gsMkXJQVm7Za2xQPbJ4nftMaE6aTRMYiiBuuX5RJEhgC8TbE
1054	payment	1397	1397	1678	1	1	870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFubU6vVXekYG1MXBTrieVp4hn5p77w5LUeJUEeKwDwxdPMhX
1055	payment	1397	1397	1678	1	1	871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTq6ggf5MjKoVLH5QcBgN9fZAXD9BXxZmaPEanBzomZb8z7UT
1058	payment	1397	1397	1678	1	1	874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqA1PqLeowhAjQnWFXr2d4CQw2oDUNAsusGtJteEL7WQJWyhD
1064	payment	1397	1397	1678	1	1	880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBvvNfsFA2RNUSRvpKXTSEddnaBJACxst5vHNa5dByziK6WHJ
1065	payment	1397	1397	1678	1	1	881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1LT6X8LfuXvaNJ273NyqkfTRW1KmLuHzGeUGimykQKrwF5oU
1069	payment	1397	1397	1678	1	1	885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2H3tkeda9pqh9jGrRJpguGXDWpBnqqU9TxAzmEt9X6mNXcgU
1071	payment	1397	1397	1678	1	1	887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoc55TRGprEjfAPztpHjMkVAZME3iwARVH31AUHCGWodtD1VY5
1027	payment	1397	1397	1678	1	1	847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptSZAoox67AhMHSJy9krH8spfi2VduSWvRzR83NfZBTVizFK6
1028	payment	1693	1693	193	1	1	112	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	Ckpa5moi5j5fhmKGqS6WxqdMoxXsYwmhdPhystCjWBXFir94BJeYy
1029	payment	1693	1693	593	1	1	113	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZ7juMNG4FEwReyFvEkmxAQbE2rZn4zBuYQJxhbnFiqqMkALRtK
1030	payment	1693	1693	653	1	1	114	37333809323	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zYw3umVKtqSVLhVnjpisJrH	CkpZLkoG5YX5gVyJUBQZgk96SNpBdmG1UF8jokEFjFfRRaqY2acVb
1031	payment	1397	1397	1678	1	1	848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjDkT79Pm7gqmGFF2Vf14ESBSxQDFNB7tnEs4tEKQz8iN3bWP
1034	payment	1397	1397	1678	1	1	851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswWiTx5VKSWc5mjcGVigpgNsHj6qFGKHe8K5WLSfbaAcmwWwn
1037	payment	1397	1397	1678	1	1	854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZMzWXE16MGYa6Z4HiUjDZud81fYk71WvbpR96VzuSTyqC6TZ
1041	payment	1397	1397	1678	1	1	858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVH1Z8zEtq8sVqb4oYVUJ8Yp2XM6Ko1ELVhbBNiHNqnArNv5VE
1046	payment	1397	1397	1678	1	1	863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1T26ympX2kvZ7fQ1BA1Vy1waLTV9MjoTw5fkNRCGbZ2wbfex
1047	delegation	30	30	298	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiTTWbT75wW76qFAsxjGzuAUnxwAPkKgmeq6Ro81Cc6GvrTsq
1048	payment	1397	1397	1678	1	1	864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjXJ33ctVm12bcaoPv6TaewLtTYoN6GDc38EFRKV5zfrtRgtx
1049	payment	1397	1397	1678	1	1	865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXz3cMmhGUMmnBPw2sKbfd9p2kCSXfBk3eTibMxMAGqGxNTM7
1051	payment	1397	1397	1678	1	1	867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbMP2sCY2XW54V2GWvqVLFaTZ7L5XdMh8kzWMiykPuQNv95X1
1061	payment	1397	1397	1678	1	1	877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4z9WXqX7cZvb79WF38YJbnTpv5ZP6PZmg96ZpwD9epdXnVMS
1062	payment	1397	1397	1678	1	1	878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhJUxJCECkgpoBDjpu98piNHZZvArvNkRzy4Uxr79qEr5LXbr
1066	payment	1397	1397	1678	1	1	882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaff33qVbeydF1aqyVwdEpjGhBy97vrcNRJFhouc3Zc3ARu8C
1067	payment	1397	1397	1678	1	1	883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMVSB2r2ufFusbpq3UiGSaNVPVi5ehAPAFfdBeTkCsmYCYM24
1068	payment	1397	1397	1678	1	1	884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqd5mG9dL7eTS6WDCPoqWJpRnvS2N9nKV321V2F1pmNTKeWwj
1070	payment	1397	1397	1678	1	1	886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX7xABbYS1L3J7jErCBhshxjgLGg41vUh8keGWgw57NpgLuvSh
1075	payment	1397	1397	1678	1	1	891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gSsSV5anqtb8FSp8otT9apbdk9gRudPpa7SCWqe8b5SPN8ZC
1080	payment	1397	1397	1678	1	1	896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBWezfxqjiLM2y8F4yThfzRgK66uzKc719aFqrSgecdwDDLTA
1088	payment	1397	1397	1678	1	1	904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9U2rGMfjAgp9j5TC22boo9a7oLPGYLt677XM9uhPt2UeDJFZ
1033	payment	1397	1397	1678	1	1	850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8LQnXuMMjronVPuWMMM3MahndbrvKPtWNa6L7Z6j6XEGKG8b
1035	payment	1397	1397	1678	1	1	852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUHPNtrN9shnGGiHVaA7SU5j8iDTvxLNMnG37sirSnC14NoW5
1044	payment	1397	1397	1678	1	1	861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5WoTHEZuiFSznjczpK2EYbHzNXEvXz6q3czYCfNaqPbCeGwb
1045	payment	1397	1397	1678	1	1	862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQsUtmzgrpYQVAbGbYPXqABeza1z4uvCgKsx6FFSQUduVtNSs
1050	payment	1397	1397	1678	1	1	866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7UiYToJBrZ6k8WnVUtgEuoPjd2YZMbHa97RgJ7SYnTYyMV7f
1052	payment	1397	1397	1678	1	1	868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUyhtGmvL94tdhasLryBf9NnN5rX4WKvEGxVfu8rpGfuVHxpL
1056	payment	1397	1397	1678	1	1	872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7E5gFiRqu4iEHNS3hAdsW92RLH7TLXShSQvCiCY99hPDjgR3s
1057	payment	1397	1397	1678	1	1	873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvsCZQAjTUTMT1RB5Tw3qfGDbPt3qPKnaRxhVEFyqjoBrfoWk
1059	payment	1397	1397	1678	1	1	875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcNJYZYfsMPY9f8DWMYhmPnU1M2RtxHys6i72GGdGWJquA4Li
1060	payment	1397	1397	1678	1	1	876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMHhLF52pgjX64YHx4m3YazNDTL4Db1CMkuMTidzvRd1YHb6N
1063	payment	1397	1397	1678	1	1	879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7s4dJbP8rCENebTd1BqrghCH7AtUNwcUx67rPpKsdXVxvJ4TZ
1072	payment	1397	1397	1678	1	1	888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1yRTYy45fZE2442CSyNsYtBEScip6pw26rBfsdKVioit9j6o
1076	payment	1397	1397	1678	1	1	892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9ReiGR9t2kaFGPhFkCNZDEomEZkLz1bwToYhvqjDut4fsLhS
1077	payment	1397	1397	1678	1	1	893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm5swURYrKY5xFbrkcq74kqr7iLgP5h8miSE2tRvp9WmC1AxA
1079	payment	1397	1397	1678	1	1	895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWPKbkcipRkMCEpYgbwcjh6Ph5qFdgW8hiZhyKTh1cVheQGzm
1084	payment	1397	1397	1678	1	1	900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy9S2qHdfuoZsLMPjZHs37CVSAca4x6GXSuGN82R4ZMKHAQGa
1090	payment	1397	1397	1678	1	1	906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoQm8iUTC5dXjv6Wnf3AGBs92yWjhF1raZXjCHp3uLJwiQkuK
1096	payment	1397	1397	1678	1	1	911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrynbZfohWYNzYvkfCt2rjYtk2wYQ4kXEdSH1GyjF8oG6SZeE
1097	payment	1397	1397	1678	1	1	912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhb1u5oQAgdXpp1U3qxLfwhUWXrTaDaSoFR1H5ymSqW8ZS8v8
1098	payment	1397	1397	1678	1	1	913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEaomNssVbvbmtmHvG4Vcf6ohDmaVWRB2XKJUePcozdaXw3Lr
1099	payment	1397	1397	1678	1	1	914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6qQYgZ2zBpf6AoLp8e27bok9vm7rAWkTNktagqtc2MSY6Law
1073	payment	1397	1397	1678	1	1	889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxZ3zsHwGSXVDMXeKAqtvaMT2tk4gzqwShkv8N5FDiswfH5Ln
1074	payment	1397	1397	1678	1	1	890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjW7Z2SnqYrWE3GeUM2sg7rJtFLGoUWSf63QCLuiWgdSqfCUtX
1078	payment	1397	1397	1678	1	1	894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoGSYbk4nwRf1JFfbc8iymcJ6ie4de5AjbgA4gF6QiCLFVzYf
1081	payment	1397	1397	1678	1	1	897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbi3XvcmZfXJgEjuUnEF7Q4ijCKSabb4TJFPhcBLycMTFXpvj
1082	payment	1397	1397	1678	1	1	898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZsgS3KKSwXUVKMEdcSpzpsRXRXSWXvK3FatkyJxy4VtCJQmq
1083	payment	1397	1397	1678	1	1	899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfGY2iPPHCZzuJ8dBNSwaPE3HfnyxNckw6mHbqZyU1rpfN5MH
1085	payment	1397	1397	1678	1	1	901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrPtKt7oqtjBS6YSFBN6kmHaqBc8HrsKXTovjZvTKf712xAXe
1086	payment	1397	1397	1678	1	1	902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj7wTqUJezMe6VrsDs5sBBUWpykHdCYpaMTjreCqcYZk5LpbG
1087	payment	1397	1397	1678	1	1	903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLteNSxKnikk5MSnkNaWaXSPzeJPs4BewdKy1UbhVfuxcvyWMn
1089	payment	1397	1397	1678	1	1	905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3918Jpa8CuALbQebRz1W2pjuUyNj3h1VFmTg5JaAs3kAVkbXS
1091	payment	1397	1397	1678	1	1	907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaYt58NeyaSCpuergRwxcsXXgFr2QAfnRKDxgNtXQ371B6osA
1092	payment	1397	1397	1678	1	1	908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2f72nXK9cLakGJ4QLAFUYpTQHLZfHrtjZNvgwHxf6iceAznY
1093	payment	1397	1397	1678	1	1	909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjcb3N7kMtYkrnsV74kD8B6P2QCbwcnZH6cHWfcMT8LXgj7Ue
1094	payment	1397	1397	1678	1	1	910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkQkiGwZeykYamkscNFZvqzPXRTByp8D4WzK7PAAtW8h3d2Fc
1095	delegation	1733	1733	1517	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BFzXEtEXQHMVBvw58iwAp2CyrBdApq14wk4wzwPqMZW4ApaF
1100	payment	1397	1397	1678	1	1	915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9DFBNXBr9aEeEDHwTQMase5mf5zBQLtfo3PGxgf5LJHX8eZN
1101	payment	1397	1397	1678	1	1	916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4oFdvTU5Q3P7pfHbAk6VkbY6m36DKaKnzhkXRV4PBSMXZSCd
1102	payment	1397	1397	1678	1	1	917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQtjL1n4t4SE2XsHQBpAVGsYRuPuRWiAiDK5L4A4n149tT3b3
1103	payment	1397	1397	1678	1	1	918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWup7aByhBDZi26RD27XPGh27QMy4hbz4ojWzrdGLNwPniujw
1104	payment	1397	1397	1678	1	1	919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJhTjPhVrB2MuHDTx3V5dTW87gEyz9Fr63L1STtArkaAceYjK
1105	payment	1397	1397	1678	1	1	920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SFSknTBw51rXgCv1ifegLjFL2P5NNCvkZ9FmXyErEEhyYSd4
1106	payment	1397	1397	1678	1	1	921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLEN8xtfbFymdXp7NF96B8genfVD6fhBSDva7BCnGeq6oZpYU
1107	payment	1397	1397	1678	1	1	922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81TSQCuWVLPxJuKp1fSZmaEBEb2xoArYmWTGQJyfVUiqWfCZU
1108	payment	1397	1397	1678	1	1	923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6kBxv7zyCeDT2B2HHQRVEHLYKamyctGAwTZzFVtjAeTcHWrM
1109	payment	1397	1397	1678	1	1	924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAkMDxFV5TVspPLHzgxf2KPHtArnfAwkomL6Ze8TR688T7TEmG
1110	payment	1397	1397	1678	1	1	925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJY1WyMaZbCrMN21KU8Z7epJFQ6SkKLMZeKUwKn2bVegyACaK
1111	payment	1397	1397	1678	1	1	926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkG1Jvowkyd57KXHMWp5GNVS5UA34eSGov6rsMkoRL9h6DnMT
1112	payment	1397	1397	1678	1	1	927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiedxFNncaxS5vPBXM5ypbA9krr5fay3q7ipstnVEJUJC9k4cq
1113	payment	1397	1397	1678	1	1	928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnUUxyuU2sFgQBoCAA1RMiEtpYjo8cLgqRNteRViNQRi1QVL1
1114	payment	1397	1397	1678	1	1	929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRaYCWAc8ZHziucDp9nkSrqv5YadwbpQyn62LFqjLtkcy6s6o
1115	payment	1397	1397	1678	1	1	930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wi42ENFvihR39s1H1UmRr4WuVeMj4TyVchBGvhd4Rs79bnXq
1116	payment	1397	1397	1678	1	1	931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDaYrq7DSkCZuwWPfZB63XU6DToSCYwv9VR4ydn42h5xpT4nV
1117	payment	1397	1397	1678	1	1	932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRtUeBEqEaJTrU72KZNp7z4NJYkx4xaFe4fpwywBKs5tAzPSa
1118	payment	1397	1397	1678	1	1	933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2RWvqDQAm4dS9cSNRbPZkin8bC3hQTLQx1wHMHX1S8FMAqnK
1119	payment	1397	1397	1678	1	1	934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCQAeA8kiCpZidtb1So3ATVwTA73G1HxvVBBrvQi4kSD38b6m
1120	payment	1397	1397	1678	1	1	935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5K3CacZKjJAYgkRBe1MR1ginQt3JVpesyaji5HRNPEwSdeuD
1121	payment	1397	1397	1678	1	1	936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTetsMP6GLNzFrvSVyeYLyiZHybAPoYvGZZHG3EGkwPo3SSntR
1122	payment	1397	1397	1678	1	1	937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6PqGT7tdvxeq7QpHeuAN841fSYWSpLniXyMibQUHwzFCVbNh
1123	payment	1397	1397	1678	1	1	938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtv9ThcPfBXcmvJ1ANgzYLpmJzG8krL6vS9N4LbKBm2haDbxt
1126	payment	1397	1397	1678	1	1	941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqmvkQwabHae5HgcZBiJi9om8CGpC3E5JZY9e2x23dLvpzjLE
1135	payment	1397	1397	1678	1	1	950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKHWBiF8Hw5EqM3DsCdTpLio19VDZDunK1Rso27ZZBvdG7S45
1138	payment	1397	1397	1678	1	1	953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw42VL6HB7tkkSytJcRTfqMbVAEi5FhibteStN3s1WV7bchu6R
1141	payment	1397	1397	1678	1	1	956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYKkyJgbT658S6DoddzyqAgf1qQ1Uzpz12X4b37hHnsYHnxqw
1142	payment	1397	1397	1678	1	1	957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUL34kyjyjksCtxFU4hLTTe3YByL6ph1QpXt8fLccU8pA2i1K4
1148	payment	1397	1397	1678	1	1	963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvvaJrFcSgYLktj7JLzmSHm4H3icHg67P5CBTrJzd3B1rHXaj
1149	payment	1397	1397	1678	1	1	964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZozRHXfdZkhZm2kBi13ykhMuzW5duejbCp7Bzbzg7UvqQuxkKJ
1150	payment	1397	1397	1678	1	1	965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbTCa7hka4sDSmN7MMW6fgr5tuF7YtU5ytM6zRqwxrteRpe8g
1151	payment	1397	1397	1678	1	1	966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDsVMMo6rZST7Cpvdb2L45DvuQ8LjwgUqmvyu7XaK5xnoJ17d
1160	payment	1397	1397	1678	1	1	975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQuSCAAbJxoZPMJwXZNxkyr25ZtEuNfhwQyJzxc95Lt6qMhuje
1165	payment	1397	1397	1678	1	1	980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Zht25VQXs1FeKo4WZg9ySM9oytE8dQXFRUT8NoFMuZjTSTgF
1167	payment	1397	1397	1678	1	1	982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPgRxkU2syMNc4wKEQA3F9jpo4KenumyZQbNbc1wUwWiPrZtD
1168	payment	1397	1397	1678	1	1	983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7QzXEQK3sbBSzM6Nff6XeHa6Zp84ppY99oFA7ba53y5L6FtL
1170	payment	1397	1397	1678	1	1	985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wdrZvkTRcc5W5a2r24RtkSPGsGepKAziffxiwPF4A1862GB8
1171	payment	1397	1397	1678	1	1	986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3v2LZqVFaxM7zrf2AdD1zEp8NSCxVPj3bX5hYBLTwHJJyLgV5
1172	payment	1397	1397	1678	1	1	987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaf7WA7qKF9M2nSRF34ZpyAzC7pgyDmRUNpqqh6fEpcfNFzrG
1175	payment	1397	1397	1678	1	1	990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRDGJ2Qtb8eLVE9NK5fuwutGgZzazV7ASkkhMhfDB4DfTF5EdJ
1176	payment	1693	1693	312	1	1	115	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZun4C6kvYmBnxf26cpBCP6R99KM7z6MLTiDsBMCWd1TK9WyTin
1178	payment	1397	1397	1678	1	1	992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqxidjqBoV8iPn4hWsxLHeLfFqkeLxbsJs1QwwEdaXVMhpLEw
1179	payment	1397	1397	1678	1	1	993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiztr3TJjGVByhE2XgwZGw1YJ1HWDSEtWKDaAih9cN6JNpaTE4
1180	payment	1397	1397	1678	1	1	994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJDjWhNRFsoLQEK4iSicYfHycXZo2cHn5Ni9eTWiZtYP6gXj2
1181	payment	1397	1397	1678	1	1	995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7whRwp3x9u9MxBMTYkTsVe6gJpuqzfjWerboEvLbavXGV7sc
1187	payment	1397	1397	1678	1	1	1000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7My2QspHJ8ijHgzJn1AWeMvVQYgykJuXCAoZorEb5k5jPya3N
1188	payment	1397	1397	1678	1	1	1001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1BtxE83eLiggvjsHMvmAfHaYNhcxPmUQZUSofBQWHaB9cojq
1189	payment	1397	1397	1678	1	1	1002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZndFraC6HrehTKHzzQjtQh5FUXd3YJw2ne2y9KNj5k9sAyu6x2
1190	payment	563	563	1740	1	1	1	2158000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGS7yQnL91gW9io9xc7jXw4MdUJBsMKugp4v7UgCjdvvh2jM4j
1192	payment	1397	1397	1678	1	1	1004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjnXSBQFNSnbJ38aiQXBqNFVLfkfQzuPQM6Paxxm62CJHbXw3
1195	payment	1397	1397	1678	1	1	1007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKqzndjBYWtDrd2R3wjJz4LaxhRiJGeEJB9mqPJUb6pRFM9VX
1201	payment	1397	1397	1678	1	1	1013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoSSyPTjn5YhdaG32hxpeFKGE2ZE82L9jEqWWL5zjYPHAHS1q
1202	payment	1397	1397	1678	1	1	1014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQwrv3MftyRE6ecJwS56XUg5Etjx4x3mkEP9cLHB3AXhfTpxj
1203	payment	1740	1740	1748	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6F9NLD7pDHzACaocQAw7ibXAuNfAPPjYhkRjEx5F42phRa5Q
1207	payment	1397	1397	1678	1	1	1018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWFDi6oCkVEGcewCMkGRhic8HV6wHxDrHWHmddWddaaMrkYop
1209	payment	1397	1397	1678	1	1	1020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUapdv7QtFE4qezPgv4SJq3CXTpsDM3ncATXyAtfpX5BsoBMex
1213	payment	1397	1397	1678	1	1	1024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxe1SMfJPSBqd9xq3oNTfUL9aRovNSeb2SiD64xVnx4aJAwyw
1223	payment	1397	1397	1678	1	1	1034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJhd3SJMfmeHN1pNCXH6CoPeVYnm5ZT2tASQeE6F2AGMdw8eV
1224	payment	1397	1397	1678	1	1	1035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTo6XRfU9bPe1hfDyDJcfYfK3K8BcAmZbeqHB9KoZDsT3YaHQi
1225	payment	1397	1397	1678	1	1	1036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbz2dnXTrPiFfW69tkPAa86SnJVfCNU82qhuFvuMFLbPUMM2P
1124	payment	1397	1397	1678	1	1	939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRk3CvUPchu36uuCFbJ2MghFyeJvZ8xkobUrMYKoN5YLRpTNLZ
1128	payment	1397	1397	1678	1	1	943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDb1xr12EoxYZapwuL9DVqF4wmzAXJaQt4LcYpgZrzRi3zUdM6
1129	payment	1397	1397	1678	1	1	944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFRSD7hmuayw2rEwJ2V2cJq8WSUguLhLxPb7nGztGtg2cx9t1
1131	payment	1397	1397	1678	1	1	946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJWShrxTrVXr3wLWoxe85kAzYfiwZJBnxHFy8WRtBuKz6M6tV
1132	payment	1397	1397	1678	1	1	947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeuyTBVBqQzKzuKRidYkmbg8p3k2KaWZQtXMC7eVXCAjre31F
1133	payment	1397	1397	1678	1	1	948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvHKGS6Q77E1aLmjaGUajC7WKxZqnjkHBsWqFB9waztgkvTHW
1139	payment	1397	1397	1678	1	1	954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpR2ArxoyJBWuCAB41HzPE7t2h6STN3VWTGy85M535A6jwk6i
1147	payment	1397	1397	1678	1	1	962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcGsjmxjjc1oLujdF49ACTNexc8EBJPKS1ppkqzcrASNBt7Be
1164	payment	1397	1397	1678	1	1	979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcYBTm5v2sJWRWAGBVscbqAErG98g3vo5huxXz1eMaEbT7JLw
1166	payment	1397	1397	1678	1	1	981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjp3WF5rRin6UfsA5x2FhQ35aNUmSxsA5E7mbyqPWTLnknb4Q5
1169	payment	1397	1397	1678	1	1	984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ999wvg2W8WuBR2qPaEnqtvWfKejt2ZpmEHvsCw43arnjY2wii
1174	payment	1397	1397	1678	1	1	989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHeKzXm74QRrH59MfxMSxuGUyqHcdeY2fSxy8HKtobngVnCAc
1177	payment	1397	1397	1678	1	1	991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N6tQ2YPioeKY4jsA5eZJ9tmW1MvsrmqP8KSRE7i56p4wTWMZ
1182	payment	1397	1397	1678	1	1	996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GDY47TK4zkaYjFyFvvsW7Kc47KG2wAPfEscWQRiQouHv1nqn
1186	payment	1397	1397	1678	1	1	999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVefxLuxneWZsugBojCBR4UZUPpB2hDuE5AAGZ9d13SjiV4Qhm
1191	payment	1397	1397	1678	1	1	1003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjdkQ8b3oUppTu2HKDSkywgpvFxmrpQd83gbvujTLHeuDvmPE
1193	payment	1397	1397	1678	1	1	1005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpGfpPv7CTadNjntCgRKNNtcMhF2K6KbpQik3GY3mzUDwPZxB
1194	payment	1397	1397	1678	1	1	1006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcbfTmVG9kpdWjppzB2iD8yjcWYqSdYug9rTcPwkVSUTXpWEU
1208	payment	1397	1397	1678	1	1	1019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDnCbz4pgrxXi9XHD9V2aZjJJPtkt8uAvGN7aVvpchzAuok97
1211	payment	1397	1397	1678	1	1	1022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4hNXfCxUhSpkXeMnPHW2YL8F2FTnMVTncAYBkzKRPuyH8sL5
1212	payment	1397	1397	1678	1	1	1023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx94W1ztAFVkgRcXB5hygZ3NscT6m3Pzgq73Qgkoq5RVorei6u
1214	payment	1397	1397	1678	1	1	1025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyxCv8fABixUbHQyyaDjSFb1nMQfzsDdSFkKTSm12fFrVyd54
1215	payment	1397	1397	1678	1	1	1026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwt6pF3wx9AZDkvuTWZths6BcM2353megUM5bKLxGhQTXhAYV
1216	payment	1397	1397	1678	1	1	1027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQysnPxVZhuwhXWUKEHgoNVFgbHxPUbnr12HL9vGM8XjnpmPAJ
1219	payment	1397	1397	1678	1	1	1030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLgdcrM9SfL8sbE2MDuHA4Uf4Uw3qQmpCSktVysmw4DHarnFP
1221	payment	1397	1397	1678	1	1	1032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFy9KYrE9uKK7dSHZQdwjXRPeLPDEQs3Cr5AijqwvzYd4YmgKC
1222	payment	1397	1397	1678	1	1	1033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStsi5HQNVetR1RHD4DL5L3oEK5NXuBmAmW94f6ZddHmgPXcpz
1229	payment	1397	1397	1678	1	1	1039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1ZFpK75ReWbfkUz2yMRHCgEC2itSStL5wQr4aM5Xey1EkHPU
1230	delegation	1748	1748	418	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg23M6St2HSiUJyKEZFXTTSCPZ6XAD5p1dfjNH5Sw3kwEJ5GdY
1231	payment	1397	1397	1678	1	1	1040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7E5oPWFtuZ8EqcZd1G15trmDqd376D3fNcU9iDgnTdp6a1bhA
1232	payment	1397	1397	1678	1	1	1041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7pryB81gS3aj9pbhphWGtirFgEuawTnsUVULvkMLWpB5KLe4D
1235	payment	1397	1397	1678	1	1	1044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTbXNrXQhnD3WLQV4LBoNcEm36GKpYkGYoCKvv6XP4NPwHRCV
1240	delegation	1744	1744	1477	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYZiXqP9m6jwNnfHrCaoocZhSjXGPA4tv8HQFAA4zF9PgKHFe
1241	payment	1397	1397	1678	1	1	1049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjqqtaYxdCMTBbLix8yAQnngukjqqTX3AUoirZuCTFzKhW2c9
1242	payment	1397	1397	1678	1	1	1050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjN8d6mycAqYXokit68uPZDtKaJLpB7gLqcWx84Z4tUYEK7eio
1252	payment	1397	1397	1678	1	1	1060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUa7dn7SqMRg2nxMqNcSfco6EuapL6Qa1gtebM21bR7N6kRSS
1253	payment	1397	1397	1678	1	1	1061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVh6sumiXrhWHXkxWBSNTh1ziHv7ea113oQeCjAPbYvEe5xULt
1254	payment	1397	1397	1678	1	1	1062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSxJgtT39x5HGEv7U1zgbwWeq8Nk1EGFTwFbH2V6LPJBgibYS
1125	payment	1397	1397	1678	1	1	940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiNgVrSggocoobo5NF9FD5YScfMysiggEz3rVaqKfCjNsr4MA
1127	payment	1397	1397	1678	1	1	942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb4QScK17BRn7oMUca3bgCDxNwH5JD31jnuuz1xdsLFjcHgvL
1130	payment	1397	1397	1678	1	1	945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjMuM9xi5WnmrVVbbpXtJSoCKdHTeMzVBMFoJ2fEEzx46xHix
1134	payment	1397	1397	1678	1	1	949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKovsM8kBP8cbgvk7AyBYtK72jUopsJXQYCdRshuQUv8e3Y28
1136	payment	1397	1397	1678	1	1	951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSXXWELr1RsQFJa7xJthuaZpVfo1hL7N5zFemH6npr3FKuexw
1137	payment	1397	1397	1678	1	1	952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdpPkbs5iYKSPKxDHosEBgi2SHH7Q9WyXE81Qep5aQCf5RKXtk
1140	payment	1397	1397	1678	1	1	955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoCHQuobetgVvJ9orGFUTwoZnxCQLe39vF8wrmWSMoEB5YJdy
1143	payment	1397	1397	1678	1	1	958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7SWDYNX3drthwhpBLfBDu8CjxNRmGNBnmNPop5CGQgNEPsE9
1144	payment	1397	1397	1678	1	1	959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJQMu1ugDjwc6WWHpjrj8FKjXTrjPkSJuLq5ehxwqK89jdbTD
1145	payment	1397	1397	1678	1	1	960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wcskpQiEmsxZuzsHVoswz2SMqtp1jAf5qYtLPrkSaGMSWVdk
1146	payment	1397	1397	1678	1	1	961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsSVSqkPcaS2EHPx39YPb3WGRdcZj8FSSkkX5LyhwDek78TxL
1152	payment	1397	1397	1678	1	1	967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HkLderqc576p2749eYU5TuZE8KbP6vXMfBtXjbe8QDuUiynr
1153	payment	1397	1397	1678	1	1	968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcNuxNfs3HCyMj4TyuR2WoiTJKrafH7wqY8wh3fEQxgCjWYnN
1154	payment	1397	1397	1678	1	1	969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kLc2QuSdtf6Cahmd8NzAifpnPtrfx5HF1hVHQw3qqChuBNjT
1155	payment	1397	1397	1678	1	1	970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYe97dkT6tLgnZTAujSXUiM6K4j5o4QVZZbsBhcy9ok8mevZx
1156	payment	1397	1397	1678	1	1	971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVdKaVmvnHHJHaPvwsyjwKWRmVa2frUQ2pbE9Q6CPDFwGqHam
1157	payment	1397	1397	1678	1	1	972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycQ3Bs8TR24GHMmcsuWYKh7zvpi8ukQTUvxRmJdeb1abDB4EQ
1158	payment	1397	1397	1678	1	1	973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzomXpKGFSeMebatgMGbPzNLXbQPaMwJhCpp33VtNMcqwbeuAP
1159	payment	1397	1397	1678	1	1	974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhHdmEfqExjFdEmPT2YZK7CrnvjoxbabCujgkFEuXifXqL4Rq
1161	payment	1397	1397	1678	1	1	976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9i1kTwjqH8k549cMvnh3RLmqYsiusAwq97ekYDmhCpPWL7Kc
1162	payment	1397	1397	1678	1	1	977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokXk8Hydd3zuiPBwD4zTutF12xe8kWdiwLSWNwQ2Hy2zb7pTF
1163	payment	1397	1397	1678	1	1	978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9rcvYrsgP5EEASdMGt76WGFoY7fBvJQ1pw4n5HtgyN9G6ETd
1173	payment	1397	1397	1678	1	1	988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VHJcfAWSTDJrPqUM32iqmnMhYT4gkTtUCnRJG5zSDPTA6soW
1183	payment	1397	1397	1678	1	1	997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthDqJJMUKSWAiYpX1h4epr6R5e1Xx7KoerGYakDgttNcwEBuj
1184	payment	1397	1397	1678	1	1	998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAUaqGd261Xo3vLYiusM8qS6DDcEDrLxng5mTxgMWP4gzTtwG
1185	payment	563	563	1740	1	1	0	1500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7oDqUYDz2yoAZqQFWyAuNeLYrYdvonJcv59TtBM4NpthDWko
1196	payment	1397	1397	1678	1	1	1008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BLaTXKDkxsHQXLzhCPDYUgxoViAsRHXmbcnc2qhn4JzbVcAo
1197	payment	1397	1397	1678	1	1	1009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQKsdDPhVgsqUbx4Ah9bezt6SUJzk7mVvB63HQWTFvRMqj2r7
1198	payment	1397	1397	1678	1	1	1010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEyCotx4o719SsjgLRw4EjuXwS6jaxFovUkaN8xttxY4D76M8
1199	payment	1397	1397	1678	1	1	1011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhvnVMvD9fc6iqJFxt1XUpJSRfqmpuXkESM98dWbeV1QJWQgn
1200	payment	1397	1397	1678	1	1	1012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspqHMMHfxdJrMucHQ4qG8EL8ZsFJ1Z5odXbwrF88JjjZzKDZi
1204	payment	1397	1397	1678	1	1	1015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qNPER6rHCx9fbf5APJ4Y3bkgQrF9a4TXMGuLSx371brWGpwp
1205	payment	1397	1397	1678	1	1	1016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUEKZDbTYKQkpXVwnaw7JWPr8L4nuFKxbtY5Y3t4YFncNDS3n
1206	payment	1397	1397	1678	1	1	1017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxBMkYXfUbAmhrEQJtn7uZDKMH2PGUi6x1YsQ2cjt6pSEhWtKD
1210	payment	1397	1397	1678	1	1	1021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bTPoK14UBV51uKkBGKtFrm4MRPwbtJLM6324nXQuD25Pk7g3
1217	payment	1397	1397	1678	1	1	1028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZX1kRmG3dG7LnGSF8UFo1qKUxd5BoJEPqewDgAAcnvgENkK4
1218	payment	1397	1397	1678	1	1	1029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe1SzjXGST11ZBxdXaKS5iYB8RmpkFtTtsgiANgKdRQVB1de5
1220	payment	1397	1397	1678	1	1	1031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadCmLYK5RcfNAKUKiJNqwDuztrXhvZZ3cPG7EdJUgqBKWsBSN
1226	payment	1740	1740	1748	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybJMfg5bMmE27ELbBmgkqWeEuc3PGRrNiVej9M7roTchyxMeV
1227	payment	1397	1397	1678	1	1	1037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJxJLinSBsnF25SiCBBPxQ2kugNDQkdRX59DJ1W5GaigYAQjX
1228	payment	1397	1397	1678	1	1	1038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXPYXRPoWnhrAuwJSdRsiXPo6qSZYgggE9JaXSafHLdujVZbb
1233	payment	1397	1397	1678	1	1	1042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMna9iDg2Qw7AWfpx3tVi7bSdWsWxVDNg94oBN82URjF7t8ns
1238	payment	1397	1397	1678	1	1	1047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpuwVUALEJpSW4XUQNFzWYu11tczdRjFRMFhuFmv9Buv9SUJx
1239	payment	1397	1397	1678	1	1	1048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KAnzGuS6sSUFmHByrZiE6yr8NdS9r5cTRht2eEumfBf5R1pB
1260	payment	1397	1397	1678	1	1	1067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ntGUFMTh4jWCALEf3W8mUD2L7JJsxUbghkFeni3ZkfSPJjbm
1261	payment	1397	1397	1678	1	1	1068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdDXXAMxVg1xCLaGnDFWR5uPhD8AuitRCeUcvhKX28Ltk7FRd
1262	payment	1397	1397	1678	1	1	1069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5JVtvtUKAZWgitDtnHAFQYKj2empt9xh7ttYkmtsLhZxgzBk
1234	payment	1397	1397	1678	1	1	1043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLVU1E3txMkREgwKgfFbJHwGgUV72kwEUG5CHdnokgWuh8UGM
1236	payment	1397	1397	1678	1	1	1045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwwS1Dwy3ibBjn18XGKCq1LaBR178wVcKFQjFjT4159cS1weR
1237	payment	1397	1397	1678	1	1	1046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ8zKLTgmKWRv2CY8Epg3prqJhbcNya3HvZGzyPfm4NgmZ7jiC
1243	payment	1397	1397	1678	1	1	1051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjoxd4PTcjaXS16yFGxYRDa9bkZRhaGKGtH7KbtrySKynysvB
1244	payment	1397	1397	1678	1	1	1052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDYQa3cp3RqG4MvfRJYEVfK3hk3u3P93G95EdddnwDEiWr5P4
1245	payment	1397	1397	1678	1	1	1053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yjgFGk4hVGqYtRdDaZJX6zpHgnqfwjfBf2Sark7nT6ACUK3f
1246	payment	1397	1397	1678	1	1	1054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJUHJGx1fukidkV3t1VwYHt1mZwZpWiTC8f76CmZAQpAn4Boo
1247	payment	1397	1397	1678	1	1	1055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uttZa92yFihgn5RRngsuqR7GWWJrPmBU4V1vDFdWCFHgV3UM
1248	payment	1397	1397	1678	1	1	1056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzPZz4XHGr7EedvgpYySgr7RoxE2EbQyY4BfAyHfqoxMWMAZP
1249	payment	1397	1397	1678	1	1	1057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDUfhksRSgEVqayjUvyLKLonuhDLPwqwHaMZiPiU3nqcRY8aA
1250	payment	1397	1397	1678	1	1	1058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFY1YQro4kmqcYKqFy231vKBNGtyMm8NYscvqXgDEPnUEqkve
1251	payment	1397	1397	1678	1	1	1059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Gfa6b6Ejxbde9QTzM7J6HNPaY7MPr6WusMWDQZWyG9fxEZp3
1255	payment	1397	1397	1678	1	1	1063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyPeNJ99LNVn97tWUy8gcYdtvrSdUj9z9hFfrcvZ2zczmTJxq
1256	payment	1397	1397	1678	1	1	1064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsow3YJQZ9GAfCXgcU5zWN4Ah9gmqT3W4ZSwCD6UQoGwpR8Af
1257	delegation	1700	1700	448	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHedbg7uqx7SfwoVdVi59CoSn9AegQZweg75aPfBes7f3zhP2h
1258	payment	1397	1397	1678	1	1	1065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS8fAY7yaqekpXKwvdDzqWoshnP2kW47hfsBnmFAruNvbJYov
1259	payment	1397	1397	1678	1	1	1066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4a7CyuvrVqEEWdvRZTFx7HYHDaiHTpgwtA5jGjsCp6LzuBFgS
1263	payment	1397	1397	1678	1	1	1070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbHsajV3U6V81Vk7CVfTPnD7qNrnC48K74MVoRfrjtnYTz9ec
1264	payment	1397	1397	1678	1	1	1071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYft8KDzTU4LAnHg2A464QNo1g2dgv19GXosxFTrRT2ndv8VwgR
1265	payment	1397	1397	1678	1	1	1072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KwiiaBzy3GhTvtfoUSPRFpeKBHH4nahkFsnTPeRRV2755CrP
1266	payment	1397	1397	1678	1	1	1073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GHu9VaDEBQtATWuFMQMKvaRqqY5aP6azvEzS7WRTcKXJaJSN
1267	payment	1397	1397	1678	1	1	1074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnttkVggyP7TxnLvZrPCgmzN5XRjMsNuMmskdvLdqN1Nx6nPq
1268	payment	1397	1397	1678	1	1	1075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8N9Xsf4TuD5yPZsUfRwyq8dApjzXNd173UMMGGZYGtcpFqJY
1269	payment	1397	1397	1678	1	1	1076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuvKjZiWPL5y3hhKu8yfTcHJV1kqgb7ssQLXpPdoMi6e1ZEao
1270	payment	1397	1397	1678	1	1	1077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8NALkk4YY4Mo8DrtjkXcG2iGriDrNGhaeQ8Y2XUbe1e1C848
1271	payment	1722	1722	1749	1	1	1	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviAFbL3WYkDbsp82bep8Q2MBJsjEjGmq4DiawsKpwEa3tGvcy
1272	payment	1397	1397	1678	1	1	1078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaGXEFhSDC8tLiumrQhnmX4cUQv2cQ13uTicP57z3LTRGt2MK
1273	payment	1735	1735	1745	1	1	1	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6w5K4J8ksUSNp9N9UJXn2dmvocswXg93QMdu6LQLSzfMoiHg3
1274	payment	1397	1397	1678	1	1	1079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kTggTXhJucpoyLDVFsnWJWdTbzCYctJ31aq3KKTM3mJiEgqH
1275	payment	1397	1397	1678	1	1	1080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLgpKgPbLJiW1Mpb1sPcyCfCShMRVKCR7myshvruWbnmBVoH4
1276	payment	1397	1397	1678	1	1	1081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgicj8KPBeDfew3FrBhqdmqG8ziGoEkFR86k9Y7XT2WrG5wX7H
1277	payment	1397	1397	1678	1	1	1082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dPYJkbq3jU9TXPbpdADs5z5fawe4vxrsgdsi8zTpY3A5tEwf
1278	payment	1735	1735	1745	1	1	2	1002000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJKQBm4jkwHpPki3zM2nRaHvB695wSVy4r1PcmhUwGKmXa7KT
1279	payment	1397	1397	1678	1	1	1083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TQ2sCwmuriL8fSxLkZGQ6KgDpqWTFjHuL93EYXFEUrkDb9rE
1280	payment	1397	1397	1678	1	1	1084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgprfJqMkZ8KXbLTMtgHFfpv9ffpwFCypmLvsWZEKit1ca8twJ
1281	payment	1397	1397	1678	1	1	1085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmSvgNxne7GwnDa3ywB6q78utQp1QSPiP31PCsyKCPWAM9LRP
1282	payment	1397	1397	1678	1	1	1086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmT8wqmjNFPgc9qdV49eHrHHYQ25i43SM6uBZ1gm3nzT4RbhcU
1283	payment	1397	1397	1678	1	1	1087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH33CLP9Qe14QPSBt8HXXuvg5fdDfGCDV8ymLCx8tqNVkp7ggb
1284	payment	1397	1397	1678	1	1	1088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjsEA8eCYiLtsCSVbj34io5UFpTbFnRiFowhtSR5ZBm3BLeW2
1285	payment	1397	1397	1678	1	1	1089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ns6fjp3WQop85i3LKybswSbMzv5WCGhFKvHyctLTm3d6hz3B
1286	payment	1397	1397	1678	1	1	1090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzWfLJfgnXYND5rRNbwjfpHxzCd5f9E1vVc7NDB6zfEDyvvZu
1287	payment	1397	1397	1678	1	1	1091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6HTXJEVEheER4nib2DiktE4LLSZYhtwjVu68BLVUWY78yjdo
1288	payment	1397	1397	1678	1	1	1092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAodf8UjL2r6fTQiTMnj9pZadsmQKiToAqrwUMZsAJcYgjgGRL
1289	payment	1397	1397	1678	1	1	1093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB4CFH6aUAS4EzkYfsLWc8jjAuy9Wen8BtnFAprMeRikzRQM3
1290	payment	1397	1397	1678	1	1	1094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkekiznDRFyoPNnNtZoKvTatfS5ypxPtK5sQECLUaWwvp5cCe
1291	payment	1397	1397	1678	1	1	1095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DL39KrdUMh94ZtivsZgfycdbc3rZDahW7XgBLkKCUUZC3Cv7
1292	payment	1397	1397	1678	1	1	1096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMnde2VkbuPpCMBw6pjsg4NWtiU7zXEaRdovYpn8A27vohuLw
1293	payment	1397	1397	1678	1	1	1097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48V84hLgoZ5hG4pu73HXgVEHrqNL85MN1Xf4AL5z7wEqVC7V8
1294	payment	1397	1397	1678	1	1	1098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCywS1DHoT19yQXN7j3RdUb7CQWYXBzPQob31XVXLiFdtdJpg
1295	payment	1397	1397	1678	1	1	1099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13ssaxGP4HZC7nD8TTN3vntfhenJXEKpYkae5rPJ8Bo2N1Z7j
1296	payment	1397	1397	1678	1	1	1100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLjjDvfBTYTUDnDCmNDqdXtMC9wJSUN7mEdheT436o2V7XPco
1300	payment	1397	1397	1678	1	1	1104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQPdNJ9P5yaxaYgeUL7XpPQoVAJWVxraY3ekNJbVJ2wmE8nj4
1302	payment	1397	1397	1678	1	1	1106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6FtQGphjrSCc1WAbnHL2QSNLYQ7qGA99rpTc9GSAHj8e1hXV
1307	payment	1397	1397	1678	1	1	1110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQouWZVXWTBMAGYbGr5YUqX3kc7wFapDhHjBqts31QbwjB8ZK
1308	delegation	1740	1740	563	1	1	2	\N	25000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAKerzpGeHgso7cjWKk1GzKh1Vyjzn5Y6xBwid56RZwpkJckg
1309	payment	1397	1397	1678	1	1	1111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5ERytK9sFz46aVT3fQ315BXTy4SqMjfjfb5CeaGeTvNY8GAp
1310	payment	1397	1397	1678	1	1	1112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJfKSgbdwKeMtJ5NdXy7q3kkrKi9r7UwyoweLYE8JLZjkwsa1
1314	payment	1397	1397	1678	1	1	1115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXUcRZ16eq6qPf1f1T84fTwu1cLGfzrh4QVBnNx6Lr1LJLKN9U
1315	payment	1397	1397	1678	1	1	1116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jz4aKsiW7fGMjXDGQBhBsu2nUP854MDJbrsHE4BE6WuzF9VK
1316	payment	1397	1397	1678	1	1	1117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4rhMHTPAG8nVjvU6swbEwQUfo5p7z5zRBMVvaJKrAZKxa1HX
1317	payment	1397	1397	1678	1	1	1118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXgW7XcwgNtPUXfuvdN256pHcZGdRtSjSE9mxW4VTb76F1e3n
1320	payment	1397	1397	1678	1	1	1121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYepqMPZcFaXWkf3MSBcCSxKqT77P7GNqRnP7FWa7brD1rTT2
1324	payment	1397	1397	1678	1	1	1125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbgcy2QX5YT7g76QKMsB5qAUpVUoGkQZkdQiTzRvKTqgvbgdC
1326	payment	1397	1397	1678	1	1	1127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNA8JGJh3e7DiXrc6EqiGGZgyAxQZjbTD1qT7vjHpT8mezPHc
1335	payment	1397	1397	1678	1	1	1136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJMACvCtCy2KUwAb8tWpZSjwgiygfJJdkjDZ4se8LE9pvVsVZ
1336	payment	1397	1397	1678	1	1	1137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDotrMobXoxG2qu6Tw1VQLzXkJxJnXVSTvrFkeU7ZtfCsdsJj
1337	payment	1745	1745	1752	1	1	1	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4u5CtLproGak79hYNDFwcjmwtKah77bHr77TFqcXwiihKmna
1346	payment	1397	1397	1678	1	1	1145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuY1QZq3MRgEF2C2QUEYtpo6BDU6e13JY3WYSRcuNzKvF9KH2c
1347	payment	1752	1752	1745	1	1	1	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1u5S2W6bzPx2AoLUoAcQ8UYN7Ry9JmTHdmnZSNKzidrx5x23
1349	payment	1397	1397	1678	1	1	1147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNi2xe7RGTs6ucRm2YqBn4KcR1kxoX7r8KHkoawmA8xjsHGzP
1352	payment	1397	1397	1678	1	1	1150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTJ6seoULmxqH6PXaxoji67dxHgarxjTiJ7uhJ8PueRs2q8Mo
1353	payment	1397	1397	1678	1	1	1151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyKPUw3xQu6GjKvSbb5c5qmVsNb5VLG87F47vBRMZcSSdqrB5v
1354	payment	1397	1397	1678	1	1	1152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLYipwqnAyVd3Ndnx55qQtF31V4RyvQd7pUKKstWTGBcYmNKi
1355	payment	1749	1749	1753	1	1	0	13000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXE6FVupGVRxX68WaXKLwWEvSv45ubEB9M89gCFGpPovi75kQ
1356	payment	1397	1397	1678	1	1	1153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVqhvDcYFKZK5w27i5f9XoP1YbAg86jAFYRSrZ5NLHBeyV9pu
1362	payment	1397	1397	1678	1	1	1158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFskTpys29C3Zuf7Htma9cWk1jmgDFoVn3RHNt85rLYhktPzby
1365	payment	1397	1397	1678	1	1	1161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViERauQyJa7eL2Y9PHsBcDYTVowXjpsiNLJsHVUixeKyvwcre
1366	payment	1397	1397	1678	1	1	1162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYzxfFH74DGbuTfvmU1Zkjjc7PyY2YmNfq7qNMYgahKLNmMVY
1367	payment	1397	1397	1678	1	1	1163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbzBJN2cf8EBYmhMAyjJ38t2VwSRX8ZjiJoNn7VdUmro3xmPK
1368	payment	1397	1397	1678	1	1	1164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGsnS3d8mLZJgdKAu2QLLZRSrHCi7WshomjveZrQzPiy3q3vg
1378	payment	1397	1397	1678	1	1	1173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5jGEBthsnh1K6xUb2Kht24SuevHc1hjs1wJgCsZn8EUJJR1j
1379	payment	1397	1397	1678	1	1	1174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi77PcW1ebMJ9efGQtSRTeA44EzBH1DwrNHku2B1hjkrmdDW4x
1380	payment	1397	1397	1678	1	1	1175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdA1KUzFB7hXN2bBEXq4y31NUgbMPajgHdffEJHSaVfCcKrZS
1381	payment	1397	1397	1678	1	1	1176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3pPJ3k5oXHSGh6GdLWgXWGc5a6ps8sGjfyD3qtWKibLBNZ2f
1382	payment	1397	1397	1678	1	1	1177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKZEUUTw9xGoQ7crpMMKiUwzoqkXDKrXLQckrjFLDKsbW3CJe
1383	payment	1397	1397	1678	1	1	1178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49jb4g5KZspS7ZnzbiT3UuXQxUSqaETrarMdDF8P4GznvPmng
1384	payment	1397	1397	1678	1	1	1179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaNUTTLWCkkHG2xDNM4wcbBZB1pETVE5sVtxFUTwHXDybh8Tb
1386	payment	1397	1397	1678	1	1	1181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdwb7qC9Yz6v8Hqd7FjqUE4UQNuY4VDTkq4yBB7N8se9Uh5ET
1297	payment	1397	1397	1678	1	1	1101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFnAeETVReCfnnC6r65X89DdAJvePupxUjHwtEoSLhbMfDJ63v
1306	payment	1397	1397	1678	1	1	1109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZuWdTbCvZE9wVkKSazmeobeVMtwYRmcYPYF1d6zt8RfXHa5Y
1311	payment	1397	1397	1678	1	1	1113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjD3aNNj9S6HZ5MzCJVEFQRuNLYSjmELfEQtFDJezui5rTGEx
1312	payment	1745	1745	1750	1	1	0	8500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqfqD4pFJYBYMkGHs6hUgxhQmDWhwsWJqKEHQifDuZST33Voi
1321	payment	1397	1397	1678	1	1	1122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDCw1MCFfAnKb57Wj5imK1eHQejJfUJszEqULPozLjohxN8pR
1322	payment	1397	1397	1678	1	1	1123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKX1iTwSwUcpjhRbGYFM18QQaUhCGE3tembhXiPcMA724N1UZt
1327	payment	1397	1397	1678	1	1	1128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLHqVD174LrefH1daYe2Wsrkxh7BViJ5nHKFEeRaE3Kp1UdGB
1328	payment	1397	1397	1678	1	1	1129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPniA9udxgALFUZNTfDDZXyBnzg3vGpskvhQA2hMZ9rNE5h8L
1329	payment	1397	1397	1678	1	1	1130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNYdjC2apYTZnffvUiFpuZ7ZsNcuACrEmo9JaFTk5S4XRKxva
1330	payment	1397	1397	1678	1	1	1131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmRwLcjvtuxHKo68gysa1yXCvyvRA2CBoK1NXxS2XvdqNzT9A
1331	payment	1397	1397	1678	1	1	1132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPzWXgEjbVJPwJioCKUsGBao7mp62uBcMLhiCwvAUCymStizZ
1332	payment	1397	1397	1678	1	1	1133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6ubjjcGGqXrS8XWmrNsGxSWdgaG5vaqVqT7dACUf7Tphstdz
1333	payment	1397	1397	1678	1	1	1134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtQGiqovX4EwxH6WeWP4PKxqkB5KMBKCgEuRZsqHKyzgUeUCu
1334	payment	1397	1397	1678	1	1	1135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWDmzY816sc2GppGvKxfLaxPJMTU2mK6VogauMnsK1AC4Bq4g
1340	payment	1397	1397	1678	1	1	1140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkKEHUdetTjPot8Erh6GWWfQLH73Cpx2NBPZ3Q5qvLnxirvtA
1344	payment	1397	1397	1678	1	1	1143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i55cGSbcjvo1Zr7ckKsiFa1XqyW5dRgAw28ih9xkeTUQsbNL
1345	payment	1397	1397	1678	1	1	1144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7VrS6ezgXYB3iecjKeWXHbHbTLv8m2S2sTagk7Yf4X6C7i1M
1350	payment	1397	1397	1678	1	1	1148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxSZjyjs2dgH1Cnrz1jpkmCzjbd4cVg1923Zd6LhwZ83V8hDt
1359	payment	1397	1397	1678	1	1	1155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkaphLtsHjHQEFxcEFB5irAgDyvzeCCQQJTzWcBiq11VMA7FUh
1360	payment	1397	1397	1678	1	1	1156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupmmKqrygXZBbvhDD2ARAWPSCaan8p4CcHeniPPKifnyLm8rq
1363	payment	1397	1397	1678	1	1	1159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxnJVAamXB7LQhmpcmQ83LBUULMnkYVD1fXGAbuSBnYVPJFAN
1375	payment	1397	1397	1678	1	1	1170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLzuzArcNJ9RAVkhgE9RhuPhjBp7GgSoVjGDipxfB88rZmA84
1385	payment	1397	1397	1678	1	1	1180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjdePu7iWshjDb1gH4toYaxvbKERFUvdjdr3QMuCm5rX6LLVq
1391	payment	1397	1397	1678	1	1	1186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWbh2MCeFvV8qKrNaLjXHwvfqrEMT7Hdu9jPeza58JZUAfZCv
1392	payment	1397	1397	1678	1	1	1187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWYHZ7eEnJUNUbWYL6373Y5kro3wXFATYtWcSoLRa2subN7jW
1397	payment	1397	1397	1678	1	1	1192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbM5cbEUQd26HbdJY8m41ZHJr6h5nqFXoDvDUirqm1WhZ9nrR
1401	payment	1397	1397	1678	1	1	1196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF6ou3XS91LuuqCGfSwfMEwqdNUZh8R8XaRBZuKkCY587UPoZ
1404	payment	1397	1397	1678	1	1	1199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaN95ZT6w4PVQXqMmqVz1JxhxtpA5Hacsrut56HgXX1N1tH6N
1405	payment	1397	1397	1678	1	1	1200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgPhKwYGHLyuiUSSfvTM5evAF8crG4GesZRgvfDszBN98Nmnfk
1409	payment	1397	1397	1678	1	1	1204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa797F9uvjiFhjwzh1v1tAxdRnMok11HbES5yHfWjPEtYDuitGQ
1415	payment	1397	1397	1678	1	1	1210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTS1PQnqwV2AiWEJYpqZPhaYwoRzTmggqzt8bdeW4FEb3am3A2
1417	payment	1397	1397	1678	1	1	1212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxQQWCCbdEnjnzeZrZibp4rJf2x4A5Rq7C1GoNU3CWQ9QqqH4
1419	payment	1397	1397	1678	1	1	1214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgT1iDS5DpEoXdMK4GzqLfHUSPiz9i3PH2AGihHSUbbUKY3Zfp
1420	payment	1397	1397	1678	1	1	1215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkLj9njGeDRTakaS71VZNkgAxrAsozGfJjFRxhZL3L6w9DPUf
1430	payment	1397	1397	1678	1	1	1225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcAHcEeKY6UQVBWvCnPRM3fikd5rmWAuLZ2mtPKUKQSNYUWXsQ
1431	payment	1397	1397	1678	1	1	1226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrbK8ED2rMrWTy1x5sfdJtgkPLfskWJFsKKP8fhJah1QEwxfz
1432	payment	1397	1397	1678	1	1	1227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBoBtV6SkxycT2LZbFJWKUxzyqhn6bcw5mGWjTQmpaEr7x4kt
1433	payment	1397	1397	1678	1	1	1228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8drtfZtosiLBQNZ8QySiyi9NNzoXZifrs4gXh8hWqVipRK53m
1298	payment	1397	1397	1678	1	1	1102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAkDf4MeNfi2o1NfnmF6S9wkgU1mRXGRae7BGXbJNhgEkGCRHg
1299	payment	1397	1397	1678	1	1	1103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvtUW2ydw1Uxn54ykgCoYaJvf5XgqD613fv7E2QLHKWZDtnRx
1301	payment	1397	1397	1678	1	1	1105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTyTcsbLN3ZyEdU1ENMmgCiLmgpGcUYLeJWdijGQsfFApgVtM
1303	payment	1397	1397	1678	1	1	1107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzks5ckJ23JmJY5WN4Q58m9DgKSfieTohb8dkXvaBQi8DpcWG
1304	payment	1397	1397	1678	1	1	1108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYFx8qv5cx5Y7CHZ5SEY8Bu4oRpvmtGvT4PAV9fgBWcDwGj8P
1305	payment	1735	1735	1745	1	1	3	18005000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEraDePViwbUiQWPXaLXJTpobuuZTL7kTCKfZHUBr5PNy1eSV
1313	payment	1397	1397	1678	1	1	1114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiF3bARYSGna7HoP3qbS2zHD5dL185tavrVefL6aJutrPnwLUr
1318	payment	1397	1397	1678	1	1	1119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgMHKkTzW8x6efU4VsywgRnGTLM5H69pCDoFneeK12DKQrDY9
1319	payment	1397	1397	1678	1	1	1120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMs1s8aNk4AFwbL3XtLNxjrWuK4MhMaQ4AjNXixoNoG17QVKe3
1323	payment	1397	1397	1678	1	1	1124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEggYXGGV1Ca4L1yxhuLogVMWrk5wA6CxufgrjDWQzLteLyiP
1325	payment	1397	1397	1678	1	1	1126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZci1ASGMFzVkuSsnBAPT4WjG3NYNF82VqhwzaqGQ4xZapEDgrP
1338	payment	1397	1397	1678	1	1	1138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZh5owWXjw3Rr7WaPpDjTdNnCpVbtjZqXF9oT3qYMkbWBMEQqv
1339	payment	1397	1397	1678	1	1	1139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwHpY5SLVWQftJMo7SSYyrD5B6mVqf7nD65uECEwA1dqjzADh
1341	payment	1397	1397	1678	1	1	1141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnVRvXZtbRdzZsT3fi9XqActqyZDPKtBFrMCn2WZQJXouG7Ns
1342	payment	1397	1397	1678	1	1	1142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvukgMAbdMuxaSp9MtsEKfYzo6oBWG2WGbZg6QnEuXCjrk1aFe
1343	delegation	1752	1752	1735	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmW8rvNzLJzyEEpwup2ZvVXjmZE3LzLWFpucreGSYyVRC9M6rm
1348	payment	1397	1397	1678	1	1	1146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYR2GgamszqhJQQEqKBtsx3bkU2dpcbMiTS65nNRAjuH7fV4gD
1351	payment	1397	1397	1678	1	1	1149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoDEv2NPn3CPTV2Fn79TzjtqbdSbK9QfxLVaRBs7W8cHmPhiW
1357	payment	1397	1397	1678	1	1	1154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzEeUnQquTGc8wEng8LNKSphs6qtXoj26PqeST7DHQvsyuadX
1358	payment	1722	1722	1753	1	1	2	1100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdYBW33MpRgGyAc3CLffW6vnXKh1ABMhrG3LaPneU9Nq7gkyR
1361	payment	1397	1397	1678	1	1	1157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfuyYoNbJVjFbMtJknk59ZLyPeT4Z9JoNfpPRXrJpAsa577mn
1364	payment	1397	1397	1678	1	1	1160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HwkwbYeJFRdjAoYXGX26sHiVgn5Q6XRyVxyzMhkrNbVgjzqC
1369	payment	1397	1397	1678	1	1	1165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdEQxBeputawZQiv3NVF2w9sukXfygS391kVKh8ZyRgyduB3B
1370	payment	1397	1397	1678	1	1	1166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWQNb8YZX5st5cp8NevyguAchXVMUc1AprjAKe4CK9Mghfmy8
1371	payment	1722	1722	1753	1	1	3	323000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3RhVrG2JfxACKV6A58RetnDNm4i25g1PzZG5hEFZanH82fXk
1372	payment	1397	1397	1678	1	1	1167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuRGrErwQ4DnUvvmEh2dQbStJ9BJttbU3ThHHpaRSd7JiaZeq4
1373	payment	1397	1397	1678	1	1	1168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHMzrTeRN4eMonxHLxXKszboRdpi1hFFB6USX6TfBjsJTYdiG
1374	payment	1397	1397	1678	1	1	1169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUzbMZXDayEGf5gVxmRdC4yEujiXuuSmHtWBH7FUDKpC621zd
1376	payment	1397	1397	1678	1	1	1171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3UFzyBepyPWvBPpgphQPufZbi9VsA2ybzdhJvb5AJ2ZY47QU
1377	payment	1397	1397	1678	1	1	1172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbupdVWRoMLEmFfSPQnF4RwavyAupZ3MwvrU352JJqZdZ5cM7A
1388	payment	1397	1397	1678	1	1	1183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ35FmwsrzQCoUFDas4iJ4qgnB4tX5dBXXmhjteJFHgD5GxiX2
1389	payment	1397	1397	1678	1	1	1184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGBJtKAYYXxqm8C1fXF5k8JuGKBLKSyhdX3PQwcz6YnY7pkme
1390	payment	1397	1397	1678	1	1	1185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnSCNpayJvEVK72RsumJUJfbkzax6yrdkcW6HNkbuLGK9T4tx
1398	payment	1397	1397	1678	1	1	1193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxemG5ED4JeCBMj3afWixRQaAvWQarXAdDivJE3dtnnpKWHeo
1402	payment	1397	1397	1678	1	1	1197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4UZzPqv12ztfw8yjfo5GDRzkjFKgrc6xg1fb7N2AvD9ti581
1407	payment	1397	1397	1678	1	1	1202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsoNotTSTqHvRimbk5eiRThjwv7adxF3VdqCHQeQmEL7QhJ9d
1410	payment	1397	1397	1678	1	1	1205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SUYmrEwJ2Y6CtFjsykcu7Jhh2L4aMJbHfyMEXDn4qyXowenE
1418	payment	1397	1397	1678	1	1	1213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnCpg2jSFYEYV8o5y7KLJdwSTA3Z8kjYMBSn3pbUTc2sGrvJ2
1387	payment	1397	1397	1678	1	1	1182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQpFrQVjWmPV8zznTnXBStMEsMMtZV8s7xYMrJkqsa7qz5w49
1393	payment	1397	1397	1678	1	1	1188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmQMgj7LGgDuNnSqYXMMXet3QehKMTfjMS1prnUQDyAxjztKE
1394	payment	1397	1397	1678	1	1	1189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvkFuBFWimQoPMJ9dhmZ132fu5XCqDuFoM23Eo7VXemUrVmWr
1395	payment	1397	1397	1678	1	1	1190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5E6tXrWaPWpaNjteroG1hUJqNtYbMtEvWi4P7GPycTx6ePHrp
1396	payment	1397	1397	1678	1	1	1191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwxCbDEJyhFzyfygJTRLw6Ba3dyfpd71qNzztQgo5G1NoHFXk
1399	payment	1397	1397	1678	1	1	1194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2iZDoywtkGkixayrPNnh3jGcEsngiGfu67afqzVevYoEijwi
1400	payment	1397	1397	1678	1	1	1195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpNU61U7rAaF6CcfSeYzFbvu5hA1cumE85ujVX2ES7pYiahLr
1403	payment	1397	1397	1678	1	1	1198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4huqKe5s254kNq23tLZsgniyeK1b4usreRjz9wXEFgnNWYfnx
1406	payment	1397	1397	1678	1	1	1201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6NZiuMHfhLGkggDJtPmpo8RHvz6E4MiexiAnwZFu8n2sVJJd
1408	payment	1397	1397	1678	1	1	1203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLSVBQ8uHSLZvdZ7FLYBuwJJjjpBbh1YtMkhZfSQ7ktnGsPP7
1411	payment	1397	1397	1678	1	1	1206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoG959uYW89sr2hCnaoRprXy6K9BfasxEisaqBeiqTrJDXF4rY
1412	payment	1397	1397	1678	1	1	1207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6oov2X3j9uUS5yafqNwet94PEfNyDC2SfCh1zWbSX9s1qx3zH
1413	payment	1397	1397	1678	1	1	1208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGN27ELNXRTuj7zXbBWUtXGzTPHq3vELpVcTzL6mSjAo1PjTMN
1414	payment	1397	1397	1678	1	1	1209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgG3Zg5KayWEpMCGRctYg776i33P5pYhuUXEasr3MyRHrSoE6W
1416	payment	1397	1397	1678	1	1	1211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmTv8ThzuXa7qGRfc3TbQuAPXuc7DJmenwLQRLcrVYeCfRDSF
1421	payment	1397	1397	1678	1	1	1216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Tsxmtx62Ur43JwQZVeczKs4choCpKzkjZWetamWsNBXULPNJ
1422	payment	1397	1397	1678	1	1	1217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHPYbCBayTgYXKnYTVnCD7LNzxhhT1y11DSNiZuzzfd6LZQPN
1423	payment	1397	1397	1678	1	1	1218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepgexGdg1yK76TRVUdTp7P7MoMFpTNypTCJpny3FqADzSaTa3
1426	payment	1397	1397	1678	1	1	1221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjD8TYiitg1zE5Kh4mxcyzNHRvJcbcVzb6M3EMV5KCnyyDjwsx
1429	payment	1397	1397	1678	1	1	1224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBEA4XUMC1G9CxbAczLias7kj5WCAPnJXPgUY56RSCa7LSUGni
1434	payment	1397	1397	1678	1	1	1229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgogu6KF1yCQrZyq7Kyryi5TURQKgjfctxapKswsHFmm6sdV7
1435	payment	1397	1397	1678	1	1	1230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4hEUWRsbPCCFqc9JBAYWLt1PbKjFjpN9jWhQ9j7fRmhz325Zf
1436	payment	1397	1397	1678	1	1	1231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFD8Y5iWkNqkKeHVjmh9truxytt2Mao48obALdS33JPjPT6LG
1438	payment	1397	1397	1678	1	1	1233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQUWQbVCZtHNq8HjyG2vKGzmgurbeBUchDc8MPURVK3ZT2gB3
1424	payment	1397	1397	1678	1	1	1219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhhSYz3QNKZFw4h1Syv2xnKuRknyXZLMAsUcjYArzvd9tT5bia
1425	payment	1397	1397	1678	1	1	1220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnywo5dEmpyVuok8rjAoGdH8c2RTjMwsJRjjXg5NfXHaXgq6H
1427	payment	1397	1397	1678	1	1	1222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYNsbmiLJCmP4B8D9v5GTy89zvNGHQEHDzdgiwuF5ekHRhPfV
1428	payment	1397	1397	1678	1	1	1223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8kYLBEwougAyRHvnJDgNeJgDpzEvQX2X6YJ1QTBzs2NVZP9G
1437	payment	1397	1397	1678	1	1	1232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHR1oHLBgUqKb5EXbKcH1ifPA7CAVdZ7PSKHhVeinRo3zM21v
1439	payment	1397	1397	1678	1	1	1234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4zcrdy1pKoGViCh5NckBYh9W6Fa1ciGPSf2EjnF5riXbuaK2
1440	payment	1397	1397	1678	1	1	1235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdFLs18RriSiKq1WizLXpNytk65oCgE2m7wUvjkP9cKbpvKe3
1441	payment	1397	1397	1678	1	1	1236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD94aCLsbRCyKQRNbZxBQD7tL9RpLdhky4SJkX58SAVBs5W1g7
1442	payment	1397	1397	1678	1	1	1237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLE6NTAe8ps6VzHJSAqKE7aYPaHRMyTQCpKP9EixmoT8TBHg8J
1443	payment	1397	1397	1678	1	1	1238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLNQowy5bvmAviJ2yNuxeJATV5RLrvFtJStwuCWqe8bt1Y4rY
1444	payment	1397	1397	1678	1	1	1239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoWo6pXXkMxRzkhzAhuZntgNeYNayQ8HDGipDAoQtT9iaoo1s
1445	payment	1397	1397	1678	1	1	1240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TrNSjhV8SBFUtub4uba9P6KoCFR1oPpmnxPPvRizvXAtgmS6
1446	payment	1397	1397	1678	1	1	1241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBazwgBKsKRcAKua4kDH9Yz9pd3TfEHzHGVjpsmN8NTcxaF7f
1447	payment	1397	1397	1678	1	1	1242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1umoaJsQHdpTTtYG9PgYAr68EuoegkSrJwF6Tw493uUbAuAgw
1448	payment	1397	1397	1678	1	1	1243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAKSRqsMJdFQd6ouUSHY7zzC2LxMnmsMqYevUBsi5nKycGBLo
1449	payment	1397	1397	1678	1	1	1244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQsmbSNNQw2rhjRASajYGdb4sSY5JXuaYYNbGPgbVJ5aRzRGh
1450	payment	1397	1397	1678	1	1	1245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VnQwT1deXDL4wdooteKUGW2M8ZyaPhtZVZ3FowggMiwwhsgQ
1451	payment	1397	1397	1678	1	1	1246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivJm99GBcQudRhqb9eWoMcNg2W9jc8PEzpYsAfQbkax8Md4rY
1452	payment	1397	1397	1678	1	1	1247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNuSq3ZvDhWYYwKGeGs2t9NGDavUo7EvUSR3gUYj3bcRgarUV5
1453	payment	1397	1397	1678	1	1	1248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPmDyufMuzLJijC3BHXKnn377trJQM12bsjWrabTD8SzLCpZh
1454	payment	1397	1397	1678	1	1	1249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLi9NnTDe8SWJKQkEz7fQgzJvYB9MTWs7cgDr2Wj4J2jnc52pT
1455	payment	1397	1397	1678	1	1	1250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2RuWCntxXGukArEKewLGeJzQdv8r8ew2nwGGyyBwCY7pR56KY
1456	payment	1397	1397	1678	1	1	1251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSAKMGSmPBvxEC89gTQGwoA1mRyCTdJZtmrJfCS3EHmQ9JYYT
1457	payment	1397	1397	1678	1	1	1252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThc15DfN5bmTYiEifHV3P2zLzhdpZ15mHQxSFjqBaDswMhgqq
1458	payment	1397	1397	1678	1	1	1253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAA4duT8YwEbXWsBQBHoawWLUc892LSQcarFn2vP9qnqAFW8os
1459	payment	1397	1397	1678	1	1	1254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxUg4yQ8H9NdyzjQurK1w7w8W5PGxx4XydcoYuGVUkyyV6PKW
1460	payment	1397	1397	1678	1	1	1255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSX7roPefFzhK1V15Dq7AY65kaTvUTWnkLLwKwHLje8BSN2JGD
1461	payment	1397	1397	1678	1	1	1256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VEgBTLMwLowmND2HmmrGCsV1EtxHdgHH11QXsuDGvM59jyUw
1462	payment	1397	1397	1678	1	1	1257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9mbKkcCg8QKcmnjXpTE27k2L5wrEp8q8835MXvLmNjXr3zyr
1463	payment	1397	1397	1678	1	1	1258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBtniCs5WCZuZa6KmRmUC87UQUsSKBENB9rCMwiHeUFvarhnA
1464	payment	1397	1397	1678	1	1	1259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkPSvTWvW9LWnudx7QPaDgdwNDb1dSyXQURCqs6aU14mKcUgg
1465	payment	1397	1397	1678	1	1	1260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkj1K8VSUzT5jr6cBfnZQvQQv6nr15jJqa4HPWiN6ZoZjP35j
1466	payment	1397	1397	1678	1	1	1261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjeqEvD51DVJGesBTX8GS8GPdAamDEsCMLDd1dCeXg8ZdXwGT
1467	payment	1397	1397	1678	1	1	1262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnuhMfjwDJ9ZB2qxQhhsA7pYCJ6zpUzBdCV71yDeCp9Bm3UzN
1468	payment	1397	1397	1678	1	1	1263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUwK2u8uyXQGAZxANzYCY7i3k1S1mWYHFNQcr6HYh3EK3gwS8
1469	payment	1397	1397	1678	1	1	1264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2ruRrhwJuNk2p4gLgkxw5NZZXSrH8qU96wwfou72M6Zkq3Uc
1470	payment	1397	1397	1678	1	1	1265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKA7hCGsYYYYmE8A1cdQXbJF5KVKp6ubuFmbvitQK9R6rcGN8g
1471	payment	1397	1397	1678	1	1	1266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh8iuFF26PXuWdMmsXGHSvuyHaciZ5TUSbwVS8UJ2u3H3ekWP
1472	payment	1397	1397	1678	1	1	1267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgEb7bzrmvpyg2gcZpHbxPgLZEqbpZzcVLRJXLfEZQLD5GLZC
1473	payment	1397	1397	1678	1	1	1268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1r751mDuqAbePgb1LQS1rza5p4wqyeJh8Z1gu76Z7QehBvpUt
1474	payment	1397	1397	1678	1	1	1269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNz8wKchDp9gXJ14ErvRuVn3y22x4jmwzqJ1iya1XWhyHkHTJ
1475	payment	1397	1397	1678	1	1	1270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC51kdUktGV4kvTbuVmafQKUaXrrKgNWMf77H5sMvAQxD4GxXF
1476	payment	1397	1397	1678	1	1	1271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWe2yHd66zWDXbWsYjpuAocYwcB1j1xfktLTTBXDoR81Rxu9Vi
1477	payment	1397	1397	1678	1	1	1272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgiTMiabuycF1MHh3oNFfpp4dGswcCwrSHgtvikZ9qW5BqndSg
1482	payment	1397	1397	1678	1	1	1277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63wt1r4WnjHGFDWdwENf2XDvu6t6D5EygUP7udvHeEc8bg1Dj
1483	payment	1397	1397	1678	1	1	1278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNBKNnQH8t5J7R1bhJAyQAQkEQKWyFgsyqKn61EZ5wTe3PEye
1487	payment	1397	1397	1678	1	1	1282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnFa6p7TzHuuETJjnfgiFhFY4Cy7Z3a5dYbf8xUSCVzcWcTyR
1493	payment	1397	1397	1678	1	1	1286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEGWTG6ncJ5cGCd8ywGn8pQNicJ11kyNCSX8r779Fa5hBSTEZ
1496	payment	1397	1397	1678	1	1	1289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwY45g36oRksFGqCav2C4wgTViJn9ktUdCsPxHmnetiFdwUeHu
1502	payment	1397	1397	1678	1	1	1293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJPb8npbcrVK283ZmwKzbdQ9aBrHXpiuqFFkPYDyNvvQGL8p1
1503	payment	1397	1397	1678	1	1	1294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLBPFuq4SpXVr4hCJMztk7NvDTyEtmUFthVrBnutYMBG7BwKm
1506	payment	1397	1397	1678	1	1	1297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2YMeJas9w5ragFuxKFjSzfyFbbnUQA3iVQbUc9viZy9jgpMA
1507	payment	1397	1397	1678	1	1	1298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5h1EpBbTAmMmCmyovu1ySpzwypwJniBbuTr4NRhQQZfRuqHC
1508	payment	1397	1397	1678	1	1	1299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqeeQGZ7N17mZ2xvCQhNwYQvBsR4LeYAsYNWRVrjYykPngUrAJ
1509	payment	1397	1397	1678	1	1	1300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9GZDsTGdAN7bzzcLDzEHUSRQtiMGmQSCm5oo2JWcxDY5d9bH
1514	payment	1397	1397	1678	1	1	1305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhpHKm8m65r9kV6U2PmtGA6bdM96jvuqxaZPRGprpaqirq2jf
1516	payment	1397	1397	1678	1	1	1307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABScmjuoEpFgdLceqmaKbNbxwzEvPwoKNKf1chgSMy75ZeDM7
1517	payment	1397	1397	1678	1	1	1308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofpX31mZ1kuFWZygDpvW57Cd619b3x5qv2FoGcJ6ptgE1NMpF
1519	payment	1397	1397	1678	1	1	1310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJB5MT3B84hmJrd93qE9YnRrf4CfHQuUeoj3Xo5Mtwct1sbzgA
1522	payment	1397	1397	1678	1	1	1313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgu2FxfRzymAoXcfLUR6q67BrQmqj91FAyR6Gp3jPYvRbU4FR
1529	payment	1397	1397	1678	1	1	1320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7A3GdatU2sNb4JF7vaGQBjoT3MsusctfjaELENycM82DeywL
1530	payment	1397	1397	1678	1	1	1321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYy4nqCQgjibDqLqfgq2TghNorPKxBKCzohg4RczpQbXLCWd4o
1535	payment	1397	1397	1678	1	1	1326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXxrpRfPCmFCv6FxZJDFLHDynSKWouBmD4igQXPYPMyKkHQeZ
1539	payment	1397	1397	1678	1	1	1330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyAjoWUQovKgz6AqrSbpyJPjzERy17whhyFmC5BeQw2fZg6ix
1545	payment	1397	1397	1678	1	1	1336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZejdTHgWD8mEV95zf4GgUoskjQQR549D4PuKYhfT7f24Xq5hYq
1546	payment	1397	1397	1678	1	1	1337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6puDpmrmMtCrWVF27F4VLFtP2xe2Mj7agv6JxmASr7qvFtoF
1549	payment	1397	1397	1678	1	1	1340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kZfNRhhyygGZzAMJp99nR716XFCRRQyrmnQXgjZyVipTFnp6
1550	payment	1397	1397	1678	1	1	1341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgS1A8r3pEt5JEwLDYNZvgM8keDQ7Ng7apVVZ9V6dzBLidnts
1551	payment	1397	1397	1678	1	1	1342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8jbdweJibDNCR1X8pc5opzbxa8TbMarBLAJ3cAaY6wwCe1Aa
1561	payment	1397	1397	1678	1	1	1352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCnkEp3diMNJKU8die5euR7dnMshYvSVPBKa5nic5hTWz8mDu
1562	payment	1397	1397	1678	1	1	1353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ69B8QwttESjaqWpr9MvNF93uqSTpL47asYbTigcmiRTwReJ
1572	payment	1397	1397	1678	1	1	1361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ytAhJrh8h84uWT5mPEpcwihQWKaVjLHfdCofr91HghyqXf4t
1578	payment	1397	1397	1678	1	1	1367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNy5h4H9REbHjax32X1SbUpwgbhpptxUMbofT3KFvGNkADgud
1579	payment	1397	1397	1678	1	1	1368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2nSkT7HYDbsMRJZn3t1vyJTv8q8x485uR27mrUJGHZdHtUwZ
1583	payment	1397	1397	1678	1	1	1372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrq3WcnSYfGCGX72s75BuMjMxs6KkHtwBxqTvKmeq22kZnHWnM
1584	payment	1397	1397	1678	1	1	1373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQMj5g7jyykbvFtAwWc3SHPUassZuB29tAEUH2uoQ1fFa5zvB
1588	payment	1397	1397	1678	1	1	1377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL92G1yCg2TvE8P8DNKViBTyYVhXZix9zrB6QT9MP2Ft6sp92
1589	payment	1397	1397	1678	1	1	1378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi87fnMUhvXfYvQgk2RoMpFPNFTPuJ3BNbfCxnFNKSzxH49u7B
1595	payment	1397	1397	1678	1	1	1384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizYoatnMZQcdM1396urTbaBEtnK79wUjWqX2FNAT7kVaobcNU
1596	payment	1397	1397	1678	1	1	1385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymu4Uo8uUKkjU2SuJuCTCnGEtmPY3hwLenMpq74YNZCNmuYkG
1599	payment	1397	1397	1678	1	1	1388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKo6tkmEa6tEmYpt7rxoi6qbPgQt7z1URYZStwfvDn8LA94hEt
1478	payment	1397	1397	1678	1	1	1273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswu4WNtx32ERA5d5pW9AYnJVF7ytqumZALUpnwiK4ukTT3gXX
1480	payment	1397	1397	1678	1	1	1275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYsPDtbPh4uPJCugr3KFjjcghyRMeKNj6VNuWM4Lg9Qbo6Jpr
1486	payment	1397	1397	1678	1	1	1281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGVFzvGqw5qNa8vo9usEYPjb49UfSnxTAC9koqYAZPWLw48dau
1489	delegation	1735	1735	1401	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmaqqMjLhatQVNTzWhtwTeju93vVPWemfAYYusgMund2ms1US
1490	delegation	1735	1735	1401	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cXSGCfmW3DbLxYZtUHo6REGwU8zFuJrjJn3vb7f6KaBLWEHU
1491	payment	1397	1397	1678	1	1	1284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpChDMBYytBrcMKXmZPQHb4T6ZaYhEbME8zzUinRqX7FNGgsYx
1492	payment	1397	1397	1678	1	1	1285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxytu225PHaN2eDChdgPqXSKYunTxLrU9aWN5Yq1Tn5EqSnWiE
1495	payment	1397	1397	1678	1	1	1288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpQ7uRd4cJ1mzPQMBLPNkviwucdGDbW77yWC9eYWAZe3edeJo
1497	delegation	1735	1735	1401	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLXmdZKiXrdqhSg7ofcWsZKDzCgzETESUdCihXEAH9d94EiXq
1498	payment	1397	1397	1678	1	1	1290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNgK44KeLrEBfBSecRb8e28jbuM9prYsHVSf16fH14iN3Hkc42
1499	payment	1397	1397	1678	1	1	1291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4APJzkL4mPDFGhu94sFvTP3ugfLvABGsGuMxFnzeJe2LYBjq
1505	payment	1397	1397	1678	1	1	1296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgtKQ5PgjQiHuuS7BxNjadteoyGGUBZCegLDSEKq37w5ugJzJ
1510	payment	1397	1397	1678	1	1	1301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh75fec3Y8H36717vzCxsnA2aaEnGY15NcmJJ2pB7gg4FDSp5K
1511	payment	1397	1397	1678	1	1	1302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5AE3TR7ZueHL8yC6QPwZ4NH79V6V5CuRZjygTjs8Wra3Di8y
1513	payment	1397	1397	1678	1	1	1304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfoY6BsP4ikqAN4LnzoTwnBafgW5CfujHr7gHEp7WNo7x7hvB
1515	payment	1397	1397	1678	1	1	1306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Z7fkYsg1ZPP2ZmgApJL82yLwYGA7RE2Fy7vJqotr7N3arS4q
1518	payment	1397	1397	1678	1	1	1309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuT1oU9fY3LVv5azAM2J3LiLr2XT8t7RCVyXaYBmAHCF4sq4tn
1523	payment	1397	1397	1678	1	1	1314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRJwvUvz5dBviHLQFdDfvZseq8wkhUUwp3vDipJetUGyadUWU
1526	payment	1397	1397	1678	1	1	1317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GiL8M267TMLeWR59tS2Q3zREM3VWXS8LxuCqATz6VFLTdKoC
1527	payment	1397	1397	1678	1	1	1318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDGHXz9r559Wt6qpfSCXcMssvRqunzVToL8nZKHsfPpHceE4S
1531	payment	1397	1397	1678	1	1	1322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZDkr3V5B6JqNh42DQAy8YcY7BpCLsjcR746ZefUX4ZTzU2FM
1532	payment	1397	1397	1678	1	1	1323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZqAdzZwed6FQc5bSjp1derdDeSy1fsgfY7gABmK15fYo5ivK
1533	payment	1397	1397	1678	1	1	1324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQUu8mTb3uTK8tm8o2wTe9fykXcyP689jVn47YcKUqEzAAbiB
1534	payment	1397	1397	1678	1	1	1325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMqnmRQmcUDTbgNVYvE5giTo2rUYydft88jXhmywnjEKAuizJ
1537	payment	1397	1397	1678	1	1	1328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecikMQLKfVmKhQcECxmWxTqJBwMzq1a6vhrYTnuH7t5BgvSCJ
1543	payment	1397	1397	1678	1	1	1334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKv8y571e3A7HcLA6miK6xK6JKqAfdDVLKeaGb5GFoqHnZEuw
1544	payment	1397	1397	1678	1	1	1335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuT2jix75X58cvCAWAEdyMByGgENqbvwcH7EHEJTPDMJrCgRnc
1548	payment	1397	1397	1678	1	1	1339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqnRinBpqUHzt7RT7U8Egi6YW7jbsa3ig7W52BTAvqa1tDpqo
1557	payment	1397	1397	1678	1	1	1348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkgSxWYxwQzRD9gmfW3psidTirEv3zFFf4NJrVnrDoZZcFKQcd
1558	payment	1397	1397	1678	1	1	1349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuBcGKac5PjJkLpNZDZ59d9zMPrUXTE1n7yY7kp1Py3F5eN12a
1559	payment	1397	1397	1678	1	1	1350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwnWN58ZKSo6DD7AWjYKpqykrE9ikRxmj4UQgFsYsDnAVgPqb
1563	payment	1397	1397	1678	1	1	1354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgeVSH9uJBU5Sm1ZMsRuBmJ7qPKGcw27n7jxrSN7ZeK2CpN8w
1567	payment	1397	1397	1678	1	1	1357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBtMdZxk5ox71qm4YjK9AHJKZyTTMDocCyo9XTzvYDaU59qKyV
1574	payment	1397	1397	1678	1	1	1363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXgiPPteAR2gypCiwAGcjH9YBPCyKtfX6XhZ994TQT5wSF6GW
1575	payment	1397	1397	1678	1	1	1364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6gXV3V83fysKnSdZGiXQSDzExuJ5GKYXY2oepXKzbNzMM6nJ
1576	payment	1397	1397	1678	1	1	1365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiC9rwijdtzpPLGDaQbmo5ryyXFN9fyXhcAVsq7NRYCFpbmDif
1580	payment	1397	1397	1678	1	1	1369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4ofDYVQnTD1cFandeFsxWFithXZNfVXm1Yue5JVpiZVtqxqu
1581	payment	1397	1397	1678	1	1	1370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3wtYf2q3HisUMdn6a27CsJee6scXFyaQwV7siBJXXtewh5dU
1479	payment	1397	1397	1678	1	1	1274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvNdcKTstEHyMaeLH6ZD8w87p7SbH7gyStCNuy3k14vvuEdjG
1481	payment	1397	1397	1678	1	1	1276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkuvJhuQ7cSMZ5ZnTMsvEPRRtsA2gYj9i9YiFdWpqEgCBEogL
1484	payment	1397	1397	1678	1	1	1279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1V6t7GbvscD139z6p5DdS11MXpPLFMh5UQUWQxYjZmJtjVnw
1485	payment	1397	1397	1678	1	1	1280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7QAQkuhErvPr8RJi32aFhK7F7CqS1iu7ggBHWpzNXVhkf6xM
1488	payment	1397	1397	1678	1	1	1283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmRNaWgqtWqPCP813kxUpQrW7ir8t19SHztqzM66GnbGC6isV
1494	payment	1397	1397	1678	1	1	1287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzZwehqMc8CghtHRQ13nDnLHfskE6BYAoMQuUVS1hFcG8JLGG
1500	payment	1397	1397	1678	1	1	1292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpgMKGr3VgXhfmu9y41u3S3dorfitTA6hfCfF3mMNWQw7NYNy
1501	payment	1268	1268	1754	1	1	0	5000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKrgrigkm3dAi2Zk2p8XuVhBGWJD4GfRSqTxcr2Qgj7qKEuhf
1504	payment	1397	1397	1678	1	1	1295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbn3VUtkA93SXJb8YkPSpxhQ8FCB5FgLnc5hgnijGimC9xBveU
1512	payment	1397	1397	1678	1	1	1303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurh3qTtw3rskZEJHcT6Uwa7u6xVheZdsNzxX7qbPa151Sk8rR
1520	payment	1397	1397	1678	1	1	1311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSAjjUsXgFuFXgdX4tJedU9zMgEgbCrkR2LggoW1GKTZb2dNH
1521	payment	1397	1397	1678	1	1	1312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFEozu9rtm9ytT7kP7iMXKY3x3KfzWHWRbHJrhMR3JMFr53A9
1524	payment	1397	1397	1678	1	1	1315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XsgLpxVaqdW6Eg9KMww5ZxAPyLzPeYiZswK525QFQbBEky3i
1525	payment	1397	1397	1678	1	1	1316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjYZg3ps9rXegdvaBiBM4ZPVHwE81jiJ2QZ1cF4ekE4jTqt9F
1528	payment	1397	1397	1678	1	1	1319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZJE8trnCVfSwngHSabQpbtjxiEjbGhaYWLZ8M3A2QyXveqr6
1536	payment	1397	1397	1678	1	1	1327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nhQ3yMjAuRxdZwQFoeoLm2s8pWbbCS48nMvCSMf5zwYzjcXb
1538	payment	1397	1397	1678	1	1	1329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKQ1aGa5A1kbRdQzjeNb2VTbWGQehAFL29iMo37dJ7NDrc39Z
1540	payment	1397	1397	1678	1	1	1331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1nVKxw1Y7ysxdwT1v3G1t1ar3jkaMareBurBJ6wCoptfH7UU
1541	payment	1397	1397	1678	1	1	1332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zR51PrBWnQ8ZLfNmtZgFx9UbniL4YC1qNWfTCvbiQR7Pqv4p
1542	payment	1397	1397	1678	1	1	1333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhB2Y81FEAvy21H4RN8KgBR4aRv4x6oEvc7eyAmyoqJMrPmQG
1547	payment	1397	1397	1678	1	1	1338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkPcFtt4HuDrx6dw2AQxiGhvGkmrQN5mNttkmhAc6rAHFmmKF
1552	payment	1397	1397	1678	1	1	1343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBGnkakp4Nm88Y7AiKCJpsy5oRr3WT4d6hTYfe46FLYXB2ANC
1553	payment	1397	1397	1678	1	1	1344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotUq7T6Jw24TAvD3sxcxRpbLzWmjxMxV2vtWZWPmcvjkRsRLt
1554	payment	1397	1397	1678	1	1	1345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnb8315WvdDQkz2iLQ69tA8Cc82DXTpzKur7S4VS9s4grsd9BB
1555	payment	1397	1397	1678	1	1	1346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9cF2QHX3o3L92wCPqi3rBFZtFzyFo4rsXjmxVXaz6v2VVZ2J
1556	payment	1397	1397	1678	1	1	1347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4YZVonsy1HGDQ8nLyhDw12UF1XDnYtvKobrYBvA9T1ye2GJh
1560	payment	1397	1397	1678	1	1	1351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmmeRuAHnXLg1Ujm37pAZPVmwZ49neBvYx4iqX9QXeDz8vqfU
1564	payment	1516	1516	1756	1	1	0	6480140000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrrqvXWWjd8dkdz7NUmRoewpHSDU3nAtpwrqu6Y8KfMvh3whK
1565	payment	1397	1397	1678	1	1	1355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZheXFkzi2rieWZxKtYdrzPp9vbRsaxyKtwTERjFe9FXj5RbXRm
1566	payment	1397	1397	1678	1	1	1356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Mjeht1LdYMwSRJHHoXp6fwUKwqLHjvzj85nA8gLsAYo68xqV
1568	payment	1397	1397	1678	1	1	1358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYpmMz6GzonZ71ytEBqLMAPgW7SFLLsMUSqTHCnxJJoABa9JU
1569	payment	1397	1397	1678	1	1	1359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwpUHvEYvuazsRTBi6fhAMpXsiRmgkhpAF25pQSdou4iwL3Yrb
1570	payment	1397	1397	1678	1	1	1360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyErb1zYhYuFCsbN7ADFKm8DiEcFjyqXMDDn2nRvfjyVsybk3
1571	delegation	1756	1756	1516	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8gQZx9gZvKJNtnCDCUn3eQRJiddWo4QM32XUVGBZgnmUehid
1573	payment	1397	1397	1678	1	1	1362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjGUyBm52xGwm68ZsyYAnq3QtwSDFx9GcN82yb8RDmPDUw9Sv
1577	payment	1397	1397	1678	1	1	1366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLghHQvw5bEDWHpgY1TWZdChQoxTTTr9fHEwk1HnUXKaDQ1GgC
1585	payment	1397	1397	1678	1	1	1374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDphiiCDfxSD7WqVq3bugHaJgh5NfD83Qu6jWerJC9f9KoDve
1586	payment	1397	1397	1678	1	1	1375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxAmy1ncrpDXJK5re6wmoMFwvXb8jVqZdSWTuf7r1zKiDpNXK
1582	payment	1397	1397	1678	1	1	1371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaLFaTs3fBm3L1Csk1DkzVExteCoEfL62hNt36bjuVYnZDc9v
1587	payment	1397	1397	1678	1	1	1376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTYaDNa2NJdhvZDPHJKgAjX4jLqSyecHLhUvPXdWnKVXhz4zP
1591	payment	1397	1397	1678	1	1	1380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzTkvW6sVo7DNyzw7xoBapJg4CPkiU6Abvn9KE7ZT83GMDE2s
1593	payment	1397	1397	1678	1	1	1382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVX6Z9jTMkiwNtPGk7KocKFCgCNcF5rjDuRsi1XvJW2hXgrcDA
1597	payment	1397	1397	1678	1	1	1386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNxj7iEKZzQNaUGCcxkq1wn8rJhXxJK2wWfr3NZyC8oraB1Lz
1598	payment	1397	1397	1678	1	1	1387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1YFsFKSeDsLJkcqPuUyxQjpNjRtMLrZpTG3QXztQ274VUawE
1605	payment	1397	1397	1678	1	1	1394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNYgS4yv81d3wCiDP8GbobD6agvC2e8SamapQfHj6qthtLvQj
1608	payment	1397	1397	1678	1	1	1397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZTf4TSfKqHvEqbZA3UerDVf5motdGQFMBwiUgp7yVZYAKyS3
1609	payment	1397	1397	1678	1	1	1398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZog7zA8F7VrJFLoFY9ijKFVBycbH7hYdUco6XzQ6F1Asa5Pbau
1610	payment	1397	1397	1678	1	1	1399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNfy3m3hqcx3qhbNqvcHuG6tCQWgAnLakz5c2E2ez1sc9NhCm
1618	payment	1397	1397	1678	1	1	1407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmjeyFCPfZ5onzZR5aMPbLgBXXvdb5FzhzR5PRudGJLi63GZa
1627	payment	1397	1397	1678	1	1	1416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHhgwNTqhJ4n8MU5MoiE2FbFuJFZXRnBm3ywKXLCwfNQKTmRk
1631	payment	1397	1397	1678	1	1	1420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJei1aDiaY3m81KgxcUu4cMJrEw4cdi4LB8SWuxwvyZZDGUrV
1632	payment	1397	1397	1678	1	1	1421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQKFBfcsxffLj9U9HKZ82cHL6iosVMayGzYz4paeCeKZFmwbH
1590	payment	1397	1397	1678	1	1	1379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEV8RxreX8mMUn3fiZg1YJo6o3MRL39jxzvHLfvaQe9qgDUUaA
1592	payment	1397	1397	1678	1	1	1381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eG5BzTbuFNf68qDstKERKfnKMaBjHixMBrnDhhKmz1g8NsDS
1594	payment	1397	1397	1678	1	1	1383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAnQr1Y6yEyboQ33TjYsL97MfyhiTrHy3ccfyVjdfgmDRPRVj
1600	payment	1397	1397	1678	1	1	1389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZityGF3CSpTG7hhkXXeRetpaZJyjt9ik8FBrwX1ZAFBjieUntQ
1604	payment	1397	1397	1678	1	1	1393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYQs8oXvpkcRJB5mgdKAx21i6XumfKauCGfX5HkXkirQbbTPe
1611	payment	1397	1397	1678	1	1	1400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwF21MSSGMbKXpwjnC1xPvByZgfsUhrvwmbR8U25afwQhnD6WN
1612	payment	1397	1397	1678	1	1	1401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcWQn4ueiiXtiSbCNXvvc4f7KBJ676uNMMCAF92HZJrczZQit
1614	payment	1397	1397	1678	1	1	1403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwBzg9kkq2T3JRQsmquzA6LZwh7gfAmXpLUbVq9XHUGgL4hST
1620	payment	1397	1397	1678	1	1	1409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDum9oaysS5EYNqdpTr6fppzKc2J2N8ZRfo4GiEtcdfozWi7w
1623	payment	1397	1397	1678	1	1	1412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwDNAEa7LvrZRhZ9rLWYhexKYR1hYpateyghh4xe1Yd85e8w4
1601	payment	1397	1397	1678	1	1	1390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTF3R1pMPDrGD3XavcBuqDUvZHNcZR3dVsza2dTe2uLEM3Ptmv
1602	payment	1397	1397	1678	1	1	1391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniSsKAzWJgit7tr8ViwSYheUD2oHA24BzHkse76QmiQaRaAj4
1603	payment	1397	1397	1678	1	1	1392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3fg19vKfxXZ9BtxvNheE22tLzMBqe87bwzTfa3qbLNL1Cqz1
1606	payment	1397	1397	1678	1	1	1395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGBtEnbHUGwxjpitUw5DLqRdAXubbYC2iA9eQxa6M18Xrok2R
1607	payment	1397	1397	1678	1	1	1396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaiTEtieLxAqXy6xcuRYrbHdoqA3ck8CPV5JT9ATL3zB6xGrM
1613	payment	1397	1397	1678	1	1	1402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTJUkVZCdLNeabMvcVxwfz8schoTvgz7MZdFzhx6e9nDj3Mdp
1615	payment	1397	1397	1678	1	1	1404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPxNfQ4YUM4YuL4qLVKXi82FwtpjD6Wvttb39UAyoWCVY56DC
1616	payment	1397	1397	1678	1	1	1405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviGG1Dy38r78t1CadauVGY7SbuxGSgmaLZpZWEbGE4Uj9mmiR
1617	payment	1397	1397	1678	1	1	1406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMe7grrezy39KBSL7tfCih57iaEBxyfHntT2WKo1B3woTXatNK
1619	payment	1397	1397	1678	1	1	1408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEwVZsBQ9FLtaZwuUGRt67AM53KvV3hNN8VJonyZ8tTY6cm2S
1621	payment	1397	1397	1678	1	1	1410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSk39WEX5Nx34ARx9oqkHc8vgsioLtMtwB2MHuTcojRhzMDRBs
1622	payment	1397	1397	1678	1	1	1411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3EyJxZaiog4PfUdF5jUUMaFUSmHdsehNgGm3qgr1w5jAHLGZ
1624	payment	1397	1397	1678	1	1	1413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrW7zWqEtnpTeTYLpNxcWDKKZw92PgzQeJgHzZ7cALn88h4BD6
1625	payment	1397	1397	1678	1	1	1414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhazxkNsPSms5QBhQCJCkhXGCXX3t16GJwgKzcLB6WiwP6Qfnh
1626	payment	1397	1397	1678	1	1	1415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdY8LRAkmxu4jFYDvT33CDgBAiwmm212yfgpgzL1ckgabBxGhM
1628	payment	1397	1397	1678	1	1	1417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8a2QhVX23SHikTdqYVzHz5bVGSfx76KVKqP1rHa79qaiTrim
1629	payment	1397	1397	1678	1	1	1418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmn62kmAa29VauiVmaiT1fctKJmrNB6z59RSKpNfVe8Ut7mJv
1630	payment	1397	1397	1678	1	1	1419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtat12FraUQKrEfCFTNFwvS3N4DBDgdJLGJJ6upw2Xx6BrmfR
1633	payment	1397	1397	1678	1	1	1422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDiVDChyzSbUenmEndV8aijfnKeWGNQXYoYtVCPEa6qKXTMSC
1634	payment	1397	1397	1678	1	1	1423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NJzxGgDHyCixjwNA6gvwLZ95Ux1ssQydiQm6WpfohnRviJKF
1635	payment	1397	1397	1678	1	1	1424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4ot4LGB4m28RjpXk3nm1VeZwRfiY6bdsijVGrXu74Fm6SSyp
1636	payment	1693	1693	165	1	1	116	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYhrvBuZp6AxSKYppmLEPiEriPjGtob6xTBDUg7F2ejDZQ8anBc
1637	payment	1397	1397	1678	1	1	1425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSzYnTzucP9XP6MkJ7XQY7bJdLVWoU96kT979wW2um98v9YEH
1638	payment	1397	1397	1678	1	1	1426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNXvWbkhFrkwuYoJCPAFbutUf8Hgc2idrVAFzMTVQeMxJef2E
1639	payment	1397	1397	1678	1	1	1427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgxhzis9MXHPsQC63PDFJEm5Mq8H6PMfKXDU9P9pEo2vxbAxf
1640	payment	1397	1397	1678	1	1	1428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kLrZ62Xaieovg8KSrVidvYw12ZDGjNhBr8vAMJAWtjHCz8bc
1641	delegation	165	165	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiw82bDb7s8Az5i6i4rGfJYucg2mSuowZuSStnAD1iJesQSgqJ
1642	payment	1397	1397	1678	1	1	1429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzgPhJfjmHckFJ2Z5xfhT9ddRHDti2WaA9Q7dsERao2nvS29U
1643	payment	1397	1397	1678	1	1	1430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFJPqsi4hgYdbJxYcdbzZFUTc8h4fjaMgdbtqx7NAybnx7m4w
1644	payment	1397	1397	1678	1	1	1431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtW5FaYedHHX1iLjF4Lf4HAVdg17zasvVypuvmvEeXtpYoyoh1
1645	payment	1397	1397	1678	1	1	1432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQM7YBkVWAaEUJ5fLrRRaFjBLmMnwzoKpBXrg6uckoCk3Kv9n
1646	payment	1397	1397	1678	1	1	1433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPoepkt5FK6vhZchBMhvTRWztzdj2wwJAmJWaHtJAsV8KJMQr
1647	payment	1397	1397	1678	1	1	1434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1f4fkr1xTaMquKxY4BntUzCVWoc2Bux7zwonxqfzHmjjm1Jt
1648	payment	1397	1397	1678	1	1	1435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5WAHLyu5xPZRQUr83tB5rSA6tpiiAPzkQQRJhUqKpSzhaDKQ
1649	payment	1397	1397	1678	1	1	1436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviAiTRoHcf5UMBWFFFAwCPdwsyE51jr5JVZEzEVCMxH7ChVCe
1650	payment	1397	1397	1678	1	1	1437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMxrpQyMWXHFqqFzowjejpH7K2dT7nk5JRDFud1M9SHXtEb4j
1651	payment	1397	1397	1678	1	1	1438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJcwyFyVxUQiMp7Ld5mbnsy998CQMTDeLGQ6Xtft67evuisSui
1652	payment	1397	1397	1678	1	1	1439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVz66iw76sMmRyWNXi3E4mzRsKsUBM74a6uvS9ee8WeKN7UFH5
1653	payment	1397	1397	1678	1	1	1440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibCdrnkgDhbVcJF7t3Wkwtg4FERxFuhXyc86KPnuBnQ6QKRmM
1654	payment	1397	1397	1678	1	1	1441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsMxMGjeM6jSWgG9MsUVXr9jpXp1P29UzLcXxJnNBQHwFaSy9
1655	payment	1397	1397	1678	1	1	1442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZnEsXMnQZupGvibAZXaYxQjjW4YLgWUivERr8nHWkLV8vMci
1656	payment	1397	1397	1678	1	1	1443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEv1xUZ6cmeYFnDqps5irf2UhSb9FuvFHvYwK88arGxmuYN3Xr
1658	payment	1397	1397	1678	1	1	1445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8vj84koMucMY55XXhWGJ83PiQoSUVwvG164HP6quKvsy33sG
1659	payment	1397	1397	1678	1	1	1446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3aswMDTYLiAFwxeE4i3uV71znXXQ2exvZnZz11mpu5K3TxZk
1664	payment	1397	1397	1678	1	1	1451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7WhHEp24KDMQJ3KEBTBQzWxdDfuPyXjJF6U1cW9j4X3MRo48
1665	payment	1397	1397	1678	1	1	1452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pQNNRNG6tJ3ZpjqoLA8QANsFs1VALwyipbQ3Mdbrpb3abKeh
1666	payment	1397	1397	1678	1	1	1453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjzRgsWA8xdd5BaRwbtinDhAXJYN2EAwQj5SFoTeycfVeUGoP
1668	payment	1397	1397	1678	1	1	1455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbcGnRCP6MLHPJnCoqnqvwsJ9uQ4G9nH9888F6mfqwjgr8C6L
1669	payment	1397	1397	1678	1	1	1456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwbGhx3FxCoedadW2VJgdfWTs9bbd1UYVV6W6YJD9dC4PGk5j
1670	payment	1397	1397	1678	1	1	1457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbT4g9WSiVxEeQouJdq16VoJGTWH7ofMN6pfo1yZ68Pc4h8GzS
1671	payment	1397	1397	1678	1	1	1458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhGXk5oWGDEeoSJo9e2KqPoab65KURaJinWdErLHmJiCr2SBH
1672	payment	1397	1397	1678	1	1	1459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWSWQLSQHbt8jiPdq5k8dTBZiWwqS7gDDqNsz87swv73jHLVy
1673	payment	1397	1397	1678	1	1	1460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4jvNszjWdfiJ3MtQsRo274z4r7bj9V24wwAyragsKmFyv5dF
1677	payment	1397	1397	1678	1	1	1464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWsnZGwwzXdqBnrtYkZbWVbKQwm7PMxTCKgQaFA6f3gLtBffJ
1685	payment	1397	1397	1678	1	1	1472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDmDPypbdpk5jqeAnPArC5k2NxqeePgdkEBF49EQm5sSpmJGj7
1686	payment	1397	1397	1678	1	1	1473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsLRTEUdSvBHSb5M5aZKjq7fpbfFQG2SWQBTb2UawrTTVodLa
1689	payment	1397	1397	1678	1	1	1476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVANb1DK1hECuR6ejqQMRTtdx3pu18Dg1tiexhH9WdFM832Cog
1691	payment	1397	1397	1678	1	1	1478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5d7vcwSTqrHFRPXbwX9CedcqgyXbyzTEFsUSXjMsWHzwjffVs
1694	payment	1397	1397	1678	1	1	1481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbqtoaTCXR5WsWVm8doLAvog11NNkyxCmoB6Xbht5GyBuWEMzm
1697	payment	1397	1397	1678	1	1	1484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tkpUFgQN8ALaLeASbfzo35KV6pKA6vh2mWnRg1JdAGD22xP5
1698	payment	1397	1397	1678	1	1	1485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHZfa1kV99uYzYWM16qjDm9BDCA2MqZJmKQfTytWMg9Keehpe
1699	payment	1397	1397	1678	1	1	1486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxutMhJmA1B3r4Wbyerfk9pjgr3w5Tmo1bgfCZ5ZKnAfk61Ge2
1700	payment	1397	1397	1678	1	1	1487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82hxhndnDQ9PM2iXguE34U3xc9D9rnkjoQkgKPVcTzeV7iKLF
1701	payment	1397	1397	1678	1	1	1488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eKofZMAUkowv3pHVRAd1GhBdCTKwTpuR5ZdE7zuwg63w4Fhx
1704	payment	1397	1397	1678	1	1	1491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fZWqzKZtadEv1azh9XqACBYusZoqmNpHKj3ssVYHdgMAHati
1705	payment	1397	1397	1678	1	1	1492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZxpW79qFUMYLKrgFsUJ1pJZtY4jUUTjagDTeXJTsw1fZ6Luk
1706	payment	1397	1397	1678	1	1	1493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqwh4yuDQrGotg53zkLyNCJPvAhK6vcVpP6UnYN4Mq8wjG2sC
1708	payment	1397	1397	1678	1	1	1495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKA5tzx1aiBFXX8GxmcwwhBVxuxgenWkDYb5MoiaeFNk4Yhjz
1709	payment	1397	1397	1678	1	1	1496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUYbMS91WDxvyxuDfsnZ4PHijGcLiwA8DieSPb3kw9tWwuajU
1710	payment	1397	1397	1678	1	1	1497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYza84Ec8iuDa5Z4qeHFAe9uWAfrmQW3in6jGYRs2qWzFTF99BM
1718	payment	1397	1397	1678	1	1	1505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y2AaEDQgSAqAy2A1mYLREKwXx1LEweHoyVR4swYVD2a4iqg2
1723	payment	1397	1397	1678	1	1	1510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCW4ttd6pGQxYumX9iL3frg4CZm6KmNtZfawGKT23xK9NUSi3
1724	payment	1397	1397	1678	1	1	1511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVfo2DcdsZwxJZYo2isWYez3EMyB9X7qoZgFbxAQn8YXRbmvw
1730	payment	1397	1397	1678	1	1	1517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZ8FL3x3tuQXeF2NRWroYuvsDy3n2GduBWoLE4xwttS99UKbF
1731	payment	1397	1397	1678	1	1	1518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSp6aaujjbhcc1cGWZhdErjA2fvJXMduD18QBkQa9me1DQ8rc
1732	payment	1397	1397	1678	1	1	1519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYmKT2r9vxyBq4xbD3E78H35EZSUcofZyvKMfa6U7NkoYsETh
1657	payment	1397	1397	1678	1	1	1444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2CZwciJZocGY7pEF2RkcUDUQbBYe8DjmeUNTkgwuLADaBsFXW
1661	payment	1397	1397	1678	1	1	1448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DrvoYNmbqhwu6FhgHnoGspMm1cN7fvN8C5sfWYbdVR5ray7W
1667	payment	1397	1397	1678	1	1	1454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZer1GYC9uVtWoH69LCvg8We9TMFjV7wS3fB8dkyMjCFLxPPvyf
1679	payment	1397	1397	1678	1	1	1466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsuB8XcDd5zuW8XFF1Ap7ACiW1fjNPy7huVaza4mVzEp9L23R
1683	payment	1397	1397	1678	1	1	1470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVuijNdgq9ehPB3tmCyeJTUsGHPEaYRMDTLG96R3zNu5qtKr9M
1684	payment	1397	1397	1678	1	1	1471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rZie6cnNCQ2LHyT2XSLiz2dXSLtkGDFpr51GLBEzEQQWVtff
1687	payment	1397	1397	1678	1	1	1474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYshKq3JrSm7NoHoXBZ8QZSNrskJzUqEHzoxQ6bNVEvLxVxep
1690	payment	1397	1397	1678	1	1	1477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXMxj4LGeCh5Q3ps6HMu96UmbCSY3SNF2mm6QgBiBRDiD6Bu9
1692	payment	1397	1397	1678	1	1	1479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpDv976APHn4kZKBLKtL6gEyNvJqYS7FBAVouQQHwnN1NrPfG
1693	payment	1397	1397	1678	1	1	1480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeR8i1LtMjzQr8D1yYm6qye2su5urdwDKnLhaTLh1tCWLgadZF
1695	payment	1397	1397	1678	1	1	1482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPPWBkzNmmfHXZwxtS6b2G7BLkTaonsDXhz8KgLexaZuzBjan
1703	payment	1397	1397	1678	1	1	1490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5hsoTbYrYVxKCmSNkYaJAfcwJpYs28kuj8qJP3nviBQZYwEY
1719	payment	1397	1397	1678	1	1	1506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXYMHMVtNioo4JT8cUPGPHKK56DoRi3KVsAe45ja8KR7TTGVQ
1720	payment	1397	1397	1678	1	1	1507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkFakqz7o9gq4XBE8WSbpNHQ3zRFEbSREZaY5jRW8uB3TDiuv
1721	payment	1397	1397	1678	1	1	1508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBgnXqdAJy2WnAHv8LbFuxprtXzF6ixMUQWafbkAceQaQHMbh
1722	payment	1397	1397	1678	1	1	1509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySsfybfL2Rz8tNNKEdB669MN9f4aRXa63qBRtzQDpvvDtTW2T
1736	payment	1397	1397	1678	1	1	1523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4TW4nff4bSdLkRFptFjookbQ8UoZ2edrPoWJhRYppCXF1hjZ
1746	payment	1397	1397	1678	1	1	1533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbJg3Voatg5EHPj3WpWf6LVFpfgBDbdW4kaxK9KiUK6dwCuG1
1747	payment	1397	1397	1678	1	1	1534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrLD7RchsphxML8h4FL8u8b5wWqvMZos6TCqtgK6gXbrWvE7Y
1751	payment	1397	1397	1678	1	1	1538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBeqc5mTLzJxyxqFQbAHSxZ9UN8Cz6BCLo5wfJvRr7HxBqxdV
1752	payment	1397	1397	1678	1	1	1539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqGTiGkXg7rnjzAhdmh7ZX7JEANuhr5Gyo7bJiSuNAt7tgc3B
1765	payment	1397	1397	1678	1	1	1552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxaXnP7gmZc6m9a3dGETEqBvupWhWwP5vXvauueBWrFmdVMBF
1766	payment	1397	1397	1678	1	1	1553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NWiM8BJ467ByqckiZQzEQJRV6NmTGuHmE7RwBRnnEyisNKdp
1771	payment	1397	1397	1678	1	1	1558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBNfcAyH8pNhXYx1WU2ALE2XCnyuAuvZ65w4zfTqm5GdGatsb
1774	payment	1397	1397	1678	1	1	1561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLiyiTm2sDEhTFJuNgQqXg9JPNnnW9LUyqyZX2Vsnu5wkfdhuC
1776	payment	1397	1397	1678	1	1	1563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9cbFttCBDcWHpmgb71x4DN74vf6GdDi56r4Lgdwbi4NBubqL
1777	payment	1397	1397	1678	1	1	1564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJTsPtU4uNrhPxVXNwDiPF5jSgzBK8KyNptJXEQN7cddiWh5i
1778	payment	1397	1397	1678	1	1	1565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94bXuxN2dGFvAZUqY2dnUi28wfAJw1F2MgEE7AZRb5wB3CfKY
1779	payment	1397	1397	1678	1	1	1566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHzvpBt8i81L2MUEVbcF5nYxwoCvum74ggS2LjPLchdbwyFU9
1784	payment	1397	1397	1678	1	1	1571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo76LysbrgCoAHCXtkj4oZPii7VuJq6aCF17SXbPw824QpKjau
1790	payment	1397	1397	1678	1	1	1577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwm5UtQahgSF67NXgoksH8ZTyv8WVBMsxVwnC6fPXJY4xNsRCw
1794	payment	1397	1397	1678	1	1	1581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJwe5jGengBnxJkG529UqqSn7RtMEJt41gXo8S8jq6mBXHKC9
1797	payment	1397	1397	1678	1	1	1584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefryshbpo66vHCPLDiasMMQVg9Mv9fMzXWLXFrD2SzQ31fFMo
1799	payment	1397	1397	1678	1	1	1586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnDdjc3xv6eETNXGfnwD9SvB4JC3HVJsPkXXGDFurHX3f6jeV
1800	payment	1397	1397	1678	1	1	1587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdRLxCknK57GGG3LMDYDzfFWZTnnjL52UoyZeguTC75tQFkEpr
1804	payment	1397	1397	1678	1	1	1591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bFD8W7S9ujKVeTxP4Q4rd9W6dtbjWwVqhbTifFgnUAzXRyYw
1805	payment	1397	1397	1678	1	1	1592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8qN4bzSLsSVxWSs8dURZrsZJa4j15phb6nWxcxNUGKXKoUfZ
1806	payment	1397	1397	1678	1	1	1593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEDuE5gfTyLD9aPNRKCdjndrFFtE6fTFzo79q7C9gkee3qYvr
1660	payment	1397	1397	1678	1	1	1447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2woAEgXUPvCsVu22WzfPGAm7cJyp2EyDcbKEXxcXeVz1Np7L
1662	payment	1397	1397	1678	1	1	1449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UTpHUcYc7YJ76sMGohNT48nSfdQ7D1kd8R4rNjkgkw7Szv15
1663	payment	1397	1397	1678	1	1	1450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdDxo31aJbmmih1f8jBbYKGximeyWvLRyi3PNFKtt321Z5b3Q
1674	payment	1397	1397	1678	1	1	1461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNdbSREXNRfeeSTLm7WdoEaK9qN2somi91NDAa28XzUX6u4BS
1675	payment	1397	1397	1678	1	1	1462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUTeXPXVBCVrXNn5GujypL1JNewRRLqRuaq4cdDJcLv5jb8tVm
1676	payment	1397	1397	1678	1	1	1463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXihSUGNUft6mqup6eSTKFEdkiBX22peDVtzKA6ZRwp6nxwhe
1678	payment	1397	1397	1678	1	1	1465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzd2TKTt1deqacu4z8pCsEvzAfk8pZaZrn4PXjDA9KN2qjqvCX
1680	payment	1397	1397	1678	1	1	1467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJeTEad1tXgG2GbamQAvzxCZyruFSaAxM78VPujpvhkzsYXUz
1681	payment	1397	1397	1678	1	1	1468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtgpBmtiYmRyKkqpAbQ8bPRrKC94zyWWu1w38tbQBoyEHRfrN
1682	payment	1397	1397	1678	1	1	1469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysiuiap3zZuEbPiFEJzaF8xYeRPvHwMvqV8Mh2pzB16xDeHzU
1688	payment	1397	1397	1678	1	1	1475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6Wv3xHwaYtDtvmfwmLkVCxYgRcEcZdzqP5TupfiVHiNwCq8x
1696	payment	1397	1397	1678	1	1	1483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6rw2kwzj4fEVhAjUFdfSxvr2b5hPNTs7MuUMtnjeAj7CyAzn
1702	payment	1397	1397	1678	1	1	1489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XQ1M9L2Y1E5gj6M7h3mXt8DrmsMLzob5TxiscdRG4XV2aFE7
1707	payment	1397	1397	1678	1	1	1494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyS6oNUqdsfY6KH3t7nTzC35Fg1PjcjGdTjZUdx4wgPmo43HDr
1711	payment	1397	1397	1678	1	1	1498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxdUwpr1TVoacDRmXrg9WSyhvBdfgDCaSfg272qGTdT8JGdGe
1712	payment	1397	1397	1678	1	1	1499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MesMwFEa4DGAkf9H17B6Ju9qYT7CGfV8QdVc5NVTn11fuzyc
1713	payment	1397	1397	1678	1	1	1500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtLpVcGGQkt7NPzE2TQ8FmXq4pDSnNDve36J86W1pfZQufbhz
1714	payment	1397	1397	1678	1	1	1501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCArfrQNb4cCqG39shcQkYS4CgHtEkUuX5L6UvWj5CBev3La7G
1715	payment	1397	1397	1678	1	1	1502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv29Nj5pN9DMfCa1cBbPHW7Gu6gaFfXzDTA5AGwuew7mRfPe8G
1716	payment	1397	1397	1678	1	1	1503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7wP537QEbszPsHevRc7uWdQtNNAvcoY9XsurfVPgaKEL5eFA
1717	payment	1397	1397	1678	1	1	1504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddjDS6d413oyr4uNAwHff8sjBfb4XFr6zuXNxXXSchWtBMpE6
1725	payment	1397	1397	1678	1	1	1512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPohmde5TRioNWXftQ769cDWhCdLBDA5oCWGscm2ueVs7wdwAt
1726	payment	1397	1397	1678	1	1	1513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtBqmdFYYe5MwnxuF2owKggxyFyHLwZPBcjfstry4WtSYr3Bw
1727	payment	1397	1397	1678	1	1	1514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySamztZNiYkTrfXHWWTqo8x5H8Qx6NMSefwyRkbYe8Wpk4SGW
1728	payment	1397	1397	1678	1	1	1515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXHVM1aXDG4K4UJ3md9oLhRdqvwv5dsgEQzS6m7TUkYpVyqRu
1729	payment	1397	1397	1678	1	1	1516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxZtzPQAuYPKYs6BppZ3V5rwQwCGnEyWUGyvHEMQwp6uRSWCq
1739	payment	1397	1397	1678	1	1	1526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUqZ4NHLE925kkeurSuoGbLHeDB6vyng9u2qwU7BMCxaFRi35
1740	payment	1397	1397	1678	1	1	1527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRA5dzzX6oy322V6bhhpeNaTHm9eWQEc9tTeybHz45XAMvFa6F
1741	payment	1397	1397	1678	1	1	1528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwJrCwL7gRUWLYjfQWr7x2YGdyJbtPTEnoz2qhrQ74TAuamVi
1743	payment	1397	1397	1678	1	1	1530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kPGw65aG1Fk4kZNMGA5czsmyTZ3CpXwfVq2MFEA3LHENQVSV
1756	payment	1397	1397	1678	1	1	1543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJfSmR5NLja7VdVXAqW98SWCxNixkQvW9xpNds43vny2KTUfE
1757	payment	1397	1397	1678	1	1	1544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SSRoMcuyMX65CytnBse6hjKfw2D79SpgdpAJL7vXQLNzXkm4
1758	payment	1397	1397	1678	1	1	1545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbz7VEpMkuQTNoT2q81oAK5rWninkV7DpzAv51s1rfgAkejb5j
1767	payment	1397	1397	1678	1	1	1554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEAM8EVRiNYwMSZFh1gjrCRXunDtsDmTe5iYFfMVML9NvAc4er
1768	payment	1397	1397	1678	1	1	1555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tRnapQuFncchRjD55fgomzSKj6BYCqdny9KrGbkZGpLd5aRC
1773	payment	1397	1397	1678	1	1	1560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDobT6gjX1pdci7aCqrRVwLKGNfPQTajdvux57bBLhraGCpnfQ
1787	payment	1397	1397	1678	1	1	1574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQRHEPuQEZwdNMy7e6p3iiHcusd2F3aSPMJBEgJbGqVr98wHQ
1788	payment	1397	1397	1678	1	1	1575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7g2wjcDPCSFYrTFBts2zp77iWaAu6yUagB4MHFVgSTNs2eH2
1733	payment	1397	1397	1678	1	1	1520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYnebdDP9f5nsPvfaZFDhJTXR3gEThfRoP4urRUMrvY4W4Mh6
1734	payment	1397	1397	1678	1	1	1521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SFca6S5Yxbyxs2yzRbwXjbkejPP4b5JeMt7uo1N6ZyDagcgJ
1735	payment	1397	1397	1678	1	1	1522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwEUtsmEB96iU9635hBBSCK6wMq66qV9U5L8G58s9tGXAk6yG
1737	payment	1397	1397	1678	1	1	1524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQ8FuNWhwvrtZAAF7fJEa6WgPzUd6K7hZtzqVx4mS3KXtqmuq
1738	payment	1397	1397	1678	1	1	1525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvrTPpyDht5z9ifNvGgjyRrf64wPvAiaP3vDQNLtuyrY8Grgw
1742	payment	1397	1397	1678	1	1	1529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMHFHjd1Sjq7RxPKn7m2SaW7RMJKC44As5BVdQJfK7LETLwqS
1744	payment	1397	1397	1678	1	1	1531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHjsDAjqcQrnH1QMKgVt7kiqiToLUf8rHh3YXfcqRBmAjCes4
1745	payment	1397	1397	1678	1	1	1532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjonz3CLAnmznwNXSSb93Stn8CQWkgrPEDnmnE1kkLidshpDw6
1748	payment	1397	1397	1678	1	1	1535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p7DPozpdkKBs8RnJ1QoXsoswY1fdnEdsTkRqfGnFrZpLSniY
1749	payment	1397	1397	1678	1	1	1536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvdqisixZS9fXbRn5v8oogoAmjYtTGkodh2KiNhMZf3MoNkk7
1750	payment	1397	1397	1678	1	1	1537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTRfM78EYYbkP7yQSxzPb1A9qF1CjrME8qZeCu32WVMJ1u77B
1753	payment	1397	1397	1678	1	1	1540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4mPC4P1fqpNfo1Sa5qoyqPdZv6cHoCmCgQTNaeMUDPdrueE3
1754	payment	1397	1397	1678	1	1	1541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrgXjow9Nn9jZj2aLFfTscD7pBuCoeNCaQtuADTE8fyhxTovp
1755	payment	1397	1397	1678	1	1	1542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvDQpvjcatwx7UhKPpPRBMtJSNYp6CMWECmmxmvXRNCETjXT6
1759	payment	1397	1397	1678	1	1	1546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuxFjPMxXuzHmgyvp1CTUrqt3iMyeQNzgBDdY9Mn1VaXEHErD
1760	payment	1397	1397	1678	1	1	1547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEFCx1bBrzEiND2Qo5yikS2HEKymu5353SURQSZ5HkJWQXEn6
1761	payment	1397	1397	1678	1	1	1548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YgrfC8Dfyxwxt8WtctUhPW3jTUQcyqjhppPb1txNtLM1nxye
1762	payment	1397	1397	1678	1	1	1549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYievMTeE1dj9dQbUK1947yWEFfwZzpfDKH2FCH2D2jU5RitQYQ
1763	payment	1397	1397	1678	1	1	1550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHuJtpGM469tQLeY5JHGNgyWGXfYxRux6NoxXJaq2QJU8R35fk
1764	payment	1397	1397	1678	1	1	1551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UcM6XZszucXPdYNMzR7e6xsXgsz1W5sfcobo5bKFavYiidTo
1769	payment	1397	1397	1678	1	1	1556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaJNss3wnRyLQRkws4QwiiHzJDWzJioJUqoBPazM6NNSR8mqK
1770	payment	1397	1397	1678	1	1	1557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YnTzccG7uaQUru68P4sHvekRKtrzckmCdCH6RW8n6KSKqHmr
1772	payment	1397	1397	1678	1	1	1559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a4ivZX3JkJiWKUpnwbWom2sPzLJd7p5vLfuFSeR1RvrYYfXR
1775	payment	1397	1397	1678	1	1	1562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PtFsbo2ARjY9bMYvvykBiRMepJGFYutwNNi5EcdBVntRAaf9
1780	payment	1397	1397	1678	1	1	1567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKLgoCwTf49wtVQegcWzTJWBZaMFEJWafAvb7i11eyvKBgwDv
1781	payment	1397	1397	1678	1	1	1568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASdwc4mSQkpuPffePyLU9jseVC1mjD4vHj2FVMhnggdPjLQoP
1782	payment	1397	1397	1678	1	1	1569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMAcpudbcsmWRUPpeAzgE6EysxxW9jBqP2w85ELXanHT9u8p3
1783	payment	1397	1397	1678	1	1	1570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtKzE8wdtUL1xrzFaVoFesDTf5nYgeTEThaKZLDw1Add1ftBr
1785	payment	1397	1397	1678	1	1	1572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DSddUk4FY8nodMpGqhB7X93WcXGmXE9UM7j8EtNW6WerDk6F
1786	payment	1397	1397	1678	1	1	1573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3S2xFk3REqEKbEnc74ySNoDvYodUQnJrJ9WT7cfk9BXT7TAj
1789	payment	1397	1397	1678	1	1	1576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxT8LinkncmgYXjovsmwwRLFApEPtke8e6VdJjWwVBTeWAfCy
1792	payment	1397	1397	1678	1	1	1579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpZp2U2YLnaUbsF4MJuX8sgQftycFTxgeTSFb6Jqa6xWiSFZH
1793	payment	1397	1397	1678	1	1	1580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8ZG8vCgZXnsCso3sT6CJJYge36vg4kL3zy6ciedhkbfwmXr7
1796	payment	1397	1397	1678	1	1	1583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnn58A5pFsRtZsSUTivYgSEUg63n4b8nV4Dx9sirdsgwSqrA3
1798	payment	1397	1397	1678	1	1	1585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qYDgfgr9voKGsFX4bfjNsiBR1LqTM6mGYBD1Ye7ujzSHBnfU
1801	payment	1397	1397	1678	1	1	1588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6UMVPSDQibJpgpgR5419AQwhpTLrgm1PSA2PqXKzPpxbX8nj
1802	payment	1397	1397	1678	1	1	1589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxWmPyQhrb1t9HEWPxiw1HQmLGPbQM3FggkbFo7js5KpW3N9k
1812	payment	1397	1397	1678	1	1	1599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfPRXqs5bvuPmMVwT9jPXmxgSEjd2PSbbvEZqijZE8ZvxWCgQ
1791	payment	1397	1397	1678	1	1	1578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguRZVZKJBiUH8bdjzRRDsNp2YWcmsixuiqFXTgNsakaHcHYwX
1795	payment	1397	1397	1678	1	1	1582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFmKuWhD1EYgLWEjqmpHXqWSPzAQWKChMjBF7SjV8Rt3iTWL5
1803	payment	1397	1397	1678	1	1	1590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VMEGS5LJ7547HqUym6iegMSEFEa98kLxw1zQMYjB7CRzptc8
1807	payment	1397	1397	1678	1	1	1594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBLqkK95Wb79XM8Q7PGAydpYqBHLCKvY8qpvE1Tppfru4b37j
1814	payment	1397	1397	1678	1	1	1601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcWDFVUEc3TcDRoMFNoD5uWQGswnBfubSamETmoEPumF3TUPV
1815	payment	633	633	120	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTa1KxBb4nXvtpEu6NR7PUf7xUdJD3naLAr1A8bX3v2ApX5ZCE
1816	payment	1397	1397	1678	1	1	1602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQX5K3QVHZfT1w7pM52HWGeQiMNrpVs7MwT9aXp7zgBvTuxaW
1817	payment	1397	1397	1678	1	1	1603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCjQHGoukSq68pNnD4M6Hn6M2FPmKp9dnCDL4Sp2qTsmPWY9A
1823	payment	1397	1397	1678	1	1	1609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJz3BzcEA99FTQq3LmXNXwFVzv4DYTnGnRDTu9cPSfBvx1h5J
1824	payment	1397	1397	1678	1	1	1610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PEoA9tL1yRWsRjCDKvEZ5achpxvhud9Bx1RZ1qrYdQQejbN3
1825	payment	1397	1397	1678	1	1	1611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZma8eHQacWtRKo9r4aX4RmMi4XAVFuJZi8bfb3n3pbxPFsCCAk
1828	payment	1397	1397	1678	1	1	1614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzPEvJhB6ZH9AnWXnXbHiU3oRQV4mm6hnt4CPhtCMK8hWjQua
1829	payment	1397	1397	1678	1	1	1615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5M1Wc7USRR7A4AgwiWTXynhDarMy4x482KhbzZKthV5gSaC9R
1830	payment	1397	1397	1678	1	1	1616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPv6yueVz91aGKSzchSYScFCmgkQVsiZCaVz8ZF4GNQXNhV8nU
1832	payment	1397	1397	1678	1	1	1618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MM19eGssGv4YHLedf3uq5vR6yXfGs1ni2dKswmTW4gCsGZ4c
1837	payment	1397	1397	1678	1	1	1623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP3RPj7x667vRsLtAYFeY2XNCtyuZMJoi49u8SU9cp6AE3xGTy
1838	payment	1397	1397	1678	1	1	1624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpZ13vYGdJzzTzXWN74H2DUF8YpHCoRRiG22vbdX8ZDu4Tg39
1839	payment	1397	1397	1678	1	1	1625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3CryjtfF2rETeSuNXjRjeJMVTKEivd8TiwNeW66ZToyXJpto
1840	payment	1397	1397	1678	1	1	1626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMY1iVKqAF12Mcav998P2RGTpFtapfSXURdcS5hfySyNsDDgN
1808	payment	1397	1397	1678	1	1	1595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiD4iuLdvhiFihmdPfCApncr9S7rS5KshDY1gvG6Ce2KY8Uyw1
1809	payment	1397	1397	1678	1	1	1596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVwdM7aGjqS5QiMGAc5KnDtge8hC8jGCJEpiqveqpXHC7Rxws
1810	payment	1397	1397	1678	1	1	1597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzmvEmjdYne23ZuEtzw4Xa8RF9o2qR6KUa1TXDeii2ZgAFQ9Q
1811	payment	1397	1397	1678	1	1	1598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERGpKenJFGuAY6stiSPzwPBN4t6EbLWxACsrL6cLiMZbdVuYj
1822	payment	1397	1397	1678	1	1	1608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRmGcha5WocFivAUQk6rKfqZZSUc9Lup6Fcm6KwEbvwiUCkyf
1826	payment	1397	1397	1678	1	1	1612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDYNudGApmtyPhFVanQFh2mey6MonF53HqJNRehKm19VeF6ZH
1827	payment	1397	1397	1678	1	1	1613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNd3CCjsGjXWzQMaeNHKV1QGJUCRKfQjrvrkC47pbJVw88mc6
1834	payment	1397	1397	1678	1	1	1620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3DVAr6WDACCExq35Da7ULagWLtq9oeHA6HgTcG8TzpW4C7P9
1835	payment	1397	1397	1678	1	1	1621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkNmrFz7jNPTiMWZBXf3Mw7XJuiPjEkKJ5NBstqaNsZdsLWRk
1836	payment	1397	1397	1678	1	1	1622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1b12Qn7vTHjdrVY7UFx7Zebwuk3kZo4SCvr5SU3dmP85yvkt
1841	payment	1397	1397	1678	1	1	1627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwckRvWWKFpb9yjCoQdkjEF2vmn5oEkE249UAScykBSfRLGG5t
1844	payment	1397	1397	1678	1	1	1630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4S9TGsLUNwJ174gF8uG7LfM9WJ2oyFCfMgKkYM3Tp7dtpkoX
1813	payment	1397	1397	1678	1	1	1600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUy3dUD3W1PTL7m1CuNeTtzWpwARzdVFgdsUomQPLWcd221id
1818	payment	1397	1397	1678	1	1	1604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1kywkfTJD3mDbCvAySoM93pQfdkV6cfQ3VYuUKAMz6Wg9hD7
1819	payment	1397	1397	1678	1	1	1605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmh57rWAGzze7bt9zLzFMtExLpoXEK9h4oLyGpQZVwQJV7aJ2
1820	payment	1397	1397	1678	1	1	1606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYem5jfbatLWxPd35BrNsdmej3VjX9tAofkJJBcT9VCV4sn82kj
1821	payment	1397	1397	1678	1	1	1607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnbJzbpEcjU6Efvqx4vK7gRBxAoDrwznudnPJPg2HoRziQgvx
1831	payment	1397	1397	1678	1	1	1617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4WBErjdhm9gmyBEmiE2bd6o4KfJvy4Q5TAUa5VKQQJwsLpeN
1833	payment	1397	1397	1678	1	1	1619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDv6YmRZLUFnAyBeSqn7VAsReB7MM1Gq36LrBCRrRZkDZnJGy
1842	payment	1397	1397	1678	1	1	1628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EyeXRuDgFyZy4xrqMUy7YyCwmXgRE9mb3YajDmfkmG8rYd2H
1843	payment	1397	1397	1678	1	1	1629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDRxpRoKBtG7WDefMdLDFSiE2AWBW1dF4wP2T6yxmB7TptQbv
1845	payment	1397	1397	1678	1	1	1631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJBATLJYqG5W7b1Sgh48crxEBTxVTpnjrG8EvQZM9K2KH6sn1
1846	payment	1397	1397	1678	1	1	1632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdsnAgdcdCp9YKZpf9ycWsBzaVUc3JG2E6HKe6Chnr3KRBrjX
1847	payment	1397	1397	1678	1	1	1633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1mnUdHUmYNruwytzhDeqYdzcqagf9XWR7YxFYa7pFMP8fDnS
1848	payment	1397	1397	1678	1	1	1634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24ARhLTEbKN8nfrxq4eZZfFuh52cUiQZuAoomVLnNnLBjpsKj
1849	payment	1397	1397	1678	1	1	1635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWQMB86MKPXChJdGnvuzTNp9h295QeM8miF6cFpHpTuRTQQq1
1850	payment	1397	1397	1678	1	1	1636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xF4eJ8J2HSeRaGNNgifaaccb3kdzL3o1w6D8vMTNQjDxwyuc
1851	payment	1397	1397	1678	1	1	1637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDoBz28ZmkarxGZxe7YRgwNgcCJsyidKFWCoWiMJKZBNdwUxVB
1852	payment	1397	1397	1678	1	1	1638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9c4HenxB7kn2cQe4DeCqbKhLkdbev1fxYWe8bxjF4i7TKjv2
1853	payment	1397	1397	1678	1	1	1639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiE9e6PkFF11hrMy8WQBUyzbTh9F1FsxGrNeduVSAXgkH9QCRk
1854	payment	1397	1397	1678	1	1	1640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTCAMrz1P4QeN5RXpwB9oK3Ni8jywmsK5crFn8xMZmkKaE9Di
1855	payment	1397	1397	1678	1	1	1641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvoa685jFzvU8MsB9CXftHyzqEkpTsDpE2sea9bESRV8HW7g1
1856	payment	1714	1714	1590	1	1	1	9900000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13LNBf6bg9SRCEZiZTKKdGuCT4XpbwXD9thHZMH92UFbaYVyF
1857	payment	1397	1397	1678	1	1	1642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFF42DThMaavPizXTUrKkoRHrehgQpakvZWs3VPFesLBhR23B
1858	payment	1397	1397	1678	1	1	1643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqH5UEkVbxEVfqaWABtKsTT6Vou3o3vzESf4GbifRpK1Vqy61L
1859	payment	1397	1397	1678	1	1	1644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HCjwVbSxfY7swsTj71aetyNQaW2DvWUvywsAM2WCg7VXQNA8
1860	payment	1397	1397	1678	1	1	1645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwpLQnJZPPixc65KCZMZBggjYwXiP2sixpyGqEFbkdvBVrYxF
1861	payment	1397	1397	1678	1	1	1646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fbVmnvZHh3zNEt3yqSyN1S6HoLWkq2XJZupU6SNfGnsoMkTU
1862	payment	1397	1397	1678	1	1	1647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9xyoDfx5tEQNXmBg53JRfan2PsEKirmWgJAZ9NAdVVYy1rxd
1863	payment	1397	1397	1678	1	1	1648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNteBvtgf9tqTNEfYqhsJGUQg36CPRKVtXtTJUYEgFGwQPBvu
1864	payment	1397	1397	1678	1	1	1649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJcSfyVmgtdTbDd95HzCLW1xb7r9DMkmW1iHT8bHYv48gyYXy
1865	payment	1397	1397	1678	1	1	1650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8hsd1NyU4paNXFmkpstmoV2cAr5iX51RLcx7PaosjLLJ8gRD
1866	payment	1397	1397	1678	1	1	1651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bdnvU6YsqAdm7mFvz6pXFJro9unfupmagai4TcxNouU1YMuz
1867	payment	1397	1397	1678	1	1	1652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1kC4UeM221dmGLbELj4TNHUZFwtRefNDki89vT411L6dmt3t
1868	payment	1590	1590	1758	1	1	0	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSAxLydc1XuqhxU7YwDog1MZZD6WMeaCiBQyxyouY4SRkub21
1869	payment	1397	1397	1678	1	1	1653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuo6T4iTGspMBga4xusDFVYdjD5Y2xPUzgZKA992kJPJsDh2z
1870	payment	1397	1397	1678	1	1	1654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rR4zbcvMAu6mE8Px32YKKV1obf9ngmu99Lz7AE36tiHQrZEj
1871	payment	1397	1397	1678	1	1	1655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJJT5VzyYfRtgDXr1cauU8rW3vMPdZepqj7pxWRwjix1WkQ7c
1872	payment	1397	1397	1678	1	1	1656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiQsvwFX5CcgTE9W194z4uaXERD9tUgmiLFfwrLjPWfHzBLWa
1873	payment	1397	1397	1678	1	1	1657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRBwU5yttumEAobwasoxYRp4QiuQSMkvy1YgFkFRK7MGT2oAk
1874	payment	1397	1397	1678	1	1	1658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTZmLevYv3wAiPDNELjEU3zwTUzPJA6dwNSJmd7RCumbCAjY5
1891	payment	1397	1397	1678	1	1	1671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6NrLMznBD5deE5ezP5zTW2nZb7pnN9njpSex4gty7eRiTXLS
1892	payment	1397	1397	1678	1	1	1672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTpbZkeSA5MZvwugSfqehZtx31W2ueL1nuvfH8zjoG5DKtRx8
1893	payment	1397	1397	1678	1	1	1673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgX6tioZBEJi4MmD4HwNF7g8jXaZzknPSzvwsvWmcqPjjmEUc9
1895	payment	1397	1397	1678	1	1	1675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbgYF3U9xwjBPFawnTEmTo4qWJbQPXLwMxSCcBSQkrsMziVm7
1898	payment	1397	1397	1678	1	1	1678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GjDRv6sjTNRqaM6H34R9qbFVSxLYFi9pxMPmeuzMy2Ysu5pe
1899	payment	1397	1397	1678	1	1	1679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHKpUAPan8ofeSS8FUT9Y5DFckCLkhHo81F5rE5TohcVxtqbk
1900	payment	1397	1397	1678	1	1	1680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL8p9fUd7YY1EVN8qzqeNVuboC6FhdBfwFe2ScGu7RdkJgK76
1905	payment	1397	1397	1678	1	1	1685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimdywwFpebFvomYDhypdAd834P6EhoV4aKW4ftSCsHfqu14uD
1911	payment	1397	1397	1678	1	1	1691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53VkVh81NgS66b1cX6BAVjNW5zFGpYSH6JQ3q4HwPbAGSXVaq
1915	payment	1397	1397	1678	1	1	1695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScn3jNXLRQUgS77ZTq1JPJTCcsUAoPNyLjuAbQNwAJLtRzyST
1924	payment	1397	1397	1678	1	1	1704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhj5641qaRWcu2tXPjdDTDvVwF5uh7mDcX4LZzsq1SpdwH2oXt
1928	payment	1397	1397	1678	1	1	1708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS9rRSiMamKtm9FkLfyrA2r5aQmFhkRPrbyEStgDtGp7GE5sC
1936	payment	1397	1397	1678	1	1	1716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYui4xPjFHQWYju5iSDCGwtpF6z7vAh2nvmG3KvUDW4hSxeA7DY
1937	payment	1397	1397	1678	1	1	1717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRswMCZj1URjfC6BEQibpNfUAQdrfkc76pMckJMDrmFPXkC3Xd
1946	payment	1397	1397	1678	1	1	1726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQNMxaRspcPQqxLiK75NkGeY6Ax8ahuCqGSoj873hTcfunqpM
1947	payment	1397	1397	1678	1	1	1727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvxFz2KzUz73Rzx6x9M8NPxYrGCcHep8La7cGDzYrdF3xEDJ6
1949	payment	1397	1397	1678	1	1	1729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkQfEhN2Vc6u1pY5ibwvMiWRWbFcovdVLsddZoAN3mNDeLj32
1950	payment	1397	1397	1678	1	1	1730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6XLYQaQZB5ANrMWvWX9T2LYjQPfKE9GDPMADNxx9jx8Sp79Y
1952	payment	1397	1397	1678	1	1	1732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhf2qj3hCCCeMY55QJzHhYf6nLFW4qBxH4ANNygQGUt7SKyfmq
1958	payment	1397	1397	1678	1	1	1737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoE7A1XoXSCQm2oF5pbqfKsBECtqmGxb7LbYNjNE82N7g4YMdJ
1959	payment	1397	1397	1678	1	1	1738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB1VJxyT3jZSjJCxqaBtbenVix3CZCobtxFwFmzSbuqoWESai2
1960	payment	1397	1397	1678	1	1	1739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGG9hqSiuqBN8SvpPShdNrFWhPrk2vbY2DavQ2edEVPEFynxzi
1962	payment	1397	1397	1678	1	1	1741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUE4r5QnQQHFRV5tEAZfWPBRvxxV6MuKKzVUDxdUiDa7azQi6
1967	payment	1397	1397	1678	1	1	1746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJrNa5zp2HF1YViSPAAUhUETZRDg2vWygbpchGtV3VBtbPTLm
1969	payment	1397	1397	1678	1	1	1748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqnamgxQL8swPSKzvUQj5Ue8nSZBwyK2ebKkszxytNKLYn8nP
1974	payment	1397	1397	1678	1	1	1752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Q9nnqXNZuiZfTXCKeCU6hBnMQBZuXoP9DzmgetnwmiRNQHuC
1980	payment	1397	1397	1678	1	1	1758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNw88KGJmpMnfEK7bFc5q5jD7YG1ZQdTNCQNqfLGzxTwhZ4ZR
1981	payment	1397	1397	1678	1	1	1759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4YpDCabAnRhD5GxjZt6pXZECnayds56Hv1HYEy4XUNyqv8Fs
1990	payment	1397	1397	1678	1	1	1768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRtHW3prg6pdjbTcqn3QB4FozmiaJ9VFRkTDapYdKZEkQC2XR
1991	payment	1397	1397	1678	1	1	1769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkMyczZ6ZTZiTNacUFLS3UV8u7uqkJ12spBNqRJwNGpUcPrs4
1993	payment	1397	1397	1678	1	1	1771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkA8hehjR1JZh9UssJFtiDLwWSUyRCZARQ3vysH6QX2HojukTr
1999	payment	1397	1397	1678	1	1	1776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Dn8JQq8E3DRKybP2cMF9ghu9Gz9JxFVX5WMCzf4gce3DTNmR
2002	payment	1397	1397	1678	1	1	1779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmm9pJdF2rDvrvv2xLp4sURrN72eLqBaPQN5YFzGrTn7v8xoU
2004	payment	1397	1397	1678	1	1	1781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTcyUSRW857vmgh11aTbNzVcRx5ms7wnGWWEuKS44ce361PcK
2009	payment	1397	1397	1678	1	1	1786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmGvCvTVPCSy7Gr4jnfT9MFC6GryihAUTEb193XgRRf32Gp9V
2010	payment	1397	1397	1678	1	1	1787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDseVU7nd2MqWyGnWUrJYBiYTcnuKjN2xm2vszKTiofa2MCLc
2011	payment	1397	1397	1678	1	1	1788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbo7GdNZaMjNoMPSJNF57U7cQgVnEezYaMdeiGcwZqeW92XAH
1875	payment	1758	1758	1713	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngiGqqr9GPHLvPg1c2iJtcfFDA5dThbUxGu5AUZNNxCnqTYzD
1876	payment	1397	1397	1678	1	1	1659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiWDaQ15pL8ej3SEfZEFMM4XXcwdeRuAHBo57tTv3EG2z9a48
1877	payment	1397	1397	1678	1	1	1660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjXx1ijQjtDJu5fm3w1Yqq36fENcGRGo8k3SgRME9skBdgRaG
1878	payment	1397	1397	1678	1	1	1661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyKUCXqCJBHcNLgiLDeztXQweBnJewzt5qUMDGyMxikSDWekw
1879	payment	1397	1397	1678	1	1	1662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXnkQgQyC9bg27rV3fAmKk3HDoEGAV4HL9aqhinpwpEmgAcMA
1880	payment	1397	1397	1678	1	1	1663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAheahNvzKw8cZbszKUikc2PnNgsK3cYaRQW81V5RFa1iUyxDF
1885	payment	1397	1397	1678	1	1	1667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXD6N4yYBFBxve4iy4maZmfB6JFKdoHGF7CSyS1QiqNxmw7JL9
1886	payment	1760	1760	1761	1	1	0	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XBcrxUaXxbD7iwq6Ab3GRf41DUGGzvxYqCiURR8Bo1CvotTk
1887	payment	1397	1397	1678	1	1	1668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyrbzXjGNGbYJZyLUtqLvssa2Uj2v24L9jFpHcSjuEvWHdd1W
1888	delegation	1760	1760	1761	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupktFkX66VHffC59GnamXpB5kQ2BKhHzTN79wx7vUNvR7ivLz
1889	payment	1397	1397	1678	1	1	1669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuZa7cnHRzup7zzZhhWKtQ3e2sP1hhmjnTS1fjbfw9A95wPsc
1890	payment	1397	1397	1678	1	1	1670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSVTPxknwRF3QqkVhjwSRUSQkR9gv2Fo2hvyb99CWdfcR9K6C
1894	payment	1397	1397	1678	1	1	1674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1r9BdcTTLcdXn5rKib5mS8gUAkfYbum51yaJUJeRUbSneNW8A
1896	payment	1397	1397	1678	1	1	1676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVQQzt5tfbJAqwwMwVGv5H4vR8pMkXpHH3eoPoTDfxstJZwZt
1904	payment	1397	1397	1678	1	1	1684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CewB81hrhorCLD5y9ivnHkZWUbJHoc5Bi7c49zJyQGYKo7yA
1913	payment	1397	1397	1678	1	1	1693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYrujbWgZ68Uz5TiJ9Bdkk4nKmrC7145vxqVTxeVjiS3Sezbh
1916	payment	1397	1397	1678	1	1	1696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXz9LfLHiHW1Cf3LCNG7koUr2V5AmYurBgJMKjTTR7n5qa9FGh
1917	payment	1397	1397	1678	1	1	1697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNqywWm3d67QefPxzoXYQfVs1bw1dLsYYrDgjzeHD8v6c3qB7
1918	payment	1397	1397	1678	1	1	1698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLTTPc3dKHPAoVkRKZaBZ9rgRMHMxSYqSYxXpxX1omWw9gnxE
1919	payment	1397	1397	1678	1	1	1699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2KjArEJ2BrKESXBQpA5PNvkv54g16vnisSMJWUFgvnEUQWW4
1922	payment	1397	1397	1678	1	1	1702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNdrZk6y5ifw1XBAKDJjeE4yhafgAiVjQooFxkF3Tq92dnrBe
1923	payment	1397	1397	1678	1	1	1703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbt43NwG8tcFujdT6AXzE9JuCz5CD4MpBiwKtKHjbT5Q8RKxF
1925	payment	1397	1397	1678	1	1	1705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBAb6Sx9zUEKtbFYGh44ifBcfMsifBEqscNAXYpxZvnUvUPSf
1927	payment	1397	1397	1678	1	1	1707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZxEgx58Fd5zt2CapLeRByyLzdtj8iT4G8iaLHCEHRGEDDXus
1931	payment	1397	1397	1678	1	1	1711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqPWLXPdqEH6bN1DKsadncV7oncGJ8Fids1Xv8u6zc7G4ZrNn
1932	payment	1397	1397	1678	1	1	1712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYExgWXWKeyuJuc6oQ9FFaf7YtJEGJ692eMsogH73VQu6odCZR
1933	payment	1397	1397	1678	1	1	1713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbgEzBsRiLiS5QiEMkLGk1ubiL3Wd1jVvCVrhmzdY5aBoaqbN
1935	payment	1397	1397	1678	1	1	1715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDo3Y9i4bYPdpTx5sH7mbNYpQ7t2acjCtzNYUP8XjgT39MvGSE
1940	payment	1397	1397	1678	1	1	1720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QzrN3ex1SE8j9PW4j1DMgcsr6YFVMAvz5TW54K3nenLEKPgc
1941	payment	1397	1397	1678	1	1	1721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57ax2cubXSccaifWgkBcZUbA6yJkycn8YU1Lj1mYUA9ZznESV
1942	payment	1397	1397	1678	1	1	1722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJ4MeRkjdyrcPFaKDMsxHkZJdhcjbZ6iRbn4xydhh8it7YE6H
1944	payment	1397	1397	1678	1	1	1724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKhACRu1Webta7YEdfkAYCYNBqufyJH8NiF34Sc1wKr4y4yd7
1948	payment	1397	1397	1678	1	1	1728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkgBMeCE1MironDLuhMABbCE64J7LETKwenRWeMPfFcT3SteYx
1953	payment	1397	1397	1678	1	1	1733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFHj1fCkwHver4u67L8fiBb4AdfA4Q7qiPj61x2QLvTvBHpyr
1957	payment	1397	1397	1678	1	1	1736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHFtU7AAk4rfJAmrTer3faARm7ZtQzZugdEmRjUvma4RyG8ET
1963	payment	1397	1397	1678	1	1	1742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tZGBudYY1wEfSfjoy6tdpaeJ9WuzgNA4U3GBSpBttTLxuySe
1965	payment	1397	1397	1678	1	1	1744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3YpZRWnKuwXSb5zT4uwuh5hfUsb2yN6KVgHN4EHoUzpHRv7m
1968	payment	1397	1397	1678	1	1	1747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZReaNqryniJC6S18UQ6rMEQBKM3V6C5vKMvZukYz9nRH18bf8f
1881	payment	1397	1397	1678	1	1	1664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVVGNwg2yjdiX32HFnSR4u7g7aJTP5GivNUAkbN8mSqUo2hqH
1882	payment	1397	1397	1678	1	1	1665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHK68UG4d32nkadpYZVzsLdDWa6pbsqqzXqKhR6amT6Ud5n4i
1883	payment	1397	1397	1678	1	1	1666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUcuKSEuvEpvjTu2BQ9TGbBvzDdUB6sGSjc16pR2fXNwAMfu2
1884	payment	395	395	1760	1	1	0	3020000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNJcyzHAN4JyJHPYDhJkB2kkhj2XckgAeVvnLm5YrhCHqjceY
1897	payment	1397	1397	1678	1	1	1677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1EWWn9mgcAkMasrY9EUNQizk2kk8BvVPGgMAkAQgcVApVj4r
1901	payment	1397	1397	1678	1	1	1681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYAj8WHUKj4Re39RYo83V8KtF5KrBk456rwMkdPD15rDLGWEe
1902	payment	1397	1397	1678	1	1	1682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SP6uGhFNLmubkM63s75BRPNW3r4jhDsBpmqSymW15kfx2mpm
1903	payment	1397	1397	1678	1	1	1683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3isPzMFtMw3LSFegg5r38rWufqorEWiFQxmWWUVMozP4w6CXZ
1906	payment	1397	1397	1678	1	1	1686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKeJDmhNdziJu86RPEo4qsbPEiXaiK2ayAunJW6S1zkmhA7Lt
1907	payment	1397	1397	1678	1	1	1687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44PULUD3FSofAvHv6nRuFuG28GZvY6Gg2UtT9kis5M3FjnaGn
1908	payment	1397	1397	1678	1	1	1688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9yaD6is3DL7RYV75Lqnxkgbwujk1SMGv5ydTM2dqcstcBvfh
1909	payment	1397	1397	1678	1	1	1689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhHL1diMsUt3o51z5YJzCsJ2fLC4VZk7QVPPH5vcy1A4HhGET
1910	payment	1397	1397	1678	1	1	1690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hRBhpaoyR2AHf6VPyTaxjEJ66zu5RRwRpJkfuE8kBjL2Sf2V
1912	payment	1397	1397	1678	1	1	1692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsTqmgnNqkHY5vPqXGDDnVCi2B7JDmHKy7LfKFMUn4o4W57An
1914	payment	1397	1397	1678	1	1	1694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRBNDYpY4GbfFLs7T9bswCqzwaqh8H5BQotF9dp4Mib6U2XgKs
1920	payment	1397	1397	1678	1	1	1700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoigap47972b2yUy5SLEZVdu3jxpVRNnnUaR8A4JZoB48cLZey
1921	payment	1397	1397	1678	1	1	1701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthVfGEWEbD4WrxXzYnC2hJXvq8Ar8Gy7hLyb6yeUQQTGdjMVA
1926	payment	1397	1397	1678	1	1	1706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjkgWKc84hofW4stf2JivrmP9yzzukMWWFWoj5wtXQBaekVEAd
1929	payment	1397	1397	1678	1	1	1709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9wAbTuRZq4Z6vjhtaRpFL8Sq1YF7PWGrJ5GgP8b6aUk8pfok
1930	payment	1397	1397	1678	1	1	1710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqofdiVXuHGptnAzHQWFno2A6X2zSN1xAxTtPSB6cyNzMBpziZ
1934	payment	1397	1397	1678	1	1	1714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BhTRnWvwqhbAJ8ehERgpXdNE4HAuyGhETz5AtskAtXQ3NxRP
1938	payment	1397	1397	1678	1	1	1718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJedqkicpX71nRdTfyhnvbYee83fJTTNibGnrEw2N1anEj6wj
1939	payment	1397	1397	1678	1	1	1719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsV19EuMZ6QPkHBpjM5HmV4TjSX64uKV8wNf38TSZ7ZtJNCN3k
1943	payment	1397	1397	1678	1	1	1723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhkuGruNoxyeWQTBM63ePTdmtQeiiq6nhYKsJF9GzQ6Gv81GD
1945	payment	1397	1397	1678	1	1	1725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNqQ1GJDkHmqHNw7KRfHBwjjjtkUrcKqCNDHsGiAB9sEnkPL3
1951	payment	1397	1397	1678	1	1	1731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uW7aBXnDqnaDg7YAVDmgRzJuej8MC3PACq2AcQnaZwVwEsxY
1954	payment	1397	1397	1678	1	1	1734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6xgLjTwDFMPk4fpwdRfZxdocWbdLXXh6h5PjwCamwqweTfss
1955	payment	1397	1397	1678	1	1	1735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRM76xvGxN84kvVqQksNnWqPgm1qQPacFabxpiLaauWpossfHa
1956	payment	1429	1429	510	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyUV7aUma6vXKijrubmkZ31mdyJaTB8W2vUUyoEQfmhVP1WjP
1961	payment	1397	1397	1678	1	1	1740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96mEaL4TBXiqQpDpZ85XWqD4bDo1Ft4zm2R4badZtMusa9RJB
1964	payment	1397	1397	1678	1	1	1743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuscN6k3V2bu3Xr3nh3Uy1CCNFZaDQgkx68Qu6wrrwCbYxLwy6
1966	payment	1397	1397	1678	1	1	1745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6h9vR16gQDBGQ143xDbBzUJiVVWaotna8hE7rEHmFGGAL8QeC
1971	delegation	120	120	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfaFA7Q1h6qqUuTFu4odQTxWyAiwC4GyW3zpBrEWewXDx8UZx
1972	payment	1397	1397	1678	1	1	1750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaf4N6sNffMZZ6vM6cLKCbf4Pio2TTS6pX9BFpYpFtozzDN2Kb
1973	payment	1397	1397	1678	1	1	1751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhJoeq2iLUGVNrLnpLxotpYQwkvrFHABbuYuYVmycU3j9bQM5
1979	payment	1397	1397	1678	1	1	1757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2Vk1HZ7eWYAhiz2oXxpcRTutnnU566xzQDAynr2CcPq7jG18
1985	payment	1397	1397	1678	1	1	1763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vg6h3yPBduYDLHZ1f5hhbBnrvikQ3ETUh3caxR8NBrZ6tZGz
1988	payment	1397	1397	1678	1	1	1766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhso4AwnBNMgp1GqnvXsuDk4EoeYbXVM7BRo5ti5e6m5Gc4Zwd
1970	payment	1397	1397	1678	1	1	1749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ibVhmLJP4caJsJqgKi3nzAbULSQdckJeEZ7A1cRY62vmDjkK
1975	payment	1397	1397	1678	1	1	1753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytWQQxfrabZCdHVbvJkNkaUiAzgHRiQxNCfc3NQ3KhZqsR23b
1976	payment	1397	1397	1678	1	1	1754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuJnLDCYPANKhwv2KZZWpkXWei5RJrFjh4VKbD58wzWrdeUGU
1977	payment	1397	1397	1678	1	1	1755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnZyTvZQKbdRxMVdfeAdprXeuUU5Cmjy2U1BNcnazjNnQTCSU
1978	payment	1397	1397	1678	1	1	1756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagzDh8KKqoBE646FxoWXo2E8pWmgxKDdTBYC5iku9obR61EdB
1982	payment	1397	1397	1678	1	1	1760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqm6qcNnB85mz7U8Dkqehi3Sm483WVNHZEPfETeWg2oxE2oNN3
1983	payment	1397	1397	1678	1	1	1761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsG4ETXSaNsSoc3z95pQtBGgX3XSagj93SPjwNnBbhJ7TmkJP
1984	payment	1397	1397	1678	1	1	1762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3rE6wJjDCFn2jQLwchpVbjN2U3dmCRy99sjebJw9eqA5VXSNQ
1986	payment	1397	1397	1678	1	1	1764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kvcYQ7gedC4Aa4h27RNzc4oiK2kvFVt8RN4DXEq5UKTmjsa3
1987	payment	1397	1397	1678	1	1	1765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoagEQqdUjJzyz1wKxQmtRjAHGSqoaZgaYhtKdZYNUVGZAbqax
1989	payment	1397	1397	1678	1	1	1767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAHPxehxs8BBBqhhYDMct9sq4AiHSRD5LaLDq2wz5ppTVmWNP
1992	payment	1397	1397	1678	1	1	1770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdqbUz1r7Z1mTiUAxAzyj1RLKSk2TXv8nSU4CZwFECfeWad8G5
1994	payment	1397	1397	1678	1	1	1772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjboRtV7jR79zjt2ezThgWGvsRcJnuqKQQ7tbsvH2PAjBTSisM
1995	payment	1397	1397	1678	1	1	1773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hMzUcwUGnMXy1xwzvCD5WHErGhQwmuVwqRCA6iHPjKwRpgRx
1996	delegation	1687	1687	1647	1	1	0	\N	10000000	\N	E4Z6JzsozEzXPaqqQcmLF12qpTgnQrFiGxdqtrfHfQcpd2KX7T27b	CkpYQw89wmnK1EKE6itnz5z1PAhW65J6LhdbHwBcbs6rrAPzZ5ySr
1997	payment	1397	1397	1678	1	1	1774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiH2Y3cpYXBvS9dMEPE9gsX6Dy5AN3iwuPgeG9xHbgAFtuESBR
1998	payment	1397	1397	1678	1	1	1775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXjPdtC75CJyU9euecAzFydFckUY5hkjGo9CvdSHGH2rim9SR
2003	payment	1397	1397	1678	1	1	1780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ggzV4YozP6sQfnD3emFRX4bXai9TBs8G87sguRfN1u8fh2yJ
2006	payment	1397	1397	1678	1	1	1783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58udZWjWqrihDtfqpvHSJ3rocqxTb8sdw8nGfrY56b3NxypWB
2007	payment	1397	1397	1678	1	1	1784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwG8Gp522q5W4W1htyesCBXrQrUbu5f6Rn5EiCFLudzrzj1Cy6
2008	payment	1397	1397	1678	1	1	1785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXCbyh19RJdAkZmxwRSpoA3QAVLPiVaNarGiZjpdfySW2dB4Y
2016	payment	1397	1397	1678	1	1	1793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVxK9E9AkQEnB4f47boLW1KVhUvZfBm11vyHZxeShK8rf9KeyR
2022	payment	1397	1397	1678	1	1	1799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73QWoDPsRuHDEzhma7bw6Qb2hVmpXiBHbdMkf3yoQQcURjh1e
2023	payment	1397	1397	1678	1	1	1800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLMHBpvUbwwr7YdmMjW1ThEzZUYyunkc73t7zzoLRjo1A7uhvZ
2024	payment	1397	1397	1678	1	1	1801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpQ36HjAQBAyg7V7H4HeWHaMaGRxKqqHjtYdJgMBjYx1ZajeB
2025	payment	1397	1397	1678	1	1	1802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5AU6KyWwoxGN9NfvJHsu9hqNc6yC8fQDdQwWJFHYSzJ1mtwv
2035	payment	1397	1397	1678	1	1	1812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GfQoR34xbiDccB5BE8Km8bHo87oh824h4JZDPnVcTWCYjAyY
2038	payment	1397	1397	1678	1	1	1815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnH4akZseVzH7TK4x7jw1LjkKA8VJ7JLJy4D9pgWULAAbH5heJ
2039	payment	1397	1397	1678	1	1	1816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fRXVEWjFy7eHQB874YGfp51pUoCpHDNYnwQzprU533GDbr81
2040	payment	1397	1397	1678	1	1	1817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEg5tR4KciBvjG34V4AacAQDrTq9n9MquDo5GRXXhaE5d7akN
2041	payment	1397	1397	1678	1	1	1818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjk1CwqN7ocFBEw2UBzMLasvnsP83GQrab1DZUPwAtjCeAR2h
2042	payment	1397	1397	1678	1	1	1819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4ne3LfCzm3U7YVyNSA1ntg54i3Q6ALegrWeTB32BmF9PSAw2
2044	payment	1397	1397	1678	1	1	1821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCv72oL68RSUZFuSpVnYbcLucZon5oi2ppTBSZmcwt218gDSFp
2045	payment	1397	1397	1678	1	1	1822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktB4eu7vS2EUcxUdGAuRgk8n13s7P3gPuQhjY2M4ZMELmFVzb
2046	payment	1397	1397	1678	1	1	1823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNJXXEgsoUUWp3bQ1hsZymtVbMbrQ1aYsx1DKpXTje3J3c1vv
2047	payment	1397	1397	1678	1	1	1824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfG3xPZLJW5vuTWC6uKm2HC1NFvFnYm2DFF2goB5M5w1t94xU
2048	payment	1397	1397	1678	1	1	1825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUC8jpMFzLymrz6kgw5ng5kC2DcahYzGt3BqrzoSY2WXHp9xAt
2049	payment	1397	1397	1678	1	1	1826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhNmyirP8eAGE8cLhPa2ptYH1LRuatUEFrxH6GDkcPDJ5Z7GC
2000	payment	1397	1397	1678	1	1	1777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutiFebxm1TnnAqLHB1vGBnPrQdALgVGigCjesY8LC2wfwMMrC
2001	payment	1397	1397	1678	1	1	1778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3PehcznywTZ533BvuS2RSNwavFTvnMDRvCtCa6CaQ8n2YQPr
2005	payment	1397	1397	1678	1	1	1782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ9C2pBVryBGnLcuDXVHyBvF45D2fwhiWysehyhuoyJQTnNiz
2017	payment	1397	1397	1678	1	1	1794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjUZt5QJhCvSFzVyWARcRnQMk8b3YP9Byng5WuATzRHAWnQMv
2019	payment	1397	1397	1678	1	1	1796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHi6NaDTrGC4Pu5yAT3XZ6uumaWVJN66z13SoSqakjoYrpknL
2020	payment	1397	1397	1678	1	1	1797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAQr9WfM3tRgRTJzq76BKvnMELKgiu99rMqqEPhpoXzZytCcN
2021	payment	1397	1397	1678	1	1	1798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntEq1GyaZhyzyBoJTac1vPUD7spR3PkM4n4m4TRfvwNLSjAGp
2032	payment	1397	1397	1678	1	1	1809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LrTaiLQaxvepopoNSuG65b74aE7XTc7VztEX3bLZmeuTGvQ7
2036	payment	1397	1397	1678	1	1	1813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQF9TmuuFXye7D7btwkRU451QjPESW6r3wbaG2DoARq69Zkt8
2037	payment	1397	1397	1678	1	1	1814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxstqvuZxi7dpLT6Qrj9KhpFUE67QKLzh2t7ZR6SR6XLPAH1t
2043	payment	1397	1397	1678	1	1	1820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1K4EMBVaWGr6EHoYMKaSRncyQV78WyxmrPE5CCqauvNV93eSD
2052	payment	1397	1397	1678	1	1	1829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzw7JGQ85n9DZGHMimKxDSA5RyemCt8ytuj73j8YgZ6kQH2M6
2059	payment	1397	1397	1678	1	1	1835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHJX4jVTMwaCDiKPS1hLfvZMTM4FuhdqDDirC4ocE7H1SAteJ
2070	payment	1397	1397	1678	1	1	1845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbFNphEK1qarFpDdJwveUSnxxoseyxhRHdYDqbRYWfWgf7ENQ
2012	payment	1397	1397	1678	1	1	1789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfShGts63wj6pf1sccdRHXuYzEFLk3eiSzHpzw1dqZkx81BGLZ
2013	payment	1397	1397	1678	1	1	1790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdzibRKM37g9aNwwg9N322aMn9fRRHzBBDefZfyUybGfbYHUJ
2014	payment	1397	1397	1678	1	1	1791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XyuaRcwgNgdwNBt7eAnCcRCp2foWp7Fvh7Vv7rouoSZsZxgj
2015	payment	1397	1397	1678	1	1	1792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXK9ZtgjiTML7osHA1VJRDmjnAYR6EfM2U7EkouNs3AAi9mrAp
2018	payment	1397	1397	1678	1	1	1795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhthoNi4MYtvCpeoAyC8bcFHwTseLzokKzxv9E1NPpFYZSCpm3
2026	payment	1397	1397	1678	1	1	1803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCgBbzmVPkznCvyJbHHmRZPTvqznJnhk5kLj3577pQANW75pe
2027	payment	1397	1397	1678	1	1	1804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiAtsGQLaq3VgvMiRGbmvE7eTCTTLcMoqqiRML9QpZhgSC5JU
2028	payment	1397	1397	1678	1	1	1805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ApjdoqU4XRqPdid4oavipfq2XXi79wbu8UYoLwEQW5izrEMi
2029	payment	1397	1397	1678	1	1	1806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5dQ6t21bDFJfSPQjDH9AT32KSfRry2WxGcnqzmqg3m5mNTxG
2030	payment	1397	1397	1678	1	1	1807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVe9UDhii9vfkrqYALWYodJ8kfBz2YMSDJ7fix2uZxAn1tBDD
2031	payment	1397	1397	1678	1	1	1808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2RzuNP3BfQJKY43t8m1c8YH1Xw9AdRTg7HThRf9FWJ8nJRTou
2033	payment	1397	1397	1678	1	1	1810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWqFyCuKNNiJVkhsgrMYUaHsxYwaJA7VB2CmcWcbYL73sjMZR
2034	payment	1397	1397	1678	1	1	1811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQoxFhCY9ZUfLgHSEmEPVhGj4BUSKYXXkNjZ5C2qjqbPhn4Py
2053	payment	1397	1397	1678	1	1	1830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdWjHnqbGEmWdLdTgKFNCBGMV1vMqUi8jVw4W2tMQoEoQYima
2054	payment	1519	1519	1763	1	1	0	1000000000	10000000	\N	E4ZACwNkrDLQv1JveNwFncBqGyn7yZwbiR72sfnpZ3roGqXQJECzA	CkpYqFRLyjZVS2ArrePvVXKe4wHg6S54dgLNXQ3r6SFgLL4FhXeFo
2060	payment	1397	1397	1678	1	1	1836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ThEUqJVh66bWqyTPYJjgsuT1AYzGSBEm8xJjFbq4JBm46jKQ
2061	payment	1397	1397	1678	1	1	1837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghy1GwuLQfJkWqkgQAgn8UJJXpBZWD6Tys5uyXFYDF7wrfkKk
2062	payment	1397	1397	1678	1	1	1838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkPo3b4d9xkRogQRV3cKAfjuQT4sqvg4uSn5fAwzsMVuHYgQu
2063	payment	1397	1397	1678	1	1	1839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxTqt4yLhdBbXcRi1CsaJPipDryzqAqRB2R9KeAdErXwPFyfA
2064	payment	1397	1397	1678	1	1	1840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeb4XaieiXdnRiRQ1WZ4SWzoVLeKPRk5fWLLGHrqu7h3yoSdB
2069	payment	1397	1397	1678	1	1	1844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenWTzoyHZSKiYhqD1Zf8N2dJSDUp4HcbbLZJgGYhenWMyKdKz
2071	payment	1397	1397	1678	1	1	1846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJii8CXmYxfsjsxP3uLbx3Dz7S1AuSj73zcGCpHtpZqBQWRmY8
2078	payment	1397	1397	1678	1	1	1853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3o7kJc9rZB4xMxYKkdA78waYRc12aEoCsaHKvmTk63qsJNbt
2079	payment	1397	1397	1678	1	1	1854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvP3SFK4d4Q25eeTngCbpjRqnHJuSEiKdphzoB6cgCF5jUdQKo
2080	payment	1397	1397	1678	1	1	1855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCwgD7XhyotbjhRHxqXpokL52Sb2SUR5U7R2iTPQjFDj1iAHt
2083	payment	1397	1397	1678	1	1	1858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAahEWqxwpYD9HfoJbVaUeamgcCid1K4zc6P2hYGWW4W14gckt
2084	payment	1397	1397	1678	1	1	1859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLhFcmjFBgRE41FptqzaEFe3BEDKWgSvxeJLozzPaXh3jG763
2085	payment	1397	1397	1678	1	1	1860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu4S7iMJwpuLXLni6a5wuWJTZpRp62PhEXYfgxUDA7Jtkn7CQW
2050	payment	1397	1397	1678	1	1	1827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gtyRhw79dcfvz7gJrwQXH6LArVB7cDWYYecsQcaxKRnHo7Yh
2051	payment	1397	1397	1678	1	1	1828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgRVtUJDkxwYb8djxwz4MieNWuhWEYVZ3KVpKLYjm7PGgzPxF
2055	payment	1397	1397	1678	1	1	1831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRuQVTh4NdAkbnjkLCBZfwvG577mtQtui9ZiduBzMosBbS7MF
2056	payment	1397	1397	1678	1	1	1832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6kpURj487cM3WwaF3CSrh2Ehzga5mEGUbstKkZPZoGg2WceH
2057	payment	1397	1397	1678	1	1	1833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Jjmob5uQXZR5yBRQAPE4sQzkoKiVS8wTQSCJBGkTGXs7X47r
2058	payment	1397	1397	1678	1	1	1834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3W5KVJd1BnPjnu3e4VUfBhVPWqpCS3h9DWU4TLZkX9KoJFUg6
2065	payment	1516	1516	1756	1	1	1	1440000000000	40000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqQY2Rj9iHQ2fFdopVkuA4WrmbwSxDwvAAAxb9UDHayQiziaa
2066	payment	1397	1397	1678	1	1	1841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvosQ5qECFGfwzn7x1wBVwd2ezKuGK4atbE4r42pgUnhZQofS
2067	payment	1397	1397	1678	1	1	1842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgErU7WezfTm2dmZX7zKKu31XdxGPvq2qS9ufwJbZM8fef36sx
2068	payment	1397	1397	1678	1	1	1843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZcfmLc592zUabUv8zddA8Qr3P3LYD6v16TuhgbsG65LNh7Qu
2072	payment	1397	1397	1678	1	1	1847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnF5Ts9FNvmXxWQ6563w9kcwN52W3ZNpCwaio9KEUWXkvk7UH6
2073	payment	1397	1397	1678	1	1	1848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnFucfoaLUuvVHzZE5QujGF9VpneyP4D5bwSJDgzwd3FkXrRD
2074	payment	1397	1397	1678	1	1	1849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXW5gtPoMkG7iymYcDNqsZDbXZj5LqgJMCkByrk74kq4pcUjw
2075	payment	1397	1397	1678	1	1	1850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCa5uj9yK7CxzHeQc8EeuYq98P47xDp2JnQi4k2Jg96PVFZc2
2076	payment	1397	1397	1678	1	1	1851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVxS1xucaPfqtnd8sNtSkajam8vdWDrxzft5gKqkCjkYKpbFW
2077	payment	1397	1397	1678	1	1	1852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEUd9HirUXCFqBtUkMFyvAEiGNrm4HFjYEqbuMeUyPWjoe4DA
2081	payment	1397	1397	1678	1	1	1856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB63Vt8FVQPEEw4DGuxDhyjthGjDq7jzmxVdMVg9gKMNi3SxML
2082	payment	1397	1397	1678	1	1	1857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQ1BEuTiMv4FYS5wgcyYZjTRVAWuLQPnddQ8xGyrmjygvCHUS
2086	payment	1397	1397	1678	1	1	1861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8yiZxeUCdbGfvnxa77xK2Ud1U9SAx1EQMEeG8mA9MSdmdMHN
2087	payment	1397	1397	1678	1	1	1862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bC7BnaKkMDtXemEwBAPeFPFNu2UkgfJQmwxdJurXwPMP7KXC
2088	payment	1397	1397	1678	1	1	1863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo8LpCdkSVZJhWLasXRWqxxWdtjBwL5majABmoCjjHkffoPTR
2089	payment	1693	1693	1765	1	1	117	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZYhz3TFL6FSJHqapTEyZ3zgWAujviYJFou9739GqQDo7zU9jxp
2090	payment	1397	1397	1678	1	1	1864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3si3u4A2MaffTYcAzTaJQzkFYRGjATCttP37CZ5Dzv6RdXd6
2091	payment	1397	1397	1678	1	1	1865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JiME5ecSnkmjYrjiuPemmK5pquSjPXo2MNFxJzTDjQE68niU
2092	payment	1397	1397	1678	1	1	1866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZ8Yd9Sr8qtkYXZ3KUSoxRsu3xQzkvp8djYT7SFguceVuFVko
2093	payment	1397	1397	1678	1	1	1867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijbmE9mtYiPF8fGC1J2vRuxVE8Exg2PPZCYJTjpsakc46mae5
2094	payment	1397	1397	1678	1	1	1868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScCvVKDM9saDuLXsxvsQowxkJ1U1AHJtAQJ1ZLEQnR8LUiAZH
2095	payment	1397	1397	1678	1	1	1869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfCkJpZZrqQVCGcHp5X9Gbspy6BncD9PA7rNxDekdzvwe6oN4
2096	payment	1397	1397	1678	1	1	1870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD65M2sPtgs1VrmhPAMyvYnGTD6XkpkinLEYro2xZ7NjEDb7v1
2097	payment	1397	1397	1678	1	1	1871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdvpavdmbztFRurs37qsbvhCsAkPz1Ky6XDWBhatiXzRYiKiC
2098	payment	1397	1397	1678	1	1	1872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UNGJLM5FAxTzhSoF9gAaqudmfvnGv82TgESqgK8WeX7C4MeM
2099	payment	1397	1397	1678	1	1	1873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGihWQ8TxJbe4aTWDVa37EXhuTjs5U9YDzTkTrzmHxUeN7zyq
2100	payment	1397	1397	1678	1	1	1874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CewKMjQ1Qx8Z6bZfaX41UPvC63arESGjQtykCf7AhmM3zWaF
2101	payment	1397	1397	1678	1	1	1875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2sGuM3FZAcWxKuNDMPjoAooBh1vU8qGLUDAKMXMj8RQFpFjn
2102	payment	1397	1397	1678	1	1	1876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjURvMkSL4W5byCqWzsXCTof2kYdqLJ2oTTgkRbymFYan1jWTe
2103	payment	1397	1397	1678	1	1	1877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYY4wCMcKDwje3CqvNxeTsT6eyirSnLTARr8zGHpYd3zigMoy
2104	delegation	1706	1706	1646	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApBonfQSogz1osr6ERxK3HVsT81QmXX9FWbNEsYnjz3B2JnyG
2105	payment	1397	1397	1678	1	1	1878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1BN2bukecWP2ikn1QSA3mbmQoFGBQG9ASj7zLohjE5vSGBT2
2106	payment	1397	1397	1678	1	1	1879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtv4xvp2Y3yyMypMFi5DYZBoLCw4ffepwMFz67cjXPwQrqsjD
2107	payment	1397	1397	1678	1	1	1880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SwEJS6wRH73srgoRcDsg126w7yGVXLSEB64EXQfbVtusxi4r
2110	payment	1397	1397	1678	1	1	1883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAtwMd9GfHmWtxn6JvW3vfjX7VVTY3PAnVHF8FgAPocQqFqpg
2111	payment	1397	1397	1678	1	1	1884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QGrheeNTEYHasUYZS67FRXFFeqKWweyGX6UnbuveJbmELo8g
2112	payment	1397	1397	1678	1	1	1885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtq2WDg4Mb5PHEWcHo6uZGyRPnDWSyHsSnF3VFecxAvtzp7R2
2113	payment	1397	1397	1678	1	1	1886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkH4CS5Ru66i9ZWVThZSLrkX6uUaGmcpVVfUigRGJjzTUd8m5v
2114	payment	1397	1397	1678	1	1	1887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnnx9UDh8fNjha8kg8ANbcTCgqexFW5AiAzpZGAuAKWhsgFby
2116	payment	1397	1397	1678	1	1	1889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuEZ2czwU5uAiYDb16CrJiEZXE9YBtC1qTctPkWCKQ21hDpmM
2117	payment	1397	1397	1678	1	1	1890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkp6Q7Rk1u4cBPfrcfqFNivGiSFDvBpdFrrb7RJ1zz8iUdkbgZ
2124	payment	1397	1397	1678	1	1	1897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hYwb2rRM2qnH3eRE3JXCV9q4ZQgiS1DfLj78Ms8N7v59tM7Z
2131	payment	1397	1397	1678	1	1	1904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2ArXMDG5t2xnPDsRDwaZyZnmxtKR7vnQ4SGwFFdvpHraEkxF
2132	payment	1397	1397	1678	1	1	1905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkoS1QqXgi4vSDxJnrgZCdPJEwErtCrMgvrbiAvF5pK6Wychd
2137	payment	1397	1397	1678	1	1	1910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcvwNxku2YLYv1YNpnjJiLQUhVLjU9nWvdJzfDZePEWhcd8eZ
2138	payment	1397	1397	1678	1	1	1911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjfjRkbosbs9Uzr8H48CgSEWXySeEcYaECTMfnEVpzN1d33ex
2145	payment	1397	1397	1678	1	1	1918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8W5LXQeFSgtwGs9cN7Qxgz6boWTDCb62zA31JSvRWbipPnDh
2149	payment	1397	1397	1678	1	1	1922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6quZiiHwk56G1dUS4r4ReS9s21YJjXdVQtPjV2pceEmzhKaq
2154	payment	1397	1397	1678	1	1	1927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZeL56PcPSFXP84ivQzyDtK89DXHfAwcukzSPYFgKPLsmuF1V
2155	payment	1397	1397	1678	1	1	1928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPgAZKtCc2gLVcz8ocvktkWemFMJX9LedKR1iGBbRguuxakVn
2161	payment	1397	1397	1678	1	1	1934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvJpzyMtA5gte2ycB7ak3GxFi2YQMguGkL8Hbq1rZFQeBHnYb
2162	payment	1397	1397	1678	1	1	1935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqxmX3nTi9aCyqmhNWN9HiaudDxsVTxgWizsmyCuy359inLMP
2163	payment	1397	1397	1678	1	1	1936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZzNjpyq5JHjYHBk8LhSDKXGidcubgK2ecaQNhPFvpKfoFkf2
2164	payment	1397	1397	1678	1	1	1937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtxtAAWFF9L6ZBo5qp9fdwTZftgVzSqD4HLtzw3Yc2QWfToKy
2165	payment	1397	1397	1678	1	1	1938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE76kHj91KvYsrkdVKRjAx8QktWjib9hzJL4e3NGVhVQTTRoe
2166	payment	1397	1397	1678	1	1	1939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNyogfoibUL2r4jLmR8jVmNcutBT58LPzxFKyqjXfQt2VGpNr
2168	payment	1397	1397	1678	1	1	1941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPP5dwhNkQg7dT3bKZorudXYaCiuPXfzZ7eR8GDUGVEsqVx5L
2174	payment	1397	1397	1678	1	1	1947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kZNgmZAjHkizPRVzhbeDriCTZGTGADLVNeciy12mRwaqKpsA
2175	payment	1397	1397	1678	1	1	1948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYto7p9WnBNwfAukySH6er8fHw7L3Ce2sG9rBGSu19ogyYw4iYs
2180	payment	1397	1397	1678	1	1	1953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnfDSLkWnYAouj3s3cT3kVY9WCVqeJ75ExZrTbHxX1eQawfr8
2184	payment	1397	1397	1678	1	1	1957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDRqxNfG8qTX9hv1hRUdsJtBqoKqFLapxv4ydnptZFVHtg55D
2185	payment	1397	1397	1678	1	1	1958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81NaYvcxQDvB4fPCqPvYBTx36Pm2zmjcCfbAzn8XP47n599GQ
2189	payment	1397	1397	1678	1	1	1962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbiSqvyz9C8pQKQGFHFX7b5wg6TCTDWcDJoGZmAcLW43MsHij
2197	payment	1397	1397	1678	1	1	1970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszA3Ap7os2XpahHyR6giHTUo3citgJFQXsHHUPCK2Y1WRomAW
2198	payment	1397	1397	1678	1	1	1971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbLFB8QhUDVJNxGx4hPKK23GNoiqnXbhcT8hGzu92wRfXfoAx
2199	payment	1397	1397	1678	1	1	1972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3aQ1aCnbXjPrp9jZChF1KdKMouP2EZT6VYvGSESaVGdAKSq4
2200	payment	1397	1397	1678	1	1	1973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZioV6hMZ3QoVYfZgjKoHdSiXoWDNHJjH9PmbAtzQbefVnFoQti
2201	payment	1397	1397	1678	1	1	1974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTbP9BiTzHBn8JcpRizCVZwQDo2Sso7rUZNvg3Q3NQJz5F3yM
2214	payment	1397	1397	1678	1	1	1987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJmvcwfepEFXUrtmoLXFEnGzk6bo7KRpHZXJihc7djFi21nrU
2217	payment	1397	1397	1678	1	1	1990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hK6c5mZvUudWy5PxpWGmEkPVvmgBmHtg5AEAHzAm5VMtCcF9
2108	payment	1397	1397	1678	1	1	1881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3679HAuLCwMPgBxvA5PjZDm6yKPZ21qzvp4YrBJZa4HQfuqkZ
2118	payment	1397	1397	1678	1	1	1891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8SB5nNpKdNLErv4uw4R83MrCMjUeAEFPNqhj3CCbnpmUTo6w
2121	payment	1397	1397	1678	1	1	1894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQXr1U2me4B2i27FfcKNd6kZamLB9J8X1ktjfPR9EyrMGQrXkx
2125	payment	1397	1397	1678	1	1	1898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePLqL245RcNLnfm5RDEyiSKUUCVvRQ8eAGcV6MG4ZpEDsXA8y
2128	payment	1397	1397	1678	1	1	1901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HJS89GWkBZGQDDjCTWJgKeb7UpcbhanTQ19aetLD4FTB1pRY
2129	payment	1397	1397	1678	1	1	1902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3toEHqWw1Ta12Yg54sBa36V5jYL6EjyvXJkbUAmssp5QpMXF
2133	payment	1397	1397	1678	1	1	1906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hgyDWrCcYxDXiuVKHrdZfGuBcxAqoLCFQXq8G32cBYZ9mzmn
2134	payment	1397	1397	1678	1	1	1907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWDpThgg87VqhUkmwdobStjfF6MqWrsHVEfV3yMj4QtzPtJ57
2139	payment	1397	1397	1678	1	1	1912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes5XuCjdJbjSAXArjezYSKUjT5R2BU51ao4LB3FKHKdcTxm4z
2144	payment	1397	1397	1678	1	1	1917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DKkwpTtE1FUkwEAN6MkxNaSp2v1wv1FwnKCkRB762QVzYSgC
2147	payment	1397	1397	1678	1	1	1920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1UvQtYQkMZPViCGgxLmGkx2MWUftrZzLvtZy37vqPTs3hfj6
2148	payment	1397	1397	1678	1	1	1921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7c4AZY3nNKragkvhRKhzbYvXFkxhVBATnfzW1fE5zNNGyseps
2150	payment	1397	1397	1678	1	1	1923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzL5PuzxPQ3MgNyF4krumRr2UAvcs4AgqYVvRH9wGkdL1pjEM
2151	payment	1397	1397	1678	1	1	1924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4SP5FNBq8LbWdyPxV4GussmGq6Rm6fzThgnekMbDcZTEKSR4
2152	payment	1397	1397	1678	1	1	1925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fcRvvoBWadyUHg6dYE7cd3B2Ukbb1gCaNw3rZ6WdnZWwwicA
2156	payment	1397	1397	1678	1	1	1929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo896mZ4QpVu8WiWdehCgQXGakZ1eg6Haq8tC6jg7uVC4WRCVV
2157	payment	1397	1397	1678	1	1	1930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAR6QxYyoVW5vTXRW2zkuKnsCTg7YYeUztdSUj8wcvRaGxVU2
2159	payment	1397	1397	1678	1	1	1932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLy2mkBV5rz3XsUPoauRvsG1MbRMrY4XtAxR1B34P8zHFGEbr
2160	payment	1397	1397	1678	1	1	1933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJAgRYPHBMqjytpqL3Hs34hs8gpQTX91RkvEy5zXLic5i3Tph
2167	payment	1397	1397	1678	1	1	1940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMN7xvHdmrN2wnE5yT7uKkiqtt929CRLA3YH7E4f35D9onmB45
2169	payment	1397	1397	1678	1	1	1942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrXRLADfU2GhMNR1SvJu9EopM1mYoaHAm7BNCQv77SxGxgbJg
2172	payment	1397	1397	1678	1	1	1945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnDRMYFA63ShF7uXKLrjgGTH6qk2UnhNnouLF6HymXfsuVbfhg
2173	payment	1397	1397	1678	1	1	1946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYT6UqnPFFVTVK5amdsrt6F7c4mP2c9ESw6jg3JFfvagNamRGW
2177	payment	1397	1397	1678	1	1	1950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gWX2MHRh78MgvLJ9zq5ytHGrWUzAun3cctc7cKBKydKDYHK6
2178	payment	1397	1397	1678	1	1	1951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBBrfbG33X4DdsNX3c7HS3qyXo1iFFsUMgLhAbzaw47jhcWFf
2181	payment	1397	1397	1678	1	1	1954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEYqPejKKm2xpUezwg8qE3kmVpoYD1Z1HwqFfpD5oUkaBdQyW
2183	payment	1397	1397	1678	1	1	1956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhq2bqkCTRt6hny5zr9eeiP1YgvEsoAUvGYqErMx1N2rvSYrQE
2187	payment	1397	1397	1678	1	1	1960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBfAZxLViiNTN5FYAdiH39iRkEHGNhMyVC6B7Ara6Z1XSdZam
2190	payment	1397	1397	1678	1	1	1963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkf4Mru7tVLxCQrs4unr7unG9LyQq1DNpFcz9Pfu3huQSEBfxZ
2191	payment	1397	1397	1678	1	1	1964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzEcJz6GNr2AjQm6HyzedwoDQAssogTCki3GThhmYySBoRNPG
2192	payment	1397	1397	1678	1	1	1965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68otQx5FEQ2UGh1X5GPy6PRsDVcD6Mac4EDEt5B86qcYKJTMB
2193	payment	1397	1397	1678	1	1	1966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpt7gn1eKyXZ9XPHSLyn6gDLCtWXzt3ASjRu9hXPtg26f5rhve
2194	payment	1397	1397	1678	1	1	1967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GpoewPb18biPn15bHsvwLoZf7JQyqXMUdwKdbPDx1HWCk8xB
2195	payment	1397	1397	1678	1	1	1968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sbsPqKAu4tiGdrvFZS2h7awGmbk6LQ2EiYdZidqZf74jFVPq
2196	payment	1397	1397	1678	1	1	1969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5BVioV4mpZiCBnYSUdY4VCEUWcYqZRiVD7Tjun9VNP9kXmh5
2202	payment	1397	1397	1678	1	1	1975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZor6HpUmcXPWgFeGYbxmagaAPqTu4BPVL26ZRMRayrToMrEgAg
2208	payment	1397	1397	1678	1	1	1981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCD8iW7756gWBZiCqPwiAGVrnQg8cYYMnn8G71BDyKAwZYQ3Av
2209	payment	1397	1397	1678	1	1	1982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJHb2igpJP7Ni3ZPDeEd3NEqRyjkLnkNg5CS4LcySDeFX88Yc
2109	payment	1397	1397	1678	1	1	1882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfyVQVy5pBH77uLaixSLSeJvENgznmQraDdDLhLeud1DS5p4Pq
2115	payment	1397	1397	1678	1	1	1888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cmY8fSWxVf7MY7GS881BwmJCtHRDUxdu765oGnQXfwVVMm6p
2119	payment	1397	1397	1678	1	1	1892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNxNsvJgWfBEJfnXfESWFQUKLdFw9GfSaqi21wTkJ51dUXVy3
2120	payment	1397	1397	1678	1	1	1893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipcPwHya2d2G1KgjL4bkpktiVmQUkjP53EABBqjkHM8Gc3RNh
2122	payment	1397	1397	1678	1	1	1895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrWL1SEvU4CQg7DYuf4Fq3vxYeuCbYMMfp9J329fqZhY9yLw2
2123	payment	1397	1397	1678	1	1	1896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvLssb1A8bLaxot1zDdWrYNMdFGUbQ6DEHYaa4fNJQMdYJWax
2126	payment	1397	1397	1678	1	1	1899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoso8rMDsp3Y2XWqzbJfPo49jX4RCCcmSxEUiCimYF6Cd2PGir
2127	payment	1397	1397	1678	1	1	1900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QAMTQAT2h4BxKKdrqdYhBACfvZHJeFjkdqWRoeokn5wasWzJ
2130	payment	1397	1397	1678	1	1	1903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLJZyVUYwCS6B4R1R2uW86DuqWVNqcnH56VxpiWS9bp6N5HjL
2135	payment	1397	1397	1678	1	1	1908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uoVxmnGXCu4QeMhthi6YdMUeb3T21NfxWSHUv2hZ6G3VGZVt
2136	payment	1397	1397	1678	1	1	1909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPALLySKf6D7UETvCmjLdBUgcxeYC55tkKLGLJJHMJ4puoMBUJ
2140	payment	1397	1397	1678	1	1	1913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qUVv9cTXDuLesY5Tvz8DWhVTkwgckeU9WFjJctWwphnDUz2k
2141	payment	1397	1397	1678	1	1	1914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoAmkw2usWQ4Maq717pw6HvbRTGiYzFA3im7JmDEYc9RH79ZY
2142	payment	1397	1397	1678	1	1	1915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUyf4EUPG9DpPFi8vVLYtekBUTDDgpXmAt67cMSbzxCSaLsat
2143	payment	1397	1397	1678	1	1	1916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPs1HwvRevScJVU4ZZFBrY2qKU6hmtUZUQxtDD2G3i5CJjA15H
2146	payment	1397	1397	1678	1	1	1919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VnWcVBw3aZhi9vG1qvW9VG9kh39PaUuPtXpp6xX4oWXnGqkM
2153	payment	1397	1397	1678	1	1	1926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJz8rzuKvu99U8NRRY42aquyhmmghQ6Us7xqSt2rGNwMqGynNx
2158	payment	1397	1397	1678	1	1	1931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNXXGgZAbPW2CNTokcLb917dxQBj8evH8yaRg33bnQFdZVqvQ
2170	payment	1397	1397	1678	1	1	1943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCL7kx6UHowUGYmfvSyeRWWfPCdGyCJnPx5MCJJD4RzziGtgbU
2171	payment	1397	1397	1678	1	1	1944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCedCtjqBoFtfk8YCqYSh6MVqgJJj9FddHUQUMKoJbnDcoMeB
2176	payment	1397	1397	1678	1	1	1949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjXfgugn6W4MGKrzjCWj6s3tzPLtRt4i4RGhf2r5DQzZd8ypa
2179	payment	1397	1397	1678	1	1	1952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrESBnBEy3k4d555mQfZrJyPfbB4A5zu1uzoCBWiQXvzBWjsTR
2182	payment	1397	1397	1678	1	1	1955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYune2vdzezu8p1oe7uDQUygxSfjnsfPLUdBbFzeq3JNDEYo1uE
2186	payment	1397	1397	1678	1	1	1959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA3UUU6BAzJvvPqgu6EwE9Gqf3ukupZ5Sm9oSxQc44SUrN6Ga
2188	payment	1397	1397	1678	1	1	1961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcu5YimNUfJS1yDLPkwFuggkLFb7Rk49NPfQtbkW4ifQwJcw6B
2203	payment	1397	1397	1678	1	1	1976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCX4ujpvEU3haHuWdP7khXi8Q9Pu4DwFPJCqaDWM8FPxuPH1H
2204	payment	1397	1397	1678	1	1	1977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HYXu1b3DJimHFXWZWrKNQbuW542sTsHbD6fj1WVHgCPBAPfc
2205	payment	1397	1397	1678	1	1	1978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZxx91GDTZaCjxsmYiQfpT5jCgvvM7g6eSyo8Sxr8b8adi6G8
2206	payment	1397	1397	1678	1	1	1979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTER69ZSEfawmrftwEX4LgJ666hJw71RJfYJAMYqPAPcfszVj
2207	payment	1397	1397	1678	1	1	1980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5amLKXrSQ7rxKXeWNhnc1qYo4EXf1k3pNvVUq1fkWkfDwAt78
2215	payment	1397	1397	1678	1	1	1988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoWyJvyECfmQiWhNtZh78uFT8Jr45QeUyd331K48San7QTtzg
2216	payment	1397	1397	1678	1	1	1989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3R6mJuRfse7HWSDJSyeBkVjSSYRmQYGeHwnMMVKJKuZbpM2n
2220	payment	1397	1397	1678	1	1	1993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Kvh2xxjPewh1CHwNym8oaEQkD3DR8Aw4zgJm6QfwetYu3Txp
2221	payment	1397	1397	1678	1	1	1994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jaVDuxvhH8DyKoRDDWZh5Dhh7oM1ExCSFjdMnkXAk3EbYbpg
2223	payment	1397	1397	1678	1	1	1996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTuKjcMiwQNBDibjTztVxJP8Y41QQfkazn5YDzfzCDrmbXyAT
2224	payment	1397	1397	1678	1	1	1997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQZ19c76NsqfGF5HoMNb59gXDQytJAUYzigdDwEoGRaTEU36g
2228	payment	1397	1397	1678	1	1	2001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXucBs35u7Y9xzdKNcqZh68uk6fa9rUd7da2ZKWinxAhU39u8t
2229	payment	1397	1397	1678	1	1	2002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMZaUGAZMGsZkBRAERts5eMoavRN6e9Hp96gr16zkfNc12G7f
2210	payment	1397	1397	1678	1	1	1983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvqguKJLT6Hqb5dky2Pvd38CjU7qYkSPimoZcY13FPSA5eveV
2211	payment	1397	1397	1678	1	1	1984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDiXBueCb8q53SqydEyH5UE61dEBdAoH9PhqRtdn6e5r8TZg5
2212	payment	1397	1397	1678	1	1	1985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5zm9w8fDPk1f2Vzoyi4abFCTK3w3THfHnTem7soXmKMWiN3M
2213	payment	1397	1397	1678	1	1	1986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQFpMEpUVV2untB7b1kUFtnXNsqAXv6PZkfxeygCCKUVzeP4f
2218	payment	1397	1397	1678	1	1	1991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6f5utrb3xUTtQVLiAtNSwQysiCQP3NTCodimWAhJ7TkmdSLq
2225	payment	1397	1397	1678	1	1	1998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZN6SQrX7CvFvxg2yuBnfKaDrJijTG15HWHzDMSVttPZRw1G6
2230	payment	1397	1397	1678	1	1	2003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy69qNt7171RK8qrpW7AYTW6XcLV2mFnN6q4QSeGUX2VQuKvj5
2234	payment	1397	1397	1678	1	1	2007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4vswERRDwJVXcyZMbWypiBh2z3sXBe3f9Y9rBQy9q7wBW3YV
2239	payment	1397	1397	1678	1	1	2012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pAaMTqvgAknCZSi676xiwSP2Adhvc1m1N56xNHhKHi8jYxUN
2242	payment	1397	1397	1678	1	1	2015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6ipCHN53QFAaunuuFR6jUEQhbz9wVvgF7nYunHBeE47mLCEk
2244	payment	1397	1397	1678	1	1	2017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZ8QeV1uaLsweJmGAPSfRvrpEngASZVo6xummLNFd9xLYfQYf
2245	payment	1397	1397	1678	1	1	2018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9AQZorXMCqiDkPigKbdqACYBPdJzRjfJjQgyLaBvGm2WZZ57G
2246	payment	1397	1397	1678	1	1	2019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb13pJpSo5yW3CRCCUNLqEYaSzvU7Qko2LtX4j9mM9ovacydaJ
2255	payment	1397	1397	1678	1	1	2028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9mA2tcUzVYhayZinVmUdTJMXs1hWCRhz6PJdBWmqR8aEwTG3
2256	payment	1397	1397	1678	1	1	2029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipkF6Wiq9dgARZzrPmWWusRXXVEqCL9itKzfobuwR1FR3pwaN
2257	payment	1397	1397	1678	1	1	2030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswNJW63Y6vWiGK8mSEpqJRWtH3ojxZ5B4Nu5eoFao5WNaYhXN
2259	payment	1397	1397	1678	1	1	2032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyyvtzF6ri3NRZfT1TJNBx9FegzAod7W4WTrqXWvu4vXgpz7G
2264	payment	1397	1397	1678	1	1	2037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2q5toNXVagQ1DDuhnAbv1tko4rKt4rj3GiwXjL4kJ4XLUJm9
2271	payment	1397	1397	1678	1	1	2044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREt8u3BQVXpGRvtnUpggSR2auM6j7xAvSdDJkCvCJnQkmdAdq
2274	payment	1397	1397	1678	1	1	2047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKfa7qHT2W3Shw7PbNyU6Sg1xcX7WKa1mhN6pNJNci2k5ZE38
2278	payment	1397	1397	1678	1	1	2051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTA7G6K9x7BfHVpxNpQuPfYZLjqbc3HDQCwNTJYKV5AnpNCfZw
2279	payment	1397	1397	1678	1	1	2052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTNK5RdbGwwNM6nfWwguJPSi5NDgdQpibtqJ7kRozmWwwmjBu
2283	payment	1397	1397	1678	1	1	2056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNwnmi5N1hN3AUuQkPNyAdTqRdBWaq5mRNJtW4WNXsDrbvTK9
2287	payment	1397	1397	1678	1	1	2059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MEom9GMxExiN87ZiEZmFnfinUwm7CppkQVKV8ZtxJ5nBSy96
2297	payment	1397	1397	1678	1	1	2069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXeeXHJqMjWC2fgxZgnkyssrBQSNvna7UzbXggQMEGf1yquFkd
2300	payment	1397	1397	1678	1	1	2072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgLNdKezarBcK3qia4VUEj9J94pTZawxewtLFFdhfemwUtGub
2303	payment	1397	1397	1678	1	1	2075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpFVwm6BiftkdaiXJmvKkd6tQYd9nTUvrArvoDFZvUSNVv7Fi
2304	payment	1397	1397	1678	1	1	2076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9ttDCcyM1qaRfL5eNg1sfAjGb64kSJR7vCKGrDmU9jQasyTJ
2319	payment	1397	1397	1678	1	1	2088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYTEywYtH58LbFWVhxALRWtbBDPRkrWZYTvYQ8Uo6CCi6TSTg
2320	payment	1397	1397	1678	1	1	2089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNp6cXibi2TdkXqcmGKDigxdg1EaiC2HxzXVAGjfsV412RAZUZ
2326	payment	1397	1397	1678	1	1	2094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUcYY6uVkr5iMh1ZtysEKueGK6z98NwzbZcYUfMacjMNQjuoc
2327	payment	1397	1397	1678	1	1	2095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfNiHcw3TC6qbA289L4h6ugEBgPyT1tYjjr7MASFNaMrkyW17
2328	payment	1397	1397	1678	1	1	2096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8anLz1EnV4PYWqoAAi3FCd9ZkkCwx4jTGucBmpd7H11K1Zze
2330	payment	1397	1397	1678	1	1	2098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKZn6nxhb6x15SKgkFg4Deng6J69JwU217Z6shpJYfom1Krrq
2331	payment	1397	1397	1678	1	1	2099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc69y3RS58BiPUngY6eN7kR6fv8LRf1L98bs2Dmt6jM66dy8jT
2335	payment	1397	1397	1678	1	1	2103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFmcfaE8witP3dxqE649azcQAA9mfYn3noJfV6kAXvSvNkpXm
2337	payment	1397	1397	1678	1	1	2105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghFLKvzoa1myFjW18yxmQABaSLc3ZakP6tkWZe94T72iRxXFa
2338	payment	1397	1397	1678	1	1	2106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXCD2Vfo42vRa9Cus4VpKqvWY8fFfpPgefUsa2zAtyDR7KYuh
2219	payment	1397	1397	1678	1	1	1992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8YSKjLseHfbzti3dDUPafaMg9Y3X7MYdXrUfH8pz2te6dKWr
2222	payment	1397	1397	1678	1	1	1995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuM8x9UhnXkkGEcsyK4Fqk2zQqGPRgn9Ai9qNiPPs6nMf77Uv
2226	payment	1397	1397	1678	1	1	1999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvijn7FcoP6P6g5ksSHPcQWSeSE1wNrNFgnqKaAgBVfanQQai
2227	payment	1397	1397	1678	1	1	2000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfotHcGDrvPZAUGp92PVp6dGepa8GULjgdzz1GWEzqBfFidG5H
2231	payment	1397	1397	1678	1	1	2004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhD4mqmnGXkDA3heVyZYsz1bRuVVHH1fGPK2vyLV4yp7u4U8Pj
2232	payment	1397	1397	1678	1	1	2005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrqiKiFjE3EA3hb5X2vXiAWN1KzrqW4MA7M2c3wjKHGq2Si6s
2235	payment	1397	1397	1678	1	1	2008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYiyztZRyQbCBQQZ2WAES9B7TtdMTUafwyiSoQdRbM5sinR5n
2236	payment	1397	1397	1678	1	1	2009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPzJm16hua2i28HBLKb1eau1bxczX9N5NBXjtftihHsXsAQDP
2237	payment	1397	1397	1678	1	1	2010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6zhhcxUdpXJnpLXZ3fnrueRJzkZxUk6p989N5ortxYShCxC3
2247	payment	1397	1397	1678	1	1	2020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AnCixcwXQ6ZDDxqM7gocPYpk8MC2axs2FgD3eY5LhuuKoUAr
2250	payment	1397	1397	1678	1	1	2023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZju5N6TLMaYH72v6Nt11YLW96hE2TKS4yGN42b6BWLAQDW2eYn
2253	payment	1397	1397	1678	1	1	2026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLyTt4kB7XZ79WK3LmqeF6rD4DueAHF4npUpMLCitVnMoH6Q1
2254	payment	1397	1397	1678	1	1	2027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo6jjrdFhw41Juct3GerkQ9tDCw5T3Uqar1xnGYiA27ASfbug
2270	payment	1397	1397	1678	1	1	2043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjhFV7FWNdtsx8vFig3Q16dG7mLkmUkfEB17pjRb2dizCoMK5
2272	payment	1397	1397	1678	1	1	2045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEgzHGCGgV7sR9vAHVQiaW7afC9CgSqfbQpDyhq6z6bJdnDN2
2275	payment	1397	1397	1678	1	1	2048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVokkFfJcF9ErpC6a9BZ4ktQB99Eq7dcViXVYv6hWGGoAvxwV
2281	payment	1397	1397	1678	1	1	2054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkQ2uVvbgc4gd1RagmwfamC3BYt8T3VmGv9Q1DQhHEwej8nP4
2286	payment	1397	1397	1678	1	1	2058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7tAWALg3Qrn1PMQftRAeKjfmoyGpBsyF6MHkmeEPyb9j5jom
2288	payment	1397	1397	1678	1	1	2060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjo2v9B1X4LMMjGJLBKeFe1abwzApAf2F2GH5rX9seYnpNY7W
2289	payment	1397	1397	1678	1	1	2061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnHiksz9mJzUd8drieHvUwuCcWyufXntTdBt8x5DD8ueWEx7N
2290	payment	1397	1397	1678	1	1	2062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQoqpCz14ztHk9iWPjr5x9NWTEtUMQEV2cGycQCZcFbGZagCK
2291	payment	1397	1397	1678	1	1	2063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK52kLj8DQYbBuXZSYFeYva9fDzuodKe2jcDyVbnmXPXpQnFt3
2292	payment	1397	1397	1678	1	1	2064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUiZ3vPKZb7pa1wM757SrPvBnwA1pKzX3TPf6ah7eVLyfhBTA
2293	payment	1397	1397	1678	1	1	2065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLzN28ETDeM48MTndFhxYcAngh8buj32V54mX5BnphpQzDUDB
2294	payment	1397	1397	1678	1	1	2066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kUxvZ2wMzF2NHJtF5jRtQwxmdU9vgf6A6rpqXaCkqohno8ut
2295	payment	1397	1397	1678	1	1	2067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1V7L3sVNcj3QjYAyDHQxu4SYhzUxHmut58kJvUZWtCoWbPb4w
2296	payment	1397	1397	1678	1	1	2068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDffm6Ueoz3TqCYrQk5sh1TUZ8LFrYbcBpfmxB33DaQ24c612
2298	payment	1397	1397	1678	1	1	2070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjrCNm5ENgX7SkjrYRKDwqBiYbQB2cqQEHiX4DcNicpSDeRHY
2299	payment	1397	1397	1678	1	1	2071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMKUatkyGKUfE81dqrgXResTU2DtfQfXWZD65y41Q8jaiZH6K
2301	payment	1397	1397	1678	1	1	2073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH86yq4xEx3YgYizkUJEtxw9fmNUCt22aVmFzt4dCfYdMh5VAs
2321	payment	1397	1397	1678	1	1	2090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ey9mqHxu1nP2j8Tzeqw4aY9i62dLgcHqVZdCchHfAByipd2D
2332	payment	1397	1397	1678	1	1	2100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PZmZgUrrYxorPeaM4pYuE2eWzivjEv3WMt7ghnXVEQxZp7FD
2333	payment	1397	1397	1678	1	1	2101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJfjb4iwnDchxy5eg3XPfAv9G5HTe4FULbCC8nPBWJCKCbhMD
2336	payment	1397	1397	1678	1	1	2104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuE4Xo78WjHh9FDpibe31QaeWAqqXNnv7GHmB6CoGow6kH6PPr
2341	payment	1397	1397	1678	1	1	2109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShqtEDvhLsmYuA5M9dYV7ukgQBJCyDUagYFqfah4RXMsjoHKj
2342	payment	1397	1397	1678	1	1	2110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxJj3GJKpjdmg1Z88752fy4rf6vHeftXjAMWDY28MsRRAMWRk
2233	payment	1397	1397	1678	1	1	2006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UTU74vJ5JXbmWdqRoGEMm61KuxJPWDYy5gjBPxoL7hAkAudP
2238	payment	1397	1397	1678	1	1	2011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLkA3zptNsGXQ9fmiMaa9WPKQksUweBiJ5z7R4DhYYhPb4qkp8
2240	payment	1397	1397	1678	1	1	2013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPyaUZcYUGxHm84jZfoPd4JpJoxN9V8eZg3HTDEsGazujhh4m
2241	payment	1397	1397	1678	1	1	2014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpGeDRFCRrhjnPBEbAxoCsQ56Y4XAhGGDzdhRTKgTKDxUQmuk
2243	payment	1397	1397	1678	1	1	2016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgyXq7mgKTAc9PXT8mdFdeSv4JWAyPbZz393gnBraqs1ZT1EB
2248	payment	1397	1397	1678	1	1	2021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4q5xDCNxSHoCgYx17H7N1EyN1tJ37nG1AshcgLDYMjhq8EMbq
2249	payment	1397	1397	1678	1	1	2022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2B9zJ5K2jDYh8VKEDX88V1cNPRfYw1bCn3rjqhf3EynXmujE
2251	payment	1397	1397	1678	1	1	2024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQP8sMnaCe3R5VrmwNP7cnpqeB1hkbxiRkBtQbb24brCT98Ja7
2252	payment	1397	1397	1678	1	1	2025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjaQSvji4QE1iQ57qmoH2TtJVEvCny659ddaWneZCJMzLb8mY
2258	payment	1397	1397	1678	1	1	2031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchmcKeRQptfTKssHBVgwVBfh9iorLYwkSb8GJbLDsSoBXo6pz
2260	payment	1397	1397	1678	1	1	2033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaFgcKMHnGx1dBhDoNDsjPY89jAVVWLYbqqyLHHf7c8zKaRWj
2261	payment	1397	1397	1678	1	1	2034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLDfv9eNGjiLrdjitzkN9JVN6Zrnhx2hUBj7gRhC2CUdoTx2q
2262	payment	1397	1397	1678	1	1	2035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyN9P7PVy5cWQJ4qqm7qPfvbQp9AW6AG8vPMy2o5uobvk4Ebd
2263	payment	1397	1397	1678	1	1	2036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9FDZBLYxjdbq5tkRD1GJ4rYLnj1gh3BfDbiVYVaBvh6CSM8i
2265	payment	1397	1397	1678	1	1	2038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQ3y3gFd4zUdvJEM7nQ1xJTXaDanYF8ykDKxzhE4iFjmTDbBe
2266	payment	1397	1397	1678	1	1	2039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pUCBRRCC8mY6owBWN1rW9mrKTSQPGQpLVVQXkEJDCn2BzxGz
2267	payment	1397	1397	1678	1	1	2040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNeFtpCPFPUGKWUPeWhyG8AD2WRerjj3AczRxq81yGjHcoqq9n
2268	payment	1397	1397	1678	1	1	2041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUv6Yw6pRpP4h51Vzh6oiXfUysPtsemhQnaQRp2NkyDBseLAzZ
2269	payment	1397	1397	1678	1	1	2042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UaF9heu6Gb5EihtwdamGDKAfYMJJrK23Dhu5StRwRSokR1jH
2273	payment	1397	1397	1678	1	1	2046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSN3jEXpLJReitLsuQuTpUpDCc6bh42Bi3bRB5eK7Ja2Spwus
2276	payment	1397	1397	1678	1	1	2049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JQmEBrrHkcbFw3H9nxHfVJ85mneAKzkCf6ctWkZoj3UKWQEB
2277	payment	1397	1397	1678	1	1	2050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbknVyDZRvbQFU2xSEmqN24acHgKuLF1QnrUvAyfzYBYdMB1F3
2280	payment	1397	1397	1678	1	1	2053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6Wg8nnvFuMMcZSFCTjhUvqAivxbsUymr4HLZkF63mK8Xwfna
2282	payment	1397	1397	1678	1	1	2055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtG8oSWDw8iKgbzqFtmrirA3BFF6eZEXsXq64PxkQLzN1VR42U
2284	payment	1397	1397	1678	1	1	2057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoG3JfWrJrqFZh8ZL6emx7SMnqjTowLZQwYpw56o6hJgyThT7W
2285	payment	1474	1474	528	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVFW9TJXAFJaEoWCLxULTwWiwiyFXLc3Pb5C4WDrmLS3Xt2kv
2302	payment	1397	1397	1678	1	1	2074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbzAbdCG52n54b3E56vGHdz1SnNA9quz7oZ39gtJea5y1D1L9
2305	payment	1397	1397	1678	1	1	2077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBzyi2a91pt9ERw4jkiG69Fvs4y53wNqJ7aU4yXEQfuSwYUCM7
2306	payment	1397	1397	1678	1	1	2078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YG8Pfa4vBZGmkDKDcctv9Mzvsx39oFNyyp71qoFdW4kDRqEc
2307	payment	1474	1474	1769	1	1	1	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAB7yCEiWiAbyWdbHP98c2fqm1X6Nttbm2DPtEPwJ2Er5bpBKL
2308	payment	1397	1397	1678	1	1	2079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVvzZibSuC2uM5ESxkaX83H4Cm5XdGNZd7siDPVxHTUiAxzbu
2309	payment	1474	1474	1769	1	1	2	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnk9ujN7A4jxvcckXboFK88R5RWYzr94gWn4YEwPEJ2M7VEBK
2310	payment	1769	1769	1474	1	1	0	1000000	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZ2hpoEspVMeSUCX4Sv8zuww4uY2HedR2nT6JJeL6pzrQDR7Cs2
2311	payment	1397	1397	1678	1	1	2080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpCeUtYsVAvq8g6HJMeaxP5HpBdXVk9F5NB2vH4TQU6tjc5vJ
2312	payment	1397	1397	1678	1	1	2081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZKrc1Y24tfoNeePpU3wBQynx1kZwerDKeqmWZZ4TNuxJaiJN
2313	payment	1397	1397	1678	1	1	2082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1JdD7tcPhzm5CmYAPMzdYSEVUVzpZQEi3sBj7vcbkGbXsCJ1
2314	payment	1397	1397	1678	1	1	2083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHFa9Ky8kJLEmWW9rMFE4F2eJJfX4thN18tr8Njq4spzKqfVF
2315	payment	1397	1397	1678	1	1	2084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6XqwiNj2kPJBgFEHrDtim3F2qBfj4SD18kfb83h723nZvD4SF
2316	payment	1397	1397	1678	1	1	2085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAmFFfCZco6CPAgXLWHK9kAxqgdyd8qgnup6tymP4SuE8EWf4
2317	payment	1397	1397	1678	1	1	2086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksoLNt4A5PjedRt9Jufy5HetwBapaA3KHELxKDpkjE1Z5FKh1
2318	payment	1397	1397	1678	1	1	2087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJDSjFEwdxyCdHZaK7Sp41P2HKGxhFH5ModvjJoshQHhfx8kn
2322	payment	1397	1397	1678	1	1	2091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1idZ4LAFg68MPNimjQs8FVjDAKkzz2cTaxAiTbFB134bpgezY
2323	payment	1397	1397	1678	1	1	2092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGmpic98fkZYdy6Cpv6G9iDU2h1efrsJ2SUj3KBQN36HyoRhEz
2324	payment	1397	1397	1678	1	1	2093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwi6Be9jmh9LqhA4G5e2GHnho82HqXN2yBk2NBi9XJLtYnz6s
2325	delegation	1769	1769	44	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcRW2SsJs7RJjVVeuxqWUEWHyKrgGGYE5QiduP8naWhEgdjKh
2329	payment	1397	1397	1678	1	1	2097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWP6b5y73qrvs7wghsccvNCgJfbSmHg3cccPp8jC4Pg4uMyNPr
2334	payment	1397	1397	1678	1	1	2102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ512DeSVajeyK3VaiKfRbjYqVdEcwkfUtJ2KBKgnBvwnkq32qS
2339	payment	1397	1397	1678	1	1	2107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfw8Q2qmtJkZ3smgDYMcZNAoLjETCQqVBxfxa45U7AgSUhizGc
2340	payment	1397	1397	1678	1	1	2108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmBsVqjDPLtqPB4tFVH1qXXKVWqADaHQgdVNJiN3WKg4Q7Eq2
2343	payment	1397	1397	1678	1	1	2111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgZqTQRiXjYVGGTqVtf9e548RMnnZe6HbQsGzn6Xj831pD3yn
2344	payment	1397	1397	1678	1	1	2112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSEPzYZPPiyYCa46KefnHKjrvKRtoVq8VZEvL6bCMSqcXrBC5
2345	payment	1769	1769	1474	1	1	2	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktpbG1Nn7jFbnWnx5vgj27QwJMrDBER8g7MMHTVy8sZjYzC85
2346	payment	1397	1397	1678	1	1	2113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoNMWM2bHSPJ7jKwqznjkBT8R1hJD1npyDmBSoZDWhNXT4myQ
2347	payment	1397	1397	1678	1	1	2114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fG8pGFC4DYV5uuiTeAr7jJxmzTjs15QmjEzmf76HV57MLntx
2348	payment	1397	1397	1678	1	1	2115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAri3UQKtyjGCHm34xV7Fx41dEbQwAWJiFWzRyKQ2XdcWswSK
2349	payment	1397	1397	1678	1	1	2116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cjeW8SL54rHCr3H9cDeN2wMREdYeUMNcqLeGzu7SwVSkqwX7
2350	payment	1397	1397	1678	1	1	2117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsp4Fb9TG6MdsVFQtyfuSNJCN5H9d6ddg8ZPR7ECPPT6yQiTjN
2351	payment	1397	1397	1678	1	1	2118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7krh7yHYvxfRXzgJpUw2UxzvMtss9uXkESYtjgc62gHM1KLP
2352	payment	1397	1397	1678	1	1	2119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9vodhnBiJAnKkLmWnvV3FE9tvSb9HAjDLQQXu1MKgkNhXWCA
2353	payment	1397	1397	1678	1	1	2120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAyNgNC6K68NKe5ZYw9rfpUEu8bQPjvTNPBFP8N7xyJokLSkK
2354	payment	1397	1397	1678	1	1	2121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxMop8i9RNnoXbus84y2td2ygpHPzcpQcJZKJ3JefdkSXVDzM
2355	payment	1397	1397	1678	1	1	2122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zL6vt7HpAP3Ktm6uMt13DnsZVDE6ukWj3NWCwpkAKJoV6wZt
2356	payment	1397	1397	1678	1	1	2123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNKw4ntaSBnEJ4QGXSFbgVSZhdMLP86u1z4QNXkUpYbxyfrAV
2357	payment	1397	1397	1678	1	1	2124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvYGr1c62yeBTTbTKSdn2Gs5KrWH7k7RNjhB9c48rAoDe7EZG
2358	payment	1397	1397	1678	1	1	2125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhzcNRUVPCsDWzFJBvbv5qiaept8NHkKxHPJvBJrmv3L3ZCaE
2359	payment	1397	1397	1678	1	1	2126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYwWNdWNF3yptBmV7rXHUZCQBWJLwwzf9CR27GFhmzSxCBPpY
2360	payment	1397	1397	1678	1	1	2127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPPiuRoaGdBYqBaobdD85UHjxmg6dAUSRvMisH13WwopHP4cf
2361	payment	1397	1397	1678	1	1	2128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxWH8YBTop7vzTGZqPttSyUdoTTbNDtCvorx7uwjmUYiQnmoh
2362	payment	1397	1397	1678	1	1	2129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZrCagXp4dA94dyNspLU17C1Qy6GYejFiXXcAdopaDKFaSBVJ
2363	payment	1397	1397	1678	1	1	2130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWSb7ZvE9D3goYvSade8ieTYqPmRo39g8aKxyPycrDxos1o8x
2364	payment	1397	1397	1678	1	1	2131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cYKjHzMbJXRpiYSxWkDGZPPvKGJxuRyiwMbwBDL2acqaYcL6
2365	payment	1397	1397	1678	1	1	2132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NQPA6kDmtoppRC8twizu6op5ysTziZVSeWoX3DDWeLDVYayt
2366	payment	1397	1397	1678	1	1	2133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFqQZ4fuqbK1KKoTJqiqm4jFUVk3BovKDS2EoXXM5Ac92H1SH
2367	payment	1397	1397	1678	1	1	2134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aaCGB6cdKYwLnCebVXpBk3Ee56TABMzQFN9refYKvu2YioZb
2368	payment	1397	1397	1678	1	1	2135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32abaB6MsZuGfQCbfRaVhLT6H97FGDtfTTNjvqw7b6anYKndf
2369	payment	1397	1397	1678	1	1	2136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNr8hrPhujy1bmkHFfdzeSx9nUyhM96hXBCUTBPNojpqkjBg2
2370	payment	1397	1397	1678	1	1	2137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhUJY34YYdEjaSbazLCo5GdwsyXc9GdAi91s4MzCzBAZGHWLr
2371	payment	1397	1397	1678	1	1	2138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFburKHUvGxyUCZELx1szQKAQFpzXReZwFhaBRv3QYEigUKqG8
2372	payment	1397	1397	1678	1	1	2139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHTm4rqNecmW1n93tvF93wC5WhMP5rn85zYsVujSS715jwojm
2373	payment	1397	1397	1678	1	1	2140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEt6MFDsjCSHeDssyDyuL9yqmWmiXhNCjCYcwXGLNTHvfoyPR
2374	payment	1397	1397	1678	1	1	2141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQ7EDgpN3wWzXLPib29wT3ocqRQZLcGRHdSmXEkNnCq6Hpxfp
2375	payment	1397	1397	1678	1	1	2142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHnEZsGLXtHsrjc1BiH8sN6gXc4RHHB9tSCDmLBbkhJxQkFrV
2376	payment	1397	1397	1678	1	1	2143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7f5on7a7MVWDtiivfwY7WV9jJodsmcSHS3Uq4S3SoinTyXkzn
2377	payment	1397	1397	1678	1	1	2144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjFXeZvrPviuYbYmhAWd7DW9ibEBMYQibjE6qPMFix7NoCK9v
2378	payment	1397	1397	1678	1	1	2145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgibLBNYcxMMPentiR58qqjpCaFNq9H2zo2iGw3omJz5p6FsW7
2379	payment	1397	1397	1678	1	1	2146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uVxvhg6JB5E8oJCAYuEyCwbBMGy4mpHZApsYepAujhCbLKMJ
2380	payment	1397	1397	1678	1	1	2147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDLSB7DGfHgUJE1GjZrGMnTPJ9DnVha5t6kG1p1qFHyQaM2va
2381	payment	1397	1397	1678	1	1	2148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bT9ZCdP2rELeLZRb5Je1sGPEY49K3RPkkW9zkrRsmZxD32xo
2385	payment	1397	1397	1678	1	1	2152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvx8bSjfZsCuTGePkvNZ2FJcm5b4pbgkmLumndmdpyjtBgLnnf
2389	payment	1397	1397	1678	1	1	2156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tR11bXxbXhHnEzCR3iXuFZixV1m7o54MA6Lt1y9MdPjTzKvx
2390	payment	1397	1397	1678	1	1	2157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8CNnjw6uwNnNiP1Hy8Eo6WDf4BmMbEfNh7RxuVSXTBri3rm2
2391	payment	1397	1397	1678	1	1	2158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTUPAVjcLASbNCqqP9UMRAAzjuXRXciL3wxKsWRghDhYpdjBt
2393	payment	1397	1397	1678	1	1	2160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXMumA76K5paEHZysaoMMWq6yikjC9mvXcYsoWHCTSvT6bMHA
2395	payment	1397	1397	1678	1	1	2162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKi2oTvGbzyWpuayzbcdwCHHMw7uux47J54PFjyUuWj1KoVVv
2398	payment	1397	1397	1678	1	1	2165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjUmCMfXcW5aaUmEphaHRjsyqFSgGYK1Ytqjgrb8Qt2NNcKvB
2404	payment	1397	1397	1678	1	1	2171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfhF1tY5xgTvkdbjpzaU4CVXwhEafQ7TaCvUVkZE2fvunVBZL
2405	payment	1397	1397	1678	1	1	2172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJns1L7h9NcfcPQCvjPd79trpHfCYoyUukrZM7cunhNxjsJCi
2406	payment	1397	1397	1678	1	1	2173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4UFUJQgBctjg4nYWoMMPTzKuMnxg4PQxq8kpU2mtSRFHaQjJ
2407	payment	1397	1397	1678	1	1	2174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtXJwFg9j6zXe1XAJR13u7CjsbS8tB56HkVfPoatPWDkeaLss
2415	payment	1397	1397	1678	1	1	2182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tSrVGQY2qBd1FG5ccUupK4AWnBKXGMxUejo2Zi6KjDV99Bvt
2416	payment	1397	1397	1678	1	1	2183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXjpv1KEhU17JbJgcvGB1nN59AQ7mAnZ4vEj1NQxF8QZvWux4
2417	payment	1397	1397	1678	1	1	2184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQ9DC5QLwjPYsyaeiJffKk3Br6AV18QGpWEMvUCPmdJ5ztVbn
2423	payment	1397	1397	1678	1	1	2190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiENGUpjktzdasdpjPKjfCdWkWF5YneGMgFkzLCwAKKETdarLq
2424	payment	1397	1397	1678	1	1	2191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDeYWbKeCzT7ASWi6p9LZbSvvCmSgyBJcayHcorF1JydTW3CA
2428	payment	1397	1397	1678	1	1	2195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpw2v1AFXZjhTCb4LNZLaqTwNgsToxj59mUZ2z2kjsVgPBWmw
2435	payment	1397	1397	1678	1	1	2202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCvU1oq1fLRcyATHQaBKWt8mhqX9wQgtbg6gajKhFk351SG6t
2438	payment	1706	1706	1737	1	1	3	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxdzRu3qyT2VcfDiV48Gas8XtWCg5uru26yxG1tL3VP6AxZH7
2444	payment	1397	1397	1678	1	1	2210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjisQan5iKuYxmk4eTP3PP6Sj1vHvKxa9e34Aenq7km3S7L82P
2448	payment	1397	1397	1678	1	1	2214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUtV9XVzud7n2GxNE581Q72DJKEav9k8GieWzkcN75df8UXyA
2451	payment	1397	1397	1678	1	1	2217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqme6dFy889wUZTxfTQ1JHgidqFU519KpPjiix4rufkdxaf4P
2454	payment	1397	1397	1678	1	1	2220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbAVR3E6Ka2NNH9Ljqy7pb3CqWwegPoma87eUMXZWVfHVnr6t7
2455	payment	1397	1397	1678	1	1	2221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrMs3vpzptG1UjNBAnRviYq8o3hD5pzw9x7S73aquXDEmNZp4
2457	payment	1397	1397	1678	1	1	2223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtPr443GBThkdTQ81qF4ooDqE3xdojVPZu9NifLeKUzxTDmnb
2463	payment	1397	1397	1678	1	1	2229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbiUn4KfZfWxw6uy2nHbZqdC2tNTJPYL2bv1AnbToHkZvhp9a
2464	payment	1397	1397	1678	1	1	2230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpK3H6SbzqwUrNDxW3TwnGxi8HDs77HziCqdXe48a37Z7uwNZh
2466	payment	1397	1397	1678	1	1	2232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvPLMSSAyhuNyCj1ofVgJgF9qYuWgeDQMrRb79V9u3uywnsoMT
2467	payment	1397	1397	1678	1	1	2233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2ekMr546rjHwjEywDVQEXE5jBNEm9KCGLt8dNqhhgxLyXiAm
2468	payment	1397	1397	1678	1	1	2234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1An3gaUs6ohtHuymBQCfEzKsjNAsxTcw4AddaFqJkGk5JHZSw
2472	payment	1397	1397	1678	1	1	2238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsZDU5qCRHSiDkZUY6CEq1kuWj3XtDGFd8iEwRFdQ6pPn25pe
2478	payment	1397	1397	1678	1	1	2243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn78bsvRZeNtYwCeXUMNCbN1rSoyJMnvfnK71hKe15TbVzbD3G
2480	payment	1397	1397	1678	1	1	2245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3H4GfHdnVqkKMbkrotnPoLWXD23Z89LgUBSTHBjaE4Hmiagq
2481	payment	1397	1397	1678	1	1	2246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEWaUjcCCKVQZ6je2Ad7Xjv26X9eStb32UXYWrSPLh8otibX2
2484	payment	1397	1397	1678	1	1	2249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuX32Lo4TcgHaJgPwaF3Li4etgx7aL3X2pEgQYdYBP9CKtDFD
2486	payment	1397	1397	1678	1	1	2251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yp7Vm17rcm1Xo1MmeoejMfYffui6QjZkzvibvegQ3Q46wkuh
2382	payment	1397	1397	1678	1	1	2149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFZreHNb3JZaT8KG5jkhHdVscYu8QYHTUAJxHPtHJDgyifLuj
2383	payment	1397	1397	1678	1	1	2150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfihjkvHSMWUHQfJUUecs1Q1HanXGa7Znu6ivUk2nhEJ14PpA
2384	payment	1397	1397	1678	1	1	2151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPoFWC23EUWdpN4i6cYMyFym5M1oFysCaNPLDguKcVFLvUUtp
2386	payment	1397	1397	1678	1	1	2153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonZ5tWsuoPxoeX9KZHUifCpwEjp8PQLiEWzGSb7f3mo85W51V
2387	payment	1397	1397	1678	1	1	2154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKXSfX1BRjvek3atriuUdFVqjovpr8QCpoFxZEFggQw7zC25b
2388	payment	1397	1397	1678	1	1	2155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPDPNBcEsY1D5dkY7TEvgLNXbm17okiKddHPHZewmiULPCNYQ
2392	payment	1397	1397	1678	1	1	2159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpEXctMxPFKz663QqMu6uhrVpWgcDbmbbsTpQP1TRt1VV46DL
2394	payment	1397	1397	1678	1	1	2161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41EVTa6uM2kLbxRhshqSk9aMAqkMUamqvRd6H3FChybSY5A4o
2396	payment	1397	1397	1678	1	1	2163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXMW4jhrSG39JcRkEGompeVKS76NJV1m8uUnYwRC8LuxXNtu9
2397	payment	1397	1397	1678	1	1	2164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbYjTxT1SusSMUEszDpNTH4DQWJKFgo6NuWK4VPFVahaDtrMQ
2399	payment	1397	1397	1678	1	1	2166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG47QVCHzm8LhJdpNQAVRxNcNuqwfiBiWowE9mHw9rwQ7jZjiC
2400	payment	1397	1397	1678	1	1	2167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbFweUKgPQ5zP3MCwdk2JU8DePzXBCRT2usj3fyoY5TXV19jC
2401	payment	1397	1397	1678	1	1	2168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGb1uKqNyGhrgVepwMF7TkpxrK2stnYZNy62KpWGCbNLMsSGw
2402	payment	1397	1397	1678	1	1	2169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp58Uc9SgjoSQexBc4hxRAX4BQyTekDTqY6bRPKASjekTMKfs3
2403	payment	1397	1397	1678	1	1	2170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zUStXcC6pyyoLYriSUxC2Yw9q7m8MLVqJrU9EjpAQfivZXj8
2408	payment	1397	1397	1678	1	1	2175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFiRvUyYuuiNcqz8xkCpih7QcYkQJrqQkZxhKF5dhhcBsUNou
2410	payment	1397	1397	1678	1	1	2177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHbBfFuGcipqa1h1rnPD31zvtedueRYy6xrjMAaz1mJoXz7vk
2412	payment	1397	1397	1678	1	1	2179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCe5HUj3P2WMXXJBqhJADsPvYadiMiLqx7Sk2HRkdm2YwFVpjj
2413	payment	1397	1397	1678	1	1	2180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnN5DodXp5qTQiMibfdmpw7AhuX7DaUzRt6ccZbbtgjrWo5GST
2418	payment	1397	1397	1678	1	1	2185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGgWAvYekhvc7eD1Q23G9Q5yx7BRCnBzWG4e5xC5bgrevJQ5c
2422	payment	1397	1397	1678	1	1	2189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTNh63g1So2CpK933cvBCmK2ts9mpucWCpnLRY4fjBRuZnC9o
2425	payment	1397	1397	1678	1	1	2192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAT4pFA9oEPutkvxuScgWecQA23CWzU6RrDbjviXaBEySS84mE
2429	payment	1397	1397	1678	1	1	2196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQndoqHgnPhTAH1RY7qjSaVSfjepMLpW1DJrLwMnm2GcnbVcP
2434	payment	1397	1397	1678	1	1	2201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGGX62xWkyAkpuieuRS8y6ydHstWgjpxQYQ8LUT7wG4Ka6K6T
2436	payment	1397	1397	1678	1	1	2203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjKzrx5eusZm9BDdd3LebsBK9cYbQJx2WtF961SkjtDVmyAXH
2437	payment	1397	1397	1678	1	1	2204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8QXdw2Ah65w1Sm7FimZmxTY7xV31BqVfdwNyH5PCAipTjdxd
2439	payment	1397	1397	1678	1	1	2205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAREsApShM3AbYetaYfrUQWKx8hn83nSnw7qTCeWzZtuFWhC8
2440	payment	1397	1397	1678	1	1	2206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohB6h33RvjdbD8GfG47KhdgZZwe1FDXXtCMrYfeNW8Bj1c3hT
2442	payment	1397	1397	1678	1	1	2208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPn2JfAH1Zq5spiEFtFGy8L8QzJG71u7LQnL8MXoiyp7YYs4oq
2443	payment	1397	1397	1678	1	1	2209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWEn2TH6A3Yzh56ZijbQ1iGp72ksPHgvQdw7M1s329Q6tTdiY
2446	payment	1397	1397	1678	1	1	2212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVh9tkL6iiFDRiNnBRW1BpdzF2bA2jWytcMPy9Bjfb9VJ8dpr
2449	payment	1397	1397	1678	1	1	2215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx46MhtGFfw35PvpXPtqmAamd3L7ia7jUBnfqAGHUYrmuZrTfc
2452	payment	1397	1397	1678	1	1	2218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxpHjxu4isKwNQ4BfEzvQ4siLFShRX8Z5hDjZsLQKA2QDTgcB
2453	payment	1397	1397	1678	1	1	2219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F4CzMFKaTdNDjq1zEC933ofDJ9JHEDwZraVh78eTb1FJB3Pt
2456	payment	1397	1397	1678	1	1	2222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdjcr3mu8kvgQ6gnUXis21iNsjAREx8S9xuWCW6UszZr7mr5z
2458	payment	1397	1397	1678	1	1	2224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahdSx56Ky115tfGAJeX7Bvg8fAtHrx9E5bXZD8DrFcvMPC7Wt
2459	payment	1397	1397	1678	1	1	2225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvXnzD6rL8g5iyg6yNmxsdVZV8vAsaVeQGdBZ57fC9NZcFH4T
2462	payment	1397	1397	1678	1	1	2228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScsC7kis19hK6xy2wZaLXEGwjRgPxKfsUuMueqKRHVLZfd589
2409	payment	1397	1397	1678	1	1	2176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvdUszkZ6drVHvMy4FtHNFQrdFsSV7SPvqvQPr1mPktWr5M4U
2411	payment	1397	1397	1678	1	1	2178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaWxrbH4F5gCB4z77uScWTjnH3CE7XGv2g7qFNxocgyxbY6HS
2414	payment	1397	1397	1678	1	1	2181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVZmHFQYmSzn2hhnSJ47LTh33Ke8cj6UfVbpDh4ULwn2B3vKd
2419	payment	1397	1397	1678	1	1	2186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCCiDm12sY9yMoefB2GJRENCavttJ4yAk7t5oMEBr1HWZR1Mv
2420	payment	1397	1397	1678	1	1	2187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMUavoEW6uswwwZu6FAs3RsARnsSJKya4TP9uaYVeGB1GMW13Q
2421	payment	1397	1397	1678	1	1	2188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwj3Kz49UFtsCgUZPCQNGcuT61gnnjDvegyFAuTUHEFTs94bY
2426	payment	1397	1397	1678	1	1	2193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYLpKMH7KipuETDB9m9A26BBvrjRCgcUbjF6fXB2PbGYwtKXx
2427	payment	1397	1397	1678	1	1	2194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYWxzKzxgkZoX728i7cwfVomkVpE9PjQVoNZk68Tr2JeoR4KPQ
2430	payment	1397	1397	1678	1	1	2197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79BFJ3p6W3hi6CD7gno9qGvUELt26P48cGmTwU3DThGzBcUXj
2431	payment	1397	1397	1678	1	1	2198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3MeaChc939Yo2oNGGb73tkQjMm6ZVB3pmDAAwxEMsKZ2TAEH
2432	payment	1397	1397	1678	1	1	2199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUNbPFdRCvkePu8gUSwJkT4ZyEBRZfaQSQEWh6TPevNgvAqwh
2433	payment	1397	1397	1678	1	1	2200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8KoV45HjVsT4QFA7YPBkeRgqpvqGm7u5JBNnjN1Q8UUgmhKR
2441	payment	1397	1397	1678	1	1	2207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcgi4ddWvYxxntixmr6iaQvND9CXWY18ea2XgSZvD8WzpjdaS
2445	payment	1397	1397	1678	1	1	2211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLXpWWafZUzkGAHuWRi4ui1Wgs24nPUyWHhFheewFC4oSp7YJ
2447	payment	1397	1397	1678	1	1	2213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRdZJ957sG6d55zweq2iUksbhi22BiPsT3pmdS1ZFRXmN9gwj3
2450	payment	1397	1397	1678	1	1	2216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAWpXLcjyAjtG55KLFPztK4NSWHqxfJg9WBXyiWNcbRzpisdu
2460	payment	1397	1397	1678	1	1	2226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsSUVKgPD7iFegYo52JQRnjNTc9Luf1GzVF4a4AC5wKoNmfRv
2461	payment	1397	1397	1678	1	1	2227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcDJ1V22vxa1DVP63eTL1cGa3bNR6N72677k2JwCL7r1s3nzL
2465	payment	1397	1397	1678	1	1	2231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7gfdHwUnMJp74YSGmsJK6me9MKDhkebF14ssbassNWfchohu
2470	payment	1397	1397	1678	1	1	2236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcS3Jjc9bCZDLW4pD7XbnsnRPxxUw6pHSL5BVs765w1kKUe4pb
2471	payment	1397	1397	1678	1	1	2237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBseeYqxf4PCXZBEg3sLGNYSxTXRfcPaxHp3pc7CLpaggPpNr5
2473	payment	1686	1686	1770	1	1	1	4106104499987	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr49iE8H2qf6fK1qKXopSAGZP8UA7igcBKugrqkFo8revryaKk
2474	payment	1397	1397	1678	1	1	2239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBKfxHkke5u18HfKJbKR2kxxHvUbRiEDDMDdtVwLJ31EScfBs
2475	payment	1397	1397	1678	1	1	2240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALJidrdd1e3MxXW2RP8TpvzyAQu8hbxDwpo6gbirN5ZYJKR6c
2477	payment	1397	1397	1678	1	1	2242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28anL36p2okyWAqJry225UQdY62LfxM29AbrmfY6tsv1sNikg
2479	payment	1397	1397	1678	1	1	2244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMvWg8iQzg7MfMJa6VvRS4r6y6rm14EbdhCYM2sRgWCdSmsrr
2482	payment	1397	1397	1678	1	1	2247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSn3d9SpP37aoFs3HQbx4qFHvTQ5D6avV2zTw5nULjuhnipTfb
2483	payment	1397	1397	1678	1	1	2248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmvtKXbEhF8gNo9Guzw8t6pPYABndV21t8RTQmAc3z79oyGTZ
2493	payment	1397	1397	1678	1	1	2258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH8KnC6ReQWiG6vb4BRxBBHCnnwxG4QqRYxzGeUTi1Zdiu6dS
2494	payment	1397	1397	1678	1	1	2259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuxEvXChx5y2faKDqubko1K34SKbMRgXiErmJccrDsayvSXRX
2495	payment	1397	1397	1678	1	1	2260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJsyj4of42pFLXZBph86SC17148WFLvejRNJmG9eHFhNLa8XS
2496	payment	1397	1397	1678	1	1	2261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUbm5uBie7hC5PEqdvJERVHXdSogEEbc6qZSt1ttJa4guug9V
2497	payment	1397	1397	1678	1	1	2262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYauRrubqgzMfsWkXzP2GZCxE8ekb1YEQd7sv44K9AzbVmFWdWm
2498	payment	1397	1397	1678	1	1	2263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZH2iTUPknkeLnuuYNxfKTsp4mBwN7YGaq4rUci1MqJevP9DQ
2499	payment	1397	1397	1678	1	1	2264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWLBs14E9sJsJkE16bx2DKivrZSdSVCha3NkTD7ZSKjJhDB3T
2500	payment	1397	1397	1678	1	1	2265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnY88jmd7iovGvH3dijk9uPSjghcMNaPRsRnRH4ms5NGqyTp4i
2501	payment	1770	1770	1771	1	1	0	70383739594	10000000	\N	E4YpWTjbjkMvauQBbyKqu4kUFKQ1oEu57veo7MvAjocUsQvL3eyRn	Ckpa5mMihxXDLVVKo8K5scPYdd2E6XcsxVazytGa2zarq1DJzdVty
2502	payment	1397	1397	1678	1	1	2266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniFNNUiBEm2xX5X7tSN1sEZ5NQo9pGikrBkx48Ugwte4vmFXc
2469	payment	1397	1397	1678	1	1	2235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWBTS1ptHNszoxJ8LJ3Q4S2VYMD2SDxguvqEAULi24d3dD5KM
2476	payment	1397	1397	1678	1	1	2241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLYtw7dWsmjqTYfAcZVU2ZxzHTVRhp2iFgPC63G1cHgcmrfwn
2485	payment	1397	1397	1678	1	1	2250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUt3aNyx1cpgiaJNmGVRJExMU7HtUYxee8NMwZJf79LuuKL8c
2487	payment	1397	1397	1678	1	1	2252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZntYM2wMk9yr6DhCZ4467grZZWpAgn5ppL5QJaS7gbhgbSRab
2489	payment	1397	1397	1678	1	1	2254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokK3FyQTH8V8zJaKS9KcRqYKxJ5NjYux5H6UAp31FXSreB816
2490	payment	1397	1397	1678	1	1	2255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1x77fcXqdZBMYTN3DSFNpfBAge8ZWEi4oEfyTBHhXC1FvSjR8
2492	payment	1397	1397	1678	1	1	2257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAMvdswKxAkYS7HD7inZwK5EWtYbFsweKtdgjeyhRV69Kw3TY
2505	payment	1397	1397	1678	1	1	2268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u1tfPw2H26CqHjh6zwP9dDZCo5BhLRpustSQBiUpGHuT89VT
2510	payment	1397	1397	1678	1	1	2273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSdK8jcKf2k2nTMZmEyoYWPwPLzrQZJJNSFPUC5mfWAyEJg3k
2511	payment	1397	1397	1678	1	1	2274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvq1muUyEXGCmcre3rSkLmiARaBpoPXTUkkKhhqGNa9taHWHuX
2515	payment	1397	1397	1678	1	1	2278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDCbBjds3EdkcDjWaGkGYB25Dk1jtyLjRALAyuqmF7o3J4xvY
2516	payment	1397	1397	1678	1	1	2279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TVYMbujztin4FKBft5AaYd2Rbfoby1riTncwBX9zus6dHZ65
2517	payment	1397	1397	1678	1	1	2280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9PUexv3KFcQ7CRVDTYBBij5khezjpnG29YFtZWHX1dDpAvXzt
2525	payment	1397	1397	1678	1	1	2288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiBKXnHBCHyiVfQije7UywWGsVDcSVSdovxrTdHwEoSQs5CKB
2538	payment	1397	1397	1678	1	1	2291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmy4XtprKXEMFLR9QmRsymVht33S5LJaK2ueT1CU2DCAniQ7sW
2539	payment	1397	1397	1678	1	1	2292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWh935QhmL9p7bdSaG6oypX8VqKGhLhJ1E1L3CxpNs4Wqj99GH
2540	payment	1397	1397	1678	1	1	2293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu41LmExsfYuw235PbjGWJ9u5z5Ad9K5Dk6Xg4YKWrUBrT9XEF
2545	payment	1397	1397	1678	1	1	2297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ72baXJ7WhGHkHgugNd1f4sUGgoTuQYpXG7CycFsrvDFQqfxoA
2546	payment	1397	1397	1678	1	1	2298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gNrHX5Jcxu79WXGTt3Tcu4GgpGo6hMLT3sexMsGcNaN8V1SN
2547	payment	1397	1397	1678	1	1	2299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLGPBG9Ey5WcBeFXD7e4cQGKcJhYWo3BQABAwKokCfS898jGG
2548	payment	1397	1397	1678	1	1	2300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySnPwQgKzhcAHsSFthK3tX2uooUKVxDRoDLxoudgLj4JGv8r6
2549	payment	1397	1397	1678	1	1	2301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoz6KfBWBvESthgbQcVukQfqEpsScPHZP7KPR3Ezdd17gSXp2b
2550	payment	1397	1397	1678	1	1	2302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pxL2Pm37He9XWTBREWW6hbB76xQsaxY95Atigtc38k3AaQaS
2551	payment	1397	1397	1678	1	1	2303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKm2B4qcwusgakTmFn2r9cj1CsSamRWo6RWZrT5odV8d7nQbqL
2554	payment	1397	1397	1678	1	1	2306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp311UXnMajGQ648hj5B6y5vHmipCzTMNhn671tUci9LjfN7DN
2560	payment	1397	1397	1678	1	1	2312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg32GSi2ji4mBKzMHAjcbosSyiuSE6JYfsow3LYVRSWPPM3L1X
2561	payment	1397	1397	1678	1	1	2313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJbLEiouUAM94qKphwT7hGqcN8HPt7esPH6cPLnG6P8xoVpPK
2568	payment	1397	1397	1678	1	1	2320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJAZYd2isVxWfMtKy9bbLYZFXjsJdSMK8pinknAaVTphUTkUqE
2574	payment	1397	1397	1678	1	1	2326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVohuqU4nkkpv1ZtSRu87d27fMbb1YQgGtJazVCChiwzZM7UnU
2577	payment	1397	1397	1678	1	1	2329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTuXUUMKseH56vQcPSuuVCn29LzMYCMVC1SqRig8nmqN7LMoX
2585	payment	1397	1397	1678	1	1	2337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGL5maaWyG6rUiiSwDTVSCNZLmji27PaY8uCt9guZXhFcyxpt
2587	payment	1397	1397	1678	1	1	2339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLh4Q6juFw3Tkn1VzV22mAWhhna7A3Ra7CiQT8vk5r8uAEWNih
2588	payment	1397	1397	1678	1	1	2340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC52RgfxUUfU9GJLtTHFb6tGU345soeu9Extn1DE4vqjBP33zJ
2589	payment	1397	1397	1678	1	1	2341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRSUYUHBzkpnCQyG98pAK66YG7Vouo8uU6UdBp1GVbiwyyUGqY
2590	payment	1397	1397	1678	1	1	2342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGW5DUdA5BtcVkS1peXjkmNn9Rzw6CxZXusix6ZDHUvSZCj1M
2594	payment	1397	1397	1678	1	1	2346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqHLPjQ5DUVvhhGqxcopLiWCZBXzHLmv1LuyVvm9Gs37iPR4v
2601	payment	1397	1397	1678	1	1	2353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaYisc9RiVcN68t3e8X9ENJ7xPbvX5aYjijJmV2GYB1Gf5Utm
2612	payment	1397	1397	1678	1	1	2364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiYy39bfGgM5NfqKPCahBPE9NBN61EKeijGiXaiwF1bkcfutE
2488	payment	1397	1397	1678	1	1	2253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5wfexGfoxExHFgaLZrALqKvgegQjsLrsM7qBJY3QbXbUeyfJ
2491	payment	1397	1397	1678	1	1	2256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmgsNvwo9QSQwQJnX8utsfBGZJXYd5yj1nujPkPLtgpF9DXzK
2506	payment	1397	1397	1678	1	1	2269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86WSqKETNZYd5iCSPptxFqUV8P4k7d2CmhYY7XHC54YQmj19B
2508	payment	1397	1397	1678	1	1	2271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyZ13YLVZmrCrJSWgntPhKS9unDn9sf78LKSPCDuxNcHiBGkp
2509	payment	1397	1397	1678	1	1	2272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK19gJjjCCmHHiDR9NdnqkYDp6BAoLSkvZ49xHPNg3dati9qWt
2519	payment	1397	1397	1678	1	1	2282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGiQErfwhRMnPLEF9jgbKswjBrqxHaRefzN6mgjHZx3ZQdJCU5
2520	payment	1397	1397	1678	1	1	2283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYpimXPKU6pRZYwvSA8WQjkus3efcdHFaXpsTxDkTMfTikHqY
2521	payment	1397	1397	1678	1	1	2284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4rNWj3k7HEehA51tMwSrrsMwQxtmLrNikFK1YxAm4xwbtJU7
2524	payment	1397	1397	1678	1	1	2287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnNWvgF3VsKYoLKYmheduEecp5vgPX7kf2bQVQ2BTdrcEkWKe
2552	payment	1397	1397	1678	1	1	2304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESDVQSYvoCLANuNF78uYumGBmVff43NZeP1GpRf9D2So1zyiH
2553	payment	1397	1397	1678	1	1	2305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ab7VA69sSgCDSZRvMKWJAK7PzYVpguTW9xJC4yZR6553xUMm
2555	payment	1397	1397	1678	1	1	2307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmyhyk8WSrVrygLcMdMFNArQ12WQEdPxJKqRoXF7HDhYEteXuR
2556	payment	1397	1397	1678	1	1	2308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaUj1CJxheZTdjChtj2KJDDgELg3N4qbXwNRzD9gVg9Ckv1oj
2557	payment	1397	1397	1678	1	1	2309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPE6ihdz7zaDSUofFY17cqq8QRynrsi6R11iv3DYvSMUYJxoB
2558	payment	1397	1397	1678	1	1	2310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvtKyH26exsLvM4wSiWZaC6VC6pyzMB9bnhJnrn1jJYfS6pQf
2559	payment	1397	1397	1678	1	1	2311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiuqgwUDmBEWPQjQNAXuuxDZa4WjV3gL3PKk7qsQqFKVeSXs9q
2562	payment	1397	1397	1678	1	1	2314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQnSkqU3XM8fXNsZxxXYMqS3rrp96RVExsa7uqh29zExmLcDA
2563	payment	1397	1397	1678	1	1	2315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7dJQYk6dPuHnvmGMigpArabgr2Fi5LMG47cf2poKeQAi4NfG
2564	payment	1397	1397	1678	1	1	2316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPb2qJKFcjKGLJx5Kj3Y1agFo3J7p97o2TBWvXUB9hBQygv5W
2565	payment	1397	1397	1678	1	1	2317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRhyUuHAxAyBLJx9ZbpTyZpsXw129nExqEkVDd5JRZ9RivW7H
2566	payment	1397	1397	1678	1	1	2318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokc845fZ11qzyXTPRLUavYt8bc59EZP2EL4NP8P66QP8AtP88
2571	payment	1397	1397	1678	1	1	2323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCckxD4zqQ94KmkNTUrJNoQJiGxVpKHsNAJLXAwMj66YkSyTPu
2572	payment	1397	1397	1678	1	1	2324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXHae7F8bArLDq7jUjF7YYv21XX6zhzxBVB2Q4KWjM6Z9ugFc
2575	payment	1397	1397	1678	1	1	2327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpSHZjti8z7q5Fd5QzmadEMcSpS9DJsXFK91tN8xMjEuP3Ex3
2578	payment	1397	1397	1678	1	1	2330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUdatotriS9oHTfu7z24QF3QkFAM5YgGYnmDtGSXWFAAgNwQj
2579	payment	1397	1397	1678	1	1	2331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYof3nbUAtdA2rEsgZNsGfv5XNPP75ZdBiMXuyWcG3CrEuWfw7s
2580	payment	1397	1397	1678	1	1	2332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxNQuTh7QaVW47LkLDqPQ17t3kVfGZLiw4xqE8QMPt8nc8yRu
2581	payment	1397	1397	1678	1	1	2333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqkpNXeywpcPbYdEp1MRtPeijUTby9VXij2JpRbVrBMmnRaV3
2582	payment	1397	1397	1678	1	1	2334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeQ1jUGr4pLh1Ly95c9XuQF3TaaRnzAfkz1tYgLzq8ZgoqEYf
2584	payment	1397	1397	1678	1	1	2336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBfdn8GgJ9DqePdZSqXSFcnb3YN6Wg6i29cZk1EwHMeHHPToM
2586	payment	1397	1397	1678	1	1	2338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBufzzXp4dsPdpB1q32ihddcn9kti5uk5NkNxRyJaBcYeo9x2o
2591	payment	1397	1397	1678	1	1	2343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshgiRrFc3ZBXJrYZEt15RadchUyB7p1FSrtfpepExDbrwJH9N
2592	payment	1397	1397	1678	1	1	2344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkG7NVU1HFyXgWGWnDPMvosr3xW9qop9vkTeGB9wZqdYZv6sB
2593	payment	1397	1397	1678	1	1	2345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoDUGU292skYHwKWifXnHZV3ZRvQyy8jYgn7xtjAdDwWb1iUkF
2595	payment	1397	1397	1678	1	1	2347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkBxnfB5DjKhm9LK4adyTD5s1kf6qFB4F9FugHHozKTnhMHML
2596	payment	1397	1397	1678	1	1	2348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7B9A2rir4o868F42eKEKnvbHx9vxavcN36YPxEE6fJQoUmKd
2597	payment	1397	1397	1678	1	1	2349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjToBd925ruTcXE67bbA4jBxFrq5nKJJYNmSVgthjdxQPXtTYk
2598	payment	1397	1397	1678	1	1	2350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHUYjW15VESGQ7z38p2oNqT3zrvQDcDjmudDL84b8LuM61Teh
2503	payment	1397	1397	1678	1	1	2267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbNVGTRCdh2iABoh1CXTxYVVgrL6YjBXgpzuQDb1iymktYb6w
2504	payment	1770	1770	1771	1	1	1	395940	10000000	\N	E4YpWTjbjkMvauQBbyKqu4kUFKQ1oEu57veo7MvAjocUsQvL3eyRn	CkpaJjmdAhyx55MNC35SCZdLei5Em155WJBbYeR6djZdfVfLENLDX
2507	payment	1397	1397	1678	1	1	2270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMthfhaWthp17o4oYoRvazFLwVtDhSq8NQe1ZodqUNJXYBPhnH
2512	payment	1397	1397	1678	1	1	2275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoEEYpAQT3zmdF6ckoC4uFoE1gSfKaXpk9y5MfezTBzPxeNWc
2513	payment	1397	1397	1678	1	1	2276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCCrmB3e4vcrwpWFYsvvJB2UCueALmccm92pY6NZjxfw2QkMS
2514	payment	1397	1397	1678	1	1	2277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU19cQvA7zCijxLPUaLLXNGVhxi77tm8yJWDtvqc9u8rqbNseV
2518	payment	1397	1397	1678	1	1	2281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7uTxJdHiDfLTfgNPpEK8a6m8Ap5c4nLZFctrG1tdPrGdmp8J
2522	payment	1397	1397	1678	1	1	2285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGp8faQJZQ12kABuobPFg8gy893QsQfX4F84kRhE5gBrwdJsq
2523	payment	1397	1397	1678	1	1	2286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7Znq8KUJ6HeyVJrEQcvZ9hBTPRrsPqEUupnDr2XM1E6dMC1x
2526	payment	1770	1770	1771	1	1	2	940	10000000	\N	E4YnwMUzajBu5fpZSNNLNjzhmTUFGHZWQ2KBKCTdWikvYtY5gcvh4	CkpZ1iuEauUgHXBwA1iXBZ58QEMQSzNAKagh3di3Q1rkrZPafDHTx
2527	payment	1770	1770	1771	1	1	3	940	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYoAjugGXmATkNUPSLpqfcEc5X1f2pZLsESjAoaXDbQLHDb82kt
2528	payment	1397	1397	1678	1	1	2289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7G5ShdSsxcjbVsobp4PDogGKX88AZHsMiRL8hkaPb5HuJYQP1
2529	payment	1397	1397	1678	1	1	2290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdkEdRfK7SZxe3Vf7LbsUb2pVByUQwFfiYBge6cDD2HgvEtFw
2530	payment	1770	1770	1771	1	1	4	940	10000000	\N	E4ZG9mxEsB7rYqi3aF4T4k21de4tDmAuASyPMdXHMHNM5R2J6E9CE	CkpZTtpjgeK63giUH1AvE4JadiwUjzWfkicMSY99hiWSgtpxWDupY
2531	payment	1770	1770	1771	1	1	5	940	10000000	\N	E4ZPvkfAfJXZFkFKu4gmYjqJ2jjLgdmiXx7we4VvwB9jYRovKiFcT	CkpYexmXXBctCzptvLJ5uTb8UJAmxb3mNVHGmKd64butL31xNwJiB
2532	payment	1770	1770	195	1	1	6	69405749490	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYxTvwHy7UbJh4UHY5duvu2SGt8GQvF7TDaW48pHe2fAJVGU3vM
2533	payment	1770	1770	291	1	1	7	69405749490	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaCJPyPH3h54Lt4RuRToC3uu3tKBSSfXUbcMoL4bvUDPRWSFbZk
2534	payment	1770	1770	1023	1	1	8	528458132568	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZw1pToNcX4SqY7wf3Aef4xEokAuJmGx7LzrchqzzoFMWqCKTdk
2535	payment	1770	1770	1143	1	1	9	946992445734	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZLcxJpkG62C9yDdfkHPDybA4zXSDQV1CUFUeRF99fmAqazAsMa
2536	payment	1770	1770	1263	1	1	10	638954673294	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZTP2KUrvhW7mrQ9vk716crH4cUNfe6Y3TSHNVpzJ2qx1WFkXPp
2537	payment	1770	1770	1389	1	1	11	1780504009818	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZXeKuzrq9rdQRBgZC7Jx2cxWJhkvWByzpKh5frkZmWqoZre7Yg
2541	payment	1397	1397	1678	1	1	2294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhRPX1VaCS2uBrLSmGgbSDKehKHzFHax49ApWL16CavsrxzLF
2542	payment	1397	1397	1678	1	1	2295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKAMuuxteCPBTHYEJ2ijMARpoGH1TvBfaC4hg2PbtcseoYx5Z
2543	payment	1397	1397	1678	1	1	2296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVAiJxe8DjubSZHGdVMcYWmrbn4erJKX7spfRRRYX9AYvqwhD
2544	payment	1770	1770	1771	1	1	12	869600299	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZVwRgbQYGgNZa56NNaccNjRXw3ZLdhge12fTbhhZu7LJj4BNdV
2567	payment	1397	1397	1678	1	1	2319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaPcKGLW1UbqVGGNFNSenndNsppKpg85xQhACGA7FKPixuCLz
2569	payment	1397	1397	1678	1	1	2321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXh1zHwZbeYyrRsfDSerX2XPYC41GxqZYbXmgwxj2GWUtAbatV
2570	payment	1397	1397	1678	1	1	2322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2o5CBJKnW6afZx2MApPus3GtE3k32jvkudXQDAPQDvrwHr5Xt
2573	payment	1397	1397	1678	1	1	2325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKZqv4xmAwCPA8eW8Ghhf9FhDRSb2zWysMvcib3GWRZDBD54R
2576	payment	1397	1397	1678	1	1	2328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPfEM8LFi2Y7VqxRWfdv7Wd5RwAiByLkxRWWFyS855ii51XLW
2583	payment	1397	1397	1678	1	1	2335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaCJrppxDQ9hAhPWpg8xtqnZ5nh4kLWmuYe5sxjteDY3HeWY4
2599	payment	1397	1397	1678	1	1	2351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGq8BJwcYxJK1rJGDu4UfSstUsatwJqCXdi4G7Sqi2y57st35w
2602	payment	1397	1397	1678	1	1	2354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUToYSQad8RLasdCkWmjn9yDRivrZG5tmbF3CYzgQcgeGbRKqq
2603	payment	1397	1397	1678	1	1	2355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq22XHCmjkJUDkggB5BSMBEUtdAiFMQjbH9LTjmgXnnih6oyPJ
2604	payment	1397	1397	1678	1	1	2356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhUFso8qskZSsGX2Hyrma6ekRZZqJdHRpFbUKmSp1L5WAJzv3
2605	payment	1397	1397	1678	1	1	2357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2KETHQbR2SXva393HAHfUZnUXUibZFtiKYySvLeHJHSDzaJd
2606	payment	1397	1397	1678	1	1	2358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mFXn4TFjcyBhYzykYNumwX9DU7CguxZZiN2F32DiQCobKiBF
2607	payment	1397	1397	1678	1	1	2359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FHt8H3kPsDPzu1B1TnMe5NhKzU2Ru2W5kzUY8VUgDAgq8nM9
2600	payment	1397	1397	1678	1	1	2352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6VKSLtYq7k5RStEepK9TYGqFRSA43tiQySsXfehMBmbzeB1H
2614	payment	1397	1397	1678	1	1	2366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupMoiSNp2JjLzNhw251TLLRAMVDRxYYWQLpQTYvysXySzfRyU
2617	payment	1397	1397	1678	1	1	2369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzW9957FBaNUXEmQ28khXLBTRPnU6Fcxr99uDW71ftSK4LNoux
2618	payment	1397	1397	1678	1	1	2370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfY9t5iEvP6XkjjkNEitjYsRcHfvSAsWzA1AGfRxGNR2PUbZL
2619	payment	1397	1397	1678	1	1	2371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr856A48KHRK4HxKMMTLcgUgJAR3a9qgTVzMhcVRRwPH2TvCLM
2620	payment	1397	1397	1678	1	1	2372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3s3KZszNqwoDwNMPJcb4ZKq3tJRnXhPYYK89kAyHJGMSuE57
2626	payment	1706	1706	1737	1	1	4	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRa7ECpfo7BYaL6pqpjFkPXm1LV3HV7DfTekuS4MjmbVCAvdPp
2627	payment	1397	1397	1678	1	1	2378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HTXoHyPyBP2RAJ3PWQezDccERz5tQp4Zpzvb1PgZJSFfYZqw
2628	payment	1397	1397	1678	1	1	2379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HGya9vS6rMkmdMg5s2cFUhaohx27VieDDFgpLfH2ojV8ZwvV
2629	payment	1693	1693	41	1	1	118	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaKE6Jm1M34PCXA6upW8PeD58dZPpyoptHZuSmh7ZNqRMm93RVY
2630	payment	1693	1693	225	1	1	119	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtsNXqR7jqoZ8n4Sf58kUpwwG4E34YaK4ALnT6uktzHPSuiNYW
2631	payment	1693	1693	304	1	1	120	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZjJCo8Tm3goytvE3e1y7jsEprCk59eyVXGxA1qK8qcL7HUipsi
2632	payment	1693	1693	308	1	1	121	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaDyhdLp2Kwo2qYybHaQrBtDpisejCRW6wwRWnjwwrHEjbGpS8o
2633	payment	1693	1693	373	1	1	122	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaBphFGhdrQkvarz5dPkgYkNFDZSvu29SRkCRfm8iGYfBpPvh4M
2634	payment	1693	1693	191	1	1	123	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYegowMG8eGbP1sVfdr9YGA5HANCTq1uyFX13vSgUxr8erVrrxr
2635	payment	1693	1693	877	1	1	124	153145890887	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZy7Pht9L5gWXDPmUDHXjuJm4RZCErgw26TYxfyqppkRTSXRMa4
2636	payment	1693	1693	309	1	1	125	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaAF8rzEXAmAWrchMiQPouc2di8y72c3vubZrNG8bpJXkShKHXr
2637	payment	1693	1693	731	1	1	126	1508431437	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYwPDav8u5n4uTjmkUj2aFvey2m25fa2tq365f5yHkvaP78Lfch
2638	payment	1693	1693	217	1	1	127	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ3z68W4uE8EmKcyUd5ooaQD8DYT7tCPwLBb5ShuaXJMJfzUu8r
2608	payment	1397	1397	1678	1	1	2360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejaet42zPATvmgPbPkDskrVErF7nuL4w1fKsp2gokg3n16wB7
2609	payment	1397	1397	1678	1	1	2361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYAEqw7nBESRworDBs4Pnk5K4PmiUk8RAurHcouZ4p4zv7mUb
2610	payment	1397	1397	1678	1	1	2362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShSBJ9nXMHZaJTv3TD2zToLfJP8FueQj3R3rgLXJgLdiAsFwV
2611	payment	1397	1397	1678	1	1	2363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHm6eUupc7WRgrPA8s4eBT3JkmDTRjhUHFjJ3fNQXrgtq2ztCs
2613	payment	1397	1397	1678	1	1	2365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3rR2yRBf4f8nXyut5jdxoRYb9jLVoM3PUDgJ6MvQWvWchmGG
2615	payment	1397	1397	1678	1	1	2367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc97DAtyzagDWGhontpuxpBS4bPbHHJJqg2KzW9LUkZcJZnaCs
2616	payment	1397	1397	1678	1	1	2368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGJtXxFk7uq8bBVvFAznqADQTiTjeSBYMh2x7DbXwdJbAPjZb
2621	payment	1397	1397	1678	1	1	2373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RGnDG6u5xaEJm3K58X1QxFJzAkUUTgcCZh9GhUpGnBeba6zY
2622	payment	1397	1397	1678	1	1	2374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqze75PyLduwS1tEHSPKnC3zmRbBoRVqVXMrL7ihbmXV3qg4rU
2623	payment	1397	1397	1678	1	1	2375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDmWDTV5NQHwpWrwFkt95xdL183Xy1Ba1fmVx3Ku9efUCKPFA
2624	payment	1397	1397	1678	1	1	2376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SwLybaeLGHYLMV1KhXcc17GgNCfCCRfShtwGDSX11r4qQT5y
2625	payment	1397	1397	1678	1	1	2377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRL4EKHTsm5bz44dts5sX5dq3E888b9EcVyp111gaConZe5duS
2639	payment	1397	1397	1678	1	1	2380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZda1hes81AWLLi65QfXw9VufcfEYw9qo1SPZbZM53r7XbyCV4v
2640	payment	1693	1693	402	1	1	128	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZgJWduHU9gHeZkv5x9dXoRBZ5msftfcwvg4SHdUZPDYxRKDnVg
2641	payment	1693	1693	1030	1	1	129	679506888300	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYcTw7Kuvkay9pciiSqSxzRsNVpJ6ZRox78G53JjiavFheGctQ9
2642	payment	1693	1693	205	1	1	130	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa3qiWZNjf3zFqqNyPGpbAzdv2iRHsLpaHZnyCDCqdMDKaMwzzz
2643	payment	1693	1693	138	1	1	131	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaBvpoEUaHTxkyFui4NZUQVAKQCNhRSoCrQ7cBteuHYMTwKDM4e
2644	payment	1693	1693	275	1	1	132	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZF7TuQPXGjCoo4rKdCnXpZnxK7jnnzvHWBEdWxBkW6U2y9dJWq
2645	payment	1693	1693	397	1	1	133	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZsLDVjmMBS5AN1Sssms2UEG6kNC4UYePL9LGW1mK5B2aHdnP95
2646	payment	1693	1693	690	1	1	134	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYfecjHjddz5Pjb8zfzAxUh37FDfzbbRgQ74yC5A3rG3uAeh723
2647	payment	1397	1397	1678	1	1	2381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAgZEnEhrvq5GGW8Dh7igEQTEyvpE62EpsUdKpFTRpZ9PZfji
2648	payment	1397	1397	1678	1	1	2382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUFWGceFMHJSdkySXGYvdWNQSJho53EbGZBhYdxadUfCDGJvc
2649	payment	1397	1397	1678	1	1	2383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKR1j47CX2X43hTWDdMbtxvuZYhRprnNs3hYX4VYP7CPufBeD
2650	payment	1397	1397	1678	1	1	2384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzgR5pY3uXYn68682ix22i6bVGmJdftoEYP3LYiXbREYqtiyx
2651	payment	1693	1693	106	1	1	135	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaCn6oF45nesQQwfkVyZWo3ft7a4AiuyiAiNpsxtG3shcL9TmeP
2652	payment	1693	1693	894	1	1	136	231410667894	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaJzFbZpqsNzXtc8LJBbGnU22gizgnzZEGkreS8mMSE66dhC6ZY
2653	payment	1693	1693	5	1	1	137	5050982688	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZrCERMP6cQcnF4hvpqynCYkTCoc6hLgWfz92A6JoTzgEMHVdXf
2654	payment	1693	1693	122	1	1	138	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaC2u4gc7syGFbVVQup3qPEhMNoRx67ooauBT88DBE2VB8jQtAd
2655	payment	1693	1693	91	1	1	139	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZXpD9NipMHtD6TgwvkkXHqQqnSyQgDBxUzHgvkbAPqXFEuMAPm
2656	payment	1693	1693	99	1	1	140	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYRLvxCbi51SYNecXVjKV3KjW9LCu1Vt68P6m7raDAEPA9f4bwN
2657	payment	1693	1693	339	1	1	141	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYbLNfU3WQxTzakL1nq3GhF7suHgDnDXTBkaaA9k6YkfTNunedD
2658	payment	1397	1397	1678	1	1	2385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkGJ6mvVUHa8uNEV1pc1a5HMFU46pqNg81BUmagMuNCFt7x7s
2659	payment	1397	1397	1678	1	1	2386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ad5TXbNaGJLfZEvTVxXM1ZeNHoHTtLsTrY3HBuLWaQF1qC36
2660	payment	1693	1693	420	1	1	142	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa1jwP8qE5aGPpciaHWfgb6wxkHrkiTxoNQYtmcEruffq5fHaWC
2661	payment	1693	1693	206	1	1	143	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ6nsDmdooWSz8T3fieR5d1sdSUGy3Tj2rjKSDSMjB5pLy4Pp7t
2662	payment	1693	1693	408	1	1	144	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZgX6heYVewNy21saETdDbXB2BVMLJK55hhCqG6j5vtBPJzcFHt
2663	payment	1397	1397	1678	1	1	2387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZVFWvzzJ33an5KyZsdpTFCCd5WABaxsUtWkd1F1ahEvFX9sV
2664	payment	1693	1693	438	1	1	145	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaALcBKaDDTr93HrYyqp5HQYeHR2PRxuGqCKjucdBSrv67Zt1RZ
2665	payment	1693	1693	534	1	1	146	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa5Ptv7vDoSw28SiB34tiS46rFAPYbt4efxnfCU62SeYBWEWBC7
2666	payment	1693	1693	399	1	1	147	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZRhvQzETCdXdEjnGdrcBxeS9bZnVXqwBFtPA9e8xK5oEHcrHG5
2668	payment	1693	1693	570	1	1	148	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZrY5DmfjugXyweVFzdeuGC7fxM8axjwUtRm6aeXQh8oiXBPQ3j
2669	payment	1693	1693	910	1	1	149	379190924772	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa4Gnp2C9WvUGcHRKkEvSQxQRZ4WcSepAJvfWkddvWiSMGgYNch
2670	payment	1693	1693	322	1	1	150	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa3CHy43oSNjGA2dS2XHk2bHw6FjiKYry77Re3GHanihR6m7CpW
2671	payment	1693	1693	500	1	1	151	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYoE1GQwMVZzXPtKRH5RN2p6aH7rnozxnVmwr48YF31uji6NwJK
2672	payment	1693	1693	105	1	1	152	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZgcKddzW3QZ4m67PmwqtWBrDdbqtNz9prFUUnwa1AN8bcjY3DT
2673	payment	1693	1693	89	1	1	153	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZpqBT95HT1Me8k1ZLW187i8mQzt5E4VGtvFJzyfce7nikodivf
2674	payment	1693	1693	146	1	1	154	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZbCsHy9bzH8uut6HSwQwjkRo3sbkRpL7PQe9Mdn9gTKck5mEws
2675	payment	1693	1693	92	1	1	155	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZWcets4hDVtcbWsYZKvzdz9UazDCw6ViQBu6E6syLvmWoGf3vQ
2676	payment	1693	1693	29	1	1	156	5279510058	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ8zijiNA7jHo5aQHPsDYrdwug9g67DexpNGdDFFBqsqAAPPVNR
2677	payment	1693	1693	251	1	1	157	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZqSTj7HkDcpMW9ug98br1KfHgkAwHLWJFRzDNi9qwfUzqF8WXE
2678	payment	1693	1693	84	1	1	158	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZPxDFqzmu69wDzxGiVyTxZ4HpBiC6FipJvVB2fdcLKdU2W2xi6
2679	payment	1693	1693	395	1	1	159	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtYekTeVt1uqjkyXoyFnsVtXQaS25em186RvSP1ezNr3DHRGKy
2680	payment	1693	1693	587	1	1	160	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtRh9eHQBQ6fDCQcQ1rnN1zHv4oKJxCJSTjGoxgF1AyTu4t8cU
2681	payment	1397	1397	1678	1	1	2389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vhfqfk21QsYistkusFUjT1LEJfcp5gftYh6UX8Cy5hGVRq4b
2682	payment	1397	1397	1678	1	1	2390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ntXEDNLbGRH6wieV29FUnpf1jdz6Nc2JmfSXSKjXuJvQBzqr
2683	payment	1397	1397	1678	1	1	2391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimt9Jopc3FFMZm5gYxFNcKqX2xmFrQZbJUp2dyXRdmGozBmic
2684	payment	1693	1693	611	1	1	161	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaDGeHGaeZPoGnaSTowTRJTxaeN6sQe7x4zgCrvtrdMgfm7EPRS
2685	payment	1693	1693	678	1	1	162	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZGaWGbdwNL27DFviDEb7zgNEYgAxVoHZT8ciX6id79SLEFrH7Q
2686	payment	1397	1397	1678	1	1	2392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjefeHvMme6PNrGPiZrHd7Kxi6EDuCtUKKwP3ByT9kTXRxSpEa
2687	payment	1693	1693	320	1	1	163	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZiRXzeAKz4EHkW42fMbPBPtm4FRobdbvB1nnVSQsAzhqp4PZFb
2688	payment	1693	1693	710	1	1	164	3771078611	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYyF6fsN4bgwnTbWWnTrtv5HvVUs5bAii5LAAUA1WyZdjZWEZst
2694	payment	1397	1397	1678	1	1	2398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2yuDgSxABfyfoRi2S7XCjX5kyNKbzNMoyBFkFWqAcEbwTpZt
2695	payment	1397	1397	1678	1	1	2399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4uQED7bjgDmLAmoU8crKPFvA52h4YD1sLqrJ1rV4U9p54WHu
2696	payment	1397	1397	1678	1	1	2400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iLG5FgeEbVZAV9yNLuQWdH7KCw8f6sRJSiEHSAajNmgfkrTf
2697	payment	1397	1397	1678	1	1	2401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZps9Tu2mJ28hEga68PpT1QxdjUKv9QrT9GZJAbuxv4nVNf7LXo
2701	payment	1397	1397	1678	1	1	2405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPk2avfi6bojWwtbWjD3j7JU7Zwqqrd13Wm68JAmeFG69Q35ft
2703	payment	1397	1397	1678	1	1	2407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGuEsi6v8LEw8hvknw883zAXDutzN5WwJzZyTELbEySbPMo7B
2711	payment	1397	1397	1678	1	1	2413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pdUV4FFcQVcFpHPcx4gaUsK2AQJnAtPBXD9dmEUzz5JE6S2L
2725	payment	1397	1397	1678	1	1	2424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdaFhmTCNBxzHno1As3K4eqtYpTCHUyrWjKUDWXtsqutRZZju
2726	payment	1397	1397	1678	1	1	2425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfnYaZS9en2BL6aan9UAyTGqqPnkJiXTMz4rTV4kPXXM1XST3
2727	payment	1397	1397	1678	1	1	2426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3k5JgePjmTcJ5fM63zcK7RdGRGxJBnFByesMdTJBphWsjjTzN
2728	payment	1397	1397	1678	1	1	2427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXdkuURDAN3t8doVscR3SZsnxvzSEAsTWC7UpMYDZA4xTi5nh
2729	payment	1397	1397	1678	1	1	2428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsAbb4x9LChDm4w4mrFN6pZEtav1PDMZneNaAiLyA53AHiSqP
2740	payment	1693	1693	78	1	1	177	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZtEX9zTYt7kpv2AakAT35iYfCxxie8vz8xNsJJTLdTyArZajGL
2741	payment	1693	1693	37	1	1	178	49271404754	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZZkUaCa8pyeZYjBgzh41ckjtNH7Niqedq99tev7rdo28Ycy7XF
2742	payment	1693	1693	520	1	1	179	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZQV35QVRagu18qPAP4Eoh52GF7LcDpPkYdwCNZhGUJTKCub2xM
2667	payment	1397	1397	1678	1	1	2388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASdM9oTPxiztUWgdreNSnZXy6sN6d1gMgm6bKDgN9zxQ5xMZo
2692	payment	1397	1397	1678	1	1	2396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtYuqt8zBExb9DSnXwaK9MaGKfyUKGXhxoGorhetM8XF54uPc
2698	payment	1397	1397	1678	1	1	2402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEGMv7JmFo1A5LDBGqyS9rSkGC6cQ5aYM59XXbMp9YYtqqs73
2709	payment	1397	1397	1678	1	1	2411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCosRfGQpatGR4oUK9ddgYtaN4L3JcSFTVuVWKZvFFL51wvpPA
2710	payment	1397	1397	1678	1	1	2412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbLz7ELRXRj3phfkiGuSCgbusGjoZ8gtqQFZNq2xCQXCT3Qkq
2712	payment	1397	1397	1678	1	1	2414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8VuYj7HQo4CHmJVmZ6X13WL1BW3tTuegxXhSXmAxx1ZAay4K
2713	payment	1397	1397	1678	1	1	2415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxd2LZteiEWqNqqLADfkpAcNH57weXV6ZJ2njTb1AZQrpg1q8y
2714	payment	1397	1397	1678	1	1	2416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvLefVbtTx5GahGniqHyNYYjF87Cq5VRG7HuYJb63THvfHt9o
2715	payment	1397	1397	1678	1	1	2417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSEUVQcVKy7qfQz17jF2aZgPArXkbNH5CmH7CaFMvZKbBbUc4
2716	payment	1397	1397	1678	1	1	2418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsM4iNRuwjcht7FUZ63hDHo9Wh2dToRTqzFuJ3Bhww1agGoKyi
2721	payment	1397	1397	1678	1	1	2420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCohcrk3fc8k13Ywpq3F7HmwZu4aDBr9CKaMeod3J39XaPywo
2722	payment	1397	1397	1678	1	1	2421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33KYVPa829XdzGxt8AvRCsmJwbN2rwNX1qJQTvyrfmWE2R5Dj
2723	payment	1397	1397	1678	1	1	2422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLeFFLqznemMCHqLEKk2ysWXt1wJ47fYDAxtFkjWuf1oZ1DJH
2724	payment	1397	1397	1678	1	1	2423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yB5NgEqjzMjS7vVAxmCAUFF75HfmVkZLR1jGjeP56MxRbkLx
2732	payment	877	877	1772	1	1	0	260000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXx9PavjXRkWrpn6oVwe29qEMD3PYvVu4N1yExCerjNzR63Dp
2733	payment	1693	1693	150	1	1	171	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZftY9kDwmPjrZD4QdCiHiVehm5f9DPZaEf8NbM93Ev1g3uz75s
2734	payment	1693	1693	450	1	1	172	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZdVSQFRNVsD8P1frn73G8QTkNmAPiAMWG1aLZbxXGUj5yrhEcG
2735	payment	1693	1693	620	1	1	173	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYugYL4cvfPBZWULi6upkFDEgWRzbtmcDF54K5w26xq5C4uV5VU
2736	payment	1693	1693	421	1	1	174	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYx7GcTEsZGx3LpUF6AL43b1Dqu6Qu9ByorDL5LwDGZzJb9ekf4
2737	payment	1693	1693	245	1	1	175	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZWotYm8Sjcd46dj6MQCNVC3RVvvujkviR9cW5SSuy9FffwiUFp
2738	payment	1693	1693	54	1	1	176	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZoeeSzuCEiACsXpNkouHe7ZXsy1B1hBxajA63T4DCSCK3xzdd7
2739	payment	1397	1397	1678	1	1	2430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdgQaLvSz79YRLqXwfSxXU4m9n9aBkNNxSds7uMed4or3Qs3t
2748	payment	1397	1397	1678	1	1	2435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVm25PUU7yMx5L1bPH6VKKx3MdGERSBTemid6ppbnrJXfXYmfE
2749	payment	1397	1397	1678	1	1	2436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGrW5fVCJzXu9WYTJgSdJUcsjJY8aM3j2SMbUy3ZC9uhfyn2V
2756	payment	1396	1396	436	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9Cj4LCbRxHCNh2pyca2uGvJf2fzkTKaCEUAB2GjqWytRnCR4
2757	payment	1396	1396	436	1	1	1	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHEVhFEZRdfRo6b9yPnkoARHcAuZ9FBjMf3MbiQZCQ2GBCxkQ
2758	payment	1699	1699	1773	1	1	1	8893278499961	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ74WA336JmCrc7vaJhAcwoAfAfmnns9Yx12fKq8WEqNZg9vfm
2759	payment	1397	1397	1678	1	1	2439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYfcN1emenv4T4GfERb27Cw3zPZrtR1Jx2qEwCBLjNvLk2YrA
2760	payment	1397	1397	1678	1	1	2440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR654n8y85pats58m9mCHg1g8MUmTGF9ogi9mYLUpoQCzX2qM
2802	payment	1397	1397	1678	1	1	2451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobFcEneSmL8SUYVsHjYx6BXv7KRqGxXN6q6Je9LDSfMkPDfyp
2812	payment	1397	1397	1678	1	1	2454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMSi2p7cq121ftVotpW4uXqgRyfAeiH9hZtepaxEPp6arvGhG
2822	delegation	283	283	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqtbQ8CaW9mVmAQpijgnPrgZRjZbYZUghjE78Kn73WmowRM25
2823	payment	1397	1397	1678	1	1	2461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjBYLRUR7VJ9yrEtQi1yww7pXzBCvjfTnsAqvYCYgPLndSdsz
2824	payment	1397	1397	1678	1	1	2462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wfQSzkbQYmmVc7jreCa5CG2NUjRMoPokVnKRKxEZrzcj7JpS
2827	payment	1397	1397	1678	1	1	2464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYa3u3L21EoBUvsS5BgmJL7XnndZwgXkB4SWac8K9cB2YEqLYW
2828	payment	1397	1397	1678	1	1	2465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAbbY8UMChhNB2289Y8KsvXxTtvJYLfy4Lb6z4KLmwBarrJRa
2829	payment	1397	1397	1678	1	1	2466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxt4rQA3EqJvaAdJ5fCpPkypFBcQaNiEnU9rwuShCAp94dXDgp
2831	payment	1397	1397	1678	1	1	2468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbtB7iswVsQShUkfbmXb9yyc4yQFWxmYGPXN7qJY7A7qTBfrq
2689	payment	1397	1397	1678	1	1	2393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Fromn2BGhV7aCoTJZg98YadiSnfzx6fiEcmMmo72wBUvGfKu
2690	payment	1397	1397	1678	1	1	2394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPz4bpQarzcPdivDWSsMDesuPXCirrzr6XMqQU3KytzD6udec
2691	payment	1397	1397	1678	1	1	2395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4eR6aQhpQJ1rPn4X5J1M4cRR8eTr5omNvNEyF3EBoNVSys2g
2693	payment	1397	1397	1678	1	1	2397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3GvVqv86JKcQfJaWWXGR2qava18PpSia2uarAYBQ5dxeNTYN
2699	payment	1397	1397	1678	1	1	2403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj98ocheWevnXEjRdktGer4o2Z9xhAjrHn85fZ6vQZ7MCsgef
2700	payment	1397	1397	1678	1	1	2404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxpnYpQXD6fYKH2L6UxchkPkr7eSUwpd5dTkYqhmGhagW6oXC
2702	payment	1397	1397	1678	1	1	2406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1XgtaUhDZvUDGCao3xh7zFLfc1QmeYtwfzz1qQqqpfDwW3Af
2704	payment	1693	1693	721	1	1	165	1508431437	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZH3yN9xt2dL5QQ7fbeyoEVMKkR5f5Y3tK1rB4nTybC8D6ywBGd
2705	payment	1693	1693	295	1	1	166	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaA2xMpvDrFFhNJDuwUXbcw6pN65nxVCtytiAdqiFzM9mjTf8xa
2706	payment	1397	1397	1678	1	1	2408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4ZyPuCUNEcTatDDi6unSsLJwDS6Ty5Z9pqQtG58Fd1UCHNS8
2707	payment	1397	1397	1678	1	1	2409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJyUyb3ReEfD3jR2yH1FzjN7norEh6CLhM6AwwYBNSAcqKkPh
2708	payment	1397	1397	1678	1	1	2410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9usFtraythcvzE5VAiH1wqhTymGSdXUyQHhBsBPDoQuTtast5
2717	payment	1693	1693	560	1	1	167	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYoPUb251XE6BrFKYE9UD5gaGDXYTQaaa3L7Ba1CzdLknRHaDKq
2718	payment	1397	1397	1678	1	1	2419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMh1cgvi5KuQGQZx9QBLBxoC2raK4y2ZnMyjppdHLm91P6BSdU
2719	payment	1693	1693	392	1	1	168	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa96MSFcctBFzowR4wN3WMib1qneX59KoNvyRUWTuXahvShiJVd
2720	payment	1693	1693	194	1	1	169	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaAkzCf7K41esqSoauNdHnP4QWPWaMBjTAhUsgzff2PNAKzzKCU
2730	payment	1397	1397	1678	1	1	2429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVr5GuWYcEJV93TbFnjCRYM1YvFKTsp2PKkiZeC314w3BMCkE
2731	payment	1693	1693	252	1	1	170	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYyurbNYgZrNFgnuVkRkEdhqidWh5Tt2PNuizuwSJUaK12VxU7Q
2746	payment	1397	1397	1678	1	1	2433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLV6DfVv6aYjBJDSHKW9RLD6p2KsRND7os5KcBg7Gf2GV4jxo
2747	payment	1397	1397	1678	1	1	2434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcmtR3pZ8mA9YFqrDMfpd1Rna5VaZvhk8rUcSDa7CsrVujSPt
2750	payment	1693	1693	1150	1	1	181	458476837668	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZLDhMRm2gZUgFKLNtpAT7uo5TKpvDkFZsssdopv1HiLbR75KC3
2751	payment	1693	1693	452	1	1	182	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYh3pMP6qfAVpEEJ1WuqbXbKu8s1Gs9VTQG9is1z9bZ8pXPgRVN
2752	payment	1693	1693	594	1	1	183	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYyaVgMpAaKN7SN4sf9EJRqFfPfJgjCZxrGkpJxcsEqJr8WSr19
2753	payment	1397	1397	1678	1	1	2437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8JVyvduJyWcQwuKkB1PbEbgBDS4MtmP8fJGfqohwaFASFdLU
2762	payment	1397	1397	1678	1	1	2442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKpDqYf3WwsafGPCHLPQgXRt3q4EFZiC31KdU8jTPggp1TX9y
2767	payment	1397	1397	1678	1	1	2446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWb4QQi8DBGzkCBwGGfF9tjRMUwne3sgS9URNnjsi5FqUKYcAX
2768	payment	1693	1693	391	1	1	184	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaJjASqZUTzByYP894fzNGGWmTp6QeUMVWJY6EaRvLRjvXBo3tX
2778	payment	1397	1397	1678	1	1	2448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBGDHdpeS8mqPWnZcRyVFv2zyp6JhZaJMyMYmnJ5pKZcyMrmE
2779	payment	1397	1397	1678	1	1	2449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSWEtDzztazncBCJLWm7xcvzvbWuHP8DbeDexyk2oq3qQyaywx
2780	payment	1693	1693	660	1	1	193	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZazdoKsHFxbZwSwG5pdhwAeq29XAuWwnp5bxy3zT25fWhZhiJ8
2781	payment	1693	1693	1276	1	1	194	1277586473640	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZftcmoiJmkm31iQMSwef6iDTX5mkSjMXoVUYJUBVM1wXer3E5g
2782	payment	1693	1693	180	1	1	195	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZqTHQbmMAdcqfejV76guhpVcdqHWidUmCh8bJoxE7KHCzsKNSD
2783	payment	1693	1693	353	1	1	196	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZJm3i5guZhH3m3kWayjFupwqacdJSaanPkWobWi2wT59YdJ4WZ
2784	payment	1693	1693	108	1	1	197	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZTF3W8VrJongfUMxBNwoyQ6UuvZASxNqvTsM7traVXPsGg9Vei
2785	payment	1693	1693	390	1	1	198	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ9nzcKQ7a7nehumPXgQ6GsLkjdy6LY1wHmJ39qjzdMysdTtrnC
2786	payment	1693	1693	601	1	1	199	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ128RFm2K7dcqB8KdqJGEc8dxhbY2KrMRT2rCEJdkvdBECCYXQ
2787	payment	1693	1693	266	1	1	200	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYxYjUqpgZBKV2CsfP6vRV3PXsWoakaoVY3GHcKuKf3rqDTdd3o
2788	payment	1693	1693	600	1	1	201	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZimW4B7Bq4hMi68nzQJWrJVSG3xL6EkD7hZ89guM94v8dnep1F
2743	payment	1693	1693	163	1	1	180	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ258ptW9ur8xjvbBmMq6PLqYxxhKEPPKamYH6WEK45ANKZHpPX
2744	payment	1397	1397	1678	1	1	2431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UiXqDenZ6e5vdwrNUeBV9QQrNy247ZMNgxPNFHF2zHtBHySj
2745	payment	1397	1397	1678	1	1	2432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPTNhSsimitVxF5JenhoEfwMyhrerJKDM3sLYhom2Vrfzzs5L
2754	payment	1397	1397	1678	1	1	2438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmj8msz4i3kK399A3jFuUhZbS166ARkK2zr2HaMhfH7yvTh7r2
2755	payment	1702	1702	114	1	1	0	5000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdiTpTvyv2CPSP5nLobcFqm8Dg4kCBV5dwxxRrujY7sN6Uavz
2761	payment	1397	1397	1678	1	1	2441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFvJ1R1PVchfA3iq35HyQxiR1dibFxoypjLe7NHzyzhvnYEyL
2763	payment	1396	1396	436	1	1	2	716700000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjhSFuiw4ACPjVPPmNLy1zEQH4fLYdZKA6ednWaw8GG1xi2r3
2764	payment	1397	1397	1678	1	1	2443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQhdGPNutrbYbNE9ZyZ3vg7a9Ux8W9CoA1cvY7u931UVyNNbZ
2765	payment	1397	1397	1678	1	1	2444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5faib9ymsEpwxfXEMBUMtNqvmfsZdxszEzJMxJrzap4yJCZ5
2766	payment	1397	1397	1678	1	1	2445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRJ4f5e6KeS1WNPt6nmFbQbQVkpEeCjvqNzHYdraGsoA6Bof6
2769	payment	1397	1397	1678	1	1	2447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPKoWpHeFtYDDKBoQYW5n65UpbS2eWeaJLNvPf8mfBPBei1q2
2770	payment	1693	1693	622	1	1	185	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZi9cRVcNCbr6HKe3JKtK1qUimbkFAWHVMN9UCi9fbgfAdzgF5H
2771	payment	1693	1693	653	1	1	186	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYRAUjZKQSnEcRFmNN8vhTY34Fz8eGQjgVjNSF5dmhyzofksGu8
2772	payment	1693	1693	193	1	1	187	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZrEfqKHgGvutL4K3VJUAbrDJ5eQZEmu4UR9VM6AJA87oeNwcs9
2773	payment	1693	1693	504	1	1	188	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	Ckpa6UyLNTxzeg8rzCBL2PFiSxYfHb9gb7PQZENeR8QLiqLK6UPAv
2774	payment	1693	1693	593	1	1	189	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZK6v2bW7GNXwHnYfDdJHKQXzpbtAcs2cb6UKX6zbN7B67chDts
2775	payment	1693	1693	658	1	1	190	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZev2rUHXQqyGRZtuGULRCdykgtPGbLRUu7GbkWg241pSEsqgmJ
2776	payment	1693	1693	6	1	1	191	24555755502	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYjy4yE8r5FPZF5vBDFfmvj9vdiseM2zDPVfwMEA4pNh1m34Trr
2777	payment	1693	1693	652	1	1	192	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ3wPDKBq8UMVoSSACz5Y9Ar3NbYckgi9ALshtFRFogfNsmBfd1
2797	payment	1397	1397	1678	1	1	2450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6rNchxJqbjd6nTiw3XUWrMByRmKQue8Zfo7bccuyyv3WZp73
2798	payment	114	114	10	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtG1NDdBRtttmyaRyrSMvE6V71i8nb2FEh34CM5hheCzRGMT1p
2799	payment	114	114	10	1	1	1	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSwe73TbX1a9RUFTEGnFjoibwyY9ywbe8BaASfB4Nydtsd6pK
2800	payment	114	114	283	1	1	2	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5q9DCct9Gnhhk4bHKYSHPrRe46KMLppxui7mZ6uScFd3Lbsh9
2801	payment	114	114	238	1	1	3	200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsbwR5EXYYrdTArpLBm6Po7oburUHAkTkgk9C8yUCYJdqCHCpL
2803	payment	114	114	301	1	1	4	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3PyzDhPuKtP4vry56jx2DRUv7PRgKvgXRCJU3gdvxs2GZAtZ
2804	payment	1397	1397	1678	1	1	2452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnGBvSFy4rYAowa8iVCF1wJYdXkPp2Z7TVJrZfYEAtahbgZbT
2813	payment	1397	1397	1678	1	1	2455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSHjhy7CtgEte8NpZYPgesBtk2PegVZS7ewwGeWe5VupTo8kv
2818	delegation	301	301	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHMJnyFDNu528pV9ULkfnhJkHXJ758y1ivFotm6YfuKwWPmdab
2819	payment	1397	1397	1678	1	1	2458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDk3drNbBWYZxQiYpRnYJQoTnt3qC2HfShQDZZefD6gKM54FQ
2820	payment	1397	1397	1678	1	1	2459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAwFgqb2kApXTRfQzLjFUq9ExiMeFLb7rp9kFaptHuitswQUQ
2830	payment	1397	1397	1678	1	1	2467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXn5LZCQkt4xYLpsNP2mUU5RFQ1NG3BenS5tLGihJX5TcAjxCj
2856	payment	1397	1397	1678	1	1	2474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHY5EBgSEjMwqpA82jgKkLZQDJqoRTcirL9awrFnEguccetALx
2857	payment	878	878	1772	1	1	0	259000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYJsK2wVBUtuUm48c8YB8fCnF27VKLbaNvZUNRzuTLYUbog3C
2858	payment	1397	1397	1678	1	1	2475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvXKpViv7R4y3X3xHPJemvcoK1U53iW9wBMHsCjZBSygHxEy7
2868	payment	1397	1397	1678	1	1	2484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6taHZTTAqfPpPQF7KMG5Uu5DHHuCLa1eTSTJAzoHQvHU6f2C5
2869	payment	1397	1397	1678	1	1	2485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CUSvFsA34iF92Q4WKTWSUqD5VZrdVdfvsfVBN7d9YNTGwAMB
2875	payment	1397	1397	1678	1	1	2491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesmq1xLdgjxdWRhMiQBCL5bMj57KkgJ7JRwdCgwZqQJtJjV8K
2879	payment	1397	1397	1678	1	1	2495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpM9dUY1UMHDjcsVaEXgB66WcH8RE1huAVnrc4bz5CMQH7bGi
2789	payment	1693	1693	691	1	1	202	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaBYmXjt2CrRFnbUhnEra7ZnwZrsqSp36FAM3GPdan2qiGPhGHY
2790	payment	1693	1693	352	1	1	203	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZfGbj5x6JjWPGCb3omazniJ64cDedB6a9F7FPnS3teUTThzahA
2791	payment	1693	1693	63	1	1	204	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZ7TbkJStBmJm74yi5s75QWakZHen3XEszSn4x8L3JSaTn5Rgjh
2792	payment	1693	1693	739	1	1	205	7542157223	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpYa1B9tLcZwqgzgucGYBnB9C4nEBhMd9XNqtVmCZSpyFxqmnd7m
2793	payment	1693	1693	893	1	1	206	231410667894	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZDeF5QC2DqR7CaA94cMUR2NbchxCW2sccjYE3BzZ9iNLyoWRZ6
2794	payment	1693	1693	377	1	1	207	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaJZ8K1UrUhjSkb6waV4nUpmPcPGyN1Bn462u8A77vGFpETcn12
2795	payment	1693	1693	103	1	1	208	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpZz5PFeZh7Wwc9qCSSrfJqSMSANSi5YtVLNdcEZTFrFEesaXhJ9
2796	payment	1693	1693	361	1	1	209	49778237721	10000000	\N	E4Z4SeYHiiuNXGWBGh66vSMJfbBgtih9MAnUk17TbvsYwGM3XtedF	CkpaL7E9NRUfncsPskC33WPseiCYsnX87PW6Zi28c9DaKASv6mXHM
2805	payment	1397	1397	1678	1	1	2453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkmKUfrkPfGMYnUUMr5b9ppDHpRZBVqrQ7SBXctP6EkQAPuhL
2806	payment	1773	1773	182	1	1	0	153938198848	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	Ckpa1MjP2ZiLn2hK9rZ82QyTdmpoZDFEtCp37xJrFy3Adnu3wGyZu
2807	payment	1773	1773	702	1	1	1	102625465903	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYsbEMKKcVNe11akRgbHimbvbE9BzgQecreuB5QnWJUjnrcyFTU
2808	payment	1773	1773	927	1	1	2	1171678650623	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYyiUai3zNgZFPwKvTyyMchd6CjYbvaA6cweKDN36p8q3U8Jqpr
2809	payment	1773	1773	1047	1	1	3	2099638102978	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ29XF7t15GQNUAJbvvLywz4eGZMd3RFsfKh7ShoLhk1xCZnyff
2810	payment	1773	1773	1167	1	1	4	1416667666323	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaAVams3BJAsn3TMRYFnVXSv9AtZvLbzQbERLUyjFpNvrwwPYBD
2811	payment	1773	1773	1293	1	1	5	3947670415286	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYjkidwZXAJugWJ2K67A8NKk8mM5rVPk76dvgRGZv5difMHb5qQ
2814	payment	1397	1397	1678	1	1	2456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwvAYFJCa6ZcGcYf2rfUVyR75Y9JcEkqAW8f3umZpsRyLSMvB
2815	delegation	114	114	1483	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKRivC3FNkczHTgXxzzap5VskQACNKp6upVNzSM3r6FnXAcVD
2816	payment	1397	1397	1678	1	1	2457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCm91qAtcfbK8onZ2mz9DSRGSN329VceZGWspN3Ge5Hb7XNBoP
2817	delegation	10	10	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhnVc3AsZ6m3jijZeZz9gSAaCNQwAe6syXdCEpRuG8yjCZSaA
2821	payment	1397	1397	1678	1	1	2460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGn3SLsqtWQfVWdazcam6rbKzgu3puxNV8HK29q2SmV16MNQk
2825	payment	1397	1397	1678	1	1	2463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjn82FgYqQMxFXWtRRgxHEtyvchAsswAgiVHaECZgKxMH7TMC
2826	delegation	1750	1750	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDHZh2g7Mv9CVpKhMtPco6izkfC1CpDgLYHvLvnekXT8HxAzk
2834	payment	1397	1397	1678	1	1	2470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetdxWecNgSjLy6bSzoQiKKUHL2SZ8rrVivPJGf7XDUZX4L2s8
2841	payment	1397	1397	1678	1	1	2472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjy1sVx6sAazpR64Qv4wUgH28VfXhEVnqfBvgKPVPeprfjWdxw
2842	payment	1693	1693	499	1	1	215	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZvXHqivERgWpW1JCYKGpco7kFttanGxbz3DSgaMDDSkBHfSMRA
2843	payment	1693	1693	35	1	1	216	14480941877	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZyiW8RPCpvX5B81u4cmWkfxTHEZ9esNK1BWGTgxMMcUPtaMCbR
2844	payment	1693	1693	49	1	1	217	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZdco8M2Tb2nsu5XL2wPJuSMnVHKwqCCcthLfxUg5dCKVxijrQQ
2845	payment	1693	1693	112	1	1	218	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYezc2qjsfEEJANHbRYDnkG6HwHVKrhxsEjWG87ApDBToN9o7s2
2846	payment	1693	1693	127	1	1	219	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYeEGwTPn1Vw3KQx3JP8bM1N49oH2QMos18MKPcfoLEpagbWhVo
2847	payment	1693	1693	186	1	1	220	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYnBQU5sxXvqSzXPX64TMs53VXTgeo5pfc8zMVpX3NSPSePQuTk
2848	payment	1693	1693	551	1	1	221	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZzYcV3x8vVNHQ3Fejij8WPr9V68kzAAY1HCVDvWtdSQTuNhh93
2849	payment	1693	1693	663	1	1	222	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZDP5gHV8sPWua5twVVBxebReb48E2aHkv7JkSbYQgRDLYeAJuf
2850	payment	1693	1693	680	1	1	223	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	Ckpa5KGkBwfuiBbV9MWXv22ba61WX24UoijahKkMvEnuH2oCE8Xao
2859	delegation	1772	1772	1483	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3miRYR1sY86YUEJZDrJyp6KZHaCLzQH1zt5ca7sk1KWZMWkhs
2860	payment	1397	1397	1678	1	1	2476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfQFhPY2vzuwW9oqDuyYpshbFJbw79nL771EdTP4Ky4tiWXWv
2861	payment	1397	1397	1678	1	1	2477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTc1ksPXRKkqMjTAqgh4rXHpAGiSuMYzQXKdBMpVSP9etdwFMW
2865	payment	1397	1397	1678	1	1	2481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDyZ8tu7VsGhEZDVxUVUkpN1bv74aSvMuF7H4dKbmFUX7VFzN
2870	payment	1397	1397	1678	1	1	2486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6qvvPHpHvCm2SMVzQA2EZcEp7gEiHV8CvKvbE8iCeycN7uqc
2832	payment	1397	1397	1678	1	1	2469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsiCQGVvC5F8HEvu8n8sexyQDcznzrSuEhNhyBtDTawXwNy1uB
2833	delegation	1750	1750	1745	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPmG36HvTopyxmc77yGtas78nAivCLeqy68yAmMEtY8JaTt4V
2835	payment	1397	1397	1678	1	1	2471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDG5Qjez95WzmXgjAdxxjtYDwSxMnmMMaDJ2KmsKtLALcfej6
2836	payment	1693	1693	453	1	1	210	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZDFt8Pc3VH7uqqnmDE7ciioD98qAq2cDu7PSxKdb3FKN9Gpj8B
2837	payment	1693	1693	82	1	1	211	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYs3Nz1StdDxRt5cLATAizeUaRAM49RBHEmKPaVozePE52tovmm
2838	payment	1693	1693	261	1	1	212	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZw987SegjacdHgp2CLSh84SwGhgmTML3dwYA7F9uoCQTGqREyr
2839	payment	1693	1693	201	1	1	213	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	Ckpa4RVvHPJ9NJw88cBJf3RQQJQAbLX12rhRjdgCSK1L9DgxzvAjQ
2840	payment	1693	1693	383	1	1	214	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZ7MWkwAzgU9qK1xwELEKUbf1N8zkR8FWQDqK1Xe4VUVmGDcutK
2851	payment	1693	1693	878	1	1	224	153145890887	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZyAtk5ToSm68JC9DQ2qkNV4QC443wPyzqhnri5URS5RkMsP9Xr
2852	payment	1693	1693	569	1	1	225	49778237721	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpZUfwyrXxUsKLgrUvNGj6QrSHQsTKfypmPQm8ASvKistABAPouR
2853	payment	1693	1693	745	1	1	226	1508431437	10000000	\N	E4Z8L8tkcncDsimpS6uGASFws91v89zZ4DK2fEmwodNHSnXnZGbvJ	CkpYZG1GifiA29dJSacEpfhAWW815WuXrgi2USSDMwRKvD2Y7to7s
2854	payment	1397	1397	1678	1	1	2473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNPWhEMccai83NHSjG7371RYcyGxqkLfX7puJpELobskovyYp
2855	payment	1750	1750	1774	1	1	2	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacZcEawMU3F8WXkHmdcbGMrCkbDWYYhSzZ2voizBqpKG3cZBZ
2862	payment	1397	1397	1678	1	1	2478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzyP848EF8qGjeFCJ7atnsaRjUF1PaUFR93zNYhCTCm1uuQcB
2863	payment	1397	1397	1678	1	1	2479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAkc5U9JnoWgVLFQzQe2sPczZZhR3An8iCrgJowXAg4mCiHTh
2864	payment	1397	1397	1678	1	1	2480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnK3NCckXuz7yfjtyHCsJFpHWJKFcuUpLcVVfUfBGTgBVvDqd
2866	payment	1397	1397	1678	1	1	2482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYretdBEdjPMSXYVRPG8G1qdTg6NvoKAWv8qSpeUC1k31XAKu
2867	payment	1397	1397	1678	1	1	2483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QP16PgYj6tqv1sknVjnwjnDugqnpDaa5muNjgJ4TnM6SkqRp
2871	payment	1397	1397	1678	1	1	2487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQhReUzYZ88m3f8eXBr8v4hXzsXK7r1iYrTAJgKTEWfBUh6Sb
2874	payment	1397	1397	1678	1	1	2490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54SnfULeJpfEP8udr7xPeKtHkq9YKhK6Wi1smdBC5EoAcMbNV
2891	payment	1397	1397	1678	1	1	2506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJc4BGC6uZuW41mEHghK7Jch9RtaqghcLBwL73nqYcwQ6y5iK
2895	payment	1397	1397	1678	1	1	2510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9k2F1oEjs3VpMApJ85sXRBdhdtonevn6iNEGNfDB4fWKagsv
2896	payment	1397	1397	1678	1	1	2511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGJZDrZvPtdvTXLBWFCp4Sj7e5ax3i373v2mgNAjihATHmZTG
2897	payment	1397	1397	1678	1	1	2512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSTa8UFnHLVNMR2G1U2NssTLu6Z5nxQE8J1BwVvEtxPLXAnnk
2900	payment	1397	1397	1678	1	1	2515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rDr9Gb4MtGqkx339f8xQRQgeP3au4CnjM6qRPYohJvi1wWyN
2901	payment	1397	1397	1678	1	1	2516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeou5Szg7h77EER9W8Pkoxzrkr395xBEip3fZF3D2ovc5MJPu9
2903	payment	1397	1397	1678	1	1	2518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWzizBXP4bmhvewHUcDXagC4PmwWVtfSW5aP1aWcgtzoQxkP5
2905	payment	1397	1397	1678	1	1	2520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxPo9SSEujoDDb9ncCvbjFwNNaaLnDhsqrje2gT7kuHD9BHiX
2906	payment	1397	1397	1678	1	1	2521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaa98DPyif6o3ijnccBfrKf9ZcDQuv5T9LHL4GkNrTEonNA51R
2907	payment	1397	1397	1678	1	1	2522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDseMtxHyNQE5LurLpPzP5xoEFJHYXeNofXRq3Wmf73L3kfbqb
2912	payment	1397	1397	1678	1	1	2527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4Lxh8XRkpYn5731crUWrVZtgChNJ9hNuqNURZ5cbCYxiw8mE
2920	delegation	1709	1709	1500	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKyWkzfoy4goeF8oSdGTSGm2sXFySrBbmTRtLFRNRrujV6KR4
2922	payment	1709	1709	1776	1	1	1	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6QdmMMmsTeMkDyd6mh6hHoxmMjKBFNrDK1wooBgDbDu26Yxm
2924	payment	1775	1775	1605	1	1	2	10000000	1000000	65535	E4YfGXnruh7P1EnUejuaBsFBhThYTKgbMEcPHYXCob6WvFN87mmWP	CkpYthAVS5vGkqMAV3nNAY6ZveY7tcnkscEV1BWKRv4HtCuGWYpb7
2927	payment	1541	1541	348	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxBVXtj3Zn1jKXdu5JiApECX5a37ZGetiy25TTc8YNmJs4uoT
2928	payment	1541	1541	1777	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1U7hXA6cw6Hgn6tfvRWhSneenV8SyjSD7rdAHEefixRyCVRg
2930	payment	1709	1709	1776	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVZWCN9iP1jXzojEuzgNCMu49C25qbiy3yyxUmiuzNKet4yZR
2931	delegation	443	443	1483	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJM8CBt8T4dpsXCYEErn1bS8dGtVkYC2U9J6adPZgwr1T95AQX
2872	payment	1397	1397	1678	1	1	2488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTaKKbjYtdytyWqnanTc2UpQBadJnYYcZLCitZJQtfUSPdSuE
2873	payment	1397	1397	1678	1	1	2489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPxv4pUZtZoUxvPDKJBdDSWp2ozJ1LxdXPVjQZByrzrz2Fc5B
2876	payment	1397	1397	1678	1	1	2492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnJHcdKfZFaE7AssB6JhH56doW7Sj6BDhDjPqcnsqVS99r3Y1
2877	payment	1397	1397	1678	1	1	2493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJbRybWfrTMAzxG2b6RWMmvmhwx8zGPRmuqjMTGgMP3jWo3UV
2878	payment	1397	1397	1678	1	1	2494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpprp1pYjkrU74u5DnXyd3SdcYazhFS6pjD8hRifPMJANsFSV5
2884	payment	1397	1397	1678	1	1	2499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dh8Zc5NhzVcQCYrggX3u4f2GQdSdj76mM4shv9hkWFPSYaXL
2885	payment	1397	1397	1678	1	1	2500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSpkHeqoT28FMU8Kw8Ygwgc7d4vJL8RdCQAqQB9szApMPUsc6
2886	payment	1397	1397	1678	1	1	2501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKktFnvME7bbpHGcUvDkHdu38frMao1ikYz8i6xkUGinnXzXo
2888	payment	1397	1397	1678	1	1	2503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUtbordmyW4T6qHb9qnms8sm5LYAoBK5cztsQUjeBJrmzvBTF
2890	payment	1397	1397	1678	1	1	2505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnvHbz3anSzdNfXkNbDkHCcYXY8qqQ8Wr2BjcRiEf3XfnNCoS
2893	payment	1397	1397	1678	1	1	2508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvUdjo9N2WjPeT2yDiMjEuNpqCaMwUePqKLxcL6DAHU2GBE1s
2894	payment	1397	1397	1678	1	1	2509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1tp3s8ogChVyTfu1jAYV92Pb48go4oivbsU9A2RnvfczWD9r
2899	payment	1397	1397	1678	1	1	2514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeFhUHw8nYvGKRYD8LqpRkiDoPKWrFurGc64jLbM8usGtfsDU
2902	payment	1397	1397	1678	1	1	2517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75Xwir1Dd1zbwogpyEHqY3cpvowLjRfhE7o6s9WQbU2cy1zxg
2908	payment	1397	1397	1678	1	1	2523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUQ8WvsSiyqxXjGx2hFQ1J1GsFru8c6eQ7ig6miKpHNYhaE5o
2909	payment	1397	1397	1678	1	1	2524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB8eUukauBHrjXe6Af55fiWqkCqS8CFuf9u93SmXyq7YJQRZcP
2910	payment	1397	1397	1678	1	1	2525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHitAU5RepjXeaujB4sF136kWwCpVkqKGThxnVY6eELmpNJmk
2915	payment	1722	1722	1749	1	1	6	3612000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpVzpQNZaUeJZr8T7oqhbK47in7aVYiZ3uFJSzL94iRxgefak
2917	payment	1749	1749	1764	1	1	1	3612000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXa3g7dLspLFSSZP6b4oCBtRxGYBc3tRHLzT5LbSmQMJQdzZX
2918	payment	1764	1764	1749	1	1	0	3611000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHqC4kfvUKe6ExQKhioNfquaFTwr6FkknZar4aqg7PZ6kq6kV
2921	payment	1775	1775	1605	1	1	1	10000000	1000000	65535	E4YvpVCiVwvnR3seivfBM47ez2CLg6iMEVfyE3qJVfLMivzBNpn9W	CkpZjvKUbvqAfPmYaM6mxMDsqDuPVtXv2b3ryBo755Zj6tAwBBiV4
2929	payment	443	443	530	1	1	1	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa96mEaW6uwttgmNv8KE4Y5nwmH7QU4U8A2AcEZmMkJ4zb3xvHv
2934	delegation	1776	1776	1500	1	1	0	\N	11000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE3Q33sgbdkFXTxnsTKjUT5zQZvzT8dVoJJUHP9NvgZccMH4F
2945	payment	1397	1397	1678	1	1	2536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzMfC1QQTwV9pd1cdrBU6q7ucyJQEsBvtsNTVbrqKMa2DtFbn
2880	payment	1397	1397	1678	1	1	2496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNyhyJeWRMipnvPRgj8mNssjmt3JCFqPybyVykHfWy4RwL8S9
2881	payment	1397	1397	1678	1	1	2497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRYqCKBBeKZ5gXa1TRjz97GjiUGj11PCLqag1tBPm8yPTMoz3
2882	payment	1397	1397	1678	1	1	2498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPFyELggdVcVWRwXGovWMmXARq2mqsAZGoYaQjqc5wHQFNYcf
2883	delegation	436	436	1396	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPwGeb2sNPkM64dr3PxThFXjyJDkgx96E4777MthPeoXdqtCa
2887	payment	1397	1397	1678	1	1	2502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5ELszhvQg8CjxynTuwTaa44H8T5Dt1mEYfc6cPVynaUnzf4f
2889	payment	1397	1397	1678	1	1	2504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6aSwxt6m5DYbfwKb4vv3MZTaQ1ZaAgothjB1sWFMeiT6fnf1
2892	payment	1397	1397	1678	1	1	2507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2k5crgz43J6pE1JxekQG8kt7emMuGbqxhmabMNA7r8kDKYv2
2898	payment	1397	1397	1678	1	1	2513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznNutifeX2Q2RLudZGkXGb2CPZhdewri8UaLH8RPHxCtBizHL
2904	payment	1397	1397	1678	1	1	2519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCZ5HSuczi4QuzCG2nExaUqGNckhdzqtk5Qutt6REFPiwQ1Th
2911	payment	1397	1397	1678	1	1	2526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VhWcihTHchGZC4YKrJZXWAy4mYjAnTvWFrbnvtLkSa2naRBP
2913	payment	1722	1722	1759	1	1	4	5761000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQUqmj1DevfM7YZvjVzDrEtfUERmMcGh6Luj1ULiomSVr7wux
2914	payment	1722	1722	1764	1	1	5	4320000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZec5UbEHeC9s65xV5oV3KpeBH3cWnqZJzfm1DiWCpDmqJ6JkUX
2916	payment	1521	1521	1775	1	1	0	3000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtNW6v4tNvoHiL2HamFVPb2647WufiN641S833h7pMUQKRbmz
2919	payment	1775	1775	1521	1	1	0	10000000	1000000	65535	E4YrvzrFbtDw4bc1ZWr274D1kVZ5JUvRrqYzmttAqXYHeWGZZTrYJ	CkpZPGX4sXTRir6Q2cPP4pkrbE6QFLLYbrnwmEWxySYGxrGKUeKiL
2923	payment	1722	1722	1749	1	1	7	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZetchph7tfqAbagHpuT3uTbiwUmGr9awgpvusdMrQJFLPkEr
2925	payment	329	329	11	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXbkRMeW3nWzGLU7H4cZppWbs56GnU2nQfGZk98rA3qJfqmh3
2926	payment	1775	1775	1521	1	1	3	20000000	1000000	65535	E4YfGXnruh7P1EnVFLggidb6QqVWw4rCGTxfPbwJ1NZ3KvY7emduK	CkpYV2gGPCayCf64ZD5cYXDnEqQNtAGwJYRZ4htHRpGW78ey2BJTy
2935	payment	1693	1693	1778	1	1	227	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZZk7yWrxmfVyPJKbQ8yWUqmkCCxZSFkr7JmH5fSPB2uGsc9L2A
2939	payment	1397	1397	1678	1	1	2530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmRWgpULX1nvtc6oRFmtKw9NJuBi9KvPEebtZfh9jZ4GWL9sGR
2943	payment	1397	1397	1678	1	1	2534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgbF5fRhXaPyNP5py7uaHyYA5u75i4oarojSeT2STbrEgu7Y2
2947	delegation	1778	1778	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAxF7MdvvabaE1zNKPDcUn8YTpNwkbpQpvqDnZDnYFkVo6FLa
2948	payment	1397	1397	1678	1	1	2538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBaTS2iBWePooCefjA2qF5ZcZSeHYb5Dc8sYpNaS8jZYjM9uzm
2949	payment	1397	1397	1678	1	1	2539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjcj323zSf78WFH8adHrZGwMKzyt2wBKET1FtnS3Ci2zJDchz
2952	payment	1397	1397	1678	1	1	2542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4bFUxNzczYsfchY329gwD26ALj458XqrBm6JHq9JnPSxhHPs
2932	delegation	530	530	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwynTCYS5Ny2c5Vu7DrXLeyrLFTsGoJpJRfQLKv9VGN5Adt4Cz
2933	payment	1709	1709	1776	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3nSgLHwqBtYYfFoTB7UaVPmmhdTPonBJgjaiyhp7YPYCyaii
2936	payment	1397	1397	1678	1	1	2528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxokgKpfpkAebV3QQ2Ni32tV72Bgsozvk1aStA3CxZRaS2uXFH
2937	payment	1397	1397	1678	1	1	2529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXz2BbJewMbGsCBczXo8oDfa4nn1xY3ykgyUTsdTEdiqRJV1pf
2938	payment	1754	1754	1779	1	1	0	3000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrV6qBHRvaxV6d6xs2LCZz9HzRJeZPr6wxfeU7hgsSK6PtJ2p
2940	payment	1397	1397	1678	1	1	2531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2EZFgyz8enpre3aBrudDgW3SNGoCepqtD3SuKZvSgroqGNvw
2941	payment	1397	1397	1678	1	1	2532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKwRkBMf7HzS6AGSKnnLdjxbcPtFuKGV2QpwDa6jACX2RhTWQ
2942	payment	1397	1397	1678	1	1	2533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qjHBHWrb46KPQyTpyjdLXh2bundCH1CHqzESwX9VQYiAqmd8
2944	payment	1397	1397	1678	1	1	2535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9R2NrWNKghcTsfwugeEMTWpt1Szr32QSwPsgQAC52emmGd7J
2946	payment	1397	1397	1678	1	1	2537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ5vvuJQQGA4kAYQAVNmv3qmrbU8Aq6Lq2CHSrz6JSwFgVJN8
2950	payment	1397	1397	1678	1	1	2540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyss25ohVV8tznmZEYrdYj3TyNHEBy8aoL4e22Yw7F6eDea1zE
2951	payment	1397	1397	1678	1	1	2541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6j8WitTRA4qg6gCf3LkGRineNt1PQrWdN9qc2uFEKoYoKRX6z
2953	payment	1397	1397	1678	1	1	2543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmWVEM67XtNNCmk96wws3sLM9sEGQeLzrkRTuGgBAwGiRhEii
2954	payment	1397	1397	1678	1	1	2544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSA5qb6dUnqnK9kdSe9vTMXdYc1Uo1HWvCHWstWc8cn9pr1Bo
2955	payment	1397	1397	1678	1	1	2545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHAfi1NPBVamxgRUwRHNCrMvtKQcTp32QY3cTM9P1qedEWfRu
2956	payment	1397	1397	1678	1	1	2546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcvsmgNdUnAMN1tyj2vDxAeCB3AkViq3EoHNwmMKKBVoQgvzZ
2957	payment	1754	1754	1779	1	1	1	200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ykdXhyxRAoazGAQTRxDsonbR9ym1jdbUPbGb9m2e9NRjR4so
2958	payment	1397	1397	1678	1	1	2547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j7huTWRm84RRE78qKdK9fNnLUDTJEfv58eBDMqGemFWUeRdx
2959	payment	1397	1397	1678	1	1	2548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE9ARbUN4wdBYsveG8kgmDuPY7KD85iLoFjtuf9mSSqdDNGc9
2960	payment	1693	1693	562	1	1	228	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYzDYX2BLMcywfiDhz52Z3qBPnzd89Z5XSgFutPz8CMsYTSvwyZ
2961	payment	1397	1397	1678	1	1	2549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNgt4GCwCBTkAyXhz8eR2viCSXoAyRf5wkApEExHB4egKMJM1
2962	payment	1754	1754	1779	1	1	2	123456789	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRjGRQzY4wZDQpdekTbDr4mUEyGkQWjNgNGEJ5vKdezwkqjpF
2963	payment	1397	1397	1678	1	1	2550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncvaXtaC5vf3icg9VMX3ugV9BDPxGsyBhmCxEVjPRkYNDAGGU
2964	payment	1397	1397	1678	1	1	2551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvMPnbbG1QBQspYR6GvCGERshEmmSLtZURkFk5vp3QXSbw1WH
2965	payment	1397	1397	1678	1	1	2552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FvkimhcHjvGwQ9kMouoa5K2H1VHUSXgRs7itX8jEEYJPPemo
2966	payment	1397	1397	1678	1	1	2553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNwRaykNZKGV4u4Y7nwdtQFP3wreivxAxVNAjrcWqAm192FwC
2967	payment	1397	1397	1678	1	1	2554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGd1sxcdzxLxzhY7bKkQDnuJQ8BNzmxGdnH1S8SpaxEdwgdejJ
2968	payment	1397	1397	1678	1	1	2555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezsLuorWbzpX9krr2aVyRKk5ASwvtpbcC1w6Z8k8QUdKty3fP
2969	payment	1397	1397	1678	1	1	2556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaYs1G65fLVoPBYYQf4JUG9ukTk4C826Hj6mEnyrQeNV7USRS
2970	payment	1397	1397	1678	1	1	2557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8X31NYQeTTVtGNjybkzA21ghqGrm9DK2RZ6ak5eRW58LDNVFj
2971	payment	1397	1397	1678	1	1	2558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7y7dRkM2zpRPyqbJnN1rsSFaqTzPTjrzHVTd5Tp9GdT4mEcSF
2972	payment	1397	1397	1678	1	1	2559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARVLxUoggj8uoB2gAMBACa8XjmGrjPLzreUHzy74xu59WW5XJ
2973	payment	1397	1397	1678	1	1	2560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBn4c1CzLEcnRHYaGhtssbTGNr5kA8xprVmyGzR2ngYbuypMa
2974	payment	1397	1397	1678	1	1	2561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDqVMAtsAPBkPrn5w7kDk1wMTjRiqPirLPLM7hkFxmv4o1fAd
2975	payment	1397	1397	1678	1	1	2562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1w5gRpcagozXaimhvd5e23UFFWbYbhUcTe95E7iWg9TH6PT9A
2976	payment	1397	1397	1678	1	1	2563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMaxyLoEQzP1mrEixNeMYtQwMY4FfMjMg4xJY7WkekqnCosHL
2977	payment	1397	1397	1678	1	1	2564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqRdyY3jfaJCYS8hbdR3b6icEpEfyANfGhhrJemkoGkpsKk7N
2978	payment	1397	1397	1678	1	1	2565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5XGX7WLFPHJucRUuYPjkDx9DY8774uoEJQuoq7qcKLrfA3Bk
2979	payment	1397	1397	1678	1	1	2566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8dNU5iaY3nqZzrVkaHdUo5JhbLURXjE9M8GZbWkNXbuNhaBb
3000	payment	1397	1397	1678	1	1	2586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVTM9o1VmchWLFAkKRSVgY8MGh1jyikomdbYiWCgUKM5jCCTz
3013	payment	1397	1397	1678	1	1	2599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjL4nMnkAhWaxEw5k4shjvZ5ADtMct2DAMU1x9fCZLzwVGF9V
3014	payment	1397	1397	1678	1	1	2600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqE1gJp8ZkZNJjP2H2xnV5gV8qRYAypVkVcjyLPpPQ5E4F1k3z
3022	payment	1397	1397	1678	1	1	2608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvGzmJNZzRaeXjZMQ7AJbG3vUj8jfV1HmLASfy84WpBBpyRs9
3023	payment	1397	1397	1678	1	1	2609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rpU2uf8i2BUpoQn6TLBDPj5Czn1Pb2HkzynVfP9A8cYCnneD
3026	payment	1397	1397	1678	1	1	2612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiTxn1QHgBB63SaAys6abz55D3t92npNmKMp15orfdy2agXYs
3027	payment	1397	1397	1678	1	1	2613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSf5MLkCrCwfH5gbpUP73K6EybUvCsteY8nt1oQ9soaWHysnk
3034	payment	1397	1397	1678	1	1	2620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMCxA6kX6wumdf33hDioVpgnp1xhsaRRGLQZXHX7WwREPiMJ3
3038	payment	1397	1397	1678	1	1	2624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fWHgDbtshaKbtA2aARk7YAqyyRLBiRpnnWsKkHcst2LWU6gU
3039	payment	1397	1397	1678	1	1	2625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJQn4og91qeK29xsAaKPMcf1KFrsrKowohbwtQNz2FiBVU6Ny
3042	payment	1397	1397	1678	1	1	2628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrhTk7buYu9VqvtNEzKbqEL64ard9YuAEmRLcyNqnZNhbSXfbF
3046	delegation	562	562	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeoABGJdRpyt36UDuj8Bx6EdhYVDeXEBKHy6tauEn2G7yhUeen
3047	payment	1397	1397	1678	1	1	2632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjd63or9ejscWGb9wCyLmwLpbcw8SBrERUgtqNSSaNNejKqXRw
3053	payment	1397	1397	1678	1	1	2636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBncmikf61Tv53KaUhoE5rh9ixqGgaN2FYctsJcebDjYpcZ755
3056	delegation	871	871	1765	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPsXaHdvP4E8aG1sG5kq17rqvPE4YPfVciYsYgrPQYkrvoDKo
3057	payment	1397	1397	1678	1	1	2638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61rod7NRfNndQzgJ6zytBdJVjTHAu2NXmBDjmJJcxmqroizze
3058	payment	1397	1397	1678	1	1	2639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEaxdMEgpc5PTjBfj18dPiNzgMYUHtRLHi52iXSmBtKes92pY
3059	payment	1397	1397	1678	1	1	2640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXc4qTGcwX4ZdAvnWeuJ4hkZG9dDWU8yMDEZx4t7egphXcqDte
3064	payment	1397	1397	1678	1	1	2645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV17EfJVxJC5cX3C4VdzBzsAoTjECNomFo1L5RPfKjTx6db7sT
3068	payment	1397	1397	1678	1	1	2649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraMbfThp3Mn15CAWXT4tUt2PiHQ4QFvagLjWQ1j7Y4aNetsbr
3072	payment	1397	1397	1678	1	1	2653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrQEEmivDuKJzoXf5CgCvtanhxYQwXTQWUbPsoGpfqrMR3cK1
3075	payment	1397	1397	1678	1	1	2656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXHqVKQ1ieR7UaWhT2gMX2B9r4f9GuoEPWXWcFVJ5cbNYYiAP
3076	payment	1397	1397	1678	1	1	2657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfYgGWtDNsMX8i6W7RGufgmgoh66ybZXSk77sJVeKxMHs8UaF
3077	payment	1397	1397	1678	1	1	2658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8AdJ5UFgmwzA18ZLQxU3zDtKSzPqhFsdkEhLCT6oLCcJWqGj
3078	payment	1397	1397	1678	1	1	2659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbcFh66GCzjK9tCejsaBNLMNq62RVVPfZcXtSqJWitW6E4GFq
3079	payment	1397	1397	1678	1	1	2660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcEyx6x6Am3L7YtUwEG4kPnfZhQje19MMRe96UmegYBYSbmcx
3080	payment	1397	1397	1678	1	1	2661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZboGpafCNjB2J4LmCxuVYMA6tMhjHhj7sirucJFzJ73gXajfuk
3091	payment	1397	1397	1678	1	1	2672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpwu5BHXJMAAvPLjzKZp2gpx52XJNfDBd4yPfCXkdt5zD1ZPy
3095	payment	1397	1397	1678	1	1	2676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPALKRSyf8BE2DwDYe6w9Vt6ktpZq8hGJjjGb9UhNBFvdo2Sg
3102	payment	1397	1397	1678	1	1	2683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLANc8R7ZzLkL4X1MbpSryY9t8hJ9CQfhDaME7W4B5xDFqrKp
3103	payment	1397	1397	1678	1	1	2684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbkGFpivJ44To3x9WM8f7T5bVprUFANoUmGjeYbtyn5devpHE
3104	payment	1397	1397	1678	1	1	2685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEb7Mmrf4AYuHAPdisaxHwoiK2N8QEpNDTzW35FCU7qF8qnfN
3107	payment	1397	1397	1678	1	1	2688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDdHtu4joQMyEB2Qo2g7naJ8YHWzBWvaUH3xVbVCK5nXyXnwX
3108	payment	1397	1397	1678	1	1	2689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwsUZvjcUhrKN22YK8EvjLpXGBwJkHDQ8Cbp8GZRfVVi5FvrX
3111	payment	1397	1397	1678	1	1	2692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofjkDWTFRFcBDGN46T8wJ74QZDrAbpMj5eJeThsKL7ZtxKBZS
3112	payment	1397	1397	1678	1	1	2693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJ1bXM6S2pNrBJjduNjXrzJhCeowqXDTm6Ky9aiB1mf746h66
3114	payment	1397	1397	1678	1	1	2695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgessmdMM4d8TW3wLqLd99hVBijvAk1znfnLgGPx9x2pS8Hhva
2980	payment	1397	1397	1678	1	1	2567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeMpjhrKMqDTYinRUEmEJxikyM1zB5hobe7SEWE13KNKmbPu4
2982	payment	1397	1397	1678	1	1	2569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Th8dnL33bxT5T94pomxAQrsH6v8bbQwGWHyg3T1itX2Ju8Wa
2983	payment	1397	1397	1678	1	1	2570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme4emRsVfpEyiYiY6bNMyUZko5sDBM3Yd619jynG688KiZgoJ
2984	payment	1397	1397	1678	1	1	2571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZordEPncqn7FeEJrSHgtjWoP87B4fa8xKmfsHEmza11r2bUHxo
2988	payment	1397	1397	1678	1	1	2574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGXpKxRrdE8wDHdQRuHCgoPhBsYKacW3UXeAy34hb458ngQ7N
2989	payment	1397	1397	1678	1	1	2575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqPgvdonztjgTVJM6hD42u3EtsFfR4j4HzqDb9KvjLG3bbp3o
2991	payment	1397	1397	1678	1	1	2577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLAHfh2tvyQyJ4TNaXrRQ5fq3wBMwU6mfbbcdhCfFq8LBeWvu
2992	payment	1397	1397	1678	1	1	2578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzv7gxiViSLAYLxcCRFJnmcw6rsyX4RYxnrBDB8yZgDg9oDNv4
2993	payment	1397	1397	1678	1	1	2579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6hhMhLiXuAtDXio9vjE9XKHVEmZKG1BE96jYstrajQc35mpS
2996	payment	1397	1397	1678	1	1	2582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFDJNgAmJAvCtohHBTZDfmQ1xVqVvrbYVUVhHJX4iebXjuHcp
2997	payment	1397	1397	1678	1	1	2583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGd1E7i72qpHYJpg3hzbVKynYo4h9eXNngGbJXY7yGeA9tayM
3001	payment	1397	1397	1678	1	1	2587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCZmGuxVCP3v4DKLQk639WJtryAQHgvBRKmTfJXrDFk3Yq3Dc
3003	payment	1397	1397	1678	1	1	2589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesxXRwQFwFChCoKKomuSJ8h5exkhSBhbRs9Yu7SfKKaWs2Ph9
3004	payment	1397	1397	1678	1	1	2590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbWu2ft6p8X8JQp7ZoxVZ4irDersykaeZZ8RGPWRwGQEU2MJU
3007	payment	1397	1397	1678	1	1	2593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LCiP4qMuHD62EPo9bVuekAjZLCq1oJb4KSzSis8c5jfjzcQm
3008	payment	1397	1397	1678	1	1	2594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkenRXe3kPYemPNffy8cdeYfCGbLz7hehxGmnujtKe9ghiHwF
3024	payment	1397	1397	1678	1	1	2610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjKaA8Ah4QFwcSaiDne8thfStShKn8cR4ujcuTBP4hRQ9Rduh
3028	payment	1397	1397	1678	1	1	2614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFdPjGqApd29AmtKW6Bhh3TrxoXwSpNsFymMAxLSP7HsjEHAP
3029	payment	1397	1397	1678	1	1	2615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CW49sccKcuTiVj9yXt62Ksr46BGwasX5XAuDWHNVY3Krbb7z
3037	payment	1397	1397	1678	1	1	2623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThR8Wi1Z4AMadWTDJp9LXDiwkgity5qk6A6e9pfRtXUAJ6cZb
3041	payment	1397	1397	1678	1	1	2627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3Prva2CfQHAmjBVJAASuL6TKibEK5TiJjjt33fKkHAaHr1UC
3050	payment	1765	1765	871	1	1	0	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZASqxxnUZ6p2x4rw1V1L8CT9cruzzUuFEMHcvQ6Z4RtdRxYt
3051	payment	1397	1397	1678	1	1	2634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpp7gX31gqKQht1zKq2ioopoBcp1pea5GTrz1yxzzX11akznAP
3060	payment	1397	1397	1678	1	1	2641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32SQwgkfZhLQPLePBjtkUUbVgFtKfKxcThMQ1UqrcuFSHYFKW
3061	payment	1397	1397	1678	1	1	2642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bVzZmyj5hD1ffAXRcgbbZE6kUqnGbV31WevZQL5EQK7VWoUd
3065	payment	1397	1397	1678	1	1	2646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMUATziyMTTEn69tqJKiAi7Yf9eKWhuj5pRKYz7C8PyrFAJEd
3066	payment	1397	1397	1678	1	1	2647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E3DDGzTiKAvrxyq5xCV7Rg5uiJpbWYnWgJxkHSGCRMA6PwN7
3069	payment	1397	1397	1678	1	1	2650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAkbWZQ3zz4hQMDKkabgdWoRkZaVXi8GQoTKYa8An1F6a1wz4
3082	payment	1397	1397	1678	1	1	2663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJLDfGbPBRJReFFpP3ACajEPKkdfEY8ZoKE3diBHYXtgLFc15
3084	payment	1397	1397	1678	1	1	2665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNtdmcBoktszYJjJbnwqqAPwysdvcawfxJhMJHXU9dhND8hzj
3085	payment	1397	1397	1678	1	1	2666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDynBkZFNHSVzTF1Aihdd7vB9zPpAapgEzMADipMpQYARbYTB1
3086	payment	1397	1397	1678	1	1	2667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZk815pt63hwvdfgjeZHfS52h2HvD9UyrKQXJ6ynbkUVkvSkXG
3094	payment	1397	1397	1678	1	1	2675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPA3so4h2BdJDvKdVcBmhauwH6eij2dDRCk2p7B6Nt4KGocjnR
3098	payment	1397	1397	1678	1	1	2679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLQXWMffoQDnziibGiocSR6JDhuWhPiVx9p1tErWE2ZV19T9g
3101	payment	1397	1397	1678	1	1	2682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RpbeAkTAAagtYSBKvmHgwTeyWMR3EsVqv7A8kHDPbrsg4GJM
3105	payment	1397	1397	1678	1	1	2686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBtSSKEkMgSxZqk6em3Z1G1jtGgkTwA8sxsNNgvhehypZo3f7
3106	payment	1397	1397	1678	1	1	2687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG912pScqJALm5pCAbs4coaUJfiawJyRdPiR8aSwpSQYYi4991
3110	payment	1397	1397	1678	1	1	2691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEzJQDvrUc4kDkJN68Pb57yUXh4eak54Ugrwr67DBhoHju6YN
2981	payment	1397	1397	1678	1	1	2568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTsEVKtZbHRc3oM53JqoTxxSGEeAd8TxwBrJbSi7VKSS4tYV3y
2986	payment	1397	1397	1678	1	1	2573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmkGpJLsydt4PbNiHNitPEns1d1whv3BohqVfDegkPYRe3tkC
2987	payment	1266	1266	1754	1	1	0	5000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5PYMZdGLdUYBF9PE3XWHSfrX9WJDW42nEH1zz7KsuDCg6JQf
2990	payment	1397	1397	1678	1	1	2576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfwD88SskfNCLE6tiZGkQyU61F8bNnZP4fGNMXoPJ3i2VuZsZ
2994	payment	1397	1397	1678	1	1	2580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5aQi5WhevfNU5VHm31LLJnrrCMZS8eAdqadDroU4yXCsuzva
2995	payment	1397	1397	1678	1	1	2581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyaccUEYrQUbv8wxTkMjEnrBHXQ6HKVqa842GqJBYwNx9rKtA
3009	payment	1397	1397	1678	1	1	2595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdtaBAcRBQER37actoMsh4f5zMzZDDERmRBPQyMSD3zPzPE6M
3012	payment	1397	1397	1678	1	1	2598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dGW6YpjsxiURpZrwc5i4W4hCVJiLCPdBnF36833T9crxyZGP
3016	payment	1397	1397	1678	1	1	2602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQ39x6z1qocfDWci2bxTQoGS6iZbB7RxbFrYKWvsCSbLqpXK2
3017	payment	1397	1397	1678	1	1	2603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtACuLaBw6AbDfLZwhMRRaR1YC74kvBsmiNu8PAm8V3yvgoaaw
3018	payment	1397	1397	1678	1	1	2604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgLq5SjG6hGHPx5wBVJhCYWCXazjf1KyLZg8Dff6y8KkAEc2t
3019	payment	1397	1397	1678	1	1	2605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdHEhqUrYBYGAHDtmfN5DhyZt7hJLuzahB1g2XqWMyaR21FM1
3020	payment	1397	1397	1678	1	1	2606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCR2fMQJLK39JL6f5CooPwaxoQfkgS4mErf8zhoS7nPh5RDc5
3021	payment	1397	1397	1678	1	1	2607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUTuMnL49XckQYtcAjmKThKKT6wwFr3kf8FRAgxPFHrxNMBkS
3025	payment	1397	1397	1678	1	1	2611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6siRMb1JDHn8zpAn7e3kwHmsCd5zR2FntBAoDfTJrAjqbh9u2
3031	payment	1397	1397	1678	1	1	2617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWghJBhtwgRBcYph15Nm5dCxAavPXHRBpV4bEjJCmHvuVWAqsg
3032	payment	1397	1397	1678	1	1	2618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwzpPSt4HVsojCWcQM2eN5cXaPu8e4Uco3FPY8PVkg1arwgCm
3033	payment	1397	1397	1678	1	1	2619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaEvmQJzEPWTXAsNmDrogTPWevFTjR3UQQcZnrr1NxXZN5gKwv
3036	payment	1397	1397	1678	1	1	2622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FovBBvJJLzFKCV3qLCxsJm1nMfttsb7cwbbXZE951ERBqxdA
3040	payment	1397	1397	1678	1	1	2626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaC4uH913tF2y8cmLe38jvawkXLg42VpK4bENAK34FWD2BJcmS
3044	payment	1397	1397	1678	1	1	2630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZasNJAVbN9S2aNCMTJVMacsQqj71CFVDKAvy57ysg33tW8p4P
3045	payment	1397	1397	1678	1	1	2631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkf2rVYb4UvVA4vcapC3iJXZaSW5QxtevzQDKCekRwJFicoTT
3052	payment	1397	1397	1678	1	1	2635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUfU1hNrGRSKpu52wHh6sQYDAYLqtY1YMNhsPhJgcVRpG3Yqn
3073	payment	1397	1397	1678	1	1	2654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmqwXDoYenWaoqSqv3yS5pH2AG5VCo58NUqSo3868M9r7NY4v
3074	payment	1397	1397	1678	1	1	2655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9F8EoDawwRa7bfiw15qtaazWDZwTBRRG51PiWAXnzSUGd2BbE
3081	payment	1397	1397	1678	1	1	2662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUAWyVwpWw3RrZMzLtvkJM44o7ERnX8psJimeqozz4JoJQ4wQ
3088	payment	1397	1397	1678	1	1	2669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgoiaAKEwriBDhtfPtBn4nZET89R9vuDACuH6dqg6D1bXKo6t
3089	payment	1397	1397	1678	1	1	2670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJeDRjWDDbpAczE4S4sjh2vCcHKeeYrwJD9PbAMYL357x3Wra
3090	payment	1397	1397	1678	1	1	2671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYTsDztiCNMs8Hfsq911dEJynHpQ2yAsbpYC9TZgheBVorpNm
3093	payment	1397	1397	1678	1	1	2674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQcamYWwbPw565rQEAqkkjBojpSsNEbAcyyAwytimtCFyXWpy
3097	payment	1397	1397	1678	1	1	2678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1WCjb46RTG5zfyDb4TCrxCpbJdkCRnVHHfhR4UJ5h9s5sk38
3109	payment	1397	1397	1678	1	1	2690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEw7ZEn9m9ai41NUWuf1pQYqjuiaHq3zy2fxrR9XJNfEUts7b
3113	payment	1397	1397	1678	1	1	2694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53xzk3fTnRxRAy13rkJn6rzcppkYhsLzmySDNngLiZKi6RRzt
3119	payment	1397	1397	1678	1	1	2700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJc2iPhTACzLDjsqQj1n6oNRpQhuVb5UKqjqywojCC8WzNJ7A
3126	payment	1397	1397	1678	1	1	2707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXRLTNuMTebP2LFAy6uTUEn43tkza6emMEt7YkG2bwUD7eyvB
3127	payment	1397	1397	1678	1	1	2708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2anHWahBAce5yEAAWrur4tgSBUyEmxVr4mE36SfriFwFeSFZ
3131	payment	1397	1397	1678	1	1	2712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDBacNnm6cXfyuVQcsmi6R69zSnMRcFoU4YDWUtxbcWrTgsyy
3132	payment	1397	1397	1678	1	1	2713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaReeKczkHd7SRqaGkdEvfQr6psih4xNcTRmmFkRiW8MrKktaM
2985	payment	1397	1397	1678	1	1	2572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxaBUyU8nDZyd1Lyuws3y6Qru3gBazuyzt6x3NpAPcfufowqs
2998	payment	1397	1397	1678	1	1	2584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2AzvMKZJQ2RHTzxFvmM1x81JRoCrwSHade7BAVGocSA1iq35q
2999	payment	1397	1397	1678	1	1	2585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiC6dYbgzscf7NzqsMHWink4EmCqMWf7AM1SkzCQkNsB9btwn
3002	payment	1397	1397	1678	1	1	2588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbJ1tHKWchBL7giWNTRF2ZicdxANkfZV4wjfYpGds9aLjZmxut
3005	payment	1397	1397	1678	1	1	2591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe94H8zfTXP15ecoDyLkmJ6NUx9BKAyjvNERT8vxgWXUk63qEw
3006	payment	1397	1397	1678	1	1	2592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZS8WGZskBAmV9e3g9wDPwCVS1VeofTKUVWnUSkgn1i7jS28Ud
3010	payment	1397	1397	1678	1	1	2596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HpbqCGtQAcBxM7qxUHrwiMtLMNeGepqMjJ81BSaEkyfPGhiF
3011	payment	1397	1397	1678	1	1	2597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ625AhYdn7evbnLGkdBW4WxHQAuWr7JFomNwwi74Ckf8T9MVfk
3015	payment	1397	1397	1678	1	1	2601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8VMsX8VqMpTGPqXuXpnk59impoairJf44pQ5QLXYCXJX3eW6
3030	payment	1397	1397	1678	1	1	2616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwt7WG1PFmR27VVPZYj3yBhdnz57rLHv2v4fKrJ7YQ9iHPmwa
3035	payment	1397	1397	1678	1	1	2621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ2XEhV8jaT36vWPDMJWAK4pBSZfuTx8bZsQLR9RSRsyDwh1y
3043	payment	1397	1397	1678	1	1	2629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDC2xbf9rVHQtFg1S66V1fkNC3hVMDbuL72XLTQCymWBmS9Yp
3048	delegation	1780	1780	255	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcKs1xuohBS2tukrv9aLYwC6CVL2CbVDKyHC4AwzepAVCNU6W
3049	payment	1397	1397	1678	1	1	2633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuHQjaiWJSo4cd1wpqTVy3kxgPez9EeU6kaSTfrF3YkJZ2uma
3054	payment	1590	1590	1781	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8QBewCRwWcQeGa3PZvNnDX3snsLPQvS35THKsm5Jfhcxo3gU
3055	payment	1397	1397	1678	1	1	2637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8c1vcXRfhYxePM6drxfuQyyYGGYpQpTAQeYz9LraypzFZPGxd
3062	payment	1397	1397	1678	1	1	2643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zAKdFpErvY3ZqSVgPCp9ZGEjrBQ1XpgR1Gzi3qTSWEauFhWi
3063	payment	1397	1397	1678	1	1	2644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDGxq2qxkRw65gYWSp9TSu2YrnLQa4TPBjsGgKNrVdgtPBC2J
3067	payment	1397	1397	1678	1	1	2648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFnTnTQfaEhcJaNtWsUchMNjZW3BiS1sJsLkN3Uvn5kgsXN5d
3070	payment	1397	1397	1678	1	1	2651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9BqyuTT5JMp1oDb48gAJdHnavcRgfVFbaAUwLjwCCVvnFwKq
3071	payment	1397	1397	1678	1	1	2652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9PiUU4UBcEC2WLonJqrbn1Jan8CsRnXfaTrT7NnCtsnnv97C
3083	payment	1397	1397	1678	1	1	2664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe48cvh2h5LGxJPFuDjE6AFYPvsFitKPUknCa7jir6ZbHJZzUt
3087	payment	1397	1397	1678	1	1	2668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqdvDREGwYL2ExoYAk3GkXXf4Dbi6nChiiS6DVeZDB2tDP4fo
3092	payment	1397	1397	1678	1	1	2673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFsrBKEpKhpmRmWsyUkJvUyvwP1kTtJrJSWqZtqE5N3jjLhUu
3096	payment	1397	1397	1678	1	1	2677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qomVdoXqSmHaZUnN7NiPFd7fsdy4LoiiKU4sL8wnPyyZubrE
3099	payment	1397	1397	1678	1	1	2680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqg1CJKvmDqnJjVNA2pmZH4rci7UoskMpBv6mnxmaobMubVgw
3100	payment	1397	1397	1678	1	1	2681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15JXRboeaS7XDap42yrZ5NkBSK52FXTESsDiT5KxH7WR9yVwC
3116	payment	1397	1397	1678	1	1	2697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiTL7jMhKJc6FayTL7jX7Nr2fZRJ1FYnwPRZUZHGCNroxJeoL
3125	payment	1397	1397	1678	1	1	2706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7jR4BkvLMvJNc8R3id1EZDfvkeR8v2e4PEG4GAxcYHNyTdib
3130	payment	1397	1397	1678	1	1	2711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8JHtTWkZjChZH6uXcdFWWZjFTYgY4vwrd2Y6uv6zx5mYa5VT
3136	payment	1397	1397	1678	1	1	2717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1AsTVR3SZ54LZh8Y9wkGoJGc6QAMVUBDrjcGdwCVxp8oHvSe
3137	payment	1397	1397	1678	1	1	2718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mm2a82aDSWvnyoSoESawfxTf41zQLE5qA8iZjFUnCea52wBz
3154	payment	1397	1397	1678	1	1	2730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TwnGdSX6e2NVX1mfUy7N6ZPo5wkWeDetyH7SuQ23661TU3ix
3158	payment	1397	1397	1678	1	1	2734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcPFJxyk4tcQYD4c9G8xFKtnvuqzhu1Ese1feUC6naVAEHx49
3168	payment	1397	1397	1678	1	1	2744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8cvMngEdCCCvTxw63kELMxrwjgngHfV882trR3dF6cJx5Zqy
3169	payment	1397	1397	1678	1	1	2745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtocKqqWtZyQbvqw8cZBWeRjkAHC3igrF2zocrn7SLXxXBa6k
3177	payment	1397	1397	1678	1	1	2753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1uF638M2RuVukqDZm1n9z5oUgokse7j9ofKn9xdj4Kd67QvCF
3181	payment	1397	1397	1678	1	1	2757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GxMjqwE6rTGe96Z6W1cmBg5q6VwT8CeVo4LgtfvSPWdHxjZr
3115	payment	1397	1397	1678	1	1	2696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPw4rCHQHvUj3sVRB6omcoDV9RbsbPhkqVBzTLXgxdU2vLEKRA
3121	payment	1397	1397	1678	1	1	2702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEBkDVLJfc3b2yJux26AM28yDC5CFhj56MPZPevVuCNcGK6SD
3122	payment	1397	1397	1678	1	1	2703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF6SoK6ooXGYF5PinxuVmSPNEsMTHKndTHfPJ4caFEDKWUXed
3128	payment	1397	1397	1678	1	1	2709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2y5MNVnFPrVSkijTwU26rz6c8jYruWiNZhp9US99HdKj2cx3
3129	payment	1397	1397	1678	1	1	2710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfULqTfgwTvNr2nnSgV7drQ6jyTdnoNVbia1nKQdZU2BH2y5i
3133	payment	1397	1397	1678	1	1	2714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRP9guygjubek8XtRvy1arYzFTNgKpYMbkMEeis5irrawfjGsf
3141	payment	1397	1397	1678	1	1	2722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhDJ6Ykt8HNYPDEr97sZWVLUsLj8eGncxz7q1fyskuqmZNiJ6
3142	payment	1397	1397	1678	1	1	2723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpViFRaCsydEYtdqqMRPeTDcZidmCQe4vrMy9ZrqmjvhbBNzXm
3143	payment	1722	1722	1749	1	1	8	1440000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTh8oNWXjpunK6FdBEaudveQnh6Sb5BETWLPPdJsb1rZouBRhX
3150	payment	1397	1397	1678	1	1	2726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzxBKdH6Vqhysf3xK3RZp5FUw7GxSEE2TgfH6qPhxGh3k8ooe
3155	payment	1397	1397	1678	1	1	2731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx8Qk6mDifihTt26GbkRSS3fdWeBrWgP46qJRXvNpNiCfzgTo
3159	payment	1397	1397	1678	1	1	2735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TzaW6vrk3SqSNE9vkG6RxSxxqneZ2GzJ57tyayxGfyrCqVgC
3162	payment	1397	1397	1678	1	1	2738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxK85dwY9joR4XVcJwbTxfNknHkdW5vsiVDZyDd6ShfxK2Ntt
3163	payment	1397	1397	1678	1	1	2739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83s8k8WeSNE7qCDo3mWDfaaHhXCNrTfokjEmDivDgkr7uPdFq
3166	payment	1397	1397	1678	1	1	2742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzxirJqHqnd8mABR1eKAbqCB893apYRSoxz8NNPiGbdfcJWjv
3170	payment	1397	1397	1678	1	1	2746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYV56mec79s6ojSx1fMRzAzq4NWWRuHv8kLaoKvZHP8S7r9iVe
3172	payment	1397	1397	1678	1	1	2748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhsnLfxQDHNn8199oty4Q4pW8kypr6ysgjGEZtCe8b6x52bvp
3173	payment	1397	1397	1678	1	1	2749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkmPxYDJEBwmTNHkk8oYHY13yMyPzoQDorwxo32JDMVj4Ui2d
3174	payment	1397	1397	1678	1	1	2750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFmokgfhW9LUsRoVwG7VKrqRqKJxGw7WidgfRS7TA36CgynVP
3178	payment	1397	1397	1678	1	1	2754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSo6xg45vM5Co3KqvncNPpxXhQwxgiv4L3wmu6h5SEPdC2tcP
3179	payment	1397	1397	1678	1	1	2755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYQqjh3Jvjjo13LwFwXvkExnGjwb8ufCdo4UXmsLmZ92bMta9
3180	payment	1397	1397	1678	1	1	2756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnY4F3BnU3xRGGRVr9RHKY8TQiJA5SafoiEnxchWUZgMgCmef
3182	payment	1397	1397	1678	1	1	2758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rs1rZPb2VCBxXYBCLKVyVCghQYExrsFhHouuFXuH58kj6oZv
3186	payment	1397	1397	1678	1	1	2762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZSZfGfbjiDfob26dMLja5gbHWyPpKZ7Za9btUjfwBabqE2fP
3199	payment	1397	1397	1678	1	1	2774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH8341SA1GFQSPvSUNjU7vhETf6ipiYHxuxNjEyLfbKb1FpKbX
3202	payment	1397	1397	1678	1	1	2777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7p8g2ywWvNpakdx3ZrwPgZCCtZig4HNxjwE1X11iFaUa6YWG
3219	payment	1397	1397	1678	1	1	2794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhhXN2A4cP2pGPYduRjaHYoiNxqymmrnrSNF2wMq4dUuBQxZh
3220	payment	1397	1397	1678	1	1	2795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc7RsPFiZPrfhZpcFSuTNNf78AaWipd8BVNf75DT3iHJrsq1L
3221	payment	1397	1397	1678	1	1	2796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1ujmwrkMc87quxqnjvhcjH4SboZLdcuZT1BArH8PeCgeJsAF
3229	payment	1397	1397	1678	1	1	2803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7JdbP5LqhyDnC6tptpRgTnjz44ScEyo7Rc2Q4M1SGmGBH8EP
3230	payment	1397	1397	1678	1	1	2804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZda9p2yCJdb2Kj56EHYXmH8rxm21H3wxop87iuaCj3Rhybx4zh
3231	payment	1397	1397	1678	1	1	2805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEz6nVY847Nf1pmpHMjhRmsNZwWiFViFtctFQeysCrRMqeC2K
3232	payment	1397	1397	1678	1	1	2806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBuQ5NvaMyBmyYg6jkrKGwnMjJudXTgvQ7smyLqRxaY4RsK3Z
3242	payment	1397	1397	1678	1	1	2816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtd8Brr1CvZnnqH1C8JETChkAdokyRkhFrbeC6wRhyyMtx2vi
3243	payment	1397	1397	1678	1	1	2817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4SmsTRYrNXiyzLYRVrRG7Fk9AmadhcHqPuNL9K4pBbjouCob
3245	payment	1397	1397	1678	1	1	2819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEZzsj3MEc6kUsYxDTL18CaqeKDUdjEuYgCuoGY5nn4xCai3e
3257	payment	1397	1397	1678	1	1	2829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdqMpHwnCVx6cNit3YTcTpx9QXNUeBavvmxnw314nGLCmGMtg
3260	payment	1397	1397	1678	1	1	2832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9duhTcM3ykqEpV7cgmRpH5oknmzmXfFHS6NVxsShd6qFPeGj
3117	payment	1397	1397	1678	1	1	2698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21SfF4wYG7C5FMcT5cDhgujYY2dUZeCELvgoaaD4WZXScpLzx
3118	payment	1397	1397	1678	1	1	2699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNE5YcHETYDsfMB81GEZgzqVGMEXupjZtF7oiyDWGwhMYKxUD
3120	payment	1397	1397	1678	1	1	2701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyBoYSSC4K5mr3azagdLwqL1r8r7LYzwPKk4YupGQtUKmXzmZ
3123	payment	1397	1397	1678	1	1	2704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6wKBsYnnYyEc8nYep2SYZ4yujueM2ZjsSZxtosNA57WqpngFp
3124	payment	1397	1397	1678	1	1	2705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TZZxfGmVLU276mr1aKYRUEL2bzmYFCKF7np1N1R81HZuwVcH
3134	payment	1397	1397	1678	1	1	2715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAXvbE4mxmmgph1XYTYTcxsFVfDt74FGBYKtEocKnrr1ypz7q
3135	payment	1397	1397	1678	1	1	2716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4w28mhTDTFRBmVyEAxcxtJKWV3UGmqs7BcsiVDi86MuKtYeQB
3138	payment	1397	1397	1678	1	1	2719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHMmBV9vSwsjretoU2yjiUsfHHVEvcYmJGFXU9rryKWDsNh4p
3139	payment	1397	1397	1678	1	1	2720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLV6cWHq4avXy58rDjfA5h15xAnLTdCWbzEUXgVC5DAvJrNAR
3140	payment	1397	1397	1678	1	1	2721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGZHChmxSNkkbg5C6y5LdSkN1LZ8qXx9qscgxchbHMco7DFya
3144	payment	1397	1397	1678	1	1	2724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9WtcJi2QMjQrwcTqP48XZzkT8kK6xSqrgAtRzStKcqm2JzUa
3145	delegation	1749	1749	1652	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FVPKoMyZZ6rq8Hqcv5gcd475Yedhr1vhoy42SykeAu4hLpGq
3146	delegation	1759	1759	1652	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2aBdrtdJcgxtHoJqgPXW3X1jLiYRpQ3PeUa673KHh5Gs1LA6
3147	delegation	1764	1764	1652	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLEmYdrQwQsXZN9fnhJYALcoUgjFbceEcCVjk73Qkba18q1a8
3148	delegation	1722	1722	1652	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDZaPG5pWdFxiv48ueqbvq9MAeDrhbw1aMQ7NzQcMzUgKVwJr
3151	payment	1397	1397	1678	1	1	2727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPED1S4E8bNBEWdF5b5zHsyE3LjQPGVx6J3dBzRxVHYPtFCWC
3152	payment	1397	1397	1678	1	1	2728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuo24KqagoySnjANXBU5fV7y3uUdggPZhQGQ9nF6H7ZtU5vtuD
3153	payment	1397	1397	1678	1	1	2729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajkV6c7eKp9Z16u1PMaCLoSzcT6DUdktnDECu7wwMFHJ1EnbM
3157	payment	1397	1397	1678	1	1	2733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5gNJVFpgR8M84nBFNM3WB8pmtjt8toU5Z3h1kWKQVUzNhkKz
3160	payment	1397	1397	1678	1	1	2736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLXaKpQFXiJ28PWZr2oPgSZv4J7fCFW6BsfHS1Hzc6St6v2ss
3164	payment	1397	1397	1678	1	1	2740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsM5ish9PGoWb4xa88Q252scKdiCtAw8wk8a5sJ8A7YiccNrpA
3165	payment	1397	1397	1678	1	1	2741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdE2kBTPyj1z8GY3YzW2rEnhczxwSv1mavc9aedYZw7vFi9Su
3175	payment	1397	1397	1678	1	1	2751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe7KLwZBtJJezXvjQNgwGaEcCE7Tovgsbu6rVeNdvuCp7GVHp4
3176	payment	1397	1397	1678	1	1	2752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsM9DEQnZa9TzyAirijU8tLVG3R4J83rURScWjkGdkf38HXVV
3187	payment	1397	1397	1678	1	1	2763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxthZSenZAYPUhV7GEUcN2FZWmep6uPq4RVD8JPgCZVuxn4DzW
3196	delegation	1738	1738	175	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iycnoLwzguGp2qZECgN5FB5KSSDumaZ8RhEWhC62pGGSumHe
3197	payment	1397	1397	1678	1	1	2772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUPyF9yjq825KkSJGPNXiBRaATh9P4UCMcyBqeR465t8FTM9v
3200	payment	1397	1397	1678	1	1	2775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipFieEB1YWLAa7MyKXkfUnwKC7F7ziBqDQ5pnxmyco4iWZoRz
3205	payment	1397	1397	1678	1	1	2780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuDoE9FB9TB24LfLwdFfMUvSSn9GL3y366HAVssfhFK6b4yb3
3211	payment	1397	1397	1678	1	1	2786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJmWiyHMDNSin5U9XFmWeZmwJ2XXvy6pUC3se9FChfLnfpeQL
3212	payment	1397	1397	1678	1	1	2787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DqbE69fbuuTnJ7hzydmpph1JsyDbby8btiuPaRRyTz7JwmvS
3215	payment	1397	1397	1678	1	1	2790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CVBs1vnUoZ2PZCNzagGJn7pwrYfaHUvvKTFCBftwXEe99C5R
3216	payment	1397	1397	1678	1	1	2791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsVnEd8DycPq7VexSKTQLq2FpdTXUvfZJ452eTV2fDxLEBjFD
3217	payment	1397	1397	1678	1	1	2792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBgpvdEWyS8ed7dSDqL1tjw96z7B7tA3Qxqcqusi52nirqhKs
3222	payment	1397	1397	1678	1	1	2797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBf6HFuPFtX18QT2FUYzi6dmPcN3Fk3aKW8P35GUogtEFtWJF
3223	payment	1397	1397	1678	1	1	2798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtDYcsvFqASxpwEUAragyXZvYYRQjnXrTEDiYJDTqWcV9gccV
3233	payment	1397	1397	1678	1	1	2807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjAPQHEW2YxJLaAzBvVLbBJWzBUgBfUBMMVCXGuDMgRrraqh7
3240	payment	1397	1397	1678	1	1	2814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YNb2KWSsFjGMqTo4BB84dbcLRE7ADHUFnaoEpJM3gz4g9sjv
3149	payment	1397	1397	1678	1	1	2725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65dyca3wsktYYxVbbccX7qQox17om11ASBszn7d4AJzAbnscz
3156	payment	1397	1397	1678	1	1	2732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPy8sUnUCqhvb67Yc2oDLtgnRPFU7ay4aFwGz4srdfX15jPLA
3161	payment	1397	1397	1678	1	1	2737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuUh8K6ZdPUZSEnUqN6hV6oizfJCjR41u5ZbnewNTqeMNEN8L
3167	payment	1397	1397	1678	1	1	2743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33SBFSqyJHvnpCmPgRYnWFqiC6Nmb9GnZEnFsWYKUNGW1rseh
3171	payment	1397	1397	1678	1	1	2747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvX5SzZwQP1tek4vKhn4UXKMgqnSV6tcJYDZSEueAZYJLiQCax
3183	payment	1397	1397	1678	1	1	2759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FVcXvXcPj9vZAA6uAVtjVcTzhGQpx3sT4A2Ee9UV1GaMZEAu
3191	payment	1397	1397	1678	1	1	2767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmzjtK2UmDbSaGQgge3iKkanNau74YUb9Poc7fAmNzXkmCEE8
3194	payment	1397	1397	1678	1	1	2770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTqwcF3B1aGq8wQQuieEFSEo6pJhK33ZfDbzmMUYPbR623eXx
3195	payment	1397	1397	1678	1	1	2771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46hdBjsy1R8nfPzk8np6s9Ss4uxuVJYadSQnbGYL6YWBrAvS4
3201	payment	1397	1397	1678	1	1	2776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnM2vGeb7PLjwHmFxPVJaYnww7ETPH67UG1MfNgTddgQeMp1Q
3204	payment	1397	1397	1678	1	1	2779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevnk9epwdUDmEvu9hpdB8G1YmfHCnwA6JxMMnTb5sRXnKtzUn
3206	payment	1397	1397	1678	1	1	2781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfnmG3Wt32jBVgcf1k8WNwoJpCCv3XgyVukFhHqVuRXVGKTYWE
3213	payment	1397	1397	1678	1	1	2788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRd9NN5HNynDCFnVrdqGoMuxUU8jKEpbSbyhuTNH4crWe61g4
3224	payment	1397	1397	1678	1	1	2799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69Htn4KQ9i6nHF4z1KwiC7jfReGUUUj9RkJ8JHwrHA2wqZxm1
3225	payment	1397	1397	1678	1	1	2800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCo2gCGHETNc3Z5zJAnKUSbD8HAQjAzp3WwwQryCBSef1sqiS
3226	payment	1167	1167	1726	1	1	0	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhYATJATDRi5hC1EqtnM9Ymm8Pp2tbVpQeB3LhZcnMiZ4xRhs
3227	payment	1397	1397	1678	1	1	2801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmePtshqLUZfJ1AXuUhWnpYQsgLKtyoQymwZrtGacUamTS2KcH
3234	payment	1397	1397	1678	1	1	2808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozBCvkrfJaDtG4uMm6LBCEUbmuEvN72Q78sKh59tSVzJH35PR
3235	payment	1397	1397	1678	1	1	2809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2U3ysqAZUG87HrJZ3Z2CdA6uT8r7q4meKJDS7ZtJ32yTEe48
3238	payment	1397	1397	1678	1	1	2812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo25VRrJgXKZSwCVhoTj6fZntcSePzMJTLAqE4cEokvKXrcBvz
3239	payment	1397	1397	1678	1	1	2813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQaxareFSuMrcuvKoreHxWReRf25BobKWB21M8C8g86fCensMF
3244	payment	1397	1397	1678	1	1	2818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7fmot1G536ANnJVdcW3jr1QCXp2tgXCaFmJNq3qoaCocv2xS
3246	payment	1397	1397	1678	1	1	2820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3Pn88Nfq5qy9FxrRiW28mz8BgaJcFqU9njoKezAZE5NLohF2
3248	payment	1726	1726	1758	1	1	0	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYcY1BMapjL8Hsy1Bw3uRdWAPAfDTjA8b8LDgqEpM2gxWWKVsuV
3249	payment	1397	1397	1678	1	1	2822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86GBiuMXKs7KF1tGgYwnoY3kQFeGuJbaV5JURwEuTBa1Z3tpe
3256	payment	1397	1397	1678	1	1	2828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eiJz5fXGhqWYWRRbruH5SU8QtXnF6LmXXUsKvD1v7hKwhKgB
3258	payment	1397	1397	1678	1	1	2830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3T2A2iVcUz8QKXXUsZvjR2gyLACseVvgv3DGDjWT1r6A93DbY
3259	payment	1397	1397	1678	1	1	2831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxeo5xtKvjh6wP7CMR8UtHXFyqvuv1FuimaeqQRqJcrNAYhgF
3263	delegation	11	11	329	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aycyiASq3RBJyqAW8rGDV5uTTTghT9m62rv9D8sbbpu4zdSp
3264	payment	1397	1397	1678	1	1	2835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAjdB2LSRNV6XTERFDfsDdgotXQFeQ4F6vBAHvujwZL4cJpQy
3271	payment	1397	1397	1678	1	1	2840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wsm82o6ESXXecv87Tm7Sa4eP6ABcAoCVRc7bjyifuCjJyWCK
3274	payment	1397	1397	1678	1	1	2842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnJ4sFUm8UFu773D37mh5L11gpfmiBQeefCYsTQMmfpJWwhXq
3275	payment	1397	1397	1678	1	1	2843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDhByG3s7aH4o8dL1xyFCNZhgFgzrnXbDb8rzs61wsB9Ls9LE
3279	payment	1397	1397	1678	1	1	2847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaTk8kfdhV7hrvLybDo3bRatfzc3j2Yq8331TDWWtHrN5BLsy
3280	payment	1397	1397	1678	1	1	2848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32oocHXHMnG23TmVFzCXdMMr6navCHtRAqTfqN2pU1GWQi8UD
3288	payment	1397	1397	1678	1	1	2856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkdb7pCVfUAwEdr6SuYS4yUqCUAcoyeLctxcB9F2VJvqpbxUp
3184	payment	1397	1397	1678	1	1	2760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoipAdiLSy82sgeg8UqkPJjLAMXF9KsXQfQ362yptLp4hNZGaJ
3185	payment	1397	1397	1678	1	1	2761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbt1hLPPBM2YFehJkucSBqFnbVotrtt5XehVf37L2mQ9dRato
3188	payment	1397	1397	1678	1	1	2764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCwFbMNsNjUhiiH12nVGLTQtNYHjLLJBdhrNogtfMvwutHQqp
3189	payment	1397	1397	1678	1	1	2765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1HEaB33XRRA4GUUqFsQe49hEBDTMLGZEgeAdoj7oHi7TnqdN
3190	payment	1397	1397	1678	1	1	2766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXacnjn9FRuwFmPXDq7gWK87gijTCCphmpkfZfM72KdXFTqpzF
3192	payment	1397	1397	1678	1	1	2768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTj6yLQ81fccvK1An19B3HNtNxqH5Aqed13A9kcbsEhTxTBgj
3193	payment	1397	1397	1678	1	1	2769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohhhZSKjTU4DkRMVxYixrfXjzbpCcS5jTaUgWkapsJVEM5xkD
3198	payment	1397	1397	1678	1	1	2773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMZtZTUSAwjcAMnYEVKYPeGqAnsEPxoUGjtjVDx11VP1xVz8R
3203	payment	1397	1397	1678	1	1	2778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8CmkzRZvnS5t5TXJzroK97N2GASy4oYYeutfrYx6fkX4hv9D
3207	payment	1397	1397	1678	1	1	2782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkpbsk43t8t9yxwNTPwStTh7XMJtVCieFANuPKYGBCmdkHPmh
3208	payment	1397	1397	1678	1	1	2783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeSeYB1wdxNtL5gWt8XmxQcAqcQJ8DKx91sDf6WZpv1oUrBDZ
3209	payment	1397	1397	1678	1	1	2784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTzkLieqBFS6gC5RjuNBkeC3QytLceNBgywWE4vDAb4vYZwoY
3210	payment	1397	1397	1678	1	1	2785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucLQukUp4fsFizcMq4jknGHwk9ZyM63pjWeP7z4D2z44wyrhB
3214	payment	1397	1397	1678	1	1	2789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRW4qV1qNuDei32AiXV4e1tdCr5mN9qfcxXT7p8ZMxDCir5Py
3218	payment	1397	1397	1678	1	1	2793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQBw5SGwxKGSBjVVyv5oUm2Gf2BhKP48ARgEkivzkJJ2bgUA4
3228	payment	1397	1397	1678	1	1	2802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStJK2FJFBN4vRJXSLQgMs97SptVGLFjP4jrpUW5hqFx3fBiTz
3236	payment	1397	1397	1678	1	1	2810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3UTV89Wvcbsfw9YfiFNbivyvwP5FedMsAxfEYFijaK2EA1Vt
3237	payment	1397	1397	1678	1	1	2811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBFL2G9nepJDQTxp5cC5oRCzb5MSJkYjfMkYghSNsmLF3qgtp
3241	payment	1397	1397	1678	1	1	2815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxuPYghDDztCoaEcbwzELzHAyf8MLffaAc4yQk8uB1WVxyJd1
3247	payment	1397	1397	1678	1	1	2821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYfJfimV99tmshpeUUrgoXY5swiYkyREZsVsKhjnai4Ka7fbo
3267	payment	1397	1397	1678	1	1	2837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHa1c3mexwpVehLgHZUA3dZVSEQ1Mf42yi6LcJf7aUSYNp55E
3281	payment	1397	1397	1678	1	1	2849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfaj2f9Kebn3jG8Hxy5bannsdf7zxKb8B8WQPvnuuGrxsgxqy
3285	payment	1397	1397	1678	1	1	2853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnchgLysQfnZVF6F2hLX7f2oMH6Vv2S4zqsgdenQ6fpxVvLsT2
3286	payment	1397	1397	1678	1	1	2854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH15vLwrzF5r4TTAtfuXjZT9YwNaeTyZGsF8gAXvEWmtrf7mKg
3290	payment	1397	1397	1678	1	1	2858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8CqQ4zp3GkRa6sccEEJghLDtUnjNamzTyrsAYfwJHZkQm1ZK
3291	payment	1726	1726	1784	1	1	2	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpSwxMhbi6YKn7PzPEyXqcvVVhUJUnSV4sWk8xDceHqdtGrWCy
3292	payment	1726	1726	1785	1	1	3	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZjdguhyUdQb4N1hrRdifak6ktHK9FDrCQ7hz6SZt9zCE4RTkvN
3293	payment	1726	1726	1786	1	1	4	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZy1XDghyGwAxEMWPDbPWPEtbJsCeiuqKWyWXrqBqXnvzF2B2ub
3294	payment	1726	1726	1787	1	1	5	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDd5Agh3TjEsybs8xHv1Yh3S6Yd2XjsCyngiVbTD4zLpCi1zpQ
3295	payment	1726	1726	1788	1	1	6	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZomZD4cSEj8zpWkLGZDJCDaAKEqZyGvi43Y9TmCWV23RN7xB2j
3296	payment	329	329	1789	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK854kgfPGqbJFs4gp7tyHFGGFpb9bDqMhpVYvS75JZfTxWooC
3297	payment	1397	1397	1678	1	1	2859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDgEKcRVFSW3AtWoPtYyNwCscyQUv3aRYtyMjHQsNpKRmxTMz
3298	payment	1397	1397	1678	1	1	2860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgBMM1RcvRqGaYYXANirs3aiV1wVMZimpDW5LXZ8pXTzuPbcAh
3299	payment	1397	1397	1678	1	1	2861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHjgFxHiTJgBo5wzDKvRx9boEkXarbEtvKMHxTS2GjhC9SPNe
3250	payment	1726	1726	1782	1	1	1	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaGNNSoaRfBrEMqYPBJa8YTyia8JbosCdXGjdEbz31GFp7c4Hq3
3251	payment	1397	1397	1678	1	1	2823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoT2CebtfFxRNVFUqhdwABnXAgoiYfU772R8a99k2782idPSC
3252	payment	1397	1397	1678	1	1	2824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7VK1GirHFvsSRDPJHv8FY7csRzwXa8TrmRKLD7yKDyH6SkiK
3253	payment	1397	1397	1678	1	1	2825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUa6F2GvXoJxi6x8p5QhDSk6KNCJC1ah3uFJWVAgo496Pn6Mz
3254	payment	1397	1397	1678	1	1	2826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPcM3ZihQAqjLwdZbqwNcsKzzb6YUVEkkHr4GeVhCvdZG9z4T
3255	payment	1397	1397	1678	1	1	2827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwG9n3rRrVTChtJubdBMiwzDGhXFAujHjGTTSnzQEYMXRmrFX
3265	delegation	348	348	1777	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQQASif16AGKjH7GVXUxPgH7mQr5UMfdUPBUkXt3n1NoKc7je
3266	payment	1397	1397	1678	1	1	2836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJXzhGCjeAxDKgy2LJqJbXrSaC6b6YHgrCWdbjKJsnzVJ2pSM
3270	payment	1397	1397	1678	1	1	2839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxgMeuhVMUEQCj1eiL8pXywsNrkKe35oH8v916M2797hjkBtF
3283	payment	1397	1397	1678	1	1	2851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WRHoKSkcbAoR9yeb2MoWg31gofhCsTVAS5w4429TWxbNJ1bf
3284	payment	1397	1397	1678	1	1	2852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4e4MhR5GGCaixPKCtWReAN814qTqFRyCc1bvJEwSiyQLnZ27u
3287	payment	1397	1397	1678	1	1	2855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiWAt1wKeead8wDp9VwvEtoCzBp1osdPPvv4eRioz599BwCjd
3261	payment	1397	1397	1678	1	1	2833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirDkLq6Do5iFw6PtgaSAmN7Hxi8hPPeKhjc88p84Hhc5ejfsz
3262	payment	1397	1397	1678	1	1	2834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba5R4G7erk8XhYCjxhHYqDakRpG6HQVE3VftghUGU269fFF1W
3268	payment	1397	1397	1678	1	1	2838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2bBKooqgzPzJYZCijyaraiAY5jBntL5dAM7HhD8BMfBK851Fk
3269	payment	1750	1750	1783	1	1	3	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhygPFtCC1bkSk1XJm2reywuzWZZ5tfHfYA4pbrHtFRageruL9
3272	delegation	312	312	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtW26N2VYjNXwspKz4ng8LWyML2UnsA4eTmxh1hApkioTFcow
3273	payment	1397	1397	1678	1	1	2841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYQwPjjNx4mab1QAJGG9ywQ7ZQgLFrvG2mT3A85ED4c1bVG5W
3276	payment	1397	1397	1678	1	1	2844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKAKk8v6gLa7uDhhEknQ7pPBNwWUV4jFuRpQKtvmYcp46EMsj
3277	payment	1397	1397	1678	1	1	2845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBptdmdfZFKA5PLBV1LZ4rpVgfZE49zmwLLEMQLDaQT91mTcd
3278	payment	1397	1397	1678	1	1	2846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnSGqumk82hFNsQRjg9YvDC3ipvo4gabFFC4nwjLbxUXN2iFh
3282	payment	1397	1397	1678	1	1	2850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpUPJWUyuAGSZD9kNm2vV58pAK2sjBxuFNCv5rcSLtFeZbGnk
3289	payment	1397	1397	1678	1	1	2857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqq3me5G4RoxCBbMgTBBsNKp4kXjjJyRVSaMXXaFgcXQ3QyFMx
3300	payment	1397	1397	1678	1	1	2862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Mk9pgXBrNQQMmTzSPySPDuK3kbYjDgFG1cacB3YcdF99F3Yv
3301	payment	1397	1397	1678	1	1	2863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQq971rSGj4HFDzHXLyzErzjWMXW8fxggL8kxMMPzkZukDiMCB
3302	payment	1397	1397	1678	1	1	2864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wS5Vz2kwWGv8Zkc2YWdVL545Jj2Z27mxAh7b5cXPKmHAqswM
3303	payment	1397	1397	1678	1	1	2865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfBViAPACFXJV5XRZuxAi4ipRnuiktubPt31myc95v9JED95b
3304	payment	1397	1397	1678	1	1	2866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLnngchaP4PsFUd7szKozgwG7eELHrRy1iUBVJzgUTXP29Sun
3305	payment	1397	1397	1678	1	1	2867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgXU4E5uyxdHscVXJsXcEraaojcdDCqXQcdNjEGthcozYHQKx
3306	payment	1397	1397	1678	1	1	2868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdTUNuHfSpCjc1YcTU5C8Upx4SgwiXqobTZuVMxX9juXWnLNR
3307	payment	1397	1397	1678	1	1	2869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqkakM8jCWL1Jj1LUoe1XWXNzwecHUH44egBjaYKB6iCJNtJv
3308	payment	1397	1397	1678	1	1	2870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyXXoTTtGMGA9CTvkneNJCBZoSfB4ruxJt9Y7BqEzFG8RB8od
3309	payment	1397	1397	1678	1	1	2871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDRmC4UJoekPoER8CTUGU3ascn5TRTmbx63XPMgy1QCCeXpsw
3310	payment	1397	1397	1678	1	1	2872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD33f7HHabqvAxcu9e7pZYmnw4G3dSsGAqwJk3Am4vHbg5zfRX
3311	payment	1726	1726	1790	1	1	7	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmeZXqfsDMUzzBP3h7SxpbnNFGL6zAcMizVSgyzSk9owhwZQBp
3312	payment	1397	1397	1678	1	1	2873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkG18Ywu7xvcmSPfYGP1UySmsePSxVmEEEpMz59CGUPmtcwJJx
3313	payment	1397	1397	1678	1	1	2874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEW29GjtrK85HPS1G25Sppb2tPe6zmK3cebMbjbuNKE9SBMqE
3314	payment	1397	1397	1678	1	1	2875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuy54RLPBrdxdrdD9ecmRXWDyA38djutz9Hg1c2T7a3HiMAxJ4
3315	payment	1397	1397	1678	1	1	2876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPyUriGFyG4GAwXw7C8ywoeve2T3mShPRgEmXut2diZH3kYBy
3316	payment	329	329	1789	1	1	2	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqe7tJGsXEYjypBoDRw7PoNdeEPnXEULPPkoG9WXbUTUVU8Yh
3317	payment	1397	1397	1678	1	1	2877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43wSt36GFmyziP6U2kkgkdDeNpfXstiLA2ZLnXeuqEYPsRXYU
3318	payment	1397	1397	1678	1	1	2878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26U9BBmNG3VZGw8qrVWEEqJVFdzu83e3rZTcski7YTumojbfD
3319	payment	1397	1397	1678	1	1	2879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXDTWXXnFF6EEBqTbe58RQancLNTEAkxcmH3ryenBCBMM8C1w
3320	payment	1397	1397	1678	1	1	2880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBBWCHaxfMFDnMsDMWRaH3dcZY8BuCfmFaD1L98gSa9FXzjnuX
3321	payment	1397	1397	1678	1	1	2881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8AegjDPNoN46vU9dSg7KQjnQfYntDa7JfbTCo923ymUjGSzn
3322	payment	1775	1775	1521	1	1	4	1000000	1000000	65535	E4Ym6mKZFnff2vCd19EWYbgAwCegoKCnaWkkFbXssMTxAi3RC9ixz	CkpaDTwYq2ST4KVZnig7kXjb7SKxDP5KkUEGL8eoiTUKaRmMuSQwc
3323	payment	1397	1397	1678	1	1	2882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ygmYYJRp5eZd1cqrhWpGbgYr6MtFqGfxRd7KmTvruu94QVrS
3324	payment	1397	1397	1678	1	1	2883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWaDhEKdgfmzBdHSkj4mz85vQmXQzfcuCVFZvXuQSKkKGZkAm
3325	payment	1397	1397	1678	1	1	2884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8fAn7F2wM81PUerwivVDAp4LXyinz8byfaJMPSDT3smyNmEs
3326	payment	1397	1397	1678	1	1	2885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumqbwjang7QxzhaeWpKQege5q6TZXymp94vypXCpxXjsi9ap5
3327	payment	1397	1397	1678	1	1	2886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZeJiL5DWUiUjhg2vFU6HiUJ7DZWqzHDu2y9xqgu85BQhzEB7
3328	payment	1397	1397	1678	1	1	2887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RFE4swf8PKqiNXFrt8pZe4PxBuRFQ951WBfkMBK2Y2iTpaRk
3329	payment	1397	1397	1678	1	1	2888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVj4QGQYUzyYHBiyAkeApnpm6UjzLUNS8j3EAvcEDt1jJk1kr
3330	payment	1397	1397	1678	1	1	2889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTkoTH44cu1qSyeXxk31rW9dKNM1vk8HjYm4Czgfhos2PWktq
3331	payment	329	329	1789	1	1	3	710000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6En2BrNVGbXWAzkHx1yDP93LexPqQJH8aRrgJzitqgk9D1xN
3332	payment	1397	1397	1678	1	1	2890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkCyDLbr7RY4VhAhPJNRkG7bJE3qVwVZxdzzVBsHWcfb2mnXb
3336	delegation	1769	1769	44	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDxqVSZJetyb7YrzDxjmfecMnNvrPEsVEm518qkUo759Y2bZF
3355	payment	1397	1397	1678	1	1	2904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MVwZPefGXAvX2ESyeSKXVhdpKhCxJGGGv5xgVKnsy6Msd411
3356	payment	1397	1397	1678	1	1	2905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrqHuC9iWgdrruMpRrNTuisY1CMYdZqxcWCpxVxw7GmAe7Ttm
3362	payment	1726	1726	1795	1	1	12	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXazEsMCdDEvE9y2oSNCoH4CTKvaxKdiSWAwnECex5kPG5DAQU
3363	payment	1397	1397	1678	1	1	2910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5m13rEKgAqCXQ9MbYZnuQiKuinhFCevLW2MKgxAd5umH191kt
3364	payment	1397	1397	1678	1	1	2911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2LmanrXXUhBVjsRT7Zf7m6BeLvzwEUWcYbggQcSoEYtZdCMw
3365	payment	1397	1397	1678	1	1	2912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQzaSqW6AdeBQvss3hZnZAJSYvy8JVMJK4AbmNHTox9Mp2Kgu
3366	payment	1397	1397	1678	1	1	2913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsMaouS95BYmSvv5YXBo33UzT8411mihPmqjwP2zUg1ZgCfr1
3370	payment	1397	1397	1678	1	1	2917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3R7FuJEX1rMKxAXE1kXndaGzVHkdj6bgqQjvHAuvoQEgYsCnw
3396	payment	1397	1397	1678	1	1	2937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5hkmdLeHkFQpv5QX6DueUS11J6HvNR3m66URYqb6xgVzbwVW
3407	payment	1397	1397	1678	1	1	2947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwguv9fTJyLWu6KNBTybXfyAuafzfw4avLb76pe97f1yvU4VeT
3408	payment	1397	1397	1678	1	1	2948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6QHxhhdJnmJZBUhpD2pWLnJKgDwhd7GCfCfTYZcF67sYtxji
3409	payment	1397	1397	1678	1	1	2949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6yiwwkqo7E5f1ND5gsy7gPfARxqTBCGgcH7TYJ4mFtUE73JbF
3411	payment	1397	1397	1678	1	1	2951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuvXf15MPof7VE2yUBGzCGpSYzRfZWS6Nn8BPhnTpE4Yatiek
3413	payment	1397	1397	1678	1	1	2953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVA1v1AEtFr3uwWS5mLdMQbqYqkrkHtJdNV4XMpiNupHyVEad
3417	payment	1397	1397	1678	1	1	2957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnSVk4pdkK4hb7gaPwgHrtoWiE2PapMbRiuQ3E5xqDv475cEX
3422	payment	1397	1397	1678	1	1	2961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahsGMercERnY7R7QFjn6i82bqWUwJrLk4rRR3cUnX7riWNCvD
3430	payment	1397	1397	1678	1	1	2969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8zT7MzGM6nC6cXaSD3KiBFEfhJMr9E7jyurdMrcw6STNAJ9d
3433	payment	1726	1726	1798	1	1	15	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpHMDQ1tU8dDLUr52PxhbaSXpRNYDenJJZ1EgwyY1rW7zeyj2Y
3434	payment	1397	1397	1678	1	1	2972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttwqj3RedwZ7bS3aDCXgZqYQrZNUyzjD7jqFkj9ZA5ou5rCUE
3442	payment	1397	1397	1678	1	1	2978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocW75xpnvAm9pX4A1kBRYnVdgxaq1ydwM6xwvPvxqcjxYyHA3
3446	payment	1397	1397	1678	1	1	2981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpetRHt7mtXAFEkLnpkdjR5XAakuUnvyF5YKfwtDTjx9R7odp
3447	payment	1397	1397	1678	1	1	2982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TnLk7CM9vrTD13LNVECtcAc6R2NC4sr2vxvaJdBDiQu7ZpHA
3452	payment	1397	1397	1678	1	1	2987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPbkLvxp6k4JJKbiQycDEU9kyhGMoZTWNzUnjGQjee3G9a6RB
3459	payment	1397	1397	1678	1	1	2994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BorRDgb3fJTfhzK25MbF3TDibiwYsrKfhUa51FKc3MAkgK7p
3460	payment	1397	1397	1678	1	1	2995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4N6ySz34KLVjXLXBovXtEwaytja7mtDeaadPyQN1gV1PKbEW
3468	payment	1397	1397	1678	1	1	3003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8SzDDW8oE5Y9NP2vWFKYt1ffAhPdwALN5xra8CACn4CfAQf8
3469	payment	1397	1397	1678	1	1	3004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U7daveVFseJQWPkgfVqxcn675VrcncyQYTGY7Mgn7ufEghPD
3470	payment	1397	1397	1678	1	1	3005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8G62auuQQpeDVY8Td3bHQTLb7BhhMkjvGPUyPH1duXN4p6J2
3471	payment	1397	1397	1678	1	1	3006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzw9BjZ6AX4YbYXdpVuXSiBTN3FBJf6MnxRLviecUYuUqdP5HN
3473	payment	1397	1397	1678	1	1	3008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43FKUcbHFkSYzQBPwVnMX36wRxKXRKj2JDQXCHVPgaWVH6cTc
3474	payment	1397	1397	1678	1	1	3009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFL8VxmLRg7memAwrRBJMYejxZ65BP2iog9kyZpJ7ouXj1KNe
3333	payment	1397	1397	1678	1	1	2891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkZF5k4Tj192fRFHZys155L3XSx2nWdnMqKJGVyt1rwqCRws4
3334	delegation	1769	1769	1483	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWtKsNoxZrbBoywRpGPSuKNMuvaUxYgj4Pg1BuWdQUue1ZGEn
3346	payment	1397	1397	1678	1	1	2898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rbGJF2ZNBvnxGCaxcLCz1DrrVvFsAp6aWoQUNkuGPHaBYj8A
3347	payment	1397	1397	1678	1	1	2899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KmT7bHKnoq8jh1FoN28n8eUK19v6urVZ39YCjrpyFHUVVZAi
3367	payment	1397	1397	1678	1	1	2914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLSKw4mk3XenVxnKT3fHUCPd2fkgGZjQzMLVm6soeb4u3JNMU
3372	payment	1397	1397	1678	1	1	2919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1s4JCS1yoGraM1BG96VFr1gFf35ymvMSkkaWBn5otv7LKpDz
3384	payment	1397	1397	1678	1	1	2927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTQrCyaCchzNgWY3RDYZk3sVTa8kBv6XEwTpeiWn9jzY9qZqc
3385	payment	1397	1397	1678	1	1	2928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsnQs24YE9vbiiYxh5GtK5VnWS6YULndCKzfTsB5t15fCJLbs
3386	payment	1397	1397	1678	1	1	2929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnPP6UurTp1gMxYzDhRxG2zGAhwoy8PFpZN7U7hizEZr1b3kM
3387	payment	1397	1397	1678	1	1	2930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDkdt1eAQzK3e87UZC6Z3QjaXDSXcLhenS4TmRZrZPUsRDvLg
3388	delegation	1643	1643	1643	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggVAhytLvNcPVnMQhVCHggvqDv7JE7mKrgx9VCrQGAgHZV3Fz
3389	payment	1726	1726	1796	1	1	13	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6SWJ4VU9SoKR4y5W5hsS9BQitg4WJnBtsp5sJRkYCruEvhe9L
3390	payment	1397	1397	1678	1	1	2931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22u4Hzwcpq6T3FLAXgBPueJyQbBZp1pUQ9XoWXUkGrKCg9xAQ
3391	payment	1397	1397	1678	1	1	2932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdPxHTykpH1bVvpG592WWCqs8FJjg8BAnTQFNFHyMGJ2WxLCs
3392	payment	1397	1397	1678	1	1	2933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1E7Me6hfsg4XjwApUUeUCyu6WWgAUoJgBMChe75mn4cxqrYr
3393	payment	1397	1397	1678	1	1	2934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMTmi8HXm7tpKfvhLTm35Z7wt4DgaXB1Wc2bjVQmnPArd9Svk
3394	payment	1397	1397	1678	1	1	2935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQXUGyQzsHdmibyrhhnwU6tQv3Qwkav5wsvFDz9mmLXgoP74i
3397	payment	1397	1397	1678	1	1	2938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FJc1znUk3Yv8TyRz94roLCoVPztdkBQsx3AocnkeDxjsQfWL
3398	payment	1397	1397	1678	1	1	2939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N4hjNbuFnp7PEVRRHNEMXYwdzGZnULdABo235uinkMUDRRCs
3402	payment	1397	1397	1678	1	1	2942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4jLuAbKqAib3X23U6CZyzH6Mr2jmFaYQ7ZeNgr5k9LC5JXTo
3403	payment	1397	1397	1678	1	1	2943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYkCD5GYnnt96SYgvDxVhsBubNP8crcRp3MzfZU8FbCXxpoKg
3410	payment	1397	1397	1678	1	1	2950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUYWxGsDEgrp8a1VMS5ZUdcdUzgnQpq8PxYW9uhQJwhNjnwXy
3418	payment	1397	1397	1678	1	1	2958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR8UsZgaHKsaGT7oCwaq3r9pkeDrnwPf3hy3w7rdKawgkWbujj
3424	payment	1397	1397	1678	1	1	2963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe21TC3zsKA6REPkftWTgHRwe2UmdzkdAvXu4GzuN1674DT2bT
3426	payment	1397	1397	1678	1	1	2965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGePjzA18TDcvmoDTXaMbqmghNZZ9axwQD71UQd6xJUi12HNRg
3427	payment	1397	1397	1678	1	1	2966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgJtXWE9kRswdQotzNVx6vUCdupUXF2zMmVMfTUYk9PxDrj2a
3428	payment	1397	1397	1678	1	1	2967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGPQqTgpijTiTBBas32eso6KiM4XN3aNNTYzL9tbwZEFJijaL
3431	payment	1397	1397	1678	1	1	2970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLscYhhyqRFXuVzdij5GabYcLtZwvmSEz1ZLT5KKAWbmnVhY9v
3436	payment	1397	1397	1678	1	1	2974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2CQH8RBJS88GrjvPZS2k3PWC1vF6ZxeFJ1xrr5usUZ2A5Lpu
3439	payment	1397	1397	1678	1	1	2976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmQwb5oCf7eTHofx2DQTTjuyYzRgZKg82A9FDg2iceJ6RKetv
3440	payment	1726	1726	1800	1	1	17	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSv1mHsHKgvcffNPQKaZgvq6Q3ch5dFYqxgnuCfDU6hFQ72qLU
3441	payment	1397	1397	1678	1	1	2977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvpPfCh6Rg5CcqsbeL5TGXNk1xHGqfHdm7w4dzVGHiXv8HWzr
3448	payment	1397	1397	1678	1	1	2983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9ihWdFCpYDzDKtWzh1yswwy2kny5d2nAToAcMTEGUqqP9WtT
3449	payment	1397	1397	1678	1	1	2984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1aSjADVa4mUfaXfFyLYzksAKXqnKuXLbw63XAeCVXp6769pf
3450	payment	1397	1397	1678	1	1	2985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5hPHtEWtuP6hmQJMLDFi6ySkv25swJYAnseqpcQgBrctUAjhB
3461	payment	1397	1397	1678	1	1	2996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtkdm82gh7VqPc4Rze8dK7MNUnRLF4U1PokLiyALgP929js57
3462	payment	1397	1397	1678	1	1	2997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagxhdQTjKKNr96nyM5dpxUNDtyvE3H3LymQdBhwYtCwQDmHav
3472	payment	1397	1397	1678	1	1	3007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwd2Ta6P2KtPhCxbvwd6Aa8xAMqXxj2LAHSSiB3X6Wpai2pVdb
3335	payment	1397	1397	1678	1	1	2892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwK3qK316YhDkAr6iH26Xe7bUPnEjTiwf4SsBo44NeWchF9ZQ
3338	payment	1397	1397	1678	1	1	2893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBP7jkNn1Zksqf2JUaHeFh3Bxzkut1VCAVTTD6Wz1NQoLKP2B
3339	payment	1397	1397	1678	1	1	2894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzcXHRXhzPsCqi5y1QVSpmsEghT6Fye36JmUnmWhq29s1UwuW
3348	payment	1726	1726	1793	1	1	10	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKHBZ8gpraw2EcGEccgFgGsdAYSJYSZDEN4YBkD5fGGwS6Yv3i
3349	delegation	1769	1769	1406	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HNGQEpamXgAUYejDaFLUUbN2FfGMd2fn6CEmbXRzXsV2d2zC
3350	payment	1397	1397	1678	1	1	2900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZpTL9n4i8XjTrUdJaY4nwXav4LaYmbRzp5PpcTtkKkqnjbBk
3351	payment	1397	1397	1678	1	1	2901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgLc45jJy61VosAwgjWZDShbb3c3H1eoJwWeNvUA8517NRsKiN
3352	payment	1397	1397	1678	1	1	2902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcqqVDaJ1DevxrikNgMiPUMPkeDAGgPv5dAZuLyC9kFMTicj5
3353	delegation	1769	1769	1406	1	1	7	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXh7qyoSA6MW6R2bxs5y1nSGXq5VHNycvT8cdeovFJyActf6U
3368	payment	1397	1397	1678	1	1	2915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppbKgurVomm5XnvTV7HekPJAbQfJfKRoy1ijLpiVzXXqz9dyc
3371	payment	1397	1397	1678	1	1	2918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcv8go9LtawaWzrcoxngkESKd9JVBdDDzp6MHo5a7pxt9Yki1f
3375	payment	1643	1643	1299	1	1	0	2813972737000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvs3TgbRfjNKJLevVnrUdvgwUAGN7r2Atm7FzYcqgeAey2mkeJ
3376	payment	1643	1643	1053	1	1	1	1496558242000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGvA1AZqMeQuXWKdBHjqmPbA336q9muGe8pybyTSSAsyy229L
3377	payment	1643	1643	1173	1	1	2	1009607370000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9y7v4ktcwR9SVrc43ZzEY5oGgfRDWSxvd9bQyA2zY7ZvmEWZP
3378	payment	1643	1643	933	1	1	3	835388537300	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAnDxgqNVUqFZhB8wUxdmiFU13bmWd8HUstUE7komUdHjcuZ5
3379	payment	1397	1397	1678	1	1	2922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCteJxrsFHQrYsk5fdSsvPAqe3PA4FLEFRBjFwnzqkex9DP9b
3380	payment	1397	1397	1678	1	1	2923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgckNWUs6Zr8svxMqJi5XZJXj1rf15qRer5owiHtFbjf1L77w
3381	payment	1397	1397	1678	1	1	2924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEz9YDtggC2i5yzGqw24qLAAiRy9VYSRZkPCubSKkxjNk7VnM
3382	payment	1397	1397	1678	1	1	2925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5e4EEFhu2DLzvxRTfkk9tBxbr8FCtzrBK2iKAgfUiJv3jAqXo
3383	payment	1397	1397	1678	1	1	2926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZMV3rXnueaLuCD24pb2hmCLeDEceje763aiqTY57UMQbq6GT
3405	payment	1397	1397	1678	1	1	2945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxv7psTPUpRxv29YUYJZ3UBGfv43ttpP7uGsZLYWza2wthyNw
3406	payment	1397	1397	1678	1	1	2946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDi3aZXVWBhtQmf6Mp5W1jjZwTA9y7pcRLXYTKcNmq1fjMVcX
3414	payment	1397	1397	1678	1	1	2954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TpFxTQPPhPDGBSR2c3zJZKJ2JycysgJbJ68E2CsubvJ8cB2a
3419	payment	1726	1726	1797	1	1	14	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkEhKWz3MdeDnf45GCCow2ZL1HbtpeZqDeJFNgmp3ECumsHycx
3420	payment	1397	1397	1678	1	1	2959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgrTqxXMB25B1mXCCRcMYpFqcHkMKiZNaz5QUMLuhXN5HSVqR
3423	payment	1397	1397	1678	1	1	2962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ojtwZhYfZuPkssexp5T36SRD78SivjS8syqzJQNkeDKz4rKL
3432	payment	1397	1397	1678	1	1	2971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwHMhqVP4nwSt2FxRm8hFPgMCCznvvyeM8pvA5EavXWPKEKPJ
3445	payment	1397	1397	1678	1	1	2980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFVkog6qFjwbVvWj9oMY7RrCZ8DepeQFGUpE7usRwwm8PEpDV
3453	payment	1397	1397	1678	1	1	2988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4tuCnGYGTmsDL1XuUK4PSLMw1Lp9C4pQQqp6eACwLuZ4dvPB
3454	payment	1397	1397	1678	1	1	2989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19PBmRDLz3ak68ii82K5MnpXyX8qNUUwCNoNkq9jP26qZnSZi
3457	payment	1397	1397	1678	1	1	2992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVFxDfE2aXNcrLyGXZ9JjNHtXqEMszRj7NH2AVy6AkZcpy9p1
3458	payment	1397	1397	1678	1	1	2993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNvwAqT1RkK8GDnPKxhXH3cFE85LCNmrGRkqd1A5wek2jN2LQ
3464	payment	1397	1397	1678	1	1	2999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNMjnddPeAKFKZKdmAvkZxe5DkfkhhowcmHepuL3AUUMhx6k7
3465	payment	1397	1397	1678	1	1	3000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfjPFZW4axrMhBKk46UDfVnAi4wSxVqFnSnE7gAQxvHtWxTas
3466	payment	1397	1397	1678	1	1	3001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTWKXaYQZVxd3d8AWLg2QRuCQut8vvVsii8yS7vtubtJkAz1i
3482	payment	1397	1397	1678	1	1	3016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTLZVeKAdjihwZq7ehT5VFaSAnTxMtGUeGeFsevqSA4jCJakA
3483	payment	1726	1726	1803	1	1	19	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcEiq3WCDFXgNv3MxERttZ2a2iLXPhs7uhian8U8KMw8FDigir
3484	payment	1397	1397	1678	1	1	3017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDW1gLy9W4EPRybyfmw95DgHemLwUMy7sWZEpYnFQooKRS8MP
3337	payment	1769	1769	1474	1	1	5	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhwuBY4RWEarRhCxcLLBspvTrHf4rzM316yPMY3BFumrL1D4C
3340	payment	1726	1726	1791	1	1	8	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZUgRgyTZYwY1jx1CsHgoJJiNNMi77NMA8k3DaSn3wsVB3XuA3r
3341	payment	1726	1726	1792	1	1	9	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXnoFH14ECU66zHCLaqoeAFfVB9YdSWWUQvFXQHkm6nFHt6J9e
3342	payment	1397	1397	1678	1	1	2895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8XGH2CcCXSUVVvRbdinrBPKX3GoBTxgo8kMfg8LujU7Z84vS
3343	payment	1397	1397	1678	1	1	2896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2ksnCrdiqhsHDiiDFakfka2NN5WjggR3aLxrQweYAwQje3kk
3344	payment	1397	1397	1678	1	1	2897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYoZohSXemb6H8mFe3RDtqoZsYf23mLGcNsce2qnMLZQE81rkY
3345	payment	1779	1779	1754	1	1	0	2322456789	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4U8322uv8Xtgwdqj1UBeAvYnZurrA6hMMFQzueZfymmYM3otE
3354	payment	1397	1397	1678	1	1	2903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPaoYetAvbfqWxnwuWizzVDijBtFU6fTbN3bTLb2PSfBwV8To
3357	payment	1726	1726	1794	1	1	11	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYqeMvM2TFAqNBN45UkHzyBHieXH4CARkyQYjiQLKVKwD9YTxfD
3358	payment	1397	1397	1678	1	1	2906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZig3NFPSVBAjC53oNw11wgUXZjUCfSg7wcTwYt7pR5hQxxkygH
3359	payment	1397	1397	1678	1	1	2907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeun1RVER8HuCpGJvUSQxhADfK52VyTRZvQLsMyCaSDUUuJZ1w
3360	payment	1397	1397	1678	1	1	2908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazTVZmt427b7ieTgsVTMwmo4DDJ5Fi7hTFs9EgzjkbvrHCF8o
3361	payment	1397	1397	1678	1	1	2909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnb74mhgNabHUVCBzpFHBHs8dYsMSwxDEwRenN7CvMVASRXEx
3369	payment	1397	1397	1678	1	1	2916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YaSBDFouV8PPgRQmf9JPuJgPnbbUNe3C7tvST425VHzW8MyH
3373	payment	1397	1397	1678	1	1	2920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqETcCjsSTQrdCWoHDU2bJuWFhSH737b1WQpjPjrgaXnQbdDoE
3374	payment	1397	1397	1678	1	1	2921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWxMyy9Wo1DBwn5UCo8x44HCXY3z5t868nQw2RGcBSYda1ZAL
3395	payment	1397	1397	1678	1	1	2936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzaHF3HNtfKGKLyyze2r1dNZ813nf9zKzRBTKTysTusYbnfJa
3399	payment	1706	1706	1737	1	1	5	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8BVMYb8bsa3JyZVTsfDPqH3VFXyshtYw48JhKHYoijU4pXfF
3400	payment	1397	1397	1678	1	1	2940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FBEbPgp66rjW5ZLstaJWSb3J8admq5pYX8HCR3JR8EKCgZJR
3401	payment	1397	1397	1678	1	1	2941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttK2PFaPvf7CPZmDDDtnVPM1heqAXYwxkHhJ1L4wfVEeNGmuc
3404	payment	1397	1397	1678	1	1	2944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQb4Tm7e2eHgvQ2pzC98SP6n33ED1y4k3tm9yCjiam6bmx2Rhh
3412	payment	1397	1397	1678	1	1	2952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCEqZXo46T6sW6uKGRSFo2N8kmge7v2Nf3ZRTQdAbpU2sqgyg
3415	payment	1397	1397	1678	1	1	2955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8GtwJ5C8GkSZ99VZgvXbox38oS73U4L4W4cFTm48eJ7YLZTw
3416	payment	1397	1397	1678	1	1	2956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwNqD6bMwF5cGzRug9oQ9U3AD96UHtdvUYEaNWguysNBC2aAE
3421	payment	1397	1397	1678	1	1	2960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovTLCxzKs7jRwuv6jbbrmCQ9b7y4PkNkWNAq4KRxD8doWGYct
3425	payment	1397	1397	1678	1	1	2964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hEb2R6G72JxqZ1yR2nvAkHni3nwjArDAZUsXpoFPWb4ZJP8x
3429	payment	1397	1397	1678	1	1	2968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaizc126UzphYARQTL9ztW58XSesMfX9P5jijezPTdCPtkA7K
3435	payment	1397	1397	1678	1	1	2973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhXh5yWwkHX8UzE4BTdrs73UL2Va67i9ca2g6FyBwvZdKUgcN
3437	payment	1726	1726	1799	1	1	16	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZs7aHfEH3byJb7vzMspgTKj7C6r8bFAbyesp9fEGbLqWHXTHx8
3438	payment	1397	1397	1678	1	1	2975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSCsfmf16jJiiHmvaGkTC75ut9t69DyUCXewG8MVhRkq9pWd4
3443	payment	1397	1397	1678	1	1	2979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfASjFG1iV3vagEUKbVM6e19cvL1B4k75GgH7ehifnwjkAsPiK
3444	payment	1693	1693	636	1	1	229	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpaCwCRhjNseZwXej6A8ZbNj9RvKA5Jx3ivVVtLrpcBQHCrEWYXZ
3451	payment	1397	1397	1678	1	1	2986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QLfyUPQwdz9ov7JWwCuhJABPMbfwHFKLa2S81wRuN7fkpkxK
3455	payment	1397	1397	1678	1	1	2990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ62ipZWJB5n72HDStCKQec1nYRYWXmQVocujUAVLxd6Qbi81
3456	payment	1397	1397	1678	1	1	2991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba8JytSuvcNgAYbF2GUppAnAqPWrB99rNi4JgYToLL6WLzyb1
3463	payment	1397	1397	1678	1	1	2998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBcmZFt5Bf1R9UFLhG9VDPijB7rEmW1h6NdG12TGT8g7TUi7Y
3467	payment	1397	1397	1678	1	1	3002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9DqcrBkjfTEJmaqbL8CEUzqfTSNGiBHGgNwCN72WLBEroymF
3480	payment	1397	1397	1678	1	1	3014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxm9sdKsTaCiZJrYk8kpTBFD5pw5JW4SSB8nMRQK47fjxPTSU
3475	payment	1397	1397	1678	1	1	3010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnLjvL2opGKbSmmdy5CDg5HXxtii9tiAsPrq1pVdCJ61GCbrhg
3476	payment	1397	1397	1678	1	1	3011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRc1tNnrRmVdUrH9auaunjQ6daJrYtMfezdsJquWEJ5UGpmshF
3481	payment	1397	1397	1678	1	1	3015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbsTprZTBSjr7Y9wTzzEC5AaYjxqiD85spzVty8eWroaDsyGK
3485	payment	1397	1397	1678	1	1	3018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTryBZSHsLSLjBXYMfXCRxzsQVCXMEK5hso3EEDKjooQrruQ7
3495	payment	1397	1397	1678	1	1	3026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRW1md5bB5UQLdhMBJi9ERNj7BpzyQA8e4vxKvVg2MP4NKhTPJ
3499	payment	1397	1397	1678	1	1	3030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPz9mNZ4934m6YCdiP64pXrHYhyTwTWrE74qyqcdBdbd4MzbYD
3503	payment	1397	1397	1678	1	1	3034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRyH9Bi9zCrmiGVqnM2xYbAXGcvm31SiLzxWobaDCaM8H1MJ6
3504	payment	1601	1601	1601	1	1	0	10000000	10000000	\N	E4YfQtEE5riQhULZebpZhunzgAL9Vabysd4rjkzTS358sDUd1dYN5	CkpZx9pYW49dDhqyhuYSda629gCpQ5WpxSczK4wAXtmzYVDZeMXBj
3505	payment	1397	1397	1678	1	1	3035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwYUANid4kfDqwXrwbssLDfdioF1P8AaEuJfXXLDvzbc9GCW9
3525	payment	1693	1693	205	1	1	243	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZBGJwvnANGyWegsCx8BSp7HQgUn5vnMrPoLqqpLViqv5uExqFh
3526	payment	1601	1601	1022	1	1	4	928188100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZEqinHKXx1uQcyyu4qdjVZ41x9nzw22pyzo9WNshpTTcpuFZ6D
3527	payment	1693	1693	402	1	1	244	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZSUK2yupSDuQDdrCZLdJvfC2jWQKa3YBvwuokQA1X5PazQMiTf
3528	payment	1397	1397	1678	1	1	3039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMr4DUs6Ewu3u5631qPwwQsfkkhPh44KAxdF7vSRcXbzwXw9J
3529	payment	1693	1693	397	1	1	245	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZxbw7LYDZKsHeyQs2sGUySorVHvtzMx7cPCWKXf2Lb118vmjPa
3530	payment	1693	1693	690	1	1	246	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYhAcs8DhhmqA44j2TSsb839mmUJaWEysNXtUnyG7yw63EyQbnF
3531	payment	1693	1693	894	1	1	247	308541912361	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa5DTV7hw8dpYbq6B7UWoyqPNUvXohvUjYVXPdR5YsJANHxzdEU
3532	payment	1693	1693	106	1	1	248	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZKkfJreakgdd2SrB66TFCQp3F6qrAz34RK3nUuuz7R514zQ5Xr
3533	payment	1693	1693	534	1	1	249	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ4rjwWaXEnYN4YqoWKU3gRvFUQCkfwf5F9SnVginJgkR1ttc9M
3534	payment	1693	1693	5	1	1	250	6734520375	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYkqkKdpkrkbWJQzuDh8ffiphuJKTKSGisSguY1LovkueDrHJwe
3535	payment	1693	1693	339	1	1	251	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa3QbX3A1mu7PN53gkBDUxfvkYZsy9cMqocSbh26yvSbM9ApuaG
3556	payment	1693	1693	395	1	1	270	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ9hoLxFWmu4Gbbz5K4Ci9ELiwj9JYzj2cgFjq1gsufj9by3AaL
3557	payment	1397	1397	1678	1	1	3042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgyk9sScvo6BTXpSPPswBAUMU95cDgPujSVXU9FoNCsc13X1m
3558	payment	1693	1693	84	1	1	271	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaFYEDPGg3SiMJLbuud6LSssExwtLSKe2hVoxyhx9rgghNvLiL1
3559	payment	1693	1693	320	1	1	272	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZXCSFB7TQNZHg4SQNwtDw71kqiQ1HNNnPnLEuQaoytK26D3RTu
3560	payment	1693	1693	587	1	1	273	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYVQujNM3rfSxw8kD4HAxBRvj7XSqigJNQo4CttTkhhaDw3ZU2R
3561	payment	1693	1693	611	1	1	274	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYz9J9LpE5Fv5ZtKnwtBkXcNMWuPqAN5UYrVZCiLvecEkVK9Tk4
3562	payment	1693	1693	678	1	1	275	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ19dgutcoXof4pGepeaouNVuS4RtfCLM46wZYA4bhCzHNu2PcY
3563	payment	1693	1693	710	1	1	276	5028012826	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZz8BfiKoVbwMPdHNqXrC76kqWq6PpXChgBqMsfZFe9dD3YM3d5
3564	payment	1693	1693	295	1	1	277	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYhRVLcRYgeH2HmvUKtMAJinXAWPH6UJofymbMQrjaZaYsmhioc
3565	payment	1693	1693	721	1	1	278	2011205120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYnzsJkyKmj6byrkLXNAxVVhLYsbRxFt624zhkUo7mv3KkKw9BU
3566	payment	1397	1397	1678	1	1	3043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe93RJEvQnaB4yq3GDJBHj3c31vki2c4ethL9FBGUDWCnCMU7a
3567	payment	1693	1693	392	1	1	279	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZjke7dGmHppm2HHDFaQxMcejTXJSKDbZBiFJJsKYRwT2yVLMj2
3568	payment	1693	1693	560	1	1	280	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYaX7BjShfmSd2KkUe76dcBWKdtyV7MYsYfXJbJQtLWkYGYpsir
3569	payment	1693	1693	194	1	1	281	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZneMsKVFNh4Sxu7T4nwK6RzAY3VaTF9fB44g2xx5mTWzSJxtAH
3570	payment	1693	1693	252	1	1	282	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZA3q7iNyx6taraJz83EthBi4zyohuj7zg4ZdqSRPYnkbbVDAT6
3571	payment	1693	1693	150	1	1	283	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaGUHo3KD4YH5UQdFJTFPJFzXhcY1GgfzbLwuJSDjHfgRrqfmSp
3572	payment	1693	1693	450	1	1	284	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYzbtoYHk2qr2khmukLkRE9gSyfTvkfZGGgovCGyXPamP6qKXse
3573	payment	1693	1693	653	1	1	285	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZeViNy8Kb5PvLJib6jN9qvEv56A5srEUJPshLzcv3WjWdMkbZp
3477	payment	1397	1397	1678	1	1	3012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6ws27dKYirCdbH34AMBBdCo7gdEiQtDioz6sFPQftakpBGjE
3478	payment	1726	1726	1802	1	1	18	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZyEKrw1pzSJyxAGEtKLLNGyMB9P1zAZ34o7SrrTsFnLcid9h69
3479	payment	1397	1397	1678	1	1	3013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEsGLeEayxGsPzYfQ2kVVDrXBJA7RooJ2LC8uBhXfpwK8iQTQ
3497	payment	1397	1397	1678	1	1	3028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDButeUZYuVz9xzdFYAN5BarHZGSo7yVjFnc9hGt54GNruWZ2b
3502	payment	1397	1397	1678	1	1	3033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qDXpZbg4KFBAunfn57e1f3eA5JzxtJ1M6NGjoGPcwZwzUSjD
3536	payment	1397	1397	1678	1	1	3040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvFmhcxLooctHVNk4zTE79MvNbhoU1ibY8ByyYtrJTdJA6buz
3537	payment	1693	1693	206	1	1	252	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaDfxH2B5FjPFGwc1eafHdDnzFYegipnWS1o5ZMorhX5uPS8odC
3538	payment	1693	1693	122	1	1	253	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYcdgdSVcck7M5Juxo8KTXZiDMeNnxPpdUKq2c6TA22T6S3dy8S
3539	payment	1693	1693	91	1	1	254	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZvKmDTdjZnFaQFV7MRrmdY2Mqbr3vE94fRXXFFzrD56Sv7VgSq
3540	payment	1693	1693	99	1	1	255	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYcH2aXRNV5FcUGkntrWsuHe9PpjcN3GY8Lv6uC2HeWkYdqTEpK
3541	payment	1693	1693	399	1	1	256	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZdFqgianzaisgQMRpn87hmDAx17emPMdSgAW79wzZFYCc2obex
3542	payment	1693	1693	408	1	1	257	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZrYDrLLjTp2tdCt7XwBhW9vXKDNRaDGtKs5fAivZREfhPyzNHn
3543	payment	1693	1693	420	1	1	258	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYkwn7soy5LGLzeNiBHNjTJDGwePHBwLCtD8U5dpWJu2bnXkDcs
3544	payment	1693	1693	438	1	1	259	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa2KFJB56ykdG27xoZjYuY5a4iAXNw76wH1KDvy6UkEMXFwanaw
3545	payment	1693	1693	570	1	1	260	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYV1N8eanSpnyux7D6XzD9LQv14iC6U37GduWTrVNYjwQp36dWp
3546	payment	1397	1397	1678	1	1	3041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsW8BxeH4EeVs1dwGRBJLFKSwmimHUKoubcemZUL7XNEBNpEd
3547	payment	1693	1693	105	1	1	261	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaDPKfXCghuZYGz9ruS1EGMQbDGVPEM8mpwNqKvtajvJSJzG7PD
3548	payment	1693	1693	910	1	1	262	505587899696	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZTHU2MV8CHAVY261yZJJnqtHQnVtRAfYkNzpGGAhHd8ysTtBxU
3549	payment	1693	1693	322	1	1	263	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZpARaYPQZzGcLSoT2DZpYHgRS6yLWQB6ohBrHNN4foRs7oUCY9
3550	payment	1693	1693	29	1	1	264	7039217960	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYc1nbwVRb2JYFJ9f5FECNTx1sGe5SjoQQuyXyF2WnN2DsjgUph
3551	payment	1693	1693	92	1	1	265	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZn157R9gmtmLao5DUDQJLaZmSYBrKdctZ2da9bdyaEti65wkFV
3552	payment	1693	1693	89	1	1	266	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZQCBff7CH78dofUuYuNFKXkn6BygpPrNRqCtB6bQTXgk2TMDkf
3553	payment	1693	1693	146	1	1	267	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYep3WZdDwWrVV5irRUSserSEZvB4DjgTpw8npJRapHN2NZDoDB
3554	payment	1693	1693	251	1	1	268	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYsKJqWVUq3afCSoM8ghW5pGyxxEvbsaUVG8nkQ7Nuq7TpQToX5
3555	payment	1693	1693	500	1	1	269	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZZRG698yUFYB7sS4kA71QPgbvKymSTKii1f2uAVJGV5ebWF4Bg
3575	payment	1397	1397	1678	1	1	3044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqr9zZniWkmkcDic9HXDH1kUCeiED5VqCVxDFvhhYQfNZRW8Q7
3576	payment	1693	1693	245	1	1	287	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZxLG6ZpwZkfemVxzmcQkj3isfwEu8kuRWkcdCLbQDcarVvgYyN
3577	payment	1693	1693	520	1	1	288	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZDpsdyPKNYtGrGmd4RPhaUwW8f7778FP96vaPcN23qu6jGttg8
3578	payment	1693	1693	620	1	1	289	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZj9c2YFc4mm5g9ayF9k9H9HSfyGd7fsvzrVqm8xKriDT1xW7BS
3579	payment	1693	1693	37	1	1	290	65694004451	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZAimpzfCpBvoWFzC9VyqrJuhLzJLtZ9732FJQsqeoH2fmZQ6B8
3580	payment	1693	1693	622	1	1	291	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYaL7mpnSH8Rpz8qQ7p4wDVYtjZB5cN8MiujeZjEKn3uwgGnkjS
3581	payment	1693	1693	54	1	1	292	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZg8MhHM4tic3xBQgYGYqeP92xUJwALvqUf4SCkjTb5YoUPNXhp
3582	payment	1693	1693	78	1	1	293	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ6L3f5sPYCBExYcqV7tkJ46CyGctw7HmgEJiM5zBbemmHDrqAH
3583	payment	1693	1693	594	1	1	294	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZAkY69LaW9z5Adqfxcsmkhd4asuTqTZxoqQK9518BkpqZnUjxb
3584	payment	1693	1693	739	1	1	295	10056025652	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZztA9Kh1KEjpQv7DMTKg9ZkJYmUfoBgxzYhhFKrApiwYbYwJQp
3615	payment	1726	1726	1804	1	1	20	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgw3t1xdL9ARwnC1QE2KdKm129h2hbG7LjErHuEFy9asXWfqSj
3616	payment	1726	1726	1805	1	1	21	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvWrydwUiruxD4bWVA87dqi7X2GS9HgsF3S4biJyvJ6HPwnFP7
3617	payment	1726	1726	1806	1	1	22	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcmXWtCcxBhDFrU3DpbA8FBPEy7DAgM5LNP78FvdPVjNwxzBnu
3486	payment	1397	1397	1678	1	1	3019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8nHqsonogPnUYfpKqXLNvsKSbmgjnxQseP1ENbhBiKzjHFdH
3489	payment	1397	1397	1678	1	1	3022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVQb7HCTyEp4VBCDpPXqj7jViXm72sGWquQe25y2N3AyG9AYo
3496	payment	1397	1397	1678	1	1	3027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWfaHNrqXCPxK3CRsq4bhnnphuhA7dzch4UyUZFcbpuUitK21
3500	payment	1397	1397	1678	1	1	3031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBHn2KcP9TrHvEg7KVNWKwAq48aWmV5MDhRhRwi4SYxySfUDV
3513	payment	1601	1601	1142	1	1	2	1662804100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYx9A2aHvQM4qHEEkckUHw6RXBsdK5izZsdg6zy8VJXwoj1Hjdn
3514	payment	1601	1601	1262	1	1	3	1121760100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYe9wbVsb33uQUyzMg3xf1fJNX53jwm5jzFxPzk2vTDAAY4sgjr
3515	payment	1397	1397	1678	1	1	3038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAG486raGHFAvHtKCVzsPfJUnyZSuvKnv5DzChwJMtkNeppey
3516	payment	1693	1693	304	1	1	234	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZiLHNKr5BEmAzB6YxY6ojRvxejVSBHqcNvo8EHz74Nq4ZqMGTW
3517	payment	1693	1693	373	1	1	235	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaGaGVuY7bvmVLkKd5uueg7CUYgRvE8HbN2k3jVEcXjKMj6Kx1h
3518	payment	1693	1693	877	1	1	236	204190785475	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYyT38BBKgtL5AeLXx9aoyz22F1a7LYC3w4kNswkzHQvP3vKrQX
3519	payment	1693	1693	217	1	1	237	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZNmwyCJrxRTRu8UkCRiMsQs4sS9tL71Q5FLm7XU21WwfaqABud
3520	payment	1693	1693	309	1	1	238	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZcKBD7MQdRoQDVqMYEAwjKvaj7SHMYuYdmcMkskugKB3xgiL4L
3521	payment	1693	1693	731	1	1	239	2011205120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYa1gjkxVX5BTdbQCKYqbKZfszYyUBKTEycAR3Cu9grvCsEP825
3522	payment	1693	1693	275	1	1	240	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZgtrJzmrmzMVuz2zxxJs3CVkCXPq9Egaxa9KAuJxYqtC5uw3Pa
3523	payment	1693	1693	138	1	1	241	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZWVP3FCL4VAJ5ADECpfbN2tF4scyFCppQSYBHUbf4QSzDB6LtW
3524	payment	1693	1693	1030	1	1	242	906009184400	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ7REkqHALjTcvs6Xg5aDsFbe9LrXF422irwoaV1Wav3WLpTKAm
3605	payment	1397	1397	1678	1	1	3047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9k51qBd2QjCuZRZzMTayVsmECo9ShEpXA5f957GahYSNTkwZ2
3606	payment	1693	1693	352	1	1	314	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZNzRCC1easRM5Yz9Lh79QjbNM13c2tJp9LcxMBpseupKbKJkfm
3607	payment	1693	1693	266	1	1	315	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa5fEyaFf8zGbrQJEFyobpLeywgoUQ1aWPEoERhB2e2FSb2aBMi
3608	payment	1693	1693	600	1	1	316	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZhFjNYV6W3Zjd4dgGhQgwBmUxpSKoNpBTMj7TALFEQY8EwBmy4
3609	payment	1693	1693	691	1	1	317	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZuLXvDXcdNn4K4eTjgkDWAqHDQJRUebZjJFFwk39fdJWHySZoD
3610	payment	1693	1693	377	1	1	318	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaC9bJc2LHmmaN7BTyCEs1Z1q8vLS5EAUYb2aiTbPy4UkTjr86q
3611	payment	1693	1693	63	1	1	319	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZoTKSe71p4ZfmPypadggJ63U5z7sV2JRaBvb1zsiKa4ePFmN9d
3612	payment	1693	1693	103	1	1	320	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZEmTU2vrgvPMWgHSqRi5vjpeVjV4Jve4evLmBXWsfpNY8pMT6C
3613	payment	1693	1693	361	1	1	321	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYakbUboMuaYnzjAuM4ZbpT1Lq9gWsANjxvaQ9RtiYYQK6zD7FW
3614	payment	1693	1693	82	1	1	322	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZT1YjmjFTbdNcLjbupSmSxnzG3SsdLGkFRmPvnwaeFLKEnYkaz
3637	payment	1693	1693	878	1	1	336	204190785475	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYuuR8ccDCW5geQbBsdsPYUQfiARaQCAyiH3bZJi2qLqpJHFwZd
3638	payment	1693	1693	41	1	1	337	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZW5VwoyRYe46hV7nVhHZqwVFS9b7jVJV4q85NYGAvSsgXNaHAE
3639	payment	1693	1693	308	1	1	338	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZkG7x9UFzrzhPbSThEdyqKcAN91bkksQAJJbc9Ek8dt3Bsr2Cv
3640	payment	1397	1397	1678	1	1	3053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCx8eu7J4fpLZqLGQG7uybkMn5JRV5jh1QZsg1Upcu35gPu7c
3641	payment	1397	1397	1678	1	1	3054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBkhtLow2tJihvbYu2TSyS97vkufbXMBHxiZK3H2m7tZxdzXV
3642	payment	1693	1693	237	1	1	339	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYecpwJsRXPTVAuATdbA6UyTGRQn1tiPoyCegfbQijCwSgFmfjF
3643	delegation	1769	1769	44	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYrh8j6T8P7V5ZXyGYixzXNAKhqYWMg3BvYj3di5fLAX5bKNh
3644	payment	1769	1769	1769	1	1	11	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3qek736KTmJxg4hDCEULnA7eBhJ27389JVZtWrPBcU4YqDBU
3645	delegation	1769	1769	44	1	1	12	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjN3oMXuTzqKP7Dhdjf2LoGMWi168smNDCtZ4GNB5BwEPyjFaZ
3652	payment	1726	1726	1808	1	1	25	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa4buYuLnqgH8UymfP6d8bf3Eq9Pnc7h7s6kQyLrXhqdfqqp7fZ
3656	payment	1397	1397	1678	1	1	3062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8tNHAnJEkafAyu5LSY7oXrJEutSVf9u3GosPXb4jVuXgaEj9
3661	payment	1397	1397	1678	1	1	3065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXY3RbfYV6Fds3GQWLD3HsHxeBCz3JKxjVYrR3k1Wpg1zGJ6Ey
3487	payment	1397	1397	1678	1	1	3020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJhinT7Dnqux6jYDhRcR9n2HgGpaBM3XFyeeJPe1DbHwLDZ4W
3488	payment	1397	1397	1678	1	1	3021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdhwtrsWAF1vWzNDHGrfTrMwLabgtqmSgieaYLRGdHNBD6oWk
3490	payment	1397	1397	1678	1	1	3023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1nf5f1qTfzLfDpr7FrqJoy1G6sxc6E3RYxxP6XGpqvZzXuLK
3491	payment	1397	1397	1678	1	1	3024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsTDbvAj5itUxhbJ1E6GbwyDJyfrnuywFsLGjgk1ydPxRyqXH
3492	payment	1769	1769	1678	1	1	8	100000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpPmxThyKMZNLnQtGJSPN6PaaxhNtcL3pmTgEp2A2oztVbd5N
3493	delegation	1769	1769	1407	1	1	9	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3iseWsyAzHKQgAejtJTmx3tSxLj2XU9SnCEp8WGLKvinmgLZ
3494	payment	1397	1397	1678	1	1	3025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9c1i1tx7tkmVHfQx5pCWTQB5aivxs1kv3xKFywpZwGWKxUJ1
3498	payment	1397	1397	1678	1	1	3029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXMUpkHsHXDBuovwF3fr6cgGvqPNbVmae4UeoKiA5CLDB95Rq
3501	payment	1397	1397	1678	1	1	3032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQUxAqDGtMiGXAod9TMfNPeECnCkkE2Yf58eSZ3R4caoKiWmhU
3506	payment	1601	1601	1388	1	1	1	3126564100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYTwqEsoTcYmXAy5EDQsthn4MREoRDdTozgSwRK6EkreDPviF1a
3507	payment	1693	1693	569	1	1	230	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYYAVbq5wk9nz6z3oPP9WF39DHG42Qat5xAHLrDGvLq33Ab3RCm
3508	payment	1397	1397	1678	1	1	3036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSdqyrMtwyXfzH5C4S3DU19fQsEB16NvxF6tRuGGXVkZp3CT3
3509	payment	1693	1693	745	1	1	231	2011205120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYTu7BxKJvSU3dXAy2EKRZuRyns9d8qAhWLLmCYUwcz2eittnAc
3510	payment	1693	1693	225	1	1	232	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYVVoMzgbg7ugR4fy3w7bd7QCAvGZwfa19dQtyN3617JyhnjxsK
3511	payment	1397	1397	1678	1	1	3037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Z95FVgmVBjBZCZMm8zCtrcYXwquzXvmgw62DF7XVTHWYGzfP
3512	payment	1693	1693	191	1	1	233	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZz8amXMzfSuAKncz1tq9ohmunZztfYdNZWo27RNQcTZj9vFXEz
3585	payment	1693	1693	163	1	1	296	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYr9fVWaaT4aAyQpGQTpfV1noBx9HFPiEtcrFsxghoqog9uk2N8
3586	payment	1397	1397	1678	1	1	3045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKtrFYANVbXqzRDWTANYka192rPH9ok8tFPf36sycPgxs3Uxj
3587	payment	1693	1693	1150	1	1	297	611302450224	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaBAsH2MEGHDHv3YMfznywrMcPioh2jfMRGXj27jfsX44c4GepA
3588	payment	1693	1693	452	1	1	298	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa3UjZ8FvCDokJruEiA6EMPUnN8idouy8ihiyYovdg5rTSyRrDm
3589	payment	1693	1693	193	1	1	299	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZSx2GGYrFw3iD7cY9xu3bTSP6FchswSYZGii8vCmFcDumWaEsE
3590	payment	1693	1693	391	1	1	300	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZTL7JgYBuZyiW8rVVTVmxhxKhVEtb7e5gQ8pN5hRTMiBXVRE5u
3591	payment	1693	1693	593	1	1	301	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa7yCSEymLUwmuQDyvTU33CmfPtzDRYXrA68r9o8evnWpep6Hj8
3592	payment	1693	1693	660	1	1	302	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaJHpuLChkPHxWJ2GGpQvzeipG2pMAYBCrYN6Q6nFjrLTfutqTw
3593	payment	1693	1693	6	1	1	303	32740408344	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaL4HJQw2HTRpvwA8SUigJnEMZK2oZmR8sxh8CSdiyDKH7bKnxC
3594	payment	1693	1693	504	1	1	304	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYWrW5RvE9UKwVww28TEyN7PfwKabyyqvffrWpJurqLZuesreMi
3653	payment	1397	1397	1678	1	1	3059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTum67y7pA7zzR7ooa86C9hd843iKNbLoeEvnZQKqaMzCowLR
3655	payment	1397	1397	1678	1	1	3061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSp2Ymwc14CztTv4gDqQvR4gJaBWddxhDmT37xQcRzS8yy8q2
3657	payment	1726	1726	1809	1	1	26	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZyF9gyeTqRw1fsCGWCNKPQLqGBQhRJz4pbvAfZk5ZKAG5wWzxA
3658	payment	1397	1397	1678	1	1	3063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXihw7hgfQ3rdm7vsjSF7jPsvJnyn1agLQGJoiMGk4UcvKpdzy
3659	payment	1397	1397	1678	1	1	3064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfjVUsL97EnGtSoqnPWoo6derqZrGWzZcGopdABVYhgcyV62ub
3660	delegation	1801	1801	1537	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xXNexoLWbo5xsbp9gX2moBEvVgvWqFVCauJdVZ5RVB8Eu2UW
3663	payment	1397	1397	1678	1	1	3067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fuk3tibHSmTEhybPUafTSR9ppTtSQY5SxPKTdg9HJt1GXNv1
3664	payment	1397	1397	1678	1	1	3068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79NGU9jYWjDCmBLnX5pEFdkmeJJyneyV3xtDydBwk7D5CXpfd
3665	payment	1397	1397	1678	1	1	3069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqQZfW4efcFVuKn15mxgZGRFu42Y2UMkbyk9LDBi2pkTJKBFS
3679	payment	1397	1397	1678	1	1	3077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTsBSxbLzamYrtDAcC18MXKPkDAyfLTBiK9vRprsqQ5p7Z7NcF
3574	payment	1693	1693	421	1	1	286	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZP6GVDxuDQQTRQFnhA2CjFYuuHoymAHES4hmwre7FgfKStuAcF
3595	payment	1693	1693	658	1	1	305	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYeRuvftuQWRf7UjrAeQvmQrNiuXcW6ZDHR4EkwhUnPuo9KxV9Y
3596	payment	1693	1693	1276	1	1	306	1703448631520	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYq38x45DxL56C3nTPofmRipwggK955q8SibvrjCcqHNnPvprdc
3597	payment	1693	1693	180	1	1	307	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZeAPwc4cfAZszHTSyReaf9VLZUpR8t5HD8WczUpn6WQqyFFWPg
3598	payment	1397	1397	1678	1	1	3046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgfeqqy9cesncT4wpA6xgbJntfH3YjuLwiVpwh3qczwgKEyZz
3599	payment	1693	1693	652	1	1	308	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZznm4Bhs2KM8teMdaKwezcjhAJwGDGAJ82sHT6oJddJup3KXm4
3600	payment	1693	1693	893	1	1	309	308541912361	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZEaEATm435Sf7W4eXziQwgtUb6t33VKZjDMCE3WgndspWqdMBV
3601	payment	1693	1693	390	1	1	310	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZSAmjajMuTcvFmt7LR9BUg1PSrYbAPDn4WCWrJborsGje9FWGy
3602	payment	1693	1693	353	1	1	311	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa1zKjSdjnhrjozTeoqg8ri5frCCrMwFJhcAaB68HvPQxaHnXUj
3603	payment	1693	1693	108	1	1	312	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYtKPsUCua4qhH5iQ1nhAvzp8DtBYoQ4NznFYYLTTk7KuVgnQG3
3604	payment	1693	1693	601	1	1	313	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZqHxxDidzEHwCpnYSamCPLSSy8Losoxgypa7bLb2R1swWaapF1
3646	payment	1726	1726	1807	1	1	24	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHfU4UX85fyEEzxd5CcBLLQt8bVYzEpz9bJLwgkK3L4YAjcVU9
3647	payment	1693	1693	1778	1	1	340	1000000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpZrKCHRyMLEMAviAJdQMgCyVHzueusUiWHfrswpW592Kdwm5FMM
3648	payment	1397	1397	1678	1	1	3055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3jsLpTkjXGXbtw7t19rKADCrevLH5UEHuXySJ9SocEh9xSyX
3651	payment	1397	1397	1678	1	1	3058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJAdcRpUV8Aq6wyPN74bFFjXts6L8Ktd82N97pnwumGwghAjp
3666	payment	1397	1397	1678	1	1	3070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqD6ksLZgNyaTv7pvCynXgjiTchuU2NSwkCX1BxrccPA9TiQn
3667	payment	1726	1726	1810	1	1	27	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwYcogQzpEdXYULErga6vZJgHe5RwaE3YaNCK2UUL8j1BSndu6
3668	payment	1726	1726	1804	1	1	28	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhsgSQZNX1LW5ArqexFxxvTjtCSB2gevg17RRDw8cL2x6upsgy
3669	payment	1397	1397	1678	1	1	3071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLRW84RnePJsFhof6aWN6dcCTMTAaGR2Q4js7hogPQ6k2cCL4
3670	payment	1693	1693	1811	1	1	341	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZkasfDoz8HdasvqfDuidyuYLLiwmBmSDTbcmzJaggiT9MyJqDZ
3676	payment	1397	1397	1678	1	1	3075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWYUzhTYmr1bWmFDyAk4oWFZJQ3uV9PCR4CdXy1PMYdu9PHJi
3677	delegation	1811	1811	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUGLxyNqaS6i7s7EGAsQgBF2HoTwRMsuCh68EBjoXMXEDfRjh
3618	payment	1726	1726	240	1	1	23	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa6LMCdSRe8VsrJYo3xxQqdYsuwUYG5KBPcXAkzaYXdeRM6fR4L
3619	payment	1693	1693	261	1	1	323	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYkkzjCPEbQcDuDzxy54BhRhbjT4BdP3khMtA95nuSoV8YX8ZdV
3620	payment	1693	1693	201	1	1	324	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZj3WAVJW6byPMyzdFJmd5EnUJbKNp9bdKvPCxeWcNELGi7GdSU
3621	payment	1397	1397	1678	1	1	3048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WXNU35e5X5ZwhbMt6d4Gxww1jDMSFz1xVjRGqfvQhUXHmqdj
3622	payment	1693	1693	453	1	1	325	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	Ckpa3aMg8qs9WCq1vkc6Qd6uXvgKZvKHsjjbG6pmP6JaFVHyzmRAY
3623	payment	1693	1693	499	1	1	326	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZuMJgJUARVtLhgJ3NzXxgwJFQZMcB4oSNiDZV6C5DMoRCE2XWL
3624	payment	1693	1693	35	1	1	327	19307569271	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYS2oKXjUo8NTtg2T56dBo2bJpmKP6mjXFSViZf6mMBqrw9QCmd
3625	payment	1693	1693	383	1	1	328	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZGT37hJRsg8K8whBBh89SLX3opgmb5ii7nPfAJ38sFdmweSVBQ
3626	payment	1693	1693	663	1	1	329	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpaDPASB285wXHN84Ywp1ym8Vcjr42DfaKVg3KTxKrtMbXgZg5tx
3627	payment	1693	1693	127	1	1	330	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZ4rPmtGJD1uYPn4kg32QMp5Bh8FoXUuGyMtfPjSivWSnRSKJvg
3628	payment	1693	1693	680	1	1	331	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYX7MuZZLSzNEX6ubtPR9XQycKg4bXvuSmHJW1cR9JuiRowdCr2
3629	payment	1693	1693	49	1	1	332	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYtRpCzt14hjqHRYsUxqWKTYcNKSY6dQiTojV57zZ8eTm2WELPZ
3630	payment	1397	1397	1678	1	1	3049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2dN5nSMGk7q1Djcytx3vcSoP6ZU8i62P7cjsxAWZyxbndTa7
3631	payment	1397	1397	1678	1	1	3050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5j6hVevYWg2TxecxbYM81ej1pzp5qssNz8fMSoP22xBW7dBi
3632	payment	1397	1397	1678	1	1	3051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbuTQf6Xv4zzCf6f12GVtf6qJFyo9ywrrQvFcafnsN4qEn9Ac8
3633	payment	1397	1397	1678	1	1	3052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcZqsQw4wTtboSocBLrd6xzpHLpmFf676AhLCUZnLwkZqLrCG
3634	payment	1693	1693	112	1	1	333	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZrq6BSxjakdkfakhdERP54vHK9odkE5FfxUfRLEovbk9noiGGp
3635	payment	1693	1693	186	1	1	334	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpYf73pokqB1jFfnmgvMGXjCqFrWSSmUXKZXhLzURaVLPCh6nehM
3636	payment	1693	1693	551	1	1	335	66369769382	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNYV4AxmeBLfGWuE8LunQQJ	CkpZarqWsMaFQmPpjgRq2QYSv4fqBnZ3B6BinZW9Bxq89jwrA988N
3649	payment	1397	1397	1678	1	1	3056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKqaGgYPwUXNbHuGFebDbx9iAoZB4QEi2wiwAjcUfDjGxhXSi
3650	payment	1397	1397	1678	1	1	3057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRA559ksEj8NmbEs2jjCuZxbXhbjG9yPnpR699kRCSYuuX9vw
3654	payment	1397	1397	1678	1	1	3060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6q9euP3pWdG3iCB9vZFo6hiDjsiw7PyxpYLAqX3RB2uQDBQg
3671	payment	1397	1397	1678	1	1	3072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cBBMiwNCsZR6a1kKutqpeCyvgU3yZFMsVkrbHph2q6Kt9kE1
3672	payment	1800	1800	1812	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGidA2dyRS4yVL7BRaGjU3KoiXdJB8DH4gUEE4DLpkmw29HbF
3673	payment	1397	1397	1678	1	1	3073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36EfhSZavLMupsZqLtuWYqgcagmEifTKwZ5Vt9ShgdZmUr4ty
3674	payment	1800	1800	1812	1	1	1	0	1000000	\N	E4YoBrw9t4rJ5G6hA442bnEiuu5TJB6ppmeZjydc16D3BurVR9kzq	CkpaAQTEzK1kHK8wqsEVW7i7Y3dzSPgtth1x6FTEV6zsAYQftzGxx
3678	payment	1397	1397	1678	1	1	3076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGsfbaSS8XVVQ7JJWXstSUY4dE4M4qxVoxmGQUQE6WXSiMDNs
3662	payment	1397	1397	1678	1	1	3066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFmBvuMeRmts8MAzGGb3Sb4A1QGFkfbwYDyQ8gc5KJsArPLpW
3675	payment	1397	1397	1678	1	1	3074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYgtoE2eP8CsTUDAZSpefxwp7Vnj41VuBUybBtvy4TjpmAPbX
3680	payment	1726	1726	1813	1	1	29	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCScZ5G6LTPkmoRs7bYC364bjAKm4Uawo1t9EYLarojzziN3Xa
3681	payment	1397	1397	1678	1	1	3078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBu2QrcP66p9ZdQ8TU61LXv4NzSuqJptvSD2detVRtPQVfSZNE
3682	payment	1397	1397	1678	1	1	3079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtT5r5H8AfmVoAwgWA6ihuE9EWiCeX5aBTeoYTAGTVDw7TwcF
3683	payment	1397	1397	1678	1	1	3080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6PJBKQFwDQkz1oqKkoEHD1XobWqorvLQR7SLBoAJ5xKEd7Un
3684	payment	1726	1726	1814	1	1	30	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm9154YuArToRXZWSYK3dUwngR8CBtv33CrcAbczqh4gRgow1Y
3685	payment	1726	1726	1815	1	1	31	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2N7q3Z3w94V7MLAAdnFU6ziTTJamtfJU8CunsM4mydbMZjGxt
3686	payment	1397	1397	1678	1	1	3081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaw3fbyfnuDqQ4NY5r3iou9TLXRAirrj4tx1RoPLg3ed41FTGN
3687	delegation	237	237	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTK6DPEiGh1Zz1M8vVvQaE2EQaz1L46Njoav9FXkmNfqpSeZi
3688	payment	1397	1397	1678	1	1	3082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc8toDn1dF9tjF7cU9c9p6miu5d8SGX88iwjqjviADvQkxaJy
3689	payment	1397	1397	1678	1	1	3083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMAMPxEYNBhosZqAuge8pMdMTAtPz5LMigsyuDbuY9b9xM7S5
3690	payment	1397	1397	1678	1	1	3084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBcA1etydpybh9i1kkPKHvgm8Lz1kTTQnsEwwGGs7KLrvy2c7
3691	payment	1397	1397	1678	1	1	3085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbTwLsmD8vnBNCtnrXnQyHfooreGn9UKvMrc45xg2FfzFZoBq
3692	payment	1397	1397	1678	1	1	3086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHVpFXL5QkyT1PLqrFj2oj7KirQsurpBKS6hrGMMdCytEHxQo
3693	payment	1726	1726	96	1	1	32	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZjZS9aq19qGoT2sJ7Sy8YH4s9HMKz5xswwj6BnK9rnCZ2G55Ex
3694	payment	1397	1397	1678	1	1	3087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjRqFTFB23mTrqMFkQ7jLY1KVifZXQR2a9uzFQajE9x3c7hbG
3695	payment	1397	1397	1678	1	1	3088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtR1XarcTfsczrcKcDQVhDQRjjqjWaxJH2dGCmoRPq3MBvbLN9
3696	payment	1693	1693	1816	1	1	342	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZ79G4FVHbHHvVri6JY199VGLDtSMKCnQKeFmkRcC5Dw8vj1RiN
3697	payment	1397	1397	1678	1	1	3089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6hgg6TLRuyRxALg6fjAondJ5EeLev1ywQn4VcFCmEC1azmn5
3698	payment	1397	1397	1678	1	1	3090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XKxfXtx2FRTcDJT4GwCewVyrU7o1Lwjnzf4EKB8QAPPvEQ8b
3699	payment	1397	1397	1678	1	1	3091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXU5gJqrJ7AGbqU197pmETk5Eh2a8HLn7jBWxgYYQ8MkLNDTS
3700	payment	1397	1397	1678	1	1	3092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbva3DxxMCNLcZmg4zuJuyzpxijZCZBUGbAbLyrpckgxAqHLj
3701	payment	1397	1397	1678	1	1	3093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDN6TbJ2RGeYqJatLZrZ9GEqXNJKKrjacZ2EXT83efXUFmu9wC
3702	payment	1397	1397	1678	1	1	3094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsE76y7Jdnqj7wMa3b8Wnoi4KBVeQLFUGcT9HAr8kpa59vasK
3703	payment	1816	1816	1816	1	1	0	0	100000000	\N	E4ZPtX3pWGqoSdgMGBFQRoA8QzCXi2QnvvNKr6GGRoqmzNWLRiYnu	CkpYnH3dow9qYyzqfAqKVqeq7vaoUXNcUFZWzBnQa8sDTzwsREbVX
3704	payment	1397	1397	1678	1	1	3095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CSGLM5vHcTwwSL8KCDzyfKHKm1vsA3NHH8WYedkiG1C9m6jg
3705	payment	1397	1397	1678	1	1	3096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfodPdVE9CQPE9DJ3P51XS6xUH7UsktgVKPam3YH1t4fCH4por
3706	payment	1397	1397	1678	1	1	3097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YRrNXFq5vAEBMsWV82q87nHZQZJdThTtg9wfs5M9iGr3b2xM
3707	payment	1397	1397	1678	1	1	3098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwFJCnW9pSAYwYHB6KAf1DPAbxDbPaDEidsQc3GxUyCeJ9rvi
3708	payment	1397	1397	1678	1	1	3099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYhb8vSdofkxwbbpbAEeHv3qo59Q6EjED2NkUMyJ9DTHuYZkN
3709	payment	1397	1397	1678	1	1	3100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWshyfEuxrqqcNU9XoY6xsAdy13Pdup4AFkhDc3TrXiPNLDZks
3710	payment	1397	1397	1678	1	1	3101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6UGp3ZASzCxw8n6Ay5Uv36Qm91iCmwkprF9uzqzpSoU4xrMqT
3711	payment	1397	1397	1678	1	1	3102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gz8VxtpKP4uVMSd2nZDWC5BPRZhQzCKTQyCFo8Wphc4WkNdU
3712	payment	41	41	1811	1	1	0	153000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpjAi3qr6Q1s8xf3CgUQP1ADmXKq65XrARZNz2Akp5tKzubXP
3713	payment	6	6	1811	1	1	0	75000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3SxroH1A3P3BnAqk7CyXY3h6cG5me7RZ2p6pvga8AvszJiaM
3714	payment	1726	1726	1817	1	1	33	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa3G2kNxDbAKyjwMuR3r3ryxPbvypT6hG6jUvJo1xfUE3y4tsaR
3715	payment	739	739	1811	1	1	0	23000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKqmo4U7fvGi9qdvrrvV7sdmHrfAUoiUGKXGRxaE7ewkinHdY
3716	payment	1397	1397	1678	1	1	3103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZfUirjG9xAff5XizZE7XGTjjLyb5w484a8D3Mkv7ZTsFkqP9
3717	payment	1397	1397	1678	1	1	3104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaHJ24Dihq4TXx6hbWMdbPbBL2PRc6qGMovYPpTs4bBBr7b59
3718	payment	5	5	1811	1	1	0	15000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkjvHgAamTmSSbirs3MyvDZHhMdW8Zbb2H9qtv4sxtWaYiBy5
3723	payment	1397	1397	1678	1	1	3108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZizWDakTp5aUXje3ievd5dFKbD34s8NSqUEvEZ5hGE4ZQUzf
3731	payment	1397	1397	1678	1	1	3116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqiCfEQu21yH4GaBJdJWNqD5gastcKmasc3WtkbYE4PDKF3HL7
3736	payment	1397	1397	1678	1	1	3121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAw2mpwm5b3d4XJtVTGb7PskQkCXgCLRECcmuh5q9wyNwaf5Cf
3740	payment	1397	1397	1678	1	1	3125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgh9UFxbnBP997jXGZeygmE8CfhQTDtyw4RFhRNxENiY9rN4hC
3744	payment	1397	1397	1678	1	1	3129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRew1QY11cRjX81HpuLfdprwU2oftDqgiTiAuY4pXZCeaY1TJn
3746	payment	1397	1397	1678	1	1	3131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfCa4Z8GGZwU9QmU2xHm77U6fF9N7G2mrUoABR8sT4eDkbAMR
3747	payment	1397	1397	1678	1	1	3132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkdjDmaE4qjk1G48HkkHSg4HmqLZeWgTeDa8HjzXz3VD6n6St
3770	payment	1397	1397	1678	1	1	3142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyNmVLHPL4tmFhDxCYH2MGu9VzYED86wd7paqjVhtB6VhbxYF
3777	payment	1397	1397	1678	1	1	3147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKFg6KK5awMk3DBaomRwo2fZLD77KsgSbqHjoiUuEKE11D8Uy
3780	payment	1397	1397	1678	1	1	3150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZmsgcDPw3DVqUXhcD6ZcaNTLoGXD9Gp3DXJPTbTi6YZpnRXR
3781	payment	1397	1397	1678	1	1	3151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLc87Mse7bXz7pKPTwY3xkd24wT52q4fdGxG7JSkQR3H2ybET
3799	payment	1397	1397	1678	1	1	3167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcSBmehscKR57mej56MQbH1efnDNbNWmEYaYmXASQki7taPLZ
3804	payment	1397	1397	1678	1	1	3171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWWLCeSaUUuKZcEMGwMoh4h7MeZAE4jMJk31mNfLp8XpuTmii
3805	delegation	748	748	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGLEe8xDqTLTweFAYSxPDBNaXQwGWJXAq6kDWW25zUU6kN1ik
3806	payment	1397	1397	1678	1	1	3172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvPJXTw81zvg84LbQnVwtvAM6drKYYM6KDBqB3y2RXnXjKS5d
3812	payment	1397	1397	1678	1	1	3178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTm4etsAAfjpJQMjLSqhoT6c8ByEijd53qUPVW8CTaGZXXpBK
3813	payment	1397	1397	1678	1	1	3179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WGPwgEt79pAPZRzrDiY5Hu5T5sej8zchX2UcrWizBRkdBCJ8
3817	payment	1397	1397	1678	1	1	3183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5F4deb8Q8aQvmjf5RzTiHy2N4trYgqhM1an2z1DrnuYfkRNi6
3821	payment	1397	1397	1678	1	1	3187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPQvNrqQm6aqWxatRmYvM5Ah6NvNX2rijMrTDqu3LfcUzqz51
3826	payment	1397	1397	1678	1	1	3191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfh96W89ZbxxzYqkbLNNna9NwUVpogG2tR3Hm7em9cLm2eETG
3828	payment	1397	1397	1678	1	1	3193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25NissukEWwvNVu556kS1AW93ViYuSVFcUG5m6a77ZbXUJH9B
3829	payment	1397	1397	1678	1	1	3194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2zT6Wi3UcyEJs3SB7FmrewmpkMJBSQbyjLVwgepu3MSepccTC
3830	payment	1397	1397	1678	1	1	3195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84osczkmoqq3BKCbeHbpGB4eV7NNpuxqeDPh2XP4YrqRJknQu
3831	payment	1397	1397	1678	1	1	3196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ94Uom8F8H61jcgf5b4fKVfCoME8Q8hr3kMwkveHLmrETpw5T
3838	payment	1397	1397	1678	1	1	3203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPcJmZfiovTWNXkufiE1Kw3DBwhfe2y8vbKxWZAkNNvQV7MsN
3854	payment	1397	1397	1678	1	1	3212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWewMYiALVgj89dQGKDvTa9XNYputq6FLAvZhq6AL3ZHdJbYX7
3858	payment	1397	1397	1678	1	1	3216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYRYKxTCSgm5Rdj938c7kZotwRXqmTpNYHYLxJWRzk9rcW6ZM
3861	payment	281	281	1591	1	1	0	400000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ExXHywvubT2qHyh5rh2VgH9DPf2Xeba2Xd5U6Lcitarf8Fdi
3862	payment	1397	1397	1678	1	1	3219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHpsd5ti6BwiVy1t2BwxPr5gtz9Tc3or97K4bneaTAimUxzzA
3878	payment	1397	1397	1678	1	1	3234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjSMYSisQQAM7Vgrko4LgWhr82j2rvhw69LHk98PVYjcX9sU2
3879	payment	1397	1397	1678	1	1	3235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjTe9CrUfv5dPSYTNVtQnMnD4GQcmidgGLwwRqx4JHWz7wWc3
3887	payment	1397	1397	1678	1	1	3243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1UUEpJgdt6fhjM12fPxfvepRbzM53Gvn8VtVpfkDyQH5njEH
3900	delegation	1818	1818	1492	1	1	0	\N	11110000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjBhdxdDdCSPq2ywCUbi9zEbnkfuE1JxTDRPKtzZ332EdHS2G
3901	payment	1397	1397	1678	1	1	3254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGJ6o2hUSp9VDePZ5WFGESgFKUtf4Wkb1ok2NjkRFXgCn1Gn1
3902	payment	1397	1397	1678	1	1	3255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsF3i9d52rAMKfdBpdacnozyT8McCBzpSrnrTXqWV2Zdvnh68X
3719	payment	37	37	1811	1	1	0	150000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgq6fpe1jegBRtsjn7kmyF5TGfy6AYSomq5YXJocddiYqX1TWz
3720	payment	1397	1397	1678	1	1	3105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NSbuEaEvWTbagG7N8xW4aTmY9Rp7fEq19NfYTpvXtpDWyUms
3721	payment	1397	1397	1678	1	1	3106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCa6tNLB1AprfYvVDpDkNcZvUgjfS9ptVXgTcKq2ofgda2xUn
3722	payment	1397	1397	1678	1	1	3107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkctgi2BYv1LLWRGaH6zoT2YixYwdHf9DfmvQyXfVgd3g7ehyY
3728	payment	1397	1397	1678	1	1	3113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yh6Q2dCYFt16YYPFLY2Co1sNjDywh3Gi9TqEz4cUp8UETcxZ
3729	payment	1397	1397	1678	1	1	3114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9i27w5R7seYEiJArak8dvhWSRqjg9GDrXZUMn5HDFFmg9h8U
3730	payment	1397	1397	1678	1	1	3115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdcPAkTZdE3JBr1sAnwREDfzH83EvcwTWpH821apesXxFvirm
3732	payment	1397	1397	1678	1	1	3117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHQjAFT8UHpB6D2DPXkhTXPJy8a7fffeLxHpB5ep2q8R7SkL1
3733	payment	1397	1397	1678	1	1	3118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynrbEx8NVHavVSbfzRj5sYosXLogNtSinBqWqvZRBfNxHHCSz
3737	payment	1397	1397	1678	1	1	3122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5JEJjP2uBy6d98TtUZHR8cmVvKWWeQtH3tYWwWCG5xh5Jgys
3738	payment	1397	1397	1678	1	1	3123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJE8XNz93F1wTWgnZFwYTombJg4PtPtz98SttCyKd2fvXvuVz
3753	payment	1590	1590	542	1	1	3	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4BYa2btM5kQCceWBN2Z32VVrKnjinirUqM58Yn989u8mMEc3
3754	payment	1397	1397	1678	1	1	3137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTpGkg3RumJdrRo1GDk6aRsNFv5oMD7NchdRz9Un6wLPVANKc
3756	payment	1726	1726	1819	1	1	34	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqPvbQtJsuRthikeX6zMvoqPx3CDdECWXABt2smxWqEpQCF7Eo
3757	payment	1726	1726	354	1	1	35	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZemZGYGbPprEyAupCzCdzqQ4hhMP5tcZufTjeoFe1o7Tz1qiYp
3758	payment	1726	1726	354	1	1	36	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbBB8yfsj2HQH1SxzmWZbtzcjtuuxbmSbmEtMLU5JMEv6crjx3
3759	payment	1726	1726	458	1	1	37	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNWjGdiHYNtji4xwW8oZv7Ymzq6mJS9nHBybL8uYoJi2tytbvc
3760	payment	1726	1726	458	1	1	38	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYdHApNuDBuMksyxTmJrf4AwDwQSexCrwHkBHf4rttbtHjP4Zhi
3761	payment	1726	1726	711	1	1	39	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZPEH9hWsebfPUWVDDjg2FZNHodfujS3GpdpWsKmYAoMHgvRqo8
3762	payment	1726	1726	711	1	1	40	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaFQnPRvZCi79bk7bfkJetQdUWPkGD3ycLg5qhPPQuiZfoZALvt
3763	payment	1726	1726	748	1	1	41	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa3AS5qR6rQCB8thhujARJ9TSYXqbjGG18heW7hZRf53pae1iAm
3764	payment	1726	1726	748	1	1	42	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZothZvHMnrNpVmZYL13iG8YuvbrrtaLFVDUp1ngZiXv5MhxVCB
3765	payment	1726	1726	1488	1	1	43	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYUcbGwf13HNoBy6ZTiy3VDgmdWbSqnirWWEb2f5rK8z9kZeZUx
3766	payment	1726	1726	1488	1	1	44	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZN9RsgB5VZ8H4qNBBpnGy8Gav1kf1byQjQB51YGYtXa4BRCXG5
3767	payment	1397	1397	1678	1	1	3139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4t8MzC4UU1VBapyqz9ivhPwHMNVZad9iA3NScMYPhRdivkjan
3768	payment	1397	1397	1678	1	1	3140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvvr7jCwmyVRNpDdJsH6qu1nC3EFJXQX4vug2ngcMZJkSmCXF
3769	payment	1397	1397	1678	1	1	3141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Acpdi5cK3zg5ixy44mDwPTxJdua67VeUV7AiiR5SwE1o9Sxz
3772	payment	1397	1397	1678	1	1	3144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbitc9szeQjG18kir7DeAf8bxpJKBYzPRqUsLjXcVVyfgPaA4X
3773	payment	1397	1397	1678	1	1	3145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHuBcbJs6ZuR9ZksBSnfPq5SfzP3Vgktw92YBmh9tja2H2xUL
3784	payment	1397	1397	1678	1	1	3153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1JzDn4MW8i3sLJ2kkjLPCaDPqpFAhySoYAEh8c6tx7rXc9m6
3802	delegation	354	354	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHyaGbz83ytHyxXpKmeJSv91osNb5eJVSK3vcjhJXhCZnvWEa
3803	payment	1397	1397	1678	1	1	3170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZds8hJUwb3C1mz7gneLoTjFP5CieRbT2wdYUWaL2D3te9C2cj2
3811	payment	1397	1397	1678	1	1	3177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK5UXYGKgJbjxf2nEiB7mc1risLCYHFrx3pFvSaV6EZzjkabN
3822	delegation	1803	1803	1540	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1NbdQMETRpurLJftPiWnwWpkXTGHhaUGCuGnzMBHDquPyZ4W
3823	payment	1397	1397	1678	1	1	3188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidF9BzMZZmYnjU1L5p5npUWJCcJRjKPmZGrHAgaGiYRNRYxp4
3824	payment	1397	1397	1678	1	1	3189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXSdZ3KZwKmTaWmzFEMwcMDKj89R14nbniQMzY5oRtYE1rhyJ
3836	payment	1397	1397	1678	1	1	3201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpa92gB6LvhxaiSnUwFwqmrgv2o6tZfsNEM9vBW75jo8kRNro
3837	payment	1397	1397	1678	1	1	3202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQr1bU3jvjbbKv2wWsCnzL93pBKRzh47TKiktK5MRQ6Fm9KhS
3724	payment	1397	1397	1678	1	1	3109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmmpmvapWYDEfxBAJenb1cjRStPN7cWgcRHoxV2f1Ro2V2bRRK
3725	payment	1397	1397	1678	1	1	3110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDNUEtJnJCjmFtupTefW3ALqQtra7QVYjB1WBn3f2kyZ9tiuJ
3726	payment	1397	1397	1678	1	1	3111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyGQ7TtBRKfUG2R5vP7Fh6WGL3DCaVC4fDsf3pETREym2q3c3
3734	payment	1397	1397	1678	1	1	3119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ovEMVREiGqdnESZaPbd7NvmnAJpL6Qnr9mLTfWgFfEQQL1VY
3741	payment	1397	1397	1678	1	1	3126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLmw7DrMT7hPTJuQDBAT9BmErXk3ALDtSr1en522uJL55TZwQ
3742	payment	1397	1397	1678	1	1	3127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVspYMYRwhwNBeMb2AuG3EhAKCdRAvRtEGxt5JeYZhGkGh78T
3745	payment	1397	1397	1678	1	1	3130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9moXs26PW8FmzniMXSyrj4qDBKFimX3k2oQKkcqMc36zrYkiZ
3755	payment	1397	1397	1678	1	1	3138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY1UjgemaFdWehW2BwEqQG6zbXyvxnJxianitDRcom9Tshq9x
3774	delegation	636	636	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRE7rSvJAiT1Vh5nQRpgaffCmje6PDUFURzRYQVePpwouYydxg
3775	payment	1726	1726	281	1	1	45	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2kTQCE36j8JVf7jjH1VZYBtfisx6H5waJuiBCZjKhq8bP8BiM
3776	payment	1397	1397	1678	1	1	3146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwR6p9aoLoNWkwsWDAXdbPKGZ4XGwEhyGgkryrZHQMiQjsS4tR
3779	payment	1397	1397	1678	1	1	3149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVGsf78gBJWzD9xqHPV2qPxWMdjjcfnAkx9KVPqYQU8E81MS7
3788	payment	1397	1397	1678	1	1	3157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ovpMDeZonVUcE9evHuLerGDMWScRyERn3iPPbyf3z4ksFRUu
3789	payment	1397	1397	1678	1	1	3158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7uTasTqUM4LxNNt48qrNAW8PzAS1wHPbu27n5JiHYm7ZFRVS
3790	payment	1726	1726	1820	1	1	47	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm1n7e6KhUYs5E5kRTysd3gXoRzhKT6Tbo7qjwpLy2hDJaGrRJ
3791	payment	1397	1397	1678	1	1	3159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrg75qMDaZQXyuZPqB7YtLeRSTcVWffGWZ9cfQcap1aEzc3Va
3792	payment	1397	1397	1678	1	1	3160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetkDgK3i5EbwZRXFV6AP2og5WPjFiycBEdiCCKxxW5UonwvsF
3793	payment	1397	1397	1678	1	1	3161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxFatjkeoEjJnVRrdheNP5dudoNR3VRiy7p5ercbEJMZS9hU1p
3794	payment	1397	1397	1678	1	1	3162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EMLMKf4UcoKvjsa9CRURPRirk7kG7CY1QKmkNhh1uFwrnXNV
3795	payment	1397	1397	1678	1	1	3163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUagEPiqpjbnhKj9Dns1Hey2KGcwsNSVBB1h6kiVufxguxL7kE
3796	payment	1397	1397	1678	1	1	3164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5RHH51wBmizPc6STr6jpSKwUmm9WtAfJGUQzmf4fNiKVkHeH
3797	payment	1397	1397	1678	1	1	3165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWnkX3VjypSonbe4LoQg9sTRaWdtuyQmMpyYPFs6rmJdgdhXe
3798	payment	1397	1397	1678	1	1	3166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ygLNpnGrY59HCeNhcgDMq53SvDn8aL3RgMWpvu59qb1xvACv
3800	payment	1397	1397	1678	1	1	3168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DXGaSL7HZyGbZjM2j2H5W3vc5tnVnp5UAEkrcue6Pn2XkWwH
3801	payment	1397	1397	1678	1	1	3169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZL2zwXsnyLry2Zi2TSN63rjXJKGqjjqkhXVh8ujLAFL4dGD1
3807	payment	1397	1397	1678	1	1	3173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGE4C3rjCuVwF2LDJ2AfSeiepn2L6TLopAXsEfzxj6Fet3Yyfv
3808	payment	1397	1397	1678	1	1	3174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw74PCYmhHhEHvYrHCwRe7Q6S65xnCsa4Fbt3So1HVKjxBysbc
3809	payment	1397	1397	1678	1	1	3175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvqgaiJ5xAZJSXmYEbgBd58qeMbUYPfnPgN7iXPD1uEoFth4j
3810	payment	1397	1397	1678	1	1	3176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4K3grKj2fh7nQQw5ZUwaLAhoBEjmza3WPSKvEKB7RHfBswAH
3815	payment	1397	1397	1678	1	1	3181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8d4arJ83yq9LHoEsbtPv5ABYiUViH37kMGVWf4QuTci59cBz
3816	payment	1397	1397	1678	1	1	3182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XWo2TsnQzRUL73CszSWp8iVmXd5SbqXc2Xd6pSWH1k5MEyiM
3818	payment	1397	1397	1678	1	1	3184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2kHr6KYc1coz6Awjb63ozidUniXUeXGe9tp7UD2JhfeYAA7h
3819	payment	1397	1397	1678	1	1	3185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7orfZvGh9RsQzdr431qn9cEf7z4bsh3xc5DGKDTF27vN6qn1
3825	payment	1397	1397	1678	1	1	3190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GkG1NrHomJS6UQokNZuhfAkLdNRckBnwrrEvWTetCeuHDYsY
3832	payment	1397	1397	1678	1	1	3197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaxsKaFW4kYePcyvKVu8tMtnWYZvtG8iosYe9iij1Nsu4Znpp
3833	payment	1397	1397	1678	1	1	3198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5wZ1DoSBJFoNnMvaHDtNDYCJTPtvr8sQBJ9LmArAj4P4NuZt
3839	payment	1397	1397	1678	1	1	3204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopF41opNoZTc2gewUp5EujAtiE9PT6hTR5h17wbS3uYuoZkLL
3843	payment	1397	1397	1678	1	1	3208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpdisPz6k1qmkwwyrT6sWigrtQKqPbfRxPYDKcGiaRQaif6kJ
3727	payment	1397	1397	1678	1	1	3112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3CSPmPFQC8Ytb5EBYR4gREkmQYpvkSEKT4dGAHx3yytR7XHA
3735	payment	1397	1397	1678	1	1	3120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyMvovjKHJcgKyYHcF63a7h3A8jVWm7YFSGqHD8t5Jx5JVnzC
3739	payment	1397	1397	1678	1	1	3124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRhbfzabNoqpiy1fqNgibQkzECZf6TPMdMZw8sZAVoHSFY5LQ
3743	payment	1397	1397	1678	1	1	3128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQuRXxb2zzg7SUpjZMXqfvujRAgmKRTnozBTWFWfQZPq9gxS2U
3748	payment	1590	1590	1818	1	1	2	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJCQKFkJZPhUHmqcFBMWaNWFrLnpT67qeAmFEWYep6GskkxW8
3749	payment	1397	1397	1678	1	1	3133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYos2ejy2Wz2pQ3ysfq8J9hpK7pZ5Ar7tnDH26wRsSDSGwGU6GJ
3750	payment	1397	1397	1678	1	1	3134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaxa7Y89c3Fd7tcRm7CwtYXeX1qxktwXhpMGCwH8Sj89bV5xM
3751	payment	1397	1397	1678	1	1	3135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvbX3oakGWfKmWAwyjn6SmEkx61o8GyECd3K9Tki8V3Lzzivp
3752	payment	1397	1397	1678	1	1	3136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqCrca6Fh14NRzDCrLBLjcPXnXV8Tq8N4266xU5d63ffAvVoor
3771	payment	1397	1397	1678	1	1	3143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDA35LwBCfGjb9HnL8Hnh4iLHpzt9Uo6n2swj3xXBVziWN4NB
3778	payment	1397	1397	1678	1	1	3148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQk5rbftYwPdGd9vPgFpQiPcakFwe9VuC684EuVj7xKVh2M9M
3782	payment	1726	1726	1781	1	1	46	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYypqQ7fas1WDt66eUosT1yCY2QibSn9spWQEGzQpugiqYXoNgs
3783	payment	1397	1397	1678	1	1	3152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMiVxDwCahUNiexSoRQKxMhrFzb8HGgSJcBy3PE2LeSmdZums
3785	payment	1397	1397	1678	1	1	3154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxFMFaLGsw1GPWNUXvnAF71PcWwJC6ZPEUHgL9NAHfD3yigwoR
3786	payment	1397	1397	1678	1	1	3155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgNuLj59fyCoCUP8K4s26XbU6RCtynt2nmMCSKvjRzKC7hqz6
3787	payment	1397	1397	1678	1	1	3156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iDmHgczGwic8WmQ8gMumpJ87fcEun2HvKiin3mbAmS9gy17H
3814	payment	1397	1397	1678	1	1	3180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqX4hYmEdWjjZXVbQAsxiEddr9LLuWuqfGSSXZKdeDurDHMep
3820	payment	1397	1397	1678	1	1	3186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2Me6tr9d8aaqijmR6g8g7ab4umCbj8zz9ZSWZ99Av9iMQEUz
3827	payment	1397	1397	1678	1	1	3192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvN9isQyCtXopWPD1Kdg1AXpmxZVprf7Xf7ZQDgukSQ3RKT5z
3834	payment	1397	1397	1678	1	1	3199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcG2NWiHHZzcsZAJxvfvxAeRzzkPVEGvWJ5XDsKVPJtkM5tgjq
3835	payment	1397	1397	1678	1	1	3200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDz9PeJprkzudsXofXAqtDYpELEWCiW6sN31pVgEQmXh3Xfux
3840	payment	1397	1397	1678	1	1	3205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZy8h3YEozpLYAWLf3BERX9J4KUMmEB7hWByPmiPSPFLotZCzF
3841	payment	1397	1397	1678	1	1	3206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyxDimStVcWyKQ2drYRzG3nsat8AmgBYCnwiQxHegnBCBmS66
3842	payment	1397	1397	1678	1	1	3207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1M4HV1ojaSzea48uPKeQ1ZR7xpmBms9uyWhbH3NuEMEXM8QmJ
3846	payment	1773	1773	182	1	1	6	47348061184	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYySNTo1JmVryEQCcnLtkJbc7EKESQQmXia8Jor6EKdweQnDLuP
3847	payment	1773	1773	702	1	1	7	31565374124	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYoVpTwurndYk3d6BV6cpeJfcpeYjZfHGfEaGVNQ6mKBqrB9psL
3848	payment	1773	1773	927	1	1	8	360516507884	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ9ZASq5gNJRCRtQWdhakckstUnZEmTb4G1dV4GNbqf7RhAfHkJ
3849	payment	1773	1773	1047	1	1	9	646042493224	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZT6mQFKUduAAaCTnNYyeGJnA57N5mfP3gExJ9B6TgYfXDJtLuv
3850	payment	1773	1773	1167	1	1	10	435897743484	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYyUTvVGBFBMVBP4tff6RX6SNmN5Lbgg747NEytmbkiYbWBbwyM
3851	payment	1773	1773	1293	1	1	11	1214667820088	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ2kNzWBCG9UKG3FrnBPyxqbVUXMpepSjxC4A5qPvfLUaWX6gqt
3852	payment	1397	1397	1678	1	1	3210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8q9QGFMjFGdFdhgnfjkbYDbGPss4Kbu12VCwqCRrGbZYw8Qxs
3855	payment	1397	1397	1678	1	1	3213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fRrbq8duNNAiB1zryByDsKE4iEhQ3aDwjP9Qe6uFLxspbyne
3856	payment	1397	1397	1678	1	1	3214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFX9n4AFnoEfz9WjjSdQE1hEioe3zDzam8MmQjW9BXxpvQ1dC
3859	payment	1397	1397	1678	1	1	3217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMxkScs1GohTRrrGTvmC7DPfk9Jr6MRbufM8bRqV8QZGS2A3j
3860	payment	1397	1397	1678	1	1	3218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkP6Zsw6BsT1JehYaEuhD7wAuJCi7g9pfAFPmsuZBkYXaQNFN
3865	payment	1397	1397	1678	1	1	3222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrqkXc4FtmgWihP8XModyVkHBrdYsn6tqWv7fyeMYTgCM5C96F
3866	payment	1397	1397	1678	1	1	3223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89SbK5MBT5s3QwQvPwgQ7mYRFqE3ynTa5TR9CVc52hQJ4WGZp
3867	payment	1397	1397	1678	1	1	3224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhY8sBrt3kRgdcwPp8o28o689P6m3iPdH6qWYuKJF79XHdTqp
3844	payment	1699	1699	1773	1	1	2	2736097999988	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwV9qK4svfEE1ETGwpRM1g9SstdVJHVDsQbHJiZ3Bt2CuKPj73
3853	payment	1397	1397	1678	1	1	3211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncLKkCRG2iywsm3ewiojcoRGy9MvS9z7hg22asqWp67EkdFLc
3857	payment	1397	1397	1678	1	1	3215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwVGbFu1MJgfsbeFVjNyme3KVWmAzKkvRuUi2M7Hy6fCRRJa2
3863	payment	1397	1397	1678	1	1	3220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxybxLTLhJWRUqes5PfDz81jcdx9tG2cutpbz87ToojUJhv3hQ
3864	payment	1397	1397	1678	1	1	3221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCpim2E1FpRPnhFvzExfefet2W9ZxTL2njuYca8k7vutPRTCd
3868	payment	1397	1397	1678	1	1	3225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRauppidFpBbbF69DrR4a5f7hQto8dFgVkcc1ZP1cz9ovVmtw
3870	payment	1397	1397	1678	1	1	3227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65yFG4P5D4A8HFav9CRaDnPX1SHco3PMdGCAzuKbKDmz8RvUi
3871	payment	1397	1397	1678	1	1	3228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNwMNrxgvGceu58WJnZzdXrjdeGJftF6ASZ4hwt8tPjTeSfiq
3874	payment	1397	1397	1678	1	1	3231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcripBjrzd9GJVQuAt8a6edeeBcmsm8aMuP9TFq23rDsbACYgR
3882	payment	1397	1397	1678	1	1	3238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgaM7HNSmH9Me1WxEe4WPhe3zdpyzPczj3Sq31AwBG7W1Vn44
3889	payment	1397	1397	1678	1	1	3245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAUmFu4KFvVSJT1cxFoV2QzKf74aCi7SLLUKS2UpXrW6hKRxv
3893	payment	1397	1397	1678	1	1	3248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZejuoobQY2McwHsc4txDAym3jGPMRkferTN7r8Ez6ASLkNbouc
3910	payment	1397	1397	1678	1	1	3262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSivW4AJ3zEHRERayUmwGYmR1VMSyDwiKeNzi67FVwmd745hgA
3911	payment	1397	1397	1678	1	1	3263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNFsDQWkNbPmAhoayqfVqqyHQKfQi6gTXqjedJtkw2DcZ28SK
3914	payment	1397	1397	1678	1	1	3266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEQHcBKVojd5tWke189HRrGuXQs6sxuXZXwpmzMCsoPhBS2LL
3915	payment	1397	1397	1678	1	1	3267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9guFZqejGsFziKcmFkuYbYuTNTAK828gbkKubsQq7uRmJECLg
3916	payment	1397	1397	1678	1	1	3268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcW21UtmT6TL3PiLLDArtyPqeFdp2UwDKHUq7tu9kizexTtr2J
3919	payment	1397	1397	1678	1	1	3271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenJAQe32YBF48c9mnnEi3pGc5n6SCJfReKrjUvDAemBsAi19C
3920	payment	1397	1397	1678	1	1	3272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatmjQdm3AUqfWAWVW3WZyJXYykdF2EB7sFfR55NSBfcBawptM
3921	delegation	1821	1821	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnthVLxEuhKBAYcY195TJ8MpkEk64QycMSTLrC1nS2iMx9xX8
3925	payment	1397	1397	1678	1	1	3276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rka5i3Waxuk3QngwTRjDPDQbTHeQamsaRtZ8mEQwbgdCTHny
3928	payment	1397	1397	1678	1	1	3279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrKrN1u5kspjRzQzFgqPgRTwgeApmuPjjRmHGdS8nyct9pNQu
3940	payment	1397	1397	1678	1	1	3291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopKxNsu8t7Z8hjb6VjVAWFAwdheDhHugBBeFcUVeWG4YWmA43
3941	payment	1397	1397	1678	1	1	3292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwNdbAET81T4yUSuWQfHQ6J6nkd6D6nbSpVRd5D4wHiSJxLHo
3953	payment	1397	1397	1678	1	1	3304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mQioQxXEbQ3ZiBwAqUi8r9TtDpQ6joLZcmQJmKbkXqjVTubQ
3964	payment	1397	1397	1678	1	1	3308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mXSdHWGwaMF6KkUY3byZhRnsqncwp4GwsAbFdL3q38nKHLxs
3967	payment	1397	1397	1678	1	1	3311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGnN93QQcq4a4YCFBbb5vsHVdfMi9memurXQLp3a9ozpaAKRX
3969	payment	1397	1397	1678	1	1	3313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCyjD5RKH2QBHCuVvrQn4f8uEAdH7bCtWm7RB2DWfEfBHWg55
3976	payment	1397	1397	1678	1	1	3318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzicJc2TwWDP92fx3ZNh6y8HCngjniqQ4bmYmkZ7q2emrgquhY
3980	payment	1397	1397	1678	1	1	3321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcPHUv3qBD2ZCauzgRjcc9AiiNU4H6iD723xoSQxPAbdnruoJ
3983	payment	1397	1397	1678	1	1	3323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSBJAo8NaXMfAtLVURgcDgXqDk7taQ6e4zDTECKP9S7XhGjWe
3997	payment	1397	1397	1678	1	1	3337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBmvTKusGGinzidTzZ6aYXVRz7LkJBwMxuLuzgxeXxDzXdrgpW
4002	payment	1726	1726	1831	1	1	56	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZ7M4ryrcLJKCWRPJnC3f45ombjfkT6mukL1vUKtNLEcQb3aEC
4003	payment	1397	1397	1678	1	1	3341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mGEbEG7J87J8vQ7dKse4jzNsAtiUzv11CCLwKH1E5sHNjyKA
4011	payment	1397	1397	1678	1	1	3349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFx5Zk76zJhiAKahSnD7sD6sLKU5GncHt5mTJURyEB2j3eEbXG
4014	payment	1397	1397	1678	1	1	3352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pd7HmK19ssgvHoBsLeVgaeXvDUP2ejtxS7NjnjoZR9TDCM2x
4022	payment	1397	1397	1678	1	1	3360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAnaZt2RLSfEVXeEU9XiSpvXzfxRb5WaLePEk3nYScGr8Ge14
4027	delegation	1829	1829	1396	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7CH7SdhGdrbp3iGhJ83qJPrKQXLfzK7kfMBUuMnnmhdMAAGB
3845	payment	1397	1397	1678	1	1	3209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehvvy7KWW41nvoLSLXbMbwMgyeTMH37JMV9CDz8RakdzwApFo
3872	payment	1397	1397	1678	1	1	3229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NXPPaxJqUmcXuSCV1GgsAfpbwZ1WM8p8gdsgutDTSZVZwDPC
3880	payment	1397	1397	1678	1	1	3236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjW1s42wXV9BDJBabB1YhBrgqxJFs42gnWd6ZQQ6wA3PcZ1TET
3883	payment	1397	1397	1678	1	1	3239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ51jBfpRS7KyhxJnwUfFTHMPr4XMvYJDyg6pZpo1bUHuk1yKY
3884	payment	1397	1397	1678	1	1	3240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWLbHYNGHDS8cakjDd5ZdoAjyqUmYwaPncGFCH56ZsASYUoBW
3885	payment	1397	1397	1678	1	1	3241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBSmaZwEpyJMHseamGPA6pgucEJEc6ZH9sJ2BgB7ywwmyyDBj
3891	payment	1397	1397	1678	1	1	3247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoz3BEF8UUKaTjW2pzi3CVKv7nsoZKvru6DSGiyAMqa1eQcDT
3892	payment	1693	1693	1816	1	1	343	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZfSaqH6CBfesiirkvjvuS8XApHFPC4u918E7DbmUeCqCD4XYhC
3894	payment	1397	1397	1678	1	1	3249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxKjPiHc8d7V9w9Wm4cgPDNrQLTeo1gyyyWaUseKZZ3SmoX1i
3904	payment	1397	1397	1678	1	1	3257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2UmCGtBL4rp79phR9yZSNBTinsuHAucfFWktSZY4wghorLWq
3905	payment	1397	1397	1678	1	1	3258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4Jf2g7zXuKwSSZgLRTTg6ZuS2UTfY1bfumjp3owkz5LWPM3c
3906	payment	112	112	1821	1	1	1	150000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8sYVU2KpsqQyQEWNH1N5RdZSNyaKrda8ceJCDDfdLmU2PVUj
3917	payment	1397	1397	1678	1	1	3269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43anUqxAph61KexCFPzBtK9dtYxhBLPvxP7mJVzyHBR7dqXwn
3922	payment	1397	1397	1678	1	1	3273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZSvdC1HNLzPfpXFjzjNPm631kUJcQsBnW1Xq3AtRpN5z7vaW
3923	payment	1397	1397	1678	1	1	3274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcoQP1SM38ZbttirVGQPZ8XAa7HsNy15hokQ1bMi43FHZVVS4
3934	payment	1397	1397	1678	1	1	3285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsyEcvMKuaANBjngDNtM3Ps8UpvWYL9G4uziDzXKkFEo9BJaa
3935	payment	1397	1397	1678	1	1	3286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XhvTAwXnDcLWQEp1mhB8281xELofTBQLpuxHV1rY7AZQSR52
3938	payment	1397	1397	1678	1	1	3289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrp8Br9gFKpTbEox5b6P4ygfqsWETCnFsLE2L3cs8AbBBirqfW
3942	payment	1397	1397	1678	1	1	3293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVKvWaXXVfyW4viVEgi1NUsZeccrse3JZALeCrb7hmvSLVMvD
3951	payment	1397	1397	1678	1	1	3302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwmRGX4njxx8uSHXbxnp8CE5Rtw6EzseAfacgEzoSu8AZEc8a
3973	payment	1397	1397	1678	1	1	3316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYDcVJNk99ZQi5bBj1sFg4zrkPYBvbEFWTbPvyrdx49onL6XR
3984	payment	1397	1397	1678	1	1	3324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jGs7cCkZqAvqTuTM37VQVv5uLXqTZnAVV7eM4UWJeYqC6kYV
3985	payment	1397	1397	1678	1	1	3325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbwt66dgZkGU9tVuhJTBSogEjLLNbJeEngRZTEHCQFjKRHTqS
3986	payment	1397	1397	1678	1	1	3326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKHQ3FPX1zTSPSptwufGgw9M2kB4KyGFz9y1u7Ua7t6irHFEx
3993	payment	1397	1397	1678	1	1	3333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAr1eGHZ5WNdSFeoTYe9eDPRHWpKjY3nAM4nsb3DXFxFSjRWP
3998	payment	1397	1397	1678	1	1	3338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jTWLVrpdP1HkFCZt8Hg6HkXyop4ef4bTb8AoHbzCdCjdyzp4
3999	payment	1397	1397	1678	1	1	3339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aePcpj3j3172nMnKoPsBKbV9DdZ8JTASXb4oDWhx3Sf58vG2
4004	payment	1397	1397	1678	1	1	3342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7EDzyLeTH7w9Uk3pt5mFbFMRotFBw48wuiGKJf6nuFY2yx7b
4009	payment	1397	1397	1678	1	1	3347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4gsBbbLBvmaZbQKjLPrVJkcf6TmT7Gg4ZXXcgoMNkw5osVSa
4012	payment	1397	1397	1678	1	1	3350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadrVj6APa5XjhvTkprRuZYsoorTn2zWt3uU1kWYUs7rnZXrwR
4017	payment	1397	1397	1678	1	1	3355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbifuqW447N9hPuo2yJ8rjhNgQmsfXRD8rKQa645rjv3zTQ2E
4030	payment	1397	1397	1678	1	1	3366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjGyMLqRUa9ZLgaMy3pqvcgiW4Kwk3TcnsF1brTfva3L4ufyQ
4036	payment	1829	1829	436	1	1	1	980000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhdDsC3d4VrDgT52x3qWnY23stvzYnu4sZd682DYRNBSoWr2de
4037	payment	1397	1397	1678	1	1	3372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBgewNCQKbjGZ66XXHuQLotwPS3bRiBbrCPgVNkmBZtESdMAP
4038	payment	1397	1397	1678	1	1	3373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxSfaigEvHwApFtU7YwB1LsWuXjJ5RoQcWCv7Xo1YMNFNWR7Y
4040	payment	1726	1726	1832	1	1	57	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZRKmM9XwayGjFSLXSVp994B3bJjaFjjanRtNTdnx7q3eH281Zp
4041	payment	1397	1397	1678	1	1	3375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtLvrbZzr2g52fh9YYjygNahas8uBT7NGFfdmrr83LjrZE31F
4042	payment	1397	1397	1678	1	1	3376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8LvzCrc7SAjjdsLcYR6nN6Ys6SZhrxS51myKMst4EdMhGx5R
3869	payment	1397	1397	1678	1	1	3226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeukZ1cioSpPUumtWw2b3R4tA9FjXHaXwFXFU3PKNg4pE39Ls
3873	payment	1397	1397	1678	1	1	3230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaEBJewrcB9DvnUUakBiU7sJjDtKYHdVHqcXs6ruRVAG85qub
3875	payment	1397	1397	1678	1	1	3232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfspW19S9JTpjj9v9PqV8mJjJSp3bft4soibMGsRKW8yRg3qkN
3876	payment	1397	1397	1678	1	1	3233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB8My6ucCDjhrrcYWGzh1nSmR1eUrmGufU2TEfdov43W8Zu2mp
3877	payment	112	112	1821	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dPgUdL3GT32XX6AAkzq99Qf1sJxU4zXw3r3ThmFcQfZsCzRp
3881	payment	1397	1397	1678	1	1	3237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyw5VHbA2Vk9ekCqhkdCa1NgoPdzSz2KqQtJF5UqErnJkNCL3
3886	payment	1397	1397	1678	1	1	3242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXnTZC3Tow52sY4drytXxtFJhYjUTLu3kSXErJc2Fk5sAkJPs
3888	payment	1397	1397	1678	1	1	3244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZAfKn3PMVYCqBu4M4sFoWwzJ4kBqL44uahwuCd3YXtUBsp83
3890	payment	1397	1397	1678	1	1	3246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBYMDGxyL77EsCi5rFCvsXJWWxwFVBzxDZNAPLoiCktoAKtcK
3895	payment	1397	1397	1678	1	1	3250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnuqWMLA2s8QZKDmpUWck8oYnAYxBcU8XbYo6PEd6buMuyEE4P
3896	payment	1397	1397	1678	1	1	3251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTRX3UCm8WduZuinpgWLVyVENffDAuJBjuejj8DYz73aybTR2
3897	payment	1397	1397	1678	1	1	3252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42WJafqpiRkpqERXb7YitRpPE34Uzq5XzFB7qRj1Vxh6ZwDUc
3898	payment	1397	1397	1678	1	1	3253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzS8SyfJg8gwq1quhjHAmvkCZzEH6UFTRdifXw4QTjgNwNHNe
3899	payment	1693	1693	1818	1	1	344	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZS65waW6j42nWjmEehiJoq9BUepjtChJ448ouGy9eKQ6h8gD5S
3909	payment	1397	1397	1678	1	1	3261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZazhoBAwyFwdqwmepAtQS68C6NbuevN93bPDAW8zhL65KW1n
3918	payment	1397	1397	1678	1	1	3270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2naPCa1DpLUptGFQMNgGRf1VhQRxDRfK8Chuoq6nyyZwwFT1
3926	payment	1397	1397	1678	1	1	3277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6JZtHiApYfPySSbSXkyBFVjRAQ75Sib9DrQ9fqLAw1rjAppb
3927	payment	1397	1397	1678	1	1	3278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6msbfVz2V8XbiuVR1g3YWGG5J1Xa1FE4Womvoe1xYLDwigSf7
3939	payment	1397	1397	1678	1	1	3290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBECipxeqmDvPBgMxRzUfknA2W5bimJDM5jqZHFVx7qmqvAtJN
3943	payment	1397	1397	1678	1	1	3294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYuo5UWaLPDscoV4d4JydHBHgqRPzAb6t1pndbTzWXKP9hUxM
3945	payment	1397	1397	1678	1	1	3296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6HSU3tgiVxVZLP8a7JWTNs685BSUiSdkkjopBmoL5hjkHAjj
3946	payment	1397	1397	1678	1	1	3297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpck1h6DkwbV2Wy5VZR4CTg61R5s73YfmWkWW6dKcdHHc7Y2s
3950	payment	1397	1397	1678	1	1	3301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsj36iQnmhTY8njpnKYKCjwcv9p6gziP3Ev7Y3WNf79meTzsg
3954	payment	1726	1726	1822	1	1	48	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqgXTML5LVRf7m8rV3sNCDCqaobVfspB5EwXhwjHGK8qpHsfPW
3955	payment	1726	1726	1823	1	1	49	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCK9nd3myqrZPFTMAAnD2rnGsA7dUuzTN64k7zxCGXrsJ3vBts
3956	payment	1726	1726	1824	1	1	50	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiBcAd4LxdJQ8D4e7D4DeRSf42cnKxiZTp5sVcgsq4EViwCLxt
3957	payment	1726	1726	1825	1	1	51	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgYaqfhFnL18iZpYCe5Yr77a3SJRDJc6MBCRv4PftR12S382Gu
3958	payment	1726	1726	1826	1	1	52	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEfESnZPQmUfqEP8PyGDdfBcJtkYMAiMwVEyZ1jk8t1TU6uFfR
3959	payment	1726	1726	1827	1	1	53	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYsuakcDyLZwXZM3bZJiVDprYWadpc19ZnzzKHPFBAL2TmDd8RY
3960	payment	1397	1397	1678	1	1	3305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDX3Sos7etsj8W1emPrgKweJRUf6CoKLeVKp1st1XKbWpsVsSn
3961	payment	1397	1397	1678	1	1	3306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhszVkReRyB8CWgKLVLrTtEySHdJf4qs5Qc1kBFcmMoSnB7U1
3965	payment	1397	1397	1678	1	1	3309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Hu6n2w6PHbpaa3hGanG515bqBynHxcjq7MxGxLGUsQt9256r
3966	payment	1397	1397	1678	1	1	3310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXfs2Fqfi9dCGJsFdXfiR5BJJJQKg2jg2XcJf7qQagVQmMpJJ
3972	payment	1397	1397	1678	1	1	3315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygs7LR9brMtt9o4vZJyoHmv9BX725cYbZdbKBDYgN7djBvWwV
3977	payment	436	436	1829	1	1	1	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3snu9ywVzaGpkwKqm97TQwruN74Q3V74u2PNTw4eMxxWf9szB
3978	payment	1397	1397	1678	1	1	3319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqH7fCHL6JqYbVTGvjpX6fgF4u7KGCRsTfEzFMrs3j1XU413Q
3979	payment	1397	1397	1678	1	1	3320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrbHUvcEpmiMWcyDXLjRLpqvAUhKCTfJ6ZHn1AXv35XqG6YMC
3992	payment	1397	1397	1678	1	1	3332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7ovXeZJdAKBfhj7tNurWoAMAMhWr2LrQrEQAFi9xiXD8h9CN
3903	payment	1397	1397	1678	1	1	3256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRpG48MmStbSq7NiqdcWXuAoTMXDkqn9AghfQPar9rREcPPav
3907	payment	1397	1397	1678	1	1	3259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRfW2j3f6on4GVC1knJUa2XQamrTjfv3BcXBcmsq7pv6bgApS
3908	payment	1397	1397	1678	1	1	3260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3NAAMTQEPbsQJukiUHmFmK4HghsYVfr6PKkRSS78hnA9VY6f
3912	payment	1397	1397	1678	1	1	3264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Ac85M4nN9VgZvYg4rBY4NBDRzUYbFFYqm4EVs9XmLH5Mha1i
3913	payment	1397	1397	1678	1	1	3265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhGYQyxw68JSpF1qhe89s1JvMvWh2CFFeskhbdkV1ZNn8PzPZ
3924	payment	1397	1397	1678	1	1	3275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLoDFuDd59bDnMqCKwd5u1mwRJLxjV8qrjRQeQ1qunxGNCbjX
3929	payment	1397	1397	1678	1	1	3280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvvomx4SPBdNGDW4AdJhYhbwqXyFYSHekUTTsv9iSgvyJ4Xcv
3930	payment	1397	1397	1678	1	1	3281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9WNdd2f3srGmUzy4hxYCbB2F7gbXzZXzksTmnphqz6yEhb7w
3931	payment	1397	1397	1678	1	1	3282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBq3wtaCgnt3bCQM2gwa8mWjoywP1fi9MMfzZocynuijCXiHM
3932	payment	1397	1397	1678	1	1	3283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2osreZQoKTme2msLxArWefSkyr9U9gSRRhLGXX3ep7fGhCroo
3933	payment	1397	1397	1678	1	1	3284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtcakJkL6Q7nwpt8vXNuhjPKdRGr1BXqdWRLYf7iHy6cBBbk5
3936	payment	1397	1397	1678	1	1	3287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUkMSfR2BossFU2xXjqQJQS2qgTEoTdi9d8ey6m8eFqSRkpRy
3937	payment	1397	1397	1678	1	1	3288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy464mgYcLmjwK3NPT4iJ8sDuHqwftnPmYVD4FHT5mDWMA7TtV
3944	payment	1397	1397	1678	1	1	3295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnNxVeUzJngZj2US8GECCqwerhXafenrCrFqBTP1PKtAvAW3i
3947	payment	1397	1397	1678	1	1	3298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPevTmoakFnY3LQhxkk4xYZkm6gzaCXRPewJjfXvGxyePzCsN
3948	payment	1397	1397	1678	1	1	3299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFbDhg4QRFHpNFHiGutx89YuPjdtCVtdyrGamMvafWdbJTHhC
3949	payment	1397	1397	1678	1	1	3300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWGkCv7JJ1JAuETGCEJ8gamQwoXkmHBPLzwHqPbbirKTWAkPU
3952	payment	1397	1397	1678	1	1	3303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eX4JqvmQqdbMoMs2tFsbWJZLSUaK57JEK6Wfap3tNScALGxT
3962	payment	1726	1726	1826	1	1	54	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2VHb3as8G95cpCmnTrNvt4FHekfF3iMkAgwawbSaqct4MCE3D
3963	payment	1397	1397	1678	1	1	3307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsx9cZjUJSZT9xmkCjNvYXsVcmPDVGuDM7pCx7kYbzahHzirt
3968	payment	1397	1397	1678	1	1	3312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97zh5hWpC6TrbUz4zjDW7GaRRvN7crey1EtkuZXxYnhcJYeko
3970	payment	1826	1826	1828	1	1	0	1300000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJZfv26cDMNeAJWfxZU48nKJ3PaSNYE3DAULaLSgC3kRwwTYQ
3971	payment	1397	1397	1678	1	1	3314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLX3CfSCWZwnjmptvwZYsHMU3p1QZ5XTouqCTnQCchNTNZxxJ5
3974	payment	1828	1828	1826	1	1	0	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnZEgofydBshhJMwFMhmJwctB869aVdR9zYLTG24sUNiQdTQs
3975	payment	1397	1397	1678	1	1	3317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MxGvNz12HkRzsud8CoYoTJ6kcepbtyRZNL1NeGEwKihNVkDY
3981	delegation	1805	1805	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm4o8VVLLa1kqdMtnBTQpA2MkXQArRw1ckNwaDRc32ujAHAHu
3982	payment	1397	1397	1678	1	1	3322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Zjk2QbdvR5X6QrSMFKx6stc3cdCBfUPnno5DhTWLrNeYMiJ2
3987	payment	1397	1397	1678	1	1	3327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9qAAcyNDvfPhmCfg8TT8YG63gyw5XpnepJuJjNXnV65pYR54
3988	payment	1397	1397	1678	1	1	3328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2u6483HE8qJi9sJnaoWzXeDxY6HFpXcpSXnac7p29Gwqqxj6x
3989	payment	1397	1397	1678	1	1	3329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGcMfQKA64zQgcxYXFdGP8ZyiDQV1M5HzrBi94ZLeUgS9xTLH
3990	payment	1397	1397	1678	1	1	3330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSyLbkx7z84BQQ3wMBQyfAYJJorwJrfQk2XKRsGTmrup1d7Bx
3991	payment	1397	1397	1678	1	1	3331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNt9R79v59v3ZFJc5CKKvLKzEkrLqdByQPh7t8KkJ744Ja9CGa
3994	payment	1397	1397	1678	1	1	3334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8iFnhheHS6cYmtQewxJkBsb1xEnUVktWdqqmasVs4Xic9DhK7
3995	payment	1397	1397	1678	1	1	3335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt13c1bkfrpzQzVsrNRdgfEYFvHj4knteP1EmEun4jKcSv2TcE
3996	payment	1397	1397	1678	1	1	3336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAX9yNChJmdcBUXu833a2LS67LqQ2eCHDvMdbAmb2Gee2UCGZ
4000	payment	1726	1726	1830	1	1	55	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxyPjbrKwGA7nhar96WSn1ZN9QDPHFQChozEdr19xdNZP7J9Tf
4001	payment	1397	1397	1678	1	1	3340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvN2F8s1wNFcXA5TS2bpFLGh7izH4vyvhEtP3pAwWwf4DL6V7
4010	payment	1397	1397	1678	1	1	3348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwjbATJm7ZFWMRyHG4t2rvrRGwNUihVNzPeTJvaDmMMVKLFEW
4005	payment	1397	1397	1678	1	1	3343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnFhP3pCw1d7X2kD3rMtMozH8ViUKphHJGsUb1RS9nbxiC5T1
4006	payment	1397	1397	1678	1	1	3344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaLvpCW5atTCcCup7LYmNt9Mz4QThFJFBSq6nL6NUhYqhP7U7
4007	payment	1397	1397	1678	1	1	3345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAz2tWEPTfDPhG6QiRPhReyQjzXeGTfiVMi4Eu7hU7yq3TZJDS
4008	payment	1397	1397	1678	1	1	3346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzqCxXoy5vU5F7zKK6z6Tmath7stebvwBv7WBRmU27RjTCQhJ
4013	payment	1397	1397	1678	1	1	3351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXiNMAdvZzBFkQjGZakrv7GeCdbACKmq37YC3mtNkNP6wSV2P
4016	payment	1397	1397	1678	1	1	3354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMX48RQMXuT8v1XeqXPBuCKLKCCigFA4g92rUSDipqffKh4My
4019	payment	1397	1397	1678	1	1	3357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK2q75qvuDWLY7JGbyG1WcPBxs7tHLmPbQyHSTPBQ69vefyTh
4020	payment	1397	1397	1678	1	1	3358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekvsmbNKuiKcvDdDN4errhK1uiruJETGvv5TwpXXezLwnKHqa
4021	payment	1397	1397	1678	1	1	3359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Jh1QPf7MwM6jRh1iUDsJSttZwrQKMeNop4xwtY99qH1oSERe
4024	payment	1397	1397	1678	1	1	3362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkvPXdjSYBCxApmxDm2852RfmNYZrkY5xoRvvjkSnzbDpFSRo
4025	payment	436	436	1829	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLj93aUpTy25WtZ5y8LrEwJkvfVFTu61YyBwEZpxuQrH9ZBf9L
4026	payment	1397	1397	1678	1	1	3363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMiZ9SMQAecKm4QKN3zU1K3FN7wMbPNVrvCt3AuNzvo3BxtXw
4031	payment	1397	1397	1678	1	1	3367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbWF6iGHHVbekQwYt8CFTr4QdiMFbVPz8FAycNPqM1yqwAvaP
4033	payment	1397	1397	1678	1	1	3369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHKG8XCSBmZ3XehhjL1YnY1N36VsJYYVHR5ERW8qi8SudmUB1
4047	payment	1397	1397	1678	1	1	3381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GMqJaoC5sQwWtTaqjuB85M9aLCjwJzt5CYVQzRhimYdnkwJ2
4050	payment	1397	1397	1678	1	1	3384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhv5GXFmgo8d5a2S92rbM8uHwjtdePcTuHM51LD5WcW3YC9oG
4052	payment	1397	1397	1678	1	1	3386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5tDgd7hUsgb2vkGJoc8zgurMhEdmZBh61ZcZhUaoa4B82PMr
4053	payment	1397	1397	1678	1	1	3387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovnkBYPkEQyWAvoLpFBckvMtGd3uMynyTZcFUTDJg16FYYE9G
4054	payment	1397	1397	1678	1	1	3388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bzargKhMpChrhNVesmC8W7cesMVUJHrrHm3gSgZnEp6RYDPN
4065	payment	1397	1397	1678	1	1	3397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eMEwan4az1MT6uHWLiReQeG7U5sEpTdeeB2EfdMznks9LUw7
4066	payment	1397	1397	1678	1	1	3398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLUDscTTW3ksNbdfmFR1uJ2o4joMN9UsDszzP3P93XnNxFefC
4067	payment	1397	1397	1678	1	1	3399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbVGNr77AUBiTvMnkTkKZ6WBMKugXR6yVeX8YWo6kLJ5AtqJD
4070	payment	1397	1397	1678	1	1	3402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeZEB5H95tfwyk8mVEVJeVrUAgkW3YqJKKpjVjJijJ2fdXH9t
4079	payment	1397	1397	1678	1	1	3411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDip9LjWz9ASSmQiD9XrdseFxi2eWqa3nuMxFJtNHVUKJ9RHAX
4088	payment	1397	1397	1678	1	1	3419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Vr5iMVYkGroGD1P4vxKRj8RoaP2pgSRaPQUrxEgCFyQ3pQ8P
4091	payment	1397	1397	1678	1	1	3422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75ciD16ZPSPHUKUW4N7gus91jokdbCQ65gMiMPJx2uPf7MGec
4096	payment	1834	1834	1834	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYeQsp972Pveo9LLBuEU9uF3ANki1csiKSD6VirHHMGw5Tnknz
4097	payment	1397	1397	1678	1	1	3427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9gz7oib3h3sBh3AcVLbeMbRWmqYk588nXd7P3PWfj76z8aGJ
4015	payment	1397	1397	1678	1	1	3353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSKhmQj6rHHx3bVTEPnSCb98xj9V4mw9KWXQCBEjpdWrvEykt
4018	payment	1397	1397	1678	1	1	3356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1C978f8U1KKCYQqoU3DA43APi93R8efroVXyvRnuREgjgMYdV
4023	payment	1397	1397	1678	1	1	3361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBxs7bEWK4w1TEXYdG4L4CJ9e1LPdG96n76dFnDmqcpRLJY2z
4044	payment	1397	1397	1678	1	1	3378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZwFQY65qksj5tNAYt2kfmdsPUd1f6xhdWdYKyn5uKVsmPFXE
4045	payment	1397	1397	1678	1	1	3379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ425MYP6ooZ8fTfCxdqDFQysY8A19EvST8wkZvv2wWcggYh12A
4057	payment	1397	1397	1678	1	1	3391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqCXseRHyViXj8rTPCg5PBGJSeczcXesTTah1ZdVpsm4vxHck3
4058	payment	1397	1397	1678	1	1	3392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7wbL23ZUdLxdYNSzfjAQiKtqL5hYpJnEWEZcLFfpEYFzWKsK
4059	payment	1397	1397	1678	1	1	3393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNBGLyN3hL7AT6ASnjSRGkD9yV2Qz9zUAoMmJ1p1HpMfxJXU4
4062	delegation	542	542	1492	1	1	0	\N	11110000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcvyD9RFHm5p8vcjDJCQNQGzZaai54Kz2tuiJ4pHyPnbR6T8oE
4063	payment	1397	1397	1678	1	1	3395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wTJVAS4gDukzWxjCTipDn6g8eYyHGiCpZFJP57VaS8ogNRgZ
4068	payment	1397	1397	1678	1	1	3400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBzobdmVZFnJGkMbaKHvvbaxnZ4ESLmH8dsWbucd9X74CZwdV
4069	payment	1397	1397	1678	1	1	3401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZjH4mRdmeR4JMkYFc28EwonwE5VXedDyS7GGc65Er9fwUx5s
4076	payment	1397	1397	1678	1	1	3408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvF1wEsLD3nV62wYtcXLQbQDQhnvzuvtzj5oM8Ls5RUYZxxnv
4080	payment	1397	1397	1678	1	1	3412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZks4pWkhK7b5CV1pW1MzveSLr2ZZRMeWWLGrKhnKaz4mMNkH13
4093	payment	1397	1397	1678	1	1	3424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9M7ZDofrdREnRQjCqZqHh4aDnLUqDtciNuVsKS8JndvfkZXQQ
4094	payment	1397	1397	1678	1	1	3425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LdRExDuQ4xetiSbri1BcwEa6a4oEbmVb9yk9UN3TthyGCo7F
4028	payment	1397	1397	1678	1	1	3364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw74bNTRD1x4nmEU3wgUEoRjfnizcTKXsLck9vx3hQux6aQvZo
4029	payment	1397	1397	1678	1	1	3365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRf9J5oon44gTgv5X2A7KviaarW1B3zwbrnQLYWVCcAkre3HY
4032	payment	1397	1397	1678	1	1	3368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswz1RBb6cGyMgW41CT5uXuKkn48Yunq2pLGJGYm3zEBRGuQaZ
4034	payment	1397	1397	1678	1	1	3370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUNESbww2Z8KBrYxTvxK17uVNMbwr3tnYgFXpLnuyZ5NjGfRH
4035	payment	1397	1397	1678	1	1	3371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oGmUUkNPLUrjZciq7uwoEMYJUu9Bctu5XWdnLMKmdrnnkgVe
4039	payment	1397	1397	1678	1	1	3374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLy9kJws7XgeKgjGQFmsUXTt48eciQdTmYYtXb7yxBoFvUdr9
4048	payment	1397	1397	1678	1	1	3382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYFgwp6NeotjyMauYTmqXmYmkTDJHMsZQLyKie1mW768dCorA
4049	payment	1397	1397	1678	1	1	3383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3igntTL4wdRJymZBdsWERHW2icCj1Efepvxrwwp8waS8mVhn7
4055	payment	1397	1397	1678	1	1	3389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWQq4EGm3XP6armcHuM5diU8KZ74KQ716gAMPComJXRtWahNr
4056	payment	1397	1397	1678	1	1	3390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhp4HRatFMD8YVMH5UojfAigKHypt1qnym1RqDoxBpG6sx6JV
4060	payment	1726	1726	1833	1	1	58	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZDaYfZszm1kBh7dWHNVaoTmJAE1TooQeUnWR2dLYCcRpiiD5hD
4061	payment	1397	1397	1678	1	1	3394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3NwpNgQgxsfx4HDQBibFPp3PVimpatKYGS7SniAkReEUpht4
4077	payment	1397	1397	1678	1	1	3409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5STfuC8g4m6J2UFKG6NE7QEu7FhrMCfBGV96hKckFhkBxkauk
4081	payment	1397	1397	1678	1	1	3413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnhTsiY6XnBVmrdJqJDN5dQxLpkenkQXs8NBj6GhThS5d54Kj
4083	payment	1726	1726	1834	1	1	59	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYrrro98cbkZRhKQ6iTy5Q387XCz8DybVMjF1nYs3dVXqUwywhm
4084	payment	1397	1397	1678	1	1	3415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwDitFdvjD45FU6BhxZzyPZ5bJ3Nu6fc1cJe5mVAW5wAZJJzP
4085	payment	1397	1397	1678	1	1	3416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnimHn5hKGVT3uVkM2W99UXVYMkADJdbFExJU8mfGCebPu9ZUN
4089	payment	1397	1397	1678	1	1	3420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5P6xjdCpoTCeDi7qYgxUp6oYyoZeFmB2xxbUo7R1f6PDALgtg
4090	payment	1397	1397	1678	1	1	3421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT7F29AJRcfgm9zEeWbYJd91qWWZh8ujDdishu7mdhuDkQFmS
4092	payment	1397	1397	1678	1	1	3423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zGJ5PtuwX2WFjihz3F71eD5tDhAVhdMFBQKMNRP2TqEaTpKU
4043	payment	1397	1397	1678	1	1	3377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMsDYpDTsEVQbmULFBHiwfpkbXmNUNFjGh1dm51pS4hw9Xtfg
4046	payment	1397	1397	1678	1	1	3380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZca1zbi8fZUjB81Eo6xcApKzUj91EykMpt9HSQGhSufnmfqd
4051	payment	1397	1397	1678	1	1	3385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvRUSdi4Gnpy1JKhn7DfYGrGftLaW29Pua2fnCWjApJcGyi3D
4064	payment	1397	1397	1678	1	1	3396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFwhiodWagk2dRKbni8aSYwkYZd3SzkpJnn26UV1Aj4BwBEp7
4071	payment	1397	1397	1678	1	1	3403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWcTisRy1Ks2a2ds1XbvUgQDh8ESmactiJsoGDkm2SzrMufPE
4072	payment	1397	1397	1678	1	1	3404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNeghFZwZE8VQWssUF81ibTTfhrkbxJfbrYzDEuaMpsi6xH4s
4073	payment	1397	1397	1678	1	1	3405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhedkvp2ZyKMcNnAaJGh6KD2JtetpbWhnjvU3P8cnz5SFsmUa
4074	payment	1397	1397	1678	1	1	3406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wEi3iai8bM94MLvpKq6hCNVaZx4vY4JnQzuPiPk6WmC4KoFt
4075	payment	1397	1397	1678	1	1	3407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa51hTtcFEoAe9CqaTMf4FsTVjhEwU7JK3JdrZbSoHAVnfgZnc
4078	payment	1397	1397	1678	1	1	3410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDnAP5YpushCHLLCW5rzQtd5HpHehLCw8GVA7fNwaDqUJZqu2R
4082	payment	1397	1397	1678	1	1	3414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdc3PcKaXuQeAC6qVF4tKd11jpHaLr1mQKu11XASTYHvfAEg6U
4086	payment	1397	1397	1678	1	1	3417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStDxMRfqtVAhaVHENUfJLGPd6KqXnxMLhG8rYsRRFwvXNmwnN
4087	payment	1397	1397	1678	1	1	3418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEzCV2PT7DJk8R3TvNyvu3JcmWd1wZwxC8bDV9RkBkoTpeJYs
4095	payment	1397	1397	1678	1	1	3426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxzDpCx8C2xgV64xDEg6qdoByCbtXi1GvrnBk8VzPUpHGUhxX
4098	payment	1397	1397	1678	1	1	3428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUD41W2fVL2wk8eb4R3WkQCFrMEwHjtQFfk8L8a1zTPutab94d
4099	payment	1397	1397	1678	1	1	3429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwykBGDxWaWcsn3Fd4Ur6jQp8GjkMRxFhTNtWnB38MyHvb9zz
4100	payment	1397	1397	1678	1	1	3430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4hS7G1nhcw2vUXqBXBh5azjY5hSZaJcjin5QKGhDV4dT572q
4101	payment	1397	1397	1678	1	1	3431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmxfQ1zupkGgZHBmeMb129AGUhBMAhjcimkpK1GeBcMebVera
4102	delegation	1834	1834	1834	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjRrjENnVsAqS2iouhdpbBJPs3a9VUVRxCQvKx5re3bUnzn3Z
4103	payment	1397	1397	1678	1	1	3432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVLJxZtdTUizUixDK5ek4Twg2H9jNjS7nqMRTtJVkNxZXRGvC
4104	payment	1397	1397	1678	1	1	3433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Z418PUGxXp12mKqhLE4Ytpv9BF39jVsgWcYnYEBt8zXmUFKs
4105	payment	1397	1397	1678	1	1	3434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaTbqcc3PM5ikBTTmsCGoTHRU7zH4GciDPreHTnUi37tqj7Ct
4106	payment	1397	1397	1678	1	1	3435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jrF1HaMstv2qXwDopFo2V75jHM3BknNUYJfZns9KenKJUJdp
4107	payment	1397	1397	1678	1	1	3436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnGpDPxXzzLJtunvSSjijoMncQSF5XCkAiuZCZpyMCgG75EKJ
4108	payment	1397	1397	1678	1	1	3437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQuV8YffswUgrD8eVP9VaVR9neaw62fHTX4A2D6sewV8DGAwo
4109	payment	1397	1397	1678	1	1	3438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYscFMChsYf9pHQSQmFr5qFcCGgadhB148U7juakcpaCTBkVQ5Z
4110	payment	1397	1397	1678	1	1	3439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pHJdxMNoEKP8yuhTHPiJpYbHxgzesGeGMbzbXsH7pdxrY1m3
4111	payment	1397	1397	1678	1	1	3440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreeucw9rr6n2A4kMaWEAYCTGaCTVPJZqF6YgFtfnoWzubf7VS
4112	payment	1397	1397	1678	1	1	3441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2munbNzZg5cpTVHaWAJoYnPdTXbB68EdmrC1mrvaRmp45MKDX
4113	payment	1397	1397	1678	1	1	3442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkAosoLhJtHKq6eF4FhehMp7U8f8J8DCTBUZBSU8c8zytXpZ8
4114	payment	1397	1397	1678	1	1	3443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SPTV9F1PQ4hRnkqBiap9PGTVDZqZXGh2Htx1PAoVZUt7FZnC
4115	payment	1726	1726	1835	1	1	60	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEMFKUW4MnVm19XossVTEhQ8LuK7WuT25s91DbqghdQ1CHx6v9
4116	payment	1397	1397	1678	1	1	3444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bFpj66R2e9VPK5SXZmrrYVe2Z91JCYM7cKFy73aZnijBdQ4k
4117	payment	1397	1397	1678	1	1	3445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tNKQ4JdEsLEnUEaSm5oHyVAmbpdNSe4BZ1rK2sFYUMJeJYb1
4118	payment	1397	1397	1678	1	1	3446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSaFWaSTzBsmoVqpQpL63fPNjLYwGNba24ky9r1VcVDf8DuHSB
4119	payment	1397	1397	1678	1	1	3447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUbpnTass9v14YS3wvBX2YRkgRbYsyZJ4awRdVNGBavnrwTnr
4120	delegation	1803	1803	1803	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zzRMqJ8NBWijoRS4DzU9tXYVHwyqKtbLYF7MFYUZPd4Fvxtc
4121	payment	1397	1397	1678	1	1	3448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1gG1Gpjp1wsiryvBQhoiz7c8a56Z9JNrX6gJTvUgprCKeZfk
4122	payment	1397	1397	1678	1	1	3449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzW42iHEyYS2bu2fsv7bx4BMcS9qRxC88SmXZSN4WuadaXR58
4129	payment	1397	1397	1678	1	1	3455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtd1y2Hua6JSe5A8Wq3yuurn8fcPRCD9m3AgdCD6h8TYCFKvJ
4135	payment	1397	1397	1678	1	1	3461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdBLzFvotTm567HpzUpoMSKb8c3o3LxzYfLRNt4Nt7bmqtvUx
4136	payment	1397	1397	1678	1	1	3462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41s2XcZb4gfSyG93n4nXZL7cLdEGbQiQK15NFgwTEZmDVmwR1
4138	payment	1397	1397	1678	1	1	3464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJz7bjEQRawbYtErFeQjErKiA2A1YbLAGiGS7b1fLDSRrbij3
4139	payment	1397	1397	1678	1	1	3465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NL32MeZ1JFu3WfYbJY3gKrUCCAGnDAngfHfVWQtWGRn3CQz4
4140	payment	1397	1397	1678	1	1	3466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Z5QVas3WzVXhqR39wpXQEPSu6AqUE8jSHybqPLVsprCJEfD2
4141	payment	1397	1397	1678	1	1	3467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnaLMEVw8hFP19sW6oM2djAeBvdYsYfEUeYc6rQG7DyhrfKjA
4142	payment	1397	1397	1678	1	1	3468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfTh5KgDLtx3LDjWuZqtqCwo4bYZ41Dq72ieTWPzxHS1UyHbU
4146	payment	1397	1397	1678	1	1	3471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLYn6MfdHzBFsoJbMyaNgtAP68cx7KbD2yn2nVowoDXsZcK1M
4149	payment	1397	1397	1678	1	1	3474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhinuccbxmYwfyvdKh61HRXA1Symix9DmaYY53D4ttEMiGVNd
4150	payment	1397	1397	1678	1	1	3475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLGz36ZCSpNCUaBm9Pr8H2WpZsNwdkhcv8YBm3tM7BMEVaHUN
4151	payment	1397	1397	1678	1	1	3476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dGntPaNoCLojHn4y15wa5tUVviAa2Eiz94j3oeM2RzouxV9E
4152	payment	1397	1397	1678	1	1	3477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetB7swqCZePuYShbKyTAXayancLKAzjBhnmvRtX2VbrFoNeKX
4165	payment	1397	1397	1678	1	1	3489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6RXrz8ZmAc2EjTCEQE5hekSxt2SBsSS6UwL4mD2TGuLRtbXL
4169	payment	1397	1397	1678	1	1	3493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsy7LC4XFgb1wzNsNBnwk6oiVcq9HFKvg4246n5KabfUHbmK5M
4170	payment	1397	1397	1678	1	1	3494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNtpJsGGuJpN4SsUfrNLSMSMj5y5gUBhG1ddUHFk5FVg4edTf
4171	payment	1397	1397	1678	1	1	3495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GWR9wP3fG3zDyz9b7FsvgXum4CnmgHPnLEXBxNJN5xdMmfHh
4172	payment	1397	1397	1678	1	1	3496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCTejUGnwG7m6PEmfzg6ZWDoFbbpdRsQiLQPYMXr2ezBSN5zE
4181	payment	1397	1397	1678	1	1	3504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCUy2SeMCVoKVnTKTgTohsG5oRrhiwpiDFofYNpAXfGu9PeMc
4182	payment	1397	1397	1678	1	1	3505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELPBr8ReDtHEAeyfVRH5sSvXq54PZ8KWMUUTkPZLJkQTUYdjJ
4186	delegation	872	872	1765	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nTpoMp1BvfDLWieNXYiWXfVjRJ3KzREQiiwJV8PyyFPdowyB
4187	payment	1397	1397	1678	1	1	3508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGkiirUwMVcptaqKWxXYWCPgwEJ14o7x1cmbeiojbwTSfgVha
4197	payment	1397	1397	1678	1	1	3518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRU1kiruuL9QxqEisGdBVcdTXgYMGgXnoXqNA6TMKcfH13bpu7
4198	payment	1397	1397	1678	1	1	3519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3jWFXos7oM5kgCXFunYVUMULAjGvh6gRH1FgUorPk4pNUB6G
4199	payment	1397	1397	1678	1	1	3520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAene84deSf4Mmjjm1JJPXv5GoxJaej968AcmJBee19Ja8ZvNA
4200	payment	1397	1397	1678	1	1	3521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MNPK1bY2RoG8u1Vc5jxj16ou1vvtH5b8bc4pp8vB9RaoLnYD
4201	payment	1397	1397	1678	1	1	3522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbjzfc9Stv8Arnubk8ja2CJomgZ5e3hgz8WnnrasVcZSux1xs
4209	payment	1397	1397	1678	1	1	3529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHQ56YwUgjc8KDGYfpu4JnkLnK9VtxHmiGakCLGxbiRRfNwWw
4210	payment	1397	1397	1678	1	1	3530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwyy3WT4eH4eBXdEWXJ5n3nh4NZs6kEnHWNMDjHRw51yH9i9f
4220	payment	1397	1397	1678	1	1	3540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2L7BpmjohN7C2rjPht9Ve5LAiCmYAkYxF16LzKyJskMcFJbJQ
4225	payment	1397	1397	1678	1	1	3545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJb8mLYUE4RL9Sxz4dnX38g5JFrqHBWLo84KtJbr5tqH5FVJ8
4226	payment	1397	1397	1678	1	1	3546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgQh1eowSVir4pR1k33uQckz5mvcjM7wWjkQTMfEjgmZAUBWd
4236	payment	1397	1397	1678	1	1	3554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrVXQ9fb5CFh1vwk4qYLSibQsNj8qeYMBugiMnU6fQbPejQKu
4240	payment	1397	1397	1678	1	1	3558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29GEUCBAVsgSMPiyUs65ms3m4N8YQ9BxMV3PSdneX7wa631Cx
4245	payment	1397	1397	1678	1	1	3563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9C8EzujmphsyjTMDRUVabW1eSGzpRxv1FguhxEL8mtquFNdq
4246	payment	1397	1397	1678	1	1	3564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGCoPT2rk15ZNLGwwnGiADFDgSkfUgGyyVTiKn6ZgDUug63tE
4247	payment	1397	1397	1678	1	1	3565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwjxrThHiouEN6BxYa7K27eRLp7GkXbUS7JfR3gDzwCDCfz5f
4123	payment	1397	1397	1678	1	1	3450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9yqZ4y5EmX8SbmeG3yfhzHM4dnE34uuYFUwiZvG99UQX6LVy
4124	payment	1397	1397	1678	1	1	3451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2q6Wv3CnhqgqmnzSFbLJTvh5axF7HV41atXyQjWZetGEj3MwD
4128	payment	1397	1397	1678	1	1	3454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TRu1QGcRscpEKtocmRg25k6bDsNNA1ZLirreSKcXfamJpVPf
4130	payment	1397	1397	1678	1	1	3456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGj7qG6M3wjD4XddYRBgdSymyAXYEWVZKyQjtJD9cSrvSBZt7M
4131	payment	1397	1397	1678	1	1	3457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2nifJKQrypxtgSBapCrX6fYSQSe4xaJAWgwsoTggqyPVSaU6
4143	payment	1726	1726	1837	1	1	62	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYRMwetErPrkJxckgRiez9kFTxbEn4h5sy48JFdts3rinZycNnG
4144	payment	1397	1397	1678	1	1	3469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiorxHR6MnnfjJCFXbxLRWwwtATidsZ6jK9fZAdh17ZsHgmw7J
4148	payment	1397	1397	1678	1	1	3473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwSftLSTpZCXwg18XF2HXT8NtbfgZyVrozQa7qopY6RCgegFV
4153	payment	1397	1397	1678	1	1	3478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFPkGTg1KMrnBoHybPyRHZaWA8en63CdqHC4KpTEh5Rt6irFe
4154	payment	1397	1397	1678	1	1	3479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNk4DcQVnJ8boJx3VE3AFsoH4CaFaLqwqbMcDUBU8FmfNkBiy
4155	payment	1397	1397	1678	1	1	3480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AA4pKiPziyADUz57p1tszZKXc56dWQHXKUztEiFabrsX44MA
4162	payment	1693	1693	649	1	1	345	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYqqPshwVdy4HX1U7q4pCdvfz8Rj6g8Muf1YCkztWpXbDtpJ27M
4163	payment	1397	1397	1678	1	1	3487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGAea7Nn3FXjJ7d2SwiaUxiYH9MPCiQ62sSiPCwppEm2yag64
4164	payment	1397	1397	1678	1	1	3488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57PKcRWjTKyyuq2WiBy4SNUovs22AjUWR1nn1mquxQS1zTfbE
4166	payment	1397	1397	1678	1	1	3490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGYzhEw9NhAcWFTUCbaBkP9ELUmM7FHdw6TQoJMJNZnupt5Pt
4173	payment	1397	1397	1678	1	1	3497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxBfpM8WSgE9jgB4XmHgTkEJPohpv2YTpeEHT3XxfkVCP9Cmi
4174	payment	1397	1397	1678	1	1	3498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Qaqy7KAPfXmNQiSPQGTFgMxsvaavJ2CQFBHd6JHLByS9jeLm
4176	payment	1397	1397	1678	1	1	3500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFiULPy3zbJMh6hPnyjzstbc4r5kVpnMC5U8UZTZ5KRoFsNSo
4184	payment	1397	1397	1678	1	1	3507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQJw7LFeNkd7U8xAsSWr3hbZonSbsyFxfwX8gWYLhhrf5Ms7u
4185	delegation	1769	1769	1406	1	1	13	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4QMFfTgGTmapTFWmutr3ZvEnV3NzktHmCZFVd78wTay2pnC8X
4193	payment	1397	1397	1678	1	1	3514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpin62ghLPiXKh3RKLD2LMDKiHWJinNcJYGBvENwot2oWKze8m
4194	payment	1397	1397	1678	1	1	3515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVa2VKgcg64nAdSMr4UQSdhGHH3HzyxbEX8j39CNFyVxfKzDs
4203	delegation	649	649	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNNbtrHhQLDXjrFzs6aHgfBZWRCCGeH5zFy2es718VRC5TwqQ
4204	payment	1397	1397	1678	1	1	3524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBwCCPu2GLwPfEP7c1DZNmShXfou5Zbu3Ncj255yMERxPBVt7
4206	payment	1397	1397	1678	1	1	3526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiA5D1iK792qAiQ4R9sVMnJ8mQq8pbGJz5gF8goCwsYnZx3Dxj
4208	payment	1397	1397	1678	1	1	3528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLFZuekWQc6EcKdBrHwob1iW24bEvLivDmtfRXiDXiPDCESHt
4211	payment	1397	1397	1678	1	1	3531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEzhszwGNg3FXwwPnXt3qB93uRMTNnJsGbJB3sobwSfmCRAYE
4221	payment	1397	1397	1678	1	1	3541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGLXNgcej88T7skSN69i9zoFrVEwrJzdv5WBBYb9DLiGsgwY7
4222	payment	1397	1397	1678	1	1	3542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVNmFUn6UdHN9YpbMQ3MqWAHVKG8CJ2yTqq7eUJEDfSDBFxxF
4233	payment	1397	1397	1678	1	1	3552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PMZdWD9h3kXWe65SRS1cMSpqTTgBnn6CAWv9Z3xDu8g5xVu7
4234	payment	1397	1397	1678	1	1	3553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptRwVyz1MgiAAqLFYW5X6zVx8Aiw2FNEv4sTPPw3eJwaJNtoB
4235	delegation	510	510	1429	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVsC5yw4VqMCx4n7cDFxgKJJKQtc6AGfH9E4LLDiGEbxb5Dcj
4237	payment	1397	1397	1678	1	1	3555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyo5AZ9ZacXhxh5kiXMycaJmexiwPaZAg2iVmcr9hHc7CFeuDf
4238	payment	1397	1397	1678	1	1	3556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskzCaeA8jEjW2fwG6p6TrTPQGRhm92ggV4wV1o8JacXvBaHhd
4239	payment	1397	1397	1678	1	1	3557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2ecvYducUqhGDwHcKnuuf87HaLR4kkBEhDsVBBD2ZgZVpQp4
4242	payment	1397	1397	1678	1	1	3560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo5EzWUMhxx2uDC9zc9PqUaVBNXttarQT8pdHZ2JhJr3CNCjLm
4243	payment	1397	1397	1678	1	1	3561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRsv4DbdirieLGwz3TXqnwDupS4Vstg5yTrXbSxhLHbfazzJQ
4254	payment	1397	1397	1678	1	1	3572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7qnV4LMLkT8mkL7H1UmrXDmXjPoZcxiAArPPEHTD2C7Jf7oz
4125	payment	1397	1397	1678	1	1	3452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2UYFMVBowbUqPFbDHQKmppgCZoh1Ta7srBD4QjuRwT3VoEzj
4132	payment	1397	1397	1678	1	1	3458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFesiVEFwsZ67idxSEe5kM3WR2cuJpGJw1WVJ18je5XAZGguoJ
4137	payment	1397	1397	1678	1	1	3463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvQTJ4ZPN7W6VsQUqcxd4qHzyGF46ufXzrnzU4eAWv5VtfsaT
4156	payment	1397	1397	1678	1	1	3481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhkpXpQMtBUoQa3jcrQ7yE6po1fnif6AsiqEhjmJjA5iG1bmp
4157	payment	1397	1397	1678	1	1	3482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLBKNCB9L3K9teK9bRPy5B9FNMMWxCaE1YhxRAa3xGbboeVxj
4158	payment	1397	1397	1678	1	1	3483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8u97xXHqNmgEsbYNbvQJYDNoCCCzaiHLHcYmpaJ5yqq125yd
4159	payment	1397	1397	1678	1	1	3484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx79aTtXXHRkYWaVAJd1s5JRqyjiZQWEppeRdmzNqRAc2Xi6B8
4167	payment	1397	1397	1678	1	1	3491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb39cf5CkSre5baKJ3P8mEqHUx9xbM4aao5NGPXKRYGFbLtRFH
4175	payment	1397	1397	1678	1	1	3499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwciYZw8z4PTsXfzn9CEcuQCAB7KEZr1suA3KABVviHWeYHKn
4188	payment	1397	1397	1678	1	1	3509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTr9rTdnT3ywtmuKq6poVVMzU7tvPHp2FE1uM6xg2WJPeqdaYw
4189	payment	1397	1397	1678	1	1	3510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqf65hBwqogh6BKrbZ3fHkuBKXHwrZ61gwgkmhGPmNEsgwtgF
4202	payment	1397	1397	1678	1	1	3523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XvxztgqjUs8ZS23sciqz4CAm8qXp4TkSGawPJfzw22NxhcFf
4205	payment	1397	1397	1678	1	1	3525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyYaceBm1nFkXd7aEpSQTNmpTftUg5NtHCtraMWumqsyY3unB
4207	payment	1397	1397	1678	1	1	3527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXQdqQknUujnZRmXEfYkAeJq9yAhNe6kRJTJ61CzLUDg82Xpt
4212	payment	1397	1397	1678	1	1	3532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQ7p39dR8ta5DBWmL5bhrKVGWp5qsBEfv14XutQgJtDgpcG9k
4215	payment	1397	1397	1678	1	1	3535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcUh454iLjegeyTS8NJLFqyvHQiDW3YcPxsAL3nWi1xV2ET7m
4216	payment	1397	1397	1678	1	1	3536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yJJ4FfDH7TjfnFKu8KT8ukG7uVJWnjdNCpVancxTdJDTg7Ay
4217	payment	1397	1397	1678	1	1	3537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnXeATZ1XGus6jXf6eNUjqCwGsHSJh2NHLZQmQUKUnNjAEkeH
4218	payment	1397	1397	1678	1	1	3538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiaDZptf1WBpcMhVEfzg1g9L3MoEDzW6n3PUGYoCSamytmoFwD
4219	payment	1397	1397	1678	1	1	3539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7ME6bSLWYUCSGK7wCjzZRiwSAPAr9QvNTxR321JLQfe6FHTr
4223	payment	1397	1397	1678	1	1	3543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUo8Fp4BFnC6GRJ16YvrK6TJj6EBxrXp3DTX1A5jLuPi9PRApq
4224	payment	1397	1397	1678	1	1	3544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpAowco5R9dn2JdHNrfQnxhAkUUeKtTJ57GkjaWJKXZRYSsT37
4227	payment	1726	1726	1838	1	1	63	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkjvpzjHuBZNJExSNxzeimHgF2WsqZk94puRRj9KBhR453sru5
4228	payment	1397	1397	1678	1	1	3547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDy2Qn9ouzJoTFdcsJguCXuxPHvRXKy2BjaWhwtwtD9ryqMX2q
4229	payment	1397	1397	1678	1	1	3548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcpfhiGPZn9kz5rfWhBgCtmk2LYjgtvWvuU6LoE5tqu8QeHVY
4230	payment	1397	1397	1678	1	1	3549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuoHZ4rD7wk4p1nwj4N6BZeeSHzyNCy6EagyajvJrXnibRAMr
4231	payment	1397	1397	1678	1	1	3550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aNWYqm3m1jnqerHPhMRVpju13eMVxxPDKXaqEv6jFMXPyjs1
4232	payment	1397	1397	1678	1	1	3551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofuDL9n4zDuv2NH2eZ1xuL9hQKyubrYxFtaDDpb21yA4pbimG
4241	payment	1397	1397	1678	1	1	3559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREVqW8E6EEPyvh7vyLHmbWmDQPnETdYsfh1iqvyfQ9GCU4e8s
4248	payment	1397	1397	1678	1	1	3566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvATHXZsDs2rE9H8XZjwkH4Cy2ZvtAX66wJcUdoMUP1zyyaPnj
4251	payment	1397	1397	1678	1	1	3569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenoRJhoNS9SSCkPaVc1oCJECuewAWDVDGMMrMNVfdNHAfsvbn
4252	payment	1397	1397	1678	1	1	3570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JnstApVaWanN5FepQatURCPoZbzUQxTu6SSmR6H7AizNGF8L
4262	payment	1397	1397	1678	1	1	3580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeabUuV6Pgw3XAeWLH8zM5Bd2nmCww5kiUHzpQHUtJTX28duY
4263	payment	1397	1397	1678	1	1	3581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BGv92aLqVULXtrfHB9zv87qfjq4woizWa6vMLa3FkFb5nTtU
4264	payment	1397	1397	1678	1	1	3582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGJnuEdzxcGMeFievPxBQJYyCT8nqjTrJp6pWUSwyCGGHWU8y
4268	payment	1397	1397	1678	1	1	3586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUu2eYG9Xh2uG4vPHwf99D9HJRKVjBk3nNK7pv5msGNKkzHt18
4274	payment	1397	1397	1678	1	1	3592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzvPpAAPmPexxbV48KWPZnxwR5cH4XYFt1KyoQkuFQCCSAWVD
4275	payment	1397	1397	1678	1	1	3593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYeGgDe9g6dtBfJyzJwRqMVUn32qkHq2i9omVbbGFw8kRCvzoJ
4126	payment	1726	1726	1836	1	1	61	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZuRJAvu5stBXY7iiLRRTVZz3zmsQs7fgewbF91ocp79z5BnvXf
4127	payment	1397	1397	1678	1	1	3453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUeqVsc7bE545QhqFRSQ8NXDEB2VJTPmfSeevWknVxTBtpj8b
4133	payment	1397	1397	1678	1	1	3459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uoUWGhknc5JR3FNmmtkafuXSP35qB3d59GQgn1GkzEYc14Bs
4134	payment	1397	1397	1678	1	1	3460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKR72oB7JyFC2vahUQzAvGC69hh2N7joQK5w3bJxsJkfSamq7
4145	payment	1397	1397	1678	1	1	3470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJiYYJnPcUskj2iZi5ZwKQfBV9Mz87Y2CJeLfPoUX813iXZra
4147	payment	1397	1397	1678	1	1	3472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhETRYjBet72aP8zGeCKkZ5eL47UfVS9yDULKZWTpHj7ukASwq
4160	payment	1397	1397	1678	1	1	3485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2MiKgDYGUmv4TDL9qzYACsX8aKc57qLowUKiD1UgmpRcfcFd
4161	payment	1397	1397	1678	1	1	3486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CwQ32jfDLC8aL8wueoKN8v2Tza8naJ5TmwKkbox6LfDVSgsp
4168	payment	1397	1397	1678	1	1	3492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4oMR74fPRzuEHXbnE3emqeHZRWA1RikX5DyPyGELqrnrtxaxr
4177	payment	1397	1397	1678	1	1	3501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNb2T1JxEMaLjB9FjFp4uXkm1bu8q5zk5cJC9r4EpFMR8jcqQ
4178	payment	1765	1765	872	1	1	1	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhE763UAA2fws4Qqk9Bxd9aWFZxG7rCBpGpP1ckMNPnDkX2YK
4179	payment	1397	1397	1678	1	1	3502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE98KehbfRRa62FFegqjTaSyzor6SUJP6u4SdwzLnQW9xNetK
4180	payment	1397	1397	1678	1	1	3503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDLZfrk4u4a32fo8V2ttdfprbygejMgrLFH7bAqt9WQZr8PHH
4183	payment	1397	1397	1678	1	1	3506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPi84vvDsNKbg62DhyjvgSSp8sJgTgohfi89kvjeBcwa8Qy1L
4190	payment	1397	1397	1678	1	1	3511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ELiJgY216dWQ3yH5xPQgfiYm7na8rxFTcjPYz1jGgbA21Lw3
4191	payment	1397	1397	1678	1	1	3512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hojBseVrPbRmE6AAPX2foye2tN1GckUAFBqArWfYsKWhv4Es
4192	payment	1397	1397	1678	1	1	3513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPqQiN9ZWZi2ZEncaeLGornsvFdoYTBYaUvi153Fph7sEDKVX
4195	payment	1397	1397	1678	1	1	3516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7DYRx2zoP76BZxbyD5vkmK42PsuvZ9tZKaEfkjr1dCtYyi5P
4196	payment	1397	1397	1678	1	1	3517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUM29HPnUXzXgvGazJGSDZqwMzzKTTXBiVQksxYcHfh1YMv4S
4213	payment	1397	1397	1678	1	1	3533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdgN8dQFKM85H7umD2wRUzAuuHzULacbLmv6n646ZHjQxPnxV
4214	payment	1397	1397	1678	1	1	3534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrn4zudEkZBhKYjv516JWDjMoB9muXyxzqDYqS63pif1DetGE
4244	payment	1397	1397	1678	1	1	3562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnomP5FovQf1N37gEuhzb8MPRXZUKYQsAGGnNehgyfRHwXhtES
4249	payment	1397	1397	1678	1	1	3567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHY4ViHuEuEbnT3c33Q5zxdc5yBdptiLwJ5Tbr5Q67TVBBFo1
4253	payment	1397	1397	1678	1	1	3571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3vvNo2qBVCCPeLuCTNATfNwgniLKWPYG9HQ1aLYEcDK4zR9J
4255	payment	1397	1397	1678	1	1	3573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ979nE29UAsdrevLfhFtS8tEf4hULcR8Zbu8fwe8zuXYryXVAh
4256	payment	1397	1397	1678	1	1	3574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wRSGJmtnpCzfeQjHmbMMs8GDcwuSjUQbWBSndLnywdYadY88
4257	payment	1397	1397	1678	1	1	3575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93KSNxYBs3eCu7QjjBBrn7kfm6UAA5hJBzhVPjp5bgo6jTpmD
4258	payment	1397	1397	1678	1	1	3576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQenKtUL1a7RQcWZgKmcr931H7KPdhc6P1zLVmf3sxuSqvj3E
4261	payment	1397	1397	1678	1	1	3579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTstayFyT9oXpg5AFGBmeKNf62sQSGF3YjMbDUcHLELxzX62RR
4270	payment	1397	1397	1678	1	1	3588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgFDAZGYnEx1pNwdjD7rjGGmnEgN8w1zZEVy2DhjiFWwdPPYZH
4273	payment	1397	1397	1678	1	1	3591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWHQACpBFqN3DGaRskU29AaKXiosZ8DfeBhGo6mQUonANxwYN
4278	payment	1397	1397	1678	1	1	3596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpHf8BQ62XKoWNvUCZukZsSR3v2QijxQ8VQatNcEP6Fz1KcH9
4281	payment	1397	1397	1678	1	1	3599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPbLYw83tNm1wnmfRZUssbKnoVixPFaB3hGVLpuZm9UeHtBFw
4282	payment	1800	1800	1816	1	1	2	0	10000000	\N	E4Yj1dXBXdoHw7N1Fe9aPax1EgRNFLPLvmThzjEVesZGLyLsbBxSU	CkpYyMV4jDtgKfbz6hCUVB6J8jYfJd85A7mvtVw7ydKLuoCK5GS25
4286	payment	1397	1397	1678	1	1	3603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uoTzYPHFEWNzgjGkywAm3KLxeGzufbRXJ6U8GErErzqYD3be
4289	payment	1397	1397	1678	1	1	3606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6cxRZbz2N6VdGryXCJkq5BY8EExwd68mZ8xtYXvyQ8WVXHxN
4290	payment	1397	1397	1678	1	1	3607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCXt3wVtLkSsvoaqx21cCqGrK9FbCovzg8krRhLDHkESbQbeH
4300	payment	1397	1397	1678	1	1	3616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ426E3RyKoBmWwKL9pdwBMU2zUZ2ewwQUM1MZPL79JoWtJEexZ
4250	payment	1397	1397	1678	1	1	3568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyashwsn6nvkazgmnBPLScDpqmapuEhC9H6U4XLDvQVgvUqYF
4259	payment	1397	1397	1678	1	1	3577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGVwNzs6vnsw5EGn4hyGotpUXTmBAbPf4pUur28A8qw3VVRCS
4260	payment	1397	1397	1678	1	1	3578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6Kd6ttJrWdf3Axp1Jj1Gm63C6Xjmv8AkTAsn2dLevmfhcpFR
4266	payment	1397	1397	1678	1	1	3584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAUy8nVn5XkL3Qex1qqgGYJtzFVieEQPbTFsVHSRdRfMCUtJx
4267	payment	1397	1397	1678	1	1	3585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvpGMn9ggDuzHLeKWkQwdLSFM9eqs3hrCzPy8qPHwiGtvYW9X
4271	payment	1397	1397	1678	1	1	3589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurav8umbhmHKhss8fHQpuihRaXvyxNhrQrxZPFjM8LRZ1RuVS
4272	payment	1397	1397	1678	1	1	3590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCfu4jhCso13zVyvwCpHvK7SESKX54a41xVjyKPEnNfgPoe1E
4276	payment	1397	1397	1678	1	1	3594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVfLK2PA9xgXEj7cSgyJ4jArJKKdcYsaZv9wZWsvuDYaGBgMR
4279	payment	1397	1397	1678	1	1	3597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76tfRBb91Gq1qSYQvDjJq9QJb2GouhQfkezuWDySkvkqgNkj2
4280	payment	1397	1397	1678	1	1	3598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Q3EKPyxZgGkr6NypxUcHM5xwwjdvSv6HNeRQ2bq2ETRa28yK
4285	payment	1397	1397	1678	1	1	3602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDsWSYpiijMYFzrFVE2yUAB5ejFkE6DJbaoWeGsH84thYcxrh
4288	payment	1397	1397	1678	1	1	3605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQPWMEsKBwBkkKSBjV5f74f79tGS6xd1UKpLAKwogXSexJwzv
4291	payment	1726	1726	1839	1	1	64	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcNvJ7rPUn3LgFaXnHiZAA718UkiA1ZY4RCJDXoQAKYVmm5tbD
4292	payment	1397	1397	1678	1	1	3608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZhqaFXEinJuJYG2YQLcsi5XeMc31h1iccnoGv3EtPU61DxNa
4293	payment	1397	1397	1678	1	1	3609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxp4oStE6JuP6nPkqniAfUSiBYCV29xSpi576a2xyuJhLtfKMs
4296	payment	1397	1397	1678	1	1	3612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtEMtdhiwCgj9i6XEFcZ3VZT4WNLR6r4dEnRQUDsm14DB2Ryfw
4297	payment	1397	1397	1678	1	1	3613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECuSptgu9sJm9BDgnSHhn5Grs9ZEbqxmiCBhoCZUL2S2h9h1C
4298	payment	1397	1397	1678	1	1	3614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNF3mJiBTAotPdcHrvpDnQdNJLz6u2bihRUSyrAp7NxbzSfME
4309	payment	1397	1397	1678	1	1	3625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawjhesziPUTqwzpPhU232WCfKk23RJmXwdo9GPpyKMXp8y727
4320	payment	1397	1397	1678	1	1	3636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUxBoNrkvCsmf6JDksJezfstRh1R7ENEEVVWUVPgfLUeqYVTS
4321	delegation	458	458	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6h9XbrQJS13T58zaSrxzPULi2Rb178siP88KDpEPyEzJ3Tyhy
4325	payment	1397	1397	1678	1	1	3639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5hxUsRDwBSQecTPPvDNNMvPNjgkFVXy9k1K7GxrXmp1JDCTa
4326	payment	1397	1397	1678	1	1	3640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZYPaxZXLnApDqYz7vvHjQQJpBrwHUgA8x6prLTKqKUg1E3FE
4327	payment	1397	1397	1678	1	1	3641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe23kgvUEmG7PoQTtidrWgWeA1NxWvyNPgUp9eYQ67U1YXoaLb
4339	payment	1397	1397	1678	1	1	3653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmEdwuybXNzrsD9wSAwv1FGw2cV6S2gKGwQVxVAC8yb5jZrtK
4342	payment	1397	1397	1678	1	1	3656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAf2enuYLTetoXsW1Bv6YTxZFXiVjXiBuvsQC6vMJ2Vbjd3541
4343	payment	1397	1397	1678	1	1	3657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmde5LUyWRupvUqWP5d4jbyX6vEoLVHAvex6mmf6UyneeRZti
4346	payment	1397	1397	1678	1	1	3660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4J9qGjJPPqm3KN1j8KYpxCjhraFr2uPnVdZ3p5HixEKx5d2ML
4349	payment	1397	1397	1678	1	1	3663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupqn2Tz55cKpdyBjJMmMq37nxyXzF3Fxg1YtvK69e6tKBLT2t
4354	payment	1397	1397	1678	1	1	3668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUcn75VeAMiXmBtvJSUqQhXauDDWgoigTaKT641V4shqwbEDK
4355	payment	1639	1639	1840	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tm7AkxVCCwCvpszD5mGLdguwtzTgmcF77oRYkrCwUXLpopqw
4360	payment	1397	1397	1678	1	1	3673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswXmqvPVFcu69h2Bbv58pQV7AYAcJhvTK8ie4b3PE45p1vyT6
4363	payment	1397	1397	1678	1	1	3676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnjEi9gahy7ZXfXb8dt4Uhmwr8jTadYBue2YZGnqth3ffJGqi
4373	payment	1397	1397	1678	1	1	3686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxT6YPMLFmy9XeGetuj3RWXuJRZCNwkekjnmqLKrjXqEuh38h
4389	payment	1397	1397	1678	1	1	3702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjU8EyxRyZ61wWQZ8Q53k4bxLwDE5AxuRjhf7S6ta8EHPWsECG
4390	payment	1397	1397	1678	1	1	3703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSj7Rri5kCfH6bD4EEdRtgq3kzYAgMmfKL2PuuW1YfoNHzkRd
4392	payment	1397	1397	1678	1	1	3705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZUyUK6HBHWpcFfNwUKVLT434zfzbKEyFR7hGCya2sjNLzzYv
4393	payment	1397	1397	1678	1	1	3706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxEhof8LhoGFfRuLA2mTgV6zHFjYhAY4CbftMXSJ19uSDFKfy
4265	payment	1397	1397	1678	1	1	3583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerpwEPBzp1R3vsWQFSGP66zSELVcCevtjFwvVJKXGetytkQxy
4269	payment	1397	1397	1678	1	1	3587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkMb6DEH28X6fKedJfbwt6722srpMHAgpnBRm19nJ9zoxeCQv
4277	payment	1397	1397	1678	1	1	3595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHkgJRp6fdJvXFoaqLoqGmsr41KZiR2tume8S57gnU4YThChs
4287	payment	1397	1397	1678	1	1	3604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLDtEBkp6AxG5TGNsXF2MYeuEioaNrSEgbA9gu1T1RXx29DF8
4295	payment	1397	1397	1678	1	1	3611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeETrb4jXiuXCZXTQCZaRkZQ17TVwaUx5mnkyAzyezCGumsRJj
4299	payment	1397	1397	1678	1	1	3615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLux1bN4QZwUXYLGT6inNzJ3BRsnPxMCEpYM9hBtqVzetnoZP
4302	payment	1397	1397	1678	1	1	3618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvQ4muzdDQSCtJPEZDyTybnDKHTdyHjPnsxdFASVNMdpjoQuq
4303	payment	1397	1397	1678	1	1	3619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7bX5dYALT2YXXhnrboB1iFCZ9Xcv9bRFgPuhuJAZtASxBymA
4307	payment	1397	1397	1678	1	1	3623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9fwv3xShhSm3FXWcsHAnDaT9LXBHEPeyZNhkx8Kb4WbLWxLP
4313	payment	1397	1397	1678	1	1	3629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHSyrVfZx6R8UfJRDLSTZVbUEREeYmJvYmsQD7LZMbuJ8dNYw
4314	payment	1397	1397	1678	1	1	3630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMkZAHhZ66WM5dsdvv8M2A4zfQS7QTn6ZyFnvwzSzku2XtXdp
4315	payment	1397	1397	1678	1	1	3631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9p5LuwmRDdyPhRa9VW4auy5D21CJpMBn8UU2jD29hetSe6isM
4318	payment	1397	1397	1678	1	1	3634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrM24opNSrZkEEjPeMbDop4Cse8KgTsLTiAxHX5oeSy5eQ8WP
4319	payment	1397	1397	1678	1	1	3635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLULkB36pjySrqFPWjBt4uyTgaH34jRfaUigxunfeCdWo7YhQE
4332	payment	1397	1397	1678	1	1	3646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijKLGj9jc6cNhj6k7ssLSwV3KkhzCZ2ensVgLya6kUotYzVL6
4345	payment	1397	1397	1678	1	1	3659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8J4jgV2BmtgDDh86ZZSrRuuRjQmsLar3QpyvMb6zojNQkGPQR
4352	payment	1397	1397	1678	1	1	3666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKRoYHey9paxD4CJ9R4XM3c7ivGu5AGdtevaE8BvgKVzHW8cm
4353	payment	1397	1397	1678	1	1	3667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRcLMyo934hFrceLBtP85954ExkrmY64DZhFaoUZHjd3T8hNu
4362	payment	1397	1397	1678	1	1	3675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpD2PYyqeyFpHjUFrR6UimhZ5JPyZgfkjGymQKw2wQA9Z5MNpH
4367	payment	1397	1397	1678	1	1	3680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwc7t9o1CH4reobpdQHtnGRB5gRmZC4HmGN5BZqAHUhHGzAHJ4
4369	payment	1397	1397	1678	1	1	3682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3D8MrkDpV4J96yRZat7ZSFy22S6xatecnZowbSHeHargJAko
4371	payment	1397	1397	1678	1	1	3684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXY6pz4s9BoMyaGBLoEqGboJdMuxsSo8K27AUvdyUutPrKMaW
4372	payment	1397	1397	1678	1	1	3685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpV33FMDN5bDy9KvMEomfmu5TX91BvBreNrt4i4dL5E6pDiw1t
4376	payment	1397	1397	1678	1	1	3689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsBRVAC5Xywh8ozLidahef6WKg26ipqLGejBBRrPgH9vEZTeH
4379	payment	1397	1397	1678	1	1	3692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWhSzJfL6jWcudqxMa8p2JiVGt55ZVrBrHWe4qJefXR6JGsNN
4383	payment	1397	1397	1678	1	1	3696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsquPppx2sdGhY5pchz5x2pU8qzUgTWL7HWVALxTfu9h3uiUiq
4388	payment	1397	1397	1678	1	1	3701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMP1c7jdiNt5dWEVfGG7FEKQcA9tp2b1YxQz7mopuRdvjwisGE
4398	payment	1639	1639	1841	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAByga69ikAhofgi9Fa1y3dDLYKnaxp6yNBYZmoZf2z2kC5Vm
4403	payment	1750	1750	1842	1	1	4	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHTbVbQxumpRXNzrCtY4mjGEmEfN9m5VXw9iLofdNjSJZHwVCy
4411	delegation	1769	1769	44	1	1	14	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGiBrDJf4qcG8aAEbVkfCcuxZR3gLSdU6wHYJJ1qQLrirc8AE
4414	delegation	240	240	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kkLvsCT53DWmoAJzCyBVoES7wfYw1eNyGkCYLoLXcTEXS5hW
4415	payment	1562	1562	492	1	1	0	719000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmv3KkkKa6YXXgGKkZEvJvZgxkeoqL3BSujU3nCsskWCkXKKD
4418	delegation	1702	1702	1651	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDpRTKtET7rVhpcjaH32zqdySuNA8Uup3MdZuPhq9cAVDBfV5
4420	delegation	1844	1844	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9H6YKLqwWenN9oxFbwb6XzF4Ao3zLyW2P3Wh3GA67z3TyKbh9
4421	delegation	1844	1844	1483	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDkPk96FmtA2HS2qcap6DBoNXXxJVB3uWAkVZMVGMXjjPp5on
4424	payment	1397	1397	1678	1	1	3711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7usTr8Hvvj5LYzaEtCW1X5t44191dz22B1xHBf6uoSSC8GHGM
4428	payment	1397	1397	1678	1	1	3715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZsVaoF4KSMezpQSyJnEFAEdWdpWhpCJopNGoGLMoXSNJi5GPj
4436	payment	1397	1397	1678	1	1	3723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCmZ7YuKgUKvFPAnVJAz4E2CiMT39wm9sgb88eLQ39mrao1mV
4283	payment	1397	1397	1678	1	1	3600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8aRpPsDSNZs8hPUzPACGM4aSJdrrbvAGpz7hbdBs2Ayx5QKXC
4284	payment	1397	1397	1678	1	1	3601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9VDfKyQwSa5xZfJcXb4EMtDHAGc1CCNHLjt1aB8Th87XeHg1
4294	payment	1397	1397	1678	1	1	3610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFBbH1K6m6cyLUWrwQpnNhwuRAf1fJAgdXjnc3K4mcLPm7vMJ
4301	payment	1397	1397	1678	1	1	3617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9yH22JMosjyt36DU5HQQbCiuMxZHn7gKmnkkWn1EPbw3XMYL
4304	payment	1397	1397	1678	1	1	3620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpGbEC4GobEFgQQ8gznXGAEDNrKaQ2RvJcJeBvrb7SEVwfE4PT
4305	payment	1397	1397	1678	1	1	3621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54DCboULhmfGrvKQAgH42aFtA71ajrWTwa9pTBASE2e5vtXDW
4306	payment	1397	1397	1678	1	1	3622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzyeRxnWpz1mkYZDFiJXtzmy7t6pRVZhAyfuJGR5cA8MPRyBF
4310	payment	1397	1397	1678	1	1	3626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHc85a9QSba6LWjLuLDrLFNLAVh1Vprbdvoj1UbpCajAgxVqsZ
4316	payment	1397	1397	1678	1	1	3632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGuPgXxNmXXJbjUtoYMwYJfVKKbqMjwS1ojjQfSbBBCsmrLgX
4317	payment	1397	1397	1678	1	1	3633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvonbiyXnXNv7V9f5WzZcYSjchQK1p8JeCYdq9X7Efeh7phnz
4322	payment	1397	1397	1678	1	1	3637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUN14LqdNTtXTJzXqN435pLDFfF9hWosf576JNYSnMZSbJumw9
4330	payment	1397	1397	1678	1	1	3644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCDiUxsxeT5fah2kTVjyZ8Xnhn42QHgnvzea56vgP1fSYBnkx
4331	payment	1397	1397	1678	1	1	3645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACyTouYvDHWRFCuAvqDAzJ2CaxrJCs8Fggqmm828AKkKQhMWD
4334	payment	1397	1397	1678	1	1	3648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXFQQg1jZcMvxT6vHugdgs5NyEF61EHTRa9pACpLHEzUWs1Qs
4335	payment	1397	1397	1678	1	1	3649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcGxw4HjMcJ2yK7cnUJyrN2zi5pYQ9wgRfydV1GyaCuWkCuei
4338	payment	1397	1397	1678	1	1	3652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCMv8g8Sv2sXKCQtRGKxwbHCXcYaDBjKJdsyvKG7WwxH1aWfz
4350	payment	1397	1397	1678	1	1	3664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5pQKBkUhwGKdbt2ZHkMZMJn8ciLvV8mtoGxH5Kz6AYzwA95H
4351	payment	1397	1397	1678	1	1	3665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5BSoYD2k6UFto1d6G27Ach4RdxCydLGFvEhQmF7fTaQd6dNz
4356	payment	1397	1397	1678	1	1	3669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgeDKybkTn5vLRYsNQZdRKWVfsnFhDwSSuTYJjwo2PWWmfV41
4358	payment	1397	1397	1678	1	1	3671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzS175Y4eykZhu42JaBuoNaX4uPq5Mm8FffB1vx7BZHUWMwXD
4359	payment	1397	1397	1678	1	1	3672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1sx5PxRQsqdg24JuVZVJWyDwEHYLWavF6Btukmkdt81WB6Dy
4365	payment	1397	1397	1678	1	1	3678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWv5AThQ8WgkB1XDmTnrkzDHfJMFGuLzZSyn8xu3apvH8YFbzt
4366	payment	1397	1397	1678	1	1	3679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCG9hL7QgF9FRadhmuZEBFGN7UhwGxxceZX3UVFkmz6313kZKa
4370	payment	1397	1397	1678	1	1	3683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwez395nK84SGRdcN6qWtY9SVqdfzqnF4UiBKDGpyxaBRHPqd
4374	payment	1397	1397	1678	1	1	3687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEiXf1y7bhkUR6zWWGhSKdaUZcBqbLLLar8EGY95udV6vtaNb
4377	payment	1397	1397	1678	1	1	3690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxaNX3DFkiJyBVfG1NbvUkdNK8vZptfQTLaqNEqShbZapLNes
4378	payment	1397	1397	1678	1	1	3691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ275tE4At8kgnkpU8ywopsBNNBitsC2jLH8VKYh3iwbUKRGqpJ
4381	payment	1397	1397	1678	1	1	3694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoAYVCEBdNJes5g46QdjmXoKZgeCXhToRpjXS7tRojMe424mZ
4382	payment	1397	1397	1678	1	1	3695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqedPWxsRSvvfNZmRLDryKSMCaoCcaM8wcMgG7BEvn1e2UoE3d
4384	payment	1397	1397	1678	1	1	3697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrViPpQ9bzc8QS2nowJxAakdx1NpupVDe6aeb9BUJoEHmubeZ
4385	payment	1397	1397	1678	1	1	3698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwVgAqyZf377gtfJtEaphQr9Y9MquAv2vPttPzCJc5YpGHKSQ
4394	payment	1397	1397	1678	1	1	3707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNQPJ89S77wMTxbjnrj3cW5aWhH87ZPWcN913TtZoqxRvxpnU
4395	payment	1397	1397	1678	1	1	3708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7QEswBpxmEaEywrGEewVmf3uGMYoGz8wAtj65qKX2sMpw86g
4396	payment	1397	1397	1678	1	1	3709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfgLAaqREPMTWLiWNefTe4KzkYqdFLvWV9kibMj3YAKs9V7Uk
4413	payment	1802	1802	1833	1	1	0	190000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtaJenUqFp6ZFPTLmz8ravXKikMGBQe9F1oY3rXmYgfxyJ1Pqh
4417	payment	1682	1682	1850	1	1	5	8624000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGkBQDSmaPb5pjVZWNeMe2NaCW5FmGuKpZev6tH1MxqHafFST
4419	payment	1726	1726	1851	1	1	73	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJaNMqEPgFbRuD5RAozfTqiRXi8oxkog3UhcytDJ5DHfcU7Zym
4429	payment	1397	1397	1678	1	1	3716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4K6op1kzHfGoY1t9vW7E1XPQwV6BzsG8cAmnZw3hsV7JjbQB
4308	payment	1397	1397	1678	1	1	3624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhR85AU1gxczUK4WF56PRpCXanZLHohdCMMrAiQtvHb2fLcqtf
4311	payment	1397	1397	1678	1	1	3627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqvENCwRPjDesaPovqxMHrVHvR2d25zbHT7bfgacT9bEoAfih
4312	payment	1397	1397	1678	1	1	3628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CL5Sibu2TU7BemHLpsE9Ewo4hGzjW1KYBWkuNho2RiDGy9Xn
4323	delegation	711	711	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtQyAE9GwWRMb8oNys781iLnkiFNmrFWVfL9GyVPgUmVSdsQB
4324	payment	1397	1397	1678	1	1	3638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUa6WJHqQWYswaa8dvKEnydDX6WngbxFwfAqMsZftFtderyXd
4328	payment	1397	1397	1678	1	1	3642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzptv9ubGDj1TRv462gyE5eTgUyKsBaLo4gZomfzx2nDqQcJZ6
4329	payment	1397	1397	1678	1	1	3643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSvKmEYLNg88YvXjjzHzkA7GHrzbmTVN6xe9AsLnTT9CHuSKzp
4333	payment	1397	1397	1678	1	1	3647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56naf4jJWwGWHRZgPkcaDaUVinRaQKidT6qHoMKKuro1Dzt38
4336	payment	1397	1397	1678	1	1	3650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYtn6hyFUBYbn1XnSQ8SLrQw7SC4tHeWMNU4nV2vF47D8ZBye
4337	payment	1397	1397	1678	1	1	3651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFpLd2DGQk8VrgzUzoHiGovSjXQvUwS9HMf3vRMx25C3UUjXM
4340	payment	1397	1397	1678	1	1	3654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1siSAqAVWrmcKQeuFci82WJNRFWebF9DSkoZpoW4mSp5Fn1Zw
4341	payment	1397	1397	1678	1	1	3655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydZo6L6CmXXXNPEku44HnBmd4WTSpnePyy5eDDDZxprtZDvQW
4344	payment	1397	1397	1678	1	1	3658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbtipgScvAxW3C3PFbTZAoS6CWxpsvGQYs4dCGvyBx979eU15
4347	payment	1397	1397	1678	1	1	3661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5kEWSKwJscuKQYk3dGQFiuriN3jSksWmnZeWn9hXduP7GMCQ
4348	payment	1397	1397	1678	1	1	3662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hYtb98ZMRbZ1xUCgwnEaVTMb1Uwa3AgU875AwvemNiADq3Kf
4357	payment	1397	1397	1678	1	1	3670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMkNd9ciw6zoYAfBVzfZRg5btg4fbrDQw4NeoQxMc5cMPQ3Z9
4361	payment	1397	1397	1678	1	1	3674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU22GxyKcpaYJStharXngEwbKXtijvPvCd8SfdYmkVayriow2E
4364	payment	1397	1397	1678	1	1	3677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5Jt7PPiDbuNgHSNFeU6gcgW4EzGoMXKMJaTuiMMXBgJosFAY
4368	payment	1397	1397	1678	1	1	3681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxMjWBwHQRyhBwiohuG6FVsFtxTRudgFjGWRpGvbHsu4i2tHz
4375	payment	1397	1397	1678	1	1	3688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpstA7qYT5er8bCG2gBD49FmpXt2NBwwoYzex5rQPif7KbTZtv
4380	payment	1397	1397	1678	1	1	3693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs87sA2U1yLGeMt65MotxxxKy444FvLdb97LUC5xoTTV1uAMhB
4386	payment	1397	1397	1678	1	1	3699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4kLNK9KSVN7g26b1GfCaR2vBD7fqgvdiGi6eC7EST3mWv9BBF
4387	payment	1397	1397	1678	1	1	3700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NMBXL9pqmjMRAB7dk2T6TH4KhSciJmSU4sQprHncjRJ7Rb21
4391	payment	1397	1397	1678	1	1	3704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbSGHEXBEfVPfs2vdBbL4i2qwPaTJCXWmANcZLv5Evmqhc8fWN
4397	payment	1840	1840	1639	1	1	0	100000000	1000000	\N	E4Ypt5Zhf6VAojcJk16GVuepGUk75zNQyCJvyTz3Rj9LCfj4Sh6id	CkpZNjKYvmbaa1mYZZiKDCKdhyrtzzkjdLE5ducGq64aCxpn46JWV
4399	payment	1841	1841	1639	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMsEhoG9fZS2H5KecLswF46BeatJq4edTXqxH6CKow4CVxbFF
4400	payment	1840	1840	1841	1	1	1	890000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcGnkrGv9agviDRBtwpfk4NRYD1m7hxrR2po1wbnhMkeCHeS6
4401	payment	1840	1840	1841	1	1	2	7000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDCQWkjdBe9a5CWjN6BSjwdv45dkGRdiMnrcKkXFNr8SVLLpXn
4412	payment	1726	1726	1844	1	1	72	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYurS1pfBYaJwz7La1PrDYk6DPddQrzGggUfpgar2gug4rxKmyR
4416	payment	1682	1682	1850	1	1	4	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMVMYeRYEDU476kbbq2MM5c1pRk1PKuwtU239hc2xWKcfxaJh
4422	delegation	1843	1843	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEqCDiYX5u2pYJYJUG8WQH2qCECY99qRmYvbiVHyyYi2bBwTi
4423	payment	1397	1397	1678	1	1	3710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfciUdosTb9Cpj7n2Up1458a3t7FGi7a4929yj2U5gGs9MiL7y
4425	payment	1397	1397	1678	1	1	3712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHqAHaPiViEzRmb36CzX3tgucguqXdzKvGpjkJHP6LBaBvsuL
4426	payment	1397	1397	1678	1	1	3713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwEE9Qib8Tv9tMNgTArXHti95YcUBUi2nJRYXijMV6VAaBpA2
4438	payment	1397	1397	1678	1	1	3725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnNoi7QPayhzHKqruinoDVXwCWwBxKwB4kcZYjsmHYA24ii8b
4439	payment	1397	1397	1678	1	1	3726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBasS1eFukQNUUWVTPGtXW564R3Fr4t7bBRbdzKAEf8W1oCQe
4441	payment	1397	1397	1678	1	1	3728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoYmRXUjKH9rtgQ1Eru39gowPPcQr8qrPbgX9KN9M64XbuB91
4442	payment	1397	1397	1678	1	1	3729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgbBT1rVC96uLK3qk3nHfHK9VqY3tLUtYys5RCfKjoYHBsSu9
4402	payment	1639	1639	1841	1	1	2	716217000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81NjxKRUBj4GNFmqKxJCMGpBqNoqL5gMHNf4Fq4keJ1yUMVqs
4404	payment	1726	1726	1843	1	1	65	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZsvPq1kWwCmAzTUDhcjHmnRFkG5FoLAeKUPSWKTVbhqF7DBH2E
4405	payment	1726	1726	1844	1	1	66	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJcXPv4RWLSJW4xXaRFm5zG8AfKx7kBwDtdwmiqzaRzz3jsiV8
4406	payment	1726	1726	1845	1	1	67	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJox6NgkMZydM68cHqmVW479GojGYuWKdzWPNtUJ8XhXUCR84u
4407	payment	1726	1726	1846	1	1	68	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZBEMnXdsXXKbtVREotc3K6GKaGcke76W3NAKET6QvGDrrH8bRP
4408	payment	1726	1726	1847	1	1	69	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoKLASSWYo6tzoLQeYe2ogb8mkFudATo6cHL4UNPVQWwUYEJJv
4409	payment	1726	1726	1848	1	1	70	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZowetyuQTSTP32BJH1eoBLsyTv9x3DfQsVDx5XgVSGii6f21vk
4410	payment	1726	1726	1849	1	1	71	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXdz4yg9N4qQigtimcWxqQjRCTsTh5z7jZqtbVBNTKFBfYwdaU
4427	payment	1397	1397	1678	1	1	3714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHzTozo5kcp4Q7oJAXHLMKhnQLvcv3cU5a2rqijdU1TmofXK3
4430	payment	1397	1397	1678	1	1	3717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRU2erRBj8wnBHWZTG3hK21xQVCbQAS5ZLc7h9DzmnkC5VorQ
4431	payment	1397	1397	1678	1	1	3718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaW6eLd7iY71Y8h4UPyDYqw6yWGhpjEB4JEQgiMRkh768XqA94
4433	payment	1397	1397	1678	1	1	3720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BgerNbDjJUAcg66cF6Fa3rPuGijRzzy4NLBr4bF5QtJ61AHT
4434	payment	1397	1397	1678	1	1	3721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCvG769b34nxcukFou9baoRJC383HHypUvXV5BfHjZAEohLRp4
4435	payment	1397	1397	1678	1	1	3722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjE6sz3kvgpcm99duUkfQEsUjeD7FKRVZNqmSRnV7HYyxgywE
4453	payment	1397	1397	1678	1	1	3740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU66D1R4VHwqAkhN6MWYFMqY3bU3Ue76Wu5Qpwax5t6Awpm7rE
4454	payment	1397	1397	1678	1	1	3741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB11xfz2fbe4ydCabLX1cUM1DH6eqfmPqxrNGk5XMYuDPDjWit
4461	payment	1397	1397	1678	1	1	3748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9HC6V8aFgEZYLKTfwfPvof3PjiUA686NffP1HnY8oTPFpHw5
4462	payment	1397	1397	1678	1	1	3749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6xv16pg4YzTYj5VLyDwrdBRhehxrFDezqBppHyQjmxFj8c2p4
4466	payment	1397	1397	1678	1	1	3753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFaBBdAHYxVu9GSbgmTDn7JGrZugcz2oanw6Jm9fH49Geu6P9
4483	payment	1397	1397	1678	1	1	3768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKjKRd8wHCXFbHNdbCcyVUZchEZSYsj6Ly4AoYWomJ9CxTGJgs
4489	payment	1397	1397	1678	1	1	3774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6miAv6wMAptBQtDfLBePzUuVspdSFUqzSfd9SMTsVEsTQ5nGH
4490	payment	1397	1397	1678	1	1	3775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjedVRjrZujwg45RJu5YbkBR1J1DsamxwqUQ67aGXsBrh9kTjd
4491	payment	1397	1397	1678	1	1	3776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9kJys6DWVetENbvwJNV334HeSJD9g28vkPiSwKXAyny1owXE
4499	payment	1397	1397	1678	1	1	3784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XWzpbT2JP8hZ2je6tev337dEye9RteF9cimmX6TkxujTPTjL
4503	payment	1397	1397	1678	1	1	3788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBVkFf4H2yrVaKak6yuNxLZ3a4RvLUgX5BRdpJVLnCwky2Kdr
4517	payment	1397	1397	1678	1	1	3800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgnHKwtwq2XVn1kkA3R3GjibAoni271zCDjwaMh1TVM7XGitP
4523	payment	1397	1397	1678	1	1	3806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDmnuVzuUH4K6VQLcJJUDTP6eyhR44pBG1MzfKDLKtnxTPiv4
4524	payment	1397	1397	1678	1	1	3807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgeAc324fA9XUYDioDjdRapNzZuERqZ2noc7Qahv3KiGeo7c6
4527	payment	1397	1397	1678	1	1	3810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PVvRL6Rr7teaCgEL7cEdnGWG4v8PP7XuihoJajNEdwu8ipzo
4528	payment	1397	1397	1678	1	1	3811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7GExWHrjdxL92mpd1vJBx3uX85hVLyc32223zKW8dzBeifWJ
4529	payment	1397	1397	1678	1	1	3812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8TfKVsTt3vVc8jDkCSqLSVaaGMRydMTgBDJxG1WLEaugXGTG
4532	payment	1397	1397	1678	1	1	3815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb56RixxueRM2sVy3Mnxug8ydmTMhEu9A9c9wWpqZXU2WtipgH
4539	payment	1397	1397	1678	1	1	3822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWAHy3aqLxWKZ9cmgRZen5XXxsUZggsPcpwbRRhfX2NUwtWgm
4540	payment	1397	1397	1678	1	1	3823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveBJAXznhfGHZKjYjA2xfQEXc95c789Q58pL4C3YYrxf4WNJH
4541	payment	1397	1397	1678	1	1	3824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnW6EaZPz1QH7qdG1KGDAqDtHTgHupkPHiJiuyH8sxBdHS3fTR
4542	payment	1726	1726	1856	1	1	78	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZPfVXnfrKymkoPbJP8LDFGK9xSpWTLwWnPDadeb2UG8uhkTFZ8
4543	payment	1726	1726	1857	1	1	79	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYx5zyk6sVqrNU44mbVEJq119LehNN1rXskFLGzNNvTotKhKmiX
4544	payment	1726	1726	1858	1	1	80	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmcinNqWeF594WxFL2ZTU43tKc52MNCBsjsn46pifzUju5R42P
4432	payment	1397	1397	1678	1	1	3719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUgSaQoPSzN8YXLhApTEXsskudiVCQMrsjmiU4PxDQb7WASVn
4437	payment	1397	1397	1678	1	1	3724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPUUTpJu5C6P3xvW7YDkinGWRdXUngNG81RJVpCYutdBqNcYx
4443	payment	1397	1397	1678	1	1	3730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8oUvDFfk4cAPn3Sk84SD8z45mUqjBpwBMH2GE8K3phn2bQouV
4444	payment	1397	1397	1678	1	1	3731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfdFWsNMK3bJ2Xi9uY4a3BSRQtpzapBUzZDCRnwpGTnnJ8BZU
4445	payment	1397	1397	1678	1	1	3732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6PFo3cALEEoQbveKwvKdDpsBqYsa5yxe7BQ7qPET1H4WALYf
4457	payment	1397	1397	1678	1	1	3744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8KtX18U5YqYFSSQhGsKHJ5hjtBFBd37dRT1jUVCeVXa1awjJ
4458	payment	1397	1397	1678	1	1	3745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxpZ4UkWxs818UJbeDcJTD9z4AxSEM6j38USfw3RKMD6zT5Ld
4459	payment	1397	1397	1678	1	1	3746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVUWn4Eizjr4KqSUVn34mV2C9KCxEHoJ6nw7bR2fVvvrzx4qQ
4460	payment	1397	1397	1678	1	1	3747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRP3QraXFbBQ2rEArKBkAb8zTuCS5Mg77u3rKHEsELY5NVRrxY
4464	payment	1397	1397	1678	1	1	3751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBfHpmdehvLGQaLbuMUCJc82jQbu9GTV3ZPCHsVVM36KJ4fdb
4465	payment	1397	1397	1678	1	1	3752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEX5H7RFx9NWmffzo88ENWMC5ECKh2D2Yt4NYLajxB6ZXGu6p
4475	payment	1397	1397	1678	1	1	3760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHxhep2JJoMY8qvbecsc8dbXbYN3VMb3wdxaW1d8udCMXcNDr
4479	payment	1397	1397	1678	1	1	3764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc7e9YN9VcR9Z8RAijBJajkQat7ZioJLYKX68gDicaL14697SF
4480	payment	1397	1397	1678	1	1	3765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMuWWX9zrTembJPRvqirzwmAKGCa5AETbwsY3HzyDq6JVht6b
4484	payment	1397	1397	1678	1	1	3769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhBJVSmNtsHbs9KY8thCb1FEqUiQwAMoyacEQLRhV27fm9RhP
4488	payment	1397	1397	1678	1	1	3773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM48fQrZKLqgHukzexsav1M5uruGazLdpxoHci4Ag1HUD9RzT
4495	payment	1397	1397	1678	1	1	3780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHT4UdW3KgQaB3LGyCBhq5zusD2trh526TTEeedMQrqmbVdwU6
4496	payment	1397	1397	1678	1	1	3781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofX4xr3ocTuWZYYSGggnaNEdwtMy2Y1WDLQkeYC8dfrW4YyoJ
4497	payment	1397	1397	1678	1	1	3782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tZLBQbQXNSH23JPrEM5utKfLjJDzFcePecHhgXxc6oKYid1L
4500	payment	1397	1397	1678	1	1	3785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQ15hQq1mykC4Qd5Xw1NzNX339abHk1zyADrH96DQbxtom3op
4511	payment	1397	1397	1678	1	1	3794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4pcRoNJhfYVT1RyQeGZYNpc1ZBcYjf2qr58NTsoK8rj7TjR6
4512	payment	1397	1397	1678	1	1	3795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECLVswQ7XgkTStDRziqHkyaHsZMpvoXmJFCJm47JT7A1oKLoj
4513	payment	1397	1397	1678	1	1	3796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjw55arwXHHnDBzeS36w2jVPDruMKSsqnEiDonSVsdabZEjLD
4514	payment	1397	1397	1678	1	1	3797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qY8oGQNsm2L7S4FDAV5kk9nepoNMYUE2biCwFHsdXFn8FeDi
4515	payment	1397	1397	1678	1	1	3798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSJVuRfiAaVv9p6ax2wFFT246R3kGxHEATDj1ZCQuVGpoyWtY
4522	payment	1397	1397	1678	1	1	3805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8mKSyxXKaLYDjqV63WitRtbF4seSJFNfHjc9ecDtxoPxsrwW
4530	payment	1397	1397	1678	1	1	3813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdnE4vsZrYvGrozj8hPx6ujvmYofu5GLqxqiPp4vFN17dBrWq
4531	payment	1397	1397	1678	1	1	3814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAQDVZYjyrzqRt5SeUcsvGEZjzNCGoQXMseh4MTVCZ3rJSNfU
4538	payment	1397	1397	1678	1	1	3821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUi39WNRrQDF2XevsNkMPqZwG9YeC3EHdgHc2ScXt5xN9BbfKH
4556	payment	1397	1397	1678	1	1	3836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtW8RVnC7m971jahgr8aUnHYXQARNaU6KsgzrdrGmGPr5Q6sB
4440	payment	1397	1397	1678	1	1	3727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbjd2LMGnLwZkDGTqkN81f4q4Ho7MdL7QkfEHrU53VDcfGTtS
4446	payment	1397	1397	1678	1	1	3733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZoV8QLDSGMovsbaofz6XFJ1ciThaSDF8Hj9tpLMpV8knT4eZ
4447	payment	1397	1397	1678	1	1	3734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwrtZySEVSfS92K8ZPi6jZfQeVCKWfvnTiw3NvH4t2sQaqLaF
4448	payment	1397	1397	1678	1	1	3735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qUQAQ1b1sBk49aoRn66THPAxBqMASvZZh9NQU52yzjaAo8rs
4452	payment	1397	1397	1678	1	1	3739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfjyy1FXpr7ycptHpv2hTsPjCCgt8H6A5rciedMqaDHPSarF1
4455	payment	1397	1397	1678	1	1	3742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5b7zFqDhTgVJSFRUDZMYH4FjdNmjsRF7pnntk8CvVmaxt8vs
4456	payment	1397	1397	1678	1	1	3743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZKk55jZ5gdfeQqsE7MZKVbvgSuWHARqb1BqyaiyesXdLyzLm
4467	payment	1397	1397	1678	1	1	3754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CCj9kzWUva8uS8Trwp723WqccyKWYcmg87aopuExj2FbzTLV
4468	payment	1397	1397	1678	1	1	3755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdmg8rn6JuwHRtTGt6YBbgdqnk63VEXGKSZUZUkZAn1VowW3H
4476	payment	1397	1397	1678	1	1	3761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEA4Y5fqbBMS1uixCf6McLx29dESVeXbvPTtW62ChRDtRG9pER
4477	payment	1397	1397	1678	1	1	3762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaLUSetU8fbo44E4fACPpLgfb72HvQtQFGLt5pRUAHBF9t6Wa
4492	payment	1397	1397	1678	1	1	3777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54w7okpM1WSrektkNZ3iG3ogm68GpdWZQme2ocDAo5Vvw2SKb
4504	payment	1397	1397	1678	1	1	3789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtySCFiUhJfg4Kcws2EmGCsBdRLtU2oSevzPUu4s8EAxuKPbs
4505	payment	1397	1397	1678	1	1	3790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAhGk6BUpjDS8phFijXhg6kKKdQaX8jUnRyzgbVoXJUFogqu1
4507	payment	1726	1726	1854	1	1	76	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZado5iYmWKJEoJSVGgustP3aByKKVwK6z2SijedZK6svZASMRi
4508	payment	1726	1726	1855	1	1	77	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxGywmwPdJmyg5oksQPrLqDjAwYGS43QyqpQzaoNaF1TrvvPn9
4509	payment	1397	1397	1678	1	1	3792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcb7krbybrFeF3gtCP8nBTzdpSXrYqnaHeeVfTie4hz1hy2TcJ
4510	payment	1397	1397	1678	1	1	3793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwKKYbCcsCZdZY8XrjSVpZ9NKYpqz7rFyMf1qvZKwLCV7i5Yt
4518	payment	1397	1397	1678	1	1	3801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkMcykpt13U3dTiKLuBRqH56YWWPVkchfzFxDFnZEcRD2eSjh
4519	payment	1397	1397	1678	1	1	3802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZKn1AGAbMhkv3FZYA3CZRc3wj3HgMvjh1SoQrfsA6QyVBujy
4533	payment	1397	1397	1678	1	1	3816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoquJS2CrQup35Df9ALanpPKKNwAwSdubw6DgfLgfBScp8BD1t
4534	payment	1397	1397	1678	1	1	3817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MmqQR3rthZAgoyQCCaRoAxkMBoYRyACURLY1auB1Muqpfk9B
4551	payment	1397	1397	1678	1	1	3831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQeWbSWf3QzM5KP6xsMAASL1caznJv1RdheygKPmNnrNeUttZ
4552	payment	1397	1397	1678	1	1	3832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpmK9aRgeqcMWQQNvPDxFYCqSLB65nsG2hpsYbnWsBXYfXW7M
4553	payment	1397	1397	1678	1	1	3833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRERF5xmQhqjZpgvQTpvsok8EKdqe9aoMRBqUr1GWVLWHYomU
4554	payment	1397	1397	1678	1	1	3834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHFW5osw9S8kUWixEDCjADC4M8auAb2zd1QZPApkJ4mpt15uH
4555	payment	1397	1397	1678	1	1	3835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4s4JypotFB9TY4DjF6zTHHFd2wUDJRiSpwd83mfAFX3jn1khV
4449	payment	1397	1397	1678	1	1	3736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1zbvcK7ZYvpBJmvhxkkAaL1msNLT15z2AuJCCqqvRLHUzJjH
4450	payment	1397	1397	1678	1	1	3737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUheVsSt7ZyeDj9C4MvU5ezwxB1999tq4gzpzfqEnKQMveNTy9
4451	payment	1397	1397	1678	1	1	3738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNqqP79oeRdRkuQvNE2VtArNj1hikhLKe9k2UYa1UwYjTAfoE
4463	payment	1397	1397	1678	1	1	3750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsL8ibBFhdZXurnDexx9uCRecffC9aGnccP82YyuthtiAonYLY
4469	payment	1397	1397	1678	1	1	3756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQBijMZmGAv93B5xM6mdNwfviN2NayFrjCy5bm5Tc6fVKDgEG
4470	payment	1397	1397	1678	1	1	3757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmB7vHf596RoT8XKGjRmQLb1o2CJm4Bkeew59GjU51P9Rw7h3X
4471	payment	1726	1726	1852	1	1	74	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ3efXHumpr6VDmiEV6hgv2KgWVPpPVmfvWHZa4eR5XkyzF4GYj
4472	payment	1726	1726	1853	1	1	75	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6XEff5WXEmGp9AabgnktcUWBNyM7aNEqYFYehL7sFvmJzZTiC
4473	payment	1397	1397	1678	1	1	3758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyKzWqTcg7dsTNZfVDhJTmvenvsp71VJvJghk4ZRCShrHFpFa
4474	payment	1397	1397	1678	1	1	3759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6ftLcMycsCC5CJdwUAEQwRmLVjQiaCu8cb8L32aq324DuADK
4478	payment	1397	1397	1678	1	1	3763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5SS3M7xeG9MmfNUDJh2nNb2CCY3woPshCpZXXzyigKEyo54a
4481	payment	1397	1397	1678	1	1	3766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXUsaSW9sbRnC4XpiRskU2zAWuyRLWxThtrQrFE1fdFfc75Vb2
4482	payment	1397	1397	1678	1	1	3767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVaaX9ZpmNHrHGFk1CtVyhXGxGYWFnGZYp9rFdnjhknnkwif7
4485	payment	1397	1397	1678	1	1	3770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieDK9eQRoJEjBtQKqS115bM7xApdbkbWp4sA4sqbpfyboSYbQ
4486	payment	1397	1397	1678	1	1	3771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAA1pDoueQLRF1LSJDGJWUPGu5C1ribRC7US43ex1oPk5YisAz
4487	payment	1397	1397	1678	1	1	3772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRCftyvLFPXWFy16ZwjQQL2wRDj48uhsjQDXhLgQknRGJArbn
4493	payment	1397	1397	1678	1	1	3778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZz1nHe2Pr8M77sVuLM83NfkDcktnzkfhzYv1AQsx1YXK6mUH1
4494	payment	1397	1397	1678	1	1	3779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxudarmARp9TMcjtkRjgXi6U91WsaiG23byvD95UkBqktmSLg
4498	payment	1397	1397	1678	1	1	3783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqmLS6sVTAatGdHmE5iChXFodpCQ7nKsYeGVHaNrjwPGHHfwr
4501	payment	1397	1397	1678	1	1	3786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMg64gEzQmADBdHFkR6ddjjLSetLiB6DR7Aq2CRwmXqnaGVYAJ
4502	payment	1397	1397	1678	1	1	3787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb31uxBZig2HZf9H1EDpiwKy2Zc1ynT5X184j6MoKoWgS7ZTLZ
4506	payment	1397	1397	1678	1	1	3791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEi9DUpeFL6urpXgfbUiXcTK6mzQckRJfwygW7BRKzGCrSEBsu
4516	payment	1397	1397	1678	1	1	3799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJq6FkYcZXYkDmd5AEryVXPF4ZdU2pJes5JqH1Z47jvU45xrQ
4520	payment	1397	1397	1678	1	1	3803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgmiwge4sGwTVkgduWGFoLfeEoZ75SoS9GAtP5pF9De9yfGAf
4521	payment	1397	1397	1678	1	1	3804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYL7W5t2A5bmvmC8APYsHtgS1984CKoTbAFsQxNH13kyg3YYD
4525	payment	1397	1397	1678	1	1	3808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkHk2yHDg2YR3aFZHb2gioxEFdd3nnSDLN1TT3s42fuTBmuco
4526	payment	1397	1397	1678	1	1	3809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs29wwH9F7uUKi9QLQbR2cZcuGaxRvmzY46Bpv7vASedkdAYUD
4535	payment	1397	1397	1678	1	1	3818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKzeiMWn379SUYUvamc5jTqnZhtfUmKiyyCAVatoinvPBcEAi
4536	payment	1397	1397	1678	1	1	3819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1emr4k9wNisRQ5odNoeqR3dZWfNid8xygHuN5ai1SEWTwLXm
4537	payment	1397	1397	1678	1	1	3820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKh5vjPE8bGv9BDEVJ1UbMZENTJYEQXBRXQevPqq8AfVn18thT
4545	payment	1397	1397	1678	1	1	3825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaZbpNcpuGY1ry8mMuH3zt85aE4ZoeDHsuGxT6n8QvBT8fgkP
4546	payment	1397	1397	1678	1	1	3826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5zwgksQob2zhwbhWKAoVMjrT7H9PN2121gwMwmQF1YWGkN11T
4547	payment	1397	1397	1678	1	1	3827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVRD7wAxSM73oLgHwkC9oxbs7uzTmRWv4NsN7z9LXJhxGC8RT
4548	payment	1397	1397	1678	1	1	3828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8FTtSLbHDiP1xZfo9Ys9BL2H8zKCd8m61BKf21NWEJxqLofX
4549	payment	1397	1397	1678	1	1	3829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRN1DRcyCDwhR8uQEtb8NUhY8NXfRYNVq2fHLrV3iduU6cSq6S
4550	payment	1397	1397	1678	1	1	3830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHs8VnSnt5T7CDacH3zKWdxg2kmveHK6gR2mHxuz3JCLsXNgh
4557	payment	1397	1397	1678	1	1	3837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiUbXo15zBFEet9HSKiThbAQgfh3cPqpF6uNZQu3vRZJRwt82
4558	payment	1397	1397	1678	1	1	3838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LtZPTtgUYe4UPX2BdZeGNjwRARbZ7j8icjo7i5nkrrZ7UGsC
4559	payment	1397	1397	1678	1	1	3839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4Q9NF9rTqFgSNc2BLWEeRg7kZ2Cftvitfjyu4xXGkUUHZ9w9
4560	payment	1397	1397	1678	1	1	3840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWwKpLciBLuoKH5TFm7UhsbQsVUpCGHPxe3AHfTnDWGfoXB7m
4561	payment	1397	1397	1678	1	1	3841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHksHhB1zCotYFcUtmQk31k4DV8qz99epdKrY6D3yat7UPauV
4562	payment	1397	1397	1678	1	1	3842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYUygS6i3jfJrk5PsRRae9r5LASFZstUz2q6ijREBxKEvyAQ7
4563	payment	1397	1397	1678	1	1	3843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pjd5YRctLEsyPSVSagBdQEiXFjoCPwNAthqhqBJM5CE14bDf
4564	payment	1397	1397	1678	1	1	3844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Erp3uvbigtaaRFLbAEnRxRwX5W7qSnghQrjySAnGQgk4Fqja
4565	payment	1397	1397	1678	1	1	3845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPTnae4ssM2jq11DskZDSZ1XAQnTAutHvovDKf5rnDpMbdgrH
4566	payment	1397	1397	1678	1	1	3846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPSknj7hzuPmqZ3ua4N1TyukRSSTozez88vNDtT9TxZ8sDgAR
4567	payment	1397	1397	1678	1	1	3847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2nf1WHbuJ9Rgq8KGS2oqQa2MVuk2dFCgC9BBQzCRsxjLTc7B
4568	payment	1397	1397	1678	1	1	3848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeyYgmU3bo16p3sVQr6nfPRbLD2cmRxQqoMKRCsVJ9Ch6CNoV
4569	payment	1397	1397	1678	1	1	3849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH8GEGnF4QhdKoDbWhvYw7RcirMtr1yhbfUQghb81vEwipjPa2
4570	payment	1397	1397	1678	1	1	3850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8dhFo1GpNYVCqmPX3S4dCdUgNgrAZx9J7dAqZWGqrXVjEbQh
4571	payment	1397	1397	1678	1	1	3851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNAWpAxjgwyu3dncx2aUqB8982pejrLues4oXZ3kHQkMP3tdX
4572	payment	1397	1397	1678	1	1	3852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jiFAPdyMjKZMtS5cJpoMPEYQEcQi5UFbT9VG3PehMZRCtA6J
4573	payment	1397	1397	1678	1	1	3853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEMofbASXiPf64d6qPw2FzX7mHgsXfyHXj6JrJS8ojfVYwX97
4574	payment	1397	1397	1678	1	1	3854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUVetqjGQUv229FH7KdVxkyjtxsoFbFdF1sMb3LRpkF8zHwdP
4575	payment	1397	1397	1678	1	1	3855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVpBsejHzASSVpd4eNQBAuARefSRGtrNsQeNiJW37GF87crBxu
4576	payment	1397	1397	1678	1	1	3856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6RK5Q3BnjzZ1u4JRo5YwsYkZNZLepsmzKpFCBfZjxnBoEV9d
4577	payment	1397	1397	1678	1	1	3857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnokFM1tWLBEebpiLecsrVDMMrxDQJAAu6CqxDsPiKdz76vwM
4578	payment	1397	1397	1678	1	1	3858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy44Ld7mwZf5KoJeLTmrXWR1WvwfTcA7CBfcyssoCb3D8Ngpg9
4579	payment	1397	1397	1678	1	1	3859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zoi3gFsACoDfRszc8aVreuaM53GbC6ZdRQS7CXX3uNcCUWbM
4580	payment	1397	1397	1678	1	1	3860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCP2ASS3bau7wg3z98qQkdWDhDv56htoaWVbU2DVLwMVJYR6JD
4581	payment	1397	1397	1678	1	1	3861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYosmxYAQhFz59iKqdKvKrEuSDocXJQgvSZjg5Tg7A5yxUm32jr
4582	payment	1397	1397	1678	1	1	3862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbeqf365c65E1QztAn4XhmM3XqBXfEn9d8UdnS95WeoMqefroz
4583	payment	1397	1397	1678	1	1	3863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuuxp3jsB2GJYtvvTgdvZbR67RzGznJ7y4WKHwfC5yRUU3aco
4584	payment	1397	1397	1678	1	1	3864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZauF5My2WneBKjQcofE51nit35xR3f1B7vFdtbaBbqxviNGenZ
4585	payment	1397	1397	1678	1	1	3865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvps4VosTGU16vczmTFA1uNPGc1w8Dw1Qd71XAqz68hEUngdeg
4586	payment	1397	1397	1678	1	1	3866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBs2HYk7SPH9W9BxxRzjqVbf41aokKv7LAbrsoHMWCyhmJCxo
4587	payment	1397	1397	1678	1	1	3867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfc5LN2Y3obzPvCXkqZ65MFu7LtnxPZs7bNqED7D5xSbPYsYwQ
4588	payment	1397	1397	1678	1	1	3868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAb2aDQ3YGQHFPntw8jA9tphDjEkZ18zDBFA3ccV3kHcvBgfpQ
4589	payment	1397	1397	1678	1	1	3869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6SNpQEmuvzdGDxfSX48XCtjhrPqg6tajLtfsWzYMZY3fpngV
4590	payment	1397	1397	1678	1	1	3870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDu965gGYJgcrXGoakwwCyXfoVoeFr5UTP7iLP6q19FkurHQ2J
4591	payment	1397	1397	1678	1	1	3871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2fQzQBSbTXiJiUCszuTmg9zcZgGJdk3JkzTaDQrKzYw49U3x
4592	payment	1397	1397	1678	1	1	3872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpbRAfT6XntwAPZmF1A2TwBCMBhGVfQhUrLAb2rDKQjpD9oPz
4593	payment	1397	1397	1678	1	1	3873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANtE7UWiC4W1cAeLPu6yfqs4WtRnWFoaXpr9PqxoyTxq1PUxe
4594	payment	1397	1397	1678	1	1	3874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisnfKJ2ZjsJP29buQk6YK3YVoiZP3NwHJUGzTTLz1yXSuhrvd
4595	payment	1397	1397	1678	1	1	3875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4EKBgte8YQg3eSif7awTG9iBk8VKPFtzPboucYcmJ4r4oBYq
4607	payment	1397	1397	1678	1	1	3884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYJNVkR4r1xXyNuYkhF5JDb4muMfYkX6rEnhWowuZepicgHFx
4609	payment	1397	1397	1678	1	1	3886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaUPoJscUKQNeYiqAxfQNmoEq72mb9zcZFDAYabaushHcKq4B
4610	payment	1397	1397	1678	1	1	3887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDRJkN7d5qr3wtYaH9LeCoK4heAg9EphBsdxudNhHrpdsMGbr
4613	payment	1397	1397	1678	1	1	3890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwzqpQ5xb5HQswe541t5Az4xWq2s3AVXoz2uwD5yqR6XAW8pm
4614	payment	1397	1397	1678	1	1	3891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCswi7vqnnm6tX6UU1C72ou46nDFMPVXpiij97cZ4LNy4BrMS
4615	payment	1397	1397	1678	1	1	3892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVYLW32GC9D2sJw1SV3AyTZR38TUW4JqWgPXQ7my3CSDwQqW5
4619	payment	1397	1397	1678	1	1	3896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDobnsJ94H6adzpvX3qvMcd5b54X9oGvB2ZEJWa1w8jbgBSXj
4625	payment	1397	1397	1678	1	1	3902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgURrgbKQap3Evm9YdVCoVLNxG1ToMTtf9ohnpj37oRoKQp69i
4628	payment	1397	1397	1678	1	1	3905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aei97MZZosyhJYuHVEchEVyo7RHFwhFmr1p7N87oxXYhQ7g3
4636	payment	1397	1397	1678	1	1	3913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT5LmpBYu9iN6JW3gnwovzt3q9QaE4dKn2wvMLJAqLdc4xM4Hg
4643	payment	1397	1397	1678	1	1	3918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZocrqpQY5a8GDXmaMeTfPGFsAuGV16YuR222jNvngoKba3Dr
4646	payment	1397	1397	1678	1	1	3921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxi3x8AMUJP4Fdjrsq65hXynfVS62sySAB1F8kc5XTyHNReXuy
4655	payment	1397	1397	1678	1	1	3929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCU3dQLnqxN1VKyAWqxKhSh4GuSG4pJaVzGQj1oNE6s16GbMFY
4656	payment	1397	1397	1678	1	1	3930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvYbr9WSWSZ3Zk94yEX2hJYHMcEVfWzRGc5eZLBRgozG9mF21
4657	payment	1397	1397	1678	1	1	3931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoywY9JyBLxVhqFyx5TUdtFMZcZDPkaVwB4x7btcyyieD6gD6
4658	payment	1397	1397	1678	1	1	3932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBb2BS66FsCvFgajbEkRbx335WvwyBY51uGL2b4bd1m8ySdZoH
4659	payment	1397	1397	1678	1	1	3933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqD3vB4LtQeRs2G1UB2iPuPyy1Yy7wiFzZmYjXtS9ZH2F7hzWF
4660	payment	1397	1397	1678	1	1	3934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEARZeN2g5JNevh8BQaLTffzNwcX6xWUaiHbLc3J7iQh2d676y
4661	payment	1692	1692	1860	1	1	1	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Bhw28V1Pr2VfV7zkGWkftRckWGxnHcoo9ETkgyhK49i1kZrj
4663	payment	1397	1397	1678	1	1	3936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHSGE1J8gnFu3Lg8ehoRzVmRiMro5RhybAnUexq2y6Pm8Bp7L
4664	payment	1397	1397	1678	1	1	3937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNGxnV9xCRb9kKPwX2nGHC3Qdr7PTtDb9o2darScfQM95y83j
4665	payment	1397	1397	1678	1	1	3938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxTQAFFFkwrXodqm257DWBaFCppuKyyMK18r4UwgGAKfbcdiH
4670	payment	1397	1397	1678	1	1	3941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEXJ7P9aEEMgRqgx3c6uPunMp2bEB3cWJ6dZgtpAEt5GY4z55
4671	payment	1860	1860	1862	1	1	0	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodnkzRDwNw3xmJ54gnZM7vGGs8mucuiVcPjs42e1N2SfrcHVg
4672	payment	1397	1397	1678	1	1	3942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9up1PD2NrtL5AcfwmVCex1FDpZG4G54YqEgFi9V1kqEkPt8YU
4673	payment	1861	1861	1665	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfkdbmwCNBCnya2ytWoRt1ZVP3jN5aaNCbt2QgvRK91vs2WPv
4677	payment	1692	1692	1860	1	1	3	43800000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7i3THihvmRhVNnNaRmy3B5p4YdjZAyDv1ePD9G1nU1x6DY17
4678	payment	1397	1397	1678	1	1	3945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76m9J6VucdnxccxgRqfzhnJLnajnwfLQ6Y84TRMBBYEWj1z2Z
4684	payment	1397	1397	1678	1	1	3950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwh74oRxmpU8EQnuEa7t7SqWwdecJG9caKKtRFQWaWfLyyr93f
4692	payment	1397	1397	1678	1	1	3958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWa4XSjyYr95cMLa9rFj3KsP4Ch8DzGboNVpc1b5sJisx3GZq
4695	payment	1397	1397	1678	1	1	3961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS5GUUjud5RwJwAHWyGGXhPgm6c8UiZ6QoeLM1423DyzHmSef
4696	payment	1397	1397	1678	1	1	3962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSfsrfrEW1F5ranKyCCr7H5zDb88cqnhcrKSfbwhdYEmNxvUu
4702	payment	1397	1397	1678	1	1	3968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppu9D3KkGzwD2k1G6Vn2Y9iXhXVWTXnNsJV3uf8U9UK4iFUsG
4703	payment	1397	1397	1678	1	1	3969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJp9uGntxRnyrm9ZxyMZ5AGsWerNCS72ec7U8JDj9j2B9BgPPu
4707	payment	1397	1397	1678	1	1	3973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1TkCvoDByread8rd43Xb9tvHwu3C9NWaAqe65vNq1jUk5mPN
4708	payment	1397	1397	1678	1	1	3974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYe5hJfDGHSoPbHQAu5d8eboVJv2GUsr3zjRYvt1zYsPqC1Au
4596	payment	1397	1397	1678	1	1	3876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAsTmRzQWN6LzDY96t5zUB52SEmgoxK1Eebc6tQ15oeMadU3c
4598	payment	1397	1397	1678	1	1	3878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rkBRi8qY5ighmkkiwzckEf7jsavoR92oEKPn2RJwaWSKXu5x
4599	payment	1397	1397	1678	1	1	3879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXotTrmUJh6FyL523bA72CLzum1qeVfGTfYHAYfjJJF45wqpr
4606	payment	1397	1397	1678	1	1	3883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HpqnmbAnrWGohENn5XZefDd1KNHwRCvnrQsL8V7acfvaTK2f
4618	payment	1397	1397	1678	1	1	3895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1VzQVhzbyxhMUgaLHedojE9EuRxMGH873shhAM8NsrcwNQ7a
4622	payment	1397	1397	1678	1	1	3899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqks8ybmSgwr3PhxVkcmczrzws9ytRCiN6L4g8aLwt8NyAC5m6
4629	payment	1397	1397	1678	1	1	3906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUBCUnGgwWBQwThNn7i6TH4XcE1oj9zwZHH5MyP6GcFnvrCbj
4630	payment	1397	1397	1678	1	1	3907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxJw3WNsNe9iiPivv4cXuaFfkhfAkVrKj2ajgpFh19UFb9sru
4631	payment	1397	1397	1678	1	1	3908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8JjuQ7m8fB6tjYhY5xBVPViRe5NAtrFX9Qq9XyvoCrhAVSoa
4632	payment	1397	1397	1678	1	1	3909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91vQGeUJXAzV3Nec5botxDvm77uXsX4kgzN6DW7Z8LnpKR2st
4633	payment	1397	1397	1678	1	1	3910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLHyPrxjUJLDxaEwRnWodojZbebs1mP2EbhnpdQBXZfjtFGjE
4634	payment	1397	1397	1678	1	1	3911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiHtw1HWoZAqWPLPdwbxFL66x9wcr2GE3h5eGVMnRo12PDKFF
4635	payment	1397	1397	1678	1	1	3912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNGdnGvTFGxFitDSGouRwPKKRcHfgtkqN5ome3xsaAZWw86aP
4637	payment	1397	1397	1678	1	1	3914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJmxct4HN1SBKKkzr21oPoX5aKLp6cF6FhtYiJbG5iUktViCB
4638	payment	1665	1665	1859	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pa7g5Kcmc3aHa836TAegq2Xm5qpChVagSnL8HUbgwh1vZPHw
4639	payment	1665	1665	1859	1	1	1	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZcYLkJxgtF6wZRghCYFvFzRofeCgYAmbrFtW6t95mzp2GXEb
4640	payment	1397	1397	1678	1	1	3915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofxKs6dLsSF3tmpbXVDdphyVKB1Vwy6RTbMHkrhsXT9vgMj4q
4641	payment	1397	1397	1678	1	1	3916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yxXxc4P9gWBtsVrEjp6rWUfYBoBEJLrVTU9b1Pyw4e3QUfU6
4648	payment	1397	1397	1678	1	1	3923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjMmd3LehaDaedVSG9pvKN99Lpm1y6dyU5ATi1ufinb6fXSuq
4662	payment	1397	1397	1678	1	1	3935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWqPTBkPikHFYzXXssc48s7Zp6MxSowpseiYpjFRSpBxptJiE
4666	payment	1692	1692	1860	1	1	2	100010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvPHYxWErRNrupbCd35Ej8JtFdcK8t1LVr4VknVk7X7NRrEo6
4667	payment	1397	1397	1678	1	1	3939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeTm8NXNTgBVqxySKVawzZy4puZPGSm89fVozGK7kV2KAhYo6
4668	payment	1665	1665	1861	1	1	2	2010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirxS7LyrNcu56iGkstocqWXpCdNXfR8kmpSFp7bdDUJqW2zj4
4674	payment	1397	1397	1678	1	1	3943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLM51P1HheCXATqfViMtKr4zz4YDfRVF6JtQh19NuBPJnud5uD
4680	delegation	1861	1861	1665	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5ZVcfTQBUpaopMTHMKuUQXL5jcyjCzc8Q4xHUiU8oHFnCji1
4681	payment	1397	1397	1678	1	1	3947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2U7r672LKHGGLn6xHgw4UUo3NAXc2KDDQeiaHG2q7ietszAF
4685	payment	1397	1397	1678	1	1	3951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzUByvFKeu91znnLfSKB8cnu1esWdxjxaNN5RPpxqny9vUPLQ
4688	payment	1397	1397	1678	1	1	3954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoff1SXqjzvXQbkRkmJ2u3q1kLPWi4QVyZoCm9qQd4bSb6cG9n
4689	payment	1397	1397	1678	1	1	3955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunswBYik4MdgaqtzcnxCeKRoXSiTtJKE53jrCvCZjsKzdYtBN
4697	payment	1397	1397	1678	1	1	3963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHYTdMhYvwiCWqSd6fdLo9cwHfkyXBqkN41kznw66xfxSMzdR
4698	payment	1397	1397	1678	1	1	3964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JwrSZX3UBhHfw7rb8KVKgPcJew4JwJyp4BtHdBtLnAnHsq7i
4699	payment	1397	1397	1678	1	1	3965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZL2fBCsv9TsJmn1BtsVjbPy97xJLSBTvZBZb31zQFWSEqfoQ
4700	payment	1397	1397	1678	1	1	3966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpLFcBHUBPGvf6eiQ674JBqyjWVoKueGTFbZPE6DPWrJtEWmP
4701	payment	1397	1397	1678	1	1	3967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CwkXEJyPjB7ZYLsAnxhdsMSh4Zmk9HZfYQQ3VMEPLiYW5xpb
4712	payment	1397	1397	1678	1	1	3978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFxkD8P8Daih5a8WBkhen4dpZShcZ8LSsXbLBVPabeerpU72Z
4713	payment	1397	1397	1678	1	1	3979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhv8opL6yBbFCrKMK4VT3RGrBHF5HrNt42ujW9z4YH2at2kQw
4724	payment	1397	1397	1678	1	1	3990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP3NSobfEvQB2Pz98UfxfsEnhn8MsW9oDTt7sJ8mgNFNtyMdkN
4725	payment	1397	1397	1678	1	1	3991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rpQjc1FLFBdSFDFpMcxmq6Zp2VnkSmgAK4PoMt4BWhh6PiPx
4597	payment	1397	1397	1678	1	1	3877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8LnZS5mrxyK7GEfyh1WRhb5GfXGpsJ4HvGYH5ndspncCsEMX
4600	payment	1397	1397	1678	1	1	3880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKoRSvD7bjNKf2yzDprLfznRtQD9fbmKemnpBNaeQrrsR3ooy
4601	payment	1397	1397	1678	1	1	3881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqsLananHvVjKLKmSgzzKZZj1MfdpNpFNE1CeR8uymK7PKZJ6
4602	payment	877	877	1772	1	1	1	211000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEz9d4RXwCKNstsf1teaEhTV6ba4t4oFPuufesnFok71RCg3DV
4603	payment	127	127	1772	1	1	0	152000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYcDdD6PQQeWHK5H1HTwBcc1LHYFeLPsJtyYMzhJ6bRd7ggvJ
4604	payment	878	878	1772	1	1	1	211000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx6FLaVxPGhydWyCdNfM4ftipPGBCBkxxr48AJoaddiTM1u8s
4608	payment	1397	1397	1678	1	1	3885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UXyytk5QzvJr5gV5Afqx3bjMHqqzNVoR7XhynKTbwaPeg9MK
4611	payment	1397	1397	1678	1	1	3888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDufGuLdjtEJqRR93xR5dFZPT1thWffka15rPeaw3xjvVgEn8B
4612	payment	1397	1397	1678	1	1	3889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCskqFguy3V1bTvxGrRmUXwUAHQiQ4jVsQmAiKWNs5Btm2eUT
4620	payment	1397	1397	1678	1	1	3897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYnty9LpksEVXMjtXM5zdee8pGvoLWHzqjkWRq4BJdZ5irsgk
4621	payment	1397	1397	1678	1	1	3898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoy9zv5bRvyQEHPBiPcbhzi2VERkXXYJKuTXtgcBqKhWoqEfD
4623	payment	1397	1397	1678	1	1	3900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4p79EMjjL2qGgyPJfrT4AEX977UQUkcXyKqPGMZ5Z4VfNP2wb
4624	payment	1397	1397	1678	1	1	3901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAYYeX1tbd7QVKPdb5BWtznDTYVQZwaYXmpKyXZVRuLh2QKTR
4642	payment	1397	1397	1678	1	1	3917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28mcUAuRRXxMS1k9ncs4UpQk5ig1zhHToFkZKK8m1MANfR9BZ
4647	payment	1397	1397	1678	1	1	3922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkJSzCyVeoqZeudgeGUXghoWwxXeyiBbPnFnSBxDuKFewXygQ
4650	payment	1397	1397	1678	1	1	3925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZBjsAVMNtEtqwQNneP7FBpqyzTv9bSCorcCPUYsKvxUK2f4L
4651	payment	1397	1397	1678	1	1	3926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFeCzJ7HTQFySyiwtaSVNCqDHUiyZLXJMwSbMY1Hvw4HpVQCG
4679	payment	1397	1397	1678	1	1	3946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggJq9Ep1s13BiGe1QmPMQ4Csb4QAWjnefG3csd2NZbZRjHFX1
4682	payment	1397	1397	1678	1	1	3948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91fHyecsgEsGgJcSkkajVXtFh49MxoQVbSsC24kxDTgaC2QH4
4683	payment	1397	1397	1678	1	1	3949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmA3Snn7AB7fKDuacUsdrvggBefZfiTtjD3RjR1JnJA2MEAoc
4687	payment	1397	1397	1678	1	1	3953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTZ9si9qYupGuexZhAk9HzSatdftMqqhhpYsiRJuDKM5RoCsk
4691	payment	1397	1397	1678	1	1	3957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZooEa6qC278sDs7fNdka6EsubhARnmG5WUkDfbRhFCQu6yqRhy
4704	payment	1397	1397	1678	1	1	3970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqzu1GJcvbVoWAESPhAZqG3VHPFqvow3VB2uev1Nnqgj5TX1G
4711	payment	1397	1397	1678	1	1	3977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPMunEgLuPTvqQFgoopTfKfQUw4j7dmxgTtfVBqkRqiBWyXks
4726	payment	42	42	1863	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8SMfBbuUKaSquevb4FNoVeowt66bAo2UwmY8xtBH2woCcjm7
4727	payment	1596	1596	1864	1	1	0	111000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYia949d3qRSPAdViBJnMMqHznv6ZjnQUVFXEzR6KfW4fcX5JJD
4728	payment	1397	1397	1678	1	1	3992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CdK5C26rR46bHYNVNRJNaX5BGvXmDSFD1LD3YCwMS4uNM87P
4729	payment	1397	1397	1678	1	1	3993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrEPHx7pRpCejoiWM33sfAAByBbiW1LbbMryayhyjTdQtFug4
4736	payment	1397	1397	1678	1	1	4000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2zDuZNZw6GrcqReakKzZWQWk6hnoBH3eTqFm2GbwMvKec16vB
4746	payment	1397	1397	1678	1	1	4009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcdHHbLbWZUHE17v76Hs4n6PKFusqX7WhY9dRCEt83ZGVMC7z
4749	payment	1397	1397	1678	1	1	4012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZR9URpsJKSHFyZSmYGbQiVFaYw6EBrTQAvn4q9U4n7X7BsCx
4750	payment	1397	1397	1678	1	1	4013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9x7dd7atxuNKRdVqdFGG6s2T2ouQKCiAFKL7f979L3Hh4pbG
4753	payment	1397	1397	1678	1	1	4016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCEkDrhjsX8BqosKfiC1ivqePJh6sqQjvuEvA1rMLPYv8it2H
4754	payment	1397	1397	1678	1	1	4017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnPE4HeSQAuwhHNrykh5qXdtmctrvT3o78jfjdjWe97Nuryaj
4757	payment	1397	1397	1678	1	1	4020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUxNfN64eTdQ6TqSBAo3MSLpv19oPXtntuT3X6moPZg7TAqJX
4762	payment	1397	1397	1678	1	1	4025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxU67KnjyFeY2CsvrsEaAhXH69zdzj7Xv6kkFGvT99ygjHxnp
4791	payment	1397	1397	1678	1	1	4049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZay9qfE8hUPy6AP9zaiGQWxrWduW54qo4P64YRdrj5WspzJZJC
4802	payment	1397	1397	1678	1	1	4052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbazTx5pFkK71EfV34JooSJmRXWmNiYxQp3nPtxYHAJ5PGBNRE
4605	payment	1397	1397	1678	1	1	3882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNmpUFtYs661hKHc6RLgjdteHrdr2QefcomsMqo3z8DAg6NK5
4616	payment	1397	1397	1678	1	1	3893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzqVNe3ZLi6QTckmmkzjmq1CiJyKCMNqHTwQovpBhD8Jnnazw
4617	payment	1397	1397	1678	1	1	3894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEt79APVJfrBiXc9YPsw826fBBT65pcTYhN1vmJwGfBGANPr67
4626	payment	1397	1397	1678	1	1	3903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXrEZHfzHmV7EmAyaJLoTAmeVewGsqLk2A3XgFjfHE83fGNcy
4627	payment	1397	1397	1678	1	1	3904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmEFjFV2gPX4WSyzWaWddTHrE8umUsKHNHiQdX8oPAUyborwzj
4644	payment	1397	1397	1678	1	1	3919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6h7LiEbvzjAEwNb5rm65fbPcwYpZmHunp7eb4Yh9qCNsRAsXk
4645	payment	1397	1397	1678	1	1	3920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt3n4FFeoZsgCc9UAtDXQkfNQ9HAtywR1J21P22YKWPpMfsWR
4649	payment	1397	1397	1678	1	1	3924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUredpDgbP6YY1R3dxYAveAC7ygWH3cAu1dnDPcxpXvJLWJtEE
4652	payment	1692	1692	1860	1	1	0	223000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTbeo2L3Vb6JpKux9SQPvK3wCktZ9YHh3EQiCn4TKbabp3Lw3
4653	payment	1397	1397	1678	1	1	3927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvr6rP3qXh9pP1jsTWUiRNwNgQ1RUQgg6LsUPUJPN4boETPtY
4654	payment	1397	1397	1678	1	1	3928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR8QURo5Cwzxk15CaXGDacxHshC3hgv6v9MhafgMK6bU8tHqva
4669	payment	1397	1397	1678	1	1	3940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6gSe3Go1yxB4EyR37ZpjsuczGEdN46T78bMzpDrPRXQtXkgN
4675	payment	1665	1665	1861	1	1	3	718000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktygXqc6kVsk4X1QXgNnuqZ6HCmVAfhyMW9Lu4fRVJ5ESUPKG
4676	payment	1397	1397	1678	1	1	3944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuj3bbobs6VKF5xM4q4dNUsYBNeo7egKkBpqgMfV69MyNhquUN
4686	payment	1397	1397	1678	1	1	3952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6DkYYQZU6p3iKjVHkZPZTKHJSfVyLgvmvnU4pRqb9bAanQRm
4690	payment	1397	1397	1678	1	1	3956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTQ2jzaVmTiXbiRfzyCQ4TznMZFfoiYuA9BZEVRebJp4moEM8
4693	payment	1397	1397	1678	1	1	3959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9bn43Wg6PMDJdTz5LcSkTvDAPaZ7RukVGwLM8jGHxBGtghv9
4694	payment	1397	1397	1678	1	1	3960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnsHJrA1QJLy1nuMuUTLpXm7ey4znRm972mHvkxSqhTy51twe4
4705	payment	1397	1397	1678	1	1	3971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGThzPWhUYRCWuMFPkbqSKmP8AqJUTkgF4uJofUEpckVcT3Df
4706	payment	1397	1397	1678	1	1	3972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHU7pANYvuZ8gLFtd3DdqnS3gCZcjWrvANQXrTqkECiUDk2vHW
4709	payment	1397	1397	1678	1	1	3975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrh1TZDqjjeqitXum45SvLEcybfKpuo6rZY6pWpwscrGmiAYNJ
4710	payment	1397	1397	1678	1	1	3976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dKBfszjEngVpY2ju7KycnvniQ41kFbMZH2SBotpxwy2yMmif
4714	payment	1397	1397	1678	1	1	3980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbavdzYBJACacX1GLYxcgfuoLzJFBVCogzRSpb5MMAX2g31Ynv
4715	payment	1397	1397	1678	1	1	3981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUgEU3qaDZybWDWDM6EAHryeEXWU8iYyWhz7vfmhodBAhTCtU
4716	payment	1397	1397	1678	1	1	3982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3DfiVt5bs2g6uYPwJsKnSoEsF7XfkkfgCQvfSHQd51hWjiZe
4720	payment	1397	1397	1678	1	1	3986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDo4QcUCW5Xao7zrP7FMmvtNVnWLoHq36vJbPSqTWnrxdz1Er
4721	payment	1397	1397	1678	1	1	3987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKA2AYaro3YYG7tqhxeWSXMg9q2Vnk6eadEWEsvUCVZMTQbVx
4730	payment	1397	1397	1678	1	1	3994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhdBwKoYDmouTqyVmFyuXYhZ2oWYNYXeNv8MSzPTjGPcWkvoWh
4744	payment	1397	1397	1678	1	1	4007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJaKSejPGTnRADidL6mGRQ8cZ28cXJbnoxkG3ATWv1qQNAyhx
4745	payment	1397	1397	1678	1	1	4008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fMEdpje6A7yHmBFbbxkC1iemVu2zqsXntSj9UjN5XZbKZJR9
4747	payment	1397	1397	1678	1	1	4010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzewBLjTK1eaaEuSv81eevoMZqQyA39SRApVyE4nKqabZDHC4s
4755	payment	1397	1397	1678	1	1	4018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYam9DYuzje8zau24fL58vZ2RQycoyaT9H4mJYp9eDjyDYgEM6D
4756	payment	1397	1397	1678	1	1	4019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uxGimpo9Hnnbc28hGsUSyquqhhyDK6PiJkeMAAQYtBpPzWp4
4758	payment	1397	1397	1678	1	1	4021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8aT1j89qxxAXBvR7fSkiZZPjQhtBJrBcYgRV7YPsP5vw6ySs
4759	payment	1397	1397	1678	1	1	4022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMmT55hUyG6SsqjkgQUx98iz4rSXkMEFCQN62zFfGA6AFfEPL
4760	payment	1397	1397	1678	1	1	4023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWWHPSkUzhd5ia1CmbFpc6z8UHnNq59kiZZc8oqz4K9qakWfx
4763	payment	1397	1397	1678	1	1	4026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriKpNN3CWjuPQMTwPmCZJwNSdy8HRoqYSVZNsaBhgtSTQhWcg
4764	payment	1397	1397	1678	1	1	4027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFa8nrRWdxPcUu4gaZ8rtiWwk5JikmAuBrVnEh4CTveAtscXi
4717	payment	1397	1397	1678	1	1	3983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeRdag7ktCtcibAd5ZLPzoTXdFasA55zA6FWREs7GoPqcj9GR
4718	payment	1397	1397	1678	1	1	3984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GEZC2pL3iuXaSYRsXRzZGK4SfjurVraVQhpt75MwWfrZFucv
4719	payment	1397	1397	1678	1	1	3985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpafGeptLLaGFVe6LsYX3UpvC84feSxVmeQnQAVNnk65iCeGor
4722	payment	1397	1397	1678	1	1	3988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASErgMzpwPTPbMU6CnnVhXUd6Pt8GLtHzzr2Ajdf98G1TA6J2
4723	payment	1397	1397	1678	1	1	3989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCg1xfxma5QrXrxR4av6gG2gSi1DoLDoQcZofGTqc2W2xW94Qw
4732	payment	1397	1397	1678	1	1	3996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDha1rzSPj2D4ZpUNjdkZBfrZkpC33uGU6n6S8MZA16pfZFqZ
4733	payment	1397	1397	1678	1	1	3997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9uoyRQxxG4gAWiGDWeG25UQXHCa6mbHXyUo6qXVhDsbig4gA
4734	payment	1397	1397	1678	1	1	3998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EXcZVMwioiRXKHGMdDSQqvBeMsHH9z7XShJ84QZYQpfv9Gha
4735	payment	1397	1397	1678	1	1	3999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHCGLFEYLhFoVKjacj2U3nWix4BUAHwHYdYdS9StMw3pz1Z5n
4737	payment	1397	1397	1678	1	1	4001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qTaJfRfgTaLfuKrvUs6KNuEFnFML6cu2ucLPfXG1Z4kWakCK
4740	payment	1397	1397	1678	1	1	4003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrhRZjYkm2nUDwW3Q2eUUznkVusTArJmqtPRPNKJ6y7fdRGLa
4741	payment	1397	1397	1678	1	1	4004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy91VVu8SZ4iSzkU6JYoQAG8iNJjsfyqdfbvCfLTkC5c8VoSjr
4742	payment	1397	1397	1678	1	1	4005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hm3xFMdpgby9ZipPywaNWwuAJVftPjRPZBRszo7Y1mxRVH7f
4775	payment	1397	1397	1678	1	1	4038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLByzcfbRAf2xKkqG2wayNkMtb5hybXP6eboPEJRdDK5Fj9nL1
4778	payment	1687	1687	1866	1	1	1	10000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZD2DHxReMojnF24n5QgUhSKFhvBeCNArM1kfKDMseDFZHnPex
4779	payment	42	42	1863	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRy6KuQ9p3XgCAWfg4REJ4BNszKnhppZPVDtvs5kPq4Ep2bpmV
4780	payment	1397	1397	1678	1	1	4041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3VyieWX7SQ5NozDPRgBpZeYWXSmVop3V6nJQ2LbzHF1VYd3y
4781	payment	1397	1397	1678	1	1	4042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83GZpbbRL6cSu12cowYFtLt4xdAC4ZAdyoRWJnaDC8fsJVEPk
4787	payment	1687	1687	1866	1	1	3	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfV3CAGD1nxxFb3aHiooGi8LQbw6asYA1b3jmkzH8rA8E7FUrn
4788	payment	1397	1397	1678	1	1	4046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVVnXXV4yQ9F43pmupd1UPZnDgra2Nurt3e5VMmBykvj8K3A4
4789	payment	1397	1397	1678	1	1	4047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kEYWinSM3Y7uEXpf2iZoG3q91JeSxfxjxYh4JTJhMw5XkFAW
4792	payment	1866	1866	481	1	1	0	156469944195	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZvsnMze9US8WR2vPqcTamgmDgPz39CSaXcTtxyPUF3KU2BrbNW
4793	payment	1866	1866	734	1	1	1	4741513431	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZCm7nUtnnmwkPMdzdmNWsuUUktkmkmdx3267A2cQHCLsUpmdtk
4794	payment	1866	1866	845	1	1	2	1359233858364	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYaiqBPhRNaz6QC7mesQyY7jYf4wAdkZ7R4LNsYLQapPrAuQged
4795	payment	1866	1866	846	1	1	3	1359233858364	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYe9A2ZXbHMd8XyqdAtYvtaEXCS3erWior2hwRQvuBJ4uFtAfRR
4796	payment	1866	1866	936	1	1	4	1258093169406	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZirY7tviZWN7ZSTVHghyLDPec57FwnbDhh4np7PqdmhVWqSvDn
4797	payment	1866	1866	1056	1	1	5	2254492180224	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZrmPYq6PhztmuNz7JSazKFei5E5qraTzkpYfSPBefxLdrBHTEy
4798	payment	1866	1866	1176	1	1	6	1521150797934	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZ6RZLgfonfHR2S7YE3ywjjVvVjpmtDPRfTzZGKSaRPX2Guhw2x
4799	payment	1866	1866	1302	1	1	7	4238821951632	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYUQtrJHQskpHrSHRoMSdTvT2ZWgPvbAkcdtnoQWNQ8orUAJtxx
4800	payment	1397	1397	1678	1	1	4050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZ5kBXffeYZRb1gSBjRiU4vbSvHY5vd89oR3H2tCdSBwLKGWa
4801	payment	1397	1397	1678	1	1	4051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DcjSa3JePtJQGcQSQv9L49NyGGgQcFEycuAtTKcw18KoNk8G
4803	payment	1397	1397	1678	1	1	4053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZy1kgLxHVPKUVjTioh28mZEVviYxYzXh2Y3ujDJ4aPqiA42br
4804	payment	1397	1397	1678	1	1	4054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyqiLqmfbKB2FD5FuM4Z6Kcr9KbzHd26cErus89EtEEpNQDGU
4807	delegation	42	42	1863	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aH3vdDpnngRj8xbKWSZE6ifxSh2CPEHBw59QcAZFF1QhMrNe
4808	payment	1397	1397	1678	1	1	4057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVxG48mf1spA4KEGN913qTpDornjFrG8waDbenqpj7UH6aBo3
4809	payment	1397	1397	1678	1	1	4058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAySN1R4ZjQQ7ni6a9X6ZjniGDzS7L13o7qGpJc4e1FbHfDuQ
4810	payment	1397	1397	1678	1	1	4059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU7UFUoUMBR6VyFmbBK1ygqYhUmPKDJrHPr7Ur7ym2ZQ4zeyiP
4820	payment	1397	1397	1678	1	1	4066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa773dfpJWVDUwyxBq3hKV85McVb87r4W81qEBMWWPRsipuHsBH
4731	payment	1397	1397	1678	1	1	3995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXvHY23FaZX44LvQkkC67zVfcnmku1no1reN1egSfXgo8Ke8v
4738	payment	1726	1726	1865	1	1	81	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZGRiTMkNaoWH39hzziMo9oeLAA1YQCbpoCmhbaWGEJZuTavhhB
4739	payment	1397	1397	1678	1	1	4002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVKm4uzfUwTb9wMaNdurCCXD8bKNikjtxUknGwT814pq9XXxV
4743	payment	1397	1397	1678	1	1	4006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucLtidzKp8SSHYCWKqpzMbDAiqLBd5vqn3kRZsNxB46imbZUq
4748	payment	1397	1397	1678	1	1	4011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfeWaJ4kSNNXpWmydr7UdWRThNfm7Ko3fC1J7BNDqH3pVrgYK
4751	payment	1397	1397	1678	1	1	4014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UyKQ5kEYNtwNPZ5tjv4fiFFDrkseNspz75od11XsAjTzDSAY
4752	payment	1397	1397	1678	1	1	4015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEJ2NEEb63TNks5fmiCetgSG7zGHx4C18d1zctKE8kQYdxu8n
4761	payment	1397	1397	1678	1	1	4024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6e2KdAnvxBxpQp3mexdsmHM8D85tcyV5n3aUZSduyD8LGbhz
4769	payment	1397	1397	1678	1	1	4032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CE7n1iDmnA31st6wrKwSDta8ECFoJeHH7Gfjy8QSomjXB6Yg
4770	payment	1397	1397	1678	1	1	4033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSVKtEpg3EkrASJCZXY7VB8PHsb4Sz1jL4HL9wdgo92o81QVU
4771	payment	1397	1397	1678	1	1	4034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcHEL5X9TBVbpVDLTUH2QhHBsqGG3BxtLx4z95QzaubzpjRwM
4772	payment	1397	1397	1678	1	1	4035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmkTZ3XhCnYPPXEpEiFcbhgG2hhj4ppeCZtMXDYNGBXjqasNX
4773	payment	1397	1397	1678	1	1	4036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4D9x5xmUL6RKdiMpyC58FBed5y49xgbA6jDvMzPrqNT9DYeVM
4774	payment	1397	1397	1678	1	1	4037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdUToUSc4G21MS8nH8jm2huQNVHhgZyJBeB2iCvdYTqAoqG43
4776	payment	1397	1397	1678	1	1	4039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLEqyR5s9EDeAmnaB9opMUm5ZAUKZVYPPzWn22s5kHhhdzF8p
4777	payment	1397	1397	1678	1	1	4040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQjoJG3fKqPMGE4ppadTWcLrxYhdazMHnooX22zp8LjVrgfWC
4783	delegation	1844	1844	1483	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3HjTtJwdikQmqq6sz9ct2Nx6GuFreuSakETvG9fBNCGGT53y
4784	payment	1687	1687	1866	1	1	2	12143037273550	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFXG6YxzwNeVjU4JhrkvjeiaWsebgtN3KQwYSezuciiJhnAxS
4785	payment	1397	1397	1678	1	1	4044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrXM4pYZcXGU87SLdGc1PJYzyZbMNCMzk9r61WN1dvMR6mSCF
4786	payment	1397	1397	1678	1	1	4045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2XnWJwZRCCQx7BUzqhcCNRAsuuEHNXQBc2s8ZYgRw5MdR3cH
4790	payment	1397	1397	1678	1	1	4048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrCJyqZSy1kwXNPmvu3VTreA1g2YcXuahrVbNvP4qPXHDup5p
4811	payment	1397	1397	1678	1	1	4060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1DcVv5VPw75FGjtwJBxDWQ59vkPzmRkv226jtozffGiCebnm
4822	payment	1397	1397	1678	1	1	4068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJRTqvhAWrsBHzs85kkukVRn2hmtJm3H1iyzSR4FYEGX3NjQ8
4839	payment	1397	1397	1678	1	1	4085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynQrWTTrih7BcZVG7QB2ceMzW6YeP8hyS8dNBoM9g4ES4dVej
4847	payment	1397	1397	1678	1	1	4092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9sC7svzR9knA3mSp5nwqXLYsQzxgqXUZ2aC31kSBpuyLfyx1
4850	payment	1868	1868	724	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwTm2s9V7fcbLUr3PvUq2uj8M2GXMEqziugAukXc4CUQWZonr
4851	payment	1397	1397	1678	1	1	4094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMDQQojmXDueHQyHu5yrvv8HyQuBUQzdP54vmM23KhToHz17D
4852	payment	1397	1397	1678	1	1	4095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRvjRg74iTRTH3AZ9rZVCS3KdjQNeXsvgJ4TVe53yfNEyy99cd
4853	payment	1397	1397	1678	1	1	4096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9r1pmxRoZ8H9xHoX3cMyAKvEiz9aMVoiE9oRJBpGNA9KGprp2
4866	payment	1397	1397	1678	1	1	4109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfc55cXxje4F3dwXRB8PbyXm6dUEMpP1i98Yh5gJiKLZigvUcY
4867	payment	1397	1397	1678	1	1	4110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgNRgrqdR4jXMUWYN6Bb7fLX65DySc61yRUM2pDfa63b4iNaw
4868	payment	1397	1397	1678	1	1	4111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtype54JMXS87VoGFWkwdimXH91zJAtmRt45CcQRH9UrzR2HZ
4869	payment	1397	1397	1678	1	1	4112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvungDLUTU46gh6WqkJKeWSqYY6WRQU3vztzce8JLBnsMzbTz9
4870	payment	1397	1397	1678	1	1	4113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yEHKVzGF7c5CJXu9dD7oZKhmjzBoCxXptzUHdCHikMGgpHAd
4871	payment	1397	1397	1678	1	1	4114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgweM8sEJGCKskRpAZvbCcy93i86PnaueT3HoRbDUg4q1vjSRJ
4872	payment	1397	1397	1678	1	1	4115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjSsNqGpKn7xPpZKsU799rFHj13kHRUTQVPJdzP57VtvTBJSM
4873	payment	1397	1397	1678	1	1	4116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW6Ha8BRACDgoUu3iokPrDrqCZRj6V5pYvyUma9N9fuciFuju
4881	payment	1397	1397	1678	1	1	4124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCY7fEsWg6iavU75DnNGnueu65HuQsRBNZs3cbyN2uNy3tPjp1
4765	payment	1397	1397	1678	1	1	4028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzr26FigrG8H3hucXjG7m7SobUCzNVWRBTMFwvp1qf2Ww6PcH
4766	payment	1397	1397	1678	1	1	4029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePg1pEbwJZE6x1BUgV5JxMDMbdFi4jdSbVjJF5f5imyCkqPBJ
4767	payment	1397	1397	1678	1	1	4030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMCKquByLrnGU1ZjJaghhbZnrDGDfe9SwUn3P9uZkeCa4PaaL
4768	payment	1397	1397	1678	1	1	4031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gbb6uTknSPL25MWM3koGcaAWC87JioR1D99t6GuMK7M21LA2
4782	payment	1397	1397	1678	1	1	4043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizEN1yJVd1pLKW3cnPr7ELyTyj1ok64EWGj5nnMgmoHnaocBp
4805	payment	1397	1397	1678	1	1	4055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW4og2PsBpHxnDbeUsyVkFFw984QSDxWUvBQwDzBu6bDfRD6x
4815	payment	1397	1397	1678	1	1	4062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXoHTkKqqRgpzZBG3yiQ8qXSq1rRKWjEbdLaAbKeozuPXnFX2
4829	payment	1397	1397	1678	1	1	4075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzhCg8xpcUYoGkX9i8TQTpdzA1UQgkAdZ296txRax2kviwBhM
4856	payment	1397	1397	1678	1	1	4099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzDWNRwRCMX15HtLUCfwC2UV1X2Xoga5HjLpj3jnfKjhDAsfxF
4857	payment	1397	1397	1678	1	1	4100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL44FB38xsPo2d1QknaaZ83GBAbDpdiuyss6s1RQR2Gym6XMLE
4858	payment	1397	1397	1678	1	1	4101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPbpQ6TsrLptZXuRceo1QzjARcb1esb167Tcbey9TwcTamuc7
4860	payment	1397	1397	1678	1	1	4103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEmz7P3xE6MGtBqKGm81Rvmwe2HhU5GpLvScvbXC61obvTXYQ
4863	payment	1397	1397	1678	1	1	4106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJAneV5AgJfCRNGtuWUbMwxmzKDCzjFk9N9iMAAQ3cdrZjjh6
4876	payment	1397	1397	1678	1	1	4119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX67cf6PS9p3isPgz2V37mqZ7JDGvLeFGcKDMLDdyWe7PsPw2M
4880	payment	1397	1397	1678	1	1	4123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpRg9GK8unYTT6T3W5SjRqMXwAE8TKzjbap35dxCTtWRZBrr9J
4883	payment	1397	1397	1678	1	1	4126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZ45PmuBWexkjHVhh9C6YWNDetKT7JymNfQuvqB9tU83hdpve
4890	payment	1726	1726	1869	1	1	83	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiraGzMhQXz7iTrYj23FpNMKJX3Woz2a8TNuxcpqJuSNc64gLr
4891	payment	1726	1726	1870	1	1	84	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8CEfhC3duSf8USjHm7nGGPfmZM3QHYXa9zjaWsiXZ1jtGT5Lc
4892	payment	1397	1397	1678	1	1	4133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8A9gRJLBnKqg8a5Hri15D4gVaYGBbuRvN3k6TtN1r4TBgBrF
4893	payment	1397	1397	1678	1	1	4134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtVnndQc4Cc3HmcvF5UMsmgPZuaGTYUghHB9CnQVaq1o22avh
4894	payment	1397	1397	1678	1	1	4135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWm9qR7iFK8Js6PHUXptxFLE5qQKuiLKqoHkE2c6h3yp8bwLrN
4896	payment	1397	1397	1678	1	1	4137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXLjBxNFsmXmSE4ZSrHtXVKKnoeuiSkEh5TxEUbZbDH7MdtRx
4897	payment	1397	1397	1678	1	1	4138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa71L6s3JNYDG2gv88nBW38i5amyZGBjhCjriGinF1TBPBxZ8aK
4899	payment	1397	1397	1678	1	1	4140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKjDXGw3C4kgLvDUSZmF7TWaXH3CNbcBSrKgm9NQGfJwqHMmX
4900	payment	1397	1397	1678	1	1	4141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpKmnnJKCEZagniKeS9z6VPv5yS8wMnsK7Rd4ghpvirmjJMWm
4901	payment	1397	1397	1678	1	1	4142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKN4jDq7K36Pgfn1KSB3kBDhBeSvRe11VUSgC2NhYJnspKDMi7
4902	payment	1397	1397	1678	1	1	4143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSe5SAwabt41iVp2ibDqLTazithFSPhbV7qzpT8zSdEEDNAn5U
4914	payment	1397	1397	1678	1	1	4155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdyefmEJEhMX6trwyzav5XN5Hakz5sUCBeCx854fMgBsiHJKw
4919	payment	1397	1397	1678	1	1	4160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hSj5Mq2DdeeLfV69QTooWTotn84tMSojiChmSNt3nWHceLGi
4920	payment	1397	1397	1678	1	1	4161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Z9nd485qYnrxxJGgP8XUFqLcXhJQGmdtjg5Q6Y8q3omSuDBq
4922	payment	1397	1397	1678	1	1	4163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkUibkcs6GwbQNw3zn4fLR1huheYSm3Ji9RAMcZrN2CzV8kNr
4923	payment	1397	1397	1678	1	1	4164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4HAhzrpdCF2tT7xUfZ2k4NKQ485EP2fYbJy8heUZiNqauYaf
4927	payment	1397	1397	1678	1	1	4168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqrwQxK6XBawxUXAkSUiSGfjycsGcMR4v1PfUgmP7XSWFmYNH
4928	payment	1397	1397	1678	1	1	4169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUSYiM7bQj6T7YnVH9WDbQn87QaoNYpdJd545kbZA4t3E4taP
4932	payment	1397	1397	1678	1	1	4173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywzS4EA26AsRGkuDvnwL8uXdJT6AQxqaHEdFeKHMHXA1itv3S
4935	payment	1397	1397	1678	1	1	4176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYeA7cChH5rXurJieajV5UTAQsjnCUHtgxs9zuf8e4CHPtBk6
4939	payment	1397	1397	1678	1	1	4180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7LR6nEgmYRhU5ELPA47tTzSgJnTL5X59CCisgcVHKZoDUVH9b
4948	payment	1397	1397	1678	1	1	4189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkdQRgBf1rrRXuLuw6aXYftNgSqgKT4bVt9qfsWSQqrn9Karz
4806	payment	1397	1397	1678	1	1	4056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97VarLHLh98nzRqrYRrgkixobBAz5yXwkoUTVHXcGGt8aQGnY
4812	delegation	1863	1863	42	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpUgKK7LV2iETAoyEU8psvPq4y1jfNWT2t3sXzTC6jvFvAHUj
4813	delegation	42	42	42	1	1	3	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWFbgYXyx6aLdTwJSadCXxEhHtbUvFcjaAthbo5FszVngDkV7
4814	payment	1397	1397	1678	1	1	4061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAS3KcBLXNYfdrKwQX3SWMBPgt9UcHaijkh4XCZ7yoghDCiZP
4816	payment	1726	1726	1867	1	1	82	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYaBvSq67xrn2rgB16ig1a1qjQngg63MPZAT5Qym4G96oqeHS2A
4817	payment	1397	1397	1678	1	1	4063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4jFPWxQa5AKxWa6VsdZVhqauWiwa5bAuvuEfedkckTvwDC8W
4818	payment	1397	1397	1678	1	1	4064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5SsDZnHcNoSGJDQHzyhg9eToNExwsNe4oT4FPMt797DFoPCkQ
4819	payment	1397	1397	1678	1	1	4065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvHPxkhSz7nxVTKeaUHBpAZJv9hMP2grh7wENZt9g94Znfy7N
4830	payment	1397	1397	1678	1	1	4076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vVmNmuWhhWHCicwBQV4CLqvdEkkZN6g7WbxiJjWE4bGRaozF
4831	payment	1397	1397	1678	1	1	4077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtheCqu9z5ypmwse7T4uBLjJrjiBnmEV1W2ZCEWrwuqsQfyJw8
4834	payment	1397	1397	1678	1	1	4080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFxV33amxkEAJ5tDjGZzqTZxxhaGC6pg6WffDf7MD8cqLwBwa
4838	payment	1397	1397	1678	1	1	4084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvm7eHyNL2JcWDbHDx6bGdjGR7kuFTniirmtFi2Mcpg3P6yG5
4842	payment	1397	1397	1678	1	1	4088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTozyfEhU4oYM7wnWjSGj5kozGn8Mid6kxv95zs6iw5v1STXp9
4848	payment	1397	1397	1678	1	1	4093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpVFWx2sLsBw6o98D2Jfh8UZiChuASjongoWpxh9b2qnYU3DC
4849	payment	1868	1868	498	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtx8P8ywtKxu7KZECv2af4dzSt234r9ifVd48G8rUviLY231We
4854	payment	1397	1397	1678	1	1	4097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Vpx9eVSDcyj6heqNRXj3jchheGG9ex5Gk6d9Bwz8kZydyozu
4861	payment	1397	1397	1678	1	1	4104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZernErEmmgS87QjQkDjnVzsWMBfVp2CXzfeTT6oBCdXJaybMtR
4862	payment	1397	1397	1678	1	1	4105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGabQ7yW8Zt261Xh32Qmd6pKSvc6zUssyNAWmz9w2iVUbwMUqZ
4864	payment	1397	1397	1678	1	1	4107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurThEW8vTWrgMFYNhwuPAGeAHYf77j8YBHQYmsKTB5PHHrjEp
4865	payment	1397	1397	1678	1	1	4108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqirrGSqZAWg2x78zytn2wAYC6zJr5ojNesduiiAs5ufGnPoYx
4874	payment	1397	1397	1678	1	1	4117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tWABkRb3cV9NhwRaXQaMWiRkUYacEg3A2oUAtNddkfwEKPhx
4877	payment	1397	1397	1678	1	1	4120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQFEuR85PWY1v158LZmf5oCStZR4dw9kcoiMiB2SQtppFPKvK
4878	payment	1397	1397	1678	1	1	4121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZik37QQV2q7yWppWzDkHCKVM9V8Ryz4EKKh8QcrbsZncAbFzUi
4886	payment	1397	1397	1678	1	1	4129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJijWHoeDKU22YWtfB2WSBPuxzERdq4wxchMqaxdYx51ecBjv
4895	payment	1397	1397	1678	1	1	4136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeofRt8cr31FUtRWdPQJd7FoT2LMo92yxDdp1GkTEQdWqAo3B
4904	payment	1397	1397	1678	1	1	4145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqofioPRG4e3HUa2ZKjKh4wkKyJH8G3GxwdkLAhLiBXVjn7Sx8
4912	payment	1397	1397	1678	1	1	4153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDZW6LuURWVq1mVSyCds11xvJLHAawCX869dMibm786gBFyUN
4915	payment	1397	1397	1678	1	1	4156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqq5DBdMfwrvwRU85ABKbVAPKzJZVo5CLM9yWBwGpqRGwD4kiy
4916	payment	1397	1397	1678	1	1	4157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtRV55h3PhYfLRMAsYbnr49K8qrjR5pfFU3ZDRtLeaixxz8qK
4917	payment	1397	1397	1678	1	1	4158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa71VpwoRuc5TXyjkF7N5iHSha1Z5fTebBtJ7HERzF13Xr9if6S
4924	payment	1397	1397	1678	1	1	4165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3YvrAm3XDuqEoCtMr91wkGyrCYXiTKZocKAmnk8MsMaDw4j2
4925	payment	1397	1397	1678	1	1	4166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYT5bL48x5JFCgA6BziorPLV64ubss26MaYpB9Kzcodd6DKwZB
4926	payment	1397	1397	1678	1	1	4167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwa8ppKVg854tbKtqfdF8uGN7zJbS4Gvi2YP4FkiNpVY6P8zgH
4929	payment	1397	1397	1678	1	1	4170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qBXyz43uferyEXiheNVmM9K7BJFzVUfJEzo1iwMw53DHE3hu
4937	payment	1397	1397	1678	1	1	4178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcxyYTmKxE9dXihUaZF7YbVjUoAWkF5z5G9GYAMdxWX5ggFcF
4938	payment	1397	1397	1678	1	1	4179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAB6odZrduAGrPg4yL5z34B5MYY48hzvJbw1Aqo7vgeSfzBHfE
4940	payment	1397	1397	1678	1	1	4181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6jSDQkNGipSdMvDeE6Gjf89iMZtXBZj4bfNrUR46uxEb8kn8
4941	payment	1397	1397	1678	1	1	4182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBNp5vczirVZDYNf7TwxugmLhEfrmqHsDUX72FbS1U4f6RNvH
4821	payment	1397	1397	1678	1	1	4067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpk8Kis5edmCLpakT6q7s366JN26CRMoDo1eJhJPjtWPpUWae
4823	payment	1397	1397	1678	1	1	4069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYjztybQN5pSngLAJKTYgQkoY4iiZJHgVK6PenTeXrdSVpRFq
4824	payment	1397	1397	1678	1	1	4070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3txKWn6sGzE1wXFGH4958Suz9CH35PLpMASfkkVR2SBUZ3X95
4825	payment	1397	1397	1678	1	1	4071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbD525xLWgjkBbwkmssyRXovv4GxBGhj51o8pKEjXiBkZmMUdi
4826	payment	1397	1397	1678	1	1	4072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53FGTUsucAqwQRHeJexg25se6ofRYCVGpP8KQSQ8o8kcnnunT
4827	payment	1397	1397	1678	1	1	4073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAA2HFU3vWaUgK2bvgisebcfmvJKRVaa1NTAzc8hS1qQWoEZz
4828	payment	1397	1397	1678	1	1	4074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgZkoW77MPxJW8C3vkp6wRSFFYPzqb8z88LwA4fYn44dVAbqj
4832	payment	1397	1397	1678	1	1	4078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bky5snXAznT5fwRSDDqEkNMYh3Mw9w2gmKx2Z2zuyE5YB3b1
4833	payment	1397	1397	1678	1	1	4079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfs4WF2gdCb1iA3PWTPudCxyFexciRdRaUsdgQXJCDi45BELZL
4835	payment	1397	1397	1678	1	1	4081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfTzU23MsMKnP3HKNoCXwtUdjK5vpyXiKb9dQukHYoQMG3UiU
4836	payment	1397	1397	1678	1	1	4082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNg1nMHp7X8JAMVqPc5tcV5HHQx5pKz3Z3Z9kRrGPsap6LprL
4837	payment	1397	1397	1678	1	1	4083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvtuXqoXoyH1DwruXEDBK3W42FecG4RZcFCcQUU4mB7WBSiK5F
4840	payment	1397	1397	1678	1	1	4086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWpcV2Juvs5rF8rKrL5q63JMiXm1tYn6FJqLm9CqzSViyyuvL
4841	payment	1397	1397	1678	1	1	4087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8pZxi7TChkP8y1yZDRcLxfGhW7vtgcKW4ij7iHviaygvpSGu
4843	payment	1397	1397	1678	1	1	4089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxLSVGJz13XB44wd9FBchDyq5d69WJa9RPENfb2Jsg9xd444P
4844	payment	1397	1397	1678	1	1	4090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5cyK4ZXsjhDk3iEnDBbqiekTPwkadJi5VNqKBt9ZR6gBRGz2
4845	payment	1397	1397	1678	1	1	4091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgag3H5SUV9zi6frpaMR3oXXkrPrLsKbWWJyGi8dZM4x1FTdw
4846	payment	687	687	1868	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSH2T2xWK8gwAaYXGQtgRq4G398u9t8THEmHmypUNYKxHqFBs
4855	payment	1397	1397	1678	1	1	4098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybZjifAJGMmMkkTdhjm2i1n9KrQMwxRTgPDA4LhcjwZZ8v5BV
4859	payment	1397	1397	1678	1	1	4102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQgNtxkL61iYg5hNksUPKThJyYcibe2ZCw2KQhRcS5G7WHpD4
4875	payment	1397	1397	1678	1	1	4118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9vus7ac8SpTg9q88qUhivN9S89jZ8F1CvoMyE8gkmJujg8MZ
4879	payment	1397	1397	1678	1	1	4122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikbFSuyotMTkAi3yXcRykNxG2yHLjA7C3yJCtCu7BGG2YXjoP
4884	payment	1397	1397	1678	1	1	4127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkjoxkDzYg31qwHQk57Vmv7ECSvQnPfGkLKHryVv1ULo3gshR
4887	payment	1397	1397	1678	1	1	4130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UCKAb3T2KAGKqifqniK4SihiKbfgfjYDg1wFd3GiCVtg3vV2
4888	payment	1397	1397	1678	1	1	4131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULKHC5ZBA2AhXG9P72kYjPh4ukbQZyDHjxjhjFsAaGU2mNvdu
4898	payment	1397	1397	1678	1	1	4139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmD3WLSpQM8WKevLg4keY3bBaEYw3ubgj536eJePMTif2Pwdp9
4905	payment	1397	1397	1678	1	1	4146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVoZbsMCt79JGonnYwcggsLaXC1RiojUf79y4Tswn6TiFTYnm
4906	payment	1397	1397	1678	1	1	4147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCemCHxXrJxTUhcdfLcPayNg3rSDv3PcM9VQnHpuwtUM4QbdH
4930	payment	1397	1397	1678	1	1	4171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksDrBUqu9EEXXGiKvYhG9KYj5omiFXdoa8HiYrmgw7jc3c1U2
4931	payment	1397	1397	1678	1	1	4172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6aWWr8xvQAvh7ZMkjE2quVmaSxduQx5aAgV5wDYvChNWpdki
4933	payment	1397	1397	1678	1	1	4174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QdKqYCr4gQRrgUEPweaq3FgMFawNPPA7vuJpSDWtG4qhBMs6
4934	payment	1397	1397	1678	1	1	4175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VgUbxeMLoneFopBuR3VrER2BsCr12HYiB27oM4LbdD6ubfEV
4936	payment	1397	1397	1678	1	1	4177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4suXS5coKfHmbncF45f69t5C7oXYdgmmoCZmcaJDihx8wXmHQ
4943	payment	1397	1397	1678	1	1	4184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawEU7y9mFtmcia7C7qKKWmRMbWy26wQ7V4tZjtgJwMpPXnG8S
4947	payment	1397	1397	1678	1	1	4188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2PJxA7qm4ZMQNLRwTcPWVeS6GchL5DubTacATC4Lyq7wA7Sn
4954	payment	1397	1397	1678	1	1	4193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKBQAqJ4ADsHLtiTmximqbjBVgxWxxZSk618WccqnV8EevFNR
4958	payment	1397	1397	1678	1	1	4197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirsBKxJWZ8BL4ALTm1PZSTxC1btZuJvT3KRUvN9jYq3P8JeEj
4962	payment	1397	1397	1678	1	1	4201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqUjMDd8ekA8TckkpRFKok3KxDDZFXc1PrhaxvLne2tGoybBC
4882	payment	1397	1397	1678	1	1	4125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXoLksYctSFN2rDNrm8orbXjrbT1RGSfiSTHFwSAP2eLxWsBq
4885	payment	1397	1397	1678	1	1	4128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M9sJ8FFB1B86PqYWaHjFBaVy9nc6rD2aTiguPL8pzDS2M7ui
4889	payment	1397	1397	1678	1	1	4132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSw2VwYGhRnEspCCskP8TzfibWCdGz9b4uVsgp3SQLXn6Ux3d
4903	payment	1397	1397	1678	1	1	4144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmP9NSx3mXcZ8StXgK5f6yPG6NJV3FLmvdXPitZV3Gk3gnRYnt
4907	payment	1397	1397	1678	1	1	4148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4j689yVcUu6xo4a5BAcdviEtmUC936Cy7Sa2d8jQExTycuTWL
4908	payment	1397	1397	1678	1	1	4149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoEkszL9WDpKYx8eHYTrV6RNFfLYNfdbc355sN63Zjk2yf7tt
4909	payment	1397	1397	1678	1	1	4150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuG16xcGDGavHuhjLKpwoYLU83K8a6z1zQp7DQsFC7FrE2PbDy
4910	payment	1397	1397	1678	1	1	4151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfc1TyrafcAuCnDvmeysyswwWR1K1JXvS24eU5t7u6r6tjUKr
4911	payment	1397	1397	1678	1	1	4152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJKF35DJkpV3DA1kahD4BLYWJxyhHcDs8nyFjkANNvSJLX6JQ
4913	payment	1397	1397	1678	1	1	4154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZesHjrPdyE8ndbQ3zu7jt5uLAiQpSq53Ncxf2SvxbYwuDjEBHy
4918	payment	1397	1397	1678	1	1	4159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepLwfgMY64nNypWz2zEjCC8jGBQ4JViy5g6n4kXbR7MjR49Rx
4921	payment	1397	1397	1678	1	1	4162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqNQBBUmp8ns3Hq7WuB2AprTBgTwsxevDkY5HpZAkzwxkrAMy
4944	payment	1397	1397	1678	1	1	4185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kiLKMWmo5s3r4ZtwfCqsjSMipUzsDJLqnuYkiocKzmxtD11C
4945	payment	1397	1397	1678	1	1	4186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMX2ivkkadCoUgx5xrUFmxnuiW8A1nGQ5xQ1m1rsBbUeGY77K
4946	payment	1397	1397	1678	1	1	4187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxdnf7wqEEAP8Zw8GovfLjijGqixyFvtEGjzYbXqTagF3WjEX
4949	payment	1726	1726	1872	1	1	85	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfSPNbyHwkbUkFaSV4tNs1CJKENxHBk6zdNRoH3HQ5fP3ZfPDs
4950	payment	1397	1397	1678	1	1	4190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrp4fTNac58QDZwtD6Qxf9QPEQ6Z675QttqkKA3YY7GTDVs99B
4955	payment	1397	1397	1678	1	1	4194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZz43sAPrJ2LRihTXGkRcPF64zXXZox2gJsfVVXuh9dXtPJRE
4956	payment	1397	1397	1678	1	1	4195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8nN5G3khX6AvbRPxoGMBomq348cXDPmtuZFUHzey5KUYS5xh
4965	payment	1397	1397	1678	1	1	4204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEm8YfmehaHQ1sUttP8h4nvVaRCnFiSPNUCeb5Ht3EbMoHMAti
4966	payment	1397	1397	1678	1	1	4205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEzztnJxkcwgFKBHGh975MHEMbABTXATF73zt3zfo9eebKyha
4967	payment	1397	1397	1678	1	1	4206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi56QcUMD1upcNRpENCTN27fHUn4WGGzoJofxkSRa4RGSWq1H1
4976	payment	1397	1397	1678	1	1	4215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszNo5DFgkwruEPwBT9ba9K7cHszbGmBc62gM2T9deKmrP3zdu
4977	payment	1397	1397	1678	1	1	4216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCd77SefifYBUwVNuw6BnPjnVDZ4NbE8of6Q4Ug6qCtj5d14n
4978	payment	1397	1397	1678	1	1	4217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Vue8cbTKeiLUTNY1vB39xBma9PJjuJfUQqt7raUhfpV213qq
4979	payment	1397	1397	1678	1	1	4218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxkpW5VV2HjTTwQsFCq4rPEibRs2ZdrpfZz2UEXWkV4HcGMAZ
4984	payment	1397	1397	1678	1	1	4222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdTuPPALgGEqUv7ksRUKrXmW8kDne4aM2tUASZmBUB9GiY47aN
4985	payment	1726	1726	1874	1	1	88	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99nEgwmeLZ3Fu1LVdD5jsra6NQV4BggzQaK86FsjYRfdsbjDS
4998	payment	1726	1726	1874	1	1	95	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2q8FznoBeRgYPEJT2L8FFeoMWSGTBfkK5vAnKWod9VZ6NWcy
4999	payment	1726	1726	1874	1	1	96	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SaopLcDXT6Zt3tVGRP7ckoGdW37DdcE9d1KWBtbaeuN5Pa9k
5000	payment	1397	1397	1678	1	1	4229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aM93vonrUQwB2er63S622hquMnC5KBNQ95iio2tjWAFwfbZV
5001	payment	1397	1397	1678	1	1	4230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzvAjojjt4rnMxCERBM1MrgHoJ6W9AH2CExUtpCtYreQFHrNA
5006	payment	1397	1397	1678	1	1	4233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3ZLJKGq4vS5CeVdi2paUM57DbDTuv4BUfMrbc8V4qZz8WqJh
5007	payment	1726	1726	1874	1	1	99	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQDaEbtqp6kchHNWq7RgFB2zBAERqUkLc2gyWqdW7uEuyAwHi
5022	payment	1726	1726	1874	1	1	107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEzGwUrAv67DZKqcFpobuk2gbUrexRsoyvt5DHUiot3XdzUFs
5023	payment	1397	1397	1678	1	1	4241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAWWZvyhDXLtkwbzoSUnkrkujCH47a3ua4PuJwkXxUFYaSMgV
5024	payment	1726	1726	1874	1	1	108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2e4u4Vie5pWx2baYqqrqt54ciSswgs75fujPjcaDjWJs6MLU
5025	payment	1397	1397	1678	1	1	4242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHrtxz2Mwv8EjmcUYceoYGJUeAwHxuT6L4PqhTKbvyj3vfZpT
4942	payment	1397	1397	1678	1	1	4183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZcvEEELKAZynTPdoC6FX4dKnUJGgJwHqboX9W7MD8KN9CRup
4959	payment	1397	1397	1678	1	1	4198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkuCkqUFCWeKb7A16o1r8o1jqEXUDnjzpsf9REcQSwdoQZ4ZJ
4960	payment	1397	1397	1678	1	1	4199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXU7LgEweEWNqrAzeWvAEMKQKPJNWegasWF2e3EJCNtHwSD23c
4963	payment	1397	1397	1678	1	1	4202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZES1RFrQCuuan1ETzR89boQvtYF9RuEDEJ91cAYdEgAynp54Xa
4964	payment	1397	1397	1678	1	1	4203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11cvkVFAptzG5n9eZpyReR531Cw8G3ksonjMYjKQ436ur8K3r
4968	payment	1397	1397	1678	1	1	4207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Q3Sq3K9d4Ra2yQQ3nwj8wxwKMvTZMzVsH7jjXfGCFbXN2i9
4969	payment	1397	1397	1678	1	1	4208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcupRBBRg6xFcP8iM8Rd5jEtzq7exZDqv7v837wBtkaSZ8R27
4970	payment	1397	1397	1678	1	1	4209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZxGn4DRQftxFbTko85scojhk1kFUMArBuyC6p9kBxPjgYP6d
4971	payment	1397	1397	1678	1	1	4210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNBVBKehHvhH8v5s9wt2G1N18U42m9at4hZfbt2WJQPtxSZi7
4972	payment	1397	1397	1678	1	1	4211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1fstwpyT6nw6QLQCyYLvyRbQaTLLhSyKGXqtC7qE3paySUvE
4973	payment	1397	1397	1678	1	1	4212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADE5p9b5Crk4DtcGRAV1pai9kg63HCxqzh52kSb7ezzbV4VUm
4974	payment	1397	1397	1678	1	1	4213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwxBKHuSsZR4bK9aRxKeywUyErsSGJLYu4Vq5fnSbNjPMj7QT
4975	payment	1397	1397	1678	1	1	4214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1xDxzZMhxbZuDtBsDwPQ1ZNFtcZa4sjqtVCsUvRo5djn3Ci1
4981	payment	1397	1397	1678	1	1	4220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaD3YGkrkZEVV83MzsvN7EVJUGEBhEjxKgojWhkMRaKHxJhe9q
4982	payment	1726	1726	1874	1	1	87	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEtd5KyuZbzwDY9xfaQDRAccupTSqz16BB1w4yKj9GqXsE1yp
4983	payment	1397	1397	1678	1	1	4221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGe5qnkdvSgyeu8KMeS878PsCn6iMdtKeXX3efnZuknjvXVdk
4986	payment	1397	1397	1678	1	1	4223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPS836U4dw9pYU52njK2qk2j5ohr8ocJL12s1EXLzHH6poBus
4987	payment	1726	1726	1874	1	1	89	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGehGS6fmWNfTu99StHMhqUaYWBf5oZzpeXpVzHHfzGsS1o5AC
4988	payment	1397	1397	1678	1	1	4224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2h3reQxZs5ULpz2a7tS3JjbV2ot5NJAVw2qN9HhrczEj8Qdj
4989	payment	1397	1397	1678	1	1	4225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgmoGkxpXE9JpQFXG3YY5zFopMv8eXhywbD9wExBPEPFiPE3h
4990	payment	1726	1726	1874	1	1	90	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjD31jsfrQjWmdCVKYchCdEbNyffSphjNT8vj7cYKtm9PHXTm5
4991	payment	1726	1726	1874	1	1	91	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeTTtcxEgmN7aAgX2UZ6a1V3uMJRx2eZtJxt1UdZnpXa9qG4s
4992	payment	1397	1397	1678	1	1	4226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHNAHtye1Y91NNgRm4hDhtUWk78rCVeFZBkHQKWxUrbfNjFZH
4993	payment	1726	1726	1874	1	1	92	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2J9dpSu6QjtaAhXdMjPV44CiXFgTxEik2abUKBBMvjeYoc4M
5030	payment	1726	1726	1874	1	1	111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8u1sk4pXnqfXR4CVrTaAMZb3e4FBqrza7XACFx12BJxreX5FA
5031	payment	1397	1397	1678	1	1	4245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaBHA25X147mF2EY7TNnRzAgohCN64FHB2t3Wrd7tExttBRMd
5046	payment	1397	1397	1678	1	1	4253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7fNHz7WvLnkxwLt3C5z6xL7ZgdgCcsBANroDK6HEwnFoAS2k
5047	payment	1397	1397	1678	1	1	4254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWoMTWukTkff9BxYwN8ti17qNS73XKuwRtQdTb3G9tgDdC7E3o
5048	payment	1726	1726	1874	1	1	119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsugivuSAPsmJcMhyGLr89ZDXR3ktVkoJ23LdRkzAXiDZvUH6
5049	payment	1726	1726	1874	1	1	120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGic62yyao9ncatkMbptF3i2Fa3pPR2YizqT3339Y9i4QYNXfb
5054	payment	1397	1397	1678	1	1	4257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61QU2z1Zs6zZLmuBE6DPuZ4T7bk15jsZ5qny8iRqHF2dh65GY
5055	payment	1726	1726	1874	1	1	123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdNQMAa8FGqeULiFBvuS3baqWmDgUAoaUcAsYoJKSr6RKCrq7
4951	payment	1726	1726	1873	1	1	86	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6sHGQV9cqHr33eH2SDjPszqAeTCEVRKswS1kACYCebGL4Tpty
4952	payment	1397	1397	1678	1	1	4191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4suGprmgdAH1nvxMTgJcaUYDdLM9YdrNX1oM4TnYqHaJE8nd
4953	payment	1397	1397	1678	1	1	4192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujCZgqEbAp4USQvrVG6QxXdxHddCWkWBzS1cgXaXQBEqw2HWQ
4957	payment	1397	1397	1678	1	1	4196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3spDgrAhhNgpDU5fEVGobk7XE7hCgfJQr7jDzUUcLz9VD9ZX
4961	payment	1397	1397	1678	1	1	4200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8Esudw1RQHmqssya8Qzo1pV2FcJ8PSv8ARwh17ihh48pwaMV
4980	payment	1397	1397	1678	1	1	4219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJT9ajCrZ4Pem1LtZ5JvKMbQZmawBdtMgNosrnafY9SuFs7Ft
4994	payment	1726	1726	1874	1	1	93	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxBEKd9MEvzRyGsbvS2WEK6g5TGW9mbpqXT6a4dQSMrM4Zc7w
4995	payment	1397	1397	1678	1	1	4227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMhsSDC5beBU4BgRXCtJEVYCyQT3Xc874GR6Q8mjzwZujaxjV
4996	payment	1726	1726	1874	1	1	94	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4szzfbchcBSvFvCrNYfWD4pXURYxtzesymqWTrj9SNYPP45b
4997	payment	1397	1397	1678	1	1	4228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2H6ZNWuzrMqgyRW5z9XdcxKuJhDmE4QB99sARKu8Pa4AXsW31
5004	payment	1397	1397	1678	1	1	4232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4zEjGbutfjfrMjACJrpPXwL2fYwgpPNeckwG55bLBK1wP6Pe
5005	payment	1726	1726	1874	1	1	98	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRx9cfVqN9KxFsDpBYonFPfgXr6cGcxZs1TfQUJpnKfunZGVM9
5008	payment	1726	1726	1874	1	1	100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHV3FEYDww1wCVBV6vfMP2iFHQw9wi5UrTLATNGKTaVBE5A3h
5009	payment	1726	1726	1874	1	1	101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZDXWex8589UwtrVrLXcZbkT23mGDfBW9t4EBfmnWLtihK76D
5010	payment	1726	1726	1874	1	1	102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyjCMjnGkTYjQrxXphTVJC2BPoyszaY3jshkK4VFReRc4uAkS
5011	payment	1397	1397	1678	1	1	4234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRpy2rR8Gmitdxqc4Dz5GhJuv3UUkCQff9MxpqS9g8ECsc5Pd
5012	payment	1397	1397	1678	1	1	4235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZyzfkKaDnM9Koes43FRQnhdMtZ6PZZJfJwtMGpkfeejPUbc9
5013	payment	1397	1397	1678	1	1	4236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUS6oMxNcogNKQ25TZHQuVJALTTDC2hUqz76Yy2pmi9FdJENaJ
5014	payment	1726	1726	1874	1	1	103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eoBPjdrepmS179AQYJSEHTvbJW61g8TxMMuQfNkPWYNxqCgB
5015	payment	1726	1726	1874	1	1	104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3caYxxVTz9KLq75bNU5hfnfaX2z7DxrDVhZGRU2ViM4Ma5UWh
5016	payment	1397	1397	1678	1	1	4237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm2pRauHa7abqA52jdAwg8974JuK3zzVJCsvakkyJB4x1KZi6w
5017	payment	1726	1726	1874	1	1	105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGDnNBLJXuvHBm1FSgeoAwsM31unyNTmTX7SZmQXkorruPW7X
5018	payment	1397	1397	1678	1	1	4238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMvNZnwF2iCENaQ3Du2ehgg84trC4B1SxQ72dP6yv27CcC6xG
5019	payment	1397	1397	1678	1	1	4239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bJcCMxVQ1fCN2WSTpW7UxcrfA9kQSrHy6uHxv7bkw8xXdUHd
5026	payment	1397	1397	1678	1	1	4243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46bbpesu1aeyYKqawTBaHn7pwoh2pjxpA66Ycb6zZEAgpDee2
5027	payment	1726	1726	1874	1	1	109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQQfKFMDsPk8sYAorbWibg7LsanecWvqBnvQdCg8UeveDiUpf
5033	payment	1397	1397	1678	1	1	4246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjyiCH4xPoHbUySJvWHRAJE6ZmWmB8cq1oMQ4v1jDRzhjDWn2
5034	payment	1726	1726	1874	1	1	113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurN6mpKNzPVLeW8qataVgpj6mVq76XQfF9amtzNoTSqWaAU4K
5035	payment	1397	1397	1678	1	1	4247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3WP3grakdP5rwgaT8h3WHmvvfUnz3F2b9DoTM7M6qkDobNM2
5036	payment	1397	1397	1678	1	1	4248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiAZ8eRe1xw2ZbZKmiyUZaceQKyBTeNkw14Z3gsSQe4vTXmog
5037	payment	1726	1726	1874	1	1	114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGh3U96eQzb9QHmPVYoXFMAoovGCKpw5hbdosnoP4gxsDvRFd
5042	payment	1397	1397	1678	1	1	4251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XfGQvCwRQNN3AQyRRxAJN8Y6SQAXfdXDDqes2Gubr7bLhQNc
5043	payment	1397	1397	1678	1	1	4252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7qT5S4sL13qo88fgwhaxPHECn2o9kGxV9F1cgX81RosqE8wd
5044	payment	1726	1726	1874	1	1	117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJSnP7mYRrMDQEvjeuVwz2AXAfgSNwRsmtFkjLpzUWgnCpRY7
5045	payment	1726	1726	1874	1	1	118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WxikhbJq8DC52Yx1Wf7tHpiDtJR9JY4eagKBQ9jv7xAQm9og
5059	payment	1397	1397	1678	1	1	4260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrxL8nVTebau5JT5TmPM2EbtQA853eiSQwuxGu9MWvNMU7DWe
5063	payment	1397	1397	1678	1	1	4263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNm2ZAawvaUhmHymSnwx9YgNWqqKHrxeR9yxLJjaYUwF74zxXF
5002	payment	1397	1397	1678	1	1	4231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahqBwaRzvAXHvYasqoZ96xV5FueXhhVSiknepmN1GwTybi56b
5003	payment	1726	1726	1874	1	1	97	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxviYkX7dt6PEkcUoYZ1SL8dxLrCxGvFLTWgGkTRWXqTzaAEJ
5020	payment	1726	1726	1874	1	1	106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsUnpL95KVH98HjNuifqCtRAmBjUykJnMbkDxaFmTTahc3Ytp
5021	payment	1397	1397	1678	1	1	4240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9y381cHYVFXSmzt1wEna1UScMPY81T9btHPwBVb2u4s26GBdU
5028	payment	1397	1397	1678	1	1	4244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kPAzwiGmg5T4Lr22XGnN3Dn7eD7LczLbwKEkzngn2BG2bJqQ
5029	payment	1726	1726	1874	1	1	110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPNFE5XRzAjbpTyRUjGYgdQC4gdKN5ip67diGEXVWP8HjjoRX
5050	payment	1726	1726	1874	1	1	121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYLoUrtMguDjo8m9QBHKv2kTKzjPFfJj1MViRemLVYWiJa5a8
5051	payment	1726	1726	1874	1	1	122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mSeGxryvoyFU78q1pKvv8zCnYxMLeDUjWVkzvcE9BkFGFthC
5052	payment	1397	1397	1678	1	1	4255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHyZT1nFswJdJsL3TM7kvwJiyoY1kgNcjdEwzSGawnf5MEBLK
5053	payment	1397	1397	1678	1	1	4256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUHyV1AGavVKHugPbcW7zC86rZiSWEYFWRiDhtZFx3ZxnbHHh
5056	payment	1726	1726	1874	1	1	124	1000	1200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zRsPux4xFLqdVXzftTeS7YVrA1NRHtcm88Aasgk6MW31yYz1
5057	payment	1397	1397	1678	1	1	4258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QJqLvAbsER2sL8T4nFCqCsWbLT2y8TUjiW33nrBq7tpg7uYx
5058	payment	1397	1397	1678	1	1	4259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7A8Xsxni2wDQsYbhAPUuzKFGZRGCwiXeFhLBuSdyMjypLuvxx
5032	payment	1726	1726	1874	1	1	112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXyTRBxLKDdCKiFmCAZvo4vV2uJqTXvGUnXKCnPjcFN8uSdnv
5038	payment	1726	1726	1874	1	1	115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMpJhqjbirYuZ9BDJjixei88qV39dnnqoTmucFTRMiPVnabto
5039	payment	1726	1726	1874	1	1	116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaYBVCc2yLm17uLXGmUfgNUg6Av51nE3bSwkwfwKNADq2xfxH
5040	payment	1397	1397	1678	1	1	4249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLgz3YmymordYE3SWiJRTPoGJ8jQPxwsat9Atq1yiHkUEUbme
5041	payment	1397	1397	1678	1	1	4250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPVkgrZv24oXSJNLwPHknB6Mbr7nMbzKaEpqmAgBVHcYAgnCy
5060	payment	1397	1397	1678	1	1	4261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXCjf8t1ZVgs7e3Ar7YxixwnvsnVf72mBj2ZZwSxrTKiPavJa
5061	payment	1726	1726	1874	1	1	125	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZgYsWeFABv4HYskE2mH6kxPXPWqKJdenxRaHq6kBamXSoEQW
5062	payment	1397	1397	1678	1	1	4262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL74ouD6i9XEinTQFhBqcYr6DEXQXdUE1Dny3YF3MZzdDC1CpB
5064	payment	1726	1726	1875	1	1	126	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa7h9srosUdrHCrmLER22ujEBDaQZHqSDcJbn3YrCG9acoto17m
5065	payment	1397	1397	1678	1	1	4264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fF8p11hD8EoKsP2HXxdJ5DGzkzdAYwrLHzdwVwsFFoCmQxQH
5066	payment	1397	1397	1678	1	1	4265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZh5LvrDHDjmoLH7qRpGiBqRzA42b1g1V3zT1QWuirzBQMsBq2
5067	payment	1397	1397	1678	1	1	4266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzF8f6oEEcrEzvUPVUmZqn3SpyGEhFv9th1XDKs5ZezxLAiXnx
5068	payment	1726	1726	1874	1	1	127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6f9Dx9jfB892HjdgpX3eDEzBpKgKbTSeuK2FMWLhihy96NyNs
5069	payment	1726	1726	1874	1	1	128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxavZmoCsBNuhe4uWtKaDGWU4cUz7zxUPmHjbCxrriezKkPcC
5070	payment	1397	1397	1678	1	1	4267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnb5Q6DwfHLnpLk8Mf2ofspToZPXDZrhmnZQYJcujd3bWauhRP
5071	payment	1397	1397	1678	1	1	4268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNMFejTVpzGrS4TAVoQVHAgMiBRRP9jFddZ9HPkT5hr3tc2C2
5072	payment	1726	1726	1874	1	1	129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQ676VVKjFTvBSDoec6ZqmkJfmu1pCX5j5otnG4HvLdzRSYT9
5073	payment	1397	1397	1678	1	1	4269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudUviuc88NALKbsE3v8GnJf3C49TrsDpcG2Rayw2BJ2gfc8q1
5074	payment	1397	1397	1678	1	1	4270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKMjsf8UTY6z1WcT8bpVQ14T8ZGP8mdggC6sLXrFSrGKHDiSf
5075	payment	1726	1726	1874	1	1	130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ih1jZ3BTjn35ZFqkBR9RiA6HkL3GNGVde2EyBw5J4QEp95iv
5076	payment	1726	1726	1874	1	1	131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6pakKhReZTuXp7VJ2vSHk1gDeXL2MtrR8NpVLkKnerbbtLyp
5077	payment	1726	1726	1874	1	1	132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkTjUHz1SPNn5kL441N9ySPw1ihm2oGSRohpYZ6pqRWtypW6Q
5078	payment	1397	1397	1678	1	1	4271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDu8WqAKwewBwM7TRUw4HPbPMEF9uWFDJT4B1dmyPZqsV8gVr
5079	payment	1397	1397	1678	1	1	4272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKiUkS6Ew8auLWoNAgXbMY5P7R3U4kZf1MSBkEcoU5NLUNHKi
5080	payment	1726	1726	1874	1	1	133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCp9deFgrNhi8RbnEEGWZ3BQrULywEGvb6SPm8RpVnDdshxMJJ
5081	payment	1726	1726	1874	1	1	134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtpCJJBZ2Nk23TVrn6brjYE3qD9iMMpfi3PWWVPPzStwVLMHwM
5082	payment	1397	1397	1678	1	1	4273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sBAf94jX3bDJ57QtZtYpGeG2oR3PNEjK4vVmVqkhhahCCEuZ
5083	payment	1397	1397	1678	1	1	4274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMvSJtctF2gMJj9NUFHhkWZpKkXA5JPhQgDBXegsTm3vk8XGg
5084	payment	1726	1726	1874	1	1	135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGh4igtEsi6GSSkJHCjNiWvBwFQLdx4gBUVqKd41boRw1c2xKb
5085	payment	1726	1726	1874	1	1	136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBpaPT6Efvkpi9QK7a3enc9Ct7UaQEq3RLmpX9Hbz69sDxv4C
5086	payment	1397	1397	1678	1	1	4275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMdAuy2MJAgbAHYQLxwSfUCn2qt9jnCwUGpxiiy4zwPtgdaN9
5087	payment	1397	1397	1678	1	1	4276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaFJdcaN2ijB21FeVZQJ1FoLGqsW9jQcrfiayxsMrpeoXTSuf
5088	payment	1726	1726	1874	1	1	137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyu1XLRFEdRnFXgfNqbkCekX7AuEDn2N3HdFUfbzNtU9CNnxN
5089	payment	1726	1726	1874	1	1	138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifniWJ5iaqTvJVL63VzCMU1HeYZqsB85TMVYiEuWxtgGBBMqq
5090	payment	1397	1397	1678	1	1	4277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3M5aWgfsQuqc3wm2aGG4zzmZPDzHpRWYga4jGyco99UY5TZec
5091	payment	1726	1726	1874	1	1	139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtvkGZ4WQc6jsPCiMXUnGQWwZas64QHce1juYqJXAFHQjdJ6C
5092	payment	1397	1397	1678	1	1	4278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aqADSjUeXqVmFWVJFoMFTtvWaYbWrD4GXBWkYEfjGxSihmS2
5093	payment	1397	1397	1678	1	1	4279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWADACS5TRMWBwmNAunChLJnyMQeTd9Xy6yAoBhEtLEyajKgPV
5094	payment	1726	1726	1874	1	1	140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUzK9SDsHd7Gd5bEabT311wBSFwJ1uyzNTNANausJ7fU9XCQ1
5101	payment	1397	1397	1678	1	1	4283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkXRA3szuurNeJh9mSydFrYn6BBWfVVkk1RCk5TsXxoBgm2nJ
5102	payment	1726	1726	1874	1	1	144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WdT7P13YbUZwsg7j1GgSngKcehgh6G28jJKx5kJH56GKsNrW
5109	payment	1397	1397	1678	1	1	4287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3KC9zBh3Vm418q4GRpfhvGwaUihKG4TGYVuUEvYcuZGV5Ueq
5110	payment	1397	1397	1678	1	1	4288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiu3x2sZCnqVhARd6RgMN8kbfanrk7W5gkWcGdccw9vYd6Hqbw
5111	payment	1726	1726	1874	1	1	148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6f6ZZHjoPnS34rbLMVtL9ATeFvuFkjzYgVfgSMQ49pmJPKSWP
5112	payment	1726	1726	1874	1	1	149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsKvWapoMD5fbjca9iZ1mTJpz2KFpaYTvaYXr6puc8hGJkvWH
5117	payment	1726	1726	1874	1	1	152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgKzDuAicTT7hcEcEBmBBo1yHyYxTSVQJZBtJiC2QosQmzkH9
5118	payment	1397	1397	1678	1	1	4291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsVb5xEfMkYgXGvzux9vZ95XfwdyLu64FPWZnNRJXD3rAeuUc
5127	payment	1726	1726	1874	1	1	157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaghUVqQBQwwojEtkU3vLLJdnNCVTVx6MekdUqArrLoTMWNfY
5128	payment	1397	1397	1678	1	1	4296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2oY2VRZf9CM1gkqgVKeBRomny6hqL885zeaxEEVcdSum6141
5133	payment	1397	1397	1678	1	1	4299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXptr4kT25sX9ku4pKx8bR8gEqZd7K3UWB9mztoMjhGED3TBzz
5134	payment	1726	1726	1874	1	1	160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzn9bJrPvDEHUtRdgdkiDoPCgVotmtVKexnBsJ7a8JyvzMVmxd
5159	payment	1397	1397	1678	1	1	4312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfAHsayemxkCcme5cjiHrERNQtqdnBZjiSLtdvHXs7D2jiw4f
5160	payment	1726	1726	1874	1	1	173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiEhum7j1iePKiX4LHgmii7Qf17KTYTg2EBwrzGVVkBFEq1rs7
5166	payment	1726	1726	1874	1	1	176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8a7nXY9pZsyahuuE7GM68MiwHy35j2nspq8wt2ifTCvtYxgso
5167	payment	1397	1397	1678	1	1	4315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHB8kkdnKMicmdK9EKhNXrFX6GS6eiEZYLqHfMjKeuBRe5RYE
5168	payment	1397	1397	1678	1	1	4316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfEM5jVfVdfu8vNLqwqRpsoqXyzETs7dPvbcY1rKQcoGBuhXT
5173	payment	1397	1397	1678	1	1	4319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBfz9sSRiphZtrGJPbgdyCGhwbPVxuKLjFgv146uGJgnQCCer
5174	payment	1726	1726	1874	1	1	179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWhQXKqeoK7CVGSuU6WmBMwHr2XnxcrYoQ7TYcXPAvvy9kUyG
5181	payment	1726	1726	1874	1	1	183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLGVZGLqGy3wJ3zUFgQaBXAe61wLX9wAyvrBgtqjT5ZAhD5BQ
5182	payment	1397	1397	1678	1	1	4323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgCgr5wFBcgDFyajU73hA1hmxy1bMoUmT8n8GyMF2NP57GDuE
5183	payment	1726	1726	1874	1	1	184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw116RhMR6UgXyMhZ3yzFqxpcY6tV1sizSwpsBBLjFNnAyMYug
5184	payment	1397	1397	1678	1	1	4324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHQzd1Aw7d2YNCwJufitp7CzVmrkcYZ7ZKcVGW7QmsU92Hh5Z
5188	delegation	1876	1876	1540	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oaK3wwxQScmsNguzALobs6ybM4GqQ9LM94BCXC11kHZ7PqnW
5189	payment	1397	1397	1678	1	1	4326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAygANPD3wAWhaScRaJtGWwhEuoGKGswR81syZjterXbcPLZV
5190	payment	1397	1397	1678	1	1	4327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwNn3ZyHjjN991TaWMo7QFmBkxwfCGHNonDsLVnGpRH3NbjeoG
5191	payment	1726	1726	1874	1	1	186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFK7aa3FhmCoRRqFTvgHQiy1szGbA42SXPQ6u2gfbK8ZB5EHFs
5192	payment	1726	1726	1874	1	1	187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnC77WGY28XvDVb5ooWkpCtv6MEXqVb1wUdtA3Lh5QCa6gdZYf
5216	payment	1397	1397	1678	1	1	4338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5MvzxGfNRCxXsnaMjXuQHffTRojWpaNzhAZmnh69mv2H9UTk
5217	payment	1397	1397	1678	1	1	4339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoMgsjB9JwSzGkbDKRWBFA6UgqED9HVTKy661W5o6dMCgCGCo
5218	payment	1726	1726	1874	1	1	199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPR4VZNumsiuE5GHFrLEffmUPSogobcPntV7t23UMW5aDdetS
5219	payment	1726	1726	1874	1	1	200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRENRXEcxyRxFNwLCPj93ctiFK3P9tWwbkQixoh1iuUGA96Bt
5232	payment	1726	1726	1874	1	1	207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanzcVkjqVpmPgitJEfVrP4SqHYcdLrvXNHb9d9db8jLu91UX3
5233	payment	1397	1397	1678	1	1	4346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcxhJQYc1VXn2V3Gj2VaDoQtcbEn8vWD4VQNokd2GcVfnHuTf
5242	payment	1397	1397	1678	1	1	4351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaWpGPnGZaptynsmu7r4B6vbFDRwr9VksD1MzH6wguFrdyNZk
5243	payment	1726	1726	1874	1	1	212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRz3hW6gE1NRuPEh63RJVp6Yne2iY41MUkXpmUMWmEtioqSfg
5273	payment	1726	1726	1874	1	1	227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSQuEdTNrDfq8vUDPu8AKsdMQuGUc8yGzZtp7DkRdXHbgxGDn
5095	payment	1726	1726	1874	1	1	141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6eRBtMMiBYb883rZERhfSr8vh3T1XAVwiswkXyquxCpYUGwV
5096	payment	1726	1726	1874	1	1	142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15xPSFRb9QKVp2Ag1bcSDutibLFEjQqNY15zSRtWiMBBpLMBv
5097	payment	1397	1397	1678	1	1	4280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouaHycuyd8PpsoPzcTSWd32aEpYZnT4ciFwbwQoZqrWLjahgx
5098	payment	1397	1397	1678	1	1	4281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVqNitQmhLSW7Ji8XM9Ug3Kw1SCcA8UxQwD2NGguKqcPs6jVy
5105	payment	1397	1397	1678	1	1	4285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdDjWqdezAiiZ1YX8TmkdAbCW8Wq89m4mhSAAKrzbwNXiRPfQ
5106	payment	1726	1726	1874	1	1	146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoPncb63d3X7vgJAQbTJ1izHpdKTHLXz5x6DFAcFYCUBCgJEQ
5107	payment	1397	1397	1678	1	1	4286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3pAVA9iFZwwFuvXmxq3hDytzzijtsH3EFnaGNCBSzHU5wxWq
5108	payment	1726	1726	1874	1	1	147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBXsj1E1Z7P9tZqKd1bcF3jtPbFjZgydpwRuAd8HB6rdeUgWX
5131	payment	1397	1397	1678	1	1	4298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYam2BauhdwazZ8rfgRrMtBeXw14gaEcm2oZeRcsX4NTVJ7ipMB
5132	payment	1726	1726	1874	1	1	159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2tv5uuwX8BVApxayYx7TFT246uvXhHKJkTFEcrCfoGRkHBPjz
5137	payment	1397	1397	1678	1	1	4301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwStkBxDJDzH2VP2ZebcuQYRp2vDh82oGMaDupj1yhDEjdw9A
5138	payment	1726	1726	1874	1	1	162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLGDYeYD2WTBxY5X3KmtrHESzYSREKpAR9Xi3kDShrAMBBjBc
5147	payment	1726	1726	1874	1	1	167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT58AF3oe8j1LtVs2trp2awzL5F1dKy3caUv9vGeZHgnhjPr7U
5148	payment	1397	1397	1678	1	1	4306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveA2Vbigr8qKa2XTX7mCZym6jHB1q9rTgEr5cB1BJc1NYnJTg
5161	payment	1397	1397	1678	1	1	4313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5xGFCsjqcmckCFookzzdrJDtCoK9aT5QMnAz6spRSYiKThMf
5162	payment	1726	1726	1874	1	1	174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekg32MXwWPPuYGKrirYmy9HqNfRJceu96M61Wi9yaGy4Qtk19
5171	payment	1726	1726	1874	1	1	178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSnKujnfVMmckDAxYRsqA7ppbmp3nxhTjMap9irweLn4xGrQb
5172	payment	1397	1397	1678	1	1	4318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUK79sAyFQ37nx5fVmSQE2UMgTqm4jS5ZrrJ7ELESeLgjHbWG
5177	payment	1397	1397	1678	1	1	4321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69sav4AsCk6ceMjWbzihvRk5aXfQjLHTtZvNY2nFKtWeyetJo
5178	payment	1397	1397	1678	1	1	4322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdf462otKqKEZ6PngRwsUzNcwtoZ4NQKgZNpDUJfhDH8gMLQtD
5179	payment	1726	1726	1874	1	1	181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6tg4QNasEGcEGdX2HRJFuQ9e1jqpzn1EzPCs31JaGZ9L6Lrk
5180	payment	1726	1726	1874	1	1	182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaufQWzkjg1wfN6rNez9rJZ3pg4RQVhfxYNyCkNyQsfQeihUj
5204	payment	1726	1726	1874	1	1	193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFYFQyj9FUgWT7LwTLpiULdxDggnT1jE2X8aGYcVjq7F8jY9R
5205	payment	1397	1397	1678	1	1	4332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iyp2BAx7j9XjL1C2xtG8KYGXgCzMroWeWzsUtMb57ngD6Z7n
5214	payment	1397	1397	1678	1	1	4337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJscj6VeVo73HXfEzfknmLiupH2R7pJcqC46YYV2DuchfGA3r
5215	payment	1726	1726	1874	1	1	198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyDAbeCi3siWWvETPBkiQreQMwmqiECnMrh3HnjWjF1Uc1oXL
5220	payment	1397	1397	1678	1	1	4340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa45J8tN8jMqwZQa9ooFNtQ9FJNLv78LnurLHyci6RU1zi6xp1
5221	payment	1726	1726	1874	1	1	201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsthMRmNTepbRYSpKXNnqmopAFsCrLRH4KF3opsmyeCbCkNiZo
5222	payment	1397	1397	1678	1	1	4341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQLAiqqnL45U762ywcombUi4U8dn6RU8FyJ5oKBCahALPwVe1
5223	payment	1397	1397	1678	1	1	4342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZjWjN7D4ytsSSVERTegVd6rGgS85RTdXnZvJVSWM3kiUvUdB
5224	payment	1397	1397	1678	1	1	4343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa92BAdzjrpAGQpYMUQTzeVobkpCwSb4KmdmJCzuV6Fgeoqmhb
5225	payment	1726	1726	1874	1	1	202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx8NPCwGsggZLZvxDaP68bwv528rofZMFPhWriLLf9XQDb8QV
5226	payment	1397	1397	1678	1	1	4344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9QBqfQ6ZCniheBLZYSWufUqJo1MmeVnLsrTaEevfQZr2MS7m
5227	payment	1726	1726	1874	1	1	203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuT4wnmXnkFBRR5sU7FyasGKLNvG3y6MfoHKwznEoDcZNi79xe
5228	payment	1726	1726	1874	1	1	204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP7UVrhkjDkRF8iHhBcUWoX8go3WyFi651zAi7MmrwkTvZ7eJ
5229	payment	1726	1726	1874	1	1	205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqTS6aJNvzTgjYXh5YEzJfCqDTEARZXGygt6fCYaSsBt5tQVL
5230	payment	1726	1726	1874	1	1	206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfU4cMDm6E6yXM4hZP1ZoKr7kj76qgsJ9N2oGAU4ja9xrdGfA
5231	payment	1397	1397	1678	1	1	4345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCNnMTXRuDMG3syNXTb53W7qXL1fGbnf3JHW4ETXp99duvx6h
5099	payment	1726	1726	1874	1	1	143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5PBW2xjAwesVsb3xwzr6F9eeLYThc7S1PpLsTNBCFGLuBZUB
5100	payment	1397	1397	1678	1	1	4282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPT6tB1JZVkCsMsMWpRrKScxsjurng5p6Z3jaqZFG1yCj9Y8E
5113	payment	1397	1397	1678	1	1	4289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfs8oajCNsNExKGEfPNBwfy18pqLRC9qqehLwZYYieCsREHTJ
5114	payment	1726	1726	1874	1	1	150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQfepbDpMH4ygJXzvJjZFGuPkZ9ayzZTQ2JSFUP982ypaY6yh
5115	payment	1397	1397	1678	1	1	4290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHmnLqq3jvBhG2PATqBLmB7MUkM3KA2zs4nyoJFZfVMB8Zbdk5
5116	payment	1726	1726	1874	1	1	151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQipmDJSSmV64jnpAK3CkKYJFYPVPvAD3JjncX1hZkhJyuMxq
5119	payment	1726	1726	1874	1	1	153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdTX5F6vbmsN4BENfcCUUkiRu2HafDXxJ1AKce3FPLhbW5ysP
5120	payment	1726	1726	1874	1	1	154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSWCjwD38hgk1vXSX2sRvGdeGooNz812GgJyGn9116jnQFanv
5121	payment	1397	1397	1678	1	1	4292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPs3DU2nVhoGUKbkzg2hnT8h4aTPweku6ToJfE8ky35x55wYB
5122	payment	1397	1397	1678	1	1	4293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2Yidmagy59LGRFoFGKmCNavuSH7LfEPa6qTZCxDEZRGy8BeM
5123	payment	1726	1726	1874	1	1	155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvcQ17dPeAYBsaPC4WH7vJzVMnskFvnyrSyPTWC6cEYHUXNp5
5124	payment	1397	1397	1678	1	1	4294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGt63AJisdZQXrdrdS5BPEyArDnEuEqrR6cQsdMjMEWrsTXE7a
5129	payment	1726	1726	1874	1	1	158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZujCKYwKWL4ofXbSDiC6szUYAFP7LXMuG9TuFgE7ycsuBPkBG
5130	payment	1397	1397	1678	1	1	4297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94ym6Qfcb9xxQcXstTtkdBqFqa2s8KjcsV3qBC3ACwMjxwgpu
5139	payment	1397	1397	1678	1	1	4302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdvtKodGYJCc5VPQV4sg8BVhGJ2YbTFaKVAFJU118iF2uLmX2
5140	payment	1726	1726	1874	1	1	163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2pcbnt8aJ5uLnnaDyFLW2NK9mN5jGnhoJgL8YRkS9Lg1692j
5145	payment	1397	1397	1678	1	1	4305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZ6VVxz9mVVZhudUKKSwMrRVPwjm9FW6wyW946DmmtqkUau9x
5146	payment	1726	1726	1874	1	1	166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2w5FmvBDtVfhPNet99pAejKpiqaQcpEsG2Sj4yV8HbJrZMEW
5151	payment	1726	1726	1874	1	1	169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2nbHp8AFkCErHenbnbXhnanvP9BCoTVvpY8oJnTurddhZiWJ
5152	payment	1726	1726	1874	1	1	170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmY4XdPUiWsFcjUriNgAvhh5Vc8CGQHkQrv2n4af4zfZCobTJD
5153	payment	1397	1397	1678	1	1	4308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqjpB84cwmukS5L3aFUptiLfUNPCKd5gfHTAHcWWBaLvEXo9X
5154	payment	1397	1397	1678	1	1	4309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWFBrn4KKPdms7ZCoXKfZoYBKkR9eUiqF5vumfm1QXyCYviWc
5155	payment	1397	1397	1678	1	1	4310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMbieT4g2v9AHo6kVkRZL8GGR89jn32u4KvCdPfat5LdkT7qF
5156	payment	1726	1726	1874	1	1	171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FqfwDVD2iVcqVHhb65JFZzN19XR2PacXJTCyKeYgszuPDm9g
5163	payment	1397	1397	1678	1	1	4314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLkQP7rxh15YFQxHT6DBWTK3fWt47r4wUFBxtNr8BsMu7KuV5
5164	payment	1726	1726	1874	1	1	175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHrnEwn9vEDHXhKpBAMbjHGAJJ3ZxTDdMtz3MzTai75xeKuCm
5165	payment	1540	1540	1876	1	1	0	5000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCRxu9vhBHmgR3wg8TNgGLY9PXdH3k2um7tgXPCyJHDu8w7VV
5169	payment	1397	1397	1678	1	1	4317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSMHDNZAgo8wFkykkDMiJBjBA5WnPSS8RzhNE7o7M43cKrHLY
5170	payment	1726	1726	1874	1	1	177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmf6Tju4RbWhDCq3vcJZ9MFxGrXC2jGhkRQsp15SdF9KCbjGd
5206	payment	1397	1397	1678	1	1	4333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnKNqi5zsMhNVq14VjogU3nPzcjduhnedqY7MAAq2j3ebCmKy
5207	payment	1726	1726	1874	1	1	194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUp6Y1AGuNSFDfpT94Ud6Z7n3G5gL4Rdmz2woWDeCQYjHnuYRJ
5210	payment	1397	1397	1678	1	1	4335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3orBuE4t3rnHup7Y8otwMeAwpZBBMqUofYu3qpfJPkHMtH4Y
5211	payment	1397	1397	1678	1	1	4336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKw3DeLoi5DtWWmww49SuJ3BHJMZVwHWD3xH9zepvWJEK5Z3L
5212	payment	1726	1726	1874	1	1	196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcruxPs6AG2vTsZZiXHhKBLy3JU3b4ELkLECKxtPhgusqFKvpC
5213	payment	1726	1726	1874	1	1	197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9FSEQC8Y6Av9vst2MoU6D51PJbTgfwzKxrCrSGWvbXf7pyKj
5238	payment	1397	1397	1678	1	1	4349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjxuYTLkNea4Kxr5vmiNAi2JyVfTtpSwQrkVrcwJ8uqrjCx2J
5239	payment	1726	1726	1874	1	1	210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RVGtDNQC2xhq11easVhf7K84i9eqR3MFR9Qo1PBMcxzsw7Zz
5244	payment	1397	1397	1678	1	1	4352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLqpstkq65TTtiX9rGw3VGpQWvgJpZPVHr5JR5eU8QkLra7mf
5103	payment	1397	1397	1678	1	1	4284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDP4RHaWtargrRWAZNaRVBurYDVJr4BHcHMAgu8BW8fwtMtSt5
5104	payment	1726	1726	1874	1	1	145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpkKRJZPDux7Vq9Ey9ytjdXBtPYwe46WJrmogb6byR89mAxeU
5125	payment	1397	1397	1678	1	1	4295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsEry9CJsXMibUnUdHNg6WfdmjwmPbfz2KPoThLDUqfmFSCWg
5126	payment	1726	1726	1874	1	1	156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvN4ym76x7SoHemmCWBxiae9MyDwh9pmhTTqR246xT2Nyuemk
5135	payment	1726	1726	1874	1	1	161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdqnM78WcxbjYikqQp9qZY1hfvDoHDYDnu84AQynwu4Ma4NY3
5136	payment	1397	1397	1678	1	1	4300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bmykxzq6jwhxre77yGhj1t6wcdpvvrgUQpEj1BH2ZTxVuUDw
5141	payment	1726	1726	1874	1	1	164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPUBJ47REciX96APiCkPcg9LjW6NSyQB83oeBkTJ9hDZ1WRgN
5142	payment	1397	1397	1678	1	1	4303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1XaXU7PN68yn4gGYC2Z3TS8iyKrzeiavprPcGAUGrinkkfb5
5143	payment	1397	1397	1678	1	1	4304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83vXFqHVQ1Ce8cj2tHUQQHoshusqAMoMfVxAH89i4MPc5U9sW
5144	payment	1726	1726	1874	1	1	165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCM5WEacBwwbqeRKs8JoPAUBsZeMZ3qQMk9vdtvW3ZyEirdRnN
5149	payment	1726	1726	1874	1	1	168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm6MLdtkGZkGjYdYqURxiyy2NR9jQnfYXzg33uS5YEHvm1gwu
5150	payment	1397	1397	1678	1	1	4307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1D7Us4hGcSuA8FjfEhFLvGcWKsdhpuoF2mh6tdRQ4V6cQEiFo
5157	payment	1397	1397	1678	1	1	4311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KZ6dZBXojMHVwjax28qjdG9okzq16NUSyxbLQeMRz89Pm4oJ
5158	payment	1726	1726	1874	1	1	172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVkdy83XDu6VRoR3vsdcv6zjgG166TJMHSmhUNLtxQhgD7p9Q
5175	payment	1397	1397	1678	1	1	4320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVypsUh1oofRFPmhf6HgC3RH92FWGuDbJnaMk3SFTUwfbEQTo1
5176	payment	1726	1726	1874	1	1	180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1qf2wUqskYvHMwqLNoV4WnBVAiYkotZ9WBEE8Gxao9TH9kPh
5185	delegation	1876	1876	1540	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaVstTXjoudhwNjgdyzCzGQNVtpP5RobRmhMSWaW8LwTLe6iG
5186	payment	1726	1726	1874	1	1	185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSs22gjABqtc9mwDAR4hGmddZAW4jrvajChFeJsScns4PDaUT
5187	payment	1397	1397	1678	1	1	4325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHhKD5gGvCQcyJhE18akfagCG7C8EeRZ7ebTAood6MTuHZVSg
5193	payment	1540	1540	1876	1	1	1	347700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PnVMTqMunhKXg8M1fDTShv5Eycjzm3AXvtAGQQNidgiYpCgK
5194	payment	1726	1726	1874	1	1	188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNUZAynNpqx3jjWER1so43Q2JYSgSCtk2Ks3rbe9qVWuHHsen
5195	payment	1726	1726	1874	1	1	189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvt2jr32mst7fsRM4RRrJCVjefX5HuoDstbV4ev4WWg4nXjjXV
5196	payment	1397	1397	1678	1	1	4328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UCM1SMAHoDFE1YiA5LS8HjjRiHcubi2DXh1r5s1DCV3v3jVH
5197	payment	1876	1876	1878	1	1	2	1000000000	10000000	\N	E4YvxQ6SFhV9NNcWanSNgykAansapi1gm5PmYkPPugxu4UzhrGww1	CkpZ8nPad5GM4kSZu482ZtpDdLY2yT793jgJhrcstb2bTV5WvhEmS
5198	payment	1726	1726	1874	1	1	190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryS7dcKYUAaMWXxtWEPhHce9MDcttE1NaMjzrsprdqUPNjDGn
5199	payment	1726	1726	1874	1	1	191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePQGDC87Rpwdw3T9u6VVfvvuYtHgUfDtdQzNyXLy1BjZXdGtQ
5200	payment	1397	1397	1678	1	1	4329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16Jc5Mbf6hAZgejv2fdZ3jfa76h4VqyApaSyZLdbER7ETRMts
5201	payment	1397	1397	1678	1	1	4330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ha4Ab187QDMEmzhWgqNtBWHjX8Be3gp3Zk6C7LU71xejPiFB
5202	payment	1726	1726	1874	1	1	192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjaeAcTLDCnWLt5LXpbfbaQ3F6NfJGSk81qB7kdtAk8sT45vY
5203	payment	1397	1397	1678	1	1	4331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhT3cuLG2iYohdczzeZPZ9rjDtPi2kCD79koHL4DhrgzLgGL5
5208	payment	1397	1397	1678	1	1	4334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUnNtEYU8ooqKsuq4p1BwYMMCNagZTyAFd6ZvCsPBhTXZzVT8
5209	payment	1726	1726	1874	1	1	195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5xKWgm1Xso6MUUPrwWffeSa2qWMhamzdAGYREhZSdHoaAKjF
5234	payment	1726	1726	1874	1	1	208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoSEssgRgFVMTmhQzAk1RP1Uq6NZFWreoJmYZCZX8MhFBLobj
5235	payment	1397	1397	1678	1	1	4347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KLQ8momuQduPL7c4MepcV7rJ3MkxBnQ4Bqdto2H2TNB5QuH7
5240	payment	1397	1397	1678	1	1	4350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3s8JK8pwSWs8B6eikPnvRYbsooZFjLwmCb66AbAC4QbKLZfB
5241	payment	1726	1726	1874	1	1	211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNF7eEHM3aJeLfyBzQzrftg8ttQvSyfF5Gd4opzZV9d47Bb8P
5255	payment	1726	1726	1874	1	1	218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoSVG6KYXUsXbsaqedkT6XadFy7cmGp3QhnYiggjCCikvoRDX
5256	payment	1397	1397	1678	1	1	4357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEHnX5UfT4Wwt4ZzqWSNbWQy2zvgjcxvtwobiQq85ut93vxnA
5236	payment	1726	1726	1874	1	1	209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEBNLNpSnrmdKJNNBxTRmi59f7Cfyy2ShddYUWJLnei8gCs6v
5237	payment	1397	1397	1678	1	1	4348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeZ7hqq2b8xeZPpjhUvL7aAQp1ohf4k2DXJRCP4yVKvFwUAYs
5252	payment	1726	1726	1874	1	1	215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDwjpjq3UJFXLXXFobt6fH1WGPowzhF2mdYQXcSvJ6YYEkoSr
5253	payment	1726	1726	1874	1	1	216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbizGAUZh5vjcB2pAzAjd3drhk6gAMaZoxxw3PpKjFgpMqYDHp
5254	payment	1726	1726	1874	1	1	217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfqzqWKTVWiWrZXjCGJxBZo8e7yK2vnWkj2nNcuYrSmvDDXavz
5261	payment	1726	1726	1874	1	1	221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxE9wceZncDwaHgDPbGJe6smKbgumBNusWMJbUKohPmeu26Ls
5262	payment	1397	1397	1678	1	1	4360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tkMhGqdYtjDC8NhSL2Su4B4FhdECtthqF9au5Q6Api82gLEA
5269	payment	1397	1397	1678	1	1	4364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPx2MmsCTF6FUFr2QfZQp5UEcfC1B1YTz7tByCDBUaqEisTrU
5270	payment	1397	1397	1678	1	1	4365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZni5FVGb7USYXMpgG6e7d46fq8pveypYB1xpYYuZNSw3HAuPd
5271	payment	1726	1726	1874	1	1	225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpyatrWRs9F1CPShpZu7VY5w278N8VGMTyaT7dE7Ycs2SvKPM
5272	payment	1726	1726	1874	1	1	226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wWxZGvH37beY4CrTHZF9N1AtbL9WwtFgEKg1Gmwp9wbdRVTq
5287	payment	1726	1726	1874	1	1	234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwT4ugaFJt4scvHQMXKmo2BC7KCmVgTbZVDgmL2NL2ePMYz1cV
5288	payment	1397	1397	1678	1	1	4373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhssiGMeD2nMANC3CiRCnBCkpXVrEVP4hjdTcABwnQRcxUt4f
5293	payment	1397	1397	1678	1	1	4376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLq9HafESHtiyUkWCPGzes5EB31cT3b9iaEtcsiiJnTSjz6at
5294	payment	1726	1726	1874	1	1	237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmcwkJpRsd2YgY5onjWKwQ4UbFMAThGZ3mtEteLFpGjp6EnA2
5295	payment	1397	1397	1678	1	1	4377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWkPtKSoVMmaPuc6TvZHoi7pcW2dohZjdm6ctL4Jcr8HRj52K
5296	payment	1726	1726	1874	1	1	238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx83Tm5yyVguxvJQQWyoTuhgGVDaeRCpczhh4RmEJQc2vvXvkZ
5303	payment	1397	1397	1678	1	1	4381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUtRny6jF5zdX8aE8aWJ3zcMXNCwftz46pQXLryTmL9DPBGjp
5304	payment	1726	1726	1874	1	1	242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpbASJ85sFx6PnDbKSYQahTHFY629c7zeXooTiW6AszTR8qcsK
5311	payment	1726	1726	1874	1	1	246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYE63uRwYqNqtmuhSxFqbXEoWVRvSrxszzDoc9pBZ9UQvpmoy5
5312	payment	1397	1397	1678	1	1	4385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz1iz7WWCYw6r4nUwZnZYjKbGsWwRg5yMDcxuHjVruHjkrMzL
5319	payment	1726	1726	1874	1	1	250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4WKgyoPAZD7nCSbVWQp3xr8qoCDxpCpeZZwP7L9sYN7xTL9y
5320	payment	1397	1397	1678	1	1	4389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XPL6CUA4F4DEQa6jSCFuZcPgHSZGqEMuTdoYEMDxAXZ4Ad1b
5327	payment	1397	1397	1678	1	1	4393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPkeeSUE3HXPhpMe6WN2b9eDP54to6PZ46tNoucYjtvkHh5ie
5328	payment	1726	1726	1874	1	1	254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ETw7ULRE5oQkvERVo71fWcxsYoXzndaKpK49UjrGvxizr9Ag
5341	payment	1798	1798	1726	1	1	2	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpYnTXxRTnXb6RQxxZsz2nAf4Mn6vkg49SKFvqaEsmB4TJ52t1mz
5342	payment	1798	1798	1726	1	1	3	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpYtaSKZCB3h62hR4VJfCjjqtP3qvHGZPk7ZZrnPDmy4KaPMykru
5343	payment	1798	1798	1726	1	1	4	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpZQC79qTLeYkN8We8cys175am4FcyuNbo45tTKfoTi525UMFdbq
5344	payment	1798	1798	1726	1	1	5	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	Ckpa1KVCT2PQWihZrGP1YwAzp8Ri2b1rd85mxgtEJzESbCrpv8CYa
5345	payment	1798	1798	1726	1	1	6	1000000	1000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpZnvR81win9aFYmG6SMvC1Fo9Jjh4oWX4RJTeKAVrXpaANS3th2
5358	payment	1726	1726	1874	1	1	266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9Web18C3a3A8ErVjZCRmXHU2sbd5SfFLTkHu4ZFQDFBhbSpL
5359	payment	1397	1397	1678	1	1	4405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6FfQaNiP83NnWZjvsDS5ginKVLL76P4eLQn7JfWwcJxKZf3w
5372	payment	1726	1726	1874	1	1	273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw14ZYXg2XPciT739yHgXXPVKdSY85XW1mGokTvEnVaxrmZt1f
5373	payment	1726	1726	1874	1	1	274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKHobSsyqrEV92eB1dJDpXEBffNwzAWZMVxCM2vs9N4p9waMM
5374	payment	1397	1397	1678	1	1	4412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9MEyYxxXPnbrpdnzXFS6ZGtDWu1mNHAUoASnDb8NYKMBgsWq
5375	payment	1397	1397	1678	1	1	4413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Qq1a11sF7P14Pz1UaVdhkvSAby486vohrCh8LKWb6nS3WP6e
5390	payment	1726	1726	1874	1	1	282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95ZL1A7mF6F6nai4kKob3u2Ev6RFY9UzqtbG4T3xoMQvewi1W
5391	payment	1397	1397	1678	1	1	4421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5X2TY29y2MKH5EHSoZQ281BBdxPVMjaH6RJrBM1zC88EoP7PU
5245	payment	1397	1397	1678	1	1	4353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeni5LLPGuyaEUm6VVCPenxZT4mnEVWpK5rXjboferWJJ1xDv
5246	payment	1726	1726	1874	1	1	213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVTkpsMoYxX6e54T3RtMVbQH9eFYcmyDXGnNhJvLPjNA34FB2
5247	payment	1726	1726	1874	1	1	214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenD7pS5TTjTzwZ4xF3rEgHSEUhCFZQiQwx6VGgKb2a88UKLLv
5248	payment	1397	1397	1678	1	1	4354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomghvqgiXNDTMHt3pRJJJxDGRQWxYdGHMiwzimgaweg99LuF3
5249	payment	1397	1397	1678	1	1	4355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgtPdiQC3iLVCwUjQKVUDxKaZrX6RntfYUaexFeMXbhsB97E3
5250	payment	1397	1397	1678	1	1	4356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8VepcxaxFkg2PC5G9qYK4bhevaCX9BHUPxWHmwBwHuyen6x1
5251	payment	606	606	1295	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEftpmxuNosQBu24ZruivycfvGi85JcFkR5QtV5oxamZFUW1SM
5275	payment	1726	1726	1874	1	1	228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkRV7xFYzVScY79hTySeT4BzVPPsz9Yah6eEUgPLUkWdfHVk7
5276	payment	1726	1726	1874	1	1	229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTCW46pGE5LEKoBiYPHLpKmupk9XCw1aXbY569xCCsThfnudq
5277	payment	1397	1397	1678	1	1	4367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fuAWg4AX3E2tcgizJjW8pKR1Uq46gJWaFFM57Mv2dA4QP2p8
5278	payment	1397	1397	1678	1	1	4368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5LfuQiLiG6JbPQ6Gbkg1RGpshqhsyeECuQ8jCWnjE1EoGrxv
5285	payment	1397	1397	1678	1	1	4372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26mSRx6RvaDCsKQxSzJhbL9UhiudLRfSYLQhpci4Y45eFtraf
5286	payment	1726	1726	1874	1	1	233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLR9EerypemjMEzSHvxrFiFQxYRnVbtommQsAW7S6DPCULj4Kc
5297	payment	1397	1397	1678	1	1	4378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHRWKYhxqMYtHCNJajEnxTq5RZt3XRaZGeaMyqWuTifp7DdZQ
5298	payment	1397	1397	1678	1	1	4379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrB8RzoKWu3FXkVzquq9XVecsZFgPwhNx7RRHs5YihpLyYnhT
5299	payment	1397	1397	1678	1	1	4380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAXgQuZuZMnhLzxQayh5TQq8SU1PjsaVbfWSth5BPJYgGaEaq
5300	payment	1726	1726	1874	1	1	239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWz29G2uPiVEaELwuQa9He9x8PQNJhtzbALeBcpCcSBP9otPf
5301	payment	1726	1726	1874	1	1	240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6gaELRj3QxiE1E7snbNbMpEqdMBje61CMkCBN1r6AcMYDY3i
5302	payment	1726	1726	1874	1	1	241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWMqoMkH1ppgSfB24VA5fU9UwSHac5Z4VRVXWGzJVfWpp19z1
5309	payment	1726	1726	1874	1	1	245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn96t2qRv1KA1YG9q9MySsemgx2Wtk1tESn4dmmDMQsCfvQ3iQ
5310	payment	1397	1397	1678	1	1	4384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxyKQh9FqmRYRLbPpLXaJBLDjD8bfT4GoUtBZHq8xEpS9KM1c
5317	payment	1726	1726	1874	1	1	249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTqBgjcpG6oHSeHe6fDaFQkPUdmxacvytb5hGDXc6cwZnb6FJ
5318	payment	1397	1397	1678	1	1	4388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLLrcbtYBHpBfNXLNzEkjXnNHtNm5yQh6oNxNQJqGwMc2bPZt
5325	payment	1397	1397	1678	1	1	4392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcWcbusKitKyAcAeSSPm4E8n1PJfF9RjXVyB84E43cY1cDZNBY
5326	payment	1726	1726	1874	1	1	253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5qHBoL9VXU3tB6sUWxHJWFS2g8YigpK6zqxs8hmSeJtuKGNnn
5334	payment	1397	1397	1678	1	1	4396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHhr5oxS7nGJPhy9BZj1ADhSBvEuyqJMbb25v79MdrWWBuFKA
5335	payment	1798	1798	1726	1	1	1	10000000	10000000	\N	E4YbHJUjWNWKBURfKE7m2gBKw8EZXiB2joKbMnn6DWQUoDG8rgm15	CkpYi56frFqnyoRBYxBK4W869mRQX7gyBdMapaFVTb2S4Z1TEK56N
5336	payment	1726	1726	1874	1	1	257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYje5d2myUqeXGXe4gSTXGtHfJho9pkE9yLKE85eYBtsMZsYimd
5356	payment	1726	1726	1874	1	1	265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPPL2cLf27gMa8bTk2ys5BHC7DqnCieehp2sNBWE27R7F6wYR
5357	payment	1397	1397	1678	1	1	4404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2hyTxaYE3aAkWXBCbJqeB4WrSPMZ89xorsYmxGs8t7axgVJ4
5380	payment	1726	1726	1874	1	1	277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ714JnuCwZnXZNDYNUZiwz7Mxds9BhYE892JpADeYLB4LvCDit
5381	payment	1726	1726	1874	1	1	278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoemxAvHRjT7jWnNVWtLZm5MVkXgVE5GUvjVqvbfbjzMFbNxZU
5382	payment	1397	1397	1678	1	1	4416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VEYbqLb6iBuo7JdMZWyZbED4Hn5xgKX6AcnZYH8TANe6UCzE
5383	payment	1397	1397	1678	1	1	4417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVUxesMwmhcytwJiCejjNPAA76y36bzUhznFY39f5df5bzZNa
5384	payment	1726	1726	1874	1	1	279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQs25cXPGThBh8bwm8mWsF4ufj1Wha9oUdYgn3jiAH7tQU1DcZ
5385	payment	1726	1726	1874	1	1	280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MR6XJeBUzRM81EvqqrnDEY1b62YYh13jMDynWVAafccM4Nf7
5386	payment	1726	1726	1874	1	1	281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYif9mHXavYge8ms39XMqcZ9DU91tJ9Uqwn8gQV6QJ2s8mhHTnn
5387	payment	1397	1397	1678	1	1	4418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerqfhyW6wXQxwUEyt9yVNbTWJvmxND3doSiNAAhc2gxspektu
5257	payment	1397	1397	1678	1	1	4358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoZbHMD2WtsGRyimcnKoLC6VPh4jMfSdjgDkx5eW4LqCxroZY
5258	payment	1726	1726	1874	1	1	219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr28ivXyvYU9G58wFgF2bX3oZH3tNiycHgjebxg1eXm3PmMeqv
5259	payment	1397	1397	1678	1	1	4359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttJ8bY8ujQY58Tajd1SFw8scDL2CYJahGKNuduVZiFF78ZZ1F
5260	payment	1726	1726	1874	1	1	220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1y82fao6jS87YKCHVpwy9J7UjNvbBkhx2qhaZk2YJoCA3ibV
5263	payment	1726	1726	1874	1	1	222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9GMDyeYdLh1qqAT6cV9p3kSEvRH5H2TrhdBJWgZcTtvx69SX
5264	payment	1397	1397	1678	1	1	4361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEA3uyZ8KUNMDUFC6w1sW7P7CaChbZnukdrg1qCVmuL6xjKAXP
5265	payment	1397	1397	1678	1	1	4362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVKpQxfeZgrNRrZ6RHY8KgVXeUFm43psuJNvhDuc9JfPFrQFV
5266	payment	1397	1397	1678	1	1	4363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4hZsVMnx4QzzGQYkLR6tp7a6LTevZZtK9MygYHaWo6dGDbbn
5267	payment	1726	1726	1874	1	1	223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCD6fnT3a5QuEZCXVu6xcQisW4s2RRMEQrfiWMchGvFSgPqt9
5268	payment	1726	1726	1874	1	1	224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcLfn8ZTVfwHbHhPUF7gppPZDkdAHxrbGTS6Rhe4RWyeemYEe
5279	payment	1397	1397	1678	1	1	4369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbid1c7rRTYZ8MpF794wVScQbTmrnR8tgUJ9T27bJyE9wvad3W
5280	payment	1397	1397	1678	1	1	4370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnJTQ8nvnn1KRVhVuqdBLGVaCEVyvSusRC2rQbFop4sDALc9E
5281	payment	1726	1726	1874	1	1	230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHviAVh3stStDK4ad7fYTrXG9iz2qe541BLTnjo9tvSVcuWno5
5282	payment	1726	1726	1874	1	1	231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuP2yDk1AfkdEgDehQimJYCjio18EuWFNtnHisSk5J2Lts2keH
5289	payment	1726	1726	1874	1	1	235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VCHtabUciZJqBMiQFezYeNWshnPL8EugHww31rP7MSoVkoqq
5290	payment	1726	1726	1874	1	1	236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfQS78Bc2DQP1F6MpTsYXFE1JKiXWGzuwzN9FxZJPhmXex68u
5291	payment	1397	1397	1678	1	1	4374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19dpXv2kgebjEFXJLX4ih9w4AsgMxMM3figKT9r5sThYy1UY7
5292	payment	1397	1397	1678	1	1	4375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEf9zPuVafTiV9K3o7tZLNwyZWUBEQveFvtJMqFrbjQnebU9qK
5305	payment	1726	1726	1874	1	1	243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBakPX5dbYKEEUGMJyXsH3crauzFqBwcApvaYCXkyFEpCWXHu
5306	payment	1397	1397	1678	1	1	4382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQEBXKh5R95Ht4Fs5Z4DD2bfsXD16w63hGpygsUbCzuQemjp7
5337	payment	1397	1397	1678	1	1	4397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxqUdYbKghPxAg6BGpNx4QRY4tywwrGLVB9vfRfNAZatip1RQ
5338	payment	1397	1397	1678	1	1	4398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNorr2nXphRaLEi2sZk9e9RnWhJbdJerWP88Rkg78AXFhxfec
5339	payment	1726	1726	1874	1	1	258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMGbqHjsAHS49mXxWXgNBhm3rCv4jJZxxVP2CQAUSHUw9WPJA
5340	payment	1726	1726	1874	1	1	259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWHe8pUz4azZSbymRdDbv3SxZnnYt1rsbgmSbnCssrZAmiVde
5352	payment	1726	1726	1874	1	1	263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokCgA7sy55is2w3WtJdYGX7CRr8imnE2cijVY5Hbmw3mvuQq4
5353	payment	1726	1726	1874	1	1	264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaGRtNbrjxBBmrsbwWXgQ1ws4gTeiM1yBpiLgPCQDoNoA8g9P
5354	payment	1397	1397	1678	1	1	4402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdNmbY9bFecwCq1ysQ8SYDuvrL4ZF5FTSCPQFTJPtsgcJA8Zs
5355	payment	1397	1397	1678	1	1	4403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfTg8gpoc7eQHgE2Ge8cBJbe7Jro1n8TRtefYEgyZgM7TCTR5
5360	payment	1397	1397	1678	1	1	4406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL929qFijcPCAdFPqFVDMXghChqB3Y9QbwWboggN6bHdQCEBdh
5361	payment	1726	1726	1874	1	1	267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4C6UjdzFHhr3aLcyfwmEpiCoGGPUoJDLa6HLAeD1ToSwcAxPo
5362	payment	1397	1397	1678	1	1	4407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhpZ1BTXKLRKh9crZEBaHppS99JKptxLzXuFDeG6GRGdnhCwQ
5363	payment	1397	1397	1678	1	1	4408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiuVfaEvkdDCPHdnCQoeJcLkVofVLAg6KtgT8XyyvTPdeZrrVr
5364	payment	1397	1397	1678	1	1	4409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrY8Kc9vipAQPeFY6drhDZjSREa6BrLyz2Hy9RsWchuKvwyanY
5365	payment	1726	1726	1874	1	1	268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa37CgmaiHrLJ24vGZKKVw7waDqZ8xsafRqkNEyHAiNuPLgA7uY
5366	payment	1726	1726	1874	1	1	269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF85K1MHsTayfpD7N7aL6dE2CndqR8edKD5ArPv4daTV1XobD5
5367	payment	1726	1726	1874	1	1	270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr17e3anm9P91jkTMXcLABMvXGe9wQs8KrHVaJqcjvfSzzpcj4
5376	payment	1397	1397	1678	1	1	4414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uMz6cicuBMXg4kmC4hR18bfLdNzfNUQqTMoERcvjMEpwEFaQ
5377	payment	1726	1726	1874	1	1	275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7TPHMWdKZB5PCALiyUztqGta17sshNzDBTevZGEM2epLPAk2
5274	payment	1397	1397	1678	1	1	4366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqs1tYL7LwZFsBL9sagtAiCjokwnrFpLj5AWSdY22NJGTxeETt
5283	payment	1726	1726	1874	1	1	232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxUb8Ey4dHdQqq1auqR2MCT91FYc9bduw19C5BKB1jW61Wbhy
5284	payment	1397	1397	1678	1	1	4371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmV9FBRgebtGZqNtqgWvWoZ1SaK35J53k6ULaQj5RioMxmpYK
5307	payment	1726	1726	1874	1	1	244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDVLLqVvo9pETr3YKwsCydc4T6DPD8CDosVPdnTL6wA49gVAa
5308	payment	1397	1397	1678	1	1	4383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUDgwAR4auC8UkAvnvoLKA6fB9J2hDFpszF1QNqE1sNRxPTMH
5313	payment	1397	1397	1678	1	1	4386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdt93JHqLW9yy9q5Tcn2CJnoDV5g1wmvSqyeH1EmVQYr2vp9Eh
5314	payment	1397	1397	1678	1	1	4387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgW8RjB1ReVeZjNFcSiKSVvtupF4WNC8madxsiFD43Wxaduvf
5315	payment	1726	1726	1874	1	1	247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ42LSsvyhXeve5F5rFg1j81sSFiJTXshYFaGMWAVhgZV3pd9g
5316	payment	1726	1726	1874	1	1	248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFa4X7qkmzh452eqnmiHmEyZucTX7K1rB8wDmf3LY2zC6uJYP
5321	payment	1726	1726	1874	1	1	251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7WMTswAuLy72KyD122MNDozdnpjq9wyXFaGkUTQ8S9R8PB4c
5322	payment	1726	1726	1874	1	1	252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmWuRihsQidnt7iRP1vcCriXMetu4JeJ2MAoLtkMruxZVvmJ2
5323	payment	1397	1397	1678	1	1	4390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32U35HWVrxrUYBgj7yDUSAwZdip2xfKapAa9kfcDqpKTYJiE4
5324	payment	1397	1397	1678	1	1	4391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKCwPmrq2o5T1a4KFGRSTSPPGL2CpKygoaxRZkpnwikTXm4mS
5329	payment	1798	1798	1726	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykEnN9BoBKpcK6hQhQektheMeCgPaz6Zg6mEdGrzn9NKDAeeH
5330	payment	1726	1726	1874	1	1	255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VFrP1EeKUnYZYHbGZxNmUsTPAXsYXkeesZAq3trB4uJrENGb
5331	payment	1726	1726	1874	1	1	256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kNAcAyRsKko3g4iLd3588pZu8ZcbZdViQkWMsseP5Bn9Cwrz
5332	payment	1397	1397	1678	1	1	4394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5vZAGbT7F3t7Tco2f7D13mxEUjBiDwn3NmCQg7nXVUPBid7P
5333	payment	1397	1397	1678	1	1	4395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqiPZ1XDwRwqDLdTFJtgH9vAkAfAHNWfLCzASUoHoSSfnTFCx
5346	payment	1726	1726	1874	1	1	260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqa5YEjyh19ZfWycnUXEYz46yVNtsW6QdsSq93emz7XFKBz9C
5347	payment	1726	1726	1874	1	1	261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCX9NpCPTb8cVZKjeRHaBmq6Z8b2gXCihLigfyaHgCuM2BJdBN
5348	payment	1726	1726	1874	1	1	262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHJZLGPN21qg3TBQJxi9qSdL5cxfFTfSBamcCGnyogi49nnsh
5349	payment	1397	1397	1678	1	1	4399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxiqmGf7xvqGJJZdpruD9uUuec6TnzTniEcQtqTPsaupUg7Kv
5350	payment	1397	1397	1678	1	1	4400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaN4zkmN7L2DapFmVa53DuutqK3oN9VYxpgFtgu2M5N1FThzd
5351	payment	1397	1397	1678	1	1	4401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PGi7Zup1deAq4Q4NW8zRimtcQRd72Ce2aBknHnrEXYuDF1YZ
5368	payment	1726	1726	1874	1	1	271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSKomDLCzDteBQn4mmwVYGXSMJjWJeuFmLRDZtMx4rKLHMS9Q
5369	payment	1726	1726	1874	1	1	272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpM9iNt6QC1q6ZfMv4dUurBJoebM3qb8S1nmdNnwUtUZ1eAK7h
5370	payment	1397	1397	1678	1	1	4410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41ByVpnH1xRJWH5sKt1sPf4hBc99hYNCHapszfM8HJegfwDxK
5371	payment	1397	1397	1678	1	1	4411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHFz93U2832nsFekNjb6YR5KNL9HAB21CB8UWS7K8sp4EgTDTg
5378	payment	1726	1726	1874	1	1	276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxoSJf9qAjVkPSPMYQrFDNuczN9wNB9NETEeuH1eEQFTztvTa
5379	payment	1397	1397	1678	1	1	4415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxtBPE3NMxy8ijqNDwuz7ig2cVCDp4ZEdJif8YKRT5V6F8qAT
5400	payment	1397	1397	1678	1	1	4426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty5dTToyjMq7op3TfGs6Mqvj8wvdwXBFsuwMrmGKRRcTRwjdk
5401	payment	1726	1726	1874	1	1	287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLBzmDcnTEGmcMgWga4P5cCp6bELfXhHf9nyw37zDzNJdfmMM
5408	payment	1726	1726	1874	1	1	291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbs7m2Ri1674NjKSBYN6ms7YLA7KvAXCzT32Bhfi2m4vqDDnT
5409	payment	1397	1397	1678	1	1	4430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4iZaUVZeo8LrpjyqaGT2PBKmugQtsYs5daVbXat1qwe31u65o
5410	payment	1397	1397	1678	1	1	4431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpw4tJfUvaysJeFMUigDsJzYokHFwWQenJYh37c5CF9urNKCLk
5411	payment	1726	1726	1874	1	1	292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnLwdUNoUxHuAP5hiTfk6VoiCaUYRfeuYFwWyJEBsF7UvoheX
5432	payment	1726	1726	1874	1	1	303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPzxT57SvdeRfhx8vZoYJAmM9CkE8WQ6H8qsKxr8JDVfri4PE
5433	payment	1397	1397	1678	1	1	4442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4wHUP7fDTaLLMxjrxPXeaGVHRn6d6ZfFmTkpezkepv9srHWY
5388	payment	1397	1397	1678	1	1	4419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYyq4ZScUD3L5w2FMeE5Ex3qqdZC6QiSVqo2jrVHc8m7Ljugi
5389	payment	1397	1397	1678	1	1	4420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJV6HzkRLUB5ZarKW1Erpt2gFqwZwohS87b6kexQ4sVPMxCCqh
5392	payment	1397	1397	1678	1	1	4422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnGLPEswAACA9J3Db12qqa3pb35je9m29vRQYcs3SoXoASv6b
5393	payment	1397	1397	1678	1	1	4423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUSYVkub1UX5jJVJb5QGw5g95mCdrVuq4EVKydH6phHLkdVP1
5394	payment	1397	1397	1678	1	1	4424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkKWjYebnnz62qfRSZ6rKFZNsN9vtn3f61LLGKTJPmxa9xRM2
5395	payment	1726	1726	1874	1	1	283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7BcskJMmNaiqD2UTeP9bpv1XAE2u7QUKQMLjdDnGkk52LY64
5396	payment	1726	1726	1874	1	1	284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqf5qvNgWfTDLLbYcLc3GmfoeLb2AchLfZDcSABj1voUriwxxu
5397	payment	1726	1726	1874	1	1	285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17NxjrFcP91CWcx1LScAY2w2qMxZdBVsCUrcvi4rJ7Xvv6JcS
5406	payment	1726	1726	1874	1	1	290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjgHj9hEsRp9a6nB9YQKcTFPHfUDKgktQLDg6ZkjYoRiKxr4w
5407	payment	1397	1397	1678	1	1	4429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jRTjvRMCkVQ5NGo3rPHkRPNZB9gwvGejwUjBDUGmnXT5inQj
5412	payment	1397	1397	1678	1	1	4432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRxpxnVaCRdAGwwwBptZp6KetRs9pZ7P46VDvBP1gfsL1s81U
5413	payment	1726	1726	1874	1	1	293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz86vzJ4VyEbL3VZa6XDZGF5ZuBM9KVUePVNZBLBuyDzCNMcrv
5430	payment	1397	1397	1678	1	1	4441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQpDLvpCzH4KMn4iHytNQKknwWJFj1V5PkAjAyuQfDmwsdq4q
5431	payment	1726	1726	1874	1	1	302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9Cb72skTUqKRdKY8B9braENCyqcsBUanS7nQmvLz8YHQ3siY
5436	payment	1726	1726	1874	1	1	305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDnLFGLxUSmmsy3TCFtomjTYHw2KEGnhksqD9cSmKhvNTFsVy
5437	payment	1726	1726	1874	1	1	306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9muryEDkXQiyWdhqBL7VNNXqLHUeHuuBHu1GMSvUYEzMKkhJ
5438	payment	1397	1397	1678	1	1	4444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjUGrLB92g4JkjQCPyQJ4dkURpvVfRico9y91AdbMwfRpLxd1
5439	payment	1397	1397	1678	1	1	4445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLSd4Md3UMKJ72u57VzrBxenCfixt22d3pQNsbz9dt5fDhsEW
5444	payment	1726	1726	1874	1	1	309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZms7rsGxshcWyzCKBZswHkqTAg5MRTevgnxAcnYKT9cc6QyimV
5445	payment	1397	1397	1678	1	1	4448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rGNhPBft16b6F26UYFNkudxQ6HTsRahdbPW8HL7DVthBmZp1
5446	payment	1726	1726	1874	1	1	310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4WgzF2cRniiVZwxiiJuVNz4wGvAMnazViMyJzNqyXK1Usi2QN
5447	payment	1397	1397	1678	1	1	4449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vUaqDiXcd483NEBKxDPVub7Ym4QF55z2vk5fNmEVX96S7EAZ
5452	payment	1397	1397	1678	1	1	4452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUymvEEPFjD9V5TxSjAvFrqMwEmPAW7mn58Kw8A7ws5wWWrCoy
5453	payment	1726	1726	1874	1	1	313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbC1E3cMf8hN1uGenRUXf81bxcWJiyGikToMSp4oL7DxM3QPv
5462	payment	1726	1726	1874	1	1	318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhX8wCA8eoxwKku4jkgo1DsxhNJoKw6qv7i8mhybbngB5EU23f
5463	payment	1397	1397	1678	1	1	4457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybyJaMF1zVdwGLTCLHdocvxMaXN8UDzSZJUFZp987XvByZ5sG
5470	payment	1726	1726	1874	1	1	322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPJ48whnBqD1PrvJ5gDm9YNSBQs1AUNhtxi371XiwGtsPk7qn
5471	payment	1397	1397	1678	1	1	4461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NWoKsLJyzC9PAJZdGwTzvtXPAE86buNbwoAxazNSLMyNd1Be
5472	payment	1726	1726	1874	1	1	323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBQvaxNdYkgfywFFHEg6u4AXd1VhJx3kvSXkiZ9BQK7Ba9L1B
5473	payment	1726	1726	1874	1	1	324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJB3gyonLCm4i3wfKSjbSzTg8XtoidL4QXupvWR5it3JVd8ai
5474	payment	1726	1726	1874	1	1	325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEiYqNQxhLhcSpktbTgL9q8xnDD4nY7hRbYnHwcFojSvf1g2RX
5475	payment	1397	1397	1678	1	1	4462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa35RHqvBcGLX9ZeRxjSbE86a9gWVQzyRReoiCEAQQepj5ss2Ch
5476	payment	1397	1397	1678	1	1	4463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2k2Lv9yvgywAewSUszW2k2DGTEW1sLRveABZdGVXdoYJvPaGJ
5477	payment	1397	1397	1678	1	1	4464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSM9ZxLRryErhZnhVUrk7DZfZMcG3KR3uaBU46mxsrE5M64yg2
5487	payment	1397	1397	1678	1	1	4468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgTUPCmeFw5ZAt8p2a7k8gbEEBfbuVpfjtQC6gnzXddcTX2DZ
5488	payment	1397	1397	1678	1	1	4469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gPiMvMASe2Qon9f9YXAWa1AXpYadS9ToiJjYbUP23za7GAcx
5489	payment	1726	1726	1874	1	1	332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtLqGHAeGXGyBimA3yyKEvjAd6EPoQY2CorUSSew13Voo9yx1
5490	payment	1726	1726	1874	1	1	333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg2BezQAV6Kowctnj3prav88oNABstySFsAKMayvr2YMwYotrk
5398	payment	1726	1726	1874	1	1	286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7tb2XoC33bWm3mvmxGnN6szQQs7cCHYTWS4jx9DTbevXeTw7
5399	payment	1397	1397	1678	1	1	4425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPngg8pvjXVaGpv2XpVYQiCDonh9oVP1KAKchufzJfioDjEahn
5404	payment	1726	1726	1874	1	1	289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3WLdVbdh1dLmd9mZnrtGXGaZHUz1eKGzwcSkH1uWv9dTXZJP
5405	payment	1397	1397	1678	1	1	4428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5Pqn2ndu9sk4usDV46GBkiHVjazLXpwEcwxKRFiF4cUNfAJZ
5418	payment	1397	1397	1678	1	1	4435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzh16jivKDBuRMkd37fLhFityeCRy2r8gckZeSdHDiGLtbFJz
5419	payment	1397	1397	1678	1	1	4436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXoQdzMFtvacUNLao7F1NEUdKUfrKJdwbE1RysSoThbb9tGUX
5420	payment	1726	1726	1874	1	1	296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTSVp8cYnDMLvrnATRA1ZQKCvouxysVVdZDzgmqZ16tAG3ceh
5421	payment	1726	1726	1874	1	1	297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLX8JWhf38L5LVtGREQ2vot6SWaZRQM9ftbvAQXgj8ATLQz8jM
5428	payment	1726	1726	1874	1	1	301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSuWDHogztQu65mShUKFihHY2o2QpPW4KxyYbEJnY9cucNU1h
5429	payment	1397	1397	1678	1	1	4440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVktfeRsTV4AY3g7pszSE9u7TLgE2V6bCRDFmZbUzFKcySQQd
5454	payment	1726	1726	1874	1	1	314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25W9KhxNBywC333u2kAk1NYTcTCdBnRjWfamAupMZ9YDu5uj9
5455	payment	1397	1397	1678	1	1	4453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoaitbSk1wLB1379Cx1wFCUkaKysAvXyVimGzfPtjuegpzBHr
5460	payment	1397	1397	1678	1	1	4456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSMVD6Zsab2LejoUfq1Q1jLXkQTS2aeFneNPzzLVbiXgaqcHZu
5461	payment	1726	1726	1874	1	1	317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4XFp2oFZGA7KHx2MLQzektgBQaJXi2GPq42KckYc38K1fdEB
5468	payment	1726	1726	1874	1	1	321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHopV9zHbywDCJzYotrARrNsjRddao8SJo2QWuyXcgWGfTdyxu
5469	payment	1397	1397	1678	1	1	4460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa8udSFW5KyDtWxfR8VY19hBrW44F5E6RWfRtupARAmrPEMrEE
5478	payment	1726	1726	1880	1	1	326	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYy3XbtMyUuSrFVQ5kVQcgt1o49jxMboq1sTgkUeyTvap6saX3y
5479	payment	1726	1726	1881	1	1	327	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaF2LtuVGGbF2docYJCuYhn8UEGY9DU95a4rYLExa86EHPRd2Tx
5480	payment	1397	1397	1678	1	1	4465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjRsV4w3p83jA86kteZihMT7RLoFSKoB1eiUCxCSVJ7EsEZoW
5481	payment	1726	1726	1874	1	1	328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ca2tAVY5dx3dWxtyFpQJmpywJv8fyUq9Hp2Fvq5FnXEAhuog
5482	payment	1726	1726	1882	1	1	329	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpxpKUoZZirj6ktc1qim1sPLVcN4gHQNQps2x88mSX9zTWnfBw
5495	payment	1397	1397	1678	1	1	4472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCG8YK5NY4CzzZktP3FGossxMhjFzpwqnrrGxphoLqneKFR9M
5496	payment	1726	1726	1874	1	1	336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWb1BWqKiNRoZDyYhUMxLkorZqbBTy4SFeWfjKqQGXHVTHuKk
5503	payment	1397	1397	1678	1	1	4476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2c28SntzWuE1HBaxBZEu55ij4wXYGopiaEgpQCqCRJoqWqugW
5504	payment	1726	1726	1874	1	1	340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrSJTFveqow6EeNZJXUSWrXBMHE7V9YUSEqgc4oKRmjCchRmM
5513	payment	1397	1397	1678	1	1	4481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc14nTDTzJoatgfBBPaC5xyRRQ8CNUFEDsNZsbeDjAafz49FZ
5514	payment	1726	1726	1874	1	1	345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFim52LsCx9wuJiMuJ1T8EmDqAWpwfPNrAGPk1tWDDVA9JRuYQ
5519	payment	1397	1397	1678	1	1	4484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnqW2XEZuRXuVoqG9e3wSEcomW3FAJ61JFGDToxTdtxuZqkRk
5520	payment	1726	1726	1874	1	1	348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2YAQogWw4bTjmrxcbSVWc4U61DDQMYMnVsdUZxmjNrBvp1Xn
5525	payment	1726	1726	1874	1	1	350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5JzuMHLSR5RRX8azVJEERUvKqA2mYdKsGRDTX9TKYjv9o4Yf
5526	payment	1726	1726	1885	1	1	351	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZor5iNscsZ7TWtKjpL3fC3nm6FA4vzr5S9hVdT9wpU5pcNVYfM
5527	payment	1397	1397	1678	1	1	4488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rvTrfkKAxVDJQCx39A6kXTu88grdzGTEDkzsYdbWy7gZfgAt
5528	payment	1726	1726	1874	1	1	352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHMa2zJX6cSjdqpB5WKBpZ4Kvdoxj9CwuXvpX58jjyw3mYyVy
5529	payment	1726	1726	1874	1	1	353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhqGbQbb3iyAfACza1FfveHpnQsKYN7LGs3T2nBJuwhC7AFaH
5530	payment	1726	1726	1874	1	1	354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZtSG93tLHfbdSPHxyD3c18nYzz8maMdMbAsdsvmYcvp29EnA
5535	payment	1397	1397	1678	1	1	4491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9A99iJMwpFvGEbiBT5iE8siqEzfACuShBdYNZ8VZFiSngFGkA
5543	payment	1726	1726	1874	1	1	361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUK1ZZaop6VPhN4ezrLvHK8RHda6tZETer8PDWdKXbU8j4iMG
5544	payment	1397	1397	1678	1	1	4495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuzbtAeqHDwNJWwKuRLYYJCmYKcGfVdALyevmfCMNFjRwxeqz
5402	payment	1726	1726	1874	1	1	288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwULUh5WEWYjw3bhcYhPEvUzCwC4WQFTkZ4YGVR6RPdmMLdvu
5403	payment	1397	1397	1678	1	1	4427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNNAx477swVx77vtNwKq4BHrZSYww5BYcG1vPqNMg2BBPveMj
5414	payment	1726	1726	1874	1	1	294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnoK9LbLxoFHCJ5PYup7PcWPggQdgo9fHrH6voJoaeHf5BdE1
5415	payment	1397	1397	1678	1	1	4433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBurGKU12V6EHWBPopg9Nqdjfmw9eWgGc8Ebc4h6XLjYUoDDy
5416	payment	1397	1397	1678	1	1	4434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRTDCk4LZNLCvA5oFcF7koPaveQfk1Qp5uBxyM6aySeoctHyh
5417	payment	1726	1726	1874	1	1	295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUk4cskKDmSZz2gdGBQoAnMTaW68dGL982Gnet6UTZJuTULfef
5422	payment	1397	1397	1678	1	1	4437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDTw38cy3TWfbfZ9oDtAtop1a4B6tUvVdFzAxEReoLRST5g4j
5423	payment	1726	1726	1874	1	1	298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJL4CuzY3G6PSVKhEJ5dWpVZt95JVgaPrGCsWB31J7XKfTa5R
5424	payment	1726	1726	1874	1	1	299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbQqULGQmcLp48NfX6xUXfAf6a2fA9i4qgDyLWevYtiiyDLgT
5425	payment	1397	1397	1678	1	1	4438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJNKKMmVBhF2drzHWUvvxzmE87AQHKQf2JUEQoFhrRFtmLmLb
5426	payment	1726	1726	1874	1	1	300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3SND1Uh1rReBtDg2A3sGLawpwXRjSHS3ujGs9o5i7D1jhRWH
5427	payment	1397	1397	1678	1	1	4439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXB9D7udZkUrFNpKAX8Zsb4CdsWZP6wEtb2EkpsiwBDjcP9Wq
5434	payment	1726	1726	1874	1	1	304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtnwncGwcaGAck9z8jmhuyvutbYz3JH1cvUFAK5BAq39GEJQM
5435	payment	1397	1397	1678	1	1	4443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCsaXJ8dmD6Rx1mWStbpnnV3GgaPV7oHfY5kZDrjkh9dJYvJC
5448	payment	1397	1397	1678	1	1	4450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaYZ9des8tVAJyKThQZFcPrz56wvoZWypyBxmzCJToxKGtH8a
5449	payment	1726	1726	1874	1	1	311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaVLKTCDNUGA65gQV1Zc4imcL8m5UVfBD77EDYag8Mi2rmjc8
5483	payment	1726	1726	1883	1	1	330	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwAucQoArV1zaZY3kXnS1CjzauHLBv9JjrHuoMpTG3x1rbN4W2
5484	payment	1397	1397	1678	1	1	4466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiucqDZBXExFafViGReRBaLZZRdEgydRicp456uKjgzH3CciT5
5485	payment	1726	1726	1874	1	1	331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dw2ZMwdDJi9J8WrhRaxMFA4cfmr8rGFG4y7PrVehYVdPWusp
5486	payment	1397	1397	1678	1	1	4467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkdXkjUrxvpEWZtAP6sCQKk8Dgxb1MV7MFv34AvBZGXSG9yaA
5499	payment	1726	1726	1874	1	1	338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMnh3t7DaQcM1HfCx22FgebBKPM9zKwYErtzvbYkfAcafjdJK
5500	payment	1397	1397	1678	1	1	4474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwiPMDjko62Qz5f3ZDppBBvxy2dDKkePNZQVDBA3tEbwJV8yf
5509	payment	1397	1397	1678	1	1	4479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEp66rKm4RdYxepT1Wswv5kt5xGoXT1Xh9iK2XhGyz4HYq8ct6
5510	payment	1397	1397	1678	1	1	4480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuncpJEjma2ixU2n7FS5k28dy3dsP3ZCVMqH7KdVafnoh3Win6
5511	payment	1726	1726	1874	1	1	343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hewz3kW2GvYgwgxr7Kb5uwmKy1YfaDcYP3dBs9Nziw54GigQ
5512	payment	1726	1726	1874	1	1	344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidGKVADc93J7T5RueEyMAvTcVBvdYiHAREdXiS3P3Ju1EtBid
5533	payment	1726	1726	1874	1	1	356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Dcr3tW5xteL6CmMEhsmR8eqaoaiEFNPdxjTkmBKodENKfmdH
5534	payment	1397	1397	1678	1	1	4490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2dNwixTm33fECd7bwRdMfrFyc3N2LGJE93yUVNHnULgtsGw3
5541	payment	1397	1397	1678	1	1	4494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Mpuef2k63NUAUWxjEh1HXYk39tij87SmQeVMjGQKH4CBcEXt
5542	payment	1726	1726	1874	1	1	360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxkfpJwLso4tgw4vny6d6zjuNYi6PFxWtNo6hdr1J5SdC58Ua
5566	payment	1726	1726	1874	1	1	374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22YGUruWkJCUQgL7GWELxmro3a4bCEpg1wJnfgh7FHeppGU4d
5567	payment	1397	1397	1678	1	1	4505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa64UWTaGfZXxGQJ9UHHoeR7NzXfPjJJX45jjKhH4xxonyHEVgq
5570	payment	1397	1397	1678	1	1	4507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXts1nn1Th5yKHPmUWMB6NqHAe7xts8t4DGivrHCWsGq2YiLi
5571	payment	1726	1726	1874	1	1	376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfPQUinpxrajW1J7N1x9XVkUsRFyeXLG5EdKf9CrULPzH57v4
5572	payment	1726	1726	1874	1	1	377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxGhh8ca2icdZdyajhGYCrDdfXiHL6GyxUDSAhJK1v9ipfT6a
5573	payment	1726	1726	1874	1	1	378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZin14m1vuBi6Bk4sUgekeBVT9roQ1qwTr2fKDVH697PDz2da18
5574	payment	1726	1726	1874	1	1	379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujthhBEt4ukHqfdh6cW9CLXkLEt6qZEN4E1Ssp9jxLBjHjsPM
5575	payment	1397	1397	1678	1	1	4508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdLgdt8gSegSo45AtKNKrXER9sbwLjag83M5V1dkMxCkZ2XjD
5440	payment	1397	1397	1678	1	1	4446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiW4njVRZQTou35VMJimBNjJvDkWNiLUSa5tw22n2E9YQocDqK
5441	payment	1726	1726	1874	1	1	307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvVwyZSVdBL1aHTkqsRvdbBnPs6hCMfFd92GD1ftFTL3oHjKK
5442	payment	1397	1397	1678	1	1	4447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe44CB4FURV84yRQxend2q928j2JvoSb5szT5b22fyTmQpzs1D
5443	payment	1726	1726	1874	1	1	308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLMG6xuuq1GNXey2XwCT7iZjsQYYbxQerTUKyc7dyDhFEXk2N
5450	payment	1726	1726	1874	1	1	312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEK77R5Hw3bHygzw9qGURaVkGA7KPa8RuhFY4yYMAbRPuPk32
5451	payment	1397	1397	1678	1	1	4451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dKaYaMHTmFGrLNJUx8oKqiZKHziFirGiXdVN7pf3sCxUFqzu
5456	payment	1397	1397	1678	1	1	4454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yHnvTgAgLrwb5T65SZcFkrgNzksRUB54FkRRdiAb4ocazJZ5
5457	payment	1726	1726	1874	1	1	315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLWJGoHeeMrnBVrg7x4rZ2Uwt3K8Rt7JWagFk8QamsPgUC1ty
5458	payment	1726	1726	1874	1	1	316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyu2y9ytWidatFfT1sEbzPuJovV2KCpmsDjo4RrpSrWj412msC
5459	payment	1397	1397	1678	1	1	4455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEg1mJ1Wehg2ZcZRoKPgJRW54Bi52hMXmWmqoMUNXuxU5tTTSB
5464	payment	1726	1726	1874	1	1	319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo78orCmvoapewBhq2wqyecyJynLbMdzwXcTiaJdEHaP5KDqAJ
5465	payment	1397	1397	1678	1	1	4458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BSiNoqgwvTqqipg6LpTFewPvPQJVLqUgQg2Uqh3MxdCWox6E
5466	payment	1397	1397	1678	1	1	4459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVYzyyL2XdAxW9B4g29NWY3nbLbu2ffeDUz51XktUu5ibHVZM
5467	payment	1726	1726	1874	1	1	320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfWPn4MyuQHAWVYcWcxc5TtUFGuF61NCN4qZuTVmLQ9xRiEkh
5491	payment	1726	1726	1874	1	1	334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9FgMTLke94Gdc9BeXhATHG6DjR5FpFJXfoiCVdqb8HPeuLzC
5492	payment	1397	1397	1678	1	1	4470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFW62kA1DoPZwip5Pvccb9qNyjPFf6t4Q6qCkNidtwxqhgsDTs
5493	payment	1726	1726	1874	1	1	335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHYZZLKv6v79TXsT86aERyCKARQdbuBgnKEeRafLDtahr4yDV
5494	payment	1397	1397	1678	1	1	4471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdSpe8TaiDbLDFyyvJPrVTH3bz5qoaXaM9vvzwMUfk1HiBKN9A
5501	payment	1726	1726	1874	1	1	339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtmjFVZew7JZbbfe7AhY15YtwHbidxm8AAysmmF63D5QgWBB2
5502	payment	1397	1397	1678	1	1	4475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8a3Dvs18U87J7WRE7zpTbjHjQRzQUphShP8GtuQ8fGYYgDALJ
5507	payment	1397	1397	1678	1	1	4478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3tVoAAvmtNQB286noKw4L3xpG6veP5EYWeGap2cXnUYNDCF5
5508	payment	1726	1726	1874	1	1	342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DbWxszYm7s24xLaPnP8vouV3J9JZttV3hfxoCCu1KjSCcFz4
5515	payment	1397	1397	1678	1	1	4482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtffvXtvDXUkpjGN6Kq3RTmESJcUAkhi6wkVNVr9V9pE2gQy3W
5516	payment	1397	1397	1678	1	1	4483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG45idzrPnvxSLVfeJSY2SWk15BygqMQWMqzyrNdZ9fob8JEt
5517	payment	1726	1726	1874	1	1	346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4ezVF2GBicQzvj22E1otLw1ngNipPXvvJjxxDGh3x3MqMxMz
5518	payment	1726	1726	1874	1	1	347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjGJHkbJmCCR8wUDiQCUoPg4YUQZmZnzAiZyjyNAEJoTFqtxs
5531	payment	1726	1726	1874	1	1	355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWGYSfu9t2xfve8wGBREzgmzA8i1ooFnGd9EZ5WP3dreas9ip
5532	payment	1397	1397	1678	1	1	4489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQSbvwCex1aMBrBWCrw6VQoAPRzaRYvxpXYWo1swHZy2jTzRq
5536	payment	1726	1726	1874	1	1	357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUyDkd9NSQXb5BbnkZ7KsXDycyAxcA21oNi4vLMmwHUDPRSdU
5537	payment	1726	1726	1874	1	1	358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoRNt1iPrnAYLsq6awczxEFcP56ii5uefK6dieXmJjWc7ExFy
5538	payment	1397	1397	1678	1	1	4492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZUXCCGEyrUxpC7jpXcKmHya7fhKJ9ZeSTKPPLhmNEYmqMoK4
5539	payment	1397	1397	1678	1	1	4493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4rN371upUTAYGs6GJhDBWD4mLz6EhvMbPHrBs7gGA5szitcZ7
5540	payment	1726	1726	1874	1	1	359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5a55ZNgmsJSi1QFXN4SfXzL3oRAdFGS8e4sd72BXjj2mrNNj
5549	payment	1726	1726	1874	1	1	365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxrNr41YWJn6arhzpsPqALqygsaMSfJWB3A9igH7yxUw8rXSZ
5550	payment	1726	1726	1874	1	1	366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2jzdKVPp2VftDZsaANsnVXk78RCe93nyPE1s1Si5pDfA6hPu
5551	payment	1397	1397	1678	1	1	4497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnrPkh1P6TzNf428mH5FZ6RsqXVcFwK7Y98WjXPNWVb2UNKh2
5552	payment	1397	1397	1678	1	1	4498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLtFQeWSWPUjCmzDrYUU51vZofZSSYWaJ92DwHATEAgtDfLnR
5558	payment	1397	1397	1678	1	1	4501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovEubtL7QVN2Pe3NPwF9v6gs8x73Sy9DYiZjN26GofsCrKBM3
5497	payment	1726	1726	1874	1	1	337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2d9voGi5UgFRke4vT7PvY5srHSD3Hws7RZarAfeUyDGhCiE2w
5498	payment	1397	1397	1678	1	1	4473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1P1fBftZVgiU4uJ78uA1Wrzn1hr5FmJZMjDCb4qMjtNYyHtpt
5505	payment	1726	1726	1874	1	1	341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatV9PwcSfFWobZnTGTq8WoyskKbp5cRn8qn13xdP7qiCGZJEg
5506	payment	1397	1397	1678	1	1	4477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqutzjt7FNzf2NeNfqcLkxM5K3Kma2S9vcB6xbihFaAWsHCVYA
5521	payment	1726	1726	1874	1	1	349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRtQ3vw6pr2pcJMzUNU125eVj7s2rHYHU3JVjFqwR2Ppsj1Piu
5522	payment	1397	1397	1678	1	1	4485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BQqxYajt9xpYXinXH5GoGYt6jTzmfN4xsxNVXeX4JnfXTGFi
5523	payment	1397	1397	1678	1	1	4486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETZQBTh3bMG1LyG9i9HFF2Rt7eZo7Bj7eMhfrJLbz4jtRGnxi
5524	payment	1397	1397	1678	1	1	4487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDAEZAGEuf3quaQAbUJUiim1jyVCKhQRy2RpdjwJyv93tbJDQ
5545	payment	1726	1726	1874	1	1	362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzwkL7va1XkuD4SaT4eSAw7uKJY9mCME4EEZj87cM7fcHTkTG
5546	payment	1726	1726	1886	1	1	363	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJJyXGRDLqqGfw21WdkWBneBWZqgsLj3tfaHJpK6rgqykgZ1MQ
5547	payment	1726	1726	1887	1	1	364	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYo6uTF39xGAAeK2qWNNJq13KsDNXuHkWukRnzNr8vS9wKfDxkb
5548	payment	1397	1397	1678	1	1	4496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHndJN1Nm8BvyKioPTTxCjntJQoQjTiMm3haiunKJEcES8gKt
5556	payment	1397	1397	1678	1	1	4500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMvZZBWr2uHFyx7m2nPr2vkyMkEKvKYEujEqL6MwAjzsMUria
5557	payment	1726	1726	1874	1	1	369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdewHfdgXFSiiUd9k2DWzgzwExhqdhJeezturbiP5JCC6cifD
5560	payment	1397	1397	1678	1	1	4502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZexU3GxUDkdfVw62cfqxGaBN4EJ1h1WjZPQB8pBwi8hiezJwk
5561	payment	1397	1397	1678	1	1	4503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDsG9H2tfkxfUbSefm23ZKRH1tB6ym3jdvRkTvqYT3SezY1Hf
5562	payment	1397	1397	1678	1	1	4504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBfp4hAnNagtJRtWgA3TcDkM3H6iz89yYRDhPebNfRB838bnV
5563	payment	1726	1726	1874	1	1	371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiUMZYMo8bzC3TubF8AAgDfwwMo6Uf53MMP5bzKi5nEZZQzAd
5564	payment	1726	1726	1874	1	1	372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Mor1fNhcS7XCh4fww4a7fxm9T3UnFTnM8iVcXVcBcfRgsTqk
5565	payment	1726	1726	1874	1	1	373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPH9rC7cUCgPZ93oJxwCdHBFpHgmKzQWyyFyU4ZCAPxhUNJSK
5578	payment	1726	1726	1874	1	1	380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoBauHEK5QYhjE5mbPe7EhmwnfuL5pUW8ZNd1Guu6TYYaaMYM
5579	payment	1397	1397	1678	1	1	4511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QuCcYYSfHbWouvXrs6LpNY3xk9JWvqov9wMFt1ruVA1g9pEr
5592	payment	1726	1726	1874	1	1	387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCQN1Nxr1n1fQ2C2a4eqk98QARgXymHpKvC1Mi5dKBwu6yGY5
5593	payment	1726	1726	1874	1	1	388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyC6a3cdG8hap5vmMLgkMUV8KDekiUy46vYmWgS8XXxgQ7cTH
5594	payment	1726	1726	1874	1	1	389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2uveEPEtuUXpRrYYz7cWjkZvQVXiEE8tHg9LyJDBm44MKHuF
5595	payment	1397	1397	1678	1	1	4518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRtogum6A8gdGYa3GBPtaL7jQKU7LNFTR9jxEbHwyb9Cj7hop
5596	payment	1397	1397	1678	1	1	4519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgEF9uT9rFVYmUnyPhcaj42s3J3XTmrKt9rHTuv6xwXHXzzFH
5597	payment	1397	1397	1678	1	1	4520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GUsUU9ULicVKncfLctRmyuYn9KWKhmh9jqLnwyj3T4XYgpRd
5600	payment	1397	1397	1678	1	1	4522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiasSLKjgrjQWgfnF84yraEojnBKtYoRTwdUXF4YEz7ubG6ZYR
5602	payment	1726	1726	1874	1	1	392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkwEYKHYdZMpzfMk1DzncVu4EZGyGqpmT8guj6FdoQMZQHbDuZ
5603	payment	1726	1726	1874	1	1	393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NC5F2Hkxs1GKHkJB1ccatToam39iHPeUNa5ygPPQfcDVVDCy
5604	payment	1397	1397	1678	1	1	4523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGsp6HLENiZubXERJ9CLqkPSMdM6ed1iH8BrR5JTn5mvujcXv
5605	payment	1397	1397	1678	1	1	4524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktbA557rGvoBoZit2ty2uzuZK6rZS9j3oEDP6Q8xozdeLeGyP
5606	payment	1885	1885	1889	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFqBnkuF4YgfB7DY36tBwZEVWA1x8PBw5xaJ5KFdVkqhuThYe
5607	payment	1726	1726	1874	1	1	394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZLzZgJfiKHuDUG7bft67TAuSu5H1cyfUtuqneU5ztG74ZXvE
5608	payment	1726	1726	1874	1	1	395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGYwFWhRk5JLsgTVuh2JHovFuFwzhMh1nXzaDavzbHx7d5EYU
5609	payment	1726	1726	1874	1	1	396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMrqxRkwDXo5y7P9BwH4cqjpGeztoDZKhFvDiBZ5bcKqubs1Q
5610	payment	1726	1726	1874	1	1	397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoR1thRvwBLPhmMUB3nWwTuvShJLAG4XYnXx7HPNZLs8SoiVZ
5553	payment	1397	1397	1678	1	1	4499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yhwrSrcwTrs3cQP3AvX3mdHBJ3AFGbcJ9ch4aVDSCZk2pSnJ
5554	payment	1726	1726	1874	1	1	367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tMwZoCxYNwW7ZJpzHAZD5vazvcLGhPSK3Jr5cBjTdcmoLNQb
5555	payment	1726	1726	1888	1	1	368	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpDqRm9LVAX6BwDcFuj414RGGxkwtFzbUPyx2dHLzL9fzj3oW8
5584	payment	1397	1397	1678	1	1	4514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFiFA4ehWBEEFxBUJdFnLJzedxfUh6bHL5ftatXSLh3HW8v7A
5585	payment	1397	1397	1678	1	1	4515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkW5UFJ8Rbk6GhLdkKigFQVnVcYfQ6fjfzaJQ5vQwRuoUh1r1
5586	payment	1726	1726	1874	1	1	383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJZuPc9xQaVxt5kQEQoytoSD3pBp9H4meVeQn3jx3LqZ7e41Z
5587	payment	1726	1726	1874	1	1	384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQn1gApKYFJRrJaEnVUrR8NQGsByJ2Po2zqeCJBkWEhTgY9Ck
5588	payment	1397	1397	1678	1	1	4516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5Ziz2merMGTA5ry9Z1DzQFeLEttrUBaD2JUnsKQAd2Xt3Mte
5589	payment	1726	1726	1874	1	1	385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLqjRQ3L5HRtrku81LfF712anETqjZfSEnkAWkAaiVKZx7Lvb
5619	payment	1397	1397	1678	1	1	4531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYswENUXZPvLkzi9MtTCnPUwe3HueTNQznX4ggVAAv4Mk1PVd
5620	payment	1397	1397	1678	1	1	4532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXmW5sF3smHp1BdrM15Pe9oYShhUySHX98trWgqq4guGuhKqn
5621	payment	1726	1726	1874	1	1	400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJNqun5qKAwo82bVqGft1gywm7r6SGAetksgy3UcD5yR1qa1z
5622	payment	1726	1726	1874	1	1	401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGihmuVdYpqHuoa3xy1TqkuuERUpY4xPsv8TzhtpgCujw1vhGd
5559	payment	1726	1726	1874	1	1	370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LjKbePzym7J6TbTrFEPWgbuKy8CASC2KfBxNP88M12KT6fhD
5568	payment	1726	1726	1874	1	1	375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxeehDreQKkkHUEQN2UuXFZevs3CqLgcsH9wVrtyBJAtYw7vE
5569	payment	1397	1397	1678	1	1	4506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjE3ia2ypHgcC8cMMyygZy2meGzfvLyHLb1qz18SUJXP9GtkCw
5582	payment	1726	1726	1874	1	1	382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wM8fVFvhceRFKXED5rgsTasiJW1QntuP3mEfPdPWT7ahduCJ
5583	payment	1397	1397	1678	1	1	4513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZcffufGxLHHbuYjFHW9JNtHmc9tA5i8YcqfcEaCbb7zMtZwt
5590	payment	1397	1397	1678	1	1	4517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyK513dC4gZoatZGmK3UmKg54dzJjKM4SNpnC5dHhdYkpZ86m
5591	payment	1726	1726	1874	1	1	386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKc8GRVP4m22jJvgSrWgji9PodZqFRfQV7RaE7y7Pm3Q9i2End
5599	payment	1726	1726	1874	1	1	390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6btftJVcQzoQSZZwXntTGD6cD5oTNxDzai4Twrctf3drFkCp
5601	payment	1726	1726	1874	1	1	391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAUTk5nwYy2dfq7JJEDCmruC8jreBpznSYs2nHT4k8cQcdfqH
5615	payment	1397	1397	1678	1	1	4529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbi4MGBRN8teUm8h8AgHMiBGYPxyN2bECASuYo2mfoFDMqEkDg
5616	payment	1726	1726	1874	1	1	398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkkJCY6oYHshBDRVu7jBRgWg5cGFBzjBrqkWY14LyyE25SARq
5617	payment	1397	1397	1678	1	1	4530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKLE38R1RHjGkcfPSq7pgrmeYtsu8dGkZLFYnCyeJUkTZKz98
5618	payment	1726	1726	1874	1	1	399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CaCCmqYB6az9SwpeUzeMQaWuodFMQQizxGTRcUFbwMoW1gYw
5576	payment	1397	1397	1678	1	1	4509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBscveWi7M9Pm5RJEMakAjYWPr885sLSof2d8KjSmepbGmJox
5577	payment	1397	1397	1678	1	1	4510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PhrrG3qpooGrvFi9DiFNG71Bh3oNXnTDmz94TsGGDJD1d6QR
5580	payment	1397	1397	1678	1	1	4512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkvHqg1NMVxxbmzeFu61t83rCQ6nPXLTs4c1k5JHbGXrZLvsB
5581	payment	1726	1726	1874	1	1	381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseYB1Rqy1UQejxK9Bek3WdQXQV47VjynhsqKfkWvjaArojv9c
5598	payment	1397	1397	1678	1	1	4521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS9gKhxrLXsbJzdKhwMWJz5FnY7bzPfLNhjYe4ma9C1EwTeqM
5611	payment	1397	1397	1678	1	1	4525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGNNBGWhr4QUJmGsxhzPP7drcQRX9JjigJ7qFTYv94WKdnmLZ
5612	payment	1397	1397	1678	1	1	4526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5k7eUUJUYeW843XoKw6eMz1Rwp5LAij4TQ7SsQMUgoSf4JdF
5613	payment	1397	1397	1678	1	1	4527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLFNDQHomuQn6FFRKhrFWyjnMAAUqwGJq9ShVXE4heLhUqe9K
5614	payment	1397	1397	1678	1	1	4528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkzYrLH1UekRayUDxKKoZw2Ww5tF31JhfYWmay3WZtbFxfqVp
5623	payment	1397	1397	1678	1	1	4533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9h8Sf1dJNhtSVxjsjjxRejLLxgM3sX5zxFnarYoEgzEkeiDSk
5624	payment	1726	1726	1874	1	1	402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfpE4jMPUwNexS1ANEQCwn14t6eJHQToe2xm6z8M4MtwfM5SZ
5625	payment	1397	1397	1678	1	1	4534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmouhdZw1MPVu5kuSHwRRVN5s9auZJRZEZz1r9BR6GVV1nvXd
5626	payment	1397	1397	1678	1	1	4535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjVE5pYRoWdpPJhQ9HtCYoidwAWSJw7FSLRX33faxcWv2pB91
5627	payment	1726	1726	1874	1	1	403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEmsHcgfqHSuWUpZy8KMrmLLot93LTDJkmdodL3QPWjZFwRAtJ
5628	payment	1726	1726	1890	1	1	404	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZR5j2QBsSYs8a4YkVkbe2qKVss8hocCFxRissBXuSgm7XxB4c4
5629	payment	1726	1726	1874	1	1	405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFsCtpmByiMqkTw9u64DRFWupis82k5qK5rxghwCkDj3CjbkGc
5630	payment	1726	1726	1874	1	1	406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHFXwrVtD7Ja8W5rEWHant3zCUxYTBKvVSSp33oUKaSx21V3c
5631	payment	1397	1397	1678	1	1	4536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6fVttEeRiZKp6EGU4KnknYZSwwWbU71222gsNBsnHBiAyHcL
5632	payment	1726	1726	1874	1	1	407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYneTdp9aENJVGrHg4utSpQj1irBc2n7rTVFNoZKtDXkUuGN151
5633	payment	1726	1726	1874	1	1	408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo19DTLyXVUKmantcsp3MiPz7FB6SU31jw7ymAqis4ovJUmEb
5634	payment	1726	1726	1874	1	1	409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSYToXeymm6KBijthutqULRcJTc74x2F6LBcsDFVeBzNRRQvC
5635	payment	1397	1397	1678	1	1	4537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4WJLChmT993ByvbyFsfdKzQJHmNpsnEuV3GBwAfwxhu8ZoTh
5636	payment	1397	1397	1678	1	1	4538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBfpt9b7SWLetqGRaTTDVjZvkz51WvYFRFzgpjRiUsXnBAzLU
5637	payment	1397	1397	1678	1	1	4539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bUSxQAzsFTR4C9gXBZQNWNGgSQE3GEdS8YGfnLxzdQZFri8r
5638	payment	1397	1397	1678	1	1	4540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ah9q4UFMEb6ajmXVfYxaaX1UW9mseX5QgpXXYuEyne9fBXkp
5639	payment	1726	1726	1874	1	1	410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGa26dXNEic5DWYACJ2PC7fwoZzHztSk2jCZ5fN1o62TJGYfHj
5640	payment	1397	1397	1678	1	1	4541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAbuodi1EzW5jKHwWCvxoZ6QjTE7N2XESbR5AfLfESn1ghriV
5641	payment	1726	1726	1874	1	1	411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadbwHWfSspb4f4ibhMdavrAga6s9Yh75iRcKXuheSrMteXfSW
5642	payment	1726	1726	1874	1	1	412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhC33yTrEQ4syaYdfCc7GBtW2JHPwWHngZiuaRwPNWM8MkPPwj
5643	payment	1397	1397	1678	1	1	4542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VHCff7eVQj4WCTEA2up8nf1ieR1JtqHpEJ8JdqLfHoJfEUDi
5644	payment	1397	1397	1678	1	1	4543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhAiZHUWbkAnX2aCRkTyfMfv145UJH4x973AFoyUaeHjktPSa
5645	payment	1397	1397	1678	1	1	4544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fikpGuzjfBuLMqeF4bTEtwdFioMgyHkpkPcqjTuE4H7bg68X
5646	delegation	1769	1769	1406	1	1	15	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dh84wvCM1LzoDLXLWLEAuCX96kBJrYiYJDqQ8KrufbHwDaXq
5647	payment	1726	1726	1874	1	1	413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4S6LdbfcQ4qHgYdkXM94Kre4AAXExCoQaJSjgv3192nGb9g1
5648	payment	1726	1726	1874	1	1	414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMFPtGKQ6BYTPstm1KjVpQ1MWPuQgoRrTCgg1BfKLi76diD5k
5649	payment	1397	1397	1678	1	1	4545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVqwiu9y6q96R5cwdN8aWuKY2DTYbABtYHBcWnsm7mA1ZDDTR
5650	payment	1726	1726	1874	1	1	415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fQ4GZ8FpVzjWEFUNVWwzA8z9dCCGWXmXGKP2E3MasZeVZt1G
5651	delegation	1769	1769	1407	1	1	16	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrdh6ftYNxvnopDZXgtq4Jh11m3KEhrcx3PCswruqHDdSY5fv
5652	payment	1397	1397	1678	1	1	4546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ3LxHXEFbS8Qfov48R1ZS8kGSD7Zj2XGRQ4P1uexGEckRFEzQ
5653	payment	1726	1726	1874	1	1	416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDUPbfvNhswFcjUuTruGBZjVGXUsWXEggsLN1aZnErTcb5anK
5654	payment	1397	1397	1678	1	1	4547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4YBDgUQHkniqG8k8YaJV8Z1BZKBxKhNATTBYhPBcQKjorybJ
5655	payment	1726	1726	1874	1	1	417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvki9qsFKTtMyDV5AuE91QpXMjakTDEwZuxiYFqCgjSyqV7No
5656	payment	1397	1397	1678	1	1	4548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nRnz5TsENJfYic5BgW6bvHJDdLf72Nf6i5jWn7ycohXJZLzs
5657	payment	1726	1726	1874	1	1	418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVxq3hpAFKzXeTtypwqvYoZKivAAZ8BthTbPhgo56MYKBuy9i
5658	payment	1726	1726	1874	1	1	419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZGXmCYVDfdtzDRVXBBaY2e2g9s24Cxc4agckrBFTxRdNqN8J
5659	payment	1397	1397	1678	1	1	4549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuzS7J8yY4RdmL8LwMpDEyf9SXWKQSEg19Tijjf2hxm7BkWhKC
5668	payment	1397	1397	1678	1	1	4554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxYYCmwu5zWjw3vpc2VXxzFfzPJUQwGRMzCMrpkTPu5RhDgho
5669	payment	1726	1726	1874	1	1	424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7a5mGdLgntkMmsCQJGpoYYWC6SeZDzZuMrx6QCrzadfMGLvF
5672	payment	1726	1726	1874	1	1	426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNuotoLTMbdxNv7sBjsAiV3CvazyeohRRvZ16TN61gbPvamLf
5673	payment	1397	1397	1678	1	1	4556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLv7PfJqUCgidSa6M9Vyz2NXYJAPawNLd82b3umZJHu1FxreE
5674	payment	1726	1726	1874	1	1	427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Rnwz8Ji47KpW6ow7Sdd3Lh2A3Nm78QBL3w7cdasnhiGWi1pm
5675	payment	1397	1397	1678	1	1	4557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWxsEXLpMKjr49CJQXMJkKz6ketL3brzD4RcSczdDuhnzoWMd
5690	payment	1726	1726	1874	1	1	435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE8YyBgxsbkGmBui2cVGAUQ1SkK8z5ECmn6nZXtCFDKGxQqRD
5691	payment	1397	1397	1678	1	1	4565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJXqcXuhTPTH2m4x3ffeffboMVReXjtmMFDVYLSkBhN2anH5B
5706	payment	1397	1397	1678	1	1	4573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaV4YtbWtz3LiDUtkfKbPTLGHsVe5ZRnmSAW7obNojpseitXxq
5707	payment	1726	1726	1874	1	1	443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hvHWdn8NLXYFLYhFK3H3vnTX19jLE71CPxVCcfz5YM7ukhCS
5714	payment	1726	1726	1874	1	1	447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYXS3HBNb3iaMqb1itG9vSg1ntDnXrxK9bjjJ7xqeJVFUWorW
5715	payment	1726	1726	1874	1	1	448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7LmQBSoMJTxGscFzux8RjNLWineguXCFvoi9cURFTZBnQkAG
5716	payment	1397	1397	1678	1	1	4577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYrJDykzNEkYvE1Ph4Y12aKeYYzWisegNhjam1gH6t851oCcZ
5717	payment	1397	1397	1678	1	1	4578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zs1GuHTrzRd15JX7yazco3E2aFa4Ya4FNbKsjCDKerUbYRzS
5741	payment	1726	1726	1874	1	1	461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHssor2JSsADpWtomSi5aRvDm7ZWU38YhFg7v1iLoo8yUTs7fP
5742	payment	1397	1397	1678	1	1	4590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYDgRqQG4PnK2odHFmu1PXdnqQQPiXTbLDoVZ4kJcoBqjKeGj
5757	payment	1397	1397	1678	1	1	4598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPuamcVkb3fjkutkBq7aYTQMQ8QeNe17UEvL4km6vVnBkioNB
5758	payment	1726	1726	1874	1	1	469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCEB2FrPrcHMCjVHJzXKVcGi14PXMSe69yWcwTcCgv3u82edj
5763	payment	1397	1397	1678	1	1	4601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8R6xzFzQdbECEFRMK1VXYeapQ9yqjHskqwseodrXMcpAu5fix
5764	payment	1397	1397	1678	1	1	4602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBfaZVqdV8CrJmfoLHo8i4xcvuthhcbzoVZLMck1NgynA3rRr
5765	payment	1726	1726	1874	1	1	472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tnueZhsMqAxMNX7kJSJ2ym852FKY2d5nLfksiGNEqqB4WgQ2
5766	payment	1726	1726	1874	1	1	473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTSzcu5UJkBVyQj6MCHhsm5XC5nw4rSA3wTFHbcMXHNr8f5Nk
5769	payment	1397	1397	1678	1	1	4604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqKXeYFLie8WmP1XGYuY5SMCxYHuydHK1jD69D2Yh228q8opn
5770	payment	1397	1397	1678	1	1	4605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPzTVb9X7F8UNHnVpkra8RPqwJyL1kxfyw4Etykt4vbuu1oj5
5771	payment	1726	1726	1874	1	1	475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEZxAQp2anCV19d1NGmGdAzUNurVkhi84nHXetaT9vnZtScnW
5772	payment	1726	1726	1874	1	1	476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbih7yGizvP9AaE6z9MNn1HY8GUMkbdwqhTpduuUuyGBAPqnf
5779	payment	1397	1397	1678	1	1	4609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxQK5ztTgKm2iB2n4FH4kET9LhgyGoH3NGJEQfKmm3pjUEwgd
5780	payment	1726	1726	1874	1	1	480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NWRyWb9i56hG5Qkh7hVP5jaf9hMfqegRpG2kaeu2SVCZPv5T
5796	payment	1397	1397	1678	1	1	4617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHsmkn7e3wnTUmE2gbmieuY7j7cLzjwRZ3F6Qobd8kEkA5vdL
5797	payment	1726	1726	1874	1	1	489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsYyT4pM4HghhYGPHEvq2Jt9XXNxU48GVHXHAbEo4mtwRgd17
5798	payment	1397	1397	1678	1	1	4618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkF6bpN1jwetycTHwfR1LP7uzyoxum8DDkryyces4TrH7BxyX
5799	payment	1726	1726	1874	1	1	490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzZrHvyehMGzTiaGaXrnsD6wiYoUfEbd4k7tAZH7tWiYngK4w
5802	payment	1397	1397	1678	1	1	4620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQei8Ruc4s5qKWLEx8vTwttTP2nE5ZQiKAPTnCMZXtG3GK4fUd
5803	payment	1397	1397	1678	1	1	4621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRX34e2FAR6RzojJi2uyA48phB27ftSMTPmAUL1TEGUck2yk8m
5804	payment	1726	1726	1874	1	1	492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMqG87qCSaRdWjWfaxwyHxzPBdeFc2hqJ9qFAFRSLbACVpDPY
5660	payment	1726	1726	1874	1	1	420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsWc1CtPtZ6RQMV3KsFvuQ3VLTcwsRFnJUA4aGb8ZraWgjp6g
5661	payment	1726	1726	1874	1	1	421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MVtG9pvH26BMxUhVs6V3nTPUcXFj6NFyhdWRLSaj4Www2NKv
5662	payment	1397	1397	1678	1	1	4550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8JT7cPqW2hka2ri7bCxwV8oracwLEbfRJCoMNdejcAKCTemb
5663	payment	1397	1397	1678	1	1	4551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHBnUBQAZJdRp7s5d5ph7q3vjvANYeYfWmMb6AWMs2Kab3MQg
5670	payment	1726	1726	1874	1	1	425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6i4pfGiq2WM9JNTg6eRSw1mVp3LJBiVSH9rFxs3XrUmGTWNy
5671	payment	1397	1397	1678	1	1	4555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89wfF1pB5dtmkqbFibJFadpKAfwbk8K2jRPdSdTQTCVW3Xqds
5678	payment	1726	1726	1874	1	1	429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD9vFfASXqdM9XPnbuif2vhcP2s2rXdeid1uQ2eTDxPzGMymw
5679	payment	1397	1397	1678	1	1	4559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdbP8tgAHGGE63zrzDHGRRJrqXxrDsHTFS8eGpKDatgYPnEyw
5680	payment	1397	1397	1678	1	1	4560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3vFWNQnWr2FQgXJvZpu8k9tgsVQwD3253YYNUGuXH83hMEji
5712	payment	1726	1726	1874	1	1	446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8qBb5xpcLPpj7AFcS76FgUuqKoWRXjHhQYV2EnGerh2y63n4
5713	payment	1397	1397	1678	1	1	4576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTmBB7oADYs1EbmDwBF3sJDXQZnnvcUv3v5uA9ByjYrqTSMpg
5718	payment	1726	1726	1874	1	1	449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsgEbVvhHZpatNufhjjhPcAZN5QobHKfFpdcYhDPTfXMj8vcV
5719	payment	1726	1726	1891	1	1	450	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSjDxRN3LNhSofdtMjweJ3RRF5JMPMZuoXLHnBp3w9WsNMzov6
5720	payment	1397	1397	1678	1	1	4579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbg9VJo5Po6TqSNQBVe7miwjCGSZBncPNeHwnsthrFHr4cQV1e
5730	payment	1397	1397	1678	1	1	4584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCv2CDpsWcBv1yVuGAL2GJ5ozrFYdy6urc2hApSztxAscHKfR
5736	payment	1726	1726	1874	1	1	458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wYTeJ3Zy2V6qqC2twBFQSJSgGWM5vWiFs5w3izSPs63uMZTj
5745	payment	1397	1397	1678	1	1	4592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWY6HM2SzPp2faygXPw97eMFeTg6aM9J7ZNNe2KJY3RVhCZNP
5746	payment	1726	1726	1874	1	1	463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJY9FKiCnsJmCEpqLGvRbyFDbuTphGFRKdBiZ5gGen2op3LoH
5747	payment	1726	1726	1874	1	1	464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8zTfa3J3Yf4TBzjpakeG3gmCLjmzZED3oP5rDnKa1nqAmTPR
5748	payment	1397	1397	1678	1	1	4593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcc87teVaVrm4qcdwsYCmAqgrHpZbWB2Ekwxt3Jz7zsGy585te
5749	payment	1397	1397	1678	1	1	4594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMcWVERkg6MxetC6sgq1DpQ1sdc9QREJoUYK6fzN39vTBMhG3
5750	payment	1397	1397	1678	1	1	4595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyrSBjXUVXRWJbz1xnagT4vFrXZcKwBj7Pe2mFPWx5Qni6BJ4
5751	payment	1397	1397	1678	1	1	4596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyRTCGKFRFdiUWwUKr9oMciTHA3PU1g85BFbsYGYGc75xWaap
5752	payment	1726	1726	1874	1	1	465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8xbYYppVUhe8bh5KquWdRZoJU2cyqw4f88APFQfbkik3DM3V
5753	payment	1726	1726	1874	1	1	466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQcRHA94yMZGScdeoJQgjApun6fJWTUh4pkyqS1wUrVKkyfNHD
5754	payment	1726	1726	1874	1	1	467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH9BEcZsfZufqstbTcFjKM7DzNvBt3Mk8hD1kJv77AopqeSAP
5761	payment	1726	1726	1874	1	1	471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUN6ERVDYrb1z6u8PZtqnGNJTMG6R2XDHhTtYMnS4DbzygNrVW
5762	payment	1397	1397	1678	1	1	4600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrAu8Nrv6osrWtiLr5VJtX4DhwNgijUgSwXAkKeohoKKL6t5h
5777	payment	1726	1726	1874	1	1	479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqWfANvKYJZiqzZH3zPyUWyhBKkdhaSh6DVQRJbsm2Y47FaZW
5778	payment	1397	1397	1678	1	1	4608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgUenm3UzGk6ZpE9gJbPtgkqmsx7ari1oDgZ8CJjniTJQueFg
5781	payment	1726	1726	1874	1	1	481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHu6bmcupdguZ8L2GQ2bRUdgCnXvQzHGTj5gtrPh8L4ZFJtZH
5782	payment	1397	1397	1678	1	1	4610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2gUben1fogr15VUX3Hz2jVQmMwgwN5yUWDzuXF1j2v9khMnr
5783	payment	1726	1726	1874	1	1	482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYY3eSUhiDMkNReDB4kqAAWSzYKGvnna5eTC2eJYvhdW4bL37H
5784	payment	1397	1397	1678	1	1	4611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo5f3ZfjYfK1dkq7tjuUHaVGnJjxRnSbJ8Mex9v6gFkeWoMyA8
5794	payment	1397	1397	1678	1	1	4616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHWueCzzB8gDuYPDhoxfCuAZNKxJGSfDgkj5gCkUWcG6U2YvB
5795	payment	1726	1726	1874	1	1	488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLh1Ts5a2KemgoHTT8XkPLhmRWnXEbeCw4F6e7zKesMnAKRVva
5809	payment	1726	1726	1874	1	1	495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zX88S9reBPUdHsNS7EdxNRueVjV9bnGVtci8z9Xmsk1TZhWk
5810	payment	1397	1397	1678	1	1	4623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZjL2Px76TQB5mVr4ucgfNWs3aJXSRQJZEcDFUH3Jsz4KK8Uj
5664	payment	1397	1397	1678	1	1	4552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYmjTY3vb4pmcHsvAqusf6r3xiy19iCaBy9gtCfM4HrHtW2Lw
5665	payment	1726	1726	1874	1	1	422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYN2fkuarY7qLcuS4AHbeXgjKWUmnE7uFRJtXPxSc2uaWcJzX
5686	payment	1397	1397	1678	1	1	4563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4bKVSbaLpuJMp723AMS6WK3yRt3pfwLYGi7wsjtjf2MkeL5c
5687	payment	1397	1397	1678	1	1	4564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW6LSP5EeunTjF2tW7DBH62hEVgrUEToDLGTiUZfMu9Ws9MZST
5688	payment	1726	1726	1874	1	1	433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZQvBzyReU8gEJzYk9m29KuXp6LqLwvp5z31dFJC2G5o7JM64
5689	payment	1726	1726	1874	1	1	434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11mxH3wgCz8nuio3WAC6S2FPgaxXE8FEGhoTYPh6X8WAF1fxw
5694	payment	1726	1726	1874	1	1	437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAv5vsnN5Vbhg21t9kV3dXRW94prnS6Zb3R7bG5M4aK2Ch6Bq8
5695	payment	1397	1397	1678	1	1	4567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqtYsVrBtddMzSWQqwzCn6V9EComa1iBBxVZPNV83acakgvdH
5702	payment	1726	1726	1874	1	1	441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYHpyBg7SWPCafrh3CYbB99NC2a9ogEnsiT9XoxaSYuwZXGpo
5703	payment	1726	1726	1874	1	1	442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhijrayPCLkfi7GqaNCgJwM6NH7mwn1xhCmnQ4ua1i5ARm5PhR
5704	payment	1397	1397	1678	1	1	4571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGGiBZ9QtAdmtSniqM1wLoP4ULGNaHBamJjHb7VKt5KL8TbL5
5705	payment	1397	1397	1678	1	1	4572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk5SuX9Y7G5Pi1ccNJUkrX4mabUXHhMvmDKVZ3XBc9yA93Tho
5710	payment	1726	1726	1874	1	1	445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqnaWtZohyzGYa8L35hATW8DiWECj9s8Ue8p3uPDGehVBn1m7
5711	payment	1397	1397	1678	1	1	4575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnp96QwJaNdDWzXXz5f3LyTjpjZQUaeWoXLL9tJHcMAkmj37kX
5722	payment	1397	1397	1678	1	1	4581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZak3QjMUiRPghL8Gvgp9ZZ5WfW49hJKWqSsTdDJGoXqniUhtmn
5723	payment	1397	1397	1678	1	1	4582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqdfmkCQooix5SmKUTHsuJEFVGUD5PQLUJr5XZcJ9KraGE6jc
5724	payment	1397	1397	1678	1	1	4583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZuNoZr2gxsRbhCHc2iXEhYcA5yBtLN1maL2jgsrfLWGAtXdg
5729	payment	1726	1726	1874	1	1	455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6UEMNVSxudULuNsm7cTcNBuwPdoEHXredJxAzF1w9wvHM58V
5735	payment	1397	1397	1678	1	1	4587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyd2Swx3mjgVAmj4siJvYZKLDkxFXobpLAPMSMcctwX9PCHnUn
5743	payment	1397	1397	1678	1	1	4591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2zYivWHb7QLmjZziG2MS2WFfQLU4fiRu9yyvxqSYcP4mJhPD
5744	payment	1726	1726	1874	1	1	462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9ZeuZ5nBawDcLgWi4iDpPLR336uaMTEdZ4hdHWoZFxBvDyzE
5756	payment	1726	1726	1874	1	1	468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbXsK3bbCfmxj54u285FBqHzjE2WDmvKsdi33R5vmnqecC8Tvn
5759	payment	1397	1397	1678	1	1	4599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSwXPnfJv6kMwXjczuzV68JHU8sEbNwbVVd2CkL5jbebTairp
5760	payment	1726	1726	1874	1	1	470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJrMUXAX7oCqVmDKfB26B7o5pVxNExXexqbwSDA85Dwr7qhLD8
5767	payment	1726	1726	1874	1	1	474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCnZrb4uRTzHgwsidURHtmdHkE5D2onJwTJp25P6BTn4UdHGh
5768	payment	1397	1397	1678	1	1	4603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhegdCfAUBznQw9TxRHEzQg6hUwNiaEfoiE9h2xWkvPnJWfT1V
5775	payment	1397	1397	1678	1	1	4607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxGZeeJn8yxUr3bJSMsXsSvKLFXroy1SDNvVZCjsWj7NMvC7V
5776	payment	1726	1726	1874	1	1	478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPRSnt5kcM529xVwnmtPskZuZXUPmKGhHAQcGFdya9picapEn
5785	payment	1726	1726	1874	1	1	483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSfnziJffVnq22Ev593RfmutVrKZegJ9zbe7K2mQduj2tt5DG
5786	payment	1726	1726	1718	1	1	484	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYTrR46x84GAPD7TnFUdA1UrXwYJQHdXUDkM5cfaN28JT1MxGmn
5787	payment	1397	1397	1678	1	1	4612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1nV1xAEuvWE4F8UEFNLrX899eT4Zv2p6WWUhxsy72KErQiLs
5788	payment	1726	1726	1874	1	1	485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbeqZrnS5gn7MMxRwttZk74JZnyztMRnWCoGKrkVcL1qZGbDB
5789	payment	1397	1397	1678	1	1	4613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1QZ1SLgfRutM6iizxKiYvRsPKB9MGW6NhCWRWPVRMCNXyqEfP
5790	payment	1397	1397	1678	1	1	4614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33v2q9TQCNgkEjY7aSU73QvUhrhuEPYRdzrZ3vhzeUcazZiCX
5791	payment	1397	1397	1678	1	1	4615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfvfBayEJ7vGyjW4wXqGTyGJ3ZJQz3tTnsxck71mgDY4QvB3q
5792	payment	1726	1726	1874	1	1	486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1naXv7z9yZm8TU8uVF4b5nKcWrX3vnzPjBjiC5CvFwwXZyr1o
5793	payment	1726	1726	1874	1	1	487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMVHQTCiDsUYJCU4vEhhXUbDZ2KVCKmW3hHdLmjg6ZJYBRDsr
5800	payment	1726	1726	1874	1	1	491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3ZBtZLkU5fjtTNtK4pFqSA7guXbZ2i8LR2EJqvRnshwHNAzB
5666	payment	1397	1397	1678	1	1	4553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1UmMVtYHcJbBnZpfJrYtWtTf9aG27CugfxrDBzHWewTKNr23
5667	payment	1726	1726	1874	1	1	423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQT2uh56CUQwiwrj2oNGwcJDUcd85JL6XHHYxBz7xALBPSzqC
5676	payment	1397	1397	1678	1	1	4558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXBpjeJpEp6rutHJdVQSsQdbbTnJbic7ZRzTNPWVqqsrteFU9
5677	payment	1726	1726	1874	1	1	428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzV7b4UDdmn3Nc4YufetEBYaKdfdBHMZj8PshWHZXqKDUkQcxV
5681	payment	1726	1726	1874	1	1	430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHy8BWmK7uGSWPyjpg5MAv2qc7DQfLdueZTEj5EVZuUzPKvtu7
5682	payment	1726	1726	1874	1	1	431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV464WQ5v3WYg4ftXYqTtLp51rMLyrEvi4vjMkKFTZhH8ydqL6
5683	payment	1397	1397	1678	1	1	4561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVx56MiYbSgfofqQtDy3Fvc2naYeYyMrKkvMFXmLDCf8YPgPK
5684	payment	1726	1726	1874	1	1	432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbE3AiADWiBCAXCR8gZR6RDhy4GRqg8tdoLzysWanX9LoSBXHe
5685	payment	1397	1397	1678	1	1	4562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKo4P7jsGxjcjhnUgmUvuF6g2JPwLafHN9JMm9xa39Ddo2Ddm
5692	payment	1397	1397	1678	1	1	4566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAxv12SUyrsn8Nr1RJj4rYBCNbn5TPkG4XohnYfNcJGeHXcGu
5693	payment	1726	1726	1874	1	1	436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1G5cSDH3SK1cC2qQNycrFy3yr4MC5aRtxUM1bjXEhkWLbjyg
5696	payment	1726	1726	1874	1	1	438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQxahqCPL8zyb8EjPnUyg4Nke7JjdgknAVWs85hDi9KvuWeD62
5697	payment	1726	1726	1874	1	1	439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4iz8gkDLxLdUTYMchi9EiuEVtEQrWrbrV8buTmQn3VHGuf1KP
5698	payment	1397	1397	1678	1	1	4568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnggncAVrBUegCoQ2RwyW6e52qAeFunJAomRyTkStnXFUbLzU
5699	payment	1397	1397	1678	1	1	4569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPW8J1Qh6NDi2EBtvW8Sc4ujYPtuXe4mocmiYoha34Jw5AYJh
5700	payment	1726	1726	1874	1	1	440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4rcWnzM1ZjBvLJdkiEESHbgJnDKBSKxLE5Sb7W6rqZM89fdi
5701	payment	1397	1397	1678	1	1	4570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGxfiEUpW15F3avHUA5ZyRG9sD4ic38JfkoFwzQgiVSi5fSbL
5708	payment	1397	1397	1678	1	1	4574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJM3BH6bGGd5TmjvHnjrrp2CSJpu6a1ikE136rbcLpQssJSb2
5709	payment	1726	1726	1874	1	1	444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPzqo9Ygho3XTLxCiUokDPx5HAvQePNxbvSjnpJDcjTYKKmJn
5721	payment	1397	1397	1678	1	1	4580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3MyeNtMhfSJN3MQcV6SQBuZY23rjh8FtAnmeoEb2a1kdRo93
5725	payment	1726	1726	1874	1	1	451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMCTUhoEWhDNQ7thYTSHgTU77iYqHPNonVvx7mK5NJd3gHRy6
5726	payment	1726	1726	1874	1	1	452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tdHb4BcLsTiQkwfmx7u2HuDFCNmqJLKF8Rxv2jUyhzGsHbvA
5727	payment	1726	1726	1874	1	1	453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZax8SpKERsiityWpBb11b3UPuo8ByJNyBomrJdd71J6ruh7fzj
5728	payment	1726	1726	1874	1	1	454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoXCMsWGtaWuBboneYNNuv4WSnFquveRkHt3deGMLhGTR1i7u
5731	payment	1726	1726	1874	1	1	456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZRT725pc7ZEtcSeUXmPZuZpFdj9YBrX8Jg7sBEXfdPqG3SEg
5732	payment	1397	1397	1678	1	1	4585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Lb9qXRS2ojUAXQWzYUvkdmNMsdi4oqcDZwWqQAsuPrz3c27y
5733	payment	1726	1726	1874	1	1	457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSi8UdEtmgqstr89hT5HPz5WerjVp58vTsi9kaoNNWiiEDpVX9
5734	payment	1397	1397	1678	1	1	4586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfK14H6EcSNz3VAgLrRdPgaRBm3tcVCSgR7QsiCC72FQ8XAp6
5737	payment	1726	1726	1874	1	1	459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WodVrpqJvcAPJgmhBThr3A6qdGvGKjsgc1DEiHBPNkS3Ynf4
5738	payment	1397	1397	1678	1	1	4588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1i7wG81fZDAvRE2DGjUPxQGRaiGxPDKp3hmf7J4mtvoKHVYe
5739	payment	1397	1397	1678	1	1	4589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6qbuasdg9RStkSu5Qqe7yP148oetNJGDEmMZezHpbwQSMUG1
5740	payment	1726	1726	1874	1	1	460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAKvCVY54j4ccK27CKBkxovVbZ5TydyQo9i9xW9XCCFbLrXa7
5755	payment	1397	1397	1678	1	1	4597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7jWFdH7c6ogEw9A3cWhaUKV23uC5XrA2CTTYKDDynsxDyH9y
5773	payment	1726	1726	1874	1	1	477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC4fMqZN7pbVft2KSWbw3NrCYaTsCPyqhDkjF9oJ5HdypNabT
5774	payment	1397	1397	1678	1	1	4606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbBLAjytztbTHBr9xkCqWzrJsZ2MGoJSQCrkXmccn4Lx1f7Tb
5811	payment	1726	1726	1874	1	1	496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3K89URu4SuQJH9Qi9pSVqmrh2KNCMCNpz2yVpLTsrLZZ3ihFQ
5812	payment	1726	1726	1874	1	1	497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerKdE41HcS9zCfcfGNxaiq2ea5WbE3viaivi8M9dX94cQ1f3Z
5813	payment	1397	1397	1678	1	1	4624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVzXUbFhiXhZMPdcS8bu3uSiWD1TbrvWqpi7m53GpR8ZGUiNj
5801	payment	1397	1397	1678	1	1	4619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfjH4369Uv9ePV6EvLixr7k5qsXYQym5T51FScxs3AmebRhUs
5823	payment	1397	1397	1678	1	1	4630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrVsk38RyGzdvZR1PFxLL12azNbPy7dKuvd44duNHcKqboXka
5824	payment	1397	1397	1678	1	1	4631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDQu4BSpmSEAsiYEyQ9WuH7rk51LLJhy1BiTB6FXinToF1fBQ
5825	payment	1726	1726	1874	1	1	502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8hxMDP7FD39haddTHDLtewxciXZo8CD8a5NvB1UzNJwqL8Nr
5826	payment	1726	1726	1874	1	1	503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbNg4u53bVRLYNGgqyM35CsTkNo1cxR9xeTLYPEUZK7r4zGhi
5827	payment	1726	1726	1874	1	1	504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXtjE411rXNwHbZhK9rDRyr7DSuHgfenEoRDbKEYHUR9kDRJPa
5828	payment	1397	1397	1678	1	1	4632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDC97u5RiPXz1TauL6FsErtDx6mDLt6K9yLgphDiUcR6Adtri4
5833	payment	1726	1726	1874	1	1	507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESRheBC3EJzF1ugw25e2ghjj1Scr7Khj9sNksQiqXfa3a7Gcv
5834	payment	1397	1397	1678	1	1	4635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVGkRCuqqKVwj8BvQzoSW5aLVX9WwYabSyzXmESnfN8Mxhm2X
5841	payment	1726	1726	1874	1	1	511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLHMdDH8Wba2S328Ea3hEugLKihETCouB3JfQC6MTFbN7EBge
5842	payment	1726	1726	1874	1	1	512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfhW9KiLefMmTGCjnkgvB9WSSgv7WDjYP65d2rJaYZUQohPKa
5843	payment	1397	1397	1678	1	1	4639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDRhdcoLAkCbEMENKxURgRjo2nuid4Xxsd6ybDmvqjbSxTj1U
5844	payment	1397	1397	1678	1	1	4640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWm9NB7tiTxKnvby2XwPVXwKiPWbrgNkXZ3Sa1KRQKXqyuFci
5849	payment	1397	1397	1678	1	1	4643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfziefM7UchwK591w6vaHCbDSEhqKzMFdCzooGHhxiHArMKfgT
5850	payment	1726	1726	1874	1	1	515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51KnEpGH3LGYrsdtmF2g3Rqh9ucZ4E74iprXSyX84zjwFNVDt
5851	payment	1726	1726	1874	1	1	516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTpukvoQJg9QbYsBT9TMgB3tB4DEp1HXamh6rCK7e7GCmPRZS
5852	payment	1397	1397	1678	1	1	4644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYMjCxWZRobzBoCbh1KX16WwTzrQDhcpJHeukBV1S68TDzhvQ
5857	payment	1397	1397	1678	1	1	4647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTawkXi8e7QvtvtViMYA5qbWxRsfkCCU3WBqdk5Qm3riK7MBm
5858	payment	1726	1726	1874	1	1	519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZtWtUbu8REfkobmLbS5nJL4C6xzaP9XXTg7GxRmrroUqW2NLY
5859	payment	1397	1397	1678	1	1	4648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5rNhY8228fDZKBGUzEs2TxPB1Sn9iQkauFXWnRiRzKcFqTyH
5860	payment	1726	1726	1874	1	1	520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrW2s9fc8ZEENbCDPnoTsKGzam9xQf8m8Y3gWf89PkkDmqszD
5866	payment	1726	1726	1874	1	1	524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZfduFvEny3exNrJNBaXndGbWembg8hGkVRxLuWwjupeZNHxG
5867	payment	1726	1726	1874	1	1	525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhVEXXGqxMWp7Ph6LcKoBdMgpuMULC8s1SFEyLcPPwKUfRuUS
5868	payment	1397	1397	1678	1	1	4651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwXNjsXETtXU2SXDnB56rdwuY3ZvHYbUwmPQ16GtvHpVrqSaQ
5869	payment	1397	1397	1678	1	1	4652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5g27Fk5FVuv2MJx3piutgAFATcXpcx8qb1udwmT7PGdmPaP4M
5872	payment	1397	1397	1678	1	1	4654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqtvesu9mjT9r6szyj12AF6xx5EjuobbRTfRtDXaiJGjTYx8QN
5873	payment	1397	1397	1678	1	1	4655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgt1jJVSV6ZATVH1RM5T7DAmQo3zzK3bvfD5NMS1qrZBorvAhJ
5874	payment	1726	1726	1874	1	1	527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoMmcjZiv7Ymav8vdXbFnkHrphaVKd7DU3oKhASr4MmbVXZcV
5875	payment	1726	1726	1874	1	1	528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRScjiuiZuLv4CLxmArMvPiccX32TVL2dxfarGjci54pSCpdvR
5890	payment	1726	1726	1874	1	1	536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKuvtczZw3FcqSxpiz2mWNSiwjvLChMncV6KiG734LeVW9jAH
5891	payment	1397	1397	1678	1	1	4663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKtcnf7SFDKuLWrmh3BLvixmXdFrx45wBMgQuSzzrJuJMeu4U
5908	payment	1397	1397	1678	1	1	4671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyCZqmsrjBjejo3H2AHqDRcPGNGnxPsmoZ2JhyMzH9YXKahDgA
5934	payment	1726	1726	1874	1	1	558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4ndJRWAMSW5e7AnizUmeus6ojN8h8hT4LoXazv5dnCtHHpUA
5935	payment	1397	1397	1678	1	1	4684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof7RaesJZEYs24YdURvNkVXazkCzGLJB5Xcx73EJhsFMsCZKM
5949	payment	1726	1726	1874	1	1	565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWeVHSaNHVr2ZF5FLWL3AYKA6dTNp177vUnNrWQApwvohsqrt
5971	payment	1397	1397	1678	1	1	4702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZMiDcM6iXN2CA38GTFmURfu6F8T9Q8sjZbbkthMqfVkRyK9T
5972	payment	1397	1397	1678	1	1	4703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKbdcLvoQ2fDYSynWw2pr2p54EpXkQdvENKnZBnjmLAdkyk9A
5973	payment	1726	1726	1874	1	1	577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptai5Yb31cXHUjhnA5scQ1vmz7ipJMwgRTTnutXhK7TpXf9tq
5805	payment	1726	1726	1874	1	1	493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQUTZXARsj4p4fjYWaYxo4e7a5N6yomSatXxLqYhU3bg2oS8Fi
5806	payment	1644	1644	544	1	1	0	1439000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWS2kL98bB4hCe5yMLzDrbS5TT4UHawJtDQxZz37ai68pFJQb
5807	payment	1726	1726	1874	1	1	494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCJxq9AHzBp4qCGtK9pZu7G2Wh4K93HMPZR29WzF3crmu5hK8
5808	payment	1397	1397	1678	1	1	4622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5rUh2Ww2qyKvWJb7N5k7DttBBf8UbrQ2BM3TyMnnxNH5JRmR
5845	payment	1726	1726	1874	1	1	513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNX7kbi8kk2ouXWV6it34oWQxeZWjnqDdavcrb15pBSoHEeAz
5846	payment	1397	1397	1678	1	1	4641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPExeDHYNioKcE48eZ6MCnJykBV9ZPSr9KGvWBZTuraXdCQv6S
5853	payment	1397	1397	1678	1	1	4645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbH5GwfPxbYjkvUGo6XpMFvnhz4VS6e2jcbpmmCXqU9kBxCSNh
5854	payment	1726	1726	1874	1	1	517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM97TNM87HHoEgPHcsYKjMfFdRm8b1u6gsxipqyVtLSJAcreh
5880	payment	1397	1397	1678	1	1	4658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdw2MdUjSwcrB9LDQSx9DGrvHKS5qSZBGHoFGrLApAgzscEaS
5881	payment	1726	1726	1874	1	1	531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwD9ytobNa5ByXqzG6UzY3tYpHTPUDVn8L7bK6FTcLbamUrtGp
5886	payment	1397	1397	1678	1	1	4661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2MWa7mz1sa5Tnijnd5y7CdbEB3sXKzS4Nz7DPnrPvpGAcbux
5887	payment	1726	1726	1874	1	1	534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJKs7oyAu3Aw6gL7dEbcdTRsAiGfo3BFf7xuKphpAQUkkvA1u
5902	payment	1726	1726	1874	1	1	542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMQ5jhxEgJoUausUeT4b94PdjursJjGbNa9Tah1yGZewm4f9x
5903	payment	1726	1726	1893	1	1	543	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYZZRLPWbL2juD8P1G4Eym4Jt9oQtEQ5guPVG2t6J8AsEnk6PjV
5904	payment	1397	1397	1678	1	1	4669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2rzs1d91bU3gXobM9NUtedauuVRtj32UMmKpDsgv2AVS8fVT
5911	payment	1693	1693	327	1	1	346	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpYoJEvCpgmgJnAGe7nuJkTYmRoijZ2U3cefepXQddygMMn6qGRP
5912	payment	1726	1726	1874	1	1	547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNiFFMNsgNNUwhLE1ZzYxA4ecHZz3Q6v9AVHsft23CewyEogFX
5913	payment	1726	1726	1874	1	1	548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6LcRpTrPRsNMKZ9sXL9PsEcK8NrSHpP8FVuUYKHhokAf5DB9
5914	payment	1726	1726	1874	1	1	549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUBmGEX7hAiQhz18FRv1uNkpjZeM9Bq6ykstvPmohNCXq1U9U
5915	payment	1726	1726	1874	1	1	550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9LYuV57gQws69isYPF1fknqkgAi5LmDM9x2ftYgbfPT9RQXv
5916	payment	1726	1726	1874	1	1	551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5XUVgJaMRjbHo6SwbZNn5tKbm68dbcBRz9BWVmEKwBbYa8fe
5917	payment	1397	1397	1678	1	1	4673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTPX55BYN8DEtfJCxr1B4JiprnGGa8qKQFuih7C78GpWfaYpV
5918	payment	1397	1397	1678	1	1	4674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiDSdjLAiKJmksaQcPuhiDEeUKg863ZCBNAerSxmAhWRtVgqQC
5919	payment	1397	1397	1678	1	1	4675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLeyNK9F81UcU7V7jvdyYBzEG1sexK7eQdLmEMYzhTaUwWHrL
5920	payment	1397	1397	1678	1	1	4676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdY6SB1KQGGjM3QZNir1r4ysvri2ecnGVUUJT9o2cev9wDFoGx
5921	payment	1397	1397	1678	1	1	4677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xvwLCbX26fu5YvoWKBqtMvXKCe1wNNK1uDFJoRpQk2W6Z7Po
5926	payment	1726	1726	1874	1	1	554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RECqXFHNmSuac853ZaPyzwdFnkGuTRKvBB5rPYQt5dMAm3FF
5927	payment	1726	1726	1874	1	1	555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4nuRLjtyBDaidF2g3BpXTpdhU3vswtQRHf1mkVYXkaWrrHZ8
5928	payment	1397	1397	1678	1	1	4680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpM3ntQB547RzvW2BD6RJGCQCkkgXh9CMB4a3FqiEKcvkyc7YV
5929	payment	1397	1397	1678	1	1	4681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3P3PoTwmZWGbnjCUKK192GkfbqgdspWNCz1LinqGqjVtMoeHU
5938	payment	1397	1397	1678	1	1	4686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcNqRZQSGmVzef28Q9qJy4Z4dzNTfD2D5LD4NEUnDLyjsZHxn
5939	payment	1726	1726	1874	1	1	560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYmnkhcBLNUPzuRD1mT8qeE3PwfvJ3VUkHcYfhsRsmmoR2wN5
5944	payment	1726	1726	1874	1	1	563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SKeA5FJVeDmFT9VVUQC4JYArYzXiNzvTnH7vNzwzdpnFA32w
5961	payment	1397	1397	1678	1	1	4697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjh6njMBAvPDxGrjk4AAwnF8GoqM8hrusLUQgvG9STtrnPDA4X
5962	payment	1726	1726	1874	1	1	572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXkuGUQhfMNGfysv6AJvyUFuGraSLzD8wdPNzfPwQBC6WFbgz
5963	payment	1726	1726	1874	1	1	573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZ5DEUs3YnJxicvanxoRzgRbkTqZwRycGzt2bJT45GDwfCfeg
5964	payment	1726	1726	1874	1	1	574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMbZScJyJEczchZid9MLYdJbRD1QwAFcdun21tcZaoWkan2zn
5965	payment	1397	1397	1678	1	1	4698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwAAkEw1qMcrmHfzGeFA5dXkqLD5HVAkmCeZ73cJdegDcorWh
5814	payment	1397	1397	1678	1	1	4625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVwGQNDBJkrxaD4AY5dVYJoNJsxuXckNbERrvuiisd81QGB6Y
5819	payment	1397	1397	1678	1	1	4628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSy47QgqSE2m775FSK48KeEcx2cQU4uFcChTttq9CpbY2VwwG
5820	payment	1397	1397	1678	1	1	4629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSmTYx55hPJgd2fN79WhnJP9KhwXamGM5S5Utyoy7zLwrDwjv
5821	payment	1726	1726	1874	1	1	500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdSw5Gbah6MyuxC1uVRaTFn6B3ba7xUAY3tss2jAdJUhAA64r
5822	payment	1726	1726	1874	1	1	501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZSjYfnrsk9BnYV6GCc2xBJt4FtbF6JsBAnD92oXF2LEnayWv
5829	payment	1726	1726	1874	1	1	505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvmPC8dRTwwv3PHmmarNHhkeNTG2pvG97SLe7Q6M8PSrtwCa1
5830	payment	1397	1397	1678	1	1	4633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92Fci6GPVmwBB8c6PTHcg4kbTj9w1vieRc6RBhUmuVhQTD3AA
5831	payment	1397	1397	1678	1	1	4634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvBgXwUBRqgpp85gy8J5u5QNNbokrvuBFyAqWJDQ2kpNb6Wpn
5832	payment	1726	1726	1874	1	1	506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8H2GsQmmfByMyj1Ln4zL9yRFuFYfP3fwQyKENb4Xzt4zkgHu
5835	payment	1397	1397	1678	1	1	4636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN14RPKMTSWnFPfVs5hwBTDaWGH5BUaVBJ65MEctBD9cVwSiuc
5836	payment	1397	1397	1678	1	1	4637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYju9QKPYMNeHCiadD7rGAfrmLHXKt9whBL664mCsje5YxWLTQf
5837	payment	1726	1726	1874	1	1	508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBkncbzAMQrbRYgV4NboNHXUBvKUpSwXqUWrcei1R1Fp9c5mY
5838	payment	1726	1726	1874	1	1	509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYE4RM9q9UH8UxaoX3JkwMad7f4qbmYP7bitWQK23tvrHh4KZL
5839	payment	1397	1397	1678	1	1	4638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsayVkta1uLBY5PFW9FioL2hXVSMoRhVNJEDGMSS9Y9Dc4Jy68
5840	payment	1726	1726	1874	1	1	510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfE6okgQxtj5FqHaaitv2c2bLDMb5XEfFzubWkA3KioNCqEWty
5847	payment	1397	1397	1678	1	1	4642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWtycwiari81TyKnuq6t4ARXZDNpcFBwrtbJcu3aBhbDxt48J
5848	payment	1726	1726	1874	1	1	514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJX28Yh4Xwv4x9oRnp9vc6KSiyuVRm4f5WGT6J2mNNKTu4EFmn
5855	payment	1726	1726	1874	1	1	518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWhWMnj5RNmDk9r4xiQAvp4NqMzJbvpQbN2bttzKDhJrJto5A
5856	payment	1397	1397	1678	1	1	4646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwdAVrVavN5uQ5MubBByAmLhfYmt9ZtGvY3Bg5YaE3GA6g2YW
5861	payment	1726	1726	1892	1	1	521	1200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLkYM5WaGUhuHv5WdZ81gs25LyivCrGATJRDx6aiwq4rwuwhs
5862	payment	1397	1397	1678	1	1	4649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ahw6s44BsWh5vRQR3s2qwxcAZX1ucBhRcPJzFo9WKGyuEyZn
5863	payment	1397	1397	1678	1	1	4650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfA6dNVMNyEhxtuh7C4EaYg4Az46EBtBRXBBcBVdmyUkPFNVY
5864	payment	1726	1726	1874	1	1	522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQz8c5wrK9JM2MhZfnzsXdUVj7k7yoCHSVJ1y7b912ns5MdJB
5865	payment	1726	1726	1874	1	1	523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7oa6EKPheMTtQAf675qD2MzpZz9TKA6AmvMit2EroNRGdRfB
5870	payment	1726	1726	1874	1	1	526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrv6uAMAqiY1uLmVuhvdzj3jeedRJJrjaW8PRzKqXGYnWzzmR
5871	payment	1397	1397	1678	1	1	4653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJX45rmsLusgKiJVgrEGi6hDjms6aMzEMz9SGbXFZFTR2XcAd
5878	payment	1397	1397	1678	1	1	4657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1LdYREyHSKgTpvDxdfM3Bm7e8zqin7Ht7WUQ7V2s2Ms7FBpD
5879	payment	1726	1726	1874	1	1	530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBEKQXmtQTcgvc86sXvouzZekPvciqxvGYoCFNhmHmcYcvAYeu
5888	payment	1397	1397	1678	1	1	4662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyHk135aCgVDvqJAaq8LkZve6sn1tnhwQhf5gD8U3PPoBhmQx
5889	payment	1726	1726	1874	1	1	535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYah7EgBNj9448SwBbZxXzZzCbdKUqQUWBcU8xBMYNHFmWxTZpE
5892	payment	1397	1397	1678	1	1	4664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnWZPWfZC6aaHsRvxDWh8gaLeM7AZg2CMrfrE4x87ixobR9h6
5893	payment	1397	1397	1678	1	1	4665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNKCKJQvCtk44vHzC48X2RYWD1BnA6jqTMTJg9AASvWqt5MW7v
5894	payment	1726	1726	1874	1	1	537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5D4Ys1QZeAmd1Z4A9auciPeS9AQEVf23BpJex3mEwxwNnTnTv
5895	payment	1726	1726	1874	1	1	538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFexxbhxbs79VjKs6ojw1bW3DfUmQZgyeae4U6mhoWX7MD4oG
5905	payment	1726	1726	1894	1	1	544	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLguiq5vsU5PEyDzXCbfz61YtC8jQgbLA213oep2w4Cyuthv8X
5906	payment	1726	1726	1874	1	1	545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTcSozkB3wGTFKVubNejdGyTYduLR2x32qCnKdnYAq58hA9hZ
5907	payment	1397	1397	1678	1	1	4670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mACMtkrXj5DdHetuGZRS81oWtdfvvLxhPgo7dv4FLXJyJbUT
5936	payment	1726	1726	1874	1	1	559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZTNPsdhAFjtybErViysNpfi1DkSr9gvJwynaVkCbxbEtEpYx
5815	payment	1397	1397	1678	1	1	4626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk85EGtkHutScb6LMzcvqQyma7C5myDeGiSg8tnMqCZQmGhQgd
5816	payment	1726	1726	1874	1	1	498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCj2x59brDkswYEo27TJvvaq3TrJAKES8avQdSHWEn1iQjNjDf
5817	payment	1726	1726	1874	1	1	499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65dvq7Yi5QuxQvD3ZsgyiesJmtoEHrHFXGZj83YBMmsH766n7
5818	payment	1397	1397	1678	1	1	4627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGcUvoMsHvwgEBybDSJP4gnXuLkk1e4RoMgBzBGBnzCRyLD4w
5876	payment	1397	1397	1678	1	1	4656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBJ5Evx1q3AZm3jgKJXTGojRScTEfqCtBW1Xc5Q65R6LcC6bc
5877	payment	1726	1726	1874	1	1	529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtT3c4mzHPgYbFtG2DM1HEZpcFL46Ubd3XLVFv1p199e4BmFFP
5882	payment	1397	1397	1678	1	1	4659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxu4oPypQPe7s7asidsXL7e6oodKyVVwzTqmMx5X8Txj4xsqiA
5883	payment	1397	1397	1678	1	1	4660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yKSQ2TTBF6Fcyqe9gJ4Wj715N5ua8rvooXkhvGphGenJTZuU
5884	payment	1726	1726	1874	1	1	532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jisnYmvgevgjVim1mK6R4kxnoEfrhjy8WBowzqRZKWaC3nGU
5885	payment	1726	1726	1874	1	1	533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNPz3izLspGXfC38SCFKYk2WHQX1Pe33dLSpqu4AssMEXaupyg
5896	payment	1726	1726	1874	1	1	539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79buBpMKtFXpfh4Q7Uuxe4j6CHS4tMSf72LmGEHNNnvWcB5h3
5897	payment	1397	1397	1678	1	1	4666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6phvy99ixW3B8r1UbLAZjDJSwBwP6XRPkGNvkysPtt2qdJww9
5898	payment	1726	1726	1874	1	1	540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1kyi9QX6HWvzzaKA4HMCgG52invegcXW7cfakmqRfpg88opZ
5899	payment	1726	1726	1874	1	1	541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwrif4YhwUADM6427GzugJNXbSejyHXBPmcb5Yk6fhv96NtDg
5900	payment	1397	1397	1678	1	1	4667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZnXmBwPPkdownwyfAypgzrjXVrwJaF46Q5GGetgTaxMAeJyN
5901	payment	1397	1397	1678	1	1	4668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsMbHCvEYvqSLGPLjNok3nAQW6wgQanace6Sw1sdWzK4XrzsnD
5909	payment	1726	1726	1874	1	1	546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjn8or2jmcoyt4HQFcLLGAH7uy6gjtkGjCpTzjvLi93bYrhEA
5910	payment	1397	1397	1678	1	1	4672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQk1MrtHKNA6rZGn1pLvXszdBugbF1fDuSCiUZ8xrCp2DNf9YX
5922	payment	1726	1726	1874	1	1	552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12DnMLcuLeerxwH6kY9kkAqFHCFEGd4zfgXmPWZjYaKF11GXP
5923	payment	1397	1397	1678	1	1	4678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocW5knWGHjqpoiB6eXjrWDqdxCqhtf6wjcMRj7js45s55B9cJ
5924	payment	1397	1397	1678	1	1	4679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYK1TSEMdrs6BrTqzipHAcL8ay77FvYPyTF8ZTQYFu1jDzwCr3
5925	payment	1726	1726	1874	1	1	553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkeSbDZgYWs9Uumb5BVs6YNbaxeKaTzgU8SdR88WuNxpYjw1p
5930	payment	1397	1397	1678	1	1	4682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVtURVwamgjMy6Tm52pCCuaZbVgwWYJRgT3oHYuacnJqcTJhu
5931	payment	1397	1397	1678	1	1	4683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYziAjiL3torbzu63J7iLFjseeQNU9jn8FgbnMQZNWUVbCzipg
5932	payment	1726	1726	1874	1	1	556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVt6dc992X8y8wjet8HsWqtsRQ8vZL3p7qicuHpwcYWT1SSL4
5933	payment	1726	1726	1874	1	1	557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8V4BdnmQ478TnFjUq9EXhanUjnsCX6zDjVjQrBBYG3QmXEe64
5940	payment	1397	1397	1678	1	1	4687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7cT8PC5s7ccuuhgL9wVw6LjDJSMUtjcyJAKeAW7FbAUDoaJE
5941	payment	1726	1726	1874	1	1	561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCqErx5ZwNKviM5VrJgY4hjRFzuGGpZpamLhpd94zbP1hgeZw
5948	payment	1397	1397	1678	1	1	4691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMNTJzPfHwD6j7fL4y9vh7n5xPS5GW76hEo6jU7JtQKiiUYKg
5950	payment	1397	1397	1678	1	1	4692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPsAxnFt4jQmJjBK38t3sJ8ERNsdaou8RpLVcgQ2FR5JxaWUw
5951	payment	1726	1726	1874	1	1	566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfJWcu3MdTmNBrmpGxjpaCE9oGAo5F9WZ3RzqG7XSZT1tg3Li
5975	payment	1726	1726	1874	1	1	579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN7ku9w1wJxe9WA81zNMoEcPVv92HTdnsG4hCgCTRkJwYLbAQ
5976	payment	1726	1726	1874	1	1	580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrcGK1xnEmJGDXMvpHUySxUkLRGLFzwFvJ4GRuTVtwHZD63o7
5977	payment	1726	1726	1874	1	1	581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENZvfo9EtZEChdA5RmxaURxdC2G8zPYi9ECWWv2bDTypQptvd
5978	payment	1397	1397	1678	1	1	4704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURxpQxd9ne59pSjJwJr51bsZm54vLqFxjTmVzEBJUNLzg6bSX
5979	payment	1397	1397	1678	1	1	4705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUHjtn8HQT7NLi8xU3rhx9hXcMqjZFrTggZoyTKHU9q5DaLDV
5980	payment	1397	1397	1678	1	1	4706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uLnYU6yFfAGrPFuYosFbDAW8o5rqe7xF53cGNCWtGs2zE4uk
5988	payment	1397	1397	1678	1	1	4710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUEEfAsVo43kc9eGkQ27phQKzYh9WU5SbJjeMdx1raRJu5oZe
5937	payment	1397	1397	1678	1	1	4685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGF8VcybTbaZGoNq9rWFcYaAS4TQwREPTgWpfPwSZ5ckkudVh
5942	payment	1726	1726	1874	1	1	562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPnqfMytpRMFBSRScpj7zf6hAonftjHCi7jEF7RoVgTWEZTWp
5943	payment	1397	1397	1678	1	1	4688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtccUBMKxM1KCpbmU6AAzp2encseeqjWchxvzo7oMm3DVR1dz
5945	payment	1397	1397	1678	1	1	4689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8oQ87dvu9BBYtixhBNwu4smh7NoDVYgbNF8YrkfYiHHtpjji
5946	payment	1726	1726	1874	1	1	564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEjkmkt8y4q6jHKELmqbQA2hXgUSuMCFjbGxknZ1VXTBSo1Lp
5947	payment	1397	1397	1678	1	1	4690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtApkme2NA7G5vbS9cCuHuCmKQuc4kLyeZUnPidt5ojatLQgJi
5952	payment	1726	1726	1874	1	1	567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDuR6Xvm1wCNLzdB7iQbhTkvNzFSsupzgYKSKwAC7rJHBSzDh
5953	payment	1397	1397	1678	1	1	4693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGv1DNjQdn1KQEeFu8nF79fpcxtthSw53iw3j288GBFdmVwdRS
5954	payment	1397	1397	1678	1	1	4694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4R9gHsKGUwvTJKhwSMoxuxxqBqTN5TJVkQzi4tPSUXUMrAVNT
5955	payment	1726	1726	1874	1	1	568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpi3peiq7AixcRGwaiRvoPtNL9c1o6vvhZA3TteqXK1BJYspp
5956	payment	1726	1726	1874	1	1	569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1cwKU7ZJAY63Z9NNdwZUAHBHz151myPdJ3WfiSbAcEvVfysD
5957	payment	1726	1726	1874	1	1	570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJenzvTZWMbLRGvFWwH5JzhxaWmM8rUBp2QkkZ4zgREqcciCs
5958	payment	1397	1397	1678	1	1	4695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD513gFm96pM9Dg4Y63QNdoFCyKXMKzwibfNqHAvgQXyUULsVc
5959	payment	1397	1397	1678	1	1	4696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Tw7yb1tr4rcF2pC9BjciYTSE2EvPbP8TAkrnM4HXLNNGuKQr
5960	payment	1726	1726	1874	1	1	571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiUstavB4iHBNkK6KurLcM3Ct1XvRWLY44h5ae8y1FCv2ksX3
5967	payment	1726	1726	1874	1	1	575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbPFCC586SbyT17FwvJt5EV7tSDoKjipm8mNWS4jk2JipeTte
5968	payment	1726	1726	1874	1	1	576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPwk39eBFLd3JQaLsgKEQvjev9EJSVdmv7yKjvvCj4nAnXQPM
5969	payment	1397	1397	1678	1	1	4700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnj3r3KNRUM8t8p1XpsasKtrcoiintpChmJeakU5UoSZztva8
5970	payment	1397	1397	1678	1	1	4701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uTFT24VVGivnS235zcGrDLNMNH8zvCkXPdPYsS4zn13meLL9
6018	payment	1397	1397	1678	1	1	4724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaQ96LdcxXwsHEprdC6JnpKXnM4MzWJrmDxPxPhvMTrF26rt4
6019	payment	1726	1726	1874	1	1	601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgXF1JW9vX8yzZa6CAEk2fJ8BoXN2Kteh9ddx8y7AKm2wDiEP
6031	payment	1726	1726	1874	1	1	608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2x4bqnNoyTMsCYNvtCRhEBS54kD7FieUoQdCfvBZtmS9cKaEJ
6032	payment	1726	1726	1874	1	1	609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozb4djwBf8ir8wJ437GtyX4NFAJeij7CbmVvvu7xJquSG31US
6034	payment	1726	1726	1874	1	1	611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTP49a7Rj3KP5kWq5gHuktUmLDtVQZktMbzxpQmcJwSPqdYGYy
6042	payment	1726	1726	1874	1	1	618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwBy2kyaWLLS6zm2hTrAoXgTkQL2cuJmVAB51giKbrJ7YubW4
6043	payment	1726	1726	1874	1	1	619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTWeGS53mzSL3gQ8y5QQUvR3bkxrh2BsXYJfhurg8hr8odACE
6046	payment	1726	1726	1874	1	1	622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1xJ5eJJUTzm5LVrLca2gjW4Rav5AUFAPM2cB3TFoEc3iW9MP
6051	payment	1726	1726	1874	1	1	626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwDFcUXgZ7q7hoEa2YdfBWrhX2uhU2MHBS1k6DxiS8JSS5teM
6052	payment	1726	1726	1874	1	1	627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVYSaAbLXm6ykA3LJ9yseuwnGganMe15z1mU54NeLhdDHcYA7
6060	payment	1726	1726	1874	1	1	634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZBmKg2Kpo8X9UDGUaw8wNG2gL5AUfE3yp7uFvN99SBn82QDPj
6061	payment	1726	1726	1874	1	1	635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwXAsnPyevpjBFV3uXDo4dWhTYiyBqVLzDd3ZTxQGfvv8SECU
6065	payment	1726	1726	1874	1	1	639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QojV4gAijffPvgVVFKZDnBUTDZTbt2hiSXR72Mhe5e9swD5A
6069	payment	1726	1726	1874	1	1	643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrgXhBB8GwcTebv724GW3ZfwYGvwibfg122dd6eCQZs7wUtm7
6072	payment	1726	1726	1874	1	1	646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCwdZCC5U76jndA4JF36fXLQc6Q1Vh2fLJSD2iRHAsQVmevAc
6076	payment	1726	1726	1874	1	1	650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8J5SBwtez98zKaZXJdwSddo7R5viLUD6r46bvu3n7VcMmAhHK
6077	payment	1726	1726	1874	1	1	651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvzaGr85z893HgVoKvSwJWk4GxbQMkPj9zXpNoKhMNNnt3RPR
6084	payment	1726	1726	1874	1	1	658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6itymbxJNqapjz5PLwQhGDYJuepNFAUJGR2ZuX9DQLL8cqzBw
6093	payment	1726	1726	1874	1	1	667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5VJg279EHi8NGxXCU8Qt2gWmtBxFKYrkHMfH6y62gLNosjT9
5966	payment	1397	1397	1678	1	1	4699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpm8NNgiBUEAsHWL1ESRY3Hjk9gXviJzmfyhxnxGcQ7r8qH1dm
5984	payment	1726	1726	1874	1	1	584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVd9r7PKLYWEQj43xG1Cd8newMkXWwGnxtUZ4YdAjKGro42Ya3
5985	payment	1726	1726	1874	1	1	585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWQWXMQ7HifvsFvn9cRhsXP4gszn81iQVy4sNUsUkZ9n4h5Rp
5986	payment	1397	1397	1678	1	1	4708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXRvf9gTzzz2SAHMZBP5WSQpozKNrrmjuPPW9n7HZopoCrahV
5987	payment	1397	1397	1678	1	1	4709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrD7Jjo6XB3VgLCTjLPW5LFAo6oJqouG1vkefDkoEEQdMyfKGF
5992	payment	1726	1726	1874	1	1	588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2PRbHgdNhGDUjWs88ZMXUYgTRy6bzj9m9ShRVYLCqgPDgYti
5993	payment	1726	1726	1874	1	1	589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdUbRHyk4tEn6hBdUGXvxTwTmmACkoR8WBuTNRS85KyTwhrf9
5994	payment	1726	1726	1874	1	1	590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsiqyHN9e6ewtCgHEekCopySZf529rFMNYcjLEsQC6EWwwRRP
5995	payment	1726	1726	1874	1	1	591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6qK3DjEbi2c1e73K5bLuoMr28xQxcy4S7T9wiUn6CamupSYt
5996	payment	1397	1397	1678	1	1	4712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8wmSzBtbi1yPd5Adani1e7EU5gykjPc862jR1X8bijyBTNv3
5997	payment	1397	1397	1678	1	1	4713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLSR98PDraMTueLNx72ouugc3kgzx7We8i22gfayrFyBhprQX
5998	payment	1397	1397	1678	1	1	4714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiy5tErfJrv268ubUg1ZxmzaKGRV7pT96TVziDKAW3HX4pZQp
5999	payment	1397	1397	1678	1	1	4715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHohotGRDh8HYaRetP3vDAKGaEBAqt1vYR7thsjsrGeo392GB
6000	payment	1726	1726	1874	1	1	592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6iUXLyLkAjbgMPaY2DVchxBE2R5vL8eeUb4CxzoX9RtaY8vKz
6001	payment	1397	1397	1678	1	1	4716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdk9HPyrAi7umuAE2jPv6vPFQT9TY5qXY3RBNoVPqRi6nVQo8
6002	payment	1693	1693	154	1	1	347	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpaJWzvu1zacqPfFRFh6X5CPGpcK199wkrC5GgCnT4o7pMrscyi9
6003	payment	1397	1397	1678	1	1	4717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaKwn4JQakRNm1pp6XCaXPrRAug1yRPKarbPcSHYtuNGNr28C
6004	payment	1726	1726	1874	1	1	593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnoWHueUH6nqgids1GL3nsu5ziB1xQ3Y6o231E7RthDcvdhzU
6020	payment	1726	1726	1874	1	1	602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDskcchkVB7Fj5WHZD3RnMuckeNsSJpq5QAE49TtHHXLXENmj
6021	payment	1397	1397	1678	1	1	4725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ySbMg2G5CXGWfAd2sLDsgZVQVXemUCG5sfFvB8vQFQDrEjRH
6026	payment	1397	1397	1678	1	1	4728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzzwW1g2o9N7feySbbBM7MN3w3VkMkUgbkqm1ARqoZC6dqRP1J
6027	payment	1726	1726	1874	1	1	605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Swpn5wzoaxJrgTY1zqakNxZedvRDaLebESpuCVnVzWsENmTk
6033	payment	1726	1726	1874	1	1	610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJXUK8wQFwYeLPdS1PNJVaLpDwPk1AQXX6T5bdJFvR56ZthZf
6035	payment	1896	1896	1713	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwSR1qCbbbDh8mZyCdTm27T8e46kXLMGjZhZnnLJhP6NkT5pL
6036	payment	1726	1726	1874	1	1	612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hXeNf8fMgvh84EdRxFjabEEMWrr317heLFq1GV9s3d7713js
6037	payment	1726	1726	1874	1	1	613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK17cmQaL62DyvQSDyQmGGJzrryZbqkZtBCTRoaxd6Q4CggkZn
6038	payment	1726	1726	1874	1	1	614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtFdFyQqVMoJwp4S5NaLPtLBwFkDimG6QvhPMRhMGovZFzjhb
6062	payment	1726	1726	1874	1	1	636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCSjmTudr5UryiNUWCy86cwC11uwHpBWG1VnRo1VB1gKnL7LCd
6063	payment	1726	1726	1874	1	1	637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH4ct6vR9TFfkrMcf9PRavFUTE8n16AmiYf6ZirX6HRsKBFW8
6064	payment	1726	1726	1874	1	1	638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwSZjSv2yxMoqEXKurigFu6jBUF4nBdvXFox6BgP9SADdxZd4
6068	payment	1726	1726	1874	1	1	642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyNJVK16vhRn2hcPQTsNri3wHCcFoj6iJ5dRpL9CS3qV5K2iy
6073	payment	1726	1726	1874	1	1	647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSxngm93R45Hce4oVTYTiAzBPACQnwkFYnZHFAJ5qzxLufKC22
6092	payment	1726	1726	1874	1	1	666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeFJh5t22R31wddABjA2XzRsc7tnWNeeJGqtwyYCSEyHANchH
6128	payment	1726	1726	1874	1	1	701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LEg6HnTYdQxPfhwqZS62LCApbGqpRcWmHKxRLGkYACNmA5bQ
6132	payment	1726	1726	1874	1	1	705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNngoYcsczUzZigDC1qpEhZvajVivbFjRt2rdzE2mHuqzsRRaA
6133	payment	1726	1726	1874	1	1	706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhq8sCzmKaNiGnkqouHFAfsg3nFCTZd8TJFeQDUNn7bnGQiY9i
6140	payment	1726	1726	1874	1	1	713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLWRijD1qJ87D323wnDC9CrB4P9vZqfVWvVK5BBZtQn6ag69R
6141	payment	1726	1726	1874	1	1	714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHzo5JS3SLe54SR2YxWdfZE3bXZ6cScVPhtJqvjwCBHKjYS7f
5974	payment	1726	1726	1874	1	1	578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtce1tWDS9ARYneff9u1RL8dmaVMswMoRqdYPwroCweXn36XQu
5981	payment	1726	1726	1874	1	1	582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX721JESW5sgWn9JxoSnosFSuprL9no85e5pZ4nhEfUyNkP8KS
5982	payment	1726	1726	1895	1	1	583	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2rKLZParfxmfVUXGFQGLdWaMmFYmATmpWLBY5d7tjnnVjiBdZ
5983	payment	1397	1397	1678	1	1	4707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WXQhzishEqn7naEgidv1XADRctTLamUn7ddkWUA5WvRMJnbw
6005	payment	1397	1397	1678	1	1	4718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoCHP5wV4D5JYJ5MBp46rfBKszABw5DsAd7ju5F4vCBnLYuG8
6006	payment	1397	1397	1678	1	1	4719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2uvocsAwBTvdePtpcuBWJLU3Nxaf13hrey8Rczwd6suq2pJ9
6007	payment	1726	1726	1874	1	1	594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChigweS2z4tfUhC8T56Kw7GU6F8XhxcrCq5TpJcFjUux3kxzU
6008	payment	1726	1726	1896	1	1	595	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYznTeHUvsNyYHpKawoisnXqLGohFc9V5XjHzL6NQDyvUvUYjTT
6009	payment	1726	1726	1874	1	1	596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mYvN1za4r6zwB8TyhsDLgU7gADKeFXUn2nBTLTQNkrijUXDr
6010	payment	1726	1726	1874	1	1	597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDhRxHrGnNzfkvGyVJJiVnDkBGP9SZbL4wDLGHZMRoUK7Vk12
6011	payment	1726	1726	1874	1	1	598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7fbmTvDTrzM5ZwnS5RHWuNsWnWXssXvMcMdAmt9S2YXudvSW
6012	payment	1397	1397	1678	1	1	4720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmbeN13k71nTtGrMPVy1UpPcmWTZ3c28fMp8YdgLcdhfVTHX2
6013	payment	1397	1397	1678	1	1	4721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWwhtyaDpcSfeMcXJqePPow9RdP4HQeMYoD69Hi1oVHRdGPjy
6014	payment	1397	1397	1678	1	1	4722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDqHLodFkUzjsWJv4MYvhf4kyyXhTR6qzqqkFJjFcx8mQZAH2T
6015	payment	1726	1726	1874	1	1	599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEwezxYMzE5fbt436hbcx1mPwrLZYdmHPhxTsrVHBVc8Z9Jqwo
6016	payment	1397	1397	1678	1	1	4723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszxPaF1HuUwZzyEfBmbWHoRK1iuZVTeUM7kBNmyrCHG1TfeHp
6017	payment	1726	1726	1874	1	1	600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51m5BudDojRnCQdVf52sm3Q1SpB88TXWcjqS57ZCuQ4RnBbCN
6028	payment	1397	1397	1678	1	1	4729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSwhV7hND5usuS5b1pEPACbdBT6dpD9Wcj2H82fMq9JDtG1av
6029	payment	1726	1726	1874	1	1	606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6z96nTu3Qbq8uULsYTDqzmNKuGBbCpCS5ssNHNFgiuP6UyyhW
6030	payment	1726	1726	1874	1	1	607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQxtpqN6u7jqMdGbMCwkLLBBAZ5LMXET92DMgXsCqgHoCoWAZ
6039	payment	1726	1726	1874	1	1	615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcqKYA6PkrQgy4cRJLhHFFW2SgakTVTmuaKJDspdj5zjuy5hg
6050	payment	1726	1726	1874	1	1	625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUw2cCS12deaP1MtK2KFx3hVSrDZaVd6cMncN3qrRDt7i239z
6055	payment	1726	1726	1874	1	1	630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZta8Bv4nLruYi7svig211carGanNTdkfyR9xvyLdMqGmXsiqVL
6056	payment	1726	1726	1874	1	1	631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9pMZBpsmPTePgMg9JzCw5wmWvgpPx7dqSdU9KPK7pvsKwP2m
6057	payment	1726	1726	1874	1	1	632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRSQ4yGxjZwuxkvmNTbJcV9vvH4eSdq3Lt91QXbaxdvjX3L7E3
6058	payment	1726	1726	1874	1	1	633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKw4aPuA9rwPJ7cJa9tLCsZJuDDDVFfArxh4KSkQTgUNUf2Wap
6059	delegation	154	154	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Gd3wqdJu97zdJzuanLHMj1ACTY8hZDi5YEBWJdKiAAmku2as
6066	payment	1726	1726	1874	1	1	640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8eT6qkcMrLDbYABfss2BF2g8dchwMja85GJFvfFc4iT7zzaj
6071	payment	1726	1726	1874	1	1	645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7qZZNqSy9QS91xok8PERUQs6y2y4dohWwP1YVpnW8tt92Rze
6075	payment	1726	1726	1874	1	1	649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a7MnYsxcohgkj9USYMg9DtuzyEqCC9ukSxeRT9wJjpAScbPZ
6082	payment	1726	1726	1874	1	1	656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzyxYX8D9dv39HBHRx8QG6xcqeHARe8mKhSjJ3WZbVW6rNRzk
6083	payment	1726	1726	1874	1	1	657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYymmgp7Qq9BNoFMPkGw4Qdve7B346nUZgHifKiLokR4qZW15R
6091	payment	1726	1726	1874	1	1	665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatttQU1cq2XEFdL2agKoL9EyjMHL7vDF3ozY7Rnm23TfqVmPf
6094	payment	1726	1726	1874	1	1	668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8G99SbtpZ4RXDGgjFYZdSfWXS9PiyuMbxLX3Jwr1vcXK8cXp
6104	payment	1726	1726	1874	1	1	677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjvhgSHXsrMC47qQpR6CB1en23kn2ZVgVP9mry37DbVUBPDrT
6111	payment	1726	1726	1874	1	1	684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXcepTHNCerpB3EyQ7pov3Cw3jMhfvLNSH7bxgHouH8Gv6hqP
6119	payment	1726	1726	1874	1	1	692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshhHfyK8jBNvkDCMAdsHhp5HU9pRe5GTvwiFgDApLXNGP1Y5f
6122	payment	1726	1726	1874	1	1	695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnjQ3qS33qb9qwUJMte9oWryyZWkxwVUwQoCnGWGQGeSMdFS7
5989	payment	1397	1397	1678	1	1	4711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQG6AC6WaobHyXpvMTRckR8ktoKTMyXpPcS8vkwNqtt8KzQCyi
5990	payment	1726	1726	1874	1	1	586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivyWXXUa7fGnwakLCH2eaBZXZrdp3THJLPabqvtvgV1uxwBeD
5991	payment	1726	1726	1874	1	1	587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmegRyZW2MBkgMkVmRhqwcwokGyxdgVvXWazLmrMpueQ91jzk
6022	payment	1397	1397	1678	1	1	4726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDmxTCzz7NJyvVhaCnMZTqTeUornXTifcUGUJia6tSbAskyT8
6023	payment	1726	1726	1874	1	1	603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT884aiPGq3J9c1kXyDMb1zjeg6mPD6fCgA8LP4pZLE7wEp6xP
6024	payment	1397	1397	1678	1	1	4727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvn28qjgD27hhohiemfP4eNnq3Mtr4BeJeQDE1FnEK2hzrASMA
6025	payment	1726	1726	1874	1	1	604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZU4mWY6QNJ5d5bbwMxkkq3wdBLYAjNXarPtmT8hEUNsfbSTt
6040	payment	1726	1726	1897	1	1	616	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8dzdth74tBKFjbApB3aHrtaZETkR5sSA1NX76a82N7WfE1skm
6041	payment	1726	1726	1874	1	1	617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78gK93E13GUdfpieEHAaDqzsoscpw8qrQrEV1YRkKU6A74P9h
6044	payment	1726	1726	1874	1	1	620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrUFz4BkVEnQyoXi7NmQx6UiHufLsotWwgaK7G8sb4DLk3Gfa
6045	payment	1726	1726	1874	1	1	621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToiMY57ga7mfGnEtBPAizTnkSpb4QmCvQPQmgkqoEN8RRXho4
6047	payment	1522	1522	1898	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9oEhtF7Bs9YNTCoPQc4bEsyCefSXEPqqQn4g3dgFSMxs1j31
6048	payment	1726	1726	1874	1	1	623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPAEya8dqpsQPK3fo9SMg6cEs8TRTEgw6smpjsmKriKLwujJG
6049	payment	1726	1726	1874	1	1	624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPWuU1zuciEehnZy1Wvcv7ftSR96NapWmHGHuEguSE6v1hW7X
6053	payment	1726	1726	1874	1	1	628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYg9c4VApxXX8C8egZJviFHw1fNEw4j3uKG3SHkejujtoFQjM
6054	payment	1726	1726	1874	1	1	629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59HzZH7SVaUB22jVsWQN8LnxPjsHej2HXQEJR3whnVN9pjgVs
6067	payment	1726	1726	1874	1	1	641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSb21ULtjbcWqJx9W7av4SES1b1e6fdXwVa7VobGQmkY838Yd
6070	payment	1726	1726	1874	1	1	644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJfJhKZ8nNMSv2zxidrBQLFQxZqtnSYMrrG1VmuqTzQpcQ1JW
6074	payment	1726	1726	1874	1	1	648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHY2TXdynUo8nj7QKfg9GDTnMhPmpH3doKJQFRqQnLEQLp83F
6078	payment	1726	1726	1874	1	1	652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJgaFibcRDeEPj3WrKjX9qT34fEd2XpPtQy9B83WY5qpXkFve
6079	payment	1726	1726	1874	1	1	653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHe7xZ5pKe6jgmjFkcSELknXnqYZEnRjuybcU43ujt9y6hgB9
6080	payment	1726	1726	1874	1	1	654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCGNV5TrnzSGpRSSYAXSyCVTVCxoHbdTgmqJsMt9KSQLMRo3a
6081	payment	1726	1726	1874	1	1	655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T5km22i4BRQHkekfHxd7yDVrmcerdhdN15tum1sYiP411ZBd
6085	payment	1726	1726	1874	1	1	659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPtGMnJyTQi75bVcheDMH9kpTPYwPKcVHZaPHbYMK7Fjgqbgd
6086	payment	1726	1726	1874	1	1	660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkYvcvKFnWDMqHAjV7m4PJUAki3VrNLgxXbWaqANRRaAznxot
6087	payment	1726	1726	1874	1	1	661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTtiDmLzHRmZHLSw7uKUdUeULxWzEUPf86RbwLAjHLXQfY2vi
6088	payment	1726	1726	1874	1	1	662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdRAp71ZGWrDcZgn83pVFfCaZJGHMMW5Gvwkca5DGVt49nP9DE
6089	payment	1726	1726	1874	1	1	663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAk1hHr3wTVQdpqouLb57Rzp1JqS2eDTdLGocD8rGSw3iQ3bjB
6090	payment	1726	1726	1874	1	1	664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqwVpwHCxqCQ5ywinmW1daVkpa5K2uVB2u7cA5oPCg9aqojun
6095	payment	1726	1726	1874	1	1	669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVwU1t18HEWi9ZweAcVfrhxqZRb7mb7huiJro26Qfv1uYro3E
6096	payment	1726	1726	1874	1	1	670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8BD8KmQ4ScWAbtq8JLrfQ9g3mogUkqwKBxGgMnEBXEP8A4LV
6097	payment	1726	1726	1874	1	1	671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujbkpPZZvzwQLX32pnP3gpHvpVBwBe3tQpLHxq1NbnYKFPPza
6098	payment	1726	1726	1874	1	1	672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEA6zNmtQvfWHGqdNTKtVRK8XSs7qrpVv4s2Jb2M3ZrbExd3p6
6099	payment	1726	1726	1874	1	1	673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpRtENwHsX2spaoGFqzibz21SxRXUtVvdoix5HsgSiQ4HkBaS
6103	payment	1726	1726	1874	1	1	676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh33h71cEGgTRgvwnNwoTeHsVLW6S2K2mQwyzQxnR5re7Y3tf3
6106	payment	1726	1726	1874	1	1	679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGAdBAonoEsk8Y6xQbazyFi4SddsjMSdpi9szvoMnAJMPdtaE
6107	payment	1726	1726	1874	1	1	680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsVRFrX8vpUBKiz2ZaaFKmZ6DRFEouqZsaYms74Jo5p2WJpTw
6108	payment	1726	1726	1874	1	1	681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYou8iX31urdnwctZV4y7CexyXxhxGqL9wyKmM7UCyKFtHMeFs8
6100	payment	1726	1726	1874	1	1	674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbD1CsUJMMFDD6xTLAr1rRPLUzGrALFq7Z8prUGmiBHMiVjT75
6101	delegation	327	327	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLpeQRG8RRzWAsEma9BeyRqMuiN7cq9G7XV8LnPgHBW2HtEpy
6102	payment	1726	1726	1874	1	1	675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANcwbkT7WmDRKmVsCNyK2RovzGWNoMxdy7U2KEKEuLrVBJVTz
6105	payment	1726	1726	1874	1	1	678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQhDFaxd6AKZe7feJ5vgxmr1oe9k62KMZxihNenjWdnSxLGDH
6109	payment	1726	1726	1874	1	1	682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvdZqRoC7Gq3TsSqAc5xT4dW8oRpjoJwViCDCNTu3X6UrZreX
6110	payment	1726	1726	1874	1	1	683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDi1qpxCk5r2amum9bABp8Vn13VQ7i2bXeKB8JyKtqtDAW81tL
6116	payment	1726	1726	1874	1	1	689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4PjKEgUBKTxNqD1RHpY3Kr1TfkyEoHw9tiQWFMPK1efFv7iC
6117	payment	1726	1726	1874	1	1	690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQkUNSUuxpKXsYNANM1JiVwcFZ9XpnfmpUX5SQeoJdVGomLep
6120	payment	1726	1726	1874	1	1	693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bAP2zESeCCfwGEkHBcGqGRqAfKi6HWzrrwZeXAfVMoQh3w1m
6121	payment	1726	1726	1874	1	1	694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu7EnhwFaWSH4vf1Khzp2xGzWxhBE37j5jS3w29pGQuWRXpZEh
6124	payment	1726	1726	1874	1	1	697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyihw61H4sfPrrTSdwgQNFKseK4EHDZAZGBBjphPt42Ek2wbm
6125	payment	1726	1726	1874	1	1	698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdRGx7uE4FTgDehzrP6pxZYNsmVwCnWEdyZpCc7aQbDEBmXRUn
6136	payment	1726	1726	1874	1	1	709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPsNReN1SHwtHcPkabrqA58YHugFhtahPpn2FSiriCAehS9AA
6148	payment	1726	1726	1874	1	1	721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9HBJ9nUzW7wecUYsrDQY7HH5i9oTL9UPhPpAtjPucxXQWN5z
6151	payment	1726	1726	1874	1	1	724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NVAxR2cqzQFBXzSpqeeLrLzfnrQM9Y3FZBfcmDHQbYUrRhN9
6152	payment	1726	1726	1874	1	1	725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhJ6pB4Y4GnJFpmcedx2zbn9b7xUxYbRcjMgEEiH76QNBmaK7j
6153	payment	1726	1726	1874	1	1	726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8QPH53pngXU9ftMDtuGycNWZZ6TzjdK5PoGaFme4YEQ2shP5
6160	payment	1726	1726	1874	1	1	733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4ZwmvmCguSm8oDSFr6CxDSAZtgriihtVXqdvmpGNXNFqhnQi
6161	payment	1726	1726	1874	1	1	734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7MA5XaYfh9AYPQw41USWzccSip8jkuv8VaA9Hc3UjuhzvGQt
6163	payment	1726	1726	1874	1	1	736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqofpZj1G7MxRTi3J3VGm9Q7BDYoCVU5Ghgs7h7Y7UtzueFDzB
6164	payment	1726	1726	1874	1	1	737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Jf64RfFRoFbT1EHKDzGZiQmCt3tdHTWRy5mBtcvB1oD6Fz3a
6165	payment	1726	1726	1874	1	1	738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjFpico5RHNuUgcngzynYzZrs55qkUPfB59pn4pkjcCEunADan
6166	delegation	1740	1740	1899	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8zFLUJzkGiKGibzWqrfJ1ReZbMb6i2gPCnkHYgWYkqHq21oK
6167	payment	1726	1726	1874	1	1	739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cm3bZyAzdXmQXHzc24roRtKDyBCxbUDrPVumS3vf9wZj5sgW
6168	payment	1726	1726	1874	1	1	740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGm3hBG6C4QK4zjTgFuoH1hykTHmsVm7n9EwpcsgekrPXhAw8
6169	payment	1726	1726	1874	1	1	741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSAAqwGHGHu32K3PiestpmAnZJnzp7LGEXyq4PYUctykmPMTF
6170	payment	1726	1726	1874	1	1	742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoCiCcckwm5gvcQy3gSDv8fgspB62zjynBvmoPxPKvo7hZxTr
6172	payment	1726	1726	1874	1	1	744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41r8BysiPYRXhnWTY8JUBUYBZ7HcjxpbSiwNmBFQB1hKkFMc2
6173	payment	1726	1726	1874	1	1	745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2NeNVKypjojPTeKBBY8a2QVo6XfDvgvaWAQHheAdiM7E3Co5E
6193	payment	1726	1726	1874	1	1	761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAT2p7HzzqKxAZZiWyBocCHTdfAsLLBjAfgrgR5A8VdESNyPvU
6198	payment	1726	1726	1874	1	1	766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDYFzbMXTaC9tH84hoC7HwPgR7xiTim6Ns6NyXGs1Tz7i7vW4
6216	payment	1693	1693	594	1	1	362	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYksUtEQTR6d9Fd6MTkh8rhAW4emvco2kB1FCTFbSUYG5sw7bdP
6217	payment	1693	1693	601	1	1	363	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZcUdvpntkL7mDnBEsa7d7uqsC3HmUFe2xdZUtM3FrozQKXqhEd
6218	payment	1693	1693	680	1	1	364	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZXuXRa4EURN8E4P6L1Y8tGo1X5REbhyCc8vJEJuKE5UmxFTuzu
6219	payment	1726	1726	1874	1	1	769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmv8p9LDcy1gZ99ebeQ69nkXucwhzLW4FYdaFqqn2Z3dXfSwgj
6220	payment	1693	1693	392	1	1	365	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaAVcpdC2fZUNxcH5z3d1KJKjpeSLbcw9qG3ZsseXus9XQLmZcu
6221	payment	1693	1693	690	1	1	366	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYQBRB5ewQmtxooMJyF81BQGWkFNPsWv7uEidQA17svpcVSQFPb
6222	payment	1693	1693	186	1	1	367	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZfezEf8G7Jyptwfjmpih79Fa7MaTmZSh9ESasCPXwcEsmTYvfz
6112	payment	1726	1726	1874	1	1	685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpk5npkuwDxkYHCsTgLFedEu1U9B2tWMKUre3XiZ3aNc6KYGqy
6113	payment	1726	1726	1874	1	1	686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoHa12rcAbTjt5qaNeUAPMDqeWwmMtW3pHRMJsweFRKqk2mq2
6114	payment	1726	1726	1874	1	1	687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfd8C9wR71y4Fq4Ru5gtw2mDuypjBYHikvcqCNvnvDu52JS2F
6115	payment	1726	1726	1874	1	1	688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqLZ51G36imVerfqZ62PUMCBR5C83u4LRM25TP1RDHtD4iFD1
6118	payment	1726	1726	1874	1	1	691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8psp6ckv6TdTVHE5joXKSedpuR96ugHrR4aXjotsEaZ9baTZX
6126	payment	1726	1726	1874	1	1	699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZiAK7LeM621cW51hE9oCt4FgpfsNAs44uNLiEMX9aV4sxz4ob
6127	payment	1726	1726	1874	1	1	700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTk1vX19ExNuB3a94oPmxxdh74mCyx1njkg4gHkPKBLH3CJYm
6129	payment	1726	1726	1874	1	1	702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGM5ymaPWPu9VkdXCD5mDhppvzp93PAJXGFypQMRrWGJG5rJs
6130	payment	1726	1726	1874	1	1	703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQGTDsrSuLT6PZ93C4ttyCESjUKqETdL89BKYjejham7Tz1Dq
6131	payment	1726	1726	1874	1	1	704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKMrJbaarpoMrQ2tke3Xknr7LHXZNX9rLkTFsxJLXjkFGwsHE
6139	payment	1726	1726	1874	1	1	712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw11BCeNveELdnX6SkD1ncxDqbpTxWMC1b5CV2DUtNU76VBD3T
6142	payment	1726	1726	1874	1	1	715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozywTJi33pcgr5cLVq3DPX74mWJrJhoorAW2KMq1r8v5A57Df
6143	payment	1726	1726	1874	1	1	716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLjcxAh2D3gzHxw1c1CJXeyiHgFRZ53Z5TCYzy5eMGrCYUBdC
6145	payment	1726	1726	1874	1	1	718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDGXfLmUuCCLdmFi4zBc4W2vooTuJKV2DAdUvJjfoV1xjMxtL
6146	payment	1726	1726	1874	1	1	719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbdcK3HCWw5WxQkmZdDszkLftbfuhBQzhr1h4DZWYF5ZMyq8S
6147	payment	1726	1726	1874	1	1	720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTHyg6cWszfXHXWUp9HefoBrh7uCGRXE8F1U6ptNpwN6pQZjW
6154	payment	1726	1726	1874	1	1	727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTQ7sN9wD9d4dgb5WJFxgzpCTmvP4cZp2w8tNwbVt72fXmoeg
6155	payment	1726	1726	1874	1	1	728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EcsZi2x4DSgkkL9ESQ5YuW2dQj5mQVeAeSNCs3erQa69dQHX
6156	payment	1726	1726	1874	1	1	729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJ75zDsFGcZRNi66Fbn6JgMV4wBUzqHwMNBgTh1dHSCgMoYmm
6157	payment	1726	1726	1874	1	1	730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZackcdgfWqL38ySNfCb7h8VqpYY3t1UGjnn1S9A18smSVWrmC
6158	payment	1726	1726	1874	1	1	731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWjX3kRL9qw3Fi7M9RaY2croCovdf4oHg1NJZL5Bw4gkDU4nq
6159	payment	1726	1726	1874	1	1	732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv37r4vE7vjmLSynzjW5aQPSBdN8uAgm6Kaf5dR5qVQakYWv7Z
6180	payment	1726	1726	1874	1	1	752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq19uHgtBcndWPrQSmwD8348uYp6CMBgbjMCvtujhdXyxzjuWL
6183	payment	1726	1726	1874	1	1	755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuKEYKhcLtdxZEvHXPctxLmX8wzb4XLds88z97cuYsTWHrupK
6184	payment	1726	1726	1874	1	1	756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AQNajTzEM59va4F3hYxJNqKSx6epwhgFPew2x4kEkZs6zGaC
6194	payment	1726	1726	1874	1	1	762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwa5YnYkfQ7GWDe6RUVZWvxBV4c6C2ttxLmowAwkBkJKtaG5b
6195	payment	1726	1726	1874	1	1	763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPjS7hDR9kPAfJ5bf39V1epVKTeHpjMrFzsN8XxQskPcDYgNhi
6196	payment	1726	1726	1874	1	1	764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkaAu9TKhC46QNjViTLLPHVuX1s4GS2cYE6QqfZZWNvhcDrCQh
6123	payment	1726	1726	1874	1	1	696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgng1eKKJB6QcLs6AyXcam7aJNniTApP8PbvQSKnSPFA4DptD8
6134	payment	1726	1726	1874	1	1	707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NGZwLa7nMVmWab45QgRRdVuyEPyMQiy3ms9oQHKgW5keHNSe
6135	payment	1726	1726	1874	1	1	708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4MbUmG9Ph9bpmtX7fqwrK45zLuWHSKT4r2VyDnMt8UMZRqQ7
6137	payment	1726	1726	1874	1	1	710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPD5AEo5uiLhyCxegRtzS33DgokhyeNwhKLS88bztTHnamghZ
6138	payment	1726	1726	1874	1	1	711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQcR1prv3wsowh373ciHyuc2u55xehKKYxpBxCnZ37etGZLBL
6149	payment	1726	1726	1874	1	1	722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU4zBgdMkN6rQpNbn5wnZWUjuG5Q7ZKAidmR2bk2ao6zHDFHk
6150	payment	1726	1726	1874	1	1	723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UDERbzwBxfEJZXZWfxbY8EaDbF88G9g62tYEu3TnpzQdYxJz
6162	payment	1726	1726	1874	1	1	735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tPoTfrdbxNmNNUvQaCYryKbCRDj8EhEw6rrXqiV2wApP4hGT
6171	payment	1726	1726	1874	1	1	743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Jp3f8k2fPAaeYwKQagzDXG9bjiQdYwp7XR8GV4MapTNDdn9F
6174	payment	1726	1726	1874	1	1	746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMCRVGFx2TDqaZvJ6MnkRaCEh6jgQ6boCiN5DA26f3u82hZrR
6175	payment	1726	1726	1874	1	1	747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuwkDTF9pT6rgjWQdRS7BNMoLEPckFGmbbYmg2KVNAk14N6Qx
6176	payment	1726	1726	1874	1	1	748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeK8dDbdxSSismyqxZkati8p99NpM64ibnBdFf4ywJXoGSRunM
6179	payment	1726	1726	1874	1	1	751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VHsRXbd93YxqbAqsGZ13FxcYjRfPvRmisHPi9LKFmnn8rHxN
6190	payment	1726	1726	1874	1	1	758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyXfvDySpHr2F1S1HfJMFsp9kRG2nPLKzJE7KT1Dgbxox3eWm
6191	payment	1726	1726	1874	1	1	759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5zinRDwN1mJaf8hetBxP7QLzwvqsdn14PAZYJjZ29daBjbwK4
6192	payment	1726	1726	1874	1	1	760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoo1sVdMKw5k7YwmuVVTroDhKphdvvPU8yqoS2Zg2q2FprEV79
6199	payment	1693	1693	309	1	1	348	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYptLHxRj2EDdTUfEM15UwviNZvQVaTkDA7pG9svZSMpvrvWWW2
6200	payment	1726	1726	1874	1	1	767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDuQy9gmHPiiCjwTrpGDjq2fYENGn52yZpS1TpH2BLx12iVFs
6201	payment	1693	1693	150	1	1	349	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYyMHjgS7pARwY5w7oPqnahmrgsm6a236wPekKaYKSs3nfR6AD3
6202	payment	1693	1693	92	1	1	350	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYdWjKzpAViau5KqtqebDAsd6BvZnNT1ZwFciM1Jguh26qwStqx
6203	payment	1693	1693	63	1	1	351	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYaxEcG6Am4CQz4upkBEum1uYJQoZSpG2Sdir8W9TZpZFfFZa2Y
6204	payment	1693	1693	450	1	1	352	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaBmL6wHrwDBjWbwTA4p5JDku629ujmKVdg7hfwpH9DNAJR6ahX
6205	payment	1769	1769	1900	1	1	17	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUGNMcYSaupa3AK5D4GiJkY6wzAVDm7hkqhxHDWn9ixVdRujo
6206	payment	1726	1726	1874	1	1	768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCXFQtL6CCBN3iBjGCpVgQgcYtJyqHAqj8DBbhY861LtnQBEd
6207	payment	1693	1693	452	1	1	353	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYs9y75U4r3f8tgMJzS6nrs9VDvTZs1tXw5nAXE1r4qnYiBzTcE
6208	payment	1693	1693	322	1	1	354	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYhRpDJb7iX4UY9xnRtm2yT5fmWuv7W6NZ9Q1BjRLNjcPa5QeNg
6209	payment	1693	1693	373	1	1	355	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZVnTCTJhPBYa1BwFzhR7L2k6CH4N8cgCDtj8oc3rPfbELasYw6
6210	payment	1693	1693	408	1	1	356	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYxVcjeqMA5nRNP6mUKdYFGMToS3YZFe3hWkMhxzct7FnxeCXuo
6211	payment	1693	1693	453	1	1	357	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ3HiK7sWnCAuwZEmfzAQ1QWa2ZEMD3pvp7NeiVuKUEsuoKh5ae
6212	payment	1693	1693	593	1	1	358	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZW3ufHKzuaHSZ2svDkLCbZhk4Gsyi56FmD6dLMoXiU6Y8mNRgn
6213	payment	1693	1693	91	1	1	359	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZxPDHrDtksf2hSsszkeLVCYc3RNt25wkFxJeG9XKz4pCgxKDiq
6214	payment	1693	1693	438	1	1	360	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZGsRokbxkY5GBPKJSzZiezivx4EKJCw6hcizCqnPPYHMXjhsk8
6215	payment	1693	1693	339	1	1	361	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZNmooNiDS8ihLMX3ZhSMe6LLysr47ZbYRA3xNZkpRqHWn3neVr
6232	payment	1693	1693	731	1	1	376	3896848722	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYvuqoHwedDtUjjS7ZQL6hE9gjFL4ZCeHXzwk2P5wpbXn2SZieV
6233	payment	1726	1726	1874	1	1	771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeWSjamSxdDdkG4RyVHMwoAkkw7sETbAKNRfPMCZB3gMyY5Va
6234	payment	1693	1693	295	1	1	377	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZcWs7ukxg1rvx9QHcn7qdAuFsBCnSa8rumwt5vMcuceWKW2kT8
6235	payment	1693	1693	551	1	1	378	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYsCreSW1Um9dQVJLqJkR1fDBGj5HyU9a9HkbwjPfYoM4WnPtcq
6236	payment	1693	1693	520	1	1	379	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaLMFMKo1W4fr62qYiRhXP4M7zLACaCUbKYiEK2afi8fPskA63q
6144	payment	1726	1726	1874	1	1	717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPW8sWp9Uu66Y8ykocdAnjgbhyjnmrbvV2GVTjT6MAzNb3BZkH
6177	payment	1726	1726	1874	1	1	749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQZYKLG3wKu3upyiWmC3EyPoFcS8hiesDBhbrKkGQ3gERsdtP
6178	payment	1726	1726	1874	1	1	750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVoQtLNaaKuW38QG2reXAoJzgcFx3DN6oxjqxzgXeZp9K3AMr
6181	payment	1726	1726	1874	1	1	753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJJzceajfSZ3bYoKopK3z9PHwHQP9BRxr2pMgGj5mV8cFN6X9
6182	payment	1726	1726	1874	1	1	754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzG95xuYnhDS92ynuoZj1hduVFqFdrREgq2wi9fvhkG49E69s
6185	payment	1643	1643	1299	1	1	5	2188768114000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRt3CqPr4Fk2T1JDeaMC2LSeooLXRgXXTxa7knLCByPYhh8iRA
6186	payment	1643	1643	1053	1	1	6	1164134907000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudL3ixQSo4u3fSEbm6jvDq7hrY9HcAtkCqoexx153Fi25qTtP
6187	payment	1643	1643	1173	1	1	7	785465018700	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVtQsZij5N8Rk5P73DX9P23hGeRBtEZzS5nFhFuyeGUWsAE7A
6188	payment	1643	1643	933	1	1	8	649631960300	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuEQvCmZNHkVYykYwX1a9ojFQUwviNQwJAwMUwTdXzBbdPXbMt
6189	payment	1726	1726	1874	1	1	757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRsCwdbZGc6BRgMg93pxzorBtsuvUUKZnnLh479HByaKzhQwW
6197	payment	1726	1726	1874	1	1	765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ngsNmQLtpbhNRjKrLHr1yfRVuf1h9Gvh9gBXSoSe8MK8iQty
6224	payment	1693	1693	1811	1	1	369	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYqxiYsnuTwsHJ1wRgjet2r1sE6nEot38gFwvK4CYLFz3PtxiPD
6225	payment	1693	1693	383	1	1	370	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZKoBoq5kKzG26kqWg9T46ozFDcDwKvdTvyZntPZAoxpwgP78CK
6226	payment	1693	1693	308	1	1	371	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZR3XjKvUHR1cpWwm4BKmde25uCpMefTKh866UMico13SXtvmyP
6227	payment	1693	1693	1811	1	1	372	127286667170	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZMHGZQmPZdWqUGvEuSVMDUriAQ6nFDSt5UN83w8fxoPKPAwaBf
6228	payment	1693	1693	1150	1	1	373	1184398497309	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ8iQTB5mhFZX1mRZ62bjoGEnxvuJPUtS8YKYeDS819XQo9WWVm
6229	payment	1693	1693	84	1	1	374	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ63nzERWjQLTKtyPR8Fpv1w8EzhumoWv1a9vQyUKbMRM1Eod2x
6230	payment	1693	1693	678	1	1	375	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYcQL6ybTLmYj1jBtrzAEFnMn3PsdN32u5gfuF9Ch6zXQTSFSHL
6231	payment	1726	1726	1874	1	1	770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4rdExS1bDwob9wEUKfTMu53RroDLRokGLZwVjg24TQTKfRTA
6223	payment	1693	1693	89	1	1	368	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZRtAq77w8DFibvMumUuo1AqrzizPtki788kgifokvhHihNQVj6
6237	payment	1693	1693	653	1	1	380	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYp5eZE3swk4Ukg9exG7jw9Hc7FnmcbAUbDdnUwWvVFEUajtZna
6238	payment	1693	1693	622	1	1	381	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaB9gGQ7KmVshdTrcwcNcP8HjGKBnJZzLEERhwWjbRzSPNeaKkh
6239	payment	1693	1693	105	1	1	382	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZFDkT71mfYPa48r5eadZ63AmBsQCvdARbjGCMZMG68bvPkeE2L
6240	payment	1693	1693	122	1	1	383	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa7GP79uNfhvdhGteEwMR5UNsbKdfhS8tzx6Nm12T3BCSwTyuoH
6241	payment	1693	1693	721	1	1	384	3896848722	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZCpniYCMNgnAk2T773o5c9aSFLwpGmEVHcFcqaB28PS4Dd3bHt
6242	payment	1726	1726	1874	1	1	772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm92MJSGpWmDwuBUN8WKvb13b18DJWvBuXNyKPuT6FTQpaQHX5
6243	payment	1726	1726	1874	1	1	773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXmro22g1wHzEd33z5CwBGqvHLQPDLteN5XqQWN8N4xaHGbYN
6244	payment	1693	1693	206	1	1	385	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZvL6SV8nSa7t8yiBrtJGSLv9tyisuh9kCJH5Zt9DrrkkEzRFgE
6245	payment	1693	1693	304	1	1	386	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa2H6nGDywzzR2kxsUDDZVKkSuyB9tijfkDbkpdoY6RLdMiFM6U
6246	payment	1693	1693	399	1	1	387	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ6maCeTvZnSzLMo3wJ9MSXcsfmD8BTEPgBVeF8SXC1nuF3MDSC
6247	payment	1693	1693	194	1	1	388	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZsLCfjSLw4deT7hw8k3FhQjGzbD26HzbViDNLzUYYeoBRwAQwp
6248	payment	1693	1693	1276	1	1	389	3300431723570	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYk9qfPndAydhfXHxdPmxJqMLSiAZnAJSuvYBNb2hLvBafkhPdP
6249	payment	1693	1693	877	1	1	390	395633738066	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZB1ZdRHxfFckXPebpuoyyW2An8ZAHuKof5QwqPTTsQYXpXMtJ2
6250	payment	1693	1693	878	1	1	391	395633738066	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYiNUFHum3sLYp1oMjasikqfzTGTgAkxpVf1vCgChkYkCfKoJ46
6251	payment	1693	1693	193	1	1	392	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZZ6babxnYCQzdJJie17NvWWu8i68AuiJnsXRYnVkwzsZXukzzD
6252	payment	1693	1693	504	1	1	393	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZYYMwDFrL2KicBYxmFZavxy5x4CvMjirupjp3cJCHAcF2DLuUU
6253	payment	1693	1693	1811	1	1	394	13048597976	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZtEheNdaH2U835xt267wx6isiU1tLvtzJQ7VZZgF3Gf7v56p9x
6254	payment	1693	1693	78	1	1	395	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYQJEpFXZBQM9xxuxPUmCLtpGTScXJK4VgMU5A6xFD3kN4zPZ8o
6255	payment	1693	1693	658	1	1	396	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYXnjhpvguvvcCvMUCsGb251XR3gjzmLbfUwDQLRv3taoTzbjv8
6256	payment	1693	1693	205	1	1	397	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZAvMLzwpNmHJVg2NE4k5zKSndKYZTV9U4d4BKtosgiQAa8dEQS
6257	payment	1693	1693	660	1	1	398	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYrKxvPNNRJbMiYYMt1VTwe4DjLw9M5DRfwWhvRNi9eB1KTt8kd
6258	payment	1693	1693	745	1	1	399	3896848722	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYTSiJD2Yk9Vy6KPaL8KtoMdnZnXVTVWFEdft47SLgvaXAjDL73
6259	payment	1726	1726	1874	1	1	774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKn437Q1gNUvGyTUe2PWsGKWtNGkxDoncnqZQviJdtntCJcki2
6260	payment	1693	1693	29	1	1	400	13638970574	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZkcBikVus917PgLMdhbnf5eDHRXApMsohEXdR7dHfMmkrGzdfR
6261	payment	1693	1693	138	1	1	401	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZSypXfsiaK8XxjHR1vFgdHBbvyUtNdSxgsScdmnbCuMvW3NqLr
6262	payment	1693	1693	146	1	1	402	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ5EMoo25mJjniTwYVr6Q4WMT57EphtP5RfLTiCJvgBXzuspzMG
6263	payment	1693	1693	395	1	1	403	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYXy1Pxzo3LLmyuyfow1DgozBEkLvhELXraCYiFn5RNeoTe7pzt
6264	payment	1693	1693	587	1	1	404	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZzJUnoYgEbSm8a8RJXpXf7qRQYbfK3Rn9zrfBbt7r4ko5gWoy5
6265	payment	1693	1693	910	1	1	405	979576555661	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZP3JuuLD7KYefiyicsgveqnHMyLHAewXCF5vrVHRpv21fWBZvs
6266	payment	1693	1693	500	1	1	406	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZstDAJxCuGUJnXUaKmLPEcrhT7NmiUfeSdRx9YQEJueUdi7dmZ
6267	payment	1693	1693	611	1	1	407	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYS11ubAJNU3gFQiyEbN23Ub2Bf7XE1D24UjuVKvQiWPe6eW3iF
6268	payment	1693	1693	225	1	1	408	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ3vRCzYaqKfyiHHEkS2kiKZXCaGvpjUcGP9ApwBxhvf2Y6kawb
6269	payment	1693	1693	377	1	1	409	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZiXdtYFXwPDKGhzMDvDTUDLZADkvhoNgXvdHaQy75JF2ahswBE
6270	payment	1693	1693	560	1	1	410	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa93WrFTmwLW4YyfLvYiYSaZTZuYK4xEYBhirKWb4yBXgbZY4gg
6271	payment	1693	1693	252	1	1	411	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYtZwMGs4Z3cnVwa8HZDdBw6RjTg7rviPPuJ5UE9iDhHraNE68a
6272	payment	1726	1726	1874	1	1	775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkNu92BXfyV3q5S2Kj6yaiemDobpsP7dpJaXcBysdkttG4Br2
6273	payment	1693	1693	390	1	1	412	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaES3u8BqXx1qCAVyPRpzq8k4a4Kqgp8vpA6LnNVAzsvqzAMVhN
6274	payment	1693	1693	108	1	1	413	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYx4hzN4KsvzAULrjLtaSQ7rjyTFnPqtFJNjGgvZYjD8PcscgPk
6275	payment	1693	1693	894	1	1	414	597821247684	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpaCv8u2zJoQFZKLtKyABwFDbdM3FMXXMF1fXY7yCjUDevuTtFzo
6276	payment	1726	1726	1874	1	1	776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTSjbNKHsU24V8pBXUWfWVkeYrcvCsXUPmCgy4QgezZejUwNm
6277	payment	1693	1693	569	1	1	415	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYwvbsBZpPZb983NXmbrFdC3fdB8JNi2t1P9nCx8NcfQcs4sVwa
6278	payment	1693	1693	99	1	1	416	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYvjtxyqTJUpFvXbHe4dwLC5pJjL3gBEm7R6h1ykjYktEGEw7AD
6279	payment	1693	1693	570	1	1	417	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYuQT9r9FsPHuUujCXwvyPDTA3iaDDq4mSkouHydWX19cDePf77
6280	payment	1693	1693	49	1	1	418	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYcM3Xcr1J6wFvfjPatMwEXe9KUoeS6kbjDbdKw1GaEU2tuTxR5
6281	payment	1693	1693	127	1	1	419	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYcqgBVC1YradbEi5NPbkNwTtkWgPp8xdWkSznxPaedA2zx3bbj
6282	payment	1693	1693	251	1	1	420	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa7PRVquPEcyVvRQPsTfa9pJBsQu7pNPCcwAQ2thEzc6BHsoi2w
6283	payment	1693	1693	35	1	1	421	37409747874	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYV11accw886sJrueBbjLNLG557fNb9pMvayBRouqBqQL7BW6Qe
6284	payment	1726	1726	1874	1	1	777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1ZC9cmhRKZCTBccXtnCbtWXzWTHfJSQ54PjWkuL86MgaKQHL
6285	payment	1693	1693	320	1	1	422	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZBErGHyMaM5rjJ5p9kXvPqpdvJXwc6fMHMVksM9ZGbEEHmneFM
6286	payment	1693	1693	1030	1	1	423	1755392794775	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZPtpxtKrjHtCdVsQn6cJeZ3qjcxET4gCRmjC4DXqetfpr6vrgm
6287	payment	1693	1693	663	1	1	424	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZA1erfX4WfPXAr9moj4ZmZcC4JuJVWUXV2JK6RMymV6q2XY85H
6288	payment	1693	1693	499	1	1	425	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYzJQwLN5RUVvKHKaF2EeNNAwA98tvGBHeSomPQUUtNEgogu8xz
6289	payment	1693	1693	54	1	1	426	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZRYE3jqczNjkhTksFg7xAAjn2b3RQBRufb2DH8mWiN1mhHmDas
6290	delegation	1740	1740	1899	1	1	4	\N	25000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqz4dv58k61sGjwJfHtyPCtkPtfyhH1ePSbrEyUasTHi26eWoA
6291	payment	1726	1726	1874	1	1	778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVCFsaJsebsfY8V6hgM7Dc1HfTVb7Zyp8QpsY8zBgvdJUq9gY
6292	payment	1769	1769	1900	1	1	18	1100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKK4cVVRco6Rxj7sDsjbeaA8UHzWWQtwxfndT3VmGfK3xcnmH
6293	payment	1693	1693	710	1	1	427	9742121833	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZuUbf3iy4hBZJGwnesZoEPkqTkqBs7fvhgUPKfMa1dXpmaVRbX
6294	payment	1693	1693	1811	1	1	428	19484243671	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZXXGsKk4k1DuXsfD1zWNPXhfK529GT7ox7f8uBFXbS4We4UFyT
6295	payment	1693	1693	217	1	1	429	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ4GDMrz9BuxvPwBUmYomzx3Ma364NPXJ3VPen6JGodPE1C9eA1
6296	payment	1693	1693	103	1	1	430	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYnQkvRD3vXMojCBzGQzgw8MiDjZHn9HhWdpduKERaC1CzW8Ujp
6297	payment	1693	1693	534	1	1	431	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYiR442FfRD5yFQYLgR9XKjwi4L9xMSSUaecTT8y7yk32wnmJPq
6298	payment	1693	1693	245	1	1	432	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZLMfhTRTwKJCzrntJ9VRpdzVigZPKzs1iRN1Zs1u2fEnjq3E2U
6299	payment	1693	1693	421	1	1	433	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ3vNaLs6Mq3w3gf1ogCxtQW2ZHLHBK8D6ezA3QHCCXegPpKQHv
6300	payment	1693	1693	620	1	1	434	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYfJeDTQE9qm4xZPUtmeDXodaTP5osNxCmaT5JxZv4XaBUaDysk
6301	payment	1693	1693	352	1	1	435	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYmJN2S3evCRm47ZAGxZwYQHURRhpBZn3sPBof8MrUSALVWF7Ku
6302	payment	1693	1693	691	1	1	436	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZz9WdchF5Yv9qiCvZjk3VYFxpAsTFpfWshobTgDpVFhFZ3KCAC
6303	payment	1693	1693	191	1	1	437	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ6SZERpsKJfmGppv3Hju8ihmZj2drkBamrEx9gqvQ9h95Kv6tN
6304	payment	1693	1693	266	1	1	438	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZnGz6bT8ckTbBSHyJNbAKByf2v1T4rb8KLMu8aBRtYFF3t4FbS
6305	payment	1693	1693	353	1	1	439	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZP5ZrQsTSqmKESBPPDHGEXFN6AWaYNfUTH9GTjDva4M2RAaPRj
6306	payment	1693	1693	600	1	1	440	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYvLSUm3qdJkEugiAeDvzvHyZzDtUqPMvttVEavTFwzkmnBxjZt
6307	payment	1693	1693	420	1	1	441	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZPeh4K4BtKS3aJqcZkRqnYKpURbZiN1iRwx71kpXmQN4fCRDiT
6308	payment	1693	1693	893	1	1	442	597821247684	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZSnHWRb4noFmxt1WiCaR9UvCjVr6yCzUh2bBxvQbYswpLg4Egm
6309	payment	1693	1693	180	1	1	443	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZRe8VHJr19XFfegVMshGTW8GFUKZymSux3V8VLC3ujCT28Vhpq
6310	payment	1693	1693	112	1	1	444	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYqReNgZFRC6D9vVveswZa8jJ8JpKdwT1FjA9FwMUnLUje54FoD
6311	payment	1693	1693	106	1	1	445	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZU8etbF1aopgwnqr33xMHFdGQcg1Jt5kYC3Z2PNwLNpJqVA73S
6312	payment	1693	1693	1811	1	1	446	63436800585	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZJAmA9KNtLPJRVhte1W2KnzHxnN6PrGp2wAf94jaDCoXpQ9HpS
6313	payment	1693	1693	652	1	1	447	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYhuiDwXe7bJR8KwrkUMHSi45nmGD6rZRrFoC47nyLUo9pZ4tu9
6314	payment	1693	1693	397	1	1	448	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpYnWT6St2MsrXfQd8NjFQcrBHj5xBy8jpuVLsKnm7i5pe1pSpo5
6315	payment	1693	1693	391	1	1	449	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZ2SC8qJ496ZyZMpRmSKA51ChsFJiGg6DEEwHgADEdv5EtA2mmB
6316	payment	1693	1693	201	1	1	450	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	CkpZJ6SPTtk8R6nkMvegQWNqCympqcaNHx2DTYpJzyR9mov1vjij9
6317	payment	1726	1726	1874	1	1	779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NPLuPRGKzkVy1GUbWZwtX4FwWF5omefM9AwBLbkEP939kt8s
6318	payment	1693	1693	261	1	1	451	128596008347	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSDcCyQYzSUzDL8xQLi	Ckpa6K4U5Px7YLf9dEYXq66WWK6S7HBZvAy3hLEHFbg35w5Nq8DSE
6322	payment	1726	1726	1874	1	1	783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbftNNUyLu8MavztNFgcZkbGLo4pxTa6cXxpBSgh1WoyQjTPF
6329	payment	1726	1726	1874	1	1	790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHfRbetXKmAbBPnPg1WQXr88YGSd8Ugq53y4u3bG4ZvpCA3n5
6330	payment	1693	1693	402	1	1	452	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpZTR55SJZGaeEK15PoJons8QSrpjCCcAq98jZDUTo3S2cLR6cT9
6331	payment	1726	1726	1874	1	1	791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMp9MtthMfvDY3xYfQE5s5QxfXuX33C7Fp5vznTrtCo5mDcRx
6338	payment	1726	1726	1874	1	1	794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJd5V7ZiDXfEwjBvLD2NVn3uwCvHC4rmcvFsCnfLS2r7QDit9
6339	payment	1611	1611	554	1	1	0	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3TVfyNavQ1EPtYncZL7areWKjNxrKg5JrUxCq3YjdmD7omyd
6343	payment	1726	1726	1874	1	1	798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7QNQB2XZ4jQvTEmEAxNeMbughmh3P4LT1nRSn7ntiLqJRrab
6362	payment	1726	1726	1874	1	1	815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFq88HhPBjsQg1WTW4dUek8xf2W3xTCcshRNKvidTZ9AYHMf3a
6363	payment	1726	1726	1874	1	1	816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNZzGhiZDfJctYZnh8RyAHr8HdyHVcWNupRCohQPyVXuDTfLj
6364	payment	1726	1726	1874	1	1	817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPXErBTQS64i63aQeqwmY1xXRynvQfFtiQL4Buun75dWtKRD3
6373	payment	1726	1726	1874	1	1	824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1HBsM6fSc2WyYpUDveB5xXGf4KnBejYb4PcrbUnZo3ianwHe
6374	payment	1726	1726	1874	1	1	825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmh6V8fVvnCvvpgYCWGGAyVANxKqSryTjk8yMAkDzbKNTi4Ag
6375	payment	1726	1726	1874	1	1	826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRdX4ByjMij2qzoMsMsUZzUKxFSrkBEizRYJHcaAG8EvwzVfW
6380	payment	1726	1726	1874	1	1	831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3m3hQbojRCPH31HK99QavMY2C78pbRX4A9VK6UYY43ynZ3Jx
6384	payment	1726	1726	1874	1	1	835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYcQPT6p2kJ1aXuCxLRSNYjfmikw1pJKCa6u5Cs4tviJZ7oyp
6388	payment	1726	1726	1874	1	1	838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzPNA5Pipss37bq6GhwmN84PgaZKfb5NYBmvfXtFrkF9Bhakz
6395	payment	1726	1726	1874	1	1	845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVZKn65C5D9W4KvuBBeS95mYPhqSXnafMS6jc2CoQCuFCMA8v
6396	payment	1726	1726	1874	1	1	846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRuoxUrbBQEfYRXSERonrFW9vTc4V4xaFKeCS7zDsDXan3tTG8
6399	payment	1522	1522	1898	1	1	2	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZP4RXN3ezJptwupd98o1MeDcycgCe9ZpEan7e2JW415iHHUq
6400	payment	1726	1726	1874	1	1	849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZms2YGBxcGAGMn8LJY9dRzZx5grYT6DLb2KFQWLcD4yuHw2oBW
6401	payment	1726	1726	1874	1	1	850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL6ExugasW32wx7FvzZaMmMxMuxxjJJZLpJHvmrJKRp18arxP
6410	payment	1726	1726	1874	1	1	859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxKMkLgqrFEM6h93ckGDSRnC6wuB4qyQdmDpcwEDVspH2wbkyg
6412	payment	1726	1726	1874	1	1	861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwww66UuvjsWfKpE8ARpTAQngEahBGs1cmFuQYr3ZGf1Dq6RQ
6413	payment	1726	1726	1874	1	1	862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KEpyYYDnrsEPBAdNi4AYyvYQPSAfvop2LNwd5uPuVhxKySPR
6417	payment	1726	1726	1874	1	1	866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFR51cxgXURNMrxAnQAW9RP4ABbh6x8JbgAnuZYDar26kpsjF1
6418	delegation	1900	1900	1540	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6B2z8QMKZePjUGsspUVav5pHDSz86BEdw9YMHKHGacZoGLVF
6419	payment	1726	1726	1874	1	1	867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GUQVYnnQSmWL7H3bFYyGGXuBAbXMRdxnXBUeRzJFkaKKW54t
6423	payment	1726	1726	1874	1	1	870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vhJNV8Wf1oe9j22QHRJdtnwjaho4gqFxWJtRmjiiLgcSxgs1
6424	payment	1726	1726	1874	1	1	871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYUwefibrzkWdgHanXiX8cxaQtsUm213BoLKBbJUhQjUpbhjR
6427	payment	1726	1726	1874	1	1	874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE53AzsWBPTWi4GiHQntaeybCoWjLWFVmnTeamYK6rjt9piFwG
6428	payment	1726	1726	1874	1	1	875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcn25T4XHJUAohbhS67ZatRd4iaPth6c8gQnTGWQjSUK3N5uvj
6433	delegation	1900	1900	1403	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3kUvG62pu74eUjgmEC9YSMpi2PQarGaX1TBDuUpHDEkWwNrN
6319	payment	1726	1726	1874	1	1	780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMrLpTDBgMzqgAQtGTrjFNAqa5dcEwn52bswYueyXBzgy4dnQb
6326	payment	1726	1726	1874	1	1	787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8j6mYQfSZkLQEn9dnecwsDfPTwo8Pj69qmc6YrYNFRAvY97Zz
6327	payment	1726	1726	1874	1	1	788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmntXT44kxDimFcYruv2dWeUMz8esVp8J7P9kETqveMemssMUK
6344	payment	1726	1726	1874	1	1	799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZuvDtoB1pjCSPWZ23eUiLxny3a1nbfrTcLjWgd6wRXDDeAyf
6345	payment	1726	1726	1874	1	1	800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TtDYxvExxLZgPDZ2ZEp8MZw8AuNBeYaEKqrWAQMNo2kU1u86
6346	payment	1726	1726	1901	1	1	801	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKYwnvPHw7QQsVKxTTXZTDkMGrbN3bPf2Vs2H19Y9sWCKVz4fK
6347	payment	1726	1726	1902	1	1	802	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmMLuDWPMrasZ5jiA8WLbPEKbHF5x1ykt1YAciMb8FYiMKEr27
6348	payment	1726	1726	1874	1	1	803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhp1yv8cfCXrpkJfTCQik9s48zNJcVvNDACgDqjcE14tuaihwt
6349	payment	1726	1726	1874	1	1	804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQtJ6GVE93XiE5w2Em2xsfGQSqLV2tHqeefH8SCv1hLJPBbDL
6350	payment	1726	1726	1874	1	1	805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4AeDjTGXotvRhxvMvTsLJjmdtbepZ1RiE7MJsni7wY7qoBbm
6351	payment	1726	1726	1874	1	1	806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFX4UF6bmcvYJfidQtin5zeDnuD5gBcMoGhAh7JsA9VBFx1zDe
6359	payment	1726	1726	1874	1	1	813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCsvpZjzVvkzzFNzu2Gm9fq7BvypgteVuMfLNe9PqxLdwJXhf
6360	payment	1726	1726	1874	1	1	814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwq1wPksD2BAcdFNgq88yJLLo9u3Q4WqSVfso3F9WBYPSY635M
6361	payment	1596	1596	1903	1	1	1	99000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2vMGZY859s9Mz44tH7vwgs4i72tKgycRL6mkf2Yonh7GTsQX
6371	payment	1726	1726	1874	1	1	822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgGfVdGTGLoHjWMn856FiyrZgseTxoKa5Tfqs43cYpRufhxqeR
6376	payment	1726	1726	1874	1	1	827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoSS9qmy9eFALChZw9UwEwTM3mdN3EtJQH66pbeuNGGHaVaNf7
6377	payment	1726	1726	1874	1	1	828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLeLnUiZRHsM1JMf5RfoKi9CAGq2EmAZrgaRGtU78ceMN6Lv4
6378	payment	1726	1726	1874	1	1	829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBcSh9jmA3yFroRCi2MqGzkuHvMg2eiCzJknzP912FRZLmmfM
6386	payment	1522	1522	1898	1	1	1	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbhbDeTduruNr4vxhrRAhWnJZufaEcyvsFRsNG6XgcvEb2xh9
6387	payment	1726	1726	1874	1	1	837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBURrZHxM9GZWVihyPotjLYSLmn9x5nPdEmmWP5CZhJHQQAhpN
6390	payment	1726	1726	1874	1	1	840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GJHvHzHz15HWHxFvp3Avmu7gHuh4o6qKf3Mh9KsJhec5bkVL
6393	payment	1726	1726	1874	1	1	843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDepVF5AqYDBM3sqyuhLKWv19HxFBjdFH9mvmemKrc3MYkHdJN
6394	payment	1726	1726	1874	1	1	844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWaroixUCTX2MSHazBCfwfHVw7KyQdZzhKZS5cJyYV6jgvxEZ
6397	payment	1726	1726	1874	1	1	847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaV3Yn4cVAG7A3moRJdkCY4prCKuUNVQtH7PLGtAWKpTnA3syd
6398	payment	1726	1726	1874	1	1	848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F2CfGzviNhpR713XQ5nS1a44jvXkDTgQQKgaNGQcukGNAAag
6404	payment	1726	1726	1874	1	1	853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZudmzQBUXyNjLD6K93dQfEpZU9p28vWErP3v1nhqoeppZ6FKYt
6405	payment	1726	1726	1874	1	1	854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ucpVARRT9VNyUfPCV7VaLNksACBwtn8qhQxLzcsVPFZtDp88
6406	payment	1726	1726	1874	1	1	855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFnJSd7c73wABsp4QTnv4ygr3Mfm8iWHYNAxdqRvv8Cnzen4K
6407	payment	1726	1726	1874	1	1	856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZEKSwFMJQ3DsYdGapBjmo5V6mTD66R9ASELQBoodjnY31oxp
6415	payment	1726	1726	1874	1	1	864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUMmPt3zPnPtfYaUMEkyuiSPBLntGLP6TUNWWUYusV87E9n4v
6416	payment	1726	1726	1874	1	1	865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4ZpNqLh6DXs9rNNiWB22bSn2pwCzo2hRY9rXjs7o3ozvjqff
6420	payment	1726	1726	1874	1	1	868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQG4oh4QHtdc39tJz59kgFekvXhVi9EKmfs1NkMu6ZduJ9rRjx
6421	payment	1726	1726	1874	1	1	869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8L6KY5Ah3PZCmPFufiXZdLC3VekFxPwVKf613RCvNSRPXN3gM
6422	delegation	1900	1900	1540	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAVDiBskpMHwUikLcVh1wCQ26hjFfy8xUZyXtj442N9xbNgFc
6439	payment	1726	1726	1874	1	1	884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AeUKqt3RtJhP4Tv4n3WMsqsoXBThoPMJ88RmqjiiwjYXf2iN
6449	payment	1726	1726	1874	1	1	893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZoAyjHpd7pe8RG8Z7teY1biYWGfRnVnL5khykzGXXC84xRXV6
6450	payment	1726	1726	1874	1	1	894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXectmpqYBnm2fBhfvU9zxKCbuVSDMGJDCtmQTCYp22TJP7Ft
6451	payment	1726	1726	1874	1	1	895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZwLzFsbp6mjBkXM8FUN3bhfn3DijF2cP35sfnpxXqxUBdXG6
6320	payment	1726	1726	1874	1	1	781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcd8AraNqVKFoFNbAfYJTkdc8GfibucLgoa5qz6V9MUoqfj13
6323	payment	1726	1726	1874	1	1	784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTDkQJeYLaf1gbeuTg3VtKhPyBGXAu7auRZanCyQssZQoL7u7
6328	payment	1726	1726	1874	1	1	789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fv6z2UEBNukxeRnM3JZnUTgyjav9YCYRwfLiqUzqxSH96pux
6332	payment	1726	1726	1874	1	1	792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4HynsWhzjB6RcWA1A31nE7gWtQLvRbj6X5RYhMyJWyEykMvB
6333	payment	1693	1693	163	1	1	453	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	Ckpa2XLzEMNEwnUtfvLaCB8M8sr8UJ5ejcz4VYWBfEjFTeRFW81m3
6334	payment	1693	1693	82	1	1	454	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpYvzCbdsWmuufXf5BsisTMBYfqPwC5YeoaHu1qh4ydP89M1DKA6
6335	payment	1693	1693	275	1	1	455	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpYVC1XtZxQHXBNhGeDRDkqLxLZeQCRAdEaTtDgrfh6ayjtP45G5
6336	payment	1693	1693	361	1	1	456	128596008347	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnMnqS6xkhZNrZEcHNScNCP	CkpZ1RFykRZqPTFMEgAGQwTj1ZPWa4V5cXvvXbgPzXrDKPzZE7NjY
6337	payment	1726	1726	1874	1	1	793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrojYgJTFiByDzDGKymWuiEcHFbfMVtqU8A4tZPGuHhPT5Nqxj
6340	payment	1726	1726	1874	1	1	795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QdieZ6hBTQ3XeCNNGDJX9RffMARPPdZ6iJTxLNR6k7bZCqDr
6341	payment	1726	1726	1874	1	1	796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZaeuenB3sTM4WGLyeWBCW3AGKAw7mqhXnM7gWotfm1x2VQSp
6342	payment	1726	1726	1874	1	1	797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnYZsLnimiRPovhJ28EMo6sRZ4y5Q9y4Uo86Cq1rcY7Q7hkfu
6352	payment	1726	1726	1874	1	1	807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1rG2ZnQ7LQZCNNUb57AJrDHMR4qnkwqrRWbSmQmCRmixxmJF
6356	payment	1726	1726	1874	1	1	810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRt6pN537fGMWy1oepxVzUXU3eRqgmmbWF5mrpDfvk75bv9EU9
6357	payment	1726	1726	1874	1	1	811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYiqVWGEVMn3kFUhMybiUNQF5ztsbHFAFAfMS75yQaef81HSBR
6366	payment	1596	1596	1903	1	1	2	99000000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYW1f53e2pBNLLdY1Fj42cwSSHB3bg4Rhxu4LrdmKa9fdA3kzz
6367	payment	1726	1726	1874	1	1	819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgzzqZUb95ot4x4LJDiL2Td89WSUurd1ccwKM6Bb51qgUSgp9
6368	delegation	1769	1769	44	1	1	19	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2UtJSyq8MjhY33iDRuwLFb4xt1wTSi9nJJezEBeVCvLPq4QZ
6372	payment	1726	1726	1874	1	1	823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8BDo1JZ525CAcMN2XrrLP13nfgJ1P36bacP6r4nYr4FhajRD
6379	payment	1726	1726	1874	1	1	830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJqLuZA5xTJqzzuRYaH1AUbMCnk3cYWcbtDG6dwRyV2sy8gqY
6381	payment	1726	1726	1874	1	1	832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH95h4CChPTgPVM3RmBvA59aFcFmLdZHHy8jTtud45Rf9q2Ww1
6382	payment	1726	1726	1874	1	1	833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc1oTyDGMQgCdQCsrJfdya3KQzUZMdv64oBLh3xQyGtWsbbtN
6385	payment	1726	1726	1874	1	1	836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQn65oaMVQEFmG454LEzPKSeQiSpW3K4ZxiCaWpTtmU1Db4Zix
6391	payment	1726	1726	1874	1	1	841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssoYS2d3exL4oeFsQK1RBtGbYcPWfW4oywF4jqhN3RwiwVafJ
6403	payment	1726	1726	1874	1	1	852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyyGLb3BXf16iYCbnxTy5RV1u71LW3WePJsN8o9CPfY1vtvYu
6408	payment	1726	1726	1874	1	1	857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikpfhLczGWtaFGD7wN2TvrtwzZvm6QkpsbUBZygcdRkFdS42T
6411	payment	1726	1726	1874	1	1	860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRS29PWaZ7igjYkfhrPk6RJ9tXUwYAPjbxV9F5WSTmXkd1HeC1
6425	payment	1726	1726	1874	1	1	872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWZGsC2FbcQ8SXJizerRpL3bt9xpEFRRLLm8qtajJXcgU89ns
6426	payment	1726	1726	1874	1	1	873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeXG8AiiEizFSW98bt7Lyr17jsMyHBGvrK2RFDBpN3RRUEhMZ
6429	delegation	1900	1900	1406	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpG8zj5BnsWZoW73B5J9Tv4cdDT8NjhGRJZwbBBKD8mZEYbY3
6430	payment	1726	1726	1874	1	1	876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9heuYEC8DfyhJEtVRTLAYR6BwWuTPGYG9V78bUXapr93qV54d
6435	payment	1726	1726	1874	1	1	880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS17FLoiLTkyXg2QCKBPL1goqyaZTwYzdWBmxfpgc2MeZ95xf5
6440	payment	1726	1726	1874	1	1	885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR48it15UhGYjX42p1B7G3VvymPZXo1JV5mtn28hhRPRjQSwXQ
6443	payment	1726	1726	1874	1	1	888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWc7d2nWWBA4ojxboPeXHYuJ9hGmXciL7CeN3WV1PzVLy1Mj9
6444	payment	1726	1726	1874	1	1	889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRAVcR6gQ7MZ7xzQPmev2uukqWpNVLeq8cABmT4cXYgDepffY
6453	delegation	1876	1876	1540	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QAyH5Vnjr9oq9xqAcjtWbC4o2qQkVbzsiZJPnGgpn1Cy2udt
6462	payment	1726	1726	1874	1	1	904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhh623Z2C2GfiYDo6YaphshALfeDEhfN6pwP1fWQ519TR7Q9X2
6472	payment	1726	1726	1874	1	1	912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NrbzG3qeV4h7SgppLdgFjVadFLs5MHpLfFLtDnpnE7KHgsJZ
6321	payment	1726	1726	1874	1	1	782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJB6URJa2Ag47hcqXWimiRLHga94UFTnTLkg9wL4xHJ9wQrqo5
6324	payment	1726	1726	1874	1	1	785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGJKrdVSEJXLzJyma3WLcyUZbwvEyA51iUzj5hQGXqmj952df
6325	payment	1726	1726	1874	1	1	786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3Wv39u5v2oUSww2oaj62owCP6ptf6n6HfSceQCKkXkBjK27c
6353	payment	1623	1623	1816	1	1	0	0	10000000	\N	E4Ynu7seRhW9HjkcbmwLcNBLtM5vHKHKysDNjXZ4e5uaCZUxKMuvd	CkpZLKv4WLHTwRKLwZcaFdVzrfCXnSofZTroT6Y353np1X4MAJ4ed
6354	payment	1726	1726	1874	1	1	808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPid4Na4a33vbZbtN63GMf3BC5RrLT2dVKjrbovYnY9MgxwUhD
6355	payment	1726	1726	1874	1	1	809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisqvU1T6Vf5K3d7nypxMJWTJ67iBiMTEwTpuTR668p13P8Ppd
6358	payment	1726	1726	1874	1	1	812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuh3Z8y2inh8TXE1bCNt5ept7S4hDD6XVfAM2jGPfM2dZzN7iH
6365	payment	1726	1726	1874	1	1	818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rm19PSrHFfocLNvkWPDmtLLkH7TmJXsGPubXjCFbZZfBsNV8
6369	payment	1726	1726	1874	1	1	820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeednv3qAoZxrb3WCynF47Z4d47kX6cTVzcpBnf5uqa4XrzVxV
6370	payment	1726	1726	1874	1	1	821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW64GU8v32yY311fELYwUMiKrBTkA2E5ssuo46d8VoMMZtsvoD
6383	payment	1726	1726	1874	1	1	834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGWapeVvoZNA96s58sjmv3GYLejAY2QzMqEjxABLoHEJD5a1K
6389	payment	1726	1726	1874	1	1	839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdRJqQmfuBhiaDHYEpvCZEkwoPqnB9mHNy2oV1b9379bwL8fc
6392	payment	1726	1726	1874	1	1	842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYtgyd3tyjsfmmBmomKnyWqe58qsg9fVX2DNRbSuiamGKTfzV
6402	payment	1726	1726	1874	1	1	851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJ4APdfyShsyBLTUbqspDSAVn2T6TUyr3MPQBzgQp3ZhAm1JG
6409	payment	1726	1726	1874	1	1	858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrSdnbdGan63nfdfX9SJKm75aQpgcxYcfB7M8JKfqtzbNFcUQ
6414	payment	1726	1726	1874	1	1	863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmGQ3rSnjLm98jQkdLgZ6kcpzcjSjajtJGA3suZZmd2du9FWx
6431	payment	1726	1726	1874	1	1	877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69i8w4Jbz12PB6PVNTLzRLBtaq1rFL2gXVB4iTiSTPQubs2ee
6432	payment	1726	1726	1874	1	1	878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4BPem6d8o71gwFQgTLqSsvJxHvbH1irEiuoPcn9HhLP9dPAE
6436	payment	1726	1726	1874	1	1	881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa735uXNgRsWqujmxM76FTqQ4irVPCer2nTwsNBxvMFpn2RE8gC
6437	payment	1726	1726	1874	1	1	882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERUEUfVdhr78JGsMoA124W4iJakdu5acjhr42b4Anf2PeULqa
6438	payment	1726	1726	1874	1	1	883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKeJrksUs6MU7NTPoNWpWPixiSJvCuX4xyapFDjUYpD3o46AzQ
6441	payment	1726	1726	1874	1	1	886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7o5WKJtVj5vABXppUquKwd7zmBZugBM3psEAwA6FMCXLzaGpc
6442	payment	1726	1726	1874	1	1	887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4fDVdrPq1d9rVt5q4eYnar1zuW6uS7bRnKqq7pQUV4gsnhnu
6445	payment	1596	1596	321	1	1	3	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZnUoGMCKnUm81cr2qMMBR6kzeKHQN1fdC1Vc1LsJEKykYvFb
6446	payment	1726	1726	1874	1	1	890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBMBXJK9P5FL8Aes3HmQ47cBK46deJucjyE43NRZfPcTc1fLo
6448	payment	1726	1726	1874	1	1	892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozgF2vVw5rJkA2NgvPKUzU8cScW5vnBr3CPReiwcXucJhaWY3
6454	payment	1726	1726	1874	1	1	896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEdENHyWZdkr83Kpz7EbwRKV34vR6sG8zCAk6kgTpv32zDRHW
6461	payment	1726	1726	1874	1	1	903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6SwC6VzDyWo6mwszFLjTWLjzdWx7vMUP4XTznHbX7yN3D7Nj
6465	payment	1726	1726	1874	1	1	907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQxRUzXWewUXZkaM2XygYVosEaQtM1VoQjwLnv1CQnhedPrmp
6466	payment	1900	1900	1900	1	1	4	10000000	1000000	\N	E4YTc3SA816XMFHyEG2rjgP1f3eFoj9ChqoLVDh4jx8cfp2gRkYM3	CkpZUYm1mQiTyn8kdr9q5nGJrCEjenEeGUs5fYDm6o2LJn1hQUuej
6467	payment	1726	1726	1874	1	1	908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKumxZi5F4bGmS8mNQ2XkFiQLNVXCLMh14f4HV7KCixaDnrdg
6471	payment	1726	1726	1874	1	1	911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wSnbiEmnkaD4zTwVX79YeAdAsHvacHex7JEFg2HU3E4S65SF
6477	payment	1726	1726	1874	1	1	917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB52bEUoHgxaDiWQjGcGmMk1LtBN1CpEcD1gYYfU4h5Lsohmqs
6478	payment	1726	1726	1874	1	1	918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAbom7tqb13W5i1BVbpYgHxi8HFuUKGTr7sLAAJh6zMeUgZ5K
6480	payment	1726	1726	1874	1	1	920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeRQSDUZbYCaf84n1YPpexBF3UD7rAwUtrVuCfimCQ4pZCu79
6482	payment	1726	1726	1874	1	1	922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a76C6EXGeid6HYgbyKtrQD4WC4894YfrCPr9AtE5HZPwJr6b
6483	payment	1726	1726	1874	1	1	923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9c5M7zp9rrmVHZpbFoCAwby9xpVTe614JJcugfuvoKowtE1tq
6491	payment	1726	1726	1874	1	1	931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLE9bkNKmnoJ2ZWc21qS8wcmPS934bLWp6Ncw6W23b8E8zF8hh
6434	payment	1726	1726	1874	1	1	879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYreCAcSK9XiqvHXb229vfPYHyBZ7HHadV8C2ZPszgSUR3KHs7W
6447	payment	1726	1726	1874	1	1	891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cBgWjijWb5Ve641LVmfVLTPaJhCKMWikxzfgTjYNdFiGwqLM
6456	payment	1726	1726	1874	1	1	898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYuk2xAmb8mwTL2wd2WzNsSa3QT7tbbpqt4hLfexqdkToEKnM
6460	payment	1726	1726	1874	1	1	902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpdENzzUEkfzfJsPA5jp98NeoWGk54ELPxsesMmgfy9qMDXwX
6463	payment	1726	1726	1874	1	1	905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tKyHdXTuZS1ri34dWxZ3ico9e2hQMD4aXDWKnM8UQzdtwwDP
6464	payment	1726	1726	1874	1	1	906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoEZ2vVNQhhAJA3RXkrjQDvgLbvNE4UsyZzMphKGjxBgWbWAz
6468	payment	1726	1726	1874	1	1	909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSZ97oG8o56rXE82P6GiFS5KPUdHuw8GqwC1xid6jGBDDytXx
6470	payment	1726	1726	1874	1	1	910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSziQbfnRnL2m6F1fqrRvCFTaQw1nfydpVJsgeCUMFnTJJ5ZMF
6473	payment	1726	1726	1874	1	1	913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZLWWpbQKxKzNDmRzTkmyW8uydYxcN2Ntfeg14QPRcvNsMioD
6476	payment	1726	1726	1874	1	1	916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENAyDV9SrPyfx8xQKPuBNJNKnD9kPyEs1ZZeSvpQ33AjSAo5L
6485	payment	1726	1726	1874	1	1	925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sV5RxDFbC9mkCwW7sakF1pVikNCyQrkvW9Huqr7rsZY6yqtc
6486	payment	1726	1726	1874	1	1	926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VKjEy3dQkoBChAy8hPSh4isGKdnhW2dCANvyLdajet4gmPQ7
6489	payment	1726	1726	1874	1	1	929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W6KTsAMn7LsMp5xCECHKbLeWsHkPGt3Vkj7kSnLeEVXDeSU7
6493	payment	1726	1726	1874	1	1	933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJWJ2kX4Z3cTU4uGTbHGgHPouraz25PJAm6X12bQXWCuyndybq
6501	payment	1726	1726	1874	1	1	941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpURVMnk4PCvLdrxfxfi66PntrdfAPRJaBgQdXvUmhSqvy8Z3Y
6503	payment	1726	1726	1874	1	1	942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRdAoJjCE5UdVLyZCKAML6GECLMaRZfRin3xP2kFpc3ouTgH2
6504	payment	1726	1726	1874	1	1	943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHed1xxEtYfMrtRBUR7zX7qVvXfiyhr2BpRvih7DAZJH4PwjS
6505	payment	1726	1726	1874	1	1	944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mUSDYcSNUTV43ZvBTupro7BvMkxkiUPgMyj46mXemXKXdFmf
6506	payment	1726	1726	1874	1	1	945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbvEXgEo48hWErv2Y4pc7MvgspEcsKQMuJY51LvRUpd6zgSSs
6507	payment	1726	1726	1905	1	1	946	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvUMvtBxYuewt9sbJyYckiLDQPAgUmwGmfnJXKGoNw1UWdG8AR
6508	payment	1726	1726	1906	1	1	947	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCMpKRrMSaRnC4EAvfzNiVkJmLxy9R8kGvEGBoVpPr1tY8G7Nt
6509	payment	1726	1726	1874	1	1	948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBxziP6Mq55DrM2vKWSmdYcAcJeZborGCtuU5tG1tWxKhDz5m
6521	payment	1726	1726	1874	1	1	959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSfgXNGVkBgjPQV4V7unpmMCvG5azE2k3Zf6Rxkiidt83g8Ni
6552	payment	1726	1726	1874	1	1	987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBKuTL8Pi6iYkzpMhky6Rh44BEWwbnMXPFU7oNxgFudiywkT8
6554	payment	1773	1773	182	1	1	12	106567337664	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYTuMS3d7fkbGvLq2qJ8YutzT7smz2xfbQp54asKtSETJ2bj1Cn
6555	payment	1726	1726	1874	1	1	989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrWrx3exWdkgvJVPL1DaZ2aWpvkktyjcMu6AEHwD389R9hVTt
6556	payment	1480	1480	1910	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZBqYTrPQD17fzBw3H1avUuptcvy8t3TJNBtPHfbVfjkLNvi5
6557	payment	1726	1726	1874	1	1	990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUdZwTse83cmUmDooY2Ekj14bZ31QL5WNVLs1hF4gB2NaiNPc
6558	payment	1773	1773	702	1	1	13	71044891779	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZtW71Q8KVB778Tqrq28QoVo6RYNZ1oGZD6UzKiGb9nu6LytHgr
6559	payment	1773	1773	927	1	1	14	811162142739	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaBJqKfrqg2RMw4qxEtcJmE1FyHA7aGbVEUQanRb1NoAjLhpqMU
6560	payment	1773	1773	1047	1	1	15	1453595609754	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZNmtV542akF56tvthXnu9yZfmru4h8okyP1YyAoiz2Adhq161b
6561	payment	1773	1773	1167	1	1	16	980769922839	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYXBKiiYzCDK6vCnFs5wapoC9G148Ni9R4GybxZi2YCB2q7fvJC
6562	payment	1773	1773	1293	1	1	17	2733002595198	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ4ttBnSf7UJyJDtHNNqXG1c8iZGPtBS2Yiwe4NuoimqhaaWBSi
6566	payment	1726	1726	1874	1	1	994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9KHGyv2LAaHq6G7UMCajTFYaFS3St8pWjxhgWk5NNA5RsedF
6574	payment	1726	1726	1874	1	1	1001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCgv958cFwhaL5ukzd1oSfRhM2yeuf2eRoNanAEM2N5xT694F
6575	payment	1726	1726	1874	1	1	1002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZje7129Ke7BQToDnn2D6TEURopomCPpm8sTxq47rRKuZdA5KmF
6578	payment	1726	1726	1874	1	1	1005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xeHkwo42gMb9j3TMmrQ5SnkNB59NRth52oxiuACmstZXjRux
6583	payment	877	877	1483	1	1	2	0	100000000	\N	E4ZRecmTzMqiXUMQsh4Co4fM4psPa3i3r6YiiUzpMFJTowWrNjL8m	CkpYaQUDsDozhZJvgJQYPaaRTAvTMm2sf5zX4uzmBMsdTvo2p42oR
6452	payment	1596	1596	1864	1	1	4	222000000000	5000000	\N	E4Ynu7seRhW9EkUbhuGwjptDMWn7o67ccYCoXfEwJygfeswKpssjC	CkpYayW6aWQ28ZaNbpjcGy6AsEXc2KMKacD9tffLf6xhhasuW9kkw
6455	payment	1726	1726	1874	1	1	897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz57xYjsQvdbSFW3kW34jeVr9XdzQrqpSRdp6tu4AvQGE8sL4U
6457	payment	1726	1726	1874	1	1	899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25d5BqtrrTm73VVHLqRPMcotCxjkWfsL6BR8X4qhGmn21L9dc
6458	payment	1726	1726	1874	1	1	900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmH1PGf5GhSGT5PbkF6memVVJ3YHwzxQKxVruSJVY93aNFDja
6459	payment	1726	1726	1874	1	1	901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gd8Wh5tsVQs7uLK2dvA8TPzTnvRoDVZZaZzwX52cKvPA1sfk
6469	payment	1900	1900	1900	1	1	5	1000000	1000000	\N	E4YTc3SA816XMFHyEG2rjgP1f3eFoj9ChqoLVDh4jx8cfp2gRkYM3	CkpZVo1LJ5ZG57VKVv826PJJi4ZmzA7bDEEuwN9ZY4WLZvt8wEaQf
6481	payment	1726	1726	1874	1	1	921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2tqTkqRKDKwuLCbS9KWfA7iy6QVoHtQWUUUWP5nQFppjC1uB
6490	payment	1726	1726	1874	1	1	930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZRUcA5ZNnceBQ6SdniG7VjrQPkeJgVJFyVD7tHi5Npk49iKH
6494	payment	1726	1726	1874	1	1	934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZgFH5Vhg8EA4bczK7v6J5RQXBjj9UKhEMKY6yzUazmhihw1b
6502	payment	1480	1480	1904	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCxy3Cad4uo7mdeeu5LhYj3229AQbzMp3PdoFTtHtK27E2kkH2
6512	payment	1726	1726	1874	1	1	951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yNQ3auSPgW7GYrCzpEAe2DvpKdnL39XJg79ckb318WHDiTj9
6513	payment	1726	1726	1874	1	1	952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKdXNe9dcsVHuKtAVhaR3EbtkYHJCkN684b8KwFsinsYRa9T6H
6514	delegation	321	321	1540	1	1	0	\N	40000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6V8JKNpCN39qfkkmHbBDJnjHySZjBXwtCyNmijtkhMpVxLDNi
6515	payment	1726	1726	1874	1	1	953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5gesXS8SM2DPG2v4aLyjhRm2gbydoQadjD8q1U37svWQbnL3
6516	payment	1726	1726	1874	1	1	954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7XFxTqFZBYLQmUTqHNRz4g3zdGUwapsFNDAquFEJbd8oJ8Tv
6517	payment	1726	1726	1907	1	1	955	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZarzByxx8cVx7GnhhGAy6KsFbQcbhN9GyX665mJ6HCihRCFaSq
6518	payment	1726	1726	1874	1	1	956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcQs9L4Ga1r4wNFPN3W6dzJhFYHz2TYewz2p4H72rwuSyJUB2
6523	payment	1726	1726	1874	1	1	961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6b9AWyZcpHb3pFzvEuTieE19tGpMknra1tLeZ3BYWdsEXJxL
6525	payment	1726	1726	1874	1	1	962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZT42oLJJRfdEYGAvUzz7AVsoJ6Y6gJvw2e3Dm6x3QpcKUXm2
6526	payment	1726	1726	1874	1	1	963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4VyaeQbMu3zVcE5rrHhLdpicLeHdK5fuvZPUkyFGH8C3mG14
6530	payment	1726	1726	1874	1	1	967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLRbA4ynVpMnbxa5qDCa6e2aSNCAQg9iezRBf56gzWNXV35wQ
6534	payment	1726	1726	1874	1	1	970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTuD8hVbWnoc8qCXowiZM73PAKKmxS1KBq5a7km8udh21UCbz
6535	payment	1726	1726	1874	1	1	971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJJigCrbNDfU4C6APysFkkPmHSWiMV7xpQMDfuQbW71Me6csP
6536	payment	1726	1726	1874	1	1	972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmmYFBwwhWrwASZDJnoGBDYjcQGkMYgg5DPTS4XxNF5tggxsp
6537	payment	1726	1726	1874	1	1	973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGz7dK8ko7k7uPiTwqQbjvFzhtZz2D2ZxkWnBHRiYLhMd9D3Nm
6540	payment	1726	1726	1874	1	1	976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQu7RwpJdUK5314PWm4HSRi2dxSTw8p6FsJmtjK3SpsTEDsGqs
6541	payment	1726	1726	1874	1	1	977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpTqnE9bDb1yCq1xYJ1N2e15qrR2buBhoTjyarkNhRYjDHGPD
6542	payment	1726	1726	1874	1	1	978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwJJFdDUnoWd5NyQHhHMfj4qN1N4U4riBFhyR1mobHWUYVvus
6543	payment	1480	1480	1909	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDK5KyoGpznJCvZYNTFRTEKpMngWb9Miw1dmyG66FjGQ8RHjCf
6544	payment	1726	1726	1874	1	1	979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgwxEPuATR375L1MNUdH4X26QdGWckgL6RnZYnSZdwkN8Fy4q
6545	payment	1726	1726	1874	1	1	980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepN7AbvtSxH4ANxBz41grPGBbhuwcgDiBHTzXBLyu7Q6sNmBX
6548	payment	1726	1726	1874	1	1	983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAVQAun8ZpLdTYeHUWB7KAXLCKjJKLQWkNfo3YXiG6KyTfKsn
6549	payment	1726	1726	1874	1	1	984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGoEqXfxFqjD8xLvvNMUDn7ZXnAsXUzMK5x1FN8QG5oU2JSXc
6553	payment	1726	1726	1874	1	1	988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSXkSyKQQWMEMSwabeWHT6hoYZWdEvZJfaG4V63aFibLY2jxr
6564	payment	1726	1726	1874	1	1	992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5rHJrpy3J5L8msp75UQgZhtW5UNJafs1wCqzQkrXi7Q2dyYd
6565	payment	1726	1726	1874	1	1	993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexW4nZ4UQCm9xJmHMLvEUkBehmA2g5WkKvY6gWPRdfgqv9X1t
6571	payment	1480	1480	1911	1	1	4	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJq6T53VLBo1Xvz4sa3oBcyHn2jLDe3zQEKmjyLeekc3hAeaE
6577	payment	1726	1726	1874	1	1	1004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhCDo4herJ9VmXqksDYgRrVZ8CRDDNy5yPT2SCA1RYod8rc3R
6474	payment	1726	1726	1874	1	1	914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqcTGzwW4NFDFJCAAVTXB4qq7DbfNyPH9Tbmn2AfdnSEMRdaB4
6475	payment	1726	1726	1874	1	1	915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fUxGDe3Q28mFcwjdPV1UiCdqWjuTbKAivdL9PBLrphALVc1u
6479	payment	1726	1726	1874	1	1	919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUe5bL3iAe4qefsh8ARUDFWTBfCNTEbtMPmtpS4mRp5diX1KHw
6484	payment	1726	1726	1874	1	1	924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFroCLy89Q5Gya5Nb7TEhBiwWaXDkspqkK62XJjRpksCnwH4rR
6487	payment	1726	1726	1874	1	1	927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DmyCUWX1d24Nd4inmwqtxr8R5yumNme1rc55CcpHeoQFJek6
6488	payment	1726	1726	1874	1	1	928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcUdsSHMYqCEccZ2s8SGw1WPdpU17ZJkBTeFPQZnukcXk4JK4
6492	payment	1726	1726	1874	1	1	932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRsqB6JVtS8LdeUs5DzzBcYZ5LN9SM7GyYQm4WWD4xHhHY9W5
6495	payment	1726	1726	1874	1	1	935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHsEjmU36AjG5PDEmEoQVd2477LkdAUv8dMj2LwT3z7SoYTbu
6496	payment	1726	1726	1874	1	1	936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYQC5iaS3GdYwDTLNDjULrHTkj8dNzPV6MhVX6KYiiQGMi46S
6497	payment	1726	1726	1874	1	1	937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWkWXTnzb6qqjEre6ttA5nDmTNzvEe2VQgJEUTcUcp8JpgTrB
6498	payment	1726	1726	1874	1	1	938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHDZVYrVMiGHHdoCUnDx7LbziVEHo9jhePquJgpeqcrbMs276
6499	payment	1726	1726	1874	1	1	939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmk5X2LPxoA7bDCEQAwJUjdzFbda7SFD5cZXaoWM9oEHu1jd1M
6500	payment	1726	1726	1874	1	1	940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTj5kFzwmVCSXnhjJ8p3yZrmRYBwysM75Zuqtjrd6vghidVGZ
6511	payment	1726	1726	1874	1	1	950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLzEy6XvdCpMqrYmpAkqqR12SDZnPboUVs8QNp9bLi8Yr9zvw
6520	payment	1726	1726	1874	1	1	958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfapSHxeAW7w6aVQ9YBYVYBXznzym2zvyPs8NsUsgMKA65rTJ
6524	payment	1480	1480	1908	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfUfsSLeRjg1mvFPzSFWdnL5ubozuH5Y6jhB4bdcuJtcNtmaK
6528	payment	1726	1726	1874	1	1	965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRvxuJn66EGxy1G2TjWgfmnumjxV7jXA2X4dNhsjEe1EctKWr
6529	payment	1726	1726	1874	1	1	966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGaUUagCJDhxrhj4G2JfNNarxPcAbFSr4pxhsJ1qCBgLYGew5
6538	payment	1726	1726	1874	1	1	974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1ckFkFRVD2UPUvYiQbj1aAdw9T3RV8rq5QXps6JH2v3YYuV2
6539	payment	1726	1726	1874	1	1	975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSp3QKDkiwaqoUBJEvofmDHx85J8U2qyPrry7GjhTU9f6ymLu
6547	payment	1726	1726	1874	1	1	982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYp8RrJsZcCnVpkgjxWkQiXMGHtUTt1HR4WM77xvhJ1H152oub
6551	payment	1726	1726	1874	1	1	986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYtGr2rUJDM8GNUsPMoVa26Qj2puzJmPtUNUbJw2DgQogHN3qd
6563	payment	1726	1726	1874	1	1	991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5FbbcZuzcwXAXdWRHkN9ZQuYxdmZMxBRaZdAHcEr1MRcPUbj
6569	payment	1726	1726	1874	1	1	997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVfzArcUnpgARv88QP2hs3z3YxirXh7QbzmttBsXkRUNhvVQK
6570	payment	1726	1726	1874	1	1	998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes4pXaTRgqEjEbbrwrX86m6zKMPfoB7xQpPCTqhkzMe7w2D3B
6586	payment	1726	1726	1874	1	1	1009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2NkbNdHUTnexZ4X5deskVNxL7bgXgf5kD7azdgDzc5dE6V8k
6587	payment	1726	1726	1874	1	1	1010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2UwpDekpfaAmghBY2UDKALZXEJjKZTdxDhHAi28LxF3gBH46
6590	payment	1726	1726	1874	1	1	1013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdAgtn5hiaF8MLMJ1TsCoYVJSz4Hoo2v2rZfskaovdWu7bV47
6601	payment	1726	1726	1874	1	1	1020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJUT8zP4wg1njtPB9eCKLkC29xvwE7Y4cbqkLWhpd7BpFn4Zg
6607	payment	1726	1726	1874	1	1	1026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAm5D3R8K44PMw9FaxbAxZFGeFodMbF7rorcsEstbmRMg6Wiyw
6609	payment	1726	1726	1874	1	1	1028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8F7L4qB5XenjRmCMFTrg5Qq56H8E5sFfnqU4qnKq9haW9BDKb
6610	payment	1726	1726	1874	1	1	1029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MfAEXBYmWiQokWRjaSEjck53CxcWrgxoqQvTqxiohYaKbBoE
6611	payment	1726	1726	1874	1	1	1030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAGMk1E1AiSAuWNmWZPmZWriBiP9VfmdA4B6BQBHpypDDC9we
6613	payment	1726	1726	1874	1	1	1032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqbv3jgp4saJdA7LGWDSqSnu1imeVBYLt6NFk7MwEsjA4a4Mn
6616	payment	1726	1726	1874	1	1	1034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKa9ZwErmP2nCdPSepBhd4oB6N2qpu1WRfvyNXNcRwxKcajL4e
6619	payment	1726	1726	1874	1	1	1037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZta2whuNeuDDJAsrEXg7guiH1NTJHRSsHWhQYqb96YCniMct2R
6622	payment	1726	1726	1874	1	1	1040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDZHss2NiTeuw8zrpnW1f9vqVQgUZQwQazwvhdSSoFiMMRiJp
6623	payment	1726	1726	1874	1	1	1041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSqmV5cJsZLavKeYR8Yg4QHeeXof1tUT6uQQvQTXknTKKVu5A
6510	payment	1726	1726	1874	1	1	949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRAS9F596pXX6NQsJZAyTqSndsTdCmTxufetVTNpJZNxGg4Yq
6519	payment	1726	1726	1874	1	1	957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttkXue1NasAB8wVTeQUSKL3NFhdcjwmLzv5avwkt557vgR5ie
6522	payment	1726	1726	1874	1	1	960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAH7BrEyDHdg5ZMncrqX8f1AMYxxgD7SRzLE83nCsgtqLgjbs
6527	payment	1726	1726	1874	1	1	964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJPFBLWMfTCXHzXgaPpqsYD4CB8tiRQyzYiEeGa1rnbkB8UdS
6531	payment	1726	1726	1874	1	1	968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3HjPXZyPbhrf7pHGfCv57NtcTViayQvEijRetSq5t6gcU2Uw
6532	payment	1726	1726	1874	1	1	969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzTQnZSRNkfrXjqq1T4EnfkLnXM4mTWv3mh5XHHfdW9Wf46d9
6533	payment	1699	1699	1773	1	1	3	6156202499973	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyTKMs9zJDMBWDaLEPCAX5dY8qHDoEYzkeBEnbcDc1BxxqntE
6546	payment	1726	1726	1874	1	1	981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzv4sPiHYJqnnBq34y6TCNyeWahjj2hMUkc4BAmQBSpBZ3zsv
6550	payment	1726	1726	1874	1	1	985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa918gEyJ3EDArWwpUNVw5jC4sgG2efSJfosvrHj8KJpDDBLRn
6567	payment	1726	1726	1874	1	1	995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDGLwbzqUNr6sUq5uyXCe2GiMtbKj1zvfFmg1hoLnmDxJQubz
6568	payment	1726	1726	1874	1	1	996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tgg1mHbc9XJCuhzHksq8hU6YUggX9MtNEE1RK1RHYuyhaWY5
6572	payment	1726	1726	1874	1	1	999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3odt38jejzGbPAwd4E3m8Z9JcyGrwkLAR8sQbkxzmJ7RwBNmY
6573	payment	1726	1726	1874	1	1	1000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKL1TqLHdbJ3SUUWsrKt7gYq3kybu6EjZPGszxwEJu5JZZTJq
6576	payment	1726	1726	1874	1	1	1003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQNDFY2vTDFhS8CMYDX7fj1U2KS4oPy9wNJg7MaAMEbCWwJW3
6579	payment	1726	1726	1874	1	1	1006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUj1sSPCk5p8dzCp3kTyfyhP457o7QZsAXDhELEZP3GEsfYfH
6580	payment	1726	1726	1874	1	1	1007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTFLPEZ9vbggoQCA6NmP266pi8DCowrR9RtMG8rqPhtdwavot
6588	payment	1726	1726	1874	1	1	1011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdZjAF6ZXMg8QfAfQa2ZMHyzPaRDFAeDoNQchJE7UuW2KRqLG
6589	payment	1726	1726	1874	1	1	1012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatZmgdXfo8kgSYG32vpzn8buoGnN9gTHE6qHYyW1HUMSoeZhc
6600	payment	1726	1726	1874	1	1	1019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqR8LPpXPwptJUpFJXrra6HrMjihLiFB883oHqmW243hNsbNCq
6603	payment	1726	1726	1874	1	1	1022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJ3nshwExgFkgjbqrvFL5hkD4VdTWma11LFXnuuvNs99wLyQJ
6604	payment	1726	1726	1874	1	1	1023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc94TfKMKLXe17tx6gN5mxjy5wm8xf6a4X5tekNrk2tgX3mS2H
6617	payment	1726	1726	1874	1	1	1035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiJM5b4ZGNuH2okjHvJZUKCchNNzjxsjRTob7FpBe1AEMxCwX
6618	payment	1726	1726	1874	1	1	1036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKZ1hb7P86ktvAoGfDpMBw3kgSNSd92xEB8g6rg8vba8enQZ1
6626	payment	1726	1726	1874	1	1	1044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5hhb8vWwNrXMnHyYF8uFZvXrdETMS9dgr85LDj1JFatEGnh7
6633	payment	1726	1726	1874	1	1	1051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJjDaL8KjbBWrBKKfmdnBCwx87JueQQbybYDqGCAFWj898DPL
6654	payment	1726	1726	1874	1	1	1072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsW8VAnTRHLxRUsKprh8siu72jBYyaDHMbJUtUTKSFFYrsRzBo
6658	payment	1726	1726	1874	1	1	1076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4prdnysmKWM8mQt1LGYvwZPTUhCifQqdB4UB7eos55Nzmh5Sp
6690	payment	1726	1726	1874	1	1	1107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTLxQWwMQhXeiKrAdyRpExcNsCG2e2hERHQobuJpBinGnqayi
6693	payment	1726	1726	1874	1	1	1110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsvk9eau92P7Ng9p4nNSgZBgicZUbqofEi37xfQrtBx5ouJXU
6702	payment	1726	1726	1874	1	1	1119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZni4Up1GX9LmCbhijXbEh9esLiMypLehif9RRzXZ26vGAdKU6R
6703	payment	1726	1726	1874	1	1	1120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZxp4e8drfckrmc2xphuHPrqXeF72oAGcE6i1Lw5ptbs1Jzqw
6704	payment	1726	1726	1874	1	1	1121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6Cbj9V4BFp7ZaXUGjv9oNKShSNPpABayczqPBxphA1w7sWoU
6705	payment	1726	1726	1874	1	1	1122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbRhF5jCGoA1vaaCb4hYc7PGpeG34thGqt12BoBcVyytCkF88
6709	payment	1726	1726	1874	1	1	1126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdUQQArXc483bF4zSnYHUipNR7pTjVXGNhEFNhpmnE6yTvha6e
6740	payment	1726	1726	1874	1	1	1156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurozdVzzLieyxSLhN8BRhZeo1e2zzrxNnL7dYtddkrrb6wSsw
6741	payment	1726	1726	1874	1	1	1157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27NyYwcEH8zsX8nKcHF4brQ1EBgKxGopbQZ7qc4rAyyh4j4oW
6742	payment	1726	1726	1874	1	1	1158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZqR2WzkZAr2GV9NFHcJs3AQLfKh4139m9X5nhQFxLJsm5UUr
6745	payment	1726	1726	1874	1	1	1161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Qybsf9ZEExijFCfFuLLd2v7GqaZeqYF31gRE8xMxNTKfRY7J
6581	payment	1480	1480	1912	1	1	5	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSj41rNSZhrdfZbaCExCpQvFrFMWCeK6exBAqPdTL2hAxMUVSf
6582	payment	1726	1726	1874	1	1	1008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqC1FwYx73jj4g6Q9nHXrm8pejRNVMBmU3VmYeFuLTFA8fvq8R
6602	payment	1726	1726	1874	1	1	1021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpu24hT2j9D76QnaqEFrcApPgzT4bXaQupGfpjMLbpr2E8Abcy
6608	payment	1726	1726	1874	1	1	1027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYradY8ZopM8rhPUeyAC6XEgMqw9W3dWQaQ2zSqMMyNAzvSPxEB
6612	payment	1726	1726	1874	1	1	1031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQU9pavCV9dtRnuSVG2JRJG4Th469dF4c6wKo5N4rhp55JVgr
6621	payment	1726	1726	1874	1	1	1039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCwEQHtdoUfKEad32SdQzXVRAB8svpY1fpfMiBVeaEuvtsmTj
6625	payment	1726	1726	1874	1	1	1043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADny5FHjXWiry6BWrcQjM3mKvYjw7vq9KKthcManrp2MBSiUx
6629	payment	1726	1726	1874	1	1	1047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUMbmLRh8kPju8mMUvGG8yX7yXthEPX6XUGsYSUSgZWFTDv4S
6639	payment	1726	1726	1874	1	1	1057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPMtrWhy11w3kzUxNFwU5Z61yFTrrheossZc5UsdvDBTaqD4S
6641	payment	1726	1726	1874	1	1	1059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbpdUPo972cTjhMzUx1Lwxf5uhVoPrPZrPZ3KSgfhb44sr1Kn
6642	payment	1726	1726	1874	1	1	1060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjJYsGucC1oMtD48PbraXnGLGndYu6fpbhXnaqchwxDWJsmZd
6643	payment	1726	1726	1874	1	1	1061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExz7mdM2dyFfVQdLVR8jCBLqSas51piLP9pcSdRTkQ7RYcR6T
6646	payment	1726	1726	1874	1	1	1064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6B4sRvVdUHtBiySZ9bDXB3R4uegsdYerNhToq835APLZ49WAT
6647	payment	1726	1726	1874	1	1	1065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9Lf9fDgLJqQqTWbEcW4jZCYypaTLxmc4vxNgEhxsPHoppkcB
6661	payment	1726	1726	1874	1	1	1079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1QfB3LFtH9HzJjsnR8ognGUwFm6zzxD8CkFRthBwLV5Nfg2D
6662	payment	1726	1726	1874	1	1	1080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFstnacoJqiQhKw3sQePfCFjAtvbR2hENVBqsSZPhEmc5t7LC
6663	payment	1726	1726	1874	1	1	1081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWZM2s2snYA9kvAeVTzACwPuHSswg8z7p2dHwoK137EAoTUTF
6668	payment	1726	1726	1874	1	1	1086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZakn9yv7j3i5PhxCcGdwAK4zSTj1G144GFN5SGC22iawVy5k5v
6669	payment	1726	1726	1874	1	1	1087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4XWLDnSRERTZmMwUKN6vo2K5dKAMkAhpcdNKi8AHn5Ldv6N1
6670	payment	1726	1726	1874	1	1	1088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5eqLNZRRK7wvNc2SZBKZGjP9gweAPhya3cj2RzArTDRbi6n4
6674	payment	1726	1726	1874	1	1	1092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCu55TGTk3d8YQ3TXKPvAo1TouG3TqQwH4NmSMnH9WR5WDGGyS
6675	payment	1726	1726	1874	1	1	1093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrc2nTasEBDFzL7Vgwh5fN4Qizhk3RrCPMhkePhfGqsL1L8Hu
6678	payment	1726	1726	1874	1	1	1096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNAscUcrXCdUv8pvhn5gRjeHE1btqG8i34oQznCro8H5WfAcV
6679	payment	1726	1726	1874	1	1	1097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1z8XwSWT748X4pP8QzkveeDRNX4jdqzUE4QoLoAbrG3JUmGN
6683	payment	1726	1726	1874	1	1	1100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYbwapnoVnJPYvED7ZRF5n2yhtXgoS2MVd72fJVa49psbN9X4
6684	payment	1726	1726	1874	1	1	1101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGF1ri9saeqziG7qZjmBCDrjuKj644gif3XM4Y9SA3VAYxbxL
6685	payment	1726	1726	1915	1	1	1102	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZoxMoffVdwg7yqe6ABqK2a4PDgUKjb7JC98JQAa8XbL8ovSAm
6686	payment	1726	1726	1916	1	1	1103	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqYTPCd72JDJTqFJgQCDhEkbVxPznQbjxS1JtaqPioW5YjXDxk
6689	payment	1726	1726	1874	1	1	1106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpTNSyfnrVEpt74Kad5Cu5VYPmYBftpGy2PnXBv8rU2Xh19ME9
6694	payment	1726	1726	1874	1	1	1111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5LexsMfmuGurFGfXzZXBKSy33zpxtvtkc6qc4dki5A6bbxwc
6697	payment	1726	1726	1874	1	1	1114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLjCMYYSsxtCW7YCegQAkQZvmZ4XdYdGJM8Re6oRNYFwop5As
6698	payment	1726	1726	1874	1	1	1115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAjJGabXq2zMXUv6Yj5QbpZ23cCsLZ7M8BhUhGp4mc4v6pXN9i
6701	payment	1726	1726	1874	1	1	1118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1y5seEtG2PKnghZcc6kXiw6BwBqfLsjcUP2B41zv74nd7r2XN
6710	payment	1726	1726	1874	1	1	1127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUb1XjVqJghHNq1PDQuNxaLJxR1XGfPRaDwkx5EjJzyJVkhBo
6712	payment	1726	1726	1874	1	1	1129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkM9BNfy4C7QDwPhn9LMiNqtQNZhLpC6jQfgfMsr1NPeFGfLoa
6713	payment	1726	1726	1874	1	1	1130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgjmu5UE8iC7PEtggGM1kpqYJN68ajbvEQH1tPRNmYPdmQRrK
6716	payment	1480	1480	1917	1	1	7	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahiTaqt6vCgYasYi5Y1eg693pMozPcHyG7oCJgZzHYd7B4Xmi
6717	payment	1726	1726	1874	1	1	1133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr4cFEpc3QxwL867XXRGWWngC1SeQruJCDvvmFzHADdyQsrjE
6584	payment	878	878	1483	1	1	2	0	100000000	\N	E4ZRecmTzMqiXUMQsh4Co4fM4psPa3i3r6YiiUzpMFJTowWrNjL8m	CkpYg3KVGFe1CmjXuyvDKkjRr7U8Ev6HtixZ6syFth91jFeUiftAW
6585	payment	127	127	1483	1	1	1	0	100000000	\N	E4ZRecmTzMqiXUMQsh4Co4fM4psPa3i3r6YiiUzpMFJTowWrNjL8m	CkpYhnEkfCX2oZgSjSByaVYFB3HgUDUD3WL5XFFRfAMEUk7aTpg95
6591	payment	878	878	1772	1	1	3	397690235728	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQm2RFXTyLnQR6X3FsKyaGX6xdqedkscP6pazwhmZb2N2uaiWR
6592	payment	127	127	1772	1	1	2	129947824773	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuCihMs97MUHw3PcczmH7e3bApYNHWkHAymLNouLBHPzqaeDv
6593	payment	1480	1480	1913	1	1	6	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYuum9nC5SQ4cUQrwwFk3eX5o1qihmenpTKh7ADp2rKiokgx6
6594	payment	1726	1726	1874	1	1	1014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ewuF7cawhsVngr98L2fhffTrinNRuYf9FGUS1Hkd9A8gSWVv
6595	payment	877	877	1772	1	1	3	396690235728	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FUUwVLwRAgTZm7BX6Bv44cPeFvy5sKpQQnP3t6Jfjk5qWdeh
6596	payment	1726	1726	1874	1	1	1015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WNhd5D8Wg8MFXrtPqa5S2HDDFKLyPu8gKeExU36tCq34WKb6
6597	payment	1726	1726	1874	1	1	1016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3shcNPGFzbvSqJuGN7gZ3aGVLSyYEA8kEX4BwFpg2EnMTdRk
6598	payment	1726	1726	1874	1	1	1017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnujFzZjVnN9XNWspzmaS8CEu81A5i2Xq8nxEYTKKvM4e2mg3x
6599	payment	1726	1726	1874	1	1	1018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVmAPYFyegANCK5E7ZhD89FKcz9R4E9d4wcaWFEJ16jtvVKNG
6605	payment	1726	1726	1874	1	1	1024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVjuJ5ei2PpFzTr893n8ewM8dsDdKQmUdZRtUSrJ2GgR6e5mk
6606	payment	1726	1726	1874	1	1	1025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYczFzGDZT3eFtyqcRsJj5oyaH37UcMwBtnzX6RtDqSeRKeor
6614	payment	298	298	189	1	1	2	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTCNizzFFzaEDnmwH7qt8UxxqMziFYUJmqCagnfYdnE58Tqgh
6615	payment	1726	1726	1874	1	1	1033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGG6XnRHtpRGwHsyWdJaSsva6tmuYsUxmsX2SCxQU6tNh7VEA
6620	payment	1726	1726	1874	1	1	1038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTf6MGMd2ga99Zte4BqAp9nHBcJS7mKevfva7xR72YLciEyLJ
6627	payment	1726	1726	1874	1	1	1045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6spkYKZjZxHgRTEUERABFythi7jsxuURkyTUQESySoNhYjPz
6632	payment	1726	1726	1874	1	1	1050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGLP4ArPToTy5VNV5uNw4VBbwU7uCKixXSQWCZPHXggaWdaq8
6636	payment	1726	1726	1914	1	1	1054	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwVakfKMyRxGjCnioF58QpEwjSmxrmy3DnCfc7gKzTMhr3zEYp
6637	payment	1726	1726	1874	1	1	1055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3WiQH64icQFtBUne7CVYrB6bC1vYU8mr5apPjspAMETTv2kN
6638	payment	1726	1726	1874	1	1	1056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnWMEAn4dNJLGchser4nJnuuU36q9dz6cLt7hw8Ngv4RDySFa
6644	payment	1726	1726	1874	1	1	1062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WpYcZzqXhL7kgjdVC5maGakMbgR1qx6PvqWydZNrJsWULxQa
6649	payment	1726	1726	1874	1	1	1067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzM8RG3fEmHoAg95LbETNfyBuVBt7HG8k245uUZq8WoYF31MuP
6657	payment	1726	1726	1874	1	1	1075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Y5LaiVgaWzniVixGnwmEHxFePWT32SUyZRNcWB9ykhDKcKRf
6660	payment	1726	1726	1874	1	1	1078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdM8sxF5huQjrPoNGS4BpcAVjwkLh5NMvofVrY9kjo8TiNEA6
6664	payment	1726	1726	1874	1	1	1082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6FbA12bfomruKSxrJWts6Cw6q2vtj6mPjAaZwisssffySSno
6671	payment	1726	1726	1874	1	1	1089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvCqmak5uk6KMQPJtDkBxZo435pWEfEAKz2QFkjaBepKzzpfo
6673	payment	1726	1726	1874	1	1	1091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXsv92ZNzyb2nhW9MLbVhycf1t2U8EhTcMkxgxXSngCpcho3ZG
6677	payment	1726	1726	1874	1	1	1095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtbtUqYuQQ34MHMeC46DzCGuaedXYNxbvXVPfJkGUwp67JFPi
6687	payment	1726	1726	1874	1	1	1104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGoqBWA823jLDYKkaCFV8SgSysNHBn1VQ8PVm2M6nUbMVh5i5
6688	payment	1726	1726	1874	1	1	1105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXPtHx8e2yUSv2twrSRAqF7KJaDXSxByqHr3HM9TBVqCK7vv5
6691	payment	1726	1726	1874	1	1	1108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8eHmdPSDFBJfXMtcNMsNQKnuq9nj7f1gHJTRjNNPNLkdED9Yr
6692	payment	1726	1726	1874	1	1	1109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKC6jyYmQgPsmoWnZrpcYifPMVjv9nVzDR3kWooUjuzczpY4Sy
6695	payment	1726	1726	1874	1	1	1112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8DMKM2xT4C9WA8fCP7spnrmpe8jmazTEy9ByFz4CDTLaeSGj
6696	payment	1726	1726	1874	1	1	1113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UGy9WZSkqb3f2XZh8dyH85EGtPxiNCA6iKWDJho5MrsTzsEs
6706	payment	1726	1726	1874	1	1	1123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjZR8RQ4EugHHxw18iEANEiPVZWDtPjLYPurKXTDzAva7Fc3D
6707	payment	1726	1726	1874	1	1	1124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVRh7fcFmidguHLTxAHruSUZrJxXH5DBNH9Egb3st2CgNc6zg
6708	payment	1726	1726	1874	1	1	1125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWPjTaarB54ETjC6DpwyN9x9cCUDaSuqmv4DNS36YCuFdQaJJ
6624	payment	1726	1726	1874	1	1	1042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDSyvf1e2BiUPb9JJ3iHUc3xCna9Lh5uTqsxEBQUpZ38rN2As
6628	payment	1726	1726	1874	1	1	1046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UDL8vsBCXaTkzayCmgaXyYFShd43t3VFD59rcdWo8dYm5Ybk
6630	payment	1726	1726	1874	1	1	1048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8GfEscEpspb65wf4dhCjRQYqGTt1tKEobwWWrLZu4sfeHsP4
6631	payment	1726	1726	1874	1	1	1049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAeXYmsBVhyWwtcSHWZpHSqVA63FfLtmNMyUDG2QiqqGLp9wum
6634	payment	1726	1726	1874	1	1	1052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfHUCEd1QtaZrDw3YnDmKc9wtefHhUZ6wFoPnJDAxeT57Q2Lf
6635	payment	1726	1726	1874	1	1	1053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5av6uytCU5pMeanDj3u1VUmFR43ExoNiBnr72rLQeKK64Z56
6640	payment	1726	1726	1874	1	1	1058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2scsML8tHm6Acze1DT8czSw8B5a2Qn84EqwR9u78DR5gGdpGg
6645	payment	1726	1726	1874	1	1	1063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWTL9d3NjBNJJ86MJGdbiKEUEGYjvzEC94GaFQLoa6e8u1Pve
6648	payment	1726	1726	1874	1	1	1066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqrBiBoMKJQqErEyEobUz8jert5WpTDZaGXm3NtDQyxTy8pX1
6650	payment	1726	1726	1874	1	1	1068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WavK1pHxPkap2dQCT6HNUc17utrSX66YV6tstVb7FU9rSyZG
6651	payment	1726	1726	1874	1	1	1069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2ouar3AzyeLXWDgxLVEdtv3A8BSEo8W9GCHtNt8cTUANH8bK
6652	payment	1726	1726	1874	1	1	1070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAW5Khpqku2Gd6rrW35rNod42MtdCjKAhsbrQrKkratq9WPv88
6653	payment	1726	1726	1874	1	1	1071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVNKgTVi3eFxVomzKRCWncGYC3SG8jXwLnvWR7ChJk5m478Ly
6655	payment	1726	1726	1874	1	1	1073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGTaxHxG4XnyjcVehUBSxLijNKkPCc5Lgm5XoZF7CtC6mHiqd
6656	payment	1726	1726	1874	1	1	1074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1ztdTErNiQNCnbed1Gusq5BYqMmd6DQUsEz4QHKkb3qB77te
6659	payment	1726	1726	1874	1	1	1077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ6LLnhTf1wQveES22fpkRhpp9B5PNcHHr533BXEgro3LaWf1A
6665	payment	1726	1726	1874	1	1	1083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DBobiTMYUW2nz2tj7F5zJuvcu1DhEBHhGYCMt6CRGskM1GNn
6666	payment	1726	1726	1874	1	1	1084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHaFHZgDTLxU6ejVPdZGd2mAvQTWdfhxhVJjJrWLL1GpYt1PH
6667	payment	1726	1726	1874	1	1	1085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY23y9FsML1hm55Aq9Zcw2vzNfs3BDKaNSjfa4pxhWwHnfTVx
6672	payment	1726	1726	1874	1	1	1090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GSEJR92nAk3Qy3Gp7gD8jGMNPn2yK2pfm6QG1tMLSpVB5CTx
6676	payment	1726	1726	1874	1	1	1094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSoxnX5pPrgdjPj41YU8NyM3eeKCo9qivYKJiFD26wPqe59M1
6680	payment	1726	1726	1874	1	1	1098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSpS1KQj5JLBNNjH4sznv9Ao3XPFWGyPXE2aUmgMys6esEqNF
6681	payment	1726	1726	1874	1	1	1099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp8AiF4giv6gMH4gJC22pUdijNhZVGXGvJrfGwcjei6dnCqWT
6682	delegation	353	353	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TuHrEy6JRoNSe5Jh5T4EAHdPH7VGvPbc6nhw2XGttQ19zL83
6699	payment	1726	1726	1874	1	1	1116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZCbhbYUivyc3ZhLn5YViYSexxn9ddr1CbM2Au3t4uXv2aMVJ
6700	payment	1726	1726	1874	1	1	1117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDF6x5BpVkDHTbAWCRgaisnJ8EzVV2kkBLsGuykRbEEcmUsMe
6714	payment	1726	1726	1874	1	1	1131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzTWz4hkxyeXeD4WFMTW7kguPkwtVUAbxqLohYh14JgUdNv2h
6715	payment	1726	1726	1874	1	1	1132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQM8gcZ2DZUAdbNCFCjsNKVciM611Csgjwg6DiPg3LQNgfKQo
6723	payment	1726	1726	1874	1	1	1139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmtLj9dEiisGN9vKQwVYqCy1Yn8xLrpu6JmGRsMJT1zBsv7Kt
6724	payment	1726	1726	1874	1	1	1140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcmTZH5AiuTkomKWMrCBKbrPdNPevB4pBFeRNdpDQ7QM9Xu5b
6726	payment	1726	1726	1874	1	1	1142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZv2P5MFfMPSsboyRxVKhVkgX4SLXQRt7Fox3oEBY79dEg6tMC
6727	payment	1726	1726	1874	1	1	1143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgNr2M3LQCKT4Ch2k8vbStaZ9BPbtmpyRhp64efxsqfEap8Si
6729	payment	1726	1726	1874	1	1	1145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeak6ENDdyaLet1bdpMnCiLAPwahcy4x9M8S1AjLRJhHCzdkmp
6730	payment	1726	1726	1874	1	1	1146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYexrexzmnFxdrs1CTqoyA1g4cyNNiWqoUpJXYmZYfNhiHDBHxr
6731	payment	1726	1726	1874	1	1	1147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYTXWcvsQiy3MpETXNtb7r6ih6ZfTG9s99TmejLMoTcCecjhKx
6735	payment	1726	1726	1874	1	1	1151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JN4xBHuubvHMNcsSUq6yhL43mZtaC3zCvtPrMXZf7i1urKGV
6736	payment	1726	1726	1874	1	1	1152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FajjHz3QdKzK1PgqEdCWKuSsuZmd2hHBP5MnzhLBvKEeucvf
6739	payment	1726	1726	1874	1	1	1155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zvnqLxGKWGidYYvtZzR5LUxq87Ccwdo5F7Ljb3n5dKQsa2qK
6711	payment	1726	1726	1874	1	1	1128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuWbarC5EnVPHT5Mdyum2Ep4tHdpwRRjBSQzBPRpauDd4TeH6
6728	payment	1726	1726	1874	1	1	1144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhcPLp2CLZAHX9q8AY8nNcff3c6UtyGKM3c6t47mLoFq3PY9tS
6732	payment	1726	1726	1874	1	1	1148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZ8xA4Mx8jDabscc415gbSNQV5vgymNRVAMchWtGAPjVV95Nh
6748	payment	1726	1726	1874	1	1	1163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9orQvxrxcgeeg4KmwU7NCvF9hkKGCypBEW657eAaUVPXTpm3
6752	payment	1726	1726	1874	1	1	1167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ1mLTgUbWwwaJLEbm4YTTGSr1X23gBZSrdixba4jyz5ERbr8
6761	payment	1726	1726	1874	1	1	1176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VGjAE34UdwdxHdo8PwV1DZ5ncQRxfF8gyJCaAtBu39s8fhET
6762	delegation	1918	1918	1456	1	1	0	\N	1000000	1616981889	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnwuPXobJ6ue5hPE7wbjdjeEkLYvd2heYHtaja2kN5KcEt5LD
6776	payment	1726	1726	1874	1	1	1190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2uhGUi5HBXYGrFZmksWK1rvseMy2Q1r4RugYxqBWQauYpsii
6777	payment	1726	1726	1874	1	1	1191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1ydbdtyx6cWdypc357kxzyajUDxPFdDWZ8MxpYp6pg6GoCMd
6780	payment	1726	1726	1874	1	1	1194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7d7mhUtNMgJDX5rs5BESQ8ojJwvEdFJBeVwTWJZMMG54ZPUQL
6781	payment	1726	1726	1874	1	1	1195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqRSBSrK6ZdUwitVy8BZ1bNef7K4eWDtmEdhzmVnPCVQjoFdL
6782	payment	1456	1456	1918	1	1	1	1438138000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5u6utBNzLgmNMBzTkdx666QRZBttHebuMXvLpdZnXmBJ5USrA
6786	payment	1726	1726	1874	1	1	1199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AkDsz1hw47TqJKMbKiZamcbVmfX9zen6Zy2bjB3yTp31qCup
6790	payment	1726	1726	1874	1	1	1203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUr6vAMztHxKJw1NavC3TByhN35PLEKZA1HPsP5Br3cxAqb6UP
6791	payment	1726	1726	1874	1	1	1204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTicyyf5qjdoKct6KrA5iAvEMLYN8rt7Z9f2gaUN16g44LTE9
6794	payment	1726	1726	1874	1	1	1207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJv7RDDTT1pRbQY91Meza5VujtXRJj2SYm3HaZZiu5c5DqVwg
6798	payment	1726	1726	1874	1	1	1211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEun2kQ6JX9aHtUdfoNo6sez8JigCunKZr4kX9DgENJnSpUNHN
6815	payment	1726	1726	1874	1	1	1227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRwJrwb3ssnBFqWGoahHu2t5YupBWNWMjpGWQtDU13vZJ4c9D
6827	payment	320	320	1474	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV62AJWyLGbXs3ukTLfHjiaXuKPkNAfJiKWi9ERGiREgWq5Ksc
6828	payment	1726	1726	1874	1	1	1238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1vJ93Cvb4NFtsXZs6nbSPEoPMe9DM5bC8yjupxjEkTZXZrZ8U
6829	payment	1726	1726	1874	1	1	1239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHKY68c4b3N2Z6ruB28ivoBvty3X85efhrecpMzB9J2t61cQ5U
6843	payment	1726	1726	1874	1	1	1251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQj9uj7UsNVxF31CAN55S7MT1c4QpSt6R6X28mCXoTjpQax7aR
6844	payment	1726	1726	1874	1	1	1252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHiWfSaTGVp9Fr8RV7Wdw4Vd4SdBNxSykFY62RAXaPLcE5wNFk
6847	payment	1726	1726	1874	1	1	1255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiVKWNn8wz271fBLC35y3KHhou32iE8VAs7b5YwFD4Py6AqhZ
6850	payment	1726	1726	1874	1	1	1258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLzPfguWwk8p8BUeA6guroQa6onKm8cQLBgWzp75GPFs1AkPR
6851	payment	1726	1726	1874	1	1	1259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQ8Z5oj2SufY8J7bezft5tWRAe367pvVmZeePhLFrYMstosR3
6854	payment	1726	1726	1874	1	1	1262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnivGn5b42kpnxV6KCfReb9mjLt25Mn8mv6DR984CQHEmce7r
6855	delegation	1750	1750	1745	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfmGFvGv9SmYZmkXumRG1VSDxmMhL2ZKHery11LYBV7JBguS4
6859	payment	1726	1726	1874	1	1	1266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dDjq353wsdrMPyTW516QyhdMWoCJ3Ncq6yjowespBvsL16Bg
6862	payment	1726	1726	1874	1	1	1269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGwunS3UPGibjs3sNv3BbHnbvt3eqA1wwrcEQxPSknWdqMi1Q
6863	payment	1726	1726	1874	1	1	1270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAhLmAgud26UakDY526s9qNisxeMqUFxnCoid1Wq2vLmGVqoL
6870	payment	1726	1726	1874	1	1	1277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzGH8vobLWhK6GtjDSBMrmTDLeG51h9b1NUT8Cfph88f8FcDx
6871	payment	1726	1726	1874	1	1	1278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWaMQnh4cecKVgYyhUBWdppgfxLZ8akS54pYH17pF5YvhpnjM
6872	payment	1726	1726	1874	1	1	1279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sW7Qp2vnykMKsXKMNoT82jST94vdmwZRkKpZdYSwyBsQVipW
6883	payment	1726	1726	1874	1	1	1290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSbboq7SDeyJx56LykgmhQpRYTDnhPxQM2jjNGmCU2du944pr
6886	payment	1726	1726	1874	1	1	1293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTiTzBWaHoE4tRMaLAkXdBTnVJy1X3vAmgg97jKTTTrCMtUo1
6888	payment	1726	1726	1874	1	1	1295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4SGH2PERXndHeMMV7T291dMYCcpTNiJBoM1eW6QTxtcTPjJq
6889	payment	1726	1726	1874	1	1	1296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfb5WbcBQq7cSgVmRVxEmr6eTVpUv2HHgPUoRufyFed7BPjim3
6718	payment	1726	1726	1874	1	1	1134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GrQveYnE61FiYg3Li1NYZVJs39YvhMvUakoj84gfZyyquHbn
6719	payment	1726	1726	1874	1	1	1135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9JvKGCQER3gdm6qgEt4anugHLXwd6YZUnNP98HM6Myj7ST7dt
6720	payment	1726	1726	1874	1	1	1136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNjXYriQB3yhr5j911M6ZaxtrhVCzDGSZKK8AAvZra5WUv51w
6721	payment	1726	1726	1874	1	1	1137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8FWEiYusD2jfWNujCGXRxGJktQiAXCNviSo2BhiBK7sFu1hQ
6722	payment	1726	1726	1874	1	1	1138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcwPyBSVG9kPKjx9cNQUcnQDbMtAfTpsp85YXNeSvfbWqEjbxv
6725	payment	1726	1726	1874	1	1	1141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4LXMPgBqwkE2wSBMPR2wqez2AdFq7FFFeQSkTcpvC5JsVad4
6733	payment	1726	1726	1874	1	1	1149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4p72q5hGfXp6fao8wcoEHsscphimTBUtj68z4XLzve8E8RaZ
6734	payment	1726	1726	1874	1	1	1150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6w8XLsDHssPoU74uWUVRZ1rWkEeajGGJbHLZpPBmEcHNc9g8
6737	payment	1726	1726	1874	1	1	1153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ryPbZTTjgYqB6fHJD2nVdLivdEuCtxxTvtBLcD3iJ9Jfe73v
6738	payment	1726	1726	1874	1	1	1154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf7WLmwMBKQSc8Y9Xxy711hfpWQheuKKeUZE98XAxmxxCHGoa
6749	payment	1726	1726	1874	1	1	1164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVncZxVZzmxLC1sL9Ftke7AgsMeWXjBBSpmTyaFJZA8PPn3PKn
6750	payment	1726	1726	1874	1	1	1165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5FzQ9qtHZUxvNQpKYWhLvFn6PayUTz5PCkoGYNvwj9fg54ZM
6755	payment	1726	1726	1874	1	1	1170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbQY3JCaCfHPvhu47Kg9uqWPSexgSouhRwkL5pbgppkRYfFhT
6758	payment	1726	1726	1874	1	1	1173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HT1XRwENZfApsQvGdhdd8FWtt6WcVynXgMLoirtoWnjN4qwg
6764	payment	1726	1726	1874	1	1	1178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLm8yTkzCcNhVX4VR67jZFqhGNaSnEgBXcYw9ASfMA6oXkhiP
6768	payment	1726	1726	1874	1	1	1182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAoCTHKvEA7m3DTcJ8GAMfq44mcoL3v57HDd8VjTAhRAC2N2b
6771	payment	1726	1726	1874	1	1	1185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsqSX8kbm5wVupsbvJk9PupbGfKsdPCrrA7XHc5kjGbaXop1C
6773	payment	1726	1726	1874	1	1	1187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaao7to6AKVTTQnLMCsvy2iTEsxHh8zoaYXh1SjdFKYxpGzih
6774	payment	1726	1726	1874	1	1	1188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFnPJe2xmLRwJJiPxpG8NirHLjEQsEum4caipzEL2uijVuXuE
6775	payment	1726	1726	1874	1	1	1189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rGsrMTWYwAumbVZWbVUPLSUdixNJxkZ7xkUQ4yXdHbWDULEH
6778	payment	1726	1726	1874	1	1	1192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPTyUu8vJsUy2VhFhYzKucygQP3BHG2sRZYiivKG8F2KMwYgb
6779	payment	1726	1726	1874	1	1	1193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUew85qhJFajj392MFUdmWNmXDok6nJyBSjXT9m9QWuzz4U7x
6784	payment	1726	1726	1874	1	1	1197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tw47b3rdH2YastU7Z1GRAxgWizUqyjEYZ3r5XrvZSTrRsfSy
6785	payment	1726	1726	1874	1	1	1198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7XDuX53etLn45YB1GghuW8PLJ1RGpH5UgRmhT69FvmnLmAeX
6789	payment	1726	1726	1874	1	1	1202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmFTKPfGK7t5aZH2iGXU4RDpWHMRpbj3iN9fWvvdMeDsNJAqX
6799	payment	1726	1726	1874	1	1	1212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz47zWVZVhLbpafBicV2rvrmjcUCQ3gcNEKwGYyEs3ysYkYApz
6800	payment	1726	1726	1874	1	1	1213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCaJkCFzurYSFGWdtUBAzLfQDFFqctSJq7HZp5iPSXBv6H3Rb
6802	payment	1726	1726	1874	1	1	1215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkXKc9iMhp84xErghLHv7B69WL5wVxo1esLMPc33B3prAE45X
6803	payment	1726	1726	1874	1	1	1216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbcBJdHvUfG7gPjcauy49mcUDbaioXDADBDedzsjgVhTH6S7o
6804	payment	1726	1726	1874	1	1	1217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5TfRuVZ2pK2bZZpLDb9vRF6Wmh8RvYytwTT8qF8Vj5VmdSpB
6809	payment	1726	1726	1874	1	1	1222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhok8wcM8uadLPSo6kjAvPT3rxBfcyWXBUT2zSX91uBGF3k3N
6810	payment	1726	1726	1874	1	1	1223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AiynRfG82EvkZDr8JhEMegEvgH9tUyRCfLnhNLFdz6TsbbMs
6811	payment	1726	1726	1874	1	1	1224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMn5YxrVdtbzz7Ho19WPsoc41BQPQnwd1hFoRR5WrVXS9GW2C
6812	payment	497	497	1474	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZZJ389SAcf54EpmmuZmTBcShtqnbdRxkRXsuGz1WsT8YpiEA
6813	payment	1726	1726	1874	1	1	1225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNxqURWDWJ2i6y8ookb3JQMgdEZZ2fpKZ2ho2GMHddGRu8GoD
6816	payment	1726	1726	1874	1	1	1228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5siRxs7d1eCdzbmBYuGqdDQAvNuaGMty1GDDZgTv8Mxmqy7Q4
6817	payment	1726	1726	1874	1	1	1229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RhRZJLAvsnskdFtbdkA8K78ggzsEBXKhzCH699kVukA5x8yR
6830	payment	320	320	1474	1	1	1	280000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYsT83vj18LH51i3HGgfPq2PcM3H79SG4ximeWrTVr269cDBo
6743	payment	1726	1726	1874	1	1	1159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDy53WeJKy8UmkZahNtXSwPM4Uxvu5euQTDiHb6wTjRp1PRaQ9
6744	payment	1726	1726	1874	1	1	1160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsQns3hBayzk2mzXCWrzVWcZituV2vGHd6hmvGvBzuDTQMPzx
6753	payment	1726	1726	1874	1	1	1168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfDUaCboUjbAk3dvmCiB3p977Tfcnd3yWnFk6G5ivSrtsUQgU
6756	payment	1726	1726	1874	1	1	1171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xTWiSdhxfTmEwfGM6n7afAmfWyhZnEjPqoNeqByGLGDLrVK5
6757	payment	1726	1726	1874	1	1	1172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5N8NcvfZyqd8xymFgouRn4FyK9pKqpPR1sfAHg5ZH9qWhTLa
6759	payment	1726	1726	1874	1	1	1174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzQuXUgSF8hchsPEoy6oWkykgwXzSQnZ8Q2kRpzF4KgJz1g2k
6760	payment	1726	1726	1874	1	1	1175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9B5NThNaVsVfxzjBA8PphkFZrjXvpDrnU4ucPSateALMUSuxc
6765	payment	1726	1726	1874	1	1	1179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Nb2FuA4tWpbaY2bCyqgcJDaoFCLfE4it8E9HRZgwfYGyQxck
6766	payment	1726	1726	1874	1	1	1180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsS8usoiwUHR24JSeqvaZGoCNsbXF9pcM6JqXstkatRGNvemXr
6769	payment	1726	1726	1874	1	1	1183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXdBrjdB6KSUMat9pE31arJkQAufjYztF2KT69oMijjn2Ms6i
6770	payment	1726	1726	1874	1	1	1184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82dHgv7tGbPzTBuAvuw81wj64tU6pC5m2NH2UtgmkMrMEPBrY
6783	payment	1726	1726	1874	1	1	1196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCrW6dAw8GUiRui7MDGuR5CUGbRodEumbMs3Pc3iJpHsDu7mTU
6787	payment	1726	1726	1874	1	1	1200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpGo6Mgs8uuYjvBux8V6B195AoUsww4Eb9T8iZkCyKxq3JaEN
6795	payment	1726	1726	1874	1	1	1208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oK21bp8U67Escch3gqZeoNoMEev345qLbVYumuob6mXczx93
6805	payment	1726	1726	1874	1	1	1218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqngZPadRYCZB2ctx83s7fYYTUEao8pR9aYZ6baheHTHk3zDvP
6806	payment	1726	1726	1874	1	1	1219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPnoi9gfuH4K9P71kroTsCLqEWpynRWMUzs1DDrL13TZBpRyy
6807	payment	1726	1726	1874	1	1	1220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6Fm5BMFgGDR3crizt3k2iBMkEzRn6q8ewxgmGwTRsa4wNAre
6818	payment	1726	1726	1874	1	1	1230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi41Jobqfca9yn3dEs1CB8QmNejY629Wsab8t22kL66UVpibHs
6819	payment	1726	1726	1874	1	1	1231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86yZR6wUA2s3WU4DWPHaL2pYmEoN2ZR7vJsuLPvi24HbANSni
6820	payment	1726	1726	1874	1	1	1232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVqmGMtaCvVrvS7WSi2HPPdRqo1mCqdkUz7vZrdnvimUsMv2A
6823	payment	1726	1726	1874	1	1	1235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvC7zFd2P7TdPFt3YcCfRxetpfred4Y3EV2ayGgRAqhHkRXDP
6824	payment	1726	1726	1874	1	1	1236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8DBrcv58f5ZUuQzvLn7jC8brT6ExVDdsr2orF6tUTno859Wky
6825	payment	1693	1693	366	1	1	457	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZUrcM713vrjjuVgttG7rsHdtng99TDnNN6wC6kSPTT8o4vNfP3
6833	delegation	366	366	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9t2yYQX3jeFNnCuwe8vr52vphYr2gEcYMAdumFgCs4UJTcCd5
6834	payment	1726	1726	1874	1	1	1242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkRbq8obJ2ph8xsbzQko66v9525UwwzbNsmwzYDuTTCC46u9Q
6835	payment	1726	1726	1874	1	1	1243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZrZfeBZo67XqeHXkJ88MwVcFs9jwcZjKB7X36ryBcSwpu5wD
6839	payment	1726	1726	1874	1	1	1247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPzXQfYmXv8vnEUfDuJf7xrDNFWijKocb9AWKpAsx52jimFqK
6840	payment	1726	1726	1874	1	1	1248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8WLGE51fdyoC4HQcAQcTQzeEL49oGsw5yYFxnSn9U5tVD34g
6860	payment	1726	1726	1874	1	1	1267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiukLLpheoXhUSNUXggGcjQExYPoAFc7gfgARRSys5o2gEB22B
6867	payment	1726	1726	1874	1	1	1274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1XkyHMHaVSYcnEMryqfePichgyb86JaMUtX1REXNeANyGUqk
6868	payment	1726	1726	1874	1	1	1275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCwrXRTPCJ1LFzKXhoxxvPrjU7FboGxpWSCAUifLHogcvEwso
6882	payment	1726	1726	1874	1	1	1289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jMgojGcgjWybbr5E9Z2xJg9V3PH18aA1o4zCFvPb5sFUyqep
6894	payment	1726	1726	1874	1	1	1301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gxZB5FUxXprm55x6oLTjMqrwmmyM6vcptoRiJYYB7HrdTex5
6898	delegation	189	189	298	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8zQfoCNBmBhLhyA4vmMBbzVUmckSAi4CJjDQdzNUaxnLoKX4
6899	payment	1726	1726	1874	1	1	1305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVrmxQ3EtcidJBCbSFjAo7Fkz5Jm2D2WpmQMefmipoXEpL8VJ
6903	payment	1726	1726	1874	1	1	1308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHeA7uZMXFRhX2jMyrzmCGX4PUWdzZsyBtTCWGsJUGdBHRuBU
6746	payment	1726	1726	1874	1	1	1162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9HmSTEFYT8i3mH3m3wZNAdXQQuG45Ams7sx4P2SkDcZvrLmg
6747	payment	1456	1456	1918	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMcNucM6UXcTWHAWoy5adcEesTi6rdwht9aff98s7p1oSw1WH
6751	payment	1726	1726	1874	1	1	1166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcQE6nJXvzU4k9wefKd93y2esAh46mAvUUHQQPVXwUR5jQCAs
6754	payment	1726	1726	1874	1	1	1169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UnaBEdbRaL7HL3qSmArUSpnHAxvB11p1ZSz26Wwt76p7dBUm
6763	payment	1726	1726	1874	1	1	1177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAb5MivbzokMAYWBQ9MXPnxCZQFFjg2uYAAUfGiU4om5vY7Rc
6767	payment	1726	1726	1874	1	1	1181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusA1ETvb4X2ubJqhNP4qehJ9qeq4JpdFWoRScbEiGvk1wn5Av
6772	payment	1726	1726	1874	1	1	1186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWiLYJax8YLGPmsokzyYW9LHpjQeZsdcTizSHRBAFFBJJB1wu
6788	payment	1726	1726	1874	1	1	1201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziUcyzkHRPYcZu1nPDHe2TN3pKbwohAa835f81p6YQLDaef3P
6792	payment	1726	1726	1874	1	1	1205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZiARngBqMJgheUjxUx7V8BCqK4St7bdtQ5vfKfyzuiQH5vE4
6793	payment	1726	1726	1874	1	1	1206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYza4EgPKZjzxRSKkouTFRUCztJCRRSfyDeqdsca3GuLKuvMcs6
6796	payment	1726	1726	1874	1	1	1209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabpxfi2PztvVyQcr72UDBmbGviAxGQ71FspdSazYnNkRevH4L
6797	payment	1726	1726	1874	1	1	1210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3ZWDEiVNrKsUuPEi6kSHHKc1gLEfhmFUmYNJrHjfSPNE5dCe
6801	payment	1726	1726	1874	1	1	1214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYy4r28gBFTnnEVbAgqB5CjGYUn8jPsSAx5o92ixcuuDsVUR2k
6808	payment	1726	1726	1874	1	1	1221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcBagRPLxYq67EaSRUbQ3otAnMpeHzRwfDAS1u4LVjfu16Fzg
6814	payment	1726	1726	1874	1	1	1226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNsLc83DZXoLg6Q4Ujc5JqFrCabkgMgPaUomN98YbK3LupoGu
6821	payment	1726	1726	1874	1	1	1233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixBdxaGDBW3nNVX4dmFr5FU2zshghAgkUNMg8getizPt8ocHU
6822	payment	1726	1726	1874	1	1	1234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZzw9kgLTCPxrTRqoUvmy5QLyuu5vNSxMEcHPz4fXH2LQVEBd
6826	payment	1726	1726	1874	1	1	1237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFPViZmN1AAhYoCbYi3SbkRNCnr5y3JtjHB5kUijS7eeGQeA8
6836	payment	1726	1726	1874	1	1	1244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFp73wM5q9yo1tz954gkDqupxzwaV1pATe5P34SpUEAULYZNw8
6837	payment	1726	1726	1874	1	1	1245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5nhPU3v7khJtKhLZnyjZtBvgsudKoug6CvALSuQkLBU1nEcW
6838	payment	1726	1726	1874	1	1	1246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtT2fzAXnt8KfVyhJvHdKM4iCNZgVrDW4M53R1G9hgA51ohJJ
6842	payment	1726	1726	1874	1	1	1250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7Qyr1zNsEtPbM19xiuapWjVP7zmUb1jZkHXXT6ozFEBvSmMS
6845	payment	1726	1726	1874	1	1	1253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9npMv9apFYzpGNWi2VkjfErEZ7Zd9kM53DxyQHNPeLR8uC6i
6846	payment	1726	1726	1874	1	1	1254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SuGM7zgzG39QvUprUG7BJh2xfYd9BS4HLmfWVDGXqcmF7SB5
6848	payment	1726	1726	1874	1	1	1256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5hC8N4XBLyAcrt5FwF7wDyjTrrRCmWqzoJ3VXXDe2Jsb9RcSr
6849	payment	1726	1726	1874	1	1	1257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqo1tYy14FNyGhjRJZLTYEjR4UfNKtmysm8qsrXtkaW2AtEYp
6852	payment	1726	1726	1874	1	1	1260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbb93WHKcbmk6nHYr2TRY17Vt6KSZEgu1NkRVueZ1xBYzeFdjP
6853	payment	1726	1726	1874	1	1	1261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7R5mqhEmaPodogm4Wi8yCUFsiKGNp3mddSnTbB6DWacPqK4BS
6856	payment	1726	1726	1874	1	1	1263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDywhdopE2zWLj3AmnLPkTUKYaRvRk7em1r1vKb6sd6aJtzZYN
6857	payment	1726	1726	1874	1	1	1264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeR2K917jDBF8VkbXxbogqdk53c9KF3dP4yHkPum2cjSSEYDfB
6858	payment	1726	1726	1874	1	1	1265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwuLLEeRT4YvorWrP1or3mYDdFvKzooqv22sHv2ki34Sodf4e
6861	payment	1726	1726	1874	1	1	1268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNqfktwgRRWDiTRqWYk7DfCFKYgGSSY4BxyiPGWRNeKoxq7UV
6864	payment	1726	1726	1874	1	1	1271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56yWkWFF9F9dcaAFYjvpwXopzYhUvX4yGbCMf1N9i1UzFfUqf
6865	payment	1726	1726	1874	1	1	1272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTTZqaRuv7fWdUSBQzURhzKphusGWuvscXVW1fvh5htLsh8SY
6869	payment	1726	1726	1874	1	1	1276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9c27pDj4RZQ7q31W8Gx5VhxMfUf8vnsQJqtyLJ6QXiEDhJ2B
6884	payment	1726	1726	1874	1	1	1291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYin55f4U8FtDWdxxgPtxhnLSvTsy7p2HTD9mAG5YRychHNoytc
6885	payment	1726	1726	1874	1	1	1292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrRPQhdW51WAFZ8Xm2peMf4ZJqGXmYJuzPr7sptcpZmyzWKpe
6887	payment	1726	1726	1874	1	1	1294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwpjiZTQZTHKENCfoHMfYtTiBSULmiUjCMTyQCzT8ZWRJVhbs
6831	payment	1726	1726	1874	1	1	1240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQjxWcADmz2aHRpxubNpKG1zgVX8qhrA6zSHJtiiyNvSVC8dY
6832	payment	1726	1726	1874	1	1	1241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7jJcrDPWyQBnA79nSBpRpvFmYL2pnrLu2zAhENV5fk3EGsdg
6841	payment	1726	1726	1874	1	1	1249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4et1vGJ5cbC4cXtZLkuQD4DJfCC6fZDqboWZ5CRDhg4SV1KBm
6866	payment	1726	1726	1874	1	1	1273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzzQYZZBmKMWNuSaV1aERvY8V1BdSSCSrsJY3164KfGxAR1Fm
6873	payment	1726	1726	1874	1	1	1280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPjYQCroTxtJckeLhKhm4KPw13sgXAFXTw834Yt6WKJmsY3Dz
6874	payment	1726	1726	603	1	1	1281	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiJ6jEthgHHFhsTu2E7H53v1yn21NJUirsFfz3CzFuHXWvZJU5
6875	payment	1726	1726	1919	1	1	1282	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZxLWrM5fhjaR4jpyhmxcRojr7dsSHL7vqNnHQXdxaS2VY9EHe4
6876	payment	1726	1726	1920	1	1	1283	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaC8p21dwfdcsQfwhkfNJ4HdFQ2nDAe6Qwmhkxn424zMhYF5dWC
6877	payment	1726	1726	1921	1	1	1284	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFBpcfUQtFWtvW6cSU5nwa7t91S6s6UxC3KeMXaBg2jMAiJMVf
6878	payment	1726	1726	1922	1	1	1285	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvDemoSgQJFTK9U7ssQ6Qt1YQy843YJEhhYaHMSpoPhTTPd2g6
6879	payment	1726	1726	1874	1	1	1286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6jriakdoMFBssk9yTwGfhZaACZnKwcRBha3wtac92XAmRFje1
6880	payment	1726	1726	1923	1	1	1287	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2pEBRxEJDi6jJj16GmgVG8AMBuLFkrGDqoSc3ZenuhNvKJqqg
6881	payment	1726	1726	1874	1	1	1288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpc6zw5BmCDcFnck3MVguvUGs1nbN88oWurNAet1v4NM7FNDeM
6900	payment	1726	1726	1874	1	1	1306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FKFUh35kKyP8uKf14nyurLswLZ5VkqoUCMKZmDQ1B2xgXf4Z
6890	payment	1726	1726	1874	1	1	1297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbkTzfQUa4Ww2hwChRBwix4R86QC2hoZY1JnwAZtpsTg2BPfT
6893	payment	1726	1726	1874	1	1	1300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKC3xnLukFxK96gVoczJcBiVcvusq7SjYi75RZPNTSbu84nSBQ
6897	payment	1726	1726	1874	1	1	1304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ674n4B2FmfFwGeuvTaGtNXNPufrcv6sgPBtiW1NTrcF2tzitx
6906	payment	1726	1726	1874	1	1	1311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCAJ4mveXs748H1tM9CNM29JzxFtfuZRQA41U8YaYGgeVqEtd
6907	payment	1726	1726	1874	1	1	1312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKCWRVnFrqYzYmXSdqDehC8otX6eGbtS5UehZi1bXCUymz9Yh
6910	payment	1726	1726	1874	1	1	1314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqWgvdJapXAeP4NFBuo8rTU92dGFBxw5AEuxSaGaKNQ6Nnz84
6911	payment	1726	1726	1874	1	1	1315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJFjCoQ4HhUNnee6Z6FQ6v1aCANbTStkG8g7nUNYUEbXcN5gc
6912	delegation	1750	1750	1745	1	1	8	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb5a1w2gZ2ygdzrgYs4JA3ouHFMYiab39oaxRofGroCkMcqXe
6913	payment	1745	1745	1924	1	1	2	2200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxExWgF93yx3nGd7hNdPR7T1CwA5gtUx6qaVD9wa14HTizgtoR
6891	payment	1726	1726	1874	1	1	1298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqgSNviwqzWRKUnHBiGpqPnx5egbnA3KohxpDvuFVfNawBbiV
6892	payment	1726	1726	1874	1	1	1299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2FXYaChv35YqmWNRn7Zq64evTx5RSpjyhfU4aqzokUD86b15
6895	payment	1726	1726	1874	1	1	1302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBDVxzmZxWPnykd14u8fqLqiHfhBjHUhHsQVxMPrm6Bdhy3V1
6896	payment	1726	1726	1874	1	1	1303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbe6i5nhtCJ8BCMu58LzE1MtearU9ZuMePgZEEiL8orgsmrcgr
6901	payment	1726	1726	1874	1	1	1307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcquecdWWaeS7TXt3sXovtCwjuWtM3AFT82VbvR6ru2oGqM61f
6902	delegation	1750	1750	1745	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiXW6EvL8PueEERbckYbEL9CtUGqpuqgBtTtaC32H5TaL5DFP
6904	payment	1726	1726	1874	1	1	1309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhuKr42xBEmw7fWJe2ETBhWCuKfWjEgueNnX2kewxTRaFUVKV
6905	payment	1726	1726	1874	1	1	1310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWawmuep51AcCQpBrrdZYSKVpGGeyjhAgfaus7TW67mtFBZxej
6908	payment	1726	1726	1874	1	1	1313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzze8P3veDVponYxX3ZKXKS8AtHLive14yAtfPHTtra8BSfEj
6909	delegation	1750	1750	1745	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmaMrxpN24jPwYiFuGZs9VJg6JhJQCi5vnASCaeCZZbq2wm7e
6914	payment	1726	1726	1874	1	1	1316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7pRpr3MFb2Xdcw4nqSGCAX9tjRoEqv8c8j6jmtwjHbzpbPC9
6915	payment	1726	1726	1874	1	1	1317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ8RDWXrE9A6LPt8JB4nPN8J7b9xHrca261oVreppZ6nbQzNn
6916	payment	1726	1726	1874	1	1	1318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJ8LuPc3e8ihWdgBUSNvwjtGB8rY2Y2ou1ETwZgyFVo37YrGN
6917	payment	1726	1726	1874	1	1	1319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBvJhPmSAHkz72K1uznoWFzur3wAM5RnwuoyNgY9Lg6xisK2L
6918	payment	1745	1745	1925	1	1	3	2200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgjN2YRFiAtjBBqafMZw885Ewtou9fEWYFZdJgag9jHX6uSjfw
6919	payment	1726	1726	1874	1	1	1320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKX8dKtQMbt8twqNwU8j6KUz8yvbt3mbiYRwEENrJnxWLMsJ7r
6920	delegation	1750	1750	1745	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1adGuSFWM8n3q1zscaHELjMFghG9Da8qf7E9K4CxmwLTNmrN
6921	payment	1745	1745	1926	1	1	4	2200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRNjuEwooWZhvTDpgtve8pMjMYYcc5MK3c2Xa5rnFXKY4EQ4v
6922	delegation	1919	1919	1483	1	1	0	\N	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhiCqXmpYc9DU5VG7x1KfDijKbJ6bu87uvC6jebPrYg6XMzuc
6923	payment	1726	1726	1874	1	1	1321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPN3y2JtQHwcgK3fiqbzKw8W28AAa1HAVCoqQ4nEqH79g8HUs
6924	delegation	1750	1750	1745	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLPzv7Nn1ZTM4Eb13DReUy8qBhAogJuNrYZu6rSrLTaPtPsqS
6925	delegation	1752	1752	1735	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtW31BWV8E8LuA1srQsNhJHKW4vby1pcc55YLJSGw65XARWzzV
6926	payment	1726	1726	1874	1	1	1322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE6EzbdmYAyFahr1CTL5iigPDcx7F5VJ6R1uWHAHaPW5c35GJ
6927	payment	1726	1726	1874	1	1	1323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fEZ1i7wszjvkg7m6pHwCKn4XgJ9sfZNq6n6GLKMFL8RFGc5i
6928	delegation	1752	1752	1735	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVR3MXHxGrW9P9GemvPtsawQ5o5RTayKb2Gc6pkWHwyHUzfmb
6929	payment	1726	1726	1874	1	1	1324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2a2c81cAV4ppZMyBoEwfUr4viyAxTYxvdh9ZAP5ZkTkjZh74
6930	payment	1726	1726	1874	1	1	1325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZefPq2e2FFvFjFEicbfySB5gXmEWFSxi7NQNK2HfeDyvBKfPeS
6931	payment	1726	1726	1874	1	1	1326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWddUWDxLk1WUzkHLAHEizwj5SkiW9yVCSJN4RWqwiiVWQcfCQ
6932	payment	1726	1726	1874	1	1	1327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSEqQ4uNPGfXL4T7wneN4wYG3K5YwHjhPpUiSjfuxgGJ4Sx7x
6933	delegation	1750	1750	1745	1	1	11	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpjrLzs3SMVkCMRWZkBVR5xkdoJfySCirobtkriPRHosTGSfY
6934	payment	1726	1726	1874	1	1	1328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbW2rHuqMzY974LqxtBkAQ6mzkFxfQwWHCjytfXeUwMDd4DXt
6935	delegation	1750	1750	1745	1	1	12	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwVxx955TyLZ6dGMk3QZALBSNPLm2Gqhe9XCNiaqx587tMQQv
6936	delegation	1750	1750	1745	1	1	13	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3LZtxByCVXTvbvzxNYoWG85sLLBawABGqTxk8m8E2a4pu3SE
6937	payment	1726	1726	1927	1	1	1329	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZsc7jWKAzJduFbb8bRzqMBjGQd5JHShXsv7ffUymVemCuP8ozL
6938	payment	1726	1726	1874	1	1	1330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDie7VhURiqNsaZQFUMLVg5QqeJgKPAmMpzMUmwrtGYzztMutk
6939	payment	1726	1726	1874	1	1	1331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxwQiqYPj4s4P3WRoNc3AFQdaxT5gbCFyjcSFS4y8RPxN7bWEw
6940	delegation	1750	1750	1745	1	1	14	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLzG2MPWZETKYBEE5FthSYYnhfoxd6Uehka7mp1A1HjPKdqjc
6941	payment	1726	1726	1874	1	1	1332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uNFxrHe5atDNkfGP68YEajcPdYZYCN2NVPnut1SArbZy2fhw
6942	payment	1726	1726	1874	1	1	1333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvV4y99VXN9XJ5RJYCZrzkLWTBvr1rbTcBU14HBDuxeW44Ye8S
6943	payment	1726	1726	1874	1	1	1334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1HH2BdvuA1BiDBYkugfj15KLEQjqHkXUaP1aUqjPQpcmt3Vm
6947	payment	1726	1726	1874	1	1	1338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5NPnbKjriu4YishiNW2rbewvoCiXQmYkJXrMaLrxckG1bbvC
6955	payment	1726	1726	1874	1	1	1345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFBr3i7KtCrwP5mG5RGNw6wYjBRno2wWVwBUP1zR7ji7rVMk9
6964	payment	1726	1726	1874	1	1	1353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGL3TE3rXvYuDU9obK8wpRtCDw2xHjZT38QuA6xHY712wzY4Lg
6965	payment	1726	1726	1874	1	1	1354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYk543qsdx7vXLHGMPKmaLHH6Sqg7YK6vCAq83xDawqajMh78
6972	payment	1726	1726	1874	1	1	1361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7cPLuSj1ihnqz3PKuSWDRBCyeyCzgZbY4MumVucUL8y4pWd4
6973	payment	1726	1726	1874	1	1	1362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFNdFXoi8raeX5CFKzQnE9kbFkNn1eskMwovnrgs9nwQoNwJ7
6987	payment	1726	1726	1874	1	1	1376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbT91XymSuJretc9UJmuzAeYcvEhfAdBEGN2ebHZViup6gEYj
6989	payment	1726	1726	1874	1	1	1378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jZnt77bpqDtgMBJ5NYbvwf6VQtGZuEUxLEhc9RighYvBY5M2
6990	payment	1726	1726	1874	1	1	1379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GvnipFNcrDKXEQcJXGTuvn9dxWbkYbkWoXwzWRvMfAcSbG7k
6994	payment	1726	1726	1874	1	1	1383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGNpPu47WwzaURMVekzEKonrwK1eEJ26T7pueJwPyNh92e4HM
6996	payment	1726	1726	1874	1	1	1385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3qGWozASFbQh8Xv3tBaZRNBKXRMojN9VhY84FbyQM8XRA8ED
6997	payment	1726	1726	1874	1	1	1386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFhcLDDFCoo7nvG1Zw4UN5Ht3zNYgtgmnySLweeKrA3TbY3j4
6998	payment	1726	1726	1874	1	1	1387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Dgk8fczSvTFRoJvuajMBy2cxuM2C1kyuGjHNzMKZ3HSPNyZy
7008	payment	1726	1726	1874	1	1	1397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCfM5LcUCsfzeLY2jyDiN6W8iiDNSxXnbqQBMCnwko14g3M49
7009	payment	1726	1726	1874	1	1	1398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsrkDj2bCYGomurWJG4pQRfvqZvfbJLPYBCLzqpxpTV2nCAoJ
7023	payment	1726	1726	1874	1	1	1412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaAtmyy4yPmhM9Ymx8SjUZkb745Vzck9nxCHGUKPQxCqUQ43c6
7025	payment	1726	1726	1874	1	1	1414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhdwB8daQvxXkQnr8fBRRxfCbd9k9XUgS2176AKibKmcSSPwRY
7026	payment	1726	1726	1874	1	1	1415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJ9seQkFSKkwWk7MW1SkeF7CnWB6xpvGpyWy1fmBAc58BxQoV
7031	payment	1726	1726	1874	1	1	1420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhinQHXcK7KTDhdcPHiSxBeRxWatpVCssejk4fUMP5rLsJmLLB
7039	payment	1726	1726	1874	1	1	1428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqiDXcLcQXkx2rVctaJCJh6HF2agbUVcVU2Jh6ck4WTLSWfF8
7040	payment	1726	1726	1874	1	1	1429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQx347cRqNGE27bsLELEVjoqcjJDBJiSyidjPoHZHcZoRHaHUo
7076	payment	1726	1726	1874	1	1	1459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRS2HQBbvJgM4F5M9gimu1U3PXMFFmyt8xQTBVJVZruAS3TsQ
7077	delegation	1931	1931	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCjpfJZUA4GH2ZC1DP2QPBeRTXKc9tFVS1yV5XP1iTHV7vwhd
7080	payment	1726	1726	1874	1	1	1462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqX87CcepivxUXUG4a88yDBrAMWAKpFTmrQHjkrPbA4zZ9ZXB
7081	payment	1726	1726	1874	1	1	1463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSgDXWP2vL4uFxadVFy8a3heHAT3isoweYE4osYGwoFWFt1Xxa
7091	payment	1726	1726	1874	1	1	1470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVqGM8RAZdBPghZ5kQsYHWeaDd3CUa5iP7EP4NAwf2WJxGMMR
7116	payment	1726	1726	1874	1	1	1489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3v4kjvn1XzVcLdZz11teqnRAueLHney5fqS2CLsEhpmvCshz
7119	payment	1726	1726	1874	1	1	1492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqV4ZuMoX3gNWoKvb26D55svoS7ymJW3m1RXaosKcmVogR6Ly
7122	payment	1726	1726	1874	1	1	1495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBurMsyMyp5VSH552Ctzu4ABHJ15TiwH9oJ319TNR4nZMi19E
7123	payment	1726	1726	1874	1	1	1496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7xDXMX29TDHrnmgPb32pS9sK8NXkWPQWychNp7HKiM6MBdXs
7128	payment	1726	1726	1934	1	1	1501	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYhdN3mGEyiqdm7kZKcMu5mKezxFLgpm7PxJWnkuyvdmffE6RFT
7129	payment	1726	1726	1874	1	1	1502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3EjG4adFEQvcTQobGpLhrvYCvWeZ9nvSVFkWASUp56cQeBaC
7130	payment	1726	1726	1935	1	1	1503	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8bhWRZ3ZqWptHJ66yGefZ7esmssfamcjCYPj9QXrZgrywUjuV
7131	payment	1726	1726	1936	1	1	1504	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFaCfkBw5byFdPxhTM7ofBe69bB6kS7DxzVkBxsGk88sojhsoE
7132	payment	1726	1726	1937	1	1	1505	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXnufA7THeeg93vjc9d39PQPuMbEB6euPyN8TCxd2sNfC8257F
7133	payment	1726	1726	1938	1	1	1506	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbFfcJk26SKHf2jVHi6Jiiyf61b5dbfWFYQpS6zsbyouLb79cT
6944	payment	1726	1726	1874	1	1	1335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGcYDoeM42LjH4CSDaWkGhrWuejAT4ZZCsyjT2wAUvtENtqUU
6963	payment	1726	1726	1874	1	1	1352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4T4AGVVoRHj2bsfr1dBaCLYctpuKLYAkNnoyRpG4ZzLYeGszg
6966	payment	1726	1726	1874	1	1	1355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiaQKxduvLmR5HcneQj7HMFuLet97m6BVh3REY3ZSDATRFLAV
6967	payment	1726	1726	1874	1	1	1356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6snpwN7xvuKTHa2ArNEktip7wHNZ6wR5h8anvQJdQXJS2d5VY
6970	payment	1726	1726	1874	1	1	1359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgKEFSWd4FLKoRZoQyKE9rsz1XdDiBmMxGDSh83ob8nfWp8y2
6980	payment	1726	1726	1874	1	1	1369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmu2tYNXaNN5cqspW4KEjwWLoPYAHxRKsvrNC3EqccS6Uv4kc
6981	payment	1726	1726	1874	1	1	1370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wf6mUz9oKRytQF7rELVeDrh2NCsUEWSYt67MuSm2omcMDvgR
6982	payment	1726	1726	1928	1	1	1371	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZxcmbb6j5XWfHgCyCP781emoYswa4NMeUpU6Wc3ELbDvoGnAEM
6983	payment	1726	1726	1874	1	1	1372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGNfF6XqqD4aXVueuoeKqFR5XLqRTwi3LFnxcZ9pZTADJA5gY
6984	payment	1726	1726	1874	1	1	1373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38gM13TwQvtJVdP5R9DtYGELHNDBEoWkVj9dP6oFqWkLpi44d
6985	payment	1726	1726	1874	1	1	1374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5cC4ZANGB26ZxSzi9gqiggMeKRcxEddsPFgTTP1eVCtoSmv2
6999	payment	1726	1726	1874	1	1	1388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdSfR196EQQXaWaMBu8WCEZdELg31eCaMb3pBw7RxNtZNwrAix
7006	payment	1726	1726	1874	1	1	1395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4cHQkRmoFgeew55Rhfsn6mjtxbbb5aFrNzadmMnK7Q1vLk3a
7010	payment	1726	1726	1874	1	1	1399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBnFzDbjtFv3oMduZWUyYZCY7PbhqZ8vx7mE6ksxuQx7bccGx
7014	payment	1726	1726	1874	1	1	1403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJzgjfn7iS9jW8SDar6gnyvdjiaqXsGNarJzcUnotvKMfPYbW
7021	payment	1726	1726	1874	1	1	1410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2FD4NKgqqUWAJNRvJngiyUcvxAMTBUAEqSZmGjETTsqiYFYf
7028	payment	1726	1726	1874	1	1	1417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwh2ZGwjFy3dB95ZYw3cyEaxpUgHDSn7yiRQcvHaUPCixfyMuD
7029	payment	1726	1726	1874	1	1	1418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7hqPDfWjhTmfRrtY95kAJSUbrqTzXkEPQM7vyAQdVAtuTAsq
7030	payment	1726	1726	1930	1	1	1419	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbWAi1t4gA1DjwKvQ62Yp3A1fxxaBBNT31MBzpmAMroyiq5FAz
7033	payment	1726	1726	1874	1	1	1422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtcsEJ1Af6NGwPby6z9bV9N5p6UPAvYma1dfC2Z8hZKrH7PKJ
7034	payment	1726	1726	1874	1	1	1423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLJ8tTj7ZHDw4kJisAGUykaioJUzoP2fscKjJnfGkkTaEbPi2
7042	payment	1726	1726	1874	1	1	1431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2yE6ACbJka4WpXBvLfz8rBzeVrYVALbMxHa6cVQ9LJdGac3U
7045	payment	1726	1726	1874	1	1	1434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1KYXR1zWUSN3Gyn4iKWnSBCNSsvXu4ebK3DaPy6GqL1r3curW
7046	payment	1726	1726	1874	1	1	1435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAr57S2KnsnoykZnkbEgSiPSS8CKw9hmvTRPUNEQ3Eb6bJxbQ
7050	payment	1726	1726	1874	1	1	1438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcJgMEhCZdKpPP5hnRW1zVySEn4hxY11ybr1cX5GYCw4DBMFR
7053	payment	1929	1929	1929	1	1	0	500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHayJr3g316fhe7gVP8LpcQxMxjNdiEBDkMzB6dEAPXaLNJuqL
7054	payment	1726	1726	1874	1	1	1441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TwLmEkLtpLh16S5hdxTZHDJYk6vP5bWro2ttNQnn18BHxcrb
7055	payment	1726	1726	1874	1	1	1442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRB1zWihAPpC8UnXaJAkPnYqdcx3kLXSz8xB31sMnhXdcApoVj
7056	payment	1726	1726	1874	1	1	1443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYw9m5tmVb1DHPoYe7y3NnJhNDgz5JeKTfrMwoaFDr7d8h8k1s
7057	payment	1726	1726	1874	1	1	1444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyG8cDpMc3f6soLL1Evr75DWpRXa3B55pfDxSKtYeZD5mXyp9E
7058	payment	1726	1726	1874	1	1	1445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1qKKekHbCeCsJaLcgHSZrAHVWMZ7PKp8YXbQUGPExPfZ4Vhp
7059	payment	1726	1726	1874	1	1	1446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBFkQTQgYPB6YWkFAvfa2mTXH8enz6VHyFFef9qdVo4iq9WSN
7060	delegation	310	310	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdc9rXmF7LgeA14LGxjEG2oLt8r1KSWZPyRreoRoDVPhZPzJw
7068	payment	1726	1726	1874	1	1	1452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowCD486ZH4fGaUc9znUBUgwNxss8osrNzpjesxv77H8VH27gf
7072	payment	1726	1726	1874	1	1	1456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBZwCNfe8sHEN1A2WhsGwzXe6J4hDfaJEjfS4WBDKZ9m9gL9Do
7073	payment	1726	1726	1874	1	1	1457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdfLS2MP6kCZxTaVfXbpBs4j9w31JUW1y38qeLW7iD4coL7HX
7074	payment	1521	1521	1931	1	1	3	1010000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFUhNGhUN6tgVEak1NoasmsHoqCLATRoHPiiQtyE8iNEWvXjE
7079	payment	1726	1726	1874	1	1	1461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tjZ46sUwv5DMixBGkQH3SvZiyUR7CkfNGf5tF6D7LS1LNcq7
6945	payment	1726	1726	1874	1	1	1336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuon82y5V2dbsSsjqaVUcdL2oZiT7LfSkU4Jq46EFENFVXeJxY
6946	payment	1726	1726	1874	1	1	1337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8XW1PPA1PiELwmYeJNMzFrnYVWf3THD1rpvkH2RuoDf4VsDk
6956	payment	1726	1726	1874	1	1	1346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSKNp9JPPLdijXJL4zR9SvZUjieUbFyffvHtYkTvXW6NfAvXM
6968	payment	1726	1726	1874	1	1	1357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFxxJBRuMKyeV4icnaB1KXPGdYEJnoLbz5YQJD7FL4Q1XzRpY
6969	payment	1726	1726	1874	1	1	1358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhypkxJhycABCeYaGFKxBBXFA4stJiDgoZ2NfXvSUkvwcYf26R
6976	payment	1726	1726	1874	1	1	1365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTNip6C4kVGjMuArn2F9oun5DsAA6QeykVzksjfM41dCzi14d
6988	payment	1726	1726	1874	1	1	1377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVodBfRZ4iqJdMcgTEkWZ7w2i1Qsxst2xUn9pkY91ebKaueqL4
6992	payment	1726	1726	1874	1	1	1381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tpsBrBf35KMD8UXvZTGPQGE279YXeBe5Gkecwke98WuPuAJd
6993	payment	1726	1726	1874	1	1	1382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgGz43rBf1otD2YEVwGDQdKk1xBaz7kyHEh5upms26DThudpE
7000	payment	1726	1726	1874	1	1	1389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNXBAwnmpSGnxJibWcoyPKmPHhmaXe6dSoKqeR8aVz5KKvkMX
7001	payment	1726	1726	1874	1	1	1390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNyudAB4t9ftMPo8iBymBvb8PmQSgFfEfWT2pVwBL2v1wwdfx
7002	payment	1726	1726	1874	1	1	1391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoAx5xBRW35RBmNxZDxd8kPkpL8J35QQzxbJ8kANp3fCnBfqqA
7003	payment	1726	1726	1874	1	1	1392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHVZxdHa8b7sxPZPxL5kkzbpdaYv1xxS9xbYRw87cb3j8kYx3
7004	payment	1726	1726	1874	1	1	1393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvtSvc2hndwbEhYixWhr6cVd7hTUdnLxwxMNZHdXkTqzydUai
7005	payment	1726	1726	1874	1	1	1394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3MMxYAnqLxsjyHTED1SwdmGMZefFt8LowWzuoiAayJ7S8TkU
7012	payment	1726	1726	1874	1	1	1401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pN82carpCMNaMiWRr8CCmMTnS8HY84RHRRcyibSk6JHtkJk2
7013	payment	1726	1726	1874	1	1	1402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1scYAry8xLf5j3fkbcDShfdSDxTxjj8AQRPPjq6VcKSadrVRC
7016	payment	1726	1726	1874	1	1	1405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUr87zLi9FY2byE6S12E64cc96PFjuuELi26zNhyMv93krWWM
7017	payment	1726	1726	1874	1	1	1406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJQpDZ5ySgbT94BxAdB1mQjgzVivnGDJJ91xWvXNvuvc6aKvM
7022	payment	1726	1726	1874	1	1	1411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNedwaNFsmFoh4WpDHpepjNp2rzj18LW3NqmNtJsM5yKTBUM2
7027	payment	1726	1726	1874	1	1	1416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqo2K2SBQZmhTZs6A5VPjwD7tDWxZA78tqE4BCme9HcECZTpa
7032	payment	1726	1726	1874	1	1	1421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfdLjqUHGUzh8j3jYVCbNpFyT6oNRZGYz5yXErasZMDinwwbe
7035	payment	1726	1726	1874	1	1	1424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QPTHiwE1Kwe6GtHummu7uQHRjM1HAAdGg5wK179cU44GMHzY
7043	payment	1726	1726	1874	1	1	1432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CqxaagW9LPHyXRddJVBugBMnNaPW3gqAn3LXLVJRnHQiCkWR
7044	payment	1726	1726	1874	1	1	1433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnJZZotjAQq16NtdswDzJWJVsd542JAy4eS75AVxq9q59KtAX
7047	payment	1726	1726	1874	1	1	1436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBKiFBK6M3dnPxpAgnuyPoHQzUEeAS3vq7gFrrYZaYtcUtvrt
7048	payment	1726	1726	1874	1	1	1437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9b1cHAafzNYDxag66wQeG7MSbb45vT9aM7cPSyMJmnLWjMMUQ
7049	payment	1521	1521	310	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsd4XmjHbgzCnAR9HEamw6WAaBXzUv127YyKoqdWe1o3Vkd5ie
7051	payment	1726	1726	1874	1	1	1439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8v6f2fKpb5LLwcATFcMaPoBBRpxmZZ8H1Eu7NZj4WgML1rDdH
7052	payment	1726	1726	1874	1	1	1440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyziYxJnRXtXfeTpLbZZvGbtM3oHtBwtwZYciTrwktBVGyFTL
7061	payment	1726	1726	1874	1	1	1447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ucKjwPiheQLu9fBZ4unMtjTJSpM7ZUfNiZQ11bNmXa7mQjmx
7062	payment	1726	1726	1874	1	1	1448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7oYvoAekJGfW9REoXVNqgXTKPX3Tu5y9BkDERHj7BY9hbBpM
7066	delegation	305	305	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYQo8xT8SvS5MNXrwMUMNF8esH7Dkp3am45tzc28MjmciNxqx
7067	payment	1726	1726	1874	1	1	1451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbvioDFUh2WRKgkhRPbKT6XPoRafg5wctp8yWWpm6sN6AneG9
7069	payment	1726	1726	1874	1	1	1453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83LdXQadvMTsYwsaVAGiQX67BrihZ8AjbfMXNW56VLfoFK9qJ
7070	payment	1726	1726	1874	1	1	1454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaDSuQBJZJPdBWtttog5mBRYRoREhioe2f1EEMxyxZwiAbrbK
7071	payment	1726	1726	1874	1	1	1455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDGUbkYhJrn56bt3DBJDPBjW6SEjPo8UuAHeTCH9uMC7CFCBL
7075	payment	1726	1726	1874	1	1	1458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgazHJ1iB5uuSPCF4hWChHzyvneEAZF9QBqkWQpoPFy6P192s
6948	payment	1726	1726	1874	1	1	1339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPrdMQkEZGQfBFHT3psjvnzpD2Lk7HhffpYjpsQXPsRAKbEgM
6949	payment	1726	1726	1874	1	1	1340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwv6JH46EsvmprL1v4VZVpTJehajPZ4rvdx4GH9saQhvc1NE9
6950	payment	1726	1726	1874	1	1	1341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSrf9oQtHNsfzu69wb2z64P5FxdYYjan1beRJZZWkPLH1y97B
6951	payment	1726	1726	1874	1	1	1342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLgftPEJJ2pNCsobzWtMqAs2WHwq5zU2eM76sQm3gxcHadWU6
6952	payment	1726	1726	1874	1	1	1343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1D82svY9AdZ1phyJbVZDaJR8yzTRdr8joVm7bQZodQN8bhBc
6953	payment	1726	1726	1874	1	1	1344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUpsmJpmcKSrvf4zMio8VKgNDLHBT36u4yfksQ6dP2ifLf9Ba
6954	delegation	1750	1750	1745	1	1	15	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngEFNUrNinBBDe9EES5a1xd79mUhicKH9aeEx1afcysoJK7PU
6957	payment	1726	1726	1874	1	1	1347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuh5RQfJrPJoctM81Vk7GvDmi4xMQSrzHoL8mU78AehXXDQUN
6958	payment	1726	1726	1874	1	1	1348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvC3zydtk6kGvxeUeferU9Er1cwnbLcvfyu4dGiq8ExDTymvL
6959	payment	1726	1726	1874	1	1	1349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQagsKzX13D9wiF2B7RHP98M2iz89HYhpgji9usoGp9HrsXpcb
6960	delegation	1883	1883	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQAFkKCrSrogShRF1BdAAB3jfCSqMZmXhrAUGWjgMWZqzYBWh
6961	payment	1726	1726	1874	1	1	1350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJN6U2zkvFw2pPgHVoaKftJE4849vkFnicUsgGpVBp2jArSMDn
6962	payment	1726	1726	1874	1	1	1351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVTECeAhJ4GW5HJoASHH8TRgFWffgAexCkMsWicsudQ7qGLxp
6971	payment	1726	1726	1874	1	1	1360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2xKsEWaAKLJbXRNFNFP6oiyuZg8UqNbhwH52uTheYdpc9crS
6974	payment	1726	1726	1874	1	1	1363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU5QTaNgArbxZKKQqBJAhdTSY1GChAVcxkjwfnYZY9zUwYJ3M
6975	payment	1726	1726	1874	1	1	1364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjL4QMyMMxxNRnXWFbFLmKQiLa2UcwL3KhZ1yPnwfi1RimzcZ
6977	payment	1726	1726	1874	1	1	1366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dsZonn42jKPxPwxcgCJYGArBF6eNoKTpywTFTFeKSjpAzZ4S
6978	payment	1726	1726	1874	1	1	1367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cB6fdUKEwXyqpCGwtb7zgYRUMkfQqEHHbFLUgHSAWsMjoPg1
6979	payment	1726	1726	1874	1	1	1368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfTMtDzzmTKZ6o4XTr7d9hcaUCnTJYDDwvj55sGobGbiemb84
6986	payment	1726	1726	1874	1	1	1375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVDcNNNteCHY9vDqj7CtJiz7FyHX7arcqQr9J77CS3L2USmub
6991	payment	1726	1726	1874	1	1	1380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZTkXpXqGHJRhbSZq7cZFFDkbijbC4c5r2irneK6tEFhYVtwJ
6995	payment	1726	1726	1874	1	1	1384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyJvHYrGWAhbHPL9nJAUzWARaTKtmtokGKrugbChcghxZ5ya7
7007	payment	1726	1726	1874	1	1	1396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYa9f5QmnrrnZPJ43a5rVTMdc9Ssj7Ad2B1MXqQmrbxhAH5uhr
7011	payment	1726	1726	1874	1	1	1400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fnrbUYGc7bTvjYT6pHdFg3cNFuGd6hetUVoFmRRFCxbT3wVe
7015	payment	1726	1726	1874	1	1	1404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZga1cvknXpbvz3iYWD4CYkHoavuEa5Bv4WfNspm8vF3JxzLgUw
7018	payment	1726	1726	1929	1	1	1407	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa3KPTREwz61vs8uoPxBhFgXWoGv8qphsmqyFrQ1VLnu8BGTBCr
7019	payment	1726	1726	1929	1	1	1408	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCQRwYGVap1LhFrRGn4cET8SR3EH3UjyZ1Tq1Z81aMDxwF46Au
7020	payment	1726	1726	1874	1	1	1409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQM5YppBe3JfK43N6iuByxaLXJanLg1PVr9MbAkS1qBnPADCq6
7024	payment	1726	1726	1874	1	1	1413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXvGnyXs7Ku2gg1q7uxpGd6FqzgjLD7ATAoFzP1boiTDXvjbm
7036	payment	1726	1726	1874	1	1	1425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQTsBWorwnEUWC7UtACM4CJzuUGcvK6Liy49WgJ7jNtcShLUU
7037	payment	1726	1726	1874	1	1	1426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3RJRo9q8u683rFAaMKPn6NXYVRSq1t4BWtQvvS45RFRi9pFz
7038	payment	1726	1726	1874	1	1	1427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcD82nFkLCZbDBtgCJ4ZXKQjuBfzcLLdAEBp9pZi1283GbPRdr
7041	payment	1726	1726	1874	1	1	1430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1LtB1GE8fivRH7Sv59tf8h61y9SuJ8FKA6eWRPdSeweJ7eAz
7063	payment	1726	1726	1874	1	1	1449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQzAa44TmcV7HLSjv5qy5DJWYEbCz49Ci6DA7BLmzGy1CjjUG
7064	payment	1726	1726	1874	1	1	1450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6ZRxyc7pxd6CCJ3LLUqnPQ5zjQmgUZ2QvDPDJSENT3zU6XP7
7065	payment	1521	1521	305	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kTjNtPSUPft1o3JBsKqjEAZeCq5vuz8Nia1PYdcMHAWy9nCL
7078	payment	1726	1726	1874	1	1	1460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWY5nevaRLjFSypdsceYxrx2g1QRynQ1UG5PDV6nFtyBeyF28n
7083	payment	1726	1726	1874	1	1	1465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghs4yyRmGXyqUR91jGRhkhGQp6456aw3KmgxWrmtFTDrkNPCv
7082	payment	1726	1726	1874	1	1	1464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNFAkWhGT1sLz7ggURa1Bw6XbvhA25bsX6hK4J8UhY9BB7m2Z
7110	delegation	166	166	1521	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkRLpD54PUZNCc3RtABNmsChGgbTW3caHJAKxrPkUxFpm7biv
7117	payment	1726	1726	1874	1	1	1490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEojjEg69iFb22XTG4TGJQ5wFRku2MSG3nHoGv7iXQfmsZJ4vd
7126	payment	1726	1726	1874	1	1	1499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZLjWNWHTnRTMvHZ7W2HF6nRJBXwYCabcc969DXEyo8xmoPfK
7127	payment	1726	1726	1930	1	1	1500	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiM7UHeSGqsp58wzkH8SWA2uDQ3u6Lh7PCrofEuvHhbzsLEVDZ
7139	payment	1726	1726	1874	1	1	1511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1wKshkXCQGsug8CBoSFrB6fhd22iWr4QiUCy57L7FGyTjq5J
7140	payment	1726	1726	1874	1	1	1512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFbYcJZaHickufEErxTzD8wzDNT9THgyEKAwuaaH6TBy8Qh67
7141	delegation	1769	1769	1578	1	1	20	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy3cir3SBM9yQdEzrcF1cLr2hv7Z8G5XWsTWFnff9VpBVeLs6
7146	payment	1726	1726	1874	1	1	1516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVVK9LN5YpHPMZMYpuP1R9woLNer5xvbZfvJTT3UVdsqzyoZV
7147	payment	1726	1726	1874	1	1	1517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybgxCTmoZefxfUo7zJ5jCgoeAyTiwbbvDfH2CudDce6Tgo6uR
7154	payment	1726	1726	1874	1	1	1523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVVzDpMoX8PSZQLhcQMnhHjxidyZKRi4wpE2EukKyJHQcsQipq
7155	payment	1726	1726	1874	1	1	1524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFRTYK2JPCxXSqxrkdGacgv7UHY6JuDBAx4twRUri1Akb1mkuC
7159	payment	1726	1726	1874	1	1	1528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFtmeRo3gxHizmQvgboMsvwresb1cTViATdxZ3RrcBiov38Bc
7160	payment	1726	1726	1874	1	1	1529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXVgB5LYzRmkVuoYmwDzh7zC8WqCmvVDdjH49dgBD9cyTqdxa
7164	payment	1726	1726	1874	1	1	1533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTRw7ZkXgAQheR1eSuecAHYcBUNH5hG863QfvUD3t21qmUmyY
7174	payment	1726	1726	1874	1	1	1539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSPkDNyKmiXWxPWj9h1y4CZvFAXj3RyUJABJfZ4AbNkNmD1qG
7175	payment	1726	1726	1874	1	1	1540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZF9x8FbKkmrrxThKNdQEVwu3Sn1JxkEppaUi8WH2BECEyt54E
7181	payment	1726	1726	1874	1	1	1544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgx7A5vbiJ6Q6p7uRZNSJcGrUmtY8ci3ZndhECiXs4g3Swein
7182	payment	1726	1726	1874	1	1	1545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFmeWn1Dq4CHuGjUVeYVfJTej4ag3aeupJQKK2qJaxKAgAHeC
7194	payment	1726	1726	1874	1	1	1555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUgquMYQVCrHgvmwxedRvt1TKfFjQLiUuBzpMvVFmr2N3Yfjje
7195	payment	1726	1726	1874	1	1	1556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5e5r793G3G48Bdzn272mhsiwvELbQ5uehDN9vy2uJrpFx4XoY
7202	payment	1726	1726	1874	1	1	1561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4jknAdMEss968dxoWEZdNchxqTS3vocV3XtMWLTTXysLa1C3
7203	payment	1726	1726	1944	1	1	1562	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgce4th7GEzThJFdDipQPzHtoYCJtGU6NAphGqkWqeYcnzdWR4
7204	payment	1726	1726	1874	1	1	1563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZobVohczuH418bJkcDsAEmxWtsAbYy85Z9zj6TDthcNZMtVWB6
7208	payment	1726	1726	1874	1	1	1567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCop8UWzpZ4QxoUb5dodtXGmHyqRqcBrk7CkBkYxKrsaHEwctz
7218	payment	1726	1726	1874	1	1	1577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbuL7zxiDSi9pfjCyKKRhubbNkvzrMcAc5kozgTLvkfoGME3qu
7219	payment	1726	1726	1874	1	1	1578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiQZe6Hdby2hqbxXrcupcDTtaTLs7AWcBt5ukEeVyqDPN8Lhn
7225	delegation	603	603	1483	1	1	0	\N	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRvXWHzc7E8FAV5DbcXLoRgf2G1HWz76QLrkWgeFntNqA17V4
7226	payment	1726	1726	1874	1	1	1584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzDD556oP3rbiGAaS3CFPXwd7jDAnTe67qGcMW5Y9Hx1vNNaU
7240	payment	1726	1726	1874	1	1	1597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTUoFt6FeVdUZjBtWspv9ZVEDQTK1J4QFRAB4k7t6oaE4pEX5
7244	payment	1726	1726	1874	1	1	1601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX58u3RsfdYvDy1HWrPQMWTKQsxkQeXdJcoQGJxs8feaNxYepu
7256	payment	1726	1726	1874	1	1	1612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUiP9LbFc9srmAYZZ2s6FWPSKXJEvZPFardUfdxJe1jRAJKcm
7257	payment	1726	1726	1874	1	1	1613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1C36FTMUzzvSWhAC7LyFMiBV1gAvxExtqEL5oB887BSR2orA
7268	payment	1726	1726	1874	1	1	1624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2StVaacQjBT51nLKWRUxpnkSXG6TEQNx3qd7YRJdZkauFe852
7272	payment	1726	1726	1874	1	1	1628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsyf9URBCKq3ZDFLpNtVXFm18nfiCn9bq1dvVbzxLgG9FHy6E
7273	payment	1726	1726	1874	1	1	1629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJj89eKJsM5baMgxRz2X1BpfqPq7RB6LceDSMq8Fc4pZQm4XQ
7276	payment	1726	1726	1874	1	1	1632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWKmHkQESx7ZpooDV8bLa1KMQrfmKjhVh1soiu5XasW1ePSuV
7288	payment	1726	1726	1874	1	1	1644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgHNiJQFaK5rHVh7RAD4RNXfkSpWuxTFkeX3epZa8Ld4VduvC
7084	payment	1596	1596	1932	1	1	5	22000000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8yQbAa9oe9YvtusywGNB7d4vyYzMfSc91phe43nTCwRp7END
7088	payment	1726	1726	1874	1	1	1468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYor49w2WKWk6Y3gFt9yCov5SULZ3yYePswsYdNz2NgqJgyf4qM
7089	payment	1726	1726	1874	1	1	1469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPBiE3jnt1uZAxKTSHAijFGBFD7zv57iAmYnHWKNnZ2j5ytcA
7093	payment	1726	1726	1874	1	1	1472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPjhJFpumr9NSwgnsQa5tXy5EbKZYmCR9d96GnYN2HUjTNt91
7094	payment	1541	1541	1718	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8hEZy7QjBf41mwbrD9p54TfQkboaLqaSeyFZYhpuTmL2rAYN
7095	payment	1726	1726	1874	1	1	1473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPdJx9y93n1BCbWhzK2okxvRxZyD7FmMs8eyUMYNuuv6R85BC
7099	payment	1726	1726	1874	1	1	1476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMboYz6pxyhHKHktWrVnjnxcRAPx6JekQ2TLY1R5ZxSUZKcnp
7103	payment	1726	1726	1874	1	1	1479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA75ornrwiTmmtUUsZ4agwjsjeAYX8LtCGH9qjyLfPh8qTZkoc
7109	payment	1726	1726	1874	1	1	1483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnJB4QG3wiGKQPjQ6fdF4yW1c9gWYsPHXvxTMTjPwq724Bgtz
7113	payment	1726	1726	1874	1	1	1486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYie4pJ9z4aqwMTUCrEkyGkFFWG7xL4DZfGfwooahZ65hEksE8
7114	payment	1726	1726	1874	1	1	1487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3WcKyntbFKsAUYKz82TrwjCNojqE2CbwHQVhnKCUDU852eeV
7118	payment	1726	1726	1874	1	1	1491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwek7SYxfSBRwXbMVQqrtnCTFxEdvKyYpwmmD4akZviPjRZ1Ad
7121	payment	1726	1726	1874	1	1	1494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokAGZqsMFPUpzNbw9d7tbWki6ZUGoSdZnDcqaa9k9pNF42bys
7135	payment	1726	1726	1874	1	1	1508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsjhPdevU44fb4YCu6vi6Fj2PD2FYP8xh7G5KjhHFBDQqmGdR
7150	payment	1726	1726	1874	1	1	1519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTudisAfNYAEUDKHkXKbn3Gcw6EhcTep9MnSCQfcHpuhcSsyf
7151	payment	1726	1726	1874	1	1	1520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8U8aU1jmrqnFPL53x7Q3mcAHdGZwwA1QpegAe4ByvT1LUDLs
7156	payment	1726	1726	1874	1	1	1525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjjdvZPk7TTBSN2df8o9ibwVjR9dxo7W5FGj2pMXDbucGMhfZ
7162	payment	1726	1726	1874	1	1	1531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5D9SSAc5NcmwtMNe7aex3evB786AoyhMq5arquyn1dGLJi3Vf
7163	payment	1726	1726	1874	1	1	1532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXUgtGsRCkTwxxu7XqoReoTfN7VuLyx3Xq63pWrz4ksiS7rE3v
7168	payment	1726	1726	1874	1	1	1536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkBQYNkdA2y32NeQXxsSkiAVY9kHpqPs9o9WUyPPxD6EQ3iFw
7169	delegation	1934	1934	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhxAPXcBmHeG3tVwXbopBnpaKVUrojQW9mZLwGHB53GhN2VqF
7186	payment	1726	1726	1874	1	1	1548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbykyksRPDNwkCzK2dGJqQscfvyoLSipAYJ2Gfi1zsvD6L1Cki
7187	payment	1726	1726	1874	1	1	1549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhFtos2VkXnPD5DU3fsa6DuHob5YCGowdkG9yMgapukXg7jhm
7188	delegation	1941	1941	1511	1	1	1	\N	5000000	\N	E4YPVcbhyETPHgogydmHHpQxFbyYTUQeLwUtHHBC8KraCXrR3kZAQ	CkpZvVKNYytxznCGSk6SGQWnNzzhdnjVSs8P4XYh5iXgYSEikr2dY
7191	payment	1726	1726	1874	1	1	1552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAejZcJ58KXNvL8YKFvg4NHHvwRG21NujyNHDqC4zt9tHaJtN
7192	payment	1726	1726	1874	1	1	1553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkGPZRV65SQ3ams9hTZqgQi7MNWCxZinW8Bcxw37ZH2HGRB91S
7201	payment	1592	1592	592	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBk6tN68h4bcKQqsPy3oNnd3usotUvBWyNyAoCHMkNHKYSMosY
7205	payment	1726	1726	1874	1	1	1564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFXmpRr6YHQwj9Nidr9Ytexg1jkPZ7TrvwSghtTrgH1XBrLKv
7206	payment	1726	1726	1874	1	1	1565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3Z75QLxjsKxghyvhmS2P2yN9NKdcZKCeVa529MchJw4eCUta
7211	payment	1726	1726	1874	1	1	1570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnQgX6kD92tTNL3HdNjA9uQnN5QEmg9KitV3AMXUu1iXPDuwV
7221	payment	1726	1726	1874	1	1	1580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr76VP5CN7UTTP46ow2KgCpUipVxC3SvuS8rsi1pBQF5YLMGq6
7229	payment	1726	1726	1874	1	1	1587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqE96tdHPP3UVP7e8ScTSqEKYhchKDqG43ycJqwewEj1yWzxH
7231	payment	1726	1726	1874	1	1	1589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkxT4kiuwTRBZ4nq84C3r5GffNQhYEcQFJvGeMQRjs6qhX6Vz
7232	payment	1543	1543	695	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbfzA1x35WjjsisbpckdBPiPySv5xvNJTQYspCD1n4krFFtZm
7233	payment	1726	1726	1874	1	1	1590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6AJouH8kGqJwBASJU5ZuUZ3Bw4gL86C5i8oAjTYE8UTgjYww
7234	payment	1726	1726	1874	1	1	1591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9PhV2xWc7hL6hekHPfNKGxV8K54rt77a42u3HQXA68VcR1Ld
7237	payment	1726	1726	1874	1	1	1594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBfc2Nw4To6azKGRsHVry5bRoDCCo9EVexDr7qRBPqGdCkLX5
7238	payment	1726	1726	1874	1	1	1595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nZEtiuavunGCoGMCRTEzBMpfJcVSVmyJCTjvVh9E8CzLBjHj
7085	payment	1726	1726	1874	1	1	1466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWNCaer8bD4iRMyMCcoKU3mH8BipT2ZpCbpq9wCbFeKfex2RE
7086	payment	1726	1726	1874	1	1	1467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocLVD86eMQvgDdzP6NmeSTn4Jqk11NYHgrNWQurgviftGpbms
7087	payment	1521	1521	1931	1	1	4	2874477000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkomsYtcy2sprSD9SFkMmygk39sBmyx5Hc8Ar4HSxdadwEV4vS
7090	delegation	262	262	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoi1HrxUm22TGPBRcr6HJSct5XXzJjQxMc3HQHfQF9CdjgijoN
7092	payment	1726	1726	1874	1	1	1471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdtd9vSdurTj7SAGcWVpcvDqwUEFBtZKC8VszFEidWtXACarW
7096	payment	1726	1726	342	1	1	1474	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYoFQHqBbdzbGRkH446EJczwCXnVe6sdbKaSyN6HHKqQx8tJE7p
7097	payment	1726	1726	1874	1	1	1475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqhf7FA1gLcPnhq74oXddj8C68qxxLQdV47SZyrk9DXbPfwnh
7098	payment	1521	1521	166	1	1	5	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHEtELGy8TKTXpufB74NRu7CugYELwuoLVxH5T6HaWRCyQ4Lp
7100	payment	1726	1726	1874	1	1	1477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEhXocpvBkzFYptUTyj49qAofKANxMTwhG5dikEe9oG5vXZTj
7101	payment	1726	1726	1874	1	1	1478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrQ8sC4DzUMw8oPGcu4Pk1Xgi99dgp66fP7dMdnzTzJsZsFKX
7102	payment	1541	1541	1718	1	1	3	7917200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeG3dLQc8KxjjCfdTFjwCvDyjNMgYW4uEps7SH96mEPGLh19Ss
7104	delegation	342	342	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMMUokE44FoRAW9dceNgHrPz8yHXtPiPx5TUTxaiypYQLjxGc
7105	payment	1726	1726	1874	1	1	1480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1SNit3abVhzJWKTZiFgJgqNLNhEYksx5Gb8JGoHTWfGGnuUy
7106	payment	1726	1726	1874	1	1	1481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpL7DfJZG6dqyjEaMNrhFruX2f77iAZRNGx7utQiGhMqK5XEvz
7107	payment	1726	1726	1874	1	1	1482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kN5XY6x2v97uwgWjAgcXxwcxJGYEghkmADihwh3PW5q7ESYY
7108	delegation	1718	1718	1541	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhhYFscRbpqUX2JyR2snLmxDHnH64XbcyDgZ5jjDgaSAyQE3g
7111	payment	1726	1726	1874	1	1	1484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5RRfaGFHW3QfocbCCQV43U9XWUkBSAp5ziu47avbiDSJpdbH
7112	payment	1726	1726	1874	1	1	1485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASaQvdrRFVrT6nbrzmTXFW3kSqG6WgdHMqLx731TbS1U7FByN
7115	payment	1726	1726	1874	1	1	1488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtBYbrzrmpXHjNYcdWSGSkEGky9tVNfYA9cpJPWW6zwUgRB24
7120	payment	1726	1726	1874	1	1	1493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcc4FrTbCXBU16hvLjjGA7Bv9vWo5Wto7W4cw4ff8kF8xCBMV2
7124	payment	1726	1726	1874	1	1	1497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSn8xkSEWgHipbXnuFbzZuZ42BR8gxtenzewgUYbdBbLG2H1g
7125	payment	1726	1726	1874	1	1	1498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1P2rKs5GFGzXr8yE1tNSwhdUTyWWcPUvZuq6qrWSQyHcmFue
7134	payment	1726	1726	1874	1	1	1507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKrG3CYBPnf5XzkWctAZRZrBihWRCU2wGmBACcEutSam2nLeeo
7161	payment	1726	1726	1874	1	1	1530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaM63QTFiGCS4SgK8ZuUA9NmKvMyKfHzp9r2AKWDS3FDytcJ6h
7167	payment	1726	1726	1874	1	1	1535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsK16jrLYuLaTXyXTB6Nf5PABtgPMbEf8zJpY37sBypiwYdkZU
7183	payment	1726	1726	1874	1	1	1546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9fLhrKEypfkvzv4YEzKaQgNJXyhHb4nsPo2FiPTALypwdPVt
7184	payment	904	904	1941	1	1	0	10000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwtQHsGwo6KD7wzK1SPyVkQUZHzbYQuhT9tjDexvRKFToVqLK
7185	payment	1726	1726	1874	1	1	1547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybd5f9vgevhjbKFeR9oiQML9KaW2Uq64oszL9E2tnk9nRqGin
7190	payment	1726	1726	1874	1	1	1551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpAHHiE4skkf78MZ5NoQtwbbNtYamuANXwMybCp1CVLhEiNEn
7196	payment	1726	1726	1874	1	1	1557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDXcj2sBtvUzS6dhWggH69srNRXmEKY67dSYs6HA2AGW577H3
7207	payment	1726	1726	1874	1	1	1566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAvVWkgqg6g2qfEvut9gBpeW6Zk6QPWdF8TdhZtrrnejWXFen
7209	payment	1726	1726	1874	1	1	1568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5oAGQETfAhvU81YGAHEUEicgmPDsqU8ifREkP6eiRq9AYoRy9
7210	payment	1726	1726	1874	1	1	1569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7txTMnhWVMBdJ22DWKmHtZcCmTK4Wg3uJBGUMBNmSDszHFEPk
7220	payment	1726	1726	1874	1	1	1579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxhm5uYVuhC1SomYFnLRkG5TJdtTUJHFwiV15NkhTYGGJsQfc
7230	payment	1726	1726	1874	1	1	1588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWfrBUzPB8AVY2Ynp3q5GzTSAPSqTgsbjBcRbFVUCQQuWXfoL
7235	payment	1726	1726	1874	1	1	1592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgK3SY1R5V8odvz6izvYiRyA7jEiAa6DYv7bvRoDoH2A7gaFdw
7236	payment	1726	1726	1874	1	1	1593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwp3g52prUu4n8CdTcfBatvkBMksi2vrtVZhkHYQuEQmgcz4p4
7239	payment	1726	1726	1874	1	1	1596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rvbLwS4kX6PnG1EfimJHHoAzsPAimZ8JEKWRoJWmpdskaB1Y
7136	payment	1726	1726	1874	1	1	1509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWuGRfhC41DTTQZo66iysrh235ihaDMEVfUmWsZurKU1KwEmEr
7137	payment	1726	1726	1874	1	1	1510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gFAXNrbLEiADp8Qj2KQqQiF95xz9nk8cSuLykENVdLfUR5y4
7138	payment	1449	1449	1939	1	1	0	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MrJj26gSqps5wEuWELAdjmEPbxiMg8AryEjqhJRXN5ZDLVhs
7142	payment	1726	1726	1874	1	1	1513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrar6aiMQhLTBRRKJKp7w8CfY35PQrt2qQ1HckKdwtgH1rkswd
7143	payment	1726	1726	1874	1	1	1514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6GobFqw6rRqijj2iyRMdph3vZCH2iFraikozRb4ZXjeFNGgG
7144	payment	1726	1726	1874	1	1	1515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkw9VhP9GR4TyN2h6QUzSEnuf9W2iLWJF84R6fYYARfZnKhzTH
7145	payment	1936	1936	1940	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUokNGfLuHJomFf4bE44RemQ8Ej2ZGZtdzoFSvHLSTdy9XNbV3
7148	payment	1726	1726	1874	1	1	1518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9sBkN9u75j4uEH3FBiddinpTJta5HmVTjEWF8rwyqJoAGTDq
7149	payment	1769	1769	667	1	1	21	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH76BJJHiwYVJQauAVTLWB8z8yGpwrCBfiwHgkjHVGGHMdL6bb
7152	payment	1726	1726	1874	1	1	1521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotgGevj9Uj6XS5VrawWUet1Y8kxsvQuL3pfSdnL8ktu9dtKpL
7153	payment	1726	1726	1874	1	1	1522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmpohzvn3dW1EnKrZhRWEp5DoyMd6WGhxjfpf4a3M4qcwAPZx
7157	payment	1726	1726	1874	1	1	1526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFmxyEZDe2EBRYneHPqq3BU2FBv7afxnuK8YjwFPGEUCyFyDM
7158	payment	1726	1726	1874	1	1	1527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEDKiHCVPYRA27JhV1RUAgLN2enhK8B8GDGx27EC96D4ZPCqh
7165	payment	1726	1726	1874	1	1	1534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhjc9qCzAyzJDXo1rWX8i3AxBC6B7AwqKHGUC7T9DmyzpLQh1
7166	payment	1511	1511	1941	1	1	0	1500000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZyH57z81ZwiScHDSUUjdVy1tUJqokMr77xZ7fMynCJaQWvGck5
7170	delegation	1934	1934	1483	1	1	1	\N	199000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtESZ23r6HU6FCEwEMpoAzTMrR2kmM34QbaiMja3G3hzR9uvS
7171	payment	1941	1941	903	1	1	0	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaMggkKaALENJ8661DjjyEhEjheZGTM4LjMwWHBRK9LFkDNSK
7172	payment	1726	1726	1874	1	1	1537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpRf9h8qcHuFvUoyQV1NQ5aKNXqPdmmJnYtbVaFP8wW8ojAuh
7173	payment	1726	1726	1874	1	1	1538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoTmMhBDU5B5v7eMry7N2UBktaBNV5ztqq1v3yirqpMnL9ybf
7176	payment	1726	1726	1874	1	1	1541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9iBemURxR7xQvhJCra7VkrCTixFvjm5rennUMRTDDmvRVWKn
7177	payment	1726	1726	1874	1	1	1542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzZocedz5AdPNgB3Up3qQcNfpozPs2Lab1xKzjxdXF9bh5MCQ
7178	payment	1726	1726	1874	1	1	1543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfYxefCCWbTZNheE1FzZChVbc6Nrf68H32yS4ZEJH4vFVqjoW
7179	payment	1511	1511	1941	1	1	1	718491000000	10000000	\N	E4YTNN4mUVeYRCxrgnNGZHr4zKUHVmr3um9WhFnq2Jnqrx8aGS1eu	CkpZqrtVQL6tfT2ePt8dLuwrsNrRN9KoZ5mPspzXfyoCJ8ud9AN8K
7180	payment	903	903	904	1	1	0	15000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaJo8eJq6bXmPJpwLUHupabzaWfcvorsSCyVX27MyzWtRfm7a
7189	payment	1726	1726	1874	1	1	1550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWLcTYZVFKg36Mpq4sJGCi3iCN7YMTiZvRn7qLDAh7JkUbN8K
7193	payment	1726	1726	1874	1	1	1554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLdqqxU9WYMbyXQjQQJ3pne9JWrXAP44bGBTbrebUSWuxXM3B
7197	payment	1726	1726	1874	1	1	1558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ocbCthUS5JpTmd8sBmgKPNBLJWjKEiMYdrHYnv16MQRb7Rrf
7198	payment	1726	1726	1942	1	1	1559	1200000000	100000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYU6qTGfJbc1qj7cgBuRfkXe2JmeuNQBNQUHzbQEpQiiLVZQt1n
7199	payment	1726	1726	1874	1	1	1560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oWpLAKJKjrKxAdPARuzFzbUa2DkQF2zm4gti17VnfwN8JiNB
7200	delegation	1943	1943	210	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZub62dyVxTuNCkkFxYTtgzDc6Aggi6hYdKJpFyAGm63GtvSm2C
7212	payment	1726	1726	1874	1	1	1571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrB4oF9jzQxhEoP3K6MhGvdrLeVnccNFCpTYiQ8gHezLw2rfL
7213	payment	1726	1726	1874	1	1	1572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMpKbCTgPjCAZBAdoDFdpWiXaqYyC34pE22F5ufYWhhPHRB3v
7214	payment	1726	1726	1874	1	1	1573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAyvkug2FCi1zh6EerdGhG8HCkKGnioU4YABB1TNXCNV9vPod
7215	payment	1726	1726	1874	1	1	1574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciE1Zqg8hmHihNbDvKbESq6KNSGoFFNFMbmaD7z5oCutetEzD
7216	payment	1726	1726	1874	1	1	1575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8pYLpXnKxshUaRUqN5bG4ZuLMfKVEXmieyoNndgDyMqhybb5
7217	payment	1726	1726	640	1	1	1576	10000000	10000000	\N	E4YnqzxPfCA6ZvEouR8TN9NBcjuc54Et9HFvRW61gj87vqYAb52ho	CkpZduoxNGC3h9iztdL9MWAfvW35u8V4yD9QoBzeh2kK4M3yHgM1F
7222	payment	1726	1726	1874	1	1	1581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ861fZevicNrC725FBT28beWQHrhYpFpp8duWSuY3us2RmiDT2
7223	payment	1726	1726	1945	1	1	1582	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZuakewn2Ljta4edMLJpLSpXWBEy9pDp74sCCvef1bUtB6Uqvoj
7224	payment	1726	1726	1874	1	1	1583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYDVhSAmubYmDofGjyW2rbvYvkd7J4JSt27pHCzLjJ9knXPwG
7227	payment	1726	1726	1874	1	1	1585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EhcfyvbFzxreK3aZ3GphQFDc2hp8La6dMFfYPuNtF4fPJZ2H
7228	payment	1726	1726	1874	1	1	1586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKD7iA6JhJumw5HXQGvVTpKSzGKWVFMjS882RpVzcd8oHHSrgo
7241	payment	1726	1726	1874	1	1	1598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQapnB4vvrbutmnWRzQg9D2UGMPwez2m3ARZH5YmFREd5n2ADE
7242	payment	1726	1726	1874	1	1	1599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8c4eYYPBMwZxSK3j6EgB3yqAyRVwMCjTiTnzFGwDcJQQeBCX
7246	payment	1726	1726	1874	1	1	1603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLaDFBurCsYmr2LGFmjcNS5DZuADw4N3GpL9P1WHxwuMQ69iB
7248	payment	1726	1726	1874	1	1	1605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDzAMCRfS2YQ1pHqcZ39n2Lf4eNjQrym1LoU5G3ucMjRi8eBJ
7249	payment	1726	1726	1874	1	1	1606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxnrZga9tZkve36s6gjX9DFojDsSRtkp2uGG9J96KpKGxgZRH
7250	payment	1726	1726	1874	1	1	1607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHVcFRxU8dv4x7QFCm41TSb2V3uycnWiUb4K2Eiv9N2iZ1zvb
7263	payment	1726	1726	1874	1	1	1619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeyFjzvYnZRmTGvTiWYgZbZ8u2U82kxNChsbBu1zqRtS2pTJj
7264	payment	1726	1726	1874	1	1	1620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZscibkiLd9T2VYfTanX6k9qKae5CDREVD9JCijTaBztKNFjDDq
7265	payment	1726	1726	1874	1	1	1621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS6jEnegQPDGtP3Cs9dckiWDfEiG9TMZLhps7CMNZcRTSbMpN
7266	payment	1726	1726	1874	1	1	1622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwmVMbYk3CuByi138kiDkb1XwU7b4XJsUSEDDHYtapFmN55iH
7269	payment	1726	1726	1874	1	1	1625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaz6DMh2o4yB4R9Mjmxe39xAQJU9732j9BXr6T6rTW2rdfDhBk
7270	payment	1726	1726	1874	1	1	1626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD87bomgQFJhMgah7hKMTHb8eeSSXeU4sPA7p5Qvn4W6UbGY23
7279	payment	1726	1726	1874	1	1	1635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyJAG7dLMkYvoJDpo4eG56q4EnH5wgZ3hkhdx2A1UrBEh6x3S
7282	payment	1726	1726	1874	1	1	1638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5hm9HYpDdh2oMdFmccZz9YKaxqYXjX1kcgdhm8gJynd2vHgm
7294	payment	1726	1726	1874	1	1	1650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaMZ5HfTsCojx51rY8U7V3gfWwaYmTirUyyxRd2aKzNPNbok1
7295	payment	1726	1726	1874	1	1	1651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCyMixaupuSzc7gciWx9MRqL8SyXSs5ob4oYADCFtjYjW5mug
7298	payment	1726	1726	1874	1	1	1654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSTS4VjGqKiYwjkBCSjqN7ajxVR3MYfxMYRJCC3GjyD1dvqZS
7302	payment	1726	1726	1874	1	1	1658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBuFR1qPpCNniCNP3kgiXBh3HMJMj8Y3RxmejnzG1j9RkUyup
7306	payment	1726	1726	1874	1	1	1662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUo5KWwXSHoU4UKsptWec4odxQ3Ybxv9oXGJY8aKyArNrHkk1
7307	payment	1726	1726	1874	1	1	1663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TvKiQCCBrcAuPQEN5VQc9haV9e1P4oS5hgQAM6sAVv2vSNRs
7308	payment	1480	1480	1946	1	1	8	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Z39J7oXgusamPW93YyBEYE34RFAc9XiuzVALJ5cys3sdmfg7
7334	payment	1726	1726	1874	1	1	1679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzraAGqsNB5t5HDcgFWKzShR9L3MK9KE2dHbhGV1pyTqaR6pM
7337	payment	1726	1726	1874	1	1	1682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHL2eSaMLJLQvQRrRG8zba9GPhCaAuKkFspG5tXixS4eQZd7Mx
7338	payment	1726	1726	1874	1	1	1683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1n7uth1eH7ikgn3epu5mAiHPPq5M95jmewxvXqYGKjthzxRp
7341	payment	1726	1726	1874	1	1	1686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHtZTSeRhkdSomCLZ5tkJ7TYzk3Bi6BHtKusm8KkLpKNwmGUH
7351	payment	1726	1726	1874	1	1	1695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJD4c29aSbYpuznGVDrbF5nbEWoXzBh8UciEUJYgmBiquKXvb
7368	payment	1756	1756	1516	1	1	1	16883489191100	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv1dHb1Zy4cWLYuYY7THTYzEJNzBu1yuVQPTowK3VEevQwkhKD
7369	payment	1726	1726	1874	1	1	1712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52kLQXw5ogNNgTu4K8mmeKbd4WaJndn9s9UEoS2F7rvnxBUtq
7375	payment	1726	1726	1874	1	1	1718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3q1gLipeEFLMiLB4tJDXtRZ6AC3x1PFWXKNtgj4h77djDXQz
7376	payment	1726	1726	1874	1	1	1719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLyiAUcCJM9Av77RNgkYvGfvZfva5h9kg9GWEVEZDjy9ENspj
7377	payment	1726	1726	1874	1	1	1720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wGtNrr3nWcKLSAMBJFZrejA8TZHB9aS7m3D6FPpJNTVXQRet
7378	payment	238	238	441	1	1	1	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebs4dabfnQc6PsXB1pY6mu5TCKNsjC282d2x146J6QgjTdAbY
7394	payment	1397	1397	1678	1	1	4740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdhx49QfF9gCzts5R3WqL8gARhyyaGHeFqRJvAWJCGndbVy3a
7395	payment	1397	1397	1678	1	1	4741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJzBc9wwWvMCcXKnKrPw78hVHeh21Gmh2NNQPsaSuzr8MhFMe
7399	payment	1397	1397	1678	1	1	4745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDX8AJMmEfcncVg2HgqaFC1VMyEhHMwFeNKX4Kme7sye3hbtNG
7243	payment	1726	1726	1874	1	1	1600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9Cx15VeTKJRvs8BNuKXB4Y3hF26Q3fnxUF5WN23GsCeKy5yR
7247	payment	1726	1726	1874	1	1	1604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGctZ3dceEoTFbKd3DUKX22Ph7YJZitRkDu4tQqERKsCeCenf
7251	payment	1726	1726	1874	1	1	1608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw932nY6ByVrRVfQLBLzwmRtQT9mHjiv9De121511twPEKjSHT
7252	payment	1726	1726	1874	1	1	1609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaUF9ZDnGEaZRgDHxu9boHbUcP7tr2dS6n93r697y6B4PZr3b
7253	payment	1449	1449	1939	1	1	1	700000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLX85oiuQ9h6eaNuFBzn4AcTg2U6Zz1iD5MDDHQg4quaXVym8
7254	payment	1726	1726	1874	1	1	1610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVq3Scv1bGLZuzyvXgi1omvy2qJ9FFng22Z1smH2mfm7ENGDtK
7255	payment	1726	1726	1874	1	1	1611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPCSvRyEfusKC67XGmvKgjjfLm5TqD849nqAAzWUZQShnjvZB
7260	payment	1726	1726	1874	1	1	1616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaSzBVEz7HxsK83sK4hGf5v4hL9eGk8c1Js9BDi8woioBTZ37
7261	payment	1726	1726	1874	1	1	1617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftGkMn5wPNuUAgrju34XhAMtB6dRzzSyX2zUM3qkdrpq8DTqn
7277	payment	1726	1726	1874	1	1	1633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6fgSmQp32oTYKKVBcbdsqPDoi1Y6QYt113jNf57Lqz4KGr48
7280	payment	1726	1726	1874	1	1	1636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cVZAwvPhRS6gkyEKJHUdivX2fF7d4NtoGxwmRCjAB44mBdjM
7281	payment	1726	1726	1874	1	1	1637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDwqqCuK1iL2nQi4yg3vnbMUSAvCBMwQ1hePB9wbedoGYQnqr
7283	payment	1726	1726	1874	1	1	1639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDRh4WT3iAaExweSZsB62y27kkTA81kdeyoifDbLcK77cLAae
7284	payment	1726	1726	1874	1	1	1640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrpgMm6Q1uYs23WPfJhvacthop1CZfGmA8UEtGCpLCJ1EHqLiY
7291	payment	1726	1726	1874	1	1	1647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2bLKQ1F6ymAMGPp9vNWJBf4g2GBzAQ48bUsrBrE6aDUon7Ykq
7292	payment	1726	1726	1874	1	1	1648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5eztBxwRUQDCEeAjf3Z8d9gkgc6ytmQDCduhRMKvB6hcTVxj
7293	payment	1726	1726	1874	1	1	1649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGPhkuzUNAUdvdVsBjmQPkEN5sTePahSaSqHZHHsfHf1jwGzb
7296	payment	1726	1726	1874	1	1	1652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcizARLRzddxHU2NC54zmNBkWo9GmrqjwJHJvtvD6P1BcfcHd5
7309	payment	1726	1726	1874	1	1	1664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbr43776mjFymMwwmTtExTUatN5cNKDN7aSHUdKBCgtYMmqgj1
7310	payment	1726	1726	1874	1	1	1665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwdFh3o6mHDmzHbrmmsrFtARLS3veK99ZufCZVdN3sRpXhdcV
7335	payment	1726	1726	1874	1	1	1680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCxbKifBDsTjMaavzPtwyXHAPiYhFzkRYKdzoePEuWPYrrELW
7342	payment	1726	1726	1874	1	1	1687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLHwnT6Zgzw6zvYmJvCivr38SrPcdWttMdcxfHZkvTU1gaJwy
7345	payment	1726	1726	1874	1	1	1690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKGmBNkxDjnMp4gPy9C1tnu6JU1ieNMERak9qLsXRwGkaat9t
7346	payment	1726	1726	1874	1	1	1691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGr81jLZfrBAeeghW2HZYegBGZa9cU47hEfFBCG7Sbae2Gb51j
7352	payment	1726	1726	1874	1	1	1696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUokaoLpPCfD5ELcLKV3R6Hhy8YWCvm2FAnmqYYgghv7AN91hT
7355	payment	1726	1726	1874	1	1	1699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTx5FBZMrkkXDaiFAwPTXrevaAYQ5P6WXisPsVndVupdCn6fzp
7356	payment	1726	1726	1874	1	1	1700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Xvgoskt1bf6VYNSCH9HnXaAqpcY7pquED25CETjDcFx5uFwQ
7357	payment	1726	1726	1874	1	1	1701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBFcsTsHVgAVLdKJmmWdRKzgC8wRt3gQcsT2MUYinsZ7cDb2X
7358	payment	1726	1726	1874	1	1	1702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQMKAD5m2G3uGFq3vn67DJjBz9TtFq6noscyZ8Txj1j2T5TED
7359	payment	1726	1726	1874	1	1	1703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgA8SjVXtdf54FjwaQ1LcdpAtug2V1cVs71pB8PCXmBU3KgLJ7
7360	payment	1726	1726	1874	1	1	1704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx9S538nXNVYUcVmPMToNGFAugsQjL8vqynYwgsaRZBH7tg8E
7367	payment	1726	1726	1874	1	1	1711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHs3AfASD9Jxuyusfn9C8Sjcrw6Po4cxBtREvgioMLVF2X3VM
7372	payment	1726	1726	1874	1	1	1715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5prYkRHT1xR7exMFepfDWz1XMp7tu5DzLp4rS6HhUiZgzmF77
7373	payment	1726	1726	1874	1	1	1716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyMhAn6xJNctcR4HtMS1g34zXBenubmg1rFuk8scqkRZTC2cV
7381	payment	1726	1726	1874	1	1	1723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaxzziFJRcwSBzNiVurCaSWiWSaqCuuDc439ZGzndvFSc9QKV
7382	payment	1726	1726	1874	1	1	1724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeBzo8zEoWt9sHwZ7h96AZ6R2tf6sPpEth3SM6mZ39oYK5ZwP
7385	payment	1397	1397	1678	1	1	4732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBRr2CFQd5KkMiKB9YJaMSb6mbcrQk6dtzPtRoNGWCSAc6RVP
7386	payment	1397	1397	1678	1	1	4733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mhyVQ46yAkdF3yPfpSgag1NJe3Lk5Axaoar4dsUa8pUUyZT6
7245	payment	1726	1726	1874	1	1	1602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGp8uA7LNdP7Q57TTTrtQvNWpKJTNk7ywSsTxstfWiJA6y4mMG
7258	payment	1726	1726	1874	1	1	1614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnRPxmaar2CFHz4R6xn2YBF1C9M3kaCca9SLi3oeBFzNXpVHS
7259	payment	1726	1726	1874	1	1	1615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZWESWYwkxXxae81CXT5QZF7drhZfnAVVxBJaCDv67w7MnPgv
7262	payment	1726	1726	1874	1	1	1618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZLz3JwevaDCkeKgmHJmRHTHhn4dFuYqVqp4GBAEvwNBSQbCy
7267	payment	1726	1726	1874	1	1	1623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDFzDxgaPswxwZquXGJBsZ9hC8JPWmFJngGK9VjMNm7hgeZ4R
7271	payment	1726	1726	1874	1	1	1627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabcEQzw1kC5q5QN842fea378gRtF6a9QFqYYg3DrHuxeTJQaH
7274	payment	1726	1726	1874	1	1	1630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mAxhL1SEAwadu15m3jxQTirCcNJzKwZXJMuDwSJoUiEKHf2s
7275	payment	1726	1726	1874	1	1	1631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYY87PyPQbSMu5axiooLwdiNxLXREwFhjxobFgbDYNrrNJH1Y
7278	payment	1726	1726	1874	1	1	1634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5258nFcg3c8ek8dtbRyGkDyQc2Y7Jg29WPhKzQLBw4VRGhNq3
7285	payment	1726	1726	1874	1	1	1641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5XxjEvY2sBYR721z9uboNXTTZfzTRGHzyYgsTov4yYoAz2cL
7286	payment	1726	1726	1874	1	1	1642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijvKHNgsFCrSQgPMz6DfKNL43VLY38vPcRLGrAKUSWx6UY6V6
7287	payment	1726	1726	1874	1	1	1643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywaXJw8aXXx5nXb1Mu6gTX2L2c2NN5sTVY4YchziNbEZqMjdZ
7289	payment	1726	1726	1874	1	1	1645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJz74ZqcC9JMyLsMav1wknx7RUh9oMDGshwcHpQUF2HFdQj9gL
7290	payment	1726	1726	1874	1	1	1646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnsAFgNTLCNaWcs5tZ3WK2yG9LYmostDzp5FU3QmHSy188mdTJ
7299	payment	1726	1726	1874	1	1	1655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RVpgkVytaqGKXn1YM4kXPXED9ZGsNJDitGsii6akYCRMeRdB
7303	payment	1726	1726	1874	1	1	1659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2UcEh9QHf3F8egg6G8xVUgoqLdQL1YxQJcUKhPLzqHHTSnDE
7311	payment	1726	1726	1874	1	1	1666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQ5dbAg5L19vSV9msX2XVZFFFn4JdciNonR6ovgu5bxzrxDM9
7312	payment	1726	1726	1874	1	1	1667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLHxyEi1yhqbaiBAfCwtEnN4fmLdEcvxSB5NFfLPJgB6kGPxX
7313	payment	1726	1726	1874	1	1	1668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpXZHSz5rMF45g6SR2jzovRHMspG62zbCbgu69QcG3fz69PJq
7314	payment	1726	1726	1874	1	1	1669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQN9pDb1xHMxn9wtcsTso9A7dWC3NHtNdJbELo7NCNW4JqtbtG
7315	payment	1726	1726	1874	1	1	1670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpu5kjTPFKhg3mXNeZSVzF3Df9AHKKvL7FwaieToPiXTWDf3X
7316	payment	1726	1726	1874	1	1	1671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRnm7wsFgsrfxYnojvuDuPQqy9P7oTmq6XEr1D4aHmjqFXQYy
7317	payment	1726	1726	1874	1	1	1672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTjGWDKAU6E3E16AqHPPTCy7KwTyJab26JFkaCrjMLWPP3fbu
7318	payment	1726	1726	1874	1	1	1673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeGoEPpdbP7FQdQgef54rDkJHEDB47hUsPoy3P12J7iyxHjfP
7319	payment	1726	1726	1874	1	1	1674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsGULdHvQAoCemmuNnnPsWVDSaWA63m8mAFbJ4aMevaQMhbDE
7320	payment	1726	1726	1874	1	1	1675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvto68FonsyehuHhSdBh1hXKZkdWq9ZmXRUWH8wCpK2ZrUe8i
7321	payment	1480	1480	1904	1	1	9	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW83Cncw2s9RKkSHjEP1pmPinvbbsHBqXAdcxrdzPEkypqPRcB
7322	payment	1480	1480	1904	1	1	10	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CBKjtf8pqEDow8oTH4P2MaNuAkTVPCBQuctWGB5wDDQEy3zH
7323	payment	1480	1480	1908	1	1	11	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpAMbTxrYBNmaaqdPxCuxRA7KTAez1HF17Jwbw8cZtZiQ3zYt
7324	payment	1480	1480	1909	1	1	12	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8PZsaT91HPXL3wRQRvcGuW1JGhQxEQ9fQE7kn9HbPmmFjqktH
7325	payment	1480	1480	1910	1	1	13	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswxQBqCsjXnNjeyGS6wpExD58sVnYy9KLJ8GLRgJBCZ9UCkYH
7326	payment	1480	1480	1911	1	1	14	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb33Wgi7fCsuvP9XGDhxRD3396nhYxJ6omdCGbZzEzoT2UXrAa
7327	payment	1480	1480	1912	1	1	15	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT45m2tEh9np7tGsf96WgP5Hn2bm3LWK8K67p9nMoj9MCZ9rcx
7328	payment	1480	1480	1913	1	1	16	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYoaprSfuJ1ejBSGasXyeMLkdpaDcPmEkaog7B6164qQYMLcY
7329	payment	1480	1480	1917	1	1	17	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJdzvCr7ggm4fHnSEWbkBYrgXVTSGdXUsRFwRSo1HkpCMuCx2
7330	payment	1480	1480	1946	1	1	18	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gpfePyJH1rShtb7xtduRBBGFuG7eo3EddAWjCCNHJ4KuDUbh
7331	payment	1726	1726	1874	1	1	1676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeabUvt8AVjidWsiXhCQR9ogLo8iTAVofyFmUK5Tr2PWiSDsuF
7332	payment	1726	1726	1874	1	1	1677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZErV2U5ZdSD8DdH4uZ5FkeiBRHPvAssHjfG8gqEUqi6HzTZb
7297	payment	1726	1726	1874	1	1	1653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacAueyy7cdpcLr4WFTe7yYUUzyJ2KE9aZYc7FSS9AuEnekG4h
7300	payment	1726	1726	1874	1	1	1656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufCnaLnYwYGBHnLEcCQnt4LJHnPSs3aVLSAqFYUk3CRcU2JMb
7301	payment	1726	1726	1874	1	1	1657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i6gW62U1b5yndLXBT36oVSLTUmD6LM7GAQzNvSkx98C3RP9h
7304	payment	1726	1726	1874	1	1	1660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEhRH8vWxaGAYjxKbgbJsfBM8aWBhxHVnWJvPTm3UwtFH7vBQ
7305	payment	1726	1726	1874	1	1	1661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxDuSskXfbUZq3ArSXPgDNSEfyWc6R3HRcmYSdWcmPEt1xLN7
7336	payment	1726	1726	1874	1	1	1681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAJRDoB1VYB3dUE24D8hStEk4SR7npPrevmDMQTtJHuqHJufL
7339	payment	1726	1726	1874	1	1	1684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAs7YLBAk7PmhTBGXbJKhZAm1cx7ZKHtzjVHLFeehZpQ1CLybG
7340	payment	1726	1726	1874	1	1	1685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2T9zvGQ6RAvLscwbQjNKpx3JT5SGptgmmVKHgfLpztYnchi4n
7343	payment	1726	1726	1874	1	1	1688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDf5zFBaGgQoCtFQj4LWqbp6p359R6TA56UNkmYkMFiyJzkiq
7344	payment	1726	1726	1874	1	1	1689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VuwK2uhUP47HsFwuk7aGzYk1pctERAz4hqnpdaccU6JJ5RRG
7353	payment	1726	1726	1874	1	1	1697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BTeMuUdg6ywDTxNHFRns7XCnnYsdxvFhMJCgnkt1VL22k3eR
7354	payment	1726	1726	1874	1	1	1698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUhHbeaJTY2C9fTw7Nh7SgHhBz5zPDdYQxuKpHRe3N5naS6n1
7363	payment	1726	1726	1874	1	1	1707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYBNhYZurAEEAGCS7yih4ETbjSkhxPxYXQG4wKSPwcg6sLPyx
7364	payment	1726	1726	1874	1	1	1708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rABTGMvSf18wHGQapELeKPg4ewXwWcGBGDATXMnfbV2ne5Gm
7365	payment	1726	1726	1874	1	1	1709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZmV279kfN49aLaH6vhLa56ZqW6JPh5G3LceNqe4MW9KTg8JN
7366	payment	1726	1726	1874	1	1	1710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytpgaXaGL6Jzyt3PjoMWRjyiohe4DNTiz4ifgSDydbLA3MeTu
7379	payment	1726	1726	1874	1	1	1721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhpyMipk7Q2HhnHsP64MX9wr92HHmpnNwSaG1dhVHBidBuGUN
7380	payment	1726	1726	1874	1	1	1722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSr726ASRvoQHDzbg5op2bbjM71EaQmq8dVGADVSLH8oLmhRFA
7383	payment	1397	1397	1678	1	1	4730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ThWrpZVNr3f3CRCJeMmHzRqNxxHiMwFxHKHtMRdcLdQXYvkr
7384	payment	1397	1397	1678	1	1	4731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wHdRAvCoVw8YkpKhuKJDEEFkeXGzP1FJyNWnoaX5i2H8Wwbr
7387	payment	1397	1397	1678	1	1	4734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwWFjw7z2Ey4gHTdpihxE34ZntFfVmD2jCLNqivF6badPXJpK
7392	payment	1397	1397	1678	1	1	4738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mrQGNzpiyGbsYDBySXis6wZGDirijiDjoS2KHsKEFawoEBie
7397	payment	1397	1397	1678	1	1	4743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrARkr5snw7UvyKBfpV1yrGPaJKejLbcjKtYBvGYnfwrSBYB8
7412	payment	1397	1397	1678	1	1	4757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunyKiVhZF3G3ZS5zVfCEq2rQ61vbZVTELXESwgBFoVDNjQce7
7413	payment	1397	1397	1678	1	1	4758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufRRCFm3stpFah4ZRpi13FKan2deYyXWCXeYtPsNqAo6dkXPV
7426	payment	1726	1726	1874	1	1	1729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSfxp9Df3hYJxEA1ewRexvTGMfA1KTf3HGvLcUeGFKeeFvQFU
7427	payment	1397	1397	1678	1	1	4767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAXviUGxrSdZ9LmQJhUQfQifHanJiNX29vMPoTqVKWALEzLmq
7432	payment	1726	1726	1874	1	1	1732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvwxtCzSSNE2J2AVVHyZSkazcve88r1bFExYDcNvLrrD5jgxA
7433	payment	1397	1397	1678	1	1	4770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbTgaVfm7KGWJe5Q4WRqxrNTMkiu91W1osuyL4rQGyhLd2j4oV
7445	payment	1397	1397	1678	1	1	4776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVHMUjNsPaWDikKABKNSt6N7XDWspWbaQdGvjGdW4atZBoUqd
7446	payment	1726	1726	1874	1	1	1738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7SLELWaDruxNaBFx1175YQE18Sa6gFV1m7kfAchPmBVU7a5G
7449	payment	1397	1397	1678	1	1	4778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDsjUNVtxAoPMLQKEzQFE1757ttWsLmjHisqgYouYpKxdCYGV
7455	payment	1726	1726	1874	1	1	1743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjcWbasEKVMeWpLtLgat1777yo9T91xHZ2bHhETQZDqTxq6d7
7456	payment	1397	1397	1678	1	1	4781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhRLY7Hf4x3RWjNQedzNxkEzWJLM9J7yANWVco5aWcEr1Pui3
7457	payment	1726	1726	1874	1	1	1744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5pEkZcc6Wh8SC1o7rUqFxYEDeojpumfK9LELUY3btySnzskZ
7458	payment	1726	1726	1874	1	1	1745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3791D7h46h1HVdBqCiAP3rGnv2d83v6zGzR41KZuyR9DReTi
7459	payment	1397	1397	1678	1	1	4782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YTY7HXH67Yjj7piSCVFBSb2MyhGQ7seFLKgJaNYJ9RGsTFVz
7460	payment	1397	1397	1678	1	1	4783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAFzDmfqx8u11wHwVaczSY5dnzhqA5C4wvvVbwcmvXg6f3Lkq
7333	payment	1726	1726	1874	1	1	1678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5U1MuYKkdk8JuiGtAFp8W6qADXZZusbzCgS8dfy5qD8yZoEq
7347	payment	1726	1726	1874	1	1	1692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHVsvQfTnffNTUgc1JPR2yDejLEfBe7Lua1z66qfCyHHncgDF
7348	payment	1726	1726	1874	1	1	1693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9fse9u1EoLZMuc2DMQoacYmFV8ixqMQhGs892bBLogJzJLZf
7349	delegation	238	238	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xAvWA3xX3vRUcmPLjXKyEGTDmjqpv3ykBo93veeFFUpEQ2nK
7350	payment	1726	1726	1874	1	1	1694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPnH49PNkoHKGYf93mN23nGuKt7ep5FQXTBVWJAnYFMHcZJkx
7361	payment	1726	1726	1874	1	1	1705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRuqygLcM5voFnCBfdw9RQ3tCJhPrgcJNjEa1vZZp77G3fpCw
7362	payment	1726	1726	1874	1	1	1706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEo1hik7To3GguvcFHrQiUZztRhaAJxRF8AKUyhYve2kg5RH9
7370	payment	1726	1726	1874	1	1	1713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm72KmdE75AXCkDJpVSq9K2k7TxdvJXutWDDYADf8vYiXqd4uP
7371	payment	1726	1726	1874	1	1	1714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKe8VziD4xh429rHYwAphqwehkcnA1hGtJGY23WjfZ9dPDXzN
7374	payment	1726	1726	1874	1	1	1717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQeaksUTLP4YREq4RgtcTeqAALc2rzwewpc1phPJCxvMVibPs2
7388	payment	1397	1397	1678	1	1	4735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7g8v7WXhQnAj2n6MzeoC1jzSYR49t42LT8uM1DwXMYbPeYojH
7393	payment	1397	1397	1678	1	1	4739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLX6A5bswK8GXQBAB9Ly5Dcs29TnC4JKdYo6NWJzpq4fgqqmye
7396	payment	1397	1397	1678	1	1	4742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK4qBucNHv978r7HkEYiYmnq7qeZSK9BsEdyR8ygmDycjgoA3
7405	payment	1397	1397	1678	1	1	4750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMjru7XMKarna92gmsQhR93M3Zqc6ZJhjRvkcF4Z5cDeyt3qw
7406	payment	1397	1397	1678	1	1	4751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnHvCzd3cCmAEdB9HzfPK7MXy74WFEunpx559nLqHFqqeAiD3
7414	payment	1397	1397	1678	1	1	4759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnZwM4NeAD9yuy9Rr5xPXq1CAFY8E98uNjSEQd7PYsGd5eXRW
7424	payment	1397	1397	1678	1	1	4766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiY3eecdrHRUxGtRXHSDgbSBviDKuc7UonvEAW2TP5XfCBPy3
7425	payment	1726	1726	1874	1	1	1728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8XJXWMNDnXm9cCuuSwF73C8BKghV27nSvtXpfUBTmv43LQuo
7438	payment	1684	1684	208	1	1	0	10000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpYUWVD9q743JsjXFfEvDeUhnbjpTxLScdCKHCcP1fp1SsEu7M8n
7439	payment	1726	1726	1874	1	1	1735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79N4eZMAXhDCREtWwdEPJjNRUjYJbLHVxJH1oGkPkx3EPCU8J
7440	payment	1726	1726	1874	1	1	1736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5F93npFb8bADYC9ScnKWaQiqFs4ZEeiN3f9FZRRKkaPZJuQ5
7441	payment	1726	1726	1874	1	1	1737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh88oR1JEGxpjKj9TWoRz5AC38WrMPPwscbtPuGt9rXW7gfKyK
7442	payment	1397	1397	1678	1	1	4773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiwD1XKrPrqFq5n5U9U7FRFpWCWbSpYe85zRK7ZdSLJ5RxwPP
7443	payment	1397	1397	1678	1	1	4774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTe75utBLbeaNkx9ggSK4BeLDnNrc5t8YatSxtLeioRpGMX9kp
7444	payment	1397	1397	1678	1	1	4775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aLXLr24xmUHfSsbCMJ9yC772PYKrazWCW51MW6MerGx7F2kU
7451	payment	1397	1397	1678	1	1	4779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczTJraPimQohGA7XGhWJEGRkcX3HFFhhgnV5F959YSynXYB2S
7452	payment	1726	1726	1874	1	1	1741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSMR7wM29Me32wnU55Qeqvpyhh2FAQWstooZdJY32omcCuxyk
7473	payment	1397	1397	1678	1	1	4790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBNcYSsmBBueyfAkvkuzX4mxS3LArcuqxW5KW98wy8YXaKxRx
7474	payment	1726	1726	1874	1	1	1752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDJ58rriaJdV1WWy6iX6tjpqUYdGW47jpHua3fETHvkTnZBwG
7481	payment	1726	1726	1874	1	1	1756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HTymmmAwJd9KMXvxpCUpQ8Rkh4rPHkRcoQ6t6Fc6ai3MmnYX
7482	payment	1397	1397	1678	1	1	4794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7JmBHJrZMJ2u2pXes1gUwRLeibft7cgEqtHhJrsgRDEcCCxX
7488	payment	1726	1726	1874	1	1	1759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAg78p23mDdSqxpgPYSqKo4irrgtamrt7quFYRAGyPuCmvL11D
7491	payment	1397	1397	1678	1	1	4799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUu1ks51iJ3MQPi9k3By659zg78qBXbuYvprjM9EtVwsxTaZJ3
7492	payment	1726	1726	1874	1	1	1761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAPhkyTX2QoJjwePuXHpk6FFgjFbKpPvEpsXwA4rapuq3iBnS
7499	payment	1397	1397	1678	1	1	4803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWM5Fvjaoy83j6xvextyyV4J5vk1XBkzztjKsUUmEvArh22Xs
7500	payment	1726	1726	1874	1	1	1765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAUfBrNSci7UVr9u31uWABju5u1tQLLi7o3c4MER4sGpah1RT
7503	payment	1397	1397	1678	1	1	4805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgnn26SiTSpDSn4cZ2tewfcRszUcAHT9TMaRerqyVV1isjpUK
7504	payment	1397	1397	1678	1	1	4806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKmBLWv3g1jexUUtG8xtrudn6oL521VwwXsn5aMkYmq8bDBYv
7389	payment	1397	1397	1678	1	1	4736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYUmy6LwYbqZykeNsHYSNCmTy1w4fEMwRWA6BJxfU6Jcxye9L
7390	delegation	441	441	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzFMRSdZkRecFt4RScoXj5H9hpbtDcVpH7Y6xVFxryjA4SY3o
7391	payment	1397	1397	1678	1	1	4737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfnNLg1h16ndATSYMwsqjZs4j9ppBisexMGMzDVUWmXAdbhtcm
7398	payment	1397	1397	1678	1	1	4744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFkXjRnqWvA3f7JqBEt5XcFwnSKU9q4AuFPXh1tbNwhGwwVsH
7428	payment	1726	1726	1874	1	1	1730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWNG2qUzEFQrDzSsfc5aMJmxKZcsh56CCiBbkevmrP2U7yUMU
7429	payment	1726	1726	1874	1	1	1731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPixCeC7E3GXY7M7kV3cTQaSegvqFhyMk5VYPi8f9PeyK6feJ
7430	payment	1397	1397	1678	1	1	4768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34VUUugD9jdz7AbiXMzH7HNRmvWdfNDndZxmY8oEu6moT87Pp
7431	payment	1397	1397	1678	1	1	4769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKud4V8bxuUsP2rFQ9uHjMTVMvt2KF4BtMKDkpkwP4UTHvs8AD
7434	payment	1726	1726	1874	1	1	1733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwkyiR69KrgoyDt77xpjm3yhRbUw7FWZrKigq5G9RLhgKAsqh
7435	payment	1726	1726	1874	1	1	1734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHHgfxGEfnnGYAyKYahqQdEvfzrscGG7PZy7KM5pLJBKATsc3
7436	payment	1397	1397	1678	1	1	4771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5VG8EzebpQqeerZUQeVnCFULrdDHo9ccrhxX1LJKNyxboenG
7437	payment	1397	1397	1678	1	1	4772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVX9CKc29R6Z9U9BSdGiZ493AZAqZGBTP6GE2j7HTfeo3gvChN
7453	payment	1726	1726	1874	1	1	1742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxDqceGbDam6upqgTBJwWNqP7MhG1B2vvxDQN9TvjwoeRdxTo
7454	payment	1397	1397	1678	1	1	4780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygs2BGPpKwpGhHPbRjLDa1AGZPUc4nkxbLKY1njr43uPQhy9s
7461	payment	1726	1726	1874	1	1	1746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPDfALQUhDPreRdHoVmfzmCmN2CoitTsq1CBx9xefaokLub4z
7462	payment	1397	1397	1678	1	1	4784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6Pg6mfNoZrD4uvmxk4YSkKXvLkLSwqyRRGfwggWLJW28oAwq
7469	payment	1726	1726	1874	1	1	1750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJWbN3f5Xgc2JfeWkumm2e4h832voCsTAs1tNA6ZGf8HKNhHH
7470	payment	1726	1726	1874	1	1	1751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjMTJp6McrvPppa3XX6GhqffLZYnWmfvN92JVE9mBt58pTxW5
7471	payment	1397	1397	1678	1	1	4788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAhZYpP5esHg6LL32LgpSLbBFfrKrXpyrUgmsEXY8MQcxDh4j
7472	payment	1397	1397	1678	1	1	4789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJuHhduEuMzJEocYr5N5WPXf6XhzVnXeCMhnG818nAnRVSio7m
7479	payment	1397	1397	1678	1	1	4793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMDp9HJRgWbpHq78pjd28XqDbRFTWUV2PP6kCvCWq9cf2BPXj
7480	payment	1726	1726	1874	1	1	1755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXif6cUpmtAwDPyDgjDzhxcNunjb7RTrLQrL69usvfzfgLqsKq
7485	payment	1726	1726	1874	1	1	1758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVxguyz2KTbqJsbhwiwncosRUZS59aA7WJ3wpY3SiAHT3fqEhW
7486	payment	1397	1397	1678	1	1	4796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MvNZNtDLgch4kAJbHRUxzDmghupp45MsupEGPEnqkiVbSbKK
7487	payment	1397	1397	1678	1	1	4797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsDXQNdM9VPBmG3qeyT14Ck9D8L5U54nQ9Foy8nMmawrB6NeN
7501	payment	1397	1397	1678	1	1	4804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTw8Trx6Pt6dzatnGfpwQavZjNue8eCkkDRNV3P5P7GdcmL2N8
7502	payment	1726	1726	1874	1	1	1766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs31PgBohE2QBzHEY6LXJw7i3tFT97Y2rB7BJhzgLE6zvqTN4W
7509	payment	1726	1726	1874	1	1	1770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCoSCiGAXUSqUCzSvpfQmE3b1rb6xG48tud8xqq7kQgguqkRM
7510	payment	1397	1397	1678	1	1	4808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVabZX8oroZgeXquaqtNCe8NVdEPviTM2F7zsnLc2jdcb2y1u
7511	payment	1726	1726	1874	1	1	1771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSv6NgVGPNB74W6cMEVnMYNz7WPNGuZEpuqS4CmnqoHjEZqMkB
7512	payment	1397	1397	1678	1	1	4809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9TyD1kZ97n7MtN5mHKWuyLFmBfUznWRB2RVihAho4ASma6X1
7535	payment	1397	1397	1678	1	1	4820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7ZNFW7AyAGkTj1CJrEMSLtqr97Z2fLiNxFgVbTA38sRdC6v3
7536	payment	1726	1726	1874	1	1	1784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKTYQkQYLVWrM8hegowDKTNeNUmr7FfovNLirb3RYYNs7gQ11
7537	payment	1726	1726	1874	1	1	1785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVMEXcLpCLDqJTXQYB7kuxPP8rAJz1WP8o4tDTRXAXZuq1cod9
7538	payment	1397	1397	1678	1	1	4821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fkAwsjoEmeqZ7aTGTDMpbhLiRP9P8XyLzVd4zosMvXY89bZi
7561	payment	1397	1397	1678	1	1	4832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFMwbFDokEjUBvX5i4nDG77HYToQ8MLaL3cpijv1GCk8fk4iB
7562	payment	1726	1726	1949	1	1	1797	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwty9cTrxyPEtP2X19E87bxmokE6BdAiAUhynu9QNzcUzu1eWM
7563	payment	1726	1726	1874	1	1	1798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpsxgxvBCuRpyLmqxY89wiARgfyYq9NDpBQx8YB2HLqJd9kgv
7400	payment	1397	1397	1678	1	1	4746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UqDdXN6KZXTM9EtVSCTj5CbayiXj5bchVbnsS1rbuLwHjLgx
7401	payment	1397	1397	1678	1	1	4747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxr5fe6osrdBN1ATVH88VXbu95rP4MpCigzmBqofoDwDLUbEmo
7402	payment	1397	1397	1678	1	1	4748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vukPH95UQwLLneKKX5XV1jf7vZZwxbNpGWvQf3GseKprjK1s
7403	payment	1397	1397	1678	1	1	4749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkACPoEc9fAgk9JYncugQuKtGXPeXkCqVmMStbie65Dh7aNDr
7404	delegation	640	640	640	1	1	0	\N	1000000	\N	E4YXQGZYfdmxVCYpSLbkpq24Qqsyyx2gooxhY3P4Z6Dr9XsYEKkdv	CkpZbVKPAxEwK9CkwvYxPVvJozGWrSodrFB357Rnh1w1HQxZQ8ke8
7407	payment	1397	1397	1678	1	1	4752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK149FuhV7b5LebpzzDL3GyevNsvhvduBco5XWMs24w68PVwSW
7408	payment	1397	1397	1678	1	1	4753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1w696njfiitKmAvrmkZv2B3g2gtJLBFFmajbDwQZYNMhsX46
7409	payment	1397	1397	1678	1	1	4754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4kaM2r9ay2SkffYSkWhRousgdPXtybVyyQWFnJDmiMm2MLfJ
7410	payment	1397	1397	1678	1	1	4755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBPhQJfs3y6CkvT95ZSuG9UiQ7F2y2Q3GknVYs5QQt2dWA1Gm
7411	payment	1397	1397	1678	1	1	4756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCqm8Uhe4xgWuXAm9sCeE1MVbgF5Et5oaKVScpiB6XxvUpLwwZ
7415	payment	1397	1397	1678	1	1	4760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFs49MK3DbPWwd6zjW9CbxMaPmk1xGgKrZWgs2KhAxrAdjRU6
7416	payment	1397	1397	1678	1	1	4761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ms2RTw1EixhboTGKvoQEdGDckrJ1v7dW3nbkQDceEMCy7SXJ
7417	payment	1397	1397	1678	1	1	4762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaD8R63FSQUuUTdGAH4YGtP94qrmPeWYyV8QvKwo8Uja1TUZM5
7418	payment	1397	1397	1678	1	1	4763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcpRz259EWc1dWrmMuYmFaspjYpRMZkRRzZE9EHoiFNntohhp
7419	payment	1397	1397	1678	1	1	4764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryfyerLHUk6XaVQsfb64Avj7qQCLLUKg78KtQi1vqqz86c4B3
7420	payment	1397	1397	1678	1	1	4765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dJNcP1RRoviAV3aqEg5z79ni8449vE8DAjSTuZfhkZoHwvw3
7421	payment	1726	1726	1874	1	1	1725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BeFjtqJeuHoT3Y1V7pfahrtPW6fLJaDKQZ36diRG6TT2MEVB
7422	payment	1726	1726	1947	1	1	1726	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2Fdn2Nn2ctTPxtAid9rgVC37YKk52FpatZd7CHQuAXKEJdSDj
7423	payment	1726	1726	1874	1	1	1727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLtZgQfYsBsvgruama7A6JDNGxAf7Le697n1JArAGQXk81g4u
7447	payment	1726	1726	1874	1	1	1739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmorsMp1umsjdWvHML2mUGuHbErSTxSerxrdPH6Ctsj21Q3bB
7448	payment	1397	1397	1678	1	1	4777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCK3Hrru5hBhrcSkv8W7Cm7ByN24fNVRjcumr1ineARwFjKL42
7450	payment	1726	1726	1874	1	1	1740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagcx82PLgPna95ztGBY3aU8iG4ofEHexHjUuYJDeHvXUQjAhU
7463	payment	1726	1726	1874	1	1	1747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkH9ZhnBZDtM6q9QGTMwHhSjKE9dX7rk8oH1yQ3nfUtSa1jjcp
7464	payment	1397	1397	1678	1	1	4785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dtEfrCDUww2KhFV3hs2XQybcAczTtvbmSTmyMfnfzC5HXZAD
7477	payment	1397	1397	1678	1	1	4792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRRvRLsUe3Y5ur7mePUGmv6NtqhyssER2WRjz9KmkL6rTKt3q
7478	payment	1726	1726	1874	1	1	1754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eQmrfbX2sKi1Uh7wkHBwgwSKipTAdv7uitDwBQ7meRR9ZXb2
7493	payment	1726	1726	1874	1	1	1762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQnD1zGdeDQsvG4pFP1f3eZTyti8nCcHhHYVpYfe9Rf8Vk7eQ
7494	payment	1397	1397	1678	1	1	4800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKn9VVQzhnzq9BZJtbATiaLadCjfHmTfiVtEMUSswwbmpjPSm
7495	payment	1726	1726	1874	1	1	1763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzja34EjFDn2EJv83i7z8kdbvC5fGLXv5VXhQj1HTeKga5JSSC
7496	payment	1397	1397	1678	1	1	4801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTxSh8wYz5nBn38Mpzvtg6H1YEufxTxAfeL7SKjqdT9BhACkX
7517	payment	1726	1726	1874	1	1	1774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXbsFwxXY8Ha5xJz2JChPBFP24qHSsTb4yCvaDwkzKWRyGTYq
7518	payment	1726	1726	1948	1	1	1775	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgqqctrafeLL1CC9RK3T1sRrxEmuxbbvmNyyGkwr3f73Cw8v9H
7519	payment	1397	1397	1678	1	1	4812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpAQvdHojPkdaGkXwGgvYc7o7V2UkjNos4bWBoZMh1BVb9biNT
7520	payment	1726	1726	1949	1	1	1776	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa6DVtV8hHKLctQi9RnMh5sb1i6EJjXRgeLUmFRdp2A1GmDKZG1
7521	payment	1397	1397	1678	1	1	4813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgLastcD4EFLE9s4VpKnacAsLoMry5cPmmg6jmrK6fLZ4XwRL
7522	payment	1726	1726	1874	1	1	1777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciJA3R4D7ibRdsh5EepDFACVn9msSsgikw2gM5ttaS96e6jrC
7552	payment	1397	1397	1678	1	1	4828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLPQ6Pi5R9zJcL2qaBsVdwDKZ7Lf1jPHsCnrmMN69E11Qetpn
7553	payment	1397	1397	1678	1	1	4829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCAdRzNDa78U5pQaXWMKjb5m4thHoufSHMzFETdDpoF8ZBxEy
7465	payment	1397	1397	1678	1	1	4786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86ZQjdaLnsxpSCt5fdVrvSgPK8VYsuaTW87s3XDf56fFzfDXk
7466	payment	1397	1397	1678	1	1	4787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUA1EJyTtCUtoZCqxVGBDKtJSwcL6yecwuX9vMuRUatA3ajzCY
7467	payment	1726	1726	1874	1	1	1748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpX5jqdhe9g9qjCcxvv9eLetvsm4ouEyhPWtoSEZgWWagqeRZ
7468	payment	1726	1726	1874	1	1	1749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoja5227TXruzBswnygro7ZE4RqqiB2mdHwJhC3TJjAP3x3uhk
7475	payment	1397	1397	1678	1	1	4791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFxsV38LEiEpZ97heeBtoNb2nveF7AYUdBm5JcKiCE7v3NVsT
7476	payment	1726	1726	1874	1	1	1753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAz269r7kZkjeyrSk16vkJwxy9Vs3f1DF9BZiRgSH1sWRqy2VH
7483	payment	1726	1726	1874	1	1	1757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavaGa9pQ92uXFVeMQaqFjDFk86eJm56qVb4XBQmu2kCVmNXmw
7484	payment	1397	1397	1678	1	1	4795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwuHkP92QgANHi1tqAfRkZ1q2CizwPPdvKf1tPsuLDrt3LGLg
7489	payment	1726	1726	1874	1	1	1760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9DEVxtFRHxUSzZp3dtDPNgZSST1oB1d1KdirhBU9jjWy4h87
7490	payment	1397	1397	1678	1	1	4798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dQsrLLhpeyLyC1G9sBYbXGpJp1m2B2NPcjWK16geMofGL3ZP
7497	payment	1397	1397	1678	1	1	4802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLa2PwGyo1zTH8NDYQVoHwCg9gqr7J6BDbuFBPmk6nV1WxLqy
7498	payment	1726	1726	1874	1	1	1764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaad8pm27cNYyZEW3nMfNFu58p6BRgpbnqF1bgTdEt3ER33W4
7533	payment	1726	1726	1874	1	1	1783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHW9b4gPYzrEwdBt2DH4FU8mo9pDKuy8s1kqyDn52vnapKGtCh
7534	payment	1397	1397	1678	1	1	4819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFzeC25mb348asPXZeNwYGn8d7T5V2jZtVeCT6B57XpJy51BY
7539	payment	1726	1726	1874	1	1	1786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKPDwoLHQfbLy1gLRCocYorYro4xQsXQieZh3Uqv1RZeBJxDw
7540	payment	1397	1397	1678	1	1	4822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UM9ZZcFSc5nB8uzp4sqRKpVhrEXiTGVaKPD1pYVCMubt2BdD
7547	payment	1397	1397	1678	1	1	4826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZzGMWUqQkaEpiCQuK1Po7sAAyfPw5f36fKvz2WRMu2aPfR4v
7548	payment	1726	1726	1874	1	1	1790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVAB48d3atWTT8tBYFg8Fdgb1XS26en3EAkbz6UW5aWppB9pW
7551	payment	1726	1726	1874	1	1	1792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6jXbFfjyykK5ZwmMQbRMuuipQegw1ZDUGYAePhjwaGJmcqo7m
7556	payment	1726	1726	1874	1	1	1794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dNc9uSYztWESyEBew8qxaQVVN6oSU5iGU8JJxu7Hzeo2sC72
7557	payment	1397	1397	1678	1	1	4830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZFv6rHrpBNMGVgrBWckamo8gKidqJE2qN4h1PXnjwkmCN1NG
7558	payment	1397	1397	1678	1	1	4831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8srHnpBhzHFBo6vnyPF7uaPKFzeAiBYFBq4XshYAS6zL7oS2y
7559	payment	1726	1726	1949	1	1	1795	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa9XierAWtWoJXN8nAxJrNLXUnCRvYoNbfqGEfoCpy63SdsHTqY
7560	payment	1726	1726	1874	1	1	1796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZiKGFddZcHKcKmPuGAxnyKbQJK7GaUaXgaDjHqfkvSrAXYWyq
7566	payment	1397	1397	1678	1	1	4834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSk7uzwTTuuSXtP284Rrj79W9ZkMGPYp4s6y9Tx2HvYeLtdF4Y
7567	payment	1726	1726	1874	1	1	1800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkH1cxx3JD5fb6ue58cKpjzDLMHS5qj1tTBhmxGYiuW6pNU7W
7568	payment	1726	1726	1874	1	1	1801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHQ7BKMD6XXUMoUaxSnxC715ZcK4SwKo98pcTXz2a8Ww9W7Z7
7569	payment	1397	1397	1678	1	1	4835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyzP8V12RArMsb25kxJvEDweRVWKjuMh2P2zDtQZxJcbBi7Ny
7590	payment	1397	1397	1678	1	1	4844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffe69TyYWnH2HFUdtrup9D4gSk3Lb85KSECtYHeurZiJCDEhs
7591	payment	1726	1726	1874	1	1	1811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKCe6Msnj4Mr6Sx6z1daJ14pyv5nowgca6kW5GnyqUNR97THY
7592	delegation	806	806	1396	1	1	0	\N	265000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXP9uwZXgSAFBmauv9dHWMofoHMqSjFy4EEfRz1eDDEBjDUKUQ
7593	payment	1726	1726	1874	1	1	1812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdHqemhD5TrrS8fhFhXR8Dq89j3jRWgv8dxPXw55u3LjD6hqz
7594	payment	1397	1397	1678	1	1	4845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqfKnzd9WU6Aqw4FNGHZUwfZiXhvzUPbEXxyFTV57faK17HWV
7599	payment	1726	1726	1874	1	1	1815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QVxc6DGwwnNnxe7mzw4DENhawGoWTKgAMZfCgX7VZDwxmSaH
7600	payment	1726	1726	1874	1	1	1816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5p9Ej2ufWaxCnMkTPCbxte2kb91HDjEu8qFJr33UAwbT4W21
7601	payment	1726	1726	1874	1	1	1817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLhK2J2qxm23EgWNCKzY6jkWxVgQ7T3hN3xPnmXRGGvHX7NgD
7602	payment	1397	1397	1678	1	1	4848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJLMmNRM3A7Hg1sxvdF4KJxkGjRs62x7MQhMBkvGTkMXRQS1B
7603	payment	1397	1397	1678	1	1	4849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcxYA7W7nxUj4CzaravBdYk78Zgz8zGGaa9KeaXJHsCE2UtP5
7505	payment	1397	1397	1678	1	1	4807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVajLYuExc4d72NNxU51wtPYMJ5McfxugaBscCheSTxnMLYbY
7506	payment	1726	1726	1874	1	1	1767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkKtxanbaJpWhWcwfi4Gddksx56Yb6oQn1ke4yusMVMn3P3ZW
7507	payment	1726	1726	1874	1	1	1768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkSYzQpiuwcLyAUkGXpQfSCS3qChXH2V6DupeQGPLiPiESKKa
7508	payment	1726	1726	1874	1	1	1769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCocUwfdY5QKaXFtULdzf6Udz4hQkwf9DEwauSM2msnJdV6rt
7513	payment	1397	1397	1678	1	1	4810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBE8dRSv57xYk9fsAQKbGKChgiuqem9MBTYBXwVWoidH86eR8
7514	payment	1726	1726	1874	1	1	1772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRCRcyzj5RMnvc6DztnG7FASJ88iS6wMGybGU6XyRTeFWQCxJ
7515	payment	1726	1726	1874	1	1	1773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbR6PFWwjwsTyA8Efrz9ZxEQHaP4s18adPUyBQ62QZUJcpvzr
7516	payment	1397	1397	1678	1	1	4811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfS4eqoa8ATZDHhHDnujCGUmGsx6KMYynZmEa1q127VAjysBe
7523	payment	1726	1726	1874	1	1	1778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbStCQ1frdz5Dhrkmhw8u1x1on7xqdJPGmwcAUbvhVmyHwuKk
7524	payment	1397	1397	1678	1	1	4814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMApB8upYLYPfsHuQWM95B1Y7LcAm85mwcbtEXM414bzCRpLV
7525	payment	1397	1397	1678	1	1	4815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiUds5SBBLnuTjukqBB1jpETgsdo4wKC7R2KAKAoCnujRYLJx
7526	payment	1397	1397	1678	1	1	4816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCB8JyE6E2yf3NQyJVfHu7pr3dDSxYGu3YNxEcvreSWPsb87Uv
7527	payment	1726	1726	1874	1	1	1779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwhTpKuMiSiGZLg4xE7W98K5BEH5e2Uzyu7Jhp57dYZuFUXTT
7528	payment	1726	1726	1874	1	1	1780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiiHQMW7wsQ3r9WsThuEtM2NuhRh9ufj6ty1pAB6C3D29to1C
7529	payment	1726	1726	1874	1	1	1781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rbwjinLiunarxSpMd1iDf82oPzYdXb85a1gKgUNDTbaWEkMm
7530	payment	1726	1726	1874	1	1	1782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp88nxfiL2467UjsErE5HFPKZ9XwWivBRsn3VQeHAnfDA7Y5wi
7531	payment	1397	1397	1678	1	1	4817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tUFQYZ38v65K4YRX28CqX2tRSYdi75dBZGYk99Rb2iF1cQfu
7532	payment	1397	1397	1678	1	1	4818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2trk6uVpy5NWq5AaXz4zuouqgbz3ZZYViQwbKGkKToYcAJsCz
7541	payment	1726	1726	1874	1	1	1787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaunRVCZHCYzFVVwvj8b61e8Si7xHjLtpReeCHdCHTCc7DHrX
7542	payment	1397	1397	1678	1	1	4823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZkJvGD3FJSs3ru2k3vgCnnRegR9fqaW4PSyQFyJcd3Y3GPxw
7543	payment	1726	1726	1874	1	1	1788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2PPPbmR4NNjbqF8pB9Pewd2mFGVqtffHCDnGXNM1TzkdzajT
7544	payment	1397	1397	1678	1	1	4824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8yHg4DTQAurxrR7VHnfRKdVtqBfy7KoFpdVcNrG9XXA6s6vY2
7545	payment	1397	1397	1678	1	1	4825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTKMh3GgvCaHdnXR48Xt88yBLyHWygY6De3MvBHkwgbyg9aRc
7546	payment	1726	1726	1874	1	1	1789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpMCd6C3wGqQxBjoBpTe9C2rcMeHtdLthm6P9YWURQLuqZww7
7549	payment	1726	1726	1874	1	1	1791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHJdDNi24FrigzTJ7FPAL9Jc7P6HCwAoxovUAhNBUTx7CbAY6
7550	payment	1397	1397	1678	1	1	4827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLna9cUsMDDW218VSDuh51agBzKamWE4XTYW7VyiC9kcvdekMi
7555	payment	1474	1474	1950	1	1	3	101000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHg5tcmp8og7NmFPLG4PcfBMNKB3jWB9hVxPzBCSsEwQPLGxzJ
7581	payment	1948	1948	1713	1	1	0	50000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjbBWwdjBhuZQTWxziogEiUoYguewW9k8SYw7KQ9X8R6SFqcW
7582	payment	1726	1726	1874	1	1	1807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZLegLFVme24B44EUVmKUxgzVj1LgWQJjAsqvEdmMbTwFjnqA
7583	payment	1397	1397	1678	1	1	4841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBUBvqnXnwMxvQ6VM8LQfUrGzfGLpaiLBHXYeNNhjHkuCFuya
7584	payment	1726	1726	1951	1	1	1808	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ9F9gv4c5eyRTgwyisStFdTjkArAmW8G75sapbuFGMRnJ53tdm
7585	payment	1397	1397	1678	1	1	4842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdFPBT4t5oX8nw715xre14LYKn7oWJFppi5e1j4dVNNpVQKZ9
7586	payment	1726	1726	1874	1	1	1809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54Fri2rs2peAtKwwnRwUyBQmYakYqB2xkinrvMraCLjadDsKj
7587	payment	1726	1726	1874	1	1	1810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAeF2BNpEUH2CBV5DNM7emujiPcAsL7iH6aGdMmtXcfMN5Gs1
7588	payment	1397	1397	1678	1	1	4843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKs1kD5xd7DKQs7WKaNFgfx6PwjVdPnv4pGqmVb85pTZv1DMQ2
7589	payment	436	436	806	1	1	4	220000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFN4w6Unj4AY7S2SRds6UnhPZvepTwvDShyWrViPsxp7HKkCu
7607	payment	1397	1397	1678	1	1	4852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbf7fZmGnPxdqioLt8PXWmmokJgXTPAu37khuM3iLVJK2Pz7Py
7608	payment	1726	1726	1874	1	1	1819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZavtcKPH9fM7eTQHgDAHyS4GFFX1iT6NLXEgiBQ1PRvYigxvie
7554	payment	1726	1726	1874	1	1	1793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNEa11YjEW12bHAi1GgDTJVD5cx8rBbCB2zZbUte2JsLYYGBd
7564	payment	1726	1726	1874	1	1	1799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YHUkm2NvXReKX88RKSbkweRPqgCqbFvBviKhFtCuuwVWR55M
7565	payment	1397	1397	1678	1	1	4833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzU5LaZFqEuXAA5XPEz6knmbugjBhvmzyCavxBiRUVqhtocG2e
7595	payment	1726	1726	1874	1	1	1813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqanNiYMUjK7DXh4ssqeZAcaGAcSMkueuUUw6gXXMqM1zNLSp
7596	payment	1726	1726	1874	1	1	1814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aTVKf1C4Pc8UUbrFscYWUsCt9FNFqxfR3EkN73Kjz91uV2Kc
7597	payment	1397	1397	1678	1	1	4846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEfWBtGZ4KmdwBxYJe5mdTXA3SRJzUERicq9mfzsEoBChAhBN
7598	payment	1397	1397	1678	1	1	4847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggPwMWrmzjKbWcLH3vMV3NVRDTXPyJfEffYtydoBFf8Wuhx7c
7605	payment	1397	1397	1678	1	1	4851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBrfZ15Gz22mPY4gVRWtEbdgK14PvQEtRKSsMTR37Zpkj2HAg
7606	payment	1726	1726	1874	1	1	1818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowTPYieyMXiHjnRScGUsvLe4K6tWaKqbqoFZPFi3BdNCp7ZTF
7611	payment	1726	1726	1874	1	1	1821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3RU87GqNdP39VmyjsY6hmEb8SXe5GETCdDvt4g5Ddb56n14t
7612	payment	1397	1397	1678	1	1	4854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj66NdpqZz95UeSa9SR6wT7E7CThvh1LauvezSkZKonizszHoQ
7621	payment	1397	1397	1678	1	1	4859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FH9ajeE9FwpopHfgeSHXHy9pJim9dNkSrMLfsTpxVqpo2jQT
7622	payment	1726	1726	1874	1	1	1826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYBeMHV9iKwgUzvGC9jCcUG2LKZDKdA8oq2KdNfEiJ7nug274
7627	payment	1397	1397	1678	1	1	4862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKty4jTbxLSZTrkowVKrjBmbqrk29HcdJFsBUSkzQAaSajDao
7628	payment	1726	1726	1874	1	1	1829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8twtiXe252nknc8V7UtwyCTb4fvMS2Xdx7WiUrQvcVvrQuqWn
7635	payment	1397	1397	1678	1	1	4866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSkcKyuWCoSZj7jGBe5zCBwTRLzZALXQrVoWH3QPXE5MEtdAf
7636	payment	1726	1726	1874	1	1	1833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYzgHtVvzBRVGtuWE7Vsp4zTRuWkbu2LBWwE81m1JY13YycZG
7570	payment	1397	1397	1678	1	1	4836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jeRr31WFJZnK6wVDSkVuQgFezokuoWUjc34zuVcfqLDHtGc2
7571	payment	1726	1726	1874	1	1	1802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ziFjhDdsvaoN4m1ZLupu1asENoCj8MpAL7Kua3x8KDYZYZim
7572	payment	436	436	806	1	1	3	50000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3u9Qy53XbejNw85amdBWo5UhUW2bHhjFnWWoEKJGjZLyjtaNq
7573	payment	1397	1397	1678	1	1	4837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCF9kUQDLPxwNXcoMyvS9QxGgArzSiiQvLHjW1pqwfBowmBF1
7574	payment	1726	1726	1874	1	1	1803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBiPuFHV3ykDHyfU2mKUx2bR6vk2L8dPc7rKW5C4G9t91jUvQn
7575	payment	1397	1397	1678	1	1	4838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1RNj2iGWWS8xdCi2dCZbfbhWdUPn7mCACsBGUtEZEiqEBWsN
7576	payment	1726	1726	1874	1	1	1804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Q1hT2BNLbX9nXsp9V5GPBZMqPuHBT7rrsjKKnVCUjjsvoH3A
7577	payment	1726	1726	1874	1	1	1805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJbX9orpVZVDoZswF5uWGrMxhdfpi8ueq2xw4DWcVnEeBtttT
7578	payment	1397	1397	1678	1	1	4839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WVQcBjSeC9U1Ut3vyzU3F5oX8V8L6PYPqAjpvD9mcu2EYwsS
7579	payment	1726	1726	1874	1	1	1806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcRMFFJHKTsbkrvkVQNariYZkSPVaT2bvTQQjiZp4seZk4Rjz
7580	payment	1397	1397	1678	1	1	4840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gzL523FmNdnWbMU5hNAjXgx2bRPTw1uxBTkSK9ajM4gKJr4R
7613	payment	1397	1397	1678	1	1	4855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoswQutgsMoKexcaDB1S4PN8Xg8TqzqtAFLSPHmYhrL7Uq3Xiw
7614	payment	1726	1726	1874	1	1	1822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjdkZefvfTK3E1owrnDRG1D5BUYrWSSVKy1whMezfMNf4U2mi
7619	payment	1726	1726	1874	1	1	1825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLBGVwQfxTdcL3UiHALZ5RmJ1qTSkGPYR6XwbWdbPLLs4kgBy
7620	payment	1397	1397	1678	1	1	4858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDS7jRkZCEcRL9QxTogaUX7GkYjPMaz9ZErecG82XstFsuvT5c
7642	payment	1726	1726	1874	1	1	1836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNyvCsEGuBkzA9yxaFX82uhEA762iasutCcEX8DwQgsYWRbRg
7643	payment	1397	1397	1678	1	1	4870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9kR5cdEejKZ1ccRekF7PcCY9U49C9kdBQYsmWpkDitqMZReS
7644	payment	1397	1397	1678	1	1	4871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5wSMwnHwjYm8s9NNSCyjn76poSopwtnzKP7QtBmJmUqArSPm
7645	payment	1726	1726	1874	1	1	1837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Gais4AGS5942if42DtSNjAgG9mw8QgPDQLtveTTQhXHbb2mP
7650	payment	1726	1726	1874	1	1	1840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWTRQmVHft6JCTUzq5dS87TY8KVsaV1CQBCq9Bhq48NqA22Mto
7651	payment	1397	1397	1678	1	1	4873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWEqVEurk5rYPyAsbVVkeBbKmXrEQ2wkVqav1Lb9hAtDYbRUC
7652	payment	1397	1397	1678	1	1	4874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiToG63434kvSFJwsnfDGAzsnSwYvdY6EZmh8Nn8EUrNcURZCv
7653	payment	1726	1726	1874	1	1	1841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnyjwwFhxFZM8KdN8UgS5TLwQMDxLUcTUbRmE7ggazzjRakKm
7604	payment	1397	1397	1678	1	1	4850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj5rBhoCxcbDAb6Wo1kFMATC84fFbUvj6axxtc5gZ2JhUjHmx
7609	payment	1397	1397	1678	1	1	4853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4M7MYUgVCixa2JXZBMvvXZM6vWy1WyPV5xNWCLySw6kpWGvo
7610	payment	1726	1726	1874	1	1	1820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGpiTNdoZQghpFuynRJ4ShDcumh3CfzG1VDCZyGMtwK5V4pXu
7617	payment	1397	1397	1678	1	1	4857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvE3qgbzVLqokFA5jNam49ticPLEWXxsceRnx6QkExAUrjNVC
7618	payment	1726	1726	1874	1	1	1824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVr4UFGJQnPLCPP5JgpQQxYtcH5Y6iur3Ncdi78UJr7YwVyGp
7625	payment	1397	1397	1678	1	1	4861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt2gVdDYoucWA3d9Xr2tQ1mVLoAfxRkEzWMhvnCXt3T2ZQQ29
7626	payment	1726	1726	1874	1	1	1828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGLg16rKDhQSkSWrTUgHABfesZ7PonFddadNZnrJ5uYDJNEUY
7633	payment	1397	1397	1678	1	1	4865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9Drsimu6i4aRKL819N9ZLKHcYLBqYFyF3gUrxNzutP6e1bVZ
7634	payment	1726	1726	1874	1	1	1832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rpkqxWGFXeSq1S8RCTLHgxiA6aduVxnNZeviXAsR1yEMC96w
7637	payment	1397	1397	1678	1	1	4867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLEy2TAVe4UxQen46umwRD2rc8NmaxuY1zPEvjvaBtoZge9AK
7638	payment	1397	1397	1678	1	1	4868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufbCPHHR9LhiwqNhCCUtkZCZ9nYzaQtKDciPNGLjk4A51zAQ6
7639	payment	1397	1397	1678	1	1	4869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZWKE9VgVgiFsUCpC1x8mK1GG9rnRebqx9rbe1iR2ESxkzbf1
7640	payment	1726	1726	1874	1	1	1834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wnLuN47gzN9zkbZrmSgXB34iE372N9qbFArYPyyMa2TWPePi
7641	payment	1726	1726	1874	1	1	1835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEVyUZ5tkAApiF9kSMCoXs5YydRfwJbkjuqqnG18foGkGi8DY
7646	delegation	208	208	1460	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9ZdrfirWkKvZC7kaYPKAE8gDGh6h5eBWD5RdxFTFVZe9DLc4
7647	payment	1726	1726	1874	1	1	1838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaW1veupJwHz5ttoG9jRXUJyjBNxkU28cQdEFY6wzR6Vm5tvd6
7648	payment	1726	1726	1874	1	1	1839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JFfESwWLBgB2Lk86FUSPgckTad76V3honrZQFrEecUnfEzYs
7649	payment	1397	1397	1678	1	1	4872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdmqzP94TpBXiD7WkqVV1gz7vf71GBGDvarEEDzv9uvzuiGg7
7656	payment	1726	1726	1874	1	1	1843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9AFm9fwkpvkzUEJeWdhYtH1XDmLJVLEERKnQBSKhuxa2aqKMo
7657	payment	1397	1397	1678	1	1	4876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCPmeh5h9Asjz8Ta69Qf9kQ2LYdyZ9PvVDAAH5N98yDLFH4uW
7615	payment	1726	1726	1874	1	1	1823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWw7rrQU36nVb5WP15pvxTGp93GbekyYSaacCa3268j5VYw3G
7616	payment	1397	1397	1678	1	1	4856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnAceismrWVRGFKpmhci6wmxSNDBXYzEB6uzEckag8Vn7GSjQ
7623	payment	1397	1397	1678	1	1	4860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe4iUZQ7qsYHpE9DgRiipkghfUqsHu8PMDxr698qjR3jK9Ufr
7624	payment	1726	1726	1874	1	1	1827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2psDKLvf4EvnY5Abhvw6WeFukTgrcAN7odxCdGWQsAi227kP
7629	payment	1726	1726	1874	1	1	1830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kBE9UgHH2KX3Bn8oFy4dBZ4hL5p71Q1c4DJXgX8gyvNhL5ef
7630	payment	1726	1726	1874	1	1	1831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3xrbmL6gNUweQmqz2Zd87Up6o9DWmYUvucAK57yh4RHkzbZf
7631	payment	1397	1397	1678	1	1	4863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8dZtjz4TvS5fJRYRn3g62Sxmg6MGma3AWoCECWGkd7sqKkKP
7632	payment	1397	1397	1678	1	1	4864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUXxSpgLWHwXEThve7Bvny5tx4UZyiC2vHt6MDJy1asnookEu
7654	payment	1397	1397	1678	1	1	4875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGbUeMg7LZN1H7f2pEjjkFBPFFdohuFW3JGdAfFKWAE7hogeB
7655	payment	1726	1726	1874	1	1	1842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkJBh6wZ5bZtdLSdwSuaXPqwM5WbVp6yM7hQSw75esRNwMstW
7658	payment	1397	1397	1678	1	1	4877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWojkEpbrUYDRdCKVLHxEsGebepCytBQS8UqosXyzuBWpTaVR
7659	payment	1397	1397	1678	1	1	4878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62LeDL8fycnsdLfQNqub5pJw4rJQr4U9RH8zTJRELyZwwJDSK
7660	payment	1726	1726	1874	1	1	1844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9KzRYE5ZH2BvMJSXtwAGAUxzecmvvPHoLuw1zKyHWcdBZDFS
7661	payment	1397	1397	1678	1	1	4879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVPnLwh9aEm2wJopwyU1euj4oZRt6VXdR4KfeBL8apppj9umG
7662	payment	1397	1397	1678	1	1	4880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSugqbMwV6pJX1fZrYg5WDQB39HqxfjyGGHATUeo4mNmQsmzN
7663	payment	1726	1726	1874	1	1	1845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcGtbkzwcWocdCb7c3fbd6sot5bvCC22Aou3UcuSg2vCPn4WW
7664	payment	1726	1726	1874	1	1	1846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbJ9dijvmnFUqKxR2u2Ur9LBN3gqEWSrtgARW5RhunXDdMhjv
7665	payment	1726	1726	1874	1	1	1847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRzHs5PtMCaJrAdjoyceMxpYspZFo1YvZXCFKeWVsNjphzvTS
7666	payment	1397	1397	1678	1	1	4881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYauMC47fFXetDoE7qX7uHebrznbBoADSnEu7juJA8hgRCFiecr
7667	payment	1726	1726	1874	1	1	1848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVw7K3VZkPyF88J8UtPcMeNRTF5w8hQkoWN1PLAYjaCGgd1tHY
7668	payment	1726	1726	1874	1	1	1849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzq8VZ2gQG1tzZobZFa7XeHzPQsGPne8D2G7wEFHPbKWdxzWx
7669	payment	1397	1397	1678	1	1	4882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiRuqpCnQhuQj1ep8bSW92Z62RgULJcd266orT7TbfgjbmPYL
7670	payment	1726	1726	1874	1	1	1850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLivJadUYugKXk7D7KUA9jWBShNo6LgHMnaCZ7YJtKKr6Rbxf
7671	payment	1397	1397	1678	1	1	4883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqmxf3nctsHmLcaw1X7iJ3FKEp2WazsVKRL4jy4gozs3kYgUn
7672	payment	1397	1397	1678	1	1	4884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNxMJrD6fDRR5NpdDCttPpV7gJZuERgYcT1WYdTqtwf7XGepR
7673	payment	1726	1726	1874	1	1	1851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQrKd6CbrvXHQypRmu38Ptvg8Es6opieMRZAQm67kY9dSkQ6T
7674	payment	1397	1397	1678	1	1	4885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRwMXwbiyg4hRXfTfaUDNhz4PeNEKKh9eJV6fUkkvGoWYeX3H
7675	payment	1397	1397	1678	1	1	4886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqQ58uWekp3ExpGAsDuLkVzamRnbEzmB3GhVBMKTJ46hiCCyy
7676	payment	1726	1726	1874	1	1	1852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyZLk52unY8n8UKLqLMuXgCvBLcPZ1VGLezeGi9VUQaYejmpQ
7677	payment	1726	1726	1874	1	1	1853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW432WQu98DB8oz5czFfpqXvg9LvC2RqJzZUYELQwWXcwAuZ7
7678	payment	1397	1397	1678	1	1	4887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZT6ynGf7Ndz4P8TZNegpSerdkYhRhYYS82ubTq21EPoWxJgT
7679	payment	1726	1726	1874	1	1	1854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wuwnhNUcqqCWACe3kguHpMRErgoM1Nc4MWtCTWWbo5P6koVC
7680	payment	1726	1726	1952	1	1	1855	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYennv1R7Myxe5yL4scFwEPyLQdPrYsDw2B5cmjyL2jnoPPaxbo
7681	payment	1726	1726	1874	1	1	1856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBE4wqmpNuPpFpiqSW7GaPs4DNLLDLLGKmzVPd5NFwZcJr2KuT
7682	payment	1397	1397	1678	1	1	4888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwxBi47dXwrYEZb4Pq1GkEv7j6E411heWWq1wazrJMNc4oJuH
7683	payment	1397	1397	1678	1	1	4889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPP9bodfYBwxvmg2xUTAW2kQrvW81C9svywzrVvJwNhfV7mqW
7684	payment	1726	1726	1874	1	1	1857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyzCE9yQS3pg1twwARyL1tWNzBDXApUuho8ABs3fa43DVDJiJ
7685	payment	1726	1726	1874	1	1	1858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9vvC9pfJw5GgMcpFtBarwEhJWZkz93jJkEU5nRxq62fJUZvW
7686	payment	1726	1726	1874	1	1	1859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mnoUVwAf3wnfWagnDP8XFVFg6y155eo3dpx4oribBLtK2CXb
7687	payment	1397	1397	1678	1	1	4890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZa2QAfSDertd6YDndrB7LUzdKg8MRoiVz3DCrdfWvzeKgTCr
7688	payment	1397	1397	1678	1	1	4891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcQA4Ra5bQLvzvYWTfLRa3kw4ETKZwri38jA19MZ3pUTBWPSk
7691	payment	1397	1397	1678	1	1	4893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLPJzYdTxNtQZJxsnty4BpcpK5bTbgfnx63cVMsPDsXtxzwuT
7692	payment	1726	1726	1874	1	1	1861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PAYojGdcSZwCQoTx4quoAfw3fibvFW5QBmTwn3sQTq2cazYC
7693	payment	1397	1397	1678	1	1	4894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALUEVn3JF6Go1KUGVeBwn1bV7CbwawfbXTqQJBwDSw2TpqM6m
7694	payment	1397	1397	1678	1	1	4895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsJafCAxyrYMMrhxERprWsFZ97RsFFMEtRMgazjjudPHtA87W
7695	payment	1726	1726	1874	1	1	1862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xmVfvacpH1ZsNnFNhzbPrfrFtBT9rvbFjnYFUywcx4LP1ek5
7696	payment	1726	1726	1874	1	1	1863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eecZBy5WeZP8RfSP7ScU2XzyTQ2Zb733gyTZ2CN7knCPmacG
7721	payment	1726	1726	1874	1	1	1875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhcF2TyzUS8KeqinjNUs1tm6vHBT6A9LQhNZgNsxULm4wdCKp1
7722	payment	1397	1397	1678	1	1	4907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvF4mxNyHQmrLGQpGm38oCW3pePdLagWSD1Qy3whtgCAj9KPw6
7736	payment	1726	1726	1874	1	1	1882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfqmTWjLWLJmR7xuQ48uNMGqg5WhV64DFDs1uB3W5o3ffDPaW
7737	payment	1726	1726	1874	1	1	1883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5JQwnQx1dnZaGXQ7MD6EbGk1duoSpR8jm6qNthtijWcpBVxL
7738	payment	1397	1397	1678	1	1	4914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FkPYmZatrqjbZT7rTZ8UVbJftUoTYodrJArobp3Jkt63xkyr
7739	payment	1397	1397	1678	1	1	4915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnov4ntrJUz2WyBq5ddpzPbaigwBxpSYDXrB5d2RoW9ivwLMdg
7740	payment	1397	1397	1678	1	1	4916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXJxSTH3bTyrdv5RJriZC2a392qFoHM6EKrT4BWo4RYuxJtdy
7741	payment	1726	1726	1874	1	1	1884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzbz9tZ9AnJxVGqffc28VJEVjx19ZZ5AzbpGphVnt5Q56fK3b
7764	payment	1397	1397	1678	1	1	4926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBYnz41KcMZmg7MqnmqKsjfpi3RwXPEbBZRuGfYduy9Pat3Vp
7765	payment	1726	1726	1874	1	1	1896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoQjPNRDfSF7bTqgeT4Tzc8iRnojpyUgteAbhHamc1Aq5PBXA
7771	payment	1397	1397	1678	1	1	4929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjmUwGqamkvcGM62mJMamaEGtepCWomsU9o6PabkYwraiCUb6
7772	payment	1397	1397	1678	1	1	4930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRKStaH5T9CCLXMUAqma1NLwLwjz18wMXJY5iLhTh3ZkTAZnV
7773	payment	1726	1726	1874	1	1	1899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx2Z9zYrYf9nUpqEtAVk5aXYW4Z5EFNWfTSDj3jB4YvEVnAwom
7774	payment	1726	1726	1874	1	1	1900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFQkpETgfsb1XvMiR76UCZ6n6ohA3rCq1p5sR2PHsyx9CXf9i
7813	payment	1726	1726	1874	1	1	1919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi61o3rAXzS1SWsvSHWdh7D9STpZbSjBuV9XBo76em9ZSWZe8o
7814	payment	1397	1397	1678	1	1	4949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCoYCbozNDtpktWj3GqdUXY8tv5pmZCZyC26garXeqUvsrQdF
7815	payment	1726	1726	1874	1	1	1920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdvd7BbxDNPvEAsecGwcUREU9h1CxE7qRH4gBanmmNERytq3o
7816	payment	1397	1397	1678	1	1	4950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFH2cN78kfcv6w5pPdshzY4MEHbuD3CfPy8aAUZffwEwm3dsZu
7832	payment	1397	1397	1678	1	1	4958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8cRmSDSgM2sRodya5neqb4jBHJYNrwsvuTCaDdZD35ASCbFJ
7833	payment	1726	1726	1874	1	1	1928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzNhd4XduDvNnPxAV9HXyJKKpFtrdXqLmKhnSvD96nuLgGZ5v
7834	payment	1726	1726	1874	1	1	1929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDJG36SSAEspMKPMSsSsPPqcmVJj1m2BWHbNsThxo2tNYtFYo
7835	payment	1397	1397	1678	1	1	4959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHC1Putwfd8UfhGcALdUBiz7NanSvNvRjwjC9t8DSCkMjGzWVp
7836	payment	1957	1957	1941	1	1	0	5000000	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeaonXFric2sQmCDNJTg14DigPr5bexjSzi2jonJEa7m1x2WE
7867	payment	1726	1726	1874	1	1	1945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRM2C92NRN77MW9jKFEqE6LCzbCLiv2g98BySZyNiNJsjro9D
7868	payment	1726	1726	1874	1	1	1946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxTFJXHXoWEDKMrexcN7zWmXdvJNbAAwksKV4tU5vAv6aJWws
7869	payment	1397	1397	1678	1	1	4975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11CByo9gRNkiT343b4xo8vtLN4cXLHsP7GqZYstvTqa1iqtkw
7870	payment	1397	1397	1678	1	1	4976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxT7Hk7rnSK8nQvcC8h3DVyUtTJ6M3yeSJNHt9N29ehMzCQJ6C
7878	payment	1397	1397	1678	1	1	4980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ff2rat9or3HaYimUt7R9HxQiAFRY34urFcVtgjxbq7rDxZ7P
7879	payment	1726	1726	1874	1	1	1950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYj7kiGd4FvJPxrX7PEeS3MaGWMG7kHmLiB8k2UxYg1heqg2E
7689	payment	1397	1397	1678	1	1	4892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLywtUt9Bm7H3HY7McqSitcpjAemDuZ7odUXzwWyVic51Ktqj
7690	payment	1726	1726	1874	1	1	1860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJqvgMZF4qqTrMtSmWiJ3QbQcr8xsiveiCCecfW8NZ3Yxeho7
7697	payment	1397	1397	1678	1	1	4896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qeVr1eWLqpFQ58FackuE3c23wVDXZmeYh1i9H36UzBrN8ZTE
7698	payment	1726	1726	1874	1	1	1864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmuKuDRXWht874fABEMw2njxvWdLpeVG1ZZiG7SYULnBRDku7
7703	payment	1397	1397	1678	1	1	4899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDBY9qU6eZb99575BFSh42vqozLVM1vcBRMYhuvD4m5jmzSpQ
7704	payment	1397	1397	1678	1	1	4900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46UnQvbzH2xQoShZzCr9fi1PpqRLeFJXRziaHowFErvJkv3Vg
7705	payment	1726	1726	1874	1	1	1867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2QKfWfdgUvSNnKaoXdhskCgwCwRF6MqKUFAadXjznAkFLzFc
7706	payment	1726	1726	1874	1	1	1868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQLdJ6pVsCpwqKWquuzHwAEnrnmtKorfjzWqmAHgXKmjUucu6
7707	payment	485	485	1569	1	1	0	1000000000	1000000	\N	E4YfQUGvkNvLasMoEqGKLUBYSNHm95nZAV6x9ByDWMTQxvb8MVQzk	CkpaJPxkvxxJkUseJY4rgLukXf6SXd1GPMMfHaySzheZJyZzEMM2e
7712	payment	1397	1397	1678	1	1	4903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrMLMYCJ77PTgGV43qCD6ihgXfkd62ehytVWwy9ESBE511Ptr
7713	payment	1726	1726	1874	1	1	1871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZib1XWJifykT6myvcfztUHg9Hm4NjXW2W1MWCGPWUh6FzpnuZu
7714	payment	1726	1726	1874	1	1	1872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFC1cmM7WXJxptNkhG5qhr3XzuEPXfQtYpd2DsRRykZaRXM8D
7715	payment	1397	1397	1678	1	1	4904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGk7zauKt5ht5v946v4CnYAXiofyYhZDW1L4qzTNs8SXMqQh8
7716	payment	1515	1515	409	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGh9BJZsnpeff8ZZSuiscuw22TuheXSiMkaRFLnFBbeAtbNpKx
7723	payment	1726	1726	1874	1	1	1876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ELJoahLnUHwU9MxtQ13zTPM7YXwSzqGnL7zcJfH1jo4kVkUX
7724	payment	1397	1397	1678	1	1	4908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvVYWSXZXrN8Wh4T27SVpVSpXq4vrDcXssW9wpU5oSLmZvyZc
7730	payment	1726	1726	1874	1	1	1879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2KBGA7c3a5frvFLffhUu8XqY16m57orHNNqGtkhe34QDUDkN
7731	payment	1726	1726	1874	1	1	1880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzNdHizWtRqrrkansk5La7VX8JWtgaGZKUonEgsLecumZuKcP
7732	payment	1397	1397	1678	1	1	4911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAU5XthmS6thgmS3LALFmZG1Z1qLAo5jKo8Uda4bd6FzSjzkU6
7733	payment	1397	1397	1678	1	1	4912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5WFLKWusqdgw3fEHVM9rz1Z3BbVhd4Bk1NE1hfC58D4NgMTw
7744	payment	1726	1726	1874	1	1	1886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3BhoMyjfNa3hy4WaVq1aTXvaBLfk4sgVHZBwEYhdLhE36Sis
7745	payment	1397	1397	1678	1	1	4918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHif7huSPbCxoUouEUfVJb2VH1gFsLkZmxqodzrarJXpsN8Rt
7746	payment	1397	1397	1678	1	1	4919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpe5PzQS7BPnw9n4nuADo6x116BjHiaczJzT7NHkfLeVhL92r
7747	payment	1726	1726	1874	1	1	1887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5R8bSipG7qXVoLgJzceRGvDQ3ixaeirvAH4dsGNgYpts84vRb
7756	payment	1868	1868	724	1	1	2	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZThvCEki6ZvJ5sZee8NXPssZk91gCpeUSsXrTGJ9mCUnYkxMh
7757	payment	1726	1726	1874	1	1	1893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9tuezjCPNgcZXJjJXgGzfGatofJy5a3viw7Fz6NME3Njqsoe
7758	payment	1397	1397	1678	1	1	4923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6efd1ws4KhFMupJUsghRHp9dvR8ieXjbpXzLxuhK1wGBDucUv
7779	payment	1726	1726	1874	1	1	1903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQjd51GpFznFpT9jqTawK6na36Hz8w8Yp4hMbukGDTWaA7iNv
7780	payment	1397	1397	1678	1	1	4933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamoJQgtxdUnZXD78GjEPWhcpzDy2VT2qxp5RxyJBeU86NFKZp
7781	payment	1397	1397	1678	1	1	4934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsAjphxERQykikKcZt3rCXAbVpEAczx8TVeFjvqppaYEFLgLY
7782	payment	1726	1726	1874	1	1	1904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZHqt4p6XzLUEjakpyk6oVBa3U9BXHDrbH1kP2JNGSzungwsX
7783	payment	1718	1718	1474	1	1	1	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvvJ76J2DfvhZ4aE3ujYZ9jUXP7etrdesqCvnkfeSCSYVkyzC
7788	payment	1726	1726	1874	1	1	1907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4T8cHZmkfkayfSsJkgkoNtNwbSx55VoxvByyDPfJof29FB673
7789	payment	1397	1397	1678	1	1	4937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCy6HHF4nA52MsY5atqUZirLN1sGesSmTUf6Q6Zpe4Sx1LgBY
7790	payment	1397	1397	1678	1	1	4938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbx2S9PB3LRifdEsyaKh5q2jFkxFxhM8aLXH6Vi9p555bvBKXR
7791	payment	1726	1726	1874	1	1	1908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6J5LjPLvwU3ZmqtTS5EoD32kPCWyXX6Vj7dto2pf3JVRZ6qNQ
7794	payment	1397	1397	1678	1	1	4940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgiLyJT7YK8EyFAXiXQUu2ze8AfobQw75DPvkkDUAwkrk1HQzt
7795	payment	1726	1726	1874	1	1	1910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7e6BFmYDLhoBU1hK9xEy8GRHA6C4qkXUs3tfKqQ694hPxo7X
7699	payment	1726	1726	1874	1	1	1865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtazj7SRcAmmB7Xmpz2YC3SzziycXHuUzFa1jAYKTEKdrNdbCg
7700	payment	1397	1397	1678	1	1	4897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NJbguK7Rwg1R5Yp2PghGBuVYKNEoJ5Lw5Y43vX9eRjWbRjkp
7708	payment	1726	1726	1874	1	1	1869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LYybSiWUoVJvtBPx3du3LY7bcagoCBD67UYGVs4JjKpHpJE7
7709	payment	1397	1397	1678	1	1	4901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNKVuMw3eQYAA4V4oyENh8oZSamyRAo8L3gzUnXRVVbqmoFPc
7710	payment	1397	1397	1678	1	1	4902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGxUJeSdwtueHrrdhuzacrtsbF3dA7wiEiZ35JeGdgWfFycA3
7711	payment	1726	1726	1874	1	1	1870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTH45gwf8nc29zgayD7hjXqLdKc45iux5bkMZ6jdBX2noYro1
7727	delegation	724	724	1953	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9n6vuWCt1q1LxDbex62cGKiv6nQnrQSWhxWgDHqjDMSyxMxo
7728	payment	1397	1397	1678	1	1	4910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNyv31M9qD5Ev9CkQbxxoQJvRm9qxWzzACju5g96z51gyxpSi
7729	payment	1726	1726	1874	1	1	1878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNRcxkfZVpi5hj1ZZvXmgoAwWnGL3FkhDuLU34aE462ybLvz7
7748	payment	1397	1397	1678	1	1	4920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjR8UB78sLYvL4CQUxZjkMWoLRKZ3Xy3AyHQGaqis1HQ8xnUnA
7749	payment	1397	1397	1678	1	1	4921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYnGrBCsRqwJDHUGh1GT4AmY8ePUJivmdEqyBfFEDy6ub7A2N
7750	payment	1726	1726	1874	1	1	1888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbJNKhQR6sWDgW8thzL7VaL8MhiTivAJUphRnPvokdsxsX4Xp
7751	payment	1726	1726	1874	1	1	1889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRHTLhVfmcYSd4NJ9iaePVnmKpLLFtUzP1an4wvXZzy1S4aNi
7752	payment	1726	1726	1954	1	1	1890	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCDVXEc5g8KgUgVH3S9TfGtvNM2QDcL17TrZA6byogNdzpdgBn
7753	payment	1726	1726	1955	1	1	1891	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfkvBw2jBGw5R1NGEGQj5HAK218XXAYtJ3ZkQk9thHHAG6XDc7
7759	payment	1397	1397	1678	1	1	4924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfKrcDGsRhitQ44tTtwiGx28UWB3kFSbT6hKrvkj18aCbugGf
7760	payment	1726	1726	1874	1	1	1894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQPgtk8vzJbYaCMoiascsCQAdMqNUpGH5VCcVBJ8ogeAKREAp
7766	delegation	724	724	1956	1	1	1	\N	1000000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDjfBvKRQtUeAhkXuQ6rRDpbiDZr9Gz6YqBCePPVF6nmh4W5J
7767	payment	1726	1726	1874	1	1	1897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhMxYumzZkGaFovLYcWxEx7hbCFD6LfReWvNFg5mU63oQFDJ9
7768	payment	1397	1397	1678	1	1	4927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPrbmdxGJTeH4AHgm7QLHc7wxV6GtX2LgZAQ5rckpeXTo3Sp4
7775	payment	1726	1726	1874	1	1	1901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdsPhcUNgRE7NaFygZbJ9phPaD7RUkUFXZQ6bNcs5qLFTspZq7
7776	payment	1726	1726	1874	1	1	1902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yV6TLYmm6no6T6drfgbcyCqSTgQt8PmGYhY2p76z7SxB8MCc
7777	payment	1397	1397	1678	1	1	4931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRrU8LHDTiuhYthGtA9wkgJXtCAFZbNUEZTgZfVGK2g17p37M
7778	payment	1397	1397	1678	1	1	4932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcUQPS3wdha2452Hck437Ua8DqoYrbr7LXnv7WFGTsUTjsWLU
7784	payment	1397	1397	1678	1	1	4935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fezK2p8XYYvkMFRMXkKYXcKXF1woueuXfRmgJqaM7MTYhmFi
7785	payment	1726	1726	1874	1	1	1905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEwL8uB6MUV63nfWNkVtZEQFsjNhSnBvm1P68a4vcKet5X2Uj
7786	payment	1726	1726	1874	1	1	1906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhrssvv3DkvnMu4qQb4ctjZ9NdGFKAfVVQsVg8JNtRS6aWUvS
7787	payment	1397	1397	1678	1	1	4936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEpDAacuxXMp48rsjvd6P7KZphZu6gHWaZt3Mcga8fSF2rVv1
7798	payment	1397	1397	1678	1	1	4942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWjA2Fkfz2XJwXyWXkQuHKWJMsyW2f2CuygER25ikoJDKAmYG
7799	payment	1397	1397	1678	1	1	4943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT11FCGVGTJysCVNAWQPHLZdyNCqZUoraLH8PFpC3nXn34WtUa
7800	payment	1726	1726	1874	1	1	1912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtHvpaJ6hHLeJFRcr6jGRqWagNj8EPRazMgKHV6Y2QgjwU9tb
7801	payment	1726	1726	1874	1	1	1913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NVw5ejTB7sSp3MyTfcn6tg6pk7wgpEYJQbUWUo4T84eKNyhn
7802	payment	1941	1941	1957	1	1	2	1010000000	5000000	\N	E4YVa9F9Z3Lra867TW9e5uSkEVbZedrh4Ty4TCFFXMKC73s8ZJEXP	CkpYmVztbF5eBuYrRua8M3epkhSk9UC38TsSsW2nRHPYrmM73awZh
7803	payment	1397	1397	1678	1	1	4944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXh6xpWgahqYyFq6cQSMktuszuxQVVBkxmABDUanmbTdfwh1gq
7804	payment	1726	1726	1874	1	1	1914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gaPUXhLo78FYaz4EraA1E78qZHTw3yFAM9J2uSgrhDkJfL4S
7805	payment	1397	1397	1678	1	1	4945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAU6jhdu6RhepV7vkUc4ATeb4JQc872wboG7zD3cZEE439eVi8
7806	payment	1397	1397	1678	1	1	4946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgv8Wu13GwnUSbcNvV2ZyHKm5fWgJ6CtWyfvePrs3C1f7P6H8S
7807	payment	1397	1397	1678	1	1	4947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMGhYMwcyWuajWFGS4d2EcngVUMB1GazxMW7ZJT82JiT6JWW6
7701	payment	1726	1726	1874	1	1	1866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDV3LAkKXZvxAuUBRwYo6dXAbrNg6QUjmZzHAqZAKbm2M63GQ
7702	payment	1397	1397	1678	1	1	4898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvNduKfU8ahxxE8wHNkcz8AxvANo2QABWxkTesERMFA4vbi4x
7717	payment	1397	1397	1678	1	1	4905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9smRrtG1KoJxRwh5PQjGaM44yeu5WjYmjSX5qrbvfmhciQsN
7718	payment	1726	1726	1874	1	1	1873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu12g9HNsv9sVF4MfRh1EbXWgrBhG5cwTEPvWq168D5jDiGPWs
7719	payment	1397	1397	1678	1	1	4906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxQKBZ4toMzXj7VicPvJAA8qiW2D9vCtmwULqZPpRZG54pySb
7720	payment	1726	1726	1874	1	1	1874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxa8AYpCv36BPQsPoMqXD8DkReH6pDNu7temRY6GLQjKhJ6eP
7725	payment	1397	1397	1678	1	1	4909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bTgBMvdq9KhmZ2xceCgRNATCkv3voR92CsZ2nKwbaur4KBMG
7726	payment	1726	1726	1874	1	1	1877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtCTUAXgzCveUCqZXFPWzKuoMqxk6nUnQBMeSuKkTWrngtnad
7734	payment	1726	1726	1874	1	1	1881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPQg3z3hdusAbeAMrUymhRE4sLDw3mDtBySBim2BGrPXYXH2Z
7735	payment	1397	1397	1678	1	1	4913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmytSMQpUstBdGpJ1BSWbokRnPmuv2Qds21vWwhdg2gP1USeVj
7742	payment	1397	1397	1678	1	1	4917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h2DDt7wDNhAXtqdDtPmbvrGCVzANCZ4jGss7YLCMkVk2BPPp
7743	payment	1726	1726	1874	1	1	1885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqewh3jh3VXCQpnroYRwnDLzDNwK8SUJpKPeQJ47z4dWD77p2
7754	payment	1397	1397	1678	1	1	4922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5FnE2k2SLP7tfwVACQPGDWsdGejuVxKdZzgXNmZyhWanTzqH
7755	payment	1726	1726	1874	1	1	1892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15PJ5e7q2d4War54ReVWauy3y1mY53oTdn9CjK4D2UQg5yZkM
7761	payment	1868	1868	498	1	1	3	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRcmq2m7ukNwn8JS4sWWBKgCWF5HwHRpBqg3V7CaV6KyJDtR1
7762	payment	1397	1397	1678	1	1	4925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6n7BMRUPnkBUYYsUJ9V8kpvLpnMWnr7kqHgttvGtkpFztLwgP
7763	payment	1726	1726	1874	1	1	1895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmXyc25aagxaascxR53mFwLbq2eUtD8QDrHcaPZjnw79uqf6t
7769	payment	1726	1726	1874	1	1	1898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRydchFr4DbfKURLWLqQ1yMRxN4KMZAe1E3xEvQToSjrYVtEDL
7770	payment	1397	1397	1678	1	1	4928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiLg5KuAtUqdnwhjHHuGDgXDMZkAobhGzsUXvbTpvR8p9Q2RZ
7792	payment	1397	1397	1678	1	1	4939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFsPZkB5v5jLNLFNYN8yoV9LPv6dWJjLLHtnhN92djDXqAdv6
7793	payment	1726	1726	1874	1	1	1909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAshKxzF9knWGPmhyHdHTLJ67ecXC1Pr9MM4yGf2ywuqiAnXc
7811	payment	1397	1397	1678	1	1	4948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYs94redruFUc9r2zJ1iBTnvhMiQ7hojMph8V3EoWKDytrxTsn
7812	payment	1726	1726	1874	1	1	1918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtX9nPtQZnGH948YMhbQRiTFt9jCU2iRH7G8V1WJLMpbFTy463
7819	payment	1726	1726	1874	1	1	1922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwNzg2fxCLGzx6m46o17ZTVJo8vTw1dzC2RCv7sphtyUcKiB6
7820	payment	1397	1397	1678	1	1	4952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnVFoXLege5368WYm1Jq4apr26HyXvvMcPf4QUsj7AFMV8c8f
7837	payment	1397	1397	1678	1	1	4960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7uQpRuDJ9v6kEX4Nbf1nHZVcNmLKAh1UB7r3eC5yugoRdKLq
7838	payment	1726	1726	1874	1	1	1930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM74cDApSZvCKT176GvsRYZzBzv2S4iD2f4WfgZg85PfgmiSu
7839	payment	1726	1726	1874	1	1	1931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyhDi7WpJjuz7tWJ4xhmmKMCUmfCerdwBTGJYDH81KB3Zz3nZ
7840	payment	1726	1726	1874	1	1	1932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZZJYG5iJoGRBVnHqUZatybGTXLZhJABxuAKEvJgNHUu1T67P
7841	payment	1397	1397	1678	1	1	4961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJwAmi9aqA85PLzuZjsG7fG4FT1M4xrzwSFQsKwoVDMnFZQ8s
7842	payment	1397	1397	1678	1	1	4962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvtgXhowRjjUoBACdpohuQjzg7MECr1JMGGdGncmbr5caXazuu
7847	payment	1397	1397	1678	1	1	4965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYzNBmGp7FTQ1BCKHiXfNyukL6LVPkP2FB5f85YYwqgayvg6K
7848	payment	1726	1726	1874	1	1	1935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8niggptQZPmGKPNFLjZEeAA3WW83cbUKejZ3i19zRbJahizWF
7849	payment	1726	1726	1874	1	1	1936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyDbD2mbexreL7SNCXCVNg9PBe2fkacHZs8d9ioDDdffS7DFc
7850	payment	1397	1397	1678	1	1	4966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAaogDCjpwQLhioWRXpT6gqdsWL3pd4KCRnoV4F3Eabp45Bxy
7853	payment	1726	1726	1874	1	1	1938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdRxzkTD7JKE9H2xAFpa16gexuDCAwnCVVY3fk8WJ4LYuFxqBp
7854	payment	1726	1726	1874	1	1	1939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdynqkWThAgKPp2hvW61t92ieXH8GhrkH8mu91a9118YbPgRNi
7855	payment	1397	1397	1678	1	1	4968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp4fuvpgSgTu9CA8KLM7FV73B6txC3b1S7EUp8ZRpndkqTDgG
7796	payment	1726	1726	1874	1	1	1911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTTNZ8ywuKudjFzF64KPmD7tEpFrXNTWm6DQfJc1QvwtiUFN3
7797	payment	1397	1397	1678	1	1	4941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNVwqexVJgHzX9xtuGzJU13gTiEyR36yVhXKUQqipEMJjiVW2
7821	payment	1397	1397	1678	1	1	4953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVA3AMZsVP2QK9MYruGXfUC4YqTWPiKKTrFq3oUVYCBW3wg4xh
7822	payment	1726	1726	1874	1	1	1923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFSjch6n2yjRtVSSdY5Pk4maZ1oEQ4JBjFmVnX7GF4qRWES73
7830	payment	1726	1726	1874	1	1	1927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYv9Z31HDMPS8wBZzfrNuKzmMDdrWYd6hcVmomXBYotzKHgwbL
7831	payment	1397	1397	1678	1	1	4957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaZGUv2PSbBkkgbsbkVSCtdkXEggj8Gg9dgbKANHucnr61Fvp
7857	payment	1397	1397	1678	1	1	4970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyPQpq7DqaKBNgMhmavpcRCr1unyrj2rbuccvfXzEJFBGi8dw
7858	payment	1726	1726	1874	1	1	1940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ4eKs7LEU95NEUyMRHLdZAZe7vYmvPBCmYqDREmMPaai4Zvn
7865	payment	1397	1397	1678	1	1	4974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutcytfvotByyzewA84jVFt88ZSDPR55VtLMNAfeJsNSrHEGzk
7866	payment	1726	1726	1874	1	1	1944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMk3ERm2wbZGjAQpDeKYCySvTHxo4qzAEqnbWE7iQu5dEgV8t
7871	payment	1397	1397	1678	1	1	4977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMRq5XqKnQVWu3W7iLt3ZMA9KY7Qc1bHdpHb6SmPiycKMp9G5
7872	payment	1726	1726	1874	1	1	1947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPxfEWTn8bTA5FNAVzG6Gzdp5o6YyGEHy73S63uNk9nnzkE4Z
7873	payment	1397	1397	1678	1	1	4978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XfvzP3MwPhRFUuwBuMTSEkmK7K38tjQqRCc8KPn1eWAdijMp
7874	payment	1726	1726	1874	1	1	1948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7m1ruPDujQJLj5fw7H7b3Y6jWp8dwGDWss2GoSRC4YGALnaR
7875	delegation	667	667	44	1	1	0	\N	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93ysb1VxVBhkW3rsVAAHKBggucFKcvzzpE5R83M94KknRdUk5
7880	payment	1397	1397	1678	1	1	4981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMDLsEJkje2eqR72H2GCfa3ioUEHV1KTFcLUYVryb38CVKd7z
7881	payment	1397	1397	1678	1	1	4982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMRxnDjVUSHeHeZQWARKYbAmmjc6g4uYUp9hpiKvs37ggzAwG
7882	payment	1726	1726	1874	1	1	1951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxqYsNYk3bL8Zgfa82rfViUujJmtUCPFuX7E1Zmex1RsfbY4C
7883	payment	1726	1726	1874	1	1	1952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47Ar3fgkNkjhLcsfGjhFpLrFSBUUcYTjphgAbHVot3tMXFMD9
7897	payment	1397	1397	1678	1	1	4989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFnJ4S9sZhGwqE7uFnreVU85hK9fezz5jCSjyhkgXE9CYxMPU
7898	payment	1726	1726	1874	1	1	1959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9hmHHzba2p6hLQiX52RFk9KFJefB2ssnAVH5fdwiUM5ep6YL
7899	payment	1726	1726	1874	1	1	1960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjc46czhz1qXqoDM1aPzsBTj2aPdJMFta7PjiNa8E9PtmSNiit
7900	payment	1397	1397	1678	1	1	4990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DVJfEYvd5ttFHTmPjkvM3fsf5RVvWqAPQB2jTg5N7az37hRF
7905	payment	1726	1726	1874	1	1	1963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrf2mnmo2HbBnRebhLBnSo2qaJdS944aUBizkFwUBcNNJFQ66J
7906	payment	1726	1726	1874	1	1	1964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SwLHkRdzexCraVEXzUM5eGA8LfugiQY5WGWqGntnJ1Xtax6C
7907	payment	1397	1397	1678	1	1	4993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7MvLt7YTjLDAJ83i4QGCK6SwgCXy1sPj83sFfiwxyfXxkuEz
7908	payment	1397	1397	1678	1	1	4994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiNZtbUKJRwF44e1tSmP6j7TMVEzm9NBXmuBjYRB3PLaePSzXh
7909	payment	687	687	1958	1	1	1	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJoKu3yWFC2Q1PxdqXkPymdA4jtZKacioAaueP4NVqFD9twoSr
7914	payment	1397	1397	1678	1	1	4997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqhLwMLsFxUq9hyj3ygaoEvypuYbbuifJ6kXhNQyH47jJKKTK
7915	payment	112	112	1821	1	1	2	130000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimjC8byFb63AjUoSXEFw6K45se9Cq4DjJtg6JSn1aUVEtwKPX
7916	payment	1397	1397	1678	1	1	4998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTX8ECvGxmZrveUEA799eNzfbFfV2x6FccmTULmiYcvnn5emz
7917	payment	1397	1397	1678	1	1	4999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYfRnQUH2wqS8gymbgurYBsEKCiwEdMCE4PG1q3ZP3uiEXUiB
7918	payment	1397	1397	1678	1	1	5000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPK9szQQjDpZ7pMJBqfcFfGZ8bnesUwoR715Gu3Y22XBoErqBi
7919	payment	1397	1397	1678	1	1	5001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyxvwv4AmJu7v2N9RhCsAJ9FUGea1dCmdkqHgtdQbxK1jQY46
7920	payment	1726	1726	1874	1	1	1967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZ6NSQ68KqWNBxwvFDSvWcbD4v7mtCjtt94YBw1VKTvM5Hs4u
7921	payment	1726	1726	1874	1	1	1968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9tDqM1rQeVnvvxAf9RPj3zKNuhtyZ6uCMRfcXCHHpYqWuN8H
7922	payment	1726	1726	1874	1	1	1969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPyCRn36BfmDzB7uEzoiLd6RoeFvi2rr7kBKapvgT65HjiQD8
7923	payment	1726	1726	1959	1	1	1970	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkY9dLtmfZQPjkLMBLX4VJbJbWuR6veC97Rigt7uPcsHzVAaLS
7808	payment	1726	1726	1874	1	1	1915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKzypRgQULPSrgH3wppeqdREVckFyAidG1yePz8ThcaJk8rbL
7809	payment	1726	1726	1874	1	1	1916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAK62ZXxsajY7ipCZJoUtw16RYS6M1JHcYMPjDUeXNuhitAtQ
7810	payment	1726	1726	1874	1	1	1917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS4HcrqHuZjMDP2dFAhW9yCozGZ9FdMX7X6azasHLGVYHKyRyr
7817	payment	1726	1726	1874	1	1	1921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUa1FJ7aWCrmBFFakLFXEoBWfukWZZfCv13yJosDqWQXvoXoB
7818	payment	1397	1397	1678	1	1	4951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjpG78nnN4JU2QrAntQ4cS77R6qN9yAjxPEimWxUH5RZ47STD
7823	payment	1397	1397	1678	1	1	4954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtGfStsy7FJDah82t1ooyFG7X1PQWG6nZhxsG2jitoMdGT3zc
7824	payment	1726	1726	1874	1	1	1924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuh5FpvUh3ZEFvHUsMQodvFp14KgWNgPEXEjsmofsxQFw4qhod
7825	payment	1726	1726	1874	1	1	1925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVhfHqWwVCPxMJurctCf1bEWjcjBHZxRHu27RcHJYPyxkCmBj
7826	payment	1397	1397	1678	1	1	4955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6r6qBqkFJCYetBc6z7Q5euzVeA6kXVMJxnsAkY85RoBbjtuEN
7827	payment	1560	1560	1560	1	1	0	0	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZ4cHFpsfkdRMro1kRzncHdJADpjBQc264hiZc31CAq4tZNFsuR
7828	payment	1726	1726	1874	1	1	1926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAB6bsdK6w8ShbhJqKgSqNSYikTd2t2JZRmnKgQE3xqF7YKcF
7829	payment	1397	1397	1678	1	1	4956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3QRF1ZTck6LYghBfciL3Zz3bNFk9L8AYpte9VpwZLHpfqdrG
7843	payment	1726	1726	1874	1	1	1933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SHusHR2YhFFW66RFJfWu7zXEy8DK39WxvcwNqcbsQpC1RyFv
7844	payment	1726	1726	1874	1	1	1934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPm9vi9c6Q8wzNpLfCX7oLyebq5uRvcw55TvZn1tBxRahyH6x
7845	payment	1397	1397	1678	1	1	4963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77HJjBgargxmYsDK8JWEK6sHGqGQA22P3PkqaFaj2P6PJhfhB
7846	payment	1397	1397	1678	1	1	4964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEHcKqb4SVvaJkSsp5QUVdKkeMwfrAVPtoUiGvdSB3EjVgbP6
7851	payment	1397	1397	1678	1	1	4967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9oSuPbBXaFxdRZgrxJddGarYff1SHrgqUH6cxa6Jq25CWLcv
7852	payment	1726	1726	1874	1	1	1937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpva8merwsZeGGDUk7oT5TeEt4kK2kbe5wxX52Rppqe5Q5vvpL
7859	payment	1726	1726	1874	1	1	1941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXjtN9qaWQZiZRNQ1XmG4AnwLX3SVUr1YC8PrhPnb8PKiH1NG
7860	payment	1726	1726	1874	1	1	1942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcc5srDZev2LDWQ5zvudwnEAXVo3BSmnJMe5Y9GpNv7GNXtBa
7861	payment	1397	1397	1678	1	1	4971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4G6zEXbSKwp9P8XdybxAD8WSqhSnUTm8DGAvr1FDsCdVEEnx
7862	payment	1397	1397	1678	1	1	4972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYStZqBb9vKX35Y1c3rSCA7DCXn1WLfF4dzgyosC66FpddzasK
7876	payment	1726	1726	1874	1	1	1949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNUp2qJMWp9z4rcFrPa1NDX2KE7ipjcv85oZGCe9pD36UXUzU
7877	payment	1397	1397	1678	1	1	4979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJkYR7hAifL8MHdRAVErnqejaiudjfwCont9LzUMjp5FB67P4
7903	payment	1397	1397	1678	1	1	4992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtQ8Fsy6o5vvvqaCtmBLCJryj4rjJMnJi1skQoHLehnGQoJeD
7904	payment	1726	1726	1874	1	1	1962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVw3kVxQKttuZwKhBkuRT1S5JJG5De2zNtUXjjKgGmqQ8pnJnw
7929	payment	1726	1726	1874	1	1	1974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBzeG5oXeqSJpjddfYQB56TekF1oDJaF1SPmCPnHVsLKDJfZ8
7930	payment	1397	1397	1678	1	1	5003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2f5kopcEk5ZzUQrF4RtiexpHsMC7YPeADhL6zxsxHTcczvbkz
7947	payment	1397	1397	1678	1	1	5011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGPJKHp9JeVV72yVAzFjaR29CKWYGjeTTvzbzLTssPixqV1Yh
7948	payment	1726	1726	1874	1	1	1983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqTBYuu4WQpBo5QQUHmcu2jezVbhFs9CPh36tyMyGxLvrdH59
7967	payment	1726	1726	1874	1	1	1992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdYUF114tggx41pXwo444hFcmKebQF68ExmV2GYvySWEYKz9i
7968	payment	1397	1397	1678	1	1	5020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWBwys4MBcNZVYGDJCnMRwdybvd9tvY3fQGYZngvFxWDBR7BR
7976	payment	1726	1726	1874	1	1	1996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhn9HTnrDyJUSpSoUr6NFR1oZnFu86FEdqDt4MvqNVRFT9GgoT
7977	payment	1397	1397	1678	1	1	5024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvXo8CEnoNFvCb244qKRbsFiLhS2fuApb3f1jYZ5twQzp1teS
8000	payment	1516	1516	1756	1	1	6	1105766709	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEEmTDEbugr1pXNSwLWJwscKpPSB86PJeGzcxkxuVAR53McAL
8001	payment	1397	1397	1678	1	1	5033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2z57AWvyWBSQ5cc9Ywvmgw3JwfNGSf9omnUhYgxRfqPavmEyi
8002	payment	1397	1397	1678	1	1	5034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUMLGRiQuu8ekyJz9cySEfe5EamySDWT9q9QUsWSVX5ZrxmYF
8003	payment	1397	1397	1678	1	1	5035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGcxKC8dDAMAcRRxWunyPdq63avP5DMGCti3vRiW7hPA4Bh9W
7856	payment	1397	1397	1678	1	1	4969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsziToGx8nBfzMyHHoLfcUa7x619EoECofqkATbuQJ4vNDb7Ja
7863	payment	1397	1397	1678	1	1	4973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5gYZ3bzx5ux8NTVyotsRqdxn2iE8np9MGjPwDfVE3NBCJMTX
7864	payment	1726	1726	1874	1	1	1943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQC6Cct1PMtA7PYdLD9YRCUUBRKvNZCQdffhNxJjTBkjEb5ka
7888	payment	1726	1726	1874	1	1	1955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPELzz6mRJU52G8bdr7TAfzzM6LTieLMtWmva3jBukWYAMo7DK
7889	payment	1397	1397	1678	1	1	4985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2pDrLiPo9Cn2NSokzHJ3VCD8pZ6DvWmPFxqchtAkTVViLLjS
7890	payment	1397	1397	1678	1	1	4986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYw81fzRLADZKugyuqkhmugdgi4Yaj4jS5JWHZsMCmJ4ijmsKh
7891	payment	1903	1903	1932	1	1	0	196990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwZK84FHGG9dAP4txSWJap9dVToAtrQDNXLkY4PUdqYBK3c6n
7892	payment	1726	1726	1874	1	1	1956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbUNTCiPQ5GiJp8eU5E5d3ELMb6gvrFebS7UpDadK6SKkP9nQ
7927	payment	1726	1726	1874	1	1	1973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5V2RBEBjPvBsuDX3vsgnti49o7sAZK77o4EKG7xFbUTWBZMg
7928	payment	1397	1397	1678	1	1	5002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mco9jiKMdvKrwLmJMS4JEGKwcSaeuvjgu241FfwbELCpDVgX
7931	payment	1397	1397	1678	1	1	5004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPAZC5SLuyLbufat7hnnUguRzrubM4iAQBrja9t4dSJYV48iv
7932	payment	1726	1726	1874	1	1	1975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhbV4F36QPzMaf22AhXcxWeo1jL5y5g1e6pYL47ea2bdYrHL9
7933	payment	1726	1726	1874	1	1	1976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BZkX35DJGoZ3Gd2maVhsSLZ3vgFAVZuzGVWBFvxiAHnBf8zd
7934	payment	1397	1397	1678	1	1	5005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyEPPVgp8VyrKNsVKXjQQm3kW8EXVQK5go1DHb7VSFdKzx3K4
7935	delegation	409	409	1515	1	1	0	\N	1000000	\N	E4YvqnwQaecwNZwrQjHewwWhemqzAUZcEyr37x5BvhUPQd7n3LQL3	CkpZLrz6UQv32GGWWkSpZFCjcoTnL7bD4SJa9VSW7xdSd4W5mkKps
7949	payment	193	193	1961	1	1	0	282000000000	10000000	\N	E4Yb1ur9QwTLGanLZkXxK1aiqeYs8r1akvjGTddkBg7AecBLdfyJi	CkpZ4sha2R9DUoTM4xsReUaDE41duAhCm5izT4u3KUDtBrfN1Dagx
7950	payment	1397	1397	1678	1	1	5012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpy86vwVgZMBgUVkJpuJHc9CgedW3yGEqsSNjQo12JXKpBzYW
7951	payment	1397	1397	1678	1	1	5013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRTbwRYayX7gUjxuKV7q82DhMAFBJ7GXXd7vAq7oJLjtCFZNm
7952	payment	1726	1726	1874	1	1	1984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBoSYKSh5dDdbRUGtEZkTrRNzJnRdqzzUSuYYJngoAVx29vMpr
7953	payment	1726	1726	1874	1	1	1985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgstaRtmDydrMpcjQmdeJV2TbPj1hK38S7FEXoCzrqim99twJ
8012	delegation	772	772	55	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUit7KmovWxwRxDheMaD3V5TZRtJEZeX9f8qB9HSwi3ynFGhL
8013	payment	1397	1397	1678	1	1	5037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3ZjqR8pc82FVPiyeAB2BEGMWR2BF84Ts36X9fyc5D3QWxyt2
8014	payment	1726	1726	1874	1	1	2009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13A7ieNqbFEamLS1R2u79eD3ZjStFYwVjyKt7gVDUhf7Xtt2q
8021	payment	1726	1726	1874	1	1	2013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yZr4nW3hpzqQBmUk76pQadKAn1v8iHri98TxYV5cNn2D2qvi
8022	payment	1397	1397	1678	1	1	5041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHftUkQ5zuijcVh6XU4JnoKzQqp2Z9jeiQoKRqFUpmjuxXy9K
8023	payment	1726	1726	1874	1	1	2014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqttyV9cNdvzwGECwNoyZT4Htz9WzouyuXw1pgmjNDoZiNJx8
8024	payment	1397	1397	1678	1	1	5042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPFMYE8wPxEKYBJAGUD8FCUzBJRxBp18QZwe7oSEtvZLP5CUR
8053	payment	1397	1397	1678	1	1	5057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxnyEz8UDUeg9cYkfErrEXrJZS8CwhxWf1dHLNLy8dyLgVe9r
8054	payment	1726	1726	1874	1	1	2029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuLZJNtg2989mr4Snhchdj1Rf4bF5jaBqwQHCakTiWfaTFjfJ
8067	payment	1726	1726	1965	1	1	2036	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZVaQwkKvxb6jauqVVRqAS7znK3trGFsrpD5VCEkG3D1er2BMmX
8068	payment	1397	1397	1678	1	1	5064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaK83ZTMRNWq9LP4ShbX6hGYCG6no2ZK9af8PbUU96iUnS4vTg
8069	payment	1397	1397	1678	1	1	5065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENQrNWEV9zViDdYPU8F8Qojae3ziN8YVU83p7tVyHV643oLWe
8070	payment	1726	1726	1874	1	1	2037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFH9mEYM6iik4ozgUCjM9sqqffhLUYZ6PeZWnrwG4zAUAprtpo
8071	payment	1726	1726	1874	1	1	2038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBXkg6Cj15yxbT3LpLkYPF5Qhk3jX7xjovdRgdL2uC5Bh66Xc
8079	payment	1726	1726	1874	1	1	2043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKCFH2BvQt7JSazV1oaiq1QTCRtv5TSR5SQvvTZAkSHUBwt6S
8080	payment	1397	1397	1678	1	1	5069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5SqKV5NTavDqeJdeAhdVt8UTpFrydjcadgcozrYfhzVhjNku
8081	payment	1397	1397	1678	1	1	5070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFBCx44CaQXwmdcBZnNhhehKMiLgjvD52VNd4EhTscXkDxfDEQ
8082	payment	1726	1726	1874	1	1	2044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBvjz712Bb8wy1DfBuXiiRkGKNj6jYtdGY2HHPrugdxC9dKSQ
7884	payment	1397	1397	1678	1	1	4983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46Q3gDd6KUcRVSpQY249pMXiUj8WaPu2PaxyTU6EpAH9XPwiX
7885	payment	1726	1726	1874	1	1	1953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMzBbYfKH722Nux1zBsNXUHBH9YAKrFAfW7gfDwVekmgsdw9D
7886	payment	1726	1726	1874	1	1	1954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtM7aTtg82VyzM8wtCgCgE6CLeEiaxgjbv5jJH6ukLqNVLqQi
7887	payment	1397	1397	1678	1	1	4984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYtzbHwijPBh6H9fPGaEvT64z5gz2JKUdt5dF3nhjeFgGQw6f
7893	payment	1397	1397	1678	1	1	4987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqLz9vSeMz3NdMcEaKmLgxGBTHPfGrQUPmMv3cppUd8beuXwu
7894	payment	1397	1397	1678	1	1	4988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRb5gWnEyDGds2eZfWQqgZgpchaNqgUycWGeWuJefs27nbZbSN
7895	payment	1726	1726	1874	1	1	1957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZLyPzVSK31ELkEtWSqbMFcp8LJ3DnyVSc3NiD33JkqSQ6Rmk
7896	payment	1726	1726	1874	1	1	1958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoZYQnSsNrAdJ5JbBmEc45NnUu4H2u8rjUSTMCPteWcz5VpWh
7901	payment	1397	1397	1678	1	1	4991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtvKuoMqe5Dh4N1Jo8yWyYpUzSH1REgyNy5Rxi6EqAvX1WGnMN
7902	payment	1726	1726	1874	1	1	1961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJtap387ZLysyzUhGaHiThBALHcKjs8ZnoPYXwXS8UxmFfYWS
7910	payment	1726	1726	1874	1	1	1965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKAy1PztWmBntKAJMqXfCnE8WvptmzccXRUTkQcJjL5GqoH3K
7911	payment	1726	1726	1874	1	1	1966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzihPZ6CRwj3VZXFdkjRehZRJMssYgpp3jTisyjWFf6UvEj9r
7912	payment	1397	1397	1678	1	1	4995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZma2CLHJ1XCkGp4Nwd4aDaKptfdxwr83bdVhB3nC5fD4ay4Kpr
7913	payment	1397	1397	1678	1	1	4996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXscxnKVHC33DXBFRELR7A4ifHXziXxCG5sdkMNEykuZTfsi4p
7938	payment	1726	1726	1874	1	1	1978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivWGXVse1Fnog5VnRg2KLMfDf7TjeYGAu2kYSQbC8mYpkUbn2
7939	payment	1397	1397	1678	1	1	5007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyuV5pTwhucfkCKHq8k1qFcUy3sCaAssQL1BTzgnRMgHapwvy
7956	payment	1756	1756	1516	1	1	2	650000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFq2QzKTsC21nf7NhoYoxUT6zkXjatAAmjmGnrny9RRUuNPmJ
7957	payment	1726	1726	1874	1	1	1987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUhjTsvh3ZSj8wuDycs3gW5MT7stA6iDfbkEeKniM1oVpoecb
7958	payment	1726	1726	1874	1	1	1988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAtpFcPEntos3DMHRnvDBtNF5foiH3fCEZba1pquvQEZghGZe
7959	payment	1397	1397	1678	1	1	5015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcyyzMyXxJRuTXvYzyhXLRf6X82wyRztSpqXmVHs14y8DzhVq
7960	payment	1726	1726	1874	1	1	1989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAUz3F5HbwbnL1H2YWBXYCRaLGPXVxy8bXMRW7Ce7STD4uNwj
7961	payment	1726	1726	1874	1	1	1990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCJQWCkUvayUB6BfrDsX2Ym9FFR8Nxh2XsAj64zakF6PQgs1F
7962	payment	1726	1726	1874	1	1	1991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGcmmVGaZxFfA5LbUh6jkLdwftHTJLjSiXSjuGiNwWdQenwbH
7963	payment	1397	1397	1678	1	1	5016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHboBZorCPhtqCChENGEtHbqLv6ooePS2L2c1NYQU8KZtD58j4
7964	payment	1397	1397	1678	1	1	5017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYok3ujrqPivL8NoXsbPEZPFN7mJwLDUAkJ1axnpArcuqeyHN6k
7965	payment	1397	1397	1678	1	1	5018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbeemu7kuFg3HxEGoFfxXjFn5qfVRH2oQVCcA1YLJDDUYJwHa
7966	payment	1397	1397	1678	1	1	5019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGsu5Svu3our76RxUHHadYuZHFjWANxkVCApj2NTK4jH3Hhcp
7974	payment	1397	1397	1678	1	1	5023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4apHCXSxDpA3e5aWB3BtmEFZ13sDyKUzaqkDWhCkFAs6ZxR3
7975	payment	1726	1726	1874	1	1	1995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYD7HbGWUFpJwSeL58un7oLpbupueq2f2bTKBVTSMxJgMBdvhW
7980	payment	1516	1516	928	1	1	2	2378770079092	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKSZTXJHaWLK9gmFj9ixT3GXi6vUybkhEvFHQa6vYmNd3ULwf
7981	payment	1397	1397	1678	1	1	5026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2rPXkdK2bURTYrJ6xei8aftcAywXk8FtFXFrwewQAJZhhbEEG
7982	payment	1397	1397	1678	1	1	5027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDkCCqke2yyDJ7SgniEMnYdGUzyWF1TkQn6u1hKr6LmxPhHszZ
7983	payment	1516	1516	1048	1	1	3	4262735600448	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AGhTFCpyKeRtfYXCTVardTQe2pT2TbHnJfZfuAYJTQFycGHf
7984	payment	1516	1516	1168	1	1	4	2876152650622	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmkBW9eeTiDaGuu8kojobRP3G9D5FeF5cr2JowLHDfF7xQivp
7985	payment	1726	1726	1874	1	1	1998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sY1LdWDWohnn924QaaizMTiG5BxfCLw4c3UZPuNPctLAqNGP
7986	payment	1726	1726	1874	1	1	1999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qPWjdMbi9HUbCRwgzkywfqJ3Pz73QCr4iH1xmdKsWvo9K7Ea
7987	payment	1397	1397	1678	1	1	5028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGf5L9AQTVoj1vQ9RnEyJBLSojRX3ofK3ZDv7XJn8TaS3gcpKf
7988	payment	1726	1726	1874	1	1	2000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6vmQreZHaKFiRDf24CvsfgpmKjAXptLAwv47eh77AgUQtK2n
7924	payment	1726	1726	1874	1	1	1971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRM7aeqnxvHeDdnsLT8aEnsGQoPxheTTLWrhFQX5iAPcooxeZ
7925	payment	1726	1726	1874	1	1	1972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVNKRumEGiVuwrKkqwsfngBtsGqwsRfdU1H1q5dpM5MngkzEG
7926	payment	687	687	1958	1	1	2	699998000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTALDUnaVmcFXj7hKhVUSPCXyARc2QrSvrwWhLysHK41ZEpuF8
7936	payment	1397	1397	1678	1	1	5006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgaNUQ6Vj6chqvuurjVi8xDnVUXewBeDQphDzyqJkuqZ7THen
7937	payment	1726	1726	1874	1	1	1977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciXWqjD2sW2fKQF6wtNTbQj8Hp5YPatDWKYbZQ7rWF7Sgeab3
7940	payment	1397	1397	1678	1	1	5008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWAJc6g7tr7UY7SVUUQmiiMtip3xwU9dmwVKkqaHGpni6TbFa
7941	payment	1397	1397	1678	1	1	5009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1rJyXGhWZZr8aLBEJxi9UoQBe1HTvUx4GxqDVLm1RUBcsDHzv
7942	payment	1726	1726	1874	1	1	1979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdHUsHVrdEPWCa6jx9JeK3NqVRJ4WxFH4ie7dc5Y8UhSaCztz
7943	payment	1726	1726	1874	1	1	1980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAp2bkg4N14ce1eGRRrLC2oD8SrtBM5dDV33WGRzxDcELLbsH
7944	payment	1726	1726	1960	1	1	1981	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFeWFdHv4Ffi5PLTREAWjRQRDRQxJ96w2VQjQF9XqbBN8fAmbH
7945	payment	1726	1726	1874	1	1	1982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ589GCUo3PuQNsxk75WoxKXXwE3v9krp1QKnXqG4SJnbkkJztK
7946	payment	1397	1397	1678	1	1	5010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHe5NtjjEHNVL55BFemnjESrXK32oVFu5nyLK9cZH56jmyvoB
7954	payment	1397	1397	1678	1	1	5014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVocAdvv5bspf8J6EmtPUGv8rDN9r9vhGZGDfn2JTfnsEcLnuy
7955	payment	1726	1726	1874	1	1	1986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGarjbCPt85ajFTKGgsKfCH5e84927NzXDj4RLV4HV6QjF8zHC
7969	delegation	1885	1885	1483	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33qV8ed2caWSHs9pz7mQqzUoudxBGYKZQ2Q7uzUp1DUrK6dwT
7970	payment	1726	1726	1874	1	1	1993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxTH38S9tEoWDYqGbpJbkf9QswmdixC95q1n3n5ALFk6RMJvs
7971	payment	1726	1726	1874	1	1	1994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5o4YmidkTJzWbTyw3jH4cG3mY2pYCb8d4YVsW9SZ6xaZ94UcR
7972	payment	1397	1397	1678	1	1	5021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa96tFbnUG1fAc7zPyP2SUc5HbfKGHHxJF7o5N1PXw8Vvtt8Eo
7973	payment	1397	1397	1678	1	1	5022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbf96ZBKdAQhvE3rfEEGEiPckd1gCp4uqxc1K4HEGcTQrowSv
7978	payment	1726	1726	1874	1	1	1997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDCNhB46n2LZU4SbNCaKgVWMPwPrwiAD4yGkTb8psSxfpHV9P
7979	payment	1397	1397	1678	1	1	5025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iwrF3PLzbjtNSARk1QMV7N6wiybAZKbefREmWkfrrhFf2atf
7989	payment	1397	1397	1678	1	1	5029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6q88MNnGX2JCqrFnBNTEk7VKrhCcm5sudHATXhX1VWQWkhBUh
7990	payment	261	261	1962	1	1	0	282000000000	10000000	\N	E4YXdwR8uKtz8oMtzcsWzvE1c6w1U2eSoPG1AeLp6JgRTCQHcpJQ1	CkpZtyAdEZTxgJnK3tNLVa6gtqFfnH2S7mPcwyyTdPRbmCr2aiHzf
7991	payment	1726	1726	1874	1	1	2001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFHoKJW4wxcbhXz4ncGLcTAiaf9GeuMDjwqbRj8rxjeUp3vb6
7992	payment	1397	1397	1678	1	1	5030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVGkNPYrtbjdhqJ7iRJVJr1CnxD1J5buJ3UVLzkpmnVronTYc
7993	payment	1540	1540	1963	1	1	2	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtS5yS2727mxMs56TJPGcobWiewaZbYLMnu3s9u8dAV4izGmwD
8015	payment	1397	1397	1678	1	1	5038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMiETe8f255U9MwhxPxPKdVGFFAJ14bBFZ1aepxAQERfNNVaV
8016	payment	1726	1726	1874	1	1	2010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ695rc9jFL1dwb54Uca9moL8dVD5tTgAFbKYyqhCxJAR3WzXHE
8027	payment	1397	1397	1678	1	1	5044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVjwinsgai5N3vBMn67psLMBPPqzyw2GcSnfjByKDy8Fmnj3F
8028	payment	1397	1397	1678	1	1	5045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1gQwr3r8MUVFcgQV6argw4b8AoTFyBfFsva5rKo5RXp9y6ip
8029	payment	1726	1726	1874	1	1	2016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQXD6giNMqK2dnDPEei9wrvCgvdwbrsDJMREWgVfAJ5zk9qq9
8030	payment	1726	1726	1874	1	1	2017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ821GAEmnsNSCv6kMujwF9QhiYKGw2fSTr6n4DXugv7f3jQi2D
8039	payment	1397	1397	1678	1	1	5050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbianbbz6aoF7YxvxBmFeFxje96oEyvr5s6f7WpKrE8PsJfUi3
8040	payment	1726	1726	1874	1	1	2022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEEJeeLdrbFEjeNkHmVh3wWYm3YHDqPbmrnP1FNtkzqruSwzf
8045	payment	1397	1397	1678	1	1	5053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfrtcrtbhiRTytEJdDLaMmZFiFJLo3vzBN3dgjy3kXBgY8eJr
8046	payment	1726	1726	1874	1	1	2025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YzBBeLrppwNjFNFNz7epkkuDroVNjhhqeRFBqk1nPSAAFMJ7
8061	payment	1726	1726	1874	1	1	2033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQnpEMCu3tomG439boummv49vELdReMRfqW2dZoa9NuWtmKoT
8062	payment	1397	1397	1678	1	1	5061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxoSHB9DwWBFKNN4sso3foJpKfahuvanakxaRc9g3ZZyFCW3g
7994	payment	1516	1516	1294	1	1	5	8014655094229	30000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Q7Uxs2suowLfJDmu7vxX3R6T4wovwPdWoXawbAqgLuSD9GWY
7995	payment	1726	1726	1874	1	1	2002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxyRtGB7TKoNLgvcUaqMrrBqHtz5vapRPEAH4VSGfsJQXmSjx
7996	payment	1726	1726	1874	1	1	2003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABfX9FYJyKBxr39kALBtEjC4ZQRWFGp4jryt63cfPe8NNnTxk
7997	payment	1397	1397	1678	1	1	5031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfnVyS9vawRLHxFbH1pnaHd3As2bQVXHxPNA2pEY4cRGX7SrU
7998	payment	1397	1397	1678	1	1	5032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoW1qwrw5yDwLEPdmKxEZhgspwFmeyeM19fC8VxDEkeTzMQNL
7999	payment	55	55	772	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqk7UMXot8AkpGzkiFCp3XLG1faxS19f3YHBSYn5Qe3yv9CdiG
8010	payment	1726	1726	1874	1	1	2008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX7SJinKsqLFt4WrH2eJzmfi9taXsXZyP4HfkAY1GKhe6abquh
8011	payment	1397	1397	1678	1	1	5036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqUTbHspa1BzjP1Rcrnsfb4n5WW9MrQyvxQTJJ1s9b2Acjbjh
8017	payment	1726	1726	1874	1	1	2011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3vnVpLvJK82no3XAyneZNo6f4PMapkisEK8GTtS4y8U6nHwm
8018	payment	1397	1397	1678	1	1	5039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdo8pFvBVv6GtApdWchEmVDaVa8ikMU83H7GkZwrTfifF5EhP
8019	payment	1397	1397	1678	1	1	5040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YrLdEuBnPWQi5hR7MqdT5Me629BU3QokjPi1tC9X6DFiNtL1
8020	payment	1726	1726	1874	1	1	2012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmLdVyxczA12fJ2RkakDHQN73yxqKTXJUFPugLdkwS5b8xdqF
8035	payment	1726	1726	1874	1	1	2020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXZ1P79H1K81P7T2p1YfmHXMBxgQpWgcBpr52rEMSjDurLcFp
8036	payment	1726	1726	1874	1	1	2021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFFo57uXLkN8YPBWwV8jxQKEVeHxxhrNPBjwN7x6jW1X9Mc5T
8037	payment	1397	1397	1678	1	1	5048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xFnQwqGsX8QosmcxME1E4riuTkM8R98t3UHMMWmfCYRpNUWf
8038	payment	1397	1397	1678	1	1	5049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxE2MimmmnqZzaCUGDzHH6hQWtenzoNGf8rSVMs5S6d8aEbTf3
8041	payment	1397	1397	1678	1	1	5051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1WaFMWdHQHTHgqHBNDKFkbynES6b5vbJqDBPLkQHnfFzE8Cy
8042	payment	1397	1397	1678	1	1	5052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RSDBRbtfEpnq4Ev1TuybQCwn8DUf97kkSRWuNRVSmcHw2aKn
8043	payment	1726	1726	1874	1	1	2023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuCLyRZozyDqrLax1LpQSVLtAthJYQBwn1jWDxyPYQ7XkLWjq
8044	payment	1726	1726	1874	1	1	2024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9FRCw91zpxwWB4eKUgojDe8ADJqgUuXNxwC21RWNaG4BzpSu
8047	payment	1726	1726	1874	1	1	2026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53stzJrwupBng6v1ua3DjLhSipDjdTWep14aqutrAx8mDqkw2
8048	payment	1726	1726	1874	1	1	2027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKhsgXGVAHKnkcAN2p3S58oiDr1uiqvzZfqCiEQ3ai6nWHKfy
8049	payment	1397	1397	1678	1	1	5054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7fP1KYTJTCDwfMs11giTYne7795vUxiyz4rW7rwDF7KMVGJM
8050	payment	1397	1397	1678	1	1	5055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5Qi2MYcDH5eGZsXMQ9soqNWa5aR9AzHedVMb5MMnCSeACYRv
8052	payment	1726	1726	1874	1	1	2028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKUajZaZLq4NcFMhr9WcfKUqGo4Tct8hgYqpAf8tgco2pSpKV
8055	payment	1397	1397	1678	1	1	5058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSEqfhHjN2YNAWsupD6D1K8gkCZQWR5E2JEPJkgAAREXqBbKv
8056	payment	1726	1726	1874	1	1	2030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnTfHLhdt7GrG8fXJbiEa7oRTTCqpqNWdEP3ykG6QJPNkTdUf
8065	payment	1397	1397	1678	1	1	5063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33j1DFs6MHbz8ydTVYtJSYKZDuxQqL3CaW4igMrTJmcnK42J3
8066	payment	1726	1726	1874	1	1	2035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8rDvgxSYbdMNhP4J8AqQHqn21aowZt1wbCwJqy7y2UF9CAW8
8072	payment	1397	1397	1678	1	1	5066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibDadMgf8ELXuBkknHqYrVF9PWJmu3DSVB8YnPBAj9NDB2uak
8073	payment	1726	1726	1874	1	1	2039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopsSBX7d7ry8M82P5aeXYPoWbyHyxCQbJV5VCWA5rmyRghttZ
8074	payment	1726	1726	1874	1	1	2040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqViG7b3HonS6DpFb87VTe5Yej2XPiL4m6KEctoThRgUiT7ESb
8075	payment	1397	1397	1678	1	1	5067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NcUfc4VME8JgD2tHg3pV5Cy4iL8HC9Q61i6VvoAZpA4Dq7wd
8076	payment	1397	1397	1678	1	1	5068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKdcNWtYxRiVyTxKvst8qGha9mq1onutj9pja9dbmKg1waPMX
8077	payment	1726	1726	1966	1	1	2041	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHt8Gwgt4xw5siKqMJJubSVX6szHirjtFM2DvRY6PPwsfyEGuq
8078	payment	1726	1726	1874	1	1	2042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecfG1R7s2CKUdmRDEAQ37a2N2Cw4sTFaQY4PpjXDHzd3XhRji
8083	payment	1726	1726	1874	1	1	2045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakj7jbjjrgkCiN4ySqx1qd8NmhvSKQLE2XeWbqAjnRhiZtoZC
8084	payment	1397	1397	1678	1	1	5071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHys5xq29byaVe2ahMPoE3p4KoxjBdjn5TyrJaYqaE3dNqvqDr
8004	payment	1726	1726	1874	1	1	2004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3A7GoELK3mi7c8o5cAr2FJJFFpiCDZWNqCbTVjKrLKjYH2gDc
8005	payment	1726	1726	1874	1	1	2005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimLDrEUypcbALu8csLAe16XAm5sGodxcAVueaAjXvcVdvKEjb
8006	payment	1726	1726	1874	1	1	2006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qV1iYRTm1QSPt2mhe5j4DoVehr9ryzUUa54y22aJKk8zVhxq
8007	payment	1726	1726	1964	1	1	2007	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQuk8FRuUHnFELCv2kQAr9dCcDrmEiDUAEfCFv9n3MS3ajzgun
8008	delegation	1963	1963	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWCXNhzqYr1zKcGYHTjkyFHRkgxiaCRi8S8eaZVqcCaXPBeey
8009	payment	1540	1540	1963	1	1	3	365306000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pnUjwYmz4mxEMPgBbxGDKMuYLcu699untfnttUSpxBMvbEMP
8025	payment	1397	1397	1678	1	1	5043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWzerqiB4FiZ51tZMariNna47EpNPptPdByCvsW5XuFTFBuPf
8026	payment	1726	1726	1874	1	1	2015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY6ZrjCrSGto5ZRJtkARXAfvmA64mb6Q17ECmLxVTjxuwfW24
8031	payment	1397	1397	1678	1	1	5046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZR5HF3RF9ZSdf1uvoWLQg5ZfmvtXVKdCgJRL1C8kircTQGcSb
8032	payment	1726	1726	1874	1	1	2018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaRsh13KY8rYx9twy8rtiWNTFpH9zv5VTfyjB5ZMRweA8FinC
8033	payment	1397	1397	1678	1	1	5047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vdz1j3YwCrDof3o4AzSncb3im5yTpE6xB4FiQCSSTUgQPCoU
8034	payment	1726	1726	1874	1	1	2019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQjEr7pBd8U8u8w8PrcYCa5NS9oJ5ZDC5mojtoGGUFZ2hfRSC
8051	payment	1397	1397	1678	1	1	5056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBtDVDWJSVfwB5vTjjYnDhAL88TDKNNRAxnNxXv1Go5cnoxUv
8057	payment	1397	1397	1678	1	1	5059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZ5gbB1Pjp8xCeedaAb5afJaSrJgiDcEGKoqR7bTPxbzMbkeG
8058	payment	1726	1726	1874	1	1	2031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFLhkmRb3K51h3q8rgH11Na8eyaBLdJAyorVJrYAkYrJYPcDL
8059	payment	1397	1397	1678	1	1	5060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJqsgVzLjmoqwisgakfSnoE5Jmcx5finVy6HtPTkyigyMNqvb
8060	payment	1726	1726	1874	1	1	2032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPxNrFVJ6MoKa4c5C8ZDdhqqnATHd6yNEkMCbjswf8sM8i4UZ
8115	payment	1397	1397	1678	1	1	5087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjUtYfx9HJfCnHPrx6tucgRq14rNE3uic7Y1whvMZj9gnVFyF
8116	payment	1726	1726	1874	1	1	2061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFJRmvoGy25zQisASH3eHRh7qmRLN3JHdxv4wHDDPnzAoE9xG
8151	payment	1397	1397	1678	1	1	5103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSgpkDJQAjfF61cXPadd7s2SKyU4eZG47aCbisViRQyb3GnhF
8152	payment	1397	1397	1678	1	1	5104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGeYuXQL84XyyQRK6MGHtjF49UQHCyTps9Kp8Ps4r52JZ7J5B
8153	payment	1726	1726	1874	1	1	2076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmAoQb7uX3wjTKAjuJbGgj1dVEi1AvKMxGrL87YXtXidkdCNM
8154	payment	1726	1726	1874	1	1	2077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxENM1p2uB6STvvPHmrvacnj9Yemf9GYsVSaJwzQwNxC9waeP7
8159	payment	55	55	761	1	1	1	3857250000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJPTLLfY3gPXqF6UWUZ2jSq1cybAZymCJEqcJv15KSCx18CUL
8160	payment	1397	1397	1678	1	1	5107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqFtQQTFpHtHENuBgKwCwTE5npMk8c7mCSvWh5Wpx2AdaaVWj
8161	payment	1726	1726	1874	1	1	2080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsocYxpWjnhwf9f27f8dHB7jD96CJhV4cPiv653G4x39bveyY
8177	payment	1397	1397	1678	1	1	5112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwGsTEkKNF3fkTSBzWEuQ7V9rTS14csb6oyRpug9eyhDhyVWG
8178	payment	1726	1726	1874	1	1	2085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHU52peKzbYkSRpPQ1sWJ93D1sxrT11tc59MLpCAXxn8WS1Yev
8220	payment	1726	1726	1874	1	1	2105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWhUEFAdZBQ5UxwYcKo5ZmsiQ3cRgc6aQ6gjHuEssUk5GoYCV
8221	payment	1397	1397	1678	1	1	5132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa449rSrFjboQ5LnDHc5d6qdQ59CaDADJfMC8A8znV2wEJ2EmGm
8226	payment	1397	1397	1678	1	1	5135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCq1WiS5m1KZqLrUrT2ECwbo89YzKa6dt4rRRxuHzwj7ZqejJK
8227	payment	1726	1726	1874	1	1	2108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchvKsH7mFCfS9W4MUp7v9jq94xszzDVXyzpkxo6tvN5wB5EMX
8234	payment	1726	1726	1874	1	1	2112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBtuwFYA5cuYzfB5s8VgE21CXf1gD9WUxUbLqLrvcN19mKnBo
8235	payment	1397	1397	1678	1	1	5139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcaqi5L3DRFbfaiuuHEeudffsg5yywkZ7kvgg2EeAJ3PsZCfQ
8236	payment	1397	1397	1678	1	1	5140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYw1nV2wDdWqBxtRtMJsZuRMU4LkSB6KawfdX4Xx6pDTLGMcNN
8237	payment	1726	1726	1874	1	1	2113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvMbm1NQZbfM4C3vVCwJmAqaFCu3hVaSDkACg4gJ9gAJep1JU
8242	payment	1397	1397	1678	1	1	5143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVfbMBsNoV2YGZMFiqVLSmrkDRu2zZN7doRWyQAXz5CGt6Ws2
8243	payment	1726	1726	1874	1	1	2116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXuc7NTm52jQUE9xvVcSKmYpBsorkGCnfJ69g39TtaCJgwNnD
8063	payment	1397	1397	1678	1	1	5062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXucA9TbEjrVjZRV7Whbv7Xbgs6ekgoKdR8KMHQaKzdSYAejuP
8064	payment	1726	1726	1874	1	1	2034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZdwz7yG1oC3QmeXr3W66nG4GPp1HVMsCPLw18YhdhJBNpYzJ
8087	payment	1726	1726	1874	1	1	2047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerLiar5zz4kGewceTUqpDfWAhUeoFoevXw5RyNL4MZ7QeCML2
8088	payment	1397	1397	1678	1	1	5073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYta5Zve269CorTS1we5e4XzhLbH6TnhoMRN5oHYiLZfbEWmFbU
8089	payment	1726	1726	1874	1	1	2048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33ezusun5vamTkbRAF33WcjfYiezuShNAng6jkyqrGDggcQJU
8090	payment	1397	1397	1678	1	1	5074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQECDBVZx9PqpLuWwrbbXBbw9B1GCV4EoVBYtW7i91thdbkqdj
8099	payment	1397	1397	1678	1	1	5079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyAjKJTaRKMZoPVrPD8Rr4MCN1nf2gS2xnF74GLPD24txr82i
8100	payment	1397	1397	1678	1	1	5080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB82z2AZsanNJDAwqZPp6CaEDmWDhiUF88eohy7qAXxRP3MQbK
8101	payment	1397	1397	1678	1	1	5081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdtMri73H9P5FWzdoe5wRqqnNQhnr2axy5UvDo4vS4ykxxkZK
8102	payment	1397	1397	1678	1	1	5082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnTyfeeWtvTZTVvhGym8x7jHRHcurdW9DN8CE9KoDknCitNpc
8103	payment	1726	1726	1874	1	1	2053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYcyBaras3wT5EnP4MM98pKg5NXZzNTavyLt7ZujpGJBqaVsS
8104	payment	1726	1726	1874	1	1	2054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQGrWisrXf5iZqBJfgrXazzbtvWRxqwFHeBiYJsYkpJ5h7646
8105	payment	1726	1726	1874	1	1	2055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Vdw8cFvvdWBh99hPppmxLtVXrSYyHkjKRzBYdmp1edTTUKaQ
8106	payment	1726	1726	1874	1	1	2056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXGvD6NNmxGvb3NtgrJBHdnNJqtREe7xc9z7pCBSsaxAuUSac
8111	payment	1397	1397	1678	1	1	5085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUPGL5URbNfTUhWmZGC1EPhrpj8ixM5fmpQzG3wFJaXjM25GZh
8112	payment	1726	1726	1874	1	1	2059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xtn5fHeGF3C48QLjd2FqB4X5mVeb3purczmt36Pvnnv4wDjj
8117	payment	1726	1726	1874	1	1	2062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHHh2kaeuRJtorEKjFhrMp1gRzsWNoNhoEPF9CepRDMtBGpr8
8118	payment	1397	1397	1678	1	1	5088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadpUYHNbrEJb8mFkqA5d5R49BcPuambHUbfS5nN6ayAhDcyUu
8119	payment	1397	1397	1678	1	1	5089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5u8Uf1XPgqbVxfaruqJMcQvHKiAs81uCQpSc3fG2oBG2S56z
8120	payment	1726	1726	1874	1	1	2063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPvps3g5GhTw1qEvoy3QFHJWvZN3kyH8VsxUjArqm8Hzi1QBV
8121	payment	262	262	277	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTEKuSPuzv7wwY5J7DxXMcBFdhAuaGrQTJG8i3WAdXFhTnnip
8122	payment	1397	1397	1678	1	1	5090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewL2EVJguaLcbj7Y5DhzgrxvxmqsWPcVbWUVDACRirE1uhKps
8123	payment	1726	1726	1874	1	1	2064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTiFjjXfBjvcYeh522MQWomRHydA5hNt1uwQWXxfxkCBReAp4
8124	payment	262	262	425	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NUfDS5BykdQZJBFVwKbKWBh7f5AVaxAJ39Ek9NGxrgeToNo3
8125	payment	262	262	668	1	1	3	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MqcogTks3gLoHHsR8pixe883rV3du64xrmTTEG4TAfhPKPzW
8142	payment	1397	1397	1678	1	1	5098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzUyL5QD1eFN3qaYh8k3jaNuaxcmGZWXdL7tR6vkTCdXXDKCW
8143	payment	1726	1726	1874	1	1	2072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdbX3B1R36SBK92v2VZM5UmPGGXdhvkEg43EGccGpoDNfKhzv
8144	payment	1397	1397	1678	1	1	5099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZic33LZNax8tkPSHqYPB4UrCb1DNiHwAhSt1bKtDWEEKbUiDVX
8145	payment	1397	1397	1678	1	1	5100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHn1q48ojEUyzexhFk3ZxtUzr8gai9xougZLquWgn56Giefn8
8146	payment	1397	1397	1678	1	1	5101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbvoYAubGBdZEresuyPruZ6xnPmyUqTPxHLJuaCeBMjPwrgD8G
8147	payment	1726	1726	1874	1	1	2073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwC1wRCfLrraik5TyCuFNC3nZh2ZSdKUFo6uNNWsBNeaiydwPL
8148	payment	1726	1726	1874	1	1	2074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxp9mftSgQAwN9PeZFtsvakwtdESvn9rTvwZzp5dyEFne16J1
8155	payment	1726	1726	1874	1	1	2078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLapTs8vZHS8RnbGh4ZS4r7iimaxaBs9Bh7u5zeuDsnfhdxt8A
8156	payment	1726	1726	1874	1	1	2079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinnrnuSUi4eRyM2UoDJq12XMMW2MhWFDH1LnJkjusQXFiV2Qe
8157	payment	1397	1397	1678	1	1	5105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbcDt2FyTtaGsKXedCvdXGJ58vt3bZnnfASPtUkFE7zLQdVYD
8158	payment	1397	1397	1678	1	1	5106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FX433sVBJyLizVih2nnNCmHocLCTVEDd9DtPjjq8yVGj2Yf2
8173	payment	1726	1726	1874	1	1	2083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhKP1awkJszXLq5ErZZTa8WWjq3GQBHLLL5wLrh3kUgZehDGjK
8174	payment	1397	1397	1678	1	1	5110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFjaSNAsHYRPgx975F9eJjLdTVXjtg2yhxwCKf6hwEGfGxbLs
8085	payment	1397	1397	1678	1	1	5072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqegsvkpRNTpj2JaiTG1rPruQCxKQAJrEmyUXFRaVu3dRrPb4
8086	payment	1726	1726	1874	1	1	2046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMKwJ2TVV3uUoNgU37BAur7AaxfmxVcbGte8gv7DaEuJb7SoD
8091	payment	1726	1726	1874	1	1	2049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRa4aVY9DbfwyX31LDEqTV5q6tDxWPr6XuhD5zWLmQtRFbpEe
8092	payment	1397	1397	1678	1	1	5075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYQv176eYGqHphu17qhwqsE7g23B7TxB3tSGzS6tyki23xcZV
8093	payment	1726	1726	1874	1	1	2050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQoJE6Gkimh8wqcS3T4qWqsKBFqLXPGZp8S1HFHE4apo7FhKW
8094	payment	1397	1397	1678	1	1	5076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRFuka4SH6Mx9kfEVRxwNnRdhq7iAQDxDVkPXttdXkJ6oDduF
8107	payment	1726	1726	1874	1	1	2057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghdANUioi86hnG76ktoCFaZtjTat9UBesDkhnf1XmPNcTRuTU
8108	payment	1726	1726	1874	1	1	2058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR87bQfF8T4qo3Fztfskf578AeXiuz7udCtemF21FVe3nd4i2G
8109	payment	1397	1397	1678	1	1	5083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ioo22TVdk5YpqHUJe7ERBcx5s4h892VFUrw2WDFeKGVV7HcC
8110	payment	1397	1397	1678	1	1	5084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvcCz9tTMgFZZPf62jd6wCSDhfS87MRsmGPc4tYCVg2SyR4ro
8126	payment	1397	1397	1678	1	1	5091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRz7fQZJzk7w6cau5jbph234XaAuVXKDCe8zHtQzYSYAFv5uJ5
8127	payment	1397	1397	1678	1	1	5092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVGKvcuKKSqkP6i4cjgQ2ac5UAN2qWFdN325jq8FfyuthipfR
8128	delegation	277	277	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG32vrTn4AktJA76pugratH9nAnxz8aMN6hFtSmyw78hhaiW52
8129	delegation	425	425	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kxjRY8c9f5SBfxfivL3umMkm1ak4Km5k9u6QvNtgC2W29Pbu
8130	payment	1726	1726	1874	1	1	2065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2AcSQvAYMvBVYbJcGpnbtT1cf8vLZ9bo5nuzaq3yjnoxXniC
8131	payment	1726	1726	1874	1	1	2066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfoXgfZgqv4NqkbqDLFaGhxYt4EUCzfpgjwDsfc7ft4ZN3zm1
8134	payment	1397	1397	1678	1	1	5094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecHSdQfyaNtBhxCwnqn6sMyyTvCk56cwrXqqTRHFNKxfibGDV
8135	payment	1726	1726	1874	1	1	2068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqyxZzQmSCGess3F7enq9Ycid5QsS1k2cbAzMXJzCRuyyr2Ew
8136	payment	1726	1726	1874	1	1	2069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhEKvckGGHoXtWyXBAMcyhcmoYwgKC7LUYfRtZhfXAzUcZhcY
8137	payment	1726	1726	1874	1	1	2070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkQvYcTfYaXaGjfj4v2NcfCyCk9aN7YFjEvA3W9XXm95HWawD
8138	payment	1397	1397	1678	1	1	5095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1G96Xz89hTvJWhtXwtifKR67su3cGyW7ZbfSkNJPkFZpdtpA
8139	payment	1397	1397	1678	1	1	5096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFvTpQZGwTcg6ZMZT7xptw9QkM2aqhp25neWsVwKQSqRre3QR
8162	payment	1726	1726	1874	1	1	2081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU912iGGcLNNDUkvoBnvp3NJ6L1f94WMN5GRqbxk2rtfJQATD
8163	payment	55	55	716	1	1	2	11571750000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkn23hgvL6sGQrGREBqYBmLHSJV3KS4aP9uuGm5trYz7DHqZDr
8164	payment	55	55	517	1	1	3	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqkqsJwKkxD844t4VMh7TtGzBfnW1jobbHnzrfD92kZzGLWL7
8165	payment	55	55	509	1	1	4	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2FaP2mxApXTFnBGoaYCUg5xzyLsrDpzzUiAsbVqWE1c5qZfs
8166	payment	55	55	463	1	1	5	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusSejjh8uSpzoHTxH5yLWjsYCaiGhmrRezZDR3yf1M33Tn3vX
8167	payment	1397	1397	1678	1	1	5108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoeCz9HbxKf5yvZyEX5dX4nhoxf5E2suyEFMUBchkN1K6qWVC
8175	payment	1726	1726	1874	1	1	2084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUzgP9RYBrGMAwgyqnNP92FKjSBAkpa36U9BpWpCUS1bQjN6Z
8176	payment	1397	1397	1678	1	1	5111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5NnhQfE9ucSN3Vs6QbERbyHwworUa3veMoa5vMVjGWwGzKF8p
8183	payment	1397	1397	1678	1	1	5115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXXE42zsN4bVwLje24JqzTQManMw6WheUNzP7ik3uNdHTJN2X
8184	payment	1726	1726	1874	1	1	2088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopfcjK6jGSrtCbg6bJsPwf8rkECLDmzvbvpzLRmF2QsdPZc7m
8185	payment	1726	1726	1874	1	1	2089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2nX7p9VvxfsYBa56Q4dH1SymhTn6BkXTZW68NvuAxCnBvbuH
8186	payment	1726	1726	1874	1	1	2090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjo13pAKY41srCdTZ4D8NFA4K8cYNm95a62XvNphcUvG1nqFX
8187	payment	1726	1726	1874	1	1	2091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRGCMEwyR4YtJtSAi3NH7dZNMTYkR41J1XCuq9SyNV4EGQYCo
8188	payment	1726	1726	1874	1	1	2092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtp1nyKTJ49UXb8HZEqXh5JGL5GK2gXcoF1iokKRuWiScAqWzg
8189	payment	1397	1397	1678	1	1	5116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcZZ3hNsbKKqWN4Ac88zyZALce1o483SCcfbR7QQUw4DyFuTe
8190	payment	1397	1397	1678	1	1	5117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ysK1L8tJAtMFjgXcVt35chkcQudoAiZjQDsJJ3pWDx1CSdGN
8095	payment	1726	1726	1874	1	1	2051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4Xw6YAGbbPLYLxR6uCwKHkxwdKD4p9ySVBNbZ3e1bT1NHC3Y
8096	payment	1397	1397	1678	1	1	5077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaK2pT9qhi5H5WbSNAc6E6hh2S5R16Vir1x53ordwqnt4Rt22Y
8097	payment	1726	1726	1874	1	1	2052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBx4iaknWn4wHUKge4cdz6ALtUVdckUSNLP5Sw1sfC1jDRHcZ
8098	payment	1397	1397	1678	1	1	5078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AVTBRA5qzW6XqYvDuugcKaxY7sUp6Xq8iYJjDGmjsWcJ2Esd
8113	payment	1726	1726	1874	1	1	2060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcoHVrSf7PAqFkv4igE1qE4zbxE8bhRBTFJgStP6gErFzyngJ
8114	payment	1397	1397	1678	1	1	5086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3o3Rj1aw93iHJ4DN8vd1un2XVYv9VouMHAcNzTCJ1C6AAkNhJ
8132	payment	1397	1397	1678	1	1	5093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGY3AeFvhKxtadBAoJS1sNjb7AtahytwMEjq6HrrbC5PPRTBN
8133	payment	1726	1726	1874	1	1	2067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZij2X9WUa5Vh57LQxzYFTCEgXChy2htpMdxVsjGc3zjcgVV7pM
8140	payment	1726	1726	1874	1	1	2071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanz9Xtrjn5nKeHKRR88matsj2Z4pkraYBk4jxqKyr8ahiJ9Gk
8141	payment	1397	1397	1678	1	1	5097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTUD6toh75MeKwudMGsnCTCq5hCDypgPDyWPB7KxVcpJDWHLJ
8149	payment	1726	1726	1874	1	1	2075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQepDRyQBc1B94rUzrQDXwDNq5CZPC3Fyqt2UkVgfWZW7zkPeK
8150	payment	1397	1397	1678	1	1	5102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99X4g9kSte8HWEbNK42wZP4Aka9utRDRLa9VTMCKcJ2bfL6XV
8168	payment	55	55	278	1	1	6	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEF7XTDAxoUXHNwv6ciGk2TEDW6NERd54yKFrJnjFXrK1qwp2
8169	payment	1726	1726	1874	1	1	2082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpTb1o5QDUixkRw1uXWUNUeBZ5mnErCP5fEC1yPcfxzoPT3Ri
8170	payment	55	55	178	1	1	7	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RT3Pc6Lak6of1URahXxCVqNGuQE6UzoNLfmphzNsV3cGTerG
8171	payment	1397	1397	1678	1	1	5109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkivKfRbGUPHFamzW7FHBEKP5Zg3moQ91emBk77ozfMsAvvmZ
8172	delegation	1919	1919	1919	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAfGZmk7V3JfXpsdi9UyEAvWxrRQwecBi4TJgxkHM3NpGrHwV
8179	payment	1726	1726	1874	1	1	2086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7GA35AX7M7C9N1T6kvPB3DG1Bx7LDEhpqKso89DoapAddBjK
8180	payment	1397	1397	1678	1	1	5113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGKqZjFjXd3SmbSFpH1iFqT6pGKyxdN6hWtMDsLYMoMqUz5Cr
8197	payment	1397	1397	1678	1	1	5121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnC6PZDqtTGu6EXLDY7cvbvo9korij1WfsoTJ7wUawg292VBC
8198	payment	1726	1726	1874	1	1	2094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZug6tGWeiAsNJsHTbcvWEp8ttCRFALnTcipz6U1g4kwX7MkGih
8204	payment	1397	1397	1678	1	1	5124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEB3ivYTJZv5YfNp7bujpJmsPziKt4mBE9gUF2z45uoDbTXBGS
8205	payment	1726	1726	1874	1	1	2097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAzyJsU3rSwATZQk4AFCzEFB5LoVhefeNhYVSE2faicF8znrm
8206	payment	1397	1397	1678	1	1	5125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUx8A5DZFc6REhhYYPiLJgzYx81Vht3ZR8hDvGhwPUGaQUHS4
8207	payment	1726	1726	1874	1	1	2098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7689LSQ3DBy5DzXTYBDGvjsh6oheqRG3uHVE2PodXGRsajm4z
8214	payment	1397	1397	1678	1	1	5129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2BCuKRFRYf9WRcSrfoFvCKNMJRg23kw4wDfbjUQYXFEeSxAMZ
8215	payment	1397	1397	1678	1	1	5130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARdS5my6zpNsbfYp3opUEFPSi9jZPvHxYXmagz8Mrf5d8ZzQA
8216	payment	1726	1726	1874	1	1	2102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbB3Uo65UhzSRJW6r6Zg1g6nkvRKn3UsQBLmdW9fygKJ1c1Wzp
8217	payment	1726	1726	1874	1	1	2103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZ3QA5TLcpRurRpDp2XRVzWc2j3oM5bB4S3wKiqKCXKs4fMVx
8230	payment	1397	1397	1678	1	1	5137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvtb2U9TtHBq8dkixfwKVNqvqvz3aUFRF13UAViEhhMcwwVGK
8231	payment	1726	1726	1874	1	1	2110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkESPHLVvYxrSmnH6iXJnhKXDJRNCGaBwsavRs1HLs2sDMgGo
8240	payment	1726	1726	1874	1	1	2115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXsU2VJtG3VWU3LXMHa3EDmc17NRNzfgYkD3SnzSqeebd3mSe
8241	payment	1397	1397	1678	1	1	5142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSduh9TYmnww2Uae2NyCUmP6gTgtQpV2wYXmz2DKppJXcwWqsH
8246	payment	1726	1726	1874	1	1	2118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFMi2vZ19RnTeUwsh5Hp879DPZijiaZ3jSVpp9KELdiRNvnib
8247	payment	1397	1397	1678	1	1	5145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb51Uuz2dUmkXDPaeDWHPPnJ8t3Mv2ZevjfJU1HysrSKdNn7YW
8248	payment	1693	1693	910	1	1	458	473988655965	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZnA5Kvc1ANPq9pBZsouhTagjjm1b8x7BwT49Ss1h5tfhZ2Lbrc
8259	payment	1397	1397	1678	1	1	5148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfmgRJVvj9Rg2BPPFhrDS3HoUDobR2zSGb3bbzE9oBwZbrtw1
8260	payment	1726	1726	1874	1	1	2121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZSn2jLaUC5CW7cea245ejCPqU3Hi6Uj474b8iBKUqe1YtDFN
8181	payment	1726	1726	1874	1	1	2087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhD38ciWjeKQbespZa5pmBD291xCjC3AQtqvjMMfwzzk7S3tkV
8182	payment	1397	1397	1678	1	1	5114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2au4j4YETag81gA7iJx22n7wrFaDtjZPm2woWA7K3d8MWjD8Q
8199	payment	1397	1397	1678	1	1	5122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipt5BPhuzQzXASq1pkcooY6qfFAR7xhtkkJ4ebdbdtYAfQdLG
8200	payment	1726	1726	1874	1	1	2095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxrYNsByTD1mtLBf6jwexCvJvzEwM2m5YRzguovghAwEhUnUh
8222	payment	1726	1726	1968	1	1	2106	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHJ6CVH9jhgpmm65Q1NiiiHHyaTJry9jTURLDBzmMdG4jX6mpA
8223	payment	1726	1726	1874	1	1	2107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVaRb7ds1qfmhQw5XzzCBnr9HB8E6eUCY7kJcssmGBdEdndpaf
8224	payment	1397	1397	1678	1	1	5133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXeVDCbKcvbC4YYMUNQbe1aoyF4n8zaxNYFVSE6ChjENhgDgL
8232	payment	1397	1397	1678	1	1	5138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvJaGpMgx8sAJKcQD8vTqrh2oxSn7UBmNrUWNWaPU4PrpdeqW
8233	payment	1726	1726	1874	1	1	2111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwumR2D9W5HsY6akAYddbWA9mBXXVNMv4GChUcXQ4wtuxi7dS
8238	payment	1397	1397	1678	1	1	5141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLCUtYvasveyUPv3y5z897Twg4YtnBqhKv3KrMhAARwXL8Exm
8239	payment	1726	1726	1874	1	1	2114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHG5SvmiqwaG1a5GgGTSiYaNF7afZ9WtQqpXj3oJSAaFXWJvr
8287	payment	1726	1726	1874	1	1	2125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVT53z8EyYpv1fKVUhzys2dhZRZXnaemUTmShUB24sMxDcUpZH
8288	payment	1726	1726	1874	1	1	2126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHK74hUPzkerhpKVXvx7aXyU6MQQKjRwbCn9Z3tVrG93S4v745
8289	payment	1397	1397	1678	1	1	5152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYuZDnD1NYVBu7dfqcVJpjYDBtoPWT8RMEfA7asdx2KyxwGtw
8290	payment	1397	1397	1678	1	1	5153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSScrZURq68kp4aC4kYQb2fkq1pUx7WrRRgmoXBJpn9AHdze3
8291	payment	1693	1693	653	1	1	485	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZn43cJT1Xhi9YRRuNjnVUE4mcsCMiZx2soXu9oio7iS3QQM7Jp
8292	payment	1693	1693	721	1	1	486	1885540621	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ5fpDgz2XLrwbjvtSFhhdN2nUTZXE5sXAwsc8seY1a3ruLnXYF
8293	payment	1693	1693	308	1	1	487	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZHGWFECSNmqdjvWXZemsMq9Ptbv256NaqTe7TcZhapnKF2fNv4
8294	payment	1693	1693	1150	1	1	488	573096047085	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZRMXCABmok21jB1a8F17FN7NbTPDLdDUyUtxgmafzoXfnVUwEf
8295	payment	1693	1693	84	1	1	489	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZoKat1Vtr9gtCq5JAsdm9vGMKtsBF1iPkLXBECY8RrVEiifNw3
8296	payment	1693	1693	89	1	1	490	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYeqsuasS25zDz2VnZegiqbX6dGpSZkpK6vjGCr9YgNCHQpvqGv
8297	payment	1693	1693	186	1	1	491	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZXYMYPiWgjZxbtnzn3fiyr3drZ6bzBa3a6hsia8zkBvanFusB5
8298	payment	1693	1693	383	1	1	492	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZc5mPG2FgxqiWGTUixCPskrgdK6n9uJLbkw1o8ty7XLPkN7KWX
8299	payment	1693	1693	392	1	1	493	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ9zfK5JPnt6fsdBT1hTZQoUXHgZprhxjc8idMCqDJbEgp4F7xD
8300	payment	1693	1693	678	1	1	494	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaCvAwGLnurQ74gDC3H4YRCt8bzyb4FzbH3uzXx2PFSFy1qNJ9A
8301	payment	1693	1693	339	1	1	495	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaDtFiCuG3BfK6DFFwVrSppVyomZKoRjcPG7DJ1BnBEcFP35LNF
8302	payment	1693	1693	91	1	1	496	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYRRQqh7R27aohfHShvSQsABUtbgMtqazaqXqomKHRZJuywFUru
8329	payment	1397	1397	1678	1	1	5157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcncgc2BtrzKKvSqcSseYpsNtTDsTKEauSfB4GMJm92rFUjgU
8330	payment	1726	1726	1874	1	1	2130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdniVMSSymuxvt822yEQ8pDz3sYHasGrsi5C3d9kuuWF3aNLDC
8331	payment	1693	1693	201	1	1	515	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaC1B8dCDnxBaSshekTeYZ8iov7p6cu5CPRjBvsDKo4W2efMvXG
8332	payment	1693	1693	1962	1	1	516	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZbFwMuZfdsJy6SW4NbkjQD6zrAW1bXmQYMk5zLb1TWocw41ViP
8333	payment	1693	1693	391	1	1	517	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaFfM73v3F72aaptkn8Y5stk42qnNPuLZSK4VkR2MBwXkc6gcRG
8334	payment	1693	1693	402	1	1	518	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZwnfcL4y1shatMRmqYfNnVXrvbPn67UDf63Frxw3g4YTGbWeBk
8335	payment	1693	1693	397	1	1	519	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYnnbmaQugWpek7J894CyWZkTZ1vP2gv8wWPtPnheeqxza8tK8t
8336	payment	1397	1397	1678	1	1	5158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88qAYhFkFCSPrbpxY3wgXecPSiRP7NFf8K9hjjgnMrTB7Y46M
8337	payment	1726	1726	1874	1	1	2131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7fhCokPzyyFkPq3HwHo7CFR4PBTUg4P4dKBdUPLu2RPPpFH9
8338	payment	1693	1693	452	1	1	520	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaLAwkkmL4PVdKAYNoTyQ7yBt3fFuMKdpSsHdXFxX1RdgWUts8g
8339	payment	1693	1693	594	1	1	521	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZfnCEBD4B4ngYW83xBQfCw3B4MNWtsedqfkFBpsU2jQ7dDRrD7
8191	payment	1397	1397	1678	1	1	5118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbURuA3eVWxe12GQhQTgBToDBgCVFuiuqrkMMQvRFFShNLidog
8192	payment	1397	1397	1678	1	1	5119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGojFMN5DfxXPTYKvJH6E78zgPSWB53UBeifyNcGDAknjgtiUJ
8193	payment	55	55	62	1	1	8	254578500000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pH4XuRPEYmF7JHpmAudbCaqxFSgWqj5x9FdRiUSgHSYndrY2
8194	payment	55	55	59	1	1	9	254578500000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8BxnnBxNjzpkPK5xaZV75ToxhjQbpxt8pmGtsdoAFb7xmfib
8195	payment	1397	1397	1678	1	1	5120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfZpqhD6wZrC5f9tyNXPHqxPThauB33BbBKoSbNcKPkYfMYFe
8196	payment	1726	1726	1874	1	1	2093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKXdBmLPmceHp9vtEnD5PqsjNU4FfduusSbjyx8TmKEFMsQzL
8201	payment	1397	1397	1678	1	1	5123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxM9yFHSgj5tV5KY1VyWAmEW5m7bRUkvaywsZgVA7Ygqx61BB
8202	payment	1726	1726	1874	1	1	2096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQxE7xCRGazfBdNiNefzCYF4YMWuBkCZSU5UBJpSu3Z8fTCcH
8203	payment	55	55	1967	1	1	10	361451500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGqnBNpcNuzDeaNGZrW5LBDvEeBmoo4xniVo1QSiUu8dMTT9L
8208	payment	1397	1397	1678	1	1	5126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRm7RcwgR5ivEFLWaa1vJnzdUuh9VRmrTiG83wSsLS6EarjJ8z
8209	payment	1397	1397	1678	1	1	5127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkGQcYC4X2a7VGT2oRZGph3KSoajxnUkRz6hiHJ8MHDfY23Am
8210	payment	1397	1397	1678	1	1	5128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8USvMbVNANow4NGeoSfeFKfGhb1TjJNYTAFCh9dYLyKwFJoRg
8211	payment	1726	1726	1874	1	1	2099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPq63CJsjtPxqfdAZFR8E9DadJ2e57GjoEpt6aq3CSLot9MP7
8212	payment	1726	1726	1874	1	1	2100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJXFdeTk6UN8EaML5CAo9KPkYWcgvtn8CGHkiYix94vqn8t8D
8213	payment	1726	1726	1874	1	1	2101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREaq17zXtxxnLJBdnfVQ2BqjMTp3aE7CgxLk2yGwWi1WkjM7w
8218	payment	1726	1726	1874	1	1	2104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNvuCcz6mnPZCTFX6aJwewQdkAZW4TiPRWBXmgE1qSkXPLmDCn
8219	payment	1397	1397	1678	1	1	5131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizPQVyx2EQQtfMaLmL1TB3nRUyxvftWQ99Cr71kAhV6mHrZZD
8225	payment	1397	1397	1678	1	1	5134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTTa6yveekXhZKbRXg2CYjDYX4nDoQLWGYBAYs4WPU1rRFJVB
8228	payment	1397	1397	1678	1	1	5136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Uxa2qxeVbMp3scAmbLPKuzmBbbxyhEf7uyqLB1kghoeg5g67
8229	payment	1726	1726	1874	1	1	2109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kc8R7635CRinodof6hR6K2Uhptu4zCcYBf5XgrPnsDp1kgBK
8244	payment	1726	1726	1874	1	1	2117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmLzrcB63AcuVdP4pMqkSfcw7TPRAKS4dVBXaUmqn741kHWvT
8245	payment	1397	1397	1678	1	1	5144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5R7AAknydsSb7XLFXXPbCxZdeHQy9AewkFvkFmsRjjaWzCAo8
8249	payment	1726	1726	1874	1	1	2119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifuqPtgDS2dkWWpL11J3aTsbkGWWugMTqktumLYYpwRqktFM4
8250	payment	1693	1693	500	1	1	459	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ1ohZx3By8hSCCC7DaxCH3tdk8rEBSyBgkaT8iHd9Twju5ZDWe
8251	payment	1726	1726	1874	1	1	2120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61taFVnorNnM3QhreKXYbFvDfU8CpELNaFTkaqY8Nkg5AtJWZ
8252	payment	1693	1693	587	1	1	460	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaH3cTeL6txT2437kN7yjWEuqhm69dbqJVJ4CfBqTyiizMPn4HM
8253	payment	1693	1693	146	1	1	461	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZeosLN39RRPRN8jgto15hEHQeVh7wpPkcJsTP5bFDJNkvbFA82
8254	payment	1693	1693	395	1	1	462	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYXSQPuhR2BGxHXL26yyKZzceoUDqCcF2vcHetNz8eKsMS9wond
8255	payment	1693	1693	611	1	1	463	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYpqzNHW3phJFuu5j1AtfnhqCg3cEnDytPjGdSmWhohSmDFw2rp
8256	payment	1693	1693	29	1	1	464	6599392205	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZfppeBemGaihnVbXPxyJjdeUBkqbNsimzZXNj3nJbXkAFDj595
8257	payment	1397	1397	1678	1	1	5146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdRNx7XqAuJXvmcxxjE1M7G2fqyLBqy7qY3HEsU7VcnmZ2WMt
8258	payment	1397	1397	1678	1	1	5147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbC3D3WXeKmjtGE2nSfShvhR95qmTzBGA3YgqdUGKLn1Ghg9qz
8303	payment	1397	1397	1678	1	1	5154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZrUgBCVkEUaKHz9TcvguBD9eF3AEAPYcsc16Fz8GbpodvCFR
8304	payment	1726	1726	1874	1	1	2127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FMzpwTxLjq9yyuWZV18gUYvziuvZkZKRJSZtKoiuSFtqNFAw
8305	payment	1397	1397	1678	1	1	5155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M11XgMDzLXBzDpvYjje9oT7k9X8VekWy2hR98zHyXn5ZHYKn
8306	payment	1397	1397	1678	1	1	5156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAd9gMBW7XUsgrYmLbPbGYkQwTfZwnadVWjzTHzMiGTgoXFnuG
8307	payment	1693	1693	438	1	1	497	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZF9qSLXhNhym5f9x65UCoKv7HoMUPsj7KeJcQ7EtWB9xJTrgx8
8308	payment	1693	1693	593	1	1	498	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYxvf3wj8PWX4PsfMkY3M6DLUcPeV1cNa82zxBxH43QrXev7MCi
8261	payment	1726	1726	1874	1	1	2122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoWXRkUdhP3ihpdTqrFbqZBQFMik7pTtD6Dd1vSW7xGdZmVEC
8262	payment	1726	1726	1874	1	1	2123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiyan99bzoQJPMpVubqWataC4Y5TQYUoRXoQGp96rovK6QUAn
8263	payment	1397	1397	1678	1	1	5149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtEoUrgWzSPVgMWyF2TaJT8wGTwf5ebwgPU93GRAAdpEHqhN4s
8264	payment	1693	1693	138	1	1	465	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa6wNrDpDJKxBTYVe4LGiSBombvWVna34Ed54641k36xukRxW2T
8265	payment	1693	1693	205	1	1	466	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ8fWJmxk1sc8RV4RKh6g2n8N16Rp4tcP7nrUhZFgebD7f1mUxR
8266	payment	1397	1397	1678	1	1	5150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GdDZtgJ1fnTCpqr7wpycsSj8iD3ZLWmZXyTbfYPpZkXNDs2M
8267	payment	1693	1693	78	1	1	467	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaE2EaLQZjYVav8jb6HRj5aTmK7GW4aqhnYj4e8cr8xgr48a19U
8268	payment	1693	1693	1811	1	1	468	170248291866	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZKV3oNVEFoeu5MqYwhN7tomGEgE9iYj7pVWKYPb65oxFRBaHXg
8269	payment	1693	1693	504	1	1	469	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYrhMSFJun15JP4AgzA8svpshBq5gLZZHgwfdqvpLMN7auVK7hD
8270	payment	1693	1693	658	1	1	470	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYsDE1VevLPEssfCGrNvy6EaqPa2qE3VnJomzXB5WcxDUxyAcBN
8271	payment	1693	1693	1961	1	1	471	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaDV1ZBm8kSb5H1vLHfuQG2ZNK8PjMzZRr6pLqeESmUt99qu3qU
8272	payment	1693	1693	660	1	1	472	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYXEaeCb3AH9gByJjBSehoG8aqkCNgk8h9mJWRaotcrhYLbTyid
8273	payment	1693	1693	1276	1	1	473	1596983092050	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYWwRGMDYyt99sBTJGpHwgPPbPqvnc2GaYJP93GMATMMG1N9vXd
8274	payment	1693	1693	194	1	1	474	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaF2mcg45nTqjjnnyNRWmotgePitXkX3meo2b4XCFU97vFJxGWm
8275	payment	1693	1693	304	1	1	475	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYa12PLjUytmNyY4WTM5BR1bcVKSDhdK83rbYk3bATScCK998NG
8276	payment	1693	1693	206	1	1	476	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZmSRnJtEGaxHYUmRp76JbPKAcasYsScxdVReFZToaS4dFKddcG
8277	payment	1693	1693	399	1	1	477	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZSS4q5VVhojZo3v6QxKNh6wgFHqLYYKMsshAgA8j3vTKU3vbHj
8278	payment	1693	1693	1772	1	1	478	445087836802	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZMjDzww7EGBaXC4H3HFHmXuhdbtHxbPmrL3fWxdbZrmZvSNkEY
8375	delegation	668	668	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTbGrDF7MwQ3cbQdgKavj9iocTvxpWAqFgwgmv4VdCBTxMpMc
8384	payment	1693	1693	108	1	1	555	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYY6iUFH3SbKcDNZgHjiCuPkuLi28JqeJezxsK2L3AzNKk6devf
8385	payment	1693	1693	390	1	1	556	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYtNfDyY7m9vnJL8snLTGaimnAg3D1ZeAJ3j3rPQaJNcbwEosR9
8386	payment	1397	1397	1678	1	1	5164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vqdQPbPjtJ72U19iu344op72RJs5GGAJxxYv8HgVpbhg6tq5
8387	payment	1397	1397	1678	1	1	5165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Zfs9eVR38okqj1iCskkmvEk5aoJ1LZ76A5AvW5YJngNr2kcx
8388	payment	1693	1693	252	1	1	557	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZPvSZp88uMQhAoGSAfbNg53pRH3FgknqGroGTDrcKC8caSbCau
8389	payment	1726	1726	1874	1	1	2137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRVYwpGAW6z5KYtRSerBy9svY1pCcGxN2941FcHTVHGXh9Uen
8390	payment	1693	1693	377	1	1	558	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZTxkZ9WBjbjRbFPXU3GBrC3qBqN1gxtm7HBZ2QZUBCfpqQ2rzN
8391	payment	1726	1726	1874	1	1	2138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnSAUFyyZFSB8FbeTmXxStsEB2RqZAFRAxkFiXrvhCTnkqyWM
8392	payment	1693	1693	225	1	1	559	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa3XKCkJE92ooybe8ksPuMgHkY6R1csm5GgAW6Kk4zbABceGwHr
8393	payment	1693	1693	560	1	1	560	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZDaqA66sR85TaS3zpimcd1zMwR95QYnhKMWRH8YcavHFr5XFHk
8394	delegation	1946	1946	1480	1	1	0	\N	8571430	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAftYLbXhmhYC8KB8s9rFFiNGHxozoynhdecGvjiLDK2Cdbwpd
8408	payment	1726	1726	1874	1	1	2145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLkw73H5VvmeinmVdypFi8XNYpTMf7RweFXhF3EZ2f4Cpxa1X
8409	payment	1397	1397	1678	1	1	5173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVumAhGU2vFRwbZXDf4TWcyciGDjr9yy4j8ZAqX3dm1qtNhBs
8417	payment	1397	1397	1678	1	1	5177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgd59QG57JqonqcTpJTyzHBAskYtP4BnaCpgHULiQpBGFGmBe
8418	payment	1726	1726	1874	1	1	2149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRy1Bfpgfp1QD2KoGSAhkrWp8h3vTK5a9AR9D75f2BgmtyzP11
8425	payment	1397	1397	1678	1	1	5181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBgaSBwZHuiX7qaFHMQjSMrgU5PrisjWWnYa9obXz6spzR3ZR
8426	payment	1726	1726	1874	1	1	2153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvGz3oSMozoEPrbQVeJkMgngjFiTbMwStpvRyPHrkZoJTTMsC
8427	delegation	1933	1933	1652	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7qYoAbdtQngryqg95tSktiUTu7xf7AkERMXP7V8FhxFDqKsd
8434	payment	1726	1726	1874	1	1	2157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwxmp9PrWnCDGwosVruXunJZMJMk8grq3amwkNZPn27vToNJy
8279	payment	1726	1726	1874	1	1	2124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDcUpzxmCxxDJJfUG87JBBDrWHdNe7nb4f9DZy3LAzbeLw2Sg
8280	payment	1397	1397	1678	1	1	5151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaZZ2hf9VKbJ1r3aerHrMYxXTNBXp39EbqVtshKnWDtgQWK9A
8281	payment	1693	1693	105	1	1	479	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZzNNfRpTFsi3Kn5tZ7zmxhQaJm65PDksJBCBTCyctNkqW9HLrH
8282	payment	1693	1693	122	1	1	480	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ5GsV22wVucH3J57ACQY9xpEtm8Sk7GhmjJyHjPaQgyP926eUf
8283	payment	1693	1693	622	1	1	481	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZWQUEUXdtaAGdp6jjKSpUtPTq55bxUWA3zU8u63MAMGjUNocw9
8284	payment	1693	1693	520	1	1	482	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZVMtB1SA4LC53bq5GuNpo5rmWWy9SEoaU1frnnwnswDBG6FArb
8285	payment	1693	1693	551	1	1	483	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZP5MtThnEnKHn5Sjr9RqrknZ4kHdHERnWUh2UV1CUNAw5fLARN
8286	payment	1693	1693	295	1	1	484	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYz8VxgqiYeSuTRrBHpQQ3MoJnrDfCUCfgeDbrc9L1Z2dQDLtyA
8327	payment	55	55	62	1	1	8	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8kCQsxnLERc3T8GjMBsH2HPDoEdPMyp7bhwL6XMHToiUTnmX
8328	payment	55	55	59	1	1	9	254578500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4YD6kgVk3RSaCJSmvNiApCDV82rUMaiMnMeHFJR74L1ypmHcD
8344	payment	1693	1693	652	1	1	526	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYn9t7XqS8rbcCmpHRTKujcjxodKnsHudyNgXF2nxaPDjAhE9jP
8345	payment	1693	1693	745	1	1	527	1885540621	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYSbBqsbEtgZKythHLNiEz9VEvM2GNTDwXXthSxeR9vrxdkcFkF
8346	payment	1693	1693	420	1	1	528	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYtEWuSWebfB1VdqHnvECTxbrUP7KWc5TnWo9tQG2ciDxxoEUqf
8347	payment	1726	1726	1874	1	1	2132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9bAW5SGrz6m5sqkh4BsEj2N5FcCivsGqTx7cH4yY78JNcjhf
8348	payment	1693	1693	353	1	1	529	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZaJBGQRyGAzSXekLaCB8WBCGN7VNprvZW7PKNiuSdhe55QrAjH
8349	payment	1693	1693	266	1	1	530	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYQxZxr9dH8V45EaqXoSgzHSvFQQ2KvDWkZoWgGfJp21j3ZhUqQ
8350	payment	1693	1693	191	1	1	531	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZAMAnV4CcrEUhPyQCcWFUpaeSHTJSoCo4BARzs95fow4Wm2G2M
8351	payment	1397	1397	1678	1	1	5159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKMrG3rd1n2rph2w933VJ6MMmnnKKHGVDLiR1zyDaVrr3Vd9DV
8352	payment	1726	1726	1874	1	1	2133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRxUSuHq6km3j8S7kgm2pHkakvTDymPdgBwrj2SaTgmbXkbk8
8353	payment	1693	1693	600	1	1	532	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZtu9v7raa1gypLCzXA3qv3zKcDMdE7FDp2jGMQqcB83athc3zM
8354	payment	1397	1397	1678	1	1	5160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6Tr6g59rbjxM6dMn5FDgpXcjcgGwjHJurpHePeM4S7eQxYC4
8355	payment	1693	1693	352	1	1	533	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa3sfLvhkvUy8hxipbRRiQYzVtdMC9D6RgQ3K4RjDjKxNSiu9hq
8356	payment	1693	1693	691	1	1	534	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ6R4JtMbiuY1Fv2S99j4kA98Us4KAjDe5vjgoaXnv1GvSazAKB
8357	payment	1693	1693	245	1	1	535	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYRxzDgoPKnhWKujY4GEnSs7gLjBD9B5ty8jF3KMGkrRYzko5UM
8358	payment	1693	1693	421	1	1	536	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZJEBFnDY2Rgtt5p7pD82tydoxPBBsLVi2qfzkkB4nxU6Rwq1j5
8359	payment	1693	1693	103	1	1	537	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYrXhJL3yz67eVhKuCBTiMb7RHmsj1UFXFVzmUjuYMfEAV7Dv3s
8395	payment	1397	1397	1678	1	1	5166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtuzoavLfLtvStrD54t2nJhYthJZPu8trwxxgmSSUaxa2AHxo
8396	payment	1397	1397	1678	1	1	5167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyy1ewCZXES3QYYTzWsur1e4GfH9Wag2cKWuHSBYC8k2Yt6mmr
8397	payment	1726	1726	1874	1	1	2139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeJ9J8QWS8YgFXYkxZBW6TewE8kGfwLHfcjsD2tBnUUr1VEfr
8398	payment	1397	1397	1678	1	1	5168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcce9KcuJq8snhxspLmmqkZAFbhmBtsueYmi687fAYN8pgCTS
8399	payment	1726	1726	1874	1	1	2140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4iSo6dY11mPpJrbtHTHZqKERKAg4cevfZr8X3q3RriDwD5Yu
8406	payment	1397	1397	1678	1	1	5172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDJGqqojqL9D6RL2wqh31ag81xszKiBVhADghb5dkfWqGU2AT
8407	payment	1726	1726	1874	1	1	2144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnDpgHUJAm2ftdMPuRjUCq9noFeg5gZLYVjxYrB4kw62SGmGL
8412	payment	1726	1726	1874	1	1	2147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcDAYxXG2oQ6DR9DGNCcSBxzDzEQ26z1L1ZggYtPFBdBDEoPf
8413	payment	1397	1397	1678	1	1	5175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymf7TPqYVDZKXp9S4WURzufr8jJGK7ZwTNfGREFBjBmq3Qpg4
8414	payment	1693	1693	1778	1	1	561	1950000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	Ckpa6GTgVe5PQ5uMwsnBJXTdB6hrRRoggdkRGyi4gP3rBjhraCvCb
8444	payment	1726	1726	1874	1	1	2162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKFpDzSoMotH9JNDCJyDh5Lj8dSaztMXLSzpVgdtMDU6jgor7
8445	payment	1397	1397	1678	1	1	5190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHH1pnLzSvkhbE6v41jj1oeWF6roWUGFpnLRMMYD3jdzVHf2ji
8309	payment	1693	1693	408	1	1	499	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYnniUHxWCrW5Uuz7uSJ7CHkQeb7Uyfq8qmVAN1T4Z3omtJ4mFt
8310	payment	1726	1726	1874	1	1	2128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwawcWfgkiALLpZbYQwJdEtjKv3oavAi3K61jnfdYnzgvmneJ
8311	payment	1693	1693	373	1	1	500	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZsnupNknFpBnKdm69vvoCrAeGH7TokCA6fvQC2Dz3kU7gCXstA
8312	payment	1693	1693	322	1	1	501	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZRNJzYfk7F5bwcxa17sZhcDt6tQayTDwHrytez4coPWGcjnWmm
8313	payment	1693	1693	453	1	1	502	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa3EXg18Vga3jQHy8KUydCJWYQdo9ebZZFgyvnMi3YwThqKZ7iS
8314	payment	1693	1693	450	1	1	503	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZE1z5EWKipaBaF7fF414tUZQASPdMXULQi8obStHud6PT2u2hc
8315	payment	1693	1693	63	1	1	504	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYmUvwzWKeAezmiqo9xRHuQDC3zWYfnSYdxN2HmueBnKgGemcDW
8316	payment	1726	1726	1874	1	1	2129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCvwrp1yxczq2FUo1PqDo1LQcD8Vm9xMtraS1zYm13RRUSiXq1
8317	payment	1693	1693	601	1	1	505	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaG5MuZoUiGfF3k2qwp8bmsJQRhxibz6f2DxsaWfoV263q4tUsK
8318	payment	1693	1693	92	1	1	506	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa27SwPcEbR1LAhQEJK2reVaCzzyARecVfMJArDws3Bv5sfSSib
8319	payment	1693	1693	150	1	1	507	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYucMoEQXfLuJhRjVjhS9MHqReZ1Thds5N2bRd6Nknmy1e2tCfC
8320	payment	1693	1693	309	1	1	508	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYkwCKLxq91D74CSDUNTnfuJ6YEmFJ6BAKcGovdVP8DMggCGk2x
8321	payment	1693	1693	680	1	1	509	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZr7y14VhAXtHefN93eH25VtSv148bsc6ErhhwN4tvQVFFb7fPV
8322	payment	1693	1693	731	1	1	510	1885540621	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZnY6cMtuqR72PZ9Lafy4b4XJfKCCNqm6592FTMmMRMMeGKSN9K
8323	payment	1693	1693	82	1	1	511	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZPaRF21QrcAMcxSQ3fgBP7a6uhrbVD9AWU9EkKH5y2JTS7CPv9
8324	payment	1693	1693	163	1	1	512	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYu1r17tuN1PP1YUKTtJnXNYzcCXi8KbdXGntB2WjSv52zCFNe9
8325	payment	1693	1693	275	1	1	513	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaHeTXveyGKtnvEbbN82kuPofB64MW2hju1taFjZ69GXgrQscJA
8326	payment	1693	1693	361	1	1	514	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYWNhYS6KH91nezmkTX5De6PMsrmV3oeRHkj2s1JcGrB3EYbtxp
8376	payment	1693	1693	35	1	1	549	18101190052	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYXGa7qJMQNvxXhVHvHGTGnyVxNJbaxQAfr5nJwkzcJmmvA67nA
8377	payment	1397	1397	1678	1	1	5163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsJKYUhq6b6XCE8FFWrDuY99VbXUQ2Y53YAcfkgbDSr2z9p5e
8378	payment	1693	1693	49	1	1	550	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	Ckpa4rRbaeaZaqwAx85SRHkEiPm5GDoq6SCFm5Dffxx8USTVMcku7
8379	payment	1693	1693	570	1	1	551	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZvaUUraut58taKBuxS92e73no47pUNaJEBRv7BP3jFQ7gsh96T
8380	payment	1693	1693	99	1	1	552	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYpwyLJ2idE2emk3sWM2b1tZc33jTCUgVxxH4N5V4Cjc3Kabery
8381	payment	1693	1693	569	1	1	553	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ1D8WzvrmCuWJBLwdb8GMApKccPqBwH5zhVc3V7stU9uU4WjjM
8382	payment	1693	1693	894	1	1	554	289263537919	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZtgqLQc3PPXurK7bTbTpRjnUZqD8uGbwr8dnEAWXZ1CAfEZZFB
8383	payment	1726	1726	1874	1	1	2136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gh9GzaKiWNhfzNkFaes4vnjt431RLctetZbetHbEiPe3wMSM
8404	payment	1397	1397	1678	1	1	5171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHeioNFnqLiATAUG65yq5h7ktbHvVHHgAEKskPQhEapiDmNwZ
8405	payment	1726	1726	1874	1	1	2143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThkw2mkZkDQ43M45BBPiVQQABmNiFuF2t4z36Gunm58XAwkoG
8430	payment	1726	1726	1874	1	1	2155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmD2RFvqdi2RfgwGd4dUpgUtDiAk4Msuv2fmnCyvin6nyaHLX
8431	payment	1397	1397	1678	1	1	5183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJBgjH47pU26xsXdQHWWPjLbAXGJftvHJ8pwurqoBn95PUxgM
8462	payment	1397	1397	1678	1	1	5199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9ToPthev1VfBRKvFzTPdnznvSEcAXpWU1pXPymRegiwBX7Cw
8463	payment	1726	1726	1874	1	1	2170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2qr4bRW1Aay6XdcapVKJ9y8MBTwjSNR2HeGRogtNGgy7bHG2
8464	delegation	1899	1899	1899	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3Z9mQXNFypJEo7sanKtcgYMNZC8MdkDJ65sZHim5KW25Escx
8340	payment	1693	1693	690	1	1	522	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYpJos2hVQuPvRUEL3trSeAvGsSfkZDHAXf1dgdqFuABAA8UEPz
8341	payment	1693	1693	112	1	1	523	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYaxBzFUkV3Jii1MducAGTXpN4qzHZgTwn1LAK7h4vMRFvkwwfK
8342	payment	1693	1693	180	1	1	524	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZ8JKACsUoAPP1NBvkhWnyzJMCPmv5jS2PeZzD1wVidY2gCbKv3
8343	payment	1693	1693	106	1	1	525	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaGipWXNB4tsAXK8xVSpFpiocqeec38Q5n1JzwZJqC9hFVZTGbs
8360	payment	1726	1726	1874	1	1	2134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2fxBYRJsbcYoCPoiifGoVFmAy17miKDFFoJCxN1d2MTqgRBS
8361	payment	1397	1397	1678	1	1	5161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyq4aaFosmhi9RE5xDZ98fsMkKeQCEBMcJTiivfquTeF5RwVC8
8362	payment	1693	1693	217	1	1	538	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZerGcALugKor8Xb82FHCXJ6hnY7uidDeVWP9KKenRHre3Khmtw
8363	payment	1726	1726	1874	1	1	2135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFXYtuwXTuyhtRTuctDMEnKt5v6VCiAaMK1xLJTvK9weRzq7J
8364	payment	1397	1397	1678	1	1	5162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtq6cRdhj5c1ScsgJM891rtBEcV84drhaxEJbGNknXZsgYfuGa
8365	payment	1693	1693	534	1	1	539	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaEjaMbVHyyHiD9mk9A37GqR9SrWUBwoF9eXSJsteSRgkLVw9GX
8366	payment	1693	1693	620	1	1	540	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYmqpP1jnXsqfctWTshha29D1pB7iCEYqvFgPVsXwA8JApBXZXL
8367	payment	1693	1693	54	1	1	541	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYaGeCapVWhLvaBupc8cAT7QwaRcWFhV3DXNE8Vz5mgwsm3nSb6
8368	payment	1693	1693	710	1	1	542	4713851573	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZsB81jy1nMSM1YnUgAvovXiS97ncSXLTpKKkrquGyWqr1yaXiG
8369	payment	1693	1693	499	1	1	543	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZrjoz14SAb8DD78ha1exEeHpZ7xaxgyDMwZjrTLGt68ecUbPqn
8370	payment	1693	1693	663	1	1	544	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZTgEqxmK8tXcyKymnU8UzoPdbS5zj84xGDBkhaTizYu7gtX9zE
8371	payment	1693	1693	1030	1	1	545	849383610375	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYriaqzMbDHP2z5FSSrUcbqznDRuamJTNxNkmP4YjJkSCrsmMgX
8372	payment	1693	1693	320	1	1	546	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpZQ6EKgAYbd7uKr6B2kA39n1VnokuUjFTTQMwX97Pex9DKcSons
8373	payment	1693	1693	893	1	1	547	289263537919	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpYqZxacK4RbibBPbD24xCQYT9USjqg8KrM3dQDKczqMs3Ewoz9y
8374	payment	1693	1693	251	1	1	548	62222840828	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNfeTSJSPWfM3222Z3qqfZL	CkpaBh6yHeASbCqXh7js5Wbbeo4jPQkq75RTYxnYap5ToCgL5dVkJ
8400	payment	1726	1726	1874	1	1	2141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCwnQLewt4gsMho64NQmv66uw11yW8HsEW6oZC93h9pobWCUZ
8401	payment	1397	1397	1678	1	1	5169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJR9vegTPSSSnx9c9aU5KCQrssAF8GFdRTrjpieQxA3eY1ynJQ
8402	payment	1397	1397	1678	1	1	5170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1dWkAWNfZc5JHtK8WhkSdmzQP5s8B8mrYGQo2CoVVtjgAqG2
8403	payment	1726	1726	1874	1	1	2142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSA1aCESQatnSLJLDNicFdMmWLFqPUAetsBtW4TUwNbYxCXd2e
8410	payment	1397	1397	1678	1	1	5174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzEhY2Z6nSoBB2GTKRzi6nJFcnnuuXJUi3PMdB27hUeg8KxgL
8411	payment	1726	1726	1874	1	1	2146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetPkwkKjk68jSuVudXj9wCDSfFkitFVYhBuTDfAZ7gEKASxNE
8415	payment	1726	1726	1874	1	1	2148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFZcttbmUHYP2mTxqTtZyovMyrx7X3pEZ2QyfgubLAx64zEMD
8416	payment	1397	1397	1678	1	1	5176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQmFADkh5prt9srfmCgA3onCPnKWJ3UJjMJvQdMrdsrsto9ab
8419	payment	1397	1397	1678	1	1	5178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySB1cHqNi92YrkejhRP8Wy7JKjRhKfTteZf7vwLFTEAdiAVT3
8420	payment	1726	1726	1874	1	1	2150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZhkiGC6i7craniPeM4EZxnwueR2fLo3GfPHEQUNvvUR7EW1p
8421	payment	1397	1397	1678	1	1	5179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeufbAb2hRwFJ7Q2Yqpf7N8PEdz5xV5xvuJpqtsXowjzZuGd1
8422	payment	1397	1397	1678	1	1	5180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrr5ZQjqapE2n9fxM1r4ZEM3jLA8D2HwM7KygUXgHL9rXBxEM
8423	payment	1726	1726	1874	1	1	2151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJ3fAWKQRZj12w1KJMHaXqwA66MSJRH1BKWdjGd2HPUBLBkJH
8424	payment	1726	1726	1874	1	1	2152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJd511GZQnAqJWxBkFxquLV8yhGRhNS5now5aDTNeV3d3Sq6d
8428	payment	1397	1397	1678	1	1	5182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MDEJKLRtNsXs8LhZeDto3tcmQapHaxKvweU2qEAzWYjHG68G
8429	payment	1726	1726	1874	1	1	2154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UfCbkCU2bpnonM1aN1fEaqpZc93ya32QDFjP4tc2KSqwAQZZ
8432	payment	1397	1397	1678	1	1	5184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkhVRVkGMmYnxHVzzdWySofEaLyA3xg48yP667PsWMRrd28U9
8433	payment	1726	1726	1874	1	1	2156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9t7ducmNLR9fYAWCp3bgC1VQqz3RCqN51A53tBkFnqoGgGjK5
8454	payment	1397	1397	1678	1	1	5195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1DC1cQj6cYnEqyjgEQJ2xRuBEh4EMip6fpPjME5xzRBCzKK8
8435	payment	1397	1397	1678	1	1	5185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUx4YQ8oUNVrduzSE9LdCUvsTkW11Qd5fbD8tircAFqcogLJtt
8436	payment	1397	1397	1678	1	1	5186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZjAmdx35wf2bvHSnMXGKn4keZrazgnuE2qTZz2J3aSdxK9Fm
8437	payment	1726	1726	1874	1	1	2158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UoRNSRnReJ3dLkoKfRZwuVfEyZxZQSwrfnXBEWaUw1VALsZW
8438	payment	1726	1726	1874	1	1	2159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcX4feYTCSeuC6QJCQrEA6dY17ff92QEeYPnorKfxgjw8xRdBD
8439	payment	1726	1726	1874	1	1	2160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKSQLY2HQzcFt1aSro39KuLVHV2Gs3pgCidUnD2qo3K55qQPq
8440	payment	1726	1726	1874	1	1	2161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMPMeqgKupqJ9rPNdmdXYLiaRg2BgB2m37wR9rWYyGTqUwCvQ
8441	payment	1397	1397	1678	1	1	5187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpoTNu6GRrWhGFQ5DSHY2wmBnBm83EWowj7qa6hMVprauJzdy
8442	payment	1397	1397	1678	1	1	5188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijRoRSMzcjmi46NbKmUyrqynFHKn8DjDrLRidtDuTyy7rnR9H
8443	payment	1397	1397	1678	1	1	5189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjjn2zbzNMRMnkXoXdLrah7KZCDU6EuEUMhbYkTLr7BcWsnDL
8446	payment	1397	1397	1678	1	1	5191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANcgvYQnbHsmCNqEmmGJdHx6McXBt9pyFcKpuuFE4bYhKLiYx
8447	payment	1726	1726	1874	1	1	2163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaPnA2uPM1cm9v2rLo9BWjDeF1JECZF3LBwSAvZVbqjxAKKm2
8448	payment	1726	1726	1874	1	1	2164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRt58oNtDzqba7K1bJHLFr3Nv4sjCMQtqk2pTkZwqxkJ4S3Q2i
8449	payment	1726	1726	1874	1	1	2165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqmQpvy6zKyiH4AY5YqhbiRPfH3sP2zX7gxAb1Ecy1TzxLbYV
8450	payment	1726	1726	1874	1	1	2166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1f2NJRVzAX4wrsdNsG857ibSLttRf6XAQkUBa8NULNuJKpJxG
8451	payment	1397	1397	1678	1	1	5192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAz9Z1dtcbXzjjfLGi4AZdnHNZj7ADezpWpKrKftYvyNSjxe7
8452	payment	1397	1397	1678	1	1	5193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJagqVSPtvnuBiiPWfmeSR3PtbMeRN8oSvMvyY7CF8vczQjLq
8453	payment	1397	1397	1678	1	1	5194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoQzktBZNEQ8Qaiu8bfL7rFQHJ3TKgpEm88R6dginHAu1piWG
8455	payment	1726	1726	1874	1	1	2167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZzrA4La3w9513iDum6TgbSmaJfo8fjTNAkmZZQNQcPVNo46w
8456	payment	1397	1397	1678	1	1	5196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtt7bDeXupN1HC74nEkWkJNV5eextuGuDucTsNqHRh85rhRq5N
8457	payment	1740	1740	1899	1	1	5	3000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRPzeHaQwF5JSyvRoUoaDy9fVnfcZSrmuVy4xXzTYw9khEioB
8465	payment	1397	1397	1678	1	1	5200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjsbvQ97JN1McXxpy7XkiJg5KGEsymagki9YUBZhAmWPEJiwz
8466	payment	1726	1726	1874	1	1	2171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6cJ8otDeQygcgPBTVqvrifZTRt4VZcoqvPynD6oCf8RQaS5L
8458	payment	1726	1726	1874	1	1	2168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bX82L3jecxdhiWDwJpP5E8sbokFYgeXJbWG2hfK8wGVPpVNZ
8459	payment	1726	1726	1874	1	1	2169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJufdry5D494FpwYDTUQborMaggA2uM72eDpA2Bxaxx1e1ERbX
8460	payment	1397	1397	1678	1	1	5197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EdY8aNtXHMxP2TsEAJySBfAQBiCZfBnJ6SynkikD919KdPFm
8461	payment	1397	1397	1678	1	1	5198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgUhgrZNnxvHBBf55e2cuycA2tJ7yfqm7YhbSYMNNAScS5s9s
8467	payment	1397	1397	1678	1	1	5201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkRfg1HDHNvqcFHFgNiWsXytQo2V4JTEamvmZaGN9TZhkin5Z
8468	payment	1726	1726	1874	1	1	2172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVHFcEJimeysXAAdJ9deimCw5nqkTY6FXFKjuHK2CmBqjVKum
8469	payment	1397	1397	1678	1	1	5202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZBFHPNmH7fLkuFLMZhT7pw7tqMQpWkT7qp7fmU5t1CVcPSrv
8470	payment	1726	1726	1874	1	1	2173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQf7oxvzTRaRjWaGo48NUXzvTniSfmq9C2UwvxbrWox8HJF8Wk
8471	payment	1726	1726	1874	1	1	2174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhpqdPMzNX8ZoCn2MfGdqFhWbXA2T4CGxeE1fJHbVASgxTxZL
8472	payment	1726	1726	1874	1	1	2175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoUqtBknckoQQVd2NgTU326ixDooibNUboQFv1GDgPPYXZrsU
8473	payment	1397	1397	1678	1	1	5203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUdpVpduCFmmamPsPTBzX3tWxXoxov23Jc1pcWxL4ccmb7xVf
8474	payment	1397	1397	1678	1	1	5204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxLD63f8z8XpA1YSB6teT9um1X236q1ucadANfvFsk4Q26sha
8475	payment	1397	1397	1678	1	1	5205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26bRzvyQpB4UeQMPPtRX8TTceeh9Nb9is8JUdWebq2uX85hP9
8476	payment	1726	1726	1874	1	1	2176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfwyKaeRShfnr7NbPJug7oCvszySCL2A7X2cCdqqb9NvBdcKH
8477	payment	1726	1726	1874	1	1	2177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5bjWXRaJvfXtQo4fNDYeJ4envyyQRJ7ew65TBgFeKJcEEyW4
8478	payment	1397	1397	1678	1	1	5206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLS3ytEnkhQcbCN7trbmutt6KucFs54PJQEePjSHbaHg6AX5gR
8479	payment	1397	1397	1678	1	1	5207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t8QcpMSa2CArJMwXeeYWiwMz8DHWvNSozNNSz27qts7Y1Ajd
8480	payment	1726	1726	1874	1	1	2178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFCpESpHk6MoMeM9xLYYTmN47wtkAPF8QJkeETz1TMhMgP2pc
8481	payment	1726	1726	1874	1	1	2179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgMv7TU93AtWtK2E7KLWEyeDrJUnXJZaPLaATSB7ekw6kNPB1
8482	delegation	1961	1961	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSCLLKL6im4Sgn6JuSqvQmXfShC9UxukhqhJtUeuhoEAdKUgU
8483	payment	1726	1726	1874	1	1	2180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTW4gGUNynC3HXWX1GRPNfeqgaxCcjFrbuacMCPTcXwXkjC1q
8484	payment	1397	1397	1678	1	1	5208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJmeuaKpLBH91tGSsmB7EdNZPSrenPWQsPWBLngWH5uHG2iU2
8485	payment	1397	1397	1678	1	1	5209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUk9vF2GKjGoSMRam3Xxjh6vrdiD7FW3RpmVCi9fAPc1gUdU4
8486	payment	1726	1726	1874	1	1	2181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwns2Qordmxw6CHvCv5PRQ2eMaMB8PYHyhVGDUeeDLbndG5WcZ
8487	payment	1726	1726	1874	1	1	2182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahQ5od9YjXxnw6UBL8ces4tQ29Kj3pPxmCLbgYoBou2FNSTpW
8488	delegation	1962	1962	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXNYgb68D63wEmbN694MFYq69RAgJJMRvDZzU1jt3GGCP7UJ5
8489	payment	1397	1397	1678	1	1	5210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkQNrecMmfpogDJBEM3TJuEyKRtQF312D3nGnXokmLXfsVNwe
8490	payment	1397	1397	1678	1	1	5211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHirrZJnzp4PqcHd3GACYEkLHyKvoxDDgt1zWcjqivCSpLFqMb
8491	payment	1397	1397	1678	1	1	5212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpPbwb8NUQGthDPwgEyvC9zLMkkURQwKrfUvVKRPSxNmkPkbo
8492	payment	1726	1726	1874	1	1	2183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6D6UMJNgdofNsdN8jfSJ7tHkeLqegBNnw8D6sr8jPwRpWMGL6
8493	payment	1397	1397	1678	1	1	5213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNnkq9i2WsuvKFyoSV8jVyXQx57R9ig8KRrYivRmnY1q6aVeg
8494	payment	1726	1726	1874	1	1	2184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGYnHMkmmm5bveEcqHPcWZjzNnFQcFjaafTsBXouLGedQSQFs
8495	payment	1397	1397	1678	1	1	5214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17N3sechz9kiwv7iTcaKVatAa1gj7mYkXFDB6QnqSH1RcXmTt
8496	payment	1726	1726	1874	1	1	2185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLm5TrcPu4VpDE2tEssUHAKEGPcVQwwBewzDDiTzgpYQ934ZiF
8497	payment	1726	1726	1874	1	1	2186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPJfzUYufC41Wu2XzuD4Wk5tDgECkm1b3jR3yADGXPmaoe1Wu
8498	payment	1397	1397	1678	1	1	5215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uNeqLn6X1UPqR8uMsLAzzQcX6KchDh253c5L1HcpuSsQEdfj
8499	payment	1397	1397	1678	1	1	5216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvjwNisNCx97uSU6ssR2pWVkGaVCPoefbEx3JuCYmsWbGTkrk
8500	payment	1397	1397	1678	1	1	5217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6t7NuhATWXnqmD3y3QngryuW1sEQW5A2F5yiXs21fdCSRL7Dc
8501	payment	1397	1397	1678	1	1	5218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoj6JKQ7gxD4uVxQ1etHQ3YLYyfo5BKB5RwyWnWqADG8cVxuQh
8502	delegation	1740	1740	1899	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zTm1mprqQWsSHnL31oEU6y5JKb9y6qy6ZPUNEoxHXLMcjAYu
8510	payment	1726	1726	1874	1	1	2192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfU8xL8KBWK8Tm7sQLi33QcvsTq1o9GfnjXHr6jyv57Wu9TFaD
8511	payment	1397	1397	1678	1	1	5221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHX5Va6V71kLQGJYw36xehiQLwqo8KNVfa8YMmPBL8bTBqhNr
8518	payment	1726	1726	1874	1	1	2196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMfxoFhJGrYRMuEaEGBNgCAkExFLGBxyzufke1s2b5C8b5Npx
8519	payment	1397	1397	1678	1	1	5225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTywfSNbYARf3Cfs3cdDqoFks9W3aydXV4m9qPYXUAWotvrJqA
8528	payment	1397	1397	1678	1	1	5229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKcSrGSBqHfYmHjGUsYDFEUEe11nFXzrkFLz1iQBfkyDfJFHV
8529	payment	1726	1726	1874	1	1	2201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDmEhc5DwrLMJCWkjQ9ow5EKEaLzS6vpXXNMJqYuoqHrHCcPc
8534	payment	1397	1397	1678	1	1	5232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGNJJKFWMbxsYbvbhPgByjdvSPWJgrpYkNbdLnKaJGQNMcGHj
8541	payment	1726	1726	1874	1	1	2207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbw6cs2eFLbMFDXRxBFsKMw6dGQvXy5fiigzfVncm2yPnCgpFw
8542	payment	1397	1397	1678	1	1	5236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshQUN94jtmneCwMLTiWwrA2mLRMP8Mm2ZwyBoEaUZfm2XnAyd
8551	payment	1726	1726	1874	1	1	2211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4fZcm95kJZh3AVsU3Qxg1Kio1ar74zskwaNQG57FZzAVevKL
8552	payment	238	238	1474	1	1	2	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQMrSMaf6cZuNCFHNNaKouppL4j4doTDdgMLqzHkd4VK5BDJc
8553	payment	1397	1397	1678	1	1	5240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuhQhugWgaMMEC6NhCN5Lfsi7pWPUyR2vzLf8fLygoyrZmoLx
8561	payment	1726	1726	1874	1	1	2215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkXXCteFpSnF4e2p9Ev6tkb7pqXUiVPCVwgNpdy3xzXK8jEzR
8562	payment	1397	1397	1678	1	1	5245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZUd86HezBGHxCRZq796LgGhDG2bVP6x9fHKPmPHjvLZEcnq6
8563	payment	1726	1726	1874	1	1	2216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fCyqPwfv73UEfHYq2WbrHQmzHL6MbAnKPkM4bd5eGrYsVKBi
8570	payment	1397	1397	1678	1	1	5249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvtGHXKrhDj9BerGwcT3ZfM3moFvc7FhcQVnR3BWHwgUhFAS9
8571	payment	1726	1726	1874	1	1	2220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHKJe9B3wLf7c8uFpf8AnyhfahohApm5hzemGAQDxxEuvQiaPj
8572	payment	1864	1864	1932	1	1	0	331990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeg6QQf9JdxJyg4Vhuwe43iQdaiQT3VEX2kmuDgtkXyPBvLcQF
8585	payment	1474	1474	1950	1	1	5	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6Kfq5efMwMCNXABqJdCdmaPPHSkciuuMs7cd7MPjQf24wW42
8586	payment	1726	1726	1874	1	1	2227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBxEh43yfUnbrX5vwpTmT8JTqBJva4wRwwJ9u5GwaovGN8CHM
8587	payment	1726	1726	1970	1	1	2228	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYZ96HCy5A4utGVg8w4niHap5t434VSPoS5wYTTQHfhV9rcxj6g
8588	payment	1726	1726	1874	1	1	2229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvzpoQ6Cvt6hb1DzfcVhaMccEi3dSVatyafy5PC5YVSmaVBcU
8589	payment	1726	1726	1934	1	1	2230	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1TfKB3UFrCjk9ghWzQbH1rZkS8yDtwPUWGaia37FT6VewgLAr
8590	payment	1397	1397	1678	1	1	5256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzknhNNrG31xisKAG5Z32igS3K1PvgekE6hwL9neYhYRceQwQ
8591	payment	1397	1397	1678	1	1	5257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmf6UqsVx48FDd3WUFwNNM6A7hFzx7uD9aQgAjcXtcyEkENZ9
8598	payment	1397	1397	1678	1	1	5261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTCaqhzn6QVSig56ZhUQgXUH8g27r5qxE6YRZYLKkRzSiaX6d
8599	payment	1726	1726	1874	1	1	2234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbqVHEfpwixLyGvgdxRaoX7KVLSW28wJogAJXNiUzZ1gkQCkh
8600	payment	1950	1950	1971	1	1	1	200000000000	10000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpYqg2iS76bAWWxDmkqB4Wb16QdF3KCB823jU3RUG4M5LPSbjAk8
8601	payment	1726	1726	1874	1	1	2235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWRu63HPiFKD67RKssXjedexmVTLmwDpmbATjs8JUAXsvxb5S
8602	payment	1726	1726	1874	1	1	2236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfz2HgiPJ5DxRvwaukaqvLvLPLUjTS16TVHRycBmWrhYxYHv8e
8603	payment	1724	1724	341	1	1	2	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXTw7zpU6aSftvLGHeRbPEs8RTYcvfkjB6jAaQW7JDkZSk4F1
8604	payment	1726	1726	1874	1	1	2237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrHatvx7TfL4orD1qMA6d7tEsxfPWahVzaekgEh8b89Yua9yX
8605	payment	1726	1726	1874	1	1	2238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdhzQzPBcGKC9xuS4rNbsEDSeZEFoE6Ky7s8w9QKfMwemnxY7
8606	payment	1397	1397	1678	1	1	5262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjc5nvwDTipf1wfjdVQQRv38Qne59dvUQuRdKdPe8c7ZuSaUx
8607	payment	1397	1397	1678	1	1	5263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3doSM7hyAAnuxeMVa2GiiDaaMn2XS3bFLoUFieR3FEqmQXmn
8608	payment	1397	1397	1678	1	1	5264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9v6jpRJwQbC9CRokBwDMfZgiFKbYbLmU9wKXtXC2mYRdHoxVi
8503	payment	1726	1726	1874	1	1	2187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXgrumdPTWLhaLY9YqyxVLzsFEzXyWNTzXm2UsBofHi3t2EEa
8504	payment	1726	1726	1874	1	1	2188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fHwvXBKGvKpmEhkXDJ7d56F5KTcW7142Y6zbT8CYT3PKb2iK
8505	payment	1726	1726	1874	1	1	2189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdURiJgLM4R27xHCA9k1uksWWhFVYMuUst942UDSw5Cq3uLTN
8508	payment	1397	1397	1678	1	1	5220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQdn5Qr2jRUA7HbPCBFGzLctYWGSib9Ew3W9ivMhkFqciwVkH
8509	payment	1726	1726	1874	1	1	2191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpEJqiNU72n35gnuts89wCfDK46TjYvntmb5efcr3bBGgsLoi
8514	payment	1397	1397	1678	1	1	5223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZaWG69Cqszrg86KBpTWUxpZKXGoCnC9EQH5u1UJqfrVyPP7x
8515	payment	1726	1726	1874	1	1	2194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KcH4m4PS9yDYyaK3PyEq2urKgdGS54hm7B5smJ3LmmwsuZjN
8520	delegation	1474	1474	1474	1	1	4	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajbqNhte3bUgQZhXxfGyFhEb4H3kQEqdXZuYzJc6GeVSjTKSK
8521	payment	1397	1397	1678	1	1	5226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKQrGsYFSSyuYu1Xiz655q7go15bQVepohh16JJk3LHEVJYcp
8522	payment	1397	1397	1678	1	1	5227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoU8eHSDX8SjmfHJud9aQPZ9eLPBXY2nidRjK5AwRFtbDt8eU3
8523	payment	1726	1726	1874	1	1	2197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6FWrUyWubkf7ojVxvNseTtMKuNBGnMJjR3yMXKRSWKcW3P8t
8524	payment	1726	1726	1874	1	1	2198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNx2XehAPpKXPYjvD2ZeC29AG4L7bYvbjuxFxM6h1R74GsXCS
8525	payment	1726	1726	1874	1	1	2199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2Zusk8a4Eh1noyukrRq1tDQ6AP7yAMmJGvjs847FCpk2DsiY
8530	payment	1397	1397	1678	1	1	5230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNtZRD1huyMxbYyJvYMsaoPtwfJYdHZJ7cd9s53Dgxh4CwcGh
8531	payment	1726	1726	1874	1	1	2202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyTBsqVWCGyU5q8yHbMJoW8MjgmLfLHZE4CgDjpq97qjhmoiL
8539	payment	1397	1397	1678	1	1	5235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX79bccbtRG5ZtABF13ZjX6mm5pUsA3UeB7MW7L6PTzBj2QQzw
8540	payment	1726	1726	1874	1	1	2206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQaynPKcnbeVx8g68coCNqo1G3j5XoXp2aSUssSxDmXErg6Wa
8547	payment	1950	1950	1969	1	1	0	2000000000	10000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpYb9dvX55zxTYTNChYC1ntkyppS4VSH7ZtEBdfnchJ1k3NHCXFM
8548	delegation	1900	1900	1403	1	1	6	\N	1000000	\N	E4YRKQGMsxHFWhNdFjHrw3JgoLhAdZp43s8AUZh1rDmScUQMQaUjm	CkpYqr312oNggBhvE2uHDsQjoXbhRdNu7iQuvA89y4TWU39LwCkT3
8556	payment	1726	1726	1874	1	1	2213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7pWF9ZtHtSzPGLdLLVWpaZShjYF5jQERahCcvJ31hiwDwpHP
8557	payment	1726	1726	1874	1	1	2214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAgdBq6hxPzEp3uJ21GTSkGvAkYqZDxvsBgBC7bATw6pVe6T3
8558	payment	1397	1397	1678	1	1	5242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvYRbSSBjxuWTLVHma9oRfQvRJMCmDDqt13XnxbPE6CuqgPuP
8559	payment	1397	1397	1678	1	1	5243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fZx58S9S4ZFo8ZinFMAne4TcBtcNmicyfZGSpBRKdZZWCr7E
8573	payment	1726	1726	1874	1	1	2221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPS7KYCfgavyYSNCgNQhFpaJnNj3wze7UgdBWW6vm45zm6D4wL
8574	payment	1397	1397	1678	1	1	5250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMhdB66cdMNaPF4ixLE9mp4opyMz8rsX36tkCdZEpkPcrH4Ts
8575	payment	1397	1397	1678	1	1	5251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtiUoUTkTpRutLwmVy7dZtTqGNJN7bfBNFndLgLpBu78xvxb4
8576	payment	1726	1726	1874	1	1	2222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RqEo3hLRYqFcUr5P54kdAH3f8BH6ZYqaHsgfzwpU8XEeZov2
8592	payment	1726	1726	1874	1	1	2231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgauLaHQjwVybn6fiEeCKL3gJGcu8ARY2VNQ9rfomuKmZ7kxm
8593	payment	1397	1397	1678	1	1	5258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXMsnTbB5AU4b1vtjxDAUBxNy25HEieDydFBc9rWgcptP3HyQ
8610	payment	1726	1726	1874	1	1	2239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8XUqdjRoQf1c8HNeagMTKHJoyPkj7iZWLJiK5vULbCHTdWuc
8611	payment	1397	1397	1678	1	1	5266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5KHcr5DG872k39yrxsHjyb9Ji7EbBWbBCbpycVhmYnMd2BZA
8612	payment	1726	1726	1874	1	1	2240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxNLExnHy1B89UcAqdq9oak8XH1HaGSgm3pF9NAvg6VnzV4ox
8613	payment	1397	1397	1678	1	1	5267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzvoapxhs6HkJxpLs9LXsPbMwVbzrZ9GUyzBHDkRHeukJNKJc
8652	payment	1397	1397	1678	1	1	5286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjsNgdxwbZn1T44ktyAZypyVud9WcHhCQuExqw9NQr5hCJS8P4
8653	payment	1726	1726	1972	1	1	2259	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZrX8ozyCKhgoDVqYXLqejHhSgezxeJjPFT9VaVjD5eJrPRmtkS
8654	payment	1397	1397	1678	1	1	5287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2rUBG6FaQNFYBmQVpwGvxHhVsddgekqHtTgX24rp8o8bx4U2
8655	payment	1726	1726	1973	1	1	2260	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEm6cay8ejDUmAWpGcWY7fQH6P14n6ww1YP6vWepLQJ8pP2Yaz
8656	payment	1726	1726	1874	1	1	2261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyM5c82NJz8Q9ca2ohBCNaFaPzLH1MjhaLc6kKG3A7HQPbLbS
8506	payment	1397	1397	1678	1	1	5219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDnvxEsXnFEQUKaB4Mf7r87LNZ1o92nqGFeHrkksX5DSfJmaBA
8507	payment	1726	1726	1874	1	1	2190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87H1gYfTUzLN9HLP933cPHXQU55UpmKFgrGFiYEa1sbPg7ZgG
8512	payment	1397	1397	1678	1	1	5222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqbA1wmA9BhxDNCFxkUurY8xkhJwsZ3TzJoa2XEK4x4ArzT7K
8513	payment	1726	1726	1874	1	1	2193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxm2simYGjsahzHg2wwrGquv6bQmsvg9K3C36MKyVEKVTgMvSp
8516	payment	1726	1726	1874	1	1	2195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNNtjmBXwKa4ai1Vgk58qBr2sdxRsvoVdNnGVzHr5asKaWbwz
8517	payment	1397	1397	1678	1	1	5224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DHv2HG6kXVQq8HeKC7fwGb9XmFucYd2KYg5tzFqapnmnDkMQ
8532	payment	1397	1397	1678	1	1	5231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvbshnwwbZ5p3eEU9utKiDYw5NDQX2bwJv2VqZ4qXu6gxx1D1
8533	payment	1726	1726	1874	1	1	2203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M6Sw4g16ummcHBzkTSyvbkWrWHYgoB1TxvviRVn9HBFbdeLa
8537	payment	1397	1397	1678	1	1	5234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nevD7XFH5sCmizxviJqKfnjVpjx8BJsG837eo28jRUmsrFEw
8538	payment	1726	1726	1874	1	1	2205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrz4QAqVQpapV5R1UDBuLXxY2Np5t1qa7sjvn6cKEzfDbKK27
8545	payment	1726	1726	1874	1	1	2209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBcfUDQLGqJZgC7RNgFzUjDLzy1dVEQjEqGw5LpaKqWXwmrx7
8546	payment	1397	1397	1678	1	1	5238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyigWanUEHThPtjD9pUBTNW4GA8zdBreBr21P7dYm1q6Nq4Zux
8549	payment	1397	1397	1678	1	1	5239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiVy6tKD35vSfB4v7oyZs749niuRNZvfbfGKwsnkig1foxNCv
8550	payment	1726	1726	1874	1	1	2210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUKa31z4UTzHRB1Shy2ighgLFZvLSGxoantBXUrSQRhWE3yqV
8564	payment	1726	1726	1874	1	1	2217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sCTyihShmMDH8WSnauUBuraVujijvwngAEfQJJJerhkNQk4n
8565	payment	1397	1397	1678	1	1	5246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodvqsbah7eJ875peJ73ZeHL2aekiU4oqAH7KZgzX9fNnijT35
8581	payment	1397	1397	1678	1	1	5254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvVQ5bw7mbocuNJLtusoTUtEbFwRUyRytBuu3F7CKeQbTA8t1
8582	payment	1726	1726	1874	1	1	2225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWfu1VBRWdGGvU2xWyL3KqvPV4ns8pXkBU6qAqSd6BJPfoqmP
8583	payment	1397	1397	1678	1	1	5255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo81qZcn4mR4nMTvikN96KPpaLrrbzJrH7awrHgyecXtERTuzW
8584	payment	1726	1726	1874	1	1	2226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnyaVKDMu517QmuPuVEJBvRRbKyWibZRjeCwCMMUtksTeJZG2
8626	payment	1397	1397	1678	1	1	5274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcNkzGP5jw6Skf45BSQFf8hZpmkhrm3tn2zTwUHT6oq9jGuAG
8627	payment	1726	1726	1874	1	1	2247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ9eerHTzwnVjN1xjgnh1wcg61TdZKTMCmWA5sbPt2oJZPsMiX
8638	payment	1726	1726	1874	1	1	2253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaASRXEquVh3fiVQ5JGjWBq1zpSepHwjiS1upNNDkWFuMAEwW
8639	payment	1397	1397	1678	1	1	5280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MnH5iSeStxbH4vLfu9iBxhoPoSiSrfvdxnDon9ocWyLeE18Y
8640	payment	1726	1726	1874	1	1	2254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPzp7QYV3EcuRiHPgGXrmGrcXtfZyRLVm8kXKmhYK33AxgmQA
8641	payment	1726	1726	1874	1	1	2255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtr9tgwcTvpX9i1woUsEZkRKLLSohAXvzAkPjvgPzDiSV4ZEXm
8642	payment	1397	1397	1678	1	1	5281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uo3o3GRm5r3MGMhVanaTiC2NuaikVVM73AkqKzT6wcXThg6q
8643	payment	1397	1397	1678	1	1	5282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJAPf1buSFjkWDjGtqBvjaiCZRz6LnGBDXzR3ViqgpAS7YpTs
8673	payment	1397	1397	1678	1	1	5296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhqxF1CgFA3gcUZhuHvYiwUHxkPHEeBCxNMdCNUq5SMokfnBa
8674	payment	44	44	27	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvMU4MRrj5C8nxDXhfRi62JW4AnoSwxb3ck7KR6Q1Xvwjyn6K
8690	payment	1726	1726	1874	1	1	2277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZackp4eodbp4mdZJNNKzYYt36RoTPShdnBu4Xd1jF7ZBtQRrr7
8691	payment	1726	1726	1874	1	1	2278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MxBVYbcL31yAWT5TKtpbsTdDAxzasMFE8wCVrbBETn9m1RcY
8692	payment	1397	1397	1678	1	1	5304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhn9PWwaG2M5ce6w8Ef3QMGnhHLrdwZ8aukTQbWWp4NRDjako9
8693	payment	1397	1397	1678	1	1	5305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8VmdgTckiFk9CmEE4VjLSVLj1JC8k1Y1V6mQ8p3dQbzRbpeeF
8696	payment	1726	1726	1874	1	1	2280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhZX7edwdxJM3Ckhv8GuPigWoHtoDWhPXV3Wejqhg3rT5mtAk
8697	payment	1397	1397	1678	1	1	5307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERJHupBoXP1TDdinLGGv9KHsLTs2B14etyTwoWEf9cxrXVb81
8698	payment	1397	1397	1678	1	1	5308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4FkvCZ7YZ88UTP7GRayoTPRevTjVT2aFpaXBuqrccgLSq1w8
8699	payment	1397	1397	1678	1	1	5309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhibPSrY5Qrb1x9Dru6umRYESe7eYSSUgCPVPeYhZKKyLQtu63
8526	payment	1397	1397	1678	1	1	5228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Gag3cBgpuUUWyrDDirErHwbsfouonc8NXN6mZfgib79t8RJV
8527	payment	1726	1726	1874	1	1	2200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkJycgEsUeo1eHdUGfL5Kxdqa1GjJLj8373tTSECv7cBE951r
8535	payment	1397	1397	1678	1	1	5233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhEeixHn4QZgM2Gn7bwawiHt4TrwysqskwfnFj7YzbiYhCrXr
8536	payment	1726	1726	1874	1	1	2204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1F3nS2QcP6TzrGFCYkEhkSpbNvwYYAekGxV12xiNXkhEanan
8543	payment	1726	1726	1874	1	1	2208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzG3s2XgyfF3VQQLanbYV9WMnEUmXv78PBd5dGqKuVvE4Ecgj
8544	payment	1397	1397	1678	1	1	5237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfB1Ni8VmYac1gNuzwcWoFBzbxY7EeXaPDAjdSzs4Nr446ZK9Y
8554	payment	1397	1397	1678	1	1	5241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42pbbPum9iw5cNLTkGiy3XTbgP957aQBpf5Gwobqb1PEfZh19
8555	payment	1726	1726	1874	1	1	2212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQpChTuC3DdhA9YDDjLcbPrzbCS2QLipgTnvbGWeSDatEJBpN
8560	payment	1397	1397	1678	1	1	5244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB53xuJ2CaQbER2u7WfZHGcnjpDVYL3mcgtn1HmhkHxWqZ6iY7
8566	payment	1397	1397	1678	1	1	5247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUs8sPUA85C6hvr5i7UDopSTbbunErHbeKit4ozYUbM9AQJqVW
8567	payment	1726	1726	1874	1	1	2218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFWJC56dyZSz5W1Q9TFgdnRq7Z5KYUP9w3ESkiBxCbWu9G13W
8568	payment	1726	1726	1874	1	1	2219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRY5XvQCee1eo4qDqYYrDeAZX8Ym6gDLMHHM3bxikrGX6Y1xH6
8569	payment	1397	1397	1678	1	1	5248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxs1ZzsXb87XPLgidJwtXrvDhc7zN93oPLuSRLnN6ixhXreBMH
8577	payment	1726	1726	1874	1	1	2223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKArRB2FsmctDdQrSBnoufQ6A8cueHi6DwtKjQNhCof77fnFpy
8578	payment	1726	1726	1874	1	1	2224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEiLX26qQCDh4VFKEg2U47sSK539V6mXxXagJTgELurEi9fUG
8579	payment	1397	1397	1678	1	1	5252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpDxMGrwg7QBkA3RdkDXpvXjcNPwhpjyaYjvTNu7p4AiL5MRp
8580	payment	1397	1397	1678	1	1	5253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaEkhLqx4vpjFByzyiUVFJrZfBwuEfmoW5DaW1LQwzsFkpvC7
8594	payment	1726	1726	1874	1	1	2232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHavMEMzcwhxwM7TTrHZ7VXU3YrKaSRECcKUpf2sHnXNDWZww
8595	payment	1397	1397	1678	1	1	5259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4sVrENsX5YZkxG2inDyzkpMPkbaZhZt3WccCEDSdN69LnykU
8596	payment	1397	1397	1678	1	1	5260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjSBBF5fckbjyVMBomFM7PmgpjMRaBmFxBL3zyvSJFukCUQqkF
8597	payment	1726	1726	1874	1	1	2233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsBhC7erQZhTZpj2765a1XaLJRDciiAX1vttYLsUqC7iQv2T5
8614	payment	1726	1726	1874	1	1	2241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuWGjnN9R6j3dXfAy81VsX43s4YzuMcTAfbCnnXjexTSWBkEs
8615	payment	1397	1397	1678	1	1	5268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzM4kFLQJprz5T2i71eHP9AoM98do7Sy4iem3kvS7Lz2Q8WUdh
8616	payment	1397	1397	1678	1	1	5269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqahF5naxJRZsmnMRzH4jxm6t45XantsMsjD52b1Y9T4icDqf
8617	payment	1726	1726	1874	1	1	2242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrva3SfaA3rkCDCMPkrd3dTJTcYyYfewUhAaDsBwzUPU8qwALV
8618	payment	1726	1726	1874	1	1	2243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrTQ8czVyEjDwvWkzezK7hvWxjDaKv1XvWSqPSXf9Q1fJxGkq
8619	payment	1726	1726	1874	1	1	2244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5iZTZqBGNK6ASuZ5znqws4dY4u7xd8WAoXLMCXqsjHsAAZZ8
8620	payment	1726	1726	1874	1	1	2245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgBtEGXkg1HCFx8jEVVW7fVqmHUALqnqHx6mhqLnxTfA6oJrta
8621	payment	1397	1397	1678	1	1	5270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTWFnfTY4ftRYkXeC9odQPPHoe94TeAHm6mYccV6SnbUMoLy9
8622	payment	1397	1397	1678	1	1	5271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieAEVXisZ5uY9h9gPGfMRAr9ijn6GRUk29qJrEKsiQuJFmGbQ
8623	payment	1397	1397	1678	1	1	5272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9UCgLPQBEaHgXiQEHRyT7Ymx2bsp6t2dq5MuARccBfjjV18n
8648	payment	1449	1449	1939	1	1	2	700000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87xNsNt2tMyQHKY6ruYZuaGgRaRNkVtXbZnxtb9cQktEyUHiD
8663	payment	1397	1397	1678	1	1	5291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmsRfsWz1UKNG11drb54AGn3L4eUYQMTxSCSGcL5Apr3XQgEJH
8664	payment	1726	1726	1874	1	1	2265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFiTV4aUBzASoy7HFjfE2zgvw4xHmNY8UEdZUVgxFMoPYMYvtX
8680	payment	1397	1397	1678	1	1	5299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEqJpYL7jhYFDWHexkdJ19Svz65CCSg66kvi5K2DPxxbCv4Jv
8681	payment	1726	1726	1874	1	1	2272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzxQwdfQDKyetYQSh43UjBJhvyzkYifw9jbJNbv8waXLkPWQJ
8688	payment	1397	1397	1678	1	1	5303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2sLBGA43NhJDJ52y6dPUBwnERzNxpo8ZrN9fgTX32NKccVcG
8689	payment	1726	1726	1874	1	1	2276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9iM38JZXhbAknLH2hdnvMHStmxm1zF3ZUqbPEz7EzHxUC47Se
8609	payment	1397	1397	1678	1	1	5265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7i47SJk2GHcrhkBoaQjF1W13wzq5PmcUuB6kXhF4iDB2bPNn
8624	payment	1726	1726	1874	1	1	2246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohBUrnDBdhczSPpijkGXg8UsQ4Wmo7xvqQnaD5RHLghsLNmE9
8625	payment	1397	1397	1678	1	1	5273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5ZyrfCv3VYDTaohhBwyQKKiQ48E45s9YoJtuQHjek6x3PeoD
8628	payment	1726	1726	1874	1	1	2248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6K513nQWZinzJHFRCTgRS8PRP1SgyRjTeTxqt5J4cFNgRZmx
8629	payment	1726	1726	1874	1	1	2249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6XCQVDkyikXsSEVmWi9AzQgk1z5QQvG7FKxn1DnaP5Zn4KmE
8630	payment	1397	1397	1678	1	1	5275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4o1hD1tJHBdZYjtP4emzWLkrNVgPdRv5V1BqFqPpG7a7eh945
8631	payment	1397	1397	1678	1	1	5276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACgeHdhQu8txmENR13oYewjkYn3xmPqxd2yV4XebDq9Yx5pMB
8632	payment	1397	1397	1678	1	1	5277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz49XrNRx1xTWYrJ5WuqRhvxtU3EtT8Hxw9F7smN3JqQeEcUKo
8633	payment	1397	1397	1678	1	1	5278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhe1C5H1bZtsTXBVLkdoad2pjmxGHKfpvtAaqcdH2ePhiWmkQ2
8634	payment	1726	1726	1874	1	1	2250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKJqLLnkbNLR5Aubm7qNJfMQYgfpmyN9nZwU6UhYy51STF2y9
8635	payment	1726	1726	1874	1	1	2251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNyvQSf7EUx4TQn847b6keVZitySeG4cxjnahPhSP2sXyUUfq
8636	payment	1726	1726	1874	1	1	2252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbaxXiTQm3whidhVQa6kjRJ13Yn1uyHVCKNr6VnG4rbZ6mCyp
8637	payment	1397	1397	1678	1	1	5279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAakae1TZnGxqnJS6eawrcfPwRApGJaZ2xPbT81VdpjjxUdyW
8644	payment	1397	1397	1678	1	1	5283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCtmBPoJ9hnPBAYiGHbHBoKokF9khVY4Ndwcxh1VeFocSkAhZ
8645	payment	1397	1397	1678	1	1	5284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxmDRxC6ge7NaNbTNAAbQNpqgakszWpzMdnywE9NQPVNsvCch
8646	payment	1726	1726	1874	1	1	2256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk9LzkTb8qTDWnQY7C3jQcBbkxRx4m7Xj89n2eSASoxF1HtkF
8647	payment	1726	1726	1874	1	1	2257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkxtJ3LKxNw3Jk3mCu3YSyhyRcPwe84GzmNFjDZKbo72jStDh
8649	delegation	1939	1939	1449	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVXcntui9sxdcBFpuVWEsaPu48Ke93QGQchuKnTjtzN1MWp6U
8650	payment	1397	1397	1678	1	1	5285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZeVse1QmKUtxRpRKvztdDRMWzrJm2sb4mQgs85fRD7L1M8Gob
8651	payment	1726	1726	1874	1	1	2258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4G4eunAZcn1P3EanYyiZWUMDNGDPATsAss4PweU54nhkXJjvc
8659	payment	1397	1397	1678	1	1	5289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqxJVJMZEQSpohTUdmzG2m9cCqMaqFwKQKPGfPSffeq5m9Ef5
8660	payment	1397	1397	1678	1	1	5290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjYMSsbNBUtWAAEQtsb4XgmtDD3LyUMPXiLj7ohnC21o4HE6e
8661	payment	1726	1726	1874	1	1	2263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmT15oYuwwCqTnAB9Hc3vP3DqhPm3FxQSfdduK6Q66f5PFg8kF
8662	payment	1726	1726	1874	1	1	2264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUP8Lbzm6AEdHsApfN5vvfNW11WEdjxG3axro3JWujSZswoqpk
8669	payment	1397	1397	1678	1	1	5294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWaq6ytxUF6QGeQxG5UUi3MJPvdkAVHmsJ3NwzZFQAB6jEr1V
8670	payment	1726	1726	1874	1	1	2268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqrqyrxw9iZzMpFL5VmjspuaoiMDxLurkQCjWgCn5ucRfZfnk
8671	payment	1397	1397	1678	1	1	5295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3WG7dBgSh2sAYWNHnzNbNqwNoQztwucvziEqSM78c3zVAyci
8672	payment	1726	1726	1874	1	1	2269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3twAnGUWbqjNiWRG3U7WW7u3ZU4jbUbc4QWiU6Ge8ZeNP6UH
8675	payment	1397	1397	1678	1	1	5297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWirQKuz6A1kSiRb2QcJpPCQncS2iZUF3wCB61VFyZdGPp4UGC
8676	payment	1726	1726	1874	1	1	2270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnCa8C3dghqCyCBQ39wWHynk9VrMZxVGArfoK2FvokQmN32S5
8677	payment	1726	1726	1874	1	1	2271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ1oJ7Rrn43eTmfRf8EwezfV8SjE6gvZDuFsumyYFTYs2Yd7cc
8678	payment	1397	1397	1678	1	1	5298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFLhEu84h3TNFt6AhpHdMSHdDbU9GKV2q3NGoRx7MtSrUyTcK
8679	delegation	563	563	1899	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JuAumhzrbS3ETsRRgN7uGBJKFAS2DjkwdkFH7fiPnCozNcTy
8686	payment	1397	1397	1678	1	1	5302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsSLMXGoZZs7a6WU8BgVmPABpVi7qfdJpeaKPZxXhJnM4yPd3Z
8694	payment	1726	1726	1874	1	1	2279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtFEcojsv33QBTM9Yc3JFXEcYbNuJEDNdw9YN7H6fWYvCaLKX
8695	payment	1397	1397	1678	1	1	5306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhj4ngxxrLoaLwSnL5gJm8RXU8A8L3W37JDD8wt18f1Rrqbv7o
8703	payment	498	498	1956	1	1	0	2000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPV5oKWXPt6CZ7y4GS4QTTF6gzx4o2Yk8C97HVT9NNMJ4jrfR
8704	payment	1397	1397	1678	1	1	5310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TN35ZPMxtEHaTr14XTB46r5wNT5oPPEmHAYJSTRpwLMfQQSy
8657	payment	1726	1726	1874	1	1	2262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirnyrYBHCjJ3A8gWXXyDu77zuf8NwuXbZ2GKnembKuwiB1tx9
8658	payment	1397	1397	1678	1	1	5288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcs9T1SV2Gzvizhns67R6ZapDXbWAqVLoaZSSdJJQEHsdXbxHg
8665	payment	1397	1397	1678	1	1	5292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScc6r9pQw8638jXY3SyXbJcgKzqX3N8eFW5MFCsJokDUnv4y1
8666	payment	1726	1726	1874	1	1	2266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jW9pJaRGELjA1gkgCvJRLDTniUBQmN5VGjWtjf2rNexMhZno
8667	payment	1726	1726	1874	1	1	2267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoG4Y1B5gvvR2Hbgwtkxrjd41yyEMx95Nu1AX5D2q8wQkJjWZ
8668	payment	1397	1397	1678	1	1	5293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YJior8jSPLi4Yyh8EEouP9h7WGik3UqWx9KYNXAcDB1tsrqs
8682	payment	1726	1726	1874	1	1	2273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwWeK69jtmJihfHpJUApNqsP5AFgtu1ewNgeBKPZcskruSsT55
8683	payment	1397	1397	1678	1	1	5300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAv6s1Bqjdt6msaAJKdyrPPuD3G1YpyvxXXu9zNdyFnZEevzJD
8684	payment	1726	1726	1874	1	1	2274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFkBKKhi58UDAdjQfRTH8pGj4bfuqHzcCy2NgD2ZNVfHNTdZ8
8685	payment	1397	1397	1678	1	1	5301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRWaMRv9iZJ3x28qyCWSZUGdtfmvPDxj3iCnqrao4FmSLqRfa
8687	payment	1726	1726	1874	1	1	2275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvgud5YYDQaxqRFUrypa23NHF9rwxhbqBQd7L9D46eovhjZY2
8708	payment	1397	1397	1678	1	1	5312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS25bCRxFxfQMy2ijmc1nmsjumVPcRZJxUPpJ2RAy6tQNoMXS
8709	payment	1397	1397	1678	1	1	5313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehxUV6UqBbjnNtwmVQhHYR5EjmpYFxt5E5GPb2UkzV7CbNHNA
8710	payment	1726	1726	1874	1	1	2285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28DB2Q5CCo5sCZVjHmo65uN8PeB21jXsBFJ78HpZMkbBVH2d4
8711	payment	1726	1726	1874	1	1	2286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjeMwXkYhQZYPCRF9tgpDtj4Bh7e5Xweb5sVg1TC2A7KaUsdV
8720	payment	1397	1397	1678	1	1	5317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EYGFP1PNJJCNZjwPwpkYnGwEoNYSaiSJzaxjbEF8cmQhkesQ
8721	payment	1726	1726	1874	1	1	2292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnirFbAmsUzdEqtKcN7HGrfZiU5vSegSRQbpfi6ytZSktLLbdu
8742	delegation	724	724	1956	1	1	3	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQej7F8tqDcfYSgxwofC6CvVhNR43j7LL92mewgCujxqEaD4JJ
8743	payment	1726	1726	1874	1	1	2302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWokADmogi6htoaz32mZ8Fp97xRMX8G1MHusJ5sXVdBd2bWtGi
8744	payment	1397	1397	1678	1	1	5327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5xntE8QwSF7H59jeUf6oC1D4hdYyAxPSeLtjNJ9KB5TEGnDX
8745	payment	1397	1397	1678	1	1	5328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQco5YmKEcDtW7RTwrngmDRxZZGudLdvpxMzExJLXMuqt8pM6i
8746	payment	1726	1726	1874	1	1	2303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz5ZWqZdzXmvr2A7KsaqNA91M1L5ya8xeRtkbt9kxdrfdyidX
8747	payment	1726	1726	1874	1	1	2304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTihYTbiSpPQjuhwxnppc35BVfZWANjcPYpQUsHTrtZS7L9ebK
8748	payment	1397	1397	1678	1	1	5329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3KN2oGUd5QDUoaKqPCtZaneqyDhwczBEfvDBYTsgpEc83Y3u
8753	payment	1726	1726	1874	1	1	2307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9L55hkjVxqyCYVvGz5Ss7zTKELcs28M5dkYGxY5nFJnTJUfE
8754	payment	1397	1397	1678	1	1	5332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAC7V2vtkNL2vt96SWiytbcx7u1Q9Qynp5WGveSxwHEJ48rfw
8755	delegation	498	498	1956	1	1	1	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTjsKEnhu6q42JqWBY2QViVKARZBMZ8wQw3wUahTbzxjGcAd3
8756	payment	1726	1726	1874	1	1	2308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodj9WDnZNCW6FbcDq7eEJfFytBvPkvywrszrfA4ZCDAs253U3
8757	payment	1397	1397	1678	1	1	5333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbVHBq7miuDjhTMe1jaAPn6cZR34TkQrR1v3KMQaYweB94dbr
8801	payment	1726	1726	1874	1	1	2326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPUw6uwud9CEzQj9pUvdRvXSdzXDgSNmHcVSTfH2LhcXK1iV8
8802	payment	1397	1397	1678	1	1	5352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXc8xirHp4SDVsqyoXnB51xdh4a28bd9akX6Ln9DJP1PhviK2
8811	payment	1726	1726	1874	1	1	2329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSBtwg5cLax4RQQt5MYFGCNpDKhVYuwDDXqXSczhSxL78opApJ
8812	payment	1726	1726	1874	1	1	2330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKdQkfo9Cz1rCqQn5AZjZSMmvHPbhxojsnYXeUEKh4Z1t4Xmg
8813	payment	1397	1397	1678	1	1	5356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TQd4AFNHrFvkprzm6Qrxye2jLSLtpE21muQR9T8gHixRvnSX
8814	payment	1397	1397	1678	1	1	5357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15VYXwQ3hg5zvnmot9e9wZTARUP1TVdiTQSWjEqXHui7aMZC9
8819	payment	1397	1397	1678	1	1	5360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCdH7rBxAjfr67SherD4erQGhDZURjhf7qEZw1KmfJJguF3dn
8820	payment	1726	1726	1874	1	1	2333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4LgUerK4aQoHFn2kqBnGs2632Dn5Pj67KHy47WYyMsxfTGvK
8834	payment	1726	1726	1874	1	1	2340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6vWQwF9aQZnUbc3nqdXNoA8geyA9ganbd89j7XUwJMHTEeYs
8700	payment	1726	1726	1874	1	1	2281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FHQUbfcPTquAeTcMwKwcTY42FXvmt35pznVv2eyRHg5zBDXz
8701	payment	1726	1726	1874	1	1	2282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDsJ8k8Ltk6m5apYpLgY1vczv63m96w26B94B14wNYBhYsDXd
8702	payment	44	44	9	1	1	1	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNSnHSyMp2NkMnSSuHwDaNXcvTfCncwitJg2vzfUYbmCzw3z4
8718	payment	1397	1397	1678	1	1	5316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzNfRfkS2YyqZKeyydqzyQdWo5eaiTyZwqkKCamDTcYrbWzUW
8719	payment	1726	1726	1874	1	1	2291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTS255iqHVevW1tqGShJNDgKXt3yxuw3v6Nosa9LeWzgvwhRFN
8722	delegation	528	528	1474	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuUbsnneZZQPF6cQbmgVmsXFpcsabceSy4EPqy2cFpB8pojd9
8723	payment	1726	1726	1874	1	1	2293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFZ4hLtqAdTC7TQQphR1A1DLeKVCKcxwpbYqs2Eq5oii8VaUo
8724	payment	1726	1726	1874	1	1	2294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuYUcXorh1aKFLYjxLFuWWmmsymwGQCfKnEBmJZrqUNj2mHZv
8725	payment	1726	1726	1874	1	1	2295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ADNT6FvZaNoQidHgLr5fuMEMPKJcCzoC4H4K6ApjX63FRtYY
8726	payment	1397	1397	1678	1	1	5318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHqsU85sfKjrGkp4EC7L285XaXjZYBL2usADpJnNvgpYWZHLtV
8727	payment	1397	1397	1678	1	1	5319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd78GG8DD4saXJVkFwPYW6YHPqVDTbQvVwgrceT537W1pZxoRv
8728	payment	1397	1397	1678	1	1	5320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jhZkCx6L4XgQeKkx8JFJmHZZc8wi3tEXcWwxEa6TAfubsaxB
8729	payment	1726	1726	1874	1	1	2296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztS7FvsWXQFkBsXJ3CnvizjBESr9nyS1tvQeFE53S2pMvzUyx
8730	payment	1397	1397	1678	1	1	5321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmTMDhkSkfs7gotXfvSrT43NNLdsbioq4dWT4GYzi9zQFyc4U
8735	payment	1726	1726	1874	1	1	2299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozcKKtbgVpCftoNU6xeSt9zEzWrLSrjjyUaBgva6hE5Jt8Cy6
8736	payment	1397	1397	1678	1	1	5324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6W4g8qJncgGPY9688cE7yXBYzbTmZFPiK56tqrD1xRpARb2oj
8737	payment	1726	1726	1874	1	1	2300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7Jei1qZLDtL5dGd8sJJfGfBuZmXYi4nKLMgM1bc4tSQG26jK
8738	payment	1397	1397	1678	1	1	5325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVH9BHLhqhyZKAWhgGvMJG2yxLaHzZy4iCqP81yzdZuYsaNXLA
8762	payment	1726	1726	1874	1	1	2311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MAdBmxCYX7Yy5eqGELGKLgA5MktcaDCV3hfh7c2w7m6TSUju
8763	payment	1397	1397	1678	1	1	5336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNaPh2qS48foFJED3mvQKbJaNmCGhLcaSmaP6mjW7js6f1KzL
8764	payment	1397	1397	1678	1	1	5337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifbeQtnTTKSvJpYz8LtjbfySdqmLiBVwJL56VaGZHVrQorxro
8769	payment	1726	1726	1874	1	1	2314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDVjuEsqRa2S1RrnbQFZzn5XpQ2mgyHAvUReLv244JUKA6ARA
8770	payment	1397	1397	1678	1	1	5340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLp3tAe1CEuVRpZArAGYzMvPpYjNgSPatSvnPD5gy8M4ZDuuP
8771	payment	1397	1397	1678	1	1	5341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVAesUMRF9oCagHbsde9YFaCfHZ7vLN2CMMGUzLnt8fEfGp2d
8772	payment	1726	1726	1874	1	1	2315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoREMpaAumJJGS6ZaPMhW4bGzJe2x8krWnSubC2csFJpQbvvJy
8779	payment	1397	1397	1678	1	1	5344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uer5EXmrdrbKSDBHzrP276FGJSfcfzRJTRB5zYUP7xXDHuQm
8780	payment	1397	1397	1678	1	1	5345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5yKyzaR1DCQctFXMw2UShGxx3KF1r6MHPET1fqSHBYCsVjaZ
8781	payment	1726	1726	1874	1	1	2318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6jU4kubPt863TbsZ6EjVmimzCj3mzbMv5pZpGqCHZXkSmHoo
8782	payment	1726	1726	1874	1	1	2319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjHP5rcjik2L7ozkCr8Jwv457GdmZmhDsq9TcY6dTJCCWcTzu
8783	delegation	9	9	44	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbo5UFoRdWBF6JVCuP7YLiSydk5kn9xgXnjagRn31xsJsfKRP
8791	payment	1670	1670	1036	1	1	2	5157000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxqihjuipiim3DM8Y771b6DHGaM1hs6WsbNM8R3vpYRDBixAf
8792	payment	1726	1726	1874	1	1	2322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaAMjkJTEvWFCFGsqx1UHZTw8k4bjGdt1Szh82e1vc4PnYygQ
8793	payment	1726	1726	1874	1	1	2323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6eXqp3YPj1xzfnechnuPqSgzWY9EHFuYNhPiPx8pqmkiGzZ4n
8794	payment	1397	1397	1678	1	1	5348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQpW2cqUcjqM35KB9fF9GLRZc9785U1uXY4t9vbQs8Stu3gCX
8795	payment	1397	1397	1678	1	1	5349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7XSgHBL1ajn6ck67cu9aaD4M9d9ZMMBQw3e46PifLvte2oi8
8803	payment	1670	1670	916	1	1	4	2878000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6w9TGYYTxB3hfvu9dzMQXTtKupwQLWPoBy7e6hxvjWtkUSUWJ
8804	payment	1397	1397	1678	1	1	5353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxh2WWZY38VC5R5jLMR566GcyoseMNSoxhFgQ4YbXdoyBjexC
8805	payment	1726	1726	1874	1	1	2327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3SxbTQcwY6Ja6uSAafccDSzCBStoUz8z2dSx5tbUeNFR8RQn
8705	payment	1726	1726	1874	1	1	2283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwVFJTk8JHvAHgoewNSPfdbWYDLN2JZE2VadsF2ioLd4qJ1ar
8706	payment	1726	1726	1874	1	1	2284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mt6HM9sxCtShum3t2Sdjf2rMWXsGcWAdESu7oZ5NYRf732mr
8707	payment	1397	1397	1678	1	1	5311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFPj76P9pLDQxejtaYLuz5iCUw8AyzptXYvRnH35jh9KA2eFt
8731	payment	1397	1397	1678	1	1	5322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJWC3B77mCBKB38sTRwGatNrcMG4nRt1H6hgRQSG1eqk43YQo
8732	payment	1726	1726	1874	1	1	2297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikG1JKwQngAVbxTysUGeF2anPTLiPM3rZGhQ7smbZ5eRBXaPg
8739	payment	724	724	1956	1	1	2	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRqxB5DAv6oB32tV9nBwaomLXZATkHwrUV6AeGsiFUghvsFyx
8740	payment	1397	1397	1678	1	1	5326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fE4C5zFzuyFF665WyuQjgF8i6N1AVucWtYmt3YT7o5Zt1mGZ
8741	payment	1726	1726	1874	1	1	2301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVx9Cu9DHpYdw65Unc4m1bCcehik2dQNGcCJanefvSQMCDfmy
8749	payment	1726	1726	1874	1	1	2305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SoPVSTqUSEgQ4RAk1ayNr8X6U63JsBqC3VNPcMfhguCbTv4J
8750	payment	1726	1726	1874	1	1	2306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Fkupz9K3FJYWyGZBy227mDzDuqqgEzrUoAhkeGuitz8ZGYSo
8751	payment	1397	1397	1678	1	1	5330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjNrh6q83HLsn5t5PsLAcTDciSsqr4RkDhUBhpRn3dAk7aHcY
8752	payment	1397	1397	1678	1	1	5331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7648eM6fQn39yNQTN9KbDdXaRWQjqkQRrsoG33yVpYjSM5iY
8765	payment	1397	1397	1678	1	1	5338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP71cWeWan933gJ4j4sbR6qRAozoHmVytoCCd1kB9JqfmJwTXo
8766	payment	1726	1726	1874	1	1	2312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVVdJWx3xVKGQUtfNMwPeLP5SS5oWHuevHv77P142vBRyT4dd
8767	payment	1397	1397	1678	1	1	5339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zjuV93J6FFD8E3QTdipKu7mSKsaPDEvc9czvYdUFw8WsZEMN
8768	payment	1726	1726	1874	1	1	2313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9Qb4yeee5RvDb4yFEbZ7s3tSySQshMjLpgWYd8WY2zha4rcf
8773	payment	1670	1670	1977	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qReLmGpRoLnHGnK4ptpK4itZPiexQwBXU6KtyfuxoHh65dax
8774	payment	1726	1726	1874	1	1	2316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uooEKRXti3hxBGAeJjU6raCbJjSkH5hZMt9ombJByLs7pYBJ
8775	payment	411	411	1950	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWQUV7xd5UQjktZTuntVCUcMuGcAp8Sr3HJKdLc1NLgtsbxaQ
8776	payment	1397	1397	1678	1	1	5342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkEQCYzheiM4WWpXbxaNvk6bTUWDiBSm6xwQNSLsqK8HcNGVk
8777	payment	1397	1397	1678	1	1	5343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxtZtzeCKxnsiMgQyB5KH5UcHzHH3JD8XJ5NyHE7JUBdWL65P
8778	payment	1726	1726	1874	1	1	2317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBoasxA6DDZ61xQysW1na4zgAgBkKmxqCV6mri7WcNAJE27a8
8789	payment	1397	1397	1678	1	1	5347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNmRhQAmmeznzRowCZLVBFoX7fWueJ6CTUxTrH8UgmbWruFF3g
8790	payment	1726	1726	1874	1	1	2321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsenzQvUeiPtiVREqrweMgts9qEtouK64jcQifoj5zY6Sc7fMC
8806	payment	1670	1670	1977	1	1	5	1109000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYowsh3LzFN4TQ5HSgqcszjauELaSFDeB9n1hurWKueGUiTZTus
8807	payment	1950	1950	1971	1	1	2	228570000000	100000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpZtNmXaUZVJXFzCKBvdBrWM3hrdrk6irKWgQ3kQ2n16H8J122tT
8808	payment	1397	1397	1678	1	1	5354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmPU1h694mqmnVgAN1DGaBLMfe1ffVgr4vVqj1rfNongQL8kc
8809	payment	1397	1397	1678	1	1	5355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyNTvZq8iFpchtj5oeceWqWMExinNhqQAimF3Mty1FyFbDkit
8810	payment	1726	1726	1874	1	1	2328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CcVZVsxQheD3786UUdvWxVsY6YqWqqtBErgu9QJwzpPadZUD
8817	payment	1397	1397	1678	1	1	5359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntkvPuHwGmkVot85XFmQcmgEPWKgSBNqkLS4D3ZKibNmKi5KU
8818	payment	1726	1726	1874	1	1	2332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw3d3DHPfnH8um4J9sDAp9KVhSiLPVJANscnCWRk4YwnfVR5ki
8821	payment	1397	1397	1678	1	1	5361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoDqyjDmG3CPac3SfqzJYopmcMzNkirNbrSUDrg9PwkQPmJGV
8822	payment	1397	1397	1678	1	1	5362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg94cSksMVUKjzPmisDiqS8kEnABegzSitgGwtSDQkTq6rxsp9
8823	payment	1726	1726	1874	1	1	2334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSxt9HRt43E2wzwxE8QrxUuLYzouxJiXgrAC351cfxj1KT1Uf
8824	payment	1726	1726	1874	1	1	2335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyUagycJ7NoCxTK7o3QyQEh4QRxz8a6yQEvYmvPnkVJvZzzSM
8830	payment	1397	1397	1678	1	1	5366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6WQ3MnW3LJEhW141jox495HNhWnkuuqMDQcXFMG1QdxFhzMh
8831	payment	1397	1397	1678	1	1	5367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xQ3W9Q4tPhmm2P6CZ5XZQSBVM5WTxfVpfA1dc5kUN5PBVivD
8832	payment	1726	1726	1874	1	1	2338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFQtSir9222NCYJxsAsbcTMvophzPanjHd8ihDJrrWoASUkzr
8712	payment	1397	1397	1678	1	1	5314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRyiRHo2gVPNSpWbzgqegQWbC2i4X9MkbcTG53MuA1tqezq2d
8713	payment	1726	1726	1874	1	1	2287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4rH95sv64FcaH5RSx1GpBugrosfBwwMxDqi8iUgQc1GAjiZe
8714	payment	1726	1726	1974	1	1	2288	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6MVx8ngqt4aJ9vyyKsAT4zbHYKhzjFPotQv3UAK2AteMC1vPj
8715	payment	1726	1726	1975	1	1	2289	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYe3YgQZnkpVBJCgfe8QMZYwD65Baayxvq3A1ANKE4ogGYGnVPg
8716	payment	1397	1397	1678	1	1	5315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYL4f9pJ1VC553BsLeKy5H92LoAmiTVK4YH8MctJYw1aCK6EX
8717	payment	1726	1726	1874	1	1	2290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoswNT7J3ggCb2U2FX1oT31EKn4oBaLnCHTMXt2z2ivfBUwobj
8733	payment	1726	1726	1976	1	1	2298	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa7nEMfHmhhM9CsZ6wE5VfbXBYPCP291ymeyWvJfsE6rwBRDVT8
8734	payment	1397	1397	1678	1	1	5323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBU9xseosib3dpgR6ByP4HqRHY5gBZhnGhf8ugVBa2noX2zFF
8758	payment	1726	1726	1874	1	1	2309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVeSjzhtf4bPzacscpCJwR4jt3LrwoxjG3VowWHZ7UZuA3vrF
8759	payment	1397	1397	1678	1	1	5334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPNMmUWXEP88pxedEB9aVZEUnBN5FThwX9jN4Vj5JrLLMJMaY
8760	payment	1726	1726	1874	1	1	2310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Tu2Ng1emkK8bzMQpd2LJd2ZPLDceDhQqBf6fhS6Mdf7PBv76
8761	payment	1397	1397	1678	1	1	5335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKauwJKtzuA2jCpx6acZ76tEvaLwQLULnbZYLn1dRpW2JXFkS
8784	payment	1670	1670	1282	1	1	1	9694000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKTg1ckGRWub1P8qzcSAC6h77tkSXDHBQ27yqCq21j3sCNRmF
8785	payment	411	411	1950	1	1	1	300000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkrBkKvrCgJBr8ohpWbebZBNhUBd1bC5zQQQdNDuYXibZk5Au
8786	payment	1397	1397	1678	1	1	5346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqrA8g7897T3R7n1MvKnCPBv122PXpzvShMo5E3mMu61KnPKM
8787	payment	1726	1726	1874	1	1	2320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTEUtjGt5sSXbrtq6sDWyfTKtAjmaAjmoy8J9Rt6c7ABjzmD8
8788	payment	9	9	1474	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDL9AMmWL67ETsytqq86af7y4NnAJqcRgC6bp7fjEJAc9f6Z6j
8796	payment	1670	1670	1156	1	1	3	3480000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyibyhhmecD6eaMCMWzGqSXnBN3LZDJxZkzMYwc95QTJLFp4BL
8797	payment	1397	1397	1678	1	1	5350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfX6gEALECSiJGXBsGavzmhJKqHq4D38R4zG3UvQBtvCo8cgh
8798	payment	1397	1397	1678	1	1	5351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUAmGzxovi62g18VEwManAw5aV8kgdVPNCzeDCkitQtvMak1J2
8799	payment	1726	1726	1874	1	1	2324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuxFsQFvfDXmxrjtyensjxJMEvqcaiFCkc2iptGyooDtU4wmY
8800	payment	1726	1726	1874	1	1	2325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKvDWiuQfds3fjPTTWLGPEsZ5m6DHTAt1x1CMdqPtZFL26C5d
8815	payment	1726	1726	1874	1	1	2331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHqnDRDDemy6fQYUvU6brjkfGLCTLHiJ7veG7ESKAD5XEb5iq
8816	payment	1397	1397	1678	1	1	5358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpAqgxv51h3CJsCnxRoV1hczni5QiaFYN3fG1ZR8nnR6sHNNc
8825	payment	1397	1397	1678	1	1	5363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wcsnRQ5nJCp4u6t9M91eTQYeGYiPA38vHAHuVpfvymeh3ioP
8826	payment	1726	1726	1874	1	1	2336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94oHLAtY4gWDaPoPrFYPuKPxCisBn5HmtacAPhd2YKFQxKEb8
8838	payment	1397	1397	1678	1	1	5370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNT1yo4otqVpArG8HT49RfM75Fxfq1Tv4d4rm2VyMuQiHym27d
8839	payment	1726	1726	1874	1	1	2342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtBUUHvSNK96En2y6wxtZ9eHLjTQMfRbpFuM1xkRxm6PT6Tu6
8880	payment	1950	1950	1950	1	1	3	600000000000	10000000	\N	E4YaTnTqqzfkFWbMz8sCXmEyT5z4BoxNMWi6eJx8pNiXNuL2un8td	CkpYbMzrrz8Wv6y3tkGESNVdgGSPNL3kzSoHXhkjeWxtbJwWi5huV
8881	payment	1726	1726	1874	1	1	2361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWW9WERwpuBxdK6VHAMaqQDhvavA1zgmAgbVe6kjQZ2LydaJX
8882	payment	1397	1397	1678	1	1	5389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8Q5rsqqNthgnMgk6999ecJGCzadhAFhSwCPhTwajwBmisUfp
8883	payment	1397	1397	1678	1	1	5390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3htEg3M2zHca3F3rtvJ6SW63vDLunW5EipadtByiAn7MNdhR
8884	payment	1726	1726	1874	1	1	2362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgc33W3rV8bbrkotriNd58QzoCPKxcEhEL3wj6KJTUVHrQr8D1
8885	payment	1397	1397	1678	1	1	5391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27gMjTW5CBp6EaqADuVzxDX4iPDSxsh6U3PPrd4PWS4fWHtuH
8890	payment	1726	1726	1874	1	1	2365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuHZC8WAoKmPb8U6JyTksYRCz3JMrj1VHfhc5dd5uXNPrTPAV
8891	payment	1397	1397	1678	1	1	5394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jMqRBz1qMeDYD3aVsTJ4eRFm24Xu7fSRLbPoQiftzPUpv6bG
8898	payment	1726	1726	1874	1	1	2369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqkxLYzQ4GfLfSPQMBmYZk6UECeoTaFLNF8Jvjs9U7sHosAHb
8899	payment	1397	1397	1678	1	1	5398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmFo74cv4Dm3wPBSEzkXCBH8WPdPAB8ur746nkzPceWbS9QJN
8827	payment	1397	1397	1678	1	1	5364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCQDQWs6YQFoW1sqJdrovBWmgv9tycjXGXugbfoZK47j3Fwou
8828	payment	1726	1726	1874	1	1	2337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcoA3Hz8unrvswEyi4qRabwhADZ7H6d7LPXNbHAJv6VupDqqY
8829	payment	1397	1397	1678	1	1	5365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkRtTQNUd5Xn8m8ooWVuq2Cgj6tERVXkSsr6CCnGx14sGKsLB
8860	payment	1974	1974	1972	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRKQ1GykYVqqrekQCm2pkNrwVW86NR2i1nUWpbFMxDmUcTZ6C
8861	payment	1397	1397	1678	1	1	5380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjWLrt6GMS2YDHKzAesqxnUBUnpSxD3NivpAWYvzGYvdkHzv7
8862	payment	1726	1726	1874	1	1	2352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPz8ftNfQitL235pKksPznkm3yFNKUEY48c2PTtvpr2WJa4Nby
8869	payment	1726	1726	1874	1	1	2356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DHw82VYnvhq232tNVRf6xJkwQsizPcSuJ9e24SyJonXxZsuN
8870	payment	1397	1397	1678	1	1	5384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUoY7FQ4ExKiboxjGGz899ddUcdfgqKV5ZQykUySGkfQG6xti
8888	payment	1726	1726	1874	1	1	2364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJUDNtgZBTXNbPLEBrZFQh7ey78H8xMJ3VLpYjir6T3fSVLcK
8889	payment	1397	1397	1678	1	1	5393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TAns2mZyCyAMAxCivhaKPSydcFM3f4QPN4VsT34AYZg1fNbR
8892	payment	1726	1726	1874	1	1	2366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzv6dguKWzMwaT67YXvwHnfAv63UuGsjG4bdC87av4EKzam4f6
8893	payment	1726	1726	1874	1	1	2367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9RWhoiTnKGmsgJdxt4dqzTLwDCzEEhmwJ2Q19GVm8UhmCCYK
8894	payment	1397	1397	1678	1	1	5395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuk5hPmrpinECcsLSURjN124iNtDUeY4pjUrFRacLa5kZbQQP
8895	payment	1397	1397	1678	1	1	5396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3D3RntekunrrkSV4WJ7JwMgRXatb8Q1x1F77g2X6fPi71nXwU
8905	payment	1397	1397	1678	1	1	5401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTPazxLD2onNA6X5JKhvkTVDESa6BkhCod2XDCVBE2usQcb6F
8906	payment	1950	1950	1971	1	1	4	600000000000	10000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpaAvwSBxPBum14ThcohjNu7uis9KsD8bJYP4ypNavotFi9Sn8yH
8919	payment	1397	1397	1678	1	1	5407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTsfvBFTSRtBXRwjiNrm6q1ekXKcWHMzBG4Jj9PBJPqjcT3sj
8920	payment	1726	1726	1874	1	1	2377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsL67X6zXLWDiZCT2Y49XUeWrmWvJrwGwkC843aoaobTKEEW1F
8921	payment	1397	1397	1678	1	1	5408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44A4msAxuipzYjxLdfJwZnSmL4htTHazt4V8ZAqcNWAGMFyvB
8922	payment	1726	1726	1874	1	1	2378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uWQ8s1TcP5kk6Xw6mF1ozRsMtBXVbUSyiKhTsvwk9fDsHjPJ
8960	payment	1726	1726	1874	1	1	2395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRH1YkGZf4kE6utjaxUDZ3TNdLQCWJhH6DuFtGp4VGZzfnLDvS
8961	payment	1397	1397	1678	1	1	5425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FJmE7EBniva9uBakHihrCGwc2DVA3Aq7trrXDCAY8svLoRSa
8962	payment	1694	1694	57	1	1	6	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZSgXMJDV16T8a4C6i3bB1sMcJsGJVb6MJ6N5SFzD7h5hshHK7W
8963	delegation	1979	1979	1500	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn76SuPJBdw2NJ9o6scFuzeLsRCLjUjGjgUinSpjYqAWxFTHa6
8964	payment	1694	1694	60	1	1	7	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZur2fKEv6UEy5PCpkrAm6JAqhn9BJdeQ4FaxCaV7dY7xVhs8zs
8965	payment	1694	1694	61	1	1	8	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZBZyAmHRV8dZVAiip2Y3SHo9nWRozUBXFtPntmJSrzwCqiqFVE
8966	payment	1694	1694	21	1	1	9	223972906270	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYeyhgjNfDkykzkjeYAn7tW6uf2qLgdig6L9WtpXqLb6SHSAZ2p
8967	payment	1694	1694	52	1	1	10	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZvJh1f9CPna21o3shXcQd1qX3j6YavHEbdFuV66Si8zJMaENtD
8968	payment	1694	1694	73	1	1	11	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZ8sKsmCJpScXFSXEc7ULxwbkWEM7b2cPJJBd2Mvpvm7kxs1Xdc
8969	payment	1694	1694	68	1	1	12	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZS1F2RasfZVFaB9mDKpspiE5TNeKkpTWGkmPKFDn5H7WeJCLfU
8970	payment	1694	1694	67	1	1	13	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYeXPhMFkVgpywt8ksb4cCn1Cehd81bEwCH367hutVVnhzKSWYt
8971	payment	1694	1694	81	1	1	14	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZuGSCDw9vt23eA8WC1KceYMKc6BF2GB2v2gMyPjAHTFD7vecuZ
8972	payment	1694	1694	156	1	1	15	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa4aCKMqiswLLdEfZjL1oKQaVyBwkWTvTfSMVvbYcfmpqptcx9B
8973	payment	1694	1694	164	1	1	16	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZTHSfeqpLecdHZvZw9coc7Zdn8Lpk5WCQkD5n3BBuxorGuJcaU
8974	payment	1694	1694	129	1	1	17	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaD9Y1VmjcLcRVshbCDiy14Q13mTPEtPojsaev5V7wdJuHG9L8b
8975	payment	1694	1694	428	1	1	18	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZaskLBWCv1rEiLftjJykXBwwkSZ9D6fX5xrEFM37vPg4kdQ3HS
8976	payment	1694	1694	432	1	1	19	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYeQXaqCShF3kHVuUDBeGBvELyDbvf3gYgBY7pGAwWponk58FpS
8977	payment	1694	1694	433	1	1	20	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZPpsmApF7U2CP1d2mwoULE2ucmGMP3CLkiM7L3eyX6xbX4V1fm
8833	payment	1726	1726	1874	1	1	2339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9FzGhgBULtJGSKEgKu1mVpvv3yGdMF43PTDtAYNWETnYku58
8840	payment	1726	1726	1874	1	1	2343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqjYhBWHtTgTqKRJPANnznmDrTkmAFzDUvL1UGfpoQqy5z22K
8841	payment	1397	1397	1678	1	1	5371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJjgYUc3fp1rUYrRPjdbCFxL52N5edstRiDxkaC3yasZcWLC5
8846	payment	1726	1726	1874	1	1	2346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rV5hLEq4aWUiinKjHjzgQximmYTN9cxEWZVMTtqNDm3Rqqyr
8847	payment	1397	1397	1678	1	1	5374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpn3KArC8ACcggGcU7kAPLnsHQaoFYhy3YvDiEAZaNvrfGb9C
8848	payment	1764	1764	1950	1	1	2	200000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4prX55Yrne6fL38vGsprX3texFiFxW7okmdJAhUrfk1uoiWX
8849	payment	1726	1726	1874	1	1	2347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLD2CWsmDsvxPcLGJ1ypdKTL9PMrL9tygdKSxxeE1LAw8u1MJ
8850	payment	1397	1397	1678	1	1	5375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7nhPKvLUgkqB61YFheGtbWTZLmuSYeenYV32zRtut7QY73sL
8851	payment	1726	1726	1874	1	1	2348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyBwFGtrghqSu7gL1H1WWUbp8JMBFrFerW2MHebKaEB8VAsbM
8852	payment	1726	1726	1874	1	1	2349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaTcsqZJ7sDHxT6YUQpPcySY1CnS9Awb8iZdXut4QAM34swbn
8853	payment	1726	1726	1874	1	1	2350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhrWqbhCRhbujgNHrJhZh9AWCiFjpY4xvKwh5BMGuzkcVVaMp
8854	payment	1726	1726	1874	1	1	2351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdkMwRvgc7cMHNRSD64fJAKyqwSAnx3AQmo9tcYucqonWpX9A
8855	payment	1397	1397	1678	1	1	5376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8RAL6cVTk8CWvNH5EEwWEopeBt5C9XY1DbT6y9cgYzgsGD2H
8856	payment	1397	1397	1678	1	1	5377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68ibm8y11oi8TD2SKetYiCLL9tw5gvmSMwC5vQWprtJxL3D11
8857	payment	1397	1397	1678	1	1	5378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtr6Wo41MRb888ZNh2nRu5ConGKDnDCVSfKS9VSNF4g1VYbL4
8858	payment	1397	1397	1678	1	1	5379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjfixGjxnADPRaxQGoM3tPFpjy3cn6xtrceGbR4Z5jawFnAp6
8859	payment	1764	1764	1950	1	1	3	2800000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYma4dL2W6PpuSpszeujbqsQZQ1gmyamy5TLZs88YxZUvN8mRz7
8865	payment	1397	1397	1678	1	1	5382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphCEXe1xK4PW71LH8D4NHvw4HADq4xUj18zHz6zFDpHpb8eKM
8866	payment	1726	1726	1874	1	1	2354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZQLfWTfCMcATD9uEBKCb9bcpfwoakoSP2fdGqGPLqXdxXn67
8873	payment	1958	1958	1978	1	1	0	3000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs56nb5yWvr1GPv3rQiCF3KvWYj37GEt9WtaUmgCFhwWekFRdE
8874	payment	1726	1726	1874	1	1	2358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvoQeueaQzFHiUqsvefiwWsa2ZRQV4j9Hrhvau2DPetkkq1cA
8875	payment	1397	1397	1678	1	1	5386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFD6yvvff1581jLTLmiK2eDjkCvC1R6Y9rM3A6vm4BsTNuN4SQ
8876	payment	1726	1726	1874	1	1	2359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCTBFdE1p38LUBvrxL3ij5EVYoMP1hFjY5ZvjNZJteGaNMTbr
8877	payment	1397	1397	1678	1	1	5387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR32TZvuJxprFZ2tCfayHvccaWDTL7hYbi9wH5CqVkrKoUZ2pc
8907	payment	1726	1726	1874	1	1	2372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLQJ2baqomvEHY8gDhyrNVBiL5mtuJ5dZ3i9zKFDayNcV9KGn
8908	payment	1397	1397	1678	1	1	5402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61pYvs4nAYJ1hPnNwU8UkfrBShWJm4jG9v3kEZEU3WNUnbeRm
8915	payment	1397	1397	1678	1	1	5405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzq1kkNMXDoQVjqDLEm1re6sgb9pYCwDc15peBobgnZqqRL1q
8916	payment	1726	1726	1874	1	1	2375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjsyXC8PSiiq7oyoofYFnsaoUw3AzBVnYsbmLtViFjkefx6wu
8917	payment	1397	1397	1678	1	1	5406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2hMC3KHLEdZ3YC6ZaoAz2UTAFSnm5FXPEK48KtidoCs8xdbx
8918	payment	1726	1726	1874	1	1	2376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjpUikcfBzmtUNxEmzExp3SGuWTMxZixBkcdEsa7YyG8hiEEp
8928	payment	1726	1726	1874	1	1	2380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgapaf796aGE87zcs7cGWpcgTJL9nvWcnFgMJA6n5r42wZuneg
8929	payment	1397	1397	1678	1	1	5410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HtXduqMXiSZBZPJzTgxxn4SwwnfiDvC7bwaZGnq36CGLxbWN
8955	payment	1726	1726	1874	1	1	2393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRshDbv99uLwsZp74bXgkyS1VeCWPDpEzDqNvJ6QkPYcqhtFRv
8956	payment	1397	1397	1678	1	1	5423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4G98bAWvYTAAbpYCxUs5kCAo45sPSPktvdGshHweTyvjZgYE6
8957	payment	1709	1709	1979	1	1	5	1050000000	1000000	\N	E4Yq19AFkEW3GnivvBhHRxj5SBy2atsqGR8QwMG6WSYHVQ2mDZfbN	CkpZWKorrgSe3bd3h1FGLg7Cv9TtDfbw9H2ZAJ5Luq6QTZ7tf2HV2
8991	payment	1397	1397	1678	1	1	5426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxo8LhcaiSeb1aeTX2Jn9CokAFUaPAdPHPTSbRvZV8oxzn6cw
8992	payment	1726	1726	1874	1	1	2396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfTqj591wpWiwfRHHVpsbu8MBe2K93kWXdYsujBy4aoDx8q3g
9018	payment	1397	1397	1678	1	1	5437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNq7aqsyMABWqGW6a8YmA8W9r7YGoix7csnjdgbTVTW9i4evD
8835	payment	1726	1726	1874	1	1	2341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWQu49RTs5ZTnZj8fMKfBgueEadv8eRbg4EMJ3Q32FLmuJtag
8836	payment	1397	1397	1678	1	1	5368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPXLkNw5cst3S7HE3BxadXoii69rSkTuJ9BJdd6ajBcsCdLMr
8837	payment	1397	1397	1678	1	1	5369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJQs2367gGi8JcBiz5nXmCAc6txDSYm7VqDShCei2RQ3VNxhrj
8842	payment	1397	1397	1678	1	1	5372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fXZtSH6JprNuES95BYHnuS7PmUCHUXeT3iETpebtfjWfsMFz
8843	payment	1726	1726	1874	1	1	2344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHmzT9tQmhEXZtxfYfaeRPiHfquA3HQpuSrDMHnSJ6o7afrFC
8844	payment	1726	1726	1874	1	1	2345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqgXsB5barcVVLBishCJWEFaZ8MhmkqcsbBb9qVFRUEKQF87j
8845	payment	1397	1397	1678	1	1	5373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCvTiV5ZEMkhpCEr7vFdZnE4w77govTd5tnK4TdEH57M5Tpw8
8863	payment	1397	1397	1678	1	1	5381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqPBJ32GahKyWLq1pESaDaKeYA14mqt6C5jGFbUJTD17VZML1
8864	payment	1726	1726	1874	1	1	2353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcBwURjHUVdY62NS19cR2rhjV3iSwfU4jiecErquYss6XHX6T
8867	payment	1726	1726	1874	1	1	2355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm2CUzTqh2cdkLUgs2Mi1PMmhvEHuBGQm4fBZodLeHywTYaaL8
8868	payment	1397	1397	1678	1	1	5383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HvEuthYkQcd65KJvDZo9jmwBzQhBRoU941QYtircMqcZd5w6
8871	payment	1397	1397	1678	1	1	5385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVprx2HUe5AhFFXViwpzm8w2b5ktwhCpr7Aeiwwy9fxRRAVHpQ
8872	payment	1726	1726	1874	1	1	2357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvY3KMLDi1MzfD26oKLs7QGpwmHn7dGbWrZuiRceDFEvDD432A
8878	payment	1397	1397	1678	1	1	5388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPYyydyKPM9v1v1LtHxWk2YZLdEG4rMaxaqXfdbxdVB4dDseK
8879	payment	1726	1726	1874	1	1	2360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqXMbs2EHDEfzgcS5Uxh7SwcEii8mXVJm9tye1DoHiCJVnMny
8886	payment	1726	1726	1874	1	1	2363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxkfFtBsjv8NtcGawQocWrKsR8n9hkvXJyk35TCDdc1EJtk9Jb
8887	payment	1397	1397	1678	1	1	5392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvxgv1waAgn2jywsnUY29bYNsZ8HU4k9MFwWPHVn5XQwVPa38
8896	payment	1726	1726	1874	1	1	2368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLJR1JRdpYWGvNRUYAQFGUp8TdENsuabYE5N1rsGHEYDh1PGS
8897	payment	1397	1397	1678	1	1	5397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CZwjKnUzfZgxHp9afG5gEqdBYMr8J33Gaz4CHLHAeutE7YXT
8902	payment	1726	1726	1874	1	1	2371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4ayUZceFUhhypqvTQD1qjfwhmHYN8iTiuGx4Zm2n5r5W4tea
8903	payment	1397	1397	1678	1	1	5400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBW6PjUDqLSB6Z1PE2kMQXc5zQMGgKjrxTB44UCQtmSr8Kc8A
8904	payment	411	411	1950	1	1	2	300000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwi4FLcZdkfDkUdz8kfDfrZFoxDNYE1rh8CE2JnViVcfZB62Lj
8909	payment	1397	1397	1678	1	1	5403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgb812ZzZxh4mjbUeXHQNuuxgzwPUXPBrwHWKBFYeyziriRrv
8910	payment	1726	1726	1874	1	1	2373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1Hr72xjzaShQGBm4PVzDq8DhDHvgxU532GRFqoP3HjRYn7es
8911	payment	1726	1726	1874	1	1	2374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNUuAWPitx1XsF5pwcJec9WMwrTD5FoWNkFRZjRf6xzNBELNH
8912	payment	1397	1397	1678	1	1	5404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD79qPfzqksqMxPGhzNjJsCm4uUFe9Nw1NoituHkmDSDLJ5Kmi
8913	payment	1694	1694	1694	1	1	1	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaL4LMJpGnvt8xbe446ADo4JRLW35bMcG6GVbkjC4TJC6BprTNq
8914	payment	1694	1694	1694	1	1	2	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa8bVPTMWwVdtTMtPmZFEbP7T2MP2LnXyMzKYJQ98cmsMuuYhf6
8923	payment	1397	1397	1678	1	1	5409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvguj86w2ZvxfaaCn4BTCnoy6WNJ1MxJQ3dpW9TidbPfv2cxfp
8924	payment	1726	1726	1874	1	1	2379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbAQyfKpyredJ7KDfomMwf9UkZvrzk5pPovQAcszJeNT1dKg3
8925	payment	1694	1694	1694	1	1	3	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYryNJ8dZz7qsfn9XbcfXZqUAfrkv57YRcYLZR8aY8AYgW97KQ5
8926	payment	1694	1694	1694	1	1	4	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa6cuzs7u9MSXstCFhBN9zvSJDrZ5YrdNdz4v9kko3VtktVoZ57
8927	payment	1694	1694	1694	1	1	5	1	1000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYrUKuv5uh1x6Ev195iESDoog38U1QBkpApk1thKJQcxqyxumGM
8932	payment	1726	1726	1874	1	1	2382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2bpdN6cxrYqRffpQEupDbJeAiv9MnxCgrXhq1codcLDA9dSP
8933	payment	1397	1397	1678	1	1	5412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRNo944caQSkFvu3RKGwCNJNtMydP6ni3TUPWVNE6miPGLB67
8934	payment	1397	1397	1678	1	1	5413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDBgUZxakcz7Z3Si6VbuWkk3R8qricLAnNQ1edZ2MGVyXus87
8935	payment	1397	1397	1678	1	1	5414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLARnAGkmn4Wr45bsi4h3uo2ptb98ru9JyUiR26PwF6qvtsBL
8936	payment	1397	1397	1678	1	1	5415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PwLra44RyxrrsXwJrktYthUrxRPCbwCY4GSiNdf5KPiMhjAo
8900	payment	1726	1726	1874	1	1	2370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtpEw3Qd4Bm3Jq4scGiAA1Vyn6ZTsGT85x6LgYmLvb7mRYfgw
8901	payment	1397	1397	1678	1	1	5399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwe9UnxL7uGkTqJZ2gSpcT2Y4imqqyXpwith4vuScnJVNmxzt
8930	payment	1397	1397	1678	1	1	5411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6kq28j1d3MC842rLQpTns1DBaLvfcNumJyXMtut28CXoss9v
8931	payment	1726	1726	1874	1	1	2381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAhmRcbjzDxVesbCsZB6YwLWTYgcPRRiqKKnHXx1RpnQ41qKE
8942	payment	1397	1397	1678	1	1	5417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMjXZ2WJTHcRr3aZ9TPvrHYxAdEmk2sqMr6X5wuNJwrBeN3oY
8943	payment	1397	1397	1678	1	1	5418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmDcpfGGP2AjyAyhmzquj6b1a7npx3TXkYWTshfsAM1RukLMM
8944	payment	1397	1397	1678	1	1	5419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1fmx5sbM3g2jzS7o54cbjA5zQqk4eNfrmTY9CEGJGx8AxnDX
8945	payment	1726	1726	1874	1	1	2387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJ5Cee24xqZhGwb2MQqjjVqD7yqXBvtfN7WTfAFLAGtbRT14G
8946	payment	1726	1726	1874	1	1	2388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KqprEYDAR5Y3xQH5tviaVrXbmbUphMVWdPwfb1gmPK7Bcxz7
8947	payment	1726	1726	1874	1	1	2389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsGWB9zShPuMNFQqLcZEvwhuEdrfoUSeZZZLGPUxvipZFGqj2
8948	payment	1726	1726	1874	1	1	2390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4r2mk6Pb3MK4ZTSrxknd9MtSjRfxrcQqTLDvPxY7jBL4756iX
8949	payment	1397	1397	1678	1	1	5420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7W8aENAv1HnzLrwaWcrzXES7DFYZJ2avCQSo3dtsc2sZDW9a
8950	payment	1397	1397	1678	1	1	5421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPkxNuPWWejm3M1hT2ivJbHf93z62MovQ6LArU8vZjfKVptj7
8951	payment	1397	1397	1678	1	1	5422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtuCn6x8MuWXHLjwswc3sY2sMqqEPe7Th1UzHXK6pA2NhPYh2c
8952	payment	1709	1709	1979	1	1	4	50000000	10000000	\N	E4YfP93swBbqbega84WaSyB3raV9snhP7duK56gBtJ9hEUh7dqTHZ	Ckpa4kxSBiHtPWoCEkqpax6fDaSLXUHVw1D4W3tXvK34px5aaVe16
8953	payment	1726	1726	1874	1	1	2391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHve63yKHziEAfZiBFwU6yuyBGet2h5uJp6RsDXvLGTvmFfASY
8954	payment	1726	1726	1874	1	1	2392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQU9BvR8TBqKSWyFaAE3iPms6CzRznVYmqX1MYeG7EpCYkpKu
9003	payment	1397	1397	1678	1	1	5431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmhZvcnyefFeWL252uukxMq5mLJ8SkfuzAzUALbAoGDPsFzHT
9014	payment	1397	1397	1678	1	1	5435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xHcuQPCd5YrK2ptZA8LDJ1PHMyBBtdqWqSMFppKiM8RfZVnE
9015	payment	1726	1726	1874	1	1	2405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1kzLirmyAGCKt1mEahUcw9Gf64p8HpySUpJLrEwUmkcRnDR2
9016	payment	1726	1726	1874	1	1	2406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhioRgJLv9LTemp5eKTTS35okXPrMjX3yvBmuWRE7rVE9U7Ux7
9017	payment	1397	1397	1678	1	1	5436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Hw1SQLHxJnxenz3AnFPWFSTaXzHEQWx57fYZdnGQGR9QRhYA
9022	payment	1726	1726	1874	1	1	2409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULyfQAR7ZuQSUpZmx3zegbMNzZmfCBfCXN2UDi4VVYxNyZ3po
9023	payment	1397	1397	1678	1	1	5439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtuXdQEX87XTRGP7ks2Pu3EaysZX9LdMaQH6LDx8CF1fM7BGR
9050	payment	1397	1397	1678	1	1	5450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZh7DLkg1yUdTd4WPzkatmET9PJWpnRvpPW7AfTHYK3UMLbqk
9051	payment	1726	1726	1874	1	1	2419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8XgzW17nYe4e712GG2W1Fx4aK2mmycRS14Uucf31T7AY6yFj
9061	payment	1726	1726	1874	1	1	2424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnga8aHJkwwg4UTAbzMBThh7yRRSkGBgti4AA2CsfHAtA3TjSa
9062	payment	1397	1397	1678	1	1	5455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJNCCFo1gjEwD5TFuEuBFmD3qpkbp6eFK7feT9Jn6XoqacGgn
9070	payment	1726	1726	1874	1	1	2428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36N1zJXsCLtwgUEFw5SuoLbMeHf3aFcqQve8HZzrGAwF9TYf8
9071	payment	1397	1397	1678	1	1	5459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVucgWURtqGLPRmeuNQtgviWUfafjzZCLxeAERmystKQwRCb5z
9072	payment	1633	1633	1390	1	1	0	6566	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpaJEkLuqMLpTrLQ3hqypS3L1ypXc7ewhdKnyNAH2AsuB8QtpWbA
9073	payment	1633	1633	1144	1	1	1	3492	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZF6nkYbd3UfWkaTaHfBKJPknDzhTsvDrGgtJ7d6Br8PZm9YdsD
9074	payment	1633	1633	1264	1	1	2	2356	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZRfQzozqCHQ5fabJpykY79nsud5if2ZZWSF7F1dgCZd7nNmghg
9107	payment	1726	1726	1874	1	1	2438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhc1mjNrfN7THrSFu6F1iTYUGzUC2eEV8A1TjvihCJiZnyFUYq
9108	payment	1850	1850	1682	1	1	0	10000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	CkpYpZdteFbXCS4ycRsxXRSGMTGKd6pyjovfEAUF4S5aEtb4FCU89
9109	payment	1397	1397	1678	1	1	5471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqvMqY5F7oPxWUQKc2PpdFAZ39BsXxqbFXpFYzRUz43fuFXA9
9125	payment	1726	1726	1874	1	1	2442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZbrLFZtiAqSmXnCHd3DhP5RPeMVAR1iDBfYAdJuggBpfxUQG
9126	payment	1397	1397	1678	1	1	5475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxuFYz1JwzQ7pZkTmHiLtsnC3TDv8ETdhXJsMjVKwqt59zokW
8937	payment	1397	1397	1678	1	1	5416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpfrG1YFa8TicWEAukCdFff5r6NRzGDkEnzjd4NRsbdvEo6p3
8938	payment	1726	1726	1874	1	1	2383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFcNyWmdy2YGmLFAB3vQsEZY4RqiZnjNJJv8uesyT8eArHK2kK
8939	payment	1726	1726	1874	1	1	2384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfgRoadZdyUSk8feq49XKV1bjCcPHVD7kyC9ie4kHksuyFEgV
8940	payment	1726	1726	1874	1	1	2385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwAi2x4xW7ZY9hhrpqXkz3eQFkgYxFuvvdDmUDGSuLSrRq2bf
8941	payment	1726	1726	1874	1	1	2386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2EKuZkECsvDPYDP2Hu933v4f6FhD2kg5t9DDNqX9ZHy417tW
8958	payment	1726	1726	1874	1	1	2394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaL9Yn3oiT5or42LSsWSQad3CBzV1915LWcjqyBVTbXk3Us6CF
8959	payment	1397	1397	1678	1	1	5424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnem2yLi8jCGCooNNe6eAoqMnMaFcg3jTyGTGwYTMjoebpzmQV
9000	payment	1397	1397	1678	1	1	5430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWTaFcwFD8uygtZJJZsENqWq7tT8GaNtqrsvEfJuucieX7jjJ
9001	payment	1726	1726	1874	1	1	2400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVpY7SdRFnbYfrfyHHF66B3UX7aMcFhpyqq6KqNMhkAyuLnEi
9002	payment	1726	1726	1874	1	1	2401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQNdaVGhvq6ZKFTM2ET3MAaoxyBUymye9YjgNJYztgCeN1gLt
9024	payment	1726	1726	1874	1	1	2410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjnKhtKXYfMnsiygiccJDshWKw322dxswDf5cYzzmNzAnxcVD
9025	payment	1397	1397	1678	1	1	5440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdBUcivB7gw4YCmwxjT66aaAxJyMb7UnAAZwvKTpmQPwyjx1s
9031	payment	1397	1397	1678	1	1	5443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVCFPTivz6psDYwPG3qZ8HgWrSMx24uGQPXEbzJCxXamkht7u
9032	payment	1726	1726	1874	1	1	2413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEVodSomgBrk2TFE5M6gVWLsiVW6gzdiBFdSq4g9MVczeB7x8
9033	payment	1979	1979	1776	1	1	2	274575970106	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZRAiK6CD8GnkLLKEX9cWpKWq3Md8fbcZmzY3htwbLZAkj14aB3
9034	payment	1726	1726	1874	1	1	2414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjY2yCTWEkLHcCgeC4y1K4vNdWrdZfPzKFtt98dgQih5QYoyRJ
9035	payment	1397	1397	1678	1	1	5444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhaSCsA2RkJJNbLXaiw8FzNPwdYuzb5kdwqjp19v1XAsMjXih
9042	payment	1726	1726	1874	1	1	2417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ocsfg6yfQYbnXxPKM32AtaQ1pHUV4LPhMqusTeTiuXyxTEQV
9043	payment	1397	1397	1678	1	1	5447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5X8pdSosNtbKocWNBVf1g5tCmm7qovdJfkS9AEVGhRHfShXQj
9044	payment	1397	1397	1678	1	1	5448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcG9otMxJPBFNDdmRFsbk2D119uuL1Hxgg6oweVZdPfKNHRA8m
9045	payment	1979	1979	1051	1	1	5	3748267631329	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpaE4dPFsiMhQxfvKhM9i1Prwan1QtoZWgYkxwtHRR9ApS7LhxVe
9046	payment	1979	1979	1171	1	1	6	2529030858977	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZhi5u4VH8j71FAS6TVwAmv9KqPAg6GfQ5e4GKyQvmnTyFPmwFE
9047	payment	1979	1979	1297	1	1	7	7047369361431	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZnvyUhQpJd6NEJ6vLEvwwJt2qhFYMUbNiXFKtN1YZcnAhZPMQN
9052	payment	1397	1397	1678	1	1	5451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1C3173uqkpcUsE5ViU5VeS2MECz2e7mMNG2yatjmoL9E2LQm
9053	payment	1726	1726	1874	1	1	2420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeYqb1bvSJ2iyAr5tGNQYTVVAYcRYYmmUUYaekz3RQ9hpzm5z
9054	payment	1979	1979	1776	1	1	8	823866553266	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pyrY5VghJmXm9pa8NmDRAu4mub4vksLU7DhJGhkcsYi6UntK
9063	payment	1397	1397	1678	1	1	5456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerA1GKAi4uGFWiyNXSLJUFWsbg4yDaM4wztT38h8cFyHy4aHc
9064	payment	1726	1726	1874	1	1	2425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfQirAkxwQaDgD5GhRDjxCZgN6shLmhyxfjywS77bL4RkAnBY
9084	payment	1726	1726	1874	1	1	2431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQy4EMREejGqYLQvQa5J6trEHBpvm8fFJLWDY1uwf6tCzA1BmE
9085	payment	1397	1397	1678	1	1	5463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvuS4XHQhNFv5imaMuB7piqZ3xH7Qob5biiYfBDDRJX2wbzyx
9110	delegation	1981	1981	596	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgvNRjeAwXX72UxyPvdWyYHyWmGMWQSMHUmMgqGbrts7oUBwa
9111	payment	1397	1397	1678	1	1	5472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNEAd8G3RokBvKNETeL47bPEYVmrc59bAbUSGWFD6VzRkjX7b
9112	payment	1726	1726	1874	1	1	2439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSEFpqSitxb2Zpqvg1TaAURRCK7rRQ7EksQAEoHAHMURSr3Nt
9115	payment	1397	1397	1678	1	1	5473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXr1E1ZqhbKGdqnmmgFjuhJr9zhgcHZoNN6TKsWH8yYokQmkC
9116	payment	1850	1850	1151	1	1	3	2726000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	Ckpa5k1w1BHkuRFHvVCZvpnaQVxahRBZSzSRyPj7wfReShAeshJ6c
9117	payment	1850	1850	911	1	1	4	2255000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	CkpYsxPX9LQNnFtWqGVsFamRtnTTHpYT6qfZij6czjiHvkCb9Zv5N
9121	payment	1726	1726	1874	1	1	2441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gFahFR2NBd6bmLbuELmk3EjGt7Ag3yugDFyvy1PbwayQ4Lbv
9122	payment	1610	1610	1188	1	1	2	3197247260000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbYSemHM9wbRWsJr61ksb8YfatFBpkSHpbnyr356HhX3diquy
8978	payment	1694	1694	628	1	1	21	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYkqSWicBjZpF7zcDxm7sRjA5HmCM6VAaym8TYagKgQNZj1soyG
8979	payment	1694	1694	222	1	1	22	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYuBwXMMQTrNPVXSrgKkGKB4FhCQCnp1K5cxFMZMhQpcSzrGQJ1
8980	payment	1694	1694	431	1	1	23	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaDRCew49W3gTDV8YRXnq4J6wvE3eZqv1F32SU6E49ghN1fVQj8
8981	payment	1694	1694	574	1	1	24	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa2PA6pXV7ojKECJBgZgdK3q9inLXtbrnsj3uiFpTgYQfU1DS1n
8982	payment	1694	1694	256	1	1	25	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaATm7ktmiaJkWALgvHuwUAokmLPmpuk7AV4H1Gf31QrCGV1wmZ
8983	payment	1694	1694	604	1	1	26	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZTXuvMvqKoo87pMp6RCnZaSEFRj1zVTnhqjR2GoNNMKS85nxP6
8984	payment	1694	1694	220	1	1	27	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYdp9Nhr1mDkaBcnJwbPm9f6iwTKnswVMy5GsQH5A2NHvLpHdTh
8985	payment	1694	1694	371	1	1	28	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYn4YqjygPPR13NrUUenfqMob295ehSx2JWcK9GsSG333tPmBxf
8986	payment	1694	1694	638	1	1	29	454027022968	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZcsy4o2YEDnAHkL1xxAhVaGaXsXNuV2Gj2uS4gDPBAB6KdYdVg
8987	payment	1694	1694	951	1	1	30	3533388363221	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	Ckpa4Ypjw9MbjRbt8MGWLjv13eaQwCJCJWYWsLHf1bNy2ForXL3Pi
8988	payment	1694	1694	1071	1	1	31	6331563977293	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpZFoeGKirWRT7FWkxcyV2FbHB4E9rbHdrob1vwQiMSxovjTh623
8989	payment	1694	1694	1191	1	1	32	4272129988533	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpaGzVfhEnWi5PBBezpUQTwGaCdsNdjhXp8UT4sAktjcpq4A8KYh
8990	payment	1694	1694	1317	1	1	33	11904134108790	10000000	\N	E4Z6Zs55g18kRKbW7SY4Ayxxa6zfET9HVDAwW7upmkg2wyzPDxSBc	CkpYRcaHKS22L7EmSNwF1XpFxti8Lb9Zc9da1CH22zDP3MxxaocXr
8993	payment	1397	1397	1678	1	1	5427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcVTctJKCd3wkxhRuSGdSL4uRGgivJ36HsRsieS1osBZFVdsi
8994	payment	1979	1979	1776	1	1	1	10000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZK2vEymW93C5bnZ8G6HGCdAr3efqaR1iSbkk5B5LkizwGxkbGW
8995	payment	1397	1397	1678	1	1	5428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9J7T7vSxRFsUKgrchJW2AmU9vf7pTV1cKXsem3CmKFKXai5D
8996	payment	1397	1397	1678	1	1	5429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuzZiexrB6Dsv5ABNJewNURQtZSaEZfYWgKhMAvBWGsW4VwDu
8997	payment	1726	1726	1874	1	1	2397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8S3HnFxqk9yDnkNfEnVo5E739c58924pXschFGaW1gebnqMn1
8998	payment	1726	1726	1874	1	1	2398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhfA7Y6mSfFKJ8FRmLA2g9KXocsRNgcbEHpQSmKtTaRQZJXNV
8999	payment	1726	1726	1874	1	1	2399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4AAuhAUd3cTZ92Wmy2RvTHHbMipioZ26PsUGcK6rhVDVENkv
9004	payment	1397	1397	1678	1	1	5432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihWrGa3Ubdz3H2FRSPyfpwEbaprBkw3VjEAcU6awGsuhy7up8
9005	payment	1397	1397	1678	1	1	5433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWrqpW7HnjKGFGdx8GiyJMZcqpWmsk88QDBFj3yniZyXhgagE
9006	payment	1397	1397	1678	1	1	5434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FiNERCGbg7xJN587syvFNtA4CBtBe58pM1V5w94g6ytQBP3x
9007	payment	1726	1726	1874	1	1	2402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJwkhzM3LCfZMMCk27rsYD13gdmsnxagEdZaSaFBmwmonvh1v
9008	payment	1726	1726	1874	1	1	2403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyRx6RqgY4SUcYRmo6Wh1m63eFkxuiTh2dWzwUJpXZd81K5X1
9009	payment	1726	1726	1874	1	1	2404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnhkrtjdTCV6u3ZJxFMxDGRgjpyidCAjjP4QB54kR8j6i6i9y
9010	payment	1601	1601	1388	1	1	5	5002502500000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	Ckpa1yvTfwVYXxVx4FAv82wqmk1xXZ6oqcd6zkrWKEQXJAfy8zcbr
9011	payment	1601	1601	1142	1	1	6	2660486500000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZEuE8Q8B64bk3QpDXGeBcSGxnRckZfa2bfPwVJZCgZsGWnbE3X
9012	payment	1601	1601	1262	1	1	7	1794816100000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZupfdhR33GQJSXoQhXKNusuxYhb8tzmxXtCmPMnKMJR1gu9guz
9013	payment	1601	1601	1022	1	1	8	1485100900000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZyfYEszDWodw4D2fwMPzfrxN5kHA1QsdbUWcPrWHfFGpWe9wTB
9020	payment	1397	1397	1678	1	1	5438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eEUuaSe3U6kyqJHod4H8U5kYu1U71cp9kDFY3rfRLfJftCXS
9021	payment	1726	1726	1874	1	1	2408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRGBvozXbb9e41KThjNNDBdHkdTf8RXUKdepTaPmfuKLNwtm7
9026	payment	1397	1397	1678	1	1	5441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcas2wKpvqrE2vZ6pLKg57ocRyDCCNCQ7fDTH9aBXhNTNLPov
9027	payment	1709	1709	1979	1	1	6	16556440000000	10000000	\N	E4YpwWCUcoxadLVmecexEyYhq9YMpf9u3b7rBaxFzbbUftDNkYdMn	CkpZcH4auKJdtA1n3zzoCqzURgTBHtHuT3ktoE6Bu6o9Wr9Kf2eYj
9028	payment	1726	1726	1874	1	1	2411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnteRWTQnX3LbdFrF6GkgmoMyhNVkRWYYy3obMheDD7ESQvmu2
9029	payment	1726	1726	1874	1	1	2412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTuwCSxU8BaXqPECqMZVRfiAiXNdvSMnLHsc3n1MnhbiB4UYS
9030	payment	1397	1397	1678	1	1	5442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aPn7y6b85bufMMak8jf33tCwKpAxh3RUFPyjzoNBVwPB7LS9
9036	payment	1979	1979	1776	1	1	3	41602419504	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpYfwDeNFaiqtPqYNxaEP4fRs8ccLe5dTyU3cyeTjFQaJXLfQJqL
9019	payment	1726	1726	1874	1	1	2407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvMWbB2pMdVPGvzzAcSJLwArVTCUgdwpzKx63csya9WBHV3ND
9039	payment	1726	1726	1874	1	1	2416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppepxSFvhCkgRGVMHoXyiGZJfK9HFus1kbqPscoqZn8mukx1B
9040	payment	1979	1979	931	1	1	4	2091677205387	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZETGoVjg2WLwnQAnWSzrv6h8ahzQjCbX61icRCRW9sCRhDChYT
9041	payment	1397	1397	1678	1	1	5446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEEttzxBk2kGwnoxWshwdCUdA49E8mAgyBbUBwFH5BTfsEihv
9059	payment	1397	1397	1678	1	1	5454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmhCGkZSuVJwCsJkCcQFyh4PrWrCPwZvGvdakXJaotwqtDm7i
9060	payment	1726	1726	1874	1	1	2423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwyUV9Kv8Bd3DZ4T5C76UVVh9YgcbYRqpv6AaUHo3WqT7xAJ4
9079	payment	1522	1522	1898	1	1	5	10000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYf1jqyz1pPvsPqN67dN3pT3nYvD8PnhQdVCVUeHPF2EN3CDBPM
9080	payment	1397	1397	1678	1	1	5461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5zbeRKt6oMALPRY4hi7dA6tWPruVvzYuHLKxDCeT3ZihoEyq
9081	payment	1726	1726	1874	1	1	2429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHahMMjtBrwXkezm5DSW9m7KxPRxBrtB6sRZc8yVEyHRJiUi9Q
9091	payment	596	596	1981	1	1	0	102000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8u7MCAaQdz99zMgtPu6ZfALQkjBdAzJoSQDCwVXpfwSSEUutK
9092	payment	700	700	1980	1	1	1	7197000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxRgs9wCNF2nRv8yqGZgomTq4J4EVsSMRhHxs5AdCYagwd3Yx
9093	payment	1726	1726	1874	1	1	2434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmi2deEfdCUfQgGyU8wvsfUcnkXow5bqhN1VschY8xHsk79RQK
9094	payment	1633	1633	1390	1	1	4	6566304342536	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpYuZ7V2ikyGL94DvNYZzinToCN6HcUpHq7pAgDVWBEMnjqYW1sC
9095	payment	1397	1397	1678	1	1	5466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqgHzgEkCCFL6aM4gLAXp31qsRNQF4jmjs2XYRwGneH341MhC
9096	payment	1633	1633	1144	1	1	5	3492404720511	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpYmXTUaGs7KevH7vXFQSuRJxPg1eVrddr1cfh337zKd1y3TydnE
9097	payment	1397	1397	1678	1	1	5467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LjKe1efTSPaRde5uTJeqzvoVoV6fr57uYHHLAwkukJjAfMWM
9098	payment	1633	1633	1264	1	1	6	2356395056009	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZhnXoQVNyZGmcPZPDCNBtabRoG3D96BXN4oc4peSTK9kRz8dU6
9099	payment	1633	1633	1024	1	1	7	1948895880944	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZcfT82yzGHwtfU9m46vMtcq9TH4ct4X3LtxcpgSRf7XgFeCkLX
9100	payment	1726	1726	1874	1	1	2435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmRm8NZXmSvRzbgv6FucdkGKNviZ3V791RTvv1aMHMqXhHCzN5
9101	payment	1726	1726	1874	1	1	2436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgfWiGBtDRBZN5WFSJJJx9jhZ35Ny5WDqk8thCeifKstXVYmB
9102	payment	1726	1726	1874	1	1	2437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6ptHqqoqySFkYcAyncbLHMuuztjadKRLVhCQF7XMYDaPLbjv
9103	payment	1397	1397	1678	1	1	5468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoo86xkAdRpbAahkinVRasKiuCwQRvREvCT1atq53Mt8LJ87EZ
9104	payment	1397	1397	1678	1	1	5469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJa9eb87V2T8deZvMGkXoNC9vkJB9EGKtKqmKdcR9TVCeirukM
9105	delegation	1980	1980	700	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5Si2eyiQz64oX5sPhhFgjKuD3e2tEy4KbbJUM6TdnVmNpbE8
9106	payment	1397	1397	1678	1	1	5470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKfbfT3MtzPa7a5PUQ87ppELVU7CjGGXSxdQLmT6KVPEW7WLf
9118	payment	1726	1726	1874	1	1	2440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQj2Y3rEkCWyFcmHtTvWdsTQX5ZXnstWjYRiw3PoBBrKjtZCt
9119	payment	1610	1610	948	1	1	0	2644336740000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eEo8Dn9whpMGbXS4q7RvmXJruvSxExHEPZ9W4rRzfA1gBrzD
9120	payment	1610	1610	1068	1	1	1	4738628770000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNPWZu13NPm9XkETbkCxTLfs4fL21sJY7y74zGH1PfaFB9ZvT
9129	payment	1397	1397	1678	1	1	5477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePgDGmk6UQi3sbTzN6NmN6wwvobPapvGCvvwRQqgA5w9oFk2P
9130	payment	1726	1726	1874	1	1	2444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZX6Vsryqpr7WD4SPVDnVX76YCfjgowpvR6MBRGuvqYDBMMUA
9131	payment	470	470	764	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtbcGnBD3RVUrSPpzf2rf84srAK4Gx1jNR5966RsmLDKLXdTZ
9132	payment	1397	1397	1678	1	1	5478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKNrqW7cRPxRmR3izBGBGsA4NCqENNYhGf5RKz6RGb8vnwxkV
9137	payment	1726	1726	1874	1	1	2446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRSyFQ5d1wEnZCK9g7GoS5kotqFAAz9WRHmpCe4fjFqgXtAJ1
9138	payment	470	470	1183	1	1	3	2976000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5TSE5hsQ8egouQcZFMpdLtUSSAe6pCmWNxfEKg54WJoP3vJK
9139	payment	1726	1726	1874	1	1	2447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2gfnffDBFBKwDGUn6MGry4E7r7VUzwxuun4wGNEpCka5jCRP
9140	payment	1397	1397	1678	1	1	5480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8UMsgThe3shdW5yDx1uhqB4oD3A2vo56UqhwtufqTFAkwJJ4
9141	payment	1397	1397	1678	1	1	5481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbbfi4RerKNL9t357TzNNZp86VcdTYntHk8EabNTBBym9JKfk
9142	payment	1701	1701	267	1	1	4	263331324931	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZ411s5tQKCzzwYRxwSnBYHiuHt5nfnHzaxrSGwmeYfnKw6AMwU
9037	payment	1397	1397	1678	1	1	5445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3GvxPdM3o3WwfFU6kn4pwHbgNLk8PZ53NTL1VxMAnVdW8i8w
9038	payment	1726	1726	1874	1	1	2415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ebPVCecGjKGRkuwECnzbiLTGbxk8iYza9vxa5ZdumLSQXsBS
9048	payment	1726	1726	1874	1	1	2418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8NHrwiGxtBJikKDA56MqzoDn2wRpg1XEaj2UbRGMSdPNfxbG
9049	payment	1397	1397	1678	1	1	5449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8yrHiJDewaP6piLdqq5NuUeqmLCKv6RW9PtCynXf3WYhr78j
9055	payment	1726	1726	1874	1	1	2421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7f6xbYG6HmUwWYedShTdikKNCCQcn22fQryevAZ7AW2kJJSW
9056	payment	1726	1726	1874	1	1	2422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNCHze2wA8LpF9VmsFuspQ1Qf7DYYnryGtxr5ojTrZXM8cpbw
9057	payment	1397	1397	1678	1	1	5452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALuEMkQrEMC2xJeDUghEY9YqFzN4Yfy3jkPQkxBRfh1Yct6qi
9058	payment	1397	1397	1678	1	1	5453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKzrrhttXFHauRHti5zDC3K4szS9npZijEk4B9TPWLcCeirba
9065	payment	1397	1397	1678	1	1	5457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fAxamWEMTyk4rL86Ay8Qn1SqJB54DbHFFPsnwtHxb2A9foiR
9066	payment	1397	1397	1678	1	1	5458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2MgHht7ES3P2bfM59VUNyszH5cT1Edn5qrw95k83kAgP7vUP
9067	payment	1726	1726	1874	1	1	2426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuaU1SZjrcNpXuUqWc2hvXnMQicrUsF9oidoSTECiBnpVzB4Q
9068	payment	1726	1726	1874	1	1	2427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbetKVw4hVqTtPMXecwBJkjfj5CfQP8RXhxd99fiYLCqtesh3
9069	delegation	1900	1900	44	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQjQs6hhphn7gm9SXhHCtbmrYNYU17QtcK5oCXdrQVGLjt8rd
9075	payment	1522	1522	1898	1	1	3	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1AC4facR3kPsLX6RkWN81r84npWEQip6YZwV7jRuHJZCvSVG
9076	payment	1522	1522	1898	1	1	4	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVv3PLCv4nXrrxMkH96nCx63AhF1mfY3VJber6BCK7H1ksj5K
9077	payment	1397	1397	1678	1	1	5460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMGSNRrzSmTUnbfvtm89NL42EoFyedr5beScXZmWyQ6P7qpNYZ
9078	payment	1633	1633	1024	1	1	3	1948	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZN78d6ddrgj9vWJ7aNVYZ78TjyPZg9ShdjPD2Wui22AZDjhDBN
9082	payment	1397	1397	1678	1	1	5462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7c9ZNMiHHSnFYtr5svUoVaX3TKjRZK6pWmrgY67QKJe54Ucv
9083	payment	1726	1726	1874	1	1	2430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZV8b653uEhgz8Gw2V5dUurp1897QK7aY3mbZAPHvFVWGa1YGx
9086	payment	1397	1397	1678	1	1	5464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbg7hsnkDkTjWFR7ynCg8sD5fV1aqdVEaKwXjF3BjWxkGELyP
9087	payment	1397	1397	1678	1	1	5465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6kPq5MPnRBCrBT2mXzLHDXq3FuZ7mnnRe41UonVVdKH1NitD
9088	payment	1726	1726	1874	1	1	2432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEp3DJ6gy1B1nUgEzenFP6GdZZyVSbEvcgd9McnVAWBRxcNsR
9089	payment	700	700	1980	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEtm7XCttVs6TRSuBfkH1bbwH2EM9Qos6EekxBP1N9srvsDQ2
9090	payment	1726	1726	1874	1	1	2433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xNfE9mnzeiAjy1fMyY8aywoWiZa7pw5M2rN1wRpKT4iPeeKE
9113	payment	1850	1850	1277	1	1	1	7596000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	Ckpa8eZ98BmDgxwvPFLShrmowyYCuv8jexRPtuzBRSwqmDm5cY1RR
9114	payment	1850	1850	1031	1	1	2	4040000000000	10000000	\N	E4YrwR6hyz3J64FYUebEpfiuTXUwpWvDTH5Xb4sMBvBbHNegZptVv	CkpYxVbhoZ8BK6AZ5JBxb8g7hAV53Bs1yF2Mykm4moTPQ9qmYoVVb
9143	payment	470	470	943	1	1	3	2462000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvyYjeg9hNvLV4XPKEyVxQbXJKGgXLQA74rjWpmurCV47VTwG
9188	payment	1397	1397	1678	1	1	5493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdq1PZrDX5GjjUPp11pnWE5i5hVBMaMzAyQf34jdkBnuz8Brd
9189	payment	1476	1476	1371	1	1	0	7988000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4E9FsEEzSahoMXCp7L6USnXA4AUMiFzVcbXKDebakHPadzAC
9190	payment	1726	1726	1874	1	1	2459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE7eCLeZo13tgrSMUPacAoq3KV154GX6dEsbEBWwN4ZDDxdPR
9191	payment	1476	1476	1125	1	1	1	4249000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bipzhkx7mh9kJS9862TCd287CVLhuxftfi97iUVzCA2F439X
9192	payment	1476	1476	1245	1	1	2	2867000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Vq4rZbwXoTuPk8F6XYCehM2UWDUkzTwtUsLEsQbFhFBANU3S
9193	payment	1476	1476	1005	1	1	3	2371000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TXzv6J9wiVz5rUvDY2KWBdpdmvxgvbcGqPs7rk4m4QYzZ8pU
9194	payment	1689	1689	1984	1	1	1	1000000000	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZpw2ASYag2EGnnKdDYpLrZ4RzEVR9wM7waForNWMyMW1xaRGVi
9204	payment	1726	1726	1874	1	1	2463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgDcK2rSW2CWBkSJXWugkfeL8mie6ykdNuG8oAyxg3dKdbHLt
9205	payment	1726	1726	1874	1	1	2464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWH8nAEms9qmtzzAV1QQmCUAZMUfydUYSH6FM1XgGsRxVuxcab
9206	payment	1397	1397	1678	1	1	5497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3v6XdUzNoNMNz6gLU9zwp9gwYiuzeW9zbMpife7BBuQizZhw
9207	payment	1397	1397	1678	1	1	5498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfxrZkRBLfCiK6HvhiU3Uvqzy6kPhJXrtjB48MivNt2WnheSo
9123	payment	1397	1397	1678	1	1	5474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxWq1iKUwF5cV4Wd7heDiCoy1a7kxhyjGk3VowMhqr6JfxnKa
9124	payment	1610	1610	1314	1	1	3	8909413760000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sKw6dK8ZowwUZFzgXgMSjhSHXtHLndbmrupVgXYU3FCkHy27
9127	payment	1397	1397	1678	1	1	5476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7DWWXtB7W6g9WjYSYoksoRuCeNpXrJkzBGuN5jUfjtZt4GJQ
9128	payment	1726	1726	1874	1	1	2443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGeJAoXGqpULE8EJj1FkMaXCxM7fEiq9KCXRkhLE3pbicXuWCT
9133	payment	470	470	1309	1	1	1	8293000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6cgC4wdv6tfgsyWMz2DDbtNsZYpsXvHgFt7haqRnHonP1r6r
9134	payment	1726	1726	1874	1	1	2445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqdsArc167sYxKNwSrByekU86mpU2KugakH6ja9dEvcC5dKuj
9135	payment	470	470	1063	1	1	2	4411000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnGoYjKB5BK1urJG2zjs5hqvhqqWwFbr4yVMM4yqrTNmUkdJZ
9136	payment	1397	1397	1678	1	1	5479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNL9vyaxWeef1SBVdaLnLQptRiFQqeGqwcDWNBm7Q8ToPU2G5M
9150	payment	1726	1726	1874	1	1	2449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZQj99k8WW7SRwSmepPLSqz5ddHNJduqLdFAyp8u8D1FzjLn1
9151	payment	1726	1726	1874	1	1	2450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oLMie2DjzFiV2cCJn4iFDU9jKmBPS8PHechLQX3QPoMBrgCz
9152	payment	1397	1397	1678	1	1	5483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TnkKVr84XPuWdF1vQPX7BhZ58hKC5VD15ec9efUzjfQMjq4R
9153	payment	1397	1397	1678	1	1	5484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsC7AvsYa5QDySDcd7jVACZgLPTCahf2e6WjnZtk4RyUiGidNk
9154	payment	1610	1610	1983	1	1	4	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqzcCzp7gRiA4fL8CjAiGFBPFYgGgmPubT9ZL2hTYjWHXhDHG
9155	payment	1701	1701	1042	1	1	6	3594765701196	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	Ckpa13sEbX93Aomgktcf9G11foaEmygF1kC8L48njPkeETkd7tk2j
9156	payment	1701	1701	1162	1	1	7	2425460049358	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpaKKpiax3HBX6R8ZLYbuGgD6Y6u8vqy8Rkk9kbsin45xeyBsj21
9157	payment	596	596	1060	1	1	2	4085000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9MnC3qZWsZzdEc1qnnzL275kcJ5PwWiSEXCevnATWmNxMq92
9158	payment	596	596	1180	1	1	3	2757000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4oTrm8qVjLN5DS4dtcqmRk1477fBpRcUHzA2CkU2pqbLcazZN
9159	payment	596	596	1306	1	1	4	7681000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkX45DoDarW1PLnpi3g65Bo8dQDPQZnVcCNKqPz3mo5CzDXro
9160	payment	1610	1610	1983	1	1	5	1389103470000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPY8XyYAsM3v2pQcvF1HgC63w8C16n314Po76rwcyU1xERhiZ
9161	payment	1397	1397	1678	1	1	5485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBk1EyddPpoLvFisXGBdQv6ScAJSpPTzLvKjUVSnTFbnu2RdeR
9162	payment	1397	1397	1678	1	1	5486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdnX1oFfgmzNfdeTeKyRjbApz3KWKJFSRuq5PiRtcvg7eGAPV
9163	payment	1397	1397	1678	1	1	5487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCe5c3ofi4CSTYmgnYgct8wP35wP7Z1BNxWnvAtN8gJxrDpC7c
9164	payment	1536	1536	1067	1	1	2	4248300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeumThxfHPkPbW1i4piPJQ91f4RaHqN9c6fv2PJwCDXqsVYhEq
9165	payment	1536	1536	1187	1	1	3	2866400000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbq1zpxp4SErkNDiVtdeg5bhCD81w22uJhddS5hhEpMmvevS5U
9166	payment	1536	1536	947	1	1	4	2370700000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkWiJnQwwxjF437TqftdNZRSpj2KgKrwxmy5PNsvfpuJCyREg
9167	payment	1726	1726	1874	1	1	2451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKt6AnKuuHgf5iQwJcLtjKtDx5F1UnrkegvD6nRzYQE4BUjpN1
9168	payment	1726	1726	1874	1	1	2452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4XGXCaSyiaMVzUH1caVZJsARNHeejxoZjAuTt5NrBNde3Hyz
9169	payment	1726	1726	1874	1	1	2453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkSMLX7pG5rMKfekBmQjfDTBv35arrhjjP6ZoghyhbJbGHqAu
9185	payment	1726	1726	1874	1	1	2458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhke7VN8r65VNsQm5zHEbT8SwkNsomUxN8ct2kXAJJpGZvfXSu
9186	payment	1701	1701	1288	1	1	8	6758760087438	10000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZoDsk872U1KkjkQoi672pGHaBtH2RSK7cqCU6vEPRaKUdsfbpZ
9187	payment	1397	1397	1678	1	1	5492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtMxMPwKg2QQU1EhXuro397LrRCe9rjPVngqf8ZWSmDh3VqLr
9202	payment	1397	1397	1678	1	1	5496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoWMGPzZRYjotKLhMDVBPi17FSo6QytA714bQPpDL1LTvPQtK
9203	payment	1726	1726	1874	1	1	2462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgo85yigZnVjYNpnE8MiKmEFezkz7VpAo8vXD8H5xp1RNwxbvz
9209	payment	1397	1397	1678	1	1	5499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwdydGNuYTqZaTXNb7WrGYVXrcukbTqMgP8W8BFcCnEExPLpT
9210	payment	1726	1726	1874	1	1	2465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xztUjfZhHkMkNppXUUqhWLStyGmEzU3WwAMfxJKSH8gYBJ8A
9211	payment	1594	1594	960	1	1	0	2279520000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQBfDhWQRUKoaqUWuNN5gLBXmEvjoZryLJ9Pw34KYDkSBKvLu
9212	payment	1726	1726	1874	1	1	2466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KMg6CeGi9xX7FcssLvxB3xoDuxxb94Df8zwTRhfsG3nyNLX8
9213	payment	1397	1397	1678	1	1	5500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJs8fP4gSbJVSMhwsPyaoVK5sGyKBfvDoGixwi956jjzYvGDne
9144	payment	1726	1726	1874	1	1	2448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9K9haK46tTNgazLCg2oLTMoDnYdBr2oJVufTEiQYGhS6KjhzS
9145	payment	1536	1536	260	1	1	0	311200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVmiyHZ6hmD9z7WrcFPLNLW3k3GWsqQzr34PRrVn1qPSFADS1
9146	payment	1397	1397	1678	1	1	5482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvapJ3xy43sP4mw2hhkzN3LKv8irzi1SCZYfQjhcgKUf9BEY9D
9147	payment	1701	1701	922	1	1	5	2006017237021	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZbUzd4b89Lz4Uo7KJRsVFsM5rzGgD5748XjZfBYFR4HCv2Bfs3
9215	payment	1594	1594	1326	1	1	1	7680240000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZro97NcWP9WMATQst1gDRx6eEzXh4Xpx3H7EQJBYhmVKdNUdXy
9216	payment	1594	1594	1200	1	1	2	2756150000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBpGaJtETMVUo8r72pqPzc2d8jSGDhG4ejwh6D1t7bLq7tavL
9217	payment	1594	1594	1080	1	1	3	4084880000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHebapEf6ykFC3FHE8rrHFkfVnRZyTqrz68HX4sKaHnhLaGFJ
9218	payment	1397	1397	1678	1	1	5501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcP7hzovB7u2Q1ny9p8A4Seqt1ocF5QWPXnFesU9nPcN41A1k
9224	payment	1397	1397	1678	1	1	5504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDLRQXWQXD54rB6cxEBMVnDcWgd2xxd94JhfcKTrXdzNVugXL
9225	payment	1726	1726	1874	1	1	2469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBHny1p6g2E5GjwJCS3pP4eRxQvgUEGTZ41zYhytU11dfaD5E
9230	payment	1397	1397	1678	1	1	5506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9BxMBGkER4NMUwXKBqrFg8sm35fmyktP3uJWS7AhJGSDFqNv
9231	payment	1726	1726	1874	1	1	2471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9W5sDjfQnbXWWjrnrjhgDmVZa28oTqUpHAyBQjjfPthP7c22
9237	payment	1727	1727	1148	1	1	2	2058640000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpWGzCr6UusBeGr61CbM2mETZR9igj5EDX5X3wD1dM6mZ6nU1
9238	payment	1727	1727	1274	1	1	3	5736600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqcy25jjDyRQjzatp55r71ppRHCDaDafJx7ZnbV7QuTqmnR2P
9239	payment	1727	1727	1986	1	1	4	223510000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8hV17ykCx4oThVscrqwWdzvBxYDehoGuXWGKRFhjKhsVvK4R
9240	payment	1726	1726	1874	1	1	2473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiL7Txe6qzmc7dEKAdSkKKL1m6JeE3v4t8ak8TVgJzM9xUAHqJ
9241	payment	1397	1397	1678	1	1	5509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2i7XK9MctHVWhnCUyA3G8hNSGAqvtz5eZzvcgU9AHMrW5iHt
9242	payment	1397	1397	1678	1	1	5510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDhdvvYX6dXdVKPNdKMZq6HnSfTcNLtXJJysoGJHhVj3haYoE
9243	payment	1726	1726	1874	1	1	2474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZog1wsdLmSftMvL8H2tJuwhdFfgtHkEoAUTiWMU1F1RqtsXzT5
9247	payment	1726	1726	1874	1	1	2476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7rXdyzzEF7mhas5ou7BLJhVbawqnsQU84rWgtxSBHGMqVSfC
9248	payment	1726	1726	1874	1	1	2477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbE3L2RbUsW5LzUhbw61CLdsuMUrxi9siFGBRf2E9so7zW1rvN
9249	payment	1397	1397	1678	1	1	5512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyoSfmAjPdmiTJCwJ7Pt2QaZS5GkGSXMg8YYTWsVn9mWNYUgx
9250	payment	1397	1397	1678	1	1	5513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNzEwgEV8ZcZQavkYZwhA5JDFVEiquRzwkHGc23wxpgarJCb1
9251	payment	1397	1397	1678	1	1	5514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWLVDz8zSBn853UFEX8SZ8PpFV9MZDTxgnq223nXSn6u6iLvi
9252	payment	1726	1726	1874	1	1	2478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pwVuM3uhg2dkgknk8gFQjeuhsdJc2ZZxyW5wqMsWiUMehptd
9253	payment	1711	1711	1711	1	1	0	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpZMRX7qajarL1KQxZEuLz2ic3jSXMpTf5NnNffxZ49wkDJmE2xT
9254	payment	1711	1711	1711	1	1	1	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	Ckpa1ykKJcwAH7Kr4WPrhStDekFaT4NwW8d8gRBD9xbz3FyNcTAcG
9255	payment	1711	1711	1711	1	1	2	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpYmem5c9ftSdvm4gJAsm3NohVEXPj18MBsXh5cxhQpjQvo9jEov
9256	payment	1711	1711	1711	1	1	3	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpaLU3nXhdyx7j2TAhwxnp7JnFEXQqqg2szDoF6cgXWKmwivvTx6
9257	payment	1711	1711	1711	1	1	4	10000	1000000	\N	E4Yvs8s5aCUdEVoL7GJQTpaxthKepJQds2qQ8vPqtxjU9gwgKpAP5	CkpYqjF6pEWCdUsBpjScAnuBDV8uEnP193YPP2LYTQ7BRESjQ1Fvv
9262	payment	1726	1726	1874	1	1	2481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qpajai7gvGEtYvoGwNCqGQ4MKkCpKWc7wFXgppd956L8o5Mo
9263	payment	1397	1397	1678	1	1	5517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrk9vyzniPYVjgSspbhew7W3DaxMz33aXxRKsBWqo9xKegKCe
9299	payment	1726	1726	1874	1	1	2492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfvxy1nC8Cah7SKKDTvqkEkiS6aeEu6Qw5bFbFzgGrenR8nvj
9300	payment	1397	1397	1678	1	1	5529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY6KwVcmwy74k2hapkagmBMJdj2rLRtMdiAY9b3E4JZEUh7P7
9301	payment	1587	1587	1357	1	1	0	7246230000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDEy34mxVzakGa2mADVg81DUqBrejcBJqcTdHasx6DL6mJ1wX
9302	payment	1587	1587	1111	1	1	1	3854040000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYnSuftbL1VpdFBt3NK3RuxaMWHSUoSa76Nqejxd5cKVjCZ7P
9303	payment	1587	1587	1231	1	1	2	2600400000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtmAaznYv8HebrE73DWqu3bwdX6f6xGhBUWLxiFVazNUq9EFm
9304	payment	1587	1587	991	1	1	3	2150700000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMCdK548bn9hD8QFTAUuvjNskcsiR2FB3YKcSyFVBocSVdqN8
9148	payment	596	596	940	1	1	1	2280000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgX8PqNBYiAFDY7Dt2VnKR2gCM7aBhQd2LEmkETzhmAAqnJz8
9149	payment	1536	1536	1313	1	1	1	7987500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ntDd8YJ7VrcY4wZckMN776GpByGGPphyp7dk1zctcN4N9Db3
9170	payment	1397	1397	1678	1	1	5488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHVbdGPYMoJ6ugrShgZXCixGxpsY5ropLSRZ8avwpbAAZrJdx
9171	payment	1726	1726	1874	1	1	2454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSZPse6gzgNbiRQX41XUoZMNhMRVNvtjSMicEWkrMJWjvNDDr
9172	payment	1536	1536	260	1	1	5	936300000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURoAQqSJdc4i7yREQzSVB2tJ14qTCAmBSpXXLbFTBfPveWe7Q
9173	payment	470	470	943	1	1	4	2462000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMXCotC58EdhrQ3X2ZGvP22EKAEx7ezcCjfkvSPrEyzxccwhA
9174	payment	1671	1671	1365	1	1	0	9523495762713	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFVADdWRBZeLaTvuNEQarpCkbE7R8w78HxUEQjtDw1P1DBwvE
9175	payment	1397	1397	1678	1	1	5489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzF97n2euqiAzna3NVQGPFqSBJdjSVe6EyMYwP2esWzxQBn33x
9176	payment	1397	1397	1678	1	1	5490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyCXiBqeJDMMm8YVUcQbccNRm9xAdnruBJoCt4nayU1HKkaQu
9177	payment	1397	1397	1678	1	1	5491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkUJBJve2rScjEErbdznmVGdSPejmdw78k52FTVdaGScdd5Y1
9178	payment	1671	1671	1119	1	1	1	5065239109009	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPECqevQiXixT9SKJw6xo9Q9SeCLvovcCJ7fA1z6Yy1qjdnky
9179	payment	1671	1671	1239	1	1	2	3417617758868	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEnNRbUx4i4hbRL7WDoeF8o49YFib71uspLbh3RC2Q6QGgcZk
9180	payment	1671	1671	999	1	1	3	2826597838895	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYdmU9W2Uk366ZoQDYwqCDqmHASisdjYWavjL3WPdWpBxbqjc
9181	payment	1726	1726	1874	1	1	2455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVS17fnznghHGifXDpEqB7fmbW6DeVYMvZLqk7FBYpdiEVj1u
9182	payment	1726	1726	1874	1	1	2456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN73AYrYTVfLGaKss7RYrRHkvNy4EnC7XxhF1phsvViLNjZ1o
9183	payment	1726	1726	1874	1	1	2457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17FTtJJJv6SoC4wKvgMWtAkiBvDzMqrQHmvM3fyhzWgivRTTm
9184	payment	1689	1689	1984	1	1	0	1000000000	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZqUh6CdvWcYiv5qDyW6RBvR9Jqzzse5sWqgfTJywFqEPwJ1DeX
9195	payment	1726	1726	1874	1	1	2460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33r1gUikvAmJNNmQNNy1nYwpp7rjLLxorsxFJbvpDrkU3Y5wg
9196	payment	1726	1726	1874	1	1	2461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuyGfWJSrbcuoPNwsF289xE4Q14cAHgVuSZQUL2LmYbdLM3xF
9197	payment	470	470	764	1	1	5	1298350000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACieAkuCvbLxEv5BUCFXNi3GSBq6fWPCLwn5dDYmk4MqLjCrK
9198	payment	1397	1397	1678	1	1	5494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZriJaBNpJhHPmVBo4Nd1KEtUchjTz9mYPNnfP45AbLBnhnupPT
9199	payment	1397	1397	1678	1	1	5495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNSTsFt27XHJ2pYmGQ1jun1BXj4AoQp7C31LiDUngBbXVpnDb
9200	payment	1476	1476	538	1	1	4	1245340000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2ZgVUw18UJjswKcd52hAgYQbMsUSXQF8yA5vG7VkqLkEw1sT
9201	payment	1689	1689	909	1	1	2	2369438510546	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpYkgc4CkeYphLnJUqFGi8fceoUqR7HAzhKa6GhPjZyKVGbXXrP2
9234	payment	1727	1727	1028	1	1	1	3051110000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6CqHoLZGFPQpeKmCm3sQh1y5D5Pn58bZPMNWPYu2WBx96R8Z
9235	payment	1397	1397	1678	1	1	5508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Pt2fTtxpznSC865kymCURs8zkrKxyE4MU8JnozZPFsy3WP6H
9236	payment	1726	1726	1874	1	1	2472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6pApZmRyTead6uJnp3C3Mx6D6p3bB7kkvRzVjfwqrLUjxDAFB
9260	payment	1726	1726	1874	1	1	2480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5p5KWqxHARCFXif1ugGZtKkSyX5DrarJ6MdDApkC47jQS9sD
9261	payment	1397	1397	1678	1	1	5516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFH7QB43ijDhhgUmjxPMhqmQJCRosndzktfrcn7KEVc38osZH2
9288	payment	1397	1397	1678	1	1	5526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6nW1GTKaxr5fCaW717Z1TiBwTWuAXNHH9CFpPbWyzv9miJPw
9289	payment	1397	1397	1678	1	1	5527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbgCCsnKqnN56B6rzM2S5bZFsKy74XhRr4BfZHt5zQeG96vPs
9290	payment	1726	1726	1874	1	1	2489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5M6Lh1LnhwAWFyJzsUEQEVQN3JHp2goPg55QoQKkMGpLFxYs
9291	payment	1726	1726	1874	1	1	2490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoGvL3jBxvKzwUEkfMQycjutvuGtf44TpGpTHesTruEQoFWHB
9315	payment	1397	1397	1678	1	1	5532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZPRN1kCQxi44nfugJhrNvRKkQdrgCjWwRSAkq88vFsyqecSu
9316	payment	1726	1726	1874	1	1	2495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhBVoNpmGDJS1jHojXAHZukHdrRxCVTNzrzv1SaiiMFvZFKcs
9317	payment	1726	1726	1988	1	1	2496	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvtgZwfMs2YEE7Syv5L9yAdarRE4LF7LGne74wSXGXvrBM2jFt
9320	payment	1397	1397	1678	1	1	5534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgjBaT6rT3tpxS9Pe7UDjvXXNu4cQt3gjnZTZCN6kkKuxeYcP
9321	payment	1726	1726	1874	1	1	2498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2zgQxDVzEa5ZoAHMzp5SfAxfFBtNSzMqF5oeZ7XPDccRK8Rj
9208	payment	1689	1689	1029	1	1	3	4246013509549	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpaG1x9pcYMG4b2xXyyTEGityrFqqedfpEPd9CSrT1xXNUVxMnBP
9219	payment	1726	1726	1874	1	1	2467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbs3rpBMzsi6J8hUL9moFR4HGF5avSFgxaBjbSLcDJF33L5Ce
9220	payment	1397	1397	1678	1	1	5502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wJC5L6nY7cTMv4S3ocm7Zq6UF7y9spwTmsewaqwAAYfqqZgW
9221	payment	1689	1689	1275	1	1	5	7983214769602	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	Ckpa1MMeTSbpvJpJaB9CcKsCJtLr5foTZc32ZduEhvYw8M7LWGsbo
9226	payment	1727	1727	908	1	1	0	1702640000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLe979jBXSoXVm1ynUajcPfQkzA2cgVZvKST3z7PeYuh8cJZwx
9227	payment	1726	1726	1874	1	1	2470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhxyWKjejU2F4tG8QLqTrU8yVoF32ngT7USEik9UyTQrmxrEp
9228	payment	1397	1397	1678	1	1	5505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq819RAtJdgFBotvU2H5ZKz578ZQqN8Bw222ss6FxeXJmuxzTw
9229	payment	1689	1689	1984	1	1	6	1253900000000	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	Ckpa3ThThCQxGPFn9rWicS4w2gQKKKghJphwUcXAAGKfASunu9Lbp
9264	payment	1726	1726	1874	1	1	2482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVRih8hWstcFF5x9CGKe47ErmDLJvYNEoPgLWhwA3LAdtQkjJ
9265	payment	1397	1397	1678	1	1	5518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeM9Dmwntgq94VmpBfkB9vDER99mEECqVn1LHNddPfKhaEKhmU
9276	payment	1668	1668	1987	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhKjhhVBoDvsaNpN3MkwdXUVYdMznAtFaXSW1kTYBvx7c6rzH2
9277	payment	1397	1397	1678	1	1	5521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVcjdQdqBuBXTtE2fMe7LYrZnQW3ckrxJLF82mikuCAkMkYzb
9278	payment	1726	1726	1874	1	1	2484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmE6UYfxWgAchYgBUDeXzYSPVg8YLzf7dApxNkpFkBbVoaB3Dh
9285	payment	1726	1726	1874	1	1	2488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkftTVnVXsAQ6nCmMSt4bYMq96ejqRi1WP7WKYs17kSokA4vo
9286	payment	1397	1397	1678	1	1	5525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpdxUL3mebije1F6TEuZpB2rggGAQJc6qWZACVNujWTJeJcfj
9287	payment	1987	1987	1668	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVtZQNCeuodmXPezJoqxUHcZhKRBhgsYMbxQhfqgbgWms5Ddq
9326	payment	1397	1397	1678	1	1	5537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ki88pnbcMkXiMj5azygvpUsWd5s7Gd24vKDahetF56ei4VUY
9327	payment	1726	1726	1874	1	1	2501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeZGEvL3yXbr14ogw75D7DUXVBQZczYej2pCcKGVkAKd2Gi3s
9328	payment	1602	1602	1989	1	1	4	861340000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3p7Btfijo4z2V19TwBnxw9y47sC8eSTJUBr7E9jgmxa7o8Qjp
9359	payment	1726	1726	1874	1	1	2508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmudnhqS3oBvod16qr87zqbosksvv1DW3Dnpg2EPMMWVZvFw63
9360	payment	1522	1522	956	1	1	6	2006000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYy6i9yzuCwxWAMvGsRh2fefzb4mcBYu9Bi9NmtQ2SeaPhg4MZ3
9361	payment	1522	1522	1076	1	1	7	3595000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYT9ft7L7EoSuZerQeGA2hG9vm4pRtXeBeVgGi3muvNZHbEMLnN
9362	payment	1522	1522	1196	1	1	8	2426000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpZvqxvPLeNegKk9XzVyQ1Fp9zSBsKEDg95mATdErx49qjERpsjp
9363	payment	1522	1522	1322	1	1	9	6759000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYWozY8FYtfY9w121SLFHHjY9KdcLuTMsEgTpT35bQ1wqJBgcxg
9364	payment	1972	1972	1974	1	1	10	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuk3Xi32iLdNKR7ozkH7cyY42ziame9i5TYk9dvCK6tRoqytgQ
9365	payment	1726	1726	1874	1	1	2509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfv3r1kfCqpvxrTTpGZRF4NnXniuTvsQQcepeKWyrzu2EnVoS
9366	payment	1397	1397	1678	1	1	5545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bf8RBXMqEpRBR2Mr1NiqbDukebGHB2iiwGbfnTYg8D52uCtt
9214	payment	1689	1689	1149	1	1	4	2864869922689	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZoA5CvQo1f43H1tfybbHVttbGX2qaeu1c2HzAEeX8FnehCEAaf
9222	payment	1397	1397	1678	1	1	5503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwZMSrhWTGHBTUTVD2rnwNTMZio4WwmoV4JH11ohy7hYZDV2c
9223	payment	1726	1726	1874	1	1	2468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdx8MBaFu6mESC8su7R1DPd9RACrMG4HhL5VRNtBsUmpqZEsmV
9232	payment	1594	1594	1985	1	1	4	1198000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkqEqoK4muyUExNVh46i1f83Duan1aFiQ2Tnfo5iMrThnZ5wJ
9233	payment	1397	1397	1678	1	1	5507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwQhfdFJVdSb29FZgarZVrA1uKpe22eJsYmGSpB4Xca7JjgtB
9244	payment	1726	1726	1874	1	1	2475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrYHQQafssY9AJgBnbhNH4tB1FcGuMT56VjsBjFJCY244ejXa
9245	payment	1397	1397	1678	1	1	5511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN6f8NYgjh4RP9VTCCeKpANDWun9XiiHc6hRMUwd7KbrPMZd9
9246	delegation	1983	1983	1610	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjRytpVrzNTMs7YRY96eamKnELHUSpydcXcQ4MzrDZDn1NVez
9258	payment	1397	1397	1678	1	1	5515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZndBVm9wT7W2GhH1jMuxgVpnYNzhS7pqRzPKwHUb5kxLZYgVp
9259	payment	1726	1726	1874	1	1	2479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUwfobJoQdjGGsKCD7biM17FjNVfdVPTeDJzGddMAVQJgzK8S
9266	payment	1726	1726	1874	1	1	2483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogEohsZqapvtKYz6Zcd3K4cTCswWJL8tk589kZo9Bq7NLYCGt
9267	payment	1397	1397	1678	1	1	5519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwDMpiLuVgficdMyqU8MjGuFXHxfivZSmEDJzuZJWdZZ6vvjH
9268	payment	1711	1711	1001	1	1	5	2371000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	CkpYv339xTmHuPUhJhLR9sTAEHTkQ1z6chaPZpYyC7U6w8S3PtoC9
9269	payment	1711	1711	1241	1	1	6	2867000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	CkpZ21voe9g9ykWBBYpbkvgj2jfhExXYtrpE8JVN4EQSZcpVfQWA4
9270	payment	1711	1711	1121	1	1	7	4249000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	CkpZx2NWTNc2n2DUK827SoRMKDis5YeGuyjbb2FLP1TmrbQyUj2ar
9271	payment	1711	1711	1367	1	1	8	7988000000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ42i8ZhyEHSWHr23eDN7Foiy	Ckpa7P8ELkLfEfgEYfCKar7ZWuvdoyKG7246Bf6WLMAWxpfhmUbTd
9272	payment	1397	1397	1678	1	1	5520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAacd9TMiegMCFXx9YnQjZusCjHi4xEb3updHBtLVwFuXu1sBS
9273	payment	1747	1747	581	1	1	0	300100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7VbGEj5oJrKhSzrnDenbGfYjzqjTkPwfTiK4xiRAiGsaEtLu
9274	payment	1747	1747	698	1	1	1	300100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGW3nr6SnGLGkoxrDuazNBSXQ7TmZmc2PqfJzE2pc9zzHJhKvx
9275	payment	1747	1747	742	1	1	2	23100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9XUhzYBvNBJBjHxYV4MQsatNjkqEQexVheocVMzxczL8zsTW
9279	payment	1397	1397	1678	1	1	5522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEih1XTw8PyNLHeFMUftbKo6J8hpMWWUbZkSTL1hoRsC4PaML
9280	payment	1726	1726	1874	1	1	2485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjQZC6g2vVrPKquL7j8JLYkzN49wogcaJdf5HbAjUqZp48eZK
9281	payment	1726	1726	1874	1	1	2486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4aqGwNchQSUxmxjhkDeHm7QjXCub75tcjqfXHoAQp7c5xo6n
9282	payment	1397	1397	1678	1	1	5523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKoWgQKjG3cyfQ6hJAvB1BPwqWfMfg2NWE2aLWHPV7WUwPVNA
9283	payment	1726	1726	1874	1	1	2487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHujww4R6bisJsyLt5pnqkF2L1GNK9RofCbf6EJnLujZ97hK6
9284	payment	1397	1397	1678	1	1	5524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMC19o4zdu7UdFwYZdv7dnkrdETyPHEz9LVjNpHHhnN6CTG9fT
9292	payment	1726	1726	1874	1	1	2491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMs1ibp6uoXq3YFhYvi2r1GjuiJUP6UGvDjzcDripMYV8eUd5
9293	payment	1675	1675	976	1	1	0	2228000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi46eLysRjmwZfgZTBPq8MSq8XWKfcw1QdtvBZ9FreudRy64sm
9294	payment	1675	1675	1096	1	1	1	3992000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUU4cGXWXEE3gXyq6FYf983Ju3soDAnHTHy2ztx2YsUwG4x53
9295	payment	1602	1602	1003	1	1	0	1642000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiJgHW2QoKzsDPFX3mdxYSFxZx76XF4YtX8jwqFyNi4CNDT4A
9296	payment	1397	1397	1678	1	1	5528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFXGSmCDTy5dWXHKxn38VHPutZhp1AxnVqFFZbLNWi9ehmM3c
9297	payment	1675	1675	1216	1	1	2	2694000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86NbyAsE81enyQDG3wPH4YY2Q1JnY1vk9SEVTFMuR1bCwQzXC
9298	payment	1675	1675	1342	1	1	3	7505000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQhDSMXAnpwt2uQc8EJGKanH7LPoEh9KDBZLb2TqUArWBXGNF
9307	payment	1726	1726	1874	1	1	2493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Ry3H19ATWi9JNz4wFBk9jb7Xn2amJZejNv15LUMZJDi43hXv
9308	payment	1587	1587	272	1	1	6	864244000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNcGuXG3i6DBJHTHHE1bAr5h6XUN9Fc9WSoYYw8QcpsY5F9TTR
9309	payment	1726	1726	1874	1	1	2494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ivhNwPDRkDjRBdq94rrCXkxyDkqfihzVsaswcvRyaDYNSRWv
9310	payment	1602	1602	1123	1	1	1	2942000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAatFdJaApCyFqTHYeHkoLXzUuxwuouGEiudd3S6Qft8Z7XdG
9311	payment	1602	1602	1243	1	1	2	1985000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJptUt9PyS41kuU2FFrTcgX8KdFksFofnt4yLEcuTkjHWehk9m
9305	payment	1587	1587	272	1	1	4	282330000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHrefz5pEw8zEECLjDnPp32crTNW9Vt5xAfsP1XX8sffcmANw
9306	payment	1587	1587	319	1	1	5	282330000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxY5KEi1379DGoAVTMh6tWPA16ZeYb8vvrYi7fMJnuSHNSg9L
9318	payment	1397	1397	1678	1	1	5533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6P9nVc6QRtxsgo5qozrN5jnEjeontKzU1MVLrnLmSyMzzQHg
9319	payment	1726	1726	1874	1	1	2497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXU5vkj8gxWFBavgBUNFXboWBHRqzqPoEoDkUu4YiHWh62jXD
9342	payment	1397	1397	1678	1	1	5541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYNqhAJsYiiCQNkgBCbjgYwDZQ18QRaaMWQ31QKsHPbGHvnrp
9343	payment	1397	1397	1678	1	1	5542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgYEZMXquNjTv4GrvR9nsDZK1gAUpauLf319Np7JhSf9XVy68
9344	payment	1726	1726	1874	1	1	2505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2n1f4Rz3yHkrhj1uN1kmNR1QX2oJ7QPXECbSYAmVRfGgbsZrk
9345	payment	1972	1972	1974	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZno56LwgpuQNQzMjtXDc2eBwvwKwNiwMerrHLpQf3Efq4GiUrQ
9312	payment	1602	1602	1369	1	1	3	5530000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4YRpC27mJYTHjtUvej7dqsoZfSmDaN74HurDRs95mveEGtzY
9313	payment	1397	1397	1678	1	1	5530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQUyfCMLZVPFvvpiGqZtzpx6sCe6SS24eSEps4Cs5SG3FawdT
9314	payment	1397	1397	1678	1	1	5531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bmmiv11DuwygNsTCoEJAddAdXMFpVLbHq68H4L6kQXZ8jXd3
9324	payment	1397	1397	1678	1	1	5536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPZdo1sDiiRkCRg6bvUNd8FmSLfQKJd9DJKZsxEPydhFh5ht1
9325	payment	1726	1726	1874	1	1	2500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwmKBU3U2WPedd83CYrzsAr2kuec9uTox2V4jeY3UXj9fkgsV
9340	payment	1726	1726	1874	1	1	2504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqgJgi2KfZfQ7wmwmpC6XoWPyKnRspf9kkxWQwSskhTe3poAX
9341	payment	1397	1397	1678	1	1	5540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2AammimkvQmRMP7j7RUikzighQUBi8U1bjBnp3k2CEFaoTTE5
9346	payment	1726	1726	1874	1	1	2506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwF3uR7Hqv1NUTavceSU7nDzMqJzGyNgkRW8VK4zz3yWPC9Lm
9347	payment	1397	1397	1678	1	1	5543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB54zhKA2UGSyTGwnSwK912ipXnqouPcHoDVRKc6t4Z178LVJB
9348	payment	1972	1972	1974	1	1	1	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqo8sNSH6XtmzuormUa9FUi26wwtYDuaXYguZseiUvk9GGhYp
9349	payment	1972	1972	1974	1	1	2	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFwm64dDBP6upt7Qr7zmFAxddEiRJUkFshnyub7m1oM9LJSNW
9322	payment	1726	1726	1874	1	1	2499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpACcZ5Y2Xi3FgHRwruvcA6g6Dix5mcMcia42uhhGSPf7JHQ4
9323	payment	1397	1397	1678	1	1	5535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYoUEKLKzxykA654bbDXjpFZsR4CrjyCPPVrqLXFkgzTfRjxb
9329	delegation	724	724	498	1	1	4	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyX77HVqGiMrF8AiNtQ21GnFPDb4nr15dMQ9dbgwdEdXc8Rgm
9330	delegation	498	498	498	1	1	2	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcR9QtNePtJgCJAYn3i9au8qMXhN2d4ueppty7CYNURczDPsu
9331	payment	1672	1672	919	1	1	0	2599000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsg758t2KmFdM3asKo3k4oXqKWkV7KoTRfZJNqRHGtqc7CueiN
9332	payment	1672	1672	1039	1	1	1	4657000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWG36bEwPPYtpBykeajbGWs41pW9EZMDK6zdp9jXMYdJJk8mDw
9333	payment	1988	1988	1990	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELyGFYoktqsAjWAG85Y2pA36qAN35Nt37UP3oXHK7aLKdxGzt
9334	payment	1397	1397	1678	1	1	5538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXYxQs7g6MSB33ejfAZMmHZ9ymDFMXx2BVJHZdJqS97XszjNF
9335	payment	1397	1397	1678	1	1	5539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjRykQJB9FytjVbAcgmqw9yn2FvfYreLxyAkov1PgdruDYsQj
9336	payment	1726	1726	1874	1	1	2502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxq82MeWBohwcS7aLVCadwtEpJucbPHJZm6yBBZevDR8Hjb7Hu
9337	payment	1726	1726	1874	1	1	2503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEDTt6ydgaWeiXLJBBMSxBbAoQdCXEAPiWKQRs7ZzAnvKuAiV
9338	payment	1672	1672	1159	1	1	2	3143000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdAiXjzaMebLr38YRnNwTLK1Ep2MemV73Kfz5UmWmcYCfH41D
9339	payment	1672	1672	1285	1	1	3	8756000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AcHbYbpJpzhs5j6KLZiZLFVCmw3L7zbdj2BpEiwGdxJmUpbz
9350	payment	1726	1726	1874	1	1	2507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDAzDoc6ATBLJecfcpkiBqoQnQCZSNAk5m3x8rgqZD34HidQv
9351	payment	1397	1397	1678	1	1	5544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHvrtSjHYGeVgQx1ycYJ7FmPQRBxk1JmTzmqDb2Nv8u3ndEyp
9352	payment	1972	1972	1974	1	1	3	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRNpnVynW5aidyWywiAtajoRmhhWcN54zvXPRz6mUXWPSjbt4
9353	payment	1972	1972	1974	1	1	4	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNr1NJijwtEu61VhbXYQVwmLudqhasS1xSxed1h11guXCnMSw
9354	payment	1972	1972	1974	1	1	5	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCydXu6qV8LVQU7KKoF99PPwKRLUuWUVvUp2yB5y2a5EaixmG
9355	payment	1972	1972	1974	1	1	6	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JHHiM56za2wJN46kcb4mTYWEkSbzwKCcjHHEEpTX3jJU33k8
9356	payment	1972	1972	1974	1	1	7	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8xUvRXtJEXgwE56oKZkoqjhpsr8LAjn3iMWG1BBi9ZLbRPdK
9357	payment	1972	1972	1974	1	1	8	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ui7TWgARRowsYJgJjtpDsc7yDJngvxChen1Z4PXm997TXGvQ
9358	payment	1972	1972	1974	1	1	9	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWd1KMWuWGesU6HmiaHqJj8kSuj1vhkW9QgTpUiKVExkzFzKx
9367	payment	1397	1397	1678	1	1	5546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPTKqy6QUG7FaRa1zH5Vp23u6aEJyy4T9jtVE66UUVdJynZ5c
9368	payment	1726	1726	1874	1	1	2510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzs6gcWPxM2PsxtyoG1gWNzFePmvgpn8iRz9fmGx4amomtUrXc
9369	payment	1974	1974	1972	1	1	1	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFPgs3NSboHv45a1oZRsFsETmtGbYCWV8ezwUkUdNLxWQXTxN
9370	payment	1974	1974	1972	1	1	2	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJ3NJpuTV8t1zxR1DZ8QpZHLqK6KpCsbALkL1NNfbbRj14pnj
9371	payment	1974	1974	1972	1	1	3	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1r4Xiq64CTN9ahkJRX1BcejwtawyfRy9C2GYibm3zHX54tjG
9372	payment	1974	1974	1972	1	1	4	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3YMQfioNEskbPGWUXEezJwMReMm8XpxgGMFaK4C7ZzKH9n7i
9373	payment	1974	1974	1972	1	1	5	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pSUhRnqxSbuVZsH29fHkZYUDG9EyeuwtrWvbGncveQaSFZRx
9374	payment	1974	1974	1972	1	1	6	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AVXa9PCnPR1E3jC9EUhFf5TyxjhQmyKAmXQYqQVqcFHyTVx6
9375	payment	1974	1974	1972	1	1	7	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWYa6ysu9Lrnf6JfDMkkftfzjLiJmtC7ipVj2U3UaZxwL4mYr
9376	payment	1974	1974	1972	1	1	8	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR2mHHvFn8DN9nf1g92Vno1v3dHjzZDm1VP2QxzvNwXMWGe961
9377	payment	1974	1974	1972	1	1	9	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfKgnU8yJ7Ehr12Go2BpxU78pSgZPKjSTkW57c2y8q4HtxwDh
9378	payment	1974	1974	1972	1	1	10	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJPpoQktcq8i7vp69nJJLmavWCuj4386wsHAARoQh36uEAy7a
9379	payment	1726	1726	1874	1	1	2511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyveZX65wSmJ73Eojo2zzacBJ6P4om6twxmfmdfNTF1xuNiapA
9380	payment	1397	1397	1678	1	1	5547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FnwgqsmZvQFaqvkqMn8hLYbvFCE4V1Fs1B3fbatnHQk8x8we
9381	payment	1972	1972	1974	1	1	11	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAhqN7BAbTZVJD9dVjwdewE5vPC4yZoEGZvL4bebmfkVv2H4T
9382	payment	1972	1972	1974	1	1	12	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8wBtYrY6cdF7NQcc2LWWQUsrwimThjrUk2hpQwp1qNmFEZ4e
9383	payment	1972	1972	1974	1	1	13	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAFsrZCMH5TZRLsivLsDUMeFqor264Vf9aKm79ZvyErniUutk
9384	payment	1972	1972	1974	1	1	14	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRmD5pBbmJTZJ83STUbgxkXWJxV8ptdgwz99g2aJdcKQEpdPg
9385	payment	1972	1972	1974	1	1	15	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVe8VMhkvQ27bGDj4DCr8hgu2sT6HpKPa7TtAphSjF9sMbMmx2
9386	payment	1974	1974	1972	1	1	11	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhcGL66wPrDsvEcptqrvahXJWWPaNTbZiJYBtdHTqpWxn4uSW
9387	payment	1972	1972	1974	1	1	16	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMtPBMjvivzzpqEnhccm2yHgFLHiux7KhSaBXGmudHNFae672
9388	payment	1972	1972	1974	1	1	17	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyz7im6CTUieT7kDg3NLrp2n4KiBv1LR4kZY3UXLUA1RHRm8G
9389	payment	1972	1972	1974	1	1	18	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxySb8TtfGoFprPKRbYXHmNbW96sFNF7ESSCZtHoV4eSgYdPs
9390	payment	1972	1972	1974	1	1	19	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6yoEVZeecASC3ALEczv1tf5fUfTr15vJgyZM8T6TY19ZdBBm
9391	payment	1974	1974	1972	1	1	12	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHRTj1JRXUrmANGeqZS4bUvEFHv2HqpqiYXh1DpMBktWVw97c
9392	payment	1974	1974	1972	1	1	13	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1LtxJ7wfaRhnaGqFA8XcwtZKE6LCuzgfiSfegK7TB2zNAgj5
9393	payment	1974	1974	1972	1	1	14	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNX4viRiXgsxYnAfGDYeUn4D8hgZ1sZDWeezzfdRuGwicTDD9o
9394	payment	1974	1974	1972	1	1	15	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9DDAZcZxgBugnXLC7aJZNfzRZ8e3nRmmkcjMZaqUabe4gz8b
9395	payment	1974	1974	1972	1	1	16	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMLEfCbm7uyRa1QXgfBQ8pPrey8EVPCocgiNi1YGRf38FaWDg
9396	payment	1974	1974	1972	1	1	17	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gmushzD3SiAQkXUhkLxfK4TdReYob8kW3KnmxTLYk3mqFRnS
9397	payment	1974	1974	1972	1	1	18	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCjqMvdzjcGHNGKmqPQWxDsxmUzQRX7RQyviXNUYd8j4KT6Mx
9398	payment	1974	1974	1972	1	1	19	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Zvk7jmazXeeBD3uy3acG5QZZvWiMFXi97oqbtkghno2Ud9kd
9399	payment	1974	1974	1972	1	1	20	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFUY9EhqDpqvwPf9Mtgdb2BASbJ5wzhEANSELTvKwJNNi4cEi
9400	payment	1972	1972	1974	1	1	20	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSQFfWTfqMPzeoN78R3JUnDBwHs5VWuYD8d9MFvrZ5T7rbw35
9401	payment	1701	1701	1288	1	1	8	6758760087438	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpYVjWwURtPADigF1oGa9Xoua8tkHRokD1myb1aP6W1Sbjrm2RrZ
9402	payment	1564	1564	1338	1	1	0	5837000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTX8hWfCgAcPDMPExZjUxdvWpNv7MMvUnG3i8LRGicLuX9NfY
9403	payment	1564	1564	1092	1	1	1	3105000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCaLJypvbF1pZgzutfP28YYGhhwNVbiBqgmuVwZda12hiedBt
9404	payment	1564	1564	1212	1	1	2	2095000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEuqtfcLqnqwMMnhxxXChE6W8aPWrWDUyozfgapbKVsqBqUWS
9405	payment	1564	1564	972	1	1	3	2095000000000	15000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBDp3qrv1seX7QwKijpu6DAu4edv35KjpVrwiK9DEdBsACHAn
9406	payment	1397	1397	1678	1	1	5548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TVwtmniahK8vi4awJrVbELG9SskJWHHgEcBdiZeR4di3UsdN
9407	payment	1397	1397	1678	1	1	5549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn1x4r7i78YYnzknHnTuuMPM5p6khgaQYMuit2vrht64CZ7F9
9408	payment	1726	1726	1874	1	1	2512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQd6bBFK8TfZVDknEVwwoH5Cg7149ArPF3kfjkUb57ZgWXjKP
9409	payment	1726	1726	1874	1	1	2513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdr5Hb6VssrsJjfZcJsUdGs7b2mNPz3mW5RgA95Y9TksBgvvZG
9410	payment	1397	1397	1678	1	1	5550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpaZTFfJuj8YAL6KUtryuh9hfpT41yE4Nfu1QpZj57igQfRuf
9411	payment	1397	1397	1678	1	1	5551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZkpCKoqBk6Z2B4hubAnbLMhTkwkqyDtQWkxCoiXkqMUXDdei
9412	payment	1726	1726	1874	1	1	2514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9gNwMd5618YYCQSmhsmjtPDpp63KiKA2C3q85jVeUnhtCmp9
9413	payment	1726	1726	1874	1	1	2515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDJiakXcFfKupq7q44vQpVa5vR4bng5e8NcaB2KA7KWbG1wNR
9414	payment	1668	1668	1004	1	1	1	2739724000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmrTtZWUSDj2fWQhGBwwJmhw36MMHLHXW2SX4yzFNAM4iFHFs
9415	delegation	1974	1974	1483	1	1	21	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45AB2RfXxHLDctuQWSbngjB3sCHBuw5ftyJntj82ZvNNr3bqo
9416	payment	1564	1564	588	1	1	4	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnM2oURWAadfe7YfNpods8iomwm7dzFmKg92Qm3w6Dpe8PdmDg
9417	payment	1397	1397	1678	1	1	5552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZam3Nm21FoFnCAZnBuLN7N1LiRaa5vK8Z5SZgtke9HxMyR9A9H
9418	payment	1397	1397	1678	1	1	5553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7AmwZ7YoQ6azq7ACGGWejzsNfRDsh9wxwHmuhGzSax7CbLEjP
9419	payment	1397	1397	1678	1	1	5554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1MFM9EG4EJ3EdE6skMYacEygLwce3F8sWW5e53fqgsQvNbEm
9420	payment	1726	1726	1874	1	1	2516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5Wu7hJHJpWvwrFBCSLQRUqM3iXnzTkTUcwrpsLAP7gNZmT5o
9421	payment	1726	1726	1874	1	1	2517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWfVZA7auN3s477sNav9v1WKhUGvVACSiJw7iKD2jEpkZA6h7
9422	payment	1726	1726	1874	1	1	2518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdenvTo9SXTSum7frmV3tPM1V4U6588qgRJ7YgFHt3vdjczbb
9423	delegation	1972	1972	1406	1	1	21	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRuMLraa2pygWJk8ptv4Ukio4U2fPFerVGTm1Fo9AfRPCQLRRR
9433	payment	1397	1397	1678	1	1	5559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbgvtkFV82VKdDakngzunZuPSNLqwoLX2NV3Vy5MHEP6TWyM6
9434	payment	1726	1726	1874	1	1	2523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD5ZN6oAg7UrZYRhthHzKY3JeduWY8KkmCxezmYiyddzq3JqR
9450	payment	1397	1397	1678	1	1	5567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4jKg7E6FkXejKp1Y3KCnyoRdf153c3vNNYJuwMqGVpyPEwas
9451	payment	1726	1726	1874	1	1	2530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqwRxLLavqwL8g8aVdPzrBHmS9MkUKcJkqu1g29QDWCFMWe8tp
9456	payment	1726	1726	1874	1	1	2533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxc3Kfo8rWMV7kLePuatB3cxKgYwsq6kzrdeiXuf41ehvnzAhr
9457	payment	1397	1397	1678	1	1	5570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hCZhGk21UzsqgAnwgmWRmH1bCVMD3fBhSwkNhtGKYjbuwpjh
9460	payment	1726	1726	1874	1	1	2535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkahXx7MGCeSke8LAGJ1tbAwPK3greUgSTotocCuZkFKazEyso
9461	payment	1726	1726	1874	1	1	2536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLNxFtp8hxMuAsAQqG2T1rP6zNEEjNBwQVCw89nqWgtH8DPLS
9462	payment	1397	1397	1678	1	1	5572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGaBCoGb9uxUaSPrtv2ENNa9fD91p5DuRGuWwVXm9xzyimzbe
9463	payment	1397	1397	1678	1	1	5573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7iySJa6L66A5P2Yguc962A6r1rThdvpqqwfN4HQZ9TjYYNLG
9464	payment	1397	1397	1678	1	1	5574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftb9VfWK6Hfff2hS4tavjEfwP3LSEFVtLxVPHj9jxmbmA4k7q
9466	payment	1726	1726	1874	1	1	2537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3heYtNZZduAsQz6GUAgrjFDuwr1BVSaTCkkC3y4x3e6ej8SZx
9469	payment	1397	1397	1678	1	1	5577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu6HfwPkZadiqqSmeji8JS9CTq3LgM9P95Fpw7onVjNVw2yYo
9470	payment	1726	1726	1874	1	1	2539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxYpUqy2nY7KQgTcgwAopRGPYUCmZNsti9EWuGFFzJpHDbmcG
9471	payment	1726	1726	1874	1	1	2540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYED8CJcpvhPZ3AJar8NKk6Fb5Gp3XRYWQPGPQ5vp5PWqgkzup
9472	payment	1397	1397	1678	1	1	5578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswRNVn69b9zCpGm27dRB6J9CCbZKELWYockhEdHeK9v6LCFAx
9477	payment	1397	1397	1678	1	1	5581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYRRnxEevzp36VaGxWLtkzQhaXezpXRZhFiDrrJ3ZCrQebjA6
9478	payment	1726	1726	1874	1	1	2542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqe68TdbG17iFiVgYGK6JRstx84qfbxrPbjbyMfXCeHtXNV55h
9479	payment	1444	1444	1381	1	1	1	8294657600000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpYxLBqf3G16pWa4ce6vbDr4UG2aHqHtRb9FcEkEPF3saZcP6gsk
9480	payment	1726	1726	1874	1	1	2543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ56YpLrCzFd3ZkncUJhtzyeT8zcUWrWiRxA24V8MqPScVYUfM
9481	payment	1726	1726	1874	1	1	2544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFS3APbwNRYC736QT6LyvPrW3E9LzFwHVLduLUxwnbGnmYBz7
9482	payment	1397	1397	1678	1	1	5582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzN96RJhXTTcvzSVDdsCmWPEwzj2FwBbvGPGRAWwe321DGykmX
9483	payment	1397	1397	1678	1	1	5583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hR4jVgMmBNqDSBxHh3drDxNXVVrwwCke51nb3HK2XM3EE8Tm
9508	payment	1726	1726	1874	1	1	2555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbgmHwEhH4ZfJWmtZ4He57fXX2GVkvDcJupB8715JT8B9NCBy
9509	payment	1397	1397	1678	1	1	5595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKrdh5183TtP9jD8AvDCmkW2Z8Mdc63MZsEKnm3PMj5Fd6oNH9
9530	payment	1726	1726	1874	1	1	2565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3j7ZpahFaFJU8usXEKLjrU6E2UUiZnvyKtwx88KZRbf6DBaZ
9531	payment	1726	1726	1874	1	1	2566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9YgPDaah9JZhvg51bGmhtcVjsHgnvG8SjKUJYCqnwMgBbPGX
9532	payment	1397	1397	1678	1	1	5607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwv3XddGQZda6XxnhJm62crwi5ne3HJTVmYLG7BiymGTmEkc7u
9533	payment	1397	1397	1678	1	1	5608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qLTaAMZhCG6Vq2aBQv12b2nCFz8vKqqKHCLLvDNxUxYHFaJz
9542	payment	1397	1397	1678	1	1	5613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfg6HFofadoXZixScFNyG7LYts63P1AZYqCg6n2CzP7aTsBfu3
9543	payment	1726	1726	1874	1	1	2571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hjypa1fNiaWTzJJdT8Qe5DHG5x1frx8YeSXDAVurFnisGccJ
9558	payment	1726	1726	1874	1	1	2579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvoNJubNQfKVvg4c5VG83eCsD4gEsLDUF2USw2zGFPkPNH4Q2
9559	payment	1397	1397	1678	1	1	5621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9pEWsTFgH1Pz3CSdRzXQTjR9d1aVdTbbJmhNaPJZyzodrvDj
9564	payment	1397	1397	1678	1	1	5624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhtanPS5DUAocydpnDzJ6V2yRESpD3pAefcruUZCwYiymtAox
9571	payment	1397	1397	1678	1	1	5628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1D4KtrS9WjoGEQe3jV6TMcdQ2ojvxjVhkjNLnnpA4upZdLiji
9424	payment	1397	1397	1678	1	1	5555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxe6o4fvgAWjvJEEcX6thkFeYJtZqXz4NkbT1AMNHFkN8QoL9
9425	payment	1726	1726	1874	1	1	2519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsq4n3SADwkL6AsNdHb3dDF6Pmv7QSmJi6uhdMjb2s1fzpfWqK
9435	payment	1397	1397	1678	1	1	5560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGbGpDvHh5daZTbxZG1sUvLMTMCJqeuPnDFXcpZ2oqgSAsK3o
9436	payment	1726	1726	1874	1	1	2524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCmG8up1ciK69LJnMWqgsSky9QP5CaDKseMXAARw2bbLiDvJk
9437	payment	1726	1726	1874	1	1	2525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzatBspn8oq3wDx1Rcy4vgidAG1Z6za3Mr6eh9FCtsqfTt4TR
9438	payment	1726	1726	1874	1	1	2526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dPfE46PJgTjdYJLjXmmKAW6qJZoLkkyreNGyi3aatQr7j9XM
9439	payment	1726	1726	1874	1	1	2527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46RVJfSCRybBgo2U8dncp1ksctfeVDYD35GpaJCja1sHjCTYS
9440	payment	1726	1726	1874	1	1	2528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvtFkPCBgJ8CdTyMwsREaSFqz5kYt2s5gGLKuBsseCRHLzUxFX
9441	payment	1397	1397	1678	1	1	5561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqqbNkB4cGCE6fFKdYSPHDHP9HxZXt3tsB8UHiXNcq2bA2qJ1
9442	payment	1397	1397	1678	1	1	5562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrFrBPVSEHNoVX851w9LRDGyksuSAsYMupy4eCFNdZgeuadxg
9443	payment	1397	1397	1678	1	1	5563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7vMkKGDZjkhKBRtPZJK6wAaJRcSnHnj6DKEMKg6cvkYpTKoB
9444	payment	1397	1397	1678	1	1	5564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHUc4XsAkHDXMHm9rXkg2RWY3BTQQs7AV2DTacEVsFkhd5EsH
9445	payment	1397	1397	1678	1	1	5565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnud1q2VJaKcaRdkdSy5UFJLtfy3y7d8cgwf9vgBsSQ78Q1GEZ
9446	payment	1668	1668	1244	1	1	3	3312579000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLP5v7LgSg83n9RpMiNss9pkFxyUcrEz42YUzovcWyCHnVmAjG
9447	payment	1668	1668	1370	1	1	4	9230795000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77n6xjpgb3gTA7mUySHrkCenwBLANAHSVUW6btpKoKy7jofUg
9476	payment	1397	1397	1678	1	1	5580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzojUjtNbUaGoGV4WbQat1CfkwUsXXirj4YcJt4UoXzytYLHNn
9484	payment	1726	1726	1874	1	1	2545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwJMKLGeuJJArihJwb39Dnm8xbY4YgWK817BPc57yiDYjDpZC
9485	payment	1397	1397	1678	1	1	5584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykJps5aE9tBHHJiUms3P3DKGqPz58j5WsxKinxHEcebdKG5ku
9497	payment	1726	1726	1874	1	1	2550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbB11NQ9y2ih5En9G8pr4xEBB1hnMWWAiz8nzfd79VvSkFpv34
9498	payment	1397	1397	1678	1	1	5589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1APiWCLek3nSUSm67bUtXxP3rbsQ6T62dCQ2JqMWwDcEkUG4Y
9502	payment	1726	1726	1874	1	1	2552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMxQBbEsjSsJyibeMKCcku8vKDoYJfhj3gx3Uueykxi3Dc31q
9503	payment	1397	1397	1678	1	1	5592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQL4UMTBhSZ8YR7hUXCXs7WMYHytADV94ZoxYAt52t956ZaeP
9504	payment	1397	1397	1678	1	1	5593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWK9hctdatUKchtFmij1TV1YJ2fMBARXusYMDprnDeyDfkp5o
9505	payment	1726	1726	1874	1	1	2553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByEDPfKXRNcw96C5LsFB14fzntAx5eVNJ9MdKVr1b5aGYToaq
9523	payment	1397	1397	1678	1	1	5603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rePvEVw1tApVFzBiBCc8PnWuG6EA7pVNyEFj8iMKTxwe5BVT
9524	payment	1726	1726	1874	1	1	2562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdZsexkdepSWb3PqK6HHJhsX36QmHkAAEaJ4pbWZvRJM1KyAF
9536	payment	1397	1397	1678	1	1	5610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkLDxATBorhuwYgpee6KqbU2uyXkwBW91n1esnsPzvKqVoE9C
9537	payment	1726	1726	1874	1	1	2568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4dsCTN7Gnv6G1ga4ogDS6EhoaBGHzXzgitWCcpR2JZ9TuuhD
9544	payment	1726	1726	1874	1	1	2572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoTGQKqQ88mcrpbzu4jPttLxtAP4amJndcoLQpkPWCsznMziYK
9545	payment	1397	1397	1678	1	1	5614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9d2m76dsYmPRd5HR2wgPBJpRbsGiFY84QEwmhPuQ1bEoPLB5w
9560	payment	1397	1397	1678	1	1	5622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMUMY6Ymz2zW7SKGEqiWFy13qJjyB56oBesbd8vjQVAZ6kf2E
9561	payment	1726	1726	1874	1	1	2580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsUvCxjCnkwBToUDHreqVB2P6bjkRQbxe4ptFnjduud6qxPq6
9562	payment	1726	1726	1874	1	1	2581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRb8rP8S67z5putWYsGDoGB3kcHGKHnAiQks9WfYHZ89qNNJFx
9563	payment	1397	1397	1678	1	1	5623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMzDkDB6tgfyURNuFRjDt5ZPtkCQU2ys78GkWFCFgrfv2nCxk
9616	payment	1726	1726	1874	1	1	2602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsrHutbRZgf5hQq5psRC8jd4PCeBXCLPXQQAG99M6AVgnbuFY
9617	payment	1397	1397	1678	1	1	5646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FvxZRfLNKgQUCSmNoiKG3hUZEjSMm6qoUk7KzRrLdxfrctLo
9618	payment	1397	1397	1678	1	1	5647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTSxaGREwCFPNVD5eUhnbCmdGmLWjBj3DjPihLZEp5e4WHCmN
9637	payment	1726	1726	1874	1	1	2612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5haBYr7DLMmTB35zhzkqk5EoSRZNA728WmPR4zfyVpAxw88J
9426	payment	1397	1397	1678	1	1	5556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRsS3xwtLSiqdpCyB9CixCpZthUjGog8X4zu3psgAv49sD9iG
9427	payment	1397	1397	1678	1	1	5557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQ8Dmcg5Mmpht4hWmM1nFq3nfgihsazZANjm9HLdg8T5diqRG
9428	payment	1397	1397	1678	1	1	5558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58bR4cLbEP7r5MAdQPd3Qxi8Xs4nNBAhyWVaYM2VUCoAgaidf
9429	payment	1668	1668	1124	1	1	2	4909561000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKn62RZcAMxEwtXRi52yFvAiJGJPqbcTxYsCvxvgCjStv7JtKx
9430	payment	1726	1726	1874	1	1	2520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZUxjbC132c9fLMqq3fQew9qmVA2FR7nXoEbEH7NTtsduDuJz
9431	payment	1726	1726	1874	1	1	2521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAiwJher8AmGvL8AefVmVz3GsyUqSttfuBWr5bJX6jL2F5Hoj
9432	payment	1726	1726	1874	1	1	2522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dDsUc5xhg3rBXJbUeseGLEvGzkzWRDRKkoSnu8GwBJE8MSSp
9448	payment	1397	1397	1678	1	1	5566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYCyamSqsmajgXjxgV1eajKFdCiFPHm3dyXqY778mFrDngGTc
9449	payment	1726	1726	1874	1	1	2529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJY1JUnNDtXBBxBYumLqg4DEKPQdBeBU6NvRRaCVUBTbUmism
9465	payment	1397	1397	1678	1	1	5575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZ4MU1BWoryj9HpbXYvbgWmtfR4Vx1GaBCExawELcWTCqEuyS
9473	payment	1444	1444	207	1	1	0	1110000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaim4ABLbDtCW43Pm1m47kaAdDgNxZwiuJ8RDTbwCWGAJPWhSy
9474	payment	1397	1397	1678	1	1	5579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYSVgMuC9aqzNnuc1L4fyT6q7EmwhXuvdergsFSSTSftWouPU
9475	payment	1726	1726	1874	1	1	2541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MB9p9JAdbp3riNEJSWLgjMNp2o88PX1Vegkf8HvxbDkSDsWM
9486	payment	1397	1397	1678	1	1	5585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcozqVZFrgXybmkCxSUQTxa9WCTWSnVJMZBkv5QHY2Pwz2SRTA
9487	payment	1726	1726	1874	1	1	2546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzN3VmJP2sXpr1cvsLCu6uiwJyUF4ZiQJRLE6ARempwKhJeday
9488	payment	1726	1726	1874	1	1	2547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckdKRLTGWygD68u288XJZk7pZnrnvSUZPy6vaxAta7YrynFi4
9489	payment	1444	1444	1135	1	1	2	4411659870000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpaH9JQgkBeZEYQk9pkk2KwvscT8TTwQ6nuXqscmmSi2NTwxWYrb
9490	payment	1444	1444	1015	1	1	3	2461875540000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZNn6uEm3vzErouj3nGW7MwmV9NGfWHPnqcrPWPhpK7z5Fh5efU
9491	payment	1444	1444	1255	1	1	4	2976634830000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZiBdkH8qBdhgASWRsdPdGBu3HaAKskVUnSuykwwrpMVDtGycok
9492	payment	1397	1397	1678	1	1	5586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvFnu7F81nvVg9tBTHJTJGE7KhrXYAz3zmPHbA3yL7RQD7wnr
9499	payment	1726	1726	1874	1	1	2551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnK4j8pk9fbCRGhZ5J2PnWxMWhSb7h9wnBBT1vfPYJFeK6Ubxg
9500	payment	1397	1397	1678	1	1	5590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWC1azu6vTC2w9Qqp9NBdpwKyAViK4XZoH82eaAyxFrdbVgjd
9501	payment	1397	1397	1678	1	1	5591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2TfNcbofarVo6qSMUjL4DC9U95KDgsHgfSdEwA3xESX5HNcX
9506	payment	1397	1397	1678	1	1	5594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufhAP9gDE98Q3rYjDuXUaKtGrigs7AfupQUeXCDNASv5MpdGb
9507	payment	1726	1726	1874	1	1	2554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4epkXVDyZ64cTw4WfbunUGPHTqeuhyeauUXX2M7SfKV4AoV8
9525	payment	1726	1726	1874	1	1	2563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczc32pXi6ekRS1uQDZUJzGs2NN5vC6MhJrTJVT233s6o61kFj
9526	payment	1397	1397	1678	1	1	5604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAowchozUvdVzJoUXHDvdP3Xy98vfU4rzXqDZDQaiP4Y3Pnxmm
9527	payment	1397	1397	1678	1	1	5605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbhmRQ8166guo84R6y9NfEWkkuh3montmJv93j2kKTWGPyEHL
9528	payment	1726	1726	1874	1	1	2564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbMFSQ8NyWJHMp1N4LauWGV5jkoFApwX6VWw76XHtkJZqZvWb
9534	payment	1726	1726	1874	1	1	2567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9g2f1on16CsvFNMu8DfwRQa2AF4wCdhLPHypZ7bhMi1wJYFQS
9535	payment	1397	1397	1678	1	1	5609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJAnywSuovkxxt2J4GxLhYahUnWEotPu1dhuo1zehDKpbjJgCJ
9540	payment	1397	1397	1678	1	1	5612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLfUs86Jta3KkbkxmP4MgyeiG6bWymQ4UCgRiPxkY2j7jKQRJ
9541	payment	1726	1726	1874	1	1	2570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGVDDx99dWYQhqMZqZmQYVJMVsx79BocWbSFerX9n5Qqf16Fs
9546	payment	1397	1397	1678	1	1	5615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgU7x2UmRt1Nbb6eyyZwcazCNc4X8oPCxeKwEFtTJrgi2A1r7
9547	payment	1726	1726	1874	1	1	2573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpPNoS1mJ2BeJQQAA679T4C3bjDfszsDvxijXY6igHhzVZwmN
9548	payment	1726	1726	1874	1	1	2574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKFom61gUgkJksTAJbcZGNJKvURW84UHy5zJwLzcSUQYrawFk
9549	payment	1397	1397	1678	1	1	5616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKM4bLGgVmX7hPBbVw2j64sKYGnMp1dS3AarxQ8bRzUKAQheQ
9550	payment	1397	1397	1678	1	1	5617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjq9bDZuxFwitgLVjRZNsrR8DBQHrrUVfKRF7kGqckiyJpAqu
9452	payment	1726	1726	1874	1	1	2531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DKjZVoijE68cU4ZXdzxLKcoP54z2Zmwno2GaC7XRisPtA9rz
9453	payment	1397	1397	1678	1	1	5568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5qkru1fdVCmLYxpVQT2SdiBbZJtuERnxcg67WWGqRjQiu3LH
9454	payment	1726	1726	1874	1	1	2532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RKfAT81gGR7KbqRk2Rz9EwQAHg99t56x9qAeAxKeFswYsc3i
9455	payment	1397	1397	1678	1	1	5569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TP4iX1CL7LjsTBWAaZfLHyCze7gy6moakTJM9siAuJafhamv
9458	payment	1397	1397	1678	1	1	5571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmWP4NJ9gtA12ZhC8LeW7CfyuTB8XRZe16N83XfxSgQcoy9ia
9459	payment	1726	1726	1874	1	1	2534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4N7ZtVwCQrMcw9rvviqNhBdPp2puCvcs61pgfUMst2r3XLSGw
9467	payment	1726	1726	1874	1	1	2538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytHLofCN3V5JKmU7siS9CWZXSXMrhmSbYwyRkoCwieiKc9n3m
9468	payment	1397	1397	1678	1	1	5576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCBCG4M6Wcop8qxehBMg2C8D1jrZj2uNAk6nbaDRXSp2TMktZ
9493	payment	1726	1726	1874	1	1	2548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfsduDqcx8sdgx4iRkyUQ6KYBz89sLWkHW8Zx6bmJbrXu14Tw
9494	payment	1726	1726	1874	1	1	2549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZG6wpqQ8D3yMEVibTaXrECA5xsdLTyo1hpQJCQszNUYfnRoP
9495	payment	1397	1397	1678	1	1	5587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbXLEroT4zEgMbWNvG33hX4YMZtHs9HBrjnyLZRbkWYF2nazR
9496	payment	1397	1397	1678	1	1	5588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTo6j7465pi9bA7S8fvxebW2mTgr6vc2fqPGyXShoKJ8ZUktu
9510	payment	1397	1397	1678	1	1	5596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8F4VBJTgbyTB3pKPwtaEbVimiPzAhF7W1KxZ7R9mQd4hHUsg
9511	payment	1726	1726	1874	1	1	2556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QpnKaZRMBQK1mdhbAF1oPdD4LbBH1rQjKZhkCqtjzTvj9t4a
9512	payment	1397	1397	1678	1	1	5597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZbpq7TpwoNoBeBHgnLJehN4GHbwcPNuVGqi35Dec49Rw8aQS
9513	payment	1726	1726	1874	1	1	2557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6zwTi7ifcFRjVn5YgZocZmCe5kZi2Xh5L18ioMmTx7CqrBh5
9514	payment	1726	1726	1874	1	1	2558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61mUXYepZfZv3h2DvShFn6Qa2YaZxUUSGV2khxEYJZPwFAM3e
9515	payment	1397	1397	1678	1	1	5598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfn9FxptGx4cWXmRZLRSpnV1rWv3PpJLkrn6sUZVxFa5Ln7d5a
9516	payment	1397	1397	1678	1	1	5599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzhu1dBALLbDmJiBbmJem6gGqfkC4cPZ9HrG47fCxqv2bBeUS
9517	payment	1397	1397	1678	1	1	5600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ANZWqqqxZJsFvSJ3BqvyKf5jDKfJ5iYjGeLGjQN4zhNyNMtq
9518	payment	1726	1726	1874	1	1	2559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo5G3zbKZ5NKScU3iHQBBX5zZTNCZXqRahyyscF9LQq5bJhLtb
9519	payment	1726	1726	1874	1	1	2560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXACQAY1c8nChNKie8i8vbKCMbmn2cbM53P37wAXtgwBiYCqj9
9520	payment	1397	1397	1678	1	1	5601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pWnnHXq12HuHsv9q2mKFApbu8PhAy7HyKnt5KZUfxbsDGArW
9521	payment	1726	1726	1874	1	1	2561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcS2wAu2TyLBiXW8aqMaAwSQpRCfthVLUmYtPXapiMcfToucGw
9522	payment	1397	1397	1678	1	1	5602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhezwAYqUkH8xQnKEyVKHQMGMzMZSgUfFAaxoN5yF54TnxFM8X
9529	payment	1397	1397	1678	1	1	5606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsd3RbjX7guDuPfa6BFRAuVWFG2fzEzupRo42dDJWYoHr8yRyr
9538	payment	1726	1726	1874	1	1	2569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6pQhSa6SZTygGN2n9nikbBZXDxf7o3JVS55satqdoiy1T1cPN
9539	payment	1397	1397	1678	1	1	5611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuJ3bzbjNDdBQgt9wYHcGBRLhtanBRe8SmR8ex6Eno5eBDuUo
9567	payment	1397	1397	1678	1	1	5626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSnx76VyxFXor1TLzykccfUz5nkmAcgThycvNNDyF81Z8r6bH
9568	payment	1397	1397	1678	1	1	5627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmHochaWx3qmFaZQMM8dMipFNPa3se1xZAn4iyL6xBYQkKMYh
9569	payment	1726	1726	1874	1	1	2583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7a219fvH7BBZBoaEXupG1hg2QYB1hjJagzQKpTT78kue2VqRo
9570	payment	1726	1726	1874	1	1	2584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgisa7vxLvn5mFy5eP4srQTeD7CWyiZMDrC2VwfHkqHcJtYqHF
9585	payment	1397	1397	1678	1	1	5634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpHUKzA5f5GfGAaSvVrDin17JXq5bmVgepVjTmCDwDoUsso9t
9586	payment	1726	1726	1874	1	1	2591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYpogshC1U7yffL8EzcL5QgNmog1dRDLBAEz3hzuGEkLqsu8C
9587	payment	1397	1397	1678	1	1	5635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Q6tpa2yWQZJwxwBGgV72s2p5g1RBT9tdKfvRkSVcAHbVnXb
9588	payment	1726	1726	1874	1	1	2592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hviFJDZwNpdtxLVN1e24QbK8W8uy56ypDLBecTqjLPSs3ZxL
9596	payment	1397	1397	1678	1	1	5638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ63KtUP9qbiAjncLSmBNPoxzjXBQkdJCxjLRaG5SXrwWPb7T5y
9597	payment	1397	1397	1678	1	1	5639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUktjVYQjCsEZ9gUKXNZNJNyqbNH6m6g8duBZTbx1geHTePZ6
9551	payment	1726	1726	1874	1	1	2575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVooNFkfk9BwpktiGh3FktFcvWafjTUFUjjrSo3TPr7BtYGGZt
9552	payment	1726	1726	1874	1	1	2576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iex5rzQEZjq3QhPXYoJiGsi2RtWCDa5i5uqjDWpEwgVGmD4W
9553	payment	1726	1726	1874	1	1	2577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW6dR9aoHgQkTgibz2y8UZjHdEqMwHmiSsNdpDE1PxNLPTcaR
9554	payment	1726	1726	1874	1	1	2578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhw3GxLUJaxCivHtsPqZbhwf25FS8hywFpGoRHA71Y8Vy2oggr
9555	payment	1397	1397	1678	1	1	5618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQi1to6kETr6JiQ4VozqEi7MnTbqV7zV7PerMABvarkgcBhbX
9556	payment	1397	1397	1678	1	1	5619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFRhdQjEMvp7imbgZjsTy6aPXfXy37GnSUn3Z3sfZWuGQvTtha
9557	payment	1397	1397	1678	1	1	5620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSaapKbutFP4vx1Da2vNuMBcB3WdWDdJxgQRPwWxatQFe1Wpt
9565	payment	1726	1726	1874	1	1	2582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQmvuCQc4Dk16xpX1aJ3yzMuyL7TiXfq5YpYGsxkYZdSoaPuV
9566	payment	1397	1397	1678	1	1	5625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvqS8qoHABsNpYtVtj8Zsse1A18WaNEt5Bn3kQuNgnzD6dhz4
9573	payment	1397	1397	1678	1	1	5629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksKZnsoJ4EPTPNYkbx7mCtN2teHrj98n5y4bjLejATAsWaPFP
9574	payment	1726	1726	1874	1	1	2586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniqsWxgCmMBSiUSvcDhh38CbMTBQgFBmkBMuMF4JwdzHMqU77
9575	payment	1759	1759	619	1	1	1	500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTa3Bo8V7HimxLFF8XJA5a25YVga4bdNgCD8KSr2Fw9VuAft9
9583	payment	1397	1397	1678	1	1	5633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rFVmWw8w7oUvMTSxktiPQNLRTAhnhdGBvNewBcqunkEnu9XU
9584	payment	1726	1726	1874	1	1	2590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyG8ogM69hVzK45fp77QRwNRWZhrGw2X3fm4TmTozbJsgdXDnC
9619	payment	1397	1397	1678	1	1	5648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7qhEN8a45LFcWnPUPVMoTpKBRRtZvs5S4Z4TrkppGX2NRhH3
9620	payment	1726	1726	1874	1	1	2603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSg8gZf5PqEsK2WwpTTFUfFmDvXA5C4tEwEbu6ydifJ7U9H9t
9642	payment	1397	1397	1678	1	1	5659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVkTGYYpnr7egXAchLvPNUdQUofeu88Y2ep5vTmafaHTsLLPA
9643	payment	1397	1397	1678	1	1	5660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJtD7wEvwLXrJZjakhooNZ1vkL4H3UJ8Ks6TYHekZbjZiZ3h1
9644	payment	1726	1726	1874	1	1	2614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1imz8kcZ4Wrk5gg8YLppf7TvPDyG2ngx9zKMX9dgGJuNayX1
9645	payment	1726	1726	1874	1	1	2615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzB2qVngCZfRsTNAiXCPDAZ87mF1Riw1vRDwxxb1agjxSVFEHR
9646	payment	1749	1749	1950	1	1	3	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHdJSpEYsMjf5outcXxtCL4cGNV4u357W2bd4thD1ZD9qrWCW
9648	payment	1726	1726	1874	1	1	2616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1GYjoGBwVmZNKgPjp25Cu78RLLQW5Qb48FjyrRXxWQGh5Pbz
9649	payment	1726	1726	1874	1	1	2617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyWNeagfED53UeeEkVrQ4Fx7xbWcHFyaX7tAo6U2rBeNjD4tt
9650	payment	1397	1397	1678	1	1	5662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbA9xBEQA6oREEq91QTS9GsTDP41BWXPkfqVbR8eyveBitQi9
9651	payment	1397	1397	1678	1	1	5663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaTfuFxc23WvFharh2jyRNWwwSKj86y96CtxCBUJtAAw9JDuH
9661	payment	1397	1397	1678	1	1	5667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaf4SNgVaQ8xADysXg21gpLDm3QhDt8d6ukxVD7fRaVESLdCot
9662	payment	1726	1726	1874	1	1	2620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyoo1bXFauFad9cmf83pPU5B563gcm7ECAdBhnf6Ap2cmDroP
9663	payment	1726	1726	1874	1	1	2621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LLbFdJ2mKt2appDjYVR3wzQpoWjzpm4AcesEM6jTabi5ypLL
9664	payment	1397	1397	1678	1	1	5668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65TEUfNJXCMkJ4RPxj7257Jzp3jZnTkKnMkjd6qCjD71Vwj6b
9665	payment	1749	1749	1950	1	1	5	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBUzpPko8PnmsW7bXhZmWm3TgR9XGGVMrmCLtykssqosLdcQv
9668	payment	1726	1726	1874	1	1	2623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCHEUoV1ceMkHJKtrtQxEyHMsu5TnYqw7ZsCeNb9Wdbg5ZkfY
9669	payment	1700	1700	939	1	1	1	1912257035010	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8M3boGCs9S28ADHCtmBnmgNUDC1P5smcJ1bd3fh9CAd1f1Hy
9670	payment	1397	1397	1678	1	1	5670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5p2djbsLzY1ADb6HcnLwvz72uGnCHAu6nuwnX6cimyuckCXt
9671	payment	1397	1397	1678	1	1	5671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFQ66Agp41ZiVPRfehhvu2groXYjTyGSEC7JdM5MWgkvuQZjr
9672	payment	1726	1726	1874	1	1	2624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5v7wiciASXzAuE6mp5VCgg2kKZVGmo6AWsnrRzfWtSWSAX9V4
9673	payment	1700	1700	939	1	1	2	10000000	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpaCXdKwfw5wU3eT5GHQnR1c2prX2F22efsw4EjoXHsBqfxiqis8
9679	payment	606	606	929	1	1	4	2098153235309	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTBP39pDF9ZWL7srKrUA5vhLUQttdihShuuX2btxS6TLz4fEE
9700	payment	1397	1397	1678	1	1	5682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFmJo7NG7o6uRqGmxGP6R8qNMjisTWjkiinNnDb2ZvAtEsW2S
9572	payment	1726	1726	1874	1	1	2585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18o1QdJjCATMfQK825utup1AMWTMXPbjBPWWbFsaFfagDKkF3
9576	payment	1710	1710	914	1	1	1	2005972659856	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6U21Ay6XuQREWnyLBUkgrSAo8CpaWX1jNgufZX6rTGexgf4j
9577	payment	1397	1397	1678	1	1	5630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeCCBLqe8AXHPMV4MFY4fvgiSbVwNSAiY9EeLYG88GvBuy4PT
9578	payment	1726	1726	1874	1	1	2587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBkDMBa83H3vbjpSa63GPZM8sU3cx2DCbJgiZuNeGKoMbSkfJ
9579	payment	1397	1397	1678	1	1	5631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6GBRJABXptmtv9kJNxiKdePCfPkpPj796Bu6fDbxxZBw8QHN
9580	payment	1397	1397	1678	1	1	5632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxiSx5QKJVGBDciRqKTm9VrmkdCCLTszXb9XNBgtPJx9ePGjd
9581	payment	1726	1726	1874	1	1	2588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbDZw8FW4CfVfwmr4Qo6oWtQQ7rF81VUoqN6wFYoVV83gQR43
9582	payment	1726	1726	1874	1	1	2589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3U3dXFRsvK7c4yAaEv8tg2C3fk9Mk2Dhe7BbcHrxhdvrWLoi
9589	payment	1397	1397	1678	1	1	5636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WyQrdMoAhU416dpurtpHBuXfwqv6TRLxyqWWer76Lx4njBEf
9590	payment	1726	1726	1874	1	1	2593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PQ1YEuu19JCqZbMJ6sUTRSf3r8n3VkAY4mGWoyMWw9gkosNQ
9591	payment	1710	1710	1034	1	1	2	3594685819296	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKSxoSyWEXTbtrPWWr3Hv8foHRcf8e3Da5gaD7F8Ka7azj5Sg
9592	payment	1710	1710	1154	1	1	3	2425406151454	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3pYqfVWLw428HvtdYEbhgdYupmPuBTSdW3YmZp2J7GBBc1b6
9593	payment	1710	1710	1280	1	1	4	6758609896104	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHx4bNV4Ez1tLdZ9CDXWd1SEx6eZZH1p9vDN29319B2iRgzNTZ
9594	payment	1726	1726	1874	1	1	2594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq29ZLuUdJu1CeutZvhk63UaUVHV7RcU7wvVqaNUMDtraTcEGK
9595	payment	1397	1397	1678	1	1	5637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2g4f5Exr28j7qEpkKw2nSNWtabxHmt64xqbxaiFNnxGwNUad
9599	payment	1726	1726	1874	1	1	2596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmm533cyKbUCNea4n9vZSVZWfB4EJ9mzHXUEfMNp4gRpPygLW
9600	payment	1397	1397	1678	1	1	5640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxbbT36dR9j1j5oNe3Bh8KuN4kM6TwgMXG94BJx1HqxHVJt5B
9607	payment	1681	1681	531	1	1	1	407503985720	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpYwxNBswQw7t6dMo3XBexe9qpdPDeRXoVdzMdMcUHsBGeV4HZvY
9608	payment	1726	1726	1874	1	1	2600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96U8UjrdgmNkZXCApnQLrxU9X2rCo3XdxSexD5eWcVpiw9iRU
9609	payment	1681	1681	984	1	1	2	3100139565232	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpZcdpomC3AeMuUVZDM6hVk7qPdfKFahdTwaMouVUuwphqq4619j
9610	payment	1681	1681	1104	1	1	3	5555423538912	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpZYh5uzjgUpvLp1hytTWCsiwT6gPVdE8Zynv89a1AfJZwqJuQzL
9611	payment	1397	1397	1678	1	1	5644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceKd7eNxTcH9h9BKs5qAQsRNwxMbXYNpSc1gf67qZmaXHMmZo
9612	payment	1681	1681	1224	1	1	4	3748354961338	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	CkpZrYWXzLHnJ7paS8iVPmCYgkPWrk3CaRbRJKxbZ32EVp7DChVXQ
9613	payment	1681	1681	1350	1	1	5	10445124384888	10000000	\N	E4ZRjz6YUAkYRFAWbaspgWzTeYL8JWbUTr7YStCDJ2XF2cSeeo8xK	Ckpa7CvecUEd76ScDUp2omer1kPnPF2nyNHXcDjpGk5KBWP6dFmxw
9614	payment	1726	1726	1874	1	1	2601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dSYdQSuh7V6eiNGsaxz6ubahTx7XjMgKW6LqSavwmTM1aWNg
9615	payment	1397	1397	1678	1	1	5645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdc3hYmfSgVAESHCZ2AAwb6E8NRnAK1LX3XoXMdUG9xTKjxKM8
9629	payment	1726	1726	1874	1	1	2609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQtwatQdJ3joiMFqSu3SBcbjkJUMkusF6WyDRgB7auzkD2QY2
9630	payment	1726	1726	1874	1	1	2610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAW7bkx5gqiwUSncqpivg23MXsPSrkFwAaA42XV3qS6D5NSqEE
9631	payment	1397	1397	1678	1	1	5652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzwdbwZocYJKwrnTUHHnW99FrLYekZBru4X5RNb2UEGJHJHC7
9632	payment	1397	1397	1678	1	1	5653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKH9ckLKX3gFU2GnnrKC27V4wuNiEFZsKCCGBxscmFsPmJQGd
9633	payment	1397	1397	1678	1	1	5654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDDejB5jMQEaFBvu1GRirSt2zVxsPPDYAntkGjCiaBBhjwXYLK
9634	payment	1397	1397	1678	1	1	5655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvL9qZrTpH1tMVPQYLgpCoQMHPAwY4A81MtN6217fQLTTeaEEN
9635	payment	1726	1726	1874	1	1	2611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Tn7F1HKs9m19zze8CVd6FGinyDzWp68esFwYzWdRZ39AiyQJ
9636	payment	1397	1397	1678	1	1	5656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsLAyPRrGJP2k9Nw3Gfpmez2NVE3dAed8CXNzdDFTvbFAq1eC
9652	payment	1726	1726	1874	1	1	2618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuJ29PaBiTx8dfcnoiUx3TvHVA4H3Kj4f4CtnaWcmMhUZCaXMx
9653	payment	1397	1397	1678	1	1	5664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwg22kLNVmHhkHj965tDkMwDXDoQm4wpgaoYnu2hxAAiTk7Bn
9654	payment	1749	1749	1950	1	1	4	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MHfs7WH6Nyb2mM3Y2oX2RgyMymGQ6BxFzdLtXm26rHYydKZ9
9660	payment	606	606	1169	1	1	3	2536651885611	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uCAkCy4wgKVL17RkSHLJzCTaqf5ySHYd3FWrRSrDgyvoNtWf
9598	payment	1726	1726	1874	1	1	2595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFrSkyUSfQKpRiDNdAcstnALtGKuSEju7GYGQjCFAqyTtvwdY
9601	payment	1726	1726	1874	1	1	2597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGFhkrco4HyT72SJ9uNFNobZ6sNrX2pX9EArwGm7ptJPesDsn
9602	payment	1726	1726	1874	1	1	2598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsvY7Lw9c2W4kQp2k1aC77BsMAshXKqp6Vt4WoFNnLhcBo4k8
9603	payment	1397	1397	1678	1	1	5641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6E9qmj7vsNWtRMSGQiQWQui4fy2SxB8Upu6YPjg6gQ5RLgYD
9604	payment	1397	1397	1678	1	1	5642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj8ewHfkXhggUHMHhdCw2kz9VDwwwFc3rjawj2qLYqwZDEVuE
9605	payment	1397	1397	1678	1	1	5643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNLccrQ4t3G98xfwpSvm2jVqxx58nxwcWKtApqmdradQkeeLB
9606	payment	1726	1726	1874	1	1	2599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDynB8cz2M8z6Us4hpgbfP41EayTnWej8yh5Zp3zU5Vcz7FLb
9621	payment	1726	1726	1874	1	1	2604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbrDLQoTzaAoadteEhidNrxa6KJ5pjNLd91ChvUDpvNp7F5ap
9622	payment	1397	1397	1678	1	1	5649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa66Z6uAyiDCoYsyMkdoxK3Kq8Lgz156Kd1q7SoPREQhVc8L7jV
9623	payment	1397	1397	1678	1	1	5650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zDp8bFfZ81X82fMNxCQv7ZPjtxqb3LcuJqpStZWq8Sp4ZVHf
9624	payment	1397	1397	1678	1	1	5651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTxRTrXRkF1sEvTz6JZDEWnuSBSZLR1cXooG4PcSQct5RdAqC
9625	payment	1726	1726	1874	1	1	2605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQSUxCzoWUUoJ1xpQ93ShiqhgsmerSN2pKAprZJpesN5QyoEn
9626	payment	1726	1726	1874	1	1	2606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEuxPMeBWRT4rEppgCLQzw3pysPbTgpMvAsuE8tmEovvjTNDd
9627	payment	1726	1726	1874	1	1	2607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9KKxdBiVyc2QF8RmPBEQz3ituHLyo9DwcMbcURZZb5Ga6yGQ
9628	payment	1726	1726	1874	1	1	2608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1oNdXWoHeVPXyZAw9ZDruqkMFtv6zHFZv7P8NKw5UWnKp4mZ
9639	payment	1449	1449	1939	1	1	3	27000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ54uqjQvjRcuHyh91eicaGL8aoL3Un2d3cLz7CbJbtdV3Qhik
9640	payment	1726	1726	1874	1	1	2613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJdcf8NBVL3FfJCfFYyKBiEenQLfPrYtc59JCNYTsKNeYhWG7
9655	payment	606	606	1295	1	1	1	7066819436851	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJchFsHuviKQcG6a1TsUGBT9UrGx5U6gXpHVu4pa97Ly2g61kZ
9656	payment	606	606	1049	1	1	2	3759080629265	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTLeBc1tMNfYPMtdBw1rWXyBXqUcCSkJTy4tvZziySaMFKwph
9659	payment	1397	1397	1678	1	1	5666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5m9kUhbwUYHzSK6h8aRqc1GxkXdSpZkMPekjXFqZjMa2g8Fc
9666	payment	1397	1397	1678	1	1	5669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTUEMtsdAHZMtnony2BHzJ7pJcTquqo3xdnBwh1ocCmawwRAb
9667	payment	1726	1726	1874	1	1	2622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7MBHUXZXaTx5brsPvEiaHBKYpjKQXfKjQyFxmtjwyFhwfRHQ
9690	payment	1397	1397	1678	1	1	5678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZArKqvjkFjj9Xgsvgb6PPEzux4V81GnDhtBSoxDQCtxedN1Doo
9691	payment	1726	1726	1874	1	1	2630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpodG4v3XdGM1iPbCG7DJV8v2rxfaD2xcfv6mD3i3jG2WApv6d
9702	payment	1397	1397	1678	1	1	5683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSubVtjVxrzE3E5p91ahBksx3G1QJCkQdEYpLguaYpVuEyxLQ
9703	payment	1726	1726	1874	1	1	2634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwFVF6Znm6iHQbEPFPBQfwmMyp8Pcjcahg7SSkNuWx6CC53W1
9706	payment	1726	1726	1874	1	1	2636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyAD9VsbYFXrCaLCJUQKSNq1LHLm2UkUCwUiUg2tjytCRJuBM
9707	payment	1397	1397	1678	1	1	5685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SNhR3STZCVqC5rrWyjdsRps9moseWPUvECJmxwiutG3nGsXK
9708	payment	1397	1397	1678	1	1	5686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXgc8Svqxj8QTGs9zJEHXH6U51UMf4d3wrJQiAwXZkqczFd2E
9709	payment	1397	1397	1678	1	1	5687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLou47RdpcEFPyzZVLHbcBT1hgCYWxxjiqNQ5GqYpcUEmNnjV
9710	payment	1726	1726	1874	1	1	2637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EDZZ9xZEu5PsWJh4LmPtv4v3LKpkKVsKG3sA2HeGBUjKXXpP
9726	payment	1726	1726	1874	1	1	2641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu7YznT4xy4eE2wusVvccfzHusoqeE7R1qdk66s59LJ7RLwdWF
9727	payment	1397	1397	1678	1	1	5690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmLy1HrytpG2x16J7wQoTuH6vE9vF93X7F2iFhJmLTZbAnEKh
9728	payment	1397	1397	1678	1	1	5691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQS6kmD3y2yiYrghYiXyjdYrE9G8efRcyGpPYDsoXesHXGkQF
9729	payment	1726	1726	1874	1	1	2642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxT3LxthwouWm1fcy65bWYE74eJWkHVe1f6VMYukPTXBVG1BZM
9730	payment	606	606	1169	1	1	5	2536651885612	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79V6Yr1ciDKdBtqTdSCnGeZj97gN9MgRD7VrqJYfqRKdyN6bA
9731	payment	606	606	929	1	1	6	2098153235310	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCJnaxFq7DyS7q68s33rB9UnUFxmdg7oXto6D3xFzZzewo6hh
9732	payment	1397	1397	1678	1	1	5692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomjoiNPkyF43dzkjYaSo7WeFQR94s4ggQpmq6XX2MxXEPUnXJ
9638	payment	1397	1397	1678	1	1	5657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1kio3vBCzKooLFoBwnnw3E5qav4JKWcYxRZvnN22QcBgEXEh
9641	payment	1397	1397	1678	1	1	5658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeiGZPUebds891ssNirzR3jcfwAQZDzPxv3oZRd5XvALUET7W
9647	payment	1397	1397	1678	1	1	5661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaUdDxdSUcQkfFEhfrShvYu5emSjcnYupsQcGVQdVjRtLy8iH
9657	payment	1726	1726	1874	1	1	2619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdshfFW9MFf2FxZ2LimULBy8o5ex6YjXviiTWgutHmENxhFYX
9658	payment	1397	1397	1678	1	1	5665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoznHKjWLXn8n9staRDYg3h6pXgJiE4wFsv72fBTqMpmopUjoU
9674	payment	1397	1397	1678	1	1	5672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNj5NXd7e1uvvkWCjqF4hhbquqAcTpnZdsghpRQ91NDMtkPtA
9675	payment	1700	1700	1059	1	1	3	3426748222506	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYs15Nyz2NCsRM7p47PGoHyDVbZwujHcfRmTxCNXEG7TQwmuQPv
9676	payment	1726	1726	1874	1	1	2625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLKAa77g33kVJQ5JimQPvFMf4tPw9xLRzxekTT8m2PdhJvAMc
9677	payment	1397	1397	1678	1	1	5673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoS8JeyhC7h7swsWMNn8TEsvoCjr6Dtj96sayhqUPJDyrtaWyw
9678	payment	1726	1726	1874	1	1	2626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BntWs6XvC2vhBRsHyHc7GT439ZPvp2UNKr1V3u2ZsCcCmZbb
9688	payment	1397	1397	1678	1	1	5677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5EyPoU98s9kcFJUbERqL7VSo4DieDNveTJrmY6FrJqVCxSYy
9689	payment	1726	1726	1874	1	1	2629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBCpvrVEmi1sU6XTGoJg93HBC9PJwQEurd8dukst5VfJTWNbu
9698	payment	1726	1726	1874	1	1	2633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JFsSpcZ573duy1GGDb8TXHbX9p57cRokJfaKoq7gouxCHWTS
9699	payment	1397	1397	1678	1	1	5681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN58gxmtKNLQSGgiZHBCSTzSVvTrnmm6nSDdNhpE9m7atPCHUR
9704	payment	1726	1726	1874	1	1	2635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn74QHA2RdeFCyXQ5BKU96Fxy7fg65eGijrdpUPZDaGwLrAcph
9705	payment	1397	1397	1678	1	1	5684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTwzUD4AVuD2PuVEmztUsMuB8tMWH6igmhsvRCzDUbKM1gLcM
9711	payment	1726	1726	1874	1	1	2638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHFKQiX4kCVC5tDxyziScWKrjk3jExoKWwgTAMzgA3GSGrb1h
9712	payment	1749	1749	1722	1	1	6	1000000000	1000000	\N	E4ZNCkMxF6FcCyWfy81tLX1ayQ3XxU3dgHcpYeRN2KamBfVwt142k	CkpZkKGGYEf6BuhPKuz6UBjTm6gjDwnahxMbaQ1GaFKh18mpgwEDQ
9713	payment	1991	1991	83	1	1	0	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94W95T44nvLUNtiCehBMaXtebY4pReZxL9xWvyBpYzy73d44y
9714	payment	1991	1991	348	1	1	1	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVatpfuPVytPrGmdU845YDKjiVuMp6gyZXdy7fEXPgiFy6EqrY
9715	payment	1991	1991	380	1	1	2	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL6w6PnQJe9d3EjkwybaC16k9YvzZsxQjQXx1GiA8SNeXi3K5
9716	payment	1991	1991	530	1	1	3	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBazjZpH12wCNkoEPBXUtownuwgkc9cQbihKX4EDXgzfLPYK7
9717	payment	1991	1991	675	1	1	4	251089844466	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGaCufjsdH8V3HX7VRwLr2Nk9XaQfMxn1moeEQi7RkcBmeUSS
9718	payment	1991	1991	959	1	1	5	1911646833169	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgURQX4zSzYKdkmTvHK9qkd88shqHUdV9uBNG38mkWW9q6D2za
9719	payment	1991	1991	1079	1	1	6	3425654746054	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTteqh5zWCdSHcFARaXw24bhUmnTUVpBTeEQV1bzxfsAcL7wWi
9720	payment	1991	1991	1199	1	1	7	2311357518151	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFgU43t9aiUYGxRYV97SwRWJ59gHrHvYoxQY7TmaT8PPrrtiMc
9721	payment	1991	1991	1325	1	1	8	6440803238821	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DRMotC4sBgGAa4HnQAesXNNQmy2dDAgrm5MKGAp5Sy6PoYnS
9722	payment	1397	1397	1678	1	1	5688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxze8HkiGUuMW34ixhSASn2NTzGGnJZPmsgxRVGczy8G7ZcmqE
9723	payment	1726	1726	1874	1	1	2639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSaC1s3czD6t4df5CyQix1i1wDd4jJpdGBvQM5DCGbxV2SzE2R
9766	payment	1397	1397	1678	1	1	5703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqj8fnVwYpef5veiGi3EA7wUk3C3sMxWV8TFdqeBVLTDbYK9D
9767	payment	641	641	1090	1	1	0	5332248000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdAD8pSgATnX3CJ59yFqQXdEZbLXVeQ5hDWGJQaxWBLybyGVp
9768	payment	641	641	970	1	1	1	2975256000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncgSTk2RLupEP6HspQuprNCkj7613JgezbUtU9kLxhb8digKJ
9789	payment	1726	1726	1874	1	1	2659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfPAJ3whraSWHDv1RLkNzyFceLfjFqAkSuFR6BCxc3rBs7A7b
9790	payment	1397	1397	1678	1	1	5711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhYfmrc8g2L1NiFQPN8gjNtw9B3HUruMgQc3oWgvTe1Ygy8MP
9809	payment	1397	1397	1678	1	1	5719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QRHFs246Zt9aG8TmibdF7WZJ8xvD7o4mvxL7zpKzBcfTPtg4
9818	payment	1397	1397	1678	1	1	5724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Diqn5gDRYijhjYw1urCriCXFHZoCaSdv4v6Pvh6xuuW1QmoV
9823	payment	1397	1397	1678	1	1	5727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDwFnUF9PyCxYtwRGB2jS8ARZrnncmCS3XKxDgSTRhxCHW73r
9824	payment	1726	1726	1874	1	1	2673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2wQat9KcwukP8iN7MFpjt4tVo6QoRLHUmScs6VqVkaCVTn2u
9680	payment	1397	1397	1678	1	1	5674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFonqkScAfiBzbsyu1Z9PYbtog77Q5FVAnpiwwM8a3H3x3dte
9681	payment	606	606	1049	1	1	3	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYR17rRi4cyrMWfspFc9DZUVK1k7tnH21PWq4btY1XkQcdjwJ
9682	payment	1397	1397	1678	1	1	5675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv57HqxdpoezeDbJCayRdQw521ccd2f8QsMG6gszZttaesDSGG
9683	payment	1700	1700	1179	1	1	4	2312095308516	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpZBYTiY6gp2Kai4FqQVxfY2qmjp5d6UoQzLHJhSmo7ywBuTxsrY
9684	payment	1700	1700	1305	1	1	5	6442859157231	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYRCPzc6k4VgTyF86t4e6cvW45H4ztNtsqszLxcxCwWVBWxNMSd
9685	payment	1726	1726	1874	1	1	2627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhnEwSLpz3A9CGrfEsHUMoVS1PqEVcpG3EQTr6pPayrFRPc3uv
9686	payment	1726	1726	1874	1	1	2628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJNXkCFEHVWJjUwFi8b6vGwjmgKyp3BYbPmeGL4fjz3Btzref
9687	payment	1397	1397	1678	1	1	5676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgd4oCRchCcc24ooXcXkLcZQAXywr6iB7wgvTCKAJC8VaMQwiy
9692	payment	1397	1397	1678	1	1	5679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAa7jdzvckpJAvSYjbYy1FUuNn2thVRANLWzDUxgJyaZeBnXq
9693	payment	1397	1397	1678	1	1	5680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQuHDJY3vBmNn1vCt5FemDAWnc1uRMeNd5HBQch2FYe2Cqsof
9694	payment	606	606	1169	1	1	4	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yBgmNy7HntT99PbDqvbu8wghnLXYALxoR5pjbcpQKKUkSfJ7
9695	payment	1726	1726	1874	1	1	2631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJr1mPzPZq35WKztdD2SJD7ARTWyrw2we99xp8hxVfnswhZYJ2
9696	payment	1726	1726	1874	1	1	2632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaB4jmaCd5KRH1CgQzpBtq8NUrEfmrk9AiFoBRzrmt1tQwp5kW
9697	delegation	619	619	1652	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7P2ZZqYD8JcSzCP7ct8fbyU4846uR6YXotxSaj8jfMxXGHZAw
9743	payment	1726	1726	1874	1	1	2646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVvFnJLnrMwtPDPWmoojttzNa5r7zcVg5hxX82WDinoPPw98g
9744	payment	1397	1397	1678	1	1	5696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9smwHdF9jtfbaiaiqFkdBKYjaQ89zr8xKBUaKHETUH84C7oc
9745	payment	1726	1726	1874	1	1	2647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv98j5TGebjA4xLzv5QCQt6PXJA43ZkNHG7t5zwh533K5ELYEd
9746	payment	1397	1397	1678	1	1	5697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwG38JVW7eSBiM1Kz9r1N1jX2EodLBZmwTyvgcEevWyLVf7wVj
9747	payment	1749	1749	1722	1	1	7	1000000000	1000000	\N	E4ZMxexvZb2BNa7wmf9p8mWvQ3vtt16ApgGcfP96SLLJgcgvZBFMf	CkpYXaSp8Y1M38XzSRVwVbAaDe8BXhEC7YDG7JNktXuqNoG6cCtvP
9774	payment	1397	1397	1678	1	1	5705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtynkTJiNA1TWUPH3JFbedprZ1oeV8azWDnKY3j7TUFEa6twES
9775	payment	1726	1726	1874	1	1	2653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdp6TmQNx3c66SgtL8Ff4Z18x1RXRb9mfvnS8Smx7XxD1Y2aV
9776	payment	1933	1933	1764	1	1	1	2879000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRXL1YKG9ePMMNEpPXiVfYL6senMLRYooYRNqtvHWsiv429Td
9777	payment	1722	1722	1764	1	1	10	120000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHT1bbANhTTnCgn2yZj6vnN3GsUqzvKijjBMZVJRSNsksssFJx
9785	payment	1397	1397	1678	1	1	5709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1PkCKGYd97s9QEf8ngF6uafQskKhapdE4r4WJ352oN3v7co9m
9786	payment	1726	1726	1874	1	1	2657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqyTHkzwKspeCM9JQZmSPc2RX2dmo7cUNSZhHsZVuoRX7y8Ag
9787	payment	1726	1726	1874	1	1	2658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc8D6YD1VcWXNP7rbtABSqVVx9V3uc4prGXJ8UWXnuyJsDhAch
9788	payment	1397	1397	1678	1	1	5710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgqyCodbCxTjsArLit36U9FEQqK6hCwE5pziCL5xwFZJs58fU
9792	payment	1397	1397	1678	1	1	5712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYukrDTSyMzpzVQgXHrEaC1KPvMVHyCs3awkAFgA9XkL1ni84Eb
9793	payment	1726	1726	1874	1	1	2660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnszspAe6gSyZ3j4FB82q4G7SoeuwCRi9UWUNECJUSgL1P6qg
9794	payment	1397	1397	1678	1	1	5713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCu24cMPDSHgkyLdukZsSU86Z7tFQxkFQvVDu1bSLPg7hu7RB
9795	payment	1726	1726	1874	1	1	2661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswwkmZT3pbjFcJFbBePV2Mf1RyFSVPh4MKEVbx1FGrL65KKjY
9812	payment	1397	1397	1678	1	1	5721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMQ4dgnkhaZoVeiuDpRbADYLn9XqrwQQDs4aEh3aVoKxG1B96
9813	payment	1726	1726	1874	1	1	2668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzHnhZAuRSvG3jUMLs4WUjk6yaAQk3b4qL654PfKFnVmcFSqL
9814	payment	1397	1397	1678	1	1	5722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrxkgVFtJPrbM1hxS6tokoqMP5m9knhLARuEpaXiMKDEZNBss
9815	payment	1726	1726	1874	1	1	2669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCy1Quf2fVDWKgSsomPijeSYx5ffNxn5W8syizAs67JLJY8t6f
9819	payment	1726	1726	1874	1	1	2671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Defp1q9XZ33v4zhBzGRxXbuSChgvsuSYNiHJMCNjiW8Zznm
9820	payment	1726	1726	1874	1	1	2672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZQDwjqhHo1JteMSaQqVZDuXsZevDjANF5ru1CpeGf9DPURD6
9821	payment	1397	1397	1678	1	1	5725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymmQKTdP3NnJHbkos6JUbeJTePBDmLDNMVFoecPnAenvEQNSN
9701	payment	44	44	1991	1	1	2	16541007000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZfEWGyEnEyto68T9b2dMgsHnwxzkQe8HSEYn8BYbBHU8Kfjn
9724	payment	1397	1397	1678	1	1	5689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmP74verrWNeWD2bYn2tAebWfRdYvf9JPRavKoumLJHF358ZTy
9725	payment	1726	1726	1874	1	1	2640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWdtoYEGbKhLC2nCiiuTxpYu5iLKwiBgjqijfZ3kvE86BTRJr
9733	payment	1397	1397	1678	1	1	5693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAYdzVLDjKRURpX1ZDrDaNA23ADXJuZ1tqhvcNFuvJQCmrXVu
9734	payment	1726	1726	1874	1	1	2643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczX1SWn1jbyuxUPvyG2VztcE7NLnnYYASgZwuuYRhCJ4A3XDp
9735	delegation	1991	1991	1406	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBocMXL5bndGJVxXVb8XtFJmei3zvLP2UQ4D33amJe7Rsztkb
9736	delegation	1991	1991	1406	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqJnNx1JCkcpLgzqei4cKA4JDreiyaZf4TBo9wMX3XQZK1KRF
9737	delegation	1991	1991	44	1	1	11	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpbwfSuhff9C1G8WxbQYGohipXBBkoXrG3kd4MbcnhETzi4mn
9748	payment	1397	1397	1678	1	1	5698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZp4Lr95a2zGfrs4AQm6R19fvyc6RTD9kMwvDJquaYu3hro6wK
9749	payment	1726	1726	1874	1	1	2648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvbDiuVZiLdnAmSyF4gXRegHckfi6byJqLG4fudXEP9aawmbh
9754	payment	1397	1397	1678	1	1	5700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BJPGK8J5NE3pLpZZMr2Yz4Cb3HFa75ame2GsMQUABvsZYEGQ
9755	payment	1397	1397	1678	1	1	5701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFPi1PqCAQWp3qYTbpK3u6WqysYJJDUxS9GJ6AdNGMSeiidV2
9756	payment	1397	1397	1678	1	1	5702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTLFKAHN9ZSgwAr8EMQBsrULfBFS7sJ6jAaZJZajStnMYjHug
9757	payment	1726	1726	1874	1	1	2650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLStkoyWGpc9BDtStaV5HgHwwShuwJHZ6LqbHmqRnQGg36PfF
9758	payment	1726	1726	1874	1	1	2651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPMWuwSXKQCbgaxTFqM2sSKN2GzMN4nNdNoYTN2wXFZzugdPr
9759	payment	1759	1759	1069	1	1	3	5076500000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpYuhYpH7RjfY3L49iuhCt36oYj53Etjk9qgycpcFg7BLmfcNxLz
9760	payment	1759	1759	1189	1	1	4	3425000000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpZRJSyvi9m6F6ykg6tkNwTSWU8TwHo6dfm8cktyJZdXEjStFhCd
9761	payment	1759	1759	949	1	1	5	2834000000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpZAgrdD5yDio3eFRHf6KjutvX1TCYboFU3CqsekeJWBmDWfwvnX
9762	payment	1680	1680	907	1	1	1	3191320140680	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaBmr82CgEdqGQVum866CHBrpTbS1jqeymPcppsoXsiAZgoa59n
9763	payment	1680	1680	1027	1	1	2	5718818348880	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	Ckpa1fpXNZ2LEbuHzn2UpxPhE5b9DbhWrgnwppEkpvQg1w8hQYSN3
9764	payment	1680	1680	1147	1	1	3	3858600695495	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaG69SjGWQeVp1dVKvrRVTZGXPPw99iq9VVv98g7hJ76hniqxes
9765	payment	1680	1680	1273	1	1	4	10752333925620	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaHC7QcPXXQaLadvPNCxEjrt1EQ5MzpDA77SWSFtqcSkDjKKzUf
9778	payment	1397	1397	1678	1	1	5706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNLukN6YDMwfEMczbqaHKnjQG6G9Ek8TBN19v8CkbR9ZppAYd
9779	payment	1726	1726	1874	1	1	2654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzM9UusmghS4w1VWv8sh1FqvH1JcQ6Uiru1kg8NAe5SDwAhc55
9780	payment	1764	1764	1334	1	1	4	8557000000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpaJ4Fgsj9GsT9RYhKTEiQ1sjAn1JYjvAeKaCAaAHnD4qT5UoE6B
9791	payment	1716	1716	950	1	1	0	2826600000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiU231TGwYeZRAcUrG3nfPfH3N2s6cFS2BDnqpWedBQD5PNbfJ
9796	payment	1397	1397	1678	1	1	5714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3GQhUS2UbiYvRTgGKcRQLbKuEaP8qMN58vpWRVxPXy2VRQTvr
9797	payment	1726	1726	1874	1	1	2662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6MfkrHdyF3CX6SRxgEAAXQfpQZL6sL49nUZ4Jwx2NDas1x7P
9798	payment	1716	1716	1070	1	1	1	5065240000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPADUSoHrKaPbKXeJyyixpCeLbxuDM3CFhLqJoFGgDxe1iRf1w
9799	payment	1716	1716	1190	1	1	2	3417620000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuuYnUMyPgH3pd2ybxuN35EVaPgjJxneNnYxnAx2kVQYmDLmb
9800	payment	1716	1716	1316	1	1	3	9523500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoawVR2kF7Ap2RXhbVHpNhxRQGQWr48wTksadB87jpmtukiu8k
9803	payment	1726	1726	1874	1	1	2664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLoz4SnPPKjABDw7wVVgujfK99HUMkwA8ijSu2ft1MBXPL2auE
9804	payment	1726	1726	1874	1	1	2665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYQqSDm9QUeRJ3XthMGH4Puu8BuXubR1A1Qd7dvGmTnWZtUER
9805	payment	1726	1726	1874	1	1	2666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTK1vyiF28P2ndGpaBh8KsBWM819Q6NqeMpYvnaECTKt4utQ9
9806	payment	1397	1397	1678	1	1	5716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGyyeARr6ps2Kg46g3fvHhTauBKVKYdSVtEGcaoYBjg4asd7E
9807	payment	1397	1397	1678	1	1	5717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWfSH7cv58cE9aGH8DeejqYMybp1KPVuXj17TApXZxph4akDn
9808	payment	1397	1397	1678	1	1	5718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARjun3y6Uti49Qfiqcuwc6ycEroJRLhMt1Jd9xZyfksfYjiXC
9858	delegation	1750	1750	1745	1	1	16	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwPEMxczNdWMtkAvuZCRtwWJV4CUpRgMWKewijB6jRYwuRyax
9738	payment	1397	1397	1678	1	1	5694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaVxaJENZwHUhWWF9ZbZAV5UMk6iEhaLBwJgZ2UYPQtw7JoYa
9739	payment	606	606	929	1	1	7	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjFJYQGor1tuXGXmEETQJxSY4aBUFr9QSuAedKqrrPrc4U2oV
9740	payment	1397	1397	1678	1	1	5695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2M8FdRjN3r3noMjPL5nadA4FrKzoznmCYwoc7Su4ffeHtJM6t
9741	payment	1726	1726	1874	1	1	2644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJntrxDNJWRCsv24iHKoUE1qdnos6wWGaDgAhX9wBcyTDNdGEo
9742	payment	1726	1726	1874	1	1	2645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4SDhBxjkdtk4wez4nuWTbRgFWL5BRzKAPix7vTjc6KbVyqoR
9750	payment	1397	1397	1678	1	1	5699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9piKCUanTN1srjUg9SiT1m4ZxGoiv4tFjUjWp4L5vrAzXnNS
9751	payment	1726	1726	1874	1	1	2649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCnQpeu2YGHMAH13doCaXbDUXSTshoKFxcTCs5ABhGa1R9ro7
9752	payment	1759	1759	1315	1	1	2	9545000000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuMig1uaFJeXTRzUvSEgzqY	CkpYonqBrVsRz8VP6CF5qGzagnwEqkaHU3zCZvQZaDTGFMQm4NU1S
9753	payment	1680	1680	1993	1	1	0	419411389290	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	Ckpa7JXFYMKYPNnV4u1UXSLgrS7u3g7XVYL54Bz33QYjFuFfkbqUs
9769	payment	641	641	1336	1	1	2	10023912000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UXbbPRZrEcBdGzqUxZpmZaBnwyqJE6fj6UsnkChrUDHKXS59
9770	payment	1726	1726	1874	1	1	2652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhD2cg5QU9w21Xyt7DP2hPdCDtQgqnKRYGraxKsnamtq5a2uJk
9771	payment	1397	1397	1678	1	1	5704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdErPfyFMRUmMwrt1zz3iNjAzetjoaJ4LUVfX5uYraLkhUwX4
9772	payment	641	641	1210	1	1	3	3597984000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLgSvsAQHqAZE4YJZfee5YfbaKGH4GaKBFScRLrD5ngJKyKgq
9773	payment	1680	1680	1993	1	1	5	1250000000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYSWLecwtDesVAH8NZRZ5kHavrYMT1gYQeyXS1jFtLvm2ioavBP
9781	payment	1726	1726	1874	1	1	2655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Fgcifx3k4SsrdsXkV7d2YvU6V6DXMp2oYsnE8UjZ3y8gwCtq
9782	payment	1726	1726	1874	1	1	2656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrMQmX26mKFbeRMVftvo3XjvE4W9bg2DrUGnndFaU2z6NJyWY
9783	payment	1397	1397	1678	1	1	5707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfjxRscknVmxQ8mwB9QdweAUU2UQQVa2zvCVCtCzfa3JgJPeA
9784	payment	1397	1397	1678	1	1	5708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmqVKyRKUMayg2Pr2CcfisfXh26x5pqvaGAeaL6zgY3YUxXWq
9801	payment	1726	1726	1874	1	1	2663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFuqnmBptL6WDvowWHxFLu2rdAWYmoGoTWC9XXS9pZH9qqLJC
9802	payment	1397	1397	1678	1	1	5715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cYXGxwm4cjfBH7SV19gxHBMLa5pJCSEH1B3MQUf7gzgEbZj3
9810	payment	1397	1397	1678	1	1	5720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQQRrdQJrkpv5pwKcVhex5sB8M1HE7MGBGsQjdTLhgDuaXBqJ
9811	payment	1726	1726	1874	1	1	2667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5hGva41Tjk2csgZD9xDeAc7AMzBePF1zXqwC8WQWCCt6FTeW
9816	payment	1397	1397	1678	1	1	5723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27243K6xJKvBEZLFewULXdihQxKWbvtwerZdsogFK9NrLwhbK
9817	payment	1726	1726	1874	1	1	2670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rcce2cJ3QVtX6LibkwfCo7FSmcnhZh7pR965Tj7pa9mYBekx
9828	payment	1726	1726	1874	1	1	2675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvvmsyYhQTLPyJJMHp2gvDUvZBNPdqC1jNyAACRoqhp7pE4Q1B
9829	payment	1397	1397	1678	1	1	5729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYBvH39urjRMGKcvhR7wHJnHWDC6TjqKBDx8nSudooTWH5UYN
9830	payment	1397	1397	1678	1	1	5730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8M7ExLo5PwmsLzsd6ypMGf1ASBpLYJJ4THo88b52YW5QUhyT
9831	payment	58	58	149	1	1	0	341	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6Y8KpxorA2iC2mHptn6H28Nub5SrDrCTWbhnAN57d2sG5ynF
9832	payment	1703	1703	1651	1	1	1	10486000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmRcNTS9Fqm5eg3Pi28SBQfXde7qVM1JZ3ivHJ8PwE34hZHz4Q
9833	payment	1726	1726	1994	1	1	2676	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoPYGdBgAYHvjZJy6QuoHMWwxjfhMGN7BoVa9VN8zMh6rVbMq2
9834	payment	1726	1726	1995	1	1	2677	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYRCMhHmMDUDAWPL8PGKezhLLWvqfGERwecjUmG93o5g1EFV8Uw
9835	payment	1726	1726	1994	1	1	2678	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZLifUQxtp2RXFyimrpw15DApsC1ZjUQ6TX9UamJb3mjKmvrL16
9836	payment	1726	1726	1996	1	1	2679	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYjJMnnofhryduXNzK5MXF3jkTFMvZ3pZ8iUge6QiaYdRE4X3rR
9837	payment	1726	1726	1997	1	1	2680	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpztnDnV6jr3UVyzmCUoFK25jr36jgkmVZhGBGqipR123GrN8s
9838	payment	1726	1726	1874	1	1	2681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8VCsQ78NVadYXXvAW7pucU4GDA1dfD33JDSnq9czusZhky1f
9839	payment	1726	1726	1874	1	1	2682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23vvVK3hoBG8EVLjudeJsBZcuJZ5PFYbXWXRY1xtqyMrkbcJ9
9840	payment	1397	1397	1678	1	1	5731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hX3of9NNA5187685DnVHb25L6fRFYhWb14ZmQ4Af6ovp57wr
9873	payment	1397	1397	1678	1	1	5739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dYb25wJfYvCvns8vPNsQBcEdqWbQC1GeyRCngRuHxSGRDQEy
9822	payment	1397	1397	1678	1	1	5726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudJ2SyMJK6J5T6YP2DKBq84QrPm2ZrCRGRm86LaAfjgAZibTz
9841	payment	1726	1726	1874	1	1	2683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAaxGSy8HyumgWP1MMzKMhhY7zK5iBwDtkUWt2DL4x6q622HK
9842	payment	1423	1423	199	1	1	0	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZbh7TgCd7oCm3hWbKvA4RyDn2W7UKguUVAVofAGb6BtTYZ7VT2
9843	payment	1423	1423	214	1	1	1	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYR5NBdexZRbsyh2G3Pu1vW3v8KA3dS33MJwvEgw6BsuPpMtqS7
9844	payment	1397	1397	1678	1	1	5732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhWrDGRTDrP4hsT2RHanLusGyvPs3vMN5xpqgFPsjyXAbMjCs
9845	payment	1397	1397	1678	1	1	5733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpTnUBxCMVKo9ZfpqSkZGehAx1v1fCGXWetsaNfY6kH3qPwx9
9846	payment	1423	1423	234	1	1	2	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZoBrvhRPrxk5nLv6JMcpabxoVgofQ5VobXwbSxoF43AF5J2tEt
9847	payment	1423	1423	282	1	1	3	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYUmiWX4AFUvKFXnQN2B6kuNqSpV3tJ1PFiGtsXfs7svvZvjWht
9848	payment	1423	1423	314	1	1	4	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZukM4cmG3ABGWmjjJUVqFXZPVzRNz2m3uHMXYH4W2efWe2Xv34
9849	payment	1423	1423	323	1	1	5	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYVWFc3k3KgZa96hxeETdKcjgkVRMdw4NMqkFfsb3t9prwPBxws
9850	payment	1423	1423	330	1	1	6	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZLzqPGauwjRFQq64YAGA7arst6uD4nbtgM9RHsiz4kxwCd6boQ
9851	payment	1423	1423	332	1	1	7	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZEGERW318JH5H1uwgahy3bgNnM951bVLQDf9xSgTSKTjcJzgMx
9852	payment	1423	1423	334	1	1	8	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYR51krcBu8amPbb7K9qN44Brfyf5uTbp2bYYmdeM5ok4cCkbfU
9853	payment	1423	1423	343	1	1	9	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYVPTyZ54XBUzdp1yXLbtmuU2t7Q8b7dQqvRwxh7Su1d8iS4R6v
9854	payment	1423	1423	559	1	1	10	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa6iECTBQwWge2K6EmuqpqBcP8HkKy7dLAkHNh6C9oVfcxtUyg3
9855	payment	1726	1726	1874	1	1	2684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjvJMFCSUg3ZUKwPG45EiJCn3wmFGH4nBPMjnjBPpcz5Uikmz
9856	payment	1397	1397	1678	1	1	5734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKwR4s64EA4pw2eRtS8JgBEr8UE5pZD7oXsTLKSjWCf5rvNao
9857	payment	1423	1423	561	1	1	11	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpaFessQTF9uUD2xdL1yjJcb4yCwWRhPAkJZVXKVGjBkaAoK8opF
9896	payment	1423	1423	561	1	1	13	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYpwcAfUdkTYNV6QyvFGcqaneG9oMMMZQssHDUwDZAcdhQh7TSh
9897	payment	1397	1397	1678	1	1	5745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxD8biLQmLX4dQdvPAhYHUrX5uvoN3nYLcPCycpBcMW1cLfWLu
9898	payment	1726	1726	1874	1	1	2696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yrZmAb1faLiDMXgocNgsQfscKcR3efdVQGKMa56hL4PwGEPz
9899	payment	1726	1726	2000	1	1	2697	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzo3gzvrLftkqrn3Q61FanJ4wuBpG7SGrEGmoJFjJaFh99abuJ
9911	payment	1726	1726	1874	1	1	2701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1P1XmxNryVzo9vi6VCV2v4wsD5QgZB3VNAjfpoevr4apR9Ly
9912	payment	1397	1397	1678	1	1	5749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXNd2agRNc3UHCc3bkF1ahapjbVxeFw75Bp4vznLpTD9qitRU
9920	payment	1397	1397	1678	1	1	5752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUkwv4HQQqj28FqTCAbjW9LAmHqj1KbkmYLJKjZ6GFdFP7CHN
9921	payment	1397	1397	1678	1	1	5753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYbTM5nYbQSqH3EtDXFyJhpyGcLvkWkDK2YdJCrJUke2Ui6Mi
9922	payment	1397	1397	1678	1	1	5754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEhgeHgsCrWWfs96NAbB7ihFuiCoMeiPJ1FNuzHXqTnnm6V78
9923	payment	1684	1684	22	1	1	1	113350095941	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZh2QMB6f4Nn7dcJQ1zgz6MQm2uxXPY2JjRJr4RHvjmDSiWx7Eh
9924	payment	1684	1684	190	1	1	2	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYVRfXgy3J3bATFdaNxGiZQ5UfoNH1bgA5jkRGnMaQNTSQky5UC
9925	payment	1684	1684	258	1	1	3	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZeBeSwpAZiG6VYEfB85SQnxrKnp9cWdspSUHDW6y5qQCTprear
9926	payment	1684	1684	273	1	1	4	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYsDBs47f84fqTu5JwQkP62HvvjAfZAY1kSYVPZDkRrfD57NSc3
9927	payment	1684	1684	292	1	1	5	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZxVtiVZMs6TnHGdLQveyDZZu9nbHNupqnFJ8XBBZtCxNd77kBK
9928	payment	1684	1684	293	1	1	6	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYdjTaEtn4HVeT2gkZdhubgEezx1GpcFgFUswykBNb1gyCYZfnM
9929	payment	1684	1684	333	1	1	7	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYQP6UTujmNAscavYjvUN3Zi6UgFC8WLKPkNKTrX2ViGMLStPkT
9930	payment	1684	1684	376	1	1	8	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZLB1N6yuY7JxAFAswWvpNtmWMAxwfWTGYSi6m4psc8Uk2154ui
9931	payment	1684	1684	426	1	1	9	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZbb6N6YtPyJkNBuAQWt7pecnQuqFCp7do1Z27GptXgH8D5s5Ch
9932	payment	1684	1684	429	1	1	10	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZY2dybpXLx927f5tYvv97xguvqn5MaoDrNPgyZTCM4PbiijycT
9933	payment	1684	1684	430	1	1	11	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYmEGVVaEBhtFn3Zsj56UfLs4KoKjGtgsNuLCzexnD4MgFykv6r
9825	payment	1702	1702	1651	1	1	2	9354000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBAyWfgRWd7khHYugLMppAsFjX1HuwbP5M87YEyvWm5pAk8RU
9826	payment	1726	1726	1874	1	1	2674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7P7hDvQprMdALnfkr4tNiRhNmvK3fTqXQMH6KqckFcYV8tzW
9827	payment	1397	1397	1678	1	1	5728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixyZQ7AiS2LbzgAxuVwHFtySnxtpFWZu8tyhTuTGARupJAT86
9900	payment	1726	1726	1874	1	1	2698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUa73z4Ua3jV4XryU7hhsVa3VPtDDThmy4tds9Nxs8yZojR22w
9901	payment	1397	1397	1678	1	1	5746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1taRQzQRfv6qrBUJbLQ3z1N3Ged7g6iwoQ6RpXkuBomNbyws
9902	payment	1607	1607	271	1	1	4	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ehby41KwKpxtcec77CU8db3xdyGo7JU5gNRD8gmCxQEsAtYh
9903	payment	1607	1607	269	1	1	5	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZaVgx3CVQMAv4vDi5tWKwaDoSobn4MvRra9jeARpZKSjCDZq
9904	payment	1607	1607	577	1	1	6	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoF42PrdC8TwDz58W6VDvhYsgrWuAqqmFzfUmVY2osWRHf1y4
9907	payment	1726	1726	1874	1	1	2700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsx3oJ7MkNrNz4tqForhmuVEwCGTMvTKnWX3rbdNDsGFtfECL4
9908	payment	1423	1423	683	1	1	14	1000000	10000000	\N	E4ZRr9KPUGGD1N17iaFeRLiHx8LBLo4BM3X6TDNyBcHRfT3vN3exv	CkpZxAb1c3Awpyqpv4y3fUdj1RyD3scuunb8fKGsEbQBTyp7pAL1i
9909	payment	1397	1397	1678	1	1	5748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xkCpfXGB1FeoaKKoQmUJz5mYBKWcktFRA3SgvY2ap4hajJeG
9910	payment	1764	1764	968	1	1	7	2541000000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpYhUWgAkh1Lk7DaDZntnEEZUVuTeuhkwUpv3DSKu3kaX1vQhtZy
9992	payment	298	298	1768	1	1	3	3038000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSAhB8THwDkgyQY745yAARVhF3SbvrarDQwkXd1Ugkrnez5vU
9993	payment	1695	1695	1330	1	1	1	6430000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGn9cDkkZttn5w8XDfnHuTHAYkAUUs2B39M7UfT5cpN1b3ApV
9994	payment	558	558	1958	1	1	1	5000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTMB5zwzQpjsUvbxThqKn7wG8qqh2BdmCxV55k9bGuFQNRVcb
9995	payment	1726	1726	1874	1	1	2712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBZfJEqVuSqbK1NTtMVRiLXdSaeLZvjXRjD18HUmx8gkN24PF
9996	payment	1397	1397	1678	1	1	5759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKMVTW8vd4PjokoC9EJbVUUrCM61MiBVqxpyNToBSkhk7CUGK
9997	payment	1397	1397	1678	1	1	5760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeW3xwkZsSPTbgQjnadhFSqkNMTbact1XuwjfDF5PJEWQQNeJ
9998	payment	1684	1684	681	1	1	55	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuXhFGoZgzMvVwbrFJWTdcoVF3kux7ys8i8fvPkyHajPxFphQN
9999	payment	1684	1684	720	1	1	56	10154089039	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	Ckpa132mtqDxLYNpmh2ZHJ25MJysjN6EBKXA7L39VHWoKX6eF79gE
10000	payment	1684	1684	722	1	1	57	10154089039	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYpQkoK17gGd1yS1uKo7q25nUJjKTNRK8rVC4wZu53vaNBk9Muz
10001	payment	1684	1684	760	1	1	58	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaExsVSmMwvuTMqYitFv4uuHT9qviNFGbYjghWxfHKNs1p8UQiL
10002	payment	1684	1684	763	1	1	59	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ3RAjpV6raE9ueMWk3FXt75ogTbbqxRucgzTPBdYPYCLopZGd9
10003	payment	1684	1684	767	1	1	60	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZdshcYjgrg48LL36odj7L2vtRVzceV17e6zckNjCW2XjBkZyMP
10004	payment	1684	1684	769	1	1	61	5077044519	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZh32WiPGb6yCoC33EprKe2hr9dvNKaoFjWtJDC3zXkVVYQekTQ
10005	payment	1684	1684	958	1	1	62	2608000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuKe9hBbMBZDrTzSMkAAU24hQQSmBnP7HyoVercY6ZZCVdsA5d
10006	payment	1684	1684	1078	1	1	63	4673000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZLzxSTnbUEHEH27Q88Vtr2V6k5abN4nVFBeLp8xp8kzj7KT9sQ
10007	payment	1684	1684	1198	1	1	64	3153000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ3amMZ2T2RzfBr3dorVbMy3q8SXriJ3sk8ad9VmiRz89oF91z7
10008	payment	1684	1684	1324	1	1	65	8786000000000	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZUwXPZSoaErtAmFfy8Zx1EYr7aff5a66vGBtJuM4KGaEfFVZi2
10009	payment	1729	1729	967	1	1	0	1914800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DopZYYbGN8n7H6FnBhJ1yiZCdQdXw9EbjbnNXYXsYuGaaHpZ
10010	payment	1729	1729	1087	1	1	1	3431300000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgpYNBtZLNEkFqScUrE9g4ggqHMfnVG9PhVzRDGwqcpgaNJQT
10011	payment	1729	1729	1207	1	1	2	2315170000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXg1jDq6ediL5RxT8ykZQjw5HkTyzAt8g2zz2VThfP4f2xJha
10012	payment	1729	1729	1333	1	1	3	6451500000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4N47EKcYwFkJabCnQJJB4Z9VprcinZE6K1rFLT6v1SPZF1pqN
10031	payment	1397	1397	1678	1	1	5768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYri4LGvy2RvvWobPDQPt5c9RfjPjRe5rQTd1VfwrMP5axFxHdj
10040	payment	1397	1397	1678	1	1	5772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8vAAZWhVtZwpUcEEtS1bfw2p9G1ikWBCtb85ZBmu3aGSZGMP
10041	payment	1439	1439	913	1	1	2	1523412000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAyBj5YsJKnAWAoSEhrXHh3WNQsv9XpGY6zRyZwBsJANNvCPN
10042	payment	1727	1727	1148	1	1	6	99000000	10000000	\N	E4YxX7z3dDu2y4TiY42ENEv7UNHR9iq3ez6bW2qAqgghCENgFwzPN	CkpZmHaYcah447f8tKfnog84yM8GbWixoS2A18yJdiobyeVaTzbMP
10076	delegation	2003	2003	1651	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSfYTybnXiGnan64bS9c2qEgQHQAerBG5g9ke4Qov9SoMGF4r
9859	payment	1423	1423	683	1	1	11	146584999999	100000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa9gzDqRJ5nY88akTrQ8wyS56ApXXatKkLGEhFJvAbJRqwBysRG
9860	payment	1397	1397	1678	1	1	5735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTC2yRckYnWPH1HfyJhRXwuk9urRv5M5aiZLQtaTsm3tmryeCv
9861	payment	1397	1397	1678	1	1	5736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgFpiERCCinih8b7nkkvFz899UH988vWB69uPGS45L2aLQzJwG
9862	payment	1726	1726	1874	1	1	2685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfufTshWFGJz2pALbG3GEoxf4tHpN4sJ75Qo3Bj1dFic8oJ2R
9863	payment	1726	1726	1998	1	1	2686	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXGupZQFrovFunkPGmRh23UF1Bd8Axeehm3V9eNUfri65eLsbn
9864	payment	58	58	149	1	1	1	341150000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4CgC3iCZ7684ucqAc3VBmLQmaZUKcsCyHWLkun7tYmt1PuDw
9865	payment	1726	1726	1874	1	1	2687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoAdRQZK9DxKSrcMcJjbuvN7fNNH9TXurc88hmy63TeVWCQPe
9866	payment	1726	1726	1999	1	1	2688	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZSqMm7FrKujTpvf11xKZwUX47JwPk4daLYmSeU1VxJRoLCCuB
9867	payment	1726	1726	1874	1	1	2689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkH5SxcEpFhTkhVR3R69ejPcWcmiN8eijQdsjXHqvg8aSxpAM
9868	payment	1726	1726	1874	1	1	2690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXJuLHPfijDFt7tRjWA95UwyVxWYFeT5xRZkLDbtVYW7xaekV
9869	payment	1397	1397	1678	1	1	5737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRur9WNzsGNy6MQs5B1BDqH65scoePXpfowGyN89wri9Kfgtg
9870	payment	1397	1397	1678	1	1	5738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNY7LhpFAUHCdtWgAc8peaRuQTakDoBgkPRkKvMBrbfd8b7wK
9871	payment	1764	1764	1088	1	1	5	4551500000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpZLcNCUuLtJS8mxbxNG8utrY3YuDLhxeTGRQyYaBAbf4Nvc5ChR
9872	payment	1764	1764	1208	1	1	6	3070500000000	1000000	\N	E4Z2YYdCrs2QxFmKoNicmv8RaS6m3Yo8PAReyPTMWkQ722HpXUpQa	CkpZaF4XSpZgexzcFZtLRWynmT2wKcC6RjjBsqLobvGYATQ7gKxhQ
9913	payment	1726	1726	1874	1	1	2702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwt4uCwBHcCtTyLCCkm37MvizwvKdGDDM8gj41xoVif3p5EVGV
9914	payment	1397	1397	1678	1	1	5750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACruKwGAX1cXbJd8n2MFa7nVcvYnzdhw82wijMk42GFrdP45b
9915	payment	1749	1749	1327	1	1	8	7570000000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpYZpZ38UaMfWrLvsN4mWPXrRSCF7TKQqsNaMqe4WxYbSjoogZw9
9916	payment	1749	1749	1081	1	1	9	4026000000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpZMh7chEdgwE5Tj9xtjDNevWq7rLwo9X3NWSCparpmPscrQ9RPa
9917	payment	1749	1749	1201	1	1	10	2716000000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpZUr8EcLqZsnu9VMACNF5WJ9RwYY8hydoPgApaw7V1PDSMgDHCx
10032	payment	1439	1439	913	1	1	1	1523	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBS1HBZuwsc17J5xPLWPXEKv4hopok1XvZVNDAJNUucxQ7bist
10033	payment	1397	1397	1678	1	1	5769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4bFsC4AFCsipEGomQN6zQpepr2GRBdgmfoa1eUmQHQg53p8B
10034	payment	1397	1397	1678	1	1	5770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNo9YaL9zDgLy62iK4k5uABnQK2jSA3cqo8YNpNAcYSQQ8Vrw
10035	payment	1651	1651	1055	1	1	3	4737193484311	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZdAscNDj7quUTZ2FtByAmzJyYmdEPCA9pXdk8ZxU1Xf7C2asdc
10036	payment	1651	1651	1175	1	1	4	3196278839126	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpYegLBijecri5jEbCmwuNheJxzb5AvwieHERsUDtQJW7qb9TXNp
10037	payment	1651	1651	935	1	1	5	2643535789138	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZ9U4B5gWdFB11qyUeqg9BZqB2tyZeK56KZBcsqqxcm69WfG2Sz
10043	payment	1397	1397	1678	1	1	5773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZQPPHo5Qrbg4mzqoW1W4CHppZUkKYERRLQorDx6vmPgLLSn1
10044	payment	1397	1397	1678	1	1	5774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYun2yvdrcpKqQUfMWndRM4JZMnPR7o9HSgy45nhGFv5cpwZhAA
10045	payment	1726	1726	1874	1	1	2713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZteV3U9xPA8fZWvNHbiFi9PnxwMpr26tHxEXz8KbMsPsBykr9h
10046	payment	1596	1596	1363	1	1	6	7373028977584	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7GGusWSbASdRbW2G9C138swF5QPw3mGLcWNHGhBF1TcZV2JB
10047	payment	1596	1596	1117	1	1	7	3921475439233	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7kgmdc9iSv5eeDmZdpMnwAAJbhJntF1Rt98te5XDev8FEkU9
10048	payment	1596	1596	1237	1	1	8	2645897619768	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTtV8MNUQAsr2go2ghUuaXCVfiKJ3RKWCEJy3bGs4p9rTWCvn
10049	payment	1596	1596	997	1	1	9	2188333810757	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjPL16yzj4cGJ4amC7cTB33CRnQnPprbpQTEtb8AAZ62mTaCr
10061	payment	1397	1397	1678	1	1	5777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQQMdWpgNGsXqUDqzKXGcA4WwukeJKgwcPwuLA6wzCiF42Gbm
10062	payment	1703	1703	2003	1	1	2	1033000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArHTLR4fLtTCtURjug3UbE5RP5eD42adiHW5HDV3ZbFeXxofp
10063	payment	1726	1726	1874	1	1	2716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDpENahxEuUqJR3vH5xC2sgZeMUhNKyxNNJmHRTiRFvY8Bbu3
10064	payment	1726	1726	2004	1	1	2717	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1YbJmupYqzxNZKWhf9RVPui4zUQT4uNHoF3vwmHA7tPmNUUSA
10065	payment	1726	1726	2005	1	1	2718	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYUzP2G6WNJKv9kq9fxRuLJCz7QvdBbmGPM8VPwwtZ4CDFwb21i
10095	payment	1607	1607	242	1	1	4	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqbhVd9xyx8NvRwok3UEFsg59o2CtLsoP9zdo1BVGpcV12cqa
9874	payment	1726	1726	1874	1	1	2691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pbcTMX4jgv7eVUd2yAWcU45iDhxMBeqMCr9PZediSpddswLk
9875	payment	58	58	1281	1	1	2	8755860000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdGqFYjshLKZwLchEdoiP56zhNk2LqFAo8QiCbwA7iJ3xf6Jo
9876	payment	58	58	1035	1	1	3	4656960000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseRg69uoGcAFFVSqCc2nSv72oNTokmyMzBJ3VZd2AeLxxx7Ee
9877	payment	58	58	1155	1	1	4	3142150000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGbU4M4mViQAkWKwZwJFMPskojek9PWGUNLWFbxQ3EUA1sq3S
9878	payment	58	58	915	1	1	5	2598770000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4u75zHoTS1tgzGSWmh8tcsCsdMjyTqgZaJgPMyLHBjqVC3wr
9879	payment	1722	1722	1764	1	1	11	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzycYLuqaJqZGC1tRT5fS5yz7cQrLQf6Bd2SABaukmxvqzKhU
9880	payment	1607	1607	1348	1	1	0	10132684275022	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEznKX8jt1R9ZFp4NkRc5qMQ8KkHZ8re5orA3iqZjWjLohm62y
9881	payment	1423	1423	104	1	1	12	263082769232	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZV87wAUtjPcfCtsbrm5eMgfxS4xQGyYLgUR9B1zPmdz6R53WvE
9882	payment	1397	1397	1678	1	1	5740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AgTJf18wVzQvRXWcaaS7ufY1sAnPF6hxQwQ6T3yNYZwfyLSH
9883	payment	1397	1397	1678	1	1	5741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Epcd1DDnfzC6qMyLZRQtgwZqx5eVMp7K43kP4JXdXe77i5m3
9884	payment	1397	1397	1678	1	1	5742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEbayC1M4XUCdsMhcRMMfbm1uYvUdnXAmLBj7T3GhvjH6rHEa
9885	payment	1397	1397	1678	1	1	5743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPNNwFTa2D8kKYUN6tSmHF9YDSJ4ZBT8qQmBN225dM82hgtp7
9886	payment	1726	1726	1874	1	1	2692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XLmYjbBfaS6tPnkAxWts22z1HzyZvBfeWwmNqwgkRTzaVHvr
9887	payment	1726	1726	1874	1	1	2693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZum3zbM3fkyAxFep1vW9NEK8241eQyTuCVeLBNFp9ExhGW8vaB
9888	payment	1726	1726	1874	1	1	2694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyYwBEFLsfK62M2u6PUedXmYrcxExfADXPz1jkX7MCYBW5C3CG
9889	payment	1607	1607	1102	1	1	1	5389246758531	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSDmr2hHcAdDHe1H5JxbzL9b8kZ5EiPkNT5u4vKfYagE7j7NM
9890	payment	1607	1607	1222	1	1	2	3636232176308	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmg4H9Q7vK3XCiBaHV8HdM5FwX4S8UDZtYDgpy5Xouj4MhEyV
9891	payment	1607	1607	982	1	1	3	3007406543521	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4QbTG6RHUU5rAdPcnRgFhvZDfHLuitcu96WVZfBnKQaDqq7t
9892	payment	1722	1722	1749	1	1	12	1320000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTx1UTkDWKUW9Qc5uUyHcnHjV1wZcevp5HYxGvQZD1HZckYvi
9893	payment	1397	1397	1678	1	1	5744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbh3ak47yT8cBUfn3dfUijmydH6A3Tx9sgfXbsGz3FkiicVkCJ
9894	payment	1726	1726	1874	1	1	2695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQE5keH9mbUyRjCcvKeVvLmUcwg1Log7xMcodUZGEYYeR9QQg
9895	payment	1759	1759	1749	1	1	6	719000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9mVnQyw6M5JHaqXGZtdAtMy3hHrgGJ2eZnwC5Yb1v5PSF4a1
9905	payment	1397	1397	1678	1	1	5747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uxhRPJxW9Cshkf2m9kfiBcotjq4UBJ9Dkcv4cEs77wqTWofQ
9906	payment	1726	1726	1874	1	1	2699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTM2ciA5TybQiarU51g5xQh836nvmSZE3VvbX9Zbu6FUcxtVh
9918	payment	1726	1726	1874	1	1	2703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbC12do3skgCgnc7sonZFyyKmFG4f9RtPrqZ6Dg8N2GXZeX5RE
9919	payment	1397	1397	1678	1	1	5751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC22vWR1yqrFD7nUvrWw2jb5FZ5nhEpYdMoCk3pHq8ss3HEAU
9946	payment	1726	1726	1874	1	1	2708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhAryFa3WgZviQDGePspQNiYwWR5dpn7nXvoLx26X86xuxRgP
9947	payment	1684	1684	511	1	1	20	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZphktpu6Eo1LASRaSc75QPgLYvs7LPCQCe8LQFR8Wh9HV3rkmj
9948	payment	1684	1684	512	1	1	21	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ6eBq9JWVRdVWDYu9hmkiRbum4fABAY7xPtwmy73oXy4RcmCYk
9949	payment	1684	1684	522	1	1	22	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZU19DTS5pKHMZhfNWm376CNf1bN2PW7FmMKYgw61PjqT1re9kq
9950	payment	1684	1684	523	1	1	23	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZUL4nBpvGnYvv9bu48fnxfvgTBS22sj1JY7tV7rSrRk36xhqxP
9951	payment	1684	1684	533	1	1	24	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYkPq6FTaK7oH1udXwUjEFSLHk1KBj6DBwAb4cZTFPQ8H9DcNVY
9952	payment	1684	1684	539	1	1	25	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZGVQiUUgDUvw2aeZ9CaqEHjd7bfTAUYj8MppREwYVekmsuPNNv
9953	payment	1684	1684	541	1	1	26	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ6C34k6ePbJKdFpZ62JcDVP6JrEjuyvLe6qVfx57QKjavpgyef
9954	payment	1684	1684	558	1	1	27	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYWGEGcMDPGnGP9Kp9FpsXTe6H98tb68qegvbZpXPgcQFe3ufJW
9955	payment	1684	1684	565	1	1	28	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYyMyWduhfBdUqGfRqme4MRF3EcEHgG2xGWT8na3Nij9sJHDR9u
9956	payment	1684	1684	572	1	1	29	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYTbpYLTqgd3rPbsQ5zioZ38dUkjyFBoyn2UVefVFKk6qKVxmJv
9957	payment	1684	1684	573	1	1	30	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYhJVqNE1vk9oNCATADAZUP4oRqCcNA9vaocFth8u7aC73Ttnh3
9934	payment	1684	1684	440	1	1	12	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZMfQEEFkKU7rhe2VoEuvuAhSq8bGBMFJ64jRkoCsmxzaopQvb2
9935	payment	1684	1684	474	1	1	13	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZmPLYW7kAbz1kpHqGZZwZiMoMbFarL3bnKJjwb142wfDxBZtDg
9936	payment	1684	1684	475	1	1	14	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuNGU9CqTNHtZQ65RWLTUFntV1KcbQaNaVM7vMyLpQpb3wMuGk
9937	payment	1684	1684	476	1	1	15	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZEPntPnQAdtdgNrRVs9pgm52y5tst8Wq5WnHkGw3KyVGniepGD
9938	payment	1684	1684	483	1	1	16	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZHm6dWfA7XCsmh3Qf96Zb3Ljfb6BAhBycBRk7DEfy9PXLL871k
9939	payment	1684	1684	486	1	1	17	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYvZNNAtKsht18VbdaxjbN4bYhfnyz78XVjTsZ9KUnhbPymCCc8
9940	payment	1684	1684	490	1	1	18	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYz4GnsgGVfcw3mx8jNVASpmiNeaKi8pHmxy1Lavapi29hmwciY
9941	payment	1684	1684	496	1	1	19	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYwWbH9FmYZ5kko16rfih4WXuRNTg7emWwqQggdUQSFB8X3tVVA
9942	payment	1726	1726	1874	1	1	2704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGK6iuV84cWaADr9STafSt8fyYDrPg8qZTrLutWqZdsBgH131
9943	payment	1726	1726	1874	1	1	2705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMazgQ27X8J5MpvJGs44HphEW32xhVwadDqxBsFUa8k2h8kNB4
9944	payment	1726	1726	2001	1	1	2706	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa48QxbCCNmdUk5oTi4W7wcsQd6aSjbUXh3k5Rt17DZBmHDiVfK
9945	payment	1726	1726	1874	1	1	2707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUi8KFSswYowiPjtQrivdV9JiQLUEzfEeuMuY6q3WJhaeEooJX
9968	payment	558	558	2002	1	1	0	5000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCScGS14NSC8efXw2UaRHKDJsgeCVTKZ26u4qgbNrxPWKicUAk
9969	payment	1397	1397	1678	1	1	5757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmu1qepJ5dQxugeumsm9i4f1NA2eZ3AZ9pURXPYRHHJyK6WtQ
9970	payment	1684	1684	609	1	1	37	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYd9PyALntYrpNmsSjL2mKRXagSuGgFWo558oDV4RnN9caMRU5i
9971	payment	1684	1684	612	1	1	38	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ3cTHFmKjQrGRZzPw7djaeWhbZKinCPgEhgWVnPwz1H8WEpTFt
9972	payment	1726	1726	1874	1	1	2710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqYLGUqviiMUzZz3goLK5j1yVQAviUQ49iR5F6hcnUBAoUW5X
9973	payment	1684	1684	615	1	1	39	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaFHK7hXXvmkiBofnZjnr2PnRAkywCujJZ3WzvBJaHVhN6rLgwZ
9974	payment	1684	1684	616	1	1	40	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYjFzaymUSaHxG4uTTpMhhAZVgBcrbPSwb4crycPctvHo1i5n84
9975	payment	1684	1684	617	1	1	41	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZ8UEsD3UasmEMhbwJR8fadCDmSUzVxP7sdCLe5a5hv8JVwepZZ
9976	payment	1684	1684	624	1	1	42	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	Ckpa27Y5wpRnfuVqoKtxRDwGZ4dBtuAAKPN2E3z1XDbbeCkcwVNvX
9977	payment	1684	1684	625	1	1	43	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYxUqoiKHLcazaV5j5EwHmUxKS8EMhPNtb2Wchi6tzBZk1sd3Fo
9978	payment	1684	1684	626	1	1	44	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZPfK34bcrs4uaKKw6M84WZKw4z1itBoxVko3Reaf7Z7bdUbLzv
9979	payment	1684	1684	627	1	1	45	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZynbgMRLU6CSEoehMGA8XAuRfRV2Da2wRZyzbZEWhm35XiiCAC
9980	payment	311	311	1762	1	1	0	8639000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdhpLrJiRwgubAJoycWGwbZyivJCumcvynueDM3cFs4cu5nRw
9981	payment	1684	1684	629	1	1	46	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYrfbdkF9aKzxsQSVMLBnPuR9sjPbt77VtQmPrFsxPvG2s1ehmJ
9982	payment	1726	1726	1874	1	1	2711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnPLY4fjzh3aWb56peNNjQRxmQ2uoRx7gMSZ4kpZquuKGA3QL
9983	payment	1397	1397	1678	1	1	5758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKKosddbyAtarph5qzeRqwvZAgRC9z7N49Fmf9Kp4QxXFG2ta
9984	payment	1684	1684	637	1	1	47	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaFzg5AwytXnPxa3j6mxz6VU9cfmBYt12UqWm2xS77a6MK2ED9n
9985	payment	1684	1684	647	1	1	48	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZQCydcke5oLPdSWUPNJajJhEYxwk8uk3Sjtpk5Gb22ji6HPdCN
9986	payment	1684	1684	656	1	1	49	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZLQ932JGLuQ5o2P6Huv6WWgDBPiDzN4SGL3SmXKcrMTQoi6kfS
9987	payment	1684	1684	664	1	1	50	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZzGWiWbufTMXWKirEFSnFNJKwwSExN7Gt5L8TYPKYuJuToUPAa
9988	payment	1684	1684	666	1	1	51	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZkTodGn9DRn5Qsg8Wd9Z3k8gSbzRZj9WGW5ZESeZa1pvBH4yyd
9989	payment	1684	1684	670	1	1	52	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZo7fFNMvP1U1fsW4V21CRfjraXwdSxYUANucKbC9k2gb85iD6k
9990	payment	1684	1684	673	1	1	53	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYqEvaFdR2ibkGuyhzpv1rJjv3jhWxAZv9dWatqQfgCc65tLmLr
9991	payment	1684	1684	674	1	1	54	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZFA9SUUVamW9RkakTTvbYKSEbNUwzf7FpR926Hjdedauuyh5oR
10013	payment	1695	1695	1204	1	1	2	2308000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Wb4MDE6KwbSSL39mCoMnna1Rigy5zHbWe5RG6NeMwbxn2dx4
10014	payment	1695	1695	1084	1	1	3	3420000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfhcTmTb7J8SmU4bjFGw2U8NBqLtC1FZqb32wwAxPs5bYZ76G
9958	payment	1684	1684	576	1	1	31	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZuU32q14g4kZcJ9NJ4hb3ZrVHpPwCSVsCjRshCEst5jQaAJSin
9959	payment	1684	1684	584	1	1	32	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZK91XBftQr7wQ6DBu3teK7avGEFT8FQ5gnjfJqJHpUv4VLfsGU
9960	payment	1397	1397	1678	1	1	5755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjqFvRtXHUVrLtuM2ueYVLC2r88QexRwGWa6qEeJV8wUUBnQg
9961	payment	1397	1397	1678	1	1	5756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF6FMdwZMEaym47TaYU5TwHksFAS2kH9iWruDqTq9SaM5VDvi
9962	payment	1726	1726	1874	1	1	2709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCf2RgTQeTxcYRcdTjfRc9vit9YTda8jEBcx5r17pHsHGhf85j
9963	payment	1684	1684	585	1	1	33	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpaHMRRy96bo626vwESePyqAVNiXBpVH2XkEpbwSb4R8EgAff4sn
9964	payment	1684	1684	589	1	1	34	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpYwq5D5aas2bPbjXDU7APV2ZYfG7rdNTrYbLV8gYRJawiSvMxia
9965	payment	1684	1684	595	1	1	35	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZgUw11v5VtXPFnSECjqAFfkj6DjPG2gm2M5okZX2q1CYCNwocv
9966	payment	1684	1684	597	1	1	36	335084938283	10000000	\N	E4Z6Zs55gNtFCa9vhGKqg5Tzkmb1YBstAeo4Bm88295ZaMaUiAsAK	CkpZa53eran1uwwALmnMTmk5UEF32M4kptY7WgbFtWH2odGp26pau
9967	delegation	1750	1750	1745	1	1	17	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQAW2WNVCaM9rjN2859iWQxe8xKdk4bFNJGT3D3t6gfXdjXgo
10030	payment	1397	1397	1678	1	1	5767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgCMM7B8f5Zedvrztk5nFi27qq74VvQ5NxAfbvtuhH3ZeriQ2
10038	payment	1397	1397	1678	1	1	5771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoN31rF837cfugifosc979oHuKCxa2mmgUmrP4gxpB7csZ75pF
10039	payment	1727	1727	1316	1	1	5	100000000	10000000	\N	E4YxX7z3dDu2y4TiY42ENEv7UNHR9iq3ez6bW2qAqgghCENgFwzPN	CkpZKFjBmLNn2eGiffmMAsmaFQ11L66fRTFALiptrbPdLdQLqEX7R
10050	payment	1726	1726	1874	1	1	2714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ASXiULmjaQcKY8aSWG9uQ61BNU42kuukpQ5rzjJQ28utZ7RZ
10051	payment	1397	1397	1678	1	1	5775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FKx9BigEFjDZCTuGSuz44Q7Ak4EcTzX1YN3rypYwHWpg8Qjq
10052	payment	1726	1726	1874	1	1	2715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4dwp563xK6gjRxCgDFoNq4g7ULLQd7fHHP5BHXUewHbCGMAY
10053	payment	1397	1397	1678	1	1	5776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZst4PCBdAytc1FgYQEQZybkpGzJoxyBbnTk4fkwyhWPsX4tuWy
10054	payment	1439	1439	1153	1	1	3	1841946000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwN6UNWFf8QnkAGkCk76QNWGC1fW4AnX6bTNSvxGadAd6FMoo
10055	payment	1439	1439	1033	1	1	4	2729941000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFK6rUZUbChLyvAPWypyEv8xyiKwA2TXnExr7akMMfrzVwPPp
10056	payment	1439	1439	1279	1	1	5	5132745000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa212jzSjRPivgV9BmtDfEUogF3QPi4W5Bt366eAnqd4jnseUPD
10057	payment	1719	1719	986	1	1	0	2097160000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBfgRdD2xRrc1BJvfzX6vqpQCa7maEXpMHYdVDr978KnU1aA2
10058	payment	1719	1719	1106	1	1	1	3758090000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoT5mSNYrHA24DNYTbQdpWZ3u67crFQfKFh63hLPHuw9QJ9rV
10059	payment	1719	1719	1226	1	1	2	2535660000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5v2dbQRtTx53EJ1v1hZb2FSRVESU2xHq27Rw3e6E34HwTrKpH
10060	payment	1719	1719	1352	1	1	3	7065820000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocAauHgWRzGeEa6fCB9ZVmyEt9mJctrprrM2ebAG62NSbV3Qw
10079	payment	1397	1397	1678	1	1	5780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6e9EkywhheWTWJiYdo831yeNUN5vRc9mkKzgYojrN4hqPX47
10080	payment	1726	1726	1874	1	1	2722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGXR5Xt1PKuCFtFSAXoaeBvh3h3X5895k85NtaeHaLQJuC2EzR
10081	payment	1726	1726	2005	1	1	2723	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYdvLCXXBGx6YCnyqAMXPnQMtqBeK9zXXavJEbHTxsd1CNAPQSF
10082	payment	1768	1768	1308	1	1	2	7297200000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpYSD9Gxb3PQZdmh9Lf8aYj5rJFfM7UvzsbGqYRprifTmqg8J2QP
10083	payment	1768	1768	1062	1	1	3	3881700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZyQjwRr7bhveYAFZWmdhRaN4w25LGejprvbsaUoYmKWmGW8Taz
10084	payment	1768	1768	1182	1	1	4	2618700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpaBfcPjwrQ26cNr9W519qaJgF2USP3xEpUU6Wth5xgt3nVf8hRb
10085	payment	1768	1768	942	1	1	5	2166600000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZAts3w3hnn4ywFkQrKGbmPe8Bbp9Ky899Lmg863pkQtVHnKTRQ
10086	payment	1397	1397	1678	1	1	5781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUsfVAN8uGC9khH8QPQahFbdNK93SZhSQcxrKb8S5BLohkvfK
10087	payment	1397	1397	1678	1	1	5782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabeABcnkwqsb9YcdcdnGCcLNqvP2C8hqridjmyi9VpJfPpzQ1
10088	payment	1397	1397	1678	1	1	5783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRJQjHAW8ZLvq6a75fbWYyNmy4dCJBU6ANSemgL7usvsXiSaf
10089	payment	1726	1726	1874	1	1	2724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRrpQNxhAtgQM2CbsQH3eNUubMTmFBBfezceDiNjLYWNdD79P
10090	payment	1726	1726	1874	1	1	2725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSSPD9LzdLvfjNkP7xzK93zKPkvAmQYM4YvCaSfqAAri3SL2Hz
10091	payment	1726	1726	1874	1	1	2726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqwg2d5AyqX3LqFQvLZtp8RfGmKEwoDkogjcz5kYB7rZhfw5g
10092	payment	1397	1397	1678	1	1	5784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvuyqPzoBvjnXL8wcZVbC6DAnv8NC83fv2JswQxEVszRvegZe
10015	payment	1695	1695	964	1	1	4	1909000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL79gkurXd99NC76Euhq67zMWAS1m6ECyLn52eEGnwYfC8KDhw
10016	payment	1397	1397	1678	1	1	5761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGq8oyGu2Df2wPr94zbcZ3QhShmupFKbvVXr6LJzVPzYAqxpdm
10017	payment	558	558	1958	1	1	2	295000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqR3Ttu3HPFLefFYATGHQheXktxeegAgbvv1PE5AuUJzdFAtw
10018	payment	1397	1397	1678	1	1	5762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHZ6vD6KfiGp1eQVXbBZdoz6J3QDzPSWJBfgQ1FYY2XrR5PVa
10019	payment	1651	1651	2003	1	1	0	5268367953	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpYh24cnyAvhMBNT6cRxAnhDKsfstg7iVNVkgEHvEBSmSPN1gQiS
10020	payment	298	298	1768	1	1	4	2000000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mEQGbWEiYPvRPnYCjQzKLbhSJw6TNHDsaaLhpzEQKRovVYHi
10021	payment	1397	1397	1678	1	1	5763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxmtKAc2vF2F8ok6ikTZngHLDZpWTgBn8QHmS6kyqXUTSzDgX
10022	payment	1397	1397	1678	1	1	5764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86PvMpKyjkKu3atXF87fgrBHn8JwrVGvqkQHhNQkoAmgejUQC
10023	payment	1607	1607	242	1	1	7	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xMf7z8udveQvX9jmGC9WLVwjE9HR3arBpdPRshBptSeTNNMi
10024	payment	1651	1651	2003	1	1	1	347712286868	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZB1WXcsZppjtEAzPSxJKUzWYKMJaq2bgJKrVphimpnJnEUkhjw
10025	payment	1439	1439	482	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBUR4qbx3KKGAe9nG7As3XcViZGFJuECcbFP6kN6fnaq98DTL
10026	payment	1651	1651	1301	1	1	2	8906715182489	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRh6CR72ohvG7g8kDbm1znFMJGNKPqj7kj2Rw2uKnoDayGK5h
10027	payment	1607	1607	372	1	1	8	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygtU7aQ2hJdwDL7Jy8dTEYKbztqQJUnHSWoJR44Z9zavnk99v
10028	payment	1397	1397	1678	1	1	5765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JxihfmNHoGKtqsKoQqjVyjP4RhU8hFxYfqDK5VjbRs18iUEy
10029	payment	1397	1397	1678	1	1	5766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXHcsj2VWCZD3zHm1bVU66tNNrS7rhZULZaA3AcE1SnBpNCaq
10066	payment	1768	1768	298	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpQtYRMFoTd1Jhgr6yX7HHwDrEXjXSoMQqfy7JjipvdPB3m4F
10067	payment	1768	1768	298	1	1	1	1000000000	100000000	\N	E4YRiPpkpbcWzDofM8ofr8x9F3PYuKqG2PXcscd4dommdiYMYu3AP	CkpZAEtEZUQyFaj9xUfQHxCUnPEHYHDt4ax3L6tgjn5ub8oudmot6
10068	payment	149	149	1283	1	1	0	5628270000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuv4pfVwP8ithddgB8MfkLTD3eGME83uvYJpfvKiQwjQHf6dx
10069	payment	1726	1726	2006	1	1	2719	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZT5Yh7A1aZkJmqJRcuoe58qfK7tqNE9zZNiScyvhU6vv33WxB6
10070	payment	1726	1726	1874	1	1	2720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtfPX6Vngk3jHaP2rFfnLJJEChf3cbdVYhu65XdMUX3DmaidF
10071	payment	149	149	1037	1	1	1	2993490000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcVg6V5bkdadCgrGmtF5kzXQsg4ZgaseGSgjsWAHJtM3YXqsqs
10072	payment	149	149	1157	1	1	2	2019770000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZBH86jg38Y8D6t8cvNEWABTLP9dgQFwbMMhb3BR23ddS8sod
10073	payment	149	149	917	1	1	3	1670490000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCqkUXAcf18XXDvP5XtC5EbksQ7gTCXMD2ZGcUoPXcWUJE9o5
10074	payment	1397	1397	1678	1	1	5778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sxfwoX2e1u2f7Rc2TxF96MeShhuc46bvcrMB69Q4NPZDRm9U
10075	payment	1719	1719	2007	1	1	4	1102625000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZap2Qg7tKijdiaa7W3pQYzwC4uZy3wkerDp7y7BQw6XBKF4T96
10118	payment	1726	1726	1874	1	1	2736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsognqLBtDDei5S2XqAfH2PW1eC7kf6pRdD5m3789QausSMDuQ
10119	payment	1397	1397	1678	1	1	5791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5sMDiQFSRCwPJizCJzafk4LhZvDDUb48PdAGCiqxLiyDtUoJ
10120	payment	1754	1754	1779	1	1	3	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1Bmz3HC4LqPc3KKiLR2p5q5VbjyJWXTb4yv5hVys1ohZMSMa
10121	payment	1397	1397	1678	1	1	5792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MF3P5ufJJWWYELdNs4xEtwAEdzXe5JdZW2g2ASDYKE4isexo
10122	payment	1397	1397	1678	1	1	5793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxJKwcGXgowC7aBtSni9sVYC78xDqPwABMvArYe2QkYWTVRPA
10123	payment	1397	1397	1678	1	1	5794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpBRMi2FK68LoY4h8PTFqcVRRbCw3XGcm7raymC39CzfJdkcY
10124	payment	1726	1726	1874	1	1	2737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGpowTAwZGDYQVECrTn2BiCfBbNVT23sVHkJpwg5trz6D5KYf
10125	payment	1726	1726	1874	1	1	2738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu532VhffzFL1hykWB9xoG7de32KMHxixbeWYcTJManJGMY6RC
10126	payment	1726	1726	1874	1	1	2739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7HTtRL9jnhbKrwDuLDAHAxiTs4h9mr5iZXVpkkJ7KUDY44m6n
10133	payment	1397	1397	1678	1	1	5798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1reESp2MGwfDg45kGyMBL1dawQKvyUsAUQ1cn4z9FSLWiF8EN
10134	payment	1726	1726	1874	1	1	2743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFreReDhqWWqHokK5PkgF4mHnw2ZE51ANnPjBd9aUBwCbCzfM
10143	payment	171	171	1008	1	1	0	1955138409273	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpYQBvzEnbrdPpFBCf8G34ScLKRoGeJigQgGhXyfZu5yoFMYEWRw
10144	payment	1726	1726	1874	1	1	2748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHTFUHzsDPEAVcKLJ6tnMkF9VPVSGqhw2XY7Vr2XzpMSjR3aG
10077	payment	1397	1397	1678	1	1	5779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQEBgNurA3MfwDLTQXUNJjJXGXwX3JoxgCEYsjWpV4XAqGFFX
10078	payment	1726	1726	1874	1	1	2721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcML85zkRT4751aYafVKZDGBBMpUWSBnrFShACXCL5Fxo1rp97
10104	payment	1726	1726	1874	1	1	2731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4o5foGw7ucF8Pv8yLyGc1rCsenFwExCtgqd9bjSRkvnyUnTZ
10105	payment	2008	2008	1713	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGN3T8XUcCqqFeizEjFFnPLgGdPMCX5UhRkjUaSAppY21FWjB
10106	payment	1419	1419	814	1	1	2	19820076647323	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk16bzfa5ayPZTjFp4hapza4Hh2u3ok32YhYWGvHG5s6sRdYmo
10107	payment	1397	1397	1678	1	1	5788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBy8gEjJX4a5dHyca16SavHJpGtzFmVcNWoSFNxGmc6wVB7NmT
10114	payment	1762	1762	1181	1	1	1	3254070000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZe3BpLZ8TDLJ4MgRSXdKJgXdJ3UZE7Hxz4pLQRe64yUrdQmEjk
10115	payment	1762	1762	1061	1	1	2	4822850000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZkMgx5oZJwBiVDnDoix6d3qDNnp4cpRcyn4vAt4V7dmBNmGa1x
10116	payment	1762	1762	1307	1	1	3	9067760000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZLzep1Pdn55zmekc4R43w388jxk19RGaBteEw2B5GRLz57Mowk
10117	payment	1726	1726	1874	1	1	2735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg1gQaYaR8mXyNkeAFRwyvwaBZkt6PcKCW58tYnNEkXrhToP7
10127	payment	1397	1397	1678	1	1	5795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaLVc8F58JP5GaDJLVp8eXVQf4zNJm3Ff37RgGRbLD71DbkGmd
10128	payment	1726	1726	1874	1	1	2740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc6HxhSzcAjKVSHSshCXpg3Zu8CRTJv11aU3TTzZyyiVJP6er
10135	payment	1726	1726	1874	1	1	2744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47TqJpfvzgXNbaHF689syBDFfa9fM8aQHqeArPm6AtpztaWzv
10136	payment	1397	1397	1678	1	1	5799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDr3dKcW21r8WQ9nqCJn6GTvMTuf9gvL3Cd8Re1uC94VY6rhUW
10137	payment	1397	1397	1678	1	1	5800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikrfHH7juKqNKvX8WX9tQD4yDjr8XopqmShvz5pboEaiU7vQ7
10138	payment	1726	1726	1874	1	1	2745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHUakKVeY2VDRLmkuxyJnrc8xaNW6LUpgqAGNM33RWSD5d5C5E
10181	payment	1726	1726	1874	1	1	2755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvduHRDVGFtt8FT2LhgkRmvKWrDK1sLF9mvt2gD2waqHPccDn
10182	payment	1726	1726	1874	1	1	2756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVh9FGkcV6KdwNLnwssc7vQB4VTYUqvkz6mLx3rdxcSAP7dBj
10183	payment	1397	1397	1678	1	1	5810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5zRgnoYasL2J5UysZ3GBV71x6wqKnJHNEpKtCwT4YGpSh6yi2
10184	payment	1397	1397	1678	1	1	5811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBZj4MEu4zKnZvJh8cMKCsGZVebNL9Dpjf14spp4EFAJuApwD
10187	payment	1726	1726	1874	1	1	2758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZDQH22cf3M8KKZ7CZX6t5Ntq2PpuoseHvswG1fJAbe4NnBd2
10188	payment	1726	1726	1874	1	1	2759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVjWyfFDvVvnhDEpnBKXU3pNsyrwFxsaLbaKVVEDuwKN4zhTz
10189	payment	1726	1726	2010	1	1	2760	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZb9LMUiNBrjLCRVxNzfpvGtToP8AY8sLB2Rv2hyFvLhnVAvRkV
10190	payment	1397	1397	1678	1	1	5813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mwozgZihxjhqATvUXfKAU1Rgu2SHzUfkyxCcrQFY2cJj34aR
10191	payment	1397	1397	1678	1	1	5814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sVpXZ4TgtxrMvqotUb1yraaKeQqi2PGxhwx33jU12Pdn8qH6
10205	payment	1397	1397	1678	1	1	5821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3dJa9PorokiQpHEk3m8GQHX82T6LfqSUuzJmXM46LXZ4LJRe
10206	payment	1726	1726	1874	1	1	2767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDc4fxypzfZNr4HUdmqBb2LgRr3AxhVC4XnJmcfiQsRpXebEcX
10207	payment	1397	1397	1678	1	1	5822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUDkReQFBFKnwMdcbmYuPjzfFH8emazc2BHoHZ6MDwn9QHesf
10208	payment	1726	1726	1874	1	1	2768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGN23P9Lcgu84JYBjfNpuRJNS9vZfwhifhMXQ8QNziajkaFji
10213	payment	1397	1397	1678	1	1	5825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNZXio7TF6uozoJaQ5WcBayPST4ny28NdCi9Ev45q17xHWziZ
10214	payment	1726	1726	1874	1	1	2771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgimEzqMTGVatxrZgYkNYU6GiUAxVhAHdff5rFjtsearjviy9
10220	payment	1726	1726	1874	1	1	2775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMsApRfw7iVfrkoWc6VvFHmt1k7V8VREq5cN2KteS2CuNDZzq
10221	payment	1726	1726	1874	1	1	2776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9mcw9mwgiCYHv86WEJ7kRUU6ta4Xad3Kf3roexfhF926Guu6
10222	payment	1726	1726	1874	1	1	2777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvwYrmaboHPAsQv9pECCVo2xPn8SvpPVusNThEGN9P7Qio249
10223	payment	1397	1397	1678	1	1	5828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDmycSbFXsnT3319zsH8xuU2hAzcFWa9UFSkBBz4sKBWeuriN
10224	payment	1397	1397	1678	1	1	5829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9TZVvQyTKgP4HUm9uZ8frJcn8jVgLryvtrUoFxLpi33tcxC1A
10225	payment	1397	1397	1678	1	1	5830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqgjQVARXqnGtMrx6ftrey7Xh1Kxj3LxocyfbAu22AnXFL46R
10243	payment	1397	1397	1678	1	1	5839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcz15BfgorLv2vtoeHj8PNsp9mKrx2vMi9JzTszqwxbbMHjAhs
10093	payment	1726	1726	1874	1	1	2727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkR1WWcZz64AvxgxS239bJVTETx8dk3XfFjY8nHZudNtakrJeu
10094	payment	1419	1419	139	1	1	0	237840350373	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHwDJvGD3YPFguJvXo7vbVmwarHE1MTNhMtoYHwirQSm7XSif
10103	payment	1397	1397	1678	1	1	5787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBDxHP5RAkXs3MQwkpcp3EfV2RFAxC1K73uCoCFSrmXibBoYC
10129	payment	1726	1726	1874	1	1	2741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeH3zXGYVkXPeK6anjYChWGucCnHFoSvYbxTkeEaJTZD6Nxo1G
10130	payment	1397	1397	1678	1	1	5796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvCYtLEb3Rrhdhi5QmUUA2YF4npnAUbz6QbKA16j5VQ5FnupJ
10131	payment	1397	1397	1678	1	1	5797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeJdCibnur85ubFyzwtWoNvk9SE3hMPXmBjYSNjmVu6E1Cti3
10132	payment	1726	1726	1874	1	1	2742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56efQu7uvrxyN8zrvD2n4gYTjAQBd8itxogXqL1H5o47zzbji
10139	payment	1726	1726	1874	1	1	2746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVF9ak7juQxp9jZnEeqCNXB8bXC61ijJatNkxMNJ6czd1nJ2E
10140	payment	1397	1397	1678	1	1	5801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxnbaeWXFeEjzEQNp53XWDX5VM2hobxf6bgCP9PVajhQh5WUF
10155	payment	1397	1397	1678	1	1	5804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5jahE2mxtaHNc8tW7ySnD1YhmfhMHYRbC4LNLqsrm979kwbi
10156	payment	1726	1726	1874	1	1	2749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ubTVw882K2RafJwXzfFaXjZYaRfPJGHYw7UxXU2zYr96jNdg
10179	payment	1397	1397	1678	1	1	5809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNbeqJXn4L8fp8wnyoWUW1SyVKkFwkj4wPKvGnPUHRESG1ZUT
10180	payment	1726	1726	1874	1	1	2754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKujvHPrDSrMB5i6KhdG4RsJfoCjP3EcnhFrnJmFNpnGNaQwM
10185	payment	1397	1397	1678	1	1	5812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyYKuFgGZqSyD6pCpgxXaEYt3JVtp561QGoMXCQWqsaqjAhPy
10186	payment	1726	1726	1874	1	1	2757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu7EKo5KFwBksR4TE6LxDW4yrFbxKkYHDmve683baYPM5gzUt
10192	delegation	1871	1871	412	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtnRbwusLbLUc6UtFfoSdNsD4ZBLeB2AVvFumrXmKndcmBRGX
10193	payment	1726	1726	1874	1	1	2761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHQ3avXdsk1G9b8o1KoYzKrtKwGyTRy8SqVw7PtfGfUnWVZfB
10194	payment	1726	1726	1874	1	1	2762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFydj2uQPfWT4dTRvCyirFRCEKfBavWfkioWnRkM2wy8ufEH5
10195	payment	1397	1397	1678	1	1	5815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb1xs1XVgfhbyFzfM7MAqfh8nA5Y8KRYDANg8B5c3UxTbF68q
10196	payment	1726	1726	1874	1	1	2763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Edupa7At3ywmwCxsxhYzMfTxGpt9Z2tZzk1BnvJUFNKdox1t
10197	payment	1397	1397	1678	1	1	5816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgNHYFCB6Hu1JyMzyFipm6pcwrrXjv5f3MQ9AKPCoYrb3Aquz
10198	payment	1397	1397	1678	1	1	5817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAE7uHgJaGt2p2Wq4tJqtLTiha9WvPWu3MZhokqd4mLRwVpqrG
10211	payment	1726	1726	1874	1	1	2770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCy5AActR77xB1U2FLKmJSjJuGuvsTgJcDHYnKsMbCK2xFka8U
10212	payment	1397	1397	1678	1	1	5824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzsobK6Z2fHxq68XDRkL138A5Ge1sbkC8jgY86ywJX4FKrmwT
10242	payment	1726	1726	1874	1	1	2786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn6z4ixR8iyrtVCp6x9qQigWCqrtWTP4cToUeLHZCTCkvD9qv
10303	payment	1726	1726	2013	1	1	2813	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYeyYvgcAzqB7JrEJ2ydU9J8XKucuowy8jZmA92aot29BRQMEoo
10304	payment	1397	1397	1678	1	1	5864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aGem9yeduDrWCCxLtPnV13C9PK3GHuU2peotXMx7tenfcWyi
10305	payment	1397	1397	1678	1	1	5865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRGF1UFZk5B2BSsfEMRw4TZKSjiQ3g9vXWJ4vKBetUVc1M9hp8
10306	payment	1726	1726	1874	1	1	2814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKgSnHse7MJEjMYi5uqLWVdyu7TYfQHM78AWe8aq1CZD2pr1c
10307	payment	1726	1726	1874	1	1	2815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfJBEg5oz2BTD9BedDmVuE5CZN1tLroVvrMRS1iG4u8a8EhEb
10324	payment	1397	1397	1678	1	1	5872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEUkWmBjpaj23avDV6hJLAn2QKQwSir6z7vkmdAXSwyfd4wNm
10325	payment	1726	1726	1874	1	1	2822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvdSKmzMFGRatG8sQVTEBDgVNtHHgFJj314j5BXSYW19E2iLe
10326	payment	1726	1726	1874	1	1	2823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbzRYdbhCfAe4rPygbUbRM7hWk1DqkGuQudqwKJgcs6UVrMiJ
10327	payment	1397	1397	1678	1	1	5873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWxdCa9MT62tNLcTBVCJYVo1qaTN39mnAAnc61ZhH8VVdaA6D
10367	payment	1397	1397	1678	1	1	5887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3bJLMDiKbbvcyAf2VApMKC1DmDMUJE6ZPYv9svSjyasRaCZE
10096	payment	1607	1607	372	1	1	5	411417920446	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgN1RUkc2FxdGpRoSS2sKDUmtt9zHBw45Yj7FowpaGQQu3XUF
10097	payment	1397	1397	1678	1	1	5785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4iU1o7mr4SXQaYwAuBGqyR3xnV57U9zVwdMEZ2PzF88Yk7Px
10098	payment	1726	1726	1874	1	1	2728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYna7tNUDReT2ih6njcN5X3bUSpWt5Wx7FuXPUd2Nvzp4spGKe3
10099	payment	1419	1419	813	1	1	1	1801826722240	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRV5sX3DSmTtwpug74ojEthVZqJZMFumTtGUD8UFuZ5ygJgAa6
10100	payment	1726	1726	1874	1	1	2729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnXqLpKRt5ZxnpzGF93grqCPkiRMR1WdXVy9arK7tBCg9LAE8
10101	payment	1397	1397	1678	1	1	5786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfcmCam4JsQ61Ssv8U4uRmGXwQBjsifT4gt6xkaQvCNmXW5mo
10102	payment	1726	1726	2008	1	1	2730	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYh5r3eHt6adomUVY7XPcH7UfngyVtXkaYt2FpLX9qrAPSNu2Uc
10108	payment	1726	1726	1874	1	1	2732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgq3gcsoZCsBn1nUGZm4BNxiHwM6CZDCFLDf6nCoxv6GkSYMN
10109	payment	1762	1762	941	1	1	0	2691750000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpYivBABa3jBL1gLygxcAtsfW6mGtVxbhJRF6wfo8LDqDqCp8ujo
10110	payment	1726	1726	1874	1	1	2733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8t8CkaVZgH9sW6xVMyZr2tVQJxmiizda5NAjwJftSsxL8DW6
10111	payment	1726	1726	1874	1	1	2734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46EvWEwrKukZPqqPsH2k44RzxBUF4UCoRTRedpLLsbDEVHjmb
10112	payment	1397	1397	1678	1	1	5789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYb5PJqJcZvtvzQGmuRurgXTQvcFPXHS7Y3bNrCnXzzAqjfnwp
10113	payment	1397	1397	1678	1	1	5790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmWeu9MhUF1Xv1js2A3C3W93PjTMJrmQPtTvPpUYXek42tV6o
10141	payment	1397	1397	1678	1	1	5802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRrf8kq4SRVR1NNNZJGPX9Dsr8cLDmaKEZxanE9hJ5BsNZDHf
10142	payment	1726	1726	1874	1	1	2747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxe9mMRVLhbSYVrXx2J7GPuj8EYQB7jduMVz9EoeiudJTAnLB
10157	payment	1726	1726	1874	1	1	2750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRteFX8CQN5Gm33femZvozxr7qTiZXkwEC2pg3n5wGPdSbK5NR
10158	payment	1397	1397	1678	1	1	5805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFM6V9GVsnvVzb58tSHYf9kGPE3oFrK3HfoXHUFL1m1kQwNTa
10159	payment	1397	1397	1678	1	1	5806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZpjeQdwCVKUi1sskmSykDqusDBzhYa7WhC2i6BGt2qTPM48S
10160	payment	1726	1726	1874	1	1	2751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgiDjpSYVv1QyY6zY5Hi58WKWpjtjSDyZ8fPzZUo9RqAAG18Gi
10199	payment	1397	1397	1678	1	1	5818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSHtgTix8DAzevtDaHHFwPPL721md8v9sBHPrZag86JVGbXYsH
10200	payment	1397	1397	1678	1	1	5819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNK48uJxjJ8G1zFXBz7Lieyox6EArsUjtUD64w19WXXuR1sWC
10201	payment	1726	1726	1874	1	1	2764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJi1YJq7Bgx4r1xd3PYQeCAQqkcF8zx3omssZQoUt4osxhAuoj
10202	payment	1726	1726	1874	1	1	2765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21jtPmpk2FHzgoSoJjGCRugAaiDKYP4DQXv6z5rxz8UCQvEXS
10217	payment	1726	1726	1874	1	1	2773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCUE4SQKm5vyFyt22Gtr9d1swWiLnN96m4WHVuQJyWnYL6b6h
10218	payment	1397	1397	1678	1	1	5827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7sCaQgwms1v4Z5jzB8rt6Yhw51fozTBmVmCkmxLeQFNnsMeg
10219	payment	1726	1726	2010	1	1	2774	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLDTjkDEcHgTsHgJAMVRnzxEGt74jrRiK4ifHtuQZxH1M1umbq
10226	payment	1726	1726	1874	1	1	2778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwhZJS5TfcppRVuXxju9Reu6k7FwBTVDcrSoZjZhX4GtcyNCTf
10227	payment	1397	1397	1678	1	1	5831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzQfdMTxd2j59V36JiJFcj6dNiENE5w8hxK4MucdvohVChz2z
10258	payment	1726	1726	1874	1	1	2794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYX2TqqgKeDrZCX5CfTxfJJbKSwu8yAKYP4Wm4iyhDeJ6rrumD
10259	payment	1397	1397	1678	1	1	5846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPP8T8P2hJ7XwowbaeWPmzZodMPG9u1xTz6KMeqj65GjUxB21
10281	payment	1448	1448	741	1	1	0	18666003811	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQvfZJsZ88VW5veJDzdNmbRyhPoJnVDzYUf6QDChJGQzbVzRK
10282	payment	1448	1448	730	1	1	1	18666003811	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpmR8wmkcE4TdmoDoAHSeVeKgHfKZn8rbmL1jcN5w2F12q3bA
10283	payment	1448	1448	449	1	1	2	246391250309	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3BuvbrS7nATh8abAFoRvVexh8CbebpPbGfaeNPzEVunBUs7gp
10284	payment	1448	1448	489	1	1	3	246391250309	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXzfj1rEaFvR6T8nLXfioqaQYurjnrLzfmuuNrX98EAovLEUd
10285	payment	1448	1448	945	1	1	4	1876970391541	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLus8HQDJ4LGCAo5yg2agbvGsrGF8fuSpeVkHGZgFqheg8VrJ
10286	payment	1448	1448	1065	1	1	5	3363514807644	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj5Q4MvxXZ5isnFE6X4R2s3pzwUdab3G99MM9nTo2ojGoRzoe
10287	payment	1448	1448	1185	1	1	6	2269430476079	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJCTvwtu8ERv8XD1ZCEo6SRPeQNY719GdH4NSWrbq5GzdeVN8
10288	payment	1397	1397	1678	1	1	5857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGEaSAs8mXPHJchpkraxzfff3VrygFGdc2vDt1HULKQd4DGUs
10145	payment	1397	1397	1678	1	1	5803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1asoiLcoaGZQXfsd7e9tDSWT5nGPA78prU2TfcUq4h49jUG1u
10146	payment	171	171	1128	1	1	1	3503591277789	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpZrTer2AR22XpNVTAAX8WdBz5yjrwNhytCw8psqawess2Qx5iLW
10147	payment	1705	1705	148	1	1	2	155970757207	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZsZoPUVhZJW9tgJ8qfsy9iYoBanWXNj9msMKa1a4K4EvPzAp2h
10148	payment	171	171	1248	1	1	2	2363942849109	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpZyHAThvi6rddSqQsXAWWCBW14hGXu9EfEXZwtoo8GoL2ZN7X5Q
10149	payment	1705	1705	714	1	1	3	4726386573	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZyz9zSPMXAT7rdoHQ4U1DE2zH1WyGCw766NdLDuLdHPXk4dBGj
10150	payment	1705	1705	994	1	1	4	1184719255265	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZFLyh2MabHPuyBfT3duozumhwxdFUZ21WmQXFYP7s5tCDGBtqG
10151	payment	1705	1705	1114	1	1	5	2123006754765	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZ3mpTN7EwPPVo9hu4AfWimC988shthLQbtfFpCXfwQw7LDxsZX
10152	payment	1705	1705	1234	1	1	6	1432434961334	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpaCFrAUn1uxfZXGYAhvJMXCWtxR4K1kBM9VMoR9aGb32wweFEpK
10153	payment	1705	1705	1360	1	1	7	3991607384791	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZ8Dyo5MAtAt8w3GxzXMBtpBHkGWFTM4g6eAzDnC1oQsttkW6k3
10154	payment	171	171	1374	1	1	3	6587336939141	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH9kknzk2BgjmYMiVhJkVkLd5RF9kz3c	CkpaCbaQpsj8NXJ3ScovPfJXiKnJmHkpXZmm7HMjMrQtrGpWovvru
10161	payment	1397	1397	1678	1	1	5807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAW8PTNrwQDGaM3td7gRPwPKN6gmqHSKBGcFpudioiuLxN7Pf
10162	payment	1726	1726	1874	1	1	2752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uaGonjr5gT2HpzgKsoXe5wn8g3qcnGtWZWeWUYBDMwD1op7E
10163	payment	1560	1560	135	1	1	1	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZAkAvUdMk3kTTzyrFyJdiSfibEw9t68qsKoM6zenPuKHvFpe6a
10164	payment	1560	1560	170	1	1	2	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaCPAaiCkBNGSqvyJezWjeHA9W9SpNEdtgvn6vUHQQKpsZaWfk3
10165	payment	1560	1560	202	1	1	3	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZ2eJWB6c4P1dXqL4rGhZFcQKzQCY8XrcuWVPEoyXT2TyaENj8q
10166	payment	1560	1560	264	1	1	4	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZnGWEUEAq6xJZvqtu7b4SxDJdAgWwAJWEpdaKJjD9Fznkk5CPz
10167	payment	1560	1560	279	1	1	5	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZxykwJirN3jLSkUUgQZx1bhY6PSWGpFbzcVU2bcWxaYjLdVdiQ
10168	payment	1560	1560	331	1	1	6	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYXyYxy6yxMAEtWJaAJD68JAdNKMh4kLutMZribw2iUQZq2hcEN
10169	payment	1560	1560	382	1	1	7	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYaH6N471FjpuNShDv7bXgHUbHJn46yMSyfmAeP31Vq2zytxqVA
10170	payment	1560	1560	388	1	1	8	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYaikdpkKLV2uHqcVi6ntHAtjcfa2WwVqf1FQqPuWJjg95461sa
10171	payment	1560	1560	400	1	1	9	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYnWG3AdseJW7poPBcaukqZvSWMUucmLznyjqAzzVnxcXAkQGcv
10172	payment	1560	1560	505	1	1	10	468147446254	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYbdG5ieniyif9WYFBQCnLeQ1L9JaMnPeBfPQBkNEj5bQCVJhHd
10173	payment	1560	1560	925	1	1	11	3387295182596	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZARSnRt7As1ALRYDMqwuZcneeAp9gK1E4CFmBBKQu7WAqXHh4s
10174	payment	1560	1560	1045	1	1	12	6070003944920	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZ2J7Tkc5SnPxHaKPuttzYp4KtPQfbKNHCA4vF37LN3rTh1TXGU
10175	payment	1560	1560	1165	1	1	13	4095552614993	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaBGP1zdY7QsdbZRosfbADzpPGCMtfyFrsnfuCXKSBDZoHjBMkq
10176	payment	1560	1560	1291	1	1	14	11412621517949	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYoQ8MDmfVNYrZbcdX7Zpx8aQPg5oG6tDP9H9r87kGYkFy5kv6p
10177	payment	1397	1397	1678	1	1	5808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXMCuXBAmQ4bqMRDzy9XDuotUL1dhgHwCghBv2cRQs8UPGTYP
10178	payment	1726	1726	1874	1	1	2753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAJ5Xd4G2NFtRZmcSbcNjmYGByKYPeG1B8wP2FwCLqCG96sNF
10203	payment	1726	1726	1874	1	1	2766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVhTTXmrKN8u8apJrFoJC3Kjk9XTdo3DdL9yrgjM32zDpuRdQ
10204	payment	1397	1397	1678	1	1	5820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6nYrJdGWe5HP88JKaZUsVpSid7DCN9jzYrjh8u6XJ2xx2pdEn
10209	payment	1726	1726	1874	1	1	2769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycF7pjJ4WozdAKgj9UGEhjGp5jx6u8sxScQ4HFLvF98tJ6jNz
10210	payment	1397	1397	1678	1	1	5823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6g8giwJPw5n2YyXC6M7nBthUwYJYQhhVK3htzR8reWy91zsTq
10215	payment	1397	1397	1678	1	1	5826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGTQjtpdJDWujsydLNEgF6Szmn6anMW2RySmVLggJX82btAso
10216	payment	1726	1726	1874	1	1	2772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQBPBZ3jCKCZxAd2uSDeqndfvPqQwbJYdyzc3DAirSJRB1XCt
10228	payment	1397	1397	1678	1	1	5832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPxw8kwrf1JgHQ8a1nkGBd1GCDFNVjwgKAMbg5H1Cv436uqq7
10229	payment	1726	1726	1874	1	1	2779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAQk6hDWx3b8S2hGDzd3dxQtRjHePFU9PbVUeFEXDo1AjjpzU
10230	payment	1726	1726	1874	1	1	2780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAV4wsBaFVaPEWbKnHJzD1aHSY8MC8Hi3y9VH5ga927nAuPvE
10231	payment	1397	1397	1678	1	1	5833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpeCcsB2b5EoBkbJqEgZ8D3zJAMo4FyZMQcarjVU86DCgKpWG
10232	payment	1397	1397	1678	1	1	5834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJGzNXQKBbTMg9WMRAc1w1mgXwbUZsceGfeKh6QY4ANxQR6ee
10233	payment	1726	1726	1874	1	1	2781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvErqq4cAzh9JeQ13vC3NbD7EEyxvqMtoSujK6hAQGNqXAHKrQ
10234	payment	1726	1726	1874	1	1	2782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHrDXDZoYUjZFbAEcCTBLFVdTZZpZhNLytqKjvMSnHEjTbrS7
10235	payment	1726	1726	1874	1	1	2783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FHmwC4d1C5nDT1U8SYgGxcePQMG7yhqAfuQeWdfSuzL2Hemb
10236	payment	1726	1726	1874	1	1	2784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmYbDY9cSUNz6pfhrQokF567MuSjEjKEGcyFaT6MKrr9yxER6w
10237	payment	1397	1397	1678	1	1	5835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyGGQQq3R4JTLdjycC3e8nQFQRFkrBwYAsYYD1Z1Zy3FskbGb
10238	payment	1397	1397	1678	1	1	5836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1XjRnp5kKz7otpCKGbhQekFRGG5mHt2JaQccFqtY5tfxwQ31
10239	payment	1397	1397	1678	1	1	5837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92QRZrZroFDX2Vd6QdgJ511YNRD8mbmjiAqdH632mFW4otqb1
10240	payment	1726	1726	1874	1	1	2785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtiFNJbYgwvyETFnJkSnjsSMg1TQFaHsaop4TgaAF7Db3rJbF
10241	payment	1397	1397	1678	1	1	5838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaLf4HqS1tzNpF7PLZ7YLQBYaBFGxL9z6dmAHhffZe3jnQKMD
10253	payment	1455	1455	2011	1	1	0	900000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUk5t9xC6tQVsFGqvuViaoEyyxCbQsE5H9ArhgpAySctf6aGUb
10254	payment	1397	1397	1678	1	1	5844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvcs4DYoyC5QExPgHRoDdeau2Lv9PSkAhCgP1kpSi4fjpLC2K
10255	payment	1726	1726	1874	1	1	2792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfdKjCjAaj3LP9VyYgLCoXrZWB48WTGotcXsRm9A8pSDvAiLz
10256	payment	1397	1397	1678	1	1	5845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWbeDabYXQeiLMZZamT6Mu2AfxH787iUhU7JCn3GcMG513Lhf
10257	payment	1726	1726	1874	1	1	2793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCK9E1sEUGjbBGEmkgS9Tg4zkz8oT53qRpQehXyYhws8CEZC9
10260	payment	1397	1397	1678	1	1	5847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNHgx1bPL5BtcxVfUKaQWXCpBMsbznjvqdHnTbzkLhXxSFRJJ
10261	payment	1397	1397	1678	1	1	5848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhTukVzoLFebBQDbEXRz6i8XfjHikEuHvbsZrKXzvWyYCF4Wq
10262	payment	1726	1726	1874	1	1	2795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAv16qLDiPJgcM7debBGskb8kS4RnAStwSvUC253tA23R5wPe
10263	payment	1726	1726	1874	1	1	2796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUr5ELdZqHenqTxqJBgbWe6AATvN6qGxDvsfeEVXErgFsLzwF
10264	payment	1397	1397	1678	1	1	5849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcDLoMm6VYHKWbEVotB9P2wwEz3jxY4rModC86zeiZaxgN841
10265	payment	1726	1726	1874	1	1	2797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHrz6E3HgrSJbsLwBkTJkdAotVEQQi9ek8jvRThT2grJ2dtrw
10266	payment	1726	1726	1874	1	1	2798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdXqE42td9fhsxkXNg4GryUUzN7sFbHcTxrW6G8y7t8XpejoD
10267	payment	1726	1726	1874	1	1	2799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHviYWKhCcYmdDty5KFCtc9rbKn13YqvtWhi7Vv6NHh8f3UF8w
10268	payment	1726	1726	1874	1	1	2800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbAWP6jvG8ZxcQcr4YL2QJLuZ4UVzCEoX48F2djwKxDEnafJU
10269	payment	1397	1397	1678	1	1	5850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMPcc6FdTKgR4UzSCo3wDPRaZhMGhZUkW3YiBi7vGshaNtoXe
10270	payment	1397	1397	1678	1	1	5851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NdYtBe66CtsZ3syrck7tcJZSL3gZDF3vfTKQtARNQEF3DoLD
10271	payment	1397	1397	1678	1	1	5852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozYFQWr7vi1waJYGC52ykAafnAkBFCqe3JRsGeP23z6zWphYB
10272	payment	1397	1397	1678	1	1	5853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKMaboTcEgRHhgXVWvnasQrMR3zBuns8CjtogZDaZPXpwB9zS
10273	payment	1726	1726	1874	1	1	2801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnvpZHYxHQKv8f4Uk8q8DNdbpktpoprj9pbpBxNJveJ4AqSdi
10274	payment	1726	1726	2012	1	1	2802	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6SztLLMKwghc2f9dap6L1HFAH5Q3CRqxhfz9vWazT7S428dMT
10275	payment	1726	1726	1874	1	1	2803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYueZM63Pt13sbDrMB5PnL51y9Una3ZVDca5pHU1q81ZzBC8wWX
10276	payment	1726	1726	1874	1	1	2804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wXtAtFeRB7oKaPD9ZTZkxxA1tLyTRALmPnAfHSfJEgUYbt7V
10277	payment	1726	1726	1874	1	1	2805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BRxUyX4JK5W4W4FB2HNFB8jEj1KSo5URMSW5bXCm11FoD3M4
10278	payment	1397	1397	1678	1	1	5854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKKSBTYtbi8ymr6nUJQVokF4zzCKKmtLrsba3acSsL5bN44HR
10279	payment	1397	1397	1678	1	1	5855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9jMe4TUZaQSEkhy2ZMXiNoK1b5k9JRVYTfnu2jmX9NCek5S3
10280	payment	1397	1397	1678	1	1	5856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPNHbLQKXzQsGYzuZMgZ7WHHo3ozKRk4qUZ9AiiM4jnfXtL3Y
10301	payment	1397	1397	1678	1	1	5863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5c1nbYgWyLbHQE2Y9qmNZQg43ApPss6HUqSr9FQeeLae1qH4
10302	payment	1726	1726	1874	1	1	2812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxg1bC5JWrzDRrmVtiRs5vWTsEDDvHDGQSzMGpDoQFKr9tpaiv
10244	payment	1397	1397	1678	1	1	5840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbzA5Ye8r4Z9EQYjdEwk98p9Nm5aonEpU54TvZGqoEjrdgknb
10245	payment	1726	1726	1874	1	1	2787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFCJKnTWkKjqtDz9UKzPwPJkgezsy2MhM76Wc8nJLdqG6dtrK
10246	payment	1726	1726	1874	1	1	2788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sEC9iULeT679dQwo2vfECDZsz8qkMyU62sS8pHhu8Fi8d3nY
10247	payment	1397	1397	1678	1	1	5841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUd7e3CVuNZVq7LTWyeARKs6PVQjcT8RexUVDhCzfNJTMFRQ8N
10248	payment	1397	1397	1678	1	1	5842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbhhSSjdRS6zNNcMVYw5ZqvwmyzVvShbC4dNjRPvsioEbjCEe
10249	payment	1397	1397	1678	1	1	5843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWcnXb2sES63DGiU4E3td8ienLhfi8gkG3DoKboTejjhvxeyT
10250	payment	1726	1726	1874	1	1	2789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZWVh2KRNC6ew6DjcPjZWcVxbMfDvbGPxWnfpA8bJhjPBABcW
10251	payment	1726	1726	1874	1	1	2790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkF1uf85eFCHrWmWBZqxfxQiauNZBujsniNGUbpmMwwguXMsLz
10252	payment	1726	1726	1874	1	1	2791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifavvq7saybGVahDTSdozzcrD7c8VpcspGV9vHcjDiXQkjeVz
10299	payment	1397	1397	1678	1	1	5862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCRb1CWfjrE1t2w8Wry9rzfreyRVzUv76cMDYg5ze2ixsCCNC
10300	payment	1726	1726	1874	1	1	2811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzdQxpvWynwEnyJcFpi4wKZeG7WzzUqsSCRTjzEaZVA43zuba
10308	payment	1397	1397	1678	1	1	5866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfr7NavAGYpMcP1MGL7bBXZPBejKn5EoYhyY4bQhoVcJSmNwVe
10309	payment	1397	1397	1678	1	1	5867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLM7AzzoQywdgP5WetAqPirJusdMJfjU1C3x9eGaHuHdpzHe9K
10310	payment	1726	1726	1874	1	1	2816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVcUVwHP3vT69dnY6kLSDWLHwSUo77NrmDN5orBW4kz93pfy7
10311	payment	1726	1726	1874	1	1	2817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdL1bWq4JBZnRYth3gHj2HyiH2QYuXuJ1maaZcGwmzVSjSX82T
10322	payment	1397	1397	1678	1	1	5871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcNriq2FNF3m6BjKGpnoyhcutFCQwAuD3hWKucQufzuLJPC3u
10323	payment	1726	1726	1874	1	1	2821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2t8GRHBjZLRZzeA6nAuwRnfrqhDK2t9UrWJHgTwE5KwhUQRRe
10332	payment	1726	1726	1874	1	1	2826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9Qfh2xUj54x54zTywbL2oNiTL2sZDJSsGTKTLZpfM82gzegj
10333	payment	1397	1397	1678	1	1	5876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXt92aoQ6Cd1CRc6aTEWAJMyzH7pxcx9gp8Ueehc6rknpCdP5
10334	payment	1397	1397	1678	1	1	5877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYFDsGo2EtwT5PtmjDy9mmWT1zftsiu8cbB3x7vjGrV2caGyh
10335	payment	1726	1726	1874	1	1	2827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyo94tMxDcDV3h75d1fFvmgSXy2zbcY7uxcov1z1uf5XUcQDAq
10336	payment	1724	1724	937	1	1	3	2644138800000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpaBsvCPNoZPyHpzuwD3U3vcG9dFnMKYejPTdSMJpk5H3fXjmgZ8
10337	payment	1547	1547	683	1	1	0	1000000000	100000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	Ckpa3LZank5atPU1qD9vJVsq4wKdDHo3FX6HmfCNFACYRjeiD5QVh
10338	payment	1397	1397	1678	1	1	5878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzgYmqYeAabvsedsf9m7Ak2i4nCtb5E86hyqXLyQ3nRwHKLxf
10339	payment	1397	1397	1678	1	1	5879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JeBueXm2Dh7U4aLF5irfYasDrrKFcjTgq8apKjPJDEUSNX4N
10340	payment	1397	1397	1678	1	1	5880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbnKSoMTL5L6d1Jx4r8r7Dv7TrhTnARZ47rq9rAqGWZSxVvb8
10341	payment	1596	1596	1932	1	1	10	588869152658	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQTQqv77GntcFzt7kfswtGv6E3LeQ7XeZStWBpQKvxLEW7SMu
10342	payment	1726	1726	1874	1	1	2828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFCbxo3zQjjEPsPk139AD7MzT4Sq7gcxSmtvZ3WA6FeqLhwmB
10343	payment	1726	1726	1874	1	1	2829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuejn9hYrrtZYyv3FmcGmHpgCULR1B9DGY7nc2qZAgTsPD6wvu
10344	payment	1726	1726	1874	1	1	2830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYKFfLiKc6tCfEsAao69Bnsjpd4MY1cg2hHrVaeYmvoZv7WP9
10289	payment	1397	1397	1678	1	1	5858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD3QobZU8Lo6oDxF72P9jwMGkaZm1bYAkodQwNPCnrYWh2SDe
10290	payment	1397	1397	1678	1	1	5859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHfBkFUBP2K7XS1AU7QgGXoK4PQK8hfY3kvfVpeRn9Bv3LnoM
10291	payment	1726	1726	1874	1	1	2806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnemMM14GtUPTCPjLpd8fcnprRTsvTq5tFS1NiMBLj9dBufH5s
10292	payment	1448	1448	1311	1	1	7	6323969816495	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeezbS4MZwgEzPyneWc9tmA9dA8U9GUCNLVNMi7LS5XzbxPKo
10293	payment	1397	1397	1678	1	1	5860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvrN2vzH7XP9LHbu7gfSBnS3uauzgbLJG3szc8MhLeGpSt5Yq
10294	payment	1397	1397	1678	1	1	5861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYij2VAaJr759gJmqq7UqTaeSwzvh7D4QYFC2Cc6n6kSciAq335
10295	payment	1726	1726	1874	1	1	2807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnQ54owbYFy8NnT7LTPePvCSY1ZxNS1kEhCrv4tKP54Eedb9w
10296	payment	1726	1726	1874	1	1	2808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4VwW3obbk6eEMcDybc8UkuArvShap35CUiHfT4J3XPfysD4q
10297	payment	1726	1726	1874	1	1	2809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJiSub4ArUueHx8M5JJvLRmVgjXDF4X33bo3vBPitS1cNAmvx
10298	payment	1726	1726	1874	1	1	2810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLN56XmCy9yRQwhop3wSnpDoqTHemUp5H5MNfqm13hjM6oBhqB
10312	payment	1726	1726	1874	1	1	2818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfjXPsLybsNbreuQWipCzjpv6FGGAPgfmGtgtQtUgAEPimmf5t
10313	payment	1397	1397	1678	1	1	5868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfYU2s1MwPfnDNEQNTFPNkFXbbddMwjHjwiuA4kuyUnPaW3Ph
10314	payment	1455	1455	966	1	1	1	2413000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrxBd4GQn1C347eLVtL3BsLZuDSS4rMYabxMv9wATRFw7xSmX
10315	payment	1455	1455	1086	1	1	2	4325000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHJnigbE5JS8MpvtjHgr3mTWDZG47dzkDvpQGZUgCtTsKq1fn
10316	payment	1455	1455	1206	1	1	3	2918000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQT2UrADN2Qycwk7gNav5Y7vdJy8HHw6qwngCMcK9ektocJje
10317	payment	1455	1455	1332	1	1	4	8130000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmBNa35vEY7A4Weu4MnzwaQwv29TqkJk6VsJqVhx7ep3qD6eG
10318	payment	1726	1726	1874	1	1	2819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKH9WSrHAsm6CksDvU1LQKEwgMn1WQmVEi76tvFRPTbyeyNjJx
10319	payment	1726	1726	1874	1	1	2820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsArecyPXMeNpkPYatAdc8KfynTh2RJHdd3Ttd1WyWQJzYxoAi
10320	payment	1397	1397	1678	1	1	5869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tY2fV94CWS62f81gGQ2pQseDpesQwyJukGakmz2GkqDc2RXv
10321	payment	1397	1397	1678	1	1	5870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemgEW8x8URYZUUeBUPErwNSivcMjBLJT4zzXjWYXwpTE3huvn
10328	payment	1726	1726	1874	1	1	2824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzH5nq4QjK5gto598LC1PJcxUpP5QjRzc9QZiCcAtMtNzev24V
10329	payment	1397	1397	1678	1	1	5874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ29yxUCcMC6igTso1LRYSqTF2yZAB9mhKwLMCPf4AY6m412Ej
10330	payment	1726	1726	1874	1	1	2825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuWkGEsoZGwvc5QCLcSWYtP8KFSqm6zWH1GUpMRj3jeoHyqyF
10331	payment	1397	1397	1678	1	1	5875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Znrbg8AMzzpyg96JeHviy8JeB47W4Svr8JwJ3YmHLyRuDHxm
10352	payment	1397	1397	1678	1	1	5884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYG3qq6XjzzrxkbeNaBgiGrHAxZhvNu5EpdiHPHXaUfvKkDLVf
10353	payment	1726	1726	1874	1	1	2834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtuLyfH6PRghZnzoS8yqimTUZ7wPRFFBHHQkYZEoWaMxGVuzF
10365	payment	1726	1726	1874	1	1	2837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5B8bqHEGAEDF72asfQAxK1hzdtnhXKrvjyUeKbWfSm1sFdcC
10366	payment	1693	1693	344	1	1	562	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZERerWSqokTQw3MiLyBxSs2PsFFXncQRtqeCcdVttRSty1o1Fp
10345	payment	1547	1547	1012	1	1	1	1459000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	Ckpa5x9WkQAkHQKTVmZewVQ8zqHmhuhmdqYsztQkNngAFoCM8N81K
10346	payment	1726	1726	1874	1	1	2831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLW9uVUwQHjeyexfA7mRwrshqSn4C4sjmYPJFVPYfk4uyk8Zr
10347	payment	1726	1726	1874	1	1	2832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJgddPFtKF9EX5KDSM843tTmEuDKij7d1iFASxfhpukgk5h8m
10348	payment	1397	1397	1678	1	1	5881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qmQZ5YRSe8TJqGUYdW1UKvs9KFkJDYYFqNFcVSyHphZwb1PE
10349	payment	1397	1397	1678	1	1	5882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdaPEZWXcp4kM97tfJNaZUJHLJXBmDWNFsi42zjQ9KjpqdK8D
10350	payment	1397	1397	1678	1	1	5883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn479pvQiEXCwFocSbB96xg3XsZGD8vDwXtKirpcTJxXyQsr83
10351	payment	1726	1726	1874	1	1	2833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPZFCoYMw6uvZs94QoVEckFpPrTxLyjhKYPucLBv3r2FpK8RW
10354	payment	1547	1547	1252	1	1	2	1765000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYxXeb6qsjPYBEegxaVebtBsuUqSw78DuzueXezKUVUAPKodKR8
10355	payment	1397	1397	1678	1	1	5885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkgnnnUjPnYK9Fc2w6Lny1iduoPgNyFFrtjgkDhLm9DbET2Hq
10356	payment	1397	1397	1678	1	1	5886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1m2thp6S9kZtwt8mQ5oxmDp5widfxP9VfCqE9v36CBBNajq7
10357	payment	1705	1705	148	1	1	8	191684554121	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	Ckpa8yBZ3V2fviHVvV1LRqA6VocVbix2Ed61CNDdfmZ1pdokzKvNN
10358	payment	1705	1705	714	1	1	9	5808622839	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpYkPAfKyq4uV2RmLLy8THrft9sg6nfiRZsKxvwQRPbwMisTzxPV
10359	payment	1705	1705	994	1	1	10	1458116006480	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpYXQnXFWouS29YogDPLBkoouRNi1P82AptfaaGsM9FqhVkN7cvF
10360	payment	1705	1705	1114	1	1	11	2612931390480	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZcgzzCY1tJmhHbn3tHTvMkwhbaxduuovBEfChiGyC5z34mFCVm
10361	payment	1705	1705	1234	1	1	12	1762996875488	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpYcVmsaRGk5sHxm9vXhrJQaCyiJ6N35SHwuNo5W9h75ZtyD7aW3
10362	payment	1705	1705	1360	1	1	13	4912747550512	10000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpZ7mnLF8mQw6Ayq1szZ1p2rE1pjGAz8wY3Ms4n2cXxRVzm9momu
10363	payment	1726	1726	1874	1	1	2835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4pwZixR1f7ckzCpx5CTsxmZ4v5dWvJCZLWZ5Xj4TDiZwR88M
10364	payment	1726	1726	1874	1	1	2836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRyBmfSfV3Nvtk963eCWkRb9ssA36nShzj2ZdetVwxmJLwMDX
10368	payment	1397	1397	1678	1	1	5888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrh78oY9SxRHHaELLeuNiXShZny4KTT6bNsR3SpdSjxNmZSfG
10369	payment	1724	1724	1177	1	1	4	3197563200000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZNxdMjFhMaR4gSeatEBdmCYvbjcBpJchmQSgVia9JozngUkXpm
10370	payment	1724	1724	1057	1	1	5	4738820400000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZcmw12ir7rkqEZJhtuVVTxUnTig1vxNL3Xjeq1jLkHP2FJqEwK
10371	payment	1726	1726	1874	1	1	2838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCx64EBmuF11cNsM3n6dSEW6kfLR3QbRMRdBv6SXNuks2xx9Z
10372	payment	1547	1547	1132	1	1	3	2615000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYRSYu75hmVpEwzNs5pJsPAZYWnrLs9Qpe7SHZPB4KTZS9MTho5
10373	payment	1397	1397	1678	1	1	5889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaaZdMHd5sohZB2X5FjwkMxFrC99trE2VAcTxnwSpuogrsKNH
10374	payment	1726	1726	1874	1	1	2839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfXuNWxWJ3kjrGoSDxVeZQVmM4iSHonrCLpADmEu2pSwatxqc
10375	delegation	344	344	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6iWJEkhiYD4u9N1zQGe52kDpf1tpraKkWoBC2sY1Tyvv16yZ
10376	payment	1397	1397	1678	1	1	5890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkNGSKwvtYAK43VEnP9iL1HmVvLEd7gdZuxksdtKkQiSqGUfj
10377	payment	1726	1726	1874	1	1	2840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNNF2kMibLSii3nszKr7RsJtZw1UpGav6QCcaTJmFRi2icFgc
10378	payment	1547	1547	1378	1	1	4	4916000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZuBGaVJKJTFFrxFQNiD8zBbArQnNRwD28BFa3KVPxgXDd3PM9B
10379	payment	1726	1726	1874	1	1	2841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77mZyirqSdbJrGcbdg2BDzAyQyNEVRNNGKauLQA5TykTjPorK
10380	payment	1726	1726	1874	1	1	2842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42owJhGvHRQrERZ33CqCSJQdLreA3K3H4abJSLdprhNuc6GCz
10381	payment	1397	1397	1678	1	1	5891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1EHwrr5SY2HCZVzUeT5bauQX6f4NmYnmBmX7LgTrSi3G67N1J
10382	payment	1397	1397	1678	1	1	5892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EYd9Uc1MJVy4N6TWJqs7YeyvZJNWDxuKzbTZjMPcevLDy7pL
10383	payment	1726	1726	1874	1	1	2843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVPHgVVVjH7m5ri6s2vFTvZpmEDgZjv241ibQ1LHz6rnK8s63
10384	payment	1397	1397	1678	1	1	5893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7syD2mW3RnrTXSRpCJjexJLDN4BNRxkvr2vEeRBps7NNNs2j
10385	payment	1547	1547	683	1	1	5	191000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZdoP7i59dvNiNp5RqycWucTYRJ7BkKju6xtWecsfCaeawK4VF3
10386	payment	1726	1726	1874	1	1	2844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG6BAthZ52SrupqhUDimMM32GrjmgvtZsHPUsL5K7FQYSijhx
10387	payment	1726	1726	1874	1	1	2845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodMW1Tt5YPxjPgH22meDDKAYviNJPiAJbYZbFVwLDeEV84io1
10388	payment	1397	1397	1678	1	1	5894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTQn12NNtd6LxrXxby8xdGG95nCvpszykFSwdN4sarcGDWzrk
10389	payment	1726	1726	1874	1	1	2846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHd21G3AYvrL3wgmZ7YJSwvnG4ZSe4FyA5Mfwze4Hmg6Hu4VHd
10390	payment	1397	1397	1678	1	1	5895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjenZyZcCP66tUrM9Hypziw2qZ2g1XEUjZuc6yijkTN8W5MYqc
10391	payment	1397	1397	1678	1	1	5896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsKgXduo5ecazW8yxRPxo992fmLLqsfPkQmVwnaC4SMu9Li9D
10392	payment	1726	1726	1874	1	1	2847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhoHB1scvKdDT5JHqrY16vY7WLWppmA4tHtqU2GxateowhaYyE
10393	payment	1726	1726	2014	1	1	2848	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnTHNSBMa4aGCqZzMoRkumX2i6uG5rsyCZ2G5L9y4AqTrMEjNK
10394	payment	1397	1397	1678	1	1	5897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YSBF8pRpCto6pSXTsyQBNQJcGtRn9f2jUHe2uvNjt131rt38
10406	payment	1724	1724	1303	1	1	6	8908347600000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	Ckpa7hgaXhTfjiXWtj5JPWb6wppqNMVB6SYKNrWzXTfYoD7tCB1WE
10409	payment	1726	1726	1874	1	1	2855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsB79qcVvu9pc88HBsvH46Qzz3XYXhEWS6kWb59kpciZbj63CQ
10410	payment	1673	1673	100	1	1	1	337270000000	10000000	\N	E4Z2WL7Rj8NjhXTuGVLvWa26s2mRNhvDL133eXGrheXSwEo2NLT29	CkpZ9khkCAijBcERjVJxMDH9UbTn9M1eqp6cMcYKi1kMyKpNELXDb
10411	payment	1397	1397	1678	1	1	5904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEeuVkLD8DXcD97VVKY3BXffyLMQ7swCYxYWg13yZGBLZQLTcP
10412	payment	1422	1422	1422	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJavjcgasEbGjVF5vquhFuZQqsC4etH1U6KengJ8ZZ4PeK21pJ
10413	payment	1726	1726	1874	1	1	2856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFeMoGcL7hDj2wV5ZT1mEk968Ux9Gy2n5sJtdiARDSf315WMk
10414	payment	1397	1397	1678	1	1	5905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWG3ZN6rrWkMgdKPhAd2ZKJ2tfjKb9FgQ3AyR5WhYD4cNexVv
10415	payment	1422	1422	1422	1	1	1	0	1000000	\N	E4ZABcF9yybQPURw55T5ad63TjCFSJtoBJWKNQFghvYi1vKf1XtKd	CkpZmyt3vLriMiVzdEL6zYej1sn8nGQ11pv3B84SfmeNR6n1baVPJ
10449	payment	1714	1714	934	1	1	2	2906467622784	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZgBbLHnLkg8R2vQ8msKw4nNkmby5ZCRBcqi1B4zQevJbrXhS37
10450	payment	1397	1397	1678	1	1	5919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uxixwc22x8y9CUe6q8aA8GYxmMMLbbijmW6q54BJZkbA385e
10451	payment	1726	1726	1874	1	1	2870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHPyJntk682FWb46XipiVJghUwHVVYkHdfWt1UQFZLpfCa5v9
10452	payment	112	112	1821	1	1	3	62000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTDXhuEGnLECi6zhn58gqyqkoHdR8UqC6nmNXtmX9EpEP1Grj
10483	payment	1397	1397	1678	1	1	5932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qc223LQtghrFg7tkFx2jYc4VLQuxeaRneNavDVrkF26pohLt
10484	payment	1397	1397	1678	1	1	5933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxvJWa68jZm4AroM6LHQkSYhrmHKWnYLTCPfLtwEEB3HToSWG
10485	payment	1726	1726	1874	1	1	2883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBreLXkKEQbZwdD9Kw61CxMSKVCdJvyrbhpAJJ43oUqzFdh46Y
10486	payment	1726	1726	1874	1	1	2884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAEqo7GHbkk8ZnwcLHXikjhN35zqd9S6jCyeXq6tvE6Qy94xz
10491	payment	1726	1726	1874	1	1	2887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaV4XG7ho5UH9HUzXkfX1d2tyMjPGqmcGNyQaDpzAJoXb1uAgt
10492	payment	1726	1726	1874	1	1	2888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6VRAzp7QoL587C8pPCm7JNWp4Dm8j95cgrRRuVwYAs9DwweQ
10493	payment	1726	1726	1874	1	1	2889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbC6WuDfjUFUPpPgaDk6qK5btqGf6x8P82VU96UCEAuc5zqkrt
10494	payment	1397	1397	1678	1	1	5936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzc8wxuDnuxk9wN88q4vYdhrotnGyDeohaimCcJpFZyM6PkD1
10495	payment	1397	1397	1678	1	1	5937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzYERvgE7sFpoBHDubuGNvQaZ8XUdjFWy2iwJLLiC3c6vQYWJ
10496	payment	1397	1397	1678	1	1	5938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVAbngrFkaub8BmpV5kboCpk6CCq5FZV52LyaBhux5o161kCb
10501	payment	1726	1726	1874	1	1	2892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoMKCfyPQr8T3NYe92dFLxyELA9zMVKBiHJkbcRDFKn49Ts6Q
10502	payment	1397	1397	1678	1	1	5941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnL4EZV5jX1AnKHqgxeh1oDEWYH6Bxgq4zFqpve24b4Xhw3J1
10509	payment	1726	1726	1874	1	1	2896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aFDd5w8xGnNdU3Xa6QJEM34DSf2LwBWY4gLB12AexBcyZhwr
10510	payment	1397	1397	1678	1	1	5945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSZXfRo4P4DX1M7AbVooJEVDutTmzWHzRC8pRJ4Tegw3Vm8Jk
10511	payment	1726	1726	1874	1	1	2897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnmbUzZjxd4dtXcLmPz41Yy3z4wT7soLjPe9xtoSzRWDLGvzfH
10512	payment	1726	1726	1874	1	1	2898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJGYr3p5RHVC7ZE2VtboZK8DgDTRNws6dK5Jr2Mz5xBkJiVH8
10513	payment	1397	1397	1678	1	1	5946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBtQgBpVoCtnGVu5QRPTZEbLTamLYQunwp1TYqoT5ttMhmJxg
10514	payment	1397	1397	1678	1	1	5947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5oSdobLkjbY4ko8H6YXYTwEPEKgDWXFuZ76dJF1RK9Uxtgvo1
10520	payment	1726	1726	1874	1	1	2901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NkTbjTAfRL1qYJnDU6bcjc3ehuRHzhS3xv3KMfo2jzmdGGh7
10395	payment	1726	1726	1874	1	1	2849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qPFpEx5MPK1TV2Rkx4jjZmbdrN7DdpygRkXPvK6dXHLr1BDa
10396	payment	1397	1397	1678	1	1	5898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cGZmydmfQ7hk5cH1iLTTDhtHhrchpYJJV51874Ht293btSbc
10416	payment	1726	1726	1874	1	1	2857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26R7egkxwdhTzfUkT9pvwFQLiwxcPvk76NKXjaXuXqdw94rzB
10417	payment	1397	1397	1678	1	1	5906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxuF8hBbKQAnUg1NHPu5hXu47wz2W876BnxcbUM63MazHzCst
10418	payment	1397	1397	1678	1	1	5907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1Bjm2hfLwng2VQdWVbCKoMgHGAYfB7qU5Ed573GJQFTBvuFz
10419	payment	1726	1726	1874	1	1	2858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjz92CcLL18QQggKvnXYtF2FQ1ptGctxD21zawJ5LKT1iHBcrb
10420	payment	1726	1726	1874	1	1	2859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaq8Xs5pMUbqHzkxXGXHkq2Pe6tMwhLiWhrkDErZjoMvdgtW1
10421	payment	1397	1397	1678	1	1	5908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVsDLSqjuXkhSnqMFN1oV1ihgjy4P3biCPnY6m4NPCh32F2Rc
10422	payment	1726	1726	1874	1	1	2860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqvo9ng4bTQuUVZtfch2ukzcM2rQmZEDxgrqQmLJ6V4ANaohW
10423	payment	1726	1726	1874	1	1	2861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXuvYqrsZ7aveLeG4MgTBaoktZDCJAzDH6xMRqHE4VpzpfWd2
10424	payment	1397	1397	1678	1	1	5909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8EKVH4jQb3t4zV9CSWgkiiz5JKMGvMSTJUhSEwzQeJC2pn9g
10425	payment	1397	1397	1678	1	1	5910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXg97NPLh1MQkrbX32bHCyFCH9ofYLbUUiDZVdsSNVdHM7n337
10426	payment	1699	1699	1773	1	1	4	6840402949970	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZNHneoivDriWRztJHkKLGooU36LBwv2LXvBb7GzbhDbw8qMK
10427	payment	1773	1773	182	1	1	18	118518922960	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYdFcnoPutcFCVpaCtTVyW3NBV2ab6MecPKGKtWcDC9CW8hqzb7
10428	payment	1397	1397	1678	1	1	5911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggigXtua19byK6AbX7bHTzgvmZRcKwNwH3EBYewgZtkyAy1sq
10429	payment	1397	1397	1678	1	1	5912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePLDfzvsCeDsGdTgtAEWA7BPaEUB7hDP6Cr69RxkdK6hDBiWu
10430	payment	1726	1726	1874	1	1	2862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2Kw7bZ31LvSBxgiJjJ7UUxER2pswmzNrm7HmKL6apk1HdPH8
10431	payment	1726	1726	1874	1	1	2863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtfxpVC56CXmVsaLCTwTyBD2BKXbsTdqUejobt9CdQ6B1dLcm
10432	payment	1773	1773	702	1	1	19	79012615310	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaC1NM2F9U16uDTcXrdqLMvhKzzBvNyrSK6Nykadb5jafVkGgQY
10433	payment	1773	1773	927	1	1	20	901291269710	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYy13N9pvtNHg2cUi6FitCbdZAvdiqZMx4z4yzECnNvPn68D3dh
10434	payment	1773	1773	1047	1	1	21	1615106233060	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpaHQfrz97cWrg6oNeZfPud7oDNF4wCDbb4kPWs5mJ2c9JEuPj2X
10435	payment	1773	1773	1167	1	1	22	1089744358710	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZCGVcDoRW2v58xNtoX8W7GEsz3hNPFCJ9a3UG5eWAavhS3tcfr
10443	payment	1397	1397	1678	1	1	5916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhNiVYUo5xEsTyEmAm2D2FzcLvsgWyjL4VGK81u64H74qdhEX
10444	payment	1726	1726	1874	1	1	2867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbjo2HagzdAGazqFkpEwYigWm9k3LLHkk4dvNKDR8PaRpAx7F
10458	payment	1397	1397	1678	1	1	5921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8vZjUHGstcw5CfzjtFjTzJddGX2D31Gkc458xy4jz7uMNqQH
10459	payment	1397	1397	1678	1	1	5922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyawk46dkhR1jXmHfdsp5de8LDt6XquD2MQmLBHk7GDd9y322
10460	payment	1726	1726	1874	1	1	2872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZBTwzsSfNGn9fG7nTcPRJHN1VPWjM2ogHBjt5y4JCs42B6rZ
10461	payment	1726	1726	1874	1	1	2873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXB4qnd2Nb5mrSTd1vQVdy1yBiTGk8ZpnzUJ4hTtHZsCvByT8B
10462	payment	1958	1958	1978	1	1	1	120000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5T5hS6YfRJcdKNr4N2p7To8gBB54WsruyjcE7WSuggRgRDRti
10463	payment	1726	1726	1874	1	1	2874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY74C5JLCnXqeeEZ42sJoBw3uJfeo8P8oyHd6S1WBELqYBVPT2
10464	payment	1726	1726	1874	1	1	2875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfWGBQnQ2hg1fkSzqkF5wh5rBec1RKjgEJC4inkqQ65ZbQ3RV
10465	payment	1726	1726	1874	1	1	2876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobe1heYKoaXqRrunYHD6GuQVVFf5DKtCLerK6njK5GFKnLZdo
10466	payment	1726	1726	1874	1	1	2877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDqFwUfbdtZhNnfXto62yerU8GfZmiB85rf6m6GeVAxDfb5ta
10467	payment	1397	1397	1678	1	1	5923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrme6oSzeipcJ7kb3RXtr84t6fzkDUZxrfQ2mQAjdzKHmUpn4d
10468	payment	1397	1397	1678	1	1	5924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2A7WYXwmZWFT6ExEJF6v6ZHXqqAt2C6oN2JvdTfVY6BFrewg
10469	payment	1397	1397	1678	1	1	5925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9bVpLF7wBYYcuYAmtGuE3TAACfLN5Wju2NHwTrkkdMMk5CJ1
10470	payment	1397	1397	1678	1	1	5926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkMe6MjytYKpFBScWkeexwVyWE1J8kPuJsYBw5LYqUUxuJonj
10478	payment	1397	1397	1678	1	1	5930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qhypv1b8ydjQfxvxCFWwBb4fxqqKAU1Vc3mUP3bywHr5cxjm
10397	payment	1726	1726	1874	1	1	2850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWXhjiTmnq2nRrNEU4JSp4jwTbCNB6sHakXpFXF9hbNyFj5Zf
10398	payment	1397	1397	1678	1	1	5899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJ4FJQ4g2U5vXDLaJKQ1CwHu7R2mdDJqVbU4Lu3M3Np1gTU36
10399	payment	1397	1397	1678	1	1	5900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZCZ8M65j7QMyw9KA3QFvPgsn3ywjqG6GKEY5qyVoCgpV8TznY
10400	payment	1726	1726	1874	1	1	2851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5cqs9uQrQj2Xwjfr79HJN1GytFugA1hVqY6fPKmrMR3wAcyM
10401	payment	1397	1397	1678	1	1	5901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpy3teHP1BgxSAJor72sQRo4FBXFLw8HqM3GR5MsPvrsVz7XA1
10402	payment	1673	1673	144	1	1	0	337270000000	10000000	\N	E4Z2WL7Rj8NjhXTuGVLvWa26s2mRNhvDL133eXGrheXSwEo2NLT29	CkpZErCVd6Vgut3wXWHQNRMX9GxU3SKX6iV8gb9bdoFo4T9KtGhRU
10403	payment	1726	1726	1874	1	1	2852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBLa63JCC9kp1656QSDYZh6imddbSXBnxjAgiM3AfsWDM6zQ1
10404	payment	1726	1726	1874	1	1	2853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfmRRACu5FebfhQtn1j8eKFsjRkZUxV9BRcFMfa7Ag2E4fMkq
10405	payment	1397	1397	1678	1	1	5902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnTGcdjqqtSe4AnQjB8MjuHxHRVYWqA9amrrSp1rYM3KxPdUU
10407	payment	1726	1726	1874	1	1	2854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPf7KszwYtt3vCsex2Na4cgF9RD9MhEFWmhYgwLpTUs8utaNY
10408	payment	1397	1397	1678	1	1	5903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSygpc43sS8YzvzaAs29rmmj89JzHYLyQeH9gHTSpCXDqLNMmL
10436	payment	1773	1773	1293	1	1	23	3036669550220	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZCQt3odoXXjdEQ48feGBDgbobwBE6mHKNmQwHUPmegwGWFKane
10437	payment	1726	1726	1874	1	1	2864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHixaR3XAGbajU9t4nfxdZME1DFm38Fj5X8RWYeqQMsDvqoT5
10438	payment	1397	1397	1678	1	1	5913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9WYwyweBWt4hCmA93stEVptmsGumzinNXtKjX816qKJJ2JBV
10439	payment	1726	1726	1874	1	1	2865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNFz7m7cn7D1EeXGVTAwsE5meBrHC8GrZJCdB5uskGUuQAXAr
10440	payment	1726	1726	1874	1	1	2866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqADpVLM8htYyEo7rys1BFzY822mcFFKXPbs9KBCNCVFptD82
10441	payment	1397	1397	1678	1	1	5914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39YaM9GUYFx7mSFnzgj3dZyzdWzAaTTeZWiSYDoBXt3B4xAwJ
10442	payment	1397	1397	1678	1	1	5915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PwfNNnHaruWhjgMKWwwhtEktm3PFjjfF4fEpZ4CxCpWZZfif
10445	payment	1397	1397	1678	1	1	5917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEzeRx5rDZrrJVqu3hnZ96tGeieFXWM5wMDhrm4FcikyoFvAP
10446	payment	1397	1397	1678	1	1	5918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gbjAPyUXYRmDVX6AqxwhvVuv7hUVrZHZw16RYVmrvtmpn4fY
10447	payment	1726	1726	1874	1	1	2868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ETvExYBafVhrZBvBwQkq4tDySLPvrYaYpoMWHotgAizPit2W
10448	payment	1726	1726	1874	1	1	2869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPWEVWEr1AatMPQrG68N7hNnkFQ17gTENgzJ8Fb7f72P3obmG
10453	payment	1714	1714	1054	1	1	3	5208365077410	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	Ckpa9F64DSL2tkmpM4KAVwA1JcU7FQwWdZqjxy6mqHGNSnfd5HfaW
10454	payment	1714	1714	1174	1	1	4	3514187701728	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpaJJBW4PeXrbqs8kHWELDDXj1Wc95nTbTdHndHgSeQGB9fyfFPL
10455	payment	1714	1714	1300	1	1	5	9792596495022	100000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpYW4RxAUdHptKMZSjbfebcEh3CfCJCzS6eHvnazbab53RjELu7q
10456	payment	1397	1397	1678	1	1	5920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJwpGNaVWVpGENVf9VmuiC65kkDEuQwBoMsVVaaJwxWZXWZMH
10457	payment	1726	1726	1874	1	1	2871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRNY1FWi8W16rCmiFnuMvDtXd4fc46chCvLfZemHw7i55Sc1H
10471	payment	1773	1773	1293	1	1	23	3036669550220	10000000	\N	E4ZAVfjhtcnCrUCBPSR7ibQebMWaPc2csfwG52zY9wUVvE2NbSYoP	CkpYQYt85U7kNSrJFXwWqDvrEL9jMiVvoAdizBnBN2kDrnVxSnuys
10472	payment	1726	1726	1874	1	1	2878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaydjZ2k3QoRTpDkcWKNir6oh9Qx4dmRvrz9gfV3Ed5Bj9oHs
10473	payment	1397	1397	1678	1	1	5927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBn2DaPRZSrGKU7Vao5RDEwkgNU1Ggxw8wCybWPieei5z59Ey8
10474	payment	1397	1397	1678	1	1	5928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9VBw6ZS89f6TaAhwCDTchtc6GeSzm54dz3cB3eUVUg9FdKKN
10475	payment	1726	1726	1874	1	1	2879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYKFbhxCiespkwDVxzkAeaWxTzEJ2C7e7NrYM1rBzYzSRfajR
10476	payment	1726	1726	1874	1	1	2880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLasRsVbGZLZYv9ixr3dAP2B27Ya8dqzeCnaLXLLPqZRdnaw4D
10477	payment	1397	1397	1678	1	1	5929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqTUZXURFHiKZ5QWtC1UYXzzCCLABWdDfQzLDLkKW2qhE9FxF
10481	payment	1397	1397	1678	1	1	5931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshSJAmSr8AkbemsW3JeHEm2K3uWf8ytEHzmxHXkUv6MFtMMgM
10482	payment	1726	1726	1874	1	1	2882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Lb9XRQukx1Th9JNYszwDkcKfkzPxrCRdEVEwMM7UuyaviUKo
10487	payment	1397	1397	1678	1	1	5934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZYPHmCehCeWEjPZkGgTH5AqyyV8KgfPib2NKcExhF2r9ToHM
10488	payment	1726	1726	1874	1	1	2885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuBV4QHMBhokRbco8hqSmE3ZNN7iFuzEVpsTwvvZXBp5CAqA1
10479	payment	1714	1714	1590	1	1	6	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZER8iLuNoAEHNBAp2H7fmnGsuXc6s7i57BjCdqwSRZuGEsT3eS
10480	payment	1726	1726	1874	1	1	2881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzNyrLKoaf6SmNtdkKmMpnshW5x3TvuZMzVBLDF9g8zFZetp1
10489	payment	1397	1397	1678	1	1	5935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7zLQ2Ri2zMw6EVarNXuAk6HBQ8kvCPGbEzNL1MjJE49WoRf8
10490	payment	1726	1726	1874	1	1	2886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHN9biv5HwPPN7Mi8VRXqzXeoG1yMsBND58x5vWyfY74tL6sd
10505	payment	1726	1726	1874	1	1	2894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdXRNTE4Z8CKhvavZBgNdSo2uceonDjvZXVzkdz3mDGmgpYKv
10506	payment	1397	1397	1678	1	1	5943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzHfC3WiDXDGAshVT6xRaSWfMxQjewRWGkYRHQcoummdENqty
10507	payment	1726	1726	1874	1	1	2895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WS3T8dHVsMCPegLQq7wd5XD3mhwUSi9Wzs3Fus4Ln7QETJxh
10508	payment	1397	1397	1678	1	1	5944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnCxQr8xYa6DXjDNHxzUmaQxFdwKGacSKffeNoYn9bePMMNQi
10562	payment	1726	1726	1874	1	1	2917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmP4tmMXbrrxUyYZsb8Ss2E7eHEvPfagLDZUtuYr1DudjFSoM
10563	payment	1397	1397	1678	1	1	5967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8nXZbRqn5YseEAgv5d1ZPafJJGKRr4bqYKCJsXvECi4J3mmg
10593	payment	1397	1397	1678	1	1	5981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqHqfhtwq8tf8C6AKjJC6AsrH5vbPDQGiqJS7k7ZLck5XVRxD
10594	payment	1726	1726	1874	1	1	2932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQeVXZBYDT2PNLN65umMSiWZQze2sxfUo7nN5F4WjtpFRNzkA
10625	payment	1688	1688	786	1	1	7	9803361598000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZXMWvb1UuoLtTeGrK5yZrmDvTX3jWHqyo2Ttj5b5XZcc81chw6
10626	payment	1726	1726	1874	1	1	2945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5Sr1DwwgPSQ8cbi8xHYPfi2bRy4yPh7KmrREfsRpwgVRLecT
10627	payment	1688	1688	792	1	1	8	2450889968000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZsUfE2hS8YjpGwQqGN99oBFGK9ez4jmrdzC2i3CUGednnxUUit
10628	payment	1397	1397	1678	1	1	5994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKizDuhNsz2at3FdU63hLEvWeri1NiV1EMbWSgW2iHjHnnLS7H
10653	payment	1445	1445	1290	1	1	1	6452000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYC1dyKFqtyD9rXe3YiPYpggBHP5kDhTGRAigBqBmjBFurW2hx
10654	payment	1397	1397	1678	1	1	6002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeU9eWZaugncYrBn9JzGNVMAcqqxMbYrB892wndiWjaXmUQQNV
10655	payment	1726	1726	1874	1	1	2953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXX19pUUsdGeQGuJkZ31nKhtmE4GaLmVMJdCFm4gbMoAjJTnW
10656	payment	1445	1445	1044	1	1	2	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrvnXSKg25Ws1FcfzH9nWH6YWx59V2VKMJ9SV4LqJ36AXV6nu
10664	payment	1726	1726	1874	1	1	2956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8BvzbHdXzE2JMFsSvUYYJ8grBeEHoQxcGLzK5qDKC8RME3AR
10665	payment	1726	1726	1874	1	1	2957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZ58ge1o6LEk4HiEXGPciLT4gnNasHmunEiL2pDZAmJZ7a2oT
10666	payment	1677	1677	1395	1	1	0	249919890675000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEvKvPhpMrPTxN7Ggc8vbUBxNtPs3RXMtSicCJCmR2nwwN7uN9
10667	payment	1397	1397	1678	1	1	6006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnv1MFTcfgK5nJEWWz68KohA65JGNgaPaZK3MfKnd4ZCZJ3BgE
10668	payment	1397	1397	1678	1	1	6007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgcJqxWZ2TbopoCTa25ydQDe1YmWjTFAymkYWujFhf82EFHqo
10675	payment	295	295	2017	1	1	0	344200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskY5zCnoPw5MVnxJoJZLwFPf1WJswfDeoq3JJ9QsszHgRfQ9L
10676	payment	1397	1397	1678	1	1	6010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoubMcDor3Zz12segJfRZQbgFNuyZ4QpPxDwW4ihe6pmSsDfVX
10677	payment	1397	1397	1678	1	1	6011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByjYi2mTeh64u51spNiiLxQJVcSFDXZbSrqP8yBGugdk74Kz5
10678	payment	1679	1679	841	1	1	1	441936090000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaEuoYzxJ31vPFRv2h9V9TKST6X9VwnKy8hKCud2YLTsw39sNtN
10679	payment	1679	1679	843	1	1	2	823928232000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ8noACZp6je8Rk43Ng9kNzNWLFjSushHLqPQnfThr9KL6hzs9Q
10680	payment	1679	1679	849	1	1	3	6100212524000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaCexPSaAMB3YiF1zwbYaaTA2tadVhJ86ViPFWBjKRKkR4na1bp
10681	payment	1679	1679	851	1	1	4	11817032227000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZh8HXStYcPSroG9E6nwQrLx3b5mBgXSHTZhv5S3oB1cEcwaRrM
10682	payment	1679	1679	853	1	1	5	1303017940000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYuunqhw8aDtmeYaBKZXP5UvnoK9Rh3RQKSQ3hkCFhWZ9vYLpyC
10683	payment	1726	1726	1874	1	1	2960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJQTadzKvgDyF3SjxHMEMcKwLNcsQiao4jphHWUu16HdE5S5wy
10684	payment	1726	1726	1874	1	1	2961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ih9KwVNYQ4LQWJnXESdHsPjnGTphbFgeDcQriwQohZEcsBQK
10749	payment	295	295	1483	1	1	1	0	100000000	\N	E4ZRkoynDwC5RjaPrhegBZ8F24t6ywVM8icWn4LbKzyCe2iu9Y7f4	CkpYrVERFAGUTe6W8qvQh5JeDYjUZQBiukCsXuRHsh5n1xCkNcqc3
10750	payment	1726	1726	1874	1	1	2979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNiKM5PpaP8YQMU1tYJwjenuukvCUqozgwzvV455vCcjuFTev
10751	payment	1397	1397	1678	1	1	6026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZLGFmLxf2im9DYWeLdmpmtJ5ygyAWedPCpDYpjbDTiDMteTh
10497	payment	1397	1397	1678	1	1	5939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAVCYGYRR4SoVCcvnF2S3FL5um8JSP8RgXN51gW6HoU7ZgTxj
10498	payment	1726	1726	1874	1	1	2890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3ZCzjac4mMNDHHF24UUTu645cJGU1bkdWeYdZVEehdCZwmN2
10503	payment	1726	1726	1874	1	1	2893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhv8n5d5WfvvCxYyRy52sFqX1Jc8ipGgLdPWjhHsGT4P6xWYG
10504	payment	1397	1397	1678	1	1	5942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSWDHPq2rvWHhzEy116zzjpk4eqPXi7tTV4UzDKSsCeHE25NA
10515	payment	333	333	2015	1	1	0	10000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmMxnHTjZ3RytHWh19ft9NN67bAVAy76S9ZMZFJfximeScnFy
10516	payment	1397	1397	1678	1	1	5948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FVJ55DCnMvqGPVYY2hyga9D69YNgQLVRPAEjiiZvE2itLDE8
10517	payment	1726	1726	1874	1	1	2899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3gzZBMdm62dk7FTVdjzQKFU8irc4iTYy8hBKogkqRVahz1wq
10518	payment	1726	1726	1874	1	1	2900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsp3oRam6Haj6DCjU9CTpYCNnQSbiqYGZ6pveSpBHtfgwndJ7
10519	payment	1397	1397	1678	1	1	5949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFfduftGi8EX8Tt31cvjGRogKwaSe7v36miRPpuvpYzWBfKwp
10522	payment	1650	1650	535	1	1	0	1000000000	1000000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqpt1Z4mrrmGm5Y2RdBBrcFwsD4zWYF4EJmvmsLKsFBkeMta1
10523	payment	1726	1726	1874	1	1	2902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQV2qTznSkoZ77nTyonZk7ZBzyN3qUci8UQCMMEyPJZND7MLNY
10524	payment	1726	1726	1874	1	1	2903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGwJRuAUJZhAgkLUP5rkwy9Ut8AViwNH5JAMPxnZHnHkTjtbE
10525	payment	1397	1397	1678	1	1	5951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfrUGetihNGDk9bkQcUTyeWZrwaKnkuRrTaog1C8KmWpaDkcE
10526	payment	1397	1397	1678	1	1	5952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfw2wLgse4K7aFqqgvTVcJ3KrM4TeFbcUayB1npaBjdksYBaVJ
10542	payment	1726	1726	1874	1	1	2908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9P2sRxNJsWDGzXBa2b1vZQf4ZNjuUdZASeygN7tP89Qh9gUF
10543	payment	1726	1726	1874	1	1	2909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjoPSfiBUayWqR4R7jrHi1P4C2urjeLcCwa4reTWqUivyv7nu
10544	payment	1397	1397	1678	1	1	5958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwSFxsNd67u438SgfxWZPvapHeb8QEcZbboYtNP4r5rWiqh3x
10545	payment	1397	1397	1678	1	1	5959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXdAtmz5rc9y2NPB11hDCUAmUeGwAdMuozGr3SLo8kkJtYovG
10551	payment	1397	1397	1678	1	1	5962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWFRsfsUE78ST7ijkmMBVyuvWRHVBfsPQtRr3Bp99RFVFawH8
10552	payment	1726	1726	1874	1	1	2912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHnCoij9ynosZG9wB7LLo7oxcAKWy2EUXsyT6fufaaV6HtRbv
10556	payment	1726	1726	1874	1	1	2914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYyZixUmaWyU2MDi36uNiiCdBpJuYqkqqtCeVZxQ2qGMptRWb
10557	payment	1726	1726	1874	1	1	2915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUGhCFBmwpA5z2T8JihM6ckJGtAeFX1CNeLiNzz2DqXhBCecu
10558	payment	1397	1397	1678	1	1	5964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZur5ENn62NKBhQL6PEoH9wARNWzq8VSN674Jz7maXd5xpKTcKX
10559	payment	1397	1397	1678	1	1	5965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yREwkPDbkRNYFQcQWPjdpkAhV4U7ThptsKWkSBP5iDJptgRq
10568	payment	1672	1672	2016	1	1	4	1005000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvssH13rhXGwhwYPCv7Saoqj7zig19R5QpwnNeVVCAZZxNFKUz
10569	payment	1726	1726	1874	1	1	2920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2t77Efrdk2p6iSF6mwVT5ooZysA8VW3BEtJC698j3ZbeeDAFw
10570	payment	1397	1397	1678	1	1	5970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2w3eGjwCqrB2EYnJ7QUYB1uv6znHLxu9omtxxAp3oGBZareF8
10571	payment	1726	1726	1874	1	1	2921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9zrTy2ZJzH2BP7zLDeAEtWKSgSL2GpsFvXLT4eTfHsRJR8ZF
10572	payment	1726	1726	1874	1	1	2922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHodzMAWbNbne5Qw9NfwhhkbXokTMR9xtg2t5Nx7oUPMo1gMH8
10573	payment	1397	1397	1678	1	1	5971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6rtmRYSk6vmGzcKc7kkK9yyvzkUwtCnmWxfCv6cwDxxa6DWe
10595	payment	1397	1397	1678	1	1	5982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CTdUtJu2ggTfxWPwvHe8vcz44pnvEH1yikMbW9jNjBd4SwMG
10596	payment	1726	1726	1874	1	1	2933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDyVh1QMDDDFQSqwrR6VTLZbB82WPPPkK7gYSBUKQAwekxCcY
10597	payment	1397	1397	1678	1	1	5983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTAVgvujhDS8PY9WfTaPXQpim6om31EhLirATyPBuzXp42nYpo
10598	payment	1688	1688	31	1	1	1	5288248766000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZFVwwnazsVWgpyMiS3zLXofTKy3VVMmzYggRA5gQwNH7G1DKnL
10599	payment	1397	1397	1678	1	1	5984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZPru4ahQoYe6iipqudNNVmyuLXGFaMeTcrrUj9nnWUeWQBDD
10600	payment	1397	1397	1678	1	1	5985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEYUT6WpwEimx4cxG8xUve12wqgbC2fdmTuiVcustVKz5afyJ
10601	payment	1726	1726	1874	1	1	2934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqracJqV4FDK42syEJZ5t4CXKdfpyMcUyZSivcw6QFAXiHgJP
10602	payment	1726	1726	1874	1	1	2935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGhicCGwjmAz22XW5rrUWNX88LXTaouohiHSdHzvWfYCPspxB
10499	payment	1397	1397	1678	1	1	5940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWveFaL47is66mqUTRmhTq5RooJnT1NPjWEbUTD2qUG7PTS6a
10500	payment	1726	1726	1874	1	1	2891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eQusA9iP3x84PdG1T1vUEYp5CprnxRSPsL72BLgSxJXkcvyR
10546	payment	333	333	2015	1	1	1	324800000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdBUFYpUUNLu1iyDbpFKajJfaaiUyBATDbyXvxsGsMreMJPCA
10547	payment	1726	1726	1874	1	1	2910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLJ5Jv54JdNtkg8TFgq9uuPxvw1vJoFDzo9EnTyehJ1kWJNyD
10548	payment	1397	1397	1678	1	1	5960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LCsqt5oW8aiJkMgPninPsfu3NcJfgBJdrwd6hika2BkLJC87
10553	payment	1726	1726	1874	1	1	2913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1zEEGcJYCURXrE2swj2V6xcrtiowAEazPaWwKZhgksaYgvRP
10554	payment	1397	1397	1678	1	1	5963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGa61evGrjFK6TSyyfrW2pnH3JoqnRZQhQe9ChETMJsDUSdQUm
10555	payment	1422	1422	1337	1	1	3	7500299770800	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZFe7md56GiTxt2Genfisy6G9RQHxx9zZ5J14V6TFUphh9sy5CZ
10560	payment	1726	1726	1874	1	1	2916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRucnDBSmTwBXZRktXyyHjjFsJjupdSuEo3DnW8nTRAk3ziY7q
10561	payment	1397	1397	1678	1	1	5966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhEQWgoAS4CieivCGyn66RvDgFuJRg3NBRYDHtELgq9gmLd8J
10564	payment	1726	1726	1874	1	1	2918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8HLz32pAcz6EcMhAj8W8sHFRVzBcxRABHUXnokc1xpenw26s
10565	payment	1397	1397	1678	1	1	5968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa627Jj7wj7wG9NjJ8X7rWaDkRA4dq1ai223CbsBGWTNWuK3Nxx
10574	payment	1726	1726	1874	1	1	2923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHFVQLcyiCvovLbPqLoryDCcmZq72LpPTtgdM5EFxTMyQcRfF
10575	payment	1397	1397	1678	1	1	5972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8g5AAgy6qisygutEyRixA3zgJScvepDCCp6TJbXehBeRXwpK
10576	payment	1726	1726	1874	1	1	2924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZ6yUoDfT8XAXZn1vLYpHtSFVvThHtgiHwBvWijsztvT5hk24
10577	payment	1397	1397	1678	1	1	5973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XMSsB3Aypi7b6np9tB47JasNfAEa7YryZTwaM6bq9RHfkjQk
10578	payment	1397	1397	1678	1	1	5974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDirpK9eXNNwiFVxxneiWJVisE9XTJGLU3LSjqsu33tnPUuTGV
10579	payment	1397	1397	1678	1	1	5975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJon5qy6W4Mqv4ytWWfdb8pFV8bWvfPdYX5iGwyXUch8YsevF
10580	payment	1726	1726	1874	1	1	2925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SEi5Xs7Z1e662FRjp9KmS5rhpPWMbjmmDf3JU1d8kbHyAJbe
10581	payment	1726	1726	1874	1	1	2926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyhTDMK5Fzmd31X9oGmooPeTKp7REVXpbCifgU3GrFuy9Us8r
10582	payment	1397	1397	1678	1	1	5976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UbmxhbWTEXEMfeuXtgc6S6KbdBaVPYwKXvLU2Q7SEhs3KZiG
10583	payment	1726	1726	1874	1	1	2927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZsxZEZxwYg15NHPrF5oj6CA8mUKH6MFjXd6jaLDxjAUiYKER
10604	payment	1397	1397	1678	1	1	5986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquDCZE4ECe4rLf64FwDjrut9P1Vzy39Lq1A38ZVsGj229d6ds
10605	payment	1688	1688	32	1	1	2	295280157000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpYt1PaBVGuRU6VdLUoEZgxBdKbwfmD6zx6Cnv9N6Zpxt2upsVLB
10606	payment	1726	1726	1874	1	1	2937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKchABHaMSxmVU1zBT9QC7gLnScjNbLTfacf7YpM6x6o9tA7C
10607	payment	1397	1397	1678	1	1	5987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbqtxGUB5NV5YmVMjR53eWtAUrbmCdz5M9q6fZ5RQ6gjmf2WNh
10608	payment	1726	1726	1874	1	1	2938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFdBfVaaMEmW5K1d9x662Xv6A5jV61oXUsJkuUNUCLJ288yN3
10629	payment	1726	1726	1874	1	1	2946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TWrPHWuLobzAGqUuxiSmGJDjvcEh8ZtnkMZhw26TPxH4Dg8P
10630	payment	1397	1397	1678	1	1	5995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZz1tpwz5H7bZjducwGynGLE4Qsc3UdiCAHafSCGfrvvefceA
10631	payment	1397	1397	1678	1	1	5996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3UCAuJA1kGLx2T6Nnca5F7r6p3tumwXfidtswMP2mGAbu3xg
10632	payment	1397	1397	1678	1	1	5997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUm2jaWs2VC9K2ijRqzzPMe7FanS7aa1ugvjggb71fzUWXaYna
10633	payment	1688	1688	791	1	1	9	222808373000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZvr1kFKWfHiBocVccsQESNpDvUyeC8UjbYFnzTo2mRHRZEcdB1
10634	payment	1688	1688	799	1	1	10	55697102000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZE7BUpLjBhrR2jpayDmGtUms8fbE6hfvSFUB7bbCc2H1P9FzGH
10635	payment	1688	1688	800	1	1	11	612667593000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfbN4odNqDuwyjbRQawYbkstukmjUmGCY9x3BUr7ggGtjwWUBz
10636	payment	1688	1688	801	1	1	12	55707407000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZN8ivHxteVCn6t7mRCbm3gHjw9P77bpnHPvXZDX6oMuN1jmoe2
10637	payment	1397	1397	1678	1	1	5998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAULJCFcNn4tUtBFmUCw8DB51SUcCebHRvgdZxVX2WMq5MKpT
10638	payment	1726	1726	1874	1	1	2947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LUWQND6tRa7YXRFFL6fEWKFybxVYHKe65S4Kx9S31mSxtUjs
10639	payment	1726	1726	1874	1	1	2948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRRoBJ5xL9QGiNH7aAvGYmucAbQVhdLLBjGR2zP5kdMEpMyCU
10521	payment	1397	1397	1678	1	1	5950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjT2EUs1B4PLgRYzNTvSiLspTkRCCR9xHJfw4FDWDnKjxiv2xr
10527	payment	2002	2002	558	1	1	0	3990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJzij8NFwCqFUaiNFjrNdKkxrMUXRWgFRLE8hvB9jZ8ugCg63
10528	payment	1726	1726	1874	1	1	2904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZdTrmB4wULbq7qCDP2XSThP82AM9QfVdmGz5Y3jJyL4Lg85Y
10529	payment	1397	1397	1678	1	1	5953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Tp6esovBZi4A9NoRjvPoXj8akGCfCFSVSFCKhW7VL6mEegq5
10530	payment	1397	1397	1678	1	1	5954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCiKoxPE9aG6fHQiYraGHWum1dp4yWEinnEUJroVx5tAVsKtHA
10531	payment	1397	1397	1678	1	1	5955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGUDWzkxo41DARqsHuUkWBXSMxzCZfW39CAweFhuqr2pjnnpJ
10532	payment	1397	1397	1678	1	1	5956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSq5TZ9ofY2xqN7qixttWqB4awKiSVUcHb1bcQgNso5oy2Zhhe
10533	payment	1726	1726	1874	1	1	2905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkkstDTw7YQcmWPMPt9ecVKfyzHR99L7CQ1er4UxgRMHSWaHs
10534	payment	1726	1726	1874	1	1	2906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFPc3bGe7Bov9UUpmWmzKm5nfCAn9ZHdu21CmZexFe4SDxP6K
10535	payment	1422	1422	715	1	1	2	8389376502	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZVUAk8GE5PLGyGtr3n9Dn9oE5F5EiKhwvQuRGDswzqmFLLe4bM
10536	payment	1650	1650	1009	1	1	1	1558000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cYMFwPsJjnecCPYJpurQCozqYRr6z5riwL6KjpBMjuuhJV2P
10537	payment	1650	1650	1129	1	1	2	2792000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwW9T3bYJNQ9j8p8Zd1t5BkHbm9FgdGp31yMEU9K6bLXvPPgc
10538	payment	1650	1650	1249	1	1	3	1884000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuiy7JGyoQDBd2BdejAUsr97aYm8ygJ7M9C7Tsuu2uFF6KxFV
10539	payment	1650	1650	1375	1	1	4	5250000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzJP8XH3vXvys83QUh7DZW9ftkndmVrumvurdRczb5pcsiYMc
10540	payment	1726	1726	1874	1	1	2907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc8EXanyirvQMsEjs71xjpJDyzHHVP4KKjHk6ZZ6oCrdECFu7K
10541	payment	1397	1397	1678	1	1	5957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPWqF6oiEk4v6kd2az3RNoPwHEKzi3pcAaG7ytQWUC6uNEFa4
10549	payment	1397	1397	1678	1	1	5961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgedSETUaddxUv7dYM2QrhYcyDypEpkeXLewR3ejArvJDa25YD
10550	payment	1726	1726	1874	1	1	2911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoeZJW2cWzee3i83fsFgFJBDK1hxLDi5PHYYW25UtRDfgBZfhk
10566	payment	1397	1397	1678	1	1	5969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAjNzYz5wnVDpFshMGKJpbZvqJggqUYkobMcu3J8FJD91uAJX
10567	payment	1726	1726	1874	1	1	2919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmda5Gzwb2zu6saUXxVspufdo57uog5GrB8whSxaX7qAqdNEQF
10584	payment	1397	1397	1678	1	1	5977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCA7TNjWNcTqukBTgUTXzZQqMKNuGbauy64Lxa8qWpbGSRWtC
10585	payment	1726	1726	1874	1	1	2928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjsAG4JKkQ3PnLukFZPFJLB8HPSzcPPSn2GstSDbcxNxkzzSDh
10586	payment	1397	1397	1678	1	1	5978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysrseyY141gCMbP4LeyG7aQgaeCyqw3EjtLPnmAM1wsgd3KkN
10587	payment	1726	1726	1874	1	1	2929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uuWUhzEjUkgibDdGKTY6sSGdL3sUxErnPtSsJ4tGXUQFgqKD
10588	payment	1726	1726	1874	1	1	2930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVxdVbVMeNoNvnNcn6peKeJgdLzG1pA1gw52mJrvUrDpAWSq8
10589	payment	1688	1688	40	1	1	0	264692170000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZ9ddf3kGJbfpavUUECoQCXzjtv3PkyrHZoX8mdFKb19Jhj3xxQ
10590	payment	1726	1726	1874	1	1	2931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4AWJT4SFGbQubCptEkJQPGYk3H93Jdb5Ma9NREYwVKJB6XR2
10591	payment	1397	1397	1678	1	1	5979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwBvk99bmtrxb7jcYkp7PdEunoeBPzWhUGYRsUg2wi7cmX7JC
10592	payment	1397	1397	1678	1	1	5980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdynBKuxTEaieVheBxkpLbtagVqRZE39agVZbuAM6shoY7WBf6
10609	payment	1726	1726	1874	1	1	2939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbULraygc4f3RLyGkPHYrqEc5v2gybdwjHytYG1zem4ZMZc3xu
10610	payment	1397	1397	1678	1	1	5988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnikQrCnF9hZw8zxx1LNfbkHNMYksnxGKq4j6iciiZ3K4rZSZ6
10611	payment	1688	1688	779	1	1	3	111404186000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZxAQ1hoDqSEHLiPoe4L8oA482MsbjVdrgit8Nban5XD2rkJAxo
10648	payment	1397	1397	1678	1	1	6000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNtJgroa4bzYNshuuyonZWNHViZAp3vY8boYWW5emie2WTrNo
10649	payment	1445	1445	480	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2eNiPPimT4GUynr4pNt2Bi8GBV3TwDdf9yH1Nrx4tGM5onVP
10650	payment	1726	1726	1874	1	1	2951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmja9uWX8rJZzTbDJ92NtZSTE77rt9quz1PF8nATWU9sqhXWGq
10652	payment	1726	1726	1874	1	1	2952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmoU2Gw9pgGvnWedyBDZJAYN9BPkwkZRtQJrh79rcvnUeAGcm
10661	payment	1683	1683	1393	1	1	0	746941148850000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYqMzX5raicPws2yppeqYEK6WBK3sms8uxX2eZRJrYVVDhjDcsu
10662	payment	1726	1726	1874	1	1	2955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzffx9a2fAseMJR7NmeVQicPsjQmgk5HVygbhzWtSiakTSA2Zh
10603	payment	1726	1726	1874	1	1	2936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5BRv2Yv5NbMGPxueFh3j7KcW5uRCuxuk2LQT79fLkQ23PZq2q
10612	payment	1688	1688	780	1	1	4	1225444984000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpZNgi65wNa9NpZcYfbYjb5rT96FnfHZg9MEFMuAuDZYMjKo6uXi
10613	payment	1726	1726	1874	1	1	2940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymhFw3YvHtYmPBaLzyLkwSmk9d2ca7ZvqDnHo59agjwr5bMLo
10614	payment	1726	1726	1874	1	1	2941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTBHuF7BrVJ4A8ooRyT2xjwMmzCA1Mr25UBCw6aQ1x5MnuLgQ
10615	payment	1726	1726	1874	1	1	2942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenZhMUufggMcfWSZ6aSyDWrTNvFascCYxmWC67iZdkEJmvtff
10616	payment	1726	1726	1874	1	1	2943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa589gwkSjjhWGfPk4WNmdykwN4Hx9mLMvkojRTM67n5n2Vx9cW
10617	payment	1688	1688	782	1	1	5	9803361598000	10000000	\N	E4YX2dcnk2evhkzDUWQmrKR9TisLxZWsNsckMDVfMdGTAJUxKqHgV	CkpaFWVAjkcCEts4ZgwbusaKYZhHw5X7yn6QQXUK2Jk11UxaAtk1f
10618	payment	1688	1688	785	1	1	6	891215468000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaAWqgjGmJaSXAveU8bjfqKhb6BoTNGL1wjExFmaGcr2oGd5RY5
10619	payment	1397	1397	1678	1	1	5989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKgUuZaefMk1jARE5ZNMvtoV6xykjjcWrj9Lvgf3pw6zAYSc1
10620	payment	1397	1397	1678	1	1	5990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZtAff3FNmRPcSjw5pfWreZEbrthBAxh3mLbh6uLMg8YQ3Do5
10621	payment	1397	1397	1678	1	1	5991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87PRuEGKpCZbfe1DxjKzvir9xG85FX4Mv4sx1QDzzrFLs7kMN
10622	payment	1397	1397	1678	1	1	5992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsjNsNgri3r4pyZNGCG9BSRF9GRDCqFsNFcWDmBjjWgCyxNJp
10623	payment	1397	1397	1678	1	1	5993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGb7fkU6MDEZhmPFeJ8kHBQLuTJVwQDaJttDdNgdzgFAYYvjV
10624	payment	1726	1726	1874	1	1	2944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRB8Yxpj7qoYQcrLdh9M1wPgfgCkVt7DnfXNcZ33wtYwCwCRUi
10651	payment	1397	1397	1678	1	1	6001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmkfXMuhWU8K7dBCRVivebuCW88TH6tD5cxwJvRgseFSZi2yW
10657	payment	1397	1397	1678	1	1	6003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXa7U4RYeEmxNpVECY4yeQcAgbDv2JY36xE155zQ49X1zVbFm
10658	payment	1726	1726	1874	1	1	2954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJ5qfy3yjSQByJfiDHtfF5shrqHoqedZ1jZkbEZUceZJjpwUs
10659	payment	1445	1445	1164	1	1	3	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtm5K7oJypraMpWbTqqHcJ19vpj4vpmmW7eCtfZrjmQsSYCqB
10660	payment	1397	1397	1678	1	1	6004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sziknyViPxcsm3C4Rg9Qh2EksMjUCYye5pETW3jDmQuzrnuJ
10669	payment	1397	1397	1678	1	1	6008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PUPFjFnRoNwminjExkXeTQN3nepg6E8cKnDPYq7Hx93Eqw9Z
10670	payment	1726	1726	1874	1	1	2958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGhjamMct1CCjVkedCwiznbuDkQoZ1WdqVrLe82jC6mmyBzgA1
10672	payment	1679	1679	1	1	1	0	1974383793000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnTD2ZSS9RnVbsW7ebvUGRhTg28RUQzM2rLa6t6bwtQ4p92TdH
10673	payment	1726	1726	1874	1	1	2959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmPCtLUJxkRrDBh8A9NGAYDWFvALQM3SPYFGtkrB4XAyJKDjs
10674	payment	1397	1397	1678	1	1	6009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oxyriiv2X4P2PM5ELrv4rYFsCyaGZ9zme7rA1UjQebJL9v4k
10685	payment	1726	1726	1874	1	1	2962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSA9WHUwrvyHnF53PC4DLpXxNr4mXE4AW7B1PVjZBzYMuEMmqk
10686	payment	1679	1679	855	1	1	6	689247656000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZo13VnMvvjFGHRCqAzH9D98W44uBXeBfZvrJKncnkPPbExKBgC
10687	payment	1726	1726	1874	1	1	2963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNFn3P3E9CpsVGM65kcAwo9ntgj48WsMD8AH1sbYRekmy61ci
10688	payment	1679	1679	857	1	1	7	1737927666000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa4scsMQXt1hJBfdt3BXBG9oiZ3Kn5ShfGyVHBW1876Lm236QUL
10689	payment	1679	1679	861	1	1	8	2400483216000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ6EKEndYkeVVkjZkzPqKjjz8E4rtJirhe9uV3ejkDa75PQeVVJ
10690	payment	1679	1679	865	1	1	9	2107354902000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZihN47wZdkpE81BxmFsDrAUzeJdtPmkiTca7SnQ2ADLmCGGkLU
10691	payment	1679	1679	867	1	1	10	12834266702000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYSiHhNLpTD6xSx9qqG6oXvLHdfC8UqjMkMVL2gqTYMd9BDPuWP
10692	payment	1679	1679	869	1	1	11	1372525001000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5Z2qiG88eyjFQSpLxhnCWYAbxxM6maszMdXzVnemNi4Aktdi2
10693	payment	1726	1726	2018	1	1	2964	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDs6mjXsAxe69AUGCqZhRD1PLyEizHK5CqejkBScinkkZoWYSF
10694	payment	1726	1726	2019	1	1	2965	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZg1Zb2nSe71zuBw6DgDyGrEqB6os3dz8enY7mvdBbw6AmsU3iv
10695	payment	1726	1726	2020	1	1	2966	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhuqe8F4MWS1nP56WeuetJhTZ7LLJZeDKuF5haUzQeuPMbUfjh
10696	payment	1397	1397	1678	1	1	6012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTTsewjfHbH7g9gLaVhhdDvEP1n8ro1NAeThmue2E9pZhsdd4
10697	payment	1397	1397	1678	1	1	6013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQhGZDGeEt9ybpznw5LSLheg5zZaD98hMQ8ypWFAvAP4R8gdj
10704	payment	1397	1397	1678	1	1	6015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFdGysZtNBgoSYE7oQiVuPpNZEytsTD5XffmAew3bLTdJkfsT
10640	payment	1726	1726	1874	1	1	2949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8acf4nq8ek78H13yyRSHjfz9uNemKVCu4hzBv8GBemNjUFUMv
10641	payment	1688	1688	802	1	1	13	612780945000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa84ta1sdX3njeMSCe3oJxjkWNfHuGgDik1jxzCgv9PdAdVT7di
10642	payment	1688	1688	811	1	1	14	431127745000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZkJCemr5c5qbqkCbabUVxyyHzJiLdJc8gWQo94QabWCU8gKkf1
10643	payment	1688	1688	812	1	1	15	4742401062000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZQVXurYFfrpbm6NVygkhHJUKwvmxCrpCXKzYp8g7Xsh9rkCpf2
10644	payment	1688	1688	823	1	1	16	6918098282000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaD3YJyUPv9LUtsekMZg7nNPubMb6ow87T5XQpnsLFGa2LFLZ38
10645	payment	1688	1688	824	1	1	17	76099014692000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZTJYdE3yV46Pmu1SbrRNwMuqZrDPn19Apyc6aQSVUh9HthAW8m
10646	payment	1726	1726	1874	1	1	2950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWrTpCmZBpsmAxVfHVcBrimTfKQCaLuLKAAne1dSEReFeFo43
10647	payment	1397	1397	1678	1	1	5999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBc32Mgnjh1kkTZ1WMsjTVpRFhFkphgnjETEd2nD5pPnchKoAW
10724	payment	1726	1726	1874	1	1	2974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJyYqReu3cfi5jGBs6DurTobhVx2xZz9RLyu6S3uC2m7HEjnb
10725	payment	1397	1397	1678	1	1	6021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiRinBLek2pjuDF7oCUTAGzHkrCSeVBS6QWBNBQKNNpMLcJto
10726	payment	1397	1397	1678	1	1	6022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXYbnSbN7HDi1wBBY24LHBDnMBdmZjng8M2MfZEgpRGWnkBsH
10727	payment	1726	1726	1874	1	1	2975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtghREYaDJZTC5JM7nwQf6rdX1w92ZacLBusdy7S1puLe1vKe1
10752	payment	1397	1397	1678	1	1	6027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHMUmDALBdtnRNs4Lu1iJ1E1McMUcQWnAjGLjsSjQnnhBd2wt
10753	payment	1726	1726	1874	1	1	2980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUbVZv48JsJDZyoFgiUeZdSZ5wpErsQBNgVstS2FjXcxDXgmV
10759	payment	1698	1698	2023	1	1	1	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCSS6AN2wt5ZEJwe6xyaqQTagwEiCpAjcoVGN7zmiRW51Kjd8
10760	payment	1726	1726	1874	1	1	2983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSiNHfQzNpBR9PHfJR1NVAPq9gNstkiGDteqNgAgyZQa6qCP3
10761	payment	1397	1397	1678	1	1	6030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UAhZ8rcE5CDnCE6Mq2XTy3nBAnt1cAC3uwZ9XPGFvgEjhqcG
10762	payment	1397	1397	1678	1	1	6031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2U5p1gQwxkmv6pz4kG5o1MAbQaYrMoG4QjaBmod5rSkNhjjzg
10763	payment	1726	1726	1874	1	1	2984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGy2rpjz88YZKmPcvyd9J4cKtws22V7j1MUb21gaBjiL4XhwaQ
10764	payment	1397	1397	1678	1	1	6032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2p6dKrQDt2aHh9kbhnm8qSxgSkf8J3ejuf2ydYEmFQqgpAw3j
10765	payment	1397	1397	1678	1	1	6033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijdB6rEmFbpxvNC8UG8RZ8LJTNGZjAV8NpufN8orVt6nPqyR3
10766	payment	1397	1397	1678	1	1	6034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrnLyKxn28UmGB6vFrMCauQLMZ7GZnuYwMFL6Uezmps6LVXBE
10767	payment	1726	1726	1874	1	1	2985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7f8Axf7nnSPJuuGegqw3v77Y9hfkPvXTMeYYUsXb9mq9cTDTm
10768	payment	1726	1726	1874	1	1	2986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cHhNjHp1mM2naanJL3QwBjt3rVPVKP17qsqW9L92UVy444Jr
10769	payment	1726	1726	1874	1	1	2987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Lf5hSgzZu6y47Jv4BZGQixGq1vMQHjYbHhZS3ANW6wD8fb52
10770	payment	1726	1726	1874	1	1	2988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBzukJktdiSufbWB66kinLtF2CUH6YSQmVc1GYhxrbrDYTUUN
10771	payment	1397	1397	1678	1	1	6035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHo83BbbDsXLHxT5D87rAMaTSfRVVUgAgiz5UwZcBtCNbg5hPg
10772	payment	1397	1397	1678	1	1	6036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvR7P671G11XWTeYB57dy9UrxcRau4DJPg3ZVwxrcXLQfzxaZ
10773	payment	1397	1397	1678	1	1	6037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrv6nFLiVm6RRhWjNtY1rQUhHRjEbQGBuy3LLYWacBaQCy26vq
10774	payment	1397	1397	1678	1	1	6038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzkncjz2k7CTzHRHxarinZXrrW4cjtTqsR2VjnMscQruGj58o
10775	payment	1397	1397	1678	1	1	6039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pMFnFzEzo1P8JPF4K7UNbFEf2s65rJ1f8aQs858vfFzZRHsa
10776	payment	1726	1726	1874	1	1	2989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cL1FAsYt4gD6PFXbWBvoS6kn1cb1BCAsZSxMSV7VoVLYT3dJ
10777	payment	1726	1726	1874	1	1	2990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryh5AriAPk19SZpxCX2vfJgGY8tAQ4ywfp1fLCww9zp3fQ5TU
10778	payment	1726	1726	1874	1	1	2991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBMsRqECjnMPR6Vx4d3PGZ6SyN51RhGuMoyj73dchXVwTHShD
10803	payment	1726	1726	1874	1	1	2998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFF9RfEuKvuGkxHUS5Eqh31vzvvbPBcU4y6UF6MUzvATxx5sq
10817	payment	1726	1726	1874	1	1	3002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcW6zXK1Pj7PgWWLpNfCtVrZWhVUZ9R8DbUhx3CsXd353SGwx3
10818	payment	1726	1726	1874	1	1	3003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEgMm5461nZmzKF5GMG6xJjzUs8p6SbPP88B13jwQCM3qhRSL
10819	payment	1397	1397	1678	1	1	6049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByCU6cy5f6LR4Nf6hKAo8Aj5T8CjcmCt9YkSBSPYRjys4MqaW
10663	payment	1397	1397	1678	1	1	6005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHjcPPSDDbkNCyzXTyPjaxwAcAcQiyrWghr7q24t9WyHZPVBA
10671	payment	1445	1445	924	1	1	4	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5F3ooqCw6CrV7yfppJdRgik9uzQzV7WA3GpAzjFaYwvq85SrG
10698	delegation	2017	2017	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEGbjtAaatFGLQAaPriy8B3jVDGFFj51DBpATefako4ue9io3
10699	payment	1397	1397	1678	1	1	6014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMpRoK1AV2dmzDdXwFxnqRH7LZHiyWHxMPY7etmfH5JazQ6PW
10700	payment	1679	1679	873	1	1	12	12834266702000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZBsha4PaHaY9Rboxc6BkVavdaABDWnVN62vLNUT77K3CCKaKos
10701	payment	1726	1726	1874	1	1	2967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkRXrRZwWyYnnJJaZiHxHG89fEBUGFRmKHS77HxBzB37a7DdF
10702	payment	1679	1679	875	1	1	13	1124978933000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaF3mV2mkynryqnWAZ1zYCN38vvpKCKHvf3Z9BS3k57Lvysxhfp
10703	payment	1679	1679	879	1	1	14	713014817000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZVoMMCBXkDWoKg337CrfKk3dsoytzu44wKzpEoMg5nye4ro6Ko
10728	payment	2017	2017	295	1	1	1	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumvqYUidxLVnXpgrJ7gW4XZ1fmC3o8n6sXM1VtHzQtGLFm1dk
10729	payment	1447	1447	1345	1	1	1	9145236398000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZPYELWf4cJC7vCRzg6d8d3AnDibS4SDS8uwXs7uff3o5cHy5EQ
10730	payment	1447	1447	1099	1	1	2	4864055198000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZZA4LiWKRq1zDP2CXR5ZQUohQZyWWieZaD1QHNGTxtKLe6845T
10731	payment	1397	1397	1678	1	1	6023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BYo8J5eAptrAisic3C2pbtnTrujq2VGKphPztmjsk9rT2iiX
10732	payment	1397	1397	1678	1	1	6024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSuk2QoxfWNnTttyy4fJAK9Tu4F2CTZamqq6ueauwYGpjeVEXs
10733	payment	1447	1447	1219	1	1	3	3281874965000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpaBTD8PbhoRspmtt2z97vGgWNBDPJNMHP1AxB9xaKcvp4ycMTkB
10734	payment	1447	1447	979	1	1	4	2714329495000	10000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZFpsFpuyzSnUHNYFmuZawoX7VTAeGspZ96ZTtitowmtfdEvAGP
10735	payment	1726	1726	1874	1	1	2976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKSNRC4NCZFEjrhYFR6ZVoNpniYg1Rn4ZKT7oKjpsG2o1Edij
10736	payment	1726	1726	1874	1	1	2977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rX7ESwFX9fPVBr7fPPbUYKeRGUJZJ6cL8rwN4TrTsS8dSLpz
10737	delegation	1972	1972	1406	1	1	22	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7i3QYt5w6j5i7FChakW6KwbjYb5Q3EyfJRwKKCxKzm5LZNDMP
10738	delegation	1972	1972	1406	1	1	23	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyE99huHu1XP8Xugev4J8trUtqdjctA1nL9HWvCJaW8eex62Kv
10739	delegation	1972	1972	1406	1	1	24	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8qVRVEL5mdZ57daWhiMASk7Xar9Gj7LGF8yfonZh4mSwGdyi
10740	delegation	1972	1972	1406	1	1	25	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLKLQaobGA3YDZQCmabg5VZEjgU6WJAHUEx6Rkcpj4UPkh4Tj
10741	delegation	1972	1972	1406	1	1	26	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVXfXAr1C2ieLBofQ4uUHuSzNocdp6rWEvCq4HLEh15aaiEi9
10742	delegation	1972	1972	1406	1	1	27	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkgMjCBLrYZVHFYdYpgFj6ijESAWhcsENaaRraa331cogHx2e
10743	delegation	1972	1972	1406	1	1	28	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1PNL5GuBD9uvq4YR5gUWzodK4aAnUSLAXMNHsGuY35aR8JPC
10744	delegation	1972	1972	1406	1	1	29	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1jMsks9JyZHsTnRFvZNN3DZvLA4n2TBjZxmyK2PQG7zkMqZa
10745	delegation	1972	1972	1406	1	1	30	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CgMcEfxhGbhhuZboJBZyoWmA5ecv4g5yF4fiCAuj34mz6duD
10746	delegation	1972	1972	1406	1	1	31	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESVEZ5Q1wm5kHDsYtDjVYko7kBB2ibnk1CzZ65drkLv9Dwc7B
10754	payment	1726	1726	1874	1	1	2981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5oDBRF3jSAbcawuzKfQu9v1ZZ2mq5N1i3NSga6Tceu6zRDdSG
10755	payment	1397	1397	1678	1	1	6028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfJBy1wtnYq2Lb3jSyun7NVTziVMfxNRPtQdUPbnP8GLNm62t
10756	payment	1445	1445	480	1	1	4	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXi9Jxax2wbKUxJEZUbywL8HMHdyiS6ecNoEdCJxmatcd1aweu
10832	payment	1726	1726	1874	1	1	3010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QohB52zDgk8vnk3TPDThZxbPGdfYpF9XmDjg8SEcfBwkX9jQ
10850	payment	1397	1397	1678	1	1	6065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8PQ7XTNqRBqrdBDyBjnhv8Rfybgnc7Q16YYscCACKQRuDxY7
10851	payment	1726	1726	1874	1	1	3019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gSzFE8kFZuCf9nVQmjjpWASPSBnG4qfsPap5mer8LxNiRMGB
10852	payment	1726	1726	1874	1	1	3020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UmaenwZ1vVaAPetkg2jZRzRZn1DsXeKEp77v575MyrcRRhtc
10853	payment	1397	1397	1678	1	1	6066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gXNJimCx3mwm2mzYDTCzaXrqLisbhJHjKTgH9qnkZYQcUvNS
10854	payment	1397	1397	1678	1	1	6067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEEnV584zfqxwW7tukYNjvVUFuj7D4mquCroVCsCLHpDKNgKN
10855	payment	1397	1397	1678	1	1	6068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpsvLU9k1NbGk78n8sxr4FbQkX3vXH2mGTB1JR1EPeDzBCbJw
10856	payment	1726	1726	1874	1	1	3021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdDzn9p2hDGAKChAegFHnBzoFDgjojr8CPmCbBFcUzrQd4JNF
10705	payment	1679	1679	881	1	1	15	3089730872000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ23oD4PyGm3jZkge3aP3oYmA1kpvaitNbMryJ8d7Be2tWXcvqg
10706	payment	1679	1679	883	1	1	16	475343211000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYdDZHw4iwWRPAigjJsuwcBgtGb4Cy5zLAYMicj7FmBt4ksKvDC
10707	payment	1726	1726	1874	1	1	2968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfhxDkkymBQtGSmX1YwaCJ5V1fLHXvMh8XkYbQNqsmxxK3knp
10708	payment	1726	1726	1874	1	1	2969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcudNuBy74ujSKC3AzcuQj8zU2UC8DvsGp6QFViHxeAxq4sqYV
10709	payment	1679	1679	891	1	1	17	2614387661000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYyYHwaj8hZE8J4HU7gsx7p9no2ufgvokAw2sKDZ3br3zfuFmRY
10710	payment	1679	1679	897	1	1	18	344871006000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYwG4FokSUxRfr2qtPKgcHVAs9oEUJsUmnw3VkJGXUwdGJmUbFu
10711	payment	1679	1679	899	1	1	19	205576432000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYiL9oy4DTDuDd45i842rJfZYEnZAEiL6ZUhBfmK5zZDoR6Fwqg
10712	payment	1397	1397	1678	1	1	6016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLxC92dfh4ZKAzFKcrxxE4GbuDn6SErgNqReuVpU6Hhnysu4w
10713	payment	1726	1726	1874	1	1	2970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmnjDpecvrqTCkLS8jmuMA6n1ZFExGoitA8HcA9MHvd3roKak
10714	payment	1397	1397	1678	1	1	6017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWD176zy6Un7X3hUWVMcZsd8Hy7bT4q5CBhZuhxmD9WwvJHvB
10715	payment	1679	1679	901	1	1	20	617946174000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYhotFQybu8pqsrHtFwDAMVty63zHCWQ7s5sZ6PVTgakXYMy9jb
10716	payment	1726	1726	1874	1	1	2971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4M4yiA8mg4VAgY4Wxu7Vi4fRHfCYgxMBuB16Wjm9pQWQosNp
10717	payment	1726	1726	1874	1	1	2972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbUNAgDfuDBfSNRd4EJVw69Nq5ubm8PHeo2FzAGFodNT9zR9w
10718	payment	1726	1726	1874	1	1	2973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5ijV4JhU1iLyEZPKPxSKHimzhQFASAeYF5KNgagvjhiJyRa9
10719	payment	1397	1397	1678	1	1	6018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QhfrBXhfcgRWoABoyv64FaYjT4ykqnzNdhKqMpsXoUhu3Vzt
10720	payment	1679	1679	905	1	1	21	2222229512000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZrUAG8hWGcPQFVj5ams91Uh2Rg5ov3BZExr3yiUwV8bKZK5C8Y
10721	payment	1447	1447	2022	1	1	0	1000000000	10000000	\N	E4YTcWgPZEpWk7rugJD6XDHgDHZ7FXgxDSoYtgMKSGFuKztTpaoap	Ckpa8fweh9xQK4okzJC3mGdnhP5bbzhZw68kWYNQprmxXvSbrtgSj
10722	payment	1397	1397	1678	1	1	6019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAaNvoxoUcvTjLSQH2DisELayPUABrn7N8vsbBNEjrkYYtjQoJ
10723	payment	1397	1397	1678	1	1	6020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzxDvyhgAC4jwMtoJmdCVw9VzcEUYDckXmvz4M8d9HKiZ8hvz
10747	payment	1397	1397	1678	1	1	6025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg92TGPmccVQ62JtNwJTBsM5jh2qAPz1G3bcnRe66N1ACppewY
10748	payment	1726	1726	1874	1	1	2978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDyam4krpwMy6GowTRcXZhhdsDgsi2HZaYKiCtcjgA9K75DtP
10757	payment	1726	1726	1874	1	1	2982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvNc8mBJTQWJp41tpJ1UQknyjBVUVXuNpaoxyzfd7RSgNhLTU
10758	payment	1397	1397	1678	1	1	6029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2AhX7U7t9bDkLxxAaxVPb6bgmuqncDpyPW3t8gQZQAUeAvgc
10779	payment	1397	1397	1678	1	1	6040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNF6GMbKi3j9CQLc8C4yt78haNeSrrrsSSETAG7sJ7zh8QLaLi
10780	payment	1726	1726	1874	1	1	2992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXysEH5dEusEAQqD5iTn9QveEzd9eAEc3GM9DrzyEPW1gpgR9L
10781	payment	1698	1698	556	1	1	2	419564339290	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpYnDx7gcyknV6425jiP1VCUAx4cCxMMUaugMXDnd7LvqHaLAGPo
10782	payment	1726	1726	1874	1	1	2993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8eQSSASvnLWJCCyhS8DDtHv1bMtxGECF2KoGwVLvYYmXYJo5
10783	payment	1726	1726	1874	1	1	2994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pmXxejaXyAEnQBNRbxt3221FAGmonQVykJvEhYtAb4NFQp5z
10784	payment	1726	1726	1874	1	1	2995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYptZrhaPSV9hwxrzPvFmRH4nbm8oB35irEaYdzNeQbJdEuCg
10785	payment	1726	1726	1874	1	1	2996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMXUtuZ15xtajpqo1ze5Nzq6d3Wf6Tdk7EtqsUKctzAP9N8Qe
10786	payment	1397	1397	1678	1	1	6041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhU189W5rXKC752nhdKx3tnVUqqZs2VCsMivvN6Wt5pNYReCSD
10787	payment	1397	1397	1678	1	1	6042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fUoiKHsRgYY3gYdLrZxas7FL6o2K7AgpzKcie3JK6Pbvh95i
10788	payment	1397	1397	1678	1	1	6043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9xZqPpQDWYzestxtsm3xY2P62moJY59WHu61ktahAtxt8KRj
10789	payment	1397	1397	1678	1	1	6044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSjMJr4HinMWfcmQy2Eu6oQyA7UTJ2ubocxxn38EXyTZem5kxX
10790	payment	1397	1397	1678	1	1	6045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3Um5kZbDJjfLrhxnpCVepwACFHNBL1dwWvJZMS1u4F3wXSEJ
10791	payment	1698	1698	930	1	1	3	3191320140680	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpZimsmjYMmbu633xjmPb5pabPqnz9MEUsCkKLmatK4SiQuRjMry
10792	payment	1698	1698	1050	1	1	4	5718818348880	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpZqSuCkrTZ58JZeGDVMqbtKX3tDcJkZEjZDhJuCUUDceVQqe8F6
10793	payment	1698	1698	1170	1	1	5	3858600695495	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpZQrxbhZuQCDpXNoKMh8MyCeCTrTwb1RbuRi5ywMnNA8duVKViE
10794	payment	1698	1698	1296	1	1	6	10752333925620	10000000	\N	E4YxYT7v9xjYVM6QbzeFn1JLKWwGv6pJbVAjhNZa7JbbZPx3XrcM8	CkpYcPMhWHvRs8gDt5tJwEPUMkhyFQsbeGSrL3ygajuPwpxr94KdK
10795	payment	1706	1706	451	1	1	6	176478352080	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpaG2kKX6Qaqe9ZGkc6pQShMQA3Dtt1Fsz2dLHjrmc8Dd54dzENH
10796	payment	1706	1706	487	1	1	7	176478352080	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYcqipXGnUtMxDv7mFRL7Sb2otjq3bU5hm6evB7jEoa2jvp5pFt
10797	payment	1706	1706	744	1	1	8	5347828843	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZN42LZkD3oL2fQoR1yKUB4hKvbNtnJ514HfykmPmChUahFGkhX
10798	payment	1706	1706	988	1	1	9	1343486499270	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZv7UXfT4gfJ1ixCNFREw2eorVq6C7ioyWNPpLidxWA365ugGWX
10799	payment	1706	1706	1108	1	1	10	2407516295700	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYQhToNc6wDS8iaxxsHQRXdbovNpf7UabEg9ivdC93Pu9UHCwqG
10800	payment	1706	1706	1228	1	1	11	1624399217850	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	Ckpa4vAbxU6k9XWKx356DdpQZDiKU8Z8j3KgfYv4DSX2JxcYKCJ9K
10801	payment	1706	1706	1354	1	1	12	4526532854100	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZc5boPEwh1xNoqK2XWaTAHCQsJMTmMjg36wozXgLaUP4WtKtsz
10802	payment	1726	1726	1874	1	1	2997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJR2u438z79FN4mz5tx4kygjNYJpTs36FKAZaDHpjfv5GdAWjp
10815	payment	1726	1726	1874	1	1	3001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5B1T9Km8c7TdFtbJMEYoozSvdU6XucBgJoAh4V5QsbFDWRV5
10816	payment	1397	1397	1678	1	1	6048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNACV8adC3ATbFcaZGkCipzd5GGrRyWCeaH2EnHxzTTzJuEDd
10823	payment	1726	1726	1874	1	1	3005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvvJACrtnbXBUb5v95ZquKR1LYLhn4oZrbJcYL51PQzs9UvUh
10824	payment	1726	1726	1874	1	1	3006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWa1CLxmiKDuu7r9iByChFULcZLWUgfVowSV3PkHu8aEKn5EC
10825	payment	1726	1726	1874	1	1	3007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2oS7MZCjLDrtNTeoFpwyhqULHMw5dptoytDYAPGgfzuj189z
10826	payment	1726	1726	1874	1	1	3008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKSB1RqNNvZdoajZWcZyensKzrBCAhdSQDW41PSeuhRDaiiAE
10827	payment	1726	1726	1874	1	1	3009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhieRkC7VF5YkByBQXQVWtGTHsjsefo5cNBjeUJDmyncGZYeHZ
10828	payment	1397	1397	1678	1	1	6052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBcskQZzjTeLtsVJ9BcJUt3u8acsoHhdka5hsNrB4iFcqbc3H
10829	payment	1397	1397	1678	1	1	6053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVVXATFRoPPf9xH6TP1K4Px99Mme9yVVLgf3Cgx2JqCHx3HEN
10830	payment	1397	1397	1678	1	1	6054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9kz6DZ9UYmNpuAaoCoyJfw2yjpyGjazzhD9vD7c5f3GTD85n
10831	payment	1397	1397	1678	1	1	6055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UG64Y5tn46aeXvaLhCHq4LzVCZzy2zZVn9vKwMyBAMqs1DBu
10836	payment	1397	1397	1678	1	1	6058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4z7EvRiiW75ZWaocS64AddueKHEjBVirgPsxHH95zLvhNcpCp
10837	payment	1397	1397	1678	1	1	6059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzf48A8yYuY3b1EbNqV5gx2ZhxdoiA3cAbdr9rMzyrBVhN27UL
10838	payment	1726	1726	1874	1	1	3012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DWkoNFGTEfgjDDuw6DQqaHgAziS9xuUesgw9H4WNawLFtmCn
10839	payment	1726	1726	1874	1	1	3013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8TkwhToR36JB97eeVYKqdZYsxDoAdJ1yc8Cb92QeLS1gwwsr
10840	payment	1726	1726	1874	1	1	3014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqcAhKAnfZcE59hkzHZvxRepMwvuV3qeoWKpnxRL37YHtYL89
10841	payment	1397	1397	1678	1	1	6060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdidHVWLuHPL6Kv8QT68i4L3D5fGjqpPf5nh4SUN3yUbSNdqww
10846	payment	1726	1726	1874	1	1	3017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9A6xRUCDVvdFMpJJtfVuAsdhsiWmnftPN1NuWudLjVWVe6YBp
10847	payment	1726	1726	1874	1	1	3018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTzbakBchRmHrRzs2M2iHAJynKaaxaw3H2FedvJ5XpgteRQhp
10848	payment	1397	1397	1678	1	1	6063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAfRnBZWJcoUCak7YNdnEZbWDCod5n6k2rzNQHNnuYEGD81fj
10849	payment	1397	1397	1678	1	1	6064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWv6YpcDEVyRQc8mvPPw6orjMB2JWwq6dXYKHQ8jeyZBUCkGy
10875	payment	1726	1726	1874	1	1	3029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR2bPL6fbCpG9gvw2T3xEHTC4NM11J8of5EB7Ci75X2frvoF8p
10876	payment	1397	1397	1678	1	1	6076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBB2cC2hZs6dosVs7VWyCcmSvqm86gTyVFLSUSkeeDjN7YLgb
10883	payment	1397	1397	1678	1	1	6080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqWXAFUUTaadz1taY5n5TkV7Yvz2jGPhKziJZXDTWNoCVmWu6
10884	payment	1726	1726	1874	1	1	3033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhcZSLK6REoshb4c6gcBLSXMq2BbJuHRocagQ8ma9akRp1Ni35
10885	payment	1950	1950	2025	1	1	7	2000000000	1000000	\N	E4YXWRaJBCzdEd6ib5xAheNcDa8FjC2Az7XLerCRrdxBAnUiSBbRB	CkpYhH3CEqobnQYvdPz8xkeon6bxcFzddpX6co2HthxhMVXHJYWxw
10906	payment	1397	1397	1678	1	1	6090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJUJ1QSPgkgM9JFphZQRs9HpSHMnAxn5ccwBRsB5RBsb5QsHY
10912	payment	1397	1397	1678	1	1	6092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQAAgfv187TRCAjCRBFr55dtdHHN6nfyuKMzTpR96jGeY612r
10913	payment	1726	1726	1874	1	1	3046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoidpKS81agfdkGeW3izrFuuX86PMspypnR9oAizgozPqNDngF
10804	payment	1706	1706	451	1	1	13	129405854012	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYu6xXQGTM8zewGaP13rFMbQa8TuWGmZ89MLq5QUFKeaGeRpFKb
10805	payment	1726	1726	1874	1	1	2999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsfVGnEzuEt8V6od7fWVhKc1EhTcarSMVy62umPm95ASJ6LQH
10806	payment	1726	1726	1937	1	1	3000	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYTvj1BSDLGXbYC2CeSHQbkESUWUPGdgKZHnYuzXs3m7N85veNm
10807	payment	1706	1706	487	1	1	14	129405854012	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZbjEiKb6eL9D9XQmoodwv8cEDy9UvrVVmNq42yxDWrhwEXTHCU
10808	payment	1706	1706	744	1	1	15	3921389510	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZ8qr3sC4AgxHAbUNhnZVvQE2yhHghw8WLDbMxcqTYpUko7L7xR
10809	payment	1706	1706	988	1	1	16	985223432798	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYeQBZ7j1D2EJ3uCh4Cm5ZA5vpC3gXGm6Pzux9A3EqviP115nHW
10810	payment	1706	1706	1108	1	1	17	1765511950180	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYgnMJ6pexgzNKTd47vebkxckY38UpNABgCF84CeSjRCx56hc97
10811	payment	1706	1706	1228	1	1	18	1191226093090	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZq17Kumwme8VVsQFT24faDNA93q7nwzNBcCesZAffBiYZnENYD
10812	payment	1706	1706	1354	1	1	19	3319457426340	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZhGQqHxQtBQMBurN8RXiqmy2B4PcAwCpUNbeVZWTv8z7yGh2LX
10813	payment	1397	1397	1678	1	1	6046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmt92cAQ81ZCvCbCwzcH83FYaHKibJEWbNDmP91aWcfsCYj8m
10814	payment	1397	1397	1678	1	1	6047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZH2NfTiN2gj7VGLXZbf7jMgw3P8U9vWTRTNckmkQfNvGsxuLw
10821	payment	1397	1397	1678	1	1	6051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWY3FSKWeX5V9sTxYmoANfgGVboA7586uuExb3QVBd8STju1jL
10822	payment	1726	1726	1874	1	1	3004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PrV3PGNyNQcCh36bfNgb8mQMjWDnzFDyJvnbkRawS3kivoah
10833	payment	1397	1397	1678	1	1	6056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWp7HTvH8f7kpu8NqMdU7dXudgSByCRRFMLeJerZghArtAXRs
10834	payment	1726	1726	1874	1	1	3011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLVGmXAek2JNT9sgsy3aTDLPAgu7PnhBtuxuwyAZC2jTbi8TA
10835	payment	1397	1397	1678	1	1	6057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVzsbiEBAK9ApWNX8Na3ijTDrXvwNERC2x2AhUPwnygHUweYG
10844	payment	1397	1397	1678	1	1	6062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKbPieENN2GYeK1gb15rTz6gLSqXNhXJ4ZagTh1twz1fPBScN
10845	payment	1726	1726	1874	1	1	3016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk96dQw8EjRed42YMhJU9TebkTHNCuC3qzzmW9gAcEhVKBX4ur
10866	payment	1726	1726	1874	1	1	3026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnFuFrNdCeGmKinfzpevVSXyDGueGNtza8TNw3feKDouYhpo6
10867	payment	1397	1397	1678	1	1	6072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVYxYMqsWExhA7c29by4yH8jXT4XEEtXo6NYJnLn9T1VpiBzU
10868	payment	1397	1397	1678	1	1	6073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWw2iDFHWSo797jGMexThn6jpL1woiSUK9qNydLBG5sPY74234
10869	delegation	1740	1740	563	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrUR3biNko84t4BqEWymKxboBV7rRFBFDfkvrfXF8vsV4pstD
10877	payment	1726	1726	1874	1	1	3030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbNDctfP9HC6DyoHipZhhbfRN6vvpKkzrYt9Qg1SRH2PvuM2h
10878	payment	1397	1397	1678	1	1	6077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiuX5LywrfqkutZNogUQq5Kr5TAY3VvczrL3UroyJucGqZbw7
10888	payment	1397	1397	1678	1	1	6082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeeg1nMhQHjsqcnjWzCy6DsELJ7p2HX7HrRc8Kdaz1SV1uBJdy
10889	payment	1726	1726	1874	1	1	3035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdkZeYQxUKoNwB3HjQDgnhDx9hBEAsneBHFAQ1x3QDQfRPKaN
10895	payment	1397	1397	1678	1	1	6085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEchfNsVJ814SeVsBM1oBsg4uvDCv3g3fTEdxFZ1tNKG72vQHn
10896	payment	1726	1726	1874	1	1	3038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQnwxd64cPZSJHnzPicAH8Ysy4n9SQGGuHyhvymSpWmFF6aou
10897	payment	1397	1397	1678	1	1	6086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPLmwF6fbNfYXFPpV7wUkEu8Fs8BnQv9StiB4soTN3UyZaVXA
10898	payment	1397	1397	1678	1	1	6087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbtyAFTBLE3bUd4VXvq3ZBZNifB8PFAxzE1WiPdgXSEkbXoJ6
10899	payment	1397	1397	1678	1	1	6088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGrZx8W4u6QderHSGkWfkgwmHA8cdJiRxcbiZc6Ekc8wfrQhj
10900	payment	1726	1726	1874	1	1	3039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMWgpzNBsXLzKu7oESQVesPwS6U6RnGnTAh424exA4sF9rPW3
10901	payment	1726	1726	1874	1	1	3040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7AwF8DX1faE9urwGjZM119Wu3AtmWg3mVxoidxUeRV3YvkUg
10902	payment	1726	1726	1874	1	1	3041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpsecL2x2xFYGHFmGdMqHAtTJvEBb7RUporBUDT6zcZ4xyFqK
10903	payment	1726	1726	1874	1	1	3042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsaAefCs2xreiYfotzwa3WGymYNX7TAL7WyKZUAD4cWEWt76N
10916	payment	1726	1726	1874	1	1	3048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3EMKN61LeYrtWYTYJNpraT8JpyBFhpjtWufhb5GXftewB9Hu
10917	payment	1397	1397	1678	1	1	6094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZVRGHvJDbcPbJxUR5FNq25uDs3CJgAK73vBHfZURJUvngFPb
10924	payment	1726	1726	1874	1	1	3052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqDeho8TzCCBoxMYjR9YgqWfRaU1X87eEtn8zuxSXT5bnZTiH
10820	payment	1397	1397	1678	1	1	6050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoTXXJxik8RYQdZMtHj8gEA6uymLftx2jk251ZzkndyL8HNof
10842	payment	1397	1397	1678	1	1	6061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKx2fA8MKZowkbq8aMxZL4fv9iWPJbYd9Y7yW1yA8BxGhemAB
10843	payment	1726	1726	1874	1	1	3015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9bQRQg45Ge5gz3R3mriS322ciPVAKZPkBmd999v8GzwT24FR
10858	payment	1726	1726	1874	1	1	3023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBe8TRzqm4ZWHcDuf5QywNtsBswXhMg29kmsuNdG9FCrFbZRiu
10859	payment	1726	1726	1874	1	1	3024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4h5JKgzw7RMJkBHEBWcQNXrpgHi8cvpDuJbPsdDpmBnzjhcAm
10860	payment	1397	1397	1678	1	1	6069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxwqkj2sXkKjUq7urhwLQugC67UaNjSBdNU2kodwic9P4obwC
10861	payment	1397	1397	1678	1	1	6070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLFy67En4B5BVk6jt6Ep7tTMdVU9y6p4yE3RoEVdd2ndvjPkQ
10879	payment	1726	1726	1874	1	1	3031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7Sa9T6wKUXCHGonQFfkw5XLc3TdxBnY2pX4sGm3Jf2xVADNe
10880	payment	1397	1397	1678	1	1	6078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjz5vTmDjSjEKiSFdxMTVJP4Li27BLkNi4DwKXiBpK5Ejhx5to
10886	payment	1726	1726	1874	1	1	3034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qkgWUf8wVW65BmM7P2sKeW3YWZgMFHRusiUEfG3xgg8cBcvM
10887	payment	1397	1397	1678	1	1	6081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CQbSmXeyUyAFEhr2ua75P5aoP9KURsMnVj5gLtk8yAtBnP7s
10904	payment	1397	1397	1678	1	1	6089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhmqRpodsgDtRkjo9ssT69fPZP9Ajyao8jBRVufT2UGnzRN6Bi
10905	payment	1726	1726	1874	1	1	3043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvY11Q9X7KimQ5wtmh1VbqazRGW1PYGjWi1UuMnct6KciCBtT
10910	payment	1679	1679	887	1	1	17	1418704594000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYzYLk6Vc3UqQc2KZMoGaDHTLSa7PRMJRfja3BBJPs1DxqzyscE
10911	payment	1679	1679	889	1	1	18	1190926465000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZDQKLG5ARJgQSNBHRn9RhM8XjbDJG5P8B2ZHWQhcfbE1VG1tWS
10914	payment	1726	1726	1874	1	1	3047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ55DP9Lod1EQDYWx5DYLEt2EmL6DvYeecTZ9ERLi7585C5ra2x
10915	payment	1397	1397	1678	1	1	6093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhGYoc4z6nBtkUDhUk5k36eC4W9mbDkY9zCHXBJGLtQYLWSSA
10918	payment	1726	1726	1874	1	1	3049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZar81XnZbxsm1xJjMQ7NCSUbqC4sigkpDqL5uqcK2ze23wJzrH
10919	payment	1397	1397	1678	1	1	6095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmf43apJYeuVgG2EnfqTQMwLyziDrgCDfGahbsZiE6MTNkJ7kU
10947	payment	1397	1397	1678	1	1	6110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96TuCmXAwxoAxmPm1nWQoW2t26yDu7Ex41SeWQnBCkL6D5jkH
10948	payment	1726	1726	1874	1	1	3063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrwdy9KWQtEFrU5wMwyk263vKSsfTM3TqVb98pSBmsEA2TCyEN
10949	payment	1726	1726	1874	1	1	3064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFEYg7nzsNzzcwA2vfrQvcma2S6yXSMKJyCE1RmpGDjBv4dQJ
10950	payment	1397	1397	1678	1	1	6111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEiB6oqxMx1vokvwZkruGN1zUHxSHy5iyYAYQ8sn1qwt8nGPs
10971	payment	1726	1726	1874	1	1	3075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVfco9koKPuCKvfQ8i7wjyKTg5b1Jq7424rQp2npcK29tFxBU
10972	payment	1397	1397	1678	1	1	6122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tuLnouFDeguR9m87Edv8mag8hjeAVsNFXrj4B3SFikasZfwn
10979	payment	1397	1397	1678	1	1	6126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9KzpG89eFtcP5ALUm99pWJYSmWXhjwHLNDPj6GhCxerFYJKU
10980	payment	1397	1397	1678	1	1	6127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3SejM6oubAfxMxLpUynFCzQg3qtzyaURZJjRPvxiPDw3UR9E
10981	payment	1726	1726	1874	1	1	3079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAXAZghVH5cY2xDXsfxaHHhgky5dez1aedCDqA4M5Pv4nRdW5
10982	payment	1726	1726	1874	1	1	3080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7KmYuRxW42Sf7mwQaJAiTi7p4sa6EqV8HKzvDdmFVnLU2gyJj
10988	payment	1726	1726	1874	1	1	3083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzj3jSb9h3ZDgNAVrS5LuEieJsKoNGTXk2ha9NNBptiZwsaKDm
10989	payment	1397	1397	1678	1	1	6130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW1hNHSB3FuNAcBsSryfbq8Lo6Nde9S9X7HKWe6cbeoDofcys
10990	payment	1397	1397	1678	1	1	6131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmDuNcHEfuVEzvDZHXu4A4h2QX3PCeVGUTvT6sbN5doS3c8re
10991	payment	1726	1726	1874	1	1	3084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8U2jtkQs31c534k6oWjMKT9Gaanwtxby3QoHF6hR5KK5Ezs4G
11004	payment	1726	1726	1874	1	1	3091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSE6HXfY62VWjSXRVsu5DDB2BRUXorjV9aBTNsPArN7XCKt2d
11005	payment	1397	1397	1678	1	1	6138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwi2H7dRoEEr78QLzY6qjMoYHzvryj4oYWG9wt7dVK1X39YYz
11006	payment	1950	1950	2024	1	1	10	829330000000	1000000	\N	E4YXdUHAxeJfL9JRVMhPb1wea6gwWhCBaDYbaEv2S46DKk6hTxrmv	CkpZgA7RoBCBq8hYiXWsy8fYuL3KLnM4iwzckb3v5QzKSgkMCjN7B
11010	payment	1726	1726	1874	1	1	3093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVAFHsjYpfsn4zsEGVu8x8YdH3UuGshXKrsYoYf5n86h6K49J
11016	payment	1726	1726	1874	1	1	3096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiC4HgzNstPmty8f78vvFhjXmWZamwpKiy3HLn3pCzVKENGHU
10857	payment	1726	1726	1874	1	1	3022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8SEztopmt969356VcqW6dEDCGt5rTyhe2xgUxHHfBrQ22CGCG
10862	payment	1726	1726	1874	1	1	3025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqbNDZJ8hqcSFdPGvzpXkpAtsUXiBCvQyKgrWQ3y4Qcbbeq3j
10863	payment	1397	1397	1678	1	1	6071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnEdxAY8Xawfnr4JQ1EnQs8S7pVwGLiwYRdzsY1WFyB6yUDKeJ
10864	payment	1950	1950	2024	1	1	5	2000000000	1000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpZkvfS1y7Q2uuMHwiET7bvhF6MGJsozdZEGjm8d3cqnt5aMFTSt
10865	payment	1950	1950	2024	1	1	6	2000000000	1000000	\N	E4YXaNmoSr6A7A8jqCDaxsx5v8xyM9Aqk2ufjeNwz9Nn25eE25vGp	CkpZYeoQzrVD9b4iKG3xM9cMkLTCngaUexVCFo6hMaepiqs9JJBvb
10870	payment	1726	1726	1874	1	1	3027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPruyux6mmaKUH3meBYrNuC6zsbKbqp2BNvyfnmQtyKEybxem6
10871	payment	1397	1397	1678	1	1	6074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSQvpPKeX9ycD3QW6rvW1iv3ZuPmBCDEDC5iU6snoHWXTM3Cn
10872	payment	1397	1397	1678	1	1	6075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YqpgPqkKfeHDVMqHm1C5mYiPyor3pYx49871Xa1SyswJuA3S
10873	payment	1726	1726	1874	1	1	3028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtBQcs85V92Y7Q3z496RgF2nA56XEQzPGy2VtR5JJHYhG6mK9
10874	delegation	563	563	1483	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXVHZb2LGKFSMU5mRfs2F6yh3juPtwsRyiwnpvXpEtcNHt83eD
10881	payment	1397	1397	1678	1	1	6079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVp8BqvVVoP9BiEYusdUCPdFienKJ2WWFi8332ipNCGVoNK2VA
10882	payment	1726	1726	1874	1	1	3032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcwHQ2wiPhc1pRW5A233pnkXHUmnHHNy77B7trjNaaVdSxzJQ
10890	payment	1726	1726	1874	1	1	3036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHs3ZnbxqCuBfPdYwdYPG34Mfe5nWwamMkRr9iLHqKFL6NNJRY
10891	payment	1726	1726	1874	1	1	3037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvrWKdz5Mo13gYM9qPhuGNiFLEd4VwCeKN3H6YcD6tEoGzRGB
10892	payment	1397	1397	1678	1	1	6083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkuJRJmQFVdZB8qddQuftGHuXKZohiCqbofrvCgurDKgnVdwv
10893	payment	1397	1397	1678	1	1	6084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnkhajg5ByFwjcjCvwi99HTkFFe863FrZpiZtiPkVSi9sqfFY
10894	payment	1950	1950	2025	1	1	8	998000000000	1000000	\N	E4YXWRaJBCzdEd6ib5xAheNcDa8FjC2Az7XLerCRrdxBAnUiSBbRB	CkpZP7N7NVANLmVeF1nybn2UMqVE4LkxVjprKKzHD9EbtSFKkX5hn
10907	payment	1397	1397	1678	1	1	6091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLV1rTTqudfkcuepesqfa5VUQajJWGFFoLy3978hENa9DxYb3
10908	payment	1726	1726	1874	1	1	3044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdNz3RGTq5arGrUBfjc7FqL7pro95rYSdH6fJDy7NsJ9RTz4i
10909	payment	1726	1726	1874	1	1	3045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggBRMQ7VH6zHh5Af4mCz7ibekc9aMUvdssD5ekjWnAJ7Lzn9y
10922	payment	1726	1726	1874	1	1	3051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYecqJ9L5thvDn9BRKm4SeBPrdQTP9Fr6LwGNTCMDZUZUvgzN6q
10923	payment	1397	1397	1678	1	1	6097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dXohkH1dW9mSJahfZXAUFciizoN4X8v8mgoMPwBMgXHoRgrw
10929	payment	1726	1726	1874	1	1	3054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15YZifjPt22BWotmKW8M6YpRxFWssvqR8TYk4HFkTYCtz3AY5
10930	payment	1726	1726	1874	1	1	3055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1hfwY5nG98wW6Dts35z55v49ScKAtTRWTLfZV8JVCnwnuhng
10931	payment	1397	1397	1678	1	1	6101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HJbeyGvntGSUt5Q4Q5vc5mWMgPUCT5d3rbxZ9RASq9HkWgZ3
10945	payment	1726	1726	1874	1	1	3062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtSCcaU4fuQxM33QYv3XMMm1e2CrNu2frnRUztht1B4t7JJek
10946	payment	1397	1397	1678	1	1	6109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3K53WBCFfNAL1JoZuZLs7PxyyuABRsDSxfCvcjnrV5Z8UsQLG
10951	payment	1726	1726	1874	1	1	3065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRBiCjd4ZYHdP7n7pnZtWVuo2LPBWo4H2jeGPtp4PxnfNmQSd
10952	payment	1397	1397	1678	1	1	6112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbtybxsu9pyGhkUqJ5NSkmLxbhKK53yYkE7CcSGUWn6Sq4pXc
10955	payment	1726	1726	1874	1	1	3067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71N4eECFpAGsnig23gBXuDhhXLt9PNZPGPrizYCJUpGbZnYZ5
10956	payment	1726	1726	1874	1	1	3068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQy4jNVxoQBhYSYqey29ZSaEcbTrTimcAbbp6f7cDm7cWKcaqj
10957	payment	1397	1397	1678	1	1	6114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCdVeYJVoJEHsSMgEXRhSAoeEzKwvyrFcyNo6JHDZPwBAQwBX
10958	payment	1397	1397	1678	1	1	6115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyB59i57MJhHPhWBuVMfhsb5fDsxMQqNwSfc86nqkArTctdhp2
10969	payment	1726	1726	1874	1	1	3074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWCawr6aa4EjmcnfvCgGExYYX4YTTmGoWBbyBL5i1QgLPn8JP
10970	payment	1397	1397	1678	1	1	6121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxL4z9a8zthpfUnAnj8bmRdVKe8ReP9qaBauLpTYxGTWgN7CQ
10975	payment	1397	1397	1678	1	1	6124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntxn7zpyAnmZUarcrkBRF8JsEU8uz3NeWRShhmnP8QyASFjRo
10976	payment	1726	1726	1874	1	1	3077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEj43FrPchMkrVfZ9VsZSbqssBcGNtm4AkxWXvxD4rRtdek5xa
10992	payment	1726	1726	1874	1	1	3085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqLbKkFxvax9FvwUGW4KUrnuiyWh634pbvJBWJ4tWQW5F9oWt
10920	payment	1397	1397	1678	1	1	6096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1B9fzfTZvvDy1bNM1rbX6Ch9Vf6Z9QKo58iGjMPS6aHBm4WU
10921	payment	1726	1726	1874	1	1	3050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6XikHZqP6csGL8GPSSK51JbHQvcbumWAo5V64Ywwgr8a9PrM
10928	payment	1397	1397	1678	1	1	6100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UUhQwmHRH82pTuDeVHqHgpQE8KeRDsrm4YwgJdqKnr2FLQ4x
10935	payment	1397	1397	1678	1	1	6104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAphkmp421YTPxToN4JjMFxdTkJCQkiopv5v3wdam5eEE2buA9
10936	payment	1726	1726	1874	1	1	3057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMH5XpbcNtoYrv9o83TLF9CdDwev9KZ8grqKxWLJdb75dQnaZ7
10943	payment	1397	1397	1678	1	1	6108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6awkUknfibHtrTqsZ664T5C5PGeQ3NSTjRSfw7C1u9ey6AMv8
10944	payment	1726	1726	1874	1	1	3061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAX6gA9tpCTQ8aoyhYgponkqdNop6ChwSeMYqwyRybC2h1tLzW
10953	payment	1397	1397	1678	1	1	6113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwab6MS5qcqNCuUmBCrfYchhxmqjNe4Vc9rrA86HWnMgbxMXZ
10954	payment	1726	1726	1874	1	1	3066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYGeX1wwu9B2oczFvnHiqb6tqXxYwnD3yiFVgviRNEWPNdx6Z
10959	payment	1397	1397	1678	1	1	6116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPN9B7GQgMKTKsuAcAqG764aLVPQg2B71ym7YhzDsi1aJiWmv
10960	payment	1726	1726	1874	1	1	3069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuhe1x2m4kQizzYVVj12KJNEuECBxUGLjVJMtpZXyXt1mDRvR
10967	payment	1726	1726	1874	1	1	3073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRGHvU5FuNs5KRVCV65d9Phyfeagy4twQ26K4oMEGx9bAtaWZ
10968	payment	1397	1397	1678	1	1	6120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL79txDeqB6wNqANwG6x4uT5kPwoaywscULSVm6hmGCo6ErXaS
10977	payment	1726	1726	1874	1	1	3078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDXekC6VPNMoxfqJPENdRLETZ7RuV6JKLhVtwo4H2bHsS4GLM
10978	payment	1397	1397	1678	1	1	6125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVk3Lv7KHHXTSanLr9SUhC51YNCbSJvJBH5ihtLSaoT4osbdo
10983	payment	1726	1726	1874	1	1	3081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyTeDMoQSuWs5ajMdJEipLxejMYekJvTCijsidPemibot8Jbv
10984	payment	1397	1397	1678	1	1	6128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYTC7aFenn8YLBXLNSUaU8K4dPFHU2maLMpppjbps1W13fJBp
10985	payment	1397	1397	1678	1	1	6129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eLvocfjBp25bztyb5GC7kTCb8n2fZyZGVX1rtzHBkGU4R893
10986	payment	1726	1726	1874	1	1	3082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQbUmAk2DwpQm8LDZqodExYcidjBPgZadvLVUMCg4aBVtRGsn
10987	payment	1950	1950	2026	1	1	9	76200000000	1000000	\N	E4YPfJZR11vjzDPSVGMhvtwY2HBMhRC2S3f9heZFbKLdvFfJXpSWB	Ckpa57toqW31MJcscGY6eqo3LU9hPxs57ZcTgEqVUD4bvSy28mi5p
10996	payment	1726	1726	1874	1	1	3087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZGsYpWewGGgQt5j78mcUC1QKJJhA5tUkeJfpvnLGdVcM1AXE
10997	payment	1726	1726	1874	1	1	3088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHovpbGevQ8BqYjqMv6QgbXjyAvesbgrAFRR5SaGfBwjJMiDHo
10998	payment	1726	1726	1874	1	1	3089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxm242E2M7ewTHgnM6PKk4c3FzJXjBsTe2wCdS4k6g6MLfCXN
10999	payment	1397	1397	1678	1	1	6134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdBQYYtgTqBqLB3hq36sSRtWzKYTvEA4trmKX6QdSuajwrpYK
11000	payment	1397	1397	1678	1	1	6135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFU1jPdzEWj2GQiJEaqTD1i3DP5TwBgrLrwhhHpnNsTgZjvt1
11001	payment	1397	1397	1678	1	1	6136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgYLbMc4nXjb2YF6YNwdeC3XW6cyfBdfMgkpTnvjqVqH4zKni
11002	payment	1397	1397	1678	1	1	6137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb46GsFQhtZsjUTUqvJutFa3gFbdgghQqNVpQNx69EoY4Kn7s
11003	payment	1726	1726	1874	1	1	3090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMC6wh7sds7x3sgLrRVTmucQoksvSXgtrmyAJEGbi5Pve9gvtP
11009	payment	1397	1397	1678	1	1	6140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEgECPcvCeKxrPwMnDHsk6dCVW3USJF9E9SzXWSv44RAXUj34
11030	payment	1726	1726	1874	1	1	3102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2eHu63UFVrkLBPiMW9yxCnnzkSUCckbucmDaMxwLb97skLYWf
11031	payment	1397	1397	1678	1	1	6149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYCpNpmDwjuhJCSGpFCDJfTYChrXsWqUbDKbUsydPd5oEnteo
11046	payment	1397	1397	1678	1	1	6156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3eYna5L5BQ8t5UAb17uomtMhgLQCbkmNBzfRHFGF3BKSePDJ
11047	payment	1397	1397	1678	1	1	6157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRQTyzFcVdpEEkQVA9LoiNiYZyXJD2x636i4g7G5HPRWr9cCr
11048	payment	1726	1726	1874	1	1	3109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvUoYPrBEyDGmkZhegqPM2NeVN1yoEBYG4KTP3Hzp9EAFCf1C
11049	payment	1726	1726	1874	1	1	3110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZojs4zPPNpUJ6wyLEpYdpkqaSWrZ3s39pYx19yAU2xrdERw1
11054	payment	1397	1397	1678	1	1	6160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnFQKqRQuHjiFkSrCmK2n2S5e7hRBNnaXniUfk1ybbFRsn7bJ
11059	payment	1726	1726	1874	1	1	3115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsouQPfYY42a63Lt7hf82LhPtwTfKbQvk96pNms6Wm8Z9CWws
11060	payment	1397	1397	1678	1	1	6163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaHXeEt7QiYd1fknRmgzp55pTkKCPHCWnbtRLSLcbEAQAwAAb
10925	payment	1397	1397	1678	1	1	6098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKhFNxLfj3sRSqLhxLQPueddP1ZQYwbGxxGhLqbsndN4Qq7ZL
10926	payment	1726	1726	1874	1	1	3053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAGkQgaGNeikjiZ4JQ7sydAMjuMhqkrmAg85KNer67L8MdtyH
10927	payment	1397	1397	1678	1	1	6099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8fj7ZAty7mk1cb9gTqthuriHBHPd1AsWqjGt3FVywhCa9vzz
10932	payment	1397	1397	1678	1	1	6102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVocGWeUWkBsDSczGq2gd8kqvokoe6hP267JUDfTU6yM7yAKj
10933	payment	1397	1397	1678	1	1	6103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBTxQwog1QEioHfGB9pU72vDjraM9RuEbs7PJCVLxt8n7Bpic
10934	payment	1726	1726	1874	1	1	3056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprDsw9zwLCTJZffTRyh28Jv7wRBFqHocK2aBeihNMAJYFrgXz
10937	payment	1726	1726	1874	1	1	3058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnavcV3n58chqYs8NHzsZkWUwyvVvVEaLLyKPfkbjMUMRDUgXZ
10938	payment	1726	1726	1874	1	1	3059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuqDZVKiLPVwohMEBZGrKTQ7yuvhSJfr96ijP9ALJJoSW59G4
10939	payment	1726	1726	1874	1	1	3060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdVtTXNRRwQLPUamBMpskhvSPzeLscCB1iZ5A2WcxZidqF3Vp
10940	payment	1397	1397	1678	1	1	6105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGUWmETXbnhLTEewxt5ee9TFGaUyN6TQBNnqopEzLjNt7rczC
10941	payment	1397	1397	1678	1	1	6106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZ49vrYP1yn8MYGVVtMeGco3xs24qNzvQgKqUhgCjUxatd91q
10942	payment	1397	1397	1678	1	1	6107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyY47uEWJf1CSSV3gkJf8B8rsYJgiixkqZZqL6FvwjCqnBAMT
10961	payment	1726	1726	1874	1	1	3070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbhuKf3UBxsDwMxAFoWM8cQRZaDP6wEnKns7jPuU7UJKcWqt1
10962	payment	1726	1726	1874	1	1	3071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15P6m29yto4bucB3mQGeMi1wQcSmrB94dY7iiae7TRuavYymb
10963	payment	1397	1397	1678	1	1	6117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR2EbJmLsFT2Vk5i8fiADuaYnKQNA2A5UUA1brZekG4kuaXgKb
10964	payment	1397	1397	1678	1	1	6118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKea4HbQHcr9yCoH3ZcAHp6aFpPQEKMRzCGWpf9VgdE69YQu8G
10965	payment	1726	1726	1874	1	1	3072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY48rGcUGyxKeWSWkwTLke42tqaGS91zhEd8b42ZSs3uLowQFP
10966	payment	1397	1397	1678	1	1	6119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUWkis3UxRTdYELD1nk91WAGWVPwd67w6coRxxbc1VQSv91He
10973	payment	1726	1726	1874	1	1	3076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWpmdZrZzwn8WVRgTbcA2ejqUz4w3y1GVnVkPdB2aKst8Yi96
10974	payment	1397	1397	1678	1	1	6123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvk7MUCKxRX1wkVVkLs9dhnv9aSw3DDo2K7vfRMmsQEnmsCUen
11007	payment	1397	1397	1678	1	1	6139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpSHFNkUJRY9NoQkhLZ8sG6M7rgVmZHJChHG1EdQnQg3CRySw
11008	payment	1726	1726	1874	1	1	3092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhyVZk5WAUyjjm8HSWjsRmssNaSbfdmmuX24Fj9XwtLBMo45k
11013	payment	1726	1726	1874	1	1	3095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCuS4tExXM4aHUDDofn8X1hr5Xj1ELbQCDZhWXmx53hbayoLKT
11014	payment	1397	1397	1678	1	1	6141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTtprXJ6oP91adJNJNdzogt1oeCikXujYkvvi59vfCe5sknty
11015	payment	1397	1397	1678	1	1	6142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8SdxgubJGgfPPzc722xLRzq5vvBWYaNp21pGMkijpXgqyqhv
11025	payment	1726	1726	1874	1	1	3100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRnSvbg5MJRTtPJoDddmg4v4S3ah28dUmEoCC6jfpV27D98mD
11026	payment	1397	1397	1678	1	1	6147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTtUFr7BBDP9awawPXrZsbxetJXeZTPeA4JFCY7TTjnjP49dp
11072	payment	1726	1726	1874	1	1	3122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkWBwju4Ems57CAwWuUa1MJiJyaakM1VFo1Rsjf4keo4dbCyU
11073	payment	1397	1397	1678	1	1	6169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSe3fTCRfdYS131mvtk8mSr3kzfPStE2qu9RnzSEnsvD9Pgtf
11080	payment	1726	1726	1874	1	1	3126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFVhTGMhdWF3rqTZAR4tbSvi9xqhsFGwjpVFG8pF4LyiB3s43
11081	payment	1397	1397	1678	1	1	6173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNKSCvzm23oxwYv6vrxd9bA2xEsG2KEhHevmuwpLQe3qiYNu2
11082	payment	1726	1726	1874	1	1	3127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48bg9yrsVa8zVcSfGTHT6wz5b1owj9KD3xJ7xMKz5KctWCeS2
11083	payment	1397	1397	1678	1	1	6174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBUkgBXhjLpwNhk165DGA3h9LSVqKgEy6iFBPESfBxswyvEy7
11096	payment	1397	1397	1678	1	1	6180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dGzCXeZeXMrF6yT6abrvYipharRAT7h9yzcHPhC6YdUGAbas
11097	payment	1397	1397	1678	1	1	6181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCwSnBxNDtbWDWuvVh6hge7avArfjqAwgvif2cnWc21HsK4R6
11098	payment	1726	1726	1874	1	1	3133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAT47FqWnmdv95UiusnRumixJ9yG89KQqHQkGmD4ZhQMkxLc57
11099	payment	1726	1726	1874	1	1	3134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7NtF9uqPpHJHMrsgf654msjkgzNHfDkkwPJhQ5XtfwHCdFEu
11100	payment	563	563	1233	1	1	7	2866900000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZFPLdnhzoudrPSWf88PbNXsw6KtChkKC2bo8UZAPaKXH5fR4QA
10993	payment	1726	1726	1874	1	1	3086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonz4rAwnF5Uyt2X92xKoh8jLtDNKQSaL9cqWBLGb8ScJghAFv
10994	payment	1397	1397	1678	1	1	6132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpo9okm37jNF6yV9dhT6xEjsjs9KLBKKsZXCW5JBZQuMEra59
10995	payment	1397	1397	1678	1	1	6133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxFApTuqeV1wePCgzrDJwo6NR6xp5qhDBasqDtuVD9hRL25VN
11011	payment	1726	1726	1874	1	1	3094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstWidSTw5URoUEiKD2bhqBN1y3n3sKkdHJGihPC5WymMUJyAd
11012	payment	1950	1950	2027	1	1	11	1000000000000	1000000	\N	E4YXPpX9SKaKLyQDxfYTCwYZroUWRDTqyxTxXBRJLT9RdjKAaqYLN	CkpYWHYtrbjkRzqmKmgn475de2JmMj262UoAaFYacvnwdjqxmLHpS
11027	payment	1397	1397	1678	1	1	6148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6QTgRvWx2ML85HaUJNi8pSg7RmemGXrFH69erV7QnTdzfNmi
11028	payment	1726	1726	1874	1	1	3101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxXMYtAcuYihy1MqzP7BSoEjonwCcZuG8pRFa4f98RBWjc8Wz
11029	payment	1740	1740	563	1	1	9	17473000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZsUfFtfdEe2aSD1MAoxRsTPMzeQxBN69gPBuqxkGfTvBmLpUJq
11036	payment	1397	1397	1678	1	1	6151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSyr5iwC27mS78N2ms1CKyBdPzgeWEaq6ZrRWG8W6Ghi5cXFb
11037	payment	1726	1726	1874	1	1	3104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKGjqrXFFq1yVDmzrMELzNoozTTzKQMasoq7zuypxSwqUt959
11038	payment	1726	1726	1874	1	1	3105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8RbqVeTCTSyrqs3RSYR9vJQdpgSiQ4zAKxhzp3DnkcLFSqsY
11039	payment	1397	1397	1678	1	1	6152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AbQrrJhr4kGBHRaUwknZNFcJ2U6QwBR6VX5Z5QEt7VZPopaH
11040	payment	1726	1726	1874	1	1	3106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqDp282CmSJvX9y2eeKvNE2X3mYjCQmQsUTuZiFrN5Sc5Rqgo
11041	payment	1397	1397	1678	1	1	6153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHc51HwrHN9L8zYEZPwcvzXvpcK471ctR3SA2TLhR2XFrrJ9E
11055	payment	1397	1397	1678	1	1	6161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4RnfpuGYjf9DzEpNr8nGPyhSvhgenmceseJ6drdVNzkUdrem
11056	payment	1726	1726	1874	1	1	3113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTjrpcgdcmJjBiNhWbyguxbsEeGUsitVRybwSyVJTn6EM8yHQ
11076	payment	1397	1397	1678	1	1	6171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYH3diBiCEq2ZCZvw7uy7LFk9dVsSgkgSMb8kVU7bV3DrwSQxi
11077	payment	1726	1726	1874	1	1	3124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJLZe3YyixDSHdc7fVNqL2fEnSSRpKrVZ8MNqE8DEocH25Gw7
11086	payment	1726	1726	1874	1	1	3129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVAPpzFHE2m4KAdqWwLX8peNbxX6Hf4Z1myiiU8Mm7AVCyXwy
11087	payment	1397	1397	1678	1	1	6176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzabjdfuwGJZs4ceyYMnvhdKqhTifJru9NccgyKiaUFq9trsKt
11088	payment	563	563	1740	1	1	6	5239000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZWAZJg8ggpYjepDH4vfWq2pnN2PhcXySCGVxgDB5Syv7pHXKeP
11089	payment	1397	1397	1678	1	1	6177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCPptS5a3qQ1Hg3J3as7CiKyRTxMJkBfz3u62Q8r2ByMT1yeA
11090	payment	1726	1726	1874	1	1	3130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLQzbCAFQ58jEnsK3Gk4Huw6vjRCvdtUu2Tqft1Mp4dhZ3cU5
11094	payment	1397	1397	1678	1	1	6179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY63EUgZrBfrPtEdUTughYxoYh647cEtwsvEctePo4YYB8Db2g
11095	payment	1726	1726	1874	1	1	3132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi15D1YRevBrqeMDaypCgEAw16ZH3PQrtmBw6SygE5hwtBqot5
11112	payment	1397	1397	1678	1	1	6187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhopR2EUJb8ubsNoeFKsyHgkH4QJdncraPMN69G2hAKg62PzK
11113	payment	1726	1726	1874	1	1	3140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLAN3ofKMEVUVjhiEkgtWrmLdCsr3JAWH2TMUuL5DACLbCiqZ
11130	payment	1726	1726	1874	1	1	3148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkboc9fRs3ydpJEAPr1hhRJNkNDn8ZWgzQ47DBtmDGwMXwFR6f
11131	payment	1397	1397	1678	1	1	6196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9g6Csbwpqr1zuEtEkJu4fiSGSYCycUiQ5t7SYnotrfV4dqu9q
11185	payment	1397	1397	1678	1	1	6219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxc3R4Kx4oypsZ5Xfv141JN2qRTkg42BQqJtdeQC9nsVeyag1
11186	payment	1726	1726	2031	1	1	3172	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ6ZDFeNqU1k2VbLSSNCSGFHRUHDKmMJuhJ4NY9JSy86spxjJUZ
11187	payment	1726	1726	1874	1	1	3173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyszup7yLszFXKfdXq6MzVe2fdSmbf7JTzPn9Mi9utocCcPvMM
11188	payment	1726	1726	1874	1	1	3174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ9UdxtfU2THyzKwAC7WnEaqsFNA9njxVN8MDfyEj4DUpu2Axi
11189	payment	1726	1726	1874	1	1	3175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrRfWcD46caiXdZb1pM7aMGYAWXFpQ5XUCA8sXphDoySJcinx
11190	payment	1397	1397	1678	1	1	6220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAd6dj4Bwg2hxwSkeKRdgTospFhq9ohPM23MfQTbfAhs5gNQQ5
11191	payment	1397	1397	1678	1	1	6221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5ux9mQKrLps7d9QuQwaZTVnfAaHftQq8c2U4qJRhLh7PJNdx
11212	payment	1726	1726	1874	1	1	3186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBW4BPaGchdR6oPVhMt2JCDRzjjHVCwG6UqHQbhoeeyaDvY1wQ
11213	payment	1726	1726	1874	1	1	3187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8V3UZXRooyG1xGhNq5jjbA6oYFk19t57ddJ1mAWyBtiQD1J8
11017	payment	1397	1397	1678	1	1	6143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSSJTNSH16zKqfwLw5jZ9UmgHKU5naUnm4CYcShbZipNSLe7e
11018	payment	1726	1726	1874	1	1	3097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDT8U1ayzGnaTLemxsa17tjvZ9xoBAGBdhD4L55uBb3bbLfnj
11019	payment	1726	1726	1874	1	1	3098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bxYSqdZKUy1fguM4DfEYs4ANif42wJJEGp1rWzzEt23MkYNo
11020	payment	1726	1726	1874	1	1	3099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFGFuno8qRhQSiN3vB5q1ASHhbxTqBwYfgCeqZtdVcjS3BApu
11021	payment	1397	1397	1678	1	1	6144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiLGLBJUFVjhShVzCqxNREXKLGonPN3HjPokmDmrA6LCjDNXU
11022	payment	1397	1397	1678	1	1	6145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGde3k6Vxezt2xyLW94fV5r91nLDV8qGAMjfnb29yvtU5nbPzP
11023	payment	1397	1397	1678	1	1	6146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm9JAxPnKEZYWHi6xasSBfop4TjJywPt6UwnD3o7Ve5w2KdJd
11024	payment	1740	1740	563	1	1	8	1000000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZQYqMqMVADtXPAW9XjmzQTqYDjeXZSVSGVz3KMSQro5jurguJM
11032	payment	1397	1397	1678	1	1	6150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiEjq2X3pUx8UvpyLG17fxC52bLvDyBgMBR24cFSskjsgeHYE9
11033	payment	1726	1726	1874	1	1	3103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY6Ycd9a9L5yiistcUVddAm77tF3BUCzos5QTTnz2axpPcZto
11034	payment	563	563	1359	1	1	4	7986800000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZ3cvATUFCfrwL7EfjHPBBfy4ZpSqVzAHtmyHLp8FdtahTFt2wq
11035	payment	563	563	1113	1	1	5	4248600000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZvLz52yuVjvpKdAAvBrRsgw4MYes37wUA8LERH2D8W72Dh5HRH
11042	payment	1726	1726	1874	1	1	3107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWevJrPy2wGbTm4gKpXGnX6UMFZTs5zsraZj95V8TTRzPERqmm
11043	payment	1726	1726	1874	1	1	3108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPuxKmKcx4pNrureVhUVKFSThmWrbyPPZ4cEmThNpbaidHeSt
11044	payment	1397	1397	1678	1	1	6154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoeknA74TuKKHASBhwEVS92rFcPXahBJvq5dgYT8H1qa1HJLCq
11045	payment	1397	1397	1678	1	1	6155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmntmbipBrc9MZqibGtt1ZwkBsFsmsoootodB3B5J3ctpMn8ye
11050	payment	1726	1726	1874	1	1	3111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCRnjwM4q5EWU2faw3c8bE6DASLYLZdcia7wJazMDMFkEjySg
11051	payment	1726	1726	1874	1	1	3112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJZqwVBnrEYEPH6vsha2bESvHiqBzP95yho4GPwYvgmsvSpP4
11052	payment	1397	1397	1678	1	1	6158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwk3M6KeqPn9YQJGv34kdPVeWd6C2WhZ3JXYZnNNh4cG7fzsRz
11053	payment	1397	1397	1678	1	1	6159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWwLme1bbcVaihhVxyPXQKZhHe7cQ73GcSckv344Y8poBdJw4
11057	payment	1397	1397	1678	1	1	6162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTPic6xLFHy44gh9Ti1eyK1Vm7zjM77BBDd6tGup3Zuoa4BGp
11058	payment	1726	1726	1874	1	1	3114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBstJKLJZrCWMJpe6mJvAuB9zEpYDyxPei7QzZvsMgDZdMj6F
11074	payment	1726	1726	1874	1	1	3123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJz4zyysTMpc3rY9rgZLufCKyTPsDxxf9qMAFqKB6kgy623Hg
11075	payment	1397	1397	1678	1	1	6170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9hFhLUCxV4H6aZdYheutQnzcMwHbPwhTRJDQTJpm646SfXBF
11091	payment	1726	1726	1874	1	1	3131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGn5sEHmYJVtqQuF46sczGM1gAn3Xw6ZbAY2ZRKQnRwTqLMy3
11092	payment	1397	1397	1678	1	1	6178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3RHqF9T2du3pbsbnbzYwLhnvZ2TXHbwuygm4iLn7anREk4d1
11093	payment	1740	1740	563	1	1	10	5239000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpZmbYif5Wzocx9vYbFfFe4BkQsSX9JexuNimdz1d5wGyDkqPEyJ
11104	payment	1397	1397	1678	1	1	6185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bjEmQQztVBiDTjejX8uFTNRar6uo279W52hLchyHQAMrxsWu
11105	payment	1397	1397	1678	1	1	6186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZKmnDUfYiUzTL8NzD6nCiTcWeY8uQzMuTRdyqZcjLmWYudDe
11106	payment	1726	1726	1874	1	1	3135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MPTvgh7ky5txgtUbSotp55z8mxnjUHmWyercKy2NTjSTpPym
11107	payment	1726	1726	1874	1	1	3136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqrmBet1tkUiEZU2R1b4uHvWZ1cSV1k1fZGAQWD9DMqVwAMFsE
11108	payment	1726	1726	1874	1	1	3137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouy4cmrR6YPN2EURnenp6iUqk6NNCoABAfbvecuemBKrGDdys
11109	payment	1726	1726	1874	1	1	3138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1omvDVqrW1pJDwc2HJ3Dau3t3n3btAakiTrwKqDJejYjGNmLa
11110	payment	1726	1726	1874	1	1	3139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpFjZEcqhwGJ22NVAHh3hhWw6fgaizxQPsYDKnWDFzcJLr9cU
11111	payment	563	563	993	1	1	8	2370800000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpYjDwvzZMJkkBDdmcHrVBQ6dTxHQvFH1yqcXYcC16T49pjfJY2o
11114	payment	1397	1397	1678	1	1	6188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCqZUBsT1cx5dy7gqUsDV3XLtHThrwU7qriPVF2DmMcj5SHPX
11115	payment	1726	1726	1874	1	1	3141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWoY9yndSTcVBetDLVkfAEvENs9dvh62erV9vTEDMFdgtoS7e
11116	payment	1726	1726	1874	1	1	3142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwdN4Wq4eUhVaNu6QznTbHjiznMLztytNfWYydRzZ38RmiWrB
11061	payment	1397	1397	1678	1	1	6164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosxcMN6RxhRPX5rdtPN7jyPMxScvaoNEdWLaNbgSBZQqp54Bs
11062	payment	1726	1726	1874	1	1	3116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJxYgNkkJ8ywdJPuaEBCpi31ucnMbEot2niefxom6uQxo4tG6
11063	payment	1726	1726	1874	1	1	3117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYchZFjYP48iiw9nWSUPyqLhj4HPTg2DQsqM6fWbznBYC1DvZTi
11064	payment	1397	1397	1678	1	1	6165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSLLN9ZAqmDicnahFd4vGDv6F4zoHUfCoNR7DZbJ4isiKocAc
11065	payment	1397	1397	1678	1	1	6166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCro7BiQ42edB5dSXKWMD3xGN3uaDs2hX5JcXEEZNPZw5Ybwi8
11066	payment	1397	1397	1678	1	1	6167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8doJFQWMRgc4mp5Mypo6ioKPkD6T2gb8t6eRf3qKPngGQPutP
11067	payment	1726	1726	1874	1	1	3118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJNn4y6sXA7P2o5xEb1vpnN9vBgcpppZQ8r3dwKizmrGeJDvZ
11068	payment	1726	1726	1874	1	1	3119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJxWctkMBr4T2o9XHn3674mVsYnWTLTjCMvmad4KqW6eQMmpx
11069	payment	1726	1726	1874	1	1	3120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThKr7yQbApMFcFjxXvkci84XQponYzeRdy3kMCDqvVUGamKMf
11070	payment	1397	1397	1678	1	1	6168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mJFLB3Qtf9N5r62YtdaqXqmYY9HA1HQN4MfWJFJ6f2qF2AV1
11071	payment	1726	1726	1874	1	1	3121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nyN949NqMbsJLDiygqsD4MkvHKmi9PbX3VuZJJVUsVCZ3xUb
11078	payment	1397	1397	1678	1	1	6172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVinpixe1RGvSxHqR66CmmZPhd34EDu8P7xcoioi7mZsxAYKXE
11079	payment	1726	1726	1874	1	1	3125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJmxRJWxQXgdEfzgTt3JenP8tjPJH6XAedCWQywiBivAYFVE7
11084	payment	1726	1726	1874	1	1	3128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsBzvjonS6ytXo1rzXaL6x7KmarJCDQpP9SEhVDxMhGfjBNVP
11085	payment	1397	1397	1678	1	1	6175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvMXYfkUSvvQZ7oW7FqpqfJpNpnEj6AoSm7MCNTuYzJJJnrFb
11129	payment	1397	1397	1678	1	1	6195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsuwT4R6WxbNEsa88mawe2hTJjGZoLa4LismbyNjzc8FVGXSB
11136	payment	1726	1726	1874	1	1	3151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyCxVQYvedUhc4EsTunFMGQ1bHeRDr1e4fmkxEtP4CR9Pvsav
11137	payment	1397	1397	1678	1	1	6199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNqLMktGUmfZmsobRDXrBRU6JJAwXazXZMt1ncKgxHiFQykZ1
11155	payment	1726	1726	1874	1	1	3157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBtrpb6JW6dkmSyNA3xm4ypfKAsiBsmGV7czykP9wUJXggaPp
11156	payment	1397	1397	1678	1	1	6205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8pn7iSdxnyuYb8s4feDBLVCwxRaAUG51WyrJATBqSUaZtNaH
11157	payment	1397	1397	1678	1	1	6206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsienqiC8Zqe7Q6M1JxAW7r2Q8LgLGs6Cs7aR5mWPyoaN8ajms
11158	payment	1726	1726	1874	1	1	3158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VXfnTKd13rNsebWr8a7JguyHMW8j7wXQKMFzUtuhWyYBhMLF
11161	payment	1397	1397	1678	1	1	6208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR65r9WT2yUzJHtiKjpZF4WMwNPkQKC5hDqq2SKTU1pHQc74aZ
11162	payment	1397	1397	1678	1	1	6209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCL7bG1W1iu19qJWxSYSBv1KVmFbe4MD8fZGems6Mt84QDqGvK
11163	payment	1726	1726	1874	1	1	3160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BPi9Rm9tPQRDCKeNRjc1CnAM7ixbp3Kfqgbagb9y9XdgK93f
11164	payment	1726	1726	1874	1	1	3161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxNfky5qkpe4udq1t2SZyCT2nvtC317ZqbC72WSuMTAa7Vd37
11171	payment	1726	1726	1874	1	1	3165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRnVSAWnXxnD4U8U98TULueNkYHfspzzHHogn7bp9FCUtcXxv
11172	payment	1726	1726	1874	1	1	3166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqbYiQJRDBiGh5oRFpasLvwaaJLiEoab5qo4A1H7ZttvuoDRn
11173	payment	1397	1397	1678	1	1	6213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLCJG6aN6N3j3Z63TL1PXhHFjjNNEReifN7grzgtuaSPpBxBf7
11174	payment	1397	1397	1678	1	1	6214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJeX1tL4wb6H3GPiXVh5Ub8hB6y38AzkHwDNwSgxf7q8eJXma
11180	payment	1726	1726	1874	1	1	3169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4bdYRSoDHznNmzZcm6Sy6qafnud2F7nk7oZbg5m3DVu7hfBp
11181	payment	1397	1397	1678	1	1	6217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8WpUAxAScAVNcJnpw9p9HzjTerTMsBg8uMA1d3HmCaMoDd8m
11182	payment	1397	1397	1678	1	1	6218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzF2tXQbQ55qewgXd4yoEvvXHLspt1s26V3cEhbk1jSHMm4GoK
11183	payment	1726	1726	1874	1	1	3170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rimK4m2ncFkMJQ4TwGT31UjpXCykd2Ujnw6pFpqTPHR5MX8X
11184	payment	1726	1726	2030	1	1	3171	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2hS3mAHaWreXggrdA79ZRB85ZXBedfXQhKZ39GX7XkgBk5RAM
11198	payment	1397	1397	1678	1	1	6225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCijjCz8y41Xi2TuKPafCqZViCPk2zbiozQbBfKa9K2kWzZFQ
11199	payment	1726	1726	1874	1	1	3179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAArLmrVzmKF7Vnvg7ikwJN6zRDSwLtWeP9bBZsx3wdz9oDNoy
11200	payment	1397	1397	1678	1	1	6226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kaB1afEfRT3Hn5EdQ3PNZ71mUx5o2RtCCE7VvCao2sqXFihJ
11101	payment	1397	1397	1678	1	1	6182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCeJkQygatXAVcSByCPjSGDFwruCRrMgqs5F8rLcJq7dZAA28
11102	payment	1397	1397	1678	1	1	6183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvnqyBerW16EEbfdqCpFcdxHDArmgadZxKeF2bNWhtaP87gjq
11103	payment	1397	1397	1678	1	1	6184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVRTQnEhrNDVxirberZmiRDFo55NWeULxjLR7dxrU8jiT12rV
11134	payment	1726	1726	1874	1	1	3150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJrzaC3myP61U1iN6hQkw3Y32SuM7uXjkzfRTeSRp7KJxandr
11135	payment	1397	1397	1678	1	1	6198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHyzDwDzpX2tCL78r7ZnB92TDKAZaaM8mwK86b29FRU9eS1ZD
11146	payment	576	576	1229	1	1	1	2805240000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpaFWP6cmM8zkxnwwFJeLv9PrVnKW6DXYyF8xPouTR5jeTYmKW9f
11147	payment	576	576	1109	1	1	2	4157630000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYsKTDzzLgPzqKYGNF66ivoFhSmKCTaDuZz1mTtwp1A4yF4Xggi
11148	payment	1397	1397	1678	1	1	6203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRk5TxNtLwGaK3JDLfnvMWupLDNGUCZG69CTv8TmE3Fcn9W3Es
11149	payment	1726	1726	1874	1	1	3155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsNXdzWAFCqx8TA1buYPQdVxHvTrmiAL9iPqhwhiYmsjBdSzb
11150	payment	2028	2028	1310	1	1	1	8294657600000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZ4JCSu9Vi3KvMomzobuJ2Ut8F31HMK7CNWME84F8gJ3K8SHMdH
11151	payment	2028	2028	1184	1	1	2	2976634820000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpaBRPk42xp3MJjF86x1A8c9269BWH6reCVhNTmKi2bVuViub3m7
11152	payment	2028	2028	1064	1	1	3	4411659870000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYXL3oiVWC7VaxBswvGEa2vQe2NANg1RBHvmm5UrsSoSYsu55bF
11153	payment	1726	1726	1874	1	1	3156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFpREAJS3skrYB1MUWZLxvyUCGTsiHeQSsoDNRHKYJAsirp2e
11154	payment	1397	1397	1678	1	1	6204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvPQm3WjUMR5ubZiqtwkKwp3n7KnV5PZJ27TCku1CU7RhAJfH
11169	payment	1726	1726	1874	1	1	3164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg63skit38T7DLPKrC2C9N2Jo4yXnRBokGWrp6QjF4KhmDfJwU
11170	payment	1397	1397	1678	1	1	6212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6SeX9RoVs5KMXMaDW4xogEaG6aJ98k2RV4VyhkfmdvMQgYgK
11192	payment	1726	1726	1874	1	1	3176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtR9e1vA7bZPGg9vrY7rYCX1QYuju7VmJq3bvPBL49sVbp7mX
11193	payment	1726	1726	1874	1	1	3177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Fdh1hp6bPHSYEUzvjqAGCBtiTUczAta1ojX9LbUThAimaC1z
11194	payment	1726	1726	1874	1	1	3178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWz8Sm73Z4e89RgynHU41NsLU51kzmAcww3XTBRBddZhZN7Kg6
11195	payment	1397	1397	1678	1	1	6222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjBBKD4wntRBsF8rHB9XUSw3HsRhwXPmTzXkgP1XJ4cRUJWCW
11196	payment	1397	1397	1678	1	1	6223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nsPtKRj7JfN3jGDakir7NuYa5VdEB65eu8zNK1RDVDbZyr7C
11197	payment	1397	1397	1678	1	1	6224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbhi9RUe2UVhWiYLxsQHsqvKbbMHNtiRYwuG5aUpxtWYybnRN
11202	payment	1726	1726	1874	1	1	3181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ66zkKSS6LEERHXvL1WLieZvmnqfLmhuSDvNXHqq7nsA4HBKGs
11203	payment	1397	1397	1678	1	1	6227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn14SY7xWY9vvaz6JbTNQQPbMXNbaGeo4kjbSnrgHFRMjjo53T
11230	payment	1474	1474	1083	1	1	9	3825014693893	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZ5PjUXMAhm6Yzkw8AtNZ5aeZE36R29gVezGrapreyCeXsZFoB4
11231	payment	1726	1726	1874	1	1	3193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8scDc7nVckzzydSdB7xB9MX4RmhCcbaasGnUXguncAGFArwz
11232	payment	1726	1726	1874	1	1	3194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcoFNrascPxytySoDoDHZBCNvP1A7dHghqHSgUbtaY8F8aYKwR
11233	payment	1397	1397	1678	1	1	6238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZun9BNU6eGz7b83k9Y1dhEvVeMPYja5ZAQsVGo9Lk4JuRcTdoY
11234	payment	1397	1397	1678	1	1	6239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHydNscpjbFBVpbvL8Ee63Cv9cBM9nsM6CK7fPoJVxeP1VMtiA
11257	payment	1726	1726	1874	1	1	3204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEvxBqeSkT4vJJqngXMfFQE89cxPm12zp6byNeYsAprNQBKjC
11258	payment	1397	1397	1678	1	1	6249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFxgsKsUGPrEB3ezRuUN5kvqyBXoechKqgzLYQj54E2SaWXHz3
11259	payment	1397	1397	1678	1	1	6250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB6NmAFb7KeRgzPfKKs8g8CQB6cvxrt8UMDm1kTKkuphWdTgaU
11260	payment	1726	1726	1874	1	1	3205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbHTX85uz4CPooddZ99QcRD1rj5vgftxKRQunYeN8Nv5K4Fbb
11261	payment	1718	1718	1474	1	1	3	1000000000	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZAADiXUzjtQ3dM4nCtwwuFv4xjNhxYaFpQAP2KDrFFa3Lv7wuo
11268	delegation	1894	1894	1540	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmL19VCyJXe77jMeiDTW8feVr6FFoUHz8L4Pu3X6wXLZ6tC333
11269	payment	1726	1726	1874	1	1	3209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsnqkBr452mxBxpHdQsARLohLYMtYJpWeZfPXtmhDDdSuyXqf
11270	payment	1726	1726	1874	1	1	3210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBmsRUJsLJDqP9FyohiNYq2jrKndBfJ6RKGB9mwgUPSSLeh245
11271	payment	1397	1397	1678	1	1	6254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLpBKTRtsygBrJALfRyeh6G2XgCKkPr7HByhEJmkq8bkLmCs6
11117	payment	1397	1397	1678	1	1	6189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFdqdXMATxfFue9w9D6LDW6T8GnubdwXd6t4RSJLMacLopPrF
11118	payment	1726	1726	1874	1	1	3143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRr6PMStkw7uA9kwn6aJZaWdXp4VS58bVfU9mZsw6GyLigmT6T
11119	payment	1726	1726	1874	1	1	3144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6421jsURkTzjhyS4xbFYDc48YN4ULWXEzw2BKHcMiMuB8E3DJ
11120	payment	1726	1726	1874	1	1	3145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiBhXf18yi3fnLzUciYWS8bcF56UCAyjX3577qReASyAqPLkL
11121	payment	1726	1726	1874	1	1	3146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKggNnB6Nn5gxATbA2df41AJDgsVFdYUD4bqnML7VDV7hQc8g
11122	payment	1397	1397	1678	1	1	6190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfspoZVCrhHeKhKwCwt8MEhpHQwKC5EkTj1oLGbDo28ZaYbX9
11123	payment	1397	1397	1678	1	1	6191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bcWeorFKdEDSBscy4x2p2HeXUvUDWDvhApB3QBvDescgm5vN
11124	payment	1397	1397	1678	1	1	6192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTVaTdWWfn5iGWQZ5VxTjbTNPE6rHQB5mjb9ChDVoeWHtGKVs
11125	payment	1397	1397	1678	1	1	6193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9fbCmFPHayYCYW22GcdYe3a3ondy3PdvT4GvmbFvdBF9dmjZ
11126	payment	43	43	2028	1	1	0	19440100000000	1000000	\N	E4Z9wy61chZh8Zcy69t2kWC22fjkBr4coeu2z9onURnuBkmeV3Uct	CkpZxjUu2mmnKs22twRkKDE73SaGGLkYiniuxuzjCUBKCnopch7r7
11127	payment	1397	1397	1678	1	1	6194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFX9TZcV19xfyKddSJHuo9jkPRMG6ybFMERgQj83o6nxQRamqa
11128	payment	1726	1726	1874	1	1	3147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXE8w23w2zgpw4LxDn2u8J9X3viKWX4zThDgbKsSMZhTKprAE
11132	payment	1397	1397	1678	1	1	6197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgZBBSibyftcaEuiwzdGfLcmfLDrqsMcUA52qtgEiWbJvvTKF
11133	payment	1726	1726	1874	1	1	3149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NDTecu5VqAnfkwN3f7Vci3YBh9gUwBDQp8XbB7B9UoBcPePz
11138	payment	576	576	989	1	1	0	2320150000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	Ckpa5Yt3VR5N2gJUCNgAbFvm3rZgd7ECVuRkoSv3w58dtCRzrfFPv
11139	payment	1397	1397	1678	1	1	6200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDc4mqpq5Bnmrck17Lijpo1wCTUWvmfa6XyNERiZ2fHU3yhx7
11140	payment	1726	1726	1874	1	1	3152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1WYuuSw9Yua7pSKkjNkfQoA8W4ZrwQ6vaGHTS1U5AdgXuAr31
11141	payment	1726	1726	1874	1	1	3153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kQKbD8b5eLBtqtw3UNZV7BKuUB5YJhJFriutrSCYNmfSv1WK
11142	payment	1397	1397	1678	1	1	6201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMq6jKghaXpA2EoF2xk71WAqbemGQv8rZCdTvRKhtT7HzMbBE7
11143	payment	2028	2028	944	1	1	0	2461875540000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpaKytcsUZv8bZUQhZd7VGRBR5o63yMnJwAjtrNFV6LbvpSF1Gcp
11144	payment	1726	1726	1874	1	1	3154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD85UjW53x3GRcqYeSmoayzvVzbu6JccnRc5Aqf5frXTGouF6
11145	payment	1397	1397	1678	1	1	6202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9GJcNFZzrvyNGv8UJdURM4TbcT1viyzt3bP6EeV44YpVKhyk
11159	payment	1726	1726	1874	1	1	3159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9psbNS3SwEtjYQARCsGUe9whgKxo8497C6eAbmTD3KQ7DjQL6
11160	payment	1397	1397	1678	1	1	6207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQphwxecgxGWPLtGSyz19gAn1fwFjXuH2YUVCrzrDEAdL5m4VE
11165	payment	1397	1397	1678	1	1	6210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8iNYVJBBEfZQ3rQoh4LdoHAfdEA2v6kpT2ZKdRNqLUQeYw3r
11166	payment	1397	1397	1678	1	1	6211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzDQcNApjE8xVpRqfdMvNq3Xgk2tVGSqtsGbj2NUczxpCEiwK
11167	payment	1726	1726	1874	1	1	3162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8u5KXJmJmggCc1vaQydhcd62zUxkMVT2GqcbQ4ZKG3FGFQmT
11168	payment	1726	1726	1874	1	1	3163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaHCmC57H1MPM3VJALSWfymPrJxTMHrVpAJ9iUDPTJuQpiRZf
11175	payment	1397	1397	1678	1	1	6215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWQY5ZtrxWyHQRHPE8op6EYBS1erngqDdRKBLM5uBUDyNyMn8
11176	payment	1726	1726	1874	1	1	3167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguLSELqti1o5N8n9MGNRGn5sSNecRfvgJUR9HbS7PJehMNqk9
11177	payment	1449	1449	1939	1	1	4	715000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZju87JJKeKfrJbX9jpqYXsWRNPjHNtvpZ9ECSVPif7ai9hi6Eu
11178	payment	1726	1726	1874	1	1	3168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2K7hbbNuLUPYzVA1xFsBpAEWsuPMijBd4WGXp8SSugZFXJnhm
11179	payment	1397	1397	1678	1	1	6216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dkNVQEZzF9BXsooJ16DPjRDX5KhkbVWmkhYS2KmAXP9Ju2Q8
11210	payment	1726	1726	1874	1	1	3185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRsgBGcEvrNpKZvGoW8munqeaQr1PeESeuzMgjxNnk5zkMbU4
11211	payment	1397	1397	1678	1	1	6231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fJwf6yDA9S2ReQPKpo5uYTUhGqvDjXWDkmU1wBjHWJh98DbH
11218	payment	1474	1474	1541	1	1	6	1000000000	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZ3VNww7ZmazUn6r94t3hMhrVcUvxmNohvcs7zkEaoWpWCig3iE
11219	payment	1397	1397	1678	1	1	6234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpooKNAcFNNJu9Yktq2y5BKgqGMUJc6hHiP7kDqMDJjKLvxK4
11220	payment	1474	1474	1541	1	1	7	1000000000	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZiqVj2h2ELNCDDGE42kgzURZMZbHjJz4pVC9dD4oh1mZXSY2Kp
11201	payment	1726	1726	1874	1	1	3180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKs8UdFN3ESbqY3TS7sLup1Ppopwpi4J7iU7rtD7jYvcMXDCJ
11204	payment	1397	1397	1678	1	1	6228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTaXBoRYSijD3uyyZKhMzPYLUSnYwp6mePL3dq7DHGSu8XN8k8
11205	payment	1397	1397	1678	1	1	6229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawbsLn3zUbvRv2a7ak6XWKtvkyN39Ciz3EkTNCTQNoSpzrFG1
11206	payment	1726	1726	1874	1	1	3182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJTbrtVTAkmVcYayPWkc3PPEx7yee22xS7DdJyGjZhQHcERuG
11207	payment	1726	1726	1874	1	1	3183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6asN2RFtkCNosEipaBRw4Dw76gSB2xRmua3kx9tLvNYMBPnK
11208	payment	1726	1726	1874	1	1	3184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhWbbUK7mFPxj7zFDAPreaCvDpUYqMoeAHbJyWRtdn8zhkK7v
11209	payment	1397	1397	1678	1	1	6230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtrjxHAUrEzDK1CjJZeRuFK5uGxPJ91baZs19Fz5QKc6xcccFC
11216	payment	1726	1726	1874	1	1	3188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3c63RVxnAxZM7twn5EHHwHiGmXP9TnqWCcgcp4cpWuaGYp7Mf
11217	delegation	2031	2031	95	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXWUVFAfUa9UsbWC6XPi8eVzjdqEk1XQ1sisxz1zahsQiCfev
11236	payment	1474	1474	1203	1	1	10	2580813632763	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpYqgE6dfM82sfLaNcrgRUvgVoKPUVWqzcU2cdVjQo3iEkax2aDk
11237	payment	1397	1397	1678	1	1	6241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bnHyukSVNdwCVyWJ16aFRQq7378XeAyKwbEwdDA64Yt1NfJ5
11238	payment	1726	1726	1874	1	1	3195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcHhwLAy5TXHEhq14GLA6nZacQvfLAHh4op7wUm1oXpWAVbiw
11244	payment	1726	1726	1874	1	1	3198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgC4Z7bpafej6fW4tT82yHk96jE1Y15D3fK2rxeCuSrMpXcUn2
11245	payment	1726	1726	2032	1	1	3199	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCMkk5FfgzMJahfiwtUS6Sd4wGDAiDbnmMqur7WrnpKBoD5BTk
11246	payment	1397	1397	1678	1	1	6244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9J9WEwQ4kCKPC5fcRqiUX3jdG2wMWRFNU45dzG5DhmnSeDpJ
11247	payment	1718	1718	1474	1	1	2	1000000000	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZyLfDrMrpmyrb8BFRxDdE83Ejm6ziP82o9fzWBiJZuxakrAU6L
11262	payment	1726	1726	1874	1	1	3206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWqJBXNyLo6cyqWLbfHozcC2vUJTcFx1hsukviiHbiopsobkh
11263	payment	1726	1726	1874	1	1	3207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBV8rp99DrDZoCkXRgLbuF4AmHkLWEnBoDATEmYkVhTt3VcJe4
11264	payment	1726	1726	1874	1	1	3208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzcLUfwmiiwbooRoeGVndsXwrb53JhMVci4x3CSzRyfDRxVZv
11265	payment	1397	1397	1678	1	1	6251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uQB5xxwdJaaC6P1prNWfELBRw8j8Jok4SzsxB3JsFNm26fZD
11266	payment	1397	1397	1678	1	1	6252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HNAFnMbZv7VKdnFdNo8FgjujW1PspJme7W8WK45ef7KfBpss
11267	payment	1397	1397	1678	1	1	6253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyDPEcFX6S1VDbHiDxyPYfeDbReH6m9AzxddMjfQb11k3VfNg
11273	payment	1397	1397	1678	1	1	6256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXjVnJh6jg3KUHy5mJxRYcmvW5iFRjbk3sj1nRNgqqKEvpwpj
11274	payment	1726	1726	1874	1	1	3211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kNkbsnqQcadzgCCkWQsvhYGerohMKqajHVdZpwxxwkXdhhLf
11280	payment	1397	1397	1678	1	1	6259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRvK9yvPksuyLB2YH6yaS4uSfTncmXR8n6TC7c5C1ATgAEfc5
11281	payment	1397	1397	1678	1	1	6260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqygkrpjNzMihuAbQscX9CFoPdz4LPuCJb9Hq6BXCYzpUm596
11282	payment	1726	1726	1874	1	1	3214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtXHbHywnSmS8hKkoctqx4umvx4s9GXWx2YVAwrS1t8PLYGw4
11283	payment	1726	1726	1874	1	1	3215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnu5gi9LrWGJPzFiy9SyNn8e1WAZeB2AiAZzi8gzUYN9h5tm7
11290	payment	1397	1397	1678	1	1	6264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpt3yiQ15i6zeTjacjA6SbWTV5NSkUQg9DFGyTNL4AeCKowsp
11291	payment	1726	1726	1874	1	1	3219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxo7mRzyEoozL6PfBFmm4p3zPGs9SUYtBu3aM5fAoRuKs2x3s5
11292	payment	1559	1559	1107	1	1	2	4735940000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx2ft4a3jT4tmCnTgmN6VqeNsSkwL21bNDgrLr6s54jokXguC
11293	payment	1726	1726	1874	1	1	3220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgb8gSAUo7XUZNw5htyyC3tApJcdGHve43PcQDBiHWMvXrtXi
11294	payment	1397	1397	1678	1	1	6265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9njZFNfVFJjindMBRBPDc9rcMujmC76fZ1aFUCbdjQmAJhRc
11295	payment	1718	1718	932	1	1	4	1732480942128	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZHraRY111pKqdLGEQQRbtGUd1MN1vhsJ64tGWU5dMZkLpkthxe
11313	payment	1726	1726	1874	1	1	3227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbHiV9AUrPhTwXFQdQx2zDokdVrRm3Cojb9ReV5JvwjYqjz59
11314	payment	1397	1397	1678	1	1	6272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sEj4acd1orxxf7HgkMiajJaaHM8E1WsCTETzKcrPJ2bASDpq
11315	payment	1397	1397	1678	1	1	6273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL2V9ofxz7oJPmcnCVfNh7m2HRjGGLYazdxhvMD7WDWRxaL9DW
11326	payment	1397	1397	1678	1	1	6277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GxuAGsFQoFxVk5Dw3KNDVTdZcjqLdgKt2ZNeHizuXCcJgfxj
11214	payment	1397	1397	1678	1	1	6232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cRMKJodSNJkpP7Ea9cqtLmBFjeMztJHraJv35bQwEkQykrP7
11215	payment	1397	1397	1678	1	1	6233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Vef4EUvqGJhUUNPyBwaxucnsKznUAqHnFDtWsuyuWtsT3XyK
11222	payment	1397	1397	1678	1	1	6235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2jJaHVHHtrsJspDDPYgqSXsbR5M3jp8xmaRHqCHNu7bj9MKy
11223	payment	1726	1726	1874	1	1	3190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7JkKrDxFRnB6Y9D5xQN6FQWkqXGT8sRzUi9EKje7hZqc5e1M
11224	payment	1726	1726	1874	1	1	3191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQNkTbnvJLNCwFTpj7jpjt1HeJ9U8sB9qAZoNLJsdzbd9xnCg
11225	payment	1397	1397	1678	1	1	6236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQUQ8ffk6NEtUtP57c1F7NTbfLWmoaWit3VZgHjzsGnXMWJb8
11226	payment	1726	1726	1874	1	1	3192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8byGFHKKFzHVTmWFt7qD8Ya1yKoi3fXMtwGVSNEeef2UYdit
11227	payment	1559	1559	987	1	1	0	2642840000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppoQFKrQeYCkBmkZGnPAJvXCjpDVNWxAPdTsf4Rthyb2Sq6KU
11228	payment	1397	1397	1678	1	1	6237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyc6TyKeo62TgzFcACim5qVh97B3gKzL7zgXm1c6dxsGx2c3rm
11229	payment	1474	1474	963	1	1	8	2134505012457	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZTdGMUnYgiUAip8NbadSQ4zDsMY2ovLPPsaxKAGk2R2BzQu4bN
11235	payment	1397	1397	1678	1	1	6240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdTRaD54fw3trHBLXCKSnvdd95PUMPdxu74GzdoGBKKZNm2GZ
11243	payment	576	576	1355	1	1	3	7817030000000	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYqxQ2qozKM1EUsSE6xBx756tfP5GakLxMK6YFcYT2xdYAmA3pS
11248	payment	1474	1474	1329	1	1	11	7191666660864	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpYXWeYNgj1NHsjcfwDwzecU1t83ZGcXjkFgBqKMSrKddiSAaEnJ
11249	payment	1397	1397	1678	1	1	6245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXrkBTYJGKHTL5nRCLTXrLr2kYDwqP9EDTB53zBRpAknZHTbAJ
11250	payment	1726	1726	1874	1	1	3200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhz5fhk5BcTYv6PNGN7Dr2Vwo2RyTkohcQudx5tzJBpN5rYKo
11255	payment	1726	1726	1874	1	1	3203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxm4KrDhvA2UdBJ8qJgNL4e2iiFGk5hKhmwzReWukEurbTxMsz
11256	payment	1397	1397	1678	1	1	6248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6D7veF4skr5GxFvLMNxpTR8XjxYBTtfjWQCpBHN9xH3TiqKRu
11288	payment	1397	1397	1678	1	1	6263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjuf7G7K6gjwwVZSXHRzjUHqZLQ11GfceCQq139tAGKSNp9gm
11289	payment	1726	1726	1874	1	1	3218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevaSvvLmfsBzhceqdgKicqKxCFGCmsqrXGfdWtcvSijyCGLf9
11298	payment	1397	1397	1678	1	1	6267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShBY4qhxCoSwggp4MbV2cjiAvqEqmQfdfyviDaNqodQTVDFs1
11299	payment	1397	1397	1678	1	1	6268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrTtEbGyoLou1HPa4kueiFTBAUS9ypMcHcbeZrtQf37QrCEta
11300	payment	1726	1726	1874	1	1	3222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTUb2QU9cH2WHA65EiJPWm5VZAFYjUkEsNSNbGHdNhy64a1SU
11301	payment	1726	1726	1874	1	1	3223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPt1LLqwpXn9G5NaUQhGRPJZykn8wJEgCS4K2R8BTitm2ou7f
11302	payment	1726	1726	1874	1	1	3224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdx63ppcZa22mmumEZfezThnJF4epEUfaqVY19exFmrbN1TST
11303	payment	1397	1397	1678	1	1	6269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCMH8hTGeffbVyQQjdUSmpPv3DQA2aNR7nRqyU1enFZtoTkzB
11304	payment	1559	1559	1353	1	1	3	8904360000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWLrRmB9ej68FnR8crVUtGzWh7YuhneAJCCpkgpfojX9ntBV4
11305	payment	1718	1718	1052	1	1	5	3104591004405	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZ8L6cjD8w9x2AJaWmME1SehL6jHFYPAZvActUDaMnUCYtJoCf4
11306	payment	1718	1718	1172	1	1	6	2094729414015	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpYfVUhGT6G8hmZmGw7tBaFDCvZGKYGtDNPHBCMGwGByHzPvCNR6
11307	payment	1718	1718	1298	1	1	7	5837149765120	1000000	\N	E4Z2RVq3FLLi3LTzp9FUz5JFkvJNULWgFbcc28qudJiq1Ld87a2Lu	CkpZNTCK5FQjxUByNMHoDDf1ycuYCnF4nCq5NWQuUUPmknVtQzHii
11316	payment	1726	1726	2034	1	1	3228	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa16WprNEJLhUmMnn7W9SnWvRcTCX9sVXCRku7W3ANYPf6REiEi
11317	payment	1726	1726	2035	1	1	3229	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtXT6fS3mgz733xDe8VtUjnDLQndeZ116GNkMkJmRkAao1jY3u
11318	payment	1726	1726	1874	1	1	3230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTR8twzWSSh4FiKK3TSXMALoq8uoQEtNVCjUQ5nRRsde8Z2hAX
11322	payment	1397	1397	1678	1	1	6275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6HeopiJVc9NZ32Cf1BBkATP5kf7KgHqZdjLPxNnoeb2UnBCw
11323	payment	1726	1726	1874	1	1	3233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTQ3ZbGpsvniLxXzHEfmBEGHbemW2BVoE53cEg5BTJZeqDCUF
11324	payment	1726	1726	1874	1	1	3234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4Y97oVqn7bd9b4YfYncPJy15gGByHQ6r5piXgvAa4DFPEcTY
11325	payment	1397	1397	1678	1	1	6276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZUsSZn1NXC1Pc4yAmWHEx8Z8G2yhUZe2Hu8nSMJWqz4SUgxK
11329	payment	1397	1397	1678	1	1	6279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGrCbdpmApwGtGoi42tfFYiq1RxVjWV7s766LVgZjZ9wpiWTX
11330	payment	1397	1397	1678	1	1	6280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjfZiB69cShWGUYtiYSKu9mUqTHaxeu5XSR5B1qxF9ebAwXKb
11221	payment	1726	1726	1874	1	1	3189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQSkoHViddZzW1tHp7ohkYNF1dthLcJ3VtmsvJJRLgN1byMsY
11239	payment	1397	1397	1678	1	1	6242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8u5kJTJnzvAbJpZb99SGAzYU3ZpcpDmEzAb5bRi3p3Z9ybrCJ
11240	payment	1397	1397	1678	1	1	6243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC12GX1VGF9AfXQG5s14eQSvMu3vyyLmzq1wGNPfwaZVxNxopw
11241	payment	1726	1726	1874	1	1	3196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPy1KZPC2YvJs8PwnxnHXh2Z1ohpPu48RwYHtMRYMPBJ6kRJ2
11242	payment	1726	1726	1874	1	1	3197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5Ww8dETTxsoAxpUCk3KEas1qbxHqSH8bo6qVPo2AVAvsupfs
11251	payment	1726	1726	1874	1	1	3201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9GHCmNwJw412fouhsSN4k8P9N1RYJav7qwii5q2MoER5zn8o
11252	payment	1397	1397	1678	1	1	6246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44pD621aNkhFGnazyoEqhftwE2Q96pMXcU14enzYvHCwqGM6p
11253	payment	1397	1397	1678	1	1	6247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzhbqqjoz7W9dL4JEjs6SJKGLxPAG5w1nrUyg64GRoizEDfgma
11254	payment	1726	1726	1874	1	1	3202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3o7BqzFMsbrVwupgs35SUs3Y7M7SHExBqwrD51Jsed9jEzVA
11296	payment	1726	1726	1874	1	1	3221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNTfF3LyrXL9RPwiddZpF4gqd5T1ubD6WBZ68Y5TXDB3ZkKcm
11297	payment	1397	1397	1678	1	1	6266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRUusguVAdE164wK5znY8WzmijnH1fy7vzhJgKbhjnPyFTd3P
11319	payment	1397	1397	1678	1	1	6274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ruwcYoPEzHMT76rY3n9ESG2e7MoF6Fo2WR77G6J9qGDGnN3L
11320	payment	1726	1726	2036	1	1	3231	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCCdxFuaDX48WymLVQqMCTVRu7b1puvSkkmBvuEnn4MvSZGSTC
11321	payment	1726	1726	1874	1	1	3232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnrFcUVsJ65BVsfhEG9SsribnxG9YeVNASgKxPR5pyfVyDj4R
11327	payment	1726	1726	1874	1	1	3235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8SvWXPoNLLrxGCBuGyYt75jZDhKHf2q5q4anyrJ7emNr3sCx
11328	payment	1397	1397	1678	1	1	6278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2StCF2p7z7Cc54USwvwdYr1cZqWY3cGP3pQLpKoA8oUJuMJDe
11362	payment	1726	1726	1874	1	1	3247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwECxiZPSEFMRfzFoYU4hyd6KeTSbxCqmiPFGtus8vTyfT4gc
11363	payment	1397	1397	1678	1	1	6288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YEJeKDpJtwxFMvq8Navh32tv2gme4Kx7ANjBSZVVQwUbaNPg
11364	payment	1506	1506	598	1	1	12	287273000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhpTmDQ62erJ6ZGFWMRctPX3YZbhrjUV9MeSPYM7ve1vwv1eVZ
11365	payment	1506	1506	1007	1	1	13	2188398000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXo1nc41VCQ76HVDmza9ER3qJEYCXMjGdwiFJTUz4Z49TJRqxa
11366	payment	1726	1726	1874	1	1	3248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiund6LMrzvg8pWwQQCspwgU9VqRtF4QMpe7jegJyrUoUVkje
11367	payment	1397	1397	1678	1	1	6289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieTEsiPnvzFPQHPQHPjXnzxKpw3YWEvsoy3JXB1oHk9JwbhQc
11368	payment	2039	2039	480	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZKrvfDLUf5H2gwrTkDhSxFJSE4usysjW7Z3RaN9SxzTafJMs
11382	payment	1726	1726	1874	1	1	3253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mQmrqFtSB3kUCkqnd69ZQgjcK9DaaxrLh3ZEwp1ySoT2ijgz
11383	payment	1397	1397	1678	1	1	6294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGEbgbUDGCBnWVgxZBZTb2UBEfy3WcnTMjkd1CU27ypxmZnpff
11398	payment	1726	1726	1874	1	1	3261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7yXy4u3uPeLixpWNmUECRfbeMxeXLynHy6iEusiea3uz7fEU
11399	payment	1397	1397	1678	1	1	6302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEDF3ENAnbTkg2UEHCKMDvgUo44btskS9PFX4CVTPayJ4ddxj
11400	payment	1397	1397	1678	1	1	6303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQH6aEmP72LDu2bjk5w5TBLgU3ed4Sy2ChjCn9fTSAXEMp2pa
11401	payment	1726	1726	1874	1	1	3262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyHjTXhXba8mFLzQ7tT719nLqqqExwoWfXjsq2NiDH6meLyuV
11402	payment	1397	1397	1678	1	1	6304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCVZK3XvtXvkxBc7n4NVnwyF3cybN479xLMj9sguohA66sth7
11403	payment	1726	1726	1874	1	1	3263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSY9vq5Dg9QiLdXGFG7mAtUnTFzn11t2pF6WwFqqkkirdj6yz7
11419	payment	1397	1397	1678	1	1	6311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYAGUHs7JYFtxLRordrh85jDCQjvF6hrAx45cmDKCavYXopP9
11420	payment	1726	1726	1874	1	1	3270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHjfvetqEEqGVmGH6bz5s3RwzjrBtrzEcuAvB5KxWob9Gm1yV
11424	payment	1397	1397	1678	1	1	6312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EW3ZeSDRFyZ1eTmTJ9P8LMF9YYDZFcGzShCUqJxmS13LnqjR
11425	payment	1726	1726	1874	1	1	3271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtgrcQ4DLEVpZPKc465jejboDPY4mgJDiMMGYWShe8zaJPX6n
11433	payment	1726	1726	1874	1	1	3274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9yFJawo6nViTqLiAimh7CDi1anGT2q72xo2RPzxvnKCapQZB
11434	payment	1445	1445	924	1	1	7	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfLMfqiZm1CyguJT45vyJR1FcanFCvtdCdmYxiU83VXEZ88S1
11435	payment	1726	1726	1874	1	1	3275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhufXsV7x3VGQjTTQXr7cqHNzHyRqZuzPUgaBHL1nB7XWReED
11272	payment	1397	1397	1678	1	1	6255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5zu6Wi3qDehGnT3dMZbp1R2LbeXLXttM5EsgVFg4BqJaCNbB
11275	payment	1397	1397	1678	1	1	6257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtixGuUFX6yZx5MWSWZBARYQcDaRdNAr2QDvXqhhmzxRBnaoQ
11276	payment	1726	1726	1874	1	1	3212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCXowUsQdfZzvkprSrHXEQ6aUarFo4yYXsJVmRgPGifiwGpvw
11277	payment	1397	1397	1678	1	1	6258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXHBXKEcPUNgnkcMYLRqT4n18kPBcZnAFzHgPm3rZVRTxMiMkx
11278	payment	1559	1559	1227	1	1	1	3195440000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iQNjXTTmxxN2wTqtDiq7f458y9Uceu4D7hRc74dwpMuJx38M
11279	payment	1726	1726	1874	1	1	3213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yiR69J9TJuF4JcMY5YWN2frDeXxMCK3zeZm681dM8ikdoqjS
11284	payment	1726	1726	1874	1	1	3216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv6ViXPx21N7mxRZvuwQqYG4EPCNgP9KuapcwaNFE4SRNEhqV
11285	payment	1726	1726	1874	1	1	3217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrrVsVVQuNWyuZXA9cg7Zqg1yz6CsWBMiib1VMYdUAkLaS9NB
11286	payment	1397	1397	1678	1	1	6261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TdqiRMNjxX6XcmL2LPBGo7TqaX68oRRs8DA88q91FKNschvM
11287	payment	1397	1397	1678	1	1	6262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKVyhF5gnWWvM2ahxTsy1M2wSYgn1LoFppDQdTyASq75pSQon
11308	payment	589	589	2033	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorawCg2LGiyhFxPaYdLKMkapERfHsoRJNXaFHXUjEpbWWRktk
11309	payment	1726	1726	1874	1	1	3225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1zbXqDQBsqqHXUM4efM9ypxPdQQbHimkmrHMrQTcReBHe9Aj
11310	payment	1397	1397	1678	1	1	6270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rDbUpdTHtafFyktidn7RpmNxgAJ5X36VU96KethPMRjQ143w
11311	payment	1397	1397	1678	1	1	6271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseSqWYnkK2uoqmEna4cgG5YrqyxD3hPUPL9b5MAPWQxwzAmoj
11312	payment	1726	1726	1874	1	1	3226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qLjV7ikqyhmiULvSLcmbTeT5MUocVqd5Yn9uG2PWRYWLq233
11335	payment	1726	1726	1874	1	1	3239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEL8ekQCCUFSoEk3hH1VWMnyKrW2ec4SjngT32Faqp8pcxZA3t
11336	payment	1726	1726	1874	1	1	3240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3enyrdM9igwArcCHZ8jaRKWvfEJaDGk2PFFpduSpSTAanFzc
11337	payment	1397	1397	1678	1	1	6281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqE7JhQurSvSAzHzLGPD8L7wMu4Wc6rV4jR8hsav5xviHm8cs
11338	payment	1397	1397	1678	1	1	6282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEW4jmgJHLovkPTqEDjHFgBnCbpoiG8y9Xatn4z7citZ5bkZEv
11369	payment	1397	1397	1678	1	1	6290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmhW5BwANW8rE4wSuFSiGYjqVr2J8FMtgbkKLs4Vog2nByma7
11370	payment	1726	1726	1874	1	1	3249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZwzkDcEUf3KeSrQdRK3Lx26eASkjXQeALxxfYqLyx4p9hbL4
11376	payment	1397	1397	1678	1	1	6292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8us9uvUhBim9TKsdqq4DLRLuSy8xskgK3FWVPi8m5NNR1SHX
11377	payment	1397	1397	1678	1	1	6293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVKMrQfipNUEiZYGebwos9bStt9eW4836w8EhigURauyuocPV
11378	payment	1726	1726	1874	1	1	3251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPMHqR9v3JKpcaUqPZuwe5WNV7rRhzjhzdbFVXyZNtve2dd3o
11379	payment	1726	1726	1874	1	1	3252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPasEjz6aq8VmwkvPweDtVYKsRnpvFmJfDVT6Q2cfwWxFGsQv
11380	delegation	2038	2038	95	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6fikDsx2JWMTZqu7N6ursS8ZuUFmDFTX4W7tBXBgUka1PqWC
11381	delegation	2038	2038	95	1	1	1	\N	90000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNcSJtZvQ2o2kuRkBRjnfuNnDEfK3yRAnJxNQYetG4vNxLY4H
11407	payment	1723	1723	1000	1	1	1	2781	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYzFAwkMisViAdH4bgWrD38LdeM43ckW9sLkDZC48UG4Hv63t
11408	payment	1397	1397	1678	1	1	6306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAVsX45pDig8mhkfpnRvJA9w8qYx7RGJKVSgKYRiP3Sc159k9
11409	payment	1397	1397	1678	1	1	6307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFzGyGi2PYKy6j4MtcDxjeBoxDBcZrAcPM7nxjtYvU6ZRdCaN
11410	payment	1726	1726	1874	1	1	3265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxnvW3o5jBB8qoF2wfxZSAGnUWr9bynk64o2wUQbKcy7VH9Fc
11411	payment	1726	1726	1874	1	1	3266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXqPu58F9Fh9aoGasfkPvTk27jRie9xEnEk9brZqDeTUuTYSu
11421	payment	1440	1440	2040	1	1	1	1116040000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg74HktSkhNWDJwoRUua8xa1CVsbqLACpkAhhhgSG4s87skVNV
11422	payment	1440	1440	1011	1	1	2	2877040000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabGsB3v3MBAJpsjkmfMMuLzPnwCsLEDBRhjiwVH84Grqbwp7D
11423	payment	1440	1440	1251	1	1	3	3478610000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwyxwXCcgSRyKSkHA8Gu5634RvzCJ8geGRSCg9Uxh1VGoHHty
11331	payment	1726	1726	1874	1	1	3236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrybgvSBWK4YYoDoJcLEMP9isTdC3LT9n4HbPM2EseQknp4pH
11332	payment	1506	1506	2037	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiEHDkaYzWnYvVC67aMi6aFBc7HKYVzFTEQDafuzguRvsWCEz
11333	payment	1726	1726	1874	1	1	3237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdq2skur9KHUjV1i84x9DKLhiuk3PYKvN8E48Duij95PWacRN
11334	payment	1726	1726	2038	1	1	3238	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ9dLU2sc2NVrHqnPU5992n3quP2Q42Sks3bHwy7SqZfig5GQzp
11339	payment	1506	1506	2037	1	1	1	862000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGXuwWG8MSiTnjiGndFJFgw7sRaeYMXbfR6NW4K2RJmqSXaLk
11340	payment	1506	1506	598	1	1	2	287	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jKvhmz34P3PBKbZoK4HzKJBHseMhBvvXK4esUmRSRrNeAtxK
11341	payment	1506	1506	1007	1	1	3	2188	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeg7ZDrZMKMRNGYf5Hb7f78SGeLwa7541wHEeCi6cuzVV7y2c7
11342	payment	1506	1506	1247	1	1	4	2645	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUgdaR2FRNEBHkuYthFsjBPoczTm5TbESnD85r81durvJzTG8
11343	payment	1506	1506	1127	1	1	5	3921	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqqYfBbwxEHFSSJZNR2DTp7nqmkU4omkG6jTL8Z7DUTbhkLfp
11344	payment	1726	1726	1874	1	1	3241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxU47ZZgHM6LJeuCrNRN7zgdJWP71DHqXLTjkQ9HNWnkVMuQwa
11345	payment	1726	1726	1874	1	1	3242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHo2JEQk429s51XVgabhbgyXDGQv2DTDY4ztj8XgAz97CNTq9
11346	payment	1726	1726	1874	1	1	3243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGhtrz1Q2gQDoESTDKZw37FjfV8jSuECjvMxRQMFAFjTmiA4Z
11347	payment	1397	1397	1678	1	1	6283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhz3na196cE8HhmKFfDk8CvwzEm1PEDvzJGrvcPU3Eeyi5whc
11348	payment	1397	1397	1678	1	1	6284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1azJKLdEsLxKg2h1VjRMnAc2Jtu2jcvUzSWQqQpE6CmmYyBvq
11351	payment	1445	1445	2039	1	1	5	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUyftTmhoe8viFSPTpsruPUeUJ9vaiPueY7Dk7NgtuqnnKT6B
11352	payment	1726	1726	1874	1	1	3244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSUyTUMPm3h1WrxV8KbkyErp5ZbwXEAJ2vhQZHzMn77BSEX8j
11353	payment	1397	1397	1678	1	1	6286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk67yysACEFokrmQZYZvXCr4HTD4wR6V3RhzE5462W5LFZ9odk
11354	payment	1506	1506	598	1	1	7	287	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ518dYD5wBsjMPNUNDvmazqaJKpJcogHQWuDKP5zkQuo3ze9NB
11355	payment	1397	1397	1678	1	1	6287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTPn9sw6NKv2JjtUrVQ4vvnbkAd5dDv3B3uwNsFDiYbYRUzRK
11356	payment	1726	1726	1874	1	1	3245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uoxB5A66iyYx1AZWQMENWi3SY4VvRHxMAF3CUgwjjhuBi4G6
11357	payment	1726	1726	1874	1	1	3246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMTZVb38Jsun81vTA9fbUmCjh84Nz5RXcZ6rLwbJFi4iPBriS
11394	payment	1726	1726	1874	1	1	3259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfKf6aidSnuCQGVYpc5WofpWZ6gasSWo62xsjpE5yg4mGLHSS
11395	payment	1397	1397	1678	1	1	6300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AZcBB9p6PdVhp1KzUyRjfiKf3MSAKDfAwMb3sr1f8NtowwBT
11404	payment	1723	1723	723	1	1	0	16599090000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtctUz6uvxG3r8rETc4PqJS57Yn6pMAokmcoptAXo2B8hsX2r
11405	payment	1397	1397	1678	1	1	6305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3C4A3iD2Q2K3pnsrFA1cqsnno9VMswXahzZ8a58E6HVULSe4s
11406	payment	1726	1726	1874	1	1	3264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgiE1cPvLPia5PC6TzSNiTEsrnvm6NUdQu4TtuNQTsCZcc2qs
11414	payment	1397	1397	1678	1	1	6309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JDr4gfJvDnQQsuRWk3XGj47kKkTerNCN5EFqHk663V4WHmku
11415	payment	1440	1440	2040	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ozV4uFoj9QvdiaUF51QExxruXWqdMSevxE2hGtti8rv8Lshk
11416	payment	1726	1726	1874	1	1	3268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpAaVbjEPZ4jxzzsYNabCZka6M7r76qxf5sXQHQJBjjpfHUGv
11417	payment	1726	1726	1874	1	1	3269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSbUuF2B66FFRmu7WqtFpHfAxsTSbJMbqXDbwWwdVUc6Fegk8
11418	payment	1397	1397	1678	1	1	6310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDr538EY1MtoaR7kDTkUUTE8oH6yj3nNt61EkUcZcMDpCpxnzg
11426	payment	1440	1440	1131	1	1	4	5155630000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AKF7hg2eefzvSeBH4jUmu1evhyLuguaKj45ZDnYBxycJa5ew
11427	payment	1397	1397	1678	1	1	6313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtr3zXfdRKFEDQLJboHk3GUNVC5wzHEjqzN6wZNZkRYcy6oYeb
11428	payment	1726	1726	1874	1	1	3272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8nfAQqWEPrQqdZrZe8C42mNjc6bPCkSzbSPgi18TELyKbERut
11429	payment	1445	1445	2039	1	1	6	1440000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9ftoqjDXZWk9ei7GfyughA1cvm7wnetAmaCUQwWSd3rRzqV7
11432	payment	1440	1440	1377	1	1	5	9693450000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY2ZTmFnZmuPjg23NtA14zMSdGNBREhxc5h5g7awh9s6bfMwXm
11438	payment	1397	1397	1678	1	1	6317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CAwm97ZP2RBJPWq56ZPKAC6ztacH3atXXXnicCvrigmZPVPh
11439	payment	1726	1726	1874	1	1	3276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAj9nTQgrhvEh22VaMwe2pF86JCNedBW6F998EWuYerxR3eDo5
11349	payment	1397	1397	1678	1	1	6285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwYncRyTGCEohXzXifijh9M3NGM5Xt19a1bVCWEWGeqAkWXhE
11350	payment	1506	1506	1373	1	1	6	7373	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvXqTYsXWgESjSS2AmAoipEXBZAQdEare4Mo4m9yL19JRYKXw
11358	payment	1506	1506	1007	1	1	8	2188	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRBuSEQ6fzSFy1jSeUhQ5o6cnKHQEG5Eo6BgvrdsjWbo55FD1
11359	payment	1506	1506	1247	1	1	9	2645	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztquiYVLSmFsgM2ArBb6Mp2XfaNQzhnm2KxKis4PmYi6tHAvk
11360	payment	1506	1506	1127	1	1	10	3921	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6L2ZvmdEFoYoTKL6YgHucgovaaob8eAPvUjYYvVFQTZebN9h
11361	payment	1506	1506	1373	1	1	11	7373	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgQh5AMW3yCuVTbf2tmt92CSWoMxTKzLwwhBzrp6mJhbPPawu
11371	payment	1506	1506	1247	1	1	14	2645975000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4BkZGeGQS11oKanaNi2fEVwjcjzybcZiiXrGcCKVnt7ZqkQo
11372	payment	1506	1506	1127	1	1	15	3921589000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDQkwnVwXDaivEMq8AAFxX51me3LxeaRNV7VPJW75eoDkv3rN
11373	payment	1397	1397	1678	1	1	6291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzrZQELYH1zzjtixHKNSCjFRcdMXNkWNmZtbzvLDfs9kdv62e
11374	payment	1726	1726	1874	1	1	3250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuHwr7UPba5YWhz9N4LaAi5jELP7xEDoMfnEzEnzATDaeKEtr
11375	payment	1506	1506	1373	1	1	16	7373243000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VpZ86pYdxC8ZTF7joztvR8CRxyZNeqoX1XPA5LkvnWfrHqoi
11384	payment	1397	1397	1678	1	1	6295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwoN2jm1exw1sr89Mc12hAWpC5ctgzBnTZjkJcMucY78X2qE3
11385	payment	1397	1397	1678	1	1	6296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9EcqRAbzS9UCjG9m1yZN15GmUcpD6j9SNyJjpbZHKSuregU5R
11386	payment	1726	1726	1874	1	1	3254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMXiGLvvLRjJVTXaFYvv2KFDdvede82NRKvK9YKDBo8AkVS1X
11387	payment	1726	1726	1874	1	1	3255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP13FaWmEqE6rZRRd31TdFBQqwHRqnKXFqAZcF8zzy2zaFrrPd
11388	payment	1397	1397	1678	1	1	6297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeeCXteqbQTFfaBdXHnvwyJVxLqFWRodjWf2Z8NEd2suNggjnH
11389	payment	1397	1397	1678	1	1	6298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LRSZvfZGCTx9DfPtZXV2kfiibQNA5UkMnsJhHb3N3ghr9Pb5
11390	payment	1726	1726	1874	1	1	3256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQHAebUmUPteQgyRYfxyXQMPNqHQFKK1SwR6Jqf63QqhnW5go
11391	payment	1397	1397	1678	1	1	6299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcMVcbNuwMyh9H7ydko85CE4Kg6R1NZhEnVoqfVi6mv5Mh9Sm
11392	payment	1726	1726	1874	1	1	3257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEFK8gh9Y8ppKx34yHmikfwAghU4VqZguuMVXtyEz7wodkBu4
11393	payment	1726	1726	1874	1	1	3258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcQbHrzJmJ8Nvx67tM4EgecJR8U8Nd2bQDDEYhEdnYK2WrcgQ
11396	payment	1397	1397	1678	1	1	6301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iPqzWf2NVXtPeaDwmcb6ftkjCVkYJVAS93EWn54oB6vysV5H
11397	payment	1726	1726	1874	1	1	3260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhoQy9r6NczdXxxKdJk3jTjKcUz84hyNSStVWpvwRjWb7FU5d
11412	payment	1726	1726	1874	1	1	3267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFeApMBeS2f63T8xwoYNYGX8oUHrAEtqV4jCGQUvUhQ1NjjYc
11413	payment	1397	1397	1678	1	1	6308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6uNPwV6EMYUuUnhwTut4c8NiFkmhc9AgCcDTz675Q4opL36W
11430	payment	1726	1726	1874	1	1	3273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwcnM3MqXL4m5qadW2z7CwBbQBfYARh4ZYPURgMMiD1VLWj76
11431	payment	1397	1397	1678	1	1	6314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDzkVyXgdmDEWceiJSLXE1WoQWyUECPFbLXL99DFXVf6J9MWZ
11447	payment	1397	1397	1678	1	1	6321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mJG54jhDcndTyFaTFzWTWtiBj8beGrZNsGEXvWWfkR5KBX16
11436	payment	1397	1397	1678	1	1	6315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5R7833VgjxdEXAnnyFhaYMnxjBj1NGEG1HgiPk5grRCjpjLH
11437	payment	1397	1397	1678	1	1	6316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVpTy1GozZw4Ed8wenmo7FayiNwsr6FvYEre5xCyFpfFGhdnWk
11440	payment	1397	1397	1678	1	1	6318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBgiTb9N2JcZ2HEHpnkvaeBeCPScSF3rtZ4n5pC797eRZ5oin
11441	payment	1397	1397	1678	1	1	6319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmB6UaJVzkDmGt4wsk7VBZSDcmeB9NmXV4huPweKwieQ4r1FkJ
11442	payment	1397	1397	1678	1	1	6320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4QVjHfXkMuB1SKCmnDsMDbnvpZ5CH1SxarPUHiQexN3B7WWM
11443	payment	1723	1723	1000	1	1	2	2781884821000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZmkfiAjqyjEKfLZuh1prtP4mgSQEHiSNuJXXho4PRs1duwEX3q
11444	payment	1726	1726	1874	1	1	3277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFXTRu3hWUQtXft6PFH62G3nyENisQJz9eoWWHt2jdMhrXe5bH
11445	payment	1726	1726	1874	1	1	3278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSJgjZVF6aETqJVgUFJZiS85MhGHf5sgLZjYNvLCkZw23wRQe
11446	payment	1726	1726	1874	1	1	3279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9aoQAmVErkQWkz5AaVUda8TpNfZjtUTsP2kqY7aKvoQtZ9Z6x
11448	payment	1726	1726	1874	1	1	3280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtsc1jaCHoJ5AKjqVVbaaSGgDj7CibHEBVGWkJwdU9hNH58MD
11449	payment	1397	1397	1678	1	1	6322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdszbxAtNr9nvtNkemcuXYpmwDKZXytGjEhk7kQ2B75pBrsnKM
11450	payment	1723	1723	1240	1	1	3	3364000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZRdkjbbGATQog46RMZ6sHZtPLrDENoaRmUVqxP86hPeugSyETr
11451	payment	1726	1726	1874	1	1	3281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbA8FNGVNpBAzKY418JSFsBP7FfuagtGFtC1W47yDY4XtJHEb2
11452	payment	1726	1726	1874	1	1	3282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeMvr1XyLTufWDifzetuNwaJJGSvxBJNDosX5Vj1En2rhwZoU
11453	payment	1397	1397	1678	1	1	6323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnq2pzAdAzx6kZELQkd5war8Qj4JHnkDmNHhfVf3fnUJUN9pTw
11454	payment	1397	1397	1678	1	1	6324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXSCYYm2FFbppAeVxji8MFec1XU3uWjuQvqeTNoeYA4fnVkaR
11455	payment	1397	1397	1678	1	1	6325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHXCm7T3uWoWcUEckR66E4TUfx16WaYQMrnPhrt3i4Dv2SDcG
11456	payment	1726	1726	1874	1	1	3283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsFrigCof1tst2rbLQBTZbEDTovrM9KCzRgXy7jEjcGZznARG
11457	payment	633	633	1384	1	1	1	8280000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZ2quRXD3kRNNmsbgUSs2ruEUMjdLQB916aQKh5yqE7uait6gnP
11458	payment	633	633	1138	1	1	2	4404000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZhCSk6Cv1PZdjG4CraHbVVT8Kz7KvQqVM9oLEmWt59qhdUygF5
11459	payment	633	633	1258	1	1	3	2974000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZaCHCBy5XrWq2XnH5L5kcYDBxNzAahoNjJScgU1jVK379E8U9C
11460	payment	633	633	1018	1	1	4	2458000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZKK2AcvrKKTqiWKjA9tPz5P6kCHYnmBU2kN9z81NxCg3au4UvT
11461	payment	1397	1397	1678	1	1	6326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGSnrBHZparrNpLosByN18KN7Lkmo26FXh4Lqxpmu97Ue8ymm
11462	payment	1726	1726	1874	1	1	3284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQBvqsYmn8TXkEpc2vRPoz7q2bR7UvvfyM1umLQdkQTvZWad7
11463	payment	1397	1397	1678	1	1	6327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyX4ZSHhP8fFi18WsfFeZQvBXhdDK6oNDEVQQHPV8UANGj57Y
11464	payment	1726	1726	1874	1	1	3285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvV3GBgEG7ihHbywDKgryEjTLsx9LFu1PGqw9Q7L3zythWhtcN
11465	payment	1397	1397	1678	1	1	6328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oxQhGt4TRCe15JyYiMZQhbTEhXhwc2iujJTXqi4XTeTsE25e
11466	payment	1723	1723	1120	1	1	4	4986000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZsRwWJxh3ptTwNB9bhi7YiUvnkmXnUMFjPfR8bzFJL1aw681mG
11467	payment	1726	1726	1874	1	1	3286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Udu3jDkw76qBYQJQ5UJyQpHkaC1Xxgpzmc7anpPUM9TwUFgv
11468	payment	1656	1656	1343	1	1	0	10138000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznbBYnY31gqZLWFAQm65yYykSBS3qua1u6CuWXmiCoZThqZfx
11469	payment	1755	1755	406	1	1	0	2000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpR8cWiuqMnJDRcTfadb5onRyQGThvmQ1dwdBVpr2Lb6aNPMo
11470	payment	1723	1723	1366	1	1	5	9373000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpYfc6MAx26t7hbRhNXeVRanR1TRrhzi2wShsPp4dZffr7TuKJDH
11471	payment	1397	1397	1678	1	1	6329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsukzKtapkePxwWyv2uCHTzcCUnDzPqCYcS45irLKE1YKMnXXe
11472	payment	1726	1726	1874	1	1	3287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjiDSYgWtcB3dGQXqCkfCL3gCPZmKMi2LiQmrLBjib9o9NY8z
11473	payment	1726	1726	1874	1	1	3288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuhVWgAkWHyd9LpJikd58R63yQXkpZNZ36oHoLdaUNrZvEkB5
11474	payment	1397	1397	1678	1	1	6330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9X1X14KW6aGC6pQGB524PSt9gi8Phzwb6YM9ZVEdsB3Ls6bB8
11475	payment	1397	1397	1678	1	1	6331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDyhjDmqTPRR8ymRnNy7m5EsmKHEdGmBqYathAUAtR5qQUuMnf
11476	payment	1397	1397	1678	1	1	6332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMvR5RpgUUE7aVFY1Q37NTSaTEFp8ebAXUiT7XCi2txjCaX8se
11477	payment	1726	1726	1874	1	1	3289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQ2L1oHkYPnLX2KmvAHYz9HtbkDdaXGy8h5hMjAXuQMZdvxi3
11478	payment	1726	1726	1874	1	1	3290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddRtS5ngSgx24x9XmGdMPxqvMRtZcxg7b8zrxRWddKEizqwDo
11479	payment	1656	1656	1097	1	1	1	5393000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMz7QS5pMaUW3cW7bjdH3XSy9Bqzns1uD7XesHXEUhwNkmQSS
11480	payment	1656	1656	1217	1	1	2	3639000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYCXMPNvgXJV14PZc4mPYJQrkymYxS1hZLcgJAcTPsPqAhobD
11481	payment	1656	1656	977	1	1	3	3009000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYav7RRYcpjy2asGFqtJYBtX2ffwGbjpzifhH5rf6ib5dKptoo7
11482	payment	1726	1726	1874	1	1	3291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvivgStC84DGsPN1okbrH4xgxqzN5BoLQaYRuFWWaFzPygEnW
11483	payment	1397	1397	1678	1	1	6333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXSG7GQG3X44VJPEYpJtN8zDF8Q8PLWC1sWiYBCAAiM3c8n7G
11484	delegation	406	406	1755	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQhqv5Sc9aojbGsU1KbPcaKifqJn13tsh13znjcz7mEHWtU7HW
11485	payment	1726	1726	1874	1	1	3292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcScdvDNuHJi2KTeRyjx9Nq4LD1wxg67ZG45EZk3gEFW43Jc31
11486	payment	1397	1397	1678	1	1	6334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Da1CJCAhMvdaQTtmGCWJvsxbrMtnv37K3Cd19Dtqywex4rLq
11489	payment	1397	1397	1678	1	1	6336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYARgMTmcY3BzgAziUhPUmkBtiJcjf7PnP4wioVKqFAn6JZt4d
11490	payment	1726	1726	1874	1	1	3294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1mt6e4uk8ZDx4umuroDPN4NRA5AfKMwxaYCroD5moW6XjprJ
11499	payment	1726	1726	1874	1	1	3297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrLPvvceqmduXZhwEhAkPAvVzXQ3uFtbvocGjUXVpDgbTXEeF
11510	payment	1397	1397	1678	1	1	6344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiciBLt1kr8YdgedBboLKoAkHzxT8rNNUtq7ZTZ5F7gceZPKh
11511	payment	1654	1654	1094	1	1	1	3431559600000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZMXDdMUVHkVJmSoEptnHHDyjb1Y5aFBDKG8x9TH1dtAe5QTft3
11512	payment	1654	1654	1214	1	1	2	2315476800000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZNYUjTvrS7KXbuQXSSiy42ypnYyoUQyNPn3sEZpdaeJnDwV3Xu
11513	payment	1726	1726	1874	1	1	3302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDxgsiGecMbCJD9Pvn8mnT7UbFYdoY9bgogg8n4VazozxLsE6
11521	payment	1397	1397	1678	1	1	6347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdncNSKYvPMyfpgVe7gQtypDsfHSvRTER74TUZ3X862ReZf3Zu
11522	payment	1726	1726	1874	1	1	3306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYQTFZEpqXMEcyXPtGmGCQR7Fw6eCSCjtEsZoL4JgeJaoLWnm
11527	payment	1726	1726	1874	1	1	3309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCWDxZevVFjHA5M6NcKbdxxjxhtLgksrgW6CxLkNzZoj5kYfC
11528	payment	1397	1397	1678	1	1	6350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpH3sP7UVe6M2UHUxQiNwgQEaLnZDVzhkGWBsAK9vqkn9CBRTJ
11542	payment	1397	1397	1678	1	1	6357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJv8efhWEemjdUv2hdZQR1G7qPGCF8kMeVdmR7WzS3GUqB9jho
11557	payment	1726	1726	1874	1	1	3321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWyTRmUhe9jKU5XwtvDk4ApKT5yaM7wfJpCBV22RMZcxdUUnw
11558	payment	1397	1397	1678	1	1	6362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TrFcTsMq44xf5iCHc8DSzmWQhx5LNkaZZLerF7ezUUP58CSi
11562	payment	1397	1397	1678	1	1	6365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkwBAqe9Hhm7xytzm2eXv5RGMZaW9LNnQku3DCkByeYtV5yEt
11563	payment	1726	1726	1874	1	1	3323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7bQ9jru5AhD6zFRJx7PT39Zhf8H5jg2UGsuHW1zHwKJ44vwn
11564	payment	1726	1726	1874	1	1	3324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6Z4KmjKN3bimnf3dNbCapo4gFsEsXmBFW6X44Ka3hVtKqvsZ
11571	payment	1726	1726	1874	1	1	3327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYqj1S5CvWUnx92qYdetCA2aHqEuWYv517WbnzNQxC8ypZ7Xc
11572	payment	1397	1397	1678	1	1	6369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigZ7qGC8km6yCiDFRx66uZ74rGgrG5bE3A9gHESfXm7n8YnZr
11578	payment	1397	1397	1678	1	1	6372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafwvqJiB4GsrSfeRHVHwPW3d4GCx8sopkp5qdyEV9Rez2jcTY
11579	payment	1726	1726	1874	1	1	3330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9XcuDktAECWzXwMq5NRNErn87vhxAwNcSQQSGRi4F213aUxi
11594	payment	1726	1726	1874	1	1	3338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqnpgVau6gARYKbbbf3uzTxmkWCJURNn76KC5DLp1RS1dKUhT
11595	payment	1726	1726	1874	1	1	3339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohzf2M1kLDYi5rcexgZowYtejGUNaSFEz7tvrnCZPD9uy9uYW
11596	payment	1397	1397	1678	1	1	6380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJdFVtC7gTVgvJKXNXs7VtLzQJzMWyrQg4ez5hUrx4AqNetnA
11597	payment	1397	1397	1678	1	1	6381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdKr48vVrzfomRqs7biCoEHwCGf32Ez1bvwWLhQtgagAhkS6d
11605	payment	1397	1397	1678	1	1	6385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvf1ygvg5yVtyCqCEUUxVpJmyhMynN6e4hj2opBZNJHQ43hTBL
11606	payment	1726	1726	1874	1	1	3344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQHpYxEk5sRWFQ3peBnD9EmgKhaP1P3eqwMv34bYwbH28wfU1
11614	payment	1509	1509	954	1	1	1	2644236687992	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAu57MKT8BFQvZsQiujU1PUH9HdSr5Vp2cgzPwtEMBoQrGuZK
11615	payment	1509	1509	1194	1	1	2	3197126290553	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYjxznmwDfXM34K5p3dWFuZTPTg1xi24beqxrfDCUbqfH5n6A
11616	payment	1509	1509	1074	1	1	3	4738449489072	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLuzLESgx2tARAXA7XAyCUs6XuskHscnPMkNcpbvqarU1a2TU
11617	payment	1509	1509	1320	1	1	4	8909076681228	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYR4a2bHjm2Xdtt33TVev143BAEeGfYq4LVos5pX7DJAKw2NQ
11618	payment	1726	1726	1874	1	1	3347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnz6VGZkr93YZydzgKFAZyUm9BqoynaJXegG1QJgVv78FRMpS
11619	payment	1397	1397	1678	1	1	6389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLdMNwrhSmoLtavXaw2JFv5ed2Bu1iNQwvVECMYRfXeJ2ZPjB
11624	payment	1726	1726	1874	1	1	3350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdqnmu6CLr6exNzX6xxwXCeyQxXyVoQaaEzExwRqiakim8WHo
11625	payment	1397	1397	1678	1	1	6392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufVEGcDdamLq3fszv1W36qW4Qj9JweuNVWG9TtqnpM2Go6R8u
11644	payment	1397	1397	1678	1	1	6400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWsPyGWo2B6mrMBtSTrp3cuKB5qcY6tzwLX3KPLNGwSsPRWYh
11645	payment	1726	1726	1874	1	1	3359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrgt4H2AqyoC13SwFafmwxHkRc69bdwEUddPVjPnwmPkBXJAH
11487	payment	1726	1726	1874	1	1	3293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxBR3XC7RdMLKiMoMFtpWniMdi2abw1ww7miCMaQorEv28bcJS
11488	payment	1397	1397	1678	1	1	6335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1mgkvqVK4h5ui2j2ibRfeGVA9Zwi7yAzZAgZrHVZozHueC5R
11500	payment	1397	1397	1678	1	1	6339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYwtSYQFSrfJXYJ9SeCpHAnduMF4ZZY8xZxCbS3giTNB6SqW3
11508	payment	1397	1397	1678	1	1	6343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17AB9WntbUr5zedNMsS7TnBDyUZGnWGhEvfesSosm2d91Qk3B
11529	payment	1397	1397	1678	1	1	6351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakrk6w5m1M67KKunZL5ixWS81Qm7tLszuAP3f2Znjaab4W33Q
11530	payment	1726	1726	1874	1	1	3310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLN2NruCAMMMdzysAzkSQAPhTXoGY9ycsctWbksYzAkwnXa83
11531	payment	1726	1726	1874	1	1	3311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLTv1SiLetdpBwxjXTKqvy6ymBDmrcWowo26hZuZMG4LaFXA2
11532	payment	1726	1726	1874	1	1	3312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyg8oBvMkp6U8n8ohDvFWxu99NBAuXJPRo8ML1RtohEvzUxJgJ
11533	payment	1397	1397	1678	1	1	6352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rVdMa3kSXWzu1Bm4sY2G7csysZCaoVpmbwLi4zhvNuJmTtLd
11534	payment	1397	1397	1678	1	1	6353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwgPpw9umoduPEZ3bckeMcKKX32wMykAmjR16FvUT27mNasAQ
11535	payment	1397	1397	1678	1	1	6354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkbgg1H2GuQQLRq9hWGE6o6VRqKmQh6A6FpgH8VN4H2piZ3YW
11536	payment	1726	1726	1874	1	1	3313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56PSN9S2Sqw2ewxWtrqnBHUBgZ88QhtAB1KwuzofFsTFus86V
11543	payment	1726	1726	1874	1	1	3316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2odbtMHAxnzizyjHYsAgtgmAk1jpDR5ucf3FFsF1e6GLMaJoQ
11544	payment	1726	1726	1874	1	1	3317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqYkEn3dEfkqacACMdtvYxMwfwYJCu43dLBXwH7y6U2cHMQny
11545	payment	1397	1397	1678	1	1	6358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4yRuE61wNMAwLyEiZJXMR2HZ7fsLWHwrodE63YvBaodN3szi
11546	payment	1422	1422	1211	1	1	5	2691570231373	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZod1pE7QLvUTuwUosYqknyhr2gXFUQadAUTFAc61fSP1JUS48x
11550	payment	1458	1458	1197	1	1	1	3528000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxX3YPtPrwyhV85vAJY4GD52zndmJZLHvQzXGGgitvAQqri9K
11551	payment	1458	1458	1077	1	1	2	5229000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZ2P9PcqaxEgT4jS4n5GERvA81AKAuycms8vNBaR8NqvHhoHb
11552	payment	1397	1397	1678	1	1	6360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipKA9AH8oWyH1TrKEfD8VgzuJx49Q8ay9CADfTGafv6EQSDJA
11553	payment	1397	1397	1678	1	1	6361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPdG9ajeSPyoaXGZSTq3n2GiucVseV9uMm3R2CXYobFjRB2gB
11554	payment	1726	1726	1874	1	1	3319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBs5WaPbbeZqbZruH2jqaGLubbPPDuqHX1zdJZRJzScHUx29CJ
11555	payment	1726	1726	1874	1	1	3320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMtmp9rgHdEj492SR5zdNZJteQhMh918jyCESerFupJU2CSvz
11556	payment	700	700	1980	1	1	2	1441000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6pr4Tnn4eD3psm2fdxEDUW6WPCaG7LMjDXyY1K5KCsYiPNAA
11561	payment	1397	1397	1678	1	1	6364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYuh2LdvkNqUZVzaBtQBu7C6KVRCsX1oidFSpxbXbPbaAdoKg
11565	payment	1397	1397	1678	1	1	6366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhAAedXQt6Tj7XonUK368cXXrfLi9SmBoj6GhjF4XovZDcaiX
11573	payment	1397	1397	1678	1	1	6370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRrXs1p41q5cThMCVxaSCuugDGK5SjDm484Jo9YrKFSC6cw86
11574	payment	1726	1726	1874	1	1	3328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11aSsFa9AopUJ5FJZoyWhgwxjda1imEHYHKHSghEkBL9fLiw2
11575	delegation	2041	2041	1437	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCVs83uXQF8jW77j13PoHSh4NtD9mPFD3ovivH7TTA1xHfcev
11586	payment	1726	1726	1874	1	1	3334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCrjkLsPa8w2RCVQFo8fvueLDM4p1BuKEaNh3E36oWZb6tcY2
11587	payment	1726	1726	1874	1	1	3335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CTPP3cxNfmJfjQHMYQ3qg7cTTCiKxD1xknQPoemeomV3fShn
11588	payment	1397	1397	1678	1	1	6376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDV8eY3TG8c42tK6Ak7o6Nb3V3wat9G4tcyPvyZBfiFuF5yQC
11589	payment	1397	1397	1678	1	1	6377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6TJtLKd9avQsELyTqGJAsRiHZRujds6PVPuBy5Foj77zfze4
11598	payment	1397	1397	1678	1	1	6382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZ66CPrHkdHpXoC1eeMQ1fGKDMoi9Vc2nc8HpiVuvX96ZAj4N
11599	payment	1726	1726	1874	1	1	3340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4tTahPadepJ4EB6Aq7MUaCuBG5DxNy5zf6DUtutjW4N6NNXq
11603	payment	1397	1397	1678	1	1	6384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPFDiht8Bb2abuYXXCfUgyUC4ZUfFhnUu5Uu639tKPM64JW6h
11604	payment	1726	1726	1874	1	1	3343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPJzT4i8jURgwDCuRpxgCK7RwfexcXrWJ1KV3a7wQt33vBvCE
11613	payment	1397	1397	1678	1	1	6388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7ecqvA9x8c4c6mxNQnZV9RFAd2Y2cGfDZTBCVzuFr8aTDGHL
11626	payment	1397	1397	1678	1	1	6393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccGTPvzBAzj48Weec5t5oDouixDQSVD4icwGn1bYDkAwMJ5Bd
11491	payment	1397	1397	1678	1	1	6337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iuKUMwGSNyDKfZJ1hUqzkhpffFcj3eQ589AL5moFptEq4ZYb
11492	payment	1726	1726	1874	1	1	3295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBbMANaQ9Skuq5UNiSaxtRwvFCnWMfLrGdL4uF1nmxVyodYjp
11509	payment	1726	1726	1874	1	1	3301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3C1s6uqxTAzxaZPMEQksba4jCisCk8RAPTi2cMRSKRcKzGQpp
11514	payment	1726	1726	1874	1	1	3303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqChQRsKWGawr1PxNMR5Fx5vkNuupJ81XeotQcZ7DPyh6pWQ6S
11515	payment	1654	1654	974	1	1	3	1914721200000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpaEPCta7yBi9Kr5XAF3EDCfmdCTWmvx5SgETvM2Dj6kzehJCVJU
11516	payment	1422	1422	1091	1	1	4	3989166654234	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZeZy51b6irvDfALxwsTzUVeoFBCVkmWRpquwxUt2qhsgHrbh8r
11525	payment	1726	1726	1874	1	1	3308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5s94kLbzwfUM6odUJfndEvp8TKkpoaP2um5jjr3tjjUxw9UB
11526	payment	1397	1397	1678	1	1	6349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3RrPtWwFnXBUQauvEAwaoZyN1KhZikD68UmdrP6hgLi9jdqb
11566	payment	1726	1726	1874	1	1	3325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCypoDLkDJVSEvNY3KU5PiS4V79viS1FUS8utV3A2x2UZRu9x
11567	payment	1397	1397	1678	1	1	6367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKsXUULQntaVFARbSDzm28eib4iSpm5ZYaSDnt8NFNUkpU5xJ
11568	payment	1458	1458	1323	1	1	3	9831000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVMZjnVZYqLUsvHDFU7abQeUy3GffAh8kgAZYYSfXgJUr7ugs
11569	payment	1397	1397	1678	1	1	6368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSyzDL5vgZigbAeHKTrcLBbKYiXPAT2qTUNnDnF1uH7y1u2ff
11570	payment	1726	1726	1874	1	1	3326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEE76bZA3ZCjnCEthehibGQtxT7fq86b3RgLR4XYp7cY9aFyr
11576	payment	1397	1397	1678	1	1	6371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzx7n84LgwStSYvBpsMCw3fsythC3pJ4fxPMhqXQrCSywFUvw
11577	payment	1726	1726	1874	1	1	3329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsPvysNpngMzPENiwJJ493DcjpjPxcQQAJzus1ACHESZLAsBg
11590	payment	1726	1726	1874	1	1	3336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzfCNbKMoPx8eRJThTXNAworCJ83n1LQgwLe5NJBtPZFL41fB
11591	payment	1726	1726	1874	1	1	3337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrfnw2YbwMT5uFmWdsCoHkpdcNHisffZKa9AA9pH4AnspMXQB
11592	payment	1397	1397	1678	1	1	6378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SVg7x9w4ymXZvee1P98MzBvr7Gr8SU2hJ2Bwo56R9rYSEJ99
11593	payment	1397	1397	1678	1	1	6379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8WyF8VA1TgECEgedoQ93JLwDFLfWGGXz7SobS3EyK1LKBeRE
11600	payment	1726	1726	1874	1	1	3341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9v7PXFPBSDHzziyyaSqSKKyn1RHUJbRfRzMYwxR5RG8rTEGR
11601	payment	1397	1397	1678	1	1	6383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXnBDVvCwZqDaEdLFRTcyjZRjAmoZbZpvkELuFiL9zoufFhCP
11622	payment	1726	1726	1874	1	1	3349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPws1hPrU1nbiYFc3zxhvEkKH73aQxT2uTPrkeBzHWKAUBBHnZ
11623	payment	1397	1397	1678	1	1	6391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8FomJMayiVvtdTeaaLVjnaYtKCMyQphPyg9ikbiBMqRizhEv
11629	payment	1726	1726	1874	1	1	3352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAvZA3neLo8PTEy5URGmfnnERBEEKkLkMozzdnFYiAPsQzzag
11630	payment	1726	1726	1874	1	1	3353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuF5xNykbqrPNRQxM6zvVXos4F2FaZUfJhfKFeQCEgnaF37J2Q
11631	payment	411	411	2042	1	1	4	830000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNT9eNuGscq3qwojf9Yc4jWQDnBQ6pydncxbpeAW6toWZDpH6
11632	payment	439	439	2042	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfntUXUXrB7ZamAUrEuSxTSdyHAdxTXwBpucdycw4TcPAtoreY
11633	payment	1397	1397	1678	1	1	6394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWNaEve9MYw2GKiw7ANevmunb481aBkAaGoHSTrtp7FHnGVwZ
11634	payment	1397	1397	1678	1	1	6395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmEaR8qy5HHrS9eLR4CpfT5Cnzw8YwoC62TMFq71DVtGnogRG
11635	payment	1397	1397	1678	1	1	6396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzE7W3oZBkpXUB6oW28C3rcAf6JA1dttLurFpDoiVQVabkJoAZ
11636	payment	1397	1397	1678	1	1	6397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1DsoJugGp32y7AhBn5BVJZMWH9LRKqdjBrrnamhWCcEVXsoC
11637	payment	1726	1726	1874	1	1	3354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK41ZqCp74i5v5Wqmsw5nsdTukQpdqY5AfD2qbGeW8ryQprpq3
11638	payment	1726	1726	1874	1	1	3355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUKjH9oNLmBRAPUKy5DpkseWVdpAfx71xzLCeB2XPYiPrPx9A
11639	payment	1726	1726	1874	1	1	3356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptg8sfGybAmg2RXhbmAPvNFnRj2F1iwSKbwqZQYE5o9sPanK7
11654	payment	1726	1726	1874	1	1	3364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1gWqQjFcm3LxqdAXkY5uYScyyKPbKr36Hnfg4JreCNTY2ozT
11655	payment	1397	1397	1678	1	1	6405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cn755bJAH56Y5jzw3spF3Y7FLATAHnpopJy354U2Eh491mtP
11662	payment	1726	1726	1874	1	1	3368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQuxg8qA3wVfbeDKSBpdNk1eeiTrZhFxuR78HgKVo9o7PgFPnZ
11663	payment	1726	1726	1874	1	1	3369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rT6KZn1fYft8z9ErbrcQkG4Au8BxeZf4ji9K7zATApEhNzHv
11493	payment	1608	1608	1289	1	1	0	6452000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjcz9W31FnwyMPgdoxcCU4smf5jfxLao8nGHDBz9WsfWf4LN2p
11494	payment	1608	1608	1043	1	1	1	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRaVArWKqzqZmvMrkbB24hXV8RZdD3eyqNTBRaYW71dPSYzcZ3
11495	payment	1608	1608	1163	1	1	2	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZbZwCiqA9Jg7kxuQVvYtLDqfWmwJEv7ZvqmfwT3rWkaa2enz
11496	payment	1726	1726	1874	1	1	3296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQv9TYV7krPFsebMjibSP7Ft2nu6ZHmFBWL3iaaf9o8vDqQzK
11497	payment	1608	1608	923	1	1	3	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDky3RrVNJSgijn2k3zGAEyu4GGe1MZynkobEvd4k8DUrPEWT
11498	payment	1397	1397	1678	1	1	6338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAyiq2nZMpynTHkZMqum4VB7YqCzAx8VL2q7LnezczbbGgXG5
11501	payment	1726	1726	1874	1	1	3298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Uhi1ZmAETpgVuQnjVNJEjukJ8feRcGU7j1Kwr5szh9uQnz7K
11502	payment	1654	1654	1340	1	1	0	6450872400000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmwGxRGRk6BcJ4tVoYK11UNAtf6NoybdgqBJFP8QAf9PEaLUs
11503	payment	1726	1726	1874	1	1	3299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiamMteWEB45kCPVLtcRxzExvXSqFGJfE3LWX4rES3N3T9RayR
11504	payment	1726	1726	1874	1	1	3300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQbQGUnzWa9bjmVQvoeFnyNxWKgARMPWk4smPWZi1CeQp7qXe
11505	payment	1397	1397	1678	1	1	6340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhk19grTbgt5vrm4hDSZ3Yu5cQrCaXweDeCFDZdnPihXHrxaJ
11506	payment	1397	1397	1678	1	1	6341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZa5N486RXQo18RCHkoPrssXYd7vngdP6ybx8eX7hLKEhcVCEN
11507	payment	1397	1397	1678	1	1	6342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuy1Mb1miMLJL12CvWPmeJFR4sL8ByR3pkM77QtTY8ohiLSEbL
11517	payment	1726	1726	1874	1	1	3304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaA6kQSQTWHquqycgSj8uE12yo9J3a1aRtk5NNUozc8oXu9RMG
11518	payment	1397	1397	1678	1	1	6345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDMQRw1qiwfbni9bNEbmxkzYLThJAzXCCzoKPQxFbjcRqKkYD
11519	payment	1397	1397	1678	1	1	6346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiZ3yCDkQkcdFPyyhdGMGEg9b4VKoZ3Ha7FFRKSwaH5oYRWjU
11520	payment	1726	1726	1874	1	1	3305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4ibk7kbSekbfgHa1LsxYyoeFBD2edfa9HrV4oRHwma8N8Tvm
11523	payment	1726	1726	1874	1	1	3307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wVt4H82JRtaBaHwErkPDrcB83z1QKeH9YGV8a77uVd2Wv1Ks
11524	payment	1397	1397	1678	1	1	6348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mB58zL4Br14ZNzYEXwRhPKWPb5zgqgGGZdFThwV3jYNAfLSh
11537	payment	1458	1458	957	1	1	0	2918000000000	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdiMo3P5cNZATvtiQ5G4N5wQMtzSj8b476cCxWircmUN5wBZM
11538	payment	1726	1726	1874	1	1	3314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYqD8R6WMbSgTzvfU3NmqBMmpJCavf2MSfakdoXXr6k1GoZ6u
11539	payment	1726	1726	1874	1	1	3315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNsnVjsxcQpvfe8LsnW4eZxFwzTo4rvUYUjxkXboq4AvaRbgP
11540	payment	1397	1397	1678	1	1	6355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEECjvECK7GDtsAnpisHS1W1ZoJur2KBUxJ4ke9v7f6xcmxLVJ
11541	payment	1397	1397	1678	1	1	6356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKevUKW8rmBbSyMvLDPSnCi4AXF9sHq1W4ocNzbKUTJT9qjA8K
11547	delegation	2015	2015	1534	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskydjVsmhExNYTou3XTsH8xTtBa7XVdQTGpU5wyVVizX1ipVX
11548	payment	1726	1726	1874	1	1	3318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uH15WfH2g3gxsG58JjZyHrzPRBFvv5c5drd97ZXuoakgJd7w
11549	payment	1397	1397	1678	1	1	6359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Xt3zh1yyTDWBX72xdMWYeAm1yrNxEtV4pcRZ6YXfkqZw5ukb
11559	payment	1397	1397	1678	1	1	6363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1He4P1jvdT6VjZFLG2vwseRSqEAbMUjxAYXriETDCypBCKisQ
11560	payment	1726	1726	1874	1	1	3322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgxaZLzcg2GswFMXFkJiQtD2xK2QLxgSKH43XLNFMZ3YbfESY
11580	payment	1726	1726	1874	1	1	3331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyu8kBCpPrd32e3Taj7XrfxX7PzrYasi5U1gJsKtCs2i9dQmCj
11581	payment	1726	1726	1874	1	1	3332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNVLsdUfp3Xq8JyUcqr4Mi5ZyAxfqQvjtRjV42R3g8b8Mh3HW
11582	payment	1397	1397	1678	1	1	6373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpjyhWrM3Rui5DaxArmkwnwgnq3Kt2QENzY9vJ6cDvWroaAU3
11583	payment	1397	1397	1678	1	1	6374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMayb4N4nLLzBvqYQb1WhgN5JUMhN6hWykBZSeqLbwpKUdYnL
11584	payment	1397	1397	1678	1	1	6375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVQwcHAvnZqLHNBgXRkxHhhno5ZtpUDSVraYMBeSwBXtpD4rj
11585	payment	1726	1726	1874	1	1	3333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2iiH5JoAKUgisWNtf5ErRV6V6DYm4WDRcFTZugrgQrrJ4u86
11602	payment	1726	1726	1874	1	1	3342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAB3LzNjXmXP48gjZ7UpPjoMZcyjh1KzY4vn1QrkyZobFEuo8W
11607	payment	1509	1509	1509	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqbmbxS5JaTG4zWm5712Rqn1ZfE5AuAUPRq4cc2Z5KsWZmSzb
11608	payment	1397	1397	1678	1	1	6386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL2FiFWq1rcvV8hgZhhx8FcdWBRcJLifr15M1eaAZAnLpVXSg
11609	payment	1726	1726	1874	1	1	3345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBVuANLknfmg5yoG9VD5NwqTJmTjkcoRriQHoWRdQ3a4kgSVp
11610	payment	1726	1726	1874	1	1	3346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hSWYf9ETMhT3vyXLVUb9MxA9iFageXHf9pf2gGcvvhejWBzi
11611	payment	1397	1397	1678	1	1	6387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwcbgX1i6ZW4JxK9xEodXYuH7LHGBKdc6hr11hW9msyo6CWeM
11612	payment	411	411	2042	1	1	3	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnSLKyiByJZs4gnChei1bTVuZYWsgW97r2fK1anHSYnF6Pioi
11620	payment	1726	1726	1874	1	1	3348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQ4gQSjfgC9HEFLAmZoVQWf5X4zT31ZgYByEAG5vWFB4K7rVS
11621	payment	1397	1397	1678	1	1	6390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGwafuBW9eLYbYR4rM4SmYH2yDNQaCgECpJrhiVkD7nm9TiDF
11640	payment	1397	1397	1678	1	1	6398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagJVxixhTeurkamAYx4zESQoMNfhBtCqM5cFyfwgMKsrZUVnm
11641	payment	1726	1726	1874	1	1	3357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3zcuyiqoTAiyUCMDLvxnTjZfXLuCkaBwsfmvkotKgX6EjeHS
11646	payment	1397	1397	1678	1	1	6401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yp7YSztiEALnJqGdqA75d5JKc67D8GweSwFkCgFhRobHJ9YD
11647	payment	1726	1726	1874	1	1	3360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHYDkxjikSjEVQJCYrNLH1WE8bpToWNLZWm3wmsXHzSaRz9Rm
11648	payment	1397	1397	1678	1	1	6402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfWUQtXgjk3v3UeCYwWTNarGv1LKrtSuZxspACmt2s5Q6ZuDa
11649	payment	1726	1726	1874	1	1	3361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoNBmTsW3McsaocNBu3bn5CpS6mYdoLMaEJn3feRhVojpg7U9
11656	payment	1397	1397	1678	1	1	6406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm4tTJQCpnGe5UovbYvF4NLqixHY5xnkHPTZSVAJg4QYwyokn
11657	payment	1726	1726	1874	1	1	3365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWV1FUcuohPe5H9H74ehcmtT9Nf64SxzyijcRbW2tnGuvUsHz1
11674	payment	1397	1397	1678	1	1	6415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJak9KJWG98X1QCWrvPriwLKMNTuMZac9GzFRpFDRyWkstR4Lc
11675	payment	1726	1726	1874	1	1	3374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eDGEYnRZokxDhXgKcmWuH8uti1rdfrnzJmXVdVYLAf5Wy397
11676	payment	1726	1726	1874	1	1	3375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNdyKNDfUNfju7aCoUnVmRJPpbkgAtkqLwa3koScgjhjhs4WS
11677	payment	1397	1397	1678	1	1	6416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJMYbykQmTfujXGjkFG1nqhQSortaykgSFzUhmVkR7NFTpgmM
11678	payment	1397	1397	1678	1	1	6417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzCcMyhQbRf4KcqJj2rkr9NzQbLnLce7wwS2pLaxkm5EkJ9G2w
11679	payment	1726	1726	1874	1	1	3376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uqMnjTTkT1eWNcBwPP9xKrKDozVea9kMqpA2vKkCJebmSqjo
11704	payment	1397	1397	1678	1	1	6428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnqg9Uti5LEqYDGbnCPxfDHgcyskNLzWfbvtPYQcVjeMT4xGS
11705	payment	1546	1546	1339	1	1	4	7988000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpZnk9UkLonAXQa61rFrA3SfdJYL9Bd4qsG9SXfaCS2WBB9JLNEC
11706	payment	1726	1726	1874	1	1	3387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEgWYhPSmYjUbV1yRahdUVSbFKdjjUtvT4hx8HUybCwyqHKGy
11714	payment	1397	1397	1678	1	1	6432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJHGGFNv267LfnF8ec3aYa86EyEWofuaTxKjYZd8ZHpAXjYUt
11715	payment	1726	1726	1874	1	1	3392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfBG8Z8wgzrqhEsiCK1bjbQoeW3AJYWLBH12zkb7utXnHWRNCd
11744	payment	1397	1397	1678	1	1	6443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLLi1vwTUvtKh5j2rctp2oPcJkGYrNddup4RaVcSFotgnXeFP
11745	payment	1726	1726	1874	1	1	3405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZverSiAhzbc8dsaTLJaZMxTxs46wRc44RZobZBReZK3Uw9kjb
11746	payment	1726	1726	1874	1	1	3406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCurcSh8KmgHeEVxWoSyfhkbQn2cfBweLE7LottsuaYFJjsz1J
11747	payment	1397	1397	1678	1	1	6444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMk8dpCUneKNy6wBBBPQ8A8mRcNQHMComesxeXXassEDSnSF7
11752	payment	1397	1397	1678	1	1	6447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeXVb5phHTgWU34Bw3YinCDAwztQAv96Gk7Bs4yFtsoBHUvJ9R
11753	payment	1726	1726	1874	1	1	3409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJFTXiqhsBKvCZWcEcPAeNVPLqNJ7Kd4V8waoJMDp27NCCgN2
11760	payment	1397	1397	1678	1	1	6451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkVkZJ8ioR5cq7RrhqEtHzLq5gcJ5JEdEfu5GVGgMcPBRieTg
11761	payment	1726	1726	1874	1	1	3413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNA2wL1Wf359JAHHGNoVvkY2gkWeyRxJofzuJu8dFfbkVdk1J
11762	payment	1726	1726	1874	1	1	3414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptvvFKA7KAApx6Y9E7v9JNYiThop87CrEKA8N6UBHtcZrZUjP
11763	payment	1397	1397	1678	1	1	6452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYgAAZw654sFnAjsj8DMLSKftANmYdswSBJTgd4qVL5jErXCh
11781	payment	1726	1726	1874	1	1	3423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnDnXMLHppsFro392QuDfefB9VtbkWafdBdSovPS2hxSfVnJ7
11782	payment	1726	1726	1874	1	1	3424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXf3PoNNAUe9iVd6chvzsVddG5qUWZLDAB1dX1fQLzXb1bwcE9
11783	payment	1397	1397	1678	1	1	6462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKN959tGRDLSq4C6tGbzvXur1dFms2qhkeK633XX7W9gBwEaT
11627	payment	2042	2042	411	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfCJJyhdmREnLmP7EmM5DFB5sTjRqVqyUqCbP4ioWhTx3aMP7
11628	payment	1726	1726	1874	1	1	3351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VskNDZY1fW4GXbyPwHkizRszBqKV5UTPWtMTXa95PxWKYhaW
11642	payment	1726	1726	1874	1	1	3358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3oMMyehynsDG321GuhNE47SA7omdzyjs3wkqC7mxLEuLc714
11643	payment	1397	1397	1678	1	1	6399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mH5JQMAQdeVosz8vPiziPzQjHbKoZBeHNLwNRSkhKwDodDVR
11658	payment	1726	1726	1874	1	1	3366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ryhaoJJ8AsBnWH9DnHTJKFoCLLd9Ejez1cktYqBSSG3hbfnF
11659	payment	1726	1726	1874	1	1	3367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3n7u8AWSxkeUnZReyKHBc6KfBMayexhVcAuJKceeYXj1oszNP
11660	payment	1397	1397	1678	1	1	6407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKGi3ET8GBM7YH7ubcdnXvJZyUouMaytykxoh8bz75n6eXyvF
11661	payment	1397	1397	1678	1	1	6408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9n2kq7DLNsybVjGAojW23xPqNcnhFjap61yizw9hdvxwfd3Y
11666	payment	1726	1726	1874	1	1	3370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FCPk6SXMA9R3D4btQMnqs4Q1sPeZRsBx3TLieznbLVQ4yvr9
11667	payment	1397	1397	1678	1	1	6411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYH3W9nsPqr8tyy8oUyXQKZUkcjxSc2qPFuNwkg5hy8GUffQEW
11668	payment	1726	1726	1874	1	1	3371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56CSg5RqsXu9gap9A4QT5s4HEdhYxDPVQ1AzZ6JX4Hqo9CR65
11669	payment	1726	1726	1874	1	1	3372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ125gpRff4zyzeQ9ishPijWxxWbJxqsQsmgohA2VqDNXEcWYpR
11670	payment	1726	1726	1874	1	1	3373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFF49WsWyS7GWvYdwCczjkWty4ZZFua8QeNA4CQvejnFZtYCM
11671	payment	1397	1397	1678	1	1	6412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtfNpF2zpbraWsah26hjz3QNcj7xsXzjdKSto91kqLrHmitC2
11672	payment	1397	1397	1678	1	1	6413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttnyAjpDoGxb2qrUVdCjJnBWkb3VxFD7UfBZV9cA7pmCCKZeT
11673	payment	1397	1397	1678	1	1	6414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmtqoy5qhiHdhV7S4FShczTCAsML6T4BRYgEg5ZNMEQjFEgey
11682	payment	1546	1546	257	1	1	0	1000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpYbjwLPSg5pDZa9SHbEFuHmoDExfpMNzVerQB9DaribBoNEWiKW
11683	payment	1726	1726	1874	1	1	3378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgiQdKS3oLnfgUQTCJHRLQBgmEMGRx6RJiyVQ75U9ihsUhqXP
11684	payment	1397	1397	1678	1	1	6419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3MUgw1RVvtAuChhV8QtZjsLB9QtzZ487f3ZpNsaeRDGKhnnS
11702	payment	1397	1397	1678	1	1	6427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsG9XZYj1F7eTiiur9GmYxJYbqyD9qmbbwa9cHmBoKxcQo7qas
11703	payment	1726	1726	1874	1	1	3386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcC7q28ZdgQ7Uwb11Wt2avzzbKUwcgKc7AkZ68wnGZwmEitSC
11711	payment	1726	1726	1874	1	1	3390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QpyDxT5uJ48FBCrywY1DoJJbJkCAuX6ipdDemdodpWtxoPEV
11712	payment	1397	1397	1678	1	1	6431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8eZQ3hGi8uRahcVAhwKsGqskpfzeMcZZ1kyXygAtdfkuixNmz
11716	payment	1726	1726	1874	1	1	3393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6ZGRDu4hwphvjxV64EuKEv7WDKigup3ruT8oNdMHrSFUFqzd
11717	payment	1397	1397	1678	1	1	6433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixhif5fVxKHgwF92ytkku4JMapMciLh86ocRSXugiDKegcRha
11718	payment	1546	1546	257	1	1	5	1244000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpZq1GEF32uHgp3rFmWUeLWfTePveCT6hFYH4wSj2Mjjp2ak1tF3
11719	payment	1726	1726	1874	1	1	3394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDB7mVmukSjof13kabCgAvuhwnckBZCvrCJapzj74Uy6WuGQBb
11720	payment	1397	1397	1678	1	1	6434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSE762YdkdLyoCtRSTWKzk1sexvCj3VfvX1yYrYSt4adcHuRK
11723	payment	1691	1691	192	1	1	0	227799354186	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpYmMwD32NLEVzPperekWqQwzki7UiAVdY5jVNd5RdLoxECWCRFq
11724	payment	1691	1691	918	1	1	1	1732430933512	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpZPjiMVrHVVVCckY3vRyr43JUBrg61NoVVtgsB1zcMcHrKfxkf1
11725	payment	1691	1691	1038	1	1	2	3104501389392	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpYUKT7WPTGniweNByfWJ5gd9XaEP1HQzX9VSZikKScdcoe7ku4o
11726	payment	1691	1691	1158	1	1	3	2094668948983	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpZaexqaoV9y7AjDRTorSHGbGJkSyHcKMWtQ64QatyQmk9QqwtLj
11727	payment	1691	1691	1284	1	1	4	5836981273908	10000000	\N	E4Z2SpZ8WAd1CfYpjnRYJibfuux4HZwAcxpuGuTpkV2tHz6c533dQ	CkpZMLTEDjbgKCP7S4ZWn6DiHNuSQjTJYUGQN4Uv676HJ5P6SNCxd
11739	payment	1397	1397	1678	1	1	6441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyoNnuRpp2eddY8eLUswqihN4WfDciU2Uzji1uP5jDy9yWQKQ
11740	payment	1726	1726	2044	1	1	3402	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYrQaMsTQVUwDaktgWs2mpSVk7vJBsGkL4cffLPJYkSAJjBrHBJ
11741	payment	1726	1726	1874	1	1	3403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY87V9RSnYEoFD68a5UE9q4LWF3ryHtNjwvxdMAbQZq1LyLCMx
11742	payment	1397	1397	1678	1	1	6442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedV1FKpWHNeqs2PijzFnVZP4itekVJbDEUnnd3buzdBGeMVr6
11743	payment	1726	1726	1874	1	1	3404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCQqzVpNKF6KGVMgt3PxaJ21zA3dJeWqDabEAAZNaRGc6tAmS
11650	payment	1397	1397	1678	1	1	6403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzT1uAY9PgCh3rTW2F3Qs48HK4K5WdTj5p4WHX966T6xwDQMPa
11651	payment	1726	1726	1874	1	1	3362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrX96SMqSMah7xSb91xWqiuAR6531PinsmwJA1h5gjZF2cpKy
11652	payment	1397	1397	1678	1	1	6404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4PyoUAsLYGNr4USohjsD3jvFdDJLFfYdvnRAPMmMNMxtSia5
11653	payment	1726	1726	1874	1	1	3363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZkLJwFXABuNvER2bzLDHuTvy57AyYS6zSXPwW2cFo6AwqdL6
11680	payment	1726	1726	1874	1	1	3377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmgKefDoiz9pKZSafSEtY2A4kjVNfmwF8MBALAiYo1emRmchg
11681	payment	1397	1397	1678	1	1	6418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieNZseVkACs3fBLk5Ts1yx3pj9t8SEBcb6cHPqG7WKAqcGQYP
11689	payment	1726	1726	1874	1	1	3381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCdZmvHpQnJMoButYhysAibCTDzb5DrmB8jN5vWjFuQuEMrVPy
11690	payment	1397	1397	1678	1	1	6422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXKpkbxrA1Byy4hgJga7CkKipJ6NRwo4J2bKPmGmM5iFmNmxF
11691	payment	1397	1397	1678	1	1	6423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiNFWd51y2azimDxEnSq9dBLkM4jzq569Suqx9WXrRQvrH3Nm
11692	payment	1726	1726	1874	1	1	3382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U5cjLuHYfFq6BAJaY8M33X8bP7VLi4JDYCANGkiE7dgnHMbV
11698	payment	1726	1726	1874	1	1	3385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8F3SujVSuX7nvJ6ZVk1kKNy73otYm49zugQ5nCKTFShQ7Wy3E
11699	payment	1546	1546	1213	1	1	2	2867000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpZd3qHqACj9G7DBuqSK91pHsNQuBi9ycb3GX2UAhLYmc9oVn4Aw
11700	payment	1546	1546	1093	1	1	3	4249000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpaBAwC5rPN5YoR7KXwCbjFBQuZvrHh4q35P95Lorj2NnWMZT1VK
11701	payment	1397	1397	1678	1	1	6426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCuS8T7fXXm7QMoMQHz7fHWPGPhttbUDpwg4Nnn6ZdVCqUy2d
11707	payment	1726	1726	1874	1	1	3388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZuf5rzgBueNhrFUNKf3G5YTwCdJ8Hvw3bg84WQKq4w1SUSn6
11708	payment	1726	1726	1874	1	1	3389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGDk7a4NBvCrFEiSSGPkfuijWF9hDX9UWiBnD93mu7r5SzKm2
11709	payment	1397	1397	1678	1	1	6429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWQbq55ztS76r9MZctx127wW1ffQaQ7JNABEMA85fYW8HQtjc
11710	payment	1397	1397	1678	1	1	6430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4iJ27YtX8ENd1CSrK88x1SPi4B8o8esDXjoGKmoggToPZKLh
11756	payment	1397	1397	1678	1	1	6449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCut5NXEokQFAkFVq85PnrbKxNknuSumQCa19yaG7H61u4tK1
11757	payment	1726	1726	1874	1	1	3411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQcMmEDea5j439berQJCYAaqcGb5rgL4pQ8UeizN91XvHyYsQ
11758	payment	1726	1726	1874	1	1	3412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnDLMNBdWfj2PBegP6obaCSJtnURb5rXakdA8kCJJRZKW2azw
11759	payment	1397	1397	1678	1	1	6450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FqEwKs1Qrmygqk1k7zvx9FoNBGwJxnB6dPXQ35FVQ4kcwaUy
11766	payment	1397	1397	1678	1	1	6454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfRKCPPX7exkxsoQKJ8wA9b9VzMCfSD4FAC89tNyakihTMyNy
11767	payment	1726	1726	1874	1	1	3416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzgdihufbRf1YaFFtjP73ytmHXM46Kjgjoou4SHup4jWBf7kh
11778	payment	1397	1397	1678	1	1	6460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawXPbMGqifsL44nNy644RKT3GTA4Qd1RaS3cnhuZwP4BA623w
11779	payment	1397	1397	1678	1	1	6461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1NzQAZiu7byLqqycaZ399SmHHFEByXkoiRgR4mJAFJCUkaRt
11780	payment	1726	1726	1874	1	1	3422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnivEqz7Ef3Ewoq7iLvZHH8MNyzEXz95ewto3x63CuoD5WPZN
11810	payment	1726	1726	1874	1	1	3438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEARwXxQhK5jvwEifr2PnjQo8T6nxSkmAMMexBPGPcQvAMQtpY
11811	payment	1397	1397	1678	1	1	6476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh3c9N6wYoGp9X9sfySCykPYmUgPT245wKmeWvmKU5tTzKUj4
11835	payment	1397	1397	1678	1	1	6488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuXbvu43MkeqMATPKVsEwkwK4nrss5WFayBWC2AYA3HNPEKiF
11836	payment	1726	1726	1874	1	1	3451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggbqPfVrPeo3bDvPNQVh85Z2CMMjGMB1x5co5T8btnRSKDGRd
11860	payment	2046	2046	1937	1	1	0	200000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfYZBnrkqyorbYse5i9FEnnZwfjuE49ehe5XJCPEaawWp8kxj
11861	payment	1726	1726	1874	1	1	3463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZXAbAxuHERUWAs6weDxcQiFaucF16oKLiH5gDhKERAJeAHa5
11862	payment	1397	1397	1678	1	1	6499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ri4hXgR7RtTvHZL1WovhcCvaEL7SQEKbnCW8tM43fKJsccZm
11876	payment	1397	1397	1678	1	1	6506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRggafXKFK71xL7BSExSHTUozVzCRKLJcpejhreqJqc7j1bXh4
11877	payment	1397	1397	1678	1	1	6507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1hCJQ3zm8grp6XCbNgHTpzWv3mJ2XkE4K4TkzxMtmLQhqizX
11878	payment	1726	1726	1874	1	1	3470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAdnLHJLW8n1mgUUEcuFk9sCfaie8p3SSdNKK5rsrdMRXSGRS
11879	payment	1726	1726	1874	1	1	3471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRS6Cu5Huha4U5kshbaf13ktp9afjaWsq3hepGtfRjjJMi8GY
11664	payment	1397	1397	1678	1	1	6409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSXwXCGQ5MqegphFScjrbShE1pPWMjGtY5XwF1o7B3H627naY
11665	payment	1397	1397	1678	1	1	6410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7NnSewrcnyZkRPzffBX3m6FLWjJpZ7QFod4CSq8RmKP6NLPQY
11685	payment	1726	1726	1874	1	1	3379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofKKCf8HceZArnzbuqXfyitkH14d23wfJjYsdfEqz8frpDXW6
11686	payment	1397	1397	1678	1	1	6420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJk5F7GkuT4Ud7ZVPmS2L2iwnj9VDDjkB6oLt489y8m92odHo
11687	payment	1397	1397	1678	1	1	6421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaZvrvYPpqRzPuiUzrJWCvZwQmCXXTNdrLTA3tLjF9VhHevX3
11688	payment	1726	1726	1874	1	1	3380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFkRvGJGGnx6be3jbY8DdybGoEn5Q46JQhCkVJ37hqdkKWtvp
11693	payment	1546	1546	973	1	1	1	2371000000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpYnFaHrstARDzx5meckKtL1vgzHTCMeFzfQrXoAbDYKh8UthxWS
11694	payment	1726	1726	1874	1	1	3383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PiFsbpCcBW1sV8e5BWzx59GJHMt71uM2Ei7DnbLb6UUqJnmY
11695	payment	1397	1397	1678	1	1	6424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8f6VEPwiJP3HfGMBCVGbfzVcsr6Gx7MQnDbgtTnEgfUwK7ia4
11696	payment	1397	1397	1678	1	1	6425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacveM4F5dzbrEwa1NmJwFwSUBjH35rt4zdvtrTHaTSmnP3p5M
11697	payment	1726	1726	1874	1	1	3384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3u2CQixB1R3RuPsAazEEXEAZ5RCNV4a9ePtgQSJr3MuvVJGcc
11713	payment	1726	1726	1874	1	1	3391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoq35b9d8ooT8w7EYvTSK7PUsmdc9tNWv5r658mjyNBr7xXFXv
11721	payment	1726	1726	1874	1	1	3395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPLfLoHaFL47VXwaRT4fMJAymPvbpVV31Lgm8cFQNGE3VEKdL
11722	payment	1397	1397	1678	1	1	6435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mmnZU9gzFwUQymiRAUnsHB7MgtmLQvKV2eQbQPvN8eaepA9z
11728	payment	1726	1726	1874	1	1	3396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYZeWGHPnu24kG8rmzNtvFEetdkoHFLvHuSP8uBWn7xqa1YsR
11729	payment	1397	1397	1678	1	1	6436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAvk5r4QrwVAqNWdyQRxfBAfXpVc2FbpGR5xLYMMzc2HFbyt5
11730	payment	1397	1397	1678	1	1	6437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1LyxK73xXbGWVocGjaTNEW7LNXRQTk7a4KLsZ46kDJuCNuWn
11731	payment	1726	1726	1874	1	1	3397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfHohnysmXgfdQ4yz4ojyrfUouZr1KGTsqyDzz99oBwCc4Q1L
11732	payment	1397	1397	1678	1	1	6438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCR71HBH2HvcRCQBJ9NsBE8o47bZPqoeDzuWVTiRrX4fcck6UA
11733	payment	1397	1397	1678	1	1	6439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoHFX5bWVjmrWAqAUcLZYyC7uqTEmdhafSvTTfVi3rDdfDd4Y
11734	payment	1726	1726	1874	1	1	3398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6GoxP5afEzhSfJQnvMUb5AjmbPPKykZTUWQT8d1VV4EtMGqUi
11735	payment	1726	1726	1874	1	1	3399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjcYzbRmxR3WNXRWqDdYx2KmXe5JQ71wrKsfJ2FvTY1H8cAzjR
11736	payment	1726	1726	2043	1	1	3400	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZG5euYbcNFH2bTiSygtTiX8fz3hunmXaDxtfZw2z55ztLxCVyX
11737	payment	1726	1726	1874	1	1	3401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyd4JSSYh22TUihTECnHNuiq2zs2cvu7QxW3tfsb4EbdFiFi9
11738	payment	1397	1397	1678	1	1	6440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmapYrRV8CKQQJ4Y1qDYiue6mWtYRb9zkxhitT9jYv1X46D8nm
11754	payment	1726	1726	1874	1	1	3410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviwPgnmBwCfbrFWfGCtKfRXfUZCbLqnKHbrfMKQncCGc3hrsA
11755	payment	1397	1397	1678	1	1	6448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4NwBVXG1L7GuJDF3FfiZofrTtC6MuTWK6vL4cPZj3j2GSG2c
11776	payment	1726	1726	1874	1	1	3421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgHKUeprpKF9bD6CRvtT4VoBZguPFqEkwVr6TqM88u4e6cLTB
11777	payment	1397	1397	1678	1	1	6459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiWbAD2EHfNpbjtcmrR6MitZSiF5KUmBhrseuTjFZiXK9TFQu
11791	payment	1726	1726	1874	1	1	3428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGTWatAyX7gQX9i9mFAQbTqWW54pzxwGx1LJM9q4EvC1QKCSZ
11792	payment	1397	1397	1678	1	1	6467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKhmjrphQUL6GEUeQ4b5CjpiXPb1LgxhNgsrrEetv4UBdRmEZ
11808	payment	1726	1726	1874	1	1	3437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8QVFSi71XL1J6MwCHdzvoK98hQv9732jht9aHLK2r7EtCyWE
11809	payment	1397	1397	1678	1	1	6475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDf2u9KVqTRB8TG15bRJfkk333uFCApein1QAtJZ5gRC72QKCW
11820	payment	1397	1397	1678	1	1	6481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6yWpDAjqDF7HeZ1DsWD9Tm1PAtCLUgVchZGq8on8heAgosRg
11821	payment	1397	1397	1678	1	1	6482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHBa9mXuWa1vfa49EYyqmAs3JSf6AiJRE6Z78ETAZtqhPePcE
11822	payment	1726	1726	1874	1	1	3443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QGoTZNQTsTvT7H7qY1mRbLqYd1nYvGiRPaWhCfx2iBZs9bnS
11823	payment	1726	1726	1874	1	1	3444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXtqAR7XUjJXCHiiHADGpvweHd5aoXWP4BmyhiT2zwzSyQsyQ
11824	payment	1726	1726	1874	1	1	3445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRGxMVBojSHQpUiF7ZSjzAbU2fLP5EvCWUFq3RRMA8EhWPnau
11748	payment	1397	1397	1678	1	1	6445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnRm2kSZRdLcQjDGgNkQp3grpJTa7en5VLzyb73XrtFvZsvfV
11749	payment	1397	1397	1678	1	1	6446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuS3cxaTBkt29XbXDsCSrkpLY9SNiLpYMTvRyfnu28SCBVcdL4
11750	payment	1726	1726	1874	1	1	3407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNScgr6xg1y7btMV8jpv1cc4f3LmzFfytgdsS21C6gFHe2uEw
11751	payment	1726	1726	1874	1	1	3408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWnnDKDkcpZ3r1yDXEYgzn3uu3VburogMcHyFqzjwReKgz7WRU
11764	payment	1397	1397	1678	1	1	6453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeCnUYmbV7TeALSMKf9j79PV3WYmToQ5jTmcBKmcfsU68tz1N
11765	payment	1726	1726	1874	1	1	3415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9rvJxtC5EasCwK1azVxmzgNe1mAoJfSbxhb3ZBKMPAnDTbQK
11768	payment	1726	1726	1874	1	1	3417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9a95YRou3jKek3fwdvnzJ5jW2xrHVJRT9u9t4qstZUVdwFZA
11769	payment	1726	1726	1874	1	1	3418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa78KUSYFeGaECvNVVPxfWGSNvBtAXHTn3p2EXNFT9HahtBwTy
11770	payment	1397	1397	1678	1	1	6455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukDWvxEYa7QbH9RZxTnw2APPCjZJH5GfVegK1csD4MgAbdQEN
11771	payment	1397	1397	1678	1	1	6456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94vkePwKrE5T8dXgfiykLRbHTJfC4BRWgScUnpMCnhF5iv4JT
11772	payment	1397	1397	1678	1	1	6457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76BD2Tc6FjRmdwttwV5xL8b9VDt5UHmdD54FpSd4uZcbseFpN
11773	payment	1726	1726	1874	1	1	3419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhQcdnCSL7JKfbanpcD67ykLz3XRgHQzSCrBXSs8KQK1Jw6hm
11774	payment	1397	1397	1678	1	1	6458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8ph3K9X5247rVg2TwfotQU663bSrEyBZERqGJn83PoaDuer8
11775	payment	1726	1726	1874	1	1	3420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YZiBzVtLTDFQWVm7S5F62Cx4Pkj3G6WXBQio9Um3yuSmVD1K
11787	payment	1397	1397	1678	1	1	6465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59ELrJJgx2jH9tHMJ5uabjmHDyz6UVdea3pktHyoZH9XTRLER
11788	payment	1726	1726	1874	1	1	3426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGzFBiQAxfbMgawha6WyJ8hPGgo927QtJsWm8cFNUq5iNXAF31
11789	payment	1726	1726	1874	1	1	3427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVg5HUmhdYXfYXbjyEHSoDZrydgz4WhjJAfmMdz9tS6x9TKUe
11790	payment	1397	1397	1678	1	1	6466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhS8V6YYekQTm3apBrJrsXfWHGxe9RksaAVsMbeKWpbUrYxbtJ
11795	payment	1397	1397	1678	1	1	6469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7FWMN1mqgTDGDKdUciVNZjn3CuxbKwpkW7DpgLrfWVdMi79s
11796	payment	1726	1726	1874	1	1	3430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGQ9S3PRqSVtAn2snvpW87uk4bbEGz57KAiP7aSE9AB4s6xZf
11816	payment	1726	1726	1874	1	1	3441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGHYbk7iShLmwRnCMsQJBeDZVEw39cL3PaosA5zwMbbKp2HtBp
11817	payment	1726	1726	1874	1	1	3442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNoq6fhrQj5j8bKxmme9NM1Rn5wuuS5FN9GBdDUEHsufFN6ZgU
11818	payment	1397	1397	1678	1	1	6479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCWy9j536tBxJNetm1F4WpQqqztkf7trHLd5VjporgXZQsd1R
11819	payment	1397	1397	1678	1	1	6480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppFetZ5jsHmA1AKreH2HwaFbUMiZWv7B8TZf62KcDQZ5o7zoc
11829	payment	1726	1726	1874	1	1	3448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBRMNupz85JrjHmzixzCHoU8Zq9KtBRZPKuXfBibt5bDHGnoJ4
11830	payment	1397	1397	1678	1	1	6485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5L9fNNDNKfgtdg4M3uBvH1s7WF6yYTD1wBgx6E9YC5qyBudn
11831	payment	1397	1397	1678	1	1	6486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53r1x7nQGsyQn73fu8joqmkR4JoAQaoXR5FXmD6uZRX7DfPao
11832	payment	1726	1726	1874	1	1	3449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKprxmJaKh3Rj8toKcFdoCTa171dzMtcqwzpcXptU1gWSgXuax
11837	payment	1726	1726	1874	1	1	3452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAw2tpnkkmdNmaKd8UKNWq6MfrMPsHiQdQ9xEWJMo1NbCSKuR
11838	payment	1397	1397	1678	1	1	6489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh28H7Gfd1i6uy8iwzezXLARpYYwGaHdSZ7o2wg3cnRQKSeRfQ
11839	payment	1397	1397	1678	1	1	6490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXCeJd3LgL4xRTXRAi9xKb8i7nHTcLwYw6GZh3VTodrhHDEVr
11840	payment	1726	1726	1874	1	1	3453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsPTam8WPCSBPzfS1f7GV3fMdBnMdWizVMZL5MNxNKxJyVjzg
11854	payment	1397	1397	1678	1	1	6496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYphBSJAqiS8TbsvNvCAEYcY2gMruJC4Lo4Pe7sCapNsAQktFU
11855	payment	1726	1726	1874	1	1	3460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSVEybBvjLEUwMCjuJe9qsVSwEroorcQEnP6YgNphsqSXdN4M
11856	payment	1726	1726	1874	1	1	3461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9NHADg9pKVCmLJGsnPQB1N3t58aBUdqXNvhmjT63SDNNzUST
11857	payment	1397	1397	1678	1	1	6497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQkajm1ciAQysC8CNQkALJn7QFpCcjA3RtWnfexmvAURuYeXz
11881	payment	1726	1726	1874	1	1	3472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5DzjFYkbmRwBTLxwZecpFgsXTfRqGeukbv8MPAm1QmhjtG5j
11882	payment	1397	1397	1678	1	1	6509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfugTKFWCJ9A2fWDsTUcsDQPJVFQTEkL5ARU1D7cQYSSNaMnuB
11784	payment	1397	1397	1678	1	1	6463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9tGyCwdJ1wzzgKz17vxDByQnSJELPm2yBaELbXVN3qWnSdUd
11785	payment	1726	1726	1874	1	1	3425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6yvj5qxeFGwYaW9Ao9Z87ySYoRr7KEs4yFcAv2RNtqctR1Ah
11786	payment	1397	1397	1678	1	1	6464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLqKTwnmPgTmCNobsCx5fhzfmB6SQeSXHwwEj5r9bxpwA23XU
11793	payment	1397	1397	1678	1	1	6468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBChGuGjAJQZVEWkQLno4UMwHufWhXdVwR32wMNntkXutbNR9
11794	payment	1726	1726	1874	1	1	3429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4XQZxH7HymZdNWDoBCwdmxtsp6LRHHNzSekKEuVZPaGLh3AY
11797	payment	1397	1397	1678	1	1	6470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrfBCjPLkX6kmGcAqgVfqJxrVx5wrQKoM64ekEYQePRL7dKAU
11798	payment	1726	1726	1874	1	1	3431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UCt2a6QiQLiqGruKEA7wHeaLvypEc5MhHF7zci5iT8ZcshG5
11799	payment	1726	1726	1874	1	1	3432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsNJCJHjPyWFc5n88BmJYXcwcAN1GfY2tj9CWsvaAp89uNXN1
11800	payment	1726	1726	1874	1	1	3433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp5yUHKeiie1WazQGZ3C4p2QjBXmEvUZwVugop8RufMRyGEc5p
11801	payment	1397	1397	1678	1	1	6471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PuxocpKbSKsRU4cStuNUUC8FhB9xtZdXiidnnbjDhGo1vJjt
11802	payment	1397	1397	1678	1	1	6472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJA3FkVbVmTFYmCtLccFGT9FunakBLJA7ApVh5SEBvxqyh7djA
11803	payment	1397	1397	1678	1	1	6473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEJDfceBzRUSBjVcqKtBMjt7WNim1RxbtiL5WPnjaJFz5bA9k
11804	payment	1397	1397	1678	1	1	6474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BLCNnuHqqcF7nDfopBrWVcFRiFbQzycLytNrotaBGqJrvtWp
11805	payment	1726	1726	1874	1	1	3434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQrc9ne3dQuKdk6D1m9i3zZfzeUuMcCidJsBj5ye2svKD2xTZ
11806	payment	1726	1726	1874	1	1	3435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxq96dyhLK1UafwNoYZcAWJaegKBAZKRxS47P4c1KZQGTvM9ei
11807	payment	1726	1726	1874	1	1	3436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvJLJqhy23cQS82tfxvgdcQVFTPvAmhnrp95Gno1AfiTKkiHt
11812	payment	1726	1726	1874	1	1	3439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwojrE1nDMgbFoHajzk7UwCta2V7XVbNc4hVmFGvbeC3QE6M7B
11813	payment	1726	1726	1874	1	1	3440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1LzfFWxwjNqJ7gSyx7TdtE73SYrXPo4h2g5g28kBpaAFyjvh
11814	payment	1397	1397	1678	1	1	6477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqwtjFQpNAykPEdgnkgs9FwFeToLd2Wvk1NH5qEXqstw5r28y
11815	payment	1397	1397	1678	1	1	6478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKihspdVEGH3kDAZHt63KFBgf8VnrugVnGsTZ2uTQxpNB9G4j
11826	payment	1726	1726	1874	1	1	3446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFUynXjwq5ZpEi3FHEzDPRhsdpBQYKvnad63EaYq3gDN5yHoi
11827	payment	1726	1726	1874	1	1	3447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5z1JcnLEonaH8rGUb14P5e8kvbuxGgRfDfc817XBKMNxbqXw
11828	payment	1397	1397	1678	1	1	6484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAyTmY1QkqJNU8p7PeTdQ6GyhWSjieBAnjtDs1y4PudvLbD3M
11833	payment	1397	1397	1678	1	1	6487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSXu4t1JMVMNo52Up6xbaJ9e7dpYMdehvQ4PptXmApCg4YfgX
11834	payment	1726	1726	1874	1	1	3450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYKD2hFcThZ7RPj2w67cRquiJdyyZb6YsxrppPvCmRE1Ph7eC
11841	payment	1397	1397	1678	1	1	6491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSXYQouuDEi4i4tPnRKgYsJpBM3S1NXpDa5EW68NBEyzB1mBK
11842	payment	1726	1726	1874	1	1	3454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCbsJZfgh99VDvssoZJLfqt91Qj4DkKQiV1fBMURawLf1ANjw
11843	payment	1726	1726	1874	1	1	3455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTBUdvAaYXzKcAySN2f1jG6K7wnBoGPNPpqPCbTjuCiYURCKv
11844	payment	1397	1397	1678	1	1	6492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJQcp9S12tC3hktRRtPUdDE3c1775cYwhP3LZiGnSpWUCvMEY
11848	payment	1937	1937	2046	1	1	0	1300000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcaULwKGXeJNRTjN5tGRApMW5bUArBDspdyWkKNh1oqd2X5Bz
11849	payment	1397	1397	1678	1	1	6494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEZ2v3yyLajySZ94vCqSFLHmiW7V4QGpUGuDV7eXBf1dp2J7o
11850	payment	1397	1397	1678	1	1	6495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfQv9GdMDVMa9MpSYhCBcxJTUkbi4NZ1USNnJTA22b13zNJzu
11851	payment	1726	1726	1874	1	1	3458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJw9QzG9zFAmrbF9encxnkuj91VNXZnwpqmuDTwPThrJs4aLK
11852	payment	1726	1726	1874	1	1	3459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33YUGSSLKQXVUggnXHibMZcSEkrs6VtUsxuTpax7nugUeu9Ky
11853	delegation	2045	2045	2044	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjVyTDq9vf8EXCfeu65bLfjue36HRRY3LmBrYmjqwdQUTcG2E
11863	delegation	1937	1937	907	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Qbx9bi2BUmB6KN5Yhie3BY5yds7ahGNE1JFVxditTX1JYGCc
11864	payment	1397	1397	1678	1	1	6500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSdQGqrKydT3UG6dBRxLvqa8Ei9ZjFNK2WPeAjPTCztfk9wEb
11865	payment	1726	1726	1874	1	1	3464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6XbQnnBvUunAkLTUdY55m9Z41f3uxJyekVTfLmgaYvaxPf6H
11825	payment	1397	1397	1678	1	1	6483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFPUKvF3Cftn38UHyNKAxQ2e1v94uJHArWEnZtq3dEBEBXo6m
11845	payment	1726	1726	1874	1	1	3456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhs8PrBSf4DFyq4BWm3FgUj6A6spX4XHako8WMY1mSpUXhdfMx
11846	payment	1726	1726	2045	1	1	3457	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkk9Lp4a5PzfyHqepcYj3Zpw1XWonqpkdruaPx7UVaCACKZQ6s
11847	payment	1397	1397	1678	1	1	6493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuM9LS37HpAQkvFdHdUfhsnJscoP5pHhfpcSV3knLXpvx73aa7
11858	payment	1726	1726	1874	1	1	3462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8soWRmaKz6dbbF1o7jomtjuvgPNKfthPyrv6o47WgzyW5pbKz
11859	payment	1397	1397	1678	1	1	6498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9BhKoZWL5nKYVBb8q5ZQsG7qbyGt6aFGwTbbWaVQaM1HL3kC
11866	payment	1726	1726	1874	1	1	3465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdydBMMModruR8ZonutE4qXBFUCrkVJ8gXEMkxYQv1mEbYC8gX
11867	payment	1726	1726	1874	1	1	3466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsBfXbFj6TugVTxQe6oncCxijDmsZ5gfp1dDRpvw8ZGQ1Tydd
11868	payment	1726	1726	1874	1	1	3467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZremUWPFMB1MQxxt9bdCCTq8H3fMTLJPom1gMD2RPq32gKLm
11869	payment	1726	1726	1874	1	1	3468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGUCS8CVCDoCYRDL51aPybdGp1AobbihRppVgWmbZNKK3gFNY2
11870	payment	1726	1726	1874	1	1	3469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksW63Gi5ES7MBj11hC7JFGuxLa1QmEXrosYZvBnyHyRngxxMi
11871	payment	1397	1397	1678	1	1	6501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNP1FnUv94SyWwmhbwS2obmKW6tkePEx5WjxV3ripshWLm16L
11872	payment	1397	1397	1678	1	1	6502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrHQoBNXnFdrb7J6nUMdEPLKNThb3A3QnzBMeEawrxQ3qt4rm
11873	payment	1397	1397	1678	1	1	6503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDfnwnkekFVTtjrgtz4AT6RrNQDRpZYmwHw96ZpKNKPGp8qqg
11874	payment	1397	1397	1678	1	1	6504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARb1vrnpboZWXNtsD4c3651eWAzrtd8Yu1cpY2RPYRNMxjhrn
11875	payment	1397	1397	1678	1	1	6505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCnWZXiVwrCqkd9En7DaRNf2SoGRDiDrz923HHezdQX1ie6qj
11889	payment	1397	1397	1678	1	1	6513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBEujXdufWFVPjchx6985yyakfHCgHRkkUqVBaiivuaobnSdz
11890	payment	1726	1726	1874	1	1	3476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCS8LSQ3G9decrdBuF7R3FRAe4rjz3thcJsY1NivvsHjWSXnFn
11899	payment	1726	1726	1874	1	1	3481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aoZPmKW1ZSUmB3y2Gk7tHmPnbGb9Pu9h35hNroXZMGFPTpFB
11900	payment	1397	1397	1678	1	1	6518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLCBjMRy3EuwS9oaDRqMkf56chWCHy6kbj69pBxaVGueyJWib
11934	payment	1397	1397	1678	1	1	6535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ywxigXZ68YEBcZRUNXBB7Wr8ePVW4Kb6KGBTipL8qUFgGtPS
11935	payment	1397	1397	1678	1	1	6536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNEfgwiUri7NDtV36buikXNq8n4PCxmFJQe1NBWyKazDyJL26
11936	payment	1726	1726	1874	1	1	3499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwU5wWuFSYmBCFe9rggXBji8hrC1QQ7w7pLa14hX3t5B843omR
11937	payment	1726	1726	1874	1	1	3500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FBrKmCkME2vPMurJWx2RpHLugBxMCHf8eQRG6TPjRACZvnoq
11958	payment	1397	1397	1678	1	1	6540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwY2VFkVMZvKcAXUdZdT4us7n5Gp9aB59adSD1H8okp3UJzj4a
11959	payment	1693	1693	251	1	1	577	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZsRQuZ25yeMtr9uC3pWE2jkJuzH9dgAygtd6EECgACD73bVm6p
11960	payment	1693	1693	99	1	1	578	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZVjJAXR3swb5SU37BrnKx71Ei68W4GKAvGT3fPHAvHYd8RvuHj
11961	payment	1693	1693	570	1	1	579	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYq7EhjY2LTsuaiUtDd1H1Kb9TWa6Zbkw2EQGgjm4db61NuhErs
11962	payment	1693	1693	893	1	1	580	327851556730	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYUte4xw4ABSGSrJgdsFycmbm1vTYphcCHLxJBFGpmYmeao8fwf
11963	payment	1693	1693	390	1	1	581	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYyVgAHuveYkfCAsAKeaLSzaaPSjQt68NKqEQv782qDgKfHw5yK
11964	payment	1726	1726	1874	1	1	3504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ReSX9w2ZT6iKi19xcnqmo8WJmKTgynYurD2AZzDbxG6U2Tyb
11981	payment	1693	1693	402	1	1	594	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYvPg8QKFRNbSyeN93TbkkgTjwe7SAkwX4kmdKz4A7azhpmU4mP
11982	payment	1693	1693	275	1	1	595	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYneQxeUigWCFHgmaoJ5S13pok9ziBo1sBAeMjoHwjsUt3S7ZK7
11983	payment	1693	1693	163	1	1	596	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa7Rkxx7eRQ9kr5UWHnQo43rh6CLi6XfGmyGieqfUd9YicAz861
11984	payment	1693	1693	397	1	1	597	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZK73cf7YrUzptYPaC2DRAh445WNCFgXhdP5kHQmGaVC2hoTQX7
11985	payment	1693	1693	391	1	1	598	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYRrNr7f91QntpvVLn6tR52uvMqaK9bjL3hXf98Cn4VC5g2ixGo
11986	payment	1693	1693	452	1	1	599	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ9K3nxYn4ouv5uThrkQGZ29srwWc2eBKzQ3rBWHJZbD8w7ud7p
11987	payment	1693	1693	106	1	1	600	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYW2tZhVPTJZMK9uYAbN9D7NyynT8ABQnSqRUbS4n7A2YBvBz1b
11880	payment	1397	1397	1678	1	1	6508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEJo6GSEPrVHEg77X1zyAFPYEzM1EsBEptgDVMSfJiLWJnzFM
11887	payment	1726	1726	1874	1	1	3475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4a8HxWR1uTW3bLJmwh2Fb2WdhAKQtfoBC9TKMzYMiSGYuHzG
11888	payment	1397	1397	1678	1	1	6512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ydnRLzxQog3jsxxVUQ4eVRyDPk4CVoEUF8KZz2eWWPw3w2kL
11901	payment	1397	1397	1678	1	1	6519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9WQTfNGwZB59Lv8xsEmHBrfNyRUU3zouhwQJE9eRgzSD2G1b
11902	payment	1726	1726	1874	1	1	3482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2CaYKjKSpLsETWrwcbnEtpz9nAhD8SpYNmsAFZD3reMWdDXpU
11903	payment	1726	1726	1874	1	1	3483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkekvwRsAWBMdPJurSQjkiqcJQHy2S4PgEivsKmKNNwt8w9yv
11904	payment	1397	1397	1678	1	1	6520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TPsuSGDifQszUpuxSbVgUt9ZKHboK6uARXcTK4TDyPn5Jxvw
11905	payment	1726	1726	1874	1	1	3484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57TccxyPnD4U2XGWyFaMRLxL9fySG842hLVx5cnjRGsL88tB6
11943	payment	1693	1693	103	1	1	566	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYwuJDp5H8q9KgUVkfebji3j8h1u7mKu2eCYnFPAFDjFDiv7crn
11944	payment	1397	1397	1678	1	1	6538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj2st1Fccdbqzvns3mehGFG8QPDZWQS7qBWe5fRrTKhVf4uBG
11945	payment	1693	1693	1811	1	1	567	192959568702	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZW75xq58t9ivcFz8y1rRxz8ds4RXtCqAzoUPZFPZY4EuC7wQcX
11946	payment	1397	1397	1678	1	1	6539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGddi9wny9ofNvQnhFaMHMmtrQP4qdMR5NveGF3X2szHL3kEYd
11947	payment	1693	1693	499	1	1	568	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaLTuDKAPwVk8vcSbDJGoJHB56RXYWQWCkUry3tHzZvkJmokLE1
11948	payment	1693	1693	1772	1	1	569	504462958661	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYiRs2Tycp8srBiqp1GtcoC16aUpFLTpW2wqboFbQi66HQFxcC3
11949	payment	1693	1693	54	1	1	570	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYk75kyLRhDqoYvz2yL5JgEz4oydEh5qCxye2kdVct8kizSkaAf
11950	payment	1693	1693	710	1	1	571	5342683655	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZTPDpQ2zeGbTTVqgnfSjEc1cbLWWsnWD2vY7GJGYbxneiagUQZ
11951	payment	1693	1693	320	1	1	572	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZhHAURG7damHJfxSq8DoTbM6nriXnWQJ3jRKkuHPYjeuDCak3X
11952	payment	1693	1693	1030	1	1	573	962634758425	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZMP3i1TMQdRMnBsQjFAr1oevAGkW725rcCP6f2fUbsdJf8HFnB
11953	payment	1693	1693	663	1	1	574	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZkEmg5FX8akWP3xYdii3SRxgoFvhxFWpPeUUxjnjBTzP6qDtMT
11954	payment	1693	1693	35	1	1	575	20515905255	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYYcAwqwsCWV96J8NV4g3sNaavJdeb63shSABPUyY1svDCVqsxu
11955	payment	1693	1693	49	1	1	576	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZo1pZAKm6bTiAKxjTNWYDRdVFWhyWkZuK4snyaAV5LtfUKCA9Z
11956	payment	1726	1726	1874	1	1	3502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuUv7ey8fwVmPLwEZzrxCGoXviNxaq42eVAGsks3ZKYCVbNSS
11957	payment	1726	1726	1874	1	1	3503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevuU1Dp4WR2XMZs7nND9AiquEbR1v6jiwcv16AaqAANwB8auW
12023	payment	1397	1397	1678	1	1	6548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9uR1xeyqjiwVLRTJf7zwiaRcvmAy7tStXUbPC1N4jSGnhhzL
12024	payment	1693	1693	678	1	1	625	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZS4GX6vENodTXZfmqfaPiTUKPY3k5hcnVPKp5xJMtmP9D6jf5C
12025	payment	1693	1693	392	1	1	626	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZJPteb7ycQpzQt6eHhaGU4skR9Ax92H9z1h51VfVxM6YBaocvg
12026	payment	1693	1693	89	1	1	627	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZzwhayxXjiW7o2nBiMzkJ9Q4wvvMeD3KK2TdtPPqUDht2TxwaG
12027	payment	1693	1693	186	1	1	628	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZqNG2TbspkLX4nQXJbordKiP4KB3ejU3w7eEypyBb7hAmiH5WZ
12028	payment	1397	1397	1678	1	1	6549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vd2ui1iwnP6Viwyxk5YV6P5RS6aDKYdDn9BdSdAxt1XTnj9j
12029	payment	1397	1397	1678	1	1	6550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYzCLAhTk9xaggDZoTbeybJQMGrRShM8n7zNs4bV75fYHP1xC
12030	payment	1397	1397	1678	1	1	6551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVi4X972CZrsQ3gpghr7Gb1LbU4mrTAQMrTBM3SQYohDGDUV1
12031	payment	1693	1693	339	1	1	629	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaCCXiGjHUCQzV4ymjrS5AD3WMCgM5VPdCxTk7SbkH7nb2HBTnX
12032	payment	1693	1693	383	1	1	630	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaBz16ALLBER5H2HiiBXZz7A95GhBd6Lf99DXhz5eQXDfooQF9v
12033	payment	1693	1693	408	1	1	631	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZthniUpo6H9SF9DxCfkxs5dKZvhsKJxytd2veZhaU4biETX62L
12034	payment	1693	1693	745	1	1	632	2137073459	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYW7Cd5PsPkCznBudttmbEYa9FYgjC3vcTYVHoqrAG4h69nd4pL
12035	payment	1693	1693	593	1	1	633	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZwXA264rm39mtJhSuNVGG36MwmvRxqEsouKF7wZkM9aXYn7ZTf
12036	payment	1693	1693	91	1	1	634	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYxwc88ehKMp8cGmGfxYnX6HDvdqCfjFZUYTWj4mhnz1zoEg3WY
12037	payment	1693	1693	438	1	1	635	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYbLsTsk7QgFRMTqHf4MpUnkE9mUyPk2k9EK41pwMcsHYCBK74E
11883	payment	1397	1397	1678	1	1	6510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9NhwThCen4rGdiLfBQ5mZEpnLS5jAJZPVi3uYgj6ozr5sHdY
11884	payment	1726	1726	1874	1	1	3473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8EiSi6rxonnFAoFjivwFKh6vb1QUVEkddNPrzVhr3GBprZqL
11891	payment	1397	1397	1678	1	1	6514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqfCxNSo3uCtuJ4reeYr1fL6puuBTCAXgPu1L4Jf5EpX3N32F
11892	payment	1726	1726	1874	1	1	3477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPcAsChXNMVcxTRmfJHcnYbDaSsK3qY6EEHYfuaiLUUNpfPhd
11897	payment	1726	1726	1874	1	1	3480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUFtaYB7krN3PjScoL41aEKLQ9DT25iWKq6ydSG5NWiejcSUg
11898	payment	1397	1397	1678	1	1	6517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DG8Ne2dbVbZL5d5fEEEks6sKAJzzwyUVsoCG6E4jArB5Bw55
11911	payment	1397	1397	1678	1	1	6523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsUv368xZ7cdtTKzvFojpURZhw4yt4tarabFy3smWQ2xn9jxz
11912	payment	1397	1397	1678	1	1	6524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUV1nPi22WHznwnrZu8akoLwxQErurKGsbgk4vyoJWbyAgKbM
11913	payment	1397	1397	1678	1	1	6525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhJmfgGnhgjTis2XhcjCDvTX2UJohEr3RUdT4XTZTD2i583pf
11914	payment	1726	1726	1874	1	1	3488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EKXHMmHJ4vaoYFWachPDV3R5XNZ32ZnggH2nTf2C8Sc8NT1p
11915	payment	1726	1726	1874	1	1	3489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgf4WqivBPb1zvcRqcWx2ACH5BXCeBUgxv7Qo4jZS4QiiHmBm
11916	payment	1726	1726	1874	1	1	3490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2PhuXRn2BuHC3YVKHpmHtPsEY5brTz68RNyHPLB8cvtnCD4D
11919	payment	1397	1397	1678	1	1	6527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWrdQqsNsMKYmuqWaMKkmLQrfF7ZoiCeaBgdWs6f8WhMkHtNP
11920	payment	1397	1397	1678	1	1	6528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSkf8h82ucmfDnZW8w9ExPV2Y8kvVuKFq7Yseq51TaNMRbtxY
11921	payment	1726	1726	1874	1	1	3492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqCnHaJDqbyMGgQEcTfBQHSr5YByVMqRY1ewRU41UgcyH39wPD
11928	payment	1397	1397	1678	1	1	6532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61nxrPyLDXSAi1RimkMzZr5qj653Guokj6HN7QaxK4DExTC9v
11929	payment	1726	1726	1874	1	1	3496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxBQeB53sWH3fRGJ9Xde1xsf39davPAhgTCySq3NWe95Z9zVt
11938	payment	1693	1693	122	1	1	563	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYsmq3AvCgUZztV3ac7CYcZz3oUtntwvWFjj6wAFj6NQWJLNCzY
11939	payment	1693	1693	721	1	1	564	2137073459	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZDeP66pd8fw4KmagkhzkAcThCZP5tTR73VcRvqhFQ6MLmtbtfc
11940	payment	1397	1397	1678	1	1	6537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRjWx6v2vdaYQziqzxMCzgdvhuK7NWQNcfK8s9zzhzdrtpe6M
11941	payment	1693	1693	217	1	1	565	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa22XSAigVN9abZmBAJqqN9xkDiqK5bYt5TGimdXyxJRxTHcFFp
11942	payment	1726	1726	1874	1	1	3501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrMpgCExFSMLpY6381xY6FPkKMgWek9KxvbgS9gkeFdV9n3t5J
11965	payment	1397	1397	1678	1	1	6541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yvce2cN7L4eJ4PWDk5C1ABNZMY7fz4gHfzrBJtowceziXJ1W
11966	payment	1693	1693	108	1	1	582	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZsxBY96PPkF73dSGZDmo1pf2XZCNjx952ZsvBHY3RxPwSWZYwg
11967	payment	1693	1693	894	1	1	583	327851556730	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYzndxQV9CXYgYDwcbmT1tg7ike396tmW2fDS5YSrZax4zCj1Uq
11968	payment	1693	1693	569	1	1	584	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZGih8EYVKW29uVJSuteouLzgYDSroU2dWnu4yfkBoc3MCJQH8Q
11969	payment	1693	1693	252	1	1	585	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ174TdkmjjkJpscvNCto6P7quFgeX2NiMvpoZ51UyyrMSo4Dgr
11970	payment	1693	1693	225	1	1	586	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYumyVBhh9qkxn1SJp1Mq6N1Bv3N7XnN838cT7SbwgcJ4D84dUe
11971	payment	1693	1693	377	1	1	587	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYQe7ZsEKEyvJFKF4QTxT9znEwCjWZ6iD6V5vZhvDy5jwFy6Dc4
11972	payment	1726	1726	1874	1	1	3505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFxfqGgLkn7mF7xEQjvq8TYx8NLur5BiEusSVVwkWDWruHanN
12066	payment	1693	1693	194	1	1	658	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYhgzVDzsvHBELiiGeHQt1tsjMukQdvGW5uUdU768LVrNoYyMQj
12067	payment	1693	1693	1276	1	1	659	1809914170990	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ6H2kMsHjd8sL5WfhjMKwgxUmZb4zqM1wag7S9L2v8bYf2bgiV
12068	payment	1693	1693	206	1	1	660	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYxKHtuxdd8CyWnUnHfSHLV9CTWKmaPfR6w2pwdXd6dQcGqBMhc
12069	payment	1693	1693	304	1	1	661	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZpah7qPW7TgiRWDZ7LYtanAKB1WPkeVHv9hMvoGJSsee8YwEHa
12070	payment	1693	1693	399	1	1	662	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYiG9RyDyz5UB1hWpbiTM84tdnW5xAm8ufzW9ji78t2NF8baBJ8
12071	payment	1693	1693	653	1	1	663	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZo2dGkHgTkEkYvLgDQ5R6ShwXGmd2SwR8Ms6VeapYt16dtBUBv
12072	payment	1397	1397	1678	1	1	6553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeaaA4iMSEdJ9zXAp6qygXhcs6TRCc7XmS89fwwATXFUvHx29
12073	payment	1726	1726	1874	1	1	3518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq87pXSpvVJiWmVVeemHWiKFaGb9322Mc7TYyb9Vcvf8eTTS1T
11885	payment	1726	1726	1874	1	1	3474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxaUXWXfkKjsJQaEBznnic3CLVNixywk9ic3rMNWtBhFGBzEbV
11886	payment	1397	1397	1678	1	1	6511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkUFhMdf6hRhrdqk5a1tsTXLoDeDvGpQyMgVnZtPomnDGYBJj
11893	payment	1726	1726	1874	1	1	3478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBqBnUwXZ2w7mmR761kTtH5yNwFEmPrgRDJJGwJCxCt8eLwLGM
11894	payment	1726	1726	1874	1	1	3479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbBr1SuGwG412euoVntG2JZGXDNUHp9LKVNmHReX5YRw5zWba
11895	payment	1397	1397	1678	1	1	6515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV4CmmqDhavQL1XTEejiR64EZZ3h2u3oVU3Ffq4Yu6Qn3ts8x
11896	payment	1397	1397	1678	1	1	6516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkcUSFjThULmEr3pMvVqK7eejz6SzmUp1rLyE3t4AGpUZw3SC
11906	payment	1397	1397	1678	1	1	6521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaTAeaAp9vBmaHCofguyZ4Zd1smCukjLk32LWHrk84JbvvkZq
11907	payment	1397	1397	1678	1	1	6522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kcVkfXgWS4ZhqaXDXUVJ2BtCn1RQyEFCqSKaKiZFXpCV5MSB
11908	payment	1726	1726	1874	1	1	3485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2B4wQBA2pGkwrUgfkUAHkWHTgMQNknvfFy4q6Ve9LePGqNwZ
11909	payment	1726	1726	1874	1	1	3486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSjAgv6DVufKRsRTwTtgyb4UMPnbkUSy81ytpv2WjEJ4mzaxe
11910	payment	1726	1726	1874	1	1	3487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabC6YCqobm8MSXGWnKpYxcaRfFPhjfETMYc7xjZ6j6Dtz8j7J
11917	payment	1397	1397	1678	1	1	6526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvrDGCQLL5TFmtALa6h2csAUkUoMHDbUA5kCnUA5AzHwwy9rV
11918	payment	1726	1726	1874	1	1	3491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZiram8zGScYLL5f1s8866yeRxmUhqboGzHCXtT8M6ZBLbz34
11922	payment	1397	1397	1678	1	1	6529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6REf6pawfBMcUA6MWGRQX8wbeL5ttHKaRt8cAGWvzDjJUsSAC
11923	payment	1397	1397	1678	1	1	6530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaUKn7Bzt8UzaJpugiePLLxyKM93hMpxh6XsyRPiCASFwPBf5
11924	payment	1397	1397	1678	1	1	6531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6rBqp2MJowm2LpXKjJaE5Dh5p1eN71N631aAdiMcpWF2jneb
11925	payment	1726	1726	1874	1	1	3493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcghCebzKyeJTYBcEbb2VXwoEpXbQuZo4ej9SzxhqBC8PAH8Ay
11926	payment	1726	1726	1874	1	1	3494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYuZYUZQ1Uf9PTnPD5b5QWWKK37X7x6ePrTGzpph3GfLpiBRj
11927	payment	1726	1726	1874	1	1	3495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmW5ZzB7UyS5TdNYtP41bTc1baQ4UvmWffL2vAEkbF4MGccPCW
11930	payment	1397	1397	1678	1	1	6533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8vGAyFqqDqNLq9AzZ67BA2try2QBcxP38yupUEWB3RSXuN5T
11931	payment	1397	1397	1678	1	1	6534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8pj9Tu5aVpFceHwHL6qCDawsrVbiUv3XaVXbiDbNjqUURJN9
11932	payment	1726	1726	1874	1	1	3497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkP8v6JtqUpNWeKHEEidYYY2qjpRMztpDfPts15MLK17XJ466d
11933	payment	1726	1726	1874	1	1	3498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sdjDJQh6LJiQ92XDcenYTB4hVRUi8a5o3sdsGZeSGHE7Y4Fd
11973	payment	1397	1397	1678	1	1	6542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJMHBihUKXS6ouwyWuwrrgf26rYY4dMkENhBtXN1iUQ2NfVAs
11974	payment	1693	1693	82	1	1	588	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa1UTjuaTDzMBTmZK86ZdSy9aQJxas9wpDCpb3mcZBEpN8upUY8
11975	payment	1693	1693	361	1	1	589	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaKnB21mvw3sFyJMqd9NWaDb44HsYAuzjLJftHwwti9tZ7KmyRY
11976	payment	1693	1693	560	1	1	590	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYjufnUQAoJqyoM5gbyiUb53nxEXnQeWnfHnhxA1bTZxkJFjYJf
11977	payment	1693	1693	309	1	1	591	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYdMHCU39oRr3NuHkfSzKx6kzdNYox2je8kZ3Y3japjNW3uZ31n
11978	payment	1693	1693	1962	1	1	592	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZAz3X2NLE98unsDsBBuxebieqpecPa3Mp26ckQKbL9Nt42oG9S
11979	payment	1693	1693	201	1	1	593	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZS4u679UVqWAbi6owTHTqh3m2zFNGnV7ewzJyFejgkoBXbuyGk
11980	payment	1726	1726	1874	1	1	3506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwHKrX7omi1JJLPpQ7iqhhh1gQaUTVxL6phPWzHdzW1w7eEx6
12005	payment	1693	1693	191	1	1	612	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYkf1r859ePZCbQN5nk5h8X3AXdgWsxmCmNSqzzDaotNCBEo73k
12006	payment	1693	1693	266	1	1	613	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYwECQXUMckoUtNdRi8UEuj7P9uVgiBpTKyf93TfqBvUEFfHvXS
12007	payment	1693	1693	534	1	1	614	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYTsCb9hwGXcNZsnxM8dEGsvF3hzJCkwsgSUXNs5bJMMGuQuWP5
12008	payment	1693	1693	245	1	1	615	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ2aQkyitJdn5jBjcvKxySmquMojv8HqSnpUJ8zVWCqoFwMGDWR
12009	payment	1693	1693	421	1	1	616	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZbA1NExe6m6zXTPta8gMuLcVko4qTXrU4p2nUXXfYQaXW7ULxb
12010	payment	1693	1693	600	1	1	617	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYSMXRAtUpgSZ2wNonWUu9tFvy2Ejp9WwZ4nSuEzyFE8X88Uppm
12011	payment	1726	1726	1874	1	1	3510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8TqGuZqygt9gyQXbyjziCepREzhC6cjcXWhfjNCMGLcGCRX8
11988	payment	1693	1693	594	1	1	601	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYkuoqVk2qBSFxk2kGbYhgCUqx8EPv4eG22ZVKGahkfaKc32YRL
11989	payment	1693	1693	680	1	1	602	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZajsyDrWs1yhHY7ppXSj9d72DYSAXjnSzDZKX9AnorxpV5UANe
11990	payment	1693	1693	690	1	1	603	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZm6xXiBtAjHMuazQaKPbVWSWdWdWM6YQ2bZcKzjVFuG3Mf4puZ
11991	payment	1693	1693	731	1	1	604	2137073459	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZb2diQZqBnsM5eThzvwYHoJCJsHe2i1qjwLr3Cf7KCWrLrVR4o
11992	payment	1693	1693	180	1	1	605	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZPqtEm5x5oZcqZpQN8Dy6f24RSyqtExDRTLxHV2mmbVPghF1t8
11993	payment	1693	1693	112	1	1	606	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZh86fqDppFHSKF7iuA1HEDxcgUNrcyYgfJSEiEDFAhtqw94rRr
11994	payment	1693	1693	353	1	1	607	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYUKTe4U59bKpGqaL7uzaoFjSHAPcbsVF6aqTjyzvf5rGhLD299
11995	payment	1693	1693	652	1	1	608	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaCDZJqJTmzPMKAaQpNzKgbjp57aPFCwKqhJCvetRcXasxeAVmu
11996	payment	1693	1693	420	1	1	609	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYbA54iEBcRjT2Z5opjJuqLYWfxYfwzy5Th5Kv7jZM1dp6BXyoN
11997	payment	1693	1693	352	1	1	610	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa66C5cbc3hu1eT9FwcZUU121wVZL9mwrvqfR7dXrtT4sqMzQKL
11998	payment	1693	1693	691	1	1	611	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZYm5nXMdfVmtVVvZxcocZDcRLLLJKq99E6FWE1nMbVhEVt5RaU
11999	payment	1397	1397	1678	1	1	6543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1BsHoSptQdsJZgipRNEUGyPHexdLydTWPE2YiErG7b5iYh8b
12000	payment	1397	1397	1678	1	1	6544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2AbuxNDa74LQ6GHnu3A5nkGnpoB5WCyurwujM3nHjSKKEgAgy
12001	payment	1397	1397	1678	1	1	6545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu3Bz8ZweySUpsKJfSQ6yNWBJGj47bxz9X6Q1uN9kSn3eXNEW
12002	payment	1726	1726	1874	1	1	3507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfyw1DiqBLxdG5zdtikEMr61eVLU5NN31GvxzNuPdoujQDMTn
12003	payment	1726	1726	1874	1	1	3508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUNT8TCydEewhseJvzP56JCXjHp156oBTV3tULeXz8GroQRDc
12004	payment	1726	1726	1874	1	1	3509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF71WMsGzQP1EhzR8oG7RkmLsPBwCqPEZZV8LgqV2xoVnpb5aU
12022	payment	1693	1693	308	1	1	624	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaJkjQGHHnKpsN6phFanWGvaNySdsTkgjcTLEkdW2Fi84uM3x5s
12059	payment	1397	1397	1678	1	1	6552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwGZhBkQ69XVBsMHDCcdnAQG44U1NWNtbr4AuNvFgmM6yf6ki
12060	payment	1693	1693	611	1	1	653	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ8LrwUYdVco68Y497ZW11qPBRpCUsYvgwk5tQ8zMj21qdmzyLX
12061	payment	1693	1693	1961	1	1	654	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZXTPZAg7QvbEZHguQKGqCF5mwgF98XjqjbaRgwzTCEGFRXXMod
12062	payment	1693	1693	504	1	1	655	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYXkmWQoRgFYru5ofUzKaZKbUkEsnNH2WV31Jgf7fT4ezJNCcGC
12063	payment	1693	1693	658	1	1	656	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZBkcYnLiEdaG9zhmZTLEbBuNdwdXhYJyu3L8ZGduYRcZdiGXcj
12064	payment	1693	1693	660	1	1	657	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZgmJZECmKKYBJWJJjhohb6Pw51CEWnriBbc5mLfMk17JYnRmfy
12065	payment	1726	1726	1874	1	1	3517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5brxjHWW25eUNDx6KyDjgSkboHt8KxnZjsbByQp1XoR22a5J
12074	payment	1397	1397	1678	1	1	6554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbQjW9ScBnRiSyEcmtP4CGg7sfszxvpWryryyfPeuF3pMHm4H
12075	payment	1726	1726	1874	1	1	3519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtSk6QDm8DnAW8tt37xkhF4ucaPcRXj34hnUCxYxUB9i2CTSS
12085	payment	1397	1397	1678	1	1	6557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1L92J7vhBgQUaSQiH5WsX5ippGTJN18LWNsNGuBBfKZWMzcNd
12086	payment	1726	1726	1874	1	1	3523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkrZ4bxdqr1mWp6Emk4BAjwQi7FaPAG18eewzp64s7jDDjebf
12091	payment	1397	1397	1678	1	1	6559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkKFMK6dwjyYgMZshAeCi2LNgqkFSXjpc13RUVZa5F3ckrEs3
12092	payment	1726	1726	1874	1	1	3525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNJGsdtrEbpVFFZpftkBMfUtbtYATj8bkSFYceEMrJKXAd89X
12124	payment	1397	1397	1678	1	1	6576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJ6YWzrew8GVdFHdqpnBe2bvYwz1uqh4xZ22CToz7xXz8XWqs
12125	payment	1726	1726	1874	1	1	3541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTLmQXQZ7SbfJisz3NTP4KU76euYbmE4HsnSu6EJXYQaz3wu9
12128	payment	1397	1397	1678	1	1	6578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WQiX14C1aJFvwRjiCmr7vTTqWdrqBqcWKmNq3YpHgsACm8Eb
12129	payment	1726	1726	1874	1	1	3543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PNuVMohZU2qTH68BFsmoeJNkc9kxUGxPW2NLuMC9Draq6avq
12130	payment	1397	1397	1678	1	1	6579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgKepc9TaLR5Ybd9s3PSEPKEbSGSDH3hma1s15p7vGWDuewMK
12137	payment	1397	1397	1678	1	1	6583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCZB4LZfTutgFGKWnY43QVmkRYCrY7vs5HaE99UJ5a1LEfW2J
12138	payment	1726	1726	1874	1	1	3547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqhDBa6KAGMV3nUTooTNyiDAtzVG53gBBJyKkcTnW7UjSBaAA
12012	payment	1397	1397	1678	1	1	6546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK2y9GL5CzmwJ88qSN2bQ1jgjQ3TMnnMT8hL6Zd5bQUniNquZq
12013	payment	1397	1397	1678	1	1	6547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUV2ViWKgp4qg3JEw9qKcbaoeeJej4nmRZ3TLoqkJMCuhMBG3
12014	payment	1693	1693	620	1	1	618	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa56auBubeeHo4LT37RG1NESQbm4PmFUTJFAcSC2ZsPp3DHLEg8
12015	payment	1693	1693	2017	1	1	619	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZQrta7wiWWbYG3qJ1YMrMAdAnAMr6hyByBR1JLow3drwSfFTEj
12016	payment	1693	1693	551	1	1	620	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYXTDtVY8RdYM7hRUcHz55xNMKPRcmRZBZJjrJZm6K4Y4GVsi76
12017	payment	1693	1693	520	1	1	621	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaELjFJoHRZCyFZPwZWEaUnmHM2fvjZhQKXYgTi3u6nEo187wF2
12018	payment	1693	1693	84	1	1	622	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYTx7ZP6LFji5vGcpT1WNx6fqbVYMJqhEDaqTBSBLwaXD4sb8Dd
12019	payment	1693	1693	1150	1	1	623	649508853363	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYijTkksqmiKTSiaBLpehGWFfeezn8hHGqmR4b4kqGKBzwc96yh
12020	payment	1726	1726	1874	1	1	3511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTLUAw189WPgXDnhNrA44svXF9K9hF4naEKTZoHFRSCkqEBhk
12021	payment	1726	1726	1874	1	1	3512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNGLNambkUTb6ehhQpSUueoWdssbwHS9NRhnmRHQGeECAUM1p
12095	payment	1397	1397	1678	1	1	6561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KzkLqEFS4erAnPTwJhqB55ikYhuDaE7SBzKrDVni8CBDBPHA
12096	payment	1726	1726	1874	1	1	3527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78Uhu3gTKRFfiH4USJ7Wp4MbZSWipWES7io6CuJ5fh2ECRGvf
12109	payment	1397	1397	1678	1	1	6568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJaRBJgJrxSaTbTMURteLFTYsMuviu2mjigC9anVCT6uxmrr2
12110	payment	1726	1726	1874	1	1	3534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWQesgRVwgDKPhqWuHn71Ex3SJJ4D9UwFbNtCiZRbvTK7tx48
12111	payment	1397	1397	1678	1	1	6569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTdaxrFaCVTM7be55G44ekYBDnJzVsDBN4qeDt7LP4AfHKsEQ
12117	payment	1397	1397	1678	1	1	6572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAoqj36aVek5Yd36mFUB1x6MCqVTPVWy1EGA3bFPtBMZFfM2SE
12119	payment	1397	1397	1678	1	1	6573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUevsnth75AYcuEvCCr8ZMRZ812hGezip8yqsRGXvKSCXmD7a4
12120	payment	1397	1397	1678	1	1	6574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5GweT6nYwhZYpcEfM5AaBYmtEviG2G65d3zBtCqEBJazonxp
12121	payment	1726	1726	1874	1	1	3539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJSZXuzEQQuD2z8jxiTHjDqfc6g8eWuu4AyNs7yJHBxCfPSVB
12122	payment	1397	1397	1678	1	1	6575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JRfMwHq8R6LwDegr9i3bVMrqCWePSHcvpH9etmro77nETobm
12123	payment	1726	1726	1874	1	1	3540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDF6rZanKp82AHh1S6yZcJBAPRNL2h75AbCaiicFXsMhpFERu
12131	payment	1397	1397	1678	1	1	6580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8r5d9SzvqHxHZkBkjLGC28NJXPyMFtg1m4LXry4es1Xk4uGPz
12132	payment	1726	1726	1874	1	1	3544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHduy3WGHSRhX6wmezb8H2nuSPAnGy5XBRc7ZC1ZrgJkuoghv
12133	payment	1397	1397	1678	1	1	6581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiq6weCaDArcMYkUt83rNvxv3GK5bAN3e1BLvjQmgQENzjuuT
12134	payment	1726	1726	1874	1	1	3545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQR8digw8LbrY7hWeMxJdyPZJcMvRjqemqHtncjt1Gk4M1Bz3
12150	payment	1397	1397	1678	1	1	6589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LPGZkNBpVphejn3Rh7qAcuCQimd2N6AMDzSjMznWV6DXTmvg
12151	payment	1726	1726	1874	1	1	3553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXE9ErswiANLGsbKA3jQbsjckaNBZZuzi8QG4u4MSgMHzp7scR
12170	payment	1397	1397	1678	1	1	6599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeN8Vsh4unq1kQYwnggNiosoxZtU2dgFBqzFRh3r3xe8Hz7z3M
12171	payment	1397	1397	1678	1	1	6600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GbsstcLQqi7Gfcw5Fy4z7Yh6mC8drh4mdTAtqshkDVZrmsUv
12172	payment	1726	1726	1874	1	1	3563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTR8HGMHcwtYVEoj7LsqQT9fXjLoKj7zWmgh5ihWUaJ41jt4Tv
12173	payment	1726	1726	1874	1	1	3564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yw1iyw4uz3cnhPRQq42Gri6ej4Qn2LFimPLMXDobv26GhynR
12174	payment	1397	1397	1678	1	1	6601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5R7Cvt8t13aGwpY9gEb8mogtnVujAfULsWU5a6ttUeb5J7fW
12175	payment	1726	1726	1874	1	1	3565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4k7ZFNT2KZz2TPxydccyUpFz2JEytZMnnZBhfF86t5CBtmRuT
12210	payment	1397	1397	1678	1	1	6619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLPCe4SWKGzaUVBaDyBnrnZnWDcJPNu94ZJ9LFX2CNBq9w8g7
12211	payment	1726	1726	1874	1	1	3583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kss9jjoBQdxbLZFhvzGV7G8mDPjuizDHp4sCR2z4sPYbfHf4
12218	payment	1397	1397	1678	1	1	6623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLProaYZLkbX9Lh9HXoa9PVkvXgzG31FyQtV3Pd6E2R8YmL4p
12219	payment	1726	1726	1874	1	1	3587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3761EtcRQ8H5ufWJA8pqXdookJnCUXPCVooYC2P9BeK3F2g5
12228	payment	1397	1397	1678	1	1	6628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxKb9iZ9MfNdcppUihCYgMAoR9yS7ySKDXU2P7QfVJtXKfrNG
12038	payment	1693	1693	450	1	1	636	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYpKTiigpVDLGvmykiibdwexARMvyGenmEUrrasWNwPPgYggU77
12039	payment	1693	1693	322	1	1	637	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZaYKQa3Va6kCHeBTCtD3rYL3LeiKgbvzzQZfSmQhLaL3awtcKE
12040	payment	1693	1693	373	1	1	638	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZRk7tR58YCgy5r7zr6oKhLVA26rc7WM5pcsAPZqgPQmnjtRsEk
12041	payment	1693	1693	150	1	1	639	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpaGgCm1GHvztJeToLua8n6oiTN2g1cj5W2Hs1UDo7x4PS23pL7H
12042	payment	1693	1693	92	1	1	640	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZpzH6zV84ZKmFkzECSkSfqkzbeK4Nciwbmp4nQbFPUuXSAqvrW
12043	payment	1693	1693	453	1	1	641	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYU4k5LBVGvUQHbxRdsqvy36UECH7sTh9EPahogjNQohjgf9A7j
12044	payment	1693	1693	63	1	1	642	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZLokka6GaJPji7sTj1eHBTRara9T4Rz5spwRaP52SszMhCCzZs
12045	payment	1693	1693	146	1	1	643	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZSDUZnBd1Rp7NEXET3RpCp1eNDFFpDDvkn6jq2q2wWQ6bCzWXW
12046	payment	1693	1693	601	1	1	644	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYTUeMjNsXXwBUGGPEMYjh5Rd7K4jECCyh7CnznDkJhF1mHD3LY
12047	payment	1693	1693	587	1	1	645	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZAxDHU5hGA5om5fTEQKk2hJ8xk7ofA7W4k87V4eH48Avfv1DZ4
12048	payment	1693	1693	910	1	1	646	537187143427	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa6pj3WSkJu13wb83YMT5QBn7W3nBhm8XRHXzv3iNRobwQdaANG
12049	payment	1693	1693	500	1	1	647	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	Ckpa9XxqEkn9WL5MidWEHb4fybfTL9DsheZHHWUJQyJtBi4w8jAbw
12050	payment	1693	1693	29	1	1	648	7479757120	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZxbNBnh7o6gus1tNvUCNYgkxaDB4NV2AW3pJndMCgHDGiA9MWJ
12051	payment	1693	1693	138	1	1	649	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYQvtHN4zRz5JYZ59wrzm2mgxna5eimKUDsVDVus9oecrhD3tGM
12052	payment	1693	1693	78	1	1	650	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZEMXmXTHuthHHWqXE8uayCnWhiWcsUx8RhJv3KtdQsRPkJrNhF
12053	payment	1693	1693	395	1	1	651	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpYb64taU7S1eBCeyzCSp3ZR6Fhfoieu6qu2eohcPxQxwWo1TVYC
12054	payment	1693	1693	205	1	1	652	70523424329	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNnorhZBTfGgrM4nh7g1Kqj	CkpZ3BDcPnCGTvdc8FgmHTy4hZUnUP8EyDU2v9WUdZtqkBbP1Zr7j
12055	payment	1726	1726	1874	1	1	3513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZPHVytiNWwvFiuQT9sL6dRbojpojzd5UACC4a6UnkbEwjeez
12056	payment	1726	1726	1874	1	1	3514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXhedfSVVXcwsntCk7F3drGNrSbXMfcMKhtrVDuv4Tr3Zjz1g
12057	payment	1726	1726	1874	1	1	3515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKw9VkpTz4zKsoLNoJgEr6Fi692VbuRPxSmc7SSPFEkacjt4Fq
12058	payment	1726	1726	1874	1	1	3516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXspkJKJn6c1jo2SKVnhoPutAhLURac2rjVwf3cRonbRR7HzBT
12076	payment	1726	1726	1874	1	1	3520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7YnBj6tCXWQDPJkXBGGYP3NLq9Se2d6bLtn9DZSGdgziXRgh
12093	payment	1397	1397	1678	1	1	6560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9TkTSCQEyDVxBCQzL8jJMD64QvCnoUsJhoebXCmEiuhx8Rog
12094	payment	1726	1726	1874	1	1	3526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvkBGYFukDg5McLfy5hVcRVGvYkRUnNgDZ1h5NBadRJDavLmx
12101	payment	1397	1397	1678	1	1	6564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CxkfGN8Fczk4maxZ9s7Kosmt14qUfHCHyb1hGnQsbmC5TXnm
12102	payment	1397	1397	1678	1	1	6565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgC4G7c3PvuqbGDS7SmJiUqDWpUKMjrx4JArdBPnNbVsfC83u
12103	payment	1726	1726	1874	1	1	3530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC6n9Vi9uHghTP8PHCdVoATnU9Z1VwC6hdJPTAvACgSGSwruME
12104	payment	1726	1726	1874	1	1	3531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLCm5x2JtEDAzDSFnAgXhBtYH19hdUiYGATSaM36wgqfqKPrm
12112	payment	1397	1397	1678	1	1	6570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAoZVDU7r8vumDRf5MuSEFaEgShjCUMoPiBT2ihrhBanzYAc2V
12113	payment	1726	1726	1874	1	1	3535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYssg4xerhei4YgkV3XaSRHwbUuSva8Tt4v4zbGEbY5twUiizkX
12114	payment	1397	1397	1678	1	1	6571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUh9LFyR7qxB7qDYFwuThCz4oTG2UHM3VXkr68iRmTjUfVW81m
12115	payment	1726	1726	1874	1	1	3536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyPCyqFASeyk6RHWd6BqHnwbh8rijiPFCf4JxusB29hEEvuas
12126	payment	1397	1397	1678	1	1	6577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SkHtXCsQzPNn2msHLTsXGcGgqvmFU1fN6YwLmARXA9PKPfGD
12127	payment	1726	1726	1874	1	1	3542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJFtudqo5isYGvhCMMNXpYEs56R3ScDqu929tGWg7keP1MyMM
12139	payment	1397	1397	1678	1	1	6584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUJtfiupQvLes9CEYZM63BBVMAZCmBomG9qijdoe1GFcAqfHv
12140	payment	1726	1726	1874	1	1	3548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXE9gKrFPUrU3zxcJ4iYjXoPaLqmJyD5qYDVMDUru7uirNfkoz
12146	payment	1397	1397	1678	1	1	6587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHonHF3zqCGJx2Srtdc1jxZDbpWdN5RVpBF9PBEggQP3XQs9bY
12147	payment	1397	1397	1678	1	1	6588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL7cgjoeYAYn7bKFSVoyWtqMxcoKdoMvTR9rgH85NDHfPqqrn
12077	payment	1397	1397	1678	1	1	6555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6awnfaugnR5jQbfYLgFrgDeRhV4VU2Lf7f7iGg8VhBXNP8www
12078	payment	1613	1613	1349	1	1	2	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSx5prKjM9UzQM5VQmfitt4vZsWN2PhXYwq9pe1qkY6eTCH7Dx
12079	payment	1397	1397	1678	1	1	6556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2pgcVhFCDSriwMCawpeMa84MC9ttcKjBTg6yXFdgZcw64eLK
12080	payment	1613	1613	1223	1	1	3	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3gJubDFwWHTbGeVSpcmkeWGWW58adxG6YoCnNot8JA18qaXQ
12081	payment	1613	1613	1103	1	1	4	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q5kvvHH29QF4h4N9AG7nVAnVrW9NykzSHd6McTBiwtmRB6Te
12082	payment	1613	1613	983	1	1	5	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Cgy4MQtdPsB2VfgAqsATPEPD21jYJ8p4kiiDTyANwxWZDtWo
12083	payment	1726	1726	1874	1	1	3521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZePtF7r7sanaenidxoMEPjY7QvhkJHdXLEPjhjU62USbMGi9DG
12084	payment	1726	1726	1874	1	1	3522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8CwrqFZ2BxTXQT69XsHU2LExLL3vjKS2oDHr1H8C8wJmnUEU
12087	payment	1693	1693	622	1	1	664	70523424329	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnUxEhGseJgqhNtjSNMEgsn	CkpYj5Qe8aj8fqM8P6BznNiwQptHv3vFxUdc8SrcRNVKor769mrzQ
12088	payment	1693	1693	105	1	1	665	70523424329	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnUxEhGseJgqhNtjSNMEgsn	CkpYtbe3ideCTRtz84SKEegQrfU7aZdniw5sJaVCWMxkhkXsqFrAN
12089	payment	1397	1397	1678	1	1	6558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgVxwvXRwapHjSWxcuZUChCuCd8NC7mgyeHnLANS6qKs121uJ
12090	payment	1726	1726	1874	1	1	3524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeGn5umRG9Qhfo97fHvtSA8ABcp6BBjBy52Y936nAbWCQPY68
12097	payment	1397	1397	1678	1	1	6562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMrGGx7fxnnyPQc9ivJZqtf6ezzvwqz4KjHNY54MxcNQ58eAjC
12098	payment	1726	1726	1874	1	1	3528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3dVFAAeX9t4E3zTSwAQEKmrLGj1reN6NrX5S21j5ZnW5kYLf
12099	payment	1397	1397	1678	1	1	6563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKbhMvScEVgFotxcKE65jgehU3kMWz6n4MDkc74jeK3cBiBpT
12100	payment	1726	1726	1874	1	1	3529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDFFWZqaogveSY5zDWrd7kmxMBzzgZiTBqeUXy9pog7suYgQ5
12105	payment	1397	1397	1678	1	1	6566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYMy5gJRxGQ9kGRADKmoymL67PzVdLGm1YdxwEtYD2X28dK6p
12106	payment	1397	1397	1678	1	1	6567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniGmiSx6M7QsY3RDJH1kxtS4MkGJLGG3CSuu8b3RSz184AmEa
12107	payment	1726	1726	1874	1	1	3532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEo5VtE2cDT5M351Zf7kbE6WUMJXfTRnuAVGR7uU53BYq5iZ21
12108	payment	1726	1726	1874	1	1	3533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVEHUXMagTu8mHzpQFLHpS4C4qtbbJK2Daiir57A66hAUvuyP
12116	payment	1726	1726	1874	1	1	3537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjyEhnJR1UN7vK27F1KuMnR3uFdNR2uFdgXB2QiLoRLyDYT5w
12118	payment	1726	1726	1874	1	1	3538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLL9wTvYBCL8ZRo1qcmGCx7kSgYmaVLgPvpNQVsboGW8tiEvT
12135	payment	1397	1397	1678	1	1	6582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmefzWnUZ65GRTomWXrhffWMu3izV1EhVijh11RmH8s7nDfzBH
12136	payment	1726	1726	1874	1	1	3546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWRLcaTfmC4m5yHrgAKBooeppXdMwDroHUz6PNuhFmFZGoa1C
12168	payment	1397	1397	1678	1	1	6598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTQ88B37ZqxoiMASTrpa7kHEfK6hY8i4C1W7HfCjJr9ZG5Li5
12169	payment	1726	1726	1874	1	1	3562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJLe4v9LBpMXpmNyro9paiLnw5mUBjNVpKtrBtSLbcyAruBEw
12182	payment	1397	1397	1678	1	1	6605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJ9yGiMNAnts7wioGQfie2wraARJgkxFrrGBJZmporqbTUNmD
12183	payment	1397	1397	1678	1	1	6606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2E66padk6sjAeyA5hwGU8bZonbNudv8XYPxaKi42GURGRn2Dm
12184	payment	1397	1397	1678	1	1	6607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkciA5UkxQDBS1HmsaY29vFW6EqLLve6vtvaBaX65JJBEm5ukJ
12185	payment	1397	1397	1678	1	1	6608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQjPJzVm8gbjNegF6Vrwzr6DeYNYxhBdPxurMJ4DnQrq66E5R
12186	payment	1397	1397	1678	1	1	6609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhJtCB87QQDf5SJF4pwdyn2ZXUPeoLmBDkQ7wdTBoJ73KhUab
12187	payment	1726	1726	1874	1	1	3569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qzdiXcBytGp7HyYbDyTfLoHhyQKe73NKvWb9a1BivFFYgqCH
12188	payment	1726	1726	1874	1	1	3570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8txxhK8G6D7deSjykx6mcdWnp53gWQugVeX5Rpi397DfN27u
12189	payment	1726	1726	1874	1	1	3571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeB8C9qjM5zR6zAnwwbczk12v6xbmNsG7pwVWn5d6aiYGbBx3
12190	payment	1726	1726	1874	1	1	3572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQeHChyBBSQQMpacPkDMfZysgGtXPk5yxBq44eyLkcq9jmiZb
12191	payment	1726	1726	1874	1	1	3573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSBunpj8suSwUENBz7cAGjRbWjx3kSaThqZ4Ubwu9s6mDSgFCL
12192	payment	1397	1397	1678	1	1	6610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3aB9WXA5Q4nZBQ2vYA44GkHWJZSg5PEzWwrLBf5UMGEbfCJS
12193	payment	1726	1726	1874	1	1	3574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9f2KS7xrPfoHrVih8hFrqMAm1ajJrjQnXwyvtLULZbvotL3TD
12141	payment	1397	1397	1678	1	1	6585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYRRBB4E5d8KWokjxtEbY2YE2stBUmHEt8AGPmFEgunq8G8wP
12142	payment	1397	1397	1678	1	1	6586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJXgicATTcVFXJgpDce1qq5g76gqor75RtYvTzjFkgbijWzkh
12143	payment	1775	1775	2047	1	1	5	1000000	1000000	65535	E4YrvzrFbtDw4bc1ZWr274D1kVZ5JUvRrqYzmttAqXYHeWGZZTrYJ	CkpZSpVL8yNVPhRhHBSGPZT9SfUyCb8ZY5nx8AXsyHNse8V23gYcC
12144	payment	1726	1726	1874	1	1	3549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EHe7GhRo1B1vs7eYEtZP1ctUqY2cR4YdHpP8VpaaH1QUXd3v
12145	payment	1726	1726	1874	1	1	3550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJW8mfXC8WQWwwbVtM8qpejeoZ7gzxfjuu7kFqzG8f67nUSVU
12152	payment	1397	1397	1678	1	1	6590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZh4X8BxPSYYgPoTZRvnmevnncNKJBdXRLsxx6eCYsipKg4gH
12153	payment	1397	1397	1678	1	1	6591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4ddLPAysRRUJe6A942GWz9uALL4BqRZ6pP4ostSxwzpYwBNs
12154	payment	1726	1726	1874	1	1	3554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19ntyZhB74pw8kezsHCRgVWN3teVuEe5ALE3zjWexuy5GDSeY
12155	payment	1726	1726	1874	1	1	3555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6C5p1Gk1fGsYh6HkUoBtSRmB5WnQ17LTNn55HiuJmFwNDRoDA
12158	payment	1397	1397	1678	1	1	6593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZng8YGnZu31y81dJestDPd3NeV3pbVUNkVnn6rUmvPRh4UovRi
12159	payment	1397	1397	1678	1	1	6594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnRBDiLETsy5mPnknaSE8Vu2JVXph9ecNvB5pGmty7QTou3y2
12160	payment	1726	1726	1874	1	1	3557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4PCovPo7DJoHJkKGuUHkpJvns4qtQZveyXRAYtwBdZvzYnZX
12161	payment	1726	1726	1874	1	1	3558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYgv3rpNgSLgF55hq15ykgXNPTFaPXwPTjoGBt71pRmzgjsZY
12176	payment	1726	1726	1874	1	1	3566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo8tSrrao9hvrUS7RxXyG7McmP9a8922ifazpCs2GuzVngUY5s
12177	payment	1397	1397	1678	1	1	6602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9BHKjN1r1FsdZkK8tgT7KDvKbL3RBmqe52JSZptDRwfU446X
12178	payment	1726	1726	1874	1	1	3567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDW68wP9DhLjbKjkfUHFkSpGYQ5ySGYVxmu7kpSRfvcrKGfe8P
12196	payment	1397	1397	1678	1	1	6612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjn9yMcQpGMExLvDcXMLaXNax4BY6CWrqZ8iMfjL4sAJWRNj6
12197	payment	1397	1397	1678	1	1	6613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyDv1thsGnezS5jChptKpyPAxHDKDcAgMC8Dhb6MP7K7L7X5m
12198	payment	1726	1726	1874	1	1	3576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS2Q6tm18z5JfR8NJCdHanSbKHjB4EuTGByNVJv2sk6is8yS7D
12199	payment	1726	1726	1874	1	1	3577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uJVv6GozBQ2YjFLz1RKR3tCfKowHmWQVzi1Dxf8Bwewaa1PB
12200	payment	1397	1397	1678	1	1	6614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb4fNS7LvM3eu17bf8YUA7GWzs9AoYnk7HEdvMQWx6Qiz9rhR
12201	payment	1726	1726	1874	1	1	3578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxkS5UPcz6PKkneDrpgVExVeFS9wEddZF3Datcz8n4poZpmiJ
12216	payment	1397	1397	1678	1	1	6622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUSFuD3yxzmY3Y8BZpxbNwqYdT5eeE7FGJi99W6buFUyg12a9
12217	payment	1726	1726	1874	1	1	3586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZartUnc8PkCD7isy7UjLhkfvixSAGfPQJ9T3rVtbqFesucQS
12220	payment	1397	1397	1678	1	1	6624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcegcN3rxdqP8EU79jz9YqC2SkHasEDtMzUL2pmkaJLVyj5r67
12221	payment	1397	1397	1678	1	1	6625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFxPPinQCkfXD3Zk5PGwzEhygVNAkfWsT6Umd4BCrMsnHDzpU
12222	payment	1726	1726	1874	1	1	3588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg26uu4suu3qUFCtYRZk3MXQRk39VKk3wJv1gR7wN8MyTZKLhH
12223	payment	1726	1726	1874	1	1	3589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzT9MjmSb93rNG9Bv21xkzrcfYL8aoAJqtKZjKjtW8vyYKUEU
12237	payment	1397	1397	1678	1	1	6632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ab9tBY1u2Z5Hv5upnSteMFcXWGMQUvGXKMBk8LSExUKsBmr5
12238	payment	1726	1726	1874	1	1	3597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHNdq2pnyH8KvU8x9XaHSS7cLKN18er348UPEkStqLYXeVNJe
12242	payment	1397	1397	1678	1	1	6635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh4Gtzggz1ufR9FqzmT5AhqMs85zR5mPKQjrH8crogiGKyJiGC
12243	payment	1397	1397	1678	1	1	6636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpgGav1FHoaAWmvWeD56D5g41Wr6MYSy5FHVXF57FtKsEJaVG
12244	payment	1726	1726	1874	1	1	3599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVVRWDyv83NUmLPykUrY9oZu4bFF5UJmNfN1iiHttVgZDKvNz
12245	payment	1726	1726	1874	1	1	3600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfku7hvjVV9uzGTPZdVVkf1AnKKA1B4VfwMyNnYeeEL45dSts
12246	payment	1397	1397	1678	1	1	6637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9A25v7zB9sH5cd7h5TgK77M6VkCoEcpMHY4GrqSRzpMGM6FyS
12247	payment	1726	1726	1874	1	1	3601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCKogozyKaW7jU1wZHtt8P6kQsBsBbEWMBtcYL8YbjxNBFu1R
12250	payment	1397	1397	1678	1	1	6639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xFyYBztNZexKJjKKe5yC7PRPJACNbpwZt6vteSEzcQ3m38Hg
12251	payment	1397	1397	1678	1	1	6640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2kHx8iAXh35fecAE5u75awoL2yNvhwXepKAPLY2gknKGYAT4
12148	payment	1726	1726	1874	1	1	3551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MHjQ9i9ArcgDGDJ8whR3o68hYp3aUnddkfbMRgSPgP8ABDr5
12149	payment	1726	1726	1874	1	1	3552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dyavYQviRP1YCBUYPAy1YoRgBPpHQrZK2qggi9mAfuKuBkQM
12156	payment	1397	1397	1678	1	1	6592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nNFgHU5ez7okwi1tGeRyE8wbRxzNZstZDtw2oKrwyBaXgvi9
12157	payment	1726	1726	1874	1	1	3556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SY8gh17PJ2X45k1zkuCxaYrFQeh7TC6g9pksWGmG5eTHqgih
12162	payment	1397	1397	1678	1	1	6595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dw24QedHJkmpE17qNJmfKo17zFPBR6eC6Wd9kfKrX2WLe5qM
12163	payment	1397	1397	1678	1	1	6596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRVB89UCF38aHVoh7vUJ4pEMLbxebcsvp9HEzgzjTv3gYQFwt
12164	payment	1397	1397	1678	1	1	6597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvKpMdStNKEZuMv5ZoRit1nUbMftTLP7aidN7iV1wi6d6F2EZ
12165	payment	1726	1726	1874	1	1	3559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRX4kzN8nWVMGePh3j2c3oQxiZGLH5Jd4wnDeQqvPEWhpWLFXR
12166	payment	1726	1726	1874	1	1	3560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78ZHd3zp5KTq9hVJK44bHU7SS5FuRybdtKkqx18518mphyeDg
12167	payment	1726	1726	1874	1	1	3561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKe7wJY1D7B2sjnRQw3ovtdDRB5kVLgH641btDuHm1vD65m6Bo
12179	payment	1397	1397	1678	1	1	6603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGKz4ad1RrQAt58mXfzMbq6vWsmbLJsUkoWMnfBAzuCDa79F7
12180	payment	1726	1726	1874	1	1	3568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoyCqcQe8pPFeZgGReGEKvm3wtaTaWJdJGuDU57hRXMQN4Bag
12181	payment	1397	1397	1678	1	1	6604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4a7X17c16SDmpZ8KTcw5NYSM2oD3VNZs7YBmmVDfWEuCERyUP
12194	payment	1397	1397	1678	1	1	6611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnRWGyZwnze1X66GFzPGvN2XyFCLT7MUCz4Q1MHW123u8ywUGq
12195	payment	1726	1726	1874	1	1	3575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZLRYWSX9fjZn1UrXuEXwTrsGKMHMFzTvsZ38tZdL5NkCTt1s
12226	payment	1397	1397	1678	1	1	6627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiwyTnyszfSVRUVAthjiuvY2Brg3gMDhoDJjud2JWPo2zV7Rz
12227	payment	1726	1726	1874	1	1	3591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82Y6YqBcri2K56jEV2zFMT49gQHTWvyGsHjd7AeYvkQdjo1D9
12235	payment	1397	1397	1678	1	1	6631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQcqcaEYtLvtjdx648s51WJNqsVCBpM6RDrR33SFWFMyY2Dt3
12236	payment	1726	1726	1874	1	1	3596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjaRYPCecd5KWmAW2eQgrjnmdksRtXBqsz4UxUAyBgwhLigGWn
12240	payment	1397	1397	1678	1	1	6634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHvavCugBfKm6na6bgepUGrdjW4nZ3fZZC29nKBrRK6nTWe36
12241	payment	1726	1726	1874	1	1	3598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vxK22wYqZZgUSVVf2vPnhb8GBQd9qto9SECiWwNWNrdHrWHx
12254	payment	1397	1397	1678	1	1	6641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mSbPQBtYjy9Y42DxT6QJnD3xj7WycCYzGSCkHfyE7AZNXAbj
12255	payment	1397	1397	1678	1	1	6642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfn5PgbiGTvg8Aqsjrr691iLmHFeLCfBoa4HuhY59MT1tQ1eB
12256	payment	1726	1726	1874	1	1	3605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vYvFy2U9mf9qLuZ54NoKpV5uNPXaMu26Dz1PPGZ7vUdEdagA
12257	payment	1726	1726	1874	1	1	3606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfFTz3s53RMMA5swBuqFLp6oeP9oMH7ERXUBx1YvQnb4ek5U2
12265	payment	1397	1397	1678	1	1	6646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i46ds7zZogeHgLZjaqGK9qLhJJ3nJS15iiKR7UL1fK8F4kde
12266	payment	1726	1726	1874	1	1	3611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhDYWQ8rxWZwdiY4xxufKn8ReFD1b3jqDzUJU2qHQnLgRpkMo
12280	payment	1397	1397	1678	1	1	6653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Vvaj3KXPEuRhV2Vxqzj9GR83YuaWQE2SUAuLr2Vnfv46MWnf
12281	payment	1726	1726	1874	1	1	3619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABCABMpakBWNGBkMQqJphtrzx4AMqxvLK6TpdybSKBebGzQrV
12295	payment	1726	1726	1874	1	1	3626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthiyyAKSn5uMaXqUz1SmXzGBb75u9yZTmW1mKfSW4J7xujxoa
12308	payment	1397	1397	1678	1	1	6667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnk2xREG9F1sJ6hAuzBTBXeYJuCNGGwHQLkwshtwnee3LPY6QR
12309	payment	1397	1397	1678	1	1	6668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEw8SopxJvCZdptNTLvpED39dcxUQ3f22eF8NEDfnyNxm78wFt
12310	payment	1397	1397	1678	1	1	6669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkaywT2ESF5QhLxrDeVoyeE292M5JycnJNXNwahjvwdwAXxGh
12311	payment	1726	1726	1874	1	1	3633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtAW2yxUmx2WamKCJP1ySpyAmRcHcntYrgdzXzZ43NqgbaGk8
12312	payment	1726	1726	1874	1	1	3634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRA3xAoStZ5m53z3nm5T9PjqhAvsueoApnME91ygpRhWQH1yQY
12313	payment	1726	1726	1874	1	1	3635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7T8fbJsR4MXE5ALo7Y1zvu8juFKGwxhSaUDDsK9Tn8ewHikAg
12320	payment	1397	1397	1678	1	1	6673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaJWm3CiziAZ35s17PDmkRSaihxYfvTsFcTMAmDQHpAaKBW5X
12321	payment	1397	1397	1678	1	1	6674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wggb6TaM7cNh2pQULCRwHB2J54AjugsGPLZfAKZEqVLxxhfU
12202	payment	1397	1397	1678	1	1	6615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFEFbHeReUDPZJKV9aNU128nbe9XX54gJ63C8EpMicEqSJyCN
12203	payment	1397	1397	1678	1	1	6616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMNKM59ktKqGCnd9xDNmjbQjdpZTBvjCCR69wk2AJeVfQBrDm
12204	payment	1397	1397	1678	1	1	6617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRfiuup1nyZ9P677Pj2RKqKxT3nm6tTaP9qfsLpGwaLfREWKm
12205	payment	1726	1726	1874	1	1	3579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uYfyjCFyWWwL6YWETgDBsRQYKvU7VMQ31m3BjvBFmm81tBvL
12206	payment	1726	1726	1874	1	1	3580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpH7BGq3vEAX4A8iutkrkGe4TeqVxdkihnLTB6nysDfLuF1qq
12207	payment	1726	1726	1874	1	1	3581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQAs8knueV76ou5ZsWrUMsNqDR3jBeqkcQTcVny2EJrUTkwYm
12208	payment	1397	1397	1678	1	1	6618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUA5ntA9ZsoGHLM8PfPvxJsWokSHDvtd4WPwmD7mbNcQbCcVyZ
12209	payment	1726	1726	1874	1	1	3582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtwJqAcYgGGRqPbeAkUruW9a6rJBAEwsq7C4cmQectS2hd72v
12212	payment	1397	1397	1678	1	1	6620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69BnqLk18pXCiBgN6jkGCBqhHnwEF9Np9tW9TXu82mU84Ntx2
12213	payment	1397	1397	1678	1	1	6621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzSjvJAMzgzuSHKtsTiB3j8DE3MjRr8CEXvC9A7bfNvBivwmd
12214	payment	1726	1726	1874	1	1	3584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefNM15GGxqn3SGoTXcsXmheLq2vNYM6231skwYwVBYxf4jkek
12215	payment	1726	1726	1874	1	1	3585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfbDVNRearuVWqpYJu78TeBs3oPsYtX5BPNb6PeFK2X3TCy5q
12224	payment	1397	1397	1678	1	1	6626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo454TxTZAxu6vrq1tHYBJdwRR6P49AThyQb1VdeRrC36QD2ha
12225	payment	1726	1726	1874	1	1	3590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6cwYUavxCsBZovuaNcEFkcEK32oyobfxZvi5NyVigYdvhsjs
12230	payment	1726	1726	1874	1	1	3593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97BsLTpsrecEdjPQkrmZyUudoZ2eyJH7dcLj2oJZ31BMJaegN
12239	payment	1397	1397	1678	1	1	6633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2UoBEtj615M6F35naVr4drfCyFP29FrGxq7HPa5t3fa8bhfa
12262	payment	1397	1397	1678	1	1	6645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskYoWHPKwS111dZFnK6FBBXvhvrAj51N9Puv8FFXaGzz69Eaf
12263	payment	1726	1726	1874	1	1	3609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaveQXG2SXnBvrR7P2YJ84HhJRPgyk5wD6iwmceA19JZusFEN
12264	payment	1726	1726	2048	1	1	3610	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXwiFF84mYgGiXPEB7B3uWT42QQEqRKCfdwYXzXzWSGPq1SF3k
12268	payment	1397	1397	1678	1	1	6647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFoW2VFpPjnjYEs8yHCrd3kPa2JRGESY77ndYpBHsRntKsbGb
12269	payment	1726	1726	1874	1	1	3613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBije31wdwbSYWiVrLTwsMccZYKZgx4LU1tgBvEy2vVCAmf3T
12274	payment	1397	1397	1678	1	1	6650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9m5fnSQesmkFMpza771FW4mVp6EBogT2fEmjzTYSbTxTq8Aai
12275	payment	1397	1397	1678	1	1	6651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVP2d1SkJRDwGGsw3zhmokKP4xLq2RY7mCZzEysJ24iDCfqsuN
12276	payment	1726	1726	1874	1	1	3616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxm2DeGaBvnhMJ59pp4gHaQAqJbULmSzBb3x98zEYSa47Jij8
12277	payment	1726	1726	1874	1	1	3617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oGKGAnyV89mDPtRANc1rsNx7DziSWtcDit6T7AWJZVx3hLmR
12278	payment	1397	1397	1678	1	1	6652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsMcXPjd1PqLQVUk5BCuUWNbktXVGEmhPMPg4gWWqdfG6b5f3
12279	payment	1726	1726	1874	1	1	3618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2bzAWRL8sVXhHrCYVWBM3RoguvRJBG3ehksnmkga85HVgU5n
12282	payment	1397	1397	1678	1	1	6654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXjQwfkFJy7zk93NR1DqcQ44tMyTY9NUiqbmje3uCLRzSFRBa
12283	payment	1397	1397	1678	1	1	6655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfKL7kzR4d7SftX58Q71u9JNRrbRjXVxL7oaeVkh8NuEeP76u
12284	payment	1397	1397	1678	1	1	6656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwUqo5EsJ7KPjfpBr4qSmXbZbkA7K3xx3hHPNPXhQiCAfnVWH
12285	payment	1726	1726	1874	1	1	3620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBRpKX6Y85bzgTAiAjBVzKaZoBYbr9B6oJ8wqftKuBUXQFt5H
12286	payment	1726	1726	1874	1	1	3621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWXzZE7Cx2FXSf2HuJ9ngsi8tx5iDmNrfWRCMAQVVysSoukox
12289	payment	1397	1397	1678	1	1	6658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuJEfxz9pXc9BC1rtr1yFaNZNCeu4dyUBMo9uZDkiBPwKU5C6
12290	payment	1397	1397	1678	1	1	6659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswzQUKBTS1osZk7HvY97gcV8HnUkvWiissGgC3w8PvPCzL2qk
12291	payment	1726	1726	1874	1	1	3623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sktyk7t7e7h1Zmp3RvAnL7mLoGxpo6eURcrFHvmQ41k1k4HL
12292	payment	1726	1726	1874	1	1	3624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWGrPc3zRENbYLHCYEbYsBXGAGkk1gc4kkFbQYcVcknvtSbvc
12298	payment	1397	1397	1678	1	1	6662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbvfYb4HGqCtu1evfQC6opiFWVBwCJCnfRinY2jBnNZ1spvMp
12299	payment	1726	1726	1874	1	1	3628	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUs2i1jhbZceKfVJWsr5sjSVp4waJ79QcZx8HjJwQV7RQ38n1Z
12229	payment	1726	1726	1874	1	1	3592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBWJqzphzYL8A3ywXX2LDqspBuYnCNJr8peWNagZJR1QimMMh
12231	payment	1397	1397	1678	1	1	6629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaYzdYEhKhR7kK6NywcKnLSYdagkquJWBnbogCWfJ2qCPugZn
12232	payment	1397	1397	1678	1	1	6630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMxXD9bQL1cv4KQS1KUvf8xETSNpZUqNSrFUnxbbRqXzgBrDN
12233	payment	1726	1726	1874	1	1	3594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXSEndQdHxUbVKr42jixd1BDcTdVFHP37QrcSbhaUUvtbdskM
12234	payment	1726	1726	1874	1	1	3595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBm5fyAaKsy1LCZFcnQFVfmPVVkqFZ1jNZk9wjzQyNBMmoxmW9
12248	payment	1397	1397	1678	1	1	6638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbEEVsQWkyiLUJHdLqGzNi5uMQ85p5hmnw1F9osoJKYGAcVDp
12249	payment	1726	1726	1874	1	1	3602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QUd3RZa8XHvojGKLn7cuuATkMsyDy8hg9CvXuqMvpkfMKy1G
12267	payment	1726	1726	1874	1	1	3612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwus78o6Ho8stMyjze6AYf3VSqxgf8ergHqvMk31iZiEtigRP
12272	payment	1397	1397	1678	1	1	6649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseDqT1oXaGA2RtAy6CkWKUMfUBpTd5MishRd4uwJ6BjJuj5mk
12273	payment	1726	1726	1874	1	1	3615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaGTBZQXq3UAXqWHPzr3FpfWqgFWr4GiNrVxtjmbNSPnTczeY
12287	payment	1397	1397	1678	1	1	6657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavgQ598AFDv6GegRV8nG9JS7X6tWKyGzCPnLqZgChCAqGFTf6
12288	payment	1726	1726	1874	1	1	3622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4SgGhggPPQp5AkL9aUJLv2Pzzj55eo8SLE1YKb9oLqrnXEoJ
12296	payment	1397	1397	1678	1	1	6661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7g3LHiRToL2d67wEeBpjhzm4xzbKT7kJcUG5XoKsWkWWxof56
12297	payment	1726	1726	1874	1	1	3627	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNr6JL2YJ6HSPNQERrmKHyJJqerG1DsjjBthCHoX68JXcFdJT
12300	payment	1397	1397	1678	1	1	6663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD9W44LYR5RBJXhGkJWsWgKvSMzbNCpLFzxWjhSNZK4GgVCnq
12301	payment	1397	1397	1678	1	1	6664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjFMLhsVi6cEmw8Dc6BdgdoX7GshyWXevsBRS1FR7rKUxdUtt
12302	payment	1726	1726	1874	1	1	3629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzo2EvQ37ZyHKhgwvbKy9kDdYSaPtRo1eEksrpKtCd23EXGth
12303	payment	1726	1726	1874	1	1	3630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5hFPTko5fseR9iHd37SFqqXY7nHaW9f9BNBRVsjZSmuf8D9f
12315	payment	1726	1726	1874	1	1	3636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ea3WpVv5sgPXYtNUEGpB12hviPjHLx6W6RRNSHzip97XxFo6
12339	payment	1397	1397	1678	1	1	6682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvpcGD1GMfTRbuhr9SZTQchJLyweHze2buHNqngKksBnECqML
12340	payment	1726	1726	1874	1	1	3649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XiJED2RsFs3fuiKHFKp9tq2tYBXNxWvJUHKu13Pcc1U83oWT
12345	payment	1397	1397	1678	1	1	6685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kYSh6CR9QsCN8PyVY6kT7mgeJkqRmvvpGz9PEcb1QM8VSwBc
12346	payment	1726	1726	1874	1	1	3652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5YHZtreG4qtyqFXm13AWgvTsm2PWstutVDnMQkfX57ZQSNw6
12347	payment	1397	1397	1678	1	1	6686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9ZyuMAcGGqd34ETjvdZ636PiDRHeEhjXcJdNE59Qi72h4j3F
12348	payment	1726	1726	1874	1	1	3653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkA8ziz4dqwMwPeEQfMixxjweiba1XeVwF7wWDxknRD4vvDis
12349	payment	1422	1422	971	1	1	6	2226108106880	1000000	\N	E4ZMr5JYgAhxSqENYcSK559P94QfwA2W98SMW3g3gZES5rnUNFGfa	CkpZ9pq6kxTMRMyZSQHAvioXqgyK4DNKdZNAGezaptvg7rKgKAvBr
12350	payment	1775	1775	2047	1	1	6	300000	11000000	65535	E4YfGXnrto29QXhFDTwqXiuZfyn1e6qmX4d2fvfhBndeGw6BEsMhK	CkpZu7p8TetuNUFrxsqmSWC2JZRPc6qS78AG5wJyJSTgqTeaNQEDR
12351	delegation	149	149	58	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVufXyvmVTCWLgaAG1ycru9jjtam3AsUy5Je4vA1zhEzWkzvB
12352	payment	1397	1397	1678	1	1	6687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnkNnsySHqcSLceo2awArJxXn8bxS81BjxSkXmo1Hc4nsYh9A
12353	payment	1397	1397	1678	1	1	6688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Wsnj2iK2wcN467xJcSjmoeW6H9xFuiL3C1wWGoXbJ7Dowtsg
12354	payment	1397	1397	1678	1	1	6689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GdEEs3f4sAeKcNufjoBdpNFamuLgjdoFdhFrKBRjTZCHjFVx
12355	payment	1397	1397	1678	1	1	6690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymp9e7q3ZK4637sFTBU4yyMJmzxZG4FbgWKa9ohwoFzzc7RFj
12356	payment	1726	1726	1874	1	1	3654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJASyx8FwYtDuZbnNmF2kxNzfxv2e7RFLFuajXsAZ62F4Rowzh
12357	payment	1726	1726	1874	1	1	3655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEfZhbg8tGkTPLYrWDS65b1KxNQNd9QM4EDhYHFmUR1JHahei
12358	payment	1726	1726	1874	1	1	3656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WVZETF2vSPufwnv48GimgDrzog2sJt1fRBmpWBjqQAjGVggK
12359	payment	1726	1726	1874	1	1	3657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmsVRtwms79N8DEDFcYPN2j1a4taxoVBeJBuAJ1PC1UWMHciUC
12373	payment	1397	1397	1678	1	1	6697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCv8HUQL2Hsvec9hHry8MPeJNNeEEG8XFUh5a7CezFWLcGzgki
12374	payment	1726	1726	1874	1	1	3664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRohhhWcXhZivVfG8xJjp5YkxSboxnwKd3ZskcZcUZesY6s4BL
12252	payment	1726	1726	1874	1	1	3603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuh3PWTd1XkTx6K2oMV7W59m9DMMzMQ8kZ3gEDurqJRrxBSmW
12253	payment	1726	1726	1874	1	1	3604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvYSqYfuxiXW4cFiA1BbYpg2xgup75PtTfgy8kmCa7JaN8c4Q
12258	payment	1397	1397	1678	1	1	6643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrNoHsyA6taWwXmTyovLjL6SnNgr5dUaoeXmdWbW4XALDgYFv
12259	payment	1397	1397	1678	1	1	6644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJqCnDK5wWd8cLeAXHMs6QdM7ZWWXaWyNLrjNwGvG6nvtxZ8d
12260	payment	1726	1726	1874	1	1	3607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAnGBFsV9SCNE2TsmYnhUCktw5APRT78aAtLxFBbPkxxJBsgC
12261	payment	1726	1726	1874	1	1	3608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGGBgWsA7krFDsTnptNwM6rdgrtzWRvG38B8UEvYoTwsu94Xf
12270	payment	1397	1397	1678	1	1	6648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW1cGN4uGPrUx76jGLkdZCxdMqagDA2Hc5YVrg8zPmC8qpAXZ
12271	payment	1726	1726	1874	1	1	3614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7mccjMEDJVHMoWKuvjnLk62Mr6RVfnbdMCbuAoWRdhGgPZKm
12293	payment	1397	1397	1678	1	1	6660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXKAkKkn37wjUJGBkrpuV9BQTQrX87Xhr8k3WMUqrb5MeA1B9
12294	payment	1726	1726	1874	1	1	3625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrxGqHczMasMUuthAEcvHgCHnpm6edg218mRQukwkiSFXFYCg
12306	payment	1726	1726	1874	1	1	3631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfcATPqCMhQQoXKjaYkNDCQ5SwWExg7BBgTaRhxHuzT5Ak8Vj
12307	payment	1726	1726	1874	1	1	3632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FNYFXqgZ6kQ9pAq5YEbeKdgxRoUX8s33oLraFypAUxKWWoqe
12314	payment	1397	1397	1678	1	1	6670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzK78F1sHuJabS1Jxg9yW4uTNJxmFKU3tFDokeC4waspLD8vXy
12324	payment	1397	1397	1678	1	1	6675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnC34aTVcHmMgwu6w4t5SSe314YVc3yrNpZkigQhU5CpTuvVq
12325	payment	1726	1726	1874	1	1	3641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9GrK9V65XtsoKDa5bs3opcL6aSLazUgmDHA1m8k8kMQpieXt
12333	payment	1397	1397	1678	1	1	6679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjk7ffcBwrRRp4o7rJYM4irixrKpUAE6Gz6twnoydUggJqhex
12334	payment	1726	1726	1874	1	1	3646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLjSUCcc5msKScaAds3R8tjCMrgcZ7kVEbPfs8gtC3cc51dNi
12343	payment	1397	1397	1678	1	1	6684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomB82eFq4DtjT9q1VebokQS265UdPYEpSmLqbAB4crUBvRLbv
12344	payment	1726	1726	1874	1	1	3651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHYMsAfnhUT7F1pLw9FquMMbnpNK7BxquctXYoJW7W83tjNCx
12360	delegation	58	58	58	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGnc9zJenJ7S47Ec3DGbV7qx8nvRkjx5Sg8WeNQNPi3cSMdjp
12361	payment	1397	1397	1678	1	1	6691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzEkjvp7RWPoFRFyjQgPJuWdJ3D54ue16vkbo1qKJYAkSGBh2r
12362	payment	1726	1726	1874	1	1	3658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMhzsUXXan2rLntDc673voPbjSqkyLQcjG1vdcmwBqgTVjnXr
12367	payment	1397	1397	1678	1	1	6694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZRfhANbCgnd8NuwYkRctj27Hsb9xTjspQndBUH7HWcaYt2iG
12368	payment	1397	1397	1678	1	1	6695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJoNzLoPDSu31hy99PtradtGsZ8SansWLTFLSadWy77PyZcVbZ
12369	payment	1726	1726	1874	1	1	3661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUDaQJsYH2WBEio8cwHY6kyAs1mQCj51iPhRjD91axkCYwqE7
12370	payment	1726	1726	1874	1	1	3662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDydgRYn6JTUSV7kgXKvhahSaj4Do25LaL8vWKPNg3Mn99xpWf
12371	payment	1397	1397	1678	1	1	6696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dPVCAL2PZB421AQxgE4R8ULVHz6js81GMtF1598BWgqd7gq5
12372	payment	1726	1726	1874	1	1	3663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEStgiK1nG7F5NqmjCpnV3T5Km8LEz7Jo1n9KrJqoxuMsm2Tg8
12384	payment	1397	1397	1678	1	1	6702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHpymzqkMzAF6BtKyPhBWPAuJ2pFmKqXUsPu2jA3c1Xmf4hu3
12385	payment	1397	1397	1678	1	1	6703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76hyYLKxzQiwsYkdvAhRfPMJR9y3RFWWCLnSByoUokCpLXvvT
12386	payment	1747	1747	1704	1	1	3	1000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYdALvKQ2DmK9gRyunf28BXUKA1yVX3BEndo81odXXxuddaEMbP
12387	payment	1726	1726	1874	1	1	3668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqXe65YKT72hUuboD85mJYAKLG5b49WFxuX3Akp7vst3a5FtK
12388	payment	1726	1726	1874	1	1	3669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAyqPvugui7aUnxDrYQ7MHR4aiDKoJjy6jnLkSFXdAbvwGFXa
12389	payment	1397	1397	1678	1	1	6704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdsF9484EUz92DBnwUAAGo6XjAauvtrM2pGwxh1s7CPrdj2At4
12390	payment	1726	1726	1874	1	1	3670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnrUveoWCs2DyNc95jfogywqze2853VLauNyjqeC1NED2vJYo
12400	payment	1397	1397	1678	1	1	6707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmVrzc6Wk4i2XEEwdP6tHwVwv6KnsSdbsDwX3xmkGbEWz9pSx
12401	payment	1704	1704	1075	1	1	0	4254000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYSmoUs7JMsVcrZVMTSdYieLP8XkrtkHiqTo4AAp7stnBLf6fvb
12402	payment	1726	1726	1874	1	1	3674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRyuwvBXFYifKfxJA2XbP6G3Px2n1ZXYj1ESJXRoY3ecNyojH
12304	payment	1397	1397	1678	1	1	6665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV69mGUG6HeaWBNYEszuTAMmpyy341dNXkPYRsoeoAkXkJoBwF
12305	payment	1397	1397	1678	1	1	6666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsy6uasqeKKKBuDcvqYknD9HJRoCoMbWNiMEt9JKZDsBpfuojF
12316	payment	1397	1397	1678	1	1	6671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48DXLPKfNbXfVRo7BRY33LCCKsigD1D3kPJWYsupKxhFQrFeD
12317	payment	1397	1397	1678	1	1	6672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBoHn9qhSU8GEUHkRKQUTsHYCochEeUTsM9ZMeZVytZcdvEgN
12318	payment	1726	1726	1874	1	1	3637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7U46jgNwdwH3d5cpxqeh7FqTjbqX4fPbmgThiBL493puobDgH
12319	payment	1726	1726	1874	1	1	3638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3p1Jj9gGn7maXXY54NupCQmpBDjyDEAoRvP9wC9e7QLHzDXYR
12326	payment	1726	1726	2050	1	1	3642	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgEmZ6vkzJEhoiNxrAvDt61aSaRbn9vfHCPXmjDmuoTThma4vD
12327	payment	1397	1397	1678	1	1	6676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsSt6mHypZtDaaLYyueYjUTv82zKriR1o3DbCth8BzSNfiGHc4
12328	payment	1726	1726	1874	1	1	3643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAz5YVjVwe4p5YHANmfX9h685NJWoSxR1Z1Y7ApVbiiE2TL7Hk
12335	payment	1397	1397	1678	1	1	6680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXEYfYS4Lpkrv9wzuN78KgyXEQWs9BMXBDasbeDeiyw3hFpCM
12336	payment	1726	1726	1874	1	1	3647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcaQgH3xepgq6XQRtrhDr8XKL9d9MN1uERXgUUgAsvNBQDMAk
12341	payment	1397	1397	1678	1	1	6683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRX4YgZHdYqMxHTenZEvjatKRZqWGm549DwzmZgQ4XPBwti1Y
12342	payment	1726	1726	1874	1	1	3650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHaCN9eiP4hginrYcGGV8mq5qLpq2KJDPeGXRo62SjgwXCJQA
12363	payment	1397	1397	1678	1	1	6692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWpWSo8nHuYCMNR28zn9eiXSX1TNCrAH3KPVLrSrHwhj7QkN5
12364	payment	1726	1726	1874	1	1	3659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4kLQCHXDQzShgkgd8M5PbNyXGJt7YqwmWfw61mQ9nkroPK2qB
12411	payment	1397	1397	1678	1	1	6711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmwY94fSJJCHYcSrtrN2ZcVvomDPtM5ZLUieppUpYmRfrqScJ
12412	payment	1726	1726	1874	1	1	3678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDiuPoqKu7FSGki9GkvTCVfkkSocu2SeYrU2ZMrb3efzJ3cxx7
12417	payment	1397	1397	1678	1	1	6714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FK5htsu9GVsnr7fvvUpoRaX5kxikAkCHygSiqW5ER3tBWTuf
12418	payment	1726	1726	1874	1	1	3681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfLonCkUN2FjqqHzqGFt6dYJF6Us9TCUGZjE36PH1W4bneTRv
12439	payment	1397	1397	1678	1	1	6725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Tcxkity8fL3sQgAVKTDooFiNZgx2NvzmMcYGDuVQ22Hv7CCt
12440	payment	1397	1397	1678	1	1	6726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc5HbM3zdkb5CWxLEbaVL14RXDHr3ZgJw7dwjKPAuve9za31iG
12441	payment	1726	1726	1874	1	1	3692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiYGsbWwABYDp8VR6ByZTzQrpqJgW2FcRfV5aDHrtrT7zaeDr
12442	payment	1726	1726	1874	1	1	3693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DsjiFcCP7y14xS7VsycMgmxrgMhJqUrfLcWyTwkQmLKSxb7s
12443	payment	1457	1457	1025	1	1	0	2552961600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXh4ncZnNjyiyV4deLfd9ZFoi1K9FPKBd643oBpfH7QyyiExV
12450	payment	1397	1397	1678	1	1	6730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGvhk2u9wy18aSUQAqD3qgAyX8pP5r3iW9jdbFC5VQL2ccV4k
12451	payment	1726	1726	1874	1	1	3697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMFhZX6nF8nHwdU786sj6sreuJXfnXMM1ZRgSi15sYS7bQgXX
12470	payment	1397	1397	1678	1	1	6737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1te8mXcuofZHaGiyRDwT5zMoNZEVW75fxEc8YKqg5tndx8si
12471	payment	1726	1726	1874	1	1	3706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYnEMeRY6yKmaCHbEkWUjXiZa5MpmnCcBi4gRPan9QwFpDNXL
12472	payment	1397	1397	1678	1	1	6738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbZjNxb5ryLTmQhHeghUEvHdr426QLyj4qF9zc5btDkB8kN47
12473	payment	1726	1726	1874	1	1	3707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEwD3XxVWXLLifxyoLpoWsdAUCapYqd3ZVxBmDMrsRAuSiPhJ
12476	payment	1726	1726	1874	1	1	3710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFmNaELndsbs1U89XPfjNoMKdJNBKizR7tG5mLocdjwWHUT2t
12478	payment	1726	1726	1874	1	1	3712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceuXAC8uDFu2zffQQtnpke1guMPCKw7xyw4Neveb6fKGwpAAL
12479	payment	1726	1726	1874	1	1	3713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8GiaNthjjBQBy9NGkB2B1EGhbcDoPP24RE1qwp4NQRA64XDR
12480	payment	1726	1726	1874	1	1	3714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8cxHZnfnEFvbP3FJxG6rDhZjhAxH6ykpUM6wRCEsPFs4TibB
12486	payment	1726	1726	1874	1	1	3720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3HXd3tFFw39Ry7MPr1EU6xbdxJxF2VRi6YvaGHoCsPNLdvHxn
12487	payment	1726	1726	1874	1	1	3721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP61gu8iWjhjKEjkESUQAJRUCvvALwcw7NtK3jf8hx17N9zW8G
12492	payment	1726	1726	1874	1	1	3726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLXMppqqiYeWBse7NzP8ekwCRZBUHpmv5W57iTQgdGZEXRgqF
12495	payment	1726	1726	1874	1	1	3729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPip7t5cFmn27ZP3usb3DnSP8epQRPkd8EXDgJZUncfmTBfgC7
12322	payment	1726	1726	1874	1	1	3639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNXpHcvnvcAecBzcook9ok6r9WrSsLJBd7eKZhMpAHgmVy7No
12323	payment	1726	1726	1874	1	1	3640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBSCP7nvuiAsdtpn463wZbdDWygK29cLGjGSWSC4rXzwgUMib
12329	payment	1397	1397	1678	1	1	6677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcipsGZBDhVVvTFxTcSFx7JxEfUEbui42eJ9bpeWAMQo7ZCcg4
12330	payment	1726	1726	1874	1	1	3644	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw3UAYpDGPtzsL9UHGB5FSZ3WxaGj4X7z9g21uTt3nrif2ihJ5
12331	payment	1397	1397	1678	1	1	6678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9z7hTJaRQvSNeqhqwPC2WqQoJ2ybvjqhT4kW7FDSbuk2SFxp
12332	payment	1726	1726	1874	1	1	3645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo4Z21ZjYET96FaPHUHHYeuoB9Y8hk1mp8GdZ2MhoibQ5X3ey
12337	payment	1397	1397	1678	1	1	6681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MXEy9GZZ9SogaTS3GWa1PRwJK4GouNaX2CvfkSwGkB5qwXo8
12338	payment	1726	1726	1874	1	1	3648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFEaH5QLhwD3VzdvLcetHwj2Pd6LGkduoMevScpGf3WtUtHH7
12365	payment	1397	1397	1678	1	1	6693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a9peV13cCgKD6C8wZcYJfgZGXE5cqz1fE3nPKNKq8ox7Et1V
12366	payment	1726	1726	1874	1	1	3660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46T7jXTXGVV4ntAJa5tJhaU62MqPpqhvV8eJRXq9uKV8ZHmRG
12394	payment	1726	1726	2050	1	1	3672	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2rDAJcMMRTkYGKKoCHGagcLPtQ68fMeEcm27cCaMBAd6kJkrG
12395	payment	1397	1397	1678	1	1	6706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPyFKQbc4ba5bRFxpUGVHKwEAVTy12NnY4JgCbYzYK2pqq8q4
12396	payment	1775	1775	2047	1	1	10	700000	2000000	65535	E4YRfE2fnUBCLHteXSgVMnFhVVVgAr3rPHwn8A4cnYm92qV5mAwQ7	CkpaBPxs8yYmHy8LiX2QVFQ3KDEhRSrbazmFvd73vaKwL3Dx7ypEn
12397	payment	1747	1747	1321	1	1	4	7998000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYfHX2vL4b9ToYETE7ZUqLmeVUHnmEhXMKVzHmw33xEqGgqzTJs
12398	payment	1769	1769	1769	1	1	22	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Kg9qe6QPJh6a1s6oiotK6oKDxFREvTRADnvWfRAMy5rxRpzF
12399	payment	1726	1726	1874	1	1	3673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFrnxqEhvSxwgzngeYxfjMX5N5S9ve721Udeqooekceah21AM
12403	payment	1397	1397	1678	1	1	6708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcazeE6gt8Bx5N3JFoMtEee5qfuJBuFYTF4TDAiMN3aXuEaDJh
12404	payment	1726	1726	1874	1	1	3675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJB9CCQGXxv4uEJK2VJ7rQqnKx4Y4rJU1o1ngnADV8UJE4UJk
12405	payment	1746	1746	1195	1	1	0	2871000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpaFery1Bza9CgMtGGKJHmt4JzMZpNr7F5cFfbhtQbw3PT8FJ6hg
12419	payment	1397	1397	1678	1	1	6715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhh3cYTwgzavksMBugXsT2bwxyxNeZzYnCapekZYMEevAYw2nr
12420	payment	1397	1397	1678	1	1	6716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmbd6v5QfpyZ5eEZ2qKt43UMSTx29KW47itznbwG3Y18wKLcv
12421	payment	1726	1726	1874	1	1	3682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjsTjFoVNCFc2oeGgZ79q7VUa3FyzkcPEzY1g6zStndmq1kd6
12422	payment	1726	1726	1874	1	1	3683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbma5p7M5UgRHX9LtrGuCqBqkEZeqYNPPSZ67S4eHGsY6zi2o5
12446	payment	1397	1397	1678	1	1	6728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmvGDBuXviYeniQSiWSztYvqqaVK1M97qwA9XdJJ36QomQRaL
12447	payment	1726	1726	1874	1	1	3695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNG5htM3h7NWzaSn4NDoqrLN1bJcXfqcofuQF6hLJ7oj1wWmoT
12452	payment	1397	1397	1678	1	1	6731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhn1f4thXzu9VjQP8dsLfbaBZDrGaXppZpgex4yqM9suKjFJA
12453	payment	1726	1726	1874	1	1	3698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAPWQ1DHUiNDYsq5JFyzBCXkLa4X7raqJu2ck2XUijKTTsXbg
12454	payment	1457	1457	1265	1	1	1	3086727840000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGVR2LSk6UdcmeajReYkgGiHHAAJsN3nyFW27aM4b922Hbs3M
12455	payment	1457	1457	1145	1	1	2	4575029760000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwnY7sWaHv3CN6RcjggKvzLhck2V9B3rPZeemrBX2Kj7pUuoe
12456	payment	1457	1457	1391	1	1	3	8601737760000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1doYig6u4q42Tmq8XBWn99Hkpbb7gP9x4SosK1xnZXLTGGK9p
12461	delegation	1769	1769	44	1	1	23	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBAv8yCSPnvYcZDxACWvcs3bQh6WfNjBkJixoakzdJvYnZezy
12462	payment	1397	1397	1678	1	1	6733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBUgxfifZYMkiDX79RnNAwnf1LWWFgCNcNhAVY4yLEWoSjvE7
12463	payment	1397	1397	1678	1	1	6734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdB1V4R2BS7p8eZDedZqLbT6ZRa56nEgCrAzpEBj5rj2smaerA
12464	payment	1397	1397	1678	1	1	6735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfA6LD9yUfn34kEb2Y51R4A8xeZ9AgyML7vWFprkTWQRgx6462
12465	payment	1726	1726	1874	1	1	3702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYGcF5vdrPBm7otGvmgRevBBMN8GrSPew5tREi5TeC9Nytr9mc
12466	payment	1726	1726	1874	1	1	3703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQSfQT3HPe45wfwSF7obLAnymiwNzCUrnNxaqYpnYjkjbQbYL
12467	payment	1726	1726	1874	1	1	3704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzUwpBMzS8aZTmmBamWBwdBqmcDEKdEj5Lbx7naN1meUruW6z
12468	payment	1397	1397	1678	1	1	6736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLvpymez72majgLe6grzeiNuQv6UDJGNRp7X1MuQfYs8mNAQD
12375	payment	1775	1775	2047	1	1	7	400000	1000000	65535	E4YpzFg29rNWPNUGAZ3fqXqXpELrQDtYtSCac5RWjWNLa8tmzpuF1	CkpZbECFzLiG2dM5amj1UXqynZwrtxUUhfHrqfJSPtoUBY9PaQrPm
12376	payment	1397	1397	1678	1	1	6698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEZ3vinjTbgGGuWDzHqc9e5iTzQgTFyk3yTC6WLwMF41zUdtbo
12377	payment	1775	1775	2047	1	1	8	500000	11000000	65535	E4Yo3WVnhpX5i9LH3Fn2zNxFZXmxWbYA5N4D3LYipz1q79qNoKkmG	CkpZSHYgTY2REFPb9jfJtgYar5khxKCs9JhvBJ2nJhsfQDZJ1YYS4
12378	payment	1397	1397	1678	1	1	6699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUbswiyQHx7SjhepXs7Z33tiNHnhtYQQs686k9rgpE6535wP5
12379	payment	1397	1397	1678	1	1	6700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjJTiLbdp2PtKAUG3QUFnK2PX2KXySxDetT2nMee1eWGFd6by
12380	payment	1397	1397	1678	1	1	6701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6by35ivxdo6trdSaJxjH8zgiBaNaZZufd1EaVThpcjmqbeWce
12381	payment	1726	1726	1874	1	1	3665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy4Er4MuXNmw6ed8vLxH1jmRGLKADkPFbiL1rViQR3bzXN5oH4
12382	payment	1726	1726	1874	1	1	3666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhi7qe8EaByqUfzYy7bEsjrP5EU5xaFZBukh6xZHyY58Jvix7
12383	payment	1726	1726	1874	1	1	3667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9KjyQMGxGP9j6Mb4DiSsNFAANB6m6HTd9axWrz9BpPg1pDkF
12391	payment	1397	1397	1678	1	1	6705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHuQj19gUbHawS1X1q2jQ7S1qqQzPdpuFy1jtiok6bgHhnsWG
12392	payment	1775	1775	2047	1	1	9	600000	1000000	65535	E4YTbvw1s9BiHM2ALfgQRyyrxtSmz6rSNSYizMdwT65UU2NHky66f	CkpZz89WtEypmuhe2EEu1brtTCisMPXmNA5XUbeQfhBuJAbhRPzGz
12393	payment	1726	1726	1874	1	1	3671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXRTAR5zGUkZ4SyjPdyvxQhYxfrvSYNmwueupQ8er2fTxDMTy
12413	payment	1397	1397	1678	1	1	6712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPe2mA47xyEw4scuEN3359jzz3nVMrYezVLosS2p3DE9eDTah
12414	payment	1726	1726	1874	1	1	3679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJVHPUfZkrXyT3w9mqfmxqc4t98wwSW4AC5tN4TWcM2uhj984
12415	payment	1397	1397	1678	1	1	6713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcnAopQ4n1XdtGWJcTXNabbiErV7t2EMr9f32WAKfb85rFnUc
12416	payment	1726	1726	1874	1	1	3680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnh5k7mdbGVD4pUetv2EJt6DhiAjdYWyp3mTzAuHyK24g7yW71
12433	payment	1397	1397	1678	1	1	6722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjuzsewFMQLX9AaD3cMsY5vyWLbzSNVr8wSR8ei3adWTYzQ9j
12434	payment	1397	1397	1678	1	1	6723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrYBsidsQkZguGgNwyi56fDRqeoBSKtJUBZdDf9ePCW5LGm1C
12435	payment	1397	1397	1678	1	1	6724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAYekGpcCDxLrfs4xePRbnB5W2cMVNy498tPepwXRbWwfrnMA
12436	payment	1726	1726	1874	1	1	3689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9MaGH8nkcMQVdKrPeZdXTKaap6E7WGaZbc2VnFk8NVCWUEzy
12437	payment	1726	1726	1874	1	1	3690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnVjyhk8rG6zSzhDf3KGDa5v4Ue6MjrMQ7y2S5mmnVi9fjhDC
12438	payment	1726	1726	1874	1	1	3691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMFDHTdArUjBJHeRWb4HdQKhE9Mpd76XWECX98CMajAP6HeQK
12444	payment	1397	1397	1678	1	1	6727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXquQFiQPQvcMMmSDBfys5rd4tKG5eh1BwwFXQmo4yDNtYsGVX
12445	payment	1726	1726	1874	1	1	3694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4tWACW8fpv1YQYWuNnnY3etFTz3Zh4eDJ3q7HBidjFL8XWyk
12457	payment	1397	1397	1678	1	1	6732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfV1Kz45nuQnErCR5nQU8y7eKNmTugetUEEfkmx4HU1kGqMd3
12458	payment	1726	1726	1874	1	1	3699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2namZ8MwjS8gAMgbcwrPPnFh6NP52EWb5Tphc4or9sW9WcT2
12459	payment	1726	1726	2051	1	1	3700	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnLihDrva3YjYyrUvvCUGbe1C3ZXBFfxtejfRC7C4ycAXtZUnh
12460	payment	1726	1726	2052	1	1	3701	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYoSzyiw3mRNRxm2N46qzzyr4mJS7jnWiHDtUXje2tp9h5NsYkc
12474	payment	1726	1726	1874	1	1	3708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDkcVYMfhBhk5wWfkBGGv5WmxgAFAkiLowYDauEE79Bk9eiXk
12477	payment	1726	1726	1874	1	1	3711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaaimqExs3sWC5YwyXi8qD1FPi5jygGUkMAzNbzqJLLyoMXJe
12484	payment	1726	1726	1874	1	1	3718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzy1ndSZjBv8MruoQXf6CUoiJxgrXjiEM5cDYHRvX2rf6pkik
12485	payment	1726	1726	1874	1	1	3719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgsimMbRGa8cq1vd1h5SsLoQLDVut4MzohjL8YjfFHJZXjDze
12493	payment	1726	1726	1874	1	1	3727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT25vmsdiw4KC7vjkiwp1EhZbTqDrJz6kbYAcEbvVLxmrM2xkH
12506	payment	1726	1726	1874	1	1	3739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgxFcae59owA1Eq76UG8SHw2ctgXyYiAyN7nxQJS7ehEdq2DU
12524	payment	1726	1726	1874	1	1	3757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbXECP22VLKJJND7o1brj5ypvtS8gY23hjn8Tdf2UHn4dxe2y
12525	payment	1726	1726	1874	1	1	3758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJDnjAFk6wuaTZct9vMgytwWuarBfr9nuhfYw96CaqQtnaRZm
12529	payment	1726	1726	1874	1	1	3762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6EfNBThhdFeyk6hhoBs5K8TRkrcfArf7tDYtDZnVzL9WNgkN
12530	payment	1726	1726	1874	1	1	3763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcQH8xaDX3KNAedeC6NL2Ya6bbiohNozD5f7BthegKcXMPdjM
12406	payment	1397	1397	1678	1	1	6709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUAajt31KtTmHYNwRf5c3ZqJsxhADRhx9ZCDi46HfKkrTQBLC
12407	payment	1397	1397	1678	1	1	6710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQG1xkAAgduQxY5e5VhcDTWUjSZKdiYmZiowjcgXz69upotEh
12408	payment	1726	1726	1874	1	1	3676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBiYXTLeojESfTwYh81MPRdQDfjvGYk63nbnRP5zTgipuCdzq
12409	payment	1746	1746	955	1	1	1	2374000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpZ7YrXyjxwHXoVu45Weu6Syy5r9CqJwbf7yaJW5wV6Sm8MqFnVb
12410	payment	1726	1726	1874	1	1	3677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkE6YQvJQJJWXKFhw3deMj3V3eswbLEhKnFJ7wWqpwnRLnvFWw
12423	payment	1397	1397	1678	1	1	6717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHaKkXSeSkfvxsRvU7jwkt7m7ar5qBxxuwJeJqyPMmjHxu9U8X
12424	payment	1726	1726	1874	1	1	3684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfqFX5m3128HXnh3xpGLCfg3MwLA96Cji6yCWpz1HKtD1BjKe
12425	payment	1397	1397	1678	1	1	6718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMibNeGSranoHY8cDbZUQE13UzzArKd9MTt6jmG7Uw6EWQ2cQ
12426	payment	1397	1397	1678	1	1	6719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCuEQFpwxZcHgA4L412HewEcdBhTDkAJ1r9AxyLmT34MrBSxX
12427	payment	1397	1397	1678	1	1	6720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9S5WAZsYGwSnRRQfWsYPYrsNSax2u3zYaAoPjVceVa8EugsVb
12428	payment	1397	1397	1678	1	1	6721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyLmbaCoounKBkPQionro1KD3ixS92LCt5e2veMeqtT4D1qiR
12429	payment	1726	1726	1874	1	1	3685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbNgGmXx1ozB1itmL2MTLCKz3Kiwgj21bk1nTwUbAq9yKXMso
12430	payment	1726	1726	1874	1	1	3686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANUwdq9TgTpoUBEqxJrnfh8Y6RbU4hggAwQw1NnhBtbBFnvPY
12431	payment	1726	1726	1874	1	1	3687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSBfYiNG3t9TwDW8dstLaeZoR7uSwBAezCQtwGjDyPLxGWh1C
12432	payment	1726	1726	1874	1	1	3688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcJeVsVZY2qRmsxos2QrEuPS3g1jE5EuBUFPLc57cz6zr8VUC
12448	payment	1397	1397	1678	1	1	6729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYa7gnUDED4rESCSecEwkRDjCigHYxgh5aNcC83qCr68bf9Vah
12449	payment	1726	1726	1874	1	1	3696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WYBKSoguZa2G6RxN6ghdpdGjT3KHxtJ7JiC7PCjeu1wEzJFL
12475	payment	1726	1726	1874	1	1	3709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiDFckYWgSYzYqM43Yt9qP6F5H9qabw4FzsXo5x64tn74QY65
12482	payment	1726	1726	1874	1	1	3716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kk3XtQLgTWtzoF5Ea4S1skq48TQsfyNigpqDyxKy5vFwu3s8
12483	payment	1726	1726	1874	1	1	3717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsici93w4GUM7WMpXfjaav7kCoEyBHjFcUKaFbmx43xCh6wW9o
12488	payment	1726	1726	1874	1	1	3722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykPJ8CCVA38JfyKqTDqAvxHm7q7yczvMzE1ChkVwSJn3TFomC
12491	payment	1726	1726	1874	1	1	3725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy1fKBD9YyDHUyVPxPfJtPkqPU3CpGgLmsVAkekFw5rbZkSKz
12496	payment	1726	1726	1874	1	1	3730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt324WRKxBzVrkrcvJuswWqjxitZk1RzkuszarWC9YBS2cs4nj
12498	payment	1726	1726	1874	1	1	3732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPzBUn4MhFeq71eeabzp5MbCU3APcPwQPva72C1UP2mNDjgXn
12499	payment	1726	1726	1874	1	1	3733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPPdZiLzaUkeGyNivzuEcUwcd7UDgkFB86gC3fweZUdQ6vrs6
12504	payment	1726	1726	1874	1	1	3737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKoAgqU693Z7CRGqFv1Rz128gGZTJcCMACLSBnEM9BJcVX451
12507	payment	1726	1726	1874	1	1	3740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fAobrYLF28CQeFakd2dpWZarxVhrXKBaQsjNhbQqwYYDmWrH
12512	payment	1726	1726	1874	1	1	3745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvU92TEPeq2Ft7JhrLKLeDRY34k4MVjJcMEyK4fMJymUdvhzt1
12517	payment	1726	1726	1874	1	1	3750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYfG4qQ1k9gH3RrVxEEmXcrvn2sZdeX6o5y1sd7nZn6tbh2QB
12518	payment	1726	1726	1874	1	1	3751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ncDvtUAFw73isHzucU3mLSJd4pmEAtcWWa4gLAR2M2AEuTW5
12522	payment	1726	1726	1874	1	1	3755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTrEvS5dm9JdrL5wxCTeQtBcsrKxKRPCV4E4goTgzd3pgDUDZ
12523	payment	1726	1726	1874	1	1	3756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYim3Sr3LBUMH9jTkwDai9JLa2GydHKTNtEWcac4sZEVHy1S3Hh
12542	payment	1726	1726	1874	1	1	3775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLYzPQUMzY4WjcV4deap88HMVP8eLeQdFcWCL6NsxHA1PNj4h
12553	payment	1726	1726	1874	1	1	3786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC76Ppds5ePD6FDovGH6SoS35ARKi8m2JsfWFqrjE5yp6UEXsT
12575	payment	1726	1726	1874	1	1	3807	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFUCmNzR2gr5fT5EMe5QKio9wT4qhce8M3xi9S5a2FpXn4mBGg
12578	payment	1726	1726	1874	1	1	3810	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibtWFKhYFxdLeP1Do4CX37x3eBEqhz82co53xtWrMLbnKpfdt
12595	payment	1726	1726	1874	1	1	3822	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsU5idPDYZnDyPQPUkUKQ1h1gj3USQqXRsMeCCt5h4mdCrRYkM
12599	payment	1726	1726	1874	1	1	3826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5H7ncxWLo5yRJK4NXYH7fM3MGZrV5XMdme9DuXTCa5vap7WSJ
12469	payment	1726	1726	1874	1	1	3705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDo9BqgUWCEbczavxryaRATiKiQQ7dJ7cg9LGuRvFG85EAprJw
12481	payment	1726	1726	1874	1	1	3715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3wUbuAwgbhbR8SaRPDqGyswYnUjjZe1HQ2Sggqx53o9QWeAc
12489	payment	1726	1726	1874	1	1	3723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgpP4kiaU6ttKnb1b2x83BjmXpkZqtsoau8FQKZxvzb7kacE9
12490	payment	1726	1726	1874	1	1	3724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnCoQQXAx97caTucr6a5tt93Kah4M1Nd532r15Sw4PL7geLk1
12494	payment	1726	1726	1874	1	1	3728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RcCN6SjsD5jeGq3z3uTrG7uKhF7eTt2d1DbWm8sa6jRSbRZt
12497	payment	1726	1726	1874	1	1	3731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkumiiUS3qgkQhn8ZLCmNniCUJR7N3jgfwpRbMiQmnroFpTqpf
12502	payment	1726	1726	1874	1	1	3735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3bXXSzJDcN3rTstZ5btGgJFudcy35huB46YxnVpiyTVthqRGK
12503	payment	1726	1726	1874	1	1	3736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYuiZrNnkg13ZbnSiCbfvXiSJ2X31CWmiVyTAEMsidcVaXaRA
12509	payment	1726	1726	1874	1	1	3742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL14exM8Hch2887WsSBFFpn6x2fEN8eu2hGxxhpENFaPibvSx
12510	payment	1726	1726	1874	1	1	3743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQEjhKKNVFPGEyPHhCaZEdyrshdwVD68PySacam9NydnNSg5pF
12513	payment	1726	1726	1874	1	1	3746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHZK9hz7YpWvCux8wHFHPWjpNc9RgzMisuVZ2SLFHQt7HD4xU
12514	payment	1726	1726	1874	1	1	3747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGi4warDHyor36jTF9Zaqnt7yqpQNFpRtE4V7cHA2wjFHAhxR
12519	payment	1726	1726	1874	1	1	3752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fihxsEQ1LccatoW8csHv6zXpUBGk3dAyWz4hv7wtrruk1Vga
12520	payment	1726	1726	1874	1	1	3753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDGN1zWky6eeD97emBoZC7AvC2XRQDEqXK6HtcU711kMhu4zT
12521	payment	1726	1726	1874	1	1	3754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBb78UAkfV7b4GLBiTtWJf2jkwvBzqpAMRj31cYdU1pZru3SAx
12526	payment	1726	1726	1874	1	1	3759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHzprjw7Jyd8f14PQjK7YCRfBdWeGVPGWXzPHRbDvWPDojoQo
12527	payment	1726	1726	1874	1	1	3760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUekn6HMrFs2eRH8eLmfQDJA14PxUvMAiQNk7AXS1gh8GwaqX
12528	payment	1726	1726	1874	1	1	3761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgTw27483oyJyBuWoQKEavEL9VxUmCqMUd51imecH4zX5Y8hC
12537	payment	1726	1726	1874	1	1	3770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAj1k8ZCZb2bBdyMuDATdcWWRc5XZoquxhcHPSdgCQTjZxMY9f
12541	payment	1726	1726	1874	1	1	3774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8addJbgYr7ryytV7HUkjN6QEAZuvpDWGq3d11FiFjNaNC726
12543	payment	1726	1726	1874	1	1	3776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ5YmF7KPepZnq5RDyyZKWPYvmdTekM3WSWp3btHrBWZUd1Fyh
12544	payment	1726	1726	1874	1	1	3777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cty4EQS5hC9u21DMwmUMT8s9CWFqRT9LVjQEVBuRiUfJq7hm
12551	payment	1726	1726	1874	1	1	3784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe25fD6WbpznqXow9wkFKyjdtuV5MaQjHBc1SJvcBXc2kqBm5A
12558	payment	1726	1726	1874	1	1	3791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEjWJ81Lr4cc37c9FvDdpfYfocaFhsrDHvhgskVeQtn9QL5bj
12579	payment	1726	1726	1874	1	1	3811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGCMJCkqcVBfVYfXZwCMKLVzP8DA7kUkfHidEKsef2SdPFhVL
12580	payment	1726	1726	1874	1	1	3812	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdpidToheRWXzeJR9Z7BuNT4uhdw8wm8EUVEdxfJQS4F12jNWj
12581	payment	1726	1726	1874	1	1	3813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJcG7nGR2XLrzDLmBr9FXwKPcdbg3Qy9QLMie7JKTa7jZxEPk
12593	payment	1726	1726	1874	1	1	3820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPcdh7tPHmXdCNXSz3pzeKUDVWhB63uFY1FmrshEmTWm9bJN8
12594	payment	1726	1726	1874	1	1	3821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbZAssAcLFQXuss4UvL3rCABD8mWYnfZ7S2jrNrtL36CiX7AW
12602	payment	1726	1726	1874	1	1	3829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk6PrPzPzNRmoJR2YsYsDWGi2um249Q9yUS6ZGQuZfWBmhYrs
12605	payment	1726	1726	1874	1	1	3832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Dubv4bP8xFCy98Wy1mnj5HF4zXmXnRsw8MoGMtbvPnAnJzup
12614	payment	1726	1726	1874	1	1	3841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwMgfuEs3JMesd7mL3B83YDUYdziFFq9tvygbYGopGbGrPACT
12617	payment	1726	1726	1874	1	1	3844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfUbuCiaNCEVF2rEJfE9hRHzeV1pf9N14yAWYQiCkc8s5RvaJ
12633	payment	1726	1726	1874	1	1	3856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyar86tZtmBZEHpTUjKidzvhz8wc2oikhySQkhWofRX6iYPdZ
12637	payment	1726	1726	1874	1	1	3860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzQrkrFnyGeGdxUHf1pBmywQERJUsyZNrKbLiXf1S633rqtnJ
12644	payment	1726	1726	1874	1	1	3867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5d4umRC8UeBVtZKbSrBwAM6nP9V3o4vMa99AsNvPr8zgXXxz
12645	payment	1726	1726	1874	1	1	3868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjL1HWjDL8M2mcBySU1eQoYG3CGzFeycPXmXHorM4axwGZXZdD
12650	payment	1686	1686	291	1	1	4	231401142041	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaJbtfR9J6nQFxPHdHwSytUT9ZUiCceRU7R4575FHGG1NWs9zjc
12500	payment	1726	1726	1874	1	1	3734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNMBfN4qQq5QvvKqx2gVzCNSkQRvwdUfofrtgbKrDqD8UM3en
12501	payment	1525	1525	1931	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZV3B3aswkpu2jmB56KnrtXzmwtxGyYcivmpAspuW348hsBwMu
12505	payment	1726	1726	1874	1	1	3738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiXScgTPqxYFEbWDYQkWrhmKNkaQhxSKgcRwLrU1VCiadbYQv
12508	payment	1726	1726	1874	1	1	3741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYRwKnqtuFbCrAcJHThi9oKq5y11qcY7DghPxv9YaNvhQeyEb
12511	payment	1726	1726	1874	1	1	3744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfsUd5pFZC7XpSuEUGsEUCA6ha3sPtDwejhp9XEy3CgvRxTtU
12515	payment	1726	1726	1874	1	1	3748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhf7w4CQY7AUFBYTndfREXmu9FNVZtK6YSCjtpMxoE4Xj5FFem
12516	payment	1726	1726	1874	1	1	3749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXD13JqufsdkXa8A6i3uZ3szTXgietizp1dLqoeAo7FvFswEK
12533	payment	1726	1726	1874	1	1	3766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFQUKehz6NAkqtgAVJDVicaWjecKgfPUTtjRYK6GpqX5K64SG
12534	payment	1726	1726	1874	1	1	3767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqye8jXPTm1zC6896odeKVmqVNZDmVNsGgj4uRMAZEdyV43ibZ
12535	payment	1726	1726	1874	1	1	3768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdX5UnkLy1f92hJsLh1V6WDQbxSvKW7Cvj6gUVYApQDQ7h7Yfg
12549	payment	1726	1726	1874	1	1	3782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5FiCybeyxkZ2QxUhoCLYyXDWE9W1aRhEE6RDDhjx5mHuWfTV
12550	payment	1726	1726	1874	1	1	3783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxcKnECCRN2AzDhnCweu4sK3hLbnJ6FQQHbjfJ1ELRwzqHMJZ
12561	payment	1726	1726	1874	1	1	3794	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNYDYA1FVx4iYJ7BDwDqLyb1ZdUATfGBt7ekKYeKFVdMqUfxa
12565	payment	1726	1726	1874	1	1	3798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqNAHM239tPvPBuU28F1cpx5XA1yda6PvU6p7KE1pZbbhxPZb
12566	payment	1726	1726	1874	1	1	3799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHH5tatBo1cULHuP5H4ZYJYZ7TRoS3ZT6afoxQbaEJMi8uaUg
12573	payment	1726	1726	1874	1	1	3805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZrLTmX5KqovEwoxhjAFdySB1CDajfWXNfAQJSNbgW53cmN5k
12577	payment	1726	1726	1874	1	1	3809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVwknBdjEAdUf7D1CoBAeE9tLfb1aHeKkfRSuCezX4QwmoAmV
12597	payment	1726	1726	1874	1	1	3824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFxppi7Yz2DcWTH14RbfeHREXjxohyxtif4KTHAXdXuUnAoB2
12598	payment	1726	1726	1874	1	1	3825	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjevVjxxfYe8SqQhjcw3WTBhvFLUUH6Dw1PxdFDHdnqZbEQ98
12601	payment	1726	1726	1874	1	1	3828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEMAn9wLjJTYmL2ZBU2gSrekvhVbWKeEmfwV1Sok5oMWtvsPU
12606	payment	1726	1726	1874	1	1	3833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ22GVCdvDdtAMkF54yfonspqtKPL5ChbXDfykoa4FesN1WaCq
12608	payment	1726	1726	1874	1	1	3835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCuqo52dhaJBT1hr81eULGY9nPLbkkXbfw6618hEh22JwBZck
12609	payment	1726	1726	1874	1	1	3836	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtuq159YsB5UkvUTHoUvReTSohuu1jHLezzQi8phSZTcN6FHf
12611	payment	1726	1726	1874	1	1	3838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfuLm5yJmC68GgP1LYqovtxZgZfL966t5K89QkZsfzYmaoY5k
12612	payment	1726	1726	1874	1	1	3839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL4UZq4oTCm9u5vSJdvTUCAteNdNoyjXWp1hnoZEKLXF8PVP6
12613	payment	1726	1726	1874	1	1	3840	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qri2RxjQwfFBeyVeRG78VkJYCjeFNGGmhrMfHqdemhGRMw3Y
12616	payment	1726	1726	1874	1	1	3843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDz6U32HkwWrVNJBoGz4NgdV7CaEkS7qCqzPHciJ38JQPee3F
12618	payment	641	641	1090	1	1	4	490222800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1ttg1q3C4qAZ1zEuTBuWnoVA8XExBd8qxQBPnhYZMBiLEkE3
12619	payment	641	641	970	1	1	5	273531600000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9VimXanDSWxsRT8dxsxQyETfog7fEdqqLoLFwRrUQYpbWZch
12620	payment	641	641	1336	1	1	6	921553200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2b23GADUMk7wxGQ2ScKXmtRF2EkZsaMvBJjsbJhUZoG614wnR
12621	payment	641	641	1210	1	1	7	330782400000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjqtxMvxUkzsUknw46rzqY9h1wRRLSdkb7vjHMsxTr1DhSfST
12629	payment	1726	1726	1874	1	1	3852	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNo1HQ6bAEvqPcbveEqpkGKCV5CFoEzAjWSASrbMRhYCBQf8c
12640	payment	1726	1726	1874	1	1	3863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dWGwYtLAv9GZvdDB4Dakqjt1mmP84oaZZDFPsrZrvNNyB8rs
12641	payment	1726	1726	1874	1	1	3864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBy5UZq4uQA4yWv9wtVQUAKc58wrQE5Fde7s5y7WJ1dT58GJ8
12531	payment	1726	1726	1874	1	1	3764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCBu2BpKUp86maW8Rdu8h4n7UjSRm13vLbP4dNzwcnYxerr2c
12532	payment	1726	1726	1874	1	1	3765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQvc9MLzGFdgpGn9EvvKJMaF1UJrTsqvGHxx69DxtBy3jZVGC
12536	payment	1726	1726	1874	1	1	3769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYya4LSgmF4Z2bUjY5AFd5Tp6u8h4TYhsMkiUWArvJmtgtQjHnU
12538	payment	1726	1726	1874	1	1	3771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2NHkNXcfcE2VwCsfbNTeB3dR7faTJxBJfhAesos8iBqwbRzu
12539	payment	1726	1726	1874	1	1	3772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWex5YwaAf5cR4KqT9tkyhgRF2h6CsnPERRqgBTjLRxDokPWx4
12540	payment	1726	1726	1874	1	1	3773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptgEQ5QrQsy7omtEjPujuvFjmxHePY3CqbZY9bdNobyFY1Qw4
12545	payment	1726	1726	1874	1	1	3778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjzyibh99MGzaR1VqpTFxVaLetkD2PKn2jPuT1KHpN5B3rJ5e
12546	payment	1726	1726	1874	1	1	3779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBSCGnVP5ynGcFD54bNma6uYTZGK2YQCqg53hw3Y3mDGhKJPv
12547	payment	1726	1726	1874	1	1	3780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJDW7G9HmhaLvzxK9dC8qV9bSTUH9BduevQgZqrSkiEMgberv
12548	payment	1726	1726	1874	1	1	3781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjExBdzTgy6JxoDgHSeSWhGSrCuxsioubCAgjhZU25oFxMRRE
12552	payment	1726	1726	1874	1	1	3785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcaGnJXu2yN7dVBG8Y3jXmTdf3A8rskKfqY6QirCyxfZVrMtE
12554	payment	1726	1726	1874	1	1	3787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqLoBNNUJUak2Nn7aXpYBawWEb4d4P6FC66jqzfutxiLHjpQG
12555	payment	1726	1726	1874	1	1	3788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUi5XnjT7nd5dHgmo3bCZSE6oMeFYL1y1yfb5WhBTeEsqKQ8Y
12556	payment	1726	1726	1874	1	1	3789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafjprBTh6ckGj9csknW9XHnJTfZji5mPwREHCWFpu3Tt1LPxD
12557	payment	1726	1726	1874	1	1	3790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLoncjMHqMhjGF9iMYa9Mp8KRTfQUtnPfxCwMQWNJxkkXcCcU
12559	payment	1726	1726	1874	1	1	3792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQKQa8dRfzrXdXab6PEBw2anZfTsyVoBCgyWn5C2XAprFQHPd
12560	payment	1726	1726	1874	1	1	3793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT75KBHph6mRNNBZq6WDEcfL2PrfQ4AB994NwRmmFjqn7drZTX
12562	payment	1726	1726	1874	1	1	3795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytGLCJe5Qy2eq1KcHrvd5P2p79Zt5qt93rBqXi7tP1UNqs2VD
12563	payment	1726	1726	1874	1	1	3796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eebA6tsP3hFaGGqShTbHiK8eF3kaWhpadJWVzowoFm4Zaszk
12564	payment	1726	1726	1874	1	1	3797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD42mYzXi12BSBds3orh1tAH4CxY3twK4Ybq8N8GBBqsGn5ZEe
12567	payment	1726	1726	1874	1	1	3800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWayUrQ4vjF319qHVLa3hm3yJHCi49KjhMHYyBr3PgDDxLiG1
12568	payment	411	411	2053	1	1	5	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYy2AMr4U9233uqitiy4aqM7vovm6rMEzbMidw1rzWTyiLgCNs
12569	payment	1726	1726	1874	1	1	3801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbJZLnnzbFF5w1rtH9xS1wsXtpXqzND3kz77aiKFx5apFXm6K
12570	payment	1726	1726	1874	1	1	3802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqdas1rFH2BoSrSYkGDxxZxQZTKAfUJFUvNAh8miVaUvGu83P
12571	payment	1726	1726	1874	1	1	3803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMBbCTe5w8NCnREgQBv3ZMmWdLugpEecJ9ZBhrgPAYecjqnA3
12572	payment	1726	1726	1874	1	1	3804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1zNVNM9LLnTPmyxB1ph88zR2tkzGGQ8uh8MvkyAN1VpJp6NE
12574	payment	1726	1726	1874	1	1	3806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKznd9Ei5QgnSPB8wm3xUdgQ3T5imyzDYKyURZxFk7mC4f3aPb
12576	payment	1726	1726	1874	1	1	3808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6ncfoJqBMuruW518mruFe5kgaXRhGQWppnjFCsJfv6qqtn4d
12582	payment	1726	1726	1874	1	1	3814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZje5U89A5GcMdGLXdsUmf6eqtJpii2pp6iqLqvu81KYa2D7VAB
12583	payment	1726	1726	1874	1	1	3815	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgHhhpL3LwDzdQTB9nG4rBGVXFPWkVREcovbXFqD6AsTTjJrU
12584	delegation	2042	2042	411	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBUyj7Y1kXPQva1wx2hNwdAmHdMt5HF3pfrVD7C9o86HqYMWz
12585	payment	1717	1717	920	1	1	0	2134505012457	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpaJfN9tBpG2BhYfwzf3QY7h6x1sD64SsHt1M4WrZsqkgSkj83Kt
12586	payment	1717	1717	1040	1	1	1	3825014693893	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpYQjXwGZEJ1mmQpzUHaPNq6yDxnMkcnL46NUeo5prvhiUZkUPan
12587	payment	1717	1717	1160	1	1	2	2580813632763	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpZd1eQFBxgegsabHnfsJMPePv6Fkj4HGP2kFFbEFRrnqgKMAmrB
12588	payment	1717	1717	1286	1	1	3	7191666660864	10000000	\N	E4YtdbRg2CnAaSfPWDYbRb8hYCKaHT3oDYtmJioLVL9p1PipQihma	CkpZ7BrtNY2Hcvfcq5qqHGbuMXMvNfpDuKiPRgwKtoTEXZaW5M2dJ
12589	payment	1726	1726	1874	1	1	3816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzmwjfURoGHMKbvF3SYYtPmLo7v2tYyjKbS1MjMh9R3C4T3et
12590	payment	1726	1726	1874	1	1	3817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHMjJuvjW6PnKYhwKEQ3NLWi3dy7g5GSZGDvzrxB2NJbJy7wkA
12591	payment	1726	1726	1874	1	1	3818	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTf346eHDtBSS6wcxwayTRSYRSekATAn9fQhUEmyhyvv21d71z
12592	payment	1726	1726	1874	1	1	3819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESuJWn9VjDGjt9Sha6rkWPM5Rxq91aSxmy86ePe1QVJurkQfs
12596	payment	1726	1726	1874	1	1	3823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYjafy8XC5vb34ByhifACX27Ubi4JNTRvAQrpiYu9JqobPCuA
12627	payment	1726	1726	1874	1	1	3850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrCXAY8snkJedPNE6LDwX7GYUkUXNvkBN7gs2x58bFhN2vJPk
12638	payment	1726	1726	1874	1	1	3861	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1Zh6ZHSuDX7SBwZ8Ex6eijzi4wdtiPNphaJL9DZ52ahWQNvj
12642	payment	1726	1726	1874	1	1	3865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zuM4fxnryXWN2u6Ztzf1gFZpYQgyanm92VzN9Ah88kDcJ4bw
12643	payment	1726	1726	1874	1	1	3866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6hh7kuttwjmazDorvF47BXMZLTX6LdaCZqWCfP27daiSsBp7
12600	payment	1726	1726	1874	1	1	3827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxBybND5nRXS5yCoiT5mh8eTJssWx51T57ERSQ4sJzsSnGPap
12603	payment	1726	1726	1874	1	1	3830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYexXPXiVmoQSQKBHvfcqyZZSnDRK3Q5Gxp7dei8ry6Q7ThXYXE
12604	payment	1726	1726	1874	1	1	3831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HYddd855yLJpFVHxTGCuw6sq4WfFCAKLwu44UZbeTvnnjhDZ
12607	payment	1726	1726	1874	1	1	3834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkB2pQJ3sgtor34B5yNbuZTjpNm7yuV4r7hoijJop5rLoxevyd
12610	payment	1726	1726	1874	1	1	3837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQW1MLxLoEtpjBRRew2wLJQyqTfQ7F4bc9UFFHDi5TWab5qcG
12615	payment	1726	1726	1874	1	1	3842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT4Nh1Gs4UdkLH4DCFPR4vnRUzgVo6jTfhpedfRtKEWu8Zs1r
12622	payment	1726	1726	1874	1	1	3845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2FdpFXAzBPMveVdiWBhvQYQPzGxZRNjcL5nqu6A73XUxLipG
12623	payment	1726	1726	1874	1	1	3846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97CTCL2eHgBq8k1TiUQWnFUGXc7yZER2rV5g2cRaWHedxbuCU
12624	payment	1726	1726	1874	1	1	3847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfyxmfPgg6K4GyiMzpX6wUCRJkwLi9Sas5RQqvNr4FDXAo2Rzo
12625	payment	1726	1726	1874	1	1	3848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrKAJC1q7oVRmkXHrem1LTkQFSSMZGW1RVLRpyQyLHPwiCCAT
12626	payment	1726	1726	2054	1	1	3849	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoqiBM7iqqZ8LR3FaWEQePJu4mydJYkRttia2t6tpPASN5cHwf
12628	payment	1726	1726	1874	1	1	3851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3YoBqwRLXRN318zPd2mi7aseXsgWsNp4xrrHbmR8DvqJgN3T
12630	payment	1726	1726	1874	1	1	3853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGurVdWa6aq3Cxs9NJTDgY8wWUnBhvMVmb3sjHoHWmUWJiLeU
12631	payment	1726	1726	1874	1	1	3854	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUpZTBoJyLoaNYuZSkTxq79YJavW2EsSpN4yq8AH9ZKLy1pPV
12632	payment	1726	1726	1874	1	1	3855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVovQjSG7AQopYc44ZTLzdxfXLjdVE4KthwjRzXUMZfXgap9VP
12634	payment	1726	1726	1874	1	1	3857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVfrmdEiLsfyJ9BphtRTRaFjtWW8FepVLEG1yEq3Qf35PiGBU
12635	payment	1726	1726	1874	1	1	3858	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHHFGDYSzPdvwS6oBRbrQQbvUNSfZwb1xnuqW5LRodNo1RPxp
12636	payment	1726	1726	1874	1	1	3859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGhvCyYKs1qjtifp3faoFFkvMa1fkmc6e8SkMjv3C6jWEans2
12639	payment	1726	1726	1874	1	1	3862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKLo82XRFcavGY1c4Tvif1wTWDjnEGDGCxww1RqTWhUtVSafB
12646	payment	1686	1686	1771	1	1	2	234661794490	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZVSGw4cSrZEryE2C3C2TZF84Kkd7cQL1tGWJi3yXzaiq85aRvR
12647	payment	1686	1686	195	1	1	3	231401142041	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYrPLwAX85ifXUmcG2VTep4JHWz8HTRAEYp3pyqq2W12hSqdiTU
12648	payment	1726	1726	1874	1	1	3869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchQ4kizcgGtS88QHCgYKTEFbEGSA3QiVQtTDfM9b2i5wV9iEb
12649	payment	1726	1726	1874	1	1	3870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWWAoyNAXy8R4HSucr2VDTMJepGkzh2Up24U7xczeFbRaR42G
12651	payment	1726	1726	1874	1	1	3871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKqrQjtBiPTW1ctedCHPF7kzNvQrWzm4Vdzd1HHZwmzd7rqqt
12652	payment	1686	1686	1023	1	1	5	1761527108560	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZpnsFvEX3MNxCEAAFuwiFq1RYsk3nt27btEk2PdUMxaJqfM4jh
12653	payment	1726	1726	1874	1	1	3872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSHcx1qnnT1meSQ3awDzQhn1ChpRYka9k1QRp2MTVf7XsFK24
12654	payment	1686	1686	1143	1	1	6	3156641485780	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYXchU3A2yRFgZ1wi6i9v28ctzxxvrGQmfUiyVZSmWAP3qgNVxy
12655	payment	1686	1686	1263	1	1	7	2129848910979	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaJPSWg9Urdpp9YQizu9p1WaYedAzCanjRcWBBppnzRRtfJbKdu
12656	payment	1726	1726	1874	1	1	3873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMtvkyNxQLcrtDLVqgm4LNfJtWdNKYabNuPt58E6Y9CNsZKmx
12657	payment	1686	1686	1389	1	1	8	5935013366060	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYXfDwPPvFqbAmsPP4iPKS9fjjcNY7qATBga3HANAcnMLNX1ZdL
12658	payment	1726	1726	1874	1	1	3874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTra6qVnLQSbdn421GvUkdHQ3cbBija7L47xrJwfZtKRhZfmg
12659	payment	1726	1726	1874	1	1	3875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfH6LsPSPc8cHgLRStSf5J2SNTRDdzjhdvpLvkf6MVTbarj3J
12660	delegation	1737	1737	1646	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cTjxHvc4R9RhmkaKnK91ypYPCP9aHUeuwM7ubGyNgWv5S7Ti
12661	payment	1726	1726	1874	1	1	3876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcRNe5vVeTXZSGHBLiVAxAPmwPAAafnehjbAxXqUQpQ6K1LtN
12662	payment	1726	1726	1874	1	1	3877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kS1irm6xZvz2zwwwYQK5HsCVjo9SM2twfmg8WDs8oRPyKE6r
12663	payment	1726	1726	1874	1	1	3878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJZb7Bb5nDGnJX3i5FCvqGAUk18dAiKdXDGpcHwjrht54ZN45
12664	payment	1726	1726	1874	1	1	3879	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLpA7CzXzGKcqTmM1xLY1Jh7tsdQonvi7Dj6VjfdXmR7vmBT6
12665	payment	1726	1726	1874	1	1	3880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RFhyyGbz2giFEBfSjdc3tKYrYYKnshAfpTtSdg58zQ9AWoPP
12666	payment	1726	1726	1874	1	1	3881	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDL28K3srguLVpBM9JxAYTa3LRkK2G7BiTiy1PxteiyHeDqSoR
12667	payment	1726	1726	1874	1	1	3882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8JeSGapbkpvidACB7akLKC4NbGP3GBhwxwh5J23AM92zynkU3
12668	payment	1726	1726	1874	1	1	3883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsh1F7dX8iFpxyj3nY1ibKtQNz2hziBpq5JgeEej4B3geqEmMy
12669	payment	1726	1726	1874	1	1	3884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicrrhKf5UNbhHLQeaiFLXktfnm5yEcHHnug4LdqjjYar6JaeY
12670	payment	1726	1726	1874	1	1	3885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XrtUuurFzjaPN4P5dxpUvEkVnaELeVyp6YThzWzuCqjSbhT7
12671	payment	1726	1726	1874	1	1	3886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnN2m71rBYXzda6aydHmMiT9GZzExbmMiNL5xKtNh81NWWw1Tx
12672	payment	1726	1726	1874	1	1	3887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsk6g14qETizPHWzW5NryNn4GAS5tA3RhK23HeeCmXhGK97yK8
12673	payment	1726	1726	1874	1	1	3888	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6T8K5rRb7tGAcypcGq5m3Rrokwm1ubUxe6zDj5cBDiZSrEdq
12674	payment	1726	1726	1874	1	1	3889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoyEVe1qwoFYPii6QWf2xn6fwQoZnoQVJePfaciVdmNa7Utdy
12675	payment	1726	1726	1874	1	1	3890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYF4rfsTx7wafjx4cBKP8ZiQ6Srx4PfMh1siJZYpVmkhvQCDu
12676	payment	1726	1726	1874	1	1	3891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLqB9mD8hB8KGhGGiKtRxw72tVKqKDFZ3hRRiK1MHtcy9qMgb
12677	payment	1726	1726	1874	1	1	3892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6E4Arjh8sFfSueSduWo7BLKQgbZccvk3C3bv9Ld6YZVGS1PTk
12678	payment	1726	1726	1874	1	1	3893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6XGxhurpBgsA8vQwhs19Tzwkh94xRSBTQRZ2m5R7jPViCZNU
12679	payment	1726	1726	1874	1	1	3894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQCuoySsWxTvq2p7LL5a8YTaSKHwrRFBqLUvgXCDc3Jbw89FR
12680	payment	1726	1726	1874	1	1	3895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzuu2avJtykN2Mf8huitXAGYj1nwUrWnin4xk1793xt22C2ER
12681	payment	1726	1726	1874	1	1	3896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvk73jMKPA2mQLLpoBbQUbGwFhu1shB3iu17YFmUnBpZJhpkcs
12682	payment	1726	1726	1874	1	1	3897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oiwGTXnrr2kJaxNbPbh5nb1zvMUYPkbfHK1CXvRQWDgwfZrE
12683	payment	1726	1726	1874	1	1	3898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXB7BbTuszBuSuJwFKFuqEE9JMzz4Y17QFPsVCak9pNJgA6KM
12684	payment	1726	1726	1874	1	1	3899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSaPcj3aDfYxN37DauevMuDsGBU3r9bTJfx7Fm9J76qU2b5XTe
12685	payment	1726	1726	1874	1	1	3900	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQUuZ3DNbcb4UVTRtPnuZXZ88BKEtDdKSggQ8dkio1JbhsKsYK
12686	payment	1726	1726	1874	1	1	3901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMR99VRJuNNNQH4sDjuKaSZSAYsTfsviWvQea2Vw7XkhoCW2T
12687	payment	1726	1726	1874	1	1	3902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHqC2p1bZB5p14tYvtmoKjxadxQB9tqmZ8skbrwNxwQZQA7jD
12688	payment	1726	1726	1874	1	1	3903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKyg984z3EVndZgHVLn9P1wty9JnhwqP4u3RqJ1hvBhp5TUxRL
12689	payment	1726	1726	1874	1	1	3904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKsGq78eVXvgsyh7e7LKGrKafMjtnx8NDxQXjL62qVu8oFAJR
12690	payment	1726	1726	1874	1	1	3905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUeNnmQACxS1dYykTySoituao63ruTbQR3jSzonkBzHFZkS5d
12693	payment	1634	1634	13	1	1	0	21715676666	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpYZxZ29NMVZpRg9XJ7uAqcbSCWxNxz6Nu2kTUkt5hqWpmAKsWFp
12694	payment	1634	1634	19	1	1	1	10860172844	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	Ckpa3DtkApAJK9QBUQebWKb5WUBEbiReBBFTgdMVt5k7PGV3VXpSF
12695	payment	1634	1634	203	1	1	2	308156237945	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpaJKXdcL7KFWb5Xyrach62EomhJ2svzwx5BR5NT8fizVNc6jaQ3
12696	payment	1634	1634	241	1	1	3	308156237945	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpaJw6CmXXV1LcmjvsPFNYqjZ3GEzWRurTHCWgr1gF7YxLuvNDnt
12697	payment	1634	1634	313	1	1	4	308156237945	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpZJJPVfVoofgBJPPSg11dgEksaGfiHc5rVCAV4Y1RBZY8fHLnUu
12698	payment	1634	1634	965	1	1	5	2286444226326	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpZGsjGNfc6B1Re1Lj5951EiwXCksrqXHKCbs8J3DVBAeGFcyjyq
12699	payment	1634	1634	1085	1	1	6	4097288463320	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	Ckpa6mPNEYKzzV9UqYT2xnRZmbzwvYdNZj8f7kDVCnvsQ9zXRz2LK
12700	payment	1634	1634	1205	1	1	7	2764522170436	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpYw15Sv7GxpZZZB8cpj3U9xdNptPZeaXtkkDb9QG9iR6BJ5WQfa
12701	payment	1634	1634	1331	1	1	8	7703586835568	10000000	\N	E4ZKuK8VGXJcSZ4BhvvoAYtG6VgZohfBVFpW9x4BZk8w4X2kNogNr	CkpZtS6rDjGjpgJNMdMNhPjGPkPWgBgxSS2KP8hdQ2V5huMnmWdfe
12702	payment	1726	1726	1874	1	1	3908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvmnqKh9QgeVBuMhT6sKtYoEk521reRZt2T8rARqU3PpLKbYt
12703	payment	1726	1726	1874	1	1	3909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv1gT6t8qWJtAKajgYnSrgJSLMiLK6ZsKkKXLvFhF7efVxhV3V
12718	payment	1726	1726	1874	1	1	3924	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh98kPPRKbGF3Q3Bhh14TegZgECWAZ9rAS7LRcGJjYzP4pFHe
12723	payment	1726	1726	1874	1	1	3929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhjZHreHpUozRzKbFxkTXssg85RJrf3CaVWC8ysPvbGr6GtgU
12724	payment	1726	1726	1874	1	1	3930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvqyBJuu9Dwpn6dqFqjm51XTE8BmLPYMj9kiUmx2pqHEc6BnC
12730	payment	1726	1726	1874	1	1	3936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuWa51eZoG7VknxbdN9eQMsYZD7QkoKUxeRGX8EzVtkhsMq8C
12734	payment	1726	1726	1874	1	1	3940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCzSRFm4jwjk1xPuiQ3518eA281ugvWn43AAxDairKiJQwTuc
12738	payment	1726	1726	1874	1	1	3943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkReaCksnJL6GWm6YqAcf7wbkt8YZ8tucsqHB1iTda8JSEkfwp
12739	payment	1726	1726	1874	1	1	3944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZwBZv9MaScH9GwwCpGuKYp7Jn7FupyPMn8SXAroU4DuJEoMQ
12749	payment	1726	1726	1874	1	1	3952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzm1xW5Fq4NwRiuB4bAXhQeZ1g4uNazVpJRPPVzVnKXpn5sSD
12761	payment	1726	1726	1874	1	1	3963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWzdiCsQMq2LdkGsYoDvDHmmDPnUYjXnyzLFfggkReyKkJfXt
12764	payment	1726	1726	1874	1	1	3966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJtKD515KoK3nCLY53aiFJBLavgoMJPgqBNpyPpYpjLCKEDrmF
12765	payment	1726	1726	1874	1	1	3967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6GgBpfmydaw3b7yftUANejuVC7xxPiE6t6aDzkyj97DchUiyS
12769	payment	1726	1726	1874	1	1	3971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQbJTwzGWEQExtEXYePrFj4Cq3NyBv4oxfbj1FQde7qYUSGZz
12777	payment	1726	1726	1874	1	1	3979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqCW6uEB1SHwT4VSr1RPY9A1djRtKG1Somky5h2JbHCMZtEF7
12780	payment	1726	1726	1874	1	1	3982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjiu2VvDvkDbkpBMG6aLN1cUhn66rGJhHCPBJ8J7Dg9tNqqsy
12782	payment	1726	1726	1874	1	1	3984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UuY8zEv6pE3GZ6WD4YuerZE2xsdyWhGCqjQcF5g8RZ6kcYNS
12784	payment	1726	1726	1874	1	1	3986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5WALGVdSxhvzzhVWUy5cdmXXrMEsxLSomb15ahk4PWCDGx7m
12785	payment	1726	1726	1874	1	1	3987	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqPs6814ntq6ipyGL39Cx8cWo8jnbLZGfHgrTBWXDkszBX3pR
12790	payment	1726	1726	1874	1	1	3992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxydyxUyKwqW1Eg4CQPBPENHumGfULh8Sr4BqDerY3mcnRjf17
12794	payment	1726	1726	1874	1	1	3996	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaUBi9vNYv7GFd9HpyW7WaKqUgFVEcfbr6ZZV2knfZJgDgqyR
12796	payment	1726	1726	1874	1	1	3998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EE5r1ryhJewwA41QRt5m6bbWETAy1WD284kEpHdzE75dacNa
12802	payment	1726	1726	1874	1	1	4004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQC49VtdzHZe9haaxLLngSUfeFzzHW4onS3ri1j7pb3TsusTmY
12803	payment	1726	1726	1874	1	1	4005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6x7JgM2ibXaioZ1HpCzmfL5ycHJuCDjVqQHfzuxb4e5GBwzFJ
12804	payment	1726	1726	1874	1	1	4006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxUURAYGuCnFNbr63dFnEEqe6AVgCDKsdfvTx5YHrjYMDA9Rp
12819	payment	1573	1573	1072	1	1	1	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFCg5xR5ugaxrxSvguPDZs7rWCk4yuWGranq9FU5d7yHKAkyu
12820	payment	1573	1573	1192	1	1	2	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddKgY6yKcQYSyztrr5mS2marhBm3gtuPZzJNah1eQFhteRE9r
12691	payment	1726	1726	1874	1	1	3906	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBk2xJm9UyZgZoZJm5uAWWq1GftefZzf3CsnFD5EafyvTW5UM
12692	payment	1726	1726	1874	1	1	3907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndSao9pFN2BWx8G3GZdjpMN7iPMQVhF83MyRfnMXCYsSsD6g1
12704	payment	1726	1726	1874	1	1	3910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLk11RZAoUqXfFT9kNgSYTJNQtWYbaLgRetj4c34U7XSg1YU2y
12725	payment	1726	1726	1874	1	1	3931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJ3GejafNK3dBjSPbBVrT73gPRKMgsumxRnkZcgKyPmRMNMZV
12726	payment	1726	1726	1874	1	1	3932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpdDqETMfJvqesX3dXhdxGMVdQPPE7QrnbJ4csFkuCr8RBikp
12731	payment	1726	1726	1874	1	1	3937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhgR41PEEM6m4nd5Dk5ws587NZWV79Wz48bHpjGJQaWzQYFXE
12732	payment	1726	1726	1874	1	1	3938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyorFAmcobKfZfcwLjMAAQq5XpoSMJCGW86vzmae89ayaAMSv
12740	payment	1555	1555	1101	1	1	1	3103678489721	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZNEPeNknPBoUZ4C3ivWLtFcyjiLK7UCUG56sPMnN6nLDgttewE
12741	payment	1726	1726	1874	1	1	3945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAgocQ952SyFQgNDwEYWnHqHYuvetqBnmhfvXqbZvufywKhQD
12745	payment	1555	1555	1221	1	1	2	2094113722186	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZHrbJQsnJL9CNkq9GDiy5UzRGBuEGMcXRTqTtG664GBQYuibPv
12746	payment	1726	1726	1874	1	1	3949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1WFhRLUt5YTynkMTokjvYQVYHWbCXzHQtucrHGfTpQRXDtdG
12747	payment	1726	1726	1874	1	1	3950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Pa2nUuX3qWZf5TMfMmuGRoMsEK4o1fpTda18FfraZe44xEx
12750	payment	1555	1555	1347	1	1	3	5835434085079	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpYhbmuGA4bto89x9BjvwgFkiSZagVQsr7Q4gNE2t9gAB4Bj2JQe
12756	payment	1726	1726	1874	1	1	3958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4i3YqPy8zgUFGevHWoYWR5jFUjKKkdyAoXSxBBxzD2j7x91u
12759	payment	1726	1726	1874	1	1	3961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdHvuvfN48UU5p34L9fet2yHR8kBmAVSZL4AuXcsRgstG6KT3
12762	payment	1726	1726	1874	1	1	3964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVjy2a6Dz1MaxxgVPfPMHr3eZuFWWJ72zx6dMBheG8Nk58SKY
12763	payment	1726	1726	1874	1	1	3965	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpMK9W1VHjfZNgPgyYA7th3qfUXrA98RRB3bCLmEAZXrxefpe
12770	payment	1726	1726	1874	1	1	3972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkmcHfE64UvBT89xoGi39WoJhpbzKobMVJCsdNZfLG7Yssrf7
12771	payment	1726	1726	1874	1	1	3973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnmUFiNpCnPFqdhzBCiYV63YBUnGrtkB94GrMRP2qc641znrB
12772	payment	1726	1726	1874	1	1	3974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpB2whFaTtUsGkfaoPVDUhjNLRXnJFYnrn7T5CbtJ6GFizEHR
12775	payment	1726	1726	1874	1	1	3977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4NNAd2qoK7huwAcC4HWMwo2CkbFBwhGqu4nc7PxMidYqWTHP
12783	payment	1726	1726	1874	1	1	3985	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYhCGpgoZRvVkvFYB6po9zyC39643W5UqEqL1nvfL2z9dS9bx
12787	payment	1726	1726	1874	1	1	3989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3fbGDitffU5YjtNnUh4bE1LDnrV9eWP12BAnP7iy4K55j2FBT
12788	payment	1726	1726	1874	1	1	3990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDE4XXBqfZr1u1E3G1b6vXCzpmSTXrNNbQAFeE1fMJDinCb1VC
12791	payment	1726	1726	1874	1	1	3993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSw6MJjQQKKNDH8GrHfYkDamEX3y3HvQ75axye9TmWE6StaaA
12795	payment	1726	1726	1874	1	1	3997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMAKR3bBeNEK8FhmqhJNBmEfV3K2Fn7hRvLF15pnJNYUhc3hF
12797	payment	1726	1726	1874	1	1	3999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerKLpFLMfC2SiVft7ZikqEqKJ9vgbncn8RUUf9a3kMV9Ren8k
12798	payment	1726	1726	1874	1	1	4000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumHwQQMAbYmUG6bvX9MpUw7KeQsdfW2xxrUf8iyZtecHGqSC8
12799	payment	1726	1726	1874	1	1	4001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBsEvNW5jw4i64q1dxtp2XhjgqSLBV9Y4PfVF5M7vhmLdabsP
12800	payment	1726	1726	1874	1	1	4002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ttB1JZf5Lro447ziJQ5qawLuisFSk2K5rtbmyss1tTQugkQw
12815	payment	1726	1726	1874	1	1	4013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGKfVyXT7RKCa2mKFt1RLQi9cQAdE5rhRTAdiEqPnVsBUTzzk
12816	payment	1726	1726	1874	1	1	4014	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvS78NdWBtbfBaFiWGYBL3FPRe8AmXvYEeqUNZ7kEu2vSYd8Jh
12822	payment	1726	1726	1874	1	1	4016	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHKnJt1SsezeRUeKUvJtyu6MPFVcz2DaW2Eo2WjPqfnQn8aFPp
12823	payment	1726	1726	1874	1	1	4017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKY56KVEsV3kjjdwqW5L1ktWCds33DiRbvTzMyoT8wN2Xzfa8
12824	payment	1726	1726	1874	1	1	4018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJmc8KddX26X19R7Z6Q7xDVa52sBK6F8Hn9VJjLygHBE88wQi
12826	payment	1726	1726	1874	1	1	4020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uKfaPF1FRZxXkYKG5YEs4xwGpaBiWt3sMTrxjhyJjSDkfKok
12827	payment	1726	1726	1874	1	1	4021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURTL2hLogbkKfzXeBC3DUubimhvVR9MkfCLsdpipeX7n6PVZk
12828	payment	1726	1726	1874	1	1	4022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAigZoKrCUz7oWQFdj6DwYtnRYJaqdNh6KCJQiU6en3fKGzGJ
12705	payment	1726	1726	1874	1	1	3911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAcbqYj9TnYuBJgUmqDyHL8oSByT4MhoTr9vBR1va4ADVyFQE
12706	payment	1726	1726	1874	1	1	3912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7MY8tue6XSodzY6xCpFQt1QbPwgEjTebt1ugbNKLGZYe7zEt
12719	payment	1726	1726	2056	1	1	3925	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbb9MmfgKjPwkk3rCpSSmnDyhzsSCZn8YyBgCRKqezk3vvW4fs
12720	payment	1726	1726	1874	1	1	3926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkd46NyjAaSTTtNEKAU3tq5eEWNDSSwvcwh5Lmi2PEsVKXVSm
12727	payment	1726	1726	1874	1	1	3933	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZu8o9zvnfW593bctFG3shT4jLRGrDp77qXmVpyGL7BrdNR9z
12733	payment	1726	1726	1874	1	1	3939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrT4d1r38TByPtqsMnbtutx7VA6aek74MBtxtTsbDw8yWxpzU
12742	payment	1726	1726	1874	1	1	3946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmfkaKpXQ3pwyAX4yebbW6iV5dUgXi3ebcGu5Vprmpdw2zUZV
12743	payment	1726	1726	1874	1	1	3947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZCSFzs6SnUYq5LJzt4958L5dvREbPpEkezb51CjWix743M3A
12744	payment	1726	1726	1874	1	1	3948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoRpBaYx5qo5AQWt5YeVdRMABYZC297yAtmxL6eD5ASLtjrk9
12748	payment	1726	1726	1874	1	1	3951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdodpiKKpouXpjv5XmBN5nQ3LXVmCy456Rfo8DhkQY5VFAejXU
12757	payment	1726	1726	1874	1	1	3959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKy9mFuLXGMQJPigSHzBXK9bDzvbPWWCZetmoZTNXcoZaDY3nB
12758	payment	1726	1726	1874	1	1	3960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTxEJrac43mKDwE9umhf4kjHkeY1HAsXuBH4Fctsz44RDYUcA
12766	payment	1726	1726	1874	1	1	3968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Dz7zrBTdVsK14sPNi7LRPKYDY1VqEoj8V95StUgnRUHWMaBM
12773	payment	1726	1726	1874	1	1	3975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjr3TjtdLQsV7jf6mqLMmZmmQQJNbMqRSooxeaYemVdesYSG2T
12774	payment	1726	1726	1874	1	1	3976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzqoPAo7ZF3czKfYusa1BvFPsYKGtLg2DCAXKBA5NHcbuD9dN
12776	payment	1726	1726	1874	1	1	3978	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfWrq4Yfm5zFKrTDyZjt4heVAYiKNZNjA8AbzGuJtY22FBAxM
12778	payment	1726	1726	1874	1	1	3980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnkHGgJQTa3LsND7y3QtmdKZ4kPCNNh6NmqhTzPTt3hhyLa6Y
12781	payment	1726	1726	1874	1	1	3983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJcMK3e25d3RJvahAc8uBuctzHhxJ2ZzXktSBkiBoSbj9RLmD
12786	payment	1726	1726	1874	1	1	3988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a1RMutvTK4gSU51yan2vWpWx7kSZ2Cceh1WJTZeBnEYBfsAV
12789	payment	1726	1726	1874	1	1	3991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqbAmaRHo6dhG9BPkfrZT1REAdoKZwSB2Ht3mkJVbc5RUBCZx
12792	payment	1726	1726	1874	1	1	3994	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEL3WrHn5ucnbf24z2FT7ZeswATJR86JNRbHTkoiS8Qwpwbx62
12793	payment	1726	1726	1874	1	1	3995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnn6bSJ5c8Fis75vqnjZF7uwdJ8vni35iXHtC8KQZUaAb1N3MM
12801	payment	1726	1726	1874	1	1	4003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCLpSFSzemTjvMshCWL7GafEH67DFW2R3gVXnjjQS6yqpxk68
12829	payment	1726	1726	1874	1	1	4023	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuWXEvTeUYp4Bi2gqAbmdw7SKX1kwFCr5vLSHCMEPzKTahRCb
12830	payment	1726	1726	1874	1	1	4024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszRK4YTFmUdyXLJewRqC5sA4ZdaYAAfZf4b28EsCqjHWZ4FsX
12834	payment	1726	1726	1874	1	1	4028	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdqgeVcoLxw5mafPg4aap3WcMVdzCW4ysMN3Jb7QrwoD1Ux6q
12840	payment	1726	1726	1874	1	1	4034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNAoAjQtUuhRVyvcNKjFRR4R9VLLxSogjNWQjTFsnTtWhNLjr
12841	payment	1726	1726	1874	1	1	4035	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Etk3VY9vXjfq1yUdKYW8NA7woifVin1Fc8smbm8z7iRq9TUk
12845	payment	1726	1726	1874	1	1	4039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSAsMhmcw6FXTiop8SZ5qfKBGi1X8q4AF4isTPdqJu2UVDdRL
12848	payment	1726	1726	1874	1	1	4042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYhQDCisiMVRzGtSSgqYsj5qibhaTiwZy53fnTTki1NRFobPL
12849	payment	1726	1726	1874	1	1	4043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZ5onfot8KiNTDW5GYwo24qu3G1Zernm9FAPhksQCCmLd83j1
12853	payment	1726	1726	1874	1	1	4047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsghdGXeer8jXpuu56ynCh83SthpgTfbGU8SyV7C1Koy8WrYKe
12861	payment	1726	1726	1874	1	1	4054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrQs3uH4wgo45b9snucekLm3ohDPmEz2FP91bCpR2n9tZnjhj
12874	payment	1726	1726	1874	1	1	4065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5rtVUR5Cd9ow8pDnS5wxJmeBXHaLHkzsAbdzbx2dNMbeUYE9
12875	payment	1726	1726	1874	1	1	4066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt4cPHD5ybnkqQnm4sKjY8KZeY9scqdxrb5efaSJ7YnMywgV3j
12876	payment	1726	1726	1874	1	1	4067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhQgg33LtWBenVHVtkKZYo3Hqh3tm4LfnuGecscQRMRpFN5UB
12877	payment	1726	1726	1874	1	1	4068	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZtQXKYsHSSavXNU56ur1HMNTrjommWiqEMRKq1Gbc1WZUKX7
12879	payment	1726	1726	1874	1	1	4070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAToSRtyd5KBnrFJnxhEDSGhPaQ1iUsrwbsRN2iEcWrxkFS5UK
12707	payment	1726	1726	1874	1	1	3913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKoR39qGtqrBNh81usBsuWiD5cd22bhhDDiWiEhiGSnQDNJw1
12708	payment	1726	1726	1874	1	1	3914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSkyLtwuTo35sjsAnhDx4DqxfRGsKM3D9r6Pw7HyKXKpxkw7C
12709	payment	1726	1726	1874	1	1	3915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1sgeEd2bzbbtyvHPbGdGGjVPmqMBA3y1y7YHwyRC5baqGgvT
12710	payment	1726	1726	1874	1	1	3916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1K6ZB35YnNwK1jX3V87WKdWPtokGahjDdXZ6mzJdujS1i7oX
12711	payment	1726	1726	1874	1	1	3917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6njdGDL3A3SSe4GKWTVujKziuRJhkALB6BprVxzKQw49kytNV
12712	payment	1726	1726	1874	1	1	3918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9Yj78bjRWZ3BcfNZ6fRzz8YEE2NgQFmbH16Ri7b5SAS4jVTQ
12713	payment	1726	1726	1874	1	1	3919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmTm2EPpfYfbUTpYdgoo7kcJkEHmsvx2RehnutjLVfrBPoJNg
12714	payment	1726	1726	1874	1	1	3920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dxvS5Kc82bXZBQHQ5N1U7C8ZB4SPRsh6CYkpc53czuquMpi5
12715	payment	1726	1726	1874	1	1	3921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1k1yHqP75zqPSBxAeHwXhJVqzJJ8xJfhNjtBLx8dRSaqVnyfN
12716	payment	1726	1726	1874	1	1	3922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrVwZVfMSM2NJTdLDfAfyZdW8ThPBcvaxNJkhub1nBkFttNzq
12717	payment	1726	1726	1874	1	1	3923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfSXJykCK8cCdj4fADL8N45cKc6jHNaZjK7bhczzpS2GWVpUd
12721	payment	1726	1726	1874	1	1	3927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmSHWUxtQER1CCJBjuA52B7BPSDTfFC6TUo3JjEiKUEKXqHri
12722	payment	1726	1726	1874	1	1	3928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjALtLA2eMUMWGQvECfD77ytUtjWmiTfF5KCKaxigMGtRiknpY
12728	payment	1726	1726	2057	1	1	3934	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHkcAXa8oXS1qxcnN7kxfZk1DKLe2n938ASAsBPRo8M7KsRvH8
12729	payment	1726	1726	1874	1	1	3935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgR9aJVqqR6GgRgaLRwDMgHYU7equxQALwz18sv7zpb3fe124V
12735	payment	1555	1555	981	1	1	0	1731971723918	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZL2LcmUCzvYMjcwJhvfDVd3g7mPQZ9NpU1vWJfsfsM4iKEpkuG
12736	payment	1726	1726	1874	1	1	3941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvP5kirRiE1JS9huFz7piTVfv3ULpwQrXfwayDnXoFADcihwn
12737	payment	1726	1726	1874	1	1	3942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuwAGTfRJajub6BnWzAcytnAV8Ls1s1XFa8sYmHP3ZyfbH3ppb
12751	payment	1726	1726	1874	1	1	3953	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJt8pWnxUNNSpDmABp3fm3HG7YnjfjiMzvmnF1oaSgLHRKj7Lz
12752	payment	1726	1726	1874	1	1	3954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs53AjM1wMgFpDY4bzrc6bM4uhYgwZXCJdsEQNPNMRK2B5GK19
12753	payment	1726	1726	1874	1	1	3955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR1K9Bo5UhX22TZFn7TQny3KVBA8UwA98rWaLygSUoDVDY6sf
12754	payment	1726	1726	1874	1	1	3956	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznxSr1aD3HHJ7F1YDkGZSaZ2RxcqUmDSoZLNsNsyPnMMm5RgE
12755	payment	1726	1726	1874	1	1	3957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5WsFjyy9Bz9fHweSYQ1vfDs97uYhiAGrGsk5sudXx1bkT6uZ
12760	payment	1726	1726	1874	1	1	3962	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtKa57DZk8sT8JtKU9RP8RuzFx5vt775JBEnZsxDyCFMFhBpP
12767	payment	1726	1726	1874	1	1	3969	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJmKwu95LZzy6G4VbSDzFshEuNDP2EaWwqkcXGgKXMF8vFANY
12768	payment	1726	1726	1874	1	1	3970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNavcMNKph9svy6LY6PTeZvwzD1R4LrfaqKRnJHTKp2JYUgmD
12779	payment	1726	1726	1874	1	1	3981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAW5gCsxWxp7w7M3jTKmxgLvFq6gLDTWzs8zASmmUGmiBmZNk5
12805	payment	1726	1726	1874	1	1	4007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNiHopAC8AEJ7W3bZcLQscWLQJGkjp9FzN7YQwounpkcxEKjV
12806	payment	1726	1726	1874	1	1	4008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrRkyffTArjaPeehg3ZnRugJeejieWPsQ2E14x2erJjjfrp5d
12807	payment	1573	1573	1318	1	1	0	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1oveo8ZK11krZzvjjZy2KNVpeKRZAYo4KpPaUpgHXubqCA12
12808	payment	1726	1726	1874	1	1	4009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppgsSYUaHtwTofrLaGV91uqWKJkrFh1okrv4kXxF4hsWfWsLs
12809	payment	1726	1726	1874	1	1	4010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeff4usSfNm6JHPSu2yL9XhMhTbi6ev5QrTeRgPF26BU5VkfFV
12810	payment	1573	1573	1072	1	1	1	5777000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxaNrUDVquTpcovdYNpVtwXyc3ySgAnUs8oP8Nwn8LKCmyMec
12811	payment	1573	1573	1192	1	1	2	3897000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvfr7jS4wMu1vMugmDsH5SrfGb4eA1UGHV3ZeATg9G3fDUEET
12812	payment	1573	1573	952	1	1	3	3064000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ8CfhPEJke5iGSXaXZfZyv8oGos88Pu1YXyZ8DpVsARhRdye
12813	payment	1726	1726	1874	1	1	4011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSgNc3BsYGdd97hj6KoqGJqMNJwEUUuzxxbnZjLZdMoo3BhuF
12814	payment	1726	1726	1874	1	1	4012	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZDCJesDkEth2dy7RvRsR1xHv2hRzyommBdqvftpZ7sGQbRzT
12817	payment	1726	1726	1874	1	1	4015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSz9iSX7ctTrmTG9Q2tCkJLZFwBL9iCiCtRtGpxXbHeNZ8FoeK
12818	payment	1573	1573	1318	1	1	4	10319000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtaic3AqgHnQFV4FVCpAtJdkAEAYTGL7BZyjAq2RAkEEb6thyR
12825	payment	1726	1726	1874	1	1	4019	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1PzdhxMEXDfGhtwJReoeQg7LkwnUwpxzQrezr9U4vdxHV8cM
12833	payment	1726	1726	1874	1	1	4027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHhptiz6EtRFkPLHXkgMmc3jWYz6yFwsD8uooDS3DK13zdAT5
12837	payment	1726	1726	1874	1	1	4031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6upxYzv4DeTo4X4zoz9jXX8D9YmwnGkZYcfafpzLDVdRPqcy
12844	payment	1726	1726	1874	1	1	4038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeYXN3GckMNVAJ7AVScpqrYSQQGiucJhZDccv7dduttMUWMtL
12852	payment	1726	1726	1874	1	1	4046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziXJGadrMcERkymg66xyrMRucfzMFMUdwBw2n9yraycdkEuya
12862	payment	1726	1726	1874	1	1	4055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRcgWPMGoJ2GqGFP6CJPQgcYDAwBhGAWw2s2zrGaD9jpuwGX2
12871	payment	1726	1726	1874	1	1	4062	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq96VCJXASxb49NwgS4uT6UXqdme3NVvPZ47fbc7mWkcMAMPde
12872	payment	1726	1726	1874	1	1	4063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfhZ7KwqsJzn4TMLZkXTZt4Y547NtXrPiChqDE7QmNvAK98DH
12894	payment	1726	1726	1874	1	1	4084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQ8bJSSR841MMpgmJJAPCPq43HWTHqcvoMkKhFX74Ymqz83pY
12895	payment	1726	1726	1874	1	1	4085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVuvvb2UkkZyx91MXL1uDf1MSyPMGdvhdRC86cmas6QviMnjh
12900	payment	1726	1726	1874	1	1	4088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipwcR3tGf4XHC15bBRMfMmTog6vpK3cRiPzJx6ivT1v9neA5b
12901	payment	1726	1726	1874	1	1	4089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxHRf7cWT7sLF7jdW21QA5K3nhhfbYquKRuRPxv3jzSWq3hbZ
12905	payment	1726	1726	1874	1	1	4092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGUkv8NjMg4JT7HTozMWmHo2ftwZ27Tz4owJPLnumfqdcKAT8K
12906	payment	1726	1726	1874	1	1	4093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbkw9yyhgdVyTJnMsryXAQur94dEAHbXiSUURXGa4kH23jQ2M
12907	payment	2058	2058	2059	1	1	0	1000000	1000000	65535	E4Ym8y9D2MXY4z3cdN5DZp9r7LMkSP7E62uPwx6BMe8eaf9EQhnWo	CkpZaU1M4YRXiH4hbsXn1LmCWVM63mVUxx1SRegzsGASm7cFUpwHM
12908	payment	1769	1769	1769	1	1	26	20000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1ycbdM8Uj88y9cBsahKPZJNuugoHVSvdSNwwX74ctoA72W9h
12918	payment	1726	1726	1874	1	1	4102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGi5Pt8hwoz5QwM9cNSxn7sWCf7A1XwyGymoFGRTbovz8rUHX
12943	payment	1726	1726	1874	1	1	4125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYosiZ6pJUkjA1w3iuaG5N1HDjKNo4ejhBpe2pyWdjo5pi1Waw5
12952	payment	1726	1726	1874	1	1	4133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtsBaByoC9Lji7FkrUiSHfou8J5pPrWZtRvWywajXVNP1y4Bo8
12973	payment	1726	1726	1874	1	1	4154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9yMDzrsomvRJZBTrmHeK6X2pRH4qcAf1Rj31zxzb7qzKNiTW
12984	payment	1726	1726	1874	1	1	4161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVonPJ7u9W88j4QimyttKSTSj96wD74VT3iwHKKb7rR9VhRdUk
12985	payment	1726	1726	1874	1	1	4162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYviE3Eg9n1r6UMW9oHU7urMHBPN2RnQpJRVMBkF8gMvwsfNsS7
12994	payment	1726	1726	1874	1	1	4171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE52TbPmLv8GiiQDiWEbLH33Xi1qnYJtcny85vqeWnSW4N9yMR
12995	payment	1726	1726	1874	1	1	4172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEnXZDCvymis8vBMHKWSBQot1z2z5jS5iE9Hh4U8DZ7TkpZPF
12996	payment	1726	1726	1874	1	1	4173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhHDTi9p5LcoSSr5BQHZb42pNZVQAYX37ESC5MfwLE45xpnYB
12997	payment	1726	1726	1874	1	1	4174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsgNwDgT29nWdZyZB7ttLBJ3mSZysLQmBWauE5HEfPrDssUgc
13008	payment	1726	1726	1874	1	1	4185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXXWGbqueUqy49qDyboAEBiEnWNro3kqiuGmMo69TcxyZzyfY
13013	payment	1474	1474	1950	1	1	12	600000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPdAvgahziMCBtWD4CTkjWgNcNri8LceqasQkJyGdDGzj99bb
13014	payment	1726	1726	1874	1	1	4190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTL1i1DpCALTJXqjQVTPeQBhTgT1TeYRo8W9fmfyiMKFUBJv6u
13018	payment	1726	1726	1874	1	1	4194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy8MQU6Hgbovxxa5RuG9RA545CX1VLpwBPvnDj24vbcUmkzMq
13026	payment	1726	1726	1874	1	1	4202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGDU2odKUFkBqoY7C12aQkXFP8Wpj8Uuns5vU84YxxMLjMrT1
13032	payment	1726	1726	1874	1	1	4206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKCtNijTczGApADaAFDA77VoCdraaPSZFDM3qAeLbE3xPAS8P
13038	payment	1705	1705	994	1	1	17	54030000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpZnacWEfyyaTUP3CR3wNgLXizbQae1c3Gd9hFsh7jq545BVuRNe
13039	payment	1726	1726	1874	1	1	4210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXxEbWyqCHc1fzT14uMW9iB1pic5c13h9jthFF36GZWdjjYwn
13042	payment	1726	1726	1874	1	1	4213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nNb2hYuL5b37xr1Esa3Je5v8yWyDU8QSwZ3am49VZoytF5ni
13050	payment	1726	1726	1874	1	1	4221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHNLJm7VoX3woG9yvGeyHXuPcRUU5zSXuBqq9VDMQoaDGNUDY
13051	payment	1726	1726	1874	1	1	4222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFQvFRSw64cQTZaurkD8Ns7YtQGDxsbGGZH9XFuDsjkAptun19
12821	payment	1573	1573	952	1	1	3	0	5001000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMSFUTwyoEKRwpcye7By6PqQS1KpATmTX2LQzukWa8Z1usF62
12838	payment	1726	1726	1874	1	1	4032	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxX2iBkjQxyMjqRRwS42gXWTEzrXeUjecsJ4ErZ5u6EWLSRoV
12839	payment	1726	1726	1874	1	1	4033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Jrpz3TBUeJW94kckfYFRRJQAxNs1QCP6ZA9jDfnt68YH7aji
12843	payment	1726	1726	1874	1	1	4037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MCoGKi6xjQNxbA5NUcBa9daThwN8cBQeKvyffdtzZJShLpXS
12846	payment	1726	1726	1874	1	1	4040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjc76QgEVtkKbL4Ymwfs4zktCmq87PwQarkmbGykrxDUwxVPMK
12850	payment	1726	1726	1874	1	1	4044	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwz7ZG9ZnEbf2aDZ4TzZiPr9gPjNoxtnve7DbCA5VfgcnxFum
12858	payment	1726	1726	1874	1	1	4051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbui4YQ8QRvYN2DCGi8BjgqjebN1Jo1ne5eFc7PcYj4Re2WeSB
12859	payment	1726	1726	1874	1	1	4052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTZyC76t1UVk92V9QXDNrc5cfxjRgGKXroj7DdPmTKRTyfV1j
12860	payment	1726	1726	1874	1	1	4053	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfvNGKFhgkUwHUfmdz3pP1ifuyNQhf2N2Jd9x8Y1UujNnKwCE
12870	payment	1726	1726	1874	1	1	4061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAph5oCMxABs7R9B2VQwBG4BALDg2qPT5xfRtGuUeqMeYpzVBv
12873	payment	1726	1726	1874	1	1	4064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7j2aeW6bPfSBx9wGALLMkSRH8ZQXjms6CxzgqfAK2tex6wxQ
12878	payment	1726	1726	1874	1	1	4069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFyGHpreRS8TEDnFEngcHExvsjXk7qEHwkQC5Pw9J41wMa3FZ
12884	delegation	1939	1939	1449	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWG248wfhnN4k85zntWxLm4GZJacVrffwDiz3BmtZBoZon1do
12885	payment	1726	1726	1874	1	1	4075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1u4aLjdy4Hy1eyS57ExJSwrYbhbWGjcX5RaoSLqwUzvdDAXR
12889	payment	1726	1726	1874	1	1	4079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupi5k8tBwKjBwj2WKc4QJGVv7JZT1EGCtWQTTdoshJJysmofx
12893	payment	1726	1726	1874	1	1	4083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mnoM5rpYt8idnPVQ63nPkdZkWY8XRD8LK6GokyisDrVJTQp7
12896	payment	1726	1726	1874	1	1	4086	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYxXntyYeg55q36fQ4UFBURrNFQghToERVkfsPU45FPasiady
12897	payment	1726	1726	1874	1	1	4087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc27fp1vom5diV5256kQbmwRNSDDyf4bK2LztShgJvunsedYCd
12898	payment	1521	1521	2058	1	1	6	1586000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbcjnBHQqCJ74rwCsAr6zw5PrGBPXqZpk328cns7Wv11S5o5B
12899	payment	1769	1769	1769	1	1	24	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCpBzwY1G9KtgrQ5PfB5v5yBAxMTUEGf1hWHkP73VKStvwZLg
12902	payment	1726	1726	1874	1	1	4090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrQSroijDMJnNkf5VpuKZpKTkwmJxamjMU7RgG8Jt6KZ1L4c9
12903	payment	1726	1726	1874	1	1	4091	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQB9u7XZ88jc2Pak7BLjmbQrp5xvMz8EBE4NkWyXyK1jKbTpd
12904	payment	1769	1769	1769	1	1	25	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNMsC2pykKgJ1WV7mUz9wdjq5QjxpTUbAWrQ2FUNpDHF6aLdQ
12909	payment	1726	1726	1874	1	1	4094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Lpyd8Z1ecm74pi8kbPemTNX39SvGjdK8Zm7vE2jr4Sqd1x9T
12914	payment	1726	1726	1874	1	1	4099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotGCSeN84BT5FCWKkLKFJZUxSpvR2xgzTmDTJmSxCmXipNGkC
12925	payment	1726	1726	1874	1	1	4108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ti3gKPeRBWEiNj5q7qUfLnrfiSCFSjjHBpD8pxXkXFo3onQb
12932	payment	1726	1726	1874	1	1	4115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBD1w5WjGupNia7vxh9boG15LVMhtFEJveHh43HPQThV1KAVn
12935	payment	1726	1726	1874	1	1	4117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2e3hBMxXWcUZ7jtA41iwQX8zCPoF8TKLXoajbXAcBwzcTF5hH
12936	payment	1726	1726	1874	1	1	4118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZpgmiEBzsbcoJSZzFSqjiPncc1CuG1PenHRuZM71DsUMSdcQ
12940	payment	1726	1726	1874	1	1	4122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcryMXNbLo6Yb9qZbXqDNy7dwpH9DCEJ3kG5oi8MJL6pqqGyo6
12941	payment	1726	1726	1874	1	1	4123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSBbZvH4etgK2f3s1DMxkfpZR7jDcW24EXvF93AX3RvT7u37B
12942	payment	1726	1726	1874	1	1	4124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRrAGk1tTyaCRdzZei5gjvLZC5tpDPAELBU5vc7vTfY26LX1y
12945	payment	1726	1726	1874	1	1	4127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnELWhqMq7mEsxPthsWqopw33WTp7KHXYXZ3xHt9RoPTpLG44
12946	payment	1726	1726	1874	1	1	4128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKho4GspZFSHxDnmDv6tNN7FZjdkjnJP2yYZxVNTKZjj38LWw
12958	payment	1726	1726	1874	1	1	4139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKMw8PnaXfk7FmZwLhm3rDASXLTmtneJomgrxbNxAT9mkNhkuH
12959	payment	1726	1726	1874	1	1	4140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9zoShRKdnX8izTMRnomqxykL7xFMDoye5wzsf8Vv3Bn3R2Jhn
12963	payment	1726	1726	1874	1	1	4144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Uov2T4nrVTDQ96R8W2d71ujaKvBRs6CSEWLWDaBKdV7Jx6je
12965	payment	1726	1726	1874	1	1	4146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh13FCfwvCE55BKUP7w87x9Rp21SdDstaShmmdKF8jBFSTfZNR
12831	payment	1726	1726	1874	1	1	4025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyDpGLThs2LVAbnJWe197EnU3xi3mY1gKDhUsAH6ycTMR4tDD
12832	payment	1726	1726	1874	1	1	4026	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHBKqttZPB7j5hoPCqSB67DsfFiv6SZkoCWokoRP4tK8fRPvw
12835	payment	1726	1726	1874	1	1	4029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfA5kW5E1Xawv2oWdcuJRtRF3zRJkrJZJvZxaqDE88SvvrdB2W
12836	payment	1726	1726	1874	1	1	4030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemHwq63E87bSfd1TNAsJVVRK6CqmXZkrAkHgw1rdbibSE36Hj
12842	payment	1726	1726	1874	1	1	4036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqU6iL6AGesg1gB35k6jSrVA74RGpphMHnEnYcdMd75u42Xgn
12847	payment	1726	1726	1874	1	1	4041	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKHQxtfemnEwmgqLMvGE6ZdmmkcwbFJK6gvpbBZ2CaZaWiFS9
12851	payment	1726	1726	1874	1	1	4045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eFXJhpMEssMc8T68f9bm2zj5b7hmNiMxU1re96MwaMXcJR4z
12854	payment	1775	1775	2047	1	1	11	1000000000	1000000	65535	E4YZaD9tEbRKj8FGKxKCUFsDNb6i3XRnNmydzwLgvk5T9w8cPKjJ7	CkpYi99BMxFa2yk7cP3x2RbtKh7b9EJ1PYUxT8oe2X5nxZAx25cWd
12855	payment	1726	1726	1874	1	1	4048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzdvL6389AfmUeJ5sJaRurfbuKSPWTBVS4hgucYgmroJ97LYM
12856	payment	1726	1726	1874	1	1	4049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwMF1wZzeSdbt5HspUXYGiU43y2LkW6TWp83bB4TuW5y8xdWc
12857	payment	1726	1726	1874	1	1	4050	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXphgLUEqNWaef4EJL5efg85v9B3MSTWJyqaAyGtRzSSxzK5G
12863	payment	1726	1726	1874	1	1	4056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUwToMdomSDhrwacQcBHKDRcACf5xJB45eTM4WwY8pvgwTU8s
12864	payment	1726	1726	1874	1	1	4057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupUu4NHMvVizyegWKcYbgzFwcHSH2wX8sjkZEutvKKAaEY2Fp
12865	payment	1775	1775	2047	1	1	12	10000000	1000000	65535	E4Yq8AZjprEiQtyCYNUN9PGBLmAa8JJNRtZEXpHqYapahSTcLgc2N	CkpZTAQAxdYJ7hv5z6tXhALLVFZuihxu8jnxHSsmFWGeoMUXbvNqq
12866	payment	1775	1775	2047	1	1	13	20000000	1000000	65535	E4YX7s3Hzzve7HTDZvce2ePq1kRQYbwyuSC9kbj8C1rs4GcNa7kNe	CkpZwH3RDvJKzVdU5hcsbsZ4JrjcmV1oSS1U6BwE7jEqc1e4ZYTyK
12867	payment	1726	1726	1874	1	1	4058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3q8QpcJmYjYN6D23euCxYn9UaF59CcngLfyMNftdBkC3zj21
12868	payment	1726	1726	1874	1	1	4059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaiDsWRdRLLnBkoAZCXu4Ru64viSUKKUabsJr2dM2kZP1QU7N
12869	payment	1726	1726	1874	1	1	4060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHjUarWn1aC4kXNPofpBRYiaHQDoo7PnPeT8tjFQmGT5XzYtd
12883	payment	1726	1726	1874	1	1	4074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkp58WW6HqvzR6v7dMoeXMY4BCjw4F18obmaQpAWtAQka2qNSM
12887	payment	1726	1726	1874	1	1	4077	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQhfXzVJtPRFp5fcFuVp7QD3zV2qZFgXp5D6L9iyTQCPvht5r
12888	payment	1726	1726	1874	1	1	4078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmi6e8mmaNGSsso7Zq1qEk5ZjqbsY8jvipz7E6epbJYAvHdYK
12892	payment	1726	1726	1874	1	1	4082	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2WMChQFcLCoC1STEXGodCpJWYBzHaWSzUfEDRfTh8bEVCmcs
12915	payment	2058	2058	2059	1	1	1	200000	1000000	65535	E4YZU4qd8otUrQDK4zTRC6dViYNSRtfjVZAaQJAr3uo4HGJtnqexc	CkpYauDNb2SpnCMSiBpS9rXWCcVnGbVsZFfFBufEj9uA16tDCLjm4
12916	payment	1726	1726	1874	1	1	4100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFNQhzDce9ZPQsLTxe2Rmqd7o3JHiD9ADefWVXX5p28PBDDer
12919	payment	1726	1726	1874	1	1	4103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNV1kuXKPkJTvAoTnxNyx9Se44gqFXFTMq71fJNhUjbZ2HV5H
12920	payment	1726	1726	1874	1	1	4104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYky88nYgPnBsRnzqBLUo5z7xftaPRAyXNHsnBXJ2d42XNGxgwe
12924	payment	1726	1726	1874	1	1	4107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSueFMFfiMsaZeHrMwtFEz3DSMTyTTPj4sdCrqXLBhyDeUug3
12927	payment	1726	1726	1874	1	1	4110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTCLf4CVsYnqkzvUL5ZF7u5wBgHbfTD8knRZ29uSTd5wymnBA
12928	payment	1726	1726	1874	1	1	4111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CeEmk11DyU5P7bx9bQH6Z75ZdNp2RBKWwZxZTpAGhbyTvUXD
12929	payment	1726	1726	1874	1	1	4112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrJB9539GgntdaD1ttnf9csKKNwt1tyMWtgCx74twcsJFvb5a
12933	payment	1726	1726	1874	1	1	4116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8TWXxm7gHfR9UiTDtQrzJmur1N4gaiEseicDUKkTBnKVzqEB
12934	payment	1775	1775	2047	1	1	14	10000000	1000000	65535	E4Ys4ujyGt75F24Z44TxUVFtnz3oHHcmLA8PNAaa7SkJhf4yR5eut	CkpZTT9angWS18PTvzozQD4osrvgv9KfLkTaPj9umgCjcfurYpwCd
12949	payment	1950	1950	2027	1	1	12	130000000000	1000000	\N	E4YXduvB7pokBNnxA8QXQh3ES9b9VgRJqZpAQShZvSPt8n8HQoMKM	CkpYsjYzUV3KdejbnSymQbpdgvowbwafeGJbDVmxoPMHHvkwnt8uv
12950	payment	1726	1726	1874	1	1	4131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNotZFVgPWnsjxEHjitxNj4r4ekUvcT1waDBEoKKKCcVZA4eeR
12951	payment	1726	1726	1874	1	1	4132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGsEMrxPmFjbyD8kvbZYHtTwf4YS6UMuF6YsR9wdiGovaWQRe
12953	payment	1726	1726	1874	1	1	4134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZfmznLXfEqkYE45hLszeEkume1DxX9ymLU1BjyfienExqmSs
12954	payment	1726	1726	1874	1	1	4135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2V2Z9QVsu3Lb55wSXrvebALVq8CsHvMZF6s1NNunUvbyB3TK5
12961	payment	1726	1726	1874	1	1	4142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuSpUbo1Q5VrpUtun21S9eVwkHDXFG1vC4WCt1vx941aovPRn
12880	payment	1726	1726	1874	1	1	4071	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8fQGL4uMn4KVW9YJALes7KpBQSWesDdrfN6Yo65BQ9SY6hB8
12881	payment	1726	1726	1874	1	1	4072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxvibibZdWpNdZMDUYkSf5Kk32UvHkE6KcpWjTUgsA6gEgfG8
12882	payment	1726	1726	1874	1	1	4073	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGiu4Dw2chrcp8WPdrp3xQoaU4ncuNjv6ye3ovFyHo6MYCshs2
12886	payment	1726	1726	1874	1	1	4076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGj6E2TLrQe9t5QVyXJjwbJQe38b6VJypLEZLe4zShLqFWcCw
12890	payment	1726	1726	1874	1	1	4080	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8VxC8TMDcUhgDbYFz4F8ETiDB896f2CztxE7a1fi8qZBR97x
12891	payment	1726	1726	1874	1	1	4081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwiacn5QHtmRQtRRzvXnXmshLsH8fDpNQYP8R4CK3VJpCDDZL
12910	payment	1726	1726	1874	1	1	4095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeMaLTjn7Um2N7hpt28gsoUmszZs2PhdGqtUfZdtRNRQCiBzo
12911	payment	1726	1726	2060	1	1	4096	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZS7EyiWjm15ZvX6L16A3pFMM6MvG2vvnbo5uEN3tgvsMMHkoUU
12912	payment	1726	1726	1874	1	1	4097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTQNQPGq3QuaDnQQ4GD2CmNao9VnjuAFgFP7phLMTQJi4XivN
12913	payment	1726	1726	1874	1	1	4098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAsVWH4kPjjNo2z7K5VuoJWxcQS3KCRttrdgMYfkuu6LUmJdh
12917	payment	1726	1726	1874	1	1	4101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rfcCGZDzTWvjvaMAPrD2V4Pzeo7hwKEQNkVLVcMZbnLAP8bE
12921	payment	1726	1726	1874	1	1	4105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnL4SQgmVbMXydSkDKutVnC8EkgPP8eoLDqyB62ZHyg7XMn5P
12922	payment	1726	1726	1874	1	1	4106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFw86LxJ912939rRsG8pa1zFzcTV82bz2ajeZPayBYSjLQfiQ
12923	payment	2058	2058	2059	1	1	2	400000	1000000	65535	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpaCfyX659UH4FggLh5FYS3p1S6fzc1WcR8V3mEBcy3owC1XznTN
12926	payment	1726	1726	1874	1	1	4109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3UqtXUZgM6Qv53ftPtKpnNzo2var5q6rdCgaCLGbSkgMEkDH
12930	payment	1726	1726	1874	1	1	4113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9bbGwo1buv74vSPfpyg4wNaw6T1c5XEVAojroKiJG8QAkkPT
12931	payment	1726	1726	1874	1	1	4114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe7HTecVALtw63XpDedBHnauDeYiFfyJywEV5hTZ5jkjRrnF4t
12937	payment	1726	1726	1874	1	1	4119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMVwWZn6tpHekChQVGBB2s5eJrBS6awcypft3Z1t546ZSWaZv
12938	payment	1726	1726	1874	1	1	4120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJR23UKGy8HLZRrJxxt9H2oYgB2SS2b5dCzDgo78FDHvfA7te
12939	payment	1726	1726	1874	1	1	4121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDZz1rC3mAtHaY8dgYFGpKbxiyuCKFgb9qiseMz6g5tNXJMji
12944	payment	1726	1726	1874	1	1	4126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFFmF9VQS7w2PBJHbaFibW98G9m8e5wyjBCqbjDdMSmbtnVSA
12947	payment	1726	1726	1874	1	1	4129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLD4CDg6aGbGiV3CvuxD3t7rcVUi4djvkgA8riyabpEWb16oAk
12948	payment	1726	1726	1874	1	1	4130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4kuwu1Q8WrWt5rpsEDPPGwRhgGp5tpUFz4Gc61wf3igLcZ8K
12955	payment	1726	1726	1874	1	1	4136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qbSQR9SpJHZxoHnANRYzetGNgaXE6WCabH8NbaSscotpDH3E
12956	payment	1726	1726	1874	1	1	4137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScpTH4W4DkHwcE4itb5P5LAKxZ7te3D35sg8rBZCgnKwqyH2K
12957	payment	1726	1726	2061	1	1	4138	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoF3TT1Bke1n3q89TrNWf5Ukb81bW2kekphUZ6DBS1YYYmVaGi
12960	payment	1726	1726	1874	1	1	4141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9qvdk9Yp1NbDianEaUNpe2Rf6xkMkS4J6d9SeMMtVNDkFkgf
12964	payment	1726	1726	1874	1	1	4145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfcrWH1aDH3U5GUhjfyVNxRftYugdhptDvLnKqZNkvF49PVzV
12972	payment	1726	1726	1874	1	1	4153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGrBG7ivgbkqJcuZ11TV8JgbZeYPKA6pdc4r689irQrRTEkyX
12975	payment	1726	1726	1874	1	1	4156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8yDG4npnrqFQEjt9HMLyLFzRWriZSNG2kbdtzNqBdJ83j7493
12976	payment	1726	1726	1874	1	1	4157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzbweyLf9VrQTZWZkHTHoYB41gPYhwFpb487bfLdc5babuKnH
12977	payment	1726	1726	1874	1	1	4158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcYm1mA4cEEjgmrPrEGdUMBnhUxcNQEQvgJuCQNq5GpQzCVbD
12978	payment	641	641	1090	1	1	8	222654800000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfmiDQmk16RfQiku4Ma9372jr5aJ2j9zUstoHgaWKVNHnbFGr
12979	payment	641	641	970	1	1	9	124235600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gnmg7Bdef9QNkqoVtZjLwqLJmyLtzsGti8kZspgRHxkfE2wA
12980	payment	641	641	1336	1	1	10	418561200000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJZRUE7EXsTKAoeVdgB1R32aWkF7SwzmP3yxzxwsp9cixPeLT
12981	payment	641	641	1210	1	1	11	150238400000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfGcFyrDvF4CQLQMyDqKcbjaEcPtKw3jFqUA8pJgUMhH8pDC6
12989	payment	1726	1726	1874	1	1	4166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf3dWMJSD9D35BrNc13tScJZo7vv7DSD5N4GnUKsZQVJzNbjA
12990	payment	1726	1726	1874	1	1	4167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqDu3EHy8v2xLUCjC8HfpYcFwHYU5HWYsnaokQ23JR4rTUxaQ
12962	payment	1726	1726	1874	1	1	4143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwTwiYDPYNVriCQmjS3edYzpVtksAbkkhMRmdawEPNPvZNSi3
12967	payment	1726	1726	1874	1	1	4148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtsDhbFBwVoEpxgch9UTzX6YdKPEqzckpDpp7DjbaZi9N4PL8
12971	payment	1726	1726	1874	1	1	4152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmpdPBcukYrosMkcDiBakjbXABJQDHUABvVEuShpGarHqpB5z
12974	payment	1726	1726	1874	1	1	4155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuoyS5AnVJE6whw6qbzdandD5prVsTBvMiaVdFQK43d65yEyJ
12983	payment	1726	1726	1874	1	1	4160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAQ2EPNikarn4ZLRZ6ZhZM2zSxWnFKRugGd58hZRBmVHBTSni
12987	payment	1726	1726	2062	1	1	4164	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKZtVumggftHPsyoEhC6TUdW8vLYBCAVHGPrtTF5r4uqKk3qUz
12988	payment	1726	1726	1874	1	1	4165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtg8jq9BphLvkzBWMShUFuykRmJ3S2Voy1FFiC5ztGrAjcv1qQ
13005	payment	1726	1726	1874	1	1	4182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2Qu18PeYSwK44ViMESPeZVKKvinne362ztZic9oaXGcmnVBh
13006	payment	1726	1726	1874	1	1	4183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUehAArF3bdcfjgPDr941ASoFJfwva8sXP96AcvXgBWzsYDu5G
13007	payment	1726	1726	1874	1	1	4184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrP5fkti1oP8jT5LDcixaxuW4XECHRzjcNn29tkTSkC2QE5fQQ
13015	payment	1726	1726	1874	1	1	4191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusfRPpNF66s6d53TQyoXoFR7dAnsJyEtPiDtAE1KVnTMcYJNN
13016	payment	1726	1726	1874	1	1	4192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeuGVFoQWH7yxtogfRbwCnqjEGpGevSEPmq8iMQHoE7zZJQgS
13023	payment	1726	1726	1874	1	1	4199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZU2GopHR19rAvg7isdA2ndLPAxumJmNG32FQMPg15y8M6pLKb
13027	payment	2060	2060	1713	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8sJ7UL1WK2Jodg3aSvJrhdzSvKPnVRZ6baPEBpFKkep7pRQt
13028	payment	1726	1726	1874	1	1	4203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsh8xzSPet72TdaLiTP4hU5BatQipYD1ev8V2HhkGcB2pZSMWx
13033	payment	1726	1726	1874	1	1	4207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcgjfJtzBTaw2o6jf4u1V9GNW3ZmybEwhyhehXJHqxaSiJMhD
13040	payment	1726	1726	1874	1	1	4211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApJxH7utSTZR8tCDHzF6HS9xSKfc33HhJor5exTAbBLExFGii
13046	payment	1726	1726	1874	1	1	4217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwj6iU3iEUmgcE1yyUzmMdh6EZ6ZAujm6viP43DM4ghNcMaS5a
13053	payment	1726	1726	1874	1	1	4224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9tCdu8LuJatDUavMbpBA4GnAPXok9tCP7qMU9LCVibpvV671
13058	payment	1471	1471	1386	1	1	0	8603000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnccHNg1cKansf8ZjRWGv6LahBve2fRa3RX5Lb9MvWP4fwcXUK
13065	payment	1726	1726	1874	1	1	4232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52668V4xyU9BeYEj7pWSd6WkRHpU3g7jBgU6eiCJFBAYeaHDD
13069	payment	1508	1508	773	1	1	0	3811812300	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZoqeu5kBxocGwCat8X1qLqK1YMo9xpbNv2Nd95KLaAEe3Jcyjr
13070	payment	1726	1726	1874	1	1	4236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkEtsiv3qARjJ5ykSBL5JqWfMkpRZu9v8gzet7vfFnr7tyBC3
13071	payment	1726	1726	1874	1	1	4237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKNPtc8DRvkT5PqgZyfYEYeV3ZKfxk2HWCzh8AGhziuj5ho1z
13085	payment	1726	1726	1874	1	1	4245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4u2GC3csni9N1o6N6bMBdz2MTg7kHcSh3uyQW9SLwMS1wTN2
13086	payment	1726	1726	1874	1	1	4246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nthtvDbjbFrAbjHagdtzbGbZHne8GBagvnaqppQLgMGrsEvN
13087	payment	1726	1726	1874	1	1	4247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwZZZBg6xRsUD5CQaRsNK7YgyfYWtMTTGmqQxSkD3Yh9XZ4ZE
13088	payment	1726	1726	1874	1	1	4248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHA1NLQnCDM1y5WfGgCXpCd8jisKf1XxmR61XZ3oqZoMmMKR7
13090	payment	1726	1726	1874	1	1	4250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZje9HP8UZMp6iQP2WxtFQuzsverCPuQwuvUGfieqpiWrhJKF
13091	payment	1726	1726	1874	1	1	4251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9F36k1HMbfj4rJtoufDvWvwLzpbFSpvoLv8KHmcWrxMfW4ZS2
13092	payment	1451	1451	759	1	1	0	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZZN6prcuA7e3gJUr5Kch2A1coccUh3Dgs5w23UKqHsAyuGzx3z
13093	payment	1426	1426	1364	1	1	0	6452000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs627GxLC6YEMWoWX1c1G8p89TYXijBUo3sJuG68jwSdH52V7d
13094	payment	1426	1426	1118	1	1	1	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQmdWUCCoE8Ehyy8n5nBzEPNwGQskYCZxsgxyVN729jsJcpjp
13095	payment	1426	1426	1238	1	1	2	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweSGi6LPDvRhTKWAMx4AidXL5mXXLFoLDJ5AdcfFphdu2g9Qm
13096	payment	1426	1426	998	1	1	3	1916000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nosD3JFoFfqkNdGrj5XwhnVCB8msUqPTwMmS64WTiztVhgEo
13097	payment	1726	1726	1874	1	1	4252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDvDgVE6pvsGYW3uGEs1VEaWGsYmWBdRbcTciJ1dKHi1PZ92K
13098	payment	1726	1726	1874	1	1	4253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQKenFNzsb1P4FTiT9Z52FPjXeKt6nkoprUaMitZmzTxY95uk
13099	payment	1726	1726	1874	1	1	4254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSJjPtMxuKPMaKCGJNAwJgURp8ytiyJ2NkReFKn29KDgkfq6M
12966	payment	1726	1726	1874	1	1	4147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuarrYmCygXrGvx6RGe8KYMrXx6aitQLujo54a9dqiGF3CUZVq
12968	payment	1726	1726	1874	1	1	4149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYLzYMetcCgfwE4jBy2nP5738BmZQvdxLoBEQk1HhgQB2dVco
12969	payment	1726	1726	1874	1	1	4150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6RiowLvAJ7wrvfweVBYHFHhJ7Yw2F4PoDDNBrHxCxtU26AKA
12970	payment	1726	1726	1874	1	1	4151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QfcBenjKTkozuShatt7C6ey9Vh5MvSvkmSAyL58KMtTocZvZ
12982	payment	1726	1726	1874	1	1	4159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFua4jKiwny829VRgyx9jWzG8Zc778P7BRFnnpQg28vUGSq9U
12986	payment	1726	1726	1874	1	1	4163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6iNjs9QeR4YeGECR3rEme9CeXLgrRLJbbaA5wc3EZLnCcEjv
12999	payment	1726	1726	1874	1	1	4176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCx4xcnXwPp6NaDm8gduxbQxhQuBkjzUCsFpa4j9KarfaRZ1P
13041	payment	1726	1726	1874	1	1	4212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57S7mSo1KrtbrgoEz2mSQWErG9fMm3nbQTQLBX234fCFrGHVV
13043	payment	1726	1726	1874	1	1	4214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9MVLtutd66kpRgrvMF1BmCcB47jeSWihwneX1JgNfZUk3HDv
13044	payment	1726	1726	1874	1	1	4215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyPTLaEtEasJ9Rn95XMfFrSQ11RciY6Tmyn1MtPjH2RAbBdfx
13045	payment	1726	1726	2063	1	1	4216	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQdpc2xNyUz4vJrcbc3xGtpDYcqZUrszBmQPm5wKCoihqJmAmH
13048	payment	1726	1726	1874	1	1	4219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KbQt9vCs4kBM7iDyEKuwJ4AD3YTvmH8vWhz41L3Mm9iJVthL
13049	payment	1726	1726	1874	1	1	4220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRritVDuq7fUzeQxRNqLU2wF4S4sBtbMYTvoMpd4zjTK3iinsi
13057	payment	1726	1726	1874	1	1	4228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7WJyzk1Uw8HXGyv5BCkfHsH2SBbp6pReqYe6GkuTs3HSriHF
13066	payment	1726	1726	1874	1	1	4233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUvbrVaR9ByVN247JS99xFoUCedFU7oAxdxtbmcVsKYbKs8xb
13078	payment	1508	1508	478	1	1	5	251579611955	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZnd9fJTHNFMi8ApjVPPfmsJ7jPBgcoVtFMVuiht2th3vy67cmr
13079	delegation	1897	1897	1600	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyPEoZFMfcWaXZwRrovhmJwvgVW53fpXQD2cQdEMZKJhVro7z
13080	payment	1726	1726	1874	1	1	4240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MhKhQiu5quc4LzSBeTLtvroALPUwK15rmEBEQpbcAre33JiM
13081	payment	1726	1726	1874	1	1	4241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhwNnJ8eQWoBKqxvhN5mN5EGMvHYXYwi21RQdZzE3ciin54iu
13084	payment	1726	1726	1874	1	1	4244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQ9WU4geDgr3pPYZcjQFdXsGEbYhFPHtxaxBJWBboRd6HZ1i1
13089	payment	1726	1726	1874	1	1	4249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRSjqYGpnjDhYaZ5emJ37at4rvZ6efXTzLFJDGjffGViN9FXb
13102	payment	301	301	1474	1	1	1	710000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59ENfXgc65wThDbraBQcEYLzadaMfr1oRVwfmTvQptYm8pD5D
13103	payment	1726	1726	1874	1	1	4257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfz44zRoNQ979d13XXKXLpTYf8NJoRtbmwBvbcz3rCJYhKPWex
13107	payment	1649	1649	1017	1	1	0	1916000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DAynarASxp3XmDMECgyd1WXuAQuLWXGAJqbiiMKEArGmbjYb
13108	payment	1649	1649	1257	1	1	1	2316000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptj93srxTGNaaQ3vRvjLvh4EajpccTQvryjUaptfACJ4C8VHQ
13109	payment	1649	1649	1137	1	1	2	3432000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvyRUBevsRLhBMrjQ9akzc6cmT54NS5Z2X5WusaZveK6KHp3J
13110	payment	1649	1649	1383	1	1	3	6453000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPE33W3DNqzzedSBtP1x69tw9ma2RR7NhgnAWXqihxRb3SHwV
13115	payment	1687	1687	1866	1	1	4	9452848201646	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3zZcx9jZ7pzRPdB7WTwcxRkATbfR8sWYHL33rnfd7PyESJpg
13116	payment	1726	1726	1874	1	1	4265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYWpm3mwFBnPNtbgn5P58RR9Zn1kHspPxU8x5hcYFmBPRVDxt
13117	payment	1726	1726	1874	1	1	4266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTGhnaGTz2M6MkRjiQUKurv84aBz9Ybs6TXpzvRocXgRD5tPk
13130	payment	1726	1726	1874	1	1	4270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQfKynKVAaYXgWLgKaUetNjtK745fqh3JJyYt4uCAGTicSuNv
13136	payment	1451	1451	1046	1	1	4	4575000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZx32QrA1LEShVJiU9eivQEzRQ6SYPQaxdLVVxCn4Ur9frAyCxE
13137	payment	1726	1726	1874	1	1	4274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQvo4RUVopj9CyiSxs9ucJjpeXFeaQLEE3vm5i9rrHUmK87cZ
13142	payment	1726	1726	1874	1	1	4277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQMvrbfzn8Rc2TeLGgeb6mGuoBraLP1j9st9QXAbNyybBMXt6
13148	payment	1451	1451	926	1	1	8	2553000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZawFRnrjttFNGEJKm6YAaVDRx3jL1v4UeciU3JasLZCWRVz6Qs
13149	payment	1726	1726	1874	1	1	4281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1nEPHtJdMZgafrCZZdBBzsL4f21MyRoVzHbDvUqywGDTUdqg
13156	payment	1726	1726	1874	1	1	4288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7m85PLUytCovqQTpnXGY5Aq5qaruUfsPRAddeDRE6iUcXqTP
13159	payment	1726	1726	1874	1	1	4291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFKnBXPqFaW92XafAvnWtBBFSDFFb2Vdj1oxGjpMM69HtRNZS
12991	payment	1726	1726	1874	1	1	4168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3p9jxFdhmkJ5m5c7PLmbxDoshX9WVX7yTD2oP7RfWzdBgRGN
12992	payment	1726	1726	1874	1	1	4169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9muRm3kcmPw6LeWBnW81aQvpKYpvJ3gYNtrB7GwuuDNNourY1
12993	payment	1726	1726	1874	1	1	4170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39wdYFCC9icvd6pLzqeraWJGnJHRqdnVWW3ipryq2MrzXNk1z
12998	payment	1726	1726	1874	1	1	4175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnDx3bp87JJvw3eLJhbP6DMaoJHCETkrd56He3rPtTbyfw32a
13000	payment	1726	1726	1874	1	1	4177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRWn6MY586LUEHzrmSt3Jr4BTGMPpaxiBYtX1dxHEUmFPt2MK
13001	payment	1726	1726	1874	1	1	4178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxbdoGY3p8nk2oA6N2gC9GZrJbPsr1GXqc6ZB2d98JUPc3BY6
13002	payment	1726	1726	1874	1	1	4179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoCuccKmxMk1pb1HX7rG1Xsue4KvLHfa8cmdEs2rt4KnijNHK
13003	payment	1726	1726	1874	1	1	4180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1MN5sKQ35DBMaEJBeZp57CQ4F5M1TmrbZtzU9bB8YQBFs7Zgv
13004	payment	1726	1726	1874	1	1	4181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkv8mwwz5nbSMsaE2yojMpATbUzBnRtRkLBdaBSbAKtw3hc9tB
13009	payment	1726	1726	1874	1	1	4186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Y7xWBtgNXyWUgN5Y9T1UfVZR36aPtX3BooFCtWiLp8gCcajC
13010	payment	1726	1726	1874	1	1	4187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQddXoYWZNqXAUvzmovPRrYhNyuLHB8Xb9VoYZjZgKLsHnLXz
13011	payment	1726	1726	1874	1	1	4188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCijoDxLvHm7R3AWF5Xsw29X5FhKqY8PU8pmSgp94LNGGH1qvk
13012	payment	1726	1726	1874	1	1	4189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZev56wzG6FdaF4Pojp2w4MSvShWxniromFjxHY2T8WviHn6h8t
13017	payment	1726	1726	1874	1	1	4193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFX8AFQ1CL1W3qBHW5gKtLqFqXDgr2gkmkRMQ1E4uqBG3cuPp
13019	payment	1726	1726	1874	1	1	4195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDx6ViDuP76sy54iK25HHVT7Z4LYkRkbL2crqm3D9wtmbHvshe
13020	payment	1726	1726	1874	1	1	4196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzU7JTHZ43HYiUkJUamWHkN6Tf5SeeiBSRArdTdDvzGyzsmZZ
13021	payment	1726	1726	1874	1	1	4197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSyD2914LFKC42uoTxpQL29AkRE4C1wcYqm9zS6htE11ho5ZD
13022	payment	1726	1726	1874	1	1	4198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8UoBRuCPyuQauKzLhS3r671gdNQhrwHEZkcyZKuEcJjx8QGe
13024	payment	1726	1726	1874	1	1	4200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sdkfGSRYpezU9Uhh7p7T165LnJJJZaPRaqd3qcyZyfdtvPUn
13025	payment	1726	1726	1874	1	1	4201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNAKFtSDZnChgR8BdR34S1CzvDDxxcib2h9RSry82bkg6ZXXy
13029	payment	1705	1705	1360	1	1	14	182110000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpYzanLMNeH8vxSzUnTXUMwameWJdDNRjLHHvJ4WTvLoWiVmtaJi
13030	payment	1726	1726	1874	1	1	4204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrwSaRvjFCAVedsdrnCte6nFWKqCseRJin5cr95v4CZv3jYuJ
13031	payment	1726	1726	1874	1	1	4205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwwpCs1LNPU9dwHt3LwwMWxW7XdWBLnffnxZwjBu3GtNUoqnv
13034	payment	1705	1705	1234	1	1	15	65350000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpaKGKuNLrvZoFrScEhcSW3pn3JpdzCP3herWTuwXiyz2SjH2qU4
13035	payment	1705	1705	1114	1	1	16	96870000000	20000000	\N	E4ZRqH2DP3aVkX2Xf7W5wyxCH9HdiwQFPg85P21445xxq1qZJ3kCS	CkpZPjQexJTztVPq8FZCuqhMxye3wyJFwUzxZudqpPC4uHLsJnbym
13036	payment	1726	1726	1874	1	1	4208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbfj2kk2ctyrEuwWPRMWacwzkqjQa7FAqePfRAU3xf8qjYBdm
13037	payment	1726	1726	1874	1	1	4209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokaATqoYSh4AoeYCZBu5dfmN7XAFUsrj1JFd9WWGJB1kHDRD9
13047	payment	1726	1726	1874	1	1	4218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUqL3HXbSh57MxPdzh1kM5xYeE84Au4no7zcNcPkvLx5xf9Wd
13059	payment	1726	1726	1874	1	1	4229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdBXJFFJhmwAXAyv1UxTx3SvhPQhWxATe9AWW2882ZboHar1F
13072	payment	1508	1508	1021	1	1	1	1914284536962	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZG9sHxFy9VvPobEH6ebRpERfJ1eGngyzt4U8musmoa2uac7Zpg
13073	payment	1508	1508	1141	1	1	2	3430381488639	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZC259e7VxYcnuy1ZVMXYXC4VG9tgmCepbbqsro3tTd1YdKbKPj
13074	payment	1508	1508	1261	1	1	3	2314546745574	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpYsYkCv1zXqAEZyHcddhiNUxwTQs9uDWva5oLR7MfBSh8yXTF6N
13075	payment	1726	1726	1874	1	1	4238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTWMksB9He3Hzq8mxhP9ayeaLKwodM1VHuAsiMTq1eaDwPBRR
13083	payment	1726	1726	1874	1	1	4243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtqkqz9JqCG8qCMZDGYce1JsU9a9PWMnmaujL8FT3Vwhw5bDc
13105	payment	1726	1726	1874	1	1	4259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7cYS59ESW28PH85mjZmpEVPeperzfK2ENXbgq2VicwXUkjTK
13106	payment	1726	1726	1874	1	1	4260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbwQW7kgCsUNXr7g2eSjPCe53g4TW4Xhmy22PS6MUo8udqdV4
13112	payment	1726	1726	1874	1	1	4262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepGs1qjEHETFt2TsjbNPoPoKf5PME7kxsqQubtKhbB5iXvs8q
13113	payment	1726	1726	1874	1	1	4263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2gvmEQ1ExqmewyewZGDhGhwJ1YFpbsU7WYEG129W4a8NUm5SX
13052	payment	1726	1726	1874	1	1	4223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaL7iDdikP2furTDDyHrGLAVVzoLZD8R2vwPsSh4gnGPBcQjv
13054	payment	1726	1726	1874	1	1	4225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyBCDkyWBm1SobJ4CEWJhjPocGKUFMMnLjfZKTN939Mz3QzMN
13055	payment	1726	1726	1874	1	1	4226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxSi5GtBpQAPmayppKDm65AgfzmnArKGk5eFhXUPrK1266R86
13056	payment	1726	1726	1874	1	1	4227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJVGqN86q52EEksu4BJfZFvKjdGBumCGCq5hqH1PaRjFmBLWw
13060	payment	1471	1471	1140	1	1	1	4576000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNNdEs3SMzEVviuuKhnXZMXkvZAazD6sghZKuLxQPH2cLrMq7
13061	payment	1471	1471	1260	1	1	2	3088000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMrAbXF3zNZVjBA7jeFvB4dWwkwzjHV1c62NSXgB8KiFyg9Gp
13062	payment	1471	1471	1020	1	1	3	2554000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZStLXDSQ2o3LsQ5G6whKnFbLGXJicMfFnebpKTafjpMtFKnAM
13063	payment	1726	1726	1874	1	1	4230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCtuJ7HtMHMY6gSgHP9dFb3F3ia9QRua1ppsJuhPQTfNZww5C
13064	payment	1726	1726	1874	1	1	4231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFicsN22zn7voZBtxVYuR3vSHEzALuKUumYv5zssuvRcMSD35
13067	payment	1726	1726	1874	1	1	4234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdbXS2L3L6NAJwzt9zoxVBHdo8MWsxrRaGcU2f7EmkjcRAJqwk
13068	payment	1726	1726	1874	1	1	4235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36uAhi8vEwWwRpcZTQnG8JqbY18g4SrtCnijfVfeQRaxGPMV9
13076	payment	1508	1508	1387	1	1	4	6449690304561	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZvYJYg4dn27tfZpgg7ycPRDbBFaow2RamGau5PiHVPwoP8Kjr6
13077	payment	1726	1726	1874	1	1	4239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJBcsvxPhyhEGCAEjsvkbNuL7Xg3gH5Ssn9vp4zCtA3u5xN49
13082	payment	1726	1726	1874	1	1	4242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLmQSNsB7NfVqNRLqiDGDJ3xupw76R4C6zUBz6mrzw1EXqEPK
13100	payment	1726	1726	1874	1	1	4255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3cwLZD6yxXAGGXXkC3y7oFY4F59dgBiDaLUcPJeaybTnZK8v
13101	payment	1726	1726	1874	1	1	4256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkq1XR5yevnTh5rSkPBSFa1JHV7Jnsi2iy1QTCpXJiRLKk1WJ
13138	payment	1451	1451	1166	1	1	5	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZPD5S5NjYPnzbFgoHWAe5DtrpGAhoSxS14nYCVTFtHqttbwJX1
13139	payment	2062	2062	1713	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWk4PyrxP7QY9sdeSB2ngoHfrcfjHqW2eiht6VLNT1zsJoKqX4
13140	payment	1726	1726	1874	1	1	4275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6mmmokGJscj2bSZuLnxKGyq59132SYtg4dtqA5jPkFLtpkQ3
13141	payment	1726	1726	1874	1	1	4276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtBqFx5Vuh3HvGoLuusLxTqXvUsU8xiVh9YsE8g5W1e8yn1TR
13146	payment	1451	1451	926	1	1	7	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpYjZyTca7tHxGwNYX3fzCHNbVjtfUARSodU5Dw5pJM77XDUS8Df
13147	payment	1726	1726	1874	1	1	4280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNs2bu6gt5qXrGBTFE5iKffwX2BzTz6wKWXwSqw2tH2aTYLAw
13150	payment	1726	1726	1874	1	1	4282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY1P3KuQknukLCG1r8dgxHqw4fw1MNsnvRrW7osW8cfayQLbK
13151	payment	1726	1726	1874	1	1	4283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpxpnWVSx1zFRzWBzE1wkyPqh9PCCjjJMApgKnqmLuwrdU3DY
13161	payment	1726	1726	1874	1	1	4293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniFSs1BeF2UfQgU7hLcNsxdxxCu4YHX1k7ToiupTs9REXjJPz
13162	payment	1726	1726	1874	1	1	4294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNJBsoj4vbTzC3K7w6FmShHtbMLhK1B69jepHEtJMr3VFnDC1
13163	payment	1726	1726	1874	1	1	4295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZg92Pr8SC3hJFGudRDGEG1aKy4JFsBJW3Qbf3FVActjPaoGLq
13164	payment	1726	1726	1874	1	1	4296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8NQ4agJSSTPJAFFArM4CFtW1Dz61QPNisnkgdPS38EqAiMYr
13165	payment	1726	1726	1874	1	1	4297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZfCJMPRAtYNM2o7Gd5bZomv9A4ywmUo85b64rFvYQkaa1mSN
13166	payment	1726	1726	1874	1	1	4298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89gCSijYUK8yQXTZxu7QnWdeiNvfkEmxmBmsvqec153AWwH9d
13169	payment	1726	1726	1874	1	1	4301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAW9jtYUNTCkfz6bV6z17BWtCs9Y2go2BUvznkLFRcQb7uW9V4
13171	payment	1726	1726	1874	1	1	4303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBdzxwvQh8wN1h6oSjk7gP2Ap77zNebsYiYDtpMcjsCV5hLFp
13188	payment	1726	1726	1874	1	1	4316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVNzZQfWopBqV41ntSefp2upp8yYU4BUuyLzX7cAGeCYqi1y6
13189	payment	1726	1726	1874	1	1	4317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYceueCBfWmjtQWKGiq5qtAZ2CEM41Stx74XaUvpyHoAC33cWqu
13194	payment	1726	1726	1874	1	1	4322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFzMxjZkCGWQBZNVjwwQhbASqrNo1uDyoCgYamuR4w4X3Lr6h
13197	payment	1726	1726	1874	1	1	4325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33pfKVZYGz9zJr6wYwgbxB9nVcQyRMED1exNSuDVr5x69fUrb
13198	payment	1726	1726	1874	1	1	4326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFENx7fkGrPeE3mU4buNLja5w8nMZ8oekmenCkWT3ZB1qm4oT
13204	payment	1726	1726	1874	1	1	4332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDz7mm1qoBm7ZaxhhVj6UEJBY6YuE8T6U1efyoso6ZkTDfPMw
13104	payment	1726	1726	1874	1	1	4258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBuKeg5vAgKAQAUoNm1a7sTW8M6GUAcPAPYhTJQ9yTgKLtniL
13111	payment	1726	1726	1874	1	1	4261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GgF7knu71PndkiBswdHeQeU5avE6AHBLWcoSNiB6XAHBVBUR
13118	payment	1451	1451	1292	1	1	1	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZJdRLfF6eg76MrDaxWMeab8XjUTFmFLTnJNpjNe9S87urtNTGs
13119	payment	1726	1726	1874	1	1	4267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5kbojfXHi7eM2Uja2L2KnG8KsJNpEhsVMobiEQJDnm9HdDHo
13131	payment	1451	1451	1292	1	1	2	8601000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpYdvyvMW3aEs5frePfe2AWwyT7drXnRRBMKxLtGaeVcK6X9MxwK
13132	payment	1726	1726	1874	1	1	4271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUoVTggRXCzQxD5B59GU8H2VQhM9Q7AwwxvEBRMCopi3G4Aggc
13143	payment	1451	1451	1166	1	1	6	3087000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZ532ZBVk1crCPAE3ybcwm4yQHMBx2xoSU4LgUEmyVszB1nCqA4
13144	payment	1726	1726	1874	1	1	4278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMdJVDUxDiEcabA4nnKkzWUrtXYGjQyq2wQx8bdqLcbU5nQjY
13152	payment	1726	1726	1874	1	1	4284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh5QNVK1Vw8eLG67APBsGXWaEWCvc7vhn1pJVPoecKueQtEhJ
13153	payment	1726	1726	1874	1	1	4285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmh5B5M5Tp5koUcbbrM3gctvqSa1PF3jz1i2Jw1DE8hJwHhYi1
13168	payment	1726	1726	1874	1	1	4300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4aDYSAcGCk99akG5Bfb26a8xRP9qqy6AFzzehaE54RWy3KEX
13170	payment	1726	1726	1874	1	1	4302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4xt3WKQP8S1xayWFdxDWPzG6JBEyZUNs7Qos1XhbNH7Azfki
13172	payment	1726	1726	1874	1	1	4304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqJ3L3EmPSmtncaT8cej6Rnzd161J41rTf4LcwFvy9VzhV2aW
13173	payment	1726	1726	1874	1	1	4305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3o2XCedxSbsiLjr7M7PnU2BLxvfbL4j9WCyniYnBGTUzCYjp
13174	payment	1696	1696	938	1	1	1	2769083740000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7Kg84FjiZ4KZP1SvyrRyw9ZCeF2qTkvfxxEVDkWANDJM3fbC
13175	payment	1726	1726	1874	1	1	4306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxadDyRThnJQPgUo4wSsHYneYuExeH37Hdij4GzmfoNxSBv8h
13176	payment	1726	1726	1874	1	1	4307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFBDAdYDanJJu2PPbyHLu4Qiz7N9JLspNaLQQ98yqpX7AVuqd
13177	payment	1726	1726	1874	1	1	4308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuJUnshErKn9DPC8j51vFeKrU7nGnKnDmi1KNf5KaA5ehNb5f
13178	payment	1726	1726	1874	1	1	4309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbb7AbJaqhFEmEUKm6u4RyWcbCECpaTh7bb1JBu9vc4o2o8X5
13184	payment	1726	1726	1874	1	1	4312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRv69YJBCMJNNpu4rsDvZHe9vHnTnqwGSFkQSkQpfQwNs4FCeB
13190	payment	1726	1726	1874	1	1	4318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWPp3M9kfR1tmVEkfvVyjgpi966zDKRh8JUecMNzZEb9R56Ej
13191	payment	1726	1726	1874	1	1	4319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnHaCRfUwYky4Y3HpRZMtRdxCwTKBZLSfA4b374y8vLzC73jJ
13199	payment	1726	1726	1874	1	1	4327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxtEyyiP9FnvjX3mLNwav3zE8EFXeEG8CXP9ucA1MeXTF49DC
13206	payment	1726	1726	1874	1	1	4334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDUcKEwSorqse7yPnTiBGgMDAVTREWYcRVw2XS8ADuYBzoXXX
13209	payment	1726	1726	1874	1	1	4337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpq1L7adRuZVubJLFbgFEqiQCnhutuzFPPifgTxQ3dW5ZFbUw
13218	payment	1726	1726	1874	1	1	4346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJyvVuCGEpLGdbYHdCehcBviGLGEBjC7hTftY8xZYXEsMBXoi
13221	payment	1726	1726	1874	1	1	4349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRTgz3uBm9KJPAyNYYxEVjn9VdDkTGk3Fz9kUvDmMZk3YoKME
13222	payment	1726	1726	1874	1	1	4350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPhj7B2amqcYco7Ye316N4PQfttjiSfKXwNn1NXfphKE79sYh
13223	payment	1726	1726	1874	1	1	4351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSE8NTQ6PjPwF26Wn8WJCQy7WmBuxkNNDZgaUstPsQ3R5ksEE
13226	payment	1726	1726	1874	1	1	4354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppQEGWj9rDyFTZQpXksNPHQYk9DUwaZbLKv7NtuFUYyFNVBpS
13227	payment	1726	1726	1874	1	1	4355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyeNysuEtTjGF9KE7RDPNoss3KjwMjtn4q4i7wk6X26ee5fDic
13231	payment	1726	1726	1874	1	1	4359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KzMq24ZyPJ1pFdRqy8Q116FjZpV74vUesBMkrkkBYdeDc7Cp
13239	payment	1699	1699	1773	1	1	5	4104187299982	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJyBaH9X3DQaqu5gvZAxaKwKFEenoBT2Zg2xCyow4AqgQw3L3
13240	payment	1773	1773	182	1	1	24	71064271776	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ39iPVoYZYaTEfUiNFtrC4ZZj5CdCWDqAgZwr7cnQq49fqwnZs
13241	payment	1773	1773	702	1	1	25	47376181186	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYbMegeizvHyjBKUa8AhqZ4ksveZsyfryT7WAyfsseadhpXxmUn
13242	payment	1773	1773	927	1	1	26	540774761826	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYc3XaoV6KZKH9RedqM2z3cDAcV2iTpDnT67tssJic3FGHWxkf6
13243	payment	1773	1773	1047	1	1	27	969063739836	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYaMNuDV4gyhMT2cYkp1rb1N2EopoKw3FYw4P2niiQd8LY4j1Me
13244	payment	1773	1773	1167	1	1	28	653846615226	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpYhyyWnjdvyZMXTA35nusA2PvPE3cgtUNfqroYK2t6t6QjMaQrs
13114	payment	1726	1726	1874	1	1	4264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJS4SRBao5v9Qb5ZZRoYCGBNpUcnGA2wHrDh52kgB7eETXkH18
13120	payment	1866	1866	481	1	1	8	121715586372	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZocysyLuuNso2kWgEy97baCWDMX921dqgHTPWR8UNFWfuoZXfX
13121	payment	1866	1866	734	1	1	9	3688351080	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZCsYiWwCMATZuEkELRquSfzWLZgCuLdrU376FLeLXeQWVcUgzi
13122	payment	1866	1866	845	1	1	10	1057327315743	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYw8M87D1XTQQoe7gxTYwwgtB5vKXKDYqpGzYFr6d1AWaMpbKHr
13123	payment	1866	1866	846	1	1	11	1057327315743	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpaDUSWppFmg3uCnvjbGA1jPaXN9jwjLzVnEqBRzo5VdxVFaVLAv
13124	payment	1866	1866	936	1	1	12	978516909538	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZNCRGVgeC1afBSyMLpobuVcVvCMGc2gebgqtXhAYM9AJzBjpHY
13125	payment	1866	1866	1056	1	1	13	1753493917952	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYvAGXVzZzYMLmd4XPtT3KGhmNj6FhAL1wbTvA9GxZ3sv5RgM9X
13126	payment	1866	1866	1176	1	1	14	1183117287282	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYtgZJU9sq8mEU9cXLvMDbHjzYkzuSwrg5NXVBFb8R7ut9r4hq3
13127	payment	1866	1866	1302	1	1	15	3296861517936	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZgyG5vHHRjktNsPqapJzpk59igJjpduCJWF6MbvGsMoN4kL7dJ
13128	payment	1726	1726	1874	1	1	4268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzt6FeqFYi7CWFA7gCmq85KKWLCEi2sYnZM8AFPjVyRcdmufnD
13129	payment	1726	1726	1874	1	1	4269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBshjQqu32PtFdM3LSPCTJZiVTyyyorZuSU2KN7bBr1Ft27P7
13133	payment	1726	1726	1874	1	1	4272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFkgRYYwFq6hCwigZgPBuKPSKVm4c2WRttjUEtE4qzRxoyp6E
13134	payment	1451	1451	1046	1	1	3	1000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpYT7bkjuSdPgxZapAXQemVFccJDwV2g41B55UZnJqts13Th66eR
13135	payment	1726	1726	1874	1	1	4273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLNVuJnM1ov45eeN29wksZPWwGXD6GLCQyrfxeyrLhTeWfa3V
13145	payment	1726	1726	1874	1	1	4279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnispuXwt2vJyPg9jrMaM67xgZbz3mkL9HMMvJ4pwouLkJ3Dzv
13154	payment	1726	1726	1874	1	1	4286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27yib5okb3Cs5LxYf8TQ2dVwQgHFd8ai1t6YsaJKPmMEaBj6K
13155	payment	1726	1726	1874	1	1	4287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYanNzCyCy59BbJqx2z6DtnzyvYss7e1XrpSfQrWhziWtRNSN
13157	payment	1726	1726	1874	1	1	4289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcT2a2D9ouq6tEXuuQupBtCEypf39RmeEbGFByk5D1U7bLNGxB
13158	payment	1726	1726	1874	1	1	4290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwr1yQZYzpvvvhg1tyvPMa6SVGngpScqDVsoQXdYAJPp2417N
13179	payment	1726	1726	1874	1	1	4310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KGXhJA2AfSVGGXEWYKtf18FUAhF7g9TngT7ZYWZaNpKre93U
13185	payment	1726	1726	1874	1	1	4313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEs9RYbiHgHASveNYiH1kxovM3ZZQrmwxT14bXuCJmXyehhxP
13186	payment	1726	1726	1874	1	1	4314	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJLYEbzbKLdmoQQemgjqibKBkEt4akk1f81ZCozM66JtCY9Yu
13193	payment	1726	1726	1874	1	1	4321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDMqkUS1TpU3BMBqCdVqf7wn9ASBan15fJVA4fwT4rdruVkQZ
13200	payment	1726	1726	1874	1	1	4328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf2RSXwBGgkfCL39mw39tJT4aaRCJ5bEYtvyVWWqKv7CtXVJG
13201	payment	1726	1726	1874	1	1	4329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYRR49RymfJqQnC3XQQtqEwHJgZqy9sNYFp1Gygyra9gGZWeZ
13202	payment	1726	1726	1874	1	1	4330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmT8BiasKxrLL3FtumzPpHgsGL1UNND1QZwc1sB9oVh6mPZ4cz
13207	payment	1726	1726	1874	1	1	4335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2v4sBd1QUjcziWv6E8pXgfTuqyXZaDxiUMtpZ65ku3rtdqrRB
13212	payment	1726	1726	1874	1	1	4340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQG4yCWyCfSTfE6VMRPts6nsnUTbbgJtTBoRquh3hTPhwiPuzt
13224	payment	1726	1726	1874	1	1	4352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADXr8e4cySS399nJM2Q3rhg2jZ7woGX3L74MEquh7JFCX19N6
13225	payment	1726	1726	1874	1	1	4353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2V2ccJCsmrnmUTajqAs89Vw5KhmFuSLr51qLNt9q2MoUo3xp
13237	payment	1726	1726	1874	1	1	4364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bgNySn5xcPTjpPLFKtQgzPCXbeSX4vhQD5yS9RBetjaiQcoq
13238	payment	1726	1726	1874	1	1	4365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkapKNRzBhKGPJeVnnrWgSGRcsWZcgBwT9QtYmo8DRKyBSo5Wf
13251	payment	1726	1726	2066	1	1	4369	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXZmEs9Bev37dWEeCQJzgv1JRSsvHuCC8QTSUQp2eSxK9RTH18
13252	payment	1726	1726	2067	1	1	4370	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZikM8tp1SLLSfgj8oZdQXhZR6WMx6oThm3LP82jRXCWJv6uCty
13253	payment	1726	1726	1874	1	1	4371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXeUGEiQ9MCbusWAYiykKHJivtUi8zs99RzwULtXGKMNZX7L8n
13262	payment	1726	1726	1874	1	1	4380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPXVg2CFc27YJ1v1QTs8ZTukRhSLL586Ah89Q8mHTMgJRBcqt
13268	payment	1397	1397	1678	1	1	6741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKYeZ3u75VqLCikLsqPBWw5cihKxuWGkqHTgFMEH5pSWRRw2A
13269	payment	1726	1726	1874	1	1	4384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BzoXQWgt4vdY6S6PMC3Pp1yWGYhFsyG1eXNbVtgtuuksM8fS
13160	payment	1726	1726	1874	1	1	4292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsx61W1UUGJZuQQBBEwxxCtBDRUViMHMeipDxPw13bFFNjbie
13167	payment	1726	1726	1874	1	1	4299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWiNj1PuEsigfMxbFSQpcTev3XMJRhqvpJ1xDAvLwHxx5KBWL
13180	payment	1696	1696	1058	1	1	2	2769083740000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidyB6UjtqEMjSLN6SvbwJj9P2r5qhvY1ZvQafQwe5Gz6izx91
13181	payment	1696	1696	1178	1	1	3	4540771340000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25eDfNHtHeQGbYM19NiymZXw3qnu6gERQ2BKuBxmSNH78pQiL
13182	payment	1696	1696	1304	1	1	4	4540771340000	500000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQDqog87bBZtk4HRL3EwWEPDA4Zf7ejdH6mxfhNVX9irLJkHt
13183	payment	1726	1726	1874	1	1	4311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUJyMgyPs5Ksrhb3xkcSdjEGNmjteefRB5MGWxSSibimroigM
13187	payment	1726	1726	1874	1	1	4315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8vBbez9Yn81ZmRJjvFGFzuvSBUgeK6Cod7qwJTUNc7PeqnJ1
13192	payment	1726	1726	1874	1	1	4320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CJ4uhDThPL7VQpKgrZ1CSvqmM6PcKsnumBYEgUtgUqCiNMem
13195	payment	1726	1726	1874	1	1	4323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsefRwf5i8SZxfq5PxSd3UrDcQYnDEMQRC8zsbGsQJPY6j6Uoq
13196	payment	1726	1726	1874	1	1	4324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGmjyKVRqLhejeTSNt3LX7m3zEowby3c33Lf4iprdzwKnkvLFc
13203	payment	1726	1726	1874	1	1	4331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfh7ddtWiddX7JaNEQoe4QYCZqFkzcdMwfPPUQwYyncc4CMWKa
13210	payment	1726	1726	1874	1	1	4338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFHSKpfo2dzhLs7qDiyEZ5rcyotJ7mEWL8vMnzaQhzhZGkg4X
13213	payment	1726	1726	1874	1	1	4341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xGLDrHJWCQ3NrbnZ7ngJoAFZ2pxnA45nb2JvW3PkpqncwM2L
13214	payment	1726	1726	1874	1	1	4342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsHw2D7u92fnmh6vpkZ4aUmy8Z4CGf8H7PoTnqPVU91vYJdKH
13216	payment	1726	1726	1874	1	1	4344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCzJa9CAPonWQAh4kBTuRcfGmC5GNK7DNUN8oJmmZCZovPrUX
13217	payment	1726	1726	1874	1	1	4345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCdGQZpD6Deub9jkwPJ1DevD44pDtpN7kyS2wit1dVKPqegHj
13229	payment	1726	1726	1874	1	1	4357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7bx5Re2GsieZu4iemWj3xCkoe9whBjLBbULUAE75NMPVF68c
13230	payment	1726	1726	1874	1	1	4358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cNfB4UW9tSsGfyb5D47XA4VnM77SHZ7CmzKWH5ee5cPrYqpF
13234	delegation	131	131	1538	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoRcwfDYa4Tn7qTmXcgWs2BCorC6LTQQmfN6Uj13NkwU3YDzd
13235	payment	1726	1726	1874	1	1	4362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgxN5HXg7BBcFkuDBwZUG5ak3ywUUnaCHyUq2djUao5wBrzYe
13236	payment	1726	1726	1874	1	1	4363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzsDxMQPuWQMDiePgK6yqmpDNxWw6p3MRXAomRUmGNVsNq16s
13256	payment	1726	1726	1874	1	1	4374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyeWrHBtDPrFVGZyB9UgkhCrcEpb1hA48VFUtBNEwod17qrece
13263	payment	1726	1726	1874	1	1	4381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3rKB4GGvYQH9Y2H438682GYuwMELsKoh8LpzedbxhXcaQs2Z
13264	payment	1397	1397	1678	1	1	6739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmRwSALdsGXbicdjo9xaERD5SMHosJGrrHCnCJPxP5kPNT8vxE
13265	payment	1726	1726	1874	1	1	4382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppsstrVqe24cc9XEJJSHDn7n4YXbF6DxYfWWJUHzospaD4wSQ
13294	payment	1397	1397	1678	1	1	6753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHQCDazuuSu4Fc8GZcwjaBJD7bWcXXoYHgN9n4GFzGZHF1Hjj
13295	payment	1397	1397	1678	1	1	6754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvgasCeX5Xakf468CM4QNdsXWAn7yqSLWqT7jGUkgr77ENHdU
13296	payment	1726	1726	1874	1	1	4398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vc3RVsUQfhQu9sN4SkrpncB2jBBFPRaRCeecXCubfS9cQ5Fp
13297	payment	1726	1726	1874	1	1	4399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxF9ihV59ue4MMZwxPLGMcsdFPh9TzV8MhMFRUZDEkdoMqKRwe
13320	payment	1726	1726	1874	1	1	4411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetPtDDFbep6LMcWwANhCYHD8pYpskeYSz2MADc5qapbjjnWFX
13327	payment	1397	1397	1678	1	1	6769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1aQQnPsLRyvuRMgJ5vHMK5jvMHjvxXqDQehfnVEQWbTnn8P3
13328	payment	1397	1397	1678	1	1	6770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85nEdHSZYFCdLgNFMuweikBqhqDmJ1BAzfbkWdiYJGhHzFE2a
13329	payment	1726	1726	1874	1	1	4415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwA4rvFevrrtq7gkobq22ysSNkstLsj2ZQfvVWZTyfYQAWibmu
13330	payment	1726	1726	1874	1	1	4416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1yCDSxo7kqeqsWuBuZVmNwXRkgPXLZWHMiMTPQuZczutEQs5
13337	payment	1397	1397	1678	1	1	6774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK434op98orBfrzkYYmrFksMdnDTgATcthff1eRd1X1oYwiiho
13338	payment	1397	1397	1678	1	1	6775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMJufmVjJaYM3CYvGdQJgMmqX4HhhDUockKakboTWyqs4sXpL
13339	payment	1588	1588	2068	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LZBUMt7qp2p6PYuxoQHZgt9pR5SoGnSQxRtTm86zrK6Xrqok
13340	payment	1726	1726	1874	1	1	4420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkVuBp7vYZvMX5Rzgf51D8kqwgGkRvEyG3HGvRTe5qZqZqkJ6
13205	payment	1726	1726	1874	1	1	4333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFoRnCLnAvz8PZMeXsZp4HqUxXGzmeGJrE8MLgGtMBZ2HtMRM
13208	payment	1726	1726	1874	1	1	4336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKcUroFYQfbqyguMwnZbSCe7SnShH5yVqJUb81zAsnFvjVUB9
13211	payment	1726	1726	1874	1	1	4339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9v9gUqGFTHAdHHp9cmxn1yz7DkpZxG126E3pht7st2UPV2aY
13215	payment	1726	1726	1874	1	1	4343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fhtFwxQgq9evBDdQb7j4gZYQQwg84FhMV79EJ5kGvw6Vv1us
13219	payment	1726	1726	131	1	1	4347	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZpdNGisy3tPLmvMF3DRphB5vDNnzCCskAZwLbfrEF3EXvnZUx
13220	payment	1726	1726	1874	1	1	4348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzG7VosjPmhZjgkSh5yAmMwoxftqaXgJupi51x4ZoajiLTqn2h
13228	payment	1726	1726	1874	1	1	4356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8rc15ARXgS3Y7f2Jd6eiPXqRsfYTdGmiU91iA6pn36Vec8wj
13232	payment	1726	1726	1874	1	1	4360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkdLUcFNyjohWsaooKeqVQtwiEvjM9QbiEQ8uGAvb5XczXqAH
13233	payment	1726	1726	1874	1	1	4361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJr9zWdVcvoWf9kFVt4agt5AwKDSk1zAN8SK3ntjzNxHvJgdr
13247	payment	1268	1268	1269	1	1	2	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjMgH68f27aiGo7z9pqP2oj8iUiSYumWnWnEeV5CL2yxvSybu
13254	payment	1726	1726	1874	1	1	4372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicaEzvBTnxME6ckKVQ7QPpxcEXpFJNYv4WHNBeNnz33pByfsn
13257	payment	1726	1726	1874	1	1	4375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkF2aGStUxYqo2cSTvxUCCQgHyekcpzqVCiqosgWpweoaX6h4A
13258	payment	1726	1726	1874	1	1	4376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9SAtikFuYXFDHCPxhZUZEyea8XJTinuUujUJqRoTz8PYk7mT
13259	payment	1726	1726	1874	1	1	4377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqakZZ3i3C7JvtJC5FWY5KRVHBVmUS9Ni6aiogVv3GNj42hqU
13260	payment	1726	1726	1874	1	1	4378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLVhFQy9v8qRsN8fpTA9Dfyy9An19FLaoRsgFNmbYc2B6rTUB
13261	payment	1726	1726	1874	1	1	4379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQVooEcNjXyRkEypbmpPJB7vRau7EGP9ABUJefEyFgMfy52bx
13266	payment	1397	1397	1678	1	1	6740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmbbLUbhB4tHsh4WwMxEJoJtB8eZnbZr47HyWnVmNREPypbK4
13267	payment	1726	1726	1874	1	1	4383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqeYaWaes8BXjKknqwT6nUHsfDqkW8Vy36nypnae3BQE7hY4c
13273	payment	1397	1397	1678	1	1	6743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjn4fceEEmFJj9KLntzZquH7QqTraZY3Ve8QWyNHPcWBUmvzqb
13274	payment	1726	1726	2067	1	1	4387	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZRQCcPujzQ8FRwaYpLtSc3FDeK4aJFHPiqRBTmWegQN6frdRfZ
13275	payment	1397	1397	1678	1	1	6744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaj71fsuHLYGxTFw77oo9dNsusbUNhyTfKmgC4tV6KrDd6CeYt
13276	payment	1397	1397	1678	1	1	6745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvogmZkhcXpmQ3jpntVwWwxx35hu1HriXDwkiQY3MsLipPXCG
13277	payment	1397	1397	1678	1	1	6746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZkqPDH4wPKt5SB2K7kY3ngNPoAbU2Sa8Wi5vCAQwbp1YKs9a
13278	payment	1397	1397	1678	1	1	6747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZFbYfB3FFQYFGyBirm62z5SSBt8Qn71Pbhu1XdDmhYWQxwKW
13279	payment	1397	1397	1678	1	1	6748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoMdU8qRNqpkjqEyW7HPSWEtJsymQ5HXwQGPAK1q8ZQY2AMP6
13280	payment	1726	1726	1874	1	1	4388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSPev9HeMWUALSk6csCm6Pc42PRyxABRN1ZuoAyGt2Yz6bkNG
13281	payment	1726	1726	1874	1	1	4389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPe5yS1qdAwzUVaZc9UM96g3onVvvccrz3GrcN5rSzuWBKgrDD
13282	payment	1726	1726	1874	1	1	4390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6V8XPQFuvAWeBRK2XjY8mbFweNy6U5LkZzHkRQjK93KSzd5Wh
13283	payment	1726	1726	1874	1	1	4391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpARENyDnD7CJKJw4CZ28kEAscCr4fMeXQHRu4B4Tp2h65cgYs
13284	payment	1726	1726	1874	1	1	4392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgVJLPmuPHfKQarw3yFBoUV1iFi9MRqkByiBVXoS3Ey1eJyUG
13291	payment	1397	1397	1678	1	1	6752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwHWj1zWPtzqoRSL3oycYyR3FKVPJzP7jk1phd2p7nW7ZnrhZ
13292	payment	1726	1726	2063	1	1	4396	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYpaEEp3gg7hbHKtMgbQZKypdaJht7QunRBRx6C6qvG45RGmL2
13293	payment	1726	1726	1874	1	1	4397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9418JMUBkFXqHbf6ps93NYA6y35biJeCTDfdu8W3Y8Rw81AuD
13302	payment	1397	1397	1678	1	1	6757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRtyiemgK9io6rtq9GXnLCbgow1rPmkxZ6B8m5RnWFjhtEJTu
13303	payment	1726	1726	1874	1	1	4402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUK7WwEfQZaqezdZ751mvYcvMPnG6d77RpT8jxudompqrwwbEp
13306	payment	1397	1397	1678	1	1	6759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQSmChhJx87hwLQP1pcPN5FyNgh1LwxRAPUDSHKXUeVe28NsF
13307	payment	1397	1397	1678	1	1	6760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWttX9gDKgXMHAeyxMSHmhAsNmMpTQeKvAxvfzBYhDor3uCEt
13308	payment	1726	1726	1874	1	1	4404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiokAZhsWUjYVsn8g9iAAKDxRHHN4xuFkjMyXLeRHJKLsY68w
13245	payment	1773	1773	1293	1	1	29	1822001730132	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZDHc8utpDQv4FxQzcG9gwiwWuNYLDW5jXPidLXBt9oHW4RGZ3B
13246	payment	1268	1268	1269	1	1	1	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4WhnhVvH8MTtKxkJqo86RikHAE7rtZTDAo7PE2Cr6atMdUkgM
13248	payment	1726	1726	1874	1	1	4366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6f3evFMn6efKTpFfnfYwkkqYkfD4acwYd3UwAeDCXg6MWVSfX
13249	payment	1726	1726	2064	1	1	4367	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYd5ujcR5yFqNH3SrjfsJ5kVMaYnmBnhPKEsb45ja15qPdbPB5y
13250	payment	1726	1726	2065	1	1	4368	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcgz2eEzYReWAKufLJKGyciTafwLDZ4YujAzojT59FEu8V6rEK
13255	payment	1726	1726	1874	1	1	4373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9NXgocB7paibahDxgqBg5os18XtrAZrEJcPFdgdE2grUBJTa
13270	payment	1397	1397	1678	1	1	6742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL6BwrNFq7X4QXdDjnwFjphTi4XqYekCVnRpDQawHoNUMnnhhB
13271	payment	1726	1726	1874	1	1	4385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDHb2PiYRS5E4NwKCzeZNsJnkb4PDUQzSkPFXXPCxpTL5X7WL
13272	payment	1726	1726	1874	1	1	4386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyP7pdGD5StRVoGWhK3HXLS4McUkYzWpyhecqZc91DFnwYHQJ7
13289	payment	1397	1397	1678	1	1	6751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfDmr6ADLXc7SAYpweWLRdxRM91a9jaRVHiSeDSaCksoxGWDz
13290	payment	1726	1726	1874	1	1	4395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajg3BH9c7DQtWfi91mUqzapKFbTyiRnxHfNmTKMdVC1haDHWs
13298	payment	1397	1397	1678	1	1	6755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22jKuwZ3m12BEL75tKC729BGzoEEKyfQPQACGBhyxdoNqiE7m
13299	payment	1726	1726	1874	1	1	4400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5dUEZcqNsur78XGtCrBZkcSCmG1nAkycWNazubBKMZbBWZtc
13300	payment	1397	1397	1678	1	1	6756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LzoZ15EkMNG2FfdNCo6khkpS17hAssHjbCHE5sdrM5YL6iMC
13301	payment	1726	1726	1874	1	1	4401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqchVSDhPgWF4fAyveQyU1fnVB47QxF7Z63kKHomxo94Kdt4xP
13318	payment	1397	1397	1678	1	1	6765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXEc7RrV5UZZ5pfwDM2fcqhPJh7i7VLGSP5zJPHyMsR5ChoFG
13319	payment	1726	1726	1874	1	1	4410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbe5Zi2e32LGgvrSMWPdA4SXmDMn5njgNkGh2SvNYiygTteFAQ
13331	payment	1397	1397	1678	1	1	6771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcD93L9hj75FU6sKPNksmNMufuViQSQKLnSVgoz1ueXhRTs2W
13332	payment	1726	1726	1874	1	1	4417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QVTH8LdiMFHzjQaRtGmfYX86JJLkKLTiGiwcHNZXnFzLNV7u
13349	payment	1726	1726	1874	1	1	4425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirznsUykMG2GL7gdchRNthxzoWLskakG7DkhDgzqzufsuDjin
13368	payment	1397	1397	1678	1	1	6789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNX4TSjnbsd9xJXPgjKmdRjqJzjW5uFP7QWDUnkeYXCgi2pCcB
13369	payment	1726	1726	1874	1	1	4435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5r1mXESSyv6cS3gLq4Crwu68cg6WRq1ERWTbw1uG1KZjuKiMi
13372	payment	1397	1397	1678	1	1	6791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnFN7zqASkhKzQdnmH2gq2hZyZ7PNbWWSFkL8Q1hKvJ1KeLdJ
13373	payment	1397	1397	1678	1	1	6792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9ZJigAB9dhr2F2AqviA9mvkGYWKxTXafKJ1o4v7tBHdHodGZ
13374	payment	1397	1397	1678	1	1	6793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1116nKCWrAien3w8NvK3bdZrWNnmMGhCnEDw8nYbEHtJMJD7
13375	payment	1397	1397	1678	1	1	6794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAAPXANVXQGZz4iTNELF7cTgwp8Mn6u7wJNBx3Yveq4J2SbBn
13376	payment	1588	1588	2068	1	1	1	1000000000	1000000	\N	E4YbQnKcERdtgNgMBtTfKsAtCbUFkcaj42TesVhkJFRSLFj7gNKHz	CkpYvAj6tjztLGH3kYghhnaupBLcNT46T3rB6RgfDDxuub4UK2Dui
13377	payment	1726	1726	1874	1	1	4437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEDpNfBhEKJf6L9m458jEyWyfivTDpE5JZ62v5bFhusMMwBmc
13378	payment	1726	1726	1874	1	1	4438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3a3B321bisLGK8jyrmAkv7NEn565jL1jSoJ1PKefx26wJgUo
13379	payment	1726	1726	1874	1	1	4439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mU3NytM1XUN4y4CS8L4ibHcXzDd2cyMhtAf37532JDnaEMfZ
13380	payment	1726	1726	1874	1	1	4440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCemnDnWGuR7nWxmp6mFbmBAv9WkvtmZTAyTX8cT4FZKzoMhQh
13385	payment	1397	1397	1678	1	1	6797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4WqwCAa3ZZ38kuyRWaSrCteVdUNVq4fd3ywju6mYLRdYSKUE
13386	payment	1726	1726	1874	1	1	4443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBtKqQJBHrZMTg8cZDFrotPqiDor945AJA6bJHTAPo18JXQkL
13399	payment	1397	1397	1678	1	1	6802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS97wxNfYvbCfoiBo8etqQ9s7dHvLyaLkPCfwYMTS1fS2YnMs
13400	payment	1588	1588	1392	1	1	2	8132871000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpZTrmqU3y3Q4yqX333kpp9c1dz2azmcVJovF5NmVfVT5icYXitA
13401	payment	1588	1588	1146	1	1	3	4325611000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpYzA1UXT63Zvgfs4FwLbEmXjkGdBMxyZsfq661Ry3tysaYzQQRg
13402	payment	1588	1588	1266	1	1	4	2911662000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpYQkqZeP8Xt15ZoaVqP4ZyZuYKCFRu1voSy4uRmjW32PXSQNA4w
13403	payment	1588	1588	1026	1	1	5	2413857000000	1000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpZLNSTWoEiyf1TH693qXjV9dn5STZz4zLfeCfx4YnnNuMqcvEto
13285	payment	1397	1397	1678	1	1	6749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6DybtENQ8aR6a5QH1zHJq6n5qidkAq2WtGSEjGM2SVeYoa65
13286	payment	1397	1397	1678	1	1	6750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUT42ZCRMPEkxxnXieHLoCZ568d41EPbbRFqnpcMmSffy81CD6
13287	payment	1726	1726	1874	1	1	4393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AUdU3dQDCATEAt4MFUUtSMg7QYqXfU1Dzt6zavczQA5iw7Ff
13288	payment	1726	1726	1874	1	1	4394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcsZnMjgHmn9xALwA7jMaW4P4V7DQPXsm7fT9jZADKmFtxr1L
13304	payment	1397	1397	1678	1	1	6758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFchh5HBu1aGYu91WMHgx7JMKShSt86E4aoJR71ysPzczc6zY5
13305	payment	1726	1726	1874	1	1	4403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYENMuvN7AZRANQkXis5DV2eCjikH6PPxDTB14cvRpvos9QkcF
13310	payment	1397	1397	1678	1	1	6761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G6uEpffe1dX9tUK2aPFwdqrW8F99tBs7aDtNXXgEY3T6pPAz
13311	payment	1397	1397	1678	1	1	6762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfu9FpqAPcvip4gnrinbZLWwLUqDGxcxdnFjbH118V6VvqDaRP
13312	payment	1397	1397	1678	1	1	6763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXeppBWZny8xzMju6MigZqkc9DkcaxNhpfn4cR8qrnFSXUrAD
13313	payment	1726	1726	1874	1	1	4406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUHWcKXmj4R3UDW9XCnh2mcxrxHcEGjwJp3skwKNS49YCVSzz
13314	payment	1726	1726	1874	1	1	4407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbue5ZXJAGkkugGeLHg3AfmqJjwwVsQnBxmkkKggJMbvu7yNZV
13315	payment	1726	1726	1874	1	1	4408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgJx3vR37bDmHoSaaBMeDrKT6qik5Rv8VEdJo4aKH91tniAaL
13321	payment	1397	1397	1678	1	1	6766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zWMkDpFJwwzbaZE8ojRdS8yiC3eNrLiDwDnnyUcPgkuxSmSM
13322	payment	1397	1397	1678	1	1	6767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMzQnmNU7X8pnKXzbPHo11WUmm4nhk8vAyWQoTHNHwUBPQnBk
13323	payment	1726	1726	1874	1	1	4412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9onDaLpyzePhgTreuoZx7WUQTDDtvuaF7BJ73kDpShR8beHf
13333	payment	1397	1397	1678	1	1	6772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxW5EquNW4fbojtCUjASyYjuhyPKjprx48Mhr21q94HdU29LWG
13334	payment	1397	1397	1678	1	1	6773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LSvYqiAiDbu5heULuSeUWKwoozmwwkeP5kDrcWTQ3ydA1P7Z
13335	payment	1726	1726	1874	1	1	4418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbuYCaAT4vdLoegTtMbVs3g9sYin8APqzJ28s8Q8xMXhHQMrb
13336	payment	1726	1726	1874	1	1	4419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mk8H7JTzh2W9KjW4BW7ARbJCzCXBqZ8UGHMwQ782fAtSPemp
13344	payment	1397	1397	1678	1	1	6777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3WuSRE8A62f5hYFi5PH9Gq5vGZxUPYVr9T4K2t99DH8PxkUz
13345	payment	1397	1397	1678	1	1	6778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6d9gRokDzH2JsJViJuXRqTaKDodvEm5iA3z1CRUCRuHmkX6ih
13346	payment	1726	1726	1874	1	1	4423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9imPnqfV2TPFGarPT5wn15wASDyWXYD7zstxqL8EWZTPRRao2
13347	payment	1726	1726	1874	1	1	4424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4m2pDFKih6SspcMp5bHtg1Kw9z7f84vnuzuUDHRzVKiBQYtx
13360	payment	1397	1397	1678	1	1	6785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9FqDmEqkZs6U33CnS9wodoXoNj9j7ordTup5v9mmnfWFtw8U
13361	payment	1397	1397	1678	1	1	6786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9416gNpMWjeMwYzyQaUkme9m45JjVgY9pduwKM5dsbVg3iVu
13362	payment	1726	1726	1874	1	1	4431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGKFF9rtezmfhj7v1iA7YSwKLmiMgjsDaSAM8PhkjqYiMrB99
13363	payment	1726	1726	1874	1	1	4432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dFybt8RoTTVdycLwsSxf2BPE36vGzBCb4AnQzEahmjumkFPf
13370	payment	1397	1397	1678	1	1	6790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmumNjEduG1Tb6vhrQ7xUo9S3ucNMdj7B2BzdbyB4TWTQeoFL
13371	payment	1726	1726	1874	1	1	4436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wrxeXsBY2aCNvrrxavaxpkfNWubYTK3uLgg7orTaJAtELQMc
13387	payment	1397	1397	1678	1	1	6798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwjpd6pEy422CgPBxjNQrvadp3iFhVmbBwYvekeRzAo4H3xdd
13388	payment	1726	1726	1874	1	1	4444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aoWmJd4axMk6Nk3tVEUe3xPhMzTkKNfZ1hXP9BeYgrP6fGXm
13393	payment	1599	1599	921	1	1	0	2005440943484	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXec92zAvZwFobkuNhYY74d8BwcWHK5SPTZ8piNgYWBJVofM9a
13394	payment	1599	1599	1041	1	1	1	3593732988098	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JFrJy4KGXsRuXsTT3W8A3ZQEqafTZ2NJTMsUJnxC6BNfjPsP
13395	payment	1397	1397	1678	1	1	6801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaS9ojQ3zjw2i7CRSq2WmxuJRowkHAsChhvSUsMGUgRcoUtTqv
13396	payment	1599	1599	1161	1	1	2	2424763257268	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahhNrLrHd7Dn2Q7iMzsKAGboicjpzAfotsfpMPjELWerrJbdM
13397	payment	1599	1599	1287	1	1	3	6756818414302	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUZvtimkYBwRoKSFUkJp3WdaSXWrUDz5vEmMqdscGBJUmdiX6
13398	payment	1726	1726	1874	1	1	4447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTG724masTFV27TrRMx1jrMuEMsQQUSME8gQQcqNo9XHvJTzU
13416	payment	1397	1397	1678	1	1	6809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiFk7ZXG7Sa48Wo3iStsAxVj7Y29FHNS8vQptknpEmDoHGbfi
13309	payment	1726	1726	1874	1	1	4405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cvVy9PX8WFUa4ZmMruNwQWt7Wjenmrg8YWVTjExF6YkBXENW
13316	payment	1397	1397	1678	1	1	6764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbG9WSG3tYfgz7vpFMWgrrYc5gK2F9V1HbJG25XTo8BZPCdbLN
13317	payment	1726	1726	1874	1	1	4409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjw8cftFSSBWRSMFNuNKQwxBdiANVrrcrCtfsMbSDYg6D2dxG
13324	payment	1726	1726	1874	1	1	4413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoZNCsDbxYoQKs3adLHamr141hFkvctAZ7pEubyxzJkS96Z4k
13325	payment	1397	1397	1678	1	1	6768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikgHNRCCHaRoFZcVbHZMfEN45K6rxJac5Y58Y5E3cGbPUiFCN
13326	payment	1726	1726	1874	1	1	4414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuivghqRp4cnRX7fK1taVSVR3QjRXKyxRjEVVNg84FKNJrthzY
13358	payment	1397	1397	1678	1	1	6784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsf4SxJrDY1LF69QKuVqRkFwA6Qs93DvdykrpRDqUgMVLcFmY
13359	payment	1726	1726	1874	1	1	4430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhtmpX5SwNWZSWphTtAZeeFaXzaPR6kKMPsRPDfsDPvxoUz8u
13381	payment	1397	1397	1678	1	1	6795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrkKnnE5tkdCyzzALsPsZm7acUzkpAdRSSFDPY9qzBE2G7Twx
13382	payment	1726	1726	1874	1	1	4441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpGqido9wD9cH9uD4ZQnixjXKnPM1JpgkbccZJ4sQs96RjStw
13389	payment	1397	1397	1678	1	1	6799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBBz8F1VghbnWj2VpeyUJ5tUVwAUxPr2ayGPtCaSPcH5pmwy7
13390	payment	1397	1397	1678	1	1	6800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZUT1f4y3RrDozRoTaPaqQNjfQzJVBs7LKmDCE7vb4sEetJg9
13391	payment	1726	1726	1874	1	1	4445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1KYYvqt1Vb3DRupYRLknPPb2vhvLkf69xcXWtBaasNgAHxPC
13392	payment	1726	1726	1874	1	1	4446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpw37upEgbTM7fn9v8B747hZADVHVRHpYbdfViSx5wrM4Gid4
13406	payment	1397	1397	1678	1	1	6804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pQxveKE8DX8GkNbQErpo5BCgvX9BH8XuHbKepuw8WQD8HjUC
13407	payment	1726	1726	1874	1	1	4449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGftQbMwm5agHsKCuBBUwLqKpbJREdLQCnpWQsXyyarjhFiRy
13408	payment	1397	1397	1678	1	1	6805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7LeSarvYY2dphk35LKnYGo7pKeLDTjMV9gci7CipLPBKk53m
13409	payment	1397	1397	1678	1	1	6806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6AQahH8LsUUS1HQCvbEx49q7sX8bjWPgBjzgikG2BHHxb4nz
13410	payment	1397	1397	1678	1	1	6807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntXw46sJ62RLfwdhkRoSaHw1aUrP5UrL1U5HeD42AYGcZa9ex
13411	payment	1397	1397	1678	1	1	6808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrK7rXHStqTqvnzuayraoKECDBFRc2o8aeVpRCjbu9maXddnSB
13412	payment	1726	1726	1874	1	1	4450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCXcNJCTRrNRJrC2hPNExubQeWXR5dJbB8Dr1xXByPd6e7d57
13413	payment	1726	1726	1874	1	1	4451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDuVXNkZGA4tHXnMRuJNcj33JL7JDwqnsGQF7iqBvNkcdSMFU
13414	payment	1726	1726	1874	1	1	4452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cNCosLF4Sv869UESoFvDQbW76JuAwQTnNNeh8fHkzV5dAN3U
13415	payment	1726	1726	1874	1	1	4453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YeXsYY38FDfVoHj24Ggz7toCBrcoXnHsM9yuz7UvvjHDqQAP
13424	payment	1397	1397	1678	1	1	6813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DHh2H94HcruKRqNnHV98AtLBpDRzZkCzVKntS5DxBP1G1Bkm
13425	payment	1397	1397	1678	1	1	6814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W6CLwXxaZw8LjZz5JrpkmoPnk6kChq7zXTNCR9mFS3urGDhW
13426	payment	1726	1726	1874	1	1	4458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtU3zqJSFvtC6cprEWKWCwD13BJPMNAhidYLHeZur81Px4oZy
13427	payment	1726	1726	1874	1	1	4459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAN3gdCFsJEafzru2P8rj9x37qaJCZbZ4eSnrFz6TeY3Yu4SP
13440	payment	1397	1397	1678	1	1	6821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcWPWvJ58EKcg21cEEj4KgfMatXp6WXENRdP8gqCzS49cGUdZ
13441	payment	1726	1726	1874	1	1	4466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tRRMMcE55dz7p1QiCYejPa5k9TK1jq2i4vhx6pogDCEsx35R
13456	payment	1397	1397	1678	1	1	6829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAJD85n1djNWLngMo3VJUhqUDViFHgN8BjNqcJTHqePdHa7bq
13457	payment	1726	1726	1874	1	1	4474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDV8F8FRbNz5nesQj4DiDw9652YTdtKksnhwqQLbUfsG8pWkh
13458	payment	1397	1397	1678	1	1	6830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGhPZTc1rx1DCy7WqksvWvhoWFywrYuwVBuQ3HSrGGEHKQ2rn
13459	payment	1726	1726	1874	1	1	4475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YpmgTjxKnY999bYLrU2nreLak8x6bJMgHKerFqpRD4XSVeDa
13476	payment	1397	1397	1678	1	1	6838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj79q2MLwvhkto5RzJwbycdkspekt8JiuDuHtkD3eNnQ9NA8Xk
13477	payment	1726	1726	1874	1	1	4483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4aJMT41uchvryDXTkB5smU5zUMijidJcYYF1BbCeiQwmPkit
13482	payment	1397	1397	1678	1	1	6841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8tcew2kt9GyowSV5bct3jSCpN2kFuAEd3NJMxorMLJSeev19
13483	payment	1397	1397	1678	1	1	6842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNct8RiPd3KeKvaYmfs64guaaUhYhVGRgVncD2BF3phASujmT
13341	payment	1726	1726	1874	1	1	4421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6Rp4sA5vtquzA51hsVTGkEPjv8ouhaNPJP785EkFjRDsshMN
13342	payment	1397	1397	1678	1	1	6776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFryPmSR1KFBDZaDBVGRHJ25Yb769VQ95jtQZDqzZtTrVVsPC9
13343	payment	1726	1726	1874	1	1	4422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UvLtRzdtgvQuqrACcMbR1pdrfLj1GDUG7ZxUTKwBiAUJn6KU
13348	payment	1397	1397	1678	1	1	6779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWX9A15s1tMy7XWwpj5rDBn2ES1erfaVapQGjTrsKSsWZTSQHv
13350	payment	1397	1397	1678	1	1	6780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kVQJSb7T6Xm9E27BTMk3oTPBATRJmLSdQNy4kEPWDspGdhAw
13351	payment	1726	1726	1874	1	1	4426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRnyrEiYdDRpzZXSTTis3wgdjJefsbqarKe7Wro9NVs3fkzSH
13352	payment	1397	1397	1678	1	1	6781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTWhgeBeqa68kRkbQeEk6hbAC5nbv1nux6TuBuWtU2x51XhhW
13353	payment	1397	1397	1678	1	1	6782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisxWXZGxuh3WzGVkJqfvKfP3HjgD2Uuh7eYpkM3bC9fswLPjp
13354	payment	1397	1397	1678	1	1	6783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CsLBHwC5YRpxiP1AqLsx9iGaQg9wL9v4zxwxdvabjCFey8wc
13355	payment	1726	1726	1874	1	1	4427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDufED2Xd2J3j3L9rB9VWeMBqr6EpejbXfPRbNFhZYN2TH5CdW
13356	payment	1726	1726	1874	1	1	4428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPy3pez88WFvCjN4wsTnskx1wHyis4qiurhPZeHDZBcZXYEx9
13357	payment	1726	1726	1874	1	1	4429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMttDV33TX77ZuHdT4FZKTB1PHg1LKXsXyWbHmk3JYaWgRWir
13364	payment	1397	1397	1678	1	1	6787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCdU3PwiizpLCFWSC4WRNF7KsAXWhmNFRjAQyTMV2nhAJ3kRf
13365	payment	1726	1726	1874	1	1	4433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLR7o2Yne1CtMKMcTr8tV89uqbnbX7LUPJLFn1xCxXXARn3MJ
13366	payment	1397	1397	1678	1	1	6788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYioKuCGeAiQ8eiyhM4nmETaBrrZTHWd6NRpemsVXwYd5XzHk4U
13367	payment	1726	1726	1874	1	1	4434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uDwnT2qEAxRBTg6zrnDXac8rmJ7CrPFnbSrb2TKaPcvYZwTx
13383	payment	1397	1397	1678	1	1	6796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetEbsnrPu2ngZvpbFXPSgihFFQzwCnn32hVy5XqPGCkARQ6Bt
13384	payment	1726	1726	1874	1	1	4442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGizcDMPXonNx4BHUaiLGepbFBowf7563MUQcDQT1FvBqTFHc
13405	payment	1397	1397	1678	1	1	6803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgJu61C4UrvrhACEHcNxWHvzystyLwmQSSfUAacMw7T1DY1xt
13420	payment	1397	1397	1678	1	1	6811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCoWnDjedfU2YEh2LUUX4nYBzYkBxAmKRg2PZhDVnpsnSCf9o
13421	payment	1726	1726	1874	1	1	4456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZQbHTBvqXYxS3wwBXUp7cws1sAHXXqrjzV4vJNkR7W4aDvYN
13442	payment	1397	1397	1678	1	1	6822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcpsqZYujHTDuehqNBJz9JPHRMYSFroE2B82sxu327kmvff6t
13443	payment	1726	1726	1874	1	1	4467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqQUMQfLamNXzwfx7hk6XrdAQRue7oW8xkNkkPAKg9nnWVC1h
13464	payment	1397	1397	1678	1	1	6833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2FXQX9rG52udY5X9BmP9Bo6kqhtZrz8T7EEfzM8n1pNN9Xhg
13465	payment	1726	1726	1874	1	1	4478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs73FQC7KMC6WNhLxmkmzZqKekX76ETi3NyVmcBwQxa8of7Lsi
13474	payment	1397	1397	1678	1	1	6837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5BS8fE4tH5UFN6nSsS9Tn7TSQw7g1gnfDEwRzcrVRWq1Ev4X
13475	payment	1726	1726	1874	1	1	4482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhb9L8RDS54f8E5sfriVkJM7DySoRZszVFcEf94CRGdzoK2zYj
13488	payment	1397	1397	1678	1	1	6844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxetryYud2isHPrsyxusHbUegrHP7RpRXA4EpFQr2L8gGypnp
13489	payment	1397	1397	1678	1	1	6845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfdy58JtVi7F7iFYnp3V7rir2u38dUqjxyU7RGpaoNtwG9fF1
13490	payment	1397	1397	1678	1	1	6846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Ks4YSKdJfhqjfyzZbk8V1cxiRcqLuVKagGjCBi45am1VaqN8
13491	payment	1726	1726	1874	1	1	4489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dq4nNDmB8z1csmFiDH95EefUSv2FhtqjqWLHu7H6noWjWk18
13492	payment	1726	1726	1874	1	1	4490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkJy91mNyJhCNw5FFVsdSDTdvdV5P3k828n3FuSDttGz66Lvr
13493	payment	1726	1726	1874	1	1	4491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJSyCpRoUiZEbjwx17YLasDU98D62bchGVF4RVAW7JQP5bwBU
13498	payment	1397	1397	1678	1	1	6849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5jNYbzhbp22okd5XrdXxin2325FXhMDsKajUsp91cJLnSytS
13499	payment	1726	1726	1874	1	1	4494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXevsaGBxDV8mvr37HYmGavPsLYrFAienZq6sWZy6JkcAxCK3q
13500	payment	1397	1397	1678	1	1	6850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRC98KNDphZfehC6jw12n3X6rQ5Pk9GP78d36LnZQe1XUjzym
13501	payment	1726	1726	1874	1	1	4495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXXBtzpDJoBNi2Nx5rwH7iwWKKjKQMYxMwHxTnFa8Zm5T1oU2
13524	payment	1397	1397	1678	1	1	6862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUMnByCYqtyZ2JEDExJZ7AeRkfJUz6NLxFF8xaPZWRZkAYaR6
13404	payment	1726	1726	1874	1	1	4448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaqtCha4jd4b3s6UFPLZipJwM8RWWJE1oaN88xr7zsBRcA1id
13422	payment	1397	1397	1678	1	1	6812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVRPLzba34aLBs2CTek5Ff6hYzn2QXMXgLrRQeForLpvfMfta
13423	payment	1726	1726	1874	1	1	4457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pyWN9iuVvjkp9dPnLkCCsURkhHcjcWZYxy7YfTZoUPqnhG5P
13428	payment	1397	1397	1678	1	1	6815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY37PEdSMpVv4dyzMM7BA4eFC9VwozzHRR9RXtxbUbsd2nxJib
13429	payment	1726	1726	1874	1	1	4460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1i3Fjtd7HFf4C6rzb1UJhgF5zBiuPnXic1RVvhX9WAXtuXypM
13438	payment	1397	1397	1678	1	1	6820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRHD4RfkgsrmUj9EzXRj6N3Frk5snJQAMLMm6Pq31DhcC8edb
13439	payment	1726	1726	1874	1	1	4465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ad6MmvVQYTdiwpqV56iCAeGA99GBpDk5wzYbBaqqpAXLsL7m
13444	payment	1397	1397	1678	1	1	6823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62HAbRJMgbRu8rWA3r5DBGeRJH8JAmknq9UwipHkyw2AGWP1V
13445	payment	1726	1726	1874	1	1	4468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6sk1mA9Dwdt4oz8QJ72cxgg1KwE8RiUuT5JuXzSMXprnL9ZUH
13448	payment	1397	1397	1678	1	1	6825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGqP5TaDzULdf4LAhGYSYrv8GJ8927hkCGwmp6UfRnoQmYwSX
13449	payment	1397	1397	1678	1	1	6826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhTQViEUyPZFY9j1r1qvUnhcfi2UL398BnWDYR3ANSLZuguyc
13450	payment	1397	1397	1678	1	1	6827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz6XTyhEwHtpUcpxZSrQtu5t3AApXmCYge5nYnpvG23TuCog6K
13451	payment	1726	1726	1874	1	1	4470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz85aQz4squCJL76ch3PmjJXfPuvj3pd42fLgjkLjcxWyHNZLS
13452	payment	1726	1726	1874	1	1	4471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhyf1nkuQuiDkm47Eu3LXxeKD3YdZzscEZ6rTLqMQWdK5MD4B
13453	payment	1726	1726	1874	1	1	4472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wdPrehVV14zEh9vop7HGRZgdgteJSPz5VAmoc2vLgqCq2kyS
13454	payment	1397	1397	1678	1	1	6828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhaRGRsiuaW8PaQfxEAnx5USGsr5VzSrexbTmH7R15dhp2v5oH
13455	payment	1726	1726	1874	1	1	4473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYna88anVT1CQRY7TDHuw5auxwb9DEn2WfoJVA7Eiq83Zb2FAQq
13466	payment	1397	1397	1678	1	1	6834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxf3w9HVWAtEWciujta739oPA7fLbRSP6SoAfWjpT7EaKy9rYG
13467	payment	1397	1397	1678	1	1	6835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrySCwNfJueLcEP6EixmiDayKDoP9oX3KmXFu2eQ9VnybBZ9H7
13468	payment	1397	1397	1678	1	1	6836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBowXnxtnZBYxrLaFmj1fty9ecuQryDV7wACQianN5MFv7h8H
13469	payment	1726	1726	1874	1	1	4479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbx7diebWbrtRvS54AbcrnSbHrCeqMNnKUQSw7HJj86Qc2L6MH
13470	delegation	1750	1750	1745	1	1	18	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Sd66BfFHR6Rc81i9Yb4zBwHvKCdixgQLsG8FQfermVmiAhUh
13471	payment	1718	1718	1474	1	1	8	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffUXMxYWwf7dZVBDkRCFB39VjR5qPAj3JLicYFPN8MjArMT1H
13472	payment	1726	1726	1874	1	1	4480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUz5muwRZCHvv2dfcmkuqLPorJniVv4A44jwxxbSqyjfjvTZa
13473	payment	1726	1726	1874	1	1	4481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYJeVcqhxGfwP5pMih2r1UW8iaK1AbiQCdvCZwDYgA3aVZfWf
13478	payment	1397	1397	1678	1	1	6839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16CaSXBdJ6o2RFgJYtZ8Tpsk3xQDgKVVfExmB9XqoPTx8VN1q
13479	payment	1397	1397	1678	1	1	6840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvWcVHBzw7i5aVAps4fpez2LFx9BNDXPysrJLG564sFK8xtM2
13480	payment	1726	1726	1874	1	1	4484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1Nn5ZKaVa2TpotwA87piB1eDj9ncQnrn9pArEDD8d6raPYvx
13481	payment	1726	1726	1874	1	1	4485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm49LivWgmLKyxaSAkaobDPa6Az2iYLQLCp4kMzEQKriRiqXFp
13494	payment	1397	1397	1678	1	1	6847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykWhQbZ33XLm9B6fyHZ45if3QstS29X8HKUYmCWsb5jm7RgGC
13495	payment	1397	1397	1678	1	1	6848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cjz2wGFsaZzvfuXSm1TLZtdo1TLgfcQfBKFSgBQSVNhhXYck
13496	payment	1726	1726	1874	1	1	4492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyREJiAj3xfT1Mbb9DFVEsJFmj11cbdJiV7hnkmtpkW9cSQeU
13497	payment	1726	1726	1874	1	1	4493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRfNJ7be57iwrwdNFbinNKqAwQWEkgYpNGAZ2Ts21MipC3UHH
13502	payment	1397	1397	1678	1	1	6851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5C3KmMb1aBYEpTFJACa1idPARDS9LMtdSYThEqarjpxv4CEvW
13503	payment	1726	1726	1874	1	1	4496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3uyX5HCyzRF4P5x75r6QdCUWbVvqCdDhxekMmEapd77h8f6k
13544	payment	1397	1397	1678	1	1	6871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7mqDEh2SBRDshhZFevJ2rtc9J6EARrF8TAEoPkxCiG3QdFkf
13545	payment	1726	1726	1874	1	1	4516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9SrhcSJLriyxs2Wj2Bt7Dn7Q6xDefD1D3qKXsnJGq7Q2HSx1
13546	delegation	1750	1750	1745	1	1	21	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidw6wZdtXfqCUNg8gJCQrbBcQxM5oWoMVA77RVfDZUUR4CrVb
13417	payment	1397	1397	1678	1	1	6810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZfmSiLS7HxkSSpfDiZHA9SouVrg7wh36WKJtLaqkzUAauoLo
13418	payment	1726	1726	1874	1	1	4454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxJX1r3dj2T2iYtqZ81iKmtsQHoNKFNLYA7Ym5U2XvwoELEog
13419	payment	1726	1726	1874	1	1	4455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDEHBWN1dpqqdoYzy8tjyLyFYKTbxW2FLABYDUCqiLanv42gs
13430	payment	1397	1397	1678	1	1	6816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1M12jWByuATh5SX3PRkQghpJ8dRoPu1SMREXRpyZoLzbsdUq
13431	payment	1397	1397	1678	1	1	6817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppaZ5NMn9subRDgDkmdwPyiyMNcHct5J5QHBAdKgNZHgc7HDN
13432	payment	1397	1397	1678	1	1	6818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYme4QHrz4EaSNpqmTXRcj1rcRkLKqv9pHCnGNWSiKDy3hH2kfG
13433	payment	1397	1397	1678	1	1	6819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAnGmaLxP4Lia1c1pXZkopyQzqga3b2wo5dkQubxaPPgth7Hw
13434	payment	1726	1726	1874	1	1	4461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37ftMC65pwTCVWVwQVoF46QEv9qmTMge7Lyj4GkFiExepX9g9
13435	payment	1726	1726	1874	1	1	4462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8hCSWaRueo8rAieLx1HvcQD9f9xwU6KR6i1rHCy7NgZHcryV
13436	payment	1726	1726	1874	1	1	4463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEWCCnXFu1AnucyJGnQQhoVwyLXHYWr2qyGu5hrhba6pcTdvV
13437	payment	1726	1726	1874	1	1	4464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHdDyJAtw1B8EEDK3Gwaq9kZBampSPMvLQcZt9SpQaZ8d1oDD
13446	payment	1397	1397	1678	1	1	6824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiHBgvy1th5Z7g5UffgcqbZWF8wsngt9MxZbbvnGPdcbCp87z
13447	payment	1726	1726	1874	1	1	4469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ74NkpFiEXfjeiMof6AVcWnbAhh4cFKeYEe4YuLwonhWPduni
13460	payment	1397	1397	1678	1	1	6831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirj96tNwCuT2x8DBYz9V4JsZE7mxLJBJs9wup6Ao2a6VPmTc4
13461	payment	1726	1726	1874	1	1	4476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdDh9G19qDTkR1JrkZVVyYLD45k7oDnRSowPwzwRGrxoATZss7
13462	payment	1397	1397	1678	1	1	6832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtpmBEoJbJnTzEtGX8cv6B17XFvrNSLLC1syXrRtPzq8E7uKx
13463	payment	1726	1726	1874	1	1	4477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKPjanBqksXP1eRiEskZFDVzchNks61f5EFXr5jcMhJ9NZcGo
13486	payment	1397	1397	1678	1	1	6843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCk74ZrXBwpiRvre4imz3XkzXcs3tHpPWFcGY6ZWE74vfEouxY
13487	payment	1726	1726	1874	1	1	4488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5po2Yfb7hRnBjteaxWBx3px8U553S39gP8rpghosQK5pMmKr
13512	payment	1397	1397	1678	1	1	6856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aTDGrh24cPBjgDxAcQvKkC3Fqo3rdTz8zEYaN1XSpMCge3u5
13513	payment	1397	1397	1678	1	1	6857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYbz79S4LmzVf9Kpx4TB4JKT7NihpKP2KvHUG72rG86QHPzy2
13514	payment	1397	1397	1678	1	1	6858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFg8SD4dubTQovpWD5UmFJsv6bJLX66w4nMSKUzzSznWQ3Awp
13515	payment	1726	1726	1874	1	1	4501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRjLsVKP97KPNweuMowA2iDu5iq9CQMie6zTADSuDdXosir7H
13516	payment	1726	1726	1874	1	1	4502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ut1sCy3skpEB6jC7FrYngWQwhRFNYNCvmHNgUh5n8if1w3iN
13517	payment	1726	1726	1874	1	1	4503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMYwqHhrXcQJRUD65aqEeYiVzME4jAACuGXxSf91N2cKxGbZx
13522	payment	1397	1397	1678	1	1	6861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNorE8zyjhSBSLCQmY9G9e3RcxzNZTgsmLWASgq4gBYawYbRPj
13523	payment	1726	1726	1874	1	1	4506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5FeNxNEBS1xAqmbiMBC9yB5791zvvPAwqHwnsjdMVNGfMUsV
13537	payment	1397	1397	1678	1	1	6868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEj8BDu21hBSsp9P8ymnKcLDTDRAv7zxUZj7MEdz3zyGiy9Vh
13538	payment	1397	1397	1678	1	1	6869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6BL7iwpNFLQZ5Rn57xrCxjxXkWuwqnajLEZb74paTbc4HBBy
13539	payment	1397	1397	1678	1	1	6870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUxcX27CaKLVa3Jik8BSVsYQUSEtZRSNYaxREbVDYJAkb6ubh
13540	payment	1726	1726	1874	1	1	4513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxMEAyF2h4tXJuRQkG7eeEBgUgHJc6iLZCtTpi8KxcXrm5dDx
13541	payment	1726	1726	1874	1	1	4514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTbmvCrcfCe4pmFReotNQiszK2JCWoqsk16XXvNuVJ64wussN
13542	payment	1726	1726	1874	1	1	4515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqvBuHiFKWadgj5TdyRphZ7uv9JqaFG21ar1fGUwEr3tcL68D
13543	delegation	1750	1750	1745	1	1	20	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvuzbaQySxsPsJtvjySnKhjYCW9CxB8BgU8HPwKTX98RPyQZFX
13550	payment	1397	1397	1678	1	1	6873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnx5CuV95zCP9kbEdFUTf5XQmkMSD2MExMg9Dy7aEyEhdw8YxK
13551	delegation	1750	1750	1745	1	1	23	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqMAXNWEymqCR3dhHw7rtxqARDQF93Fca8AqxFcojnbe9Bbvz
13552	payment	1726	1726	1874	1	1	4518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57GSGVx6zfdumoaqqyXgbcenmbGMfZzrid8MdTcN7MrMotEVW
13553	payment	1726	1726	2069	1	1	4519	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNorsajo5mJ1Twg142rqzoPzTWLb5zMmuDRqttnrh8BcfgActt
13484	payment	1726	1726	1874	1	1	4486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyPuFJcx3BFqZ8nQctW8oSULnMC1Uzm9SWH22kbBjLxwmoXaa
13485	payment	1726	1726	1874	1	1	4487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkd3gsouMK7sbvnEqm79MhQv1b8jUYFvyyyXDXoVMueuLjb7iY
13504	payment	1397	1397	1678	1	1	6852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYyBeecTVmbo9kTcUcJ61NgGk4K4aMUoDMHsfhLpua3pqtZYi
13505	payment	1726	1726	1874	1	1	4497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNK5x2ziU6wriuMDbTEs8dB186tk1dkboVM75ZazcJTF4zm8U
13506	payment	1397	1397	1678	1	1	6853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotfAUS3n4XqKqREyBaUemdfB54vG8RMUcUy55Nrhd9H4KzsuM
13507	payment	1397	1397	1678	1	1	6854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8P9sGmfEmqHoMyY3AsyxhXDAhmViNGVZp9eFHU2YwcTKah3oY
13508	payment	1397	1397	1678	1	1	6855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCE4iVHbKx5Y7c7AY6UnQ1KyPFi5MV1cZtSna2wgUZbUtKhy1m
13509	payment	1726	1726	1874	1	1	4498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEGQLRpUR7W6chSZ2ny6BWUupgSbhqKYJAAzSAeEizC9DwSwD
13510	payment	1726	1726	1874	1	1	4499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobRfS2nJZxEAKjpDrR8DrTVShEZww43aWXwz1dnto3rxEco2J
13511	payment	1726	1726	1874	1	1	4500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSTDUokTceaznTqNBNpgCbLvGFfJ2SkobPDGDhwURMrEGnKLB
13518	payment	1397	1397	1678	1	1	6859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6huKj5kbuaXp2Nop7G4J34qLSXrb3Lv3chsBbvqDeCEvuq6C
13519	payment	1726	1726	1874	1	1	4504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QMbbskmVN6vD5GFHTQXPLBBsTecQQTXdDL8oNFL3H95GR2bP
13520	payment	1397	1397	1678	1	1	6860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSexAFyTL49pUNb95n8cA7KWCkqhvUdg4XfPxwTXBJn2m7HX8N
13521	payment	1726	1726	1874	1	1	4505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJh2FRFQRiLVr1rUvy9HXGn4EbQrUAnyFxHBnbCTXQbnbmhGvh
13535	payment	1397	1397	1678	1	1	6867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ7oi9bpS22PuFR4VEE9in16cooHUfVGDMFP3YnDKdxZfhMGa4
13536	payment	1726	1726	1874	1	1	4512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7T4PN2iZ2PGAwEc93gCWsjDALsGfpgSiaH9BEvKLnfPBhZzH
13558	payment	1397	1397	1678	1	1	6875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsKEVbycJxTrRMKo5AhSArgQQShVFTGyAD1MJF8DD5hTncY1K
13559	payment	1397	1397	1678	1	1	6876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvj8zEkrvVxLhnybGsHkQGT3mRAGkPLbKGgjiUMA3ueGk1vsnQ
13560	delegation	1750	1750	1745	1	1	24	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUDy6F6VY8p8Qft8qA9fkWtjLRuPdKL8ReR9CYM6zKJQqTmwR
13561	payment	1726	1726	1874	1	1	4523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvDhivwJENpxKUGngtEuGEuKeM96NG3G4YizKzjapcZkCDMqe
13562	payment	1726	1726	1874	1	1	4524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dBzwL57ouk6NmHa5vTRnCtt1paegCPNoBA3zyZCDvvxzQdep
13573	payment	1397	1397	1678	1	1	6881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXPngNhCTVaJdRKbUFBR7N58Yn1e5dd5H7CnnSz61xhx6HZLb
13574	payment	1726	1726	1874	1	1	4529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMtG3h2C4eDF8Rp8Hpq8jG9t5Kg35kV516t7huBBG6yRu2SzN
13581	payment	1397	1397	1678	1	1	6885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGxiAgNiJYdGoDB527mxvyeQaSfdxGXVQ5skBUEwSzvgjvFXt
13582	payment	1397	1397	1678	1	1	6886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBVETJc8oXdyDGc83NwEtCSZ3aok7pWPngjSujaSQP46uiVYh
13583	payment	1726	1726	1874	1	1	4533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5CNTHkNGBeuqW8wxGfk8L4a8pf4tfQbaMdaFGtDVqfYRaERQ
13584	payment	1726	1726	1874	1	1	4534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRe8kGjJdpjU1DFfhFau7BKJ7jkXdJ4BXjABv8So3CM9NHLAbE
13604	payment	1397	1397	1678	1	1	6897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwYUAKM9dmPPdvcdL8rB7vENxYRaJW6GRzW6uuRFKdiWJap8U
13605	payment	1726	1726	1874	1	1	4544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhyNh4iKsXD9onUoupMRHWjHzJRxi5uwdg7Ga5dxHP37VTH1ps
13612	payment	1397	1397	1678	1	1	6901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3v7UhiNaZoFF6j7zVAad5krtnLLaCX4FPpLmPsJb59qKunAL
13613	payment	1726	1726	1874	1	1	4548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu3HTpUqFeKwJYL3Lzt6q6Nt7EARB3RfWn2kCRXbALrhThccz
13641	payment	1397	1397	1678	1	1	6915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xJcBZwvKGEfh4FxDGb6kW1DmKdXXP5LsqAJtwaiRZbP7jqz5
13642	payment	1726	1726	1874	1	1	4562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VGcDRafrQ1LojCxxnYnrJ5Sjduy7LcjaFDfS1g5V3Bw3jdCR
13657	payment	1397	1397	1678	1	1	6923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRJjXevggDSWRTggYeLjxvvAio8vYjq8exW1DKhQRDvPn4suo
13668	payment	1397	1397	1678	1	1	6928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnqZ6em9MoEPxD52oULnjVmD6z69YdrCLSfMqSiwzMW4nYfz3
13669	payment	1726	1726	1874	1	1	4575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYB9eKnEYtwi7RXwHPD2Ly4MvWQPzw5khvAUrSotJgyAZT7ATY
13672	payment	1397	1397	1678	1	1	6930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gr9yZDSnKUXGURXw9GCMC3QPNrUjmNtwKrHCUMcrswQLpywf
13673	payment	1397	1397	1678	1	1	6931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutaLXynB6n54qJiPQcEESB2SeKEcghW3tUhDAgKiLTjfCg95X
13525	payment	1726	1726	1874	1	1	4507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfxQqzDStAXCnnpLTPLszeJo4851doxYGrpufpo3NpXTGYXYo
13526	payment	1397	1397	1678	1	1	6863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopokUzPayQGhgRLRZrbS7ZZAN3V2diLVxoJ1VAaRYJp7KdYiV
13527	payment	1397	1397	1678	1	1	6864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZ5iwZxBfgZ2xoAKinamTGFw49LmAAPHMRCENcgVVc1fK8ZMG
13528	payment	1397	1397	1678	1	1	6865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgVjavN4mV2FB7NC3EPvBwiyuFRMH2MFAHtbQ18H8ACZF4wA4
13529	delegation	1750	1750	1745	1	1	19	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPS1ZYoXgtMmYa9FUuUxGNrVw8WgCZgn62t4EAqwrdSsTJE1zH
13530	payment	1726	1726	1874	1	1	4508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYSyEf73wU2YoStyQ4tMZF8ZKLFdWAdHQqBPQ2ibnh6cLxh5N
13531	payment	1726	1726	1874	1	1	4509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZohvaVWiCtndZuudSig71XyJf3KSR4hv8Z15SsTru3pELHov
13532	payment	1726	1726	1874	1	1	4510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fSB5VhbXZosiq3yFFCz4pQ5EbfQgvCvJWJLQ54En7mpsk7cL
13533	payment	1397	1397	1678	1	1	6866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9xm2vDAX7cP5kWj88JocYRYb8bdfDNLHLTAPHZxKybJ3nUpp
13534	payment	1726	1726	1874	1	1	4511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16YdoSTA8DhdJPt5wPXmRhbEy1m8fUoKEEjJahb4xAkeuDbpw
13556	payment	1397	1397	1678	1	1	6874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpWutcDYm7TDrvS2zosT3Tyih5Cq8o2Fgpw8PvBYtNXf5agmw
13557	payment	1726	1726	1874	1	1	4522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yKa8oC91NeNgzDguyfv9BfKMppzcEAzm9Ssz2coXYiXLBqwk
13568	payment	1397	1397	1678	1	1	6879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQG9U8dCcGfUZtWYmRCVpSpStjTe9AbNYXLrDD7X5yKF4RjBPG
13569	payment	1397	1397	1678	1	1	6880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpSXWcuhMMbrYj5LPNemSmZGVWW6UBbcesqxSiFB5ZT6b9L4f
13570	payment	1726	1726	1874	1	1	4527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjfKF8Q1MrPYqpFX1BvmtZG8VpfGxiWJCGMzyM8FQaKKdX7gw
13571	payment	1726	1726	1874	1	1	4528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEBBvJbQbEf5V1SscrPpbJegvpJFYwuiamUmR5Fjvt4DQ4f1G
13572	delegation	1750	1750	1745	1	1	26	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURVzgnjUfXrYv3m7hkcX1g4T7JZv3QmrALUVpbBfmE4jHRkZB
13575	payment	1397	1397	1678	1	1	6882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8wqXJ4W1hKJ9zEct7CoxX8eprw7ZBmbjhVprdBeSVLgTSso6
13576	payment	1397	1397	1678	1	1	6883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYooDasN5adDAKMrbyHHWDbosWE6Nz7yYgKZVo8s3aPa5iKcsVC
13577	payment	1726	1726	1874	1	1	4530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQFCmAgXABemfNKQzDszFtgT5yobabZPVgPkswqab7ZJqJwLz
13578	payment	1726	1726	1874	1	1	4531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BNny3v5o9GdhdVktVSYjxwYKTHhCiot1ZXw2J7wkZRU3qHtX
13579	payment	1397	1397	1678	1	1	6884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCMnZhgiykGKWqsamP7wQzdSB75P2UGmhZfrLTxdJjYT5ar2w
13580	payment	1726	1726	1874	1	1	4532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTfiC17LioKgBAjo871cGTiysY5TEVTP1EVRgYPN9J8G6nkML
13595	payment	1397	1397	1678	1	1	6892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeN7kZXpE42P9KdsGCxeLjx2TGJYcuxmFvtndZT6Hq8WyispJA
13600	payment	1397	1397	1678	1	1	6895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAY6sAKfritoN4GAV5WstC2DdUENfwsK2cQGZwpGvHMWEixNT
13601	payment	1726	1726	1874	1	1	4542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfzi1HWUWmB49vHjJDzMMnb9FrCRJkvRT7JheSFbAFM5L47DG
13602	payment	1397	1397	1678	1	1	6896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6BPajw8MnLWst5UvnMBg9GbhVXkAeZs8sU97ZGouXaKyikqJS
13603	payment	1726	1726	1874	1	1	4543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6MYCHi8q1S95yzmbqcXWTdEUtFVEMMZT3Qj3U2VqVoRC44ry
13614	payment	1397	1397	1678	1	1	6902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGQgpL7r4uVwMUwCHhHgPKS5s6rKEAP5KmVbs31U4zixTJ9gB
13615	payment	1397	1397	1678	1	1	6903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YSi5A9A7dh7BDWHic9GaSV6Q68i3dSJKqPey2dFf9uKDET3g
13616	payment	1726	1726	1874	1	1	4549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJbbKx5FJu2YRgb8VRyteKg3Fgs7Y54a4ZBRmZaV68kNkEEhD
13617	payment	1726	1726	1874	1	1	4550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DW2qoRHYSeog5ZRMgUmFs5K4vpVQSg8aUwTKiifozJwzHT2Q
13620	payment	1397	1397	1678	1	1	6905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr591myUex6eaxwU7sckuWo1LcoBZtydMQg14cc1uVvCndxTBA
13621	payment	1397	1397	1678	1	1	6906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSpsLjJ5YTtTyZsG5ebmt9r2HCgSWKUEL3etDFzLL4xVSvLLA
13622	payment	1397	1397	1678	1	1	6907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNUXgz6CbVZx9AHT3oC3VcSsbPeB3gzDiVTtMWSbWwrSvwyT1
13623	payment	1726	1726	1874	1	1	4552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjPa8mFcDbKLmL92DDaeUvTpAQ9ApYhRDCFuvgyc6PxiJAQQ9
13624	payment	1726	1726	1874	1	1	4553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkpAyKqWartbRkGLYhhnygcBWowKfFrtvqdqes9nBZcsKsvrh
13625	payment	1726	1726	1874	1	1	4554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLX3198aXYhmpRtTm4m6RPb9boYjDYByoraQwKaQ7vT7m2CnY8
13547	payment	1397	1397	1678	1	1	6872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwaFDpBkKR4guKKXv88PrR37E4tskz1ssuD4d22e4gbCQNws6
13548	payment	1726	1726	1874	1	1	4517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXbrNcHf52w4eAxosUSqpTbwTMzG57vqLCryEDZaJK7Bq5Y5Y
13549	delegation	1750	1750	1745	1	1	22	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1hYxYt1SNbQuSxGA3txF9DxwNfaxqe4mT4bFHtRxLKpLMw3v
13566	payment	1397	1397	1678	1	1	6878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoef7MkEHmftjubuVnspdcNKQr7jCe599XpBSEeCpmnMS6BNJP
13567	payment	1726	1726	1874	1	1	4526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yCB3HLHsN7ySPXV61LX1B4721PHprJ8JtsgJep9b5CUG7e9M
13589	payment	1397	1397	1678	1	1	6889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3sjNSuRWwfo3noaMGsyVaxypAbezCAwUFPv53iueERad1DNG
13590	payment	1726	1726	1874	1	1	4537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyMvrCZZjGrAzUNzL6VtWaoeRmu5Y6R2aMSryNNc3yWUijVKJ
13591	payment	1397	1397	1678	1	1	6890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd57Z2kZtauGjez87t4eiVFM4A1RZsXPJFuXtGgqCAwVHsuyYM
13592	payment	1726	1726	1874	1	1	4538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZka8GBGpV54axZYMs2TKs9qTHq1s3S6JpvndRPTp86m4Tji6h1
13596	payment	1397	1397	1678	1	1	6893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLnBw2pj9AEK68mZkrHKR39qDH97bcoJ21oTzGfrxv3Hrt7fx
13597	payment	1397	1397	1678	1	1	6894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRodtTVuvwGwDcFojxce47Bsym2V2ujFU9cd2ifgDwx2mKN8fo
13598	payment	1726	1726	1874	1	1	4540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSvoCQX1BHJtEstHoBXFsbp17Fjna459UQYorTPspA3syujKvr
13599	payment	1726	1726	1874	1	1	4541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6rHydM2p2bNX1F8ox2FJSTfZSMEnVfb4V2P5B6oBncQRZ4iE
13631	payment	1397	1397	1678	1	1	6910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86iT7aiV33X6CgKTKuJyaFD6zV1TsEwJ7vGoBWCcwRsv96Yeu
13632	payment	1397	1397	1678	1	1	6911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkwb2rYwTmgszb8q8BdmoDykjvEcWqphUdATx3gGFsHWgXYcw
13633	payment	1726	1726	1874	1	1	4557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWZx4fGvMprEZnxdPTUe3AdBHWoWY3CNFjLBUEqrP1UeYdTy2
13634	payment	1726	1726	1874	1	1	4558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSL35uL5WqzAXXi5gPhke5nX2KsGq78yoxK5xRJ1efEHV7m9c
13635	payment	1397	1397	1678	1	1	6912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9oMJSic6iE66BggxKe5Rs72uGg1GfP7fEZ9s5c9NS2Lh6DYh
13636	payment	1397	1397	1678	1	1	6913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrwSd7KsiyidGRvLMf5UKD3UJY8VvCUN27trS4R3Qr1YVdw9h
13637	payment	1397	1397	1678	1	1	6914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjeVF5rqG3556CkKBFYzKktRjBjXPc6Dv3d1uv8eaBHLyKfWt2
13638	payment	1726	1726	1874	1	1	4559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEEB1HkRfcWBqXj2SuDJaG5GtGPAmFTKgTaizpSUGhEkMUmNtk
13639	payment	1726	1726	1874	1	1	4560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7YAHvvNhn1yhhq4FWW8zWYLZaa1JnQVyhSMwNtPRqLKxbLZD
13640	payment	1726	1726	1874	1	1	4561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAm4gQBAc8R8d9RcLwUYcdzrNP3TEMzaSAJxsCGWR2wig1kGPB
13666	payment	1397	1397	1678	1	1	6927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWXrd1y3Q5Ah56Eo36ojzYj9K3UzdyHYhMz3XGjYBq1ZUn3pH5
13667	payment	1726	1726	1874	1	1	4574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj2nTecEutk3VykNysBA1ZCTNzVRVGi5cKvZjrc7pB7uhxweK
13684	payment	1726	1726	1874	1	1	4579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6aTFT5gTG4ifTgBFqfCQZu4fT6FkxDJLrrKMn7TPGeX1eAoS2
13685	payment	1726	1726	1874	1	1	4580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZ7erS3ErqBdadUCzQiJbA1DkKxnBgJRQvYPgE9xLFEA3GzhN
13686	payment	1726	1726	1874	1	1	4581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ybKM87iAybZEqCtfok93wXyLyA5M6enxgy2dHvHrbYrNrVZH
13687	payment	1726	1726	1874	1	1	4582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTmUgnr1yKWgAXwg6PgYag8nHYYri1MeKXkFj1QqigZAuVYN2
13688	payment	1726	1726	1874	1	1	4583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VKwHt9ojQE1b5s69yX6PW1kffn7hEtJ25yspsxW3XjS8wj5E
13689	payment	1726	1726	1874	1	1	4584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWk4zCvffc5Re1aeMjovigwRjdEaj1tE9D7det5CgLhUfsZH5v
13690	payment	1397	1397	1678	1	1	6938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobevW44ZSE5kRpHWkjuywh52f7upGj58aDPkB3HxTzBAJH5fZ
13691	payment	1397	1397	1678	1	1	6939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdptGStPMsXqSmH5cK7xymJ4HwBMubBPUEFULssq8rAhaZLfG
13692	payment	1708	1708	1019	1	1	0	1948895880939	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtE7zeVsmRXczoBDxFWvrFuYvvf8gSsuS5o9FJTmqj5BoEUZe
13693	payment	1708	1708	1139	1	1	1	3492404720511	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkg9C5t4JWoZKgkTAdzyCaParLJA31dLHYk4vW9ZVWRGGY8wY
13694	payment	1708	1708	1259	1	1	2	2356395056001	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnR6MsZDSJSq4hdbmdPVK5UMpFKbCj9Apu4mckt7JQFJMWhnTP
13695	payment	1708	1708	1385	1	1	3	6566304342528	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaw3HDhAeQuxjv3ByDQdwmq66qxEZQWhDQUMMPZbtqfk5p26a
13696	payment	1549	1549	1236	1	1	2	4079093000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4y8UzHmeu8KTS5JauVqSJunexkpsZZYAWsaeTxiwt4JcKZA9
13554	payment	1726	1726	2070	1	1	4520	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWh85u9e5rsserNcZ8cVUuN1aLyCAVZAo679zQW3ZHP28D33Up
13555	payment	1726	1726	2071	1	1	4521	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ9svkSaSEdrsnGjfZEcKdQF7xcdsb9v5DTxWWWpnnkXKVLzgyB
13563	payment	1397	1397	1678	1	1	6877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmyCuCmwLvTL9jRDKmv4Sx1DcbH2XtQZ75DhKAFB5VMUvr2BD
13564	payment	1726	1726	1874	1	1	4525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhvAiVvBktqPCp9EWXooiw2GCj1aps9iXRerSsig8yFCUxBzd
13565	delegation	1750	1750	1745	1	1	25	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvyJ9EgPUMSemhqnKHUy6tbfXhkynGMz2TjWFSg3CjfwQS1oy
13585	payment	1397	1397	1678	1	1	6887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3akY1GWBTnmfvAXF9qzeUedXuLzm3Yf8TssvYBx4vttmvCpvG
13586	payment	1726	1726	1874	1	1	4535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtHXN1yiykUKvxcPfMEyEJVMYRQmCJYeTixWDPSj6bXdCYm5Jc
13587	payment	1397	1397	1678	1	1	6888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iwCTD84fe2PNPUMEXKx2G4LvC25wo3c8ptxNeik9L56fw1Nc
13588	payment	1726	1726	1874	1	1	4536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNVf1bSHZsMu2b1EhtKTwtZmGDxtKupyffjXJ9nPZH4gaXcuMp
13593	payment	1397	1397	1678	1	1	6891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQrA3CupBrvu2ZXnU6vvo8LyD7kTHuGBSJZEfhXJ5eiTz1qUW
13594	payment	1726	1726	1874	1	1	4539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffvoZHuc3HiPybbxRa7jRBCtoDoJimwSbLCnFyFMGUJj47fNK
13606	payment	1397	1397	1678	1	1	6898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kQwCRswapdYMZ4ZeTi7SGXxQRQXfTqep9T7LsSSW6EoVZkcr
13607	payment	1397	1397	1678	1	1	6899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEATU5cqUJRUL2AJqRvinvfESqaeXYc9oXo6PHWZPAEVUpa2n
13608	payment	1726	1726	1874	1	1	4545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8ktprNgaZ988nCFiAiwYAtVeaiB28iwmcNdHYfoth93Rqo2e
13609	payment	1726	1726	1874	1	1	4546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWX278TnFoyYCH48pmeqKAkhsjLGWmtqK74bNzW1hprR8QJSS
13610	payment	1397	1397	1678	1	1	6900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhP6JXqoJG4fTbvxH6SFy3HYwSdijKkrmLxjsqGhTcWKoApZv
13611	payment	1726	1726	1874	1	1	4547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Sj2dY6JF2c5ckqJ6NkCgqcSwm4rTDNFJXLwmFGhJJUeRcLf6
13618	payment	1397	1397	1678	1	1	6904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfqsb54KmRNw9kX28v23QNvNJaFzhvAdRwdcGxgj475CQhjMw
13619	payment	1726	1726	1874	1	1	4551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3JbyuYJH1XRziDaR5Vfs9B26qQj2sBhmNgHALso2wXFAj8G1a
13626	payment	1397	1397	1678	1	1	6908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEDawaU25zDTH9zu6PadgchNLahox9Fka9QShvDPhcaMWYRDk
13627	payment	1397	1397	1678	1	1	6909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVacHdqu1tAvzbbLnagPdXJPLshY4KGLc9WcXCd1YgmFEMpBrx
13628	delegation	1750	1750	1745	1	1	27	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3StBk4Cjp8C6xUKoMrMBYUodHY3ShxD7gAD3e6EMHRuu4w1CR
13629	payment	1726	1726	1874	1	1	4555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa359qRxMyrotG2m9xRh36xpcv5rMHhzuMAef3mkXeC5gDahWBv
13630	payment	1726	1726	1874	1	1	4556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQae7xfhZXQSDxkLy7cnepLQakST15Dq1riAVB8MKXMyrH7Kkq
13643	payment	1397	1397	1678	1	1	6916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrftiNUfzo7dybyv8jKudqnew1RgQXDjcoxiB4WJGHcnZJojE
13644	payment	1397	1397	1678	1	1	6917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdi5TQMeZfe2WtzM8dyPq2n4TkvbXZnWf23At4t1MocEYKtBpF
13645	payment	1726	1726	1874	1	1	4563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdvwPSHarYwhKVTnVPX82BhBKvUFnXehPhBGmvibDQbAdepyV
13646	payment	1726	1726	1874	1	1	4564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJxqwwErcquigmgKa9hAaC9Row6NWuEFbCzq3jk4ag4AZ9zQy
13647	payment	1397	1397	1678	1	1	6918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQzpYVhRZk2de47K1s7roAgkGW8AVQiM8zPuB9m1Lz1JZhwFo
13648	payment	1726	1726	1874	1	1	4565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyd7QXhWHP44mmcnzLQpfGLNEpoE6HCkoQf2CoUjjYS9o6RxJa
13649	payment	1397	1397	1678	1	1	6919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapmik3MLLJ2jFAXW6Dm1EwouG2cvarSTxAk4KzqrjjVtQw2Gi
13650	payment	1397	1397	1678	1	1	6920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQUj64tL6Fvn3o3vmA9XvLLBrsBBijY8qCwNnc514WNWiWw1g
13651	payment	1397	1397	1678	1	1	6921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTJ9UdQ7kBedJ4jC21uingUvPWFb9tm2MEVr7CUAmwSwsoVUx
13652	payment	1726	1726	1874	1	1	4566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaerUrNiDY4E1gV3TAxZGyctmqPQC3TrqwcPqiSQWNGvnFnYQh
13653	payment	1726	1726	1874	1	1	4567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ72CBSoRzinVskpNASBTGF7DwbNnRV62FicitXvv8kXG7MiCZd
13654	payment	1726	1726	1874	1	1	4568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKuaN1c6fCAcqaUBjAZJZ1oxiLQPkwqCZmH2LjGBH7BdNkJkB
13658	payment	1726	1726	1874	1	1	4570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC8yWtezAkTKdGN88JD7uuB2EQvv3yyUgu47PQHCZgczKcgFb
13659	payment	1397	1397	1678	1	1	6924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTn8KVomH1oZQ2x2faUFepdB9MtWksUkPmGKePqTZEFWoiE7d
13655	payment	1397	1397	1678	1	1	6922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhsFLWPcatPqy15AZJztKpbresNW4Fyux6b5ZbFLVndAEv2xJ
13656	payment	1726	1726	1874	1	1	4569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZmgBwxbTpmXSxwkWRNNpXcsUM5RKo1QXH7bjdfA3ZqVgPwSx
13664	payment	1397	1397	1678	1	1	6926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdj44YTa6xH6nXV6KcSFRhB8ihrFggQSBJS9YwFMyvG72CG6vA
13665	payment	1726	1726	1874	1	1	4573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxAAuF45EmRx628jbiSbwseMZQkCa8mqYY5MAUiDE9e8Qnhxd
13670	payment	1397	1397	1678	1	1	6929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkYJsmBZPoKjYJuGUH8TQrm1BC7VAnfDfdhEpwbb3GtV66rcp
13671	payment	1726	1726	1874	1	1	4576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTKm92yu6c7WELf3iHKkSCjWL6B5XaND8BKSScVsvvHQ5ot8L
13709	payment	1397	1397	1678	1	1	6944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXmSKWpe3SGrE41GfkhSr3uSq2BMc7XxnfhrcWeu69UzW2Ls8
13710	payment	1397	1397	1678	1	1	6945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZLyw9gc4pkuJC3CFL2MjCF4MLjanYrtQZ7b3Hr8y2jpaZkKN
13711	payment	1726	1726	1874	1	1	4591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1jfyXdywjza8fN1RtRKvZCmAp9oYqDGsgqpnCd71ygqgTwxf
13712	payment	106	106	2073	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3nEqrtTdG2qeFYVvcJzCPoUgaxwMdjfCL7v9fkgXWUww8LTm
13713	payment	1726	1726	1874	1	1	4592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsi68tqphmsk4DNZBuofjtfyknUxALhhEQQoZXneLVqf5dATP2
13720	payment	1397	1397	1678	1	1	6949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCY21ZmmFhUQQSXTNzvWZYzzgVFdQbdKxYEJwx63ELLU6qPZL
13721	payment	1726	1726	1874	1	1	4596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2DZB9BbHkz7cgARZrA3LZnm8WBGQ7S1EswL7hoDipyXf23xb
13730	payment	1397	1397	1678	1	1	6954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhwmMv79HpcGDF9sFHmD88Mj35YoRWa5VabhRqKBQ4QQtNUwS
13731	payment	1726	1726	1874	1	1	4601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3N5qfrUy9yUwfkHKpdbwjQQCUKeMEzHbZ8SngGThxQgseL9Y
13736	payment	1726	1726	1874	1	1	4604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBG7QfEwZXykT5TyqJHhXDBznMtftTUHtpB4rW51KdC4nLFuK
13750	payment	1397	1397	1678	1	1	6963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnJkBcZ9SjAJxkC7hDvwardxRuFT2EYtRmRZswfkT4NRhw5MH
13751	payment	1397	1397	1678	1	1	6964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFKsPvpGkECT3rygs2NBLkCfE3WXPyewJhEUwo4u5urEpVKp5a
13752	payment	1726	1726	1874	1	1	4611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhwJbJiNXMV4kNef7WJ7SwNJLSLtJDtozWVZfoexswfXQYncE
13753	payment	1726	1726	1874	1	1	4612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzFntmRsZR9LSjbyZUrofkS9nj8D3fJwUKiohYe5nW1j6qLxB
13754	payment	1397	1397	1678	1	1	6965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3VANqjHxoyCygopiy6wgKMygg3hVDibxAP2CFmoP82Tn4jqX
13755	payment	1726	1726	1874	1	1	4613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FQuF5NeoaCf5TxbgHqSH6i3oYsbDpfXiZ6Lu9fnCU9EQS8vL
13759	payment	1397	1397	1678	1	1	6967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyNdy8BLd5quAfrns3tnQuzpoe7BaZPHfNRPyP1WNUaiBLhUn
13760	payment	1726	1726	1874	1	1	4615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEGJkMhP9dPT35vDFT7K4fcoHZrL2CfkfaAnxo5fubjRtg3oA
13771	payment	1397	1397	1678	1	1	6972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmV86zqG52Tb3crJHAQmJVCxnW8LJZAoxcGB6w3xfz15R4mqDR
13772	payment	1726	1726	1874	1	1	4620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51QiJ9ucQUuy8rw7Nmk47M14AmYCywdXkoR4t5VSiroRVwjLq
13773	payment	1397	1397	1678	1	1	6973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKny9YsTuh3YP9SFPJnDhJxFVHnpeBESRbqdEBL3aXeyk7N6k
13774	payment	1657	1657	1344	1	1	4	7034120000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySBSWrbQnRkWK9XGbV6uTQHG8bVYXPNFAgkza1YHepC6zsnd1
13775	payment	1726	1726	1874	1	1	4621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyggrKCFNrc2z6uFRqCZTmRo5Ywjg5RfY4Nc3c1fPy8dY9FKr
13783	payment	1397	1397	1678	1	1	6977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywX6EsVtuT7sEJB5qPwLaRNCsxGoXbTEwffGYKAedUWedegZb
13784	payment	1726	1726	1874	1	1	4625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWgsQ35HP21aCemK888nGnkuCtgcwq1EAEstX6LZm9YH35Dxu
13789	payment	1397	1397	1678	1	1	6980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf5ZtBDXeA9v3jNNqpi3v9qsEd8gR25NNNpNpW18cgbzSneyy
13790	payment	1932	1932	1958	1	1	1	498000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFrcErN5ZNtkaVuowfG6psbCujyJPXHG7ivYCKBUgzvcCYy7GT
13792	payment	1397	1397	1678	1	1	6982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8VvASZGCvZPABQ5syXzCcfCTzMCy1cEXLWVt5u185skhftwN1
13793	payment	1397	1397	1678	1	1	6983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdDn7ixZz72rjrSwaGhDtvn4daTuJz9NStemeeicXvtYsKfN1
13794	payment	1397	1397	1678	1	1	6984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdbHYVh3ZatY85XUJUJ2oEjEQ7AJaNSA1nVkeWLw8KSdaSghx
13799	payment	1397	1397	1678	1	1	6989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgfGaJX95Pm1CzjCwaU7mY3KD7F3D3XtyoQHrt5amJac2BSeT
13803	payment	1397	1397	1678	1	1	6993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDPgE3Q45dnriFVSp5wbnsXfGn8BZe4NiiRapjx546D6YourS
13660	payment	1397	1397	1678	1	1	6925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwvz84iG76jTAeZMvWPLvkikf1BGwTrg2DUxxmKpRb6GMoC12
13661	payment	593	593	2072	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6crn4TSCMXZLc3QA5GXiDq2ScUZjWSDwry4eJkmDc6WJTDpU7
13662	payment	1726	1726	1874	1	1	4571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4Y8uzXAv734BaVw95p1nE4YQPnyntWWwbwKnJYbwzTM2rb2a
13663	payment	1726	1726	1874	1	1	4572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ocKoVoWCKUyyH5moVHpVi4rPHSLs976p5CT7js4WrEyf3i4G
13680	payment	1397	1397	1678	1	1	6935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4EqD6NpL1g58ThJf7xAmBq8ZDZ1iLuePqVnZSq1VckVZvv5p
13681	payment	1397	1397	1678	1	1	6936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnQrTtutPY5ZFQfWbmiKUF16Yj7K2FYSoQTGje2xy7ur2S3rq
13682	payment	1397	1397	1678	1	1	6937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEP5eoepSp4AfyLU3GAZuvS8XQ9Q5qiu22kSFp5gVyMGNZ8V8t
13683	payment	1549	1549	996	1	1	1	3373682000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3AnZgB2Q5nRjKHKYtRZS2S47pdEaabzq327kYQCNx9VKQRaD
13701	payment	1397	1397	1678	1	1	6940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8YwEmobLJpTQRZZeTkjiRYW28EKjx8vGqeZcESLWzCZCXTUV
13702	payment	1397	1397	1678	1	1	6941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywAzT8X7Fy75njSTVeJN1Frh5e32prbP6SbGTRWLWfc9rYTyH
13703	payment	1726	1726	1874	1	1	4587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARm8os2W651rvKHCpa6ghSqkd1zPdwpKETqiWcnbFt6LFjW5Y
13704	payment	1726	1726	1874	1	1	4588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMhYLaTJdhkuPMwL3Nve7Bzg492W3thCpRNSCjqbkx1gQt18o
13728	payment	1397	1397	1678	1	1	6953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kkFjdDsh1c5xX8cz4wxq6QNc7yffg5zmhVF8QBtszHwQBRWo
13729	payment	1726	1726	1874	1	1	4600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmin7owDKHtDoF7u6hF4vw6MK7hKEn1SLNUayCaB66Gb25Duxa
13738	payment	1726	1726	1874	1	1	4605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfZuH1mBmWp25y6Qs1n4CoXAKAA7ynarAhMc2R1pWjozhmjuV
13739	payment	1397	1397	1678	1	1	6958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2567VHWcfsCUMcbRfuPrX1ziErkM9yvvjqBL6rjsDCwH4dDaG
13740	payment	1397	1397	1678	1	1	6959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSz693SfpGCRbJn5ZPz3NwHdKvrQrL5DmZPYcYuf3mVFRRePjD
13741	payment	1397	1397	1678	1	1	6960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rjTXVshzWMeUXbY9QtnvzzPDH8oB7gCNn7CvjrqZrm9GcQwn
13742	payment	1726	1726	1874	1	1	4606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspnxXsnAsHEHs8sGnEY5xCrh5wJ8kiFjCDPG4wPHEFvwL5krA
13743	payment	1657	1657	2074	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmKaVkxZYVmZMMUD6noG44X8aHVxv7f9v3RsyEdqjqMhUPWAfZ
13744	payment	1726	1726	1874	1	1	4607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5D2feaJwtgR9dgm42kpzcnqjfGGdQxSJ1rw8sAX4PeJTX51t
13745	payment	1726	1726	1874	1	1	4608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBt1djNdYcxu4J6z7p3jiKqpG6HZuwxfKwfNgx8kAQmg96kLr5
13765	payment	1726	1726	1874	1	1	4616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcthKYzm7BURrmkZYKuZEuJGCgNfCxoLLq6q4nz1uA9JuFN9k
13766	payment	1726	1726	1874	1	1	4617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44h4g6zu5NWb8BptWSTM2JwjivXWNvszYJP7YiG6eT5Exkg1S
13767	payment	1726	1726	1874	1	1	4618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GsNJoJMTFywsstz8cJW317A6Tb37ZxR1HDiirRR6mVthydzr
13780	payment	1397	1397	1678	1	1	6976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCY1pPJgYBvVyR7DHoZbiMEGxgruHSYuGB9FcniK1J1vhzu15
13781	payment	1726	1726	1874	1	1	4624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyadwyDczBtSfm9DWb9VgWNhF88fkP39hHcQtkMUNC9ddXGuE
13782	payment	1657	1657	2074	1	1	5	1162600000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcdYM94m9xv96L534dA6pnnHgH1VkWEYnDQQrPjMYnxXGY4TPK
13786	payment	1726	1726	1874	1	1	4626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KJqmK48wZArxSmDQrAK4PeCvQMvgwxUX4jZctwBqunh9gQdH
13801	payment	1397	1397	1678	1	1	6991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiB4wCaaRTVNWZWgjoHcnASaxfJq9ikf84BvtkbAhTT2pmp8ws
13802	payment	1397	1397	1678	1	1	6992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzXq2oJakYUXEJwFxAcBtgNDP8DanBFDWh5wmmTFwqYFPS7aZ
13806	payment	1397	1397	1678	1	1	6996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW11tJmVLsH1CCo14aMFAz5QgMvGWZYvTAcKXLC1bbxvQdtgmP
13807	payment	1397	1397	1678	1	1	6997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvo7Mhw3YJwasidPQxH4ePxVEVtrvAqECefK6xj7P7n8Q2TyrS
13810	payment	1397	1397	1678	1	1	7000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiNBazff7LbZLfo5Jv519qvwieVWsXHhQoVNU8SjH7NdfG77H
13827	payment	1397	1397	1678	1	1	7008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjcx7pzS9fsnh65kQpfkrPknJAhwopo2ZKCqA1rfdJVgTnFZWh
13828	payment	1726	1726	1874	1	1	4636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyz3viAmGJ9xsQ7D78V6PrSpphQRMMCMd6QfMZewpnVCYZ7CF
13843	payment	1397	1397	1678	1	1	7015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNwzJBNpw8rtjADVnWbwhfXWgo1qdFKSXJaF67L58LM5ck7b7
13844	payment	1397	1397	1678	1	1	7016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ41q89JufriE7amsiUt9VJUC4sTqafNTsLGyWwdvxKBKb9np9
13674	payment	1549	1549	1549	1	1	0	1500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8qJiC362kMR4egsxSdZQN16NYEtsDLopLvhDuBuNSYCTwaJP
13675	payment	1726	1726	1874	1	1	4577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLWXbLGByWCC1nJAoaxe5VMha7Z7gmqvsqVLEyvdYqfMud4rv
13676	payment	1726	1726	1874	1	1	4578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6o61bvXZaKynCkFQn5gqGF4ST3fwjxzuZDuRhg1raMuoWfKg
13677	payment	1397	1397	1678	1	1	6932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzEWsZsv3hkq4QvXA6tA9cjBwHfiJQYx27gJn2ydnJahdpHhNX
13678	payment	1397	1397	1678	1	1	6933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtSvohmEVYHGzchV3LEpWCJq2MjiN4mzvLgb3FL5WR3MtVWDH
13679	payment	1397	1397	1678	1	1	6934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8MqVYY2JUiYoUJ7UyCx2vparjnvyhHp1w41UComWvowNyHUS
13714	payment	1397	1397	1678	1	1	6946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fymYjY6kiUp55MHMfJ6ZsLjHhfa16uUyJAVk1bAQneLj4qKw
13715	payment	1397	1397	1678	1	1	6947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92RD9WyADZLdZ7cw1ap6vTJHZ1FDzXEyz4dgpcfPUg1gYBeaS
13722	payment	1397	1397	1678	1	1	6950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxWwwFB9pvqdV6sAfy4tzUXU5DfF57pNF9Ea4qd3UtFv9mwqQ
13723	payment	1397	1397	1678	1	1	6951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xURNpYBUYVLRokbUjSS8pdMnjDSKPqfxfpFKEH6PH5nBpkeB
13724	payment	1397	1397	1678	1	1	6952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmypD1saniwBh3EaS9XXxRC3YpYSSaZZa8Fi6KwyZFw3gbWF2
13725	payment	1726	1726	1874	1	1	4597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2D2JciasygyCj2p2CETPpzs3dugJkkpwdQipN5kdyg8q3bgEy
13726	payment	1726	1726	1874	1	1	4598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDedmCfTqU7gBunxvmU3K5CVGjFBkouCzioQFz92mw12svpGJS
13727	payment	1726	1726	1874	1	1	4599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSy8VStTnotKBjd3sQapfzSeM7LtdcetQeD4pZMvxgMUqJNnSh
13734	payment	1397	1397	1678	1	1	6956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SHXfq8tkS91Z2dL6oGkvdQxMNEjZEbsABHBYZqKgdPU6dXwq
13735	payment	1726	1726	1874	1	1	4603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnP8ef3VhF5chZNURNrRCud9vD6GhQK9C5VKhx1HAkEnsH1qX4
13737	payment	1397	1397	1678	1	1	6957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDraGYGjr6j72Gsn2Auw2bbdJA5o5Ynn3A4jek5JZYs4ZUikb4
13746	payment	1397	1397	1678	1	1	6961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbH4fHWM2oHDvFWPwfpmmpEj1yV9npgiDLy5Swvy1W4DZZ5cKK
13747	payment	1397	1397	1678	1	1	6962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9XnykDBh6Gr4L6jWLK2VAihBwEEjuf6rNGW3Hb8pzxxPAZ4e
13748	payment	1726	1726	1874	1	1	4609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGby3xP3Kgkc1vZUsba17gHg3zhrFaC1CHFqkFmXZrtYJjKJp
13749	payment	1726	1726	1874	1	1	4610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP12YtnzUTtVHpqpP6TPX1BRkziMGQLzoqA9UapuY8tMfwskvX
13756	payment	1397	1397	1678	1	1	6966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjnXoGY9degL549nzgDrQaoBecjYnQk2bZKCmE9z6ww3oY92Q
13757	payment	1657	1657	978	1	1	1	2087750000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgNRzxpurSPPscM2nkeay5Z4DyDJLSREYFKT6i5k6ztJVKvyN
13758	payment	1726	1726	1874	1	1	4614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYhCZE28JAGYnkZVcRjhDyphwWVdW3nvdAidRSpmvCspJdEAp
13761	payment	1397	1397	1678	1	1	6968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKp4EWAqMGBfRpE5L6RzjqSu3mgqFs54i2bDpaLneuAAoL67CP
13762	payment	1397	1397	1678	1	1	6969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfwH5v3iEXUCEGpPzfLdShxojfHmmUym5VSW7p25qndKvL8yR
13763	payment	1397	1397	1678	1	1	6970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFwqYjdL7tmnjidwBAx2Hj39YCHJr7HJ3y6HVsN1n39e8Rzcd
13764	payment	1657	1657	1098	1	1	2	3741220000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmGFstykNirJvA14a75kN88ee7XuRgCeuqpZAiCYUkcLLSBPx
13768	payment	1397	1397	1678	1	1	6971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPpePynauBwpdzUBr5QGsshnwyxsG235VpUmns3VG5Y8puTqG
13769	payment	1726	1726	1874	1	1	4619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZimfiNkSMici3Aa5fbS7PgZiyWc5muVadEfzNQWZcB27DH8W
13770	payment	1657	1657	1218	1	1	3	2524280000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgkN87js2LGjRjRpMDTBfMyz5kEWP7VwtybFZ2Rd2GaYbsZGw
13776	payment	1397	1397	1678	1	1	6974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8xMfE4qhzAXq5UtakkxSb7YWcR7H3kUf5g1X8HbQTKCD5yEb
13777	payment	1726	1726	1874	1	1	4622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGoA23LhpLmCHV1kuDzh7Px8b5fjXdBPacvFLF1MqUmoSawPt
13785	payment	1397	1397	1678	1	1	6978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVRtwpiD5vPUnk2VdFFRgawVXkdj98fvH7aDNHJUXWbw1rWCp
13795	payment	1397	1397	1678	1	1	6985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDk4YNvLibCGc3epFuBScKp2jM91tnerC77xC48ijxy46VQsE
13796	payment	1397	1397	1678	1	1	6986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCiya5EM3tzgM1bMZrk2gUgtiHmzhrtMdPXmvKwt3jAZ6zLe9
13798	payment	1397	1397	1678	1	1	6988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoCDe2jWAvmv62aRWVpon6g5nkjvEQLeu2nBWtxTQSasADiarx
13800	payment	1397	1397	1678	1	1	6990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJiuEoiYnqrG4ZoFqp5tNgXdaRUyQkPxp2rZzodo7HN9V2oDa
13697	payment	1549	1549	1116	1	1	3	6045608000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLauHqVi46M7T5Bc5dVSkgTMvHDNXz32hKL8SVEBgPMQwexYG1
13698	payment	1549	1549	1362	1	1	4	11366754000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeVMky8SDFktbf4RGUMJ39qcEBVvr9CevT6krdJwX3Ezdi8uh1
13699	payment	1726	1726	1874	1	1	4585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xgjyngsTjQs3dGNUWwHsUfHfhHG5L9eAraGiX4BYhjfkQBk4
13700	payment	1726	1726	1874	1	1	4586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YpEPu6MDJKUV6mXB1DAgi79fw8HnJAN5LDfisiCuyUCvwoog
13705	payment	1397	1397	1678	1	1	6942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8GdXYdhntxUmCwwoiw8at9wBWxdXWAqLikBgDo7pWxHnu9w7
13706	payment	1397	1397	1678	1	1	6943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4uC5oqbnBZayu5b1PwMzFQEWxoLMt5FZgkG3kUHAkcF6GFmg
13707	payment	1726	1726	1874	1	1	4589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcqQpSE2hB1y29BphnktUqvCvzF4jdsXae8zezTwoT7GDVfya
13708	payment	1726	1726	1874	1	1	4590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzivUtJrN8rwt4rJRicgFNPxEYcCUdU9nWPUdtndEAgxf9Td9
13716	payment	1397	1397	1678	1	1	6948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopBM9mdt45B4Ei74cC7qd4nVU5KkG9nZkBye847ffiS6mnefu
13717	payment	1726	1726	1874	1	1	4593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsxtgGFhsXg9V2TYjUXXSxRfd3XQHz2yniXegbkrGSXjF9hhW
13718	payment	1726	1726	1874	1	1	4594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjVPe3YqKKEp3ckPB3m27cpk61h35eTuqgRBFuUYosv5r3q9y
13719	payment	1726	1726	1874	1	1	4595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxp3By8d4h8HXtQTJmf47Ufc7GqR6pWtQDV6Fd7jvUu1YdteK
13732	payment	1397	1397	1678	1	1	6955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViMB3hzcJ1c3Wzh1kPx1QxoyukCYkpAgkXi7CyFaTyNjYMTet
13733	payment	1726	1726	1874	1	1	4602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZdPURS3j7MFumJ978FJCBWXt15sBUU9RJsrikyTS8mxYqJgB
13778	payment	1397	1397	1678	1	1	6975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatiHakSXCW813Cuq68xLtCwjtmLchaVTpwU85TT7AEkfjvLYg
13779	payment	1726	1726	1874	1	1	4623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QKKMWokQyP2XaEsTD6oA9x1iLPzZSELJ7YLvoHrm6wZmf9fG
13787	payment	1397	1397	1678	1	1	6979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWBhHHvo8e4D6Ubempy9PUwrvQEERqe2yaEWByihpM4VcBk9m
13788	payment	1932	1932	1958	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCHjZNAijrS7u99EXCFpNiYANsQr6has9WdH5Rof5RbFaijo4
13791	payment	1397	1397	1678	1	1	6981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCypUwRvmxiEhi2xNLNQRNfh6eMnCBkVSkqzMpSnAe5qMusfM
13797	payment	1397	1397	1678	1	1	6987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPzWmskiNGko7dEwrfF1QgKXMAuSJps4HYfeDHPg2bremLvDY
13804	payment	1397	1397	1678	1	1	6994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwY1RVaxWvTghdDbSuP5e3QuoCZkzFjtSaNpBm5wLLi38e2d14
13808	payment	1397	1397	1678	1	1	6998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTvBzsf97Z1SrUWwvFmFo2ASC9VL12jiUiM2D1LypAXBWgLao
13815	payment	1397	1397	1678	1	1	7002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWJ6thHbhR958fkjyTsnNNh38Z3cMaVQAyWLkJ6WmeXuo2ixv
13816	payment	1726	1726	1874	1	1	4630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9QVJ7eKqdWYv8dQ5MWarcNE4S9tQHeTXt21anJyWHsCXFvqx
13823	payment	1397	1397	1678	1	1	7006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CsjyJesVxUiDtTfoipdGVdRnF5jUF3y5k81J9YyvCHgz6CsU
13824	payment	1726	1726	1874	1	1	4634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1uCdLMggysiViWYbsLg2goNS69xxJqEysGxQkoD3xMHiWd9K
13825	payment	1397	1397	1678	1	1	7007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcB4H1fUCma7Vn4hhRqZh7Ljv5RrUAtqAeuJj3ZFw94Mrp1pm6
13826	payment	1726	1726	1874	1	1	4635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvc5tTNDvDGFbFLR3UEawguKcRd6UKxMtvHnMyfopvbLfJHtk
13829	payment	1397	1397	1678	1	1	7009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEqP1qNd7ZV9KtVYG15MhsRJt5ceBp2rtWQxAZwxkL4PPxzcQ
13830	payment	1397	1397	1678	1	1	7010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs47KLe8LH2Jj432XEFqaDTbzWDXeRW1SR5LkXUnr7yXAAJi1T
13831	payment	1726	1726	1874	1	1	4637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgcWxuTQamRJUbAdngMmLhM7YyX1z58R4YWQfuQjaXs6zYRbz
13832	payment	1726	1726	1874	1	1	4638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTn21pUAQeyNL8pVfUYi2Ajba6XToAsTKNsZxF9fVWAqcQToPh
13833	payment	1397	1397	1678	1	1	7011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUt4Qx9S6oJH4FmX96d9sAxwb4X1vV5sAWgyPL44Zq9Rvtjdh
13834	payment	1726	1726	1874	1	1	4639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrpsMweGdbknPzJdaq6Zegg3BCJdcHp9YKwcDKWV3JWDMufTsX
13835	payment	1397	1397	1678	1	1	7012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ke5ixjbB94Sm73br5vEhqLaGo5wiYQxtzHP9tafPP3oHYcB4
13836	payment	1397	1397	1678	1	1	7013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggxLLX3uDbgovHii6DzgykmJreYUyfGTiSzH1AQy5zo98CEtM
13837	payment	1397	1397	1678	1	1	7014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCE25N7JWRJqprnoxxgJJ3NpBuprq4rcPFosRRfVBjirmgH1CR
13838	payment	1653	1653	2077	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhef6zXyDgt6BMNt1GcZy2GPiKd2C2wEJiK6ad3cqN7x8HFHJ
13805	payment	1397	1397	1678	1	1	6995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgyPHenSHu9rYwTPqbHqN7j7WYFDmQh3kiNzbYPkaE1m1gStW
13809	payment	1397	1397	1678	1	1	6999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqqX2DJQ7tS2LwQydpSMJSyzNbPMeNTarEXDyibYdLVsasUKy
13817	payment	1397	1397	1678	1	1	7003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQYE7onMkDa29oLuHfZTj8EXXd6CH8sogaYcJAqiAFZf1RpS2
13818	payment	1726	1726	1874	1	1	4631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1r67QANebLM6LNaBFntfwPeUuZqGzktgNY3Ud2hNvz78Bsxke
13875	payment	1397	1397	1678	1	1	7030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbXayH4uELDJmiexFnJWwfGgyxGvxqVswFVbNwJEKxPpYcb8ri
13876	payment	1726	1726	1874	1	1	4659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5FLfAAmUcnS54Gdko1aq83Aw8rq92WAvJeZEhuNzpoVGYvsG
13891	payment	1397	1397	1678	1	1	7038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwzHLEucRoQTFuYCyLtLvFZ4fHQmDgPXBZn7PU2iSS6FmyGG7
13892	payment	1726	1726	1874	1	1	4667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYeNLC9vXqndDfyFzxSu6KFPmTjcqUgY2iRTJJcYeKMgvL6bX
13899	payment	1397	1397	1678	1	1	7042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWJWUoKWwpktvnRMSrDwekx9wuFa5KaQNdKJrgjFDvgq6yqt2
13900	payment	1726	1726	1874	1	1	4671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhi22FQWe5dokMjHHGkYBUBsXZrbNQWx5dYYDdm1zUmLdSSua
13934	payment	1397	1397	1678	1	1	7059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDg4GsTkjWqJnzCdeua6Rxs3jPuVzLkQLWXwhZEYzgL1SLeLdB
13935	payment	1726	1726	1874	1	1	4689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4RKWbG2QQCdBTTV2wSKmiggMN9V8APA1zaDyX6CdzqamEqGM
13942	payment	1397	1397	1678	1	1	7063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXvxVjq29cMmxRKPLQhuuoFjj9dJfE7Qrp7jPztqBabVggEEM
13943	payment	1726	1726	1874	1	1	4693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8eZfQyh5g4ESLBPAPX5gZ3kehYjYmNZdzpBLF2szeiRiJWxM
13944	payment	1397	1397	1678	1	1	7064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsc1abmc6XmVn4pneLVsuWDPc6eLpKv8rZ8rms2Wa2AC1YmasD
13945	payment	1726	1726	1874	1	1	4694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eWsrwzr8ypBRu2fvzqMvxbDmUdNoExkGYDjcYTWSSesf6LyM
13966	payment	1397	1397	1678	1	1	7075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASAzuPzjQ6Ncdvo5YYMM57Nuhg8iMcBSwiVxbBbrmuNX5TQUW
13967	payment	1726	1726	1874	1	1	4705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56vtd8oRdSCpSSWCntphHGobUBpr4hP8R8Q7pukZD12akRzbq
13811	payment	1726	1726	2075	1	1	4627	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYu1P6FkNvS5we3eo1mJQTy5Tysr3ebJbTf7bTKBXFohHHSGoth
13812	payment	1397	1397	1678	1	1	7001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecCeGdqV2uxHvSbAhpLgm4NJ6VGnRvjN97dktwYKs9UQeFCuL
13813	payment	1726	1726	2076	1	1	4628	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLCXqAX5EDz7yHXxs6RQrLD4TwaMMLcWcm8ysCzYbC5ReViLDT
13814	payment	1726	1726	1874	1	1	4629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskHfuK7bNvEBnwAYJdJ3uZM3Fnq8qpjSnxKbh3t8hi4vxPtiv
13819	payment	1397	1397	1678	1	1	7004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZorqhdmt4th83AbNjGHqPLtbvV53CDqs2ytjpBD6WPKz1YDi
13820	payment	1726	1726	1874	1	1	4632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbd4zaFcyC94BRaP8pfrFdiCmAFsVD5UUR5nMptPyZZUTx5ea1
13821	payment	1397	1397	1678	1	1	7005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopU4GEdx2k9A3tLWbnDAHBoVK7hh274KsgsVY9Mnjp8EsK97h
13822	payment	1726	1726	1874	1	1	4633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdj5NPqwfaPxhvceRjNQVsGgkyboyiQks8BdoHrrx5w9YparaS
13850	payment	1397	1397	1678	1	1	7018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjXsTxUNKRG8RLQNR4gksF9LRkzf2VFAuHQwisy6rceDmTEFW
13851	payment	1397	1397	1678	1	1	7019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnReB4xHMFyJvhskbdqx4wz8ouSsHKcaSgj2ywqJ695irZGRA9
13852	payment	1397	1397	1678	1	1	7020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZ5GaaLxWwFudBaxUpnhEqkbtVLvTSDhLApsjtjaEaWZFZtju
13853	payment	1726	1726	1874	1	1	4647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwRBMesYmBjYoFwC3gYtBKRzV8CDz75tyxx1rFB1HU5qt1nwF
13854	payment	1726	1726	1874	1	1	4648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb42n3RZ2SJeR4oesnzcSRWopeZ2UmggW95LRxYEEEAEE183B
13855	payment	1726	1726	1874	1	1	4649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYZ5tAyeMaSLWcry1Q5S2mPS8wNMKyTmJWw7Hd4dgBTYm44fL
13856	payment	1397	1397	1678	1	1	7021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJS1RXX1TpQnyp5SPKfaN84btT65ep3vgvaaqLhggju17JPTuK
13857	payment	1397	1397	1678	1	1	7022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyomtre73a2LVtGxfUmYRyJphsu3knjPBa7MexVFotJLJv44M
13858	payment	1397	1397	1678	1	1	7023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFPpEq7G8ZeEQx6vqaEY5CpHLtuTe6y3arJufzi7hnKnet9Ey
13859	payment	1397	1397	1678	1	1	7024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YxFU9rJCZVUC89SspQZ8FegjHtWieHLk8s5jgxXuzLXpSEdS
13860	payment	1726	1726	1874	1	1	4650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAETfH4T9t7DYtvpDELE8iD3kP8LoRcpKMJ4WKZJDfDV6ojafi
13861	payment	1726	1726	1874	1	1	4651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwUSq5xXCxn4LBLtDLx8e4wQzgKSofBWd2zEBGj7jfHuJ691f
13862	payment	1726	1726	1874	1	1	4652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYergprx5HZAzMs8yNesr9uSL2jbgY7U7ef2WUsuvTkMDsvjmX6
13863	payment	1726	1726	1874	1	1	4653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBv17qecRKxT7Ew5fYvjNQR4gmLYZcUeGcxeVpHTyutiqetfc
13873	payment	1397	1397	1678	1	1	7029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYe72VptrvLB3bbmrgGApNv21pL39ieZ3k37ugrYK7adjHzdAx
13874	payment	1726	1726	1874	1	1	4658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3yCpRooopjXK1gBbJ1bbCzAHhaifdiKWVFgki7FPqJ3PpiMqq
13881	payment	1397	1397	1678	1	1	7033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUoUp3aAZ46xAMGpiaZiB6ZA2HeuwKmj4phD6DLJpUS1vSJAee
13882	payment	1726	1726	1874	1	1	4662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvURU4sBkfTyqiaevfMHfbxmPRCdogy6tjhdJMnjEV3vXzcEg
13893	payment	1397	1397	1678	1	1	7039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseKnCMqThke7gUXTyvafLixGupU9pk2TjQd6h7uvMdbxu9x1v
13894	payment	1726	1726	1874	1	1	4668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRioa1FaRfPv5PZqohwoBKyxL7ccJrCs3q1uLW89SMhgtNLmbx
13907	payment	1397	1397	1678	1	1	7046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWubjQ73izuoY3YEEvKpBkxpLQ3suuRgBFkfswSun8VQH6k3m1
13908	payment	1397	1397	1678	1	1	7047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFDsAu9n1VbnsS8onK2hicKKDQYhUiUEr8ukrREepupURCSpX
13909	payment	1726	1726	1874	1	1	4675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgExo2KL1nJLyVWoToEFX9DYoi2KdZAivUgYbcPS7anQUVXze
13910	payment	1726	1726	1874	1	1	4676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxA4KePaP1opgeu4PMiXkH8kzfcRN7V1TDeFgz9k6jTjTsn5YG
13922	payment	1397	1397	1678	1	1	7053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYkN5r9VMsGMiS4yznmLMKKVQFV9YGRBkEfyLzQv86nFe4NEYY
13923	payment	1726	1726	1874	1	1	4683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyWzWzBhVSvQ52rAestVLd36LKXLwjuF4aHawFkKwqwck6NUV
13924	payment	1397	1397	1678	1	1	7054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnUXiNBHokoqovQ4syywEjuSsfsLvUdQ3qTdrruvsFKTzMhQz
13925	payment	1397	1397	1678	1	1	7055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYj4CYHekRmrHfUdGTYuU64C7PDu1HoDidGHYHekxBYYfs7kCM
13926	payment	1726	1726	1874	1	1	4684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCg3t7Ymy7L6MPohvFif172zxBoGra3xMMKi9Re99vRav36Vc
13927	payment	1726	1726	1874	1	1	4685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpz5HDk9LacLiSJEPzbPw8RA5EC7ZNm5RXDsxgNC1xSzqViiA
13839	payment	1653	1653	2077	1	1	1	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDe2Lv477CiR9jXV548qwEwYWVmexQE5m1xW6khsevaE36kTx
13840	payment	1726	1726	1874	1	1	4640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aAvwML7umRbbcAEw4CcWdJAxNuJevvUuxSu8AAyFZyfeCqK1
13841	payment	1726	1726	1874	1	1	4641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVJ6aJcTijyXSSaWVgDvPc42oawutrFCdL1pgQYaQcTAANVq9
13842	payment	1726	1726	1874	1	1	4642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdn9QQDLijYorrDPhN4A6Nfc6hJCMhbSJvyai4p4C2NJjbPpM
13883	payment	1397	1397	1678	1	1	7034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjmsY4dh7tHNMqLSZi2JiGLMkepmNoeys5MfTvPKqzMCBpcHd
13884	payment	1726	1726	1874	1	1	4663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqhhyAzYrUWddvYYkHPGFdrBnV4eJ4h5vprC6bN4ziNt35m33
13885	payment	1397	1397	1678	1	1	7035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGSmYH1BX3AwGUaRe7vH118FnFh2Env6Nm1yozkeabgLKfrxC
13886	payment	1726	1726	1874	1	1	4664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfJxCpb5SXBNyCKbs7z6W65guresJHdxg9eH7wYqmc7JkAamF
13895	payment	1397	1397	1678	1	1	7040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uAAzLwMtj1eTEdnbgaWVPvtuph9ga9TehATGbFHc3vXbNX4h
13896	payment	1726	1726	1874	1	1	4669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzunDX8LRytbhErTvubUMTkHE9WMyxp1AbCJZCyVJBRdFUpe7K
13901	payment	1397	1397	1678	1	1	7043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyb1iib198Q621Af9vt39nxq7ainwXW3VSKvTDMz7FbbQvENg
13902	payment	1397	1397	1678	1	1	7044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VZ7GYStpww6YKAuiepn7qyA5r5Ltv3qiuroyESsngJWiYeeZ
13903	payment	1726	1726	1874	1	1	4672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZd5eTkjjTqxckknqcVZXEr4md3JiziqnxaYiJuBHMWzqDjfu
13904	payment	1726	1726	1874	1	1	4673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSXxExMbrjW8Zi9GWy1qnXdvuiQgzuP7g5a4yqV5p3yJLEYXV7
13930	payment	1397	1397	1678	1	1	7057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13ovcFcMJmE8rrpEVuNbrLtGAyXAPsFQVrjcAnF9fVZt7mgNt
13931	payment	1726	1726	1874	1	1	4687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk45e3afBG8PWXk1NQTR9HmPnzte3sQ7eQXURmW2BPbaxMgbte
13932	payment	1397	1397	1678	1	1	7058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfokGq2HwA9aWTiUdwAxgrqrScXz8Y2iqeSkVhdoEHAW36Z9D2
13933	payment	1726	1726	1874	1	1	4688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTiYgfDeypn7ZEsVNcNKxYCi2dmV3MY46uoUvJhpSwA9rbAvL
13936	payment	1397	1397	1678	1	1	7060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyDS8cq9VqBrWwFFCrSgNMk4ydH43ouVbhhUPh59VtPmCHTh4
13937	payment	1397	1397	1678	1	1	7061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BaZoCrYTkymAXxeagG2BFa5De1ChGDnaMiTnTpfnpAYeib8i
13938	payment	1726	1726	1874	1	1	4690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsjyapDEoAshgWdr6XY26Pt1mJBd3sScfv7gtC2XED5yWALSR
13939	payment	1726	1726	1874	1	1	4691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMptD2QGyZuVuY1wgLVzzDzGQpNALFuk6pnQYfRjyiaPfbxsC
13940	payment	1397	1397	1678	1	1	7062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56jG26VahVdEHRxyZR5KGZv7tJe9TJR2hevC5Qtj9soRQbfxH
13941	payment	1726	1726	1874	1	1	4692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvtscnSHyECTntqByEunh2AYmTFdjRp36YKmUr6D7xNZ5BvgE
13946	payment	1397	1397	1678	1	1	7065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkA57mvhGRA8BitrzYifFxThMYqVPNCRoPyh3ooZa3zkS9JY2z
13947	payment	1726	1726	1874	1	1	4695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRLCocPKPwT5a3uFnw9YXSk17YNoToubCgL3pbgqQv67BS1dD
13948	payment	1397	1397	1678	1	1	7066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5D9zA6XLoKwUc3gLPSs8DkdB16XgZLN9pCM8xgY7JpVEUtwNr
13949	payment	1397	1397	1678	1	1	7067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvUDbw7NRgBHKJCNDxR7pGeghSzYEMatUsS6ubFs9f4o7tbxN
13950	payment	1397	1397	1678	1	1	7068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eMS3R48GwWZU4adnWVawGDGnCfvnzVqZT41ishiUcR7PhnLZ
13951	payment	1397	1397	1678	1	1	7069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAq8SL4LTpsCnNAYCPMTxMopTT88kKjeeNsgWbq8ijkh9wPpcD
13952	payment	1726	1726	1874	1	1	4696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEXGFJuwH1EUqp5HhKkHQrnMgxvuS4k1xC3VaLLahZPSJKBAA
13953	payment	1726	1726	1874	1	1	4697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMcaqJ3QNRsivnzgvcFcT4Xd3uDL4V4D4NNk1hwranyG1RdBQ
13954	payment	1726	1726	1874	1	1	4698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBrKcP17SikcxPWYGsumhzp751KeuFmTEA57sgorHsmT2TQhd
13955	payment	1726	1726	1874	1	1	4699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhVMKSg1yncyULjdxkEkFuPtep4hheNiXrE6AF7n9n28YboAe
13845	payment	1397	1397	1678	1	1	7017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGsVHE7EpvL5xJMFwuh8zELo8vpKz196AF4bFsGJF7eSyiMFX
13846	payment	1726	1726	1874	1	1	4643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BQMSbykpuhmWBor7MqKpGKvivQinAjkFcMCmiroQbPRCuaga
13847	payment	1726	1726	2078	1	1	4644	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCb7NPS7GfhnAuawVMD32ronTMSzEffB3fPSVC3ioczwx8JfN2
13848	payment	1726	1726	1874	1	1	4645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1CwYenkCrGg95Db5WeXPjJwCcatwAE1GMPwEJHJuTApVJ38F
13849	payment	1726	1726	1874	1	1	4646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjPidW7VYJmNHLG9FVgsqLRk1fi4dvQ4NPw34F5tBZw9Gkf6t
13864	payment	1397	1397	1678	1	1	7025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1btQfdCEJdujsrvqYfoWvpw7xTMxn6C4bGdGHXiLKeX6d7rz
13865	payment	1397	1397	1678	1	1	7026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFp7cvEncV3Aqi14rfUiKb2SkXDdcCPoEBRYMf9RYRTmoE4p3
13866	payment	1397	1397	1678	1	1	7027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjHu8Y7xTfVE1MXEyMbLoseRUSGeAgR4TVD5FE2gGso4pEqR2
13867	payment	1397	1397	1678	1	1	7028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XxDJvtMwKKtg8A2vQhjTCcHvn3Q7ucz3tPX3KJfiQj4Ke7jZ
13868	payment	1726	1726	1874	1	1	4654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMVa6LQ1dbT38heiqZVUwgNKcy89uCbhDb8tu14zCzovzrghY
13869	payment	2044	2044	1816	1	1	0	0	1000000	\N	E4YtjMQLmo4RKeHKVCvU4CjvW8hYLbW9ikY1oiEYsU9YgWzsdTBnA	CkpYV7P3ZFe6RAqXT9gHmDvtGZricxVX62qvJEtnVuEYr8oB3QKH4
13870	payment	1726	1726	1874	1	1	4655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSJWKDCPsQxpznJ7hYGHiMKi5a8k3Ki6JeufP51tWq5oofUjZ
13871	payment	1726	1726	1874	1	1	4656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdy6QDgWUMxMZor4ZKZnjeCZBHAUqcgaxJCYsctY1oC5j93ekk
13872	payment	1726	1726	1874	1	1	4657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuVonJamCBjmSrTMMqMEUGn4uS8RsME27FBwEPRDcZ5joknAU
13877	payment	1397	1397	1678	1	1	7031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWxKUGS3PkYTBVB9qmM1DVSKGh6dcqWS3d7A7vdG3rqykHYvF
13878	payment	1397	1397	1678	1	1	7032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAJdcMB64PyEUNxkybcvT5i2g1fBYybNh4TrdGYvdSfaj8AGR
13879	payment	1726	1726	1874	1	1	4660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPYmTgwBPBoQjBSV8ZfXy5fCiHSRvAYjHaQpdPwSy6QWdse7m
13880	payment	1726	1726	1874	1	1	4661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmYmz7fT1xbo4yNWk3gZg8XVadmQxtoocXNUZwekLHWxYNjdF
13887	payment	1397	1397	1678	1	1	7036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpAvPvRNqe5ZTUfHiUFak2ckA6CBbrkqAM3MbxYdKrBbUjzfn
13888	payment	1726	1726	1874	1	1	4665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7LPvivxhWNBRejsMKVBg2Y4EMtU63ab36p1CJT97ATPFrP3R
13889	payment	1397	1397	1678	1	1	7037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFvcKwcSpdgvj3x2jX9Jd4Wigit9tZ4cv8b6j3MPNqFyPeokU
13890	payment	1726	1726	1874	1	1	4666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxacj1VySmfdLkZYpCmE3HsAhnwxtTHpjJKejxyBMhoFNjE2t
13897	payment	1397	1397	1678	1	1	7041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdThC8bxDEQD83PsfGeGRecWA7oqhtEWQdtBermD5XGpUo25L1
13898	payment	1726	1726	1874	1	1	4670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVgeHbmsZ8DtU8z6saGKiWxkKuqYKBoW6hSV1FoKEzQSeUWSy
13905	payment	1397	1397	1678	1	1	7045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5gykcp5X92hR6fHrTUFr6qJEMchCkns4zSKCoGQiHZQ5avaA
13906	payment	1726	1726	1874	1	1	4674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHWZeLeJiTtQJFdxUV3XpGnVm9ZT2zWbGYKHmkqvpNvxYH324
13911	payment	1397	1397	1678	1	1	7048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWG5ssqyiP6SdXoMHZ2QhKfDH9HS7EVkjF5ssN3enLBEmrrzw
13912	payment	1726	1726	1874	1	1	4677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTEyr8KrFRdRoJUxTkwRaSnDrcSnJ3mDy56CxgzG6DfSGXCzD
13913	payment	1726	1726	1874	1	1	4678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJjtnp7vWmKfGVH7Kf6iim6y3D6yCtaejKXDNREUkdX8Buufe
13914	payment	1397	1397	1678	1	1	7049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdUcfqLETviVTSTxFoGLADLYZrHujsrPhMAk2sd11LpZRmQvFp
13915	payment	1397	1397	1678	1	1	7050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxGt6Kcv9LRDFZP5my6FuP3qg8ZhKs9eXhox9DPKeWpvrx2ER
13916	payment	1397	1397	1678	1	1	7051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbzobcKFSEApwkPcxTR7VFeQeGSze8eUUe8AZNkuxcxaqRQxJ
13917	payment	1397	1397	1678	1	1	7052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDdnqwhWCbmhTgGnqABA3cpKjSoX7qPBgJnkydSZsuFnMajEk
13918	payment	1726	1726	1874	1	1	4679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU217SyGcMVdRyMDNSc4EC1VJ9SLh1RYyWg43K4f7fsTgvCfmb
13919	payment	1726	1726	1874	1	1	4680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpeP2dyLh7REmfM4VPrRzaQsubhzSsoETHFJVenCnxgbqbyUg
13920	payment	1726	1726	1874	1	1	4681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxgMbZYRkpSLQnCbkMrD6pM2zPNUprwhbBn2iegKWjBg4X9pT
13921	payment	1726	1726	1874	1	1	4682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLo7XWz5np4tNxL2YJoBMbczYUssQeNxTqP82ZFWBC3jaZBDd
13956	payment	1397	1397	1678	1	1	7070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoxBL7srSyQZMB1YfvqjPk5brpkP9ddPkS9X7p8o2yKqzyVWA
13928	payment	1397	1397	1678	1	1	7056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJwg34qP7DyLDwS156sPxjEZiThsoXRHXiTkwRvBxjpuQjKfa
13929	payment	1726	1726	1874	1	1	4686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicvcicoWSWoS3eKswsjeZtVusJkfW3mau72TYphAAgveY3Xk3
13958	payment	1397	1397	1678	1	1	7071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJLacbScVk264fX6XMthE7Qne8WtcEH5osHj5RaN1Ze84oSpf
13959	payment	1726	1726	1874	1	1	4701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVJp6Met8AvKZx5MWCAa4Axo1CWMpWdWgrxVZ3SAz4KQgcVDj
13960	payment	1397	1397	1678	1	1	7072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pZZd6WZwMXVcfSTv5i2we65BNBct5CC8MoqpH9TmvmD8aXvG
13961	payment	1726	1726	1874	1	1	4702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXNP8kfn5aqNoe9vrwZYUq3Bz4zwi7BdreFZb27ZcJ3z51YVH
13957	payment	1726	1726	1874	1	1	4700	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWomSqd51rSewzsFzzzCzVcN8VNMbwUiTwFD3L8NNs3HaPZ6Y
13962	payment	1397	1397	1678	1	1	7073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJe4VTEGVwk3WMtYHGc1vqDQbUS6PsFeM673r9RnB5yVEpjxX
13963	payment	1726	1726	1874	1	1	4703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEp4YqPH7PKYA3t7senjKsVfnpqaXnyPMagAXxTCWdaqZHfmWB
13964	payment	1397	1397	1678	1	1	7074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Bcr5HHyKV6F6uu5i7pbGHGgqgAzU38yXNsNjzA36qBSQFrUh
13965	payment	1726	1726	1874	1	1	4704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBDGgWkHphSJHBo3Mj3vEtfwkJSeH3CY96uVeXkumybiJD3cc
13968	payment	1397	1397	1678	1	1	7076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF2PJL5C6vy9bUwsJKseQPMCM57gRtYgx1HdcwNyPofgSaCNw3
13969	payment	1726	1726	1874	1	1	4706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqYhbwNdeK8odNh9nqe1hJ7JYaLGnmrivbsXHvuKCG2FE3jMX
13970	payment	1397	1397	1678	1	1	7077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8HKTBEfLDbsxokLzFmkD8PabA6zDrjeFkTRxYUAHTS4fPGmK
13971	payment	1726	1726	1874	1	1	4707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBeQdEZ1tfoFNbS6WSa2byjsRdznuZAwwAcmhdBPC3kSm7TLN
13972	payment	1397	1397	1678	1	1	7078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WiWM43YVvdck6yP4tJ3D3ZCBdMzmTRDHQgE5c2XVx7985jK7
13973	payment	1397	1397	1678	1	1	7079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenqZ6FLV1rnogomHoy4ybT7dQZB8brDDs4FLki5nYTP8rQgKe
13974	payment	1726	1726	1874	1	1	4708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbrEnKFxbR5QNDtZXye9Zm8f4qiGzFdVXWw6CfhLb5aQHDz2n
13975	payment	1726	1726	1874	1	1	4709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAamXtq7h7jU1EDmADVGH3gqKrCjPs7rAaCrfbfBrhuywaDEre
13976	payment	1397	1397	1678	1	1	7080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYucJZrG8fspTyeYuPeQjbNrgjN5Qny2ASXVaonepYHbWVmr4Bv
13977	payment	1726	1726	1874	1	1	4710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKsQWtYnjNeoXnhWnUDQrH84vyKqUaqMCMcg6wotBz4xJQQX3e
13978	payment	1397	1397	1678	1	1	7081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBjbw6vpz1odbVfpTrNUzJTGrioFfdXtueyTruSDcRupQZJvU
13979	payment	1726	1726	1874	1	1	4711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtVcY1GvuU3QpUu5B3v8zqW25GVpyPKAFwAXvQfe5VsULaxws
13980	payment	1397	1397	1678	1	1	7082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8QeBSJWr7Fb58nTtECSBJpkdjx7yFtNdMqkE7GZEJrk51QUR
13981	payment	1726	1726	1874	1	1	4712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFUttnhu8pHqR9z145h4twwi4xrtaZqDcGShwux6TxnzgjK9r
13982	payment	1397	1397	1678	1	1	7083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrRvKCGRDbxDunn5tFLNp5sovW8PLnde8C5pRpovZGuLUmyzp
13983	payment	1726	1726	1874	1	1	4713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQy77CnZ8F6TifQKgLtwjKe4KXvzVXKVGqmD4zmGsKNTPSYnR
13984	payment	1397	1397	1678	1	1	7084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9zqKyffQMxd3LeQNbfuCFto9FwXNamZea1DHjXqzv3q5WBEm4
13985	payment	1726	1726	1874	1	1	4714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TGkgX7GJAWm7imxXB9E36Sut83i2dYn9BE3TotFkagWPnpfY
13986	payment	1397	1397	1678	1	1	7085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNgsPHV9zVPntHnN6LBAUeWk77dJYbN2gPoSaYbDJTN4wZNLH
13987	payment	1726	1726	1874	1	1	4715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVRLf5CWPMNywEXXtXXMVcCamToEbysLiPP8zw3F5q8dXpoNi
13988	payment	1397	1397	1678	1	1	7086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rbjsNhDi5JwYfX4ZoV9pYWZNtgchN9eGW5feVLdm56CNmTpA
13989	payment	1397	1397	1678	1	1	7087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCng3JS4sBeUH7DyrFyjjwHjGS5HH16NytinNLcB8p4b84Q83
13990	payment	1397	1397	1678	1	1	7088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uGbCiGkSyCvUf3SxMVjB8BctP7fm1k1Kuv8Fboqx9dPkSmgD
13991	payment	1726	1726	1874	1	1	4716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJeLqRnAzrGJYsiyuvejmBN4S5xbKwcK4QcRJVWLTMuAkHQQb
13992	payment	1726	1726	1874	1	1	4717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7isWWVAdwr3a5Hg8DW1em9CkjqmXkYAJUYrVEDbqUw24nXHKp
13993	payment	1726	1726	1874	1	1	4718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3XGEaRw8hM36GThpcqopNAz6zMWe8uzaSfJK9yMa18JQKuYo
13994	payment	1397	1397	1678	1	1	7089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYboVsdhqZhwAeZQfDn8hVzMdc4Lo76KXYbcD8cdpabBJGB2T2Y
13995	payment	1726	1726	1874	1	1	4719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDSFnhMtCoUBkSZTS1Wz6tDjBWULBEA6AC2Pu34RD7Un7SCHC
13996	payment	1397	1397	1678	1	1	7090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DuDwFtRDTrBUNo435wnAQMsN6KGmW95B6gLGK7p4ZXt9BZwR
13997	payment	1397	1397	1678	1	1	7091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLMUFkSm6fHPgRLNVUuoCRjroA5ayzLBanTatqb4wMdPTWNZA
13998	payment	1397	1397	1678	1	1	7092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87spKEzHJ11YTWNdyMTKDh9rVrohSw2vtYmaAD15tWKwBYRn9
13999	payment	1726	1726	1874	1	1	4720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQcY6g1JfKzti2E6EeP3NUPJwRja9o5SqDgqHrmfDhDj9Mbjs8
14000	payment	1726	1726	1874	1	1	4721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRNjPLf3Fz12FWSbuHktRdPXdbWUz3Wh5nQyi41dXfiF5BqW4
14001	payment	1726	1726	1874	1	1	4722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cL3Jfx2pKDhYf6rHT1MqUDNccyrsqyyNfV5bWfbk9EropT6B
14008	payment	1397	1397	1678	1	1	7096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvY3TbsMHkxD5W4TAZJY7csSekW7ZnyUSrQsBrmSviPkf5wtJY
14009	payment	1726	1726	1874	1	1	4726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfZVnDsJkbkZXbiDWt4DHtxYVrwczKKrfSQVyjJSLjQE7Wug5
14012	payment	1397	1397	1678	1	1	7098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiJGgQupdQb9aGxapPgAh5ZnN9nGc8JX2EfGu2JmjyT4dLAfJ
14013	payment	1397	1397	1678	1	1	7099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrgFKdF2fpZasD8sxEFfAg8ApCtW2RnKKqAgU8T6afP6PSJZJ
14014	payment	1726	1726	1874	1	1	4728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4oqyuVXyWoCmimPR1w3KqTkG2gfzXi13VXVJrczsN4kYfgjBf
14015	payment	1397	1397	1678	1	1	7100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKuZyU3SoUoko1WEiTT1FrBvkcaTJvyeWyc7zeYmFTEv41Sgj
14016	payment	1726	1726	1874	1	1	4729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLn2hQbuCV4f3Ej51UzUJNciarhvQXokqN2tvnXhof133jm5rw
14039	payment	1726	1726	1874	1	1	4741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLRAQYK5G6nE6z91RanYZpcHEWtST1H8nYPdXfkLpf7ptJfKN
14052	payment	1397	1397	1678	1	1	7118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWP86pwjsfALxe6TUiRUqDHYT83X1v67yBKJ1ySWVXj1heX8L
14053	payment	1726	1726	1874	1	1	4747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8afhmKZQRqtJJ28eXyUtr2LbcChUZu7oZ7FPTy4SjxiKZG1ZS
14057	payment	1397	1397	1678	1	1	7121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRj5zWhorN6nw2KtrVX5oD5azxZhTBop4RfCL7UBm7Hcws3nxv
14058	payment	1726	1726	1874	1	1	4749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSk9F3HgYi33XDn41oi8DMydE5S7WjvuSiooiaAbDSoabK7on
14059	payment	1726	1726	1874	1	1	4750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNgHvQwVxQdZjENL6iDNaz9cGLPFspQJy65B5r92jQAiNsJ1H
14067	delegation	2075	2075	2075	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfuHJCnsEjtkQP9ax7G6fmhcSH8PrJ682i4dGN2g6be4owRQy
14068	payment	1397	1397	1678	1	1	7125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJPjjAvdHm9apzBWqaPPUxtxke14EGtrCTddHJduT7ADwvs85
14069	payment	1397	1397	1678	1	1	7126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLfRG7BKAtJaK1e6XGuqiXyKfeGGjnaCLgB5dhWCxeBHkbvTf
14070	payment	1726	1726	1874	1	1	4754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGGi6aGBEXpPvLAf3NS1estPPGqKjAJgi2sfTzanbMJr6SDtt
14071	payment	1726	1726	1874	1	1	4755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnuWdiKhS9Ut4SdM2mohQMn7LmQUyex7VMuJSHDBqgPBKvxjU
14072	payment	1726	1726	1874	1	1	4756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa488feaEYYKvSXjBsS6P7XZdtBZveX2SnQDVzjnZEuWuhBvrXE
14135	payment	1397	1397	1678	1	1	7148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5TtqoP3j8nNgPaCDqXia2SMhfstQoFgkSjLMpkAvSdgKVncC
14136	payment	1726	1726	1874	1	1	4787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Y3AdgmQJVLikUWkQxnYKUFEMT2RLtHXQNqEEGz3ZxKLFDzB
14137	payment	1726	1726	1874	1	1	4788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5N4R1uz6tjdCma8ieZNRPim1gfUAmLJpBWBXU6hQbTtBS3Mj
14154	payment	1397	1397	1678	1	1	7152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa95aRHQNEnKWqKDM6HdVuM3Y7AV1XnWC7thVhdKSey8nsgfDtD
14155	payment	1726	1726	1874	1	1	4797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbn46yDKjn4VPE7SudQLpfTw1t7MuQfZ31dFo8JSDQ4YPtCZ3
14220	payment	1397	1397	1678	1	1	7165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyCGj7vuqAFnxWoRjHa8d3t16RZC1N7hqgLWasroSGwkhYvra
14221	payment	1726	1726	1874	1	1	4827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCH67YBv5ymJvFxRda97LoqSdoN8215hyYtSarSL49WMHvfgmf
14222	payment	1726	1726	1874	1	1	4828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoXT3Yc5h3997CCSfM3RFHu9MG5uYEC9kTnxPc3JnzybQhF4V
14223	payment	1726	1726	1874	1	1	4829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4v5zKEq4TgT4ux4aayTw1kowWAeNDoRNaUmgfybKjqnQ7sWx
14231	payment	1397	1397	1678	1	1	7168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLr79YEhJEtasi1QcB5zpvepm5v4AELRXa7mQ6XiKk8PGQ9n2r
14232	payment	1397	1397	1678	1	1	7169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEengcwwV5u1WV4dZhtduESy9eZRMjZM2EoxTypNwGrR2iHaME
14233	payment	1726	1726	1874	1	1	4835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT5pnQQbJev1n6kUBPm3XQdLhXcbZ5omVou638eJqVysQFk6wT
14234	payment	1726	1726	1874	1	1	4836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPvebK3puyoqeUS7ymQ4kkBdpFSQW3RTThkMN4VX8n9GMmdBN
14235	payment	1726	1726	1874	1	1	4837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCf4LdHXvdpLQMhfwkfZnchfFTtrG6nMfw4ePgw4pkc8GgqZB8
14236	payment	1726	1726	1874	1	1	4838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWuNC5Fha3heSkeeJuLwQeEAuezc5RN2xZEfdS6y3SkvgzTUB
14237	payment	1726	1726	2083	1	1	4839	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaA7MoBjU2ANcVeHnGL2fHa2b6bK6CB6N3Wnxj8GrqRtcFH4iTs
14238	payment	1726	1726	1874	1	1	4840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreDibwyRtjrLJaMSUqcxzdPPB1MF2FCmveYnqXwWetXy8rptQ
14246	payment	1397	1397	1678	1	1	7173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEMqZsc4F75GB8N92rQno9BjC317seVRxcbkcPqJQteZgb6x9
14002	payment	1397	1397	1678	1	1	7093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rPeSCHvbSsXJ3eNdC7PUbX957qMhda1m2tsbupu89sC4bzj4
14003	payment	1726	1726	1874	1	1	4723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFgv9T6wKQgorzYAkBJA1tB2suzezhXAPHNYBTYXAg5swdtN7
14021	payment	1397	1397	1678	1	1	7103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yUXA1ESizrtD5wBHXiRWAWB2dgEAKreAxxwyxEAb1SQ79t7G
14022	payment	1726	1726	1874	1	1	4732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUHM7RUyLhjxnVdaGjPu97sDBQ1U3fLWdCyemmvmCKcGGHp6M
14023	payment	1397	1397	1678	1	1	7104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoW8WXKKJcrwH7xUhwQHZmB38kwihEdy5KpAhRkk9PVUvY3hd
14024	payment	1397	1397	1678	1	1	7105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLADW2sDh2xYKvMq8rK62qarsHfk2ZTcDdMoEvcKwVnE82zGLe
14025	payment	1726	1726	1874	1	1	4733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGaTRJss4ygkB72MouDKLWaBXReyuEMSxE2fYnac4BSsZwHFu
14026	payment	1726	1726	1874	1	1	4734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1rXB5GqhGDd38kpMiBTm9kSS5o7AYrRS5V1mpSbZRT4t1ddC
14046	payment	1397	1397	1678	1	1	7115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGo1DNtaNf7QGZTvRBHv7SpyBXB2CYPbHLaasg3jnfFSVrvtRm
14047	payment	1397	1397	1678	1	1	7116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5652MBVkuSKhgpFRa3mgujCuZ4qEE3m7o7WivnRpJf2J8zr8
14048	payment	1397	1397	1678	1	1	7117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Bw6L23a6gRyKACm4Nkk7URWwZkkRV9oLy1gSJsnECTfGfHKG
14049	payment	1726	1726	1874	1	1	4744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebHiB5K3YYkQ45wLyMzKqvbQ1CZjUFPrGuJdz9VF6MJbzsdh7
14050	payment	1726	1726	1874	1	1	4745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4yvwLe2w5hdKncRczTzZsF55Cu2zR9VgSuA9YNuYnmL4kj6Z
14051	payment	1726	1726	1874	1	1	4746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GM2NbdkYXtBjm45HGhooDCaYbo8fByvvxiv6nEfpxedbmxCk
14060	payment	1397	1397	1678	1	1	7122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiYtTU2Jxq2TwZkR5yhHiqVn2Sy6ZC3b83JW5Yvy4hWJFqmBx
14061	payment	1726	1726	1874	1	1	4751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxRUGxWgz7AQuDy2Ndx5qvV2s62Rb8nBdeYfTsxTWhH2f4fa6
14078	payment	1397	1397	1678	1	1	7129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmBtHDN8orTyFF4gvgrpXCkYWLYfgkm7KvQjopo6XapgcNQjg
14079	payment	1726	1726	1874	1	1	4759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSXHus2Jxy85fhcVBzkBrBuWPnTdFCWRb6MhH7rL94eT8XtbVN
14080	payment	1397	1397	1678	1	1	7130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZnzzx9wXVXrT5fB441D9EmsWB2ikvjasJ9eaJxVQymuTD8QK
14081	payment	1726	1726	1874	1	1	4760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoryQCHtmZi1uy9eaahrbYVELbEXthRrk8yQE6PW5CCKTkA7vY
14084	payment	1397	1397	1678	1	1	7131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2A3pKjTtD5XPdtcT3JdHwzXM5jrpBuDVex9KoeCknTKiui5pD
14085	payment	1397	1397	1678	1	1	7132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBS9K9GCpvDGo7PrVx7JanWesEGYeajNwu2WzEWWDTr5b5j4e
14086	payment	1726	1726	1874	1	1	4762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQz6aYryAJnWcBi7MPMh4td2UvY8j7CCvDENHw6oyn7fafnqV6
14087	delegation	2073	2073	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSJ7Xmiv6akKJUD9JNcG2aLV7EagU1zgZ1LmwnAXWwj1rYntD
14088	payment	1726	1726	1874	1	1	4763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbDrg66ZvELKc61cPBG1hbSMavERC1cQnZrmFFe8E5576zjReM
14096	payment	1397	1397	1678	1	1	7136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3t3jmQVYUkZj8p1mjA226Xfp3oeBuc9faMaXYqt1M9KxQCP5
14097	payment	1726	1726	1874	1	1	4767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmUSBWLHGMpfhNLt187Dp25LVvLsaiHkSpXBdp5tsxisx768F
14098	payment	1397	1397	1678	1	1	7137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarravXhkf448dXxBxdbT174kjT2XTUNPK9x7GwN56hThHjXcc
14099	payment	1397	1397	1678	1	1	7138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetAyL6YNa4ey3eXAhpjF5YBJQVMkV3XQ5pE51v2o98ZqwsmUQ
14100	payment	1402	1402	795	1	1	1	259619730296	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ9dq7y6WYrsBivS3oufBuN2DXLN3VPxLkMzKMr6F2myEmJFCTg
14101	payment	1402	1402	796	1	1	2	2855814541130	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYhcQXERwycqbwbXe8MG9UPZBwZpT5xw51dj3imxFuDSybrFvDN
14102	payment	1397	1397	1678	1	1	7139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCXfmpxm5sDWEzkgu69PhBoY2WRCTiWmQXNggHoawpZAdPJYm
14103	payment	1397	1397	1678	1	1	7140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1znuqvRRpKQXFDp8RLdduhQ5e8m1caHHaPtjs9USWMXe8saTJ
14104	payment	1397	1397	1678	1	1	7141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNdSQKPREx98gmt3kgDiZ6ybzs4ArwpTxveSEz2qwTdmpL2Ug
14105	payment	1726	1726	1874	1	1	4768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGhXxNYgmL6FKB2S4CWSfhrZYKvhko4aVRPnS3Vk4ksDYAhqU
14106	payment	1726	1726	1874	1	1	4769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3igssDVCu3XRrt7kJZUjD6C8GcRLnrRtq9dLXkGWKya9UEVj4
14107	payment	1726	1726	1874	1	1	4770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gv6jW7xy2J7LDYcXwprzsuEczzWfvZg7YHumPeDsQoMDtiG6
14108	payment	1726	1726	1874	1	1	4771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYprrZs7B3i9HV2uSW1YqWKg7A9u56ZYnGuLD86PSfFUvoVoKzc
14004	payment	1397	1397	1678	1	1	7094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUAyNzewvquN1UwJ1275QCf5bW7oLdtsM4pNgkNQXBeNWxpZf
14005	payment	1726	1726	1874	1	1	4724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtt6gZ8uq8atdJLpuEay8ayqiznfZcHxGXNBF6u8mF2Q5iy25x
14010	payment	1397	1397	1678	1	1	7097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKqYxsEYbKAxhrzkewpbhLMxuVX45BhSKPsDZAxD3UJpL3pzS
14011	payment	1726	1726	1874	1	1	4727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8fHpt4fGEkrxfJC9ofukLYPaRm3pQc5qQPxbWmcVhN2PV8e52
14017	payment	1397	1397	1678	1	1	7101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMBUn5zXoNSjTSBDU28ER8sbMaBbnVXAo4WMT7Ak3g9LwSeWf
14018	payment	1726	1726	1874	1	1	4730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDaQxBxAx8VJMGkSdUkAwtpJwZH6Jv8wpoCKm7hzp9wgisL6M
14019	payment	1397	1397	1678	1	1	7102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpZmgZDQwdJLXJRpHjpNDw4QRXDxCGDcBwxQmSHK9dmJ73fmv
14020	payment	1726	1726	1874	1	1	4731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUo4nHFJtEMh9brK2NTfqSEJNHRV6wuY7GLDRgJkmCPwt7Tk1
14027	payment	1397	1397	1678	1	1	7106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQsjvV4yAuyqysPWYH5Dfvf7jmUAWdUdhP2ZxAEXe776CUHf2
14028	payment	1726	1726	1874	1	1	4735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrjRDuU59ofp1rppJ8xanAJmSSYpwtySSs5WTkF5gu4EWShHR
14033	payment	1397	1397	1678	1	1	7109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEErDCZ2s8hDLmpA1knthQc3dzYJrQDRyw8ybW5Ty4cbCdhxS
14034	payment	1397	1397	1678	1	1	7110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsM83WErRpAeUjuivARSykNj6paVg6ka6pjCw51b2iM86ahwaq
14035	payment	1726	1726	1874	1	1	4738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFW6RTvgJLsrPTvRmBnfzSMpEVdcTKZeRCEpVdnT3JFd414Fra
14036	payment	1726	1726	1874	1	1	4739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyTsb2P6hyt4gBseMV3hZCDo6DBzSniKkwTYd4euDMsEMKFT9
14056	payment	1397	1397	1678	1	1	7120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwqSo98PiCU7m9tjdTyJyCUm85TRRecV7z32mrp7kTAxevfa9
14076	payment	1397	1397	1678	1	1	7128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNKvpJ2EQ9FXMhNHWxKVzePYr73EpZcV1Jp69GYxJumhZzFzN
14077	payment	1726	1726	1874	1	1	4758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaYtQkyGc7VPGStTSkQpde4cMUkgwZPEBqFsmrJhBRu1ZYJC1
14116	payment	1397	1397	1678	1	1	7142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1KtySBwkwm5p2xmxhzweRY3uvkGbesUPonyCXqXH5uDGpThTZ
14117	payment	1726	1726	1874	1	1	4778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9ZEpqvqkb5BLoTF8HfkW8YMMzB5nRMfZSYFgwgreZZ9qsJmJ
14129	payment	1710	1710	1507	1	1	5	100000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dXJPGLzeQWLTUCjg3DmW54D1LNmFuc4A8tUrhCK9uu7mLp4S
14130	payment	1397	1397	1678	1	1	7146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HcpjNwDDs8nJzCvqiHfFSbGWTMdWQtyFRmsbjZLQybnspLo1
14131	payment	1397	1397	1678	1	1	7147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4ptQSyo1dMPpSPfD3JzLXmmAs1uWU3ivVscvZZEeFJj8rBgh
14132	payment	1726	1726	1874	1	1	4784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFUgfWhh6obdAytkf97FNrxEW4QD8M3ZHQ2bjSio1vdWHb85T
14133	payment	1726	1726	1874	1	1	4785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnmZMg3BhfFun2CjSqemeBrZWZFcMpBz7h7QwzGBo1CnJHWXF4
14134	payment	1726	1726	1874	1	1	4786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTfE14U8FjaM79CbnMpzQBuUa4nuWfCEidmV7YiD48DnkUcDs
14146	payment	1397	1397	1678	1	1	7150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pYn4j6vWL1DiYS1vocLf87SMM9XUj79hFiZKKJmtX526pEG6
14147	payment	1726	1726	1874	1	1	4791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLVCQ1Y5JN8LNKYY7R1qrXXLcjV31VP6BWWydKAbAJC1FYhQq
14148	payment	1726	1726	1874	1	1	4792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3Dt3ufeAZNn6h9HuJ1nhGvP2GZAUMx88euGjKyLrJHzXh9N9
14149	payment	1397	1397	1678	1	1	7151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9B5CutFweLjiZsL5zr2bHZKTi2YGe8rTT4HRguFVCFxHUXNnr
14150	payment	1726	1726	2080	1	1	4793	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLWWsqpnWBC3VVUEbYEFPEDru7pRLa2hTZnRfxPJq3uKVC7qa1
14151	payment	1726	1726	1636	1	1	4794	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKggNb6j3y4NpPuhLg1MXWZ3DSjBddymUEM7DWWUztQQDBzwMv
14152	payment	1726	1726	1874	1	1	4795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RitjkCizaHyZQA1LdUFQkYkWmtFBenCaaZ7qoufUWcBYsbnX
14153	payment	1726	1726	1874	1	1	4796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmEc3MnmxG8AkcHQbTs5ck4WiqPcNwZ6rNj1f4PHPCK3CSMjf
14158	payment	1397	1397	1678	1	1	7153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq17GSXTPeydcyPRJZxkMkhBcxKigC7YEBrwJFWuJ467BsPBL5
14159	payment	1397	1397	1678	1	1	7154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKGzSe7iXQHd7fTajv7qYTryTjvR1Vfmm4SsdSRDNPtcot5w9
14160	payment	1726	1726	1874	1	1	4800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYTAErAUTmbLwXCT8tRkCe3gHqSrinUqgMdoayCpyMKCMqBZn
14161	payment	1726	1726	1874	1	1	4801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZ4qQwLXRbYHsPtLUJ7jnkUfNs7KVnyrHP2NAEKb2y5KTjkVX
14162	payment	1726	1726	1874	1	1	4802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82jMrSCpwwaZSbi5Yn1YsQ8AGyNXuyuRjvigdr28w94Y2STBR
14006	payment	1397	1397	1678	1	1	7095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAUHV7vQNfSi26XkifUESAruKzU2osi2HkKnb34teT4G9uE8o
14007	payment	1726	1726	1874	1	1	4725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQa4dpcJFa7KV9BQawLWQY64LV4ujYhM29fdSYJ71xAu4BKmB
14029	payment	1397	1397	1678	1	1	7107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUkLTu1Nb36wz2DdbxfTfUxkYF4m4JWLjZNLPovjMTkeyBU5A
14030	payment	1397	1397	1678	1	1	7108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzNJMAA9DQ71fJ46AJTpgnYrEihTquve99evdZ5WYWWHSFviq
14031	payment	1726	1726	1874	1	1	4736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVdoaF6KpC5ejdRdj4rVmpetQSvv7cKFnM2d4WGKEjKiHj57B
14032	payment	1726	1726	1874	1	1	4737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYauqThzfvHWxGZFinrpZkueK8KUdNNgHJ3Lsxwua46WVRxJKKD
14037	payment	1397	1397	1678	1	1	7111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSn6KHhUSBTR6rAP7ja6LXNbqSWNQStaGGG37a7TTUXZNiRpo8
14038	payment	1726	1726	1874	1	1	4740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGT3rYqze1WRnNwiCPWPoUPGKTWb6vsktnXfwET4WWiSaBqJvk
14040	payment	1397	1397	1678	1	1	7112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhKpLjf7PxqBHwYioULFpboUDRHMnrjwhA1uynEY8m2dxvvYJ
14041	payment	2054	2054	1713	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtnRLa9SQK2Ee2s65adHkibmUMKHtEifs37whEXBR59Sx8Gcy
14042	payment	1397	1397	1678	1	1	7113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwMpeGZqyi7CJE3xSoaP1aPq5EXzai74RsAYCRMfUHpv28ADf
14043	payment	1397	1397	1678	1	1	7114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEQRkqjZNZWDosWmGAsJSjZqFSMZ1M8dcD8gzqmZccqVp8od8
14044	payment	1726	1726	1874	1	1	4742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYs998afjCzRjXpAaPirKF3im9sdUPSdpVUHoojteUhRt8wirj
14045	payment	1726	1726	1874	1	1	4743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bWnRd8Vk7rWT5Uh4qcGCxguvYXa22acRi3LytVsTsu8ZEJfW
14054	payment	1397	1397	1678	1	1	7119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8kUrTD17mJDZQqqi1as2XCvaxF7NWV3Hr8pqLdYurQ6Fkzdei
14055	payment	1726	1726	1874	1	1	4748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1K5YmRSbJ3k5cPBAEYdQjRu3BmVvynHULwutofkTe13h4HeRZ
14062	payment	2075	2075	2079	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZsZW7F8cCkQnMXU3s5HiLvruZuVJwZaTffDT1xZq2w3MJQAS
14063	payment	1397	1397	1678	1	1	7123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8dKu6Ufun7RpWxm73vC1nHMi8mLwb4rUUK4FvSDwAXmJh68J
14064	payment	1397	1397	1678	1	1	7124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevik4urWrqt6pCZ2MoseHJP66B9mJ6ETefuzUegGiFDBHnCsu
14065	payment	1726	1726	1874	1	1	4752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQso48fmkBXV4dsZvUqyEryq1pfzAt5V4tQFV22uFonV4N63kf
14066	payment	1726	1726	1874	1	1	4753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsE74yHuJx2X82TzcSENRuERnFxrYmA6eGcu2HX64Ty5XyqbhN
14073	delegation	1693	1693	1483	1	1	666	\N	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYXCofLM9LfvvXXP9Bw4kDZk	CkpYino6G5WMVrkXb4dphK8eeLo2LY2LFVwiR2MHTjmM1qAUfYn1W
14074	payment	1397	1397	1678	1	1	7127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyYquuh49TnJJsqALghZvU53QeFmi5n72w7mfoG1gRpcZoAm6n
14075	payment	1726	1726	1874	1	1	4757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrdUQ2seYPuhGfiU1L7MKaPjA3kGx1UrrL9Ctu8nphMPuMrh2
14082	payment	106	106	2073	1	1	1	413000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FfhxzD9HaWK3jLZKY9yURdzwr6gh3ZxwKbGz7X8v3XqN4gh2
14083	payment	1726	1726	1874	1	1	4761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHFsFCTs69DWjvokvbCqYDyTZYsZR79yYg7Lsg8TXjCkuMVivc
14089	payment	1402	1402	34	1	1	0	312983391438	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYUUAp7K79grXKmoZpKfXpKYovHqsufiFNCC7p7F5d5aB1TVcoM
14090	payment	1397	1397	1678	1	1	7133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVtpUhGTd1HtnZ2k6HZQBoSEoJCqtEKhUGmmZLZxo1GJKXJZ9
14091	payment	1397	1397	1678	1	1	7134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtX7iSyhEaXcHXANKneaMra1C5YMw4HCBLDB2MbhkPfxkkjkW9
14092	payment	1397	1397	1678	1	1	7135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4BdUumfdnJkpai5jc77NwfDuHBXSbXhPucPn26G6wkv24PxV
14093	payment	1726	1726	1874	1	1	4764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9B7RCWrVeMPK7ePfGhCVHBrRKuDybvntJkpGvCfaiEfB2guy
14094	payment	1726	1726	1874	1	1	4765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjehyU4fA3VrLBLmesJ7J8L8pssgE6bG5wLurrzTShwp67Aev
14095	payment	1726	1726	1874	1	1	4766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXekmAJywGNaTv3SuzD5vxUry73rSyE18Ride6xC46hUWhiRp3
14118	payment	1397	1397	1678	1	1	7143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrQfQKPDzVkvcVQhnc9VdFRrdYPYZxsSRLku3HZs8fa6fzSah
14119	payment	1726	1726	1874	1	1	4779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDczAGbcMKC5MncyM3Ca3d2Te8jpG4tPxdcb6CHNYmoyUEPojR
14120	payment	1726	1726	1874	1	1	4780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnTPMnviUsPrbxVDYb75vqomZUxYzVabYVd7rmvX1YZXo9zCU
14205	payment	1420	1420	2082	1	1	0	5000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNwpVquiLgXGfPazG4dTUmxHuJRAyYyB5CEZssBcaar5d5icR
14206	payment	1397	1397	1678	1	1	7161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3UQ8Gs73kSU7vwDKDRJqu3WW4fqZKn2tPENToyuXuwthwGsw
14109	payment	1726	1726	1874	1	1	4772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrkLEDibe4LdxHhBNcyrH6eQzFNpcHJ5omqQ4KTGidQmWDyE1
14110	payment	1726	1726	1874	1	1	4773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdBGdqpMGb7NyGtTeobEYch8NjMtBxUa5JoQCaedDCFGq1NwK
14111	payment	1726	1726	1874	1	1	4774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYem4YFpZUPJtbe8Zi3DE3psb2L1HjuDJcJG2YGoq4a24Y9Jk
14112	payment	1726	1726	1874	1	1	4775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnqJo2rsgNobcWu6D9F6HWRFejZ6UVRKW25DSu3kba1G8QqGg
14113	payment	1726	1726	1874	1	1	4776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5618ZEuzfJp84DadieHnnXkiT79h4EkmLaJiMW4N8SUen3Ki
14114	payment	106	106	1483	1	1	2	10000000	1000000	\N	E4ZRf4XWzWLF6BwBq4EWzNkqeUpxwvxFezFNm2sj237BFEgorx646	CkpaBeniEm4h7hJTWApfEkh76uz9YAhqsZ6U8HuwioFLzTtX1MUdf
14115	payment	1726	1726	1874	1	1	4777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkMdGuw1xMhCi1dBrGdQ4by2Pi4Ph1dkH4pyVtcs2J7mbwBuE
14121	payment	1397	1397	1678	1	1	7144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgTLAwCzppkcGCMUzYg39CHWWBCNYrMRfcuHG8MKG1wAWy4iZ
14122	payment	1397	1397	1678	1	1	7145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZN24gQL78NPkK7ADuX7drTfe1zeWg59ypqS3b28rgBvMh88m
14123	payment	1402	1402	807	1	1	3	122977766961	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZxNjZWDNMfYJNipbvnRwa2uX4XmvD6vbEAA4EmSCkpgQFapaFd
14124	payment	1402	1402	808	1	1	4	1352754256290	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZGCzVvtRJPPiawdSE1qrEZyxGWXpnfew7Ta7KFViM4Bdux9HMr
14125	payment	1402	1402	809	1	1	5	279086220927	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYaByc2M7V8HNfX8Q7AeT6wstmksS2FsHjf7Rf4ZBauar5bDRRM
14126	payment	1726	1726	1874	1	1	4781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdm892HyemtKgrUqcX7diK2SJPW2iZj4j59ZS3tnsh8CSnESb4
14127	payment	1726	1726	1874	1	1	4782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Lih9aibxAgwsrHnuJxRLsPoGhx9fTQMw16Tu4ZCP6EJ53hCc
14128	payment	1726	1726	1874	1	1	4783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGYsSZuPkEPDtt61cTXknFDbkvM9cYYxhz5mzDr9McsvhpoVf
14138	payment	1402	1402	810	1	1	6	3069945751228	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYVo6pS9oXKv78rgQPmemiUPyGVr1XVjn2ukwNKiaJmnfgi9KhU
14139	payment	1397	1397	1678	1	1	7149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVedqTZnyE1TFSbtpDHd847fDWtoxfaSyEMpfzoNh9959aXVRq
14140	payment	1402	1402	842	1	1	7	389207747947	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZkV7RuujeLU7K647fPiSLgSZkxVf7fWyfrW2TdD3ciASmmrBF5
14141	payment	1402	1402	844	1	1	8	725623588957	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZeunxMQc36wt8tUuFPpo69YmLL7utEZgBx52iCHf7zQCzmi2fx
14142	payment	1402	1402	850	1	1	9	5372383091570	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ7XozWzLeT1Sx5QmiP9GSRR5ZSi8Hnsmu9PhKx3tc6gT4GhLvf
14143	payment	1402	1402	852	1	1	10	10407116782127	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ6WZ1c7VaBeMJVXz2QJVY22UAeNqKyCJ6ZjXxqwUEEVNFsYubw
14144	payment	1726	1726	1874	1	1	4789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jyknsMCmQj4qwu6qgwKYjJqyzP9ZynYAHUTNc74wR3JeE5bU
14145	payment	1726	1726	1874	1	1	4790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2zerLwN4ywPKL8SVLq3gL7AydXcgFAWfaqjk5SKsf8mQ1SjiM
14156	payment	1726	1726	1874	1	1	4798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyM9odxnnjVxQRpgF3ub2beGZHJzpWCEjYRs3BLNy4dc8zmwn
14157	payment	1726	1726	1874	1	1	4799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFCXo1aZfyWF81Nwh5Sy9a1EC2hYbfSwZ8CLhBmeeRVU88oNZ
14163	payment	1397	1397	1678	1	1	7155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3VQ3NfSsN2meGVTBSDRECVK8UstLM7m2mgT9C2SZEjB5hSwi
14164	payment	1397	1397	1678	1	1	7156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyfR5GMnbg8CK8tKrQE7xtk8GBhm1TMnhntVR1HdwQBfH699L
14165	payment	1402	1402	854	1	1	11	1147552076813	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaAZMsWBqdkciNASkwzgcVxMZKm4xk4xW4qGrFin82TFPJVe2hV
14166	payment	1402	1402	856	1	1	12	607012040752	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ9pubXjxsFXGs6xkSUaD8zRUdT5s4fvAFUgQM1Avjk5Cd3mzev
14167	payment	1402	1402	858	1	1	13	1530571790543	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYqmfzRW2nTpsf8NEnQcmm2J9zW2kuxgTia8hH9DGJScetT87YH
14168	payment	1402	1402	862	1	1	14	2114076417905	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZKsShathopZoHiatALAatrZeNfBYk8KcC1fwJ9Po9o68LMJRq4
14169	payment	1402	1402	866	1	1	15	1855921871779	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa5rf5zi1iqeniZmT3tDsp2RoQ5dXRh4RkAMpbCN3XLXW2V7xGU
14170	payment	1402	1402	868	1	1	16	11302982831172	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZKUWeY7cTg5fpDqfHeSXDxFs3v4U6pwmkouLKtJU2QxxNqGcqi
14171	payment	1402	1402	870	1	1	17	1208766101386	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ5oX9wYH9LhfmViwqRQtrDCDKkiTHC4bGsoaCXaSu7Um8takE9
14172	payment	1402	1402	874	1	1	18	11302982831172	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYUoLtd18goyUhgj5aiXiGUMEJd8R5ytq3qArM6Po1s8wN5GbWo
14173	payment	1402	1402	876	1	1	19	990755284935	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZiFXQGG8rPhVfGGTDin8D192GUgGopXVgpN3krEzXp58BKYvWf
14174	payment	1402	1402	880	1	1	20	627943490425	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYhTgegmVKj2PNGMrRcwJeVcuiKVRH13xiYgGAA5Wg4hPW3Thdf
14175	payment	1726	1726	1874	1	1	4803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuuuxarSVYVMQFJuzmAFRZD13AxXLYF54SnnQCJqmwowthkY73
14176	payment	1726	1726	1874	1	1	4804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgPaBGqsaLW7M9qJtiKnksXp36PrrWj7cSmGrjwtABD5prEVC
14177	payment	1726	1726	1874	1	1	4805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3urREmQUd7TwpvBYEJMtPPcXKdf9eb6izA6nkpmmx2u3J6bw
14178	payment	1726	1726	1874	1	1	4806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQEoVp6bQVnr3r3kCk8WqunR9pQjmJLiD1rLFiLAMe4gukejV
14179	payment	1397	1397	1678	1	1	7157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rAAm8tVtvGNh3Vn1GuusFYYqet5CK4b6x1gAydhYWDTQSKyZ
14180	payment	1726	1726	1874	1	1	4807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtbn8PugJe5wQHukzmokWw5RzvdWAgsEQsjnrChooDvtqsz5M
14181	payment	1726	1726	1874	1	1	4808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSNVtZpumoMjy7W7ZdffPKFvJ17YTNGt5HZHYKH7weimkenXY6
14201	payment	1397	1397	1678	1	1	7160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2hDgskqcZX1jEbrB68ZRk1zVe4qSobMkkHBjTNpVv4Gzvevw
14202	payment	1726	1726	1874	1	1	4814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryUxnWEiVuhG7itkYf5JTzRUMUAoh2f5N7pQwWTURCXJbUVZy
14203	payment	1726	1726	1874	1	1	4815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92TEvzjGNG6fHmKerBF3mTw6zF6KMUw8EHQP41AZUR7mC39sw
14204	payment	1726	1726	1874	1	1	4816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dqb3Gbx5oJGq9FB57No378ySV51PZawPZrdQ5XwBTKtqMLaZ
14217	payment	1397	1397	1678	1	1	7164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9y7HiZnJ8zZaYZ5pxjVzrrVY3VitzKJAnLmYMh4d9FD6yjiq
14218	payment	1726	1726	1874	1	1	4825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApBvhiGF2rHfEktmmK7eUWCV1P2H96f3tcZ8GxjFfLFBjnfA5
14219	payment	1726	1726	1874	1	1	4826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ98wwRaqnoesNA8vLb8pH9aMhWyVtgbffT7AhnyxUq8NKp9hUL
14245	payment	1397	1397	1678	1	1	7172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qFpszBQyqGio29xevDFmxCAq8M47CsFzA8ZaUymmyuUUvHAW
14279	payment	1397	1397	1678	1	1	7181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuneBKoi1Ee8FKoPXdZMQHAxgM1vd1i8az6CV596g6Qiriqh25
14280	payment	1726	1726	1874	1	1	4870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFmREPubHmdzL6BgCF4ZFgB7FhNUuPMBszxSVo9Cq36skYyQv
14281	payment	1726	1726	1874	1	1	4871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxCvEDGMUZpPwYbHRj35AHSYguFAYe4AwiicJX5KvT2HP3uX2
14304	payment	1397	1397	1678	1	1	7188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5y423SDNujcMZ6Cjen62HuEzg7QmQtK8V5zDpHYqpqgdLsKB
14305	payment	1726	1726	1874	1	1	4888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx3iJYksGsWZF8BABp7xz42Y5S9bcetNUhZMjysmdMETFXXJm
14306	payment	1726	1726	1874	1	1	4889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fdJ1e7Qo6zc6cY3yPEmkwiLgmqtCd1tPDBYv7WqBVyFmoQ7P
14307	payment	1726	1726	1874	1	1	4890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AheGQvgt1jQG1gPZ8z43AmjqUepLjVs41LQpZ7iLbADKoDaD
14314	payment	1397	1397	1678	1	1	7191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDHwUNZQfoLDZvRHWxQEcFR2qbzqW2iRRoKMnvLpkxZpxdm6C
14315	payment	1397	1397	1678	1	1	7192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpc85HcPTFtSEQhyTWykH3CzNXkr5Kg2air6nbgLyQPMunPeSN
14316	payment	1726	1726	1874	1	1	4895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCa6VfvUARSk33DTVM9GMCzDMP7DS6xUYii8QfCqrAAb3QB39
14317	payment	1726	1726	1874	1	1	4896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLrc4XkMvG28pV9nJeKqptTEnTvffyvVhiryqv5Jb65KYrxdw
14318	payment	1726	1726	1874	1	1	4897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfnEJkxVcGYHVAWLcVByqVUPe7JqGXNGTSYCMmzSXNfbCKVq2
14319	payment	1726	1726	1874	1	1	4898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHGm6xa6KYUTnGLVy3fSdSByT697mUXTsfhzssrGmcnQpVwEN
14320	payment	1726	1726	1874	1	1	4899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADQRRDBrMxc8emH7ckZmmJBbATw9oKQCPUExiLGyDXzpA9WhP
14321	payment	1726	1726	1874	1	1	4900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRYfUTpYabWXMGsUA4jvLqiwiLCtRjhTbVYex7s786TVDH4X9
14322	payment	1397	1397	1678	1	1	7193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJJrpmsPgcWx2DFGKRSighHobimu1oa4KafXuPndZjJQCSHtt
14323	payment	1726	1726	1874	1	1	4901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAfCaDsHpxAPkJJ6BAF4VioAv1boBm4987kMzwrWgZrZ1gjSg
14324	payment	1726	1726	1874	1	1	4902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9UQsefajQaTvfcbLgdn85oETr8RENqNEFaJeJdDXJGqf76Zo
14325	payment	1726	1726	1874	1	1	4903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Y4xaiL9H1SFVXt4TCvQV5pmbSn2XdvgAQDmtRqppQKQ1bH6d
14326	payment	1397	1397	1678	1	1	7194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVr6bHQwGbuHCGbfMQQZ87JTFKpRACSXDt5hM5XHu9QNbhZaqJ
14327	payment	1397	1397	1678	1	1	7195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZCGrmp3zc7eWhZ1euB5X2F8uqioMvE7DBaYysvS68gf2Y8ie
14328	payment	1397	1397	1678	1	1	7196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgjo7QWBgy9kiG2oFWEQzFjiEKePe9AzZp3E5YTU2CCb7qh4Ss
14329	payment	1726	1726	1874	1	1	4904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzBhV6Bu5EbZFJ29BMPXJZ2c7BB8585LVWM9974D63TYDJJGi
14330	payment	1726	1726	1874	1	1	4905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNW19o93RL7qGYBdHPHwboHAN46hJTi8BWiyw3BXDrsXcpyF8
14182	payment	1397	1397	1678	1	1	7158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnKEk5PhFT4E9i2ghfN3UW6mBrqgrpjj3u6nKnQVHQgFAC4Fw
14183	payment	1397	1397	1678	1	1	7159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3T6mfNWkXKNgt7Wouuykrm9vHe6feowMHoGwVqTUfRvEQ9xf
14184	payment	1402	1402	882	1	1	21	2721088458699	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZvehksKQ8mXQfqKUaw6TCU17tLgUVuJCX8VjFvULg4RNo1QBHR
14185	payment	1402	1402	884	1	1	22	418628993633	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa99CRFMJT7MBw3CXMx9ASTqJKUYksBZDnaTXVUQALKoARyw6LA
14186	payment	1402	1402	888	1	1	23	1249435908129	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZhvn5SYkScrrR8EaAmmFVjEWyEUzx4oXr7XpiFWPDebHkYmT1Q
14187	payment	1402	1402	890	1	1	24	1048834476096	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaDiLjW2ekWPNm3uyKJpCPzFnPp6GLF1fAKEij49VAYeRQzoWpU
14188	payment	1402	1402	892	1	1	25	2302459465037	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZtabmsE7paW55bNCru9EFwRWcjFua4wR3jAYXKdQgMLup3EGdh
14189	payment	1402	1402	898	1	1	26	303723707441	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ45n4PWdMaJhrWomviHaz3sAxCDFoPujYvpuntAq2VqeVvdbC7
14190	payment	1402	1402	900	1	1	27	181048667141	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZrYjkjNyNbVuMNarg6xyKc4SdxsbiZU9PvfrxcVPGVmxLF9yAo
14191	payment	1402	1402	902	1	1	28	544217691679	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZypVG3aFnnqCjR8WykMxu9HT5apDnVvsrqD33bYX3j5CTnYGFt
14192	payment	1402	1402	906	1	1	29	1957090545271	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYgRLs3iDxKcvkrcF68BrxkRMvHup7LWveFrZ3CVFtsES133rUn
14193	payment	1402	1402	1267	1	1	30	437399149501	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaKic39AhNtQrsh3gXdyhxY8KKBGdbdabNHczvVD1qqbgobu6D7
14194	payment	1402	1402	1268	1	1	31	4673067789	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaLZRFzHaUmhp6ibBMsoeMHiamKPt6KCAQamYCmX3z2BAhbWfC5
14195	payment	1402	1402	2081	1	1	32	984784944532	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYcjzo6988CJ9AvZdkLcrtXUFAKwnVCmq3NmZnXRceSj69xN148
14196	payment	1726	1726	1874	1	1	4809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzzRHdNSrJKLy6gHGjshCX2UxZNUeCRcvNMMFAUhEQQLRPjDQ
14197	payment	1726	1726	1874	1	1	4810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1A8ntKqog9akbK9dgUo56r1bEHa5t16MsnHgSqhtQamKW17i
14198	payment	1726	1726	1874	1	1	4811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMA3Tnytx8842vDHjkBZodohvqDJhzzqg8KsNmfrqs82rACEm
14199	payment	1726	1726	1874	1	1	4812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPo4XjoXbbNGqfS4KDoBHtZbKJNpwrBDoPMeF8FMnuk64oefjX
14200	payment	1726	1726	1874	1	1	4813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoox6cxAWXMAynzfSXe7gPKdBx9vwxabYZ1zLKTLRw4ZNWGJGh
14213	payment	1397	1397	1678	1	1	7163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqxtBwN4uCQTbL8J78kVsc8Qf1bXsX8uaTW1YfoEARXiQgLXu
14214	payment	1726	1726	1874	1	1	4822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DLM2fT6txFGxCA36BpEMH2fsbo5FuCQ7yHxkCtbJZEYjAk5d
14215	payment	1726	1726	1874	1	1	4823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFSBzeYf7SfTPkzFJg8Mc3Q7EB5JgjCmrLvQLHHb6uPJnJ1wg
14216	payment	1726	1726	1874	1	1	4824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSuk7BVsozRHz7jmeskJLMvLouj4WMkB1rFoRjinwD8DPmAAZ
14224	payment	1397	1397	1678	1	1	7166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrmpVReRY93SUWwnCDULvLKeuYFBjNXsuB7c7fxshFR1viLKy
14225	payment	1726	1726	1874	1	1	4830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxrDQs3xgp7wAry1iHA7V32vu5efvyReVCgZw3FfppGXXx3rH
14226	payment	1726	1726	1874	1	1	4831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa628fQuHzpGRuYMfx9EpTQu6ds6MCDAS2FxDgaumx2mbcLBtCR
14227	payment	1397	1397	1678	1	1	7167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnr2nvEv5cT9jio2UpVKQA7igDGnuUy45nvPgd9H5DjhJyo5y
14228	payment	1726	1726	1874	1	1	4832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpufgERo9Kf31i3Hn1LCVoGjmb9ofUc76xtaBshpghkXs41Tt
14229	payment	1726	1726	1874	1	1	4833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxvHsY67FvM7sLLTxnNdxMLpREgkkhhnLCERqTiAwb7jD7skx
14230	payment	1726	1726	1874	1	1	4834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Y73PqGLfQPSyemmf2AETzFTAaQr1kF2aH7pDoveSUjdRNQk8
14242	payment	1397	1397	1678	1	1	7171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QEnj4vDv97WRQaHu1CSAchXt5QTw5YqcAnCpqSoatQo5ebjB
14243	payment	1726	1726	1874	1	1	4843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9RyDoGDteFBvP2tgfSaW2mvQ2yL7HPWEtDTDAE7ggARpWN4G
14244	payment	1726	1726	1874	1	1	4844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt94SRa6HZxvCXF6tiRrE5VzLTbfStFGqmkp9y75PGK39xfJxH
14255	payment	1397	1397	1678	1	1	7175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEm1U1jnEVpnssxcu9efoySo45G3TLYN6ZTHspQFYxEzfhg8DA
14256	payment	1726	1726	1874	1	1	4852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoskwcD2d647TY9u9qTPK1KXpFcW6jGsx1iSJ7gtYkKXpn8r96
14257	payment	1726	1726	1874	1	1	4853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoJDeFQdsju7Ps98coPn7Zos99LQKXE9AgZpnVJmqSHcmfecr
14258	payment	1726	1726	1874	1	1	4854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLRk7teNJHvFtzBFNRumsorSKLQYy4SEmSdtpKCzphHpwR2tW
14282	payment	1397	1397	1678	1	1	7182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpv7cCV7tDwKdtWEyUzeLwSyaWn6CPSeH6XeEpYX3gG1iqfKG
14207	payment	1397	1397	1678	1	1	7162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwCusfbd3gxPiuVbkhKSWcWScq4DhGRRyPv8PgaaD4hznbEBD
14208	payment	1726	1726	1874	1	1	4817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGrLMD8Vj55GD8PbZvxdNNc21RUehBgu1LgiAdpXSMNABwoSY
14209	payment	1726	1726	1874	1	1	4818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EDz7yH9DmAyWcJpbgq5uJdwqUUFnhRL6S82CZycLttgaQCKd
14210	payment	1726	1726	1874	1	1	4819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeNUpie8vwWhnGqGdJqA1GpAK8nkvgcANXNCuDTYiUXXp2897
14211	payment	1726	1726	1874	1	1	4820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSK8r6pHAwnptraqXNCWkKnvz1xK85pHDkwiSZCYdqxNJ5fDXM
14212	payment	1726	1726	1874	1	1	4821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzUkvNwZK8i1hEiYYcYLchdYv8iK4xw7A6WGmQmGNJyRipoGy
14239	payment	1397	1397	1678	1	1	7170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QzC2bQDscr1R45wtKaam9TVVTqS1DdMChQtyAi3kNVjCNre4
14240	payment	1726	1726	1874	1	1	4841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeRCKsGDubkypVCeUiPpZMyhxqoqFmJ7tCyV3QJwwXfWboXNS
14241	payment	1726	1726	1874	1	1	4842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYns6VnaFyMvBsUCLj8E3vjQHRAV3FxYXqryofNGZUnPt2YqUSc
14252	payment	1397	1397	1678	1	1	7174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiZ9ciXXTHfBQeMGFeEYmYpq9YYnDZBCuoC4DxPXqRRg3gpQj
14253	payment	1726	1726	1874	1	1	4850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLJY64gzvSm9d5nP8d54w4T4yZ11ECGNEZ1uC8GFxq8veSsQu
14254	payment	1726	1726	1874	1	1	4851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFM7TX8EFgnmdHBEM9Uk9g8mnibfaUWRJotPWsEwnTHegSAGXf
14267	payment	1397	1397	1678	1	1	7178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzotC984kaBmzPDVkKEsKywACYjU5SZHWhZRu23CQFvZnyu1FC
14268	payment	1726	1726	1874	1	1	4861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXCruKLwwPdLwvfKLy5GhTNfscZNrFdgp52GiQAsKgrj8hZTy
14269	payment	1726	1726	1874	1	1	4862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDcrshFYCVpYdr27HXhqoZd7khjAmQCJ1GwuzLDf5bFxLxYqF
14270	payment	1726	1726	1874	1	1	4863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtXnb2Jx89EqbhwVYWYHihxet7aNkk44zxZeCVa9xwCpSjApP
14271	payment	1397	1397	1678	1	1	7179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMqxG8xXzbjiaRFq9HXXnQhxHKbyYMQp2pwcBvtGNzgZQe7wd
14272	payment	1726	1726	1874	1	1	4864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCijnMhkQVrRSHvu7vbTDKwTPQh4h1qiDRxfnAvbk3AyPBgfX
14273	payment	1726	1726	1874	1	1	4865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp533bCMAi25gLHT2uGAVRY221UEY2NerAXPmkUGFWa6qyYH2c
14274	payment	1726	1726	1874	1	1	4866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZx7Yy5Rsd97DYrPBssRHsY1noRdvK1YfuRw2KrkJxkESQD1N
14286	payment	1397	1397	1678	1	1	7183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtwSN9VCL8YixkpATwNpPiB8tdkoRBbjWnRZhxKyaaKzk9HaK
14296	payment	1397	1397	1678	1	1	7186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSQGnwmEK35W5Rn7cqcRN8mmfef3sdEWshqSZ5sEUTiPpj76e
14297	payment	1397	1397	1678	1	1	7187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoWMC1zBcv84Z9L4SGw2f1AXNfyp3votJbmZAHsqBvPfNZhBT
14298	payment	1726	1726	1874	1	1	4882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPebe3Q6G1gQVfMAxxiKXcStpB3HE7j2TmgYu2eHgfDnMgT5U
14299	payment	1726	1726	1874	1	1	4883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBpxKUqeXNH6qT7s7K2mcK24Fg5Mm76pa6RVa3sdNMTvu1e15
14300	payment	1726	1726	1874	1	1	4884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9teNNpfYGE5p35PffjoaxAcVu6ACCw3tSa4YpV6BnTCGGQBr
14301	payment	1726	1726	1874	1	1	4885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQCABKhcaZUbF5gFgCi2rnY4smLuBeVjfZtRvAyR6SFXuJUvb
14302	payment	1726	1726	1874	1	1	4886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rs5YTG1vdt8ihyoLyKjqpXdZ32NZ45ZAGtm8NfHBtRLMea6o
14303	payment	1726	1726	1874	1	1	4887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDsFLREH8KfDB5L7v16PdUMn28u7kRXTqiPLtA9VZwaxYGxAG
14311	payment	1397	1397	1678	1	1	7190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVVrGFa5pWhzK5a4g8aL3ALfKgJbYaMwHjHLcxvABF7bRdFa7
14312	payment	1726	1726	1874	1	1	4893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGh1LgouNvtdHsPGWewcL4HD7t84cwEdtYqD9fpfctktcRwEt
14313	payment	1726	1726	1874	1	1	4894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wUjydu2GGGZZ6QTVcTWRMQsQ2Afm6GmB8ZLkNAygAyWRffvW
14341	payment	1397	1397	1678	1	1	7198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRZT5NTEMvc9EYckkQfkMj7wWuioks4cZTddGSXz2nfX8QZpN
14342	payment	1726	1726	1874	1	1	4915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31Mj2MVEhWDmAtH2KTqGpWuqFTJZcdoqhtYyfv4YDPaYiACk5
14343	payment	1726	1726	1874	1	1	4916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrVETGyHbRCUV8TPnpmF2EmRmdyC2nbksKmWy6j37Dm1Jtsen
14344	payment	1726	1726	1874	1	1	4917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjgtyjjWC2Qb2tAVqY2cvu6gUVM8RU4FWgDC4zWnusFESTbcV
14396	payment	1397	1397	1678	1	1	7212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoRP1vL9DhC6WepHQXr7vQ3j8uCDHoCHhjbLAY2sR25rQxqbt
14397	payment	1397	1397	1678	1	1	7213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oCqQV9a6bAyQryM1UDtZZ4kb9cWEVE5GiF7mcfuFFf8qspzC
14247	payment	1726	1726	1874	1	1	4845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VhDucseTcKDUKfCMnQpm8PDe8Nv88fEAEM2rkxuJNYY5trfK
14248	payment	1726	1726	1874	1	1	4846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdi3uNX4ZAa5g6noJfc2UQWKqkPzhm68NUveaQNqNhB2tHyqM3
14249	payment	1726	1726	1874	1	1	4847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtPMHoHGZGN1SBAsNh9mJWhBgNQrnQwzhv4gQtEa2zuHNjd7a
14250	payment	1726	1726	1874	1	1	4848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj11Lus8KTY1SSqRkisfL6ftfssDCjq6kpFfFdWcLSB4eiXVnT
14251	payment	1726	1726	1874	1	1	4849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8TGUa2ougan4pbrfX1qAETADE9VmFfdRh8v2U31AVpLLF974
14259	payment	1397	1397	1678	1	1	7176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1yyjCNtENByM2Ro5Jj4yBPikG1qt8wujaPG8BXkDiwzs7cg7
14260	payment	1397	1397	1678	1	1	7177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cmgC3k3MrLAzjXvxTAy7HjxZtc2MxUaZtc3YhcLRtXjH5Pue
14261	payment	1726	1726	1874	1	1	4855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWXZ4PtchEEVBM5DothQVc6owmxbGrKCLQWmyjZUy5EVXYkwP
14262	payment	1726	1726	1874	1	1	4856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUMCHET5UqJMV3y2pdNmEcmaAvT7Wx9wb7Yf6vVSErNmqfUYz
14263	payment	1726	1726	1874	1	1	4857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFz2Puk7x5KyqvrzZy5tr8iEbUPkHCphPoCMEA6JsA3NPkPf3
14264	payment	1726	1726	1874	1	1	4858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFwSZNsqpGYvnkQSFJrqYmZqWb2fgdamt4BtcUQPqXEBYQbf2P
14265	payment	1726	1726	1874	1	1	4859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8JyR5omFDL7y4bg5Q96YPfYMSmVe5uBcMwGFE5BCJ453HyxF
14266	payment	1726	1726	1874	1	1	4860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaSPRYaFVRQJDCLBt7d6q3P8CixpCp4pMrD4ZobPqgka2ekg1
14275	payment	1397	1397	1678	1	1	7180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM2utGfHu6nEZHX9MnGFrDaYTRwH1bEaFzMsmtadpFtSJ6S1Ji
14276	payment	1726	1726	1874	1	1	4867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgtBj4dp1LyGA1fRYCaUoombbF2mjWgaJN6KxqYkZcRUs79Zc
14277	payment	1726	1726	1874	1	1	4868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPTFDUhqqYn5UdBP2Nntiqc6WGKyS1hSCp6yiXbAaC6ZY1Gju
14278	payment	1726	1726	1874	1	1	4869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtt4QtXq6DCcNccehGSrrM7kfEjmujAXJTi2ZUe5p8wfKEe4iH
14290	payment	1397	1397	1678	1	1	7184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dq45YvwTJjadeZoGz5Y9EZzdbV2p2mhhHBq61qGvu9D1mmvq
14291	payment	1397	1397	1678	1	1	7185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pUkH2yibQ1Vc9kCA8nUdcYgDkgmCtYcTZMc6xXX6kdkvQW4K
14292	payment	1726	1726	1874	1	1	4878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GUBM2A1SpjAfbN9GYoPmWMQJc8fwKbytTXHSocLV7ad2dAia
14293	payment	1726	1726	1874	1	1	4879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWLjrKfzJ3KYgia9pmgoQyMg4oFbhL3FNiX3nTYkUujBsWKc8
14294	payment	1726	1726	1874	1	1	4880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPsfBDT7bqNhFCWMbXsgETKFYd4vcdt9NYRhUWFxh4MQyaXS6
14295	payment	1726	1726	1874	1	1	4881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbzu6wK1wya4umhqj7goeUm73munbWrdP9wPa9DWBgsLKwSy9
14308	payment	1397	1397	1678	1	1	7189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinn12F9hWM5fs6PC8ZqN8jgr5viuyht82nxkZPMHKFKRQvLG9
14309	payment	1726	1726	1874	1	1	4891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbVrHs3UccbhZbQ9R6gUvoT6Dkey8ZHCgVoWRvNxLWKL4RzAc
14310	payment	1726	1726	1874	1	1	4892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeeB2BXDDbZPmAGqk77nUbM524MzyyNBgfxTaxTm3JbNCX4PKi
14338	payment	1397	1397	1678	1	1	7197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7QaHYa4yd2M9jSTySG5T87yYgs6S5ivg7QEP2zwMYeSanbyR
14339	payment	1726	1726	1874	1	1	4913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj2qfiY9fRzwesN9NcGpo9ESmp2m2pR4S9apL6kPzufpi7GUm
14340	payment	1726	1726	1874	1	1	4914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZASHkfAh3BgV1fdkUiN7hWmG3NiHhovq5LWiKrRW7U8uPsau
14360	payment	1397	1397	1678	1	1	7203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTJvS8GT2fMFPV2RTvKyNZBbd6zQgPpbL1j68vnwHD4JkhSQN
14361	payment	1726	1726	1874	1	1	4929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqexRZXgZuxs5TKHsqf7PfRLXYeU9vBwpPAWUr4nvmKe9DWAt4
14362	payment	1726	1726	1874	1	1	4930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfdrTC4pipu2PB7YWSbyPMKxXgRkEqvrTWLjuxHFtkv7QeMTx
14363	payment	1726	1726	1874	1	1	4931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KGzE4fwYUNoyRXXeDWtW2ScouBGYS5QYM2xWaL6ZqZr7wCkF
14364	payment	1726	1726	1874	1	1	4932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgn7NyWLB9sXmqgme2kt31TTVsFu4J5EcbCQ7o9Gy8ZARtwHS
14365	payment	1726	1726	1874	1	1	4933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSmtMJceFmSd2J7n7QTuPXTKaDQJTExism5LzbLhMjhyn2Fxj
14366	payment	1726	1726	1874	1	1	4934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Z99ptR1iJZE9yzJQVVsaTtHrRrz1gYPCTzkMx5E7pcJrZn9P
14392	payment	1397	1397	1678	1	1	7211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfUkwr4HL3Heyd2toA7pFvW1tw8bdgXoJhALvMTXGtPrt3rsL
14393	payment	1726	1726	1874	1	1	4953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgN3ZYMe8UXpfVW2SWvko8yCVbqc7yBakz7RkRUsWJ55omKTzq
14283	payment	1726	1726	1874	1	1	4872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGniAtLKS5AKt8xky9x3qxprGuXTyzGn9Nzm8yD6BGfpUJqRmS
14284	payment	1726	1726	1874	1	1	4873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNTKZupuq466oAHBWDkmdNGLs9NBYAU67MofWRXceJyrhTh6A
14285	payment	1726	1726	1874	1	1	4874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBafZSs13feUhCHi8YC3S6cUFtrh5afeHbHQHKS3gReNbRiAw
14287	payment	1726	1726	1874	1	1	4875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJutyjL3vFAzovsHvBjuGtdKehbhxyY3U61qxpSvMdKt3QCYbE
14288	payment	1726	1726	1874	1	1	4876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzE4vVoXNKTvAbj2byEsSc6HHvZBJL5XxQ78tqDMkwkxkoXS6
14289	payment	1726	1726	1874	1	1	4877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qo8UWs6ZtueRPVpq52yBq5zVMHiDywZnQdG57oNzHqKAKqMf
14345	payment	1397	1397	1678	1	1	7199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTeSxAyRPoytqyWxU8UipnWfh453xjb891Guq5MEE61T9f9tY
14346	payment	1726	1726	1874	1	1	4918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7AV17Db2FhzkPtrXWCUiz6ADkozNVxz8ncgWRVY9Ug6q9hXW
14347	payment	1726	1726	1874	1	1	4919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcgrp4FUhL3oaSp3oKdxFYFZHpu3RvC8PZMMRGWEJKX7AR52s
14384	payment	1397	1397	1678	1	1	7209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLLyj9bYAwGS3Pi5vYayAxunvsLnMGmjMq4TN1wYaKPHoz2tz
14385	payment	1726	1726	1874	1	1	4947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XgaYmmFkgjVHWiDf8ZJNXHXmuacqNSRxkQisQgbDL8oMfCeJ
14386	payment	1726	1726	1874	1	1	4948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1X2tymX5nvYGHcJ6RX81qjHSsTGWPTWcfm6jk3qpB9YmhkRgE
14387	payment	1726	1726	1874	1	1	4949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFAT6dr6voftzYPkoCzvQYrJT59kwknwZqD8eeBFEHLwcETsH
14388	payment	1397	1397	1678	1	1	7210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMdCR8jyZk99aSmWjP5TBpjNpgw6bXrDqRtZr2AmeXeHBCJ41
14389	payment	1726	1726	1874	1	1	4950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXQqZP2J7mxWHjQSk7VHK7efJT7qPAD2DnRuHfhQN6ztJfz6y
14390	payment	1726	1726	1874	1	1	4951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdf7QjiuPRZBfhnzreECpCbn19sJx56p6RiB7MAwYdyh4ZSZ1
14391	payment	1726	1726	1874	1	1	4952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxE2mgQHykCuXjdjG6kDgxXa224S8Auki68DYnnr3iK3194UKa
14428	payment	1673	1673	1122	1	1	3	4616070000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpYzcUb3iZT6yes6hmvkYWncpaa1YKiQhfaXwmSMWUPHtZfRi1wg
14429	payment	1397	1397	1678	1	1	7221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatdMZxMWSzKehE8QVd9UyfMysotxpzFXo3pq1FohymVgb1xDv
14430	payment	1726	1726	1874	1	1	4978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCuEDqgfsSo8ocSyY5Q1AvtMUYGwXvdKh5DmCPs8bmgpLApFu
14431	payment	1726	1726	1874	1	1	4979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTYJrMEdjVt4SPvoHSNTpsxt81kK1kxJMViHkgtoVq119zWdU
14432	payment	1726	1726	1874	1	1	4980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGv5ubevVNzjq69WXFdCtZFmTPNssdnotHjeCHXuj3thxdtUb
14433	payment	1397	1397	1678	1	1	7222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBi5s3aYjrgg5pm9fBtV3MuKBowvo7Kw1UyYrykaGyDjcFwpUm
14434	payment	1726	1726	1874	1	1	4981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAnrwJi3BqFXQ3RXLBAhJUZb5SrMjDbqeTGFUVkBeE3GkT4wL
14448	payment	1673	1673	1242	1	1	4	3114410000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpYZJj2c3zruxPccpTiETQbyRhnNhmmo2875pgtER1PwafSiChF9
14449	payment	1397	1397	1678	1	1	7226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDn1AtGJcAzHacbsudxCtdEpbewxJvKXFRmvHDBnBS3cEHkFP
14450	payment	1726	1726	1874	1	1	4988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFC8Tz9gRe2vU9b3nLEqtumivmLqkFpn2kgP191i6Nf7ocBCTT
14451	payment	1726	1726	1874	1	1	4989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSCgJNQxXdNdeCE7DdT157uKVofYgJnDq6bNnzYpr2Q8NubKb
14452	payment	1397	1397	1678	1	1	7227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmaNposUV1jwU9b1YrfcoTRmQkuJxV28n8vgGk77UhDux7ja3
14453	payment	1397	1397	1678	1	1	7228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaPR8jsBNCwcUABRUCbZVb9iEDzZakQZzT6DPrAjuTiGZeR8P
14454	payment	1673	1673	1002	1	1	5	2576830000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpZXafXa15Kcg7wuSLsaS26GP85ELTaSKnmdA4T9vsyYiZVh3g4g
14455	payment	1397	1397	1678	1	1	7229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MJnM64FvUrWEXzXfUer44jXBeMWjNhC2N2W7rqrwJD3VMZns
14456	payment	1726	1726	1874	1	1	4990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomtHRohbRt7w811ecuBreWqKXuiD3kxoHPeMmRzNMXM2kAyi3
14457	payment	1726	1726	1874	1	1	4991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhwedoHne686WvTtr3acw1UdXpEwYtKskriaNqHCtJsEkXLG3
14458	payment	1726	1726	1874	1	1	4992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvuL38UAXKmfFXgwbGFL97YyvvvXYPAD9AVMUPTyncqqzEacA
14459	payment	1726	1726	1874	1	1	4993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVC1LeKzUarJbweozzckEWgz3m8hAiSbFCD6SFPtLJVqtNBBws
14460	payment	1726	1726	1874	1	1	4994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQhhN1wnaZWaygWD1cdSwwjyqftCPvHtWjEvsNgUN37UvZp4rE
14461	payment	1726	1726	1874	1	1	4995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYsanvkTJh2dXwPZKMJZxTeLQsiHiqFBzNq5fAGiC8Qihn6MB
14331	payment	1726	1726	1874	1	1	4906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQ9XVtyGw39jGtQzq6xB9bGwaGQGp7jahuF4tVTw3NZvbpQrW
14332	payment	1726	1726	1874	1	1	4907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnpg7qFS4ff3ty7h6Bw4H7yzjg5nLbCd11SgYufQMCfMKEoWek
14333	payment	1726	1726	1874	1	1	4908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vkz4aDva47rMJDZz8PksTxNEFytgbfdoodBJwYk5rpPaoNxj
14334	payment	1726	1726	1874	1	1	4909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ77r46PZpEqQY8MFpJnUC7ca7KWBsFMRJBpgVRH8Xqx4kUet
14335	payment	1726	1726	1874	1	1	4910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejhaap21JU7nEU1FtPYctSqyAwxyeWbde3b7CfWN4qo3PeWfd
14336	payment	1726	1726	1874	1	1	4911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknTnaP4fpSCMdz5GVgVydXtCPExTxtj6ndB4Rrp4pzYubqBQa
14337	payment	1726	1726	1874	1	1	4912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWsTLzJb14TRQPTsPxumKWchTbfFbK1C8rk42thoDD3Yq8diw
14348	payment	1397	1397	1678	1	1	7200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTB1QYfp4TXizcZw5DRGz6598j3fGa7jXKp4sXBEpwD6uWJF74
14349	payment	1397	1397	1678	1	1	7201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSi298MSmfM7JnfcigiJ1vXnrmanN9UfpPxAsa8YucJoNsLAzx
14350	payment	1397	1397	1678	1	1	7202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCyPWbF3CQ116zoRdxMvhEDUgK7w1k27jPXwmNCdfrLvfjLf8
14351	payment	1726	1726	1874	1	1	4920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZ42opzjwSxxrJq6wvAnNUjDyWAhNNxyVcg9Sc8QmDAFggeGu
14352	payment	1726	1726	1874	1	1	4921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuK3eLRQJBEk8C2FkpbYxx29MrUQ8nYQYsvtHVjPgy4BtjRD36
14353	payment	1726	1726	1874	1	1	4922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTEVrna1btPAVjiDHXzVve5aCnbiz6fkajL7p3oh5PqzuZE5M
14354	payment	1726	1726	1874	1	1	4923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiNQVEbcKpu2EhPr2ojkvjZ2sjFWu3uZ7jR5YhTZjpUf5DmZan
14355	payment	1726	1726	1874	1	1	4924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DUTs9846UEYVnTags5WYVAhUeXbPds3psicVxfuMy31EACej
14356	payment	1726	1726	1874	1	1	4925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnioR3d1r3bjFDvyPcsU8NdcnsYoU9GvfUHgosu5gLgPorn2zw
14357	payment	1726	1726	1874	1	1	4926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5vdkXG6Hhm25cANSdgRf3wFkZvYnL4YQ8EgFvd66oXtNZaiT
14358	payment	1726	1726	1874	1	1	4927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaRBRSVGFepg4ghjMySTNArebcbZBRpQjPFBpCVUq1nHyt9Sr
14359	payment	1726	1726	1874	1	1	4928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3AMB4tSUNBGwc74gBiDhn2kihuWEbeeE2LK6g6uMRv1LpXEs
14367	payment	1397	1397	1678	1	1	7204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSVCKEM76RsJKkKY41K4v5HYJQkUtuEe61d2zvDE9skzX3EFB
14368	payment	1397	1397	1678	1	1	7205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUsbPu1a8yHMrH8m8bwCwpciY5j578Ty6TwAjidowQud4pbzrq
14369	payment	1397	1397	1678	1	1	7206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfCkXNzvw9ev7ob4QZcfwGkMTnvnnKa2LPfjQmmNGYatDhXom
14370	payment	1397	1397	1678	1	1	7207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFAbbepq9VVKPBvTDMHoP4zEhbrb5GbV5gp3GxLmWaHmmPZ2M
14371	payment	1397	1397	1678	1	1	7208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAFeoBDQ1285X17oX7NxWfs5nbkopEcojwcc1rqCAmZsgnqLF
14372	payment	1726	1726	1874	1	1	4935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKfMjZnjiBRQL9TDKWrP4pLfKShTEpzMZKKfxqSFeBvZtFyDb
14373	payment	1726	1726	1874	1	1	4936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDxg4bZ4TyeragmdyevSwEV835gfJRADj3q7ihmVnPCJRdQT4
14374	payment	1726	1726	1874	1	1	4937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xST9YBi25TdAdE5SGzVLpcxPfhEoF2cr7svUosE1SqGwLTuP
14375	payment	1726	1726	1874	1	1	4938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNj6xYqGTS2tavDorNp7x8uEuhytN7vLRSYZobSjFoQmqjPLYD
14376	payment	1726	1726	1874	1	1	4939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC76TfjCzcXoBdywHwwxwdMdhhgrvufwffeeCDX3BGQPwmhgSk
14377	payment	1726	1726	1874	1	1	4940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNT7zW1JeKW1T54JjdsSjBWxbpRCvfeTJ8pqW9hm2XWCs1RL1
14378	payment	1726	1726	1874	1	1	4941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuomALtpAazHjTtzwBndnDLFpXxqvDPQV22kUdn96f5bAsYd5G
14379	payment	1726	1726	1874	1	1	4942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrGuF6sgJUrHJXco7SJKPpmCpkBte2Bgyc8hxh4oiLmAkgQDj
14380	payment	1726	1726	1874	1	1	4943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDTuRAWxf93SDF7dpwSnDabbdrnmkUw4Jtz2AX8aRjWNzsevoR
14381	payment	1726	1726	1874	1	1	4944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRps6ZfXTWJaeuP5wg49xat2npAofpgk3E7ybDPPH4SygpiUSS
14382	payment	1726	1726	1874	1	1	4945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr58db5DTHSWMDdZXdtdNPJ1wthCK7RpatmG2BvEbVT7mV5syG
14383	payment	1726	1726	1874	1	1	4946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCZ9JVChH5QTLCh5TuLNH8BXUcSmDdGy9Y39yx1cSGMdu8Xxo
14435	payment	1489	1489	1014	1	1	0	2552961600000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL9DbXwzjo9nTahPmwSjB1oCKbjeBTMUbjGW3QiUn8C5yVxkk
14436	payment	1489	1489	1134	1	1	1	4575412800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkRR2XgMexnJNiAmzUYnaeNjxR1e78CXC2j58YFEHz22h9rcr
14394	payment	1726	1726	1874	1	1	4954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCYd6sQRhc5PJPRx9ZFiT1MUxYA47x2vMVndFAv7r2C2WNFAV
14395	payment	1726	1726	1874	1	1	4955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLtFdonpM6zsdT9cbBzfafqVNbmV3rTe5C1knusdjD48EgP1w
14407	payment	1673	1673	1368	1	1	2	8680660000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpYcSAh1vAVtDtp4Koy3K7GDzds8MU7ZYdyk6zZY8efSuPkkyuT7
14408	payment	1397	1397	1678	1	1	7215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8uhctxfTfmcAALZZuVxWJinMJk96zM5FQnTaPXTB7q9jw3jh
14409	payment	1397	1397	1678	1	1	7216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPaMbtomQTgP9kTzogAEKCW3JgcG7c8RPDnYzCWzZRL73g8k9
14410	payment	1397	1397	1678	1	1	7217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4k6wbzUbvxUbipgwQjN1WH171qcpQMYD4SN7hHeUmMJ1F2sN
14411	payment	1397	1397	1678	1	1	7218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdG3wyEzi588kzFAvXUkULoEPXo9r2z14CyyCm5WPaNHyUGEsx
14412	payment	1397	1397	1678	1	1	7219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxr8MYBT9DdiBNqdSXhPBqM2fjLrbUeonCYrNAJ9wqQMNWgsu
14413	payment	1397	1397	1678	1	1	7220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe7EzNtZLpB4cVj31ody3URuGPDy3jwx7SMw15vTatpCYXNQnb
14468	payment	1397	1397	1678	1	1	7232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2y5WRCY3NjDALdJCmjLcWuFZRzXfLiX2rhJ2jKsqfzjFgYPY
14469	payment	1726	1726	1874	1	1	5000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkziAnJQqw8D8X3rtSqZ7LnJUWg9yyoGzdtVYWJcHYMJ4h4ej
14475	payment	1397	1397	1678	1	1	7235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2oucMLNdEHS2q9Dzh8uGcTkfeBkaf4ypiUSTLZXZGPXoTHWs
14476	payment	1673	1673	23	1	1	6	166630000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpZgy33UWXUic15Rd7eFnYtDJ3kXe6N6WLwzCZNwCYSbWtV7HBDh
14477	payment	1726	1726	1874	1	1	5004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuzaMsYyetY6eD3uhs1pJdKbaAMx4ptvRTnePUHYdfkTL4WXrx
14478	payment	1726	1726	1874	1	1	5005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEEtk8efVSi4XqD348Z24bPBQQRfQjCiaGknn6Jaydz5MBZ4F
14501	payment	1397	1397	1678	1	1	7242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkgXxBXTNbzdWpnVjUrHcBbBZty8rr5Mvr5yh9LJji8qxXKEd
14502	payment	1397	1397	1678	1	1	7243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8ZvE1m6a9aGB8E4yx9cjhWixAeCNkSEz5Yg6jaYRV98AcEah
14503	payment	1397	1397	1678	1	1	7244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKXg3PQwf9T94hPTKL9fCafenoF1htGKfMP6vDvNbyDScGUNr
14504	payment	1726	1726	1874	1	1	5017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJL5GbfvM2ebyf4xxbUciZSqw4ChvXRdf99NgmzFh671x6VpD
14505	payment	1726	1726	1874	1	1	5018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXEfoLYpZScBDLvWxUzgnHtx5gTsGE88JYJq8FEB1W9fA83mE
14506	payment	1726	1726	1874	1	1	5019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSEptj7fgD9E4CbWNcjowWVFCw6GaAKW4iSKUcYStZsizoJAM
14507	payment	1726	1726	1874	1	1	5020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6VQCKRwfDwuo4N15NeoTYmdHxbjkpVRrKcP883xvgqoC8vYM
14508	payment	1726	1726	1874	1	1	5021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBabTZ78HA93JnFJeCqbEYsdnU56o8MRyLskht9ckQtr1DBBt
14509	payment	1726	1726	1874	1	1	5022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGqqHo5yJkuxXfFFBKjkW1hBsFniRFi4fQSxVdcmwbDTKqmFA
14536	payment	1397	1397	1678	1	1	7254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNtg1y8v999kZPDufBVYUDzniGZs655QQSghcLTProg5EKqLd
14537	payment	1397	1397	1678	1	1	7255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iq4r5FBvP3qjDBDFxAVxQbyJL7TPUqoB74uVDXekjybws5ZV
14538	payment	1397	1397	1678	1	1	7256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx2FAWkPbc49o3iwbAwsZoGBSxKzDsv1bDAZqHJPoAMHbxeVGc
14539	payment	1726	1726	1874	1	1	5040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9UTPPHWAdZhVi4RLQCAqAWRW1kRt9urzryfGyRTQLgNdgJbg
14540	payment	1726	1726	1874	1	1	5041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9MWxyPaNBiwtbZNvXmZfQYdAmhZAA6FzVQD2bQ2GNhdTKU3M
14541	payment	1726	1726	1874	1	1	5042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFV9aecv24EQsS2L6ZWTR4VMbP1uaovpZp6KFX2dxrVcH8UG9Y
14542	payment	1726	1726	1874	1	1	5043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdUdjmzN7528cCQo5YcX4Ha78NowjeqjeRbDA6wehD73ECoaF
14543	payment	1726	1726	1874	1	1	5044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVGXH5LRJ6eeJcM6hUJwfzaXiaPsJ8ihXRGrZS9NKQ6xfbBTg
14544	payment	1726	1726	1874	1	1	5045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUxyar98LprdvME9eEupEcmpxaMELkzPorb6EMzXCSS7GUQ3w
14546	payment	1726	1726	1874	1	1	5046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPz9CzggTStVKGyzApgcmaFCjNwXe7Rw8xZoNuehdUn9VgAe1
14547	payment	1726	1726	1874	1	1	5047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHGf9YCPL2G8qpXuis96ZhdnABYn1V19kfBsGzkLdWdA2s14w
14549	payment	1726	1726	1874	1	1	5048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunTuc6nzJWrP4Gjw9fGxZZcTpW63qQsmm5M8tdEd8iSqx46dE
14550	payment	1726	1726	1874	1	1	5049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUWa74yPWRzrv5f3J1DYNN7dipZW6pcnsvwMZiq9SSWM63hvc
14551	payment	1397	1397	1678	1	1	7259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCj1H3nh5oy1oTHRYy8A368W9hhvQWFLNGAEyBTcL834PVCsgU
14398	payment	1726	1726	1874	1	1	4956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmGr5HihK8U2q6bvzbZNzfkT5PKaLSPV8J6eentuKgJcF3rny
14399	payment	1726	1726	1874	1	1	4957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM81XbESqXUZmrva6xgiw4kBtGFePkgeEo4JBbkQkpCpwLLXCG
14400	payment	1726	1726	1874	1	1	4958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwV8AM3BTkRisPLrCPST2FsqEk9w65JcRL6zMHXuJKP9iuPC8
14401	payment	1726	1726	1874	1	1	4959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND5mJo1eTHxbmiLbimt18YfS1jTVTFqVzY4xDfP8n8gRptYUp
14402	payment	1726	1726	1874	1	1	4960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjfqYrfJu63UYC4q6BHGVW3VjPEhprJAB3tTusb8sX7Hgnyvv
14403	payment	1726	1726	1874	1	1	4961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYPDcnZY73zEKrLji8ZsNu6atmpf7JjsMxXEu5gQ87fzZkcCi
14404	payment	1397	1397	1678	1	1	7214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfpkatvwTQb97w9S4E6SvAEaTS9zqmVXkpkLKA9cFMWZZdi9F
14405	payment	1726	1726	1874	1	1	4962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7Dai4XP5m3ku9ADYCUw5d1Ts5eTF5LgUtJaixcgqNfWepNH4
14406	payment	1726	1726	1874	1	1	4963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2zzRYcTVxqScdtfNVn3w6mke37gDw1xBh3C3LE9GsEfgqU5Lq
14414	payment	1726	1726	1874	1	1	4964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFsWcHLuDbSgpWey67poNrLoPU4yeEcFFR7pxaswsPoRRGD5P
14415	payment	1726	1726	1874	1	1	4965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUE7snTWZ4gvSUoD4Jt4fR99z17wQyW4MiZvFhnaVtXEKz372J
14416	payment	1726	1726	1874	1	1	4966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8uaJa4J1RLpS3wBt79AzYTUgrWg8Svf76dkbjA5Ntg5KQwhn
14417	payment	1726	1726	1874	1	1	4967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGf7Lk66PncNRMGN8MBDK8AWnANuLnpHbfCY9QosA6n86Yu7mf
14418	payment	1726	1726	1874	1	1	4968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMZLcr11eUBqDatqnLrDfpGnZEGqcbe5RMgLMWvaGCeAyH6WN
14419	payment	1726	1726	1874	1	1	4969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEgJU9TW9y7UZuyVBB3PFRpVDfDvzgu3XireGnr6JywJY4tz5
14420	payment	1726	1726	1874	1	1	4970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURSiAE8SaTMYQqUGJpsdNR9aBuCrvC1bchjHCX6kf2wCHC4Jo
14421	payment	1726	1726	1874	1	1	4971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkv1v4MZJVZ3oSVJ4Pjc3NamkAQzVQDxP3hsCbvTS3T2m1Hf1
14422	payment	1726	1726	1874	1	1	4972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaBR3toDVQV9msEifnDqSKCQhPbL6d3B5V9j2pb23nNijyWje
14423	payment	1726	1726	1874	1	1	4973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwT2sDj9iWR7TDggTemi8o9Z3zzMVFK4zMQGearfgZUC7n6nqa
14424	payment	1726	1726	1874	1	1	4974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZGEjghnfJAQaNy5cgQaRzvUVHGuENsWWjCVpyoGoAHFsQdKB
14425	payment	1726	1726	1874	1	1	4975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3PQHdGUhkQp99tqsZXBong1DQ6BTerVJ61HzpCtX378nmmps
14426	payment	1726	1726	1874	1	1	4976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPjzvC5PhRGfKxW7n9sxmwQriV9pbmre1u8vyCEYgBMN5wb8e
14427	payment	1726	1726	1874	1	1	4977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4JSwmDpTXfTPYy59cXcBhV2PB49y8N5rDUmNecHehRmhGRhj
14444	payment	1489	1489	1380	1	1	3	8601163200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2rmhZGw3AR97tdhZZAmPph38KTkfEqAjJd6NuucKWesQykLB
14445	payment	1397	1397	1678	1	1	7225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTYzumfjvioX49NU2E4PWZHCZchts79ALk3u342yQKhp3AiAt
14446	payment	1726	1726	1874	1	1	4986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYe62KTkgDyzeCBXZttuQis8hUeheS8PeUZLAu5SmWhj7Tf4XB
14447	payment	1726	1726	1874	1	1	4987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1YuPmhHVetfBVUBUxW6b8hZ2wUK6W2MBtckoi6zDpf1r5aCP
14462	payment	1397	1397	1678	1	1	7230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipLKdhcRb3cRWZFHDig7UtxrsPmciWw3YF8gz3VEfYmx6pWHu
14470	payment	1397	1397	1678	1	1	7233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2cPUpvJ5mVT1hrSAzdai3ibVxxh98nA9V11kuou9E5aZC4h7
14471	payment	1726	1726	1874	1	1	5001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1X5gWvFVFZbcdP4BXXpzQqbW8wAtNzk46KZuEA9VyqMFh9Ch
14479	payment	1397	1397	1678	1	1	7236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWrJWV8kkMGqKLTgy7VUBVFiK5cCHuJ9ab7AxV3UiQNwWo8Az
14480	payment	1397	1397	1678	1	1	7237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMi5VxhYcUWShnSuKaAe79H1hPZwki9jfXMthhyk4ZigFV9H2h
14481	payment	1673	1673	756	1	1	7	5950000000	10000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH32Wex963ev3JAX3CCE7sjbq	CkpZYRpFEYWK3WRismGAHE8U7i8vsFyS3tUxYNA9Brx6i9MVPmQmv
14482	payment	1593	1593	1346	1	1	0	7977000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGZhNdm2Hmqnp9hYsx8HDZoywaG7nn86tbfhCDYkP6JN4CcSL
14483	payment	1397	1397	1678	1	1	7238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eKchn37PwNHgoCk1xyujEEhqzNsfdBsFeiyTDhRGAou2yHMY
14484	payment	1726	1726	1874	1	1	5006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4xLLkMwMXLqa128qLFeVdrNQRtkS1mX9W4j78ZGE9BhUthq7
14485	payment	1726	1726	1874	1	1	5007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQZTmgXGAbSWp6VDWTarjm4SE48hNgzGoF651NcAxNSWmhz2i
14486	payment	1726	1726	1874	1	1	5008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRrqN7G7Fp7uLFJHGoCdHkzGPzTDBLa17kgv8Esc6Km7LoQsQ
14437	payment	1397	1397	1678	1	1	7223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3S9UY2bn8RjRvaUv293EcmXdgbV6rZFzoobBuCnsf18cFX5H
14438	payment	1397	1397	1678	1	1	7224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUGTB4iSoh6iSpJ2haUU5Jf5CcueGuuzRJZYE2JH9HN9HvRyv
14439	payment	1489	1489	1254	1	1	2	3087302400000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZEc4Rc5FpyZhRHxf2kuJCUNacrsJMybyuQzjpDNZesoANF6M
14440	payment	1726	1726	1874	1	1	4982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRwU9z4s585ns2btypZCYRFAjUStWYpRoL257DGVWPmMo1xTF
14441	payment	1726	1726	1874	1	1	4983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQsBakeXBB9bdskXcGFaULXF69AJAzhV5SgSNw8WNyJ5JqUY4
14442	payment	1726	1726	1874	1	1	4984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYmfgsW1s7BH8J7vwJbtbfADWLdkTzH6VsqTPpSfjx3Mg5CQX
14443	payment	1726	1726	1874	1	1	4985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZfhSfFnvFNCwyfsfP51iztBcX6Sujsvcjwq7W2RmjZk81wZ4
14463	payment	1397	1397	1678	1	1	7231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxof4adnvr5NgH4uQ3zx1c8UHYTknb1q99QoLUnEBgwiccLJjE
14464	payment	1726	1726	1874	1	1	4996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgVBp6TJTCpN21DK4Xh5ZewCyrEHTVkQdGYioaA7nZtiECsta
14465	payment	1726	1726	1874	1	1	4997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRj8ESADFpwJXr2w3ogcQxPL8FQzjc3575jzeUwnBWiSqymqoV
14466	payment	1726	1726	1874	1	1	4998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMYgWg7TPmaU7WjGU2pz5JehzN1GBvGcdRkPJ7ARG7m7qnTmL
14467	payment	1726	1726	1874	1	1	4999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKurL7wwqkMi3ebYDCjrdJZe7ih2MJKBWdtxafTGAag2yafosu
14515	payment	1397	1397	1678	1	1	7247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdx5NNMQRTQmgH4WT3ZUM7h2NY4M1LDWsZpYk21MUVjtvQ8RS
14516	payment	1397	1397	1678	1	1	7248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhm67NKzMDZJLH81jPyK3HQYHvjSvWt3DPTMxqzYDazAdQNqox
14517	payment	1726	1726	1874	1	1	5026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYot3Z1ZcwbMJDAXCajFzG4nUSb4Tc3EFZtgS3WuHR1KKKGiJGk
14518	payment	1726	1726	1874	1	1	5027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1kb5VCvz2Ds9xEBuxt8qGFrnNC2VfGRHJrWpvbua1qy5rzMK
14519	payment	1726	1726	1874	1	1	5028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJZUKXXTzqxGDn3hhPby5iVhs3hrPTtBCXeffXU1dBWT95JiF
14520	payment	1726	1726	1874	1	1	5029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXfMkLBJP2MAWchYH9U5KFjCAFUV2wrHg4CwdTcoiAwPZgviG
14523	payment	1397	1397	1678	1	1	7251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqNUBj4ezJ8ne7KwKft35H87hBeBccYPB6wpSjMf3HLCZYh9a
14524	payment	1726	1726	1874	1	1	5030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFiwdZKj7S9v9bSnUbWxh4z8cSh3jQGBSKjuhzXQtr8CLN5o7
14525	payment	1726	1726	1874	1	1	5031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsseq9DCje2spdu28MMbkTXc43RYGwzfYJFb6io27nURKeiXi
14526	payment	1726	1726	1874	1	1	5032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx7XFSbKV7A9azKYoyNBK7SYLt25nPQwPvddbVbWXNWSVsCz4
14527	payment	1726	1726	1874	1	1	5033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsYFWqEmkC2MqeCtjwzenQpiUDQbskCyXQsuKE1FAn2LsP1Ff
14528	payment	1726	1726	1874	1	1	5034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EA87KmAszVadHk73RBxP64RsyfiZT91YyUpWBxJ3PEkYMq4M
14529	payment	1726	1726	1874	1	1	5035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyK9wzTJEgQ8YCNpKymJvTxxZHBSKatm9aw17sVE9pV7FJxU4J
14559	payment	1397	1397	1678	1	1	7262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkpJhimMHHvUjtGWFyYqtYSWsjbcfw6onvoEGm2u19XU5V8uH
14560	payment	1397	1397	1678	1	1	7263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVAdjwwovEgijcyfb8n23dQikSLzDQSZgLP8z6BZiyRbr2hCR
14561	payment	1726	1726	1874	1	1	5055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHJKVj4X6sT2wx5RTpQTc1Xr2d6mQXUagLBGnmZ3VH2Tp9Gwa
14562	payment	1726	1726	1874	1	1	5056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHg6NJCkKr8vhmohFiviFbSbkxFTzPMtAuPtExLXiaoxygZeWi
14563	payment	1726	1726	1874	1	1	5057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8v6sQ2XKhCQeCXnNAdExuW3vsez9qd654vaNuzjnCxLghdYP
14564	payment	1726	1726	1874	1	1	5058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgYZGU5f1ZjVYZkMPWxUydfN2mnyJCDpG8AVe3qvvabdmpA3r
14565	payment	1397	1397	1678	1	1	7264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb87fDo71E96VrgTUnpxo12oBXyMDjkL4bX9a4hqvozm7uzWR6
14566	payment	1726	1726	1874	1	1	5059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhni2DxA7ViDWsPGjXo8RTHypM6MBPq9AuvEGYDpwHLFxFm3R
14567	payment	1726	1726	1874	1	1	5060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1NiXPpgjfNhWXYSBD28crCQ8fiqPU6L11uxDfUNdXWgAbksL
14577	payment	1397	1397	1678	1	1	7268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYheaZiHz7h2Qs8T9czBFExgZMV2NmdF9Up3PJAaPqLGmkh7pMB
14578	payment	1726	1726	1874	1	1	5067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeK4TYYAr7bgDyprDn7jT6prWHJ7q2JELh8opmJmxAwxShcXa
14579	payment	1726	1726	1874	1	1	5068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1MRv2vo7owk6S5SYXLcTkwEane3qjMcfhuAfKxA1srr38KgD
14586	payment	1397	1397	1678	1	1	7271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPSUHdDBUgNtnRP3UQDFY1f6M7Fyfp8EYssiU6LbitrqSrhZf
14472	payment	1397	1397	1678	1	1	7234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiDuDD9KdfQBdwzuFRJ6DQykYR4mnivWqx2jWdT2gK5HJWZrc
14473	payment	1726	1726	1874	1	1	5002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HaBR64FiYRWWp4e54hNwbNn5g7kkpT33NAJm2vU2cREJXxmw
14474	payment	1726	1726	1874	1	1	5003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMLFNNUJcTmdF7rVuXgtUh5btNzj49Vny9VLiFrk6KFa4rxci
14489	payment	1593	1593	1100	1	1	1	4243000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSJVNvaTunnQkbNRfZqTE5TeUkJCUR5Pac8p2pVK9Y5BA8jUo
14490	payment	1397	1397	1678	1	1	7239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQNr42vPyFpCkcUQzbZAMyT7MtwVukTtwt2JniQdQSKx7etx3
14491	payment	1593	1593	1220	1	1	2	2863000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweKUPaT32wtfK3GKoFyjpGBckTZqFgnarfUDeoaK4WEAPN4hc
14492	payment	1593	1593	980	1	1	3	2368000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkPjWh21WmxTWRVuygme4B6Vk2nJptVeL7Ynqwp2krTQTsKGY
14493	payment	1397	1397	1678	1	1	7240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzKrUdSDQ4YvMSZ9VSJtB7vnFC6UPEAPnkkEH42z51VwiHWQ7
14494	payment	1397	1397	1678	1	1	7241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKqzD67Y2hqxsBddpbymwjBxcimiwi3aPtgCoErPSyWFkuzpw
14495	payment	1726	1726	1874	1	1	5011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbN2iYTzrRRi76vcYri8UxdjhmgTeA5hpTWsJPBiV3M2jAUK3G
14496	payment	1726	1726	1874	1	1	5012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdQWSRZy6dm8DBcGaR8FzreXcnQzepiiAkZzXNz6fG4oj1HUW
14497	payment	1726	1726	1874	1	1	5013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86F9sXHpVcBYr38pSgaqwVcUg3pEseQiwxymr2w5u9KSj2bby
14498	payment	1726	1726	1874	1	1	5014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehaGzH7Sv5qdvm3TpCGE6RCXwsfdxgU3WUZndrSAUJuzG6sNy
14499	payment	1726	1726	1874	1	1	5015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsnZLGHyX8Y5CCiNro4AUYrjpHXQD3ch28MxD9VfZfgcVKK7N
14500	payment	1726	1726	1874	1	1	5016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDQGFbyc2copdFQTTkxEWvRxxULULrzEYycz6MmburqjDVBha
14511	payment	1397	1397	1678	1	1	7246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPDMGbhSBf8GJuRp6GaKoBJCJYw8G3xKro3h4McNHGqf1abBQ
14512	payment	1726	1726	1874	1	1	5023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FWP1gVuRKH6iEqeqxVSRZwnMJERPMcqNeu59ZeehFk4Wa6xb
14513	payment	1726	1726	1874	1	1	5024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zo5sM3LaGuvrBhyjkw4XGopGbMrYxzuhTSNLHsefnUvv5dH1
14514	payment	1726	1726	1874	1	1	5025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ko8uFCZLPgA55ajPJv588jJpf8HQ1irKXL8S8Hfw9BfoFmfE
14530	payment	1397	1397	1678	1	1	7252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywwSuzJxEk8GvqsWtswseJnEiYywsUc4NSERWrsmnVbR6MEXb
14531	payment	1397	1397	1678	1	1	7253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSfrF5JbTb3tZBwjSFdFYR3Yt5Z2vfeWy8VtoTpgS8xteqSQJ
14532	payment	1726	1726	1874	1	1	5036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fFBuaPxcg8h9DVziagAnRMUbrGeFL85uUPDvZLitvaD3LqN1
14533	payment	1726	1726	1874	1	1	5037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQgX9QvDmwWdnu6vZZuxN9sAgQNZX8WSpLMM9xUKmJheUVWnU
14534	payment	1726	1726	1874	1	1	5038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93G8WbKw1spXK6twDodL6bNiEL8Ktj5UXZSfcFRWvEDUoheeH
14535	payment	1726	1726	1874	1	1	5039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwWQAvtzcxk6E3UWLkc9yERtRpsLBwKD3KQiig1WhRUG3gfMm
14545	payment	1397	1397	1678	1	1	7257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvvrqd3nuP9Gtx6WjVoRsGJCHJkkBqpoS7wyS4qhvUMxanseW
14548	payment	1397	1397	1678	1	1	7258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuQLw3hfJBmCJ3aN1Ab4QiNjBsNcPPwqU74t5gnnBLbvygVsH
14571	payment	1397	1397	1678	1	1	7266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDJ5pNuG52t6YttFXkamabGTQak2LoDwHf7r6Nd5wpvhkhSJ6
14572	payment	1726	1726	1874	1	1	5063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGtitHMnCBVznQhCETwKNEadFz77avKUqKBbEfzzPe9L6crRo
14573	payment	1726	1726	1874	1	1	5064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1P1YG6d6PJdWCs32E2exwfKpSPyzhguo9pH7NJoWS99upDSC
14580	payment	1397	1397	1678	1	1	7269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnuk7qntQAtAgNZV2pEtd3m4Xyhkhd9fW1Lbuu2tfuriE5MMT
14581	payment	1397	1397	1678	1	1	7270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBar2M6sNMJj8p5tkoxUEvDx8Mu9mkvCc72h3dogVZtAy6HgGV
14582	payment	1726	1726	1874	1	1	5069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEbaLWQNxifiJdv3c6oVkFj5za5GJgtpG2nEqN6AUx77fXJXz
14583	payment	1726	1726	1874	1	1	5070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfmLbSJjxghvx53oG7SNtxeQ94FG2fxt6YhovGTrva8jeFk53
14584	payment	1726	1726	1874	1	1	5071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFx4U2d8EYjbS887c2kfXHxum5tDU3q3cHkcrZFR7PtM7fLJZ4
14585	payment	1726	1726	1874	1	1	5072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXyB3gKYVJfnVX2qar4Npu4u1ivw9u6FLw4bYvMPi6zJKoV1b
14589	payment	1397	1397	1678	1	1	7272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4RubCKWXBUFBTFbdtGWL8CdsCUXYM2M5SHYULuDquDzUzvzy
14590	payment	1397	1397	1678	1	1	7273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWUWiKSygUGVCTHXmx2hBkHc6BqMhUGApeHtGxZzSGnCkytBG
14487	payment	1726	1726	1874	1	1	5009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSj4XXhdtscZSWeR3ae4eQAUeuM7bNrPVwkk1VLymvpmEbSL5
14488	payment	1726	1726	1874	1	1	5010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2eZ9sq55gmPts4SEZoGi9q1f418ToGtRug4dvdZdHW8C5WsT
14510	payment	1397	1397	1678	1	1	7245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwB2n6Gd3qDYdCA75DenNiezRzsECrtmuTLQvGzpfpV47V5n2
14521	payment	1397	1397	1678	1	1	7249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabxGkm8UiJ57ouLLoEAdaLYdb7pX9NPsiGHQCMdkqc6pNJ9yt
14522	payment	1397	1397	1678	1	1	7250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswBYWpQXUQ2kEeKNFLrifKzTW992XMpnaxUkTFg7QYiba9fvR
14554	payment	1397	1397	1678	1	1	7260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLHGtxiYB8KPNEjjqwDXMsJynf7ZdxM1WjafmWG3niaj9TFXR
14555	payment	1397	1397	1678	1	1	7261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj4HNykrcJfDESgC1vcpezqLyrxqtYJ4SJmUuNdK9bR5MTzFu
14556	payment	1726	1726	1874	1	1	5052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvnB3XPubwGCdiCyJWn1Q48NVawz81ba11drCfP6SNEM9Nrxh
14557	payment	1726	1726	1874	1	1	5053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc6foBFVGJf1ivQZTbcmPKdvC7v2DcxCEqJqR5KAFsf6JsRd7
14558	payment	1726	1726	1874	1	1	5054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfrCKZXqorKHJCBYmFqL8Rksg3H32uXwSZ9bS5ezUdHcvVUB8
14568	payment	1397	1397	1678	1	1	7265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DkCWXsahy8SX6yV7ebAFQP43DvDpb9XHxtCZjKqS53QdvoeM
14569	payment	1726	1726	1874	1	1	5061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmibyozeJpMUGTsja8FjLpL2EhHhZrahXnNdNGGSSmWM6GRJRX
14570	payment	1726	1726	1874	1	1	5062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPTSsawYWV7JJkJDq1E1sRHVXxPJTcBdfYnNfdtZJTYExybPY
14612	payment	1397	1397	1678	1	1	7280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHape9XJrmKarPYN5XJh2effDU8DiKtdPTqVaTKkhymBVx5qbN
14613	payment	1397	1397	1678	1	1	7281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjd4FM99X4wZN4AwEDLS3GTCgzUo58vXF7NjQ7szzjGcZ4w6p
14614	payment	1726	1726	1874	1	1	5090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQKevVcTE8rPCtPfGRheYqcuxpCYipNjjuYnRvjWh3hHsamHc
14615	payment	1726	1726	1874	1	1	5091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrZZhhiiiUx6b8gqdSqsHbWShmqsjm8bK361Tp2eiKLjy1GhEy
14616	payment	1726	1726	1874	1	1	5092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWu6FYD5VekDaboFVZYquypZLZVwUG3PLmsg1h9bGhZuevWHLG
14617	payment	1726	1726	1874	1	1	5093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MXvRPgR6PeM7Ub9paDZruQC9yk42z213CD6RaJEzwUJ5do5W
14618	payment	1726	1726	1874	1	1	5094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6DBtDgw63PgeHMPkqL7ZjNzJEcxjNeicBMbP1TLN6Roszes9
14623	payment	1397	1397	1678	1	1	7283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdvLiCNRfCPR4VwYyqFj6wA3ZYejY93ZcPo7M5SbjL5bcKwBY
14624	payment	1726	1726	1874	1	1	5098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHrxNePsvZQDo9nEk1RV31hEPN5QMWdJ8mDVUYDsALnpa9FLs
14625	payment	1397	1397	1678	1	1	7284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHutZvXS1uGsCdceJckBgiTqdYFh4FHH9jpFQxQ1jj5JCWwFE
14626	payment	1726	1726	1874	1	1	5099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgF1jK28ZoThaEY7Z6saKDmFzdsYyKkFYxQfteStFm1sFDfCaw
14627	payment	1726	1726	1874	1	1	5100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zSvpxEY6RBzGHLFT6oG8CgRDzYo2k2tMQmAmCgArMu812C6b
14628	payment	1726	1726	1874	1	1	5101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvopUgJPP1vGXXXX5u973kzAJXpi7gjTgZrULuTEpSAZzhY6j
14629	payment	1397	1397	1678	1	1	7285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4tP5ps3mVXLACfWoMX7N9DMqrAVmNMFgnBSjUytjzrg2GZQv
14630	payment	1726	1726	1874	1	1	5102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPFejXHi5VWEEL5J6iethZNvNEunNScLZ2aViBqezKtuRLB1h
14632	payment	1726	1726	1874	1	1	5103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KDHJsT7B7W5TJFQVMxbm6ZLTQEiQ5QcPM99v8mw8Fuemmbuk
14633	payment	1726	1726	1874	1	1	5104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTa2qHWeW3beQq6gM7V5JLuF91EgJEtryPPrrVVcrW55TbMJB
14639	payment	1397	1397	1678	1	1	7289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d7XnW8egfvzr2TGh7WDct46T8u3MTt3WbsriXSK2iiu9X81U
14640	payment	1726	1726	1874	1	1	5108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVWLiqgw8x876AVcvqmVp6c7SE8kni9e2crA5u6Bj4HFcZntm
14641	payment	1726	1726	1874	1	1	5109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqqKibuU4N4SqrYLxYPSA7VFcks9VahXXX2qiVMFvFSvBPUzp
14656	payment	1726	1726	1874	1	1	5118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhqNHf2rQdHEWJdU3JQEAFZ5oezzc6mjgXuQytZCzNBhUpypV
14657	payment	1726	1726	1874	1	1	5119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XZT3u35StiZXsDio28R3JFyDskwoLnF6QyLyv1Xc7sfEtK3d
14659	payment	1397	1397	1678	1	1	7296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ujaUgEthnCadMXncrcviSBMxaGK2bF8gFL2zup5Po4UpW7YX
14660	payment	606	606	2085	1	1	9	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1531FKkPdoeThBWAQJNoyPkg6Tdwk2yHWy4ENtjFBZHwLA53
14661	payment	1726	1726	1874	1	1	5120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCSaSrqf13SGKV4WEN2HD4N3UfWLTLtHbYRY2Pj7zvHqPpp16
14552	payment	1726	1726	1874	1	1	5050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMcqXPXuXEXAU8tvjYypK5MV7aKGf15vssQ4N4yHFdAb5Wh3q
14553	payment	1726	1726	1874	1	1	5051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetvWi1EB6JXSuThWPhjuBP2vxx9ycKdaCY1S7s6aiNcAujafr
14574	payment	1397	1397	1678	1	1	7267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uPBRvt1Rh67QeruALzjY57B2QQt6t1B4EKzipkVxG3r571Um
14575	payment	1726	1726	1874	1	1	5065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcRP89LiPaN4Kiua7Pjtau9npyVKEKjdHiopsBjHVCmZMV8ZE
14576	payment	1726	1726	1874	1	1	5066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdzRe46m1ZPGm9Df57DBx3KGGiFuQ128bhoZnFHfudyCY1DBM
14597	payment	1397	1397	1678	1	1	7275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnEbnnz3hy5k1owaRZz56ffEuDBeki7mvWixysBzmSyFCNo5o
14598	payment	1726	1726	1874	1	1	5080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WCgpTty3Fiss8sF24hGpRYvrGTdFzc3jF1bGEcK1gS8T5sw8
14599	payment	1726	1726	1874	1	1	5081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNH8TkMSzVuooDxQcAp2w3nJjymXficnTi6hZiw1M7LfgNi9b
14622	payment	1726	1726	1874	1	1	5097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwTEBExVjsaRgwL3pGAi8fmtg7rmVJkxvj9zAS6LP6EPpj2YC
14631	payment	1397	1397	1678	1	1	7286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcPT4QQLQWvBcnC3cFYnSDD8gmkv8FMrXRKrj4zt2S3L2nu6C
14642	payment	1397	1397	1678	1	1	7290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgg7we4k3aYEUkyb27W38ZnKeT5Xtr7BvZPjPRJt3u121UvQT
14643	payment	1397	1397	1678	1	1	7291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBS9EbgrSxWBquLRM2vyxaLqFC4Y4FnVJ4sx3QKk1S4kLN4Y2u
14644	payment	1726	1726	1874	1	1	5110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYMcaeHDnD2F1vvv4V4VFh7DREWMdYjuFRfbVuG4QZhbcfa3Q
14645	payment	1726	1726	1874	1	1	5111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MJbkCfvkBvBsQyCZLELMFZE4vd1DXDVqZaBkyqMMio2rw2ca
14646	payment	1726	1726	1874	1	1	5112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicUemhqiXqdkEsN53WLCnng54XDKsithFVk9EoyR3DUEhsYxp
14647	payment	1726	1726	1874	1	1	5113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPe9wZZzEYEM7oz5dcjnA7qkaCn6BAhaRLUD5ShWvcxNuDFXs
14654	payment	1397	1397	1678	1	1	7294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLc1tFCxY4sEmGFtmuxzQaNie7Hez5wVA8nZgaqjBAuZ3w4eKP
14655	payment	606	606	2085	1	1	8	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1v4vPXX83TbuheWk3bsk3yr4wj5CKzd16JsuZ5RoCYf2mv4N7
14658	payment	1397	1397	1678	1	1	7295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Fg4toVYvwModNF2fctWmV9tgp9qcsRXC3xBaQqvvCf7b5rqU
14703	payment	1397	1397	1678	1	1	7311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppmAupKchRCL51Z2Nr3fjHEdWdjXoiTqJunUJaz4bQvU9rt4s
14704	payment	1726	1726	1874	1	1	5148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgnjkQSMRzgGxGb2v1AzoAv9Hp9uJMHyrwZjbUnrJoYmvy96y
14705	payment	1726	1726	1874	1	1	5149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ve2zExUadR7zxsyiUJ1iTYWgMSBs62668h1zzkQt2jRLZovx
14712	payment	1397	1397	1678	1	1	7314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42Fp7JPfjUxtYyjFjGPKQYunzFKYYcKYNpMvWYnSoxbaQUyeu
14713	payment	1726	1726	1874	1	1	5154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhvR7Cc5sqs1s9zDB6p33VYayD1cbkXg5kA7qAMWXQddAMpfW
14714	payment	1726	1726	1874	1	1	5155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWu7EufZSYXosFABkCGPG7DFCveH2YSCqjmALrWykDJEMZzvCg
14727	payment	1397	1397	1678	1	1	7319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKNy8wmWXqtLejiqeQKake7JMJMqv4BUymrNwaf3djGqpPzi6
14728	payment	1726	1726	1874	1	1	5163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFuQSeEemXEyfZ5eduzGL6KJujy1het7bi6MZ9zSM2EoDnhdX
14729	payment	1726	1726	1874	1	1	5164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VT5sdoQcntXVFxruKQcGQipQRmMLTaChnYdwzLtSuhqRDq1H
14740	payment	1397	1397	1678	1	1	7323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcANAEcxGukx1KzvicQBmAYEpQ9BDBjqM7fXEtyN6Qnc3GDgt
14741	payment	1726	1726	1874	1	1	5170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9v2MyfSAEiAR9ng47MWkLoj4Y86JoS8vRJJdnoLdCFh2wbTF
14742	payment	1726	1726	1874	1	1	5171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qu4LNfr1brpyKu8MBZy1vgLo8Qo5MC3dp1th7m1JVXEnbsoL
14746	payment	1397	1397	1678	1	1	7325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyB2JEBY6FeqdMF6BidmcMiw77nRE4qPNpxpsMHzCC2GtgFR5
14747	payment	1397	1397	1678	1	1	7326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeVG2CuDT3rHPxGuVfpbF6Sy7WFeCuvazKZXL2tCJVsaxD5qg1
14748	payment	1726	1726	1874	1	1	5174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8nRwa2V3oVdLijAsKhtKN8uQgwbiyC7zXVdC4WSZYaDbb7Gy
14749	payment	1726	1726	1874	1	1	5175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKDBDG95sdpuMfA6ThsmWF5jCRD4iYeBp8XBbdZHCJhgUTybS
14750	payment	1726	1726	1874	1	1	5176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6SdoUFTnHkkuLci1g4JmKzC1qZZHEDzfYcHVVacLBPg1NBfqL
14751	payment	1726	1726	1874	1	1	5177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzcKg3DWqxos2yaniSur9wLf8VSyczbP6HMfDkA6GGH3nQ8oe
14752	payment	1397	1397	1678	1	1	7327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYktbrdaaH5LtrnxxyiBfVzBQc181V9LKZ88Exk9friPPFA3V
14587	payment	1726	1726	1874	1	1	5073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnS2r1YJmNdHMuvopLXTG25bkWxhTgKnf8hGdXJhDKv77cLLT
14588	payment	1726	1726	1874	1	1	5074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGmWQz6iwwbzwcg6swEjxvabTRfVxEsRa3tHdLTsNYUVwre2J
14609	payment	1397	1397	1678	1	1	7279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTGqGiDPzmQDrYJna38bSQiv3Qh6jxWTaSaedFrDePtNjoHyE
14610	payment	1726	1726	1874	1	1	5088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85HVN84i6aHiQDkJ7Qn69wyewCkB53eWyMFDPFMVTD6hg4ShH
14611	payment	1726	1726	1874	1	1	5089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQWYGx3ktF8Eee8yJrrtFfawExGrrDPxK6BnxYXpDez6qVptn
14619	payment	1726	1726	1874	1	1	5095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEMztcvxwfAxkzyxBaLm9e61REegn1rB9WHjpvURVGeichp95
14620	payment	1397	1397	1678	1	1	7282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKdkT6KXoackPGsXz6twFYxtebFNeKnEsMMvrR9yrWhKxYaDQ
14634	payment	1397	1397	1678	1	1	7287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3dcyv5LAtEHM6qGqL5StUc26qR9zD17Pup5sTyD7bg5bZGdi
14635	payment	1726	1726	1874	1	1	5105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQqFrXoHLTJ8WuoMnkiGHvKFzqBvBJKMXYunwxT3SSM3bKEVK
14664	payment	1397	1397	1678	1	1	7297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurkaC8JKfgP645aCQqU7WnFbMY5cyMsEPZptsAqLHEJPUAQoh
14665	payment	1397	1397	1678	1	1	7298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxvgBZxr5aFWSGpm1TPhsJJs5YXaGivKugfFozascteVmKeVF
14666	payment	1726	1726	1874	1	1	5123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzXGZf85kH2uDd9F8fb7VAby9x9nqqi3hJFBYFYyVYvinLZnp
14667	payment	1726	1726	1874	1	1	5124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqrRwXcnJh7QJtK6akzPtNETTEhTjcuE5MfMroRYwew5XLS8Jx
14668	payment	1726	1726	1874	1	1	5125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUM7osJh4BTsn1FPkVvtrpabxAiXoThZNEWFp4fjFDPb6UBF7k
14669	payment	1726	1726	1874	1	1	5126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKB9mB2kct8ygAAf8ax4rL23Z8je27myBBLD4QtTDcGTNvH8K8
14670	payment	1726	1726	1874	1	1	5127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh6zcjzx7ZHFktrZLwwsB6m4FiyPktZ6oY5kGBdJ4mL1RajUA
14677	payment	1397	1397	1678	1	1	7302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuRyjec21HxMGxveiEyV2Jz2WiNcsZVg2yCK2NJixB8CmVjEG
14678	payment	1726	1726	1874	1	1	5131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhq1KtM3YdFpAeSeMUrghFtyEvXwKmUD1mi8rQZ2SpTqu7AvCW
14679	payment	1397	1397	1678	1	1	7303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWsjV5dZduDyxTivG2YBv2Y5SCt9rS26BGfvUrUXEe7Ryy3KN
14680	payment	1726	1726	1874	1	1	5132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDnEEyUAMbQjnYyYFmgqmQQEjFjtPG6xrqtyQdGMyD48crdtAr
14681	payment	1726	1726	1874	1	1	5133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYexrhcrWSNX5X7MX7trAKcrd7GVPrUeMCac8RyJW1Y3E9r1wN7
14685	payment	1397	1397	1678	1	1	7305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTvRip9dyABfr44dnPSqTDbcPybwsJerCRRYaKwmrEi3wuRupR
14686	payment	1397	1397	1678	1	1	7306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWFW8noe4xS38ephCPJ7tKBXCznW5azovzVW6Ym3ZSXWDt7zN
14687	payment	1397	1397	1678	1	1	7307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoa9YWDWLrtg6mAWGXBs2E2Zuk4Et8udSQmeTwgGV8t7uLxYDC
14688	payment	1726	1726	1874	1	1	5136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqueB2iVjVeQnbw63MgiiF99ZaNrxJeAZDvuHSFModfnG7iLh
14689	payment	1726	1726	1874	1	1	5137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ivKYVhQ1s5Boh4v1QJ31xkUPjeHFXpxPmpKT4a2z6rSuEVp7
14690	payment	1726	1726	1874	1	1	5138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVzsiWYZdT8kPzUyULkuwf58VddudTY8G4rW9qcCMuSxdN7CM
14691	payment	1726	1726	1874	1	1	5139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1MBUMJapH5nvCNDxPoY29XybuogKGsJ8ZKULpCn6jjA99HBL
14692	payment	1726	1726	1874	1	1	5140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5Ci1n7SR8dB2Bc1TesGceaaAjoEzF9W7yJ8N6VLwPmJY2zsg
14693	payment	1726	1726	1874	1	1	5141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQYxJQWCEEnR6wAMkMmTnoxp3y12HpRiiPVTQzVgGYMGzhCCu
14697	payment	1397	1397	1678	1	1	7309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4ancSYgm9WUnoZvZwaesbp3rQgFMFe2x1YkR69TUudpPp1bJ
14698	payment	1397	1397	1678	1	1	7310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsuWfAC2SJxdWqEyWkgrcFdkNYFEH7xZUaTFNZ6yqLG7sdr6M
14699	payment	1726	1726	1874	1	1	5144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3RLdwL8FRYAgR9iLhz1pyYWSgTxZDuHCiMDLRvhgC4Z2aHv8
14700	payment	1726	1726	1874	1	1	5145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRV1mzRhpRFbcmLxZBUC81Aogv7URuXc3H78KucEV5kkyqcrJM
14701	payment	1726	1726	1874	1	1	5146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wFF4YxWQBe5zoDheURmrVHvAvdU3TpdpX2LiBHRmFxUkhdrz
14702	payment	1726	1726	1874	1	1	5147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EWKkKkkoG1t8ymmeXcnPXS5STZVQrT3gXhE6zscbeNEoJULy
14721	payment	1397	1397	1678	1	1	7317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPX49oFrg1SRRnZQ42nZV1e8SserAnEUL3BKeqEWt9j57pftD
14722	payment	1397	1397	1678	1	1	7318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaASBi6P5K9e1H9BtUozWJuabzR9647pvs3SENg5oCVByqStB
14591	payment	1726	1726	1874	1	1	5075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXE9y1nkoouaFeWFxP5DNwi2iQNmHtH6VKdRGwkaeZNxv1tsE
14592	payment	1726	1726	1874	1	1	5076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGKtFmNhpZux96C77aS8yPSQhHW5pZn856pAWTUTBdygh95Sy
14593	payment	1726	1726	1874	1	1	5077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEU62XqMiMfzpk3McziDedBcnefLyxB6t2Tp1KgyxWnTiAnczE
14594	payment	1397	1397	1678	1	1	7274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6BgaNg5HVFLVRa1NuC3tHrBmUu8vQKpTRWdcAxpfuBe2iuccc
14595	payment	1726	1726	1874	1	1	5078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjmRnMPdcKSHdNwJrRUPq3Kqy98FiSKnxamMtEcB8nY1hAni2
14596	payment	1726	1726	1874	1	1	5079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KAuRZFNnMvv8Sh1KbLEyYDhKjDbx3Apc6Y8sEbj2QgXd4CQS
14600	payment	1397	1397	1678	1	1	7276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVN92Y2XabadHDKRdGTa67St3Ze97FX9Bdb8JMfYr8Z5qP4Twm
14601	payment	1397	1397	1678	1	1	7277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsioM8KedmyvbG8m3b1UmbE3ypabHJh3G3LvcTzWYuyFDLogpA
14602	payment	1726	1726	1874	1	1	5082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tAWQLBq5qfpjdUUwg76oTQbZ3y7eogGWmZoUgQFoPW9YjxLA
14603	payment	1726	1726	1874	1	1	5083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyAddPyCJVsp4B5sipEYCGjHz2MXr2RMwa7FSYgrPyufTFbpU
14604	payment	1726	1726	1874	1	1	5084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Kx5FahofcnxkmkeWxJZG9hPneYkeFvvRyUGCpv273x93iKJE
14605	payment	1726	1726	1874	1	1	5085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsizoax8wj1DSgj9hniJBKasv4UKKvGeKPJfQR6CM1hgEvxJZS
14606	payment	1397	1397	1678	1	1	7278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBz2HucPP7QjbL9R6WwWXzhKxSGcz37EsTBvtLpJWb63cDQiWw
14607	payment	1726	1726	1874	1	1	5086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxrmxkwhH8XTs5goZZHEo7ySc6yF3NrrT1Yqwv9g5n7fnZrV8
14608	payment	1726	1726	1874	1	1	5087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgPKRmbHxW7p4ypnDZfWzWaEzk2u4LZWk16TtgMhC7xNSL4BYo
14621	payment	1726	1726	1874	1	1	5096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa74M4kQYxZBpPY7DJWh82UAs1AjrF511Doxq3EU2cos5xZxNef
14636	payment	1397	1397	1678	1	1	7288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ayNrwQBNYKvdt7ge4jP9RBZKqaxBbbgtWrEgjaCwZfdUQS9k
14637	payment	1726	1726	1874	1	1	5106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTd6G13D4zJSjepWH7xyzKwi4s7c7FCtBLczTgU1EtzpMDaJUS
14638	payment	1726	1726	1874	1	1	5107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XuKxpnrDXJbDpRDGEkrVx9bxDvwjWe3pWBz3NPuunAV7A8so
14648	payment	1397	1397	1678	1	1	7292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASkW7kpYkqg9yubYA7PJzjXYKe7UvU3ewjXgzyABZSx6tqJbP
14649	payment	1397	1397	1678	1	1	7293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMoeoF6ycDQRRv3LRdAa3ujPtR5guiq53xkqRg7HDwZok3M1G
14650	payment	1726	1726	1874	1	1	5114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJusPnZSdKNdgzw275VPfDwLRc1M4YZqRPGKQ7wQKekNmB6cUJ
14651	payment	1726	1726	1874	1	1	5115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzSo43tdq7Zp8SPFBnGBWwYQeESggSKYAModDykhpKSznqpR6
14652	payment	1726	1726	1874	1	1	5116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmD75kMrhfsvy8UTW9EK3dFh7R18h7mLq7Bh6HW4sMJ3vQYN4d
14653	payment	1726	1726	1874	1	1	5117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYu8pUwtSg7Jw5dhouREWodkWCcR7wyVyPLNzEC6y6TsKXM5Mv
14671	payment	1397	1397	1678	1	1	7299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Ued9kUj4HaeNrKrLXYdyFgwM5T7MbwLGfXyw14C7c9oFLEWH
14674	payment	1397	1397	1678	1	1	7301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAJw3iv1D8eEeNMNJMQvXK5EpHm9xZrAQpiUCdmy36qDujX8Q
14675	payment	1726	1726	1874	1	1	5129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7oHJ21SuUpmWcw6Ci5EdojyCUAN1FoiCEHG7XoK9RiZ6V3PW
14676	payment	1726	1726	1874	1	1	5130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbvBiEUu18Uh9AWaUHCxSsuXhVRs98pcVucj1Vu5gMrNLkvan
14682	payment	1397	1397	1678	1	1	7304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnry2orNRiqZHa8uy4S4YUWiF934aPNLRJvtBG9pyZh51pWC7C
14683	payment	1726	1726	1874	1	1	5134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLf8oipFehCoTYzqfvjqq1SZCWT1XGMXG8QEc4vioZSqJ1RzcU
14684	payment	1726	1726	1874	1	1	5135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWoQ9vVfqhfimMo2VQhfe2fNAGLCEgFqkrErZwXhM572wCdsPX
14694	payment	1397	1397	1678	1	1	7308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQ8LJR6KfLMmjx7bNLF9vK1WbWsLtuDV3dgbX18N3gwtLigET
14706	payment	1397	1397	1678	1	1	7312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2DSCNhkKvrBE7gYUMHUvDybXZWRbaZPrUpjm6ZuSUQrA2r3N
14707	payment	1726	1726	1874	1	1	5150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwPsYVzr759PHzhfyy9vySQE5dPhH9gr9kVw7UJDMwi7qV2eN
14708	payment	1726	1726	1874	1	1	5151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTATDzk49X3MD3cKJ7Qbven6NFWLnFGtr5BgUoNtgT2P8sPj59
14743	payment	1397	1397	1678	1	1	7324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgnoKXnqSrRuXik57x31yiykX2XifTxT2fk1dXpc2E4MejJi8
14744	payment	1726	1726	1874	1	1	5172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRo7ii8Ax1rFqEgonTbpRbKcSSBTFzTS87G7aG3MExp1bGgrM
14662	payment	1726	1726	1874	1	1	5121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPdp5chZm4LhaUVuawgDtJuZ1TpCPNxaPpoJopraDZfi5vXpHE
14663	payment	1726	1726	1874	1	1	5122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TmPNApEbdiFvrKGP1YbQ2WFBSQ1fAtprMsxJ1uYcoxNs3nZX
14672	payment	1397	1397	1678	1	1	7300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHoKA83zKtY7kpxUHh3Xv9mR6MqRRKAASmqjDsjKQDNJhA95s
14673	payment	1726	1726	1874	1	1	5128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmeySzFs2UubvBGHDG4D3TE7XLemuTsCxaJzKUPKVPbbAeTqZ
14695	payment	1726	1726	1874	1	1	5142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7xGSJNAhBukr9AAkMnfRa8r4jHZHqFHm1SRrsZHN2bd686L5
14696	payment	1726	1726	1874	1	1	5143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRghfKnfEZfBe397mY6DzBcnch4evqn4KYVRwSR6UL6GAm6zN
14709	payment	1397	1397	1678	1	1	7313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nijbkTkAYTSmgbbCoM2J92huBUsefXSBmWZu7q5bbCvfv9wN
14710	payment	1726	1726	1874	1	1	5152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsguhDNfMT8p4b6XjNCX9zcYe1yZFDigBKudcwTgdq8aw2tUs
14711	payment	1726	1726	1874	1	1	5153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKF1vWU3ce4431wMC6HBFyh9paRxpRMzir6wZVHWqfnwA9Vq2g
14715	payment	1397	1397	1678	1	1	7315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2hQMq7rvWDbCMjDzWRvoL4sHe9f6EHfyRzqThMCavYWqHstj
14716	payment	1397	1397	1678	1	1	7316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcW8Tjwr3RX1i62qqBAWUC75LK2A8MzQPKUQLmw59FBFwuZmw
14717	payment	1726	1726	1874	1	1	5156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvtFNGYF6sCw1xNKkuaxnCs9bYx6xdWNUeoKQzxDm9piTbxxwp
14718	payment	1726	1726	1874	1	1	5157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CHdMSyb5Do1PGDvUftGSqiabsoYGM67B2r9r8z2aM5vQt9dY
14719	payment	1726	1726	1874	1	1	5158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4eVA9TJGQzvVVHeSGW8BpTbwobMP8X8JJse6nRsY42EjpiE4
14720	payment	1726	1726	1874	1	1	5159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrdctdU8TEZjsYbrvRy12f34nKSwEMnUPxKGb4WCZF4vDfCHi
14730	payment	1397	1397	1678	1	1	7320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MGgWNDWsezqJS2bXGKTi6LiBgz2kfawLMKXMmNdBJTpaLZ8Z
14731	payment	606	606	2085	1	1	10	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzfVpZYiVcbXDCTtZAprCw5B2D6LQ1y3k9p2GxyBpLz6M85uB
14732	payment	1726	1726	1874	1	1	5165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBA5CwMukzn3zyN7qSdY3vKoc1KDPSo5tA1z4vXNGMTuBXYkJ
14733	payment	1726	1726	1874	1	1	5166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48pfWGFrZ7BMckGHXqFGFd7jodoRysN1KshjYfiUjz6gANU3v
14767	payment	1397	1397	1678	1	1	7332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88UZ7yDudGCDzcDjddDWLKBppARD1uxrE7sE3FMcVQ4kYALNL
14768	payment	1726	1726	1874	1	1	5188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eXNAmD1yeatV9mjZZRiPyx3PB7E4aQR8KQcNr1ecL8rG1Crs
14769	payment	1726	1726	1874	1	1	5189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMptLxTfG48t2ZRPGJSnFmAjmAZi9TTmGSXAK8Qo6ZWZVe3bA2
14793	payment	1397	1397	1678	1	1	7341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8r3xsyb74yhwjsXq9hE57fKsnCMokw6xyMsNpQV6EPGcy1SS
14801	payment	1397	1397	1678	1	1	7344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn4BUEbiCmxsTqUeNnVB5LxCkQ2vaUJGZenaFddAHATSrc5YYQ
14802	payment	1726	1726	1874	1	1	5210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6FFumsyGjYzFcJrtTf49woQ1L3BjJtxgb9TGP76T4FzR6Q7x
14803	payment	1726	1726	1874	1	1	5211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDMWMmkMEG77WoRNaHra4S1Avz5qqye9b5m59yHQDRurpyKK6
14804	payment	1397	1397	1678	1	1	7345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQ74zWKZNUMZdZ2ssxxmKkLLeW7psgdTGpwoWc9F535QAtYqJ
14805	delegation	1750	1750	1745	1	1	28	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaS6KdXzUZyuPyzrpkMpC5Jb59gffMfjGqdzGQuB6haDnwaDAq
14806	payment	1726	1726	1874	1	1	5212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHeXnnEFbh1UAadZZPSu2JtekmjXHSbWFoDBimzBJ7k76pjrR
14807	payment	1726	1726	1874	1	1	5213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa591Epmu3x7cwYfWznDHsnkNACMLRXWLK6GQPdZZXGGk8HGzkg
14823	payment	1397	1397	1678	1	1	7349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcwsr8FjrYumKPGvDkgkJbQfH5cFS3bSw5Z9ztnv7RPwDfN5V
14824	delegation	1750	1750	1745	1	1	30	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfr1yvvHpe963kKdZs3fXb2dFGUYojRzXZnXuEXChzkcjYxNK
14825	payment	1726	1726	1874	1	1	5225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHqKyPVfymp9MCpFjrFDRkMH8g8yjsRi6BpEtUnaNcgyW8bFb
14826	payment	1726	1726	1874	1	1	5226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpWmkp4x7s9svWYXssSBawfRUUh5qGBccuL31Ff2wp2fFcxaz
14827	payment	1726	1726	1874	1	1	5227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfG7assznxYGNbcB6c7cdemL72uCmaKsGNRayguwQZPdpmgYi
14832	payment	1397	1397	1678	1	1	7351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBRbZHpQoPv34eC9yfGDxw181v5AhjRZESRLMwkaLk5eQPj4P
14833	payment	1397	1397	1678	1	1	7352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLesdsS14iVwPp3kxmThXYj79p6XJzrnQnVC6m74CxMYL4mLu
14834	payment	1726	1726	1874	1	1	5231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPWPYAzBz6bR2wdbsNyo2uEJYC8WEomjSKyAgeysLg7r7X8d3
14723	payment	1749	1749	961	1	1	11	2135500000000	1000000	\N	E4Z2pPQ4m3xQiCqSCGzrfyVjQ9oRJhYrEnLUubuMGvS64VAufATCw	CkpYtQ1jioy9mMRGCBUbQsvGMM5zDrALWmFRoSB78GHcJTJCBuC2C
14724	payment	1726	1726	1874	1	1	5160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAqUwpozH5axeJJaXU6xKKH5J21jMGzh111MEmuvq5ZCnCEwgZ
14725	payment	1726	1726	1874	1	1	5161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBGv2Qv6Cai5KMf9sBJk2jQauVqtEMqF5JDrJkxZfDeExRGzU
14726	payment	1726	1726	1874	1	1	5162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo326QhhV9SJJK6dWbnhR6uoNXGEEzdMpCVowNc4LGUiikDNqM
14734	payment	1860	1860	2088	1	1	1	1012300000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3hQdy9xt2s2NQzxjDuhDJ1naTCAtgJnPE8vzvcWZdJNFkz2v
14735	payment	1397	1397	1678	1	1	7321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmk2SW4WimrD3SV1eeuU9tnGs5BbJsmGF8FznmynxJ627JFwM2
14736	payment	1397	1397	1678	1	1	7322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hLA73mNJdxBEehE8Z5EkqFGwB45pGDozf47j8q58DsYqkW4s
14737	payment	1726	1726	1874	1	1	5167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeZVAJwbftDLdR1A7qHJM99UxYo7fWNfAUTTT1tN5xJBH68ts
14738	payment	1726	1726	1874	1	1	5168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNWfJk5KwcpXFdSs2cFdSj6W6GqL5Fc2VCZkkMvBN5dbwYNh8
14739	payment	1726	1726	1874	1	1	5169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3RBvjAFnvD8dFyZtCsUoQw8T36H8bVxykVTLfaAt9P2t2D4p
14761	payment	1397	1397	1678	1	1	7330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgLki7dp82u6zvVU9BHSCdRBkytJUZGJQMoBa7ZnC9ZQWqW5Wm
14762	payment	1726	1726	1874	1	1	5184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Dj86EUN7Hrejdup9TNbr676eUMCHQLsnHqErTgEAn7D7yraW
14763	payment	1726	1726	1874	1	1	5185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPiCA2kcCqHyKFLdPRWBJarbzPGBkxwExErCpbbcgnsAjTm3D
14764	payment	1397	1397	1678	1	1	7331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtFCJ1Nhzhq8ahZJH2FKLsdznU6q3eHh5RcvSQxN1QUTkCy1k
14765	payment	1726	1726	1874	1	1	5186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgaoBGMGGdHYMBmpdXGRobLK6cQDwkTknroBmr7VYRSccz4vx
14766	payment	1726	1726	1874	1	1	5187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayEPceEr9FXprU4CPffuDyt2MCLVaa3eRVserrAK8h3NM2RVD
14775	payment	1397	1397	1678	1	1	7335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwnguDFm7e18M8z2e9jdh8BRTtQchZqRYHUeV3VNox1JmyPxM
14776	payment	1726	1726	1874	1	1	5193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc51zW3rvDEpgBN7G9c4ygfeBf98W2ivCGBBy1LKMbgdsYd7cH
14777	payment	1726	1726	1874	1	1	5194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrTUckkiDXDL8kxDEcXGqaEFMbTDeqAmhiGhTRYHGi3k5TN8E
14794	payment	1397	1397	1678	1	1	7342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZobKhdjSHZR8swFHernbJpeJBLMxfyd6HvpJBWR1YwmGs1UJyS
14795	payment	1397	1397	1678	1	1	7343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTe52f6Pw9R8z6qHbrno8cALqJNFgNj2Vfcd51jrGVpUHb2RR
14796	payment	1726	1726	1874	1	1	5205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnJcmrZdibvq917REDoZCVxyJ3WsxtgLace4A9NsRLXsHYyaL
14797	payment	1726	1726	1874	1	1	5206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyg1Q8dREQqMFw1tv336pSi6cpeNaPDqWQn9R1prg43PeprEH
14798	payment	1726	1726	1874	1	1	5207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY26RFPFKtFLEs1AQqCurEPUDWxpet4L6xzhVnYidBNouPB4TN
14799	payment	1726	1726	1874	1	1	5208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ti4VssnZzJSRdBzGHxtU9UGs6FVRyGxCvTFVWJBRhMWMUpti
14800	payment	1726	1726	1874	1	1	5209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv4aLsE7dwBUxaqwj3hfiq9Nq82RKTfB5kyopvGAyXeWj6rAv
14808	payment	1397	1397	1678	1	1	7346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8jPNofZeaStyg6vCvLLAeVMuVKVcP2EvRYwZ3ixr9ruwYwQL
14809	payment	1726	1726	1874	1	1	5214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmnctwFSYe7qYiipGkFB7GFEJokWJ4UEtKAQhoNwbVwiFxdyv
14810	payment	1726	1726	1874	1	1	5215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpDrtgFp12X1maAqCGAcxnemQ17NooxUPmhDXJbCnWM6LBNE4
14811	payment	1726	1726	2089	1	1	5216	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYuxoeQx84bd6NGaadDcnkw282wrux4o9gZG6E8fxtHJtum64TY
14812	payment	1726	1726	2090	1	1	5217	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYWRni3dcvfwx1dE186rm67RRzPan62TDsyhCgzRJxtRrSvR12S
14828	payment	1397	1397	1678	1	1	7350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZea5hBSm8XcHDq63pXU7VJ9Ybixa7gTQ6uBfNHTbFhUSYFit1a
14829	payment	1726	1726	1874	1	1	5228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ87v4MjincSQQQuwYurKnegdvSD57gstVFqAkhVqkMdUNoVao
14830	payment	1726	1726	1874	1	1	5229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt46EqgkYZbMQfRDFBydYdghNKUruMFwn1SZ4G7zvV7hRAszz3
14831	payment	1726	1726	1874	1	1	5230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSo2fMh6x4eWxy9o9NsPJvfeeCsZUrH8u1nbGYyKZwPJfRDu37
14844	payment	1397	1397	1678	1	1	7354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVigWHGLqv7HYro9k58XK6RU3AfyM5cpZ5G4bGP9oS91QujEs
14845	payment	1726	1726	1874	1	1	5240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRetKqmaq7hfrcwsF6zU2KZb4RoN3YJHHcadosibHV9XPz9CL5
14846	payment	1726	1726	1874	1	1	5241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLtjujXCx597HVKvFTepzqJWw7cv3vS6hRbpP3ZiHU7FR7zYy
14745	payment	1726	1726	1874	1	1	5173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNL6Tv4LtCjDxsqTTjU5oLEcHwQb86u1praHVoybHAvqXzTPN
14755	payment	1397	1397	1678	1	1	7328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCq6NWxeBPcs1k1x8j75qJxRU81Yb9px1wuvr4wFg9ENpK4ed
14756	payment	1726	1726	1874	1	1	5180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qhuJwvg6fWvc4UhpwdTfqbqdbM73C7jzMv4xsxRutK1gX3Uf
14757	payment	1726	1726	1874	1	1	5181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4ATvJcFS2Vms9SnPk9o9KjBgFSR5p9GYmdsUbCS5UJgh8n5D
14758	payment	1397	1397	1678	1	1	7329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDKSHtZyHG9P38znjKS4LbpTfTXuN5rpGwVa4mYunhrSaZ8vrZ
14759	payment	1726	1726	1874	1	1	5182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVV8CbpsjQk3DY5HP4VY8q5pYkTnhSP5XnwaraPKyGj4sAuuRA
14760	payment	1726	1726	1874	1	1	5183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ac9kpA5vQ5RMhRTZn4HJmS5yvkwKEtT6W2LgYzsE2qzSNbqz
14770	payment	1397	1397	1678	1	1	7333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQFrK9A5LynjiezX7GdHKTM1nhiq2GZtByd9k5iq2TYfMiFVT
14771	payment	1726	1726	1874	1	1	5190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ2SS6BKU4xXxaBby7HUwM3BbrYoiihDeFfGpnAGZ7FxpAhzP
14778	payment	1397	1397	1678	1	1	7336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dvdowkjq1RXB1pkiGzg4hSqrw2V73BAtqqL8bMR7dNw8pBRM
14779	payment	1726	1726	1874	1	1	5195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbF6q4kq9UZK7P3P19SMPpKYZTW41tm2SntHgKzwQ2DuoQi8u
14780	payment	1726	1726	1874	1	1	5196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhxR17C7oG6vm6T5pQ4gFMJkHYNKmMfr5Uor1NkZyh4Q8QMXQ
14790	payment	1397	1397	1678	1	1	7340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6C9RK3UyBSq8phV1Ppp2kSThQ6nxQeUrp4Z9wz3prpGDW1E5
14791	payment	1726	1726	1874	1	1	5203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWQXhR9uSfegq2R1Hm4s36i6yrKcvkC1cEneRUTnDnw28CK1h
14792	payment	1726	1726	1874	1	1	5204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGXdumx57X6euxma1syD1PeLuWkKSMuFKiLMuh3tgkEsK6aNN
14813	payment	1397	1397	1678	1	1	7347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSHq47qJzJm7Lj8tafVuCtFWcWJgxe8CknhT9qWTyDofVwP61
14814	payment	1397	1397	1678	1	1	7348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnRTU7KKSptaFzY1PErbAsmAb2EuhKBKhdT83UBzJHymMekwr
14815	delegation	1750	1750	1745	1	1	29	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WUXevvRznaDxWG2VukDCSLq4R24Fr4s16HeevSJdMdUK7byH
14851	payment	1397	1397	1678	1	1	7355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSu5Te3D2RvjymPNaZL6H8RWfLTt5ZMryWBr3h2fBd78mUBrz6
14852	payment	1726	1726	1874	1	1	5246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgGcwzRoVTYUoJDaoRmqfWL9tVczsr9hQSmFaGVA95FiG1VCN
14853	payment	1726	1726	1874	1	1	5247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXZoCnBTJxZ7R3X3izjMs7SFZ4ciRrqFUwGXuUKfmdapppG7R
14854	payment	1726	1726	1874	1	1	5248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyY6QwXiaNz7NTs96mdWxmA2ErQJvhfhNsKbRMe1Ndt2Jzwib
14885	payment	1397	1397	1678	1	1	7364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsx1AjM8L1e4PjowR3BRXRMASPYZP2oZUqP4zUB5Em7s5bVc2G
14886	payment	1397	1397	1678	1	1	7365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGYvVpY4rpJp8x9cbwxrFnibGtVgPdPWUSXhAsT89ruWhifDM
14887	payment	1726	1726	1874	1	1	5269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxZsok6dV9p4a5LD8dxQcf2Tz8mzRgJU4tdCTbYnsGd46HJ7b
14888	payment	1726	1726	1874	1	1	5270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4smEEshczfyMapXUmq6Reph5AH6sFwyp3Xb9jWG4Wy4SgHVe
14889	payment	1726	1726	1874	1	1	5271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6cmwyUuFBStHkPUxXvm7xDfr2M8J9rBaMhUoBzpSHXJ7rsasm
14890	payment	1726	1726	1874	1	1	5272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTHuFMQn6Lv58t5vBmwWjZuw98ecnRetKsHRqtP5bGfLvcZJi
14891	payment	1726	1726	1874	1	1	5273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapsVcPCk1z3Y5BTjQ17HRy8fVqfRixJmyzFAG5STCJBWNfgLo
14892	payment	1397	1397	1678	1	1	7366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirZ16rfL6JqzyNm1GcogLze8MwpeWRFWySEAvn5Mcyf2C4VzS
14893	payment	1397	1397	1678	1	1	7367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdQPpMQrhGnKpbgkJDX3o94kpQMwTfi4NnKaPUQqSnWsm5eyu
14894	payment	1726	1726	1874	1	1	5274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh4kGJ8CRH8pQUqW1rrLjUUpVL3HYqH85fY98pPDddUSrhJhN
14895	payment	1726	1726	1874	1	1	5275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncR55NqCu9v4iLnB6Zxwdi22VpYY7Z1146hVi5gMjUU9Xpr4u
14896	payment	1726	1726	1874	1	1	5276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpq3SLdZXbtF1TnmPoEHFCZmjZEzzaVZ4Czr62PRMbmESvxmoY
14897	payment	1726	1726	1874	1	1	5277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTibbyTFNf5LZYDMcYFaTGXVRZ2ASwTkVwC1QqLpPRRDuTH9Tk
14898	payment	1726	1726	1874	1	1	5278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPZWKXXHb4s9kExm8rdM5MzE7WNcpUDbTN7aKUL9E2ZZ18mhb
14899	payment	1726	1726	1874	1	1	5279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4hCDntdGhg9QnHW5Fz6RrqpCh1Q5VDJd7Ppw6QoW1tnnrhun
14915	payment	1397	1397	1678	1	1	7372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTgjXTBAH5Hg8khqiPeWxPNr4EXv9TMPhAKDWbGDbBoLkeW4p
14753	payment	1726	1726	1874	1	1	5178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GDsnrDozGE5UUcvzxRK3sSE3cWep7PkTSX7CULr7cw8JTagL
14754	payment	1726	1726	1874	1	1	5179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTMRzacPEsWY4KngpZm58tH8xZE81MeGjAWa1cmeU5eEgZFPB
14772	payment	1397	1397	1678	1	1	7334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUDg6H3PA7esh8AXXar3jcPhWA3g3dRqGTbwUyTN52mq9n7wr
14773	payment	1726	1726	1874	1	1	5191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnEA6rzqyWhPfMtc1rDwaBoCWWwHxEKg8YsBydCdY7kTZfqZS
14774	payment	1726	1726	1874	1	1	5192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUT3ZpfrMpyx92p84xPMsAK6BMVDkAauXao4cHSSsm5UPdr8m
14781	payment	1397	1397	1678	1	1	7337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvV39FHPMRpVcDmRf9imerU6ByNjVGG39ZnUr9hd18XLJ5Eq5F
14782	payment	1397	1397	1678	1	1	7338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsL488xG9dDB2vxJv6jsiVti1YFgcYEc4RCFwtAcJ3gUzSu7J7
14783	payment	1397	1397	1678	1	1	7339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSfk3JcvVmeNnY744swPjcEpEPEvGiCUmHcuzpCZVJoQxnk14
14784	payment	1726	1726	1874	1	1	5197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNvpHYShzZjYSu92o41pekaga6jZ47bmHZC9aZ8gXYRCUrAWv
14785	payment	1726	1726	1874	1	1	5198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1PArLwaebaXTubQuWd19U7UU5Bu7DezFyeg7LvPsmwfRZTL5b
14786	payment	1726	1726	1874	1	1	5199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqTnN8SpWHUYXxG75GkV1EcXQSXtkftZ6ZvBEkgoZrW625tRX
14787	payment	1726	1726	1874	1	1	5200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjt31jqoxqGG3jVpzye3ap8T7RyYfFZZJYL8FRz3zEfysY68ds
14788	payment	1726	1726	1874	1	1	5201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsqYcF5i4UaEKAXcRSaYzhrVbSPgWi59sn3Jy1xbYzcyhUNFw
14789	payment	1726	1726	1874	1	1	5202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9Ja9Bg4UfwJkev5x7mnwt6oo5h5fvKfQ9AYuexxjMCphZnsd
14816	payment	1726	1726	1874	1	1	5218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBYEXpzuqhmstLSN6qBqeDqTEPjcDQXoj2DjzZwE5k7djr416
14817	payment	1726	1726	1874	1	1	5219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4udLv3nabfZaWhagoC38XkgJfDHbPvwCodjx7Z26jPQ2AAcL
14818	payment	1726	1726	1874	1	1	5220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8Xwp172VSrH2dRre8scTDjGeMnjfP1kfgoKRZ3SGGyp4uSD3
14819	payment	1726	1726	2091	1	1	5221	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ3WGUyijEDPPxsgpb8wKXNDpTvVfd8bJyZCmx2hCqzLas5akim
14820	payment	1726	1726	1874	1	1	5222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdGB2sCjF9xnmu59pDAbnYvpsgoeqoEVQR1HA6hingzLgsGG5
14821	payment	1726	1726	1874	1	1	5223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtL2XRxnvCheB1yQhFtF6KpUyVu7e9jN6HYc62ccBkEnpb3g3a
14822	payment	1726	1726	1874	1	1	5224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12kAhAgVmnnYMFKRLUtpK5dE517oPqfK1rnfW2xqaVY8nwu9c
14860	payment	1397	1397	1678	1	1	7357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hYoHSjeQQMu3efn6aoMFbQtbnFoEc7AMHPjmGQ252kePQir1
14861	payment	1726	1726	1874	1	1	5252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXX8ZK1LEFvDUdRDntC8AKJMBHJhzKY6rHB15xv9koLXEVvwjJ
14862	payment	1726	1726	1874	1	1	5253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdFN9KNqsCJf5C5k8T3fj8JPrxwjCc8HUp6oK3cuQiqMv65bT
14863	payment	1726	1726	1874	1	1	5254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaWc1wVHgPXSodAZ7zagfh44VwtewShW4VcWoER7rLC2CZcyY4
14871	payment	1397	1397	1678	1	1	7360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkg9CWqy8MjJXrHeUkCgbZ8eU6i5k9LTaZxUfDm5kctQM8RbJ
14872	payment	1726	1726	1874	1	1	5260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZnaDJ9YhDHJEWm2w1BGMkJHQ2mr8jzgdVWmjkSPAmUfVxwCQ
14873	payment	1726	1726	1874	1	1	5261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQFMZEkWbbG9DAuHDpoCLYtK3V5pf6bakxS2jdpryzvGhwz68
14874	delegation	1924	1924	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1eACJJrnk3xxTEHK8hETiQciTJKJE2smhiKrNyxq3BUbcvxb
14876	payment	1397	1397	1678	1	1	7362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfJ18XDMPJAjJL6p1DacmQrttrhzNyxHsdxz7nPupJDFqo1Lc
14877	payment	1726	1726	1874	1	1	5262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65x5iitLB1CxBGrNLC1KQJmQXhbRrmtn4Tfz2BT7DsYvPHz4A
14878	payment	1726	1726	1874	1	1	5263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnikz8bphoksjCxr7doztY3WkFM1Ekh2vFwH4FVazMJEs9iKBr
14879	payment	1726	1726	1874	1	1	5264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigAV6DjiDagCuScDnssuYmmNpAVx8zevdnfAV86tEE7LurrNB
14880	payment	1726	1726	1874	1	1	5265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTc8NzJrQMdXPzZsfuczEQuy9uAtiLHVxr7NwSnweggw5YneAm
14881	payment	1726	1726	1874	1	1	5266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenLoPLhPZpPENT67y4t7ZfGfXHcgz9S1muJsXRfg6e6avUCAt
14919	payment	1397	1397	1678	1	1	7373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sTVkiAYGVACSb8Zu2XjEy6vXDM8cWShUFCqBt9vtV2VeXG7d
14920	payment	1726	1726	1874	1	1	5294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQsLMQwBJuxb69HYb3ZUxMaYJPjKUj147MuGuZ5pvyY9XSNJn
14921	payment	1726	1726	1874	1	1	5295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdENBCKU63oRvprVjdGrbvMcyn2TXYA2vfMkqc5spxhbj2eSTm
14835	payment	1726	1726	1874	1	1	5232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTswjEjfeZM8VDFxsDPm2nv9An9dVMfSkde6Qk4ryxFdkLW4Bs
14836	payment	1726	1726	1874	1	1	5233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkirm8wcwVpoStf1ZPPr5eLLHSHouUDJZfNkqNYHanyQdVL1xJ
14837	payment	1726	1726	1874	1	1	5234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZgUp6WWKHK4RBcftL4MVbiUzjPXfNH8bXWSmXbgoRhzoKtT6
14838	payment	1726	1726	1874	1	1	5235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5XmY9yoj4GjdmbdZGey5D2T6cBARwLXcjyYTfbnKs7B5o1sL
14839	payment	1726	1726	1874	1	1	5236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHCRwE9AxfMWKW66fsgrnLm13JvUbjqZzBAu65RVNmP3wJpJs
14840	payment	1397	1397	1678	1	1	7353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHfCuMvsEgrnwuqh6RoUozn7CDoz6VjAXJX8tGxhybdYUk5PC
14841	payment	1726	1726	1874	1	1	5237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rymM84ANCbkyav46RDot9GWXNBTQ3UFqiDspAaTNK6n3VcjW
14842	payment	1726	1726	1874	1	1	5238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMLLHsxzta5AD92kVpcZuDjX789DtePHuEBNHEhYXbygQ3DqM
14843	payment	1726	1726	1874	1	1	5239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9izThvffpNtVtPZkTAyh7DWNej2b5ASmLsLZMAqvddebuk95
14855	payment	1397	1397	1678	1	1	7356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhn7cfRnSh2TkQJ5kQsktmA1bqyqyWnr2WLQyMEG9EanV5Maid
14856	payment	1726	1726	1874	1	1	5249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZAFtCqKbe3yM4awscB3mmV222nbUwnu7QKThfYKpEoU5fFBa
14857	payment	1874	1874	1726	1	1	0	204000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YwB6Ne4QdLnrv4FPnmNVR47FahnvaaDLDgcuovXgS5J2Fdxk
14858	payment	1726	1726	1874	1	1	5250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7GUWGcdbHCsMVytR2wnfJjxQM3bR1esgvzCfB4edV67qSmqJ
14859	payment	1726	1726	1874	1	1	5251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jCSu2JEBx4utuouyHbWTK62Qa2cj6AWfYc1g2zvHCbKPZAUQ
14868	payment	1397	1397	1678	1	1	7359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQtp7mbbGyLhh8Tttv7WFZzst83mK7s1bGScia12DdWAk4wNw
14869	payment	1726	1726	1874	1	1	5258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Kbeogq7wtnSBcscycUHNrykDoqU6UFbtqiPYXft31cucJNCc
14870	payment	1726	1726	1874	1	1	5259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZefXvq3Nt6PQ9PDjneR8DAuFxzLxtkpT5uEaoFDZQ6v8Mh7aLX
14882	payment	1397	1397	1678	1	1	7363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYn7GFBrrqAqtKUc7LTs4LFx7FghvVpmyPgLybnB1SD3RcnTkM
14883	payment	1726	1726	1874	1	1	5267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5vYmiDfv1vPcDbbKWM4UAH3EQ3MQfskUhKzYYuu1XyUJ193V
14884	payment	1726	1726	1874	1	1	5268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iWHvEDwZbRdSQfQD67J1vyoBbQCBVGaGZajEwgwT2HKTh1TT
14911	payment	1397	1397	1678	1	1	7371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hfKthAvDUx3tcqG8GnybJWJPvbaFAZAQzBRSvJeYdrdPKVgG
14912	payment	1726	1726	1874	1	1	5288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHytvihRTh6VFzcNUFyUxJY3fBfsFBu2zNazXEuTSmSYhDa3Cu
14913	payment	1726	1726	1874	1	1	5289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nS7MRFXtrYHgRPC2PJ4vDKWgcgePAnqVAZfB3ihA2gJJA4T9
14914	payment	1726	1726	1874	1	1	5290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGwBzejvvz65ytZj53EojF2LkmndVaCxB65rvQdUwrdVbh5ME
14958	payment	1397	1397	1678	1	1	7383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gpkXVi5afXFRMcFRzPQHE2rmS6AvCsNwzq8J9bDWoJPMWQq9
14959	payment	1726	1726	1874	1	1	5322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQnYfuuzyrjDBtWBiJZHoVjode6fcrhzgW127dFt39pk76CUs
14960	payment	1726	1726	1874	1	1	5323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRfsXdJajHWqRsXZYcF1AiMxzzV1FrbeuYe4BZ6VPfjf1eZT5
14961	payment	1397	1397	1678	1	1	7384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZos2vXaxkPmWBt9FrokBTpYbmhLzw9LbYnHRzv2PrwBZUCXmfj
14962	payment	1726	1726	1874	1	1	5324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5ZbwJRnYehErTdMCeHT8fQcznds7t4V169d1CPJku26zturc
14963	payment	1726	1726	1874	1	1	5325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZts97jPNCn8Qgkmxzzs8jzMAQVP1pWE1cvUKnVkvzAdjnMLmMc
14978	payment	1726	1726	1874	1	1	5336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2p34k4SFfWUJJUmPHcQKh4E2VXxGSNi4W1X7t1JbS3kX4rgni
14992	payment	1726	1726	1874	1	1	5345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsoTUEcBbRmcXYNjDJmbwZkagq6YM17kux25EznTKQJXVppGC
14993	payment	1726	1726	1874	1	1	5346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3knV4ZLVkse4NSq3grnxw9EF2rZDDgoSqtqbgLMMjDsW3DA6
14994	payment	1726	1726	1874	1	1	5347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzYx9idfx67Fe1nqxkfGMSDf1eJjvpKhky1cvbDUnP6MZu5Ek
14995	payment	1397	1397	1678	1	1	7394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnQ2PiZjSQQwsxu1oHoBeuzV633UgNootrtqsEcVAiMxAoVUP
14996	payment	1397	1397	1678	1	1	7395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqH7KUBBxewStuuTa5318nG3YgMtSk67JrdAEztV5pkzT4u7tC
14997	payment	1726	1726	1874	1	1	5348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgv9qHVQ93qzRVXptdcULm8hQbgQSgn79nz7Big6nxiaHTTxTm
14998	payment	1726	1726	1874	1	1	5349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6KcRPZzKp8KtyhgnnQgfzQhbiVWubc7wstBYZNV1bFTRik1c
14847	payment	1726	1726	1874	1	1	5242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYCz2znCEgBNqWcyFBqtHBF2aLZNLsnbA9hkF5cqYqZQCdw1B
14848	payment	1726	1726	1874	1	1	5243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTq1HuA5TzHuSQR6vLWzES88tDHpKWV7R9tCwg2CSyLEGL3H3
14849	payment	1726	1726	1874	1	1	5244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEpn2xq6mmFM4KuhjJu5Nz3sCNnVisELkuFfcvdimiR49gA5W
14850	payment	1726	1726	1874	1	1	5245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCQbHXV8z576gszX4pSRejFrzpfTLFCYsV8G2K7uA2iPJ1vtT
14864	payment	1397	1397	1678	1	1	7358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9F4pazZn1kQHHy2tKy22G54sBLTdkC1qSc2E7xhFUAA9U1Xb6
14865	payment	1726	1726	1874	1	1	5255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCHVs1k9sQc8j7vSuv5gwmKXR8VXPZffcvn3dL7uR2PEZvMbu
14866	payment	1726	1726	1874	1	1	5256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDyZM76YN337NEHjEY9xUA1Zkvw6sNgQThtAXza25Xu3VXkxJ
14867	payment	1726	1726	1874	1	1	5257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEzSt7kd44PyCmdrZ8n2tkUXdsbNfL9JWgc4dvFmb53UfnzWh
14875	payment	1397	1397	1678	1	1	7361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3uaaWTj1VfbMn7vaxKAYXrNmXenHj1e5RuE8MRrkzkiafcWV
14900	payment	1397	1397	1678	1	1	7368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6n9q6C3gnBiUzooQr5jsF5ZTHQ5QxH3TVWDWxjKX9nR6Cv23
14901	payment	1397	1397	1678	1	1	7369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpQD8HRX8XZHk8gDzx3okZbXGeegYGg3uej2GoCSaDmHdk4cr
14902	payment	1397	1397	1678	1	1	7370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPwSoSe1emnqVjPeEdpdLdzM7Hrc4jiNkRxKq17Jc6zou4moR
14903	payment	1726	1726	1874	1	1	5280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6pokcrdJxNx23QCfwxVwe92L1fs2MKN4KoSzSXQvgeRGo4n5
14904	payment	1726	1726	1874	1	1	5281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm8UN4jo6B81BVzxQaWJPd3hFEmWK1k6KVbVPKwzktG6bxGbr2
14905	payment	1726	1726	1874	1	1	5282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZai9x5zWhSqSd7bp26dZVostDT3KFFfc7TUBTfMkqHKQJXtqT2
14906	payment	1726	1726	1874	1	1	5283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSPo2fCn5MYwoZwH6Guzs5rVxrjDVtfSt9D8pxvTaSgPbiWEV
14907	payment	1726	1726	1874	1	1	5284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFsZdBHHDzcVh8oLEL43S4cz3hF1pHkSS71Ewpr9jh8vE3ewc
14908	payment	1726	1726	1874	1	1	5285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidU8z5ZXzB3Zkn83ssi4NhomH7qawG5skf2HC6B5Kf68KDUuv
14909	payment	1726	1726	1874	1	1	5286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsp9qNqGUcudpbNGVc9rnVLJyTUauJqZz52yHsg3Ujk5x3baZ
14910	payment	1726	1726	1874	1	1	5287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhEiHPdupunf29233qxoFvL3cfKmB8qJaWgSBMBTVtXC5Uzsry
14923	payment	1397	1397	1678	1	1	7374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4eSJa9btm2TJfXWgKpuHAMSTZoULF5eyy6Y3NVz8fvd857sco
14924	delegation	1942	1942	1402	1	1	0	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBDQrmNJkMNCAMhiFMpF63gE6hpen1SSix7i6CrrW1mdCxMAn
14925	payment	1726	1726	1874	1	1	5297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qo6xbmHBbEGgEowCmwjxgHzM6Zw1hUrx2kXnVJD8wSiRLWUU
14926	payment	1726	1726	1874	1	1	5298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZKeomLotCgv7GcsjzK1cTHgRFrnja8y1n5493p39z8raWbup
14927	payment	1726	1726	1874	1	1	5299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Kzb5xEHRfKGVHstCpbeKVAfHGmCYhe5UtsJjCrKamejyUViu
14932	payment	1397	1397	1678	1	1	7376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHXTCerZHX5MLwa3RFKCdP469iekbcRgxWqY2k4uyB6oNBpzS
14933	payment	1397	1397	1678	1	1	7377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwDkoEK5YEEMnyjToeWLXxDaF2pWbKD1CSC5pbbSqtiNkBvGB
14934	payment	1397	1397	1678	1	1	7378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DrNjp8MVxpPuSALagpL8D4mSfZsa3UvGDwN3X5sAPRgESKy8
14935	payment	1726	1726	1874	1	1	5303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimo6UKTN9ymwPnYUE7ddfrFsjXMAsqf5zYzmf4uCQ9Y9uQprd
14936	payment	1726	1726	1874	1	1	5304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDXj6vWfJ4scQK18vqwxCdX6rgCfBSR9tdGy9AiJXqsNKtt7R
14937	payment	1726	1726	1874	1	1	5305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCGwLAG2PNaYcBWDDzUfGKMMqp3ugTazN8KsLtTgjcNWFL3uv
14938	payment	1726	1726	1874	1	1	5306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfPZXHDwZASZTSRaKmpjTSzZmwP7Ro71PV4ELqKjfuBbXzG4P
14939	payment	1726	1726	1874	1	1	5307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJT1W7hm8uMP4VAcZAAVAaV77LKNEoNhWK4ifX8kvQrM8zXVE6
14940	payment	1726	1726	2092	1	1	5308	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvkkPVuD88CJq3HteWcoRKvQ8VXeqhpeBZ2MYe7s7HBaB4Zc5m
14941	payment	1726	1726	1874	1	1	5309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51SAkoJ3LRE8HQFeqDmjK644ccRKAJ9wH4hiRZHez9xbYANrP
14942	payment	1726	1726	1874	1	1	5310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVxJHZDSa862iXKsrXvcSngPy9ffadSS7WAA6h6YY4WxpxyDc
14943	payment	1726	1726	1874	1	1	5311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa211xvv5TKPi7ekHTSRvTixTGP4pfwXNtdrHK28U7hahbCfayT
14955	payment	1397	1397	1678	1	1	7382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YJPuWsYdyXUY6JfLK5n7VFZggsxX3Wzu8pjvQNrJCXSPbss7
14916	payment	1726	1726	1874	1	1	5291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4zVD482pepFj6EDtCo52BphBnrEU3bSQXv1jmQvdYCSCCm8Z5
14917	payment	1726	1726	1874	1	1	5292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgzdBtNCTmLGLySEpBQgXGeMP9j7A6SQeTDQuBpcUPxpn2LkA
14918	payment	1726	1726	1874	1	1	5293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1X7qzdASL6bB5m2wSXNztSFbiWKPovDV7mpneA9MEXavRzjV
14928	payment	1397	1397	1678	1	1	7375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtx71iqY6BBMnb1f1oBPS4JyqcdfwUPgYxa818gCjxxuL1nnVn
14929	payment	1726	1726	1874	1	1	5300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8mGPfHeUhAYxKNU5Fg66i97zYm43evBKkmtRtcbr63R23TfG
14930	payment	1726	1726	1874	1	1	5301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcxNtV9b4xPaEgPMANqYukde56k9YHq1JAU9XdY3UGzgNZyKp
14931	payment	1726	1726	1874	1	1	5302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SSwa3BUZVgHQBNYDL2zH776VtYkx6nGsfVBMegHjhAxWNm1k
14944	payment	1397	1397	1678	1	1	7379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR25beYm7zMwiWoCRPL4fhmcPjCFd7hqfLYySDa4V4RuEbBgkN
14945	payment	1397	1397	1678	1	1	7380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoatE1o7cUzXPTHh4mS65NMZTpY1xyuT5PFbK7KqoSPUwum1A
14946	payment	1726	1726	1874	1	1	5312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuxLkDw77UuENRZE8qR1iZGCGrihjuzCstKTUHAmBC9QeEra2
14947	payment	1726	1726	1874	1	1	5313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uKhsGSLsxMQogtDmMbAizPCu6MteH5DDACf8SdPHYYFGfTrC
14948	payment	1726	1726	1874	1	1	5314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hPpd2yjuF5hjugUVQyfEC8nEvDdthc3eUnD2TVMN7DnmV6C8
14949	payment	1726	1726	1874	1	1	5315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TW293AxwpsuBZyfYHhE7izrvqFsjtFu9NRKcDyabsPWN1Sz1
14950	payment	1726	1726	1874	1	1	5316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91yDBUjMKJjWcumZPUNH7YHXVmcRhDwpC9U8XmQttFHBt35ZQ
14951	payment	1726	1726	1874	1	1	5317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpNHhKaSTqxHvy2g1NFmtoWr35iwt4TbabTP2iNExrtG5415M
14971	payment	1397	1397	1678	1	1	7387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHGYmx4e7CwGfckSb4dFceJPnmQy9qePNvwKYMNTY2vs1FkEm
14972	payment	1397	1397	1678	1	1	7388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuurEsHDayr1czfAfR6ZMuHbyVUeTsquVkE6fMNaUCaECAkA9k
14973	payment	1726	1726	1874	1	1	5331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGbRX7Cen93Qe2VBpLoZYrUVe49rnvpohfTmkhZtHzgpvVGQD
14974	payment	1726	1726	1874	1	1	5332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fRMs7A2jv3vrddBNKGp6HBSoaQQJFT4HynxhLoidPCSj1uYi
14975	payment	1726	1726	1874	1	1	5333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3t7rhe5ktsM4MQ2JrtEj9WSJg1usDLfLzdSJjicbPWyuoBiQ6
14976	payment	1726	1726	1874	1	1	5334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYmbxStwLizPEhyHAyKjKKPuftYSSTm4Dbjgu6tt7jyLpQD4U
14977	payment	1726	1726	1874	1	1	5335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENcE8a3WTjT2u6SHMenEYuZHwy3E2bRU5dfBRnYgkofvJUtXp
14985	payment	1397	1397	1678	1	1	7391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKRBnQS6LNRJgS6XCENqZWGb8kdrwxkgcN1r1BbiccWCL6Vdc
14986	payment	1397	1397	1678	1	1	7392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9KqJGrdbRK3FdFCLmhjdgfHQXfDifzR2eGjsT5Qejqvgu1kD
14987	payment	1726	1726	1874	1	1	5341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECX7arh35t6FqS4ThZfSP397jvtge9Wb6trohuYQEm468wpKm
14988	payment	1726	1726	1874	1	1	5342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdhBDuunZXX1mvFKYhL6wi9zpe6xWcwCSt4Fg3wR9RpZZPSv6
14989	payment	1726	1726	1874	1	1	5343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRinSJ8AdMYAVtmCoFXUMXGuXoTGpBbKTgtPmpmLzTwkWgKFss
14990	payment	1726	1726	1874	1	1	5344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9R2Fk5R5xszkLg9jPFkuFNCjh9CEjHxnWMkBnGy7cc3tQij7
15013	payment	1397	1397	1678	1	1	7399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTa6yeRSeVt3cTgUzrbT6uXeNMbSg6yLyMkg9548W4n889AfxF
15014	payment	1397	1397	1678	1	1	7400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcyXAfw5JxiZgLALYNv2T2yEK9PT8g9N9bq9BuVvbjDvqRLdm
15020	payment	1397	1397	1678	1	1	7403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnn6RXqT9CDfXtY6pcdAZjw8Y1zLxNwsVjiGQqzsuaWeXPkS9
15021	payment	1397	1397	1678	1	1	7404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5XgNZy7PtwaaFTn9qmxvwuFvDA9TYEi1igDoDBmFfKcW2Ugd
15022	payment	1726	1726	1874	1	1	5363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJpaZT4PpfDd4GFkpmP7pNEgt9z4rAKkQbKt6By3S9Zg1DXe5
15023	payment	1726	1726	1874	1	1	5364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQjP6XYYvi11mqVEvGxicSje2xnu924YMDxHg8WnNMdcv769B
15024	payment	1726	1726	1874	1	1	5365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNeiHETHMSCtBQBPT8t82BvfBju7wCLPMonD8RgzXNbwPyzkE
15025	payment	1726	1726	1874	1	1	5366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3p7ewgsAetb3SoS2v1EbgKWzuUvshBuG6rmbLw5UuWi2GcrP
15026	payment	1726	1726	1874	1	1	5367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvFP5hXFbpKghxEV7QxBSwECRN7eM3iVTsYEmKSYXUjnsbfB1
15027	payment	1726	1726	1874	1	1	5368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2nm4S168wo6wadVw1u6pRvdp25yBiyHZbUaf62o1VrkyTnQS
14922	payment	1726	1726	1874	1	1	5296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcztTXfExyGstMtFHZhFo935EbBc9jM4FK1J7H8wkt6iDyWE3C
14952	payment	1397	1397	1678	1	1	7381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJoU5dkv8MVohY46MSHtHSx2rabyTMoNRPfoGWjZGeZk9sGQT
14953	payment	1726	1726	1874	1	1	5318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHQmdoEZfMXqpV71SJ3FtTfnFR4Ky7S6pLRKZMcPR61LshVUU
14954	payment	1726	1726	1874	1	1	5319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwVZMNhR1k1Lhw7Mam6VAmkxtimuuHiMVKS96ueiyQnxnUpXL
14979	payment	1397	1397	1678	1	1	7389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgp5g23s6txafM3qxDQiCCX1yJSZJbQQ7eRs6sCKuqPynZvfaj
14980	payment	1397	1397	1678	1	1	7390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjgD9G3eWSYFeEyknfkBZvX5fiucMcmoaPPkXBRW3nw6JPbxG
14981	payment	1726	1726	1874	1	1	5337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sa4CTzRnqWfjuPNUTJzx8LhDWLjnn7SM1GEp8tVR49UNgQRv
14982	payment	1726	1726	1874	1	1	5338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEHKAmnWXVcRRJb5j47VBtXcvfmqicK5zCJ4dq8oGM13HxPQ8
14983	payment	1726	1726	1874	1	1	5339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgS6Xt7Dz4wbFX6YaaVvSuwWWaxiTcemcKaFa49XT3n8U4DF1
14984	payment	1726	1726	1874	1	1	5340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkPh4s7jZyypHG5M3DBrr7suip6t9518Rmu3CenRo8qML8wfZ
14991	payment	1397	1397	1678	1	1	7393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYqnCb7NoBQ4AHWxmEGMbMt6GdaQmMLZVLdR117kKbiimeRbf
15033	payment	1397	1397	1678	1	1	7406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjpYV6DvfHbxQE9YMkVkbyeU4oLHigANjPHBvTCLd4M5ydVXY
15034	payment	1726	1726	1874	1	1	5373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3UufbQuEak4a5Q9G7A95g6avWNXW2D7cgyFRGVKWiMJ8gxiE
15035	payment	1726	1726	1874	1	1	5374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AD7bzcch1jA9h5XCaGbEuQxrxhtNXp6mn4RNq25mehZHPtjy
15059	payment	1397	1397	1678	1	1	7413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBcskXf7WdniZdtNZUqhbx3M2L5rvY9Xid4d4kD7JUvRonsh6
15060	payment	1726	1726	1874	1	1	5390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAKNF3FJMvGkNiHyPAnFV5doMRFLdhej6T927CggZYUVcK8rA
15061	payment	1726	1726	1874	1	1	5391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdStAL6iKbbrgSfPtThPxBQu3Vu4jXASDE2q69Kjod1AKZR3ev
15062	payment	1726	1726	1874	1	1	5392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEuPAAyNoSrrq2n6NStBXoaq4V13cfhx9t3UxUM63MgAg97mqk
15063	payment	1397	1397	1678	1	1	7414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyVkhZaJUgpWgdbLNPxTbQz8CdvLtXdmqHfPBw9652mCcBsqh
15064	payment	1726	1726	1874	1	1	5393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRbiDnVV99LHAsX6w5QkXJ9jRbRKteJZZKZkp8Y88NyT8r3aK
15065	payment	1726	1726	1874	1	1	5394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTb8hbkYwckuF5QXiZpqGkX8UMKNdcAfxzs3nom7y4P3i1hmMK
15066	payment	1397	1397	1678	1	1	7415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrCKyFXabnVyc4G2Lw57VtgAFVxGUHNt9WHAZ5AaMgecXCskF
15067	payment	1397	1397	1678	1	1	7416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRVPbodNwZnoG9KqjLJUn5wL6DKYwUbGrkJE68vAS2Z1xdGri
15068	payment	1397	1397	1678	1	1	7417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWZDKAbezzbvVt4c5nEudr8eARtG5wqkfCBNuAxYZkGLMEQ9y
15069	payment	1726	1726	1874	1	1	5395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmnxrm2DvA4irRipKJ65FS8mB4Rdf5yb4Uqx4BZYHfGRCMM4G
15070	payment	1726	1726	1874	1	1	5396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsWCNeVEpPcHbWX73j7PzyypEm4JVYErTpJWJThaAXY8UZpkE
15071	payment	1726	1726	1874	1	1	5397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyLEwzbtbrcGDhsLHuAA188QWkaLhjokSRHXzUjEwCYf894Aq
15072	payment	1726	1726	1874	1	1	5398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcDjHezivEaL98XxwZLdJLMGpiUK8AAm69bxJ3AHqkwJpY3R7
15073	payment	1726	1726	1874	1	1	5399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbkQPkk1HBUiFJ5QZwKnsgLdmQGKxYASFZ6MjaRkVnB1H3Gms
15074	payment	1726	1726	1874	1	1	5400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCtTTZus6TXVYSJLnEHED11c4hoy6Lna5HhoR5WBBLxrJjj8S
15075	payment	1726	1726	1874	1	1	5401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMLG7NS7ugSWizY9VJuH4C6gAaCnyg7tw64FFBjzjr7WiSh6r
15076	payment	1726	1726	1874	1	1	5402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcAn6cNL4Q1TrnqjoExS8yGtRMTXHHDN8vKvN5DB4Eb64jLPS
15077	payment	1726	1726	1874	1	1	5403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoMurqfCNqBAn1V5Buj5WKSh9Q1U6MB5KjBzzBt3jxvsrD415
15087	payment	1726	1726	1874	1	1	5410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2QYrsqrjGbyqdeDgnC5fzrMCPqa1guPRTpBEbTp62Ef5Vs6W
15088	payment	1726	1726	1874	1	1	5411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYata4iPXo2txzx86gALUweiVtf8o2J2Kn2cXEVF48CdtswPGsH
15089	payment	1726	1726	1874	1	1	5412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKeAKPi6sHE3LYcNDdtV8wNFcLmDGkJ5hUvgYh5qpEZ2mTjww
15112	payment	1397	1397	1678	1	1	7427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1wLn9DXuh3252WbAB33GvnN5sqhN2vKbCRviisdS9XNsYoEo
15113	payment	1726	1726	1874	1	1	5429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4FgeA4WBg2Xr4gvhQyskqrhoszo8xEDuX5s2kRgSeiHZhg7F
14956	payment	1726	1726	1874	1	1	5320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQugegkvL1mnA8v7iZLx6W5xjUU4MK73pkHVo7MDAQx7nGq4B
14957	payment	1726	1726	1874	1	1	5321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd134vHhZFHjDzFkomLF3xwCDqA7NAMjiuqs9xSpJv6UzG5Mkg
14964	payment	1397	1397	1678	1	1	7385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapWvqmmceLmooZ2r6XTvjP8RnWwGotCrVHJmETBuT7qzWaDv1
14965	payment	1397	1397	1678	1	1	7386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXnWUvt6nDRgk9x1crGnYvMTAnU1vw9hD4GMXaJyRrEoMMmQa
14966	payment	1726	1726	1874	1	1	5326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLg6nxFcxVak7yzbnQ8vx8dj5mY9GZNYMFQmHHRCUYvRztbEUL
14967	payment	1726	1726	1874	1	1	5327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLUegxmGJDAHDvX7MLShdkqcvMu3CffnhEscaA4dMMhvh9SQi
14968	payment	1726	1726	1874	1	1	5328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDz8vtmVSrjA1AZtRXYmnnhAFGAkzFwSGa9RavpxwatcMEeJYy
14969	payment	1726	1726	1874	1	1	5329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxKkfzeduq7xF9h5TwyV5bTbeWt8h8zqwyXjDoBBBQWn1ndzWe
14970	payment	1726	1726	1874	1	1	5330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfSguyskkr3nauA8jJNPurnwsHHhJb4gpPhvp3FBfTwhZUYMw
15007	payment	1397	1397	1678	1	1	7397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbBPrCef2C46H34eiEKmTZhsa8eBzdjpFfQvZuTrGjs9oU1uv
15008	payment	1397	1397	1678	1	1	7398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nHu2xkkJd5GXDY9bCDc3LXWj93uSuMvEMnXNPhLc1uaa23SP
15009	payment	1726	1726	1874	1	1	5356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9FG4Soa2XMSkTQmatZ4T1Nh7r46dfNG6kVBPPsBu1Etj9Bkj
15010	payment	1726	1726	1874	1	1	5357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMikc2J4z9RemKU5k6uZM59jYSDRAFtN6CNqDS3BCpBDzGsw3z
15011	payment	1726	1726	1874	1	1	5358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskFAv1NyYcY9maHFFacTeS8oWH6GaVZxWDnQ7DYctoePtish3
15012	payment	1726	1726	1874	1	1	5359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4Cg6TNPmXCFhmyKLxkKzRog1nETweSkV63UfDLxPs6jbu79V
15018	payment	1397	1397	1678	1	1	7401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMCwebYejchHoLdvkGDcSmoQKhhtXUUpaUm6L4qaDNtNXniBv
15019	payment	1397	1397	1678	1	1	7402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YvhaLTsQhu4uucPUUFfyMafXfzzPTtLmcwSUeYAxXBDXD2v2
15030	payment	1397	1397	1678	1	1	7405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLcfgEo34KWyc1M8U11XYQndCLciWwADbyThmySxt1A6kWVdUV
15031	payment	1726	1726	1874	1	1	5371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchPa94omPJMvr23rakgaSrxXJCSGiREnsRk6qoatHnRnMs5XJ
15032	payment	1726	1726	1874	1	1	5372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1AHN3NdZMVTfrCJR6ggWkuncuM2k5DfXtaSQ74hw3kCLe4HD
15042	payment	1397	1397	1678	1	1	7409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8GQZPhMeVCQeotAAohWwaC8sFrRJipwoHMcTSckFH9Em7VpN
15043	payment	1397	1397	1678	1	1	7410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93aDxagxMVuQanjJBP9LxdJBnfs4Ke3AeT5AkGmY3NCWywPVj
15044	delegation	1926	1926	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDr2mrYpnN5yKFk2nvV8bPnygQrNCW5sDF2fHX7beHgDfjG9di
15078	payment	1397	1397	1678	1	1	7418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXuDChFTADUg7Xf33XisNYcTENqaemkDxkef8UHJ2AZyQPiim
15079	payment	1726	1726	1874	1	1	5404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxjxyNuFDbEeBiCA51KPooheLJdgrFzh7FTzKwhCLTzp2cpd1
15080	payment	1726	1726	1874	1	1	5405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnYEKe8xe6McamvMCbhNrbrfMBZ9ykHGw1cVHhrzKtuVCuGuY
15081	payment	1726	1726	1874	1	1	5406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbAKNys6czJE5kXGsETUeMVjz8tMXdiB693A3dcTkAVuvHZeN
15090	payment	1397	1397	1678	1	1	7421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXgY9mZPDsesBQ2wvwbUGv3DzMa8ua3Ei1dRunuKd4tWW3ooN
15091	payment	1397	1397	1678	1	1	7422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsYY28LEcmQ5DJSyoF6Uu9idy9mDapFi2CAR6ZjNY4Ldggupg
15092	payment	1397	1397	1678	1	1	7423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcsKFEsiZRFUwXKftzdiwxF4DRK88HVHUijb7JPFeLV3gr32a
15093	payment	1397	1397	1678	1	1	7424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSTycfWDmkqtnfoy6ubVCsrZUY8a74hENfkqvmhs7aiW2MLfW
15094	payment	1726	1726	1874	1	1	5413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrKDVqkbdgYXH37GfE7HtjFjgSKbVbfUP3eXQDAvDz1P74FVS
15095	payment	1726	1726	1874	1	1	5414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3VTPwGHyEjZrXRpGT3EX4ewmSgKVzLCZ3tSR4FSaoQfXjvZd
15096	payment	1726	1726	1874	1	1	5415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7VK9VpipogLiMoAgDJ9NxrketdTPWzQSTPXVALRwucLQfiA6
15097	payment	1726	1726	1874	1	1	5416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNyQahWi7iLTzx1zSuHQPT46NDZumU5qssdWdeJMSVBAc6ZfQ
15098	payment	1726	1726	1874	1	1	5417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4gWvszTsoRPZcycsWmkCKYAJzQ8TA47LTgePdL8PyvP9mmQ6
15099	payment	1726	1726	1874	1	1	5418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNUDRQNXgSCVAEBK8GervrsHtYM9sdjnzbgLhKkcqMvc8Svex
15100	payment	1726	1726	1874	1	1	5419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3MiLPi6LYRcvWFwpUBbaJtiWAkZr4qixfRyXennbGYZ2zf8M
14999	payment	1726	1726	1874	1	1	5350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLRRKXv2s2iy68vy19hXaD6UU6FjUg3aJewkHs2xnGPsbhbsd
15000	payment	1726	1726	1874	1	1	5351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wjEv9deHY9VqyegDE5Kwef5e6KeyQ6aufTDVyaXs7gnPYB8M
15001	payment	1726	1726	1874	1	1	5352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwfUfcxCackjejsEQHvc1YS32qPHZss5inJCaxxnJtEYkxZEu
15002	payment	1569	1569	485	1	1	1	721000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixUeFGvaJ4ypkzwQMVoTpByKbMLDSfU7G7qWeBP1HigzzMnt8
15003	payment	1397	1397	1678	1	1	7396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwtqF9m8SVhyiHUNpShaHvzyRZboKxJcUZy9enhwWW93VtjEo
15004	payment	1726	1726	1874	1	1	5353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2mAthM8Kjp8VUHXJUtGsxzhrJq3kHXw2SrdGCwbqWqbmNzbB
15005	payment	1726	1726	1874	1	1	5354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5M9UBZeGsjGbHtAEaLBZi7rNYXo3TyHhKTJYHZdG1FCsK4svG
15006	payment	1726	1726	1874	1	1	5355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDJjEUUM5Y6gKQS79Bky6iTZyhb4AnKTVork64xPaN9Z1sbP1
15015	payment	1726	1726	1874	1	1	5360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasfvNHyBbsf7Xkid17tvXieVa6ZUQnZRvnad5DbYBszxP77pF
15016	payment	1726	1726	1874	1	1	5361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDK9GcSBeQZ8TuyMziruWrtZ1d5APSbZDb87Dhaeb7o5yK3JT
15017	payment	1726	1726	1874	1	1	5362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZyH4KoWHbfmda9BTbS6SS46aLAH98gCfvMyfx9ha8iTUGXx7
15036	payment	1397	1397	1678	1	1	7407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VdAZtie9q3p72VUb3FacchtzQcjRdMok3S4tYSqPDoeMG2dp
15037	payment	1397	1397	1678	1	1	7408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTQjKK9jLwirmqAr6cehqNfjmAmdxsmB8tEAdHzS9z9xqRyiq
15038	delegation	1750	1750	1745	1	1	31	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopboChuv9Dh7pkDSE9QfVW2rc7fQCx6dtMPVBLY8FtSNEVo9S
15039	payment	1726	1726	1874	1	1	5375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3vQ6fhx8AUQVkdfm4WN9kWX16F29MJnG796kdT1uBpRzZFVY
15040	payment	1726	1726	1874	1	1	5376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6Xn72wN6rGorGW6MGM2antmayz7bs2T4EBw3HLxUHkdmyFk9
15041	payment	1726	1726	1874	1	1	5377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTped4AqggLX3SPpWJ8LJ33z4C6jCt6Rz16fs23KK7i3PNUMYi
15055	payment	1397	1397	1678	1	1	7412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCDqT3av3fgjoWrTuxgBB2uZpFZAe1YTBXrEvTLGG76UEXbtt
15056	payment	1726	1726	1874	1	1	5387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2tzsMhZBWmg8Uy4VDs6cwGnsNJ29uym1hMxbTJ8KrqsMFU3W
15057	payment	1726	1726	1874	1	1	5388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBc6fZDnWE1KXcs5oJKLymFstoZ4AJqxbxx8JCSW4kb9sHrMGj
15058	payment	1726	1726	1874	1	1	5389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjZDKQoR4vj2mZPmPcxZ3j5WMEtaZyQapXsUaFKjNxzJkRYie
15106	payment	1397	1397	1678	1	1	7426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvKNpktYtbn6FPFkVnHVqQT6yNheXYwy3uAocHk7tCsArRSKts
15107	payment	1726	1726	1874	1	1	5424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECERnquPMpJSSnRM2x2cAJYeNNsY6BpWLKuuAFC4gvAq45WtB
15108	payment	1726	1726	1874	1	1	5425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdimFFStfqgnDCG8PA316eER58Gvk5J63c1k7CnNRhzp2TsL2
15109	payment	1726	1726	1874	1	1	5426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6kPY6Awhzf5T8xp2kRuSFpH6qSrwMMLEDVSXnnW6GPXcg6pb
15110	payment	1726	1726	1874	1	1	5427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqkkf1oYuRZLzLy1XYS3MZcwi51r4pU5NnCCmdaBLXJbyuJSy
15111	payment	1726	1726	1874	1	1	5428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYiDRcrL1WDfy5ZREq7px2bqJ8NACdMgZiNr9LHMKQLAUfiMgn
15120	payment	1397	1397	1678	1	1	7429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPbsx6bjLrqR95PfHFLzPduzwaziWFep6AqYab12G2RwtnKQX
15121	payment	1726	1726	1874	1	1	5435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6DTL6KKVeBhp89q7SE7DbhZUiqxfdbCNHN5ZY97rd8q4dbWf
15122	payment	1726	1726	1874	1	1	5436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbzcGerie86HFiVqBbXBEWbjphENmRg7q3VQ5XRFouAtWoDTR
15123	payment	1726	1726	1874	1	1	5437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3j27cnnDtdMjFFUPDBcvb1sWhyxDGA2JXHBTnhqpvEkySqDjn
15127	payment	1397	1397	1678	1	1	7431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJFD5qqNRUBUYGq3F2WRSqha4Hpk6GzaTTpPzbidNnAZ3hRyy
15128	payment	1397	1397	1678	1	1	7432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPFfLe89mjDMvDC7qeNKW9dT2iAhxFiAqnQqFEurqHr7dtFxm
15129	payment	1726	1726	1874	1	1	5440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAztgyurrCN77MjkBepNJsmkAvtGPjrnWxUDCPEEyyMSoCdp8
15130	payment	1726	1726	1874	1	1	5441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5JgT1U71cP54heynSRfUM6HaKiEUTd2QYtPGtXMxRfCwrPcs
15131	payment	1726	1726	1874	1	1	5442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVx3EcJVmfP49HsTKJPEijKSr8mwLsDF7JYPwwctq79PioFMm
15132	payment	1726	1726	1874	1	1	5443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybM8r1VN9zo4Zu7Whvu6tx271wdgYjLaxrW8qFwYQL6twAHa4
15133	payment	1726	1726	1874	1	1	5444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdMtrkFdAiz4oEyGMUDiwLRm4mLxSWNUcvevTjHJhgrEnBu42
15028	payment	1726	1726	1874	1	1	5369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavfMa5wEFCq62hCxJ6g73C24uMx3oJGDPWUH5ybsUt3jeitEH
15029	payment	1726	1726	1874	1	1	5370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EvBmGDYFxbVrLABBWkbPq6wRAEAGdgRserG4RsEA9BauTwmb
15045	payment	1726	1726	1874	1	1	5378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Co1ov1UAsh5UgA2MFDF285a2SRFYoz5Bfy7hrAUmoNpXZse2
15046	payment	1726	1726	1874	1	1	5379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMZKc47YgVUnULzG87TmXFbcS3Juq6oDxBQknZJQkzPBAdR8g
15047	payment	1726	1726	1874	1	1	5380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJk7yDjUerDEP9nAh2etEXstz6LrDEND4LJtvPVKc4hJCgpkwq
15048	payment	1726	1726	1874	1	1	5381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpgxoUSceukuAhY6w2sAf5N2gdNWDNjHCbtn6TfeKpDsXSWMa
15049	payment	1726	1726	1874	1	1	5382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHDsv4qaB5oPGJAsLvwZpZ7biMxEbPdWh1cSnQXjN4nZkxuNz
15050	payment	1726	1726	1874	1	1	5383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbgGHhbp1dCr2VwqwAoFdFQkutVoAAA5JWQGJxEeoDnLQwFh6
15051	payment	1397	1397	1678	1	1	7411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvmBRLGF4gtuUzd1bJqBo8pkyY5gR2jVU5AGe6WVQd5Zka4Bf
15052	payment	1726	1726	1874	1	1	5384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6TC3feBob8BkZfBa2F9pjy3HED4oYeiHA1aL9mY11w8e7yBX
15053	payment	1726	1726	1874	1	1	5385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uj3WXQiHTxhQVbUzA76wNWepKArd58G87BkxnPrMsxBfdqyP
15054	payment	1726	1726	1874	1	1	5386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwJZ1ZbF37S4EntbTVYNmBye7BdzYro1xbhvn9S5oBvebLkB9
15082	payment	1397	1397	1678	1	1	7419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN23t6AoKAmA1gDpwRp8dKJ2Wh86jWXvtz3JZ6UVrezCZhFJvu
15083	payment	1726	1726	1874	1	1	5407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zPVGdkicusAbLa92x2D59mCfCtrpreUL57t3H9fc874ULPmp
15084	payment	1726	1726	1874	1	1	5408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSxkGgKzu7UuEPfAuUPdTN4R66XUh1x8xZrwG4jeAGB79aVKi
15085	payment	1726	1726	1874	1	1	5409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5uhQVnA5iYoGT6crQSsip692s2Ufug9pviijrtGx8tUnrE1e
15086	payment	1397	1397	1678	1	1	7420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FZD6PxDzVnG3NpP6ugq7EVVGii4DHfoXzUeh47saaaDNWmox
15105	payment	1397	1397	1678	1	1	7425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3D7v4Qp3zBUTZLRecmwdgM7iKNnE33PzCGMLSGbU3Di4J5Z2i
15116	payment	1726	1726	1874	1	1	5432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLre3VpMQ17Bn1cGguWJN1MtM72aj3ywBZNkke2vZF6McdDHB6
15117	payment	1726	1726	1874	1	1	5433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5ozGegz6U2gLRzAW17BPe3k5DADdPGwNqZX6dMqaCh8UXJLZ
15118	payment	1726	1726	1874	1	1	5434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDk2kyRH44pKGXzJM2DcC8HnxEkqNwiH9mekMoQfeSSaFnJgT
15124	payment	1397	1397	1678	1	1	7430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSuQcvDHYhcdF4TstTrueFWNFL5BGYQwVbrxnxRMmCY6p8ifS
15125	payment	1726	1726	1874	1	1	5438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XXx5sbfuDCns2SYiDffqGQ2bHu8DqbWGhCi5y5Yemjdy9PKb
15126	payment	1726	1726	1874	1	1	5439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4EYX9ZWUNL8jN7xEsaJVBAe3xHFyJAZcx76P3hpbVBshEkAE
15135	payment	1397	1397	1678	1	1	7433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEE4z4aYeDWPrzaQntUgQCNysRKt7M5nuKG2FUPiAwURy4xXd
15136	payment	1726	1726	1874	1	1	5446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaFssj4wFJtjod4WcgbVaSQA6D1ND8jmB7EqzRD9wxTaqYmKr
15137	payment	1726	1726	1874	1	1	5447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfBMXwqJkRs1hT98qfv9bpCeGB2SnviQ7mrAw7K3ovfcUMrfE
15198	payment	1397	1397	1678	1	1	7453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiGKV8C9PsVmNrrVcch23n6pkjEkx6LdYopSQHBRtJyxrqLko
15199	payment	1397	1397	1678	1	1	7454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7m3E2ywHhVxgTCcVyFvN1o2P4pJahnertd7CpnWkFxQNwaUZM
15200	payment	1397	1397	1678	1	1	7455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtsKiv53xDUFJHPNoLkZoQzYL7boT6ApQfrwmcDE25JFyfAvc
15201	payment	1726	1726	1874	1	1	5488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstiGcqGA2D4i9eSNrzy7kovC5Bas5nU6LQWZLL41NtTDyRKri
15202	payment	1726	1726	1874	1	1	5489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4K4ffVyqRbcjLGvrrMg76XNH2yQRj98utmAvsP8HzEcN4fRc
15203	payment	1726	1726	1874	1	1	5490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmg2GFUBGQuqmTDDY9TD9BYYfK36ix3WEiuH48iCLNWw3YLPds
15204	payment	1726	1726	1874	1	1	5491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxw4sM5ix658Mo1uCrpnUbnbdjXbprvWoctUoV8T3n8BFNVbUo
15205	payment	1726	1726	1874	1	1	5492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2gTYkRVMfSXmGxzaRBLsZLnjS964b49yvjbvV4fhjgwsKT3j7
15206	payment	1726	1726	1874	1	1	5493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eivat2mGjFQDc9TjoSBqUGNLQ2FBgC6cH6rxSEAFCQF9CH2J
15207	payment	1726	1726	2093	1	1	5494	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdvHFUS5oRs55MgGqQbmrLTDRnZwJu6ELf6SP8gbpG4i4XQBBZ
15208	payment	1726	1726	2094	1	1	5495	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWMHzXRgHXAACG8LPKvZcMkw3fnoZJTuSa1cdjyjGasEGQZ8MZ
15101	payment	1726	1726	1874	1	1	5420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjCBBttZY2UdA7U91C9BhcaEBoHcZU1W7X3ryMWkJCFX1XLrC
15102	payment	1726	1726	1874	1	1	5421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqTLwSrv6XuDS6J8R5ssrF5Nk5yhf3aC15ahTCJ7SBhAYeysy
15103	payment	1726	1726	1874	1	1	5422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgv3vjc98fSrurGwyQU8LupgwYnS3r57MdepfjTyJMeL5Yray
15104	payment	1726	1726	1874	1	1	5423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27EUZGB9yvHfhFDdEnoGgYDPfVbfdUuUnVDanTNH2eWdm5bu5
15147	payment	1397	1397	1678	1	1	7437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2qhfn6hhUzpLxDoFjJfMvfZAaZ4ti6C41y7ra9yBjyXxLEL3
15148	payment	1726	1726	1874	1	1	5454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyPCAbUJMwVrUybT59YGVSkvKHBVdcnc79S8H6vxLT83gLAJf
15149	payment	1726	1726	1874	1	1	5455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdx1Bsopcd9MVLKYbXjY15iSd8cKUu3a3BARZodkEYYZ5zVjGk
15157	payment	1397	1397	1678	1	1	7440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebnewopjgF4iLE3i7ZcePVRxzgBsmMY4PSE97SeukU7hLeK6r
15158	payment	1726	1726	1874	1	1	5461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBc5ByrKLxhQr9oBSPkUhMnnxoKWLpAw5CKAet64BwT5MdxPhi
15159	payment	1726	1726	1874	1	1	5462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkF3tud1aFgs8vTUBu2xe2cxd1Sixbi69DCfd3YSFeaaYv81d7
15160	payment	1726	1726	1874	1	1	5463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4uHjxKUHvXrAmwcxhpDVwBDFgwoHMrd87nHnN5GRr8rXgMDd
15161	payment	1397	1397	1678	1	1	7441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBoCZdPni68JkTvkeuqDXU2T78gyGMcWUzr87MSzvtSVHZW8q
15162	payment	1726	1726	1874	1	1	5464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RNt82r2E4ckBWwaq2gYY9MrruQnFxgoZ4hjH3sGr8MAxuLEp
15163	payment	1726	1726	1874	1	1	5465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYToVqVjstzW1xmn3ihQQiqVKRWuCcUx3eRXYVsVr3CmHdzN4T3
15164	payment	1726	1726	1874	1	1	5466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUyETYr5DFrw4ViesN4v6nMrc8gn48ieaLwPcjhrBnEn88eAj
15180	payment	1397	1397	1678	1	1	7447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5kFxSLq1HXKMXYiNKzHxdkJh9S1UW8qWWw9Cv1nkHkigt4aK
15181	payment	1397	1397	1678	1	1	7448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVvPTmzZsAyz5tEu2B5TEQkaRXiH1q7oDA3DnroQN7Z3Dff87
15182	payment	1397	1397	1678	1	1	7449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4q7kdtnbRYw4nSguat7bBWBYAcoAFiLnFS4dNj3fuYqRoyxc
15183	payment	1726	1726	1874	1	1	5476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7ZAYWWb2fxBA5mGPgM9G1mMg3ooMUfhsfAVDHXhYu2pMFLtv
15184	payment	1726	1726	1874	1	1	5477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgjtGJZQq9K41kL8drr3y9xJbMFF9mLjwGpgEpsw4ysWhtmgg
15185	payment	1726	1726	1874	1	1	5478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme7HcLuNgtgYJCy6VYSwHZCwM51pdoyqzD8xeLRybsNopC76N
15186	payment	1726	1726	1874	1	1	5479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf7a2AoYSWD5FMFgC8Qbxi9swuJYCVARfAkFciTrNSneMwr84
15187	payment	1726	1726	1874	1	1	5480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfQvnWrujCGikkHEYpicTg5wVwbQaL9TciuCEZUUurkeUD61m
15188	payment	1726	1726	1874	1	1	5481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxMrWr5KK94tuf2afe8dGicpV1FBbs751sq77koJgErTjWAoG
15189	payment	1397	1397	1678	1	1	7450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCSETb2JxStEwo5D8zCNSLyz5LT6Kf67aunSwvQGG3kHTaz1Q
15190	payment	1397	1397	1678	1	1	7451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVY6DfPkibPbYcs6PEwsMKzgpr55LeY1NZD2Mztu7T4R4J2az
15191	payment	1397	1397	1678	1	1	7452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fGNVfhoY7voaB1RdJT11T9X7ibYjcNdMqgJayi8eVNVk8e1g
15192	payment	1726	1726	1874	1	1	5482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzj33RhvocmGVjp1QmdHGyEvZv96S2FzA36zGy1nD3xKyqtii
15193	payment	1726	1726	1874	1	1	5483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwbaBBfw4Rna5bSDDDeLiPmD31BHHu6dDddtQycWGDjjun6kr
15194	payment	1726	1726	1874	1	1	5484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryuX5vofNJvpGWcJJobjAbfXL6Vt3SYJa3tzkgXGcbyZBsDDY
15195	payment	1726	1726	1874	1	1	5485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXDDXxbGBTdBiHhG6DJ6MGggEbGiZxpMKPSHunbGG2SMhUJz1
15196	payment	1726	1726	1874	1	1	5486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7xHyGaJGHuxR2nf2yFkqjLnpf4WNKBXs4cyTmFN9fyoUkE1M
15197	payment	1726	1726	1874	1	1	5487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNPcPVZKLWKfGxkvPCfFLdz1WMgZkuUfSzCM9REv6C8Qivmon
15219	payment	1397	1397	1678	1	1	7459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFf7BzC6DB8F7jGdhCfm6ZgPVbcPK5zVKEz9NCnE2KMowZwhdj
15220	payment	1397	1397	1678	1	1	7460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsxoADqwjK7nuSTmQW4dXBjyhNcPRcUdZuXnXPDAhWGS5nDYTf
15221	payment	1397	1397	1678	1	1	7461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8SxRxQrdM6nUHYsB9ArDgqNWkJkfnjyEwoqrLazskVjPPmxH
15222	payment	1726	1726	1874	1	1	5502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbJvLwtxk98tvCikAn45u1JkT55zG9z9HuNy6oaAr8gRZKLF1
15223	payment	1726	1726	1874	1	1	5503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXk9RWthYpESFCoYkrfds8gGjqhNBHkpkSdkqLicWeoG7RL2GV
15114	payment	1726	1726	1874	1	1	5430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVzBhmHm4oGQCziQvaUD84Rvv4uJU21wBUfNkryPtWFqhNRWD
15115	payment	1726	1726	1874	1	1	5431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNguDMZVvGFxm3EB197wMKNqcoA9PtpFCYfGyJjvTtvCWwMay
15119	payment	1397	1397	1678	1	1	7428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cScWhKeKEinr732MMLaF8j3Y115x4T4qiS16wd7ysQ3CaTkK
15138	payment	1397	1397	1678	1	1	7434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ctPtJw3PA7oFteLz1QErjoL5FDWpmsqMyPRBGubV28KMiH7U
15139	payment	1726	1726	1874	1	1	5448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZWuNGMMQe6aQJAHRsSdHpNEf4eTatZLdhXPncKRCNZtrR24a
15140	payment	1726	1726	1874	1	1	5449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSi5n7KxNmvgSsXUrkvhmKUN5pYDYu6ER2wwkNzDTVBgS97yoE
15141	payment	1397	1397	1678	1	1	7435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4QswSh2i2dbA2PaeNWv7cmfazFEuJkbp8NaQFu2eNZNcZ6Jp
15142	payment	1726	1726	1874	1	1	5450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxq6FKAuYhpk4ffp77JESkwhVZKbTwJ4jPuTfCt2avsAXamTwK
15143	payment	1726	1726	1874	1	1	5451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXcNmNHuYzkAh1pyieW1W98fGSuEvHkxMGKLs6vsunGcywQ8Z
15209	payment	1397	1397	1678	1	1	7456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvaV2sjodnwEQRP7cXK2WKqXQg7p7sza9EQFST8EjTjtgB694
15210	payment	1397	1397	1678	1	1	7457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa688agSocy96QVQw8hudSLmmQ6tvVEFkGFggBU2Jv7bk8rR6cb
15211	payment	1726	1726	1874	1	1	5496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeJ96JMq7kwq82Usghg6qHLLML9HsyqMGv76J71CNZhuWPgAW
15212	payment	1726	1726	1874	1	1	5497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RjXdHL1ea5Mk9ZDXd9UYrmbBptP8yeWHJRPitxXP6t4TcFMv
15213	payment	1726	1726	1874	1	1	5498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1pHviGDGnZazLwsrsjMGg1h7c88NsvSHnYCFA66K5tApUoRh3
15214	payment	1726	1726	1874	1	1	5499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2dscSh4vZSe5b7aTbh5nXKNHZYKdpGzGSGD7BF5nyKGNvnq8
15217	payment	1726	1726	1874	1	1	5500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvREn2DXeUdL9TJTfCVJ4pm3Pq8BmNesewnoR6e58wfFV8WU2q
15218	payment	1726	1726	1874	1	1	5501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2e9Mbe9Vka2UzKRMoC3YeDQZ4gGRnmzwWzvKxL3itFFQiyMC
15233	payment	1726	1726	1874	1	1	5511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEhDtLHdotNgBcJ9vXTLicWhHgPZcizJc2DTfmkFEhnVETznj
15234	payment	1726	1726	2095	1	1	5512	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSMZSkme49bAT9q1hpMSPh9c2rfqawhKBEBFSk3iBcfYpQVnix
15235	payment	1397	1397	1678	1	1	7464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcT8PBbQSrsJqyTxNxW2KbVzV9zPi7svq67GCUXow6cGHzBxYX
15236	payment	1726	1726	1874	1	1	5513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2mWLQUAhncbcgPdgHkK2qjSFEnk13q8QeQiGcRk5x5wPzLXe
15237	payment	1726	1726	1874	1	1	5514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSZZm3gkt2FjWF1xyPg3QvqprgbhBNA5oZBPxHoptr6w23r67
15272	payment	1397	1397	1678	1	1	7476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKWndidu3k2BgwtjusxyH2JNnZDNNVPVKdwnpwbgwt29GJgHk
15273	payment	1726	1726	1874	1	1	5538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn8MZbnzCq7nic8zeMtNMyF3dTLPCHtn1S9H1Qde551pXadLF
15274	payment	1726	1726	1874	1	1	5539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Yb1T965bg27JuNGkiwoX2fvAVc9q52jZnMMAW55orHaWwBRC
15275	delegation	2077	2077	1653	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Vor3UyMabKPkG9pi9PNxmixQA1fLuvq1qa9NDmgAY9ixNJ9v
15287	payment	1397	1397	1678	1	1	7480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczCtt6zaeJVxDZyUEu3b71rKvYNJU8uMuVdS2u4ejjarr7Z5f
15288	payment	1397	1397	1678	1	1	7481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVc9mEVM23vu6wHM9uB3UaRW6vKyjougJVTQ1T7sYi64iXpMUu
15289	payment	1726	1726	1874	1	1	5547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53zU7iYQtN61FhHYX393TxFbCJG1kR77idk8rm5dDZQtYEN5Y
15290	payment	1726	1726	1874	1	1	5548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyFX8wGbNki9Xk4uCV2DNB6b8TXMDzVVt6U9HjueoPczog3gm
15291	payment	1726	1726	1874	1	1	5549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6w9UPELaYHvxJ7VTmaQgH7sotzpuiNVzDJcT2hr6cLy7pWSX1
15292	payment	1726	1726	1874	1	1	5550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVtqxa8AqU6T1dcjvZE3Ada8V5EYgGA1mVq28qGpCSzmb5ajx
15297	payment	1397	1397	1678	1	1	7483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MjF16bahvGUjMtFQJgWQR1NGvySgtvDzL2i5x7P64qNV9RWu
15298	payment	1726	1726	1874	1	1	5554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNLf199QBmNmnBBFFsJi8RNYRc4v8KrTFzr2LduFbBJxwLMJB
15299	payment	1726	1726	1874	1	1	5555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVXySiNrtTqidm5KQBYLfWkCTSemq69tWLrAVXGbK5EK23urU
15309	payment	1397	1397	1678	1	1	7487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy82ZaQqDx5DFyLB3CCefCdQciUAiVMJie8jkekwqg2WhKuodr
15310	payment	1726	1726	1874	1	1	5562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEcuTyj59nfZDFPQMd9FA8KU2CRhgi1svXjCRVXzMZEv4MAdX
15311	payment	1726	1726	1874	1	1	5563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7y6C3bnwzFttf15ERbs94htmbVPxDop9D3GXCzUw7xkghf4VL
15134	payment	1726	1726	1874	1	1	5445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZai5oUk6JriAGLFjHvrE9CWVFjMgvm7KKDw2MTwxCaVKZmbTSz
15144	payment	1397	1397	1678	1	1	7436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAT6Ev2qfHnKE4do2ismfqXsqpziz54hVDRMxtykETdfmnvaw
15145	payment	1726	1726	1874	1	1	5452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTnuE2d6RJ6ZYfqWopuy13kicX1w23mffV8g1AUwqSxPhvXor
15146	payment	1726	1726	1874	1	1	5453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZct99rsa3KSsLYoRfBXJhFqKjrz38nDHm2DtMoDGMBLsTErouQ
15150	payment	1397	1397	1678	1	1	7438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wL3QnVvFxMf6hP1mtpWDpBNnkTqPn7pJFHNJJ5s47jcdUSNS
15151	payment	1397	1397	1678	1	1	7439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUhWySozzfQK9DDMw47GGmkMinpU7pw727ZMkmv6H2TgaQHxL
15152	payment	1726	1726	1874	1	1	5456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFvffzksYHf6xvGyJzZ3d9HUTgabUDRBCfkrw2J2Uwm9py5Lu
15153	payment	1726	1726	1874	1	1	5457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqcB2AP489SyhVgQVwFL79ge5ihdxn9Ku7Vryd9vK6bzDrKQe5
15154	payment	1726	1726	1874	1	1	5458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmKJAb2gskVufVGZB1YFhowU2S3iHoM1BWxhNRYMPjHD62vRN
15155	payment	1726	1726	1874	1	1	5459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVpBR2cRiE3r9hFb7UvrbQZGRYU31i6UFnG4fRqiVvHcSoFMW
15156	payment	1726	1726	1874	1	1	5460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1e9EjaX5gu67j9ZGJesKRPFxi1xBr4Go3GudsCFAcCXQ4uat
15165	payment	1397	1397	1678	1	1	7442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqRkrR2CMuKhykCdZwqxAStgyAK2N7y4RRK4n99LskKGDRt5R
15166	payment	1397	1397	1678	1	1	7443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEVsUHXDWbMT38FUj7VSf5WrCDvHhzYNfE7zg5DjjbDULXS9q
15167	payment	1397	1397	1678	1	1	7444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNh6uUGMgJAFS3DyPZ2zFBhrUpNij8qXVCgZ1VUMmc2d9guh7
15168	payment	1397	1397	1678	1	1	7445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxUtkFppFiniE3U8grEm7mvjijsf2gTXCAbcbCGYjDhNGqzmu
15169	payment	1397	1397	1678	1	1	7446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPSFMBDq6NhazjiLcoARpUusJJZHCH3xKYztj8JjDeEc2zsBD
15170	payment	1653	1653	2077	1	1	2	1436000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bobaRduZNjR9cEJ1KthKaevaeRRcydMveQF3DMuXFZShSGxb
15171	payment	1726	1726	1874	1	1	5467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6QicJvKbwLGvXTHXUNG2XKTUbEBvqYsmq8uQVEApTmAK9LsPe
15172	payment	1726	1726	1874	1	1	5468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAVx8Rbmu31y1xCuiXuF2m8t4i3dWbbUfituW9XqgyjoQyRcZ
15173	payment	1726	1726	1874	1	1	5469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCostrMUtbo7GWmb2wTova4PvNdt8VmnqYbMC81EV3HE3p4K4D
15174	payment	1726	1726	1874	1	1	5470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdVPi6tLY4rFyPbL3rkfWFGFM6xG8BdU1Hz8VxJ83DVE4ekA6
15175	payment	1726	1726	1874	1	1	5471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTp13pH6VTWfxUtciouhdwuiFTC4ePw1jdbmSY5C8JYm3qFnpX
15176	payment	1726	1726	1874	1	1	5472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdc2Rcy6131ztmdzAMk1sG4drdXSVTz6v9CqDvsmii8BcAnAw
15177	payment	1726	1726	1874	1	1	5473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtC2EuycAbw52CDB6prBdpSCATDeNBdoGpCcwiZCZ9yVxCqmT
15178	payment	1726	1726	1874	1	1	5474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXFi6EwZfrUXwnous7KdYPKwvpDXthAqi3Vj3AGJ9DNA5xRWN
15179	payment	1726	1726	1874	1	1	5475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENYUa9Y2jJYLBfDywPxmpRexe6Ao4P7N4PAKaTPq5t6z9eQXe
15244	payment	1397	1397	1678	1	1	7467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fXV6KcftZhNTZoRnqQ2G9KVk7o7Ei9W3asoXBNmu61vf95cW
15245	payment	1397	1397	1678	1	1	7468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfrvBiD6HuYun8dwYwo8E2D1Txkm2yQ7wftfhxtcaX6nfdwNm
15246	payment	1397	1397	1678	1	1	7469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7M3yyLvgCtcCgaBHFY9xkJ1pguwHcupHv62SLjpLmDsquQmP
15247	payment	1726	1726	1874	1	1	5519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnxXNqUdNMJSuUC9U1XigLyzcdmGftZT2iLZCbT7QuXCxkxEL
15248	payment	1726	1726	1874	1	1	5520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuYhhZCjsYST2j1Qd9WoXLcjyHBLnvHCFUX5Viji5mqZTmd4d
15249	payment	1726	1726	1874	1	1	5521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6hZ6YPAQo924urfRd5JKPNKtGL24M7bRVJFDkxydQYPe2wYj
15250	payment	1726	1726	1874	1	1	5522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXG2xsV2jm21rBpPtjXrhkP3qu8ijwCRbG54hGPF8EJs5KM26
15251	payment	1726	1726	1874	1	1	5523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqutRVSr8Tqutc2yiAYkP9MkkGFsdogYS1VvpH2gVuzTo4Y6s
15252	payment	1726	1726	1874	1	1	5524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyjtUn1V2y3G4hAhyaL7Qs9AeCCA9jwPZFS3BiPR4ZfV9gLe8
15253	payment	1726	1726	2096	1	1	5525	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHgALgjuHHxrhnGLrkmN1X3HnxZLmxXJS2MRTaWSS2fwL2QKxv
15257	payment	1397	1397	1678	1	1	7471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHygocjWoFaQTTGonVByL9VW5DQ3V82YAWZa94GsAycLGmHTa
15258	payment	1726	1726	1874	1	1	5528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VU5o6YohKTXbRdLfS3CZ5MTeqWApJCHG5zMB1Ce24i8M1ria
15215	payment	1397	1397	1678	1	1	7458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5Hj9TecHBMQ5JNZqqoKdrSJWxAAdxX73kUhQdXcF8ocgsMo8
15216	payment	2094	2094	2094	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9XyfTShJ8Z5WmqwZZT1np8y8s1P4RV6u191CqrrsKNJonCvh
15224	payment	1726	1726	1874	1	1	5504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14EimNgiJSnMXBe3CdFCVMTmsmkrxrveu2ocX4QT11SK4RA5s
15225	payment	1726	1726	1874	1	1	5505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sW7bnnJRSXQgPk7SqszmaKfncCpqv1qobzHfZKjb2g2hJYk6
15226	payment	1726	1726	1874	1	1	5506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdJpxoec97GABnwwg6FXYmgYTPxmEewLjQ7Ctnm6kQiGmc28s
15227	payment	1726	1726	1874	1	1	5507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5f1px44KqpTyd1DqxBLLpVngSpH2tyZPof5jD67t1RgGYg95
15228	payment	1397	1397	1678	1	1	7462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdnArCKtNhyt2UJSBJitL9AkVthkZm6RDnoVFDFpmTvQpWECS
15229	payment	1726	1726	1874	1	1	5508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPEGcw4ts1jRwQDv6SPNq3w4kFNGkgQZ4AiZ1kXnCDRt29kVx
15230	payment	1726	1726	1874	1	1	5509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsdtexXo8yvBHA6qJMiUXU78LTFHiHVM67h5X7eWPuVdaVmpS
15231	payment	1397	1397	1678	1	1	7463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPkjnmXxK46WX7Tr4LXhuejctqoNxsynRCzM4SGRjrJJrD4nU
15232	payment	1726	1726	1874	1	1	5510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SMnASDMvqKpU8YEa6YPvLR4nZrrtGBy1xu4WvtxuRk6S2bHz
15241	payment	1397	1397	1678	1	1	7466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgprwZUqBMaaZeHiZhk5LdrujgFNaj8sp4GwYvHwTSf4iX4Uqm
15242	payment	1726	1726	1874	1	1	5517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4w3YoJGWvnPY5qp3pQBwPAV1upuS79CycBjzXkJvxRsBtwhio
15243	payment	1726	1726	1874	1	1	5518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhS3DAaU8EYQR9mM92NfUJLsSwZWXFTr8mQde5CAxnQpWrWfTm
15254	payment	1397	1397	1678	1	1	7470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDN4SAUxNSFnsYqBDVpcJgVNSwVKE8SvxCKBHg7sc9i2skPh4
15255	payment	1726	1726	1874	1	1	5526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HAzh7MMkdToV65kcQVCKv61r6oLRm3zx4pJnWu5aeHyquJPd
15256	payment	1726	1726	1874	1	1	5527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JhKDGyDJxnj8h764KrysHDEpRtFHCmD9harw4QiXvVa3dLJE
15263	payment	1397	1397	1678	1	1	7473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqm3HXm2dFR5RkswvqruWd6mg7YMWCzXzaMsGoXM3yNR4ZRKxd
15264	payment	1397	1397	1678	1	1	7474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xp7fXpTHDdghY6XfmE23Mq1rsGkFNUzfzVMWAHpspwEuKYWR
15265	payment	1726	1726	1874	1	1	5532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwgNJRjERvJCW2aP5EACtuDpGnRSMMxHKiQpdU42G7VoVV1nH
15266	payment	1726	1726	1874	1	1	5533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCek8pPP87K4ivHFM6qPVRTvCcP7mjJKFKbBY2U6NfgMQw371F
15267	payment	1726	1726	1874	1	1	5534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrhvq1BA3htaZfWMz16fFbyajgqPwmW1fMCarJhuXFukJLjNS
15268	payment	1726	1726	1874	1	1	5535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWFFd9HrwmGx7Xc2foyjHeNVxjmaXQSMmsAqvKX5RqqVge154
15280	payment	1397	1397	1678	1	1	7478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzQ3V6u4Jnu4D2Q5ASYbUSoFeiTjp4fqezv63RnAu6z5bYcXV
15281	payment	1726	1726	1874	1	1	5542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqvFXRSDeQ1utksyGAHz6A96fYEYiosUoC1pi1L56FBEoKoN8
15282	payment	1726	1726	1874	1	1	5543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBqep5hKuaK4HjaxPA4Gjv3iQSKiVk8hsCybNn6N1uzL5dhso
15294	payment	1397	1397	1678	1	1	7482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnspje3n2K1MtWqrorGDHe8CXGbXYqmr2HXFGNRrbHTj5CpHW
15295	payment	1726	1726	1874	1	1	5552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPhbDVvLpaFWm6pF46YiwsWFcmwHVVJ7mL346jrdKoMTrq8jq
15296	payment	1726	1726	1874	1	1	5553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UjtCT8jv6h5gCNicM8X6gWM5ESKWyzQUa7YVKqMccqnZ7q7T
15332	payment	1397	1397	1678	1	1	7495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYWhjCgv8FcottWbra5sYcgUgRVhBdh9dyJJpxCn6LyswQNZB
15333	payment	1726	1726	1874	1	1	5577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEg3uwciHLLV9WALrvW1BvEpHKc8m198pzsmqh1tdpssXWtsA
15334	payment	1726	1726	1874	1	1	5578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWuY458cMTaDwx5iPZLegKFXUn8QWLFfjqBfwB75DwvHphy2R
15349	payment	1397	1397	1678	1	1	7499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6hYJ1EgvZmnyPbAdbvPPRTk7nUV24dUfQ89TZjDUBGzgz5n9
15350	payment	1726	1726	1874	1	1	5585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjN83iqTh4vEG9EjMgTgt8nzHNeR45LW7sLVxYNfFQ2gvrb2j
15351	payment	1726	1726	1874	1	1	5586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJuGNUvup6ukocGhE9ihuQhdhUKFM56nkix52rMfUXGGqKEAT
15361	payment	2058	2058	2047	1	1	3	500000	11000000	65535	E4Ym8xYMC16hGsi8e7XJQnbeynAtrrE4ePtGP49YeusKY2nELHjsd	CkpZ542DBkVrpQZJKyPLuNRF8Ctd2jhY7BKVHjQwMTamo71fMkRSU
15362	payment	1397	1397	1678	1	1	7503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYgphCyBEfQ88gjH5jH1Nrudx9CycdUWfisbx7qgPDjhAZzDa
15363	payment	1726	1726	1874	1	1	5593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSopDA8uNykyXycpGzUhqy84neLavHguz1io5wSvaBWfbug5CT
15238	payment	1397	1397	1678	1	1	7465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtz3ACLNSw5t7PudZaPoG4qCatLu7Ug8y2jkFgGCjqiefSBfu
15239	payment	1726	1726	1874	1	1	5515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcDEwAJ7XrE4aXS3kK95nFqmJsMuWwf3kBXNQ9dn3BzywkvRL
15240	payment	1726	1726	1874	1	1	5516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeUTx1x2VrN4at3yFC2TdLzkMoL6Tx5HALdhCZPU696dHpj6bh
15260	payment	1397	1397	1678	1	1	7472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5hyht4fN9SRn8pfnLajxhqXN9M3daYuQt2u2ppBvLsyXZqZt
15261	payment	1726	1726	1874	1	1	5530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUE8Gyumn9rfY33D29GFYhrq6BPupNnaemnb8CCDprDmMbBMX2
15262	payment	1726	1726	1874	1	1	5531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmmtFXeaaE7V6nxGcbXCPhh1Ro3asprpQP4mJEcckVK6Qpr5X
15270	payment	1726	1726	1874	1	1	5536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5P7YfUAwmqCqXCfD1QEGpd4kgL5zoM8TSb6ta72dZ3f6AysCz
15271	payment	1726	1726	1874	1	1	5537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYcRiDNwu32wfQu7msFdeXCDomUdEgVH3fMjUAYrD5VLKfLs3
15276	payment	1397	1397	1678	1	1	7477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkgwk3mtJqMAnp3c4FJNY89LEKXV1wSGadFUqWupAuTcV1Gte
15277	payment	1726	1726	1874	1	1	5540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Jf9niEuVQ1E1KMiim6HNWjAAH6urTDvL4R5kyuwWS8c1qGBw
15278	payment	1726	1726	1874	1	1	5541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXbjqqAjapq755Wg1s8u88rmcY87F9hcZQ7NKEhUwwG9vMUjp
15279	delegation	2077	2077	1653	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptQ9RUamkZr2P6ax7eB7LFenKgpP743UkktFYoZTFJMDACFcy
15300	payment	1397	1397	1678	1	1	7484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6nwuQt7PkRPpJeU5VZhX5SkNG2Wz7PQDTPRFEZ16zF5rNb42
15301	payment	1726	1726	1874	1	1	5556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQj6h2yEPwR4bi2PxAZk9EkfvBxjSwHi3XeHLKRuevzhS8ihg
15302	payment	1726	1726	1874	1	1	5557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54giRMaQkYTBaTs7F3UQPNLG2rXUEHuoPDH9n4YqmJi7rBozw
15322	payment	1397	1397	1678	1	1	7492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMX13MD6B3GVDLKcbR2myWxjci2JWC6tbTk6658it1bJaCDtW
15323	payment	1397	1397	1678	1	1	7493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhq6pFQPSwW3J5Xtngzmv3LCfeioY9BUb2eMxxzXhQXGgtiYB
15324	payment	1397	1397	1678	1	1	7494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqxsrTbXYX535y3uvBZ3jtKSDtHjSSTd8UBVJmmj69K8F35CT
15325	payment	1726	1726	1874	1	1	5570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdgc8hEhDbvGvQ6p3CyNcok6egzkAx8s1kG4eMYvGfRFvsuRx
15326	payment	1726	1726	1874	1	1	5571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Mi9dxrXRsYwaaL9vH2EwtF9sdig685ZJ6mbMSNTh2gVDd61k
15327	payment	1726	1726	1874	1	1	5572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UyJWnEy5SRhAjytkkCfcuBBv8RbX9Trm8ZmZe8eRaDmzYGXW
15328	payment	1726	1726	1874	1	1	5573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZG2tGNf8qKdQnp44nEsbso6hkjdsbq9kSZfib3rAwFWU2Jtuo
15329	payment	1726	1726	1874	1	1	5574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmd7GgXJREhDJVDXhogov53N9jvPzdVExGZKoMsrQfj2X2cZJG
15330	payment	1726	1726	1874	1	1	5575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAShDHDs2iKVhLaWvivF1vzcFb9gQtrvwL6BeE8Xh6C29mkb5
15331	payment	1726	1726	1874	1	1	5576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShAesEtzCx5rQBCZdS9XFcPMtzh6M8odF5sGCZNzzNLQFgpzD
15352	payment	1397	1397	1678	1	1	7500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQXvhC2yXDVvxmp47P4PrdfRpW8i3qAFW7hX7G9Gzm7o1AWBr
15353	payment	1397	1397	1678	1	1	7501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbJkmnr3j871NQtKnPzdxQAHjjWdMd334gEdMQQyjRE3sRLNT
15354	payment	1397	1397	1678	1	1	7502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiBwBa55bTaSMgCqcZ93TjCdC73xK2DjmSdR1irxRuG6Avw3dh
15355	payment	1726	1726	1874	1	1	5587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yTdAUDS3vLg3Yiwxr271AhxcpccUwEZeDmiaQHv5o5u5s56i
15356	payment	1726	1726	1874	1	1	5588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiS6zwM88QQW7TLw1nz9u5d5Yaa2gaZDqqGM5JQGZesEpPRVc8
15357	payment	1726	1726	1874	1	1	5589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfc3DNb3q3eNA2kmsPNaF5JQAGriF7ntah8zwpkscTciVrrc9
15358	payment	1726	1726	1874	1	1	5590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMuAF8ya5oiPqx1BecuxNPdmsuFYddsLjAr7sVHuTQXrSmvLY
15359	payment	1726	1726	1874	1	1	5591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKa3srPraygTcy8LSyEeADnhAv6vdh9aUB7tzWdDV7AcKsxCt
15360	payment	1726	1726	1874	1	1	5592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRejRwe9xv2yvG519xdmwQ9i2eBcwYt7btAKZCeQLDYgCGygBX
15384	payment	1397	1397	1678	1	1	7509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpRUfnY9Rp1Y3XPKUaECTys5wDRAZjCVPUCVKhcuRACLhtqK8p
15385	payment	1726	1726	1874	1	1	5609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3TTG5WxjGRp6EwzDvistQwQb7SBbMCA532ogQcf37DJvLvMq
15386	payment	1726	1726	1874	1	1	5610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqhMzEZSXrVGnhCYDuU17zVRKUEafoUJQCsRCyYAABDZ1cKxT
15387	payment	1726	1726	1874	1	1	5611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCovq4eqTJiCfnoqjYwjZgtPhj6FYArDewrrw2nSfdzUhthP2
15259	payment	1726	1726	1874	1	1	5529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJRii4Nu25XoY1RwVsHnKgkgoW9oVnbb4CgVkVjEJ5tdayx8W
15269	payment	1397	1397	1678	1	1	7475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzRxUNT5D8wPkexAXGw9WPGWNMVn6f4wfTcPkz2mgtSs1K3Tg
15283	payment	1397	1397	1678	1	1	7479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymMba8V3SGUsA5ev31LUBKe5W5jU5GD4RepVUKQk79wDvxkyK
15284	payment	1726	1726	1874	1	1	5544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnqbZZDacPyqgqZ32rWxCQJQBU3n7hvjcW8BpdFC4YD2APnSp
15285	payment	1726	1726	1874	1	1	5545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MpXdAE3Y47AQxnvjqUbmNkZqWDpu1KKyXPmk4M4sUT2a5KAE
15286	payment	1726	1726	2097	1	1	5546	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmM9rT973C67oJGCjQHC3EVL1tU9NcAzX9KfuN8eZnBJybDah8
15293	payment	1726	1726	1874	1	1	5551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHqBCcQZ6Sdf5qT5RtArei2MFwou2UXYVRvRjfQAW6Tm8gurR
15303	payment	1397	1397	1678	1	1	7485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4XiNfx9U9A6vc8hyKYvGgt6vHcfc9ckiCSproiLx13khQwav
15304	payment	1726	1726	1874	1	1	5558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8D9uLZdZGz5MNeAVAFp5CLw7LH8q6UnDAZsqwp9TVKdrBApi
15305	payment	1726	1726	1874	1	1	5559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQXQz6CMM7wiDja3iokiGin3Fpap2PJraP7tiBGkqh8SJpQzq
15306	payment	1397	1397	1678	1	1	7486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE97xmgJuhKTet1RF3ojaaB23L3xJCbWMX25zYCeiRuoCo2JPv
15307	payment	1726	1726	1874	1	1	5560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2NQaSjfGoevTxkThYwMHkYeb8pNAPyA7CnrPSj9yQzjV1Qnd
15308	payment	1726	1726	1874	1	1	5561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq77mbteAeo2Yh8fA6hXVmbr4zpgr9VAs7GPzrw54LuKrjGKip
15335	payment	1397	1397	1678	1	1	7496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevTzjPNsSXBYyiQeYicLtHkAeYtWGazhuHXrf9tK3GSJdWTRn
15336	payment	1622	1622	169	1	1	0	178742095387	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	Ckpa6oBgcDE4cy7wBoMTjNfjPdQcyEfqjbd7iX2YJiPfa33pyf6ag
15337	payment	1622	1622	990	1	1	1	1367708631720	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZN1hFmscGfF4BcbDrq5mq45PkgZn72nceQxVDNhZ4sVSRHPYT1
15338	payment	1622	1622	1110	1	1	2	2450922149520	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZPzJKBJFwRyR3Ge1DFY5XQXnnkL2szvFDmufQcpKkdiUYgjvuG
15339	payment	1622	1622	1230	1	1	3	1653686012355	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZHEBUckMogqMD1mbb7djw8HoEooz7AjggJFXasjfEuV1YSP8ZN
15340	payment	1622	1622	1356	1	1	4	4608143110980	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZTX17CtK3kYp3aRKC2a6ddfGB8yewx5FWFDodZTr4YPNdTpmsZ
15341	payment	1726	1726	1874	1	1	5579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUE8C6ibEtQK871DKkUdRVki4y7eKzETwkaowvXERan9RwScc
15342	payment	1726	1726	1874	1	1	5580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3aAcbv5kAEvrt7Sn2kaFGiG9dxLjL8qRUnmCqFgGoS2vnKxV
15372	payment	1397	1397	1678	1	1	7506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8zs4q9ymCnKNkvckxFjCbfbHjwB7ewUenShhBeteHrcLhbg2
15373	payment	1397	1397	1678	1	1	7507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeqxtuqgtmEamBwf2WixDzbvNShwxLr9FboPzQEKVqJFCEwr9
15374	payment	1397	1397	1678	1	1	7508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8GfRQ7v1CWLxi4BQPaVNzrvWriAYY1TFxzYHLw4Mfgk7sALP
15375	payment	1726	1726	1874	1	1	5600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjjPQmgK7UsoDTX8FDHRRsyRqMdXiapqAYxXKMFv63nuLb4jH
15376	payment	1726	1726	1874	1	1	5601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTsKE7hWWts5PDMYVpyHF8SvNJUWKKY9ywoG1pDNPerhXeVb5
15377	payment	1726	1726	1874	1	1	5602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9rsNf9PtkkHYjNVm6WdnDwu4oqtbd6r7RefQwbZUziCfDjGL
15378	payment	1726	1726	1874	1	1	5603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNBtXTTVCTQtQGDeLg1VVuqdmQrFf9sGryA3DJJTgB3C9GNQA
15379	payment	1726	1726	1874	1	1	5604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCPXBhU2P5ddKimVkgEJMqev96XMcPLYxKKk57SbccDvpw1Ry
15380	payment	1726	1726	1874	1	1	5605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGj5Nd6TKrEVDNuzgQ8at2EwkPVfy8u8o9TNh7gug7AimdW3Sb
15381	payment	1726	1726	1874	1	1	5606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RJ6YnnadejB3r1v8GbpQUESXFNYrvbXcxgP7Nhjh9LwJ3cnz
15382	payment	1726	1726	1874	1	1	5607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UBM7mK2hZm2bEuxZgq6WSdiy6Xt83sa42i8LBUiBMLS7u1iV
15383	payment	1726	1726	1874	1	1	5608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaf2ZYKfNQU6FnhCGgMjBd5rmiGnUTcq9RoGnCaqiSS593bmTt
15409	payment	1397	1397	1678	1	1	7515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvatQjnvQFGeqxMFJNJ1EiCW96c88ir5WkA1Vd7iGNuSqcgnkS
15410	payment	1726	1726	1874	1	1	5627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevRcWhzon8y8bxxo7ujZML39zjWAwghco88AwyDLRf2bYxgCU
15411	payment	1726	1726	1874	1	1	5628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VsectmF3JByqkmCFfQaNhFhFzetPNQUoWsWxVccNAtMPfhTV
15312	payment	1397	1397	1678	1	1	7488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqzkH1WMXq4zDUDFyRgxDP8YRCui521UdhcBiA6gPAC2sj1QM
15313	payment	1726	1726	1874	1	1	5564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8wLA3g4mCB7XsmAgDKxRMNXkosPQuJZARvt91YA5UsihzCp1
15314	payment	1726	1726	1874	1	1	5565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVcp7VcX4T1tPtzJBnzehoaTDeZvoqHMGSGgMraBqzDHKkMXCc
15315	payment	1397	1397	1678	1	1	7489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn797n2UbReyE3bpUg7dcHNreYJgJCrT3As4VZ74VyS5FX3WLs
15316	payment	1726	1726	1874	1	1	5566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHd2KfNxbwppqmwVk3fzXhvYSDpRafj4qwoQ2D9zY2cLbracU
15317	payment	1726	1726	1874	1	1	5567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnM9Fr1tzpGRhfRxLo1XhwjYQnJxg2f51ijZrne3hm3VcTxYw
15318	payment	1397	1397	1678	1	1	7490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnmaBhSRyyWTsvmY5FA4zK6gu8RwNtDCMfo3MtqyXxYjRXS6H
15319	payment	1726	1726	1874	1	1	5568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo7dkTfZEys3j3iCcS7HVM42xgqm5Ti8Us92kDnzitv1nWdiW
15320	payment	1726	1726	1874	1	1	5569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjXQxvxc6DJQNVu85kLhKQTALMx5oFGDDcupQ9VRZaBA8T6jz
15321	payment	1397	1397	1678	1	1	7491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMpq2pqjfgjaNpR7gP2i2LjSf6kU3vs1KW5JmoiSqHKSBqSLg
15343	payment	1397	1397	1678	1	1	7497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQH6QeGdheEnDqV82yZ3eQ7fV6RH6aBY8imbQUACBGB771wwE
15344	payment	1726	1726	1874	1	1	5581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQsamA1Mwz3f9hG1zYdHfV8b9DEF9TW4VF1dRG8pyfdeHoXFP
15345	payment	1726	1726	1874	1	1	5582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu1eFFHisQgkeqCE6avF3aonA8jhpz51kbTBcZsHdcpyGmii9
15346	payment	1397	1397	1678	1	1	7498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5bsqMTt2pXvWjEmVFo7qqSGghyK2tMtJwFhKAiEHyjZzpuFhx
15347	payment	1726	1726	1874	1	1	5583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9LZK7wxEvyAsUXKZwmbAW1ex6u1a2jq4C53ske6HHRQtRXdq
15348	payment	1726	1726	1874	1	1	5584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3RBB9EpvbxMTjctHvhBCdxcEuyQ86Ff6y7iyf4kQbY2YfxUZ
15365	payment	1397	1397	1678	1	1	7504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYstQuAXeXMWb5Hfwsg37kLd9uPXFZrh4QDzfvCvkVEwEpQHeX
15366	payment	1397	1397	1678	1	1	7505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbLrp4bBcfe6SYtWmy7zANw4PmqXTzKGzxDn2b7wDM8fyERiz
15367	payment	1726	1726	1874	1	1	5595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9PzLK7z9ZK4vo4zMfgHYWZsrTkzik8KYY472E4BGzcUvG5aG
15368	payment	1726	1726	1874	1	1	5596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbDztM3kzZFcvkGWw5BqARkxLXS2MV6WFMWQGad64fNXD51FKB
15369	payment	1726	1726	1874	1	1	5597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrFQsKLpESpJ8P3v1L1NXU2g6LU8upJ41hH6GcmgJAv5FcmQ8
15370	payment	1726	1726	1874	1	1	5598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6V8PRDHVKDcBSHdoAjWUGcA5UeyGwmL2VwfkZZETA4rafu1P
15371	payment	1726	1726	1874	1	1	5599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCr71gxkt5GyuHCYd1LMjKERsYgd8X1k4K1iB8QUKxDFZV4YY
15388	payment	2058	2058	2059	1	1	4	600000	11000000	65535	E4YZaEeQ5LsBZWgUMQc61A9snFW8Zhknu6TBPPaM8cbjYxv55nubz	Ckpa7ExzkWoNg2vrSxCArinK7Egg7uWqAUrwWGVYK2tRMtS44FwpA
15389	payment	1397	1397	1678	1	1	7510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ273EMa3fbjDsxYQBefrxCw6Q3Qg7D5gUyWigXLo4PmGZ7vhGp
15390	payment	1726	1726	1874	1	1	5612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWKRUTjJeMtpfUXSRnSFuy4D6aj29tNTL5fsC7rtnCexiGcCj
15391	payment	1726	1726	1874	1	1	5613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8UGB75Fsd37U5PECLGd3G2e1WcmGjPwJCcY8LWNTNtGBvnJV
15392	payment	1726	1726	1874	1	1	5614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoV9oBWh1qTMEsYo9aXNZ9NY5RurpmtbmdHBksbM4MGbkUb7aE
15402	payment	1397	1397	1678	1	1	7513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvX9Mz5Yo5sCMxb7foycWq68hr2oTye5ivyvn3cc9Qkg7cWG9
15403	payment	1726	1726	1874	1	1	5622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakYuyafbwoNSAkeTWrrMm3o5LLq3eKm4suEANHaPBivo7cKf2
15404	payment	1726	1726	1874	1	1	5623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBWvaWgppejZvjJ8LAhoUhRrz5d3Vum6wKcmunqgp7gxVtMJK
15405	payment	1397	1397	1678	1	1	7514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzA8tipYv7NnwkvFWkucWDGjaAFhoKEATv1NxfxKDN52nukLHx
15406	payment	1726	1726	1874	1	1	5624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDk4mnxayn8KYcdk1KengzNki3rwmuJ8jGKPmzGRycmR3Brw1
15407	payment	1726	1726	1874	1	1	5625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqiUjWk4DewaKZKTfxJwPLsPNNtqBsSnZysynkTHMmvhhp5hY
15408	payment	1726	1726	1874	1	1	5626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAvRYSKRdaJGa5N4hQavogB9p64j4sHJjtAD1CtqVbvWjAey7
15412	payment	1397	1397	1678	1	1	7516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXmRcprMUuyuxR9KpHci8B9hjjnbYSX48gvJXhLAjer3Ezxui
15413	payment	1726	1726	1874	1	1	5629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdq8BWAsFzooDJz7uXAxvLZyPZvdZXBqWm8GxK4x4m1s8RYBqQ
15414	payment	1726	1726	1874	1	1	5630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAaPmzmd7bS4Lqp1ToDk9ntu5CLzQq2cfZbzYLvnmYWEWMXps
15364	payment	1726	1726	1874	1	1	5594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtK5mZYqisDXP454yBpGuEH28Po8v49FFeTXLjg3wSDyKDteFY
15393	payment	1397	1397	1678	1	1	7511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyjYgcRbNWkjs9u3YUvkPDTkgd1auhTYwCfUYDqRhydGxCd9q
15394	payment	1726	1726	1874	1	1	5615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEEA2BJctPjfruBneTAjH3nASNQRipx6TjJVDZbfKjNELZGgx
15395	payment	1726	1726	1874	1	1	5616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GZ9owa3nhZLq2yGXRt1fJ6HDXwW9LacvDqtTMJw5K6i7AhLS
15396	payment	1726	1726	1874	1	1	5617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfovNL2HHrVZn6AqUL2Yc1bRRE85vRLRCBAsPfqf5gPgAkWQe
15397	payment	1726	1726	2098	1	1	5618	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYp5gmkmV2rpK9NznZP8nPyNbryWAuXttmWv2ASmeiXbWwVUS9C
15398	payment	1397	1397	1678	1	1	7512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dGZWZNj7y5p3JhSCqBFxJwSAe9EE4uQ3nkEvhLdQXbbrKbJX
15399	payment	1726	1726	1874	1	1	5619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFfoTryDvkgJXRv9ptAETL54ic4WV9j8SanpSuu156FGkW62k
15400	payment	1726	1726	1874	1	1	5620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGSC6BqgeKze8Xz34hY8LbMWgszdzbYEDyovFdP5wvLwQeNwb
15401	payment	1726	1726	1874	1	1	5621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZkfu8NET2SeMtbiZRUKqQxvjaAwqBjkLsFLuTGqehQJiaSRZ
15415	payment	1726	1726	1874	1	1	5631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2kN96r1fEsHFysL2h1iUaKfkPZqKXNRyAyMbjUZPeTp5Vjyo
15416	payment	1397	1397	1678	1	1	7517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3qdaLuMJZEERQf6o758X1cxJiDLMFHX4vfoSADVtwHDzj1sf
15417	payment	1397	1397	1678	1	1	7518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLyGoW1uKXZfaqHWdeCKJTfGKf6ZZEnTSMZgVodsbG6JJidCM
15418	payment	1397	1397	1678	1	1	7519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugSgTahBjYqYWEeBHKvK1pM7yPgYDVQHatQAXDJZbaWKdX43T
15419	payment	1397	1397	1678	1	1	7520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWM2m5GSNpUupbUaA74s1cQpatQFamEqUiqVcYQdp8PrRRnos
15420	payment	1397	1397	1678	1	1	7521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccvDQkcjf41vnd2cKQYuU3sYFXNPmRUfgDJaa1W9XGEj8NY4u
15421	payment	1397	1397	1678	1	1	7522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xTpSpsu1KmJz6vehJYpdHMgGmVj2xPDMa3bw6UapHqFsWME1
15422	payment	1397	1397	1678	1	1	7523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HRjuferjZ149D16JmzMHf19bU4VbjMqYwRcb5jwZjgPLMggR
15423	payment	1726	1726	1874	1	1	5632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxtgQvPKnn7hpuhtutadC2Cq6FhJDQUzHeAznQAL27dB3LuSe
15424	payment	1726	1726	1874	1	1	5633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBnLKFC1RhCpEndhsg7qLstfYZUn9MTxFY9shQXYVQRyDKDcC
15425	payment	1726	1726	1874	1	1	5634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWSNPMQXM5gh8mitXG2sPJQrz1dZmxmR93Fuas1eb2mTkYdV3
15426	payment	1726	1726	1874	1	1	5635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHPq7QoWkqBXfcgge18ckEyToVZU2JdXaxpSMFjzajc5cjfYw
15427	payment	1726	1726	1874	1	1	5636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mEFPHZ11DCckwmciGEeH7GmQBf6hvX3kyQMfk6Xpbo9AS1rj
15428	payment	1726	1726	1874	1	1	5637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjWCSGG4uVD8GCCid2MKCsAgMitPjNaVy3Ts9QTpaBBQFtCiM
15429	payment	1726	1726	1874	1	1	5638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKpn9VjZBULMLxupFKe1x5gnNfzpfQWUgY8Az1jKRF711vyst
15430	payment	1726	1726	1874	1	1	5639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MT7EX9DygS4JLgWN7QXsKYRQY3xySTKzXxRZUoWAnsAqahFV
15431	payment	1726	1726	1874	1	1	5640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1dgMJkVb3F1G5Jtq5mPbb8XhL7x1b9msn2gj8E6fHzPuHCMY
15432	payment	1726	1726	1874	1	1	5641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrKTjqeECm7FRUDusnGqkhGZrDWo6mamtnM3QDGJNbXKfzyaZ
15433	payment	1726	1726	1874	1	1	5642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gjwvKEmCtKQo18ZGfegA95CiURnVBBnwfkxnzuYBP2SZ6prg
15434	payment	1726	1726	1874	1	1	5643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjziFwBWntnMgoVF92JpMxGH9Fh3f5p4Y4oTvndV7UzSjgprc
15435	payment	1726	1726	1874	1	1	5644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wYZDDmB1Qi5XgsBmFqcWrVqwHneBk9UQxF4AgW8ma1WRrp5m
15436	payment	1726	1726	1874	1	1	5645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgedLeSizu3DptXg8Jd6zUVhJnBdmzP2KX4B2BiP5sWpuj2PZu
15437	payment	1726	1726	1874	1	1	5646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeKyDsKQSBQ2xiaUL1yWgXWUS9Xq9XuGmN9kP3rA6ezbQ3rbN
15438	payment	1726	1726	1874	1	1	5647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgJb1qXzokrYx8wqZs8NchxamXxMD2gNVZ3eb2zr7TWvCY11A
15439	payment	1726	1726	1874	1	1	5648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMweuyKoP4NuvDQosquC5gVm97Yr7WaKmsSC9SwE5dKhB4TPR
15440	payment	1726	1726	1874	1	1	5649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfWsBYLH2K8EhRtQKUGbD3mBMCMcn5fJtyfqq48XsjdaJ1nft
15441	payment	1726	1726	1874	1	1	5650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjmiM76TKTZTtpMugBvEZHddVQzrvHLk2C52jNaTPdpzYuW5E
15442	payment	1726	1726	1874	1	1	5651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjyN4tSKtZwQhjpF1Xtbq8AgXdqhpxQC8prJpAU5SR32DHjpM
15443	payment	1397	1397	1678	1	1	7524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpT7JSZLnahBFPUj7T1L3Kw7kUB75qufUbcG3DNWUu69pidZf
15444	payment	1726	1726	1874	1	1	5652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpx5YnRFHw5FHpSzUStXWV4qvon4j4T1NUu1p75brxLjUsReTc
15445	payment	1726	1726	1874	1	1	5653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RrE2MXhfEe1C6oS9bbvn7soVUXhw5uJDvhFwjjXUjwCKDz8x
15446	payment	1726	1726	1874	1	1	5654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEred1BPyPBRodpdbXcwh6vtm1x63wmsFKZzkcGrxhzrSMPzm5
15447	payment	1397	1397	1678	1	1	7525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mMTA9Ly2k8PYn52fkod29MnHnosthEpa6LqzCqQmEdGofrwF
15448	payment	1726	1726	1874	1	1	5655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LDmB9J4yh6PB8w3tU8h38KhvCDw4L7PUbZ25g9GqTUicDhqG
15449	payment	1726	1726	1874	1	1	5656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcGqJjAF354EGeUL5sRMZZcWJPNiWCWix8AWj1fQuDwdWHniH
15450	payment	1726	1726	1874	1	1	5657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkv95sYqCTk3WYE43M4u36BmFS8DoXpZM2VbcwkztHgdM2hJJG
15451	payment	2093	2093	2093	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJCz6mZ6KPqs4r7UqT45L4BKYUDFW974kUGNEY7PRV1tK4ZYE
15452	payment	1397	1397	1678	1	1	7526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZiKNo88B1ohhQuCUSo7CQofkWZX9wSTw8okAjJVpe9WAWTfD
15453	payment	1397	1397	1678	1	1	7527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KmpvkoShHLxNyryvN4h8RBekp1bW7UmkR7MNtyqFgY4r1JjD
15454	payment	1726	1726	1874	1	1	5658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafGUzNrt52vRjta5LrYeXrcW5oigJt9keX9KyR8RBreVZxuTQ
15455	payment	1726	1726	1874	1	1	5659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QByT8B8GdyqufRXxeSDjBRFR9hivyZovxL3etp5iGegqsUGH
15456	payment	1726	1726	1874	1	1	5660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjA9UDRitWUa1jturumZXkeJ1PotdJMzt7AmQ1bPjNnMnZaEr
15457	payment	1726	1726	1874	1	1	5661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ktuxVHQqQcoBbvqXCGzkwogfamfeL4hXn8eH1xrVWbhxFB2X
15458	payment	1726	1726	1874	1	1	5662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLsatwLqzV12GDZsp5ZDCeKk7FtSd4k29VHRnGQDDdB8pp2ia
15459	payment	1726	1726	1874	1	1	5663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8xxQToqeVqYfUG6tTQb73ibrRvKvGf7g8inPc7WxoSoccxDu
15460	payment	1397	1397	1678	1	1	7528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDRbeuXAZLJkjhwzSvMG3qM42tHwYY87jhBYX4BGr6aEEdUGT
15461	payment	1726	1726	1874	1	1	5664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsJqn9foL3sRW36neQcF4b8uPuJjD9aD8A6DsHjHk5TFN21bQ
15462	payment	1726	1726	1874	1	1	5665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQorYz6eKHw26F9ChtcPDKXY7RLcdJ4oEX7fpCptGAt1zTKS81
15471	payment	1397	1397	1678	1	1	7531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKJr2DymncFv6G6bHCTdsQRwUczu5VyydzSwbeoSertNXexLf
15472	payment	1726	1726	1874	1	1	5672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJpqqcgbTCCLxSMR27kDzyH4Zz8SmJs5uBFwpJQVG3ofr4RZ1
15473	payment	1726	1726	1874	1	1	5673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6kGLcW5a9J7DWDJCCz8zgt9VC6C3eLY2vNah9UDeHLrLe93N
15474	payment	1726	1726	1874	1	1	5674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6J4zeabECwcVJkxwUMgnNoPyRHypdVzzqHaPtiqhAEPHx8p1
15475	payment	1397	1397	1678	1	1	7532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcypAT7p3XVfvNxyZk1BCKYaJWV7HihqHFLPRGjMxp4jathJF
15476	payment	1726	1726	1874	1	1	5675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3BYQ43sVbrnf7ov7T2RYuZhZNisHe8tv3MnQLQawaVfBnJUX
15477	payment	1726	1726	1874	1	1	5676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLCMZ21qBtivGpYxFeDx3v7AB4D43wvYVrWHDXMAW48zdxyy5
15478	payment	1726	1726	1874	1	1	5677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJt9LFFw1H4URYHfBcPwA2n9n32jfXBQZbXPW43QbFPn57rjXH
15487	payment	1397	1397	1678	1	1	7535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41pU8XpWP5nv1RrqaiXUrMH3UQcftnquB8WAwwzEgreuRQm6n
15488	payment	1397	1397	1678	1	1	7536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kKmEVUV5FmUEeqtrvbDiXxnC8DBSjuo2afMGJoQQMPXBzMkW
15489	payment	1397	1397	1678	1	1	7537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQATWn3XveAaYjVccKXfu7Fr839yviRXErgeVwEWD7v2Lbwhsz
15490	payment	1726	1726	1874	1	1	5684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrr5sz24UoVV8L25a6JyxtdPcNrgMeoRLct5zV8uwSUq8y1st7
15491	payment	1726	1726	1874	1	1	5685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwvs5LsS3pyf1TBVVkyqrY5NjCaaGJRYgDkiGQv4TT3CEjmwh
15492	payment	1726	1726	1874	1	1	5686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVaNBDKd38gRiBDXXfRyizExPwwxRR9RUywqDxDcan9qP7Byr9
15493	payment	1726	1726	1874	1	1	5687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtXwRiuwPhXLaR7BoV3Sc4iGbwim52Rr2JKmhX45YH42Gevks
15494	payment	1726	1726	1874	1	1	5688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQCBxpgMgCj3db3Ryxx9RK2LjYtdYRt9RTjwrBGLDm9maq6Az
15495	payment	1726	1726	1874	1	1	5689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67TnuPSeMob8LUbq8fzWPhRsnGttyANTUCXLgQnE2dUad2nm9
15496	payment	1726	1726	1874	1	1	5690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9GAZos7V6UdggHZf4Hj54Hs5D2Hpa9AFne3zbyXi2wUi7bc3
15497	payment	1726	1726	1874	1	1	5691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uBNpT9qFTxuWfC8TLi76eN8zZxiQEFF1NQ4d9W2ht6dySy9b
15498	payment	1726	1726	1874	1	1	5692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2N9QNMmqhbhhJvLsvPX2YLvXhqd9Arptv5UomXRcntdMokmU
15499	payment	1397	1397	1678	1	1	7538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGn3oU74jBEynEHvtBvKDjvDh6wPjZGASfpMX3r7SQvYLF831m
15500	payment	1726	1726	1874	1	1	5693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWpnJgzQuQ73hXvCsQPaYTbx1ckYwqbuedXKecSKA4Gc7ieYV
15501	payment	1726	1726	1874	1	1	5694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3QVe1ntGfJhgwbmQRmSXv125DNtHNoiSaRrxh5WdPLX19uzG
15502	payment	1726	1726	1874	1	1	5695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d2TKTsXCqS86dc2b3ASLEmrRswVJN24k7NM35vQkxRdUzY1H
15542	payment	1397	1397	1678	1	1	7549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtbsVbQLKPDGQ8midtdLh2a7mKtiM4mAzKjVCM1P9mU3YFkfB
15543	payment	1726	1726	1874	1	1	5725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZobZHTDHgaPjv9pFo6ezvFM5puTYidYorrFjF1VTAtcEKn6Hk9
15544	payment	1726	1726	1874	1	1	5726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaq78aVzSVfXiTnPtji2BAifCA2XgmairWbeuhFZddqEhmboh
15545	payment	1726	1726	1874	1	1	5727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdqMQ9mbgD3w7bG7Sy4HFRtnWhA73XBsDQ6MeKwpkQGGPbKZGS
15463	payment	1397	1397	1678	1	1	7529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwZJNQ186754J2WMjPzVWKBSHjAeFkB2LsfyiEJtuBQRDKRN1
15464	payment	1726	1726	1874	1	1	5666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHt4UVUeNDAg3gUNHjv1jznZRokXeXd1Rs2TrQdpRpcr7PRTjy
15465	payment	1726	1726	1874	1	1	5667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGc7HFCNnU13xqHZwWQTJyALFPy64Tf1gkvHTg3Phm4VKhtXpP
15466	payment	1726	1726	1874	1	1	5668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbaT6Y7LirFAWQWes9stuWeAE4Do8K3wKDVotM18XXMQFrNrzR
15467	payment	1397	1397	1678	1	1	7530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpurk6SuCPmLPQ7ykt4e2BqsZJ2rhwcjEmoBBdPfF4233oa5ZN
15468	payment	1726	1726	1874	1	1	5669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZNoHAMqkH1QKZ93YutsTtzk15vUp8Wg6GPkrvU6zHMqdumyr
15469	payment	1726	1726	1874	1	1	5670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1eLBbNk4oMtiFjQxug3iAY1u8amRW3SjRw1CEt9JpL7MoKt6
15470	payment	1726	1726	1874	1	1	5671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM78FvZSwuimFzh6t7zbj3PiVPUGpB8a2rDuK9RFqPHB7NfanT
15479	payment	1397	1397	1678	1	1	7533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC4z8HroYJaRvQKAaTx6xfaX9VqyQqp5VTv2SjR7LnkLksnAk
15480	payment	1726	1726	1874	1	1	5678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6Qzep3wwKDR6WYR6V8Qa9UapPspfsQmaciGfZNhg3xEqyJW1
15481	payment	1726	1726	1874	1	1	5679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3PT9V6zHbPaXXUEA6xvMMCGiq2v3oo7P8LC6QEB5MKq5srJ7
15482	payment	1726	1726	1874	1	1	5680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2ESkmn8Cya9JVJDECBC77ekvwiLko47TM3EwxsH1MBZeniQA
15483	payment	1397	1397	1678	1	1	7534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zsdBDGfdGaVGoRKsqydkeKYPmkq8S7LQHKJtypzdrkcVDQFa
15484	payment	1726	1726	1874	1	1	5681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKjfkZMbGf6vY4Hb7Af7XHkG1GEaR7c5RwjpKttQ1wc2vNL1j
15485	payment	1726	1726	1874	1	1	5682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQCopCY5RQ8bo56qxNeJxJ2BEG9C4CUECGBkbjfRn8ZM1NDjx
15486	payment	1726	1726	1874	1	1	5683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TdoKFpTuYQf81h2rPZZivyTL1fqCxXz5dj3aH997Gj9d3Ycq
15507	payment	1397	1397	1678	1	1	7540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAf4pe32AS2SdwWEuugoEKdEN4TTj9BknSRETiopkNRddbTZyj
15508	payment	1726	1726	1874	1	1	5699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy4jKeC2G22GVd5WfnqjSM89H7nDKB5oqig1ebxLE8pDCB2w4
15509	payment	1726	1726	1874	1	1	5700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mZXfcggJhjKfR72vCt3M77J1G5NGjzq92jZSZ9C6EQQnmss6
15510	payment	1397	1397	1678	1	1	7541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2pBY37n2o89YkQX6jyp8N2srZNa2exiyXj6jA2jqVLQpCSFK
15511	payment	1397	1397	1678	1	1	7542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BQHtWAmDFvrtGJMYHT58G86E2LypB2WjjPQNVLAF4NLtRvm7
15550	payment	1397	1397	1678	1	1	7551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdMsB1rxzkCbafcxZoKfB42ZAa4H6CvMdm6gqtMfsNc6AnRFj
15551	payment	1726	1726	1874	1	1	5731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8UburiFxQTGxQmgbubqVv8k4H4ANLgUPX5cM6yqyKxsPLkGB
15552	payment	1726	1726	1874	1	1	5732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACq5C7E3vu8G9AK3wRQvrowZGjLumBqiRRG5b95ypZyE34GRx
15597	payment	1397	1397	1678	1	1	7566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TAwAazZW75xDYEJ36yM5fmvKR1zEnuU24AD5X4WRmL7sq4Kh
15598	payment	1726	1726	1874	1	1	5759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf5pNiDS8HDE8vPahpwDvCtbJV9V2SzLa8TDa9Ptp9rJB6oDq
15599	payment	1726	1726	1874	1	1	5760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc7gJzNicoZrVCorixV3b2LLLjNb49HadGPaTAwhGpjvtuQT88
15600	payment	1397	1397	1678	1	1	7567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyLT33U1iCYXMM5EvbSdJZfkoTED9tgGFQi2EF6C2T2aXnijb
15601	payment	1726	1726	1874	1	1	5761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaRa6g2KNrvwrF5eyNfN7j4BS8eCydpwTEZa3bKYntJFHpQuw
15623	payment	1397	1397	1678	1	1	7576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PVZWcUR3xFFMEXUfdcEzUTwzKMQU59d5qR9faND1Pq5X4LXu
15624	payment	1726	1726	1874	1	1	5774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F8HKKYDZDRE6hpc9ag2wmeRH13iSL84JSQyxeFoXnB3Q5rjr
15639	payment	1397	1397	1678	1	1	7583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdPVi7ToQ2U3mdveJBVbjQUvPm5zHzLE3qHh7yTMyJMqC9Nv9
15640	payment	1726	1726	1874	1	1	5782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXV78cJjXyVg19ZEZUW3UMW5wxWaw5vqZf4rn9wGa7fXWCxkCX
15647	payment	1397	1397	1678	1	1	7587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjySorQLhu9Ck7LjZWMxvacMKfR4ZU4H1HXQXfiyKLcY2oE1ta
15648	payment	1397	1397	1678	1	1	7588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmH6nWrugMMRrnaHbeMw7WVFqcPxvuCmLJnn69uuZAgMF6N93
15649	payment	1726	1726	1874	1	1	5786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwc6jrihweRXwakYbSdAsery7L3Uhvn2MmS3hY9nSoQvxBe4g
15650	payment	1726	1726	1874	1	1	5787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VmPM6zXqxyLRqGP4yWnE4LT7mqPQ2Pys2DSD5DG67p51u5gH
15657	payment	1397	1397	1678	1	1	7592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mKe5wtBkRG3MJKucYcboXNxM4sGSvoXztS42of74uqRHvhF6
15503	payment	1397	1397	1678	1	1	7539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTJXdWX9RNQg3aXmBWknPSJw6ZciShdS6msVsw2UNdc6wo8Up
15504	payment	1726	1726	1874	1	1	5696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXGmVhp1gy4eEBBNtpg6rTrQDGbEe196U6fd7y4EDQH8LQWCJ
15505	payment	1726	1726	1874	1	1	5697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4gvjd1XB5HBojtX2kHk3e1FgXdYnCrmGCgrsaA4GAt3WU7Nc
15506	payment	1726	1726	1874	1	1	5698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVkAwy2B9LVbeuQA5chxJxPtDpNhkuLi3DTUdc62uE9nW1hva
15512	payment	1397	1397	1678	1	1	7543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMT8AX2gurrknTKPhXU1rkaUYhc1NpqxAt6xk2WnmUdN6BZBDE
15513	payment	1397	1397	1678	1	1	7544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsL9QxAXqhE5ZYEr41N9HiEVyqvY33dv4FgbQDnTasbzpbzyMW
15514	payment	1726	1726	1874	1	1	5701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcg6xb3XhjYn1tk3WbBQMrq74tCnAb9mkdZWjQRMuZrLdVwu5
15515	payment	1726	1726	1874	1	1	5702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzCzpMrcyXrWvaa64a15zb3ErjxFMAnCpd2FNt2a7KMHk3hHo
15516	payment	1726	1726	1874	1	1	5703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVokj89gCNCsktN5HxdWbwhLjbmVgvTv4sE8ji3ctoybBgqVY3
15517	payment	1726	1726	1874	1	1	5704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCJwTxBDn5pnje1YXMKZGVAr2T4FHEdFGVZPfPLR2kWczyCQm
15518	payment	1726	1726	1874	1	1	5705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYni5bSymMcrWnWbg3cVq34pHEwEnhYC7rA8vff9aDhNma1neoR
15519	payment	1726	1726	1874	1	1	5706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYfWyJREQNutd8j2oyh8h1agQVhBxgEaq4kDhPYNrpeRWHzVS
15520	payment	1726	1726	1874	1	1	5707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeXRJ78zxezgC3K2H6BdNucnSG4CRAcMgpSnPeqDNsSFW3ReCT
15521	payment	1726	1726	1874	1	1	5708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqtM36aWyttmSX51tosDQg3hnLiBXgWfW1R6KhmM1v17jdHQp
15522	payment	1726	1726	1874	1	1	5709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAyZ8iio9MFvk211jjJmgLWYpEAGY3zswoyVbnCVo11EkrhGB1
15523	payment	1726	1726	1874	1	1	5710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUJ5ydso5DW8nTz96tmaha6jTP5MSfTpwRW8bXmEBaVW57emc
15524	payment	1726	1726	1874	1	1	5711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2E5zr6fU1rCE58H9pDMDzJt6fHFhUCJUgTgmzSKXUPkKhNyrd
15525	payment	1726	1726	1874	1	1	5712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5LFVL8JYpW3PYwG8m13naYioZeaBwHeBEDiMwyniDoUFKVA1
15526	payment	1397	1397	1678	1	1	7545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZPv9a31LLg5Ppk3bQkJE2fPBYg6oySFE9gq9VeyVEnk4EABq
15527	payment	1397	1397	1678	1	1	7546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLabA7HnDgX77WeJNWxAChF4CRgn76zC1NyDBGkDT8eWFaQ2v
15528	payment	1397	1397	1678	1	1	7547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdNms9oRW213ikQJBoVKQgLEU2rwhLTSAvDr3LHCF275AQLtM
15529	payment	1397	1397	1678	1	1	7548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hR813AdMKyTnt2nM8cE31Rcs3HjG5HtrcgHEWG2eKBqdVSpr
15530	payment	1726	1726	1874	1	1	5713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4GgxT5A21Lct2oXN8oUPgLobSLFLdUh6mWL3exUsiwgmJLF8
15531	payment	1726	1726	1874	1	1	5714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbjsd2PCsrQQfu7pq5uXzW5B9oo2gYW7hz1KcGy7gixYD1QNih
15532	payment	1726	1726	1874	1	1	5715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa94S5NepE9LbGnfRBa1hE9PmmCTzL5WsJAuUWf4JZ6DZXw7dS
15533	payment	1726	1726	1874	1	1	5716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHPThGhRBchnygrrrB5EhZQL16bH3afbEEc2sP4w1p5RTnHWX
15534	payment	1726	1726	1874	1	1	5717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxH9w98qgrr6ka1SuScX4ZLbsMF44M1u2N47zz2ybomdYTkyD9
15535	payment	1726	1726	1874	1	1	5718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8thQKPgFfyAY8dhgE7JCcEFyhmBvU5tkeyK2a2Hia5PZUVUe
15536	payment	1726	1726	1874	1	1	5719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsuLHLerXYmCJeiFaYy5T7aUvhDsJAzmPHiEj9MPZ1pY5LjtS
15537	payment	1726	1726	1874	1	1	5720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6C192iPiaMGekFCQm3bxEZpXvuqUwp8D8sANXcUkyLK5RuGy
15538	payment	1726	1726	1874	1	1	5721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgPeLXP54hZPLWWwXu97QyyyxVE8zNDsii93qB8doDZDBwMDq
15539	payment	1726	1726	1874	1	1	5722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LUxfXgBcyqSjcL2EiUKwLuTL5onbkuAVHh8eripEKAt1Z6Je
15540	payment	1726	1726	1874	1	1	5723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoYzHzzEuXVdfuhJG3tETGtTn96qtALTcviyTKJ5XzdR4cUSA
15541	payment	1726	1726	1874	1	1	5724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKVVjZFJnxRGVuFHpYZDBavydH8zXqZgWb7vLnvYBYJdgk2aN
15556	payment	1397	1397	1678	1	1	7553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs43msG4a6osRNZsgN8hh8uoWAfHhxbv2ZF51zbg7WmZHJCb1b
15557	payment	1726	1726	1874	1	1	5735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP45RK2ZY7DEbgcLp7nv3FwCz4RPvjG3qcwGUqRuvSgT7DaHy1
15558	payment	1397	1397	1678	1	1	7554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSJ3fCMR5vuWHZRFAo3tMkaxk38oCRYea8TwcwkeabFDUfN9C
15559	payment	1726	1726	1874	1	1	5736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cVSdtorc2aoauBvHpJ5ZUJAQtubobY4M75V8pcEzXfoYWwiZ
15546	payment	1397	1397	1678	1	1	7550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7TEub7JweVXwKZuKKpqUcC2NKgf9pBX14PhxVCxiUMbiG3GV
15547	payment	1726	1726	1874	1	1	5728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pzHJNGfVVRKW69zwLYdh648DFND6AeYVbAQNqZG2TQ2QkNqE
15548	payment	1726	1726	1874	1	1	5729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3GXgeGQd73qxpeZ1wvMjARPXfNCyp84o2mqTahKAPT316tyN
15549	payment	1726	1726	1874	1	1	5730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfZPAmZDW1QPiFHtoWh8hARuY1VEfb8EuhR8iZ7Y54oY5n7Bs
15561	payment	1397	1397	1678	1	1	7555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdc9t7tfzLFqjb8FT4veNfvERQDjjaoP8BTvSSAC2nzU7ywLdr
15562	payment	1726	1726	1874	1	1	5738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGvfhpVNbsuFXc9VoLpWfTtwrKLQAiGnwSZ3XwWm11vdFEneJn
15563	payment	1726	1726	1874	1	1	5739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXE1cYT2MzhrJY7m9xJwWNVkEYkP7iuR2wotfCU7jkBVh1ZRr
15567	payment	1397	1397	1678	1	1	7557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4UryCoNVLVpCP42P5hN3gtEbK8f5Z6a3ZcngV13CFbnq9whS
15568	payment	1397	1397	1678	1	1	7558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLr9fBxVE9VjUxCpjMrt5dmwTdGVfushyrbJvh5pa8FcwveSp
15569	payment	1397	1397	1678	1	1	7559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxk4kUxy6NgAUqFuXwvQhvP4L3yRbCBbGdrCw8zJhyPkAvV19
15570	payment	1397	1397	1678	1	1	7560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxpjrRuLdxnFSkaR5DPKuyCyUwPoKwFvLzkQBiSHSvQDGqCwo
15571	payment	1726	1726	1874	1	1	5742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAK7bsPYy8TZP2r6x2LEEctifzgsCYNSxVDgeywGEx2HTCEFkg
15572	payment	1726	1726	1874	1	1	5743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxBmZ5KMN9HXdHWDxmEby6uTkccWeUnm2A8xXB6ZF9Rz2H2VB
15573	payment	1726	1726	1874	1	1	5744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vPkxhFAb6UjCM9LaecPWcwJGPzZ8nsCCpvsydzgkfq9RPH4m
15574	payment	1726	1726	1874	1	1	5745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsffXUmn1QKXYi7Nc5JdPW2vTTXFaddo7RAY45q8pMXyjX7DGo
15575	payment	1726	1726	1874	1	1	5746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8FVEMaiiQWqicEqXn5y6o3AEV2oMwHzcRh4iduMFdzBQQBG1
15576	payment	1726	1726	1874	1	1	5747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNmgwoab8aZQXKQCv6eTzBbtsK6X6T9xNb9k5VZ2ZiQoCDxdB
15577	payment	1726	1726	1874	1	1	5748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtoPTpQMSypafaqpKfV5QKRvpRKNExEFKPXxkzRXy7ZF6T4pjE
15625	payment	1679	1679	889	1	1	23	1190926465000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaF3uWkhiiv6mXjiRWofzCLEnBTwE6CQdFWGJy8uESPoaR3XmAE
15626	payment	1726	1726	1874	1	1	5775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXMDZ2hWb18DuVqaRoLaJshEJscNnWeqmAYSzQHdsMToC8pqM
15627	payment	1397	1397	1678	1	1	7577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTNzwBdarkVYUwfQBpEPDX4ktGyg34m37HVZpu2s2BYpRGQqc
15628	payment	1726	1726	1874	1	1	5776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVQ8hSKEyX1251gqR5pFzrwsp12vThubxyHv3MyLyZfqyn5u6
15641	payment	1397	1397	1678	1	1	7584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSmEZGP8btcvciskMRPogvFjhJ5FkSNYMMGJSs4GNo4eGTtK2
15642	payment	1726	1726	1874	1	1	5783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRvoyWoMsV7vVL2yrjWB7W1kDrC9Dzg9Ctm1iWp8SFLSGHyfS
15653	payment	1397	1397	1678	1	1	7590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbrNXdwSYU2sCLNg9ybVkqjvSxcAsJD1pK4o4BQPk1xArwP8G
15654	payment	1397	1397	1678	1	1	7591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVGrAn5WRfQVHkveZkDqfWkRP22TtpkhGs3Bu33a5tF3iiwJm
15655	payment	1726	1726	1874	1	1	5789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NP1tUN3y4m5EUsXhF3X8EYfVwCuXUepNrCBiXSkXc592G7pr
15656	payment	1726	1726	1874	1	1	5790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgyX4djfrWjwDWMcrRz8ovQ7kb4pC8K7Myk5qCwWt8sBV6W1i
15663	payment	1397	1397	1678	1	1	7594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrwwYq6XNtmzJkPyTXRTCWX87TyvaxHXCuQD1WeCziAArMwtF
15664	payment	1726	1726	1874	1	1	5795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXz46RQFz82kadHhw4i9nxFQeHZ35hfpwR8NDB6p442zwrwcU
15665	payment	1726	1726	1874	1	1	5796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmXR3Zc1ocVihjQxb5KMd61b1n32oVt7fzdA4jrhCbkgg3fWm
15666	payment	1726	1726	1874	1	1	5797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYdvWMUDYRYrYAPagnjfpHpGwHLWim1c9W7NCdrWVfzthttNG
15694	payment	1397	1397	1678	1	1	7601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctSR1vHyT8XNU4CoSdPdTrQjWEmxvsGf65auSbycms3SGDouL
15695	payment	1397	1397	1678	1	1	7602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYUBBgPqy5RVb3sT2xefWmr8ATp1V66qPsGbGBrQAyMJZDU1c
15696	payment	1726	1726	1874	1	1	5816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa435twQvLiFK2Dxe65vXRJy5fPDXtfHT5Ya1eeWE3LieR9fFr
15697	payment	1726	1726	1874	1	1	5817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmMQziPpJrqNQAGynEdxVmTWqQdvsPWGJsHofkVrGEx5qJN1u
15698	payment	1726	1726	1874	1	1	5818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyKA9BT6onjynKUh6swb4L8gpQxxyoZLuZ6aVUf7BHURCNo5E
15699	payment	1726	1726	1874	1	1	5819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZae2MbziAgaMVgZm84eZLYMUEPMkHRaiD7UPuK8BjEXEaJWohr
15553	payment	1397	1397	1678	1	1	7552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgoUsoWW8NXpeocWq7F3nhfK7bZfdFmcLwL8VxwoSTQMGobby
15554	payment	1726	1726	1874	1	1	5733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPTUj3XFeaE2gd3Nopg8hwWXDpP26DRqW5kd9brSStFcKS6Ng
15555	payment	1726	1726	1874	1	1	5734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVhC6LMJdMN6zQjhQMgVcJLRH3ebPxzzW5V5GWrkkwypD6sjR
15564	payment	1397	1397	1678	1	1	7556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMonGVEp1F76tzUZSYjH1M1T9qmeotkhjRiwUNaAYb1XdU2GA2
15565	payment	1726	1726	1874	1	1	5740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPng6GEYArDYWW3ffKNAzpJ7QQSTSjGdXXgmTh2rukwuLRMyqm
15566	payment	1726	1726	1874	1	1	5741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMt2RRLz978zG3Jk6fcs5E1fre2DtxBgGkbypyGcsx4VotHBWE
15605	payment	1397	1397	1678	1	1	7569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKP6S1eqBXuPt8h9EgQZtSQb4rYaW3Z3B4Cd5naoYKgVBQV7i
15606	payment	1726	1726	1874	1	1	5764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrndVhm1UV943Tujsjs6HNMk8WF5y7McT2qzMH2uNtfEYCRQX
15607	payment	1726	1726	1874	1	1	5765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrERCFr9rnVmsb564aB12sBPEj85vq4C984NP2sX8hkmU64jqq
15608	payment	1397	1397	1678	1	1	7570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwADUbEAt39pGDooxwrHiQfsdFDXYC7wMVZzgr5K4ERLeQ7kTp
15609	payment	1726	1726	1874	1	1	5766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMaPhmtNTKFXCSchsUDmrEHSdrzuoRq2qM3wXGvUVvu721uPi
15610	payment	1726	1726	1874	1	1	5767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBm9BGuM29vJfs4kbUUw4hwAh9WEauBsYpib62RtLxJ89vcBPi
15643	payment	1397	1397	1678	1	1	7585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnntStTzYVSEqP5n9bmjJL5JmvPSWnBb2Q17Wg2WVwzoPaxNh
15644	payment	1726	1726	1874	1	1	5784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqevQX7bWHtH6wnRRiUWVPDbS3tAfbHQeKmQpFpuHzmBBwD8ro
15676	payment	631	631	2099	1	1	1	718000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBXW3oCHySUF5x4ZHeHBWTPPrP7Lyc1wUFvbyrUf88mSv8mbF
15677	payment	1397	1397	1678	1	1	7597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KHiEx5JbtM75GiEfsi6WBzRpfD2Xxk92GRrJeH8cs1Arn8Zb
15678	payment	1397	1397	1678	1	1	7598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQeVFbpKHubyCzeC4SGMStLyhEHYcb5LLuekuBr9cZbsPEXbj
15679	payment	1726	1726	1874	1	1	5804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2NXuQ2psqiLWigNH1siBPA6qBC4dQGFhT5s637hAyn3xXjbk
15680	payment	1726	1726	1874	1	1	5805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzKJSZZd9hJWGSMdr12VTskYj3P3uhFwZREzLv52GLy3TumUc
15681	payment	1726	1726	1874	1	1	5806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQseW9sdHB6Jjppjz66onmtAhZB5EjZ6gSatZENQR93ASfcQhN
15682	payment	1726	1726	1874	1	1	5807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkkU9z25cfRuMnuEYvJ985262dwtCN7jtbJKWEupb7XM9G28M
15683	payment	1726	1726	1874	1	1	5808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4fakpGAcj3JAsJZDazAsmBcoyNoDhvRXZwRr6MJb8Ck5EsUw
15684	payment	1726	1726	1874	1	1	5809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7aCWPYXP5DsHFxQdaMg8Yru24sbis9GC7xYpDZSvDLjESpsi
15701	payment	1397	1397	1678	1	1	7603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeitdJ3N5Qh27vtqwYZDgjX6YhL3zPY8thJxgA64uCKGkG2KMo
15702	payment	1726	1726	1874	1	1	5821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurRicNVpCoe9QZpeRioiRenFsDcrVkrmnBZTov2otJBD5Cngv
15703	payment	1726	1726	1874	1	1	5822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBmsh3fZqEF4KWj6MfmCc6NWpwNkwGTUg2aXdrfpG3UXTcYzy
15704	payment	1726	1726	1874	1	1	5823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vtgMC1fGBqoZhAdZagfDjFxqHV59vPEJCTsMFw3ez8kwag9k
15705	payment	1397	1397	1678	1	1	7604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4D4fkBBWswpwyws6t6Hci8epVbwRErTJiDrY4Gf742zJcwvgR
15706	payment	1726	1726	1874	1	1	5824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDS2MyuSm64YJSH6JEHdFwKuH9nNP3Rx2mXqwHyHsHdaf6BwK
15707	payment	1726	1726	1874	1	1	5825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7DWB4rAPCWYLPREBTHkQBc6mEyjMrixSZEub3dnZmWUcxB95
15708	payment	1726	1726	1874	1	1	5826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYewZLWNpjNmEQof87bREBmeJYc2om67DsaxQymcZotKuKg7NZT
15709	payment	1397	1397	1678	1	1	7605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnEojKFUQgMgWEs4e6TBYCzy73n7qs3ucDUybbh9sENhHQB6L
15710	payment	1726	1726	1874	1	1	5827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRA4ynGQDrxG8PN3ucZFT1rYEyS46z4AQzCTcS4szqrk5CPYZj
15711	payment	1726	1726	1874	1	1	5828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCD5xjF9jH8LXYo4czmUfeudtrYCLD1jyhQPvbSsPky3xmDuAj
15712	payment	1726	1726	1874	1	1	5829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJ39pZUpUZ37wJzqAvH9pv4M31LnCtS89ustPyyo8hv5gPzVo
15722	payment	1397	1397	1678	1	1	7608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Lraj1dGUkPVnc647JWApwfu6y9fwWnQBD5xS5PzvGgCDidzg
15723	payment	1726	1726	1874	1	1	5836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8YygQ3tVzTpNQjgh4qHVhH2oYUTMqze9PxupYzYTvQ3f7sC43
15724	payment	1726	1726	1874	1	1	5837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26v6DVf2juRQwoNYLeMWYJv3aZrPcE654GdX3SAY5EHjnyree
15560	payment	1726	1726	1874	1	1	5737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfu38SNuqbgizwmKp7DnjiEzBUwsfMNykYPUJ33vt2y9K5eM4
15578	payment	1601	1601	1388	1	1	9	3752000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYQaXp2pp94YWyrFFGBArnw3rzrUoS1VYeA7nRP3Xpcmzg9BwA9
15579	payment	1397	1397	1678	1	1	7561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYd9P9y4KwGEHxcfPj7b7LUcBX1WjSRVqe7tGsArpmG445k3Pf
15580	payment	1397	1397	1678	1	1	7562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYzjymX7eRL2xunseztkcgqME2eQriXdECVC69kioBnwXopxB
15581	payment	1601	1601	1142	1	1	10	1996000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZtwn6QRJ4KSBKeZLvshDDf5ToTnHgvTTqSNUuKFCTUheJUerc1
15582	payment	1601	1601	1262	1	1	11	1346500000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZ46YRoaTvtvHzp2H93prJxAP4gv7nPz1Q5QJMkCJrUKcpKYitf
15583	payment	1601	1601	1022	1	1	12	1114000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZcZU77WcYK7Wa6dj6yE86ABhgj9KDqgchCwvTZBPDwzyNNPKwB
15584	payment	1397	1397	1678	1	1	7563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcdZQFmuskf47D7U44U6Q2i6cMcAX66a6syYNDwpsuqFitupm
15585	payment	1397	1397	1678	1	1	7564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZrB8fTwLtguPdE2hXKny2nN59vGcAhFxTvwPDi3o7NchpY8G
15586	payment	1726	1726	1874	1	1	5749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBEZWZ53LAkmGLbTYoK6WpxjDNnFY16NG7YbCT8kS3x1K46F7K
15587	payment	1726	1726	1874	1	1	5750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbQwsKw939F48r4qQgwghabVwAjGKraeeki3XF5KRcGaEACEk
15588	payment	1726	1726	1874	1	1	5751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRggvYr9GW5GdUh5tPwvqpiKCLYh1eh3SBL5xS5k8ekmQSPcKn
15589	payment	1726	1726	1874	1	1	5752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrKMF2KJ3L6y9rq4HGEWmVRrygyqZ4VmufjiacvngdHcwGKaf
15590	payment	1726	1726	1874	1	1	5753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbER2aeaXGoUEGg3ogkqRCcZqGjVC16RUX7BWsC4SJG4EYuszH
15591	payment	1726	1726	1874	1	1	5754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsm6jW8Juykno4q2X96knmVWygNBT7LNYGTdC5Rm9acCGzD9X
15592	payment	1726	1726	1874	1	1	5755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MNGXZ7R87eJ2f3XAmMwG2TsoffsfnW2pQK9A9kHXivxHS5YX
15593	payment	1726	1726	1874	1	1	5756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZci1JV96xiBHZeG51F9TBiCB85JFK2jVJK4dnLBnqPEPreP3oE
15594	payment	1397	1397	1678	1	1	7565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb6Xy43vCmJPE5rCZhjok4Cd5KsZjau2GnJsBW6fJGbpoxB9F
15595	payment	1726	1726	1874	1	1	5757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oYwamrAzdLN2Jx3SKfCUhQY83Y8ebnFYqknwfmtJH5dVf5x5
15596	payment	1726	1726	1874	1	1	5758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGEWCXpMJChDX6SwBoZywKPZ9RiGBpGtxCSw5RSRn6HgoMtB4
15602	payment	1397	1397	1678	1	1	7568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWS9iwx7MvneFUvWtzDUb8TTaVUkydA1Usa1mTAQKBKVcpapzK
15603	payment	1726	1726	1874	1	1	5762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb9tuVfK9KfhXsFnSoF61KvyGtSwr1fzJL7ioa5ocik8NQm6M
15604	payment	1726	1726	1874	1	1	5763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCurKjzPxvMWdTrfgi5BmS5zyozcTWzKdAzTpsvSgwnt7LMr8
15611	payment	1397	1397	1678	1	1	7571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3w9SkpfWTt6UTXVqXZwdeDT6Uz6ji3fjJFz5BxeaVCcQfL7x9
15612	payment	1726	1726	1874	1	1	5768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnE3aBagjyXAUf1LvGwxyE53uGar2kqH6kyq5ceWeG6Q55U2X
15613	payment	1726	1726	1874	1	1	5769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcjNe1tzqyrcA3AdtpN2M341zgZUqY2mYCQinb7tZghLCSuSQ
15614	payment	1397	1397	1678	1	1	7572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYED29hbFNanDgC2oaEJZ7aPH4D7DfggkmBcVE2kV6TaRf16pM
15615	payment	1726	1726	1874	1	1	5770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD69CuFQxXeGM9MMm9557WmkUgez22HEHAdxSCu9YLxHqqmHem
15616	payment	1397	1397	1678	1	1	7573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXqEUqjzmgGjSNfJQjm1idHPeKf4w6dLu1YrBMuyoLRaF6eak
15617	payment	1397	1397	1678	1	1	7574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQGJHGZc2eQHYZk6kgX67pZozVachwnBm3c29qgTGdBmjcjiY
15618	payment	1397	1397	1678	1	1	7575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27vbMXfbh6nS3UpxkT8B3VMe7cFNBzee9QJZF8txM1BNzDiYm
15619	payment	1679	1679	887	1	1	22	1418704594000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZkmAvvi8qakS6Dpcs8NcBMywCC33zzbJsSzgo7GbdN2GG9J3Z9
15620	payment	1726	1726	1874	1	1	5771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8d7x8tS3Gvd8NKjhUbHmL382kTU1ask7hwGGD4T2ctFBg8rb
15621	payment	1726	1726	1874	1	1	5772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEwE24AezLt9oAbMNHrVQmxme9FocEjtqTjnuhDG6BfJuwkeSh
15622	payment	1726	1726	1874	1	1	5773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVMAKrRY1fAYqRkmeFbuVWHPY5XVGFMohbrf4nf9bMuaw742U
15629	payment	1397	1397	1678	1	1	7578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8cQB3aUPSP6iDaGwxkj2KnAMrfWN3mN4FZQEPQZL5pN4J6PW
15630	payment	1397	1397	1678	1	1	7579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3myrxsca25BXNmfxTUpUGB7V1bHAdQfdVBR8FfSeQuCrj9cu
15631	payment	1726	1726	1874	1	1	5777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh4zVvrFyM74vVwyYykYoFrA61UFUjPmgntE3zpUL979NQk5Ac
15632	payment	1726	1726	1874	1	1	5778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo227X9xL2TEQ6s6T3Ewh18gxoJuME8dJSTsT7hZwNwubnyQM
15633	payment	1397	1397	1678	1	1	7580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUoePzhPpDSXcYqtn7gFw5S4kGgJcpHhd2Ar81ojaDoEZnWMN
15634	payment	1397	1397	1678	1	1	7581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKoj6hEgstYsq4By7eriAjpkYbk31zApVPX69UJwb3mQuTCuc
15635	payment	1397	1397	1678	1	1	7582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzxt2LgGw6Gs5uQhpSKAubQneifbZH3kgzE9LAwfuQHCrbRRE
15636	payment	1726	1726	1874	1	1	5779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK245gZB4fx5QjNS4o5d8uTpv7t3wgFeHENdaAFZLNkL76QMaw
15637	payment	1726	1726	1874	1	1	5780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpvfm3X1kMbK4GYbxtQEDx7F1XYGxjzz5QBqktzNSfbbq5MLM
15638	payment	1726	1726	1874	1	1	5781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSucpcXbhyo2Ppttswx7s4u6UipWvQr9V8PGoZSqS3i7s4Pphi
15645	payment	1397	1397	1678	1	1	7586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz88u3LJWSzQef7BiH17HZriw8ZqMWPQyvThV1VDxgphA5hGyt
15646	payment	1726	1726	1874	1	1	5785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkk3jTvGxqUi7NWwCnFHD5ns8CRFnQ8ysdEozhuJHfarugGK6g
15651	payment	1397	1397	1678	1	1	7589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk43R3WFyci4hjVacMnfsxSgnxudmuSDHcKpWD3kLPsiHnrsDR
15652	payment	1726	1726	1874	1	1	5788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5zXVb4Eua1jyDqtLFM5auUsDyRpjfDSczpK8NHUoTznix67Y
15659	payment	1397	1397	1678	1	1	7593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyELRNtCyGzMJYYt5gNZGgd9EcQwaHKRGJ8GT1m5kwCn97LoEp
15660	payment	1726	1726	1874	1	1	5792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeBX9pTcdswHyyCQtBQzZJrwGpFZvu9wuDs6H3B6MU4koDSnJ
15661	payment	1726	1726	1874	1	1	5793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHpoZ8U7QZ6jMRbzAQyfhY1J1KX1rWtHTCErhtmXFsJRg7ci9
15662	payment	1726	1726	1874	1	1	5794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZsLQzH8A8WHuX8vmvc4ZhhMMHQtQNo29UGseexjtTHbDN7bK
15667	payment	631	631	2099	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZds5S7iD6UByiyGj2NLpnj3wbShfA1G3kZT6Sz3dQTMJ15VK
15668	payment	1397	1397	1678	1	1	7595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDaQdR3HCwsAA2CLELS4aer3KS7FWuuE6PTEgeK8wZNtE4GaP
15669	payment	1397	1397	1678	1	1	7596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6fRJ41kAMdgjcHrwhq7V5nP3vofQVZA6sDzG6NdCGpm5KWKs
15670	payment	1726	1726	1874	1	1	5798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3CZM1PscpXXajCgwEFWbi7VMfK8WfNu1GubK3x16McpRBsLN
15671	payment	1726	1726	1874	1	1	5799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpdJwAzok95ZBp1dGDhbizu9Xts6cYkpiRppUxk7TxR93mLQ3
15672	payment	1726	1726	1874	1	1	5800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVz8UFXJAiqw2ryieawHQBAj3jSdFSKQKbnHabnrFmJQibwyN
15673	payment	1726	1726	1874	1	1	5801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9LkmJJ71J8ZbcdeBv6WAVWSHFyCCC8rLJBcPfGjxqRbWFxGE
15674	payment	1726	1726	1874	1	1	5802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6v3ckEzNaS7TgW7LxfBkXJcBhUhkXwat2mGpf77WFeq3A4VrR
15675	payment	1726	1726	1874	1	1	5803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3pGGM6RmgahuMAmgWW21tQ3ZkpaCTq8fLA6Fwa3e9bo5VbRG
15685	payment	1397	1397	1678	1	1	7599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKCtPcwwG6Ss6tuThWGLkxZpPWTSogCrANPJTzRbnqaLSUrKe
15686	payment	1397	1397	1678	1	1	7600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdnBgFz1GDQ6XpTZWWrXGgQ84rbsnqowmkUggvfB1ZvbmKDy5
15687	payment	1726	1726	1874	1	1	5810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWcBmS8hswnXvbNMSdz7L3ZmRC3FTmcEQ6BVPLxCyGJqF1Zxt
15688	payment	1726	1726	1874	1	1	5811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6i15HEuQjWDqcoSs7mFCTEFH1F4Pr2SfKcT1hPVHmbfJFyaFg
15689	payment	1726	1726	1874	1	1	5812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pZujE7f2RiP4pwNJXowMwwoUQUVpkpHdXnAvVgC7aJDP5Pza
15690	payment	1726	1726	1874	1	1	5813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbNNdEZyEovjHCWZGu64DAhiugjawfmLPKCZiEhTFgq1ZrX3b
15691	payment	1726	1726	1874	1	1	5814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SuArzo8hhjTwVRbLTN8LLMFBfNRURUsW7memv4zKESZnkcUU
15692	payment	1726	1726	1874	1	1	5815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNiWrCYvc7ZFVELYcsHmREfZTzk1kwHCsUb6VA9wWixxD6dpW
15693	delegation	2099	2099	631	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PHSemCutcY5jUkp81z52YbWwp8Ae7yBmdSiNQbaCeC6Skt1e
15713	payment	1397	1397	1678	1	1	7606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBmdSAzfCpFdgCGisVs2hjgYiuvneqRgw97hpAkXkbBZiQuTuu
15714	payment	1726	1726	1874	1	1	5830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgpGjcYVAi9CYBJBNsmnS1gYT33P9XTNFu5nAEhnRtJsADDgJ
15715	payment	1726	1726	1874	1	1	5831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zenNpQV6iFJpY6eWP6zP1eXe4aCpnzgJzALKXYrhPAKLhG5D
15716	payment	1726	1726	1874	1	1	5832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1sar6hAr3FXaJwZko1ymsr6zan1RKUD84P1gw92Q3pF6YqSS
15717	delegation	2099	2099	631	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTMFCv6V1sJtJDdKDqxEa4uD51TQCtVTMXd6nKQinWc2895VW
15658	payment	1726	1726	1874	1	1	5791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXYDvqA77egh8rnSZAFdw3HvZbbpNjvWWCQep7ApRUNb4BvG9
15745	payment	1397	1397	1678	1	1	7614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PjKzE2WdB6SgyBJa5uGXCbYvKeZP2BUh4ouqgrSfqn8b7Ejk
15746	payment	1397	1397	1678	1	1	7615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoLPFaF5V9KAXFafEYyxBHYvnAD1FEkUphQtSkyaDNffQqpqj
15747	payment	1397	1397	1678	1	1	7616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzNDPBT8XW9dTG1JKDBqLCBoKord9wc2wBqVsdYWqMJpP3HLp
15748	payment	1397	1397	1678	1	1	7617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfyVgZTKgWLQaUXR5sbC945GLjnGPGp9ivZYY5guwQuvPaGMKp
15749	payment	1397	1397	1678	1	1	7618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteihQTfk3NsFjEVS5eeYZgXyEFXNFhfLnFNKz73h5Mk2ULZWG
15750	payment	1726	1726	1874	1	1	5853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZFFt9zc1PpkK5ySY6RhW4qBMcgGiGLRES1TzKZpV2c91MD3E
15751	payment	1726	1726	1874	1	1	5854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf17XUPni7UpBsfDxbBTdeDs2Bd78hsdPBNB3BuA4TV8WsWGzH
15752	payment	1726	1726	1874	1	1	5855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy93e9NjQSDQzCDTVmtSgHdj6Nu1FwfFobuSzzw6AfnpHJFhJt
15753	payment	1726	1726	1874	1	1	5856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VRu7MTxhZm46RUfriN73yzG2vQe7LhX37hnnbCB3uYn87ry2
15754	payment	1726	1726	1874	1	1	5857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfefRvGC66JYXUzjotzDNnCqxx9fAr2e2MUjBHupE58u3UiXHs
15755	payment	1726	1726	1874	1	1	5858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4tVnV7t9iSwprzsQ8csyknHGpULoXP3a8AAma2NV1aQszFBg
15756	payment	1726	1726	1874	1	1	5859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1H1z1hd6nS4oa29AG2hDSdyNbBztjkPfdxB7jD3PSu3PJ1g7e
15757	payment	1726	1726	1874	1	1	5860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRX8zjjJBUqYTzYcVNKnvrdECzgfUEivJFpFkNJSt71DvgWqKe
15758	payment	1726	1726	1874	1	1	5861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTBSDA1WJnmkbPsQJZcrWPYX47PYBTrFSSgSr7eR2RZSmVZsJ
15759	payment	1726	1726	1874	1	1	5862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFSCHbWtojksqwTPmkyf6frMYdFi8rkRwCUcwwCXAuDoBRm8L
15760	payment	1726	1726	1874	1	1	5863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhu5EHnxhhmL7BdpaBKXTSwZkXEAa3oftxLK6Z4wSJrkwuNTg
15761	payment	1726	1726	1874	1	1	5864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuknrYVw24xaqo6diZGz8owXBE73BqRmFuD9BJxSr8Ewr1TfRC
15762	payment	1726	1726	1874	1	1	5865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcoScFbV7mfVEi3nFUrW5165umyjcagDDZrRuGziJuyGXifxjG
15763	payment	1726	1726	1874	1	1	5866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23mfGniaZGz1ASdZrp9UbVwL9hWkkHYwncxwuNz8Tvd2TiHtE
15764	payment	1726	1726	1874	1	1	5867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyVKgLkyJ73ant1cV2FweUn7NzxbutQGe5ozbtQ1jusbqFB7J
15769	payment	1397	1397	1678	1	1	7620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtFHgDcs6vQuRjq9mZ6VQBCeFy2e8GNxeDyztXu3AJeiNPwr8
15770	payment	1397	1397	1678	1	1	7621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcwKNZLKyXkNJWcAJaFgnuG2aUHk9XzickDxuqhA858JryHnNr
15771	payment	1726	1726	1874	1	1	5871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRT6KbetPkZUDa4tkhFVoYWukGR2xy7RUobfboPBnupamd1srK
15772	payment	1726	1726	1874	1	1	5872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJ9CHpgyewbCjir7uoRsFVKUpjSVyYrgqEnUjhj64BFQ6zVBT
15773	payment	1726	1726	1874	1	1	5873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFsFBpzwFNGmuw7J1FQUygCRt3qJqQVTVVLCpkYmMdkXwMaBg5
15774	payment	1726	1726	1874	1	1	5874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJY6HtLN3NoGaTD4hP825tPPtKz824hyYhkbNvsGQE9wTRMgq
15775	payment	1726	1726	1874	1	1	5875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDUjbcxxmKr8kn9MBssDCnt5ymyGs994Cs1Fi8xjN5Pmq9Y9e
15791	payment	1397	1397	1678	1	1	7625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVdtEQmPRkGNMz4iRvKgX1t8D1sRELqHjHaWZ7fxg52N8pcHL
15792	payment	1726	1726	1874	1	1	5888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfhpurs571C79TymAzj98kY3U7CQoRENHzccFQjNj1Dw8RVPY
15793	payment	1726	1726	1874	1	1	5889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZf4nyH8U99h7LuixTZYsFTKT3u8dcH93RbzG2Gdnq6oJjtWP
15794	payment	1726	1726	1874	1	1	5890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBPZ8qs53Wd36h4iW97NuNwT8U917ZaD2qERCQ8MRyrfW6NtU
15807	payment	1397	1397	1678	1	1	7629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytuo4N1Rbh6YizzY2BNhpJtdnehzdYGGCY1WS6pQxVfU7oJ1H
15808	payment	1726	1726	1874	1	1	5900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPziNdkhzx7TGytJ98bq4QVMRgEHHx8vDzbyraC8UaGPhuGr2
15809	payment	1726	1726	1874	1	1	5901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkZWtgWxD9J1WFwAMQpDZQgaw2jhM3GSAqsPnTYQwk1EcdSv2
15810	payment	1726	1726	1874	1	1	5902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBiHKrhxi4wkeBctUPVPAGN34M7pxeQAXHMCWMkNR8A4wUVZv
15811	payment	1397	1397	1678	1	1	7630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTArYromqB1he3N84xYVApUqxGHHiimCWKY3SuucRKuZ8ceRx
15812	payment	1726	1726	1874	1	1	5903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZC5ijCHhhMabfTbXCse9S72YtrUUCqNAkByZ3o6EAFSN7CE2h
15700	payment	1726	1726	1874	1	1	5820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Mpn3piYqjXd8LFfXdx6Y48avaU9cWWT4U2ZuMzqeup4j3iet
15741	payment	1397	1397	1678	1	1	7613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYERKoTeAm2YgnKP7XSCHXDWMGckpZzeFiuS1fqVVSAR9uW3S
15742	payment	1726	1726	1874	1	1	5850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXU9M4XYusRDQdFbyV5wtrb44CSBmycmhnhWkxDGPKVmENR4Ce
15743	payment	1726	1726	1874	1	1	5851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuNwBkVzgN3QKWfbtgotVKH8AeQYDq9QXqTN43LvH45CgE246
15744	payment	1726	1726	1874	1	1	5852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtxhGmYLRKhzfH7zaSvShugN89rLUTJgVgxa7H1mgESgVtToa
15765	payment	1397	1397	1678	1	1	7619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcWGQm74cymRPQeETkCKCJRKNAwvzzVsNcZimUezRGQBdG7VuC
15766	payment	1726	1726	1874	1	1	5868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckebRgbhUkEe6SEBuZnS25GmfewHoTwVozgtq2mNfzcU59TVe
15767	payment	1726	1726	1874	1	1	5869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5c7fKyKqbD5AjvBAqGoxNE9n6QbuRwiCjugFjAPyG25uEp7F
15768	payment	1726	1726	1874	1	1	5870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYucWo3NDBiusGWW6xUMMgWjJhUa2yhGWmTJqN3rwAEZTM9N2h
15787	payment	1397	1397	1678	1	1	7624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBX6PHcgZZzaRDN9W2P8psaqoaz8NMQfjBRmsVKt8awUatEgM
15788	payment	1726	1726	1874	1	1	5885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZFNM9hnJveXBM1rWB4cpeWof9jfPx15eA1QKiAkYubcqZApG
15789	payment	1726	1726	1874	1	1	5886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqBVLX3NauVw3QdordbCk3NiihyWJpwe3kpdSzxx29TXUJ9dK
15790	payment	1726	1726	1874	1	1	5887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWsQ7TQJiva9ipLUeesshPL3wvQztCEB6d4dZ2uYmBXG2RDc5
15815	payment	1397	1397	1678	1	1	7631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdwdkNQLGc2GD8pB8aHJK5RhdpZpNt8gKc15PG42UVcBVtjHt
15816	payment	1726	1726	1874	1	1	5906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqDxqJU7xqpmtPBK4xpu5MTp1BMMAuKUSTNMx7GfbSZxDzfKP
15817	payment	1726	1726	1874	1	1	5907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr6yKkMu97hapYVBqHPnXgcWxbB8WaRvQ8QTVnEeqbjreMrJ8h
15818	payment	1726	1726	1874	1	1	5908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9dkSQeDDKPFun7VmoygHscdj4MykAJiLBXH3g7cPnwWocvuD
15831	payment	1397	1397	1678	1	1	7635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe29en1eNoPYibixqVavhB3j4Qd8RDErixnZqmoXX47Zb5nDQs
15832	payment	1726	1726	1874	1	1	5918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvj8omdQmgUg7N3s5MPEeAHJNcvfLr4ortM1VkppzfN5TLoZzn
15833	payment	1726	1726	1874	1	1	5919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhS242BcLSyLJ2zztuHyCUxmoVDD45c46E8wUqfGZKFo2bAwX4
15834	payment	1726	1726	1874	1	1	5920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjdR7GY6DCtea91xeswXRFBMSAC69L71NaPHmtmehhFGvBX51
15852	payment	1726	1726	1874	1	1	5933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVmwTV7sSB7X4z25PH8TeBzGaWc27FNiFUq74b8o93LbjyLCQ
15853	payment	1726	1726	1874	1	1	5934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfG3iMCCLB2MdraSRwUwGNePn8rssoNGyxkf1LjG89rBu9trLW
15854	payment	1726	1726	1874	1	1	5935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7RXG6uD7R3jPB4U8jhiiS6wxB6vViZQ2pt3Muw9BszmY5Xpx
15923	payment	1397	1397	1678	1	1	7657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaghRYALpsRKNpnkzBZNQM1hsmAUY6SZFvrZBHBGtcTX6RMo3
15924	payment	1397	1397	1678	1	1	7658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyFNhFpPQmm9JWK3mRbQvLCCL575yZcsfP3LzQEMRnjSoQnc9
15925	payment	1726	1726	1874	1	1	5984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FzBrNvnBpNvCuHauPNr1QcDhUbfiSsiLXXv8o1uMeneFeoRU
15926	payment	1726	1726	1874	1	1	5985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNZGTNgvF4UjuGg9PXGH6NWbog8SbRs8JwsKQe8UoiYA3ahNt
15927	payment	1726	1726	1874	1	1	5986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eDEt8LTZzwFncogkTHu5xPATVp7nVZD2V69qPdRdTmGrtARa
15928	payment	1726	1726	1874	1	1	5987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2TdFpPxE4AyUW63YZLE5MEP4Pc1Uptw6VsgJtB7iMmLorAJP
15929	payment	1726	1726	1874	1	1	5988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23TpVCB2ugWdZ6jSUBC3h8fUgsmaikQ7DSrTZ74qVSK95b9tr
15930	payment	1726	1726	1874	1	1	5989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqSdCXg2Pok54ywzUtQTWxefxXpKHtjATaWBTm649w1FcBZAw
15952	payment	1397	1397	1678	1	1	7665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqrUA95LxsTvie5SQShLV6SonzQGNNr8ytkgkdCQLbjoafD7X
15953	payment	1726	1726	1874	1	1	6005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaVDbojjTeGE5LgVQn6GBdnmctCbBbc4qU7J6Nf8vKUBdixMn
15954	payment	1726	1726	1874	1	1	6006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdK5uMn3pgqfhr8Q1Z3znCuPqvsRzqyv9HsNUKyZusknwaHCjp
15955	payment	1726	1726	1874	1	1	6007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQCFgUEbMZ2bmXbqiFrf2NNwuS9UCUcPVkrNtHD9D2jLoUitE
15956	payment	1726	1726	1874	1	1	6008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQbQKVhVcnX1dLnQDFcRnJqVXLtdYzVzzfJLVTeguU7nqJts1
15957	payment	1726	1726	1874	1	1	6009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF8GE3R7ABeBRadqzDqaPtaKdVGGCaVWW5VQxuFKHs4okLzSee
15718	payment	1397	1397	1678	1	1	7607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdDFeRKdBseFTM1swvc42C8nuYazhfBEdFRR9te9nVRjXcLCv
15719	payment	1726	1726	1874	1	1	5833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZnUqQ9CzcEkKbxdmTW6MSPjxo5z6hRjZEzcpcsydM6rMHu2w
15720	payment	1726	1726	1874	1	1	5834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAoQ32hueVELi193jpbjbWhKZLZQ9TJEymLK4Nk4S6n2kqWyG
15721	payment	1726	1726	1874	1	1	5835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsVWqJSncPygExK9eZTc1LxUiF4NRCYhR8fZSvyehk9JarJSd
15734	payment	1397	1397	1678	1	1	7611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19w3FrCxAaKbJjnLTzvXSomh2jpfQPax88HteEidqnMpWeVqr
15735	payment	1726	1726	1874	1	1	5845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZkKgXenzsPMwJefRZqKxwqCDVYq4f8eAqCFQh17rshsXe6ko
15736	payment	1726	1726	1874	1	1	5846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1pBLqFSLbXDKmcgvXRNmzuhHK2bbQrcExi4yS4tET69iLhKt
15737	payment	1726	1726	1874	1	1	5847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mDrWZTc4wRqYn7Uwxu3KiV9gboTVzpBDPd2QLEL2WNkcDRne
15783	payment	1397	1397	1678	1	1	7623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY1ou2oGifCyLQatKw23Yr8sEGbQGwvNHL9bcbrNz9buvzgAZ
15784	payment	1726	1726	1874	1	1	5882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMg1nJEa3zRiyQQ4RaxM5DbqtHRQGQ6SrEHeQv4iruLxMBhXf
15785	payment	1726	1726	1874	1	1	5883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHwAeLhAUL24P6T1dMH5TT56XcjQGmeYAxHES6uVKGYhoYDUw
15786	payment	1726	1726	1874	1	1	5884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeoEkQGmQ256BeTNgVM34ciCoWqczEzGwFTEWDyrWz5WUDPhW
15795	payment	1397	1397	1678	1	1	7626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsH1beXU29BnYFvpPPt8Kvotd7tvp1YWzy5zfXcjUKyA2pV1Y
15796	payment	1397	1397	1678	1	1	7627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRsDJ2sSxx9BL5JQiRaWrQYo5B56sFELSxrt6Ak7So1WyMrRqM
15797	payment	1726	1726	1874	1	1	5891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaL99MuKoDZwkxfKxCE6489Qd1DiykjsNg6if2TWffbAk1MoYf
15798	payment	1726	1726	1874	1	1	5892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRggTbZe2qtrYYHUotbWrjtuFPBgCfvwi5XMDES7SpMqqZYJ2H
15799	payment	1726	1726	1874	1	1	5893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNtDXTzsaLf7DhFXVj5XfbdCGxV9Cvxh2rwPSigTi1HCTrpRV
15800	payment	1726	1726	1874	1	1	5894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVcPktiGms8eGsdX7uBDF2v8HrhUsGw7GDkQHGr5Rw7qRh9JP
15801	payment	1726	1726	1874	1	1	5895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxMfSwGNtLdbtenYoGZy5AZaQDcMq7dPWu3R9CgnSUjthaTTE
15802	payment	1726	1726	1874	1	1	5896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJeYpwPzpFYGdkhYhrnWFZPwxXg4ANipt6bGijqwxLDwd6z1U
15804	payment	1726	1726	1874	1	1	5897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPawGXUPHSVU3hzPRwvVcW5ZdYCymzgjDTtk9dGi9htcp4Ewqs
15805	payment	1726	1726	1874	1	1	5898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiu4w8iVs4vKDK5x2tjQycLBGCyxCvAhWnMzDSkYo4frgmxhh
15806	payment	1726	1726	1874	1	1	5899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeQahnCwPRjpmzUsU2Phygwee8ubHC4TKyAu7dKbwLz5JsjUx
15851	payment	1397	1397	1678	1	1	7640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3m49nnNCsFoo7Bw3QX56tJEdmSCrYcMFbaUSkki3eMxZZgkUX
15879	payment	1397	1397	1678	1	1	7647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTTjRMCzVFo2T6kJqHfhqURNeZ9mZZCu2FuDrsWPMFdiFUcu3
15880	payment	1726	1726	1874	1	1	5952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAy6P5Kbf5JoqLrCn5oD7qwU5LybvvUHDi4vYsW74J7L2HbFc
15881	payment	1726	1726	1874	1	1	5953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdM7eEgvfBn98ASQamWVREiaY8vqyrLeC3vR4atSftyrWQfZbj
15882	payment	1726	1726	1874	1	1	5954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyDYXqgaNWe9U87hLMydAStRqCJupbDXtLgKxNsAZxXi2EPnF
15902	payment	1397	1397	1678	1	1	7652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcpeV1d8soRdowZhRDMsXFSnYuG67qdesDGAGMnXMxx24w36A
15903	payment	1726	1726	1874	1	1	5969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2Ryp7CM9wNkBu17PZAeh6f7cXVA34kViJCmVwFD3HjeJUca1
15904	payment	1726	1726	1874	1	1	5970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GDvqhPstxLminu8ntC8dxq6kTYK6CqHxqbt7jmFX8zw1ahXu
15905	payment	1726	1726	1874	1	1	5971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQhHGwep6TKPtzQU5zrSqiUmTgiQQzYvtCWKNbmZjL87tiD68
15911	payment	1726	1726	1874	1	1	5975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfA9CHEsVzNE7txkxxqzbCJkptecbT84qY5kbiDqvwDLQ9sKQj
15938	payment	1397	1397	1678	1	1	7663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5Y1vii3Q3BpPZjU8HrpJx2wThCtwy3hi7z5hAg1bWmxfcWvd
15939	payment	1726	1726	1874	1	1	5993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDXuiEXJdutYRssFu2YXJFbESi3wRe25uQUKPVjgUJDnTxxj4
15940	payment	1726	1726	1874	1	1	5994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTw2AsUVJr8ZLbu7DHjDJmMcwM8qt1AbSezwErfF2tiCRD7pG
15941	payment	1726	1726	1874	1	1	5995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZde1KWZgSt7s2aFmsaQXicfqB7N43fe9qYZ3mAagjGbVAcdhAD
15942	payment	1726	1726	1874	1	1	5996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7VDeZ7fnGQUWpZHLH5uCDUAoorx3faskLQgnrWp8CALRoi2i
15725	payment	1726	1726	1874	1	1	5838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXSJtYYVYTzBFcjqpYb3yKP1Zv135kzLNSuBs6uApJowYQJcY
15726	payment	1397	1397	1678	1	1	7609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKW6L52BeMpR1eFRwMtsdpFCpkhNH1V2gqBDcbJ6iegABE7Sr
15727	payment	1726	1726	1874	1	1	5839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgjNuKZs3YuTy8pWR2LKJdKPZYA3cFZbju9b3VkN5XSCbDPC3
15728	payment	1726	1726	1874	1	1	5840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdZJ2fJqtswKuKCs8Kp8XJezQj7bk5UP28h7xkGVeXfvAfCgG
15729	payment	1726	1726	1874	1	1	5841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3EMQuC8PdgPw2R7oDVGFZg8pDRkbJiGfJLjtd8EFxW4Aje8f
15730	payment	1397	1397	1678	1	1	7610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdgZPKkVsLsHbuXDnFNWpR7eT2r9UkQnPLHtUiayvJaMUBAHE
15731	payment	1726	1726	1874	1	1	5842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RogbEDa66p6d1LBdjC4pS6xRbvzCmtT7T9df2LfUnm66quLy
15732	payment	1726	1726	1874	1	1	5843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5sJk45En21XYuSgJ79fAsMUvyP5kAaG8FwLjRe7HjXLSqng5
15733	payment	1726	1726	1874	1	1	5844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmqEmDdms2M6wrsjbBHVZgKZMCN13bXuBedtdQGHsxjHZCBJQ
15738	payment	1397	1397	1678	1	1	7612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9VpSydkn8a6jvwPuWZZz6x7VYxzxNmfT9Xcfd3txPTEzSNk9
15739	payment	1726	1726	1874	1	1	5848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrmhrfjmVpdXEw6QCNju177ry3sSWERA4S8XydTwKqM1jw2iP
15740	payment	1726	1726	1874	1	1	5849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eBjN1DXLiYNWYUNfKPBMychWmv9KdrWhZwCQ58xznzuWAvqs
15776	payment	1397	1397	1678	1	1	7622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZabtiCrPmZUhhGEBQfHNqfL9Y3a63WdNGaENkuaV12Wvnf3Q
15777	payment	1726	1726	1874	1	1	5876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVSMXz9iTZ7hyfjBEH3MDs8orwpPjeq1EF4hm3AfAxg2bYetu
15778	payment	1726	1726	1874	1	1	5877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxYYY7U1QFzVqy8iepvi9FwYzC9BHXZvxGt7vBgFfHY7CiMkd
15779	payment	1726	1726	1874	1	1	5878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7PyvNErpNNF6bpgbyTG3ASZgi5EV1NBUH9Gbiv6eq6tAWNVq
15780	payment	1726	1726	1874	1	1	5879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JjCwsyXkzeB3xvv7omDZKJtYc4XjfRHVPFiE7aLhGG8LH4xm
15781	payment	1726	1726	1874	1	1	5880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZ7EeVoD9shh7xc86Kh8mbm12TjqgqfWxN7J2cZigXWDLj4w3
15782	payment	1726	1726	1874	1	1	5881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7u9yaWdjnpoH9Rf7H72DTPz5xDVs59M39bKBchbHHr3ytAeB5
15803	payment	1397	1397	1678	1	1	7628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyfEX9LwUUEnXVd5oTKb7GBdz1qQ5aMf8f7psCYb99mbuXKjH
15828	payment	1726	1726	1874	1	1	5915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVxV8xwbYDNnkHiU3rQUGfdB9vzRVZdZj93PMMhaCWYoS5tJd
15829	payment	1726	1726	1874	1	1	5916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3Q76FGR4rpnKJWZRNi9f2nXJTfxU9Liafs9yiTfwNUT8c8Jc
15830	payment	1726	1726	1874	1	1	5917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRA5dyPoeHaye3qwW5KTsASDSEZfdiU1AGh89X5gRCeB8pwqR
15835	payment	1397	1397	1678	1	1	7636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXy2Xueqdd1esJdgVBw4zYSnmTD2K5j8JyxD94ybtakFfPb4s
15836	payment	1397	1397	1678	1	1	7637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7UGYVkFq7sm2zeVHkifoDzTcxc3kWpJkGyafBXqGoTP9hb5K
15837	payment	1397	1397	1678	1	1	7638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC9wAsTexCJQTUh4s5KEzNeyVjb9H4Rk3RpmiJBd7M91P4dnP
15838	payment	1397	1397	1678	1	1	7639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCw6Z5Zkv1ZuHSyMRQYasTc2LKtUfY9ZHgEBP3vMbkj8UtiPkb
15839	payment	1726	1726	1874	1	1	5921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFNQZCorrrqUJtPqgwiCbyaKqK4Vg26TPsmMxPRSJxZ4ydZ7H
15840	payment	1726	1726	1874	1	1	5922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykuLKNqyYT3La86GajLuzPwBBNBByCuz2igKbbhhxyinAijj6
15841	payment	1726	1726	1874	1	1	5923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiDJ9ZTAwDfUARSfLLYiitUcdLVGjUEEzGZi93WZKa44kAhJo
15842	payment	1726	1726	1874	1	1	5924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqbzbVZ5DGaXYzdsnCwDTWr7ZzwMDr1Qc3jDSYuucdYLvdUgz
15843	payment	1726	1726	1874	1	1	5925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pXPSTzFik2KbdENYuPo8bvJGtYYhZ5UfCmdwi7rGWd9LSpPh
15844	payment	1726	1726	1874	1	1	5926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2iNzduvpgP8yW2FFWSdLLpcwoPSmGkiEWjMoszb6nijXUguGn
15845	payment	1726	1726	1874	1	1	5927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuHvU21adQEWsekXEN2MdKNMwUnz8qNqL4wZZcHWCEE5LbpQr
15846	payment	1726	1726	1874	1	1	5928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZQE34faT3vSuTYcLq2682819TY7UDPYGohsg9D5xsSHwiQiS
15847	payment	1726	1726	1874	1	1	5929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQL9ckJWvHWD343Zn7ZpHoTxTLKNerjurYPBJHyJenZMJm181
15848	payment	1726	1726	1874	1	1	5930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnuPmdBgYpj7nYTKfAqrwHZxRTV4PqFXvNXCdFPtpgxyjWQrB
15849	payment	1726	1726	1874	1	1	5931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvjSFkosKg2VzZtJY1NJKGb1sTsVd89Dgqtn3Sw1ac9Etwsfh
15813	payment	1726	1726	1874	1	1	5904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRtZu7hcdpaRPNwZvFFPEBDuPh9weaETLYSumdhrHWE9TRpGn
15814	payment	1726	1726	1874	1	1	5905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaf5ihVppdWdSq9uFE3RPwBTXQ6M1CcpxtVAvF324RSFsuZx48
15819	payment	1397	1397	1678	1	1	7632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LUttCXjupEwyMWCCyFA2PNC1k6q1NkkZ2MDyTftJRZeT3siS
15820	payment	1397	1397	1678	1	1	7633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwD4rJkvCimz7ErqxuuHNpFMppEbLguSrz8C5gDUHz7mxk3Wmt
15821	payment	1726	1726	1874	1	1	5909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYyZgSsvxLWfAV6FDb4fCtivCDbYofEySa5BdqCCYPPb44QRy
15822	payment	1726	1726	1874	1	1	5910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJSSu9qNTzPoLXuPwP2Qete3LYyV6T9aVKC3N86bdq8e3zTgQ
15823	payment	1726	1726	1874	1	1	5911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLbviKYXYrN5LisQA3rrMrMXd3dRU8qsaQXTtxpwjCkpRcwUKi
15824	payment	1726	1726	1874	1	1	5912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7kMBoVcFtk7En1TjZSEajReUV2xZZu2dTMcBpQnEUBnwUJ5F
15825	payment	1726	1726	1874	1	1	5913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6kYAyZanVd6GKSp3RN9Bvbx9kEfaJ9kdq9ZJ7hq758rbmiYJ
15826	payment	1726	1726	1874	1	1	5914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbbzf6DxNrXaABLm6chkogRmDnDT7GH4JDAuD2vfNLNWEbqAA
15827	payment	1397	1397	1678	1	1	7634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwQrT9Z46UvHunSFhVW1toDBgL2VSv2DmisNSwx8ednG9Y7Jx
15861	payment	1397	1397	1678	1	1	7643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9Q66eFdERPKS2t2Y5pxs2fZ17Tvg8Zv52iAsp6NKf3UsFPpG
15862	payment	1591	1591	2100	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ki92FeC7JZeJ2miT5EBgxR7npqfHKp4DfZ5nPWqTDBnTZvBh
15863	payment	1726	1726	1874	1	1	5940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZHzUwszrxFDKxvGE4NoVt6L1FgG3C9CYjQoHUMUtkf9FSdq1
15864	payment	1726	1726	1874	1	1	5941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ6mTcSQVhqw6Q4UQfhBLNBS12cdRKrCGLrS5WanMaBs8eBDyd
15865	payment	1726	1726	1874	1	1	5942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ABbiV9a2NY21znZ243RjLvvemH8DyLZ44NRNvk7yqGfVfsUA
15883	payment	1397	1397	1678	1	1	7648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJ5WwqTHh1H5QxsWFdwany6RZQuMbXxWVBAVFbyHVxNFuoWyQ
15884	payment	1726	1726	1874	1	1	5955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQXwnwWnWVF8vfNX7a6wUVEw3ktfsYtuayujM7SqcDsRSmUFd
15885	payment	1591	1591	2100	1	1	1	717000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYno6kLTV7Xcs97XfHCoZxnWYiQo2LrNYYYtr3kh7mmsQwvurFT
15886	payment	1726	1726	1874	1	1	5956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKFRkXaEouSG9HBUNNsTHRd1yo1ZLkjEGa1t3nQT3H4T6Y6cv
15887	payment	1726	1726	1874	1	1	5957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgr2m7UCExnihNw245myVUyPXBPL2c5pUUmu2h2cSHcyWAzpe
15892	payment	1397	1397	1678	1	1	7650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTsvYLHPuEvfk9D9wLK1MG2YqByTH5iNrUsQ64Yt39wqv8GGgZ
15893	payment	1397	1397	1678	1	1	7651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYKuvNLVSRhRtnzHnBhCGZGxij3GNc68EcXkmhAMYEVswoHis
15894	payment	1726	1726	1874	1	1	5961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPM7nEa6ZQWokV7JT8vgtkrL9VQGZ8iZH4joPFkHXSsN8kKLnu
15895	payment	1726	1726	1874	1	1	5962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTu6YiJzAxpBatZYN2TrqLz3MDGFukLxNECS1oL5Y9Swsd1JVE
15896	payment	1726	1726	1874	1	1	5963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa13YhRF2FqqnZnehSQvJYb1PseBhWopybMTrB7R9CCc8gDQAC
15897	payment	1726	1726	2101	1	1	5964	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnfPK6EoQRpv8paWPw71Exb6Zdp6s5Fv2vphLgn9FWwNm7Ttk1
15898	payment	1726	1726	2102	1	1	5965	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoZRLDw2zx2ynZcrBsjPfdiZ4cuduUjp9JAtAwatW56Pe6m9Nx
15899	payment	1726	1726	1874	1	1	5966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTGjDuuszTWGb8N4hBps4P75XeQGS1V8wu5mnESAjJ4kesw6K
15900	payment	1726	1726	1874	1	1	5967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpa4CUh3BuHGERasvaBvqAi9spVj6RxoVpTXWmyjucsCpCpRCX
15901	payment	1726	1726	1874	1	1	5968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNfSUoJy4xk16zGep6tRP9oUrimeHXhv924WV3BcxhJ4i76jh
15912	payment	1397	1397	1678	1	1	7655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWgu69WDJUyetfKSYRdRZPRLWfcDZ8DzAD6kaibmHVATkexdx
15918	payment	1397	1397	1678	1	1	7656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTht4TC2aTd5SzCyyKsEHEuz5ZW3xsqt71pkuK1vDij7rUNwyZ
15919	delegation	2100	2100	1591	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdoXjSZGLvL3w8KFQ8Mgoi2piwQ1sPEVvqA4WtQgpyzoWAgAZ
15920	payment	1726	1726	1874	1	1	5981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALJRjcR4BeGBtkzLrU2upKPbDfpy4v8CAtCkXoXNCe5LpBKY5
15921	payment	1726	1726	1874	1	1	5982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8usHB6ubqTNQDKsJMN1nBg934CsUqdTENA4cFVRKNyih12Lc
15922	payment	1726	1726	1874	1	1	5983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAFuJ44ek39ZxRDfmy4ygyUG7WanTf4gAeUBtjyrzcH79FPTg
15931	payment	1397	1397	1678	1	1	7659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqt79gfLvp55mYQhtPUaJzjnmbjUvZh5bfWZux1zmj7hmoSTL
15850	payment	1726	1726	1874	1	1	5932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLZeBjoYgFvWd8rHSxN5YxAwsPZbdeMVLY3xk6C9j2tzPfucN
15855	payment	1397	1397	1678	1	1	7641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfbB6pbfNcLi5oaKuYxH6H9HJd2CxB5UsVjoCiEYDasAhjh4bL
15856	payment	1397	1397	1678	1	1	7642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nUNYVfxYPzPda18o5ABBKqSaAzRvmMD4p2HDjyZzjaz8wjBt
15857	payment	1726	1726	1874	1	1	5936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutpD4mmTpnucWaih8dWTxzHQMRG7WdjivmpAuEMWBe7vCspMA
15858	payment	1726	1726	1874	1	1	5937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGiNAZVomwitPD3fTuYvuZrkW6qpDK7Ljhnkv84PoQvhRUnG7
15859	payment	1726	1726	1874	1	1	5938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhzr1k1uYs9RQkFwT94xd2mUrGD7gfH4K2a5MgnheGuhQBbSi
15860	payment	1726	1726	1874	1	1	5939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndE8REvW864uMhqZ5DJZ26xvmLkNtfZvaSEVBhrxKmAuA2aGf
15866	payment	1397	1397	1678	1	1	7644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSW4Aaz9fDqwheLhPAqKsSLgmd7hFFXuFta1e5jhzhWsJCu3A
15867	payment	1397	1397	1678	1	1	7645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoySbHbs3mhEPe3Ran77tnp9LZ8po8ksbcB8R5rfY7o9J2Lvj
15868	payment	1726	1726	1874	1	1	5943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoozPCVkFVmUPXqEDQPzhjNcGNpSLqmoaSBALZrU8RfVSJRAea
15869	payment	1726	1726	1874	1	1	5944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWaCGiPUb7U9op5qYNYzu7unxZ2pcQSgDxjhGuHkJZRAxrhGJ
15870	payment	1726	1726	1874	1	1	5945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJG5SpZPksPzS2MCx4jpivCeTxRxDHX8kHgHc6FfABxWutjDMA
15871	payment	1726	1726	1874	1	1	5946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMKyUDxNGRfvhhwyp1fxdcyarcpMzm5Gzjtw51gV87GBEabyg
15872	payment	1726	1726	1874	1	1	5947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWBHE75bUsNME3jXF8VxQVyksj7X1Lpti6g2vTYg8puDYtZPa
15873	payment	1726	1726	1874	1	1	5948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGkMCG8rtsLVbqoHR2npPHsVza2EBNxsT9jCTv7TTAmH1BgP4
15874	payment	1397	1397	1678	1	1	7646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3w2LEG8HJsF1UUVaGP8iKcDBom7rPwbi8Sk7BTRHszjGWTXW
15875	payment	2100	2100	1591	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNYzqhdPHNp3955QpfizbxUA93jbPniCwhjWwKN82xgfMsZwk
15876	payment	1726	1726	1874	1	1	5949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gAMmRihQtYPCA7wfhF6ycVR2o2cWx5kFRxre6ikKajw4r6NA
15877	payment	1726	1726	1874	1	1	5950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMWiW3FwyRWMBE9mFqQtn5WX95xRDMSKCVUekp1v9zV5zEzUL
15878	payment	1726	1726	1874	1	1	5951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvPJSQ1CKyBrzhvUVVveWgKBaReFuxtsxSz2M9QSz6D6uxKas
15888	payment	1397	1397	1678	1	1	7649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RstaSXECrZPUqX4SLdasY7jiYWaUML8mDg5HZSGBwNHJwcvt
15889	payment	1726	1726	1874	1	1	5958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CQteTGk9cwPKNLfRTTvsk1ekR3J7rEZm3ovyytLTHfieaUCg
15890	payment	1726	1726	1874	1	1	5959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtcLDQw5oxqEjAW7JmHXn3GGqHJLn6psuWNBNswobUd5Fbexbg
15891	payment	1726	1726	1874	1	1	5960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbj1skqm7AEbv8BEHUgJHD1w2AK39BBzcqbY4khH4Jc8x1VfQk
15906	payment	1397	1397	1678	1	1	7653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYngeQ3kQXHj7iYKpdVggdPJYqHdcPh7uWKJSWA2KsK8ocagdW
15907	payment	1397	1397	1678	1	1	7654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJqVrG8TXuY7F2TNqSQvZoWJq3ckWK15tvpqMoXNCfti2aoUE
15908	payment	1726	1726	1874	1	1	5972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwxVXauvUXNejP3FZDPa2FAvqcEFXtz1Tcr3cdg5WaztL7myY
15909	payment	1726	1726	1874	1	1	5973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGK3ojWT6X8kmukXjtCUSYfUHcjgJsYEcYvdiM8fkAQGkS523i
15910	payment	1726	1726	1874	1	1	5974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2t6j2aUezWCqgqwagFH4jnYTorrth3Fx2q6nYKcSF2hhZTv3N
15913	payment	1726	1726	1874	1	1	5976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DTZuz4Gnzhej6FHrRRyYsviBZLdeNZjYCpbaXrt2MgdsJfaN
15914	payment	1726	1726	1874	1	1	5977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7qHEwj9PSfyYdjJE5SVyFffuomXwwFE4kWUm9MwCWHo6E4wy
15915	payment	1726	1726	1874	1	1	5978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6r156SNvjGpUy1ZgjetGEMNvWfSehDcoRSEk3cjeBh98XRY8w
15916	payment	1726	1726	1874	1	1	5979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUW8Z1vQmZy36zjak4AD3oWVV33HXBHZQoM4SoNSmfvPSUcFw
15917	payment	1726	1726	1874	1	1	5980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9MbZwH5Fgy5mYqo5A7W3ipruCYvmtgQzAdLAfStGXcH7fy2wP
15935	payment	1397	1397	1678	1	1	7660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKWyfwFzZHJBGMnQoyvVCqTTGZq9c1QnCRx2ZaX2Jh3M9cxbp
15936	payment	1397	1397	1678	1	1	7661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YX7MuQZu1ZvmxVgDuxkvUvQpUz7mkuvnCsz4vfzjoYFvpUWd
15937	payment	1397	1397	1678	1	1	7662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnp3TktUb4hBMjs8UpvPGMRUgbXvtmruXi1DKsJrrNc9LyftdB
15966	payment	1397	1397	1678	1	1	7668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46cy6DwrufjjxqE8HJGH92vG571SpY6DkkCMrXxfYYfMrhoaw
15932	payment	1726	1726	1874	1	1	5990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6QGrfm7aoMyFrYCXX8DFx5FY5XM2EQyWumTW88XaZudGLHCnL
15933	payment	1726	1726	1874	1	1	5991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ5wyfDXi87efXygx8e6MLCUdpixSv8vuQaBKenDZngfc3t3B
15934	payment	1726	1726	1874	1	1	5992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Qg4Dd4MATLaGmPGqKqgpPReQesZx8vWATP6bWiQk1vyXghqS
15959	payment	1397	1397	1678	1	1	7666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTiUs1XCVyeMazyvvTevdECFEegF86d8Ls63zsnoBwZJTt8DW
15960	payment	1397	1397	1678	1	1	7667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQxmRG6tLrQCk1fcoWnaiYC6zmh75jKLvJvUZyL9gJfZz5cjC
15961	payment	1726	1726	1874	1	1	6011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCA22yAaF6ERxLK239ewbv47vwZ8s1ZdiAGri3hXAgsWd5CRW
15962	payment	1726	1726	1874	1	1	6012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGW4v98M1mowRZRY5vDmnswbXJHLxumW5kBY6AzpEpjn77qyo
15963	payment	1726	1726	1874	1	1	6013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTX8PvevvFLXCqducLyphgwetzifcDrJfo3vBNhYKNy58mXVJG
15964	payment	1726	1726	1874	1	1	6014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFKH5xYChqeQnLUrcXjDqrkiTWEGwDCJ28GHh5jYCJFagPSD1
15965	payment	1726	1726	1874	1	1	6015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRzGRDJ4zMnzoRmqVsvUon4NqryABtyUZrKgTPcvDpP5fxnff
16023	payment	1726	1726	1874	1	1	6058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eu5PXg1AnUxV2bD8AqtqP5TH3UKxJiPzDFykJrnfK1rjd5G4
16024	payment	1726	1726	1874	1	1	6059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqpew8k9Ez26oEhCLeEwRmPiWFCed1Heij6w5puUmnzbjautZ
16061	payment	1397	1397	1678	1	1	7692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibvJQf8KhLpLRWLVTwJPbhnRxziY8MXhJiyMFHpkTAGUSNvmq
16077	payment	1397	1397	1678	1	1	7696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmJMbt2FNN8ZCSGo3ZgL2f1XozwGTZSBGTB8asQoPjCvhtjcN
16078	payment	1726	1726	1874	1	1	6099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1MCkscd1WTbPkgDbjx1DGQQmYgD5T6qeNg2GuUvpoRxvWxNs
16079	payment	1726	1726	1874	1	1	6100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9rfe3QSNkhHb9QwSvCsUbSzaNkmsUqorfQnqisTSWwBD1xze
16080	payment	1726	1726	1874	1	1	6101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxS1WTeNthGrMxkDkk8Bp1BeTQ82gpCAcZ1q89q2A6ZdowZyuN
16089	payment	1397	1397	1678	1	1	7699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5dNi6VFycQzTfJbHFSrQcQeSwfAa5yZ2Hf8CxNpmCJRgN1Dm
16090	payment	1726	1726	1874	1	1	6108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJbnPKHbLvLyq6CGiMeJv4xQkyFAAhMoMf5Zjo1T7yE9K5Ece
16091	payment	1726	1726	1874	1	1	6109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdTvwtwSUp7eEwGmfPGa6egV2gye5oUjs3tCV7iyAPZZBfuSy
16092	payment	1726	1726	1874	1	1	6110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3fpe1ri5qRrQddN1AU4sAJVoy3dZZZuF3qrQUvhJAyLhy8i9
16093	payment	1397	1397	1678	1	1	7700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiBb94niiPnMXYzxz6RmPz7uUNPa8978xVjY1W19wQcoNoZ57
16094	payment	1726	1726	1874	1	1	6111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pMgz2r7zxpiz8mbyzyS4kNG1JrzCrw7dzH9bvAEA4XqipGaA
16095	payment	1726	1726	1874	1	1	6112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EfU1oMWbRoNLekDe3gqVLkqguDTPFTmhGWggKvaXGiY5GAuc
16096	payment	1726	1726	1874	1	1	6113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Xtskmd1AuoS5En3fHrzAwatJtizL4FbdKwqaaY1tQEafmzdZ
16116	payment	1397	1397	1678	1	1	7705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACsmW7CUXrxgGU19JVCBMR3LkvYW2Wd2w2o114huZNvnC3uAH
16117	payment	1726	1726	1874	1	1	6129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQ1qYjmsWw3dXKtuPoDDT8hao7rxgLRYM6QyojkfhLpYNtoWs
16118	payment	1726	1726	1874	1	1	6130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gwogfkqvhcKFWgch6HqeMRS57yXfXwokCbmoyPoZLhXkNwEo
16119	payment	1726	1726	1874	1	1	6131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQzz3kp1vmuKJWCK6PU3RkW9tJpgDoGMao1sQKsjriHvZxvQE
16140	payment	1397	1397	1678	1	1	7711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwb49TCv83LgU9XXbUzUQr4N4GqaNer7pqikiNyPVFEbf8RS1z
16141	payment	1397	1397	1678	1	1	7712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1phS5tc5yvym4e9L92gkbVm9PAq3GgAr1hvpktp4npFBkSoMU
16142	payment	1726	1726	1874	1	1	6146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjS7gZmTpGtYARNq4KRkYLWRKK8Uxzp4b53wwoY1KUB4KhrrA
16143	payment	1726	1726	1874	1	1	6147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuoLQYsKrFU9vuiqpfNrHqERHJWo1sBDahM9ArVb72TZ3Aumc
16144	payment	1726	1726	1874	1	1	6148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1FPnn3KRnQKcE5fHsMmnHMFu1abqmbtQ4YRDfrLhT2XzDFtX
16145	payment	1726	1726	1874	1	1	6149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCM3HbwhhCPuxm8CXMgZfB7aXy6jhqXKN3WSEP7w1XzNkgeobc
16146	payment	1726	1726	1874	1	1	6150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiN266SNjphYxSUTrfA9a7hgn85FHGqiA9wTGwNxDnJfkpoKz
16147	payment	1726	1726	1874	1	1	6151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1oruB7m7CQ3YPCEaGXDovK2va2gY9qoh5xEzw86XEM4fyT4P
16164	payment	1397	1397	1678	1	1	7717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZuwMF6x3cXEnBu1o6521sNyVAs8USrHS55tqzYb3dbnKcMCS
15943	payment	1726	1726	1874	1	1	5997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8PQGDANU1NAmvo7YqKZUgjwXDA166Dh7by1S9AaRmAVzMTb7
15944	payment	1726	1726	1874	1	1	5998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQbeNbkNT3hEh9LCMKDV1GBKNg3vT39sUgqgrA88xTUn66u5U
15945	payment	1726	1726	1874	1	1	5999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufLNqM87f5jJJ3j7GQvBsds7VLFPBUtirXAyjFimqcRxQZYvU
15946	payment	1726	1726	1874	1	1	6000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb99zodFQsFPckB3PTbjXjiTJww9eFQNvj2Wn2Z2UzZ1Mvjs7f
15947	payment	1726	1726	1874	1	1	6001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdXDCn3X5vXFQkHWXi57vLRYtaRoSqRM2CqovZpH28cpYKrar
15948	payment	1726	1726	1874	1	1	6002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyUxAS51Fmac1sEdycsTxbJd243wvhqVnTbxzXuEHZMTMMGZE
15949	payment	1726	1726	1874	1	1	6003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDfsoYp2Bab1CSydV1YgPsiuSuYWxa1eeDSmmjhrPdAMfteEv
15950	payment	1726	1726	1874	1	1	6004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUmutjrtLgtyp9gyuQBZVjvBY1XPdN3DhhFDKfDL9gpyPY7mt
15951	payment	1397	1397	1678	1	1	7664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8z4kaqYZetCmNYsFNHxMjPnX1KSzCW8ix5oTeY62HdFy582yo
15994	payment	1397	1397	1678	1	1	7675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9iF8T8HuwEhUM4qHBBGcFBLCJY8VzA6ogGjCqyETeF4JiKiV
15995	payment	1397	1397	1678	1	1	7676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAMbxaCUcRutYr86n1Htm4GkyiGXdXVV8caQVKpszdM6Rrcrf
15996	payment	1397	1397	1678	1	1	7677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2NuDrtkGu8ke6Kc5VKdGQqp8YMfWRuWnFoswBhBDBpjA4n6v
15997	payment	1397	1397	1678	1	1	7678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7mo58esgH5PDhchq1e66YkwkatvFipn8NwLDPKBcYQMeps7K
15998	payment	1397	1397	1678	1	1	7679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRywu1PgugQ1HPx7vf9X6qR8Sqng19sMgTmNY4GGSJpfZdnQw
15999	payment	1397	1397	1678	1	1	7680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixDX9gTBQeXLCBZqGMUQjVW9kFbVoiMXsfSH34jcbXo6bj635
16000	payment	1726	1726	1874	1	1	6037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDxLgZcxQ5VBfJ53T2KpJDcrg7apwxM1i6cmFLYAiw4kXouZL
16001	payment	1726	1726	1874	1	1	6038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGjrZ1192sNryBEACg6PyVnwj7QWzk95CrtvkdKMDpX4kd9qg
16002	payment	1726	1726	1874	1	1	6039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL16VZDq9aTjSzbXE8mM58AUWKFCY1vt5u7R8tPJh3kg3i6Com
16003	payment	1726	1726	1874	1	1	6040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzsthe8HJgXMhd7BcunuhfBX8AY5fAnB6TVDi3kvtQk9SBv8bt
16004	payment	1726	1726	1874	1	1	6041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNYPEuqLPETB3uBwAJkGpYAtkXgY8HpY9FYqovPktWG89SBro
16005	payment	1726	1726	1874	1	1	6042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWgnZG5ztJhEAX5dpbBkkU1ZzqVxiSRnfGJDLG4yFPnZkfB1z
16006	payment	1726	1726	1874	1	1	6043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yEWk4AxQZYVgSwBe91cBSdVTpX4Z9cys74dra4u9r4y9Kiyv
16007	payment	1726	1726	1874	1	1	6044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxAuK3wsiDYq1waUjdTDXsm4xbXS8EcFcPhfS7t8uXw1eLGCi
16008	payment	1726	1726	1874	1	1	6045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ocHmmfRYLqyiNQxLeQuNQWpB1eqxydh4FG4HLF4BFZeSTZoj
16009	payment	1726	1726	1874	1	1	6046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzDLu5Gvjjhc4qiPniYm7bGxiPzU78m7nVhH1s4NWXy5Khxie
16010	payment	1726	1726	1874	1	1	6047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJCxf94cQ6rnZ6AiGFr84DhQFMLFwkAF8NDf9oS7DvLs7MU2d
16011	payment	1726	1726	1874	1	1	6048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9GE7ZGxQagnp4tPZ24yRniCAuQtrgdysXEFCgqMAnCmyQJCY
16012	payment	1726	1726	1874	1	1	6049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeXtPyR1xMWR6vbcYPtDGtyEVcne3ayNxQveQw2HwUvW99vPC
16013	payment	1726	1726	1874	1	1	6050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AQohVyoJ7Q6XYJPYwmpB1aChnDykHUgt6BNYMZjbdNfre5ae
16014	payment	1726	1726	1874	1	1	6051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCbctUk1BvVcmxQL1R7NZLS4sxJ7MLrEYSbiGxUaUghkWpFGu
16015	payment	1726	1726	1874	1	1	6052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ax1KWWGHWcxQHRMg1TU4qgb75Nzbouwf78zg3fbq3ZnQvfY1
16016	payment	1726	1726	1874	1	1	6053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKhu3MTJE8BXgtpDVJuqfJEYhXt5rw6CsaPgRVaYjbMkL3sZy
16017	payment	1726	1726	1874	1	1	6054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshSZ5yKp2BdEtEUeJ6XpXTngmCn7EXEk7zQGprsyPGR4nCKUp
16025	payment	1397	1397	1678	1	1	7683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWJz71L8Q51qejmPve9sJprYTx8HRySFgJb2dGo8yjywKc9qr
16026	payment	1397	1397	1678	1	1	7684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ9wPQT9PQwA5XSavqEMi7zuPUpMTdaz4D3gQrvPnGWvTT2EG
16027	payment	1726	1726	1874	1	1	6060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNM7J5yZE1VkTWAD3HvZqfAfzVuCGL1Arhwh6KmFBEVm7bmBr
16028	payment	1726	1726	1874	1	1	6061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJ28kBhR4yWScRkMZk5abcR9We84YeHG5neZKRTwYWbPdi4yG
16029	payment	1726	1726	1874	1	1	6062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpAbJrPwbGABXRpPUtCNpjjFfW8HBCNRCRwC13x78h1uP5M4P
15958	payment	1726	1726	1874	1	1	6010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc45U4C42chBWoBf3x98EwYP6G2W2QZbNhQq4WfhxpjZTzwxEu
16022	payment	1397	1397	1678	1	1	7682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTszpfSdLsQ9wnZGk3YnkiivTRythqzwNcLmDYeGwLsu9oiTTU
16033	payment	1397	1397	1678	1	1	7685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzRfoZteMJCXpUKTPMYQNhFhy9eviwJNdkGDsp9dkDyXkKaQ7
16034	payment	1397	1397	1678	1	1	7686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCMqHsstB1Ega5z1ZmTRzEQdq6jnb99yvQqvZ33nr1uHkvrNq
16035	payment	1726	1726	1874	1	1	6066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUdmk51HKyyd3P5jcpfA61F1f4BtvqSytZn9HYdntWbgdAfQ3
16036	payment	1726	1726	1874	1	1	6067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwegvnU8BHZJNTChd4fW9qrg5TubYH4JbBy3RsMt87izFt2FJM
16037	payment	1726	1726	1874	1	1	6068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QbJYdqt2rwAfLZqyiPoE2qK4bWcgTPwWwgkbXCYjYTLv59H6
16038	payment	1726	1726	1874	1	1	6069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxVYxCEbQjkkrUCJQBBEfHx4zLmSR2muXgrKWRv6tP7Siqy9K
16039	payment	1726	1726	1874	1	1	6070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD7SNjxzRUb9JDGst6ba7dhGqA5CdJUKBURrWXCTWpTz1WSEiB
16040	payment	1726	1726	1874	1	1	6071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnccQtocJjF2i7R4drdGqtLggQCnUmfnJnePj6QX2q86WRgf4
16058	payment	1726	1726	1874	1	1	6084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoeyQrB63iGKQ4b1U29YzMhc3gS7U1ajKVdBE1KfirGgmj2av
16059	payment	1726	1726	1874	1	1	6085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCtBXUFS9f2UcaQ9MG8otCH7JdQPsAd8hYVXpSnC1CR9eko9M
16060	payment	1726	1726	1874	1	1	6086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kmNJLcAVjUFqhYqtdDfxVsJvDS6qyJjM5KFnoByNearRtXxE
16065	payment	1397	1397	1678	1	1	7693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzzPWtLnwvXrPBU2BTQswAypsc2KpRDyDdhgoyVibQMhGd2gX
16066	payment	1726	1726	1874	1	1	6090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBTqhnyxTetqFtMNPccGK7qGU6erMRjfjfT3EWvrCUmrBkrsP
16067	payment	1726	1726	1874	1	1	6091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJyQSSVcvwB8f98UzS1uv8mxm5pdGZb7ujHCRk6ZU8PKwstuC
16068	payment	1726	1726	1874	1	1	6092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyDJz1y1DZ18RogUKgKLfVzhTLekmHSX2CX5E4hUQqzWxmgb3
16085	payment	1397	1397	1678	1	1	7698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpW6bfMiHHfquuVMYoLJAs7nW6QGBqMGi6iGYfLU6rcDZpW4Vm
16086	payment	1726	1726	1874	1	1	6105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDAREu8rxVpmwJguPzf1V7rGCiBmtJKm3cPLUHQaTgMjUC1Kh
16087	payment	1726	1726	1874	1	1	6106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWtzsPNyJAmcXmYCuohLiVhoP1XyQ9RQydGP9WwoeWQqqAn2j
16088	payment	1726	1726	1874	1	1	6107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmJJeazskmzxhAXFrx978MWnjYzvjedVejuubDrU7UtYCapic
16108	payment	1397	1397	1678	1	1	7703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtjoWiGuE7ubTgpPcdRSqrtr999F4Fx3iPxAUQnAaxYVrjZxd
16109	payment	1397	1397	1678	1	1	7704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkevzCNLtTCeSt7EVJxYYwp7N5CKRV926Ak6wcdwzJTNQ535tY
16110	payment	1726	1726	1874	1	1	6123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRayPaCmmKhPgqdFT4qgvNyun9euyg1oeA1CDduH7i1NYViSoG
16111	payment	1726	1726	1874	1	1	6124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBYnVtwhxMAMeQh7KWQpyAfMXLKr5VvosKMSwp75odYWg1wyR
16112	payment	1726	1726	1874	1	1	6125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNJn3dPXccs2ywZUPcszcFNbsMUVHbgjFUy8yPSN2rfMTqoGX
16113	payment	1726	1726	1874	1	1	6126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5TPi6fxRFDMT5ECFVCjKVssbxcMXC1umCSC9MXwKT3gvBs8N
16114	payment	1726	1726	1874	1	1	6127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaG2dyqrJvTKo3g9AsvH3sQRBNqQPjMwYRChgF2znds6switJ
16115	payment	1726	1726	1874	1	1	6128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YkBoRAjAr2uiMRG7zN6ASmBiNVukt7ow2XLZisGqe6QzDPUF
16148	payment	1397	1397	1678	1	1	7713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkLobeXoDDHPpBLfKCmQmiFZXrzbCs5zGJ3QjVHuVhoLKAPGD
16149	payment	1397	1397	1678	1	1	7714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxP9RzUTRdLaiHuWsmHRA7kT4KnxHNFpXS8D3qQTRHhBA43rU
16150	payment	1726	1726	1874	1	1	6152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4iMNgAUhZASuJY19DJiea1upVdXsJXEzb7V51wGkJMM7cJLx
16151	payment	1726	1726	1874	1	1	6153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm23BffrTWJaX5BZYtvrhdPdUC1tkDb6U456miS2FhRYE9LPQm
16152	payment	1726	1726	1874	1	1	6154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvQdohsNoi2nJ5DfdNpdGGEEw75r66vEjFEHzeodNqUjnMea8
16153	payment	1726	1726	1874	1	1	6155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmbYu7Wg33yCFvFrNteMUdNaMPfKPWc1SZdccRjK8cjYxprRg
16154	payment	1726	1726	1874	1	1	6156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCkbXYfGqSTFLCcBLrUPF4AyqFqq6CXw4XZKHFvQjxfhBbqLm
16155	payment	1726	1726	1874	1	1	6157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDtmBgBRJSxrto8ZKNtnhEwHpgQcmmvKmZhV7kXkxrrfFghbb
16243	payment	1726	1726	1874	1	1	6222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEJdzVbjf78ysAgrSahdNFPTQXTHaQDmRr4JM7AdrrSDTKXM2
15967	payment	1397	1397	1678	1	1	7669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGu4iB2scAaXD7cSuus7zQ76GESgqNEDDJ2mjZYatZLWNPcs2
15968	payment	1397	1397	1678	1	1	7670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwms6TddSkMywDjZHynJ74CRjPd1cfNpd57XDPRqtToaNNiRaL
15969	payment	1726	1726	1874	1	1	6016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oJ8ykq9nKEpeAWdgGB4VWBvPJm3KbNaDo8QnBMtPk2zUsEac
15970	payment	1726	1726	1874	1	1	6017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43ZQzzM5L4VVnTX5B2untaQt1CxewVVHbHMchBhja451BVeG6
15971	payment	1726	1726	1874	1	1	6018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnZRZoDSGu9fzE7hsgn6HhutBhwGS6qwsyKHEnafdpg88sqcm
15972	payment	1726	1726	1874	1	1	6019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GFZ4cgLQHdVodrbA3XM2LqHXt4PpPuq8w3qL6R6Vc8RinQzz
15973	payment	1726	1726	1874	1	1	6020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRPML9teDZxZuXWCKDjCA45hhURMcK8EeCHjK4kpG6BqHh3oT
15974	payment	1726	1726	1874	1	1	6021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHFHk32oHDaYRJPZnPtqKF2TxP6iosbAVAnZvxyJkpW7EqxQc
15975	payment	1726	1726	1874	1	1	6022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwyHw2L8Y84eULoZgpc9Vmun7xFR1bZdhKwfEajudMMW8L9Xq
15976	payment	1726	1726	1874	1	1	6023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZnGcxzx6tFGGbdWW8f9HfKGgdTAp27y9xzU2fMX78VH7uJnV
15977	payment	1726	1726	1874	1	1	6024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYta5H1zh9vQ7jZg5XXSJfAGBUB8kXt5orJ5CYUutrESwzvLNmK
15978	payment	1397	1397	1678	1	1	7671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ8i1oFS37eUBHUKKFSWu3D5zmEycWT8Ew7QDhQ7G5ggqNN9n
15979	payment	1397	1397	1678	1	1	7672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p5rZXmTKaz9o9QCXqfDzAdrtzvwon9NepVyUbf8cwDZ2xms9
15980	payment	1397	1397	1678	1	1	7673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuXN9ZBz6hfe8U6YB9KAEDKvGRvyPuz7bmhSY4k7MYSTEqAUG
15981	payment	1397	1397	1678	1	1	7674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTdQx9T66UjuoXTuDpo9YqQLTWrmJ1bzQBu4LB65V2UAhnfoA
15982	payment	1726	1726	1874	1	1	6025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWTkZqfMmajsZVPqFNVBJZHttYmm7VExVJvk4CWMA2UE1h7TDd
15983	payment	1726	1726	1874	1	1	6026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumz3gh3MMx3EbNqqSEVwMUjMbbL2W9mGufhTyfr3CNBDGsXBk
15984	payment	1726	1726	1874	1	1	6027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngQsvje1eE9U7cxNARcWG4LVNLS511HMZ6ZgXF7pQXTLR36Wt
15985	payment	1726	1726	1874	1	1	6028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDt2ehVetcc4oRafX19DgCatbwxCqyz7D57qj13FnfACVFPauu
15986	payment	1726	1726	1874	1	1	6029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2mpoTqU7ArqpWXG46pKYMB88jwyg4wiPjLB4MdpWpSnst4xf
15987	payment	1726	1726	1874	1	1	6030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2ybxjZAfyU8B2uB9V8apowdDHMHwCfm2KLVzTcFTNS3a5ZGx
15988	payment	1726	1726	1874	1	1	6031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaUvsTMB1j1zet5vLAXnG9eSSyDnhAs5NtYRAEAV4weT43mpP
15989	payment	1726	1726	1874	1	1	6032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPvoZGbbVcUgAk2W2GrtZr2jA8E6STePyVYQcQCjrbNBS5ab3
15990	payment	1726	1726	1874	1	1	6033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6dhQqd1vrXufcMJQBExwCrwxDVqc76XXQbAeML2JiLWrLXJg
15991	payment	1726	1726	1874	1	1	6034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXkE5ovJjnzPvbdf1CC4v2AyZbd2YP3LCdWubAH39ALAUwuAA
15992	payment	1726	1726	1874	1	1	6035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhfrVHy8MK9tqNhBEqKUBdFS67MWtrRykhqKHcmCuS9PJFvyq
15993	payment	1726	1726	1874	1	1	6036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9nmDj8W7QUE62YrnK9SdvHAdKzCVTQ4tsCvkNcB4FyUDPQU6
16018	payment	1397	1397	1678	1	1	7681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ayBVLUmTRqsDGWdHXew8ddiuJV3AunYFr3rapC1MEbdNFNoB
16019	payment	1726	1726	1874	1	1	6055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVPYJYqgo3p9EJKRMr52nZ6HBbda7VgR4ZEiadPRGhWcEiJV8
16020	payment	1726	1726	1874	1	1	6056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5XhadrMMVpsynDrFTEY1H9msfwEU2ZdcP5w4rWwc7Ksdf1Ee
16021	payment	1726	1726	1874	1	1	6057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVC4poqyUfJTfgJgzSVWarz4Aks3x97qHuQfHuBe5AYfnTMCV
16057	payment	1397	1397	1678	1	1	7691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Wm6zfN4hREWNJQ51x5Zj9Nsjfa7jkyvVH8UzmtMTHUF4J5Sc
16069	payment	1397	1397	1678	1	1	7694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGvjAaFcbk68amBceBoDs5tfwttiTXEcNwC1qJARwTiF71Pxj
16070	payment	1397	1397	1678	1	1	7695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVEhpeyJDr69KqBiSnhvCLFgtBSbrcYsGxDCN7rjshv3ab88a
16071	payment	1726	1726	1874	1	1	6093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSq2CePWxnVV4exJzf9wRwZZgXR7DKM1CdPiVmjMrYDcmTSFma
16072	payment	1726	1726	1874	1	1	6094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNCe5KDKV4XqhePySoBwjzS4pgJfe9YrBdtbUmG1EcFSJn8Xh
16073	payment	1726	1726	1874	1	1	6095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxu4cZxcien1u5xY16W8CXwcbCq169bWawWoQAJaWMa35E1VTM
16074	payment	1726	1726	1874	1	1	6096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4m2Gn3baX69UwpFCJf7mEjBpynjqoz1n99zyZEy8mgbSC83a
16030	payment	1726	1726	1874	1	1	6063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVFmG97yk516XGjwtUcqE9nVkHFU9MwE9u9nj2qVd99wP1fyp
16031	payment	1726	1726	1874	1	1	6064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYukZvTWBwf5hVVmoLHWe23MjtVLcSFJXb3sfu4Aw3QxJNjW3CD
16032	payment	1726	1726	1874	1	1	6065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tPydHG7fWQZ6jVd6mESYF32LvBmHL9oi1sT3bX8iegsrzKYS
16041	payment	1397	1397	1678	1	1	7687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcRvtSEmK2x9KjUPJ4izDFCRFvMXhQC6KZcxU1rJfNCVwzTNW
16042	payment	1397	1397	1678	1	1	7688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPyFe8kF4DHVTB4vqjaGauDPFUzwPHuEJrLNMWZr9YcZsL5Kg
16043	payment	1397	1397	1678	1	1	7689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ekZNKuAngqK2FWZayo6mpoufTzTzLZAZ5NS7LCiwFWptH9vN
16044	payment	1397	1397	1678	1	1	7690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLWKCz3ntVFx71WzngYN2dSrSfqY4k6KbnPreCBLfYzDTrpXD
16045	payment	1726	1726	1874	1	1	6072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmaEqsPvctJE3qMJa5kfhPTrFrHamHm3Bt4QerZkHbsvnK2Fi
16046	payment	1726	1726	1874	1	1	6073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15R4u4WypuaeSrkYe9qvANj9dqTFBGHtr5ytES2zwge6AkAx8
16047	payment	1726	1726	1874	1	1	6074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dkGSyreHKCfJWLSnbh8jADPzWGxP5bieVFQhbneYKa9sRBMq
16048	payment	1726	1726	1874	1	1	6075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXskqVc15xvgUsHZGffyzuY5odkj75okxN1PtghRrgfVJSwhC
16049	payment	1726	1726	1874	1	1	6076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CCZzXHGtjyQzGHs1LpFL4EpenDktBovKdH6CAUdxwCcVy3yo
16050	payment	1726	1726	1874	1	1	6077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF2S6QE9nL8V9b71eFPDH97RrorJ2VZm4bgNsSLoDDv6CTZLEk
16051	payment	1726	1726	1874	1	1	6078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXZDPeACqy3ot5JWK8iSVneaDudRYB43UPYLe6h5tvPED1TZu
16052	payment	1726	1726	1874	1	1	6079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZN9QJbMVTX5XvrZb2By8w5Cjythw7MRCz8UUSjDLCdUmvkqsr
16053	payment	1726	1726	1874	1	1	6080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2FA9g6LiFLhRMCarKeqEWBswZkHXv57gMqcPGpyQ4eUUoPnH
16054	payment	1726	1726	1874	1	1	6081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYz7Y4MkT3oNY8fp5WVHuAP1AFvYTyFHzHh3m7BuQxD6Ca8dG4
16055	payment	1726	1726	1874	1	1	6082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFhd37PsfFn78cYcA4keLXF43Vu2EZpqJiEMCte9smYGQ9jLc
16056	payment	1726	1726	1874	1	1	6083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAouAghbAtQpXk9Rnnv9EhkUfwqTfLbBz5FBnNi5pvQXzxffS
16062	payment	1726	1726	1874	1	1	6087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVAWEV1azY9fX17ERXaK7p8r1HfEzjYcXh89aSSZPLkfuWC1k
16063	payment	1726	1726	1874	1	1	6088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjiAQLvWQpBG53CFiUF5jvNT2edzikqZKRi1BgCuAKpBKQoM5
16064	payment	1726	1726	1874	1	1	6089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNTr169H9uetp7dUduzDyL9xdois8xqF7Z2Tsfb9SGt7YNDZg
16081	payment	1397	1397	1678	1	1	7697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnh2tQpYfyPYWpsy6MrrRpu6wsASDcXMyEwUzrNiG4VrjqMsy
16082	payment	1726	1726	1874	1	1	6102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9roPhzHkZgnAK7wzqDEHXpw5sWe89UX9s6Bvr8aBRGLShTM6k
16083	payment	1726	1726	1874	1	1	6103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhJro9ACMKqvmWsCtoF5zKcH6RYzZgBDduYvqYcqQ9NRd9ujy
16084	payment	1726	1726	1874	1	1	6104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTQcMogvYykL2SXUTNRTXkBBppiKW3TkFhWo9j5LLE5ptwPd5
16097	payment	1397	1397	1678	1	1	7701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfbnnoXER29EfUoNKNLzcUHZ2DDp4NGQBBZfK4GDVD2fzcBwb
16098	payment	1726	1726	1874	1	1	6114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3igUwFYzNdjzUiGxKjkvGdFcxCdMHU5UnmfJoniCfBuX857y
16099	payment	1726	1726	1874	1	1	6115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuUenxxsmEy8Ux7CDLfMPeELznLtY3ZadVRci3hvwPAnfGMBz
16100	payment	1726	1726	1874	1	1	6116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8NPsPhh5jjvqVBqPJuZv6apDUKUS7i9zwj3m6MYjkvhijksv
16120	payment	1397	1397	1678	1	1	7706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VwAkduMDkaRq8frqomhYZyki2aaFtTURfVhrGCREwZH64kgu
16121	payment	1397	1397	1678	1	1	7707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDYZjACPujEjG3FX2KNePkgkBBDS8cJRD247yRtNkFTQPVUyH
16122	payment	1726	1726	1874	1	1	6132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciDhYt6mSK81hvNAprPQinXgqriisfL45kTfwPNEbPn8Q1Y9J
16123	payment	1726	1726	1874	1	1	6133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDK3NrsSaSXtSkdPSi2BbM3MqUsqYvHiXfLziEdkUisw3J8yvE
16124	payment	1726	1726	1874	1	1	6134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Kb929whfaqA6p61XYLS6wV8EUp24uUxE2tv2dAdY666aegxe
16125	payment	1726	1726	1874	1	1	6135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YqeyNdrGiVrtr7smmxG5V924c2q4MMyQHDdybLumbHEgKzZE
16126	payment	1726	1726	1874	1	1	6136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9UZkMhQ7qHwSKSxxUFSmYc4WXQG69c2CiNzCRj61qy7CYkn3
16127	payment	1397	1397	1678	1	1	7708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTGRAK1rMm4cvauPJRwJiMddNreonw398HqgrdUtLYbuSd8j4
16075	payment	1726	1726	1874	1	1	6097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpPHtXVhVrjp1XGfs5NEE4WMtfB8kxCnRxqHY51X4cdeeXaXB
16076	payment	1726	1726	1874	1	1	6098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCGsSs5nNJYTP3FtCjXL9wdWrbfQS3m6RiG7fAsNxH1qbncxi
16101	payment	1397	1397	1678	1	1	7702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgErDvbWrRkea7WTcAgYHUp7ywJ21BuBmroKBjPeSXDoThiQKU
16102	payment	1726	1726	1874	1	1	6117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuEeumFJYL9iJ3vQscAGaVDX6AsqNBzy2CSqAvnDjo3zZvv2L
16103	payment	1726	1726	1874	1	1	6118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QK22aw12ZM2ANQ4PPK2PNKcbMUsYKzebftXTRQU7EZst3ZEn
16104	payment	1726	1726	1874	1	1	6119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKeLHYT3hYk9LJkQ3hcLHmEqyzTXpfC3NoNTEaKZNraZKaWtt
16105	payment	1726	1726	1874	1	1	6120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqW2ruRBxYzimJ8UiEfDGQ4ygwvJK39JYky1DTSEgAKhLt2Z4S
16106	payment	1726	1726	1874	1	1	6121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtZjQWL3w8AhpjLwMnd3cPgacZdxJTbQcXhQ6BWXtXdcqbKFa
16107	payment	1726	1726	1874	1	1	6122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRMeu2ASU3iJqkvdFyA9CAX7V1RiNz1umCZNa2m9z2zTBrdjS
16131	payment	1726	1726	1874	1	1	6137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSxQiMRAz6myKLkqyyuY2TCffnZqJL9PsYD5XzGhCwyvkwtKa
16132	payment	1726	1726	1874	1	1	6138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPHqtAmdHrY7A6XMvN4UFMXakSiugXsTDUb8PfnoPUD9JwFwZ
16133	payment	1726	1726	1874	1	1	6139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7aBTeLB4f8ZeHUX2MxNm5VzzDwi43SCSA6SMm95sRCULNWqb
16134	payment	1726	1726	1874	1	1	6140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hNZfroSi71Y6tvWzQNM14Q3WBaWK85ncHbB7iQhMQxbzFRCY
16135	payment	1726	1726	1874	1	1	6141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QKVQQ6CLVdaVHeBoMujwtFX4uYxhcA6LM9HUgsL4CexEBxA1
16136	payment	1726	1726	1874	1	1	6142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5G8fJhj7ZdG1xU3gd2RniLoowDLR9FCu7Vp31VD3eF11YC5yi
16137	payment	1726	1726	1874	1	1	6143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9QhD66g9yfQC66TFfoTY2Sf4mqLZBJW1E5jZRhx3cPXCrGPp
16138	payment	1726	1726	1874	1	1	6144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqvzePbhafDvpB7wi34LnxNzkcrDdhtyNaoAST2zKzeSD2Wr3Y
16139	payment	1726	1726	1874	1	1	6145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVC1HH7HzNW4N3gr6oRvVg2KLRza6b3h6dQ1RXm7mHSHouwH8
16156	payment	1397	1397	1678	1	1	7715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsAhtPdd6m6aSBgxwreYECn9XE2xjVfCKh8158TRMKTVxbESL
16157	payment	1397	1397	1678	1	1	7716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnEn4igB3L2iAQHLoyGEDRWAX7BfxcSKxENBAoWDyqeQXe2fj
16158	payment	1726	1726	1874	1	1	6158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2F7j6BxyvZ6WKPAbDKxdendND1aFGMeV3mmkiUjdEud2voYG6
16159	payment	1726	1726	1874	1	1	6159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcahUSy2XTe2M492CTKv8JAx68rrSJsnaJy1MTNWR8u7cQKJXV
16160	payment	1726	1726	1874	1	1	6160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLY3r2yvc6uHA3TEBpTPMcqJ4G5iy9g7nwirL7RPRbiJCmsbeS
16161	payment	1726	1726	1874	1	1	6161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ENRZBKfDVx41MyrS4v7jrBdyxHQc4PTD5xMuPArACzM76ojP
16162	payment	1726	1726	1874	1	1	6162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61L4TwM1fLjsf7CsLqXWeKuaPMMR565ZNdQ8gPY3yPTkbpHdU
16163	payment	1726	1726	1874	1	1	6163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhyV42Ch574cmB7y3hBCzCs4E2t41wCvaFx2RzVPZzVmmiAHS
16222	payment	1397	1397	1678	1	1	7732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvC3c9tyWr5ZaNWDH7QpRSXbkEM24AdQuwToEcNCFBG3WwAULT
16223	payment	1726	1726	1874	1	1	6207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcZoMMem84VFhhLHNCyQ4wxij7jhkrfFqU9LSEhMeDvpvpHRK
16224	payment	1726	1726	1874	1	1	6208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRTLDhG9WSPs8gjNv6c7NKe6A6hZHBgeGTCG4H3gczbxXR3r3
16225	payment	1726	1726	1874	1	1	6209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCh3TYm17T2HofmiwgBBMZSx9V7TMptwk3SbH84oYnVjQtyUC
16238	payment	1397	1397	1678	1	1	7736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oYUBFC4LctHxmzaHaXgiMHgKwEvYy2PDm4yPsQPLtKapEc3L
16239	payment	1726	1726	1874	1	1	6219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76zLzMhLNB7Ek5BjrazwVtv7K7hFhiMbbYpJmCP6jgDSZZfaX
16240	payment	1726	1726	1874	1	1	6220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oTBgYmPUu5ycPvn1mXSGv2iijnqXCDUXj51TMFf6CUE6HHea
16241	payment	1726	1726	1874	1	1	6221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQTuWEYMDmkwBE5wS8YdU5UY8d6GMidzzn2jpf766m2gTJbKh
16242	payment	1397	1397	1678	1	1	7737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zbSUVNGZCq5pr9Ce6Uu45tB2QrzE2rgGf8ygrFECRSQrSbPu
16249	payment	1397	1397	1678	1	1	7739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXtWVL9eH24S64UmAKKPsWez81DTLfgG1D1iVgwFoxCEDfEX5H
16250	payment	1397	1397	1678	1	1	7740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jd616Uvthy32jrp3eCWVzbkCbFZf4uAr551p1GasBpcHE3UG
16251	payment	1397	1397	1678	1	1	7741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4MczdeARat7TKdR1adNMu6PBaZjfxCmRSJkoVkJGsCRTkFH9
16128	payment	1397	1397	1678	1	1	7709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZA7mbgg1DbhZrjRPgdia1Hfb1A6UEnDVTuAeZ8nMekM4hJLu
16129	payment	1397	1397	1678	1	1	7710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtz11ZYsnvAe1x3PoGp3xcuLASSBnjiDNUfkdz2TAeJ5uDdkWD
16130	payment	1749	1749	1950	1	1	12	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsL2SoUAzqDF843UejeZ2v3eHB8jbbMspgeqZwMPk9Y6CCa6qD
16167	payment	1397	1397	1678	1	1	7718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCesJJihSBVEMsPPf8NkEK6t8jXhEWRwGce3e1JLYVV5Mf2oUd
16168	payment	1726	1726	1874	1	1	6166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChn1R14yHcaUqGcasdmbSCCrbVR73Sg2vgt6LrRRRdsgXqdrM
16169	payment	1726	1726	1874	1	1	6167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzi8q7GxcvLQ1duqDwiiMaMp27yhUF5WQPZjfgTLKjRg6pBE1
16170	payment	1726	1726	1874	1	1	6168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBWNVA3aFQiAgrHwWEFbwdjWoB22Qj7tV4qsDtJQyJmq7jqqG
16171	payment	1397	1397	1678	1	1	7719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5tAKKWhqNzn2ZmHuonJMC3uWKfDNvoVPPH8Vxdd3Bs7p271iD
16172	payment	1726	1726	1874	1	1	6169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkTSS3N7C55pFYGc1HbJ3muB4cduR8xpvdvXAMUfi9k8HLXtCS
16173	payment	1726	1726	1874	1	1	6170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8isAm7TdKBTyE3HM9tmYYAMSVz2XR8xbZjAEQ9YFcXaDbbuhD
16174	payment	1726	1726	1874	1	1	6171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmAJPuAaF4eUfX4LCkyMAA7E86kkDiiC6XjLNg5JnyGWPFJrp
16176	payment	1397	1397	1678	1	1	7721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4g1Ah3X1xcS2JoM1oxvxrZBJnxqeHywhfsUgi9Pjhs22NdTR2
16177	payment	1397	1397	1678	1	1	7722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXApquwm4RLzVo5XTG3TYoaBPcDYSBKwYtTReL26GrCswajwsg
16178	payment	1726	1726	1874	1	1	6172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigQPVeLMBeU9q3jCJCSiE3kzBZrCGHvihTfwumbXbgNt72LG9
16179	payment	1726	1726	1874	1	1	6173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEig5G3727uBhByPTNTQHvh184t5kX8trWeLgLbVgFi9B7dmML
16180	payment	1726	1726	1874	1	1	6174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxA73TL9sMbEQxGAjJPEaw7ce1DryXPYhA937Yv4bPLDy7JMdg
16181	payment	1726	1726	1874	1	1	6175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7amNZH9NkYuFprfD6VPFjqZVUQg1MV4bR4TMaevvm7QxAMAS
16182	payment	1726	1726	1874	1	1	6176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9zQtqvqoq7UETEnKsqH4H29ptEWppYACmCT6neYDniYE4PmA
16183	payment	1726	1726	1874	1	1	6177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcD26VxwQimLTYaSe67KGV7LpnQ6n4ZvgiGcCJRFLUnu7YhUtN
16184	payment	1726	1726	1874	1	1	6178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97Djpxumn3YAE65nGsdPtdXcWEddLhJs2QFvUPFjjXQ9StCHg
16185	payment	1726	1726	1874	1	1	6179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBsGd3FY4gNrebfRmgHQFWKLwoGjRKmCafxhzwE9vVp97vKBz
16186	payment	1726	1726	1874	1	1	6180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Nt8HaBYiRWxSngDySfc2KfcnHDdaLnc24mdXySauAqDsvDmg
16187	payment	1397	1397	1678	1	1	7723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqHnQvrue2FwU2Sj3VnJbAs1JFqWP19a7gTsZkGjqHtoKLLAQ
16188	payment	1397	1397	1678	1	1	7724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFPNP1QMxUXhXes71fNJjkuYouMaYzSCZAq2C7Jsa93ywsvyL
16189	payment	1397	1397	1678	1	1	7725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VZoAW43drQ9t6QLCUenJx5sWbhnKWx1veiFdQ9PkqV3XfsV7
16190	payment	1397	1397	1678	1	1	7726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwr9hs8LiSewoCWuZG7KkYkvKyWUfx8MSF4omEnRRJRa5X1oxo
16191	payment	1397	1397	1678	1	1	7727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbzHZTMP7rgw5h37QsJqQCZXqAoErqLJPNYhcsHY6GdT1wmrp
16192	payment	1726	1726	1874	1	1	6181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6qLHC1xm3S7QA14ykir134Um481pWZEXkPjTufeG5CJjwxpE
16193	payment	1726	1726	1874	1	1	6182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ74MN2e5rGPDhcnM68KfojtZjvjnddJpPHB3CDNQpDrEVAAwTf
16194	payment	1726	1726	1874	1	1	6183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCJgPwg8bGTX3eb5thtiiVMzBjXk9eLrbbhRMMKc5mEt4Gt6N
16195	payment	1726	1726	1874	1	1	6184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HUn7FrdEZZrBUaE6qPEQh7NESnytJ7ynhX5uVvakNhKgbCH6
16196	payment	1726	1726	1874	1	1	6185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6FQeMAaeKT6egbreJEPm4wLc81VaFvqcnyCiwzoaAxwUeXVi
16197	payment	1726	1726	1874	1	1	6186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNRnZgVExER22XnvVGHS8ZxyHn5zTUQ8LFGJc5sWhSYtQiy2g
16198	payment	1726	1726	1874	1	1	6187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm66NKDLFyXFxaQVGpYrANHPyi13CCxG5PukogBN1iDBaDaL6D
16199	payment	1726	1726	1874	1	1	6188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPyr6XMQyRPdx67zvjnzpiNjo4zVQuV3B19HPEZ45gYK37K3w
16200	payment	1726	1726	1874	1	1	6189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZmEpNx7Hft969BCHtR9AjbaPMnTGinDy6tdB8cXZnCZSKENv
16201	payment	1726	1726	1874	1	1	6190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzWrzpCQcYSJxnse6DD9bAveTsgtA3hSS5HfmJpzzP8QkocTr
16202	payment	1726	1726	1874	1	1	6191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuhjE217VkVzdfuF5yWgWiBEboGBHL22rhmoWRej5f9KRwBAd
16165	payment	1726	1726	1874	1	1	6164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTD62jtvEeSbee9YApJMc15tfRmrWKbrzRXjNy4AayPvG7kgP
16166	payment	1726	1726	1874	1	1	6165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPrPeEU7W8yKuxb9SDRXbMY1UJZa6QfwukpKWYqdHSaktydrz
16175	payment	1397	1397	1678	1	1	7720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6HP5nrLFZwjTEMTxU58h4UaAcMRMy7iJ1VPN1QKvLTyqS8to
16206	payment	1397	1397	1678	1	1	7728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTj4Qz9UJXpHu7J6xNPcUaVyUH9uzySScbSABbT5wAwYXhCh5G
16207	payment	1726	1726	1874	1	1	6195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxieT3gRCsZo1qqfao9rnDibhway8N4tkAuvgLzEYM8fSeU6Lu
16208	payment	1726	1726	1874	1	1	6196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxVNA1vEysXoo8Z5inoWyRgJd9hix5wGCcvt2UQdrQLrGytmQ
16209	payment	1726	1726	1874	1	1	6197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNhQ9RbuQa5Kg6xB7926w19k7xMg9EiVfpbXszByGL5AJ86Er
16210	payment	1397	1397	1678	1	1	7729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgyoEYxF1bCQqKT4rak2Y7LSx6DYbNzSj2cNpaxhF2TA2UH1g
16211	payment	1726	1726	1874	1	1	6198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynEQMvKC9PV8pKb6KSq9EpmzRDtoSpRtzkXKfjnZwGTwD1Vx5
16212	payment	1726	1726	1874	1	1	6199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiwEcjTVGHevrZyYvksuYBX9puCnMrqLmrMACeSGUwxNHU7Ub
16213	payment	1726	1726	1874	1	1	6200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPe1cCxVnARYK5Nq3tJrj9YAkytrNYYuqb4M6z3XJSuqhPTp7
16226	payment	1397	1397	1678	1	1	7733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdaGmgbUaJo81tJqt6ajQSamLsDrQYTgmAPNpYPQAsvqhyYid
16227	payment	1726	1726	1874	1	1	6210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgrbtKucBdvV66ppLCePSpJDodiJJiN9VvLSVFb9UEEo8Sj8Y
16228	payment	1726	1726	1874	1	1	6211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqechEFNXeptHX5ZtkcBRFyvYts51ai1ScXse1qPoWch3NmR6U
16229	payment	1726	1726	1874	1	1	6212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHySVbh3ZgFTvrKtL1M5WfFT84S9MpQRvRZMij54ezszQybn56
16260	payment	1397	1397	1678	1	1	7742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLjB4vaVVnDbbkyZecwrU6FqRYvfKYR3UH8AnEuUbtKXYbxLd
16261	payment	1726	1726	1874	1	1	6235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhut64AST7xWpYoGH5MEVBSW6c1oNPukPizqB5ivReyAxgZSE
16262	payment	1726	1726	1874	1	1	6236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1ckshmXGHrTtLcuM64FiaSPKYTppKbc5y64M6JKPAboYzmN7
16263	payment	1726	1726	1874	1	1	6237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAffXjf58qt9FFEmYKv3MKpvV32X4mpHfAYxUdS129UCGwFXFS
16264	payment	1397	1397	1678	1	1	7743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuiyZVJxAiuc4sZPt8U3dykF43QnpXSv6AEuG39xaHm7h3Yzr
16265	payment	1726	1726	1874	1	1	6238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAtWFjhMRTBLYBBi1vvxX8iRqZAjK3p5dAdwiw7p7FcpQsEQJ
16266	payment	1726	1726	1874	1	1	6239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9HdzCew6w9HFTtwCm1vHfJftvNtoMyCET9zdv93DTiG6m3Yg
16267	payment	1726	1726	1874	1	1	6240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5iMFmbqUZZxceYnQ2fwc1Q5i49p75JkJgnmJhkf5opcZbYcA
16268	payment	1397	1397	1678	1	1	7744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8E3oE7dZixBEcMLQW3SK8ksrmEQ9BSrbQB6qdbSAQFSxPNCek
16269	payment	1726	1726	1874	1	1	6241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLcZ41idkVGeqtwrwTDARXLS9mLu6yBCzT7hdWMvN5g9PAeHx
16270	payment	1749	1749	1950	1	1	13	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzu7CgwSbGYYkhJbAKbYRuRJBKuSxGGP5eYG1B59g45hkCX9wr
16271	payment	1726	1726	1874	1	1	6242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgEpREViGqcgRuXm9YzytCq8t4kXoecodwx8qWshPkj7C8rEj
16272	payment	1397	1397	1678	1	1	7745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxgiktAEvaTMWNAXyiRAURTadMP563xWHnpM5X35w8RgXyNUu
16273	payment	1726	1726	1874	1	1	6243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLemYhWyGuLVa1CJafdeo9TAzC5nyh7NSRSAJsofTv3KdrSVGZ
16274	payment	1726	1726	1874	1	1	6244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnvUTNmQ1KcpkU2KcbzEVz8jaCKoXAyiiDfyR8FNDM3HNpZrq
16275	payment	1726	1726	1874	1	1	6245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiArG8AMrQLSQDbnA3K9FPc2brJDLXTbfMGxR5sr8BLnkPrBcB
16284	payment	1397	1397	1678	1	1	7748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxz5SDajNK53hBAvpyhYLbuLGesdw3fpvSRq3K9NmEHa4Pxxr
16285	payment	1726	1726	1874	1	1	6252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHd8F9SuSLWd4ikU5BdckP4UA7DEs2GF66wgq8wJYpDSNuDmY
16286	payment	1726	1726	1874	1	1	6253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFHRNhM2WfFngcaHUP8Tr9yinKC9asZoPLyCQVhAqkpqvVLwS
16287	payment	1726	1726	1874	1	1	6254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NGbemZkoZT2tp6iTY2yzcFPXEto6rXZiLXVZtUDGy4RNvai7
16310	payment	1397	1397	1678	1	1	7754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1PCpUhvtryszV8bysjnMbmYLtqD4jPiNBMDe1P4ijrEZaYLng
16311	payment	1397	1397	1678	1	1	7755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYFKq6Mesr3sHToEmwpsPdSmiWfCSQ5AowcT2UUVarhuc5APk
16312	payment	1726	1726	1874	1	1	6272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqszBZ9r1pHjUw7cmSH2rXoL7C7zktoKGaTHtwPjDxV4MQqJK6
16203	payment	1726	1726	1874	1	1	6192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTL9aMYVGXp1aotczuuwMemTR7W9xCCUzRFbAc68QKr4Libd5
16204	payment	1726	1726	1874	1	1	6193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwPgLT9YMgNi1XJB4XKtWanhuy2e4Pz87uEVXKNXr5TRxKHva
16205	payment	1726	1726	1874	1	1	6194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdKpP9itaHmsotLvNjdZE6iRQMwDDBYPFGwFk3uFAd8vKJAbs
16214	payment	1397	1397	1678	1	1	7730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSA7HYPX9W2MDANsE3m9aVS2z3FNo3oa6ZhscKUMacyhATKata
16215	payment	1397	1397	1678	1	1	7731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpK1ppvNikAt7eu7yNG4cVSA6sKeMzyArvWNHntyAWFqLgQsx
16216	payment	1726	1726	1874	1	1	6201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzL8hGisD1a8bnLF9Ki1VxWgi1hK3n3ijCAE6oZwheYhCVAhz
16217	payment	1726	1726	1874	1	1	6202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JJTGK9Fb3T6tC1tpg9CDrcFjZaPQ2AJ8Ka5U2matND7PMEEN
16218	payment	1726	1726	1874	1	1	6203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxKaa8cJUg6bMLNqmC8cLXcKXbyHvAPMLcarkVtmBZXYLum6A
16219	payment	1726	1726	1874	1	1	6204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjh8C1TnbUbm1z9TpytAvvcxv3wkYTDCHCrCZHGK4RB5JfVvTQ
16220	payment	1726	1726	1874	1	1	6205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXBw9hRCSbgjkgy466b51Z8UudsppGqbaLBAy99YKzNGqpayc
16221	payment	1726	1726	1874	1	1	6206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Ee7tpCNC15NTGL6vU8iY6qhfRaabopVjEYoJskNzm2rXCCe1
16230	payment	1397	1397	1678	1	1	7734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHTERvDtQnT6hJZmm3UUWqNFLsMtkg8wZHTNiA1aKqyYejaVS
16231	payment	1397	1397	1678	1	1	7735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7edN2fcfEVVW82T7R6BqYhUp7rBCL2JxTL9JKDoDsGNHr6EGu
16232	payment	1726	1726	1874	1	1	6213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeb5sX9bAhGimo54VHqNqagM82VyWRCarRKYQhniJ9UV7A3g1
16233	payment	1726	1726	1874	1	1	6214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTmmw165T7WYkzLDKZf5Q5zfYM89gDFY66bCZNmwVURu6jEpR
16234	payment	1726	1726	1874	1	1	6215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU52WLAZwdvUCd2Es1LCgkfgXUupyQWTdpz1VoGR5rGcKQdurc
16235	payment	1726	1726	1874	1	1	6216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dJfrnFxhYUJscTMPavmnSZXHJizinycrEbSJZnHtV1eLKxcY
16236	payment	1726	1726	1874	1	1	6217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMSyqdcKFRpcyXMKPnzpebmutw2zCG2jYEDBtkXWGATxWirPk
16237	payment	1726	1726	1874	1	1	6218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQSf4esHMHySN9sxcABxibUKTTnzG2BSH1L689ZvLACtsvjQJ
16276	payment	1397	1397	1678	1	1	7746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtNRC6hHVD9RxWQVAsnXuuipVQuZdVDxWA3wkDwYvSX7y9img
16277	payment	1726	1726	1874	1	1	6246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4fXHEjcr61jfQpyooE2BHpXPaUq2M9uwLTxURF9peqLqjy85
16278	payment	1726	1726	1874	1	1	6247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCSu2y8SAGN1qy1MZKH4wHT88wwd4ZhUufBqr2xdiXmDq7xqsZ
16279	payment	1726	1726	1874	1	1	6248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMGgSkMEyB1yFHHUANecsfDwFtGWZw7esytS7gMCThCfWGswa
16280	payment	1397	1397	1678	1	1	7747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn2Qd7Zo5Z5fUno6Bi5qdtiQQycDxTv9EwZjvyRDYMMz9S8Z6
16292	payment	1397	1397	1678	1	1	7750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbBH9UHazYzovCJNhWwsRrfRLKEyUzkDgna5g9q22X7DS6PDy
16293	payment	1726	1726	1874	1	1	6258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTAcWvCSAHcZ83yuBPMrvFEPDLTQp2HvN91NNz5jG1xZrNaDF7
16294	payment	1726	1726	1874	1	1	6259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9ZNywYDP7saVzCRwbvwnY46hnRpcV6YQ8z9TzgmVe6s637ip
16295	payment	1726	1726	1874	1	1	6260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAmPc4H6N4hf9bgR3PUYcU1JtAu15aS9zFBouR3m86VrnGbk7
16296	payment	1726	1726	1874	1	1	6261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DA6beMKJhLCLTSMJjzhh25rXzjcRkbGXaLdbrqUhsWC4YpLy
16297	payment	1726	1726	1874	1	1	6262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpbhRykR7HtDSgjVQ7oeP9yqoktxdWgnC5XGsZgps1BU34Qmv
16298	payment	1726	1726	1874	1	1	6263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHx7xREmFSByr5Yiwt22kRvRUUvZhYpkZjUtyyRBaawRKPma5Y
16372	payment	1397	1397	1678	1	1	7769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDmVbiMB7dWA4rbAZ1T2RUQh857awFWYd1P9CT1qKxu4VsGWZ
16373	payment	1726	1726	1874	1	1	6317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKm7JvBayXn5zy2NyEr8eCCBtTyW5BLdZRS6PVMGgjLCfMt2H
16374	payment	1726	1726	1874	1	1	6318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzDUqHvAVTat5XigtteAXHJzxeA2hW4FWt1zvNHCXxT3SyqKuJ
16375	payment	1726	1726	1874	1	1	6319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4rWTkrnPBPPPYz92bVNSPA6nxGqXGdHxVMKmMCGXC6vt44Ua
16388	payment	1397	1397	1678	1	1	7773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnKpqNrfLKuVwpSgQgaGsFLmHJq4bCSubmA84shbpaiFFZWZ2
16389	payment	1397	1397	1678	1	1	7774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNw88rhE3B3XqMF6jhKJzakYCshia7nFtaqkDxixctj74hWZA
16390	payment	1726	1726	1874	1	1	6329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsSAADWVzPE6NkYHCidVwP3a4ozteU1gbfPYUVzg5MVPABfBa
16244	payment	1726	1726	1874	1	1	6223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4shZzk9UrsrKcK44gdoQqDBN4gDby2oSEkpHHjTKAx3YqB1a
16245	payment	1397	1397	1678	1	1	7738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhgkA5r4RDdG9seVxv5xsC3zyFCeaE2DSQTPVv5Vw6pXq42bJ
16246	payment	1726	1726	1874	1	1	6224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnaKjZHs9dYDdUu66uCRDYcki7ouLjuhiGutcJfUJYQ8tyabpd
16247	payment	1726	1726	1874	1	1	6225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgGY88Z4Ht8NkC5To5Aj1phRw4sZENupJmnfPX5aSrcDHHzMs
16248	payment	1726	1726	1874	1	1	6226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Zz75HHzCMTK8Yrpo3DFX7ataB8WamuyJgj4tyEYMhXKBjgGs
16281	payment	1726	1726	1874	1	1	6249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1Wd4JMyey1KxTQSw2pVMfqquwpcvyhr9qqoFsKQvgsKaBLFK
16282	payment	1726	1726	1874	1	1	6250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDL7AAbc9XN4LPdDKRJNGjEDf44vC7SKjQhpr7eS2M9i6oPgtb
16283	payment	1726	1726	1874	1	1	6251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnY4D61tZiUM4AvTwnnePRk45sJESkDwgsCKDndSFx31LXoyt
16306	payment	1397	1397	1678	1	1	7753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4MVgXeuRvQ4c1sYC91FcXcufcWHLhVsRfFXXmqTYrsKZsb2U
16307	payment	1726	1726	1874	1	1	6269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1QbNp8VWEJkgZUm2Sz8wTTSdodu9mbbcVKfiZwDfjPahzEJN
16308	payment	1726	1726	1874	1	1	6270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdzJ1oruwiUCH7hzswTVHpnDRRm76RJKcP9JfsLXEas9869Vn
16309	payment	1726	1726	1874	1	1	6271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xHseNWxznhaqK7Cehig7uThNhC3VCVsaNgaoc1Ga3gnpKvU9
16318	payment	1397	1397	1678	1	1	7756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLpBqkvdrFbwLXWpn3C7CGVyLsGpZHYXnFBLCjwKp4tZUccwc
16319	payment	114	114	1950	1	1	6	50000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQ918TCAkFPy3yGXdg8e7XMduMgRbqvwiDehSmFv8pheQBTyx
16320	payment	1397	1397	1678	1	1	7757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHomn9RrqTLjkPWhrjUjFj72DpcqcfPtt5TfUFKvKstq32Ez3q
16321	payment	1397	1397	1678	1	1	7758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzca6XuGrjqTMGttbVQiKUEHAqXMcUdmQWcwbwLqGjehcWhFif
16322	payment	1397	1397	1678	1	1	7759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9x2hzCnvmrHfMNUKDT4edzqx1NGv753JdFsygSpnUtxozsosb
16323	payment	1397	1397	1678	1	1	7760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrrs2mR1P2jCK5b8B7VTN8UuNT7DHpzVT9ha22TMUcmhstUNyR
16324	payment	1397	1397	1678	1	1	7761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYooPa74g6FZtfjV41dZqbReLKuYktugfJAGk19k42LTyD6PZks
16325	payment	1397	1397	1678	1	1	7762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzd4TJLj6wyYkyoy8SHr8xT87SKjDTRbmKyi2pXoLJ1soyB1r
16326	payment	1726	1726	1874	1	1	6278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PgpKjzqzJGPP8tEjdhaRVXLuYQ5Qp11aru6aXVV8ojj2gXnv
16327	payment	1726	1726	1874	1	1	6279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8gKaZn2VxRmAidBcTmwyy4XSKS6zcqJLCG53YKrNgRgU7Mrz
16328	payment	1726	1726	1874	1	1	6280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2Vh5TciJwr8mM6Q37mrBKHM48V1sDgNW8h1xZnGgvcSfhpo5
16329	payment	1726	1726	1874	1	1	6281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJC7Rbk8NvVLLuNuHD2FUercbgyrmJGTRWrnDX2eyHgWN8JF21
16330	payment	1726	1726	1874	1	1	6282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3ckR76gU7ptgpYw5GZLoUUGZWF2oPoqjyzQAjfKJmQ9LJHWX
16331	payment	1726	1726	1874	1	1	6283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAkSqDvNoPSpPq1Tf8x5gNqQ6mKdudvjfF4kqe7Dt3sQXCY58
16332	payment	1726	1726	1874	1	1	6284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5dPxyXzMUPVQsaB6gScs5g7MNHtfAdq6WakNuGm7tmH1s7zk7
16333	payment	1726	1726	1874	1	1	6285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3fhC9NNTDktQU57Wy5sVka3sVSeQD57fdcrtZXv9a2niV2Cq
16334	payment	1726	1726	1874	1	1	6286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1e6L3mzu8aHA9Hbc8hQR86aEeFveutrkUnBB9eX9iCQKpqrWs
16335	payment	1726	1726	1874	1	1	6287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJg9AJcNcuR5bJ9mrZXAHtDKE4f15U3Xox9Wg2d57Q7mWfYRd
16336	payment	1726	1726	1874	1	1	6288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWESKyvtouZ6umh63vBCF7856CiCipkVxPD8UajzU7tg2Km6T
16337	payment	1726	1726	1874	1	1	6289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SuHMFHt3D527pXHh4K9rCkAgwn9FbLvYYY2FPTsDJrpmKZNa
16338	payment	1726	1726	1874	1	1	6290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfW8q8wKXxv6ZyXVM8cXz1q7WXeVZcjvgUFj7n82EVUNrysMhd
16339	payment	1726	1726	1874	1	1	6291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzrHou8Ygjx74jGcE1dtFwt5bSbhMUw4ZS6XZWh4W1d6SKTqL
16340	payment	1726	1726	1874	1	1	6292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1rp5ZWgaNH1fs47PGK1Mkbw6xW6ioHgocfE9amGF9t6nZ4Tx
16341	payment	1726	1726	1874	1	1	6293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZob6gyom4nHuc1ExmwAJmz4qhcdcUReerR3Nzho6CQSqLoE7a8
16342	payment	1726	1726	1874	1	1	6294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71HzhdJEiNmgec4ti5G7ByYW3DTG3mhgUHfcPSME5wQmP6kkb
16343	payment	1726	1726	1874	1	1	6295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhA6CEDmEfiBaL3b4JDXFwbnHqrudv44z2HNdvZpuKVyHnsS9w
16252	payment	1726	1726	1874	1	1	6227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4ARitfTXrzVap4kg6kR1JfWZ4C5i6m3ohdRd3MzQ8Qu9NgxX
16253	payment	1726	1726	1874	1	1	6228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRaR8tvzUtdGPLXHyiohc9daG29GJ17WXSxW4qXSteQNV5Ww2F
16254	payment	1726	1726	1874	1	1	6229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4UgwhXjEYaM25WW4Lp1AXySwCs4TTwnJsiikafhgXjJGAU8K
16255	payment	1726	1726	1874	1	1	6230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LknqJ7QqDhi8NSriyJVArTn6Py6AmG8Nj9T368cG848c1mdm
16256	payment	1726	1726	1874	1	1	6231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgb793e4vfcRo6kKY8PTGY8fgu1wrhQFZArUqSLg1jYHtXsKJ8
16257	payment	1726	1726	1874	1	1	6232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzby6YXCshdfRbbTp6ce3Zdr1DjPUUUKDZKYnnr62r9U4E1xc
16258	payment	1726	1726	1874	1	1	6233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67ynaQb5jQzPyEKW86zj4WBPizwTfmpxEukLjUv79UUi3QrkZ
16259	payment	1726	1726	1874	1	1	6234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLR5xrbEehcVRYYypQ75gHBZgHkDW1ampGkybXsgDXbN9dGpU
16288	payment	1397	1397	1678	1	1	7749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Ucu8HS1mYhUEYDzEfDcQUskZC5KGR8vdk9feF2Fd2oegRPY4
16289	payment	1726	1726	1874	1	1	6255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqSbUfoCif6ai1vPYgMkmnhsqN1jpea6aTFrQd9aMyKjVb5x4
16290	payment	1726	1726	1874	1	1	6256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3zkJEwQKjQCCijxTthYiaXxi44b7HsFoL3LfeDFN74r2YS8X
16291	payment	1726	1726	1874	1	1	6257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DTPdufR4FukV8WnQnNNj2BCF2443cGrHT8KUWuUet6yXJXKq
16299	payment	1397	1397	1678	1	1	7751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTHR6NKKnrypVk6YRWLKnrTZHdD9t8rwNESYzfQaRWnMntGCH
16300	payment	1397	1397	1678	1	1	7752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBdikBL9yNXhqww7otx741MWxWNeWRyomv3g9QPQTJmrHkXe7
16301	payment	1726	1726	1874	1	1	6264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfwJdw5dijb2ckzSKygcgbcxqaoGftL78oZdEYEFB8sBavz1K
16302	payment	1726	1726	1874	1	1	6265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGmse9XwUE8zEXocnXnx3Q9Bs55359f24RkA53Sfr6yTwTbTf
16303	payment	1726	1726	1874	1	1	6266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVUoDssdjnDum3wGgVC8nLu8ga4LeCpFx8k5uV9JWd5Ynb6zh
16304	payment	1726	1726	1874	1	1	6267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswPTxVfWfJqti2ea8qewKQFQCPzYhwuS777ugnK1PefR73Dit
16305	payment	1726	1726	1874	1	1	6268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTYFm46CEBPQoLWdn8mZZisRCXVQyJCgTCSv5aVz75jdX2Ysv
16376	payment	1397	1397	1678	1	1	7770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgweC1PFXR3vjVqKGEzAZtqWW9v3PyNGxAM5MYFZeqYAPFBwH
16377	payment	1397	1397	1678	1	1	7771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfxxpNfoaqn2tAKQhT4YGpwSp9vmi4MSmN4FFMcSCvwQJPShJ
16378	payment	1397	1397	1678	1	1	7772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TaHEDvMLRXiq3KM9vRqFbV2X3BQj1aQ6P34SpTCtfS4ZsMSA
16379	payment	1726	1726	1874	1	1	6320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhye7bLhxDNHuBvBEaV7s5uGnwWoLB2qHPYK6HnjcNg6LLqNGb
16380	payment	1726	1726	1874	1	1	6321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHXfbNVwy3QJtAN3Uq9fnSfGXVtAToidPRxF9VA8skyf34hw9
16381	payment	1726	1726	1874	1	1	6322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCQzKDYkYzfsu5N3aUL6aiuGXFWNn2M27RJZUFo7tnHALWnrX
16382	payment	1726	1726	1874	1	1	6323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWMDWcBHUcYgitE6ZL3VPupLuUhrHqi2td1FZ9VfD8W6oWyCD
16383	payment	1726	1726	1874	1	1	6324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGD3a3SXrYnkjy9qYg1LdCFKzjmZ46kperCB3Mid3jbkysFio
16384	payment	1726	1726	1874	1	1	6325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHh8r1cxJGWDjH6ujQFC5Wb3hNFTv5P6rXu9HU7JP289UPZnw
16385	payment	1726	1726	1874	1	1	6326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSf5kG5ubkmXmhUjpJFyhKbdUsApXKvogLXwSzUV9GdunGvJq
16386	payment	1726	1726	1874	1	1	6327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirhwd1yxkofUSxsWdKSoZqma4LCjNN99JLzvBpxEBfpdv1gwo
16387	payment	1726	1726	1874	1	1	6328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6iNmmGrQB6YuXod1SWP5TZ1gjkMuJWbB85AgyrRTn3YSa1x5v
16397	payment	1726	1726	1874	1	1	6335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQ795KqQbAdgEAU6g526yfCMv3F6cRpJV5fm1X1micRjGXUGp
16398	payment	1726	1726	1874	1	1	6336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1htJBA2zyMTG4fCAcwQ8Xrf5p96BQL1XzpKiskh95PQxygd8
16399	payment	1726	1726	1874	1	1	6337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVRvcjvg6pe9johJLVbx4fqc7seaH78hG2X2o5Mw2jGkQt2w9
16459	payment	1397	1397	1678	1	1	7790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENHq2Ux1pEf8nXXdKdqjBTXko1Yh6MCGyqJLkbNNAwFq7HuaT
16499	payment	1397	1397	1678	1	1	7799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdn8a5mgARAZ9SqMrJLiv1usVYMaDswyrinpPgV2qWg5Fu9iqn
16500	delegation	1924	1924	1745	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gTETsFJLPkjztzXX3YWKHn5xNMW8GFwkzqEJj6tvfXDe4Qan
16501	payment	1726	1726	1874	1	1	6405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5V5nmSHw4u9QUuu2Th8QAkNGmpuHPUwGHVhZdsy1dqKmN4xa
16313	payment	1726	1726	1874	1	1	6273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEnmz519xWSisamvbeXpVgYJdwJouV7mUFx8wueH97xmTbZtR
16314	payment	1726	1726	1874	1	1	6274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RggAbT6mkKe3gZ44Qx2sW14b5SMKnDDpyc9wsUzGERmV51aP
16315	payment	1726	1726	1874	1	1	6275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocCqk6gFiwxsdfYofNQKQ7pYj9hGcKyRH98LRSL3QMvcx8gmY
16316	payment	1726	1726	1874	1	1	6276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFo1v1PLdM7Sbaw8CPcKoPhJxVL2YLkeoDHCwhXFn7dRbv5dBT
16317	payment	1726	1726	1874	1	1	6277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuWiMSAeLfwioavc8QHevayDj25nUN2A5iWxzZsSYvHon9od7
16347	payment	1397	1397	1678	1	1	7763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNKWy3rby31QfH7iF4P3RwHTdxbMzwBwBF2Upp39DfFsQsRXv4
16348	payment	1726	1726	1874	1	1	6299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTtiXSHGXdNbBbCjHjPxX7q185vyHZrDgKTiyqia9mQryhzES
16349	payment	1726	1726	1874	1	1	6300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkqtZGmcctjXB3cJ3yvhPnwySEaQXpY6GvzAgrFctHVAfvM17
16350	payment	1726	1726	1874	1	1	6301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9eQP4jrGij2DMTu2dvQM4BxMjGqASa3QvgqWwDqMR1nZWYt3
16351	payment	1397	1397	1678	1	1	7764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoPKAyBFLRuwWUtYHUPbCqqHd6mhArkcrq5hmAwtdSLXFqBt8
16352	payment	1726	1726	1874	1	1	6302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWE59y2fTTE3CRfBdBgxphpdNVPsT5jJYZFjjUxYEP4U3M1mk5
16353	payment	1726	1726	1874	1	1	6303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrjPaUSi1EYUyxAniHvWWTkMNZNqeXGQNa1uzYNmAk1sKd7TW
16354	payment	1726	1726	1874	1	1	6304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBG7eSebSkmqK9E3vPonvV2BANxjfqQRHiX9DMgxuxzhstAQNz
16364	payment	1397	1397	1678	1	1	7767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8pkF7YcfgV9hFxQyWBMbdtQadep3Z3QS6Z6QjWQmEiegDBmh
16365	payment	1397	1397	1678	1	1	7768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfBLdHiqbkSTn2pw5PrEEo3n1bZ2ivhqn8YG6LAKEAS75nerY
16366	payment	1726	1726	1874	1	1	6311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6XCbRdaMpoJ6jT6GFEDte7qBgxC4ezzUU11NWdNyjNBA6EAE
16367	payment	1726	1726	1874	1	1	6312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpi4BUr1RpfDWsSbM3VupJZiNUmcq9SGoLYHVYmRy7xv9eGHgq
16368	payment	1726	1726	1874	1	1	6313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfmdaXSHBCvJ3x6PhTRKwvcocsrJ5Nwa47CCchAbgYT9fpj6w
16369	payment	1726	1726	1874	1	1	6314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXrrvfXTvsKusyuaErsDBSuhLe8JBDg3xbvYZwcnoCGq6KUN9
16370	payment	1726	1726	1874	1	1	6315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WR1gYaAyrbEJJgPSWU7o6FXNSkQ2mKTBJ7q2rdgBGNgqvPhC
16371	payment	1726	1726	1874	1	1	6316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5LRMa2GWC87HV7yozE37XY3b3KrvvSha2dDszkUMYZnZgbHwT
16396	payment	1397	1397	1678	1	1	7775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAipK1dTYGPBEaFhzHe2AksDykjqVcKUDBAgL3qsh43Y8sSAca
16410	payment	1397	1397	1678	1	1	7778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvutVJHcMkvWk5DHrPHkv2fMksiWTi7GPVdxhGC4RK8Ddwxmsq
16411	payment	1726	1726	1874	1	1	6346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7VYvMYCxnWAwddRQNBVQpMPJJaXPmbnSpm77JVzYBh4tMHPp
16412	payment	1726	1726	1874	1	1	6347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKmM4c8i8THLX3dsHvMd5qwpW9e5p99U9LxPwbqq2R4FgJLZp
16413	payment	1726	1726	1874	1	1	6348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZ6cuAMhnU2Upu5Riu387JVtmv82GY6peKzzMwxHEtq1Rho4S
16426	payment	1397	1397	1678	1	1	7782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWahQDYh4k2ThRShvuqbbDAix8cJpBUVL7umT9oUcuHu1d9M2
16427	delegation	1925	1925	1745	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoVLY3TYdGDEW2ba7wVUCxeeSkNdsi6GbbST1T3cY8QT8wFnH
16428	payment	1726	1726	1874	1	1	6357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAqNcYJm9odvYq3BtTPRAPgvWwMWM3ELxvRAhqCQFefaWX52K
16429	payment	1726	1726	1874	1	1	6358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xoUDCQhuUDW4kw1ycbx1CJGww79Ep1y24zajze3z9PFScFGi
16430	payment	1726	1726	1874	1	1	6359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3TLx91nsBtZ3fDHsyBCbocb7w8D5NigxGc3WYsA7k13oFkYt
16474	payment	1775	1775	2047	1	1	16	90000	12000000	65535	E4Yb1MPktVG3thA6rpEqocNUVKTqNk2RAQSrT7gqveHQWcTwMdGFr	CkpZNrYfSNGYgxBPqL3xskYqy2Z3HPpzF3UyB69AGEzSRdosKF3wx
16475	payment	1397	1397	1678	1	1	7793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCvicUXXEdWzbdpyJNToD5jfyWa4Kmvc91WsR3bTeAyVB8R23
16476	payment	1397	1397	1678	1	1	7794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8tW1AWDgMVNHrPDWdV47LL3pjR1LRhf8HEoRn8B85ktYEzYZ
16477	payment	1397	1397	1678	1	1	7795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NEx33zTi9My9b1cPmbi6wWp4uEo1SmZzRjq9HcwqEVx7NWpX
16478	payment	1726	1726	1874	1	1	6388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNMWqJB2gGDh87MfAtKsx6cYgPjEzJ7jy9P5jkGDsLAyXLEJx
16479	payment	1726	1726	1874	1	1	6389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAn39BS2ryev9bwVyKeTi4mFw1bLUyPBxCBjCiKMJpXy8DmMh
16480	payment	1726	1726	1874	1	1	6390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1rNNRvRzFjAy4toj8V4DwfiaY4CKQYihf3pbupWmUTVgUQ9U4
16344	payment	1726	1726	1874	1	1	6296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxzCZuABbcjKJYJP935xZMASp3LcjtEvvWUh6xypBcqT495sK
16345	payment	1726	1726	1874	1	1	6297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzUdBQLZ3T63BjHa6d85W6yjpq8uiq3G1wk2ftmqcDjDrECYi
16346	payment	1726	1726	1874	1	1	6298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CsERJ3f2xT4VZMkFG2RLf7BMmoHQ4z25EDADBvGG3KfN3vue
16355	payment	114	114	1950	1	1	7	670000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjNSGa9WYH2q1Zo3pRCV3hxYNzc3TNzTejogLkwZR6Uq6X3Rp
16356	payment	1397	1397	1678	1	1	7765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2R8PtiPZJtU9Cob2K2uWMGmDeVmb7ZBsJBjkjb9EjYrEhAzwd
16357	payment	1397	1397	1678	1	1	7766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyricXKghMkJ9vxV9SKFWDYvYPpXWaMRFZBa2d8DSNhwpCvU8
16358	payment	1726	1726	1874	1	1	6305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUCaRGt7SwVBvsj7dMEYn3Q5kVwu9BqhnsQVLh8r7wA2sHkag
16359	payment	1726	1726	1874	1	1	6306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvxEfUhFYW1FXZwfe22twVhYMt7jusiKiWopNZ1orkch652gN
16360	payment	1726	1726	1874	1	1	6307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7riugs9UTS71nU3Dt3h2kEhRRLK3NDuhnkdwsZfo37eNKfASk
16361	payment	1726	1726	1874	1	1	6308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pDqn4F8ULmdxkrokviE67vMdFeTTkX4URSqCGQjn5UqvP7TT
16362	payment	1726	1726	1874	1	1	6309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZdd23BTtHsJajCFr7obmSj2r1ptdV3g19Wh5KovfeQWzAvJj
16363	payment	1726	1726	1874	1	1	6310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdv1AshE2FTo4tf3yzQaSYnRjRUmDkWRMus7epqT1oPi6nx6Hy
16406	payment	1397	1397	1678	1	1	7777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9yiR4vHrSduejDZB8Nu7TK85RXD2YLMhjvikopWNqzGiQbKw
16407	payment	1726	1726	1874	1	1	6343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TbEheZZXEqa3u9eCeXWigFmjhPkvruxk58fcX86qVFcrUSEz
16408	payment	1726	1726	1874	1	1	6344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp18Bc3F2tE2eKZkoDqs6FfNKrq2cowHsBm1dzfSwhPUGagvvD
16409	payment	1726	1726	1874	1	1	6345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpo2D774kav8oV7TZC7ZrdzhKwNPabWRa2um14MURvK9b3Lu1c
16414	payment	1397	1397	1678	1	1	7779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnBUwjSs2V5dWXfQfGkXnDVnR2a62fUKwH1sW9Y4zM7psANHg
16415	payment	1397	1397	1678	1	1	7780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8jxBvd49USe9pLJyirKGpNnrL7MF13GW1s2fPWR5DpxwfPmB
16416	delegation	1926	1926	1483	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWE5GYkM5DT6ELG6Zbo1T2P8kuT1cquEsQb3655d3zZXjNPpru
16417	payment	1726	1726	1874	1	1	6349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScw9Bc1yNTr5SnheE4Ps6ELhiZFTbSYSYSYan5UPVMJYMKhff
16418	payment	1726	1726	1874	1	1	6350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtawSvo2pPpoTaJ7C35uEVgCMGDbNEUgjcw4xFpoUHukmaB9KH
16419	payment	1726	1726	1874	1	1	6351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmsb5DsNV5JkT8iJwqRQAg7eqVAs8aVUQvG2xf6JUprLk6ta6
16420	payment	1726	1726	1874	1	1	6352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBRFpF4xkhNnXpkaFcESVtkTAUsW2v2ydwT97DJysAuJAnUkMB
16421	payment	1726	1726	1874	1	1	6353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwgCAvgBExCutHdrM1JWezEkERarcEHUPYUwF3kQHco9JLD9k
16431	payment	1397	1397	1678	1	1	7783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypSA8SnQGoP7MswUJPQ9Qxr9fLrc34P7PeAByw2L5DVCKCshQ
16432	payment	1397	1397	1678	1	1	7784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuf3CqSAvZpfV3qguvPv8TuR7pXVcABoPQs4PAtUzrpisNM4gx
16433	delegation	1769	1769	1406	1	1	27	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAxYhc3y7STy6x1LA5gGA1ktjjCJHwLXSY7BrU6gaV2QR5hEC
16434	delegation	1925	1925	1423	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZK4kzwwyvrLQSNGhUFDYbw7J8j7ZhdfrSS7BXfBZ4jj37kjG
16435	payment	1726	1726	1874	1	1	6360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpB577nRweUfqW8gLJjokHf7otzPdZFcWrVoGwqSEHExr1JUR
16436	payment	1726	1726	1874	1	1	6361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWmnaZuacQ5cmhTNVoiANJyj1EEBUFuxs3iDJR17MhYbNxJpY
16437	payment	1726	1726	1874	1	1	6362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JxHPdH1tPMeWUGBvTBNHWe64AWMX8bCjgGmXWNoWLeu3LG8J
16438	payment	1726	1726	1874	1	1	6363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyCUUm2tYoQjaE3vTkpxmWz9n3grJx4wW9bifrVktTLZJvsZR
16439	payment	1726	1726	1874	1	1	6364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZogKfg47ZARZSQEh3qHCb8EqKHbquwxeA5mFwm2uE1XuQt4YUM
16440	payment	1397	1397	1678	1	1	7785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyiHV7YgK3h1KjPENaLwVMFhT1xZazWWQD13k9Q9WuZtcbYWVP
16441	payment	1726	1726	1874	1	1	6365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhoqb8vmk8A5gRxcnvhYe2j7YSxJU4ympP8fHTXpjhe7odiBT
16442	payment	1726	1726	1874	1	1	6366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKM8YfQio93gzS73LhVJ2uMo2Yys3RimTdscVK6XwC6izqaeLG
16443	payment	1726	1726	1874	1	1	6367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4h4LYpV94Dr2E2ai63Rdc86bFCxHm64fT9arAcj9zNYMd2JrE
16445	payment	1397	1397	1678	1	1	7786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi68yh7bh7nej6ReQ8HrB3rem9TzaCf4LLpSri9qXNX4gHod36
16391	payment	1726	1726	1874	1	1	6330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFyeVTj9QVZPmRX6ogLMtU2htfzVnJ5yrsGxedHmKdJfUNTyC
16392	payment	1726	1726	1874	1	1	6331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpnGgurHv9Xu9RXZnPXsgHfMAvEkm4NGMrKAjUbAD9vajhRqt
16393	payment	1726	1726	1874	1	1	6332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9LMz8oEp81btcRBuHG9NScnSw5rHert2EYYQZJd2MnFmT4Lu
16394	payment	1726	1726	1874	1	1	6333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYWVqMDE6ukHk3P4jKbqDFGyMSSTfaEEuJUturTsrLnMCqz8T
16395	payment	1726	1726	1874	1	1	6334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFQT7tcvxrAKd1vaNVaGgkuq9hHgb6ukwFhe58ASCg7TCDU7U
16400	payment	1397	1397	1678	1	1	7776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkENp9PfQhDewgpUzDgf4iBokEkkfSBbBzsTWH22PuqB5w8hRv
16401	payment	1726	1726	1874	1	1	6338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouRNxENasSGpCvC4MCxCtRCsmyJPQCizzcgHbtWSD72HrdZZd
16402	payment	1726	1726	1874	1	1	6339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTw7iFW42zh5Kc1mRF8N6Av1c3DfLb5UFEG3pmMwBPr79to3Tb
16403	payment	1726	1726	1874	1	1	6340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGjf9ZKFY6MrAM8RbEcUKH2gFHsXk5qLGSMf5xyV45Eo3oNcG
16404	payment	1726	1726	1874	1	1	6341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkPFW3UBHKL7PeyrhjWD5z4Lr61TQSsUC2CHs7qDMD7oT6vWk
16405	payment	1726	1726	1874	1	1	6342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PV5WcshTG36nWoeG3M3fgcXbmPenA8tG3jQMS9nPEQCfE4XH
16422	payment	1397	1397	1678	1	1	7781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZepoqUYx8Dp3U79ZJTy37RDSXf1Q7s3DbfUmt8nyPNyWtryo
16423	payment	1726	1726	1874	1	1	6354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxdF7uahpDhXQq8ymPDUAHPs5cbvxqpg14xwqXRqXWLwdnKzN
16424	payment	1726	1726	1874	1	1	6355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWSz2Aoan8jnvEt1Z43MUrUjKvTMSnaoVoCbjZQhoPRPRc6Zu
16425	payment	1726	1726	1874	1	1	6356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvU7rbzBTckpzNWt7BxjZryJcxRVG6UwkuLrjRfvA1wQWedFK9
16444	delegation	1924	1924	1402	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyrmbEpJG1H9NmdUqjdzXpQDay8GHcnMcurW6cCBd8BpqxNqr
16457	payment	1397	1397	1678	1	1	7789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCDYYF8SCuhBbLAU5rKrncjBqSQMdGF7Fvh3NPoVfyZWnwMg3
16458	payment	1769	1769	1769	1	1	28	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPnWLtFuMS6iJobDcVswNasJYsLv9PiKtyGLnPrZKG4WJZ7gx
16491	payment	1397	1397	1678	1	1	7797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99YG976P8Y84HTqM5oPT3g8km4GkhK48udJ1fXALwJiVZasiJ
16492	delegation	1926	1926	1745	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRjqrCYyvp7vpxQFqN8o16mQ8DjTcYo3dA3os1AqFZGP6yEjm
16493	payment	1726	1726	1874	1	1	6400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3PNK5HtaikKKKA5jnkMFd86h473FUCwQzub26zQoZFRbXUkK
16494	payment	1726	1726	1874	1	1	6401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrosaC9EGMR46LeeMDXtcLnNFKrVKB9PLYqYmbtBLv9QK5W4dE
16495	payment	1726	1726	1874	1	1	6402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcLgRAGj4VUvQWjJvP7rhS5feynW7U7GQLZerucTAmkCvSpNH
16515	delegation	1924	1924	1745	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZbUhqAnLc25kHvShauW7wXfyZKu2HvmGZDzdrvXjYAKunyVj
16531	payment	1397	1397	1678	1	1	7807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kavkfFDxEKRuvjYM5qHMsK7XEFYtp5VrZWwBMpWLnmDt9Wxd
16537	payment	1397	1397	1678	1	1	7808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYbnyRRnRxAQ41yDzNeo5BvBZM4i9r5txGE7cv8QyfjsVj5EB
16538	payment	1726	1726	1874	1	1	6428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvQBFcBrdoY8TvCwYY3sRNLWouELr7sr3YaMBPrvq54NcLVWL
16539	payment	1726	1726	1874	1	1	6429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6R5h865vgCfQGjWLheBMXtah8148Qqx1ALHRvbCRiVnwUKyUZ
16554	payment	1397	1397	1678	1	1	7813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tPCanXchcjb4awitRCS1VCnPPDXV99iA3J9BGjKNyimTLQ5n
16555	payment	1397	1397	1678	1	1	7814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpgfks6G3hdJM3A1FacZGjXGfitLkCFZQdd7Nd6Pej1dCUYFT
16556	payment	1726	1726	1874	1	1	6440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcch3mNz9dSHpzckourXrvjhHBF1DFnod4f7QUs5TnPJqYhJ5L
16557	payment	1726	1726	1874	1	1	6441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8PEowcvsYwFU8x447cXgAdN3U83kkNzA2JbJMN5ScmTyfbt8
16558	payment	1726	1726	1874	1	1	6442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABzpVnkyXmUVcCfzGv5Uh8RPNUgoVdHYJvGAztnrCgfLSbC3N
16559	payment	1726	1726	1874	1	1	6443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTs6ikK9uY6GL9c3jcBku5ftAYrHW54FFZ7PLQZJjNYaz5Y71
16560	payment	1726	1726	1874	1	1	6444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwpE6kbAj5UhUgAsmZCA3Tq57h6iPSSWFjLSkSYXDHGVkrGDX
16561	payment	1726	1726	1874	1	1	6445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vM3GEWvxcKAaVZWATFzUuSC1oEyykZGAyv9qQSXo6M3r8qEc
16562	payment	2058	2058	2059	1	1	5	11000	11000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUo4PYSLEomND9ZpomGrsn9dKGNdxSo8VrFdUgno8uwVcwmBh
16563	payment	1397	1397	1678	1	1	7815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwLufuRycw88CfvBMPmEX1zb34YVbpTHDKXKfPtsJrfDXoCFS
16446	payment	1397	1397	1678	1	1	7787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXgmrJ4bEiMjW4hMtHHZ7iuHSqesMq6SQeyfu4uoezuRXiKdG
16447	payment	1397	1397	1678	1	1	7788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7auvMvBdUxmCPFbx18oofKB3itQoFtd9diR8Rpo776wKof8x
16448	payment	1726	1726	1874	1	1	6368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MgGXrMgZ8XaSQqfxPrLgZvRuH8HLiLNTLhYtbw78yvmWVL5c
16449	payment	1726	1726	1874	1	1	6369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNjJjHWvBnTsHLBaGL977rizREpcNGgq61UViuFfsmPWJUccJ
16450	payment	1726	1726	1874	1	1	6370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLL75pLmAgWSdNNDk6PSym1n11N4kDNBCpBLQFL934pQmpXsT
16451	payment	1726	1726	1874	1	1	6371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Vubb9enfxvoiXo31VS5PNqmS1qQpBhWUcn6zhmqfgASnJBMa
16452	payment	1726	1726	1874	1	1	6372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmDVhiKMMCvKzwiZD5v6UTFem1xDUfz5EE7uSJytVfq4ULMP4
16453	payment	1726	1726	1874	1	1	6373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEaPEMejsK6dEvPdUtPMTijjazEszGaiGvqTGa2PqaMe7W9rZ
16454	payment	1726	1726	1874	1	1	6374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yAmiX1w4MxdcT3tTh43VL48DciVuBup4sNfdGKHxr93dixt7
16455	payment	1726	1726	1874	1	1	6375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiuLzKcaDTZRKVCJUuBgTPL7bENmv4G6FmezzfeZ6VWRAv9SsG
16456	payment	1726	1726	1874	1	1	6376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFPfQEn3QE5QxRtTModYafBtm7G9kkqWvKbqZn77w7jXNnrv3
16460	payment	1775	1775	2047	1	1	15	700000	11000000	65535	E4YVB8xuKeCWid85sFVXJYTy4DX9uX8hiuzUFPgk37BjYuR2BzAz8	CkpYSs8xxJtu6TxLHfFbpLErp4t1bAZPd59d7EyPzA7hcGtXyjkcs
16461	payment	1397	1397	1678	1	1	7791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPvE8JLDUg9pGJPKphC5n6UqmkbbFDbGWTui5R1tZs7U9sPU7
16462	payment	1397	1397	1678	1	1	7792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrwrEao2NKqjzNWRkQJg3du1L94ky4gfNtUhCVBYfk5DKxvUp
16463	payment	1726	1726	1874	1	1	6377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBoz2Rskb2QQDoqL2gkHVeeuYMdwcVEgo3xaNaBFZWfjNdLsL
16464	payment	1726	1726	1874	1	1	6378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgdREbKazC83gQZZ5vTR7tWG595Xzd5GAXykzRosWyZERLMwX
16465	payment	1726	1726	1874	1	1	6379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjvFajcUMFcPSKGa42LUL5kBdmPqPajXwYYb5jpCdLpf3xyRR
16466	payment	1726	1726	1874	1	1	6380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpEEDwGzdiD1WqUo1hZaYTho8YBHVfXT1LxJHAWSJ2VyXdR5p
16467	payment	1726	1726	1874	1	1	6381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFif223e1UCTRm9RYt7StfCZ4mPySw7A4A5H7nJgfRcQ4qzBj
16468	payment	1726	1726	1874	1	1	6382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzUtny3P2zxhvQ2K6vhGoxKZ9ciT8gyunp872zRQK9bfVR5po
16469	payment	1726	1726	1874	1	1	6383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8noXREthjeAJNHyME68FrcNLBURfe9A8a8XEd7UewthiWrF5
16470	payment	1726	1726	1874	1	1	6384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5PQ3to7yonMjd6p38HiZLvu49y46BXZPtKSYhMTTJhDv5k5j
16471	payment	1726	1726	1874	1	1	6385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89Hbi9PTak7uvecwRmKkcJgmzedpAJjDR1nqbSYcgtMppQY1C
16472	payment	1726	1726	1874	1	1	6386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfKSweY5uCcaCCedFnQySZJa1Z3L4VPJUZ7pBgC3587uchCnd
16473	payment	1726	1726	1874	1	1	6387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWrsw6SfqeUzKcMFuVHpzhUdTBcfqXEc21iBaeKEqoXDQKa1B
16487	payment	1397	1397	1678	1	1	7796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZGt6M53QgHv5j9Z52dKmdcgydYbJhTCdYhnSdN9fzTUuoMzm
16488	payment	1726	1726	1874	1	1	6397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFntRAgP6f91USvLP4oFdpm5uNMWJrpee3Bh1HZr1wswcMdvA
16489	payment	1726	1726	1874	1	1	6398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tneoKGEy9DxXyWs1qZdqHwCecmLaygbJaobUVoTpRvvt9P2h
16490	payment	1726	1726	1874	1	1	6399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBU3NbpPLSS5kieE1z9tewwttbiZ5XFnHxTLqWoAc7fQ4btUCR
16504	payment	1397	1397	1678	1	1	7800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwGT9ueKy18DQh8DXDHM76S2jQhqCnaaebuXCWJoqAy8FZkYz
16505	delegation	1926	1926	1745	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKHSNpowbKKz2ngM57BQNXU461MKeiQb8vrnDKifypEUVie5t
16506	payment	1726	1726	1874	1	1	6407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENJUsBiX2Q5CBv2Ajzc18798ycdstJDLn4dSFSWXdtwhnNQVo
16507	payment	1726	1726	1874	1	1	6408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNARfNs1gDm5gU5ALceXtGFyRt1SqTk8DQ5LRCZo4RjAKVJko
16508	payment	1726	1726	1874	1	1	6409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgM7yWf8xSY4SjaHHqXt2SjXp8Aa5Vsrgp2QmB846GjQyw9vF
16514	payment	1397	1397	1678	1	1	7802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo84S4639CKvkaaLbvj1mDi8s3iHjpTDtmL7nfYqx7ZbNsE4yD
16516	payment	1397	1397	1678	1	1	7803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQqaxNg3zpm9zHAUYX7MZaYPfj2RDsBzWrkXH2RfYMXqzGy7o
16517	payment	1397	1397	1678	1	1	7804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qkAcT4xYFMkcadFzuiscRGrwxXNzN3kp18NWijh7W4zvMs1c
16518	payment	1726	1726	1874	1	1	6413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuApJzLcYUjcRiCd2wsFt3DjUJQpChKv2KaAwAr7o65c2vKHuS
16481	payment	1726	1726	1874	1	1	6391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Je8jwMKFMA417uyQ3TXtQxzc6Cmv9ZXze1d9KwtRYJWXjzdz
16482	payment	1726	1726	1874	1	1	6392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNSWDfHHNThXHP9pQGnNLSmPX9oYFSo2fEJRXxfZjjp6oSDN8
16483	payment	1726	1726	1874	1	1	6393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Jdiojz7GJnEE1kxFR6U3cZCY3Xno7PjySFK5fCcoescULFxn
16484	payment	1726	1726	1874	1	1	6394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLFiyi3imi3GBGudcresoXsnHHvpaj7wjxTHTut7j8zuDNAGj
16485	payment	1726	1726	1874	1	1	6395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo5HDzRTjtUie9cRDrMynxv5TH5kqobQrnypebZrfojFUmNLR
16486	payment	1726	1726	1874	1	1	6396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DSHDfDpUfywTAzwvtNyXoC7jq8xUhhSUNjogyj2jpyrJ7Hd8
16496	payment	1397	1397	1678	1	1	7798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFoy22ssT1p7K4NcGWC8Mq7puJEkR4g4Mmzc7FGh7oWW38hxB2
16497	payment	1726	1726	1874	1	1	6403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3a97aHDMzVb5kmGgTjzaqxAegFwYb8Rki3QtnyLbMzC6UuU9
16498	payment	1726	1726	1874	1	1	6404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwxsrSnYTpwWPQEMp8G8YE8waPL3tvGbXKLAL3k5QZN9DGDJp
16542	payment	1726	1726	1874	1	1	6430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwsZ2cpqrmgYzLxea9nDoPg9P4XDRCULVNAEqy38t9Xj5LKrTL
16543	payment	1726	1726	1874	1	1	6431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdd5Z7cZaET2mWRPcUcTnRLFjwuNdRFCeyKWXtbRYC2XbrkJ9
16544	payment	1726	1726	1874	1	1	6432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EnVad1YkB7CZbyMtQ8UgzjoxtDNSSF3oNsQxSMJo6x3vP63z
16545	payment	1726	1726	1874	1	1	6433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgBwqDokTkn1usvWYZDUdLGJem2diVQT127S9AP6kSR9vkwXo
16584	payment	1397	1397	1678	1	1	7820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28bZrfBgVBwV9FcLkMrZayDV67sg6WtdcD7uguj4Vy48AZTHu
16585	payment	1726	1726	1874	1	1	6461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MjScf7sgNHR3j6Msv7Ehk4sY2pKKVu2xmpttXnEa82bJ6akm
16586	delegation	1769	1769	1652	1	1	29	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEWsEJUVQBWQUZGwSV2WFxubj8FCrCXuoFpVM6ehyhHpT8DiK
16587	payment	1726	1726	1874	1	1	6462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJi1NTwupcydYJsJZtWqd9LoyTpfnnJf8Fg4gb1FwP96Fupn6r
16588	payment	1726	1726	1874	1	1	6463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mJP5M48cKarYn9PzPiieJJzdg66hveQH5eLCh2Z3BnAZovuY
16589	payment	1726	1726	1874	1	1	6464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVAmfghEYz5dhLu3uAgCk7AoqapMWWBHFrg6FHmagjGon2eYc
16590	payment	1726	1726	1874	1	1	6465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5sSYLSL2MkZCzdcB5ehH5vmxAqRxAuEiBSs9wyehzY3CUQio
16591	payment	1726	1726	1874	1	1	6466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgd45aEqgNQwWLbYbdmmaTSsq3d2tJ7pAWYejv1jS3RryS1c92
16596	payment	1397	1397	1678	1	1	7822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaQvou5EQM1AfZQt2XMg3pxgdEEN5bCbon3mqZuZD3WDU136L
16597	payment	1726	1726	1874	1	1	6470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvXCbHRrg2jBPsAuqQWxdvvhzfXFcbyuM3DwNM7q87jQTjRj5
16598	payment	1726	1726	1874	1	1	6471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfQuzkvAKecKwnot4tnV5rVkyf2mULpeSSAEmxABdNcY15po1
16599	payment	1726	1726	1874	1	1	6472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU3UJZPSzJkjUdNkydCcrBJVyRSmboGTW62moj76LKGhhfGMn
16639	payment	1397	1397	1678	1	1	7832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekWGGqDLf6vWZrnTACRgpf3tNFF2sLU3hCMcxT9o7GKLL6bjf
16640	payment	1726	1726	1874	1	1	6502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XCxVpGkTzCDvmnuYzVDPuXqJAg5jRP9v1JNFtcriw1PmzszE
16641	payment	1726	1726	1874	1	1	6503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEpWuAL7Tz1Kgr2uBj5VVZn5Eq37bEc2S59KiMovCJaUacRVr
16642	payment	1726	1726	1874	1	1	6504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBUh75BjNTgwCUh9jMwWuaMpU6Mo9fY8FnMc9mZrssQzLKHfb
16644	payment	1726	1726	1874	1	1	6505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCXPCGiXXK9Now1BpthRHwhz6kRqsNLp6cimzdAJ11aneRd83
16645	payment	1726	1726	1874	1	1	6506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriPghRLhfekyFyuiEzEc5vqy1LxVsSpMGvspXFASfxpR24UYJ
16646	payment	1726	1726	1874	1	1	6507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBZE8kYQZsymM2j67dTyhsiSy7WtEW4xuwyC91LR6ENZoUbQfU
16650	payment	1397	1397	1678	1	1	7835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93dUA83TBNCStJexh8WUUPyqAq59iTpSWPeLfJZuHV2y9pPH4
16651	payment	1726	1726	1874	1	1	6510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnubWyWJYqk9MPMHXs4QzoPwg5woFuweywThfnnt3Cb9c9JC93
16652	payment	1726	1726	1874	1	1	6511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwBp2i1fG8gGdHnvTTLs3tcuX6oUs5WdgGZCLKH4Y9zoCQ1y9
16653	payment	1726	1726	1874	1	1	6512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsMQjUp38fvFEG8P3eSBiUnYNSbVPZfJzz3FxC3iQTJGoxFoy
16658	payment	1397	1397	1678	1	1	7837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrt4o9hkGYiwSf1ENGKJKab7GCYnienAdd8vDDHhwZv6EfbCB
16662	payment	1397	1397	1678	1	1	7838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ3xkiv5VCTGwYNygWV45jYY2dG49xvB76paAvTQNBAXRsTJC
16502	payment	1726	1726	1874	1	1	6406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg2fSQDMVjZhj6LeHNj5wbiFFVbHVv5zPoTjb5QQHJD5oK7pqz
16503	delegation	1925	1925	1745	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mCePKWx3VJQ75aaC8sYbUoFEVdrxVbwoUuMt1DUHCPEox4bS
16509	payment	1397	1397	1678	1	1	7801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfJCkZz8Kz41M6y4EsFFJFphyoTdGiVhgRWFGZcMa1njotyxc
16510	delegation	1925	1925	613	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPRN132tZv8PkbaVQjoGLzNpWpZ6Drop2bcNcToAKFC5rmtDk
16511	payment	1726	1726	1874	1	1	6410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4zgZvj2kiqoUrruEf74jTrFM5w5kGCUc4yGMv6RefvgEoQQh
16512	payment	1726	1726	1874	1	1	6411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD41iu6CacuKL2dg85vbiwAuKdunhh1urMDD6oJLbGU7Uo6osY
16513	payment	1726	1726	1874	1	1	6412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxRZQvmAJYMQfBgpyD8KfCaQfkomU3ZXT9R55X9U7xnqKW3Hx
16525	payment	1397	1397	1678	1	1	7805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpxSpimMCRVDccNjYKXXiwEuHVHQW9FmeQtE7X8gWwNypbpqS
16526	payment	1726	1726	1874	1	1	6420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizEa5tZ6LKnBh1w3nFAQccKs1i9ZaRAj83GgCrRa1aGtgCdjX
16527	payment	1726	1726	1874	1	1	6421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6uXmYYpYxPYpbHPX3UPBVJ2eLREQzD5UGAzVzNz3TufjnjM6
16528	payment	1726	1726	1874	1	1	6422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcvm1KfZxQGhM2VSGakV3QpAd312KBnXDgGFviEW2VZPpS12v
16529	delegation	1925	1925	1745	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EJnMz8AKY2WvGrvkTxqwDnKaxhQUAy4Jui7VmEJoUcs9Shvf
16530	payment	1397	1397	1678	1	1	7806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqyDpZMihVwAt7aGmX4oaGfDHcruGbfnMSc9SFXh7KyMebgix
16540	payment	1397	1397	1678	1	1	7809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeZCs5UiCjAQTLYnuAkVHTsR5bBK6E75xcRxbGFv9cUQDZRSBW
16541	payment	1397	1397	1678	1	1	7810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2tkgHmbZGMbenHoCQvACCKuhzCrPXMLxicECkSFrjY55XoyD7
16546	payment	1397	1397	1678	1	1	7811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTxKDoodCJbArGK79ERtGVUn9KWm5LaYx4dJPLdZzN9ZuCBVv
16547	payment	1397	1397	1678	1	1	7812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8tVdY5WgvLzA81HKu35nNCANUKG6tKupXn9sGrtPPxfpm484
16548	payment	1726	1726	1874	1	1	6434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmYcL7cuZf7q3Pii9ta2ATko7mcubVEQkhWZsWfWEYDYCPADF
16549	payment	1726	1726	1874	1	1	6435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkGNC7kDx6ZnBbyXGm7mTN4HWrNeFuVGJS8z7QY5d393v5Zny
16550	payment	1726	1726	1874	1	1	6436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cufQdEE9c9jbMAKzKXUtritpRtGajkhozzTCnQhqyZMMYzQw
16551	payment	1726	1726	1874	1	1	6437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEegHmbncymChqGWX24216RMG7JkEWEnZeQWKsHhHnQv8S3p7
16552	payment	1726	1726	1874	1	1	6438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTuR9BMF36D5gS9C65qnxZuf7Fi682Ys86JiuCERD1yYD9SzF
16553	payment	1726	1726	1874	1	1	6439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmXGhgNkYo61PqEEFmPRFWpPMtM2KX43hPTE3EvzFSmoMSfs3
16564	payment	1726	1726	1874	1	1	6446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMk7JwyjTNwWdXT7fxybC2C3dXifVhpeqCYwEY9p7km9oukht
16565	payment	1726	1726	1874	1	1	6447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCr573a49m8Vz3tn1FfpBte6Be3WWf8jL59i7TY9qJShv6aJC3
16566	payment	1726	1726	1874	1	1	6448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm2nqbaKSjBFpVorq8zCjGQrJd7xd2he8Gyvprz7gQPcokiXpT
16567	payment	1397	1397	1678	1	1	7816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSED8GwFHAHYNGgCDQ7xBqrNN2fT5DrdHwUPMVUsoxWMV9yjom
16568	delegation	1925	1925	1745	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQxtvfyewLjE1j2Tm74VuygjoKUy5BawLWgqPVoSztidrpQ4y
16569	payment	1726	1726	1874	1	1	6449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mS6qXUAQZAxcb7BVYMmUZ5XXui442Am1ExKR3BGFKnTWHehU
16570	payment	1726	1726	1874	1	1	6450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwexwy5vxVGHGiesKVat125jknsSw1tB2UHdJ9FKJEy8npkuNN
16571	payment	1726	1726	1874	1	1	6451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxz4jQm4Cr9pLMwmMi5frbKW8qaErBmEVN2u5Zqyt4V7S4Uk1
16601	payment	1726	1726	1874	1	1	6473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4eTMos6MsRKFoPrMxTZKFAGnfVzzejAsbRLLqwhoZ85gM3bM
16602	payment	1726	1726	1874	1	1	6474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdw2ZNsfA1qBWUgDsgUrGUL5oRAGEPiYYVhjjuBdwcPBshWZ33
16603	payment	1726	1726	1874	1	1	6475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5Eiyw57kNfUrEaygXkoC6b9EaoCEJrrJF6a7ZGs44E6PsKFg
16604	payment	1397	1397	1678	1	1	7824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TwQ6JCCweXEH8FycqHEbqwTooYhR7i6BdWeKHZ3syodgcS4z
16605	payment	1726	1726	1874	1	1	6476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNZT9j6axjfmjgMn4AseNqK51hDbYDrFgcuHDVt9z2LHFMojW
16606	payment	1726	1726	1874	1	1	6477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAebvFtAdVHiMJFEsoD8WbhH4dbVfsQDCBLrKZtbQL3vTuLzxE
16607	payment	1726	1726	1874	1	1	6478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bAXdbRGHLh35SjiFXsSStNXTbz6NA3iTygQKEh5bnnY1Ke3T
16519	payment	1726	1726	1874	1	1	6414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYE8RenqeMKCm66xnS4vyyedpE5jrctZ6TW8SgVwUwPe1DGB4
16520	payment	1726	1726	1874	1	1	6415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2T5ngsAZrpGxK3TCgSsFz8mx7k9vXY6qFnZxXtF1oV6eiysW
16521	payment	1726	1726	1874	1	1	6416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyE1YTB91BG1bK7XB2u2uubceAszL5NQ9HcCPKcsNZm7MQHov
16522	payment	1726	1726	1874	1	1	6417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsG97AR3hHpJUioDPT8AD6Cvne63YsAxineBdJwjJVfJe8PymK
16523	payment	1726	1726	1874	1	1	6418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4vK9gWadgbhzcrMM5GTPc7SntMLJS7QSYptDp4HVaaadKfsDy
16524	payment	1726	1726	1874	1	1	6419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pQAaYHn2jdHuRyGMmNvg6Yqga73f5WW68c1FuFWT4M27C2tg
16532	payment	1726	1726	1874	1	1	6423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ioN4jGxXeKu9B2jQN1BQst67NytCBpX9sQU5NpWfmrM35xne
16533	payment	1726	1726	1874	1	1	6424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvjcyRFBfPhSyfpdL9qqajVh3iN8J6nk8HisPLadKVrv7hQy3
16534	payment	1726	1726	1874	1	1	6425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99jfY2mNnmBHzNZFvRYbuarwGSYNs92h77ubC3jKiro2Vdm35
16535	payment	1726	1726	1874	1	1	6426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmPJXopcnKUC39azH6fzoJ3QCwD3aSXT9zhqasADudMwExrhT
16536	payment	1726	1726	1874	1	1	6427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBJJye6C4dSMCztcKueeUqUQro5xSa5F5JHjsXcdDi7nRrjjA
16574	payment	1726	1726	1874	1	1	6452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRAKa7gzmUj2yW7hrN9zdg6P2NugQRtNdoz4WBSqWYMCEWG6Q
16575	payment	1726	1726	1874	1	1	6453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiF2TffwB558XJzPxquAKGF8uyeSC4u9NsA3cqu1Z3n8PGVKD5
16576	payment	1726	1726	1874	1	1	6454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTWWJRc9h2xwrsngh9z64oPACerjiEVk2jX5tPqapdpAPNFA7
16577	payment	1726	1726	1874	1	1	6455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkdHAFTdYHvkQTzERKvByjYHnkcxztsTHYK4n224goXN8ho3R
16578	payment	1726	1726	1874	1	1	6456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbDV1tKsuYkFgknXYk4EBis1JL1ha1B9anLpCzAxWtVhrsTTf
16579	payment	1726	1726	1874	1	1	6457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehpUEizwwp4Yh4J1HU77oFUZqGGmyVaGxQRbRmyVwNC2TdPbX
16592	payment	1397	1397	1678	1	1	7821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBi3tmV7h2YFEHFDK2zyLd4DRFgUnWVP9eg3fogNyh6ugj7uVe
16593	payment	1726	1726	1874	1	1	6467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GYZAfxLjdkL3xtT8JQSJ2FU3ruhut7zboHkACbdW7tTQvnQq
16594	payment	1726	1726	1874	1	1	6468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8muQxmCzcqXran99xfFfeuQX9nWkQv7cnz96N1ZVEuKGTeLmt
16595	payment	1726	1726	1874	1	1	6469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ZbxCVQyD6VEF2ofFEKJnGYypCbvWuLXm2wLJqZ6emRHxFyF2
16608	payment	1397	1397	1678	1	1	7825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGoXv5b9H9rHaBBhNfHMAQBnGBh3pDsUEfJFMtXvfDKedDbwN
16609	payment	1397	1397	1678	1	1	7826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cVYKGoxRRUNuAnJ3eHwrY3BPActhJuABuDwhNfzdRQmvumxu
16610	payment	1726	1726	1874	1	1	6479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV4Ez6NiKByAvVunzCDUGQJCcUWeQRd32K2zSceawMc3xhVv5
16611	payment	1726	1726	1874	1	1	6480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTBbHMR6VQ2yAras2mpPqfVtLAE7FErEQfr6g52S44H74dQ7N
16612	payment	1726	1726	1874	1	1	6481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKYxLZtYNhSqGjrqAmaBSXuJ5XxY2k4wCNJjzMrugaMk997Ut
16613	payment	1726	1726	1874	1	1	6482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiTamMABxq3y2mLgVfoaWL7tKsSGu4eekBi83WmQTNGeENQry
16614	payment	1726	1726	1874	1	1	6483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa71xnhfjVVyLw3ayx6RTvKi6RbpMdC55wFnk5x4ZqGZmWC3hmw
16615	payment	1726	1726	1874	1	1	6484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBt3LiGTj1d9XCoAw2emcDhmqLEybjtD8gWZicNh8V2YpRUUcV
16637	payment	1726	1726	1874	1	1	6500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fit3pPyeu1aLFtztC7p8G2tGx1EMhUNgiYiNz4mDrRWTGngb
16638	payment	1726	1726	1874	1	1	6501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUZzdE21sfZu3XMUzH1aRqoB88kQUJzhh6NWZmesUmTD66c4f
16643	payment	1397	1397	1678	1	1	7833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfaQ3hVhHkzNgmAhiJBP9e9k5qQ1EDUgewJUag1VCfyBfCf79
16678	payment	1397	1397	1678	1	1	7842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxysq2dVDRdhRbYPGQSgS9iMuXDD9QCET4wygmswJ69tTeVxjv
16679	payment	1726	1726	1874	1	1	6531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgQeeRwPkzG5EAe3Y5SpK78urDP3cM5xpF29txqzjuB7yfpGg
16680	payment	1726	1726	1874	1	1	6532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9wUnVwQMy8u8PKRuMtC4zVR9zSLRxaSYgW2ptNNiWA3u1pPH
16681	payment	1726	1726	1874	1	1	6533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8vypPv7Zg6zm3VoFVqZFtiYFsDStWUavpUJmsgbn61fznWWh
16701	payment	1726	1726	1874	1	1	6547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4zfSC2o59gvctxYZxgNv1iaTYWpMbhZtwXaW42ZwDeQEsLoFb
16702	payment	1726	1726	1874	1	1	6548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhy6TKYEM6AMG4d5CHqVbTTJZYThjMhH8XKJD2RsvPJG2NaSRH
16572	payment	1397	1397	1678	1	1	7817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHLBv4p5QtWWLNnr82HbWkxawTVVJZHSae6cNmGgNvrgfszKD
16573	payment	1397	1397	1678	1	1	7818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgN29UaHs6JFTkBE6bTSKXG2mmQd9Vcsg8qMtG4j8fSxbPET2
16580	payment	1397	1397	1678	1	1	7819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmesGoZZdrviSasUqbKXhSqhhXuKiqpjeCxHpqQbkeLe7JiwQj
16581	payment	1726	1726	1874	1	1	6458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoM55sWoMen8NWRSZ9DuWtVGARTDsrpMXLuBoRmZEJjaXRqsHz
16582	payment	1726	1726	1874	1	1	6459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMnuE5d4LZf2ifxoMsvxH8bF3rPxAutW87K3H1yxehq7XQt2w
16583	payment	1726	1726	1874	1	1	6460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyc8q6p5LM3yGws2fJGLDQyMPYtTKT9jG3s3HznNi5zYgNSEvn
16600	payment	1397	1397	1678	1	1	7823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTA9aZ9NHejHbUzxLPTuB8rM3UVXMkoMmyWfyGNevNG7NawMxZ
16622	payment	1726	1726	2103	1	1	6490	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZAGuyQuUbDWMnNPBj9oG7uShzNERgjX1s11FMyWU6KChwcGZ2j
16623	payment	1397	1397	1678	1	1	7828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoi859T6kwJGnvfixN8wWCtUxGbELfDWSMbwcezA3guqPYjsZ
16624	payment	1397	1397	1678	1	1	7829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5yCjMZS3nBhHYFD4gvccFjsqnc3mB42EzqoCHv8Mh6pPCVVu
16625	payment	1726	1726	1874	1	1	6491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo7XwDqgDzEXQYiDYkcxw4X2zdAF7o8EyBv79A5zsgQXq1HLa
16626	payment	1726	1726	1874	1	1	6492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBLBYoidB5hZgJ17dR94Qj5Er6FAQQcRw4VghvfgaXxh5uDh1
16627	payment	1726	1726	1874	1	1	6493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eCL5e8Q8qjLDyUjzxfhWMXatNK3uiDibL9rHFgDs3GchQq1d
16628	payment	1726	1726	1874	1	1	6494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3QdcdAzTJAJwiAz275PkZ65gYrSEgAthmQaXXgANqMP8VQkYL
16629	payment	1726	1726	1874	1	1	6495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg37CCnWZDi3bCG62NghwsMPnFYqncv8YzZpjqcd7KWsEnDAab
16630	payment	1726	1726	1874	1	1	6496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiJQQTS82u3oA2wsSCjwtWQV37Js7wprDz6zLUEG2mpq5ZmuN
16631	payment	1397	1397	1678	1	1	7830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDWdHJxnAx5p8zHqzk6GeS5PSorDgcg91MRZJHbjpckKCYNR3
16660	payment	1726	1726	1874	1	1	6517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1Dt1muueAAS1vF1ghpM6V6cjfNe1tcT9EqzfDQk4v64QjXUT
16661	payment	1726	1726	1874	1	1	6518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaZ41ww1DtLTVfrbqLrT16kUsRN5nC4W5GohoHxur3urvZb4e
16674	payment	1397	1397	1678	1	1	7841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AcLHqymiCvNG8bCsm2FXWwNWMdpALY1XY2wvho9GDmnuakzc
16675	payment	1726	1726	1874	1	1	6528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBx9Y1DN8eeCykVmAvNRbo61KbDXxxdfx7ZyuUB2GWMU3KchS
16676	payment	1726	1726	1874	1	1	6529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVW6tVWL89YGGQRNALzgSsSE95vcXvrECk3UQQQSsx9XPUr22x
16677	payment	1726	1726	1874	1	1	6530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPsWA7RTwCU2nNZRFVX4wFz96wyS57yTYB8fFPhqrBucVz12F
16690	payment	1397	1397	1678	1	1	7845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsmGM6ez8WNC5kdLDNLFsJJakV562ZgTDathJ5cmEiKCQ7DGX
16691	payment	1726	1726	1874	1	1	6540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVDFwd9L2tNgthLYhAEfFRj8brxaH2cJ1RDWDfD8VQEAne3fJ
16692	payment	1726	1726	1874	1	1	6541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJQQZY9hxmWXXksMtSvNzAKbnwxUfMJWTuJEVaSB23j5ei7FcL
16693	payment	1726	1726	1874	1	1	6542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MZDqd8raDxbATFtGBZi8UvauXwWKYAmATbGEj33ZwkgtwT9m
16717	payment	1397	1397	1678	1	1	7853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQ16vTUDC3KFERQpnunDasSH3XrtHopLUaBLfbZzTruuMXBGC
16718	payment	1726	1726	1874	1	1	6559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyoHxGEvniCYHqKktwC9r5DU32oW1jDAueEjtUinqrU4Tu3vG
16719	payment	1726	1726	1874	1	1	6560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHqeSxuMtepgv82tGD3G5vpCrzrpXau6iJphSJ5h5haExGEb1
16743	payment	1397	1397	1678	1	1	7861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsTdWrGjVLqYeS3wdMPLeci9UbUXmmdE4GuW4CmnNqw748QgY
16744	payment	1726	1726	1874	1	1	6577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi6xpPUgjkj34rRcvXQDg9SEa75NT2ALZT93PvbksmTi2f246
16745	payment	1726	1726	1874	1	1	6578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmp9N5Vq2wyXi2jVR1bQcxMVR4EXGN4GK71FhX4yLyv9D4wn9U
16767	payment	1397	1397	1678	1	1	7868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UvgzwB9UhYCeFZpvsA9MxhGsiCgvt6L1pSLR2w6j489j8ZN9
16768	payment	1726	1726	1874	1	1	6594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2Njj179qjhao6wkjHVT9zbeLhseCzKX3rXrY6mg7QGbR3Rya
16769	payment	1726	1726	2105	1	1	6595	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkG4YdcMiaXHvCaz8bUN2Y5cuc3RYcrcmBKEMK5mVpm7HLUgTF
16770	payment	1726	1726	1874	1	1	6596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyomRvzhFC2ArJi5yKAw7o2wDCjL4ok8Ngp8BJP8EkjHWYukn
16771	payment	1726	1726	1874	1	1	6597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGjMrxSp8A4MWZ91pvYXWZjzqph6UQG1yBFCdGS8BkPeXJJpT
16616	payment	1397	1397	1678	1	1	7827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjRLCgriza5QKFFGzH4gcutDtxrq9gf5ETnYovd7vikDvFy52
16617	payment	1726	1726	1874	1	1	6485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBN2z5XGiVaWBEywgfgN6B7eGpWFkTHa92H55RsdWZCowGmsQ
16618	payment	1726	1726	2103	1	1	6486	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa2R9CGf3YZtM4ucsJeZiiM1H9GcR3mUFvR9RFcfhGehTKWwuHj
16619	payment	1726	1726	2104	1	1	6487	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdywUavbw8vB1j8vA9VtzMJTUN1ceziLJhSJ1HPGbiLJAh79ST
16620	payment	1726	1726	1874	1	1	6488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wcHyggCrdjvHLReaMbcgCUaQpPLVhky9P578J7i4BejXV7R2
16621	payment	1726	1726	1874	1	1	6489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFyZ6N1uiLfdJ872nme3oH9gUrQHtcbTKenHLJUeghyizWF4D
16632	payment	1726	1726	1874	1	1	6497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnq7M76ZSr1HcKnXdiCV1gyRjUb59iVxuQiHdckBM3MzYAQ7v5
16633	payment	1726	1726	1874	1	1	6498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68hnHHaEYgh6XvJYaxxN32jG5ijTG5juhSgLCaEoQq6rHHyYh
16634	payment	1726	1726	1874	1	1	6499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYek5v26UPQMwyoaNRvnWtZPCcmsFpqhaEEL5gxfHceo56zSUoU
16635	payment	1397	1397	1678	1	1	7831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUdVfKKMRq28uaXncjCWG8F6Gmq8hPpjr1xep4hSounxa285x
16636	delegation	1926	1926	1745	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Z2pih3nf6BD49NtVXbbm27ZdexibwpHt8re5HqryNtZbCGU4
16647	payment	1397	1397	1678	1	1	7834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpzZ6sXRW1tpjP2xxQyKoBq3BGkqE3GucgkczSwT7oah2T5Ri
16648	payment	1726	1726	1874	1	1	6508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvLC9PgaVFaVkZxFdw2Cy6nR8XvhaL5F6hWD7FAnZWx9TTAGu
16649	payment	1726	1726	1874	1	1	6509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaj5MGZ873esdwnsNFdosny1EC2WnQSZytp5dUF8HBBcZeSzh1
16654	payment	1397	1397	1678	1	1	7836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AbP2ujcqG8SddPx6MCTkMVHWMj3EiVUWQKkJ7wbXVfc37tKx
16655	payment	1726	1726	1874	1	1	6513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9YYBEJGkEVE3s5hHYzNKdjCYrKUhhtXxTmyRJJysMBj71knM
16656	payment	1726	1726	1874	1	1	6514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8esq1PLZJVjK7QaDpXs6UNuksUrjysHEtpQ3WF3Jk8gg5mfu
16657	payment	1726	1726	1874	1	1	6515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkY4YQAcGwbgcuekWxBiFTKEF1Az7E6ztCUtuM1YAA5sneiM1
16659	payment	1726	1726	1874	1	1	6516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2nPMic1tNbQxVNmipmb2uX5STAswpzLvyM38GpFCcU4gQ9UJ
16686	payment	1397	1397	1678	1	1	7844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKXJhsDF7Sxvo2ACc8P14FQFJxyoYKSmdzpNJSQZx9C8z47KS
16687	payment	1726	1726	1874	1	1	6537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwv4y7DTo26XqYT5MjRM7KhXrMAGZAxTzoQsQUypBreSNZRL7q
16688	payment	1726	1726	1874	1	1	6538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpRxqtixLHdNyQvnNsuyhd7U7Li79SxnWaF3DXypeWpd5254h
16689	payment	1726	1726	1874	1	1	6539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4WSEZYVDqdhTA7QKjXJNPtmYuV8wLonyawVyTiZc1d3T2y17
16694	payment	1397	1397	1678	1	1	7846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZthv1nyS1VdPaMPBvJKmn2rX82KLfC7T1e1xBdyni11je8ogzm
16695	payment	1397	1397	1678	1	1	7847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3HCuWCYB8rHvh6T5USTKnqCrE858fGfootEeM6k1T7qTwZKL
16696	payment	1397	1397	1678	1	1	7848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwChdZnTVNPHdB1Skk3Qww6Yb2qSmYVJzXLFAzDcAXB2eAu9Z
16697	payment	1726	1726	1874	1	1	6543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu2qkd3tSqxyxAn9WUKomZ8yWY9eS8anKCpJSEFBssrkngv3H
16698	payment	1726	1726	1874	1	1	6544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSeEZVkCrx53Ur4W2wFKGfoCEt6YfgV2zC3pooAmQUwiQpHW4
16699	payment	1726	1726	1874	1	1	6545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvr6prib6ehRrfQ58ZumnzdKWoLkfu7PPKWws9UxkAsXvoSWM
16700	payment	1726	1726	1874	1	1	6546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zHJaQNoBinci6zdyFevijyF1D6nMQ1Sjts6pPBo9PR3vmg88
16705	payment	1397	1397	1678	1	1	7849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHurkDhmBiWpeQ6fGMANE4pppLpvvwU6hFF4QbHUPoCZay4P9h
16706	payment	1726	1726	1874	1	1	6551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTBbUNbzbdKehnKcLCzaJpraVBpoGDKeCJQncUTmNkyEdXjK9
16707	payment	1726	1726	1874	1	1	6552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs21B5EFDjvpoerQ2tsXCoEMW4wKs8H8bTLjYRHwgsT3Mq7bJ6
16708	payment	1397	1397	1678	1	1	7850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcZPpH9Sxwff9ATBP2kQuEAHschtC9Z9iPUfMhHgan7tC6iH7
16709	payment	1397	1397	1678	1	1	7851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnsURv7PBs8byCqXpySXvt3MQbofRk6Hij1vFvGVLRSeVgrBF9
16710	payment	1726	1726	1874	1	1	6553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LMzp3r8AoZ49Gu92bENMtpXuSa4xNCYZbsCokYLdqxZB9Hud
16711	payment	1726	1726	1874	1	1	6554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEp2SeGkykT6qGe5FKToBBHw5xKFSveWqZNtvVAHFfMSoZYRDv
16712	payment	1726	1726	1874	1	1	6555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWh1zGR7ffwMwPkxNxSRZ2npom4T5kM8qCrpMJFe5wFBpyjWGL
16663	payment	1397	1397	1678	1	1	7839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweT6FmHdbTgSgqQXwkMk59LMRyVCtSYTNmqw19ZzHFZ29DDit
16664	payment	1397	1397	1678	1	1	7840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAixq88RvaBDDMZG1CkkS4vg6uK396TcV1ZMhQPh4h5LPcs3o
16665	payment	1726	1726	1874	1	1	6519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDirBsmySaQ3KkfRxGtPgMBazyUjrBuUbQsYWmzQ54FXRhmzy
16666	payment	1726	1726	1874	1	1	6520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpfYZk9kJ1H2fGngEoPWEjnyGgGi9kGNwgsrTQHdJhQGtUXPcb
16667	payment	1726	1726	1874	1	1	6521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWnYgvUK7sguwnMWdLPybVXmxaiMBdZhtBJWtKdbkYG2DY4vsW
16668	payment	1726	1726	1874	1	1	6522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHJ7aDGK5em4Zr8ZQUNCyxdBn14GWXNRZ8dqb6AtXCwVr2DHi
16669	payment	1726	1726	1874	1	1	6523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9cjcTbMYN2k2h5D8mu9QsFEUxkoKNoefsDf75BZvdqNxHeTj
16670	payment	1726	1726	1874	1	1	6524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTJq1XwWiHMrenGmiwmMHGtWrzfskMJL75MRkM7hNM4vzxMCp
16671	payment	1726	1726	1874	1	1	6525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBoxKcbdNQ5VrpS5eiedSfYpCTNUoFPTMfCXMdi5VDgYamQ9Ce
16672	payment	1726	1726	1874	1	1	6526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrupsYaRTRdEbNtxEx7DGDfcPmTy3bWZJjcY7BipYiAVk6ytR8
16673	payment	1726	1726	1874	1	1	6527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBPaESm7AYHBXWxA6yAZW1YqnB4ETtzJeByYTRn3dXJnx4FnL
16682	payment	1397	1397	1678	1	1	7843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdArdZKTcjdBUoPaSQ2GtvPpdmWHuBXRjPvLsznhtXTtQURPF
16683	payment	1726	1726	1874	1	1	6534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLPkwkVhEURsYZQo2X6RnJvH4aFMDovMKnwEBwm1prmXh1DKR
16684	payment	1726	1726	1874	1	1	6535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4giGdGTUCE1VEvMXNf3XmtrMCfcTjmKyUMsh3CFjdv5RS8W5R
16685	payment	1726	1726	1874	1	1	6536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsCQZiuPWPwDNvaYD36VTg6KxJKxE8o3xJGFdT6FHNNXEZ83F
16714	payment	1397	1397	1678	1	1	7852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxf64MW3YyDsZzupErGAHH2jvX2nNZstF3R69CViUBt4H2tax
16715	payment	1726	1726	1874	1	1	6557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwsrdaSUoLcVvLth5K8c72wVzZETnRgsmaPygJBM9T1jEoWQp
16716	payment	1726	1726	1874	1	1	6558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgGXkZZ5LcRnZwX9T2NdVxBLCexnsVn2FbunYLFuSwuYX95c8r
16720	payment	1397	1397	1678	1	1	7854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8uDWB1jW23WqTtvN36WynfQaJbzaZ7yPoNoVzYXbDYB3oiSJ
16721	payment	1397	1397	1678	1	1	7855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxrUieM9HyBbCmyGQsPQVJ8fdxtX4LswmYZQSgsvb4ELeAQxh
16722	payment	1726	1726	1874	1	1	6561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWrPZvqJiCYJ12SSpmhs9mF6uzYSFG5e5QYnvtj3rGa36jAt5
16723	payment	1726	1726	1874	1	1	6562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75YMH8NmbEvzdugwthemWX5wX2BBXzd9pGaZKjZdGfYzkjjvF
16724	payment	1726	1726	1874	1	1	6563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BGko1KfBPy2Ly3pvo1MSiuoAukgKU1fCm5vuKYdQp9JEYEYy
16725	payment	1726	1726	1874	1	1	6564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUtXLE9g3om3z2aufC5SiDQbUSNenuf9PjC4RHzhg84hgDn5X
16753	payment	1397	1397	1678	1	1	7865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2gbtfDUYYBAc6XFMGZvEdEBnpB3pLr2jhEWioqw37MadP41m
16754	payment	1397	1397	1678	1	1	7866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9Zmh3Lf8mtarJ8Jq26TsY8kpgyGcMhKqLH2VSSfnp91CpkgJ
16755	payment	1726	1726	1874	1	1	6583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtwMPJtFjxKqaguZALfyr6XbqcUj4Ey8TwSEmGQnn8Dk234Yx
16756	payment	1726	1726	1874	1	1	6584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMw7nBuENq7aZhc4v5RG84XHf1Hzv4TcFqWQgW2nMf1VjrJzEV
16757	payment	1726	1726	1874	1	1	6585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cSxVQNZeksovRU5tJgcfGMNeQ359gDT4swMjxLDbnmGnmVDv
16758	payment	1726	1726	1874	1	1	6586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsM87vyuMWjRQh9vyuRmmaBLhgwZr4Xpnou8kbNzobiGxEpoFX
16759	payment	1726	1726	1874	1	1	6587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumG4yo14N95vhqoGaSJckTBnSvniLzQp2bjvQVPbvUFU6de6e
16760	payment	1726	1726	1874	1	1	6588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxw6V3DFq1aMuwVnR3b6Hx3jM1Mfod4pLpVwsmmyxVQ8ag8Lz
16761	payment	1726	1726	1874	1	1	6589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBZgHHg7QyAco2MrC1KuA3TXNXscPFALZzEXEFyN1wtf5tVsmz
16762	payment	1726	1726	1874	1	1	6590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvbgjeLqD7eggSxkBjC6kiLQ1nGBivK6DcJ38a9ZYKqjZSsSr
16780	payment	1397	1397	1678	1	1	7871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfh9WiFAWiYeQHjTSoKAK5nJ3YUBHZki13Ri8eEAYjZATpmaZ
16781	payment	1397	1397	1678	1	1	7872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9h2STxAwjFmbMcshixZRFrSSixH94DCrWAb2W64oKEuQYKQM
16786	payment	1397	1397	1678	1	1	7873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRqnjusTe2Ut6Q3tYacNcBM9bqCGMmYT5VDtWxEmRc7f4hPcg
16787	payment	1726	1726	1874	1	1	6608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGapKikwESGWgpGqVxhZDnvLzE23V3NQQLEvuh5soZgJsudNQ1
16703	payment	1726	1726	1874	1	1	6549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2kk8m4pXEKFNLgEZ78q9QTAgmeQPQQJj97YWmsXRQFmdonwq
16704	payment	1726	1726	1874	1	1	6550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbgwcb3gPm5u5DvkfTgjkur7RCmvR6Zu2CabFtdYkJ9Eh43dk
16729	payment	1397	1397	1678	1	1	7857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtH1RVstgmt5rSJU6gbuWz2zSJCB7cczE8MwFUzBwwix2NddXw
16730	payment	1726	1726	1874	1	1	6567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxS8iebwsE8rNgEaWZJzVwBsKSZhbv6YxTWXkFMPUuu575pYbw
16731	payment	1726	1726	1874	1	1	6568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAQ4SBFChawKDuo8pueCxBqqFWKA5vQ5Rs6aj4BL4pFCE5Wz6
16732	payment	1397	1397	1678	1	1	7858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AuFVMGdBHsh7N8hS347d5gdfYJtF7FcguJKGnGTRC2U2T3TR
16733	payment	1726	1726	1874	1	1	6569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRobNTyqXcYjuQwK1GWf4skPNwgn78tFzafZwzo7mN9tzuuS3n
16734	payment	1726	1726	1874	1	1	6570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj97ot7ZWSmSGKAMEvv1skYuaEBKLFLjUQM9v13BMLwamjzRrK
16740	payment	1397	1397	1678	1	1	7860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoQLHtxoHbmjByAWFZWBvLdAwv17HPxMYfBZedYcvhop8YRTj
16741	payment	1726	1726	1874	1	1	6575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUsdDQrrdAAYUrwhx9BaTAoFQEZcg5bkb4C3g1BVjS7VhAA41
16742	payment	1726	1726	1874	1	1	6576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNrM1Mms7xMtk7EF5AEAK9eAXXg5Uoj8AnKURKWW3N4zXvUru
16752	payment	1397	1397	1678	1	1	7864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9mN28uiPgQeBCPvUhofgb6nxgjAL1k7BGKtTbsZvJKD8c7qF
16806	payment	1726	1726	1874	1	1	6621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfwe4x3d3UhGNDGE9eZ7XsJ6TEtfL1kmanPLHKYv7vixHaAfv
16807	payment	1726	1726	1874	1	1	6622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTU7dQxZR9hQdTJkRs1odVAqzmQFZCVcXHyNN9aosqQWyhFzs
16808	payment	1726	1726	1874	1	1	6623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtn6sxA5RwHYjG2md3iqdtXEeCGWELbGQ8KTXdSkRJiZV59gcM
16829	payment	1726	1726	1874	1	1	6637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcue11HrZZBykrSLZ1S5JLeRDGKFrBC3U2nWXccP21LyxVfskj
16830	payment	1726	1726	1874	1	1	6638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCg9ip4KMNLzoCbkJ4JpXsDef1dsxLzWuofQUoZsbLqQPzTPD6
16831	payment	1726	1726	1874	1	1	6639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSj6m6uciXCi1WtJFWFWd61M399ZmJG83LDRNVDaXu3iHG5ZBW
16832	payment	1726	1726	1874	1	1	6640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxUpxvsLXfoUjTwpDH7jqqkLLhoFGZz6WARzfNp9KtEh8J9p6
16833	payment	1726	1726	1874	1	1	6641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1g4LXWRS7mWgsjrRdDMdPwipnbP3cGDh2KePqMA19wCvEo5F
16834	payment	1726	1726	1874	1	1	6642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8szUQszC2gwCP8HtVugPZHShUkVDx93YJoXJEAcQ2fkNGjknD
16842	payment	1397	1397	1678	1	1	7889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHzsxWXyENr3tFQqksHShXwrhTQbdbDqHWny4iiCbMA4y6SKu
16843	payment	1726	1726	1874	1	1	6648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrNnwBtmbTvuo6KTFqGqRBYjfmiGfFsXhuYJQVyEz85rcLwej
16844	payment	1726	1726	1874	1	1	6649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjGJ5qH7qrMDZjt68a1WygmQndBzr7yGvBaYtBfhQfS2yjSAZ
16845	payment	1726	1726	1874	1	1	6650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7juFD6q211tu3qo9bYD34ztAQyz1pDkbtLzdmHE12ELM9gZ1
16866	payment	1397	1397	1678	1	1	7895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrGtR9R5uWUrLCfLRWrqmDfpxBs7UkmZiXVG65w44W29PLbXN
16867	payment	1397	1397	1678	1	1	7896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPdKVGSA92V915z3cezjqcyp7aG5WyEj1rF57Sa7tLoH5PS4Y
16868	payment	1397	1397	1678	1	1	7897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCV1H7uNfQnBVfzzFY3yL8UjArAedpeiHaZJucatbhQ3r8khSM
16869	payment	1726	1726	1874	1	1	6666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpEyzNrDdydL8Uzu7axjnHSqHqz4wiWmXtQjsua5tAe3ikb1G
16870	payment	1726	1726	1874	1	1	6667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrqpvcxMuUs95STZrozDZE2MxSGR2KnP5XfCKTdoZNQxqYUUJ9
16871	payment	1726	1726	1874	1	1	6668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM99wHazpX3qYoufPrw1neoqbQYtjDfWMrScsBkkZcTWsPWZiV
16872	payment	1726	1726	1874	1	1	6669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA4LDWc6gwL7RjHmMQgbNoXFj3m7W9bo3gFxvhYhA2cuS5qbZ
16873	payment	1726	1726	1874	1	1	6670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgzJySWgUQFxdoPKMMUfkQpgxUx8rsQk8b2fJ7jSNcv2USQpe
16874	payment	1726	1726	1874	1	1	6671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzjYZmF5TQyxaCJYttJAWFTvYVYAuY1HqvjwENHXkeTmGnoGS
16875	payment	1726	1726	1874	1	1	6672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bbuPgDfdA5b3MvabGu4znMaPTJKfNx1JfgA7kV1RRBTfLsK8
16876	payment	1726	1726	1874	1	1	6673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8S97z4HicyVK3njtSqCYbjcwoRPXeY3qfRVLYSgr5b6BWfZE
16883	payment	1397	1397	1678	1	1	7899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDfJR8n5YC1SxzJaTs654aPvtNKNZULLabB8PbffunsmnJEfW
16884	payment	1397	1397	1678	1	1	7900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAdumtxFxQZzcbyQjrfE2Nq9WGuGWYpyxM5m9rceFqAir3CES
16713	payment	1726	1726	1874	1	1	6556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2vFgfbPXk6rxE58Tx2sTVa5eV8i2obx5v4pGEVNdbLEtofei
16726	payment	1397	1397	1678	1	1	7856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHiSqYJMW3rKEYyjrKMGtTWoH4gQW2S6Ux1dL8bZhosmUGSPQ
16727	payment	1726	1726	1874	1	1	6565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWLpNq3zUBbZZdtzL1fteHzrEpz1fGqMjYnwkuh5cwkkXE889
16728	payment	1726	1726	1874	1	1	6566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ydt4dh4XW3UXSWbYnjDZiwKKqTf4wLTfE3gtcVdzfFgjcZWU
16735	payment	1397	1397	1678	1	1	7859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkDaSNULjnkKEp9kPp6ubpB8oD1LZVYMevC1bThefUnjw94LAh
16736	payment	1726	1726	1874	1	1	6571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPLXmpKUgHPHR4Xa6imx5eAQW83w7Qzx2V7ZuFphYyBdH9E17
16737	payment	1726	1726	1874	1	1	6572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1smLJDeBuLHUD6ooPCJmrvNARhMczN7tNNavt5QJL43yT4iJ
16738	payment	1726	1726	1874	1	1	6573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZny7hCiYAMx9HwaGvLjSu87rA63W6HndG6HoJetGD2nSVmDfED
16739	payment	1726	1726	1874	1	1	6574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpUnBk4U3CFVEc4xx89HKx3BzkRF7dmZgnBr7dHxc9PWJTuX6
16746	payment	1397	1397	1678	1	1	7862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Hav5wnNApgEN4Sg4sYYtHTQr7CECZs8MeJyuoBuay4CEmux2
16747	payment	1397	1397	1678	1	1	7863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGXs8nn4AsMEAfEVW9f7ZonHepRuLnAwxTxStBA9fy1dDwpqZ
16748	payment	1726	1726	1874	1	1	6579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TtGenvWvcaiE7gbXcJHtMY5Yet3ML9wuso7ZLABMocsREDTc
16749	payment	1726	1726	1874	1	1	6580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABQzGE8dXAgM5WnujHJFnHPaJHJQPbFjndWwjX8kwcze6ARdo
16750	payment	1726	1726	1874	1	1	6581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rUX9xKKEfsW1CqScbu3PgseZXZHVjz4soYZ14hkcMdGNmwNh
16751	payment	1726	1726	1874	1	1	6582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcKNcBWWgTSWEDFjsp5ypg5aEB38eaDxdrWPNvKJEriuigdrW
16763	payment	1397	1397	1678	1	1	7867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFHWFeXKt48PaN8ZT7FRLj7pFuQW2uejuL9MwBHiFzfi7qkx1
16764	payment	1726	1726	1874	1	1	6591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaLVHbsfSoeezRYuDRwWS6nxF4wr7AtmE4DGqSfMLHmvMsAXg
16765	payment	1726	1726	1874	1	1	6592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn1ZCE1HHuzPTWs2SZpFmtCCJfNombTbWVwQ7emauMkFjqeP5
16766	payment	1726	1726	1874	1	1	6593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpe3ZgwvaBXt89vqK3Js8q4KWzTAPuiifXgEia4z38rCqqGErN
16772	payment	1397	1397	1678	1	1	7869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPos9p4brqyebvK92ZtBSiQEsKcXPdF3K5pDVD4nf4jbU5NM4o
16773	payment	1397	1397	1678	1	1	7870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEm5pGBN5YBJGp9KZCUstURYpdB52uhzaEtGm85EiEajQaU4v8
16774	payment	1726	1726	1874	1	1	6598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZ8SvvG5jHZvVGx4Z9iuyUPNs8QeKtFxDKA4zFfYkeDGVpbA7
16775	payment	1726	1726	1874	1	1	6599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPiUdBJKuWms9WtzxLNP1fNkiM7BmxrS5kRsFbuWKNfKK8psm
16776	payment	1726	1726	1874	1	1	6600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvobUmwEPA8nEv9tsf5NtcNzcSq4HzA195eymbyXDXWRMAmJa
16777	payment	1726	1726	1874	1	1	6601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxBT79on3uEoafL7Hvri5nAHHNkPqxAruy7t1aXmVe26nxPay
16778	payment	1726	1726	1874	1	1	6602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLMoGumN4sAt7Mu6imyYdW2C3P67ksfHzKSmbyUz4WXuso8HY
16779	payment	1726	1726	1874	1	1	6603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEd3RfKXvjhZiJFfFR5ZzXBrZuCJhuzd6AhbvnZ1aSKaHv9Y8
16791	payment	1726	1726	1874	1	1	6611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36wUSZvURKg249MFDiiWEF4fSYb4ffRANZTFmuDHKd5uExyJK
16795	payment	1397	1397	1678	1	1	7876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW3BBrH6sZcyJMoj8qzaDe6iDYLpkMaLdeNZJM4yNYFYbVAMu
16796	payment	1726	1726	1874	1	1	6614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5QxhZzfx1qiCDA5wwdWQSR5dPi3hR3zpXZvy18QHdPgHhX3T
16797	payment	1726	1726	1874	1	1	6615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjHXmDbqg1fYuJmkE5VPJzKktfFF3gHd7J3mkFxBWq8mut554
16798	payment	1726	1726	1874	1	1	6616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyEmbHtxpz273h7K1FXN9zjxAkq1xzhKnvQyhGMyX3V28XMgy
16805	payment	1397	1397	1678	1	1	7879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUV4EWskipiuyzQHd8sM61rTpiQgouJ3iDP7A4rgwDFoXBRhT
16812	payment	1397	1397	1678	1	1	7881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAYLANhQYDo6SKu78ADrsQki36DHYSv5nFKEipDwFA5SKtNog
16813	payment	1397	1397	1678	1	1	7882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hXvJ2tfbyBK5LbExgTF71MxgFgWqFAWBu5YujxTqiUj39oyA
16814	payment	1726	1726	1874	1	1	6626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3WPvCWnv8za2PJobLpzxMs1nyLD6SGoq1b5SXFzQs41QaWmE
16815	payment	1726	1726	1874	1	1	6627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQb3yt9RpDpxMbyQ26EpuJAjWHhaADsAtJQG46jzpqDeqcjfkY
16816	payment	1726	1726	1874	1	1	6628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHFxoYQWh36o5jTtpzSJuHwt6cUjMTicCr4XoGV399Y2jpf8J
16782	payment	1726	1726	1874	1	1	6604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWhWe914CSKgh4jdvQnZwD41rLPtosUwSRY4Be62EUzPARvra
16783	payment	1726	1726	1874	1	1	6605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQwx7Mb53bjDQe2nf93ghUGNbW42QRDX6V2PTidC5dE1Nqeam
16784	payment	1726	1726	1874	1	1	6606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMuoJLznXPajm5MGXNyb2tnGYXdvAkN3kru2CUUGmhGgDcWRY
16785	payment	1726	1726	1874	1	1	6607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnmTkpFFAabkWAy9rnm7ozgDHKHFYgD7zXELaF4K5spRFyh88
16790	payment	1397	1397	1678	1	1	7874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNoehLPxjcWfBRQpt7DJ1WscdG9kRkuuTNDccU8F4LMqoBZng
16792	payment	1397	1397	1678	1	1	7875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr95fzdM6KoGXDak5dEto5fyw6SvadxuYka3KmwV7J2h8aP1CK
16793	payment	1726	1726	1874	1	1	6612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMQZfa2PodeFZGGgEafdY1rF2w5WRxqcGak9Bc6jBgCcgQmns
16794	payment	1726	1726	1874	1	1	6613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZY3ino1tRVybjndsWaVtW5a1TftwGNCV8BgDFK463ftS6wwtC
16809	payment	1397	1397	1678	1	1	7880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcZ5yrXvLMJuJTZeRCFVPYTAv8mxM8hNzXMp1xs2hfTUSg9nM
16810	payment	1726	1726	1874	1	1	6624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFBXz9r92fg18hjXzDL4G9sfWZms9Vjehr2WPMhvdTc6fYzDj
16811	payment	1726	1726	1874	1	1	6625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfT1ViF78py3nF9zhvV8TVhwDPEAJEtSAjjANVzyV5vEiwmAsb
16821	payment	1397	1397	1678	1	1	7884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJw1VTuFyyA3geprzygcnKmkL2gHC1D3twuTd1PycFPS2qeett
16822	payment	1726	1726	1874	1	1	6632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFp6ei2FYyjGkqbsRkafo68WJfPqeDCGghsi6qwT89tdazH7E
16823	payment	1726	1726	1874	1	1	6633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvkAQcFJKX3irC2gohUK7GHDaxmLa9QEYkmBpviAR5jMs2qtD
16824	payment	1726	1726	1874	1	1	6634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZ4HwKWtTSiqhtG3s71CxfdG8i9oGUrGVg1eUUV9C6UHeCBjD
16825	payment	1726	1726	1874	1	1	6635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAebAMGmANv4MoP3fmYECgA9vwKQgZ6JivWmHRkGGRttTbHXS9
16826	payment	1726	1726	1874	1	1	6636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSk6e5t3seN689cfGXyqHhf5jd2FmE4yzmi6cPpgv332TFHU5H
16838	payment	1397	1397	1678	1	1	7888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMn8wukHVmjT4zRPEq8am5J2HMVHhuWpDRxt2bqn81ohRjRAbp
16839	payment	1726	1726	1874	1	1	6645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgBjkdn5iPBiX2y9u9dagQ3txJk9Mkq5nk5U6S1JD3fUWS9dN
16840	payment	1726	1726	1874	1	1	6646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseZTuzhGD3t8CbvPg3m6rNX8Kk9WR3JbExRgCtSZZGVXRHNip
16841	payment	1726	1726	1874	1	1	6647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79dZR7ArPUNNiVyXVkkydor8uGA3EdXiuAJKMq35Gh7kFzUuY
16854	payment	1397	1397	1678	1	1	7892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22BvZNWQH52NERSLS6GxTPs6dxM6F9V64UESYYcSmrZmff5NS
16855	payment	1726	1726	1874	1	1	6657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5vJzDi67vcumbNi85gywGLyZHT6qMC8fHwZvovjUN8XKSLHM
16856	payment	1726	1726	1874	1	1	6658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMpb2T8y8aB83ER3PLmZfyHdJFEsFFAC3caWyUdFTRmGVC5WA
16857	payment	1726	1726	1874	1	1	6659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAJYgm6LzccKSBKLrNv4w7qcErLD6eMU5v9WNuN2ZZgZFd9aL
16858	payment	1397	1397	1678	1	1	7893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQXwjm2Nr9LoCXHrxZe2nA2eQmKGww8aKmeLUspisKyYUSHCc
16859	payment	1726	1726	1874	1	1	6660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxwfKbHKHd3wYN6R7i6eMbYxWjXKg579H2C1Ys57CN8HPVXMG
16860	payment	1726	1726	1874	1	1	6661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpsUQ3FS6UdAioaGKT3aZQ5hZzqqC7HGCuUHTRan4LBDAVdUi
16861	payment	1726	1726	1874	1	1	6662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdTKAZ1hwDKmDiHnAN4vDYbd2TcWdVCDrvNpj5v4c2ox4gZ5oY
16897	payment	1397	1397	1678	1	1	7903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXuPfVm62y6WDgHsGtyr6JgNqPscW6iTyZy1rZ8idnf6ZLGdYA
16898	payment	1726	1726	1874	1	1	6689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFRhE7TXrg47bzUSm1KJV7w5CSmE8DeNwRaxEwfCwtxWBwxgme
16899	payment	1726	1726	1874	1	1	6690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2MCqVPrNL1JR94ohnWXomx5cms3m113YUkpDEcYwwcKuUXJp
16900	payment	1726	1726	1874	1	1	6691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BDB3NG6f5BfHbm5NqxoTHJiNp5Cz4tDN7prMNPh3ZQyb717v
16936	payment	1397	1397	1678	1	1	7912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLo5zWfgvZiQyW3nAUu6CmdVKhJZdJVc7cPuXMq2YTD2CYzNS
16937	payment	1726	1726	1874	1	1	6719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71NxBAH3eNgf1Ky9wGugt1ocASaoEwjVGfLzabEXcGMQnaMQa
16938	payment	1726	1726	1874	1	1	6720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUTxgcz1ZR8MJb8rAuYf6oaYqGe6qiqQ61usshvAqsq97LXrrj
16955	payment	1397	1397	1678	1	1	7917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5TtZcKB7a8vV3e4QU798KDyf99YJoAMJY6HpXWUQ6zSicVHi
16956	payment	1726	1726	1874	1	1	6733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLXvXBpkGqMvRBS2xrkREbegizXa4rYexihJciEJaoNUJ8GaE4
16788	payment	1726	1726	1874	1	1	6609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHb81YhFNef86sfYLz2EjF7zzDECP9oCUav3ZKANxfudopJpm5
16789	payment	1726	1726	1874	1	1	6610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7bTqMLGg2oc6DjzwjR9t4bMepVaVrMuuFbKS1YTLLc39ZjTL
16799	payment	1397	1397	1678	1	1	7877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQ1kQGGVpZxiQZiwr5XMmbPiPWLYeHNDMUE4VShUtN7ZhyKGf
16800	payment	1397	1397	1678	1	1	7878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHWtQPegb9JvuP6dzA5FFjpAynSe6cqbpRPh9AWaQRGDdrzYT
16801	payment	1726	1726	1874	1	1	6617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzra2nJDx9k6WTwv3JN8sokUsofYjw58LEYAD9sp55wPp3UALK
16802	payment	1726	1726	1874	1	1	6618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7aKTMw6YYF9Kz1Cq4g1Ueed3aoTPZNAc8WMgqZhEdgD8TQf2
16803	payment	1726	1726	1874	1	1	6619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYG5tvLvv8Lks9CG2fS6TJpH1fxW2NkWQybSMRpZpgWmuAQKPu
16804	payment	1726	1726	1874	1	1	6620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7gq8Qn2hRxNexKurku9fr3CdNvv9N7HkGdJgeAYxpTh6AYw5
16820	payment	1397	1397	1678	1	1	7883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGtC6RiBP52Sjpz1r1ayS7L2eexYPpq1bYbYKEFS6gLmkg12R
16835	payment	1397	1397	1678	1	1	7887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXLo22pa3qqNJTbdErb7FmML5s1T2MC8jZQ7KpAgXFdMfA8Y9
16836	payment	1726	1726	1874	1	1	6643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nXUddxKsKe411mjVvqQbNWBYbUbWjDDSdNEExQgNCZXANxAL
16837	payment	1726	1726	1874	1	1	6644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiubgFnJvwRt8xutGAbpyezfC24s9ywXcbSoRgSBzRLxVqNhnX
16846	payment	1397	1397	1678	1	1	7890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUStCizMSy87AUbSkpBvX1Cy6NhM6gaX3ovHtDnoU5UNbiPh5j
16847	payment	1726	1726	1874	1	1	6651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5G4jsvC6AihSX86K56B5LwLQXGGmYW55irXJ9ZUxLRA8BE6VX
16848	payment	1726	1726	1874	1	1	6652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwK9UVyPgieNbBpkAaScX7PgfNxEfo5ZXMSzoo6a3Kc9aVB7Nj
16849	payment	1726	1726	1874	1	1	6653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWUVxDGeKVLH1erh7eV5ZM1cqwNcH3EGaNqaNYwt2FXD4Citz
16850	payment	1397	1397	1678	1	1	7891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe37ydwiMM9C7F8mktBmf2w1ditj8SsWViy3pCZ57KUQ4SM6Ap
16851	payment	1726	1726	1874	1	1	6654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1Tb6agsnRn5rjnDXYp8HLYXHCboeTSJSkZ5Znk51igz9AhdK
16852	payment	1726	1726	1874	1	1	6655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfcZyTCT8nJfgKHvbucp1wgnA287tUbU85j6idkzs3wqjexA6
16853	payment	1726	1726	1874	1	1	6656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Tyqqnc9AtbAMsYJXstPQDNoHgQG28vbd2cJpw4Fycx8Ys7Mp
16862	payment	1397	1397	1678	1	1	7894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kHaCKszMzXiNeBCHbGj8EnwXwF9WkkzZSRmiXx9hLK4on4s1
16863	payment	1726	1726	1874	1	1	6663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREjHWLrvu9Jbs4kERfP7fKGR6XaaiLkZ2ppBn1woApW6WJjxm
16864	payment	1726	1726	1874	1	1	6664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ns5FFrfw9nSRjQmxYnXo2EteqEsxtoWY3NqG9wER9vuY6YWT
16865	payment	1726	1726	1874	1	1	6665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfUHrLpXya56NXuBXsjdL3ZQn5hNCGU38Ad6LAPrYFXVT2Lpb
16877	payment	1397	1397	1678	1	1	7898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3AjV5WyXbsHZH1YqGwfZ9TraTMjofcq9Pv48DNFENCaAr3aWj
16878	payment	1726	1726	1874	1	1	6674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTq5AmmZmdKLC5uE9cmsXhpXYCDmpMqYxxKjQtW2Lns1hH7vTu
16879	payment	1726	1726	1874	1	1	6675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcBdXAJK5fohPz8vrxWpcHvKz3ftP4ZVF3PwerqxTxUHV8q1D
16880	payment	1726	1726	1874	1	1	6676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgBaWFUDgjqxwekMNttLyvGEVWPMwqTAQ2JG8YvBEwZtbk3ce
16889	payment	1397	1397	1678	1	1	7901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2p9MS4UseUsegCKui2vutPdtqhwTZBZNvgngdsARMu16unWG
16890	payment	1726	1726	1874	1	1	6683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPAPbv3ALkZ35MEEosTpx7Wi99ner7ziYRpzZvpePmnibRiVb
16891	payment	1726	1726	1874	1	1	6684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxskzEMyjaaYfHDw6XvHrm64aChcAkgLat3iAiFyVadMt2zDsb
16892	payment	1726	1726	1874	1	1	6685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYep7G1EDJEYLRvHz4bAwDjaedZWNCKCX25zYJNfBm744ChwN9b
16893	payment	1397	1397	1678	1	1	7902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8ZFKLFPY3M3oxApbNki3niiVv6cLpbQu5Kia468xaMRDPvhX
16894	payment	1726	1726	1874	1	1	6686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMAKMwjCMdmqp67YRVEfLRmU2qbaQio1MeYWU1kf4YBMQj8BX
16895	payment	1726	1726	1874	1	1	6687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXx5bh6RX1xwxaagWVjpeQnyo79vHs7r2XPG2RYQ7XR1phs6by
16896	payment	1726	1726	1874	1	1	6688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZJXiJVvxHybb7ZnL1caUswTBifpmrkXvfqTxxBfKb7uhVFhU
16905	payment	1397	1397	1678	1	1	7905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQgQorxSmJdV1j1hmNWvaqFxoxtJxNVoXfak787rwu3DCpURo
16906	payment	1726	1726	1874	1	1	6695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Rq6n3aQUYdC9HVupZdVSmKnHkhYoaXn3sDhxHpgkmegrqefq
16817	payment	1726	1726	1874	1	1	6629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ABsv3i7jQKXGbgGj7KofXK2Dud31kM8f9NyEwLqTMZHcJtUG
16818	payment	1726	1726	1874	1	1	6630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuHkK8GYTgjvLZ1BGeDdz3LrRAR4NLr2CWsvf7gUV326ajN6Y
16819	payment	1726	1726	1874	1	1	6631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Nhi4yD85MQZW43gFCFQ66YPabz2jwRyGjyX6DUtBqCNRRuYZ
16827	payment	1397	1397	1678	1	1	7885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCrFawkNrU3tdL88xwP94UU9rpJkubbg4wJsxDyRiqDT5xDJTh
16828	payment	1397	1397	1678	1	1	7886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tqv7YSqbZHec4ZvuhUWtb2PriNXXXiZ1zgp2cVrVYDyokTBZ
16881	payment	1726	1726	1874	1	1	6677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eSN1LzVMSMGNsxzzRaDnpTFD9nw6yGDxgt96pUpmBbTraVhx
16882	payment	1726	1726	1874	1	1	6678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ3xsdBGhWu4LnU8u3YKwWyBMLApzP6kxNRBJSrW9r2yccw3Q
16920	payment	1397	1397	1678	1	1	7908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwr6YcYgA4MCiuACRX4oUrvyV51dRjj6mSWpKSdUrxTq8uQZBE
16921	payment	1397	1397	1678	1	1	7909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhWRF6zbBmymmd74TFZEtGoZU1vkPYGmLqE1grhocxDeswWdW
16922	payment	1726	1726	1874	1	1	6707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcg5cGYSJnY3N5RM3H5vxuRyfRxXRpVsPVTKWfbmqh5YmufrvY
16923	payment	1726	1726	1874	1	1	6708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3sawoZAg9DefNf8Q5C3JfZ71YMZ2SsMNs6x97GuiE1jDXJRY
16924	payment	1726	1726	1874	1	1	6709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAQ8njJuXoLt6q9o1gxjJdcmse67t49yqT5ouqAjH4hrinKit
16925	payment	1726	1726	1874	1	1	6710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEYjFsGoeHJFVEpAZkVog2bdSXrJuykEYgqfVnCveSGKeSM4V
16926	payment	1726	1726	1874	1	1	6711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLCJN3RmL7jmcHNwLfZ9yRxKTNZ6fCsd93DufdkMYmLi2QmoD
16927	payment	1726	1726	1874	1	1	6712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8umYQ7jeTZ5XxD1giRG8PewU6iE3HPtk9Qrt7zWnDMC5a2zJ
16951	payment	1397	1397	1678	1	1	7916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQfWLbKpUUaJWDV2tFPEbjg3fPkjf48adFR9XfHSUXmPNufsY
16952	payment	1726	1726	1874	1	1	6730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkACcLMMfZkFxcUCDTtpTkF7oa9seGtv7ULKh9ePNNy4DiGjGC
16953	payment	1726	1726	1874	1	1	6731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6bmdhbUJc6G8wqHSy6VFL3K2zi7MVRbXiJA6FXeGkhj1eBM5
16954	payment	1726	1726	1874	1	1	6732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbpArY8sWD2DR5s9exNcGniYiTTAzuQxvG73DFmsrZfRm9yJG
16966	payment	1397	1397	1678	1	1	7920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxx4hQAR4mXdkcDMxBHv1Uaa3TeE3DchgFSmHRXkk9oA8d3WJ
16967	payment	1726	1726	1874	1	1	6741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkYHDTPwzbkxSt4RY8HB5J648ijBzYtDyjHTDrgRGQcdXYWYm
16968	payment	1726	1726	1874	1	1	6742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6UufKskeFdqqGvhf4WbJk5EWm2eaSUGiKiypeQR6fJupvJaSx
16969	payment	1726	1726	1874	1	1	6743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxng1DrS3Fmi1Gb8NJfaoAZJAjbuKNtrYrKofFKwWJXtbsEN7h
16986	payment	1726	1726	1874	1	1	6501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFSmrM3uijZEp4yqsj8XUbKfG75E6smHbfwaPXyC974eeuYtM
16991	payment	1397	1397	1678	1	1	7926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszpmGBtnDMae4X75YctQvrdsdqiv4TzCHktYHKfCnzJQEQzmw
16992	payment	1397	1397	1678	1	1	7927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLJEKc3yr4hXCvMWimLhSVxKkg9PtnZpnVRdxkFBZQfP45Des
16993	payment	1397	1397	1678	1	1	7928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpNudExBG8NwKvKycTLPTvuLXRvico6aJCB81fQk2AiYMno5Z
16994	payment	1726	1726	1874	1	1	6759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvGAmrGnXSCqSrKuMLqXUucMR8ojQg86pyMN9eKUZzrwRszfq
16995	payment	1726	1726	1874	1	1	6760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouKZvCUrqvZVwu1a3KPqcbRNgZCZvMMBBUKsBnmAvK9UEXtzx
16996	payment	1726	1726	1874	1	1	6761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSeqZuquqrr9UCPtPACr7UCkGuWfst96ZMACBho124XwEbis1
16997	payment	1726	1726	1874	1	1	6762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuMzVRGRV9hnqjj8MDoBFPAyaH4RF5yraixKQQs7DUzBn9Nc1
16998	payment	1726	1726	1874	1	1	6763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQWUm4HBpsdZ83S3K574Ck279NzThwndKDq4kiWYPDFTY3DDm
16999	payment	1726	1726	1874	1	1	6764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWeMm7hnwvjibBkqe63qJEe8b2eErKmc8vXmrc3UkRX93q1vm
17000	payment	1726	1726	1874	1	1	6765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaETRESaBXYesvbdpY9TpZsjxeKgDB5ngP6SdvTYZ4wtbzfEmB
17001	payment	1726	1726	1874	1	1	6766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUkA9wMJmScH9XifUEHJgZkXD2CiHYYyz2d3xE55Dz2Aq3vrN
17002	payment	1726	1726	1874	1	1	6767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gvCS7F3VjQvh9aDnCkfVnNvbeXMxE4aG87ibLMqyM5G8UdSz
16885	payment	1726	1726	1874	1	1	6679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJsfiw39rGFr9Sk2LVtXLBgyLdAV7b1XGVkR7xdnDPzBB9b9Q
16886	payment	1726	1726	1874	1	1	6680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyykpYPDgMQDEYrWgoiAj397rEUFxDho3p2yksaSYsbgExwRB
16887	payment	1726	1726	1874	1	1	6681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFqsf4kCNuYamGM9P7Tz9YaYoWyQDvHgj6bqqxvpKjQ3o6TEE
16888	payment	1726	1726	1874	1	1	6682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhwNFtQSuxN4Q3Lnq2QvzhXqZMcvEfTPnXG7dRS31Lv4v8VgF
16901	payment	1397	1397	1678	1	1	7904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRtdMkyxx8xTHaAuiBifqSe6GqyLokDjzNKEg6VVZqYeYxJf7C
16902	payment	1726	1726	1874	1	1	6692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UfuVLAUnrQYfyN2gfN1mirFcauiCGDvRk3KDM2HsjQBGejo8
16903	payment	1726	1726	1874	1	1	6693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoTA7EFeHibvceD6AsM7g3cY47KUYzpV7Kf3gxtHc6Ko2AAm4
16904	payment	1726	1726	1874	1	1	6694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYWWkBk3DN3M9jFNdch25ZtX1YZcAgwe3DUZbgA8K6jooz2Q9
16913	payment	1397	1397	1678	1	1	7907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonA7G4uyzkSrStGqFmp1tKYv8qQWZiMVpdWvpLqhKnhVG1Spj
16914	payment	1726	1726	1874	1	1	6701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbyzPvUFmv8Vuh83f4UAQTeoEM6Rsc8eMCfSe1FQEKtSCiPFJ
16915	payment	1726	1726	1874	1	1	6702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9RBxDNopxvaBjdzgicFJtewnN16uYDobAavue1aM9eRadNgBi
16916	payment	1726	1726	1874	1	1	6703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpDBdkhdrpKTeQey7NuWu94DpHLY7zSNdx3MQoRD98weUkixFZ
16917	payment	1726	1726	1874	1	1	6704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkM35ikAWXTBaP4BtxS3ECvyF8jrSAv32t6km11Tn1becj6m6f
16918	payment	1726	1726	1874	1	1	6705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA92XxtguNAb5G3xdRYh6g7n4EyDA5TLyv69t4eFvSPWgZDhXv
16919	payment	1726	1726	1874	1	1	6706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2p91mqxT6fbhvx9vQvXFvKZeG9gZfSKfEpgKLXHa9LA3FCysT
16947	payment	1397	1397	1678	1	1	7915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywkXqVY7XVsQ4iwDgW3hwZLzaUYRtwZuEna68y6MxH1nVxPui
16948	payment	1726	1726	1874	1	1	6727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9dA1HE1axcrsywXedh2FQ5LMLvqmu2gZmmhEk3cpgm9oKfPa
16949	payment	1726	1726	1874	1	1	6728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYct59yYvY78sMY8QycrT6JJFWb4HVsMPfZiP7HtMNS3SQUM6uN
16950	payment	1726	1726	1874	1	1	6729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexknunHA7XbQBBzA7UozBtCSC1NKiDHA6knNZn4PY14WBhLHq
16958	payment	1397	1397	1678	1	1	7918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfED7mYgbtVTuDfDFsnXNuCg78C43UUaEeDeaNjv5AkGx28cH8
16959	payment	1397	1397	1678	1	1	7919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa31gz9yd4xDskbZ4v2LGUn3uWN3FZYLeEqH8oCanLZL1aHAJLB
16960	payment	1726	1726	1874	1	1	6735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSqPg1964Cn7pCEACY7DLjTEmYXaMLSotaHxW1VcXyJjukwm7
16961	payment	1726	1726	1874	1	1	6736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtyjH29MyB1vQjuo7Gn34vdzyUiTfvv9muPxweYdnFTyXd1XK
16962	payment	1726	1726	1874	1	1	6737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYd2f3n3xHFL3mPZLdUhim2d3iKBMDAULbWbBi31GTFo5jLBY
16963	payment	1726	1726	1874	1	1	6738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxeYSH75bD8Whk9mTsj7MmKrm7YPstH6TY6K62dpFZN7DXhVe
16964	payment	1726	1726	1874	1	1	6739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLxXK6f1u4oxNvRkMVcgGFnBxqEYcVHAqdzR2mJBKjhrFX2N4
16965	payment	1726	1726	1874	1	1	6740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3dW8jt3x5fCVPrTBKe9Bpi9nz5DBUVvHY9UJPxoguznC5r9G
16974	payment	1397	1397	1678	1	1	7922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7QP3j5a9esPnspgCfMLJrQMhyZ929Kna71WvJ97jdCA2bXLQ
16975	payment	1726	1726	1874	1	1	6747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbmfnBqKEzJsV45sK95xiany1mmHiJVqHJAG7vvoajmeN6Jtd
16976	payment	1726	1726	1874	1	1	6748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19vnFUUg5F769UScB9isLx3LN7BbBU6953ew3rWE7fBRit9SM
16977	payment	1726	1726	1874	1	1	6749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHL5XsWm5oKK4EA3m4rhyjU4KveWZBvHonZHVzoioZibmCBgn
16907	payment	1726	1726	1874	1	1	6696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4Ac35g6uvFRCEU9mhkYoi6QcbkjuNNocuYGK7sK7DFWv8aRs
16908	payment	1726	1726	1874	1	1	6697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyExvd61KK7DE5iyWMCP6bf6g2VbKHrndLFhEpEfBjmyHRkndc
16909	payment	1397	1397	1678	1	1	7906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hDTV6QXBiRTHxBSr11XHoS6TigHg2Lo19HPJNsxrpux29NBn
16910	payment	1726	1726	1874	1	1	6698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQ3ozPpZgUR2gRRv78h2igaEwhR6rGGaccUo921V2JpCVUuTY
16911	payment	1726	1726	1874	1	1	6699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTuNdT71S2XVjKbtbPDfPYyEikk2yH5RhZtZUFgqYb7AKw49h
16912	payment	1726	1726	1874	1	1	6700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgi2awSgkq29xYH2wWFdisMWPqWLx2H4K8gvGNP2h4NstNetm
16928	payment	1397	1397	1678	1	1	7910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzL46xYHajDZ6teHiKGgjVMLy9GpbqVb7gVtLsb8CRZcM8Vt1
16929	payment	1726	1726	1874	1	1	6713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmibwxhpPJZKB7nUud49KqZSLVBQ2eBHSjYYzPWMzwrubeVuyD
16930	payment	1726	1726	1874	1	1	6714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MPdsGhiXob37zzNrAUBNP7JezVfvwgEinVsV9YG2mdKbNUdt
16931	payment	1726	1726	1874	1	1	6715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF8niyVWfV8VztsmawzNqG7KaNE2Qop9e7Pe6dJsBFvKFUmDo6
16932	payment	1397	1397	1678	1	1	7911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbfhijXA6zz9nFpXDPWVEeZTQqKvrbSkHgrU6zdKWe816Lvfm
16933	payment	1726	1726	1874	1	1	6716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaf7PHRNTWCQChPu9wv3Pp88dUbqLyBAJyhNoh5XnbHw1QzBw
16934	payment	1726	1726	1874	1	1	6717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97qKvzwAVtPgbFk4TzFBowp7U5Vwfthw6rpQzxm4J4MUy9T8Y
16935	payment	1726	1726	1874	1	1	6718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoJmVr2MR1Piog5tQwRSnhFh8TejzFHgNZo6HLcTJeoyZFgTV
16939	payment	1397	1397	1678	1	1	7913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6RMUqdXMgxCFwx1HZvWMUKvakA4xqzMQWdYyt5gA6xMq8m2M
16940	payment	1397	1397	1678	1	1	7914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoETQrhHdJ1fauCrz9e5G4Xr6NkTepbmAGLtLPm1t4kBXqKH5z
16941	payment	1726	1726	1874	1	1	6721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUtGgiE6zgugdXQZ4oGw6PG42uVVnE166K2FmXFd2oSpXAvKC
16942	payment	1726	1726	1874	1	1	6722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgfCWK1hmZSd6Aud7qGzrFuezhBSnNwbfWkcvugEReJHk7D7a
16943	payment	1726	1726	1874	1	1	6723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZ9izxd4oHEj1gG6Q3WGo7jdFLQEWEinH1Kkff3igmpRDTzMk
16944	payment	1726	1726	1874	1	1	6724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYit8znZ25fqQFSZKAjjW1aEJMNxHHKy9fF5fEUQ45Smy8KrDSh
16945	payment	1726	1726	1874	1	1	6725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhtyyBEFivgBdoSgxNXmD7pSrsqRksAL56SAZ4exLDrNe3aJL
16946	payment	1726	1726	1874	1	1	6726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccDjYikUv8jhCSeWBAv4e3beTSaMFze49Xg9aMwznqrNBUd5C
16970	payment	1397	1397	1678	1	1	7921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2a7MSig4ugBtMBcqRmFJRsWJGZDMHEv6JDRfWLhGgECiCJho
16971	payment	1726	1726	1874	1	1	6744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLTV1NQZiUqrfx4GhitP8tbAS4q6Hnij1EZScaEp16E9dwN6j
16972	payment	1726	1726	1874	1	1	6745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvqgZoE68VMcGKFbxdMZhQhzQPUi89fHHYTk1U43UaXEcTfxQ
16973	payment	1726	1726	1874	1	1	6746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WcDBKK35S494n83G6BPXir2DYTeaPFDZXywj2DpwuwWP32D4
16987	payment	1397	1397	1678	1	1	7925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rnapBUysdeTVPp2iFdrAZUokN1DHpvBFneyfLNwyjtARMdq1
16988	payment	1726	1726	1874	1	1	6756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcu5cf5aQPARfhgTgEY6RqpNPE8eyzuJE5BnrTHFGhCHiKWbx
16989	payment	1726	1726	1874	1	1	6757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxvJLxwRfXVhZDfhQUTdES124g5z2gBvf9Xce3peKLNWyCsxU
16990	payment	1726	1726	1874	1	1	6758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUMn1BvC13gQSLzZJ1y7mV7Cb6BayQyCqKbaNvBCokCjaReCe
17003	payment	1397	1397	1678	1	1	7929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkUtRFLnGAquhjhUJz5fSdPc4iTEWfZjUWdeLx7KyTGw9k9b7
16957	payment	1726	1726	1874	1	1	6734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBS327uFJXxWk55A6ZoWHs157xwv4DCdUQj3LxSNL4twLyQtri
16978	payment	1397	1397	1678	1	1	7923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGtXDGyzomsp5YewkCerjXPVfKYxZQbvk2TGBq1oftfGznds3
16979	payment	1726	1726	1874	1	1	6750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSr83CKjjKnx8cbu83RQVbJs3xMFPQXGb796LH3BwdwWKJRxZ
16980	payment	1726	1726	1874	1	1	6751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoaemzG5FJCw8CnrSnkJhyCi2sHa3rvJD2KLTf7jTnV5yyvWH5
16981	payment	1726	1726	1874	1	1	6752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWdQP13xLg1GfVXHk92XA8d72JmGLEg3agWVUXopEjyZhjkiM
16982	payment	1397	1397	1678	1	1	7924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdhFXjyQHxMF3bs88sC3Kh7z9xd5QqL8Aac4BHifBbu64TRLM
16983	payment	1726	1726	1874	1	1	6753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb31fFhBuLrt7neyvCLMrqUPtE1C2V6U9gQbKdUHSghvKixizy
16984	payment	1726	1726	1874	1	1	6754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4N5dLB3KB6utN8kcF2DAYFqjBhJf3PucgZdeeS3b5JP1wAVo
16985	payment	1726	1726	1874	1	1	6755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsa96jcjU5Rgkdv6XUSHj2BpEaatoyXxQb7442yAigqwXSxo7V
17004	payment	1726	1726	1874	1	1	6768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZFDRfQJnRxPf3goQpmxaxowAPwt3tPR7f233AxAVm7TBsZdB
17005	payment	1726	1726	1874	1	1	6769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpisPvQgsh2Yr74dqPCCQX8cPhwfbTEBkedoNcaiCYtzRYN3Vh
17006	payment	1726	1726	1874	1	1	6770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFczjRCmrTRhbauAMpBVLhrcfKxmDtF9Smisu74KpbXZSmNEc
17007	payment	1397	1397	1678	1	1	7930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JiBbkJ98uzdudhnjQM2aw5f1DdX8v2cxodxXrkBfBkErLmWz
17008	payment	1397	1397	1678	1	1	7931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTEfkb5dHrUHMHgqX4bdDxh2fFedQHjXgaRntuAq9RNtDhmom
17009	payment	1726	1726	1874	1	1	6771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEd8AGDZLaXVEcr62omnSPyNAYDbRmJxHzPj262pn4sTkcXaY
17010	payment	1726	1726	1874	1	1	6772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFnQfNL8L3mg66dkrPN5BECeJurmCMWhF5hpH4EfYCo8NpbBsu
17011	payment	1726	1726	1874	1	1	6773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbDYZsLBzmCC3bEsirK89BpKRR1kio9kKdDh7NWQwrMRJLYtD
17012	payment	1726	1726	1874	1	1	6774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6mEqrYsdoUakGz4T4QyRHHYumZRJQCUedvhDwQb1MC1P5GTrB
17013	payment	1726	1726	1874	1	1	6775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4gF6RpkZ3WFXQ69ky8Kx6PkhYXqmMqQ9F2vvA9xg5Q59GudY
17014	payment	1726	1726	1874	1	1	6776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGeiB6Wesf5LBbWjKMZ3aqjNi8jtRw6GConxxCd6rqfv8EqZCN
17015	payment	1397	1397	1678	1	1	7932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4WAE4eHVuCHVjYnM1UmgJ3HmaHPNuwigrYTiCCwuXCYYovW4
17016	payment	1726	1726	1874	1	1	6777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QeBq1ixJkNDMLxHEBrYBx8TVW1F4RerzdDxzAKpppRnSPyCU
17017	payment	1726	1726	1874	1	1	6778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV6GYcFqbvfXu3aPmwv7RQuGVNGm9WjjVmWQuk5vTrVFyb9u9
17018	payment	1467	1467	1010	1	1	0	3619378064601	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZmDGwRFpR7KHeferKqqZHvdwk53dFMgL1ieh4F8anZNyKAtqpc
17019	payment	1467	1467	1130	1	1	1	6485894480949	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZCfAGmum537wW8yPGK6o5qhsacvcajH9xoEDiTbPWX2CCVS4Tq
17020	payment	1467	1467	1250	1	1	2	4376162246859	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZ8dH7pX8PMYeMdmb7eFgDp8ZcCu8BWC3mxKSvxCj84cWDtYvLA
17021	payment	1467	1467	1376	1	1	3	12194565207552	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZLFCRkerHKZo6oAkS3tks17N5H3pHqU1j1FsjGPDo7hEqKD5Zh
17022	payment	1397	1397	1678	1	1	7933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrFKQLLHKwdUewvuPbuRCLSLTRyyDrYdPbVpALBxNXWbKY7t3
17023	payment	1397	1397	1678	1	1	7934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyELwvgjJoWPTiQZiVSD7ALjmELF8nK9MwAAQRnRr16eKDD5S
17024	payment	1726	1726	1874	1	1	6779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7W9BTNvbqY5k1wqJiSHyKjBrHZniaYZcY22oTNxaYR2mUdY8
17025	payment	1726	1726	1874	1	1	6780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4o92iH6Cac1EG2axDZ4Q6KJCtEbhCgnqWLFfkUQh3ncK5KF7X
17026	payment	1726	1726	1874	1	1	6781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iMp4ry8AcbYsM9Bq2z3NcWZbLQ3oNijWXCtzKfYTP9vNWKH2
17027	payment	1726	1726	1874	1	1	6782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77beXMhzTHuo6EqwjHcKrvtGMiPnaEFQb6HQHrdzpRXmzShnq
17028	payment	1726	1726	1874	1	1	6783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ35psuzaR6pmsBXMwXFx3si35cnqwfuEBkzcxPQJAtg5goant
17029	payment	1726	1726	1874	1	1	6784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwWo8T6mJWpr5yqBoTtknqJLrCUoh5wSqerVXyaEdF1FcxoyuU
17030	payment	1397	1397	1678	1	1	7935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKasDU4XcGNvzh4yE916zppMNvgE3zxEHUN38wWDwds5rV9fh
17031	payment	1726	1726	1874	1	1	6785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJnotjvQKc8tHTkUFQ7bFeFL6hDQvpaAY1eSCE8nASrgc1Adv
17032	payment	1726	1726	1874	1	1	6786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9fDGhCCwGuyS73ezAGAYidoof8jPUvVZCeEanXQRW1kW2qQs
17033	payment	1726	1726	1874	1	1	6787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLGsveLwXmrBavGJUowXdA7JfWiWtZg72J2P4Zn4Uc6PDxApC
17054	payment	1726	1726	1874	1	1	6803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6T6nHBdaASs6B1p7R8i7VUc8couJdHRFWiWYLBu6tR1YTy5Ez
17055	payment	1726	1726	1874	1	1	6804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhB6EtcWm1SSbwZHJPiq7UoZJNuB9zJpCguDxAvAGUVza9Y7U
17067	payment	1397	1397	1678	1	1	7944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HmUPz6tUqjGqYaDgRDbJwLJxAcQZpRVbLb59w4WtuqyDryt6
17068	payment	1397	1397	1678	1	1	7945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUP2LW8NJK8E4zSXvx1K5CYzq52FNVxQgYea87G9Havyhs2h97
17069	payment	1726	1726	1874	1	1	6813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbuGUZJYPzBH1pYecAaLGrJiNrxC7s4ajvoj4zHoanFvHAJ7aW
17070	payment	1726	1726	1874	1	1	6814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk79otzLaLv1Rd3g8MkR3YsA9Qk5pZALV9FjGqZhj5vtSDLsrX
17071	payment	1726	1726	1874	1	1	6815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWc6Miqg85aBcLSkkeDqBTGhqzVP4t34rMcu9f1unKant5juba
17072	payment	849	849	2107	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HZPzXPt4jJ4Pino1T2TfWaLkuEGaynRwFNWPzRWzynjP9P35
17073	payment	1726	1726	1874	1	1	6816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDk4SsPCQxKspHebq8A6ckEPcNSU32SY9vRDoW57owiWzgK3G8
17074	payment	1726	1726	1874	1	1	6817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH98L7mUQ1H9F1juFUPtCuGoBZpXYqFzkjNj5NnASemiWwz58t
17075	payment	1726	1726	1874	1	1	6818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnpaCGFPnSQQcj3z3GnA1edYrK6kGaz4kV6kQUdP35E6Yj6ML
17124	payment	1397	1397	1678	1	1	7959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuX52beGHiZBXmSTyPTvdK3ENQcoja5HwYs2Cty1Q8kMnUKvb
17125	payment	1726	1726	1874	1	1	6854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpPSfijrmYQJtSw1vPJvpSgpMZcGDuzBhiRZ5QwcsHmr9J9DnU
17126	payment	1726	1726	1874	1	1	6855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3AQ2zLsL5KGdFvBkEcCEXAN6wn58r6ZJteTHH31vvJmUg8MX
17131	payment	1397	1397	1678	1	1	7961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrg6WHJ25cwUmfZxuRSL7ac4ndmGXJWWBuVBWg43sxpbERY7b4
17132	payment	1397	1397	1678	1	1	7962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzA9eZFoyZimqb6YC9kBSQAiGkJ8YUpi2wVgYsBYCUdUi3Jr1
17133	payment	1726	1726	1874	1	1	6859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGzQFCE9qfoEtF4pLUAsYrD6N75UkXG1Mw6CMBkbYu1Fqt4jq
17134	payment	1726	1726	1874	1	1	6860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLK9TKQgJeNhYvkvE5FpQ35P3Ze8H2dGBNUYqWtYykjqYcBwG
17135	payment	1726	1726	1874	1	1	6861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwXKQNhxvTQtZ66GHx6wBcVNQCZDVWEVEoNreZsH9Kw8yCHnVJ
17136	payment	1726	1726	1874	1	1	6862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6xYY1SdyPHKDNtuQndTmL9XivsCJe1tYPhK924b9mcTz2c3zx
17137	payment	1726	1726	1874	1	1	6863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLqYGg3pRCfWU7AszsXqqvyoA1Edq1Ld41TuP4YnDfDsJwsh4
17146	payment	1397	1397	1678	1	1	7965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKVaUndAFJcppVooB3EchAJAEAZ6XR53jUdqKXCuLky3A35Y8
17147	payment	1726	1726	1874	1	1	6870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NKd4odgq6ZH5ixr52d5TFHLFeXMCgWWgA8ndESRCZRtTX9gw
17148	payment	1726	1726	1874	1	1	6871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzDrGxmKXNbpKCi9gFGSTUZABLaFDEhRwVJ1m236XxWGR8pQTQ
17149	payment	1726	1726	1874	1	1	6872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBxpw6sZGgFzxSLCB1fDyetoZrM4BK2ikYpvGCfBvSnzSKmG4
17173	payment	1397	1397	1678	1	1	7972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KrkUxWRaQmmN26txHvtfe4XWHxxEnJRZMURfyqyQJLttNL8W
17174	payment	1397	1397	1678	1	1	7973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqCjgWr2gUqauhHhdAkXcMBVmzvE8XMYnN8xSFjwDYspRR1NC
17175	payment	1726	1726	1874	1	1	6890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoerUZKUL2ZhV7t6iF7hDuS618V6NBTHG5dyhNc5APHPFrEJoR
17176	payment	1726	1726	1874	1	1	6891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnDHVBRGGnXiMbMatYVWaoqZ9fSBR6ZxNMHrUNHxRBSCqoheyQ
17177	payment	1726	1726	1874	1	1	6892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkMHfeSd4XeWSpt3eyHFV9oaYbM5TjYKmEkfZxUx1sVSfnrD7
17178	payment	1726	1726	1874	1	1	6893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQE5Gmy6rTc5TWFXXEhy6yseuHrc7Jdwf9gSpgq7bwfHEHYcU
17179	payment	1726	1726	1874	1	1	6894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iTEmFHJtJJ9wKZstKcRsJABkxLE3UcYUpo2WBCWS6U9jgpyQ
17180	payment	1726	1726	1874	1	1	6895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSWcefj4Yog1HBFiVJt2bLs4RxTECmaraHYhcUEtFbacXavFJ
17234	payment	1397	1397	1678	1	1	7987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41K7bjZ8uiEVCTKCVf4R1Bu5ovn3NmP5kTkqHbgve2mL4tMvG
17235	payment	1726	1726	1874	1	1	6936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpcQwwkH2pwXCm52cpkX68g3LHTh3WAgydoUV57NMvdRiQXR9z
17236	payment	1726	1726	1874	1	1	6937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CPh5f2jbmQPJgcNuMQYrwrdkuyXGYjGcoRMC4AGwqUcoFgRD
17237	payment	1726	1726	1874	1	1	6938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbdZGZYD1FRhyUrsZBufmTgue11G9mpHpqhk5WtL9X4xsnAsq
17034	payment	1397	1397	1678	1	1	7936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGzRqsKPpJaTHm8myDthfeCoJ9m1WXbKCPijfef4wU8U2pbmV
17035	payment	1397	1397	1678	1	1	7937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8inoCxia35PKHa7SGFJSBeG8w81EdsQoVXHHamHqBvYrYivF
17050	payment	1397	1397	1678	1	1	7940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhJ6bnFWGrHokymuPomKUzULALSoMiz3gtrrpf8Pp85rxQLte
17051	payment	1726	1726	1874	1	1	6800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcj8ATwVMpvp3bhncTYYJFmJACYunVrwsrpxsnMwyhxDrgBB4B
17052	payment	1726	1726	1874	1	1	6801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBbrpV3F4v59WF94ts2Kn4hVnfCS7Fqfha1KZu2UTU3xN4vMj
17053	payment	1726	1726	1874	1	1	6802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf2PAM6oiD6m2XeQLH1mDxGwEuyqmfsWMbEffh43PF6s8t3Ur
17061	payment	1397	1397	1678	1	1	7943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNK5cfY4VkMdn2Ad13BuJCG8nhe8i8QpMu8RPtyWihbBfYEBK
17062	payment	1726	1726	1874	1	1	6808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbkbuy3XCMddkVjnuFdys9Y5DbhKCHqonh1Tow3hGGzTvrRJA
17063	payment	1726	1726	1874	1	1	6809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbW2u4GBTL4qTPHkUGoK64WwdCejTFPRK6j2LfC6tWcvdgiZQD
17064	payment	1726	1726	1874	1	1	6810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9yyEjiVoEsGLrEB98CKtF3jwdeNkpyjuqDx5QBQ1NqSop4bQ
17076	payment	1397	1397	1678	1	1	7946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMtXawvYpwiFACPYwCaGcNBzoGn36jLmfJk2DwXEfhNcqNmm9
17077	payment	1726	1726	1874	1	1	6819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1Vth5UNqMYVd553zdz8YZjDXyGJYxLbdfGwjpj3P5cPkybFM
17078	payment	1726	1726	1874	1	1	6820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEdAKaYvTx8symAQazAjhtZriGeXZkY2eHSydz7JfjZ11tt99
17079	payment	1726	1726	1874	1	1	6821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapG3tyXEggToJUN7H77TQho1tTVMyz8LonBegRSCVSKsASAya
17088	payment	1397	1397	1678	1	1	7949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaZU6f2cxuHFwv83s9zMtwWHSRgRjmVWoz2EKwkSf8yifQPab
17089	payment	1397	1397	1678	1	1	7950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUFfcVwhsdZmNwx6eiyhq1DDXLssTJaoLS1PPH1Eq1KkfJFNq
17090	payment	1397	1397	1678	1	1	7951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1LYfftV8GwvhP2bBdfQorHVhUseM1vG4xxeEUM5EXLb3iGbc
17114	payment	1397	1397	1678	1	1	7956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziht8HxnwXownK4gMszUsgSX5LeYuKJ67Bb8GbBabcPvrf2vS
17115	payment	1726	1726	1874	1	1	6847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4bgrCw3L86N88Rx6TLBnKwgEFr6hPkWseJCtFwA9nfz1EMLU
17116	payment	1726	1726	1874	1	1	6848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxK6GZVU7hdbpK15JRya1kzXkfzwLrSU7tuAfpJrKbgB92qVK
17142	payment	1397	1397	1678	1	1	7964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjewz8pFFmNtHuHUAFDmHhP3pU1K5V1adr1eB26TYUUh2kWRhc
17143	payment	1726	1726	1874	1	1	6867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbypTD45hbMJriGqFzqByXC5hDDKrpfudRNXXUZsCp24BzS1WT
17144	payment	1726	1726	1874	1	1	6868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWUZxSQ5dYpP1wGBBhtzoD47QemxHF9fS5ZGRiPi6sU5ki3f3
17145	payment	1726	1726	1874	1	1	6869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwp1gQpMLbMnVFxa3NontNwrvChM5eNgmNuLZoTT4Dmpnhojq
17150	payment	1397	1397	1678	1	1	7966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmoY6g2jS2ovce8H29s7DZ5AE7Xi7y1Rgx6Ktqso9Uai6whfW
17151	payment	1726	1726	1874	1	1	6873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzc1L2SoD1rEi3WNr9m3qpsR4omr65KAGuCnkJ3MBPFHBuk8FP
17152	payment	1726	1726	1874	1	1	6874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXdHD2FusDmfjxecWFdNaHBtck65aocui5BCDWdyThrb46F79
17153	payment	1726	1726	1874	1	1	6875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMThPp9YfTGWvw45trBPj4JBiEHfWF2vJsEhBMUPSTzBPv4k1
17161	payment	1397	1397	1678	1	1	7969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhv7eqSc8UiD144sNNrPsdERCzQPbvtqKyYWEcefwWbFVjg1Mt
17162	payment	1397	1397	1678	1	1	7970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVrxAV1Zc3EkptGbwQrZBhghCo2ep7WpNLSeU5TtomF6dBnWX
17163	payment	1726	1726	1874	1	1	6881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEomUSX615LsU93cUAjRsS5SaBrsGpHLdhfykb5KkXS1q15uy8
17164	payment	1726	1726	2108	1	1	6882	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYdPXvm2jZ4aHg7pZRYxqQvwiMzAr9tGj7DFSrMUr84Xz3CpFU8
17165	payment	1726	1726	1874	1	1	6883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmapwkwEjHVQmWDKHd76wEutUNwidpsbFWbur5CE7gcnNNEYmm
17166	payment	1726	1726	1874	1	1	6884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk11ramW4Qvy77xVK8Ff4hPKQjfySzDPk4dzvwTcRH2t5zJtCT
17167	payment	1726	1726	1874	1	1	6885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcXWhX3VtvgxUJgwuiQ14tKAgf93ZhUGz7Qh8HgyDcSKSsVHm
17168	payment	1726	1726	1874	1	1	6886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFevVDCfUzDdK25qGgghqmUtDq1y5ZwHDRqhaCTk5HR3rD3nYA
17181	payment	1397	1397	1678	1	1	7974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLKGvXV6uAwg5Dfe4ESgjuxCqttKzEWh5gkc6E2pEuRuJhy4g
17182	payment	1726	1726	1874	1	1	6896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKTUrfCNvvhkaLdKLTVgdWYXn4feiPTerdoW6cCasDCfd5s6X
17036	payment	1726	1726	1874	1	1	6788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EUTbJPnvadEPv4kUHRN7hgwQao2GdGW8fNniswwLGh2V9mwT
17037	payment	1726	1726	1874	1	1	6789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5VjisfGU2okGRf4oUDFAxfGtYwcoqYexTV4kmbcxRi8nMXMF
17038	payment	1726	1726	1874	1	1	6790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEryXwoCAah9Lg1XKfQZDEzGkkivUYWp39G2FW9uor4EXM2Lr
17039	payment	1726	1726	1874	1	1	6791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETsdHqcaGGijYevS7rzVRbYXBzSVzxURQz1DNLuMaHc4nLx4E
17040	payment	1726	1726	1874	1	1	6792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6YpgifTMPQfCAZKRziEo164kMxfFT5FSq6ihuXeJojhhDomH
17041	payment	1726	1726	1874	1	1	6793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZuLLXqzVGKMsd5LdpYGhBu3aWLLRYG1xUMnFgRzGRUPekbiS
17042	payment	1397	1397	1678	1	1	7938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQub1wxQ1bfLDsiPU4QZij1NCeZkmAUsq19YSXZHjXabKhdgfa
17043	payment	1397	1397	1678	1	1	7939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQSfPD8fJafqAuqqunEvrydJwA71jF9GyjdXU3fjd42NMRUg1
17044	payment	1726	1726	1874	1	1	6794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebUBA2jsssav88ffKcJXv2VnjSahitq3q1qx8cwxqctrs73dB
17045	payment	1726	1726	1874	1	1	6795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnruZU5TkRQ9FcWsS6J49mnpfbVhXhKn3Cj7cWPK1m6PgrKHRy
17046	payment	1726	1726	1874	1	1	6796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqjTpb8QGW7nW9Q4ZPhWLpyDJVA2DqH7Uod1LL2xAn7e7D9si
17047	payment	1726	1726	1874	1	1	6797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRcMKMb8gAsqqXEY7bskUSrLerkJJ5BxjFrhnSNBQMHHXG7eC
17048	payment	1726	1726	1874	1	1	6798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKqJqKCYRVbsz5CommHhtHLGuB9corXYoHVUrfcB1tnB7tbDJ
17049	payment	1726	1726	1874	1	1	6799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pLVA7F28M6RRyRs3emZHnxE5MbkUujrRkjjh5oHbCkuVRJcs
17056	payment	1397	1397	1678	1	1	7941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6y1iabzVk6pPBgWHD7EjDHTCWX86TMTBzUt6gLt8xuEakGkrX
17057	payment	1397	1397	1678	1	1	7942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKvvbAq6MsMAWUpiciKfvCQwwtoSYrVfqunhctkbdFvMtFdqo
17058	payment	1726	1726	1874	1	1	6805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjQa1ZHccxDghzJXvg13aJAvc4xnb73HYD2QcG2LG9fYfcsLS
17059	payment	1726	1726	1874	1	1	6806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdcgRnT82nvsTPYKGgBL8TTsGFoeDUgs3Z4Mt3A97Dj4YUjNj
17060	payment	1726	1726	1874	1	1	6807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25Q1winnqbYq7LF9AbL7asiUpiLNJb8tTNGNv3pp26JmnGdQF
17065	payment	1726	1726	1874	1	1	6811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCk8zKX4y6UZ91eypBoDS5sG9TCDXJWaoGS5RYWpdyJFsqV8ji
17066	payment	1726	1726	1874	1	1	6812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn213VdViPAq7w5fz14vVwU85tCWGSTQ4Rj2ELaXeEoD8tADGp
17080	payment	1397	1397	1678	1	1	7947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8xJtcrHccEfh6o4ZUec4hLHxh3FFySpYDF5xh2XnNgNQH5hD
17081	payment	1397	1397	1678	1	1	7948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeAz75S26HHvcsJEcdWWwiH67NWsh3GTVx3nPxitdfKNRc6km
17082	payment	1726	1726	1874	1	1	6822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdh4naV3PTkMDbpfigBARkt9JpXU7evrtK5SMWZyz8Zkv4PFPJ
17083	payment	1726	1726	1874	1	1	6823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMDYGzYk6unY669xkFtZCw2YdKQBtDqrReK3VoGDGwDy2pUQv
17084	payment	1726	1726	1874	1	1	6824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctvY4KUpiZFTRmSqTnGGtaUUuW2eVcBFy4DrGnT49xL943TNa
17085	payment	1726	1726	1874	1	1	6825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjXP9bbXbW3dt79bYYzbmQbp8sxsN2XaJ4gKB3g3kfGmyKMcE
17086	payment	1726	1726	1874	1	1	6826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWTt2SJKW8vum1ZAVnXK1RmvQWucyidtgnt7wcKAkR99Z4eyb
17087	payment	1726	1726	1874	1	1	6827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTqi46KHZgR55TFxxH2qe1NaiSucQmMTkdrkgw5dbZTTLgpmC
17091	payment	1726	1726	1874	1	1	6828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHdD9AS4BQYfUPKEMLDsTF28z8vd4zcttUxz54FKJftU7jWsn
17092	payment	1726	1726	1874	1	1	6829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZds7X4VuCnzfJSWBXPMUmeCpYCcz8hQJoABDeVDgpoVb3piRH5
17093	payment	1726	1726	1874	1	1	6830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkqyeH81wv2F48a8VdCCXAxLugG4qDfNwWp6Fkocn2ieHPE6Z
17094	payment	1726	1726	1874	1	1	6831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Nzgur9Qpw1HkC1AYmEuG7k6cEscZXZYKVqnBTywR8WneEbgi
17095	payment	1726	1726	1874	1	1	6832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WdhpqEPUJrrz55sp2n56725RbmbFakQ7oxkcpiNz3Ap7va8u
17096	payment	1726	1726	1874	1	1	6833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM24KqkSrxyXPPwvEP9coeS8jSyeguA11bAp9FVkP2Snjbed5h
17097	payment	1726	1726	1874	1	1	6834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYrmc4N7JdLiiSerM6gxeYLoxytPVERsgCgVk6p6995BXSiZs
17098	payment	1726	1726	1874	1	1	6835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVGjYF3TXcRP65QwDDyBdjbYxdJTBngcMNmfkQp8XRUzxgAzY
17099	payment	1726	1726	1874	1	1	6836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN75YL3g5LBwuYJNw4cQKCp7iChXugfB1HEmdtJU9LH1HPLuZC
17100	payment	1397	1397	1678	1	1	7952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Q7rKdeub7y3UaZXk3in6NA9yDbb4xLueHxDUV1CHyadoiY7b
17101	payment	1397	1397	1678	1	1	7953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DK7todm5JyYeJsvNP6CWtWjKzqmqW4wpSuM9WR4G8dxh2DBm
17102	payment	1726	1726	1874	1	1	6837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWqXgPajyDHw8caFzEr2Y4DgFtBkgL5FEJ5RgCvdmyYzc2fU3
17103	payment	1726	1726	1874	1	1	6838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrximCZfKzgcy78o8LLQbP5cihmEyf2Zmt3JqJHm1Gb6cTdYYh
17104	payment	1726	1726	1874	1	1	6839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcTi3SyNdPvxQmAEdw21vkYqxNw3hqMwYh5BS6xgBzhvGjL5W
17105	payment	1726	1726	1874	1	1	6840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Kr9cjvt1ipzto5CKUGNNLb3SLav2Jvf4CtRLfwyQws3sxx2K
17106	payment	1726	1726	1874	1	1	6841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FDjor8pyfDTyaPzYkW7gKJVLaqHFBa4iZUGWK9Rc5p7fEKav
17117	payment	1397	1397	1678	1	1	7957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDo43mdDTY6WVvS84PHiwHqmEwQT3wvjQGoHbqBCfzjRd8duq
17118	payment	1726	1726	1874	1	1	6849	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCi2ZQFQKeYsMjtFYvohb7oWwEKCFWjPrby8fjQ7hxA924G8Wd
17119	payment	1726	1726	1874	1	1	6850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgVpQAuwi2ZUwxmksGd81NFnpCe47q3tnq6G8C5vMA9XbkTaZ
17120	payment	1726	1726	1874	1	1	6851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkc9gmLZCGmViXqjLnycMseQ7nroHLPMujA51KA4NTr1VtjMvX
17127	payment	1397	1397	1678	1	1	7960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YvYnB9HEcbwh7TrezPyWMkD2gFVQabjZzanBvvzyDBjs8Etc
17128	payment	1726	1726	1874	1	1	6856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaetAfyB8gWAVYvtqB7eFNHH2TNoiSpXbhfHVpzu9FfA3D255B
17129	payment	1726	1726	1874	1	1	6857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTCifCJRrcJvMiVyJintvGJbk8GhUg7sG5mGEJ5M5iuc1XZ7X
17130	payment	1726	1726	1874	1	1	6858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7aDM8VtkPzUHLnTJKmb3BkpBvUkmKfvvqn9f7chFy78phYVV
17154	payment	1397	1397	1678	1	1	7967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYee5BVYcKEEwUSKWrAaktMBfYsjMksUD1D1oQUkccE7wGKq6EG
17155	payment	1726	1726	1874	1	1	6876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrTADULDxUhMpYKStgYhNVaYLN7dZqDgKA4GRQhKETH4UV7KS
17156	payment	1726	1726	1874	1	1	6877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUysrbXH5DDJQ5gBcajyUGoyrrQMgVtAL2bpyVdZ1vqo1QKYJ1
17169	payment	1397	1397	1678	1	1	7971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStDjXDPCwq4wAczPA74qYpkPcFRW9SBEADgkDvAXwKXNsqvty
17170	payment	1726	1726	1874	1	1	6887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHWmzYEAszxCA8bx9aNjS6Lzfz8EJZzJNVEgkdQAvxMJyRtvB
17171	payment	1726	1726	1874	1	1	6888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtiHV9xwMq2Je5Etb4bR3f7SN9PupPs4J7V27D3E8RYqiS94r
17172	payment	1726	1726	1874	1	1	6889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrje4WLYH9rJ5nv1EsLamFdT7896EganZLAm34WEDPt3GbKpa8
17185	payment	1397	1397	1678	1	1	7975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJX37o8KRsnSw1UyeLPZnQDcYHW8ih2JXZq4mvpNFkUYPxDDC
17186	payment	1726	1726	1874	1	1	6899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rfrg56x5FE3jHqaGnMVw2MUTM8j6kBQnhbCRddtqW6htAVNj
17187	payment	1726	1726	1874	1	1	6900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLKZcjb6hScCDVGre7ev8JD6gaD34AsCacuC65n5ej4oYVZBr
17188	payment	1726	1726	1874	1	1	6901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GmaPSXKgduukamYm8GrPQBbCBKsiKdpFcHdtRBRgUmiyxZvy
17197	payment	1397	1397	1678	1	1	7978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNkdAX4TGLktEK93SgWQAqZMqhQc1a36kiQfBugUKeqdiqcAm
17198	payment	1726	1726	1874	1	1	6908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD2zM58pkK6WuhMmV5YreQr3BGfMEJ5WiSzfdJmuyBK2nM1zB
17199	payment	1726	1726	1874	1	1	6909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDWHvt9763GarsRNGp8pD1J5DskuCWeNKQV3gqgXNxWhALcuN
17200	payment	1726	1726	1874	1	1	6910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEmaK73CgBNLDgzKeY49mcudnZTTfaY7zovt84AF4Kj6TgNSc
17208	payment	1397	1397	1678	1	1	7980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeA3ZFctLoVT9arsDzLdmSoAC2SyYKpXg9MY5R8cK7ks2ASF3a
17209	payment	1397	1397	1678	1	1	7981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKxnt2z5XxeLjy9obW8dhahaiw7kbaQtWEzuPFiGY6xeXuQiR
17210	payment	1726	1726	1874	1	1	6917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6snRYRZsgWAadpDPzFN23fxPm4YJu2NdrBsSyjs7geUCtD8vL
17211	payment	1726	1726	1874	1	1	6918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEarpEJSn6jWK6SDqi65e46KrxYqtJfACiLHmA3YsLW2YPszAh
17212	payment	1726	1726	1874	1	1	6919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXwPZFHhRgGReXYGAHdWJdnAv2Y5jeRmLBJBLt5EuNfKvTZdC
17213	payment	1726	1726	1874	1	1	6920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPpGbu53uT43E2vUdADzHoPGE8qiyjeFx7ic4oKeHZowXgdM3
17214	payment	1726	1726	1874	1	1	6921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebAwAquzKAeijwtao1r86UhAWKCrELZrNuCfZCeegdQH3mSWZ
17215	payment	1726	1726	1874	1	1	6922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HKtXkuQxwBGpaYTGyEMJwrsYmFSGsbwfnCSHeN27c59KzY9v
17107	payment	1397	1397	1678	1	1	7954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpYvHG43ZHmVjAwkS1U3WETtMnRhRUZqJsnjAKqwd8UA6LNUq
17108	payment	1397	1397	1678	1	1	7955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHKGcTgHtBy4oL35eepJyvhyzhxrQAj4qQMQ5GQ9FHPHxSPBD
17109	payment	1726	1726	1874	1	1	6842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniKRs9JuLcNq5UqUR7CwdTnz94y2MxrZLBd7ugPQVGQmaBCkn
17110	payment	1726	1726	1874	1	1	6843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzjjAxsewp6uakUmnmYKttBYT2dX5F7vvePNSfFH5rKF1m4yY
17111	payment	1726	1726	1874	1	1	6844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYscpE4SBKMcQAi3cY3UHSxf2y3hgHBfk4ANRqJiB9XcwAFtCY9
17112	payment	1726	1726	1874	1	1	6845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvjbaCpxj7YFVGDchmMyVzTcQnp8KxfusCyipdXCuv9iBeRr9
17113	payment	1726	1726	1874	1	1	6846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweQnRZbfANRcB1Mgu3F2p7Mih2GmpQPpWByyRfkXFKY8bx7tU
17121	payment	1397	1397	1678	1	1	7958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzCpbRr1ukPLoRTAxKy6BoYp1TNJ4KUQ9ki5X3XK6gsL2ouiZ
17122	payment	1726	1726	1874	1	1	6852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqAn1s3FkcLqnckiYc6dTMKHNuG9ETfvZyitg5vAjhZ7vth8b
17123	payment	1726	1726	1874	1	1	6853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaS1ycUNsEkfNyYKPR3r1htZv4DyXTZZcFoBPCHHVGHjLkwGwr
17138	payment	1397	1397	1678	1	1	7963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6sbnnTFpG9ZerQrsYHXR3cwRk1MHHvu8HPmQVxM2edFDXres
17139	payment	1726	1726	1874	1	1	6864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHFTZhf7zHQFbJziWhZuVhDgJfzpb1gjGEYTQSvx5upWXZ7ra
17140	payment	1726	1726	1874	1	1	6865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVdcLupCwZKVuLrKahVTZpVmWfUvW2PpySb3mYg1fLPFBbHYy
17141	payment	1726	1726	1874	1	1	6866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRaqDhnFrDcYdg5A9ZnMvaiASvb6kG6tL314uBZ4tNRUGygaod
17157	payment	1397	1397	1678	1	1	7968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwM2M8rJ5Er9cNJRKpNvFZgSdMqeB5LKFDjiCnxYr2dJXdQASj
17158	payment	1726	1726	1874	1	1	6878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUokuWoF4iSfrGwvYu2jspLQBLcPTm4S9UqN4kvGUiQq8N16u
17159	payment	1726	1726	1874	1	1	6879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3BKRYJjtTbytFfm6m5AHDL792zVG29cuYmrhj7dtBXV2vmZh
17160	payment	1726	1726	1874	1	1	6880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe61SxYWazDgsgUZbZHQuv1f7vGkecqQrGvXH4EVmdAeWeUMpv
17189	payment	1397	1397	1678	1	1	7976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHfCeq7cRBDVKvqoH6QJ67XTqGbFwWT3UENbXByY3eh5qRvkp
17190	payment	1397	1397	1678	1	1	7977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWcwUCfTwm4SvKQQGaw7vh48fA8FrJN4kw6JVXSNSRA76W2FB
17191	payment	1726	1726	1874	1	1	6902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KC2WzANX6m4J3L4B6WQxSgpuFq7mBEMHV4VBy4qD3pZuQYHh
17192	payment	1726	1726	1874	1	1	6903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdFuTpYzsXT3S2rtSaN6TupbKAb54CwNzcswJ2ew7pprmBe77
17193	payment	1726	1726	1874	1	1	6904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42Bg1KaHEcZi76KJsaW97YHkbHkvsmc3AC1HKNMp5zHEFR9pr
17194	payment	1726	1726	1874	1	1	6905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ayQNzD3hwtEBxZk8yvQzTUSc1huJLJwL7aiPNX32WAVQoxeT
17195	payment	1726	1726	1874	1	1	6906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Cz3WMzWTLZvkHxZW7JJoETbEnt1e6Qf3hux18KUi3RQq3qzJ
17196	payment	1726	1726	1874	1	1	6907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLgpPFLVjSK6NHT9CQyEZuCrQjCbJsuncGJxFasCwkrsoLhgn
17201	payment	1397	1397	1678	1	1	7979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHsD1RjefDN6qHHqzB4rA9fqJcGwMpMrjrYTbXCvVCjsTePthJ
17202	payment	1726	1726	1874	1	1	6911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCmfat3yzw3dY2aA5sMT3VhPqkTGGCmYDrc3FRjJpxFe7Dxhd
17203	payment	1726	1726	1874	1	1	6912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcqtNHVv3dGu7F3o7kdWQ7q8a9gujYNwWZuo3fdARK14tdLhpV
17204	payment	1726	1726	1874	1	1	6913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3b2qW6NQFdRAhqe2UghKdww3m5FgtoXT9HuLuZpjCRjY3D4D
17205	payment	1726	1726	1874	1	1	6914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2eNq7cqXnPCc3yQ6xyTKkcH6EKFw6jR8987xpr3E3byvA3Mk
17206	payment	1726	1726	1874	1	1	6915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3V92bgfG1UY2nzf8mKhoJC4opXCpg5wZYY4LQgu2Q9GzkxQ8U
17207	payment	1726	1726	1874	1	1	6916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNcr9nsSx7p2oBKm7QMNv6Va4kzenctUYjo3mk4c5iiEvP6tv
17220	payment	1397	1397	1678	1	1	7983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmvEeoWfxE9cgvyatnukE1gyjH3nbLBRzN78LKi6WTznyQpW5
17221	payment	1726	1726	1874	1	1	6926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfX7t88P5n3yJkqPkCNKrbt4V9fPPFw6qLUSjCCJez2fycCooY
17222	payment	1726	1726	1874	1	1	6927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH6ZYRzWGH8tSvXik3rwrUGsa1E6Y2TgXHoF8bfws27LAQUEn
17264	payment	1397	1397	1678	1	1	7995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQwEo2gQGKgBzth8cUkaomDYq33iMqFXs4XHGqHggkKe9VDUi
17265	payment	1397	1397	1678	1	1	7996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7REu2SruuhArHH17S3KJhUpayTPBhooteVc1pjdhwdiaVcyc
17183	payment	1726	1726	1874	1	1	6897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfU8zYW6R7Ur2U4et61vwhjcttnJHM6hHB2aTGGuE6nX4MAhX
17184	payment	1726	1726	1874	1	1	6898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mjjRr4tc3cyZ3NVsC3Ur1436WdPPozQrmQHDCjxVPwxFKdu1
17239	payment	1397	1397	1678	1	1	7989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNuBBSeBZ3ibjZPLVSZ7YahDMQmSRq4tycHVaUYZFP3ZTzvuX
17240	payment	1693	1693	141	1	1	667	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZkiaB5QAgcDibNZEpNAuikbLVNLPmE16TkzAucwNxeA4LBqJrK
17241	payment	1726	1726	1874	1	1	6939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KUNJAEX81szm7EwNpWQKriTcFb47T31nMbYwsct3i9PeVnuM
17242	payment	1726	1726	1874	1	1	6940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJE7Hrse1qRQg4dEXRjKkm2aGCcjuHX9UUbAJarwh8roXnqL7
17243	payment	1726	1726	1874	1	1	6941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6v2iRgPLDPLD4T3FNB5G7xFVjREUkexiV4FiHv3bhdKcyWzx
17244	payment	1726	1726	1874	1	1	6942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fpfNUzA5r6seZ4ceDcmpm3q38eTfwUimfGC3FakBHPjN6Uvc
17245	payment	1726	1726	1874	1	1	6943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8oP1JUUyFhe6HFRjeaJmXodAfqpdocZeAV4QGT6TDJBJEfSob
17246	payment	1726	1726	1874	1	1	6944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCptixpH7Y6gUyFwBk67ku2tpgQRoBc2MHYSTWAnoAcobSNuiS
17247	payment	1397	1397	1678	1	1	7990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkQtG3YRxveABVZZYirEZiuqcnTjRorLsh3HPD11LqA8guBUn
17248	payment	1726	1726	1874	1	1	6945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z4vgfBua4mx6CBtuXmdSmjohWaK371UndaQbxDZpvqyQEMF5
17249	payment	1726	1726	1874	1	1	6946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P6rNzDET4pfejoj1CzMpfh1uCE4f4VjJa5MrgfmTMHCx9mxJ
17250	payment	1726	1726	1874	1	1	6947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ8vHWejrQbYNzWcbGicK8XAMhZyEAFUHWbR2w1NkiiEEiSSg
17252	payment	1726	1726	1874	1	1	6948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS526NzFjmZyJi31WTaU1dgrknMwYvxJsJWQuvQdKoRGHPvdr8
17253	payment	1726	1726	1874	1	1	6949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVWNUUYde59728hNv6Q1fTUhVxd2PGrFqSNCyb25GodhiEKqn
17254	payment	1726	1726	2109	1	1	6950	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZe96GtYMgnETPcZWhCmA4uRU6nqLSyJ9siRUbxtjKwAAvHY6HL
17261	payment	1397	1397	1678	1	1	7994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJ8CHCfNri9K2WQ1Z5unSam2ypsB9QqgUzWiDoVDYXpjovWhs
17262	payment	1726	1726	1874	1	1	6955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9zdrUdqQMsE4jERcSE19CM5SSkEqjdomv78yYfWfHndGTHZg
17263	payment	1726	1726	1874	1	1	6956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSouec5Byg9zN8ULt8bckQ9dTawgCZ62ZcjL8Eh34VpXS6RqwQ
17276	payment	1397	1397	1678	1	1	7999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsjCBcRqPFsX7amXyWzaFoRAJzZ8CV3PCv9HC66ur1LGSRPj1
17277	payment	1397	1397	1678	1	1	8000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxgC8969it6hMh7H3bfQEgPELLw9SXA8g8MZ3umjGFeJ9S4ZJ
17278	payment	1726	1726	1874	1	1	6965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8GdQgpJwTm79W39FFsDK2ZH2KETjPjMjGtH2PWwZRpd3VZdo
17279	payment	1726	1726	1874	1	1	6966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvadccZX1iQYzgVnxcshJzo16qeEMwdHGwr7kAx42AdFCQqnD
17280	payment	1726	1726	1874	1	1	6967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjhoGKztdFCLonDjpjETEqQJezbVAaRHM2JacHKmeCoXUE8LiR
17281	payment	1726	1726	1874	1	1	6968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhAVWbU5dCJ9kEFvgiQNf2r6vuSMEMHWrEXQwhv6XW4tc5vgW
17311	payment	1397	1397	1678	1	1	8011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQSWgjdQj9P8jgwV2AKte3RPdVuHtSZue8E8hd3jLL1qwua3U
17312	payment	1726	1726	1874	1	1	6988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPx8pXHzeUH3q8WcySMGDsnsnJUhtgHQvN8QBrkScrvPuhT7g
17313	payment	1726	1726	1874	1	1	6989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrGZxetH16ZgfF748DmB8uypbXuQWoZn6gG2SRjGKxq1tpwiw
17322	payment	1726	1726	1874	1	1	6995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWu6EoCqQzSQR2YV8YTfTkQ7immKGc9AB4P3MasGiBaNZvDig
17326	payment	1397	1397	1678	1	1	8016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ww4esiAvsw1q9gwsegtLkny6jyNsUZkE3bpQA3PoU9zF9gVZ
17327	delegation	1769	1769	44	1	1	30	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Yp8YrQAKDpYjRMT4mRzVZno7oiWzMvHpYPYgHeZ4AH4VTL85
17328	payment	1726	1726	1874	1	1	6998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vKHc75m28kJFUESke6GebzA47jfTLezfqFSr8AFKe5DT6Auf
17329	payment	1726	1726	1874	1	1	6999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqycDouk1fn3s1T4JzZ2wwqXCmS8bndYRBgaBRDHFJiVW7qUk
17333	payment	1397	1397	1678	1	1	8018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJyiwmDz3VqyXUpF2zJqAfW6vZZn1BqftYC29XjebknEPBJZX
17334	payment	1397	1397	1678	1	1	8019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MRG8XkUKSUxC8sXdmHCYb9qTq2Jp39SyQxEWfjD4UkGumX7s
17335	payment	1397	1397	1678	1	1	8020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoehqrP2WVi1F1BngGQGGfBZ2Y5jhLxNb3QF7BBoZeZgVK42Pr
17336	payment	1397	1397	1678	1	1	8021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSA7r2AWBYV5HnzAJhrDeb1Xkvy6EpPwnnKC2eG32nLPU1PXxD
17216	payment	1397	1397	1678	1	1	7982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCCwGtPpeVTmSgvnGkMPJhgrBcjidsp8VSFt2ruz89FDAwPJE
17217	payment	1726	1726	1874	1	1	6923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDZPT8whdWnPzQn37PqBcPhJ1wqwq3oRsytMU3eyJSqc9JSYq
17218	payment	1726	1726	1874	1	1	6924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yzG7pZjX1frWebCADifwS6os7BLF8rM6xnru72E4761LX3pb
17219	payment	1726	1726	1874	1	1	6925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAC5BNToELcBYLh2prFRLuDgruVH4tGJUeT76wRvQkfRSrukQJ
17223	payment	1397	1397	1678	1	1	7984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFZvqnK49ZN6aZsPHuoU31jJZFLHRJ5scoV6AtqyCkdhnBVng
17224	payment	1397	1397	1678	1	1	7985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72nkeUmZUe7F7qmVMuM47UHgwrEGSd5iAUY5LgyjQByavGF7L
17225	payment	1726	1726	1874	1	1	6928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhsmfPNwtENRyxYyCDJXbibt4RreMZpBNHtE88dNLsNCPXmyD
17226	payment	1726	1726	1874	1	1	6929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFM97Hrvr9TFGkD7Mz1UGvq5B8fKuiVJfED541xvRBy9yaWRS
17227	payment	1726	1726	1874	1	1	6930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjG2ugKMVSFZNGxXJgJruu3AGEuDFeNiQUBUbyMeNxvhummMKh
17228	payment	1726	1726	1874	1	1	6931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXwVuTKqVgmayuLvUFaY7qi7LsPuLiPoddqssxTnikDLZ2ZVs
17229	payment	1726	1726	1874	1	1	6932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pkf5qgcLPy2SNmiSW2uDwF1HYCW98Z8qmUtNTysa8kxxd4tc
17230	payment	1397	1397	1678	1	1	7986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyYYCUiKFeKNR2YNVBz6dUR8zhNL5Rbvq9uEq9EnTQ68Bdbhjz
17231	payment	1726	1726	1874	1	1	6933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rBzaqkoyB6GRgTk2QejK3TmS9eTJC583pVXWSTX4CHRNFMAT
17232	payment	1726	1726	1874	1	1	6934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXsYWRokoVcoHWGjGq9ZMoLE9dqZoZK4r8izQdexSqmYAKbNp
17233	payment	1726	1726	1874	1	1	6935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGUgZbyms2MVB5zfNLHJVuRns7AMi5XSLRbEjykdotFqMZNH3
17258	payment	1397	1397	1678	1	1	7993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZpKTkhJpNUXrm2QF22kr39TjEgnJwCzJCGE54gfVzCogy4s8
17259	payment	1726	1726	1874	1	1	6953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy61ShRcbBhJd7yWoQGJax3iF3zGRdLYJPmk1kwz1jyxeAkiGo
17260	payment	1726	1726	1874	1	1	6954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XvKs2cgfvwYo2xRAh8FazSpbuSpd4v9FjqFaruWYmMEFPuWG
17285	payment	1397	1397	1678	1	1	8002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEpMqAcdmxxSQwJG3jMkniMiBcNfkQhRisdK7acp62n2xf5sh
17286	payment	1397	1397	1678	1	1	8003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdBdNSbLVTzf2igZEynMqzoAycQvjeAqMbcjH7G4aTHVsRqso
17287	payment	1726	1726	1874	1	1	6971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1bhaxXt8cQFQapVS6A2usG8yZ3FraAA3nWmcioFosR3NmoVU
17288	payment	1726	1726	1874	1	1	6972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaLdJVQcPVccdAcxFL9WLcihiKUxzxJjqnunweKBbGCzgkREZ
17289	payment	1726	1726	1874	1	1	6973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBk8H6TfYf4EYGTA6Yjvu2PXdkhEYMf2FvFdEWALwtRKXG7QL
17290	payment	1726	1726	1874	1	1	6974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLqo5fWpkJijtbitELWAQvGFHFdVSbRP81HBvtGiEoBkqtDAt
17291	payment	1397	1397	1678	1	1	8004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PGixcLebdrwiwzNpqGjCBb73xz4H8zqpND5ZpouWSrEGv321
17292	payment	1726	1726	1874	1	1	6975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYws8NrAx1gc838mcabqdLy1sXdHw7iVz5pePfZZEHb4KYVzn7C
17293	payment	1726	1726	1874	1	1	6976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXxSnwGgwWWtkZd7Bg8ujyTX7tNBQvGpjuEswETVLyF5mTobP
17314	payment	1397	1397	1678	1	1	8012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUK7BsFns4ETg4cwATQp8YipHv8iHZKJxef2xw8iamo1h5bMw
17315	payment	1726	1726	1874	1	1	6990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9Xxi6nDqDUgxD3jW95DGc6vy8pgTM15gbPcc68F7MMeFgqCb
17316	payment	1726	1726	1874	1	1	6991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKxVDDmff3egbq8ZTbgTWGPVGSuSjvBns7hxBbBZ3UV968EDD
17323	payment	1397	1397	1678	1	1	8015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3DpMdjNwUiz2v6hCW6rKKNtweSFJmUqmom1ND7wrZH6upY4x
17324	payment	1726	1726	1874	1	1	6996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz1xgwAnk6Qq9y8LM86nr7krArDVnd9WJd6EFSqBEXLzXf6j2Z
17325	payment	1726	1726	1874	1	1	6997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVgRZQRxY7Mg47trzTf6McXSonFbdHb4PrvRfyCvkPnvzNKMD
17350	payment	1726	1726	1874	1	1	7008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuX83nr2ZbBDonHSrr7mqvMNYNdt2rB4KPSSuKNqHtVE8AL6P
17351	payment	1726	1726	1874	1	1	7010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdjwgTH3fT62wiWDDkg4qwTbhb5TRqwX3fLgVuqgqMwKsekqu
17352	payment	1726	1726	1874	1	1	7011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXH8oZzdE7GkT3BLAhGcWbGikBMWtk6n82GVnkiaonbYgoWX3
17353	payment	1726	1726	1874	1	1	7012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH83ATksz2s3gajaySuTVAvVgnB1ZhriUj58bQF5fhaEXWKg6C
17354	payment	1726	1726	1874	1	1	7013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSM92VgGuU3YGSezKAKSjWoUifDaJEkn36ekgW5QkTVrurgXL6
17238	payment	1397	1397	1678	1	1	7988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8gcdvnsPYazxM5NxEvHe3hKiRTfLhwGPMxiE96kE93Sx55G1
17251	payment	1397	1397	1678	1	1	7991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwH6EYqYHJfPVWg8YPRYw9UCBpnYvC1RgPf3kDi7FpFcn8e42
17255	payment	1397	1397	1678	1	1	7992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSvx218wqvtBBon5AsG9wYZB7j3HF9EQVrcek15sRe6WT9Y6VL
17256	payment	1726	1726	1874	1	1	6951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH8ThaQe6wBXCs1grLjWzgxBu15K11yWfyDEqdzRxbGS6kXXpB
17257	payment	1726	1726	1874	1	1	6952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLECFnnjc9GEDmEgdqBsB5jKUGPWnDcE8ePCWx2Mk5SNB9wB4
17267	payment	1397	1397	1678	1	1	7998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KQkfyAtvqDVbeSBEyyBcoRVyBSzUMZFzzkmjYM8ji3kTwmiR
17268	payment	1726	1726	1874	1	1	6957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRi9G29aj7HWtgQx7cj5n6a1AdcN5xoBJ3HyX1n1auKFCwXh9
17269	payment	1726	1726	1874	1	1	6958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXRyovpyqirX382H6TYrvjaUQ4G3uVCoHUjPZzeBSqZS3VTHB
17270	payment	1726	1726	1874	1	1	6959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy8N59kei53caStUYuN3QDVbFQVxHwdB7Gc55Cvr1P4oatjh1a
17271	payment	1726	1726	1874	1	1	6960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4cicpCdmpfzZhTzKrxXhVVYtFsHFkuuo54NF6zbAnXCJGMBK
17272	payment	1726	1726	1874	1	1	6961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLcYWMGbXKXzJhHqUR3muSsq92fmLJd6DzEYVHikoubXBgGg8
17273	payment	1726	1726	1874	1	1	6962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiF3xmnWpuoeEoZMR8s89Y85ikPbaQfv96KGTMhJVqwdJYa9yb
17274	payment	1726	1726	1874	1	1	6963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMossBXioSCF25rjSryvfpvj7yvYnD84vMYUXwwWbTkYihxcjU
17275	payment	1726	1726	1874	1	1	6964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKsDH8a8YagkxcvL7e1A7k7dDtu4xT8RPAtaXT38ERB7pn7ts
17308	payment	1397	1397	1678	1	1	8010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSoDKpV1VHs5RGJPWMfe4A5TpTE7j1aeWdsCqc6jzK6VwRSg6
17309	payment	1726	1726	1874	1	1	6986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPqHwegV1E3or1rE6jgs5G5ordopWcPxTh52th6S6W3Vw1qxf
17310	payment	1726	1726	1874	1	1	6987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzh8UodeCd25QFi84QzPqHK6VPCUYDLnkZHPLTQmsVi9knLvD
17317	payment	1397	1397	1678	1	1	8013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaER9bvVZoc36x14e3FPqz2syPPzjwNmPzwu6V8P4FV6d2wgrSj
17318	payment	1726	1726	1874	1	1	6992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZseu2yoJ6EHrXK31Zt18i4dKAntGnextocR7Vv2hexcmDAQb9n
17319	payment	1726	1726	1874	1	1	6993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvvemZmXxiQ4oQpbR5jRmZ2NFZrTwBLmyWLqaP5NNZ6D6JtSN
17320	payment	1397	1397	1678	1	1	8014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ZaT78DXmVBS4czQDCdCQhYkNsEaoQDdH4Vyccg5kyfgmzav6
17321	payment	1726	1726	1874	1	1	6994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWyfJ8Kh4naQ6dWEpc7LghZRbGksRp4x9PU5whn3N3gXgo3zg
17332	payment	1397	1397	1678	1	1	8017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhC8ByhfZSHL3TpCFoHwKh3SUha2EfWPWTZp8jSRMNvG3M9Xs
17366	payment	1397	1397	1678	1	1	8028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAyk52LQEDSY7J9EArbouCXvh7TPYnGfRjgjMQuRYnAKV1Ej6
17367	payment	1726	1726	1874	1	1	7022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRC2U8Gwh7LKxhruFSPUZrQd2fZsULrQkvMm8xwuuEvcSMXQod
17368	payment	1726	1726	1874	1	1	7023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVzuNhujiKe5EWzWwTA3Ami2KDHvxujVezAiQvfa37JVA16g5
17369	payment	1726	1726	1874	1	1	7024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxFSx6TPCswb55V4bfv5YDSsoqgBMwmWeB4SpGS7zhERmBVEU
17370	payment	1726	1726	1874	1	1	7025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYum8AP913f1d6LMn9dqPgb3iGDK6xZX9uSFE4rGoPZquw248eW
17371	payment	1397	1397	1678	1	1	8029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPXbZMD364uuzH2Cpy4sx7tNc6crVLWC38FsYWXe6b8MTesnZ
17372	payment	1726	1726	1874	1	1	7026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBwdGJWBSCBX5ZVBSmjXWRfDCKp7PBE5DtdwR7vGuYQbnzkLW
17380	payment	1397	1397	1678	1	1	8032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQK9q5AdYGwzAj6TAvQTQRFrLjhBuLe5h6imuyDq4uG84yxeE
17381	payment	1397	1397	1678	1	1	8033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jVUerKqAUhyRukN8rrLunuj314JmfxDNjnGyqcXTKsSdgKRr
17382	payment	1726	1726	1874	1	1	7032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7Toz1UkB2pemx5mv4KU24GLW3srsuwj9m6mLLBF6BnYbrv4f
17383	payment	1726	1726	1874	1	1	7033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NdRf2fCuMtXvhCQqu4saQjA7Tj8eg7CktjP6X4o3w6p7Z5YP
17384	payment	1726	1726	1874	1	1	7034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNW36Z9pgQZWTSozy6jTuWRyDLhaGXWaatEVMebjyu1NN8EHK2
17385	payment	1726	1726	1874	1	1	7035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa99RLnkJVFqPHoCSR2yzQiVt4SSmbonGAKUtvnHF6onbfUxia
17386	payment	1726	1726	1874	1	1	7036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQ13ZTzF6vm3HLEn7BKWYLXMxJj4RpaGP65Zo9GQF8d6VE6rL
17387	payment	1726	1726	1874	1	1	7037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9L5XY7AKBmKytTVZMRCR7iK1akAkXFAph5pWXoxo8yYPLfUi
17266	payment	1397	1397	1678	1	1	7997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAtrmG8nCxa1YiFEp9WLBmSndAQLXtdjhmckctecwrDxBu7H2
17282	payment	1397	1397	1678	1	1	8001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJaKu1A9DyhV2ZjM9g2WrgKK8uFF5jgLUKSLaQbJ6xejHAYf3
17283	payment	1726	1726	1874	1	1	6969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPUuDxLh7GgMpQNo2U65oY7ewncE8WCe6VVoxcxVs2h3WX6dy
17284	payment	1726	1726	1874	1	1	6970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm12Qff7iCf4ZKt473Yyy62taEs3HjfqxVM2r4jzSrgfHu7Lpm
17294	payment	1397	1397	1678	1	1	8005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtvPzA4bRKtsy6AHV9vwh67CC65grDjuxdi2bTLZ3qaLiCTpF
17295	payment	1397	1397	1678	1	1	8006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1qA2Xm1sNdEQU5aBdiHi2Z7WVmrYU9GxbgfKPPaXAkM7iQBf
17296	payment	1397	1397	1678	1	1	8007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicTmgsDvzYm17CM4F35iy5aPCsHodzbCnEBA3bfaMn4Bh4tUQ
17297	payment	1397	1397	1678	1	1	8008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAwYqCMs3ZQc1b2eagMuHMFJSh4BaqU4X2nbepkWBaetNmStwA
17298	payment	1397	1397	1678	1	1	8009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGY6xosye7rhH4RbabNmEYp1BGbHL5CvLMMVAxwdenzXj2sBAU
17299	payment	1726	1726	1874	1	1	6977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtdQVMmwStt3zbgPmgkTYtFcvzHT3HVZU5DAZXPC218Pd931K
17300	payment	1726	1726	1874	1	1	6978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDs6za22psmvX3ax3G2vtFAhrwVC1GqqF8r5BnFNaAWcpxdaHa
17301	payment	1726	1726	1874	1	1	6979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6TrpjeFKYRPw1NrFijmHLDgksDX5Qo45du3ifaWKFsgk4NT6
17302	payment	1726	1726	1874	1	1	6980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWJEq3s4iwoUa5TWxF6Rhk9QMBShhnAqqewaD5eaoeC4pci3R
17303	payment	1726	1726	1874	1	1	6981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KxannvCKxZ2VEHu4FntKHrQoHBDycvkSHX3kswSGN8v6dHiw
17304	payment	1726	1726	1874	1	1	6982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnp7XbheuzR2UMvjipdkYhNtJA26hxB3JbbMBWkDJFwxCJAdCo
17305	payment	1726	1726	1874	1	1	6983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AjQ2T2b4dsqamaHH49P4PovTRZ6k2zRur64TsNSnmcgSvBwa
17306	payment	1726	1726	1874	1	1	6984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZB71avbV4KrPPPZjPPNp3P3Jgvk5tANUdsEjRnyAkQpzU3PhL
17307	payment	1726	1726	1874	1	1	6985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJS58SfDXkGT1yWurjrrKPqL8MHuS3KqiW1XSjqgZCdX3jGHX
17330	payment	1726	1726	1874	1	1	7000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJFoievSDEDPekxbfL93sGCHMc8H3wPutBVWx4HVKF8k6SzLc
17331	payment	1726	1726	1874	1	1	7001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQQsK9WhioCT3YfCSJMESNqXc7wRGc38gPC9Gwa3vDi2tVMZW
17344	payment	1397	1397	1678	1	1	8023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EkdGfLRCJVoRdVr8DdhGHvZkeRp9mdodXo3vJTLoUucz9R5f
17345	payment	1397	1397	1678	1	1	8024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQAscfa1hvhcdX5fJKerr1byUeqUExh9Uo74m5itPSg8KhmMH
17346	payment	1769	1769	1769	1	1	31	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpxxQZnayKTaZhz2WSw2G9sst28SQxrKptBJp8HhVAX8a5RDB
17347	payment	1726	1726	1874	1	1	7008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSESPbQhiiVzaYzrJrKXSz4Uui7gWZEkoTeCnhZ3nETSt6Rtf
17348	payment	1726	1726	1874	1	1	7009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KpTdLbtzq1k8MzZnPvwgRP2NeXutxnUVMA37T9QP6nwEg86k
17349	payment	1726	1726	1874	1	1	7010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUgXc2rM8JVvyPzLbSh3mF4LkTMne3p1ET4fG6b8ZXqJeQcTm
17359	payment	1397	1397	1678	1	1	8025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8MsKnMeHC38VBbTr8XysMvsZUhaW5BWnWPezmxBh3Dz8MRxF
17360	payment	1726	1726	1874	1	1	7018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcM3EBjP7ZzJEYLKVj8pBxtjewUCAbgdWRqoneVS9sifMVreju
17361	payment	1726	1726	1874	1	1	7019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9ftFWinFmvqr7FtAkdSd5gCXU3GUkrnqMmVXDwCseEUM84Vj
17389	payment	1397	1397	1678	1	1	8035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFyTEf1py88j31QkR45u6grr4eoB6A81M8d5h4q4LMCpqfqTp
17390	payment	1397	1397	1678	1	1	8036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65Nth5DqcVn8FJqMbF1bvccHXLB4Tgjy6aRgE5c8g2zKMQNLL
17391	payment	1726	1726	1874	1	1	7038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6yKLv61qAGqxN17iDjJMNf55ka3RzCqzt7ssFYPLxVMVpC6p
17392	payment	1726	1726	1874	1	1	7039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHyijbhRzoa4VWxixf2Y6DoW4eTBr5ktj4Jc2ToGXTT3Wsouq
17393	payment	1726	1726	1874	1	1	7040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGvzT7dP4Z9mfwGV8XV55ntrtSu9Gc1P3HWSAJnJTFvr1yXAT
17394	payment	1726	1726	1874	1	1	7041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiUQQY5LsBmpsZ9EcB72nqbFtTbFFGqRApJm1EiSbvUiqenna
17395	payment	1726	1726	1874	1	1	7042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ivbDWwRg1TimUbr6t8dpLg7qe1uCeV4GKz3WDsRyZaJDq3A7
17396	payment	1726	1726	1874	1	1	7043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZYLpL1T9MS9eNr7CdQTJ135NjvMjbwNG8UKTLiuPXDsaUmeZ
17397	payment	1726	1726	1874	1	1	7044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzdMCicaYVmtvJeW2xqCEpGiatRP5BTg3ZHCbAN6vxMEZAcJV
17337	payment	1397	1397	1678	1	1	8022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9pRMjJLs7bXNbXBQG2A9zct1LuTuvDWgEX2dkdmTVDTQEy22
17338	payment	1726	1726	1874	1	1	7002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQGFbLK7L1u9vo7rQbajBRqTLZ4UKRFyjQNZhGKyu8yyvTRDg
17339	payment	1726	1726	1874	1	1	7003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtWCZ6Vu9gEGb4VKQxR7iE46PXb9rVfsakBLGesccueX2bZSd
17340	payment	1726	1726	1874	1	1	7004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgJzSog5yQicrZjGti51guBPqhPLCPihUtQFDGr2bCcLLLSnb
17341	payment	1726	1726	1874	1	1	7005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGojuffu7TUocd7aS23345jMp4yZwuDaixqYg2nDPZ1hzT8gT
17342	payment	1726	1726	1874	1	1	7006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHB9s6cq8kpi5j7fr6TKCFjC6oa9Vg9XiLCtqtHWiXaqYqAq1
17343	payment	1726	1726	1874	1	1	7007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcv1yhNuzPMp2vrc7iSUKVHSSTskA9mzJfeGCw3CAXd471gdU
17365	payment	1397	1397	1678	1	1	8027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDtYxNyYbeG46Nuw4k4niQRcpDPSah89MJ4LDF2VQeLSmGHuT
17373	payment	1397	1397	1678	1	1	8030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nuPaELHXHM45rNPSMbHWxtJBcePh8Q656JRUjttTHy3Y6D4P
17374	payment	1726	1726	1874	1	1	7027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjJA677kTzfw9KvQ9dV7qqnn1xq8q3pXR7JazYfTVbQ1A7rFy
17375	payment	1726	1726	1874	1	1	7028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKdPMRrb49ADSYjoeNKL2g1DpoBc1sq5GbmHKczED7bd2MZJP
17376	payment	1397	1397	1678	1	1	8031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKd7SWu5Ywzm5qEfXeXcXCatWT7KfidjY1T6Fr9pUWA2gS3gmM
17377	payment	1726	1726	1874	1	1	7029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSh7PeAQQkXKuAgVBds3P4bG5yUMLpppfNHRGzrWduQKuHZ5uK
17378	payment	1726	1726	1874	1	1	7030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaBNjsiSkyk17gSsaAEJ6F3V8BUyvL1wEL75k6BP3eiG2Zmhz
17379	payment	1726	1726	1874	1	1	7031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRmKTEbwMQxEhNyQqW6JL4hd8zDyjHK3VctxDtyfrE2YVqq9c
17388	payment	1397	1397	1678	1	1	8034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6rYeSdRGq1yAgjwZbDeU5GhrGwfL91gQQNgNauEJqe7Q7FR2
17419	payment	1397	1397	1678	1	1	8042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZakYg9kHEaqeARaiE9PF7sRqWCn3Qbo414Dk6NNbBEy6RWS9M2
17420	payment	1397	1397	1678	1	1	8043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB44UUA92eqSDZ8kNb9grUKmKkRu9cGV94YG1eySz4UeMArivz
17421	payment	1726	1726	1874	1	1	7060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJABcDrfqf6qv8zBfx1RCc7rjyJ32ugpUBtR6MnWAvKLqf9Z1u
17422	payment	1726	1726	1874	1	1	7061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQyfGReE3SZ7aVnBJL6mPqTm3WYTh4WwuG3rRDrXLWdJL9jQv
17423	payment	1726	1726	1874	1	1	7062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNuvR3SxLRaUBneTPBVVkbQKnt7bBL2LGzzPGU8QYBcMQJVeK
17424	payment	1726	1726	1874	1	1	7063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUB83DGaP5DXEvyauqdVHpVJFmj2RxxqgGgfp93q85red2VAq
17448	payment	1726	1726	1874	1	1	7083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUWeEfsnm7nUTHvBVGKQjWxWutbYqTi2EMehW6xx5BWZSkDHF
17449	payment	1726	1726	1874	1	1	7084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZpJP3oXfncck5Je8cVSZYokZTw3Yz3UWwqSxj7bpZVGGtqjP
17456	payment	1397	1397	1678	1	1	8050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rMygVYppPSnqsPyfFC2Peox6jUHAhZdh18RuDonZ2MQimbFY
17457	payment	1726	1726	1874	1	1	7089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBHiVMBXtwua6Y39PpeGSMVWhN8qJXTyZQ63NsQd5cDuSBqVi
17458	payment	1726	1726	1874	1	1	7090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LtnbSmZH1h9pL5khzrAnoezpy8DBBp2XzoCSzeWRvxsDV2kg
17459	payment	1726	1726	1874	1	1	7091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMUL9nR8byjg1wfevMDfamRaeeqsrHKwbDE8VDHxqUd7ZED6q
17487	payment	1397	1397	1678	1	1	8058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZERdERbjXEr2dazW9knSgQS5BGzWsrjaeFcvHuoTwjerhM366
17488	payment	1397	1397	1678	1	1	8059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBBR9BgwbDshY99HUGyRHaJhEdRkfJC3iGFwZwxZgpGrgbZXT
17489	payment	1726	1726	1874	1	1	7112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUyLHkBgPHtb1L58dqVa2dHudTBwoXjNBQ7fBxJV1aYnuGSbW
17490	payment	1726	1726	1874	1	1	7113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2asHrAFHWhRvUvZ443EYd57mTfrXvtcuKDYyi3w328ULAzW1
17491	payment	1726	1726	1874	1	1	7114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEpAPp2jnGSEdg4mkz8dSBmmCSPu9R4RxiEaMRZNVY563jV3E
17492	payment	1726	1726	1874	1	1	7115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRtje8iJN6LxSKJER9df8ccsUprYGkorJRjfHZp9YPf43FGaX
17493	payment	1726	1726	1874	1	1	7116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVxCJxgJoxzKFoEPpnyY4kKB1X2W46CTun2Zg6SBGkXtTFYc2p
17494	payment	1726	1726	1874	1	1	7117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARZyzuaVTVimT59q2tj9KT4tyJCsj2QGmNQpc5WE21u91gMLD
17506	payment	1397	1397	1678	1	1	8063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzv3syNoHSDWwxqdF7zSYyWJHJk1wXju5FFtse2LzLvQn9MYW
17507	payment	1397	1397	1678	1	1	8064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48kquwqJjXqNYKNQzLkpTFNHWNEo8DM9EWSSfcVK6QBVayhPJ
17355	payment	1726	1726	1874	1	1	7014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKURzHjMahostgfTU2384Dif4Lc7Uj4GF437A2sk2m6YpP9wn
17356	payment	1726	1726	1874	1	1	7015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31z3eC6roAjQ7V8Z2Hbw8R8qaa2Vx1qCkUbJNT9Eurv2prynR
17357	payment	1726	1726	1874	1	1	7016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVQvo4AcBz3x7Tbv32ZSu6xqR1nPTNZxUfccC6YUPx2HPstCK
17358	payment	1726	1726	1874	1	1	7017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzn3YHG2JMwps5YLJ96VZbRyfBj4tLttT8tzd8iRs1RACqwtLA
17362	payment	1397	1397	1678	1	1	8026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RVgj18YnGch3tS7fhxM2K1fh2KApFW6Lzb3QHnSdv3GphDq8
17363	payment	1726	1726	1874	1	1	7020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwGDKbTwKaYuPjQAEJ1KJrYZUX81ApB3MAf2VfDbvDmYQFbcad
17364	payment	1726	1726	1874	1	1	7021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhPQw2uaqvVQjYyDonQHuP1WN1CHaGHtPGEJVBkykw4Ziz6xT
17405	payment	1397	1397	1678	1	1	8038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxteddrUZqwLBqxKEu7mxeE6hDR83Q5dvDqmAovJ5q3xQ7YRLM
17406	payment	1397	1397	1678	1	1	8039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxg6BWKgQ2QdWnDTjLBEw8UKBsep8Z15gxYm8MeenCswJ9wbYy
17407	payment	1726	1726	1874	1	1	7050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczsyC4TVLUmy3ZNu5bBSMSpccbSDWa2Tsv3giUaUfdZcKSk6b
17408	payment	1726	1726	1874	1	1	7051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGdzQd1TC4VVbjcqwoa4yPmKWoVEpJqeLfDY4JPyBVUS1Lv7Y
17409	payment	1726	1726	1874	1	1	7052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgF7tpo53b59wAqmy6zYzq1i8f6yofTPhbUn4BKT7XAa7EALVF
17410	payment	1726	1726	1874	1	1	7053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtS5WuF83ioBWspWsS7wimh42Y115z5evynPgbTP7T3JC5HXZg
17411	payment	1726	1726	1874	1	1	7054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYTz4yL3n7eukZUq1y6M7aTJEowaUe9dWwoA8ucJ8Zhdutanz
17433	payment	1397	1397	1678	1	1	8046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXrKt23NKgJyuCQ8nudB8FN3ZXbg8X4vZyzDLSzbs9chXu9xQb
17434	payment	1726	1726	1874	1	1	7070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEwevxrPJFmLe8muY8bAh1S8n3naUsiYjHxJu76uYqPK98cvn
17435	payment	1726	1726	1874	1	1	7071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrWcwNyPbEYf51oy3kw3yogHjQUc6Zu8reM9GnbneTd6PKURQ
17436	payment	1397	1397	1678	1	1	8047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47pixzwQi5z41Rv8ptHVdFdcWNW1J1PAufLqqeo1zJNCvQvAF
17437	payment	1726	1726	1874	1	1	7072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2mbFsXzTao9nK5SFxB6ZNMahaGMfXqe4LwHnhcidUAQsiqzb
17438	payment	1726	1726	1874	1	1	7073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu16kyBUpP2sxxxWdqeFRU6WCBkTNYN6kTvLNVkqCSr6zpSrMB
17442	payment	1726	1726	1874	1	1	7077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkGzx8GkVTieqtoHjoZ9F9VFTQU4HVAQJwbJXZeFp1PwULYQq
17443	payment	1726	1726	1874	1	1	7078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjrSJZ85CKbyViPPxM1FB21cTJGGR9KTkWNtRFXVmDwhqMDVU
17444	payment	1726	1726	1874	1	1	7079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6JVkXH2w4gkU44NgvJfLAPf72tdijZ7tJogSUAre1tNWhr5n
17445	payment	1726	1726	1874	1	1	7080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4FRXrsVRYyVvafpuSDPCgggS736huabdZZzzfhRh7rmyDCba
17446	payment	1726	1726	1874	1	1	7081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC79BK8FvfUDQD6xWUM7NKtRUwDzqcpMjZGo2J7sKiMKoQEoz
17447	payment	1726	1726	1874	1	1	7082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSMwr2yj44AjyHEr2U4fYiBBMRfufDhsEaJdah76Sy2tG4EuE
17472	payment	1397	1397	1678	1	1	8054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGBWP7JQAGgU4698XMhPPv67H1YDyb2MsCxvoUaedPgvmc76r
17473	payment	1397	1397	1678	1	1	8055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpk3BcZNXKkWLiUDnRfWTyswdBzRVcVgeYFG8roHyv85DAtS6u
17474	payment	1726	1726	1874	1	1	7101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVWcoEBXsdAtLpy9gjn36G96HtpzScwnqYUACA3yffhbpJyYn
17475	payment	1726	1726	1874	1	1	7102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjRjsqoXsY3DykRp3SMZAzLpBMtNS3wKwLkDP9bX9EvpAn4XB
17476	payment	1726	1726	1874	1	1	7103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLJ7XUNnKme4zHKLWQJzxG76aokpQkThb4AkcRhNtfejDuvsP
17477	payment	1726	1726	1874	1	1	7104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodAxxFaGUtGMnzRooCdAXHh85fsjFGfnMSH9VgG7H2AdCL7Yf
17478	payment	1726	1726	1874	1	1	7105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4iPFfSTpi3a9mRmWuD9PVp2hUjgPaM7PeR2CY9rHwB4DWW9w
17502	payment	1397	1397	1678	1	1	8062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGVjyXz76ikSZvPZK3kuECRQjFwnVCzZ6uQ2fLSaqjoaC4zY2
17529	payment	1397	1397	1678	1	1	8069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCSLeRVSTHqUhnaame9cDqMwN1vdMvD2S4paNrNUuRZGNNq3ax
17530	payment	1397	1397	1678	1	1	8070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68uqw9qc6C8KCCAX5Gw3LVKjX8MsvEnzd2ftbGhUasfDCxwST
17531	payment	1397	1397	1678	1	1	8071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEuLrYh3PRQhj5DVdjdMivAfKPTBEu3DXraCJQnbiFhrj47L2
17532	payment	1726	1726	1874	1	1	7143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6S9qP5ACaEskeJ99notUMofWzy5D3t4nnPPzjhYSp6j6WjwHf
17398	payment	1726	1726	1874	1	1	7045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8B6z5LagZRLvVJahZtd7jEL9NpxPcLFcyEzam8VoXAp3Xosa
17399	payment	1726	1726	1874	1	1	7046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AtAtdxYgbhyiC4QNXurRnXfkuRUCiW6bdbURoNZPA89w4iVX
17425	payment	1397	1397	1678	1	1	8044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqc2dzY4TtPddmpj6zmpAqMvSQ16PsRwrKPoxXJMSzPKqkWyMm
17426	payment	1726	1726	1874	1	1	7064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctnTkTcKU4DbMSDqGQimMPSAaVyTMudr69ZiEL2koRHyXXV9P
17427	payment	1726	1726	1874	1	1	7065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9WUgHEn8UJy8bgbtyG22Utkgi38iPguewcmdJa7oG87jWMch
17428	payment	1726	1726	1874	1	1	7066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSvXGtk5hH4YATScH4DJXPveTXEn48tv2QSq66byufHR2XpC1
17453	payment	1397	1397	1678	1	1	8049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MdpiNrvECtaLWWFJFUpBBgm716Ys6zVW7cKm1ydgQvmFMVMn
17454	payment	1726	1726	1874	1	1	7087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazMsZjmESKEPBNyLsnDyKph6nc8nfGF1QS5hpyhoiocdkBMaf
17455	payment	1726	1726	1874	1	1	7088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeBFwGb4CCRLL2anMCefoDQk9cSZS4EyMXk8qUes8P9U7jrgf
17468	payment	1397	1397	1678	1	1	8053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuR7mRHozoTeQbqJ13M66S1ZiQK93N7SHbBZ6ESh9yfCmHu6Ke
17469	payment	1726	1726	1874	1	1	7098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1YiRGe2BDvHqEtJQoznyFfHw9kz7qAvTD5sLdz3C4EXeXePi
17470	payment	1726	1726	1874	1	1	7099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcx4HpGrA4ukdazPnTLSU7HPEoGqsdxd31XujFRGRHHEnPCjDe
17471	payment	1726	1726	1874	1	1	7100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61SdCKnGm7e1iUp6J7GGye8uRgjudki3U2YEXtYmgzzNqwkJe
17495	payment	1397	1397	1678	1	1	8060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcecE93oq8NDa7QC9hu8A2MDf3VRHTgQSDSb8y55XS4KaXeExz
17496	payment	1726	1726	1874	1	1	7118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm61brKFYBPzSEx5qLVrmzJovx8bEkT8gMcyUomg6yzp77XEn5
17497	payment	1726	1726	1874	1	1	7119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq7zxdx4tpXjTMGN5njFvUDsY6923vYt4ibtRAzCnPJZ7HSfe
17498	payment	1726	1726	1874	1	1	7120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJcFceoC2wSkPWhFo3ZySMwVCnyQHPQcvRJCr2F79HXqZXU2X
17499	payment	1397	1397	1678	1	1	8061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSFy39dAqGQ28gtH2b25rEo4CV9sVEhsz5kTsWCxLDnnECfL2
17500	payment	1726	1726	1874	1	1	7121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Dv5kjLXseZnUwGoDZzKRfir74CbrPVLPQCeJDEeGb7ykxDiY
17501	payment	1726	1726	1874	1	1	7122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vDTQRkHHtCPCDLM3p9fueat2BbzKioCBvhBZJ4nbpdHihR4J
17554	payment	1397	1397	1678	1	1	8079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNKFnXLo9EBc7GZKZqSieAjfp9MKABVcRmGYieH5Ym3FHQVee
17555	payment	1726	1726	1874	1	1	7158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRduGyuGLQvmQSFwz7LrbWLnaatQHBVQ3Gesw5BTaHqiKbzZ48
17556	payment	1726	1726	1874	1	1	7159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5qMKKcCE8GBHxZWHAa1caQ9eKgjrXhyv2key4h477rh7oP21
17557	payment	1726	1726	1874	1	1	7160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHumGbK3Vo32n5SsUXfgqxeHkaKiQEuXXH5mTz62CSfro9vnn4
17558	payment	1726	1726	1874	1	1	7161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5rBUidjduskztpjv5G2HihCoQeMj8coSZotJ8SfUfm2Hd5Sz
17559	payment	1726	1726	1874	1	1	7162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xU6RCVYgvrBhw8RgHpHf7oNNUJhZivZrbwLf1x7xbKHkRszC
17560	payment	1726	1726	1874	1	1	7163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXxAg14Y2TwYaK637YzZm2L6r6jBtSgKpWFLMPtiEWb9eEnLn
17561	payment	1726	1726	1874	1	1	7164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsndtabw5tAxdQu8gCodGC3QCKo6XsdGcJR2Umq8RWNqALAD1
17562	payment	1726	1726	1874	1	1	7165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrM8zswkwagsBSRy7uiZSRRxZnnm6g2zwbSsJv6kXJofJhszkX
17563	payment	1726	1726	1874	1	1	7166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2VR3RvoaXidtbM5AgN1d1rpGQbqEmGrahmD6hzEuuwFydXkCn
17564	payment	1726	1726	1874	1	1	7167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBA4WWsSNZpeUnJJJRK8YeGj4H3LoBR9LR6gf2eMw8Vf3d8Cbs
17565	payment	1726	1726	1874	1	1	7168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDZ1r4tdpvajQt7MCrSRSM23eZ2g5vChX2YnVvnzeCbPJsrFD
17566	payment	1726	1726	1874	1	1	7169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwM4AeGvZXUozTG6vEgu6UFcSefZiHyU4ex87YQZZNEH8UnB5
17567	payment	1726	1726	1874	1	1	7170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBCwptrXLxuZYqZD92yywNsXpNeUqigNjQhubgyrcnnFxa7zMz
17568	payment	1726	1726	1874	1	1	7171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmD3YeqatG2ZUXwRKvo8rRrFpmahsZBU1kfhje92TmxsUG8Z2B
17569	payment	1726	1726	1874	1	1	7172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysBkBExeZYo387gbTHxWieNQ8ZsmBa1z1qDg9juFJJUKgt9JK
17579	payment	1726	1726	1874	1	1	7178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3rMt45HmyVn77AfusyNX6tRBWd7EV5ioFWuRWaxWy3xvUxZwU
17580	payment	1726	1726	1874	1	1	7179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Hvnt5Lh89hHX1kACUL2u8nU3Ax5Cy6JHgBNXx3DVRGcXzge9
17400	delegation	141	141	1483	1	1	0	\N	100000000	\N	E4Ys5NH37gKfEaPToDdfSskg5eXUoQi3D6xtbBfwy1kYskjE3zUHT	CkpZSUoRUHUrj9m4GvNctzDCrveANm9GvDtZR3iDi8B9gihY2Buqs
17401	payment	1397	1397	1678	1	1	8037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPaBWcLnSdaJri9NXacctcGJRhNjWDuyczJEVdPiKS729A2oJ
17402	payment	1726	1726	1874	1	1	7047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTVfYAMYHDUGYYJv4gtiFnLSnrJ7DXvam5udFAnXHZ7bafunF
17403	payment	1726	1726	1874	1	1	7048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCQAuJkCmmuzwe4c2khQ3ZEhikyWcAdHf4PpHtMv23bHwhMwV
17404	payment	1726	1726	1874	1	1	7049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4H5AQEq9eXQGUujE4MWRc4ERfk7S6qptbS85zWjA6A7avCnr8
17412	payment	1397	1397	1678	1	1	8040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusNg44VRixgppuidhzfS8E6BwxgT4omrDyLYVB2gcx4P7xQhm
17413	payment	1726	1726	1874	1	1	7055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1KH66C7FrceU6Pyv934nUPUwcWoNYocnagJz6qHYfq1XPh7pH
17414	payment	1726	1726	1874	1	1	7056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRmTnidgNuck5LVuWVqBXi3ahK8nZAXzBGQtRZRCGaWAXSwPS
17415	payment	1397	1397	1678	1	1	8041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqFuzhjRePDo9jzRr2uGv7ZodYJEsCEBHGuQVrFaH4Gd7tWab
17416	payment	1726	1726	1874	1	1	7057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe8s6t2iEqEbemxSxcYqhjsZyb6kDLNzgTZ3G6B7w5wh9WqYU
17417	payment	1726	1726	1874	1	1	7058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pFEZPr4tMGcVnyxwi5oV3YKG6MK6s6XjCC6CFeuR6XLuB7tc
17418	payment	1726	1726	1874	1	1	7059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdfMWeuCXgnoAwHTJENUzbFHuWT9JMNi68S34cAfkejCqEGs6
17429	payment	1397	1397	1678	1	1	8045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKxYJkJEYcK6EbAMxGvsKfaC5FQ7CSpNGswmJ9QdfSwjvVU61
17430	payment	1726	1726	1874	1	1	7067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixf5JQg66ASeEQScaDSKCmjRLx7Hm6gJp7B24d6pQXtxvcaT2
17431	payment	1726	1726	1874	1	1	7068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybiSFbyc9KowaeAcwSkSFVqj27PMTx8snjPk3gfz5rJN2f1vb
17432	payment	1726	1726	1874	1	1	7069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4FbRTuykTAHxcKftjx4LKWaPLB63uTxooefnF2oUmT3ivyEK
17439	payment	1726	1726	1874	1	1	7074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVqLSEjsf9jLm7jPFWaYcAsEoSrKYT3K4B8EPtKgWpjDG8FFa
17440	payment	1726	1726	1874	1	1	7075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHTp9sikNotgcrA6wiAWM3XWCGiXzJzajCWHrD5w4WhXCei9o
17441	payment	1726	1726	1874	1	1	7076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEP2mu1bikrDokeQ7hbcRPYEjUTPnnE2SpZdey9ZusZBoDSY1z
17450	payment	1397	1397	1678	1	1	8048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAL48H8dVMwU8guaQjgBSWE2fBEopEaq4XFWQfzUN6QxjM7SvK
17451	payment	1726	1726	1874	1	1	7085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT7nRJ3rqcGMhbFLn6PXSaey5A8n6nL7AKvghVskx5WHv4w9k
17452	payment	1726	1726	1874	1	1	7086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzT3ZoEVzgmgA9SPdpHq5YrgPmg5okGoPSyvPWW13mzEbziust
17460	payment	1397	1397	1678	1	1	8051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4BnbFsHvumqgCJaADZ2PL8TtnmGtXSxyEuMYuqwi2kVoqLE1
17461	payment	1397	1397	1678	1	1	8052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRLJ3hyDQUgEK6mNiAMLrhvBMLgGgEjXZF6nkwXwMCoLWxDHk
17462	payment	1726	1726	1874	1	1	7092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDejkJsJoXxH6T2XywWBLcWcM3UBPby3vvoH8eYxkHLFgBaauo
17463	payment	1726	1726	1874	1	1	7093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnhcEEL5Nf1aw1wsqGyiSiytYEwPAvtqYg8ivvn9vsHL2r4AU
17464	payment	1726	1726	1874	1	1	7094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi8fkvaXCe6dtVvyKyYJhJXUSziJY5oMYyQ63cF8ceTjh3NxKe
17465	payment	1726	1726	1874	1	1	7095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3HKdcbHFqQ8NLSiuyxQdCDoS9WiekCEn7i8VBERuuC9yXdZNd
17466	payment	1726	1726	1874	1	1	7096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwSfoRwmWVNAj6HZyFRr2vLHFo6sjR4jZagXucwmXtJ3JAn9Y
17467	payment	1726	1726	1874	1	1	7097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSbbMkVndFEDV2wSV1nQwohFkWuNQFTocaq4ufM2KfdLudpTp
17479	payment	1397	1397	1678	1	1	8056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZboujLJtYRaf8zAn37MQgEVFUKLL7HDhyivnhnW3wngrCmu4J
17480	payment	1726	1726	1874	1	1	7106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7UrSAHRbZCVvUMWf3dcniwy5X8gbMjAUQXSVshQYAXSqiUMj
17481	payment	1726	1726	1874	1	1	7107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYedtGrimjBqn2nFNtpgvUJf1iUtHPRFreMJnKroNzQUBeqCN7W
17482	payment	1726	1726	1874	1	1	7108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKodVWvL591FFY4RWEFxW1BXYhtZyXMW9B9Ct6yEk1sWbSwC4
17483	payment	1397	1397	1678	1	1	8057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Yhz1deQnwfacRjALZ4He3xbVEKmfdG2eHgC5rkW2Ab1N75Hv
17484	payment	1726	1726	1874	1	1	7109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT74ntXrY13vw9NaZt1PDSYrjgB1tsTTp9Cx42NRffRBiWB2Q3
17485	payment	1726	1726	1874	1	1	7110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuPGbF2dwF4VQ9ekb8bLHNxao7HCU6eDzxKHTq6RhULZaHPfG9
17486	payment	1726	1726	1874	1	1	7111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hFPx41awLdWyn17UZdHnkjzrURZSYGUY24KyGboN3CkQ2Q5j
17503	payment	1726	1726	1874	1	1	7123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9odTZMT5zyFgDHtMbxstuDHwi6MLfka8ZXLPrJyfZbuBfLvX
17504	payment	1726	1726	1874	1	1	7124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ddzco5HCDUUp4vWZHHjQ1PMkCnf2r9sy7SMXzKsvy3CjbZc5
17505	payment	1726	1726	1874	1	1	7125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRc9zXYimrPbJfbz6Z3Wqy7tvEBuEqoiPVuAMaGtFuwQ6QipmD
17521	payment	1397	1397	1678	1	1	8067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQA5CuzNFbPeUPkbLQRAB52LuK2Dt9NzNSbJutn8CGa2GFhpu
17522	payment	1397	1397	1678	1	1	8068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvhQTFBWzSuxhww6hnHPmCutGtDJSoRw5HwvpzQLp7qgMLCXk
17523	payment	1726	1726	1874	1	1	7137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvt8BQHVcZMjojwoG9ykGzSb9FstGUWeFZBA6i9LrtRWDUaqq5
17524	payment	1726	1726	1874	1	1	7138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9L9x1nVtpvijUQhoTh8By9xen177tTeFPkCBdtEWsM1tPHR5d
17525	payment	1726	1726	1874	1	1	7139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzk3saiEp4avqCc1EHeCtD2FsF4r1v2AGLPBxwNWMK9soSnFME
17526	payment	1726	1726	1874	1	1	7140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7bc1uvuXXXyM8Pp4ctoqhxSP1mXBXkP1S51PSidZLZy6FemA
17527	payment	1726	1726	1874	1	1	7141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbiQwWkGfQVmkMyXZs8Ffo88S2ycF9qEw75YPa5zxge1wwA9XD
17528	payment	1726	1726	1874	1	1	7142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdefuxYFk2WBLyaJ9W8fnimo9UY9SWRERSgyxfBkVqjFzcsex
17541	payment	1397	1397	1678	1	1	8072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJWdTAVVy34CbxU8xNcDp99wsUVVXUkR5jtNqb4Z9JZRHu1XQs
17542	payment	1726	1726	1874	1	1	7152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2kogJNNWPxuJLSAVtgrv4tMw8WQKp47bwdwtkRHPSXtymmFe
17543	payment	1726	1726	1874	1	1	7153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC43n1LZ13dGnicL1uX1jBpqAK5Cjbc7KB6SpmVxgroAykJED6
17544	payment	1726	1726	1874	1	1	7154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35fVT79U3ob952BeGsTRomCw3wugLz6yJvcpKpbKRwq3asybZ
17545	payment	1397	1397	1678	1	1	8073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rC4WFVbKL9V2FRJ6aVWmCGWcMVPAVhPNUHmHsMPxMnQ5txtM
17549	payment	1397	1397	1678	1	1	8074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBahECNXgVoVk61svhsYqeXFq2nTuU7zV3CYHeFGNwnYNFjD9M
17550	payment	1397	1397	1678	1	1	8075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HwoCDdgkPWpjBV67QgR5iXeofv3mjMfvDyeEgj3M3HpTcyEV
17551	payment	1397	1397	1678	1	1	8076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wN4hWCwKZt2tX9e2w8vLzcz3mAtjDdmkfVAYXrDvnfjshb86
17552	payment	1397	1397	1678	1	1	8077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWcB6Q4B4KcDHuV1oiD1VeXY2pZHdzU2XTFAHtqwpour47nSY
17553	payment	1397	1397	1678	1	1	8078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3rjnSkC3BshNjCUx2Pp9UAekZto6eYAJ1RAY2RZE9bZjDmUr
17570	payment	1397	1397	1678	1	1	8080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKLZ47vQ51ukpgghcgifiATTrZyFgiMNr1sMfMWNydXRL5gzF
17571	payment	1726	1726	1874	1	1	7173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Dd9xWM697wfa1FeBAK1da9WgvNKBTccjpD2okYiTEMCRYQWL
17572	payment	1726	1726	1874	1	1	7174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4URR8QkrBHin7w3WhgziijWpoc1KowNUwLGYjwPNYHYAhHJ4o
17573	payment	1726	1726	1874	1	1	7175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBxFKHyjKtgWjpcxDDiaeQP8ApknkrGzdABnbUPpPE1oqPDjT
17588	payment	1397	1397	1678	1	1	8085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUo8H9RBCiWNp7ZRgVje1Kbqp2L3DUZGMm9CDWwyJT87zvmfF
17589	payment	1397	1397	1678	1	1	8086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuuKsXUK9wR5z2XgzU57AsSsAjvaW5c6rp6RbqqGGgxUEE5Ut
17590	payment	1397	1397	1678	1	1	8087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1P7L7KWGHnTVaXrasu4JdYiyrF3XgGupxvzqFtgNHZGibQAM
17591	payment	1397	1397	1678	1	1	8088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXSvrUTzNbEw6zThiCm3YVRWWruk4YhesWSogNgXfTy1NNR9R
17592	payment	1726	1726	1874	1	1	7186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXygLgX2d8oVeh3sWthn6JvKShpKwEaFVT5ZwKNFReZSGYMrxF
17593	payment	1726	1726	1874	1	1	7187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevPrxbvRBtjPreknbPQ6YmPejj4JPip2FLciK7WnLGEdzMwJX
17594	payment	1726	1726	1874	1	1	7188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ48WKzUvHYqp1SQJUnioJzenaMgDVHk5UWaL2YaRV3dtYukz
17595	payment	1726	1726	1874	1	1	7189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWcifGnAn5bnH5e99JEetXjRg2hJTE5M9ZLwkUEvZyAWHyDwu
17596	payment	1726	1726	1874	1	1	7190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfnEyeJ9nLNh8JFgxPxmg96fWSZf4gKKi4qV7aSXvPVKrT6wV
17597	payment	1726	1726	1874	1	1	7191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hC6624xXsZ79eHdvfyizCaBc4RFVpcNsqXvbAa7ky5WLd1tT
17598	payment	1726	1726	1874	1	1	7192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5fWQ53kNziNuSY8pXC6qiPTGTF7HYaFN5yPm5NQ4Pgjuon5e
17599	payment	1726	1726	1874	1	1	7193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc19XJrvNtVxbVxnkDGBSEeFtcekhDz3Y1XHXdqLXSVLeHfJLD
17600	payment	1726	1726	1874	1	1	7194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjkXhpracXbnbC4NLixungNgY9PVhpnKFtTAFrGEcF6cCWNJvt
17508	payment	1397	1397	1678	1	1	8065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9vZjP98d74XJ5jyDbNewxMEhVsenefjMTAu8nYVihrh1wzyV
17509	payment	1397	1397	1678	1	1	8066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7Eib4qWBHa8b8A4NJdkpsTSWroyTpt2KDxotbgP7F7AfLkiP
17510	payment	1726	1726	1874	1	1	7126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbAHqbAu75JtkqiRRUTDnCmkQxAYytoui7k97stxeJKYxyHpz
17511	payment	1726	1726	1874	1	1	7127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkJ9uYh7QmFN7vnEKGwiuFjLKyAEXbNT1hM9CK1uAFHm5vSgt
17512	payment	1726	1726	1874	1	1	7128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBSNpmn5fwUshpNNLe6h9m5s6BimV1uHudGssQ5H1vuk4omY8
17513	payment	1726	1726	1874	1	1	7129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqkBeLVfrrrUi1WebxYBaiSTfP8uHuBWHLR7KMtbssbjCKuAB
17514	payment	1726	1726	1874	1	1	7130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmjKNsX7dAUjXVTziWGavvvFxZQaUTgEEzvqo3ezBLjhaaisL
17515	payment	1726	1726	1874	1	1	7131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMY19AiuJNqxqhf4X3Wd5s7eYiun8wrabnvzqA1VgZv3aVDRh
17516	payment	1726	1726	1874	1	1	7132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjfNhifqMhkSX1QeCL52LH6HRpk9VtLBE2KEXeDm1zaPTNd5k
17517	payment	1726	1726	1874	1	1	7133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXohwWBQ2gfWG8f4EkpCzM8og2vdYPo6doGXUWfsUUDrg57PV
17518	payment	1726	1726	1874	1	1	7134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisqH8MHBZUSjcpX6F5UYyPbqxD75StbaVTRNCZQLjLUHcr2Ek
17519	payment	1726	1726	1874	1	1	7135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hvgdeqsCf8qtxZp3Jgd7rxA2QwWxH1c2saXya2UJADxA7MT4
17520	payment	1726	1726	1874	1	1	7136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp72YQrBykhU5T4ToKRzP9nof4ADXAGvqeD6ABYmgXAnmPW91t
17546	payment	1726	1726	1874	1	1	7155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzewBdUddJqVMqDJwfr5dmQmMcSjXqbFNmTC6XbvX1ZyBQh8R
17547	payment	1726	1726	1874	1	1	7156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ72pknb3AscwzdsF6CYrSySuZm3ruPquujQe7nPfNChnET2Ddh
17548	payment	1726	1726	1874	1	1	7157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZJZcwgqoygkNcEjm1bFb8EjstQzUDVu7s9BmjsvLj2RPwTKw
17577	payment	1397	1397	1678	1	1	8082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhiCyRLBuWDHUofLE8vKiRjANvG7EbdwYBk9YUrwMcmX8twe8
17578	payment	1397	1397	1678	1	1	8083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37bh48VBVq1jVbiZaKcPxESqB8fTskPEm9aFHJaPyy393Jxpp
17604	payment	1397	1397	1678	1	1	8089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31EUUTPtPowUdiAZDyBJ6JREXVMniPTvkMSqNPoBy2Mh64Gy3
17605	payment	1397	1397	1678	1	1	8090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMqJkUwNgKXBtRB779hmoagcCXjBG4ZWEKcBdEY7aiE2W3zDt
17606	payment	1726	1726	1874	1	1	7198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDTRAVchk3YeyAyi6yp6SqAphJRSZ2z5Dt7t88QqCcmWjXB67
17607	payment	1726	1726	1874	1	1	7199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvv8hkZMxW6Wd9KHPrxNvvW4jUrxPFjYbqfS7TNDRpmPwDci1g
17608	payment	1726	1726	1874	1	1	7200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXk1itt7GieMaUHkrioKHKz4m3XnqiH6CLsjFNNLwQnnLJyM1
17609	payment	1726	1726	1874	1	1	7201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5YNuZ9hiLD5FxDwuB7J5yU1Ms3PgGSMCRGaxsNHygc4jjXhB
17610	payment	1726	1726	1874	1	1	7202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqG9nAWcefME5TowevRMUWN5FdSPc1aWz4by8sE3x6RsbQC3kw
17611	payment	1726	1726	1874	1	1	7203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMy5JmfsHFU9zAEPw2Wdpz2DxwDXgq5edUMCMHUeBQR93v3LX
17617	payment	1397	1397	1678	1	1	8093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw47j5Ly6gtuFogj2JdcKikZZuTJ2jRPA4bztGw9ZLuHs8Duwk
17639	payment	1397	1397	1678	1	1	8099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkRWBEx3GNrVyg9x1aGnkNnKvpx3pXpAPzoQswEmcn4XNEX7L
17640	payment	1726	1726	1874	1	1	7222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyucdtbmu4AsPCoiE98wNP8xtRWvjABg26xfwZ1jpS5oASpPMe
17641	payment	1726	1726	1874	1	1	7223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWiQz5LknQrrctw1hbHnN1NdouH87PvpJG51Q9EG3e3SQ1oN9
17660	payment	1397	1397	1678	1	1	8107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwJUeJucrWbntqQxLksTkmaYRknLixkmMmM3C79b1tkneua92
17661	payment	1726	1726	1874	1	1	7235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZ5JZJ9MJvESrArEE8MyBEKuRHzP7oWdWAKk8DDwSxQgo7GDH
17668	payment	1397	1397	1678	1	1	8111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL1nHJxpCR6tpuUWoKmUtXiLoeTiMuRzDqbfAAButETkrGwhd7
17669	payment	1397	1397	1678	1	1	8112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9auT9p5v6mDvV5xVsCxFoKChaiL2FTSTxnrj5w8xuVQPGi1M
17670	payment	1726	1726	1874	1	1	7239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89usnShgyqC6ZVedVsmtSkH2R5nZnSYi1ERAkC89cK2D33EDP
17671	payment	1726	1726	1874	1	1	7240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrBrvz52RDSJAEG3CQtsQy8maR1R5o2AkaWubQ4XrHaA1ALyG
17681	payment	1397	1397	1678	1	1	8116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQUeMWiRWZqZCyp3TXC99HWaqN8wmvMrWisZSVn5ALunnNyfF
17682	payment	1397	1397	1678	1	1	8117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2duxVzTV4tMr3SsGgvfzQjGT6ZE3SvS2D5cLQQLnsqyth2z6s
17533	payment	1726	1726	1874	1	1	7144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmaKx4itAxgYMnCJbGxfSN9ksZRkmw3THiXgWQkf3P4W8LMD5
17534	payment	1726	1726	1874	1	1	7145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSAXoePjDot2Qk98JGcr1QMt44SeuL87tecbhE96avZaswZna
17535	payment	1726	1726	1874	1	1	7146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdgtUR2nWfmzAFAS9jetMBLQkohYF3yG3pMkWFKVucwJ5h8MR
17536	payment	1726	1726	1874	1	1	7147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSa5BiABa7J8B5AHcXaLdJuvPg8ZdkkzuAGzcGo5Sp9UxZ2VYb
17537	payment	1726	1726	1874	1	1	7148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjv9WJvViVUrwjceph5jG7TtcfNQypBs47M5jYrWcN1SYVLk4
17538	payment	1726	1726	1874	1	1	7149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6XADt6YsW8h1Ek2rZT2nYjqc6CotRwPuymTunub3VNy2S3hh
17539	payment	1726	1726	1874	1	1	7150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNB6saUHG6xMftaFvXqRj73ynCG3MysEdfh6E5sieYeUZYUaw
17540	payment	1726	1726	1874	1	1	7151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wURVUnF3m66K35WgVWtVyqPfPDNVjXRTwzsaBENurQQPcvTP
17574	payment	1397	1397	1678	1	1	8081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZ8BM1SvNxmbLW23gXCEDLpJ4MaLgJWBaUMHPsoXGg5RHueXR
17575	payment	1726	1726	1874	1	1	7176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9vACZT88kb47QuCA3QhtVDPXPhfWKm2kwmemdeRwtHSfkeGa
17576	payment	1726	1726	1874	1	1	7177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMQkeK9PrWNAvtNaJyrYpNyDfFx6ZRK5S8QDvQCA31ugGrype
17585	payment	1726	1726	1874	1	1	7183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYAmHEJH84t3aEbeQ5KUumyQ9hFZYKRF4W7BrgpFp4tMNvuqd
17586	payment	1726	1726	1874	1	1	7184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcuc5VE1zwVzz1vDcpxsvsW4cTsoXhjofEpYuQnZBXEa8uotU
17587	payment	1726	1726	1874	1	1	7185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd93kZrPp5f1kADB2d92icb6KvRjFc7Kgs6hhNqhPvH84oktFp
17618	payment	1726	1726	1874	1	1	7207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJDN4vvRGPXQQVUfYYjHahBPAcSD2Dnxkazh3BVCFJwY2BbdN
17619	payment	1726	1726	1874	1	1	7208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qSaW9joSBqHjw3FMqT75j9qQ9d65oCfnyDw4HtdwcFomG1a5
17620	payment	1726	1726	1874	1	1	7209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEbzZwbNBGAZdoNHWVCayfiMmHoTPBKzAxJ2BLbgwG3wNndtH
17621	payment	1726	1726	1874	1	1	7210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi85RUN1njmdEfD9a2np8wAH6unJFxChdhNrCSSkbedUhifnjm
17622	payment	1726	1726	1874	1	1	7211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGg59yPnAq1BUXWyz6QmVvDZdekKp9bJRjBDWRtq2fDhwJD92
17623	payment	1726	1726	1874	1	1	7212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtofm294jLnjFg4zmkaZgocikwmeNmwNEvLHwvqz1kkbaoQ55B
17624	payment	1397	1397	1678	1	1	8094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMZUvVisGzEsaV8aoiegu8zo592SoJ4atccHtd4JbZdifv2Kc
17625	payment	1397	1397	1678	1	1	8095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yneqjs4x8iPD9iKpeofKZ9SZhDDXR6YeRrqqpVPZsfDEUXWb
17626	payment	1726	1726	1874	1	1	7213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAdhbNA6VGm3gYNxsVW7Bv1Ew4fPGKc8N1iXgewZcCHQDXjoQ
17627	payment	1726	1726	1874	1	1	7214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxWyDib6BoDyLt2oqRnW2NtpJi4zChACaxueEM6dJqgAUKxR6
17628	payment	1726	1726	1874	1	1	7215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqDaZWSgK7MZCEEYYTZYsGZGTh9tUaT9QrozQKePbyiqnHjMa
17629	payment	1726	1726	1874	1	1	7216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNR1YgQRsCMfVRhjrkexKbDzCVj4HJJStEwwDdhB4a4DFeg3ZL
17644	payment	1397	1397	1678	1	1	8101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqRmxaviYAuQL5ckC4PfDyzTThVGhYNR5c7vEbaSmXqzvy7Aj
17645	payment	1397	1397	1678	1	1	8102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEiNsbcMQKpB4LEvi1TC4wPZcvb5QQ7nuuMbpGDzxAHDw612k
17646	payment	1726	1726	1874	1	1	7225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePJgzDV8F5LZMxVoJ7u9YAAHnsT9Y7CPrDMXgTNMZgNAGJDhG
17647	payment	1726	1726	1874	1	1	7226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTWD8RLK8WQMH9UgpZQxpu3kTBNWKCDFEegAPpxi5kBL8Jir5
17648	payment	1726	1726	1874	1	1	7227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJvAgaEmWwDFuEdxgmsDLZEMUY1x5dZ4P2Qs6mUB9cy8jXuV7
17649	payment	1726	1726	1874	1	1	7228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtA2JtzQfh6JWkDCkm281oBWyUf5d3rB7DxVVukRW965kvHfz
17662	payment	1397	1397	1678	1	1	8108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxio6u1qGXq9jT2CYMhL3YHt7oA9uK9fuctzDLCv4BFh8ZKrW
17663	payment	1726	1726	1874	1	1	7236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3ssz2zVRCT9FAzEtTngnCo1PQJFybyvZ3QFZzP9DpF9fhgSU
17689	payment	1397	1397	1678	1	1	8119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAjuHBsDvsqDtF7NQzP6WtgsNnA1k1wVPdi1656aPYGPQx9Jz
17690	payment	1397	1397	1678	1	1	8120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkEwFbq6nX2SBbXgyNfxdBf315X2C1j2rGhTi7rmcFkomxmAB
17691	payment	1726	1726	1874	1	1	7252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7341REZKf6D2pcA89hJw8PUVBwokuVeAX5h4qUWaJbg1FQQm9
17692	payment	1726	1726	1874	1	1	7253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDv8yAa2sddEZJLou6MxAT7auxGYTEPDHZfUMjeEgZNDULpLCD
17581	payment	1726	1726	1874	1	1	7180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHuhwpPjGipAS2hSgs2HBF2G8C4XnWPKurp2qicChv9tHP9QMz
17582	payment	1726	1726	1874	1	1	7181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVoPqB7GPe84pXoUAr6XTRpc5wSJQuR5ymzXhg1UCdEvWHerUr
17583	payment	1726	1726	1874	1	1	7182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNXdrjAmkWTBRJa5f8Lt2t1XcCxHyKJkfKGQsW7DPkxcB2FLy
17584	payment	1397	1397	1678	1	1	8084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18GRc2SMY4wdUZBqSypVg9gHPkAPsB1Hf7rtwzK7W75UEtcHG
17612	payment	1397	1397	1678	1	1	8091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFppzCah8SRansUaKCmv8tNvzoRfkXEvRj4tqL6MJ7nKafUhMw
17613	payment	1397	1397	1678	1	1	8092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUy7EzET9xxmatVRCoaSTcGban1LztcpYicSKHuubNkGeRWnb1
17614	payment	1726	1726	1874	1	1	7204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfDeEjBZo1VzMwT5FvUAwxUgm4xvRb8EiSsZMfaDnREZXYBAn
17615	payment	1726	1726	1874	1	1	7205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrNTU29WHK5LkvmDmJXXKwmQBfhaViEsBmFGBe8Bv9BxReTJU
17616	payment	1726	1726	1874	1	1	7206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7wogWXNXrJ4sSRY9yB3oZAvtq5nijtN3B2JeLCcKNJ4y2hcek
17631	payment	1397	1397	1678	1	1	8096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwizokshE9uKf5TqRyTu8jZPUAoK4oiParBuZUdWGjQ7UQqwd5
17632	payment	1726	1726	1874	1	1	7217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYyZwBH2rFCqz9yUBqz5UqcFoDC1skMi8CRCqYDpT8VQqrgtf
17633	payment	1397	1397	1678	1	1	8097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYataurGsMMMuxuTdnXUKVQh7i23P8X2P4kc2AMEJBy8D2TBdu3
17634	payment	1397	1397	1678	1	1	8098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMd1LzY27S9d6Y899F5WUPXgfyjtgoHbn24AdbiErZDJQYvwFs
17635	payment	1726	1726	1874	1	1	7218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuo3jqBQSTQFc4BAV3EAQLGABt6eLBwaZtRzKkb3rVxHwgkmpn
17636	payment	1726	1726	1874	1	1	7219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKzUHzoyQBWtaVRvYCaSeBa7d7rjhfFiHsX91eXj7MG5ipWHe
17637	payment	1726	1726	1874	1	1	7220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVf2YrTiKtjgXh1VKy2Dq3mf1oGNxKYeu7oxuCzkGVnJ7xR1i
17638	payment	1726	1726	1874	1	1	7221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKh2ZNKzwL7LJXL5wYk3xDqef1yvemoTQx65vEK735tGsdGUxj
17642	payment	1397	1397	1678	1	1	8100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdahZvRfUH458ZEUtjb3XdEHQnC2BivV8KAuV8YCaxgATDHi2W
17643	payment	1726	1726	1874	1	1	7224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Je2W8XjfKxvq8wuKKYDSyKXTLeKArc2FxP82Df2VaopLd7CA
17656	payment	1397	1397	1678	1	1	8105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwdXXcm7Ga67mVjWKbZoC6v9WXvxAQMDWczSRiyoMYLfqXbxW
17657	payment	1726	1726	1874	1	1	7233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1SVCDDk2DGk5Q6uWJgUKGvetXa1wdZvU7pCZEd3LJg6isQAq
17672	payment	1397	1397	1678	1	1	8113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZheVg3sHWkLfPzCzmNuNLi4jzGPk8DsWtoVeKqNX44hHg7NTFD
17673	payment	1397	1397	1678	1	1	8114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYfddfkz41raCU7qyz5uRYyHNC57wfRMEpc9iihg4GhBLaEJ1
17674	payment	1726	1726	1874	1	1	7241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAowfb2uBpvaKheuvZqznm9fSxF3i9RRRHm5EFWit8imFP1Pj
17675	payment	1726	1726	1874	1	1	7242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqaU4FCTn9xQkJp3NSpEyosGLLSHNthqaXuqruJLmd9u6cKuX
17676	payment	1726	1726	1874	1	1	7243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5vB5JMuQ9mHaq4BqbkQBb9s8bgoTFiy73r5XCkB2DYBdbhG7
17677	payment	1726	1726	1874	1	1	7244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNGYjX6CZU1BZDosoHVniFi2GjxhSKykWmcQpZTNwa6ACb6Za
17687	payment	1397	1397	1678	1	1	8118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKPPZyTLS9VadNUMbGYoESRNmxPvPoW5shsWRvDknxWBnsQAS
17688	payment	1726	1726	1874	1	1	7251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTeLKNdcH5c1YLQDmhJzV4yThmY78HLYD3qW6ZJ4CVaXGr9wS
17705	payment	647	647	2113	1	1	0	100000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmr9bL68qtdAMJ6dnJWpPhjAnUfsGfyiCLXBeCgmfXs71g1aRF
17706	payment	1397	1397	1678	1	1	8125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zWiRyhjs7k85qUhg7Dj2d76PUrH1x7wBr1EqjtAEMPGp3SYw
17707	payment	1397	1397	1678	1	1	8126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdymfaZCFAUrS1g7GLHgZYYPV8tc5qti4XPmTUuj72RHHN3pwf
17708	payment	1397	1397	1678	1	1	8127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnY7aZk2N9eD3kRZEFD3YNpyQYAnFSL59KcVuEaoYXom58k5y
17709	payment	1726	1726	1874	1	1	7262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyctN14gaEJvRCf92L1QXZ4M8mbLQCUceVwhMUFNxP3KkSYtN
17710	payment	1726	1726	1874	1	1	7263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmJm3PkMdHumKaBJpUoLWAbGtNWZuNmmnmWR6dfUoCHcAxnGo
17711	payment	1726	1726	1874	1	1	7264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcvTEfgCrSPi9LbUP4fhNhXCaqMoqRXNtPjHrGJoE2K13ZpRH
17712	payment	1726	1726	1874	1	1	7265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWabZxwtjMf1noPiPs8ZFxZxantb2q7dp4Z4sYrCJa4EcZDSF
17713	payment	1726	1726	1874	1	1	7266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2sBoyeqrinyZGr8Z4r84whK3NpayVcbChx41e2wtgJwFGXWm
17601	payment	1726	1726	1874	1	1	7195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67VKy93ijiiQs8L9sBwJERvqYps4j7bm2uEAbNMa2FzrduURz
17602	payment	1726	1726	1874	1	1	7196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhY338HC1VdrEAe9QNbJdMFYsJWxtNqFggxgUc8wddFfGCAGh
17603	payment	1726	1726	1874	1	1	7197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FQECGPxybA5PLBLBqXLw7pLJRs9JKrNato9PywXDtm31reDj
17630	payment	1726	1726	1874	1	1	7213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6u7RZziiWKyFbw4JhrKoNbJzF9YXtqiQvAzXBGRirtpaCuiq8
17650	payment	1397	1397	1678	1	1	8103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5syVYcjfErHN62Q7mvhm9DGxwfEX3F45zXaFW77kYWoiAt1d
17651	payment	1397	1397	1678	1	1	8104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LofS3KgVhotYYC2X72u3FZmcMMJF85SJodneaBQBr9aBtigG
17652	payment	1726	1726	1874	1	1	7229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxzTEXLiyiiipxCX2JJPAb1ahfcKHX7pGEUmXUDBtLEzdLcJo
17653	payment	1726	1726	1874	1	1	7230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkhrdsB5quZade6k6aaFq9WqDiPJ88xVRM8Y7NWFuafyrAXoN
17654	payment	1726	1726	1874	1	1	7231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpLuhZWpR2ypca77QtvWAdSnuoZY7jkEWUJadRQuDpGpi28Zp
17655	payment	1726	1726	1874	1	1	7232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uh15GAzcsD9wTkd2YKTDNmQG3BfVVxgv1msjZwASiPj5QLHK
17658	payment	1397	1397	1678	1	1	8106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKr1bnNkcLcWaLAHGhkFpNvFM6E4r8JMZPxPmXv4597eoVQWHP
17659	payment	1726	1726	1874	1	1	7234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmonWC5k1UVohwY59URjEmAL13NBhtMUXsekxoENASw1BYsCH
17664	payment	1397	1397	1678	1	1	8109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdYN5UCvvpvR6hD8ho7wqRJMCjwPAuofbZN1fuwpFjfz4NEY6
17665	payment	1397	1397	1678	1	1	8110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm14uXuLfVr64NUoEutVuLBjZhNAmzdW3F9ShSLbVGAtKxCGS6
17666	payment	1726	1726	1874	1	1	7237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3csX3d4URfoQbGMjbT5jU8stNwuNwArzuVRWxbW4Ls9y8vA8V
17667	payment	1726	1726	1874	1	1	7238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbycV5uLPbpQGnwbhUPcTimXZESVBT7TetwNz5kUJSrdRwA4pp
17678	payment	1397	1397	1678	1	1	8115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4X7ZaYTU2wuk5QRrFnQxYuFHmUDdxYtdjwFxLEGupCdmZc4iu
17679	payment	1726	1726	1874	1	1	7245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY255rVAP4zCmC6ybUzAb4iHn2gZWuejasKt1HCPc33Ya8tY73
17680	payment	1726	1726	1874	1	1	7246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHSWqXVpTDBECXRRFb2nsRFYkVcvZkuWinLjLdwTDqtTEiqim
17728	payment	1397	1397	1678	1	1	8133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdm5SGYVDUbgK6atG5dkn6ojHgMuaSYoQmMSvetPY71dgkbiwe
17729	payment	1397	1397	1678	1	1	8134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8YPJETULe2UGDyfwxzYq99K1B8bbr3wssrm1xfB6Hf73C8in
17730	delegation	2113	2113	1560	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9ZnhJGdZXNn51Tzxp9nTkW48cbRVaZ8VtYYdkvFDcMnJnSce
17731	payment	1726	1726	1874	1	1	7275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFADayoXZSsHwXtZtVQGG1HNayGfAetMqksLiFDRu1RbUtx5n
17732	payment	1726	1726	1874	1	1	7276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gBByiFZPpcFnf2ae6vD8nwTEuf7nDubw2rSonL3K5faNje1E
17739	payment	1397	1397	1678	1	1	8138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUxit3SwwVDLfGy4JPohfzeuxm98pompM5AMdQ3YRperbCeYc
17740	payment	1726	1726	1874	1	1	7280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVYY4AiBdbFqXbr4F9HLppxqxS7MCFFZic1ZtUob5vosj5EFC
17747	payment	1726	1726	1874	1	1	7285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1QxU7JQPe32L8zhpqUTX4SeJs54jdpkvMe8Q2cupTrayeWzQ
17751	payment	1397	1397	1678	1	1	8141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjo6B4Q9Rar8FcC759keDkcAqT1c2T4bjwUPEo3QJtVR7G9p1c
17752	payment	1726	1726	1874	1	1	7289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWxFkhtf2ifSm71PbSjkvGBoTpXfn7x7dNjRydkGstQZxBs87
17753	payment	1726	1726	1874	1	1	7290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2cpULNqzZ4RoEU7z14NdQbat5vVxDoYQMrCfdbDffeXeJcpe
17754	payment	1397	1397	1678	1	1	8142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkwDcjnuUK8FtmviW2fJxRzampELUgaYpL7nNKQrU5zuLx7vJ
17755	payment	1726	1726	1874	1	1	7291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDkKKKopKEDguKVgG3gemTTKAiobbCKmsBDifxrHbn776RHTa
17756	payment	1726	1726	1874	1	1	7292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzN6c54NZZ7JciSRTQ9Wkca4YnNcRfcicd4Ayw4v4kU28fnCRC
17763	payment	1397	1397	1678	1	1	8145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuAnxyJGb2Kp16ZmqnpEHp294ssb5rACUiSNXCGCuurKTMUf4
17764	payment	1726	1726	1874	1	1	7297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TYn2vqJCCVe5HqAenLe2Cb24ptP1R6BTpYVqhSjzd1Dvivnt
17765	payment	1726	1726	1874	1	1	7298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPWEw6ESkbUdRKNY7nNfKog42RJs3fukH2HwqyxWvv8k7EzZR
17766	payment	1397	1397	1678	1	1	8146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYNnUJqnVLaRgK4c67my58GjRvfDiQ7w4xTkZrz96JvEwyKuA
17767	payment	1726	1726	1874	1	1	7299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78RQ4m8Qt7L9LtpyU6cDzVnc4WCXRUWnF5xHAUDeYWgJX8vDg
17683	payment	1726	1726	1874	1	1	7247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3kmUiLAMx2AySiJLNsT2frGEiabeb6QmaB9xa8vRmRbQut8e
17684	payment	1726	1726	1874	1	1	7248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZBv8v2U8tRCjaTLuTBBp5xZ1FhusJ3UvyWdWBYh92adZ2gKwY
17685	payment	1726	1726	1874	1	1	7249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSYxhVcSDHdca32c9zUh9qs3rCVL5FSBzQaXfKqsif2uSfGrk
17686	payment	1726	1726	1874	1	1	7250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZid6xdQTm3sh2PbnxFzz8Ki7tegjdsVqgKHScQ6ukPFH5746Z2
17693	payment	1397	1397	1678	1	1	8121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mrjAMPFahHLTAA4HCrbA9hT8gpctTjzjJRyAXvVWxzPS6nJM
17694	payment	1397	1397	1678	1	1	8122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBE3DJVGL9d94WkDQ9xx6UTKtFbz2tKS695dCoUFNvLAwgmPPn
17695	payment	1397	1397	1678	1	1	8123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW6iUaw7eSi9dZQuhbbDrvXNQeuvocKqMmUH1mEvfN5egHSoo9
17696	payment	1397	1397	1678	1	1	8124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHY5CZiYHoZ4P86LE6tVSU5hWAvgv1Fhk3hhf66D1BrR6pGpJ
17697	payment	1726	1726	1874	1	1	7254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiDLs6Sa4Ki9cDfZZFqVEZhxhSVZpjJaY4sXQSKvq5G5Yv1jwM
17698	payment	1726	1726	1874	1	1	7255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBrRTLdcznBqbKUeAqrZJ3b8PLPLa8kCGjuaAqTcNRsLK3STG
17699	payment	1726	1726	1874	1	1	7256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBEv32H46WG79XSVmtWkSc5f6VCYghR3B7qhqZGZYZxLgFABxm
17700	payment	1726	1726	1874	1	1	7257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UDpnB1CT7YRNwfLdGwFbuL4A2zFVQiGQqGzkbkELjy8a7cnG
17701	payment	1726	1726	1874	1	1	7258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFEkqJx6fn3ZDCcHhvkCEiXpfEk6mnbdvtTFxF9r6QDWBZyvi
17702	payment	1726	1726	1874	1	1	7259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8282Gk39LUg26C33npbrEv7dLcLG23YE6xFHLv9m5n9EqRE9R
17703	payment	1726	1726	1874	1	1	7260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRTyagbk9DYjtMSVh18m56GSmUV8QYHVarBd67q1CHY33uaLf
17704	payment	1726	1726	1874	1	1	7261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8QVvb3wpRzSa1XcGuuL2RUqeokJ3AmkJrHziQryFvzaUGBk7
17718	payment	1397	1397	1678	1	1	8129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbaj4nESVjUmM3BfxCEggYyhJyVxAn7n6fSYrMdaCvz7HjozMr
17719	payment	647	647	2113	1	1	1	234983938283	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8hwkS4pLAwEaTDDiUy2bzz8HWCrQnhmt9Km8TY3PSHLQJJuk
17720	payment	1726	1726	1874	1	1	7270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RJuD1iepkCvxzcLhZPR6oeMhLajsh8VThR2hq8Yci5EerXBk
17726	payment	1397	1397	1678	1	1	8132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNQKrwKVTQfR6cH9MvWkdMdmQP3nfgBfgg82AFeXbTAgooQap
17727	payment	1726	1726	1874	1	1	7274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgShtXiGHa439mEW2VA3puXt5mnfDiigHypUBTHnj1PAbD6MeU
17733	payment	1397	1397	1678	1	1	8135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxP7Ke11DAkgBVmZhkUYWSsjzmiMjKUNbd5JaV5nx24PcLHy9b
17734	payment	1397	1397	1678	1	1	8136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuh7snFApXvSZwHJzQhBXdkPeaSNRHSR5wkSdbEFwwpp3EzNMG
17735	payment	1397	1397	1678	1	1	8137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7Rzk8iBpo9hKNN2uczCYDwXaMeXQtuVyY4mK7bZ5NrKiWJhw
17736	payment	1726	1726	1874	1	1	7277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jZ6CAJaqF2Kr8Cw5Q6PXrQrCj6maou8bXErGvW9N9dYr2pRE
17737	payment	1726	1726	1874	1	1	7278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgS8fFn4Qhj2816UPCJeZL6aBiDsC77FAfbbUYkAu5wJbuPwr1
17738	payment	1726	1726	1874	1	1	7279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFSdGrNEmv7geiY7v7Yj8Gee1Jbo7kUpyZLZvrNULmZGGepAj
17743	payment	1397	1397	1678	1	1	8140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeuDhuwaAdmxJSQLi981n2Y5kMozQbVEmmcCedP2WLhpw2anCY
17744	payment	1726	1726	1874	1	1	7282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySAWzY6ewZGHsyPXSc3hLLoi2CdUTyDXXCfo5AVHHKTzHp5E1
17745	payment	1726	1726	1874	1	1	7283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGUcGxHbfyMSykBMiqeD9V74NUXPGDTPJpvPz7RQJu6SSZeEA
17757	payment	1397	1397	1678	1	1	8143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuzDpqz8ugANqaRa86FeXA7ixvthdvSaTZyN3iiPHRdbCzkYT
17758	payment	1726	1726	1874	1	1	7293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ9ipZuAAcDDAnfqhrZqUAqzm3rpb8uxXKBSW4E767TnzAnodw
17759	payment	1726	1726	1874	1	1	7294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymJNiddUEeLSYD7Ra5ZPRASH9ePHYJW7iQxGyw5qiLBqgAaiD
17772	payment	1397	1397	1678	1	1	8148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1P6sA225FedrBYEbrVyXJ6gk4tAeDUjuDMSu1txEVd7RFuvWk
17773	payment	1726	1726	1874	1	1	7303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu27erMPPYtEejocSRj8FXJ3XtJbT4JVGQv2fwKa128zxoqXx8
17774	payment	1726	1726	1874	1	1	7304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hNVyEQTujSh9iA4gWsP75sQXSfQU9UoM5Us2bz3nx4HMTcna
17778	payment	1397	1397	1678	1	1	8150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbtY9yeA9WDhCJ8ArML4RCJ4ULieboAqCLqPPzpmUyAN9tYgc
17779	payment	1726	1726	1874	1	1	7307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfrHEbxgaNc9GMP7Cs3iu1RmtkTMaHbZcD9w9yRFREECtvst7
17714	payment	1726	1726	1874	1	1	7267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpGoyYn8k39mpeS5u3hb1Gs5SEkjCD7DbJMHFA7ycrmAoev1J
17721	payment	1397	1397	1678	1	1	8130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDesQN1eRJpDwSjPUfGdjFaAdHawrgnk4JMdXDJoJYKnPfPq4D
17722	payment	1726	1726	1874	1	1	7271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGJV5nkuXFbsjojs92vUg4q3A9Rp7hBv3uQgQCai9ZCPxmVL9
17723	payment	1726	1726	1874	1	1	7272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQXEhWAYPQRxWZTN2Yp8uaKEPyLeHhhYKyi8ubGWY9CSJULjE
17724	payment	1397	1397	1678	1	1	8131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdaymyCG9fUbuRXB98PKKRREYath7U5Kneb6bF1JbrAmnG33n
17725	payment	1726	1726	1874	1	1	7273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsWLFZryWn1UPqvFhptu5Q7RTF1rtyZXyMkVnmYoR7ft1Kit4
17741	payment	1397	1397	1678	1	1	8139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiqxfQAQAeE51tVwJ8NYWydbJLjSFptd83Y5mityXwQhzLcfU
17742	payment	1726	1726	1874	1	1	7281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEpn5Rxriqe2KKYwFXkMigNQ9weTovj56YSCxjBciFL1Y6KxB
17746	payment	1726	1726	1874	1	1	7284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqdpTudY6ovfsFeuB6GusKcsqEiM4VRKkRL2uopZtVbBp4dNe
17775	payment	1397	1397	1678	1	1	8149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRHAbjdTWHK7fkb93oYdMqyXrepbadyv7TyDQ3qS85Dc76Xpr
17776	payment	1726	1726	1874	1	1	7305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZc1S85WoAzZjQpCPVzVibFjiwUTDszP6RQC88PY9mrRZ7Kr3
17777	payment	1726	1726	1874	1	1	7306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5Mutj2jrW6XZyPRfLd3CnFXinQ7Pw9Uo2R2n2aFWG7QeX4qf
17809	payment	1397	1397	1678	1	1	8161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCRstZSXC4Ui9BdDMtRnbSssvedhZ9njBnmuuBPz9hptESniT
17810	payment	1726	1726	1874	1	1	7327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnzLLa8rKoZcP3oyCm2ubK3ktGGt9qT1wjbMmiGhj2RKwhWNU
17811	payment	1726	1726	1874	1	1	7328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXR2vfoUpEpx7aKkCf2Rda33ZqDgYMSC7k7d2itSscTRXNv6z
17818	payment	1397	1397	1678	1	1	8164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yagEjGvqBhaGAXGCTFXTEFFDC14i3vP2Z5PxLqZFTs5k8zHa
17819	payment	1397	1397	1678	1	1	8165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof6ymexroiPwvGiRHZSXQP5cKgxg8Q6s8t3weQpPzDuszYNBR
17820	payment	1726	1726	1874	1	1	7333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPaWGm2uqrmb4MY79119SwkLrrXM5wNGNTVzcU5Qpx9va942u
17821	payment	1726	1726	1874	1	1	7334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58EXwK83at9VULx3bJVTdwoc3ntk2WAbs9MzorNmCUYu1MJSo
17822	payment	1726	1726	1874	1	1	7335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wa59tbBidGew939kNL1bPkmwmimFZRaHLKhviACh4dWKyWdv
17823	payment	1726	1726	1874	1	1	7336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw3qp9FWiqsk52r3JMnPNBVdgJjpdFhXbg2abKGLU9vjiTxxvC
17830	payment	1397	1397	1678	1	1	8168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt3v8yu1GL1oDRKGnihqYkPxF9Xw8BfPjFWeLqDDjSWTpWWdL
17831	payment	1397	1397	1678	1	1	8169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdi1HqVctT24R4VGvBpF8t9KaovVbrDfeDVpfd9TsbnkH8zbp
17832	payment	1397	1397	1678	1	1	8170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFs6qrohV885YPuGqSW2VaN6iMXZqWmCiYuh6HQL811Lok2AS
17833	payment	1726	1726	1874	1	1	7341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmpecx2mWmdgs7GELBQqd7c95gTrq7sgvJpNNLsZ8PSKDiXoW
17834	payment	1726	1726	1874	1	1	7342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBCpp3F5FoxpJHBouEJyesuWkijr5ozBxW1cnoTBC2EPPSGjL
17835	payment	1726	1726	1874	1	1	7343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtq4EFq74vVR8MWKeWfTYAgU77rMBAy5LU2PXhnnvz1gwhanGb
17836	payment	1726	1726	1874	1	1	7344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTwyz5ypxbNEvUGwRmNAeMq5fMyxUW5Tnz7M1NThc1y7UXobP
17837	payment	1726	1726	1874	1	1	7345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtANorNFuVxaqC1TPGvXshQ9bM7n9LPUFvqtfr5V9cEYRWS1dK
17838	payment	1726	1726	1874	1	1	7346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BF8H4RCtVUpYHrheBNLWBmTzf4rc64h2HVewfs9rRmYd6KEC
17861	payment	1397	1397	1678	1	1	8175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZ48TwPCi66Ua8VgprmLnjh7zqMzv2YujLijQWf2tkoGq9Yxu
17862	payment	1726	1726	1874	1	1	7365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZbbKpEMjJ5vmuVDH6i2J5DdfdB46v98LEu5KQ4h3ANCfBKrP
17863	payment	1726	1726	1874	1	1	7366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTyKRVKJ3hKadxo8azKuDe478uamKCuzEMG6h4sYHFAQUvu1c
17873	payment	1397	1397	1678	1	1	8179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyutjA7f7XRHrFuFiftMcbtciMkBhv8sDJrmvW3GkztCzt4Q4
17874	payment	1726	1726	1874	1	1	7373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsE1Rk1iBSwHtJm5b9uUQoqaFPPoG51DyEm5eFBddXDth4HrX
17875	payment	1726	1726	1874	1	1	7374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4i5RVLxPypatgmAx972HAdGjBaPXKC7sg9N5QjjDXpjyd44P
17879	payment	1397	1397	1678	1	1	8181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJMg1WVmaRSY2MCnD56jK2sRAYKwCNLKzi9N1ReVnGmBcne5R
17880	payment	1397	1397	1678	1	1	8182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYws9mwaYGPj5rjvVRT1j53MLCdA1GbxVQdaiVJJRw9yDqvBSqu
17715	payment	1397	1397	1678	1	1	8128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC23siQhSyBcattYLsKdBcj2Wdx4RvzXijqU4UQcDFTwWhQEon
17716	payment	1726	1726	1874	1	1	7268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EDLqgvMR1JfGanUa1vdRQxJic7fAgAuBLMaYa6ozYbsQVeqF
17717	payment	1726	1726	1874	1	1	7269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqFS4GF2UwgDWXkLRPusU2m6mpZDgAYrQTrVTNArVRCXmAzVd
17748	payment	1726	1726	1874	1	1	7286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1LrFEYqLVzPyG8a4MwwJghHjnSJUPDUh1hiahqM9zqY5apvj
17749	payment	1726	1726	1874	1	1	7287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvJP9gK2ZxFFDybzvi6iMARaWSc9cya7wJkr1WBAw5BJHPjeY
17750	payment	1726	1726	1874	1	1	7288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcgEdrtrrL8sLeRe8zBeqPQiMHZubarhLrJEQr6P8npmgLki4
17760	payment	1397	1397	1678	1	1	8144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4ZrYCm5ThFygQWx4ajRWwG8R29nHirTNHM1ku6kHFUNS3PBM
17761	payment	1726	1726	1874	1	1	7295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbchExEH3mHZ8YNubkaoXpndmSiq9zw9Gx22gapxoyKA7Hbg7Z
17762	payment	1726	1726	1874	1	1	7296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPLJGLdkirfjscob7gZcqqcvdafpYyj3yXg4itrYUt2gGMR5p
17769	payment	1397	1397	1678	1	1	8147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hGRUtgyL68raJBne4xpuyAFs5ckNJQ72TVxZdD7wg2zYodDP
17770	payment	1726	1726	1874	1	1	7301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4kqohvypf6ZHBb9xgx9y2mGTSycU28Aa9QwuJZp81DttGvni
17771	payment	1726	1726	1874	1	1	7302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbXToisygYJuokNXg1tazArjZmGLghihfiKHJJD4eqT9sT34q
17792	payment	1397	1397	1678	1	1	8155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHq12bvs4aTcY5P8kYrCycNjmNPkndE98HCNzXjZEhUTeLWebP
17793	payment	1726	1726	1874	1	1	7316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDT8JDQkYSLm7rKpFfia1jq8bQ76NjmLLm3gZKXFFDpTgpVNa
17864	payment	1397	1397	1678	1	1	8176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekZCEYWAaEryXvEosdDEWJ2y2WtkFyMaWqPeczoYfJDeQUW7s
17865	payment	1726	1726	1874	1	1	7367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFk75ADBk3jmhQMGFfguKRwLCUuiwUVRXguyRkPNa4J6F3mJo
17866	payment	1726	1726	1874	1	1	7368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBfiQuY2uZQj2GKoY9Np7WoYtSF36V4F9GJdJpucQ4XXao3Zr
17887	payment	1693	1693	251	1	1	668	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYxNPriz49ZnnBbbrWhBZzbvncXnXaekchK9Y8V6xHjKDkCaZkj
17888	payment	1397	1397	1678	1	1	8184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Gq2PkEJ1VpcMp7FCRGREVuYqkndagBHCcxEyL14mgy5T8JFe
17889	payment	1693	1693	35	1	1	669	33788775438	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaB3hNTqx4kYVc4J7yuDDGbScYChy8cWZQCRYGm1pjcs9fhdtDW
17890	payment	1693	1693	49	1	1	670	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYTwBxxnb8pYgonAMoranLTkWBL6eG6ev1hwMa6RG5RRXfeTj2N
17891	payment	1693	1693	1030	1	1	671	1585516072700	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZdmqt8CjWT4ETn7nffBMQHor6UvwFPWFSeuT4YGupaLfRW6841
17892	payment	1726	1726	1874	1	1	7382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWf569fmPg9MzvGsPShah9sp3FWRwsn99BSVeTXJNoFvFr6qy
17925	payment	1693	1693	163	1	1	696	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZn1YCt52EsmCYFfeK5KBJ3mqzdJaKXtz9yV1PxbRtRFsEBKHRx
17926	payment	1693	1693	275	1	1	697	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZAFJ7pURoAshj3cnPu9nyzNFfdLCj47AWUTySpmNaczRkvJb9n
17927	payment	1693	1693	201	1	1	698	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZLDMgyajvy2ANoVc2ZEYYgNo4L71saxmqcA1p9moMbdAkbQsP6
17928	payment	1397	1397	1678	1	1	8189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUzaMVZ55mmfJJTPTd3xpPNobyLs9ABx4Z2iS42h7H2BfeTj5
17929	payment	1693	1693	1962	1	1	699	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaE823yXFBR3rHMVKzC2nygxJtamS3YFfk9sgJZXeGzn53s4D1g
17930	payment	1693	1693	309	1	1	700	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZvXHNSDk6yFko1AyGiYhFFV3EsCK46wjnyoTvURhk8hozkDkFu
17931	payment	1693	1693	82	1	1	701	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZoEGvvtVzvapjhp4ti6XVXKi8npSdBtauUJwnxzbxUjxde1W9V
17932	payment	1726	1726	1874	1	1	7387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fxzHjTYGMc2wZRBQGJAQ2jz3d5ERwDuSBZ7Fz8rDhup5SkiX
18014	payment	1397	1397	1678	1	1	8200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9jk5YZ3JSSzxQM8mLH5bN7sHdTPQ9iAQXJ6b5QiuSQ1qRHjg
18015	payment	1693	1693	304	1	1	762	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZSYiHnvrLyobjZ8SxRU5R8LrFxjwp5VdZeXn1vD6KmE2kgRFhR
18016	payment	1693	1693	399	1	1	763	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYm2t3Zx6GgKdpQBw2aQn8M4oBQtinNrXYYnUEvXhXtvKoUfWLd
18017	payment	1693	1693	611	1	1	764	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa2fDsnZG11bzF5HazbQwguQw4tkJeG5U1b46qRRLZeBYcypwh8
18018	payment	1693	1693	206	1	1	765	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZP3N63XMDyqKAKzKcgjZk66zjB69CXhr7FnsQi1MEFWyWzNHYT
18019	payment	1693	1693	622	1	1	766	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZjJjASiM5nmMVHWQnAyAXrW9YpHZ9nHQdFU6Q6Vxo2gyptdEH1
18020	payment	1726	1726	1874	1	1	7398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLHXVVwBJpr69KaatgbKnjE5UjURfZ7mttrxZ26qaVCxzCdXs
17768	payment	1726	1726	1874	1	1	7300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMa51i7pmuk4C9ucLe5UCzJwE5Kbz3YvP7Xqewa6Ty1bqrs4N
17781	payment	1397	1397	1678	1	1	8151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZMiwTWoZvsJEB6Ej9qERzuX1jDMLRQPUZkKWzEY1ugpgLsMt
17782	payment	1397	1397	1678	1	1	8152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bbyiNzB2E7JoFJqcbkvmay9NXwGf5oqsvveaj4zx71Pn3B4F
17783	payment	1397	1397	1678	1	1	8153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2ZiU86wn4o8KchWwUDJyvDRnVF1c9VSpbL4DagpwLGKv6mDH
17784	payment	1397	1397	1678	1	1	8154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoFBAXvaVSzzVy42UYvMj42fyQWueovdvNmrKxF6azk8gVbae
17785	payment	1726	1726	1874	1	1	7309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7i4FEGjMM2Dr3B2USamn8YXMeLoX1u9UXQYKFAgZCNS9Nfgi
17786	payment	1726	1726	1874	1	1	7310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNpLke5Ry4YjFgCgNzHzD8Z8mc2T5vy1CGacMY4iKmBQXwEEp
17787	payment	1726	1726	1874	1	1	7311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDA4QqAMUYf4f3kQk1jGnoZPGAazdnCsruiXMNjviKZqtJPBxu
17788	payment	1726	1726	1874	1	1	7312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyK91SZA15vPbsEiz6t7NZ7Uye9DBaQuQJUcUHNnvX3MYQL1Af
17789	payment	1726	1726	1874	1	1	7313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFe9Kh5CnZhS8whXBKkAVKadcZBJJze7tbYzK5hM2PMyrHFyg
17790	payment	1726	1726	1874	1	1	7314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzQXFzp51FxSKpcSBG5h33XkgG1CEs19HUf3MkK1n5pvhVpnk
17791	payment	1726	1726	1874	1	1	7315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtffNe4QQCzAD1wfNm8HuHdHyNGA1Y8GB9pzSxbPKgWgcQ5P7Z
17797	payment	1397	1397	1678	1	1	8157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW83KPKaPiQPFUhRXCq5UFz11Gfh77EfKV675VRDhrk1mgr8FY
17798	payment	1726	1726	1874	1	1	7319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPf8px9EchVrCHLNHTvnesp3Pr5n1fbp58K6ZotdPNxxNFgfp
17799	payment	1726	1726	1874	1	1	7320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwa1Wq5bLAEb9hVRrpq4CZyVcXiLRuSTx91NrZj7LeB43aAx7
17812	payment	1397	1397	1678	1	1	8162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKY7FRkLDub527pv1KeB2npMW6rBJQtktyi9q4fp3VMBLMSaAZ
17813	payment	1726	1726	1874	1	1	7329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MKDYH4YjnAJaN1bMYtaMZtHAkocqD2J2fM73XYggsEo6LCQ7
17814	payment	1726	1726	1874	1	1	7330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34k5qR7nCQeR3CYBntevE8DgNyWmgwsXE8CCuoE1XNeqfddVz
17824	payment	1397	1397	1678	1	1	8166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5snDxm8ZjPRhG6ovoWA26opkmCAUJXVRTP4pb3wyP64zTety
17825	payment	1726	1726	1874	1	1	7337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAeH71gwC2j7S9uNubGqtdZD6eQoYG4Ly3GVvHwMGEG2F9DKSe
17826	payment	1726	1726	1874	1	1	7338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgwf3vE2UPCX5ewTVpq1VDHipWSK8x3U5s8AViX2YSVj5Ft2x
17839	payment	1397	1397	1678	1	1	8171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcvFJGmGz8KajEpRYUSNZj4iZaCRaMUouLdXXrhLEaTrjEmD3W
17840	payment	1397	1397	1678	1	1	8172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8GtcjY2zzM8GyVnx1CgCGciJQVSZYHGRzeLAHa7kbu2dwNV2
17841	payment	1726	1726	1874	1	1	7347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuhu4evww1xNe915E5VXKp344BAPAvG77EVVmUkNQdwEP3JyvL
17842	payment	1726	1726	1874	1	1	7348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdM2qTcyrdfjpi4brwobiGvsdbjR5M2ewpTQSCwHoXrF6eoGJv
17843	payment	1726	1726	1874	1	1	7349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcZApKTcBxKp1xXP8et6phkgZfu7aZDu1SSTj34KVQCSNQoUr
17844	payment	1726	1726	1874	1	1	7350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzB6TVU4JsKj9nqUSCKA3KD8dGZ6euHgi3HwQjLgEPdRSnwGEB
17849	payment	1397	1397	1678	1	1	8173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDEqSCD7An5AhmH14gJpV8Kka6nppLBhWfm5a1iHFL19sssGZ
17850	payment	1397	1397	1678	1	1	8174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TC8e1AxBrtsLpJGZ1wSnsELGGoKxw7m5QtJD1o4h8ZpkFZgt
17851	payment	1726	1726	1874	1	1	7355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLwqz9J2ZFSA7ouy16jRBfPyA1CwyQPW6nmQ7YUZueXRwTVw2
17852	payment	1726	1726	1874	1	1	7356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBSktiVTQzbrppFjoy8Dg642P8C6KZYqbW5qEWo7a1UPyL3e4
17853	payment	1726	1726	1874	1	1	7357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZni1y8ao9GKseo6eEFAPFLXbjv6dh5dy6Jq6xe9CyysCx15HbS
17854	payment	1726	1726	1874	1	1	7358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqGtprqNXHpsFefBdgDA6osiwJz5LqmAk3C9ggVTGvD8yhW9K
17855	payment	1726	1726	1874	1	1	7359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5UDH4FCGaGCyKt4ze8DLAt9xseTAm8Sh1kycvdYPukGcK5J7
17856	payment	1726	1726	1874	1	1	7360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwVU38AnciSU6r38VQQ7YDB7bM5KwwRjwkmVSW5HwT7T7jq8G
17857	payment	1726	1726	1874	1	1	7361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyF4xTzAXsW9RnyWEn1qq1TLqCCXL6XVsYLXge9f1eBLUuKtZR
17858	payment	1726	1726	1874	1	1	7362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7rTgzzQZ9RupdqkiuFQmpAUsR37Yiz8haHhsEK1rSLHxaF2M
17859	payment	1726	1726	1874	1	1	7363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4VmzXg3EAmQ4wHmLkrwWhANBm4hWWrfiVQd7Hqivf5bHna1y
17780	payment	1726	1726	1874	1	1	7308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEwCpha7KSVnsxZdxHwMh9Hn9jbPAzgBMzfukoYdVPXKK6K7Z
17794	payment	1397	1397	1678	1	1	8156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNKygjmLZ3bueYTFFrYmCdCFtYuvRdrwuw3KT3QSh12umBtG8
17795	payment	1726	1726	1874	1	1	7317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqrfnbKWoxXktGb2uSzXx2p1kUVbn6F8EAwXEqs8URbkjheR3
17796	payment	1726	1726	1874	1	1	7318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1pHdgnugiqXZ8ajyiCE9WcBnyuR2cjoM7hkVomFwvZATooC9
17800	payment	1397	1397	1678	1	1	8158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJt5pWo9PSfCNXiPC2KNDCjNBM1tp6gRpHRDZZogwvH9m8Y2q
17801	payment	1397	1397	1678	1	1	8159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVAe9aMcXDv7vpVdELGdYcP6K34cmpVvaoCb9yuE5MZx5e64b
17802	payment	1397	1397	1678	1	1	8160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gkYuejLBLxYtgGGTruYq734CG24mbSAS5ByK5pECrvoZ5Rbk
17803	payment	1726	1726	1874	1	1	7321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPSfWhoLo9VJdF8a6GB5KJiML36FU4Kq6W5EJibNLgpZtcLMt
17804	payment	1726	1726	1874	1	1	7322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmQukiQ6uVvmRtWEVB7wPquwwxHDVqR5TWgbKKcrqDD12v9hZ
17805	payment	1726	1726	1874	1	1	7323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7mk5E58ukA3MXkqkLaURSc2btFCHSUENQGA1SF9QXHStDire
17806	payment	1726	1726	1874	1	1	7324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLAJkC2N6k6rXP1AKYFmyMHYcG7PynVb1RMsB9SssT8GNfS16
17807	payment	1726	1726	1874	1	1	7325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrRLz4KL4MS4qcKrDb9j3RCp1Eq5xkXWq6njx9C1WB5ha5oTd
17808	payment	1726	1726	1874	1	1	7326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jffXuxFJFvcY7R24AjzUCxFbM6ENN9gDpmFGhJKceKbDBHx9
17815	payment	1397	1397	1678	1	1	8163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGWRbiL4YiYRErojeNpBQ93fsWdp9Vn9ZKuSqg9Pm72ZCjxjL
17816	payment	1726	1726	1874	1	1	7331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoamurb5qTrg14A1CavowD7yKN4QEdYx5bcowBdMNMa6fZpcV
17817	payment	1726	1726	1874	1	1	7332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89iUrBqEeB7A9KAf7V9KgpJhGb6xxVqxqEKC6X1FEt9x2wia1
17827	payment	1397	1397	1678	1	1	8167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LspV4TchRjz45nXDHJb4tAT53LzZd8DRyYfegDBvX2Q6tvvM
17828	payment	1726	1726	1874	1	1	7339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRYzftuKA5vc67pCmftz9uz5nMQbkJuoJ9BDu79TVzJQFfKuh
17829	payment	1726	1726	1874	1	1	7340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGVmgSForXVdx8j6hyy8SRt5MzLwyaJMb38XSRoqNsq7SP8kK
17845	payment	1726	1726	1874	1	1	7351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdqn1ATfGSaJXnkUUeaLGg2tzq4AHf6YawqUMFRCPM43MnQua
17846	payment	1726	1726	1874	1	1	7352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGGyhv6SysSawCTbQ3WPajgtzY9d62orPtJZyqLdxCYyV2CsF
17847	payment	1726	1726	1874	1	1	7353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5hm992VUBRXCMJraeWXyiemKNXG38LvnbeDoA5qcTDyVtYVJ
17848	payment	1726	1726	1874	1	1	7354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nK5tGhxUq3uT148qd23wryAm9cgK5vdy7hhXQvvDFm7thxVY
17876	payment	1397	1397	1678	1	1	8180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFh7g3Gnur4xbSFvh4bnNaBHzomnZgznmcJTKRqykcduQmB8x
17877	payment	1726	1726	1874	1	1	7375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vDmC4hJ6PkWj6xtUuCvjLhchzdphTZxN4BjxKWzfGzvjwoqs
17878	payment	1726	1726	1874	1	1	7376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPPsxAekMdRErSfnwg2cFa9ukWjCauMvsmYHhVDAF7UQYHkv9
17893	payment	1693	1693	1772	1	1	672	830827858416	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYX8AFNifrzpfhEjKSXB6QdivWBUM55UFJeJRRif3gcrzu6sSbU
17894	payment	1397	1397	1678	1	1	8185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTukZaEkWxKawqMugX5vhqDVXdN7ZyoLk7eeNCJBXfT8Bbvjr
17895	payment	1693	1693	663	1	1	673	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaG4WSngiWw2Unz8fPLfZJJtL5HomgADfePKnuZBGNfwqaXpmWW
17896	payment	1693	1693	320	1	1	674	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZGihiqNsWZhRZfUivfG6zsZ3gPsCcA6g9Z6PHEsJJzzkPFUdMX
17897	payment	1693	1693	54	1	1	675	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZf3jT5gpp21VYBZvjqHQEWSHqqi5cTtVibtYkgGNYtBYPxtRQG
17898	payment	1693	1693	710	1	1	676	8799160261	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaEsknbAQbe5pBvJg1iEEra692uHXDbkJNoGLzBhcPBnyF65un1
17899	payment	1693	1693	499	1	1	677	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZED7wmbHJNFJijiAwz14mJ3HKqrC9ZZQ1VguRS15AeuHvmrjXw
17900	payment	1726	1726	1874	1	1	7383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaZyECEubEf5eWDvuKrMpE5xyMrEmfvYCQnkcFcJmsjWL77gw
17901	payment	1693	1693	217	1	1	678	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZFV55CsJfBnXfcYJMaRhwjsoXhE83w2dA8yWPt3CviLjrxEcrs
17902	payment	1397	1397	1678	1	1	8186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqe1Czjec5oJz8v1AeJMibptNQ3xtuKXPLs3d37XL2Q7jUmpyh
17903	payment	1397	1397	1678	1	1	8187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUf2HXzmJSgfDDdLS8BJyzwQBYLSTxXWukBMbRKEc19KTiWznx
17904	payment	1397	1397	1678	1	1	8188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfytSF4sms5rC2RCpKQmJVugtygcsoRoSi5waMk8qD6eGSAzC5
17860	payment	1726	1726	1874	1	1	7364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG72tqYagWqAYVHndj1P8Bu93azBBhaUv7PKv6vtCvKySZYskH
17867	payment	1397	1397	1678	1	1	8177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVFJ37AoWEGhNa5PpwLCiWhon5sb45BzyV4qf7N7uD7s1SCky
17868	payment	1397	1397	1678	1	1	8178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNpChYTM6uZhdG2qF5ndt7R48VD7bmECL9gXg3BVxTHDte1LV
17869	payment	1726	1726	1874	1	1	7369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SbYzjf4qf8bbpHdyMB734hU6zY34u5K9crRD81t1pNTgkjin
17870	payment	1726	1726	1874	1	1	7370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJhQov4MgkMpjbJXnFGa52uGRxHJcmcrVGez2uQPTt7GDH6J1
17871	payment	1726	1726	1874	1	1	7371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTqLt1QTcBYYLhZ4yGgVDQr5ekmMVAq7tkvbCyxM4qVt1p6KV
17872	payment	1726	1726	1874	1	1	7372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQPsdD5NsjYdCxuu1vGQ8iLmzvnbmkz48tBGeyn6pucW53LAj
17884	payment	1397	1397	1678	1	1	8183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKmRdf7TcqNWEVkwLjXojpMmuvWgmSFfRkQYkeVLXj9xvS623
17885	payment	1726	1726	1874	1	1	7380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9crqMjiKrwgCSkuVSYGrfqZchjUVimdre8UeuL9Mec5ce5t6
17886	payment	1726	1726	1874	1	1	7381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38gGP1M2L4QRfBNokWhdJxxb3t6bT9oMo9x9txmHH1AUSuPbT
17965	payment	1693	1693	691	1	1	726	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYfY9NEQMQCcd1UY6NAJGY6jFQhYtNJ4HH2Hv7SY55SYxdALLzZ
17966	payment	1397	1397	1678	1	1	8194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuoz6MvYpNC9JznM98rF41T8tnEshhdB8W8imt8LbYAtgN8fZR
17967	payment	1693	1693	731	1	1	727	3519664096	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZwKLFCjX81sqz85Uy6H1SaTjPwYP2tZRJwEtShXkveAra2gYSZ
17968	payment	1693	1693	1150	1	1	728	1069779287892	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYx6xP3tSsRdoSqzeV5tDCKuRxTDMHWfpMfjd1PSQ2ZLRugZPfD
17969	payment	1693	1693	84	1	1	729	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ1q4JMhKcCiLSt26NWvQ6kMvAGw4uCMJrxsyMPZXBex6BVo6S9
17970	payment	1693	1693	520	1	1	730	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYgGp1MCkgN5GdbNGfCvUU98ddQo3hbdXetJ6U9BSve9wKnST9Q
17971	payment	1693	1693	551	1	1	731	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZe4fAeztnNfrkQHU5RLnBpRkDa4SaFNK9Fuxsg3sUUstZn8dRQ
17972	payment	1693	1693	2017	1	1	732	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZV967FwyD5CKPeVaEMjGycx8WCzMJLtjXXHDTadh4B6xhhF7Fv
17973	payment	1693	1693	63	1	1	733	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZQhqVPZUFRh9RAuYjRKqmLBrNyMdgcCKigHctfWoYxRReyZCpQ
17974	payment	1397	1397	1678	1	1	8195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLJH9cvd9Jr5qucB7keRmPM8SnyYb9r76mybLL5MAQTeknUSX
17975	payment	1693	1693	150	1	1	734	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaFXPCZeqfFqsSkLKL5Xvpaw4n8XEQQAWjQmkLwCiJoY3qxMx1d
17976	payment	1693	1693	92	1	1	735	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa4NM5BoQjPsZ1xFstnJmR29rkV53fFY2zEwXA5ss4XyYTHAFG8
17977	payment	1693	1693	322	1	1	736	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZNcnPq8EZ3AsJCw5mpAgHgDmViKForD1p6FFqQ7KQeZjgjQn3p
17978	payment	1693	1693	373	1	1	737	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYXFHtuEdr9Fo69DpZNXK6RJhZFGc5mjb66kP9fFj4BFWqHiC72
17979	payment	1726	1726	1874	1	1	7392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSRvgYnBvaryY6jM5nUcTL5ujUrE5fPMesiwkhBi4XBmi4HpY
17980	payment	1726	1726	1874	1	1	7393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1nLATg4PtQQpEyjRqXYAokHCh4THYoPh1gAiAhpMw9h7kpj1
17981	payment	1397	1397	1678	1	1	8196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQssCYufV4ybCA4qwqJSNz3cmdRvQWgPz3aJ5oyS1UAfjaKRAF
17982	payment	1397	1397	1678	1	1	8197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt39Vh94cAr7uDNqBC1NnojZ5UQ5uxFWb2nGghD6K8Ru7tgtU1
17983	payment	1397	1397	1678	1	1	8198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSnkgYFxkZFE6EsL5BLon229tcuXsiFASx9BNShnbCiHAmmKu
17984	payment	1693	1693	450	1	1	738	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa22Qnm4oq5R5d58rUeoq7Q7jCtRMzE1uyT1q6tXJbPzDPvpgHL
17985	payment	1693	1693	453	1	1	739	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYWR1XsV2ddPiUJimYsGdFpXYQxFqPu5yjivt47ghcSP6t9FquN
17986	payment	1693	1693	593	1	1	740	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYrkeZDzoCfFLQPdzXEUemaCNDdafqxkdFUVebC6kV5FeT8WQp1
17987	payment	1693	1693	91	1	1	741	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYY9az5PFAFyZa7m2vwaXPWFxD6R4h4WxUehBKJZnn96aPjB55s
17988	payment	1693	1693	408	1	1	742	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZsWYqHNwsFGNyfibT8xGvLcf7Nu5M1pwXkEYh5jWUUqN6TPSvJ
17989	payment	1693	1693	438	1	1	743	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa3cJsNk71xxRtRqCLst4Pz9k3Z19GRBpF3X88uKQAfutdNK7GH
17990	payment	1693	1693	601	1	1	744	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZZ7si2txrJhg1uMh9aQC5HdNCCiP15QX7YQL43NZg2H2z2BHab
17991	payment	1693	1693	745	1	1	745	3519664096	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZBGZ3c6qC58R8K13Gfg1XA9MtvGtCDFyKVZy9pQj9dUYg9FQNh
17992	payment	1693	1693	339	1	1	746	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa8k1JEhbG4U4got5r9qZzbKSsSNe6W8V17Ky4Z1TJwxdQJSNcm
17881	payment	1726	1726	1874	1	1	7377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LktBmcCB6Txwrb8wHcXhCmZQ8QYGnrS2wqP1Hxu7CMf3w18g
17882	payment	1726	1726	1874	1	1	7378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiatsYjDnvMAhA4eYPbDfN7zX2mqgTWgDR7woU1ttmT8qMmthE
17883	payment	1726	1726	1874	1	1	7379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7te3Kv3bXhBrzQKpxPPEhWJNoirEsFoGe8NyYCCQhc2TXTmzu
17933	payment	1397	1397	1678	1	1	8190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAeLKhKGfchz3FtDTKdFrL2YhV1DEjXYFcdttJN9sTarTW9NJh
17934	payment	1693	1693	361	1	1	702	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaDWq7RB1dDHGnVsks1c5f75TkAvGMmm92uctzCWxt1ZX2fJb4r
17935	payment	1693	1693	452	1	1	703	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaENA1qQUsJgCtW93NP4xFKRwugD9Mnya4jao5ab6q7UtVKfgsd
17936	payment	1693	1693	594	1	1	704	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa1ze2qxeRZnDSBBfgXkUQhVJcA8nbCQZpXwG7BgyUYbAZ57aMP
17937	payment	1693	1693	534	1	1	705	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZcJiRLa2ZSb5Mzf3gDf3zktrqrmvKaq5U8NkCWyrR3V7Sdezvo
17938	payment	1693	1693	245	1	1	706	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYkHbYxTAJXdXp4Qia3USvFVMMLahH3mXX7eHsVoNoNPtQSLVmo
17939	payment	1693	1693	191	1	1	707	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZskZ3EbgYKXEQqY5W4Rad6BM1v9TsFuxse86PEhTaS6F4C5gMM
17940	payment	1726	1726	1874	1	1	7388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVokkPPafuHQwrKzzmdMs2SLpdAJjTSX11YSePbeKybH4KTvsR
17944	payment	1693	1693	266	1	1	708	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZknN8ysbMKMBWQwrRTDvjwUt1ZxxFZnZmYuiAKRt342weG5o34
17945	payment	1693	1693	352	1	1	709	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYzveF9goU5LFnNmPn3QoYEjDYnBCeCEkgCbXdVEg986KApFiSs
17946	payment	1693	1693	421	1	1	710	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZH3vXquPGGJDDo5B8gwgPxdNc3kimXyFcpyvRDsgkLd7tTVDs2
17947	payment	1693	1693	420	1	1	711	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZkKS1ZkVS7U4MKM7yaeWdvAzS9Y4Libr9iqcoqLdLDtvBrmwgU
17948	payment	1693	1693	600	1	1	712	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZNKnMr2TnbTMueewjtxz3cU32ZfEJwpfx1rdk8iGGQW4bHAXK8
17949	payment	1693	1693	353	1	1	713	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZcixri1Uxg2or18GztTzMCxjavoRCt1FNZ5qcU6U6gTBHhyN6G
17950	payment	1693	1693	620	1	1	714	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZRwHu22HPtu1iyZxM19tn7U7oaPAdDTo4WtSRPEk9mxxFgWJ1y
17951	payment	1693	1693	180	1	1	715	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ4eYBDo3cFsoDKpg7rCaVNn1s7E37ytzTZmjcuBEgkvYwEBcCo
17952	payment	1693	1693	112	1	1	716	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYhWnPiP2Hdkb9E4nVXA7E96bDxxaJwcqqj9XRCBwC8LmFWpk7q
17953	payment	1693	1693	652	1	1	717	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZfb6evEzKQSX8Sm2iySWtLYQQHA99zRbaBspgPgaBAoNdk4Guf
17954	payment	1693	1693	680	1	1	718	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZu194dMQrQSBKDyhFafZ2vtYbRfaezHj5mDZ1moNP9VM46W5YE
17955	payment	1693	1693	690	1	1	719	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZeNncRMug9kaF6SzGhLLoyNJJiBxgdp6VrCEQYexs1phN64Xxq
17956	payment	1693	1693	89	1	1	720	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaGh8LF4CWaFB6LA2biGPybsVBV15i9QfTc7zQTvkmyThHQoTkK
17957	payment	1693	1693	186	1	1	721	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZT9bn4JD8FKuSyLWF1rkRp2EV6zq2eRHft3S5Kkqzw2LzMd4K1
17958	payment	1693	1693	383	1	1	722	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZyjYTUHXjx9E3XfwrVeywr5DGqArzw7pBzgehRmfEfMCShtYtu
17959	payment	1693	1693	392	1	1	723	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZaMBgxuNGRCuuww14GZd9vihp4TPHpe2PcXoEVjoPY3PkhCkz2
17960	payment	1693	1693	308	1	1	724	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYouxipZpdgQJ7dAKzS4MGAgWYcX5hZDpiKmjG4QExeVfiAkXxX
17961	payment	1693	1693	678	1	1	725	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ5yddzLw1QUByHh7uxQwR7DoNoK8SKvLcp9YSCFt88SYqf8quM
17962	payment	1726	1726	1874	1	1	7389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9w6bNxZrKPRFAHq8d9qZwjFQ6FjqDEERdZWYngV5WfCgf9kEj
17963	payment	1726	1726	1874	1	1	7390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAcQrRmiTHUsmD5C9YjfuDygm949CyE6Uoc275p4TNSDAcsRk
17964	payment	1726	1726	1874	1	1	7391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqq2DQvn515LxNXJggpAD9uwPs5G8QjCXDTYRKodVXXxvbXt5L
18035	payment	1397	1397	1678	1	1	8206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQo8wCaauStPxpzHv8CBWZYMAZbD2o5GVvFbMcmj4RrswkYtpr
18036	payment	1726	1726	1874	1	1	7404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9uMjRYvGVMpACZxUGLTmdRC64BaA4P9SFRayyyGgDn9nsYVJ
18043	payment	1397	1397	1678	1	1	8210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPNY11sXEsjSqGbZKsYvDVEvMALNWEKYTSoJPkPJMeNfb979M
18044	payment	1726	1726	1874	1	1	7408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZta8JwpnRPpQAvqFKpMUTT6WeEbbDDbhhRkb8noQ7s1iL9DsiH
18076	payment	1397	1397	1678	1	1	8226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJT1ko1EfvAASNdUag39foSPbWA7Bhjr4HvxTLUPZXKkWmUaBy
18085	payment	1397	1397	1678	1	1	8231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZerN6Z9QvwfPKDYtkM4B69rQ2y6Rmy3BJUDdYgifqfEVQVn4vJ
17905	payment	1693	1693	103	1	1	679	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaEE7f23gAxSxT3rnhLUC6tkoDeg5WQ3jPHuLVyrV6yHejdxRe7
17906	payment	1693	1693	1811	1	1	680	317795751869	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaH881tchFXiT3BPvGUv7vc1JsNLePFPwBdTwkUSb6JByxcM2Ax
17907	payment	1693	1693	893	1	1	681	539956803737	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYxkrAPaBQbjKghowpLfXfr5m89ckkmJo15edSLGCgx78uUZ2gK
17908	payment	1693	1693	225	1	1	682	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYenGqNyUYFxcVcXV7RMDZYRXfqrAXpuZf9pvowuyknngEQ9Yon
17909	payment	1693	1693	377	1	1	683	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaDj3uJ26SSQni86mQkE6gJgxoAnxMRE34G8S9bSgbKLxPAiJZq
17910	payment	1693	1693	560	1	1	684	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZWLAr4VJGN1B2neMkuKrDgpVBN4V8uQgbpdu4hmHen28oqQBg2
17911	payment	1693	1693	252	1	1	685	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYhf8RNhTdSfBFqdM6QqW77acZ7YN8zj49qVRJB9EwFk8arnB7v
17912	payment	1693	1693	894	1	1	686	539956803737	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZs7VoLSKRZoVKYYVKVKrvrAYKY7T2xYqeyELTNnFQ43TNmbQVB
17913	payment	1693	1693	569	1	1	687	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYvsRFK8qk2X6fVybEGy3vci61auz5wrDmx38DQXNxBX7R1HYXt
17914	payment	1693	1693	390	1	1	688	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYdV3Sv12qRANnLcZXj2vJE4bzGqnV9j8secyRaTfREQGkmEH5T
17915	payment	1693	1693	108	1	1	689	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaB8KwpJ6uapHwLetNfJxHQ86LLoax3NnBFmcRcqyNnAoCrUvgT
17916	payment	1693	1693	99	1	1	690	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ3Gy9T5AGxTqRNBfcWCc69tBeirnKSWFAsuqniUELtq7nE8Nqy
17917	payment	1693	1693	570	1	1	691	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYwi8Bz4Y3Ju71W6XCcADVUc9VfTquXrbHBJ4Gnosb7cnAe4c7W
17918	payment	1693	1693	2073	1	1	692	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZNeP5FgB42ycMK16ScMUy67Yc22czzLzPbe5GeHwGdcDfF9eMg
17919	payment	1693	1693	391	1	1	693	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZVWfVuEQaKLhJox2Soem5DnSNmK6VumxsxxYo7sXrqWLaKJmWc
17920	payment	1693	1693	397	1	1	694	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZiGZ6ZiS79kajeX1zWrQBQHHVzZqQQCDARdSdUWkzchZvWzn5Z
17921	payment	1693	1693	402	1	1	695	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZmZQzinzrfdN9UUKkCFayXAYx8yTUT2QETjzszGqwnQvPF1a2S
17922	payment	1726	1726	1874	1	1	7384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa64MwmhtFEZ1rvHJoHmSn4i5E78JgQH6rpBpCVVh4jPe6vcav8
17923	payment	1726	1726	1874	1	1	7385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Boj5xoVk4vZw6qKC1yQwn8aF2yXQQ24bfWgQBAS6Rmuuw3sm
17924	payment	1726	1726	1874	1	1	7386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZwXEjhTQn8FLHvqZkqHK5xrgMnFMKdPWyBTVhKLBVns5Mnwe
17941	payment	1397	1397	1678	1	1	8191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWirYGDT81PoWENoimkW57Esxav2mm6Q6Dfx2KcdioP34RWQmY
17942	payment	1397	1397	1678	1	1	8192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeR9u2HcG95JBrAU7yEnP1tXWnxLkXptXuBZ8njJ2ksMJokXVp
17943	payment	1397	1397	1678	1	1	8193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEAAHzXECRyeYwA6T7FGanUVZcF3ZfpButs3fPMEtmz49qw8X
18005	payment	1693	1693	138	1	1	756	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZDzkHpzSQy3GxxxA6qSTjAN9NzxCnfQLokGvFkcEwj1m5PkAye
18006	payment	1397	1397	1678	1	1	8199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjCht4DBXKnfpX2S1ia98iuQkRWUNVNSdtsNWbVpSmhXS9ziP
18007	payment	1693	1693	146	1	1	757	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa4JE35R1twLUSL7CmQmVoP3Wi4QHJTnYhDygdfaAbPeaos6Pee
18008	payment	1693	1693	122	1	1	758	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaF4NYMnP7wqQNkQYr233LkfaaimLau92h6a9HatQuGWmAiSSNs
18009	payment	1693	1693	105	1	1	759	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaCE3FfcTsHnDUHSt8h9iz8Z75hAW8xsoLxpGAV795o478juePN
18010	payment	1693	1693	500	1	1	760	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZm6qjnKsC43xi9FwDe5NTS1C3PiaqcqtQ5x44X7puPnLeBFCac
18011	payment	1693	1693	587	1	1	761	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ6zTk8ApFxCe6DQYxWsTnq3DvfUpubjLRDcCS2rueGRW6H17nq
18012	payment	1749	1749	1950	1	1	14	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcw88RtSaVnkerwbSSBYd4hZVGPqtMTXTqTgRhQdkbHAczuusP
18013	payment	1726	1726	1874	1	1	7397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiuLy6ZhMd61ueY4QKwSbwtf7EVF13UzA7jVcB4ToWNZPtJBw
18041	payment	1397	1397	1678	1	1	8209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEAv13SbY3Aj7ta2SmoHi4nDjA2J6m9hFq39oKv8Lqx3BUoPb
18042	payment	1726	1726	1874	1	1	7407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYE8zZkVbc64X1wypLA6g54VsR4SaPvfDbP9oEnrkhLak9mRmW
18072	payment	1397	1397	1678	1	1	8224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4pTduY3DVHJ1C6TGncGEdVkLYyUrQz8tF1MxoDu4gQ2W7Js7
18073	payment	1397	1397	1678	1	1	8225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqFdpPpwa6bxozCnmEu4MmSa9oXJqaGhzfVrPYbMuNwxgcrq1
18074	payment	1726	1726	1874	1	1	7422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxwf9MLn9wHYystbLgeWPEm72SwtvT86MLAon6AnUCDdufT8F
18075	payment	1726	1726	1874	1	1	7423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsARBajUkXYPqKDuEQ9Jkcf2tAeP8j1ZDaELG6gCRXx1kJvXcD
17993	payment	1693	1693	504	1	1	747	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYTpVT9B2qQJNwo1fjRsyPTeDSPwsCsbpa8k1akBXtqWtWnCmij
17994	payment	1693	1693	1961	1	1	748	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZpsKbhM7HubdPGTyBUS8ru4KkjpZkazmX8VZ6n6yHaxAwfcqRK
17995	payment	1693	1693	658	1	1	749	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpaH4QwMpsnj4kFb3eiFSJ2g2Nbkn9t1xqDJZuXvyfNGzs15q9Hk
17996	payment	1693	1693	205	1	1	750	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZWjrfnhskVFeY8bYML2WeCrobiZNztKuvnspEYgYyjDduPgJgL
17997	payment	1693	1693	660	1	1	751	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYaCkCRUeJu6EspXzVfQvgBMCsa8ak8QWhD4YxVM65W1tF1vxxb
17998	payment	1693	1693	78	1	1	752	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa7p4613R11NVWRXxsvSJdkekFZCuhKGCZtBSYanFv4ceMdtkTe
17999	payment	1693	1693	395	1	1	753	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZT9tBrDmzLW83Qm6nLm9xQBFrZaHQ1y96oG6rxFA3dyRe9Td9C
18000	payment	1693	1693	29	1	1	754	12318824366	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZbVBB2vGztbZZ1pPdgtyicPWt4T1NUHfUhYgEjAgNqeEZJf9v1
18001	payment	1693	1693	910	1	1	755	884778824468	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYgaB61Y3k6xRS9fnJQADHmovQfjrcmj2gsaoXjKTqgfPsoAHMM
18002	payment	1726	1726	1874	1	1	7394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDejCTT22mNN1dydZ3f1kKT2t9vCqcT1HapnGQEMbRb8fTe7J
18003	payment	1726	1726	1874	1	1	7395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCF2kDFL12LccNBwSoKY5jktbPhANVDuvwWm8nWRxKG1hSpt1U
18004	payment	1726	1726	1874	1	1	7396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPapXdn8n5mPL1D5ueK52NmimjLbGDw8cHkRT86N36qvR6JHs
18027	payment	1397	1397	1678	1	1	8202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAWj4CW9DJbYJ4KmihYcHFDC6Vzz4ZeV8PHioysB1VRhEN4nS
18028	payment	1726	1726	1874	1	1	7400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL4sYF3RXeS7bVJoZVjoGLKmi8iU7TY8viVzRrP73VctkBwwU
18050	payment	1397	1397	1678	1	1	8213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qCLReCpm3VDpMsArtLdJoHznDhthGZJDZyTpoAapT4i9EvCm
18051	payment	1397	1397	1678	1	1	8214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEjZvADL3P9dYMKoQpzri8oQ9B9G8stBuMN6z2j6BZiRiSpho
18052	payment	1397	1397	1678	1	1	8215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCprPTpYGFfbSmEM8UDXoSChg2mCQBhheR42DM9bSicJoYwiY
18053	payment	1726	1726	1874	1	1	7411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJibaZzhn4VTqNgBZoBPPnPBXvpaT7UAL15mLfrFwQUBy3Kyf
18054	payment	1726	1726	1874	1	1	7412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybMD4Qg8ys2Ng7SbNGmhc5VvZKNtC4L1GocxbEe9YR7bBcfiV
18055	payment	1726	1726	1874	1	1	7413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDm7DC2A4ie6qmyARkLqW1M8H1aPM5fsHBwCtsen3mWVN34g5V
18068	payment	1397	1397	1678	1	1	8222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPD4NvKnuWjhP2qGwELHkdkYbHqfi4X6FX715o3zn3jowMtU7K
18069	payment	1726	1726	1874	1	1	7420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sW23a4hf7f2CJ6wQcMmdmK52BhjR2X2yumZbSApWoLVMgAjC
18070	payment	1397	1397	1678	1	1	8223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JL6usVgvJSh9vdUbBfZABVMVNjnvRECKGQ8ZNcwBoJ7U5GQu
18071	payment	1726	1726	1874	1	1	7421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7Qgr7idoi5ibkZrSGeXw8Njhm57HE6Gf4ayM6PSgVAv1HkmX
18077	payment	1397	1397	1678	1	1	8227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SXmuTSSYEw38a9Ge36iiBvCNnBHuUfvCdjW3bbizwtqiiUVe
18078	payment	1726	1726	1874	1	1	7424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLajqGtNTZeW8wsmHQ7okV1nrREc8jtWDYHgy57YFfnvRxBVd9
18083	payment	1397	1397	1678	1	1	8230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRZm6UHNH9fGz8rojNZZXF78XkaxcX8y8rProcuxbbhsFgEBd
18084	payment	1726	1726	1874	1	1	7427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAnj1XhCxJDTbTLtCBe6tDsUqMmveroJjVrJv5ybVv2kfsJ4Y
18101	payment	1397	1397	1678	1	1	8239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzZFNNrGea7YDjnwH2MACYW99YCbn9NatoygjJinzadF1Heo1
18102	payment	1726	1726	1874	1	1	7436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtrGKaJNS7nQrrGLizHknTYWbpm4yANCwiNAsSbjzawu1hQwuJ
18109	payment	1397	1397	1678	1	1	8243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbjyrcWvPAeUREA4JaeL4c9JDHykdh3wMjRC4Wdc8W4CwTkRF
18110	payment	1726	1726	1874	1	1	7440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrvKRxi8AxivYHwduEnmvcntsfyiRLNbumU3VcifLDaB66AVzF
18117	payment	1397	1397	1678	1	1	8247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPU9bMvAv2WMGgnyTNAQBoAQRcZsF3gd6CeQdzHe8gBKD7jWs
18118	payment	1726	1726	1874	1	1	7444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoaWdMKzGvzhTz8PJWbdR3VjRjL3qj5xzHXBtYwejYkni3Zwv
18125	payment	1397	1397	1678	1	1	8251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmMArFYWJAwvBWxXmJ3ktbGLqeK3vtqYWGo6z27PaXN8CsNbF7
18126	payment	1726	1726	1874	1	1	7448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLrjoNUgfxhQaD2REj9Nv2byTtR2DXjcrXWpgeak4Gk95VLLq
18154	payment	1397	1397	1678	1	1	8265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwY4jTjQsH8n23NiQKnEL52c3gcHcdQQ9Ara8dqwtUJ4x2SxYs
18155	payment	1726	1726	1874	1	1	7463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbEm9SY27rgx66Cydi732ULfM6fquCvQYhjxEz2mtY7F5rF5S
18021	payment	1397	1397	1678	1	1	8201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucgjpkYmyXbAiimD7Qc62qMJ7iSaufSxVPyswhWD5REhaoFUP
18022	payment	1693	1693	653	1	1	767	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	Ckpa8aL1kZuuJcexTbQ2BFvbU8bRG2mcJijkEqpfoM7HWJbkMfPsG
18023	payment	1693	1693	194	1	1	768	116148915594	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZ8T1wdR8AMhsQRpu8xfNco1riMixaS8vyjzqXRXMsMxaNMKaPp
18024	payment	1693	1693	1276	1	1	769	2981035105160	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpYri8c6s15b2A8WEWoiQQiGeFKSk6FkJMjhRrz3n7AVrxLqHWmt
18025	payment	1693	1693	721	1	1	770	3519664096	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bNuyFxthSu6Xip7X3vWhK8r	CkpZyUSmPMBkviUSubkwUzjAstwnTUMrBaXe8V4ERcc5VawFGdWGj
18026	payment	1726	1726	1874	1	1	7399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pmRtxpVudcMeq7Urg51UaHm8gLR2tWRK7Xo2gj8brPs83NT5
18029	payment	1397	1397	1678	1	1	8203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBqpbAbGMyi34riqsi7wfYyqRUooMe3HhDADxXnM8qmfc6RQz
18030	payment	1397	1397	1678	1	1	8204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VuGY8uDwTqMqzvYQRDeECtjXAwottCthVJC5wpkhZwQAVrQY
18031	payment	1726	1726	1874	1	1	7401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEt4Y6yByh4PfEWdV8K46E273nSeZRxUt14nGPih3QfseWwGmb
18032	payment	1726	1726	1874	1	1	7402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHMtikL1E78hZSRrd1ip6yRWZ1RY3g4WWh1Vqk6dusYuuEkhv
18033	payment	1397	1397	1678	1	1	8205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkc7LXPnRaCJ2TXEab3gwJN7bivegfSn4yXx2r2knW9SUAbTm
18034	payment	1726	1726	1874	1	1	7403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxL8HAmQxHk5WBfzPtqLYFjCD4Ay4EHGyru18dhtGcB6v7YdJ
18037	payment	1397	1397	1678	1	1	8207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyuwaVcUzyjJ5f2xd6gnJfza7m99Ke72cqn6aJ1LdMLX8bLDG
18038	payment	1397	1397	1678	1	1	8208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1FdULR3dfHnb81bTNosqYQ9SUYgKfrZkFkFp6LX54KLE9ooZW
18039	payment	1726	1726	1874	1	1	7405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1uM886grxb3mqXRcNdcsTMwNVro6JGoULdf7oCUZBD9U9rZ3
18040	payment	1726	1726	1874	1	1	7406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuAvfoyhonnk7nGoGYnFhpdmoH6cNy5XfyrePLcDjK2zqsCG3
18045	payment	1397	1397	1678	1	1	8211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhyo1neHgYtrU27EoSQLP7DbB7DoUDHuDxcEo4FuFb4G59zhFp
18046	payment	1397	1397	1678	1	1	8212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2y9K3okSq9ZMwDCLcPwuaXu83wZEGW7kYyWEeT9hjyeHjb7ca
18047	payment	1693	1693	1778	1	1	771	1500000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpaDzBw7iUeCVBEPgEYokWpxL9WV9PTjvso1dv8RkP7FpVffUZuE
18048	payment	1726	1726	1874	1	1	7409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3qA99BEtGgcR4Q2WYszBTsCYurKcZZNM4N5sjmApr4dzXV1d
18049	payment	1726	1726	1874	1	1	7410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBzSNm4KvcZTjqX4k9guzq86k4iHtHJqj392n5SSiAbGgXCXgW
18056	payment	1397	1397	1678	1	1	8216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUQdGZx2bUQLPvoHkCorNRns1Camss3WqfGGiVkApmZMqZQw1
18057	payment	1397	1397	1678	1	1	8217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcSNUCnMccnTi11zcawuvkQ71GHGKwzgDLKtof4KZg7pRG3G6
18058	payment	1397	1397	1678	1	1	8218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7E6X3MoLPGyYDtn5MRwoDxtkTRS6rUQ1vbfzqtg6Q5sZXBAm
18059	payment	1397	1397	1678	1	1	8219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKfUqmDc7fSEe9KMemtQ3cQEz37UPr8KCTAph6FNkDb7oGidW
18060	payment	1397	1397	1678	1	1	8220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvem1hxrUFJsiMtnPCDaUntzqPFi53ngMEDUp6g5qpgtXAve4F
18061	payment	1726	1726	1874	1	1	7414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyof6rAFEM9XUFJWzaWJiS431pf6DTNKvCdoiPkgJgVK1p8CY
18062	payment	1726	1726	1874	1	1	7415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZi1omoPKa5YyeH3dcV4QRj26UcndbFzNQQKewqqanYDTbFjq
18063	payment	1726	1726	1874	1	1	7416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtpBw4MHECTrLGetaFXpcgUWodMcz9J5TaeWhAQk77WyzTuJf
18064	payment	1726	1726	1874	1	1	7417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY5yefJYRbhvKRMUPgHtkAsMGJSui8yk7UX9AkRZmA82f34Wk
18065	payment	1726	1726	1874	1	1	7418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Hqgdu62rXgjyPPVo8AfygUYGEGUSoLiQnHx2gCMrBD7qRCBE
18066	payment	1397	1397	1678	1	1	8221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHEunsv4xVCYN2qvsiuQudPrxptgyENAzFGMyNoUiZjT7J6SR
18067	payment	1726	1726	1874	1	1	7419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cRWmBNtXdySn4PeWhTawy7uGXE6a7UJsD9XkRLEQv7uvpiKE
18079	payment	1397	1397	1678	1	1	8228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7hUAVr1VMDudVDqiv9xafGnaSaVWjycGh21xMDPXZ9j6rTNL
18080	payment	1397	1397	1678	1	1	8229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XRfQQJEcgGnBbmXCV7h6AfoeXFiiD8xuSLymdh7UbCyJT46y
18081	payment	1726	1726	1874	1	1	7425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnjLDK7hmTwHpTbbzMmSFj5J673RN57tCGBGc1yK7KQ16YMKL
18082	payment	1726	1726	1874	1	1	7426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3efMtjHPNxBjua4WyBKEdiKnuYccJRPxyPgDKLHcGL9cYdYRS
18103	payment	1397	1397	1678	1	1	8240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1cYqz8BDhs83mbY6tvCwCXT1hYoNvUaBeJFR41i2hZoJWLPm
18086	payment	1397	1397	1678	1	1	8232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkBMRXpGBmkwtGGVhR44q2Djns1chQmKLw71HapPX3p5CY96S
18087	payment	1397	1397	1678	1	1	8233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZr6kDX9oXeJri1xsVZWgLgFz2BmLRbh8fq4AdxAU9jaCUJUP
18088	payment	1397	1397	1678	1	1	8234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpobyJxUZiJUHtqVSkQWZctu5zkyBZxG7nd9z4V6r2TBGvriK
18089	payment	1726	1726	1874	1	1	7428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwNoQUveAskQto7FMUF9fRLMmTGoDJ2oq8wCjEfSXA5PbWNDgk
18090	payment	1726	1726	1874	1	1	7429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6EZvZhA7bbUBGiCdD1PLTgDugBU8xjjESFsbSWi5JFJjCBio
18091	payment	1726	1726	1874	1	1	7430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvjuyA1eza4cTBNFVFw8W6Ekf2yg8Ufh86Gfaiyo1NFJSzvpE
18092	payment	1726	1726	1874	1	1	7431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77px73KagyqNwm8CwC3Qa4YLsEZSqMz1t87EgsNJF1eepgVQs
18093	payment	1397	1397	1678	1	1	8235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1TAzazDjVx7eWPyQY6LWMXaHPTm63Gm7S8XMEPjzQ1ZtRbfK
18094	payment	1397	1397	1678	1	1	8236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCEUZuDLuHmsAvNy1HNC1kipE3J7VBeZAJHW2AtX2gH4ajdjz
18095	payment	1397	1397	1678	1	1	8237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjMEYf1HRkbwSF2HB2nSGbXMFAQi74yUkT7yXMt8VpPEpcBWP
18096	payment	1397	1397	1678	1	1	8238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjXPhgeA2QQHFaeaU6hHezgcnPP4fyWoyWzArQY4PqrtZieTP
18097	payment	1726	1726	1874	1	1	7432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQuwz2kGNuPRkjttrpNaDPnpSbcDZcwFY9wQtFY8KFt7i6G7m
18098	payment	1726	1726	1874	1	1	7433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNnEQteMszDGGCM1QQ93gK8r98YTFWupoF6ZTkD2qCZcwbQn1
18099	payment	1726	1726	1874	1	1	7434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPzhqMYgN9tqyq7wX7MX6aXbJd6mtR8kSxR5kTqs5EsVL3De5
18100	payment	1726	1726	1874	1	1	7435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmos6PjiUz6tkajEAQpPiMqwLcP82KU9AVm2k8iGXpCAuNVLa
18105	payment	1397	1397	1678	1	1	8241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa84sZeSyKhTuTXXdNLbsdjBbYPyVASNNjsjV1Ycm5QiNb7NjN
18106	payment	1397	1397	1678	1	1	8242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6AssZJuR1qWHj6un1wrRBFUCWJfkyb31vUBQwJSYaeEN1PKP
18107	payment	1726	1726	1874	1	1	7438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DXJLBe47hTqnAoyYA66fVDrhRBeN7XXUxcQcUqwWxDdsdKpP
18108	payment	1726	1726	1874	1	1	7439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBh9xN4m8F9naJkNbzfpfcv9eoMGfe2Wi83rjp1CEvqTrsaVpN
18113	payment	1397	1397	1678	1	1	8245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7A2aHSozpMMMq9buVq2XKzMYUyJNnktFrnr9SPdg48vAH793
18114	payment	1397	1397	1678	1	1	8246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1zJZjHM7rXp5tJFY6R7modsZkNdNC3NhTrUp7LaVSCW4CEHo
18115	payment	1726	1726	1874	1	1	7442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQk3WgqZfVEqzKKX4WVP8MrfpwLk5xU78F5o9BTLtpsD42ZYzQ
18116	payment	1726	1726	1874	1	1	7443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU6BCG57QkVvgzq1H25ge8935U4ScFLLo1zhBLd3FPEMQ6yVc
18123	payment	1397	1397	1678	1	1	8250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qn7sAGvpJMizur7Wk1a19XqYzrFC7UDfLcPZgrYLUrVqLWsS
18124	payment	1726	1726	1874	1	1	7447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGPRAozLbwhmcKRmDeJYsHvun9HzgeaMxc2J9UnMHDrmYvSct
18131	payment	1726	1726	1874	1	1	7451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DmUqBxi55MPB1HW4VtZrRDJLfGfbKuW8Qmc4zQLGnAn4GZvW
18132	payment	1397	1397	1678	1	1	8254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVFz9zkgwnu7Z3AkQGN2zSVWodMYqZX92QY1d7VfSSQEESZCm
18133	payment	1726	1726	1874	1	1	7452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjuVUur6gYYJxbFRmSWz3o9EJ5LnyrC8XW6wdqDyNyUpQe3Qt
18144	payment	1397	1397	1678	1	1	8260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYprtzKvC1Lkcxq9Vf7zGCDgW6maJFpJRrqC5HeYYoxLyMuZoLf
18145	payment	1397	1397	1678	1	1	8261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtw499M36ttHKxqvgLuerBFUii8MGYndaXuj88bgkjx7BgKX7e
18146	payment	1726	1726	1874	1	1	7458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeaQdYeEJRo284MATE3aUauHLe5JSdQFLWF27w8Hadpd3LxHH
18147	payment	1726	1726	1874	1	1	7459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4sWfQkde7SQXakRQ3zM5ffUPA8Au5vcGjS8JMDodMSUr5niw
18148	payment	1397	1397	1678	1	1	8262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfpaNuGScgMNdYEKa8AQ6RDaPMVaNEc2YMLu6AYbZVeDiWMyG
18149	payment	1726	1726	1874	1	1	7460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbN6BtAC2fVvPwbr4M3fJs4NU9us7e4tRw3ny6bh8jAAkiqGx
18156	payment	1397	1397	1678	1	1	8266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ACdknQvtk6yLkZwG4CU5n8oPjPZvAA1XwwW2G2YMh55F8rLW
18157	payment	1726	1726	1874	1	1	7464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTD2tX9o6MrCtdzW9KpGfB9yjX6USaM5JEHEWNJtEqr255FPGr
18158	payment	1397	1397	1678	1	1	8267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wCJsM1MbkxqZY9tZQZZtnFep2QTL7acNKKMPbV3k67AAptvd
18159	payment	1397	1397	1678	1	1	8268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVW2kduL97ntEkReN8M4yhPoMG8weejQSGHbDLntsJEFpDpe5s
18104	payment	1726	1726	1874	1	1	7437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxRMv8tbw7QfCtsFQamFVdrvXDEJHRwN5hBJM5UPbCY4BdA8j
18121	payment	1397	1397	1678	1	1	8249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1BkAjTwDm8Cjk32Bypyw1G6mV2PcCU3JoVmjVWxFRyAfE5FJ
18122	payment	1726	1726	1874	1	1	7446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zKxaNi5cLWjT27yZm42XmsQBxygUKQGyXLArDFiwPsfC1Chu
18134	payment	1397	1397	1678	1	1	8255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYs3gjshXo3vP3hX8SFJENTdvfxiAcX5sipsx7bE8qu34438v
18135	payment	1726	1726	1874	1	1	7453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrsxDK7VzjqCzeaT2RS9CQiZCspDUeiJMc88inVGHNrvCQwoV
18138	payment	1397	1397	1678	1	1	8257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn7XARHL5Z3zPSSwXni6HHHebNPtZvP3qBxd273kAPyMypWS5
18139	payment	1397	1397	1678	1	1	8258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaYGzqeEgsiJDmjSxyQuzoHaop99H1UXkcH8bFuJE9NZzMeub
18140	payment	1397	1397	1678	1	1	8259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMFfHw5ioaeHbnpHz5y2rKkHrKvFLgs7XeCzYT2XDhcUxd2Kj
18141	payment	1726	1726	1874	1	1	7455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXT24jcE431StEaY7AvMpRDCgj9khG6HifkyS2q1KWmLxTy3qr
18142	payment	1726	1726	1874	1	1	7456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1mq8ZV1Kf76xPqCERgmX9Cs8ZYp9Y33Cm7v2uG24997C2bT5
18143	payment	1726	1726	1874	1	1	7457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nFmgZSw1NUw87jTe7k6F3wxGBKpG5w4puURkeKSG4Age89F7
18150	payment	1397	1397	1678	1	1	8263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9uH8o18mKaywDLtUgNgH5qNRCJwtc3oxoJnv3nDZtpwM6Qsd
18151	payment	1397	1397	1678	1	1	8264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU478bxuNtpsHvardy4omaZpGRChBu1HfChu8685SUMX13rF2V
18152	payment	1726	1726	1874	1	1	7461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEoLSJ6ewHC2UymB3wqdkEovVzurq3vDj6KbZfsmoSaaDoqJB
18153	payment	1726	1726	1874	1	1	7462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHS7zMu8braDLPkmYRagHa2ejYvnmEhgDP8wYubgXs4Mk5sean
18166	payment	1397	1397	1678	1	1	8271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyLe2vfv86DSgQr6SngNJ1km9yKsef9kNoqtP1Rwj37b9zKjeJ
18167	payment	1726	1726	1874	1	1	7469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgKoATiR5L9vUVwhPBrmvvRuCxB25yjdCyFYV4pWJ5uY8EqbCZ
18182	payment	1397	1397	1678	1	1	8279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9WivDycwLzgZ8HWDREftrSyvkSuWUNx3UhupC8zH6YyQqSiT
18183	payment	1726	1726	1874	1	1	7477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGABPtYHZdt9MmVjiXBxwwcYTtwKt7jJsfAGdhRkBUH8gDQ1ah
18188	payment	1397	1397	1678	1	1	8282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo1WF2ESd2N4A8X9RHrhMha1FngZ5Eof3unRqn5J3prxSkaoRr
18189	payment	1397	1397	1678	1	1	8283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmAuQ5gQ8hSRky2TmCN3TZz5VNEEwZUADF4DicZhpSMadaKn2
18190	payment	1397	1397	1678	1	1	8284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26irjc12KgUTLPksXxW987XP7gssHygjvCw3EnotZupmkjwie
18191	payment	1726	1726	1874	1	1	7480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3X2apj39TRruqCKAdoPnJAxqHGwL8CgqzSJQk1nsnkpkjFf7i
18192	payment	1726	1726	1874	1	1	7481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TQXPdJvcQCouNqpZmqXi8snRLX3LS5xXY6suhDo7MPUj3psz
18193	payment	1726	1726	1874	1	1	7482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQReasaePnG13cTGhwsF8AWUQw2LALCp273iMfoAGkm7YFnA7
18199	payment	1397	1397	1678	1	1	8287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjh1sKen86rcSW9oY7CsTC1zRjLgNvdJYqHwa4iBXhRmxRyFbX
18200	payment	1726	1726	1874	1	1	7485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFheiAkFRR7btYn2aB9zi6djyeocX5tuZ51B73nBHbvf3erG2
18220	delegation	2085	2085	1483	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAQpJngBzGUcWXLS75hcpCwuhJ1JzgXAVFss3P6eT2WKxCyZ2
18221	payment	1397	1397	1678	1	1	8296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiG6rJAsYLMKu2NWMEMFMB24BmrfMGwgm1jQAYaX7USSPKhVj
18235	payment	1397	1397	1678	1	1	8303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CjdTCVzt6sZkhF39GcRd79ujRCRy7JUF1UKdks2bp6rVvmFq
18236	payment	1726	1726	1874	1	1	7501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQVos2PGXrkTd7pRJpySEeANP1rV4iCi4ZmBM7e7BWfnuT2D8
18243	payment	1397	1397	1678	1	1	8307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3c5SDoRbVSs8CoGN48jmPWXt7eToKgPWxXm2pfTNRu9t4U4Bm
18244	payment	1726	1726	1874	1	1	7505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBQg4hmeaddDaT3epzDb6Jfj1mjP514DqTZUGavFVFragCNkn
18245	payment	1397	1397	1678	1	1	8308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3jov7K4Pene5x7iHcbaDrAweLEVPfgawNuiVd6K93mrVqF3f
18246	payment	1726	1726	1874	1	1	7506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJHLwtoaEoshKmtjSjpVfTomfWNgFpDvdkDHyaWe6zg3HbwAi
18259	payment	1397	1397	1678	1	1	8315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4VcERaZnmozUCyogWRCxYDcLJy89LaAfqR6W7XNWsMgHiJtb
18260	payment	1397	1397	1678	1	1	8316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdo4s7RGA5DXDibgbBNJhrgRGr7vtrdnNrVJBcMWZim7w3F7Ws
18261	payment	1726	1726	1874	1	1	7513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7m1eTBDaWn9jtAbZTrhT6WJ3nPhmU5vN8wanEHBKkBaqutXmo
18111	payment	1397	1397	1678	1	1	8244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSiEdFTTwj2iCvjPtsp7g9WCJeB4amomo7a7sr1G4yePLFoe9
18112	payment	1726	1726	1874	1	1	7441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5Em8s5u8YBioSntEbyG7S6jGicmT7rvQvG3NxYRyjcrjZSmV
18119	payment	1397	1397	1678	1	1	8248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHKSdT56HCXRf9R8YYPvVzWsDSUmcCBKRMXnPx8FGfBPzEaRp
18120	payment	1726	1726	1874	1	1	7445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa26e6s84K8FQ5iZ82ejEwNSooGPRxeAzVJpfvLThvDKtGwanwC
18127	payment	1397	1397	1678	1	1	8252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKFHN68JDUG9Te1bKBwfCNbqwRTarrzhmfDH1yepzWfiWaXz4
18128	payment	1726	1726	1874	1	1	7449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJiBnUjawbzLQqqjDeZkMNtT2BS9PyM6U2XGRSZBFU9Rx6cBc
18129	payment	1397	1397	1678	1	1	8253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSh1yKwH6UmqDdkFbzULfWKptzK3cqM6hZeWtqHLatYX6F2nH
18130	payment	1726	1726	1874	1	1	7450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWD2UeNHHEzEV5ZgijdJXsxKDXzeYQ9kwRTWJteafpsS2a4g8m
18136	payment	1397	1397	1678	1	1	8256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMJ8jt2563nHicNHcUna6ozZktbBgTJpetA7kHsqhuDmqRFTn
18137	payment	1726	1726	1874	1	1	7454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHuxDGKyErhW62RJuyUxe3ok3aGqYMEUnQRa7JWRpCJ7sWwFMt
18168	payment	1397	1397	1678	1	1	8272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucELk1FJeju3VNKbuQMpL4e5w3D1FnuNki6JQ5iQ3HvqVQofp
18169	payment	1726	1726	1874	1	1	7470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVmEk9mB8WmX3YXJkjdZp48D2u9sZfUHihATP1W35KNigQ882
18174	payment	1397	1397	1678	1	1	8275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRu1G4c46dDiWau2icEGJUSSjPZDADnEuy2uJMac7pwxvJc8XN
18175	payment	1726	1726	1874	1	1	7473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQucGZQafmYcADpETPewuDymbjuscMGJ3nAShySJVDyt3Gbq52
18176	payment	1397	1397	1678	1	1	8276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQ6fjdFGfS1eM9ZmEo4422x1wWsBZBiUDgunj6RuLJizHPcYW
18177	payment	1726	1726	1874	1	1	7474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtm3JXzcFcEJYspBpVAjWFy7gVBi4GbfnJR5YLHYacc1ZiqGn
18184	payment	1397	1397	1678	1	1	8280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWv8nCikn1Wv8YJ7eU1VZGeZRPu7EorkQatcuTqW8pdW8Ydy2z
18185	payment	1726	1726	1874	1	1	7478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPbxPptqMfMaKgNyHkbMZcQHdR7omSR6MNYnssQy1m6oj9Eix
18201	payment	1397	1397	1678	1	1	8288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TyvnY51sLHckMviUV5dVoaosxznAEqXJSzveJrt3kDCmGR6P
18202	payment	1726	1726	1874	1	1	7486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pWLdTSZdV2G5aTCXBDYZ3dig8TRFHRGrxZCUakSZZRhKCt67
18207	payment	1397	1397	1678	1	1	8291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYos8SexGj2wXRWPd8ps44EWH5XHpWtMVsNpHLGxtpTy7wWNZib
18208	payment	1397	1397	1678	1	1	8292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcht9Bsja4ip6GEiXuNxr5EQ66KZrxSW2NNNo3ujib9257GVs
18209	payment	2085	2085	606	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbckA1RbDtMov1s7YgVKRDzi3XKXMsy6pgeNRSXFbGXJgxd7r
18210	payment	1726	1726	1874	1	1	7489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziHaBRLi3uwog2rCDgTxsQBYDtEEHxnSGe452nqj6tpZGT9K7
18211	payment	1726	1726	1874	1	1	7490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3DDkpvdS85y8uxNQEQ4hbU4yE2k78ZBj787mAqa3JQGnbywL
18217	payment	1397	1397	1678	1	1	8295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1AoFhb7DJaoj6HT9TLWhR4bxBxR8nJynjmW9vB96aAEAfqbv
18218	delegation	1926	1926	1745	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmGtGFsMCzs6qTapEbCNFJFQ8dxc6WooDMN4r6ma22F7Mv56vU
18219	payment	1726	1726	1874	1	1	7493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeN7rFbXhzcNs4C9rTKYwrva7YcKqiMhVnxzTbWCDYaVkbAfB
18222	payment	1397	1397	1678	1	1	8297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iate8DzNu8vbxGtt8TDYwMPx1vePvhaeRVtkwizzczdRpuxy
18223	payment	1397	1397	1678	1	1	8298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU1kbMhhxWZFUzUHhj7J7QvgvGow95v6h7Y82848CfDya6f4r
18224	payment	1397	1397	1678	1	1	8299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRb5HWXx8A22ELc8cn9V4FBCoYZJDvdYwe5ZkiGF1UQorjdnn
18225	payment	1726	1726	1874	1	1	7494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vDMpe2j3xvJD7HA8vck6SBZLL55rvQ3ivawJvSNqedqaDcMf
18226	payment	1726	1726	1874	1	1	7495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtMJxuLrbhhZ63U7dnfykikiBrFax6p348sSG2TyivHPTB2mQ
18227	payment	1726	1726	1874	1	1	7496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQtGNH1ZRKp4qt86FtQCgay5p56VNkABcQnyxNG3MUewWpmcU
18228	payment	1726	1726	1874	1	1	7497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoL4d8zbdHnZBkXeEBJiNnDnwhjkFPnCkHXtATb5VVfDHbkPMW
18229	payment	1397	1397	1678	1	1	8300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfwrMar7Vti3vJ8Bh5hbj8p2sceZixM8Z6fMEvhBE8E9hAH1Kp
18230	payment	1726	1726	1874	1	1	7498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKz6Q4zht9bXpPkZfMMKioXTNGfqmLpuxTDfoSZ4GgRASeZpG
18233	payment	1397	1397	1678	1	1	8302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYST1SmS6Azj85HRnJpAKXSg1BW3DeiedBorJ82QASpRcCTXQie
18160	payment	1397	1397	1678	1	1	8269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpvnZmL2wSgCQEzzEbCJR76xcVSxSRJkDYrtYLML431jWKCPy
18161	payment	1726	1726	1874	1	1	7465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqpM1ujgY5uhBULZtPMN6m3nK5vTe8AHSCi7UQdFuTifmwJnS
18162	payment	1726	1726	1874	1	1	7466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2S9wrVBrYvF9TrqXReM8xqtaHhFTMzV8hHs4nSbbU3NpDqRP
18163	payment	1726	1726	1874	1	1	7467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa397GTX2vshJ28uCDdUq5bpYEVNhNPvz3Ss5tyVRv4FRKCqnno
18164	payment	1397	1397	1678	1	1	8270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwRMkrNoKpwFQnVTFqhtRVcHwVb6uS74VnBYxrVEeRWZjNRTC
18165	payment	1726	1726	1874	1	1	7468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPTeeqLBPuJvBM8QPRhCePpJzTkZgemtkRoD81jWH7gXNQcUq
18170	payment	1397	1397	1678	1	1	8273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CABodF1uiJmgzEKDB1rK1TNTiTrZZxFFWhcrNRAY5wjLe7sD
18171	payment	1397	1397	1678	1	1	8274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYGQ9MHc1LuKqC2uuvoYDWNZEPDNNqqQq4MwyvpBmXmnVw2jR
18172	payment	1726	1726	1874	1	1	7471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbowXULBRTQpkpx2tHXxhpim654SMm6ZnD6CtGi62E6yXKhh2p
18173	payment	1726	1726	1874	1	1	7472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8fniVPMh65u8MG11T9vQ3Bg2EnhV24x84H23FT9asy6nFbdx
18178	payment	1397	1397	1678	1	1	8277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLJhXmDhjUd4wb92tdmYokLzk2i8AFBmmktvkb9mH1W399FCn
18179	payment	1397	1397	1678	1	1	8278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcE5rwNV1o9QJrrZQ1W7SutgAv1h7h2DHUokJsHybiRnYN7SwP
18180	payment	1726	1726	1874	1	1	7475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugfGk8VFbUW3ArDQ8QamwKHmMpr9EqHAZxyU422NT8JaxoL42
18181	payment	1726	1726	1874	1	1	7476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfRXWYtEAHXV9Xo6bQCEK2QXPGMwbUTEPfF7z3VvbFxDkwKqN
18186	payment	1397	1397	1678	1	1	8281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRp4HxozmqqgcVZbxgVAVHVsZFQ8XFfnSc91yDkSTDisHsNq3
18187	payment	1726	1726	1874	1	1	7479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpzXTcqUFxqj4aTLXuXqcRm6CKbmbTkYTWdBxjyXBRv1ee9ha
18194	payment	1397	1397	1678	1	1	8285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3yiL5gUXheaQRRKNcRCgvK1bEGQxLQiytrHENFM9HzZYJcmm
18195	payment	1726	1726	1874	1	1	7483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGejmjQK3aUMLDThVQW5YnUjehp8oZvpCm1vpSntegCuR9xBUA
18212	payment	1397	1397	1678	1	1	8293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJLB6KCaVFwhp8uaxZFTspWygLrNzBedwsTZvY9Z4hQeGLnK9
18213	payment	1726	1726	1874	1	1	7491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqa7gjeEyuJZDs3LqUu8MXnsqBZYhitdb5CeQd5FU9ynW6KXT
18214	payment	1397	1397	1678	1	1	8294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdgZ3gV6Ydh7JzxrehjrvFbqfR5TphdSWCSM5oKQC4D1VVJJQ
18215	payment	606	606	2085	1	1	11	1100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKYEKFRQstjRTEAPxLjwZXcr2mwKsqSiieMN93Nko2AkAWRoC
18216	payment	1726	1726	1874	1	1	7492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRCtfqgumWhHwEh6jcYFQiof6XuBEgPxMSyrQXMnms9ngYpfx
18231	payment	1397	1397	1678	1	1	8301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQnDXSCZ2VyQRNEubmbuzukma4ZYyouhZrwapqTcGDAJoCeaj
18232	payment	1726	1726	1874	1	1	7499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UdAebyETzvRgs5QcaGHUFHvCmQ151aBXRRtcUnKnTsf3cUjM
18237	payment	1397	1397	1678	1	1	8304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxPAPRPeN56Np8fs7DxBm4Gx5ZXRsFXV3NFaYgdy9y2nJ372b
18238	payment	1397	1397	1678	1	1	8305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofLCEGkHLczcSjieYq8YHPeC9yTJ9HPCxJKG7nbjiexJzjKTx
18239	payment	1726	1726	1874	1	1	7502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9bUR4omQD6XRetyCaD61g3tVmgb6LFTvaJiquauNvNcFL6tt
18240	payment	1726	1726	1874	1	1	7503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8A6VjW6ZvHPH2e8viLjcDp2iuebF2Kq2d5n9dpda87L5iMZC
18251	payment	1397	1397	1678	1	1	8311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkg6AvoXsciEKNNZqtckkVsmjXvrZ1jUvtxqRNWyQCp5euAy7J
18252	payment	1397	1397	1678	1	1	8312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYvxzNrHKXtoUGGusQc9yeo937Hmj4CLnjKbGwqPCvkKH2Lmx
18253	payment	1397	1397	1678	1	1	8313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUEsKtwuzkNfEGAEHBfJwkfhagDgFwzBWUcoTDGwowF7V8ycT
18254	payment	1726	1726	1874	1	1	7509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBasbpdNYZS9Qx69PHi5uTA5jA5WhzaaHY8MfQK71pqenkSZbp
18255	payment	1726	1726	1874	1	1	7510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd4FZMqLdexWNJ1QVwuHqr5FrJmrypNic4KsRYGQE4Rg11MMSv
18256	payment	1726	1726	1874	1	1	7511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaBb7w36ESYCZb8qAC5sLD5fKXh8XdLKuBVAWprkk2mFfjxEx
18263	payment	1726	1726	1874	1	1	7515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcpoo7tHRM13N2z3qBeFiSfgeW8dEtZPY5Vuh5tj6Wa9GUtE9
18282	payment	1397	1397	1678	1	1	8326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAag4ottjQYM1Evd8ioWE6V7BxdxhpXeTxwo9pE3bUC9yzhoGe
18283	payment	1726	1726	1874	1	1	7524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkfGLhqD1S4MNF9ruS4DkM25mRB6XpeLjiJVW48nm4f5n3KBY
18196	payment	1397	1397	1678	1	1	8286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FeefFa75nBWShpWuSSdQkWJGd72tveXc5jzschuEET33B8RY
18197	delegation	341	341	532	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcwq7k7WnLiLJ6GJAW26mfDKXncPw4nE7yLQiKpMaNnatg8K4
18198	payment	1726	1726	1874	1	1	7484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoDVAbF5WTpcZPgSsDtZCQuuNmULTJiFigH83umQJPoV67VYa
18203	payment	1397	1397	1678	1	1	8289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU48unJ1y9veCkRY1poxVbLNhAwZUhrdJKEDJRLCCH61Bhz3fD
18204	payment	1397	1397	1678	1	1	8290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxUDLLZLaCM8GUrkV9THeSKu9ZxXcGFvCn6j9kGo7hCz741kV
18205	payment	1726	1726	1874	1	1	7487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGydgPiG9ogM5uEBCPPrA3STj6p1iNKTUiGXmjAXxbG2nrgW3W
18206	payment	1726	1726	1874	1	1	7488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarrFYrEomB24pbCXHnAB6AekBRVgiaAyjg14zJiv6vVjDgTe3
18264	payment	1397	1397	1678	1	1	8317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YxtEaK1ycnsub85ieGT1XARud7csCDsuE34QZ9eCpZkG57a7
18277	payment	1397	1397	1678	1	1	8324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7s1qN7NZZBRbdcXxYXPwDUBh6KbrXsc1JVz7AK34opPWN5oj
18278	payment	1726	1726	1874	1	1	7522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCakdXMsmCeEQMVqDRp5bsD8PppgkqtYYatJQDo7DK9NPJhWi
18279	payment	1970	1970	2114	1	1	0	100000000	1000000	\N	E4YXdVUAfyak3PB79YwmjnS3rTmv2hnNrRBzPFVWK9jsHuj9Q78Nj	CkpZiTNRbkdJGwyAecTYX8hgeSeEnwbgenpYb8NV5Y7REcxwSydH8
18292	payment	1397	1397	1678	1	1	8331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBEdCoWienkdMyuu5LkRvMKQ23GBhWfV7fyN6UjAiS1xQYUqN
18293	payment	1726	1726	1874	1	1	7529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZBLZDmYCW6eyeS1hUrT6vAkrb1KS74p2hPRYuWKMWA9F9QoN
18294	payment	1397	1397	1678	1	1	8332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjnPjherZcg3yYPC5JcUk4KuD3qmsvxW8w6kXUKN7SkH9tsqT
18295	payment	1726	1726	1874	1	1	7530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEE1mdRVaFUSxFXJ8XTP5RJCd5HxzVPJM39jAwBdBQWj3Vdmj
18296	payment	1397	1397	1678	1	1	8333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDomX58G2a5QZTbvuYLfi5umXoFgzZzRJPojAtoN6c9cgicwJH
18297	payment	1397	1397	1678	1	1	8334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQbW2CBMpVXYdVvUnUcNbAam5NriQDdZ5LYwUi4YpDwUNLwyv
18298	payment	1397	1397	1678	1	1	8335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJKgESPqYUztV2W7CQjidnjfFMNtUMnxTGP1Sb3qEd4vwX778
18299	payment	1397	1397	1678	1	1	8336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSn4HvHTBsj2T1kJ7pmASAkwHuTXsp8CQTqQ2PJpVQVPb2yaP
18300	payment	1726	1726	1874	1	1	7531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZboiRHMDN4hpJ2db2iDToX3eYEFHdicAkc7TuvXK4EgCyh4uMU
18301	payment	1726	1726	1874	1	1	7532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGmY9uTuvaXzQYF3L85Bdge6vpCMtabT8jr181RaaVEjra1HH
18302	payment	1726	1726	1874	1	1	7533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvPJof9fNBFFrfS5uYaNCtGuAm32WRX8Q7EhaV57CzeHcj3EM
18303	payment	1726	1726	1874	1	1	7534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLk7pZL45t1xnm6CNFHvYzmjawtrSRKHXatJpt47LLhtq2T3Xb
18306	payment	1397	1397	1678	1	1	8338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH9TrJbPEgwEdZRHFWbyymReodJxU9MbfRinJnFrNsh7jtp5M
18307	payment	1726	1726	1874	1	1	7536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeypV5Qx9x7oQ7Keykn8eYBwNGtgRyUQm65XjibsFk6pGRGYk
18319	payment	1397	1397	1678	1	1	8344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3KjEDFszbYrumnQ5LpWHk734RmwQiHzUuWmNrio46P178mno
18320	payment	1726	1726	1874	1	1	7542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYfnpMgcKGA5fBr5w6QYchvCXGbUnxzSxFBK5abjWGNFZauXs
18328	payment	1397	1397	1678	1	1	8347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA79y4oACH74i3rarLKgLsq26SPAKC7NgZAm2RzJX27F1cndPv
18329	payment	1726	1726	1874	1	1	7547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65DPEqgYE5mqxNTiw4Q67ABF4575PjerKsytDPGnTWx97hbQ4
18330	payment	1726	1726	1874	1	1	7548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBTTMLc8GE1wZXvC9vYNKVrxcUkYzUEdtPwj59kU3JUmhuzLU
18331	payment	1726	1726	1874	1	1	7549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvCXZh2T6pdWofkbLTWm2SCvmqSc3wjBucx5obf7SJU9kjTLR
18344	payment	1397	1397	1678	1	1	8351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDmo3joXSMfZiX829p5czKkCLxNPUTfA9qSorHeoQHo5XkFhV
18345	payment	1726	1726	1874	1	1	7559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9LbGwheFfeypCvNFhzSrZWL1epxUP6YgfA2tM7M9gvj2Kkkw
18346	payment	395	395	1760	1	1	1	500010000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNgo93k9ko48ctgrUT4jRdbLjwp4hY6vALZNMDsruPAAo26Tz
18347	payment	1726	1726	1874	1	1	7560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRhKjNBVqLMbFnm5As5NPEcPhijWyd2jgWGn6mqbo4ZArDDV1
18348	payment	1726	1726	1874	1	1	7561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZ8v6bf1QKivcjJK88cBkRiSHv6ebKdiWoY4P9SSXYCe35Qo8
18352	payment	1726	1726	1874	1	1	7564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYQXYTBkFGBq8chytJHy3NA44gbDCsoQouZRXYLGxpGQ4MGbK
18353	payment	1726	1726	1874	1	1	7565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfUSywgy8ubLm3GsRNotbvDiDTmbauoYMLqqS2w3cSdJrf51J
18234	payment	1726	1726	1874	1	1	7500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2NMmRFQUha4UuvoT86h2eusYh7qXfUFsvTkoL5CyaoaAbeYZ
18241	payment	1397	1397	1678	1	1	8306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7J76yB9coLmmvQFuZEQGaGoFYUXF9g3iXTLwKdy9629gAvRn
18242	payment	1726	1726	1874	1	1	7504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AsjjwGP5zwMie26Hc6r5Z4YTr3tcpoFtJkywystHEx3owYqm
18247	payment	1397	1397	1678	1	1	8309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoeNni2xYBg8ZvoknJ1CvMWhfprAzizjGi8ZzNUhyv8aCfydc
18248	payment	1397	1397	1678	1	1	8310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgNUBBPaefsejzYVJcqeK7XxKCSxC39qyhpHufJAvzmpT2y4k
18249	payment	1726	1726	1874	1	1	7507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rC5LrDFtN4oyDPQeviQMX83vTeh1ovtsh6cb63VVk43eZkvi
18250	payment	1726	1726	1874	1	1	7508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3u5YgAe5HACssYJm7X364FGJaHKyGrptkcVhxeFmmpo7F5TDR
18257	payment	1397	1397	1678	1	1	8314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjiDLDvqDFn5qAMp6XPmXLTV2kRoFMxviLNcHVYNTNyJnQ51C
18258	payment	1726	1726	1874	1	1	7512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBHUbJ7FGwEbttQ6xqFP2eVyjzgXEVinAinihJgnGkMkPwpwp
18265	payment	1397	1397	1678	1	1	8318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtbVsGB8qyfayGwXVTrBrZnt2UDJtvSfswXrB9bPNY8FJPNCaB
18266	payment	1726	1726	1874	1	1	7516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KZUcbag6GXjs4KjCqJiQUhkYPHqqDf3EenJ1kBMXDxibYv4U
18280	payment	1397	1397	1678	1	1	8325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyKsDGb9JtMYqoKf9G1ma9cRpZU88t5TNTha2t2GULf3BE8PB
18281	payment	1726	1726	1874	1	1	7523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZem3QiS4m4TsBVWqHiSFcPEYt2ggZicMMJocH9sw2e42bkhPbh
18310	payment	1397	1397	1678	1	1	8340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnoWXFoQWF2Mpbrfh1wRWfGWdarc29sAMAiCCmZ93MLrhU5Cf
18311	payment	1726	1726	1874	1	1	7538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYiTajpT949dLRibJRtrowD5X7E2Haiymk3MXPvy85jbKQkdW
18364	payment	1397	1397	1678	1	1	8353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1HvND3BMUV7sL6sysJvuA8vYZPN8cHPtkLTRW8Hv7G87LBz1
18365	payment	1397	1397	1678	1	1	8354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AabrEqVLA659EwpbPyz4HUC9UBefwNvKobsdgTYN9LLgoGHq
18366	payment	1397	1397	1678	1	1	8355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvKJ3Kgk3Du89MkBUtEZZvxDRJcykpFi97Fspp3eZx5tcHhXk
18367	payment	1397	1397	1678	1	1	8356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm63p77AGZaLabtzcUrShUCENjSWe2CBSX4CqnewgdGybZ6Ls
18368	payment	1397	1397	1678	1	1	8357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbmVGNT24hh9t1UCnrTWTcG7Y5bWr9wUqP792jPxwnM9vqJxX
18369	payment	1397	1397	1678	1	1	8358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn7B6LHHUUBSDRPvUnwaCiZdry8gyoG5sKfr3tFshpTdsPhom
18370	payment	1726	1726	1874	1	1	7576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShEoyNpPh5i7hNuoAhi3C6gSJYgm1oty9kxPDEPpxDFzFuxJZ
18371	payment	1726	1726	1874	1	1	7577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CabvXhxifCTu9ZwvWi5uv7dcE9CXmMbUUHFkUb5R81GXnSqd
18372	payment	1726	1726	1874	1	1	7578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrjdWtFv31h7MYcrC8ec8fyhQeg5c97R2aA186rJU1d7Xw1PH
18373	payment	1726	1726	1874	1	1	7579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJucrsaN6RxNaQWNqiJpH2nbqF2nABCnbeGn6RphMY8qnfw7Q
18374	payment	1726	1726	1874	1	1	7580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbnmEeV1GE2QYSXb7c6urcTvFhoboicJe5UMUEJqhbtqAUP7G
18375	payment	1726	1726	1874	1	1	7581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NGtoXx1WWkQQfRecphxciMTth5AjamL2xtHT8xtFqAED3njw
18400	payment	1397	1397	1678	1	1	8365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwrvsFatyNY9y1XNu6uMujFhLGrL6paaMsMBDgDFFDvKhKeBVY
18401	payment	1726	1726	1874	1	1	7600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeXZrGvbYnQGzQfYqVqtpxnnSionsHKuMTm1RE9QEQsxwSkTu
18402	payment	1726	1726	1874	1	1	7601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdL21B8X1nygfbUTCGAUoFNLuU9m9SRD32X1ZoGBJiy58jD5i
18412	payment	1397	1397	1678	1	1	8369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9m9HeJjw6KRVVKVKTaoEXnVgWYFKBUaWhgTvr9ZsW1VWrmmvw
18413	payment	1726	1726	1874	1	1	7608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbJY7TCZux4RwoxVnde5QrAcrSQaPcgGeWrGN8yd4Mswy76Zx
18445	payment	1397	1397	1678	1	1	8381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiWXfqVSwhaFMZDoVe3bSskg39SwTETZLnvRqtvdfev9uXraV
18446	delegation	2114	2114	1970	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8ifv1DxELpp4xPz7gT5SQP1TEdQZ4RJHWeJ2UfrfnFKWWTri
18447	payment	1726	1726	1874	1	1	7629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTWWzWT93FqZ9DvAjF9L7zmquQkjM7Ssevz9xPTvysRHDLTgp
18448	payment	1397	1397	1678	1	1	8382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLP7AF3qi1zL1aBqmCjBmcaAcib6xz17DuN6ong58KSp9M1Msh
18454	payment	1397	1397	1678	1	1	8385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTaC7bigMbKEFX3WuMLqYhJQbnuychR8RkbLrc9VeYM1EaKQQ
18455	payment	1726	1726	1874	1	1	7633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezTwHJPNuaF3YmW8A7wxAYCkUAt8tbMDdyhx8eshg8rCGqypf
18262	payment	1726	1726	1874	1	1	7514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8M4o7UdsvNy55jC1VcTRZD4Zhgw8WCqqQ2nVd2vj4KijpkSbr
18267	payment	1397	1397	1678	1	1	8319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XfHYnQ5EWttaYqE94tscBS3HTKARmQaNDmB32s2ztLRozvbV
18268	payment	1726	1726	1874	1	1	7517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ342i1FJjYipD6uXyDQNXo6eu2H6ZsEPogTeSx2MsrdtM3vHCR
18269	payment	1397	1397	1678	1	1	8320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSerktMjKtxdRdgtQnLErDTvWsaFqo4a3oCsQWfw1Nn2oXb5A
18270	payment	1397	1397	1678	1	1	8321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFfRF6NUFXRpjiJGJwxmSp5zmrQCgnkThrJprHxZoQwZBN1C9
18271	payment	1397	1397	1678	1	1	8322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHiYCy5g7qMvxwpRL5fJXHANzgL4LBJ2JKTi8WZ6YdQPadn2q
18272	payment	1397	1397	1678	1	1	8323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdj9Qos4yetTLzWue7bb1btf7zDvpUtVXLH9h5CTF4UFn319ty
18273	payment	1726	1726	1874	1	1	7518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtraWRoaD1eHAhnFpxAW2zHQVG5Shn3HTd7VCczvoczwZpr2Wd
18274	payment	1726	1726	1874	1	1	7519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Dk29JXwCaweDPSu5HnwFwsKuUEX7TsaZY66szbW9KbaTcasR
18275	payment	1726	1726	1874	1	1	7520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SFAHMgHewdYGGrtZ96YnoT1ZQtuvFcnshBUeJdfBnEbak3je
18276	payment	1726	1726	1874	1	1	7521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifsV1c4AFmGizjpFvFEpT7353sy5yM9xXEpoTWTcxxQ8FzLVz
18332	payment	1397	1397	1678	1	1	8348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyw2eRw45MQJs9WNcizm9eBZ6htFZfKfi6rr6cP9sUFkVx3aB
18333	payment	1726	1726	1874	1	1	7550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrJ8kX5vBMa1T59JaGPXsiXboZw358M9LDYkqD6Qp19W2CD2L
18334	payment	1726	1726	1874	1	1	7551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpQJHHpPEgqCmHurCLRBPVauDAAZre7XmTMQESfnVu6GX5gEK
18349	payment	1397	1397	1678	1	1	8352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4qFBkP6ZYGHv2vKL6ZWBhG1hxMFdFbtup2PPg1JnF6TWpqWJ
18350	payment	1726	1726	1874	1	1	7562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayJTHQJ5ga5eQ8SYtmViEdJ34eHSYra7WEm1nM6gsVatDKWVx
18351	payment	1726	1726	1874	1	1	7563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCszZdrMhsnQutFL4mpwGBzLDmHUyLmSD7Bz6FwvPCNWpUu9p
18376	payment	1397	1397	1678	1	1	8359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwALjLxtuYF6dJE6j4oYYXRTpAvsKH6mYNABtzeXhELRZ4YaX6
18377	payment	1726	1726	1874	1	1	7582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdUQowpMa5DX9Mw3TN7Kkm8kB1YNwBcCGzB3Dac1BWVwfH4Ea
18378	payment	1726	1726	1874	1	1	7583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWPvCWT3H8f2cNE9CNEnwpqp2trvYRSykYB31fNQHHK8dZFmn
18379	payment	1726	1726	1874	1	1	7584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58wB3xrVHB5LCGv5MhdkNPk8XXNZtqeyKE3dXUv4hcDV73Fs4
18418	payment	1397	1397	1678	1	1	8371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMDZMWtsFKEUfasoz7erpRuS3X2BKgT9XpqkxRd6UzVaMY6qZ
18419	payment	1726	1726	1874	1	1	7612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZage7m59w92RapUFaAccFXzqUgFeJVW33fQu9c3wPPvxMadDW
18420	payment	1726	1726	1874	1	1	7613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGCEZCBf1wrWWuMofmTBJtyv8z4nRfn5swJD8pyeT1SETiciR
18421	payment	1726	1726	1874	1	1	7614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLg5JCkASsmZgWftcrdUhZ5SSKpEd1ZN41HSuagyMHksX6T4j
18449	payment	1397	1397	1678	1	1	8383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XdepvFRMMY27t39QtfNG4xdhTuQXUjotKCBuFg4PSE5eqPLe
18450	payment	1726	1726	1874	1	1	7630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXZKcBDZeTa3ibWTTi2akzsLHeDqD281VY5HJxssD1qk9Mr8G
18451	payment	1726	1726	1874	1	1	7631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzizZbXJMtkBq3jLJUSLgebjch7oGJQf3XaETmJpgrFLSvFc4
18506	payment	1397	1397	1678	1	1	8408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehyWsLAgAQPZS1nEd1oZxWia4iXGgp42YQJWjPA5UbXNUf2y8
18507	payment	1726	1726	1874	1	1	7662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVKc2hFtxCZ9h7vbCBB2eZtT6AVFVb4BsERW9fbADPKxkRxMB
18508	payment	1726	1726	1874	1	1	7663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBX3VgN1NEqdJeyHnNhajwJpW4zTJSzxm4pwdphZSLJ1ixjYG
18513	payment	1397	1397	1678	1	1	8411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZquqdnK9Tqf9e6soD9PUhyA1x2Ms8iyMWADGYL8LsX1GPcHi
18514	payment	1726	1726	1874	1	1	7666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdz5WWNcaiRJ2ftd1FWGS5BC1Y8hmHt2Gcd4xAQqKyoSey47Rs
18515	payment	1726	1726	1874	1	1	7667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtbkcYksnJVsmE3qmRNZC3rZFqKBjuGEmgDMN986Ln6a43pDH
18524	payment	1397	1397	1678	1	1	8415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpY7DG5fCTy2F4ZgMMffbj3xWAfgPn776tk1YeRzB1fjZYBMz
18525	payment	1726	1726	1874	1	1	7673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRC7KCGoijXCz9ix9LYSWsUQpY8LCh76pVP8yg1oMwToVMbauv
18526	payment	1397	1397	1678	1	1	8416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmV8zNssHyGsEM3fFvdAdMt31BCXajzXuumW9puzZvdTrNaYYL
18527	payment	1726	1726	1874	1	1	7674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrZSRHJRMCxSQgPksFs54AWB9vr1zASUMs8DGiJgh84gT9xor
18284	payment	1397	1397	1678	1	1	8327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7cjpwZiwi5PPXBZcz7U92TALC2vByyqmtKhNkXB2kRovkzE1
18285	payment	1397	1397	1678	1	1	8328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjBmRJHqoZutVrKLVQmGyXDzsr3ZQgaQs4bjZ8ZiiTzTDbJyg
18286	payment	1397	1397	1678	1	1	8329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjr9RmkZZH8TUD9L3pVvks5d3auPsZRDwhxoNA8C7gt26koVG
18287	payment	1726	1726	1874	1	1	7525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvrpiR1UBiVPnP8zK7osytddMRYzyqtTX46m3urmUMFK6xnpR
18288	payment	1726	1726	1874	1	1	7526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruJTEx7TUFePJhmjmDHpcEnWaJqCxC5RRzQKsxakWzjiofCrR
18289	payment	1726	1726	1874	1	1	7527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgdFpMCiRuysnyVP2zDejaJw5whFFsv18yDhvCUQayXU1hEoQ
18290	payment	1397	1397	1678	1	1	8330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTjswCTdEHxgEteVADmzdwDXDucgFHfYLjtUr9kQKfYN4Qcej
18291	payment	1726	1726	1874	1	1	7528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaeGFJRMCN1ouQbrmTALYnZEUYxtAHfAtApC4mo9XNFTdUxjf
18304	payment	1397	1397	1678	1	1	8337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8A5wvAJWoxhg3nBKjpAnstTRA9VsAcoGh22G8mtasojQPULJW
18305	payment	1726	1726	1874	1	1	7535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyGGWQaaos5tv6VPMtPqZwcKEstaB4EfnkNo5sYTVMKUNqeQ8
18308	payment	1397	1397	1678	1	1	8339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsff1HseFf9QQAxDZP2XfZvVLZC9sXLwhuH3JGTktLPZbvmPg
18309	payment	1726	1726	1874	1	1	7537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXZWDN8qWLrdtkFr7MMujnDnZWqvZ85P4RRA2Ba9tSEzixPzB
18312	payment	1705	1705	2115	1	1	18	2000000000	20000000	\N	E4YdNRyrfKF6tz4UgQhdLmQQGXbEZe3sgWksofaqmhFRoJ9d8CTVp	CkpaFxupCRgxmqyr58ajkQCpY1oR4SHSftWVfCibWMB6uoWCs4Ymn
18313	payment	1397	1397	1678	1	1	8341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11b8Z9uyFWK2n3QWB1FF3U5fJ4XhFTA2LiPU2DHqunDEvWpR6
18314	payment	1397	1397	1678	1	1	8342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3fFe8ErPkhxm19tsg4zsBoqxbdnetLda6odN5FEWJm9AHLTr
18315	payment	1397	1397	1678	1	1	8343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjaZm9zZqwrCbaTTN3d3YY8ULAJrasXRURDR9j1LrqMMPWcCw
18316	payment	1726	1726	1874	1	1	7539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodxwxKNTZ754RZo7NR1NmGy7FH8V9tPgVQdT9p2DP3TLkaXgK
18317	payment	1726	1726	1874	1	1	7540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQw3YmAyM9PfiWBZUyFa6k45DLaAv9Qf7a9ufFcJjsWpWYyiBT
18318	payment	1726	1726	1874	1	1	7541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjUgLxpwwtVHADXBNdj9KYfk9VUDSsA4sj7qxrhW7aHXMyFVa
18321	payment	1397	1397	1678	1	1	8345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB4rYTBaZCFvBqrJW1NXZDTVGVwwB6XHV68uq4owtL3dpFPR8
18322	payment	1397	1397	1678	1	1	8346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQyVeyJ26mCDU6fgi6MLCLAZ5HRDNvTxXELdQ7MAD8iqVkrvT
18323	payment	1726	1726	1874	1	1	7543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWY8gkJ37r7pduCMRexsSnsgnNbZuaLt2FVZ695XAod1REj1pr
18324	payment	1726	1726	1874	1	1	7544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgjD9adHWHVcLRVejgCH1j42aafVC8TMcJtcQyF8AfZhU4x4Nn
18325	payment	1726	1726	1874	1	1	7545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiwPQN2Ui4F3hW69a4fftTLCy6sn5AXFd2Js6B83XapmeLTAc
18326	delegation	1950	1950	1483	1	1	13	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTKaaTsUeZrHhMDDWAH1GqYVMBfgsRpz4uJ1Voh43Dk3jCCdJ
18327	payment	1726	1726	1874	1	1	7546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4L8BLHU99z8rN8SnXjshZgwisAa2EUC34dDyCyEDUytEzQyNm
18335	payment	1726	1726	2114	1	1	7552	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfekDvP9S4di2evUazHYjSNPKZ481zT2kxWqbA4dkMapkkHt92
18336	payment	1726	1726	2116	1	1	7553	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYWHoGJitJWPhjrTPTeoaFr9Ckoae28c8RNTxjkkLVY6o35yCSw
18337	payment	1397	1397	1678	1	1	8349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFrpLx5QcLugpYMtwG6VfGrGG8uaJB9pVo3ZyRzov3zEoMLgk
18338	payment	1397	1397	1678	1	1	8350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgAmPUThpUWFWtfpTPBWyZCLCPdAoaYviA2KK94npKmTpG1pD
18339	payment	1726	1726	1874	1	1	7554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbaYo59jQyHr6t4FfamBamdERMeMxBZegfCZ6pExQP1nRuxj5
18340	payment	1726	1726	2114	1	1	7555	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpjHb5myjjiifpJxNNwis8YP7NKcHJrd9zXvmjbjAZuYrtcSDt
18341	payment	1726	1726	1874	1	1	7556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAdyUU4nM2Mr3YPHeYHmzVkfUHWEmNrTLuTRk2v5JjofyVj2U
18342	payment	1726	1726	1874	1	1	7557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtGbJ2tWg8AWFrca7nCLxm122DidD69nwhDMCVMi8X8B3hSaq
18343	payment	1726	1726	1874	1	1	7558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXUafp5HWH6WrenhkwDfD5PnszHoH28RBgsZ52MLWxT2LcvNM
18384	payment	1397	1397	1678	1	1	8361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFi2pAdPx9AkoL36tbbkQp2GWAGkaxnr37Akds8R4ZydPQqC9g
18385	payment	1726	1726	1874	1	1	7588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ112wSiBeiBcE6JiQCbSbxWxavdvSZXFhyWYQ8CAnQdMn42WAh
18386	payment	1726	1726	1874	1	1	7589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMh9GBKNjPGYGC7xw4ZLLhrs2vi2M2KNU3VGa1S2nhtfiRLxN
18354	payment	1726	1726	1874	1	1	7566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4RsKs1v4U6pFrSJy4xvYVhrhXVw3fXE3PyWqtQgtYbAaY4jh
18355	payment	1726	1726	1874	1	1	7567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iJXUz4c3MhCR7NG2PitbSoMahLmbBUjCbqs9gZTFfqXKsxpE
18356	payment	1726	1726	1874	1	1	7568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7zyQBLQJkksLTksxa4ugjs5rnF8wzQ7gjrV52BX8EwdiQHbz
18357	payment	1726	1726	1874	1	1	7569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvGNc4Dp4vAd7DD3TUeWKTH1U4nFUWyhSQs491JK8Z3kPBU6d
18358	payment	1726	1726	1874	1	1	7570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX178crduxYRbKLo67zXZV79JS7gR7b6qdw8rp2MoydxBKJDP
18359	payment	1726	1726	1874	1	1	7571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3qxooPSfDMwAMbfaaUumnN6GmdktZ9zm9kZCgxEfXSPXiKJ2
18360	payment	1726	1726	1874	1	1	7572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2cofwU2DHq2eMy66Vdhk88SAwPHoKv4ywoRi8HwEXpEYGMid
18361	payment	1726	1726	1874	1	1	7573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaqjrApimvyuyTA9eNneQ3iuM4dUcQwGz3yqLvDA6CTVs1Mis
18362	payment	1726	1726	1874	1	1	7574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtojN1yEeAU9nC3cL7uSJAnKTXUAJZb8u1d7raZhoYpvntCMca
18363	payment	1726	1726	1874	1	1	7575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Sc4NnG9edya7tjPyC6rvK4kVyJAiBnyM65x7qu93NyN9emN
18380	payment	1397	1397	1678	1	1	8360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJstAVawg2hGwJDWwQHKyrovNNFNHjUWhw4FnrKSLTmVmkzW8
18381	payment	1726	1726	1874	1	1	7585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jJkuon3jc2oZL8Bc1D5Ahxk2oxf8jJQdsFonsGgXuxUidpN6
18382	payment	1726	1726	1874	1	1	7586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWkEgCYA12ZwnG1rCMNpVU441L3tqnXYu95JnhR7AoiGMqcXnV
18383	payment	1726	1726	1874	1	1	7587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4MbtJGU6sST1v1rxYrsKevwDsDqrdiDwMJFwVEzP8fsoB7aV
18388	payment	1397	1397	1678	1	1	8362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNu36t1TJTjQMVk9AfnBzpPSRJZ25q5NAJTkNpH6Z3jCwCnstQ
18389	payment	1397	1397	1678	1	1	8363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qYW3ckEKMmnYBp8Yboh1iwDs3wJM45Vv1jGuMQzzcYxv1xNm
18390	payment	1726	1726	1874	1	1	7591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPLEdVJXufcV9p6XPMcAksVp7jnBxovVFiwKstjLxWpDHTYXQ
18391	payment	1726	1726	1874	1	1	7592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjVsYqHd6SiMuWYCdr2oKZvDVoakyw3SdCUQnCJnWccnpAUaF
18392	payment	1726	1726	1874	1	1	7593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97Mc5dtFpBXJ7UVqgpDuC68PAPxvqR2QtFmR5uEZxCyvxovXj
18393	payment	1726	1726	1874	1	1	7594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkW5Kur2e8NDpt9W1k6gQXc5bHLcYHLNjDLmWmeEJ5ZXVyBPUM
18394	payment	1726	1726	1874	1	1	7595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZBMa64jCYZKko5tJPG7c2gbGRozenAdcYNqeFGLHubtmhJLT
18395	payment	1726	1726	1874	1	1	7596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqKHcfunizLSZFAUTEJw96ci89V8Ko2UycxCfU3acenG6yp988
18405	payment	1397	1397	1678	1	1	8367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWdSTEEXUt3NxRgGod5XCwNGwPCAC3p7hTHuWCxC7QZWjMtHn
18406	payment	1726	1726	1874	1	1	7603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1goiqbF6Caod4sNQG7e1nRpPijRpYkuLuTaM2ChcEobfpEefX
18407	payment	1726	1726	1874	1	1	7604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDGsQiQcsMUg6jc8bfYj5yX4HFLLGW3q1ZfU5njUMSykywc89
18408	payment	1726	1726	1874	1	1	7605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpTYfTVSKXbL6EuwsUWbZpNFyedgzoTwZv676kfogNkgMDxRt
18409	payment	1397	1397	1678	1	1	8368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mtrY4i22ptLjik7zK2hiquvVdzCqisSjYSyiJkhCZR7kwXye
18410	payment	1726	1726	1874	1	1	7606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACmkQGcW62ozxkQcdUCgYKiWsdPiBpDZCgk39fctXQo3JcmoP
18411	payment	1726	1726	1874	1	1	7607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRpue3dS6ESsdZFi8Rik2tJb7SSrRrbTt32EFPypT78bHBQ2t
18422	payment	1397	1397	1678	1	1	8372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND9Q7Q1r4F92SsMHPC4iWUgoUzbdPJBhAAePkNJhfdSzUXHmW
18423	payment	1726	1726	1874	1	1	7615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRpVadCcerVkYPAiVkMyWxWi8wUMG2hoU24ykY8K2UuZSiKwU
18424	payment	1726	1726	2117	1	1	7616	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2iRfpDDyHqfhRfs9gTTQ9TgtSQMFFcxPwanvKwqnsU4bKDA6F
18425	payment	1726	1726	1874	1	1	7617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXjgRVfncfJENcR1uKskfez5TvpndHG8LpuVSPPNDb1P85JXh
18440	payment	1397	1397	1678	1	1	8379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKnLbuMPrRmK27WcmBs1GoCvhF5iWE4tzCsgFeKVXvfgovfBP2
18441	payment	1726	1726	1874	1	1	7626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsKfzmkYPXnorr61bbo9eDGBq2567Vt994yhUegTKtvYSpjTL
18442	payment	1397	1397	1678	1	1	8380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y1Dd97gwQgWpErFMzmqf44BQWYSty45Q11QUxTGP1fzE6Hnd
18443	payment	1726	1726	1874	1	1	7627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfiYaT1d42iP1XgB7MRqvuHSawRAPMeJn28zxiwJqLL1LnuCu
18444	payment	1726	1726	1874	1	1	7628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkaLrdvEbxxU7uzGDMtn2FduftwDVe8hQkgH2vCgyANTG3cj1W
18387	payment	1726	1726	1874	1	1	7590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4ig2g9JZf588LH988bRMaqKsiLu9YtjBtYcK2yVkNWGUcsSn
18396	payment	1397	1397	1678	1	1	8364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSuxAqPeF6nK2rLgcmXTotgYuNdFyYxd3Q9NLhigGNYAUpd8M
18397	payment	1726	1726	1874	1	1	7597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFUA3C8FAVLNcf9pu8P5JFLvpZfEw6nfuZxbLUYNoGJ3h7heN
18398	payment	1726	1726	1874	1	1	7598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBsEeZCrgKxCeMrEMaiAxvySDNFwpKp71wkLBftkYPPvrpeK2
18399	payment	1726	1726	1874	1	1	7599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9M1LLfY88KBTW63pQanxsWqHoFNzxHwkPJodUdtXPjLxJrCxq
18403	payment	1397	1397	1678	1	1	8366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdpdpmZfPmNdiuhoYrkmXUcRyvGXGhfMrFfVYMqnzdUkWwUowr
18404	payment	1726	1726	1874	1	1	7602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUyxX2oPd3WNKi5jg5Zguuyhd1jZ1DdcXKc2aSYq71KRugnDG
18414	payment	1397	1397	1678	1	1	8370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuCiyEywGb7H2iaRLx31jKfXcxwjr6g8XNucjedAsb3wfVtTx
18415	payment	1726	1726	1874	1	1	7609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLQ9t9WmABR4BUcmjB1fUU6sHz8mUYKu8n8axAB85gFBbnXvh
18416	payment	1726	1726	1874	1	1	7610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfre37DGMEQ9VCbe3uzSEKtHwBhK2hwjd1H7BY2zPpXpofeq4
18417	payment	1726	1726	1874	1	1	7611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8rYvEwGdGMDDhxonMQZwc7CmwYqWVZcWrKpGnfNhgfbiQjZ9
18426	payment	1397	1397	1678	1	1	8373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3PeJuqtPRWdwCeewE3gykpRUydqzExQoMJndR6HMiPnW8rus
18427	payment	1397	1397	1678	1	1	8374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVE9rQBk1EE1JFxRfobjR21bjKbtnR9EjNz4DsnPZZeJXGx8W
18428	payment	1397	1397	1678	1	1	8375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPERkxCKkDT9tnfTCEiYnEumKbvsDWmXawQ2SwDtvYUkmrfbA
18429	payment	1397	1397	1678	1	1	8376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7ZPborWHXNUhzPKo9TiyeiAxUbLGZh7xfjMtYqxhPMyVnX25
18430	payment	1397	1397	1678	1	1	8377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxEYrTjkWkaSSc6eB9HgJXHH1LLfoUR3nkNAfwAijTbho8Y7a
18431	payment	1397	1397	1678	1	1	8378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiMThSDqMQhn68tTPeFrdjwdib3rK6XchVduLVjbU5BDdDPHn
18432	payment	1726	1726	1874	1	1	7618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGvtwjqepbX1XJbZZzzDhiJxCq6NovFWrPhsWrSVLEw496UYd
18433	payment	1726	1726	1874	1	1	7619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4cadoyBEJaawX7BXUgZUHA2rbZ9jye47hhYvAJ9DXfYfafeN
18434	payment	1726	1726	1874	1	1	7620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgz2tK31svHT32c8hjHitusWCoqtj5oMoBuvJU73oN3j7Yh9cn
18435	payment	1726	1726	1874	1	1	7621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1q2Gmx1H7GScoVd66FXBkhAKSmg1wdQ1nv5eVjphSjMQzhSH1
18436	payment	1726	1726	1874	1	1	7622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctWosXu13nXuC2Pxz8xU9TLreiktP3GXPT1jiuVzXfzctab4L
18437	payment	1726	1726	1874	1	1	7623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY88ZvD9pjMbQ36WbC9QjVcJAB2gdjbqDTrh2jXYEE242J8rUB
18438	payment	1726	1726	1874	1	1	7624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41rD5YkUH1MnDhLnGmpzPDs5Be6ceopzpQq8Hs6SbTNPRaHtD
18439	payment	1726	1726	1874	1	1	7625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKybH1rQVYNpgV1dCK4HWeL9ZymhYF6AQfWQQFWa4DpBXHMjsy
18456	payment	1397	1397	1678	1	1	8386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWRBrifN2KkBKM9LDk8p4iTDym2DaV5ZvyH3ExwXiWNYyVJTa
18457	payment	1726	1726	1874	1	1	7634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYse1Fm2hvEPfnNidZXSoxXoHd5faHPuNbjKPo6W3J6BPRoMfPx
18458	payment	1726	1726	1874	1	1	7635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkowgcHP9uCKhuyurT5STQbNGRMk9fWXwyq2m6B1P1RYwGapk
18465	payment	1397	1397	1678	1	1	8390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLysF4AuykwKZ4MzhrrBuvAnEZeEzUDdu5w5gAvxwUKdmyQxX5
18466	payment	1726	1726	1874	1	1	7639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43NnD7EyYW7Ss7wgUXHpJPK1PonuCwiC9Rk4S8waVyr2n9u8G
18470	payment	1397	1397	1678	1	1	8393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRc53dNeK9XBjs1QZSh2HypS1JDNkY6R4qfQKtz2FZTmK6mLv
18471	payment	1397	1397	1678	1	1	8394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPmgvYxfWsubGVpJ2qY2fgeymq41KYNT9f7RTdioTKEzsUoLr
18472	payment	1397	1397	1678	1	1	8395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7Jh2jt6h1AKiU5UZe4NfacS9HqF4bYWfECSpoTwrbzH2kHie
18473	payment	1397	1397	1678	1	1	8396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQq6EYp6AMRN1uUVk5koRAjLU7C7W9sHJi4p7HpweiHZJWqKH
18474	payment	1397	1397	1678	1	1	8397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV16ipBGGjQojhoBFyudEpujL9Ezrq8agwito4EQVCzGZxZmXW
18475	payment	1726	1726	1874	1	1	7641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJNxXsAErJziGMovX9c5pHxDDnGURX6hebLDNXkSXVxRBhQhd
18476	payment	1726	1726	1874	1	1	7642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftTmvghLk4z4BJb4NCp28ZdR8WnPRsAYAgcBaSWApYU9GSNiw
18477	payment	1726	1726	1874	1	1	7643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DEGZL47Cji4SjHWZXgDFSm5hJQVEmFxiBT6t5JYc9PFagfKQ
18452	payment	1397	1397	1678	1	1	8384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXbPqAu2CH5xx3GDqZFUjzuiLa3z91DVn7A6qr7DPEYfbyRvE
18453	payment	1726	1726	1874	1	1	7632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHjUNcno4pi2DgtUAgWsFEXMri92cgiP4W32y19KnQya2ucoy
18459	payment	1397	1397	1678	1	1	8387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApWfxWxMM4n9eA9S6BzJaQ8zoe2XnAjokqvBxjSeMX8BqyoeL
18467	payment	1397	1397	1678	1	1	8391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UEEtUJ2fGPf36C8fg7zwcbkpmcTT9aZdq963TWxWyZB8BYsn
18468	payment	1726	1726	1874	1	1	7640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvU4REPTWA79KmmyD7sovNLmJwAzSf2jXF3suVHYicVpVjw1i
18469	payment	1397	1397	1678	1	1	8392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7z5N7UQkRopZn3mPZmMG7SpmJgN6aCQztJVk1ZXhPyCEMTsM7
18485	payment	1397	1397	1678	1	1	8399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4g9N8mUdk9RBuZJEvLKX2FNzxntteYankKaQeySunsFk6zSSb
18486	payment	1397	1397	1678	1	1	8400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNLf8Tk5kBZ1PruBzJPhCQPErqNc6jZL6zK3E37bkJbHhvxQG
18487	payment	1726	1726	1874	1	1	7650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtAweHFmYYvxj679ra9FWcp6cPjtS7d8EvDQGYZ96bCNCAwPy
18488	payment	1726	1726	1874	1	1	7651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uKwQ6EoTJUsFPGcEPiwCgG88biDt2HFFRumgeaKC54N23518
18489	payment	1726	1726	1874	1	1	7652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37VezwHZaaVtxLnwAnFBfsmp99Bbhmewq5Ddf2W4zANWD2m9u
18494	payment	1397	1397	1678	1	1	8403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsaL4FA22DL46AHxiUD3gbFE9wjCwA6yJmCpa49FWkbfWY9Dg
18495	payment	1726	1726	1874	1	1	7655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiHH3Cn4UTzpB1dQgJLmNqCeaHo4jcPxTJDLkVt8EYJfKshsH
18496	payment	1726	1726	1874	1	1	7656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7mp6mHWmMKSmyzePfzyVUSGNTNspp41V5y4DPgemjcXPxzcZ
18504	payment	1397	1397	1678	1	1	8407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7U35qcnLR374ysHDa2KGL9Y3LzfTvfTZkimGbbcY4itBY4NZk
18505	payment	1726	1726	1874	1	1	7661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtgEhJGZPvwPt7CtnCKLSPzGKnGLHhjwKCcd76j8kcqMcNfXj2
18533	payment	1397	1397	1678	1	1	8419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XwYXtUd99MXfqbZgcTnxL18sWsjWkpwwBXcdQNkAtkk8Fmft
18534	payment	1726	1726	1874	1	1	7678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjMCVFVGYDhk6jKzb6zfjj7FrSBJbM1jCb7mHroYPxgMTqHVu
18535	payment	1726	1726	1874	1	1	7679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LZ29i4vSoYHV61TwaLAebdbG99d71BYchzFrSrqM8bSMWQpn
18536	payment	1397	1397	1678	1	1	8420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8vg2pFQ2hKhQjCdCrYoqGDkmKQ2LxM5nHJw2nP9vndGt2afM
18537	payment	1726	1726	1874	1	1	7680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPXayBQQohHdHirucgPHVZc8bRpXcpKe4bJJVAzw973nCFGSq
18565	payment	1397	1397	1678	1	1	8432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUChrdruqJVzUYZRTJqxhmXJRDwJZ817hV7MM3Tf6GkAfXQxrz
18566	payment	1726	1726	1874	1	1	7697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8E8S6YKDzT5nrq9woNc1tT3gSzWW9WsbgJCdLrdBHSPJ8nF6
18580	payment	1397	1397	1678	1	1	8439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxX5qirvnyrs1UUzoafQRpcehMmPKMYBDvFrJs7Wuq2jEztJWi
18581	payment	1726	1726	1874	1	1	7705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zdqQCtjRpRyciTDGhB156QqQVhUFFTLaCnEPJL65ykBjSvkN
18582	payment	1726	1726	1874	1	1	7706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xre1t2vY2S5r16LJoFadMrSEVN9zF2TtKqhuGRii9jsrPvDY
18592	payment	1397	1397	1678	1	1	8444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsTBGJ8LDa3c3kiPSs1HdBsrPMuQ4UjFZBkg8NN2yiXZaR2Rw
18593	payment	1726	1726	1874	1	1	7712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqfs8NqnXynq26QD2yB9uUqB6ZKtkyfgkiK5wFUPdNpMapzii
18594	payment	1726	1726	1874	1	1	7713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCaeaerHDSNScjR4BU1umDJA6JjxA9miyhn9NmykgdFZbZ5Bb
18608	payment	1397	1397	1678	1	1	8451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcN621SD7kLJRBo2HqkgKeYRQeMDXFjeTM4VcVbCw1j9XoKCAN
18609	payment	1726	1726	1874	1	1	7721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhembhhLMZGpmN48RGsR5SmyQRJWURwH9meKi37WN7Dm6cdrH
18610	payment	1726	1726	1874	1	1	7722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Xvra7KMB4wLKpc2gBB6yx1KS8cfdJFrYmni2feaCaXruHsV5
18627	payment	1397	1397	1678	1	1	8459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8MDpiTbNA3GpKn5PWa4aBDAsH6SYD4mtg6RcHKMj1q9KZWaZ
18628	payment	1726	1726	1874	1	1	7732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhtodn89TuppZYzhLbH6d5XktKRhCdWqBPKyVDvuJH8VXBKmQ
18629	payment	1397	1397	1678	1	1	8460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMLnKSBvRe76LQEsAiBg67xrfuzZPaDaBHMJSWP5i8EXtrZA3
18630	payment	1726	1726	1874	1	1	7733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4vNSVtksQGGZK5aHC5SvS33oJ4ckMABWFssirnJuWhzAGRs9
18647	payment	1397	1397	1678	1	1	8471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrvbkDaaDoLfmtKLYNBP7CMr2gw4bLVRz3nNg4kvTZ9uH9nzH
18648	payment	1726	1726	1874	1	1	7740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEo76ciiZ6XsqBLQyyjogYT3MRT7gPgGRJPQ7ehS4NtH8WUZan
18460	payment	1397	1397	1678	1	1	8388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSVw9rJ6VQSFem7LbHh2vjv9JZPUH9mozySNVWPb7FqSvsCGk
18461	payment	1397	1397	1678	1	1	8389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicT2xAesZ3SDkYBgdDaXfAtDzGMVH4RCqa1cAbjoz4aynQvgU
18462	payment	1726	1726	1874	1	1	7636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9ELmnyVvmb5dmtAVoqWRQR6ZMDBPsKvYpCw5ee38q78ud2JV
18463	payment	1726	1726	1874	1	1	7637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cp1QtJn2k8cJGJD5uWNYUiiwLRxtpYkormMjUohnhnEAfjhM
18464	payment	1726	1726	1874	1	1	7638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwytadbaGUz68zBcXwc5h4GxS1xZb2ZpZWm9g2433JpLxSins
18483	payment	1397	1397	1678	1	1	8398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1zADavnEgZxXdYkRgqxEWdWAV69KoGh5Nyrdp9BYC8V3J7ba
18484	payment	1726	1726	1874	1	1	7649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbEmKPXPehWDu6eHJKqunNZKpx8QjE3m3bMu6zu8Dre3ebsBc
18502	payment	1397	1397	1678	1	1	8406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpQTeyVeEpAvDNm2p8xZKFd98UU1LxgJJKHAGpYAFy1vN3Gkf
18503	payment	1726	1726	1874	1	1	7660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yy4HnLRmWrYE4pFn8sd1WwusvehJaZyCKGvbnFTXBiJrt5CN
18512	payment	1397	1397	1678	1	1	8410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UwtGo79assfXMSoRMvDd25F9TLsEX6hfXCKqzMnVi837rEzi
18522	payment	1397	1397	1678	1	1	8414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTnfBLCpRazfVQUMhVV3GYckVNP4pQgzpQXBsLkwGAgyo6xoC
18523	payment	1726	1726	1874	1	1	7672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdisMadVVoKT95AVjksB2syR1KLE18x9FN7fad1NDhccMmdX2u
18541	payment	1397	1397	1678	1	1	8422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8g6dmaVgLV5pjvsUtkVpgzYsPdmRgYEa1NZiZwiDF7LBgyV4
18548	payment	1397	1397	1678	1	1	8425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4PcZt8VFiWhi4niGRPh9AuebfbXUyVmo6v5niec4CwCDJWiM
18549	payment	1726	1726	1874	1	1	7687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9cZFyBaofUfYMChXdjp62U92teoZNGR3CQq6kR6ykguxmAKk
18558	payment	1397	1397	1678	1	1	8429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEhMZJnoTMA93nScHeMKdYyptnmQGoHQJPTNmd4UPiw1ArAdm
18559	payment	1726	1726	1874	1	1	7693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhiigaiW6Y6LmPkfNunszoPFhyNLPnBCucBbzwpu7q9ipTQGn
18560	payment	1726	1726	1874	1	1	7694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAjeQhkYSyHDdTWRVpAuAdSUBs2zYNtDW4iNn5FxFNySYzcAz
18576	payment	1397	1397	1678	1	1	8437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpMUXKxPBZy4GQZvJ8LsVeQKLxEDAo4xkxEZqxzxNxsTXDYakH
18577	payment	1726	1726	1874	1	1	7703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkKB7EEp5t5Rt7VfsX3DHWs1dDBPp9Rsykik5vwptonDtLqXW
18588	payment	1397	1397	1678	1	1	8442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5sEZbhi1KEWSKDs9vKK8mK2aqyKdULemU8KDFC3fGC9RYcEg
18595	payment	1397	1397	1678	1	1	8445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfCxQkBBrfZ1Dxksm2Aid2sGP7BkPcVKvNQdr8fTTzapKvD1h
18596	payment	1726	1726	1874	1	1	7714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHb257w3WVM9yUM2Lgfd6bLKwWh3BZAC5DvbJxNXdoZ6ooDUt
18623	payment	1397	1397	1678	1	1	8457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2VX5pdvtFqG8JmQ8riWCiPT2jZ1xZaBNd393iskUr7aSB8dr
18624	payment	1397	1397	1678	1	1	8458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJvSZ45cTV2XehpRWgXqvwsHKiyAoks3dNK8FBpiws3cztF4r
18625	payment	1726	1726	1874	1	1	7730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD78NUNJPo8DNP5jKbsGBypnnS9UzSqxhk4DogeDiU1o7r45vy
18626	payment	1726	1726	1874	1	1	7731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XDf9dRVz2R1XjktTyHuwATKYaFCdjm2HR7StVGydfprHwzMK
18631	payment	1397	1397	1678	1	1	8461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ij4WtmovhnDJhxVmcTJt8qQxZoVkAJ2Zkeg3aAYQKuEsMpie
18632	payment	1726	1726	1874	1	1	7734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6XH8ukUgHcpChfnEZ5QkaLt1KToX2tJ7v7Fv9KmuyMcez4kK
18636	payment	1397	1397	1678	1	1	8464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62fPoVo7EHkZSdFQHMtA1rexS6X11n8hk2nHnMTVAgG3MHKrR
18637	payment	1397	1397	1678	1	1	8465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxh366CZMokSypq7miVLnvEkk2ez24LxhjnbJWHMbj2pFSnEz
18638	payment	1726	1726	1874	1	1	7736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWaoyin1JJ65Nf4idacmGew2mYcjKF19XW2r67x2jM7cKLrTr
18639	payment	1397	1397	1678	1	1	8466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaaqdJ6Y4fZM4mWa8RNMzn4Y3oFEYkszTTgRnWhX6J8dA6kFB
18640	payment	1726	1726	1874	1	1	7737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U3MGYnb3533qFFvoMtMABo6u1HWZQqcQ63Fdh3ZttuRxhVed
18645	payment	1397	1397	1678	1	1	8470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKgQx5gMCJ5skB4Fk3ejVsBej1u8N8z4tbF4dJAEnYPA7jgzy
18646	payment	1726	1726	1874	1	1	7739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysbdEJoEfBw3MW1Qit2jShqiRmpBGzaKootCH4wTfYdB8qwMs
18650	payment	1726	1726	1874	1	1	7741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tz7Xwb9Yg1KHgXC2asiqx8G5BeDx8TczTEytFsruNwqAk8bB
18662	payment	1397	1397	1678	1	1	8480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9ot1c7Vv9Scg7pK4o9jogwaueJV5WcRpJdECcn5vQMKgWYP2
18478	payment	1726	1726	1874	1	1	7644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9KeTmqUeY3qUHWgWdUnFwHAUxAs3pj2gAZ8w9VEvoGBHgGUE
18479	payment	1726	1726	1874	1	1	7645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FB6iJGnFMk1adWg96M2kf87xF9cvA9RMMMXkoT76KDaffbtF
18480	payment	1726	1726	1874	1	1	7646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqsunKAVcwmMjxJoLrtz2MLbPZy28bzeP5HDAJXjQaobFsVf1
18481	payment	1726	1726	1874	1	1	7647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mhr5uJWBZG1HK5FKcaEqtVdrJTaWhRd2KB7USbTj1cjjJPaH
18482	payment	1726	1726	1874	1	1	7648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WgHvj3oqLwKcc8khBgmW4WbbAydVBm2WsSmPyc6Wm2yxUsPz
18490	payment	1397	1397	1678	1	1	8401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkc1w1VrfWa5ycaeAMxhd1DEjbZJMXje79tq8Zej4TFrbbaDL2
18491	payment	1726	1726	1874	1	1	7653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE47kXjCp3JEArigx1PiXiEdM32riDgBZGYjmW9VG8W4CStjC1
18492	payment	1726	1726	1874	1	1	7654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiAXQ8puYsSHuMtCrdyficwigqrt1Hh9WXpkFgtTtsfGoz3u6
18493	payment	1397	1397	1678	1	1	8402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVnq5adVzYUB85WwbjC5UTg7kMubXnMXoq5zNeJbPxXZWsmbr
18497	payment	1397	1397	1678	1	1	8404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4yKNnXL8PaG8hZvebyZFuYKQVjY1eNVRDeWzjaTXwLTZnp5u
18498	payment	1397	1397	1678	1	1	8405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqKFGcZCx2DBw7vprcZT2p5ssgAFcbWG5XQbAXbzAA9GnDWjM
18499	payment	1726	1726	1874	1	1	7657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsjDGCuVvrnRzryeQspQXmoNXCgR1uDPfyZXBHejoXNePrY2W
18500	payment	1726	1726	1874	1	1	7658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqSet1MNacFbK6K7MQqYt3Z18mmdLV7qrGBQJxyUFM1y8vxYAH
18501	payment	1726	1726	1874	1	1	7659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoWVFHKWczAW2kqQx9a26R4B3wiq8rm9PhxNV4BA2wSTDJwMG
18509	payment	1397	1397	1678	1	1	8409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wL8MPuefnuEoAfxjaS6SvaoaFfYfcHW4Nz88NhaXEE3N1Vtq
18510	payment	1726	1726	1874	1	1	7664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QxTnSf5Q4qgkrBEprLFY4VDfQbGNKuCV3pDh2iBpoGTBCi8o
18511	payment	1726	1726	1874	1	1	7665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspSvWEv5uM8L3qcLKFzQEtFFmBAQ6p8PKq1DuKu7M9afYrh8t
18516	payment	1397	1397	1678	1	1	8412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWWGDMUAdJPWyxQS8MB9QjTmkzCN84BoGc9MCbFcAAzJAn8SB
18517	payment	1397	1397	1678	1	1	8413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GWzKFJbeKB1sv3xM8B1C2vahTre57yXAro1QkcyrPiGkXsFa
18518	payment	1726	1726	1874	1	1	7668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWErMkHNYsMQxXAVtq2hkjX9Tvq1MKdGFJ9sF1cg7q15qLkpk
18519	payment	1726	1726	1874	1	1	7669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgtFjckm6T9PqZuoRCPTuTJU3DrtRAkQhmu8kutzFu9swArGj
18520	payment	1726	1726	2118	1	1	7670	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzYxnUYzPNb2xBSeAj3z3CDhXGqtoWxi2HnrwyUiF4ygm4kenx
18521	payment	1726	1726	1874	1	1	7671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYiTUJfAcjospW6KKLYWog2z9iwXTKjd5BYCzePAaK7auTvF55
18529	payment	1397	1397	1678	1	1	8417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCgwdvsbmpjCkUBQk3EWtg7CjwvBKDHsctk1zAGZAc7Q27ycK
18530	payment	1397	1397	1678	1	1	8418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmM5eDuVAVUcCXU5X3qS8CFyAvsedoEmboVV2EcpLDdGKGpo7b
18531	payment	1726	1726	1874	1	1	7676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nLSjmZtqNq3hP4pBMDSxybYpmRL4TQtw7dYiceJ8QkTBV4o9
18532	payment	1726	1726	1874	1	1	7677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvavhbB8TyRTiec5Z2PXQoQwXqim6tmPy4HbyqgCrmYXZeYkEh
18538	payment	1397	1397	1678	1	1	8421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BJxPXzGqqfUsbRHdx9jEScfsCr4unyxajoUoPhH4z6RTpN17
18539	payment	1726	1726	1874	1	1	7681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKdcwQtaaFhM4NUo8zuPYXDFXQDfc6uSCHmrpgQGYiqKPB7WcM
18540	payment	1726	1726	1874	1	1	7682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRAXaJLpKc64or32WaoefFnwrut7PK1xw8TeGds1XuHbX3NNW
18542	payment	1397	1397	1678	1	1	8423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWmHACuvqqLKQStwXwDkBeJZNG1EPGmLtL1x3xRvrhtsZ7nwv
18543	payment	1726	1726	1874	1	1	7683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqyEUcsK3CJ2HT6P333Hiayc9tvbCS3vYtURMCPUdBxKdyMKA
18544	payment	1726	1726	1874	1	1	7684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGg4JcAXwLuGCKpWiQeuuPwCoKBLqe4BH9VE1eNV3xhYaSgbJ
18561	payment	1397	1397	1678	1	1	8430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq27kWaaoQ42zgV5yztehY7zmJcG5i3DKMFxdm5t6S8wkyuMnU
18567	payment	1397	1397	1678	1	1	8433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWJHwA8UY7PunSddsPvGBtSuB2z2MtscfpuyaowSrvFaqdUS2
18568	payment	1397	1397	1678	1	1	8434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LBwrQe4kUzefhtygVY22K5Xdz1Mq3JceqCCRVgwDm5f5Yhcd
18569	payment	1726	1726	1874	1	1	7698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAd3vgosuK3z1Smo1mmV7GA5bknqxoXKfey4jy2AFsVwtAmXBT
18570	payment	1726	1726	1874	1	1	7699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn4vcmKM25dmW5BDRGBqQhBRkzb4LMhhNw2AEZdwDyH1iGpBG
18528	payment	1726	1726	1874	1	1	7675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZw4H6VJLHnTqZW7SXW7TN93U9HG166xpuLb9Ay3fCWa5aigJf
18545	payment	1397	1397	1678	1	1	8424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG4nxDkZXhtvRfhUtk75xKQygxbiaiHszzUozBkb9CUDKisus
18546	payment	1726	1726	1874	1	1	7685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjL3Zt8TwztakKDXn4SDwn6wH6Why8E1wJfRgAHWZ6eLSJdLE
18547	payment	1726	1726	1874	1	1	7686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FnbRutPWQWPCccScsCChBSBWJ8nVkjC1vgmVEdQCumrZv3Rd
18550	payment	1397	1397	1678	1	1	8426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEEN9vTgE7bwtERMLrGWLCT9dzxJzvTjLeuzutnwB4WDak1Qt
18551	payment	1397	1397	1678	1	1	8427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1ahn6GQvHMDTWiBE1JWrfRRF2hNzBKAYZDuEaux7p9Nav9Gs
18552	payment	1726	1726	1874	1	1	7688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GdHdLXNy9Yyf7xgmwEpepcjZQcsWHbzHgRf73TR7SQ2FPzfi
18553	payment	1726	1726	1874	1	1	7689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxntRMcgY36XExWtmVjVywypMj5n362huNU8GkfXChDHa2V39w
18554	payment	1726	1726	2119	1	1	7690	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYWGLCUzUHit5iv2vYbxJ9wzWJDnFJurTEYysefG99baKj9vsys
18555	payment	1397	1397	1678	1	1	8428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptmC3FwnYQvT5ahM9DrA4LXyZnA4kV4qPBRZwZXdZ9YbpGqdk
18556	payment	1726	1726	1874	1	1	7691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAA6UNMdVRjuPRP8ZRQvrNozMehH4AXUbXn96mW6DwyS8yYUB
18557	payment	1726	1726	1874	1	1	7692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkYMStMdkatv61kdJeY73R5cdoMnP4Eu4BJqHZErFjx3a77Bz
18562	payment	1397	1397	1678	1	1	8431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoYZ4p3ay93ncNxrXN3xUu3sGpTuVHpBx94CXNQrrRoMdG1Wx
18563	payment	1726	1726	1874	1	1	7695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CpNvVFzht2r9wcfrrTXaBwSVp4iLggcps6zLP2qY4rbg5g8q
18564	payment	1726	1726	1874	1	1	7696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdk7mgrDgNE83C8LsuQ5CBzGfEJXuHaiP5mF1KnhWHhgfdyojh
18572	payment	1397	1397	1678	1	1	8435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPabE7SZ4LYX4mgXMd64nruj4Uxv4wXQiH6eWUYYqwRn1Ruq3
18573	payment	1726	1726	1874	1	1	7701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSWkHaDtotnuND8uW5zMRLdm6wVTbAv4Ci5Z1Xvekhpy5MC9r
18574	payment	1397	1397	1678	1	1	8436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG5JNzuWpbh5MKyBWYwxZsZSEgrrNsP5VgZqU57DukGSxnpah
18575	payment	1726	1726	1874	1	1	7702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wLGSxD6d9XGAzPrUfUcG2go4Hv1fr9pJ12ZrEB41AkJuxxX7
18589	payment	1397	1397	1678	1	1	8443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmRk31MV4wrqTqRiyTaXUhA8RnxEmGYp8FZgWJHgALMnwaDnk
18590	payment	1726	1726	1874	1	1	7710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrbC6JGXPv2ouwoCEYarW3MHpJ9A9h9W28qLUcUjbc6RdJJDz
18591	payment	1726	1726	1874	1	1	7711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrA471kBx7cFJ1qxx8L9ZGGPjs4AW1iBWzyxsoeb6oiJdtjqfR
18611	payment	1397	1397	1678	1	1	8452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZto8hRyFLRzg8MDWnQnNrhNQiMEgh9G89ok2Yn7YBn5tXZ3a7a
18612	payment	1726	1726	1874	1	1	7723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSct2XRtcLr4S5Wc9hYzfndmvoeABTa9J2LKce6C9qUEv7zQ9Q
18618	payment	1397	1397	1678	1	1	8455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXojE262kE3ovHafRRxwWKKFj1xGpceqL8eremfAMVc7TNr6BC
18619	payment	1397	1397	1678	1	1	8456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9S52zRcCFJe95pVdouXA9hThzyHxySuK3isjPonCTzNUjk9c
18620	payment	1726	1726	1874	1	1	7727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRQdTAsmwtqw1PEuwJFwiG2xxVq4NYYLQRs7iNoz7Wo6cT1Lc
18621	payment	1726	1726	1874	1	1	7728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mreCSWmpGvDcFzgshzGfQrdbwFGH7UWZ7ryfKEAWg2cMGpWM
18622	payment	1726	1726	1874	1	1	7729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pf95gzf2qK3Z3DQbyPdpxCu4iFrCwHhm5hfGwmbiTChAgdHG
18651	payment	1397	1397	1678	1	1	8473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTeuDx9NprTWmGpCraURP8XkkoMDZ1aZhRfqLuxEkUtPpdFjY
18654	payment	1397	1397	1678	1	1	8475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8CjH9rtseGKQb3MBrb4eYVDP6vcBnw4zhSyzhrmX8AnbzgEt
18655	payment	1726	1726	1874	1	1	7743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnAnxRFer6WgghX5MomvYWwdfcV2FUTqnKHVDa3zPCk3WL21Q
18665	payment	1397	1397	1678	1	1	8482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyYq32hkGiYdFBHtHQ8dzuzPqy8XS8FwSRJZKPJPJKtkCjFLNY
18666	payment	1397	1397	1678	1	1	8483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmGsVNzCrgftoVnAHfSwGBKeoRUtnNx8nC6sEWMKjjZCh5N7p
18667	payment	1726	1726	1874	1	1	7747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fEWzWNdwjAhwhsN4hD3RJH46C2Xjoa3aQ6GX6m3pMxgdqTyD
18673	payment	1397	1397	1678	1	1	8487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwZSk7CXB3XwDFPfELrcyunBD8xgQrmJ5irUaPodfLJERUZFd
18674	payment	1726	1726	1874	1	1	7750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsnXYKspF9moJ1pU7UYyABnNvfWoGLL4MtVXpytPWcCGNLnkp
18678	payment	1397	1397	1678	1	1	8490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5phnWNZSej5Ko7Nsb3f8pxChEvxbFYFitgM4ceXjQhF6kXTXj
18571	payment	1726	1726	1874	1	1	7700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCosGrgifZBD3d67WbE9F5CeZZJNkjETRKoGxAuYbhDhS7GC4
18578	payment	1397	1397	1678	1	1	8438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFdFLjLjHfdHTsscLYdGNPBd4M6ExzPCUnPyiQPsRw3GXE2oA
18579	payment	1726	1726	1874	1	1	7704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1CSDJ9GnBcDddi7G6rtq7BZWBBVn8qtLcfwdMZjmzSJphVb5
18583	payment	1397	1397	1678	1	1	8440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC86hEqahjmTDqeJ7Dhh53CEvBYvUUBkSziGjnXDtdJRFQARJt
18584	payment	1397	1397	1678	1	1	8441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkHW4i9Jdi3uv1hybEkQNsVxAJDren78esxUUqV5ig6AtGk6k
18585	payment	1726	1726	1874	1	1	7707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWjnUpCHRY8k2ecxHAy6tKSnGbfRArv8vWqkeiMvJeFgfd44G
18586	payment	1726	1726	1874	1	1	7708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSn3zXYvtsW4FZp3UqVCDLGuBSSAUDZbs6F46u5KvbWcNXVjcD
18587	payment	1726	1726	1874	1	1	7709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtw77xTp4BK5Vf9FBBGP2TJZ1xyciwD6wkBF8gdyp24Ubr83DZ
18597	payment	1397	1397	1678	1	1	8446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3B2miv2jp8EfjgB44uCpeFBYBaDXQ67aAK4j4tLAhq6qxx6U
18598	payment	1397	1397	1678	1	1	8447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2Taban9mRyDJfHveo4qfgaFBqnERcVSx3xMRB1SCV7a116Y5
18599	payment	1397	1397	1678	1	1	8448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipttZ7iUV48Nosp6kCjJcZ6MRsQntmrtJFUTLFuk9t7wYLuyR
18600	payment	1397	1397	1678	1	1	8449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZsFoPihbH93fPHdnQNgcFWBSq4C6JRAbXxfFxL7QVoNuvbTx
18601	payment	1726	1726	1874	1	1	7715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2vdRUcTTdZu4X8H5JRWWaX6U5fyWq2ra5jbTyZT3k1JmU5Gt
18602	payment	1726	1726	1874	1	1	7716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDgqbM292PYR54PuxVxvPRWmdGASSgzrmpLeWu4DZSBh71MM4
18603	payment	1726	1726	1874	1	1	7717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU7juxDu5N8jNM3QPbsu61GZuNXyjyCTbBVwiDb5YvzG9iyAc
18604	payment	1726	1726	1874	1	1	7718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDNaTjbBAxcWLoBjB314ivNQ5ybtjx7qYygmcE8ggidDqHQHF
18605	payment	1726	1726	1874	1	1	7719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVCVsD5rc4arEdo1TEx1gkrxkPfgMsi5Un9ft7PYn24RKqCXz
18606	payment	1726	1726	1874	1	1	7720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZzjv9DRMCgcMTMnZtdKffumpJ7vkEp7kgDLLGUpebEkN6fBw
18607	payment	1397	1397	1678	1	1	8450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPdQQCtsnzYVHLDGCqz26ZpDKP7jAY4fue7GWSEWCRcpNBwnC8
18613	payment	1397	1397	1678	1	1	8453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4X7nMh19ekhRDieHDUBBDvB8GoAGAiKsQ92w9gXvpmiNZ7ks
18614	payment	1726	1726	1874	1	1	7724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4yuLZ78bc9gtyoJZUGdTH92mTdc8pZHLv9SPLN3djqFaS3Hr
18615	payment	1726	1726	1874	1	1	7725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsVpcVzet8nM7PAERSMtH7ZG2MZft7YEf31mAbT9YGNUgpY7n
18616	payment	1397	1397	1678	1	1	8454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRDa9qnv4BD5mynx2VYCa9n1JB1HcNx9BmMP86HoAqn5EJfEF
18617	payment	1726	1726	1874	1	1	7726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGprALxk62AsbgXWLRH4NFKSEvzPw781rjKUXiRBGtc1iDEE9
18633	payment	1397	1397	1678	1	1	8462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZMmUDPtuxysawVjhKiFrbFgHeJv6t34UKXhe4bx6eiV14poF
18634	payment	1397	1397	1678	1	1	8463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1t8n6BbKB2mupAkEWX3ePnrjKadttCuh8q2VbaAt6eeit1A8
18635	payment	1726	1726	1874	1	1	7735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEhH9VFdGofzLKPShPksPuoUtBGUZPKKTd81HEiWcQaFJGYbY
18641	payment	1397	1397	1678	1	1	8467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUQcgvvMDrhcDWzMMeXbCa5FhRQkyp6SL3JtM69gJ8nobESHJ
18642	payment	1397	1397	1678	1	1	8468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSARK2ChK9hZyefsV629kbpcmVVQYx9kv43gqNmuvpHMsVaysa
18643	payment	1397	1397	1678	1	1	8469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabZ6xhejZ1B7FHa6qjkE5SXERzyHbdkT9u6znMLoFrf8L64mt
18644	payment	1726	1726	1874	1	1	7738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQr33ZspUB7oqGNiR1z79akbCYo8fwa5sHvWjrBNo8fR6RXMJ
18656	payment	1397	1397	1678	1	1	8476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHUSkEyNncYh3m8DphNo298qumEX8yC8AQiZcMDAWUojksLx6
18670	payment	1397	1397	1678	1	1	8485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYiueAwsKdxyRFirzbqbRuxdt7sbFV9P5YzDsb1it7fypS7LF
18671	payment	1726	1726	1874	1	1	7749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJG6Tt3Lwvf26JGQDtN78mZ4X6yQdZaDwQ5m8XinQGWzyQwHH
18680	payment	1726	1726	1874	1	1	7753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9M2QmqoKujkwEafNb1sGPuSB4Aj8hJ4Khj36uLGpB8pRAvWnc
18684	payment	1397	1397	1678	1	1	8492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9qer7L6hvbndFnKnf3DFcupaKifkk7JxkdaswsvkLb4Q1yVZ
18685	payment	1397	1397	1678	1	1	8493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfeayW82HJ8gVz9E9ubhjJmEtoj85kiKMnt6LLaSwni3cNRHT
18686	payment	1726	1726	1874	1	1	7756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCHDhLZDyf66EjVJ8nyQrSBYNFAkqYWhuQk95PSB9z9KciM3y
18649	payment	1397	1397	1678	1	1	8472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFCewmSJkzzDv6jFVqexmKR6HshyGbGCfHFe57iuC5MCnY3v3
18652	payment	1397	1397	1678	1	1	8474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC2fi4vaMPy35xyz67f9ngsUVfhLTxqFsgeX3e9zNpJsU7quq
18653	payment	1726	1726	1874	1	1	7742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSorzduWHgrh7bQCM3cxDYon6fyady6qva5WBQZEEcThVSSEw
18657	payment	1397	1397	1678	1	1	8477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wAYMnZT7or7mbgiCgjAWWLtL7iscmHSNA59PHy4YhrY8zRmh
18658	payment	1397	1397	1678	1	1	8478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrFzwscs8UKbUCV6o5fymhESJLBWawkoE7BhNYk3fmuWV4Hcv
18659	payment	1397	1397	1678	1	1	8479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcriq3Lda7h8RYmtFHuc9RkoEYT6usWhZ6yjzXcyorCu3K3jwV
18660	payment	1726	1726	1874	1	1	7744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SPAvVvfs3W1wiQKXYvvNYJQbTFKHmMpdzKwkASkEJL6B1wZo
18661	payment	1726	1726	1874	1	1	7745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATiGuccCyomxYhnz5bBDpDDg6hx5ycNu5p429tzqATmeWDjSv
18672	payment	1397	1397	1678	1	1	8486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYACD8pb5qRJWHTn8bSNuESckBqLEvCnJrZxKQjDtAL5SWSgyN
18682	payment	1397	1397	1678	1	1	8491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9p5Yi8UvfgRuGpAfXtL3zdaqzryvLYDkLf84cpoFA1J3JN7k
18683	payment	1726	1726	1874	1	1	7755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QbiFTkXTw48PDZUAh5sTPZ9BkYbwHYGQhU9kCL5HvgnxNjNC
18687	payment	1397	1397	1678	1	1	8494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgfYVbbYgeZEohCco4xiXNCn44pRyMfFoqYKJvQgm67TBPQNv
18702	payment	1397	1397	1678	1	1	8500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoaU1LiTp37j4JP2DSypBQHuBuT2pTnMyoebpEv1NJ5Ht6CM1V
18703	payment	1726	1726	1874	1	1	7766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhszRqj3i3fPcecphCupkuvGt1rKGYYoKjWX4gxVWfX2Pftd4
18704	payment	1726	1726	1874	1	1	7767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WLPP627nU95nuwzLk5uqWS1kYndC63AkewpRzLL8YZ17vtTH
18713	payment	1397	1397	1678	1	1	8505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbA1o9wW8ZdWnkrvYaWG4pxe7D4N4yBzza3eqjcWLhckD96xzv
18714	payment	1726	1726	1874	1	1	7772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTARXDjkJGC1PWyxfYZojbLwKYujT98urhP5w58tbjfDXsxYz
18721	payment	1397	1397	1678	1	1	8510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZjyS42zAX8z9bzh1zkXtL1hQrTYcMPZ4f132wuJkMhAL7pKo
18722	payment	1726	1726	1874	1	1	7775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6952yaMWRgwgYiresrcCovTy2kietueRGsE3RoLi5GoxFKdJ
18729	payment	1397	1397	1678	1	1	8515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPCtJZXE9Q4hMWuuPYwc8n4tLo4oMVzvBNA8vYK1GDi7KmReM
18730	payment	1726	1726	1874	1	1	7778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xpQZciV6Bpdwih6yiiKUxfiEVqMPR8nqW6HATnp4NX6Z6sbb
18741	payment	1397	1397	1678	1	1	8522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1YZG2z7patTVtGGFABLGudaHB597LBMw3Wu4iumQvAgoSUjW
18757	payment	1397	1397	1678	1	1	8530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32EZasHAjuHgWrNFZJHhdCo9pg89PeWDwVYVJgb2x4h5xY39D
18758	payment	1397	1397	1678	1	1	8531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfuAe5UtTxVuZFZe671ifDi2z8erAvvkWZynFdnao9VtCtesX
18759	payment	1726	1726	1874	1	1	7791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR66NU9PfVc1Gu1gx3Z1CkhACEn1b4ENThwjKDCp7hq5kzNQGv
18760	payment	1726	1726	1874	1	1	7792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnU7jZkN5hZDLx3DpVEumk2rPjsQhwGJb9UfBtHYHfMMbRGbn
18761	payment	1726	1726	1874	1	1	7793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTA4jqNLCzR7SEPbs8NiRorMUeMVyQZS1RwYMXYNkSbeQaNYsx
18762	payment	1726	1726	1874	1	1	7794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyffQb1WW4PPBsreioS9nLNDxw4WWZmd6oetkmFVwBgYyfcTrv
18663	payment	1397	1397	1678	1	1	8481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4s32NEh7H575T5pr56abiz5S1JJUjb31Y4qUghKRs2PpXDob
18664	payment	1726	1726	1874	1	1	7746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5S46pRSJ4T5bC8FczkVWbAHd2XKS6dbiFLEnASbgD2tkwim6
18668	payment	1397	1397	1678	1	1	8484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhSq268cngnCbNx2YLCRAJvNUVEt4CyPqaWC4Wx9Tx5ELiqA8
18669	payment	1726	1726	1874	1	1	7748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7i6fefc5xHhEYZDVYK3zguBHo1MsmtogtD4SbqMZs6B51jBA
18675	payment	1397	1397	1678	1	1	8488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVenXmP915zjbDca4g5WCh2ko3cWkSpTdW8Gtfwz4tE1ZHaUw
18676	payment	1397	1397	1678	1	1	8489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWE5cjikhmckNjddwbqsoRvyAzRoLpYJ95Z5WuDFBoBToma3Su
18677	payment	1726	1726	1874	1	1	7751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4k9rX1KctmkdNo6JR6V4DKbyyNbNo6TNtS3dtAXBHUXaGWLS
18688	payment	1397	1397	1678	1	1	8495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnpWANsijwpjisJLtL7ZHw9B9vWeDyoXx5CRH6etRCDN2hqzw
18689	payment	1726	1726	1874	1	1	7757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sB57StWn2wvCmrMq9xv3h1ZVcew9G1w4Hu7NLv77iojURE1x
18696	payment	1397	1397	1678	1	1	8497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnG3wyyLTGnsMzUjUWdAUeQ9FeZ3ZWfftHFmGKYVA19e8N6Uq
18697	payment	1726	1726	1874	1	1	7763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDCBnTbRFDA5nXjUanEPwkkNhunKVaLBEB3Rxor833qGUTo1K
18708	payment	1397	1397	1678	1	1	8502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyMjX7dtGANCrDKWCFcUMBkfGUHQJNyhNhB5d394gg2GQpvUo
18717	payment	1397	1397	1678	1	1	8507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGCmM6fF1bEogDSeYshUD4uZksbcQeoiq4qeKKtGp7WY5NK43
18731	payment	1397	1397	1678	1	1	8516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTKM2Xncpo8z35cTQ3tQaNWGcCvGPX9kNwQdf7v8vT4p5xThM
18732	payment	1726	1726	1874	1	1	7779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFH93TrNKEtfqrvLL5tyu4Bpkeaqs1wGpygzaY2amFiBdpJS4
18679	payment	1726	1726	1874	1	1	7752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3e36etFAGRbkDM6iM8ijYmLNYctX6EQ1tNAzwgv4eSxtP4EkQ
18681	payment	1726	1726	1874	1	1	7754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSMaQjkXF7LFmGkQzYLhZHbE4d3SCUvH3resiTDL5qXNNaHGQr
18709	payment	1397	1397	1678	1	1	8503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkCwx3sKxwjt87NX8thQ37f76uTFPsnopFSETuddzmc6aBzF4
18710	payment	1726	1726	1874	1	1	7770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7DVCo6wvttK8sDhLbUqfYhFm4U6yx4hhJ75UdaZhQcHPpqc2
18711	payment	1726	1726	1874	1	1	7771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZU8f6bbC51XNeda7XGDQaYd2Aq1EGP3oPpaWrbxNwYga3CtW
18715	payment	1397	1397	1678	1	1	8506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8CkWVVDQpx1kQ8PNRjCRUBsx7K3m5iKfJ6zDnA6SnhNR7yJz2
18716	payment	1726	1726	1874	1	1	7773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJpPXVKf57wdyX9otdhvCx4kjcJcWGQ8Sf1xxUFyjwhC4Sx9M
18718	payment	1397	1397	1678	1	1	8508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVDzC2TgyViz515wwnrJjXsWq5aveMHq4UfrsNiM57jEfdbfe
18719	payment	1397	1397	1678	1	1	8509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxpX8gWNvxdANpJazsz7Ws9xYCREvSc79XLr5VzwJrBkKpQfc
18720	payment	1726	1726	1874	1	1	7774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnNVYRBodtB3FM2Z58bZfzcTetxk1QWS74A1qN5FN7PjtUdfo
18728	payment	1397	1397	1678	1	1	8514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYMWNQSWuckWNMrGtMrGCRprDZzbisHovKKWJzMSwT9Fd5auF
18733	payment	1397	1397	1678	1	1	8517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRkZWxm2cCqbUnbtAM9ASjLy1fijwoVFSj4KUMm4U3NKpaC7D
18734	payment	1397	1397	1678	1	1	8518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgDuf6bdrJdML48jcSMBJe5t5LT2qv3HsRWK5eTUC2pYJyhURy
18735	payment	1726	1726	1874	1	1	7780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZ6MVCMDAjamjk3VkXjn4UwyEG2b3vP9sT7kwCDR4PSNJZZSX
18736	payment	1397	1397	1678	1	1	8519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSwvk2soT4wMqyCBkuGci9Ba4CuMyqYPzTye871MKf1WRKTeM
18742	payment	1397	1397	1678	1	1	8523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCu8x1namBJcSYHFWPP9FtjSXFKSP4d5CxxgjGFXTb5Wq7ebh2
18743	payment	1726	1726	1874	1	1	7783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQf1yVUuRyHEX7mtknsdRiM1mJZSAJYM9XbL5z6nSYBMat7Ap
18744	payment	1397	1397	1678	1	1	8524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzS1PQ7KMtf4k8j5rUWLsgGbKKMdzLAC93kgZnpRWvNcc4EUtM
18745	payment	1397	1397	1678	1	1	8525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeuK1Q3aWRV6p9QrG75wtU1e3GR6RGPPnJAcwN5jq3m7DNLWu
18746	payment	1397	1397	1678	1	1	8526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw3Nb7QNCQXdk65daee3EN8p6prAUvJmgT9x9BD4RY9Xp5U3Rx
18747	payment	1726	1726	1874	1	1	7784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopb33386cuX9dbNc8aPE9jyCrWCGQMJERQRddLNk7sTLzTeRU
18748	payment	1726	1726	1874	1	1	7785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1odnYR4igyf65pVhcdTX9psWzq3LdgDeAJTrcAHe1PzuHJ78o
18749	payment	1726	1726	2123	1	1	7786	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaAbNex7hwnznttoHWEcwUUTp1McmnDP2J2F2MxWvCjD73XGs9D
18750	payment	1726	1726	1874	1	1	7787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HpzANtKogrXdfvT5C8GAnG3PJHcW13bEt3fBF2tprvEMNdB3
18690	payment	1397	1397	1678	1	1	8496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZqSBQHqHTgCnUFCLgcS25vp5s8fykX4DpPzQFysVv1RCA2PB
18691	payment	1726	1726	1874	1	1	7758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZ5EXHwmDS6SU5iP6bCJvcybaPfjxviP78bsPpEEwwq2eoVSq
18692	payment	1726	1726	2120	1	1	7759	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYYHJQWMtqt7shDxsPtzkYo4hLbUJtj4KixBgoDyQbkmsJ28aXd
18693	payment	1726	1726	2121	1	1	7760	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZBdAoor5pTTZwWrKFAFX4ZqcFqo1XyA45Kmgh5zcmEMHMwwHzQ
18694	payment	1726	1726	2122	1	1	7761	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZLcBrn4kZvsmpNfF1N7vwnzyVKb3oymFFu9SAuknkx2mtpsBVy
18695	payment	1726	1726	1874	1	1	7762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NfGKv1nuuSkPEowr9W8Tnnxe6MrzU4K6Ko4to7hAUnn1v3Wr
18698	payment	1397	1397	1678	1	1	8498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYBN55x1ZG8Evk2wsj3jx2DBzD7pVSwbb7pHtRFPFjxyGSitr
18699	payment	1397	1397	1678	1	1	8499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KpgH9pKbECXbpkmM96NVNRAymX9w2iPuWxUjoDTTX1QmLYe8
18700	payment	1726	1726	1874	1	1	7764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5opHvWdd8XDE6EP2tsi83MPQ27xPhEMPWVp39TFMQX5CMKb15
18701	payment	1726	1726	1874	1	1	7765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75JR2ypMTPjfkC53wUvfPQYA6Nx45LqdRzVvQuH1u5YdVuUh5
18705	payment	1397	1397	1678	1	1	8501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUVNPLdxnnwR6esCpTvtA5Hj7PyuB5U3wN4Cqi5CSkVrYShMv
18706	payment	1726	1726	1874	1	1	7768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAhinW9zcYeSXzmJ3vznL7DKwUv1CaKLtYzzWe24TGHKCQ4mF
18707	payment	1726	1726	1874	1	1	7769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nYwLk2YH7Pje9BLGe7JS58t4ZVF2NEDD3dy9DkpMJstyoRYz
18712	payment	1397	1397	1678	1	1	8504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3apox7CgrgMURpAUARWpC7gHoynuwRUM5uNra13rbKN2KtSR
18723	payment	1397	1397	1678	1	1	8511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6XYxWRWnaTKHnFKPaAD22FUoZ1qWTGVKE1YzW5e2Chy63ewVW
18724	payment	1397	1397	1678	1	1	8512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx3pGupfCtF5aZMRbGA1pUkEhGM2xBCa9UW1fixqcbCLCLJTg
18725	payment	1397	1397	1678	1	1	8513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnH7DHQzh7C7xor44mY4Uxb1SvsSnX38Jwd2TpWHyhkh7dgWW
18726	payment	1726	1726	1874	1	1	7776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8bCvAHCPqRjfMgTJPEABjyYvydpYELnwPa3PYAyJTeHQj5h8
18727	payment	1726	1726	1874	1	1	7777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrcmYQHAtH9Jhz7VqArHy92mXXeVyJG65zTt7RuKv86PJJxWW
18737	payment	1397	1397	1678	1	1	8520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazH73yuQKpmzz8yCdaFxZYeeHK7nfEdMGE9M8LkrYaSwhHvcZ
18738	payment	1726	1726	1874	1	1	7781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYi4pFKXxryZy29BWmjkj5sxquKj57rhkqjfz6HpU8LpbfA2F
18739	payment	1397	1397	1678	1	1	8521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpmzGebGd1QkSFHG3UpsjVMcsjfddHFq1Qc8XWmzFfUwhMY9E
18740	payment	1726	1726	1874	1	1	7782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTfQwmZ5Lfyiz8fJgUbQAcWexkUYJwEhigv3scn1vNcXmGuUG
18751	payment	1397	1397	1678	1	1	8527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKP6fhPLMa3aVaTAcG9syAJyCVVneWZVraYrCGUwHHTqY9NDG1
18752	payment	1397	1397	1678	1	1	8528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JbKWB85vueNrWsnTeyvwiketc8EpAceqyDgotCYYmPRyv9w3
18753	payment	1397	1397	1678	1	1	8529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVHhwZXWzu7K3QxiieQpKz1dWUuQxYCQrSJGrCDFUqVJ4xTSX
18754	payment	1726	1726	1874	1	1	7788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9scp5afSnQ624QusH5oe1mj5cdMPgRS69gcdDYkjnCWHnbcVB
18755	payment	1726	1726	1874	1	1	7789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYtXTD4JENdamRFMomdj1tarz4hSPENhbkdZotKv3rbGJ3Hs7W
18756	payment	1726	1726	1874	1	1	7790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh31r5oGNMiHvoG8Vp2TDA8EMPNhgTiCjBXHV22YRuBM2FNfHD
18763	payment	1397	1397	1678	1	1	8532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9eRtCacPdPwHuqJU5gNhJUSQYhkBarqSwq7pJwSSUpEMBd5L
18764	payment	1726	1726	1874	1	1	7795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVQfFjZwYurYvMRmQsn9Zrn9Z7wWJtSGL6LyGJUSXvx79tmEK
18765	payment	1397	1397	1678	1	1	8533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedgB9157NMFSRxCmaA24ueq3Qwke3yxCkvmubjpRxYXXYask7
18766	payment	1726	1726	1874	1	1	7796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Hd2sr1ddMbvQaMTnmHQpKigtsCe6WTLsRRd5bob8rUx3aCnD
18767	payment	1397	1397	1678	1	1	8534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYj9oueyK36SNXY9bfQTLWZbwRsmu5ujvdykyhGHzdfbkDHTY
18768	payment	1726	1726	1874	1	1	7797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXGdrUBqERRQSnPXCM6Dgvq9wtkq5rNYbrvZNLWEbLPKysLpn
18769	payment	1397	1397	1678	1	1	8535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uc1FJExwsn2iQEAC5bwP771KQYK8DyUbAtPFWkzYLaUSAcVr
18770	payment	1726	1726	1874	1	1	7798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kMatgWCYcqQotSqhinV76W5DEedrUi3dU25DdjmrRU3hkbJn
18771	payment	1726	1726	1874	1	1	7799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2dxW2UNvZQJXqFvvXMwrqj9Co7nDrSWGaWw1KbY7JzWhYLTP
18772	payment	1598	1598	2124	1	1	0	300000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBHs8ynBWbn2mmQxnhsTiAjKFdXtFJe4D4Pc31QvZymvDn3aX
18773	payment	1397	1397	1678	1	1	8536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqicc1Cb9AvzgWMJsepSt5LSn6WUU88iXfuD74rvuhij5KJLeq
18774	payment	1726	1726	1874	1	1	7800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDzVLaT462jhjnuTVdu3mo89g2xhZUAqGXPephGMn6S7H4MVv
18775	payment	1726	1726	1874	1	1	7801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrnL2ML3hW29MKnqzgWEqfXqSg23p5ZLCL3NLR6BGLFkYFtNm
18776	payment	1397	1397	1678	1	1	8537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERdvs5ZCu6rkezEkNt2GVj7HFmBxtbBHi3VNgxNApWMxfJmWP
18780	payment	1397	1397	1678	1	1	8539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZb8Zn1FYR5F16UeAxpjHzKAzGRjQ6g3Tvz5p7HhnUqnohWG9m
18781	payment	1726	1726	1874	1	1	7804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGhLjw5Kx1xXwQXhWdNJUaAYvZMLYVoCKy2FQVCdHvjvSTQnx
18782	payment	1726	1726	1874	1	1	7805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiCmXUpASaHxw3v6Qf8fw5grPUj845r1ydHMnMQvC6aYoFpRs
18783	payment	1726	1726	1874	1	1	7806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvNi3d3fJsXgFgjsatCTRiD5iW24oSehNJMaGYA1hLHwqrq8X
18791	payment	1726	1726	2125	1	1	7811	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ2pbEJGGx6NmhwRovYoUxCqJqHkiFj3gy8EQdtXTz8cjfuAJZR
18792	payment	1397	1397	1678	1	1	8543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmWPwm3zxwwbMQKRvCja9GVSYNxa58rvwjwhaNtQVcf1PxpsG
18793	payment	1397	1397	1678	1	1	8544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAry7tRikKv1G7xQGmu8b7D21sCvgiXXzv28m6z7mcukzbMSc5
18794	payment	1726	1726	2126	1	1	7812	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZb1bun6BwdK36Svir3Dj4GaNr5ADymPutrnY9fqMvFUFk1xDLV
18795	payment	1726	1726	2123	1	1	7813	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSSUMoTYb87KYhXeCJddTnipw9TgjUY67sNnEb78Y9UDRNjhv6
18796	payment	1726	1726	1874	1	1	7814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9LvdxVCEFZVeKWgR4L9R12i8vjPLk4UK4D56SoH2tbLexCWc
18800	payment	1397	1397	1678	1	1	8547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGpdi6aH9T6UVzXKDWhD9KhuTLmd2VgMcB3j78QeaotimL8P2
18801	payment	1726	1726	1874	1	1	7816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3LufAJUy7X4fEzYarRfQbgToVWo8WkVLSQ1XSzJ33D1wokJJ
18821	payment	1397	1397	1678	1	1	8555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Tj5Lb5Di5MS8wTHftez758qdp7N1a3UQ3LtSXrjJi9W9d3m6
18822	payment	1726	1726	1874	1	1	7826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaYpQ2ufhXy12tV6ysKmE5FkZU24tRCxjWtXXPXQ6JV8NhgJi
18823	payment	1397	1397	1678	1	1	8556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxtvxq9TH5TdAXU44H6KK4mE8hsgRvuwqGMoZxNq5sekgTMRFJ
18824	payment	1726	1726	1874	1	1	7827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMEVHPwCx4zbdDJgmqpDFu6QPwYsqKe4BiwKFaGuuSrZS7HH1
18840	payment	1397	1397	1678	1	1	8563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BJ2VNxEyY2bjqJkAVkpr2vcdDY6UsUcp9vZL33MUuiYcWRga
18841	payment	1726	1726	1874	1	1	7837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEhTfcwsYtxBqVEjfXVLfUdusX5rMYk8ZbngcMDtaRwvMRHWL
18865	payment	1397	1397	1678	1	1	8574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1juhLtYsKAYV4a4ThHAs7RZc1oWwxHqU3hvtV1WjYX3FdXXE
18866	payment	1726	1726	1874	1	1	7851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwqhthMwuN9EWkBf5zn5waHFgh4pSpRJxULKASvApbFJ6pxGR
18867	payment	1726	1726	1874	1	1	7852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHFJsWnvnAaA2au2awcP6qDrCrVYJUoM1cmK84QrCzuSyzMkh
18881	payment	1397	1397	1678	1	1	8581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxoo8KYsf1WXSeYtpDWyWDHSj3KZYT6U9G2FETupsBTBsFMpd
18882	payment	1726	1726	1874	1	1	7860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PzTe9tbkufZBox5vWQ8QgVPmgc4Y4DakiX6UG84SBTC9g2Fs
18883	payment	1726	1726	1874	1	1	7861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZRKecb83EovDByAiepWZyxBrDMHPvr5o5fV4qpikceTRuLAB
18928	payment	1397	1397	1678	1	1	8601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwpAW9eRPQudXuhePc2kx6DrasV15JsaFxsi3C6CiFg7kyDH2
18929	payment	1397	1397	1678	1	1	8602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtpj3AeET3rLu9h7Fzr2yhgvW1UJDwyMMTabm8GUGinh8MLV7
18930	payment	1726	1726	1874	1	1	7887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sJjGPALLbcnP8CKTHizMLBhp1BkaERfecczurnwhnDNeENzr
18931	payment	1726	1726	1874	1	1	7888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUt43B2BN7vXR6xUUC1GQtRXxidnaa1QcN3KomEKVUqEDBPF5A
18932	payment	1726	1726	1874	1	1	7889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrF7zZ8iUcdmzsjv9yZaNwSaRsYBCNTf45vTDX4sKa6Juv7pAp
18947	payment	1397	1397	1678	1	1	8608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhqAy22WHe4BQYzM8kRaAhCy71oLRdHS7NZqi3DYn9FL7fZ3m
18948	payment	1397	1397	1678	1	1	8609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYej4XrndnZyw8ZHYJ3piHXJrVoW65qAvKhdzaSczbWjK3HG6Y8
18949	payment	1726	1726	1874	1	1	7898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzK4dneFrLCE1F5gnTKp6ipnSnJuVqxLKm2iDibNoP5U96ZcrT
18950	payment	1726	1726	1874	1	1	7899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTiuXKSnQBtbYX9sQLKUo3sTNePNhAZ8pzBAzC2DGUjhNVGMy
18777	payment	1397	1397	1678	1	1	8538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mqQi16n333Y1XWu2eD1LMPU5kEDtESdnDzP9mfG3A2Ts7t6H
18778	payment	1726	1726	1874	1	1	7802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DDzwWiaMFym3xM1g6QLuryap9qVyUTVVVaUBRkUUX4qAeiUJ
18779	payment	1726	1726	1874	1	1	7803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZivrCAJdhotePAmoymGimL277AbwYTh7Ui2Nvq2UHTNxER1V
18784	payment	1397	1397	1678	1	1	8540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa52XW7DN4hLxUoYYtujBA85ULR1qCsKALmNBWLJQc61BhqvVm
18785	payment	1397	1397	1678	1	1	8541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCoAafGeK2NmG5f8MfKgmvbqEeu45bHkSgtmpMPTEjKc3ppFZ9
18786	payment	1726	1726	1874	1	1	7807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND1HnvemwY6fpHpn4tauxxMpQ45MXH7kd9Fi3TmqbU6XRxcmf
18787	payment	1726	1726	1874	1	1	7808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmY87zrCSfnVX71bw6tY2eUgW8xrATmWvSCytrrVnkTQqdnebi
18788	payment	1397	1397	1678	1	1	8542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59doufV1TMuqyRnMQxijYr1EqQg9JdVK9j1Yj67aevUgm1Mbr
18789	payment	1726	1726	1874	1	1	7809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjArHKPS2dVwwNTZcWhU4K1eQJeJ8xzehiFboeA8kwruXG2ubf
18790	payment	1726	1726	1874	1	1	7810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegCVjSiLN6xoRPBNoXheLayeWtuSqSdJENywkZvN1NFi8SUSc
18802	payment	1397	1397	1678	1	1	8548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzQ49Atmfc8baPogGePiDmymGAX3dR6p3ih3tHf5N3ff1dmdz
18803	payment	1397	1397	1678	1	1	8549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGujUA1YFL6cjLmJkAVw9hXXU5SCGLL9e75bi8DZH9nJ5J3UNC
18804	payment	1397	1397	1678	1	1	8550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2H14PUg6hADChypThk32oKpig79ZG24wGMhMzQzc3b3C4VCGh
18805	payment	1397	1397	1678	1	1	8551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6oxv3irjKkd5BNjdyBVD8Q8smTAKcqSRDiayZmSwYxMcwQQJ
18806	payment	2125	2125	2127	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEj63gziPqkoozgF6y8BMFYJ1RUg7ZKqSKWdEYcUGBbeco39B
18807	delegation	2125	2125	1407	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwN6tnUzjLB2AkzjGJppYhZgSpd1iuWCcisX5jUvrvvd9Hq8Q
18808	delegation	2125	2125	1403	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycgTvQboBQVwo8Hb8xPrmRVY5an7fYoxyb8CqBcAi6ikq5ady
18809	payment	1726	1726	1874	1	1	7817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2faSxcc9pYQCJMvKpVD4MVm59XBQj68XghbgCYugHmZYDpiPF
18810	payment	1726	1726	1874	1	1	7818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9iyucoMgisdBay6rShmgoULaacwq5HNzAAD2VPkZhGAyPGuen
18811	payment	1726	1726	1874	1	1	7819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyKnwVT4wU4eGngjqmgBwQbpoHAoFVPfQDvXqEkQVSEzJzLhpg
18812	payment	1726	1726	1874	1	1	7820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5XMfhqKWdE4kEuZGMd77k7ULg8cQRQmhXTBcSu6jMrG2123f
18813	payment	1726	1726	1874	1	1	7821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZrzUKVR5QAi3dRMYjaRdBHkKdrHYkX7dwc6KBpB2sCYin4sV
18814	payment	1397	1397	1678	1	1	8552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTDEc3ah7HUy55mEMjVozFWVZBEjc3BGquyc8RBC71uZ23ADF
18815	payment	1726	1726	1874	1	1	7822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBtHM5K8jLyzmAiBRuWrpX1GYrokssb9T7kicsUrYfqptTaKc
18818	payment	1397	1397	1678	1	1	8554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MqastXoChKMEUAVm1iV3CPFf5LrMdZFm9H6s4qRCJhaVpDXb
18819	payment	1726	1726	1874	1	1	7824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMe5APF81Y5deiH8Lm147HiURKbtq9RAPfrWmHiNHyhKnzfjU
18820	payment	1726	1726	1874	1	1	7825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSGK5uzm2CXTTujCtN9prgXFbKZaChboAE3BZAGnRPmnf8EJR
18830	payment	1397	1397	1678	1	1	8559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATDcwkep6c7jjgyZfLS7Re6Aqh8MM9YtD5Eyjq3jpyCXXY64Z
18831	payment	1726	1726	1874	1	1	7831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MLLPvrBtUDJEn1dYVBtEfKTovC9kfzHD5EMN4Qon82VQB2NU
18832	payment	1726	1726	1874	1	1	7832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41y4JAf4vKJEwDz2WZMpJLQoTH35HZEuXt9CXGuJLH6zpTJbL
18842	payment	1397	1397	1678	1	1	8564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawpvfFbfjSLjkuAsKqexaXLocdPi4kYRUMMEhXc8bbvB6Tuy8
18843	payment	1726	1726	1874	1	1	7838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpMyJQbQRyvqUeQTNS3EQoryTuWudR58yyj8YqHhNFw3oQFKk
18846	payment	1397	1397	1678	1	1	8566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SZiys4mwPpAtcATFGzQzEVh3gQFKESybEHFjs5UrVKn4knqH
18847	payment	1397	1397	1678	1	1	8567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4X1b7iQXHCzFzXWsPnJwCrvfDhiPLWrPkWfys7JCR4whkSt4h
18848	payment	1726	1726	1874	1	1	7840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJ4yiZQH8QsquSgJBQPdLc5rucTMGC5sNJ9RTs7kH9uihFdsT
18849	payment	1726	1726	1874	1	1	7841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWVGbBqhVQhASiNcTwVffmE62oCMfWP8rXCQgLibRLbCHYdg6
18850	payment	1726	1726	1874	1	1	7842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAzfp4MfeTPfihUEcKieXbgKx9QKUipzpmUmA7ByuHy3otn37
18858	payment	1397	1397	1678	1	1	8571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoDFZkEnjmcfC2YJeotobt3DrxdfqDG5VqMsDCFmhEKKn9WSd
18797	payment	1397	1397	1678	1	1	8545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAZGNDXvv3aqZ6kNbmBpevvH91aSbkyrh42hLn62vVkMk95Ai
18798	payment	1397	1397	1678	1	1	8546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnunqf11iu4jjg5o9RDgidnHxuDXcmU4CLd7UapkRqsjhqrgk5
18799	payment	1726	1726	1874	1	1	7815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqUAmjaKr82Tqg5sy5XQcGmvtMMqTUfaBW1fBsx51G1P68QJe
18816	payment	1397	1397	1678	1	1	8553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxmz4u8MGP3DKX3VAQVBnyMreaVxqnz4wDqns4m6ktwrArFz6
18817	payment	1726	1726	1874	1	1	7823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVzxfCqMnDT115ybyH2erMfodWAWzLxS2d3hpjB6gFth3vKw7
18825	payment	1397	1397	1678	1	1	8557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyJmQCoWKS23LNmoFJAxG8YbyvoXT3XacTSa9QdGDL3PV4e49
18826	payment	1726	1726	1874	1	1	7828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkJjR19VeVeFXtCsR9cezyk6QcfGQr43kK4ikrgbzujE3J77R
18827	payment	1726	1726	1874	1	1	7829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsSFPSgJoMyAA2uwzvc99aPk6FRFFAZmyd9kou6ZKt34PWmPa
18828	payment	1397	1397	1678	1	1	8558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAqQHcxE1kewQUPbFSMuDqxqWf4bEMZnpuwiXE5cpiTr2J8Gm
18829	payment	1726	1726	1874	1	1	7830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZx8RSag7hZQJk8cpwgKVA5zjmjEYCvtcLNUWroXnLW228fPFc
18833	payment	1397	1397	1678	1	1	8560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivunwRkKu1frA1nDKGsWX2XjRgJwkt3akw5cUpkhNGGQ7TvzK
18834	payment	1397	1397	1678	1	1	8561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JoNxXJEGKEuDuQFKjoJogH1jS6rBzjykHSEFMLh3JfQ6Ag5n
18835	payment	1726	1726	1874	1	1	7833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8yfSrEog1UL8Tkg1keUauH19acfJBpQkH68hxfj3g2VLBT1bp
18836	payment	1726	1726	1874	1	1	7834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYcZw5KQtFHhpG3FXnqmzR9Dwb1TgHb97kYMFBA75DgEQdvJg
18837	payment	1397	1397	1678	1	1	8562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsw1pcSH7iaY2tvWNMxq1TYDHHtFzGDVrLKxnEambZ8W7KD85N
18838	payment	1726	1726	1874	1	1	7835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGSjsiNgBh71qjTfabjjwkASQbA9uFkPeVSTmijJZPVSmnNw7
18839	payment	1726	1726	1874	1	1	7836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VLTptHdCe3TUaNb5cJiRYwj4jSsyXhyzPn5Qzs75XKKP7AXr
18844	payment	1397	1397	1678	1	1	8565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgEQeSUTcmeQWNDyx1c2spL3JQpntCjgMkoo37DEscoLhEAtL
18845	payment	1726	1726	1874	1	1	7839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUAbKgdzCw4PaYDP7wujHDZkpT8yTmrGHfP1A2ggvdgn4bnXx
18851	payment	1397	1397	1678	1	1	8568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpH4YdVe3pYdagu9YKZj8jZuWG7e9B7LDGsEJjV1RBbjQAK93b
18852	payment	1397	1397	1678	1	1	8569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXESb1QdH6oR4CbEt3Gewerg8SZWQv1CL8RedExqWALzn5nFyx
18853	payment	1726	1726	1874	1	1	7843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQPhi7MzSFYhDhfjbXrip2547CAkP3yscqAwNZND3a8T2MGzr
18854	payment	1726	1726	1874	1	1	7844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaw4tfWh2DzugUxsUxbznvPAZ11Vq2ogjhcWL7aEEWi2jJM6p
18855	payment	1726	1726	1874	1	1	7845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1muqhmj7p4x7soCatp1nWr7GYQQPiyLCgsZbarJMVmdgbJQf
18856	payment	1397	1397	1678	1	1	8570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdiWFhQtdwzXcJRx3miB1J3RtHwM1PyL1Tk6R7e7MeKJbtC1Qq
18857	payment	1726	1726	1874	1	1	7846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjozbpxiX8jx7kPjnQbc9S4NVAut7fxPZnYdVVQp7j92S6CEF
18862	payment	1397	1397	1678	1	1	8573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiz52a3SwYJ4XevwRPgV8wxkSAqijMmW74SDQXA2L5GeCr4F1
18863	payment	1726	1726	1874	1	1	7849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWt4EALqZuZBBU93eNfuUktbi2VWqTSoyCznmxtd9zEEu8iRFE
18864	payment	1726	1726	1874	1	1	7850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8JodPH3CpFEWAP1z8GjMKfqxnSMJSadaB6WxaS8DHBnD1QvA
18872	payment	1397	1397	1678	1	1	8577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZED1amWjtgaZh9MHeyTZxG6hm97WrRP4gam16r4t5R7mFXv41h
18873	payment	1726	1726	1874	1	1	7855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrii1fbviEDCwJsVxzpeFQjAKtNc72ygr1Edxs6aaph2NpWXm
18884	payment	1397	1397	1678	1	1	8582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMBdkFxXm55uoLttg36hVetwfAwuLGeikVdm2XN4DLCNj9ybh
18885	payment	1726	1726	1874	1	1	7862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5h5inTNM6DKLUT9YuwPJZbrcAYPcsLoeHjBa3hNaFhcJSr3E
18891	payment	1397	1397	1678	1	1	8585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihacY9FtAw9aL2DqNw1TLNpVEbJ8zQB1MFnKBJAvVafaW3ZaM
18892	payment	1726	1726	1874	1	1	7866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxLpEwUQjHs9YtnE2ZxiofrWX8Cmg48ECFJtBiuFgLED9JNVD
18900	payment	1397	1397	1678	1	1	8589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtwWMYpeanNxGhkjayw5VqZjZuRGopRYJxDbATRb3Dhfygp6J
18901	payment	1726	1726	1874	1	1	7871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBv5XcmuNpLaBXnrUts8wn2MYr2sBCAmpreU45hX8AFHzc4ASa
18902	payment	1726	1726	1874	1	1	7872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nUUd1dXcpCwgVk598xVjEw3BNUBcnwowSG75bjo1wxGybwWF
18859	payment	1726	1726	1874	1	1	7847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV22xYybRJvzsccFw5Ftys5z8Pxmood58PJjiHKfK2TxAdnFz1
18860	payment	1726	1726	1874	1	1	7848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfeTJ6X3tL3fEei1PQ44VgNiqM65jQmgBVDBd22gheTsmGJG26
18874	payment	1397	1397	1678	1	1	8578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSXMyMtad2SKWwjrvYjxi7uz7tQfbntU6gDoneGks2bqBurQ7
18875	payment	1397	1397	1678	1	1	8579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhR9XqGf1VEVgUL8PbhXAwYePvcXyHiXYwG3jCSygZt43WGEHd
18876	payment	1397	1397	1678	1	1	8580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixNZYMPEudkAKPKPkLDT5Wvyntc3e98BaLsdjffpv79ocgoHa
18877	payment	1726	1726	1874	1	1	7856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5VCetJ9LPGE19fL3MpEKzqn9E1kAwbgYjhtHJYw3UTvn7ujT
18878	payment	1726	1726	1874	1	1	7857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyq31fH2gZiFmvvWERcjbxi8fgNYwpVwKmbxHa1XPWi8GX8wm2
18879	payment	1726	1726	1874	1	1	7858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36S99iCW3rmtGSXMxtphPuHu6UxLt7fNVuZDqDVNx8LXpGhD5
18880	payment	1726	1726	1874	1	1	7859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCz74btSGsiRyFheXJotW3K5yXSHZujUQ6Rsok2tLeVBf1YzX
18893	payment	1397	1397	1678	1	1	8586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwK1ccMWEYvpszdkFFQrULjtVZ3m8Xk5TfCMEfzQnUh7BT5Mia
18894	payment	1397	1397	1678	1	1	8587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVxKVs2f5YysY97SjPnZEtJ2oMDvUVocHXdANvoqZjkmj6VPm
18895	payment	1397	1397	1678	1	1	8588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SCoHJjTs9GH5jEp6HkeM5XJSURdbZwXH596PrtozjVwqXm8r
18896	payment	1726	1726	1874	1	1	7867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfLRaaY2pWoPkTuC76an4PcBhnKaQs9CL7FdnopUnje6HHoU8
18897	payment	1726	1726	1874	1	1	7868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzqyN3bZGYFi9A9i9y3xJAauoT7FNr7jcHM7ufAzmYRHGxteK
18898	payment	1726	1726	1874	1	1	7869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjReAPP3tC6ArcxZe6LE5BBQfg8Psb1vW7VVHQSstmozfCEEG
18899	payment	1726	1726	1874	1	1	7870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXWBHe6E9MGR8TFVnDaL8EJFFYAfM2VrZEjo8jtFUJZPehf2k
18905	payment	1397	1397	1678	1	1	8591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF27puEM7czcaogYkN51pZRHbiksmmhSnGrf9FVaYPcuqTCTaF
18906	payment	1397	1397	1678	1	1	8592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCkHhhoUE8sWRK4fYZRRczTu1bJpRgrRXsjPDDBf3YFoALAHq
18907	payment	1726	1726	1874	1	1	7874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDZp8gZ2J47RcFxZ24iciSDTNutSnKrapY5vvceXZTuKq58sd
18908	payment	1726	1726	1874	1	1	7875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAomYWCtaZusERFZSqMsPX6ZZwT27T8pZfGbdVumh97HHY37yv
18927	payment	1397	1397	1678	1	1	8600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHBHDmUKjTFqaZUKNgESF9EyS9AqzQv8V45aUAn3Z8bwMZ4fX
18954	payment	1397	1397	1678	1	1	8611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15uN5zUFSGUpzdYoqF6noTLVqtGVSEqQAshmepTwL4xJUqBtm
18955	payment	1726	1726	1874	1	1	7902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ygPttnZrPng7zGyeqRp5RH3e4PThwZhnvbbwwkzJaAv9o56C
18984	payment	1397	1397	1678	1	1	8624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQ4qknBBNtesBurAMtzxUjytDfWfnq77q8qMgVaAzjyHrHmgV
19012	payment	1397	1397	1678	1	1	8636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1FYsYCuFgr5SCUavXYBfdxbiKbLsT8k5vCkwnbsxKVfwK3cz
19013	payment	1397	1397	1678	1	1	8637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa91T2c3usq1TWkZLzDH7NWRrWqhGz2beYiaMCtuyZy4vRKftsX
19014	payment	1726	1726	1874	1	1	7935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDU1KnRNmtJJhfK6KjNGMD3H6ouDTagKZZKYDj3wXEVSiC3em
19015	payment	1726	1726	1874	1	1	7936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyNV8g3r66mtW5k3PpB4iC5hUP3s2RuvdwJYRzNyDh85F1SqS
19023	payment	1397	1397	1678	1	1	8641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmQPQ6GfBpzvj6VdCt6F7j6FGRKViC7WvwikthbCKRKbYej3z
19024	payment	1397	1397	1678	1	1	8642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFU1xM3CTZxEoRBkAzz87FiXxdiuNUoZvNCVnbQd9bW1XrFWJm
19025	payment	1726	1726	1874	1	1	7941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGJYCVkzNKXXdtKj9NG8JB5aYYaDr28vo4UzhYJSiJWby3LTP
19026	payment	1726	1726	1874	1	1	7942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98zTrVG4LW7mmRkFLg53XDke1cZKcqRSLCZ1sECvCwbJo345i
19027	payment	1726	1726	1874	1	1	7943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNyybzWdYuSCVwEd6xwYQY4yBjaaKLRjdduJcXVVjN32JBKmm
19050	payment	1397	1397	1678	1	1	8652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6uU57sAUhFTqrn7Bcrc49REbYedwmCqd5z8NY3TmzhgMZrvn
19051	payment	1397	1397	1678	1	1	8653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaJZUoSQjvMtKMRK6yrkb49AQ1JQ1wHekACS2eo3TV6gG6bUZ
19052	payment	1726	1726	1874	1	1	7957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCAN67ptgaBo4WxwvKsi1UeEuFoTcaQd6aa7a6SEFXM94zHEe
19053	payment	1726	1726	1874	1	1	7958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2ggfUMqYJMQyihYrfnmBvYCEYFJWCj5U6WU9m5CNtm8woy16
19056	payment	1397	1397	1678	1	1	8655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTAvFJLiCHQa4vRzxaPurhPSCUQBE8T1hY4PK1863vmyeJGy3
18861	payment	1397	1397	1678	1	1	8572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwdQWTzf8wVyARfw3j8zRpTXHtjRZzsT13GjVQW8rPcQJp95d
18868	payment	1397	1397	1678	1	1	8575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEe1dX6jufxKwPoAmmFJddVhxmcHxFjaxGVJstP513pxqXKR2
18869	payment	1726	1726	1874	1	1	7853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyALk9bgHXcHZGFQ4EYCN5vSF9A57Nipk3dwkpp51jENgf3Nw
18870	payment	1397	1397	1678	1	1	8576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7WSYeB8gWvg6CKdf5ZVvvKRdXJ8adPksEJQEP3FAPBd9YfA2
18871	payment	1726	1726	1874	1	1	7854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcvpgaWJmXcjjjLyvkKmUUoZ9yBQJGY87PJBEBTkMXHiFjayW
18886	payment	1397	1397	1678	1	1	8583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XSiDxofkczPQFGjTVhptfN1qjPHyBZkjVGKQvrxZVpKytjsi
18887	payment	1397	1397	1678	1	1	8584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaewpU5jA8xxs5YLovb4UKbNFDxAAF5M44jEWCpbkbZhv91GQY
18888	payment	1726	1726	1874	1	1	7863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPb1GAXtyZGoiRPgL5dkoKTuPzDRUV4zEr7dNWuY9QNMSaejvQ
18889	payment	1726	1726	1874	1	1	7864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmASyZFnQUGdQRc8W7WWpDD4UZdnjJ6Cw6aYWMdVCQYTWJfzpR
18890	payment	1726	1726	1874	1	1	7865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYhm7oHWdzS85JbcDuwSBLvo34tLwS7HDmttNk85WnsyK3ZF1
18909	payment	1397	1397	1678	1	1	8593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtqZeCxu6dgJdPojnFykk6xQVUsrb99FXnDxE4ER6Ku6LE9cVw
18910	payment	1397	1397	1678	1	1	8594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VzibjBppKDHUDDakBNxZBL1KRU4QJbxPhgLumCrpMH4AE2gB
18911	payment	1397	1397	1678	1	1	8595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UEvRo1YvWKP1yk5yZVRhLTjj9vmNw3WzHUL2UDzwdBmXyMSs
18912	payment	1397	1397	1678	1	1	8596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMD7ZyqQ2FmbjsxYioTwCvyKt83VpmtyQApNcbafmADWUcoJ9Q
18913	payment	1726	1726	1874	1	1	7876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1heyAiVvmASm1L8VfBz8EBEkGeaEZzBgt1YHi9MnekvuryRk
18914	payment	1726	1726	1874	1	1	7877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQW9f9RsbYaZV5aAj8eqkDcRb8m48yR9qx2XFLXwMgrJtPaX7
18915	payment	1726	1726	1874	1	1	7878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Vs2XBaHnbed7EaKNWSeFnzvJ5PE4ge2ekrTHhnmA9dRrGGUy
18916	payment	1726	1726	1874	1	1	7879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfv6EVcoVeYA7K3v6Kk4u5EGuYxivW9gCSwycFGjr9L3FNkHui
18917	payment	1726	1726	1874	1	1	7880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrj4TdPu9EpQ4VLbgJ6BJ6FpB87X2LZdG9qkASLjj5ysQ1aJWp
18918	payment	1726	1726	1874	1	1	7881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ542tR95VJNQYQaQerz5mYswSpjVNMHsQE3P9pTswDGCfiBZW
18924	payment	1397	1397	1678	1	1	8599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiMvFDgE8Y2osiVXk2CrkE2YGKXBZeSSQY3WZKTnA6Cq5hJiP
18925	payment	1726	1726	1874	1	1	7885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YBxquYaUPJ9DW36g5bF38sEXqnaQy1rhAst73piW6uuaPLXs
18926	payment	1726	1726	1874	1	1	7886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDT7gPXn6dpY3AYUfodwUvZPi5fxiMrTCpFAWsYfGG6G71dgr
18933	payment	1397	1397	1678	1	1	8603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaS8VP6PTyh8q8yVUBoXa52RVZom9qvfGJBx2rCLiEyjhW8Us
18934	payment	1726	1726	2128	1	1	7890	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmzatVp53AzhQdBBACfZVAcgzsN5oYRvAefNmMR9osixCYuiFe
18935	payment	1726	1726	1874	1	1	7891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8mvK6PqriXPdCzDY7EyT5CxvZtJkTVuSye39MM44DpNs3zdq
18936	payment	1726	1726	1874	1	1	7892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjuHVC1homWfqjGLf8W5AosdDvTJiceR295J7ZQ5ft66oCKM2
18937	payment	1397	1397	1678	1	1	8604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcgnB38C8a3RsNWe4Xeq6QqVhsDvQMp1BqofQ5wU8kZQ46pQL
18938	payment	1726	1726	1874	1	1	7893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSJsTVUJDVaYeWCXDt6rPzivNVcWBAGqd3Sa9GKPQMx4KThmn
18939	payment	1397	1397	1678	1	1	8605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdai7W1Tmc5vmjmo1HZMwVCb37tK61k3PGdztFBT3Ujcie3jC
18940	payment	1397	1397	1678	1	1	8606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9pSwP9jrSVyw7ianQQbtESChwvWUzWnV2eWeLkRNuC7L9vqP
18941	payment	1397	1397	1678	1	1	8607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGK8bVvhKYz4WvPLJutcTeUVPjzxJ5A6R89SVEGmngHZK5T1a
18942	payment	1726	1726	1874	1	1	7894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYvWwr1BG7eKQmxA3ixw46uvHvfoUGqx7Y8YMrD4UTxV6DaR1
18943	payment	1534	1534	1694	1	1	0	4320000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kaia6dmHhmkvEgU7yZbcKCirsfVLmi1ohie2yQv2Qt7n4a1i
18944	payment	1726	1726	1874	1	1	7895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAX6wCk358cqBDxoMoTeuKVcQNsR4qv4R5Pgq17BaD4ZLxy2rn
18945	payment	1726	1726	1874	1	1	7896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbX5WkEUX3ysKYE9Z9P2L1n4G2xn52pmUCAyPrm3So4QttkuSJ
18946	payment	1726	1726	1874	1	1	7897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDWLFJDr6eCHaJ6wgKzZ7AygcaPvEDoBHfPprkAf4Zu71eYVJ
18956	payment	1397	1397	1678	1	1	8612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9nezH7ggrGC17iZXTJPGkqoEMQ9ToddA62gCDNRgxVWuZZR4
18903	payment	1397	1397	1678	1	1	8590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEP5aqRVKwfyaX9RSWvfEi9bpGFQZ6JKJyYdRkKD1ESEArDgY
18904	payment	1726	1726	1874	1	1	7873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaVSFTY9gThieikWyneJkRDDdJ8BVkM3HQmDX77EQ5cEpoqeV
18919	payment	1397	1397	1678	1	1	8597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjbnV9mBEkqvwXRpbrxR3im5GRBHpJWLvr9RimcX8NSRRtv7o
18920	payment	1726	1726	1874	1	1	7882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHxxegdp3g77XghzY1mWHteRaSsebUreaUegDMNSuWNKrtMpx
18921	payment	1397	1397	1678	1	1	8598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rgs443pAsHuGk7q1qmVbgmMBa4fC2hrs8oq3Pb35c3nBk987
18922	payment	1726	1726	1874	1	1	7883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QHPB1u9bgQtY6doXd4bPwrz36jAsfAmTrPVNYkqtpHeVC6X5
18923	payment	1726	1726	1874	1	1	7884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVWS5iheBBb6SNy12xVdN2CRUcfhCoUuvX2FHEir6bnzJ9HxR
18951	payment	1397	1397	1678	1	1	8610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQaTZZwz2nu2UuXcY3Mbbv6HYMGzyByyJJkdZbFYK1uLzyyUx
18952	payment	1726	1726	1874	1	1	7900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxchEnVdJ54eEDDuD5jiVHuhUouC7QkzeGPXMcuzzgLzd8r8di
18953	payment	1726	1726	1874	1	1	7901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJJQ4ofamw2P94KyxvYVtyrsZxdV5qQxhyZRkgQniGomQiyUK
18957	payment	1397	1397	1678	1	1	8613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa5ThLRMF6pLy4Kv1XKWBPxvBEpCvoQnPCvEqUgaavWowPaki
18958	payment	1726	1726	1874	1	1	7903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYUyL8q8m4Eo4UJB4qFAgJduofKXZu4pmmoXKadWS15deCiLuh
18959	payment	1726	1726	1874	1	1	7904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7puaWHogTQ7gFVHVXYNaMVaX7Qkca2niqsBFSHee3oUsu7SzU
18979	payment	1397	1397	1678	1	1	8622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUNTU6Vcr22Gvm9CSeawQE6WCQiCVmffeAmHxCBqUc22dagU2
18980	payment	1726	1726	1874	1	1	7916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4P361HVDspjYqXkanhZSvtMcbop4HfuvjBL9eaM4Vhx7qtLoo
18985	payment	1397	1397	1678	1	1	8625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85GunK8w2xiY3XxZZSuLrhHa5s6koTvUmbvBW22P3gPF8UxGi
18986	payment	1726	1726	1874	1	1	7919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybrfCGrRas8uCVsFE28qSS83e2vpyZjULenzZTjjrVNrocNJQ
18987	payment	1726	1726	1874	1	1	7920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxd8xeb6UBJYUyJC6ssCKDfG4sFYxfL2XuurNuheaVHkSVezv
18993	payment	1397	1397	1678	1	1	8628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp33p3s5HZkXmxtRPDEehC69vwWu5dmRU1Hgsf66622VeWMA7
18994	payment	1726	1726	1874	1	1	7924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qP8Nan4B5gTwiszDNinpKaFygEv7tFBoCAQ4MxVUwMhYiESY
18999	payment	1726	1726	1874	1	1	7926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEuVJxtfukomuHR7tjToGUayqvPSZMhGLjvnRLaegpo4DvixPp
19000	payment	1726	1726	1874	1	1	7927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJj1w4SU6MaoKjZChNrhc8DEkejDaEdRCDzd26xMPNpSP6Hcg2
19001	payment	1726	1726	1874	1	1	7928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gSeeehdLHhxr28G8E3LnGtfytdsXq973wdbkbUtCDYyZtYJX
19002	payment	1726	1726	1874	1	1	7929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjdhvVFJaBLkypgE2ZcktqDnMN4D2RRxvHizEC6fHM6w15yTt
19003	payment	1397	1397	1678	1	1	8632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWLFCG9VgFNUBjwJ7jawxoPQ6jfj3AhavbwwmyD41ZTmyvNN7
19019	payment	1397	1397	1678	1	1	8639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWZN98Qmq33MNQAS4hokqyt6Y6qiizXNf9KFBNc3Av3UwwGsP
19020	payment	1726	1726	1874	1	1	7939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTFVXoqL5L7LUhTpUKKCFczcqCnh5T38sVP5NJZPZK5xUjaps
19021	payment	1397	1397	1678	1	1	8640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hD73XEvY5TQg5twY5DrSGr23SCjJFQj8o3RrvErMjAF2qvt4
19022	payment	1726	1726	1874	1	1	7940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJy2tmeRn358mNRBUmDLv5LD995mjehCKbpeBeZVxLyt5b6S9S
19031	payment	1397	1397	1678	1	1	8644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyViNHoRox17k71GBGBMQrbbC4fTXeFunNemSE1xuuvz2KEmH
19038	payment	1397	1397	1678	1	1	8647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYuWUzhCd2QtbL6Wg4CSsfKLNdccEgJ72aWLcWziNuam5fiiU
19039	payment	1726	1726	1874	1	1	7950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu1HXNM7u5ahTXsFxKaZdWLLEKfM4eQn7N5TT2xRwgjhGJBQj
19047	payment	1397	1397	1678	1	1	8651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jwErR5QBCSyQnLYDLBDE8dMCFAgkXbPtAPW5ADWRnY6LRJTG
19048	payment	1726	1726	1874	1	1	7955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9H5GNy43xD5vfEMkBy1mKHz8ATizSYQJnwNzBM2R2rvPGpb9s
19049	payment	1726	1726	1874	1	1	7956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDCJ49Sp64u7kRrHjY3ymATsnocJAfd1UwAMtbtirpHognsfb
19063	payment	1397	1397	1678	1	1	8658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRC6R3GfFo7PaEWRdQmArfjb1bkiiDchYJzszCXvNHEt3Urm34
19064	payment	1397	1397	1678	1	1	8659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfh8ePKvG4iTVhdwceXEpyawz8s4CVcAAuuauEMU7m8qf1ShV
19065	payment	1397	1397	1678	1	1	8660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDc5c4zDxikYjoSxSJ9ju9wZ7rfhUEviTUY6AbRG2uZWkifpr
18960	payment	1397	1397	1678	1	1	8614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG1GQ8EcfrLN9JDJMNNbucze5kngNqMRfcER4o5isgyXkWAjS4
18961	payment	1726	1726	1874	1	1	7905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJqAjt1dsuYB19B3wmyNmxtAEfKxrUyEY9KQ4nmimjyFs7bjE
18962	payment	1397	1397	1678	1	1	8615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj739tw1hDV6U5mCLxtNBb74ATYxayJh3AUBoGCEpeNaAHvJxs
18963	payment	1397	1397	1678	1	1	8616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZooVdATJtyLqnE9ozGCRrhnADaufXg7dacybsZEARLJPiW8w
18964	payment	1397	1397	1678	1	1	8617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdE4SvtL7JvaisL8oiWhWrj9TScADtSrUTA9p4ZDQqw9XQkmu
18965	payment	1397	1397	1678	1	1	8618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2y4hsi4FavtFLRDVysWjpkFZMHg1CGiQo4x1CkJ5iGpmiYU9L
18966	payment	1726	1726	1874	1	1	7906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5DGkKK7EtEqKdcEh3qsgQkPRBirrvfnYPWSxyq4VvnGRkzgF
18967	payment	1726	1726	1874	1	1	7907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjzi9ziMtjg95HomgRaJEVQV16KZjNUWzhhohVsfJo1EKhGrB
18968	payment	1726	1726	1874	1	1	7908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcn8wWTN6ficRoNGtkQo9EC5aVGyM6sUNWXqH7WVcZGa3LTfb
18969	payment	1726	1726	1874	1	1	7909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjZ2u5SfUZJWGmbgCa6bQ8JnjTJJUcJxzc1JMjgfXPQy6kUrS
18970	payment	1726	1726	1874	1	1	7910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYDehbXA6HZfAR9N8DET9oJCEMhhS79iP3Hu6hKjcCsAhqqa9
18971	payment	1726	1726	1874	1	1	7911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfk4mLArdifwXfNZqx1SPXRERQkVaTZGNkZJ2GnujrA9yGS1mQ
18974	payment	1397	1397	1678	1	1	8620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PAPduvLhZv2qTCazr7YkBcuFRyVp6FDMaguhopLe9iEBsWbz
18975	payment	1397	1397	1678	1	1	8621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTp6sU9Vs3RsFbsdRi2imiuuzpMQibrkDJjxTMVxKnLPhK6Cte
18976	payment	1726	1726	1874	1	1	7913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yLkJtafaTKzYQP5vwMMEwfiXcGuaNN9H8hh3Cg4tanF5gnit
18977	payment	1726	1726	1874	1	1	7914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15YBujrMceHQ5JHrdoq5inHbG9KdPUfD1Y8nM6DvBHtEWHvG8
18978	payment	1726	1726	1874	1	1	7915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQyqMtWUYQjr1DcfCy3pAMw1nBT6vmJGARo7em4vR8zSQiMG6
18988	payment	1397	1397	1678	1	1	8626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK47TLvFvpHu5HFExhpNB7YcHGdurTjJqvaNoVJwXg2xcyQqaH
18989	payment	1726	1726	1874	1	1	7921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJXJgPbK3tKo72i2LdQvvgBoxNxDUnPMj7nQRfNS1xxCuHGMm
18990	payment	1726	1726	1874	1	1	7922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt6vkA2aSarcmWVEkFoWeW657EamaLdtvNCL5BcaP4M7Rm37d
19004	payment	1397	1397	1678	1	1	8633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExr977nRBvWPj1Pogd7bSojuWmssp2Jt6KVaZJxWyWbpRQLV8
19005	payment	1726	1726	1874	1	1	7930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvd867Ns2sdjQyZBwrcHEr8RpaWfgWqeiFNhKKApNjMD3eGcXY
19006	payment	1726	1726	1874	1	1	7931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHRSSBsWuUxycGGwfhz2suSCuTpHJimBQ2w1Jk4qRLSEjhHwV
19007	payment	1397	1397	1678	1	1	8634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtYXB9RUgDozNZAnGrhgrREQWtkq72BvZ3d4TKzMSSEmuD1eJ
19008	payment	1726	1726	1874	1	1	7932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHw26JREavde5T5yPGnygWBuemVKk1We86HE8fcN2zwsE592o
19016	payment	1397	1397	1678	1	1	8638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHysXTasZYyn8UPu4PdjiGqwsKAPiind5xJZRrN1t82EWi3HN
19017	payment	1726	1726	1874	1	1	7937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2Lr8MrqTkPvjpoVwmyhWVzcrqRKPAhtTPgRTcEPqSpakQtUM
19018	payment	1726	1726	1874	1	1	7938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVg62MRGe9pc66omqSdTNzFd5fgP5oAwWA1sbxrYQscG52sqkA
19032	payment	1397	1397	1678	1	1	8645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJGuB46LfVnnw31MAnbwYxwr7XePaVrgU2UThpM4qF9JAaKRN
19033	payment	1726	1726	1874	1	1	7946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qeZEaCHc94gYt85ahYZgqQgE3scRRJye9ma5Bc7ipaZ3nWsB
19034	payment	1726	1726	1874	1	1	7947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizsDghi6kCn8CbbWdM3WAnKX5iycZSRiDdoLpV3THh8Dmva2q
19035	payment	1397	1397	1678	1	1	8646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4junY1HQa499MYJcTVaUiR2vVqDgeQAd6VeXu6dpxij6sbX8
19036	payment	1726	1726	1874	1	1	7948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7WE9AXwrE7aEHsDPYTWiwLyXuNWLx35KGxw5CTesSfA9byCr
19037	payment	1726	1726	1874	1	1	7949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsa9XpEUZZD5CN9UXbTBo7Wckrw2DmP111pLViCvQrrrJgNEde
19040	payment	1397	1397	1678	1	1	8648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgKjmtWXiC1K1A462F3GJKLsnRnbkzyZme3KCUkQoMqpqGxutG
19041	payment	1397	1397	1678	1	1	8649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLynifag6m4qBHYgZNLKW8s4sMSpUpYFSxcbivihVb7bPw6Cm7
19042	payment	1397	1397	1678	1	1	8650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzozt3XgQLhT4ubTty87fvERovkvbCKQsM3szk3t1rMWNpZN1
19043	payment	1726	1726	1874	1	1	7951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WwjD2qZ4ua72uik5pcmHTDCCWzs7zY1HJ6Xk1SmQ9ktvGsFr
18972	payment	1397	1397	1678	1	1	8619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wmczRPGDwJGBzaprRhUiB1mmzXJXLLxW2CCiSVjaSweSSJBM
18973	payment	1726	1726	1874	1	1	7912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqB8aZkyr3KpqaA4byvPEYVyuar8jpqfSG2oJZyWkMYDeCpHZ
18981	payment	1397	1397	1678	1	1	8623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtDRbsN8eaNBeHZ6tk7JpAGTXqtZZ681pe6UD4egmSuvHpfWf
18982	payment	1726	1726	1874	1	1	7917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ec2BUif4MoE4DvS17sND4h4hHuD89j161ZUgX8NGyais5tnr
18983	payment	1726	1726	1874	1	1	7918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKJjYmt2ivixT2yvaT8gYLRFw8WK97sBvnUhVTsn4V9Nq9cuZ
18991	payment	1397	1397	1678	1	1	8627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxi5TkjwZ1Vg9yvBUKbgjHRQD7ab3rbSqLFiLAwX4Ap9576uh3
18992	payment	1726	1726	1874	1	1	7923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACvTxorLJUTDFLKx7iGwJA7LMmis13cND9f5Gc6WhFefk1MCC
18995	payment	1397	1397	1678	1	1	8629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1cGmxhtWVrHvmqMVsdMDJJrMeqhFPcy8yxrf6gvJW69EMUaW
18996	payment	1397	1397	1678	1	1	8630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJKyJoyHjjyQntuzCCmuL4iyQKmfetdaotNdmEZ4JxpejKtXQ
18997	payment	1397	1397	1678	1	1	8631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERp8qQ7ArU6BCUJ8xCThGqAVpVV5ZY26eSP5JQKt5YoD23TK4
18998	payment	1726	1726	1874	1	1	7925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWZ4w1UVB2L5DJpa4iFhrmiVohecF3QueMGcRaYkXizLPDabq
19009	payment	1397	1397	1678	1	1	8635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53Ua8sz3ebYMBvJRjgbkLC5eaj9WZdtS3KhZrAFJh6N6P4gMx
19010	payment	1726	1726	1874	1	1	7933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB6VzTUWvzHGTj9TdDhAvUn44K2H3ecyjJvTRWJANUdEtZD9oW
19011	payment	1726	1726	1874	1	1	7934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5QkuWT7dw2Ac96Ky1TPp5s7j68mNZAJa4S8XDZ17zdgHpdKc
19028	payment	1397	1397	1678	1	1	8643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mLKLN3erLcScPcBKjsvJcF9dnmCeiUvtKcGAaehXvT5ETLXj
19029	payment	1726	1726	1874	1	1	7944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJqhYxX4Tb9fhZXqJhHL75xpnoPZUUTMYLirjbhCkeeNGPGMD
19030	payment	1726	1726	1874	1	1	7945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArGNqqsg8WcmExs6sSTvyFedZepvFJWPWs23tgNzaPERCGH3e
19075	payment	1397	1397	1678	1	1	8663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZazoVTeAG4Vxedrt5iYLT7fdBCuY988qgfQT2CA29cfoRtPKq
19076	payment	1726	1726	1874	1	1	7971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm43BZQxogS7qB6ESpVR6HPzk5sjZTxtEHGDRSJssVuoNCX7vF
19077	payment	1726	1726	1874	1	1	7972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffQ4UiLtZ1B6oyyRkvH2B6eKNMUnWeofVNBNPxMwZuKP8t4K7
19078	payment	1397	1397	1678	1	1	8664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68EnaNtSfzWJrocqrwW2sCa6zLG3rHJsmdSPTGA8CEkvjLdx1
19091	payment	1397	1397	1678	1	1	8670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYB9B9CtyHeKaj9zo7cPXAFmR6W7c12StwMEucRReGPb1x1P4
19092	payment	1397	1397	1678	1	1	8671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6gq9dyGTKf1NUuFeegYdXEuhxHM8JEhDpzkcUUCNAYNy9jTy
19093	payment	1726	1726	1874	1	1	7980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsudZqgTfeXmQzjddPDCysLFExc51Qi2oSHWZmogVwHcEFfqCo
19094	payment	1726	1726	1874	1	1	7981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWpXWKxR5GHkwQEhPdioPbKB4ULCdeSvRAt2LhWzxNGLRHCNj
19095	payment	1726	1726	1874	1	1	7982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvYjzzXg2uh1afRdL7qU7Dywcnb8jgBFx2radKi9XmEeuWgVh
19103	payment	1397	1397	1678	1	1	8675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LcmHR1TH6XC8HcmMVSVLWoTfySxnZvncxStfiucDkwTsxLRa
19104	payment	1726	1726	1874	1	1	7987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsprLLaACHkJw9761dnK9fzCc15EqrEnfgbqv4o8qtY9BKU6A
19105	payment	1726	1726	1874	1	1	7988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzvrGu5kjw3igzLPRkhh5bXpoZX1znoffEyciqVMAFakrvBdR
19106	payment	1397	1397	1678	1	1	8676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeQMVvtRC6DdEsL1mj8DPfvmtVGKLeq7A2m6ZYuCtKiSbMugw
19120	payment	1397	1397	1678	1	1	8682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddN43UnHfWsGVShyeFoMEfZMoWBdVg3cuVcfCqGfhPk9C5YJn
19121	payment	1397	1397	1678	1	1	8683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaa3SxWsWuxvjgc8qZjLWZUSaWr51Qkn2v8owLMh6K4ZP9iqMS
19122	payment	1726	1726	1874	1	1	7996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6xgDydfMYdBZfZMwaWZBMFh4WwyzucKJGtksuZsjDqtpC2kY
19123	payment	1726	1726	1874	1	1	7997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnsDKS2vu1EqNxJA6oYS6awmiQetED6kkPAxP7GPwY9oqZLHkC
19124	payment	1726	1726	1874	1	1	7998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TBWeGr6ApQ3dgzzZhUCiVmvG98USijsRmnCeadswgznyue2Z
19125	payment	1726	1726	1874	1	1	7999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnhfJQxUVgAdDaATsQxeWMQDRrnsxZe8dmJDw32HTXuSmxFAK
19126	payment	1397	1397	1678	1	1	8684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcySn6YxryvwxZ1iHmKeZmmjUJ87TiGGwwrotbf5peQajia1ZA
19127	delegation	2119	2119	1403	1	1	0	\N	1000000	\N	E4YjBKt1tTWPKDLGw4k1D8o8ZoJ9vmSfo8Wtwy68dsxcMAdWjvcZk	CkpZjViYSLJc5B1etFnNWnTXMwQhFp1Z7coEqfDD823AEGRgeoGBG
19044	payment	1726	1726	1874	1	1	7952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUtjNHnBn3q9pbNLwKFmChESCeDsLiinYYykoVW8YzjsJrexW
19045	payment	1726	1726	1874	1	1	7953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SsBz5tYJ9wDLkDxxfeYPiELLM4beHreAo1nDSj2FXQZGJkAR
19046	payment	1726	1726	1874	1	1	7954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDf3egrR3LqtW2gQroPToqYvmoGFgATgeGeb43taSuLRMJsiUo
19054	payment	1397	1397	1678	1	1	8654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXusBcivGhsuFkwKcTr5qQYzPjug4Wt5gpjXGw8fM1MnufNLK
19055	payment	1726	1726	1874	1	1	7959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPikZLPipTpUp6REYyKtWUqHPwQKhvUTRmTtH9PAQeY1kj9LAj
19089	payment	1397	1397	1678	1	1	8669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEJ5maLTk5v5CtrutFqJuFDJM4BkPdGgUCRRuSyVmeV9PAkRD
19090	payment	1726	1726	1874	1	1	7979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuyhXhh3sdjgA98R3FXCw1uvBEu74aT36sfW6UxEkaEYHFfpm
19113	payment	1397	1397	1678	1	1	8679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTaLD3Xwwfbi8rGM3st3ccS3vgjzd1uC5BWsDt1mr1AiyCrKH
19114	payment	1397	1397	1678	1	1	8680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc4pZccKpjcdKGzbqmuMK8W7nt1ZbuzA4858TmgjaGnNiKT6A
19115	payment	1397	1397	1678	1	1	8681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYdbELLc3zcJwopaJ3cznu3t2U6vPamdRSp3VeVrLowLdDwA4
19116	payment	2058	2058	2059	1	1	6	110000	1000000	65535	E4YjCfWZ2JV5f1D8RVzmiHGC4mobfyGF1MrQGfSgiVFEE3amHamHJ	CkpYVkdDZE5gEXFnYvwSbp8oKmRcvt6n2SS5wdYjaXY1ns4BHjTeE
19117	payment	1726	1726	1874	1	1	7993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5YYnztRCEHBjWP5KSav57JpbsK3LiXMD7SbiP9DWR6LfWGSk
19118	payment	1726	1726	1874	1	1	7994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaeRmUio3cnspVh6deKPbudyRvbethhn8TaBQxQtwS14VPSMN
19119	payment	1726	1726	1874	1	1	7995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFxqCTgF7nMHseTUuB7wfGZ96J6vAvU6GCRuR1diktxUmufT6
19168	payment	1397	1397	1678	1	1	8701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCub362VGB7unQVaaec95AAs1YWtbvLaL4iom2jQ1mER7GgmV
19169	payment	1643	1643	1173	1	1	11	1299265444000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs7Cc56cqitGShXZtTZ3MMUfpPW7TqBYe3RxuMdq73uHvvQKBB
19170	payment	1643	1643	933	1	1	12	1074579182000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3c6k2cVxs9sh7tBkmX2wz1Lh8yqx6RkbmcEVnKyMMUNEVARZZ
19171	payment	1726	1726	1874	1	1	8022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUaUaw4rX1wY6GGeXXXWQStgtFtjgGQASFiXBCd3yyKm4WLau
19178	payment	1397	1397	1678	1	1	8704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5U73Z8T55uRQDmoBs5BKkh1hquMnr8phXMcSFP4n1WahaGok
19179	payment	1397	1397	1678	1	1	8705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfn2SrK1wsBRFZ57HZy47ariL6UScJ6F32kbHeDYDdTd44MpJb
19180	payment	1726	1726	1874	1	1	8027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZW2wugPF1wyc9Rn7H4d7BrahG1NiVqo13z1HGymPdgyxskdSs
19181	payment	1726	1726	1874	1	1	8028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvtUYiGP7KTpu6CYAGsX5BpRGKDZDSZKpoCb7yWpbBBffF3Bq
19189	payment	1397	1397	1678	1	1	8709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMCTbgPVpqNrC9ct3vwgxq61Jx51VoUSEpDjkmj8M2DKZbevB
19190	payment	1726	1726	1874	1	1	8033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFLh4jBUY8ZUKbWrTPWseEkoCKJQn4hwwJkkQ9bphUhNMyrhc
19191	payment	1397	1397	1678	1	1	8710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm2L8AEAYyv6F7qfh3CxgAjbzSiiyStVKaDhtA8x61PwaXDSUt
19192	payment	1726	1726	1874	1	1	8034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoSvT4QZojgMc9GjmpQ3ggZhubt2wGJnTq7twamtYaFL3zuaH
19193	payment	1726	1726	1874	1	1	8035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb15AzzSzjMLStZwWqhxeiZNut7MCc1B2GrG5ar9jsfT4mL5c
19217	payment	1397	1397	1678	1	1	8721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8fPsnzMZfHy5AU5tHNV4c9W5wDiVX5Et3Kn2VXp47v55U9YqE
19218	payment	1397	1397	1678	1	1	8722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfcvCpRAWXEJjvcKjvPR37Ton2VG9ShbpJqfzQBWqtzMKJkuQn
19219	payment	1726	1726	1874	1	1	8049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNS9nt9YcoPxexXK1uSd3qWJS4tTyJipx9ZYDTrQCFseH24v5
19220	payment	1726	1726	1874	1	1	8050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBK38pLKCKNsiBhBiPD1WrYHnDRJ61ButaJysMp91B7q7KcC1A
19221	payment	1726	1726	1874	1	1	8051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLKZuE4bgTT5wiLR8X2DgF2PrYSDepq2JVv6iT7jsWZB5oQmP
19247	payment	1397	1397	1678	1	1	8734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXv5XZ5Tbh13uvbWi1mLQGLanr5wHe2W6UDQLmg3FxJyfijfPH
19248	payment	1726	1726	1874	1	1	8066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fWSnduQshBHpHQzavyJnN4tS18ieyymiGYVr1rGo5ZCixq4Z
19249	payment	1726	1726	1874	1	1	8067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRho6DsdNFjXAp2b7rKgxjEEfqD7A3yHbomUhYWG1dcF1mTQPJ
19255	payment	1726	1726	1874	1	1	8070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpJTYH14DoTPWSGFVVNyjFwSmAA6T6veHxyz88X2JjrGUZiYP
19256	payment	1726	1726	1874	1	1	8071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc8yqqRZxqcNpaQJqrdKMpXmbV6qLxweF5WRf7cZPEE3BGduoQ
19276	payment	1397	1397	1678	1	1	8746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLzrsR4TimutBRyKawVh9kKJ7zvdJytj2TXoUhzhtR99hPmbz
19057	payment	1397	1397	1678	1	1	8656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2gEbF3LjBtLt8gptsKteVKZXBAtCVZTWDb4r9gD2oBPaDbop
19058	payment	1397	1397	1678	1	1	8657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmk1RnT5nrYUbjWT7GghJUr3EPbrJgQ4ULCckvdzX1xqqiaEAG
19059	payment	1726	1726	1874	1	1	7960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcb1wcXYghkbUV1ZQdiRXLYC6ZdQiEZPb85HZLYRRVq6X8NjrV
19060	payment	1726	1726	1874	1	1	7961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaqD2fD42aJtxyq2na9EGfmYuSPXVEM36DTEv4rMi6EGR2kwz
19061	payment	1726	1726	1874	1	1	7962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93mUExSFaBitKiBJuiqqj3wxYZHxz4zUVfyBLSKqKhNS3hb2V
19062	payment	1726	1726	1874	1	1	7963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4FRozC2rFuRfTkCMHwyRKVA2pQK5CdqdKT3VrLGyjBzFvY5M
19070	payment	1397	1397	1678	1	1	8661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjKuVb9hCdvm3U4gqfAeRuGK3yhALHM9j3pcxPEsEdEy7RRax
19071	payment	1726	1726	1874	1	1	7968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8aY75SqRiEFRC2kusjKj5LLzzNhv57vLqo4HBTNjzaCBEdp4
19072	payment	1726	1726	1874	1	1	7969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSHce9FN4NrCJDVQKirbfyHnNnSCJsBZCaJuEuQkxYFUfynFX
19073	payment	1397	1397	1678	1	1	8662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqZLsLoDt6vzHDsKT8oenLuDbv7sEshCUAxLHHxKVSvepxQYE
19074	payment	1726	1726	1874	1	1	7970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cofHYSTjPyfZ95n8zXqjYVRzJjWdm17vfKaEwq2JmFEFdTC1
19079	payment	1397	1397	1678	1	1	8665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKSrUGw1u5WSmPcL9qoxmMxWaxD8JAA5hPUvP9Wr1scoBc3af
19080	payment	1726	1726	1874	1	1	7973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2kn4Ltuqjt7MiaGzyHgP76hftMC7vJtvGS8jT6Z7tiYby6RC
19081	payment	1726	1726	1874	1	1	7974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNPrEbzcVC2VGQcfG3HrdruhtNX9aVpBRfNqN1MS4G9yBkr1E
19082	payment	1397	1397	1678	1	1	8666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9m4e8iuQrddZ6xojrtYvAGcXo4a1x3rUshUa9p3Yc7AWshSw
19083	payment	1726	1726	1874	1	1	7975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwF4Xb4YCpKgP3pHcxj94UgwTZZTjc2Rs4Dv9Eibd44MxLudv
19096	payment	1397	1397	1678	1	1	8672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjLrEyZifS3ETWWZg2JYVcgdnuhiEFQtBSMyT11FoTqbHecPi
19097	payment	1397	1397	1678	1	1	8673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsU7b7xtiLe7apLMc6hvDxoP4kyKpwxPpHFWrcfj54w9Ghcams
19098	payment	1726	1726	1874	1	1	7983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonDf6sHEnS3Sh8yU2ndTWpqTUS4MZqb9QXCHzwJucHMEsRvoS
19099	payment	1726	1726	1874	1	1	7984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjCCCxdxmtwmJj8f7TDumL3shio7ujNikaowUAVaaCxJXucio
19100	payment	1726	1726	1874	1	1	7985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8BT9oBaqh9LUrErdQz5Sdh14KR5cwGRFt78aL4WWF6CKudJ5
19101	payment	1397	1397	1678	1	1	8674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECmivmUS2P1DEHB1tAF4e7MoZJB6f5Q1z3qisb8qH61MSTHu4
19102	payment	1726	1726	1874	1	1	7986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjT77x5EPrap4TmjuhzqzmoYkcSzCYkGoqoUYdE6szZ8fwAusS
19107	payment	1397	1397	1678	1	1	8677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NpRXHqKELa1zy57MFSqmB7xWwJhvT8UtU6R6CeXAAVQ6jCxC
19108	payment	1397	1397	1678	1	1	8678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr81Nao1suaMVYHSsRhJMxpdkMyV2mBjStKhxmh5tFSL9gHJWK
19109	payment	1726	1726	1874	1	1	7989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gz7tG83qUspP9EqBL1NPXWZkDWBF8RjU4CCoHYgYv4ZtV3qv
19110	payment	1726	1726	1874	1	1	7990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzLFf6yruWSaZVbCkMfj8Mec2Cp1T6KEHZgzW3L1Pn3xHMYmc
19111	payment	1726	1726	1874	1	1	7991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaSGXQysHNp26pnqS9yDkTZghj9UHo9dEyZiGVhHe7G6zjdS3
19112	payment	1726	1726	1874	1	1	7992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3DbQak7JyP3HQ8xJDPLvnt13gskbh5WAiqLT7TwJhWk4pjWZ
19128	payment	1397	1397	1678	1	1	8685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQHHJRZwKPqpwTLWxSGeMQgbXATK5r6rFkrERPxMDSsTApMSn
19129	payment	1726	1726	1874	1	1	8000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa37GmQgMVTy7qmKKqUutLnJ9EWajasB8w3gq8giAwtv9wTt33E
19130	payment	1726	1726	1874	1	1	8001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qZ5SecDJ5f1WmpWmVDiBVTydertQscUT6mz6cJsx1fdccnJ3
19131	payment	1397	1397	1678	1	1	8686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRG5QpXis1Q2gzqx5nFiRhpzfFwSoXtcTSnR6rWq9ykx39KaoW
19132	payment	1726	1726	1874	1	1	8002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3FyoiE8GEePYdt7GpQjpeczb6VSS8gweQSAY4H3vhMz99Qi7
19138	payment	1397	1397	1678	1	1	8689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFZdPz2tWtZ8EDnFCdbn4h8eKpnUhe3pNJXBRws3c1qRRAGqB
19139	payment	1726	1726	1874	1	1	8006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BtMdUx5WFufweabhXsyCK82fgoq7iqD8CM1hzUWUa7f4JRT7
19140	payment	1397	1397	1678	1	1	8690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEQjDphvn3Z4DQf6ayPej4A14QBA8PH9MAME2gouptVNCusgk
19141	payment	1726	1726	1874	1	1	8007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdrknga3nH683CqNcXbgkXDNe31A6dcPC7MssZUSo62BjFkc4
19066	payment	1726	1726	1874	1	1	7964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe29TdxXUaNSqyCFXTF8Exhv8uM28ybKN7QK2qthqfQKrYSe8z
19067	payment	1726	1726	1874	1	1	7965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPUu7HqNUP987uD93uZPNF82k1BMKW8FKU7WNZgBdPNn9sAqc
19068	payment	1726	1726	1874	1	1	7966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4BY1JWmbXMPqz3iGLpVL8RWreoMhL3A2zg3uLizqgCscXB4d
19069	payment	1726	1726	1874	1	1	7967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSums4HFHkqe4bKPp723NyZWN8usPBJ1D4RSiSf6Wzy8NvagSi
19084	payment	1397	1397	1678	1	1	8667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXF6s8r5E1VExcLEQCQXVm3taLkRTmc47h3GF7DrBTVo3vnS2
19085	payment	1726	1726	1874	1	1	7976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HUpdz7DGgBL9MjBDzF8zhAmmHX46tjy8KLa4buE3NWh2RgEu
19086	payment	1726	1726	1874	1	1	7977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1pKB3TYTrt7k9SUpt1x5Q8Gqvky8vFmuJ7xwUxz7anaSGfGq
19087	payment	1397	1397	1678	1	1	8668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZXWc7dPQbrLCBNhSYbFSzQdgQteuPSGtDa9bobdHo4ARYFVn
19088	payment	1726	1726	1874	1	1	7978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3ZrfAR1UoS4wXYMzAATQc2ytgHSzPgo1LGH8UVLg5yPTboZc
19133	payment	1397	1397	1678	1	1	8687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1UwaFfaYPP9yUB74VpqV8TQ6hQJ1QPUD3C8N2iF3YMk63pno
19134	payment	1726	1726	1874	1	1	8003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjAbnm9oy6jt7fFZDukfhXSFuWCUAwBKoqeYWmmh6qaDckQG5
19135	payment	1726	1726	1874	1	1	8004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzx9JrVgtwW751gjgwf4EMNSw1vfJiZwjKezjdqKvRsNnz3GCN
19143	payment	1397	1397	1678	1	1	8691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTp3uprWVZdLpZcCy8bwRe9MjaQtCq2NnzqvPVxEV8C1sxvhq
19144	payment	1726	1726	1874	1	1	8009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUL5rkJqyU8VuAywjqbBi6JRNpmkqb8ZEEEZeRWxB4oBRBADb
19152	payment	1397	1397	1678	1	1	8695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjybc95n6qrZQRAedyHcAnt7PrRv9Ee6az6cNtRxr213pEw3o
19153	payment	1726	1726	1874	1	1	8014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwez2ZRhRheLfi5YdB2WYtwzLbtw1cFGxBSXL4ViPKR7q4VGQ9
19154	payment	1726	1726	1874	1	1	8015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3H74yjuKrpWzeN4uSreJmzn8ZNct5RMp7CrSNDHnpVpptFCdz
19162	payment	1643	1643	1299	1	1	9	3620518685000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsf9Uthdk3pm2FsUneY6LSiKSUCsxbeu7bbQGUXJXUCSW84HLw
19163	payment	1643	1643	1053	1	1	10	1925636688000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSNjJ6fPuM8HefP64NydSEpW7L9KufxH5x1qg9dx3yFHytcar
19164	payment	1397	1397	1678	1	1	8699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54m6b4jY4Em5cjAwMogAxjM2o3M1Mk4FbsMt16PM28gJwbxut
19165	payment	1726	1726	1874	1	1	8020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvnH2hEJFU25srTB4LK2rfzLgCe4NdPVVysjcMh8PXDcPvF3XB
19166	payment	1397	1397	1678	1	1	8700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5BKbLmYKBBU9TwBonUAWxrzwP2tPYwUgfSvCaskboe8rPMot
19167	payment	1726	1726	1874	1	1	8021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXE7FJaaopctH2W5t4gvxbTfSmb4i1XADf1ZzKNwnaxAnvwJyA
19175	payment	1397	1397	1678	1	1	8703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEmcZ2F2zHoZnMMi3iHEATYDwJrRkHUooeTddPGRToSxfjbCg
19176	payment	1726	1726	1874	1	1	8025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRFTwXJzCJWWJXPnrBG9UQ36eSGieosf22yjdCaeKv9e8912b
19177	payment	1726	1726	1874	1	1	8026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjus7piTqNKhfrRXhbSXRaocV269JhpDatwmShCXfny3vFDD1i
19184	payment	1397	1397	1678	1	1	8707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBnwgMaGha9mACVjc6LhPXuVRsE9b3a97LozJv7M4NpCZhnQx
19185	payment	1726	1726	1874	1	1	8030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpK8knQLMC2m3g2jCWL4NcXKKhFf7nyQFcjVqzL7TEupucRsh
19186	payment	1726	1726	1874	1	1	8031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZRWSu2b1TLBvvQVzDs26pnnfx8FQ8nJo7HQMoE7Z2zWP6Xhe
19187	payment	1397	1397	1678	1	1	8708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVZazmjeMtt9ABeojpAWjs7DZaGKmsT9bhp6LUqmpq5UY4cD4
19188	payment	1726	1726	1874	1	1	8032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyHzHpbszHuo9TeanC4Wu8bhidTyjCN1NnYUZF3geBok3HvEP
19231	payment	1397	1397	1678	1	1	8727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1g3UPzFsY7MAmGszc6kG9nj19JwqiRkDqnwAaoUst1YX2HJpu
19232	payment	1726	1726	1874	1	1	8057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1itWi7Mb4RJvzfFwLrhKwTrbYLXZjkM9a5iQ8D75GmYJ7QwA3
19233	payment	1726	1726	1874	1	1	8058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWGJ3PnSqDGi2fRDTrye5N8T3ShMQx2LBHuLk3qUvZxZodQD2
19259	payment	1397	1397	1678	1	1	8739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcygEy5gJGJiLoi5JkxTDxJKiEPcdrPSoHqPQnS3JGyoJBxvPW
19260	payment	1726	1726	1874	1	1	8073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Dj8cjbMBdooQEmEzFG7qYUmtyXkBNZEGkfukggPHZgXSshBg
19261	payment	1726	1726	1874	1	1	8074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3prYE3CgDEW2Bbs2n7kggpTEariS2MnXCtYPakQPqwtfpz8KA
19281	payment	1397	1397	1678	1	1	8748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzwTkhRqeDnCy4aE5s1WYu3AzLFpXCFLkjBa7jTbwA4BuTtFU
19136	payment	1397	1397	1678	1	1	8688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFumB5U6T2eiLn2HjJqExCS2NL2FgR7TRGtmcQHnLC2YWkgWnQ
19137	payment	1726	1726	1874	1	1	8005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78U9CjjRsjYUNYCV6fjmTCKk7GnvbjyE6HMaN9rjHKjyoJskZ
19145	payment	1397	1397	1678	1	1	8692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3FFFoSgbMVtr18iHLY5AFAtXthRC2dqDJKz5JrCjibBgi8yg
19146	payment	1726	1726	1874	1	1	8010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSacxJRSNvdhgGQu2ue791BaDfgM5EpAt6HDVZ1xEUFBGUaUtm
19155	payment	1397	1397	1678	1	1	8696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxvFA8E5be9YNgF9vhoQuB3oHyy3AzaN1rrzgWhvmYUvRC8fN
19201	payment	1397	1397	1678	1	1	8714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NyqTKHgDuonA1fUGDEtFD1ETLdYxRV5R7T58bQzEqtRQ3xGS
19202	payment	1397	1397	1678	1	1	8715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fwoq47gwmAacjQbh9C45JuA1KkQ9zytPgVm2KjRe2SFL2q23
19203	payment	1726	1726	1874	1	1	8040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHXYXN9aU4cpaqq1RbV3m1gxLBGCVyptFwR35jvYGFaPyCt11c
19204	payment	1726	1726	1874	1	1	8041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVuYPjYuHPXtUbhQzU4BG1DeXu1Ut98awwLNTFkw5oXTQJ9Yx
19205	payment	1726	1726	1874	1	1	8042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NoTCXWq72sFMojcyxHjANz6S8WdVtK9YT1RgRAq4JB4F8WcG
19210	payment	1397	1397	1678	1	1	8718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzzVNpGm4pEBv6sL8dDHhCUQxnanVzTXfaXGVa7zUWf62qHkJ
19211	payment	1397	1397	1678	1	1	8719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY22fGY3v6WTAHjsr54Doxk5Up2RwPBkW8nJ4bEu5yB4VfH5QH
19212	payment	1726	1726	1874	1	1	8045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvaeLaUt1PgrPY8aii1BnEKkfueFt647SKe9qrsiqx2EN5RRMV
19213	payment	1726	1726	1874	1	1	8046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfWhyXhwFduF3wzfqs5UPvBPByuepFiJndhjUtqZySY8e4RGr
19214	payment	1726	1726	1874	1	1	8047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTTkbNpCHqK4Py7X8RjVRkFd68Cqa5zGiMEVDTF4PT5ggdtBr
19215	payment	1397	1397	1678	1	1	8720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pMG3hEuiuEkUQtTBeUDMrbrrki4p4BPiESt5rj47rUUg3ETE
19216	payment	1726	1726	1874	1	1	8048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7q7gXkGMemiagwzp9oFy7SrN8WbZ21mrSsBChngFAvEMBdrg
19222	payment	1397	1397	1678	1	1	8723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFL4kLxdvxpNECF8an7E78xSJ73B5TKhogs2jdYWNfrBmJk9bk
19223	payment	1726	1726	1874	1	1	8052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYEsyeLS1ARhuh7cH1S2vEZLKv2dYFZA1TcdPBKcanbDiu9wj
19241	payment	1397	1397	1678	1	1	8731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEbVoNY6Jcg6KneCQQGJSpTBA3SfrhxcxWetcAGFNT5K1eo7j
19242	payment	1726	1726	1874	1	1	8063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54beE7FQjuk6v6RnjtiVvkHq59XsAZeWF2VXvsRPua5HXxiN8
19243	payment	1397	1397	1678	1	1	8732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uUzCr788iMmbwsmtBHcuSo3awwn3BHkMUNXsUKhHB1824p43
19244	payment	1726	1726	1874	1	1	8064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZNMvzNyWrf6jDiRF56soqYvwGMTVJudesQu66Yx6AQV3HDrj
19250	payment	1397	1397	1678	1	1	8735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSegisqBMqNQpYce8DwMy1gWaX5jyftLFa6TCcGJL8kLWYBm3o
19251	payment	1397	1397	1678	1	1	8736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLhpRPCZz11AY1iwfdfTbAMkXhaANcGVvYwUBaARxgfjrpux8
19252	payment	1726	1726	1874	1	1	8068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZyL2Hr7Sfavb6oFasUC8ziMdadYGPKRBAgjLtZvEXXHCrZCV
19253	payment	1726	1726	1874	1	1	8069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hmz5djyth1rXE3L6PDiTRHpBxCZEmnxYa2uZ81kW5rheGRxu
19262	payment	1397	1397	1678	1	1	8740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmW13cSR2pjLBDxJok6xZyyCgxquWTHohYkjwTQb5hGtvcmAHM
19263	payment	1726	1726	1874	1	1	8075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nmVSpAaUA4r2KCfywewsSFNtsYWfyMUmwpKaMignvasFUKQ8
19269	payment	1397	1397	1678	1	1	8743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9vGRYkKUQp3JQNHoQPMQi7bv5zN8YDJV5fs4k8LNNVAMsdUW
19270	payment	1397	1397	1678	1	1	8744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSDzhhwQqVsT5NuVQ3gb4fZ6vGJoBj1X2VrvTHjinng3TMMLW
19271	payment	1726	1726	1874	1	1	8079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqKTm3f2ydUhnDUqTF4BQ5nBR2VbCbsLUqjZxAUUe3QbjuaAW
19272	payment	1726	1726	1874	1	1	8080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTHiEq2mS4v8Ayhr1rhduo6HmxH8nMc9NNAMLxgQoEmsmXte5
19278	payment	1397	1397	1678	1	1	8747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLSSQeckHjxW4kFd9YfaEzbhFQuH2ffEBdxPzvXMiVZfrLnsF
19279	payment	1726	1726	1874	1	1	8084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi85CKgXfHb1YmXaWYhspkJ3x6MPAUYBoVUwKPrPW53sGuhkm8
19280	payment	1726	1726	1874	1	1	8085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxzj1CpJmT4rKCqoiFkrVZhoMHpD6xVFziG6ZchiJHQ3USi5e
19317	payment	1397	1397	1678	1	1	8763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeYTxsgsbJREhnyiwui2Hwy2Wm5P9tXbRbuke1fHbBqXujALE
19318	payment	1726	1726	1874	1	1	8106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6R5dhEJzoSRj4JEvQpzqrxWbaJFj3Qqj1VdNmAWBZp8PzCD6m
19142	payment	1726	1726	1874	1	1	8008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvPrEKKZtw1tyaj4DWRCQ31ghHGmkhyEb3xV7vBCrF9e1e6XC
19147	payment	1397	1397	1678	1	1	8693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgJNhr14eoq7j1x1VamzEQ47EvwCrYtt8dvGCY8dyGdNHiUmb
19148	payment	1397	1397	1678	1	1	8694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZVwbN6trX8edhmLukCKUNX5bzkoK7bRfMkkAqbcfdY87Mfqk
19149	payment	1726	1726	1874	1	1	8011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfg86srib5y9TAQjp2XkMDsuw4UrVpuwJbztxNeikmc7FykwT
19150	payment	1726	1726	1874	1	1	8012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAkFxxmit4vE9Ey3iiRrM8CmpJktZnZnBz2gvng1MmCL91sMY
19151	payment	1726	1726	1874	1	1	8013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYP9Ajd5ipdu7EHwLPUkBTweetPKGjPpMK8DQMMvf2Kojok6j
19156	payment	1397	1397	1678	1	1	8697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgv7ZDg3k5tHp2iVnKBLt6TQMRBK5qPPCzc2MwwoXkZybUVoL
19157	payment	1397	1397	1678	1	1	8698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVm5BsfovYhCTNiC35HGGHM75GCYP2K8VFpTS8voSFxp9wrdyP
19158	payment	1726	1726	1874	1	1	8016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67n5QMEdo8JX5ntyVfqNrhqAvAtn2DFit4sbHC59G6bPyBYrP
19159	payment	1726	1726	1874	1	1	8017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrj2kPmNUBpbPtgoPynrmie8LtNWF97xED5p9M4pztsEjCViE
19160	payment	1726	1726	1874	1	1	8018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCu2Xnh6LoszfvbznBwPBTkDC5Dxe83qzSmWoAkTsqBKxcQnE
19161	payment	1726	1726	1874	1	1	8019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5SDLSKpNcrLv5XWAfRAzxo77mDYtL4i7dJJvuZrqFLbgrEEH
19172	payment	1397	1397	1678	1	1	8702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyTJpfCXVaA7c5GGSaDRhJa1c53TZ6GnrG8cDtfgRk9uPVg8u
19173	payment	1726	1726	1874	1	1	8023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDWhHUXMHpYJRc4o6cnaMZpzR9vCFYnM2GX6L3U9wsCnJq8FH
19174	payment	1726	1726	1874	1	1	8024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhcEvBRfGdf94gektNtApSxfEo13rhuXiSXMT2qu6whDYZj46
19182	payment	1397	1397	1678	1	1	8706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVueYmKRA6KfekkH6sHDH95zVNMMjzizAMvLXNT49iSJKDV1T
19183	payment	1726	1726	1874	1	1	8029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwmvaanGfDdpxaedsNn7czBqcvWwDugR1F847KwALkesdqv4G
19194	payment	1397	1397	1678	1	1	8711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaLvLUUzC8Rc6e1geVHXdnHgomVN8V2eWC5UTZNPso76Tvf4m
19195	payment	1397	1397	1678	1	1	8712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2xWuQTj5sAe2pN1bBGmomQiZsqXjz7jmXZTdSZgEcstzPBqe
19196	payment	1397	1397	1678	1	1	8713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSHmeoxNCoN9usqDDJsNkcC2AAJKLY2hYXUzM8DYTWgZKj9tP4
19197	payment	1726	1726	1874	1	1	8036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14J3A6sQvPuip4dJqejg6VJNga8wBUsLxLkm3C2uQm6MkVR3F
19198	payment	1726	1726	1874	1	1	8037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuC8FJ3WzmHKGaU3wkUPaPXsAs14xtyMmLvHi29XwJrTAncGVF
19199	payment	1726	1726	1874	1	1	8038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWXxKqQfT1kgYvE1v3Sf3PVQptKHbsfiRmkgWarke8c1Rv2X1
19200	payment	1726	1726	1874	1	1	8039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuetqQ3dNYDej4RZavDyN4HXqTVnLKLM9J8ZBRFcZyKDiM5nG
19206	payment	1397	1397	1678	1	1	8716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNuqCnZzjMkkDRx4YxNkCVuBFZUgwKpaPaWZ4d3fCy4EbNWDs
19207	payment	1397	1397	1678	1	1	8717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8cViWp6RTNvEiCHkSA1peWQeLkf38DetAcjyMNpVrhMaPPG9
19208	payment	1726	1726	1874	1	1	8043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CHpaJobrQeVL6MVW7HBJNMC5hBbBrszdLdsf3bPyfuYoCjkz
19209	payment	1726	1726	1874	1	1	8044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZePzS3SJPj49HGDRVk6sov9rwz8pP6VsNeB2vLiS3x3PRV1TTR
19224	payment	1397	1397	1678	1	1	8724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtxddaaTrDA74JVAgyaNQB6sprQCzrqbbrbQn5Btua7koyrpc
19225	payment	1397	1397	1678	1	1	8725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3Ck5Rip5CNrWWTZaoMuqUBN9TBb9SYxK9HGaHcySs2y4P3YA
19226	payment	1397	1397	1678	1	1	8726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPVjivmuzvgqwfLXMH4Po3iQCqmLHsv3vhZNrakvFBynynsad
19227	payment	1726	1726	1874	1	1	8053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXo8bCdzgSLmo4Y81Ehs768BWk3wUziRJHdDuwRfJr3m7Zb8B
19228	payment	1726	1726	1874	1	1	8054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKwwsJHb76LyX1Jq34GvBb4jrYCGZe8JdPaMt6LeMB1piH6aT
19229	payment	1726	1726	1874	1	1	8055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBBjXU97Vn4ForgsiUkvZnZPdpDmNC9hCjwBvkStbZFg8mpye
19230	payment	1726	1726	1874	1	1	8056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJznT2pN4RjMQQz2Bzk8gExdRFMvHB2BDQczkLPxKpED2MWsE1
19234	payment	1397	1397	1678	1	1	8728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYot4TBZkRLCjhFEgbW2hsFvcxDPhsbhgYfn1JMdePWNTTBSHqf
19235	payment	1397	1397	1678	1	1	8729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz6TKG9uvN31W7vB7isz9Fqa8H8LBo2v4RSqNtidMA2vyAwET
19236	payment	1397	1397	1678	1	1	8730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQYwGeVeKgnojZ6nXUpXkhj57g4qsXuLGYTmY7oxZ6cEX5P8X
19237	payment	1726	1726	1874	1	1	8059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgX7EbGZWkvv2mSQN4Fy88sBqhX9kW9kMRBs3aZJ8nNB7FTewi
19238	payment	1726	1726	1874	1	1	8060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2k7VMECJcjdYtXo4naiGL1pM5LU4165mdB5WHK3KfREuwfue
19239	payment	1726	1726	1874	1	1	8061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2pMt36bzB1gFTUtp7qiQG7m6dC4cttUt6K4aoR4DXLBV8UVZ
19240	payment	1726	1726	1874	1	1	8062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkADi3i5MKnzP9JF1tpFNtbFVyV1Gt8iwFHnzuWfimyJdsKgr
19245	payment	1397	1397	1678	1	1	8733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TpDF1fhBViC1oZzXGRW4gTxM3LBqFsYpv78mYvF6T21ED6HX
19246	payment	1726	1726	1874	1	1	8065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHJCjVWiYChnBkuSehFuYTRqnmACZaa6b1nCuN3BsFY4Y7Dro
19254	payment	1397	1397	1678	1	1	8737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDMUDSJkZ6aAxA58ay6JTNWo5TFcVDGEAaVYdE6dSDhKG7j6F
19257	payment	1397	1397	1678	1	1	8738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVBU8eDStNX1sAktXVuNjw3HUemCaCP59hpaozg6SMkrsv6QT
19258	payment	1726	1726	1874	1	1	8072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcYT4xTNAB17h2CjZygkzsqDHuyj7RCFc8vL89rsKTcNpFEGn
19264	payment	1397	1397	1678	1	1	8741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7unnmgETPqoDJxhCbZo1AYgGVT91aojvPSaE1LLGNixTBEQx
19265	payment	1397	1397	1678	1	1	8742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7QZHXAPPmJYjDzev69i6P4BPUGvZWdcuGsCpq86it8i3AQzj
19266	payment	1726	1726	1874	1	1	8076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmm4aRq8Nm8G42FCCCn4F7FChaktXuS54ysmwKWUWvPdV2xkCq
19267	payment	1726	1726	1874	1	1	8077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7s6jwPrVzknkiHSBhXPbFhhDi4H13FhJPbR7e8d7Cr4TdapTs
19268	payment	1726	1726	1874	1	1	8078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEetrSkEryCtJoYeX6uNiuiHmggJmrHGjq6hPFRRCWPwP9Fpc
19273	payment	1397	1397	1678	1	1	8745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFsBbrK9hnrdk8N59PU7Y5tasLVUGhhhYLTrAVmQAfK3uEsbV
19274	payment	1726	1726	1874	1	1	8081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69FxRq52L1spX85TXRb8AQpeWsS7uWE35qfctP9yPaHS46dt5
19275	payment	1726	1726	1874	1	1	8082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6BvFUCU7ia25rdoermNLsx7r3qA61R8cmz2mv8poKnTUt3MJ
19311	payment	1397	1397	1678	1	1	8761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHENhaqCp1Cc9Pk15yYyvkXNB3HFaBsJbBcZizFvgmvvSRyGcP
19312	payment	1726	1726	1874	1	1	8103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSADJKFmX4mYfiE5BVR3HwAjgbXnTy8TafiqAafjdHiA1fRxd
19313	payment	1705	1705	2129	1	1	19	4800000000	20000000	\N	E4ZEURhzma68F7NjrZEFmxG6BXun9Uh5cmLqGQXVMBgbzZVF2gAcC	CkpZR9w1tUqEwtErsUbkNGmagZsm5Wdhe8rNb8r9WfjZnY5hHbyMc
19314	payment	1397	1397	1678	1	1	8762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuVGjNr1XjvmPRKLk169TVdVdhJKJMk2MjFC1CTqynGU3uLpK
19315	payment	1726	1726	1874	1	1	8104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyt2RPSjvLAHStDXr3M79wWuBQtFXF9CVSnmniCgUwTgcXEsW
19316	payment	1726	1726	1874	1	1	8105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuPJCUzJcr3kKCeLF3LMNXLDtziZZeomodJYEuK9P61ER4u2Z
19319	payment	1397	1397	1678	1	1	8764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHRkQSpdtfHKRgHU297bAoVYb7TBbrxmp5wstEqmvvTfyqG6U
19320	payment	1726	1726	1874	1	1	8107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bGJXErdQQJNrUvMJ6NHcgHgdMdMjZgrBM8W7rCPFGR24CG5H
19321	payment	1726	1726	1874	1	1	8108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnvV8qNkXmuziuDxWM4NX9eMenDgx8RwzGCq5C7e8iMVP58r2
19322	payment	1726	1726	1874	1	1	8109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsKCNTu8CkH2TkqobSedkT6PC7JGNwuyrTmash6FE9xPQC9tK
19358	payment	1397	1397	1678	1	1	8780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKQMPXjTiNYv7VS2wXZNocCzfJ2Qdx8Urtu3iFQnWeC3DmKoZ
19359	payment	1397	1397	1678	1	1	8781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2Q9HCn9BQSuPj928A6wT7DfaqpEdKM9Xo1wrGMnKbWy1oHgP
19360	payment	1726	1726	1874	1	1	8129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wVWZd11kWyQ66iBqYfaoA8Vb5cRg64CytZSBRWVhPrAwFZUT
19361	payment	1726	1726	1874	1	1	8130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAss7WnaVDqGmEnVsBFZExj1DVLPApQXFVXkAB9ej1XPCp4mp
19362	payment	1726	1726	1874	1	1	8131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQR7ktZM9iuwBpKY1rVKCMRZjPGWcKYuBcmzk6R53U9ADoBkU
19363	payment	1726	1726	1874	1	1	8132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAM2HfmhNoRNbKk9DBpzNvWxRsobSsGF6fvTqZ6nTnFQtvGxNN
19370	payment	1397	1397	1678	1	1	8785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsmJewAmkR7cpqWxS1EmupzPotxAethRFznRQgGQovZE8UYRm
19371	payment	1726	1726	1874	1	1	8136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3D4pf9bpCabGRp9BYkvaQ32Y1q8xaCttqrUrYeAusLGqffvJy
19372	payment	1726	1726	1874	1	1	8137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGoWgZntfdMT7Uh9ohxNNhyDJmMTrq9LHAGsH6NaLctDfYfxHQ
19377	payment	1397	1397	1678	1	1	8788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuhD21cbEovq4wx4U8CfRtMJ5p6DBjXU4z8KDk4mKeAd232TL
19378	payment	1726	1726	1874	1	1	8140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCG2Kh2ELUk4nZ1cUohatQ8WRKfnyqKsDitYJ5tdEibakQYeJf
19277	payment	1726	1726	1874	1	1	8083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hTfRnMuqhpfMC9eicXwi64Hm1DPL1fGTSpbVBT8d1NE6iqQ1
19282	payment	1397	1397	1678	1	1	8749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4jdWCPjZzAtSutDuv3EJX1j5AJydAZ7BtH7H97yR7fz68PWj
19283	payment	1397	1397	1678	1	1	8750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfspTegUXNcPHU6ZXufW4tbw7FK6HUyxw5dEyLUTJ4MAXyp9Jo
19284	payment	1726	1726	1874	1	1	8086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RMEiFePdsScf9Ux7igSdBEct9AKxGJfbpeef64bCXtCLy9Wj
19285	payment	1726	1726	1874	1	1	8087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTd7tt5egTZAPovaVWjiZBvMaozY9vRA9nT5a7622GqPq296F
19286	payment	1726	1726	1874	1	1	8088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8agQAMcmtJmmadR7nzYSSMRUJqchNXgofWVroyfUDVRDM64s7
19287	payment	1726	1726	1874	1	1	8089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYig6YFwtBB3a8f4vnKg7qnAWADRxraJ5DqYeBztGo2qFg9821w
19288	payment	1397	1397	1678	1	1	8751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3SvBjM9gMDY2R2VUrA2Fj9VJDqfx92P9TduRyiibfm6Po6aN
19289	payment	1397	1397	1678	1	1	8752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pTiUSRaRs33MZrvMigfbcyCeWsBY1iJLyujtk9G2gGntyHDu
19290	payment	1397	1397	1678	1	1	8753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HT53egFgZz4GLLbHTxtfNocEYkgLskgHNAuirLBGHCgES1Zw
19291	payment	1726	1726	1874	1	1	8090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqzZux2JysE3tvmvQ4qKpnUThe6vmX9Qds8NQAYNGqUte2qNz
19292	payment	1726	1726	1874	1	1	8091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYT5hejmJgGe1cxZWwu7R8ZHnuLiGzwYgZLA4L9yvH1BVhAhi
19293	payment	1726	1726	1874	1	1	8092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMCSF1gCySczHFn2PxAPr2m6zRQbj7RG5d6UMq8VAgChQgZNR
19309	payment	1397	1397	1678	1	1	8760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpeBP1XpiLpp5hXw98Cop4Sp5iip6udMT45EP4YgYeBhd2ej5
19310	payment	1726	1726	1874	1	1	8102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCSFEbG4fAwagEGV5z3ipsFViK8rDAL2bGacwYiKvW8crufqW
19323	payment	1397	1397	1678	1	1	8765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShMT3aLjcvPNpyLhjexPFBZwHfbL2LcXhpYYNb5CDeYEKZcqS
19324	payment	1726	1726	1874	1	1	8110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8RNnkaKgaP5X73Ebi5UCTHNxGaFZ4BiDM4R7HsS8eLU24jiF
19340	payment	1397	1397	1678	1	1	8772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKzRPKTdFLF4MztET5Z31KgXSo1GpEZyH9TthWQyXEMXvvk2q
19341	payment	1726	1726	1874	1	1	8119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyw3Q2Kz3fs71bFR7vvK9iCWAKHBxaWkYX8AeJT2kNZkvbsW9
19349	payment	1397	1397	1678	1	1	8776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckyuEv8iTiELnTABXSExgmVfxgAPfE589VAEQ5JaTZZLK87gY
19350	payment	1726	1726	1874	1	1	8124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8A8xHdrfFW51YC2kFWXhscs98VCnMwWb9JEJ8SgjzWxdd7p5
19351	payment	1726	1726	1874	1	1	8125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrM2MPfDnf2MbNZ4XVM6TyUURtQ1qNStWPAquBpmA9hdD6BsCf
19366	payment	1397	1397	1678	1	1	8783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67uHjP9mCLaMyVhZPTTUp699vuBWJdEa8nWu3P1AejM6ZwKNe
19367	payment	1397	1397	1678	1	1	8784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDzWX6DCGwFVMBVGBJhywcygmabm8AtmNmdsH3CyJPo9kqugN
19368	payment	1726	1726	1874	1	1	8134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHe9P7ZijKfGqpiKYsvofGsye6JnRjLytPsX3u7rRNnFJu3Ad
19369	payment	1726	1726	1874	1	1	8135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8f7XSYi7aEghPioXgnRdhHHakXbYPFygVvUvAR5hJboFue4kt
19422	payment	1397	1397	1678	1	1	8808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhof8JwLwLrLqzskU454xxesU61AKzKmoWeWvTW8f8MXSzdeqQ
19431	payment	1397	1397	1678	1	1	8817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBMHgRpT5jPPPSfiiPVVvv54WwSfHcPsdDtypNNu6QpaxztQB
19432	payment	1874	1874	1726	1	1	1	4778000	1000000	\N	E4YgyYcRPZdhKqQRyKezP8ixgNHPEh5ZW9Kswa1W2eciBPGHC514B	CkpYzNtQxkpDbxpcY1nTz7oKpE54rMcPakbGymZGzs26nsJ1iaoag
19435	payment	1397	1397	1678	1	1	8819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfS5QZQZhhjT8rW1C81EAYQ7GvVf3DEy132k5YzdTGxhtRDGR
19437	payment	1397	1397	1678	1	1	8821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqyW1y921DoiHuGPzNZDGyDa5qkV5KtR9CsXnfrPQ4c5jwTTP
19438	payment	1397	1397	1678	1	1	8822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNM4cnyxBaMhYJriGMv5AKbrEH7CDtUew7MMnbPUzoJv9MYHm
19439	payment	1726	1726	2132	1	1	8166	150000000000	1000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	CkpZv81WEbtEaoMjkdsjM6PLpMeCHnRZ1M38oRnWXL68n6FgMTYRi
19450	payment	1397	1397	1678	1	1	8830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfH8HiFQ83GFJyPb9gTUx3Ym6W3P5EWNbwTdhXtHquRi8wyrL
19451	payment	1397	1397	1678	1	1	8831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcMNwW1qQLtx42mWgowbq2YSTFp7T41xaE79nyscTpBefn8rn
19452	payment	2133	2133	1874	1	1	1	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9sUvZtMhwfa2mi9W2Dd638rKhKTRtZURUeSLxtuUgc6PBSM8
19453	payment	2133	2133	1874	1	1	2	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvGPaBWMqwBuHYy2uy21JZ57ifjQXvn7PK5TBdJboN38iKER5
19456	payment	1397	1397	1678	1	1	8833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMDCMWRnKfEAkrk9rMjGbFoVshTeDc2ZcRDxhsf2LPsxUGjBC
19294	payment	1397	1397	1678	1	1	8754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHZJLCUriFz1nq2ctfo5YUhqeoDpVUZdrxiWwrWXpRVoJ8rGf
19295	payment	1726	1726	1874	1	1	8093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUbWCXERYRBehkwnrMQG1ijdqxwTYz1ax7A13Yi71FPrLitvw
19296	payment	1726	1726	1874	1	1	8094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBJbFJy9J4MraeZFWzz6R5S7Lo1HTxiSEkAM4tDoHzqdT9fTj
19297	payment	1397	1397	1678	1	1	8755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEatSaCj5bsf6saZrLPsdXP3oEGe825FnmWKKSNdQwtqVawYQh
19298	payment	1726	1726	1874	1	1	8095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKicV4BFWeNVfHgY12eZTvmC3ury4iwpfdp5x3aXMF2c7oRU8
19299	payment	1726	1726	1874	1	1	8096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtWZPb8Y9SiK9sUnGqm2eFJpW7MChXuzHEpz9XnMQmz7gHqYM
19300	payment	1397	1397	1678	1	1	8756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZit9sjPZmzLP1YMU9MbPcEYX13pYkTzLPyaZf91XYbPcjvvRKo
19301	payment	1397	1397	1678	1	1	8757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZooy7LUceMFvZNAq1HdscLydNtF6oZw981aVpjk8PyHER7MdrR
19302	payment	1397	1397	1678	1	1	8758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpobgbiMbHUGrYQWpD7WhaXRqrLfDrtkxXE15wpsk74FwQZHGa
19303	payment	1397	1397	1678	1	1	8759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZ7QZ17BczdsdRjGiQMuinSB9pvhHZFrKPKUypEePMhYr4Dn8
19304	payment	1726	1726	1874	1	1	8097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfbNagbmc1VuCiajbF3mbcqRvTbC1vfk3utmTF4UvkaQ62YY8
19305	payment	1726	1726	1874	1	1	8098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhrY81oFuJJyKi9E52kcgPvByX73xELbFBPBjWXnXHrdvFzXs
19306	payment	1726	1726	1874	1	1	8099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtmUgro6Lj7jPS3XF1ncL4tuBqeTWi74XLHQHUyzsHtyDxYv2C
19307	payment	1726	1726	1874	1	1	8100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA2Ryv9scj6XM97B3qyZsBVL31JVYigrMcaoez3rQV1ttQ6jR6
19308	payment	1726	1726	1874	1	1	8101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDFGfbu8F38Y1mtfPJFcj9jfBNNB2vFE86q31xQdM78YDqXDP
19328	payment	1397	1397	1678	1	1	8767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBkRKA7UbULEMcN2kxHKfZ6iWEx6H7mu5PbJ431AtAUP2ZCeB
19329	payment	1397	1397	1678	1	1	8768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqax786ehQzdQd37QpwgtYoRxvb2vbFoj1jHwFYDXf8dAssTGG
19330	payment	1726	1726	1874	1	1	8113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFo3oUQ3zEtfaxZh6UMbBrMY6xyAAnbT1JBY5woY3cfdXJe2N
19331	payment	1726	1726	1874	1	1	8114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTZjyfoT46iCAEeBm5Yyc7hfUZiqB1RXda1tU9FyyVc7nMPQU
19338	payment	1397	1397	1678	1	1	8771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgETrXaCHBTH9Yq9NWPaaxCPrK8qjsUChwqsnFnTEo7W9UQzH
19339	payment	1726	1726	1874	1	1	8118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GviH2WxNzaX99jeqWw7hyHp57BX2kMf1NAW9tYmxhFUGiC3P
19364	payment	1397	1397	1678	1	1	8782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FgKH1DdDPL3HzPnCvZT8jenXnRYRPW9qNfBKkRgXGotz2TyW
19365	payment	1726	1726	1874	1	1	8133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZow5whRzweWVfyyJfb8CSGBjGYQYwYFuPLY3eANFZFo8yM9SME
19373	payment	1397	1397	1678	1	1	8786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKLxNRSyT169kwBBSfCYEXxz3jQ1kGRzZhHTweyFsKghQUx3U
19374	payment	1397	1397	1678	1	1	8787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrBZnubcoHXYKWwDBGQignRir77AiTsipcbPcccviFHzYUCgd
19375	payment	1726	1726	1874	1	1	8138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsm1kDTfBsULwEMbb1vyEM9DyrMhvi6yNZJZdisDjrs8GyxNDN
19376	payment	1726	1726	1874	1	1	8139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVuQ5kYrNoagLDsXcGerAEz6kdKHdTbNpvUPZJpEcSMZo2oGrU
19389	payment	1397	1397	1678	1	1	8793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe7WGu6YKAiRBuAa7WfwU6jr6Hd2Y2gJ8rBYkm2m6NMHZNt6ch
19390	payment	1397	1397	1678	1	1	8794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbdqLES3PAtRVos12YsNibLVnwh9co9SVFK4TCSicEuXUjSqJ
19391	payment	1726	1726	1874	1	1	8147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwmThP8oo5VzgEbPvz876TNZEJ1LMh32cp2kD2iQi6iHkbjxY
19392	payment	1726	1726	1874	1	1	8148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gAVUs1LQKDZbuJ6JrivtExeX4Aj6vRRvR83T1hWMczak7vLc
19393	payment	1726	1726	1874	1	1	8149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8sZFvyyowuGouFpjdQqNgSjHiLWEkofQGdufjxVdUU9biC8g
19394	payment	1397	1397	1678	1	1	8795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhVJYt891pQtx8ZmLnTf2PwfeLdJsbQgW81CHb3gebM4tE485Q
19395	payment	1726	1726	1874	1	1	8150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaUFhkmWgqRbHLzNjXqsYTq2oqQyGA1FpcY752WQK56Su7d6y
19404	payment	1397	1397	1678	1	1	8799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWiszcDupM3uYMsxXMDtxJvEqghTo4KTVSrrmTJkGhgfjM7Py
19419	payment	1397	1397	1678	1	1	8807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLZvgH2YJiEfB88hF8o2ouSs8CheXwTPL7nynaDfKgFEUCM9K
19420	payment	1726	1726	2131	1	1	8163	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzFodrBCm1WAJFv4fpt4dgzBDtuu1mM2S3nSWX18N5NzQrX2xG
19421	payment	1726	1726	2096	1	1	8164	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaAvLameQgrvkNZL2Tnka7Tv5dZHF3xa8nNY3k2Gc3rwmEsPZda
19325	payment	1397	1397	1678	1	1	8766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5v9c2HyUURw8xxRg2Tkwju9CqwWvmHPmTLm6SQX5gsuB1AW4T
19326	payment	1726	1726	1874	1	1	8111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwFUCGp5W25wzCoM2UgDSShcTwUcJh8viGSLnDQ5vZWT4sBXA
19327	payment	1726	1726	1874	1	1	8112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8jV7qM2dipgPciBhoUKNnbTEGU3Vd6XvCTe1VmQwT12pT41e
19332	payment	2129	2129	1705	1	1	0	1800000000	11000000	65535	E4YntGBojNhZt9X2GmQRpsNwEHxWWDrtitdjRU1h8n6UVqBQ1TeCS	CkpZsn3GgWc7N7Ry64rC6Ew9d8e5eJAKX4MiCokAsWMX9R3yqggTc
19333	payment	1397	1397	1678	1	1	8769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtxTY9ckqDKsjNK2nKoBLbdhuzyPhWW3GaAdg54ggPBNK2CuR
19334	payment	1397	1397	1678	1	1	8770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iJXeKEWnjsAGVUUFQ3pEsimH1dEHNyrYteuYrNbcEmPJfuty
19335	payment	1726	1726	1874	1	1	8115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgzsWfyNXRGRAuouWV9Ews4iC7teKqKY5yez35y4qqVy9YLj4
19336	payment	1726	1726	1874	1	1	8116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kUVCvWiFRq4HJF5Zz2G2wJHZ2V3mhenXbq7nC9wBnNaE2GEx
19337	payment	1726	1726	1874	1	1	8117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb7n7GZarUEh6zuArj3Mt2sKbyncfp7E8mRqmV2ceW4Nr5Toau
19342	payment	1397	1397	1678	1	1	8773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDyt6UBEy9EncQbkM8VyCyLvpf1Rc1kfE5x7vmk2xNB5dySdW
19343	payment	1397	1397	1678	1	1	8774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfK4G2MCwHAEUHveuWLjQz9C2DjVisvdzeVzkWCVAmd2mVAzg
19344	payment	1397	1397	1678	1	1	8775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUtet8DhoRAPudZkk2czyqzPmUoA3gzoGzLW2XxTPbw9NTEY8
19345	payment	1726	1726	1874	1	1	8120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbLa98fpRFA5bZruqhDvkhKBUjoHxbt2sdoY4iedXWLKAfcpd
19346	payment	1726	1726	1874	1	1	8121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjV9xA48Evfyn51grPjHTwaJcsRYF6VnL7AF3rYeWfXWdan19
19347	payment	1726	1726	1874	1	1	8122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNkWjCrrTKDndXkpLoWsHL2V33cAqDwm2RtmViU1zKwAzBLWg
19348	payment	1726	1726	1874	1	1	8123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq6e6dCdNs7zBMoKReZuykPyCqmPyYmcXE56wNACZUoLcGWUo
19352	payment	1397	1397	1678	1	1	8777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaCUm7TE7PSrVbtBRExVhknH9TaU5Qui9RgKPTsJz2dF52zdU
19353	payment	1397	1397	1678	1	1	8778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqT81x5UzVQTWorz4Z4MqLXDAjkN6uANzmbUhU8NwkKQQWZxK
19354	payment	1726	1726	1874	1	1	8126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5sBvMxTQScEMK8HwVXfPGp9DumrNQh5ntHA3t7rnvvviW1jo
19355	payment	1726	1726	1874	1	1	8127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQUPMyro8CWSnnrDaNEBqYhof5qvNoxeMqZhZKivkX6EqVBoJ
19356	payment	1726	1726	1874	1	1	8128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5svCJ8zf9RUVF3LoyJj6eZZMtP4WHNthDC8KsY8UmXzJjhHiu
19357	payment	1397	1397	1678	1	1	8779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6bZ2quS5qWLXBP6DYoCxuGwXWngaQdN1SB1XHV4q5AUB7p1g
19396	payment	1397	1397	1678	1	1	8796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XzqqiQtDUNXKYJRhNr2ghg4Lh7b7hZX9a1dVqG3qL5ABZtf1
19397	payment	1397	1397	1678	1	1	8797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNW7p9scHABPgCvRHiTgyvZuB5e1xwJbHeVz3Dpw6JGsb3oK4
19398	payment	1397	1397	1678	1	1	8798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyrtkThc3pxPAynPYWCwBN41sWbgdxLoRD8FFtSHNNdbYdRp8
19399	payment	1726	1726	1874	1	1	8151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxiFxvct9MHESGavsQBLxZmuQwnZ9U8ZEis2zEpAXUtCCENbgh
19400	payment	1726	1726	1874	1	1	8152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NH5ugB5rTs4AUMoN62wKSunaYW6GrfLy57yLCs9ceihkSn2L
19401	payment	1726	1726	1874	1	1	8153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5X55wQ7SPQ4ReQa13B5dfamgpYLUnFPrsZsBEZ4tbETczWtX4
19402	payment	1726	1726	1874	1	1	8154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPotKTGLg3R5gyzZf37zVb2naPvgw1R4Pd8BEBmuK4EMFxT12
19403	payment	1726	1726	1874	1	1	8155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTxUgNtLDdoGtAgfGKoVMQkKxX9ZAhG1o2WhDs8t7twtwbMsm
19410	payment	1397	1397	1678	1	1	8802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsixepnmvcL4vwio1pmbb6uadnE3AYVeLo41VJ1V415Zrgpts
19411	payment	1397	1397	1678	1	1	8803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9p2tv8S5vzmWK33Zmo4GPAEexXidDizGWxDKujGXCVJYae9v
19412	payment	1726	1726	1874	1	1	8159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBKXnWDX3Dp81hxdUavLxsqFe7Z9wtLNUCe2XgZ5UU3CQMgVf
19413	payment	1726	1726	2118	1	1	8160	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKiGMNBR6yjUc3jDgJY21Vd6et5RwMwM6zSh9nqdWXWQGpXf4A
19414	payment	1726	1726	2130	1	1	8161	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm7uD7V3KQRmLR6dpCnm4zUTvKELmfjNiey8GNJpVVcJdXNwoU
19415	payment	1726	1726	1874	1	1	8162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9thYDrTHTaKW6iAjjTEs3RkTUhvUY6cCJ8u7Wghj8jRYFgsv
19416	payment	1397	1397	1678	1	1	8804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSbeMhFMwfDacaUmnyj7UkuKG6CDSkWnNyTzNrvWtb5iTAdbX
19417	payment	1397	1397	1678	1	1	8805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1iZTBW3PUx12BTcxnTdL16jaFMk6ppxZo4hJaDLSkNVPPTgX
19379	payment	1726	1726	1874	1	1	8141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSsHoxAZK9CbTURwhuRxHmWYXfVtY8izpkfhVwrdqWjebgSqh
19380	payment	1397	1397	1678	1	1	8789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtBJ3UFteVjYXY4YWRZP2tQzdJoQAneJJE94GB5amqTan7mk4
19381	payment	1397	1397	1678	1	1	8790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiikxD38VZqaNA4DXAf4V7r6VVSU1PQNrv2o2BdLtJongrD1cG
19382	payment	1397	1397	1678	1	1	8791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpriy65QB9iWorq44goNk932ktAiqiGxtNS2ttyi15mrkeZ5GJ
19383	payment	1397	1397	1678	1	1	8792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3bipGauiuqxEQpHemhRbp6HRSVNJv7zu7xMLie2w251WBALx
19384	payment	1726	1726	1874	1	1	8142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgdux85QCV4TtiJWBcG7zXcNeLihen8xU6UuwHkqeV5bC1zy1
19385	payment	1726	1726	1874	1	1	8143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraeFzgYhAw6GKtYMuT3qJ6MEyvp3N7KKSFK4GCHzpHG264qC7
19386	payment	1726	1726	1874	1	1	8144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAc4wwhKR1pdnrhEoRwwsPSyxBm5tqmgfYj3WRnv7LGF7LRMof
19387	payment	1726	1726	1874	1	1	8145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1waaAJ5piMXY5LYh5Z62uw2E6Jj8s8mxeTixhgQSNdr1HdSf
19388	payment	1726	1726	1874	1	1	8146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbwWivn5BRD7F8eJz22YBTDaWVLDQe6ixyypimxT6kfYsYuHjE
19405	payment	1397	1397	1678	1	1	8800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdQqCzDY1fHfGfRL5Tphjc3yE6pFboPwGab6WQukQT6PeNuD86
19406	payment	1397	1397	1678	1	1	8801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrGJ6ciTQSNVLjqbs6GSXgY4NxzkSYFYXWjTYPVnQLtmT9p6C
19407	payment	1726	1726	1874	1	1	8156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpVWGMqkr3EkGgWXyn7iwvDGELTp4sZw8XeNPPNf1y7MnA6dp
19408	payment	1726	1726	1874	1	1	8157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFXgvTEn7toSv7F5BQW5Hyxrjr4XBjXSRfFS7ZeQwz8s3hM3T
19409	payment	1726	1726	1874	1	1	8158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVgSmG9zAn6dwcXmBamv4c7LUNxisqdRCfDamUXQNz2JMM961
19425	payment	1397	1397	1678	1	1	8811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdekWjwkyx2SP8EMjBcU1EJstdvvrMFJ3ZGvdQ3ysCRcgHPr9w
19426	payment	1397	1397	1678	1	1	8812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yaQMBwy3WWMpBoHEEyjP9YYYttWcJDyif3FhLmBH6XYWjJTC
19430	payment	1397	1397	1678	1	1	8816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWn9hebfE1LpSyjPqkqGVtETLK2WCt9oUFzuNRBqsFxva4TVvG
19448	payment	1397	1397	1678	1	1	8829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFM3FcaDfVmFo76RXshmsZy1oTfUH1TqyJE9YMbEoJmPLDyFm
19449	payment	2133	2133	1874	1	1	0	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTEKq7of1AZRHC9ngFUQhrpWbG3Txz2RjJ9k81Qe786gCJtLv
19462	payment	1397	1397	1678	1	1	8836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKh3xXTgaEqjd4onQBovLk2jEHSTdoTG3C8HebixJ9JZUiHdX
19463	payment	1397	1397	1678	1	1	8837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcuB9YfzhEXoZGuBNW5JnCKuo5gS1cauz98WmPdpbnWCDzQC6
19464	payment	2133	2133	1874	1	1	7	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCjvTE4iWF9LYYnFXBv9eR3jxPJyqYsa4bThhX8YcttedpF3B
19465	payment	2133	2133	1874	1	1	8	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJx9W4qhio8fobdSvwKWVrQK3yGQRAiXqPDeh8hwxk3GVcgNrk
19466	payment	2133	2133	1874	1	1	9	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakU2HGWhZRhfVCqE5rq2MP51SoSGVYsxRr6kFHwGRUiZzUzAn
19467	payment	2133	2133	1874	1	1	10	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7G5SGozoo8vQzt9FgGCV8ZD4Dkhg7S4pA5pK589mRL1XDrAyC
19492	payment	1397	1397	1678	1	1	8848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AXnRN1pFpGhBuaNH5eHBtny9RaDiUhLiKoeZsuie1aW6MS7r
19493	payment	2133	2133	1874	1	1	23	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDuXQAqr5F8AnuEQffKiGyARcGu2gWMZshM4Zujr2Eq84sSVE
19496	payment	1397	1397	1678	1	1	8850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4XPAF1NP4sDBiYecRoWFja5SkPxLyMdfbJf3d7kbKgbHQde5
19497	payment	1397	1397	1678	1	1	8851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mtBeQZbaXhJNV7oXSZPqqiPr7jXCUodWvJqGx8oVLj62pmDs
19498	payment	2133	2133	1874	1	1	25	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCM3RGQatq3QUcGumQQphb3mWAF9TSnjycknHkSPmpVKt9FzP
19499	payment	2133	2133	1874	1	1	26	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmr37UPTG4Htfpo6D5XpZRxA1gKNbKRdxhF3drW5tEYQ7fomH
19500	payment	2132	2132	1874	1	1	2	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3ihiPKgZgbUSL3LpgysYd71MCpA5Je6RyZbRkNaGPoSoLJWL
19501	payment	1397	1397	1678	1	1	8852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QfjWRDTB8SWFoKTJRPvYiH3mrJmKzTrq4YSBMugQZWGTaF5J
19502	payment	2133	2133	1874	1	1	27	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwafzzvuBovK2oZAJpjcdWg8h5md3qCwaLsWMX9cqS7ch3LLga
19513	payment	1397	1397	1678	1	1	8856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSika3P3W6RZauZQhAsnsxXdYXRCgFXwbJ4BKdYkuA371sekF
19514	payment	2132	2132	1874	1	1	4	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Sd9WFF2KKjJRLSrh1AfwzEUhQizA1TSXdtuWk988utHnW7wt
19515	payment	2134	2134	1874	1	1	3	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2UD46ZTRZd5JwpuUYtMFr7xdSgj5FSKLFFpVGu8zwUwJya7h
19418	payment	1397	1397	1678	1	1	8806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkvti175SwRiUhcPLXN6f3i5FbxB1m39jfKKZJX2jZNuCYDnb
19423	payment	1397	1397	1678	1	1	8809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SnVL1bYrddKozoS2F2k1cCJr2rsc3W2g4335qGFaZo56E1Hv
19424	payment	1397	1397	1678	1	1	8810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujDj5afGMoTcdxAcv4PRGTwcZersCsvZ5TZnPZ7mAkgJPp3V5
19433	payment	1726	1726	2132	1	1	8165	4778000	150000000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	CkpYnNaYJnUdgYai6ALH5YRtLXTC83dFaZULJL4MnujZJQEB6PSQV
19434	payment	1397	1397	1678	1	1	8818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrNCFhiJkfrzWu5cJzSh57Ky89s6PkxxXbeguTS5N9Yh5G9Xv
19440	payment	1397	1397	1678	1	1	8823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh2HAjMkHWTbcq8CTMdaFFNaBZmaW6y6aT6bm7RPkvACvKzwo
19441	payment	1397	1397	1678	1	1	8824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCV1pyAfdk683EX313cuxZC5BmKaaMDeRMjeLVUZLRpL56jzeD
19442	payment	1397	1397	1678	1	1	8825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54uWhT8mP9ZTqqowSTHFbLfgM5yrsjLo44pfuPFK8kLQRunrx
19443	payment	1397	1397	1678	1	1	8826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RHq5mQqhqmMn8mRXjRigw8nrTpWYN7CfUoct9chXfEBkd96A
19444	payment	1397	1397	1678	1	1	8827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAwnwkkWb9y4M12Q8zek1pBG7YHcVAfzfDhe5puZ4XNhYGMYa
19445	payment	1726	1726	2133	1	1	8167	100000000000	1000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	CkpYS2QCMJJMA98Dr4dXHphcLY6QouoGTiGU3SKKZqa7BjMmrJgwB
19446	payment	1726	1726	2134	1	1	8168	100000000000	1000000	\N	E4YnuyA3GYg1X1GwcW56QdCoxVcCLwLaPkjX36iFKJ1vioKHLuXpf	Ckpa3JfFqDv5359RqFqYCZsshMQvDignZuQXBEf8XaWQiwVtS9mDb
19470	payment	1397	1397	1678	1	1	8838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68kpKYSaEMLmkbkth8ZStMj8xqhJmAFCSUaGLLmANJqzpiENE
19471	payment	2133	2133	1874	1	1	13	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPu2XAaWqRx6euRstnEmu2XxKS7PqwP79Sjf3oRJH4jYWG1Jce
19476	payment	1397	1397	1678	1	1	8841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhF4V78aNJwNenbdesVWM2cpEybWUDNrMKJy5Q6A1Mp7aayyzZ
19477	payment	2133	2133	1874	1	1	16	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9nmRHkJLsH64RA7sVSKxnhAiD1E6KzDdZxYgR2UujEr7EaDn
19478	payment	1397	1397	1678	1	1	8842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjfjX5siHQ67rzSU5BwP2ZwboRsjL41Nu5zJYUSGZUCNkvDRa
19479	payment	2133	2133	1874	1	1	17	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGabhSDdgNgxQDsdFf3NbgYvCJopdUEA9azk6Zs4a3KsuXYKc
19480	payment	1397	1397	1678	1	1	8843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaY5kYpYJnYnwVSUh7ntyEHRWsZ3sZcH6dJNZs4m66bmR7qVC
19481	payment	1397	1397	1678	1	1	8844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYP6CtjX2VdV5pUkPL7nUfSqrKGd9j6R5F1p1k8Zh8QBkSmZB
19482	payment	1397	1397	1678	1	1	8845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAg8BqB4aV4jQrMHKkqbvCyvzCZ9FEWspsfoXey1R6WqSjRRy
19483	payment	2132	2132	1874	1	1	0	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEX92qRRCspQahTmDHTMy2oKWkYLt1y5f4J8KeQU3diTvnPAz
19484	payment	2133	2133	1874	1	1	18	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsuLyFTH3pRvTVE7xifLdTrq9gBs3r7VAv5Zwn2qRG9V4DcaA
19485	payment	2133	2133	1874	1	1	19	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQj8HZVDLyRVq3JVMbqFhcZtYbENsJXvAUqoUw77BHqB9gxGM
19486	payment	2133	2133	1874	1	1	20	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGbvaYYJ529TgRARHKDQhH6iQuPLatABhKSzvNCMF3z5Bh97W
19530	payment	1397	1397	1678	1	1	8861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkP5aQaiRTMQdpGrV2mtA64kD1PbkUkKbEi8SSoAYzakEbbLZ
19531	payment	2133	2133	1874	1	1	36	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xDTt2kqfAVpgbK18Fqvpa8pQSALpPEyFdGgHGhm339ZtMuNX
19532	payment	2134	2134	1874	1	1	8	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYo859kawboYpP9FY1Akzrs6EFg9kYxqKe79LeuVnp94axrKc
19533	payment	1397	1397	1678	1	1	8862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TTC4nMn9Re9W8rSEQ4JL7Z9dXTcEuaSA3tVrDMzgsJzr6hPa
19534	payment	2134	2134	1874	1	1	9	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgb5sMyLhecCt6jKj8QtwRBWkHrrZn9ionmCJvE1N68ogAFtZ3
19539	payment	1397	1397	1678	1	1	8864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTqY3Bwpy9dx4t4jqPhrAN1fcqJYi3FP6EN8ikypLQ1fke6ZJ
19540	payment	1397	1397	1678	1	1	8865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dq4qBUNwnnveyLf3ixXvfNxAqcYXGrbfqYqjcMedgh9FPt3d
19541	payment	2134	2134	1874	1	1	11	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4KdJaG75SkDL3K3E3RLX5aW8hxMRtzuLUYXyECoFLrxWxLRK
19542	payment	2134	2134	1874	1	1	12	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YopmaRGJjSDjRWysbcKE3KkZ3cJ2nVAPCEky2bUkj3PAFQxn
19543	payment	2133	2133	1874	1	1	38	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kxEgqcoZhYrusRUFhVz8yxTz23apuiaPfwtVLsqgMeVb6iFF
19544	payment	2133	2133	1874	1	1	39	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hawoQFgFPbD96p8RkxTRKoS8ZRHrkWRobaBjFCjAyx2aQdPg
19558	payment	1397	1397	1678	1	1	8870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkHWwT6jrjKkwanAyegquqUY37SJr2ycfGagii34dcnUzUXqz
19559	payment	2133	2133	1874	1	1	44	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKLsaYwwhdxbYUq4HxVdGV8cmtp5LWz9U9DH5PencvPQKdekp
19427	payment	1397	1397	1678	1	1	8813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVkWseRVeQgzSU9J2CkRX5vaYAGRgHE9yCUsxwzfPMaBNDFTQ
19428	payment	1397	1397	1678	1	1	8814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmD1Cb8b1pUqBQhChGtQcYynDN9R9Wx4mak6nkVqqtB3zBXi9F
19429	payment	1397	1397	1678	1	1	8815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4q8FX9WcZu5CGqJvfqw7tVxPxC2srttjytyQm1DP35VmH639
19436	payment	1397	1397	1678	1	1	8820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDR2LwDza2QGw8XCtrEsLFySEYnZCTwTEGK8NUqmCeFLML1Lq7
19447	payment	1397	1397	1678	1	1	8828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzHpfvgWXZb7ntMMNzMzPGG56UQu6WPynXyg6jazNJoFZ24Jw
19454	payment	1397	1397	1678	1	1	8832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP9wQHQtEjqBe6caVE9VSJcAwrmoLvyxbzPbzCndRRN84FbxW
19455	payment	2133	2133	1874	1	1	3	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrweWsh1pKLXepRJSTmwwsuwewNc7rb4zg1NFEAgTfNWR8Zho
19472	payment	1397	1397	1678	1	1	8839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgLy5vVGXhJMDr2XsntydnhTEtzXp8MaePdW4w719fpj6cqNB
19473	payment	2133	2133	1874	1	1	14	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5U2GPLMQDRa8oMDRQLsDBhbHmmz1fp2qFFFtVNN631bAxXZgZ
19474	payment	1397	1397	1678	1	1	8840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmbzobcUL1CmmAsVnPGZFWWCaz71aXQfMucTaW3fZmek5oUVV
19475	payment	2133	2133	1874	1	1	15	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa16zszYfJA839xbyit8E8ryZ17CnmqiW6Rh2GeaE1URWARpVXn
19490	payment	1397	1397	1678	1	1	8847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JXssgvHAA9kUtqhFer8LifeCoDK7mEhj3YeMWxuZ4Rpf2rbX
19491	payment	2133	2133	1874	1	1	22	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZpawjjkZTJbnMkFfoqNDNdwUUrdP6eSgka2cADp6xrSFuFbs
19507	payment	1397	1397	1678	1	1	8854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBgMz1dj4C6ZkDvQkY2sT3wWX6DSQrfHZ8abZMAP4M8wfLuc5
19508	payment	1397	1397	1678	1	1	8855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwe82FJeCetqTZ98cAhVKwqgJdZFdJ93GeobCmFdWgL7mE5xC3
19509	payment	2133	2133	1874	1	1	29	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZWoHzqomALiyQJpeo4g3gSp9ie8C2LH2Mk1a8miv3BbHVMFk
19510	payment	2134	2134	1874	1	1	1	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5JoGXqZcXr2B1GoiqUStWF1N9FkrqFd8ErsD2cVmDdf9BZNd
19511	payment	2134	2134	1874	1	1	2	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSU4FJkAwJF12d9nM7Mkj53Amy8TNP7ahEKmzN5eTUaRSsCqsP
19512	payment	2133	2133	1874	1	1	30	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3TPYWZFozdvC8L3pUPY8wG1TrX8G8cdp4pbhm9ceqonPumyJ
19523	payment	1397	1397	1678	1	1	8859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1MEX4hQA9oQ7Q4rZX9MZvyybKhoQUs9ej5gc2vvNd8wbGWL8
19524	payment	2133	2133	1874	1	1	34	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHktSMvaKwyVMirNLjkCpMcwDiLYJ85BgM4bwdxRWzPuXsBeE3
19525	payment	2134	2134	1874	1	1	6	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYjBZmvoy68fPFMva4EBNywnHga6eC2sE9tZGLpNp63TLnG44
19526	payment	1397	1397	1678	1	1	8860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Muux7SrdYsNxAw6Kk2yhruxBprVxWKN39A6cGKXkNm1uQSUp
19527	payment	2133	2133	1874	1	1	35	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTvCGuR4Pmb8H23FW4H3XEPvzn5Lr2t4bb3vfB1wWT3q7piPh
19528	payment	2134	2134	1874	1	1	7	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi64K6tGfzYAjp7NWuH96Vq7ZHGAkdY87Rwpp8dSdTrQhadWJY
19529	payment	2132	2132	1874	1	1	5	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbwVpFXYtXrJUpp4XNWufSMTRN4favS9xSyKgtkymqUGZXkBo
19549	payment	1397	1397	1678	1	1	8867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL62NmDJNJjwv2JMHWQq28x44rYKkxekrb3n2jjfPxTAatrDSp
19550	payment	1397	1397	1678	1	1	8868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUYEYHENxcDLhv3T5yYrMRkMjqUY5oJKhWHmFUMs6dmqDtH2X
19551	payment	2133	2133	1874	1	1	41	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7Z9XirRZbhXdWyZxtguB7LxtCAGytmE7qhdFe2Q2oe2ZiPSg
19552	payment	2134	2134	1874	1	1	14	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P1xSo9YRntkuVb4FsbAgaKvNpX9E1n3kMSbRxLrE8pBtf4Cn
19553	payment	2134	2134	1874	1	1	15	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcHEvZMW3jW1cbPT1KKzJaejH2i6xw3ph4MNfw8VfKX2coAYUr
19554	payment	2133	2133	1874	1	1	42	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJomGcrpTEko9DHrqKukCDDs9vjwSBdajR6cEgk1Bg2qpjFrJ
19562	payment	1397	1397	1678	1	1	8871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUmcEx5vSa3fGrQaVmrGHXim2Z8AdPvuzwu4DV9oeGXAWfVkKd
19563	payment	2133	2133	1874	1	1	45	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3XNaHzzGTXuVUe6r2Y8ErnaioHnwSRKTaVYuPZLJoVdzuQKW
19564	payment	2134	2134	1874	1	1	18	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3VGTBKDhrXhkPst4zTHfQjBkP9Zv6j8TsFkSQpjwBYfZJXZX
19575	payment	1397	1397	1678	1	1	8875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjophm9oUZBaXN9eqsSKpjBbr8xfGBWXc53H1Hrw6jcKndMdoY
19576	payment	2133	2133	1874	1	1	49	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7NDufFU89kZEF2S4iuYh3f9gJV7dLUaLaoxvhQ5G7np5nVHA
19577	payment	2134	2134	1874	1	1	22	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkgev6NQbL7XXtW1KFcjpQpd49qVy5qqmQfATTumpGyC2qNU7
19457	payment	1397	1397	1678	1	1	8834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5pu5x15196xyABZnTo3QAqHXN9bwZRRoGKfpnzzSN9Af21u7
19458	payment	1397	1397	1678	1	1	8835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfNxkgibcfYcCCkkp6DGFyJszgTjYYkD32hKgCNz8BCkWAYKW
19459	payment	2133	2133	1874	1	1	4	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx5SLtvfVE8p6p6APC1jH37qN4vKQsW4HzJWhkix1yw9Vjkse
19460	payment	2133	2133	1874	1	1	5	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcSH5si9gDnRiPbgLvuuSbEgnM2p14puT7VsQTEsfvHKQkrYw
19461	payment	2133	2133	1874	1	1	6	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYCnQnoN52FZZH51KeyE4VLg1TqDUvoqBeFtQcZu4ozWrCJFB
19468	payment	2133	2133	1874	1	1	11	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUYBvPRfyUchf6LcsSWY5yKeBUzfXSFK5jn6t5Mza3aNRTtF4
19469	payment	2133	2133	1874	1	1	12	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosFmdFzC8kZtos7mm89ZxbspYQzFCQ5DEfkezRbT6gFzFf18X
19487	payment	1397	1397	1678	1	1	8846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gye768tUi1emWYdwmxEJGL7WmtVQ2hYu5mLz7G9CD4jR5Fh6
19488	payment	2132	2132	1874	1	1	1	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCvgqtcKWwRu92P3RYY38Pu2V3dEWAfgRiFpPExnrtdm6sVus
19489	payment	2133	2133	1874	1	1	21	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagDkkm3qMxDt5YVMKB9Do1H2PTVsKs6k1ARWVk9rm8LxaSwBQ
19494	payment	1397	1397	1678	1	1	8849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXXbJ3g2diNfhozAitn8J9ibXHLLBciMJUZg7icRh4jPt4J3M
19495	payment	2133	2133	1874	1	1	24	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHNeBUfURp8YVyFd6sJo6DMFTV4o7sBYjKZ6WFasRPa97cYSa
19503	payment	1397	1397	1678	1	1	8853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jUf9KBenV1Jz5WnCV38VgRFXkD4gkkF1fS1itSGSSdhpU9p8
19504	payment	2134	2134	1874	1	1	0	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fZH1QrbmBaQuzj6aDHYQ5NPLAp1dxbYb8H6aVHatbPsTMYkS
19505	payment	2132	2132	1874	1	1	3	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBAvTSq2jbcD1oL1whkJ6gnHktErvyv4gpdQJSRCABY8AB4Ds
19506	payment	2133	2133	1874	1	1	28	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3trcPpF6R9b9dVxa9xtt3PkAu8nacFr3a1AYUXE9QHf5hshD
19517	payment	1397	1397	1678	1	1	8857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExn13znCt6LnX3s5aYuPtB4CiXENm1NSz3PBTaFx1T3TA5xMP
19518	payment	2134	2134	1874	1	1	4	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMDqmcBQAd3eUNyKKBPwKdbYyFwNUsV61NaoaovweNeKGvn4z
19519	payment	2133	2133	1874	1	1	32	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfksFxJyVAVswY8pbhT9wXMutMCKVyuMAX2LgCmT1qYkKs11X
19520	payment	1397	1397	1678	1	1	8858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXWd5cYQJznmitX1yjcHmZE4Rs6VxBjLr4eHvPt9eBqZxA17n
19521	payment	2133	2133	1874	1	1	33	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnj35AnfcwQ7PDK5g9iKYkMtTMJ7eou6Fs7AQd8gNBq3gaaSJw
19522	payment	2134	2134	1874	1	1	5	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ687Mv7JCaJHYTztbn4XhwFdm1359F17JoZb55ivSJLMP65KhN
19545	payment	1397	1397	1678	1	1	8866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vkdM3boWRHpo8AK72YfcHq3qpp17F94cXZuHfm5SaNmkbyuz
19546	payment	2134	2134	1874	1	1	13	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBMr56J18FQsGFuLnTp1t9wX48ymY6eX41mon3KqeU9pfH1us
19547	payment	2132	2132	1874	1	1	7	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrFEfFi8mWGCjDMRckg3AVMNuPqsBHaRJyoxpd3fYm9oB4e75
19548	payment	2133	2133	1874	1	1	40	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6zcoBCCKP3vYi37gUL6JXJDYjt93LX8sfymWL6Jcz9vEorF7
19555	payment	1397	1397	1678	1	1	8869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoULepahAYwPgRxWo9ETdt6nseHy54uNXHzHsX7fTyiYC4Vct
19556	payment	2134	2134	1874	1	1	16	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRc8towDonf7CrJ9h1f6hYFaG4oJ45fuCmFvbCWaBbDYo6aUy
19557	payment	2133	2133	1874	1	1	43	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dZx8x7ghVsuU1a3YuF56Z37dSLvNmFi2Xam1FZkDHvLQswJo
19652	payment	1397	1397	1678	1	1	8898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeeHUymDdyZxH7sQyRqCp7WRxToCaYAocMymrYEDDXbWHjFxT
19653	payment	2133	2133	1874	1	1	72	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1NYWRfsymHGXLd3i5usvWaXzta9wTYqAfhjZcGAHFQFzAnmR
19654	payment	2134	2134	1874	1	1	45	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2F3J36gnmtgcoLsz36tLkT4V2vvKKhKnpApwUmggpHq6WMPY
19672	payment	1397	1397	1678	1	1	8904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUPDWhHLciYnkhvacGU4maKR1owJK9LL88czYAKxtfesKfCvY
19673	payment	1397	1397	1678	1	1	8905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtos1PaVTwtmSfS7S912rKXu4CATbVctDCtRsUfN6akb7Kts14
19674	payment	1397	1397	1678	1	1	8906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdzRXTuzCqEtc2uQSRLgwqasqaKgGRqKCur9X4se93JXFvbJZ
19675	payment	2132	2132	1874	1	1	19	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeduw6Hxkhj5nvXRRSjrC5Jyw7tpJ9KaizfiA2izejcwPBkNhd
19676	payment	2133	2133	1874	1	1	78	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEm3shRW6xnNHnKuKKWy6vrpAKHvaiWXkicr7PMGxK2viNYTwK
19677	payment	2133	2133	1874	1	1	79	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwD5F9tm5ekBJJH6PP7zFzCK5wxNmhX6rVX7ESU34ed7AS5zSs
19516	payment	2133	2133	1874	1	1	31	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbjGY2sYVb8rh94Vz13gC5BwFuBLjF318WWMED5qPmVz6WDXy
19535	payment	1397	1397	1678	1	1	8863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFuELr6eCU7fEh1VizwbZ48QHmQq2eTtTzCfXED8FgzpyGYDK
19536	payment	2134	2134	1874	1	1	10	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurF5bQfzCCz2J972P5e1PBh1qijUnYSwYDxhJR9UPiXT8whjr
19537	payment	2132	2132	1874	1	1	6	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5C9YKt35AVxsRpJAuhUrJoGQkfbt1DWXmp53DEYAkxt3cfS6
19538	payment	2133	2133	1874	1	1	37	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXkSNSVk7LH27v5QuSaa2k3ehLy94Bvq875SJeCZkJTj2Qdsm
19578	payment	1397	1397	1678	1	1	8876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22C6fMGupe7fuBe894g29mQc4o2jbeotKRXbGDKWM8mXjYXUE
19579	payment	2134	2134	1874	1	1	23	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kYGnBuX8CgRkLD4hpRpP85DDHkwvuSJw6gJCGz1fuXT9E8rp
19580	payment	2132	2132	1874	1	1	10	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWP6Fv1jApuuT3YUCDRjsEKjPxpN8me6tRFCrjiaK3tm7BeNC
19581	payment	2133	2133	1874	1	1	50	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4q37iBsdojEnVeEKXki9VsrHpN6qiud6HKqiQQo5fYJGcfVS
19591	payment	1397	1397	1678	1	1	8880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcLi3tKLRsAuFyPHfgnmCvxmJEdU2ZmVe4krgroCrs8zETieH
19592	payment	2132	2132	1874	1	1	11	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqKuihvTbUmXS4WugYAEzwLM4Q7CpESQZ5Kvd386jfKSAmeAq
19593	payment	2133	2133	1874	1	1	54	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGTDvP9qRhcasKgDH3PJwY5JprUEbSpqV7TggR4D9QxEQ2yAA
19594	payment	2134	2134	1874	1	1	27	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7dFYMZR6FH5RKKNE57BfsrTfS6kNVceR7bANroPHxqyGZHy2
19601	payment	1397	1397	1678	1	1	8883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcu8exVScMo63wvzj9CXg1giadSFxQsPYgQUkXZaVAHbJaDkFo
19602	payment	1397	1397	1678	1	1	8884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFQJ1cY8dj72RiXFBueuxWFFB5uQvGpdo5Qtggi1Y1zojvMFHy
19603	payment	2133	2133	1874	1	1	57	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFXJkAwJdrGPoTXhtg2vErnqSLaCz8iWSpJKp9ghd4tPUF1gz
19604	payment	2134	2134	1874	1	1	30	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxD4BNgsmss4oJjUcULWMGhJuvgTJ9kf7bH7ahVgaoo18W33f
19605	payment	2134	2134	1874	1	1	31	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgM72YJD8kCcrLXJbv32yDrxvtM2njKQobSFvHhTKvpvUsRRv7
19606	payment	2133	2133	1874	1	1	58	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EoN9ptD23BMzzXKnXQSNeLqHUU4tDgg4rbF71hTen1pQkezT
19607	payment	2132	2132	1874	1	1	12	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5QFmKeAPJp74HCcP8CupRMBeVWq6ab8yT2iAxf6C8eQxHq8j
19628	payment	1397	1397	1678	1	1	8891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrH2PgnzeKgtTnZvw9DbhyqPP1ATKgwHd9KUcMacyh7h9ChHP
19629	payment	2133	2133	1874	1	1	65	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1iK3ajAhU8tUCAjrhaEoKasidC14SvaAssDiCpFaCXcbmtb9n
19630	payment	2134	2134	1874	1	1	38	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojBpzWRPQakr3cnspsr469X6dHYBAvSpn4ooj1R1E5YFtuHWd
19638	payment	1397	1397	1678	1	1	8894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJMSHYTZHb1zutMr8PDkynmCzCV5Jiap1VaCHWegR362LRt92
19639	payment	1397	1397	1678	1	1	8895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXyE6CJgFfE97BbFakSiGX7TheHMQrvFU69Rpu56BGFQmgnza
19643	payment	2133	2133	1874	1	1	68	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVjUWZ2va9ezB3TYh7vMpAU4TJxHvhayJjb55899h4DSRinfa
19644	payment	2133	2133	1874	1	1	69	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFpbo1zTGQKjj6LDVZ3RN1cbq39ZmZfckSKsy2RJfezLJeam9
19645	payment	1397	1397	1678	1	1	8896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjMWZzQo37EmRftZB2imgXRh1ouDn1bXyCC4AJpWv2X7eftRB
19646	payment	2132	2132	1874	1	1	16	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwWMcTEvQk96ew9JPiGtzm3c418HeEmE9ywCcFMCYNgQk6wrT
19647	payment	2134	2134	1874	1	1	43	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL5CNT6N2PaAbKBBU2pvXdWo3tErUvLFqbZW1EjFKBBbCfwLkh
19648	payment	2133	2133	1874	1	1	70	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfF2qDw4mVXmjfGaBrJ1ocv4ZUdBvx672J1qfCFLXmDz2EzM5
19685	payment	1397	1397	1678	1	1	8908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoa1t2zBfm4TayFWEw4p6D7TRW4aYxnopzBCjBD7FvrZLmQuM2
19686	payment	2133	2133	1874	1	1	82	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJuuZtegNaFNiLQS4vFUwT68FRd3u1NYWS4zLbM5zoVB7B1RB
19687	payment	2134	2134	1874	1	1	55	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2r2JtAmd3uKmTLrq64Q8SfAmKeFqNVetcSCvB5LEzvMJkdjWg
19695	payment	1397	1397	1678	1	1	8911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabJDx5aLBZRXAeufqG6zGZtTZLZT33ui8mbvXZbE6VLrWJoBF
19696	payment	2133	2133	1874	1	1	85	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSMgBeFuRFVTB9gJ1z25WCn9UvRi3UR3DJd1ufvYSHgzeW2ra
19697	payment	2134	2134	1874	1	1	58	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7SCjKh2LXe9tDfrCAws1GfzXfeWEK6CDuAufSNsxsdocmkJ4
19751	payment	1397	1397	1678	1	1	8927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsciYMQcYAraK4wa21LfMcr9t4p5PNpBbby6b6mPFEzvvAxLT
19560	payment	2132	2132	1874	1	1	8	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aEeA7X7EiVEz68KZPPDN1u37AkkTD4H9gKViWkv5YFmt2TGs
19561	payment	2134	2134	1874	1	1	17	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiiYZr1SR8CB7zTKk8pQXjte6hLrH8t8grnyqf2a4o3BEv5h9
19565	payment	1397	1397	1678	1	1	8872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhvpvHtnb5Roc7LYbZ9atThbTeuCb3Z2dqbMRnYFyrz1xU82o
19566	payment	1397	1397	1678	1	1	8873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSfNjSQ6hstyHN6xmxZdvP8SCj1ApRuFZJA48TGs5nEGZeAdE
19567	payment	2134	2134	1874	1	1	19	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvfvDx4Ff4bT4qkiGST1HjBtCFpjazy6ujpZmsUJii9R9yiZ5
19568	payment	2134	2134	1874	1	1	20	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aaajpVwR9q8h7ir7UkWAAP32kFVeH88T7Rxwnggtpi98ySa7
19569	payment	2133	2133	1874	1	1	46	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZocX32r6bxa5TKjXtdZqUwm71JfbhwEbwk7EWXfjPji23KNv9
19570	payment	2133	2133	1874	1	1	47	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPhkMjLmEAFN4yA7xsP8QLN84N8K6Me99csGdVYKmQXZMDHPA
19571	payment	2132	2132	1874	1	1	9	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzksrXn2qoAqmMHWws1dTsKvqq1RihmN6MJXevmm5UieoWJQnC
19572	payment	1397	1397	1678	1	1	8874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoQoJj5U4sWWDtDAchBt6x2N5meR55ZwwQpcU8819JXanBZkp
19573	payment	2134	2134	1874	1	1	21	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzn9TgYNsJ6RkwNjEVH1yRrh8YXtQBWxobEsyZnkVBA43SP8oX
19574	payment	2133	2133	1874	1	1	48	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3GHcb899hbdr4BG58z9kdFZYbjMuRycAkCBT8y4e2YmCcrnc
19582	payment	1397	1397	1678	1	1	8877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4Xp2JhtR1dgNCDgB9qHXhs8Q6vzRmWGkDZMcKDb6uZsE2wS7
19583	payment	1397	1397	1678	1	1	8878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfC3A6Xmo3J88RKPJ3Vde2Q76axrR2gH5yM8pV57871fqipvc
19584	payment	2133	2133	1874	1	1	51	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS2Fq9GAmArKtT2h1aXTZFGpJCSD5zBb8Hcy5SAnU9Q7Dqvk2
19585	payment	2134	2134	1874	1	1	24	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2gSw1amYEaExFK7KusQch7d2qxcSvhfveSX5DnBxLF8frtrNE
19586	payment	2134	2134	1874	1	1	25	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEMmtq1vnPJxdcvxH6sTemZWk3bMpAeBsai2X8jmrHmJKb54Q
19587	payment	2133	2133	1874	1	1	52	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGvdSMQ8JgvGLx83aMTGtaXWFZHWgC3GmjqJjcX4xv8fPjDuu
19595	payment	1397	1397	1678	1	1	8881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAnRgKdBPF2reVBuC4R2s8hcwjsiAsxbfgGT35wyqHQrhhoSk
19596	payment	1397	1397	1678	1	1	8882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHuTgToaUF24gFauyPxJYrRm9EPP3b4nFtboRE4ibJih1a8n8
19597	payment	2134	2134	1874	1	1	28	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYBC92SwSCqL3ERVdgf3oGHbRDQRodpHviPuME4BuGtLosfq7
19598	payment	2134	2134	1874	1	1	29	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBGAyxFjUEDcppP7d7KHcCWVhjcs6VPkjHVXNHvsuPrKvgacU
19599	payment	2133	2133	1874	1	1	55	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4GaLZW1Kpe91rniUBMH5HK5MDcEL2bkCbhJBGLnu845CkA5h
19600	payment	2133	2133	1874	1	1	56	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp77imaSsrT1qaH3yJkKeubH9TG3th3ZwAaadSmobWeURSdwHc
19608	payment	1397	1397	1678	1	1	8885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW2p4DcBLyAAfBLnYwxMXh7wSa1jwzYiszek5rb11qm6PX59F
19609	payment	2133	2133	1874	1	1	59	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimki8iAMmMwLmmdaXicPRcm33LJwA73B3hQ4CmoW53zmJTsHB
19610	payment	2134	2134	1874	1	1	32	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfRid5YD7xBQwYKatDsE5D7n5YMXyGSqwhyKEgQeRQumQuTpw
19611	payment	1397	1397	1678	1	1	8886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYxFAHPsx4kRXsb8KTQ4dTmcjvZd1FwbimEmY9U5GvYoTSZXb
19612	payment	2132	2132	1874	1	1	13	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94jbYPS5izGWbPcFnj3FMSf9gxbjoVaTDu4uuP5GC6JyhZUP7
19613	payment	2133	2133	1874	1	1	60	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCzCDFFctDfAPULvPY958a7XAVFUfkgq5Nub5zi3TsouLUFk2c
19614	payment	2134	2134	1874	1	1	33	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPrDLRKnqYGZuetf7W5swopTVYibfW6mWPf49LJhEbBUV6XEk
19621	payment	1397	1397	1678	1	1	8889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHrDjz9pMxxrNC61Q2JshcwdzNdB7K2MuStTt2dUJc9kHzn3W
19622	payment	1397	1397	1678	1	1	8890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoEgH4WJfJTsA3r2GVTVqkEL9adyX4Pvxo37dYUmX5qGfVFKQ
19623	payment	2134	2134	1874	1	1	36	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEvGMF1imCwTuhwAHGsKk4GXiXKNdtCS327LNoaosPKPdKgbM
19624	payment	2134	2134	1874	1	1	37	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExkPzd1xVQUhKve1PnWcBEudgx7y81E5YubhjnDNeJDhiv8uc
19625	payment	2132	2132	1874	1	1	14	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqf2bvyEDu21dv1mx6yxVexzdPXnwaEgAPGdD4Xw4pxsjLx1R
19634	payment	1397	1397	1678	1	1	8893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbs7eHHgdj6pGktLbozt3hBMcaoSV2zrDUmadnJzXKByg6Sgs
19635	payment	2134	2134	1874	1	1	40	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPzYAWBigkJ3k264Ldcd7dVBtA6YpqmJZiue5LGgNa711cufg
19588	payment	1397	1397	1678	1	1	8879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCP1z2tgGgdwVS2a8W6B4dGpTZK2M4DYj95NVsdc7nAcyEbZW
19589	payment	2133	2133	1874	1	1	53	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJNyZTe9Yp8dBGJkLEDXjjbG6aT3TSvNZNP9LciEKjGapFG9R
19590	payment	2134	2134	1874	1	1	26	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqL6xQgFrJ6iBzReDQ9N1kHGCBPv6n4UQFAJ9Z3RatgPP6ptE
19615	payment	1397	1397	1678	1	1	8887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSMhnmueiFrRDT8Wuxof3m9s2banDpw4iWvUWgXVq69wzyYKN
19616	payment	2133	2133	1874	1	1	61	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbjjFBMvMbbjh1Pj4PfTJH6mD6B2xLFig7La45vJUfs54JoTK5
19617	payment	2134	2134	1874	1	1	34	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJcY4tU6KTno4hR6PMtcro4s9LELPq3egW9mxRKWi599TMFAs
19618	payment	1397	1397	1678	1	1	8888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjdjtVcXymSZikqrvPhQ6WfQnkwfVvbPS7Td3wZjeH2t5hWao
19619	payment	2134	2134	1874	1	1	35	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvDWg2WusbPVwP8YDwVsdJ9wC7aJeWjnT4Tai973qoaHBkxS9
19620	payment	2133	2133	1874	1	1	62	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ7Ac28qDH7YdvUyCnWxiXfvjkJAnDBNPGD9UrfZQhHCTgdUz
19626	payment	2133	2133	1874	1	1	63	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbNy74DwSYGvadsEKbrPrGyLWZjsLsRf9g39d8jnM82u62dj8
19627	payment	2133	2133	1874	1	1	64	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGVRXi6icN75nhYf1m3wwF1inQUErGoDLebhkoHbhYm6Cpo77T
19631	payment	1397	1397	1678	1	1	8892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mZSXHoqCYjPWBHVwWiaEeAnsRcVFhUCr7z5oX7gQD4WJNARn
19632	payment	2134	2134	1874	1	1	39	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDfgUAssY6Y5vrrVWXWoWrJUwmcfL64ytoLc9G2gBXvaGaxHn
19633	payment	2133	2133	1874	1	1	66	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmS7imFnsX4zKeXQ6EbZFRtv7zSTeUtWgoz69CvDc6nZfy9Rn
19640	payment	1569	1569	485	1	1	2	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtciwTd3To5gh8qHzbZZoCxokxVqtBES2PaZ1SCCwsvX3X37AZ
19641	payment	2134	2134	1874	1	1	41	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TmjVkwP6swb161S6TdRzKk79aMqNumVYTxP8PXJveXzdpu7k
19642	payment	2134	2134	1874	1	1	42	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9TWck8Ee9zcCjkW1T42Mw377Fv3jkAGFA1U6aag1xG7KuGVB
19668	payment	1397	1397	1678	1	1	8903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Kt1N6tMPWVVt5WdZQkMcCK6QZoiLWsMSF5yFaVfnhXuoFkUY
19669	payment	2133	2133	1874	1	1	77	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dWD7fiqtNedUx1wY2yXGqmbcwhiDD5KARPBo57vvshWzY8Gp
19670	payment	2134	2134	1874	1	1	50	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWFy82Pb9K46KbYSGq1XmfK8ENxwbi3hFC4LJQjN9maVe68rK
19671	payment	2132	2132	1874	1	1	18	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKpsYRF9Szzyfssx4J3YQLEuZBsZoADa1kE5LRLRDmkbHAEVz
19682	payment	1397	1397	1678	1	1	8907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9mbc7rDVHVwoEbCwthJyyg8Vf43UwNSKXmCidfMBp5Hog1c8
19683	payment	2134	2134	1874	1	1	54	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDsRjEzuE5PEwru3RtXgbyMfWji8oXJi1PtNqh3s9qLxEBfjPT
19684	payment	2133	2133	1874	1	1	81	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUH5srPJ4aDJUr1vEJ3RP79dtyuvw1agLXqEdtECXooVang25J
19698	payment	1397	1397	1678	1	1	8912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGra8f1CqQ3XPxxR4hKtbForFF2nfrJ8z7BCEtiD4KMT2WX7EQ
19699	payment	2133	2133	1874	1	1	86	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fFCa4XmLvJ6iZVuVoyHkGHzACt52pFKt2qisyYwovivxEh9v
19700	payment	2134	2134	1874	1	1	59	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bBfK9FNFXMxzScR6GrMxQeRLT6edDyx9z1Xvf6mpHfT89P4w
19708	payment	1397	1397	1678	1	1	8915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHt3ZMRufg7MZfKyhSREGSanbhhFE4ky6LnkbFZGfCjtwtmQgM
19709	payment	1397	1397	1678	1	1	8916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ku1Gs3wNh12mt1fYw7r1WDJkqQpSdMJYTWgciEEb5sSqeuhM
19710	payment	2133	2133	1874	1	1	89	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqAvVq6gCQR9tsAvmrb9nA2F5GbBd2SJptDJktkaRq5Xuz34m
19711	payment	2133	2133	1874	1	1	90	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TgerJyE7MYrEyGcg7HAvhSjRqjYAhrVbYzsXzuwyNWyUgk5Y
19712	payment	2132	2132	1874	1	1	22	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfVNRn8PvBZPoeRkFFeTj5SBYpejAFNRkfDFbXsTgCg8J7RqD
19713	payment	129	129	2136	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7W6mGdhGyTFFTebJY2Roxry6SzAzt3k2nMvj3r1VmNrPrkBV
19714	payment	2134	2134	1874	1	1	62	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTaEKECu4h1fw8cHq1WDtLRtLFeCX6c6T2gkvmaZJSSGgV1P4
19715	payment	2134	2134	1874	1	1	63	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQNfjggmHUTudSunju9AsThjH8FG4eSwqbhL6XXmsxVDYcMEY
19736	payment	1397	1397	1678	1	1	8923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucPP82JJMMWv5H3QCwz8bJUthycKPe5v3sJAHSvELLvZq31Sk
19737	payment	1397	1397	1678	1	1	8924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmhjRc5ThTFTxL7MRKW3j7DhZ2JHZRfBW8VcTsiJHjftpysLz9
19738	payment	2134	2134	1874	1	1	70	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvPUSxiyXtTfqGeFDcKwfxwxHkqxFsdUf7nhmWdVCMTgHz3L2k
19636	payment	2132	2132	1874	1	1	15	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqismKAiwcBpYkaUrXNeKChCYxUvkg7UrNWMrioNR3of8MVrj
19637	payment	2133	2133	1874	1	1	67	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtgs2piXrf54X6yjQ9dFKPzAcHvtdU4ZboZB5AXGiQjj55GBA
19649	payment	1397	1397	1678	1	1	8897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWSRXE81xu7aBQDSiugvzHYEMjtTdAWdurGe51jtGAgUtepob
19650	payment	2133	2133	1874	1	1	71	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ838tKWdjuRJo1b3R9WaBvY9F3DjvoLyckzCkzWzGJEqdCsrjW
19651	payment	2134	2134	1874	1	1	44	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvzJiD2XhUBzbSJYhqwh7avFghS9PUFKd5PH1eFkEqhjWxNYD
19655	payment	1397	1397	1678	1	1	8899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6uRbSjiRG3YSjukQGbJ7LbRmzva2TybfA9qMqzJ7vKE6pbFw
19656	payment	1397	1397	1678	1	1	8900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3v393NpeRVinJfGGLHrGhaov8e1pubQPmKKnfTgJdLkL8w2XS
19657	payment	1397	1397	1678	1	1	8901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLr9XwnNYingjNWohoc5LShZjChv5bRskm4W7RTq833AJ4B8q
19658	payment	2132	2132	1874	1	1	17	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvY18X8RBTnEeTECxDBzo5Vz8tnTUUVqqwYKegeQBRuoYBeX7j
19659	payment	2133	2133	1874	1	1	73	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy48GtLwMBc4JXrw9D8xZExwFb2rbRRVqNiGfTLYEZJkyrGcRH
19660	payment	2133	2133	1874	1	1	74	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sHJz3CXB1o6NhDyPWY7PPuVzpoDfDDysNSW8tTuRhqp7ngFv
19661	payment	2133	2133	1874	1	1	75	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWkP7C3brZSyj1N7BRiiqbjvCLqy1oA3qs9E9WomT8CYZbb6a
19662	payment	2134	2134	1874	1	1	46	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCiuinUyiiRU6VoXzu6xfLJT8LgnH7s9GgqwE1mbMF2rrhYiHy
19663	payment	2134	2134	1874	1	1	47	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnMRT1wqiAPDpZZnVKmiAxNBcq2sKfiajxEmgW9NyUMcRTabT
19664	payment	2134	2134	1874	1	1	48	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoaK6A5vdm6bGWw4E7ngzQM8Sg79BJKwECuisRq9ujJ8QDsAh
19665	payment	1397	1397	1678	1	1	8902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYgrV8JhfReHhyDb1cHbkHgsDsYr4HoVwKzHMG1FsY4PszBCb
19666	payment	2133	2133	1874	1	1	76	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjX26TGdcqCCiogahFgBAf766MRYa1q5ZHzM3gG3UYXrpciW5j
19667	payment	2134	2134	1874	1	1	49	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPSW1HPwSsoJnxtGYAnjnuM4G38gyv6yStnaEtVynpMBuMBF2
19691	payment	1397	1397	1678	1	1	8910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREUNhMgqijvnLxb6tCaRsAzxFoR1G3YTwsMk8e5s94pxNCQBi
19692	payment	2134	2134	1874	1	1	57	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhxvEX2c1mDmQAEsWRZzgCmheRDnJWu821HhUztj2BU85HX6X
19693	payment	2133	2133	1874	1	1	84	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFMcAKVoc4umXFsWspNjnX8TPkiNMqbEJUfiLTwfChCAxfjhh
19694	payment	2132	2132	1874	1	1	20	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtbstUtD138YBpZdZ9e1yx8eMWDoDz5nUbLojaisN26gzX2MJ
19701	payment	1397	1397	1678	1	1	8913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEdp7sMSmG43uA611h7QrhoLs2Yk4c7LwEPdfNA5hbQ3shGAa
19702	payment	1397	1397	1678	1	1	8914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhaBzRJr3U3n6MiusPFBP7cQ711T2ABrVSAmKqsjAmsAMSFbG
19703	payment	2132	2132	1874	1	1	21	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshKLCBH2XHSU9opF8Vj8n2y6LR5qYMqhxct2MjWNaCUtMD3wn
19704	payment	2133	2133	1874	1	1	87	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtt1g7wfyP7GQdXMve7ndvZAzKHq3D86zE2G5Hv1KNrjUdZV57
19705	payment	2134	2134	1874	1	1	60	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uQAXs4pqVuWHQUVR9WfM4VwXaaozgZQv33FJm1SB2pH9b32T
19706	payment	2134	2134	1874	1	1	61	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKxX1SL1hAF8eAq6sqCemzWDZS35czmGdaGMevgyHnoL5DwkB
19707	payment	2133	2133	1874	1	1	88	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBtiEc25cXrnwubYhSc3Uq6U45gv5P6nP2HbdgTymqTTcgdhC1
19719	payment	1397	1397	1678	1	1	8918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeggyUhHrBoUfTnXMGH7A5ANZP5B9bNeKH7KN5h8RTtHKMMHdM
19720	payment	2133	2133	1874	1	1	92	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfQ3yRexwjnfHHroZwRMcQhiQVaAv3sucoa8pQKk7BVMeZtxT
19721	payment	2134	2134	1874	1	1	65	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SUGajK4Pfhe8TTj8JFjrtewPdaEjPfHkeZeHNgXgKsk4nZuS
19743	payment	1397	1397	1678	1	1	8925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZwyBo8gCQyWpLJ4w2NGFADBhzGRgHosvP3HBddzD62bUk3Ng
19744	payment	2133	2133	1874	1	1	98	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskugjHdQwk4GPFpj8Kvt13SQDTYTDte4GMH5yuWpWgi58rJxj
19745	payment	2134	2134	1874	1	1	72	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaSmkv4JfRGEUAzgFNgNv4C7k1ytHphYCBmSAJMsQ9q7ZPycU
19746	payment	1397	1397	1678	1	1	8926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrfdXkK1Cw1YcXpsnQoP3y42YQMUYvsvMqCpWLiL5fig2U2Xf
19747	payment	2134	2134	1874	1	1	73	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxeXhovZ7G4LBx4UeUjWAHYqizHftXcaAKGVam8HuVWRuFbk2
19748	payment	2133	2133	1874	1	1	99	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHqL6yfdq6ZFe4dVagH4mSqiLu7zvS6WsrA3tVCVkca4wkg5iz
19678	payment	2133	2133	1874	1	1	80	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKm3EGN81FJsNMVdWuCCBXKgz4Sv5sXQxTuSNTmRLoEUtAsrx
19679	payment	2134	2134	1874	1	1	51	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEW78pDwyrEVdbjqAenBQMS7GnaRJeRzjyPaPWXwPCaRapoa4
19680	payment	2134	2134	1874	1	1	52	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKXAk2UYpQi1fbAbmeDs1kS6dYgf6zrqdyBg6gJbTibDRhNCY
19681	payment	2134	2134	1874	1	1	53	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEASx7twzt75CH5cdXNGn6rFna8rt6Q5Zzb18UL3DozXBvwhmT
19688	payment	1397	1397	1678	1	1	8909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcerkMEK4BErYW583rN7tQYP6r3DNmhaTqxNCZRb2i3Nzirh2Y
19689	payment	2134	2134	1874	1	1	56	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMStamm1AVepgzDaHmRW4Efc5Lee6G3UqqtccaCQkcREzdCrYA
19690	payment	2133	2133	1874	1	1	83	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6Qc2WbAsmkDEj5QycAHrmDkNK6aLAyodkbsdmq3SqzKz5QMS
19716	payment	1397	1397	1678	1	1	8917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuS1nohEQrFrrHdQp9ZZCUAb1CugfRHN4XRjAXKURErbDT4TD
19717	payment	2134	2134	1874	1	1	64	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdnR16pFTWqwtKrMjzMr3zwdPPbbJHsFMfWZbG7ZpCPDuxGm6
19718	payment	2133	2133	1874	1	1	91	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBH2ZrmqJkxLbpfk9voFdWb5GQT7w6KaAsTWZYW9hKfRGTGC9i
19722	payment	1397	1397	1678	1	1	8919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQEbRHBQQ9Vx1iLb3StLA5QDsVWbm6Z6DqohKNr9a8hQA5J48
19723	payment	1397	1397	1678	1	1	8920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sDPV7c3r3zHkB7dLXYEmti5a6EMSy9mJK7bSMXiAGLCgARkX
19724	payment	1397	1397	1678	1	1	8921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiCM83Dm3J2xGwAxMgzrDTtTYDZHvetZRRpMgrHfdR6EW9dBt
19725	payment	2132	2132	1874	1	1	23	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMtkMqXjj4SbK7r3QfsPXHVuAD14mZuZ6EHMpYaoHNWzUgNVu
19726	payment	129	129	2136	1	1	1	444000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfphVu4KaooarEJL8jSkQoCrcVFN3JFJ1xgvXJYz7CmsAzvrHP
19727	payment	2134	2134	1874	1	1	66	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtNkxnU9G3YsCgMhru7SyMoiXxcSJuugzejfUqn5CUqQuyuHS
19728	payment	2133	2133	1874	1	1	93	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoW3b96rqZCm5b1q56635o863RW87Lr3oJ3rmv71JqnNfYBpGt
19729	payment	2133	2133	1874	1	1	94	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gHs9w9LZDUA2kmXwB66SbdPLUNC2muQMowSLQwy8bWz1Uthb
19730	payment	2133	2133	1874	1	1	95	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLYiXuGjVVW3Xnxj177E1ijRyd9EMyg9NkNtHMUvtYBJkso2B
19731	payment	2134	2134	1874	1	1	67	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9quUaBfToThprzrUWpsj3CMrK2ea6L5CfaHTtK6a1yyBCZtjW
19732	payment	2134	2134	1874	1	1	68	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUA9pv4K3iFVmTbyauzYizR6qVSk6iFo89TegLT79Fykj9mx3N
19733	payment	365	365	2137	1	1	0	100000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxDAziwqMsjjfo2HT3NrBmtt1LVuyEpCbhNzCphYgaWQydqSP
19734	payment	1397	1397	1678	1	1	8922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdbJgvaJoFEqdSq27SrDYdcZTEomwgkQBzDLHjmGkonLC68Hb
19735	payment	2134	2134	1874	1	1	69	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaJpF3frw65ugx4uwMqqV6ev7z2E4zMdAH7t2dF4XmScgWXiY
19771	payment	1397	1397	1678	1	1	8933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LbizW47aWf4grHcGcsnoeuxQGnKmibvci26AYSMg3GdmQDwR
19772	payment	1397	1397	1678	1	1	8934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLvgESTQAqasbKh169J5HhKVowee3yFRWPQgBJNyHCKN2YAzH
19773	payment	2132	2132	1874	1	1	27	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfox1btEKPEhnCa5Sewa9zf9SYvDzedBxsR715765eveZfVdj
19774	payment	2134	2134	1874	1	1	80	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8KsKz7tbgfcKzGkoEJZkueU1r2kw53KjqcHhdirSHLtk8o5i
19775	payment	2134	2134	1874	1	1	81	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VFnpBq9qsRWjNMjJLXQKAHUfwcyBusW3rFNRzgswxRcT4XRc
19776	payment	2133	2133	1874	1	1	106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cauehu1yCHJSeWsWWrNvH6fdgmHnvjYnTJ4LXLPHNEnGt81v
19777	payment	2133	2133	1874	1	1	107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmuUZSEGLt7tGuxeLZJzAhwQN2UGX6qWxW4UvYQfMRXgqQEHk
19786	payment	1397	1397	1678	1	1	8937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWGyBrLXZQYUaUgVEcY4CUY85Ro2eG63ooKjFDLZ7X5QKJcLi
19787	payment	1397	1397	1678	1	1	8938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HdctW14q84MUHWem7ketadrpNAkyyUuQ5gLuhTjvr7R5nJZE
19788	payment	2134	2134	1874	1	1	84	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipHRVcYHrD2dTX8uvLMBPSwghYyArAfQbM7B4LTL4YoSoEVG7
19789	payment	2134	2134	1874	1	1	85	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfAYQr6gYHSaRN7bhPJBjG4aVYvjYpN1KbeJLGDT5WzVe3KpS
19790	payment	2133	2133	1874	1	1	111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7RhTfvpmkrn4GrJh1rEJyo6ctvgUoFQNboNfGSMHPj84CwNe
19810	payment	1397	1397	1678	1	1	8945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVAjUNWAAeiRN3bTjh9jb4iRTWSyDDuc6QuYG1CvirBvSy5Xj
19811	payment	2134	2134	1874	1	1	91	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRAV6tLPvxJSj9oPMg6JNjT3vUZJjGAJa8YupyXh4birUzt5L
19739	payment	2133	2133	1874	1	1	96	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkr6maS6Cby2gBQjxGL7gq9iUKQFtZuNRYdYZMHCoLxooJCwk
19740	payment	2134	2134	1874	1	1	71	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfcrJ6Lj9r6GGQPYyRoT5VsPeTE2hdiGKZbhfRAS1zMYXqx9Ln
19741	payment	2133	2133	1874	1	1	97	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXya8vr325w4T6ABhj68GBtRDowLaQKR5gej78BPwqmN7DvZt
19742	payment	2132	2132	1874	1	1	24	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9p5ANjtTCwFNPktezcZX7Dp8qkc7S78c3x3uj88YBBjSFUNfD
19750	payment	1474	1474	688	1	1	13	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbmwuZCz5wJ5z2CPTdUVnJa3euMDcvdo4uGATqnq6iAq1S5mk
19757	delegation	688	688	1474	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLJQ8AK3MVze7VbzsoQXWagLjTnSLqLnyGYbT2AvBJVAT3qLL
19758	payment	1397	1397	1678	1	1	8929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSZa9KKutSimkeCt1cN5M7gVAnSUkFu4ge3xEUTVy3wXazGUqB
19759	payment	1397	1397	1678	1	1	8930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7LG5Ft8Z4FxgrehVo67Mk9JnTYE1nSZoHnY7vY6yAFxxDnS7
19760	payment	1397	1397	1678	1	1	8931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcsfbBatkwdSbXsBLUPtzo1Cw4KykPvzcAS8VH6XyTDXngzBN
19761	payment	1397	1397	1678	1	1	8932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EH2FAEH1uMdAhSBuzXTLez3XYdaLYwUvSPJNYyNpBpRLRgHN
19762	payment	2132	2132	1874	1	1	26	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8A8boZ7Gq7YDdPJwGrMWktGh7mwEC36Xnm9AW2YDB3Vpr4Jxi
19763	payment	2134	2134	1874	1	1	76	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEUeB9Dj8hcd7CMkStDTyrBJxJnwRSdZSiRp1YoLgmchSxQLx
19764	payment	2133	2133	1874	1	1	102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoc3LcVspLjMjiBg6B8TpqUoHMUZL9MJN57nqZG9iMbkP9zFgE
19765	payment	2133	2133	1874	1	1	103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3RwAisJ8utaY4T2zxXQfYtbp8fahSaJpj5bsweEyyNw4uJN8
19766	payment	2133	2133	1874	1	1	104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixq7VgxK3KbaSvj6ddEqyWAk6hUeADKHGUYJQwru8Kix2v7dv
19767	payment	2133	2133	1874	1	1	105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8NHTu4hS3QqFAdfvFRPtXECYYZn6C5KvwM3JpPvGM2LqHspT
19768	payment	2134	2134	1874	1	1	77	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzMD48sq7Sk2vPgCV5LoKe42okUPVYXNe2mGu9p45ZBw5gReH
19769	payment	2134	2134	1874	1	1	78	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7QQtDD3J2Uw7Zonyn5n7iPS1mg8kWzGH1KqpevY7iAFoqVj4
19770	payment	2134	2134	1874	1	1	79	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDZC52u5Bs4Z4SXokw7GCLE2BSyjnxGLhpi1iqAHmLTq9LLhJ
19785	payment	2133	2133	1874	1	1	110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TvyTafgjtjWbiA4miJsP4LnYJTdVnskCYagSqXK3uvHMPhmP
19798	payment	1397	1397	1678	1	1	8941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5oL3KBmnKB8wB1KQNhsjcEUubBPykFmS1CosG9UX6Gw4NUkS
19799	payment	1397	1397	1678	1	1	8942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vJwHYqYJZbAey6aXx6k5NX6gYrhA5aEsutkMn9VyVhWJi77M
19800	payment	1397	1397	1678	1	1	8943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSo99DMhR3PhqxEDNNSxcCDHFD4LwnxNZzbTLmVo3ACBsR59TR
19801	payment	2133	2133	1874	1	1	114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1qx9xEPL2FkGbCzBtwPzbGh2gteoBJ2vAMeMTbGYUA2Vgtud
19802	payment	2132	2132	1874	1	1	30	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2iXABa7j7pxRx5pDaQGoVMeRzv8x8YS3dnW71xiEmS7M142M
19803	payment	2134	2134	1874	1	1	88	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnkdf4AkQ9qCWfXxgMWZxpncMDnydpDHCWVeafrZi8KGWCnjq5
19804	payment	2134	2134	1874	1	1	89	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk2PsiUPpfgnqtZAjKjULqwnMGLxo9yrhfHbkzVoYuLiCeaif
19805	payment	2133	2133	1874	1	1	115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVQLxUe4xE163fBTPbDpxxCDo1nNHiHCBqbowXww8bZXtP5BP
19806	payment	2133	2133	1874	1	1	116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vaPZX3mCpTrW53w6NBpoNtgYR518b1QTNRiHQm1NkXCeSsSi
19817	delegation	1697	1697	1504	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsT4F9Ch3e3NuFfWQnLumsZjHgJbJAYLYBdw6GYEmNgxKFwPR
19818	payment	1397	1397	1678	1	1	8947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9Ns8VpwKra1D2eeM6B4NnbrsCPcimM2SR1vGAD8jgKYLQPu1
19819	payment	1397	1397	1678	1	1	8948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Vo5P7zRoHdfnMBQswqTXGfEHsWUozRZqvQ9Un5yRdZJjHCgK
19820	payment	2133	2133	1874	1	1	120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpN9ogYH6sAaTDWAi5GdGDrE4a5q2qcRJajnqVzD9QWu696xi5
19821	payment	2133	2133	1874	1	1	121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8gV6gxu48gaypgiMZtWTNBMb7DRM1gCSJn81bfP8zrD3gAXt
19822	payment	2134	2134	1874	1	1	93	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8DtUXpKdWQFVMNSJDwPwQGNj58ueSwHAoRvwVCRtWPEEksYW
19823	payment	2134	2134	1874	1	1	94	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvM8nf2aKK1QqUXUF51sMJnKXLXzvJ4rDqBhhgBtJk9TwEY8Aj
19832	payment	1397	1397	1678	1	1	8951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCTUVaiyCEA2fBq1KuchTzZNyT7fDGZ8ZMdxAcHQG2G3hdAbo
19833	payment	2134	2134	1874	1	1	97	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDmstef7EdrvqjvWzJTuURvAwNn67ancxyygs15RZW7k94J8t
19749	payment	2132	2132	1874	1	1	25	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1suqGEzenbVmpADL87bUH91wfaDxpsbCYmXzjVSzm5MPopiD
19813	payment	1397	1397	1678	1	1	8946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXo9Ccy7eKKxuwMeXUNc3aKqYbAnkJqVqrRQRWULG9mtp9nVG8
19814	payment	2132	2132	1874	1	1	31	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fKRTfU2VpKpq2uoSnhQGhQtNy3RRstPRa9u1ArrzdTgQnrFg
19815	payment	2134	2134	1874	1	1	92	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyefe9diFJMRpxVRSDGiSydEMY5mZaxmCJqZiDCKZBjiML8oi5
19816	payment	2133	2133	1874	1	1	119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGK8C4EyofKWSDnHGo9rmRNVUGwnahHJWhpMvrmyFb45pRtHsn
19827	payment	1397	1397	1678	1	1	8950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPAUQ22S4u8hWp4Pf67nRFRUZnd3FNVd59QujsrqV3gGwCdva
19828	payment	1504	1504	1697	1	1	7	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5quiQ7SjQmfbakwKPCqF53m8BY7Cs84dcyX6iZKxisW44z7Kz
19829	payment	2133	2133	1874	1	1	123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ619c52PTvheeCk5ipeQDo76XmVDmMKgMNyXRajysTb7j27JLZ
19830	payment	2132	2132	1874	1	1	32	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxqLretJum7MQUfkCSdK32hBHXFqV8CtNvvizyFdygnPTjQ7G
19831	payment	2134	2134	1874	1	1	96	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtd1kNZxBLf73YAuWQr3FiUBtNLMNLmoeREfv9ynQtFzk59kYT
19853	payment	1397	1397	1678	1	1	8957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAUaA62RjyVh6g6QeR9G2zzcdaRmmpfP9p6kodPb2EaVRi8xp3
19854	payment	2134	2134	1874	1	1	103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjLrMUevsmzapGFZ2qEVmaj3H2msZ1vPrgZP8qwDLsc2cduH2
19855	payment	2133	2133	1874	1	1	130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgC3SHRRNLyj34iGTZZrisikvQMxNUo1FGtMZoiDFYSZN6mRy
19856	payment	1397	1397	1678	1	1	8958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5b9i4XkncEkJW4kjMPx499EDkng7euqCHRh8sWpuc7yHeoTSv
19866	payment	1397	1397	1678	1	1	8961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnirDsf55qBverjWCW6rtiAenQZBEU5H9Xdq3zpuEXBEAGnhoU
19867	payment	1397	1397	1678	1	1	8962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdB6NoZpMxjYXvnvE9psUnnbDwtV1SHGKqdMk6jgav3taA6xCp
19868	payment	2134	2134	1874	1	1	107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVEVMeqmirQT5Bu2iYQg1Q77ZKZ8T43bJeZashkPRU9MSxLid
19869	payment	2134	2134	1874	1	1	108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWrAGpMyve8tdzdGKwsQ8etUzovS5cBXS8KhwFnGmVJEbzfY9
19870	payment	2133	2133	1874	1	1	134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXK6baPKEEktZuLHzscAcAUpXnu9feUmznuE6LHadxmtbVhYD
19871	payment	2133	2133	1874	1	1	135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HYwcH1PDgJSPpjMj52CXrVf3YAqhWYQb8b9bsA6TmuC2o3Qn
19892	payment	1397	1397	1678	1	1	8969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzV83h8PcwaLPRx114SCsapZH7WHLhxcWEj8kiNy8ome7HZH8z
19893	payment	2133	2133	1874	1	1	142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUBHsuSLd2REeH5zWiDcJgqSxPbMu3wyCs2b9kbyXZmnFirgG
19894	payment	2134	2134	1874	1	1	115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaR3oCYFUvriUswYku2okdBXMjFQWuLxKU8LfAXE5fBsaTfy1p
19909	payment	1397	1397	1678	1	1	8974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FabXYYwAQCdzPPDD9yF2r7jAUJHPgiYVVZ3pofaAGK2WD8W8
19910	payment	1397	1397	1678	1	1	8975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonpwJjSmUaH8zffHKdXzzMsZumDndJkPvkU8WoBN8cZFPKf4z
19911	payment	1397	1397	1678	1	1	8976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSYm2PYPhhy21SxQF2gtVJRtfnDLa8ZTV7iZNKzdUPsv3khDc
19912	payment	1397	1397	1678	1	1	8977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVA3SDyvgDSNLyffVenXjyCTV6Nmrfb1Xeg4qAE89mkTBuqBXd
19913	payment	1397	1397	1678	1	1	8978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjo6dKyc3QUbCr4PkojE5gfv9bH66JHbCfEohesdcccRcSQAUs
19914	payment	2132	2132	1874	1	1	40	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTsDyr1E4V4SbD9KYujeA2xKfsPdZ5pwjesUovL861H5Xe5xvf
19915	payment	2134	2134	1874	1	1	120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyASnfPtdkxeMVvxWnvgYFhw5HL5cHRAmURG64ncqCJYXr874
19916	payment	2133	2133	1874	1	1	147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMbDZwdY95ss1UvxENKcTx5ToPx8xDZe2vT6QBC5GPbBRpE2c
19917	payment	2133	2133	1874	1	1	148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhomT9f7voquHrFsGfNFfBnXqRQSqUphtZemGCMhW3VT1Sqgvf
19918	payment	2133	2133	1874	1	1	149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJWe4i1fymJDm1LLTdyJpp83eLzA2tXVbaoPDhcY8TUGpRmTZ
19919	payment	2133	2133	1874	1	1	150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZi5apgqJQhysFiiYQHKazbR6PmdKxr2YyoRqmCm9XVcGi9F3W
19920	payment	2133	2133	1874	1	1	151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXQKUW1sFxsgyUr5RfB2FTdoFcdr91Y467YWz4SUSSLAyv5yp
19921	payment	2134	2134	1874	1	1	121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVNCQwQPyPygZtU4CLwG4SqDvMM9x9Gmr5eUGEbVMgewRaVCY
19922	payment	2134	2134	1874	1	1	122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF9HZJLXbuDqzpLFs98MihEGQTyftVg3Uqcmsu73bMshQ3esA
19923	payment	2134	2134	1874	1	1	123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57K4jVhD4eyAT456368d2WvKe7hhP1E4S3EQkVcH7uuFfgnGk
19752	payment	1397	1397	1678	1	1	8928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBqigBwufJVRW65e2bCzKfiUo6ihuTvbP4aNjTGYh2YhQt7iP
19753	payment	2133	2133	1874	1	1	100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwBrFeBEGwLnPHGDxovhBrqU96siPABb9MhL6mvkdgmcUvEdn
19754	payment	2133	2133	1874	1	1	101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiQskk9Xi6yyNkMXcyiy8wTzPm6bnC1MwkHURVfGMsbxzwfCV
19755	payment	2134	2134	1874	1	1	74	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAwftkubqFBpKb9ao7r9QjsU6ga1JMiA9ytf7cLtME78Zv5HB
19756	payment	2134	2134	1874	1	1	75	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Cyq4t8gzbF6a5ni8yK3ys3bqYZSJiUqDSfSFn1MMZrASTcKt
19778	payment	1397	1397	1678	1	1	8935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhCh1SzdoRp39tBoCnVWbDgvmfrpyAwP2HCUNHhbXRqXFNDuK
19779	payment	1397	1397	1678	1	1	8936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeH1P715N6DKhys12iYaDjUQWCmyuF1K1vHwBE38jVirrqQWRc
19780	payment	2134	2134	1874	1	1	82	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZudv3dCKM4dhdHVECwTQWpiikFY5NcHCKxBo9PQXU1sBNwBp
19781	payment	2134	2134	1874	1	1	83	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdME9PZsVunEnqcnAxskjzUKztSUvUgfNAqbCWbqYuYqRE2qtb
19782	payment	2132	2132	1874	1	1	28	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KpVcrgZ6EGaozGpFgPf1Bg3juizwwB8trs2HmtEMNddWt2ja
19783	payment	2133	2133	1874	1	1	108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxmjCWSEefhu25V8miHPbftFP4RfmUP3GJUVChPsdwf5YCGgE
19784	payment	2133	2133	1874	1	1	109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyXKCBpmSyX1Y6wQvJYQLHg27xz2AMxqNnjoGRcxbLn2SCfog
19791	payment	1397	1397	1678	1	1	8939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6hefC5eDroF7WwjLnNBNVwc9cxesRkzMbjEhxJhSJfRK4mzU
19792	payment	2134	2134	1874	1	1	86	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUEbrMpMZ6xaxvX7iyzYyjWGr1885B5vTTocpyER1nUekE6nB
19793	payment	2133	2133	1874	1	1	112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukmtKfoVY7nUnuSDV2nouaSMmuZ7rcJfE1dEVaKwe3Sb4v8QC
19794	payment	1397	1397	1678	1	1	8940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsDpHSLSsVr1UrcCtgHAiS6EDWKEyvL6pVyaargeYQrTmKQNM
19795	payment	2134	2134	1874	1	1	87	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfyK5JuiDpmoKASbQKCGoj5bQb2YCzJdDgukXcdTtBhCZeHCE
19796	payment	2133	2133	1874	1	1	113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKntKjKahFYHPDzXxa5AnR9vQLB88xZWcrjz5dqfEcTS7WfSxt
19797	payment	2132	2132	1874	1	1	29	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH996tZC3ut26c9gKvShsoUF3piriin2cj2qLRDW6vfEdNsr9r
19807	payment	1397	1397	1678	1	1	8944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvYCZxd5Hj8P4g2k8cxM7WuYMxZTu8HuaMFHgYo8nwvM6qwKT
19808	payment	2133	2133	1874	1	1	117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcKJUfSDuaMHiA76KNfpgVLBPinWtxpczatMcbTQFbYiCy9w2n
19809	payment	2134	2134	1874	1	1	90	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURGeigFyZQ8Awv71uZ37ynMMGwc5jNLH2kie83DKcaaGZc7iZ
19848	payment	2133	2133	1874	1	1	125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GXJ59SFzCigoZ65myp1AWrPwYw8WDyZdBpz17gUsqunxC9Bb
19849	payment	2133	2133	1874	1	1	126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59NgRaZEd1kHLxFK7XQoBCugJMHVxpprqkeAiU4jx4a4oRxdw
19850	payment	2133	2133	1874	1	1	127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT8LRRAzBv51EtkUymBRG4yds9dRTV5feb7xSteGFpY6cREED
19851	payment	2133	2133	1874	1	1	128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQap66J6XZytq2jGNJTypggdmu8Jio9WZnBVv1ytyhDm2kN1dy
19852	payment	2133	2133	1874	1	1	129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZvFk5enWP2mbxfEZiq7KcsEDEhtdYtAJCbupbx7euocWcZBC
19859	payment	1397	1397	1678	1	1	8959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnz68tU9yj1ebpAjC8Fdq3bwpjNf4TF6QryQjEoPXtXoFxq6Ef
19860	payment	2134	2134	1874	1	1	105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrjRb1mJVriz7i6Z1tNoVdz2edUyJUo5FcNU8FXLak3TwMvxuY
19861	payment	2133	2133	1874	1	1	132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41Nh2k6gogtJCYMoVFJuVCEFzNpMuzm8KDcyTCsDvut3zZY9U
19862	payment	1397	1397	1678	1	1	8960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtWunG5Tx2YVvyU3TBqShKUCN7zHpAXunPwx6w7DWRMYwZK34
19863	payment	2134	2134	1874	1	1	106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp29wbvi2Ldd5Vr1Tt978ELX57CsYXMd5AZhET7K6RvJSnQJq3
19864	payment	2132	2132	1874	1	1	35	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ag5SKvviMehptET2utqAmN8PiUyqU4EY7oHzdS1VPwEscwKp
19865	payment	2133	2133	1874	1	1	133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAqKeLJUf5cyR3NVKgbjxDL4RDZ9NsFMTvcDBKeSK5a22bCet
19882	payment	1397	1397	1678	1	1	8966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciuS5zKVkC3ZfqSSDuNfc9138WWppGkon6VPrWCHt8YJhhdVq
19883	payment	1397	1397	1678	1	1	8967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfiM9iRcTtUGP99YNK54xaTkiE1cR8wvgDFce8vrPRSJ56GD8
19884	payment	2132	2132	1874	1	1	37	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHNvNyEfQFEq4nKtFDVCPimvkFMCaUrKi5BCs3UfTB6LFzGbA
19885	payment	2134	2134	1874	1	1	112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NCBb2vRXfjaPSMUYc2TncbNTG5Q7rvEautDeM7pw5rqAv4bA
19812	payment	2133	2133	1874	1	1	118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Qa4U3QjyNeEwt25k5Uv5pXujwSZs7xXMbzLPvjDsmZjbBBja
19824	payment	1397	1397	1678	1	1	8949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgufYX9ScPFi1PsezAwfYLNxWXT2u7CNzi5w72mpBRAdeoBhC1
19825	payment	2133	2133	1874	1	1	122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLBWUmuU6zx5xiqAnHXcDtKDidWGoVWA4PNYadPY1SXxQp3px
19826	payment	2134	2134	1874	1	1	95	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNneZKsUiN5JFjnFUCrxZDkHmaRDBE1jFSfVUMasdHnEFQiKYv
19857	payment	2133	2133	1874	1	1	131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrZpRLujKSXLevPP7t1f5sK7ckPrWsbhBpJ4zVfdUJWjQiJ1D
19858	payment	2134	2134	1874	1	1	104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnVDdZUfAFDcji1NXp8saxyoeqnFAAQyykqJhCCkPXDbHMd4r
19876	payment	1397	1397	1678	1	1	8964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRW2w9q13G8m5hJnutaKPSXTgm4may3dT2ZhXx8gw6fnxKBcb
19877	payment	1397	1397	1678	1	1	8965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxf2TihMnwtcJacWjDpfUkNSzY9SNuSubgWX6A5MBu9oZD4gpk
19878	payment	2133	2133	1874	1	1	137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUB2GqUXh7GvNEcg9uHzDKZpskZJmsiMpyq4VuFtqWhCjCYVb
19879	payment	2133	2133	1874	1	1	138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgBLptQNifPJnoNoyEcGYRnF7JBwvEKYYzBpBv5sc7RSKP6G5Z
19880	payment	2134	2134	1874	1	1	110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWQUNhXhvSjX9n6HSHVkdytUbWYq7C1RhQW4qLdtF5ZUwnDs6
19881	payment	2134	2134	1874	1	1	111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoPvo3SXwaKpjpDD86t7aJ5eP5LsEubM5rxWFqA1K1SoVSg19
19895	payment	1397	1397	1678	1	1	8970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCgkgfmokiYUQaHgwcajpWfBpDcFTMGTMnYCi2Ks1pEcQR2pSp
19896	payment	2133	2133	1874	1	1	143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjRFwzpVSXtWU8treFwozybvkC85PrBjxtCypypgRaAmaV1LU2
19897	payment	2132	2132	1874	1	1	38	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6mmyKmkDf37jthb4ehPa9cRHocMBaAkBVh7VPopTCMYKQjCi
19898	payment	2134	2134	1874	1	1	116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fDyprhZuFvqps6ko6kT243WmACUUhUiChCr9USoxwTfJV5Cb
19899	payment	1397	1397	1678	1	1	8971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3rzcnAKekEM8va68NUN8aHEhMTNoruXmSyBqWkoNyGiyiK7c
19900	payment	1397	1397	1678	1	1	8972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuL1NpRyzqNqrsyiunpUquHJbaXrLrH6kaw9xsGRwjm2ZjF73D
19901	payment	2133	2133	1874	1	1	144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bhTLhgJQ6RK51uxZMhunjwKRocfwjn6jPXbagRF6VjwiYc4u
19902	payment	2133	2133	1874	1	1	145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4VWqbnaorSgEnbg9XsnaUrL4rCMjQ7dyk3YWfwSyr5heQ82K
19903	payment	2134	2134	1874	1	1	117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBiWG1cxgjED7GF72WsmLw8bKRdSe6UFEC7P5wqtYmBvQUU9FQ
19904	payment	2134	2134	1874	1	1	118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJTMx6tgXvtGrMMaaMKus5QDHT3WSpCp33G5X8taxSiq3C9b1
19931	payment	1397	1397	1678	1	1	8981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6PVd79gsiwjFKpNtbdbZAuNNWcm7ZdFATA1Pf2rpCKffHHEg
19932	payment	2133	2133	1874	1	1	153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7CBkSneQnLYKtw4EfjHPETBTGNwEq5FrTFrdSyGGt3t2kdn5
19933	payment	2134	2134	1874	1	1	127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAZoLEhedkBXWk68xoJLfHPyWazhtwgzQ1DE3dEqDYJ9ds3sz
19945	payment	1397	1397	1678	1	1	8985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgbn5m7ULwLooyvvPsKicqgMMFMzUKqxuKZsCei35bxGVZ8w64
19946	payment	1677	1677	1395	1	1	1	122852906474000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYmkxtr5vLkYTGoCjKuCWuV9VeabaeNhTftTRthTjHEFBGQHNUj
19947	payment	2133	2133	1874	1	1	157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MHRgT6bzyizZrbCZ9asobFjZoxmTJbRKzgZ2DD7eo3jdzenF
19948	payment	2134	2134	1874	1	1	131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYee9YPAkV4XTUNr12ZjJRVUbyJxHDNGemtF5NvjaU5P7qQESes
19953	payment	1397	1397	1678	1	1	8987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK22qq9zpwimpyQVtYocNXPrHvNt3uuMsF9vmStt3ARTCbf8tk
19954	payment	2133	2133	1874	1	1	159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpYjDvSkVfzeSx9RExjGqaKLEQ8Qftv6Q3zhxibgNhKNZE28Z
19955	payment	2134	2134	1874	1	1	133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi85Htt5FRVT2ZF5JaddL2gVTm98WoRqKJyWxsqsfJApJ9M4f9
20036	payment	1397	1397	1678	1	1	9002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYBJ9XpGVot8hNSpzSQLyn9JVsVNadRJ85ygRtfDHv3PfCwox
20037	payment	1679	1679	879	1	1	38	297667693000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZGRUE9fi2X4hqZoB3Kvo9LTikqYzuJJV2GhBQVKseHvcpieTLe
20038	payment	1679	1679	881	1	1	39	1289893338000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaBN9cCa3W7NiT3RXBXrDPSVYGQDzQRYqaGnVsFr6qk7xnXGr86
20039	payment	1679	1679	883	1	1	40	198445129000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ7aHoJjGGxT4kPmhNEQQ5Lj8idLdQWLqssC6EGkRQvccieheN5
20040	payment	2132	2132	1874	1	1	48	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLMdmfPWmYTt22YhdV49hpmiEwrzePadvDxRCkJGiTjA89KP8
20041	payment	2133	2133	1874	1	1	175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJutcwuNkdi6zACosPvviFw6qRW9ueNHsBKwt7dZY2vZsNmvp
19834	payment	2133	2133	1874	1	1	124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWaSmJtpZ18Ph1QfHkammasBaJuRLJiksNu8NQNBE7Us8YpJV
19835	payment	1397	1397	1678	1	1	8952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYf3yGFsejZ6suCJv2yhs72SuaMjdfJFeMP58rsMVbHihypG4
19836	payment	1397	1397	1678	1	1	8953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkzLaoCq7ceJXxe3MR9TBiA8FNw1Y3HF4a2fVW9PbLDNpnAJ7
19837	payment	1397	1397	1678	1	1	8954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBPWoUiNy9d38TDrspWKVDwK4na1KDFhHKHxdFFd1acksQyHV
19838	payment	1397	1397	1678	1	1	8955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZJpmYPDmBLnaRkT91AXjW48D2DR1uvzivQAxf6jHrT8b3gvZ
19839	payment	2132	2132	1874	1	1	33	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvdphLjNDYJRPW9e74bM5UJeseQFax3FGuuZdfvhSUd6g9WnD
19840	payment	1504	1504	1697	1	1	8	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsKTjnXGzyQHiRskyRTnTMkJWzWEC4FYonBpa2XmDHmmFoeHB
19841	payment	2134	2134	1874	1	1	98	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZ1s8NrsTvUYx9z77qYjdWZfkJjwr2aCzgPnbQgSPTXfo56WS
19842	payment	2134	2134	1874	1	1	99	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5U2kdaTKfaceARX5mQRewsx5Zs2ZCdk6FxkEjpMqWDpeZDAYk
19843	payment	2134	2134	1874	1	1	100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtShdWZCmeCTpG6yTmJHjLWcgTWKpBgEcPHcLhAShQYocQ5f2
19844	payment	2134	2134	1874	1	1	101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKv5N6XWuAJS1S923ceWubd4bxWAJJ2MVa6wUtLM1sAvXV1xhF
19845	payment	1397	1397	1678	1	1	8956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLza8CyZkiV1nZUU2hjvqACTEZ4wGM36djQdQjiJc31DkUM5GK
19846	payment	2134	2134	1874	1	1	102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQwtsqDpnWr428Ardi7CpG2CyTSg2EQc4by5wjotf5iJuMWRv
19847	payment	2132	2132	1874	1	1	34	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YB63BihcYimSKUMoF7bdjdnECTEVSGmHMRjedEuFVQMtE8YP
19872	payment	1397	1397	1678	1	1	8963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhDmUHnPRfQGnyVymh9R847vCQun6jig6r9s66Ej67BEGYB4J
19873	payment	2133	2133	1874	1	1	136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQi2jZZq8zCTRg24EYqRiehdg5WXjkn6FmnZjhnuCesomQ1gGZ
19874	payment	2132	2132	1874	1	1	36	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34HPfEoj98nBDwPWWsitTRSamNPY86M8RsonivxLx5TjZnXRb
19875	payment	2134	2134	1874	1	1	109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxvQMvozqNrmoeoyyvgPETsfUZPDkwNaWYCt7s59BVPsQnA9V
19925	payment	1397	1397	1678	1	1	8979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyS2KcLkxunKuWbuixLUEjjnrhNi7h13xixkbodVDfn1WeD9z
19926	payment	2134	2134	1874	1	1	125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRabk2uCB9rR9RhyDYetY3F9oTwADtm3tWzCxHxa11dntGiAi
19927	payment	2133	2133	1874	1	1	152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdeqZEsJefh3KT39mzZehwpgFah4giCd522miYY6hyQZqMAvM
19928	payment	1397	1397	1678	1	1	8980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGcEvDTKidgJ9rS2gzqWhpFmbDVcH3vm6ANpq65r4FFmDn2xc
19929	payment	2132	2132	1874	1	1	41	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsScN4KLMRfNZxUtm2Hi3X4gTYDkczan8LZYM8YRqYU9hf4hK
19930	payment	2134	2134	1874	1	1	126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRrFxqz5L2pR72mRGUC7qgzMBANQbGit3Mqohv8cvFSqKjEeR
19937	payment	1397	1397	1678	1	1	8983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCX7sKPwuqSCRsxV4YgyVubRf4ASt8aiivRSb4yZRAhym5ftT
19938	payment	2132	2132	1874	1	1	42	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfzzTCheZJBZ27QZfkA7e4Eq6FCFheHz32Xb45crk3jMSbby9
19939	payment	2133	2133	1874	1	1	155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtaf223b61C17dbrTrj7zTdA8RTv2JpAdyY9Ccb2Yuei7WqKn
19940	payment	2134	2134	1874	1	1	128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKND8sYaez6NGhQH12kcuF7xpR6FjnWPEeGAWQBz9tKyiCWMpt
19941	payment	2134	2134	1874	1	1	129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRQyP7kNTcfzVGmTGcwmZQoMbM9BrHApcedw9KhFbn8Jhtakx
19952	payment	2134	2134	1874	1	1	132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFUocX19CB1n32WXQkgi5gAJB13o3HpeKk9Vb7z4LTr6XFGN5
19967	payment	2134	2134	1874	1	1	134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMpSmKHwUcX3Gh49gLEsjQnyAgsBiXG9WF1Rw7mNCg25DUAHh
19968	payment	2134	2134	1874	1	1	135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S7eLp4dehUQ9tAG6y3LF929p397xc7x2X6Td8EdXyiA1D81p
19969	payment	2134	2134	1874	1	1	136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MLC8YA5ScRiWu5oX9PeZiEJvyn4dVDc8DgMtKsN5LwX4VEqz
19989	payment	1688	1688	802	1	1	31	384231596000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfJVrwHjDcMCtzDR4S9oxhf2MJjg279cSbHRimGGKvCcoVQb2L
19990	payment	1688	1688	811	1	1	32	270329721000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa8ZzoPg7Y28hK5zsa8hXriDJZC5wzXxjKjXewTRUgjLaufoyu1
19991	payment	1397	1397	1678	1	1	8994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjrJoKv91hw9LVXqgGKNDR6kQdQrHTH91RUPAJZDvwJEurESL
19992	payment	2134	2134	1874	1	1	140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4vc9D6hpbayxSjHiyKfdCjPAo8N9J54psj366he61TAwfoYL
19993	payment	2133	2133	1874	1	1	166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8N8dabDJFruA75qwWb31Dz34hUoFDDLHuJ15FxqTLTCqWFTi
19886	payment	2134	2134	1874	1	1	113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdmMTAFMGfg2HRPqhKYKDmNMGX1j4Yy2KcEfgXUAXpxnznqWw
19887	payment	1397	1397	1678	1	1	8968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAkbG7YnMV2rj8S5LZ3Ld1SBK1Rqbto4mcmehUgK3ko3Dn1fa
19888	payment	2133	2133	1874	1	1	139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6ZGquf1ahZPEU6Zm3bFKrvJVNixMcYZ4vVh7XL9i2epWUMwf
19889	payment	2133	2133	1874	1	1	140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS54DrTrkNFQmyjjCbjHfmyjKS3PNXDCSVYRtdCAVU6UD6fMZm
19890	payment	2134	2134	1874	1	1	114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTajHy6y2u7EriWg511BmiELNvX5sgWC1aTEHgqw4CvDVkCFA
19891	payment	2133	2133	1874	1	1	141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Xf9xqhbn4vT2GFLk1oUix8vC698zfxWxZXFYobhUC1u1HU7
19905	payment	1397	1397	1678	1	1	8973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ89UcekZivcofyXPqz9aXzQnnMHF2NzByuAA9jcD8QpdGx3Yi
19906	payment	2134	2134	1874	1	1	119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9DwmTRq4FFiJfACVpQEjuoTp5sN7tqZTFaYJ2nQwoiHLNthi
19907	payment	2133	2133	1874	1	1	146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzvmwNKoLVTQHhbubiEh4XzrXTaZ3CE43LMekQG2D7NUZktLp
19908	payment	2132	2132	1874	1	1	39	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JuE2N81zv6RpNcRohVvQd6gvskWPjzp5puEH7bzZ1FzQNyRc
19942	payment	1397	1397	1678	1	1	8984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgx8acvoTiqXkp8ZsxhtqNcc2iw3h5nGKGnS9qwv68PzMFe52r
19943	payment	2133	2133	1874	1	1	156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4ib6ftBjY2518K77FPNN2P5dTHJctzEx7yboET1AiEqRmUp3
19970	payment	1397	1397	1678	1	1	8991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNjb2py8ejRSqAdMCNxvE1npXDdH479qQBriuLc32k3yd76ZW
19971	payment	1397	1397	1678	1	1	8992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohehcmWa5JxRLhpLnd99aasgiRbjKwXVrSQhGd2RNYguWzt7p
19972	payment	1397	1397	1678	1	1	8993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s5AC74HFSTLBmbTC5Fb5HRKLrsAqUo6Gw1vFHT4FYrpAyEZX
19973	payment	1688	1688	780	1	1	22	768389889000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfUwYXfVddP9KULkU4zB87GNLWCCdZVvg8MJpBVRpK8g5stAm5
19974	payment	1688	1688	782	1	1	23	6146994786000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZYgU5HobVgNgQfXJwydG41z1TjnnK15faLox3uajbU5GooQhZx
19975	payment	1688	1688	785	1	1	24	558818195000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ6sG73U1HwTnkeaEhGxZFuengWj4HRyPYLq1ZsbhGTbp8tu1gF
19976	payment	1688	1688	786	1	1	25	6146994786000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZkTbaXAs67qbu6VX5UXBCZ3zPzgsgaBVNY7fhgQMJLCUhnd1TS
19977	payment	1688	1688	791	1	1	26	139707374000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYh1mVBNpGvatQETuAC4Mxq4br9MBuRm6R7Jb6ChJH9181hDDyH
19978	payment	1688	1688	792	1	1	27	1536779778000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaFJRoWJ1yjkM8Ah5GfHrgG6E9mxGwrxGF3RknDXz6uYUeqQtXS
19979	payment	1688	1688	799	1	1	28	34923714000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa3bjzL8TSKPHUJvsHtaXJDUCtHwWCZXUsNx5Q4bLfbMVV8BPUG
19980	payment	1688	1688	800	1	1	29	384160521000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYhmDunp9vy9A7huYvqaVAdbqW8u7NJCk1TsHBYsMZBzGnhw5QY
19981	payment	1688	1688	801	1	1	30	34930175000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZUcQtmHsmBdxxMW1s8Nfb5XDaQJ4PP8TrdrhqoB6EuGQ21sKTv
19982	payment	2133	2133	1874	1	1	163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyimsWW6zf66WGYR2PYzmBgGJXJfsdbJLzatgBBEXs8GAkiW1b
19983	payment	2133	2133	1874	1	1	164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy92oV8F2L31RfXYQ6NsT1Chvg8HUYdSTNL9C8fFRB3EZ76F3A
19984	payment	2134	2134	1874	1	1	137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dc1fHnG1Tt9nbCAYWAC29Add9nwVYQCmjgGrfzWAgpg5hZPg
19985	payment	2134	2134	1874	1	1	138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5EQuQpEyqvbrefyHiJrhK1EBy86S7NDR2X4CoZWwniTAd2H5
19986	payment	2134	2134	1874	1	1	139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSb6XWCY6CcdbvbBhqbrhyR8B8kgSng3ecVLNTHwcqZPY5Tq54
19987	payment	2133	2133	1874	1	1	165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mULTfHpk5ZLAxffYMjwYfxc1dNiug5RbGMc13waoxCJbhcwP
19988	payment	2132	2132	1874	1	1	45	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGW5oVnvVVzhWvHeeHNY8x6MtoWo4sJ12AG3EFWkXhbHBTfmWd
19994	payment	1397	1397	1678	1	1	8995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZU3azw1tecJHVk3MKFc1hNkrz3skW24iEZEDuttXQJsj8ayJC
19995	payment	1397	1397	1678	1	1	8996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSuEjp4mS6A7yHcmhQgrN6yYZ5trSavQ9wPvrFckgjew3m6LD
19996	payment	1397	1397	1678	1	1	8997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTAA5PQSN3kDuLpuUpAKLSyrRtY7MPoecTktqPtQ4LuBuHtJgx
19997	payment	1688	1688	812	1	1	33	2973624334000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZq2rSxvvJBSxzCJfNMAjd9ajySgKB1Fhi1nZZ58WLa67gaqnLt
19998	payment	1688	1688	823	1	1	34	4337850201000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZmc8uZzMZERmbG7WC2v559mvhLZjVxEmEzo1y2N5Eca4z9N9my
19999	payment	1688	1688	824	1	1	35	47716310565000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZTEpexz96hHxqa3a9rfnHjMTzqL2eMD1AeypsHSCwEqQVjz8Ym
20000	payment	2133	2133	1874	1	1	167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEMnjqQMR4HX6wAjJvGCp5tfmCf57vgoK2Avdo92ZiyLD8A48
19924	payment	2134	2134	1874	1	1	124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2xtSPgS5BeqiG58euhbRLvPRFfm28N765YegDyZz3d5VFBB4
19934	payment	1683	1683	1393	1	1	1	314501157750000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYk25LHysbEGt1MXWUf4WFxxEFzaeP2Dsihhxr2eooLWfcoHKNR
19935	payment	1397	1397	1678	1	1	8982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQs5jhVXMKwuYQotsZ39JGj5o1nKgas5nmB1AiDCzDt4rfrxW
19936	payment	2133	2133	1874	1	1	154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYUXJy1CHA3GycD6UcmF9JEWX9yWrj3bcBerY6TuRtxnSwZLA
19944	payment	2134	2134	1874	1	1	130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HDiyAh1tnVZTdosdki4zF8C6pH69BrRvkBE4dFraiy85Kesw
19949	payment	1397	1397	1678	1	1	8986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dyWtPHZKLmaCm9pBmAvjpdRrt1Z5V1yJgwLtWf5k5Zibtsrc
19950	payment	2132	2132	1874	1	1	43	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrte8i1HRq3ZMJoXXu1gGfkPJTwfXatPY4FPAzSRWSnHmygbTH
19951	payment	2133	2133	1874	1	1	158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCY6KdtoGiPwNT8An3uN5pGtQwsqp23gUfHgzeSgcievsVgNBu
19956	payment	1688	1688	31	1	1	18	3315886828000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5D3Qt92rCrzZnUnBT1KUb4RqN3adLe4YfikgiF5BWEWm4UEd4
19957	payment	1688	1688	32	1	1	19	185149305000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZHM5cktAmYQqJy3ZmC3whRGGimSXtPzZBzvT73aXcgg8okoNGq
19958	payment	1688	1688	40	1	1	20	165969741000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYspBoBq2mvVbHU6CoHwnZnCfoMKGB7WrkYvPnuqVePrYBz3P4N
19959	payment	1397	1397	1678	1	1	8988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRA6A9YumwTgVoisaQa476EBj859s4bVkfTiXaQtQfNs5b6Qp
19960	payment	1397	1397	1678	1	1	8989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqYs7LjMkyMrC51bnrEYZ5uepEUPFgekPfnB8oPtxziWaK4dH
19961	payment	1397	1397	1678	1	1	8990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxx9ukgUH85impBYJgQ8CvjKVCSiTvFP6xRfg5T8vbnGaEKNS
19962	payment	1688	1688	779	1	1	21	69853687000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa1VpkVcYscHzrd8rDcsRk3ne5UhAbGUr29BNhqhq5gn11SMXaU
19963	payment	2133	2133	1874	1	1	160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4kxJhoZ2pK8eYcvkf5xFwJHixCMn95kY4dSAcZfRhN8YZrFo
19964	payment	2133	2133	1874	1	1	161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhjAh7nK9PppaNuGS5MWLbKqMtTWJYQKPUqyJhVyvJTw9Khic
19965	payment	2133	2133	1874	1	1	162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatzeLg7c218BpwV8FCuLBnK4mvStXSFEbtVLXLF9gMQTgoTbP
19966	payment	2132	2132	1874	1	1	44	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPFFpDE86U3pwCPxMfLdsZv9q4roWvRqEoyD9nDtsRj9orJTp
20007	payment	1679	1679	1	1	1	24	824260949000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZBWZ6MYKoBjxFFZf6EfjNvM4Wb9sPwQBjaDoRfsvc4cMpfydFN
20008	payment	1679	1679	841	1	1	25	184498405000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5a2AbmSPn8V2KWXLhAPerRDopMiphnakgrtSQMrv3NLrkFEJW
20009	payment	1397	1397	1678	1	1	8998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaEoSA3PAZZMAtnJH8Grq4GEYWCw8J4ZFRQSrKVcqykDY2CghZ
20010	payment	1679	1679	843	1	1	26	343971557000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbQYtXjU17sWCD6wFdUPDVZfTDdzEiBgr9h9ev7P5k6gLxB5gN
20011	payment	1679	1679	849	1	1	27	2546701905000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ4FbAjgtxdxnFsZ7TKHVXdNU8Pe3Y9wNuy1AiUH2PYebwaBkLs
20012	payment	1679	1679	851	1	1	28	4933345906000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYgPynYoV6YrQjfahRri4Ea2RLiqfntDpv93cAY8GtqMm7uiEMi
20013	payment	1397	1397	1678	1	1	8999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcPDKzgJrR9G36DnTVSutd2MS3AU9HBYiQyLWNJJErmNbmiBX
20014	payment	1397	1397	1678	1	1	9000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQbCkrUEgtsMZBZsf5oqonaNW4attcHSGHuQjBiw1xBhrnFkh
20015	payment	1679	1679	853	1	1	29	543980764000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaKa2TqLMXjRDo4NPtv6Ypdb7UBvNypgometo8QDRwYdMAkzXB3
20016	payment	1679	1679	855	1	1	30	287745437000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZHs88kAEvbNCnaHhEQSnPCdMAgmvGNvVdviHbXHEU6CotqaHNi
20017	payment	1679	1679	857	1	1	31	725545820000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYj92FviEpX77HSDhEFEKdWkvAeTrT9QYFS3keLHo1PDSFy7pg3
20018	payment	1679	1679	861	1	1	32	1002147901000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaDWSTYJJzNtvWcfZEMY4ApmqJpF3CWuMEGTP449movFHb6kY8i
20019	payment	2133	2133	1874	1	1	170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxRdJ55dbAd4CZJNbRJKeJ3FoYarcEq1vVPhwghwyDH6wawpZ
20020	payment	2134	2134	1874	1	1	144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8EmHXEmvX7YAp8ovoNgkCyMy3WUs7YFcz918LRpZnqnGMEjQ
20021	payment	2134	2134	1874	1	1	145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn2bqsqPKqaGuTKTdbsvntVh5v4WeDTEdtdT5fonz2Q23vBsd
20022	payment	2133	2133	1874	1	1	171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXtJWDkzJyoVgu62f2FLCPSv9SoNzMzd6yqnBqehLMa6Y6P9r
20023	payment	2133	2133	1874	1	1	172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGC6AJUzCK4Tq68ZSXMKL2qdky477EoBcu4GZ5t7fEWVnnoiaV
20024	payment	2134	2134	1874	1	1	146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gUbnMRtQSnR299jPuMPF6jYG7R5zmmDfzRzECFqabbTmcfdb
20025	payment	2132	2132	1874	1	1	47	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUNcJpYrhCyb1zSAtD73V289VaGowpYdLG6fKVcEMDASCaLtb
20001	payment	2133	2133	1874	1	1	168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfCRFxNdomEv3Dus4SJGSCiEt6HqcgshJNxgbnF8Zn1xNokP1K
20002	payment	2134	2134	1874	1	1	141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxLafhfnJK6yShqfYMfD1Ap9BVn6jQp7Aqzhshwm7sPkwU1B2
20003	payment	2134	2134	1874	1	1	142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nsw6xzb2NdJ79frGjPWHHYqFj8R8eCTor7sgrH8VZu7ANjaU
20004	payment	2134	2134	1874	1	1	143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1VzimV9bEyYFNEE8vKvmuqXakptXRryqpWXvzUSigsoBZK3e
20005	payment	2133	2133	1874	1	1	169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzS3ehRihtd3CXwvDxpJuRpkK9DWCP5odAKFZ8hQCHc5QkMyU1
20006	payment	2132	2132	1874	1	1	46	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sfyyy9bmvohS8ih5FZEPLScQTdw1hEsf7oq8ZUmYtYVPitVE
20026	payment	1679	1679	865	1	1	33	879773405000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZwADt9oqAcPdac12TbbpTAXyUsUdQmSHBVRhWtW4ynKqrNgZqo
20027	payment	1679	1679	867	1	1	34	5358018483000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnqqVEZC5roMffQWsfF34T9ZRd43C87JpAtZjsLfFhfugPYfK8
20028	payment	1679	1679	869	1	1	35	572998403000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYvjNZkwA3DVRWhrZbggCzLdeYK4jbV38q9G7yhWKQ5JDjkVfZV
20029	payment	2133	2133	1874	1	1	173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3iYkGRfXnMazUpaUfYWRWnwFLJBixwCARfru1RJPrs9h9zax
20030	payment	2134	2134	1874	1	1	147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PheR1oRG9Q53GDwBSdC4eAsrojGZ5g7D37KD3XR1sy7UadqM
20031	payment	1679	1679	873	1	1	36	5358018483000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYQ9KJctMEhY8d55JAUkmYhrRgZYbJeGUDVkJRWfdMDknSnmbsL
20032	payment	1397	1397	1678	1	1	9001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSTeFVdoteAGNR6XJDKWm69Uxu55FrfpPbKJW9jQ1MDdyeswE
20033	payment	1679	1679	875	1	1	37	469653472000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaKZ1ruzQTS3dJaYZrvpMuXmLFEuBgwS4NyEBHbhHHExVb5RzH8
20034	payment	2133	2133	1874	1	1	174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14ftKTH9GrZCJ6Fu1Wyd7e7x9o5xzbviWHbKTPBxFuKn22QDL
20035	payment	2134	2134	1874	1	1	148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxLBnSV16C7n2kC5jc8UpAiXB39ArMQ6xSRXUYj534nmFgPau
20066	payment	1397	1397	1678	1	1	9008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2nxMgTYjjQSb54qJFpSXY78e5r7n4m8RtJewQrkE1QLjCBod
20067	payment	2133	2133	1874	1	1	181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsmhdBjsKGEZvDj6K6m9HTPJi2ViPKyzThRPYw1b7Q438KPo2
20068	payment	2134	2134	1874	1	1	155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxsGEzCXm5eUm2DXyghAbMuhKD4Tqo4FTR38EHHAyqGFx241bx
20069	payment	1397	1397	1678	1	1	9009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7wzHRqRcYwDnVJpn4K9C8XwecHd8CvG4X7manphuUDaGUPa6
20070	payment	2132	2132	1874	1	1	50	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj3WGyFFtLeSjR2mpK6djSxwLWY8qtk2WTZmtdzGqvF2b3NST
20071	payment	2133	2133	1874	1	1	182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfmCsqt3sxLYnfSAUSQ6kTT9cxxrNK433PJeDdBnuxpDkyz2i
20072	payment	2134	2134	1874	1	1	156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9HJqxsCgMfRzNZRypzpFsrFN7ug2uCxvkM6PUacn4GYwvv69
20102	payment	1397	1397	1678	1	1	9019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaropooDJbebME6epnhCgzWtoP7NPAUEPV2Wmd1mP3UZVUMU9v
20103	payment	1397	1397	1678	1	1	9020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEEcyK9bWH1aiAUiDKqSuSkCuhNfMXYSL9WiGKGcYBLTgZcEe
20104	payment	2134	2134	1874	1	1	166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5tmbAQkYKEdnPEt87G96uygvMFLr3V9VZzrHU2nZqkHHgtCxe
20105	payment	2134	2134	1874	1	1	167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a8NUspmBib5Eo2C8vbTVZYyYF4q9B5kFXEk9WzvD2XYQAd88
20106	payment	2133	2133	1874	1	1	191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjaGYMeHFFhF29f6yb8z9aoZ8nsV4zCr62yikjQa9DcX8jTP3
20107	payment	2133	2133	1874	1	1	192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkib8m2rRuMPC7Q2mxZchzAoVk8pqe9qHgdVGYgrdeJ2C3iGa
20108	payment	2132	2132	1874	1	1	53	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczifTsyQwrM8C8FRFT4HovVioHEazxdYuJkLHYytD1NhKNCUS
20122	payment	1397	1397	1678	1	1	9025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNAb5owFq8YtQ2vH8jvj6nnK6Y4LPFMhzAhYkDtv2pPCv7e77
20123	payment	2133	2133	1874	1	1	197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGi8KcaTELUN7od5FejA26BzeVYUUKhTQXwhQd32rWJ6UfFnbc
20124	payment	2134	2134	1874	1	1	172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjLX61MnyEpYN9CZyjdJCdWpeNkgKzK3HJ5Rc22Qxv5qVPZo2
20141	payment	2133	2133	1874	1	1	202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmciX6xCgHUmHDeoBiUgctwQkrtdsL69UwU5F3mpkrRrNq6hef
20142	payment	2134	2134	1874	1	1	177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51neEY1dzE3fSEkmXzj425KB1fdeBGK2fBbsxeumPY9Fs7dP8
20144	payment	1397	1397	1678	1	1	9032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4iRDFEUuM841NVSGqGj6PMWvBFFWmPDFfrxT9CcS8DtK1WBn
20145	payment	2132	2132	1874	1	1	57	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5X1MtwZ8o43iN8GwwQ5x8Uq3s1C8n3TR2NnFkiWw9iv6eVUM
20146	payment	2134	2134	1874	1	1	178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYku52kRkRbpirZFdUvH39Ae2W2bvaptNTjeCDsDQA9uJznPYNA
20042	payment	2134	2134	1874	1	1	149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA99uG922M7hga2QuRLg48aNRjQnfGXtSiCjsG4gzDMzHFVSeB
20043	payment	1397	1397	1678	1	1	9003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTC7ZHmupvh2kZewsd9EFNN8RYgvXJZJvAw9aVBxR3s4iih4YW
20044	payment	1679	1679	887	1	1	41	592277347000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYcFmBojZq4y7Q6xsAdEQGrTnJBNZqkyovuMkpRw9Lav2Q8RNkz
20045	payment	1679	1679	889	1	1	42	497185088000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZgDdmJn35F1rgihfeXpEddY1DsZpPa2jSGJbm6Matqc7UPEFa1
20046	payment	1679	1679	891	1	1	43	1091448209000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZxU4ddLSnmZSYeCwPTWFug2cMGTxDUR48jjcyte8hefZMxepQS
20047	payment	2133	2133	1874	1	1	176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwy6TS8sH5axmrFvc1954FoEYpoSNsbB59h7ybGBGnV4MGKud
20048	payment	2134	2134	1874	1	1	150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8281S1WTxS9aupZ5VJyYHoafW6mDyYxx1SvHJ8wMLgEqyjaU
20049	payment	1679	1679	897	1	1	44	143975910000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYc93DNhhPp9DJ3RqQ7cV2UgVp49eC7geBMSDAeb51piYaPGX41
20050	payment	1397	1397	1678	1	1	9004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8BmqNdcN5a52Nonnu39JFNR5DBhPYEHToPaTsgjJUCNyCJSS
20051	payment	1397	1397	1678	1	1	9005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdV4qp4gpBqET7x224yvBSyQbeLqtWUbB9nSFVdvwyDFPzC4EG
20052	payment	1397	1397	1678	1	1	9006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVtiUsVngdk17u3fcUr4vA7Um745EqvLbQoEVQpV3bcuriXqj
20053	payment	1397	1397	1678	1	1	9007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJhiFcgduWiijebXoTPRTKTDEDapM6ktdiXCACbqtd2J9PjCo
20054	payment	1679	1679	899	1	1	45	85823549000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZfJmL9hA9rQWiyafV94oyBRaYmqoWMNiQSAMx6KKcZVZTnERR7
20055	payment	1679	1679	901	1	1	46	257978668000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYW7K4jrSuoDB9ewJ6NqQuPPBktLpjmPA8nF3Er5GEfjpFe6yfu
20056	payment	1679	1679	905	1	1	47	927730978000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYRhSoPjh35586iU7hoMwVwXw2oktEyjGha1dfkrM8L9hJPxx2C
20057	payment	2132	2132	1874	1	1	49	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBq2DAQQN1BYQm7sJqPRFxzkHDevbgcbikZmP1KhvmpQKRjgh
20058	payment	2134	2134	1874	1	1	151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75PULpUwG4ikHSijABb5TWZPBzu2ppF3d9mZ42KwfeQBPXp1L
20059	payment	2134	2134	1874	1	1	152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAW74XiFLF3CKHcss8dhtxbAf6Cqo7s5DW9pnqGF4qRupHg65
20060	payment	2134	2134	1874	1	1	153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eSzJeYn4DKaHKEgxTc9GUX4jAzUjtwPUAZTA6fXmhFyniCem
20061	payment	2134	2134	1874	1	1	154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71e1ZzQ2q7KUKfqTtyZqBozqkghDbeSFPt3YgYmKPJwvovUzF
20062	payment	2133	2133	1874	1	1	177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVhi7CNemhNHrGppYa9oH9HcSddauvpPL8v5vUPezxborysGH
20063	payment	2133	2133	1874	1	1	178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACPffVK2XwJZka74BDp1CJDziUkWCQL4yD6weTtcqDZ75qCfk
20064	payment	2133	2133	1874	1	1	179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFagRg7xDQaYU3a2cj9LNYbfLdYF6abeZs4TBGZXXxyTqbiJux
20065	payment	2133	2133	1874	1	1	180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYrKfqjD3tKdZ25H7JNS7RfuMoZNQ7ateaQMUNtVjB6Eryhcr
20073	payment	1397	1397	1678	1	1	9010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yPs92hphg5G6dToHhN9bmbSp7zBY1P14cNkxsRQMVRCqk5Zk
20074	payment	2133	2133	1874	1	1	183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAVfMQVpoqoT2Q8B94e1erN1hr8wWiGksaVKViM3eo1KtppPM
20075	payment	2134	2134	1874	1	1	157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUtbkqnBHjMEJtNT1sigVmP3G77aEkA6BsN8BmFdWVKJCAeha
20099	payment	1397	1397	1678	1	1	9018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9C9rah16cdDinyxyqqqKRNmcwXQk92Da1VC5kEiCMALAKWeu
20100	payment	2133	2133	1874	1	1	190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxq2b3UrhZiC3fBunUo9fB9oD3LK8ZgXRDaADnoTBJknfnzpsP
20101	payment	2134	2134	1874	1	1	165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWmhhEmGNUXDkboqjDY5FxGJq9wNUPTqss2ZifmQwM1SqkqbF
20112	payment	1397	1397	1678	1	1	9022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZtqS9mhe3WSThnS3r8owL23jFtGQPCU4WnMSz5mvsFkR83Th
20113	payment	2133	2133	1874	1	1	194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXtBWXQanCPv3VRYaPBQs4Lp9ZmFrVH22Z6G9gwkrQk82zuxN
20114	payment	2134	2134	1874	1	1	169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBURDa9xBLqhNUAZJfaKgb6pm68f7BR5n8Kx3WoLaC64J7SyB
20115	payment	2132	2132	1874	1	1	54	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KsyV2xgteSi6EoAxCab3FvLNehYn4ten1BMZU2rJZyF5gVsg
20140	payment	1397	1397	1678	1	1	9030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd29qRxrHwuQcCrZ94ZtJvPN1cR7hieBqQcmKNjSRxaNPtmHTf
20149	payment	1397	1397	1678	1	1	9033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurU3Fuu7wnMryZbLNUZ7SPoEVPmUzs5gyToosfkpzXxGH8RVr
20150	payment	1397	1397	1678	1	1	9034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMuHxJoMeeBr3XPEBeY2uprNnfXKCcQbHKJmwDVTXQLNqePDj
20151	payment	1397	1397	1678	1	1	9035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMimdHhxnb3HQbrbxnnf1e1yLkENRT7WFDXV4nZRLeQD3Pnw9
20076	payment	1397	1397	1678	1	1	9011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiisUmAS6JHHG4CSa2JqmnPJtAT39WNuZWuaCSYXXZVgCDTpJ
20077	payment	1397	1397	1678	1	1	9012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1UhFgcRdrmsGGHmBtTLAwMQiZk7Tj3PKhJ5D5SCEJPGCPN23
20078	payment	1397	1397	1678	1	1	9013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbkPFrTbHdq8vyy1rRefyRofLVgoh3PBAbF34Yf6emRXj8htt
20079	payment	2133	2133	1874	1	1	184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDNvjnq2Y4tSRELy3KGL247dx1PzWMPL4yu3N4SYJu7X5VbVd
20080	payment	2134	2134	1874	1	1	158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThs3eaqEJNrurfUr3ZDWMHZnrsAQD8TQfg14ZpriGkv5ZE5eu
20081	payment	2134	2134	1874	1	1	159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9zN7SXVBjZGdP4A1uCk3hySKXjDw6zPDfPgA8o7XeP2HeiMV
20082	payment	2134	2134	1874	1	1	160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxphHDQzM7cQrkmzHYD1VxKiz46KQycjcpFazeY7fagmSkaXj3
20083	payment	2132	2132	1874	1	1	51	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjELikLEVMBKHBRretj2hce6Ts6h825gPSSj36XpRgrcoRh1u
20084	payment	2133	2133	1874	1	1	185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4e7X429TYsRfMSjLPqf1PaTaTpheWtoruuNj8mdL73svgVBL
20085	payment	2133	2133	1874	1	1	186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYho7DzMvwjoFSrogXPotom1pxoJz6z444oFeS3YuB5XckYJzoG
20090	payment	1397	1397	1678	1	1	9015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmc9f1kA5rURrWS71LBN1LcikiChymkZD9SnVYgtdXMFcHRY3
20091	payment	1397	1397	1678	1	1	9016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTASWesUG5ox7b4VhEWqR9b2uoM2VaHRZDqMvmWSPPwkqrCde
20092	payment	2132	2132	1874	1	1	52	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAk6xVPG5mS9oCNNhnJAf2FwoBnkMnQSA5HoFhiK7SA4N7H2aD
20093	payment	2134	2134	1874	1	1	162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMH32A8XrXKDVWdAcWcSBGfQhJxAVophJ3Cfbf613BkaQSg7K
20094	payment	2134	2134	1874	1	1	163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChddbGi6KDcUJ2Y5bcn9WhG699Ki3iLxEGu7UXGZ5vgudHm97
20095	payment	2133	2133	1874	1	1	188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3biVfMpa1iQF6J2KwxQgg3t9KNUAEDpGdD55HVgPUoKcevgA
20096	payment	1397	1397	1678	1	1	9017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJL2af48PDmKA3LB34PepsT8WmydZgwAHwvkqGei95ymitY5R
20097	payment	2133	2133	1874	1	1	189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVoW8zu3Ya6wbY6gCiyR26z36BNgnEHBWDTkRTWDGbS2zSDC1
20098	payment	2134	2134	1874	1	1	164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJjmomAjDjma5QbeqyFtECNu3LtDmy79ckWpsNQsw67zjbr1V
20109	payment	1397	1397	1678	1	1	9021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnHPi1pwAphxWBiRWSrwkHHkGhcuBoChDSYwB93NtzXYNbSHC
20110	payment	2134	2134	1874	1	1	168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83pUTD3ALrNqC5o84qhPWQREVpKXFHSQ2yjodjnz28jJn9dCo
20111	payment	2133	2133	1874	1	1	193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdgp3p4QUhwmrccroGe2uJGrAbKFUjEL1L36cuDu98C4bLNrS
20119	payment	1397	1397	1678	1	1	9024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygQBSvqMSH5vKqguqCCRagLnwcoxzetS2ofTrtfE3S66DaruM
20120	payment	2133	2133	1874	1	1	196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbqa1ZA9pfaWVDobUATEp95GSNBoE3YEg2aSMc4abSydCXJMx
20121	payment	2134	2134	1874	1	1	171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLtM7PXVrf2MbPrShSa7hdrDQQzXXSyw6uEmwU6CZmmGgiD7Eh
20132	payment	1397	1397	1678	1	1	9028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfydz9BRw6WGF2ithCUVBVW9wHLxGuczaf8euDqzo43ZWZ4LSt
20133	payment	2134	2134	1874	1	1	175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrQfVed9jSzcPv3P8yiht4wu3eyP8VQuCKd4rCXcer85ybBw6
20134	delegation	1893	1893	1519	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mZLCnuy8CxU7EhLZV9tyTtSNX6uDJhxwhmKoGzGaLbz6AT2U
20135	payment	2133	2133	1874	1	1	200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNkk1xmCZVJcjT7n1PY6apQgucimtXPESPgUSdiL8Nghy6fu7
20136	payment	1397	1397	1678	1	1	9029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsscWLRA5iESrS2cCQj3M9GoqpXDBFsHWEweEsRD83b6mkAQb
20137	payment	2132	2132	1874	1	1	56	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgf9DDCs7gTV3kDtguc1fwgtdPYibDJM7k6wSdLLTStCYe1sL1
20138	payment	2133	2133	1874	1	1	201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZaFMXQwhmJCwqjPcsz6MnqkESnQVBAPCZtZs5gzP5RsG31US
20139	payment	2134	2134	1874	1	1	176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zQvMwDaWcftYDfqKKgFvGtrpVQeTS7AMUzC8ecaAuLQJ1spc
20162	payment	1397	1397	1678	1	1	9037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZwQSuVGogC5w9qgpMMDrc24xHBdWKNV9qsVBd4KQQmS7tCCz
20163	payment	2133	2133	1874	1	1	208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUDemVHdGZrxPk736q9s9VRQjMXAGZbrdED5B41uHNtfEAXiy
20164	payment	2134	2134	1874	1	1	184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ufsgXQeo2jvoeYMSmKYonG9chPbd1f5N4QGaR3NeewfwaVXz
20192	payment	1397	1397	1678	1	1	9047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxFZyTk8tSTPd4DEcwHZRGaJzeq95bXchCpTEFXP17WZUAmsp
20193	payment	1397	1397	1678	1	1	9048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3mqtLhvWc4LnqNGENxcFsAhck6p3TEBWbQ4zgotnUPFjzx6x
20086	payment	365	365	2138	1	1	1	50000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbYRLzu4Zkg1vLFQgXtEyXWpXAwrbp89mbsj9N9cCVcvqSk2c
20087	payment	1397	1397	1678	1	1	9014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2C73ZJFMJvEVRvXuCNZAKCh3xW4szpEhcVV3XNLJy1EzoNEo
20088	payment	2133	2133	1874	1	1	187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTawqJEhWGwHo4JpTvcBCRXQ4PPMSWV47Hn22PS5jemM1jnPub
20089	payment	2134	2134	1874	1	1	161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifJWoZi9o94bv4hX4cKz38roZT7eXxV34p9TMVp6gDYvr3AU4
20116	payment	1397	1397	1678	1	1	9023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2UGM2vkxgJ7Z9pebnQUK3AzXmQhmPHB3L9HbCAA5fdLAqNGE
20117	payment	2133	2133	1874	1	1	195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2z8qeJvVHwPRnBh25z1avnZZCaaRG4TTQmjSYcgkW5zbx8Gh2
20118	payment	2134	2134	1874	1	1	170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjUrBPWPLjoLeP91H88avoi1j542s7djxTVgspdAQcDzeLXCS
20125	payment	1397	1397	1678	1	1	9026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYD1ppv344g5pvhu3EsUayWTvH4fKfYT82mqqyaJJ342T2tZ1
20126	payment	2133	2133	1874	1	1	198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3z6989uLv5bfMbwkEPUNEjjZYcqVjDoQQPSWwUSGvpPqSHZY
20127	payment	2132	2132	1874	1	1	55	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoKrbgdQuVbdbJNrzyL9HK3ig1nLqdGtwgyCuE82z45mCCaLW
20128	payment	2134	2134	1874	1	1	173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1u8XF7T2u2RAoVSxRrXTAbNF9KRPdNTC6mFs8n5qKCmQbrAp
20129	payment	1397	1397	1678	1	1	9027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYD7ZwFooJRZpowz9P9t7kJ84tScDTAwxsWG7iERRpW9BudCW
20130	payment	2134	2134	1874	1	1	174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW2DBDdDy7SMNJqcEYhV9j2vPBdfEH76Xecg47RHvNPmZ7UKE
20131	payment	2133	2133	1874	1	1	199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5FNZaH2pzYuCE3CycDYYBmnZC5oXZrkbER7dPGqbSYsemEKE
20143	payment	1397	1397	1678	1	1	9031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxQYNGprBmSParJcRXntRYgFXQZ6QvVBpFKkSArgqPqRz3koA
20177	payment	1397	1397	1678	1	1	9042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwheiUSCgbNGQ26LwNYUd9FM8foQ7MfSayrd2Ki6t1RsRVAYR
20178	payment	2134	2134	1874	1	1	189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEhpGki6aAC487EagbhHsbD9YezNUt2VzFYuSE9z5U3ZHqStQ
20179	payment	2133	2133	1874	1	1	213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmKm3oSfGpnU8A3aSvCMrx945bhLyVQZmgS51H7tsqeRRvnZss
20186	payment	1397	1397	1678	1	1	9045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCY4hkZuhXznigYd7LMGBbxXxQWArEdnvmqyuRjVjd3UDmhJgz
20187	payment	1397	1397	1678	1	1	9046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRF2ZYArSUTHZ4v44jkgJgPpYtFB7kxewXwanKzjYDYMfdjmM
20188	payment	2133	2133	1874	1	1	216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7qomagZEjwLPTjuvwfhDVHjbkRhp8fBaChbLUd3G3e2iccYW
20189	payment	2133	2133	1874	1	1	217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCmfN6v8YRxdSzc8SuPSGLQE3TXsjNhaTnNsBq6jSzm37eYXt
20190	payment	2134	2134	1874	1	1	192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuk2CQHiNejU9yLSypemaBpe92Pp2WHwKww7PnEb8rNF5CcFTd
20191	payment	2134	2134	1874	1	1	193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZka8kXTkD66agJNNYJKTU6CTABX4W8panc75a9LPevPVmPCbzC
20200	payment	1397	1397	1678	1	1	9050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUCJoQAVvSgUJp6Z6quk9kMzcwKQ2fxfeAbiDWppwLkehTB9e
20201	payment	2133	2133	1874	1	1	221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKqZAGvGXAcBaKoniK962SZwvXdqjUnszpxgGRY9UEh7o86oS
20202	payment	2134	2134	1874	1	1	196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoP1czMzUCi442mkDAYsNvnZSu24jVtC9arTH5M6qVfjeNbNd
20203	payment	1397	1397	1678	1	1	9051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZZcM4YM1ZA1WQAK4NWBNm4Ms3p1C8fVFqZQs3625aiGcysjT
20204	payment	2133	2133	1874	1	1	222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPt4yt3p7r8BfnVrbm7XAHffmSd9598aChnStU69obQST9gcD
20205	payment	2134	2134	1874	1	1	197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxyZpZBGZsH4bvW4oEXt5o9YcbjyoCAjjVAqURCh6BobptWFT
20247	payment	1397	1397	1678	1	1	9066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4qNXC4MfPw5ViqLowQrvCRjZZeffe9wNqqYaDy5i9DaeaPAB
20248	payment	2133	2133	1874	1	1	236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVCWn5w6XdeewXKCMNqAcAmLci5RxiyahrRTCRQ1d86htjhCx
20249	payment	2134	2134	1874	1	1	212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W96q6BCQ4AT8ajkTUWVTHHvJ9o1uuGmR6NbzHG7mDJJ1t4jE
20271	payment	1397	1397	1678	1	1	9074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudzm285XV8AhcFNCBou1QRZyJ2UwN6W3uwykrmV2ujU6s8KyQ
20272	payment	2134	2134	1874	1	1	220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9ni6VjdKg5X2wQk7ccspzzZP7d77z18EAbzmxqgBNtGdP5oT
20273	payment	2133	2133	1874	1	1	244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJ5nYvuZgMYt4PtJ9nFvMf8XiYZoHrzYUR34a2WVLfX9Yh78s
20274	payment	1397	1397	1678	1	1	9075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYkP8Zp6boB4fFpcRimfMoGWfL7qUDaYn4o3aCR2R3zcbsh6m
20275	payment	2134	2134	1874	1	1	221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbmUJck8QeiX541ojpLCb7PJtgkbTtt6s79oEgEn8XPnc1UBb
20147	payment	2134	2134	1874	1	1	179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Dmu3YEW3A2R7fqR6n8aeYn3xucW7igENcKdF8bv8ift8kabE
20148	payment	2133	2133	1874	1	1	203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYEe3StT6JcJKPyoJMaUB1Xh52EcV1gunjNsuTCQ2UtjC6WX7
20158	payment	1397	1397	1678	1	1	9036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkhnzXQ5x4j28xKNYHaK1X5A9tR7tmxc671CN5Hypx3sNDqvc
20159	payment	2133	2133	1874	1	1	207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5eE6M4hwGzn4GtUFsf95YpnF5jdPUSxZALyvNw3hbo52wDe3
20160	payment	2132	2132	1874	1	1	58	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr495thqPc5pc4kwnnsm6MwW7CGJ1JU3XJ9bxYjd7ZtwQcGXcp
20161	payment	2134	2134	1874	1	1	183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6mVxbobBhdhodAtJckGfDVpQxndtUr7zRvFynf2UVhYGfxjw
20168	payment	1397	1397	1678	1	1	9039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxUEkCag4VPmdsEjpRrLUHJ7vqA3ozyLP1ZgFU7xbjuC7BBBK
20169	payment	1397	1397	1678	1	1	9040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWC2BnjP6h8z6SRarqH4sUt2sfrvaDiUNume6CtX32Kweeyyd
20170	payment	1397	1397	1678	1	1	9041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWLdDCac4pLgNnwpRzprsxxBjL5ikzbfKHpCR4PFQKX76MVfS
20171	payment	2134	2134	1874	1	1	186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqCCbgT7johq85vuoQV9sJJjLVgnt5fHrwJUPqRzCWSBgGHA4
20172	payment	2134	2134	1874	1	1	187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByP1LVJn5VVEC5HRksY4mdM2VRhULr82XVBmqbVnLWN9UvW8b
20173	payment	2134	2134	1874	1	1	188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC4xo755eG4hvqLBCqJD4v3WqZRPY5p5QpLqzVsURnewodXxM
20174	payment	2133	2133	1874	1	1	210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfmqZihZWNXRTJ56RcCUN13HZbDDA9KbBcSRdiCtSfYxwLm81
20175	payment	2133	2133	1874	1	1	211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSiDGRrj3JBy2sMZoNKvM99QrDn8Yq6thruRX4iT9VawSp1zq
20176	payment	2133	2133	1874	1	1	212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvovaGZbiGEuvrD7GLbyw3RfXwYieUjrKi5bUjNBR2abs7A1F
20183	payment	1397	1397	1678	1	1	9044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjsFmzFJDc8xN1xkQmgR7zRy3vzDpPweoNBe1843jTDayMBNU
20184	payment	2133	2133	1874	1	1	215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qPwwAQ6wr7DqTAfKohPVnUXMHLKxwJMRRexdPQ4Wx1hyitTi
20185	payment	2134	2134	1874	1	1	191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVaDMX9tjs35jcg8QwpfuhqsYiiSZR2maeGqPp4CRobarRDt4N
20265	payment	1397	1397	1678	1	1	9072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VTQQJntyzvS8ETY3rr35ZioyFgPrArm6h6QrjEDG5jXDaXa7
20266	payment	1397	1397	1678	1	1	9073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDcu3CVP1ZWao37VMots27LyeeYgAkfxbDnpDs5rL1MsoQfjn
20267	payment	2134	2134	1874	1	1	218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Aebpmacon2eRE9zjftVB8stmxuJw9V4ppyE2PyBzqZDxcMx4
20268	payment	2134	2134	1874	1	1	219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJeAHa19xhPG9wPuKmc2BW1q9SRJ9WMkGa4gP7brnGX4Q2hTz
20269	payment	2133	2133	1874	1	1	242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4V8ntZTdmzwsEdrL3NkinhHxpQJBsHkNgLJnDWyBUK5HysSAP
20270	payment	2133	2133	1874	1	1	243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTd9iB2YovyQAiPdNMtvEMoHdDiLKo5zgMbuwmtL8nRQH4Dbew
20289	payment	1397	1397	1678	1	1	9080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxTprKqH5BMPPvhJfHPLCoKV748oeyuFLBms8pMEiQGk3kpud
20290	payment	2134	2134	1874	1	1	226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtJo2pMXj7gmCbbT5RqVdk7B8VEWtz31HkJ97zAR77LF9vxGw
20291	payment	2133	2133	1874	1	1	250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75hLe6ztF3GzYybamqsxHgNx1cUVS833WJG9ceFmY9a7AZV3m
20298	payment	1397	1397	1678	1	1	9083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCC8VPsyjebg9ZRUg3q4B58ahNpbuaXttbggnCRyXkXGWsUH7U
20299	payment	1397	1397	1678	1	1	9084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2QQKv2NQfHdno4p2uLMjpt1PqyK127kprnncZe5fydLL2ms8
20300	payment	2133	2133	1874	1	1	253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgf8gkNdfCw4CuWikYoKBMSBhoMuLCYCEokCivQSTABdYbD6j
20301	payment	2134	2134	1874	1	1	229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLocAonDD3s2BascvvVe1SRk92UEu1d8sw3zjFGdNwjdx8ocEG
20302	payment	2133	2133	1874	1	1	254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwPHhcdg3u73kbTDCqifvTPM2NgjXLP8VpZvdjiMeTXtoDzQJ
20303	payment	2134	2134	1874	1	1	230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvEQaBm1KJRBr8aPZJGtLnaqviRxUDUVwPrcmNVeQXeL4zUJn
20316	payment	1397	1397	1678	1	1	9089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBGLq3fB1LNY4tveUQhuuhvuN7RRpL43JrjUYUW1rWjscW6hZ
20317	payment	2134	2134	1874	1	1	235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpByLipPia6mDL2s3YS2w92dxkUyHs3mepArYfDorWPRHsNfyP
20318	payment	2133	2133	1874	1	1	259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LgTbL16hZuSf3GbmVVjoigkgCgexjcdqrojH8m2e9qRHcgch
20341	payment	1397	1397	1678	1	1	9097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjMXEepRzVB613nYd2q5TqFMyBfPS52kjWb41NDqnQZxN3PvH
20342	payment	2134	2134	1874	1	1	243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6ajQWykzuh7ANZKruzCjg8euW8N1YE4hcp8rC8JoHrnREZSP
20152	payment	2133	2133	1874	1	1	204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGAMjVBEp3JSW3USykSMRkmQUXVZSM9ThQKyCwr6mMtq9iYHE
20153	payment	2133	2133	1874	1	1	205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25fKC39BLtG5Gg68qrKPABkSM6R3dmprRwHw2HuM3XYyTQ6z7
20154	payment	2133	2133	1874	1	1	206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtsqsW1Li6mKFB2PU2ASHF4SvMjmCeV63n5ne693PDui7kcWt
20155	payment	2134	2134	1874	1	1	180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMb9Xy2QcWTmHMFz28n55oWp2192zrv21JEg6EX7nWVWsNySGd
20156	payment	2134	2134	1874	1	1	181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGKgMmCsqyqgouX6bduhVFfPsXobJp5dXxwGtaqiJAntEjURp
20157	payment	2134	2134	1874	1	1	182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXowiu7rCw3jtozzDmME2fsKWrRHgnErCLjtJUGy5pLSfpeVG
20165	payment	1397	1397	1678	1	1	9038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzL5wNk5VXVe4v5bxTDY12pQC4nSMF7KnncmruqKkmP12chC8
20166	payment	2134	2134	1874	1	1	185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabemqsfDimyf8w3nv9s7HCmNNSNxhzeAcKvHgN7gyqoNXoXea
20167	payment	2133	2133	1874	1	1	209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe646fE95UygbqkSt4foSNeAFi88XAV4XL1WaHY1UpE142ciL8
20180	payment	1397	1397	1678	1	1	9043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrm9ALTmWKWPvvMG65XWj9tHRuirX6AaUFqcvor7RS7ogP9Go
20181	payment	2134	2134	1874	1	1	190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZED3XrThHpyKnzejWfsgMe1cexLFZ6SpUJTwWUxyuZqeYaC4u4
20182	payment	2133	2133	1874	1	1	214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwG3JmSrvUAXC2RYJPupnjVhYwAZ3RFQ2wXBBWCGNivUmEdUH
20209	payment	1397	1397	1678	1	1	9053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcdgxomMwLxTXGYNvC4HnguSouzGtNhncWDhXumba42tiEbyv
20210	payment	1397	1397	1678	1	1	9054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWtoAa3gKcd49X84dJtw7UKfV7hjBdUGq6GtmjhqeN5xUbjkN
20211	payment	2133	2133	1874	1	1	224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TaXxo8eXpayuyguvoXNG6wqzGD7idg7A4BTWjmKqBczEpi75
20212	payment	2134	2134	1874	1	1	199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHeyBvpN4cFb4SPeRfohu59xnxuyW9Ck4FcvFNGtQC3r1Zkc5
20213	payment	2134	2134	1874	1	1	200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYLDmnauwcp2qzVa4gF72W7BJT7q6HpYLa559QbzBkcbTDEJ8
20214	payment	2133	2133	1874	1	1	225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpo8aPrASSXZ35a249pLeChnXQ1urixQphzrGejiA9ioG4XSrW
20220	payment	2133	2133	1874	1	1	227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAjgpTSc6dCoJpsT3CQa9VTEcM4KgjmfPHKC9AwYw1JJfTVAb
20224	payment	1397	1397	1678	1	1	9058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3q1HW1Zw7mTsbiL2AqdJLC8fNpRaQnRuK5K2q2DdKKFhuTfE
20225	payment	2134	2134	1874	1	1	204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjSJ7Gb8UdNyMajwPePu1eRcguY4FBAxCGCyQ54BPgHqfJ4mn
20226	payment	2133	2133	1874	1	1	229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJe4qLyvsf5KgM1T1uUfUBXCXKeNKK1oBZvSeqWB5WDABYwqj
20236	payment	1397	1397	1678	1	1	9062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1o7CjhD1DjxQhkSWJqwmVMC9qNW7cPfwV9LLFsU7vdm3eA74Q
20237	payment	2134	2134	1874	1	1	208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrewR1L4Uht8u2iLVq9aEh1FVfopfpv6tBRKedsQJQmsjEnWp2
20250	payment	1397	1397	1678	1	1	9067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQXQVro1cRGQiNqbN4zmVxoENfBwcyYLGpM7WqnrNrKmApTBv
20251	payment	2134	2134	1874	1	1	213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAc9KXoFVM1vG9fHpmMR8c1p8njUXXivnijKt1QfJDwGKytWj
20252	payment	2133	2133	1874	1	1	237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcadEWGkkRdeVGYCy6XUHLRBxEmkwpjpCdo3x2zqfamH3YgMSt
20259	payment	1397	1397	1678	1	1	9070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pUBcWikFB78MvwZtKZHagGynu4PpAxYTVUHAK9C4McXZTKmr
20260	payment	1397	1397	1678	1	1	9071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKk5cYs8mzxp1gj8BGW5EwNUhUt7Jz5LUxfKv3exFB2c73XYLw
20261	payment	2134	2134	1874	1	1	216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FgfF5TCHDm5YGfZ8g5KhUn9PqLUyg9xryuEsNGU9iQt84FKV
20262	payment	2133	2133	1874	1	1	240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikSgg6F1rXQbABQUYKWp5G2TJ4QkVuQGRw4sn9P6AGQEPTCA6
20263	payment	2133	2133	1874	1	1	241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkWFCD5SKGGKqYKDpTq7xWX53iwJMMxemzUCSxyzcdoEagWJr
20264	payment	2134	2134	1874	1	1	217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8U7SnJZWz6p5s1aNRi9jqHUNbp8ukD1wn7AMcfAib1zQz7zD
20286	payment	1397	1397	1678	1	1	9079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeYiKXu24v24ejC7UDCNus5eMCobWbKdSmGXf92xXs39gHxGt
20287	payment	2134	2134	1874	1	1	225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZxJuL6khrYHa71R65aAcfx3NocAMDZNdJkDgRDeAYApCHTM9
20288	payment	2133	2133	1874	1	1	249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28Xb6PmghUci1Xydmj4jG3tiaCQ6N9c6iN3P5njRPxP8UDp72
20295	payment	1397	1397	1678	1	1	9082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHR4gNRRRJWYtHj2WfMT4tyBKSdJCk2zaqCHz74cs8boRNRHiX
20296	payment	2133	2133	1874	1	1	252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXPGHkqZUkEsEBoPnQoHS4WgVYCopW3sKrafLDmYogNXJxDMb
20194	payment	2133	2133	1874	1	1	218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNsyt2iFTkoh8JcgAPegHyS78e2RvJqjhck58r4Yivnz3uGDH
20195	payment	2134	2134	1874	1	1	194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UAM5DYWkBMNSheb5n8kXV7qXTV2HjVRcNCz4q5vCmQDipLmc
20196	payment	2133	2133	1874	1	1	219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTyo6AsvJ2KDopTn11SAY8fPrAXigcCnquKHs2AJ4FMprgrHj
20197	payment	2134	2134	1874	1	1	195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmaVarfG7KiMrodsppAfEyC1cfmhghaB4Z1B6NcVjBrqEvnLZm
20198	payment	1397	1397	1678	1	1	9049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuPzLexnC7WPF6pgCLumAnsKsjXhccui6gycHnaxWk75pFLvYz
20199	payment	2133	2133	1874	1	1	220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBYK7nms3pqnFR2nKiHz4etVoJ9kjwcycTig4uVHVWbj1k1mt
20206	payment	1397	1397	1678	1	1	9052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXrgycj3gxXiGFyi5gcWLBt7djLJJ73bA723P7oQp9UktearK
20207	payment	2134	2134	1874	1	1	198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfYt44MQCTJYaHiEir1jQ6nEtpiBQXq4yXx8puWTJvhaY3tQr
20208	payment	2133	2133	1874	1	1	223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiX48aSzTi3mcM3hSheYXe4vKoN9qCi2tdZVMVacHMiMDtFu46
20215	payment	1397	1397	1678	1	1	9055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xi5q68AZGdtXAuSgTYCDvuu7NZ5QZEBsgwo97PMMHfhnpczi
20216	payment	1397	1397	1678	1	1	9056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWusJR3oR7pevmM7wj82Ubftsu6fnW2TB9m4eCbWYNLQG7iu32
20217	payment	2133	2133	1874	1	1	226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8Q1e2oq7rzs4smEnVY65wrzZwdoZ7nYrRNpsZZSCuWw9foNV
20218	payment	2134	2134	1874	1	1	201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6E5KWs4tuucwxxCw5zLCKJPwh9XKBDZ7PDvFZXidEXuRQhpjM
20219	payment	2134	2134	1874	1	1	202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnxcphcwuKPuVtCzfFHknZDJMQjgwHt6J2wPTvswa2YW6kjwS
20221	payment	1397	1397	1678	1	1	9057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEN9DqrzmWx9xFNooq7C9NUZ2KG9EJ2WKmQXqyDUWPfU6bXFT
20222	payment	2134	2134	1874	1	1	203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvr5U6P2bX8BZ3NWLi33ocnQmz6mAFRh4pjFs5bXk7Qt4Qx94f
20223	payment	2133	2133	1874	1	1	228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcHjVTDrnCGJmwAT3vMp1m9gdfpXW6xb6qsJoErNbPusApn1v
20227	payment	1397	1397	1678	1	1	9059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBM5bqx6nHmmW8SuLLrbWdXUSRMRdCEt5YcEATopC9PArvnes
20228	payment	1397	1397	1678	1	1	9060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UB81Gavzn8nX47ScRLuf2yq45oZyQS11YstZU3KMLbSzWkET
20229	payment	2133	2133	1874	1	1	230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSqKuvmuyQDwDuB1tUYpCiSZFCCMDbvsop7ZQsYZR8WNJvtyf
20230	payment	2133	2133	1874	1	1	231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYHL3X41XQRF9eASDG1VjaJRLNUAC4EhVLsr3Mk3e9H81p4P8
20231	payment	2134	2134	1874	1	1	205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVC5cn2WHdZMmWurcsghaJ2arm9Hv7qP9fZGKM14qWzrqdNCL
20232	payment	2134	2134	1874	1	1	206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8CAjmtvHgMiHFBzEcrVfngsTBDuQPfpm8ur9gcEpkroSBqEg
20233	payment	1397	1397	1678	1	1	9061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvhEtjpWciXRhwAKFCvW5dzzGHjDHNvqdntLxebyEp42CxdeB
20234	payment	2134	2134	1874	1	1	207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiAxLKg1Ady7hzP7eMTyWtgShdD4bkctQZvwgTPpoZ2bJrcJ1
20235	payment	2133	2133	1874	1	1	232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhJ7Po4CLf2D4BMRNgczD8RJMY1498Ce3ZCPujH53qaHyuq7s
20238	payment	1397	1397	1678	1	1	9063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYpDKj7GCfsrc3yQuw6ZN8jBKz6PvdavdPQvFGqoHG9kxURWM
20239	payment	1397	1397	1678	1	1	9064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH6iKB5gJNK6WEfvK38MY7kc9Skk7Pg7KzWTKVhqdtXZtYbxy
20240	payment	1397	1397	1678	1	1	9065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5qxzFSsfSegg2hai7GHjxE5FStzYuSVAqnvpiT9G9nL9pSSi
20241	payment	2134	2134	1874	1	1	209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPaqMRqbgtqsGC6Qzb3Dq51H9FvimNubVD9wb4Ph5Fgw7n9CA
20242	payment	2134	2134	1874	1	1	210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8jaFKWDxcinGSmfHNrMq4x15NAUefu3CzczTthb5HsdJ2zuc
20243	payment	2133	2133	1874	1	1	233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNdXx8w7ZPcsasT6TWFRQjepqRCgBqfeK4ad25r8K1UQ7HHBV
20244	payment	2133	2133	1874	1	1	234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFD4PxC8dgxUjQxKRR5qTcf78Nnk5pNtsiVRpnycCh7y5H7JMd
20245	payment	2133	2133	1874	1	1	235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWdtb3hz1VVQrAWQcBaHvXVaWwswSUxF3CAB29h7R8Jaykr369
20246	payment	2134	2134	1874	1	1	211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7y5nvzfepvcWLQezbQq7QriVQnz6LUpBWPvNfWfx3XJAebcq
20253	payment	1397	1397	1678	1	1	9068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKQUxjPbNhyCJFmExQ6Uxhawk9SfXRbU3nmDjQKDGVuktwLiy
20254	payment	2134	2134	1874	1	1	214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANjhp9PKHXpmXgPFgLgd1WBeMWQniR5Sn4AziHjB2XJG971Gd
20255	payment	2133	2133	1874	1	1	238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyL2H9FTrQcatiTVdcPZ2JCgtSKX4eCbSSixkWPmxPr4qZHTcj
20256	payment	1397	1397	1678	1	1	9069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9AMqEjh1oezmvkmBTZWrf1ofcwUBtmoUirSFprFioTFp8cXB
20257	payment	2134	2134	1874	1	1	215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRYy2toNYVZu5WEBLzKdS6wAAGfdvWkv5UsKUJoZsmZxVgsVa
20258	payment	2133	2133	1874	1	1	239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNVHreTBtHcAUKRfKEdauQdmiCMDEfJiUVuiXyo192NLCM5mK
20277	payment	1397	1397	1678	1	1	9076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmfQXbbKZUDBW4FeD9vMHYSCch2NFH68oV35YkHzyysqbA5qj4
20278	payment	1397	1397	1678	1	1	9077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyY281GPUs78CAK9C14aFX2T6usxKLTH2GKVvw6ynG5CUbH8Z5
20279	payment	2133	2133	1874	1	1	246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMLSkeuoHuZv8tM17t6Gf7t3JLsXdo6MPuVaPvDeUSvEQ6xk7
20280	payment	2133	2133	1874	1	1	247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxX7deSGN8wfpmfZPc7rZ9itnCwBTV9f8KpQcKe9wshFPWkzJB
20281	payment	2134	2134	1874	1	1	222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxj6DuBborskvtb5MhJ43ngG9WvsuqBiVa6VtY6hMhNiJUn27q
20282	payment	2134	2134	1874	1	1	223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQhJfTcP39hEXEgxdLnvatAHg2z5dcaLhMz58PnoZdSqKgzxf
20292	payment	1397	1397	1678	1	1	9081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpT5xcVsD4wcph8CFcKzRLmMMuA78Z5zADr1Qdij92FcBaQHLy
20293	payment	2133	2133	1874	1	1	251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYk8oJ62nbVTWTtxaPytjthr4cHezndFrNCezEQA7s21efMJA
20294	payment	2134	2134	1874	1	1	227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAkmgmsMgAupJ4uMg9aM4TAqr9RNK5ueqMuG3NqRs7vYM7ep3
20304	payment	1397	1397	1678	1	1	9085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaELQYjdEXrtWrxhyrArmXRzc2a1TKUCkJvgwRVuNKXvRCHmFGd
20305	payment	2134	2134	1874	1	1	231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvktZpaumzSFFm5Kj2Wf9aNc9w4z5gvA7jCeyzB75VhU4Z7GKW
20306	payment	2133	2133	1874	1	1	255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTeUPVAjSsAs6vb2P9tYojCZCqMPZSUWMUfAAHhDkHngRhiCX
20313	payment	1397	1397	1678	1	1	9088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJL7K9KYmeQhtpa3gGSJnYu2BMPP5PGLFBdDxf8NsrEKh2S6Vi
20314	payment	2134	2134	1874	1	1	234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzgDP6VdonrEvxkAyBduXbxh4EsWok8FUBeLqeKNhj5LknNKg
20315	payment	2133	2133	1874	1	1	258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvSEdWdV5SfaEd2Kvnt9UJxCNxh1vLyZEVwfTG6e56ZhpQuqd
20338	payment	1397	1397	1678	1	1	9096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVkWME6o7S8ib8mAUHw2aMsQjsVkaCgtW5n3VtRb4pSmju3BF
20339	payment	2133	2133	1874	1	1	266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWkmQVcfhgdGwZoDMgaqrfdsPyofMxze6ckWRRLyGy9FkPfMp
20340	payment	2134	2134	1874	1	1	242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJaqSL4HEX9w8VkWVE3oud1Ft4rodXhrkJb8KPexPJP3sFaKqL
20350	payment	1397	1397	1678	1	1	9100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdZTjW3NqGSRTJrGtKVt5SBjiHgrVFkvwfsssCh91jPRMSNjo
20351	payment	2133	2133	1874	1	1	270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQf2b2UhjzmzS1j989SPCwZ41zuwY25ALhwPZ24hF5962c4hw
20352	payment	2134	2134	1874	1	1	246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNeH6SGXbtkHcv9c6Ub8UKxdppM2iiidGtQsgNfWNpYCjmNqM1
20362	payment	1397	1397	1678	1	1	9104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEa6JYfLjmncYZgoUV3U8ZE4nwqhi9up4kEjsPqesJzJEaEGn9
20363	payment	2134	2134	1874	1	1	250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnMRvBDFCeHyLqTpLAUBcnnnrvVj2uXJrj2miWUjbMk5JK1i8
20364	payment	2133	2133	1874	1	1	274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLc9WWCf3zdeFjYgrCrW58KwgDPZyCiUCDe1nYNanagQ1oSXW
20374	payment	1397	1397	1678	1	1	9108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjr5d2XVPTnM6dAXhEXcpoDoQmYswmrhohct28AYpei4xumXa
20375	payment	2134	2134	1874	1	1	254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYasiLKPFbfTnLysRc7KyVfwmVNH7WadPr1tMBkpXj3CyKHjBVF
20376	payment	2133	2133	1874	1	1	278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nHTmsVd7nUf5vXyWAnjB5yMJ4rjaTn3fg6SmJVgKPvPiqM9i
20383	payment	1397	1397	1678	1	1	9111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZeBQpeAMSMW2Rum6cZcMCCU1JFF2uKH8YAuUZmkhJrw1PrxxL
20384	payment	1397	1397	1678	1	1	9112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPPBdhJvimSs1UjsAsg1T46xjbF77yMgUckXumCzqDxb3Kfi4
20385	payment	1397	1397	1678	1	1	9113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWq7mvNznrgk7q7VNifod7ftpmP8gzFjrwRhRF3XC77xZfHTzF
20386	payment	1726	1726	2139	1	1	8169	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzKq7CdEz4YmmT7QnJjn3j5Kz3NSZaBaVAJvfC6YkJ67Pkk3P9
20387	payment	2133	2133	1874	1	1	281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwh1i1PDF1GfWJVeFBthujr7TYY1nchHpLW9zahyf8dX2c2v9
20388	payment	2133	2133	1874	1	1	282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgR6MefBEAt6DszU56GRkXGQuc1HnvGZwfFCE6nTQm9GKXWX24
20389	payment	2133	2133	1874	1	1	283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsxGi6uhvdP8PJcbTFCDSdbqxTbYfYbBoSw9yNmNc83X8QKUg
20390	payment	2134	2134	1874	1	1	257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVrXonq9JPt5rxxM3YqAXFncoE5GCQgcmepHJMm9PooQMGK9P7
20276	payment	2133	2133	1874	1	1	245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHB13UY37b78dMMQ7b6aCQ5QpPgX2ZuS8MHq7Pucrx11MS3xPD
20283	payment	1397	1397	1678	1	1	9078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRvPeqBTSXVX24M6a1isK8CQDsUej1xPr47Nc2wob2FmfGuH3k
20284	payment	2133	2133	1874	1	1	248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdJtShnJTN8shx1mKarAoimhqaXEKAxYPgdyhLe86DL15CZpz
20285	payment	2134	2134	1874	1	1	224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbuYCJJZipVxz4fVwAWHAiBpNSVRMbsDs7aSBxmkiaLDLKfXo
20307	payment	1397	1397	1678	1	1	9086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjnah1VgkP6HAf5CkUciH5ZsvZTXCyWWFh2zBfnfCNg7XKSoS
20308	payment	1397	1397	1678	1	1	9087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLbLtQ7NxLeLBsNC4mmE1Ry5ZUtiBMKUaKTEiEYoX75fpNJgTJ
20309	payment	2133	2133	1874	1	1	256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhGDWvkDGc7WN63LvQRzAN69jt6jExDUGnQsigG6ZjNkRa4tU
20310	payment	2133	2133	1874	1	1	257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMZTgDtJCqErW8npaFJgdM8EZKRSLXynbiKofDuCnRhnmSWc9
20311	payment	2134	2134	1874	1	1	232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZndH13nzEzWpcFbvSHZibXb6hbd9EvB5wsaAzfF35QUYbBBBVE
20312	payment	2134	2134	1874	1	1	233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJsj6sKDVWrhim3TW7wLM3qGqShzdksCsnJd9tAm2epJNXpge
20319	payment	1397	1397	1678	1	1	9090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDAG7mW1SF8WKXS65ZtuQhoDabFpmMgERvri6D8d9pNBguiu8
20320	payment	2134	2134	1874	1	1	236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4vSzLw4nbYkpBnmfHaM3taxcFa6Rq2PSpsRD921k1QyEMnuE
20321	payment	2133	2133	1874	1	1	260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoUAN788neZ8z5gpormAECm8657PcD3wxhSgsn9M8v5tXmdgN
20322	payment	1397	1397	1678	1	1	9091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgnzM7k9XfCdGqrpCcvrvQPi9UoEjGYCQAgF2x3hPArA2EnsK
20323	payment	1397	1397	1678	1	1	9092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoa5AKacxtaf7a3VGzZkp5bjrJDxw43kJ6UySRTFpkJW4UQxjs
20324	payment	1397	1397	1678	1	1	9093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYooaqpcWjWSVGUHDromVCLHL2w98BoWe2jwmPYKbe82AuHF4vZ
20325	payment	1397	1397	1678	1	1	9094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxeN1cLVuw8HNRn5MDkRk8jYKFGMM2XE9k4PB3kxcVszPP576
20326	payment	1397	1397	1678	1	1	9095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRvd3Ej7fAR4pepDV2hngcLNsP4wiUwL639Ke5XyaVBBcLkkP
20327	payment	2134	2134	1874	1	1	237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMtHEjZnMeL3zT8RBBadTcwRHAi1VGct4WY9e7SfwPM8UJQ9L
20328	payment	112	112	1821	1	1	4	186000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9sjdwzdfUBHBECah7nA7E2mbxz3312CmZNRD25hXBRHDLqq82
20329	payment	2134	2134	1874	1	1	238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8Q9ZN6FgcG4jnvoSX92FwJS43JnapBgJTtYp4aTs4iVU8D5Q
20330	payment	2134	2134	1874	1	1	239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UVFCCG3e4PNeKU5EgY5WYGwAKHrE9cL3oCeLUV1DqKSk7YXm
20331	payment	2134	2134	1874	1	1	240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBodSva8pkDTxRsWXx1xXasqp7hbSoojfjMiEB9ZnzZdcYxKT
20332	payment	2134	2134	1874	1	1	241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvaTmstxNi8ArDdaR5DmqPju1PnMrttxXBLfxikQKaPbiX4vAv
20333	payment	2133	2133	1874	1	1	261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgGQ74vuqvQSBmUfMB45Moh6aDTyDrXPckQGUmfZpHsGZrXcq
20334	payment	2133	2133	1874	1	1	262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWjD3gWxnRRHeCxJiPqiJh9w447LCme8NsCx7tB9PDrnSE9y5
20335	payment	2133	2133	1874	1	1	263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxteWWtQn6TrJA4MV5RUnTPk9XbbRUjGHiiUhyvnU1uNRU5Au
20336	payment	2133	2133	1874	1	1	264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6SmywtXArQub2ebBeW1NkJ42UhmEgsdgMqzaSq1osnetVkHx
20337	payment	2133	2133	1874	1	1	265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZsUVQzLYjDDKnDVZgygjtSNHE3kGV7V34UXm218jNcMxZQ6A
20344	payment	1397	1397	1678	1	1	9098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJAsGCKe3q3NWJ2943zb36EMw3LU9DEn7ckcSViq1zjRsUHfR
20345	payment	1397	1397	1678	1	1	9099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwq67W4vTSiwxG85xScaunX5rCxyAeqemof6Na1Ub6q3BjQjgR
20346	payment	2134	2134	1874	1	1	244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcrMy4x2CtsMRYMMmxKanxwnoFq7PXRvgDZ57houa7gXwjVwV
20347	payment	2133	2133	1874	1	1	268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAzPyf2KgCUWVERcCrjN9RHrAexhYJKqMs3rRCMLu5y1rRzRn
20348	payment	2133	2133	1874	1	1	269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1SBiWdu3wnQ57d6cHRpkvmEUaFUhQUVLsKPHStSRXdDYpsCU
20349	payment	2134	2134	1874	1	1	245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLsqydCJMnjsjZvvyZTy1JR6cCULyYLbM8xs15v33LuaiaFDE
20356	payment	1397	1397	1678	1	1	9102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVgSYTUvgSorfrzsHJk7Q1NWMURo5iYJRpPrf3ZwA2R7R88nF
20357	payment	1397	1397	1678	1	1	9103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxj4zyh1jQeaL8GDKsEVijExmVRULAX6dBnPE7psBeRZVyibL2
20358	payment	2134	2134	1874	1	1	248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzAtLRmD3o5QNR3TeZ95tFQmSBTUbwBSKEcRMD8FAYz6de7XA
20297	payment	2134	2134	1874	1	1	228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRyaM5aq7wo3gFhB9ihvifQHRKEeEnMSNvDr38iNRQ4KnPkXh
20371	payment	1397	1397	1678	1	1	9107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJm18Lj5aXGcSQayVNvtpL8UvD2YXYGnJXyaMZqqxGgz9CuP15
20372	payment	2134	2134	1874	1	1	253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypiTiy9ED5XqeDvMCoRcTRPULg9wfPVEF6hSySQ9WnHbnwmDn
20373	payment	2133	2133	1874	1	1	277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yw3jzqXQ5fHWWTze3mRS3rAkU4qMHVhJaJ9JJ5mNEFRpN4N3
20445	payment	1397	1397	1678	1	1	9130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4TUcZZAZQxKFX89DtYknGKi5CF8RjByUpkbajphkJPN79sT1
20446	payment	2134	2134	1874	1	1	275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8VpNp7o2spYvXC5Mp655V91sh29aVQk5XCdpGzAip1g1ikwS
20447	payment	2133	2133	1874	1	1	299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ApqZY5VHS9c23pjghyVf6iFnYpQEgmP6ANvSWA8QrXXNcyhH
20475	payment	1397	1397	1678	1	1	9139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzQ7cLnFgmqbseqBvHjtDKunwXSKDVLRLBCfazvhjCPKD5sdM
20476	payment	2133	2133	1874	1	1	308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsyUnR1qPQBk38Y4soLgM1wdMrqUxoHgQfH6EZL9VVirDMerN
20477	payment	2134	2134	1874	1	1	284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3NZcdYRhajiBpF2bwrQntVe2QxDemxBCAbwhM6ziGg2tqr8b
20499	payment	2133	2133	1874	1	1	314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7q8iYu7r4Y6tSrWgU5UGQcBegAESeZkQSxCJ69G4SHfCpGA6
20500	payment	2133	2133	1874	1	1	315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8sQ9NqdqeRG4KtjxzYRiQGEJ3oztRhkAkWD3MPbGZeubjVypg
20511	payment	1397	1397	1678	1	1	9150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4ahmaKKnB7Xn1rp63vzb26d6SfbQpx5qPePFFfQNcjyimS4u
20512	payment	2133	2133	1874	1	1	319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BLHwM4gX3kNanRR85kM6XGNxLgug8uk9B8eHxwMTZHnMzsAx
20513	payment	2134	2134	1874	1	1	295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAWdv5kbyB49RTPDFbpCtsZp9gaq1k7qzYeiWXKLR6jHjCu7F
20528	payment	1397	1397	1678	1	1	9155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKiaY6BQYYhGyxX7ADg1NVfAyMHddyqjrBSip5QvEe4UMPtD6
20529	payment	2133	2133	1874	1	1	324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyxAbJQgecz8Mb5RYWa6yejtHueHHyajmZoFpi8c4c93EDsYk
20530	payment	2134	2134	1874	1	1	300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR43Uz47fJrggyuXeqntZurHBwNbjPKgpNiAfJ4MRJifcz4eha
20556	payment	2133	2133	1874	1	1	331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuwaBXbnHGzbop84SFU66y53P4d93dAthRTgwSD1ks9VhfRH1
20557	payment	2133	2133	1874	1	1	332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAErFfzqeZcu33HWDuuBLiPVpYPZQ4KQftqH9w8GBBAbNRUYH
20578	payment	1397	1397	1678	1	1	9170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpfuh8XttRU5RsQTw9gFi49d9CmHwbkdDDV41jTFvqYz7Eijts
20579	payment	2134	2134	1874	1	1	315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsgxbqTqd1Qqf3AXKVpt6JGnyXnMB4K1kaSBhfax513c9JKiX
20580	payment	2133	2133	1874	1	1	338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ33Z7hrJUfUhCrnVi7G8UsZRTKK7SJw4rgYegcL3nM6YnfVz5
20612	payment	1397	1397	1678	1	1	9180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnahWxq786AxF7bMUFX8X8mz3R3QKZ5BCRXh44HraW8qHyu77
20613	payment	1397	1397	1678	1	1	9181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9mhQm1jMvtsNkCocJq5PXzzZ6g2WVx7y3BswrdR34bUiRZ8L
20614	payment	2133	2133	1874	1	1	349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oKpQ4pMKd3qqzgYKBP2PtLpdNQ4skoXpehQRuEjRVEy5WyrD
20615	payment	2132	2132	1874	1	1	80	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvubpedQKdeSm2fox6qKzRDbX7S8xvZp49h4XSXxxNn7ntKXn
20616	payment	2133	2133	1874	1	1	350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1eW5d3s2FLPZhbLtm6vQQQHGvm2JDY3Mox1PL6UR125jSYUT
20617	payment	2134	2134	1874	1	1	325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8Q17TUQfR7Fg745UKJbrAtuzTJpKUdFXGhQqxg7nPnp1tmTE
20618	payment	2134	2134	1874	1	1	326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahw6eZrFCJGHmzYzBWtcqM8aHnoujJiVH2TXJSEVo6w5CohU1
20626	payment	1397	1397	1678	1	1	9184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBxLJakGuxua91HtKKw13exVAXsTPD8VMuBtGT1iLsCSijgGR
20627	payment	1397	1397	1678	1	1	9185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52yvx6YUzZ4Faif8P6xAPz88963YRCDDZpDKBDXYvLj7bNvoZ
20628	payment	2134	2134	1874	1	1	329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ287T3Sip2uzsu9DMzW5WJnQ6gqPHMNFGNNMD2woe4moU2bBC8
20629	payment	2134	2134	1874	1	1	330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSLSH5qkKKht1RbAL9atCZ2hgNGy5ZbvHjKqJwWL65EyMPpbg
20630	payment	2133	2133	1874	1	1	353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiHF5r2vdrzPjN6cdJtdt9SM3WHy8icca5BAvGo7tY6KGRLyU
20631	payment	2133	2133	1874	1	1	354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwokrTCv6vJuPoFBg8xyZ26Qmgx5kKHSFpBiAk7JT4e6yV8ht
20655	payment	1397	1397	1678	1	1	9193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nNYoLjSJjD4U4P9GsTKAvBpenGUgiiNuRrUjPgsBSQkZufcu
20656	payment	2132	2132	1874	1	1	84	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SBPqtWfez5biM1rRLygFtvXL5yrmErtQ2ihyzLCH2USmso9D
20343	payment	2133	2133	1874	1	1	267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS3nVqFaW2ymLT88wpSNokMKSzh4xVJyw9JbWigpuhddo4BUw
20353	payment	1397	1397	1678	1	1	9101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbq48KqCUZEFDL3xphmRNRXe5mnDuHdKSCwiDsJkP9JYN4gAv
20354	payment	2133	2133	1874	1	1	271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTa9oAEaV1vUJJNAJGDotAFR3P8dKNUcNNdwUMqfn3bCDu4Pu
20355	payment	2134	2134	1874	1	1	247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQswNUJaZFfYskYRua1XMtaJxTUcybnjYuEa59x5gyDbeXMF2h
20365	payment	1397	1397	1678	1	1	9105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xSP26o8bv5CzM3vq3KpmKa2cmjb7qqG9wP7ZK7kBsv6KbKd8
20366	payment	2134	2134	1874	1	1	251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohTZuZDRR9YUq5jBoWniM6sXtUj7aSbbTpgRtC8J2Qta2ugdf
20367	payment	2133	2133	1874	1	1	275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5DLq2ovZeMXNaf8G1CazTQSkJZQLS16JPeEtZCPe3oGnjXEB
20377	payment	1397	1397	1678	1	1	9109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzq6G9LScc84d5JbUnTDgPQKXiocAQheFvvrTmGSdUmATHHtP
20378	payment	2134	2134	1874	1	1	255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQBhD4uxLoaM6bWXR5uZbgHT657rMjy4PEycHpsEFwWqWF3LY
20379	payment	2133	2133	1874	1	1	279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bjRDnqwnpV8dJKnGKf2VbCPvfs1AzGN9i5BLWRtqRnX9BvaV
20393	payment	1397	1397	1678	1	1	9114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qDGCtCUhPCuGBwKWPPBs2BQmXsDiR3m393ra4fZdkqm3gbBa
20394	payment	1397	1397	1678	1	1	9115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSwgd8k7C6JpeQPiVpGefQ7qz459G2V6HEpybxvcUYFCrn1MY
20395	payment	1397	1397	1678	1	1	9116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXaGwSWg9193YD8eoNNrNRyNg73VYLZfqESY522Crcaowrt2T
20396	payment	2132	2132	1874	1	1	60	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhdHDkfvF3Qw56hcX53VYLyWqAKb4BxbNC1L7mxtBVa12VrBt
20397	payment	2134	2134	1874	1	1	259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXt3uZ9b1duUHs6qVXspQ2jncuXiPoao87bLhcZTNeABVY77CY
20398	payment	2134	2134	1874	1	1	260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rCREEMagpJHXXL4pLUrUtMvvWccaEtc1ozqBDyzpqkY1xJF1
20399	payment	2134	2134	1874	1	1	261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVUTcDCeXMKuNL3cnDDP8wfVJk5TDspjazbNZesPCCKeRQiJY
20400	payment	2133	2133	1874	1	1	284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHUCspXrJQcGg6FoKzDseRJwV9DGtDpQmmtdFAwB6NcE5zdz6
20401	payment	2133	2133	1874	1	1	285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxALiGAiQkmPCjTvRTVrfAHRrHdTwfwvXDxLujnvjLPQoUjRB
20455	payment	1397	1397	1678	1	1	9133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAipCUFmBEQJ63Qm4aXZ5yooyiK583QYZ8RKD3fhfSEKZKdozX
20456	payment	2133	2133	1874	1	1	302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvy1sri36qeUJyWEPd87mP1uS11QR1MVyzg4tht6i9TkuuRSyn
20457	payment	2134	2134	1874	1	1	278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoadKjdpgXqHAqaLsajPFJvNBpBgyr4xHHhVYUbcxGuS6fYU2n
20518	payment	1397	1397	1678	1	1	9152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG412ir56K5kSHUWZ6bck7GFqdZBWEUuYRWgdckD3iP56UQr6K
20519	payment	2134	2134	1874	1	1	297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoR2XVbzmyzj2bzhoPCV8AVCSp4wFNhvKRJssA7kw3vZTQBgeT
20520	payment	2133	2133	1874	1	1	321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTg9eQLnAcf5aM68ny1pnXLXFwpEmvSpABdwQmREJNVSoeq4p
20531	payment	1397	1397	1678	1	1	9156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1tpEpWZtrSNo47zar5X6grKKNBnPRRgQf59iirX8YzETS4v8
20532	payment	1397	1397	1678	1	1	9157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbS96NWc8xSzWNCeRSLr9vPGHo3rsB9F2Z3qpjFyXnZ8QSD61
20533	payment	2134	2134	1874	1	1	301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1meWZBLRt8ytLrmQdvAAAT983cbVk8q99ytu3uQbwEoAyNLST
20534	payment	2134	2134	1874	1	1	302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17USSJAVMPn1uqBKUXKSVTFW8uXDddaU9yEJvW2ewoG27dFVd
20535	payment	2133	2133	1874	1	1	325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPrrbRfZ5MqY6pGagvHdSuDN11ccDdW4kS88A1J17DzNw62Ng
20536	payment	2133	2133	1874	1	1	326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHazZK1YAYmp3uW3br4qUndMeT6ENtjLk8qX8GXxUensDtDN1
20541	payment	1397	1397	1678	1	1	9159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ58yB4inwFySm3jmDcLBw9NBtzBYYWuB7UbtigykuX4WBVx2
20542	payment	1397	1397	1678	1	1	9160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjsi2EJbTq5daHitDJVcURCjKfCMF4JZz15FUdM6Cr33sMjtL
20543	payment	1749	1749	1950	1	1	15	1500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZava1BtMsvYqgjwDGLf37kj9pZC1N33Xs8TKCbaB2YL8mkuweZ
20544	payment	2133	2133	1874	1	1	328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdLaxy2JrjtVRPzG2ZienDXYRpBmZKcRMPAPpR2nyDrahrpDtA
20545	payment	2133	2133	1874	1	1	329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoGPSa1EceccomxMXkwvcAUUsf2m8SpUKmPyao1aeMoHV39Bt
20546	payment	2134	2134	1874	1	1	304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgztrfuStW1mEJTUFPidWVX3F9vzj5XCeTyKeBVsc8Ec7EWrsd
20547	payment	2134	2134	1874	1	1	305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vzuYsWpG3CRqHGk8S544Xmq6zGVkNUuEsRaY8Bh6ke4XiDKr
20359	payment	2134	2134	1874	1	1	249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxH5SDjBrnDKNcmdK19nCHvR6QG5NXyWvNXokHFfiYZQfxB1C
20360	payment	2133	2133	1874	1	1	272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHJMB1ssdYaWTyYbR9jy6razHtPXyGGTRTZ9yRZVPFCAP4fJN
20361	payment	2133	2133	1874	1	1	273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACbumf1tHuAtuLhw9GVi3p9RYc4npqRRAt7HZTDLffhdVqEAQ
20368	payment	1397	1397	1678	1	1	9106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9muoXRHiJxSDeT8xjawpegFsGwgzCcB5AYYwEkkQogV4P8Fjr
20369	payment	2134	2134	1874	1	1	252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGfyuSkJkoeuDBaZugwHe7vEdZ6ouFSdt3BWyBToU2gzHVk3Y
20370	payment	2133	2133	1874	1	1	276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3JXQN3GQkeTvvyFp3MD6gxPC8zUdxNdh5qYefGCEEkax49Ly
20380	payment	1397	1397	1678	1	1	9110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqajQkJQ2Hex17L8UiHgA34ZH3HfURHT58nwrRqXVzzFRDqoW
20381	payment	2134	2134	1874	1	1	256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEUuuWAmxSurmJe98gK6N7RsLthCYtbCaV7iUAPiGvS2uCr3d
20382	payment	2133	2133	1874	1	1	280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvFnEkJ1oJhd5Q8hF94SJZ16qT1zGurGSGq4Vi3hgdEaZDQP3
20405	payment	1397	1397	1678	1	1	9118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijGvXrHenWrLsr2WAZCgCpKFefqs2xgCzEGZsJ9GdrSGrzbaB
20406	payment	2134	2134	1874	1	1	263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHoT66c5JHWTy9WPQxEAHrN3bBdkZ4VzWM5hqkDnNF8qsdUCL
20407	payment	2132	2132	1874	1	1	61	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpW6wEDsJtoQ6h2jSez5kNiS4yp2KzUWda2UZ9ALqGV4s8iM9u
20408	payment	2133	2133	1874	1	1	287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybpyGFgJno87Ct743Dn9rvyMaNbTmRmhpt7T9Q7npVjjx2jUB
20419	payment	1397	1397	1678	1	1	9122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpojp5f72g4UZEnNHW7gogJ67Y3AYh2f9eDGLVpVGi1nwCeELD
20420	payment	2133	2133	1874	1	1	291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAyxj8Gon9GbY51M848ygqzY5J2YBfhNbMp5zYqXgLFLi3KLi
20421	payment	2134	2134	1874	1	1	267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63DfY9gQ7tcpkuQtvT1d2YNppLGSWdhEkxVTXd53hbptR5Wyb
20422	payment	1397	1397	1678	1	1	9123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmmSyRWeDq6CxZpzFfq1i7YXjXrLTtcCjXq8E6HB3gayrCiTY
20423	payment	1397	1397	1678	1	1	9124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrMEroKunHVDqyQmmwceCmA9qNtsBkGLyeq3kPbeiDHwgmd92
20424	payment	1397	1397	1678	1	1	9125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAXXakiHo7QnNCVp8sV6e3RQ9oq7dhZRdPdoQj8zTZjGofQn8
20425	payment	1397	1397	1678	1	1	9126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4j5bddytHMiU3KycaKDCRfywH8suifNsy6XyQ5aGGxF5dUVX
20426	payment	1397	1397	1678	1	1	9127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc2UZinxGoqrZ45MJnoDsAbNDFQwjJaHmon2kLpcA7ZvxcBwp
20427	payment	2134	2134	1874	1	1	268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRDbJx35GLPhuSYPfNWAXVtSm7dqnNNX1aMXBBSR9N599srXf
20428	payment	2134	2134	1874	1	1	269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HngE6A4YcSvCaV8cNr9PsHV6bJtaHXwrcTp8kLYr7xpGTfcM
20429	payment	2134	2134	1874	1	1	270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZai8xM3UziMRSHrFrDysVP4RPKJJAsFUi5Bm2rFNeyKtvEjC9r
20430	payment	2133	2133	1874	1	1	292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHtYBegP2PnP3J1mCAQRNJRgCJMG95v9DyMGQDy9B67kgFXne
20431	payment	2133	2133	1874	1	1	293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfpDK3pfWuWVAikt5SmLsSX7KGGg5Xu2Qji5cFJZjxR1ECSrw
20432	payment	2133	2133	1874	1	1	294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6qsussNar7pk2ZsGPoiVuK1VTyJrdreMzzUn7NKMfvqSzXR5
20433	payment	2133	2133	1874	1	1	295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurdbSxwLZvZ9cZEJofbme5dmWTqRJSsCueDTaPXWy8vEfeC75
20434	payment	2133	2133	1874	1	1	296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFAcZKbcnCSJeeg8Lk26DTfYXNq4NY1RgZCmq5tkRZbtcnudW
20435	payment	2132	2132	1874	1	1	63	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2EnRhD6ruWibZnYjxrBza3BKJ4tVz6iLDga8mhMbHyyB6D1z8
20436	payment	2134	2134	1874	1	1	271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bkfEV3ewqX6V6nxCfeb7KEGbVTiVuZDKhnQzZyAGrpDz39r7
20437	payment	2134	2134	1874	1	1	272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjzTeQdqPpNrpin2Y3KrmRzjPz3gsLmxibZqSuM86TFMwBUtG
20448	payment	1397	1397	1678	1	1	9131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSv5uJgUbYWSFx2aFraRqMnvV2XSBXJ1SuRgTfx9Yp4WkhRykz
20449	payment	2132	2132	1874	1	1	65	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZCWvTDHNrthjmpiVGyAZ5qMBHXbstvtQ9pe8ThZy4KBv8KT3X
20450	payment	2134	2134	1874	1	1	276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo85VeZma5AD9Tn6HDGoR9gr85fQVLfjv1v7SBjwhHyaewakC7
20451	payment	2133	2133	1874	1	1	300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuiJRT8x728kqaeSaD9Dwr8NNoB4mY2tdfmSTghTWBTdsTExb
20458	payment	1397	1397	1678	1	1	9134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFHkKjMpfAyYYkzMaQck9ABvnycpNHnUSDVLzxta7U4vXtvcq
20459	payment	2133	2133	1874	1	1	303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfL5wKrT7N2R68DsLQNtvcKaWWvDTiM7Tg11RLkWbCJoSa6iT
20391	payment	2132	2132	1874	1	1	59	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9zVKXzH2CATBmwPomK1Hu4dbsvXQRbuPy81wZzpqHsyEPaL2
20392	payment	2134	2134	1874	1	1	258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NQ3bb8UoMMoX7zVGX9zNK1FCHPFgSw5XQFkFAGXTfogNF5EA
20402	payment	1397	1397	1678	1	1	9117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzG2HpPE7bi3RJU8TXmhCiArDZTmvoJBUxr3fc6oi3fiPukz8s
20403	payment	2133	2133	1874	1	1	286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvg71T44AArLUk6F1WGvBGmfEoaS5UjHz9vtyesY6VME9JntE
20404	payment	2134	2134	1874	1	1	262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHB1Sp839hDCDkrnxzpXWAUtS5y23zAa9pVCQrmwxU3ohpsMB
20409	payment	1397	1397	1678	1	1	9119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHoSxMspcZhSJYCdDdmQBctXTwTexBf4AqcsGYdmgHmqGMNyV
20410	payment	1397	1397	1678	1	1	9120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFzQRbNX3bYAQ3uZnvgc32XNGAwkKEyUJ9eGmg4mQ88fFfHDL
20411	payment	1397	1397	1678	1	1	9121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqHN77inRT7W1ggFA489fmxmMqejYN2sSYwFPcWGSysnhmsRj
20412	payment	2132	2132	1874	1	1	62	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JB4g687bp4HfAE5n3nPjiueYfPyEgKW6NRi4mQUnpaX2ZvHL
20413	payment	2134	2134	1874	1	1	264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGan98Wa6fTopHqCTg4cMajqVpvURUgzHQxLraKQ5Hmu8UZEQH
20414	payment	2134	2134	1874	1	1	265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKDtFEmynEKH8KGKLUtPL1ddtMVfEaGZLipVbfDdSUKgGmdTU
20415	payment	2133	2133	1874	1	1	288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ow6vRLzksQW46ZXtzC3c5ewqropdY7pi7rX9deX2diZyotXo
20416	payment	2133	2133	1874	1	1	289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7wWx16gHewfuzgA3U6zULXuSAkvhUMo1nTtzYAC2mLRiGqAm
20417	payment	2134	2134	1874	1	1	266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2bkdMrp5WFN5mtF2MR3T8tiPM4SrZRkWsSKhGWRdY1ufUv5e6
20418	payment	2133	2133	1874	1	1	290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLeFYUcARfVvGv72dw1kJgAubgzjwQ95YvUU8Grqd3tTGEzthy
20438	payment	1397	1397	1678	1	1	9128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdhwHctPor4L5sq2HSfPro2bpA7GNtuTKytK3stSuGq1KwaZP
20439	payment	2134	2134	1874	1	1	273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpspiyojJYUEkBB1aroxhAajxcv9kT64XDU3rH7RFN7Xvr1sa2
20440	payment	2133	2133	1874	1	1	297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHJSBNnun6fLSEevQ1FHYavkMWxpjRZDhPVhSQzRCKSSqckoL
20441	payment	2132	2132	1874	1	1	64	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLWTkoUp7EceDCNv1JrL2jqqkhJFvapC3E6b4LUEGNW1yudeT
20442	payment	1397	1397	1678	1	1	9129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUn9bFGY7JPh7ffHsyaCF5Vy7xeBXcHCycWcrrAmd6gP55ve2J
20443	payment	2134	2134	1874	1	1	274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDA6k3sKZDMNs7hBdBBh5UqW6hgBLLv1HPQzkGofQYu7Bwyc5H
20444	payment	2133	2133	1874	1	1	298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXbkJPQ76Benffen1aUbkBNHGKLjwAt1S5Xzz7gasrboWH4Be
20452	payment	1397	1397	1678	1	1	9132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7995fvzoeugnUw166w1zppyeq8csjimCqsgfPj1TSb822mM5B
20453	payment	2133	2133	1874	1	1	301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pLhj1rLueRYh1LdLZbgRPtuBGkYfzrURPvFV2zM3xii5GqMy
20454	payment	2134	2134	1874	1	1	277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYpduz8qBZLZYbYJfPyyppnLWG3EoZhhYKTFeqqzSB69tpqGi
20462	payment	1397	1397	1678	1	1	9135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhXLbEnXPvsmSiaY8zf4hycWSUD8biPiCqwqd9ngRToNPHhyp
20463	payment	1397	1397	1678	1	1	9136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BzT85UrAbixiAsksRoteFYEGfXR3tDEj3JSMBA1qXobVRQiG
20464	payment	1397	1397	1678	1	1	9137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLEA3LUW4KwN3w4tpEbnNDHQvLHTUYrfAcPzZcsxx7xjxA2dX
20465	payment	2133	2133	1874	1	1	304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eTf7BCW4DBNAv1cgGc1wQ47iCCv6KtZiMzo6CK5N7XyqC3Dt
20466	payment	2134	2134	1874	1	1	280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFA1LL3erGvd3KWVWqYgTqrRFLNDTFHhThMtEupnSPLUGHwE1s
20467	payment	2133	2133	1874	1	1	305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvb13UbSoVHiBCWi3sXm95TAjv6B6ecDgMede8yoaUAuWZZ9fZ
20468	payment	2133	2133	1874	1	1	306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfCzDvkNEU3Hzv332PfwbALXRLjy4dWBmURE1hGzigLk5vggv
20469	payment	2134	2134	1874	1	1	281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDefmHEwaDDhoqqFtb7VaUHsbz5e3ymhrSQwvFRiXevmUQa1mC
20470	payment	2134	2134	1874	1	1	282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBs1GhdnS3KXyzCvkp2a5Zybagf72gHNQc6x5WWwVTqHDs2bU
20478	payment	1397	1397	1678	1	1	9140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ428LMpYV2kpeCXrsppWQzuhiC6F6tqWa9hemSnKVUMsQjSxDD
20479	payment	1397	1397	1678	1	1	9141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BVfjCzWkxWrKEP44wLDgjdDExdFpQatsfsALwCyPk5PY14qg
20480	payment	2132	2132	1874	1	1	68	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2bEaTBfZXuiuY4jho6hxXiuF9yXRh5WLFKhRuaoy9qdPUKib
20481	payment	2133	2133	1874	1	1	309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmc9GXd7DSWzNMMaZ9Cy8rjLDGB3Ybto6FYf7cdzQAvXjpsm8J
20460	payment	2132	2132	1874	1	1	66	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56zyZJVP1aanqCRRjGKdUKpgKLheY7po3McXhPEAMrqES31Ag
20461	payment	2134	2134	1874	1	1	279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6o8fc1nxex9SrJ7oCQ8ZzvWChNGDedebMWknMT5P7VY2xRKvj
20471	payment	1397	1397	1678	1	1	9138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2X7xQVk1wXCAusoVrWbZBudtgLKipkLxvcRV9FkQes8H1haf
20472	payment	2133	2133	1874	1	1	307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaRQ8RaqYixg7SwZx2ZeaogGhGqrgn9fqBEMm7ydytrZnjjpZ
20473	payment	2134	2134	1874	1	1	283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzmyhrfk24ZS2v7qwbTH4USgxP46Rg5VW9YojcZMLYSkaNJZz
20474	payment	2132	2132	1874	1	1	67	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabP5Pf1SNWzWMZfHMmDpAd1H97PZtbS8cg1YcUHmPycZpb4ph
20485	payment	1397	1397	1678	1	1	9142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaABbH5RJe4XeJvu5PHR4im8AfEoSmqMfdBRR6a6u34qYKP32
20486	payment	2133	2133	1874	1	1	311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJAkN7gxmTf1aWPQcn9vkUcJbky2VhjoAALai4xaPVDxQ69Xb
20487	payment	2134	2134	1874	1	1	287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fWKguUZBeD3y5jZvQH4sqVQ81zDH1jujcGZiWoPKknqRjqSB
20495	payment	1397	1397	1678	1	1	9145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Bub5wWYYJcfCik1fQro9HkPWUeqpsxvV6HZLBAGhtJ2yNMMj
20496	payment	1397	1397	1678	1	1	9146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMcP93G8MbAP9i4mpKfrZRUF3bUBKS99uNLGA2VSQ8HWN3hHP
20497	payment	2134	2134	1874	1	1	290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopgNc9AmJJTRVUhJXaX8bVy6Bq1xqkGU8EqmgkznrXEUgJyad
20498	payment	2134	2134	1874	1	1	291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBrkiZfYJcGq537rj9iCcdSQ4J25JvxwchZXccMC8wNMeFhS9
20501	payment	1397	1397	1678	1	1	9147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfn7fVp25bQS6Zuqt2FpDXgndkYuffaWLFgTjEVxAJh7UeHZg
20502	payment	2133	2133	1874	1	1	316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMGCpq4yUNpERweWBvRz5GBMSJeGJEAncX9P4hPrfSZshSNj5Y
20503	payment	2134	2134	1874	1	1	292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpziSW1m6pdPhM3zrxwVekqgZhVMoKxoGKWVfoZXZJKUm8CqLX
20514	payment	1397	1397	1678	1	1	9151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHrNr9q3pyuJEgqQf7EX2LDHyTuP1kX3PMJZosVzcnxgsp12i
20515	payment	2134	2134	1874	1	1	296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX54BooChvJ4cCuF8VfXJqwH4ybX8CpizPzFUA83mceH2P1yby
20516	payment	2133	2133	1874	1	1	320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDCWa3cAayrpQp7ps7NSeGGbPxqffozuef5yhy2DjSh2CnAiTG
20517	payment	2132	2132	1874	1	1	71	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewngTqXkBLPHbwm5srkgEq5rpJQr4w7o1apCUxA1N5s6dLEf4
20524	payment	1397	1397	1678	1	1	9154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdLFaCg2g6FcNnu1dWSTn1SmZENDcydNAALXefVCaN5Lp18Yid
20525	payment	2133	2133	1874	1	1	323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWE2jxDebQy41P7N29hznCCWc7x8i3ocSFUj2gPrsU9Pn5wZHb
20526	payment	2134	2134	1874	1	1	299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKZCzjmtA9kb4FKT15bVNSr7B7ANGGkbjKyh7f7mVyNTB9WFE
20527	payment	2132	2132	1874	1	1	72	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBv6vHqvvRW4JrpNXN3hoa1Gq5mDu6C9GvK1TEBwZvRQR72q5
20537	payment	1397	1397	1678	1	1	9158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxMdjgG99GuPmKVRgg7J3qQRH3tM4kK2wvcsqtzA5VQPgbtzV
20538	payment	2133	2133	1874	1	1	327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSLXpg1D9JMPWVm5JcjY1YFUBFfJw58fkJjDveF4vTTnbBsST
20539	payment	2132	2132	1874	1	1	73	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Cp9Cb1J6s7H1N882ZRTireYrHFdiCsSicgwMK9KG8oiqJ6wt
20540	payment	2134	2134	1874	1	1	303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYAUiFv4fMcuB25kbNqv7BHbSsda8jYi3a29xwTj7zrw9nH7M
20552	payment	1397	1397	1678	1	1	9162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjDJvxty7zSeJuoMD5wWPu2EfacUs5MY5P3H4Mkoj58KxRPor
20553	payment	1397	1397	1678	1	1	9163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxff4uzXgWk4sMCRzEVh1KPZYt77wHuQEHF8LafG5A528FddX
20554	payment	2134	2134	1874	1	1	307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPbdwE3YaXtzisu4DqeQMRpEMmgo8qquMtE9DqcNV2As9By3o
20555	payment	2134	2134	1874	1	1	308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1wEWCtrQ7XCw2xa5dqWmfwym2ReqVRG5sp4oSK6yDNPE41km
20562	payment	1397	1397	1678	1	1	9165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5wN6uSgCFrCVrVdU5DooASxvCxbJLJnSLQNmbFD8CKAbCYFJ
20563	payment	1397	1397	1678	1	1	9166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgVmEfBkz61KX9YNjviz2nchc8tLdxDEaZ8VyeUwMQwhCM7av
20564	payment	1749	1749	1950	1	1	16	1500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYPx1a7zjirgqghSgr8jzgJg7Yxu9orBhomgmnK1jZH9xVfRX
20565	payment	2133	2133	1874	1	1	334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAa3bv2T5ZDQfA4DtQpAisTnYJv76uYhT6BemJ7Xe1K11WmXak
20566	payment	2133	2133	1874	1	1	335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqsKn94f89ofHgS4zv274NEHNHrGvTrtAKQ6EMuSTFV6TMotr
20567	payment	2134	2134	1874	1	1	310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbdY2YZVCSMREjbgmahu7cRw4pwJud2FoPh5Vg5ygH2eafJyJ
20482	payment	2133	2133	1874	1	1	310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihL9vFk7e7XrcJzTmVrMeoo1FR4RSAk79T19RKFm73VosWAdP
20483	payment	2134	2134	1874	1	1	285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqgZnWc7XwjtN9k1ME5sMB7WdiY2Tx1pbdLE5RFz71j4sCZiy
20484	payment	2134	2134	1874	1	1	286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNdmVcHT8Yej1a8dCmZYjGQB7kiRASwFsKtUEPZKjMDGhhSdy
20488	payment	1397	1397	1678	1	1	9143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFS271j3VvBgFa7ToXkuyaBCdogds3eUf2qpKezAhGaSWcdD4t
20489	payment	1397	1397	1678	1	1	9144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VAozp6iKuWpPUa9hptkAoMSkrq6FTUeuZhn7F1uYx5sanPwc
20490	payment	2133	2133	1874	1	1	312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaaNMfQ5YKsduiy66in52QmJ1ZEvaD1u5NJEqzpPmwZM8AXNcL
20491	payment	2134	2134	1874	1	1	288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2yWyvxPCbHJynLdzDS92JXWYZjhekuaqqQmZnnCSa9MNLHjs
20492	payment	2132	2132	1874	1	1	69	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBm9cSA1D4Fbc4yX9hpHVDZzNVSWq5DfZQDvpxK3fiyJ35n4M
20493	payment	2133	2133	1874	1	1	313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZj6F4qkNR2yxG46diDnJEKivp6vmWgMN6v2weJTCXSHApXRy
20494	payment	2134	2134	1874	1	1	289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFHGbhXaRpUSGeYd37A3Lxpu7rtJVu7fEDwvmCBkaZQk8b178
20504	payment	1397	1397	1678	1	1	9148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9g9FzQZxfic681njd2f1qrK3We6MmzYcXgjiwGFSnfXkETcTi
20505	payment	2134	2134	1874	1	1	293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65iPm7BUd4RaSEYgJ2qdtnxq8AAiKiN1jyN8v8oPtxRmmMb4v
20506	payment	2132	2132	1874	1	1	70	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa78TrKX4QvyzoAMWupPPgHz7Wcm1m3ukFtxcb2c85JqTUu1j1
20507	payment	2133	2133	1874	1	1	317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiio2LbhieoL1sNBrmizWBmptLCJGxVxcJxxozcveDuZzoGC2e
20508	payment	1397	1397	1678	1	1	9149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSZihPrX6t5qNbWMGjGTbmwBbvzsUbTaQgma9qCpFn7zAmwup
20509	payment	2133	2133	1874	1	1	318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPM9Buu6ym3YmMuzBXNE38qdQhmrm6VWsbUsSa7cVdQ6PzzJz
20510	payment	2134	2134	1874	1	1	294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa656QJM6jAyLTq253gfSpXpmmu675AsG75FEqecHUa2CP4jSS7
20521	payment	1397	1397	1678	1	1	9153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMEXRGov5jg4oVFiqna9XsZSRGpvY7gSbGPT4UeVpAnxevb8r
20522	payment	2133	2133	1874	1	1	322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw37cj1jrXpFuMEb1M26YogUuikdiCEVSwPbSuzm3qMAW5dChf
20523	payment	2134	2134	1874	1	1	298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwomxzxRXus3FyjAhvaVYSczU5wTBrxaRDw3miTVd22Y1B1N3
20569	payment	1397	1397	1678	1	1	9167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZggP3M5SsfBvRb5fhAkYbXLyL7Nvky2coKVWwpK2uXr1We7TX5
20570	payment	1397	1397	1678	1	1	9168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyAdLbz92Uu2A4kXdbVJZySD6x2QG6yMjaN9ps11ztNd5xq38
20571	payment	2133	2133	1874	1	1	336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUUEuDuWdx7jPqUUrDupphftXKCBmrPPM39dpCsFai6L1ANtC
20572	payment	2132	2132	1874	1	1	76	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkBUEwenj7UTy6DFs7A2o9QR4bGXeUXAs1ytmwNv61gW8w2BxV
20573	payment	2134	2134	1874	1	1	312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4UHVqtu1uomT4Qqq5rNNyqTMk58LoMngnkYTmn1CxdwXFfiV
20574	payment	2134	2134	1874	1	1	313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNxaQmci7tpQjpeDfb77L6ddtJqZ6WBWux5jddz2ubYTMcKG4
20575	payment	2133	2133	1874	1	1	337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jLndja8rvNPgzZrG6qWKbkJMPBmnJmZF7UqikQHJ1ZEH5SNG
20576	payment	1397	1397	1678	1	1	9169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfPjXWNqvJbfZKw1sB4eXvSH24LXuX1sHpGVg6JYdJ7gfnhus
20577	payment	2134	2134	1874	1	1	314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7QvKB3JebTmyGRYFtXdkoyA6hVd74J4sUjdU7pXV3uPi7yaK
20584	payment	1397	1397	1678	1	1	9172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T976DVwoXU5f9UWJ8sFrd137upXtgtMA5CfrJaxCJvoFUzie
20585	payment	2134	2134	1874	1	1	316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC5FjsDmdi5v4wJsKZ2fxKxpWaPRRj5bGnPTujJeEPP3oCZQ3
20586	payment	2133	2133	1874	1	1	340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXetbNE77GGCEYWS4DS9Ax7s9miiYZDB2HUGR8eP2DwLRHaPa
20587	payment	1397	1397	1678	1	1	9173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrWgZqBtpS11rKAAt8HVEUEXYzernMtV4FiHCR2qRdX3qsERb
20588	payment	2133	2133	1874	1	1	341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPqobhcpjnrAqZtVRGURJUKx8Ud162AMwVfsAFnJhN26DyRBL
20589	payment	2134	2134	1874	1	1	317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqyZTJajkJU7aKMvFXV7f7C8ZWq19KXF52AiquCAP7WwcuqPX2
20622	payment	1397	1397	1678	1	1	9183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Yr3u1sMsGJryqgdh87SScKoSs5ZhJwfKwvXFwh84dqqiH1eP
20623	payment	2132	2132	1874	1	1	81	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDfHHhWvhYBEoZFcrH8gdqto9k7gHdbe1ATjFgqvMjuBJYkmE
20624	payment	2133	2133	1874	1	1	352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7D2MmBUVMwPXXTjM7x9uHxz8G2GAJYGLDX2r3m4A5TM6Rf5r
20548	payment	1397	1397	1678	1	1	9161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEYGsSs3KaVsFrUCteSAhURYAQguNwbnuFVWRdW69vPHnwjnR
20549	payment	2134	2134	1874	1	1	306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkwpPXdnyxs2c1PLcmcip6NRnDa1WbKu9JpnKQDTxWZvWMQtH
20550	payment	2133	2133	1874	1	1	330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhbwzjuZWEg3conxtP1jCLpP7pkaendYBj42K61HQBr6r45Qt
20551	payment	2132	2132	1874	1	1	74	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEK5HvhrshFEMFE4ik4xkCTKU1Nc7mgejFGYg5f3N6e3ScjPE
20558	payment	1397	1397	1678	1	1	9164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33j6xHyM2M9k5w76bojdT5qXrkVLEVfrC3a4pB8tGzKXvh3jf
20559	payment	2134	2134	1874	1	1	309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbFUJPRZ9c4Gzo27RaSP34XNjfT4Yiaf6zSZLMaAY2cWBiETM
20560	payment	2133	2133	1874	1	1	333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZinmiDbppWYEtYnRZa1FRamzoeh4LXEV1X3L6GU2fMwUMe2hz
20561	payment	2132	2132	1874	1	1	75	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSFKeDFY1km8x4xVVWJQhbjtHhhrGoxLLq6qUP7B3G5zQhRkC
20590	payment	1397	1397	1678	1	1	9174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMETpFZDszxtJHsVtnmRCdwLBG8298NsBDr3PYVy14rtQthHT
20591	payment	1397	1397	1678	1	1	9175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAy8Tm6E2vcnhKTf8R8g5JX3QtruXWSgsPC9wx7BE7YNXbJRbj
20592	payment	1397	1397	1678	1	1	9176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQzCtonS7jcgEzcvjFqqV5qoXEtz1B8NGubnQF1yhGJn8bnpe
20593	payment	1397	1397	1678	1	1	9177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDDo62nV7ribddaVypcCog2osCjeDnsUoYMLBAMVQZQJiFjBJ
20594	payment	1397	1397	1678	1	1	9178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnpRLxjQ7df6iCmtr4AvdRq3QRUaujhn8fMYM6pkapZVCicN3N
20595	payment	1397	1397	1678	1	1	9179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87jkGxGzvbvyJzHJxA32NAgGnUSBYbBuGqM5BHtD7ndcMF23g
20596	payment	2133	2133	1874	1	1	342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgrtPx79TaRmXvQf5JHDswC5p9a7cDa6UGTf5uKQZuhY7WekT
20597	payment	2133	2133	1874	1	1	343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuSmYYo6MJaxYne6CN4PJF9XUpXyjHSnBrYbjxBnpELtyAvxh
20598	payment	2133	2133	1874	1	1	344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKsRnmzV2sF3F49qEw3Yt7FH85Li3TAHiA4uztB78NapkL2cz
20599	payment	2133	2133	1874	1	1	345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWRotSzswa3u8bKQkm9BAZkshxuaWF8JcwiehqhDWw3z3zmvp
20600	payment	2133	2133	1874	1	1	346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSshmbYsz7napJrAY3z5aZ2VK2w7PoijKyPUPoNEWRjaVDvgE1
20601	payment	2134	2134	1874	1	1	318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQYAHpHdioPmvSEHmEs1nUd8iYKuwNM1YktFEwFTWTf6pZEDe
20602	payment	2134	2134	1874	1	1	319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbHpTeMTUw4Nh2Bs9b1VpS3WhTHXgAbLP5CqdyneRTqzpGnfT
20603	payment	2134	2134	1874	1	1	320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMsHofFoTktKwyoLcYLt6aKTUHpuEx1gM7sXrrfpqLF571DQF
20604	payment	2134	2134	1874	1	1	321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahyTJGAsynPU4Jf5BasqpLH1ChJUhtKFcojBqnAnH54kBLNNQ
20605	payment	2134	2134	1874	1	1	322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyMR6V61fnDPPJGYqArkrcyAWJzMckUMyxSaPAEGJWCepyoMm
20606	payment	2134	2134	1874	1	1	323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYct85jN5KhtTjioz9R9tMCNgu7wHNotfRsDw5qS2K6WLo8UY1J
20607	payment	2134	2134	1874	1	1	324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLm1dj47czh53msMBqcQgs6Wjf1s5DcAXPrx2JFTAvjt8soRF
20608	payment	2133	2133	1874	1	1	347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ntYgAVZH2Vh6THG6VGBysXUYKx6CEopEX6w4AhEjKGRKmKpw
20609	payment	2133	2133	1874	1	1	348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGM78EA37uCZ7uefetSkSw7c1ZDwLsXHigSyQtaYSKPJaNwsM
20610	payment	2132	2132	1874	1	1	78	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6kyjHo826N8mcyA5ZNCxjnW9K4jrSpwCmhosZv3n4qH2Wv4u
20611	payment	2132	2132	1874	1	1	79	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcWRtPP9owPbmb6kXT85R3qXeGe48s3Fi37hz9w1D2x29zPoS
20639	payment	1397	1397	1678	1	1	9188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXS4D3TH8CPqq9usLveGTu7VxZVyxxEiH5b8VX9D24j871jL65
20640	payment	2134	2134	1874	1	1	333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1xSei8ktqaJ9SckmRucYQcxDHKK9jy1xghgesfKBUcaP4AeE
20641	payment	2133	2133	1874	1	1	357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkRBXYru22wHZKWS5WWrrHCUBJzfsjJ5kLMf8VWPwrNWGD7UQ
20649	payment	1397	1397	1678	1	1	9191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYboYZ9svj6KUPKLhrtKEpFk127LVUqZkhpVQrawGGbAqjLHJMh
20650	payment	2134	2134	1874	1	1	336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTAuCqnR2i1PSJbx9wwjJXQJX7G2cDgKzGeakvEr4b6pu7yti
20651	payment	2133	2133	1874	1	1	360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvKRUQk1nDkfVC7cRKePFmboPcfzKNAGoMnWcDRQmd3W5HRNr
20675	payment	1397	1397	1678	1	1	9199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTsaHVHw7TxZiECyja2scx9m5DjVGDwbjPrbSHsos5H3K5xVa
20676	payment	2133	2133	1874	1	1	368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENc26PwZ2mrji4xekMeE1m7DAkLYb5rdj98Pj6NY4PBGMDkQA
20568	payment	2134	2134	1874	1	1	311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WjBUJGRiLZNwY9KcLyPenVvrAzWrz99amyZmAYfmDBzREd6v
20581	payment	1397	1397	1678	1	1	9171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u5TtaUk92VFezjX4fCj49fz4jiARDFrk8rEjhvovss6Txh2V
20582	payment	2133	2133	1874	1	1	339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJq3JzpuZXcSDmRtYzK9ajGYnqQZfF5Y43b576gNzCZVPTpKr
20583	payment	2132	2132	1874	1	1	77	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRX9Pv9AMYbMK7zCy1mDvf3QVc6A5CAPGPaML2jMscThAbqwwy
20619	payment	1397	1397	1678	1	1	9182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa277EKWVKaLNvXBdFsRKmnTiRZ3u3DuxHBbDeeWAjvcZj2N1mo
20620	payment	2133	2133	1874	1	1	351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjB57ndbNfQmG7rgY5yBzMT2Yvr4y7ghAZmnNDdQzhoou31Ce
20621	payment	2134	2134	1874	1	1	327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySZ6eio9tBFZa7VyKNk8t6zhuca2xPpMTh48Gh6BzmWXjVfj4
20632	payment	1397	1397	1678	1	1	9186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtT5FJF8zdcZVV81QsPb92sUcXJXcvZw1GPQbwUaJEfJsmgHiW
20633	payment	2133	2133	1874	1	1	355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSdSspsaQTkKWd3tyjWhj2QXrra3ng5RTx3YjqTxcCuWkVXs7
20634	payment	2134	2134	1874	1	1	331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTC2LGqfKdnQgoPcR85yzzLxpNz1Y1sHHV9MJinjANHbeA61p5
20642	payment	1397	1397	1678	1	1	9189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5QSALcCDp1ytr852W52WkrUYAoq2ajA8VvPZjyhiergWTuGd
20643	payment	1397	1397	1678	1	1	9190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUHcD5dUqMcrexbtDSDaTgb9qKrUAbj3JBiciY9VPTzW8yYeC
20644	payment	2133	2133	1874	1	1	358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSoBA7zivwzrCv5vfwU9qEb2xZz1SEfr6ffJA8TH9TSoS4s3H
20645	payment	2133	2133	1874	1	1	359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6EaLNBWAoMByhF5NmN7CwmBeHjS8NdPUoeXupYxz5wequRB4
20646	payment	2132	2132	1874	1	1	83	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGffD9pfQKRM7JTq7X99BrgzV45ZFmLwTBCTCbR3fR43x3uzgW
20647	payment	2134	2134	1874	1	1	334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL36ywDArLdKTQy6AmdxnRSJR3gvunvU7AbPU9HKQQBjZXitc2
20648	payment	2134	2134	1874	1	1	335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudxGxzVvYs5JRDm4dYWgQLyKoygCMYaq4Hc4Wg8gDj4K7zcjK
20672	payment	1397	1397	1678	1	1	9198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFqTSKowARKnSSSJgxcBipNL66r3NvUT4MMb5NVzajbZVEyKx
20673	payment	2134	2134	1874	1	1	343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJiUCq6d5NYTk88VtkuK54NLWDTV9NscFj7dszCn3c5TeFHvf
20674	payment	2133	2133	1874	1	1	367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7ZkufAzq3gCdNptqe72hav67rvDyDaDKF7V2ww9AXp6Yacfq
20682	payment	1397	1397	1678	1	1	9201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTJPmDGQsNJD9hQfXyMre6xLB4WuJUesee1U9MZKrW7zRa6Ei
20683	payment	1397	1397	1678	1	1	9202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgzyuGoRgmSptB8AfPWcfpYy4VucTohwyGJZ5s6NQqPrLA3DH
20684	payment	2134	2134	1874	1	1	346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESrMSxq17U5ZnmwmrvmmTkLiA6pE2mrzPEArGSoPbLF2EVqxb
20685	payment	2133	2133	1874	1	1	370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4ST5rF48kDRZZjvNxZxRpMmZR7FB6sjZ13SaDYzyQXYX28E5
20686	payment	2133	2133	1874	1	1	371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwasKi6WYpeaTbvzaYVy91oDDJ3G17iNsU3sqVpjmDw1FwRCTj
20687	payment	2134	2134	1874	1	1	347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGaEFBX1kANohHukMJWDjArbncecwQXPSEBPGFxieqt46CYNFh
20625	payment	2134	2134	1874	1	1	328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4jqTag5ahhDtGqaAAnW9NETd9kU2CgAje7NVdLRoPEA5pkm5
20635	payment	1397	1397	1678	1	1	9187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7V7kfuFJSpXJgU2evpMczvU5FTY8RYDuAi2fK6J9d4P6qv6r
20636	payment	2133	2133	1874	1	1	356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5yFoYPohSH9wmyPyfQBV9EiTDavb2wp5zYpUAigAtDBHT783
20637	payment	2132	2132	1874	1	1	82	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCUGXzwPJ21x6Tdj1ayPF2YEGuw5xQ4AtH3eySg9j9fTig4ZC
20638	payment	2134	2134	1874	1	1	332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjfMQKq5TwWwUpTx7bmxGCxfPVudBKUVJcJDoztBnUYyG4VnR
20652	payment	1397	1397	1678	1	1	9192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHmCibFbENhaYqKhmHWyrSeVmyhYmA93XwFWgcZasU5T58pxJU
20653	payment	2134	2134	1874	1	1	337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgXEBDcahVd6Y8eKsueCi88phfVfrYqXTCNpjTqVcZfGY2b8k
20654	payment	2133	2133	1874	1	1	361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZkBedogzUcUH45nvJdzfRtgsRQJ9pxYejiQFHuAstJbPcuNQ
20678	payment	1397	1397	1678	1	1	9200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpx3A2VE8enxY1CNatY9ppNoG8N4KeutUpCtCDyMa6GSPNAibp
20679	payment	2132	2132	1874	1	1	86	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxmN7K9S5SeoXUZk6BxR61ydZ7q5arjLS91gPzTmK6HMW5Ni6
20680	payment	2133	2133	1874	1	1	369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4FUBwfzqf1XFde2qcMvmz7F42MA7giyxGZjuKYU297yM2mbV
20681	payment	2134	2134	1874	1	1	345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12F8VhUQyrG7Ka3fZv76SvgHmzQeBU2YX7vLrxSeWXoLbWcAA
20692	payment	1397	1397	1678	1	1	9204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCc9rFmV5a9MWas9BrmcavJPgF3QDWDczfmgTqSYT6uqnxi2i2
20693	payment	2133	2133	1874	1	1	373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtvqK9z9KucEoNGHAwbrHcXksj57bawaAFCVr1zhPHxtiGneKG
20694	payment	2134	2134	1874	1	1	349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jMtX1R4T6tvzxRMkBQ9gZULpZ8g9roNrDnX2jcumbR77djQp
20657	payment	2134	2134	1874	1	1	338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9NwEcgApAo9rmVrdMDZkqYn6d6VwnipGnoM6Py3QoNKqJtHu
20658	payment	2133	2133	1874	1	1	362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLh2DQkiLUrqmJa4tGHKFKrapxR9V5JgseZRNCmKjXCErTSBmj
20659	payment	1397	1397	1678	1	1	9194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3zZYVJCU8Xtm6y12BxAUhvfHisD2hNCXNExWCrkZFPvvKKvC
20660	payment	1397	1397	1678	1	1	9195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjWwvxwUrDuHc38wfDXMLAfngQA4bgnKak4JrAPJBnKbJaMB2
20661	payment	1397	1397	1678	1	1	9196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTU4RfJr1685GHPdwVh8p5jibD33MFnVS49NrpbM4haGq5KScr
20662	payment	1397	1397	1678	1	1	9197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrBWEMH5HmbUdrPd4U5ejUjEjd6fKy4q57gKT9J3kMtHb9daA
20663	payment	2132	2132	1874	1	1	85	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuC64c9qpZkPp5viPDRb5mLxofKmnWTUvcy1ke5WUPZV9KMkiB
20664	payment	2134	2134	1874	1	1	339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5KNB28qY6LKTXfU2uwb8sqDjZmS1F5x3BmHpUX1kFjswAWik
20665	payment	2133	2133	1874	1	1	363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXuwf67dV22Jr1bERLutsYoNEv3JQxAeXGWMfcNZ8TppEdikmu
20666	payment	2133	2133	1874	1	1	364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3trJeYfkGjGBwry67ETdsXpJkKfHVgFzKVY3z2bLfWuvX64Z
20667	payment	2134	2134	1874	1	1	340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6zrGqWBMMXqgnnmK97ZizRNtasiWN4RFS9pAjMNbmdHqU2W3
20668	payment	2134	2134	1874	1	1	341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgocsVWVKcEgfq7zvxpiPtxiDgBGW5YqLduEhP6T99DYQnud8V
20669	payment	2134	2134	1874	1	1	342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvaCxHCcYVpGiE4k4BGAdnF6tVxw3KwEaFeFdBeQriVM6LV1x
20670	payment	2133	2133	1874	1	1	365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmreXVxkg6F3XusBdpuJCFzw8BMZvgBmYUEemifcGZgZiSA3gD
20671	payment	2133	2133	1874	1	1	366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjafxmRXcYpmeTJkvaK85YvHApSugtPMrmRghsvnVvDvmkRqvt
20677	payment	2134	2134	1874	1	1	344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxAoWs6yXhUzcptpEtamB1KwN53S3JtvTCTtuw4AF59cVR4Rx
20688	payment	1397	1397	1678	1	1	9203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4WM1ZppUkwCh8cL9BCyGUCATL2DDubspBUAfrvjkAKh7X4SC
20689	payment	2133	2133	1874	1	1	372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwqYawsDhe9Ty4x3fEWj7t9i7zhxjB3rpwXedNkTdcgAGNWVb
20690	payment	2134	2134	1874	1	1	348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweQNoquPKzEhSJikHQF1Pc46iiTi3QJabwmVuYSj5rKfuzdR8
20691	payment	2132	2132	1874	1	1	87	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pAECmqALQHXHEA3vXk5t4ry9ZrhHe6WLmhtoeYfkUAeyEWtk
20695	payment	1397	1397	1678	1	1	9205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZLNuAXkfbJdWk3MgoCpBPhHQYA3RaYzb9cgjhHatiqxTtn8o
20696	payment	2134	2134	1874	1	1	350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYZyrN9LK9C2UXK5BTyGRxjitR1mSCdrPyybakKnNaWofNNSk
20697	payment	2133	2133	1874	1	1	374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AwuxAXKqyfe6LnYwQUS6kXg8anWew6pSBkdNBJB8CupYyida
20698	payment	1397	1397	1678	1	1	9206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5G5rCp7gSYAsVAaX2hQSNYDCcSosnDrkrZJx73rv45gTVSTuK
20699	payment	1397	1397	1678	1	1	9207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjGofz79ZBNAxJ9H3DtA4PTPMvotYPLrCnLc57YnVw46Vwc4k
20700	payment	2132	2132	1874	1	1	88	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvLDxM2phhSRwTb5rJYsmGzPLNoc92hC8TR1L1BazBWTE1Cfc
20701	payment	2133	2133	1874	1	1	375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqKChrust6ERhSZA4THJKJqqYi1Zim3z1PDapkKMQvjmVcqFm
20702	payment	2133	2133	1874	1	1	376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RU9GQ1pDddJGTVkhFUzDPqCfrcuZFa3Jk6dn4Bsxr1tTvgfX
20703	payment	2134	2134	1874	1	1	351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa946w1rQuTKzpjM5SNmfDQsLaUsMAVX4BGeb6E1Ko8WnL34BZf
20704	payment	2134	2134	1874	1	1	352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDAQa3CkdGibptLd4Ea3mFUEJr5dmZP5ktJmnUDJ9fFp29M1M
20705	payment	1397	1397	1678	1	1	9208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnifqYLwsGmmzFhmvLsvSoTPdxwP4vHGQitvTETGjEy5VyoZwi
20706	payment	2133	2133	1874	1	1	377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFKxp19wQRCP6tepjcJn9ef4jGzLisA7YNPAy6yTYKAz4UuMq
20707	payment	2134	2134	1874	1	1	353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTEUPJ873VJpu6jrHteQcxQJGZgrYa3T3eppWtAJu3TRXtYy1
20708	payment	1397	1397	1678	1	1	9209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPdKt9ktFM2KejxGHnVAEVNiZSKjiLNExbeJtc3M2drrLMrq9
20709	payment	2133	2133	1874	1	1	378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuauuejPeFaXP5MbPAQFod9c3Vpx7N3ocnf1oBP8yPgfMQ2Tat
20710	payment	2134	2134	1874	1	1	354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8njGtDmwhHK6N6Uww6P2Pg5YB8Hd8zowwQxUEbkoepNLzFdhX
20711	payment	2132	2132	1874	1	1	89	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gi42AW8XMLxeiYEG3ip82qV8ErE5BxWMRUBQsgfMhS2zYUwo
20712	payment	1397	1397	1678	1	1	9210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFwo2Lch3YRKhstxRmCQEDPtCQC9EEjK5i63REwTopqd6nEv93
20713	payment	2134	2134	1874	1	1	355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgMkJLfzogFqWedthSauagCrjNBdxDRJZytq5uKKpe9LMCygv
20714	payment	2133	2133	1874	1	1	379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2veTL3aYvGQpNzht8jNpWNbJ388R6WAqTJELhAC9aLJz3gLC
20715	payment	1397	1397	1678	1	1	9211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVbkxEP9Ktc1uH3ZvM3b2nBhoTU41iN9Dk93cuxoLa5qbGqYF
20716	payment	2134	2134	1874	1	1	356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkwZaWnHh3xeeo8qXUCozKQgUfA7gQRkwALsVfshk7nGS2gvWm
20717	payment	1397	1397	1678	1	1	9212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMthHhoRiBc11T4KV9PTVrN1TvJfW6r1cyde84xpaCGVZ5Vkdw
20718	payment	1397	1397	1678	1	1	9213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FkyPemZzPD9Kv3kMGCmuCK3pnh7s2KABs5yk9sMvhg4zZbkp
20719	payment	2134	2134	1874	1	1	357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbAYKk52X1ZYG7zeUpxbCbyPAny87tYCRt1msGNUs2Zz4xne7
20720	payment	2133	2133	1874	1	1	380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6d5tcndENhSS1pjWKkqSmSCw3h1p6LCg7cq7HxHoMtkv1cBUE
20721	payment	2133	2133	1874	1	1	381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMMYodKHithWDxRaccdmNhqcEZpohrzMFRaoUXPrh2LJq3gXf
20722	payment	2134	2134	1874	1	1	358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUHdvw32eG6wX6ERtAtKJNunb5LaPMPSANpY3ReSbtV3B479k
20723	payment	2132	2132	1874	1	1	90	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsGCuQ5wmT2uP55Hyugif8NSEik8f6dAbodmQHsjAb2t83AWo
20724	payment	1397	1397	1678	1	1	9214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaug82j7BrZ7yCbgPBYB8YmTDdsfLxdSg5ehg5My9vL8hf6cj2
20725	payment	1397	1397	1678	1	1	9215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9V17eyb6jinDXKE1Ekbp9swHL66o3Mepxvv4BK46Xda5FJXk
20726	payment	2133	2133	1874	1	1	382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWYgZtX1UWQTNYggZ3S5xnLU3iYwZxzCCZaS8PcRnSgo4HBbz
20727	payment	2133	2133	1874	1	1	383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt57P9xjYQxfoqek1Zify4XGGUvmXpVeqsLT4PramESzae2LRg
20728	payment	2134	2134	1874	1	1	359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLeaypTdPsEvtRVsJxN4H9rNMctSqA7qoiTDQBMR57Bthkiuq
20729	payment	2134	2134	1874	1	1	360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHf2wZ52BxfVXSYDx7BMmqUFRA9c1axZv1BYMY57rSEUW6ktE
20751	payment	1397	1397	1678	1	1	9223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPv4yHkdZhJSfn5yj9hpcoHAKGPiz83RHd2tRCqyad2CJPybF
20752	payment	2132	2132	1874	1	1	93	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkRRHzUUFjqKCUCC84n7hrLExwtj6R6oRCvwVhYuTAkWuf1iq
20753	payment	2133	2133	1874	1	1	390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2cwWYeeJuwuViUkAjpsitJFPuSorNjTE6k62p9y6o34BVW4Y
20754	payment	2134	2134	1874	1	1	367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxS8u25LkkDAS2DN2HvLGhKMG1hP8wc5XQaPg8XtRxrXQoth4Q
20755	payment	1397	1397	1678	1	1	9224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfK94Wc78dWdancXbeXR82kbMmzHChveWLygGBNA3PAmenrquw
20756	payment	2134	2134	1874	1	1	368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicgtcZigPUAjGWJDNxqCCyTRGkLbckA9YEiRUPo43fMbshRtL
20757	payment	2133	2133	1874	1	1	391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4zmEQPBYNhHz6H7XctrxRyf3RduqUddXg8mki8kGUyXZuRMw
20768	payment	1397	1397	1678	1	1	9228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvkibHKufQPCHaaDWLzeKFbhzz2wEf9vcNAhHYvoqyeLPyeaM
20769	payment	2133	2133	1874	1	1	395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUgcGARP3ymq5KpvEUZXx3VQBYJgWZvgedrfHn92YsU9r2rWA
20770	payment	2134	2134	1874	1	1	372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Q2DKMrvKKJvsccSzpuHrCA5vqA1TQtVeo7TSoXWwvzyj5rws
20778	payment	1397	1397	1678	1	1	9231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1FWcwXszD5XrubMmCmr8vfzaZ1bTysDvk61YmqCsd7ks4t4P
20779	payment	2133	2133	1874	1	1	398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpYM8rULjACQohTkHVod9xx5MBSvukdv1q19r4JqaWZrM2B7k
20780	payment	2134	2134	1874	1	1	375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9Tgekfb7UeNbmKaM42uJtc2Sm3hf8JRTdFXHfgCSDvuPAYa3
20793	payment	1397	1397	1678	1	1	9236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKawXaKpGfTDU7Hz83Qwd3S8D5reh9KQfAYSEU9XUC9y4fEqeZ
20794	payment	2133	2133	1874	1	1	402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiVQ5b5JTFoar8esxj61VEgBRmwTmGdpnDFLiCAhfuZGY7ejm
20795	payment	2134	2134	1874	1	1	380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRuppb3QHHxrimfiqvQHXXXxMfTrhdEzuvhWRJPm98oyHV93AC
20817	payment	1397	1397	1678	1	1	9242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnPnCdaaQS15NDLgnvJ9gWJ2CiziVcKR1hRLGk6pzAVbT7VzH
20818	payment	1397	1397	1678	1	1	9243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1RpcqEMcd8Hog1qrTPHFHfz9nc7pr4iDYR6ZNUjbjyjvhkcG
20819	payment	2132	2132	1874	1	1	99	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBvfgkhWhHVprKtMo8R78h9AP9napvR1bTUQkdVoLqkpqe31e
20820	payment	2133	2133	1874	1	1	409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF83UKwHQHRAV1cZweVkTZzaCN7dpbGcfT4M8NPaNprpQP7UEN
20821	payment	2133	2133	1874	1	1	410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbS8eePdiRJ1d4q4sy4KcWVRnXKm87adUcFC6xRJzeGuJ3kNH
20822	payment	2134	2134	1874	1	1	387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvsJnNpvM3tNiQpMm2w9LP9iGD9bz72UagotFjVahamK1j3L6
20823	payment	2134	2134	1874	1	1	388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbn3Rkhfq1Fq6zFKuoFfnmeYaV5KaK6rNSN6fjA8mFXhNLFzd
20845	payment	1397	1397	1678	1	1	9250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesx7M1Xbr2KrR2cBxtdomULwHNVUWF8tCDAWAffvLSxedX3Rt
20846	payment	2142	2142	1684	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTAYCKjRDa3HgdXM1XoXbE3zj76S5rFbpYZ52qYLF2PCjbLwc
20847	payment	2134	2134	1874	1	1	395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdg88Bi3wVxuAhN78Ha3E1yacTC4hQN5dJdYZDDQ1fMEXGCK78
20848	payment	1397	1397	1678	1	1	9251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDjBUS5CB3bhsbeuAXvu3GZBrXTSBx3ajbVTcAeib5ZL8dqet
20849	payment	2134	2134	1874	1	1	396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpR11F9Y91dYSJRpmmVH2f13cbqUy1sv7CXr16xh1AUQ6KUbNN
20850	payment	2133	2133	1874	1	1	417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9XvyLc4HBndNQ5Sm9aB9EACFA1PQGtCRp7ciuwc4gKxZnXgZ
20892	payment	1397	1397	1678	1	1	9262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYReNTQ8EdXJTjLHtteyVqMiP4SmqcmiLkBvLFQSo4UFDSQ3CQK
20893	payment	2132	2132	1874	1	1	105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR48UvqydLeAkV9gP4AxRP52rUFHAytPFXJxcRPiZ1H6PJRX3
20894	payment	2134	2134	1874	1	1	406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrNX3MiB2PVaV3g6Xm3uFkAGfeDyFgD6k1h4N32QvGbMey7o9
20895	payment	2133	2133	1874	1	1	428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9J47xbtcCiU75pczaPvBoVrpfmQDzazH1hTyhMVXuyL4FMLP5
20896	payment	1397	1397	1678	1	1	9263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TEjNAns9FPj6q1sGN24yNKweZBuYnxutAdpBcovNGEnrFcTA
20897	payment	2134	2134	1874	1	1	407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApTXa41jhWDKEHDLAF9gRbkhmJ8gCBVhn5z1JUvfA8vr6exD2
20898	payment	2133	2133	1874	1	1	429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2BJdmGZ7L41UsuH9mTtPBC7CSZbPtYXGUwzrQhZHvHcgvtUJ
20730	payment	1397	1397	1678	1	1	9216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbQ682jEiRiRYQ3MtHvr9xrM9PXxVXG92DzM6SjHK7FPKkSxW
20731	payment	1397	1397	1678	1	1	9217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq88pDuUyeJQXqd67o9m2tgCpVJJcjR4SCMXXuv5gjZ32j6aY8
20732	payment	2133	2133	1874	1	1	384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKkkMf1MGbLMXLGbtKX9s1WQoSkk4VC7ypvw7QHaWKExeupS8
20733	payment	2133	2133	1874	1	1	385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyo7MCaFePgt5v2o3iUDUqj4fEc4T9ZUntqo3DnPRtDd6oHeMT
20734	payment	2132	2132	1874	1	1	91	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CpaZ2Jb3phaEqrnyXaPxK33LjvNM7swwYcGfh8v8dBxDXeTp
20735	payment	2134	2134	1874	1	1	361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrkmaoPCkAAYd5B4d96FtpiJdFUSEVhTG9sFntMA7ggSrcUvF
20742	payment	1397	1397	1678	1	1	9220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtAD2XiLgT8oqEDZo5HogkoC9iNHu3SgSPwhLkMvyFWnVtyAp
20743	payment	1397	1397	1678	1	1	9221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabyyndPs3jfMxGCTsWNHpQBxYhVyhRRctBq9m9q1EUx717GpE
20744	payment	2133	2133	1874	1	1	388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTLfedQZzCDJgboaNRJVmkvy7N3EQejPjxQmomwxs8SeyX6gf
20745	payment	2132	2132	1874	1	1	92	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd16cZ1b7KRbBznfNBDsq1ZXpBQsQm7QdskMFU61xiqE3NvRcE
20746	payment	2134	2134	1874	1	1	364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqTWGRtVQFcn2USVQ91pjTiHYwTdRizuzNEHLBgFvrdcqUzni
20747	payment	2134	2134	1874	1	1	365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKRLDxFrkxDMnyoCPu4wV7feND2FPXKFkLcUmBkLuVL6k6GAx
20748	payment	1397	1397	1678	1	1	9222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeHzRmjrkpSQ5izh5DQMq2yAXt2Z1bBtMhb4rGTNhhwVbYsbe
20749	payment	2134	2134	1874	1	1	366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVddJq3gVtW1ivQ317Ex9qrFMSEPq9ESerNGodMgm66kQcALRU
20750	payment	2133	2133	1874	1	1	389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrx3RmnWPiRrT1uhT4728VTks7ZR9p7jWg7kXF4XF7qarxDZD
20758	payment	1397	1397	1678	1	1	9225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvdoMfJDXzxgwptCw1RruduX8VB84C52ZRUSbUPTDgg5qnEpP
20759	payment	2133	2133	1874	1	1	392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTKtQoUwLEkpmEKemoeZ6trbG6nbkQqQqdxTFJRoaZxXmyRy3
20760	payment	2134	2134	1874	1	1	369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVauA2VZEA5r4oi981o2jkrfQPBM4vvo1bxFUteAoTp4XPyRFX
20761	payment	1397	1397	1678	1	1	9226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2Mz7Ci9sGpkqTEC3squfaDZkJ2LoXHZR11VpSY6Hnf428SUh
20762	payment	2134	2134	1874	1	1	370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrK2o3svtyxKHijyLh95yFK4BpaGBUx2eDz58evGR4RqrHutC
20763	payment	2133	2133	1874	1	1	393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8KRbyxJbQdJjx5KPtWQ9rJEtpcLJ5Z4cYr9sycosME8e53TZ
20771	payment	1397	1397	1678	1	1	9229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8gbsrktwYSyKR5axvbjb4xtbd8n3h2SgeKa1BvyYGXFWsuK7
20772	payment	2133	2133	1874	1	1	396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Dr547VyB3YnTMvwaocg2N4vavtf9NWNVWHyXd2JfGRnJKtxi
20773	payment	2134	2134	1874	1	1	373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGYMYzX43uQdEqGDQM9UP3SQCoU6aV4TH9rAZLyMKAkGzHAhA
20813	payment	1397	1397	1678	1	1	9241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxn1FVygdxgiyUMLw1Ah5Bh6oF9gVmKdFJE4PfEP7gH46cqhZu
20814	payment	1684	1684	2142	1	1	67	1001000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgb4UTHsNpqr3FQfBt1riqdo8ZuhYxWZ2QnWjNP2itjMHziMP9
20815	payment	2133	2133	1874	1	1	408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPTJQ81m1SWi7hN9M4PDRWfbnrkidFcKWbo5aYChPhwtEbuqj
20816	payment	2134	2134	1874	1	1	386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQSQtuNdUYaGJSok3x8VktcFjgFme2wXhREbxY87J4qqkbHSC
20824	payment	1397	1397	1678	1	1	9244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkZSQEyFxNEP55BnPbSPfBA3FBCwB2drmRUwx58J8ggTQkEGi
20825	payment	1397	1397	1678	1	1	9245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4NX41mcncExUSzuykgoNXrrZwtJXsAFRy3R6gmK992gsnN3G
20826	payment	1684	1684	2142	1	1	68	3000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9jwpAm6UVoLVxxQEoBrz7gYJ6dLStRPUCMisUjf2DzJz1gRv
20827	payment	2134	2134	1874	1	1	389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sA9cJUewWTCi6hLXcUKUhYxwkkXgMgP2cRE4aF7TNN3gPNt3
20828	payment	2133	2133	1874	1	1	411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyo99gW49CBMYqEAErzK18u8H4hMt2oo23yidj47G2saM14KF
20829	payment	2133	2133	1874	1	1	412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxN21xQDkzLo6wiDZbdykUAA7JsTtMeTZTZKL3FxSzSy1n6McR
20830	payment	2134	2134	1874	1	1	390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwLrciTuZCCtDTAqMoKKwpJBqTesfEK2RNvkw4ZA2ZdJAFtdV
20841	payment	1397	1397	1678	1	1	9249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfbGjToCZj8EUU8oMriqTDeVFyxnQtTErttoRETNawE5JVeja
20842	payment	2134	2134	1874	1	1	394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQ7oUtRDrv9nQ7UYoavV23TxC3y1bqJUPPaWrMyXsRU8Bynko
20843	payment	2132	2132	1874	1	1	101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDSpP63FYYTocHYsnnxoYLiAaFXZJmW9npJex4TkHiKZa4D9g
20736	payment	1397	1397	1678	1	1	9218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfY73yjHmVaiJ7pfPQH1r4pBuMQ2oy3VGiJLUpKdqq3vk7XEh
20737	payment	2134	2134	1874	1	1	362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbdTBCutZUFXoaQaqHFajuNfrizkhqzTvo6BFYj3k66cwk4R8
20738	payment	2133	2133	1874	1	1	386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujkV3CcujfeZZ7Y1KjDnvXyp9k8bMCSfcG4JjpuFy9oMpQa3t
20774	payment	1397	1397	1678	1	1	9230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqHXgoYVu5NTKBjmEV4EkHPFJH7xJ21cMxWXwScGtrxDdRFgK
20775	payment	2132	2132	1874	1	1	95	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8pserqYa9HqbvgHQWNSacYnBRwbZHj6WojRiS34utewRsRkY
20776	payment	2133	2133	1874	1	1	397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpRb8ratMJpErvCdRqZYkuPWotdMwXB59BCLeem5LeFxLnmET
20777	payment	2134	2134	1874	1	1	374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAcSJMVW6iAMAyZoQ6X8d3FxdETSwRiEKEfPZZUrofJdjH2Dq
20784	payment	1397	1397	1678	1	1	9233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZ2GH1DoKdYYBFM81cXM2K8NRVdBkuEDFrzWfvnthYYbc4EKT
20785	payment	2134	2134	1874	1	1	377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhnc5PZAD4XqRvtn1fUWngFfdLH5P7EZASjrkybePWdBzovLJ
20786	payment	2132	2132	1874	1	1	96	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGk4s5Qof1uKi2zMdd35SNKjp17hBFG4ZStWK9tLsu27yum7s
20787	payment	2133	2133	1874	1	1	400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRJ9VGVRbDBCBMpFG9TVUqG24MX7AFSmVBk8GMBr4UrPL9QY7
20788	payment	1397	1397	1678	1	1	9234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4obvoLuba1dbgA8kgPTumdXbGsAxrPfcFfLKhSoqhzB2mEco
20789	payment	2134	2134	1874	1	1	378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1A1XGfToyjJP2tExEA3oKnMdqxGd7E38ueyyWgjHJognqhZNh
20796	payment	1397	1397	1678	1	1	9237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcXEmqkwLuCLeXLxA9GTaEKFtubc3aHzuCdYYQx99Y4nuJPZP
20797	payment	2133	2133	1874	1	1	403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9hQXeKE6Lfu4KRMHzPdnoZBC3S6o1CNC1esyEFu2zCJQs6tr
20798	payment	2134	2134	1874	1	1	381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8Px3tUQCbFtj88sCrgCfHoLkXHp1hnouz1X88S8b91aMhVV7
20799	payment	2132	2132	1874	1	1	97	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKRGSLkA9kZu35DufWKs7La5tjs8vRDS5cXsSH2mbMb2FTcWr
20800	payment	2134	2134	1874	1	1	382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxMEuU9zAv85ThaPYB7sa4B8SkvtJtnYV3yGd9h9Uj4PoY3zH
20801	payment	2133	2133	1874	1	1	404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZHAQNjoxnBe2X8yhW4A257pcPPEhLf4ttratxBYayJWNxZY8
20802	payment	1397	1397	1678	1	1	9238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3Ui9CuBKkdESDKCpapdJtBAK8Hgz1Dc87LPhGHL4bM15s2jB
20803	payment	1397	1397	1678	1	1	9239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCN1HsVy8VKa7xjG1vJAiQEjuo3SEMVvEpFh3FzsXAkgFEofzz
20804	payment	1397	1397	1678	1	1	9240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB7yNDyo8L49LhYrnU1To9CSTinbtCEhwmrwbUDD4qKtf2aXH
20805	payment	2132	2132	1874	1	1	98	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAGSrsi12YW4EaBXEtRSxMvTevgrP4M4X6FfbXf98nFjXDuWa
20806	payment	1684	1684	2142	1	1	66	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgz2JZ3HWujNgYLNhwDNJ5b8pYzd413Qr7sWkFb84PGsyncpV
20807	payment	2133	2133	1874	1	1	405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYTCKhinnbjA3TyCqRPy1Kft5NJZ3w11P8XKcNsuc4d8AE3Mb
20808	payment	2133	2133	1874	1	1	406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXxEqEvyG1ishTTWzQSWqUakPvYQgpS6UMd27hz1qPNWZeU98
20809	payment	2133	2133	1874	1	1	407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VoksqwWyHy8DFcBnCffR7Mvvsjd2bZvQp1ypVb1eoyAwvrED
20810	payment	2134	2134	1874	1	1	383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMbroEHxtgaEcR1WQSmVTohDQJ5Lqv9sR5vDaBMEsJr7qtcKU
20811	payment	2134	2134	1874	1	1	384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkdH92XWAyW99GNK7XnSMTEuj1dkTxN5u8vbrrJ3qQYtBuu1t
20812	payment	2134	2134	1874	1	1	385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NFQT7cvRSri4ktAtJ6A6A3ViprPwb91abHgPworSjdbqa7j9
20835	payment	1397	1397	1678	1	1	9247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2mK2i2SSik8QAFcSPtfPDKYdm3T7vtFozSnGH7jQZ1Kjpqt3
20836	payment	1397	1397	1678	1	1	9248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHNnoLieAE5UyHYCNX7BN4LkqVyvPdwmYQ22DJ3t6qoPbRXtC
20837	payment	2134	2134	1874	1	1	392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYqqHroaFBEaAvFFrTwtYs8brG2pab7Td9N6Gw7ShiDm39z4A
20838	payment	2134	2134	1874	1	1	393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVzay9xDKfZCnJE15q7svV8jSbnNpbqPfNxFmyHZKWyETQ8S1
20839	payment	2133	2133	1874	1	1	414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJYUkkLwig55WqgXMMFWvRxib3JyMzJcofbeA1HAFi3w2UhiP
20840	payment	2133	2133	1874	1	1	415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQERYWHPy6bJDs5BUHsDhjhEZVr2ANLiizmh4pLrQZSYhVQpA
20882	payment	2134	2134	1874	1	1	403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSY6UPE4Gge4fobupDZBzSgv2QC25G6eGz8zcoD5zgYMmkijj
20884	payment	1397	1397	1678	1	1	9260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijHb2bgRXQrbszgFKXv5doBvdXcmYkpohwPcaZtrkLCxDzezG
20739	payment	1397	1397	1678	1	1	9219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8HxKRycf6k23PCaCE52ErduQ7ybBHQceSj9tyk8oH8x4rGej
20740	payment	2133	2133	1874	1	1	387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT12EF4HjfPfpHnRyKYdfiq8RTWT9e6RdrG8V3fqrL3T8W7jEp
20741	payment	2134	2134	1874	1	1	363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBAhhJwC9CGCvjU9jiQH1oJgAxbV8qNmGpXr62hKhkeyr9jYF
20764	payment	1397	1397	1678	1	1	9227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyDKBLD13KCu1re7DpB6d4u5cRZBqap8yUXtnVxchvXeyXW5a
20765	payment	2132	2132	1874	1	1	94	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmR7dcWismjc4DMipA2c7ib5BzwwwjBRud23P66UwW93NypWx
20766	payment	2134	2134	1874	1	1	371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcfxzg7WpDAqy427ripLzwh2zdgisKFTWPPVz13ZNXxYAGBvwU
20767	payment	2133	2133	1874	1	1	394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PSHqgjqKLQ6CEeN8XLG2PN3XPSogow1zub9Lxt6xteJB9dre
20781	payment	1397	1397	1678	1	1	9232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gHX18KmaNsZxgCtXmXRPGPSaeAwEcReCQtJAdKG1erRMLoUz
20782	payment	2133	2133	1874	1	1	399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhB2Eq7ZNWJ1bTv1DajMmEHPTWP3XJYiPCKCERuSt9N2RAKcJA
20783	payment	2134	2134	1874	1	1	376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TYsomgZjXJm58eYXXPCu56bSJ8siRxE7u1ZM2SDA5ZNVmCDi
20790	payment	1397	1397	1678	1	1	9235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9saiwKtDsQJH13Bd8hKpVipNs5h6Tb6yDU3pDEh93WanDaMF
20791	payment	2133	2133	1874	1	1	401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyxuDwp2GXuWgcpn7FT8qhDfvQFxzXrXbtuCycniuAE3ohz6a
20792	payment	2134	2134	1874	1	1	379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TKkZzNvqXXnyPEBthdssYFsD15pDLdyUPircWwjfsAqHBQP5
20831	payment	1397	1397	1678	1	1	9246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gbfrHYbWkZDC4kq16EQEeX4CWpFsphnFu4xXZ573a9mkb5k8
20832	payment	2133	2133	1874	1	1	413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2gk189MSNfN4kgpR6nU8Bey5trJCnczsyS7Fdo8HnyU4eyK8
20833	payment	2132	2132	1874	1	1	100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVecmgr2y2zd7vbA8pwtmNAv8rCrqu3BsjJFfEcgP2ixu1Neur
20834	payment	2134	2134	1874	1	1	391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2RDcTijRFGGGwDjYwo8CAeRaP2MymgmrfUSVs7DWZYjTU3wj
20867	payment	1397	1397	1678	1	1	9254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkamqvxv53N217CMKCbUAqFF6rc6Y8THyuXN7mxb4HS6ruYvj
20868	payment	2133	2133	1874	1	1	420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU121hshY5gxzCBSDv7tRz8LZEmJdk6EbS7t1kWWZpTt5HYY1g
20869	payment	2134	2134	1874	1	1	399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Emmm5GytjCzr6Nj7FFjp5AoymwDG2c2nMjQhBfxqEUzJYRuv
20877	payment	1397	1397	1678	1	1	9257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1uSRZc2QF76fsYk1VtF1Wsy8JyDEQa9pf8R6h8PwxQxRLJJP
20878	payment	1397	1397	1678	1	1	9258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccj3H1uJLgZGyAiBX12xYtC1rvZcA1n33Fe5ahErwz3ujKW3z
20879	payment	2134	2134	1874	1	1	402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FjdJtzyyKCyeBN9K7Rb4mQNXxgfHxyUV7hHY4u49duAdhr6b
20880	payment	2133	2133	1874	1	1	423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRAsZBrQtqDkLmPVu8V6776475bh8VGDwZiEMQW9vY9MSY7E2
20881	payment	2133	2133	1874	1	1	424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuHczY91naMCRGXVmD39iRKkCZuQAek6Be3PNunk3di5L7S8N
20883	payment	1397	1397	1678	1	1	9259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8abd3aEYscdFm6domfdiosKCyeUXBZYadFTh9ZfKnhTncVVEW
20908	payment	1397	1397	1678	1	1	9267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ2MfMAnMGsCEZVUMptiuGjGLorV7XLeRRWfA1RZ4kdGECTtG
20909	payment	2134	2134	1874	1	1	411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudq2K6KjJ9Bx3yRbDhs2H8UxJFQScaYfqrLtg1K1NMwQM11Mf
20910	payment	1729	1729	2147	1	1	8	555000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XENRkXz6assC3rdWxZQg4M7g2iLxZhUtJ5vL8PM2XA2nB8gW
20911	payment	2133	2133	1874	1	1	432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9VXYB8xeLw61o6s93T3toi7TReW9Ly6baWZctgdxSe7c1bYV
20922	payment	1397	1397	1678	1	1	9271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY92u6UdSpakWbGBUZ2CGKLoKbJcgM4aCumqUQyoPxt8qRYH7q
20923	payment	2134	2134	1874	1	1	415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7WEwvqDqEzjSdDxVjZafXeGvtLJXPCDsgBdVSRdey5EBHsCB
20924	payment	2133	2133	1874	1	1	436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVHiCF77X8CBHozLEZChAzwCRVRW8qMLxv1r4UDZ1mySscxFM
20931	payment	1397	1397	1678	1	1	9274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2J2mh5ETR8yWDHcgo5vSxr4wEu3rq6Ceya6PDui139qx2or3q
20932	payment	2133	2133	1874	1	1	438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYy56a6y3fzSkgvQD41frhntnxbkZ8cSmfUiUEqjWL8QhSzP8
20933	payment	2134	2134	1874	1	1	418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZjz23WHZkymbtVjpMGFu1RvTwCCuaft5Q3H5wCNEY9SZwNJh
20935	payment	1397	1397	1678	1	1	9275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6icJeer85B29An7RrX7ddWwYZkCKqmQU3WEPwLWMsQSYnmSY
20936	payment	2133	2133	1874	1	1	439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmm7Rww8XdM96HgZ6RXUvGa5kG8Z993nn2DDCLconn4hSYLZEJ
20844	payment	2133	2133	1874	1	1	416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJmEKhTP3FWDyQZd5dx7Sh6JMoGrpoH8d845s1hyLcRiER7Bx
20851	payment	1684	1684	2142	1	1	69	2850000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5v2NUNGMKtWp6Qw1sBVZKvgaafQxEPridh1MkbRgr6KqVGKMH
20852	payment	1397	1397	1678	1	1	9252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrYG9pkMnjBEh8XcRFLc5NtLDUPn7oxtT9i6ApiMBBA1kic9g
20853	payment	2132	2132	1874	1	1	102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEstSjTUEkxdVfJPoxnz4kb3V5QeCPqsxWuETdruEJHFqc7q5
20854	payment	2134	2134	1874	1	1	397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzXzhdwe2YFZDwvgCMpwSTLwtcXaUDPeemBD296SHq7YQ9oaX
20855	payment	2133	2133	1874	1	1	418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqyLtCeNkuWhVuYXZmbcwcMRLfZrJabVtvTA1CuJat7pSEAWtj
20856	payment	1397	1397	1678	1	1	9253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjgBAU5y4nApWtfovpXTGimxesj3j8K2E3fXoC7YaZuGKFAJx
20857	payment	1726	1726	2143	1	1	8170	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmkLuBpyCRByLnyX2ktdfxTffAMwerkcSDqPWpGDhSKb84d3jB
20858	payment	1726	1726	2144	1	1	8171	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ5B2UUEQjPfbDo6sjvzgU8Br73PtAZ2axYHZqDKjBsg5UGjoZc
20859	payment	1726	1726	2145	1	1	8172	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDhbsqV2EtRdqbaoBqYUL1p4jH6kC36WTkrFi2jxbShXPai2Pw
20860	payment	1726	1726	2146	1	1	8173	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZJZcrr8SD6gCyGu5ewuZ4da8BELytneRPAJjsLMLRPrKvi1JBQ
20861	payment	2134	2134	1874	1	1	398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWtozoudFrAnop8BZQ5MhgEFJJHRXQuJUgmrzenNjtSa15Vm3
20862	payment	2133	2133	1874	1	1	419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeDBGX9udDWFaM37PGbQUuLQnDYpvF2VoUp7K6eUUru5rwsQq
20863	payment	1729	1729	967	1	1	4	84100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAMdjwycJSNdBgLUk36AdJCzDX7hgR5LmJS9Cq2aNj59v2iCT
20864	payment	1729	1729	1087	1	1	5	111104720300	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMgrPzuFGLQjwkS1X2bHAbo31UaSgUeKS4ndX3BRMRtzYFwidY
20865	payment	1729	1729	1207	1	1	6	91225055850	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWV4UQ93EhRoG4c2F1rKjmUSMr9biBDFY7kAufPuiZH1UeCtt
20866	payment	1729	1729	1333	1	1	7	164804343100	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwGCExvfoNsDGxdbtLqirM9iS8LJhmagoSHPaNyvcsBiayxU3
20870	payment	1397	1397	1678	1	1	9255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepBst2kF4H7H6DDd7vuhy5cx8VRNX9bHd8i99BTS8H5rRaEXG
20871	payment	1397	1397	1678	1	1	9256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAapGEBVjvaQqFnc2qYrr8pUKqU2AD58e9ey8WosGTzHiYKuB
20872	payment	2132	2132	1874	1	1	103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUcsAR6PQ4Vy1iLQinsMyYtd6SLwoaUfPnyBopUvMzzbnMTJc
20873	payment	2134	2134	1874	1	1	400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DXEgdheqByoEpTCUhkMYfyYQrhCuNcYrja7gmu3Ry6apVGLJ
20874	payment	2134	2134	1874	1	1	401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRnE2u3gJ6kZUimugdLo6WWPFAuhMjwaM86j9caZxUxJa6ro2
20875	payment	2133	2133	1874	1	1	421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiLm2uGZXxPKU9XjR3DdwRepe5m7XKhDs2WxoWRB7NLqcyQtw
20876	payment	2133	2133	1874	1	1	422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeysWftMdD5419XkiyMm7NpRFGzko5nExyGTh36V95bQvoKWiN
20889	payment	1397	1397	1678	1	1	9261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9EFMbgY75pjCwTDhoSyudKXXP9UVo7mfc3QBG53vi2p5cjc5
20890	payment	2134	2134	1874	1	1	405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSwp9DqSUs1pokfMN6LuWgCyqUS8EyKQELd8uoTybGqd33Stf
20891	payment	2133	2133	1874	1	1	427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9pAnr2B1ohzUoKR4nFZU19CfhkpudwAAEQmvRoTKejU3wX4x
20899	payment	1397	1397	1678	1	1	9264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa232RzW9NGb2v8duwH16or2Nj8uegyBvuBQNx5wisAM3cW12PH
20900	payment	2134	2134	1874	1	1	408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodhnpPBMSwdniXeEHnkar5RyTpBwaAxMCo5eyLqMrDZkFjd16
20929	payment	1397	1397	1678	1	1	9273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYss5sdMENNejnoPykVPbBfJfQhRFCUo81SWjc91cj5FLf6fZN3
20930	payment	2134	2134	1874	1	1	417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxv36m7p7jDDnK24nfodhPXB4ctf4pEMVZLAUtqFJGrRWqSxt
20978	payment	1397	1397	1678	1	1	9288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNzG34Qh4jehTd64kcX1MSCWww4eu92E6GDCtvSTXRKRQEjT6
20979	payment	1397	1397	1678	1	1	9289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9iuoxQ2ts3RT55EuYGHbzfPBGts46dqXwPi99WgejKPJqZ4A
20980	payment	2134	2134	1874	1	1	432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxoNzqSevxLCJz79zJhkB8dr3tkVwFiHstwMuW4EpdiLnRYU84
20981	payment	2133	2133	1874	1	1	451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhpJchsQaqzTfTm22TdXSo1QU99zxhAisvQgWQgcwvB6Y7hCJ
20982	payment	2133	2133	1874	1	1	452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXbP2aG2mmadbke9BN4Qgg1yxLsGDK9naqcgtXCBt7pTaKmCp
20983	payment	2132	2132	1874	1	1	113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAqqk7a6BEVofegDytsPpNU6haTS4LiyUNHWnpaK4EEvS7STg
20984	payment	2134	2134	1874	1	1	433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLHjeEwoVTSDhszkutsPi85cTE1uGjwK65s99KAvW3e5GHt4R
20885	payment	2132	2132	1874	1	1	104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ563oGMaJbq85H59QChhL8TU7HyAWsiPUZMbK6KGFLUtNFiEiv
20886	payment	2134	2134	1874	1	1	404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7w71hUrn1bBEcuv7HddZ7p2WS5Bqqdk4ntWUy9qnk5h7DQFX
20887	payment	2133	2133	1874	1	1	425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnz84a1QkdFDdCXkdSsczL3XyEjhUWe6vYfy3Fk7sBiVu4kDF
20888	payment	2133	2133	1874	1	1	426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xVU9umrUoDgyqsYwv4BNnUEE37Vw5nwQmGbH1vMN4XkhYmR8
20901	payment	1397	1397	1678	1	1	9265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4hM1CLd4Kkjfv6naDRudCJbibs7g5zR3JvcqFfnYP7qUTLZm
20902	payment	2133	2133	1874	1	1	430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YFq6LJfa1UFFXjoQXvFvnyKV4RudEgccyho94jVVTA9X1tdy
20903	payment	2134	2134	1874	1	1	409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADkvukYcZ2KiKhsavYr9kdj1UGxumJLX8xBPMndsAdVLK9rw4
20912	payment	1397	1397	1678	1	1	9268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQ2XAbUjsv8jEAP2bWnCzs7Th5uEfL8WCxSEJvQkPDJqtZZ1M
20913	payment	2133	2133	1874	1	1	433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkayyqRWMBkDKjopKbd3fiMnoYNyqvn7DYjFdkqHFf9xJ18YsW
20914	payment	2134	2134	1874	1	1	412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDxRBJj6N353w1MgTkphXppbUwKDxrFH6UuRzGHbuHDNaD8cb
20915	payment	1397	1397	1678	1	1	9269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbnyMsP7Tz3mwcWR1vzMxsGvYZrvHVkmM1k45hzfuaAFr7fFm
20916	payment	1397	1397	1678	1	1	9270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6Mcp7Jn8ETX9uohjV9fkMutgXM4TStU5MyENU3s6A5S17uAb
20917	payment	2134	2134	1874	1	1	413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oF5mDqf6VzEqdtbBsZeNa1Xi2UQvwpB67smRCwZcPpuVtiLf
20918	payment	2133	2133	1874	1	1	434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3H37ozaNXWF4bgJjhnRsgfjPmix7E8U1BvDHNyJ2rcjr986o
20919	payment	2133	2133	1874	1	1	435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdPWbyyLxLzyVnNH6WuEzqsRqH7fg6187tfJ9AXckHht9CyJJ
20920	payment	2134	2134	1874	1	1	414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRZSgYbsxRkF23v14tX5TmZxwUXBPYp7YUA2jYKZRnnxKkcCG
20921	payment	2132	2132	1874	1	1	107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaspGA5snEuvobRUXt3DAWxvb14J3xumBLAw8HjkNDru8vQMT
20925	payment	1397	1397	1678	1	1	9272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryPuJLMeDXS9Fb7JpZoyddzpLbArifSjoZMspPqx8ZRc4f3Wb
20926	payment	2134	2134	1874	1	1	416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv81ptvfJppieDPLJkm3Cfz4AtqiPMaq5SiGEQ5TptCTVEqdbn
20927	payment	2132	2132	1874	1	1	108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZE7TWLnmN1UKX1KksKPTReNgRwTPSdbD5zSL998v5jsMadjX
20928	payment	2133	2133	1874	1	1	437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsXgHNeuVXTkYiNzKhzBtdu6g86gp3tR57SoHby4U545VN26T
20938	payment	1397	1397	1678	1	1	9276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm34xpWSnSBkZBCSjBzkqp6Uns4TVoxSWrAeyhYp7sdQa9V5yW
20939	payment	1724	1724	937	1	1	8	1000000000	6000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZ3LPufkEdPHcQ3UT4Z5o1KBAJaLuRPKBpDcH4bBsn2dwcKgLgb
20940	payment	2133	2133	1874	1	1	440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiReDEKy4NWpyxgBmm9NJrrEF6EuyWpXY8XRLPFqZuLL4ZsJrv
20941	payment	2134	2134	1874	1	1	420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59YredC4Wxm1TDi15norVWn2oHpL4PSRcRFqW14u3ChXHw5CS
20942	payment	2132	2132	1874	1	1	109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJboxsh6AUo1faxhhLLRHhDKTx5uyHDMmQJmhB7EaKdb6JK1qd
20943	payment	1397	1397	1678	1	1	9277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZud7yXoJwQEBoZTXHEymxq3BNQBp2JZCwBNNsAtCYvgz5qKFJ4
20944	payment	2134	2134	1874	1	1	421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLWXtGTvSf49hsuaM3y6wC4vutMtdbFGXBzN2ddrskKkPEwKt
20945	payment	2133	2133	1874	1	1	441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGypqJHbdjkCJLunM9RpSoWn7NEkZbXCMUnqDtuFHnhbEaPiRQ
20953	payment	1397	1397	1678	1	1	9280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSP7i49JcdrG1w7Sz9zfxPVB5qtWbEkc6oDv3wFCtDD4TUkgu
20954	payment	2134	2134	1874	1	1	424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUa6QJX4ypp8z9PTJVfJ3kK1cATpDoXi233RaXkNH9a4N3q76j
20955	payment	1397	1397	1678	1	1	9281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoYLCqrsV4SMdrYeiStGEcb6S6fN32DviMie5EZ1hYqdNVKuU
20956	payment	2134	2134	1874	1	1	425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2xmkCbyg9FUDRR2BDz6qnCz2Lztw7LFiXy9Mumhqoc6iireR
20957	payment	2133	2133	1874	1	1	444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedVKsixcjeu5iHeqbNXcmQ1oVKohCAf2Zs1k658cGfUPEgVxL
20965	payment	1397	1397	1678	1	1	9284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnocUnY9WjXqH3si72UNpLdqfiSutQvAMagcEnsNrTu5ciCoC4
20966	payment	2134	2134	1874	1	1	428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvKBxwGnQUcpyYg2nsBUybqjJv8Yn2DqZPa6AF9uawwju7Nzb3
20967	payment	2133	2133	1874	1	1	447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCf8rnKixAF8auX2KcHUTtDgiphWLCGEm4CkmpePoBYD3b7DtJ
20968	payment	1397	1397	1678	1	1	9285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUhJ5BMo4hhnKjLnRUFFHhXvS7cpeFdMyK9Rk38pCmMQBxP9k
20904	payment	1397	1397	1678	1	1	9266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXAW1v7sGhp7dMt33ckF2wTKDHPp4eEiUEt1GCerPyDj2anMw
20905	payment	2132	2132	1874	1	1	106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXoqDEHVYqtL4a6k5SsQeRXtSREsK1p3LVdsjYj5QuoiTrXSf
20906	payment	2133	2133	1874	1	1	431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGxrJThqZw5qMj8JD1QSsD6fSgaTupLcP4H5NJtdgW4qwgzbG
20907	payment	2134	2134	1874	1	1	410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyv48JSQCR6fwdhuPQMCoK8j2CtfZPvTP9aysXUHUnyhe2ra7d
20934	payment	1724	1724	1303	1	1	7	1000000000	6000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpYdxCGF4bjmRCeCKu12WsVfJytHdJo4Kyt3LSSfy5rCzx1qGu3s
20949	payment	1397	1397	1678	1	1	9279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYC9EdtgGMDj8aiZmxdGMfeHNB1gMcNV2eCkWvyCqQ6DBC13H
20950	payment	2134	2134	1874	1	1	423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5XiZkgtkzhx214Nv2QoKBjSrTzBrSmzczAFFVRJEJHAAUKgz
20951	payment	2132	2132	1874	1	1	110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrMawZnMEE4H1veUEawiNQZ3QxDUikhRBktyyiZoHvL22ksoU
20952	payment	2133	2133	1874	1	1	443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGUKkbuK9gW8jatJkiMLUnm4UGMoLbxbCFcqVdAY2QgiQpFuC
20958	payment	1397	1397	1678	1	1	9282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrFRSDkgsuQRebtEjAUMYvmkLGUe2h8udvWBhceRbU6S7e3iY
20959	payment	2134	2134	1874	1	1	426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJz9sLkHVh9qLtH8muBo9oxfYtFmyV6iChBCVLkxk8AJMUoVU
20960	payment	2132	2132	1874	1	1	111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvW4f9ZpVvw29TDby6hRXc6cYyRgqDfruKFLSf6UEed65t11JD
20961	payment	2133	2133	1874	1	1	445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UKMDR8V9BcAofhZpLHxeayaEnvbkFFEksDmCZyH2u6mixcjo
20976	payment	2133	2133	1874	1	1	449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrAJt1wtTEoEJ8nyX3aKrJu17gVuESSZZtDeVkhSb2q5Qv3jH
20977	payment	2133	2133	1874	1	1	450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGeLFD1nk4NnyGFTZdY7zDejATi4dDTnRCsDF7drziZUTFcZw
21011	payment	1397	1397	1678	1	1	9298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfWEfPqhPw1MYLpFX3fuuddJCa9FihrX4bXAhG9BhPfp9KoiS
21012	payment	1397	1397	1678	1	1	9299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCP2hVYG7MZNVRG8Zpodoj3hEnUgZUE49znauXeT5KSNxj2odm
21013	payment	2132	2132	1874	1	1	116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6FcwnjLf9uV5GtJaLFYQwkAS4YZ18HbDNejgERfN6M42NBJM
21014	payment	1769	1769	1769	1	1	33	20000000	1000000	\N	E4YPiPN94DkzUvkiy9YfDy1zax1wBaiHNQ5WRg5zspB7Tyxngw5MS	CkpYnqfAnsUHmwL2khJdyNKf9cV4Pv3zwN9mKijr8TyLkranoqEEE
21015	payment	2134	2134	1874	1	1	442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshCYqvamCtNwSrMF77VNBd2wgLS4RgWiiwjCck1HwYQn4pQ5L
21016	payment	2134	2134	1874	1	1	443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUths3TSvKR1UtapmEDK5ek2jQL7VLnLscWGRNn9wzwtNkxS18
21017	payment	2133	2133	1874	1	1	460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYRErp9UgcoAVc6DAVbPj2v5onJVopCAbTwsimFaS5geGb1jY
21018	payment	2133	2133	1874	1	1	461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3n1A5mqAEmjoPP7UuM5TqpZauNzS3w3v2NajYgQGu2GxnpwhH
21019	payment	1397	1397	1678	1	1	9300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i3Yzgb8cU2cxAq2xsV4pknazft6GeTPBJd9LXwfuLEt2Yq9j
21020	payment	2134	2134	1874	1	1	444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4vZDi344BqfaMJ9M8facm43nzwTs1qedrvYNBbDWzcUc2Far
21021	payment	2133	2133	1874	1	1	462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzX4rBh2q9joFcJshi8Mmu61U3VsiD8wr7PBN5zVM3vdVnhnv
21032	payment	1397	1397	1678	1	1	9304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzHqW4iBLeP3hw74bKYbssXWqF5kWUA8DjVfjr5iEpg52HPB2
21033	payment	2134	2134	1874	1	1	448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYum9FHaRPPX4RLPbNpMuSfSCtq6wSYRQkAvuWtaekdjzKsEmcm
21035	payment	1397	1397	1678	1	1	9305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdb5Yh3rqsoa1hcXM9XhdWjdrNjJNZcRzY1aK7F9PussNXqqu
21036	payment	2133	2133	1874	1	1	467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yY5zd7ch3huk99ZD4YmahUdhLfpN1cLHVqDH4smFDNY4PgZt
21041	payment	1397	1397	1678	1	1	9307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqymd3dpPuywLRnRgNCqANdxGpHrXXfzqCARJLvpqHdao1NHVY
21042	payment	1397	1397	1678	1	1	9308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPbTQFMg6QyHyUa8furcE2RFDWW1hrjVr8nPA44EteBD1Drqd
21043	payment	2134	2134	1874	1	1	450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmADBaRm8g9rpXcvckcHsrJPL8BmaukmuS1UBRRH8UJ6XJwoq
21044	payment	2133	2133	1874	1	1	469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdyg3gYuUfKzhTm8TioRt1Qe4z24rA5g2kr7GW1hbj1bhYyrc
21045	payment	2133	2133	1874	1	1	470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAXupUvPAKmNib6r2XqBWNxNCvyeVcRKJzXSEyKioKf6m6ZVe
21046	payment	2134	2134	1874	1	1	451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKi2w95Bhuf93Tr6d9cmDbrYd4rsgdw4PTS6gAjMFtmFYTpzqi
21057	payment	1397	1397	1678	1	1	9312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4L6GXBzE72UewbBnseya992XGM3gkesG3yyP5AgiT1kvN2Kfg
21058	payment	2134	2134	1874	1	1	455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiDkiY1XbqiNXBNdeHezVRDM1Gt8q4QjNLbgtUvQgHVgFjxgd
20937	payment	2134	2134	1874	1	1	419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnv8hHXtDXm4aEj3YxBFMA1NqWhBhDWeV9Cy4Rnqshfnn48Ybh
20946	payment	1397	1397	1678	1	1	9278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu46Un6rNy8xz9VYpWhwuxTkhsWfyR24YmEchsPns5bMR8gryi
20947	payment	2134	2134	1874	1	1	422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywwYzRyEJX8UUWHQf6CGx9S7vhrCXbNKt6quSQZKLub6iMSAr
20948	payment	2133	2133	1874	1	1	442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetMWhpD4ApmHGVbxe9MsCYEfvQEG61dNQpDCukCSFa4hQK1kN
20962	payment	1397	1397	1678	1	1	9283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvn96Bf5bi7JtxwZkvwrbxyY9vCDmm3akLgpkG6rwyVk59WKbD
20963	payment	2133	2133	1874	1	1	446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdHsQ1t48Sd2Nc8NeUrDwuWvE6Sttt6dK5JxWsxrTevjLdnn7
20964	payment	2134	2134	1874	1	1	427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9Nu5QN5fmQn8eQi2WrDXw7ARABzeomKDAb7ZfeUttKhieizJ
20971	payment	1397	1397	1678	1	1	9286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpH59y9ZMt5q9kWXiZBjhN2N3b95RWxYtfFkDAz23kSy2YSiJ
20972	payment	1397	1397	1678	1	1	9287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MHnkdhHv1aX88ZH4UyHeMK5PvKoGU72MmJWGdkv1BD68e5Qm
20973	payment	2134	2134	1874	1	1	430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruLYfKYyyikaoyMLfdUXNfa6M9QqYadhxP1gHwqZB8Uu4rGAD
20974	payment	2134	2134	1874	1	1	431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaumr7fmmJfnAvJdUtzxp1WLhXstRYhnTKtJ4KguA5WbZ4JQCc
20975	payment	2132	2132	1874	1	1	112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnyUnKh781JZkrtWcawBUYwCAUSucttgD4wz3R3ubC813F4rjq
20985	payment	1397	1397	1678	1	1	9290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHEWXpdEycpdZxG6mjgmjtgGGh25r7UvtzPwiiMphfQr1Ku9p
20986	payment	2133	2133	1874	1	1	453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68eaxC5679xe23S1eAyoyKMDePyagDCjLSDogkVLc1fJtN568
20987	payment	2134	2134	1874	1	1	434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFF4NacScHnaVtJvJRJrBm5q8GHJ4Sd5NY4DKjLVZpNEdrzUv
21022	payment	1397	1397	1678	1	1	9301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPwGecEBiRq3hvtvWk6cYDSja49RMoSrTfZsTLZHvchs7aqyC
21023	payment	2133	2133	1874	1	1	463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXdkFzASDztWWXUuJvAZ3HK9NvzPAczfgrXffPEaPK9MJT8nd
21024	payment	2134	2134	1874	1	1	445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbPV4Uakqn171YP9WxeYzdRRJ5V7fqqpNy77XBeVd82qgDe4h
21031	payment	2133	2133	1874	1	1	465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwnrwEBsS8PeF2ZdKjVmAj5ffQ819qvV9TM4hg94ztGLNVTYA
21047	payment	1397	1397	1678	1	1	9309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHisR2kYt2BcHBHtL41p54kr1aEcUtoH8oEqUTL9PhudoT5Qi
21048	payment	2133	2133	1874	1	1	471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZFAQjBhpBe7teXPMqZe3aPmkhw5UqgPEpBKescrNXTDn451s
21049	payment	2132	2132	1874	1	1	119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhiHf5Zdp29xheAs9pz5tT3wcK6fMRjxNziwzv1mFhS4jtnB2k
21050	payment	2134	2134	1874	1	1	452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKw3uBMsgquT2xHbX2DCs1cQcmfG3LLtfJd3sUgDpnRJhcorcb
21060	payment	1397	1397	1678	1	1	9313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbCQtG12j4EYbipr36aqLG7GYz4atBQmAtdK51jusXaNh9er1
21061	payment	2133	2133	1874	1	1	474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH8KthEzS1CDyeugTeG1XFeN5jST4nno7pRhV1rSigkMqtL4r
21062	payment	2134	2134	1874	1	1	456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SCLCVX6SgvygEpk3YHBhvFbLH38k7CBf8XGdfJAraR9c97Xy
21097	payment	1397	1397	1678	1	1	9324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQ1oWS5bvpWFUaJWZ5rPB1dqg2xwYNLH3Hb7XyzziSMiC4Gor
21098	payment	2134	2134	1874	1	1	467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCFFDvjEarZDNPaStyYoKyxMpD7CL7M6fCv4LgFGuSUb78DmQ
21112	payment	1397	1397	1678	1	1	9329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYayZQM7bCwgVJAQ7c6PKwypUvMjUq9W2rSjzGRSNEMHsH1nwVN
21113	payment	2132	2132	1874	1	1	125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLM3nyefuPbdFpgayh9ZxVsKJdt6vTTR25JSYf1qrBouacEJs
21114	payment	2134	2134	1874	1	1	472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJAwePBLR667crUKW7MqB3aJvJmD2gxn9USdvB72u8mxZbMSj
21115	payment	2133	2133	1874	1	1	489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCSb9WHb5wGvMXQrHZgL2QTc4ax8vtg2BkXc617CAFEZxGDHJ
21150	payment	495	495	2149	1	1	1	10000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWwhYcQRTEehZH1GY5qye8AAtXbkYUk1vvirtpEizpZMq2pBf
21151	payment	1397	1397	1678	1	1	9340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsgv9oZDEh2tTJxJSiKiWtrj8GrMo8GHKjWXvwyVkcxypmPiL
21152	payment	1397	1397	1678	1	1	9341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6Pv5zHUfpdaZF3W4D41LdgQM3KSHz92igZaPS5dQ6CY1qyM8
21153	payment	2133	2133	1874	1	1	500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQm7B3T6FzL1JCnGGdkQ2xXjD83if5a3nys2Mc4u9DAvJRQEH
21154	payment	2133	2133	1874	1	1	501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLb2SryBmcZp3kYk64hFV7GdB8115iWWVxz33K3BjG6grvuwA
21155	payment	2134	2134	1874	1	1	483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyGsqSPDxU1dT1GNKovfqEJVJcqzt5iYcWavzGA1577H4yzGH
20969	payment	2134	2134	1874	1	1	429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhG4GNMyVbnzif39EWh8opXaeBBJ3PoXMzeL2CEnWkfFiNZeJ
20970	payment	2133	2133	1874	1	1	448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4dynbXyXA6GkBFXU7cXYu5MBUUkLWFHS994Uq273SnGQ54vg
20995	payment	1397	1397	1678	1	1	9293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLWZFkphbbXhZxXoAb6FK7diPbWA5RPgMaY95VQ76tBLVWVR5
20996	payment	2133	2133	1874	1	1	456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRTr7Wd9Z1iQ9Fm2Cks39tzw4CsjhnJkZroADm427BhbjwSnq
20997	payment	2134	2134	1874	1	1	437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6YkqAMZoHkp17hwFuLB4VS6qicVf9w9j6B2U6bLtAR6JhsXU
20998	payment	1397	1397	1678	1	1	9294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7afoVfb6bMUhfYCgaP5oyqz7oVqz73b3mqF4dqzqUj53zhvy
20999	payment	1397	1397	1678	1	1	9295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wZ9Rbcd4J2ndm19qmopGrt4cnAUCwQf72rYNroDeoK7d8fMC
21000	payment	1397	1397	1678	1	1	9296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKH5GRB2sUTS8wyXwddW92cmUJ3DkbuF28w8GikDFEbaDTHc4a
21001	payment	1397	1397	1678	1	1	9297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQurH2W7rutbp22KXY73NbLYX4Br4uUG8NBwPgBPXG32KHhC7
21002	payment	2132	2132	1874	1	1	115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrLpHLNJm1o57TJfS1neTH7VnqsrGnBG5brV8axbpCCsnrPwe
21003	payment	2133	2133	1874	1	1	457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCuwN644a7f7eX5t5UNgA4vpKgee9bREjs3JLpaCyF4qjx1ane
21004	payment	2133	2133	1874	1	1	458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27yYPHo5RzhQAJb9yMNMVa8PUDCHnbm3Ns12hXDTpywxLcbxo
21005	payment	2133	2133	1874	1	1	459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fCWRzhSh3xRcrMbtUrauZegnkqVCMFtGeQjC2ME6SJgFEY8y
21006	payment	1769	1769	1769	1	1	32	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEskq9im1vQMKJghMohgJNVDrNW5bPSVPHw73rDggfmdB8rnrJ
21007	payment	2134	2134	1874	1	1	438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP8f7san4ih3vGU5M2aHoaYhCyjrXEgEHKZbXoY2YQCrqb9Q3
21008	payment	2134	2134	1874	1	1	439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXak3LY7Dm6cbFArNE6ABJuyPc7dN9Hbe9s7rGqXxs65Ztm6T
21009	payment	2134	2134	1874	1	1	440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCy7yU3QDStakvxYo4NUmppN3PRVnYRevXaPh6ttADW3SQcuXm
21010	payment	2134	2134	1874	1	1	441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudxsoNEeHkFPEHHHDKNZY8hsALscYHuSikDXVeFvYh36ZHezF
21025	payment	1397	1397	1678	1	1	9302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYD2JSzJLEvf9Jc4yndFmongJNgQb5oCjxDZNqvDdVx76A4oG
21026	payment	2132	2132	1874	1	1	117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fDjLvxfNWizvjMjpPSGe2qpSC5LMyXTcLSLRUafq5v2dDE3H
21027	payment	2134	2134	1874	1	1	446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWvmaaCGMkXbTDVuuFfjjCj3tAfQc1CSGCKc451uhKxZVzPiS
21028	payment	2133	2133	1874	1	1	464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLh23pTVgXbngjQtxsiM31Nzvk6oDKzxETN6kb5bw2Cz8qorrW
21054	payment	1397	1397	1678	1	1	9311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeuy8Qax6Rxr2paXpTk9aKX4VipUnXhmNi2A5wCWY3thmRghSr
21055	payment	2133	2133	1874	1	1	473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuu9KBgNEqJB9tyiQaksPtYwZbNqXZzWdoms9ut7UKDFk1NqHf
21056	payment	2134	2134	1874	1	1	454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRAyY8fUDvr5g4V1Dy9Q6Pb7ZHhESWWD2FDiV9csMfDRAQPyb
21066	payment	1397	1397	1678	1	1	9315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRGMGkbgjgEbYiYMQ8Q5zgmgLwJTjPFhnucWcQpYkf7mjdpXc
21067	payment	2134	2134	1874	1	1	458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMYUm7yHXkB1GfSbqJTpjBgQNHn14HYk5oHFsEgLHhhNbbUDM
21068	payment	2133	2133	1874	1	1	476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mMd5Yv6SVQbr6RhaDLDknWPyWqhGohhfzWsC7ZVxgvEZCinp
21079	payment	1397	1397	1678	1	1	9319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bhT3gEBrPwcsWFYpZj591ZCgnyFcwoi9JGujXFLnA7t5Ez83
21080	payment	2134	2134	1874	1	1	462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzLc9mGgdxmDz4BLGH8cAMBYbZs28S7BX63YG8wrUvbA2zvBj
21081	payment	2132	2132	1874	1	1	122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJisSuEETumkgPuovSo46RVN7LPjV4cbysQdxDDMCMEHvYqiEc
21082	payment	2133	2133	1874	1	1	480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMupDs45mVs8odkPgkBYJZX5yMHybDGLckFjJ5RJJxNDWivLf
21106	payment	1397	1397	1678	1	1	9327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7unRj9wubhDLUiWAD4c9KbJuUbAPYeT5MzyZFeQayKa7pGiHm
21107	payment	2133	2133	1874	1	1	487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRYFePekzfh896S12yckVftoqXRA3vjwni3ERsb8XCHAU7St4
21108	payment	2134	2134	1874	1	1	470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNoPSiNMZHwvEmQMXpHqniuvCsS47BjripwxvfmtoFmTrXgHA
21143	payment	1397	1397	1678	1	1	9338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5M1bEQKq1Y92mqHm2eCD9tVkBrzzxGwL8wkDHEyJWncrYFqC
21144	payment	2133	2133	1874	1	1	498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREwBToRbiHcAdkQPrXzw9RbNbbGu2e3U56A7UfT5ZvCc4NUj7
21145	payment	2134	2134	1874	1	1	481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XJ3yAXmgvvwMBuFd2Q2K7YbSewQ3q1gMx9cLJqJ6po8WNCaR
20988	payment	1397	1397	1678	1	1	9291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqZa25jUwacjfcJw8F9s2orXdF8wDn6sG57f77VBfUp9ebNW6
20989	payment	1397	1397	1678	1	1	9292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtCNA7ve4K1sJ171pMBHTeswbNwRCW6gVukJaUKMtKTuLNmDT
20990	payment	2134	2134	1874	1	1	435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRftjYgwnJkHXMhnDBpTFmf7aBu7NWX9HdemFvPjUPgfjip4aT
20991	payment	2133	2133	1874	1	1	454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgRtwUPP77ab89oLmpuqaxZU8ZJVeFMB5ci8PuwLn81os5vsF
20992	payment	2133	2133	1874	1	1	455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzzvBBZEXfmowCiv6Thhrrks244xLefBxjRsJF4hEa5u3kC2G
20993	payment	2132	2132	1874	1	1	114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQUcYqMw3ofKVxdLh94dPqkQPNDA7yJHPhGifh3JjQ9BUH1wx
20994	payment	2134	2134	1874	1	1	436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoRHL47P3YSD4qfooTVkH5or7ZiHaT1qiuPvdaAwHZoqPYJ6y
21029	payment	1397	1397	1678	1	1	9303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5hf8akJxTS9AUgqB7uq2q7P1g7mD6ZDpgxiQ9oJvVPBXp2US
21030	payment	2134	2134	1874	1	1	447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBwXYjB6RvZBie2Y54oSKku5mPX9mGjmpS9vhjVsFfqsSXpQN
21034	payment	2133	2133	1874	1	1	466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7dtL47yzK3M9JmTULMHX8xJLhrNEz94pGM1Xo15tytZxwste
21037	payment	1397	1397	1678	1	1	9306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugefYvPcJWuzmBLwbUanvTfPAXb23dZZ3vouQEFXCrWdhrkA3
21038	payment	2132	2132	1874	1	1	118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3AEV6xEiJTKERK6qwvCaZjJupusFrrCCcgLZ6DY4KF2D77BP
21039	payment	2134	2134	1874	1	1	449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUXoqJF7iGGY5bypp3kC57dNAP9CjBAi3EQmQMRwDFx8NPAYk
21040	payment	2133	2133	1874	1	1	468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4eS9hoLZzhzqt6frCmvMrNoctjRVn8bbjkvyRei1bkuGLRXo
21051	payment	1397	1397	1678	1	1	9310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuoVh87rsAi6USdYqwKiJg5fxszkWCC69vn2fSQZPJQh1evd2t
21052	payment	2133	2133	1874	1	1	472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSSnCPD4VVSZJVkEGZqVjqbyUyB1xKNVkXKzdVHD7bsEeRn72
21053	payment	2134	2134	1874	1	1	453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAVkZPKTAFENm3DSvHYigsHWSFQDLUj4JUewQiPn12jJC67Ei
21063	payment	1397	1397	1678	1	1	9314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYCTFeLrrvFHncbCo3nViq7tg8tiTzXTq3hsr29tEQ9gtvpip
21064	payment	2134	2134	1874	1	1	457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTygnWztqU3eikzxodAJ4TGTBpwPQd6zXxdE2yX1BbzBk2GMCo
21065	payment	2133	2133	1874	1	1	475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1vyErPVkZMxXeFc6AiQBWELFXNs8yfgjsYphiRgRFZVfEPnD
21076	payment	1397	1397	1678	1	1	9318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEnnF78v9PZPm1z9K9Hps1ug28mStT9gB2eGDRAn5FZpvDAyxE
21077	payment	2133	2133	1874	1	1	479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyN25kDsaRSuKoVe22MWPDXVfvtvn8jqvh7HN3Lwsg1Uq8cx4w
21078	payment	2134	2134	1874	1	1	461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9C3SU4avC5TrKnoxZLsxsVSXAQnTxSXchmXchLBf7RTzye9k
21089	delegation	2144	2144	2144	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7SFrswNtWYSwhxeZZ9a1HQUAJsncUbao2kAhGvxfnqi46Tam
21090	payment	1397	1397	1678	1	1	9322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Wy3aE4Aii7i8qXVDE1zoKxDv9hJMppPDqiMseNhdsxvZcBD3
21091	payment	2134	2134	1874	1	1	465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1yjp3NGvScMuZUcm4kX7XxhJ4XZvxCmDFqFsVyfYEth4S3CCZ
21092	payment	2132	2132	1874	1	1	123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhoJX79Wn3B6Qs2GF8yp3n3FJCDrnmznS4TCRcDkVfHdtjy6y
21093	payment	2133	2133	1874	1	1	483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLvjVGSxN4sxndngdYNBtSAzrpvt4v86RtrLPKpMtr3gbuyrFK
21094	payment	1397	1397	1678	1	1	9323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5BbPJxjEdnuSJ6gVBnnGkmTRTM6EYNkR677EiqruJrjnEgm6
21095	payment	2133	2133	1874	1	1	484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsS7XRSFpk4jgxRkKrsXbYdnf2mWSYD6UWRaSQ7PkDnSkurRmU
21096	payment	2134	2134	1874	1	1	466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUKtfV5Q5BV91W5r84TwA9pGSrXQNkT5Xihq9bk1R8MReu2HQ
21102	payment	1397	1397	1678	1	1	9326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGPzazmHUdhxb6yypaKB8ATz9WRSpfUCroaCtrtcTpHj6Xd1N
21103	payment	2134	2134	1874	1	1	469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6TpbzR3tUhb46CFTvS2fWYUQzjhKEPJMvzeQ21D6PQ3zaWd5
21104	payment	2132	2132	1874	1	1	124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6TBAK98W9DzJ2nbPkwsJRQXX7eEm4VcorikbYjyzvnXX5paW
21105	payment	2133	2133	1874	1	1	486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr69Pyjv13CJQhtMLc4bgGvn8ownNG9ooAYHMbZUwuSRnyrtdy
21116	payment	1397	1397	1678	1	1	9330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWPmVmR5waPrRmac1V3VdoFGdSwA6cumMRNES5zB4pVk7bvcB
21117	payment	1397	1397	1678	1	1	9331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5DyzhurWMSmbRVrfLNvJp4x8r4csFPuUM4k9VBQvWWHuiPrM
21118	payment	2133	2133	1874	1	1	490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyJFbpukzogCP1XEQEx6tChu9S2hg86NYrgMje1qC1M8H6uBj
21059	payment	2132	2132	1874	1	1	120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnaC2js5PHQZqmfVJEd9oKNy8Tro5RPuhJbuggxfXF7rwAF2C
21069	payment	1397	1397	1678	1	1	9316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjSjSviqNH5iTWQJJhJ9Fuvt8THdM35vNdNGprbgjfN95Y8zV
21070	payment	1397	1397	1678	1	1	9317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKuY4VTKvzFxKZ18AxYN81AZEN4wYt4Wq9jL57Q3f52wZqfMX
21071	payment	2132	2132	1874	1	1	121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRErZcj9Yk4kknq2785R4BUyYkhVQ1d3hdrd1nSE3bCXfZ6yQ7
21072	payment	2134	2134	1874	1	1	459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4g9h7qNoXYpnsvtfuqMa3QWTbGWkRZL7zhDW2KKFSfYpnu4vb
21073	payment	2134	2134	1874	1	1	460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqGMXQAiz7cpPVnmE82pT2paSduBG5jMy1X1jEtqGzbrvaSwV
21074	payment	2133	2133	1874	1	1	477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pUgm9rLn2x8ggBkiQgpLGZ2iT3VmD1ZLC6twHfqffhXmwhgo
21075	payment	2133	2133	1874	1	1	478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpH8oR1bUQi21fSJyQTAyNiwMZsfDVwsAAg8ysED8Bk3ZQ882
21083	payment	1397	1397	1678	1	1	9320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjaxqrBYdKFwAJNMdYCEZ1cXajfMA25N7MhxwErQubETFCt7Y6
21084	payment	1397	1397	1678	1	1	9321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKZMuqeZzhiv2SfGxKUwgBj5vPRi8G9tE8hTHD1TzSVaMCyD2
21085	payment	2133	2133	1874	1	1	481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDhYaq2A24jYc4cXdn2kMxWyiV2Xi6k78uRH2KAkk9akGqtEo
21086	payment	2133	2133	1874	1	1	482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdr1fRinbYKoguLSCmwFYQkYe5vaMNJBtkqUanvpEyynb9Dys
21087	payment	2134	2134	1874	1	1	463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LA8HY8XN312Zk1Y5qd1D1qGuEwXs4S93LnGDmEAgQMspU1ud
21088	payment	2134	2134	1874	1	1	464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUCZWt3LAqopne7ABFyBuDTYxt7BAkDGhb1HT8vHEDPWkmTqE
21099	payment	1397	1397	1678	1	1	9325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrMtfdYYhAqdzRGDwFue5p5Mwsw85Mo9je5XK7DiwFT5UGyQr
21100	payment	2133	2133	1874	1	1	485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiaSBjFPHze9K22jdACaz8i7KTpMFnLgA8GfRMv48FB2DW7mu
21101	payment	2134	2134	1874	1	1	468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLL5aW36i95ZgDcvLX9pUfpcoGH2Bkqou6YP7s6RrizVZYVsb
21109	payment	1397	1397	1678	1	1	9328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7PSNA3Zcyqgyd8X2MdVWJ3he6yWyEE7tzpQEyeAyrQq2QYXX
21110	payment	2133	2133	1874	1	1	488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqjwxViZjw2ZhP9vrXSDNKU7QtdxZi6fHRjP8Ei1vd5r7sWeZ
21111	payment	2134	2134	1874	1	1	471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZkXCYS3STmzJcHEmBrhWzmPiPeGbu7qXD2m3uLxUET7jZXUZ
21122	delegation	495	495	2149	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgvcKhf6tRC7Tnt5h3bUsqFTCmGQxqhWAH5qz4HAnfiMkS3fX
21123	payment	1397	1397	1678	1	1	9332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ky24ueWr8NDHQKPPys5L7yBbfcUjMW9QK1DtdPwf4uciwyCk
21124	payment	1397	1397	1678	1	1	9333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjS4snvcViHWEJ1Aajk9VkLVpFzYa3qCM7UN5i2Dp1PENc77gW
21125	payment	1397	1397	1678	1	1	9334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6h9fsq4mAwUyrMVCi7Tax3rAC9c8W6rNGdi6HokyS4xbhSz4n
21126	payment	1397	1397	1678	1	1	9335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopmkwhZPCdMakLuYif7MCJy5mKbHedTPEbmn9zkwqPbqeAuEw
21127	payment	1397	1397	1678	1	1	9336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgPcXiw92a14baGjmJJ1bazWmUqXKFucPJJTj7pPrEDCsDUgH
21128	payment	1397	1397	1678	1	1	9337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGqe9fn7CdfbkkVpTzd3A6VzJ8p42NtMiy9WF75Z5r9w9vjG4
21129	payment	2133	2133	1874	1	1	492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aKG3KJUJkCSv3TMpnrXXpt5K9eJjF9vDdeJY6HuyT93EjRdm
21130	payment	2134	2134	1874	1	1	475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcVkvmrPWgko3ubP31H9mMJYYbjb4g9raRxPYyc3ZYB3RW7gWS
21131	payment	2134	2134	1874	1	1	476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2d4wbsaDGvfoUXCdPzGZS7Ruv7bvsRLkpN4kn3mSjTvfWEwHb
21132	payment	2134	2134	1874	1	1	477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDyoxboZkjtr325JGLypQy7gzWXhScGZ4xZGdXDqSkqpvsGLU
21133	payment	2134	2134	1874	1	1	478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof6Uo6TnajNNCqnBKprrQwAWPjCHT8qL7mDSA69e3gxHcFgVz
21134	payment	2134	2134	1874	1	1	479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhobtAs86Cx45Ehs2MFew3xPfiuc9f8ncxaoT7FuxEnm6YDRfF
21135	payment	2134	2134	1874	1	1	480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHcY1QbdK8gguQGxRbYH3giv5HU3cPxSkszM64LYy2pv1TzmA
21136	payment	2133	2133	1874	1	1	493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j3Ly57ovhZNezpvryrKcQvQEYnPC7vef1R7tsretEdWKCL2G
21137	payment	2133	2133	1874	1	1	494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeUrNWbtdncAhAdW3f8Yv6LoHzqPSQuNKLWzVGF8JndckZcQue
21138	payment	2133	2133	1874	1	1	495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHecTB86hyFxDgH23cxir3Wh7PexWyrfMNLzom4eUFiUUkA8q
21139	payment	2133	2133	1874	1	1	496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk2eWBWhisUCzkDY19JWTW1DvWXfb24yJWXRBdgWtzZadfBFu
21119	payment	2133	2133	1874	1	1	491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnpBJRAKcGQnTt3AR2zicnFcQir2ER4vKuQyAyAuHeFd2cJd7
21120	payment	2134	2134	1874	1	1	473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUT3mXXmJLiCVk684byPrLDxr1gxJKXkBiCXQTiYMGm8pQ4zf
21121	payment	2134	2134	1874	1	1	474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPddguG7wctC56JnVjLH4pjTgKchj2TFgqJW13VQzL4GHsTj5
21146	payment	1397	1397	1678	1	1	9339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyucZtQqLoo33phE27dVLCiH5ayrjiri8t1rPQFU3Tn54Xxx1B
21147	payment	2134	2134	1874	1	1	482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVLefazx3zQmQBh3Qihb4kkz1toNCA95xhP2drAPBiFHjcpkV
21148	payment	2132	2132	1874	1	1	128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRD6vbMycKWHQUzQ4vyidLiHj1gj9hrj67zSp79wtV6Pu5k6m1
21149	payment	2133	2133	1874	1	1	499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTWy62GUV81KAvSJRZSQ4m4camtkemwG4YPrgHdMWX35L7Hjv
21160	payment	1397	1397	1678	1	1	9343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6UhGK2LefaKeH3H3bfgkDPJcYKtLUWnoAQjdPhrb7CLZwKBHF
21161	payment	2134	2134	1874	1	1	485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb7tXVjkCgYUgfJBqc69xm5mYtz45DEuKJ4aaTpzW3ZQtqY65w
21162	payment	2133	2133	1874	1	1	503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2jjb134rG5Fixgn1mjAKaHLHxsrMdPCJBquzL6BQLinBkqe3
21170	payment	1397	1397	1678	1	1	9346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQRtsBfojpXLmeUWQsTLU391PV1DDNaN32ekJPMWZLcKKnKxy
21171	payment	2134	2134	1874	1	1	488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAS7k34LuaeMdGAcgVjgkikM9xoPzAhZj4wduhQPimrUDHX51
21172	payment	2132	2132	1874	1	1	130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQyAH4VP9x9hTPovsgqomyiCptNXEs6y1M6g1cWviSBfNrhhm
21173	payment	2133	2133	1874	1	1	506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCuG1cpNpgMRBrnZNTcvzNv9XFGg2aG1oBbnLUsEFffeLZTop
21184	payment	1397	1397	1678	1	1	9350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANFFUYePuYHwo7PZGod7mTXmmewGKz4EpL2gUKgjwSyPUthY4
21185	payment	2133	2133	1874	1	1	510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb245amRH77DVnQ5rJsFoXAyHWA8twucZ8RH9r4TqzSpDJSNC
21186	payment	2134	2134	1874	1	1	492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq95sU9W3QVd8WEXRm21hReKC9wveCd3nDvWkM1ZDd1P15Tjt9
21187	payment	1397	1397	1678	1	1	9351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAHqXGU1VRWSc59398nGt3Zja1ST7vE7tM9Q7TVMnmcDYrjKY
21188	payment	2134	2134	1874	1	1	493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiS5e47PxT3AAtDGqARt7ffSEzww2389Vgy8HuSobgKLjLaCqh
21189	payment	2133	2133	1874	1	1	511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZid9BcmpUFH8Z1y5jEUbJtLdFySFJTyHF5amT2x7VtybAmHHxe
21207	payment	1397	1397	1678	1	1	9357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAuqU616g7TtZQb55VgU52NR9wE6aGzysmZmBfHAS3h4dHQ4g
21208	payment	1397	1397	1678	1	1	9358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pRhBMbqCmL4NjvEcx36opCCgm3hzXUTkMMgAgaM3oMkXBD5z
21209	payment	1397	1397	1678	1	1	9359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBzJTMJWdhZptfYzE7nUsCw7Dm2A8tw84hA2AousvyvBeTLkZ
21210	payment	2133	2133	1874	1	1	517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYnmPoCGxeCnCUiXh34ALPQpw567bWWmWBVYGKroC1MqoNSeU
21211	payment	2133	2133	1874	1	1	518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2a5R7PieG7BaTMXVtLTsf5U1cfer5xx8RWgq73MJ89p7ZL8MK
21212	payment	2133	2133	1874	1	1	519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapkh9Z4a3vQpmqyv33iCc91ywoEZWHpKSZJNMEmwVZhKHaEGv
21213	payment	2132	2132	1874	1	1	134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdzR5x5xAaSKrVC5oGatZGT4rbja3XtDPVvz9G2foLfqJjFkj
21214	payment	2134	2134	1874	1	1	499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiuRNLhNizajzZ6q2vHYwmv53QL5aCc651TTYTsp5udeUz5Wr
21215	payment	2134	2134	1874	1	1	500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQkxLAUt8dy7Bff9rAEbepEer8S3RDPL79RkecoyijPdeDVtQ
21216	payment	2134	2134	1874	1	1	501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJdg9cUA4B6V85Xgp1R6kzgLtAE48n6e3TyWK6HD7sGF2Sx5o
21226	payment	1397	1397	1678	1	1	9363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4bdVrLrz8ZyfGWW7NsHU2oFH5gNsqCTfAM3zqF326nN3fCGN
21227	payment	2133	2133	1874	1	1	523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3qFdqcoGQRYPCXiFBToaeKmDjPUTa2oSCyTaNoMBE2hmai1U
21228	payment	2134	2134	1874	1	1	505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEvUvs1JFoa3e2ooDA71YFXTzkxmxJfBP3gd8y9HgwTGFR4Hbm
21229	payment	2132	2132	1874	1	1	135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7AnTAkm97ayKjXfPFgTVtRGwz1M5nsrP8qNxQZ2GALXm4xfq
21254	payment	369	369	1312	1	1	3	8909100000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpYQjt89XNXsv2kGz2bWE2qA3AKL1p8xdJmhTyh2y1SN4JGEaboi
21255	payment	1397	1397	1678	1	1	9370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9vjAYLL1ZA2yVDdroHwpr1KkYJPMhiu4Y73kXenj8r3z6n64
21256	payment	2134	2134	1874	1	1	512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbKV63TAMJogDZKuKtp9kiWBSNk6iEBzecq1mKd2N5EpsmY8h
21257	payment	2133	2133	1874	1	1	530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJiS2JsQjX84aAX5zdwfp9nAkmbtydywFw6q7PsBWoLoySJ8Z
21140	payment	2133	2133	1874	1	1	497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdZ4xHRzkU41MVDxW18XN43Hvk6cp6cRsnDBdqBniwb2wdCWx
21141	payment	2132	2132	1874	1	1	126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZA4DvVqYUsJ1Cea1KbeGu6pdoCpZjRfZANLqZVkSxEVCeqp5
21142	payment	2132	2132	1874	1	1	127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZFF9RKBL2MWegDWieUP9uvEQh2eCQ54HFFcALEopVtWpHq7J
21166	delegation	495	495	2149	1	1	2	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT61i48hTPdaeHQgWeXqwLoTCaADSBAsFnLC3KC88J5XGpfi3v
21167	payment	1397	1397	1678	1	1	9345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUx8aVywqAdiFanbQzKwEWjWrqgUok4Bxz1pBAs3H4eEtWDABx
21168	payment	2133	2133	1874	1	1	505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpD2wfpD2aNrmJcWZS2XdrK4jW7wKAGpLYknzV8MMnvyovcJSg
21169	payment	2134	2134	1874	1	1	487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTupaWKdXCxwYYdYDx2nWKRRapzzR64U96KKvEViLNRvgLdB16
21177	payment	1397	1397	1678	1	1	9348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBPMH2CpchX9UyWFVHymG8SGZV5kLvRPMbMtCGNGpqgJqvJy8
21178	payment	2133	2133	1874	1	1	508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLuJ4TQxrsycUy1j6Kcp2fXyfPtofuQkwLa8wG9pBZEPCnYHR
21179	payment	2134	2134	1874	1	1	490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6aLs9ECCh52zbuWWb3FocdNrJz54VHtqistbHoi6zaFwLVGY8
21180	payment	1397	1397	1678	1	1	9349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZw2ekkmudRdPoRQmATni5ZZ5r2JnTLBNnntgtwVCuVfsBTcC9
21181	payment	2134	2134	1874	1	1	491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfc1BnvknMaYghUF1aJjtnTE319WpapbGqXz7w8baVd79Smd4
21182	payment	2132	2132	1874	1	1	131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVvqUFokwkhJGY3jeiCpToTLRSVnBHa8DFpUUxJA7TcpwDw3i
21183	payment	2133	2133	1874	1	1	509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTr3dMePF8iMk4QbM367FXTEsevNxVSN3Ni4GvAfAgnWcGcebE
21193	payment	1397	1397	1678	1	1	9353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWqK5SCLm8wpy9bmwdiptzjuH6b7ETMvnqoD68GaZqTW3KaHj
21194	payment	1397	1397	1678	1	1	9354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkPuZbVwgmWSMnHuKvi7om28n4fuRJohbbZmm399aWcqGxP7P
21195	payment	1397	1397	1678	1	1	9355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVYiPTKswcELFWQBDJiYKkygGDiToi4XkrBhd3fodVW99L7i2
21196	payment	1397	1397	1678	1	1	9356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFaAsd8oE8nbsmid5bd4rUPEFgSXDwTY85CmvV3wgLhUdFs1H
21197	payment	2132	2132	1874	1	1	132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSd7diWjEkFJvDmh4BW7BEaW8XLH9JqroDYh1p2pAuGfKpG9x
21198	payment	2132	2132	1874	1	1	133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmxQTiSrZm42JX6v4Kz1G6g9hoQAfePz4TeRi1kuUcdyecXSp
21199	payment	2134	2134	1874	1	1	495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMSm5etZRtqKNWB7Ja9W9kpFQkSwJSK6uSjfotZp5rz12quan
21200	payment	2134	2134	1874	1	1	496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyyg7tiU6c6QW49FRRUX6TgMwjLyCb2NnbokaCofbuPQUBbtf
21201	payment	2134	2134	1874	1	1	497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZrP9mqpC9LtFUXC1MNYaSVUxpmRoS5ktCTmKHZuQb4mc9Mhs
21202	payment	2134	2134	1874	1	1	498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4Zufoz6ZYDDnsWVGNMLNTsYD8AqyP8JLfcp721AnHqqmVshb
21203	payment	2133	2133	1874	1	1	513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKrrpEGH6iRy1si8NcNCwpCqyjRWXQi9t8WoD47upFF2Y6etb
21204	payment	2133	2133	1874	1	1	514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZhYnr83gHNb8mEWgTUTjr1xfVRfdAAezKxmrQNbJL8Mk7L58
21205	payment	2133	2133	1874	1	1	515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZXq1GDikjrmfttEdGu35RyqdfNEqsiVad14VndbuZHoqyEEa
21206	payment	2133	2133	1874	1	1	516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWr6nU81UuRMxREfmvED71ynKoCtmr1gew43zKJrSgdK2cvy8
21247	payment	369	369	1066	1	1	1	4738500000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpZeHbhWQ9cE6eByHSmWRgQtAbpVvVDEyuEFdhTv7NzK9G8nNvJk
21248	payment	369	369	1186	1	1	2	3197200000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpYmvhewAf2BeEK7itGtsSyuB7x2WYdnwThB9aSiKCENYLuWBskb
21249	payment	1397	1397	1678	1	1	9369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKpvmNBGu6k4ip6NDYfmPeRPNQ9PjBa2hSrjFDUani2Xe9mEa
21250	payment	563	563	1359	1	1	9	800000000	1000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5YyRYD8hfcgq9wMtuUiiyL7ZKg	CkpYa23ETkRQReA81vMnQAvXTEz5QKURxfcmrzurfFfy7A39FvQb8
21251	payment	2132	2132	1874	1	1	137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvVaxN5K6owF6ik8vALVnBcxQqsuEXp5Bq114T7ZMVAFH2hBb
21252	payment	2133	2133	1874	1	1	529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XPENxzPW6MT1UJpPqrwSRGxAmUo9TXCTWQpSjx19PHF3A7aw
21253	payment	2134	2134	1874	1	1	511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYo4MrUhTuTLYxn1pakcmPZtTMWYnzRByzUKQSPzVZVoKTmqNr
21260	payment	1397	1397	1678	1	1	9371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Cq6YtaPMsqQGG1s5FNrvqCzKzCJwo7WqEKZw6c6GHy6bqLXg
21261	payment	2133	2133	1874	1	1	532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuWvUYn8psu8sCZGvVfVUcQoTrwzLxbRprRGL5Q5AY8diADzu
21262	payment	2134	2134	1874	1	1	514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8Hu42FP4r5qXvumDE2sSTDe1khWiDgX9oBhkLhp5fyCTpagu
21156	payment	1397	1397	1678	1	1	9342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUoDjozPGaUAX9bf7DpAwevePFnN7acn6xUwMLUFa8RadCexR
21157	payment	2133	2133	1874	1	1	502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpDbEC5SbtdQ1k6mXgDjvv8RQrH5y6JAakvoWzGE1GbL6w1W5
21158	payment	2132	2132	1874	1	1	129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJU9Q6wBjAPwkCT4NJZWUVCpAuovaYLrtbyNVhS1zjxZSbkyfZ
21159	payment	2134	2134	1874	1	1	484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWU7vJ9kpsgMgkkSZGfc2ord9NsuCKmd2WbDmpddy3hpzamdM
21174	payment	1397	1397	1678	1	1	9347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJG4PjrCYFuSZq1iLfkWPgJCnKYTsYGZMBJB5tRKnawaSU3cB
21175	payment	2133	2133	1874	1	1	507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTThLZuNVN1KnRwxPizzBCgff2xrtD5AgRKcipL2UTFkgeJmhL
21176	payment	2134	2134	1874	1	1	489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8bbB1VgcbV9XUKG4FSU2KbpXexZGv7LgDFV4xwRFpZnit64C
21223	payment	1397	1397	1678	1	1	9362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4U8VrG9ms8vWwxsJN3AswYRiHQpiZz4TaW7h4okP8e76S4pig
21224	payment	2133	2133	1874	1	1	522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYom3wHVFNtyqf31xrTS6yWRwPQAqGns77hegU8iwsLs9dDo3TS
21225	payment	2134	2134	1874	1	1	504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAfweseFsxEPjg6uauWZ1ctbFQeLZFGjbtceTQ7e8nZHZqJVa
21236	payment	1397	1397	1678	1	1	9366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3rJvPPRk1zYJs9KoAsoqPTrrRL2HfPazazNeNR3segyXugiH
21237	payment	2133	2133	1874	1	1	526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ5re7Pjxuquggt4zSNFfe7Y9WXEXV6L2joW9TGz4bon9eJus
21238	payment	2134	2134	1874	1	1	508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkaqwNvBbdFCdQNapi7tzMGLBmt7Sdj2npHGa6v1SXx8JQhQt
21239	payment	2132	2132	1874	1	1	136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRd8HTVnHNcgAfwkTBAqi1tvDUBn27q454Tjm4coFJp3afZ2s
21240	payment	1397	1397	1678	1	1	9367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBq8ERAj1t2RKEwVW83ypEenMLLGSXkMas1nPjFYyMMUg585E
21241	payment	2134	2134	1874	1	1	509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6cYxsoWY8jYpXqEWPB85MCYQp8CVpoZPLGmDBVSLUSrC7TE3
21242	payment	2133	2133	1874	1	1	527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqynmDYA63BW9VeimnKahxtJGDokF4gYP5fkgQcSK4JbXd4Gub
21258	payment	2134	2134	1874	1	1	513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgWKNmLYNDYHswoFqCDu3aGZy84g42MxJsSkkW7fghv9zroii
21259	payment	2133	2133	1874	1	1	531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdcDadDm4DSPs5ewdNxnewPvb4KbGpHLY6DDFWAu1GiZiUbxY
21291	payment	1397	1397	1678	1	1	9381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjaaokzY7BG8yaffFbxQVMAaGKQCtHncXzD3iDuY3GEUmQK4W7
21292	payment	2133	2133	1874	1	1	541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PDPnDns5VAqN3g8M1Pgxu4Z2xisHRLhSFJAPM9PAJLgwd4nW
21293	payment	2134	2134	1874	1	1	523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN95etUB2NBdKoaegdtFw1xBoKAJawvAQ1yJuSEr5XRq99RGA2
21319	payment	1397	1397	1678	1	1	9389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfd9vWJ7cMb7Wy8Qq5E2cxouox7Wo9azQ5MVpRray23GRxqmco
21320	payment	2133	2133	1874	1	1	549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUyHvc3hZBFUp6fwtQ5PfNX1VhtH2XmFb3fGgft9oC3DyyaKX
21321	payment	2134	2134	1874	1	1	531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbi733DKkh8npBnZZguY35tWy9ZKwJEtvJWZZsgAxurGdW6f7D
21322	payment	1769	1769	1769	1	1	35	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7L4Lqh8LxniNDYNkDw1szW6bPzmc5t3ooQHv8KD8LTc4k2jkW
21323	payment	1397	1397	1678	1	1	9390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqwfz5GzySzgzKji4C8wLN5nZJcefycUUuvYBWE3WPGoRmjGW
21324	payment	2133	2133	1874	1	1	550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHMr4Vf4gDyfhTYToDiibH9p7ftCEvXNiYggVbGVhvqe7YcjP
21325	payment	2134	2134	1874	1	1	532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgXjzjcSqNJyfLV9A5KiiYLbLkQXjfQ9BVr7RMiuUtVVVoQHM
21363	payment	1397	1397	1678	1	1	9402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyA6J3X6c7HAJCYEx467PTUDjQbR6NTCg78gsxomHTd8an8hz
21364	payment	2132	2132	1874	1	1	147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6rhLdeUppj4e6TXdRGk6fZjQykVz5p3AhdNaBQ3waCwHHqY2
21372	payment	1397	1397	1678	1	1	9405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfiJGWhDwNZagMkDM25H3Y6K8EUdvL2AV4y34SKvWF5NJxqip
21373	payment	2132	2132	1874	1	1	148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGkqpu6TLF6jV4cYVMNHLbNztDXQHpFzWHpBRQFvPjq2CVgrx
21374	payment	2133	2133	1874	1	1	564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRQ3TEqCsLiCp1ePcJyhNyzKuwqvjTDpNk6QdKCGwsrg4PGMq
21375	payment	2134	2134	1874	1	1	547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VyUkWxmiLGr3RaPXDzPNFpH2KaRSDb7GKmihpuPWLJtAQw8s
21376	payment	1397	1397	1678	1	1	9406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupPcbhuUVVA96beUuRiyfh4uxPSDfQiqGCupRAXhqZNgfCdv4
21377	payment	2134	2134	1874	1	1	548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogAs4gtw2ntEK6MPu1mP5gGayM4YN5XvoqpABfiX5MEsTrf8G
21378	payment	2133	2133	1874	1	1	565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhfUSTjHmjnjU4GzHRtr9Ac65a9iVvChCvY14ms27iBm5KJn2
21163	payment	1397	1397	1678	1	1	9344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqw663kbwUBHQsRV9YzGcAvLRZxEkS33g5gsgaqyMWY4eRoWf
21164	payment	2133	2133	1874	1	1	504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdkYj91dWGAqT3ZUUWuVQyZNy6t2iJvS3wno2HRwiCBjXinq6
21165	payment	2134	2134	1874	1	1	486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TJmRi88NbE34smpF7nqr468ZpTccbUTHhRyuw4bprULD9wkP
21190	payment	1397	1397	1678	1	1	9352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiKoUd6XBHCyGeapq7bUeiS1171PqELGMjbYTTzWyumNU1J8V
21191	payment	2133	2133	1874	1	1	512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxypPgENMnzw7Hnmkt3QPikVD9bkDM4524iHpWUKUFYn9oJ8f
21192	payment	2134	2134	1874	1	1	494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3GBZGaUx5dmHgLuJ5PtquR8vG2wwfbL9X8mU9BBkZnXHDQ5S
21217	payment	1397	1397	1678	1	1	9360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiKaTP5HM5SPbPKXjGF2LRYuTUErjT37NgnKFiNpV99BzCH3R
21218	payment	1397	1397	1678	1	1	9361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsefRvvm2pB6eqFZxQrzum2PrHq9uaXNiLWB5tEbnZKQ3tmru
21219	payment	2133	2133	1874	1	1	520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4QfSCpDdPsGi5a8rGvhsEeBJS5F9gezceEDxFRJv7PzvQjqS
21220	payment	2133	2133	1874	1	1	521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGQ77KBp9JAYzhVAzJp5obMdbX2acZsWVA4asBqocaajRiRZQ
21221	payment	2134	2134	1874	1	1	502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FS5TSDceAsHUVPcaoFzhHct88xHubHANCYXaRVUiceWqBC9a
21222	payment	2134	2134	1874	1	1	503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4mw3o5wLsUq1oUdj13cS6mBJyBbetwDuLh9GsuPWzNoRFU9q
21230	payment	1397	1397	1678	1	1	9364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnD8feLL8J4vrqyaJiAV2rT7zwohDN2vhVRPMP8ySW3nUhNcV
21231	payment	1397	1397	1678	1	1	9365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yPR1GU1yqL63psRYAvGUfQq43pmT3ktC4aHBejUmvU1cLfjx
21232	payment	2134	2134	1874	1	1	506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBYzYqZ3usnKtPcqGE1Az1nAd5CFhCHQyqRm7mR8xMQbSX4nM
21233	payment	2134	2134	1874	1	1	507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUKRrVFbqLmta4553v3Pk7xcGVfKLhU3bCP67NN87xud3EPgH
21234	payment	2133	2133	1874	1	1	524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dEE3EF55YjcgGW1LbbDh9yita9b392X5bQzW5P2Db9i5JXch
21235	payment	2133	2133	1874	1	1	525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsT23PPzotjGWfJuAdQEc1KAwTCjc4sXi62UQLbjxVhiykNum6
21243	payment	369	369	946	1	1	0	2644300000000	100000000	\N	E4Yq93MArDhxZfapSuLkPQoxSJwZNeoZ3FNk9wG6qBb8BvJKa2BpM	CkpZTAXKiRQ93J4tG88hPmu5HBJDVgYmju25zTo4B9gBKruZKbHdm
21244	payment	1397	1397	1678	1	1	9368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARHv1EQGaXd1z8DF1wg5nZi6e94nqH23Knquw2a7RQyrsxYSH
21245	payment	2133	2133	1874	1	1	528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvGQ2bn5TbQgHaAeD65T9doMJ12j1GNoc1J31hTAd3ozZ4CJj
21246	payment	2134	2134	1874	1	1	510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24MZXhQqVRRZSCutBYM7PUiiho8JL4Pi41oYmm6K31ifDCoWz
21288	payment	1397	1397	1678	1	1	9380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cTNHGnFxboc4i474NaPYiAY94d6iTWsQmhheacg3z1shPa8U
21289	payment	2134	2134	1874	1	1	522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jA7oLc4KEQ1uqJEpny1wGd3LfPGkHELuMpXYoTYyoijDZ1q5
21290	payment	2133	2133	1874	1	1	540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4yPYLiNf93CPCnYcBDVQSyokRbGtdZC68SoAeQrVEusXfE1V
21298	payment	1397	1397	1678	1	1	9383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7mvys9HbbhsS7LVzeq4AEoPKt2QHW5Bs7fVwWoqPQRyJehug
21299	payment	2133	2133	1874	1	1	543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQeg62G7hyjD1MkQxfre1mup8LiGKMrE7FvSBGfsEmp1wB4RJ
21300	payment	2134	2134	1874	1	1	525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtf5evoshFCwhvisCeMQgTgByLgu91otWDWPCmNt2BVYsLJpW
21308	payment	1397	1397	1678	1	1	9386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiGidgZxpXZhGuxg5dJNsVecjWBsaVrRF1WwNwUQysueV2PHg
21309	payment	1397	1397	1678	1	1	9387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGf82XWPqbNSHCeweW4obUPMk4oykhdVZqe43V2922kUmJEnY
21310	payment	1397	1397	1678	1	1	9388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9EXz13Zfwr8YEtJLfJXbVRnzDGhsr54zA2zMqZ9NkpNNBkR4S
21311	payment	2132	2132	1874	1	1	143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhBScXCtzJWHpPgX6nXbyJA6DEMmE4Kkb5GBY3jRgFPLCywyG
21312	payment	2134	2134	1874	1	1	528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNa2YWxcArBYPk9AieLi2jmxFkvf5Pa9Zv4eAVhwHPP4TtCtZ
21313	payment	2133	2133	1874	1	1	546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZ1HvbsaCJRmhCeAW1HxsJq1a256U9uwY5JZzQm9rap3J1444
21314	payment	1769	1769	1769	1	1	34	20000000	1000000	\N	E4YPipufvPjbhKEd38aDyqKCfci1y2vteSzhfxspVK9kYWs1EUUwM	CkpZ1xgyRmcbgrCUz6Z3Z6FqrjgGamJ3ETAEYSjfeVDywDNEJAsEs
21315	payment	2134	2134	1874	1	1	529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnuEkcXRWWBoVXhYisZzqmFWpNun7sddwtszeX9cSexaHTmPqb
21316	payment	2134	2134	1874	1	1	530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4GJEkemTzojqfXLS7x7skTAeegXVGnorUoWQxydN1xUjg39z
21317	payment	2133	2133	1874	1	1	547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHbPKCnZCv121vqhMQPqN7iXToAi9AYV9EoKN2LaKXMv5S8NA
21263	payment	1397	1397	1678	1	1	9372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vrSBMkMyaiTsfL7XtRgvvEHvukXtVCEnjduUXg9zyfnXWkBa
21264	payment	2132	2132	1874	1	1	138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGzN5AoYNcq1oEcJuKyF3nmwjFxNN19J5nZSzujYF6fe85mvo
21265	payment	2134	2134	1874	1	1	515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHXqJFhkSuMZF6NsGrvN7Y8wDakNLUQMv4fsXWE7yiGQtxb1Q
21266	payment	2133	2133	1874	1	1	533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcUZ8aoGyBPSXCDB8JdjqR3zAauQwuawoAF1Pp7tVPto7hzqX
21272	payment	1397	1397	1678	1	1	9375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGVrdA9ACnxZiE8z2P1WFs8o8AEdNvjGKRnhyiAg9HdsjiEGT
21273	payment	1397	1397	1678	1	1	9376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtvKw324yRgcvyBnJXaQrTV8sX9aFkSs3mwCguRjedJjJBPhov
21274	payment	2133	2133	1874	1	1	535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyxESCJobhCwoBXyLUwy93EQQqnr4uyofzUZ4KmnxiuXFg6PH
21275	payment	2134	2134	1874	1	1	518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkMmUkpC7MqcNzSWuo1jMtWaE6SNy3SsenQmnP1LXc4oftsCS
21276	payment	2134	2134	1874	1	1	519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3DYWtr5BSEVJwxRthDKnnWGmVNT8DWYDiyJSqeha84Cyi1YW
21277	payment	2133	2133	1874	1	1	536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVY99pM2mgJegUXdYqzBHHEzg9fRpqcKeohe779YoPE9jRRa6Q
21278	payment	2132	2132	1874	1	1	139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVLrLNor7HFgi4jG3HLTaJu2JLhNMjJCAxgVmtiwpokuBzAFu
21282	payment	1397	1397	1678	1	1	9378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLBTbxnVbWC4Gbor7ocpNK5ZLK84bhquoe8Mbg7g5mx8WsAnw
21283	payment	1397	1397	1678	1	1	9379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VsygYztHR1yJ5VEsygUTNtGwWEmaxpxpgeFbc2ogULuxbh24
21284	payment	2134	2134	1874	1	1	521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbxQUuA78hxfiX2upHn6Bq5Xs9nBWSXhXuTbubFk4RJcgJvRh
21285	payment	2133	2133	1874	1	1	538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZYXdrwKGGRwvxsunSNnWisC3RusAsXCXt8QXTzQhYSwzD2XcQ
21286	payment	2133	2133	1874	1	1	539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd69tTKL6S17z4ufAheaDBDq9xF42bAKRzHTLA9QoxrHo5amrS
21287	payment	2132	2132	1874	1	1	140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwNGLB19CGfjNiArPSzb78AeptCJe8NisGoUMfw1yh6W3y6Dq
21336	payment	1397	1397	1678	1	1	9394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JgqFmypyMbyMSn3xtwcMZE2jRre2h1K5CF6zCtJu7NH6jp4r
21337	payment	1726	1726	2150	1	1	8174	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWibGu8XfGfygZX9qi6kx4MXMg22urGEk9J1ZHkeFrCPv8HZrp
21338	payment	1397	1397	1678	1	1	9395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEAk6fMvDeFvg9NUfFobLR6A4ti8yrmrxdwxV2nfbt4LFMtfnQ
21339	payment	2133	2133	1874	1	1	554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPBpLVMYLaqcDW6kv95VKMuRFk5BSDFXibwbRki2pDih4oVih
21340	payment	2134	2134	1874	1	1	536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6U5Y4Vtd7j1mrwZW2DEeQ6Y5u6eAvAv9xvmhVoXYFPs7iHrR
21341	payment	2134	2134	1874	1	1	537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffpwfuahorGmw6PSBwsybKSYYEGJJicUn6TaduNdtNRxwBrnq
21342	payment	2132	2132	1874	1	1	145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwcJH6UnqCTS2BLzTJxvRNkAyzPkK6nEatXXjao9wNoibhbbu
21343	payment	2133	2133	1874	1	1	555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZfRUHBEy1CaZnc9XSzKVhG6DoBHrEJbptP98hsDDfvd8c8Qs
21354	payment	1397	1397	1678	1	1	9399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ63P4bimJ3ZK7bE13xyPfVxqiZzz48B75dLZYtiUhmRCmv76mP
21355	payment	2133	2133	1874	1	1	559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmJf1Jzk49dn7NZhk66rRU3R58WgnDfAJz3pzM6qKDLrjxVfY
21356	payment	2134	2134	1874	1	1	541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtf5AN3msCfCBhDSgiujmmG6mG5pRFCwhMGD3AcvUZwao48ENB
21357	payment	1397	1397	1678	1	1	9400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1TgbCESTbwBnDDWCNpiNznj5hksaMHP3aKf1wHyAVHr4fCCb
21358	payment	2133	2133	1874	1	1	560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCvLZiSEGLDTRXyt41sHQfZnQgfHPQ8iCuQ5eN9RkgXLrXW3r
21359	payment	2134	2134	1874	1	1	542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZd6qtejj1PZpNHjzFLnqEKeMWSQVHFCw7KF6Qs792spb1cvX
21365	payment	2134	2134	1874	1	1	544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDePgUhtfrBv5xWErHbzgCTVq49vJ8ANXj49J1eUnvF7JEQkXu
21379	payment	1397	1397	1678	1	1	9407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkW53ApsFGb19Uev6bmuevNSCPLZ485ESUy4Hbb3kgDkafBef
21380	payment	2134	2134	1874	1	1	549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdvnpUJrLNiUjCcGnv5j4DCPzuthdQ253nbeYG7LZ5kiqudxg
21381	payment	2133	2133	1874	1	1	566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxaBfnRK1LmNdaF8Ku836db3f4QDFs3yhCSAB1QC3Uf8ummNB
21392	payment	1397	1397	1678	1	1	9411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAd8R8zuoYmr9G6cfHYLrvrpxpofWTDuiB25Qx3KsWffuUGoK
21393	payment	1769	1769	1769	1	1	36	10000000	1000000	\N	E4YTc3SA816XMFHyEG2rjgP1f3eFoj9ChqoLVDh4jx8cfp2gRkYM3	CkpYmDuURmgGKmdkKhx1x49LQt3URigctYSwhGdLure45RcoL3Py2
21394	payment	2133	2133	1874	1	1	570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdcrnkop5YSjkkLxdSF3AjqD2U9sWgnbq13hLHWHNtu9rVb4W
21267	payment	1397	1397	1678	1	1	9373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmF2wdAzttnd7kRDU74A1QTkXXzihhP7rk68ccSwgYXtANaP8T
21268	payment	1397	1397	1678	1	1	9374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnERcmzZFsPhLtkcEjUcTBWEzpoh9Vmt99t7PpUNc62hY4HwX
21269	payment	2133	2133	1874	1	1	534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnubgy6PRvWa6fknKttxGxcN8fvsrofiUnFPsGjZ3G9MkVhtoj
21270	payment	2134	2134	1874	1	1	516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4U2A1dRJnafqve59hKd2buaRY6sqn2xWetERsZZjStssF6uzB
21271	payment	2134	2134	1874	1	1	517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpD5dn6whttx2bsJy6vXAir8RfcFG21Du6zzd1kZ6Hw5mJHxx
21279	payment	1397	1397	1678	1	1	9377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa18am9XCwvmqzMtNRcCMiesh3JAdNvHWSutDhT9Q7eZR4NFfa4
21280	payment	2134	2134	1874	1	1	520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX63T5AiizPWtZjDoisjx2Ezj5iCJxZsmPBkVYCTtkt5q4xHL8
21281	payment	2133	2133	1874	1	1	537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkovRnuYo4vSMJgkwdD5KPwaBaQY8RkwnKSRKc8cpiBCr7vj2G
21294	payment	1397	1397	1678	1	1	9382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdUKiBdm9ios2m4pj3Lgwp7Jq6BLMbryXPyTnRrpVFNZeMH8tQ
21295	payment	2133	2133	1874	1	1	542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvxSUaQ5kexi9Lc5XcHCkVVaPiSapm12237nEbJMDqppBk59i
21296	payment	2132	2132	1874	1	1	141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmmfdmHuLcGFtuh3KzxwGVkgfubkczpZFiu1btQ311EQUEQRt
21297	payment	2134	2134	1874	1	1	524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbYnLrgt1qxRun3ERQwxcxJ8tX3SHLX78SRCZtzXybm7b9vYje
21301	payment	1397	1397	1678	1	1	9384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAD2PLCgmA39eAXnWNMfAqDAJynqjExw8Z6Fv718kTDKaMjnLX
21302	payment	1397	1397	1678	1	1	9385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJsp7MKa9i9z17NUAwEFvMQh2MfHUaAQEg4YprTbT7Axx4jGm
21303	payment	2134	2134	1874	1	1	526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ns4KcEm5tx124mpGqcWQa75k82ETt77D8s1shYeznMwkXgtR
21304	payment	2134	2134	1874	1	1	527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ98urQDLq3GfydnQ4aTDFaLfwEQnsPMYz9qWrxqZTyTawjE45H
21305	payment	2132	2132	1874	1	1	142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1w6JAK6hCovzRFeCd5ukDELUhoVgTfPvuVMtYAKhNGPwkwWX3
21306	payment	2133	2133	1874	1	1	544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MLxpBuFNVveX6GfquxeywzfS4XDzRFsebjLBUDR9S59NhLx2
21307	payment	2133	2133	1874	1	1	545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmWH4PnYz4waLcNs9Cr5R8bxHnrWHYaQ8wMsMbznjk3rREYUA
21333	payment	1397	1397	1678	1	1	9393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZzHsUjPU85mZucSXnzWvoewnk6Rb5yJQQ21aZWjWm1Qt7zqm
21334	payment	2134	2134	1874	1	1	535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFec6Vx6Gn4hszP1DbZ2cNXpX1eFx5Awz1TDGvvcPMRNPHVVX
21335	payment	2133	2133	1874	1	1	553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXB2zSPGzjJju3VtN4MrQFAr8gwim8N1gyrF8VGFCdUeZtavA
21347	payment	1397	1397	1678	1	1	9397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8Fcyqmkk2H2mHEwV4YdXMTcGwb69fJw9y9g8sXMGfX3qMrxv
21348	payment	1397	1397	1678	1	1	9398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYtTgTWYdqVV8hB7AcyJqJfRagUXYnHRfC3iHYfHjJvNmF4W2
21349	payment	2134	2134	1874	1	1	539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCLj5Cgd5H81bCJf8S1vNSE4dXYCjUm2m4mPraY1zPenL9mjX
21350	payment	2134	2134	1874	1	1	540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEDSVw7mc1eP132HLmqtKrSr2isS1wdDsZh36y6Gbtj4iSvQU
21351	payment	2133	2133	1874	1	1	557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRA5gMsxAr9gxrKx49gr9VCzfnCR9ShSUkvGx9ps3nvHHUMJS
21352	payment	2132	2132	1874	1	1	146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMVMJVy45j6HZNfzVK7KCJ9RowPYiCJaBtEzxCAaPVMrpFezV
21353	payment	2133	2133	1874	1	1	558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF6rFFBrYFY7nNoxqq3DApw4ZTRM3LBLMdtgr3cuj8fCQtPhxY
21360	payment	1397	1397	1678	1	1	9401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5sv3PAtjwAy5jG9dGWntPVQ4tUwn149aBiXRwUTqPRAtQxe8
21361	payment	2133	2133	1874	1	1	561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNoiMtQxeQK4pa8RUWqP7LcLF1L1R3TdVnumpUE1tm1s2FgXp
21362	payment	2134	2134	1874	1	1	543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGJvqZR2UByPEwKFfbrSAowBi51XVYdUFQvLuyVJpviHa7qP2
21400	payment	1397	1397	1678	1	1	9413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYucjaWs2Gt9NowtsU7kqzk9uHpasGx4DdQ85KSLxALssHoJH56
21401	payment	1397	1397	1678	1	1	9414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFz7eQ4CUaDWcTUwUyUAXvMPcJXPsfZkUiSFGixnTakSMCYgvP
21402	payment	2134	2134	1874	1	1	555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUEG89T2VzksqhA6TUYJvhCSgu3d3ZGgFFuQcphkVe3RUGT4ej
21403	payment	1769	1769	1769	1	1	37	1000000	1000000	\N	E4YjA2r9h6ReNRESkoVjezFpTgnbRvyw6wwGMkMYJJXbWQmG8GHd2	CkpYbir9yggqws7DaNF6VSPeWMy2ZTiSnhR8S1TcxV33PERSwyPQT
21404	payment	2133	2133	1874	1	1	572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKHNdAwcvELdBx3cuiMm8CkCTcVtYeSk2aD5wfEvdEPHUnPrT
21405	payment	1769	1769	1769	1	1	38	10000000	1000000	\N	E4YVYpcXYqGw1TihHE6AVSsn82GVn5WHobQWqTeNgrNxSkqxMs2Xs	CkpZt74bCb9UgwBLaVbGsNzhKQXfGAZrebE4ER7v7K8XkZTDBA3kz
21318	payment	2133	2133	1874	1	1	548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQCff2dKgfz34Ja4cm3oygrraYugN1bMtEtwT7CTvtmHBN36S
21326	payment	1397	1397	1678	1	1	9391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyh7ghCgD51XYaA5fSRr2CUwnnNW6pNsbVCN5PQc9aNFEh4gZ
21327	payment	1397	1397	1678	1	1	9392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TcAqQPNyJ4otKyx915jGEj7p2g5TavUaqDvcg22L2AiLZWu9
21328	payment	2133	2133	1874	1	1	551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUJzodaBmfrCC1SMCxFfGqM7Ywo9ZFdYp4LYyGn7XEkmHXS9y
21329	payment	2132	2132	1874	1	1	144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtxmAMvYUfpSw2rXGTbxbRzGSCgQz1dmi84xGkFxQaRMPES7M
21330	payment	2133	2133	1874	1	1	552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo475Qk9YHASHJJ4NuqYP87JncWHTAKcHg7icQr7Dyk5jwXcF1
21331	payment	2134	2134	1874	1	1	533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7kVg9DENovg2UiHnGnBD64Yji5ayVWwECP13iwXmd4pd5XUvE
21332	payment	2134	2134	1874	1	1	534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnuFLaTs5N7jC3Mgf2mhC3u2Z3RBAwGtUfxPdqLLceyms1ZoSQ
21344	payment	1397	1397	1678	1	1	9396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ54dvG3R55sFSdriPDaT3RoFN5ZFXsH1p9wCvbGkZhpCVf5bz
21345	payment	2134	2134	1874	1	1	538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfU5JZHVVypvnHrfG9inbHio3KrUNd8ieKp9iXizD5YTBXjit
21346	payment	2133	2133	1874	1	1	556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3n1PpSFJ5RXGQE6XFATSM1xt9LA5GM9AK4xNPCjYaxAeKUBt
21366	payment	1397	1397	1678	1	1	9403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikAYmB4YZ6diKmTEJp8knThABemcnPSFXnMAteWTHEU6PD3nf
21367	payment	1397	1397	1678	1	1	9404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ynyb7XChUGjZWPkuxpPTzxfVmT2UeENqqEJ4mYsdJHWV8GVi
21368	payment	2133	2133	1874	1	1	562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPLHRQJLjQYGf9yfdxCo5mbnhgi8Zarz9VwMxLfXPK48zqTAf
21369	payment	2134	2134	1874	1	1	545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSBGpW9n3AgMsWh1iMSGCeEidPxrdz7T6en3yoWVTm6nFdG38
21370	payment	2134	2134	1874	1	1	546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBNNj5yCzDWxWNFU8UDEV3jdHzvTA2KPgKVAwLENW5mUz7eeP
21371	payment	2133	2133	1874	1	1	563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGaHQdFNsnXUCbp7DKRvpEsENDP23BJ8sq5QYRAQT2XFgjrpT
21382	payment	1397	1397	1678	1	1	9408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxd6KzmUg4TLCPrS2po3g19oZQojuCHfGp398bbUfe9WffN1hi
21383	payment	2134	2134	1874	1	1	550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyX6WhMWmP2u2jntttig2KnCBxUY3TcWsQ2hohAfMkkTeyjxp
21384	payment	2132	2132	1874	1	1	149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfUSDg38dFavkXNSYmKCX987pdLQkK2gvHyQn2xH1pm6NNiNt
21385	payment	2133	2133	1874	1	1	567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyT1QPD6Mw5fHQdXJ598qzdQJEAAjeqCazE9RsLSRFWfV4Eszo
21423	payment	1397	1397	1678	1	1	9419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9qfQqsPKSd6cbQNRJxxD3GZuqmVG2uEuzdfD8DdSiX7g6us5
21424	payment	2133	2133	1874	1	1	577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaz2AB8XSmkAX21ELDj9oDSNWCPWvfTQhugRaaJkR33Ez61uv
21425	payment	2134	2134	1874	1	1	560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzSiEXtqCf9zi7ZYVGVfz2bGhDCi37si8vBiy5YG3cgzoWmox
21426	payment	2134	2134	1874	1	1	561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeKf43vqv9ua4QQnvKWokSrpUhe2SaGoyE88NP4ez2WUrwZZr
21427	payment	2133	2133	1874	1	1	578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMZwj6YFDRAAqgqgXUnwGwt5z7SfpLVGKsjGNaz4vfZ9D2i8m
21435	payment	1397	1397	1678	1	1	9422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqobmzg6E18epLT8qd7ZXc35tDjhEPYTMCRUXeWUyTxubumbD
21436	payment	2134	2134	1874	1	1	564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKHYxBThq7hBA7H16kTQFcYYvFLd3YfM1MskKTmRKgV3dr1iB
21437	payment	2133	2133	1874	1	1	581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoP74tQFqgw73Tdy9ziRS5k72ZqKgLYceFauLCcFL8jVBiHU3q
21448	payment	1397	1397	1678	1	1	9426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv575c6M9EqXkLepQ5mXVh2EUeooRsFdbkosyWRwHnyPdb3N7S
21449	payment	2134	2134	1874	1	1	568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSekknaJhdHEVpLFTQ8MnU5dSWozKvsFaeAro9mP22unk1vMH
21503	payment	1397	1397	1678	1	1	9443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRJKcQsm59fkZeZFHpS31df92pbaZUUeagYDhqK9JVjAaQhZ4
21504	payment	2134	2134	1874	1	1	584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WJ9ZmfykTPMhSCLd57WuU2xNZfDczovS2X8X47LtxsmfyZYg
21505	payment	2133	2133	1874	1	1	601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iKAn64aaQTw4f3gqn8H2Tg53UjKB4LsTf7QMRCC7CJaV9LFM
21513	payment	1397	1397	1678	1	1	9446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5crXXpx92GjGM1RZRmXRiQhRst1TihWdMsBquYcNaZs46EEc
21514	payment	2133	2133	1874	1	1	604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRVywYKLuwMP7V4eAdB1yCxtx4kdGaUqG2F6Ez35k8JG6fA1u
21515	payment	2134	2134	1874	1	1	587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GeqednZZJKw6yqhrkQh7jpj7Rt1ALv9rFmpcyi8EYqV4pxRb
21516	payment	1397	1397	1678	1	1	9447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsqF1kH7619qXaqDMAae1NZ7qV43okPp3LRPNrFWasZvGajJyD
21386	payment	1397	1397	1678	1	1	9409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPzaW1WVrhLpFKd4bEBr66Hdw3JLCvUkStBbYhfYr1QCEbERS
21387	payment	1397	1397	1678	1	1	9410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKatVD1zPNVgKppKQcMJtguYaRwemR7a2Ds69wqidau7pTMw3
21388	payment	2133	2133	1874	1	1	568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLNvfwXf3RAhenGFGMCRgdkHSKqhi8ASHrUF8T3KFKuDY9ygs
21389	payment	2133	2133	1874	1	1	569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS69eYnDEZ727TPP6SJs4XBtdFH2WVMpvTEnB6VqhSTAxL9aFh
21390	payment	2134	2134	1874	1	1	551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82uVvSe6Dc2Esw4K1ybVfBJp6ce2YG7CmepC4gLW15fC6yznx
21391	payment	2134	2134	1874	1	1	552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSrr5DVVZTe7FvYP6nFfm9LQos3LDYaa5LwHdvC8C2op9kyEB
21419	payment	1397	1397	1678	1	1	9418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSKJ9oYm3KRge8aZQkmaGpYC87WkcDBpT2b11N2hj6koy2QPR
21420	payment	2132	2132	1874	1	1	152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4D4mozeYhZ8J1dx6N8bPZ2zsmY271tQDRastbGutf5AehWRrk
21421	payment	1769	1769	1769	1	1	40	10000000	1000000	\N	E4YhDHfvF4aDhC6Z2sBFzV523F8Xiftoh6pYa8ChqazXWfoW5ZZbF	CkpZr9hCKCs1Wh4jwQrEMyXwqt4UqfurtqdRZarURCaMxFuiv5gvi
21422	payment	2134	2134	1874	1	1	559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GCYHkVA6zZr3VJz3Gvgrq3uMP11bxqdZVmePukdZFazSHEYg
21428	payment	1397	1397	1678	1	1	9420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bQm4oV6aSEpvmrDz2ZAtMo7tcHYPtxddDuhHncwuofD7b4uS
21429	payment	2134	2134	1874	1	1	562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigym2VuuwZpkopq1wMNhUp9kd1Bs86K56BpacE51y1h5roeGj
21430	payment	2133	2133	1874	1	1	579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeao5avRWdZbJDPeDfB3azAjLCrAit3HY11KK9DxQpYeEgiXLd
21438	payment	1397	1397	1678	1	1	9423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJveNnqdeiqzAHn3fPBBBhd7BaA3zm4m8v9LmcTH1bQSb84Co
21439	payment	1397	1397	1678	1	1	9424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWwVnfgGKEiwqevKyUZT8Sx57muEfSjHTossvEiRmekJzLMJP
21440	payment	1397	1397	1678	1	1	9425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GwYRwtADiP3A17x1CWJGVAKmnq24nqK8WH2hfxFGNrTV7gDT
21441	payment	2133	2133	1874	1	1	582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSB62634yW1aucuQLJmkpxPERDrGn9Mmq4FW1m6ph6AoYw5uy
21442	payment	2134	2134	1874	1	1	565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpC3BhsY1eFr14wS68ssnFXou4dQ5a2VjBVeVS1TWPypkSLzE1
21443	payment	2132	2132	1874	1	1	154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZvo1SuKC4FUTEuGLgZJWP98noiKtc9VuRvUALRUYdDYotQJQ
21444	payment	2133	2133	1874	1	1	583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRH65qzuePCvQeeAd1HuD3jLmGDwGVY3WJHt1JbhZA2uRtt4wY
21445	payment	2133	2133	1874	1	1	584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYz9YUSnYsu339SBKVZrugoQL52ftxLzGTQRGqvrDV5tm9ahSU
21446	payment	2134	2134	1874	1	1	566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ERaErhjy9aM4jjyeXkb1Te6PP1wAKQnzfnUiZhzkdm4PfhWr
21447	payment	2134	2134	1874	1	1	567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeoJAGgwKaCBv9R2cT97JAARuxPJU2onzi7Cf57orq9cCNt1HT
21450	payment	1397	1397	1678	1	1	9427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNef6vgMGCkJZe1ciEv5cyqvQm5bBpWu7RJRos1L24TzP896UH
21451	payment	1397	1397	1678	1	1	9428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNpjxt5QrRBuv6A5chMz4aP5p3H86WpALyhWmtWwjnKG3zS81
21452	payment	2134	2134	1874	1	1	569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFHGHXXL1bNZQbcGtyahQ1oZ5R4hCQDPwZK9r2oS47iodhess
21453	payment	2134	2134	1874	1	1	570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ET587vMMSPbVq45H4QYwr2y3UvkCedUYzro2ckN8HtbSSvu2
21454	payment	2133	2133	1874	1	1	585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyQkfm2KUyY87Fp5BzZTQshw1EQ4Tcq1hmqbdQpy7iig127aE
21455	payment	2133	2133	1874	1	1	586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSnc15D8TMznMMxkQ5XGSF1QtJ83hNNfmcYgSmwqkJ8EY25VV
21456	payment	2132	2132	1874	1	1	155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSocwwgWZx1CzS2PazkqsFJjVmWG2wxdQ1KFTCCKoZHifd8tK
21457	payment	1397	1397	1678	1	1	9429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6kh9Q3FnAw81mMTEiQ9faSfCMkxYMRt397YStc6skb6rFWbz
21458	payment	2133	2133	1874	1	1	587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhW65F9a83otxtoPp7PsxEn9iurjwF5HjkUiNsY8eHV6cF9tH
21459	payment	2134	2134	1874	1	1	571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQbz3DVbRp7RyZm2mRLcvJxfZxtpuDa9cRsWheKQxkV9ZW3Dx
21468	payment	1397	1397	1678	1	1	9432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSrBrJXS8D8u5E4i4XZmf3PhNMGp1s7dzLBRRfYSzU6GrAK7W
21469	payment	2133	2133	1874	1	1	590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWdcD74Xbebbz9KVHyVZrm4oiucZ5TUjFZm1tWH2h4p3jsarN
21470	payment	2134	2134	1874	1	1	574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVV2H3bbNip1UZLEqPNHgChezZbQs64G9Htn8UCd8ok4ayuCUJ
21474	payment	1397	1397	1678	1	1	9434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhFEkG1Dq38g9pKWS7gTGiHyGDUtxa1SuiDMFnD4ymXFdThun
21475	payment	1397	1397	1678	1	1	9435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vM7DA5R4cgmBXGxUZPHiMJ9hYpVSDNLUh6BhZpXAZZMNG1U8
21395	payment	2134	2134	1874	1	1	553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyEZt7P4k6FmC2yyd8mxvJaYkqwSyXGuqHxWHyhXdN1mLFbGj
21396	payment	1397	1397	1678	1	1	9412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8zonNBsDz6xu8KiR2j933XoppauMuopiZNj5ZWv49mHQDruy
21397	payment	2132	2132	1874	1	1	150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvu5LgE2WDbSkEL1wZyaZNL1DeyhMVowipefd3JWBefUuQHGB
21398	payment	2134	2134	1874	1	1	554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNEEFygV34gJ5sRpSwgzkN4uPe5PJz8qPdF6noBGHZwQJbBYS
21399	payment	2133	2133	1874	1	1	571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADoR7bwugcw1apEyXCAL3NBvywXmCrYQZwD5ELCyKfmg3pxXR
21460	payment	1397	1397	1678	1	1	9430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7bK6d4gXEZ1mLnX6k98Xtgfz8UJjU19ZEub1Sq3nd1qsYxA2
21461	payment	1397	1397	1678	1	1	9431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2f2Ge1UqVCwEzGQ72ke5tawMjDg9Xx3ayj6HURGGYH8Kt9Kv
21462	payment	1726	1726	2151	1	1	8175	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa9nySxrqcjZKJfhHWxwsZYSdexAvFbMz4Ng3qy9xydTN1LnvBh
21463	payment	2133	2133	1874	1	1	588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUYnAQJVHcJdCneWYALG6Znibr2dn1CaEPFYGPXs3XWxmq71kB
21464	payment	2134	2134	1874	1	1	572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qYQEGYBnbZV8Bsmw8DUFrwuQxzzUuBKGqb5GfExTstKqxZ2z
21465	payment	2134	2134	1874	1	1	573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYsfDNjuVk7o1jREuJHbUqpMURAMXCXcT468Vw28KtKgDq55k
21466	payment	2132	2132	1874	1	1	156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULur4tEig8fdkCZLPPJgFj7sTM9bibB7vAB34pA6pomcfvhGA
21467	payment	2133	2133	1874	1	1	589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuDnCN2tuwaZWZ3dzDR9Hypb8yXxkQqzHx1Y6zk9UeLpyNjHF
21488	payment	1397	1397	1678	1	1	9438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVtS25QtymP4DJJepoAoZ4f2KUVTavPAT1rFWaqmk7bw8YcV8
21489	payment	2133	2133	1874	1	1	596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjewmJLAMXRaK5byVD16vvSBcw5wmPTm9SR8jj6Jj5pViDcrxz
21490	payment	2134	2134	1874	1	1	580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcErU99SkUd7V4feut1JggeriEtVkGJCi126otFeNM15JybzYb
21491	payment	1397	1397	1678	1	1	9439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6keWGACc2Shd8mNPgRLiixBRtXcSk2eEK9TxwWyPEbQMQG7b
21492	payment	2133	2133	1874	1	1	597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Wh55DeBRNhdcviVt2AVPURGDvu1nis4dWNFGP9LtKSRwNwc8
21500	payment	1397	1397	1678	1	1	9442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hcuhHqPFrS2xhxSL1Q5JuAA65zm5Ec4gwfY5QGfMkaK9eyra
21501	payment	2134	2134	1874	1	1	583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTsfVdJVFbhY3wdiV3fnKrTbRUfoXCzUkp1njqGgrHccaWQwy
21502	payment	2133	2133	1874	1	1	600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpRrZbxmfWeeWaLdjXF6zHSBJMb7M7SBRCzC4iBjSe1PhQ2zo
21544	payment	2152	2152	1860	1	1	0	1000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKdag7GMhQ4PMyQno9nR2Xh1Ccpb38Rdqf1W2ZEFrHvvpMUhB
21545	payment	1397	1397	1678	1	1	9455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabyBYk27Mm9socs5eCkPEPRrd1kRKHgmSQmtAuLuEHz12gEki
21546	payment	2134	2134	1874	1	1	596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYswkM3Ww2JfW28VULUKP441buiF3SKSeQGTsZfmKUEsfNNEACe
21547	payment	2133	2133	1874	1	1	613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqJhNpdMZZUSxposnV4Jrt1BWtUahaxNAgrTUdwPsRW1pgt7d
21554	payment	1397	1397	1678	1	1	9458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJDT6P8rxixssA71dStfTBY9n6oWr6t3tJh9HDUsCbnGEZ3io
21555	payment	2133	2133	1874	1	1	616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQta6q8A9mjUsQbqkkZ2zbVbGzmqujaoPknDQcUbHJttkUqSEt
21556	payment	2134	2134	1874	1	1	599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2pS5mP9syn437vVb9oKZ9zvrwkGwyBr7Zy51E3pMw1CyeGBB
21557	payment	2132	2132	1874	1	1	164	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrhmvDxmtGAHP3nLWbcwxihqe3ZswsncfsKqUj8TTjwt8Xpzu7
21571	payment	1397	1397	1678	1	1	9462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfodPEZh9xmK4nobL1zbmFkWxohjYCuvPpMyKXwSMVVoDeoagV
21572	payment	2134	2134	1874	1	1	604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGGuPLbSne6ow2UkHctLhkDxiwmdys13c6cSc8knPfFkAhpAZ
21573	payment	2133	2133	1874	1	1	621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZb9aQz74ufj2QJamuMJi1hXpvfdP6oogxCFV4sZeEmVpFHGdk
21582	payment	1397	1397	1678	1	1	9465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KphnbHXL9Cyjwh5qTRrKzHYAcNwiD8ZfSDsxTGpvutE3JJ5F
21583	payment	2134	2134	1874	1	1	607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAJyCey1ycKH2SZZ27nG5rvgQeTvD7jYuuNu5AqS5gSKpdPHD
21584	payment	2133	2133	1874	1	1	624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzJLqdQN7VSWtLGF9bLLW4MmdNi9gVfQKMms3pGJNd8oryhwp
21593	payment	1397	1397	1678	1	1	9469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRk23NsD2i6Vh1QUSM9bdC2Y67p8HUAX4aNgKxt9YikqbpmDu2
21594	payment	2134	2134	1874	1	1	610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xy75UUY3sEFiXZDiNciyLnvK7qBEZtNaseJ1iSiw1eWtQB1J
21595	payment	2133	2133	1874	1	1	627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnidEme6nUYaU6t9BRFfdPZbg6dKkA3EuAn78XY2FeGP4LbFu
21406	payment	2133	2133	1874	1	1	573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zVF3aWUyCm7ueHzWn3oxbFv4HRqY1SEsfKbrUvDXPce5jPQE
21407	payment	1397	1397	1678	1	1	9415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcdcXMaTrSxYF5yPs9ZhvNrhKemRFbd8oMHRicTjMria6SNxi
21408	payment	1397	1397	1678	1	1	9416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASMj1W3ZqFyatBu2EKenJjtUqKa14u1ZLnL78ua31RNYYrtFM
21409	payment	1692	1692	1860	1	1	4	63603032300000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKmprMEkMQQHioW27UPz4kX592YQnUvn1W6EPy36z3Krwd8xA
21410	payment	1397	1397	1678	1	1	9417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEavV6fz73ykNo2nraaTP2WDgvVCApyadpGviskUKfgGPAQ1nt
21411	payment	2134	2134	1874	1	1	556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmbS1dLcDSmJimGNxYih6tyFnAkvVof8rXo5pLZjtxMexynFy
21412	payment	2133	2133	1874	1	1	574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLJx89NzgYHbwFKFmLXASAkGJYn5miyvpQq3obabaP4Mpxj4D
21413	payment	1769	1769	1769	1	1	39	10000000	1000000	\N	E4YXVZnkzvRdfN84ziy16TizTiufGfZWr9fqgASWoMsixoto1uiVB	CkpYnAbWgU2YVcn3b2n3xXzxk6tNtN6XbyxfgUf7ju4cQPBg16nnZ
21414	payment	2134	2134	1874	1	1	557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsk6RGpPnMpUTpPsrNot1uTCfCsCKrMWFHwcjzS6dz5jeMKVK
21415	payment	2133	2133	1874	1	1	575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uaTvA45GFyhAT7Has4Ghmnb9vQLEb2vgAeYt3guijpUUQZLR
21416	payment	2133	2133	1874	1	1	576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAniavU48H8yUUPDK2sJhEXg8b7gTF1oBkQ9FxfGfKhkxupjZH
21417	payment	2132	2132	1874	1	1	151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiTUXLTAjcWw5ufw9T3AVLPv9PqmRTVrqa5mo4JZvh1PAAnHi
21418	payment	2134	2134	1874	1	1	558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfeu9cV2g3CHPCGJR73FsYPZUpMyq9MBVodchHcT23sDy5nba
21431	payment	1397	1397	1678	1	1	9421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyPptrWkdv13sYZiCkBEc3z5HyDfxebAYe9GSRRjuCovS6Ddn
21432	payment	2133	2133	1874	1	1	580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeB1dwGM1ucibZtnJHaYcxhAMVcHCAcUdYum2Tpr3heBscsUyJ
21433	payment	2132	2132	1874	1	1	153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxm8WoVi3qxeALhGtgWBD6eWGfP29ky2HsxKei73QWAdYvVYYp
21434	payment	2134	2134	1874	1	1	563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQUby45Bw6PP8pNvu4uWq2t5Jvhwf4ky3cfT2UaAtC4rFQh4d
21471	payment	1397	1397	1678	1	1	9433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gxvjX9jXyWC85vxnEgxZd9fy9aexVg1mkEByoTt3oU2By8rk
21472	payment	2133	2133	1874	1	1	591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9tBvmidrMSQRK1TjBcjoNpLRKVTuczhi2cmDc3oospdXi96h
21473	payment	2134	2134	1874	1	1	575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH64sL7V4HYGHUce2oEjFMgQYeUdgW7LvnFAGreDQtcQquqSB2
21484	payment	1397	1397	1678	1	1	9437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydDcZcPTWa7virEB4SSoQAQF7mdjPrYXU3chRXWecheLK3CGv
21485	payment	2133	2133	1874	1	1	595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7vgwE24MRLyMvoSDH5M3RQbW2phjAwzJJ4rWAxyfs4uZ6g6c
21486	payment	2134	2134	1874	1	1	579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3B8Krjm18n16p4DsSfdkYTZoCwqfPcHxPU2YBSKgHPpnm99a
21487	payment	2132	2132	1874	1	1	158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EogxVE2DPLEMnDzDbW61TUFrNmFeJwAmS1n55CrxmKNZuuhg
21496	payment	1397	1397	1678	1	1	9441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSED4U2MnZvGiykqTcMFuof1FfB99Thc5ckUoKFQVZEgMdCZ6A
21497	payment	2132	2132	1874	1	1	159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxbVB5LuMExGCDxVqLeH8Dth3y8T74fT1YAxdYGCoGioKuUrz
21498	payment	2134	2134	1874	1	1	582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYs61f9SgGPTB13NBGPQqkCojJP8LzS4r6pRpaYDhw8FKSjTDK
21499	payment	2133	2133	1874	1	1	599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZuQYRDc9qxYkouUV9E8R42wZiGihs2RBVoocEozV9aLoo1N5
21510	payment	1397	1397	1678	1	1	9445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMobZZqPRR6RCY2m1defrf9o1Ttv4vwoHBgTUBpm8zL31HE5T
21511	payment	2134	2134	1874	1	1	586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCxqowRhmqM8GQc9msawdPvbBeBWji1wcSnVCMgLNZ86CLMupK
21512	payment	2133	2133	1874	1	1	603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZey3C5UnXkwwxfhsyMbxXLazi4NwxhJyDgdfxN1xpBnKkekUok
21537	payment	1397	1397	1678	1	1	9453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzGPj8FaDg1W3rCpRdfJFK5ECsTmQHrk8hHx3Q3JYJQZSPzht
21538	payment	2133	2133	1874	1	1	611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVVkSyvVe816PpJN7LkYXU1H9P58ms9zjWPKtYjyp54bgtrT2
21539	payment	2134	2134	1874	1	1	594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQ1iu45GaQsLCfShHhfwFp2SS9gvPe41aEuqWaTCWHqYAb5pa
21574	payment	1397	1397	1678	1	1	9463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpynAFcv4DGvb5XJv74gpojbftYTktZfjmoYKKdXbGQ6niemkx
21575	payment	2134	2134	1874	1	1	605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCEWC81KhHpSVDJTS1fscciHDTwxsKcUyVeCaAwx7sDUkyBV3
21576	payment	2132	2132	1874	1	1	166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQfb8Hh6gXWGrKxvkzZhKtroC2o9gVTCNvMaPHxLH5uubXZfF
21577	payment	2133	2133	1874	1	1	622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXed8rs3enLi42nEJWbeRtedzXoCUPJ9eqFL7tPRsXGjbjngFq
21476	payment	1397	1397	1678	1	1	9436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58tYgLRcHg6KFdQFKVwi1JQgnssSVdWNv7DTZL3QFdAp7nzaQ
21477	payment	2132	2132	1874	1	1	157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNadzgu8wFiTb1JLyr1aQNVn91bDQoMXEnpc74BuLJdTNMD7p
21478	payment	2133	2133	1874	1	1	592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyDsZaAB24WSHHtaXAJ15d5qXY2M1YY37ytgidpx7HpuszjYd
21479	payment	2133	2133	1874	1	1	593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCUmbPirAa5RF2a8ysYfoUYVVSgkdGJ8qovff41UTF3pXtC8W
21480	payment	2133	2133	1874	1	1	594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmm2DamzXdVMvfqHgNp3SAHrbgpoVPweesbreW1DY4tq9HaTYf
21481	payment	2134	2134	1874	1	1	576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvhBS5rZEjho7nioLiNZ7zTJr1BTJQRxpeSM64dofigEMYjMQ
21482	payment	2134	2134	1874	1	1	577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgP6uguBzASeZVE9Mk4utw7FVHUNHK8ktUDH69epQLPbiBhh8N
21483	payment	2134	2134	1874	1	1	578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgJjJEiuetodZ1EecAn5X8ha4opADyYHr7Wbr2nywbbUN5E38
21493	payment	1397	1397	1678	1	1	9440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MSKsfBCATsW4PMVJkHXupNmCipNgLFucNU4zE2U1L5AHc3yE
21494	payment	2133	2133	1874	1	1	598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEwcuCMygBbJ8qTVGdjFRLxLJ79dUWurAGciwcAianDW4B8iG
21495	payment	2134	2134	1874	1	1	581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2FLLQyscuXh5h18gfVVHS1Yfoy9o44dmCP3ThZecgKDWSb9W6
21506	payment	1397	1397	1678	1	1	9444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMYkBpooRHTqYJoG5RUeQ568gRQ42phLLGQ7pGnWcqnn6dFCV
21507	payment	2133	2133	1874	1	1	602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jqfNzBhpSN7yg239wP4CYQGu5YhgEX8YxQavyszGfDdXG8HS
21508	payment	2132	2132	1874	1	1	160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MvxE3sppT1MhYZRtCRFhEeApkhdtmPqA1UBQAgRa3ki78eex
21509	payment	2134	2134	1874	1	1	585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHV6zgRmprKgEvhyFTbpoJb9TMUV8zH3Z4MNmQYfcGqFhSrdHv
21534	payment	1397	1397	1678	1	1	9452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GMau92myrFeLZnF6h7HVKviP8yK7guKrZ4qedE4ZiaybudaF
21535	payment	2134	2134	1874	1	1	593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGhvZRHdq2ZDXEP3CBP9SZwLRQSytT8b6JZJAd6Q9f5PC3ECp
21536	payment	2133	2133	1874	1	1	610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PNFr39vsnqrh5fqgwvsUxu3sD4AS6JAe1QyscxXHg5q5WTZ8
21548	payment	1397	1397	1678	1	1	9456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGCuxNjtxmVgj1uUMkNCQ9MusLyGmD9qz2x1omPHK44mo3T8E
21549	payment	1397	1397	1678	1	1	9457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR5arHGV13Jm4TZ7eHRVdhY1dZgmh3ZkNFaH12gxs8rgTPacq
21550	payment	2133	2133	1874	1	1	614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZf7QkdPdi91ZFM68WRs8x9faqo3rBf2NmB5xk4GYJJ6aRkm4
21551	payment	2134	2134	1874	1	1	597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKzRHmbpV9a1HCSTHqRu7FdPYj3n12wynWH3sNNidCz5BUGKE
21552	payment	2133	2133	1874	1	1	615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTRm617x7JzykKg3GMEgmLBKwyKD25cKyLACEUPbKHC76ALLi
21553	payment	2134	2134	1874	1	1	598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9j5f92Uz1wv6ezEpCEx7zpDuzha73SKvwZM1Tfo3eRxMcKh8
21578	payment	1726	1726	2153	1	1	8176	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKSWmzx15M7fYY3Y6YSSK7K4EiMsE7TMRKQjyNSL1krEPaCxKS
21579	payment	1397	1397	1678	1	1	9464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7gbcyoiT25injtYY89GDzndzxEmzguG3uMuDAi4hBLJaif45
21580	payment	2133	2133	1874	1	1	623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVufT3wfc5BCNpwWRtwFQLr82cwqpGqDT4n3DW5VUqugcdhPMH
21581	payment	2134	2134	1874	1	1	606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFBcswwFxta8axTba4GkQwYudqZ6x4HaMAq48fT4N4iQdXJLP
21585	payment	1397	1397	1678	1	1	9466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GJFtVgYXUkk2VyXBMJd8a4eUoDX64Dk4Symfe3Hydgx5vfH9
21586	payment	1397	1397	1678	1	1	9467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjXybnQFnG1RAyvRcZ9H2MgbNdeNUZSJAnCtxg7LzD7vGhSRS
21587	payment	1397	1397	1678	1	1	9468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuy9NVvgB6kfbmT8rKPsimRC9q47JgKnKNyj5M7nyCYkZGRyQ
21588	payment	2133	2133	1874	1	1	625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8efRLvGyoc4UeJwUnB66wmVLwkToFyxwmdLWAQHtYugHpGWnE
21589	payment	2134	2134	1874	1	1	608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Qyhx5qGbZNMiBaG3n9nH6rcdVJsQSQgmJgG6x5CHBtnQEa7w
21590	payment	2133	2133	1874	1	1	626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrM7n95SCJNuc36ATAP2ozPWM949qhbsxt4M7bzppnkDbGEv4
21591	payment	2134	2134	1874	1	1	609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxt4v9Tx9giALu5z3zYZR4MMJJ9ydwa2PXxGQviSGzZCqkx8r
21592	payment	2132	2132	1874	1	1	167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprz9bVfEfhmTtAzWxEHgYYQsyjzziJpbMs1rSUhpJeqmeuYLt
21596	payment	1397	1397	1678	1	1	9470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFyPTMnfTiurbqTMrcv3FzaLC15W7XGavPQNaaVspZczXjfim
21597	payment	1397	1397	1678	1	1	9471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKosukohvJzLc8tUCh2EnbfgJFmyXWRuoE4XFB6iCG8MRq2Zp
21517	payment	2134	2134	1874	1	1	588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WhUmT5kBdmWVJ8XKZ9BuUvy3hcittawBgpWPH3MfWy9NhhY7
21518	payment	2132	2132	1874	1	1	161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3fYUE2Gy5jcjRfUrdGGQ9D3rtCrQJGNZSa4Hps2UQuJKAmCU
21519	payment	2133	2133	1874	1	1	605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYXwqsPEatMncNj6QYbXJ2NoFKDkecFx2YKQKtH5HZfEh6vH8
21520	payment	1397	1397	1678	1	1	9448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPNw5WWLLCLk7cEPdnHRLn168QnAqU4DTGkjBDrCLLKEznMwB
21521	payment	1860	1860	2152	1	1	2	1012300000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenQiknPGinDrVCNur2oSzjHzpYArzfXJtAF6rGLCa3KkvYon6
21522	payment	1397	1397	1678	1	1	9449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYiHMNyiVkJv8HSXNN8U28QbR2RxQUB1h3Z5ZX6VNVQ3Xu5LV
21523	payment	1397	1397	1678	1	1	9450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wy4uUopr32BymiD3eenCZgiFLU7Nk6xdmGE439D94ca114Cy
21524	payment	1397	1397	1678	1	1	9451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bPSYqnpLR8dq6cjodSxEdyxso9jP6AHmpEaBHGwoMPyzq6yF
21525	payment	2133	2133	1874	1	1	606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusSPNkF66vGwVwyUHH3wjXLp2zYwX3tNTTHA9K46kpbH2RVS1
21526	payment	2132	2132	1874	1	1	162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uQfHvi7QtiRG7z1E8xUoM9cnJnGyVfALf1xSHMGuoQy9rR6f
21527	payment	2133	2133	1874	1	1	607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMeJZ3HrncwEgkL5WTbe1vfdKo6wobkZcvETVgMSUz8rXosRoU
21528	payment	2134	2134	1874	1	1	589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrp99NdcWbCRRSEHmvYfbkUftwk6vZ6xEYdYa9wjnCGA6SybhC
21529	payment	2134	2134	1874	1	1	590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3KonVGPxqG9KT7JsnFLGy2mMnaPXiGteJ2azc3NTrcrr3SYQ
21530	payment	2134	2134	1874	1	1	591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAa1r5vJbp8rnxBpTKMpvXWWAre5syNJzPwsZewJkyjrqKc4Jr
21531	payment	2134	2134	1874	1	1	592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7U6eJZbqRPPKmNXdJrPXkLPwjMk4uKwwAqzCcKmuLpVhnZQAF
21532	payment	2133	2133	1874	1	1	608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WK7tVoU4kT3pgs39gfPe2G5T5i1qmNvZdvP3RHvL9MyZNqCY
21533	payment	2133	2133	1874	1	1	609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmyKX4xbM9HXGxvPRn7tpraXLXDZ8S8DW1mjaCdJ3deU2dM2t
21540	payment	1397	1397	1678	1	1	9454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRs9wYhVauSdiYraLt1sD958bbRKT9DKjY4FsAwTFMUPdzMsbm
21541	payment	2134	2134	1874	1	1	595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7M5ec3p1hKANifsKuuzdp7h7NW3n5iHUjmt9HJ51qFpSkHAbX
21542	payment	2132	2132	1874	1	1	163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLqnv4xZL7X2s9BckHYwybJMCH7yWigssT9KxwzpYWWhc49ML
21543	payment	2133	2133	1874	1	1	612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYedNVKxSH658kiGG361hoUzpKQFjvcGwpZAwzKaFdyM36NVh
21558	payment	1860	1860	2152	1	1	3	107499000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKPqjLosUQXWP74M78CqxRketnx9C7EbVaKAM5DMdMtic7fJ8
21559	payment	1397	1397	1678	1	1	9459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk2GwsgSiUr3YbEwrtMYGo41e64VrLGrwnQQ8EPHyBxxbPdYA
21560	payment	1397	1397	1678	1	1	9460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1G6ryioCDp4BdcXKXXS2WrzVkX5U1ztZzfHqK8xfNnN3uimX
21561	payment	1397	1397	1678	1	1	9461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvw9D6zr8XjnDGdhMDSpPEncGAjht1Q5pt95QFwvvmt89tTSfW
21562	payment	2133	2133	1874	1	1	617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkUTQKSykvJtaRKU1AJGXqFEjGSQ1vV3BCQak5nYxMKPN2ri6d
21563	payment	2132	2132	1874	1	1	165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAjLyxLhxyrJ9NdhZ71LauA6peh8ZLSFRLy3zKd7fDmEyC7cT
21564	payment	2133	2133	1874	1	1	618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEf5Xiu5q2rcou37dTpY6y6utuLXft5oYzpsyBjAG2JfoWryX5
21565	payment	2133	2133	1874	1	1	619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQENRBgY8WFL18DMRjyx4kBbNiVdC9evDkk38ttmaoGC9BzMt
21566	payment	2133	2133	1874	1	1	620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwUcEqTh9gXWjuPrnGrn7Y3vb2kzKPfpzV579N5RnDEM4Nnwk
21567	payment	2134	2134	1874	1	1	600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFDQ5f5zdiKJyxRghmijVeoCC4L6rsX9z9KiVNqKLAaPZ19SZT
21568	payment	2134	2134	1874	1	1	601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KN8uG57J1i15h3x3vuYDWw85uJPHQJHTGJ51TbuX6PRmnQeu
21569	payment	2134	2134	1874	1	1	602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgaAQdmyB33PftjbZqyXy8UhFBP5yaoVTS4ubQNSYfpHHbTDU
21570	payment	2134	2134	1874	1	1	603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvd42bkqEwi6os3nTjz1EynjKGBrVCBQCT4W5jXi5ZSrCgdRh
21637	payment	1397	1397	1678	1	1	9482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVRpaVkXkgwznuTvjXaaoJBfeKMZJvN9p2RJtfsCHE6uTQ2A8
21638	payment	2134	2134	1874	1	1	623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXvkaYHuU8TxFC62UVUdZB6J97SjE8Qyx8EVXkiuSR2oR4mp9
21639	payment	2133	2133	1874	1	1	640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EgQyWgt5W2CAGyFxZnpqn7EWuXpRWyKssWVkg5QJmNQAZpCk
21647	payment	1397	1397	1678	1	1	9485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqabmY8ip2DYqbuxSG7BxvXmqvychfB3eUQQ2fFaWTsPZ1i7NP
21598	payment	1397	1397	1678	1	1	9472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BamXPzyB79icpuuCYmrGjKj92SHWzAwwuBHa61kDEDUyJGA5
21599	payment	1726	1726	2154	1	1	8177	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFYnuiCQ7RuBKkQgrRLxu9p1oVys2Dv4RPop8uqYSDaJR8jJvm
21600	payment	2134	2134	1874	1	1	611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjN97D3E3r2hkuhuLhAsFgYpUnyhwWWaxHTFNRuowhrn9uK9Sh
21601	payment	2134	2134	1874	1	1	612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75XoqUjcLcDF18GR2iF9MXnrPg78HFUtHH5Pvu7KC88wDpX4u
21602	payment	2134	2134	1874	1	1	613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrECNq5MX6uaKcKbGK8aaANHBtFWCSmUWKrL9kGsn98pEdBxG
21603	payment	2133	2133	1874	1	1	628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFvPLCVJwzfDwP3UfFBZ6sGabdWvjnwp8HwHoCJqmWsjPtaAU
21604	payment	2133	2133	1874	1	1	629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqBchsXpEJPJjaJLaUgXhQCaVuW7RrCgNdeWFGVvrq5VJrH1f
21605	payment	2133	2133	1874	1	1	630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpqaQoK54jimQn5jpVV8dB2KRFETu5EdSqEBgDiMUTcL8uraE
21606	payment	2132	2132	1874	1	1	168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3fY377raSfDyrB6kMnwRic2kxJRnWaB2AgNysxPxR8ncUGWD
21630	payment	1397	1397	1678	1	1	9480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9CmpAywtvTCiNbFqL3Ai1u9KWnZH3FRMoQDmzVQiemncD59u
21631	payment	2132	2132	1874	1	1	171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NdVriuRbhMswJny7kM7pnk2FLVyan15RcQrFkiWbLurfa1oG
21632	payment	2134	2134	1874	1	1	621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdre2oEETEdFyXtoeWmbbZvsUejHgGEGMDyh27dZ64grXDzkb
21633	payment	2133	2133	1874	1	1	638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw94zpaqZEvov7VwdFcvhz4fU6NEeZnF1nzUcBV5kAdhKE8a1q
21652	payment	1397	1397	1678	1	1	9487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLMAQDD6iY6PsSCq8SaaZmrJ3Exbne57Fr5QeQNyMR6GC46pm
21653	payment	1397	1397	1678	1	1	9488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerjchovFQbFLeLuQRYksYbeo1i8LLiA1QLBmkg3jHfKhLCFCR
21654	payment	2152	2152	2088	1	1	1	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVm4yWsmST675YQoUXG2D44jC35G5rRbkg5d9dFYBHVtPBB9i
21655	payment	2133	2133	1874	1	1	644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEv9hEQ71PuENZnSMCNgs9jwxf7BWjLeHh4ijieGvqAnkW7eN
21656	payment	2133	2133	1874	1	1	645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQfeMhgZzJmcennKu89VRLLP9n78T1ryPN2Ve6T7rZro61TGzC
21657	payment	2132	2132	1874	1	1	173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoeNTt2Yao3FSkGU2Cg7WCJCkCcwj2tBSurkXWTb1NuDvq3y61
21658	payment	2134	2134	1874	1	1	628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GCjNTAcSwG3sks7bXe96Njigv9BKJqquLKZLArhxpZMhbkja
21709	payment	1397	1397	1678	1	1	9504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKN5b53fMrEar4MPPPEzBbVwn98rHtxFmp4hjb3RW5pRGp5g8H
21710	payment	2134	2134	1874	1	1	644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2eJwZWY1XzDzFcHvnExS1x6WHVnVvVLPcnYE8HtAmBBVj9BfY
21711	payment	2132	2132	1874	1	1	178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLeU5rMUkj2Z3GvSw8VyWLYCQiBsbmRpVmA8cau8wXDFH6Ropb
21745	payment	1397	1397	1678	1	1	9514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyLn72LtfUEb8nvMDvu1oRtu9Tw5jjkvnbywPdNYp5ouFms9Z
21746	delegation	1597	1597	2155	1	1	2	\N	10000000	\N	E4YbWypda3atfZhudXvpUfcaDf1UYD6kjRNze5WueGnsMn2JQXz9q	Ckpa2pz1Xyj88BD8YY2xTcpoHfeDj664nLayxQeSghquqjgxzAFJo
21747	payment	2134	2134	1874	1	1	654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEqL2TZa3BdoSLMu4TpDDXfxvkm48qpow6oij4nRrgXR3VVDb
21748	payment	2133	2133	1874	1	1	671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hv2KVitY56dZZnEAEAmQDB2bAQmE5jmSAQ7eWFA33nPh8xJD
21749	payment	1397	1397	1678	1	1	9515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDY7EaLXBW2maaZPe7D9fRwxqfnUUconmtzgAeN6yWikpUcp3w
21750	payment	2134	2134	1874	1	1	655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrK8jPeotJsWUb2719Mb8CVFYeNaex3GodWAAtggvxYMgZ178s
21751	payment	2133	2133	1874	1	1	672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMikfb1j1uTaCWbwvk3MvQvvtCpdrZgNCG1jDuujVgw2WjtVF6
21770	payment	2134	2134	1874	1	1	660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbBpRT7q53euqjrEw1KCMjCcbgD5dGdEX14mbXRnK7z5Yjgzs
21771	payment	2134	2134	1874	1	1	661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUiwn9vqbyjYcKDdabezX1ZUT8CfosGg5W8WJ4L5ay2uMmgJQ
21772	payment	1397	1397	1678	1	1	9522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEPJpjUHtY4qbqUAwUwUoZ3adRJSx6YwbyqiQefTp3wYTKpuE
21773	payment	1397	1397	1678	1	1	9523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCWeoPmi4NX4LTP7cpkFjsNwH4w5GHqoWDwLDtRgx33XnPUo5
21774	payment	2132	2132	1874	1	1	184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgAUwtcosGmLNZHMLjpAVSvwVPTezUBrfSimTR6fm9eXfkD697
21775	payment	2133	2133	1874	1	1	679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgXrE1hpnp7KWm2WUqnQJVKcV92qzRoBNsdiXGj6tLZyDdzbk
21776	payment	2134	2134	1874	1	1	662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4f5aPviuzMZYJAsDTnaxDgMbsjGZ6oB1LXH4APD474g3hjARY
21777	payment	2134	2134	1874	1	1	663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdV8qzHbgoT7cqE1MLtaHwDn72Bnx5m1Pn8XFGdTCY45B896Bo
21607	payment	1397	1397	1678	1	1	9473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFuVce5rrmaVMFaqATWyUrtBhFFvwRtLhLhksB9KvDKezGB6e
21608	payment	1397	1397	1678	1	1	9474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuULNM29Zz1dHtAZ5t8rFiB9a56ZH3N95cTBowkBECk88QHEPs
21609	payment	2132	2132	1874	1	1	169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAuXF7qW7SxTe6PNEe1NS8LkCNum8XLxmF1q9mcHfFR4icnmK
21610	payment	2133	2133	1874	1	1	631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCneS5VFrFyjqwTkh1qpyoopZRZkSDiSGfRHU7XUANdh7eQ9F
21611	payment	2133	2133	1874	1	1	632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCxUSd8KZVB2Fy7v5yNNjRzB3nd2gJuTVAKrc8fxSX6QQqjWo
21612	payment	2134	2134	1874	1	1	614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzfmN6FZ4CFshmqvacBtVNetr1ZmRwE5T5mRUDaTqD2u2rBi2
21613	payment	2134	2134	1874	1	1	615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ouRr8jfCwb9sbfsTGahjbMUd3PFiWknNdxpzmGpovCnw8H9L
21634	payment	1397	1397	1678	1	1	9481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbvgknha19CPaFdHZBRXJwmgq3YiQqQKB2aWwSArg7bCSGztd
21635	payment	2133	2133	1874	1	1	639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAbZ5hj8Qdct7Un1Lj4NLDyGTgNKXGjNwPe6KCrC2HWvXvaca
21636	payment	2134	2134	1874	1	1	622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjY7RHjybSHzCdDGvoPFw85myeBu7xuBX5oYmmtLp7f7vMW1iP
21659	payment	1397	1397	1678	1	1	9489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1X1eouJ97jwJam9i42oHHJkvGWtpW7m4m3Fvanotfd97X8w4K
21660	payment	2133	2133	1874	1	1	646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHDo8q6RWE4xdczvJnoHLcr3sC4cPaqa175YyDJTSbvosn653
21661	payment	2134	2134	1874	1	1	629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19jbkRbLM7xJsrbv4sTZu5HN9pJZ6YkmZmLTr5DPf274fLdCQ
21690	payment	2134	2134	1874	1	1	638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1Qb5Dtrzuwsi5JwWkkTRV911X7BhHCCHbtGuAhTSkShqNbKa
21712	payment	1397	1397	1678	1	1	9505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaAKCNWKRGgyr1MzbviuHXBvCQJdN5PAFyYKyf68MhnyZ5zFh
21713	payment	2133	2133	1874	1	1	661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZdPdf3fgryqQoNpxMSoDh4v16zaPmqMGDZpczasZEgh1ZBS5
21714	payment	2134	2134	1874	1	1	645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JsU6TZc586vhAckKF3uqZmGbNgufyLPAF1MXxys3ut3nV3Bp
21715	payment	1397	1397	1678	1	1	9506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTgu1n5GHift8mTiAybkW9jaDZwPtJtjPcrSy4a5VnH1zFXrK
21716	payment	2134	2134	1874	1	1	646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiG1wYBhswijk771pZduAq5rBFw35ScZ31T76ZTCoaMzDLfN3h
21717	payment	2133	2133	1874	1	1	662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkrE7Dn3PSz9yuZy7ooZjnfCFRobPa7bHTbpweamMT67qC2Jk
21727	payment	1397	1397	1678	1	1	9509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQNWYSP6dzRyq9eMj46TFJtFtKHW7W6QZBmTGqh1S97w7gRYx
21728	payment	2133	2133	1874	1	1	666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwfuVcsGU6BGqAMjNst4DUHCHRyGe6sonKTCZQaoWMkWwdNoq
21729	payment	2134	2134	1874	1	1	649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHeCnbgP1PoYatBRU8HdfhVz7wyRYKUsff7873VocP2cNtwqZ
21730	payment	2132	2132	1874	1	1	180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvbAXPKnpFvV32sftqn9aVGCtZn6BR5d9Bk4xYda2d7fZBTNg
21737	payment	1397	1397	1678	1	1	9512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz26tR8J1AmLsCPxYhQ3HrZogh7C7YYnvgzBZUYkR3YvJA2Ay8
21738	payment	1597	1597	2155	1	1	1	1010000000	10000000	\N	E4YVcLG59cWG1h54yu3vNi5z8eXei7VNDc1FgCqkdS2wv4DtVs4e9	CkpaJdhsFTpwwFC8oVpDWRo19pT5DLny1rHcELCdSaRpRAjpjsHMD
21739	payment	2134	2134	1874	1	1	652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuodVvWUfqWz96KMDawtvMbjDL7jg6vuzfYta8qouiohrNMK9Q
21740	payment	2133	2133	1874	1	1	669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLB8R8n6oj52WT3Ae7KeDvV1LE3Ry2rvsvKeTFcHJToWQwNudJ
21797	payment	632	632	1016	1	1	3	4377000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpYs6ZthdPHgmBPh5HiAMxs746D8jmG1SGChDJ8SPx22y7a1ue1w
21809	payment	2134	2134	1874	1	1	672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvjFsrkh4oeQaFJzT9ptwTr4UHjUjD9ebKngnjjwcnxMG34n2
21836	payment	1397	1397	1678	1	1	9540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDuiq568AKoHYW1WX2zXH6env8HL54pzqCD9388chpo2mftdg
21837	payment	2132	2132	1874	1	1	189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirw8ezYGQKYnYXge4Kp6rdtjymdtf2QSU9we1f8VQuq8zxhPA
21851	payment	1397	1397	1678	1	1	9545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25Hrhgtr335is6AtA5HKkRoKD62PCi5snZZa1cwX949vUzeeB
21852	payment	2134	2134	1874	1	1	684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8S4deeutAtizPXcyhrYCJucwaq5MxNNM14kCs4c5qWZWUoD5D
21853	payment	2133	2133	1874	1	1	700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnC98tHYF8N6a3pgwdmGEf8LWouw2WGTLtJaHXdcyW4BQm4yyQ
21864	payment	484	484	1073	1	1	1	6373000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZf4miw3WLUepu3bAtCpU1yzmYdYULwoqUWnQ3sXG7tTPzQ34cN
21865	payment	484	484	1193	1	1	2	4300000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZ54BfLkMP4MhFV8VkAysDYCHqHmAN1Q8n4jkGUWK8grAH64iKt
21866	payment	484	484	953	1	1	3	3557000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	Ckpa181HVKhSxs7G269MvM6hojc2mLXEXv4nTFsC2T86mqunZnqRF
21614	payment	1397	1397	1678	1	1	9475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbQWaB5hXebFk1fSnw418BJwqfKRebhYo2pH7z8AdwEMBYo9L
21615	payment	1397	1397	1678	1	1	9476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDVcatzsuALNNecsLfxuQ68Xus5fKpZscMEEK2AbmxTDkYe6u
21616	payment	1397	1397	1678	1	1	9477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfeDk8oKG1NnKjYgDXiC3GcqvcLK8rLb4QCx2ygHcJBvJZL3cD
21617	payment	1397	1397	1678	1	1	9478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUi2oebnXgrXAVVVCrSvNYeXYJQeZegtMRN9qshrz4QzbBFGU
21618	payment	1397	1397	1678	1	1	9479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfq8EH84ig9xkCzhX3HJie3D2unWRc7h7cRhWgdWaSvjAPJxg
21619	payment	2132	2132	1874	1	1	170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnZDMomJcYa7ZWYkp2mxCBs1tccBv2JymhMkLcfaK6hra1Q5C
21620	payment	2133	2133	1874	1	1	633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzsTN4a6RJiQFb23JhVNTx7RM3FUXuMdJUYmV2EorHHWRqbM1
21621	payment	2134	2134	1874	1	1	616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwusN9faZnBCdfjL5Q2eXcWUrDtwCpfZe3M518ts1yYMhrNDc
21622	payment	2133	2133	1874	1	1	634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGERQGyRkS5FBvwhMYFTnFuqUhWGHyw5rrAxLtaGgVyAHrzto
21623	payment	2133	2133	1874	1	1	635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYXoWF3mECKwaxW1sC4kigxa3GuiyKZK1wZuhQA2fqg5s1vTF
21624	payment	2134	2134	1874	1	1	617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGBELiQQh9v6wzViydJ4FtjhdbU1TKWmiJm1tR2k8iKd5hmyK
21625	payment	2134	2134	1874	1	1	618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKCiLFRK1KDQzvSVEiidSmdqBBG68Q452DDtERnANwK3FiJaC
21626	payment	2134	2134	1874	1	1	619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NvhMsm7FQQzhqUQECxJhiuqZ3ZDgfyL2Lg4RYgPX9YC3qmd4
21627	payment	2134	2134	1874	1	1	620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSemsw4r8DhJP2xL8aHk26Jcs7wRYLHg1in1rctohHf2pxkMV7
21628	payment	2133	2133	1874	1	1	636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvThFqxudnVH9QaAyEbuQWp3XAtaBLTPprtmHip7Nq4jMCQ69t
21629	payment	2133	2133	1874	1	1	637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsVndYK5kPuSrWsdNWzDAtaZGiH9fK42VnEG2T3C3AanWL6Ed
21640	payment	1397	1397	1678	1	1	9483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNJKGHqm8y7U35qtuhLUsR2EzACsEF2NZrvsqkZEi2xT6nQND
21641	payment	2133	2133	1874	1	1	641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonjnUg5vAjnQ5CE72HgLvA4EE6XpSU9rfFFBoaN7YN71psKKZ
21642	payment	2134	2134	1874	1	1	624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3E9ogyddD23eK1PaDjh6e8ugNmrHMc47r9Jdbjr5227ANnUb
21643	payment	2132	2132	1874	1	1	172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeBysi7vnwcGcA1ZtGk6WZhgG7tr4bapkW45GWPtdeSxZjQ5K
21644	payment	1397	1397	1678	1	1	9484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpNKUsqCBPfoP2JkuAefKRWCpt8n4CX2jtcqoyoa5S3YYQp92
21645	payment	2133	2133	1874	1	1	642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpJpXHv7TMPj8p5httuMVnfVcnwrZNfpbYuJSQzDpx4AAV6FM
21646	payment	2134	2134	1874	1	1	625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2vy7Ee5yLKNZwzLbKkdToEjYQsbPpUr26pLCvLfteq3Yh6q2
21662	payment	1397	1397	1678	1	1	9490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8NuH4FabGVSf9uoWCBpiRPsevbmSrV7QVApZByEs3kSeHzLj
21663	payment	1397	1397	1678	1	1	9491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuzfLr5oM8E1T1fEmceFwpGFiCt9D8yNKubaa4YyVDfvySbXE
21664	payment	2134	2134	1874	1	1	630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb8HVyqxVqEjp2qvNtBKJRSGQAx86bbawjgCMV3bA28VQ2FF5
21665	payment	2134	2134	1874	1	1	631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeqgUQwi3NHM8UHbGAihckt5qxHjAJKQYJDSMocFyWa5xQtRu
21666	payment	2133	2133	1874	1	1	647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCALUJAJ8zH9q6pV3EUmgYdDRPFSYJ9yXCyWUjcA498XpjAPFe
21667	payment	2132	2132	1874	1	1	174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTzwqEX6iQ8T4wHL6ciJMFtTifNvgPxt2H13JE2JEaFQzPrsM
21668	payment	2133	2133	1874	1	1	648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNeoNrbq1CP1pZsevLz8UQMdUU5EZPuch292dVpXAnexcvFAF
21669	payment	1397	1397	1678	1	1	9492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLafELBZnnzjpdikdvVSEP8zM7rBF37rtZPbdbVcKU5jZsBtPz
21670	payment	2133	2133	1874	1	1	649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPgwpSaBrMMiSbSn9LLxLqcmfrgRwpY4bWs7CciZxgYNcbX6L
21671	payment	2134	2134	1874	1	1	632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAm2nqW7AUuDq8NbiqiicHAyM2TE78PSSULCZYMVWRm6x1xnqe
21672	payment	1397	1397	1678	1	1	9493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrssc5ir4xAz5znEMUY8fV1wgF5fVXqtTBH4GjuwVcsUcP16ia
21673	payment	2152	2152	2088	1	1	2	77748000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtyEEVQ96rjNyxRhmQokWwt6nXnEQpjxoULCb2amrqYX7ecpC8
21674	payment	1397	1397	1678	1	1	9494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyCcH3j2AR7RvncyJEqazNxNH5NVcNtDDraeFsBdaA6RdeGxS
21675	payment	1397	1397	1678	1	1	9495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcg5YHVR1XEoMmyZn1Fk5pb9YMMvfQKtefjRYAkekdyzFRVs9J
21676	payment	1397	1397	1678	1	1	9496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9utSQhV3E1H2Fj88csvtyhKY7Dx8WNUvYZVjWqDvxu6Hj2zR
21648	payment	1397	1397	1678	1	1	9486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUk3UZSb4u94cve5RxALwt9yBkm3pdPQZf7Rt1rXHZuSfwuDy
21649	payment	2134	2134	1874	1	1	626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkcQcgfLVSgnw9P4sLVL64AEV857DB2Z9uvYdHTFQHjVSTBka
21650	payment	2133	2133	1874	1	1	643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEqcCq9QMRA6LXrBTwqz65TCjdnnpVhgWMBuJoZw1S5WPLXoy
21651	payment	2134	2134	1874	1	1	627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbq3ydR55ffNY5vcgrQjwpCFJwv1XBhBwjCScG2FKH8iMYoYSk
21686	payment	1397	1397	1678	1	1	9497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1aBhacngQxqqMrRyxtpvoUCAHTc5mXQY6A6jmspVA7rJqrTy
21687	payment	2133	2133	1874	1	1	654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsw1pn3MjxgZC5XC4pZLwxTTVMZGCdUU8tt97m3u9Eig7wkWok
21688	payment	2132	2132	1874	1	1	176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkx5ZBu7or2dFY582UAXDUFaBEXTSHgRhx8Q9vHQA3jFWtHtWK
21689	payment	2134	2134	1874	1	1	637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AnD3y4NK8VZuURrK8YYZ7WjNkQwGWDSzPxXTpFJxyZM5RvNT
21724	payment	1397	1397	1678	1	1	9508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuEx57juJZMbCW1wKRo7qSytk5akwH1J3DUduzJpL6gYPfLvu9
21725	payment	2133	2133	1874	1	1	665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQMiP3bq7pyjhBDc2kah21mxUvKwMcDmHUZrMT2Ey6T2ryf29
21726	payment	2134	2134	1874	1	1	648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuN6g7NMFPUxYxsH9Fy3Xub9ZNpFvLswACsQge425MgrNWQq2
21731	payment	1397	1397	1678	1	1	9510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6KVqJGTACjSyWykVkYbqDYVRMPzp4hrWB19CJxP8G9Q4wWUr
21732	payment	1397	1397	1678	1	1	9511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgGSPv7YE35vrhJMpUBPvNBQM71ZvbiQtaUsuDLUCiHDRRFi2
21733	payment	2133	2133	1874	1	1	667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTAqc8xTvnnqEEhPtd7A1mVxPSNUxDmgaRbDBZNF3UHqrhaYJd
21734	payment	2134	2134	1874	1	1	650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYps2HF3GNFCdpNVZ5mHuQ68GkHUjmUTRgzZytJSff36x6dkF6o
21735	payment	2134	2134	1874	1	1	651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJnT7rpnUte9gHmCzaRpe9RZE3gUSoWdBq1zgjZHCmEGatWqd
21736	payment	2133	2133	1874	1	1	668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimHoGH1AYEeQYFk8fnx8GkUF6BPkeFGs5GXcpt6GeYj361bmE
21741	payment	1397	1397	1678	1	1	9513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibiLm8sWthYrtZgLFbRmD6ey2E8k2adHbhyjtT95X2HJdd7is
21742	payment	2134	2134	1874	1	1	653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagc3B45twSnK5L4hdW2qKR79Rgz4mcgSE19m9YgidVwG7wk8Z
21743	payment	2132	2132	1874	1	1	181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWWyHeeJbEbgNLftNj4y3A2irsuUNcuTg3ZF79GJTLWrYjPzR
21744	payment	2133	2133	1874	1	1	670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Mz1A2KGFjAEYecVWCnAJGg2mgc7cBEgjncNGCHQYZw7yba9P
21752	payment	1397	1397	1678	1	1	9516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLfv6JhNfwky1qYKZQYTUov9KBs3P4Yt5aPUr4brjbBkRcXZXT
21753	payment	2134	2134	1874	1	1	656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXzJsBypskYxrZ21jpedTYiZhp6pCCDup8Rm1GzcWUePge4vR
21754	payment	2133	2133	1874	1	1	673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGp4yjxJwCLWNGwhciZZDAZHqhbgNZQ2ECzngKSLNQDZnaQPA
21755	payment	2132	2132	1874	1	1	182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQVvHBhsX2qeQ7FjWxvoKMzLgosiEZXTHUbtDLH6nfXwB7gMK
21766	payment	1397	1397	1678	1	1	9520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqNQPMxz68AZ3hSe9aoJPKYakRbdRqTtiSmhweDvuULERJJLN
21767	payment	1397	1397	1678	1	1	9521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GcywrrqAVtVacwh9sRcEfHejmqC3meYryPJxHnS1YWkrpVLS
21768	payment	2133	2133	1874	1	1	677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7fmxiFgszKqWXXmhDz3tRMTL1k6Zz6duuY73Ruecw91S5ePQ
21769	payment	2133	2133	1874	1	1	678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3samCxahRAjUmVikKcHsdRrgrKGanuQNrd3TZLHGTbD1JzU8X
21778	payment	1397	1397	1678	1	1	9524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7xjZ9HwssqHW8jfJEv6nh6yiSepdGA3QSu4Ny4zSVWm4X2eu
21779	payment	1397	1397	1678	1	1	9525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDN38PZhkE8wfeU8PWaCiNvL6mKxV1hkzcLiNFhNFmXRSg8qM
21780	payment	2133	2133	1874	1	1	680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGy4fDVyy59VxPwi1jrRxbPVQQhrcVbzedjso3mroA7Bc5wob
21781	payment	2134	2134	1874	1	1	664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13sWr3PrRbLZomwvM8jMhiB8eytj9p5v2krgXSHrgjFoKouN5
21782	payment	2134	2134	1874	1	1	665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYag2wfjuNDoBxu54baWvgx4QsU8ndda3kDVidG7Fb51zjLgudW
21783	payment	2133	2133	1874	1	1	681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNhHujNZx9iuxVYw836YzmyaB5Ew7n996GyDjGGyxuN6oS48R
21794	payment	1397	1397	1678	1	1	9528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpoKHy33u5cpkhoHCciChfhtDf6jK9wHwA1udWsXJMQ78yR2i
21795	payment	2134	2134	1874	1	1	668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vpodZUtT99Mj1wnWMuyp1hsr47tDcy6QtVbJuk37KCbsEBV7
21796	payment	2133	2133	1874	1	1	684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctQnE1uGCAF9QpKe58818uxHhFapr2YyCc8Kzk6YysgTp1rLT
21677	payment	2132	2132	1874	1	1	175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZt5bAhqRGm2zwtYZUYoa7LXAJUoqnKhjGXJCvaCnYQp1JCbNh
21678	payment	2133	2133	1874	1	1	650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXWbR9Po67M2HJGSbqn2TW3U2enUWq4JWF8SJJ5GVmKX8DK9S
21679	payment	2133	2133	1874	1	1	651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3roeqCRE1AqxmC4B22LTazcUfAnQY4Us41zjrg6ZoJyVPnMs
21680	payment	2133	2133	1874	1	1	652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFwiwwDb7djuzWFxHciYMNKY7LrJCHL937ns97mVtYLm2e3fj
21681	payment	2133	2133	1874	1	1	653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsNy5r9xVkzk8sY2cXBJZaQZU3QqDGWG8eM25vU8DTN9EotJq
21682	payment	2134	2134	1874	1	1	633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ReMzHwRRkbJZVCkmNyN9sg5AQsTcinR8nxszwux2JVrj6cLK
21683	payment	2134	2134	1874	1	1	634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFogziKQG5HQ2twH8ZpeVqTiBKiMnC3kAsTJgJyn17H6WZskY
21684	payment	2134	2134	1874	1	1	635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkHVsJLUZpMZcSQRFVcxUoDTGC2CbxTtQri5cjoPv8eJH686g
21685	payment	2134	2134	1874	1	1	636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5HawoGucUgW4CaW8Y2SDvkbqb3q3d8s7msttLRYmLL8yQcoE
21691	payment	1397	1397	1678	1	1	9498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHazgit4ST5xpYHjmYgw6hRBvMPEpFJwUhN4JAgtoVZCZFwg9U
21692	payment	1397	1397	1678	1	1	9499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nnuWCm1PnRWjzUBPjxUe6VVqMGsnk5Zs3fDWUto8LThH3DmW
21693	payment	2133	2133	1874	1	1	655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEzuTfHtAmVgjCA67VPu4mEAaQeP8tdTeTmMNo1mgxAYs4K4X
21694	payment	2133	2133	1874	1	1	656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYchtJKeNFU7L3Hb96ba9pXPHzx1x2ks194L1qLEZKA1fLuik9R
21695	payment	2134	2134	1874	1	1	639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZhbZqtKtapPXdurYHZ4UhFG8eeg8S2Dx4YdvboHoxfLU52sQ
21696	payment	1397	1397	1678	1	1	9500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtogrAdR7w8SSt6rHR87njFTrchWBvN2E5UtcuhqdZPQupTGQp
21697	payment	1397	1397	1678	1	1	9501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRDnB2ZfseTvfGVsUC2jVC75HSEA5viJKEaPvPAyXrGFe8Q95
21698	payment	1397	1397	1678	1	1	9502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtf5fNH1rrXVDvVQuD5By266DMMXJMQCy8iNWxXaicwxKweZ1e
21699	payment	1397	1397	1678	1	1	9503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQM8UZKLyxva2Ad8GrWo55yg4KR5KCnKdm53f4KeEqUgv6bLU
21700	payment	2133	2133	1874	1	1	657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuryr1FS6a3m2b3yLaCrTfTwd7JeCT4mbvoaeRL2KMKR27kE7
21701	payment	2133	2133	1874	1	1	658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYyVqbtgXpgeg8aLqKbnTauAJY5XTFrYYRBgWx2bx2gqfzvcq
21702	payment	2132	2132	1874	1	1	177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNtf6a5ci1wqjPUqfmRub1MB8qL8DgCsW6FNEAnbwvVEzDk7N
21703	payment	2134	2134	1874	1	1	640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBMQMkpBSDCpedpMnzHzavnoYMshAefDumeFGWWEsjyP7DSUh
21704	payment	2134	2134	1874	1	1	641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSTB94pm3CCjNxYD6TC5ZvALBv3FHggBatMkvDgVajQxJHdwS
21705	payment	2134	2134	1874	1	1	642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkk9Lk3BtEQGSSP1ixLy7bvyfY5Tc8mqD557uqtiKopofp1zAs
21706	payment	2134	2134	1874	1	1	643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzLF7mLUFMKBgwH1uErdo4N8rmnP7bK5pwo56KFKrghfET1Dm
21707	payment	2133	2133	1874	1	1	659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuFFvfYgXjo39ZwGxfM9PApEeV3WGiXFMjXnG8daUbKY6rdHy
21708	payment	2133	2133	1874	1	1	660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDqBjoEGRpzjnaK3Uj9Gissp1MznMoV3HxnHHWinsYX3GXhLS
21718	payment	1397	1397	1678	1	1	9507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7QjdJ12pkBW11YzptAvmRnuu4qsCQ6ZmbnhT9dnu4JZ7kLSqY
21719	delegation	1597	1597	2155	1	1	0	\N	10000000	\N	E4YbWypda3atfZhudXvpUfcaDf1UYD6kjRNze5WueGnsMn2JQXz9q	CkpaEC6BF99zdkANC56U6oyLTQuLGithEv2eWATRnX1v1RRH4hy4u
21720	payment	2134	2134	1874	1	1	647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDxd6tt7nrkXEmkukepLQiAALzCVaf9iJjVuvSPCyb5vWaiHF
21721	payment	2133	2133	1874	1	1	663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrWFoH1ro47u9ieeQJSAqUx4pUibFWyaxp9QkUJ5Z7cVZ7j5v
21722	payment	2132	2132	1874	1	1	179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSx87tNLRcHKqoiSY27JE2H7CPYKTv99FJmXmBTYvbhZ7m5yLk
21723	payment	2133	2133	1874	1	1	664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeCRrjSEHMJhq3ixGVKaRiNkgWzia3RuHq4dRFy8Qv5R1wJU4
21756	payment	1397	1397	1678	1	1	9517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvK3BZYqzF8pRgvitXi4HdAkt5Q3oUHSWfKxFYRP9eiVwwQtka
21757	payment	1397	1397	1678	1	1	9518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKG8EWdcRsffJB31kRbzrFE7NhXgq7iY3kkZzpRMGLQj3fWCUV
21758	payment	1397	1397	1678	1	1	9519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVxVgyBkvx7irGoSEJ7UYzF7U9dDjWPsfukRLEW4iRaugsGN2
21759	payment	2132	2132	1874	1	1	183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduf2XmrFBb3Dac1BATUhbgPiq2RhM1WUmzQVVwURBtcFZbKeW
21760	payment	2133	2133	1874	1	1	674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tF4EejL7PdfmgUkBgkFPXrxuUGMNin9B22QTQM8XoEpyKiLA
21761	payment	2134	2134	1874	1	1	657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9fTbek12qmKoNQm5AYZwhmh3ZyPjoXmgmttoTgY1GVEW2UmB
21762	payment	2133	2133	1874	1	1	675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDDu8M7M2CuvMacZQTevmJ3q5UcoQY1y74YjBDsxZzbR1p2Nk
21763	payment	2133	2133	1874	1	1	676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiRirTwdtUtuzuhoiCTLvNepGbjF2wgHrAWREG1pTgTMZprim
21764	payment	2134	2134	1874	1	1	658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1HBUe5D9WnQxqNBWYN48Tys3wgs1H7chzgPiuQG9YVYULKDt
21765	payment	2134	2134	1874	1	1	659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsE2reHnS2q3zap3hWGmx2xyA8RDF3M9zyLgj1grLjbTd8RxQh
21784	payment	632	632	1382	1	1	0	14747000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZoDSUSLvvw56XZpZWimy82xHUJwj8PoTHPKJGr67ynfEy4zHM3
21785	payment	1397	1397	1678	1	1	9526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqkdHSex5XT5DJAagvYofyXN5wVRVTjYGmCkLsFoTPFtLwJYw
21786	payment	2132	2132	1874	1	1	185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHefNTqYLTSJZk6grq8ukNWdbFQtwQcYRaBjcSdeyoCnZENF2
21787	payment	2133	2133	1874	1	1	682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTExAPky9JMmhmcUP6UjgocvXjJGrSwsTczTMKfXKtAF7bVpA
21788	payment	2134	2134	1874	1	1	666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4SnUGdYXWYRF9y4xjXD6s9rCop1VpAwtqUSEDCzsBs4Xpdi3
21803	payment	1397	1397	1678	1	1	9530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4XvKGQuCQbKjysrKQzSjRwGz1qx6dcNBpf8Bs6bYzsFqBrbd
21804	payment	2133	2133	1874	1	1	686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpyLfmnYisktMW7BwHYC4K5SX5FboYimQV3ViVmZSDyN6gTd2F
21805	payment	2134	2134	1874	1	1	670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHE29ShXBBXb5DRuwSzQ7TjgqdfNam77KzuHqemanc9mWqCiN
21810	payment	1397	1397	1678	1	1	9532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFxZVMhopJkSXQkeEnhx59z3q98mQ1iHJojBMziST36UVr3JW
21811	payment	2133	2133	1874	1	1	688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21DjR8MWWA3Szjup9cNeEtCzqXABXDUFLzNpVTdSYBZhhtduz
21819	payment	1397	1397	1678	1	1	9535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCEDwSeGXk1rsGC14xkPDVHXCbTBzzMcnnC6Pqp4vXnpZZeDF
21820	payment	2133	2133	1874	1	1	691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCM5b67eTLjD8HTjh1gaaj1oGDscMPjYs4v5MYiJfwcHBDuz2
21821	payment	2134	2134	1874	1	1	675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvdKyFgqjQZFk93PsXgvL8Wx1inUPQfGfAuxns5b2DPNZ62hq
21826	payment	1397	1397	1678	1	1	9537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyRU8BKrGB3WppWCLSvbVGWWMiVRRSW6VcrSGjDkCwP7N56EN
21827	payment	2133	2133	1874	1	1	693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMQyb9Txo8aDcDuvoWjxFbxYsWeZqHrDSLygARiLbiWC1MeoJ
21828	payment	2134	2134	1874	1	1	677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmtMPN6nfSTWU7vPpPAzEkC5LvKfgvdscrfJNnQGQifcbxqkL
21833	payment	1397	1397	1678	1	1	9539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFbDo3K9hrkJM9Y8VAtekGYc3HRndec26f7zjdwjuikyoH9x3
21834	payment	2134	2134	1874	1	1	679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6k2FGvM9eLxGDPS4hpGgZMDf7pinLJfXnBoLngY6gb8YDer8
21835	payment	2133	2133	1874	1	1	695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSjXssnsRvUHWABEYGerKH3ePZfuW2ZjG7nG746vpSJe7xWB3
21841	payment	1397	1397	1678	1	1	9542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB74aJPpXBe7aMyEnAcxpoSEibByUhCySRs1gRGwHLbWBYLhzK
21842	payment	1397	1397	1678	1	1	9543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1ntT16bKnLmHzmDMBWJLDEvQJHQNd2EWrFmpx2mdmpuKtyDL
21843	payment	2133	2133	1874	1	1	697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1x8QSe54Tkp7Jc8cyHpX4mgLjfrnvAvuFrgHsBSQ4vFuwCgD
21844	payment	2132	2132	1874	1	1	190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2HeCT58AUq7rZrtVoG8APVv2gUc1fRrcockrxP77NMC9dNGBX
21845	payment	2134	2134	1874	1	1	681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11LaRhF9YCxaBEPKrcRoWQfSc5jkqnWQayLSrgjP2UsfAPjJp
21846	payment	2134	2134	1874	1	1	682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnX97k7ZWcunC8KokgatMtPmVWHR4qYNQtWPnT4BCQcReFh51Z
21847	payment	2133	2133	1874	1	1	698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DUz2DpXr9DjYSppn22KcU6B9GMVqzL4qKtLvMqbWyumhuaKc
21899	payment	1397	1397	1678	1	1	9558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEnL29gF92hSkb65jxcYJ6U11vRmbVbNz8cXeyLi43gP1PhAc
21900	payment	2134	2134	1874	1	1	697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqp3hDWKCPHftFer4kBFfqmStpXXjnXAb7a9xYix8xN2fazC4s
21901	payment	2133	2133	1874	1	1	712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKBWHHZj1pXCS3yi97YkzJzu8Dv4wYbaUbwoMyhGBGnrcaVWq
21902	payment	1397	1397	1678	1	1	9559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2a3Lm7hswU7Sz5ZJs3K57NR5xXSmyhaEsJZavbqRyXtNCTLDC
21903	payment	2133	2133	1874	1	1	713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTjy1TZSpyhjC6RaqYB4hvrAVj32dZhaVrUM9Ge2KPKFbiKhd
21904	payment	2134	2134	1874	1	1	698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJbBpT9TPSQ3aaadrtcwRsfovuUv9o3NiSy7nY8ke1w5gxhDt
21911	payment	1397	1397	1678	1	1	9562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHFo1fAkFd8cp5VnLi8Yutvfo1C2HkcdbXtgwF3uW8shCdagQ
21789	payment	632	632	1136	1	1	1	7844000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpaFCza1nh1DcdhtCW9vY1qFPeDTyx17BAdidQdxAZN8tnHiyJoD
21790	payment	632	632	1256	1	1	2	5292000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpYfQ1w3tJoLaNuChEP7C6b7tVELB5mf7VAeVrLwb7i2V1LQ4wV5
21791	payment	1397	1397	1678	1	1	9527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcAoVuYhTZUEgJe7zYPcqcUCiHW4FK58Hsv9FiH7R4DCySE4y
21792	payment	2133	2133	1874	1	1	683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQB4cMDvsz7ytCWe8qrGUUWfxnTv3PHcwQf2q8H7kyLanx9WP
21793	payment	2134	2134	1874	1	1	667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4WTZxCECEWYj8sgQLC7txmSyDZw67HiUKBd4uAwQisPhYMTc
21806	payment	1397	1397	1678	1	1	9531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcPpZKy1aV61wEgBntnDoWwXf6KihmTpMAxNasMZ9Ur9xchmR
21807	payment	2134	2134	1874	1	1	671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6Hdn7r74gHj4b8rxgKL4hUSKJUQnuRMjwvViUkF1Y9uoM4Yy
21808	payment	2133	2133	1874	1	1	687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtSzZvzscBQnm4MAXHRryTFZ6PjSuz4wGfzzeXN4KfPSq7nih
21816	payment	1397	1397	1678	1	1	9534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GZYFJJhoRDVaaE2DfgJY2dWSMcsmXAEMytiDcvaQ53WmWsvy
21817	payment	2133	2133	1874	1	1	690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJTQKet6rc9b19eNf4BJNE3CyfxBYyNYDbmSL44wpm3E5E7rk
21818	payment	2134	2134	1874	1	1	674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tQnnQ4JZWaivFSX9oCa5ZcqPqfttFMrMWdjXxdJnLon5oWxE
21829	payment	632	632	1016	1	1	4	4377000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZtJj7QnFtDdXyLeAoPWnDxKxPVHEUKmqtgco8nycs3sFidWvxt
21830	payment	1397	1397	1678	1	1	9538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKyk3WknvRmNFvTeTVowdVaJSMdiCgEmqcUaFntmPwoq3LxGm
21831	payment	2134	2134	1874	1	1	678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRT57aw6ckNTEZRdPdWLvAJDcjNxYDgb5UVKLJjS7T89ASm5ty
21832	payment	2133	2133	1874	1	1	694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkwaXcNw2k15L8eS1WQLxtLajXvpqafxHSWeZMsnR37QdTkrn
21854	payment	484	484	1319	1	1	0	11982000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZtEsMyZmKsuzeAM6ZhcaqDXh35FJ58R7pbmsukh2shKqCoacCo
21855	payment	1397	1397	1678	1	1	9546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNn8u2dUyTCDYMdFe4djgnm6cGpQyL2BjARxQRJvL4iv1RUHq
21856	delegation	2087	2087	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNXz9CuXu3zTvq7W2tJ9igw6RJA9DW4G3J18mbSb1LtZgpksK
21857	payment	2132	2132	1874	1	1	191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4SMVb4DoDYHFXfBF8ijF711SzjTSsPfaERbSdiPbh8kU7XiD
21858	payment	2133	2133	1874	1	1	701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHRWaNy1JKrkmdf58r3ZetVA37wQ84RVxdsytv2V2XXGnkGy7
21859	payment	2134	2134	1874	1	1	685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuP5muNnBMWiaBX52j4Av5q6dB2Sy3stSaQRnSpfp7qdwTB9Ku
21860	payment	1397	1397	1678	1	1	9547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46ugSsy6xxaJ9QThhF2PJqsmkT9PQjNLTH37ue51Ar8L5NdTT
21861	payment	2133	2133	1874	1	1	702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpz8aLc239Gh869txA8eEcgEUYwEEXW7tnTit4bGYAybYFxVV
21862	payment	2134	2134	1874	1	1	686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs6dTkdam1CvrBXF4e6rYFKscP7EMX7kR4za6xi5UJTmhDS5Sa
21863	delegation	2086	2086	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQAv7nATtbNAHEmfapQGZQ8M4LaBaazwhQ6kuohB1r9hiYwHA
21873	payment	1397	1397	1678	1	1	9550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2yvWN9b9sQYyPVYQEMxtFwZhHVzPMERqj9aJfdFb4xgmR4aa
21874	payment	1397	1397	1678	1	1	9551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstJQ6HBANb4XGarXq5rVEKohRm4aNXdr2NES7Ev1saE7R5osd
21875	payment	2132	2132	1874	1	1	192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnmJJntM7XXPKQqBKLHMsFdqXxpyiN8cPpWygUEjHkgUyBzKg
21876	payment	2134	2134	1874	1	1	689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtq9BUoFSnHyq2ayn89e1ESuTYYffzG8BvR4YXgqgRoT2ugTZb
21877	payment	2133	2133	1874	1	1	705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRtBESniLKPuyASAn4qZteNE1KRCnQVXjHtNdkyWuMrwzwxYD
21878	payment	2133	2133	1874	1	1	706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJJTppqjPYi4oz5RFzPmMD3eQqtXU5418fyxSr4WFmpFYg9cF
21879	payment	2134	2134	1874	1	1	690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDaamgAN31KMbUuoRajKN5d9Jogfk3zEoxPdjbzxAcNt4Zt8e
21887	payment	1397	1397	1678	1	1	9554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkEyTnDeU9c8KhbVxc3xcMNdStBxZs1snafktmW74byErUAbJ
21888	payment	1397	1397	1678	1	1	9555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvRtGQfYAe9fzc58PyMDPFMBRLCESQzwPMaYtTz5X9Ds821Sr
21889	payment	1397	1397	1678	1	1	9556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfWV29zYdX7mKTDJcSTFS6Q1AP2JhdkL1SWght2TgDV6KwMkY
21890	payment	1397	1397	1678	1	1	9557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTHV3Pw7RcsLHnsBcnCv8J9ENyR8XpeXtJ5j2r6cDfBFaugYT
21891	payment	2132	2132	1874	1	1	194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtw18NtLbjfjLmK3Gbmf3diVu8CNutDJLnhVNz2ZYmYjp37Qd
21892	payment	2133	2133	1874	1	1	709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5sSPnu33pAPn9dEV9q8XRferNnG9YsLEFTiig8pBjVG7N89k
21798	payment	632	632	632	1	1	3	575000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpYc59PD5eG6kUEvMusstbDGihH2T9T7rAECf9jpKPjXWjCR6btc
21799	payment	1397	1397	1678	1	1	9529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFswBJe7bxwPGAmdp5DZarKZvbDyHBYxdVKXPeEggzScNPqhA
21800	payment	2132	2132	1874	1	1	186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpgieVtzsRxj4RvnYJrk1wVowwMmXtzDxnHc5TBaSizocbfmz
21801	payment	2133	2133	1874	1	1	685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh15xvrcTqLpbD4nKP4C7Y1cT65oMka8qJmHWh6yvmdNQSQ82J
21802	payment	2134	2134	1874	1	1	669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqbiFMLznk4bgGzVetdnZ27FSfNDQk1Sap8zNd68E7YvM9jqb
21812	payment	1397	1397	1678	1	1	9533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuJzcXze1TuFKhtGXhyydqcyLcGqHtyktz58tAQ853cWQtFhKA
21813	payment	2132	2132	1874	1	1	187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNAq69Tbfbnk4SP7SkDsSwdzNBKhAGVgay6FYB8vLLEV9BmwA
21814	payment	2133	2133	1874	1	1	689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzsVG1FFe34tpe6X4HunYhB7aWGA4VCs1n91wZuK4FmqBviu4
21815	payment	2134	2134	1874	1	1	673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1akJZvqdSBLoLYXPh2G5FmQsDto7PnbEPqyk8dcr3FQT3uuC
21822	payment	1397	1397	1678	1	1	9536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XmJneTvrL8DPUY33qF8ygad9UhpL2BYasTkHhsqqZkAvQLo3
21823	payment	2134	2134	1874	1	1	676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhJeytoUMfS8tdALaHyWkj1qXTiZSsLaLj19M4eZnH96beC1q
21824	payment	2133	2133	1874	1	1	692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPdfx5ZSVE5fk4rX54KbnXorY1Mw2E9qmvuVXahp2inpYexbS
21825	payment	2132	2132	1874	1	1	188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YHvqiPW2YYLMCoSQyUrNyfkTUiQU7sJroo3K97oGkMrw181i
21838	payment	1397	1397	1678	1	1	9541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRsEP5E8GbZNgKV2j8HAHp2BNSbnPzeLGtfTtryJ4QHkeRAVa
21839	payment	2134	2134	1874	1	1	680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYkjxEwFhzKWFiPmyr4UeKZgJtV1qUabu6xRYwmH3Pg5C8VRw
21840	payment	2133	2133	1874	1	1	696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsT7Ed3NHy6bG1wRGT53qGB998dZyhREmboiv9KFHs73UZTovW
21848	payment	1397	1397	1678	1	1	9544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTYMirRPeuoSYUKspC1VbBqxLy3qteVCqvV1j3mbDCV2deyBa
21849	payment	2134	2134	1874	1	1	683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnbF2Pz6NKFy7ASiD58QbFbj3Yg1QqvhFSHzAPXABgzEdSaAA
21850	payment	2133	2133	1874	1	1	699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyyNCxYSNbySXZ2CNx6R2aseUFKu9griJDmaNadoh8pwbXo8S
21870	payment	1397	1397	1678	1	1	9549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxSqjCkgNr5nt8P1Q4Cq2tF3VHezdE8dNqJmmLCTewXoz61et
21871	payment	2133	2133	1874	1	1	704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8fwAJpNLLDWmK3EEDaRKwzJiQeGZ8jQa35kfUdH8g177nA5o
21872	payment	2134	2134	1874	1	1	688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa95Kgh29epzdUGh5JvuF637MnHomX6i6owVScyC2LP1BBCLuWf
21880	payment	1397	1397	1678	1	1	9552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBiJiLocTzmdHKKNvEZHVzd6ZT1iS9DWeNt8tiMc2wYjN9TJA
21881	payment	2133	2133	1874	1	1	707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbfwt2faAHhFYJKtFiRUvAiCZMLZ1n6j9qWJzG7SPsNUcfqQr
21882	payment	2134	2134	1874	1	1	691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVtqdyFJeZAD3SK1E6ToWyuHZPNmmZWgRzv2YLdyYcEe8p2Fy
21905	payment	1397	1397	1678	1	1	9560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZypGgsAXWPXQ6XGohJKHkzqZSkDKCJ1xP6coLC1TR2eL3UH79B
21906	payment	1397	1397	1678	1	1	9561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAS4R6MjCNmLGyV93ZAc9Nx4PFovPc5bnv3GJHKanQan6RoFF
21907	payment	2134	2134	1874	1	1	699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1rorayTfKUoR2WA8FfG8gRSmFBgyHNo53nNS6rPzgC5LUrD7
21908	payment	2132	2132	1874	1	1	195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQJ27acuZ3NESLCQtdz1J6J2PJyzDkFiLJ5GVFCErPDCAuFnK
21909	payment	2133	2133	1874	1	1	714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydvhaDXUKjRceoDf9uyKVcNLH7qZt1A99m6HFtGJPyWVid4H9
21910	payment	2133	2133	1874	1	1	715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4E2AWa2YWSc7tV9J1iRF6ZrmVwYDQdMWWShE7MZyNEubEJ9Jj
21918	payment	1397	1397	1678	1	1	9564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkQjqPW2zwTzzCmR37Z92M6KmGCxwDntwMB69g6Di5nDqL7kJ
21919	payment	2133	2133	1874	1	1	718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjV6ti82LJpbdFQYXPDGxqTX6EHmP4uo1FW9beU7EYuetXfhQ
21920	payment	2134	2134	1874	1	1	702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnMtnUkqbTBSwGVrRyhhd5apXU5cVY4twpJVD9EDmhqmVu1qU
21943	payment	1397	1397	1678	1	1	9572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt4jMN9sknCzoGqk64N2rdLVC22dhYdWfekdJA58XZgZNuPKe5
21944	payment	2133	2133	1874	1	1	725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUmN2HF6hsVGT8AUvQAUkEYr1PPwgnLAzTeMqvik7MyNA5upaX
21945	payment	2134	2134	1874	1	1	710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bRLg6CDedJ8tuTP6oN4tHRErEss2jJkyGa83eaJZHtoipbrQ
21952	payment	1397	1397	1678	1	1	9575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPeRxB4kyQpZbJjrJhCqkpZQW5KQMvp5ZiXDCEN265YdH64o8
21867	payment	1397	1397	1678	1	1	9548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtCdr4k1CZAgZejNWQHHKUyAgYNoMKrzezdZnpU27fUUzxBmw
21868	payment	2133	2133	1874	1	1	703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWo9xrhm5SUerZojXysMKfqrFHhQDri5kd3MFmwjom4pXsTJXG
21869	payment	2134	2134	1874	1	1	687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdaZB35mer28di7FzGac3tMc92Vw7B3zGxARX9EaTkR7P3WuJ
21883	payment	1397	1397	1678	1	1	9553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQK1i8ew2SMHyP7J4WnVZUMBeUKCkJDWse9YhTKnJpRkimieVx
21884	payment	2133	2133	1874	1	1	708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaEM2enRPgaceXTvZXuW1Z7Z7EdotZW4X9m2FHhi5a3GqRcjn
21885	payment	2132	2132	1874	1	1	193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgKWDpLTdb4PFbGsP4aSZrD8UQiHMAsf2adsA7na55fhPbSK5
21886	payment	2134	2134	1874	1	1	692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZZsgSZD4wjkVrve271wwqQypP8vLmvCvxc1Pw8xMvjGLGfg1
21921	payment	1397	1397	1678	1	1	9565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTauZjMDdAHQNha94kmctg89GdnXARRivJxNyvBbaACjVonkTN
21922	payment	2134	2134	1874	1	1	703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUyMbpMG8EidfnnXLUu2k3NLbEZMB3Te5QvJyyfNVRaUjZVAp
21923	payment	2133	2133	1874	1	1	719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfKvjS8Khf9EyfnWdQXqmqJCuwBwvq1yFMk2yXpnrj643CuDF
21924	payment	1397	1397	1678	1	1	9566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyS5Ynuaf7cmzev46f2yqLffU6KMFDRGDKRbcAaYUB5rARQytU
21925	payment	1397	1397	1678	1	1	9567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdeJSXTsoDTKW5VfKQXR5ArjiL3PEkcEx3TPdA7c1fG3QTB3h
21926	payment	1397	1397	1678	1	1	9568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcASi9kLv3KuNBdXtKGvQzNPV17DYdpymMKMLatdemcsLdJGKP
21927	payment	2132	2132	1874	1	1	197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2wsoDAEPkmeJr3yxLmeUnpF9vAhwbbjpZdEw9Z7wsWUCuaLE
21928	payment	2134	2134	1874	1	1	704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPa8Jp2KKUiSUUt3pqejdnLcxwsyQbqFBw8gaz7eTBWXPjEvc
21929	payment	2133	2133	1874	1	1	720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRjPHZ325zPPHCPpdmnJg17EDKd8wyRdPQmpCiM7B4rC3PzrF
21930	payment	2133	2133	1874	1	1	721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGaRzrMKy4c2UE98oKQ3xwHkdekHxq2iMiANtjddQtWJNWFQ1R
21931	payment	2134	2134	1874	1	1	705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83WA1zB7T38rjGGdr3J6P14WD4wCDv1wcaWCS5Bj9nVFGNTqE
21932	payment	2134	2134	1874	1	1	706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoD6Z5iq7FLWKYUtMa4ZciPERu4JkL2itQ4SHoT7khUCukLyb
21933	payment	1397	1397	1678	1	1	9569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzM83qRVSouLtSBGzhJNQnKkvY9r8keSvcA5WrRUS2mSwaGyiA
21934	payment	2133	2133	1874	1	1	722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnw4Wm4aaULaPxtfYpkKpucECLyhjZsti5kcBNMtbH29Ct38YN
21935	payment	2134	2134	1874	1	1	707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENhSLDgNy5YAJDoaH2LnGeDZYqQde6VTBeLWEXF51rZPQ8oas
22035	payment	1397	1397	1678	1	1	9600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tJ4ef4zSWonD3VEb1vQ9dP4wrNthfGBDCim2p8fWeVQwNnKw
22036	payment	2133	2133	1874	1	1	752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbQV5FcNNaJYhHpjmGgTRExN5hEhPxwXpbQfpqBvjhRbsHVhT
22037	payment	2134	2134	1874	1	1	738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRG3mmUsj2zupXXDG3SvcDdhVSiUJ7By6NhkvCujwif1mtJb7
22054	payment	1397	1397	1678	1	1	9606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKkMHeEk48CLKK4AgnGSjxJEHDeTpz4rnRo1vMuq6msUEnJDS
22055	payment	2134	2134	1874	1	1	743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZ6cpeKhMCzL1DCsGBV9czqECn5gCETsKB7nmeipwUZTHmR9d
22056	payment	2133	2133	1874	1	1	758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrGWpntmmB7AtXc5NbGWBci6SXKdckcNR8uHtm5iiVieCJizA
22092	payment	1397	1397	1678	1	1	9618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxhhT1hDJNpEsYrMX3UJtMjit3oosZdrZV3Y9KGnR3LBwVxuo
22093	payment	2134	2134	1874	1	1	755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQHMfpd1Ujm5PTTVmJfH2MPSJJFBzS1X9YzoSKiCGwAATi1Tf
22094	payment	2133	2133	1874	1	1	769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzJ5YDh2XCJzfV7M8RXSEU8qb2D8LqEJfdGroTvsdNso6yGwN
22100	payment	1397	1397	1678	1	1	9621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThM9jNnpMLWLDvtmsXvJFcmXAHBRwBeHnVKu1MTZyagysxZBx
22101	payment	2133	2133	1874	1	1	771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvEQi7Rs2NBxS3MGdSgCpfDYrew9qbQeXEdddHoKa3B5pViF9
22102	payment	2134	2134	1874	1	1	757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZMpRzyodsNR6JBQhcYgHDSuBtyvwxjrGLAqNdRbqA95UhNAj
22103	payment	1769	1769	1769	1	1	41	3000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tup5cCXayqFZnhjdHZXJijwEzWd8MU4pH8FtTw5MpNpngAih
22104	payment	1397	1397	1678	1	1	9622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBS7cEGQsFS1Xq4tJXhZFu6TukJ9ZebjZhUSnQuP543QZTSS6
22105	payment	1654	1654	1340	1	1	4	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86Gxxxh83bcJ7hRiCS5n257GBGHuYbFgk6ugeDMFssX1ZZcVY
22106	payment	2133	2133	1874	1	1	772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrWfRXD81mBLY82ijeAvSBT6rztY6kMSV3P32bdAog6pspx4Z
21893	payment	2134	2134	1874	1	1	693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRYj3be4231Chu8Jw6AQVmRoEdLfoWMQUrhR2EZbbbHqy8PBa
21894	payment	2134	2134	1874	1	1	694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeQnxPJFqLmt2VYeto2eaG2t1mcAoyaQcm832q5Z1uaMMWZLy
21895	payment	2134	2134	1874	1	1	695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9vdkP46N2qqyCi77UtnBs47jDbs2nv5fMQTC95K2WiFpkkCD
21896	payment	2134	2134	1874	1	1	696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ywqjWLT24ZoQ9LJiVAm9UVvbaMV4iMZf8mHNPoEuL48tfs4q
21897	payment	2133	2133	1874	1	1	710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cZYSPSFGej9r1i14CQxTAhsL9MCRxJ6AUa4AnzFrkHeXFhj8
21898	payment	2133	2133	1874	1	1	711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aCRDh7eApcQ7s4eRuxgZcvm4ZeMFVis7iq2wmUpZrhVFuwoe
21940	payment	1397	1397	1678	1	1	9571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFYR4379FvwxByWWEBttm6L4RUNV6vHHFLjX9P7KAjhHBALaC
21941	payment	2134	2134	1874	1	1	709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoctJVZtdKwRfhgdQsLU4joeAEdYxHPnhrcLMmtfnJ1o6E2x5
21942	payment	2133	2133	1874	1	1	724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8We2rvTDtFzHdxQQ9jBRmAWuuCYGXHbyBcxB8kBCMPfZWwm7K
21946	payment	1397	1397	1678	1	1	9573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3SUCQ2MgVmefvtxnM4TzSDsNqTTqfLiKkzc1AHB7bDyF6cp2
21947	payment	1397	1397	1678	1	1	9574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrGxh3fL3Ci7WBnP6TpA4S4SHxqKYtEgXd8Sg66bSYrqVQ1gQ
21948	payment	2133	2133	1874	1	1	726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePAkdKGu5mGd1uhrrKwsmVUf3SXYCTaYD7UAgfjW3zcBCrKyU
21949	payment	2134	2134	1874	1	1	711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdBXNVbwWVMfWaHkk2kVur4gvCNtG9ZGKxPhdcezQsdQUzACD
21950	payment	2132	2132	1874	1	1	199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaj4jHMapHZsCq9aDHdHUhjRu76yp9gWr7Rt98yY44Xj8ppS3v
21951	payment	2133	2133	1874	1	1	727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUAcWnryqDzUxN3t3FU53jXGrFzQPTQ6gJqi4ouEcS8bLxeiX
21975	payment	1397	1397	1678	1	1	9582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XMKoskYrhfy78AhZidkg5crfwT6YhYrr4KQmymREheupCkfa
21976	payment	1397	1397	1678	1	1	9583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQFDoeqinzsjbcvEunQ6mGaazvkxLseh5G4AwkfcP8jKY5WfG
21977	payment	2132	2132	1874	1	1	202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwJ2eGtTTu93Qox3FkF6NJMrPgNGaif366jxYFH4EKeGxnzyD
21978	payment	2133	2133	1874	1	1	735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJq3KY77Jtx83fFBD8mQvaA6GFzPqTxuj8SAELkhiAh9Ewf9G9
21979	payment	2133	2133	1874	1	1	736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJdBcu7DYUPeJuMiGx3LkGeKGRnnunMLRh2iRxqVqWFEyuZ8o
21980	payment	2134	2134	1874	1	1	719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQexFiib7UNo7YdaKawWojNmkGBBuSC5E4QDnPgPM4cdEUB9H
21981	payment	2134	2134	1874	1	1	720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQSzhbB9hEPknEKtUSpQDqASzhssCtscGf16Bj8pN5wqW2MkS
21984	payment	1397	1397	1678	1	1	9585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5LRpuwfM6S4sHdwUEFTULjwMabRXomgcSiZtWbrQgDsBVCfB7
21985	payment	1397	1397	1678	1	1	9586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3n7nNmUycn8172cvmRURe4VL9saUv457SSvBQ3VQWHwqAivzk
21986	payment	1397	1397	1678	1	1	9587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesQ7Yu2rdmWsLXvLzvc1nnVriabQcHqCeSqG79v3UiejARtMQ
21987	payment	1397	1397	1678	1	1	9588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4EqisEbS6AeEJTNNAFr5Q6TeufiavDGx7En4Ggtjbt6AB8Qz
21988	payment	1397	1397	1678	1	1	9589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2thse7LVNLZfyWTMR1XWPh1dV6rwm5jLq1w3LTbt2XFapWGTv
21989	payment	2132	2132	1874	1	1	203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeW2bTdrCwGbMTPCYCzWuxvnqAJs8MxjN8sud6z1supNPT6z2
21990	payment	2134	2134	1874	1	1	722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6pbEQqduDE44PPK5W9mBMQZR1gurrLS8PYWhYGobgXB6W4Lp
21991	payment	2134	2134	1874	1	1	723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8ewurCKwcHT7hxfGqiheMwVwnvD9J72mAeg1mgLPn118mDyX
21992	payment	2134	2134	1874	1	1	724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvoZBCYpqe2pRgTRHzYhS6ijY5YU66PQL7yVoG3YzJPu3V2q5
21993	payment	2133	2133	1874	1	1	737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrx2hEjy4xN1miPkPkKdXZuJwmCtJ1urnN7ZAJxxg86tNHNypm
21994	payment	2133	2133	1874	1	1	738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR37txQXWvgK2nDjhYGSup4YCrbs6Z3Agh9DeTRVEtg4hjfduJ
21995	payment	2133	2133	1874	1	1	739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMpqXDMrhAqBvSecTJViNrn6xD9afcoXGWBQuqcw8BmfVgEUD
21996	payment	2133	2133	1874	1	1	740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSy5t8vjsvWEpQUrTn3HzHrNvAFVJTw65UddAbsd4x7eXqTKhv
21997	payment	2134	2134	1874	1	1	725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3MCJF7Pj5mfudQGf9KjhUUr8AeFQ4pY1my2XfxZq5hhQ7hji
21998	payment	2134	2134	1874	1	1	726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjSWPHRbUVQCDmZxpv3CL8wrEC7oTEtFDFDXPdQXxm9MwCVHi8
21999	payment	2133	2133	1874	1	1	741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmo8Fy7mTVjLDxcf4DgtnKonevV9rvLihxXvUaabs57BBR5Kt
21912	payment	1397	1397	1678	1	1	9563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYU3vWXcnoCBFRRoYM51yKd6zqAMvvgvzxHL9Pr1yV7A19TG7x
21913	payment	2132	2132	1874	1	1	196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5mq1wnKhqRrbXdPANjRRh5ZPeXy6mi7h54txwmzwToMFeemf
21914	payment	2133	2133	1874	1	1	716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6yobt2TQmo8wkhPD3N4LpkWDLBubg13r79m7kVgA7j5gkwVk
21915	payment	2134	2134	1874	1	1	700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpat3wY8dyRnF1na3MNiub3kjfrpAEa53rMKD96xksZbCmfQ3j
21916	payment	2133	2133	1874	1	1	717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RcmJFtL63mhfkBCszokCkPaxqYZzoyzYHH384u392aiPAZDs
21917	payment	2134	2134	1874	1	1	701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbpPpp64QVSCSghwk98dKZzb5PCK8NM2wiKLYCGmgRr3ZXMM7
21936	payment	1397	1397	1678	1	1	9570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczB5ekzDUAVEWiDGL2kHw3BjWfKo4A9ccbG9Z7Qe1kMj2ZaCg
21937	payment	2134	2134	1874	1	1	708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqCgFnT5JmGqEo1QiLcCYHt9umhRTJGPmbt3NavwMSCyXMLLu
21938	payment	2132	2132	1874	1	1	198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2Ci9PBGKi1dP1bfUb3hyKtvuY9QMtv1yKREXuJ7LtZ3Njx4V
21939	payment	2133	2133	1874	1	1	723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxd8Vx7aLBs8uD6rC3ae8pvKeDbtHuU1Atwcec8GHpPZLXZWe
21962	payment	1397	1397	1678	1	1	9578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmmsUhzgYCUzKDii1nHj6Qep4tRPMegjEH2bz7fNQaanwTY1HS
21963	payment	2133	2133	1874	1	1	731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshfDsznGXcowmHe9JNR4g9fydzF3gzTCL2WxxerumTE3aWGH6
21964	payment	2134	2134	1874	1	1	715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17S2aCGZR1i7Pdb9Kx1jjuNjni8NNLzaRPLSS3ubXxyrQ1jDr
22000	payment	1397	1397	1678	1	1	9590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdexwu8x3rdY9cYgE5zecDNMSmZE8L1FXuB9aWT1FFr1X4hZx
22001	payment	1397	1397	1678	1	1	9591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgoYoAYnpfiZC8cTRbaKJgEwKshJpS75s4PoQPmx8DUkigqfP
22002	payment	2133	2133	1874	1	1	742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiM23C8oLuFAgCtzAzw9F9EuhrfbTBSBRUUHYRCTN3dTSNVbLx
22003	payment	2133	2133	1874	1	1	743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQ9zkRX2XTxL2rd8SZhNdMgMG7WvpN4z7qxvQDpgyu6ZVGiPM
22004	payment	2132	2132	1874	1	1	204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZup849WVeV4bREwRWEHeQ8BiWVeCbjeXKCESVyGb4v8KKFrxvB
22005	payment	2134	2134	1874	1	1	727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvKxBKAUSUU42vhw52h9sDh7YE9ZzcZcfDQv4DSdtuxxVH4AS
22006	payment	2134	2134	1874	1	1	728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxzYHERUxwKSevFQJdgiQh1dVeCDU2L1y9S9syATfA7rxzhHb
22017	payment	1397	1397	1678	1	1	9595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiPCJdJzrxMWH9ULbDJ8xmBU8jKPkS2rKxavfjuMnaLTcioPr
22018	payment	2134	2134	1874	1	1	732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsd1xXC6Hi4r3PCax33ZxcGhsgcmZc3z3mU6Rn1tCjqGSzNtG5
22028	payment	1397	1397	1678	1	1	9598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cwoyytJ8wKkajoWCi5iXSGnvnCvqVW6YjhGQmfcrwXpNdohy
22029	payment	2133	2133	1874	1	1	750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmf6y3PT4ZYrbK8TmLHH754PqWR9Cr3gvW3WUtj8WJ7ACoFmPL
22030	payment	2134	2134	1874	1	1	736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUz2P4t2GauKpWJASr7NHGtwt6fzJb7s4hRkq8MHWSLAUznvE
22038	payment	1397	1397	1678	1	1	9601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAucDHKrb91b843QJcDWBr7KkrRsqdVqLzuunjq82aRjTzhNnr
22039	payment	2133	2133	1874	1	1	753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1b3neYVwPaaaNsFPWfstQnVy5JBF2q2MPjc16XeYvwMrEMBG
22057	payment	1397	1397	1678	1	1	9607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5muhPxmCBdhsM35DLaeWGVPi8ttheVkuZsrrwirHKybCe4Koi
22058	payment	1397	1397	1678	1	1	9608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9cYWj1Gmg8HF4Er1EPURSZzDJxyHcWxgKNFD3PynSR96Ys4E
22059	payment	1397	1397	1678	1	1	9609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxo9v72hR7ztgtfggE7ZPnj3Mi7sctC1co1Czzrut1UUbJqtir
22060	payment	2133	2133	1874	1	1	759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ668Nxy3WQTCrzMYTEd1mL3YcP47sVhXGGiY39T5QSfrGuNsRf
22061	payment	2133	2133	1874	1	1	760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksZNG5FaFPCXQcrPBgNmK9ciPJVnXcvg2c8Ybyw6ReiMpfctV
22062	payment	2132	2132	1874	1	1	210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmAqZHMEKTGWWr8i9YujvsgLcUwai4cFnFa8aPYk8USEGXvtV
22063	payment	2133	2133	1874	1	1	761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeymhLK3aUivRmxRorekn1KSttvWnjhWko1ZmVfK1ZTKLtp2j1
22064	payment	2134	2134	1874	1	1	744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RBPG5DGwXJKizx7MEN5FpDsr5zioc9cA6AJQ6uVYDQUDbZLR
22065	payment	2134	2134	1874	1	1	745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqTgr5V45Af3qB6LJRXHgtApqzHTDa95GCaWYNwBUYzLiwQbY
22066	payment	2134	2134	1874	1	1	746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dJCdosPSkBDSmRMuEzg3KXifGmzAjwN6Rwv47AAP5XGmryPE
22095	payment	1397	1397	1678	1	1	9619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxx1aCABT5hphxtsQqgkWNsjehzgPkrV2FKwAZFYaqJ4KsHjm
21953	payment	1397	1397	1678	1	1	9576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4Eggh6neZ82drqPF1pP4DBufTmmbE83syDyVD6SyjMBnTn4K
21954	payment	2132	2132	1874	1	1	200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWqw2Fg8QBrDXVWaxScwFbnhukotbKDPzBrGqKCjoQh5UT4dr
21955	payment	2134	2134	1874	1	1	712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoP3ZYSa2PkEdLHoXoQ8pTNRL2HKavAoPYc4DkpHtc6odZhsVN
21956	payment	2134	2134	1874	1	1	713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxssCLDZCWxmJr4KvZbmhy85EzzC9RUzVTDYY9LEbxeeYTdGv
21957	payment	2133	2133	1874	1	1	728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4xfFXXDZyhb3QC5cATcMePu9Gg1jPDrZBc8pfawNC2cajpkEL
21958	payment	2133	2133	1874	1	1	729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPgLK6t7193pQ8cRAt6amqCdjabG1CXMf4JY76nGFuiicWkVW
21959	payment	1397	1397	1678	1	1	9577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uBDAc9Z2yri6FUpevakrbwgj3uFaakbfEuktCqDx5wb2vtjy
21960	payment	2133	2133	1874	1	1	730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNV4zEF7NbWtAXPrx3xKS81pLAiuJUn5nWV8Mk32Mz99WH1RL
21961	payment	2134	2134	1874	1	1	714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVYACjbcqxyMFoKbtfHkgdizamwsb6J81sxPVdwUsVzdkQG6B
21965	payment	1397	1397	1678	1	1	9579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoJUprY9N6tqCwu981fbeyiPNfm22UCgWscWRHXTHJphdVf3X
21966	payment	1397	1397	1678	1	1	9580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2SvYdjniq6sBShPyYJrjL7F14MVUrgYjJYbNyJaAC8dab3uMt
21967	payment	1397	1397	1678	1	1	9581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2vGw49UDVcYBeukUoKaBv5mLkmMS7LC5zHyBzj8g243uUkaR
21968	payment	2132	2132	1874	1	1	201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyoT5FZKC8GwY7utsemXSCQLXCgp4BktXe8cJFTNm5SsTrWPr
21969	payment	2134	2134	1874	1	1	716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9WLv3MvUWPU5c8DFUu6wpn9kREyQS2XxA1AXXvtC3sUW93Su
21970	payment	2134	2134	1874	1	1	717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqNyKuNqn3UqnCWZMweMcQgKqTBTH5yfcTbn7CAYeGzPCnysF
21971	payment	2134	2134	1874	1	1	718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikvL3MDBfJY6txiPXz2H3sU9HEWy4Yd4jY56rgCAEk3TwugD9
21972	payment	2133	2133	1874	1	1	732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BL8fvbxGDu67g79UZYSiLSbvHkynesCEEpa8s3wTwzfauc1y
21973	payment	2133	2133	1874	1	1	733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSraqpZJc5miLsFED32VXVQQS8oEhyQ7o8eEhYocw96d9pR7h
21974	payment	2133	2133	1874	1	1	734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASD6e4KATaV2mghCABeVsu4cN843vycqVhS8LezrNZP523YsR
21982	payment	1397	1397	1678	1	1	9584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqVmXqgsSGiZx5nwqeUgJAgmTyFb3Nrryc3eBtuyyveS29RRG
21983	payment	2134	2134	1874	1	1	721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUMomWe6S3bPYG1pGiivA4Gs6G8AzYHgWZSFFqSe99nfVkpd8
22007	payment	1397	1397	1678	1	1	9592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUBNVqv3yqSbXis5SuVHoAu34XrwkTiT8pVVfsNyG7znYu15S
22008	payment	1397	1397	1678	1	1	9593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzuRFqMiBDxShneWgPSAsBF8JfKJFKJnTHHJVLohRs7B4CN2W
22009	payment	2133	2133	1874	1	1	744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMPxr7EpKcqL3bpVVCZ9j4q9Bdrg2JQZoTGpxAU4Q9LZkdbuC
22010	payment	2133	2133	1874	1	1	745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkL1ni2xHSaVrGPxzPmxbNnJRFihbtSyZHfP3uQyU2ZG6dkQ44
22011	payment	2132	2132	1874	1	1	205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyv5yXiqo4QuX6wK4mT11Lc6bpRJCA5NUd5XgTKDNHG7gJHwZF
22012	payment	2134	2134	1874	1	1	729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6FQ65wqC9L7jVqNWVe5qG2ayZ5SZRG47sVb7s4rkLJs2ZNDu
22013	payment	2134	2134	1874	1	1	730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymovhiWUb5tbtcTbcvWviphCNFyZpzGNPXuG8NDh9FrpNBX8N
22031	payment	1397	1397	1678	1	1	9599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty8bHCSUCcf7My6VUVERHvJjL8U5AXYJjzEXrUs25Q7egt3zn
22032	payment	2133	2133	1874	1	1	751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBmd7nECezoQKGxYhkksUnq3Y1qvMuqWh3zvR5KAapeMxHvZe
22033	payment	2134	2134	1874	1	1	737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ8WM5oFkjCg5A87WQDy14k4j2e5uzsQ787FZ2WXR8R9ThAgnR
22034	payment	2132	2132	1874	1	1	207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceZ1P7GpgUqBbmV6rVc7FRo7675CVACa1Gvx6EoXwQQ3yx41a
22044	payment	1397	1397	1678	1	1	9603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb3EUzrHRVYNW7EeFj2xmTYcjxHxuw4qbvy9NG5AKHxDP4MZa
22045	payment	2133	2133	1874	1	1	755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG26U8WX7KSvXddwE57ZepTvJp3WRvnDxe2gK7w1nGAudbUJK
22046	payment	2134	2134	1874	1	1	740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSohAMYwCvDaC3ujxs76jVUoUFdBt6GnFMLTycW4Gk3JTHScFS
22047	payment	1397	1397	1678	1	1	9604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpHkgpyJYVooa4Wf9ZiMUXk2x27YUbiDPHRyd1TaUGYKQhJhj
22048	payment	1397	1397	1678	1	1	9605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6DC4gpUqhGRJxX2SCufzvacq5TpVZZUnHj217mRLceu9DG8v
22049	payment	2134	2134	1874	1	1	741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfh6q47Kpzenfq34wcK23SLmT7FAu5Q7Bxm6gr1sPRqPVHpAWR
22014	payment	1397	1397	1678	1	1	9594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUxJKT7iKH6o4R6GEwosnrQJRbbt8jyqiut41AYkroEoYzoNa
22015	payment	2134	2134	1874	1	1	731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxewhaK8HCF1yXkkzccqJQQuGjfUDMq6SUt8HjusSaCvEessjZ
22016	payment	2133	2133	1874	1	1	746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZugvvS2DFETPHguTUayj46pon2dHyVnxGALc3FWddxMYpsrwXV
22019	payment	1397	1397	1678	1	1	9596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2XxKtDvT5aES2poixma7zFZzvGtE8WBaZADKwCRmbbyVWSdZq
22020	payment	1397	1397	1678	1	1	9597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HS8hngB98MSKeUszVWctFkdFa93DWfe7ocFLcTT398HfEEhJ
22021	payment	2134	2134	1874	1	1	733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuX1N11abE3c7XW5cFtcvADw2EpzhuH82M596LNCNTLMPS4RBL
22022	payment	2134	2134	1874	1	1	734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVMmYiZKa7gGHUQkmzBxH6M6XW9ks2f8WCsUYve4CjhiYKMMi
22023	payment	2132	2132	1874	1	1	206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnzGJxiE3VeWcTQE6D7uyFMFcDgt3h7gKDW7wybnvDXU8v4Ea
22024	payment	2133	2133	1874	1	1	747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4j99rvHJAEtFuXUc9pycpwheVF74i9ZabX8DP9E6YbS8hX4rq
22025	payment	2133	2133	1874	1	1	748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5QGDsvUCAN71okyYAEZDTNZ4WNUqrcY6p9SPBseCZ2BABVvG
22026	payment	2133	2133	1874	1	1	749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbpjU4cPWkZ233evRs3jdCv5JfDZ1ezUqzmaz6E6Hc1yfn6S3
22027	payment	2134	2134	1874	1	1	735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJofKd7BvgjQWZy2YGcHphLXXo6bd5smaGnu7UAU22Qo22q3Go
22040	payment	1397	1397	1678	1	1	9602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFrvbqW82Zazj11EFRiqPuey4ofStNzMEQ2u26yXU4PhjgFm9
22041	payment	2134	2134	1874	1	1	739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHazb3JKLdmBLUXoBB5UwCa6R7raqKz63kQeUxVrFNNixpjDL
22042	payment	2133	2133	1874	1	1	754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCErrLRMNo9CKQEgakXQeBTC269ciQmrQqxaz1VdpJ5UeEMTjZ
22043	payment	2132	2132	1874	1	1	208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWKDSCszR9dUr9f2B3CuohvAJnLWvPVuVxF5WGHpG2sMzB1ZE
22070	payment	1397	1397	1678	1	1	9611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBi9YMkPmpt9bT7n57cN2CaX1u9yJbdfh5Zp94ToA5cajuSbgd
22071	payment	2133	2133	1874	1	1	763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekgFEtvBGevJ8JHn2x3bGmAxKCdftqB4g2RYgPBajeSJuPrvf
22072	payment	2134	2134	1874	1	1	748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZecVNEy1USuUS8Hau17ygsqcFmaBAaa4a34T3KE2AYw4oGDC3
22083	payment	1397	1397	1678	1	1	9615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB7sTfAqRUHnmFKAXKfizTpxLiGbNshByAHq2dyUGsi3EWQJC
22084	payment	2133	2133	1874	1	1	767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNbRzMUB8DbERKJeeJHD4Pm1cJ3L5HA2Mc6YL1ANzg8AQtDTo
22085	payment	2132	2132	1874	1	1	212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQnzE8jEdh1Z4x1UqoaKAUwr13LSwjZ1WQoHpBMYV9LqFadZ1
22086	payment	2134	2134	1874	1	1	752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4yUp2SjtSaqqjF4Vjj1QrVbvGkYDvPGSsMgN2sgTiMcn5e5r
22109	payment	1654	1654	974	1	1	5	1000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZHjSg7JfXkhU5V8Gqg4JZ2CjVBbkv5iAivVFpuUkz6vuDDNEip
22110	payment	1397	1397	1678	1	1	9623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGPNgunUcgNjCDYjdrW4u9fRi2WvhGHNXL2M64Fe3sTQynTp3
22111	payment	1397	1397	1678	1	1	9624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ8q1ME2wWSwPfA3KNnVMSpnjZNXGFvjMB8MrhxTicTkPzDa1
22112	payment	1769	1769	1769	1	1	42	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzNAC7azYeqnyvwdCDmV5KHqZSEDoxEeqss5QMKpwGW4RVYrw
22113	payment	2133	2133	1874	1	1	773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLdr4Ahr2eVRhe1yWxSCoUsM52K2cTt9JAVKJxomNZE7u34GR
22114	payment	2133	2133	1874	1	1	774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBeuE2EJKjTBZqaio37yE6dvajQRUwPnCWyhP6Maipq9gaFvy
22115	payment	2134	2134	1874	1	1	759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSxibouMw23NGBQX1XzEo4JB7y8sWiNqE6jrMJygzerbxP5Wm
22116	payment	2134	2134	1874	1	1	760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpU3ddkye3cCoMLYtjJjRYeRLvBZ3qpt9T464FfUQs6ingcYJ
22117	payment	1397	1397	1678	1	1	9625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Lg4cNQqTjHmVToeo8JMtc5dnjwQTBox1tMx7CN3neELaKSVP
22118	payment	1397	1397	1678	1	1	9626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYC95JmtSuNwKrtZtA6Lxtn9tQTqc5DHgS4wNfRxV8Zqvp3eJj
22119	payment	1397	1397	1678	1	1	9627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVAxZtiGkUWEn26QwDqFRSk8Erq6rVLjVW4aPeWg7MYk3DMTU
22120	payment	2134	2134	1874	1	1	761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNx824Z8sKEb6BFGegHVS5esGwQFi8N1bujn19C9joGgBe5vp
22121	payment	2134	2134	1874	1	1	762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNMvDANS8LoFwZTYwc2zSyPUVFif8ibcYCvvx9mqbsy76GFzk
22122	payment	2132	2132	1874	1	1	215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvJ3qM32K911rTNpdnAPnk5Myyf5ydZ7aupM7cqVRaWuUQxdV
22123	payment	2134	2134	1874	1	1	763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23tYvPpVbZHMnCYeaxhVidD8o1PfHDtCKxKPEpxzDr71xhx5p
22050	payment	2134	2134	1874	1	1	742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMjMggmJx1XFANHXND122tAW5XA3CvPDQ5sfrdcwGGbGTqYPd
22051	payment	2133	2133	1874	1	1	756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwBc4htGNTARMc1rRzpu7gCWAqgdwsib2WXPsFrJNTpZSiQLQ
22052	payment	2133	2133	1874	1	1	757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeVYbqmAMFGW9qsHhiamqtBGPgfbHbR5bGqDBMSj1EN8xwJpQS
22053	payment	2132	2132	1874	1	1	209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1aJW2VGtdT3tCeFooj28BP7zbSvXr1tXUTPBW1dsYJZCJxKXs
22067	payment	1397	1397	1678	1	1	9610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvdteeDvsun85SzS31fAV9qw6LA376or9UsqUBs2wi4GiVCHB
22068	payment	2134	2134	1874	1	1	747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY2KueW259mqEBtr3sPhzq3j1kVxW2yWNUGoZQFpnRNhrSwED
22069	payment	2133	2133	1874	1	1	762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAy2eYCN2EKWu77rPHiV1zxgtCaxMQXjb1gFt2LEMavQT3wYEa
22073	payment	1397	1397	1678	1	1	9612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8SiymT5pzRZke4w7jR9iAtUUdCbXjCYgNDDMKE9pQrtUS8J4k
22074	payment	1397	1397	1678	1	1	9613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8c6guMCs6oEny9GsQD3bcTSjPokyiN7VU4aP5VCWR2JAuUrmw
22075	payment	2134	2134	1874	1	1	749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVAba5K6BPnSjiQb5EN1yfPLiUodNWhVyVkpa2QW9PpCUtKoo
22076	payment	2134	2134	1874	1	1	750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnqAcQkNZifF1KoNACS8fa6MzNdNRqqf2R7Zs4XHsnDb98xPq
22077	payment	2133	2133	1874	1	1	764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6Fhz1geEhSCZifN1VnvDjNBdxfWpcxxFP53VnV7nohNY2s8Q
22078	payment	2133	2133	1874	1	1	765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJJwPYDYuhHyT1jDRSUeYPJG62f7SMQw6NvdqZYteAtKwf5zQ
22079	payment	2132	2132	1874	1	1	211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmfjLNZLJ7X9dAu43KLLrPj4oxiJ1ymGzwFUvt5NqhF9Ce4rwV
22080	payment	1397	1397	1678	1	1	9614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4k7YqBBDhiNKQdw5yGQRWLSAUvP5xuXWnWPr52QFufFxc7ev4
22081	payment	2134	2134	1874	1	1	751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cJdHhfntrf5rVto4Edg4c8fMcQL4pV6BAmxVxUHX6685nRoE
22082	payment	2133	2133	1874	1	1	766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxCgDvcDAkS7EKWTHmaDKpngNR71b6QSLBthdMgbdh48J35oM
22087	payment	1397	1397	1678	1	1	9616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDneF5LrTJTqG9shwu97Tobzy7pNxRFc7GTk3wgpohTMWDJpcg
22088	payment	1397	1397	1678	1	1	9617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5iV6ccMXbyaS8VrjAJjcU6jBPJH1JUFyWytFEyfCQVkuNM1P
22089	payment	2133	2133	1874	1	1	768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6bwxGsHEa5Q8mVJPGzrKZ17DykTnEkkagGZsYBVr3LsFgcUH
22090	payment	2134	2134	1874	1	1	753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdiYpDmKzT87kXRLWYFt8gxWsDcNKJv5T5K7vSf4bTxhhDhq41
22091	payment	2134	2134	1874	1	1	754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p4uuZKzTEERjn8NhwKPsEAVjrmi4T4Z57arDyu4ktAoJnbQv
22134	payment	1397	1397	1678	1	1	9630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjc892S8tXrn2z2gAGbWzctcGtSNsdS3XUNnqRriR3HTq6hv4
22135	payment	2134	2134	1874	1	1	766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebo93xrTDJwEXxP7KM8AL4pi25b8kQuRA4YnjgR1i8Xrv9rwT
22136	payment	2133	2133	1874	1	1	779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9MhzKGPacd4hh79Nh3yNuDfZDggJKrF4QAHyvM3c7qDYitbNd
22140	payment	2132	2132	1874	1	1	217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLcCVQiZA9nJXSQrhX5Qx7Z6Ub64CTvhBgzCsqATSEQsw8y7w
22141	payment	2133	2133	1874	1	1	781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe858sp8BjhHvjmyQoCP8aCdSA8JK32Si6JGS5JmsR4ZAPBWWt
22142	payment	2134	2134	1874	1	1	768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoMtqtKXQ2jo4DSmfzFSYeaoQebMDZ6Go6SjSVHoj9uT7Ydca
22151	payment	1397	1397	1678	1	1	9635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrbvRrFTxxBJaJvrBozYE4DatScsgVB4xXFttdwTi9DEGwQES
22152	payment	2133	2133	1874	1	1	785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSMjyzQt1nF6MD4E1GWGtjZNroMm39r2EvdYa52rhE2vYgqZc
22153	payment	2132	2132	1874	1	1	218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGFFYk3onUQrmYoQNS25UpMd34T51tWF1u83LU6nvZbBmTANP
22154	payment	2134	2134	1874	1	1	771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYfNxw3vAWRcVc2Uvb1xFEC9PE9gguPGNphguwyPRwiWqvheG
22181	payment	1397	1397	1678	1	1	9644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFD12mDz1s5VrrW7fePm8AnXdZCctNgL75A6YPE4C5zLGekx2Q
22182	payment	1397	1397	1678	1	1	9645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcdNiD4u5V3pymTr7VTThkbhzh2gxcKzZhVgfM5iCpnvPMJG5
22183	payment	2132	2132	1874	1	1	221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF4cowWtCsn8oYyHyu4LCkGJLaK1AeH2BhaESyZ1cChU4Jeqo
22184	payment	2134	2134	1874	1	1	780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ieXYvYTXPokcPC4GCnTUb9y837zRWmM16ARFG6b2iF5W2FM1
22185	payment	2134	2134	1874	1	1	781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufHCLkBuinDqi9gcdpvvgBEtTxRXtwmm4o9V2SKMd6XSEa21w
22186	payment	2133	2133	1874	1	1	794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2XytG2vb24mMNjb314qSNAVGTDdYNFsa3CS64cigF1WqUbDM
22096	payment	2132	2132	1874	1	1	213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZSziYf9hd31JnVcuzyUNtNfcXkHUxmhXeaydU8NBZjbjjUif
22097	payment	1397	1397	1678	1	1	9620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPgPfnyDzaHD74CKxSkLaroPYqFFzZKKzK2tGnuMbZ2DJ8kWC
22098	payment	2133	2133	1874	1	1	770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6i5vkbWWpjgtZ867f8Wf4H5gdn7KGudiSdd7zbCZjmLRSe55M
22099	payment	2134	2134	1874	1	1	756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZjs5tKNroVBYbfCCSaKukmRi8nvXDQ6bwz9zwky9wMFyGEZC
22137	payment	1397	1397	1678	1	1	9631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNV1wUuzr4qjzhGNTTUcFHBcxfn6pLQD9mdkLW52oefppTaAi
22138	payment	2133	2133	1874	1	1	780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySGNtENwbjRPTiKDUvJTGSabBu8qhQ64gitiPpMJws383ZmLe
22139	payment	2134	2134	1874	1	1	767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaECrxQEoeYC79irkBEiEkknjaXAxBt28Jt4bRgkJHtiEbuZ864
22143	payment	1397	1397	1678	1	1	9632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BhWF4qqmkSZgrVvsozVa7sTrHUd3ebrvBozJhCneFJYgkV7d
22144	payment	2133	2133	1874	1	1	782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3J6tnitFs5czLDijXDaeHJBVgQ81SgBJHYm2sGRQk6mYYWLeF
22145	payment	2134	2134	1874	1	1	769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeaw5RKHXgGZvLSYiVA8A7jyGNmacWQssiTtGDdHFvqYVu91mK
22228	payment	1397	1397	1678	1	1	9657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xDbgG9ReD3X4ApkrBEfcP6y1Cfu2yrodqF6on8LztconHjtR
22229	payment	2133	2133	1874	1	1	805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JMZTs5RnTRGU4iofQJYbrDYzmcaZTza2b7yK3XUYkJdta6Yw
22230	payment	2134	2134	1874	1	1	793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhPN98ubLjTJYLnx91yiGrUcZ7LTEV87nMcHLHAPMUSbm68uA
22238	payment	1397	1397	1678	1	1	9660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JPNZ7kCLcT2RFecHZnAeANCK4keJNUYzamtBCh8rFq2stZaX
22239	payment	2133	2133	1874	1	1	808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJjbmNP4Cec9hGvkN71ChMHomy3csAoxNQ23RM9j2oHTWhqyT
22240	payment	2134	2134	1874	1	1	796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmuRSf8g8zekFNenWjimoR5LFTBDQtXPhi6HjJPHaU9rgwNNo
22241	payment	1397	1397	1678	1	1	9661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMuGvHkWzJYYbeSGuvenFNxxiJQRkRqtjNba9mYDKFgf4RLptL
22242	payment	2134	2134	1874	1	1	797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyDhhh6e8vX7mCLweKLvMUi9DeCPzBq6LixmYvVcjcujPNVfC
22268	payment	1397	1397	1678	1	1	9670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWDQwWQqxiYjNRNKGqHwzyd2bSAMNvr3BkQH32Jkx7yZMUfgQ
22269	payment	2134	2134	1874	1	1	806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRdgQgLUkqXuHabJ8VqK2tK8ryAkT7UcMbvNKsC1Cx3D4QESE
22270	payment	2133	2133	1874	1	1	815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfroFm1c36gMFrTFEXEsHnRHrPcsanten96soKcRHDXH4GeBP
22271	payment	1397	1397	1678	1	1	9671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcis1BMMEXZbQhx9Cynp9SEivyL1DGC3NMi1z1j6WTZjR4vbS
22272	payment	2133	2133	1874	1	1	816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXHJvYvHBRsn3EzuT7PFdGdHySYGsExiuCXL7HLMxNGiubp1M
22280	payment	1397	1397	1678	1	1	9674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgrFrdV9LruG9pnWcKQWpyPgfGz7RZFEuJjWa9BZz6oyuEhfu
22281	payment	2133	2133	1874	1	1	818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPbKmoL4tP4SikkSAf3bNdGcCYWjf2png9QFEzS5dCJmhwCPJ
22282	payment	2134	2134	1874	1	1	810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YP7dbqc9MYv4QZzsPWGBaMNwoENwJcR7aJBdiaFAt7aoRqvX
22283	payment	1397	1397	1678	1	1	9675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7adcar6szPgipG5aZa6TKSrnTM3Mn5JVkF93tXJn84RbAq6u
22284	payment	2133	2133	1874	1	1	819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnabUHKrsK4euVQJLmKGtN9wwk24jf9rwP7qjCDYiDxKD6A3x8
22285	payment	2134	2134	1874	1	1	811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkQ4ra3WuERnsuLgu8kZgzRiXVnJDf2jU1rQVcYhZofqBDgWp
22286	payment	2132	2132	1874	1	1	230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4WDxCnyC5RQwFyHHJikAXwfQK5JgsvXzaiBx4BFu1yQvToE7
22292	payment	1397	1397	1678	1	1	9678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLztR97qcpbAwfQo2LQByFdzmXeRNmfFJRWqVWK5BCiLX6e7n
22293	payment	1397	1397	1678	1	1	9679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvKDbgb9QVkCizsqQe24VCFrBX2mjqPsSkVzziM54nQkpxSBj
22294	payment	2134	2134	1874	1	1	814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSE2a84PBCii72GJ6zE7BzNxjgGeD7czLm5ApT5tJ1JBeXkG2
22295	payment	2133	2133	1874	1	1	821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWXkUfiGzz6Ud6bxfLgVZU16rnDNRQHJQZAMit1heU6Nv5Pii
22296	payment	2132	2132	1874	1	1	231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwtxd8NUa2c5SycdjSNhMXsJJhQdba64c83aj4JAuoDqynTdq
22297	payment	2134	2134	1874	1	1	815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69qhBY2Bi1qCUc7vgqbm7NDcX9qQhW7UXb13FLpyN13Ua91e8
22298	payment	2133	2133	1874	1	1	822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKerpmH8JehF6PPPpUsoKGb8NYULZ76NuNLWhVZXojQz7Pc61m
22305	payment	1397	1397	1678	1	1	9682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSZeEXYjcL9tuZGbM3KXEsj7qdpqTwM5MYVf15jbDHq7x5QZr
22107	payment	2134	2134	1874	1	1	758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyK1GjeXnnzvBW2U58ciAQePc9CkmBTg3QS1J778QkdEHoPhFP
22108	payment	2132	2132	1874	1	1	214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j9spPcP7xgvaJZRYbvkXvPA3fW4WXCKtMCCPa5CKxEHYhrdZ
22131	payment	1397	1397	1678	1	1	9629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhivUnZTZZowRYMxA7pcWgCVb4iVqW8QEKVRggoiWAb6ySHE7
22132	payment	2134	2134	1874	1	1	765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvMBkdBmrkGsYFGjUns9kVprMQQqbKmLYZg4JTsqNFAXiRFC6
22133	payment	2132	2132	1874	1	1	216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYxMuNn4yL7GCBiLy8HFcRauDfuXD72hbRbL4yovxzNbULHmY
22149	payment	1397	1397	1678	1	1	9634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgVDTVXpcjMiGEGiq5ZYAjaXpNyeqZbo562MHMfi7YM7ZBCsY
22150	payment	2133	2133	1874	1	1	784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tcf1xoBdoovaSA26xDr4PVwQ8BSASmGNtffkEnjEaNRUbUUT
22158	payment	1397	1397	1678	1	1	9637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZ3RVmyYYtU3LAQomnDxydkqZaWHCdPqtusos65ocbm5RzSS1
22159	payment	1397	1397	1678	1	1	9638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32MWB8Q6Z99YtWtwdFbqMWm241FbJZvXHWrh7qYaRVbQeaQCM
22160	payment	2134	2134	1874	1	1	773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHxRJHX7YfaQstcANnhUNRhSjfTRXi1spXzT9p46DiNXzitDC
22161	payment	2133	2133	1874	1	1	787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsce96TUoMoeECYT5gG4iWj8HdYAbFCNHfREpDPXhpRwSwX8no
22162	payment	2133	2133	1874	1	1	788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZrYAoRMhPEbvn8u8RBsDSSGzX9XLPNiC9sywVK4hxSmU1gVD
22163	payment	2134	2134	1874	1	1	774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkTEnnHGZVd45rhqZyaXtHEhMQHyPP8616pKgQj3D5FpZpfShr
22164	payment	2132	2132	1874	1	1	219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BMQqNW9F6hhzrKijXWKKU9y6bmDq9SPciqaYWMiF24gFH3VV
22194	payment	1397	1397	1678	1	1	9648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCXdqRXHCYzaT4N3fMrACNX6XDgZNCU2e7SEap3hYsJhkCFuH
22195	payment	1397	1397	1678	1	1	9649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXy1YiDaLXMxkLinkePQr4p3v2actdeT3kUTCaAdBpiV2x1EtF
22196	payment	2133	2133	1874	1	1	798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbc2hiagSVsn9V7FQ1WJUvQBCj1DiGCz672okxekYDzPfv15n
22197	payment	2132	2132	1874	1	1	222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75EMzv7vaGDEMxcZmVdGAsDC7mgnbeQXiSXrcDg43HKF16bUN
22198	payment	2134	2134	1874	1	1	784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfdfFmMxV6pUiZ7PHgzbo8YYoujdQ3t8CAauH2BK2SjsBaVod
22199	payment	2134	2134	1874	1	1	785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKj267ijsKEJ91RSUcQAtLk81jvLpTtgtBdo8A5uN4j9HLTL2G
22200	payment	2133	2133	1874	1	1	799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGxmQHrkBGVLp78u9gsU8SGdvHRTpQU2HGfj7e84PW3c5b6BKT
22243	payment	1397	1397	1678	1	1	9662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSzyxwgPEzPMMXX2fk7rGAzpqjtusASd3N9LQdb7KR6JrQQw4
22244	payment	2133	2133	1874	1	1	809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaKrbzYBwULCvXw15BMGwFpavXX1CoTDEB4vxQhqzikZzRd2Z
22245	payment	2132	2132	1874	1	1	226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDouCp1ZfhDxcFN618w1Vgm9VfGWbac1xwt8QX5KNARFUo5664
22261	payment	1397	1397	1678	1	1	9668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvusdhgzZtZs1PojsWXBzwnzre679EKvjWGrtcNKmuECAUZfi
22262	payment	2132	2132	1874	1	1	228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8g6V8p6RNZTRz62StVX3TiMNE4TaRn5jUcTAZyNRNsggV2ztV
22263	payment	2133	2133	1874	1	1	814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZvBa2RMbjLmXw1JdiWcH8m1yT9XGPtJzm2DbYD4mvvwxgpLb
22264	payment	2134	2134	1874	1	1	803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XzaUYhUDsBbTXdGEDQ2eqbDYhoTPyYaKHbVrQcW3DMbnfQ5W
22265	payment	2134	2134	1874	1	1	804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzdNbmHZNEuBMgMvkBT4YpyvU68JZ3bNqVFmbaxeRan2ZkMb7
22277	payment	1397	1397	1678	1	1	9673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvXXzbJQDCN4f78AhYyFo6FT4CVy34FQqW441D8n85BA2BWNx
22278	payment	2134	2134	1874	1	1	809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKZqWbjPjWESftT7evipa7t7Xcrs9Dtg9d2paYgJ24kNPzN9B
22279	payment	2133	2133	1874	1	1	817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9TyGsQUMFMr6Ezo6EpG8ThER6ArzyzJGGETxkCPaWZDphHpB
22289	payment	1397	1397	1678	1	1	9677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhgbyiUjdHAbnjrDRSDxshtzsubNrZn67ncRvZa8BdGM3AcTs
22290	payment	2133	2133	1874	1	1	820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFDEKrY91f72rV2pnT3w2rvFyRZV1AEZ1TCaztsmS9xjnQoKV
22291	payment	2134	2134	1874	1	1	813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUdo5stHYz38YsdbKSvyzGZ5At9DWRajJGxKfHNPWk1W9wsEC
22312	payment	1397	1397	1678	1	1	9684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxbAS1gGYTEBf3NWPTZ64UPc3edpK69ySfcS5Xpj3T4qxVoXxF
22313	payment	2134	2134	1874	1	1	820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3e43iuRwXLJwBegAQdn3dv7E2WGLi6xh2MohUdTr7eGNpBKR
22314	payment	2133	2133	1874	1	1	827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7S9VKCddqjWe4JNwMXekmq4VYRsn2DHzA4b3NbWYbXTrDNM4
22124	payment	2133	2133	1874	1	1	775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PDpKz6Fs4GYmr3ywWByAif3xDjaizGwdBiNBErMUpQLohXDT
22125	payment	2133	2133	1874	1	1	776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYqw9B4nAXCJ12w6PJiikeGagFhGUNZE9aq7M79y7cpN8GGMJ
22126	payment	2133	2133	1874	1	1	777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4AXEbf23m7fFGRzAX5TkZRsLN7i5fCTAzMVSdspDKd8K2civ
22127	payment	1397	1397	1678	1	1	9628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocxjkDGKd5EW3Z5hzSUQdh1NMNQNsL7nyjrBE3BHDv1LFBWKs
22128	payment	1654	1654	974	1	1	6	1000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	Ckpa3cqqhbXh1V3Cd3E2e83z5X27TSg55SqbKc9qfApm8syYMUoD6
22129	payment	2134	2134	1874	1	1	764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi95o7LWdvYiCTU7oPkmFntd9g7QZ4rNN9Ftf6CxsT3QancrWz
22130	payment	2133	2133	1874	1	1	778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3F2Kbt6EnR736QcTsG2EmdU7kZ34E9PrxJCybs9isfbhx4RC4
22146	payment	1397	1397	1678	1	1	9633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQKkFdqbWtScWigqjfK25EeqhRxKUfSp1hdC33Qj7zbXCeY6d
22147	payment	2134	2134	1874	1	1	770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYAoTYuBhDxyoe5DxPZG8xBY19d7oQYPpVmxYgNeUpb2ZM1Er
22148	payment	2133	2133	1874	1	1	783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5YhX2DwJkSyH6RGPmeqiRAGivrzGWCbMDCApLERLXWS76jTo
22155	payment	1397	1397	1678	1	1	9636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzqxcCbR3qgfdjCbwqTiBbu51MWevEnRJKnVZKEZ95SsH1Yon
22156	payment	2133	2133	1874	1	1	786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmDaWWZtHz4geL4BjzGbxFCFns6aQvsThFw4yUrvNwwycZsip
22157	payment	2134	2134	1874	1	1	772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3bDeT1Uzr6xiDDCAmvxrsKUttsfVqbxTytWAvpDZXZK1kwuu4
22165	payment	1397	1397	1678	1	1	9639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3YJRRxqU65iVDCL9arkZpM6Vyq9rmP1x1Z1wVVQemop8vQte
22166	payment	1397	1397	1678	1	1	9640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQbmhVMU4UCzb4yWxVQdcCbh1pbfGMugXuhkon4N7iMjGiRpi
22167	payment	1397	1397	1678	1	1	9641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFXa7w5tYzoFVmsQsouQciHN9AtXC3a9anH52ss2vUscQLTE1w
22168	payment	1397	1397	1678	1	1	9642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXU4DLXFqvQ7ToaUjZugpiwnuYna3jAg64mJsbXH9ZHXVCerp8
22169	payment	2134	2134	1874	1	1	775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ377crhxF9StDYG3CV5u4V1CAQt1bz4V1uqViqfroSAD2w1kr
22170	payment	2134	2134	1874	1	1	776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrzxEcUZjuEZH34U8fBFSdt7xr8Ty53eBQZcwgwBcUrYH2W8m
22171	payment	2133	2133	1874	1	1	789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinRUhwXn6dBgyHB3r1KJF8MaQmHrbuPzqkzxF58g5b1Fm4UtG
22172	payment	2133	2133	1874	1	1	790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdHQM8TZ1wJ8ggX2kGaWiMVa6QwYLS4ZW6XnWGKAgi4tkHPSv
22173	payment	2133	2133	1874	1	1	791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJVrrhUC4dpHgTRsG9YPc73aLFfDp4yWA87GFZwYn4YpwcH3T
22174	payment	2133	2133	1874	1	1	792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxBNbUE69eX9J8tR187o92fMdGSMavm5WbdSEZvJnBLWFPCKkZ
22175	payment	2132	2132	1874	1	1	220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgdsRA2jJy173k2HBbyWQJaL7Y9agxGs9orQMnHuzD6LYzBHy
22176	payment	2134	2134	1874	1	1	777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46unXNQVZoAynEZUFoaA7WD5nhmsbt8HLCzqHtzUFxwp5Fbzh
22177	payment	2134	2134	1874	1	1	778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dovGnaAfRS1Cvb6WsXz5XMwvypfsGsaAHaYW7fifA35BCRiW
22178	payment	1397	1397	1678	1	1	9643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sFieBYnPU7LQYtXycLcoixy5tqTutkNuZuqSYbVHLqDwKH3q
22179	payment	2133	2133	1874	1	1	793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2VmLgN21AwFNPtnbcB5WLGAFUKnTSNZA3PobBABcJhHQjNAu
22180	payment	2134	2134	1874	1	1	779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Pm3fxYrVQcAv9gi3Jdngg3n5kFmTA1vNwBhKgo5f1o17Shd1
22188	payment	1397	1397	1678	1	1	9646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGmEY6aonVnHRHDdt5G1CyQLbB86MX2ENNb3NpeDT9NZVzTer
22189	payment	2133	2133	1874	1	1	796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ175JxqBLQd65Vt12aYP1nfQEXqCXEw4Rta6YHZyjX63qv9HFx
22190	payment	2134	2134	1874	1	1	782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4snhcV6cjn47e7ScDY5WU8YsezWHpxA5cz8EA44BTSbgfvbjk
22191	payment	1397	1397	1678	1	1	9647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvt56KBQtxQQc7UvrKoGVn2XfDxPAaFUVzQqgpT9pigSb6jgJ
22192	payment	2133	2133	1874	1	1	797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJcwuuu6bY5DNfBafAos976xrh43Hr4tHFainzvDbtRHNFshx
22193	payment	2134	2134	1874	1	1	783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jeeTJ6DF3saEanq5memApBBgTKm1CLnK9C26XJehVVkPt2mg
22207	payment	1397	1397	1678	1	1	9652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvfuomzktS84LN5iZe9oVviNogGBmJoyg6yg4sDJQVhE35j89J
22208	payment	2134	2134	1874	1	1	788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBRnXBUV64fk5apR7M8untCsjjrGfyn63AAywbSEdxcGG8CEB
22209	payment	2132	2132	1874	1	1	223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX7ZRWQuLAE9f3A9rrNytqtiN5kxzibcwyMjAyP8TwERrFbecn
22187	payment	2133	2133	1874	1	1	795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgExzmDCShhBcv1AyBzwF571TeChwnMmmxtcQChSUrHVMtUoqb
22201	payment	1397	1397	1678	1	1	9650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1t6dMf3b5kBHpApvwnB4n8aFv9e9EVmxhnRGX3uFerSN3Arn
22202	payment	2134	2134	1874	1	1	786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuXwtenzRs7HcHMEWcXqra5G4kMRrAg5XsFKcpn7Ue7cHiEfN
22203	payment	2133	2133	1874	1	1	800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TaXGz2ZcvUUVHeMz9pUYkZtzK7YC7dniNGF2dWrUraduHr91
22204	payment	1397	1397	1678	1	1	9651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjR8VEgKXVQBj31PciYQaHfpmyFuVRofzA3uWddxudfgJvZ35E
22205	payment	2133	2133	1874	1	1	801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuMmPUQQy6xhdxPTC4hUwLBKtPmeLDV8cGxVJXQCAfyREbC9Lx
22206	payment	2134	2134	1874	1	1	787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMyyFArYKfXfJq11VFQiRn33MV4WjbeFsKDVZxU56GFqHJ9oX
22213	payment	414	414	2156	1	1	0	719900000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9xiWrZD3cLmn843W8qoNuUe4VwfDpxL884sjEsp8JC2WFCgR
22214	payment	1397	1397	1678	1	1	9654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoFkTnZhhai393jqyeeyJVByWt4p6KGsd2S1XxEHsK1h5jptP
22215	payment	2133	2133	1874	1	1	803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTfzkYue6uu89aMM53YEJoYz7P7WAJENcxA9316BcZy4Cb9zH
22216	payment	2134	2134	1874	1	1	790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FxFutrzQHfsmmHCxf4xqumxfbXyHmf1NmBPhCoVnZMBSfqXt
22231	payment	1397	1397	1678	1	1	9658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKPCgvW91ULsB8NE1cHAXCFEz789AP86avxD9VGrLQs3Weckt
22232	payment	2133	2133	1874	1	1	806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsi2Ds98Z9u6YNB7uk4gYNeGYmYVZW5n41EH7hzg5UnmBuzEh
22233	payment	2134	2134	1874	1	1	794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgkjyzBqhs8HjHRfDJJSd41v6SW4V44ce5ZMNiSV6m8ViA3TM
22234	payment	2132	2132	1874	1	1	225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpfAoTiXvcFSPWWp8xg7EwCzpRsUQ7DvxtZShFVimrLkcUGyX
22235	payment	1397	1397	1678	1	1	9659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRcS3kx1csKksTbHMGUVcn6rq7C1toJ4fVqgZfRzH7EvZXyGY
22236	payment	2134	2134	1874	1	1	795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnWLzSAFQPZcgx5WzqheHsUxC4wdLKKL1uT5nrDzc2yVhTAvt
22237	payment	2133	2133	1874	1	1	807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmXU7t4Qbki9qd1uFMprXK8hq3PQSSGnrJxWF2Uvt4Ma2Kxat
22266	payment	1397	1397	1678	1	1	9669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJeneoJHqAenqLWEDsoxuSHF5sPy29smm8Ev7akKRhEdJFQe8
22267	payment	2134	2134	1874	1	1	805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwipJotPfg7t5GjetimSvCrpVYobiGJg1BYqCtHNaaAqzvCr8c
22273	payment	1397	1397	1678	1	1	9672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaCg4dm52fayDWLNCPi2XenmiHx4rHJp6nyhUWLooGAVGz1F7
22274	payment	2134	2134	1874	1	1	807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFoMQP3YJactzbAi5XeTAPaae7Uw1GKEJvYLnNuZVbiFGNsPs
22275	payment	2132	2132	1874	1	1	229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJiHpm873tLoLkL2wPMpi1J77He512EaynudX5MD8YQMGezYr
22276	payment	2134	2134	1874	1	1	808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJET8AMZZWeaoZGzMJ7Yge4gcsM5eKj5YHLbcBmYzAAzVdFkHu
22287	payment	1397	1397	1678	1	1	9676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4M4jtkKe4fFbtVtMLaxnwzsD6Vagkmi3FsKkiSbRFo3TNn9Zh
22288	payment	2134	2134	1874	1	1	812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4K5JUC5H6AqKhKzp5ACMARvbAenSMzBnRAsy7BLSzpfR9NEin
22299	payment	1397	1397	1678	1	1	9680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWiwJNzkmgfWMymo9cWNrrvPZxyDpg3PieiwViG5fcNctq9kW
22300	payment	2134	2134	1874	1	1	816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Lz6HRswRFy3PR1GzCVee9LJsffHuATy7rydx3gytbDG5Shux
22301	payment	2133	2133	1874	1	1	823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9ZD6fh6Q8FKHuKBqKS75cXkVFWNLAK3cptfeskXdgj65nHFN
22302	payment	1397	1397	1678	1	1	9681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1decMTAgxjy64go2Hc5UJkRvXwAxksrqh9oyb1xH9ieGqgBAA
22303	payment	2133	2133	1874	1	1	824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrZRLzoCRCFbcLYQ6Z49XZAXRDTunubQ2bhTvmyZcBXht5QHw
22304	payment	2134	2134	1874	1	1	817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoW9VTV84xdpjJu2PmwhMrEMP24vn3kUKnkRN9EdgmfxeqoejP
22357	payment	1397	1397	1678	1	1	9698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCr3TJ49G3qXzFPkSeSrv1rHJ8mNgb6pAyk3TjqsxoGhCUcLx
22358	payment	2132	2132	1874	1	1	237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9TbTvywb25RdrinhwX7vwrqS4CjqMm1AYkTS3KVTPGYwznLTW
22359	payment	2134	2134	1874	1	1	833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnn4qpi2NPUeKwt3e5GzV9tTWhkCoUgcENmr4h9UzGfGuuGzhL
22360	payment	2133	2133	1874	1	1	841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHagq7TRYsVuJ8CKabtuDmoaVZkfJFaSkLSsnb7yic7TRFpPeK
22372	payment	1397	1397	1678	1	1	9702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPcKtZNB2SqAByoy6ZAb3JF5EosMFaGurh7jAGxosJDkzX4JZ
22373	payment	2134	2134	1874	1	1	838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWzT6xe8wGYzcm3ar9S3LCwRFrZAfFKkn6okbPyhFpCzuPw9e
22210	payment	1397	1397	1678	1	1	9653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrBwy5SRQWfLtqQ1VPCVibkuhgCVjZQ3pFyNbLMMj2imEqVvW
22211	payment	2133	2133	1874	1	1	802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5QnF6VUFnqP5HDr4AwYLzPdzDbRMeDMWVSkPd88hNsHCpVa2
22212	payment	2134	2134	1874	1	1	789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnt9uc8St1ZXARAUHfy4xzDQ8TCduyqEgYK2eJnmmy6zEEz2pS
22217	delegation	2156	2156	414	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdgpGFpVmTTNNY2213w9DNa5ZVphJiAeizyWUDrDKDTpqVhiF
22218	payment	1397	1397	1678	1	1	9655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHS3i7VhVGvy2t5gQZp1osRQqQPSaX2d8hn5xzzc26ZAgvE1f
22219	payment	1397	1397	1678	1	1	9656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzukvwfzydWfJwerS8pWa3qfArq3NrBtBbpLzZYDjLE7xJiWiQ
22220	payment	1643	1643	1299	1	1	13	807388252600	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWzswPf7zp1oXXHxmRGHDNu55cAPHS7Y3HJX7yhi5m9hYhNbC
22221	payment	1643	1643	1053	1	1	14	429891807800	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAt5vuvdvSNkoxtnVzGVi2L9EFC8VmuS25ubKqrLSrozPQFtiM
22222	payment	1643	1643	1173	1	1	15	290381849000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1Tna3B6wHRnEaFQBxji5oqSH7a2VE5LhqdKctaSbBHU63ea9
22223	payment	1643	1643	933	1	1	16	240338090600	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiNamUBeDyL1Chy5GcWqJQLVPfb5YgakTBCqaJsz1PPiMeFgG
22224	payment	2133	2133	1874	1	1	804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3MPmQxkGSv5NrtVR2yyd7P2UVkSVc7DiwY51cH77vxnXDbEy
22225	payment	2132	2132	1874	1	1	224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziJceRHw8grD5NMsNDHaTP1omudQtyxhU9BEDEDqKnnE3Q2xK
22226	payment	2134	2134	1874	1	1	791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RuiiwiLMTK1zXDcLBSmS7mibUTgUjdMyeobx1BqvXRs4JaFu
22227	payment	2134	2134	1874	1	1	792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCF2dUmCRwtx51wfCN1ze1F6YdM7ygiuNGyLiaztE5bYkZB54k
22246	payment	1397	1397	1678	1	1	9663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtgyMQeUZiaE3CsBr8yH8ZCmWRProxBYXBdghT4DYmFup6f7j
22247	payment	1397	1397	1678	1	1	9664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDC1aSLTuNycNJKE41WxdNXhho86XTQHtN8cwqpU4xYvp95Pka
22248	payment	1397	1397	1678	1	1	9665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqTaVrwptZE47Nqk3YAjGJtWdCu8MJSExWghq8wMFAsw4FYpJ
22249	payment	2132	2132	1874	1	1	227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHskXoRP5vvmUPRTDKabXRn1Zjz8HjAuSUnwHw8EwREquJjHu
22250	payment	2133	2133	1874	1	1	810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3T8Jxrqd5y3bmobnsYdC9jz5maZrFynoFLNcGDqBpoBpqWLo
22251	payment	2133	2133	1874	1	1	811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84sYnu28imHThwKFtxnfY1Xnd7x3ns1aqg5abgpQaSsZBJPXa
22252	payment	2133	2133	1874	1	1	812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrZ5DkGxjGK59JeJSW4q85iDY9Nb78qv1rDTjawr4ZZmqkM61
22253	payment	2134	2134	1874	1	1	798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tH19KEGLwkvCHsBS2GoBpaqpcbzxwfADRA65n9RdX6E9rJTH
22254	payment	2134	2134	1874	1	1	799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqej4qcuhqwKyrexqpdMCU8TdduUc8hC2UVBop8cLfyFbymwC
22255	payment	2134	2134	1874	1	1	800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dPhm93f7ty66JXsU6CbDfRso5KrdeejDt7YEgeD7ZTayn4ZF
22256	payment	2134	2134	1874	1	1	801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ7hy9GbaCtUoGggyf6K8A8793bfkRJ87dn9FPUic9Ug1JG16d
22257	payment	1397	1397	1678	1	1	9666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1TGQvQBtQ7ne9VbzaZuMwVct4pWqvYgnVD8ut6rSJdv3ejzJ
22258	payment	2134	2134	1874	1	1	802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeojQRJ2aKxkcmWziddP5thq6n9w7hvqi3YyfmAe6262x18zeK
22259	payment	1397	1397	1678	1	1	9667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdd1F4cutGtBVrrB5Kyd4xWUx8huHnWPTYZW4XGy37uJgeRS2
22260	payment	2133	2133	1874	1	1	813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiR5osEH5b9Qs8XpHaeeNnjP4YDkw3RtnnBGQgajMfwRz6xQL
22309	payment	1397	1397	1678	1	1	9683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nfS1v6MS7qPy35NmSPWkp8WZM4zm1ADzK5BCofZyEvTuWMdD
22310	payment	2133	2133	1874	1	1	826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCAxsdD6qd7u7YSq2TaXRGyTZVJ9YxQxUXyF9udWLEZ2sBZYy
22311	payment	2134	2134	1874	1	1	819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJifse1sRFuzRDSm6zYbDBaUasVZhRFm6ai39kM1Fo5LwiFRp
22329	payment	1397	1397	1678	1	1	9689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6av33wsbdrV1WvXhwakfjBv81h8eCtFecxfGRyYNicTFoUqd
22330	payment	1397	1397	1678	1	1	9690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76ZPDmLmCH8gCNJ2BaduSoX2s5BhXKNoS91wR6PzL2LRMNqHT
22331	payment	1397	1397	1678	1	1	9691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNDirym2sBWA4icLtXAHwf96XSCCdPQD6LZ3HjG4tHG9SmyKc
22332	payment	1397	1397	1678	1	1	9692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvGbkNGkYeVVvdUM8s11UkPAVT3udGZUyBR6t2xMnwzAQUAz7v
22342	payment	1397	1397	1678	1	1	9693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJn4TP2U5tzRm5BmUqHcxNE2Yn3xCaMt9KGCjdLdcVug5FpBrR
22343	payment	2133	2133	1874	1	1	836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nqwUud8EVvfavpdQHFhz15npfU9WVfNegzRM1H24vu7QeZCM
22306	payment	2134	2134	1874	1	1	818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePgM9gPYVr81WAi7LJFrLygovycsvL5uRujfJMaDPZV45xS2X
22307	payment	2132	2132	1874	1	1	232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQxm4ZXbYc31J7DYtFwpFotNUUZbuTxJDMDAQb7cgL6H6CiNe
22308	payment	2133	2133	1874	1	1	825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPd6FxbioXZ1V4H17NyquZbXVfUHq3LUFX6SCtxthWLuG1CcT
22325	payment	1397	1397	1678	1	1	9688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRJkUQb1TAb1ZfvbKKNLreYerKxvAFj8qivWccQ8HCZzXXuZ2
22326	payment	2132	2132	1874	1	1	234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz19emnTmeVyG3eceprUzpMffQ1YRcMiB3Nn8ca7uWj5sL96oG
22327	payment	2133	2133	1874	1	1	831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLungxGupavmo4QyVQ4vNuKrkrhhkJ6fJC6F8KYKKSWmeXguid
22328	payment	2134	2134	1874	1	1	824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3GneR38CUFYmwFkpHPTuHudJ5B4d3gzW1W9188Ni48wQjpa3
22348	payment	1397	1397	1678	1	1	9695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FhxuSFWr3uQUWXqiF2NSVZwjHLRdMTBirND1Ma5KuXGe3xp7
22349	payment	1397	1397	1678	1	1	9696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUjNCxvB19JX8igC7N871VfiuW1P8mHQBcFDnpj1KZK76jpSy
22350	payment	1397	1397	1678	1	1	9697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBots7LmyZA4GPswuyPg1ggce266BRUEyY1E9FMoQ5Tj99FJXw
22351	payment	2134	2134	1874	1	1	831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifaWqpTPxVB6fpGFW7hyNHyHTtSLUzjHRdV2boZe58EY18dDM
22352	payment	2133	2133	1874	1	1	838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBNsfTCcjjzjwQSe5jHajwn11dApuJJ6pQ1ywpZ8X3tp9nrgC
22353	payment	2133	2133	1874	1	1	839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQASGiHKJYuPUd5Gyz2hJHxXcPfXpvL3zZazSfEtVM7RCdm2hG
22354	payment	2132	2132	1874	1	1	236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGS5kxPZED1TwLtoSdTffQqcEaFg3zn6QLFwSpCi3L54Q3eEZ
22355	payment	2134	2134	1874	1	1	832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZthDGBaK9XScSV2BWaJudiUWo9ncjmfLUedXuiwiXcGvGeQvTe
22356	payment	2133	2133	1874	1	1	840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aBSqFeRT9cSkpGyBCcoFF88XLmtUJtVRjviCvobFuMbmVU2w
22378	payment	1397	1397	1678	1	1	9704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFy4CpE5uWnQQh222h2dP7e2EfqeySb1v54TQYGoDUdD3esKsG
22379	payment	2132	2132	1874	1	1	239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1CXiTV9VidpEu4ecBCmWwkVLWQsHvBhiabfNeDN5VTvoXSkB
22380	payment	2133	2133	1874	1	1	847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtj229TazmSAdpaZmjiaK1hkjzw75DLkyRdjCphihqbvw9qTw
22381	payment	2134	2134	1874	1	1	840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKUABqudJnodGimhaH9bk8doX6jhMvo7aoQVQkNmLpQArpwrs
22391	payment	1397	1397	1678	1	1	9708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CRbhJvLpTq1mSZUXkkToeU6vdR4QUd7zQ7QsSicv4TDN6xz1
22392	payment	2132	2132	1874	1	1	240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZq6xSV65kEuib7Trkt9GeVXPFud4woWzRWvjhkxL2vNwuSSm6
22393	payment	2133	2133	1874	1	1	851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxkmFYV2EzKb3mUnAW14xMZTWyJs9wLYi62UFp2dFhFvTsivN
22394	payment	2134	2134	1874	1	1	844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63CtvgMr4SEahWqztyeggPfDDxkFyKi2ZWURMBjJ2J1Roo7AE
22402	payment	1397	1397	1678	1	1	9711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrG8XzHWJ4Bd4ePwpqfRYxSNZbn9d4Eww9anZQUtKozxrpUPbh
22403	payment	2132	2132	1874	1	1	241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7eqJGS86n8mdrS6jnmpeKanG9bSNRN3stMNANNTpUjG192pe
22404	payment	2134	2134	1874	1	1	847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSvk8ozivMSsTD5RHoDvStfAkVrETHMyxS487T2qk3YKoJa19
22411	payment	1397	1397	1678	1	1	9714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSgPFJKDnSQv7YfurHMTS6yx5uxJzi5awBw3ckQXgmvoDNtKM
22412	payment	1397	1397	1678	1	1	9715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGB7stdMYSPqDxYBwPZByJpdA8qxz4otdNf6jxwXZufcGqyK3
22413	payment	1397	1397	1678	1	1	9716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1JMgRoKeFMCre6VwgMHPevMUFyhU914Um1kkP78MaN1vBUPZ
22414	payment	2134	2134	1874	1	1	850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQuELd1A7G8j8TNxfcPSuziJVQF5GR9EpMwweFzmgFEkE7aooG
22415	payment	2132	2132	1874	1	1	242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbo2G4HgGwfFM3nX59Wb8wRFXH7ay2UUdPHJNp1YSNmXm4cjt
22416	payment	2133	2133	1874	1	1	856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSUBbqwL5yaxrjYZaqYTYeoGwRnnUWDYsFHHs6b7bbAiuzhn2
22417	payment	2133	2133	1874	1	1	857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZebqPMNyV8dnF4YocDUM2QrEnijyCutdJjfftyxzfDiQLvnqU
22418	payment	2133	2133	1874	1	1	858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eoeYmRpzyxrh5WhvZ6i4ZN4FgSDE7CpERDRYQ9NqmNLyHuvU
22419	payment	2134	2134	1874	1	1	851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VhYLJNFWYTo7Kbt7TexSMShB2VXYsbk1nJstyzpMrwo81ucW
22420	payment	2134	2134	1874	1	1	852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrvqaqQBf8qfUrMktDma7CM4P5oCEi1jovZxDuYScMYqECkgAu
22428	payment	1397	1397	1678	1	1	9719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweCcmnAUf5HU68zr6jNhgN5myzLiois4FBatZv2p6uAxqjzFi
22315	payment	1397	1397	1678	1	1	9685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBVrLabqgxgPfhEZ1tCfrYc2gmtmMfqZH7D2Mi6anxgAoSp7G
22316	payment	1397	1397	1678	1	1	9686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcybvTGStXbhVF6WgjXh9B52ckZHwG5ZQYbDsJHQBUhjCEJJK1
22317	payment	2133	2133	1874	1	1	828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZejMg2FyDDBzBA4E2chS42ssRH92uhx1f3Y9Ymj8Lng6X2LT6q
22318	payment	2133	2133	1874	1	1	829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwrWdDkFsG6Z2otfj2K91VzMBPbMJTrxvsWakQidi2QEtfHq3
22319	payment	2132	2132	1874	1	1	233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6LzwzHuHPdnpf4dtvmDJfi6Pu8dyaoMoUgeYNvsRfCwjvrZi
22320	payment	2134	2134	1874	1	1	821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89x7KSKTch7okk5daJnCemgg7ozfgLiahmvG73m7y5jwjMrvx
22321	payment	2134	2134	1874	1	1	822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQ6d484yYH2oY4hJKfVDEpKFkeVatqDBECAhpvXhd2S6axn3E
22322	payment	1397	1397	1678	1	1	9687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1Bof1ddPpWMtPmhV3AMeQBPV5qR6g88XhpCJNMN65beRphap
22323	payment	2133	2133	1874	1	1	830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTao85Eyh7hwfsGevveja3beas5EZZvfzQgNGP8FtEh3juricN
22324	payment	2134	2134	1874	1	1	823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkY9Lbpmw57hRJ31999FgaFkbqqj5AFyGhqRCmnr3XjetGaUAX
22333	payment	2133	2133	1874	1	1	832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwMmYqWcoST5L6Vi5YG6Kc8Azhd8Lu18oxL2wSr27rLvjFeHj
22334	payment	2132	2132	1874	1	1	235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptGjTyaPjrLPjxbeeR4ZGghTMMMNnshvdp5SVvqmVUnVSbVVy
22335	payment	2133	2133	1874	1	1	833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnu6h7Qe351NFKXfDc3zeL1qhFtVJyxMSeoVPdJBSp4QZvvhM
22336	payment	2133	2133	1874	1	1	834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYiW5HPwdMH4KMVyQrY6eHLHsef3dLbHj5k6xKVosZb76ubXM
22337	payment	2133	2133	1874	1	1	835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GDptmFSLw563GJvsgpRv7hq1bZtRVcqvp1CdYRN6dFk9wQTP
22338	payment	2134	2134	1874	1	1	825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEf8YCbRFf3J1AP1j6LLXuJEcwjcKqZeL6CQJ79TWTFE3JnzVz
22339	payment	2134	2134	1874	1	1	826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UzXv9bp4Lb3UhTjwfpMntYKsQCXiGPt9Qb4dgXs1HDEHVPAN
22340	payment	2134	2134	1874	1	1	827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GQJFd7KRypnjputXubgwP77HWR7db29sVQ5sEuyLzKY4RnrZ
22341	payment	2134	2134	1874	1	1	828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28EYREXj9oXhp7zEh7fRi6nkUsSDQ4EvinKW3SX5Y4KKxYZ3k
22344	payment	1397	1397	1678	1	1	9694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBdmoFasChjxBRxbHQHpkANXg5Tjsk66LdRb4MG3HTdoJRg5n
22345	payment	2134	2134	1874	1	1	829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTx4jVMD9NPxZzDbQ67byyTcwADmPs21ZHP5nrXgPKPWf9ibi
22346	payment	2133	2133	1874	1	1	837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmLCLrqgKaUH4KXU1Q9jnTifST5KdRXihVkHcdePupuusi8St
22347	payment	2134	2134	1874	1	1	830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgegSBUH4E2uthmZED8fDS1EhGyfbcx1zyPhNjHEJoLPrudsxf
22361	payment	1397	1397	1678	1	1	9699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWh1T51TbEPoLX21UAYc3HWk6fnUV6vmftwRZEdHjoE8XA4Tku
22362	payment	1397	1397	1678	1	1	9700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4pKEqLVovnRinyJazH9bY76cDmRY2aaHyShq1qSztZFzbLK2
22363	payment	1397	1397	1678	1	1	9701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8L3BPE3AX6VacjpciTzCLrL6LDzBBKrqiuxch8BJARKuAXTH
22364	payment	2133	2133	1874	1	1	842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcE6rSnmqgZgYFGhzcZUTB6LSaJDnrEkfCf1FiqRK7kNAz38ed
22365	payment	2133	2133	1874	1	1	843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32gYYpcbJRLvos6V2sgRE1rw6gqZ2dGVkDLdQQ12Sh9iaqhhn
22366	payment	2134	2134	1874	1	1	834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZ9p2wUMqJcDHVmUFHbzQH5UKXtoT7VBt2nLjLS1PVkbpWki5
22367	payment	2134	2134	1874	1	1	835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrraojBUovp6Z5wsZvuaUY2QRjJ2JjRxGBmF7iua6eY5kVgd34
22368	payment	2132	2132	1874	1	1	238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtfrS38SC8guWBkTTMcm2keBaUcjCBG3SgokZ1YEZAnYZ41Je
22369	payment	2134	2134	1874	1	1	836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxTjo5L4HkU6SEAE85NHQfuPz2yqxKa89oAXV9RZGGCSpGufM
22370	payment	2133	2133	1874	1	1	844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hqLcYqMUe9HuU2BQU9V9CPzUzuVm6oSyPVTbBGoetB8sKLQj
22371	payment	2134	2134	1874	1	1	837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NRaTEGbPtSbwQbEY4EynDNdBnd6evnxExQrSrUrqaWAkggpL
22382	payment	1397	1397	1678	1	1	9705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnK6QLoFaXGknPmhnJks4SiNQxQUjyeA1QtCJsiPB35cf8oon
22383	payment	2133	2133	1874	1	1	848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZao2LosahipcS5YPQdsV2eYMBS6LZFToEFNDJ9NdcRoKbQCBsa
22384	payment	2134	2134	1874	1	1	841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ryEYAe3DcV2CBPr2nWX4A2Mo7EyiG3TxoabAfC4ordjfQiod
22385	payment	1397	1397	1678	1	1	9706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDELuW9q1TmsuUevQsPoL6QmLdABAdmRQcCixrhKNoRpaV5CRx
22374	payment	2133	2133	1874	1	1	845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NJUjWFaBWiunDJY75Whpv63MqNXyRLXkVaMRpjyv3M7zJdUL
22395	payment	1397	1397	1678	1	1	9709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyfRhdXQhAw7N6ACkGhPDodEY8DfkFsMWW1UNZDgZnzVWeERx
22396	payment	1397	1397	1678	1	1	9710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEx1ermTbKV7q4R5jxxrERmph9aZZwKKH2HwFdPBaMJqCPvAk
22397	payment	238	238	1474	1	1	3	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEp5MCE6nc4aP7LVnULuysczgoKMXhyVfh83pvPZwSWRShPsqi
22398	payment	2134	2134	1874	1	1	845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcBGEowJY6ca4oyJYJ1PGfN1KyQozAJgm2DQ6XhsBXREAQ8pV
22399	payment	2134	2134	1874	1	1	846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSqYo3smAhPrL7JxoieJVvcpDQXuvg9LprhP9U33ooTrrftdH
22400	payment	2133	2133	1874	1	1	852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JN5wHoguJbPtmXUomvhsP8HVkFNHnhp6GkXeb7mutcsj8b4x
22401	payment	2133	2133	1874	1	1	853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVGFJrrbQzaxdVGuodPT1HZjW7Gy6Vhx5DBBpHpDbFvHovUJ2
22408	payment	1397	1397	1678	1	1	9713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuq8mPeV2pqtjN6j965Vmy5QtuQnNGfcNCoGWmEaoRN822Zd3
22409	payment	2133	2133	1874	1	1	855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcDRpYRGGfeUZf52An9BYv5vGyjr3aW9LPTSL8D5pKAZL64F3
22410	payment	2134	2134	1874	1	1	849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YJ7yKHURJadUbSoaDnPQDQhgX6uhZtokeyNshHcu9aW5Svwz
22421	payment	1397	1397	1678	1	1	9717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xDav53ixDuXB3vTkkGYpmf3R35mP4z4s2Aoq7Q3SrBWDC8pt
22422	payment	1397	1397	1678	1	1	9718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGp1n4JVCzGbmqB29U512HtULNwz3SiV8FYj9VB58veRfVX2k
22423	payment	2132	2132	1874	1	1	243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSaVR25XZu7YTttozTwa9SgZcMzpyFE1B7QCyxWAW1QnzXWzah
22424	payment	2134	2134	1874	1	1	853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzzX53ob3ddivB1ACJA1ikHPHQnV4BDF5iPiAqCXGCK3VBuFr
22425	payment	2133	2133	1874	1	1	859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMmyu4NLoBrHnZnGJvCX1Htw8tbZJDXUdWvUtt9QYFFXA18cu
22426	payment	2133	2133	1874	1	1	860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7Y1bfbkQMTLwRNhsWf7c8fLRQps5aAuSA6MhcMAHhxNJdDfv
22427	payment	2134	2134	1874	1	1	854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmKjf8kDHf8UWAiSbQLdf28v9NMeeJVjWA2rKGprVp4WFgxs1
22434	payment	1397	1397	1678	1	1	9721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1W4NMQJSwkW4LaoysH6sgCSkPiRqFasq5TRZnUmSnBcHjH2LU
22435	payment	2133	2133	1874	1	1	863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVs4E8keidU8dCj9e8MF75EdkmPHoK8G2qVDP4uZ2Ch4cVWN89
22436	payment	2134	2134	1874	1	1	857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyj3DDh1qVzH4UBGYg9pjAjVZ7ASKidTreuTgG8YG5LaauAdUB
22437	payment	2132	2132	1874	1	1	244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSthaJCTEsEx7AbWt77FVRDJUjYfJcFoReDXuhkchAwdqnguH
22475	payment	1397	1397	1678	1	1	9733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1jkwYaivsmXUPHQK3F3xaSAC6t4mheLcYBBJncJpihQn6Nrd
22476	payment	2133	2133	1874	1	1	874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKBwFaMVd22G2ELCfoktGvRvCmYhKFyMuaiTLFjAJpALJvN8h
22477	payment	2134	2134	1874	1	1	870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGSscqJfmN9m6n8Jcr7zv69bf4QtGo6HQLY9LpmWqYfqhSfDo
22482	payment	1397	1397	1678	1	1	9736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufewYfKAKewi8CfdGhMgwe55hpmkpC1MiWv3hy7G2KmeN3thV
22483	payment	2133	2133	1874	1	1	876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZno5iUgdZecJFnyTu2jVL7V8BjzdCdkNc32WJ2Yq4oV6wMJBvd
22484	payment	1397	1397	1678	1	1	9737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gGXmsjemJ4gnSUZUyUYydejKm8cJPtpuhahiyH7w3SJt8B8t
22485	payment	2132	2132	1874	1	1	249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbB6wZNGCfUt2p1hybccqKend4ANanpzCx88t1DkryzcZNjcbY
22486	payment	2133	2133	1874	1	1	877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZjEXKKt2pebky7MBjU3ANBNqrdexUiJmNBUfTFbYggKBRntY
22519	payment	1397	1397	1678	1	1	9752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpjABnxvrq87TbdocEzddNHpBr2nyo2s4dwFfwPfnDWirfdKd
22520	payment	2133	2133	1874	1	1	891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRM6Sx6qQgYw1BtBXNDU6SuHTqEaYBbQCnn75rKnw83x9xaLh
22522	payment	1397	1397	1678	1	1	9754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUR3fVY9WD8SN7TQ58hutqYLcZSWuEctJ6rZpyq92FmLnHzNSR
22523	payment	2132	2132	1874	1	1	254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoM9i4GqzNsBesBaNue4mEEfgzQJvTHDqEfZ1BaVtd8U8kfHPW
22524	payment	2133	2133	1874	1	1	892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAT7dZRxwaTSFk72hwYpxY2yRMMQMSDXQq5aCaYdtGz6888sSz
22532	payment	1397	1397	1678	1	1	9758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfLdLC1C2QhKiR517u8ezEz5qFcBWMSsxPijXTmh9a6tCdSiC
22533	payment	2133	2133	1874	1	1	896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHX9VmC7bWa1TfBsUvkkczBuG2xYzn8LSENSLFHxLVkuBGr6Ya
22539	payment	1397	1397	1678	1	1	9761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72ENV7aqjhX9oM82hVt6fVYgTRCTJWdx7FUW7hVqY6K7qEdPt
22375	payment	1397	1397	1678	1	1	9703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99AUZXpFmt7e6MhfeGPjgN5CVoVDw3C7Zoz2Hv11nL2KMfHmh
22376	payment	2133	2133	1874	1	1	846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7czmMmFttzeZSPpw7kYPsnhB9zgyBQgGTutWEMKEVwV8it4ZM
22377	payment	2134	2134	1874	1	1	839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESTzPqaNGpGp8r13jWEt2uAPZMTSXjFUotXpxhjvutqnrzAzX
22388	payment	1397	1397	1678	1	1	9707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpGD3RUJLMHAFtg2wqoZ2a6LzN5wjNHy8HkDz2N3U9dqtFDb2
22389	payment	2134	2134	1874	1	1	843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3yf7bdkkyX1dJ83oy1hXpjbQ45DWzQccb7gHwvrE2YYcp4zy
22390	payment	2133	2133	1874	1	1	850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuprEGViCaGuEWp4XsqeR8Mr553VffqwgHvinuY3V1YxiVg99R
22405	payment	1397	1397	1678	1	1	9712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5fHKXe5gxrMEUnNh8jqPSgM3eBYHKcMh7zFFjkn2tRavxp19
22406	payment	2133	2133	1874	1	1	854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpApKkukQGeJnFmDFuRq15FWvKzNygUZZyqFfHaYa5yRbyJzhH
22407	payment	2134	2134	1874	1	1	848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJWf9rrjozdEQfj2NgZTpX8jRuAoZF5fRbSKcdpszywnyVo6L
22431	payment	1397	1397	1678	1	1	9720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQ8jCcwupHNGvQUkM9sk2YAvqzCJuhJVYYe4HQV4znN8QcpmY
22432	payment	2133	2133	1874	1	1	862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyyKneJqj1bB4Vw7hecAkgN6mPbNgbPXmWhDzz2CA1PikPq8j
22433	payment	2134	2134	1874	1	1	856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFSwZtHEZgVSVFS24BPKPFJodEyWPFG7P8G9YXdZHTPqjJCtp
22459	payment	2133	2133	1874	1	1	869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaLabp8XcHWpHMLAdJCjLpmDw5sp3gVREg4vq4fi7XeHcPFPz
22466	payment	1397	1397	1678	1	1	9730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDcbBMdgUa6cv6cm6HJGKaEXKUeoXbBLc7LWPCGUuabTiF5o8
22467	payment	2132	2132	1874	1	1	247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TEqehhBuFN9SgALpuEr6EgGBhCkBkSjTpBgyBJZGebtAky7X
22478	payment	1397	1397	1678	1	1	9734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99Ak673djDneett8cinTkQfrgWTNpe5XXMH1xJKfpgkt89wuT
22479	payment	2133	2133	1874	1	1	875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREK8SciFN5pVCUR51LZx24dRfBAYA5GVNA59Mi7BKk8svxYPL
22480	payment	2132	2132	1874	1	1	248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Xnf7XBGFdFCXCmML9Cm5EKkQbx2aVQnuRnvqFyyhNuoeE64x
22481	payment	1397	1397	1678	1	1	9735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4rehbWUXUhq93c5zss7fGhM99M9eqJ5KYRyqbD7HQfNJs8xj
22487	payment	1397	1397	1678	1	1	9738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU7H7RSry5duKzagM7UvkzCMXNcxiEggdr3WQUKHwVrjwybmma
22488	payment	2133	2133	1874	1	1	878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgHL6JCnebiubvq2TpSJyGVofXFJCJtkktCdJzSfk3NHWbQpT
22507	payment	1397	1397	1678	1	1	9747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttPr8W2vzeDj6u7fkmubmewNimDemjbPeFPvSpSJrZhbf3FGr
22508	payment	2132	2132	1874	1	1	252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNaGCSpSbyvTpK4oGxTYbCNVT1j9kvhiVv7uVumiEixXCpSNU
22509	payment	2133	2133	1874	1	1	886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBXzF8Pd5GRu1xryc6QyHx376E9XozEXp1Kt58LxDssN5RGgw
22516	payment	1397	1397	1678	1	1	9751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HtMDRFg4BmsSp5doHVEbzYAEanb1WJX99c9FCNiM6STDZz8i
22517	payment	2132	2132	1874	1	1	253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrUp6kSK5mU3sDHYePQpruLf4NfvM9KkGogz7g2XRVkWtdtMq
22518	payment	2133	2133	1874	1	1	890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FSMHWdKqBQaEkgr6hiYiap9nBuaA67ycJHqULYLpkYoSEq4r
22521	payment	1397	1397	1678	1	1	9753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJjHH6HNsnXw29HzFqP9Gf5TvNX28TW3HzKTZYfq5gNhVZVYc
22525	payment	1397	1397	1678	1	1	9755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbtmbDC9syYwDTvkEfKot9siVnT5FR3F6iyYXpoLd44X8TeEC
22526	payment	2133	2133	1874	1	1	893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxq6QDWcGtLi2hp3gS8Qmuf7yNLBt2ZVht66TXiKZhk9hXoAh
22534	payment	1397	1397	1678	1	1	9759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uxE9n4tHBYWXF39bJVckpawsVoGazhjimYJ6QgedV3eHsdnp
22535	payment	2133	2133	1874	1	1	897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQ1HuSjiEfxePBDwTdfp17a37FMatBykLDjxGWcPcL5jSUNTW
22546	payment	1397	1397	1678	1	1	9764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXtoDwaBEeai7wF8FW1ExdSi5J2C3jMPyr6efYpaLegt4aDzX
22547	payment	2133	2133	1874	1	1	902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTPHpWZDb2SS6jFdP2W686YR8kVefzNshXLPStNXEy3VgofB1
22553	payment	1397	1397	1678	1	1	9767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDUWuNyjEa9CWCt314PiCc4iLgUQ3mq4HUn9Q4wSjNNmAronX
22554	payment	1397	1397	1678	1	1	9768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRBJZzbHcRLwKcF4zaLFjmoRjfVMkcSiofAHfkiaXn1yNX3XDQ
22555	payment	2133	2133	1874	1	1	905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8c3poXHMthKz8iXWphNTzbdLar57Z5oMCDfvg6cQm5GEw2eKA
22556	payment	2133	2133	1874	1	1	906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1NEU4KAc6z4ptwMn3P2m3qjV89bXatvozfX9mzQgNHz4ijuoG
22386	payment	2133	2133	1874	1	1	849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkPn3Xqxb2qyFQQp1mh8Nnv7G2epQEZ8S7KLNRhNxGRmEjxusF
22387	payment	2134	2134	1874	1	1	842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2Z9KLgkT2GQbyAhgnrzdpWMhKo462BnJR2pG4yRKPGo1TEJN
22438	payment	1397	1397	1678	1	1	9722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuGX5tdYh6cHWbx8Y6pjFexPVfY7YB99jGajZ52rUJa38MZ4G
22439	payment	1397	1397	1678	1	1	9723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVE5qQ1axt4Q3oXBxKq99Futezvnxo3mD8yZA5zLHyioQAdJVa
22440	payment	1397	1397	1678	1	1	9724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHXeRqduoeWyAqiV3rhSbKw63ZEAAvGXKWNvvymShTNB43TiEv
22441	payment	1397	1397	1678	1	1	9725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPjEuDjSjCd6of2gprHJ6vLy1q5opJqaQsE8jy24iTmdMhD8PX
22442	payment	2134	2134	1874	1	1	858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbd7crtuHj2UnoVuD6PWP1L4QWqETHApcwgiAbpm1LpTam3H8k
22443	payment	2134	2134	1874	1	1	859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb61ueXtXxNz2Wrig9DLbJearHUbgYbTppzsp6NjPVhChem7JC
22444	payment	2133	2133	1874	1	1	864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2o3XhAZZmzw8SL1XcWk88GC2Gw6XVgPkscCapD1HA5saDWSJe
22445	payment	2134	2134	1874	1	1	860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFAHKju5CZwZVRppKxjDPQ79ZqXRkxasBL56A7ihFz1ifGj5k
22446	payment	2132	2132	1874	1	1	245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpTX1XvDD4MoMmk3Jxey6JtpT3HfmfLU88tPBHo9EwNKMnJnE
22447	payment	2133	2133	1874	1	1	865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt8TNKjaYN9pGbcddo53TwNL3nWiLTzyDGhNzg52g5KtFCcDh
22448	payment	2133	2133	1874	1	1	866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeV46c1ptcgmW2mXVS8U6wgXQN9hHoiNMZHjSz44KP4zb7JCzs
22449	payment	2134	2134	1874	1	1	861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6aro37oL6WV4eVdmaoqAuiheMxrNeKE1QAEwmgHQjub1RTcE
22450	payment	1397	1397	1678	1	1	9726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS2jQ1Hg6ekBegNC8hwRZ1MgMeNmFv3zvZrSPYCLp9sQVBJb9
22451	payment	1726	1726	2157	1	1	8178	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYrEBjjgdMKGqLpB9eYV4sF7N349ALX6mSkkyabfxaxz93bNLi
22452	payment	2133	2133	1874	1	1	867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGie8qKBJHCfDf9csEdNpUzTpicEmrGJHuU4Wj1mrV8mpEv6H
22453	payment	2134	2134	1874	1	1	862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMs7PpQ2bCdzMSHArJgRGaLT8NnmngSstLnEybt9du845F6uiC
22460	payment	1397	1397	1678	1	1	9728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqs2TtPjA57NJoqbdg3GeL5WMu2DmNeyHTh7HWF1G3VR2VDDXM
22461	payment	2134	2134	1874	1	1	865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iTunQ3AQABsrTKioDZHqK5HrmUXA42SxR3BeNkCJc396p29j
22462	payment	2133	2133	1874	1	1	870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6ConJhuANBfvJVLvS2tVBi5HmfGyymmNUHLjiZn9gMBC8u8G
22463	payment	1397	1397	1678	1	1	9729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQF4kGFAABfb5skyLB1YaL9y9j9rnkMwaDnZAUKfanwyuHQFmv
22464	payment	2134	2134	1874	1	1	866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUsmvL7eMy19hugJiMAYX5ASxQzxG9NLWgV5zJk9uMJWQcr5J
22465	payment	2133	2133	1874	1	1	871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWMPf7P927KqchxUugDCRW9NxYQXMzUH2ZAnaQgrsy6KEH1nr
22468	payment	1397	1397	1678	1	1	9731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLJ8yPUTVeDHqVyJEXW9ZJ8YYvqq9vJqAwK6G1FKobszwrNuX
22469	payment	1397	1397	1678	1	1	9732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6RH5h1W6LAGdwaVtEYxe8uipo8aiTLUuU4ED1PNH191PCBeD
22470	payment	2133	2133	1874	1	1	872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMFbxDVVCvbrHL8s1Jv7toueXUhbJugRRozQxMuM6HDpa5Eya
22471	payment	2134	2134	1874	1	1	867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeewosfLFWoiaUAPWoXjViYrjht9KHtJy6znVA2kF3AQpXpt5p
22472	payment	2134	2134	1874	1	1	868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn99qfDBQVoL3E5xsvNnz2tHM9x5vha4fhuCSzCisPfoP2VoK7
22473	payment	2134	2134	1874	1	1	869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZ8jzNJBvkF6n889y4Sx7mkbmghkeFdvNJnkFcE6DRRcgdHn9
22474	payment	2133	2133	1874	1	1	873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9oEn1k4q9MBP4n949r3HqhpKBWD9gPXXgBvpjgwvGuaFwbts
22498	payment	1397	1397	1678	1	1	9743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyFqUv65DhrJE2VXND8apwpeWrzc1EQrzdSVddJpGSxwfjQSD
22499	payment	1397	1397	1678	1	1	9744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjJRjXA9BXWHm5B6SpVrJpxH2Vz2E1FNysjdyD6YVdkEXP9o4
22500	payment	1726	1726	2158	1	1	8179	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZig4r4WBUBrHeK4cDRhj73Fi2vZ5jCpt4Z2Nk925xRLZC7KMvY
22501	payment	2133	2133	1874	1	1	883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdB5rryvDZpMneFwwBhg2rVEvaEMvF5sUtV5SWco3pUzP7mxcV
22502	payment	2133	2133	1874	1	1	884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKCACFViVp6CV3HqWHAPsrXnEyygUqa15JMAWXjbfTg7itK4b
22503	payment	2132	2132	1874	1	1	251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5RvjUTx2JZaPKDFtA86pvRnXv7wRxQkev7MyHgT8Cfm86JNb
22504	payment	1397	1397	1678	1	1	9745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBV5QAPKNsPWU2vjYXkiA5ZYrfpi2SwMVQh6B9DbxxPAtUCF9
22429	payment	2134	2134	1874	1	1	855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAis8KDo4Ce6x6LuozP7xENoMabt9JQwefX4d4d3U863RKAREW
22430	payment	2133	2133	1874	1	1	861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUvn9hUK6DEyRyoPzsSFLiwiroqzVpPkyw3bmBzg9mY8Bx3yq
22454	payment	1397	1397	1678	1	1	9727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3115nrYXqyHDcGQmG4qG9SXUc8tw199taTsYvTNzwgHgCs1xM
22455	payment	2133	2133	1874	1	1	868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SAUxRKZNYvj7VXwfXjv2YHFW9qJbNCeiv4yK4nHPF5qV5ASN
22456	payment	2134	2134	1874	1	1	863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZfKQsq7kTJYVjpseHn7LDRSTJCLA2JbDj1tBhLHJxrLdR9Ks
22457	payment	2132	2132	1874	1	1	246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcu3U5Qc9ts51VeDB6cagfa6RAP9xNFSZbhUiTiy3saECBg8B3
22458	payment	2134	2134	1874	1	1	864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eRPAbVYXWsUoXSpPjcQUmozg2LRd5FJDoqoUvmRiCe1sK47G
22489	payment	1397	1397	1678	1	1	9739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoDtbU776aehznTj5NZqs8bNMi3vdZT3TPYZ98mxRzerSL7HAE
22490	payment	1397	1397	1678	1	1	9740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcGv9ZfWqd575tZTaUNBq3Aetuny4aJT9kcHuYtfavjmrc4Pw
22491	payment	2133	2133	1874	1	1	879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZUUPvsssdpUKbohG8K7RDnkTXPxqp4DLAXFwahWLRq46nVLD
22492	payment	2133	2133	1874	1	1	880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYia8JktQwRCkMXUDULHDnUosZ4BbmgcNaPVBaw9KUcYdJZPdED
22493	payment	2132	2132	1874	1	1	250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiRdCC6NbUpuTCKLBsyXcuJoefy73piKBvSSntQEJ16naJL8k
22494	payment	1397	1397	1678	1	1	9741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbY3PX36gV3SGP7kediYx5bfZC7RigukmYXTAgfPARcaukKwFP
22495	payment	1397	1397	1678	1	1	9742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqKqET5UFX847n6MmfyQ3SN7bDqLQ7qsnYS3nKndikfAgpuWc
22496	payment	2133	2133	1874	1	1	881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC62vPV6MmjhcwkheixFJ1bvLms9iH3ZnW8FmuFCsjrDdFscyH
22497	payment	2133	2133	1874	1	1	882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUBSwTR73nswaKksmCs4dz5ScnFJC57ipQz6huhR5xRWbb4Zr
22506	payment	1397	1397	1678	1	1	9746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfwfZGeAYMH2JcDPnqUFwR9ow7pg7HH5W85qnsiaeJcMdX7Hvi
22510	payment	1397	1397	1678	1	1	9748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjcW8qz8ota1RQbeaNrdmp2Egoxi41jMBaA19yqb9pyaNeTgcE
22511	payment	1397	1397	1678	1	1	9749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ak5CX8kXBJ38PamKFto8pJg17hmMiMqQnkkhbfoJEywPrC16
22512	payment	1397	1397	1678	1	1	9750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikk83Pr6mLUp851fSDuxt6bYxMex8EMYKxFKXg7PntAFGGidZ
22513	payment	2133	2133	1874	1	1	887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5CgJCx6AxoYf1XdwRZ465S18uhTDFgaCByXAq2y54kfVDy2g
22514	payment	2133	2133	1874	1	1	888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsbRiu7qHzjpxYChV2qTWqwZ3CvQcrsUAnAc5L6dpXGfxkHuV
22515	payment	2133	2133	1874	1	1	889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JUNn2Rk3s9LuYxBXbf7x8fZ1JjXHdgHy25gTXFQv86ftkSjd
22536	payment	1397	1397	1678	1	1	9760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRXZXqwV8tRrJVecmyjUzjLMUKPSb24Dkk7PUn1vAX4bK8FW4
22537	payment	2132	2132	1874	1	1	256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBN3ArpatSPYi3xWVjyGBnseedpaBUwfPHTt9DHWgpK7u3UUNk
22538	payment	2133	2133	1874	1	1	898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7rxY43QDcHc6PCBSCHPD3zobhvia56BSJtpzPHc8HK8WYLXy
22541	payment	1397	1397	1678	1	1	9762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaVcJYgNQatce51cwRqpJNioza5y7H83satLri1SQ5Jpara5k
22542	payment	1397	1397	1678	1	1	9763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8Y589EBKxMKXNFdGeMwS2PprDZJt3LeeBKYBJ5NXMdg5Q9Fw
22543	payment	2132	2132	1874	1	1	257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52dJ2uAdYGv6UGUPp2iqjfvHz4azYjRp1q7UQfmfFby61VErY
22544	payment	2133	2133	1874	1	1	900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxT6KLDtwXZEMUnPcG3F7xtZbuoYhehApFyY7fzoA7GgTt1fJ
22545	payment	2133	2133	1874	1	1	901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRebGtRQX2HTH1MUNxkYepuCCr4wNakoEcxiy6aYacf3To7ET
22562	payment	1397	1397	1678	1	1	9771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKC5ehhdZt15pTd1ozMd4SgZmuX9NVBchYUgccu7nXEAYm5PXH
22563	payment	2133	2133	1874	1	1	909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dmxYjzYcwgQzcZvJ4GPt8XUJRjJmJwsb1wSVBY8MzdmghLRo
22608	payment	1397	1397	1678	1	1	9786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbmnBYLWNNcDC2CW5yLT7fGmjBmNMRJPcMyrZaUaYXcqYsk1n
22609	payment	2132	2132	1874	1	1	264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK88QRzKkDm9P3Ab38HiWtMzGPbiS2stc3Skrqh1aRhUM7GMTR
22610	payment	2133	2133	1874	1	1	923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKdt1CXAPjGmq4HEpZU3vZa2iodaFjbpReRXjkSu81s9vpxMAf
22611	payment	2134	2134	1874	1	1	883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBVxb5ZE1RVcvbuGfKBhjSjyXLqBYD5zyprtSqRRnc5aC8cgq
22637	payment	1397	1397	1678	1	1	9795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VEiLyATazZPKvv8xCyFe8QKhdGLttWc9kULJ8hoZbwwy8T9J
22505	payment	2133	2133	1874	1	1	885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwaJpgn3mWicAnLFTNPwSLKvSAmBnbxYiwTqi9XYekLPxAtyU
22527	payment	1397	1397	1678	1	1	9756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC6GnN3DyWpYWNSrxnVTwcigBWDoR7jSBkqoW887Kdg6tVygdM
22528	payment	1397	1397	1678	1	1	9757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdpErQaB4K7aSSa7N2mTVqDagB6mGy1MXba1z1LienwwsdjJW
22529	payment	2132	2132	1874	1	1	255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHuDcu9e9YgzW7rjf1bxfb3CEgoaW8bzwr9QKzDHK27HWmMkE
22530	payment	2133	2133	1874	1	1	894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdrgrKvsiQhLydFCHSxdJGJpaM7LPX3wUBdQD2H7rgZvBcH9g
22531	payment	2133	2133	1874	1	1	895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSB8DCde5zJHBdKmhhueD2qeN64BCrTg3vmDknRYzHNvaq6NgD
22548	payment	1397	1397	1678	1	1	9765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YRZY7SyohMhxnp9NgunasddKUrECdqRqo43ubc6NipMh4dsH
22549	payment	2133	2133	1874	1	1	903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSr6uPW8js4bghyWmaAZhLP1CwDcU1rMMt75uYWqZgfnRCy23h
22557	payment	1397	1397	1678	1	1	9769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdioct8NhmMVbfEg52wx9jjzoUDpdbWRurK7hgMzWYheTxcz6U
22558	payment	1397	1397	1678	1	1	9770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdceDmGdVnjohe6nfUQaYQi1JR3maKJk2gB7Go2h1ioW4KYHZd
22559	payment	2133	2133	1874	1	1	907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCD5EdVDbSre81aoDgte6qQwZ58xGnsM4sRTD4reVYN7rsogc
22560	payment	2133	2133	1874	1	1	908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1V21vJRWVDSkLk8DxgZ1BxZowQKyzx8wHLPxLW8Kv12p4jpw
22561	payment	2132	2132	1874	1	1	259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwwBfTkbVsq1cBJJAQFqPdBya5TXR6CrxSHcPdScdeuRkbixd
22582	payment	1397	1397	1678	1	1	9778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHv7FeoD4UZpx3rBujLbwegimy8hPnC13RbLPgEKF3CeMur4y
22583	payment	2134	2134	1874	1	1	875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnDkXGFkrHUv8JDqWCWHyfvA5HWiJM3A5c8iPCiQUHioEEM8m
22584	payment	2133	2133	1874	1	1	915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHAamyUhc8mD4Ht7a8CQNc75BAT39z2QvEWvbzNBX19d5NAyN
22588	payment	1397	1397	1678	1	1	9780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgHyaeNUH6Bbsr8v1SEsLe6gchqRUq12y9KVfEsW4cp8hgauS
22589	payment	1397	1397	1678	1	1	9781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2gTZYf1boorfYnh2TRsACqzqWeKP5VTQQxrotYku7SmWMMwT
22590	payment	2134	2134	1874	1	1	877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjnfboMoZPBEV5d5isFZmvvjmRuZaSRnjnCbJxrZpenRe39up
22591	payment	2134	2134	1874	1	1	878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYakAJGezNCKc6qjxCTrh8kwuQ9fGEDnPjemLA36rfmF135VVKc
22592	payment	2132	2132	1874	1	1	262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVSz8VDLvucYLBKXn7xb715FSYMR9wLBn6fbvU6gecJ4zUKAP7
22593	payment	2133	2133	1874	1	1	917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGg7oqHcGS1mzanUYhSeA8BFUf4bcJ2o77R3iBpJRtyu52RiTg
22594	payment	2133	2133	1874	1	1	918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLTUxCEA1WsS36CYCRR8vr945UqU6ayLbCK5tZ7EmUHSU9pTN
22595	payment	1397	1397	1678	1	1	9782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXuxU8KgA5Uw71LXPFfANxDsWdukqzJqqFj1ZZHaNnTfGKRmZH
22596	payment	2133	2133	1874	1	1	919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdFBCheUFWMtFY9BHM54s4NMGjFkrauuyndVRqw59mwvHkqvt
22597	payment	2134	2134	1874	1	1	879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqL8jqmMjS8TeMZf1urzt6Li5tiP1t6NN97drHpdvrYuSQw1K
22615	payment	1397	1397	1678	1	1	9788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LHSjimFApgvr7MSiiNcYpfQuCF7QPkn3jrcPjG8M8GaCHdb1
22616	payment	2134	2134	1874	1	1	885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5N9iape3esPp2VWwRRbwHCtM8curmmAJyN9CZuH4ZGi6A3cd
22617	payment	2133	2133	1874	1	1	925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbdQhkwQWTafTXQsZ6MEFvVPBX7PWAXw5rjxPT58rtqJzxrWt
22627	payment	1397	1397	1678	1	1	9792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JfyCuKYh9yr5tZAhMaxBYeyCda9vwx6rXDpxjywfevLxmS8B
22628	payment	2134	2134	1874	1	1	889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXA1PeHcx7pznZqzZjbnE66n8N48jpLRFQFFWngDYpbxAJv8v
22629	payment	2133	2133	1874	1	1	928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJBYgbzyp41apjvLGou2C7jWx2RSQbjkgkEMxXLmNCandeEzp
22630	payment	2132	2132	1874	1	1	266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFdoj5UPtKWbv1BBpTKaMrdkAJriYLnf3dydRiBhUCsi2s5zr2
22631	payment	1397	1397	1678	1	1	9793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPo1Sa4P277sYWhXzsEHzqonN9JMg6aPnxj556QsRTwai9AjtT
22632	payment	2134	2134	1874	1	1	890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZakmHzAAwHy2DZTMvbFcx9XzF4EgiYNADkzxKaSphc5Ctbzvp3
22633	payment	2133	2133	1874	1	1	929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBggNGwbhfpEYVH27ExLQCSeMHrCb61jcUGQdxJPUC5h71GJ1
22640	payment	1726	1726	2160	1	1	8181	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZh61NY63p6JwZMTzxitf76gVw7W6Teb7J98F1LYd7kedeXY4TU
22645	payment	1397	1397	1678	1	1	9797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGv3EZH3RGymFkQbahcS6qsCJWFVKoL3ZDqVD5jZJdD5rEnLLA
22540	payment	2133	2133	1874	1	1	899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kFLeNeWYVKtRf6NNgTnoreWfHmV8Ud3MNy7ifuHNjwbCwd6o
22550	payment	1397	1397	1678	1	1	9766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFqbJ4wy8ee5NoQYdigmBPfw1FmgC3pe8s52n25DwMeHJsox2
22551	payment	2132	2132	1874	1	1	258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7qxhmguc17jzd7KthHwNEuaouguppgw2wcZwT3BFPmrB7fUH
22552	payment	2133	2133	1874	1	1	904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCrDBcdp2YBKZJbvtBd7ZD4tDbZPcTe3GoajBg71U7htp6XxN
22564	payment	1397	1397	1678	1	1	9772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3u5oNNP3GzAEBqYVWY7ji1papPmyCdgeTXTpcLd5GCAZiPx7
22565	payment	1397	1397	1678	1	1	9773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYDds8KGQN3aeV3V16pTMBg9J485XcN2mwRZzHzBTbvnnW1Sb
22566	payment	2132	2132	1874	1	1	260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv67vrE3HshqDHdA6pG78K2SPadzmLkZhM7tNmw7zKPGfB19xF
22567	payment	2133	2133	1874	1	1	910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCeZKcqHvXWWuoBJwiArpVfQWgZAPZt25FuzYPiZX9MYnS7NA
22568	payment	2133	2133	1874	1	1	911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpY7LpWdxy3jWSR2Wb1AdHtWZ47SUYecLXDXAJ1ZTiT72oavW
22569	payment	1397	1397	1678	1	1	9774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh6C7wU13eBBDRsRzYAYjQnSG2pYMbNGWarwpV7hph9x1b5HU
22570	payment	1726	1726	2159	1	1	8180	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgwCTcPm7bVUDUEqQsDzd2ZSuzXGiGf8HjmkyMNq4t1R1eg339
22571	payment	2133	2133	1874	1	1	912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbUrukjszFidgZFPSLG5d2PBffqGMNthQZJ3ZQwwLawP4N6Sk
22572	payment	2134	2134	1874	1	1	871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXcNCirrPzCr5AY8s4JgDJs1kcs6zQtGBQfVqGsgGvQNb9Z1m
22575	payment	1397	1397	1678	1	1	9776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeHzGYRiPqdgwxWtin49seVDQFZgoXJegmAJhF7V4TJELiPdT
22576	payment	1397	1397	1678	1	1	9777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmnLzK31aV3vENVSUF22Bn4cxRKNvSKeMZBpXLnkC974ZZn5Y
22577	payment	2132	2132	1874	1	1	261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbNqYAzqez4hR399jmX77FTvW5XtunhF9RKcJh8EQCQepZDV1
22578	payment	2134	2134	1874	1	1	873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZc9RSf8HujX1vwSLQ3otAthWUi2uwHB7FoShadyQtdMostjw2
22579	payment	2134	2134	1874	1	1	874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8SPqAN8YSS8XpAThszxVJmkdgHpJ5xEDDFZPqUDPdGpFvjS5
22580	payment	2133	2133	1874	1	1	913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GtxNfzWhwwJwkCLpWEQoYfxeF5E2nk2YkZpyYUtUU7aoLngc
22581	payment	2133	2133	1874	1	1	914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FKsaHdj6xWXXeuTzDReWpYM398UiEMn5azSwPx9jGzneSVLC
22598	payment	2133	2133	1874	1	1	920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnYA7dSpgXDgmq22imrBpHdgTtQxhKAzH8Zy5CiXZtEXfBDJt
22599	payment	2132	2132	1874	1	1	263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPk1XuzZQwL7z4hhiMKx7zKBW8YcwpBFY5KduA3BzFLho1RC8
22603	payment	1397	1397	1678	1	1	9784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGqPLg79jUFENYNigGPdmsFDZ3nvjn1Dnia15cLyDsbWAfaw4
22604	payment	2134	2134	1874	1	1	881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdmY8L3r3kJET9d7Pt1M9QxSbbR1wtPe6hzTrARo26KyxGCSq
22605	payment	1397	1397	1678	1	1	9785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreKHcvnHxdUyXHmRFq1VKRDWZLmxUgGPZ2eMUMYrkK35hzbv6
22606	payment	2133	2133	1874	1	1	922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbWd6g6rAnQ9nv9pQaSDAegy7TRCEHxz5rJbtjojR5eofikZJ
22607	payment	2134	2134	1874	1	1	882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNjNyBcfZ3xCtTgxoPvk2EvpoFD5M3NEeoJ1fqvrR2ZPGhZdd
22618	payment	1397	1397	1678	1	1	9789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9Qb8yZcwwUByGygWBCvf9tQP7KTWo72tsBne8oAdJCwpsejw
22619	payment	2132	2132	1874	1	1	265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCdMRPtYq9eNmy45bXY9Qe3ndQoBHsyWdQ5t1Ct4wxM5P7Mbf
22620	payment	2134	2134	1874	1	1	886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5f7XwMGV4qq5nTuRhyZZQqxfbsMj8jc9hfTRG1nvnyqqW1zTj
22641	payment	1397	1397	1678	1	1	9796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFduSz69rCGgU1PRMMBeazUmCfcD9hi4oF89zZtrjkzc2yqm4
22642	payment	2133	2133	1874	1	1	932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FJJgzyHd21yZ7nmdyAmgnNDEW5rwNhLP7U3toThjkamUPrVB
22643	payment	2132	2132	1874	1	1	267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFg3vf9w3LNWiPzoNvAnG71pnajyB7Wgjv5cPjDaEyDJzXaSf
22655	payment	1397	1397	1678	1	1	9800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVxJf2KPftUmM5EN2Lav2wTzXfKktQcq4xS3ZHW6kxWnd1Xyp
22656	payment	2133	2133	1874	1	1	936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoh11iSbW8sGf6Fj4cTXGEnwMZq1LCJF9rc45gxv79Ta9mStf
22657	payment	2134	2134	1874	1	1	897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe8Coe7it7YFHy1XMdh1S18pwLN1AG4oWrszkViXfjibW8y8Hy
22681	payment	1397	1397	1678	1	1	9808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VZjyLRLJhjLKzRuvNSm5eVnBDnxT4hBJfUcyBV5eyerEmNKq
22682	payment	2133	2133	1874	1	1	944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhgFm6d2fukSKpCs8DpPbJGRy2bvCZkPFa1ozDiPCgCxtWBbk
22573	payment	1397	1397	1678	1	1	9775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRBZHvGnoKsHPwyk4ELydvbW5RHtrxVBLz7V3Y263928mZQUY
22574	payment	2134	2134	1874	1	1	872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnU9fpZSkP79wUvfpGHCg3px9LSVwyYDeMMwveuyRYL6o1qvrr
22585	payment	1397	1397	1678	1	1	9779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqizixS6ruhCqMrAwmVg4kVp7UNX8pM4ELDkd9LUfiAW2k428v
22586	payment	2134	2134	1874	1	1	876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy4GRC8rYXATJu36HzD8eZVXT78SLBv7Lm6SR3EgTCEFKNmvA
22587	payment	2133	2133	1874	1	1	916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpNmoAkBg7ffYcFvVBMmhUnBV2V9FkApNMBbnYH1gNBNzQNDV
22600	payment	1397	1397	1678	1	1	9783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKU4eX2HpAvCHCf7rvUdjtVg2SnVMRFGK8sr2EucM8MDpSVBj
22601	payment	2134	2134	1874	1	1	880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGuJB1E48UeiFv2bbjU82qFaPraZFRQkrzUrRVC4buVhWiTsp
22602	payment	2133	2133	1874	1	1	921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgmKCUK8CjqyzqwQ8DRZepHEJUUhHmEHsfmjhvq9gEKZb3ogh
22612	payment	1397	1397	1678	1	1	9787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDcuxShajPVLxXvXiNBERHrNKnDo9YutHqB1Lwct8bTW4fkES
22613	payment	2134	2134	1874	1	1	884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkCwBcVqp5YR7kwDQ1TFS1wWNsdiY1DoDcBeD6coNMuRiyqYw
22614	payment	2133	2133	1874	1	1	924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxbKNdH3CLyeqsTKgK6NUD7wbNmk1sFggd9TL2bANMCGUvrgJ
22621	payment	1397	1397	1678	1	1	9790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyiWwr8QWWU5ykrwvHLiaHWQJPXGGya9mJeLfz6uJkM9xnfUwJ
22622	payment	1397	1397	1678	1	1	9791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYi2NcUisMguZVn8xYVtZ4NJTyCXCiEQBMidfzNDu3Taa7cWuf
22623	payment	2134	2134	1874	1	1	887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZw7FsnUr2Qj5MnDADKPMK362PsmqtcWFRdgnWcS3wrkaxP2sL
22624	payment	2134	2134	1874	1	1	888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14deQoV7Y9Qh7rzSgf6atQPrcPrcsUvQq3jLndCNudzSM9Qu5
22625	payment	2133	2133	1874	1	1	926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QFgNdT8mUJM1pr9Q8LooUQizYAtAUKk3a8ee85ZhPdVzSqrj
22626	payment	2133	2133	1874	1	1	927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdd5XTc9pmgoM3h8v7XGBY4tfzqx41bjhU5RQrD1FHhRbTU5NL
22634	payment	1397	1397	1678	1	1	9794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFD7dqDBEbvrsJDPSZa4jUuWtrM1XbkMzGbVeb4UD5X3DFpWr
22635	payment	2134	2134	1874	1	1	891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Qqh3JHBoS7owo1Xzh34w62YBL2S8gj5TawF3wkyN9x2zWSUe
22636	payment	2133	2133	1874	1	1	930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UQpBmXypJprUgGb7x6ikKC5KTLTTjvEwZnBmAM5SqcYtXSqg
22644	payment	2134	2134	1874	1	1	893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8Z6KqT3esgpGdHRTPQNTFoSqa5wHpE1eYmqsaGb8x6ny8oWL
22665	payment	2132	2132	1874	1	1	270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseF6Yn3A5RweBJtMHt3Zj3qfH3GJooQGL1UiM5DfkTtB2L2ud
22690	payment	1397	1397	1678	1	1	9811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbc8MTRAU89HJQWrjsoB47orHXQ61PvcBqDfp9Px3JELHjWHLE
22691	payment	2134	2134	1874	1	1	908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBuXYWzt1Ffs3upEEVNY3nfzUYCwQjJv9hzt1kA6HeAMrwda3
22692	payment	2133	2133	1874	1	1	946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2YUQjX4sTnVfH7Ugpr5dnRkQZ6WiUmeNZ9GaQwew6gDCtgoJ
22696	payment	1397	1397	1678	1	1	9813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY9tChPqVWG7CchCwXQzbhmckmRAn2uGSQVyv9bxUzN1LFXnm
22697	payment	1397	1397	1678	1	1	9814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7j8c3mxn5gQVpBR1y8cgUWDTMoEZCvJ8fbVUzGqqZQdLHuMRE
22698	payment	1726	1726	2111	1	1	8182	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtsZhqa9PwB7ggek6ovENUy634ETEg1kjzhwfz8KJYGshWkze7
22699	payment	2133	2133	1874	1	1	948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXQMVNvqrtocWu75BdQRnWChvmGGszmxhmAwZgEXEcSMWbxba
22700	payment	2134	2134	1874	1	1	910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAb4XDcugExnoZTszS43e49AjzvTn8j4pviwBq2xWtK645ZdE5
22701	payment	2134	2134	1874	1	1	911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvE4ykQceAajQAj411p43Nun2eqWQj53o5Cqzvinzmwi9ZSUZ
22702	payment	2133	2133	1874	1	1	949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQve7ceckBfW2x68AEMo4nHTB796EbZyR46VTprERhVYjvV68
22703	payment	2132	2132	1874	1	1	272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ge3LWPVpWXTscFYnYcTgKwNeDR3hqZYnWyaoo1pjCwavehmq
22726	payment	1397	1397	1678	1	1	9821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVdAvYjkX8XPbyg9dtXDG4KtzMGB9GS283dHeU773kBDTivET
22727	payment	1397	1397	1678	1	1	9822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKXnSSrYAyka7nbgneqYdVJasiSr5w1UqnKyeas2p8kmgfHaM
22728	payment	2134	2134	1874	1	1	918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkBuWK8HtnUe7CfngiAM9yaEaNXfqMYN7vgRbGwZpjKXkY6cv
22729	payment	2133	2133	1874	1	1	956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAhCgXHB2rDGbvaPjwkA6qxM9q3fM7UNg3zgP8nTM3BSFHfZk
22730	payment	2133	2133	1874	1	1	957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXbkhKEYot37a9gJ926oyu755Dd2vEu7TWwQwrivwvCFXSK95
22638	payment	2134	2134	1874	1	1	892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYNmhQuTMq5dLF4JHwQ77Yt3dnPrx24KDcrwUZrfwHBgtrftJ
22639	payment	2133	2133	1874	1	1	931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMWNPp9Kdk1SWHpwxoiuQBZqzUfeyxQwBukdyExFEgs5phWsf
22648	payment	1397	1397	1678	1	1	9798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnr2i9M1DnZYf2oQmeP6LLRc4nKT5zkVZhh4jKRFDHP78Gt4Kx
22649	payment	1397	1397	1678	1	1	9799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhrGMb4HGmAjUfkXap5WrWHmkrcErwLfwLNpcPTsJQ7XQiLaP
22650	payment	2132	2132	1874	1	1	268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GLT6EkGXVgX5ago6tw4c7HF4hK1q1xQM334AxwCTWTV6p7zm
22651	payment	2133	2133	1874	1	1	934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtcB7w3RzqUsZY8VJS8wHd3w8837rJ6zMdA5t3H2y9PnfxQ3xJ
22652	payment	2133	2133	1874	1	1	935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmFSNErBRAoR5GhULi3EjxoWpJdzTchmNuBQkpT5T1Qt2i3Bj
22653	payment	2134	2134	1874	1	1	895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLcCVQCJHmT8yNEKm9Z1NaYf51srBkb5WRcYZ7N4me37QD9dXg
22654	payment	2134	2134	1874	1	1	896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHJjaFdWSntZrDTYZak7kcx5nubTD2PpZEA65a2yWcbUy9MY1
22661	payment	1397	1397	1678	1	1	9802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEZwqbdBQy4soNypNHrkmEVVRKfVAPwMBZ2Tyu8J7Wx3aP9EX
22662	payment	2133	2133	1874	1	1	938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyStRsUJfySXudb92r4ezaSYDUEoJtTPr79waYRN6B6AngeSBP
22663	payment	2134	2134	1874	1	1	899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhvoWr3M2kmZzttNxhXzezaRzFsHE4YaNSGGQNiKLAEsvmivY
22664	payment	2132	2132	1874	1	1	269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5bA5oEmuDQS7wunnhywt1knjLRMRzBhMN8XGq1og6B2qGRMCa
22666	payment	1397	1397	1678	1	1	9803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56vrvTzLCQBzBw1HosEkqGzyApnYvEt6gv9WLhw1zt3EEWDwW
22667	payment	1397	1397	1678	1	1	9804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeKhWon5Rgbg4D6yq4GHxR2si88PskFWGBFBZpaz8Erb7oSzk
22668	payment	1397	1397	1678	1	1	9805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaMXAvycQxSr9JTwGe1GePMTeUd8Xtqwt8447ib64ef9EMJFz
22669	payment	1397	1397	1678	1	1	9806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9Gn1Vd1Df2dtmLfjFtKMh72qvPw9J295pxgBCRqQW75ZmiDT
22670	payment	2133	2133	1874	1	1	939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7Y71dj63zXEBnoASYHDsTm41PAkVf9N6YgfBxgS3HGz9piHe
22671	payment	2133	2133	1874	1	1	940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWMvhS5mjb7acVXGWZYKtFgeh55t74gAunNVFiod2HqoJkjkN
22672	payment	2133	2133	1874	1	1	941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiREERf2sUeeLpySnFxxSfQ2pzc2cxzFH3JEbTYGKC1WQFhYp7
22673	payment	2133	2133	1874	1	1	942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBWte3fCPVVcbvaQgxozKaEMQXLPPYDwRjBBEpRZLfiyksdZu
22674	payment	2134	2134	1874	1	1	900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PFxB8Fet5KPgAnGQFhykLNa2J899VNasoApsAmkTCAUKV1pX
22675	payment	2134	2134	1874	1	1	901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuxYUoNAPpfBgrSJKjxpAKsZk2sFxdGCR4vjb6CXtMszajSC3
22676	payment	2134	2134	1874	1	1	902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7v2EWABpW3Z3vDTZjABgPZyH76dQbjLSLUdiL8SZivHUc1ro
22677	payment	2134	2134	1874	1	1	903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJ6btuv2pCCxdSEAGzzzLEn5aj5yWiECgN3L1jEAs6pyiqqdc
22678	payment	1397	1397	1678	1	1	9807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5m6htf8sXTjc9UEs76xPo8JNS8wgnbnrXiuhmraEc42o1USi
22679	payment	2134	2134	1874	1	1	904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFbGt8FRht8AdezWjy5MxfF9eMCmwi2kqUv5XP8nE4ngpVz4E
22680	payment	2133	2133	1874	1	1	943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKRZShG2yftQppEGEC7XDQtN2UW9hc3cRTBSWY5D2vDM22xSr
22688	payment	1397	1397	1678	1	1	9810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYns5X3i2dGHJpbMFr4hHirD4PsSpkYAKKNvvsnveGxLPS3DxZJ
22689	payment	2134	2134	1874	1	1	907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDZWMZE6MGrT6ogyDR9pcPFqQhvqVZKST8FpijsJLrbAhhvDW
22715	payment	1598	1598	1958	1	1	1	2100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnfVfietgTknLtmYNRitwhsiXfvrnjkTBjCKNQRfCFZk5X5Ko
22716	payment	1397	1397	1678	1	1	9818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMpUQ9cZXYZ4szQtqc1Exz7wJGiNWfJMsHAKyE2v9BiXyramg
22717	payment	2133	2133	1874	1	1	953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmuu7uMfB7XZWHFchdD3cBQzQXE778DZQwXThMgLpEyfN19vM
22718	payment	2134	2134	1874	1	1	915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9eiXHRk8CnCk9UUM8yRuFcTymDcan46ZfvtCq3Z81cJcWvJT
22719	payment	1397	1397	1678	1	1	9819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvmSTAatYbEejQZE63c81WsXq3G1EvhSASvVhTjwqiUmZKSB1V
22720	payment	2133	2133	1874	1	1	954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNr12QTmoX77nP3uqN67UjQLRwCqnVzRNdCD7xhoEXw7YCxZL
22721	payment	2132	2132	1874	1	1	274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54ERnpTaArcDdQTrDnie1EcKjN2sqewyztrHxiDBhqQ8eLP6r
22722	payment	2134	2134	1874	1	1	916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCPzkhs6Wtd3hRvx1SfXtNQ5PJz2xE1GvoBiYJ23TCMWtVKgeg
22646	payment	2133	2133	1874	1	1	933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHjQdcStMTppeptfSAbqHWGdWM5CLuvYYLJZN8PMeDE8rBGAu
22647	payment	2134	2134	1874	1	1	894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWUC1142jhAAxFUvz1AWvnL5pw8M4i6x6vGdRZyrtzH3unCr6
22658	payment	1397	1397	1678	1	1	9801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMHqR3RHg1UYtJLopbEgYb2o4Jt6CzRZXUWrsDjMUzC3rM4Kw
22659	payment	2134	2134	1874	1	1	898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdqyDRVocgteaceFfSFzJZFMwB6p3S718hUibw3kC71rCT2rf
22660	payment	2133	2133	1874	1	1	937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97c32vCvZzTgwYkBwrQJrQVZJ8h7v7JNznG1tSSQJwAc3YokR
22684	payment	1397	1397	1678	1	1	9809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBUdWdHecMNzWY9fbPSnuKjuuoU3fvNXoeGW7ckJSenu6ot5K
22685	payment	2133	2133	1874	1	1	945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1g2bGXBMhHygkGmmYhoTfREZ5PJUgVpEEsNrkCspdVgQEAuaD
22686	payment	2134	2134	1874	1	1	906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vDj73x3GT9kx1tRxXf7fSwXyGLQh2KfF7WWLYRVqdTBAqAvk
22687	payment	2132	2132	1874	1	1	271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHNa6ivrCD4katShJUDfDZedYvKNqWQnYH4oKHHNYBUFYQ15d
22704	payment	1397	1397	1678	1	1	9815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1zv7C6TmkihTj2BCd8JctZGNPXkRoB8c4ybn62zXv359ShdB
22705	payment	1397	1397	1678	1	1	9816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YswPqfrM74kmrpPNULGiWCrLbZufK6WwqfriDWs9Q3q3wdeN
22706	payment	1397	1397	1678	1	1	9817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCaziC1ChhmsrP3LydK5tjuWgoR271C2vWqnNaj7UkWuncfe6
22707	payment	497	497	1474	1	1	1	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbjYvva3sJQ1nRqs2R5uJsvWV6NecrBeZG645WjnkSx3rek8hy
22708	payment	2133	2133	1874	1	1	950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcp5mzwc3wBM283114sUDyaygXTZXCaHVmEXnMnp8wCEA7hMDo
22709	payment	2132	2132	1874	1	1	273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7NBAeFzeFGoiCEUdEQZnRfP6zUhQh52H8CCuTuYKECy8WU3f
22710	payment	2133	2133	1874	1	1	951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmo5RMWXNsNSy5tEdxSauHcFghtyRuybvU2DQqAszwRQDgqM4
22711	payment	2133	2133	1874	1	1	952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHnr84wLBxoWKA6KUKCUfK8LrUQUPWsZ3AxebAZqq8Y1cJhPj
22712	payment	2134	2134	1874	1	1	912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCbkYv3sRMzQbdsgPUd9XmGn2VNMA6n73gAstwAYGxoBVAF3d
22713	payment	2134	2134	1874	1	1	913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKDcKAtDr65KZXGs7nVTRX3LsQsH1tfo4EhtskDr42upSF4au
22714	payment	2134	2134	1874	1	1	914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyndxYKv1G7eAFfxj4dy8wcwRwSDucCz9t6MKq1HTdE8QmLWB
22732	payment	1397	1397	1678	1	1	9823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDDEhdnsTkTpANsLuLZY88cum6aRc8uwYiWAaY9Y2eEXFw37p
22733	payment	2134	2134	1874	1	1	920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHfq1rTJRt8iqYbMyETpxZuTiK5aqF85HMMPwwRwfxNXX2wsp
22734	payment	2132	2132	1874	1	1	275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDufuQJJC3NpTpmubB381PQ4UuqMU2ZyqMsbFQEiuELU5hLv6H
22748	payment	1397	1397	1678	1	1	9829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62YdvKiFrTCgx7pn3LR7adhS92NyMzDJ8SUc3MpgBkuhUAaby
22749	payment	1397	1397	1678	1	1	9830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoMdk9HFRgpaFfzB7nwwaYUnCpunXcciFDcV12LN98h2dB4baH
22750	payment	2133	2133	1874	1	1	963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdGYRwkBN54whDwGjSGiMG5GCpwRXWVdZxniSL91TcGDwBEFFp
22751	payment	2133	2133	1874	1	1	964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKrpDUipVMV4r4bbBpWwddgk2Kq7QEtiCJ9BFzHPXD2GKzxgc
22752	payment	2132	2132	1874	1	1	277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYeg5nvQWpcZMcsnnpRdzz7izVTHX5xVa6oXHrZvaNPX761AD
22755	payment	1397	1397	1678	1	1	9832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeHJoe1X38e2mzZB6R4P62Vo6eQ4QugjAJcjYLevRaNmWmWBZ
22756	payment	2133	2133	1874	1	1	966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPwLu6rKZqLQ8biNKZg9fe93xdWosGPFUnfXT6oPwDr1TjvC4
22757	payment	1397	1397	1678	1	1	9833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2z7vFJr9hiXFez8z69ja9B3NR7HTnHEd8JypQcJzEHye2ESg
22758	payment	2132	2132	1874	1	1	278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotH4J4EtQNNdJ6UdsXSHrs58w2Xr1bDyt8D4mPRiZqKamWMbR
22759	payment	2133	2133	1874	1	1	967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHKsfZnR9ok7tMcZ3PuSzNuHTz5eQdCgDgJPuPcF569TPJEJyk
22764	payment	1397	1397	1678	1	1	9836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYAwK93nB1y1e8udefz9kFb9MvuBAjcVxibfhhfJ6D2KXgVhf
22765	payment	2133	2133	1874	1	1	970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hCRc1usJ9526CJc5Jq3bAtsWXZga2kQwwNVCEPuiAuGAYC2q
22766	payment	2132	2132	1874	1	1	279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP2LApLZHgDcsn1y8az2E8KYMEmhaTfX8oUn3TBLAGN3TEHWn
22767	payment	1749	1749	1950	1	1	17	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceygSPe4K6nWMQVPHRKDBdEJC13atZAricejEbBv2hKRnPWqU
22768	payment	1397	1397	1678	1	1	9837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmANaMQWWTgxqf5LdypAYEGYthnvGvqmWbyHfb5rFWAsMTFqR1
22683	payment	2134	2134	1874	1	1	905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPdXK2XN2Z6bGCG7okdhKiiWwv4HV43oTcLMw8PWVedA76bgt
22693	payment	1397	1397	1678	1	1	9812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktqVuyMvmPaDmEAeYKPtT6sbEHNHifMYYHfxFbmcJ3o2QMWwJ
22694	payment	2133	2133	1874	1	1	947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZMNm1Sia1eopJuo79UVfGgpWcWyWCmfzGTSP5m1tb3KE4uDe
22695	payment	2134	2134	1874	1	1	909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUknFCEHzdMwtaWZ6KxqAWkZRphFJcSzdCq57K5GYcNpNxHFgm
22723	payment	1397	1397	1678	1	1	9820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Xj7QeBuWvZUtfXGtUWFLJpxDBerz8F4qK4gE5AxRBqr8e2GT
22724	payment	2134	2134	1874	1	1	917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFoSfbnwMwn5MvKgCYLRDa87Ra7akZ79YL539c4dBdfXaK1ur
22725	payment	2133	2133	1874	1	1	955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hVpNA1SdaouNKPttD4gQW2bPmDNE9HJPzvvtPdoRbEMm7emj
22741	payment	1397	1397	1678	1	1	9826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sB8BJqyKsgJqDmRGq38LDx6wwhUTrmxNznDGRRHhkcpwjwha
22742	payment	2132	2132	1874	1	1	276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7a4YWH5D1q6fACMVXTu7iLGqapXqFjDiuWSGfeyAaU3wAcQy
22743	payment	2133	2133	1874	1	1	960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRRMHvjUhCXAEUzVM2WhupFLAasupa3HzzfYow9Ku4ALswMBD
22744	payment	1397	1397	1678	1	1	9827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsScTN12SPSBtFju3W6GX9EzBaibaK9VUSnxXQ75oFxD9gw88Y
22745	payment	2133	2133	1874	1	1	961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEJxTQEc53P6sGLQyRQn2v21QKiHwAb2GTBQGz1DBoeGrcfT5
22762	payment	1397	1397	1678	1	1	9835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW67pMpo9wRLyUQkGhL8PGPYfh6V3j24k5moL32Dh1MnrKGsis
22763	payment	2133	2133	1874	1	1	969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuP1ntMmVc9iAnnwSbQDw8kYpPWmY8h8vUbTdumHWhwnJ2UgxJ
22770	payment	1397	1397	1678	1	1	9838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGx9m9BWKYfwHVe4rDehw1suh9FBepw4wfxW5gk6zL3f8aUrU
22771	payment	2133	2133	1874	1	1	972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoSJJzQVswnskwZGQ7Tw3Nek4NqdxNQcctUh4RHTNdXR5oNpa4
22779	payment	1397	1397	1678	1	1	9842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphuCJwjdeRuuuVc1SYVdHyim15G5DYkMYKxS4YWsHhFrhVJoM
22780	payment	2133	2133	1874	1	1	976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbXKCznghBRtnjCg6SUrpSac2sL94NKPJdqoMDKUiMo3G1vZc
22781	payment	2132	2132	1874	1	1	281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEydEEVeeKdDGCFhgJzS6JuqZRvBCZXghvp8euiUDPCSt5DcKv
22786	payment	1397	1397	1678	1	1	9845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fRK3i1xkJ4YqKw3HPg7vWpRAnbLQzN3nQw3si7renKunkNeE
22787	payment	2133	2133	1874	1	1	979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg9pSAWYBqRKGcWQoCuJVYu4sbxtivka1LcthcXDU1sZTnKV3
22788	payment	2132	2132	1874	1	1	282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8W2v7xEQSBLS3WbegBrhgCPd93533CvTuZ3MMbpmriNcg3zEN
22789	payment	1397	1397	1678	1	1	9846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9g76WDsV77fJvYSZ7cWSUWNrmtmkdGprSTTESQkCSs9fypBQ
22796	payment	1397	1397	1678	1	1	9849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLeTsCT53b7F7U5RVMnxuU8pcSFBvKdCycQiSsM2tCmqYdeYt
22797	payment	1397	1397	1678	1	1	9850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxXtTQF2ioTyJhVbqVwN1k5qsGDb8mBksUWV9PzmFJVL2fF57
22798	payment	2133	2133	1874	1	1	982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oab3YUqoLnpFBdqqStnEK1EDXdkxJ9QzLJXtN1wzQTY5G6Tt
22799	payment	2133	2133	1874	1	1	983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNtfBdVsH5PvFCGvcqNs2ZCdp6gztojVwfwXPRHqESCgEQdGj
22804	payment	1397	1397	1678	1	1	9853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9p6dnrMWQbiy4BSkj9cGJNr39xhaA9djbDxpMs7JPWEoKZQ1
22805	payment	2133	2133	1874	1	1	985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Dkd1MSPY2y9ULiuCnpUf1caWZ1G3LQyiwrkVtztKqXDFvWbY
22806	payment	1726	1726	2161	1	1	8184	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbsN5g7JaVUELg69qnsUF8vx3xuJTMQRHwXsqtgK7ECjn8ySy4
22807	payment	1397	1397	1678	1	1	9854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXowcdm2r2KtZiXaFPSCFmxqajRigW4eB4j6zk578WHUaZT9U
22808	payment	2133	2133	1874	1	1	986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8CL6oK63pD6VKipLKz2BTGmS9LZhvyER146aNKHnmAqax4rX
22731	payment	2134	2134	1874	1	1	919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6z8tYrg7kcbgCRNFmUtwuazxib1HPs9hb63bMeW23nFmWTxB
22738	payment	1397	1397	1678	1	1	9825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJAaPXg1QvutkTxGSzzKREBEY7RspG6bmT4wE1YRiDQzuMQVW
22739	payment	2134	2134	1874	1	1	922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXDHqmajuTej7HtXnVsMhw2UZEiwq5vjVdrMqZZKZMiQ5DjCg
22740	payment	2133	2133	1874	1	1	959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7khXYaLgDKCPQ1frSdwg9dbTzz3mW7QvPnepJEpzbgntGt6e
22746	payment	1397	1397	1678	1	1	9828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqf3RYJYJcrx9shdVruriuJ4o3WEZW9ffdvLzxBzEcYF8cm1Tq
22747	payment	2133	2133	1874	1	1	962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT4JMGrhrwu59rvUzUprdqvSy29oSPHcCzFuJ2WvYMP2XcDad
22772	payment	1397	1397	1678	1	1	9839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkAgUyLEeGUyCVm2wtV8GZTbzQ4RiQCnHUCZJdrpmJ6YUFsZb
22773	payment	2133	2133	1874	1	1	973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4qt3vo5LtPoPMsZoDfDbJt4rpX47gJjSWtgxe8JtHcCjKZxa
22774	payment	2132	2132	1874	1	1	280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZui5gRKB7iiMtfwvf9x3MBcfgycKvgY3dyx3AjrKyZVGpE8ahE
22782	payment	1397	1397	1678	1	1	9843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYeRChNLuXdQqkwzZzKqVDfwxKeyom3yYqKKJ29STwTYwQ6T6
22783	payment	2133	2133	1874	1	1	977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWum56MLiRsmmwdA9tuJyi9fSqGfbH2YsgfzeQ7mLhfjXMrwHw
22784	payment	1397	1397	1678	1	1	9844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcpxTYPsxmMhMZ2KhR51vaKEiYzSRpzk6WxijGU4WsetZ4gLg
22785	payment	2133	2133	1874	1	1	978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVd4vw28FcCYmPNPfytiFDsxPeMez732UrBng5ZFmZSssfTQu
22790	payment	1726	1726	693	1	1	8183	10000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbfR31ohUHBHAn22zm1RRYgWtupGT9utFnm3P8RAEXF6rvscnP
22791	payment	1397	1397	1678	1	1	9847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCMpd525VSYWqHvbh2xGJ34vvZJgHaqxhdHmNDNFKvKaTExZs
22792	payment	2133	2133	1874	1	1	980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKXLg3jL4JKwofFqQL7NcTjxoCZubXUSwZGQP7tSFRWVmYVi4
22809	payment	1397	1397	1678	1	1	9855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzBSDTJo8iE3h8jaRGPtt37ZpqzmhEhJ713wJpGSzuyVyj55M
22810	payment	2132	2132	1874	1	1	285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvmMvig5tBC9D7ffCL9aVf95g7S3WP6aX5cjWTziS4K635zCh
22811	payment	2133	2133	1874	1	1	987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQueQDrYY6mVDtzrk2YaJQHGwsbX1GipqYcsk97s1kMVnPcYMJ
22812	payment	2134	2134	1874	1	1	923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoy22HfsXKDr4PGKdyZEeFNiB5AUygFQzDMMkSgck5x3yFFim2
22735	payment	1397	1397	1678	1	1	9824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVvnSWMSE6ScbMAkTqnt8fdsGv9sCdt2zNYHRysAVXAw9nKkL7
22736	payment	2133	2133	1874	1	1	958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfj6dce6sC2RAK1n9L7aDGWKdT1Kskm5sEDp7rw4GquzvGKpt5
22737	payment	2134	2134	1874	1	1	921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3rFwgTBT4WkYGuL1BdhB3eVuH3H63q2zieKrNnXoZt1pLMEZ
22753	payment	1397	1397	1678	1	1	9831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaCdCRwpecaj4gXbFEBoYrABemvfK35Vzhdu32BMkZue75YKYg
22754	payment	2133	2133	1874	1	1	965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkmfDuhmArxLMhmrhDpLMVMSsJFvJ3waniPdXLN4UvXtAQeGw
22760	payment	1397	1397	1678	1	1	9834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZR6meZEEmYXsYNpqZqqj9Bb1jhCfit4gHY2jCL3F8nEW63zC
22761	payment	2133	2133	1874	1	1	968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdLdCvssDsYQiH3Vp9iHsLnkSriGHQjLCtTVLJsqGy7GLgmHi
22777	payment	1397	1397	1678	1	1	9841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47tttmWwqZ5ncH6RV7yCuK6yF4nNbqihmxfBHp8XuuixN4fQ4
22778	payment	2133	2133	1874	1	1	975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycLYojMnGHhQBZYkDWhkEpNp6gDQAtErLEfPFH8vJooaL2ZNY
22813	payment	1397	1397	1678	1	1	9856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWrwtY6tikP1tM482gUSe69D4LZqoQQc46fNAFJyJthe6eh6P
22814	payment	1397	1397	1678	1	1	9857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEKU6yUMTGii235iL9CVDsqY9nww9DoSdYMMhamruoJC4aQkE
22815	payment	1397	1397	1678	1	1	9858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1VYRjJZpAdVNeEg4wLpP8XbpvXCPzwkP6JRpRDCXDmJQugRZ
22816	payment	2133	2133	1874	1	1	988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdpALtpA9y1NBrBixwkuMuRLZbkrn86TA3HqCLKQy3gzZLLZD
22817	payment	2133	2133	1874	1	1	989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ237cV154ruk4JAnjiHbVrN7Z6zSME97koeWSvzNV3LTzDBnNf
22818	payment	2134	2134	1874	1	1	924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9qk7WZ4A4a2fu82pxDJfzQbyVvcagZRp64KchdPSB25eDgC7
22819	payment	2133	2133	1874	1	1	990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAKZmD6LLyeSEYMrygtAh2J3XgkuhCyWx7TMrR6pfMFyeVVcp
22820	payment	2134	2134	1874	1	1	925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDS9fB3gnxZtVnFbqTyUhG1UwY6YpWqxULcYwuwXoyqqmo4po
22821	payment	2134	2134	1874	1	1	926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwjTpsZ1bzYiu3FtdVHCd8Hvnj6FM4ebQmwWffGkmhfrmFoY6
22769	payment	2133	2133	1874	1	1	971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyn8mQNUvM3a4dsyE5tZDpLLicipyktLE3GEAkXKHrLZeh8dP
22775	payment	1397	1397	1678	1	1	9840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfdqZyfyfS8G4iWqYP5kqGGtKVa8XSZGDwgX5LBGW3ngcojVB
22776	payment	2133	2133	1874	1	1	974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSuJx5yxfXgHug5Pt4QyWiZNpT3jbBEzTnY92pgNgmfJia11F
22793	payment	1397	1397	1678	1	1	9848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdW7fr5fWHX2WA66AneSUDWd5mEPTi6hBmqiwDUw7njMydnJ62
22794	payment	2132	2132	1874	1	1	283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSnL7XaDVocu4EpyCMBD2p5VitLQYjjuHJjVRvaFQThkdrsoS
22795	payment	2133	2133	1874	1	1	981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDU4AF728AXbJXRbdC7x5w228rAiiHAubXcTYbzo6qb2HTJcpm
22800	payment	1397	1397	1678	1	1	9851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU82WvBKsQ4u4LHaeNCVZPPoxBA559Cx3GQjRi8AANbrMYD69m
22801	payment	2133	2133	1874	1	1	984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Bcy94zChGbuD3vAQftCEfM6913KNh2RrudGCVrjZa9zCCmCU
22802	payment	1397	1397	1678	1	1	9852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCUkuLWis71Spd3CPypZnTDzor75distHpc5zeuGSLmjYEqqu
22803	payment	2132	2132	1874	1	1	284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhJmvBGPvThGDKX1sPs2eWEMsxnNV7H5U99VnrS9KvzyQiPsC
22822	payment	1397	1397	1678	1	1	9859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3NbJxESYSP9SN9ghBnstwz9eGbj7PAEf99MgME6tpp1SqNUh
22823	payment	2133	2133	1874	1	1	991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPhAHZd5qTcv3EEHobyiEC4fgw61XDuFsVWVEVoU3CAt5e5a7F
22824	payment	2134	2134	1874	1	1	927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP2mzA4J3Le7HccuWwU3h7ciwtJ97MAt7NsrZPkVCGu4oPsRn
22825	payment	1397	1397	1678	1	1	9860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwn4BuYhBkC5T1o2pNPSyhJV294J36oLupEmhS7L3zmZ1gffpr
22826	payment	2134	2134	1874	1	1	928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYYt598SycCDDLAuL5b7BPEEhLFhFys1TQ2LYFewK1uTr5QXs
22827	payment	2133	2133	1874	1	1	992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6JaPhaky42hCWRq6n3Uyy8fUR1pekT2goVE7MXsLD4kx4Ark
22828	payment	1397	1397	1678	1	1	9861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGicGsT9ErL5FhSwC5dSovKTKGNoD3CTdE94DiTFvf1SDTrQLw
22829	payment	1397	1397	1678	1	1	9862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjimu96KLQocGTQVXoXrxmktFYembxnACeo2NSYAhuBQcrj82
22830	payment	1726	1726	2162	1	1	8185	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtTF7UXshj38nPxQ3FEFsi2cGDiCCs97oD5TWthvV4sdK92iRp
22831	payment	2132	2132	1874	1	1	286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFhyfUJ1QWvjbusmdpvJtPpcjXzgetvAuWY8TGpW5pUmh2mAx
22832	payment	2133	2133	1874	1	1	993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnJf2p9HUJWJAaLB2qHtJNY8tXgWbmJDN8RcwcroJZ5MX5qyu
22833	payment	2133	2133	1874	1	1	994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJ5cQhkHZzTZk9FHh6x5ouRmhWjs5XpUs4KqZR8Hjo7CBdpbB
22834	payment	2134	2134	1874	1	1	929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tW8MJ4xsrTDwchoqUDHiWX4eLKBNvvdBMRptc1Pssgggre8K
22835	payment	2134	2134	1874	1	1	930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZRzSoNbJnRNwGoErxkKBzak8Y3xVjd8RWLYkgujLnZAk6HiZ
22836	payment	1397	1397	1678	1	1	9863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiaGGKVadN1d4wrccijGvojAvfC9ohw87Bj4fRVdQgNF65uoZ
22837	payment	1397	1397	1678	1	1	9864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3prLnF1AeJiDppSwXTVp5kbZ8KfBVqxRrnH4xmJbkXFNuobd
22838	payment	2134	2134	1874	1	1	931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1wWm2irB9hsuXYg4j2YepKPReEDVS7FRZgaHUPhPqyhU1EL8
22839	payment	2134	2134	1874	1	1	932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmefvBcBsAJ8y6UuwQ8zwJ6sbg5S7vkkrDvPZ7ANbenoB6pd1k
22840	payment	2133	2133	1874	1	1	995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZd6Y4e7NQHLjqNcBzVj391yXYe3gbvkxYqD5Wyv2BWwJRB5x
22841	payment	1397	1397	1678	1	1	9865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYD1s1rnQ2cEB4MeMkPXDn7jRXWRsCihC1iFLUXXeLBcUK2Kx
22842	payment	2134	2134	1874	1	1	933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfErEYtKeYJonGaAFmXuX31gc7NtnDbpKFWMyHXQSfYFYLwWx
22843	payment	2133	2133	1874	1	1	996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dU6S8Antxcuyy6ikCi6KbfvHHcpkdWG77fkpADa8v4AG2tid
22844	payment	2132	2132	1874	1	1	287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhjmEaFZ6D9gCoMDDZWaFXZvE99RmXKiteeVkxHpzmEjKrYa8
22845	payment	1397	1397	1678	1	1	9866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumecLjaUvTyNRhaYgJpnaJ62ir9uhba2Ae3svXCZE9NNmmPbv
22846	payment	2134	2134	1874	1	1	934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZNu2C7HEETQLJNg2zURgxmbDFVoumVCQ4KftzbHoApQQwk7S
22847	payment	2133	2133	1874	1	1	997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsn1Shna9TqyqviE29o2YTUrahVbZMfo9YnqsXyQoRWUqmRzBT
22848	payment	1397	1397	1678	1	1	9867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpNARPBaDRqGLKSpJsBFfGY4SdGArjTPTCjS8ypgv3jUjeaBc
22849	payment	1397	1397	1678	1	1	9868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7urMaayj1QbYDJM4XLmgms5FwN2HEkXqYcz4xMNij6QEaz9Gv
22850	payment	1474	1474	188	1	1	14	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M8AtPYnPDnqkGDE7yhSeVEhBNhSnXRqhxMvh7Ls3Y7WpMeNN
22851	payment	2132	2132	1874	1	1	288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSPSfL875xqpr5eEn81CNCx236QMJ7gS4jVcRBuB6zmKRfz4K
22852	payment	2134	2134	1874	1	1	935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pK7vaPpXjAVVASpWWT4tgLQLUZ2KuUhMfiECtXRr8JFd7QcH
22853	payment	2133	2133	1874	1	1	998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ujFXVxhnNY8SzUUQSuQhBw5weXTWW7FfdtmTRTrV894w1wFt
22854	payment	2133	2133	1874	1	1	999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9u5H8QX3XtKEXnjREBALHhubGeQV1V7wT98wTgbg6aWw5cX4U
22855	payment	2133	2133	1874	1	1	1000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCApmVbwdttNygfpjaHBAnK4BnspB5bkhEgNBQvcJerfxDoDPr
22856	payment	2134	2134	1874	1	1	936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGasjqdwEdQoU1RGUfmtB3Lasag8a6vbc2xYx7v7dM7tRCrcsr
22857	payment	2134	2134	1874	1	1	937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XNdbj8YRvaKBnbMe1EzrLVzzp3Zno9Y99tRTAyyf6ia4RFox
22882	payment	1397	1397	1678	1	1	9876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1y5PUapumRsGvZb8HNUUstKxDCCYHhGUdGwSD9dzXS2v36Ux
22883	payment	2133	2133	1874	1	1	1008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDNd7Bgi4ESVqpoAnJcYmpHy2oH2PXUsVqUY7iyBQ4EFTgtBk
22884	payment	2134	2134	1874	1	1	945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrvuudnds7HsRwWBxhwMUtjWHvtcMMi7PdMvWrniLJTeoWqyj
22895	payment	1397	1397	1678	1	1	9880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5fiT9XuiKaBdM5YQg7ti5rJbWtRrVJEWYtdNCpGR2nXA99ZZ
22896	payment	1397	1397	1678	1	1	9881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsctX5ncrpJtS91uejLKiEocXAp5wisPV73FrPYUSaxNCD5ios
22897	payment	2132	2132	1874	1	1	292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Gx3ZvLkpu8NGZkaiGSH5SpmQyNLAM8bsd6mVDBfznGrC3Fef
22898	payment	2133	2133	1874	1	1	1012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJKT8DzFjP4oTyPruNMgr9Gbz2GyDT32HSEVW4kWc7ckrafSN
22899	payment	2134	2134	1874	1	1	949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutwYUAH6HmcwhNNTJgPsrGYMQTjzeWcaNPgmmwEqrnc9nZWz7
22900	payment	2134	2134	1874	1	1	950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDa8YLAVVUiJsTJS3sMWRgfZT2zK7SXU82o2rnyyzsNvHXtAi
22901	payment	2133	2133	1874	1	1	1013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpGsPBKBni45qKPDPp4dBabANwULMXtdbvuzrPQksrxD8HZE4
22934	payment	1397	1397	1678	1	1	9891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnA3hbLC61DN3xzrSgWHovHpxgfwLc5YLUqD3nG98p2eHKJ2t
22935	payment	2134	2134	1874	1	1	961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgMmmfG9Dy4da4XuZXQQBNxWTrzdk7yWXp4GzJRWjio9spFSr
22936	payment	2133	2133	1874	1	1	1023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxMgF8YjC4fUxjmwk85VYE5xN2VxuCRgb6WHjaNRPZYmqr2U1X
22959	payment	1397	1397	1678	1	1	9899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3SG1y2Ufb198h9phv5bUhfBdR85jbCLEyTGGLHQa8qp2ingn
22960	payment	2134	2134	1874	1	1	969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGWkmHYFM7vrwHQyoRY3xNceF1gw8AjxsAY92n4Tsvz832fXr
22962	payment	1397	1397	1678	1	1	9900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24JLNPnUMdFE3xxuZyZRqUKX5Xng6N41j5Z5SgFHLBXdAagBm
22963	payment	2133	2133	1874	1	1	1031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLr6akTFSCgZMaQ2bSvJj7ApFAvmKvyVgrqUUpmur7v8uJVPx
22964	payment	2132	2132	1874	1	1	298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzyQWejhdua8CKFC7AMDXsE1YgZPhYjnrTmeUkjvaydQSjekt
22965	payment	2134	2134	1874	1	1	970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRBZ4GT7ocMfKSrn2QCjtQbZCPnEByGJhwwwDM8XJTSs2UkG3
22991	payment	1397	1397	1678	1	1	9909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMbTxwqn3Ldq3bbypNZLAmnQwHS8hhwhq7VhKBXjjWHFw7Kef
22992	payment	2134	2134	1874	1	1	979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7B7a1Q33h3ekCthRzmcPnVVQaF2AXvjUPLwVSPf7vtjjgFN3
22993	payment	2133	2133	1874	1	1	1039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBfSBMLBMQrk3nkgmQ6kXno6vQR5SMyd2rta2JYjKbeKQN2ze
23030	payment	1397	1397	1678	1	1	9921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1N7kNQXdh6Jk6D9RBLFc8kZwFoJv6fXayrHUsNaYZgguUgRe
23031	payment	2134	2134	1874	1	1	991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnMLLifeiJb73e6RaUMRFQHdxFf2G7vCmrxfKxYZSDbyvE82sp
23032	payment	2133	2133	1874	1	1	1050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxTpqgamfx2EW6BaJGKWCvAghtWBgJuKFN31aX66K3kJY9NeU
23035	payment	1397	1397	1678	1	1	9922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDqZA88vdDH1QDf9XpD3skwfxGjALx1dKizddW6xviktVaHYH
23036	payment	1397	1397	1678	1	1	9923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5ZJ8ZpFmojfxo4HxNnkkN3wwGpVmkabR5njVsQsM8DeXYrqj
23037	payment	2133	2133	1874	1	1	1052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6B4gyze9ZomrNgCfDBnTh2Nop3mkZha2bF8WfcTD5tnTJNk9c
23038	payment	2133	2133	1874	1	1	1053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPLRCNdhQHNpz4y5hw37FDcMUXRthq9d75PMCQG3C76R8Etby
23039	payment	2134	2134	1874	1	1	993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtT8m5A2Ni4CC6J48TXGgs29g8Sc8fY9iRUWMDefrxV5V3CjY
22858	delegation	188	188	1474	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqu53dUJdTByG1Hsv5j1GyxF1nir2incLzmb2niLMz4aEAtQpe
22859	payment	1397	1397	1678	1	1	9869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXM5QrmaZmpFNeEHQ7n2kzQYvmyDAJaRVqbMeRXZsGit8ctxVG
22860	payment	1397	1397	1678	1	1	9870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxP1ttit7KfbP9NeVxHqbwPEGFUVYmNxwuPYnimnkBtPkcsR1
22861	payment	2133	2133	1874	1	1	1001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpd8MQsLTMoDhMkhGVHru5nymDKUodLkCZw1nvr9UWGJrDcDC
22862	payment	2134	2134	1874	1	1	938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpiEY9g4mRmrveR9FJP9XY6P9rKDQpJDWuCCg4WR6ZaZXKq39L
22863	payment	2134	2134	1874	1	1	939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1EQZDLvqAP1B9b98vMVs5p39uYBmtsxrRsZVjHYnKw5DpnWs
22864	payment	2133	2133	1874	1	1	1002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9gW2DeYFgxh9tQvH885HrAsUa85nffsEnzzFWhauuMFr3Z43
22865	payment	1397	1397	1678	1	1	9871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgW3YJLPZxafrBFqMb2zKL1YDrMbTRmxP7Jex5AxdGh2o6Cqw6
22866	payment	2134	2134	1874	1	1	940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmwUhWn1tFGfbxNoZLemQv76RerE3MaZt6C4NhZeRBrsHwWk3
22867	payment	2133	2133	1874	1	1	1003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbyjZ9J2WL1N8ypkzs4LFRLM5qQ71iY4YqhBhGUrejVYYWAip
22868	payment	2132	2132	1874	1	1	289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAi2pUkVa6Ca5Yo6FuU3xQGjH5T1wy5YKV8arvRr5PLmdFWeLr
22869	payment	1397	1397	1678	1	1	9872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1hp1bndF9YcBK24duyh2CjZx6T2KKwmjxr6BLnW1bZKBQTrP
22870	payment	1397	1397	1678	1	1	9873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupKwS7ZHZ7oChHqEFWBVKK6oPjW1gynqAGz2jmas1NXJitoNW
22871	payment	1397	1397	1678	1	1	9874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1R5EzDSvJpeBCDSPnKGqfVQBeC4WKAG1o1GpYsJJRK8yaUmx
22872	payment	2134	2134	1874	1	1	941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXxmYGF2WtSFTvrN6tGVtYCcMLggCX9yma1AFxTAn8cfhmmHWS
22873	payment	2134	2134	1874	1	1	942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTiuJ6HZcMnn3z1Sx53hJx2QAV7zefDkZexnKdyjR7rLNqR7R
22874	payment	2134	2134	1874	1	1	943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDUmgRMiw59db6XdszaiuUN3ivP6HHj39Vgs57CrRmmuntjJZ
22875	payment	2132	2132	1874	1	1	290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXMbRbJceDTCaYqj99CjZPugQ2AC7HngwA6Ey4th3vxqNhCzw
22876	payment	2133	2133	1874	1	1	1004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekHQPf2BGxMeqDBUcAhZR9jmxGwF3mKo6EaREnKdFP9RDE9yz
22877	payment	2133	2133	1874	1	1	1005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPzQkM5KrDLnwAC9ZsgBmFCibnpmsJDvU3qCsCG5FKGMNpg1v
22878	payment	2133	2133	1874	1	1	1006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhViC5fMSYD6MCTrgWzQECa2TT6rLr5gT4qoEVjvHCcH33zjzc
22879	payment	1397	1397	1678	1	1	9875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigpEKaQEhRb1uAywLKh1rjrFis76jR1kFEvKCVvgo28R1eJae
22880	payment	2133	2133	1874	1	1	1007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKecfCFZqaFSLcHuTUZBh4xJJ2RKNRd4Xn7bscFAkjVX6JpmUJ
22881	payment	2134	2134	1874	1	1	944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAVGEPY9bSDQb3TA4RfpbG5k7gDYPQybvzZ8A9cojAzCnwn4U
22885	payment	1397	1397	1678	1	1	9877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfsj32rcpmhELPMW8tEjKdoMT79XvZpLMSozKhYigntvikJRE
22886	payment	1397	1397	1678	1	1	9878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfE6cs5Z8w25hupfTpzbhs5Gr17AwSpDfjAUPgXqYWxzjLFiHc
22887	payment	1397	1397	1678	1	1	9879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xa5Sz2KKMpG9ivN1a6RFgs5XoxYakNHBwM9zJ8XxFnpzKndT
22888	payment	2134	2134	1874	1	1	946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSh3jpC6WrhKjZ19j7m7eHzdusiQQMdW62DxuyLPXAWMZDSBym
22889	payment	2132	2132	1874	1	1	291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAqwMKnhsxfsokY4EbbpXutj73sXEgyBr6NYGC6qu9KVKJZpQ
22890	payment	2134	2134	1874	1	1	947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExSZ8uuPeXjx1jx2X8yfzRk2mxr6NbEucPKQbvT13zAqcJbSH
22891	payment	2134	2134	1874	1	1	948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPywRSogpDPDfkYYKuzVedpU89PCNffddGutm2aHX5RcX8525
22892	payment	2133	2133	1874	1	1	1009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFJAiFBqAb8XrimTNRt7FBi312WvqDw2XnXwNsjN2fz6Lojat
22893	payment	2133	2133	1874	1	1	1010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MjxtBkRAjifYquwv8rfWSUH4H1c2esjN4oNbD4tADSnC8h9g
22894	payment	2133	2133	1874	1	1	1011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNpbb5q4K8npm1EfMg3xVwqEsxYmyYStyUTdhT8vUeRTe7hZy
22902	payment	1397	1397	1678	1	1	9882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVpi5Jc1kisA4QgNLbwSueCz1cqDr53YPEa59SUhmCEEegLep
22903	payment	2133	2133	1874	1	1	1014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoS9s3oEkjiUPC2uCrZNXgC1d5ZXHmscM52QY2X7Vr2vBW8NC
22904	payment	2134	2134	1874	1	1	951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsMa3XGfseV3SfPY5QmhxXLMZ5sG4GiyCYgpouAs9BXmg9RW2
22905	payment	1397	1397	1678	1	1	9883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmG34TizqZP64EJhauQoYsmSW2ShLU3pN5yzHbPobHcXhkfQDo
22906	payment	2134	2134	1874	1	1	952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuv9XqZAQLEWQZWq1GZapyTFgfZ96V5t68h36j4deiesAuuB7f
22907	payment	2133	2133	1874	1	1	1015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunnvmNPxuNrkVCpwPAdnKHEuAE8VGzvZFUfiRRQoqqAxgaBfV
22915	payment	1397	1397	1678	1	1	9886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4AQASxe2qw9e2PXbpZbj4LVzA3ywvjW6X4EhfWn37bZMKvxqt
22916	delegation	2142	2142	1460	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6jmMDoEPDqcKe7XA58zZDYmKTPsCVCTVVLMDiNUkmBqZFDbP
22917	payment	2132	2132	1874	1	1	294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoudCidEALMZReRuwr7LVcpTkoT9ciYh696K9fQDheDau6Qugt
22918	payment	2133	2133	1874	1	1	1018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFLKyUavb4tPaY4zijbargQVpeGMr1asodEFbXTJmfYgzoPsc
22919	payment	2134	2134	1874	1	1	955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87FRx41hzmV8AsfwtXTiCoXGL16VfDFseJgsRC1aWzjf5USJR
22920	payment	2134	2134	1874	1	1	956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnLpPbmfuKfzknrD1KWBvrBGezs5RcZSVjkXMH3WChv16KEnX
22940	payment	1397	1397	1678	1	1	9893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdjgg3xJ98cyBXmK3uKAmgKwPjrKpMJKsJyb4fdaeNAV51qjN
22941	payment	2134	2134	1874	1	1	963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFe8yvgJiwNNg6Vq5fMu1nFB5ogAF11TEcXcgY2Cuzonaq25C
22942	payment	2132	2132	1874	1	1	296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2iWujC1cYpTvHdH9h1q2Q9Cz4RpndyhkirjtxsNiVmKGQnH9g
22943	payment	2133	2133	1874	1	1	1025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESgDMCb7TTMt1fdy4q2DcEHvbL2XESPHsWpcrDYpU46Zphqzn
22944	payment	1397	1397	1678	1	1	9894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQktFV2GDMfksq65QJ4e9B7gVqpVpuN4s2jcHgpTvbpeKKNW2h
22945	payment	2134	2134	1874	1	1	964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHiXmy2H7wUgF7mLhST5AWzGCjYhHXZHr23UyA9kWXhUxn52C4
22946	payment	2133	2133	1874	1	1	1026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFn6Bd6LDLMTSxoAe3RV6q38YkFWUJ1TVqdB5P1vzmfpZZcd5
22956	payment	1397	1397	1678	1	1	9898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMA6mQbEAQGG4pgMEEnpSup7NGdWhpre9Ebsbtu5YJfTjAU6B
22957	payment	2134	2134	1874	1	1	968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDBkiBnomq8SatAsGgbnjdQkQfA9ZWUufXEfkALoMWrgok3n6
22958	payment	2133	2133	1874	1	1	1029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWDuNyGhD54tagbYrXaPgzBefANNByQbU9pDpHBqtcpBz2Bx9
22961	payment	2133	2133	1874	1	1	1030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVmBXtuAXP9faEkrWVrkJCT95uQK8KSiWZV3bDBmUuFszsxth
22966	payment	1397	1397	1678	1	1	9901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNzg2911EsLZpNCJ9VU63q3EXPjxfbHXLtjF5caXkVVGT2bXc
22967	payment	2134	2134	1874	1	1	971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nwSJo4aY2vPuy4pUieNujyevircxw935bRRwqo8pft556nzT
22968	payment	2133	2133	1874	1	1	1032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6afgkyGG2CW61JZQT7yNZQ2uVpefgtp85xGVhu515R8mgYqfr
22985	payment	1397	1397	1678	1	1	9907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBk5yRk1gyFPTrcny3LmJbu3caBC3YaSmZErQ41NKfv95zbFX
22986	payment	2133	2133	1874	1	1	1037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3uxBs8CeFvardM28WwLFY22VBb2NaPdKkTN2io9nD2d7qBHHL
22987	payment	2134	2134	1874	1	1	977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8P31Pv6888zpwoEt7KKzo1k3nvRKFmkpCjsvwahRgDc7FzbCd
23011	payment	1397	1397	1678	1	1	9915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3D3TfPe8ff8Z4j1b6RM4KtKHP9nNCh4S5gZHLdgYiCYvwuoPp
23012	payment	1397	1397	1678	1	1	9916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSzGy6uEWzY8LWGtTxxfi8u1mUDe5d1UhHzMZcMY4M1iCEtAk
23013	payment	2134	2134	1874	1	1	985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7rixbqd5XpnpK9gzVXvrbqtrwQL4BjkUwqPjGbLcKQNx6EZP
23014	payment	2134	2134	1874	1	1	986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmq2aEzyFkQHGNSbYrxH8a2uDvCfsxobqKcQC5txmREsZvfTu6
23015	payment	2132	2132	1874	1	1	303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJHoKUz4v6ZsRfqPfU74KGEqhGhGMB7PwfEdnj2mcYp8GsM3X
23016	payment	2133	2133	1874	1	1	1045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58PxU4cX87BAJPM9DpCUg8iwzQDRnddC2mmFvkESpYDKVJAhC
23017	payment	2133	2133	1874	1	1	1046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkbCuJvCMkcUcYBpDGJ9PfebEStEcKutX3ABxo2Q2h3y52hBv
23041	payment	1397	1397	1678	1	1	9924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3t21Ffd3eKMyrr4T3zwLsVH7LyppKgCsZpWvXJvbqUZZfede
23042	payment	2133	2133	1874	1	1	1054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYowHwGSPd5rrppLWvFnGRJ2UipvuctkPGaHTrtYy1uYNVZNce
23043	payment	2134	2134	1874	1	1	995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bmkVR6cqeWybS5VZxL4N3bnxQnff981zTGyTMXVyy4j9LH6e
23081	payment	1397	1397	1678	1	1	9938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9q9mZtdYiNWoH1ErwLvgi4mqMbkSAppzi1ifwiQEw5qELU1y
23082	payment	2134	2134	1874	1	1	1008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgoG2CLfEhRuNPFXds9vVaMBQ3SYxjhsiRqa65i6JexXZkCnE
23083	payment	2133	2133	1874	1	1	1067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnvPGF11ihQ3hT6boR3JdUNyjUUdgDmugLp5KmMWp4rARM3M78
22908	payment	1397	1397	1678	1	1	9884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9WnRXA9XtgADqSfgcnqRcYsNG6U4AWv8vGXv9Xoehv2HZyHs
22909	payment	2134	2134	1874	1	1	953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHxsodoBekeGpVY4HzMefyPvGo63xKBLckZ5jKRiaRoHtGhcM
22910	payment	2132	2132	1874	1	1	293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpbadzw5U32JLiGT3WdcW5yHuRjJ5MGraRtYd3KRBPxB3zYc1
22911	payment	2133	2133	1874	1	1	1016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88Vyh5zPW3jdkg1hMTmscBzmuD8jnoyyXdf4RK1Uc3qAw25ti
22912	payment	1397	1397	1678	1	1	9885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QRTfuHLu2vnFdi8eVfCPPBqjCC47atPDsVUVTUWBgbfNodvF
22913	payment	2133	2133	1874	1	1	1017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2syg2zyEWAkJz6aZE38ThVoZ6J9ZvUD2pzcAU5aZVbyCh8uyv
22914	payment	2134	2134	1874	1	1	954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFcB2AXysmbHuAxfrELgn1G8qzPtbdGP3mn6Rug2AeXQRJmx2
22937	payment	1397	1397	1678	1	1	9892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDWiVEYDyJiV3Q5DaPE7rnUWdgtEkSvqqqNHGw4yRwBm4g8uP
22938	payment	2134	2134	1874	1	1	962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyfV5SLvXjar3ChyWLKTXadH3paSthvjcjVARUBbEeJ5n1Bfk
22939	payment	2133	2133	1874	1	1	1024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rNjCsGPf6UEf4mhziTEXnNi7yjg2Gsz9sc4DQ6DM5KprrxJx
22947	payment	1397	1397	1678	1	1	9895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ52bQSQ494xHYiSyn8ZXpSAg5guxqz8ejbpF3VeictvqRcahCB
22948	payment	1397	1397	1678	1	1	9896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmTvMn8EmTkgUQQnKKfNpPbx4gMQ5P9nP7zZNt2hTY49mMZgi
22949	payment	2133	2133	1874	1	1	1027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYft7Fg7EzpCAyMzZ4e22dRgxfcGprhwDRXGUjkacWYkuK6ZiB4
22950	payment	2134	2134	1874	1	1	965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHCeDnvBH9ki5fJooaKkMVQGotfwebCoDp7DtjZRUNf2bfSXJ
22951	payment	2134	2134	1874	1	1	966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21EpUBvmFj5cDsPdYLL7Kt5e4UmaNngqfdXuL8fxg3A1w2aDm
22952	payment	2132	2132	1874	1	1	297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvciLjt5HTG5ERkadLCgmAKNXthUpToe85hXqAEGxEkXK8kmHS
22972	payment	1397	1397	1678	1	1	9903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJF7yFp5wSBxBrQd15qp1yVBWQ2yxhg6zDwRXhBKuBaT79zcS
22973	payment	1397	1397	1678	1	1	9904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJG3vC2MgfcPFZRG2f4kHx95FeykqNcxSutfc2fGPHYF6hTK89
22974	payment	2132	2132	1874	1	1	299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5kis8cxsjcFyrSjsGUf5SpHx615vgBaBuLPPbPvJVznwSoMH
22975	payment	2134	2134	1874	1	1	973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNVSRURwZfwrHkHtuhTXETJkAx2er9QFYVrug9xPb5E7Drf9T9
22976	payment	2133	2133	1874	1	1	1034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNowa46NjAudHCZ1FwAzAyCQN7XoRQFLkSMepK11n7s9Yitv4c
22977	payment	2133	2133	1874	1	1	1035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBou5k51QHsPGs5KcvZi7eXZKvseNgtBTD5Bu1vhCqTfpBEe4s
22978	payment	2134	2134	1874	1	1	974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyNmx7qznTkHRMo3iCPRLgGUR2HqboJS4K7LUhTdkRVdmx4E4
22979	payment	1397	1397	1678	1	1	9905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6bcdC86TqwtWkJVATqynWXkSKFomMqrd7RpctEDotEcZgSWM
22980	payment	1397	1397	1678	1	1	9906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2NKgwjsQk7E2FRrLNUoEpbNZdTt9qdhggxm94nCK9TwoXSev3
22981	payment	2133	2133	1874	1	1	1036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAMcX2c5hQPh5HG4vfWkS6j6Uehc9H9iZmdGwQgW2BqjmkfcN
22982	payment	2132	2132	1874	1	1	300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEY5rp5TLHsEBiyEE5c9LB6Y2wdgqjXNSVqsVXuugy7GTuMaeh
22983	payment	2134	2134	1874	1	1	975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJYbdom8Fdvzbo1FXiLRJwpm8goYTfyY3UroU9PXXT2PPz7LH
22984	payment	2134	2134	1874	1	1	976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4QjhX67qZiLRM1VSSLib4hVg9PA4fzgdt4731Bir5Scy69Kb
22994	payment	1397	1397	1678	1	1	9910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhkjXNUuHJZqE28Aifkz4LXRw8MueofhbGd7NpCUmakef5eBj
22995	payment	2133	2133	1874	1	1	1040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43qUo331b3XAvrvLjsYiXDK4s8qQ9xvLvGpN4iHoTfd7LE2s3
22996	payment	2132	2132	1874	1	1	301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKGgfmZ75UbSCyhZKtj4cJF35rzETjejDCH7WDkouDL7GfDjfF
22997	payment	2134	2134	1874	1	1	980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpPsgs8cE7jtvjGYxsL14HX9ihrhe48hHhexkBYrT9gtS1s8K1
23004	payment	1397	1397	1678	1	1	9913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27VQ7AUQ3iBrXZQP4trpDK4KLWzaooo9JfFSWxcoq1ox4vyMW
23005	payment	1397	1397	1678	1	1	9914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKNFFTh6BLfShkDCmFE1dJjkhRP6TormvVuNCTNde3Lgoy7ZH
23006	payment	2133	2133	1874	1	1	1043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixtHCyLg8YH9CGr9m8xFtoUGpzwN27M5njaQDFFEtbpCc219r
23007	payment	2133	2133	1874	1	1	1044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBCXn61iqtxKNQoR3F4Ka9FCuNvd7MsbdoKE1uQTNDxoQ44Rz
23008	payment	2134	2134	1874	1	1	983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZKQXrqpRS7xRdi7u5DjbBijStVhhaf4SpqcJtiLiEVYnxC82
22921	payment	1397	1397	1678	1	1	9887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbySUUDUXPUEEsQErwC3zPWTZfcX2tSCy3QTSmbboPM15Bmta4
22922	payment	1397	1397	1678	1	1	9888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xsw7iw8ZJ6Kq6gjkywEYpQaqHwCxSQax7GDfxDDJmJvoXH3S
22923	payment	1397	1397	1678	1	1	9889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDFnyH46kmuFsw5Tmohx9ofV9VUNeYmND5oGseb2T4ETswCDF
22924	payment	2134	2134	1874	1	1	957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7epVmKThMVZw5MeH6qXLwSUCYtNQHHtJAEo9q36PWGyYYXTy
22925	payment	2134	2134	1874	1	1	958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgJbL7WsLx4t1MXLqDXLHaUA3NcN3pourEE7JDGNG5RY4YqPx
22926	payment	2134	2134	1874	1	1	959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9iDBa6dTTvcv7s142uAfpevQVAtFLAhJarRum3tJYHTQN57L
22927	payment	2133	2133	1874	1	1	1019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDD7BwD1sVs3u84KFSfB5Q2zmgLaMpt4221iCYrV3n6js4JaED
22928	payment	2133	2133	1874	1	1	1020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXVyh9YVaqmfbua2Eis2Pzh1E3DFwR7jbpyW5TJ3JLzd2CUKv
22929	payment	2133	2133	1874	1	1	1021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRqfCcPouYUFEonuJpBZkwob5HED9csQUAN9bdXxutYNLWJxF
22930	payment	1397	1397	1678	1	1	9890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5XfKBHkBwFdSqDhHP2uvEjzVHvpF9zaRpGm8BqBUrFGpZbME
22931	payment	2133	2133	1874	1	1	1022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThQZJrfSogyaGz6q31LWQcWjxtWeWvdZZH4EwCHjjKAe9S7qc
22932	payment	2132	2132	1874	1	1	295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutaTJwVMFP83zkyRsHvP8FpyfpanY99FsjUfcZLBbQauVF4FT
22933	payment	2134	2134	1874	1	1	960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJB4eNuTDj4dhMeFjsm6v6oQHvg2VBCteUCrZ4Zt2c6QVbucCo
22953	payment	1397	1397	1678	1	1	9897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrQEgb41MWfUoezjVzgLc1VyXofMkvtXsWSBA1pKZVdQXJC1f
22954	payment	2134	2134	1874	1	1	967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRMvpmCoUo1uPrnQ6bJpyUc8rGQdhdvsPDahoDYc4nW8Qgaxz
22955	payment	2133	2133	1874	1	1	1028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYJqK9s8tnErGxHTSHoUJx7fTbbTHvXw4NCs12ywcmyAKxuZH
22969	payment	1397	1397	1678	1	1	9902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2yfRrUntrPm4vEc1nkGDPHfu8oae9G533oAffv3gvNtjSeJu
22970	payment	2133	2133	1874	1	1	1033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSjgkfDqQhzNbF5TqUrndKGPy767GwxAcRarcTXQAVXGu7PhU
22971	payment	2134	2134	1874	1	1	972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLc77BPCu2fiJNcT9gPk7p6wjgSaGU4Ax88fSFiCSdqbhcbiUR
22988	payment	1397	1397	1678	1	1	9908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyZMojDni1HDghGUzD4K1Bt4BRjbZcmwmiuZsfRS32eY3ABYb
22989	payment	2133	2133	1874	1	1	1038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLBzrGUND8RXK8yicDk19ncbPJJaeuBKkXDnYWEEKaH8PGqhr
22990	payment	2134	2134	1874	1	1	978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVGSuQXZeoEgydAjGocSjh119hTyqh5BccF66GYL6MgkGoUeE
22998	payment	1397	1397	1678	1	1	9911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVuLfYUg49T1FKKtnbW6G6DxPwUfvq4hB9vqLmdjzntgHPAes
22999	payment	1397	1397	1678	1	1	9912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBFWK2kMYE7AfTtmc8v3YFjdRpdS82fps1teR4eV2RvpvMNy3
23000	payment	2133	2133	1874	1	1	1041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkM9x4uNQd67g4M4WqSJTnEqP79mFsDheF5SnXPGFBFMroqeq
23001	payment	2133	2133	1874	1	1	1042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu9YjgUiYAJ53hyHdDXSdMJnWGCoP5UJ5m9f8qygnTt5MGNpN
23002	payment	2134	2134	1874	1	1	981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetCLXhFzXwf86uvAHNHGcHdcNP1LkNRV97tUD5EJJipfKMiRX
23003	payment	2134	2134	1874	1	1	982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84aDV6SFYcjW31ERUEwPT3KYCBiFEveJaTaG1QtVbLP3B8sGx
23023	payment	1397	1397	1678	1	1	9919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NPKmQS8azsUFdFgR1DUmDf4aauaq7kYtMdLotd3p7kkTtUky
23024	payment	1397	1397	1678	1	1	9920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4Q7htXpvp6cqgzwjuhCCP9WmGEwP8pPqXArrLTuNgtAuF9Lz
23025	payment	2134	2134	1874	1	1	989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehNMGxbyoPaNwemeKyXPJFWyMNJYqNhNhQZLMRa7Pmy1yxwjF
23026	payment	2132	2132	1874	1	1	304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYroNTPpr4KEey4KYbHodoSKSvZGcuyDTTnH2kaKZo3fp2vnx69
23027	payment	2133	2133	1874	1	1	1048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4qggUMLUZy1LaMhoH6uUfVuLUQLsb8PDuHgAJo6XRwEioTe4
23028	payment	2133	2133	1874	1	1	1049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfpcRshDD7f7LTr8JYtYeySWAFGbaptxkSKccEgw5dtkdSgzJ
23029	payment	2134	2134	1874	1	1	990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENwCoE4vFFYqWQxXaUBQFwLDdHr1cSfm9VoufVLSYrBUPZke4
23053	payment	1397	1397	1678	1	1	9928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7czNRBTHE6BwPTy3mXRQqywZTf5CMVpYGkqbtXRLqSs5Jr25
23054	payment	2134	2134	1874	1	1	999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSaeLg6nqmxCCXVJ9MR1AwLL1VoxMYUkZ61jnrzCtrPDBp1m3
23055	payment	2133	2133	1874	1	1	1058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB46H1tEQyu5c48Rb1B3eTjgA693PWaVH3zzpbz2kQ3iXYaM5S
23009	payment	2132	2132	1874	1	1	302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjoU9Li7ZdfX7s2h9X3C8EKDKtAPMaCeHrRALJAGJnvFRHawV
23010	payment	2134	2134	1874	1	1	984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9eNX1wLnMwaybT8WP5Bbq9pqStgpP37FdoekrV1SFPAnweFb7
23018	payment	1397	1397	1678	1	1	9917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQzUPiioPjJdAUygy1iUk7rD6ZHfbggZNXDPK63D6Hiq1XYSg
23019	payment	2134	2134	1874	1	1	987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRWYwByiJuo5DBdcoQFy4e9DNLwA1B3ACmSvs591T8pkcWXUz
23020	payment	2133	2133	1874	1	1	1047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaD3jW15Q1jTkZ7KjCNFcDKbgzifDqhfFcPY6JRW1fh6gcW99
23021	payment	1397	1397	1678	1	1	9918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Pe6qksm4DTFhBQo6oVtip4sY2EUrewSGCLoV56D2WZ4HR3x2
23022	payment	2134	2134	1874	1	1	988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Wme3uaHRukhn9ZM1swDw4cy64Tj4LP8y4VXkZZoiWidVkq6A
23033	payment	2134	2134	1874	1	1	992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFbfCmSpqJsYktmA1YWzTzuVEqyBq1F5cN3fPqxvMN1hEuK6k
23034	payment	2133	2133	1874	1	1	1051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJcYDhBNgDBovXuqHfuEoBcPZBuVNtAkhaCqY2iDRPgCkyB7T
23050	payment	1397	1397	1678	1	1	9927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AU87wLgQXGSgv3W5Z7u4oXtwUjkomJoBHEE2FV2LWwKkHcRk
23051	payment	2133	2133	1874	1	1	1057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxEg5Ynp6X1kj9fYyqAPnJnk3gZuLtRRS1uU5geCacYDGJFav
23052	payment	2134	2134	1874	1	1	998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SjhbeFrmrPaYkiej3egoc1yYRanKFYCsGN1C3YJGZvGtgbcY
23056	payment	1397	1397	1678	1	1	9929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePph1rXo6LSzcg18d44poqSSPuNsi2nc3gfJNsKR9KooNFfFj
23057	payment	1397	1397	1678	1	1	9930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Z2aEFWsgSoV4uAHS3L81ms4vEYVP124TUGGUsSjtX59AvXrD
23058	payment	2133	2133	1874	1	1	1059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWwH9fkNekdVfVteRPHMBbvgDjcmCczmKS81UJnAHGRRrgGz2
23059	payment	2134	2134	1874	1	1	1000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmW7BKSW5ACnBbgXSvDs7Mp2j3ZMHCGwhEPbHMi9C8W7xARKK5
23060	payment	2133	2133	1874	1	1	1060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XBqHJs6ay43onHvEgot6ts5tBzMD3oVASYXbDM7EpUKvG4WC
23061	payment	2134	2134	1874	1	1	1001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLwZByLYy13e2yFNeVcdLBwtvwjdFR9uGYukX5nkCwHc6w85f
23062	payment	1397	1397	1678	1	1	9931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYij3bhZverHKLWiYG67mjRpcKfHorRKU3oZm1dUS226anGdebn
23063	payment	2133	2133	1874	1	1	1061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCg4o6mV7DG9C944NE8xq5ZojYBCfHGYjtCJHHLkWEcaSjbvA
23064	payment	2134	2134	1874	1	1	1002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzmidda5r6gy24ThcYR8xuvhVUE2oenu3YyWcmcuLNquWRdqw
23071	payment	2133	2133	1874	1	1	1064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfNkt12xGTyeETirtqawSPu78PtjNurP7he69JaagdghnLUSq
23090	payment	1397	1397	1678	1	1	9941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6EJGKh5HpLiNFpXEgdnUGJsG2q4bTQqHHd4QYqVwKqZVenYb
23091	payment	2133	2133	1874	1	1	1070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZy8Qik1VwUU9piBfNCu8ZpmpQnvwJvSuW3RtQEz3yTwMrXdS
23092	payment	2134	2134	1874	1	1	1011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RLaDyjTgNcD9c4KYDW9H6wmZ3ZVEb5N4tNymycbzGecPkfmn
23114	payment	1397	1397	1678	1	1	9949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYQCgTjZ2xMdgtx4EtW3cghUwKwAZXPke2PRaek9ipoR33UEy
23115	payment	2133	2133	1874	1	1	1078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9fAnWVtZFKg6aKDGohxjGAFJw6Kt48wYu2EauziYaCP6rdHJ
23116	payment	2134	2134	1874	1	1	1019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZoUWVCQZ8s5jqRtLNgWnTifqbPqBLiuz2JBGTbppZgh9tcBH
23159	payment	1397	1397	1678	1	1	9964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSzuP7GnkfYBGYJ7rBay3KAVA3W4kXDGGvGVxUcbHytH1fvzJ
23160	payment	1397	1397	1678	1	1	9965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5QUb1UQKrPgpZ5naSNhhfy1bTcgFQoqVdoyXFrdtNn5EpaLB
23161	payment	2134	2134	1874	1	1	1034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTZUDxJLG8FSJJ5Bu7k5Sk5F6WaBSagC398w9HXBdyqJrnBoo
23162	payment	2133	2133	1874	1	1	1092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGunxjLFtDkpqUZtt61SBHG92Fc7pyA89QnBsS7x3BD8k2V4A
23163	payment	2133	2133	1874	1	1	1093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yq14cxjhksYqJ47Y5J9o5nKctzJci78CQoRTLCd7JiydRdVF
23164	payment	2134	2134	1874	1	1	1035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3a6z5dde75jVaDxGWfuMYYAoQxj4ZFKhG67STX6UnZfewLg9G
23181	payment	1397	1397	1678	1	1	9972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxc1AnKfMVtFm8gCG4jSSUEnpF799ZHkdg6KqzDBZHZSdof2N
23182	payment	2134	2134	1874	1	1	1042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrPEunNFSSnReiM8c7WhN84GALncPpTyBNGp6RE3piXVksGEt
23183	payment	2133	2133	1874	1	1	1098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3BgfWa8eV7n7JhdrGdFZkjEoKNGDpHFv4pKFSQwZVccsJ6Fd
23219	payment	1397	1397	1678	1	1	9982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJgKSyU4ugcrj5PfVntYQMif12RA3d3s3TxrgZu8hiWhc3nEZ
23040	payment	2134	2134	1874	1	1	994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EKNCLQRHoNdBqxJkcH68ijejHgxqFLe1ZKpddc2e5WaVSqFU
23044	payment	1397	1397	1678	1	1	9925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof8SbkUuSRHsWbUPry9gRrEisjNQW37gqVtBGHdGa1MDfaLUs
23045	payment	1397	1397	1678	1	1	9926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxEvsEPK842BAt8MpvG3KouXYkpZaP5XEhypAdsJka3sSoaae
23046	payment	2133	2133	1874	1	1	1055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcHig9Z7Szj8M7F1QrpoAtFaz4Nq1SBdu9PnCZtA5xouiCsXg
23047	payment	2134	2134	1874	1	1	996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXEAPgMiU5r63PRE6CNLFbZcj942qngWmZ6bfshCJAhbrAsFk
23048	payment	2134	2134	1874	1	1	997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71445RLj17BfauNVV7sy4rQaLCA1EHvMzY4pnEK5coXAc5EkR
23049	payment	2133	2133	1874	1	1	1056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeAFiGe7SEyg1brs6nyZDXGj2cW6bGonWPDovPH2uUR8sjh8p
23072	payment	1397	1397	1678	1	1	9934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLqhsHQfieqGtEigdCXcrTdfgtUhUy7Q7NptNGFdW11agZZ81
23073	payment	1397	1397	1678	1	1	9935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQqm6dXAzAJgUHCppqB63XDeqwpkftsbLeY1DNYKAJdHJYw2V
23074	payment	2134	2134	1874	1	1	1005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPVLZEZrW7L2Urmpyr7ym3eBsrWu4Dea6HeVBZHDoWM176QR3
23075	payment	2133	2133	1874	1	1	1065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzTdLMDgrjzfbwDTDivTYoUwDdRJ8pM9utHRQoZwaWaGLCpks
23087	payment	1397	1397	1678	1	1	9940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSch2PAfAH4JAA2nVuNwAeoL87wX9EeFyNxRV6kKRc88iVUpg
23088	payment	2133	2133	1874	1	1	1069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYQehhZyPRzbb3paTk9zqvd6Tu1754jTKr9j7W7Q1bKyo27Bq
23089	payment	2134	2134	1874	1	1	1010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ooeyfQejRqFgJXL7XCCYtCtv21ckwsV2S1QkdUqK6u1rVcHz
23108	payment	1397	1397	1678	1	1	9947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJY1PJoNVLtXiaNtSLtqPnNtDsZnxBCf9g53H3WoXsrT2WDSB
23109	payment	1397	1397	1678	1	1	9948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDAukkDqRoEBDSP1v91CiYnVNyvRzRSt55skFrkFJLmuEQu4m
23110	payment	2134	2134	1874	1	1	1017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtHs4DwZu9G3FeStgLgmRrZmrDQYMqjSVhxbd48Qmcz36eeyh
23111	payment	2133	2133	1874	1	1	1076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qCdw6moqihHivfVEyJWsxt75D3PHp8mEQhvN156AkoE4Qr2x
23112	payment	2133	2133	1874	1	1	1077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3QhazyWq9W1qUZjCx6Vp7bdWtftEbzSUm56wncXSpmxuzH3P
23113	payment	2134	2134	1874	1	1	1018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87uoddxY3s1zYuFhrzTqyW3wn3weBPmoo5w6JYjucx5YbTeEn
23118	payment	2134	2134	1874	1	1	1020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJRThrCHRzHFFQa5Tz4bYoTzzb7Wxaz2QBBhA6U9s4kvpQwR3
23146	payment	1397	1397	1678	1	1	9960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfwNN85KDLz8Ccscq6dGcDj3mdTud6HTFFYUW8TDUQT9UsY4P
23147	payment	2134	2134	1874	1	1	1030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTCsxrmhc7BZuBV35mt2zu6dp7GP8PBRBxEkD7Hy8pmPwyzWe
23148	payment	2133	2133	1874	1	1	1088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6NoB7FbCgeXDzU55ExZpNCtJGBoFwyp7ws6uP7jkvcSh5GdZL
23170	payment	1397	1397	1678	1	1	9968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZ7zEZ4cse9SgBZ7W54C56X3qeS9W5xLbtnxzhogyXXpn1ieL
23171	payment	2133	2133	1874	1	1	1095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFu8XL9WF9eCGUqu4JawhwbEieiFf1nGFvgEbV2pB6Y3pVpyL
23172	payment	2134	2134	1874	1	1	1038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8JY11xpt1dEMCVo5gzRANmutSNArEPNdTyGmcWxWD9Xooz4oP
23173	payment	2133	2133	1874	1	1	1096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTZ1DXitbfUmweGSbCwtZi6DQs61LVyh4ncCpCrKmqVb3k3vEa
23184	payment	1397	1397	1678	1	1	9973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgX68JsLhtgSnSs8mGNuf5W5rivHAK52TnF1wPm2soK5Lcpfp
23185	payment	2134	2134	1874	1	1	1043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWSGtXNxPvHTHKxKmT5YdWAk8dLecWhcFMPzGMPPr7zkUcX5T
23186	payment	2133	2133	1874	1	1	1099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkuMHCt6JYvSZJCd5zuTULU9iJQ79tEDKy9Ehnjx7wzTRGyAM
23192	payment	1687	1687	1866	1	1	5	9452631301632	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6ktdTXWQ8z7Y5EqX9pausDbSw6CQQSTgyZrNGFzbbAJVcFU3
23193	payment	1397	1397	1678	1	1	9976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdST17JaKmX6qu8x6UAQKfCzhMdkxcntfUScG9ydZ49A9tSYT3
23194	payment	1397	1397	1678	1	1	9977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzbtv1LP1TNsMUdFe8mAjkPnCc7NJb3HDHNFEuXXsPjs6VbD9
23195	payment	2133	2133	1874	1	1	1101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxxBqnUWCBa2fg2ZTCNAFKXgwF2X4UBC9VfraGbztjbFLbizp
23196	payment	2133	2133	1874	1	1	1102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbUo3wz3VLm3qxqJJ2nCXRrEDNuWeCEbADJA4HzckARBfPbU5
23197	payment	2134	2134	1874	1	1	1046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDuw3gJ8UMQVy2gJN87eCqi6X6N7ErXPeXGEM5a2gbtVJqy8tS
23198	payment	2134	2134	1874	1	1	1047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK59X4T7uJZaqgMNwtiCAegKrXSBECQFu6F2MPN1oQbd6qYMJg
23065	payment	1397	1397	1678	1	1	9932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZvdjSDpPmPWQ6tBgEiAxzXzFJz5XSQ7Rtjmz7unSb47EP5oB
23066	payment	2134	2134	1874	1	1	1003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQMALk7rbmbEZdmZvMBurzeeLqvuMUKhbDVL9WEs1WTAWWWz4
23067	payment	2133	2133	1874	1	1	1062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmLGDuYLm1bX42DCdT4qaLPrihAMvyi3c8UYpLLFZEHBXf7fA
23068	payment	1397	1397	1678	1	1	9933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg69NUKHbcQavStMyBj7BrTJV2n1cgoENDkYPcSezoZnVoB8cz
23069	payment	2133	2133	1874	1	1	1063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEErsgr7ZHJJVqVHN8cLRwFVgwTgwszEtcYiRc2wPU1pJdG2V
23070	payment	2134	2134	1874	1	1	1004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBq3MQddMZj1HaiKhFpi7WfYuvvHY6oLgJL2T9rEi44UKuZde
23076	payment	1397	1397	1678	1	1	9936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJP4nrKnuSbADveSdSAJoYcpddkPPP6skCQqauxRiYwKp61deT
23077	payment	2134	2134	1874	1	1	1006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9xzkHMQ8uoGGefvs4pPvEW4XR5Dfkg5X6wvGNYFXaG8sqd8h
23078	payment	1397	1397	1678	1	1	9937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyK9fGUjZL2jMiYMu1PVqE9fndfyCZUzTbG2Xk4zPt75As4KR
23079	payment	2134	2134	1874	1	1	1007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvLCXoJ224kjCbPycZBhRdZ4wMNmc4ya2u76XXxYt4ctpyHsL
23080	payment	2133	2133	1874	1	1	1066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Sjx3TsWmoQZJZ59kCPUDuUH2HG18GGnsHm8MRP79FT1PHcBy
23084	payment	1397	1397	1678	1	1	9939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8G68aTQ1CoBsUd7RL9Tkb8FS2XNPbojTSsQxWswnwUW86hLvH
23085	payment	2134	2134	1874	1	1	1009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGC15Xhp3fWpF5AscK62J1xNnFjLijZ4pzoChesLAx7mFUzVg
23086	payment	2133	2133	1874	1	1	1068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD14EKDzpWGivMrmzTr36wA1ccXGT7Awv1Dr9XfPH71KoqrC8L
23093	payment	1397	1397	1678	1	1	9942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1oPGE2CWkBjtKi4HvNUCxoUfHw1jE1VHvnXJkhQxpgz6vdkW
23094	payment	1397	1397	1678	1	1	9943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1LARd5g3rLKTeob49Ch3zvjYLcp2Utw5ETu2nH3AjwgroRwq
23095	payment	2134	2134	1874	1	1	1012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rDaiV8Sgb7LVk2wekF8FwY1LzrsUW2g2V9b7Q3ZZ4jz4m7qD
23096	payment	2134	2134	1874	1	1	1013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwo2gsdwXJUpUFpm9QfzyFB4uCZxZ3wEETjQxrH4sQ2Wy8Lci
23097	payment	2133	2133	1874	1	1	1071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVyncjNBoKq5oKrEwRRcdaFnijscyWbdiSAKeN5XQPfxoTVqD
23098	payment	2133	2133	1874	1	1	1072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2ipQrJaLBa3EujtuxQixoHmP89i4i18XASHRk2N4mAK64waB
23099	payment	1397	1397	1678	1	1	9944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrxPYBP5S6ZXaShryGKFbBccYvCx8fe9bCDhB5qGNnZhpi6qWP
23100	payment	1397	1397	1678	1	1	9945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ421FGHefhcAFr5yBBY7FMS97mQWcjmrhwYKo8ByaJjyozSVFh
23101	payment	1397	1397	1678	1	1	9946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ywexf758pXAzd2f1o4b2PdoyK71UgYCE62boTGdnu8hdXHKt
23102	payment	2134	2134	1874	1	1	1014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWv96qgvnVpnpEnTbkDweyJXFCRPY2wB1YFeUxHR5LcPkLqPBZ
23103	payment	2134	2134	1874	1	1	1015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyL8EWYr8CNxRSR92UxMy344ZHmKo95ytS25JUNTVxdBy8vLn
23104	payment	2133	2133	1874	1	1	1073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkLooBefVQh2zGhG7nCiw7RJAx7zSuHKNUdJXpayQPdaLXnDz
23105	payment	2133	2133	1874	1	1	1074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLVG7LS6MMTuynhLKrH4N3ChtJUEMEobcS26veqAven69Dwzo
23106	payment	2134	2134	1874	1	1	1016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwZ5tdPePZwwRGtqH3dpKGWHJmNfY56xdfam2ruSSmZXRkpRF
23107	payment	2133	2133	1874	1	1	1075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4NX7A7NRY9TnT5yU3bHRSyiTidmRd5LJFmaxgNRxg4nBMANT
23117	payment	1397	1397	1678	1	1	9950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2mbqhD8KFWbLrXZxRP3hEZTd4Ecx31u8E4yoWwnFkDDdvGxQ
23119	payment	1397	1397	1678	1	1	9951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa381YtKLMEyBCSkaBsCkZNtfSD3VcPXD8gsgEKKPgojL2kek32
23120	payment	2133	2133	1874	1	1	1079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp88tTgSJs4Ym9wkNgTrZS1DWnYiA3LZU2X2LUFMN5ZGzFGXw8
23121	payment	2134	2134	1874	1	1	1021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhunG8sTjm7MF2ptTa1kn9xBJ6pZZWm1rAfpCcXuTRFqibHq8
23122	payment	1397	1397	1678	1	1	9952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ35vVRgqV5qDk1PPsEsaAgmSPkh1dKgDdePV3SPBVKHstFWXs
23123	payment	1397	1397	1678	1	1	9953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfXcK45fj6ezbUTqS7oW7sWLcqgZUuDV3BxAXmnxSD3A51HMR
23124	payment	1397	1397	1678	1	1	9954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3K67eo7S5TM8o5KAyUD2dQbgMTgSkotRh1mvmHJhPGzSjLvK
23125	payment	2133	2133	1874	1	1	1080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDujCLSKf75sgitnFjzo3wv7Mr6uGzFDmfHoWDiqmeSvY5N7c
23126	payment	2134	2134	1874	1	1	1022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYM7jQnBwHcEy564Fqrk4i1MQgJhirYpED7KG2paxVcQjoNp4W
23127	payment	2134	2134	1874	1	1	1023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLW4QiTgCCPMkgEtSGddnJx5eVxgbgC2QKEzFCqmKSVjos4JxH
23128	payment	2134	2134	1874	1	1	1024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWuMxRsCkEzWno1TubhLVBZjKkx4zkq5FXQkwp4ojEgAFEfvnh
23129	payment	2133	2133	1874	1	1	1081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtDWWEZ7VSNVJTMMz7PpqxMF8B3v8S4PFyuDUoR4EC6GYnMz6
23130	payment	2133	2133	1874	1	1	1082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgM2ZAPZyuzJFHJQsLVnmMimc65nhU3KGfp7ynDGNkqmsnxrA
23131	payment	1397	1397	1678	1	1	9955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpd6JxyKmDPuYUtVPY3zjeyoRUWaFe2ypVeXh5fLRWLYAroVHR
23132	payment	2134	2134	1874	1	1	1025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQa5UZLeUMbUWVLrWa2NFF3LFcTGMcKQUJocGWi9HBf4Tp1ED
23133	payment	2133	2133	1874	1	1	1083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHFTYmScj11LHcZfjdhpi3mfwCVzj4y3mamVh649242d84zWQJ
23134	payment	1397	1397	1678	1	1	9956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyf4pKGexrRpQi1riaizDcDrbb3vZU7bHMNrro6JqfvcG59Xqw
23135	payment	1397	1397	1678	1	1	9957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2wCjUBMRuJDrKv1QP95ZAZmS6BTsuTxAnYC1iAy2SGtVuGa4
23136	payment	1397	1397	1678	1	1	9958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj9yBtk8MLBLvdAt8F1AmHVBmbj5neghAygfcCV8fkYVAogsYt
23137	payment	1397	1397	1678	1	1	9959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSwHHLhJAVGmBbrLjJ2fBGUR5dPApSE2KhRZK1HYcMzD4gEfE
23138	payment	2134	2134	1874	1	1	1026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8coTC4U3ptp9afCZZAgS5QSPpuGNu8oonP4vTN7LPnNNcagFQ
23139	payment	2133	2133	1874	1	1	1084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4AnKBdTMovgcYGLzBQuzVQEb4XDzuxj2ZCvDCFgN4D4sz3zs
23140	payment	2134	2134	1874	1	1	1027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57EJPVU5QMrjL9McXgCBL1bw4ixMFTGprqoQsgUGrqBwzEjUw
23141	payment	2134	2134	1874	1	1	1028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6M4XKDfoS1sT6HRw6Bm29Bq27V2ZjTUcaxibvZwYH12L7u2m
23142	payment	2134	2134	1874	1	1	1029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KT7a8u9GzUo5qq5FTd1MZBkVoZNR6ptkwMZG2ZAZgLJGPFCa
23143	payment	2133	2133	1874	1	1	1085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB57rWB3hPQsVygAVdAvjvSTX9LvsX3JGVa9DHnznWGuQWDMX
23144	payment	2133	2133	1874	1	1	1086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEM1q9HdGSzmCfcE3b3tFq26Ef6DwZC3eL24x7vLYcNh4VunHz
23145	payment	2133	2133	1874	1	1	1087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnsC8TtszuF6k2gn5Y377quuSaLfTrGHAdzpoRs5R7bn9t1HX
23165	payment	1397	1397	1678	1	1	9966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMgs3V7z5uxdugN5sVXzPACZZzan9JVEuqX28XcSdddv3SCUi
23166	payment	2134	2134	1874	1	1	1036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjY2eqQrZGzhTr9Xjy9BhFxwEhpJ4Ld4Bi7D2t5ALKujRyPmtk
23167	payment	2133	2133	1874	1	1	1094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeEGoi3efGTw2G1TVSFX5RnaWXpEXB4rkhkvkBaUW84gGiYAC
23168	payment	1397	1397	1678	1	1	9967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr16RKzZEs1YR4KbugmNQ7dPgoHVgQPKfdBqsS7XAhy8fhaKMJ
23169	payment	2134	2134	1874	1	1	1037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumHHkZuzPiB3TMK757J9GPnWCJMwMYVauhvd85oqDNgigsx4c
23176	payment	1397	1397	1678	1	1	9970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLA3RNNJv9NTpskp6vH6hhLT7BYPePSP4FhoRkwS9bLYYtExG
23177	payment	2133	2133	1874	1	1	1097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUi63Lo4dXLYZeU7bUBcXB2n2vmdGFkhrB5SSrDq6GE7jS5oa
23178	payment	2134	2134	1874	1	1	1040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBqhv18tuEBBzrvLqtyWZssNuGqdQFBZLAYCtxV71cM2KJW4w
23179	payment	1397	1397	1678	1	1	9971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYbf4KbQ97d5SA4KzUxzjJLxXcJtB5Jr95VrgRiJiLhB1gWgp
23180	payment	2134	2134	1874	1	1	1041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyYoC5zMSEyD8TCD8XC1WDADF2zD6b6MZ797ANJuEhXKpcvNR
23189	payment	1397	1397	1678	1	1	9975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgivjJCPy2tzDyiTeAUNMSJcbUrNSBDjFtL3azxVNn5Ps9qxbu
23190	payment	2134	2134	1874	1	1	1045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qgDBWDyJ7f38mv7w1X9Lu7wNEwLQw2ioH2k3bEeTJ8PhJ5AM
23191	payment	2133	2133	1874	1	1	1100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUUN1URBnjJ3cz7rbmqim4PVS2WgKbH2Rd8rAFvkbdCgvXvrE
23199	payment	1397	1397	1678	1	1	9978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sxkvrgawDS8ZojbNizkDESQ8wkqhhRk6a1D4yUTgdvNCguFZ
23200	payment	2134	2134	1874	1	1	1048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Qz5i1jtPDwLNBdqSDrLByAYTr5H22zJomujcG9nVYJ2Ku2Nb
23201	payment	1866	1866	481	1	1	16	121703800914	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYSGnqpoHrf3yW7dCYJxVUks1JU1LzWzz1BfC9UX43V7YHaLhXB
23202	payment	1866	1866	734	1	1	17	3687993946	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZvRZXZTGegjtHPcadabzKnZAbjDxmGUhRPrxbp23hn4LTSXuHa
23203	payment	1866	1866	845	1	1	18	1057224937032	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpaAva5DWTLoBLkGFFwcYExPEtb2KRcZEWD8af1dN6XNBjGWAj3v
23204	payment	1866	1866	846	1	1	19	1057224937032	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZYEomMmokktPFGA7Jc8fjW92j5HX9jLRTvjQagZ7qVfZEa9g2f
23149	payment	1397	1397	1678	1	1	9961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpqQZ2tqg4iDNs3yiDyF1ciGij29zRkuf3VkfPRiMiPk3kd9R
23150	payment	1397	1397	1678	1	1	9962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQL1xhvwd1fDSa7b9VWJjEwpW2ubBUDXCGQwXDdb1Mx9AnbTf
23151	payment	2134	2134	1874	1	1	1031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5nDw6q9DB4EywcAayRAkDAwDiWL4FfpWqTPYj1MhLL9kdEFE
23152	payment	2133	2133	1874	1	1	1089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddgVwQEpbUJ5sFte4FBnzptjsoKoYixVFUcnQ4N57ad7DEKfD
23153	payment	2133	2133	1874	1	1	1090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDxAhutGPBHwDWeeZ6q3Q3y6q1Am1vwkyhcpBbHG75LM8urEt
23154	payment	2134	2134	1874	1	1	1032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXH2LmAcNrvRCbcbrtAcCixHp8hGpRYryKugiHRpCLeWZRrzc
23155	payment	1397	1397	1678	1	1	9963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrdtJtadStZixGZS9dQoSLFBLSw6RfNnvFVqe4tgsH1CMHrfP
23156	delegation	2135	2135	1505	1	1	0	\N	10000000	\N	E4YXR9keVZupY7MB5V3rXkjo3myt9igFm1RNovKdSHNdhee9YWBrk	CkpaDHiKvEUoUvmyfdptwEAvG35zEgxcMkK6DiKyM6y1HuG3Ju1J7
23157	payment	2133	2133	1874	1	1	1091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7gGBGieHmhN5NNGjT3N6YgqbbwGLRDkHkSGsWu9hPc6c831f
23158	payment	2134	2134	1874	1	1	1033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiQ4LZ3ZW7FUxxHvMUdL5N5po8evSUTvq6d3yM99yj37iASZv
23174	payment	1397	1397	1678	1	1	9969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxTBRJEhpjmUaS2SbVR18khFmrXJbJse4LhptzuCD5SMjn84X
23175	payment	2134	2134	1874	1	1	1039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPHMYMAar9tJaAmR4cvepYYf6eYpNgAsQ4kBxenQiQgM3bP7i
23187	payment	1397	1397	1678	1	1	9974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sLnu4h6wMTmhFeF4iMq5Gag6UsGnV8NwLz4E1jU43yqptvAm
23188	payment	2134	2134	1874	1	1	1044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSznBqXRnEUqMQUht2o6HMWyy5qxpgVZhmrVu3K754EZffsRu
23216	payment	2134	2134	1874	1	1	1050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQ4vYgs53MvPU3JSNC96TKXTK6RSWZkvPqdkX9dUrt7fwuonJ
23217	payment	2134	2134	1874	1	1	1051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYg31Gc8GK2AwGWkLaa9Qyib4W4QLmjM9zkNMkezyMie1ZaXn
23229	payment	1397	1397	1678	1	1	9985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZ5DRdBxeWkFzhxFnnAHXX3YMcq4mqq5bCKHCGBhTRZ8B1iZM
23230	payment	2134	2134	1874	1	1	1056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZs88D938ssFSvDpowGVt2VZSXPsoBb7rEC6ZE7soFPnSpNs6h
23231	payment	2133	2133	1874	1	1	1110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5dg25taESF9WDb7YqN3UDXpgA9yUxgx73PyWajsbW5xiVai8
23269	payment	1397	1397	1678	1	1	9999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbFGSdEpMJQZbRFQiM71oq3CvSLVKZPGt7Z5Jgedek7QPPHoK
23270	payment	1397	1397	1678	1	1	10000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZ6QY2PFJm2T8QntGhY6JjRp7DoytTy4ef1LhqGDsTNA9vS2i
23271	payment	2133	2133	1874	1	1	1122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMYDeamH6qzaxKdr4wgx1SWG4ZeRPxb38VxahirrwH4Tm2265
23272	payment	2134	2134	1874	1	1	1070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzFhe1Ap5WPV46BKDvNFvBrktsvNqCmAWaddPWWYw4Xqy2GRE
23273	payment	2134	2134	1874	1	1	1071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimkoWyVqUtzeGNhtwj1cybeq2BBP3rYfWsH5m9oSd7EhCCCmz
23274	payment	1397	1397	1678	1	1	10001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULCV3J7b1tLgun138R7MuYKPJwrbD9Kc4f5891LtUou2MYfNm
23275	payment	1397	1397	1678	1	1	10002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BtksHNTp3EDyivyBQE22ZXrmPgauJXSCVqSB7SQ3PJogLeKj
23276	payment	2133	2133	1874	1	1	1123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRi9dacDUaoKE2tpT6dWuomCtFVrWVpocZyW324a59uxGfHjM
23277	payment	2133	2133	1874	1	1	1124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYhY3uqbrqSeprbfeRtLo3oCrmUBPo6nrjzLy9MvJMMDcvVKS6
23278	payment	2134	2134	1874	1	1	1072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZEwHYY11NMUB14H6rTnmfCcA8NdRVviab36BD7ZPrggqjsgy
23279	payment	2134	2134	1874	1	1	1073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUabqhPV6he8cwAf8kR2ardauGdkYhNVMRSMc31CvZNiNo11J
23297	payment	1397	1397	1678	1	1	10009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmTvQx8uFrYMUjKT7u5TaphQiqvV2ANEKXNrN8juZG8yBS7rJ
23298	payment	1397	1397	1678	1	1	10010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKK9mmLYPfqJoa87kaLpxgbyKsffJzoayUrR6fSeHgFtxpvFtS
23299	payment	1397	1397	1678	1	1	10011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eUEwo75aRHduvxtuAHPQosTMq9u2kqfjjjP2KFZEyAYFE3ty
23300	payment	2134	2134	1874	1	1	1080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPoMXqiy7Zx6R1cVExWCp3gVScANtux7eTSRJUjzdC56dccYK
23301	payment	2133	2133	1874	1	1	1130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxAhqs6oRiout2mJFdDJB7iU6SD5WcUYbX3zee169FJetdRp4
23302	payment	2133	2133	1874	1	1	1131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgSe5goaVmzMeYkirxXvbHwcTSNqU5Sa1xG9cJyWoJDmsvzUL
23303	payment	2134	2134	1874	1	1	1081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZap8tPFQ9nSzaSwGTts62XkcGhqn9SXMSPGa8VeWxReTvfANjE
23304	payment	2134	2134	1874	1	1	1082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcQypUKXiRJPUz5Nu2ny5JrKmU8Hg6U71BWckV16VEvFmZ1sF
23205	payment	1866	1866	936	1	1	20	978516909538	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZxKNNdtJpAV5ikWTvEKy2X298R7cCGhYo7x61tETC2QBr2F7Ko
23206	payment	1866	1866	1056	1	1	21	1753493917952	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYhLSxtwjaDmgVRRrsKMAyKotTWXkoMphY5XdrCZHnqe6Lqc4MT
23207	payment	1866	1866	1176	1	1	22	1183117287282	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYRW1HqQ6FkPLHGb97i1XVTvJQvxvemUL7H9yug8oEdkbobJ3Z2
23208	payment	1866	1866	1302	1	1	23	3296861517936	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZouW7mMAmnUFAZ7ErnZUeyRSe2R7DREw8bbmHFcrsm9SLjBS36
23209	payment	1397	1397	1678	1	1	9979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFJmUXHtcRKvyzMtHHo6cXJA661Vbp4FhckpnmjhcX6ErZfEo
23210	payment	2133	2133	1874	1	1	1103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8VWc25MTARgQ2rbeqzr76v4gyNptJC49uT84tNYCLtQ9kdgo
23211	payment	2134	2134	1874	1	1	1049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ485AbRrehUoPcrwskMXXSufV2jBRSxYQFhi1UxH6CXZ3FMtLM
23218	payment	2133	2133	1874	1	1	1106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjw64oPoHnE2MoD8pMCEhb9UwmFLwQoybQCCWYQnUiA7Pvch8
23232	payment	1397	1397	1678	1	1	9986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdx9pkhU4C9wKiH45QujjyaDRp9YubUfLKmKwHDvPLn4cUw2XT
23233	payment	2134	2134	1874	1	1	1057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxUztBzkTv7XikEPa8dA95k2eKmdM2AZwjgSj7suJ2DAiaYDY
23234	payment	2133	2133	1874	1	1	1111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXmk2nfSpnCzgA4hvS4GUhjXZejir54qLC6zfLvvcS43JY5a5
23241	payment	1397	1397	1678	1	1	9989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLhaxNg5ciTvVUfzcB4nVpEbFdTANuMjFyMdMyUuE7ya27nJt
23242	payment	2134	2134	1874	1	1	1060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkS4mSJrPGSnCTNzHAqE24okSzGeXk3rNSa6or1XSpTXrcwfy
23243	payment	2133	2133	1874	1	1	1114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDGa62TrvNMDG34vuTesLGBoQ5V9jsPWCnET1PwrSQC894n1o
23252	payment	1397	1397	1678	1	1	9993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8L7KHMzGsLKHs7AGaYCPQL2h91JwzhfaLy8ZPk3spVbEedDZ
23253	payment	2134	2134	1874	1	1	1064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19ZDxzdD87UKYFFWqgHo4NuJwNEmu8PCZUaGtD3mKbBY1nqR3
23263	payment	1397	1397	1678	1	1	9997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sFZn5tMMt34YMxzHRTNwDBnz1gcPrAiACGbVnTmBrht8nnoj
23264	payment	2134	2134	1874	1	1	1068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKuGPsAkGSbuqDtw17k1GSpLZhjTdYKiF9i95MMWsQiknKSAV
23265	payment	2133	2133	1874	1	1	1120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrq2eswvuEKbkh6Uov4TdVwsUJazj2bbLSGPapHCzttorUZEY
23285	payment	1397	1397	1678	1	1	10005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAqkc1RD7tE3qFSMJqMRy4oVjkaFRXm7dYkUHFBWXXnabzRue
23286	payment	2133	2133	1874	1	1	1126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFZkKRwPH54YFaXYoHvqamcAvGjt2FgqqcjKLh796Z6f7MNai
23287	payment	2134	2134	1874	1	1	1076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ9hdVkxbBDCpL5wqQvkDER71KCY8NG1wp3sPVPTjq4sUYd2cE
23315	payment	1397	1397	1678	1	1	10015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GVN5Zd7jp1bhNn6K7EdEUG1U88HWUR4i23zcm9sxSGHS9tS9
23316	payment	2133	2133	1874	1	1	1135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SPUKSt54spyCPW9Axe45nnbAL7rEqcxqGm2fQuwXcgfj2RuP
23332	payment	1397	1397	1678	1	1	10021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DNXuHqCcKZMgEzDZTdna7m5qVN4oEXX1rKKA1chsxaLT7shV
23333	payment	1397	1397	1678	1	1	10022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCEumpukiocbube6azBKgi1fyxfRT5L4sNufGLGMN7Zw3eBje
23334	payment	850	850	849	1	1	0	5000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2EroXi3EsosAqPh3SYfGHjfVPrFmE6pE5GyUSL53bWto74seV
23335	payment	2133	2133	1874	1	1	1141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ8BS8qkXCcKBLcL11dLe4JA28TkEHQj5LTYaFF5kE57RJqU8
23336	payment	2133	2133	1874	1	1	1142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwm8ZArUYbotFhNHDZpkapfN9k2mXXiqP5JrUUKa2ubzhRxfh
23337	payment	2134	2134	1874	1	1	1091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEscAMEcra2DA83PGMGD5ZiuHJRXbTtxZa96m86ZHTPUmHzn8s
23338	payment	2134	2134	1874	1	1	1092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmov5Gf5BE4XxRNPbnvjkrMG9BYhoZFuTMvU13BS68fCeuCpWj
23367	payment	1397	1397	1678	1	1	10032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99Ed6GF9Siwjonavvv43tNWuoJsU5yLGZJd3AWEannDhq6QG9
23368	payment	2133	2133	1874	1	1	1152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1NwrvTxgdus8kJ2kqVh8VJEfNdD5isfZhtmDcc2UrzQzgrZS
23369	payment	2134	2134	1874	1	1	1103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQo5HR7f792aFV6UMXvoNdYyi7ygVFFFgEU9R9YeupZZ6SGWe
23392	payment	2133	2133	1874	1	1	1160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXkh3LX4myLJAVFL3gxyZrKqi3vmD3toBKqeVNFz8oWQGiPKx
23393	payment	2134	2134	1874	1	1	1112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aZddVZnkYePWnFTRMrnBv1YGWq7jetSdqdTQppkV27sh4Pxk
23417	payment	1397	1397	1678	1	1	10045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEAAttZ6mCYZ3Ykp2RLJGnuo6KTs1F5a18UnVGZ9B8PLQSdaU
23418	payment	2134	2134	1874	1	1	1120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVc6TgPZvE76hMR9moVjuzbgdEs7uUVTue9Jbeg5LxJ2cX8hWv
23212	payment	1397	1397	1678	1	1	9980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYozdmVbLtac6nFZmzSaqjrq7PbXr7WEhNJyw3b2tQTCPeVZhR
23213	payment	1397	1397	1678	1	1	9981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvjVPTGkZ6nc92hwoJQFtGdhYKtKESjsuQqk17Z54qmg9Ma8D
23214	payment	2133	2133	1874	1	1	1104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEY5SNWUfSGLkX4g3xgjsR29BKYFVZNan7qeYZEpnJduFf6vD1
23215	payment	2133	2133	1874	1	1	1105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoysWEE7wykfxaCFWbR7Snkq5Kw9LYTTbsud4Q16DphrvdyW4N
23226	payment	1397	1397	1678	1	1	9984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9Giv6Jmpc5TfdvZjaWGrAeCC1F4HiezcU28P9EiQc3N3VQAC
23227	payment	2134	2134	1874	1	1	1055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBmEcX8Xyhxco2dRReyxPaRWDQULjdf2KAT1jjPhBQF3wq5dr
23228	payment	2133	2133	1874	1	1	1109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23U1qnVi1PrQfZABNdTAABTFRL3SMeVy2vBDFUVeoM8aZKhea
23238	payment	1397	1397	1678	1	1	9988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgfMjocVuZg3aq5Mfcmt6hAXDAwsuW7vFXguvyH6GfXxw7y9u
23239	payment	2134	2134	1874	1	1	1059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMtEMF4rQG77DAYSq4PxkzqNQukaqzKoXUn2sddho7kBgzH72
23240	payment	2133	2133	1874	1	1	1113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBBXE2pcb11wHSLphRWR8caZocY1FQsERarsXJFkpb2hKWM8p
23247	payment	1397	1397	1678	1	1	9991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCbdKmChVeCPBcXWxJ4Um6VY98tqUCUrhiDQaMBtNsA4sgydg
23248	payment	2134	2134	1874	1	1	1062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjqFCD7DhphWEiYrG7asM3huA5GbczwMkwgejPNgGctkeNXRP
23254	payment	1397	1397	1678	1	1	9994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgFziqheTJC1UJd74KJiGfLQjqSgPmLsV8fai9M6kwKywyyg7
23255	payment	1397	1397	1678	1	1	9995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3WYeKEuVMH52x18tivrKMn7pqxYMr3D8izqrJhHXLqSaXndf
23256	payment	1397	1397	1678	1	1	9996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamE9mKbvSGWtUD5RSbJkWMGQqSeCsBGHWuYuZFwHfww8DB2nU
23257	payment	2134	2134	1874	1	1	1065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkN45eVDHWvF9TWrovmAeivFMbz7SRygNU4rN6ezQVt1kKhVgF
23258	payment	2134	2134	1874	1	1	1066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUT7kpeGA9q4NHArTYemDvNz8SFAHodCohchwgsKYNaChJH2sz
23259	payment	2134	2134	1874	1	1	1067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV32wbqR2iFcsKarLjUyV4dD6qgpWX1n2UyhiieyqtHqaERic
23260	payment	2133	2133	1874	1	1	1117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6i3M2MTAnEkkUrpqGCCX9EYYRLyU7biuUu29YeW9imfDcHHo
23261	payment	2133	2133	1874	1	1	1118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwwG4cztjHs8y6Tf2s93bCvGAtD1hK5kuyQmCgKNoz9wY3jsA
23262	payment	2133	2133	1874	1	1	1119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G12PypC9UZB8DPphzRATBqxZArj2i41Q5HM2bidEWCJX1YFg
23288	payment	1397	1397	1678	1	1	10006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YrPUHvX9gmQgDuuS2yfLRhtDmbXVLGLYcDEw5HzGcv4N92EB
23289	payment	2133	2133	1874	1	1	1127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCGgSQqyN1qNkNuxy4y9gedyLHpHEU2DhqvcB7kYE6trNvjYE
23290	payment	2134	2134	1874	1	1	1077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4d165Qdon7pyTbiXMfJxEMv7426R3tF7YfxkNXopFadGxZBh
23305	payment	1397	1397	1678	1	1	10012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yQPc9qijxHgPAU41vbqjBbA5sMqRkV7GhiPCYnsUaKiHESdR
23306	payment	1397	1397	1678	1	1	10013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYZQbi8nLSy7LqZjYa6qz8uX7dpHQCB1WuBRD8ig51HRygQMS
23307	payment	2134	2134	1874	1	1	1083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQiL59bNwpjhBrZtonjUt1sMCpfPBHG9AH4gpYX2NmY7piw1V
23308	payment	2134	2134	1874	1	1	1084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzxnRQ4kaX6Gg4jhvDZMiCurTv9tLyY1z3rd4RfBsMfaSr9tq
23309	payment	2133	2133	1874	1	1	1132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjWjg5SgkEXrQ64ZDpkMVM9GBMvciMHMxUNnjYPvU9tX8Eyzj
23310	payment	2133	2133	1874	1	1	1133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGX7mD2PjFpA4MctBJUDLSf7uFR2SwKe5qHR7h9Mq91xRQnnXu
23311	payment	1397	1397	1678	1	1	10014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRebf4tfG1BoxJNydwtvY8SEiDGCdQprne76r7NvhEaWuf6pV
23312	payment	2134	2134	1874	1	1	1085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmtYJtskS9G42znxJDGW1kEwQtZPbvSkypywyaJdB7zJ2AuHH
23313	payment	2133	2133	1874	1	1	1134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvSCJ6PEsiRQspYz3Sn65bPC7ibo2WeKuySduJ91L7k7m1phM
23339	payment	2134	2134	1874	1	1	1093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1fHLP5NDe8UiBYwiRb534rMqQ69q1ssZEJi3svEh7ewFRoUo
23345	payment	1397	1397	1678	1	1	10025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhy5FUvXxEjgYAwERm5pWi8DxHiPxPRnDNzKGWakE5xz6wFaW
23346	payment	2134	2134	1874	1	1	1095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZGQ5FUHp8kSdmQhvKFQdttLSig4eq3bVdVMcVTrz9A3qYheK
23370	payment	1397	1397	1678	1	1	10033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5sGf47nx86ZEA2PdR7v1owSZsSNywHZ16qKhAdm5vGSkVLFa
23371	payment	2133	2133	1874	1	1	1153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkD8mnaihbwodFFCtesALadyuNJQgnbWk7YiqQrJ8o8Cx15dJ
23220	payment	1397	1397	1678	1	1	9983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYony7ewY9VpWtcNELNqjFpeQ1uGctbwSz76dLGnu7WQRK4c88V
23221	payment	2133	2133	1874	1	1	1107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9rZqwKG6PdTSEAUTgdkVR9pPKRha2Wp7JUjm1jN46iqVVBDS
23222	payment	2133	2133	1874	1	1	1108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVexE4A62QkCGyBbPiKoPjomWqi1QhGcEatFUb8bsFHWKjG7N
23223	payment	2134	2134	1874	1	1	1052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMv5LDtCZJLYTcZ4tE5UMJUf3vmoYHiEkS6kKUhySuS6ZapCr
23224	payment	2134	2134	1874	1	1	1053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5QmHjvTZj9pWGJk18pJwcEsLGWmDCwCAGtWbhprCqfqzykrs
23225	payment	2134	2134	1874	1	1	1054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt19VUTmoiwaQf5YX5uPiTNhTxZz3JcNiCXoBTDV8iFNZ5Cecg
23235	payment	1397	1397	1678	1	1	9987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfD5T2amy6XFXyi4MmiXjW7j1GsHLGbym9VV5HZo8DCHy2XtyM
23236	payment	2133	2133	1874	1	1	1112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mAccX6SY7mkToxy82RLHTW8vsdtQjC8dgHM39Q6NpFae1AeD
23237	payment	2134	2134	1874	1	1	1058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAnGU5v2zsargaepYfdh1ta9hYogacyfT9L8SovgDrerbH3Zk
23244	payment	1397	1397	1678	1	1	9990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTte8Mvjny8AR8mWJLRKp9fKNRX4GDa8FXZQ5uUX2WjvWWu1HT
23245	payment	2134	2134	1874	1	1	1061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXBn5EHkKwqPqiukwwH2ytZ1EwSMLjohPqBYAF4gZgzTEC2wb
23246	payment	2133	2133	1874	1	1	1115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TndNzMZpXfap6QTsbQGpiG1tYdx8jMShw8GxdTW4q3Wb3pUf
23249	payment	1397	1397	1678	1	1	9992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLayvE6GhSNT5GZhGTf1yLYeuiqk75yzyH7TL1ydHsTqkPXz1
23250	payment	2134	2134	1874	1	1	1063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3nyd3ShcMWtc2fwwemS7stC3uXNZTJPPpymHCPnVDiNqyJEp
23251	payment	2133	2133	1874	1	1	1116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv68ciHZxp88sRsFJc7jXQE5eUFfxsc6u5jP33V3SuS7FxMn85
23266	payment	1397	1397	1678	1	1	9998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNkaaoJCqpAAcKiwxMyhTFgAUi8cCXsLwgqDo5ssQ6Asw1F21
23267	payment	2134	2134	1874	1	1	1069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMUxXfe3GZe8h6nXt3E1mxSBF8c5Jbvi5bgDwNfJ8wGbr3vZ8
23268	payment	2133	2133	1874	1	1	1121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51gxiqQs4UmAEKMdjmr66vtxtVuDnBmi81zVtdQj58DGc6tVp
23280	payment	1397	1397	1678	1	1	10003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbk9ixp1XzSNZg668kXv2jY8f727HTnJ4S4vpMXxthc9GYu3s
23281	payment	2134	2134	1874	1	1	1074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawVvtk6AmLX7FeovY2cZtfPjMb72BKi6BbwNszDy2NSHbbdne
23282	payment	1397	1397	1678	1	1	10004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupvztLTcE6VhXCDpgZUUQdtGVQagVZ7zFkBz4e5UZVCWCZTXr
23283	payment	2134	2134	1874	1	1	1075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8Qey21rw4HkJPJ6Bhmyz4VDSjfa3pQyYaifHzGpYDu1hD1je
23284	payment	2133	2133	1874	1	1	1125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFjdHvXUYkBZdeeC1KJfncVSEzLdExhmx3riqhLjrXBHXFhzE
23291	payment	1397	1397	1678	1	1	10007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwP3RicixGRZJPqKwFx5eaFWxHXS2kY1Gpz6HuF1jHmFHpw8ws
23292	payment	1397	1397	1678	1	1	10008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN56hswTD5iN2oKRwUghgAEgzHM4qPfdUk8x1Ed18v7K2G7yv1
23293	payment	2134	2134	1874	1	1	1078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGRDA4dGmGK9GtfYjDZypxDaAHroKgNbZTPthTq2xeiSVJqNj
23294	payment	2134	2134	1874	1	1	1079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S6AndaJyoThB8CZFwgpJoWVNV2Fopdu8MUJBrRSY6H5viZwU
23295	payment	2133	2133	1874	1	1	1128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6oNc5K1vHqLuH57RCWtuQ1TU9hro2SFUKche2EggHtJXMPxe
23296	payment	2133	2133	1874	1	1	1129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPquL44NcdZrazZLSa6Tqzna9bRtiZ6tjPTtLN4zVrwr2tYmY
23314	payment	2134	2134	1874	1	1	1086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5893ZQp5Mh9U58WU3owHVCmXW1iisVUzdizWEdyY2vKBZm6n1
23329	payment	2134	2134	1874	1	1	1088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3C5xkqvBqJLhxrG2AVVUTHXCdbftomBE6MACPwxbKHhLKCq5
23330	payment	2134	2134	1874	1	1	1089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtdBpXnZW8ai7rrAAEUSxBxLR2nWafT3iDgCZfmkF9mDs9R2z
23331	payment	2134	2134	1874	1	1	1090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXLjoD133xTufrbFUaje6TqukNJ5qS9J4xm5oDsbjxPkDmi4J
23340	payment	1397	1397	1678	1	1	10023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9KUP7XMSjUZW4T3c27fc5b9UjYY3NesczGYdCNxX5m2gaDKS
23341	payment	1397	1397	1678	1	1	10024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBZbKdZvKsguLTyhjMMJVf5KEKPk9EHEztoAmBYb3sf9DQf9mj
23342	payment	2133	2133	1874	1	1	1143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZRESAsTXrvjsJgkj2BEp1zEzP11oCoJtemc37LsqxCjvkdSR
23343	payment	2133	2133	1874	1	1	1144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRRkAGzfgPqMR9C59v1AjCV8Ky8JD5jVMjiMkGcwKprUCrZ9kx
23344	payment	2134	2134	1874	1	1	1094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84HEdjXeFE3dnswqj8DpPEgHHYKcMkdwTMbpEoBRDo6o3Q7V3
23317	payment	1397	1397	1678	1	1	10016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuupa28giYy4dViwr3H9XNPk7Z8w3oaUnQJWLxiMCNHj8FeHkh
23318	payment	2133	2133	1874	1	1	1136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTH1PNLAJEARheyA9w1wvz3abfNHGPnJrRzaMSJTbCgdkuim7x
23319	payment	2134	2134	1874	1	1	1087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsPcmkTA9rTU2KU4F94RVyyWJJoKBadUWCtrwu3zp5dpkKyyd
23320	payment	1397	1397	1678	1	1	10017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJwhoAf41mLB9BrRuWjkPs2kLc31Ujq5gwyH7bG6vB5BiikK3
23321	payment	1397	1397	1678	1	1	10018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmb51HjmpMXH2org9nJudaXphAo428xXnYPCYGPDLhKAd34kP
23322	payment	1397	1397	1678	1	1	10019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pMZ9rwexFJhKChRQD1sw7wczjR3sLpXTC4CYQM48YB1CNo5e
23323	payment	1397	1397	1678	1	1	10020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBD41aiChf3Zd44XHsYsWPNhXGKj4UvYSGyAP1nHRy3fd1xkG
23324	payment	1598	1598	2163	1	1	2	1200000000000	8000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfuoguwukNervGSBozKGyuwqGDmKmiZ55j81yvneNhkupDJEx
23325	payment	2133	2133	1874	1	1	1137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVbP8EDLVhiKmvfzu2WiM73QEnzbaw3N12rQznKubW4bkewXS
23326	payment	2133	2133	1874	1	1	1138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9L2WMnHDQcMgZsFZbe7hFpfghrpAMPuEodJxqTyqppUKxTq1
23327	payment	2133	2133	1874	1	1	1139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnELgyhWDuncEFsRf2QBa6S2XUzkb9VPkUa5ypBxfRwrKukjn
23328	payment	2133	2133	1874	1	1	1140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYmuqMpamKd83JUC9LuJgroFFzmrjNxKyyT5wMDRNNGYjkDQx
23365	payment	2133	2133	1874	1	1	1151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1W9aSGuo6fLSspH7cfJw3mkj8pghNJUBjWe2dabe9TBaSBX5
23366	payment	2134	2134	1874	1	1	1102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8HMb3omHwsyZtxrcwJefbFiF3RaBmBpvV4rqGhsFEegDCP9j
23382	payment	1397	1397	1678	1	1	10037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAe29Q6Gwq6Gnf1hbHkoctfQ1taJprg5wV2oMPoxhAZ8JvRV7
23383	payment	1397	1397	1678	1	1	10038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWnig9QfaXmzup9fa7nHgFtRjn2pniFj8TyYNWouupibu92ka
23384	payment	2134	2134	1874	1	1	1108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcntLmkNNKXhnCSHidy2GPxNkpE4EnMPqLqYzy7UGhW4q5yid
23385	payment	2134	2134	1874	1	1	1109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4YCTD3PPhhe6n9NyX4iT9tboZkgETTwciCcpuGgbTLCnu2cX
23386	payment	2133	2133	1874	1	1	1157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiwHAQYh1KyddM6GqnUs6gBHdSCbRPVwqUvTAL234E1BMrt6u
23394	payment	1756	1756	1516	1	1	3	1298566290000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe4f1LKPVaZNKYjcfr1cdzGzp9b6w9HT6Cz7UAa5WpNE7aMkt2
23395	payment	2134	2134	1874	1	1	1113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4DdbqDd5BjFGYF9ndE7td2wYJCJJjPYZwFgU4w8rxvLKsAxZ
23396	payment	2133	2133	1874	1	1	1161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32urerPAoyTuyNhbDKVBmXdS2RwocimKsDZUc8SX1DNnC63fA
23422	payment	1397	1397	1678	1	1	10047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVw1F9CEu98RpfR4Waji72tQP7bcDghCCrDe12sAMuRXY9mwL
23423	payment	1756	1756	1516	1	1	4	176152740000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6WhLJoToGcFNVv74hAEMo3K7dcK6Vsc8v1rkGxzBpCm9xCDix
23424	payment	2134	2134	1874	1	1	1122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFc7kSq6oM72Cg5o6a3H4g41au9nqQLzf7it3RqDPBRhaSCyA
23425	payment	2133	2133	1874	1	1	1168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbtAe7nQL2K6G85TSBcrR9JtXg7Rm594Fugqh2bhvfWsbKRG5
23426	payment	1397	1397	1678	1	1	10048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvErrL9TcU1QGNrSRP5RiND7GDFYaHiCeGzpxaAPhqt3vrThZ5
23427	payment	2134	2134	1874	1	1	1123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgonxF1CjejGbuspLghiAs1jARYjqwqsJK6DoVBPUG7cmu2YrQ
23428	payment	2133	2133	1874	1	1	1169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYucnB9zV3hh2hdEo4u55iEPPXb3Kr7kkRx8h3V8vaf5tLgksJD
23446	payment	1397	1397	1678	1	1	10055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVock6fxsums1zwhJc7vGeMGZCKFTMTBcX5wJ4wQMTXguFt19
23447	payment	2134	2134	1874	1	1	1130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5bmU13Z1Atau6KEvtq3mbLpomiTXnW66YJNVf93kN2evkfXo
23472	payment	1397	1397	1678	1	1	10059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLzy76ygT9hdewRintHZyzPWPdonCiBq71tS24ppudHv6fzFZ
23473	payment	1693	1693	91	1	1	787	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZtfK3PBgHV3TNR22T5JTG6t7Th78phTP8JdEca8DzFCsnvVa3f
23474	payment	1693	1693	438	1	1	788	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYaaBoZUa2kBvMBNuecicLnEXRhepFnh1ygv7tKRpoFCubpjNmF
23475	payment	1693	1693	593	1	1	789	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYZMrGqSUdVzGre2F2L7DK2LditE5LGznsvpJHKBV4Jwnjocax3
23476	payment	1693	1693	408	1	1	790	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYfrzqbUYLKwMoMJmp6vkRkcCZvvRdoeW8eJr4MNbM1fJvuj9iw
23477	payment	1693	1693	601	1	1	791	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZHYapST4yjSmnggfGz2BLa7rKa6CmiQb48QeqwJravFgtGEftw
23478	payment	2133	2133	1874	1	1	1176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s4QBXTNLo1VGK5rvQmpZiFSvcNJj43K58nwKJA9Q3hpmP6LW
23347	payment	1397	1397	1678	1	1	10026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGfR49hDhD6N3QSojC7uCCtAjqMi8LaJKnnHrdKso57bYy3VSJ
23348	payment	1397	1397	1678	1	1	10027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhvodtEtQP4YTf8ePPKqqURqsGGbhYZ6hiYNaMMUzHt4xG7gH
23349	payment	1397	1397	1678	1	1	10028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoTjBdaHGffmY7uhk7FUvGePXtn8nNULZpvPWwdzcXrkFhs7g
23350	payment	2133	2133	1874	1	1	1145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYtVNWxHs7xN9Hjw4TVbzDsmWPKd8oGtpdRF4YgvDsQNGFV3Q
23351	payment	2134	2134	1874	1	1	1096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkPSPiMV4FPq1P4gPg88RitW3FWNkRXbDop1E2Y6TtAviuQcVh
23352	payment	2134	2134	1874	1	1	1097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAX8d8KGMTnq3qHTXRmEikqwgqbP5dzsww8FN8HmFrASU1mYN6
23353	payment	2134	2134	1874	1	1	1098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMg1ov6vpWXwhox5upiRS5ZF679rXQgj4dZDtDLRu9ZnVDEyo
23354	payment	2133	2133	1874	1	1	1146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpThMGAx69ktMEepXbZT2DNJvxRgrEWbAEpWL1Prhoe5KAGWRh
23355	payment	2133	2133	1874	1	1	1147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF8Fkd2DJJpx3qcLrvaWYnNkJdPf34FnNbgJWMjRHhzkTbXp4m
23356	payment	1397	1397	1678	1	1	10029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMVX2ZKJfChZht9Gc9qY1JjUVSgGLz68STE2wtKb4h2KVQc2B
23357	payment	1397	1397	1678	1	1	10030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhftYhggCe8au49gn3JTnnBiYgewRUy8jdHWKN3FRm8UEqE6Cp
23358	payment	1397	1397	1678	1	1	10031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzhhHnVTSJqJFbEaGBeM9iTzPM5ffE3QSN4n5Hwu1bMAVJFvb4
23359	payment	2133	2133	1874	1	1	1148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSYwT9fB9JW1BJX4ak33CNsKuebdMcUHMMFXGGxWWbQGGxwco
23360	payment	2133	2133	1874	1	1	1149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpgpLVByZYpjTuN4Q2UWR3E6nrfABWQ6MG9VeGFX1jfpQ7NQC
23361	payment	2134	2134	1874	1	1	1099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbRS1CAsRTB5WgBzsdQrHCWVuMphSq7tTMYcSoU41FdtikuZs
23362	payment	2134	2134	1874	1	1	1100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrLvi9UU9r64to4i6ejKKbRvcWZngatwAciFAKfUNVubpiER3
23363	payment	2134	2134	1874	1	1	1101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQzhjTKN7GYJNZzardnesVurJyAMGLzkBisFnfPynYEoEX5FG
23364	payment	2133	2133	1874	1	1	1150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuXwPdW5mRpGdtY9272RVPZkST1Et9HoRqud9UQZkTyZw6BCK
23373	payment	1397	1397	1678	1	1	10034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRZJ9eBnW8dokguHVC4vAURgqgpQg2Kqf8AAiVfTW8kTVPru9
23374	payment	2133	2133	1874	1	1	1154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVrpfh5rGUWSfjBmTqBfe9NzREKFAkNqXWkURKvdEHZbHoFF1
23375	payment	2134	2134	1874	1	1	1105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9hHLNVCauYba44NVUPDY89iQ5wubpL7L4tVwvMsitoEgnG7e
23387	payment	1397	1397	1678	1	1	10039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj2sjPxvU7zRCem7JwGdQfuSwbP5jaVnELCx1tGArht2qvHWN
23388	payment	2133	2133	1874	1	1	1158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEzafSwf3TenodmJzvBZz82ZLofdDrgGifmV4rsXLWWwVzduU
23389	payment	2134	2134	1874	1	1	1110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXtnA7KX18j1NKUth4tBETGePRqEX5Ve2GERPpG6fz5tgfg53
23397	payment	2133	2133	1874	1	1	1162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJrywuwbaTjfqrJRYLpjupZG2drhfJebq3TW6yeXMCEaWTh4R
23398	payment	2134	2134	1874	1	1	1114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzPFjSqrScaptTetS2x9bShiuW7h7GEHfdWpgLsQYrNzvQb5s
23405	payment	1516	1516	928	1	1	7	176152740000	100000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpZoDH23uHWqAaCPF9HobftVrwJB14rKvJGS9kS1KahcTAYfWzNy
23406	payment	1516	1516	928	1	1	8	176152740000	100000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpZPjsojYGnfreKtcp1dUn6TFJTDPfq2Jbs97LasywVnWdZXiYgb
23407	payment	1397	1397	1678	1	1	10042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB21TquzES4HRRMHEkTHpokPJfynfSJS2MpsX388LMqwftE1hB
23408	payment	2134	2134	1874	1	1	1117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N6G7B3VyVAyKwiBPdoDhHfmFSNNzMys3ikdQtJc2296e9LVm
23419	payment	1397	1397	1678	1	1	10046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkfo5G6f8gpd9XGu3Bu5sSd2F5rkWc5Z5M3RQFbhQy5EJqCxy
23420	payment	2133	2133	1874	1	1	1167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSAR3nzaT98GgLWyEUxkyHCYaDNudqSK2rNeNjE2t2bn3peFo
23421	payment	2134	2134	1874	1	1	1121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ9uHeTXwMusx2ZusJyPirnXfY3Q4dwyWADQKQAhGV1U77r62
23432	payment	1397	1397	1678	1	1	10050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78HyUtr1a6fpa88MoUQnjWc8PC2BLDayEHwB26HwTwdyfLSmA
23433	payment	1397	1397	1678	1	1	10051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGXD8gAykuQJsCnGdSbWULDf4wXdhX1NDNHHPCpUXxrnsnRD4R
23434	payment	2133	2133	1874	1	1	1170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfavwNjHnZf6FhDwpLy4FztqkaEZrZFyPA1CeszqSspx4huk4p
23435	payment	2133	2133	1874	1	1	1171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvapXobjJkNNAKtNec6wfQg3sAP1a6hEVb5PAJESpZf2A3Ap7i
23436	payment	2134	2134	1874	1	1	1125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZio6UfwnKgvmMdqRPXjhssj6jNtRLmFq7xjUb2ts5KZGnDZz9R
23372	payment	2134	2134	1874	1	1	1104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHskWpDhmDyCuRug61ETcLxdJwFfUNGUmdmSUU1sG4GbxrMjUB
23376	payment	1397	1397	1678	1	1	10035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDMY23hE49aegGuUWCBLM2hTjGeA3w1iCJuSryNqvPjAAHM4k
23377	payment	1397	1397	1678	1	1	10036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYBHzdL5qujSReFgYQwZWB2EJrbGys8SCLcA7gCVCsXMjq1cQ
23378	payment	2133	2133	1874	1	1	1155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpXzKi2HJ9PY4XsjvTcUVbHF5rj35XGw8xnE6Cgd4bqbX4Aav
23379	payment	2133	2133	1874	1	1	1156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaLvqp1VwhX63B62YvUfwGWQnZz37hVr59fTXGU9Z1SJNLpmTA
23380	payment	2134	2134	1874	1	1	1106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzGnnhB2apnhsekC6iRRuAm3b8QM1hXNdXvFst7WXVBbStbWx
23381	payment	2134	2134	1874	1	1	1107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZJDajc9WaNvjNvB2hErjgHeQvobZX26KCXqEj58CofoQ6RTW
23390	payment	2134	2134	1874	1	1	1111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9NL2xTWekJbdwRBfqeLqT1pgnQntna9ZyeQWigboNH7JbWSC
23391	payment	2133	2133	1874	1	1	1159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MwEVVASN1oy6S3aQLXz5CpM4qWz37m3fxwepVDXhYLeDKc9X
23399	payment	1397	1397	1678	1	1	10040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5zAdHwnWScq1J2ChZq5Vtf8VtLW74uQopGpLzUCn7nQpFXCw
23400	payment	1397	1397	1678	1	1	10041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ejMyZRNbM4tiG8X92qzbWRKpagozcyHn2D1KP4xizfV4ceeY
23401	payment	2133	2133	1874	1	1	1163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTD876yjbkBoXvSp8ZwrK6xRMVEYBRrkfh6tpQy5LQ7Qj17Z1
23402	payment	2134	2134	1874	1	1	1115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5YjMVKqDxayjpGsXtiT5gViJqUzMAZ5YbUVyYXZrNb287vop
23403	payment	2134	2134	1874	1	1	1116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSX1VLLUUXZ7YmpPxn7oAbvE6YS7dEbuXD3VVm2nbtmgCN8ggW
23404	payment	2133	2133	1874	1	1	1164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8kREPqJGEe6SsogNgAbWa6edBjNyxnJpA3dR3VDHfY6aCykQr
23409	payment	1516	1516	1048	1	1	9	315585010000	150000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpYhySR1VeRtMkN73zCn6NUULKb52Amv6rWVyK7wqS16QQ4YGCea
23410	payment	1516	1516	1168	1	1	10	212964020000	150000000	\N	E4YvwxYsyvHG21KpA7kRsAL2JB4u3nycLepSuRfq5c3aMtMzoZ4hA	CkpZDFSAvMZgZNhH4a557JB91NHv3ig1xCeeD4CdSnLoc2TyftEbk
23411	payment	1397	1397	1678	1	1	10043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujobgVkVFPazgGgjQaiAA75jn5AH4pdrYSo8DmP9gcJbLchhM
23412	payment	1397	1397	1678	1	1	10044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckmWQrpDBcnLNGMjJkJRLGGtgcBFtHRmFRuW3oJtgxZKEyU7n
23413	payment	2134	2134	1874	1	1	1118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwj73YVUB4CEDcif3tW8sZ1Gzo4Wfa8X3zou3jN4u5Jr81Mmv
23414	payment	2134	2134	1874	1	1	1119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5rS9sGNkW167dRFjLiD8USePvuxj11WebLdVY9QrpyaZ3Yg2
23415	payment	2133	2133	1874	1	1	1165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcT1cHVsUyqYd4TcWuaDfJoneWMyitWtxW6LmQGxK3kJwFstp
23416	payment	2133	2133	1874	1	1	1166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEx3CiJhtthHmHb7Hmr4X8LF4vcG5QEodFd42EMgCdDZQVtijm
23448	payment	420	420	2164	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQohxWQ1oxjfepRUk7X4xjjxD5cuaoceFEvynTnL4WQSqXKxc
23449	payment	1693	1693	352	1	1	772	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZV2jWXKVbJ4A71Zdm3itbyiSQB7NaDvfxJoSeVR6xZNUr6oG7J
23450	payment	1693	1693	600	1	1	773	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYm9TSHphtnMnRkwxftKH83frwKKij2L1kjoVJf3JvmuMZmQsbL
23451	payment	1693	1693	620	1	1	774	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYePKeZHXf8Yo8nyGwLeCWG1oH2RBC6w8c89ZbgzDNiD19PqixZ
23452	payment	1693	1693	1150	1	1	775	764128062780	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZQHkVVrYi2YhMmwdJ1pcRFPUDYtufUaZ6waFiz5NoTHMryjkB8
23453	payment	1693	1693	1811	1	1	776	227001554708	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZVbdNjdfEbByTCwiM44YFsTay9huQB39LZitU33usA1Lvbzn5z
23454	payment	1693	1693	84	1	1	777	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYV7D1aQARVVCBPhS1wVy4L5vNBwiQ7Ka9cYMCJhWqXfTVNc9bL
23455	payment	1693	1693	2017	1	1	778	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZX5uT6zzjNP64oratsnEJp4iJQ4n24vJS6sVoSNpVDNhZKc9tM
23456	payment	1693	1693	520	1	1	779	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZhWw64aDs6iEVE67zC1JBPbrEo7mmcNdd1NFYU9T5QGviMKaZi
23457	payment	1693	1693	89	1	1	780	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYoJY1SvwpVsujUUcfGMJw5i1JsU9FpDmUGtsH8VM72vxPp9Nb3
23458	payment	1693	1693	186	1	1	781	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYmVC5KQEfWSu865bDbAQGgQCUWF7hfjLGx8Fvz8pxwsiks2cCo
23459	payment	1693	1693	383	1	1	782	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYiDX8F7gcXYpriGHS8quus98C1NpgsUKYCUiUMTWVLvYRFdunD
23460	payment	1397	1397	1678	1	1	10056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXQbzScza4hPsVQyGHWoxQsut3mA84yYFoR5KngDkQtbcr1bH
23461	payment	1397	1397	1678	1	1	10057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3hKuueCzPxXh1cDdEPgnBNsC49aiK3NZAJoKFP3PLYsJ1BQ3
23462	payment	2134	2134	1874	1	1	1131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCc43gpCxbuvmqCSxV93XDfFmjiwijuF8n7Qc45kK1XS5XXp9
23429	payment	1516	1516	1294	1	1	11	593264520000	100000000	\N	E4ZCVuxjaB6fRpQNomLVumZGFDnFWhm3uNrU4iigiwp292xBGkuXP	CkpYnpcvcb3j85yHzg7ewyPRgu7KxA7zfgkt9F7FECKoEK79v992k
23430	payment	1397	1397	1678	1	1	10049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5bRYoDtAjSwarn71ZmDRfxnzrpSAikwYiM5fBAypsht6q22y
23431	payment	2134	2134	1874	1	1	1124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSANRQJuCPupianPKKzStXJEp7oKuzmMFJHPzHU1MFbjjCFd8
23438	payment	1397	1397	1678	1	1	10052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaj7AhuXdmMuSDxbm5SmH5Q3fYJxi3FkGHG6pDCv2fYTqoYQD
23439	payment	2134	2134	1874	1	1	1127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdUABZ5r76gZwVN2szDVs53pm72Ts54Ftq4iSnrc5kZFgHzDQ
23440	payment	1397	1397	1678	1	1	10053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6S9MgPHgxLTbq44ELgb75Rh4d8Zjmdacrwe5RD8f8Aw7fckSP
23441	payment	1397	1397	1678	1	1	10054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSZi3qTjL28p8SCKzjpbJhNVTp9gZ1SfGhWRYHtBcy4CQuwXs
23442	payment	2134	2134	1874	1	1	1128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDLQnUrCPnsqHQhXZfWrvNGg5amjU3fvS7zwGkmLEYjLTwEfs
23443	payment	2134	2134	1874	1	1	1129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFNYEndt2vevP9Rkc9WzNz66881yrkyTUYThVaLuycu4RW4uE
23444	payment	2133	2133	1874	1	1	1172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVRL6dQvE1J5B14VAmkdDE3APdSVDpakS9nCNdhQuxYRP615U
23445	payment	2133	2133	1874	1	1	1173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dFAFgCFBu2wG5SZQnZHixGJrnyJ3mpXu2qZ462PshLukcvEf
23466	payment	1397	1397	1678	1	1	10058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZoGfUYwRxwEVbQcJJMiSFzLCdqsYyDoGxoCHXPcxzA9vNmfV9
23467	payment	1693	1693	392	1	1	783	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYdnbLBzC6eSkRagCw4c1zHE61J2AUrprjMkLJ6NUypX8S7qFcy
23468	payment	1693	1693	308	1	1	784	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZU9LLsYV6jfWakVBb9cnSrXsHAg8VVxJoSVaAYtLHoWY8SoKPG
23469	payment	1693	1693	551	1	1	785	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYRJKYQi6tm8FFYe9ehCFgXRaAugK7nkvPRvPprp3QFrSuFUzuq
23470	payment	1693	1693	678	1	1	786	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZqw7MoABKfxjbjRjxtDiNGrKvpMdYjvNkcmLn22ZpkfD54Jvpc
23471	payment	2134	2134	1874	1	1	1133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTt6G6HowFVFg3gpEPZrrxzs4yehSsBm4TMwpMiHYo6CAbYZcD
23532	payment	1693	1693	54	1	1	826	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYu7XuqUZswKV6GnRxBqiXr1eE85KHwEoAWyNZPwwD6Jnkg2BnW
23533	payment	1693	1693	710	1	1	827	6285241536	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZxjornQvFuwEBhqj2Dj4jS4CxfiZWVtx9FCJZ5i2aJMgUZudco
23534	payment	1693	1693	499	1	1	828	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZPNcxLs84fdH5VXfXpSj74mXJvtSiSADJBa7N7WH1aRoWB4jMf
23535	payment	1693	1693	721	1	1	829	2514096608	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZppc1ddb7V1g1ci3cPo5MLAufWzcPTd53ioPF5qUGharxLoAwW
23536	payment	1693	1693	103	1	1	830	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZsdVEQQh3AtzdiRP2SHveSNP4eui6NjrHEwMdXSQAaKP5G7X28
23537	payment	1693	1693	217	1	1	831	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZtmLsR7F8QajfKmKpUJGnsWvR3oD5s2mWcpq5X4GpNPrabQeXE
23538	payment	1397	1397	1678	1	1	10066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqaQ6P4TwV537j6AUadtDGVrgbXMxiS249EdsBnvjVLpa7vWj
23539	payment	1397	1397	1678	1	1	10067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTtYYfPvcRFwbnZAcfEQRvDYU4dNdmUSCL83jM9asQhTGbNts
23540	payment	1693	1693	893	1	1	832	385691228416	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaEjqiq8dcXDpjzvj8VZnWg8F5nEN8wkn7tYQhSRikFfQKx9v21
23541	payment	1693	1693	251	1	1	833	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZbYuxvvwUW8ApGatZcs4Y7v8j2q3NAf9sshtyjYVTZ4tnm6ybn
23542	payment	2133	2133	1874	1	1	1183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaS2mgukQzEdLLWXSKvrhyidjSTLTDF3nvdCQ3edvkLWJJhzv
23543	payment	2134	2134	1874	1	1	1140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVrHQEqZNiGQGWBRyxLzSMio4yAdFrYnWGGEkmeUPn7QveqVo
23544	payment	2134	2134	1874	1	1	1141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbHaNqJVP3hhfaQRNoN3GMzKHwKUFFzUNT27BfMyeeda4Qse1
23576	payment	1693	1693	82	1	1	850	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ5Erz5YXYYUsBJzMhcJiyLkRLDoRwoV2AFGos1azd6CugvcTLY
23577	payment	1673	1673	1242	1	1	8	500000000	10000000	\N	E4YkxNha8sZLHffMgj2r6ZZsHeKbRjvJry3FvGTrrMtjp8uHECXeU	CkpZfJHBB2c7SgjKzvoTc1wVgT8arGZNYWj1vyDmPrVSkaRAQP2pg
23578	payment	1397	1397	1678	1	1	10073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkDnKSCWAq5KCnwNy4GXLikDhjsofshGkUgb3hegFjztqZrHx
23579	payment	1397	1397	1678	1	1	10074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj72Fci6GJ2Guux6aaHc5EbFdQsrgULFoyGi7nr7F8UYmXZg8c
23580	payment	1693	1693	361	1	1	851	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpaCjYfHa7ik1yorwo7UvRZxQNqykkAPjrormD5Qv8Gq6PvJRUj7
23581	payment	2133	2133	1874	1	1	1188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnpKaB8x5CBRAX9Ut8AdCuL6cBLbZgKeAdeC24Uj73spa9yPZM
23582	payment	2134	2134	1874	1	1	1147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJy9oX2kMh78E13TvkQSukXU61NMDqdTBQYkvoLoaLqCJ5o6DJ
23583	payment	2134	2134	1874	1	1	1148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeXR5kng8dioEu5J4i4VE4fDxkJTMtQ6Hdgj36Yn4LB2W4FVf
23437	payment	2134	2134	1874	1	1	1126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32yoEqxVg2gRC62ehmXeiAvL7xag5KWxLBWFe3hPpbJBWTVK4
23506	payment	1397	1397	1678	1	1	10063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpJgxStBUumL2w7qGyTZZ9bhNq9vUu2ShLuJvSRPpg6UQ7fYK
23507	payment	1397	1397	1678	1	1	10064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKWtsegxGX2VWLjAqWHqSPJvkeJaVnhXKg9WmMRXzBbsJTBcQ
23508	payment	1693	1693	504	1	1	809	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa9YbTa1ZeTxD6HUHNxZtfsGSDKHz5nN2SsmkdmVQQ8Fyg2sddL
23509	payment	1693	1693	587	1	1	810	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZLYU2piiSwXSaMQqGiYvtKYofNVBrFQEWELQ11TZTsG31zi91g
23510	payment	1693	1693	1961	1	1	811	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYuXT4dpbRc9TxaiUiF1rfZzeCUaYLGtnDfa2owQpVzFHTEX8NH
23511	payment	1693	1693	611	1	1	812	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZpB7nEbou5SCWcMAEj1q3W4u8YXyJvq5EmK93eFknHzZATtSF5
23512	payment	1693	1693	205	1	1	813	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYncJYLy3p6pmgmczGnuhnNbJKLtc1R9o75m7R2AzwzP9Yrw2d6
23513	payment	1693	1693	658	1	1	814	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYhSyCFhCRwDa5iTwoW5jupJWH1Edeb1nT12b3kA71aj9ubbG47
23514	payment	1693	1693	78	1	1	815	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYWJ3puEswGCm2yMatx2GrzL5BmtyeiVbLudEH58X4MFyf3XiWN
23515	payment	1693	1693	660	1	1	816	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZgoZDJteKqUgappWh5d65PcqTSZMsx1HQyoL1ajPHMRfqkqGL7
23516	payment	1693	1693	1276	1	1	817	2129310789400	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa8BQUD8kRkUMCVBDfNwqs69jVqaHEAQ92p6UxGEdXgJspVBj7B
23517	payment	1693	1693	194	1	1	818	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZvynKwBoMv3g5qhDjQ3GMUcZpDAteRfcNiBgHbzoKtSQTVNLme
23518	payment	1693	1693	105	1	1	819	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZAcFHt8DXTjEbEYnT48RmYrAvRr1MY5BezG9F146CGeH9N7MAk
23519	payment	2133	2133	1874	1	1	1180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwkzRBa21eYC5bQZ3hxG7eR3z83wTPsxoxU3LvGEUk81BnXuq
23520	payment	2133	2133	1874	1	1	1181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbvfr1mpbybYtSAt9D5AnFpV8YQYao3JD2FaCjcWcXxq1p3qo
23521	payment	2134	2134	1874	1	1	1137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEvnuBMQgndac4jd5fB2w4A9dZ86wX9DFmNRRFRwqF95FNa5N
23522	payment	2134	2134	1874	1	1	1138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4ZpfCMrNaaqahu9SJeBTnuEck7rL7eXzEhM5mvNx9L89NZpz
23573	payment	1397	1397	1678	1	1	10072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSpdkpqHGjLTQrhQNAGPyLDshD1keBT7aLbo9KhcZ6biFZL4r
23574	payment	2134	2134	1874	1	1	1146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGhCEam6TrEeiTsDu5Fo9G87wc3K2qjwmSgraWeQ1vopybbBV
23575	payment	2133	2133	1874	1	1	1187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhkyALFpHWdiCshovQPWKoxbDCHmL2TuvB55sLGZa5fDLZ3dn
23593	payment	1693	1693	397	1	1	857	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYwVePTGQczmkQjo2VDCG3Hzpyo5i1FMoRWKDw947f171MxEdGZ
23594	payment	1397	1397	1678	1	1	10076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3qmS1UZCh16vT89F8LqKZNkWV3af1JzCmd7cu9MYTb5DtWpc
23595	payment	1693	1693	402	1	1	858	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZrQYoPv9nZXnUYWS8kVhqZt4uMnMsKXYaXWFupgrtjn5WWutxP
23596	payment	1693	1693	391	1	1	859	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYX5PiJMNyWtwbMwTDNEtuLX513ndEh9Nqpqf2nabbyRasJtXTD
23597	payment	1693	1693	452	1	1	860	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZXjXvkdNCgGa4E9BXZ9UP7gSCcM6NKr6fs68zNXQBY4w3p478F
23598	payment	1693	1693	2073	1	1	861	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ2boTLm2c9FQq1MPp9xzKfygceaf7r4nhDvApopkZPQupmJiKk
23599	payment	2134	2134	1874	1	1	1150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFyRNQ776SDgz3HH3MjUqq6DpXhYam5ce8PrHCTCdYEtUYfxp
23600	payment	2133	2133	1874	1	1	1191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9L3AFmVz7uBNxRmJRFbSQQq2SETnsaazZ7KkCLccKmaQTXW1
23617	payment	1397	1397	1678	1	1	10079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbFtTmtGkLfbnApEmjZn9znWauMDBFCBMV6Af5Q13a7posjCD
23618	payment	1693	1693	191	1	1	870	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ1QZNLY19R2nYdvXFTLSbYBYEPMuQqHkJS3MaZdKQaWR5ZvW5L
23619	payment	1693	1693	266	1	1	871	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZdCqSXqiv8QUT17XqPUMXhK4ef39q7XeVwHfmtatfwUK9JCvJo
23620	payment	1693	1693	534	1	1	872	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZDhUziECTE5GwpgvJYp4mxPpSzs6z6neMwReseN3fNV59WTrcx
23621	payment	1693	1693	245	1	1	873	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZByNz2YxafFwfcJUqK74pcrhhPznvEogSHvDP4RZ1WHdH6Ybe8
23622	payment	1693	1693	421	1	1	874	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	Ckpa3ygWKD6gJvMDLqav8PP9ASDe5yPe7GjdW1FqtammZRJyLMsT1
23623	payment	2133	2133	1874	1	1	1194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPkQmPw551V56dZLnZt1Ncx8A1LJPonrjThJgxzLFHufmyWvV
23624	payment	2134	2134	1874	1	1	1153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86iVicjiKgJJypDHU6z6h9btRGV42qy5w8Nj2xvk3ibVExorA
23631	payment	1397	1397	1678	1	1	10083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfx7vJVUQNmBLgk4gK7xD9jbLQ54meuAT384M7HoVgDY31SVg
23463	payment	2133	2133	1874	1	1	1174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YHzJGi7minKvk5BH1xhDmq7erWU7kz9qicGkbTiZDAvLyCC6
23464	payment	2133	2133	1874	1	1	1175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqPigo2Z4b44zSLERFsVvJ57ReA6wTvdnDn6t13PEubFYQ6wC
23465	payment	2134	2134	1874	1	1	1132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEormBjcDCyvEQ13iz3BGFymusotPFDzCwNeWs2xrQdFuEXJBL
23479	payment	1397	1397	1678	1	1	10060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A4gWbkb3KvqxCG3VKzLPAdZHVoP8NCr52FMsz383ASkbgKXT
23480	payment	1693	1693	691	1	1	792	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZmivSPQU5q1LgTE4n726ba5qXHuVTcBKW8cteYDP7iPBfm8yui
23481	payment	1693	1693	339	1	1	793	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYUDh7xi3wBKBTdDGK7Vq9CnjLckVT3SWBedSvnPE8CTVvuXcx8
23482	payment	1693	1693	745	1	1	794	2514096608	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZE7Z73s6o8GDYUEdZhTYo7PdfHyYatmqvM97MKrHb4scQXjQPS
23483	payment	1693	1693	63	1	1	795	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZ3tLsXHC54TBTRwC2CJSJnDW9eogAz984MQjjqX1WfLykYSD4B
23484	payment	1693	1693	1772	1	1	796	593460467759	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYj9gqr1ZPuhwc3HakZW2CNy3E99ZtUuntX3F5fivJVHSSxmHGN
23485	payment	2133	2133	1874	1	1	1177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYei5RSvVVTfvuPQBN46ZbCzoQpqyD2gZgu8iij7u7HMhgqZaoD
23486	payment	2134	2134	1874	1	1	1134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdk9fygGTtmFYwnoj8i9CH3B3rjyCPXxdh2zPexzRjxtK6NDTf
23523	payment	1693	1693	122	1	1	820	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYUxNWGVWEUZpLELLtUhFwymxpQEgqwjMUYX2aoyNwpYJz67ryC
23524	payment	1693	1693	622	1	1	821	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYUqzYA3jUomW7rVH1Yu6sAY77di95ASFmbiEnrUkhUNhFRcgtW
23525	payment	1693	1693	653	1	1	822	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZGpZZpvs4QgsfVKJ5Egh3pmVbhhFP5Pwgx7rWD9Dnn1DrFTW8o
23526	payment	1693	1693	304	1	1	823	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZpaNQcYAP7nF5izpFX23rP3idhbRFAL3tUr6r9vTQX73FnX3Ad
23527	payment	1693	1693	206	1	1	824	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYW1d4RiErJbpVtHrB35RgigEGDoY2fqe6JrK3JEuJA21MwkxqV
23528	payment	1693	1693	399	1	1	825	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYx3sEAHzWTLW9ArS2h1H7axJQ71waSoU5BHmy3xmJATqDFCVi5
23529	payment	1397	1397	1678	1	1	10065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa78jMZmDMhqTeZoaVy5gBuP3FRYLybZ8CCRYah5wY6xrAQZGh4
23530	payment	2133	2133	1874	1	1	1182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngthdc19vsxsAeaSjtmJzGtKeNqFN9q1C89kRN9EGXjckryYT
23531	payment	2134	2134	1874	1	1	1139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpLKmgL9QaheCB7UC7q4Nv5M3NTztsJ41LGVoHEYdJnPpBWY1
23545	payment	1397	1397	1678	1	1	10068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rcN42oBdZeVs8sjgGqj2yq7amLxfKB8uE82A9gmL1ZzsSYwg
23546	payment	1397	1397	1678	1	1	10069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55cwk7jNa5jKJ4H94TA6T3Z5aQ4mS9hDYr47Tc1SSHYga3R7A
23547	delegation	2164	2164	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLUR8YD3mv7RCQ9ikiDZreFws13SyHUcTbgHU5QgGGtpUePop
23548	payment	2133	2133	1874	1	1	1184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2heZmCbLnpS7AoEwNGKFBUcfCci5j6EgV3auKzVwVgvsfMEk
23563	payment	1397	1397	1678	1	1	10070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERTwUDb3rnaem8TBm1uFPqRVV4DPH9iB9NEauggSkX9rEbX7h
23564	payment	1693	1693	225	1	1	846	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYwVTqHeR5mvpD13z6HvJSRQrhW4ZSTpnRzxHNgupb3CZizJ2o5
23565	payment	1693	1693	560	1	1	847	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa7XTzuKSP8yJU4xyc1QzxEbFyS5x665rZStnmL4hJAbDMeQGEi
23566	payment	1693	1693	252	1	1	848	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZEmXjy4935DdoHBwQqzP89EM3fHKc1R59hoMgYmtD4jri79p5j
23567	payment	1693	1693	163	1	1	849	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaCwUebDBbxokBqkunCpqaZ5NQSiQBjMrmZFuFrKcnMc9xhLMZm
23568	payment	2133	2133	1874	1	1	1185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbpLnUWkc3PdGE9b8LU5Fyee7T6uPHeC7pgYstpaF9TPVdHM1
23569	payment	2134	2134	1874	1	1	1144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjoNNTq6TSgdsavTou8kf2LGkRGrNEH12HTdpQCUEMDFeyFzG
23608	payment	1673	1673	1122	1	1	9	520000000	10000000	\N	E4YkxNha8sZLHffMgj2r6ZZsHeKbRjvJry3FvGTrrMtjp8uHECXeU	CkpYdeP3Lcg7CcRDjgaaE8gqqDEszEcbWR3zz6P8urbs9o4beKLMW
23609	payment	1693	1693	112	1	1	866	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYibRxCUWu3QDutga7KLrL8JuA1uDBj1cjXATvj6z8X2xghZj7o
23610	payment	1397	1397	1678	1	1	10078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA19RBTcbgFhzNqVNF2zBKWF5QYTFZUAkFLnW6HTHTk79AdMS5
23611	payment	1693	1693	353	1	1	867	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpaFpzTcCW5ngezQez7EPqrtjjs7sgBDL3ME1aocDJM5zTz3zGyo
23612	payment	1693	1693	652	1	1	868	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYowdb7GuuVAuUNxqfzTthZiTRcTtUCJqtjUW5Lkw4PMRTKKkV9
23613	payment	1693	1693	420	1	1	869	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYwb4qGAzGXV8qzUNzMMWZumzhjEc1PB3sqGXooLATTB7sjyjqZ
23614	payment	2133	2133	1874	1	1	1193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVcAmhRrGNmWBha8SWraJc8N3ecVY4JPVbccZXjcqU6g1rsV2
23487	payment	1693	1693	92	1	1	797	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYZ6jcMe1y86HgN9AEZXZcwE4hWebuCoKSHH2ZAKDatGKm4K1cq
23488	payment	1693	1693	150	1	1	798	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYiwn25bYZbKwaSb8ZVyBUwMdvYMNZi7PRf4HqpLf7rctkoiBQi
23489	payment	1397	1397	1678	1	1	10061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGK3zs7RkXc6UcT1igpoJYVpMkZyKWFm2nyaw18QVCS3zjn3bx
23490	payment	1397	1397	1678	1	1	10062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6hKYYiGCpkbYwFDWTwvFLmmS6LK23AQQqViMma7wRwzbe6nQ
23491	payment	1693	1693	373	1	1	799	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZTpvdusrCQRsCiNoeVUtJo4fN7kbiyLABKdcFxn1CmM3Eid8qh
23492	payment	420	420	2164	1	1	1	529100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVmHFMY5xe9inYvMzwYX94TeQksXz3oRwFakE7QsG55GQDL2q
23493	payment	1693	1693	322	1	1	800	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaFKQ4ZTrdwgoH6Q57M1aQvb17YYcPndH84ADfrM6ZMTDnmJkMT
23494	payment	1693	1693	453	1	1	801	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYr69fJjuTtkYmaeogz6HzZbMgK1wwTQJ5uDcjWS5FWTZYbzg8q
23495	payment	1693	1693	450	1	1	802	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZ1QpN2NyTAjhXsTAdzMBrc2w93SXfA6wNbvHSwddKci8cNpMBM
23496	payment	1693	1693	395	1	1	803	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZUBBXCkHakADv9A1BbVZ7koFxoYNjeVxSNcGNoENdeoGkGGc5Z
23497	payment	1693	1693	29	1	1	804	8799338149	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZUTjAQip7KTmd4buzv9oe6o8oxEuwCxox2cohNZssVzb9FP3tJ
23498	payment	1693	1693	138	1	1	805	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZUNRftMpmMkeHmgb3NMXNS4PB5JGX2QbZUUvokyj89S3vS2vT5
23499	payment	1693	1693	910	1	1	806	631984874620	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZhxpkigpW45ygmJnp2dTd63pMh6ADPKezVv1FEZtwtB5xCaDcN
23500	payment	1693	1693	500	1	1	807	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZQ6L1A7W9RLui7CncAAhGNrqsr8uAthnyTCTrvUf3c4JfbAB85
23501	payment	1693	1693	146	1	1	808	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYhgPSDPGa66fFUCSNAQhfwfvdnEKMvSrbf5262tFFqgzxefw1v
23502	payment	2133	2133	1874	1	1	1178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgydRhLsv18VaFBkZTVPy1A4mksm8ZNGFRPcUFkr8c91rPrEXr
23503	payment	2133	2133	1874	1	1	1179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTU7KyTYJYrCfMagbhk9DRWST9kBXzzCsweFuNkZfZrtREi7m
23504	payment	2134	2134	1874	1	1	1135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyFR3vSF8vN19KzxgVUJumBg9xAdrr8jGZtTrGgczhqpn5hX5
23505	payment	2134	2134	1874	1	1	1136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj8Vbk8wHp551hbEH7da79swC8tKFd1mfYrb4BJfgcM73Bo4u
23549	payment	1693	1693	35	1	1	834	24135327520	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaDYSYouXFmM8R17YyJuB2Fdfxob4BQP4WW1n3xyHwAH4LxToYL
23550	payment	1693	1693	49	1	1	835	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYRymioAqdVxY1Ake8mABHALFSa1CXkQZf4RYkwa6wbZYXb93oM
23551	payment	1693	1693	320	1	1	836	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	Ckpa4rS6Zc8e7XYves1YQLXSiXpyicFMScU8MLz7DSeJSYM19k5DU
23552	payment	1693	1693	1030	1	1	837	1132511480500	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYaTf7HLa787vBJJ4b4iZQb2ofS9NGQBcU8Hp2BLfaCjTtVenDB
23553	payment	1693	1693	569	1	1	838	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZx72dpi4qaNC2MejpMYrzuyiNUaoSCnyAfR76MpA7Gwn43yFxK
23554	payment	1693	1693	663	1	1	839	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZ4ekhSwRLy44P2KTUUJWBmkZAg3sZbNKeeEEzXYuqaaEpMCeCy
23555	payment	1693	1693	108	1	1	840	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZYujmzDSXE393rrBE27RJvHZYzUBomDnSNMUKR4rwuprBQmLVk
23556	payment	1693	1693	390	1	1	841	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYQVJRwVCo8GpeQrPE2yRXqm7T9zuj5F95DkSEYeEoJzztA8c5h
23557	payment	1693	1693	894	1	1	842	385691228416	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYsX2hQFDWGNBbzZdJdB4mBkKcuGsTDM7dUrAiREQ5sSzpk6HbT
23558	payment	1693	1693	570	1	1	843	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpYri8Xg9xR4YE6dTruzfFqBEwxPBgcpx5edub95q3rBN4dTA9Qp
23559	payment	1693	1693	99	1	1	844	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpaKJDLsTAV5EGzDRfZjrWQEPsPRXksCKEBN5J3wxwE9A8djfmF9
23560	payment	1693	1693	377	1	1	845	82965188373	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bP38fE9WtDn5vsFapJvtZTM	CkpZA1boAc4XEiohWEdjC3iB9RvHRYbYFPAvF9tqoAVxrCmW8dNYA
23561	payment	2134	2134	1874	1	1	1142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSoozdjfwj1sWFBy44sL9j169NsvrcbmDTt3ejq9hBRrzLnQNr
23562	payment	2134	2134	1874	1	1	1143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDmXM5d4mCEBBQah65mdknB8waMiXs8eHfyV2amTt5pnfnXDs
23570	payment	1397	1397	1678	1	1	10071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwu7c19fgJ7j6JztukW9CUk1JueXdkdTYBtNxDcGnifYc6LicH
23571	payment	2134	2134	1874	1	1	1145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGjCYv9vGvMwSUU1ZM73RvAMPJarBmK1zpQ8FZjciNzKWRxnx
23572	payment	2133	2133	1874	1	1	1186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAmg6QEgqvfsBJe43urNc92uHNcNm2ZRaAraXLJtRr87sfB9d
23585	payment	1397	1397	1678	1	1	10075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFvFAUxXUyxK9mqUqoXmLhEXacbjVpZLsw8soPYtn7qGVJrDR
23586	payment	1693	1693	594	1	1	852	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	Ckpa7vzNCuoLKnUuLTmwX7ZNGZ3xenfJmbN5EvPtwCBtWh9x8f2ou
23584	payment	2133	2133	1874	1	1	1189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZF3N8rbMdyi3KjAPCpXEjS2FbmCoPQqbwgQTwbhpLXzRVf2t9
23601	payment	1693	1693	680	1	1	862	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZrVgrYQb2bsR5howDt5UK8L6XcFbb2ZvptUj9ThGzzA2AHXaaq
23602	payment	1693	1693	690	1	1	863	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpYsNcYNaHWSxTXxw3ZvBNkM1RKThEVgadXwVWZn6Hc6FPbFAyXr
23603	payment	1397	1397	1678	1	1	10077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvje5CwrbqbA9QsApJ6A7FPRuEJpuf3EnfDSiL911op24YidcV
23604	payment	1693	1693	731	1	1	864	2514096608	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	Ckpa76rKyPnxwvn9shhxSW1MLnmbTbmqBpZwRJEd2HWYntEZi4TGF
23605	payment	1693	1693	180	1	1	865	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZhoacaW1CBrjhZRuhCfq7YU6XxNhivumksBJzvFbaRwwUMKo3q
23606	payment	2134	2134	1874	1	1	1151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS6EwfZckxuGvAzns9676wnpsXdeFfVBZ95TYRYC5fEmn6rUV
23607	payment	2133	2133	1874	1	1	1192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBnxau8Zs7qNH1ZwUMN8RsuvXfJCYpEgTSTQwXez7WmJVGcku
23625	payment	1397	1397	1678	1	1	10080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY66NFfTVSsXTv4H4B8kNs6wHfiKZMrd1zLsqpfyAJbTRfQgxW
23626	payment	2134	2134	1874	1	1	1154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizwns4fTB4gaJfy4ajWvkEzjxRLmRuixQbpBgS9qgvbHCbx4p
23633	payment	1397	1397	1678	1	1	10084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLBsGmvxkKVy83Uc3W5J2d64XWtiZ2EfiToJT9ivbH6J27Tci
23634	payment	2134	2134	1874	1	1	1158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtqE16vgrgFpdP9aTVecH3LaFZwkvbPJcGeKRzXBFczQUtNx6
23682	payment	1397	1397	1678	1	1	10101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYAapb3wrgS1uUFZ1xh1PHqtvQSKTMWSfMnQPWbj89aBgRdxp
23683	payment	1397	1397	1678	1	1	10102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoMbhSwKv9YFvN8dvLa93LC7WezEYrNMBGqd9nejPy7dmRM7o
23684	payment	2133	2133	1874	1	1	1209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGP6G3mxDqv1E1Jrx1jkHdosg3tU5FNSoRSToAztoW6cv6RtkA
23685	payment	2133	2133	1874	1	1	1210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkv544YdxU7Y56HeBi8Qbu798oYN8JA5WwzoDZD7wxXEG4LbQh
23686	payment	2134	2134	1874	1	1	1175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gw7kK2iJWmFb77afiFRQhNusQg12BTkcDWYhLUWnCSSZ1JKt
23687	payment	2134	2134	1874	1	1	1176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa442MVGqUCCpyCVWqxwQSJU1iqa7ovcvKfvDRgZ6LpMuJ1pBJu
23688	payment	2133	2133	1874	1	1	1211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKAPox77t54HuViQoCv65qkSwZB53KiUdGsCjtRVkuJEQTBQg
23689	payment	2133	2133	1874	1	1	1212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzQDXkyDw5hZ963oLb5qLmSCSBxPPxgjAEbpsZomu8ddTzfHi
23713	payment	1397	1397	1678	1	1	10110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAo64HbkjU9Umb1cTXsLJdQ9K4EqHbJKFpZcHf5aFkbWt3Vdp6
23714	payment	2133	2133	1874	1	1	1221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5vTuMPWg6FjhvS5pbcE4Rit8tJUmtcxeVkd945etGvbmt3Hd
23715	payment	2134	2134	1874	1	1	1185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmEr184RXRf9D27YXrQ1hDnUgajQnDutBVwKbLnhZXXdeucag
23716	payment	1397	1397	1678	1	1	10111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3BwTmak5NZzbj7XzRdmDoX9Hpp5HXmzc4MZwTT6KTRxikifA
23717	payment	1397	1397	1678	1	1	10112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhadUdp9yYowdZi1WsdcTrrc4LfouKNYs9Pr9GtB5ZhSkrR6DQ
23718	payment	1397	1397	1678	1	1	10113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjxUs3gryUrEUZExeT56cXbV7k49uD9mDR2tA4pLEtndMLQhx
23719	payment	1397	1397	1678	1	1	10114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqLczjyVnEsgYFhpwWVMzN3W2ZWwMZ57NxwRQQaWfGmKXqrCd
23720	payment	2134	2134	1874	1	1	1186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbecLDcKgWuJwMssHiTV1KqB1EXd8H8Z1XsWxYeYgMxeHGQ2u
23721	payment	2134	2134	1874	1	1	1187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJg1REvaje6AvDtK1nuhNzA2N8T2iw63Lhk4ZjDUsGX1aeafv
23722	payment	2133	2133	1874	1	1	1222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKWqYeD6gaJiCS4tcgde3HABec2AkDso5vjARuPPqYy4aWpa3J
23723	payment	2133	2133	1874	1	1	1223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyNoGUAsgG22HciXPfzDfsZj4oKbBdCxiDm6tfuRTZPSYCiWs
23724	payment	2133	2133	1874	1	1	1224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVHpeApmxKjfSCKMo7EAtWHNnpTG71EBKqjGczpPtC4ffivhZ
23725	payment	2133	2133	1874	1	1	1225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqLvX9rxAyCFxqmtz9pATdGyo93eSFhjz9eXUUMhdBvRSEhcc
23726	payment	2134	2134	1874	1	1	1188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkd4eRvLR3Xy7mZqPMhgXMmVtcc75MJMc7MYDcey3GciY6DcW
23727	payment	2134	2134	1874	1	1	1189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJURV5ZRrNXD3qgJ5otaHKd5neHfLoztYHL2RETMCZn6wMeGY1
23734	payment	1397	1397	1678	1	1	10117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGQERqimw5k8mosEzeL4sEydcwF9y93neFtxj1SAUK6UL7iQ8
23735	payment	1397	1397	1678	1	1	10118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzfGvX7xSxArjZgX8NFfUYUxqkfWHj9jWTBQM6uMMt9Qyhj8h
23736	payment	2134	2134	1874	1	1	1192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAj9TtxmpRdCNvdnzc8xBtCxAsktqJ36FVxiokQVHCZWDMojDi
23587	payment	1693	1693	309	1	1	853	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZp8pTu6pvnN5ebXXMqMaj6mo96ieyiKb5McTk7N316gWH4ZyFV
23588	payment	1693	1693	201	1	1	854	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZbbmVpX1XesxzdmACj3qmARtL58EVcSULWKJszuDfxFdy4eWvm
23589	payment	1693	1693	1962	1	1	855	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZnFp6rDchr6R87bKewz9ZEzJrmVbRXzrUWbZ1Yxfaeeuaiaxi3
23590	payment	1693	1693	275	1	1	856	82965188373	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnjH3DchRGctSHaqFtucW9x	CkpZ1Kikm1T9nLRJ8Dmsmuu2vrLDuaLHXvNbWiVNHvf3paezcUfnD
23591	payment	2133	2133	1874	1	1	1190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmuABu3n4SQhnaygiPTvpaeVeigo9j7uJWoQkYnMcENF12MTN
23592	payment	2134	2134	1874	1	1	1149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSgHSBi98psf4ZG8mpGiVsJFEwxde5786Aiv8r7RwyMDbuajj
23627	payment	1397	1397	1678	1	1	10081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WXmDATzGczgJaaDFHpHi8MMneSqpLSmaxmJnsK1KTUBYzzwm
23628	payment	2134	2134	1874	1	1	1155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkppX5DrgVPZHegXnGWgjWV6SkKj9YrZXGJjbSh5MoYYCSx99z
23635	payment	1397	1397	1678	1	1	10085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjg7Kq3wTPKesi5sotsSUP9UPV3kU7GNP2Lh6Gnbns7EdcTuP9
23636	payment	2134	2134	1874	1	1	1159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRetWF5t1QoSLcBU2r17m6Y8LYsbVFj8gbtyNfeBUUr6cwQFLu
23637	payment	2133	2133	1874	1	1	1195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrp8yePq567qjD7NTmFLpAaV4iMrjHkZ2fYLNR7s1BPHReAeN
23638	payment	2133	2133	1874	1	1	1196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKg4s4PFDDkPM2g4J2zewD23ZJte73FvM1siAWSv3K3VdyVSZy
23639	payment	2133	2133	1874	1	1	1197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutt34B5PMY41faxZQSnZhxsBpPM4TD639beADw1YsppyjR93k
23640	payment	2133	2133	1874	1	1	1198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSEv1tCiHtG267HHBYRH46zGzSmfx6SGJP6f1v2xc5khUHrCjv
23647	payment	1397	1397	1678	1	1	10088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxz2TXbskfhuLwijbxdNHn2tvW3Nb6776PWM6HuKNEqAjDGVvs
23648	payment	1397	1397	1678	1	1	10089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKyrjU3bnKMFjkft8bs3WwbuScHA1Gmwe2ofSayV1uNW1CtJh
23649	payment	2133	2133	1874	1	1	1201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnRh1Tj8c8N2bg6ejdcUvXuoN3TNKqjuBbNkCVGF42U9n3fBTh
23650	payment	2134	2134	1874	1	1	1162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFvoyFSTwwXF4ve65EDgs7BiE9EyHTSsU4Fuf58xaRtatnDCX
23651	payment	2134	2134	1874	1	1	1163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNdeGCgQtVXb19UA5FYEjo5B6V8hFZYbwoqH6XBKoKvQ2TRVK
23652	payment	2133	2133	1874	1	1	1202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvx3cNBTXHkV9wjbrimrxtXkFLP8G6LrnoJ9vetwEGABcVzFh
23670	payment	1397	1397	1678	1	1	10096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4w8yqEsxv9q4sZggyoGUD8DgFCrJHwkGGtgx8YtKZSLxJgwhw
23671	payment	2134	2134	1874	1	1	1170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8w8LeyrAsmSLXfyabrtJ2b8d8b9ZFTA41LC4tZTWHVi7fyVWQ
23672	payment	2133	2133	1874	1	1	1208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsHNwob2W8x3yevy9GgwSKTaZ5ZZ5ispo2SbPYE7xQHKABNCm
23673	payment	1397	1397	1678	1	1	10097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeM143t7oy4iLx7atwJ6HGS4HZoyLisgRCD8rhfFcW5ztWx6KJ
23674	payment	2134	2134	1874	1	1	1171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXbhvPCetroyhApkMSkVRVJMS6rd5ZC816hBMWfJZE94DETEN
23699	payment	1397	1397	1678	1	1	10106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rHKFkTmn9BrcfZiGJMLC4AhZMcodayp3242YsidKGJopX8iK
23700	payment	2133	2133	1874	1	1	1216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDn5N6z5RAtwg5NzwWtNikFtZcicyBfhU4v8y5qv1xdmCewZ8d
23701	payment	2134	2134	1874	1	1	1180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDby4wayBm41ffNEMndEmmKZB64pcg1qZLq3W3LxD6DSaRCTTu
23710	payment	1397	1397	1678	1	1	10109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4x6EihWBXoAGmQB756bTXcU73Ng9ERqCBLUNoNMPddrLQZ4U9
23711	payment	2134	2134	1874	1	1	1184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpqCaRRUTkvFreRAFjaREu6GFP6Yt8KkQFuPvpmkazQGdgiaD
23712	payment	2133	2133	1874	1	1	1220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7SZUqZjreyEQiAQ15PCmvnSGtauWXTHzUPNz3vkrNqa4bmHMs
23745	payment	1397	1397	1678	1	1	10121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRH4mDGaWsiYvyR4o5LgzB24G7AsrFnBNGmseSsUvF6kJJwT22
23746	payment	2133	2133	1874	1	1	1231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAML8h7wLk7UmJ7RoF4u61g4eVievn6LaQB8QeXJ5Y92ATwSX
23747	payment	2134	2134	1874	1	1	1196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4pRWKWMcWqtxknpVGvWVaS1TXDHzpphNcKzsXf8uUscH4bRW
23748	payment	1397	1397	1678	1	1	10122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBLNaDQTF7QEkWhgkmBiSsx811TvcdausnrS2Thcp8gvskhcd
23749	payment	2134	2134	1874	1	1	1197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mRjF425dsWqxxC8excFp2U9xXHxkSwkAqXjkB4APX6f6zRxU
23750	payment	2133	2133	1874	1	1	1232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6q9dbA9X4hxd2J9LA9n1DYt96MhTQkx3V1UirHcicow5GLbf
23757	payment	1397	1397	1678	1	1	10125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCrFmf5c4a4Ef5MJAK66FQx8MSYnWpchdpd9K8qJu4pSVdiF6
23615	payment	2134	2134	1874	1	1	1152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJh8eWQoYcAffFuQfs64kyfiybGcb4XNsdUPBxnmkXWGgfy2hj
23616	delegation	1926	1926	1745	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZep8XnPRMQKhmdy5bAQosTBYqUj9DrMLfcwz3PQPswhZvgfPfV
23629	payment	1397	1397	1678	1	1	10082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEfkWrLGFwjoNTR67G3WxXkVohqUp2LrpiCb2Z3HixBesqzaN
23630	payment	2134	2134	1874	1	1	1156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCM1NzR56K4ubmysBSK3PFs8vyQJEDgw13VynmrrrkAvAcTwL
23644	payment	1397	1397	1678	1	1	10087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeFuczGeiWNWScmWG4nc2dDBiTX1LXikgXqqXo6Q5WRXeVFWU
23645	payment	2133	2133	1874	1	1	1200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrd3LmnbRQ3PQs8aafF2cHfm27JWEraCAPSsVRLTC54ihNJYT
23646	payment	2134	2134	1874	1	1	1161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76Pqu8VNXMaRdY8AL496ofLUXGCB7KTF6hsebBNDiWnNxEE65
23668	payment	1397	1397	1678	1	1	10095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUNfZ1yKdpSXNhnkJs5o9APeQTVGBg2dw9BDdmoqsUokVstJ2
23669	payment	2134	2134	1874	1	1	1169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LsX57nYoik9rW1npvB9ZNfdrDbSvRiVuDXx4nZqPLJBS2ksV
23678	payment	1397	1397	1678	1	1	10099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8r5pHAPn6qoSLJ6E5mZ9xK3aZc5HBAoGN6W5zWPEM3jtAJKGH
23679	payment	2134	2134	1874	1	1	1173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqTY1NE5zk51Fcf95aZ7AopHBC56YSYJzCxV9gb7MdXACAuM7
23680	payment	1397	1397	1678	1	1	10100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgACFQCCWdtQQtLDEWYmL43x1YfW9nhKkqnJkji6iciJhjmAX
23681	payment	2134	2134	1874	1	1	1174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWsGT3Gv1ZTVj74PvcMxuWrox6YmQeu8RQbD5HpT3ALJdrXHz
23690	payment	1397	1397	1678	1	1	10103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYai6RYv8aursnejg8pqTtKU9js6is6rxNbNKHPyszEnXYkutVo
23691	payment	1397	1397	1678	1	1	10104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sH5ziTZm6qHr7YEHvWcpSmysYmQepbTvj8aEfQ1m5xw5v4zH
23692	payment	1397	1397	1678	1	1	10105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZmGkRW8osrG3i3SV8cnLjWqLYYZ9AnQS7D8wEvDYnduUmaki
23693	payment	2134	2134	1874	1	1	1177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLApjdghJebqEC7EsKLtf3jacZX9K4bok9yvwk6SdUsQnfyoW
23694	payment	2134	2134	1874	1	1	1178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsdLUDvYLGBtH9fzw2NeRpVJNsZWN6ftzUMTrKpWVSrHqQHPJ
23695	payment	2133	2133	1874	1	1	1213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm8DNiHuf5X6Ssss5tWaaKZBftAE7Pt4KFSqnfRhD1g3dXuJYe
23696	payment	2133	2133	1874	1	1	1214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9j8FakoKcUB33J8DDZW6VsfHgXHh99hckxcr5hRzBFXENQ69f
23697	payment	2133	2133	1874	1	1	1215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByNvXsNArhwwd4mpU9WV5krkEAcCuqTDmifRHMSRuc9uR99ER
23698	payment	2134	2134	1874	1	1	1179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7g358ZP43Phh3qsemq2714JzCf9SQQWdxh5NZandLEQQ3bg6y
23707	payment	1397	1397	1678	1	1	10108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJd7ZuXvikkQQPSHJe4y9XYfZ5bcwy1LbvEG4H3xDVpNq1vkkr
23708	payment	2134	2134	1874	1	1	1183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7w5TXVaiGPjoJxiXjuhGdXS846GdVNwnDAJAs2kNZgdW6Cj6i
23709	payment	2133	2133	1874	1	1	1219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6rx2w3dAjHAfAb16MccHd5ix5BrdPc4ND9PCzyoJ5N1rwgbE
23731	payment	1397	1397	1678	1	1	10116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMiUh4vret8kFr846GCF2NRovtPiRxFauKjNdMV78hyssVamt
23732	payment	2134	2134	1874	1	1	1191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvjAugqi3MNdnPfavMEE5BmRAhLH7Pw3x4J9CQ7bx1wPJUmtY
23733	payment	2133	2133	1874	1	1	1227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSLSBVjqxXjadzW1uE1hq883p82yhbJ8ZsX26G5fnz7nhnVqa
23739	payment	2133	2133	1874	1	1	1229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVspdZAStZgStYVvtUDoYfSv9xjZuHgsZCyZQ7sPzC1RPhW5J
23742	payment	1397	1397	1678	1	1	10120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLwiuRFcg95DyheywpvYLkL9QF3ZT6eex4hwnZNNk9z7j2NZA
23743	payment	2134	2134	1874	1	1	1195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQLGuc8QxTDwx3R6vLFRsY4bmoNA4p2oW9f8jqF6pasqWFN8A
23744	payment	2133	2133	1874	1	1	1230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazP26E6cF6m9K9AEnzWyNPsHkaDWJJwSERvEhYsAM3p4XBGBj
23754	payment	1397	1397	1678	1	1	10124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuevRMDzwKkURFTCqT4EKDESChRnDK2EUS42ga9Xy4itSHxH6v
23755	payment	2133	2133	1874	1	1	1234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfCsCG9tZPcjPtBgZ192Zjx4ZLBQ4CUeo5DcH6p4gHjve14ro
23756	payment	2134	2134	1874	1	1	1199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTAg39yJM2DE2ScEhmDmpEGLFshQKshKsRtYue2zqDdoHh6Y1
23760	payment	1397	1397	1678	1	1	10126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgHhhrKXRyYSHLcJRtTKq5pf8PZtH3Doe5Z2wpy3nUF19c8yh
23761	payment	1397	1397	1678	1	1	10127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKFhVce42b7E3sQTNtrEmStXQFxbvRKoGAH6BavKrFJrthYkZ
23762	payment	2134	2134	1874	1	1	1201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwzRYJ3LdYtnPAaxCBHP2te3PK2Fdb4A2Qetou2x7u2YW6LH3
23632	payment	2134	2134	1874	1	1	1157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWfXGgDRgqr77uTXsjMDjmk63NcZQo6oAdnkJKPqRdZZu3FFE
23641	payment	1397	1397	1678	1	1	10086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSXBZ2VFWbVtfJtww4D6kdVFJcJvfv5tYFUCERC1LoQSyFak37
23642	payment	2134	2134	1874	1	1	1160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7x3w6TF6teTfjH4g65jKgN8NtZUmAPaAS696ftfdwhrSiGPYm
23643	payment	2133	2133	1874	1	1	1199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDreZHqfpZTicWPFrbsdr1wi5EPE69D6sjMj1k7UBNmEgUSjNu
23653	payment	1397	1397	1678	1	1	10090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYykAG9uDgmKbB7MMn9aU7F7STc4H8euwUZcaR8Y286Sf5pVLj
23654	payment	2133	2133	1874	1	1	1203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoEZDyyUiRxZ2EUMCvm3L7iCSNJ4TNsmKj9jjiPDNzKwPN2uy
23655	payment	2134	2134	1874	1	1	1164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC5ZHdi8uZPZGqWnvWmFqbtRuiFXsKZdsKUTtQ9B5pbFvX1Y2
23656	payment	1397	1397	1678	1	1	10091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfan8gsq8dvcVt8DuKFii2QYUxwEFLY6iToo7w5DCdN3Rvcn9d
23657	payment	2134	2134	1874	1	1	1165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpSp4xQhRGx3WjeViQR7YMBz52jAo5vXn6fWQuJX8kqNSLjvE
23658	payment	2133	2133	1874	1	1	1204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2UCVkgKyG2MDy2D2KwnEkDqPHXjPwwddSCbLZ2hbGphiVsGK
23659	payment	1397	1397	1678	1	1	10092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdMjBmfKma49KZp9EDF7avm1JG5Xa8e2qxAkydBwUt5Xngum4
23660	payment	1397	1397	1678	1	1	10093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrgRL9fhHJdrirtCdfMdg1coCXUaJJSNykwv5V6sRXGLF2ou6
23661	payment	1397	1397	1678	1	1	10094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24RGsYq5qHcSShkExkLAC71To5EfRwcnGKfhJBDyCtJ5UuKqF
23662	payment	2133	2133	1874	1	1	1205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYocZvdK2GaD5jQi2DpaocHDZd9ZW9DAhkXpmTbYJPbXGLrsd7P
23663	payment	2133	2133	1874	1	1	1206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWXnSiZzf2m3rEeLfvyJif4E2t2QrXavCq2AyY1VDihbLjRgEV
23664	payment	2134	2134	1874	1	1	1166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsksZmP95vpvAXV7nf21skzbM43C55U9uU7opuVQSNLduEegkW
23665	payment	2134	2134	1874	1	1	1167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDz3rDmbdEHDK9A4nYhY9cd6zZMht67rAyaMvRkistSGNkwd8
23666	payment	2134	2134	1874	1	1	1168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7L7atXrdGZEwttceinheabRfvL81XPDMEAkqsWELUJfeGtkjH
23667	payment	2133	2133	1874	1	1	1207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMzrqd6iAGJc1AYoy2odjABKfjtdM6e7o5RDG8VGKSfYs6kf5
23675	payment	1397	1397	1678	1	1	10098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqw1rqXwnZ7osnoXF96mdpTGLBWzS4i3WtxKYjVMkXe2M25uKn
23676	delegation	1924	1924	1745	1	1	4	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYietEbQQsnR8f6sfeZ7cZFZtC9SdFa7xYdrNz4VxSk4opnPhNt
23677	payment	2134	2134	1874	1	1	1172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDFDrn3FuWQ2U3DT9Jhfismx7zYocYv99RkeLfnpYjBPZwyFc
23702	payment	1397	1397	1678	1	1	10107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqk8n3znmyfmM765K29v7QeCjqy3BRNKQDTQjr37u8ZXtnScyR
23703	payment	2133	2133	1874	1	1	1217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQFwsSnQbHfQsMvGwGpJJXLbUXDeLCtqLM9toaT9XQsfE9TGZ
23704	payment	2133	2133	1874	1	1	1218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZsTFiRZQw42cCzFdtpuhdBEH1gg9LSNacRYgLUeTFwnXsepm
23705	payment	2134	2134	1874	1	1	1181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1MBgjh6N97jgepMmCSM48NKFD24v834ZWJBuZPwoX8dY7UK1
23706	payment	2134	2134	1874	1	1	1182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJhaMy8xABb9rj52JXLizzgEGKXGjKYbZECBnmXmaVei2C1YX
23728	payment	1397	1397	1678	1	1	10115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrfoqtvT7Luhypcjd35pPCRX2tDr2k4UVrTvSPqAAwQPHDX8Q
23729	payment	2134	2134	1874	1	1	1190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpPmvWftueoZM5hxjQ1ZvNVfPrYjdvHVnKKhzW2taGjfY8ugP
23730	payment	2133	2133	1874	1	1	1226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLg28TW6mMjNRSJ39Vrvr5va9tHv6Sn7p346Dw6KPbi9wLYAm
23740	payment	1397	1397	1678	1	1	10119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8YsuQYfPZGLbBytUb2Sof5cmFB6B5a4MHfc5bWGw3ayMKb7yy
23741	payment	2134	2134	1874	1	1	1194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68RxF6NdqRDbBKEJxotnVMmQARF8WqSakFnekmhgi3Fq1ehMe
23751	payment	1397	1397	1678	1	1	10123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHz5GwU4fpNZKTZW4c2ta7vEVmfa5yMawJ4768KfvRyAZ4Y2B
23752	payment	2133	2133	1874	1	1	1233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ysWkUb1Gz24u5LevPBVa5DqNHvtw8gg8ZU7EmNXdHGuTFBer
23753	payment	2134	2134	1874	1	1	1198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUtAxvqy3DQ5xFXnbbxgw5ghAvqEsqxEyHTKS9wGkNGaCXzeu
23775	payment	1397	1397	1678	1	1	10131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanSX9gV3yJxtPZMeZCGtY6aW5vAMf9uEhgdQprujTJxoaXVWP
23776	payment	2134	2134	1874	1	1	1206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhr1wktXD4xowSZijTsrvbxVsnbWfCTSDkWpTa7pQmVZz74Xtq
23777	payment	2133	2133	1874	1	1	1241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeFpmnZzFVPASC8wi7cptzT7xKQZfywXJ4hgtgG7YdFev4kja
23737	payment	2134	2134	1874	1	1	1193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHkuSyJ81ffED8EfdK7aYK9Gq23ENHvwHkEuGHMr8TQ6a1izD
23738	payment	2133	2133	1874	1	1	1228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZib19FZbK7wRprYGFYoKvsJzD3kLSzKNL1qRBxfqjKnYAGZRZu
23778	payment	1397	1397	1678	1	1	10132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uA6EWhpULgPuWy3ECvVUyTEPA5ZxTbEuYY9kFRmzX1PAH2y7
23779	payment	2133	2133	1874	1	1	1242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeUNrwPCCyfP5ugjJUKeoUPjDai7biyxpBN9NpFwzNZSaZ6gp
23780	payment	2134	2134	1874	1	1	1207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCb7fJRyE3HxLsUBMYoUgkhBBMXb2ACw6V9Z3EfmkccLLH9mb
23793	payment	1397	1397	1678	1	1	10137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1GDS7x2TqJiZGn8e4tZ4s2kMaLfEygq9Hn6Gsos8GxL1g5m8
23794	payment	1397	1397	1678	1	1	10138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYfmEF3mP7pEYvqDmGcSZsWLKA5cgk3ukuWJ6vh8bh6SgLqRs
23795	payment	2133	2133	1874	1	1	1247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7snbiDbHC16cPbjfNtspYMz7AyyLh8pULjkxQeQ2byb9qaB1b
23796	payment	2133	2133	1874	1	1	1248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJsePEJSACA15xGNGWtDZdLMcUGpYVrZP7QVFzJUWb9pnvFEy
23797	payment	2134	2134	1874	1	1	1212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6iGsU92esGKdtYs6tPu2C4dL4TwYoUmVhEwtWFq2jis8m4iN
23798	payment	2134	2134	1874	1	1	1213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDHL1FBhqeoethbMvDs29Sp2dntkw3AezjV2sJJCQKFtTPs77
23812	payment	2133	2133	1874	1	1	1253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvs1J6QynGnT3xiq9myfYmsQLxh8Sgqff76mgJQ57dhBxAQU5S
23813	payment	1397	1397	1678	1	1	10143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE88KeGwLeYQfdSVLruaxwobkpUe2nqxMhZieqeLwoMzynUz2Y
23814	payment	2134	2134	1874	1	1	1218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYxf5ED65sSqnK2frgL8ndCZqsRLmKDbEtdfhnKiXZ3zuN3MR
23835	payment	1397	1397	1678	1	1	10151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1y7VjLACVAEdAQBtQDWmd2XSn62pgCd72TNdFZyEBspj9XqdL
23836	payment	2133	2133	1874	1	1	1261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnfPZ3V8YPn9ViWYkVE6cjtpdyctqUxXss6EUv5vyGa4UVqsg
23837	payment	2134	2134	1874	1	1	1225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKA7Hzmd3oF2iGXmDiWPg2Ly89bB6tDpwtNFbsySBG69LXHxsx
23838	payment	1397	1397	1678	1	1	10152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cKWexokL9fu8EokphssZMxzRLL3niHHSgWFCHwJtktH1uxTz
23839	payment	2134	2134	1874	1	1	1226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9E7yBNts8UVW1h9fuC3iy28AEF1saBdKo1eZxbhTRWgWowFtK
23840	payment	2133	2133	1874	1	1	1262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVm3dwLe2M787DnAUZa9CeKpNZbTaCVLH4d2BW742Muoz7Y4D8
23859	payment	1397	1397	1678	1	1	10159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHo6TfMYrTQvmPbwU6QjVSyyKmakajAPvwSiofXkKRX9RUcjNs
23860	payment	2133	2133	1874	1	1	1269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLd3hojaC5jqT5SQusR2oGSfekRvWiULCJjVnTXd5fKwev5yp1
23861	payment	2134	2134	1874	1	1	1233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKamG97gMxkbQyZnJCMjXCRxPXQPnNSYvsQJ1gkQNDyvMiudrS
23916	payment	1397	1397	1678	1	1	10181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJ2VWsKcyqwSi3dkyo8CcDqvTVRBD4iXmLsSH323p5HmhH7EJ
23917	payment	1397	1397	1678	1	1	10182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBRTYVG9SqDjeuo4UqVZ7zPKscUhD3zxoJdZVmiUmNvtviuKR
23918	payment	1397	1397	1678	1	1	10183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPpbEE5N1JsR1jmM97FkM8bS5YUBZ3qNVDqTd8HjC7WTb2JUo
23919	payment	1397	1397	1678	1	1	10184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzzDCoAxoqauHTDcfrxRL9desi6f5qL9zJXSfocb1MsANMj9W
23920	payment	1397	1397	1678	1	1	10185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygbTQLmZdwbXEPGJjGiRX5Fxg4Px2EmkvY9gbKLLT4r5cVsh2
23921	payment	2134	2134	1874	1	1	1255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6qtfSktXA3aKaFZLjsHw7fcLWevM49q3naU24ozMgfKq4KFS
23922	payment	2134	2134	1874	1	1	1256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJffXQZgYo3xc6jPiusN35y6XjhYk6UgM49frMiSDG1BQMCGz
23923	payment	2134	2134	1874	1	1	1257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaR45hdzuZuH3cPHW6EBy2Yj31yk3mrUjDLd1gLTpRswLv4bK
23924	payment	2134	2134	1874	1	1	1258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6ktGjqzsoAkdGZQANp5pZ9hWgG6XHVC198eztSRnzknYpdzF
23925	payment	2134	2134	1874	1	1	1259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwckNg8Lg7DHXW5oUM7VxUiz1iQNYs4Q96yqUQPYSwhAaYVAWw
23926	payment	1397	1397	1678	1	1	10186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3waeDS9C65FjyK7f6X2Hc3q2g2c6iLTbLbuUBBuqcehUPon3s
23927	payment	2134	2134	1874	1	1	1260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJoSW2GcDmjmvBg6oKf2wTdQHbgntU9KLdHsUqCvVsKznqcEDH
23957	payment	1397	1397	1678	1	1	10201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6u6KuCvG6Huf5b8y58EJxNXEG86i2S1rcMwtyoA73Zzdv7EC
23958	payment	1397	1397	1678	1	1	10202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5qFyJirM67HbejLcSHLfrFk4RPeadx56Euv7CPDzprEzhjQW
23959	payment	2134	2134	1874	1	1	1275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFjDyvxf1yjuc6qsMjmtVkWfoM6n1KcXfjGE6t9A36t4JdRNN
23758	payment	2133	2133	1874	1	1	1235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcmZk4X28hujxJNyGZshona32iQSYHQKE1jDxYLsFC3eRrW3NE
23759	payment	2134	2134	1874	1	1	1200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBVcXyno13HFdj8Gezkmyy6uLyDx4wpA7eZ25Z8TqfpX9kAFX
23769	payment	1397	1397	1678	1	1	10129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgyAyfgN2BdbJzqEhqaHjAV35Z9VGiygT5nsCFR4CpgaMoHvJ1
23770	payment	1397	1397	1678	1	1	10130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqeCQ9iZYV3yNaBaDzEvM8fA3vEs2n6vam8vpH7FKUsGcoxff
23771	payment	2133	2133	1874	1	1	1239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVPXaZn4joJG7uzf3hnkpDASZfCjPXs8FimhrxTi34YnzfdZG
23772	payment	2133	2133	1874	1	1	1240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9kttMTihd7A2dzqkoLdudUtZPi32eXcgnU1Xu98x5Hghkapw
23773	payment	2134	2134	1874	1	1	1204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqRaNYdhnFmnpzaqX7vTRQi4smeB1ZQR1uQG6u6RZsR58qmkg
23774	payment	2134	2134	1874	1	1	1205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVX6cN2Yb73skJ9M25iye2s2nqdb2bBV6bCxpDi8c4hdwvMMx
23784	payment	1397	1397	1678	1	1	10134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWDMZQEoCJkmJeiP9c8xhrtNFckaF48EuG9hGvJ3rau2x3dP1
23785	payment	1397	1397	1678	1	1	10135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChd85HXdSXkkxswjd1XEiAJyLx2wroXQ2EFCUjeeL3isbPejZ
23786	payment	1397	1397	1678	1	1	10136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnmhNco1UU9viqRBMCzRuCFuSdMPevGc7KZVhsHzALjLajnUK
23787	payment	2133	2133	1874	1	1	1244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9cotBkynD888e6LFuJFvu8bvSjqpBzhYNrDQTFfmcNf97S6p
23788	payment	2134	2134	1874	1	1	1209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpL7T9gj8xDKyh2Uti2SaCkXKdoSb99dm5W8oLzujBRDmk2k6F
23789	payment	2134	2134	1874	1	1	1210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KijNHtmScWYP3HcecmRd83Ao8N2omx47EHEPeMDp9yWcJvZo
23790	payment	2133	2133	1874	1	1	1245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRM83KYVeRLbaUyKN2Lgg1fWpf9vEc51oKaB4FoXQbf9u8mrYv
23791	payment	2134	2134	1874	1	1	1211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYc7KLq9tDWQZ9AdyPenC7HuyiG71Yi4wUrkdUK2yDgL4ubSyp
23792	payment	2133	2133	1874	1	1	1246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bbLYnVRAwAMQndDFzf2Yy16cAycTNb71hG4PNx4ojSpTfY5W
23799	payment	1494	1494	1950	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6tYdXY8QuKrGtxm5X8bxbGCYseha3qsBCtvmqiRRWBqyrpaq
23800	payment	1397	1397	1678	1	1	10139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwRCZBZs3ga9D9yxeq99tzrY2fkjHc3eogmfj1QGGeWjRr5tW
23801	payment	2133	2133	1874	1	1	1249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLfJqykynGyxJifH77c9x8bV4ey47dhac7Scz6ZUzojgVLmGP
23802	payment	2134	2134	1874	1	1	1214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9UbwhuhgXGgg2S8r5r3uHoFiK9WBZKQh3SY8k8vCaM1tYRrG
23803	payment	1397	1397	1678	1	1	10140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW19ussBTPzqw237qCevSzegeGwingj4jmZiAoSnY3TSoieTgp
23804	payment	2133	2133	1874	1	1	1250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXP9oH3KJUSBGH9mvwiNz7n2v3JAJUUrWm4kqyBpL7jv5kpG5o
23805	payment	2134	2134	1874	1	1	1215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhDF6FNH7Z1H2ANXdoxj7eZHGeeFgmEnHfYmic1rA5f24vpk6
23817	payment	1397	1397	1678	1	1	10144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvfmeLmjnqcqH7oDiZXXqhwX5aHccsHVrUAd8BNW2T61VyUsx
23818	payment	1397	1397	1678	1	1	10145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKVYaCjzcPnYMtNPuVxftthSZWCtEZbED6nKLXpmig1Z8C1Ua
23819	payment	1397	1397	1678	1	1	10146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QTYu2VBdCEUApnMnrZtG2ZBobi372HKztrXsB2Cc1WWqXnmZ
23823	payment	1397	1397	1678	1	1	10147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEktF7myCeywBbECLbKbmqDQR2DcnvyJ6gnawtyEicFk7qbny4
23824	payment	2134	2134	1874	1	1	1221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMTBAowW1Vf3NHAZRBNYmoS9WiU8V6Yej8K9yqSatkF2vWcmio
23826	payment	1397	1397	1678	1	1	10148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84p2Hq4SZxu2deEsZxEp2xu5cTJFKAMXzQFBUahEX1x18i16E
23827	payment	2134	2134	1874	1	1	1222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bYtCVTybESEbejRGEnp4rrS7TnrV1uBc6V65V8aCwgYiYXXG
23847	payment	1397	1397	1678	1	1	10155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqZ65vHj4pxVn4GW6RFC8WoeajwsEAkJE2E5jGF4q6Y1YFfMp
23848	payment	1397	1397	1678	1	1	10156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXNsEdZWipjfPGoFqrLcuPsUNaof9PHzjv8PKFfeKPrJH82C7
23849	payment	2134	2134	1874	1	1	1229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaB6Xkrohjo4fMWvoFQrRRX6mDsyhtsTe9N2traj5jAXbscJjn
23850	payment	2133	2133	1874	1	1	1265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3QxEzyB83mMkbhxe78HyDEhnJyFSj5GC3Y4PTRDYrD5ccYSz
23851	payment	2133	2133	1874	1	1	1266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRUZv2hnKa7i82mUNKGTdMbj5Y5oVWL1cYvH5NsexfhEdvadMf
23852	payment	2134	2134	1874	1	1	1230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLMe8EkD3M8XNpiTgzyEHe6ENwVKSiQXg19MkStHcCR9ZPi2E
23865	payment	1397	1397	1678	1	1	10161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkv9QbkNRqwhc8EfMhqqX2YwjfBpZsMwPT94RHw9r3uy74NhUc
23763	payment	2133	2133	1874	1	1	1236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2jf5hNp9ahHu6Dqr8TPpRB8d6vzTqksx8vF1Q3HUj72Dge5S
23764	payment	2133	2133	1874	1	1	1237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQYEL2M41HToWMJr4aMuyNxhtpGdUUV6hLosG1Ux3FBHVMQmA
23765	payment	2134	2134	1874	1	1	1202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPNX6Hv1Uf1mQiGQ2vu4da3CPmJAuXsT55LbPeaqsXUwN1d9e
23766	payment	1397	1397	1678	1	1	10128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqdnyPx6yotioSVwsYWVTrXP29E3nKVQ9bBVGS3RxiLRbrhnQ
23767	payment	2134	2134	1874	1	1	1203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmkzk59vqCCCsQa2HHtK6nuXTSRWcN74tqiitWQpNeiio7yvnw
23768	payment	2133	2133	1874	1	1	1238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFt53GYuLW1EySqYYwEanih6LcqeEw3ctidsdN3DzREnoB4Ehp
23781	payment	1397	1397	1678	1	1	10133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsF3Lw6p9gmQwtGhvGedt1xEBy3cY36RZ8BL3ZdomUptmnCvoJ
23782	payment	2134	2134	1874	1	1	1208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPS4MhL1xmr1jnSWAzjtAV5fGuXB5ZaDGh2XU9iTUgLc1Q6nU
23783	payment	2133	2133	1874	1	1	1243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMTjyNU1mefFmFb2zh4Zpyv1LbZvZ5iMyzovf9iuBEWdDecsF
23815	payment	2134	2134	1874	1	1	1219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42LMqZcrYBrwkWda9c8dKZfADmzRaLEDczHoSRnQmAbBdcWu1
23816	payment	2134	2134	1874	1	1	1220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxM2NHeCMgBkrK6y2exunqxbSJZ24Zpjv9ooiWCeJbyHkok9z
23844	payment	1397	1397	1678	1	1	10154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYfmvYMBAtuWdT2BCh5dVE8nxXsD7CBCk3iNgtb4CW1FJVgom
23845	payment	2134	2134	1874	1	1	1228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4HesMKzcQwBYE549tbfRW3X6pNQhK7en9T98EZCzhQ2iNPxN
23846	payment	2133	2133	1874	1	1	1264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcSTUte9TntDNbGtA7ZBM5xKrxEExzAi3B82kYhKXaohsbDTU
23876	payment	1726	1726	2166	1	1	8187	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYmT4QNZQEzdGb7KKL1vDRgUGMLgCsDwDtcpL5z9fD6UTXa1Xej
23877	payment	1397	1397	1678	1	1	10164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxjLDv67fYofH1AaBgvmHpTEJ2ogf7V27ZwYVmqDiH6NjpH7p
23878	payment	1726	1726	2167	1	1	8188	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEkhT17ohSt5eWZ3T5zHaxucirF7B412y3hvGCtcZHWHUJAymm
23879	payment	1726	1726	2168	1	1	8189	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYucNVF1GHWSw6iXhs7TEb98J7ii3VPrtsy1L53AF7HCShLms7x
23880	payment	1726	1726	2169	1	1	8190	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYePAPzpg2S18jTxMi3iPyofoUSwVMEShyvW4N81Fbs7ymxceqo
23881	payment	2133	2133	1874	1	1	1274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17GreMvpgur4qvozde1eHHb1DygjSDGjZHw3xZXzkZK1zA1RJ
23882	payment	2134	2134	1874	1	1	1238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr5efLnqfxEbzhginobB8HHrmSfrNVkJMDc4oeyok34JDCN1e
23890	payment	1397	1397	1678	1	1	10168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT95cqRM1P5K8mCdAK5zmuGiSEtqhqpbeP9u3U5w23yKaR6BQu
23891	payment	2134	2134	1874	1	1	1242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zGLdXMerFuzFQ69ZGNuUZ8npFaYi44iejHAV1CZ8HZURc2e7
23892	payment	1397	1397	1678	1	1	10169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmB2ZehvZYc5ASQ4whUT1psUAhmx9pnyCYm2eH4Cp2VxdEzgr
23893	payment	2134	2134	1874	1	1	1243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvpWiWQggVq3yckvYhPK2qDbP75MMG92vsL9AaeMnx9qrtgSD
23896	payment	1397	1397	1678	1	1	10171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb5WGTBBabBZoujj1Z39zycUk39YCKb8TnWHSECte21JSk7GB
23897	payment	2134	2134	1874	1	1	1245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hf6ckt3mYorwRJqCLXwKbnXPwSFNF3ep8jdnrbuUPE1WES4q
23930	payment	1397	1397	1678	1	1	10188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJap2RSha6tKHE8fh1SqWQjcRHg9h8a8nVatoN7YA7Nfto6TND
23931	payment	2134	2134	1874	1	1	1262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNi5oKHUSfgo4NEnpHaK6h1jyqGX3mDPhWThsvcnXFKKHWiu5B
23937	payment	1397	1397	1678	1	1	10191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ498pb9Y9dmMfzJejRhgfu46zVuLe3qN1VQn9ssbYWC9zpqR4s
23938	payment	2134	2134	1874	1	1	1265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdPgtK4FrCavuCfUJ8tpF8VhL9yW2dTBJgJh6LY8khrSVrjT9d
23939	payment	1397	1397	1678	1	1	10192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RRV8mwvBsJZPeNoAHU2ZYSum3BGwGg2phFVZ1pok6FTLM7ou
23940	payment	1397	1397	1678	1	1	10193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JhW6nNskYmJwKFH34Doy4VHurj7WonoNdbDDMRgj9wAd9uqQ
23941	payment	1397	1397	1678	1	1	10194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe2ZpSjSAR97iD7ur3TYmY67rLYsuXJD8LxaFSRosUCQvnNMm
23942	payment	1397	1397	1678	1	1	10195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCg6BzK4UvSueNhdPGxRmSiyzcYDfUeoQHH1FL9Aj2C1RhVqJH
23943	payment	1397	1397	1678	1	1	10196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zj5WKZQ4isStugS38dAqxrgrurmu8RXyPfiu8vzYuogK3oJ5
23944	payment	1397	1397	1678	1	1	10197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrM111HmHHTrttPzUZu7coESir9Uo7ebWDiForFMnzfEhVnmcX
23945	payment	1397	1397	1678	1	1	10198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiWFWp7FnfgtNPCiUWWa9Jr7iPsYf4d8c6v6w3jzZHVapq612
23806	payment	1397	1397	1678	1	1	10141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHNmJtJRbK8j4HkVsVsq27iXidK68fnds9YMNBsDUSQbg2w1h
23807	payment	2134	2134	1874	1	1	1216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFZ1JYGx336vPJ6bi9zBiBjq1cNQiCcZ5BXkN8tyqicvYTXMJ
23808	payment	2133	2133	1874	1	1	1251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEXAZYFXewtWuzE5ia1uY2tyT3irhYNUuDNBiiwfYi7XA9oNW
23809	payment	1397	1397	1678	1	1	10142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXufMNGpQuX9eaRH5CLAw2ETjXYtU8nLZNGar8as1629NMjFav
23810	payment	2134	2134	1874	1	1	1217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7AoCucsmWHkZphCnZDV3uJhi5KbwjKCzZEAqGnebbQwfW9cvx
23811	payment	2133	2133	1874	1	1	1252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSUWF6fbZyZephNbuQjYmjBDpobE6t38NZ3sCLGKyLtn4AMTSw
23820	payment	2133	2133	1874	1	1	1254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQf768fyWXvsEamoqeRVAirptaS8Jt3TMgK48rsP4ijt5ZuKh
23821	payment	2133	2133	1874	1	1	1255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrZpzfZjrdKEDCzVqnHQfRd6qzwPiZxVCjw8xvFEQSAFHU6Yb
23822	payment	2133	2133	1874	1	1	1256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2cqLGXGiyU2AC9Zzx7aQuRdRQx7Tqfu2MzGBgZpgQp7JqE8q
23825	payment	2133	2133	1874	1	1	1257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDyHCbJDSbwEiJkebVLjz7fmmcLH3V8xAYzLCKwNMwSN5bMRS
23828	payment	1397	1397	1678	1	1	10149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunYjoit3AcKrrYP5TWVWD8LdyTY83A52xXkw7cigS67xz5oHn
23829	payment	2134	2134	1874	1	1	1223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb83sPTZb78Zxn6PTDJYTRaLaYR5ovJXd2S8ny8dYrpAXeeCa
23830	payment	2133	2133	1874	1	1	1258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhccbeP8oh9mLPQrdjHAdvSzPo2TH2J13yh4Kyyn4iuavcN2a
23831	payment	2133	2133	1874	1	1	1259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZw9JcVYpnhEcVe7AqaPhox9o8LJzHMWQgH7GWyorQf8mMAJpE
23832	payment	1397	1397	1678	1	1	10150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUwCps7ZWLpyaEFZ6DhTkSsJuJy3LKB83vwbgPwzAzb4cw19g
23833	payment	2133	2133	1874	1	1	1260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBeCsKM4d8sEyw4TqzG7hYBd11kmWzK49GpdzzzA67UuB7vdK
23834	payment	2134	2134	1874	1	1	1224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUp8qrKpvxWribvFBbEeHzgaxcW5me53ZVPSkrBUfuoLmX681
23841	payment	1397	1397	1678	1	1	10153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDv91UmmKCGUyj8SYHua99poixH3Q4AZVLb2F1MPuk2iaZp5Q
23842	payment	2134	2134	1874	1	1	1227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPZfV6K6qoJeqzNQQ5bJaRH1o4Zf3STw7EDDqsyEjAX7fiHaQ
23843	payment	2133	2133	1874	1	1	1263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfS4eBs6xETAN7qegh25Bipj5SphpypcFmJhn3MLAdVGmDQMUz
23853	payment	1397	1397	1678	1	1	10157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHp4TPCT6XwhmYUneduQ7SiWEufwGLxd5mN3DnZnfwkiPLLgFL
23854	payment	2134	2134	1874	1	1	1231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4ww35g14JhyQFhFLSb7Z1W4jo327BgVnTmmhngxb6Ujf61rm
23855	payment	2133	2133	1874	1	1	1267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrevoSP89H87ta8fqBmD27JwfsiuUBPKP5n4opjwTGcXwbdF7
23856	payment	1397	1397	1678	1	1	10158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6BUrYYH2fuagb5LjQdQczEytBjrbYxAu8a6eipHa4Ncv8GSN
23857	payment	2134	2134	1874	1	1	1232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmjpZz9RUBjZjbU9BAPhqVDKSASzTqDQ2askWb6Yjwouh5Wra
23858	payment	2133	2133	1874	1	1	1268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94soomHE4uXgE4azZdSnD4mHo2CNKjHH9DhNSgmBesuHH7V3a
23862	payment	1397	1397	1678	1	1	10160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fDMR4HRHpKnmNFGgNThmGSKqEZFtLAEeBE4VwThtjN2T5EUg
23863	payment	2133	2133	1874	1	1	1270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmtXPJoCHUXLhC7f1C2XSfFqZVn2LhRqGoPtsSFCR6bt2BuqEX
23864	payment	2134	2134	1874	1	1	1234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHXX5moSnWjCx5CNzuxEBG957JcsWaAK1Se7n775aBNNMon3R
23871	payment	1726	1726	2165	1	1	8186	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhsdKEurPjBLKTudysDKyNN8GAfQnxGNkg6qcvfAhvp8U3H7Mx
23872	payment	1397	1397	1678	1	1	10163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtHLqxV4WtMYfwtDfsSvX19Z23v6wU4SMGeygjxJ5LGvcFnhY
23873	payment	2132	2132	1874	1	1	305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjQ4NZdxrxwA1qrd3AdUvNzC4yCW52LZKNifWbt5YnseT7HXv
23874	payment	2134	2134	1874	1	1	1237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Kg6FbnMcsF6CW8cnAjdABrBhPBddk1kzqewwqbBvxgkGyd8M
23875	payment	2133	2133	1874	1	1	1273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYPBVQ8nLLdDREmpzQBoMSWyzWYHjASCZpTJCNEHEYiBNUSMm
23883	payment	1397	1397	1678	1	1	10165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJB9iztZS3AUTpFQiHLh2AahahS2gH4DrCyv9eL3vBUYBcvWcf
23884	payment	1397	1397	1678	1	1	10166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVT8XsKF57QYHS2RS5XUrAP85wzSfJgSGn5rsR5YRMNgVFRci
23885	payment	1397	1397	1678	1	1	10167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LjLcp17ZdUHRm39gj1tebSGC1A9sRsvDc94qa6vLZxihE7qb
23886	payment	2134	2134	1874	1	1	1239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivBXbYY6CXpqRqAv1rea2mZm4ZyvnVYf2Rsy9YBzHCE6Z1HJp
23866	payment	2133	2133	1874	1	1	1271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1vq7vgLuKWyKbLXWPgD8s2iBw7KtosBNbq5EhYYo8B3nkKJF
23867	payment	2134	2134	1874	1	1	1235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaY7KrQUgLkc4qzJeLNWgcAAgGkyhoWdNz3ujjoa9SwFVReu35
23868	payment	1397	1397	1678	1	1	10162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nVkBUcCfybpAwXTCk93HaDumuppsnJTnS4fb7BzrXMBRmy41
23869	payment	2134	2134	1874	1	1	1236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wkMqrz71H9SGH2tYhEx7B9rQkR3qpPxMSPHpJChJCrSnbVj7
23870	payment	2133	2133	1874	1	1	1272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfeYd5vJ8Ypk14NFQA2nUH4HAveDrKxnkgNAzMaYBtpnSmby2
23894	payment	1397	1397	1678	1	1	10170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6XdQp5bt3kK26cYm3YFTGEweHkdab7m7WKT7haLJ73TsrBWqY
23895	payment	2134	2134	1874	1	1	1244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3iJvUW1oErotBRs1KoYYbjQqPya9gdFYXk59qenevcJMwGGUn
23900	payment	1397	1397	1678	1	1	10173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3JiF75EGLyWgwg8mi1DtNbKwbEbZC5oZPG14LZxEGuXb1jUx
23901	payment	1397	1397	1678	1	1	10174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVo6vRrJvTFcPSHmM4sGcvSbfTesvehauuUvZPTxPfwexWUyB
23902	payment	2134	2134	1874	1	1	1247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6K2Xhvq9JAHMohyrRydzREaACJ1dEhYXivxZAAEHwE5a9MXT
23903	payment	2134	2134	1874	1	1	1248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSwbYNsuMqHXohxRYYYhfwYYk1czmXCdbyNndEHp446Ak9WTe
23908	payment	1397	1397	1678	1	1	10177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMcJ5dASXSDQzftZ7ePSyRgFDzi237mtw5KhXHrgjSsUxKFfZ
23909	payment	2134	2134	1874	1	1	1251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTv6cTQbDQUkSGcqUxTAmVBMfWkuQLFZTjPRhhVaKzupb4a15
23910	payment	1397	1397	1678	1	1	10178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSofrWzv6uwtC6y4dT8S3tt6jfT36ykjontBVGLL5mE2CgyZN
23911	payment	2134	2134	1874	1	1	1252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa284Uhvc1U2xrJ6P3V6fRLinYiD8T1M9cWah69JPz1a5ERTp1d
23932	payment	1397	1397	1678	1	1	10189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfeZiBRHmaAB2Gs5CR6Sw1gNpvAygVHUHfkPNM1zfRMVmnQAC1
23933	payment	2134	2134	1874	1	1	1263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRcu6bGzcKjf74q1F1ZCnZf7uUm8VGNfKGvCVSVbQKofhBQdeC
23934	payment	1726	1726	2170	1	1	8191	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbtzkCg51EYrqu1EBB43ivukwqLjB1SCtqBj3gkZw1qg5XRAXL
23935	payment	1397	1397	1678	1	1	10190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PSGgFx2yDB8zBurhFd9nEPmfrJ4qV3iNED4jtFpqRdtmCy3r
23936	payment	2134	2134	1874	1	1	1264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSG6muKB7UF4HbvCxbropLh8tLncQ8G2mqbxauVBPvaiGEgUp8
23973	payment	1397	1397	1678	1	1	10209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaPtRMXKnsJzkpPwsijUAmmWWC1fs7m8D1WwvA1ridwJV1TQj
23974	payment	2134	2134	1874	1	1	1283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5P3yYM3EJzqkrQAhzmde9tuw28aq9i5KDnYLyRUeH5xsvrysw
23981	payment	1397	1397	1678	1	1	10213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDv4DDJ1VTGvLqAh2WDwhaUWWDtebmmPrLm48Zop67fpXS4Bv4
23982	payment	1397	1397	1678	1	1	10214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQk9F7XfgPJ3nEz1nuZd4N6LksC4H3ceuxsm4zocAcrAf1hqB
23983	payment	2134	2134	1874	1	1	1287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuGVS4FRmarWy4vvy211JxrR6rjj8gHT1FLbtocViEZnvMCn6
23984	payment	2134	2134	1874	1	1	1288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVa2HPi5PRFH9mqmRxcWQZMGaxw1LsFCeSySZ4gSJqqDvBaX7
24002	payment	1397	1397	1678	1	1	10222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdcG78QXD6iwZ1FzWQ1idpo7t2eZcehYcwCWhwPV6PoBxFpbu
24003	payment	2133	2133	1874	1	1	1278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4729wp157cW6bwodBdiKRxSeFW4LmqaGAsSVDN6jHfTRNspm
24004	payment	2134	2134	1874	1	1	1295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyB7gFeeot8b9fYgxkMUVkUofKLC2sbTbdQPARXaMFKXezqCU
24015	payment	1397	1397	1678	1	1	10226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp2yDFRQyT78Dq2bbwAW8s9kL3Xs4yMPCHJmEuNAsySWvxycYk
24016	payment	2134	2134	1874	1	1	1299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYx8VWoSn5kEK4P6LNJmiCriW4iidnX34p6UtfVTjYW9gkbPLg
24017	payment	2133	2133	1874	1	1	1282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFozb3YQwUzcVk1pv9xsWJKEDC5aNiUDpiA9sW3gCSY1tHoqeB
24036	payment	1397	1397	1678	1	1	10232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1UzutdsJwoc11mxqjRiJds7F3QLurCEzDmSnQXcFeK87EDCR
24037	delegation	329	329	329	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rbxcSdJAu1zUCg8eQdJp7952ZZeoGCD1YUad6HLU1wNMzPTf
24038	payment	1397	1397	1678	1	1	10233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTpfLXuLQ8EG2R4FNaZLDcssn6isu1kWmBXds6BCi3m73mmya
24039	payment	2134	2134	1874	1	1	1305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeEPN9g1GGEERmToQddNC5z2arVaEXKvhYx9xi8cJrzLVzrxj
24040	payment	2134	2134	1874	1	1	1306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYaDEndCT4WVdPDw6eP2w7FRLFfT7TKzrGKyig5PRw8Zfs2jy
24041	payment	2133	2133	1874	1	1	1288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDyjJBHgAsfDQ1bmtjmJbiF6tLdKFLrQHNXNKJ6ALLGmoQihV
23887	payment	2134	2134	1874	1	1	1240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1W5a6h5WyiWUkDs4RLCc3dEBxuJRoeMExFdNcJvCRGwBNCPi
23888	payment	2134	2134	1874	1	1	1241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5x9Ti1D7oftja7pKmNkZKxUNThDtR7u1F8EugTRumhY4HTdyw
23889	payment	2133	2133	1874	1	1	1275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTnUAzogTGyqnCDdL8cDJGgWDjvn9HE4RQx4PhbsvJJa2XV5N
23898	payment	1397	1397	1678	1	1	10172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK17aRn58edHMhCXL1gStQHDYP4xoS8Nwgf2MMG1EYqmqCao5k
23899	payment	2134	2134	1874	1	1	1246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3VEez2jJ4VZSubHiFjQ1BnLyAmJxCuRQS1VD8NfgNxJfxzuE
23904	payment	1397	1397	1678	1	1	10175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9avCkdpTw2gWguEkqFD7omyp6pNuVUz14EA17fd4u1gY57bXt
23905	payment	1397	1397	1678	1	1	10176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCbpWqesMi5WqCfxaDeM2VyEFgCYpT6pjTQeqPpKAuuHS1G6q
23906	payment	2134	2134	1874	1	1	1249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TtF8a8xUSdcdzXb772NTC3VvBv3QzKuSRY6Y7PMoWNriNMp9
23907	payment	2134	2134	1874	1	1	1250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qLcNj37W21DcbTsRm1c8vydXJz2nwUN8RcKkgGZNs2QUHSrz
23912	payment	1397	1397	1678	1	1	10179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUpqEVs5aWu7dz7WVTQbdC2x2fPRpKevycz8nDtmtWBRihSbX
23913	payment	2134	2134	1874	1	1	1253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjANMHFu3U6Q4bPgohTZ1DXHCxbJq31uSTV2LRGRt9GUmRcpE
23914	payment	1397	1397	1678	1	1	10180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsEsnKkj7XKshy3iNksddHxTUfbMpyzH1BhUbafgQiqgkuYPE
23915	payment	2134	2134	1874	1	1	1254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSuwsbZxjJGfPZrGWFvsYv2ypyxAjZubitnqNGhGCkfKDdv2t
23928	payment	1397	1397	1678	1	1	10187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYi8ADAcpqpKhcpPYbzBmRKtTCeJyvhRUSCiktntyjQHYJYiF9
23929	payment	2134	2134	1874	1	1	1261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3KsEoYANk23uXDvtbSRtJBLTFBcvbuS63FmWqehmNZ1GqgCa
23961	payment	1397	1397	1678	1	1	10203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDqLDay1cBWchJFEiY4exnJuaw4PG7AT12CYYyi71AW3mooQ3
23962	payment	2134	2134	1874	1	1	1277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBo2V8WreYLS1aUrS8rwB2NSepooLF13ABxqYyh75JSHdGPXdx
23971	payment	1397	1397	1678	1	1	10208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHiY1zeBvSBpVhG4aQVERgMQCvsa9nHPtbMSkbKQsNEt8RHJW
23972	payment	2134	2134	1874	1	1	1282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmB8rXmQUNNQUJtn2rmaHnkhbGMfHgvscK9US8cJmZgaC5nHL
23979	payment	1397	1397	1678	1	1	10212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9mJQCpiQXUWgoXVFXbuXV6cJXeeKkm86BuxMdd7rxsrYTHqU
23980	payment	2134	2134	1874	1	1	1286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEZwZSMCa45eQRAuxnbwCU7hRy7yXmopgUGJpT4wvdv7aMUxoq
23985	payment	1397	1397	1678	1	1	10215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPVUvUXX8mU8ocHgd2DMJfPa5DAvMGCjNQqG6YQUvrGwoNFAr
23986	payment	1397	1397	1678	1	1	10216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eH2yHJYHiJL3YN6drsq2MAfLvVRgNiC2gQgHnFNGmQ6VUagz
23987	payment	2134	2134	1874	1	1	1289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAzcfNUBHYkMdeNHR3tYRPjvHF5SojDCDgwRZTxncw6qHcbhu
23988	payment	2134	2134	1874	1	1	1290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwPpRgGfz7xm7bNHHkQk3qwHqvqFSnKLcoVoTZwp11js7SjTqK
24018	payment	2132	2132	1874	1	1	308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnwTFtszkzcWuf42vpyxoXhVWbs1aLayvsJtyFCxF2cZSQptG
24019	payment	2133	2133	1874	1	1	1283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4B5j2yZb3TSEpW9dTqpf3LPvbEsSYfF6B371PJu8sEsBtJBD8
24061	payment	1397	1397	1678	1	1	10239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdmZh2zQNsjfX1MS5DyTPueTCtXdkE2DSrpBJLNe7Eeto7AyC
24062	payment	1397	1397	1678	1	1	10240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFv1CXZpSj7SpD64FzLRfwfypoF6oLPS5RrxSMsSFWBsNeWxaw
24063	payment	2133	2133	1874	1	1	1295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qW6gzxXACfjYcirdioHXKBFu6vqR2vmyFbQh3f1xXR7o1YW7
24064	payment	2133	2133	1874	1	1	1296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmYAhk3jw63FGg7Ch2gpj3iL4pm4ZCTMA1UVBVo6VaTJwzAjP1
24065	payment	2134	2134	1874	1	1	1312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93ihFbowRrzJYKkA8mNPnkCoBRNKbCYzJHeqzvmGTZUNeYg6p
24066	payment	2134	2134	1874	1	1	1313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpSNEjY6v6RdesxPEGBNqajs574bQmixu1BGT82t8TMUwoB4A
24077	payment	1397	1397	1678	1	1	10244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSd9gu6sSoKpe2tKtJNZs2B9siiy4GBTpBpzkAhV98q8VZh21t
24078	payment	2134	2134	1874	1	1	1317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigVzF7qKe3YnBrSPhvJGVwraZjQuMVF7c6VeFyELAfQs5Ld4y
24079	payment	2133	2133	1874	1	1	1300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaGMDAEzdtgZDtzmAMJ3Nvah4hy6G7Mfg5rYNEVPuuVRCrnjy
24080	payment	2132	2132	1874	1	1	313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1771oUDn5FbBXBcMZPkCpB1JjwCtgAQEqcEdXExkxfQsLoFc
24081	payment	1397	1397	1678	1	1	10245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYSetCWxLty3okWsi1iSrW157AHrbrb6ht6N5J474avHKJgaB
23946	payment	1397	1397	1678	1	1	10199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwfek4o1MvP9nDcjnL9QLmM3EmyJ8nFQ3SACXxuGxatRqqtSf
23947	payment	2134	2134	1874	1	1	1266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrw3cJDjKd42dV5iiNHtnqkLc33BRFa5Wv1tWcbn9xK84bV9x
23948	payment	2134	2134	1874	1	1	1267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxQqWaMsbT3qQiUtXC93HWV1ysQ6HhZEbYFL9RtFh8u7eHcJG
23949	payment	2134	2134	1874	1	1	1268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ844n4jwe3Vi5NkgCD9xGzrmkdQVakM3j4YFeTxLPcfNr6HzMJ
23950	payment	2134	2134	1874	1	1	1269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZradLrNpNJr4jFYPhVRj2aZUfSAWLHofZRKWaZKD4HX6rW9G
23951	payment	2134	2134	1874	1	1	1270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxC8btEdtA7EDeHW9LPHtUGTrWZBWq7YE6UiEjmpv9xVcrPr4h
23952	payment	2134	2134	1874	1	1	1271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKD7xcXRhK1ZH26ABff1mY8sZ9CnABpyvcYQunsEvwCpFexqVX
23953	payment	2134	2134	1874	1	1	1272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4SDKkGz4GChD2HAfmbrRRDbJZHHxVbYZZRJUfJjVaEogEus1
23954	payment	2134	2134	1874	1	1	1273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdJVFHNotCz2pQKaWfEideEnd84UHzazi92mT7zpY89wiF29X
23955	payment	1397	1397	1678	1	1	10200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxN5CfCM7pArjnhZwsyzjMXDw1cmwqUeCsLNPqr9quGBvQ1oDp
23956	payment	2134	2134	1874	1	1	1274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiYFJSyFwQNjvyxfY3BT2EPBfhns8Hmbi3RFxJr3PorzPsxug
23963	payment	1397	1397	1678	1	1	10204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZBJBn5xp69uLtbsCi68Lm6h93uf3ib7rHpcyeD3NrbvwJH5v
23964	payment	2134	2134	1874	1	1	1278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPs2KYcygz8WLCWbDiTX8JfksXwxV6BF7Sdouj6b5pegqPWmF
23965	payment	1397	1397	1678	1	1	10205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhq9V3EHv9HU4kdjvkLAWysuQAehB5GoJWhFH3hU3PC13iLJR
23966	payment	1397	1397	1678	1	1	10206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaCvAsYoRTso7SK3hKDSk8EkM25pN73ZjzQxVo82MftCMaSE4z
23967	payment	1397	1397	1678	1	1	10207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkBgRVpXBVQZd6R43LgorGn2z2UjoQhnPzyrhjm9dDNAMKVjY7
23968	payment	2134	2134	1874	1	1	1279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKudZnt2VGyxdvey1uVYJ4x1LTbd9usdm15gPzSEmFuKJDWWX
23969	payment	2134	2134	1874	1	1	1280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vVwmE77yF6JK7X8SzeKVaXmjqDuLaq18GbFv9L1Ckk4KuNRZ
23970	payment	2134	2134	1874	1	1	1281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJeCwJCnBYCrtCbvqDCkLFysmobc2G9dXbCbMFUEcGVNX8tga
23977	payment	1397	1397	1678	1	1	10211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyCpqYBrvPJrmhmF4LHDuMW5pLCKU3ZZV29zUNN18LqSaJ4M5
23978	payment	2134	2134	1874	1	1	1285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhzDNy86FULkCjmsqMCwRWaTaGeydBx918KxkoHrDGRjUVWHL
23993	payment	1726	1726	2171	1	1	8192	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZsrncaaTtD2gBsk9fBcuqYiQVRHPetpDucRQdU2sLpyEgLpNGt
23994	payment	1397	1397	1678	1	1	10219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxs5jhG3aC1zfBkBKoN69GXNqAsgXC6WzFqQv4xHGvQpTL1sS1
23995	payment	1397	1397	1678	1	1	10220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwzsxUMWWxxDiKHQ5pdVquFNURa5319kZCYGH8Kg4nnnePDFM
23996	payment	2132	2132	1874	1	1	306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVwrjKvTQy3R1tYyTLdpgCHQMyVWSQHVGqvx35rP5yLEKSG1U
23997	payment	2134	2134	1874	1	1	1293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbo9xyH7Rz1zZYrvKZmFhTrmTvYnvPZPK8eP7Ch9zng6Nd1QAU
23998	payment	2133	2133	1874	1	1	1276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4y6CcnPN9BexTvbzFhRGkguvBhWBbVw56WeY5Gr7XVfmwgXk
23999	payment	2134	2134	1874	1	1	1294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMMdXLEfWp32x5cYPLgsw6V9CP7QFsbbxPNkdDdu4db9WHAwA
24005	payment	1397	1397	1678	1	1	10223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7N8baRVe2ES4KHmdLYcTDAHFaB5DbMHwAYfwEuG3tvDhU1LD
24006	payment	2133	2133	1874	1	1	1279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RjCvKzMTA1p32yv5vpWU147hs22wyEJvmkXKfzN6PDLqTQou
24007	payment	2134	2134	1874	1	1	1296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHQYXwrDWfyEJ2b5BxbDnnvZyCtqyViWUdwYrCBV5QYQVmTnT
24020	payment	1397	1397	1678	1	1	10227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUix8t14k8NmXCMPFaepesP2cXVAuJ5EnzsX9SETHrHr7ze9aU
24021	payment	2134	2134	1874	1	1	1300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3bXN3L1sa81V3ERSRGyypMU6cMvU9ZCSZx7EJHGTKaZ9FcUSZ
24028	delegation	338	338	338	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAqYnmwJaitf8wVDiWUuMfBKPmbK5cHz8iHT6Egkm9dqs1H6A
24029	payment	1397	1397	1678	1	1	10230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFsXiDJ18GEYu2wh8QUaShps8PQERDtzh1xgLX8TV18kDE6j8
24030	payment	1397	1397	1678	1	1	10231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahfcBe2X34m4NfEzLq1JxADkJuLcP92y4cygvkMjV6LedMKHB
24031	payment	2133	2133	1874	1	1	1286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwWaauCTbtaCa5bAGdgh3oDVv5YUK34gr1RQJtDrwkq8pziHVS
24032	payment	2134	2134	1874	1	1	1303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykvpuFxveENYFq1N9jeWkiM3fVo12tUo4rX5M8xMUvddZQnDG
23960	payment	2134	2134	1874	1	1	1276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SCc3uJWFzxLKFSe5o9giJfHcYcbhSzBUbTPghNmmEN6thpkL
23975	payment	1397	1397	1678	1	1	10210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HqgNa5CN94jMJAZBLsSyEdGE2LD4VkafxtnUZeXoaN3Mf7SW
23976	payment	2134	2134	1874	1	1	1284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpi3LSZvpNJvRfvEHXYK9AyLFfnSEGWpG7vCw1eQu26PoZ6Xo
23989	payment	1397	1397	1678	1	1	10217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYUtB1mfoVJMrjBSwQENxoVsGWcUpyT4hWWUK7QxqeKRximDe
23990	payment	1397	1397	1678	1	1	10218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfVqYDKSgrrwc5dXWEhjqmJP5BBoaW3WzXu7GLgdAVAFZD4e4
23991	payment	2134	2134	1874	1	1	1291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7BNJHfVWxvc74JvfLfgBPoXKiUeM948mKLQRRnBnMCJQZc6o
23992	payment	2134	2134	1874	1	1	1292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY5xAhNFSHHirpkwugEMqpswPM2u69NNynyDZFvCMStG8MGbK
24000	payment	1397	1397	1678	1	1	10221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpds2rLZtdUHByTQx3VD2MSYpBNitaVdS1L7qh8CJQbH8QeMC
24001	payment	2133	2133	1874	1	1	1277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvpwBpSc3aiEiYzApm19sPkpGoQjsbNXQxmvPwtbfrSU6Veex
24008	payment	1397	1397	1678	1	1	10224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3esvbqCa7goZMwZoTR1xivL5y83eLSJkHBL9dDKzuvRSt2Ft6
24009	payment	1397	1397	1678	1	1	10225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXk9jv5ukq5RH2q79ghTvdJjsEStsrcrSB9kZ277BEjyQ84XJC
24010	payment	2134	2134	1874	1	1	1297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwuBJdBMo7YwMdfRkHXuA8Evu21J1oAT1aaiB9VbZSgrU2TT9
24011	payment	2133	2133	1874	1	1	1280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvnNdBgRAAa3dLqSexFgV7DtacdeiwmvskKa6QVYqR7xZ4hm7
24012	payment	2133	2133	1874	1	1	1281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUFKRjGU7G4jaCXYf3RbspVMdEVGdkBkf7T9vVAG4yLRea1qNR
24013	payment	2134	2134	1874	1	1	1298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuoh7KKuyQxNxpjbAxLAkFUm8tad6pS1skJe63VTPpcLiaBtcG
24014	payment	2132	2132	1874	1	1	307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAB8Hs6mMfmA2kW33pCeriYEJ4of1dSTHzNJGn3C2Zj6fovtuQ
24022	payment	1397	1397	1678	1	1	10228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWWeBiDYQEptDh3WfgMLEwigTGkaZjcNDSHt4MGQX9uauwUKH
24023	payment	1397	1397	1678	1	1	10229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfX9UHVGvPvmUGZqqkMNwhjjyVgwXR8WYZ7mVfcxpd6sXt2Krb
24024	payment	2133	2133	1874	1	1	1284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYavC7NZqH3RksSNTZbLaBbPsSBZfsZvQN844YNTSGjShE3my5
24025	payment	2133	2133	1874	1	1	1285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweDA1G9SumZUSFvNkGXuyyBEtrG4nSutqaFz468rAYGGWyrEf
24026	payment	2134	2134	1874	1	1	1301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyibdBEe1r7UXKcCmbUbWusQUdeAyNjBmUp4o9LJRstvnE6WT
24027	payment	2134	2134	1874	1	1	1302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4d7nkRN5ebnnVNSxTZ4eve74XRBsReBckNr4t2CiXQtk9dFrg
24067	payment	1397	1397	1678	1	1	10241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36mRaPHpVeKNajMNmbZ7F4v3JbNjyXCSbcffESJUQYzi1bYKn
24068	payment	2134	2134	1874	1	1	1314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHA7MMLUqh9MUpPY6Qi19jQLdbgcPV1eFQeBV44E8r8ZCwBS6
24069	payment	2132	2132	1874	1	1	312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuhH8HrHwKxW4ehknjMaKWRyRXCsu2aGhgCBpE9oSBvJMrgxJ
24070	payment	2133	2133	1874	1	1	1297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpM5rg4gkFqJREsfeaMNCGJTWXeZYaFSMn4P7frGTtz7vMjZvi
24093	payment	1397	1397	1678	1	1	10249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYAmjSdK4u2GKpULiqLXw3QhBobYQCMEej6r49pDvx7877yuTj
24094	payment	2134	2134	1874	1	1	1322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQQ2K6konqPWUhaPU3QQoKaJRDskKBREcZiLRLoFWqvTCtGN5
24095	payment	2133	2133	1874	1	1	1304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb6PGP7uNJKuG9Cio4mGcZfr9bfUbBSUs6uwHDANPVN6hPca4
24096	payment	1397	1397	1678	1	1	10250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKjeMh1Eh2kG6kTw3TqHPYxXY3D5eFeJxf8bxQNxDd6FAtKPG
24097	payment	2134	2134	1874	1	1	1323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LUXuEmiXeNFBF4F83Jmf4vYPn9KRdms6ALWpUM7m6MxC13KY
24098	payment	2133	2133	1874	1	1	1305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9scKDhPs837RyWsb4UeoF98NXChJqkCmMNDn6wSEdoroRnjF
24149	payment	1397	1397	1678	1	1	10265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStGbc9aJFEtRnDuQdE4GnuZZN7pV5tSzBKqHXsAsPUioknh4k
24150	payment	2133	2133	1874	1	1	1320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCuedE6k1X2NCpqiNY3Cqm9QwkKzJCLfRoxhqVqjfuW9kAF9xw
24151	payment	2134	2134	1874	1	1	1338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX67w4HBQmVSAAXs6aGsL2mRSEhEE4kxWgMMrY5gUTus1fW4kw
24161	payment	1397	1397	1678	1	1	10269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVapMCdVeu3dJ2U7zUtPvDwysM8VAt8SgQvFT9qQ6RPC7a1ag
24162	payment	2134	2134	1874	1	1	1341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJHKNrEt9yjGq5dc97udbGFw4wWNjMg6MUnjy5BT3haWbDbEw
24163	payment	2133	2133	1874	1	1	1324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLkFBVNd1pXXPYcyoRpGeVujykLeiqpcYwXQRgm48Wcqmm3bsa
24033	payment	2134	2134	1874	1	1	1304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsLB99tpi1ckr6SqFvZN791oexQaAzYvGJa3qNxiLm7b2sahK
24034	payment	2133	2133	1874	1	1	1287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQcgmkHcioUwED334nFNf9zCpFmG486mWef8XKDNXnoqteCPE
24035	payment	2132	2132	1874	1	1	309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmC3hs9z8dCb8Md7NmL2QU5ixehFgwvXpFUPZ7m3W9WkYFzkGS
24043	delegation	1789	1789	329	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhYp1eirkqtj7MzoDHc94Wu1k7LmKzYrTHjJghwKQtGb4rx2e
24044	payment	1397	1397	1678	1	1	10234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sZEgzNShNT3v8on6UBxvRk4yWt5M8HYjzAyXoc32Ei8SrVGd
24045	payment	1397	1397	1678	1	1	10235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vt8kAmg1B6TXnqkXK1xAeY9SDPh7oWLFmFF2mDSzJDtSzmo6
24046	payment	1397	1397	1678	1	1	10236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4VSRwG6KsCzzdxKYq7CFtp1TpKBXds8tCKV1Mfzq9T9H7V45
24047	payment	2134	2134	1874	1	1	1307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpAVv6nJ5eEcjhiFEu7cBNVAiUTcDZtKb667cE86AsQuG2tPQ
24048	payment	2134	2134	1874	1	1	1308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpEYV1gnvZC7SftSgjmZXJqWRcwn83NkM2BeCjWNSvALyuMZn
24049	payment	2132	2132	1874	1	1	310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9txeJVKFLS4bwdPeCEPrRToL6bGnc8Cm2m4V5L27vRYQmq34B
24050	payment	2133	2133	1874	1	1	1290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDquUh84LREtKPr313CMVWpBLMNPaJX95dcxthG7dUsi4n9ka
24051	payment	2133	2133	1874	1	1	1291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqN8uHwRQ8gVexZFWFyRXoXmKRwpF8tfXeAKLw1dneSc4etS6v
24052	payment	2133	2133	1874	1	1	1292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkmeyoXEKwJLbeoC8oYLhrDV7u9zRpuJrfd5fgL6AXG1bs74Yb
24053	payment	2134	2134	1874	1	1	1309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aRMQGCJTkSg3axa31TqjsjbccSVmsqJYhXvZnr3zooYeEuYw
24074	payment	1397	1397	1678	1	1	10243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALcQEqootLcc53cw3oaTqrmjfBSvyrPu42zw172CNsoY2NXT3
24075	payment	2134	2134	1874	1	1	1316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXZCEE6MUc3ghftuYC84pb3TLEpuX19odzMX2DwA5ATGJJF9s
24076	payment	2133	2133	1874	1	1	1299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HSDzgFV4Kg36cwfqGYFco2nJrgRt3gyFVzDobiqax66hkZcS
24099	payment	1397	1397	1678	1	1	10251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDJnhJnJbNPyJag5FHd2SCQ45aMz2NYzjdsDRNBTdmKH8Ndbw
24100	payment	1397	1397	1678	1	1	10252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJbsHmB3uy3dM1AykQDyLyp3NbeYq3gjvbrPfuYexfGRkZLUA
24101	payment	2133	2133	1874	1	1	1306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoS5C3gnQMSQcddd3whSPKwzec13qintpwRXTGaR1MjZ7pH64C
24102	payment	2132	2132	1874	1	1	315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFra8Kzm8Z1hmvpwp7gLciq8VHVk8m8o3r3qbWAxJaLqvCudwv
24103	payment	2133	2133	1874	1	1	1307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpGXy9FArxwy2RCVyneYCa8sAGkUSJFzsCr4xr8u9Qt9NRuQn
24104	payment	2134	2134	1874	1	1	1324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpdeBnphP8aLweR6M5X8zjnHSKEvXJPuYi7tmCVG6JRVfdC9q
24105	payment	2134	2134	1874	1	1	1325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisGdSmrHhDiaPXqkiUhP9ok43VjUA95B8sZbtTzVRHaTsRmpU
24113	payment	1397	1397	1678	1	1	10255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpE56vJ8vKb7n55ku88k2vmqAS3vYuMi8q84dAyATmuLdnmhu
24114	payment	2134	2134	1874	1	1	1328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiw4axSCLfCJ42UDKmtEehFE1HjWckqZfk7tXLcxRtXrKAgatR
24115	payment	2133	2133	1874	1	1	1310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrcbkyV1HzMmZbtjiwu3atSin2UWRK5XH1a32TCfMDVS7njP7
24116	payment	1397	1397	1678	1	1	10256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXAVgKbxaDdxnwCurgvZFez21KecwPCpmPxqY2VAsd8Crna9n
24117	payment	1397	1397	1678	1	1	10257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBGdDoyceDu6b2SBwL7KrNWHZGTzDLTUhcZzGNHEH4pbaCkaF
24118	payment	1397	1397	1678	1	1	10258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDRtNGzP5s8mkXs4kp7YvrSrTvHLFPH6GkRrMwiT8F8DgCRUG
24119	payment	1397	1397	1678	1	1	10259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5K9fGCUHCvTwQd91zVVk2aDvY5V7mnfMC6XkTh3hcMJwBFsh
24120	payment	2131	2131	2172	1	1	0	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpYii1xw89hhqi7gStJPoZNX7AvNBW2BsonvR3Kq8K3myxmQDWXA
24121	payment	2131	2131	2172	1	1	1	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpZFzGojWTuDqj36D53sZhsZnJD6RAWBSxe6gkTWtj6FFf5YANY8
24122	payment	2134	2134	1874	1	1	1329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzYBKfBKfyPY2byeWYVau4rTWWpaBN5fvp8kQ9BS2ZZ7vygDr
24123	payment	2133	2133	1874	1	1	1311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZ5XbwYzTUDhQThBNvUyamH48Sh5chmt5zfFNdFR9dP6sKbKx
24124	payment	2133	2133	1874	1	1	1312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYge6zASdBcr8F2NwYuH471RAz8yW7EQkjXn9KEhcDYqxRZ9bTr
24125	payment	2134	2134	1874	1	1	1330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9WBAtxQZS2RMs2Cd1fqsvGJUJhFbzDa5VrM7trNTpo4wZqj1
24126	payment	2134	2134	1874	1	1	1331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEwaNMkNi7H44T4Bc3xpStSn4Y8ntFdwkF6DkuEpuSeCLzg3C
24042	payment	2133	2133	1874	1	1	1289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbEz5znQS7VX2LvQPcv9QnASNZNVcqpU4gUMRDyEQQVaP4Ctt
24054	payment	1397	1397	1678	1	1	10237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFqDqQJR8ssWY11EqNE8Mn624WXjWAexqf3BH5cJJ8UBGpMCTz
24055	payment	1397	1397	1678	1	1	10238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsqMVJTwckADtBzYbs9vzTvTd8uHn2MHyPN5hsD6U272K81kNJ
24056	payment	2134	2134	1874	1	1	1310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWK318zRXtaejHAJm36Rg9ixmHmFzgcXZJRWx2uhKoHZaX6HBW
24057	payment	2134	2134	1874	1	1	1311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYit1wpdpQjd32JXrWRga88gwdkGDWHbi7sYfMK4vuBypR4APKs
24058	payment	2133	2133	1874	1	1	1293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxrNFdnZMEnbnU16vmodGxKYTAyYCd2c6bfjnAj1ypmpN1eJf
24059	payment	2132	2132	1874	1	1	311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVuWEheS4vydcXYTcNdgKqhHM1p19cUk5ffFABmcpBsqSsKVv
24060	payment	2133	2133	1874	1	1	1294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGSNWDogoTBw7MX4eXM1RuzzNYxtdKKzXbdLokvaVNqo2Lb3j
24071	payment	1397	1397	1678	1	1	10242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZdKd7oxQoLUwG5Rpc97HnEtnfVBv7L1TJM2ZbHhHNRJRi9SE
24072	payment	2134	2134	1874	1	1	1315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpWtBrCXXJ9iZfMwMWXCUnWTwpeBPsK8m82ZJokYvsWBNi9SD
24073	payment	2133	2133	1874	1	1	1298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVjaKWc6t992HfJGtBsskj9Vsrh4cVczVLSYf4fwPgB7cQ8Ep
24106	payment	1397	1397	1678	1	1	10253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXM9gemaDBRoyS46kWfW8SD4stGWv7gZkw6RdxySKLxndDh2jY
24107	payment	1397	1397	1678	1	1	10254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTUaCY5wV6YxPxF2U5gv38JpoyzscsBsfnnzTZwzeyuzWDfU5
24108	payment	2134	2134	1874	1	1	1326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7tqp4WZRW1d6kepSzwcvhfJpa9QwLbWTZ8qxJcRZPKWpS7hD
24109	payment	2133	2133	1874	1	1	1308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EndX7nzKd2bs5isc3SKoZhoBw2VRDzPhSa18iuWpaF8Pm6SL
24110	payment	2133	2133	1874	1	1	1309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwA7dGRHe2c1MFM7J1JHKc7hpNKh99q6N41eT2KLTSLkx6av8f
24111	payment	2132	2132	1874	1	1	316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbNsiQCx9aeLFeHDP8yTax92JhYwo191XiXdTbS6rn5mKvdGy
24112	payment	2134	2134	1874	1	1	1327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpvWHrvksrY9GY74c7sxUnnpJAVQUXKuAChLrrK4wcFuvgNxo
24184	payment	1397	1397	1678	1	1	10276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hhdMPy5fpFzbZbtdzVvR1ajjaupEnNwLyC1qe1NmHus8y7z8
24185	payment	2134	2134	1874	1	1	1348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM824AeqCK2E1aKEosW1ybgXprYC9bh66Dpt9hrxj2XH6g3v5J
24186	payment	2133	2133	1874	1	1	1331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdxg4PMbC8bY21h6sWS3npPkKxUffBk9apr8wSzwtxBK4DUuK
24206	payment	2134	2134	1874	1	1	1355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPX8P1SrCRVmgLMjBEP6XP8X7HdXHwX8wbmaSR7b7JzxD6dV7
24207	payment	2133	2133	1874	1	1	1338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEejKcT5rGFPEp6LUKUk8DzgURXg65FmEop3MW1iN4qvQddRRH
24208	payment	2134	2134	1874	1	1	1356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTE3X1FNopDZ1BHX2sEngCwByUUReUPzHZsCQ3LkepDHfhs3ND
24209	payment	2132	2132	1874	1	1	325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqzuEhbiu28YzziZbrV6xdhhfCVYBmpF7LaXJE3AsTCAdhPCb
24210	payment	2133	2133	1874	1	1	1339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEBZJ7swgiE4iRb5PgNvqaVSZoamEUTVfE3uaEtfoP4cNgXxH
24217	payment	1397	1397	1678	1	1	10282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cLTwY2SPBA1PAfZQ8EWYoD7AdVnsMyd3a4jKfJA7pKScMAPT
24218	payment	2132	2132	1874	1	1	326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9ysQGLvFtED4ceDRKvpTxs46KZdW1Z8Egc35VH5UPmeV3tKY
24219	payment	2133	2133	1874	1	1	1342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj51vvzqtZYcSQLxzpPYxhNtijBUEYTPNcrRziLzJHXtrRy1VV
24220	payment	2134	2134	1874	1	1	1359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZws3NfqkAhvSskhAdud13V24rozB12jqCMAomsUzJoxBQV9MNS
24221	payment	1397	1397	1678	1	1	10283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rCd2UvGXWWaeJ8iN3oqLNASK6Pu4jQpGg1V9op17bg7j5rnH
24222	payment	2133	2133	1874	1	1	1343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9zUVKjzZM1naxaLE61bGVe4hQ5PVB6HehJnzL72qUeS2uwW6
24223	payment	2134	2134	1874	1	1	1360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwT77UaXnHWDV48u4sFsiGVHyeS6NLLp8aZkkynVgqFf3e3Ag
24234	payment	1397	1397	1678	1	1	10287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouv41nrzZrwa6TuqLCs7ZynCRNrjTFfRr81G94ZhyrqSTo1H4
24235	payment	2133	2133	1874	1	1	1347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRVjM7hppWqzRjfJpNnQDCfYxSE8jHKVQVkN9LZHMqKKakLMk
24236	payment	2134	2134	1874	1	1	1364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo678Pq1SX3hwXovukjVPfZiU4L7bQgBXYmk6HbdANuyq98x17
24237	payment	1397	1397	1678	1	1	10288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4XGtJhrYQD4gqW9xUXLUWAie7NQF2V4mhBGLV4RfXLC91E8j
24238	payment	1397	1397	1678	1	1	10289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4c9ugwDRjgi6imKAeBqgUrLhkkZBRdUicektc1VXNG3nBc8E
24082	payment	1397	1397	1678	1	1	10246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaekhtGwKZ71CsJFMCoSbTpiT9s9keveX6mjZDmhPyCr8xei1
24083	payment	1397	1397	1678	1	1	10247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNxMJNQ1qDEYf1fgtioEHAjJUB6P2bdr9oFxe2ibRgkCCNgMU
24084	payment	1397	1397	1678	1	1	10248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19WYxfiytWDiSh6mevXZ44c5Vk5tBpVM28TERp3T5fvLPDzi1
24085	payment	2133	2133	1874	1	1	1301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSrUDRdJJekdAjX3ABUcq9htudNBRC8ZLtoBB5jHiNE8k2jcr
24086	payment	2133	2133	1874	1	1	1302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZdorWLxMaT5Zc4hJk9HPBAUgiM2rpXrh1nsf9Qe8vyVeGfxP
24087	payment	2133	2133	1874	1	1	1303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4sb6c8PwL9EVf7TVhNrfRMoEkumHEyzNAzTYbfyyb7dXNL181
24088	payment	2134	2134	1874	1	1	1318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9UKAmYD8VokZNurhWw45mk3MP5nGWkYmq1N5D2fmDPYKt6Qd
24089	payment	2134	2134	1874	1	1	1319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtEP1cJ7U12CXSRK8c5fXWpKWi9LgnLbRM4aWsW5kcewCgxzb
24090	payment	2134	2134	1874	1	1	1320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVycgYgb493h5QxQpBNT6dqbydqbpxKqvwBASqjJDg67yauUT
24091	payment	2134	2134	1874	1	1	1321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTR9Rq4QxUBaLfkzqrKjJ9GriMNBZomonEMteR6CWJ3o4LT6J
24092	payment	2132	2132	1874	1	1	314	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTkqf1BkHUDRdefs6JETnk4YW9GLdsUa5TAnJAXTpSzAzBBsm
24135	payment	1397	1397	1678	1	1	10261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCZ5okmQn8oSZ9agh7mSZwFq3vXFs7JUgqesTvKxL7pnwoCes
24136	payment	1397	1397	1678	1	1	10262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaf1qkjsfxrnf3dqLy4Eps86qptThxUCSuPTKkGPtnYP9QA7A
24137	payment	1397	1397	1678	1	1	10263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpF365jn9UrCJhKWoc8vDvR7LdJkFDWDQFWAZ6K3JhtcdHf6WV
24138	payment	2133	2133	1874	1	1	1316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkjzEnqLtWyVoFsjH2PKy8HJqLgjYYpaiDRTJdBiYpoGtv3W2
24139	payment	2132	2132	1874	1	1	318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfZY1Um1gpMukj3mv1Gnqw5A3j8XAhy7szMAZcgqhMFmWXQrk
24140	payment	2133	2133	1874	1	1	1317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAyTGcpGApYH3Lqi15wR46tKLe78oqHSatLM9KEfboCmudb3e
24141	payment	2133	2133	1874	1	1	1318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMUc1hPRTxrWyeaUsR9u2CZCooKJg7ERq9zdHQhAmCF5AZxU4
24142	payment	2134	2134	1874	1	1	1334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwGMoBn2LmpU8gLvFGbmFPxK5vUHzLxCqn5XE5t5dejJW8XfH
24143	payment	2134	2134	1874	1	1	1335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjyYQ6JCjSziLkb6kUbQ4oYe1EWRwMJXPXoLN8oKdUwWLAsiP
24144	payment	2134	2134	1874	1	1	1336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb6Sqv11fGBqpN9s2TvBfnBEBtCCk4DiJ6c5AoQgRr73dwJ76
24145	payment	1397	1397	1678	1	1	10264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ8j9aWidb1RuJVHTFeALKN7dACZemsgSxNeDFf2x7gdDcRXd3
24146	payment	2132	2132	1874	1	1	319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJqNLy8ttgT6Jnym9PqGcBqZJDLN31YuABxAZuqas1oziyadw
24147	payment	2134	2134	1874	1	1	1337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhH8qXZ5FDMcbX1Ut99MScGMp55FcHBCWBEubUW5pZfkmpURGJ
24148	payment	2133	2133	1874	1	1	1319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnw9yk51pTSJ7wVDZPZZ3GSBRDdQoH8CEE1TztWB71ydAUtkrH
24158	payment	1397	1397	1678	1	1	10268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNQNdkK2LujLPbVQxPLm5Qz6EyPkKFuxa5MGqaAhqw6AMW8XS
24159	payment	2134	2134	1874	1	1	1340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsZFrCrF4Pa4U66BSVgQwgncs6ri7WvJg8ASJtLTZ4wyb5ERR
24160	payment	2133	2133	1874	1	1	1323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMvr1R3teRFHGjZASE2CPwMnNxG7qSUbZmQHnjCWw6GwydKcU
24181	payment	1397	1397	1678	1	1	10275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeTAgLAN9xwuVYv26ademqXaL6tDYDUDdaadWLJsGx6TgDfFq
24182	payment	2133	2133	1874	1	1	1330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8R5SZJT3rfyGgpXT6mNJkbscMAWrGZ4LU4xoCuN2nAvQsMQ7J
24183	payment	2134	2134	1874	1	1	1347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJb25Km5BxMiKW5pM7DBaAA3g34EdRivZUEDTzmyHPwKJYFPe
24194	payment	1397	1397	1678	1	1	10278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cK6jW9mcF4yZ2uhYokiGVRiqqs6YLGspcKaQwExDRVFis38y
24195	payment	1726	1726	2174	1	1	8193	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZR8TiEmpaBSzcMPRRRTC8Ddw7YLKaDGFkmb8QyKs6vcSbYdsTy
24196	payment	1397	1397	1678	1	1	10279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVRFL4VZkctzCb1uGhWsWsP6zcLztsNwYRU2dcm4TvXPmmc6S
24197	payment	2134	2134	1874	1	1	1351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6zENyQG5T9ErfvJmkKajRJ6sW8fuTt9A4xMF4Y7Si59aKjtU
24198	payment	2132	2132	1874	1	1	324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXyrrJZhR8xs4F1PaZNrDxmD2Yn8ZXSqpF2QhVxMn1zhMWKHr
24199	payment	2134	2134	1874	1	1	1352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEr3GctNErWes7Nn33mmXdYdS7qEJV3Ygq4G6ycScFN2T3qpU
24200	payment	2134	2134	1874	1	1	1353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2HCD2oYK1Qrc5D3fsr5VSjnb5EVUCmhWVKcTaPzyAJcZg15p
24127	payment	2134	2134	1874	1	1	1332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gF9oeePBb5Lc3nd43EHAnxCRTS19HaWHVCiGF4k6mofrNYwR
24128	payment	2132	2132	1874	1	1	317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83XtGeS2pXb3gAo9wsWHmg5nWFMiDMBpY347Ybb6bP4pvwLA1
24129	payment	2133	2133	1874	1	1	1313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbdLS4rEdeokYNDgtzWQx2tcbr2CLoHXpzJnkzWqac1eqaFBh
24130	payment	2133	2133	1874	1	1	1314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMDqua936Tdb3o9h2HFfGVGxKEzSNfGa6fqxTqVAKkm7Ugvbp
24131	payment	1397	1397	1678	1	1	10260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQwohJMC4uWxFZFNkBH9cNRZm7juFsfzQHewmPE5UsGvGatZ1
24132	payment	2133	2133	1874	1	1	1315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPFQJEQcUzZ41LcQX1THhVzXiS5h5dsYPUgiiA7p8xwhTJ7WD
24133	payment	2131	2131	1726	1	1	2	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpZBQHreAMwLzruMqhX59fThqHSnwyXdfbCwDGH84W5BQ3y2PDcR
24134	payment	2134	2134	1874	1	1	1333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtpnL1q8Zqw2DFWTzraU87u3EaAnxd8rpvczBBAyeENeBv2qg
24152	payment	1397	1397	1678	1	1	10266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT5phvTjdHmotLEGYydmTJeGeEhsaH4xm8ZunizNXikTQtZcfU
24153	payment	1397	1397	1678	1	1	10267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZsjKWX5bzBLrEbkTvwVqZnsyenTL2R8Tb8mSrsGtRVojDwFz
24154	payment	2134	2134	1874	1	1	1339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRE9FbJBtkDgw1sWnFrzyQ8kUMi1nfTaejzMoGDKUzqeBBZ5iG
24155	payment	2133	2133	1874	1	1	1321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5Yp6VmApxj8PFiy4Bd7iH3tVpqdPeTtunAzC7nrCLyaXCGoK
24156	payment	2132	2132	1874	1	1	320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuH8UQcbtRmmkBU7FoUPj4oVsjSag3qq4h85whc4HW4GsyvWB
24157	payment	2133	2133	1874	1	1	1322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8cxQ6oJKicTiEsX6G9nqPgS2URQvBgyK4F3AnZsw4uXSULfG
24164	payment	1397	1397	1678	1	1	10270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpmmggcPXP2FYZHrfvKZ5HF4xkSBV47ojtHdoXvkVJF4LVRVW
24165	payment	2134	2134	1874	1	1	1342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHXQU47SEZkRUp4EjbAiHuvxD18tVNbzMpKW5xCEu3iNx1SmE
24166	payment	2133	2133	1874	1	1	1325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BfDStFJHvQtsc1koasQ4fyMHpLxqwdTM9HKjXfQYcCFc4zyx
24167	payment	1397	1397	1678	1	1	10271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkg1iY4AyRcDUZf8EXqNio7EwwJSkirAQwSDyA7syudekddpxw
24168	payment	1397	1397	1678	1	1	10272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGHmgYqGx4chMkZtVT1RH6aYigF6Se1VXmd6e54qCkB5TL2Dc
24169	payment	2133	2133	1874	1	1	1326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyH2yDoFKPQwW3jDEUQZEwUSxyP9YFCaNtcWpnF8zMBrm8Sfd
24170	payment	2133	2133	1874	1	1	1327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwEDn6Sn656zwHnZ98VhgZk4sLe6jYDwugyE15637QDCFuepY
24171	payment	2132	2132	1874	1	1	321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYcabvR99xE3ozoN9KGz2kcVM8MPLujZ7xChiDes1P6Fe4Wrp
24172	payment	2134	2134	1874	1	1	1343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLhpX83htN46KM7MT2FDvdrVMXWFzPKQPdqQ2UGxq3SJ2m2wN
24173	payment	2134	2134	1874	1	1	1344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFvHbgd4NFTP6YmUcDd12geJkCkzLmJvphqkGswhpELEJcNae
24176	payment	1397	1397	1678	1	1	10273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2LQjETyE1hrPNVFWiq1gZrug4VPmxVcrGBvhxSDwZ1NP8n1j
24177	payment	1397	1397	1678	1	1	10274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rHzmgZTsw9noKRwpLBBw1Wf41h6e41kK53xZDgPGTU942WdG
24178	payment	2132	2132	1874	1	1	322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzEuVPM9GZjQReqvdsYLfmnFzaWg8N3t7zyHqbTvVvperDRHKR
24179	payment	2133	2133	1874	1	1	1329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYFaLxLqc3Z15pDC7QGaNDEjxRfgQkUXATvN24h154fYNvqTFR
24180	payment	2134	2134	1874	1	1	1346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXtRAvmdMB88A3vG3chp5xPivDc6vimPQ8ffFpfpZFUFAMKzw
24189	payment	1397	1397	1678	1	1	10277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDE6RmPZuYLmKSnKonwpHBdb9QZj4f9Zb5zQmPKktpFkdxjuuU
24190	payment	2118	2118	2173	1	1	0	2000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpYyDUUy46xaXi6R2a6E1ewe3ik8Fv9gcrboij3LvW3KvVSkc3V1
24191	payment	2132	2132	1874	1	1	323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbJRHsQw5hvJp3N9LKSMF9Fwc5GP4TVY9xQM3AJJC67U4QRsoy
24192	payment	2133	2133	1874	1	1	1333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBniK8Wzfy99dRQdwfwvviXFfXco7zGm8rv26PYUkmxKavBRNV
24193	payment	2134	2134	1874	1	1	1350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbGvhVst5uF4GJRDGeywjmVrjFTwS8BCHNCgiyZgQRkqDHgJ9
24204	payment	2134	2134	1874	1	1	1354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdvVTR6eraZuUKiSuLtamPF4kcQ7AcSQFvAYe7MSH1CWRdjGv
24205	payment	2133	2133	1874	1	1	1337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49R9HEJGPcgmVGb7VJNz1a7J6E5Ry3iY98SkQng9eYw7xLxht
24211	payment	1397	1397	1678	1	1	10280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9H8ELReKQ4F9iJFrZcSx6x8RwbNzCMkSYHvuoV5ExdgRwiYjs
24212	payment	2134	2134	1874	1	1	1357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwjX5ZMUpgFS89TeH75tek8Je1Xv4jnC7t4YdW9kMvxRN45Qi
24174	payment	2134	2134	1874	1	1	1345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfS8i9WLK2Vfx8bL4GvpKhMcf1EgrqPAySe9QRkz5cXeTnFPz
24175	payment	2133	2133	1874	1	1	1328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRNeLGTMGa3whL7eisD8ZHxq6jaUGLruCK3QhGhFkJhSrzofq
24187	payment	2133	2133	1874	1	1	1332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzrkn3WH8PFJREFwQ89XQFwycg6GDY6TEs7fYJ75EfEzcWUqV
24188	payment	2134	2134	1874	1	1	1349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JkHf9LAwdXmkAndD6GBNyLkJ61fNzf6DVhnZoWsx5CXVEa7y
24230	payment	1397	1397	1678	1	1	10286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvETr4ohZf9eag9V4W5CJdABwj2k4NhzQRb2uDR4zPFavqzjv
24231	payment	2133	2133	1874	1	1	1346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7z3YPjL6WEC7mTVb8meYvSwu2Gor9WfuoLZSqMUQf9kciMcB5
24232	payment	2134	2134	1874	1	1	1363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGD686UkNnNi9ErZWhFJZoyaYsKRX93xQBUtvngGjvej5fJ6JX
24233	payment	2132	2132	1874	1	1	327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGQoJfHX21MNB4vFwbQ5TmuHLVpmkC7CrwVAF25Ap8NX8mwhx
24244	payment	1397	1397	1678	1	1	10290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhriTok5gMAtqHMfzZrfj9BUAYHzRkfyewBTMaL76nh68UoGwK
24245	payment	1397	1397	1678	1	1	10291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DKVpqEEf94nfotGwQS1xawHt5oEEF8GY9ab2WJYSrZkh36Lx
24246	payment	2133	2133	1874	1	1	1350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrzVMQV3DBsxfxaXxcgKHvosQ1BxgFwCV5PmQ8NwQZtEiQuJdq
24247	payment	2133	2133	1874	1	1	1351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrerdMTzZrHs6JUCYS2qmGrTUWny4ws83fwYJxaKZLTgzxUupm
24277	payment	1397	1397	1678	1	1	10300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWgBtbNnUJ3VHPwfKkqQQCCWaEpVnUAwro2uFpTKxnees5j83
24278	payment	2133	2133	1874	1	1	1360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWdUgH19gwRHr5xP5ARtzxU9WdKpDK4CtQ788BzyvqT8n79oT
24279	payment	2134	2134	1874	1	1	1376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJfaKvwmQxxajMFuMNNtfgJVKioT3qu4MUd2E74CsJuhE9Hb9
24281	payment	1397	1397	1678	1	1	10301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78eCVcGpxBBCSHKZYyeyqbHsrZYC3XQ4j4Jb8xm52PcAMkkN2
24282	payment	1397	1397	1678	1	1	10302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoW11os8gMvcwCYAZ23ELiCBoX2pj4hp6NujVJYQTCeNwb9R2g
24283	payment	2133	2133	1874	1	1	1361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXSxM76jdAwhN3sF9gFqc5rPGjrpK9N5CmmdYYeAt8Wynmc2v
24284	payment	2132	2132	1874	1	1	332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyLVavjbqJbLF6FkP7PdM1VerrNcRdnZTjzB7JAC53hw9PGtm
24285	payment	2133	2133	1874	1	1	1362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwWt11RYt2DzQNuhvqWXxeCJtD1pAWybv4vMTLYidCVXNCmyy
24286	payment	2134	2134	1874	1	1	1377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABqqUFPn8vuTb9yuJdVS5LcbuXTtLWp4Kq132dtKYwLPuKj1L
24287	payment	2134	2134	1874	1	1	1378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XzN9LhmT67FMRZvae9aNDPiTJ1cCE2zNqD7zJdXduLs6u2jS
24288	payment	1397	1397	1678	1	1	10303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KXFGM2551f8b4GQtZ2Dda2Ea5q5kisbZLXn4kpeEF5XHjTuS
24289	payment	1397	1397	1678	1	1	10304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyUJuXurs9MVB2zwgEH2ryZakcwXMG2W5buJ2VkGgAzSMRh1s
24290	payment	1397	1397	1678	1	1	10305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEz3X6k4NoP1eqXYCq7TGbT83HfqKzrghn6nhntgybF9R18Rrc
24291	payment	2134	2134	1874	1	1	1379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjtrxPJjKfPzrNeSJ75CBK7vY5o23KhfbSXzRtgDVUYdnTY3j
24292	payment	2133	2133	1874	1	1	1363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5z13eC6kAiKc2TjRPtBe4iJhEiaforwcip9MmdhdDhcPMuoA1
24293	payment	2133	2133	1874	1	1	1364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39WmyVEymdnQGCqtJ3e9EfssobsLGH9ZsPG5V4CUwwSsyqG2S
24294	payment	2133	2133	1874	1	1	1365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8S7ECJtKQqHZQNns2VaYgjVwNai4hwfFqzXUz9xDBNdtgr5FW
24295	payment	2134	2134	1874	1	1	1380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZke45LcNJMYwoUePTG1RD6pFvQE5J27n9xEV4pETrjMAUuLgd4
24296	payment	2134	2134	1874	1	1	1381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4D2goXFtEbbeYxbXRyEd8jVrcnJJULnXFYBmR7daFmDDU8zvg
24307	payment	1397	1397	1678	1	1	10309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvzfMdtdgNYkV7t7AhUnuJpqVho8C9cDFxfNgNYC1xpRQeUgZK
24308	payment	2134	2134	1874	1	1	1385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17ZKdtjzSnQiedxjJNzwUGoTyYUu1DHAQtRMPJak3Ni5uM2LM
24309	payment	2132	2132	1874	1	1	334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ195XNMzaJ5eRv1t732fHrsQuoFm38DUoofULvvMdG9ptFgjnz
24310	payment	2133	2133	1874	1	1	1369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78fVRuGK7qp1ayF12uqXrZXvTwEpjNsz3o4LCxhpp16JqwuaZ
24334	payment	1397	1397	1678	1	1	10317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1taB16sJh3eZTtEaTUkVJHMVeC5DNNgkASrbdZMQoCDhx7S6e
24335	payment	1397	1397	1678	1	1	10318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3XRKbiJp9Jz7qhLvWhaq2B3sRLkCxJVjK9zhHMc9AgdJoYsy
24336	payment	2133	2133	1874	1	1	1377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsqJkNk1Lxr4NsF9SFbKD8c4T3NdTWdNcqJXUgoxYqvCzKWCQ9
24201	payment	2133	2133	1874	1	1	1334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TxytqrCC8NtFtcoCZ8Rkumv832UbD2Pjcn4Be1HfB1TRrFRg
24202	payment	2133	2133	1874	1	1	1335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywahCFnm36WD2z17chLJkL5gVKF6suUMLWPwtcYEXj6xCcd9a
24203	payment	2133	2133	1874	1	1	1336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jppH9f5yDbm2pLsM84QMLo63d6CCH8sBRvsgp37JogJZNj9L
24224	payment	1397	1397	1678	1	1	10284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCdHhBuY9ZBRXG7nruTE9SyvGpKs4XkMtGerJkucm462gJdSf
24225	payment	1397	1397	1678	1	1	10285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxjDfUetWFW8JcjTAr1RZ9EETV8YKB4oAmNXPUWMRE32RkE3U
24226	payment	2133	2133	1874	1	1	1344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3Xgn36MNs444Ytr1LyZenudi7Dn9pPJD2YHviJNWwQLnPrkb
24227	payment	2133	2133	1874	1	1	1345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMAWmYtQGmRVHKHvKzbUXA9BXJC7qpcSDXjYoEy7Usobh9av4
24228	payment	2134	2134	1874	1	1	1361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKj3dg2zn8b9ZXgfjYgZadTSFi2Kg7aNehcDrrG1xxGsEVkMu
24229	payment	2134	2134	1874	1	1	1362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstxfACMc2F41WqW6jhqoiTMRstCzJFWn1sZGpLoefaccFYYo4
24254	payment	1397	1397	1678	1	1	10293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn28BCrVrkDfB3aCEb8t6Wzqvwm7Eon96R5zgcbGqpboxWM6aZ
24255	payment	2133	2133	1874	1	1	1353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyL1dWjM4bGKhmVRVqSayfadYWYitgsptRpqaAbZKKo86g5Wbe
24256	payment	2134	2134	1874	1	1	1370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJawHaCtCR8igskXGNNsfxvwHaHLdSvRzRzNJ1oLaG8D8waRS
24264	payment	1397	1397	1678	1	1	10296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcxR51EuMJJCGonVjULtVR4LhqiUgHDcMgJtcVXJAwpYyhuZA
24265	payment	2133	2133	1874	1	1	1356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX3RVXAvSiycX1sv925VFTGNhTuF36tCdo7y2wU6VTVSLbo8v
24266	payment	2132	2132	1874	1	1	330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZcjjp78rL9s1r8UbW9egWKhuaDBrK1A7j1T7MDETnUoadubi
24267	payment	1397	1397	1678	1	1	10297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mP4LuUhVVWcKoewdFHBmM2mfn7gG2jtatUee13qNgExSAdL4
24268	payment	2134	2134	1874	1	1	1373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjpPdeidYjLTHDjgVgqQEbPw2MckPyE97XTZrqBvsf6utzthM
24269	payment	2133	2133	1874	1	1	1357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNcUn37b1Px2MHbM3n4vkCbto4LNMrCZQ6U4oApLzBWXxisiG
24270	payment	1397	1397	1678	1	1	10298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHhGA8cBDzTTjCHpfTDJiCmYKxoENzXxuv8DQFpeb3sAj1n5X
24271	payment	2134	2134	1874	1	1	1374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqBNULpE5WnXub4GzCGMAh8LyBFNedbRKsLQu8B1z1U7NRb4N
24272	payment	2133	2133	1874	1	1	1358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV14emTx9zDdAfcDrfM6eVhWeUKPS6K81bi6NChwaGeowbP5CR
24280	delegation	2141	2141	1567	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXUBei7ifBY2RATJjutXXyg2D85MjtuXuqvNGFiL2axToG8uc
24301	payment	1397	1397	1678	1	1	10307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGkP23a33oxV2rz598NsGyuR8f1Fh2AsNCXb4QNKKWmH3hU7z
24302	payment	2134	2134	1874	1	1	1383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7jfD9D8P7TowCBBLDnpXJpmMhYDZYY2XTGEjGdzUrPGeSKYm
24303	payment	2133	2133	1874	1	1	1367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt8tiBQe8axUtsFZsBgDLmeMDVtMoLFn3UoX8gJd9jeaapKY4
24304	payment	1397	1397	1678	1	1	10308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Nen52Vvk5dP4mgkARHXNEox8ScQQVAK5ciAMAvwvo1Ja1a2d
24305	payment	2133	2133	1874	1	1	1368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGNz2NShwLFMSGW3nWhYU2YtAXPxyoaTW5QFwcWuZyo8s4XFD
24306	payment	2134	2134	1874	1	1	1384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5yh5EVH9kWzAn7Xv66iw7pKmSGLWvXnuxC4gqmPRtd7ssJheT
24314	payment	1397	1397	1678	1	1	10311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ah74tPDuRxzYM6GoCQ2N4iAkTM354zGc9pk4WTqp8b3hCFF1
24315	payment	1397	1397	1678	1	1	10312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmA7n8fsuHwkyrDEBd8Ax3Y59tKTc3M1zpRYN7RAmGnvCc7h1q
24316	payment	1397	1397	1678	1	1	10313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMELuME3za25vLmW6yiCN6FDxHUuL3GUgJUodCaghCJFHqDKV
24317	payment	2133	2133	1874	1	1	1371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthw5yH3QRu9kGRMCAxxhtm7VFQbk81eo3LHmwidWqTbuCYAJM
24318	payment	2132	2132	1874	1	1	335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WFrZoqe4pmKQr47qbbwdf9FxG1pBA8f9nJGC94pPpAXSRqqJ
24319	payment	2134	2134	1874	1	1	1387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEGvG4Wm4QVKf4yymzZYAVj2rxTtt38qCinZgg7ZUphKhYVb8
24320	payment	2134	2134	1874	1	1	1388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUtz9BKnpTLd754MqDD7PWgcY3nN7xQs1HNSeh9VBDwrVe5mx
24321	payment	2134	2134	1874	1	1	1389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB13PyADLv7PX7ogwzatfup8N5e9TP54QUgsrbzfxCezP3ETxp
24322	payment	2133	2133	1874	1	1	1372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5isR9U9ycnQKCH4kxwkPnuZB6bn5w2waCRCAYduamqU3AsHm
24323	payment	2133	2133	1874	1	1	1373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtx6PHcPB3j2B3Kcs853epGYipvFTXEFupwuBS888YcCZFz9uA
24213	payment	2133	2133	1874	1	1	1340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZvksx8WmEBGHsRVFB8DNwFiCJYnsDwnPF7yWzDp2SeZBcPTZ
24214	payment	1397	1397	1678	1	1	10281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vhpJiV16DZV31zwpV7h6jzcjZinDS1dWJ5WN79CnDxsJzrFU
24215	payment	2133	2133	1874	1	1	1341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fWCCKoi5m9VtEhVocw53To7rcNkZHUadeuLXpYb33BrNpktQ
24216	payment	2134	2134	1874	1	1	1358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZv6UocJArt2zn4xMfjU1JRYPF3AgN1jmayq6ZzKFPsCE9eGS
24248	payment	2134	2134	1874	1	1	1367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckeNDbh4FXhE2K2xpnryC3PCBzDkaQqhXfjz14zGccrz71LLu
24249	payment	2134	2134	1874	1	1	1368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhjuw48HRgUxDcCywRwpEgY4pbWKqEwTRQKRyAxwk9taRmrq4
24250	payment	2133	2133	1874	1	1	1352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAzUsGkbw8gBjLPYT8Q43wPBdC3Dvyon3jrioukHBXGJd5xAY
24257	payment	1397	1397	1678	1	1	10294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwk3Sgne8WV5cYHkiL4a786criCeAPuaU69omBntMKu83jwY4
24258	payment	2134	2134	1874	1	1	1371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty8PnBVrorpLRm7xJGocM3erUhaNmC2s28btfBGXKeCxHzcQ7
24259	payment	2133	2133	1874	1	1	1354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmbjG2ryU3VoErGgSw2RUoLzjBjLmYxr5RY1TdL1MWBXLgcek
24297	payment	1397	1397	1678	1	1	10306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyPz9XEZuhQ3dHttSPkZrXKzvust8PEVExPLxFiyxV6GB354k
24298	payment	2132	2132	1874	1	1	333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfL3zUJMK5U7DUtAg67JAT3PkuoFPVjwNaHgpiB4kyHhcf2RJc
24299	payment	2134	2134	1874	1	1	1382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3E5GHognLe5gpMR8bi8iARRt2r1Jnzy3hLzPGqB94boHySFn8
24300	payment	2133	2133	1874	1	1	1366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXwqA8h2kigbbXuUHjnoiiixfnWtQ5WUL191rQibi4bpcpdm4
24344	payment	1397	1397	1678	1	1	10320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5Mi3ehEQgA3RoHiBxWyQ5qc7QbnhwtBWnGovY2Y7kDvW68Et
24345	payment	2134	2134	1874	1	1	1396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqXJp8eWjXG31vNp7C47WHet6MAfojA11ZMFkor5i5kCqPQ3i
24346	payment	2133	2133	1874	1	1	1380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QhXXs5xgTbtTBFUnraX7vBZ4GGcYJY5XTMVNS8gfurvasis8
24371	payment	1397	1397	1678	1	1	10328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJBBqL36DeEiJMmjyyt99zPkXFUthA31RMD8gUdwz8ev6fof3
24372	payment	1397	1397	1678	1	1	10329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmipQDeA1g4XD9GbsWPq85vpeAe5CNjtLG9JeuBRa4et3wSRd
24373	payment	2133	2133	1874	1	1	1388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpX8mwqQDSiBayqWr2ZtmxisYqGfEArDXetD3bYnQF9WLfSxns
24374	payment	2133	2133	1874	1	1	1389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5PP2tx6vKvYbw9n7FAVDDaKdrUpAdi8vJb8TVfU797ZpSpRR
24375	payment	2132	2132	1874	1	1	340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrzhMgsAvosEThNVwek1b81rw5HburRQFD9mAPW14Fz3TAp99
24376	payment	2134	2134	1874	1	1	1404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4gzmMbfKvLTgw7e1x7PN5MQ9oxokNXW9vvANCBo3Gk87P1Ez
24377	payment	2134	2134	1874	1	1	1405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZvQ2JbEp6qv2szm4tHWuz95bYoeUWDXVDz5n8tUkF8xmpqHm
24378	payment	2133	2133	1874	1	1	1390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjZkPhmsVukb9zFzgd1JKDQpp2jwAPvfjVaXwPWayyJANpzx5
24379	payment	2134	2134	1874	1	1	1406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLupL5M5vZBLi5LSRjUbiZVvAbPdSkj1qwgC8YBmbXBnFe9fsS
24382	payment	1397	1397	1678	1	1	10330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfqDCgkinKm96129bMBcpPkmbkXzN6dY8LsLbB8GDBRANK2Y2s
24383	payment	2133	2133	1874	1	1	1392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaNENGtiH77RSRBo4G8jKVsCpm1ooTUth4RitmKiLq8XHkg6Gn
24384	payment	2132	2132	1874	1	1	341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1ixekoCag53cCDyCjx3B73wZhM1FS9KjKbu24S872ARRiJhL
24385	payment	2133	2133	1874	1	1	1393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhRaPxLKy4jD18sX81EE4suA2ZJJU4YjtbBUa4DUbbuWZifM9
24386	payment	2134	2134	1874	1	1	1408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJ4fyYSbwa1dkvgNxggNZNYxzQNZB5JrV6yK7UYkmbnmCqxbj
24387	payment	2134	2134	1874	1	1	1409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEP9o9Z1JmsMeLVE3khd22ifhnToeL43ZtV8J6EGLVxfaB1c3
24398	payment	1397	1397	1678	1	1	10334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSfAM61CguCFZo6WAjzb2bAoi7m9pbGF6DmeqQJ6cb3wWWqxF
24399	payment	2133	2133	1874	1	1	1397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5fYT8Px3gNhjAgmHucQx4ieaigQkDF33qkurjGBU4rZTcBYH
24400	payment	2134	2134	1874	1	1	1413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kvTLroUZmyGEYLcN8stRiqHeDJUstsYUY2BNe4qtTfSm4DCz
24434	payment	2134	2134	1874	1	1	1422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYss4z3rVtyWiEqoZJ6ftaTSHnpc2FNNzgrL2p76wkY2NbWR5ST
24439	payment	1397	1397	1678	1	1	10346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28jXzdQa6AhHgpiQzTSKjjPh22hS45yGBRURdCNcbe18CAiG2
24440	payment	2132	2132	1874	1	1	346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1hEFXVGDJN811FTh9yPLY7H5tCMcCx5ggJ32xVfYa96xPnWr
24239	payment	2132	2132	1874	1	1	328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFxqqaJrjTQLpxodapR8iVCMcUoiFfxCzdcLRKrmRyxWMUEniX
24240	payment	2133	2133	1874	1	1	1348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDrhxo9ovsupLyHMAAq8VxULQ7LaYos2HR9ESfmYmFgLQzsw9
24241	payment	2133	2133	1874	1	1	1349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyNGaaSvfD2gAddDVeuZNrdoqB3t8PYZ8maRi8Xxpdi7QjF6Q
24242	payment	2134	2134	1874	1	1	1365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNMLvNut1atwMdVMZvS5CsZztyFFFGMnq83uxroCm6Aq96VW3
24243	payment	2134	2134	1874	1	1	1366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJigLtfz9Q1V47F3ZY5UZRYJaDXRDz8jk8To3rnfQhjnhYhzR
24251	payment	1397	1397	1678	1	1	10292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAuvkAZWCGuqMCjZRYX9JUg6MDBL3oHPgq2xSVjjJktwTG1oB
24252	payment	2132	2132	1874	1	1	329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYraRbTxd1LYQLWqehKnQXhKEcziTMDjUqUT1ixXWeg7rVkZpxY
24253	payment	2134	2134	1874	1	1	1369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhutEUqnppV1QAuSeywKEtLpLGDUnVfbuTcaDXu9nNN7gD5kNP
24260	payment	1397	1397	1678	1	1	10295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9gxoiptPm9E5BWk3r37arUUCHbDxhW9kEqto2rYm89f4PuhF
24261	payment	2118	2118	2173	1	1	1	2000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpYSEtfsuTBSeTozSjXXJqvukMuxknVyMkEwEAr3XRT9m4VKwuMP
24262	payment	2133	2133	1874	1	1	1355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3kTD4C7HCi7V1AiyBJTo6yhmcDq1bWaLR8AZJhYYXQ71QNUm
24263	payment	2134	2134	1874	1	1	1372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStSQFwfYVc9PvTBHFNWCs5xE62VWzLrqsphAEyWiPq8UQ7ETo
24273	payment	1397	1397	1678	1	1	10299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4tJmEW1K85nJwCdq7MpWo9mJEzchQ9e9mh5QVXFBD5BXpBgc9
24274	payment	2132	2132	1874	1	1	331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjXj8E8ZBFMEd91HkW52LVJxWg94xuW5Aci7k8PjZkUyoQz8n
24275	payment	2133	2133	1874	1	1	1359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYWYqq7tzCKoej6g88MjYNjrycD9TuH3wMr2phaiEiUapFdyu
24276	payment	2134	2134	1874	1	1	1375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsqGcc8DR9vyWGGM4pmAmgtqc3xDmG42433eNYJ21oSSo5cEr
24311	payment	1397	1397	1678	1	1	10310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYXXJRcthNVVuxVNQXqbviRFwxfUAStQCmdfhnK96oh3PMLfq
24312	payment	2133	2133	1874	1	1	1370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTc6k63GbmCuvvSCDxzTDGuqnDKePj1R6TKU9du3qRY95sMgic
24313	payment	2134	2134	1874	1	1	1386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSt1cz46B9LxxAtgQTXhDwjusWgTamLDrruxuUpzQQDWv1ynL
24327	payment	1397	1397	1678	1	1	10315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxATcZV4Ekui2ZiGjq7Ef9VStuv7b99bEREArc3dn4kBSZ6gk
24328	payment	1397	1397	1678	1	1	10316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaXtXuXiVZZYd7dyCTW1tjf4EUC6jmkety6duHerN4xrEKT68
24329	payment	2133	2133	1874	1	1	1375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSeNdYV31567kyig3ZoE9u1egRfThLEkL1mYzxifcV3NAeDR7j
24330	payment	2133	2133	1874	1	1	1376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz1qsqV1QdFrJbStQAJbjWhx9Xd8UFWpoFmsxmWr23jANNgRy6
24331	payment	2132	2132	1874	1	1	336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMFs9aDrMenip1GTRcVtMkNMGD6HZuqRbmmeWd4zvotJom6Ej
24332	payment	2134	2134	1874	1	1	1391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQX14GLG6A7KhQd6YrSCXXZc4Pmyz4CyRGaoEZXpLdcgEEAuWU
24333	payment	2134	2134	1874	1	1	1392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfxweB3VEsG4A8wPzSUDV6RzqEPLpznZZCFqXCBV5hFAThMpn
24340	payment	1397	1397	1678	1	1	10319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Ded81pqt4QEPZFdjKUSmhYBxD4xxyw4BXBSsApm7FtaNYqgs
24341	payment	2132	2132	1874	1	1	337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVVg37dKAVUkdqLxXWZDMfQzwzT5ocUpEzJzZLTudcxq9UNuG
24342	payment	2134	2134	1874	1	1	1395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMU1tB9HR4oK5nhACPWMmWwtvLqgj2Ldpwz81Whfa2Rvp3n5CC
24343	payment	2133	2133	1874	1	1	1379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczDpUGVYnaBVcnjoVm4iAEFeKP2icnVWQ1eRXRM3C4wzkjouG
24410	payment	1397	1397	1678	1	1	10338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkauMTuWB9qwYP4MHCutW5sAUhHhcWfhyb4A7qZcLtiMj77Mi
24411	payment	2133	2133	1874	1	1	1401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVCcHNKkruK8zWQH2msbDGQBBk9EKoXCoHgHweuLMuXkPNBLLT
24412	payment	2134	2134	1874	1	1	1416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuQMg4NDiFiCA4eT4xfLERXFRd8xsZKTnZwbqMLxdzyLJEsptP
24417	payment	1397	1397	1678	1	1	10340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfCsyYcLTi4BYECFy7Tg4pTB5bMBXNPM6CLUUo1x9reVvq6EN
24418	payment	2133	2133	1874	1	1	1403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2TSTfRfTPq9jU1LeHP8rNqTVds3QvL3NFDYiWLdDYjRfY9vq
24419	payment	2134	2134	1874	1	1	1418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvF6LMxDp5M5H6LizT1Kjm74EMzoGKdfFE3uP5YkJ54KCdDiMq
24420	payment	2132	2132	1874	1	1	344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uFjius7VpzcrbXJRuRKP1q3cs3hjZavZL3kWjAJLfa1gJpJL
24432	payment	1397	1397	1678	1	1	10344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbMzTwLAVqVc4hiT2RyJPMJdDkKSngPf5MkLHb6tCLNZG8Jp9
24324	payment	1397	1397	1678	1	1	10314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzo6HKA9yAQWX7eEWySWKez1t9UurepnkdmAUCjvqTJk9pC7u3
24325	payment	2133	2133	1874	1	1	1374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2atsDN8faUrUi4BMUunefBAieWDLnM2JDQdSw2tPJonaia2NZ
24326	payment	2134	2134	1874	1	1	1390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa864pnWqyH8kqmJrMx4HtphPbmB7mdJVRmRb5LtR46hgSef5FT
24347	payment	1726	1726	2175	1	1	8194	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYXZ8YKxNqK7Y3KJH5ZbB1s4pd6WxkHVd721CHuJh7JukeGi9JK
24348	payment	1397	1397	1678	1	1	10321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7WoGYepKB6RMZKrtgW6Cro1WkWX9HuWvERQA4BL25by6FEMo
24349	payment	1397	1397	1678	1	1	10322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVcjCVQ7ihndCfQDMDfAunX34aUhwiJBkUXyGHQEWP9XjnK5P
24350	payment	1397	1397	1678	1	1	10323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5oTgw9tzFuHv9ns19p5UML5G4qx4zBpbgESsBBRVkrpESpdB
24351	payment	1397	1397	1678	1	1	10324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjk5tzNqDZdQMR7yjg1i9ZNzCzn8X9Mk3DLepr972ouf6U82NJ
24352	payment	1397	1397	1678	1	1	10325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Won3WVyaeNqDM58tUcFGB7xasubopEaDokwjkBKDrYgLZnTM
24353	payment	2132	2132	1874	1	1	338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1649e2vHUkUDWiboUetTTPcBRWnR7UoQftdbnrx8u1o4FapdG
24354	payment	2134	2134	1874	1	1	1397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKChKnmwZVMuhSg8LZ5Z5sBsUvQZqiVJcaxFaHWdyudwWuL7UQ
24355	payment	2134	2134	1874	1	1	1398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCrqtAnpWxZh4MVHR3eMD5nkSvaxcCJLQBJByRyh9ZB2hpRC7
24356	payment	2133	2133	1874	1	1	1381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6wKcK8jCNk1emjK65fpssSXfUK7qaDDe75x9kmG2sGoeRrQYp
24357	payment	2133	2133	1874	1	1	1382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAWiyiiZ8f21YuzdTQJS8cLK8bosvpBstgriJyqPoZdQesuTj
24358	payment	2133	2133	1874	1	1	1383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYregnG3s6DSETwDTVeV4Qt7nMXCfyzopFLTcoiu6h4kvK6Je7i
24359	payment	2133	2133	1874	1	1	1384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1A13cZeDSUQFkyBG67VgKzEJsds7by3Wh9LSZYejuvbGr4WCv
24360	payment	2133	2133	1874	1	1	1385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DHFhijRQ3kMJ4y1Hw9keZojkaQSp5JMb2FZbDhwp6RxCbjxS
24361	payment	2134	2134	1874	1	1	1399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCq4sX71HERsMLEnE9MJKLdct1yE1iVeAXcGZs5REHywHY9GLy
24362	payment	2134	2134	1874	1	1	1400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpKBdSCM3sDwxUrgbJmvHzKqKSZpeg9UF29bc9ZGAo8fiTCv5
24363	payment	2134	2134	1874	1	1	1401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPj23yaoFm3FpYGwBnzESkPw4oSMj2MfPAhvLTVHjuJu66o4M
24403	payment	1397	1397	1678	1	1	10336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzRWj3dpTvvPdx7Z7DTPJziFGQcZUqeFqU6Fv2cdAwDtp1TMa
24404	payment	2132	2132	1874	1	1	343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTrMwvRjnN2J35ZfJWabTjRHKpGuXxnqZKAcUcArmydYjUUmN
24405	payment	2134	2134	1874	1	1	1414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7UnTm1bmWgcxLfmfpxQ7ofFWLSCksNtsp4hhsY1wbYbVnSTJ
24406	payment	2133	2133	1874	1	1	1399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgGQcKMN2RvTSRz4Ed4FYKiZ6b8P5siRMrD3GjUFgpPFcJ1UG
24407	payment	1397	1397	1678	1	1	10337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bbqBQ6ApuhEBCMgQYG91qwqHk5WSyq5Ezv214JTbhRCrmmX2
24408	payment	2133	2133	1874	1	1	1400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRLUJ1ztMCXQStHnCpUJw6ym9FLWoeWK1sWGKkPVtKgNHZ2ya
24409	payment	2134	2134	1874	1	1	1415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83dZot19Wao9YYDMd9WA2qKzLRNQ481Vu4f5cXBVr4xoaBbqb
24421	payment	1397	1397	1678	1	1	10341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjE3Jfo2Knj2baUHjgxduqTqce2dFYb9hko3z6kBHNqQGrLuE
24422	payment	1397	1397	1678	1	1	10342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9XjiZn2kRpPkkekFYxpa5oJztPidpEbPvuMj1eKzZ7uJREZq2
24423	payment	1769	1769	1769	1	1	44	100000000	1000000	\N	E4YPrK9idKKvKuQtCr2pqaMk2xTRHidEMJazrtJmtokcsaAmX3C6P	CkpZLGRyL982LcbwyvguxxSrkcqe8AcdhnKsMzEVAZ3eZbKWjUvVx
24424	payment	2133	2133	1874	1	1	1404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkzqjN1CVRmRGDyRS1yh534BkfyrZT2JhZUKZydGWMAmWSsvuq
24425	payment	2133	2133	1874	1	1	1405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFiFxywJbsfkRNv1bGQqUp9nKWGmnJ4wQB14vPR1tg1osxjvw
24426	payment	2134	2134	1874	1	1	1419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fMgUpqJFZMy2rwG9KUZzJP1JjxG8xMxWpML5CKqrbkSXTNEi
24427	payment	2134	2134	1874	1	1	1420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQ5V9na6ie79BhtDFJQCfwSwjAH7acqLArNQt5HgGkVoZySRV
24428	payment	1397	1397	1678	1	1	10343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntPEzn71mwxycpgVmPD6QsMBi9RH9WJqYWmeCirTG2sqzNWPc
24429	payment	2132	2132	1874	1	1	345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4x9rctLcgSpsxETggsK4BUS97WTGWvN4i81pwF4hUSnZoPUr
24430	payment	2133	2133	1874	1	1	1406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg1Puz49t6qysaBeiXkjLfreuu75Br3UJXwJxnYJGH6szv8LE
24431	payment	2134	2134	1874	1	1	1421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7DTwhJmW3yo6Fm6uD4PJxMekTjxuhfbF9FnVdPVtYgwZeWGV
24337	payment	2133	2133	1874	1	1	1378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp56MFk9Mf66skZ6htNGXygWMQpqqrfyDiFXwXUcTU7HEx6R2A
24338	payment	2134	2134	1874	1	1	1393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHAX5kC78YvutWiPHbuDCc7WGcsw77hiTkASQf29XeSM2vgrk
24339	payment	2134	2134	1874	1	1	1394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4eMUSDDhA5sXqR9tyvusNiovCzLEHeWqjsaJ7Hp1WFmK46emJ
24364	payment	1397	1397	1678	1	1	10326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoMjbMCbDqe7Cs1QfHP8djJN46QyAtdwQL9tMmVihP5oCPRMa
24365	payment	1397	1397	1678	1	1	10327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3uSfLNT4eH1u98cw6Dcgs3MYaattCu6JCBfYMirfdECLJkLQ
24366	payment	2134	2134	1874	1	1	1402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwmLzUB4kVoLWP2KJF3XMgBHiWhoiKq5Qtr7kULeYFRYb67cx
24367	payment	2132	2132	1874	1	1	339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2xXvTRkuWzY86wukET9cL3A9RaxYTvZhZotjnPrMjpJkVsPq
24368	payment	2134	2134	1874	1	1	1403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1oAtEFHH49NftT5oH5X8HdtiFYhufWnsRvv787KtBvfFgGGDt
24369	payment	2133	2133	1874	1	1	1386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BdnQWBFsoWW5M4yBkiPG7vUzfEVDP8FMzosvTuwQuTtvh9bf
24370	payment	2133	2133	1874	1	1	1387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysFEoeRktr4CNa5TuwjscBsn12audpit9JkCva9zsnPk4tfKJ
24380	payment	2134	2134	1874	1	1	1407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUm4nRXgCCkCPB31hcgGqz2hv2EzQHk358JDhYH5NrRVgH3UXX
24381	payment	2133	2133	1874	1	1	1391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMRefdhWQXzrUqFe5beKnSMDNfSQrTu9u4TqXQMh3Emva2k2o
24388	payment	1397	1397	1678	1	1	10331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPNdTNM6GtYBZkp912S1G9RhSgqPUN6xacpwgFRcfzzdHzpKE
24389	payment	2134	2134	1874	1	1	1410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGjyujjxg99X8KkdpXt22o1y91Rg1SRuZC4pGpWaVPbYtEgWi
24390	payment	2133	2133	1874	1	1	1394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fYnH13j1yDKjkZN1LvnVjn8hh76xMjgLJeyC9w3SCk4zrEh5
24391	payment	1397	1397	1678	1	1	10332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBu461HQQJQm3ajhe2X4RA7oVt7coHwF6K5k9NUp839EPsNKC
24392	payment	1397	1397	1678	1	1	10333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MVvup5nFVfZ79tAX1vJVGBrFnkhFK9Ldb9Kisp8P1eETrU1m
24393	payment	2133	2133	1874	1	1	1395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHkVApAQnkeqrWBa9frasBFhWZDV1eQFxrpkgGy2CmLe4StmJ
24394	payment	2132	2132	1874	1	1	342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfALcLsFkchovqtiHfBSNx7XMpumw8jgLDPHdxhym129J5bg8
24395	payment	2134	2134	1874	1	1	1411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCoVqTJjYHasifyEGS1Dq8YiT8wapFTkdFohdw9JHEd3WnMxz
24396	payment	2134	2134	1874	1	1	1412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRWB1xtj6FJ594ksvf89QPPKjCs1SmrJVmHDsTwDY6Z8TQdxd
24397	payment	2133	2133	1874	1	1	1396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQEZvrCJPoXew6CNPNPPGBTH4zjxnpMucYVjVuPtYZmzvrSdG
24401	payment	1397	1397	1678	1	1	10335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBpcwZLJD79i6LFufGozNLSP1NAQDdnAZVfkJrmRr9t9HVZWV
24402	payment	2133	2133	1874	1	1	1398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogd5Nom4uhsaGjxSyN3fRBzhuKEtfWZohJL1hemKwYrxmsARs
24413	payment	1397	1397	1678	1	1	10339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvGtMGK5yoCWDZzFiqtcYMqbumKC2JrS9KwVfqyRVmfanAeK4H
24414	payment	1769	1769	1769	1	1	43	10000000	1000000	\N	E4YTjyE9Hxey3Sr4nKzuPdj7upfmuLACzFz6BEu9RYPcXYvMjytwe	CkpYt1umsJqDehRb2FE6BvPazPvj6xyJu5iCXGXtfL45cvoc1CiRS
24415	payment	2133	2133	1874	1	1	1402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8JiKcbccbaxT1R4CCNex615o1hpMANMxb4aFjRfDUVSZEA5N
24416	payment	2134	2134	1874	1	1	1417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6VAJqFYYRNLANYd9yeXSPH6h8XjiXZTDmiYVRif3sEEutsbd
24442	payment	2134	2134	1874	1	1	1424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Jd8LkabWaX2daWGYjTjdZT8bHaouJX9sBQsR1fdoQERt2Zty
24443	payment	1397	1397	1678	1	1	10347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6RRMjvQDbVwTRACJoiUiz8QcEx2zSwFFFokK9e5xAesJ84hL
24444	payment	2133	2133	1874	1	1	1410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvFCMut7CfNyi3b2HzGPmGdm5hw3v7EQ3Mzv4k5qfQrkbmfDa
24445	payment	2134	2134	1874	1	1	1425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHQ287xSj7uqsrrSW5UE1LyXtcoBqC9FSssoTLX28NArikyNV
24469	payment	1397	1397	1678	1	1	10355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHkCwPB3EzmoUMC1MmixfuiH43R2gYwR26Qt28Y7Z1ijonwFf
24470	payment	2134	2134	1874	1	1	1433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9yxbbrXAgaVviFaymBpyGxsTc6T1W26bTzbcDdzYVHBs9bZ5
24471	payment	2133	2133	1874	1	1	1418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZsasvq29R7DCCB3bfGpPbP6EAxNFgcGrXskYTByapRBFPgDB
24511	payment	1397	1397	1678	1	1	10368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbEWNfipproG4FBkE4rwE1ZRQMuVeArtUoZve4rZwC8Q1pL2Y
24512	payment	2133	2133	1874	1	1	1431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sbVmFAE9E9aduhyUz7tJvvERrPzn9Z8fiZhEnwwMPjBtnrXw
24513	payment	2134	2134	1874	1	1	1445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMj7abLVSHoTdXGER8cUPAKzLJiCKmsymBBkm8kEB4PPgHFjwt
24433	payment	2133	2133	1874	1	1	1407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFU2K4XqBgxp1EbADBC5MKWRJcbeuLwR4Q6qaNX1b8xH7gLykT
24438	payment	1769	1769	1769	1	1	45	10000000	1000000	\N	E4YRJ5LQJfNofP4JsK2xGipRVCv81GhoLYphB8VtcsnbUV8vr2vSQ	CkpYxs7Ky43F5giVbri4msoB4tGoVdTdp2sgxxTK1HH9TuCcJvUoF
24446	payment	1397	1397	1678	1	1	10348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9FVHG8aK5MGSmXgKEjuVjQJjq4VDxKXari1f5HY3mVuxRewc
24447	payment	2134	2134	1874	1	1	1426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcyHvgZEjmWoP8WjbLkmzPEiLyAxuXhvpHk8fSpU6dWBmb3HG
24448	payment	2133	2133	1874	1	1	1411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyE2QCLp538bVx788zHwDcW7XU5t4q8dKoosiN5C9C3C8Hxna
24449	payment	1397	1397	1678	1	1	10349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjhQXz11KMrcUdhkxdMwcsHQY2qydAK7cPEzSKLRiTkyLRHxc
24450	payment	1397	1397	1678	1	1	10350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3ZqXfM5DNaG8njdndk4PHEU5Prwc9sMeRHrQmtdwjPpAMoiH
24451	payment	2134	2134	1874	1	1	1427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbmj7BTAMVH8yNV1Guo4LJSEbUmQ99XkWVUbxSPwciSsCwXu9
24452	payment	2133	2133	1874	1	1	1412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbQpeceKfkdUaWUMGfXn4HBb7BQx48vVFdt1Ju3fnX2ozs6Y3
24453	payment	2133	2133	1874	1	1	1413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfc36yC4rwHzCkDjvEoFmgsA79D8UeC6iJfvxrsAPzZUDFQbM
24454	payment	2132	2132	1874	1	1	347	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UhcBMCsPZQFzp3xDdcFDXWhu4cnVsmg93BzFr2ABYeDw2JQ7
24455	payment	2134	2134	1874	1	1	1428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCF4gkCUCd2kRh4DTbXsobZPetdcn5J4UqdVFNRhrsc2fvtbe5
24459	payment	1397	1397	1678	1	1	10352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFxa8BuFi2DUvb6FnBSfAxEyE8bf1JdYbhGw1nyE6NGwuLgQG
24460	payment	2134	2134	1874	1	1	1430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhamHxXHyD13hVM82Ajk5we5HvDDcwxrWVDDb8Ypy6cpaSsiUX
24461	payment	2133	2133	1874	1	1	1415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcAxQtGdpv7KQU7ZvSgGdWPdCQxHmWU287ZhWAehFWULPyBqQ8
24462	payment	1397	1397	1678	1	1	10353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrzqycEFukKbJCAQXuriN8Waqdz2VswBUJnRfbVuKkjC4qeq5
24463	payment	2134	2134	1874	1	1	1431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwc4kQdMctuUcE1FxeuDShyp65GA5FEabfBtCam6FrdCunD5eQ
24464	payment	2133	2133	1874	1	1	1416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Mm9QFsohvswV4xjKg3Lb72e1aDoKL1xcWmLMgoi6g5sNpdW5
24465	payment	2132	2132	1874	1	1	348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xhf9HhR8Qd9QxWsf3tA6SHqTtYuDPwRnhua9Gs6QgZrv1Lw8
24504	payment	1397	1397	1678	1	1	10366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GXdZQ8GbNNuLW4jHRQYQtFzn9f2KpvE9YVBFQcbfc4hAcjzB
24505	payment	1397	1397	1678	1	1	10367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmT9pg9BPLsdDEqxAY3vR9DtEqnXnqWCoXJCCHtqs4NrEjpZ9
24514	payment	1688	1688	2177	1	1	36	8352322800000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa2m7DDqDPdnEnicx1qCD2vLhNRxuMD7wNp8jM6oSdbuHwN4nK2
24515	payment	1397	1397	1678	1	1	10369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhuada56UDFwdYHqFn6HXqKc3PDVVDKqYMBzLK6fRLqtFwL2E
24516	payment	2133	2133	1874	1	1	1432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPr7NrQuzHHuTrfuHmRqqMqKojibUCQbUdKg7CXx7fc1PFUemD
24517	payment	2134	2134	1874	1	1	1446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdp3mp3Ht2hoeSy4335ygurcwLFTWf3dVPxjRNu5hXVGJvpLws
24528	payment	1397	1397	1678	1	1	10373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGhggPj7gj3ykRFfpCtSJ83NNVzfYdrUdf4VxzoqAYod6tW7G
24529	payment	1688	1688	2177	1	1	37	13320400000000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZaaVsBbJdq8gQC8kPNqgExNBYYttwEvXrUE9BWvKCHaQBGhhPA
24530	payment	1397	1397	1678	1	1	10374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLYEg31DGoh4FanC4ksDtUdUEaXXWcNz4t2H2hQcNBD6cEVzY
24531	payment	2132	2132	1874	1	1	354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpwTHYENhWdFQnmm1QhgpV2JJgqJMi6xeZgRF7dta4gVJAtT2
24532	payment	2133	2133	1874	1	1	1436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB77BqSgR45yTSBho59fem8frS6yiZsr6Z6zA6xi8LUmKMJnC5
24533	payment	2134	2134	1874	1	1	1450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbjxtcoh4TL1au2TBhTPhnGDxdBqz83ZahD6oyjWDMBVqoErD
24534	payment	2134	2134	1874	1	1	1451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFob58q8zPbp2Hpp8J4etdQ8sn4VFiKgkjuuUJPC1MqjLiJsJ
24535	payment	2133	2133	1874	1	1	1437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcc3ZzA3avM4o5J9baBBgYdx8uTLy6555xtz7WSX4VcBHxQgBp
24536	payment	1397	1397	1678	1	1	10375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsvhyFAYdZBaG9fmbA599toeUzGzJVG3BDUqX6SEdNqmiYu2Z
24537	payment	1397	1397	1678	1	1	10376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDsq1r99WU3xxGDH4azEbpeARG1Wz4cChL7w75WXJt1qrhZRR
24538	payment	1679	1679	2177	1	1	48	1548057200000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaA6z9vWsCwEBvKnuEbguw4H6UKLTt1tEP3V2F2QZ1VB1y3NvkK
24539	payment	2133	2133	1874	1	1	1438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsuAz4HJf9JXxM71tRj8GapQ7xYdGPERjXCQuCnw4wtPJyCUm
24540	payment	2134	2134	1874	1	1	1452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZd6YL58EsBNXCQp69tcGxfCcRQNAenSEjKt1D54xMo7PLwGf
24435	payment	1397	1397	1678	1	1	10345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3kL6gwRWtcS845RZ918nqLVBavensyEFD7Gt5qbbN1hXdYVo
24436	payment	2133	2133	1874	1	1	1408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJLqQ5SPVQi2Sa3xXwHpYbYuQ1FmsHiJQjnwosLCcF3p7Mpd3
24437	payment	2134	2134	1874	1	1	1423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVDTN4Yv2BZX4pDh37GKPTQvabW8mqkoMK17oPuTAhTEc9mDK
24456	payment	1397	1397	1678	1	1	10351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfc6Aavt2CGW68a5qyf5J28KxAEi1sTshxpTQLrMdWnikbNa9
24457	payment	2133	2133	1874	1	1	1414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSiWFARELraEYkm37YeEVa7LDw7koJ6fg8t1mPY9XiKp3sr6e
24458	payment	2134	2134	1874	1	1	1429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NwDMKTSGyG39yias4Li8AbH2xSvwze61zRQr9vDyVRGsVP4f
24482	payment	1397	1397	1678	1	1	10359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSRTsun9c9JwwLCcQH4Tn4Vvu7Y21abZfmU4wAJ1kHChsEoMS
24483	payment	1397	1397	1678	1	1	10360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZsUuQnqk5KREr3xypjHnnchWpkAJwWnWx2W2tGWig8A3wFKU
24484	payment	2133	2133	1874	1	1	1422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxh7ebY11t9qWPe9mBy4v194wydrCMfjqDVGDL6Xe5fMhcV1Rt
24485	payment	2133	2133	1874	1	1	1423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgUxQ2j3Be5FRHrHhMTxPDRSVQQR7tKNjE9GguUWkTSLvVsHc
24486	payment	2134	2134	1874	1	1	1437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8AsELTmrnDnB6DSvbUVvHZ7DKUoaKYjiFH8vpxHCTMeXCzB2
24487	payment	2134	2134	1874	1	1	1438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDL2rkNyFX1WBETxkBPqPMXotUzkBAhYf9cFoYR2ypiFyUQunm
24488	payment	2132	2132	1874	1	1	350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme3Q9pd3hS1sd3uFDwBWbLazL2DxDfyqUzLA4piZHroBSYp3w
24489	payment	1397	1397	1678	1	1	10361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQi4hN8atyw1vqmBUX5iU7P3WYUwKyohgM2B1LKtwpJ846kdJ1
24490	payment	2134	2134	1874	1	1	1439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoWhNjCeknscwUS68ha1gBNzxkQXLyzx9wPVTLtci9LGqWZyN
24491	payment	2133	2133	1874	1	1	1424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDJbzTgrTNcxoJryiFyCMG29F3EaHdxHRuuMtepBb4dmDYoG9
24492	payment	1397	1397	1678	1	1	10362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DC3F5ehPkoh67E5tXB1hYwzoKAH5xAYiPZNfFCqPCn69mBWU
24493	payment	1397	1397	1678	1	1	10363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9H1HxsbRXrZb7gj4ptPRhsS6LZ6HUHYfCGNNnvaJknF46CJc
24494	payment	1397	1397	1678	1	1	10364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkpqA8FMn5esS31bDn46ueXcdzSiY8yRMQDvM9v3dw8zS6Vri
24495	payment	2133	2133	1874	1	1	1425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQeW22vLCvESqgX2g93yopUmanbHg2qas4SVq4LUgvuZ3k6BsM
24496	payment	2134	2134	1874	1	1	1440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzsmnt1SAgpXmpF9EpEQX8ew1xUsZpTG1ugTovPxBKMCFJGVq
24497	payment	2132	2132	1874	1	1	351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhazZM5B5Mif645Q1UoYqUqQPE6TVXUFxfzXbTcscGVxViJoyo
24498	payment	2133	2133	1874	1	1	1426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1vusi3kYwpUNREeGLXZhNDWtKRbNTvMAYYsncceHw54A2ZYa6
24499	payment	2134	2134	1874	1	1	1441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmDasbdykNNKGimMdecu8fSbouXw7mjrqMLDoUwQmR9epi8Kd
24500	payment	2134	2134	1874	1	1	1442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQimCfmnNDn6s1KJwYv6RJDzBzQTmWj8xBfkM9CXMbZWtBBKL8
24501	payment	2133	2133	1874	1	1	1427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBuD4HBJSp4CYjk3qu1rVrHUWXhDn5CCKMckHKpoa3qtvysAL
24522	payment	1397	1397	1678	1	1	10371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQeG43yJsiU75qvBMzkVVZNxAfhEALZCx49N7Pvomw7o485wD
24523	payment	1397	1397	1678	1	1	10372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2PywWEV7ojGfqcXmASjSL3ot5oXeLKwZS7Pg59KE8a3eXYBa
24524	payment	2133	2133	1874	1	1	1434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgetrnpEiRNh4HKtCHJbARwHLcXbJVNrNpr9W1hkNpLFjYzvm
24525	payment	2133	2133	1874	1	1	1435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmNEHYMgLKLTHnEXfw3f1GhuxYEqhVL3XRfifYFFnqRP1JuNX
24526	payment	2134	2134	1874	1	1	1448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSmQQr1bpxM9mhDu2nt21K7L9urZBgBs99wpG4f1b8MnKPETe
24527	payment	2134	2134	1874	1	1	1449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEGyqzg64E3kzCp8qf9mTudeK6zgNeigKMZsRa3oUAUh7eoeA
24566	payment	1397	1397	1678	1	1	10383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU23AzmFCi78v7xK9km2WEazfpgNoMHDMtEHF5EaLfH4p8uzy9
24567	payment	1726	1726	2178	1	1	8195	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfsaTzZE7fBUdokDZP9WDSBZ5dSn7ECFEcvzzHca3sG9uZQe9V
24568	payment	2134	2134	1874	1	1	1460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1rcfWaH1hTRmjYEHXrh3MgJqGbJys4bbbhT19vnxwhsSmvmE
24569	payment	2132	2132	1874	1	1	357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6X5ZGHdYPzpnK23w6NyG4nXktd9neT95XwbGxv5gWsmwXbJRD
24570	payment	2133	2133	1874	1	1	1445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFahskio8fxo8wURTALSUTChzmTFMQxLwSrjXW74Dta4xg2HMg
24571	payment	1726	1726	2179	1	1	8196	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYf8hawq2e8kpKYoahy3jKqvEDmMoRbmy9GmyRZP58tyNPTsuGF
24441	payment	2133	2133	1874	1	1	1409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1PcfXQAkKZdjFbG9qKPmpAvFxG8QNN3D2bqLJE3o3LgG13uG
24466	payment	1397	1397	1678	1	1	10354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxNrLjjbdf1mfSRxxJ8TZ2Db41vqeR4k6GLQLQMUFTBS5nx3R
24467	payment	2133	2133	1874	1	1	1417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeGYcr7SpiiJ53c7ZR5846bBHSF7QEtxfYf1KJq83xpZjtPUP
24468	payment	2134	2134	1874	1	1	1432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2RKzJYr5qUMJF7TaXwATwmdPvcQEebTGGn4vQvKjHZBybiD2
24472	payment	1397	1397	1678	1	1	10356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoofCqo327dsyaPCHfgN33B72mySYvDQA9jvzLMcYvoBB5Mbq2
24473	payment	2134	2134	1874	1	1	1434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEPcTFovEg5GSDuVyD4QhpSrPLpaG9o2BiquUcxj2p5AcTxvY
24474	payment	2132	2132	1874	1	1	349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AuJsmaEooP3qSo2Z5bjeJJ8U4HnjA4nkFZB9VQXCrUK9hfQJ
24475	payment	2133	2133	1874	1	1	1419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KUGNnqfU7ERwB4UHuHhTDTrwn3ZtiuKGMxQj4c6zE1gJmW2c
24476	payment	1397	1397	1678	1	1	10357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUmWdwpHusZ1qcx7B1grYzyTU9tNBbMM17jYyRSCyxCiuBrAi
24477	payment	1397	1397	1678	1	1	10358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWWtZdRWXCiVjpH1fTKvNPdwAco9sSxz3aDkTmEjsuJjV9aFq
24478	payment	2133	2133	1874	1	1	1420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEJ57h58eaEB3SSKKGkaRD8A4gDjJCNgRFxfDUDKxJCEFjm4G
24479	payment	2134	2134	1874	1	1	1435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmiYsi93srbfmEDibtNxukYNP1RsvQ33DFmexwxwf3zaCSxpz
24480	payment	2134	2134	1874	1	1	1436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQkXEqSpfADcUQbYvgcwjQK6x2XJnLcrsaktD32BVMSdYoRG9
24481	payment	2133	2133	1874	1	1	1421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCQLxmZtcSkn7jZe8c6DYUDKk2ayVyBUKd8T2oWMw7CR2Rq5N
24502	payment	1397	1397	1678	1	1	10365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKxJyxTmjjWTsSPY4vhyALyn4e25GsomtFzr54UdrPyyZa4Hz
24503	payment	2133	2133	1874	1	1	1428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmEJ8EfuEqiuDvbhBpSVCPePGxWcaR8LDjfZhSesmurZqvZcKL
24506	payment	2133	2133	1874	1	1	1429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4s2Hf9ezEWga8HNRM5X2b75Ep6oS7RXjC1ozyHQfnaSYLxbR
24507	payment	2134	2134	1874	1	1	1443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrvBit66b2UC4mkmWkK3iep3L5tUMKDqsqFqfXqnderuJgNhR
24508	payment	2132	2132	1874	1	1	352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZTN5djTQQmi8LWcCF5jkSybBTU9dHBbrgfMkvUot3GTpmL8b
24509	payment	2133	2133	1874	1	1	1430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwmbLyJRZ9jqe8Ub8WrHeWzcyrWvY2TKKFGaNyw6aj6yQRtXk
24510	payment	2134	2134	1874	1	1	1444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFK4BqV3aQymgmJbcjdwATLYBSoZDMyDbRXcSHyY8Ujz6st1vu
24555	payment	1397	1397	1678	1	1	10380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrejwP5jfuqgRgBRntkaSXdLb8VQwHA324Vt9d7ScAt3tLgtHi
24556	payment	1683	1683	2177	1	1	2	27215439399541	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZyZseGh6iNEddBADYLA5WA2r9wRqztxF3Y5fSGpzA1yZr67G35
24557	payment	2133	2133	1874	1	1	1443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRjHVthuATrWReE1p1fs5jbjubYmuwiBvtsCvLNbnRQ4VStnn
24558	payment	2132	2132	1874	1	1	356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46BZsrwsgWvSowUUDAQHoJrpddeTrFQRHtHuonkwdvH7TRbkB
24559	payment	1397	1397	1678	1	1	10381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVhKwS4NSEu8aoEbc8jGTmS1MhF1SEhyGLfiygY3bWi173ZrD7
24560	payment	1677	1677	2177	1	1	2	9557246850100	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZZVfftazHopb81tgC21ZgBjMe9NCx9ipdehnnb3TuJyX1MnYYo
24561	payment	2134	2134	1874	1	1	1457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtP8EwbLPWwsGRaaTsusRfTptp69kVoQUk5rPeKdLXeXyakQq
24562	payment	2134	2134	1874	1	1	1458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9KAqhWxxSuMZkxEuY6F5H1vdrAsyZ2uVeYPCBbDeqyJfDC1j
24586	payment	1397	1397	1678	1	1	10388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6S5ACB3ddvnApmu6HezN1KXWngo6tQViuZmq51w474J6TZPEc
24587	payment	2133	2133	1874	1	1	1450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuGgDBsBJxCpRAS5kVe4bN9Ma3TNwga3cqHhMae8SYDxoz5mR
24588	payment	2134	2134	1874	1	1	1465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjXUvCAF9tuigVTuv7SqvDnVZL6igVyUEUfw1WTgxHGNfvgZ9
24596	payment	1397	1397	1678	1	1	10391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7euim8yVH2wMyECAdXMBkrhsiQpBtQFT55v3B2HqEUVq1KwpD
24597	payment	2133	2133	1874	1	1	1453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZwdhgYyTNc1kZHsSke8GgUUXequete2X2r899VoTeW3xQ72s
24598	payment	2134	2134	1874	1	1	1467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLxQd51xKjB3YxRd1EQicgU35wa4Y4NjWi8CZbMhobnbPfvR7
24613	payment	1397	1397	1678	1	1	10396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2nZYpK59XTFeWFXheGCKAijMckfP2g2FnGckkzbqgfvCUjH6
24614	payment	2133	2133	1874	1	1	1458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkWWb3yfo1VWduvjp2yn91JXqzKeCXfy7qpFCyBcTk8FnP8iQ
24615	payment	2132	2132	1874	1	1	361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBqej7Pz9UGbr4RHs67oorn3pQGESYhpLJ2CYZeYKr1KFfG3G
24518	payment	1397	1397	1678	1	1	10370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTHtFwBBEF6jHoQZqeWKDfYo8FcPQaEz18DkzCrPPbX6x4xQV
24519	payment	2134	2134	1874	1	1	1447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhQPif6f9xEHLZ6tcxg78mMj6BKMXfejmaS93ryqAZ3b48xjm
24520	payment	2132	2132	1874	1	1	353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi9dah2w9gEgCFWfE2XbcVoyvVnsM3veCnVemYiAwrEnd9AV2
24521	payment	2133	2133	1874	1	1	1433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UQppExGv8BVbovVtFwjPA8i9AivHteLsi16U4J2oR2TMqxzA
24589	payment	1397	1397	1678	1	1	10389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGXiTdn4oMh6fv5v8nb2uhithQuVfR39ndjMvGaa63rZTMtRR
24590	payment	2133	2133	1874	1	1	1451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMNFA5Mf2XP9kKuSpGhiQ9dD4sbu66DvmtckAQi21iGudSiFN
24602	payment	1397	1397	1678	1	1	10393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkUAcWSgybEbKaDfEQAcKMr5pcPrjhBUKgMiTnwY4iK8hXAiUS
24603	payment	2132	2132	1874	1	1	360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjk4P5iRQmwrR6EMFsH91KTvsCkaGHpKUUhVk4TaJL74dSq1c
24604	payment	2133	2133	1874	1	1	1455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsdpLpneQnm9R3j1ZkaRnYKm3j4gzed89LxdVuggipm7dfGwc
24605	payment	2134	2134	1874	1	1	1469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurF8U4xkpngsBcrmes6bVbWgdFEZjJnDKEBNSbg2TvjhGuSXo
24610	payment	2133	2133	1874	1	1	1457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgEwmwC3Fg3wS23BcHNh1Hkhgcy8tv1StSfju85xTo9fb22Af
24617	payment	1397	1397	1678	1	1	10397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrFHcPm6W6qky89AZgob2ZtEGGqACMixwVxRv84T3J6jKfSiW
24618	payment	2133	2133	1874	1	1	1459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVazTUk2N2rXtHx4sR6sXHDZYMHUxkGH1rbxHFqfhgtJE17pf
24619	payment	2134	2134	1874	1	1	1473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK4GNFttFkTq2cL4jvG6Ai1F5DoCNx35WiPjR6LrCWnkqjmcLF
24633	payment	1397	1397	1678	1	1	10402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEAuJLLngfYLFHvZtMiYAFPKrTTJnHLTXBy5potQTcQ6wvQtZ
24634	payment	2133	2133	1874	1	1	1464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvARVUD8pZd2Fha9Ahnjo6wc6vxdcefaR9jtRDkZtkDG7gko7K
24635	payment	2134	2134	1874	1	1	1477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihxHy98jxSufejcY25xjSZmqfwS66bZpfi5Kdc6vvVSk9AxVR
24647	payment	1397	1397	1678	1	1	10407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcp9T8Ec1Zph91ooxQYAwR3DLzE6QiHA3PB4zq8ienpHuemtn8
24648	payment	2134	2134	1874	1	1	1482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPkoAbnL4uEd2YBcD7qE2Cf17LopJ7tZsx4H2WNpCMxkzRP98
24649	payment	1397	1397	1678	1	1	10408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9BezDAb8W15pFcAbqtjZ865P6GBJt5x49z6pw51bttDu52j5
24650	payment	1397	1397	1678	1	1	10409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbyXzfrHJDDPfLccj77V31ySk3EnmHj8isT3FFUXBpWWHFSFsX
24651	payment	2134	2134	1874	1	1	1483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRtgyU4sLzyf3dXcxDFTDn8fAnLNULLmrRY99kREUzzGTdUys8
24652	payment	2134	2134	1874	1	1	1484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEk4fR2pvn9a3WtC58LQhebPj2x5JqF6xo7869jSe8NaGaB1UQ
24656	payment	1397	1397	1678	1	1	10411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJtf7PvxEa9dPpXEdPbuCVDvZgvbXyk4WvyENcUQYcbhCL4TM
24657	payment	2134	2134	1874	1	1	1486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYmiLB2Qt1u8BF6cRuQz9Ax8psG8cGTDegCS7i8tJXVhgDoyh
24668	payment	1397	1397	1678	1	1	10416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YhEgK3rRVusTqSou56AgSmDcHWfrAUyz44sZvzaaQkxgS2X1
24669	payment	2134	2134	1874	1	1	1491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5Gcgz9To2jPn2iZMzHPJUCtc1g7tAFzpWV3JZUFTvhoJ8YXP
24670	payment	2132	2132	1874	1	1	367	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEkubexSk2sFz14rW1tgfxJcNDcrAXSUNn4VAxiSvrrUR6T96
24690	payment	1397	1397	1678	1	1	10424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHK4Ggitb1nDrNPhZaUCWSSLQQ5np9RegPTkFS1d3qJaTifWDv
24691	delegation	2139	2139	1560	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8HCgB1pjSqHCWUrmq82TaxMnngNxJFvPBCsK2dZAysxp4KFN
24692	payment	2134	2134	1874	1	1	1499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oBxRmwy9SA2Kd9VVezCdsPiqfJhpt84miUWSwS5witgJuCnn
24697	payment	1397	1397	1678	1	1	10427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtdxd8WSeJd81RwC5NcwkVxZkRVT9mdXUFqWXw9pnDyJor4vn
24698	payment	2134	2134	1874	1	1	1501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa614DxkipiFChDeMSpWKYKWKhyUYsqj64SVzDKh9pJCVMQU1gE
24703	payment	1397	1397	1678	1	1	10430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7raawVV2byvXgRngRhsBJzeHHHKegRQwSn1TqGxpWiuGEdk5
24704	payment	1397	1397	1678	1	1	10431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfiHmTtH8Ruuu6hZyUMFgLbxX58n2XFm4cYVZiY3owDg2xhJoJ
24705	payment	1397	1397	1678	1	1	10432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcEa7T39kmsKJz3wKm1Sjr8YQ63qpiYv5HHm4vXmExhLpTpNK
24706	payment	2134	2134	1874	1	1	1504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGGxK8a4x15dTEdMsnGMhCfuahyzK1NNKfFuUcv97kuvxhdSC
24707	payment	2134	2134	1874	1	1	1505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfLZSAya734DRMzvpeWxL6Twa854XcW6e3zN2LSyHki2BB1r2
24541	payment	2132	2132	1874	1	1	355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t4tyspme3MPqKDF1Cb6WNRjLdcSPxxm8MD6wscmNmkC4xePo
24542	payment	2134	2134	1874	1	1	1453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9B8ovsw8SyAnctqcLBQmAURe9AixtXF9E4GszDV2C83cKgj2
24543	payment	2133	2133	1874	1	1	1439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUfQf8zVGxby1sbFqwLrFGbhDRPEHYJCed5khKnnS3AuAdwtn
24544	payment	1679	1679	2177	1	1	49	3708100000000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZqoq1GtDHxSQA5ak3rWhoQkb9Sa8BW4ReTnnzxpmWt4VaoUcEX
24545	payment	1397	1397	1678	1	1	10377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyK8c3mrfVZYBCvG1uDhQUBkzHb3M3B81aGN6jPM7u78zskwxx
24546	payment	1397	1397	1678	1	1	10378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDq4R8zUoV4jA2yrVBGezvh7f34wiDFnZUhUy5LW7CZzS4tuN
24547	payment	2157	2157	2157	1	1	0	5000	1000000	\N	E4YXYczkh3RDn4ayEo5fLXQf3U1mZyAVtadozsT41ftMqkqsJxvdM	CkpZ1xcLTb6pULrYKUQKfYGbEMeqEffJa4CwUEdTS98oRSdsWDWwH
24548	payment	2134	2134	1874	1	1	1454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdLLDJipYuhCGKmk5FWpMaLkK3MUKeHphMh3LSf2umFshCwMB
24549	payment	2134	2134	1874	1	1	1455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuyipy5t5x58sMToF8V1wgkjugfaVFd7ZyAHp6E8emn5NJPq3
24550	payment	2133	2133	1874	1	1	1440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp29nJPAzQfb6dkDyB4bRa8wobNq5DQBBoeVaikpGrjgaEqMH4
24551	payment	2133	2133	1874	1	1	1441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPgzdiqFUheFcomaXvrCQfc1WVs6jivvpoVfxcncTNubBn4Ya
24552	payment	1397	1397	1678	1	1	10379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2YT6q8XjrLcPiv2XXXdwkbcbH6JaYssJxrVthFsYnWUgsKd4
24553	payment	2133	2133	1874	1	1	1442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXtsLk5iivhcAMQPVH5kKS7gWfrV8Fs1gjYnKh1nsxQ25wqAB
24554	payment	2134	2134	1874	1	1	1456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pZjFcGmVvsFiJYvS6moqH7nAEe3cxi8g2eZBSJXLjDgFZoNt
24563	payment	1397	1397	1678	1	1	10382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWofA7AJ6PxG1ZAndpyiYqmF6CxWVdUDwzV874wSSNgF7i9fN
24564	payment	2134	2134	1874	1	1	1459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzmVyiEBHuAkt8WRmt37uHkMx4Fpg8YiPNxJgbqNynQsqFAQk
24565	payment	2133	2133	1874	1	1	1444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6L1JcLnb3wdtphMdSiyeixnBZXh6LtYBWG8Nomcha2fAYaszf
24591	payment	1397	1397	1678	1	1	10390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQxaDFcW4exv6WcjkwUkDR8vdpYwqS2Ad21Fw9Eu1S38XDyvQf
24592	payment	420	420	1483	1	1	2	0	10000000	\N	E4ZRjvbHX6e16ZXnLT3AV7kagDtpqmgJyVAGj5iMHAHq7fb92dEhq	CkpZoXTL9cacGupXL4Rg169XyxVs2K8zbHw2EH6FxSgVLtyToFqyp
24593	payment	2133	2133	1874	1	1	1452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjdxwgetuW6pPGN5pCiPBtR5hptDdAgTz7JVnxJ1NapGSPgMy
24594	payment	2134	2134	1874	1	1	1466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgFyZAxsMEXD9CtMiTsTUDAGKPfj9CfGQ7sBV69jMeZghgp6k
24595	payment	2132	2132	1874	1	1	359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nekDL5P6XvBNCd2Zoo4pVBXZ1v9Jn7NmPnnPK8r7V8kY4pEF
24606	payment	1397	1397	1678	1	1	10394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLHUAP6Zv6yiWcidFmNrdVYdgFJYyXT1wGdjhAoe95GusWGDUM
24607	payment	2133	2133	1874	1	1	1456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnTDhehR7mC9cGYqrT9EJwAntDTJdSgCBdUbpwD6HeNzsZajT
24608	payment	2134	2134	1874	1	1	1470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYmqck5rA3eu4v7N3Rkc8aA9vyU6uDETjK9fhXazsHSC2VqKv
24609	payment	420	420	2164	1	1	3	83000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7YCu2jh2pYUKagQCVLcPT8qVuj3qCLvGHjroGogSN7EkzaMp
24620	payment	1397	1397	1678	1	1	10398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCF2nCNYp8qsjNtdgZuRHxhPXFNZeFhWLU6pb4DsxfG4sgwyZk
24621	payment	2133	2133	1874	1	1	1460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1fg13JjD8XqfXqPtYm6cxBnkCDKR73D3VZoHMnQgPPtAmaM2
24622	payment	2134	2134	1874	1	1	1474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZaAEyuuP5CX2mby7cHTVHU5f4XQwVwuQoE8VX5cQ5g9eMzQT
24627	payment	1397	1397	1678	1	1	10400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6vFRFxEPaaWXGBnEFkF4p3jwEnEwdZMVCnKd6jrQrk5sj7Cf
24628	payment	1397	1397	1678	1	1	10401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4hcAjBxqZvn9FDpMfeLRcB1gFox6wFZrLZcYD4QC1U6VT2RhA
24629	payment	2133	2133	1874	1	1	1462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVjhDQzm8k48NZbX7YzzS1uiDoezui75eS4MXjTxqmzvfdoRy
24630	payment	2132	2132	1874	1	1	362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gpFuYZDF2c8XgTDHhJqXKSoBNyZ9GxYjjWJz8Z7NPjyt9FUb
24631	payment	2133	2133	1874	1	1	1463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ntdXK6eXGrZrXB8BKkALhueHX78NcZkKdqMq6yhxyLBQHKoY
24632	payment	2134	2134	1874	1	1	1476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLfVKktUG6SBSvRFCsNc1bdFTh9dReA2nZJimJHLqxnHPdt2H7
24642	payment	1397	1397	1678	1	1	10405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PEZsZuDCi9GqjGqPbqAN7FiQ5pKEDqBAXcFyU61fMc9w3CfS
24643	payment	2134	2134	1874	1	1	1480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRW9x5iBqVzQvvhKbhz9dLacdn5ddYjgaAMxZcBCCkqcrayzQa
24653	payment	1397	1397	1678	1	1	10410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnadMSASbRtTiyFxktukU7t9bgAGXCcQEJ8ME87MJ3MopBF3u
24572	payment	1397	1397	1678	1	1	10384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJcsWENxkRmdXFHNezkpTPDqyJLkiZ3enUwisYLpBkQrUALTmx
24573	payment	1397	1397	1678	1	1	10385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYywWdYsKbFVdabezrCdSfqsBisAMKq2hmpUTJeoxVw8jGWc8c
24574	payment	1397	1397	1678	1	1	10386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgnAZ36aTUQB9qy61w8uKA6GXQ8g8YpkGTs3HGVYFjL6fBKq3
24575	payment	1726	1726	2180	1	1	8197	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1W7KXkmm3eyQ6LDzKDStqEjgyvRoygNgM6BWYLDguB5ngc4wU
24576	payment	2132	2132	1874	1	1	358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9cN4gWzobFWPAqffQ2Z56xbHCEVTncySYQ8ayxRqbggPmz9P
24577	payment	2134	2134	1874	1	1	1461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7E3kGyVQzDYKzjQVauom7DASqWMQqsStRwrfX6K6TKFeS8mb
24578	payment	2134	2134	1874	1	1	1462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6nQDsBqVqmr3ogo96Eo2Lo3LtpDL9iUocpT1MFKm59TG4Vq9
24579	payment	2134	2134	1874	1	1	1463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYLmzq1fXoDGC4Ay8yiH8eyYKcm2EwaGtiuQCb242J1EqzDnt
24580	payment	2133	2133	1874	1	1	1446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iT2gtuU5ov4kji39MnVYMRvsJVR8DbdQMzC9wxWQyVG6Vtck
24581	payment	2133	2133	1874	1	1	1447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmuBQNiSvtkMdhG8dQyf9HzhgjQjg4f2BZhVyNMviFEEABMqjN
24582	payment	2133	2133	1874	1	1	1448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSYcqYgxwoAZCq1j5G2wW6bZv5WhAnzJm33K6RJiJbBSK6agn
24583	payment	1397	1397	1678	1	1	10387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQBuHY6gkfUFXUyP97JMGAGQStXTKwjCEToxQn4um62djmSuf
24584	payment	2134	2134	1874	1	1	1464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeQgJsqB5QrvQefn4bh5AbiATULk9Rgxq4xFQeL97n6tzqRSU
24585	payment	2133	2133	1874	1	1	1449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGB3zWdYjoWXanHzCd3Giksqq6auAfCLpdSrff2FzE5V5FuaHa
24599	payment	1397	1397	1678	1	1	10392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaeJ1jWLdJiBo4ZEtxdr9cgD8h2JKU1ngiQrgoqpUGCu4kyfH
24600	payment	2133	2133	1874	1	1	1454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXvMV5MkRhoAgSE5wgjrKahR2rTdEyLgnv29UH7JCxvPMYkzG
24601	payment	2134	2134	1874	1	1	1468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR1WNuGTkEy2f4zwrZLQvjiAtmXa3uURttae6CMDDUYRfBRGF
24611	payment	1397	1397	1678	1	1	10395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAtGZNgJfXPBA3RErVda9FyiBQhLXsHJShRdobcwGQA3MikFc
24612	payment	2134	2134	1874	1	1	1471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEthxqjAkNp77imNYGNF7miE9dD87B85PiLUXB8szWP2Npkbmc
24636	payment	1397	1397	1678	1	1	10403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTiXYDDzo9VjZWJg9efN27og1RHTDXMy4ymK2gmea54JNSM2P
24637	payment	2132	2132	1874	1	1	363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8XpaqUj6HWZ1b4s3DUUbS2nXGhcBKZZoWdmRoktxVb1CzrbF
24638	payment	2133	2133	1874	1	1	1465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtnp5bArZznajo6VqKb2TaMHhmbNFZv4G3MDKtdo7NpJQNwGJx
24639	payment	2134	2134	1874	1	1	1478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1h9QqEXHkuhJ7xJYpgf5AsAYwEs2mgJMu4ecPioCsoZZfonv
24658	payment	1397	1397	1678	1	1	10412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1VJmR37thBXrvhYzyBmbLksrXzEVrurnQ8hfo4C8L4SaduLJ
24659	payment	2134	2134	1874	1	1	1487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9AXcqpn69XWmEf2QFF9o1DsaLBUmMhzmxHBTVKkrpx2LFrXj
24663	payment	397	397	2181	1	1	0	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkB7dFFz5pE9wwtduuX86dp1bSJLi2ne61LNMREMKzPE85h6p
24664	payment	1397	1397	1678	1	1	10414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzBgcEAp1rrFW6Yy1ybFSugCTy2T5YLrkqjocjTg7j1xTyR4t
24665	payment	2134	2134	1874	1	1	1489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXHLWvw331iX8FgVZDxz4XdNSz841iW9u6gQA2trK6iiiQESsd
24678	payment	1397	1397	1678	1	1	10420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi4jGdfj2Kz2xEC4oghjHWQY5wkjpk5FzBx4WwmLH2NrC1QZZa
24679	delegation	2181	2181	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM23c21GGXtScfdurP3LhfthQSzNvodVvr1LWE5TPQ2bx5xr7e
24680	payment	1397	1397	1678	1	1	10421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqJXSyQMStLEopvdNydUZMPHJj2fjFR91FQCYoYhUTb9dMsVA
24681	payment	2132	2132	1874	1	1	368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY72oERm3AZ1ecBBMhCaPytzusvpexAN6RSmPxJ1e4e1eTd4Mc
24682	payment	2134	2134	1874	1	1	1495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZktLPa65m2bpPotT24Kemqcu5KBT6fWGiB4estkqM3pKnaK2
24683	payment	2134	2134	1874	1	1	1496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyoP2KqQigLPMKbobHyf5tzSfN7ttW7rhzNyV6AHqpmgS7aDY
24693	payment	1397	1397	1678	1	1	10425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58vstvNobx1HtXkwhBZM4T68bVk82fFQbLeBgndWt62apWEe1
24699	payment	1397	1397	1678	1	1	10428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1FpDnBLSDbWk6vgMdrSp6Q1N1o9SpFadZZ763uK9tJjgma38
24700	payment	1397	1397	1678	1	1	10429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitmPWLV8ZEdjgwceDCS3f1uMPgTKswxiNR5eM6ss426V5Svu4
24701	payment	2134	2134	1874	1	1	1502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCb4SmAt8zJL5CW9G7yyHqdVA3Lruv77xMHC66jnVi5DmdMfC
24616	payment	2134	2134	1874	1	1	1472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaF14B34UEfvacbsEzTreoyihdH6ydZZEnd3LN51rwBPJvZoS
24623	payment	1397	1397	1678	1	1	10399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjDXoygDPpQKFU82RdvoywE15fsxEsKqFKYE1NnhQtJGdJoBx
24624	payment	2134	2134	1874	1	1	1475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt46iE1YGYc8kfxspkbRPJDYaVXFo4XB367AofjHxXb5mjF9K
24625	payment	2133	2133	1874	1	1	1461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdn1hX8nFAKfg1gLB5xFhkeY2oLuDZcCdFMV25f9gVWgje6HT6
24626	delegation	1804	1804	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NFZDJCac6cHnXhaQrLB9tPiaAFC1TFbkmPYn6v6F1gdqgpVy
24640	payment	1397	1397	1678	1	1	10404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW6Hp5BWkRxtRYNtnWK19EQNCNNodRVFmhWd73xVZrd694KFW
24641	payment	2134	2134	1874	1	1	1479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1HXCCDgwrLcMZmoaFex94KECdPjCbTToBgEnoVbU75RDgtpY
24644	payment	1397	1397	1678	1	1	10406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQid2dgmEm82Sc2461xHVJCXJ2pTzsQVWwXU7e78H9P9iTyrT
24645	payment	2132	2132	1874	1	1	364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8sfjBZb7SzUejp9tDfe1pFdiy2rq7cyrphXkRhAMFi53Ka81
24646	payment	2134	2134	1874	1	1	1481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8d3wveSAoxw4pwSBnYG4i1ovb3nfRmsLWNnZVjsP8B8M1XerB
24660	payment	1397	1397	1678	1	1	10413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErNy87g2xufCTfLP2u9bzd3Bf8fmzGUcJWCaMUyuC4FHxoue7
24661	payment	2134	2134	1874	1	1	1488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ1zvUVYMGMaEj73RFTuF3LWaGs5wGwaTBFpRiwedJ12VH6w9o
24662	payment	2132	2132	1874	1	1	366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXzivrY9CS6XuL3X385b1FALLLF7PFb4MgpKHR995Q6Qrc7AA
24671	payment	1397	1397	1678	1	1	10417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1svB6TfhmfzopFJ8mfd9foqgxg5UCkCi7Sja8AhH4iAi5uUsy
24672	payment	1397	1397	1678	1	1	10418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4tUnXgQ2bov3SH8cix2PuKAkKSxEpjd3CXGiQgk9GF2FjoTg
24673	payment	2134	2134	1874	1	1	1492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEjvvbj8RZ4eophqb2EKVnE1pWfJSKSAnTDqXk5akrxa3CEDz
24674	payment	2134	2134	1874	1	1	1493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBfHxBJmwhQUcTBQDzaGzd1JNmnE6WLYMLD1cGJGcU4o3F11f
24694	payment	1397	1397	1678	1	1	10426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnq8ixEQhQH5m8sWTe7GzbozRNythNk9crvPbHsX2TxNy3hsfq
24695	payment	2134	2134	1874	1	1	1500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzVXnih5zAUJpGBWorXbyiULWF2UWwp5x68kG2juQGnY8xs55
24696	payment	2132	2132	1874	1	1	370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJ1TCtGH9iYQoEWSgZ5zGXaFNPm9WBqE3KKhC2fyZvLXSdJ1q
24720	payment	1397	1397	1678	1	1	10437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWe6hVbriMuPAVXnTCnfiRYt5y15hiD1h2LUA3fyLV1c4Ettf
24721	payment	2134	2134	1874	1	1	1511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8z3e1GmXsY8tptbZoLTpUb66NSxxQ3bCiim3E54jLrGoh2JJp
24735	payment	1397	1397	1678	1	1	10444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpvfo7FDwJSLZ4X2EsnqLmxH6XDQQaPyiJC15wXuA2YVq97mH
24736	payment	2134	2134	1874	1	1	1517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRwEFAiqoaHYZgZicBF7wphrYK7KFi8KUKPWWo1DGti9Zxr2M
24744	payment	1397	1397	1678	1	1	10448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMjejiZqBrWiE22uAV1BY4PorHj2AF8HoA9UETnpqBsASHZga
24745	payment	2134	2134	1874	1	1	1521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oLTqzCr4RtbV2Yq1sLy8vmLAa7Un4c62GDgkqLwo5CzeWSms
24752	payment	1397	1397	1678	1	1	10452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZ8mbyYb61BL2gF3EmkrSsZv8xpmPu6AyzCybZ54hVVV4BnQX
24753	payment	2132	2132	1874	1	1	377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPtmXDenHq6B8VRCgSVqsTdCk7u4vYY5DxVg6ah7Kc3GiCBq3
24777	payment	1397	1397	1678	1	1	10463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUuajkgpBwH7iXyPbPHfS9XDY7s8SB631zthxk3j5j3NeRtKhS
24778	payment	2132	2132	1874	1	1	381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbGFCRewyuE8rr9SKY1Ri9BsnqXFaDwamJY3inUwpZFhbXwt3
24779	payment	2134	2134	1874	1	1	1535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1VhhPn3QRjU5u6hAEudEFYeyU1Uynnd2gE4WsFerxV7UpHSv
24784	payment	1397	1397	1678	1	1	10466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36K1BzQE3pLYtsPFQogCPq1E6XQHdFkiXf6sgL7fH255tWdZ8
24785	payment	1397	1397	1678	1	1	10467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupdZDwpWra4iBfJFtPRkbjD5d5393GSH1CjghbefBRUPtqQ5V
24786	payment	2132	2132	1874	1	1	382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfgUvaARY5KGcbxzgUKGm1nExAhn4rj7DhSBM74mwfhHBu8xm
24787	payment	2134	2134	1874	1	1	1538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnsbL24K1gCKUm7bAQuAH3mssKX3VxgyJaHd3kYfqzXoZ29Uy
24788	payment	2134	2134	1874	1	1	1539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwz26QsR9mp1hcHwwGvuSRpdu3dCTX7XaoQjKxJp9iMwoEAof
24796	payment	1397	1397	1678	1	1	10471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmGJ6fu3SdGmrx5DGEVhRtWXBdwXgnzQWV3Utj7gDfZ3H8AQX
24797	payment	1397	1397	1678	1	1	10472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9Z15X8he9ysyxFNxDtfqe7ed5W3GMvj8M2xUApvK7ffNvChV
24654	payment	2132	2132	1874	1	1	365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDasH1ZiRsP5qRWHv4e3wNnKHpc8fhtizBvYE4E97NL9Upw6S
24655	payment	2134	2134	1874	1	1	1485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHtihgixUN6dDPhVrwPwKcFVkq5PHK165tB2N898f3ADcZTgP
24666	payment	1397	1397	1678	1	1	10415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuB7wq3VcWYx4KDbrBt39wJJEXThBtAJNpiztvisZ5DjyWRMVJ
24667	payment	2134	2134	1874	1	1	1490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2EjHpyuoqaNSNagRy8tgmZXadt5DDj3YJbwrzH33Q4swTajry
24675	payment	397	397	2181	1	1	1	612000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsi1qxrdoBrLR5aNnkjQstgi6Wg8wPoQBFGaPgqz5ovfspZ51
24676	payment	1397	1397	1678	1	1	10419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7LhGEUv8FYcBVRD5faMwPTjnj3UsYKePTYJZeGZBfsh5NSkN
24677	payment	2134	2134	1874	1	1	1494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rgoB6d7VkZRrK79bnmcJrdVVDTgmHGHeQ47Wm3oDoDxUK5hN
24684	payment	1397	1397	1678	1	1	10422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4igHzRPbgP6GHLHp8jSYyUJQqFxKk8bFiQZR9FEJCRTZ8jJn9
24685	payment	1397	1397	1678	1	1	10423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSU5eXkdTxvdj1bcSxZeQpqwszmVsy9CBhtWCSCG58mXXvTwAT
24686	payment	397	397	1483	1	1	2	0	10000000	\N	E4ZRkn5kfqEwjP97kiGDR8rrXb3eTCzYgUaPzq7DzXk935zaeNAUv	CkpZCs1hZtgN8oHRRLTpowVtq8K11RE8uXcZr58ooi24CM4D9a4xr
24687	payment	2134	2134	1874	1	1	1497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1txVZkhP9nq8AipdfncAd12RcKyxs2cFGF5WxDuBag9YA7uav
24688	payment	2134	2134	1874	1	1	1498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxDoYWokTDBzxkTZE72Y7HBXt2g2bEsN2WySMMM44UTTEDwi1
24689	payment	2132	2132	1874	1	1	369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNe5StCm7gfxPTm2pSE8tZANqcxwuXJy7LjBc222qDxbq2ksd
24715	payment	1397	1397	1678	1	1	10435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7oUvrWUQM4tCr5kZcxf6oywRT1BiwgYAtksiKWooeL8LuuDgd
24716	payment	2134	2134	1874	1	1	1509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gofk9FPGwwjLv3fEzevsSxcBz6krijcCs1b9jyB6yXEiVg8u
24717	payment	1397	1397	1678	1	1	10436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzWmXmgtS47ssY3HySUxRdNyfiy6zcQnnYS4hBgWGybTApFbL
24718	payment	2134	2134	1874	1	1	1510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4Fvshu5pQhkqEuhsrFroNWNcbojaFc7q838WH8G5fKjYDSTd
24719	payment	2132	2132	1874	1	1	373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hkjLpV2wKdfnfA1PMRnZN9iajSfBenj3Wegq4j8EAfp5Ar7M
24729	payment	1397	1397	1678	1	1	10441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9NUBbWN72XUrAxVH1Janhd7AdUM9sX1Harnna3i6v4TipC5S
24730	payment	2134	2134	1874	1	1	1515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpyQj44FXCrYNx5Mw1GnRzD6kzKA2Mgea4eWcErMCvnpA4zBVq
24758	payment	1397	1397	1678	1	1	10454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExyGeGqVuVU8qpJv1Tb6nCkgcJABwcT1ZKrGGgNsQ1bECqMtb
24759	payment	2134	2134	1874	1	1	1527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFD4fAWhAvqGuMLJJpxSDxSexPadWi3ySHXtGmwhRReiueT6K
24764	payment	1397	1397	1678	1	1	10457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtkLiABcLuabUWQHhPZPU2XKbpWDfUnz7bzAXBmPwV54hxnXn
24765	payment	2134	2134	1874	1	1	1529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHkHay69eEq5yx33tHEe1pzc4YX5EVvuxtxcYH1Mh8xESK78a
24803	payment	1397	1397	1678	1	1	10474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEtULc6fcZRjfFdhtWZGYvcdqYRoNy4Gw1ESkn6RKE1BRjrNB
24804	payment	2134	2134	1874	1	1	1546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrhxbwYMxiJMFHaKQXrSBkjasGYe35WCo2VyvgvEzLpvSMun6
24814	payment	1397	1397	1678	1	1	10479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqhEKE4wiJ1EKhYnueAqAYhnPprPwbgdSTXhdVHVR1upQ6LxS
24815	payment	2134	2134	1874	1	1	1551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQ6GsziKjCq6Yu7Ze5KJUrTRGPuUhoYtmZucQPaFV8cCozWNK
24825	payment	1397	1397	1678	1	1	10484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteXk3gUEBB7xqjncH5Je8BwSnEUxd4gEV5ngqNzeUK3nP5Qkm
24826	payment	2134	2134	1874	1	1	1555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs72BZPQLP8Mx2vqzh6GoJdPBLPxVJvpZz2fnuhdy9u5nRQdUR
24827	payment	2133	2133	1874	1	1	1466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9YAF9yc3pXGgszz1GDeuo6fGT28hQTvFf3P72EF1Rv6TSFxz
24883	payment	1397	1397	1678	1	1	10500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBGJE1YtJxSMBi42PwvcuRkYnJoScczvw4QXbkxzzrRZU2KNY
24884	payment	2132	2132	1874	1	1	392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmAVUYJtNGqJbQobZNQ1AUQPw6EQAcJsNEwi3Fs2cvU4hVEeR
24885	payment	2134	2134	1874	1	1	1570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSP9XrcyZYBYTsyWAcf3g2DRLPDsj3BnoH9p5TNykFYW1bw1T
24886	payment	2133	2133	1874	1	1	1482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTZXB3ZhW2Vqf4dfCnoHUKCt3RMDvt77PBdf5o1n9nBQ4Rgvd
24918	payment	2165	2165	2165	1	1	6	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHau86174jRgmjgxsQvbWLrBxsRrTg7psz9s4JLdbKjPGuaEtS
24919	payment	2165	2165	2165	1	1	7	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4EETiYUoYo8wFfWPQa8Xa5iHPu7QArkKaHDFQb2rm2DMoXtb
24920	payment	1397	1397	1678	1	1	10512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmuAXUKi6NcCL3YZsYj1WrCTXub2vwFuyLW9FKKSSRsfLVKV6
24702	payment	2134	2134	1874	1	1	1503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKm7GscqB1iAq2FviZbNKKD24Pbrd4iXDgqF7MMrKPFit8dE2Q
24710	payment	1397	1397	1678	1	1	10433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hnSawAav61gtKDMLioyxpg1H7dBztoeqgpwznSqARfcmuJHA
24711	payment	1397	1397	1678	1	1	10434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8yuDDgox8U8NQUhoR93BRBS5gRPV9FFcZXwRVECbWSL5E3dv
24712	payment	2132	2132	1874	1	1	372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBBes8BFSTLJXtaPqYtLHPQfEKfmawkGsQjdDFHJYeJWASohh
24713	payment	2134	2134	1874	1	1	1507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvo5gXUA2ZLs9iMqtsZJVhpgAvteMKTHdodXZfMHoN7rsqXWK
24714	payment	2134	2134	1874	1	1	1508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiX1TcLdQeEyujgXrkRcrPZfpfFE7ctidxjub1zpGP3PVSX4W
24732	payment	1397	1397	1678	1	1	10443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCaCAWedGjdc1N2eLaC3KR2R7tytgKP9BWgcKBJkw4M36z74A
24733	payment	2134	2134	1874	1	1	1516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdzKkLKXXFyabxZEdrqr1W4fENRPgLJ5ZZN6dvF6uW6uMynq5
24734	payment	2132	2132	1874	1	1	375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Ae9oUQyPLCActv9GvouiQjijytpuDaJNDGDADLJNgEkijbqU
24742	payment	1397	1397	1678	1	1	10447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ59Ty5aqiUZy69CGfq2GEJodfz3asPZMLtgsbiPMP7PLabd3d
24743	payment	2134	2134	1874	1	1	1520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYab3m1tThjHRJ5hgru2FHZU41zrfPqY3QFsVNBeAmipuLQiLcZ
24748	payment	1397	1397	1678	1	1	10450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNskNVJcHzvnZGMJK6TjWaXas2oTecwoM7sGT1wZWwjh21jMg
24749	payment	1397	1397	1678	1	1	10451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXMkDAyubwRZaM3iPWpMP4TXuU3Hf2GWZrufcLNBoG6Jchx28
24750	payment	2134	2134	1874	1	1	1523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6Zs3osTckmcVeVkcxTJzD7kvB5eZj2ceABaLytG1g2Jgyapa
24751	payment	2134	2134	1874	1	1	1524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEmc6X8uVd6waZj1JVDWAEbmMk4qSXSotAYkU2gx2qSVpwZTJ
24760	payment	1397	1397	1678	1	1	10455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGcqKEW1aBKrv4MNq6Xryndkyr53WryAdVMdMHx3xEEoyryMg
24761	payment	1397	1397	1678	1	1	10456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDAy56e1DNGVxz6z33tURFFaSKj8ko4h3a8u7E2SM1Xs8rtpQ
24762	payment	2132	2132	1874	1	1	379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJz14zxe71ZpqogUtiz4ZViERthfyEVRwt63yFbzQZv2mSm1z
24763	payment	2134	2134	1874	1	1	1528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwRcdWsmjEfzdMkPkyYDiUtrBgxy7DFaPpd5yaU2pciBz3NECK
24823	payment	1397	1397	1678	1	1	10483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4nvEsDgLcZciEnvSUsyUM2HkwH1Bt3HzpoRRVBNJTjEvQjot
24824	payment	2132	2132	1874	1	1	387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4fH8EwcrrqBDGpojos6n5CC28gU9ArxCop9V8Q3wZFYWn3iA
24828	payment	2165	2165	2165	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFANrW5owKnGDz96F2yJGJNedzgFpj7cbdmFU3sbMkd4w2vSsU
24829	payment	1397	1397	1678	1	1	10485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvj83CivSqXxHUmBUHt6Lv5etWgdg1RUnZQ3bjVGcHn3VAPBA
24830	payment	1397	1397	1678	1	1	10486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVw1MwdWbpoSaHHwDxqQpdbywGiBo9aNTWgsnpyYczmGuYe7PL
24831	payment	1397	1397	1678	1	1	10487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC9X9VmZuLdU7VLQHz8LUPdd5cGchAhM9XT7pj32UtzwJT185
24832	payment	1397	1397	1678	1	1	10488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3zA9gyBgG7KEr3UyY6VbiRZsbtE1XaYjFQYgD4ej2ZQNRbaS
24833	payment	1726	1726	2182	1	1	8198	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiK8KDkRKfGNRS1W6BLZ5ut7PxGD9UvaBD3i4XgJ3PxAYYVp9Q
24834	payment	2134	2134	1874	1	1	1556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdM1FqqCFMZdfZ6NHihzUxdKYSCLzZP5dXnCRvA9C9t1MRUFCg
24835	payment	2133	2133	1874	1	1	1467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5uHptGaVwzLnEtdL19SqqP5ehtmaFt2PiS4bzridNraM78zQ
24836	payment	2133	2133	1874	1	1	1468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnoG3rcEgAuuGv2NWCN6h7RpFM3DHc9WsKTjcuLGLAr1kGpFN
24837	payment	2132	2132	1874	1	1	388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc76YphsTSZBMM5ugWnHvUzh1YCKRhs4pMYTUqVubBhT2JWeJ6
24838	payment	2134	2134	1874	1	1	1557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbiXoocnCdC3jpoZ7xycvhFvsBV9XF6CcqrL1pudyzush3msn
24839	payment	2133	2133	1874	1	1	1469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJute5aRv2x8hvBFuVww6aRVyiw3m1hCPhLkygTnpXiwD9pbB
24840	payment	2133	2133	1874	1	1	1470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLi1Ada3hcafYSu84vPSvBnSsuBQq4Ak2FRWzKepo2wMekp39
24841	payment	2134	2134	1874	1	1	1558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6oz9Jc9e8oPD7gfGvSyWZRT5jB7qjcYogix4kbEXVV6RpZy2X
24842	payment	2134	2134	1874	1	1	1559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHrwxicVPvyHdoW7Y1VqGyoTH719H993YKwhKpBwBVoruswqW
24843	payment	2165	2165	2183	1	1	1	10000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe22iZXpWd8wp9p13Wd7mj9tDrnXa89nvGPPNQBmhLuKgDUr2v
24844	payment	1397	1397	1678	1	1	10489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwJmzKZCq747LLUT5npdpmHtz7QGFHS2UMo5PQqSPJ8vXoP6A
24708	payment	2134	2134	1874	1	1	1506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiFsGTKCrw6o2Qypab8MPKEWcXE2zhP9GnrbEqsq2VgwxDUty
24709	payment	2132	2132	1874	1	1	371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYJZE8D5RF6jA55p3eMXjyRTCzgTNYXqaG6QMTbiHmPb94QeK
24722	payment	1397	1397	1678	1	1	10438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjsE3uAtgUrgLzDCBx837BbwwX4quqFSxqwSjQwnUmviroCnUL
24723	payment	1397	1397	1678	1	1	10439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2XZdFfFT4vCqzHya1e3UFN8EDvBThsscGkSewbNjPF3jRbNh
24724	payment	1397	1397	1678	1	1	10440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWKWSQaKEkX6UMcaBYJVcWoQHSv7mKzqU7VWXyFSG2ZDPxR8h
24725	payment	2132	2132	1874	1	1	374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj91db9HkhrAJTfePWUjgPtVSwBcFpWN7ZpnkrUV8CDuzWS2Kk
24726	payment	2134	2134	1874	1	1	1512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMqhTCNHZspYjC82S2KPRj4aafC5xWdY4P5qAkWvsTHuJDXax
24727	payment	2134	2134	1874	1	1	1513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgJeMfacHFYxRhLSWYs1jzKyiH1SKBmTPJvKZ95RjYh1FVTwE
24728	payment	2134	2134	1874	1	1	1514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwgjCanfSn4DEt9D3sUsCG8P87FhSJvPNfkLYJhtH2gq54XAm
24731	payment	1397	1397	1678	1	1	10442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpGpWYcukE9ocC1aLtHKP92Y9ujbufeieag8Tpw3NQKR3dAFem
24737	payment	1397	1397	1678	1	1	10445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6bjWNrtHLn9n7k7KCn6MEyiwERNsJDU5Co81AVHyXmhvZR2r
24738	payment	2134	2134	1874	1	1	1518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYgVAL91aUbVdwdLWSKTAb7KnsJT18aPW8JspxYXDnbFRnFq5
24739	payment	1397	1397	1678	1	1	10446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwewV5drZs24X5ru6vWbhuFSvHsCfAtnmDXrkh49pK65hdCKPC
24740	payment	2134	2134	1874	1	1	1519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGoExmZ6e9HGKrgXXBNADvjBC5xWDLZ8zMV2qaocFgJEAreU8T
24741	payment	2132	2132	1874	1	1	376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQVkzWGQK453SHTcNX4moC4iZTVBdR9mPziJU2h7xBTi3BNRm
24746	payment	1397	1397	1678	1	1	10449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJd2KTG89kfPAZokWrzR85h9TDhQKBLK82p9tqcFPDetikdpCc
24747	payment	2134	2134	1874	1	1	1522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcV87AnJLFuSxiQZXk3FgMP4KbgxF7YayWCcvSgyK3d33LcSCA
24754	payment	1397	1397	1678	1	1	10453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XyLowYMdAQ7AoMKmvnFypq3HSwp5WAsyptqnN9geBsbYDRes
24755	payment	2132	2132	1874	1	1	378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Z2bsVzhfmFwzQfv7j73iaebiZZzFXdds4ohoJDrpgzdrDvJc
24756	payment	2134	2134	1874	1	1	1525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ankGRbtwJcMSxHnxxmbunA5vFGE4FXXM3ysh8x86SbKpebNE
24757	payment	2134	2134	1874	1	1	1526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqWGCSJZbUWT1wBotai2zDDSVcJcdwgZUWqJn437Mi8irRnJQ
24766	payment	1397	1397	1678	1	1	10458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWCsSeesTP3r1UziRGhQXRxo8LZj3X1ruGEBhB8aWqJsxHTFp
24767	payment	1397	1397	1678	1	1	10459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqJmD4dTdUFx9GqBgREQVTx2ZoBy6wYKKis4z8ofrd39uTAiH
24768	payment	1397	1397	1678	1	1	10460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJRgx4jDrjjSGt4V21nhj57Hp1xVf8qTh652T2xmXaGLiabCL
24769	payment	1397	1397	1678	1	1	10461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbtNWEVzwyJeWgco5vY1utZRU2C5iaWhkCJYLhx3BKVgQn5Pp
24770	payment	1397	1397	1678	1	1	10462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFRfCwqiUiEDh3zNq4EavwZddwfhoV2zJDHrR1ELrWhoK7YTw
24771	payment	2134	2134	1874	1	1	1530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdJZEh22RWByBk1RJ6Lqu4jMFeSch4v3EGLUCKLakPMW2xRFb
24772	payment	2134	2134	1874	1	1	1531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKw7u73RsB37bLrLinUzVcsxNHBPdiiHDP4PHuY7fXxGBCThQ
24773	payment	2132	2132	1874	1	1	380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzp7bzrUMBSaFDbM23WC9pVuF3s6p7jB73YZEwZmFMrroC32s
24774	payment	2134	2134	1874	1	1	1532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYuvV3Fp1dAZvyvMSJtbK9xwRq1iYrJDQWjVyr5S18QDggqBB
24775	payment	2134	2134	1874	1	1	1533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTknow5kt7btqybWG1dA8ERLMchTBb6K2TPmsfUXSnXrPCAxz
24776	payment	2134	2134	1874	1	1	1534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KGkdjNYd5EC5wEhwAE42DTCrGuQKtN2MDLweTUrXaRkYaFRW
24780	payment	1397	1397	1678	1	1	10464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2aAZ8ph2XrTQ2qBbb2edssUvKZ2ttBUhxftze4yoyXSxFbh1
24781	payment	1397	1397	1678	1	1	10465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6cQGz2io4TWkKw8hCcR29WXeNiLgBvZUi9RzrrCzTf3MjQjQ
24782	payment	2134	2134	1874	1	1	1536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHsdq7VnQ5NUmTpRxo1TPbsHrJNxsK2Y7n8wpuHQeZ92gEsnCW
24783	payment	2134	2134	1874	1	1	1537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwrKu3B1zKhemNWAvAjke8Pz7k2Fsb2Zg9xe3DetVj9pZVcmw
24789	payment	1397	1397	1678	1	1	10468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiV9REGue8vhGLcAfY8PJkE1qTZFiWuPTXX9G6sbrhPVobaQ7B
24790	payment	1397	1397	1678	1	1	10469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cfjC2bf3QEEajkMtNpdtfFUgHEc6KaRg3kQUTmRd5gZ1Eit2
24791	payment	1397	1397	1678	1	1	10470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGWiUzg7UsHcJYqv3rKvhZdVTk6HYAMAJpwGwhAJWZ662J7sp
24792	payment	2132	2132	1874	1	1	383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYJqPfY7t763d52x6i6DXukA1FM5XFoXQ325YuGChaoXyxQaD
24793	payment	2134	2134	1874	1	1	1540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXa1xu7Q8qncC8fcWueRAmsdnLFWhgqv5GgC4aXkU5yAZ8ntbJ
24794	payment	2134	2134	1874	1	1	1541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphV4WsSPtk53EGVd7WtsaTWeC3Ab2JUsEVFdcSdcVPUA4Hr9V
24795	payment	2134	2134	1874	1	1	1542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwedyuAu3YWFskJyGHTG5jTcAk3dT61HBzcyQX4Coeca6TgjS
24800	payment	1397	1397	1678	1	1	10473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBapyhJ1TeSQrxL7LNm1HkrhtfFKX8HcBhH5DN5aexFc7hTo1
24801	payment	2134	2134	1874	1	1	1545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6jYRsUoXa8tLMy138ujK2FdGEYA1uz6Q3j2oXu6rJphcrxw6
24802	payment	2132	2132	1874	1	1	384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB7hQ9Srwi3MriyeKd48LFFZvnv47xafGuGNx91oamEkSEwa9t
24812	payment	1397	1397	1678	1	1	10478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUbpNQcq9FE42XTGxR2LXbrXUnxF3XHcush6gZgDutmM5GNRH
24813	payment	2134	2134	1874	1	1	1550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCFQ8qeZYnV4CzrVfxE5ehMmrUEkfk2tahLyn8pBnv276CG49
24816	payment	1397	1397	1678	1	1	10480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofbTh2hfbfwbcVfUhTt1NsniTKkQ7aJVL4n1XHfAdSTfaw5Nz
24817	payment	1397	1397	1678	1	1	10481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5agW2iDcnqoNH4Pa375NujNf1Q2mNiCEQ6Q1FqLJsy5XxtvB
24818	payment	2134	2134	1874	1	1	1552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nkRuhuTLApCTgrvW9bn9WhKK6rEDrJQfkBrKRuLa9MuVGjei
24819	payment	2134	2134	1874	1	1	1553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEg9WuU1r53FN4UfKpMU8ehnKfZS9WSnKqi2FdqzTMLJk2EYkV
24820	payment	2132	2132	1874	1	1	386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9e3qKEVYuJZWMMe6Mga7oAdZHbKi8h8nc7Qc2RbXXZR3utQxX
24821	payment	1397	1397	1678	1	1	10482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5TFbuMaQbM5n6niF6qCta7m5u1TvZo6eFh3NaPwaeapEbREt
24822	payment	2134	2134	1874	1	1	1554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcu5BpBqUuLkMSKs5EM7ohnsxpZLBQButjwE1aBUHpoAU781NA
24857	payment	1397	1397	1678	1	1	10493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJ2uiEE35mpUA7QZiAdqr8gk5pYEsPQSZhDxTdGrQsS1Mhuux
24858	payment	1397	1397	1678	1	1	10494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5emDyXWbQ4FdVVvhvWeg7g4vQb7cooV3WdSTHsDntLqPx5Tg
24859	payment	2134	2134	1874	1	1	1564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFD4XXQy3pzTM1cx5UaztvcSPTuDNxwVZfYWX8BoR4ifG5oAa
24860	payment	2134	2134	1874	1	1	1565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1T2Dba6AhisGjDArXMG8248GmziXkuFcEC5CppK7JPMrbchdb
24861	payment	2133	2133	1874	1	1	1475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MHMbyjbT6FzL4fyNLo2pQSQHmzANWVPQQn6YdtgsuXtGZpAD
24862	payment	2133	2133	1874	1	1	1476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYci89TAqNmQ1VjHimUHYoBhgmin1oc9MWdVtyBGBftgZs2g7p
24863	payment	2132	2132	1874	1	1	390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ECmutiVyTtqfBX9oHwTHsbvRPRhJ8cpjXdaeH3YF8FL6kFyV
24874	payment	1397	1397	1678	1	1	10498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMu2PXfJAfzPpCJW9XfZo6ZTnQ7vYQgThTQQF1R9zsth2FcjmQ
24875	payment	2165	2165	2183	1	1	2	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9Za7KT3mS9LVrJrcoVwYm8L4BgvyZjeh74jooFvpTY2TdB53
24876	payment	2165	2165	2183	1	1	3	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9djfRjSitjQ1ik7QiN71M8hyUQwurtHq1pysH1kUk1PoVWbG
24877	payment	2165	2165	2183	1	1	4	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdLp8ArCjZPn1YXE67qwyStbabao6WaVVyCqjMoXwhCC28QTB
24878	payment	2165	2165	2183	1	1	5	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHLCYHgjMoJdb3Ma7XmrT4ARCBQv6WpvSb9QBVC5uQ6kaCiin
24879	payment	2133	2133	1874	1	1	1480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4HrqxyAxpmbJvrevn9rsZFAZd7StvuXta6neZ4dg5rvzHsxA
24887	payment	1397	1397	1678	1	1	10501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpjB8NiN1tSz8vqzNTDgcc6md18FwGTKCWZvybBN8hgMoqN9Zr
24888	payment	2133	2133	1874	1	1	1483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3B5V2Q2M35Aq2PkQGzD2weN1UeeDhJyVgT6ZTZxQLvryjjQm5
24889	payment	2134	2134	1874	1	1	1571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFd5yJzpW55noSZGpoHoCnjJRfpj1AomQUK74TKMXaxU7r3A7M
24909	payment	1397	1397	1678	1	1	10508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSeJ1zyrKk1NemqBwhhQfs7znuNTLMXkxiskmmKUnTgU6v6W6x
24910	payment	1397	1397	1678	1	1	10509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9Jv6eKew3ZnYkU4xqZXY7GGpBmUu1NiJJa8GXjhPkvRXE2xN
24911	payment	2134	2134	1874	1	1	1578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkAZrGWCfJ3qjM4x9DKf3j88cC8PYwmDFDjuahzhorZhsGQxE
24912	payment	2134	2134	1874	1	1	1579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsV1EDYWTjfwe4pMsmNFLp3kHF8QSMLmTKpGr8gQYjrfHiQh8A
24943	payment	1397	1397	1678	1	1	10522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsNtY4hhRNRTHowqAr5gwjuWSJTEXDB4TE3QJ2wWw5DUzpXo8
24798	payment	2134	2134	1874	1	1	1543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUbMCZSADGyxzigw7JWch8hbZ2ouEfyQNzJH7LtY7ktnfhtDt
24799	payment	2134	2134	1874	1	1	1544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyr45jPFLdmyUWM2XsKiiw17vdhfndUym4W5JJQpLTpqnc2cCt
24805	payment	1397	1397	1678	1	1	10475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgZdywB5BpXM5sBp9fkYH9mPcNbTd2Hk8GcDfrNx9DxkFY7Ly
24806	payment	1397	1397	1678	1	1	10476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CDVQ2XKSSxgVyQHeS4SUyCzGeeP7kuHJfwN3oRXRGvcU1mLw
24807	payment	1397	1397	1678	1	1	10477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLaQfgXoBHFcPeoLZeupR8BqXa7ejNyzsVEUb23j8zh3eZnZq4
24808	payment	2134	2134	1874	1	1	1547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6Mak2tRiHH2GAwCxBhZkFxBrmjXDsUUTJU6nPLy7a6RbXCHV
24809	payment	2132	2132	1874	1	1	385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa887kMYFdMsuXzb176jNdDMCtVeArfKmJ38MsE7TzgjRVUiqt8
24810	payment	2134	2134	1874	1	1	1548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZyEgqcqREGP4m8tGYamJnq9PfWaCoaN5UfYxtsrgVPF8s31C
24811	payment	2134	2134	1874	1	1	1549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkeZR7Pg7kwRrw1jbSCxrKMiBAVV47LB3qqX6n7Axct678eUA
24870	payment	1397	1397	1678	1	1	10497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCRJDyaV9yeQJt2ECHuUXiwcsR9A41Pw7YnVX4u5m2bFq3MBX6
24871	payment	2133	2133	1874	1	1	1479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkJTCdJL7YZTz51wB3wgTM1CZG95o35zdTihei5nRQbw9QSJR
24872	payment	2134	2134	1874	1	1	1568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbS2GVFJ7KMbfy3AePVGUH2sr8aVyd5pTFWg1n3UWPLd3CUGw6
24873	payment	2132	2132	1874	1	1	391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAA3aDP7figS5idZrANJif4qftZGNeDnbdMtc2ZMk2jEwUbWvj
24900	payment	1397	1397	1678	1	1	10505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGL5dFrAWKyFZwANasm3Jn2bpP4xy3usPe25XDvfJSppHYg4o
24901	payment	2134	2134	1874	1	1	1575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXkbYaHJc4rU7KiTqEiq2uf8Nz3BW73EhUzwzQpJgYhghWrVQ
24902	payment	2133	2133	1874	1	1	1487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwX5XnjCn95qfZtcXmFkoDL79TdZsCfZwDKjxj9YwjSC5tU5uw
24929	payment	1397	1397	1678	1	1	10516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHxL53pYhqjzDGidVrYQq8sNQrBzqNsvQit3aLp4cbBTUX2W4
24930	payment	2134	2134	1874	1	1	1586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbk86U48ZB9CW9T14RFMsDAx11RBi7cwMBnGLNBJu1uHQvpNyh
24931	payment	1397	1397	1678	1	1	10517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNqtie5b6pa7ebP39oG6CzWjHfmzSuDbQDZ4UCbzHnWq8UyBW
24932	payment	2132	2132	1874	1	1	397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpnJHVBfzFYS2H23tx29CmjdFs4AhCVkfsokqpMvdry1r4fud
24933	payment	2134	2134	1874	1	1	1587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMZEVrmycF92Gjh54TJgUwWG1R1n2NeGtrktEGGN2dfrAKZyB
24966	payment	1397	1397	1678	1	1	10530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBZDsgh7tG2BUo7Pqt3yyKEqtTT6geQrJTdaNzoMEDQfE4hRiW
24967	payment	2134	2134	1874	1	1	1599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvAx4GZReWSpgPUYoDaAwmHSMzRhC4LLdhkmkqNcsLwZiKUwk
24968	payment	2157	2157	2157	1	1	3	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xwQWLzir19qZujv71idiXsFAwuSrvTWX9kHXgfNAWWMXtnUC
24969	payment	2157	2157	2157	1	1	4	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYinFuW7PjZg2c3mJoSjrXk2XP8bCJwo7Jov5Hy1PYGrPpVrAPE
24970	payment	2157	2157	2157	1	1	5	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPxupDpnTNMSi1ZQDKQXNGAgphHv435ujPVxPVBWWXMdYnEu1
24971	payment	1397	1397	1678	1	1	10531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiUvH5spxcoGJDP4tkM3HbqKdzn44z5kKaZn4UkVET8E6Lvbs
24972	payment	2134	2134	1874	1	1	1600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfQru2FMw47RBbNBexvKC3XYu3ZNs6ZV7STcvcbzyhCk8fo6b
24978	payment	1397	1397	1678	1	1	10534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FzfneggBbrEiziVHvxSN2ykYggTxEXMzxQiTiTcBQt7EPoAT
24979	payment	2134	2134	1874	1	1	1603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9fwizq3uZiy6EnVKWmMmbnsoRdYKewM7qt41WJPbSi6mTS6B
24980	payment	2157	2157	1929	1	1	6	2000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn7ep3AQFHG669a1MBCvnkhVa1vdFBKorXLfs1PZbVnzWoVhaM
24992	payment	1397	1397	1678	1	1	10539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9Fihgab5yYCTuj4puAq2bte3PWvntkFUC11U89mC8JdwcpLY
24993	payment	2132	2132	1874	1	1	404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeHtS7TQs7adrwijTnzjo6MKovKtU6L1WLKRGXWc5KV81rPnn
24998	payment	1397	1397	1678	1	1	10542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwjxRR4au7XbY5Kn5t3b5xGi6eK5CokfzLuedwfDmKUiT2zRT
24999	payment	1397	1397	1678	1	1	10543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3dWReuSUn8agm9sFoVtmnESu82352e83Lt543L2Lzkns5Dmo
25000	payment	2132	2132	1874	1	1	405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPwwJtcBSKa5QCPV4LGBjsu958f5pdwMEpKMwszPgpPqdLo3c
25001	payment	2134	2134	1874	1	1	1610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21Q2dCBbMZ5koFEvi7Pz7rcMFCZHVG7bvodgp7xpVbiZy21Kr
25002	payment	2134	2134	1874	1	1	1611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6Hc6AnjjTkxKfjqkLRwN3bhqgd2vPxrTjYTALCF2JUzhnkbi
24845	payment	1397	1397	1678	1	1	10490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxvfygMgpuNqByYi6FZy8cJ5XaJBVYjNn4ZSjDsf4aDmr9gEiq
24846	payment	1397	1397	1678	1	1	10491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkBjTRdvLxVtsVfSqjByXJ4QzgcN2giLcd3C9YFDQWr5wvjxv
24847	payment	1397	1397	1678	1	1	10492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiu6SHPZHTZ7JtygCsfNmhhPfH2XmnytToW31T6B1QVKomTF6
24848	payment	2132	2132	1874	1	1	389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMj5gx56A4cUKGvoQuYpGQuyppdXi59DPtEKFb6zfbLLpiLH1
24849	payment	2134	2134	1874	1	1	1560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFRVeeJcjUYUs3keqnWLLeh5rgLWusLp3sbDUBaKKh4pmLQWf
24850	payment	2134	2134	1874	1	1	1561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFLfdyTErrCAW3BgeZoKG9bvpF9tHJtGLq3uCshNHBaapQfzm
24851	payment	2134	2134	1874	1	1	1562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXmqbo2cUu8SbViDN3zHne4Yf9V5QXPB2MB3Txhsz9duJD5xu
24852	payment	2134	2134	1874	1	1	1563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpussFHRtWiwmWY3Gmw5uGaxtNJo4vxyr7sAJbaacLq1agpUd
24853	payment	2133	2133	1874	1	1	1471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXjxxkMVz9Bci6w1QBWxPv1YnEkG6abG2MfVExq2b6C2JC7at
24854	payment	2133	2133	1874	1	1	1472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ci24o92VSBLMJDUXqXwWY8dfgS42a8bbrVTycZW8UknuDZqo
24855	payment	2133	2133	1874	1	1	1473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77bQ2HwazgJN7KNFrVudrPD4HtYBtcHrmHwtq8kocvJccNEY3
24856	payment	2133	2133	1874	1	1	1474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWbo9NMcXhUkPrdG2M3z9pBEhME6jan3fxf6aAHWPiyaAie3V
24864	payment	1397	1397	1678	1	1	10495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HYHPUtoLiGRW33V4dEjMNT8w7tyeFY1oDdV5GQqKKeAGRFCx
24865	payment	1397	1397	1678	1	1	10496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9wDjz1j7sYeE8QTB6MuniYG7xFTNfCMGJ3ihgrdthtvG7uF3
24866	payment	2133	2133	1874	1	1	1477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYurH8Y5LbMhXNYjMbgDwTGUxU3Zkfn4nD1aQxKDFfGikXFwc
24867	payment	2133	2133	1874	1	1	1478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwN313f5afajrYZb4bcqdyBsqHsMVq2JVXYHY2d4UbHm2rCcF4
24868	payment	2134	2134	1874	1	1	1566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VGv7j9kcCqJ6WPgB8GXA9Vgywx6RGc8kbAAfS4G2JqeK2hbN
24869	payment	2134	2134	1874	1	1	1567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZNPkqaBgcPt6mKaYDbEtUv6urp7hKkjsv4yVya4KgNua2AK1
24880	payment	1397	1397	1678	1	1	10499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm19nRhyygAFD6tLDvmimDVtKJEFgrdQN4pHk5MwXHDvx7SM4Z
24881	payment	2134	2134	1874	1	1	1569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EztGW5ercaBvLpysBttHNN3Ufn9vZbC7R5Yh1ZCXBqEqGyoc
24882	payment	2133	2133	1874	1	1	1481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVUb1wjvFsvAYj3eTG7VnRdLcQNHcay3rHMkidLAuqAQQZxzr
24890	payment	1397	1397	1678	1	1	10502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4cw3iQNhNdGRvP6Er7UbudFXT3sUVuuraEfH5BQUdrUp8fwU
24891	payment	1397	1397	1678	1	1	10503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEvH4Rgzz3NzBhrfi1RSxVxswfNM9KXbotNqQY8XA9DWUQ98M
24892	payment	1397	1397	1678	1	1	10504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8dQRitP8HvMnW18zkw843UTF2TPeoPYbd86q9PHv8C4Mk8hJ
24893	payment	2132	2132	1874	1	1	393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVU97qTdTEvCQBqVMyK4tyLo3RzWoa7mNKJiu3SXDCJ1CjbZk
24894	payment	2134	2134	1874	1	1	1572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp5pW7yUGfAS46cNHwzbaAbeWdk8o4S4Vp7aKxcygfEx7YoDbg
24895	payment	2133	2133	1874	1	1	1484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnJJWEifKGk4W7UTyuFRd2Yag2Ngti7MPUS7fEBXAb7ndZiwZ
24896	payment	2133	2133	1874	1	1	1485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYURLommnvcGQrJAHkY2VXVSQHLKSrWiGD4tHZ3G8t52xYkYQK
24897	payment	2133	2133	1874	1	1	1486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ29fXmywp51zCRbKiye8VsviMF3b2KXJjx9gVaRHGm3ZWBW6By
24898	payment	2134	2134	1874	1	1	1573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1mSs2GfGPi4xLJ3Za14K41i7BE9BNnYCudKJm3LhCt4fLd3X
24899	payment	2134	2134	1874	1	1	1574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tDzDqMyjZfqpmWt3Va6agbu7wVu6kPtNPaTmdreK2Xtpb63F
24903	payment	1397	1397	1678	1	1	10506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGY8qDMd7VjUM4TiTRmhTTop58TsXwCzexxzih3ejj6rHwCNLM
24904	payment	1397	1397	1678	1	1	10507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRs2jrzEuLgAjxVhYx6xZX7636ycDKcEeyajCs6gjtG5ZU6ewY
24905	payment	2133	2133	1874	1	1	1488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTe1pzvGekM7WSntWmPyapAZV9cEzui9yrbfeYBLuhZjuc9T21
24906	payment	2132	2132	1874	1	1	394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjJQyGpE63sdxCqKeY3QPVBJHcofJWhwhNv1BUsC8NxN9o9x3
24907	payment	2134	2134	1874	1	1	1576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgiTiFAHetqo6oWvFRjRrzeyy3a7QWKQVYR5PS4UBjEqxhzmo
24908	payment	2134	2134	1874	1	1	1577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjfhk2NSayGgP1HTGETpnPsT2vfuQUTYoyJXF8HGDjaqfdXjU
24913	payment	1397	1397	1678	1	1	10510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6HZAYPcRApJoJoiHSY2AnaAijH6uFuVSsJmByRCpgwt4QXpt
24914	payment	1397	1397	1678	1	1	10511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUSL5N8qne8yWgKs7JUmdMwioZx8ih8SNdvu1ugvs3VWjvfPT
24915	payment	2132	2132	1874	1	1	395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRxNVJGMcGNPTXiswZkAtqttWnF2dWmihtrWrsibi5kFuzXdv
24916	payment	2134	2134	1874	1	1	1580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcVwcbazETVhPGznwn5FRpRjTqYdQj1dDq4NBVCPdUAZVRBbw
24917	payment	2134	2134	1874	1	1	1581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4tZQHPDMu7BYNCQXqixQ2DSxxLGcQdemhvAeaQkd6uLCyJHE
24939	payment	1397	1397	1678	1	1	10520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSar9R1anQQnyAJXDpF3gbKYBz2XFQv5VQYsusBUsbYz1XFJ9m
24940	payment	2134	2134	1874	1	1	1590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPasEtEtF1jcSqNb5LYJoXbPzsMUszsEhJDCHut65RULydEnJv
24941	payment	1397	1397	1678	1	1	10521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCwcnBx5sd3oNxz24zETAoyYGxcXDWfgTjxVX2RrYorZPkgap
24942	payment	2134	2134	1874	1	1	1591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uvg7VUsDZcSWHbFB7a3GjJKLA5UqRPUAfdGbgMS8mkZcR7nR
24951	payment	2134	2134	1874	1	1	1594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2wNn6Zonkuw9DGmrgZ3sUZw9jzojEHCqxCasbewuEJwfmgsL
24954	payment	1397	1397	1678	1	1	10526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsLFswdVFc9DPJ8VDX1y9x3BfR7F2XbpWRag7p2WnM5cVAKjH
24955	payment	1397	1397	1678	1	1	10527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQrLhmtGKfbwAfFXfT6cRQvATwPZsn5dXqqT6YinpK57L6oBC
24956	payment	1397	1397	1678	1	1	10528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHVs3dGb52vG1NhnrnkXMykhzuDfBEKW6h7tV4fJbRVNTN1AP
24957	payment	2132	2132	1874	1	1	400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhGFxTd9Ys9W8xUe13H71D3zTS9dN8dQZHx5f7UyxRT5vVYM8
24958	payment	2134	2134	1874	1	1	1595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNc83qb8Q1Rg14ysMyvRTZJ2SJPF3txMLhuhJLmL22PeWHMEg
24959	payment	2134	2134	1874	1	1	1596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXbjVShZMoJyGX3hBTfjF3m6VvJ78f4zEs6QSGid7jLh4TFcm
24960	payment	2134	2134	1874	1	1	1597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJmbTEJpBYHsCdoHE4HLP2gZ6NuVhvBuuEAC3WHyUKMcsDfV7
24961	payment	2157	2157	2157	1	1	1	50000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcz5BUvrMg2ra8j87PDAKsz2kkgzAWofmJsssAmXXvh5qaYQZ
24973	payment	1397	1397	1678	1	1	10532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwernRUQ6hPSxzNituWmEj6T9rX2Wnz2URou9yhYgTt7MbXvyc
24974	payment	1397	1397	1678	1	1	10533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpddmX5a7PH8GyYGNdo3BcZbTWVcSQzWmVXSnyQB6ENuTrHZu
24975	payment	2132	2132	1874	1	1	402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsoJ4jYZ89y6FKZ1Hx2NGGnvxatVMHfAXJCJ6DuRE8Q12HGDJ
24976	payment	2134	2134	1874	1	1	1601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZozB8tf6tRHJ9JbPXqfDjP3SwbMWRBTX2tSUnrSoFm4oXgLLKT
24977	payment	2134	2134	1874	1	1	1602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNixcneE1XiSxE6PMVxBGQJpoY4YqoMmZCejRFPfUT2Dd6FUth
24985	payment	1397	1397	1678	1	1	10536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9nw5qYi9utB4KVL94wQb7NFvWU13DWzWkoXf8rCT1zrCQFpz
24986	payment	2134	2134	1874	1	1	1605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFN1CsVcfLcGPpyhoxBMhqpZcUHRmyu9CfR55p4TpSykcscg6J
24987	payment	2132	2132	1874	1	1	403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKLuK7C5K6u3KBsuuAcXCegZ5tfPBgcC4HgwvN1YDqJLB4N4v
24996	payment	1397	1397	1678	1	1	10541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSEALP6EKaqeUrKoKpxDM1uFvSBT8bLiraWbh1ukwJicAaJ3A
24997	payment	2134	2134	1874	1	1	1609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuqzJSoAX5eC3wM62QUiX5VZq8p8grMMDGFrFiCYJuPoXZ84R
25014	payment	1397	1397	1678	1	1	10549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztGUkGTrEQmpaxnoV9rYajgeTjorH45zWyY4pNjExhCb8UAqQ
25015	payment	2132	2132	1874	1	1	407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNSjPuarSa9tmbKA4VEpPZeCtjJTfjFe5besUPtYinzbZeyb6
25016	payment	2134	2134	1874	1	1	1617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh3RbqCcihS48JZ4R3e4gzwXagrSbq8SHd98kNYQbv83zyDNxC
25021	payment	1397	1397	1678	1	1	10552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZystX3JhHR94NUutw3bn3H6HroLyEnp3wJnbt2D3miMCwPW9tm
25022	payment	2134	2134	1874	1	1	1620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEkGBdrjdQWQM2atTWnX8ykwNa3Yp3xe8ifcrnA1TGqEAUbHV
25023	payment	2132	2132	1874	1	1	408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNW2U19Z4WsRCrKvuQjBCiSGV49BhWpDZXAp6LkGK6zZ7vkhF
25040	payment	1397	1397	1678	1	1	10560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYapQw1YfyW4kS4aGyrAPNdJfZNFgUSGh8j3aLpFPthzjoJ4Fx
25041	payment	2134	2134	1874	1	1	1628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4thGBtyN3QMLuLqai8YGa9qCcrYKsDaFyF3YPxzwYZ5tZj3jP
25042	payment	1397	1397	1678	1	1	10561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNWiKjESwmkFSkbwnJ691Xj6sUEMs9F8fPif9BaaTf3Xj4hqZ
25055	payment	1397	1397	1678	1	1	10567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6cySgfvjiMkRUPp4edXMG2aykcX8RNNZSkzii2UhN9UCwteQ
25056	payment	1397	1397	1678	1	1	10568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEvJJZunqL7M9U8VxD94nDmeuCXSTpW4XxHbT4ojdiYth5DRY
24921	payment	1397	1397	1678	1	1	10513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVB1yPREzZr8xyrXTo4oTbvKwYJLEKU5ydYExcXSGUh3364Drt
24922	payment	1397	1397	1678	1	1	10514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SFY8nMqrJnoCSZuzwJDzQQVLFnw1syV1EvmShrTXuhdCvd8f
24923	payment	1397	1397	1678	1	1	10515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacNNpSfj6VzdqAWUaKY8Y3HuGysnTFfK36XBcqbCdEma2T4vp
24924	payment	2132	2132	1874	1	1	396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqnND7rieie6XqmgTXZBM2gLZRH2mNtkBzp4QhBFN3rXvvptE
24925	payment	2134	2134	1874	1	1	1582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkt9fFWj5C8VJiT7vPneZEeY3dCkLFW69dbRbqkGnRJG7j9Rwp
24926	payment	2134	2134	1874	1	1	1583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoBYhfQ4vmCSjzhmCNDmeUzbT8wgpWMahELbpHytZAs8gr8dK
24927	payment	2134	2134	1874	1	1	1584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPmVEXXF4vMUj27KXnocajFKTLebzr7jUYYzHYegWgVLyETAA
24928	payment	2134	2134	1874	1	1	1585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UPnYpMtgnX1faA9HFNr5C5gMzxKjvsqNxN6XDPcqY13QVUuY
24934	payment	1397	1397	1678	1	1	10518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgo4b5Z1oGTzfHGtv95z3J27FFcz4wa2xZg4nCmiiXtxHRF8X
24935	payment	1397	1397	1678	1	1	10519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vy7bWHK9pH6yXBuUxn3SKBdhfDUKmUkWyBZU4Qp1Ltk1tNZs
24936	payment	2134	2134	1874	1	1	1588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJjiDRXBGBUoYr9YrPZpa8kYWNsVCaDm3XUyNtYuoZze43bLZ
24937	payment	2132	2132	1874	1	1	398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQDhJf8PA5f3rGH4c8TTv2c98KUPJNtZdeBZg3rkPM8x1Y8A1
24938	payment	2134	2134	1874	1	1	1589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSBrdAmFZjY6WQPL8ped2h7tjex2z6JnJEJzdaRNb3bcbV3G3
24952	payment	1397	1397	1678	1	1	10524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3ZQK5Lt4bnVnfNb64U9CC4kSefGSCtVXavNJoSJMddJpZBzY
24953	payment	1397	1397	1678	1	1	10525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXb5RgmdyiQK3R2wFP2MWTvajRY2QUPoxZaFg6shLCpdKE1oi
24962	payment	1397	1397	1678	1	1	10529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLDDtU4xRrA1aHvzfq21KaEiGncgeUxRteLMXH9TL8gDhBA42
24963	payment	2132	2132	1874	1	1	401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9wppFt5M2siDCFNz37WiaVVro6bN6F2CRjz6brCpkE9nCwKV
24964	payment	2157	2157	2157	1	1	2	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPTRLWkVHQfgjAWrKhTSJQHbFgJiR3HXf6e8nDxifohW455L7
24965	payment	2134	2134	1874	1	1	1598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XAR1WLAhGXsvSFz959grWiMvHW3dAa2LFkwrA7ejmALQVMeR
24988	payment	1397	1397	1678	1	1	10537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJYrSa4yRZn1zjZsTsz4xuWW8px48cq3CBR9SmDmB2QmMZePS
24989	payment	2134	2134	1874	1	1	1606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ698mCaeCVQZsPWWyBDeCLUQtJqWCzJeK3mS6ugXZQbmbBJw2n
24994	payment	2134	2134	1874	1	1	1608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJS6CE2jcr5cKdZiFZ7WnbPpJ6si6D7tVxa38MgMjizCKqAVMi
25003	payment	1397	1397	1678	1	1	10544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1xsdqTJHfYhSW13DYgJhgUirqQSz6aGY2yrYCdYXdL6Asayf
25004	payment	2134	2134	1874	1	1	1612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagw9RbzYNNfc4b4TY9CM7CtDfsmNojPaQYHG4DX7hcgsyxC1L
25005	payment	1397	1397	1678	1	1	10545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSduWRm3g1A1ouwwyMykDd19XzLzNbbQvCGhJFyuJDo3ju6Pqt
25006	payment	2134	2134	1874	1	1	1613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdbHyUiVmNcaveSSsFoQLh7s5gZjXybDsvDAhdGcg5y6FYFTh
25007	payment	1397	1397	1678	1	1	10546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcYF4xMFrQu8q4NT7azN8oK4M6Z1uTMRPnt8eZe25KfvHtzJk
25008	payment	1397	1397	1678	1	1	10547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaqrYdR8PWBED5sv8dqNmdXBsoiVAA4jXU3maRjeE2wNNFNHs
25009	payment	1397	1397	1678	1	1	10548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2K62FPTthZdXSdMhxGfSDBPKjmmH1KVWFKAC3fbf2PbvHZBp
25010	payment	2132	2132	1874	1	1	406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHwZf2nTFmSoSajrgtSxbnSYG6avykrKSCWPyinY5tQsD8ikf
25011	payment	2134	2134	1874	1	1	1614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEmAjK7xAxWYyKgnhn9MGgjbo1YADPYthRZfBq6LmdcBsD3ao
25012	payment	2134	2134	1874	1	1	1615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCzXpmwGGGkb2e4PGQ74Ey2hP28ZAuvPZQvirTNSm1t6wFore
25013	payment	2134	2134	1874	1	1	1616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzEzapWKdrcshYdc56UykH7iy9KH4uc6egg3sFLmJpzAQ298M
25030	payment	1397	1397	1678	1	1	10556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78mzGkCdnh7iJ1y4pD9Bao3gnAXED8B1JHxPg6VckrxTvvq5d
25031	payment	1397	1397	1678	1	1	10557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEcqwzZyfy261AJLfBhtSHKCPW2t1Er69XKs3BVjvj2B5iH77
25032	payment	2132	2132	1874	1	1	409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcqNDUDcVqYYgC985TARnVGyuqUoybfLPTYhAiyEj8TKZJo2h
25033	payment	2134	2134	1874	1	1	1624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAaEjZ7fuTd8e9UA2XSrNCwuzDonNUYxcaRxR4opS4acJTnfm
25034	payment	2134	2134	1874	1	1	1625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnL7foX5RRpCPof2vvFvmJMicvB69ZKxTX27xBy28E25K5fHtu
24944	payment	2134	2134	1874	1	1	1592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6s1YaR3RVUrtcK5UVAauthfjoNmrprVPayLT8g8ycf7G8rpP
24945	payment	1397	1397	1678	1	1	10523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ZQ8eS6Hh8p6Q1275x25mG9iLLvRrybJ7cDjWK46TRKT29Bpr
24946	delegation	1740	1740	1899	1	1	11	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXz7jV4mTZFHQCs8w7tngybEx89Lomb5ueTAWc2WRhEkSVeU8X
24947	delegation	1899	1899	1899	1	1	1	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyqr8492rszAKy3UxUFkAYSsVufYP7JUdkdomaRc6yk2GUeuB
24948	delegation	563	563	1899	1	1	10	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYCsbo5nfx5e6B5sFDYcAtefguFAF9hq1heWVtErDVPWFNobo
24949	payment	2134	2134	1874	1	1	1593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtg1zTKVJn7QtSoRCk35Gd6c6KrTcEahWzBNdc9G3TKgXh2DBU
24950	payment	2132	2132	1874	1	1	399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoRkEHVr2K4eAf1Wpt9zUAS75n5inBnmaaeAusgqDQSbzQGZF
24981	payment	1397	1397	1678	1	1	10535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vH2HzVBPntAmFfVP77sE7RRxDbQRY6U5sxMXjeYFzWiZVAef
24982	payment	2157	2157	1929	1	1	7	40000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrU8RNebyWGRc59ZQYYUz51CdhFHhRydRbSo4egS3NhGrtXjN
24983	payment	2157	2157	1929	1	1	8	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RQVz8PxUzZ1gXEa8RwLmEei61FM1q4DKxvmWQEpUByUG6n7G
24984	payment	2134	2134	1874	1	1	1604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1Pzp1ZCuQdGApqWQ8wNetHUQW1kcm5XX9JaiR38CUJBrju6H
24990	payment	1397	1397	1678	1	1	10538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfNz4LWArmuzyoJqcUEqTPmkAmpiYAxzuCz1yvQBVLKfwQ6X5
24991	payment	2134	2134	1874	1	1	1607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1wfxXVdcDgkC2hKS7Yd7LYQHk6K2bj5yZuFu6dTpED9t58s8
24995	payment	1397	1397	1678	1	1	10540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnrfrVm6tgQCZd1SQ9HP1qRR1capJTNk8iMCo3EfT3J57KcFQ
25019	payment	1397	1397	1678	1	1	10551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr9PFjfTdvLZc2igovKwYb1gdMnfg265rNAECHDXMcqDXuNSb
25020	payment	2134	2134	1874	1	1	1619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5bLQsWxDqgkSygoLnEYYMi9Xrw5KEtFfvDsGujEVbJz2Tn1y
25026	payment	1397	1397	1678	1	1	10554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UBCihv9KYvNrsJDzDdoSFS8MbaeGZWCEk9DpMMtNuKWpNo2o
25027	payment	2134	2134	1874	1	1	1622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWryyFJSBaZiYbHqwihEt3acsgZR9v6cyYdWhHfAYNAy8ufMb
25035	payment	1397	1397	1678	1	1	10558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1HXD6dWuGvdwT4iK2iZFpkuJvPhxrm2CcAVy11io513FMBrG
25036	payment	2134	2134	1874	1	1	1626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR39Nt9jSckogf2RweGkZdSk24XVbkbU4ibAhtry6GbbR9SXdP
25037	payment	1397	1397	1678	1	1	10559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvY265wYWgiNx1oy1zhH3VczH8F1Hvcm25j9H71Wd4qGtr4v7
25038	payment	2134	2134	1874	1	1	1627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekbAJYhdy8AAPXqVAzyandUzbkZok1USSE2XCZKfRiYZGR2Ha
25039	payment	2132	2132	1874	1	1	410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFN83CpQqAmne7RZw7qKqSGxgNZ8nPC6xnevwYxFkkqiNqXd7u
25050	payment	1397	1397	1678	1	1	10565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuioHaDthJYBMr3oy8NZMTcCkMqDN6EnoBofWHs9wLF7dcDRbd
25051	payment	1397	1397	1678	1	1	10566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBF2jR8AAHzSThZxGQPfvNS4AEHCPbUsn72qiUGEm2RqcPa5rd
25052	payment	2134	2134	1874	1	1	1632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFRxhKj8pHcupSwur9JT3ViYCeADDjprfvmb5R3o72pzLSdw1
25053	payment	2134	2134	1874	1	1	1633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7q7ANSDcmpEe7ixJ7JNPJkJpnNGo64RNtDk1ucXcCMEGPjYA
25054	payment	2132	2132	1874	1	1	412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCyMRUtjSa3fismWbGP3nBsTBQtpBXXwLzGP7pn8wkm6eHM79
25091	payment	1397	1397	1678	1	1	10580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftKaSKhtpZihXR8ckZQL9kw3cPmMWVjZZPZ9k5SajBuKUCzJH
25092	payment	2134	2134	1874	1	1	1647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FvGd5FQhVsNbqHm26ao9PmLU5MKjLY14ZGgYryDmr2kobsGV
25093	delegation	1924	1924	1401	1	1	5	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2RZp4L42Mk6QxhdrjZbtqhuLkkmQpPRAm9NS4QhAtQPeBdT3
25097	payment	1397	1397	1678	1	1	10582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEk1iNpJPx3tbgiTPNbQUMHh7KpM2iqFe8GfK6SU7hVsX3V1ks
25098	payment	2134	2134	1874	1	1	1649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTQU9X7pXxZg19i5zySJeJ7chzjjCFJxN2kY9vchRP7unoXZe
25107	payment	369	369	946	1	1	4	132250000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqQm2AMtdWjanem1ZuZJyGChdfA5v9HLdRBVqD7aJgE6XKfHe
25108	payment	369	369	1066	1	1	5	237000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsdt2FwN4jP92yuQmkaAqceMfMViWZPUWhgSXuHxtfq84rvkL
25109	payment	369	369	1186	1	1	6	160000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwYCKz8MkNAaogCnQyRJQrX2swgi9V7WCdetHTBqFuiB9hexS
25110	payment	369	369	1312	1	1	7	446000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pcXFasWc4pYNEaT9buVteYkymrNTTxAVZDar7WCWDoyMYPDk
25111	payment	1397	1397	1678	1	1	10586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fio4Z1SgPLr5VzzecRzpUo4DA5dMcW28MC7q5sAgM39mJf58
25017	payment	1397	1397	1678	1	1	10550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fVrncXYCjzBtAoTaK46kNXWBJnmk2hpN1Hg2VtnySqd5CzWj
25018	payment	2134	2134	1874	1	1	1618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DPku4hFBKmKKcznyG7fjURRZFzxJPCCGSrwxuN52mHuVV8GF
25024	payment	1397	1397	1678	1	1	10553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB68Lgnj6byLoKQs3vuUgsQSbK8uHUV5uxBhWdCYB35UatNXEY
25025	payment	2134	2134	1874	1	1	1621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyvt7uNkSPdTpvQX4gYmeF1LjNvENHtXiL8qqjLBsprCt5Lnp
25028	payment	1397	1397	1678	1	1	10555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfDwU9jGQk4uCEe8fQ52hxFTXPYzBnLzcC1r5GiHAskftYioNE
25029	payment	2134	2134	1874	1	1	1623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46NQLy2QJWg17xToU5c5QfN7b15RMwKmRB3HwKiNtmn3sQ3Yw
25043	payment	1397	1397	1678	1	1	10562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiViqHfZ7sBwPCAzvMuuWaqkNj1WioS4US62gDaJmH3ksLALAX
25044	payment	2134	2134	1874	1	1	1629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHwsx6He2F6jJdDJhLsv2nV5sayA7oKBdqqtKeAkqu2JhwcSx
25064	payment	1397	1397	1678	1	1	10571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdNcv9WmU1bijVNB6M7i4U7FSRDF9kNfDZ6j4Le9cAS71Muc3
25065	payment	2134	2134	1874	1	1	1638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ1SPHxWoGS6wzZkvn9WrbovU9LjVPfCnBqjqp9fhgSqXutJmP
25066	payment	1397	1397	1678	1	1	10572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7S31FrKJ33hgkd6Aw7R1ce7wT6iRo5eBZrzzLFwDrjbZoxYkT
25067	payment	2134	2134	1874	1	1	1639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxYRYRkk7uRMEeeeDFMaZF7QSHL8WRoRYmfcxcNSM7Q1Z4fPb
25068	payment	1397	1397	1678	1	1	10573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhxfgGsQBPWjQJAjoUrd99WJHQnpnRw9T8uEwMK8umbCQK1UV
25069	payment	1397	1397	1678	1	1	10574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3L2mM7cLZJL7jyCy7CGsgQ6Uive5YysQ3QxFCUC2f5vJDEkRj
25070	payment	2132	2132	1874	1	1	414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2281vgpxSzuJbZ3iAMMF9khWJS2cih7AbKbeC7EqbV9SE3U8
25071	payment	2134	2134	1874	1	1	1640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosMLQSbA2brmjjpLi2UjdpQeBXhPESzV8nuenokRBDFWFidyv
25072	payment	2134	2134	1874	1	1	1641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uksiVmLbWwRqxVjQJVPp1m3wGw8PpqiWVmRHWsEtNxUJC14S
25085	payment	1397	1397	1678	1	1	10579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XGhbT1nwqVcnohhpjLRJ8Wk68HxZrfAGdc1ifQtfFbpj6ggY
25086	payment	1643	1643	1173	1	1	19	224352000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGoJha6AgffX5NB8VAcpYCp9v4WugxZnR6e3h6qdJN9CNNJtn
25087	payment	1643	1643	933	1	1	20	185637600000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YnGLTyTr4N1ZAqb4B5yQLgPPRrHNpM5BaP9fhgDzh8hrhkBp
25088	payment	2132	2132	1874	1	1	416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK2eizJXAW7CMXUyFbkGmotyWnYiKjn8HtjAvNvza2U9yT4bw
25089	delegation	1925	1925	1401	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmXaxvDPQ26YztU1CEbULZSSi3EEzhSqq8kfyDKXqFmp8fKjA
25090	payment	2134	2134	1874	1	1	1646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEBfEsKDCzKozaBKhdM1p4xzBjgMyABXehzBpCRVphWpTmbXM
25099	payment	1397	1397	1678	1	1	10583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeg7Y8XXNMASNKDCdCcuJ2sGaVdE6LLt3oDQkzGNHBzhx8KWUA
25100	payment	2132	2132	1874	1	1	417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZH58wSDK7WLSnSci5FHMcSSCY1q1n5FkEEikVhnd3Fe8j1b7
25101	payment	2157	2157	1929	1	1	10	4200001	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD9wQSoPSqVsYtHGxmUcYeXw9UpgcGzRcqeLB2inEVTQhVzNQ
25126	payment	1397	1397	1678	1	1	10591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYau5QfuAYhfa7SVfRiXvCjv8cbArEB29nWZ9njAvuRMAckpAqm
25127	payment	2134	2134	1874	1	1	1657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1GcmQFvQJn3waFk4mnHQQw6J2wYctearQtvWgHajPNu4nPmM
25150	payment	1397	1397	1678	1	1	10599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEkjFUZpXpKDdpkXrgL2CyefM2qBrHAXB1niYpAiLdWuXJrjx
25045	payment	1397	1397	1678	1	1	10563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwgSCvZFnvDno7LJSTa8Mf2PdyC5su4hXq737B4brGtToSuvf
25046	payment	1397	1397	1678	1	1	10564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkE1hiuawrzJ8v54QsHUtoQt6ErB3dW3Xye8Dvrn82AvfDBwyH
25047	payment	2132	2132	1874	1	1	411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11yNu38tHyMfTCwnnVxwXhUjgSLsUnZ6bh8vcP8knLzLsQ1g8
25048	payment	2134	2134	1874	1	1	1630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4S9aFHtxaHNvNKJosqUn2nU48sefVdu2kALu67EhTxZs1JWi
25049	payment	2134	2134	1874	1	1	1631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymWcBVbhPr9uxMGMv3mKpFKSXKZTx9PagtJzNp27eENnuUJBD
25059	payment	1397	1397	1678	1	1	10569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPmivYBGhVMQ7KhYxo4KVRUVGtRuiSpyC7bGMoyRVjg8Ud8BA
25060	payment	2134	2134	1874	1	1	1636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiE74NEnqJLwAdLEc4NSZCaHZ9pKpCVwMjS3EtpSeYNRcapzQ
25061	payment	2132	2132	1874	1	1	413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mEm1hTXwNuCjobuukK29HmzLK6YDMSGgPHKw4k1ydmGGr3WD
25062	payment	1397	1397	1678	1	1	10570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm88cuK4Mv1C6MUUiEHvdpehvw896QpPbatsfF1uP4mtBfeSUW
25063	payment	2134	2134	1874	1	1	1637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxWuBo84MZpTPFH8jYmp8HMVmWde5pmrh3JqgJFGi8BPZDRq8
25073	payment	1397	1397	1678	1	1	10575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDH24P8esmL4GkTqgF5gcD9RrL1xzMY2Qrj8uV2TnWmACALqzH
25074	payment	2134	2134	1874	1	1	1642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUEAxsgg8j7LMKNSjzjYzC8BXYbMEapTvqpgRgwqZknZpT89C
25079	payment	1643	1643	1299	1	1	17	625312800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWrvfEgXcxQUGuWize9Eum9mRp2burffACwceioCeeVKztG6d
25080	payment	1643	1643	1053	1	1	18	332560800000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9Sd9mmi4owPjooE7kAwm7CSUN9JM4qt2og2jyurAzWSBtKmB
25081	payment	1397	1397	1678	1	1	10578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSneYUrtm4aCDj2tQ6ou1BSqoSbEHqSXDjuvXC9Wvzrau5Jdfs
25082	delegation	1926	1926	1401	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyHnU1uyXLygKoQDm81Z2uZMQFW2eTvsWU9wLcPaYLpYoZMia8
25083	payment	2134	2134	1874	1	1	1644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2rBAuJE6gc1PMFd11rutEhQCyoFuvwvDy2YSpdLjvmFWtmzu
25084	payment	2134	2134	1874	1	1	1645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZje6EwQSD7AQN9WGqJAUEwvmnsf9tXJpKLYw82wLHKQvCLTfx
25094	payment	1397	1397	1678	1	1	10581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvTYJhdY2s2MF4uW7mS7Wcfpm8Naq8wU22sGdxRkwmcS2DmUw
25095	payment	2134	2134	1874	1	1	1648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfiTaZ2Kdz27kzmU6TZNL8BT57ioueQn4u9dGxXsnzTYRgo2a
25096	payment	2157	2157	1929	1	1	9	5000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdmVRoNykPYZqnj9V8voM6wENWf6bNdpJR15qTa47t9ZSbivp
25102	payment	1397	1397	1678	1	1	10584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnQuAKZHoHCY7JMuJCGNFurqrXKoRERrC6UmkL1eENaSoBCSw
25103	payment	2134	2134	1874	1	1	1650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHz2U7GpnpPbSVpVTDUmF6rAVN2Ynq8ueaG75VDxhnaVUJckc
25128	payment	1397	1397	1678	1	1	10592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4JGTGEd4ftkwtkXKfTSmVVEU7VN4q3d8r4Ecbc3URUKDKkng
25129	payment	2118	2118	1726	1	1	2	1000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpYinGDxRDv95U9dRo32xCihWGjiLcD2HosRiwvYgXgvynXRh9rr
25130	payment	2134	2134	1874	1	1	1658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwshbUL4aAwLT4ga7oNK31x9ovje8jWK4CaZd1RVLdiWR1DZrm
25146	payment	1397	1397	1678	1	1	10598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGTnjLRNJcePTdB7Ejq3WEd2dAKvjLzUzFK6Vu42Pxh12BNjb
25147	payment	2134	2134	1874	1	1	1663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZuMQ2Q38WSWgRod15yzTSfQNJQW45hroUZgoJfPFyf2ve5yJ
25057	payment	2134	2134	1874	1	1	1634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb96gjt9GyY6XRLoyfsY7FDtW2LCdrXNRhLrYN5xQU32yKTKH
25058	payment	2134	2134	1874	1	1	1635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwXQ1KfxxaqZKhY1tVQjgf3KDjZTCaxQxftkGdwwsdMasHjoM
25075	payment	1397	1397	1678	1	1	10576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeePQwNXFdxPvH7iGJztTznPWaERW8C69b8daL4j3Scp97MLG
25076	payment	2132	2132	1874	1	1	415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6bGWXqF6inhK8BhhdUvHkEuGMSu7vz76yUjt2JbcBHgJVBcz
25077	payment	2134	2134	1874	1	1	1643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5QowzwGBLVmkGrMbCoZ6Cg2XmuY1EB2D2z9UmDVxK7TvLb22
25078	payment	1397	1397	1678	1	1	10577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspDcygsqvzc4ouHfhuA1WDAfzupZqoXPMBMnMZWGCVLP6xGbt
25104	payment	1397	1397	1678	1	1	10585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEJTzDgcYjVbZ7oMTS4GrCAw8MUXxozZg5FQMZxUBCokS5cNE
25105	payment	2134	2134	1874	1	1	1651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYTGiCU4denDpHpJYgyxg7V7dLTywanqgv1HPUj73eaEyEmjsF
25106	payment	2157	2157	1929	1	1	11	4500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPd2VJUyzHU5CkwUEgvD2UPBBRjD9C93KGJEJTcvp795yRiLJ
25140	payment	1397	1397	1678	1	1	10595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQpA7LNMNDi2TE1UVzdR8dx8wM4x9mxhGW2kLTLZqyjERd4nW
25141	payment	2134	2134	1874	1	1	1661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pUVPcMm3vaBhbsLW7Bt5A1JdchJfztVEb9qG1ebR1f7duidB
25151	payment	1397	1397	1678	1	1	10600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkiRe2rmoihV4BNaegpDQpUuStHuQDzcfvprzaUaroTdXFEKtt
25152	payment	1397	1397	1678	1	1	10601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKX2KMcDfSpuQvjuHhKWF3uv8GkcNWnqMy8WWZ1HeNdiqotNg
25153	payment	2134	2134	1874	1	1	1665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKmPSiqK1MrkiFVVeDYa5j1SGXdrWLqf8XEbHqj6bxUSQpXab
25154	payment	2134	2134	1874	1	1	1666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQ4XR3jXzbzx9jfvJP6HDzqBaJ1XNB311Yu23QHt8bZN8NW9U
25112	payment	1397	1397	1678	1	1	10587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrXFBXUPFjond8T8a36eVwYvBQaDqHZnfcf2G8Di2Kn7U6Ga4
25113	payment	1397	1397	1678	1	1	10588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKbEyP5kYJyHvzZtHTyMfsLNhf5txeM9J26tND4AATHgztfby
25114	payment	1397	1397	1678	1	1	10589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzat8q56Bke362y1ME6kuj5kpAD5p7rx1kQfBqHVN5PCWZ3v63
25115	payment	1397	1397	1678	1	1	10590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFL4FTKDMzyiWMuegdkYzcBmXpXz1ei9FYCeqJbeV6JuzpXoK
25116	payment	2134	2134	1874	1	1	1652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWxgSAJgiQ98z4U7WzUkSXp3wwXKc1LLzF5sUXrVnvRa7yvYcM
25117	payment	2134	2134	1874	1	1	1653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZ2ERT38DoWha9L6GUJdBSso7XntiuTQ5CFpZGjFrG4zkt7GS
25118	payment	2134	2134	1874	1	1	1654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PoJV7kzyD4tMrGUYBc7pWUUYphTZV6Khb89uBVSy7QMPMi3u
25119	payment	2134	2134	1874	1	1	1655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYinVKGtss1cJcFiX89a6GWdshMpzbv4qFMt5gv7KYn2L5v9w1
25120	payment	2134	2134	1874	1	1	1656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKPDMZnuzom89j4cnoQQNDn3uT6j7mbNDwNysWCoxPoH9YoWr
25121	delegation	1750	1750	1401	1	1	32	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguA5UM46ooutQB8Hfyibwyy2HR6CWz7SJXkXmgjaR6Tvq6QRB
25122	payment	2132	2132	1874	1	1	418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuy6a7Yz84NJf8nJW3EMsEYYFJqnyX2jB6WH8xR1z2i5Kz2BMy
25123	payment	2132	2132	1874	1	1	419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYbfjS3PfLF8tCCLXKnm5kznuTT6WBnogzz36R3zYdrHXvqBX
25124	payment	2131	2131	1726	1	1	3	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpaJZ7U7Sn77gtpd4Uw9m788vBfUHCKALcCzWRHL82a7Z39rAfEb
25125	payment	2131	2131	1726	1	1	4	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpZ6hXp8BJAzJea4qg2g5k3QpYFeZ4rxTGC9o7iBoEoQUCkt8kUS
25131	payment	369	369	946	1	1	8	6620000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6jFrTjXFExbKjB4ztLomwYEW4RWRDVGQBJ7imQE412NGR9PX
25132	payment	369	369	1066	1	1	9	11850000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLKAr2nymMH4M7pChXUMBHacWaAdL2ff5rdgdusVeXwH9expf
25133	payment	369	369	1186	1	1	10	8000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAQV5wtqHq3ja4XVkFhRUVsDEgpeaD5e6FGUpVdzK3k22bEuq
25134	payment	369	369	1312	1	1	11	22300000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZunzPpRZbFbR6YRQw4oytzzAtb8jk3mCkvEv9FwMA7ps3y3q9
25135	payment	1397	1397	1678	1	1	10593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKVVyqAFKDVVsu6aHoB2NH4LETTePaCydSW25ReZXgeEEDf6P
25136	payment	1397	1397	1678	1	1	10594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeH5dBCCnEw4icm2XAzfDmKdrZmqQVccryWLmPrfrPADrp939
25137	payment	2132	2132	1874	1	1	420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSLS5ZQRmuGE661fqwDhCfY7AC4WjbeG52X5LZAVnZ6dMJEVU
25138	payment	2134	2134	1874	1	1	1659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLExQuWDMTvLLT1QnKveFRpjMfTJfZVHXZHqXtXAdctNSuBn3
25139	payment	2134	2134	1874	1	1	1660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQ9Bv7fd7UdrvjbafMyRwGEuPsCUfCvtLUCnhi5swBGCKugqx
25142	payment	1397	1397	1678	1	1	10596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CGnh9khhY4oU2YroqHaN4pXE2W6Ws6JDBLpUTnjmN4XYm4Cu
25143	payment	2132	2132	1874	1	1	421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7CLCfdiuF2QgG8yWkxkHo79HUYZFBdMN9QMwbCNT6o3tqKRj
25144	payment	1397	1397	1678	1	1	10597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaA7gHDnxGt4QHMrDRCnXUVoHNKBCt2oTs1zYc7Mzum1dNMugS
25145	payment	2134	2134	1874	1	1	1662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQEe74C3SBzws6aeGjEeB7AuFHwytmBtdJJBYoDEACy2aKN21b
25148	payment	2134	2134	1874	1	1	1664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1doZSXYXRwb5iRp9kkB7xRH71Az5vhYpmKR7Td3SKdNeDwpo
25149	payment	2132	2132	1874	1	1	422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGTLJ5thwmN42nt446dun69aJ2jmtypW7SLiK3Kw8No29SwvY
25155	payment	1397	1397	1678	1	1	10602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6o1a4xE685dRWYGeQwdrAseQdXAWanFTiMo571funBtqspfe
25156	payment	1397	1397	1678	1	1	10603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbsjdFBoq9xNGWbD1hAJoUd1e4kzqA65GQ3RLakWuLeUKmHgo
25157	payment	2134	2134	1874	1	1	1667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnbUd7zR4rAotygYbQXsieQc5WsJgVisCPcxw38bRQRCtpmEP
25158	payment	2134	2134	1874	1	1	1668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUwPywDhpqqtbD93QfCqwqcFEbTaJtApR5VuBrQkMZX8KqJbG
25159	payment	2132	2132	1874	1	1	423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLr1bj5mZTAkiRn631R7eox2ntKeJqjDVigEtR25dNTc9pEKWg
25160	payment	1397	1397	1678	1	1	10604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1C6KuVuAQAZq4tcs3cjYCvHMER3nzLyiVJa85Rs9XF7ZbynjS
25161	payment	2134	2134	1874	1	1	1669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZkaTyr6ucqbd8SAd6Z3h1piZFSCKDt8Ayev6NF8EmxJXLYM7
25162	payment	1397	1397	1678	1	1	10605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvWf7PfhrxDJJJo3r1sA6NGj4B77d6dyEXCNaaC2TBtptQVJi
25163	payment	1397	1397	1678	1	1	10606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyZEQuk8MUWuLDrHScsccK3P1Q3uLPmzNYaby74NcTumzxaYn
25164	payment	2134	2134	1874	1	1	1670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61j9x4sBr6YZSiGPCDY2mV2prCiwxRo9JsjZcntjAWqjShJfy
25165	payment	2134	2134	1874	1	1	1671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZmzWDP4pATpF8nQPifwuwYZvwpcnfix7HAE16rkDru9zDgj7
25166	payment	2132	2132	1874	1	1	424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHL2qwUAAjoDNkBwjeXtMWh3WanEkxE99sMjXrfd8Rz6gdioT
25167	payment	1397	1397	1678	1	1	10607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguidoXSTYsuo7o3YdgX91wpKE6pDAfzQFQxPGLPGQ1BUiAQ9Q
25168	payment	2134	2134	1874	1	1	1672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuiS358PBnqYaN4bJ7PMue2nArjdT7FVETkVMrihK2BDihJhH
25170	payment	1397	1397	1678	1	1	10609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUkYswMvC6CryrrzB5vJNnwyeGWuCBmVsvvggEUnk8zqxPpuir
25171	payment	1397	1397	1678	1	1	10610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdfz2j6Vn33i7hbDD47Att3iNCoVL4NQarQVQhAUhu4m2JUNT
25172	payment	2132	2132	1874	1	1	425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiPh5aAymCN38twkWU5vEzby9H5ML8a8AbN3S5Zay1CWdVY3o
25173	payment	2134	2134	1874	1	1	1673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pCBi23W2Gpx47aaKh3fKuB1fgmUNhckTHYC4juQ5EXvrhRej
25174	payment	2134	2134	1874	1	1	1674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYpusmdyF6z5rH8jyQ9otTsbBBSUQ9HP5vp3KLz4MsqhKjEk8
25175	payment	1397	1397	1678	1	1	10611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnU4NciiyeNq8nnjfutEnPvxQfJgmNZArycBKvwbvV1iAWPGR6
25176	payment	2134	2134	1874	1	1	1675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49SU5GNSnSr3bab4aMMp4vXS5RK5GC3V69PQK2VXyrzRLEEHk
25177	payment	1397	1397	1678	1	1	10612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4YLJ9oL64VMHkjnPR1nJW4XGDvn8rSeXoEgatnmHxjU6f6LXG
25178	payment	1397	1397	1678	1	1	10613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZux1agMksRJjoR8EzotQf3nVpPj9SdaV8XDFvnwHVhdCna1S4F
25179	payment	1397	1397	1678	1	1	10614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyfPrpS3Xk77Bwd2XreYwqMxHMUd5ehF2XLGgHt8AfmCm1Xo3
25180	payment	2132	2132	1874	1	1	426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjkfixwnvawEmmP582ECsgwPEBoZa2dxDkaGkesPDhsV8cCNH
25181	payment	2134	2134	1874	1	1	1676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9eo4soAx1r6npwNJgufWMHK1s2Vxf9xi9ExYutErZHySVWcZ
25182	payment	2157	2157	2157	1	1	12	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwT241LTadgCoYasfWPe8kJugjuDa745cHZ18AEBLDiqtC3LPG
25183	payment	2157	2157	2157	1	1	13	4000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcFcxNWRabBr7Ft5uxxcUYqXA2Mmt3drQttLabGrbCj62s5Yq
25184	payment	2134	2134	1874	1	1	1677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2tr1tu2mjvRkHjZmmW5kmeEn2rvHnGKxchFwZzhw9CPHhMAT
25185	payment	2134	2134	1874	1	1	1678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UbBpSZ76ddjZ5RvqWiwUj84Scsd6a7kr5bWMZzoPVvdsnMXu
25186	payment	1397	1397	1678	1	1	10615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdraydLRcCN2hyEogdaZgS9B72k3ntezqRJBdM6bFm5RNAC5rZ
25187	payment	2134	2134	1874	1	1	1679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmbHhX1ZdWksyqyvtEiESukYKsEELQrDxZj5Rd3sRijEjRumT
25193	payment	1397	1397	1678	1	1	10617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHHfBLC9uUNoFwFeEdkF4UHLLUgFam5FTQXNLR913fvUFtgwL
25194	payment	1397	1397	1678	1	1	10618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCaQiK5p9HPMfoFNJzxh5DzHnfygxF64EudLS4Pq5TDB4rBEQ
25195	payment	1397	1397	1678	1	1	10619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAqdWHamKjUnQ3BhJSTrQvLukk9ruqa75wwT5parutsUjuqPQ
25196	payment	2134	2134	1874	1	1	1681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjn4bioaFCncepEDPUq1UsstpBjo6yCiFiY5iLqRpDyxriVTM
25197	payment	2157	2157	2157	1	1	16	44000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1W2jP4V4CzcMM87TdhEAZqLrtwemFtfMYkCc9awpLBbq7Px7
25198	payment	2134	2134	1874	1	1	1682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFueGpAWAbX6G7cD4bvF2X1H6oEvZRHs7gDhQSoCrZQyHhR1ob
25199	payment	2134	2134	1874	1	1	1683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkWrbSsDcKGaU5nbgw3G4maEyTF6nCkEdoLJUseLmqkG6y9iQ
25209	payment	1397	1397	1678	1	1	10622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VhSGJjqrTSeEbWP9f4CKwyGuKTxdnEPhWRvWH2o75XsADPrM
25210	payment	1397	1397	1678	1	1	10623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpzpSmc6Ubo1Tg5poq1WkAJehK8uqKR3N8ZJMRY2Tjdu3XDSG
25211	payment	2132	2132	1874	1	1	429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZnrsG5GkYmCzv7B1hxRkNYXcrBvKKeKRK5ZFiDyLuGdBWfDJ
25212	payment	2134	2134	1874	1	1	1686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyi99b7USbrHcaSQNMQAi144R8FyWxz9tzKfzBkYdFDtC32rmT
25213	payment	2134	2134	1874	1	1	1687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQVNMmpJJG9PfpmJTn5EhWPB7tBy6yvcDG4qVQ4uyB59y9A5V
25218	payment	1397	1397	1678	1	1	10626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4SCNK3J2zkBbrE634dv1geYSoLdsYh4P49qpPKKBCihdXq6Y
25219	payment	2132	2132	1874	1	1	430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvezWUnBuEhGt6pWetwCZYmgPzcmNrUz7pEgoFaZjrbCJrWZe
25220	payment	2134	2134	1874	1	1	1690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cLo9FsaeQtP5wgMJXKDEyTWBMQ4XDzmmC6NF3UpV8VQhzFVE
25169	payment	1397	1397	1678	1	1	10608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYgFaKMPbDeY1Q5hcnZ11sVKpixoZamQMpf3xqqzeBQZuxYR5
25188	payment	1397	1397	1678	1	1	10616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhoVzcDwr4wEvAigKe314WNwf1pVPTfDLqs3To8w8vRN2MviGf
25189	payment	2134	2134	1874	1	1	1680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtwkWsUbyGE57w11MDQe8FWipB6yL3jMFLUQrWXXGUxpBVYqP
25190	payment	2132	2132	1874	1	1	427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCrNxtEoWQD1unne81KzA7CbdoBznVR7zMTHfuoDb3LRiZzBu
25191	payment	2157	2157	2157	1	1	14	40000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjYKxMJfrRAgpxj9zAqCuEWrWjxnARLP8xN7CC395HVdopBmW
25192	payment	2157	2157	2157	1	1	15	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3PPjskfyxVggmZn6LQ9bJfuU6GC4vVdBaz9p7H8TeC5TCjRw
25200	payment	1397	1397	1678	1	1	10620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNHoj4qxRUPHW2QtWA3mYrjuko7k9P1n89KEYUBxLW3znfMYZ
25201	payment	2132	2132	1874	1	1	428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSa3d3UvK3rC61Sg8ECuX2k5ZFmnRfLkcLthHwwfxSSpASQC1
25202	payment	2157	2157	2157	1	1	17	52000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPSnKgQWBHz32bnWgjfSjyz57burtVv6ZQVNjUecVVbyxMGEh
25203	payment	2157	2157	2157	1	1	18	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa193mBPx5PWMPuRQcwzH26UcrmbPknkyFkfoE2NzE9RexLhNzX
25204	payment	2157	2157	2157	1	1	19	21000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbj8v7JUouCZ1f35Kme8myrYDCkM9qSttmdM47RZ7gQ6EcyYyL
25205	payment	2157	2157	2157	1	1	20	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSRG1G3Eyf4S7i5E1HPaPMbMmkkWxhrtVQYdkGmCQGyicuiHb
25206	payment	2134	2134	1874	1	1	1684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZSUGPrNLWAsF1h1vceRfWc8iPiYYgBMCAbtUhM5qtwBR4PNv
25207	payment	1397	1397	1678	1	1	10621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUkznGp1nBfEruVumMgzd6hiPbaboUCX2G4AMMsS7QjrMGWmo
25208	payment	2134	2134	1874	1	1	1685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFUV8g4X7W65Z8Jb9yhuUHQ2sH1DjPVP9zPyDatrKqG7Vw2CS
25214	payment	1397	1397	1678	1	1	10624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMLV7i91v8PWa7cHhk8vzsRQjUQvo1ZeU5LD2z4AqqgWPwKEN
25215	payment	2134	2134	1874	1	1	1688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3TfpqCGeSChHMAf738KHpsGKCYzrez8ApHjcyJXwAHsKMmTE
25216	payment	1397	1397	1678	1	1	10625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEbBYJDVVucJbBLrShtotposB9sK3RsZL7yrFpuAgU3tuMUVw
25217	payment	2134	2134	1874	1	1	1689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKxdiXHpUjmcW1VM6AyUPQSqE3mdQDUZSsonqUeawKEGA269b
25221	payment	1397	1397	1678	1	1	10627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwdndeYxzb6eoWKq5r9rhtjyhpx5wTzCAWoJGy4s4WbEArxZz
25222	payment	1397	1397	1678	1	1	10628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqi4zJmnonAQ81pNYgF2MkzWQferrC9sTnwoSfBA7CrSMuTct
25223	payment	2134	2134	1874	1	1	1691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9NyEu7GvS7FDn4fwaAfHUPptTw4LhUq9uQrdTgxaU9wFrTmj
25224	payment	2134	2134	1874	1	1	1692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStNGRt4Wfra49yirN5sFoc3XU7ac1AHe2iBddn7y46PbXNPnZ
25225	payment	1397	1397	1678	1	1	10629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cofxxDNQBzXF6nqwfGZQt1XoHjmvjfQc4qcmisQedWXHtAfp
25226	payment	2134	2134	1874	1	1	1693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHntRVAdecF8FHUWGmgRFVTQcqTgmY9dkvBh1bgqzH8GZn28Z
25231	payment	1397	1397	1678	1	1	10632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqXta3rJQjhSr6wvDVJJBdSNsrcH6ptUHHHJnsnngp9RXm4UY
25232	payment	1397	1397	1678	1	1	10633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsiVW5qT6tdkodjtKMNpUFthk6qgRJmWv6UA8YjU4uYvLm3UXw
25233	payment	2132	2132	1874	1	1	432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHjWb7mHq6142kbTccaKgGENraRG6FvpEggMNBJXaFDVpCiJz
25234	payment	2134	2134	1874	1	1	1695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt5G4gaeVPjK4xvkxN8pHHE5FxH1hcKLRSSv4qzNLzkkF1qir5
25235	payment	2134	2134	1874	1	1	1696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRqC46HJFz2WMx2c9w9TFH1FVNveUq1pbeieYnmwrManLxPxK
25238	payment	1397	1397	1678	1	1	10635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6M2E8rURNu8Hm2cR4f1xfVV8zpUvwhKPhr6HSdPQNuin26zLx
25239	payment	1397	1397	1678	1	1	10636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoaEaoraND4YJ7MZ3aurFvwmFgirCDkJr716TRMobKHqgSGdL
25240	payment	2132	2132	1874	1	1	433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGFeGwxsQcm21Mw88d39B2erjTWGEFVV9DN7UB5RuspKwruCd
25241	payment	2134	2134	1874	1	1	1698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBbBopgWCh3mPhd7ZQP9WY94WXVTcDeARKhMX28BCYs9c7LVT
25242	payment	2134	2134	1874	1	1	1699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFwZkA8AozPxYmSrmxeoA5yxzX8UcxFGSD6wgHEyN15L7Za1F
25243	payment	1397	1397	1678	1	1	10637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexiB5Nq2abVewFB4TEjZNaPb4Hc8EgEsuamTAU5B6zW2VBXEc
25244	payment	2134	2134	1874	1	1	1700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSBFGdqNrNY4N1NY5HdMS9joPmR9ZbaNMQ64MTvwKGA5or4MC
25249	payment	1397	1397	1678	1	1	10640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfzXPbcXCtWx6MxupR2agBigYMJBS8WSmFXwVxn2yLcvheR8s
25227	payment	1397	1397	1678	1	1	10630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9DhUH3A8D6FKjdsSnkGQaNZYB8ch3Nt9JyB9hw5QkhoVuCZQ
25228	payment	2132	2132	1874	1	1	431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32JjtMp6jtTuWE1GDfmVXQ3wKLbRT9PSt7VofaLGL2cr8aKUS
25229	payment	1397	1397	1678	1	1	10631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28uhowZ3VYjQWvmGj36Aj1AWoy4QfgUw6mWAGzi5ZwUTQrjDe
25230	payment	2134	2134	1874	1	1	1694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwbfhdErNsKL3h9QHz1KKH4jhKexsQrQt8vkAv8rL5YuqM98E
25236	payment	1397	1397	1678	1	1	10634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4U8kzXXK5bstoLkshEJQizQyCohWK21z6LxfuPaNJBEs9PZG
25237	payment	2134	2134	1874	1	1	1697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsoTnGVrpe398yoKTa89SU7VG1B8nxLApkmdxyUZGPQFyPpb4
25245	payment	1397	1397	1678	1	1	10638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmL8zPkWkNdwumVXrPyxGknCAYYuqcFpnqYrHGyPytgmWH8TZ7
25246	payment	2134	2134	1874	1	1	1701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrP5jJg73Nm9cCo6ffqTtzzPDduhio72crZETdU7ACSnPryL7
25254	payment	1397	1397	1678	1	1	10642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpB82q3bk8ayT3FDtDzqcnARVVM9Jp8fdgPHR5szi44DeNj91
25255	payment	2134	2134	1874	1	1	1705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe76v4pHW5novuNn1x7qchbePzxbmWmGbD8vFJpYSxBphqwiTi
25261	payment	1397	1397	1678	1	1	10645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QpDWnmxtpVYMbs2HJf55Ktai7RobMpg8MyYbFmDUUsCMnoEW
25262	payment	1397	1397	1678	1	1	10646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRLfhRaztFUmH4Ef3N3duqZL2KR7aj6YsqhgF8es769m8oezh
25263	payment	2132	2132	1874	1	1	436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSDXZMnusRdTBZzisfv4N8ocokn4ydE1AgtyJCrUmkJ82KZbg
25264	payment	2134	2134	1874	1	1	1708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzgo6goDvYxLGNpquQb6BQv27AYuC9vswt264doe5UdfTgTFc
25265	payment	2134	2134	1874	1	1	1709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmCW7i8ucjGA5C4xUdmT6GhwHFFiopRf7QDpNPaaiuANMtqhT
25268	payment	1397	1397	1678	1	1	10648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFN99GU2HfMvvxaoXgrc5Mgbfimm6faB5XGzkZhTEfAYnP7fW
25269	payment	1397	1397	1678	1	1	10649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA2mVuWpMRdHnfYTRENvbciaiZPpMprXut7PvH26pTfAf8qJ9U
25270	payment	2134	2134	1874	1	1	1711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxyLxxDX7XApgS9uGGPUCfvmTD1eQPgyg18qXYbivWswXDj3K4
25271	payment	2134	2134	1874	1	1	1712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKt2PWjweWAYZVsM6PvokLssJzMvn95CU63XpNitjYnhsoYVCy
25277	payment	1397	1397	1678	1	1	10652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNgZ8QixELpVwHQBtv7eovFRnDFCiuhmEaoT837K3smkbDyyC
25278	payment	2134	2134	1874	1	1	1715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYczziZEHpktphqmkwAh58gzfM6nCBfbJjUKNuWcJ54u9sUFRx1
25279	payment	1397	1397	1678	1	1	10653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZxxt8M9capEHkq2ddPTskzPaVxvStUeKS6XT3MUhNkJkCJUX
25280	payment	2134	2134	1874	1	1	1716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTt6rhCsGeSU3RYUMaAy7UMj27tC3Dvn4Ue1S2iXVuNpan8Rg
25281	payment	2132	2132	1874	1	1	438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gq7HLim9A2LXbWiVfbnQT2v9nfJFjL9TFfPXhFjqRHdWPMRk
25286	payment	1397	1397	1678	1	1	10656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYPaStVifhx5WtqsLRqcPQgFgFxZ35YmdXwbbmqjKRZ1kLgEA
25287	payment	2134	2134	1874	1	1	1719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPL4RhJbMh3hGChpJW8THsg2pMSfTTB2tHYKsZdimUrdVbGqC
25288	payment	2132	2132	1874	1	1	439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZfNktZfdaPZ5dZzbE2KgGow58wBTrJMgkEG6UXGkcfV22ocF
25304	payment	1397	1397	1678	1	1	10664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURg9WpEGg5XYep1jAzCHR56reCTRHo3xjYAnFRwchDujZeA2F
25305	payment	2134	2134	1874	1	1	1726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxgjecCanTJLSmFP1m1htc45WqYLuKx7MSAiUXgdJbs3TiB7Q
25328	payment	2133	2133	1874	1	1	1494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhgz7wZm77PJ6i5SEnnxrVC3GWSNXiQjsidzmjxb35z5i2mNX
25343	payment	1397	1397	1678	1	1	10677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvwJ8Mgcpcbfdf51p4bTGAgcYpFzBuCfPEqm8EVLAb6RbW7gL
25344	payment	2132	2132	1874	1	1	445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKimYcCw5XBAmBiewcpKAhJejLhtnfDYPMNirjBwES17DfW1k
25345	payment	2133	2133	1874	1	1	1499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdszwugKXctZLnCHbvrdZhZhp4T8ruRWrbvQqebqCyTXNDVJa
25346	payment	2134	2134	1874	1	1	1738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDVefNZ3LyTKDupbV7d7s9CPm38jPuhjupVjLAk9M6JvgTLUv
25372	payment	1397	1397	1678	1	1	10686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsS6ypEU4pv1q9dQTsbUCfJQPEoDEh6LyVe896aGcKpSbXKJtr
25373	payment	2133	2133	1874	1	1	1508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ935bdbugThN49nyPta57i3Ji4w5WgLeR5khzrc7APSWjfJx2P
25374	payment	2134	2134	1874	1	1	1746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaspsYFuoJpp16JGaibBFUWifdT6itwG1uTfMzA71bKk112NSr
25375	payment	1397	1397	1678	1	1	10687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8r59iKutrdj2mWWGdeXYqis6zXfpCtTSZ6pWQV6u6baMsBFdm
25247	payment	1397	1397	1678	1	1	10639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRWPDTShSZLTprMGwXguaVxSvQtpmGjaEcz54shMvUJPTNJyT
25248	payment	2134	2134	1874	1	1	1702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2biktiukPz5aawfinVEyVcB1rUYmJAgWHxygfusEmHXTiiM6
25295	payment	1397	1397	1678	1	1	10660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8uEDbCXVtLbPiXcttVes4KjQKULVuhNMzmnUh486tmYDchPE
25296	payment	2134	2134	1874	1	1	1723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM712syMqtQwipiW9sbvoYYPecRYhzLYMgM9DD8nJs3duRrBJR
25297	payment	2132	2132	1874	1	1	440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNdLpVRj1Q53uDs144HofJqvELFBAZkYUTbKr1hNLT4JESKJs
25306	payment	1397	1397	1678	1	1	10665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvmedGZd78P7JCTEBHgso1z3WtXtHYThzutFL3ZxnBBjccEPp
25307	payment	2134	2134	1874	1	1	1727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqFUBHb9n3QXex769WAdDZbpKF4rdM7EszvJZho34H4hFoMkF
25308	delegation	1926	1926	1483	1	1	8	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLD6piM2V7mGv4pPrKoW3V2wWTyYj4oy84eR8RZhS7En9QRNC
25329	payment	1397	1397	1678	1	1	10672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17hqNTcAdLqX2HWbpa94x6W4GhrTCyWoH85UQ37T8gH9vP2hy
25330	payment	2134	2134	1874	1	1	1734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVyQmchSZkLF3JDDWEKSbTophkxg7YYzXvqgEsV9KCe9BsTmfP
25331	payment	1397	1397	1678	1	1	10673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKsS9pHsC33MJocjyCERdjr8p3bnVsxdm2FYBdVN1t9hdGKu6
25332	payment	2133	2133	1874	1	1	1495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgAW7ntXCN1MGTSJUH67CusSCqysXQeJH52EjhCS3YjmcoP847
25333	payment	2132	2132	1874	1	1	444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbpZLxVX62J6YPaxudaG2fiKjHCZWPSvw1hh7S8SGYVtpUpG5
25334	payment	2134	2134	1874	1	1	1735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoezquafWqPfDPYKioRuCUxXQkUDinjDRgMGDTtbhgBdsswBsr
25340	payment	1397	1397	1678	1	1	10676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisu46aowEbUZbxQBZSuFfBwHeXfAnzesXYDrxfMusZMiGLf8S
25341	payment	2133	2133	1874	1	1	1498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbz54AbKUuCZcVmnNUHGWdcLjCeJRNKwgJtwhBXpEbtQuCabU
25342	payment	2134	2134	1874	1	1	1737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cjrNJeyVYN8wEpk5CvEG5wUMrqcPYwz2g2fdw6nCapw7snbg
25350	payment	1397	1397	1678	1	1	10679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzQfMcqp4LLZAY5a1miuxDtP3pFmyPoM7JwhvVgCRC1dJw8m2
25351	payment	1397	1397	1678	1	1	10680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXig5izfQZbe9y5tHF3XsbGvo1hrYzHaPQj27MXMyCMhJSqGg
25352	payment	2132	2132	1874	1	1	446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAk69Y2YD6knEd37zmfCpvyRXdGDxgkwdPkapAMWnokY6cJYC9
25353	payment	2134	2134	1874	1	1	1740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGZxxXWYMpVoQYMM2SKaKZqKy3n1xcgvUppeRpnHZsMAgXvdR
25354	payment	2134	2134	1874	1	1	1741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinuddLSdDXJD3p3ZKcU2z7qbnE2BPNCievcEMTvQSuWT7P8UF
25355	payment	2133	2133	1874	1	1	1501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApnyBWKTiRnyoBYf3PvMCrSurDzjENe9ucBJ5A2CSzEXqyB3W
25356	payment	2133	2133	1874	1	1	1502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhhECPv7yUnQncSYm8yAHQ1tJmkcDoMimZepeJSJjBZEN8SGK
25360	payment	1397	1397	1678	1	1	10682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehSwbny9z4Z4oQEMsYLEU9hbn3ArxyNz56chqjkT68pGM3eK7
25361	payment	1397	1397	1678	1	1	10683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUeqa2horMKTvaUKEV5nNUtvi6Df4q11u3w8ssKcdsaCKsmJW
25362	payment	2133	2133	1874	1	1	1504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiDqRSzPWGwRjqxvxeYHF9rgmqQ7dNbQYC8ibQ1XVhN67P3xG
25363	payment	2134	2134	1874	1	1	1743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKJ1y9mU6wn2mmtL1nwmSE23YvfyXkBg9cvDSfQsjPyCu4MAB
25364	payment	2132	2132	1874	1	1	447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCxkb2qoeVoChVk3mxfauMW8JrZASSDogJV49oVtjKLC7x6op
25365	payment	2133	2133	1874	1	1	1505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrxXmRx6wNdeiuk9fxmw46z1i25tdUNzrPWKywsL2YECFotx9
25389	payment	1397	1397	1678	1	1	10691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHoM7JgaZYpjxwdEHCRXXuKNq2iqe8ugLFA4ZHe8SZwjJsL7j
25390	payment	2133	2133	1874	1	1	1513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFY2JTwvf8CnD6gofZ6g8kky9MRs2tkG689F7cnY9SJ3FfFyk
25391	payment	2134	2134	1874	1	1	1751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qfgAZmhx8xEBz3SqdfE8mgfXsG7NJ1LC9YQM7wS316c8Sb5U
25394	payment	1397	1397	1678	1	1	10693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiM3B1d16zFbUAiUA6EmRT1fT9v28nqUw7whUj4dC2A5zA5YsQ
25395	payment	1397	1397	1678	1	1	10694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVM3b5bfXB76VgKrxgvcgUzsuVkqjPPSiNcpk2wuoMU88X3jo
25396	payment	2132	2132	1874	1	1	450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBPp13MaFYhsfTtjhB2nHXrvHt3YydirjyuwqiMXxyZ1WUAiX
25397	payment	2134	2134	1874	1	1	1752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gkDHLjL4qniJBUoe7Ma72oH8MBj1qYoegViezGDZQHFwuhsv
25398	payment	2134	2134	1874	1	1	1753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmP5MDJkXg8Lofbx9gpD1ffdRtrPiXKv3eQu7GWo3oRdQoVAQz
25250	payment	2134	2134	1874	1	1	1703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4gXH4H28USyPkNfzJSVdbBwtHjtJyq7JFSDA1XhX3QXA1mr6
25251	payment	2132	2132	1874	1	1	434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwAoceaEEpAiLCZihcGW7kKaW4CMomirxbgNmHGvapDpSq8aE
25252	payment	1397	1397	1678	1	1	10641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTHfAzNLpYYtVMrwtgZyAGRozQ34e8NQADA7dAb5ZEPEdifgo
25253	payment	2134	2134	1874	1	1	1704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2o8MyqDR9uUMfGLGXS7sUq8vf3yo6GK3PkZQkBRPvEp6eTSr
25256	payment	1397	1397	1678	1	1	10643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNXWoXuprKVz43QHhJAiRUjsL8pswzDzYUsmN6rtKkxuFuFN8
25257	payment	1397	1397	1678	1	1	10644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkER9qGv3UgxWnwJxNikM6A6DrjDhy6PmDydp8Z4Qvpf5qzMi
25258	payment	2134	2134	1874	1	1	1706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBDYZKwgnBaqHxSWrY8aorHR6oQBGZNpHyT3MhrJFtqwmyGXs
25259	payment	2134	2134	1874	1	1	1707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYST5SsVd1zMpbziNyxVHJkhYFXdGmACCeWuguofkBGazGTF1VL
25260	payment	2132	2132	1874	1	1	435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZde6mGCUzSg4F6To3ZpaJwSTfE9yV8tEBKieF5nRsCshurYYcm
25266	payment	1397	1397	1678	1	1	10647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTN7oTiGs4nTykRaQAz1kXjw63r4wnA3vgVfwgThGw3mCZY2V
25267	payment	2134	2134	1874	1	1	1710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRsZSE8DSpxnVsNTvEVF8DuEvbZb4bGaPfLyVFe145MRCuJqM
25275	payment	1397	1397	1678	1	1	10651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5th6Km9TF5ZZQcTmSxbYUKb7RbBtkcqDytgmoQeMiykXt5wm
25276	payment	2134	2134	1874	1	1	1714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsXZwoaYpWJsSoXHd6Z3i673NtdvC5giwjDWokofuYnNz37YU
25284	payment	1397	1397	1678	1	1	10655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnz2SFVqxowCKKrvdG3BwNPdM5Kc31pdGtQnLkXXb3AmmXFag
25285	payment	2134	2134	1874	1	1	1718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fN6Pme9L5imFSpmSYEvy5y4vqaN12T2fvbMwFS2qDt29649t
25298	payment	1397	1397	1678	1	1	10661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hV43wVo56zavc4xMjHTEL7P5vncomYzas6KviiNJFBKEBzZg
25299	payment	1397	1397	1678	1	1	10662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcWQj4bDvuPhGxms75LpZUY9aBeBVxtqq3Etx4dvkSBaTJ2E5
25300	payment	2134	2134	1874	1	1	1724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkuqejqCwd1KqFogxQWr2qDv9aXPWwmKKEytCKqQw6qLh3vvoR
25301	payment	1397	1397	1678	1	1	10663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizuEmWL7P3kK2mX8jHGb13RaYyiiXZzK75ZLbvRq5AZjwbiAB
25302	payment	2134	2134	1874	1	1	1725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhvDnZ58hjNqNHU9XUevpiPhvD5vPmauif1YNKZoixnuNvukZ
25303	payment	2132	2132	1874	1	1	441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVpQnhGtEVfTUi5FrNMafLzrYHpKsmWQfHfZ6sgnD8QfosrET
25309	payment	1397	1397	1678	1	1	10666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxf21M6CN8ECjkDAgGz1XBqQkfuqwBqGGJMNsQKQZvAPSNd1Ew
25310	payment	2132	2132	1874	1	1	442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeA5UacPm5Ny3TqSFZXefNkdsyjqY8kJziKqmKAWDNm2emZGpC
25311	payment	2134	2134	1874	1	1	1728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6nkVjM6zxjTdMNHVkB1bB8eLADLxfJkVGsE6aq4hU2eq3V25
25325	payment	1397	1397	1678	1	1	10671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2dWiCXY2qhzrAx55BfFgACbcRhPXnyFwSmvBTwdYn99m56BR
25326	payment	2134	2134	1874	1	1	1733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhddRReTVR9fypxQcSAav9GPsu3YjXX4Y9zY9M7pAKfZsHbgXi
25327	payment	2133	2133	1874	1	1	1493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWSsaA8yVZVD2MRrdi5g1mrfExTuLtacdduDsSqZraDep8iVi
25347	payment	1397	1397	1678	1	1	10678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeMBpeA6e27GUP8vuaycs378MmuYTmNFdMwUtEXkM2UdnLRAc
25348	payment	2133	2133	1874	1	1	1500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyf6jtochefWBhG7GKsrvjzZxmtjVWLyp5THZLstSJZgmM7wom
25349	payment	2134	2134	1874	1	1	1739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9eKQ879rwUaocCqjMfFBXoMWi2N86tXfm8NdZcmwZWmjRr3uK
25366	payment	1397	1397	1678	1	1	10684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcBNfpkMSKL3riUW4cthjXiEVApX1Dr7jW4aLxHwkrvdF8aNm
25367	payment	2133	2133	1874	1	1	1506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYf3DpA3cun57QBjqSsQmbodQKgYAAennqqwdWknLX5rm88iq
25368	payment	2134	2134	1874	1	1	1744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4xc6YG495BSy3cUiLMD4jhS1w165gyHCEPYmT9TiVQPoZveX
25369	payment	1397	1397	1678	1	1	10685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG2H61XaXLJJJqkPyZQHHN3BU8qwSW4j5kD9zfpBqGEvik1zQ
25370	payment	2134	2134	1874	1	1	1745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbddvqa1qbGga7u766GuMeq4HqcRCpFcDE2WfWJbimCDg7Xv1X
25371	payment	2133	2133	1874	1	1	1507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7Nhbjx9EvZPqZS32ZZnszR7bg17uEq8tNjZrtYN7y2r4gaQe
25392	payment	1397	1397	1678	1	1	10692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwsGAPzXWuWzhn8QyYhPS1KB7F78cjKEq94pmknibwotQZf6z
25393	payment	2133	2133	1874	1	1	1514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRv1aW3kvjSqXUm3b77kKR2viP3U5rc6JVvbcuvN7AAZEBU9v2
25272	payment	1397	1397	1678	1	1	10650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QigEU4NSuiZSMhyDDcwYp2qRtRjbMG8WJSWf65TeJAow2L9E
25273	payment	2134	2134	1874	1	1	1713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6wDdZACVHNeydaeUDjegm7rxmATqjKBaNiVECCJKivxnk8EV
25274	payment	2132	2132	1874	1	1	437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68uigMLQRkip9V6dc13FmrxCGJQqSakp6uv7W2UiFuDJAKiBy
25282	payment	1397	1397	1678	1	1	10654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7Zc4UYzwgza3o2jUtN2E1hUTJrUecXtqvVAN6BmWFyXvCj5z
25283	payment	2134	2134	1874	1	1	1717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwGhJZbUtY5SD5R9MjALLEZUfF4abdK1e8LVoPxqptSNtA4CS
25289	payment	1397	1397	1678	1	1	10657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrQFg3JkwF3MtkFP1G6GuJ1VywVqrteVqSAnfh36AmM1u4EMs
25290	payment	1397	1397	1678	1	1	10658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjes6RGE1maY17tShqmKdxMQGmA6a1ygCp8RMpyxXxFRxCqE3J
25291	payment	2134	2134	1874	1	1	1720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Wm2ovZhQ8BSiWjJXfi5TE71T5hAN3S1H1m2qLBrdcGmeqYw6
25292	payment	2134	2134	1874	1	1	1721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpUef5GSvqK7q7vCt6NaCRvvWz7G6nmJvehjVJ8xkmzSru2K7
25293	payment	1397	1397	1678	1	1	10659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGDYRXtNUbxeHLmh4FL72a1vKbxxVtv2FtEp9eub4ho2ANZH4
25294	payment	2134	2134	1874	1	1	1722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyKC5rPVbHesPreViM8YzAvsPVRqAAZg75UCPAFMQZknzPokG
25312	payment	1397	1397	1678	1	1	10667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqRXn4r5NSMURTdWhGpa75s2b9YAiCiKsSMs3i3Q5CxWMJDRZ
25313	payment	2133	2133	1874	1	1	1489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRsxdwMp5X9LShnXxqYnYi62aXGoLv1kinbnHwQEfc9tUo9fT
25314	payment	2134	2134	1874	1	1	1729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHuxmJYcyMM3UerjNRyWybnh782utWcuNDtK8rcE8M4iewJbM
25315	payment	1397	1397	1678	1	1	10668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Nvec65nZSLkrxXAMgaYhmz8egeKSXexMGmY8RourueZsKJ1N
25316	payment	1397	1397	1678	1	1	10669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCVF7HET7TQhKm7FtV8imz9qFf4hWferz6A1Xyt7Sfe4F2bGV
25317	payment	1397	1397	1678	1	1	10670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMbQhUumhpFyhNR4eBs6ca959YRKeTQWjfJPq9dXvhzX8fmuV
25318	payment	2132	2132	1874	1	1	443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUrDrESgfwFg52htcGebepy7RjVN6ri1QzBEbiRuUgpKw2TQU
25319	payment	2134	2134	1874	1	1	1730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQscJSXSPE18igHsMGz6nPyUSbZe9BZTqKUaSrjVVjoZaNDhU
25320	payment	2133	2133	1874	1	1	1490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tVMdFi2rkjCScEZVth8mNpGZb5s57gCe4vjfhDKCAANvEPsm
25321	payment	2133	2133	1874	1	1	1491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVbze25qBGH3GS9DMUgtK5NaE55MxLHyoLfeMwoDhfAXkXZkb
25322	payment	2134	2134	1874	1	1	1731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYr5AUxUuoDM2hRSsfo7ki242G7VRtRB4ioQXtRVb6XDhu2WBs
25323	payment	2133	2133	1874	1	1	1492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrMMbAHVBwgjLHEXvnM8Nd6HCB8JM5ikFAyNx9TW2nGNakvBw
25324	payment	2134	2134	1874	1	1	1732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdpwPFpy8erhpNPsShkRPS1MSuw5nFVJnrURFYagREGB1ZjPH
25335	payment	1397	1397	1678	1	1	10674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDGbUgh72DWg6ePxG2JNLU8jQLLSHzJmPJT8JJKJomzsNKRrg
25336	payment	2133	2133	1874	1	1	1496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgeGWCyPNjL9mv1fNCeRLHVXZoEeKwSv26dTXi9tyn1nVkz7J
25337	payment	2134	2134	1874	1	1	1736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYpDQGXzEfrYfLwfbo2SsPzavfgdEDzvVZuy7ovjU19LMB9va
25338	payment	1397	1397	1678	1	1	10675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Hoxx4hjBtmoMyoeyrqBV5uFemDzSR97eQn8Zskkgq7CeNDT6
25339	payment	2133	2133	1874	1	1	1497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwA27ULkGfeXQdN8wzHT235Xpjc4frwpFiUM57AY21Dhug8FL
25357	payment	1397	1397	1678	1	1	10681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLbsQqVgnkLw8MwJvsU67KVWumnZPHNqrTtGYGWsFFYeThSru
25358	payment	2134	2134	1874	1	1	1742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGk4y7cESUuP6z3UrBU8AANkVdNBmBmfA1J1ZN3FqwfZ8KdLP
25359	payment	2133	2133	1874	1	1	1503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZ148eCsY4sq2KBBW9Xyx2apAXTZRzGy7UfCE2ZFohiFz67Q7
25379	payment	1397	1397	1678	1	1	10688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpbP4sgDAQCYevB25DMjV3XnEmXsMALz3ZGiFa8LzmPeJ28WU
25380	payment	2133	2133	1874	1	1	1510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9gfpBE8HtFehNitesrJwps3xF6upFjuxcB261BsLSgHPcHyW
25381	payment	2134	2134	1874	1	1	1748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPs9DJGE6DfMg9vrhNdtLbHC4x5YoAvASFdyeZwijR7vKbutcN
25382	payment	1397	1397	1678	1	1	10689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkamPJDsSbLuvSU6jHiDbUVdafEgjWuLyj6SsHMmBMgzZfFjwu
25383	payment	2133	2133	1874	1	1	1511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeShHp3NDBS8AEGvEjiQBXHNRWUie4vBZ5AfXA1MYDnfAHauMB
25384	payment	2134	2134	1874	1	1	1749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZB9Gw3rtfZS3b2LEbiVs2UBU6TgcWXJ5R3vvPUVuHjJdSCrrX
25376	payment	2132	2132	1874	1	1	448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngaZZA7a7YNgujsiSivvhjhgyYMy9XuVx1k2cDyEiM1N1oa8X
25377	payment	2134	2134	1874	1	1	1747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LGLde7uxy96rR6MCVgBexxfDm6Riufs5CgbhsY9oun8JurVo
25378	payment	2133	2133	1874	1	1	1509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLabojkPJ7vdUyDyww7Mf37KevtuYwYzYuxQFrnSRAe13b7Hah
25385	payment	1397	1397	1678	1	1	10690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpjHPB7MBLLLL2EHbsVjWYNtKTXY4qvLtG6HyHb7W7vmfWFaT
25386	payment	2134	2134	1874	1	1	1750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwJokpUBKbd6rbSGLwme3L4JQYiwCfBTfFAFnhd6xHDrSfqLv
25387	payment	2132	2132	1874	1	1	449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRLW5ViPksDFvXHZjXzTCdHGXAHU3uSSo74hPoGNdtxa18JDZ
25441	payment	1397	1397	1678	1	1	10706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK87z74CvktgD5MDBdAGRs6oyG1LT2x1H18LsHqMQJbL76LBCa
25442	payment	2132	2132	1874	1	1	454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7mPUpBT1zNqVo7DVWs4QoNH856ox3Wt9nKjD5H5PAqqyM3gg
25443	payment	2133	2133	1874	1	1	1529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4pyLnAqL32xpzLVbdqkecVnnZkjaxd2c2oaAVacGqfhN3FKx
25444	payment	2134	2134	1874	1	1	1766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEwsZcKrCVzkYBjRmaw31ckEgw9wAcSEmu12CtThDPqGvbi5Ai
25490	payment	1397	1397	1678	1	1	10720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Y1GKzpkxyvw7KAKEUtmb9cc9cu1bCRz1kVEBBa6mDohHTfQW
25491	payment	2133	2133	1874	1	1	1543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJAJAJPjbAhn4fuZkp1kDVhNRxj1cevh9fxJvTafMoSRx1CiJ
25492	payment	2134	2134	1874	1	1	1779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5gtKNn5z84eTCsN5troWyyqyKm7VaXsSceshJvcUwisPRaoJ
25501	payment	1397	1397	1678	1	1	10723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdAAXFU5z12juYHyFMCQ2hLyTSbQ8DaBtTyny2gm9Wy1keu9x
25502	payment	1397	1397	1678	1	1	10724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfdbedY1w7JbEhEqBS2Arj1fDKhFadr1hs5w7c7rq6PWH7fCD
25503	delegation	2185	2185	1403	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6W2chxiBPbPbkfKBuv4VNpEx8vVXnkupdoQUNrbV4GDc9swmF
25504	payment	2134	2134	1874	1	1	1781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhS3AwFTBGngPcZbA1aJBZxAjNFCT9qe5gZXa1ZqiydJEgWCLh
25505	payment	2134	2134	1874	1	1	1782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvv3csAnsNdebo83SqScCGb97tXhJzN9RjCroyyYJWGq4GhCZe
25506	payment	2133	2133	1874	1	1	1546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67wk2tUop5UYEK3UZtgwvjLbKj9AqFxpf3JF1UzR9uri53EqK
25507	payment	2133	2133	1874	1	1	1547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS2v4wATLVicRLRKweiA2fSpffBsGRrfEg1CyemU7E9M3F6uSC
25518	payment	1715	1715	1715	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTT2SsNqbZAz8FiBXsTjYkA8ia1uEjRF4SpA1b1P811AYa3eAs
25519	payment	1397	1397	1678	1	1	10728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFnjrrvcQUV8n2kp67j54EM6dMYmoPVnoP3pbf4iiki1zwHx8
25520	payment	2134	2134	1874	1	1	1786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRruJC47bEN7hUdV9hTims3nN4fmup1uSP73RpqjssHZRYG42w
25521	payment	2133	2133	1874	1	1	1551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZteXHspfytTTs2Z7zy1R34hxNJf7hV86LcurdaXdHWFt6XH8gJ
25529	payment	1397	1397	1678	1	1	10731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeV6JrvNqKW38itJLUT5C6pP9Axdi4sBhHgb95i8qH8v6nrgz
25530	payment	2133	2133	1874	1	1	1554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XJgejSjk8s2g5ga9JfQDsqqeZv3JcMvXNfCLrvLyxGtDJxqh
25531	payment	2134	2134	1874	1	1	1789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QVqkwWdLMqFkQBBjrB5W5GdSY9mE2557ZQS1PTcF2Ha2zsN7
25538	payment	1715	1715	2186	1	1	1	1100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZ28SHp516TJDo73Uv6gUdvT3We58sbAbcW4whQns2aPLwtCe
25539	payment	1397	1397	1678	1	1	10734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPxCS2RL6pnFkh3ZjbfQrw4ca4GBm2qZmTAYMGshLsRyJrbRH
25540	payment	1397	1397	1678	1	1	10735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1obnKFg5Jyv2j8xc4DSwvGVQLaH1iVmaf8G8XCMvzChS9gtj2
25541	payment	2133	2133	1874	1	1	1557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSabAhWVd6cx6PbY5YDzbkYfP6s86UrDvZVEavSoJqsgLQ3i2
25542	payment	2134	2134	1874	1	1	1791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVypJx9f8BuxCAnd4mriKmwopwbsb3wVWznCLBLgJmgzNbCcw
25543	payment	2134	2134	1874	1	1	1792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwUrZeXVJ2ob9x23FV4kcTitU4TwmwHkAjaBJ26LjN3mNxARv
25544	payment	2133	2133	1874	1	1	1558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnriCUDYkuYmoDqe2Gzs1k1wcFvMMJdekDmsSg77YPkn9wSuH
25572	payment	1397	1397	1678	1	1	10744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcdHJXQFAJYrCV9vhR7VYodzkW6PS3rLYiTNSGN5maKBZXVLw
25573	payment	2134	2134	1874	1	1	1801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxmnRZY62nwjezagP88ZyXqp9UZwaCFH6BMyXZV8eU7DcLqJZ
25574	payment	2133	2133	1874	1	1	1567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ngi21BefSaBKhpvKMtSLvDSvAgdw1sjeWX4ph9CA4pfXG7of
25582	payment	1397	1397	1678	1	1	10747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWXdHZkbfpMG4U6bdVU586C2zmYyyM6ZTnHF6oUoYRFQpTqAb
25388	payment	2133	2133	1874	1	1	1512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7fUWkxk8UZpPxXX3Hni5bq2414T5ukCkpjcvbjS47NwQSXhw
25401	payment	1397	1397	1678	1	1	10695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa813QaKhYhYDAcfiZfreE4bXdkHU2tFnbpjx5JGy5w8bNCh4jN
25402	payment	1397	1397	1678	1	1	10696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JSboDBjZsRjmvC2PMdTpuAV4zcRMMfxMkvvikKR9a39pS2hw
25403	payment	1397	1397	1678	1	1	10697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsonCnbEvemXp9JwPSQRXbziVjWmYYSq5SMrv754PjHX7LNwD9
25404	payment	1726	1726	2172	1	1	8199	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaB3jLWXjWhuBYngdsJHp5VKkCrQaqPE9KVHzbCGbae5Phxc2xy
25405	payment	2133	2133	1874	1	1	1517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqwaGwpzbLSumRU14riSyPHKBKYmxhvruetxMqNoenXRK9rNgC
25406	payment	2134	2134	1874	1	1	1754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgupyiTvy9bo4Ht2uoqtT8RgomjEyyFij5TTvz29imbbPKBS9
25407	payment	2134	2134	1874	1	1	1755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFCPXvq81ZVW1DpXW4MVfBU42UHG3Ryebrk6oSXfscX7jC8X3
25408	payment	2134	2134	1874	1	1	1756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9s1YnLRnCF3eumk3mhAR4pY6RoahdKvkGECXcCcnLejZHUyC
25409	payment	2133	2133	1874	1	1	1518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQc13XvWRUDaKshx6pDNH16GRXCnn8yQ8i91xymhjHGiqzonLp
25410	payment	2133	2133	1874	1	1	1519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGwQAz3VBDhnYVFsBhwUBbFdyWtKzLu5Rmx38a3ZYxzTXBWym
25411	payment	2132	2132	1874	1	1	451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zJR75DmKprazJpzN5vtisb4xAvMrvGuUtapNyCvr3h7ZvS15
25415	payment	1397	1397	1678	1	1	10699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFE1xDdjqDDBEXeEd1491f4tFt2QpSnAP9A9yUL1Durv4iSznh
25416	payment	1397	1397	1678	1	1	10700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRBx5ZN648JhcCAKAshFSZM3n71mhpSznA7EiDQ561PB4FGqr
25417	payment	2133	2133	1874	1	1	1521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1LRCaQXqdEjfz9DyMQpz4ua5DtL4P6hmoTgcsc6h4r2G2ntt7
25418	payment	2132	2132	1874	1	1	452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jAZ3aiqJr3PVEhB7iC56LmZ2kswMiUwnQrbx3LwRtM3wvq2c
25419	payment	2134	2134	1874	1	1	1758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8EJjVFe5hLVo5fTzLAjrbkCXRUbw5iHtbbjnYWiRjicUZYyo
25420	payment	2134	2134	1874	1	1	1759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsbaDnc3YRvnCjwW42QPFAswAxRGZfMbbEXUQo67miva2x5Wx4
25421	payment	2133	2133	1874	1	1	1522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvR9ju1hLYDKDhLcL3MCEEYEe2gbt9bvbTszqDv2BzbFRz7Nh
25422	payment	2172	2172	2131	1	1	0	1000	1000000	\N	E4YcySJT1WGmuhcG6AEJxqNugEZpwzw37YqJxFbfoULmQKUCtFYPW	CkpZdVyPkRJHVNaQYbkctxA284wzMBf4EDrw7HNCg3c1oHMqbaQRE
25423	payment	1397	1397	1678	1	1	10701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctTZFC9G4mTx42YGHrVtRxyTFzctH6uggbp1EcxpyB29srvBB
25424	payment	1397	1397	1678	1	1	10702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDdBU9KGzfFZwspS1wC8fqnraye5tFHF51CCSNMCjAqnGuQUx
25425	payment	1397	1397	1678	1	1	10703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiqsiVdjxw7B9XCVGbqA9jvcnvwWEgQWqHiBCKZ6LVhEsk8Nw
25426	payment	1397	1397	1678	1	1	10704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp977wqxnnTxqC9LDZbr1MrdtWvjkN8n9zmJxKiL1YAarDPbkf
25427	payment	2132	2132	1874	1	1	453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UsHzGhoSnwbs8ryjJjygr5MkFto7DQxZyv3XzmyGKb26kVcv
25428	payment	2134	2134	1874	1	1	1760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WbDxwJKv4S7vvNMtRgVVBwFrGKRTp92JA2QBNNE9w2Nmw1m3
25429	payment	2134	2134	1874	1	1	1761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXVdBRSqBr5vefwapRJASgu3o6U7emXjVNShBnNr2zprov1gn
25430	payment	2134	2134	1874	1	1	1762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPe6Gdr9VAKqLCWfZtra2V7oZGnUJbPWbDVDht3b8eb9bwZGq4
25431	payment	2134	2134	1874	1	1	1763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKNK8CdUCvLfdQAA89S8WZGr88hnibUk3Hv54uDXGZccYRgzSo
25432	payment	2134	2134	1874	1	1	1764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56zCKsMPcdZgUbPqCSBEttjictWUMdFhqXfVJJryvSV9ZBFao
25445	payment	1397	1397	1678	1	1	10707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKPbjJUkeCoCa9hY5UsLaf5Njjvrd7vZMcWq6AxJFYiSJ65Z2
25446	payment	2133	2133	1874	1	1	1530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ZKc71HjxZPN9ZFMHfDijcd12pkoimKwXXEWRSaD57e3o1igK
25462	payment	1397	1397	1678	1	1	10712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfQBDz52RwNwMeAjpPKYFX5gSRkYc9NxGhQwmkwQNZGdujn32
25463	payment	2133	2133	1874	1	1	1535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnmmDh8VxvGk6yjTwLafJ9Donhkms4GQArWgTN9a32gqRvUdK
25464	payment	2132	2132	1874	1	1	456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4xRp8QddYXm3jzYFR24T1XAtvnjA3Q8HLaMXagZjjaWxjbZa
25465	payment	2134	2134	1874	1	1	1771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrpbhsKKqWgBAEvpqSHxSrXydEmBn9AftQG8dfXPbMsKMJLjg
25493	payment	2035	2035	2035	1	1	0	100000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77oCzL8ZvKb6Dag6MNMoKzwD5mZi1FymP1Tq4Waqtg2PEPYWc
25494	payment	1397	1397	1678	1	1	10721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGTV3PFE9QJLN9o3ZAMVG12GPcBZFSwNnPxSbPB5Y6GCYyrhM
25399	payment	2133	2133	1874	1	1	1515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpnRhbQg3at6mvqerF6xtbUTH1Bu2js2P3vyWTTvPmfFRUYu8
25400	payment	2133	2133	1874	1	1	1516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBmdMKMNQ33NVBFttW72vZ3tJAdHefvYYq9dfPeAmdWgh2XMF
25412	payment	1397	1397	1678	1	1	10698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRudh5zCKR3J3wJrNkHo5yCbfsposCWBtWLxukuNeXYM9Dbdgj
25413	payment	2134	2134	1874	1	1	1757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHdp1zae1EtgWAsV2gQbUeCZoQiAzVAwJdnT1jeF8x57pEsRk
25433	payment	1397	1397	1678	1	1	10705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JTXJyrcb9Nwy5qzme39cdR9m9UDXxETD267tMW1VGW9UV8Yh
25434	payment	2133	2133	1874	1	1	1523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3thJEBnrvA7c1ucBwKFMnaKcGP2jhvDbcQswYU2911ZzUrVde
25435	payment	2134	2134	1874	1	1	1765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLdfu35yM3hn7tvQXG86s9L2xPyEV2PipmEMLRerTDNkvWfgTP
25436	payment	2133	2133	1874	1	1	1524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXigFfLnGprCKhWzdommiiAd1PKLkrbs17Erj2zsdHJNGKzPCT
25437	payment	2133	2133	1874	1	1	1525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirXXj8zEJYtT6qjfkDoz2TM4TnQ5dMXaqeNbT7ASiAk2A27Na
25438	payment	2133	2133	1874	1	1	1526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsxAV7Qj9UdmHWCZvQYFevczJb9uneRHfDC5iiYGncMYe7unNC
25439	payment	2133	2133	1874	1	1	1527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gLKj8A7xPJ42hxjCYuSXjdAujWJZPHhENeCk1LCMnRy2nzWp
25440	payment	2133	2133	1874	1	1	1528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqUcjpmrfL5fDiZtkSxoMPPfkT3nGTfFC6EHZVvxig9TnCuK4
25450	payment	1397	1397	1678	1	1	10709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oHEu1s5RNKfcQphqMcMSK2kkJafjE9BHBE7Xy467v1wvrTFi
25451	payment	2133	2133	1874	1	1	1532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXuxaYJuY63q6C6ALPyfivvRC2Vctg5edFBZSV98ZQR6i6b2CY
25452	payment	2132	2132	1874	1	1	455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonExnTgMk4XVzGrZcyuaCywpdnrXihimnXNJ8dQa1Pcq3W2Hs
25453	payment	2134	2134	1874	1	1	1768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rrTUPSEAcC39S8aQuwx353JXh1UVgevA8XVXqNkGmem6XGHM
25454	payment	1397	1397	1678	1	1	10710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBsgdiucnSGdFDGWFJj51dp3HJirWkiNXpUfQBybCAmV99JRn
25455	payment	1726	1726	2184	1	1	8200	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiEkEWwpUkm2MQZNSgjoaMAkaoFbRJMRCNFoWhxgSTgMPx7Zbw
25456	payment	2134	2134	1874	1	1	1769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ875JESrGDdHTC8Pruok9P4GwF8ejUgBci3S17UGKAWmHBPiZE
25457	payment	2133	2133	1874	1	1	1533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJ4yNp8ZjLwuVBTLJnWVUMk8YEB5DTsd52DRkhTRXY5s9wgaJ
25466	payment	1397	1397	1678	1	1	10713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfAcH9UR9wyCzRn7KAhRgCrxdXcPgmnhs8TAdgmkEReQXPwtt
25467	payment	1397	1397	1678	1	1	10714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCaZ6UwTEjme2qMy4ukscJ9GGQaHGXtfSFjw3wXThxwGrJSZC
25468	delegation	2184	2184	1402	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6JpRGkWZ3DrDtur54tJ1ZNXSJpiQtZ1N3F4ki1WZHi2CEEJG
25469	payment	2133	2133	1874	1	1	1536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCgMzLBWRr9e7u6LbpvAT17dKowFhss8ZaNY1FX3Yi868rWi6
25470	payment	2133	2133	1874	1	1	1537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSG6Hajr1Y8WvJh8yAMwqazngPSUoDGp5XoqyGLKk3orf546Q8
25471	payment	2134	2134	1874	1	1	1772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkng9frj4bjuATQBenKfJfSnsnoQ5d8YD6STRoNLDkBP4uAnR
25472	payment	2134	2134	1874	1	1	1773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFWFPgpiPeoz3VQpwpWss2M1dYWYPqLMBsvE3R2iUYShDCiWu
25473	payment	1397	1397	1678	1	1	10715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CaRNkBLZxera3s88SYtBUVvNiWig5MS6sm4FzRpiXJ6rVkj2
25474	payment	2134	2134	1874	1	1	1774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8BfKz2KxKRujbu4Wavaz896LKkGgiHcEjtojqJw8jqAYLVS3
25475	payment	2133	2133	1874	1	1	1538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHsJvJyL4g2xnXStkKDmCpKc53u2rhU2baKiPskY15mNFkFBG
25476	payment	1397	1397	1678	1	1	10716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TFSowFNHEf4neeyKNvumzbBZqi7DR6mSdsYEsRH3SX5BWiCg
25477	payment	2133	2133	1874	1	1	1539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTh8EQLNeJUiTwZsxkJ7MEaVt1Vg3KdZuKn5swMcFe4kvRsXU3
25478	payment	2134	2134	1874	1	1	1775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedNmW6E5RQs62RH5GeTgR32iNWHVsWzh1sfmKCRGnYiLd68WM
25479	payment	2132	2132	1874	1	1	457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoH2aVftBSfoYwp1tJh7rGejd8Ks8i9WK4YrVC79s6yEEcYmGW
25483	payment	1397	1397	1678	1	1	10718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZguY6ek6rrcUwrjq14kko2DyCvPmRyxVApKLQENA4C95vdVYxp
25484	payment	1397	1397	1678	1	1	10719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyhV44MaCoL79hmDDhe6V1XaXK2bRYXQs5EbgzNZLLNE5ZG5j
25485	payment	2132	2132	1874	1	1	458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKMi3cMsnc7vzKXta4FmsQgSHr8EJHqM99hBPLUDSLaUbSwr7
25486	payment	2133	2133	1874	1	1	1541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQn2FC3rAF7M7wbH6ZYsuSQBHSDz38JDYofR4v3uUCyVETo44
25414	payment	2133	2133	1874	1	1	1520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsy46obmg89aaszyAjzPaJF1r4odrQDSTpd7oZoexKpZCwQoE
25447	payment	1397	1397	1678	1	1	10708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnoSGj4JjFzRd2G5LGKG5gXVCgmkTuAPWCtZYq5CApG9Jk4nx
25448	payment	2134	2134	1874	1	1	1767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cdH7BFs1cJrYNmWG3gf1zosJbdDK73pLWjionsYqthtiYZSy
25449	payment	2133	2133	1874	1	1	1531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nBme44gANq5KYner1Nd5vSin935ou29cp24tU8WkfuSmMRiD
25458	payment	1397	1397	1678	1	1	10711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJdN2kDwDGbR2zNNqYCVWRVHRM1CX2cEsLc9moPEVZFnBknJH
25459	payment	2131	2131	2172	1	1	5	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	CkpYcCdTfVhwQdYHAAfHur8ejwt422UNxdGQP68cvKPgy8ZdApnXj
25460	payment	2134	2134	1874	1	1	1770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYb9bgytLr3xvpAio2UgbFyntVnsCsNxz1FAHgu5soijZAf2x
25461	payment	2133	2133	1874	1	1	1534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9UqZXJRz5JFtpdep5kGZuEh2YPoyVPW89biis8JgiBK8Nuk6
25480	payment	1397	1397	1678	1	1	10717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYwP3tJMEPfTBe2UTeqHY4fYnHTznQ6M3EPXRdMPdkLH9L6e9
25481	payment	2134	2134	1874	1	1	1776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfTKFgnj83Uy342seNJGPeU1M7yssHJ3dmP8Q4PsAqKoPdszR
25482	payment	2133	2133	1874	1	1	1540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLYTgugh3BLDLKsCfRkRFnmUqfLPNuY1ARadykMB9nidvzWSP
25498	payment	1397	1397	1678	1	1	10722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9FPx3Ed1NnnCYKXKBH7D3HKyo4av2AwQAvwehLgAW7c4Vuv7
25499	payment	2134	2134	1874	1	1	1780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkQjUvExfcpp5voKFPnTPCVbrKVqUqKVFKZwRnBkfEQTR7WNU
25500	payment	2132	2132	1874	1	1	459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPTjEdNm8QofqJC2c8noie7TEggRkeXzNFLYUG2Gk7HdLn9Md
25509	payment	1397	1397	1678	1	1	10725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyn4VgcV76y2DMHw9HD4DYk9kadia2J5bdUqaHbxint3MhExU8
25510	payment	2134	2134	1874	1	1	1783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4gDKudxBgdSRAzcu6PMDQSzLj6W53XJGkwiDCtRbrMoBQhsv
25526	payment	1397	1397	1678	1	1	10730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLEz4CyNjjgvwntgviMMWyVrVx1Lhbf2j73CVsbZSo6He3etB
25527	payment	2133	2133	1874	1	1	1553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMUYWNbxQ1yNDwLfpRbSPztxQRNcVPWMB7pTEPBnWTsiQzy9W
25528	payment	2134	2134	1874	1	1	1788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgU94Fpbp2t8fAiw9acJEj8EbHC8aJeMS3kfoRvAZGdMBvtrN
25535	payment	1397	1397	1678	1	1	10733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8V3TNkhQg3WJ5pbRfrd3rvJLLH4Jp9DkRDEicEoANiWNn3Wui
25536	payment	2132	2132	1874	1	1	462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbk8SeFFRTHQDJqB9DQaL3YS8fxaToaYwJ96T7rTNYsM74STg
25537	payment	2133	2133	1874	1	1	1556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZorNQb5DDTsSP8EBdwctdhAfpAn8KYL2QaLBkyFmBxZtnE25DM
25552	payment	1397	1397	1678	1	1	10738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKw8Xmj3ezLDzq46afztr8KinWXhKN6qjq3Jc3UtPvqNMvuva
25553	payment	2133	2133	1874	1	1	1561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaKK38oGYwt5MKvXdsrR2GSDK7WpSyGbq9We8rQ4LtqsaoANp
25554	payment	2134	2134	1874	1	1	1795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYJT4y3oGoQbavUY8EsuxNZyLKYTZwyPdEonR3XNPxQEmboHi
25562	payment	1397	1397	1678	1	1	10741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TLoi9z7HznKe2AwRHwAcn8HqgqL25PafQ39pqRzDLJTadbJH
25563	payment	2133	2133	1874	1	1	1564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVA1NfB174f4JcfX1xm6A5yeew5yNH8jfGJWiTAEjoBygayFS6
25564	payment	2134	2134	1874	1	1	1798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzCNvZjV2ojomm7Vfa2rikEmQUyQB1qH5x9cmCVWgaectfKak
25578	payment	1715	1715	2186	1	1	2	523957693786	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh3nCLe2BHYTK9UYmxx7ccvuKWRie4Awp5815Z5bwsceppDBPV
25579	payment	1397	1397	1678	1	1	10746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAyQLUKQbFsBysHosMdpRifpyQyUnNWrLJVgpEahh1YAt37uTS
25580	payment	2134	2134	1874	1	1	1803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyqfBVSyhbQGoCK7J2qTaZJ7ZjnVbyDq9CkRLr22jsZ2Cgtb5
25581	payment	2132	2132	1874	1	1	466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhM12J4AXMDHx1i6SEXFvs39cuZBtLHg7Hyde8pyEB9C8pUBS
25650	payment	1397	1397	1678	1	1	10769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGo4FHGoFQjnspKWxPC2edMoPcxR64vr7SzJxBapEUB1iqa8oJ
25651	payment	1397	1397	1678	1	1	10770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxAz98W8CNHwwtJQ8HdN4XFcZDic4bewvi9CDGuiNvBv3W3kX
25652	payment	2132	2132	1874	1	1	473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwJx8taSibN4XaBRNHyRMfrgb1jrvGyYjrgT1oWaNm7GBkcCm
25653	payment	2134	2134	1874	1	1	1823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4JTym35vmWNxgvabqcfYJq79FUmzHW55wVnWPgwMiwf8gExU
25654	payment	2134	2134	1874	1	1	1824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLCTCQuhyvXRcsaYBKnt7QEjeu4KesqCG7DUTjskcX7UjZft7
25668	payment	1397	1397	1678	1	1	10776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAobFY1BqrJQLYpNEFifDCxtp6nCi9Cf18SWE7SghejL2oo9j
25487	payment	2134	2134	1874	1	1	1777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHBc3hG4pec6yRo272dLGYPeBue767fnnegz6VHnULMQcqaNo
25488	payment	2134	2134	1874	1	1	1778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeVDnLTJtGsZebUYsNtP4Lun4PZcLAZ51tkWeUhjfD1dNst8V
25489	payment	2133	2133	1874	1	1	1542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UiPEWonbAPK5w4N5w4CyJDjM6fxKkEfQQNo4rR2qzFpiCVgx
25511	payment	1397	1397	1678	1	1	10726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAuczY6XVEbvUWjXeHSWiFwYkWA2vY9WnX5wC87yTMqSnwH6E
25512	payment	1397	1397	1678	1	1	10727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfypbeSue2r3yfPqDfVZn8qomTmiomVBp2vZepTNMKC8e9LxE
25513	payment	2134	2134	1874	1	1	1784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPYPBNcquavn1ZF7bsgsMYXkRX4gU55yCyQS8wY5wA3uzUBYk
25514	payment	2132	2132	1874	1	1	460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPeYjytwps5J1X4nqo4TCXw49gZQwGMsUfwJsHrTHnW5Ur79E2
25515	payment	2133	2133	1874	1	1	1549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTKrUnayk6VFyg7wzxXcAfMdqrsdKRo3TZ2UqUu36CJfvKpup
25516	payment	2133	2133	1874	1	1	1550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmexipiq1hYV7XTeF4Mp8TiJethwR4MUuMLLunEq6Yw1CVmguv
25517	payment	2134	2134	1874	1	1	1785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFphC8E9dmQde5dZPgu8hRAE5LyuPhs3zrBrSM3EgMUcGGWw2g
25532	payment	1397	1397	1678	1	1	10732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6QeUr9kwN7oGch4JcLMBnuuRYqC84v5Lz4pRQUKf9ugLzjuv
25533	payment	2133	2133	1874	1	1	1555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDrPNS4FUbfVLWG6o9qzJv2He72diYWHkmGhiybBkbc2D4esN
25534	payment	2134	2134	1874	1	1	1790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPzCDXSXkPL8HBRor9XqC2ajJAGdVWrdkhE1PSfqZRrFTVsHZ
25555	payment	1397	1397	1678	1	1	10739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb8pk6pkxT1SEYUK2aFzpjSnb11uZyAvMDjXC1z6wPuk1zXr5P
25556	payment	1397	1397	1678	1	1	10740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5gYq6Z4X1inCxZeg3BALoYnurK7xGhYAqCgjxdkdTyYAryxY
25557	payment	2133	2133	1874	1	1	1562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y69SsFKKqmQKFSm9v2BQB9JgFiEuaQnSMbD36KzMsYDASQEo
25558	payment	2134	2134	1874	1	1	1796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx2tNRtasotQSxvFKe61mpigb2r2A8G4VXbcjhDF7qTBGA6yk
25559	payment	2134	2134	1874	1	1	1797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4LN96FaunVTSkimjNNUB8eocKMrqK71QUgSEfMS4EDzPx5eM
25560	payment	2133	2133	1874	1	1	1563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkxrQjVaNyCU97qf8ro9JVcHyvb76dWquxgcwwU9fhjADnosy
25561	payment	2132	2132	1874	1	1	464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83SWWzX6e87cW82u63pwAWDL4EpkmVH8a12gFjSyvxfo1YzBZ
25568	payment	1397	1397	1678	1	1	10743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gQ7ZRdWB1aep9LJ4LF4FvJPn6h9B1qacXQ6JvXMTNV1N6HiZ
25569	payment	2132	2132	1874	1	1	465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEtekn6Dh19Sj2y3165g6aVGJt4LNRq1txrbx9vKsxa9zAfEJ
25570	payment	2133	2133	1874	1	1	1566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Bcv7i57GRepqRt2YgdsErE2CvQmanyTZq9Qsj3J52BsFD2Ft
25571	payment	2134	2134	1874	1	1	1800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAac3PcCwJX59ZbQLFrbw1APWXdMZ57yG6UXAbUKvy6CMLm7p
25594	payment	1715	1715	50	1	1	3	523957693786	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wLPDbhsKL8WH258pXgnYyuhDgeAvpN2ke626EydMoJEyBWsh
25595	payment	1397	1397	1678	1	1	10751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYky9tJWBKUZmyKiTRemekV9oB2mo3h9MvXeu2b1azUTaSFHrxd
25596	payment	2134	2134	1874	1	1	1807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJR69f5UyWK3f1N6TwqXpp5zKEYgdCiJXQnMm7rLBFKS5R5oL
25597	payment	2133	2133	1874	1	1	1573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFh3A4gstS6FtwqJEPN8PTD15KS5ybs5UEJw813YWgwdbXceis
25631	payment	2134	2134	1874	1	1	1816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpwucJ3kpQxoyrviqd8h28nmzAyCk48ZRtMVCv1nnxznrRkQ2
25632	payment	2134	2134	1874	1	1	1817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWf7rkrEoJ82gs3pnzoytfp3XcSCNKy3GAoU71D2ppVUMaXHSf
25633	payment	2133	2133	1874	1	1	1583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ygeQ949EhL6CoCFYVhAZDfkbg3x3R4toioxt2k2g3hgeZKu7
25637	payment	2134	2134	1874	1	1	1818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvU337DXhWQX8BnDHXbjy1fDA62EcDfYwcynMfqTBtTtKY1EN9
25638	payment	1397	1397	1678	1	1	10764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQH6zZm99YrCWQcA77KNq9puJsan3ccy1kvWL6rmG6YHf4Mw9
25639	payment	2134	2134	1874	1	1	1819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJwJB82UWAsTs4PkZz9EUgd6c1ho9BuoETGbkjwCAFZu3uXZi
25647	payment	1397	1397	1678	1	1	10767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wJkswLEL77CTcVE7YnRVawyv5sWNfEVVEgqTvPtxfGCC7tLs
25648	payment	1397	1397	1678	1	1	10768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5ZWiUE1zQcL9N985hvjKQRYyyGXoXdR52e5fyMKnz8AFwoyg
25649	payment	2134	2134	1874	1	1	1822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBUzyDykyYqvuHLknVuFhPkgG6TJ34bXnC3cHvhM7SMRzVKNh
25657	payment	1726	1726	2187	1	1	8202	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYredrP6y7HaJnzzXKJ5DXmHnN8bRxh2wCnSdbExtZKZr9Uoucg
25495	payment	2133	2133	1874	1	1	1544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdPBkkk6xVJaxLLMH6bQ96DpowkAix3bhwpj3tyFdpzGgVhFi
25496	payment	1726	1726	2185	1	1	8201	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpmJpLmnjbdPB4VpSJfayLGhkMZKVdDkRRHiUDM4gHNveMtrmN
25497	payment	2133	2133	1874	1	1	1545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hGSyhhcXhdLfk8JunbWHTuGm7nmZWJhy5ri43rssmiNGJCNP
25508	payment	2133	2133	1874	1	1	1548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qoPLLds4R3VwpkN72UNWTneKeyzfsRBTmks5d8Baesfr39KQ
25522	payment	1397	1397	1678	1	1	10729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa368egyJSgjVNU6fsnFr8wbyRLCJZzN298APFkSskPG34SAbaM
25523	payment	2132	2132	1874	1	1	461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPqiifEk15EQhG9z28qkPc7GAh3q6mawpxhCPuBdsyU5phVPh
25524	payment	2133	2133	1874	1	1	1552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvezCC6U7qSwP4BYFG4yMMesiQ5uii8E6MHwJNnU1cbQorRjRU
25525	payment	2134	2134	1874	1	1	1787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oq48wRhNd4E2bZmynkjjuMEYBubmTGp2psimw6UtXY9DtvUM
25545	payment	1397	1397	1678	1	1	10736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKJiQNrE9wu1Ug5Ujy97V9yL7BKG8fegb5wA55MEjVt43zsFE
25546	payment	1397	1397	1678	1	1	10737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxxMb5XL91wSZfVQxJsbbMEVJwec8xsF5vv9m2NDBoQbT3RY8
25547	payment	2133	2133	1874	1	1	1559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP52nmPHkEYVfQxfDQznhFLDCf96WRZoPj8gKA9XzcC26VtJw7
25548	payment	2133	2133	1874	1	1	1560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAossiXVNs2ZaoTZNpWJ8GTX4FxvdzpHzUpNgNVRuhtPRHfGH1
25549	payment	2134	2134	1874	1	1	1793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMSS5DonAmVZKWnJRoREgfvc9iaBYrow9Hgj2YsLppzcezgrC
25550	payment	2134	2134	1874	1	1	1794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcwKFaiTqivHSjT1WPH2hd9okuxXqCdRLDVbCM2iQ6X3iEkc3j
25551	payment	2132	2132	1874	1	1	463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAZ8spZF97DtHcGoBignXJstJ6uCn2v7nP7a1Y1zyy3f7w7Ys
25565	payment	1397	1397	1678	1	1	10742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJGAWHPJy36SsdUHP5yoRZ87T4CNj6ZmXBuuwKdvaWDcovrH6
25566	payment	2133	2133	1874	1	1	1565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzzaCXWubrsMYgCxjQtvzD6s3QBR4PMMqG1m8pgxdjJgF8cQR
25567	payment	2134	2134	1874	1	1	1799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkAhQK6zjeMvubNa2a8KPH2sJfv1XfpYpr9bgcyMQXzgte725
25575	payment	1397	1397	1678	1	1	10745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47zW9aftDSZazdjiGdZNWLxWAxsHZGBPjTa8by9Ao34tjNaCn
25576	payment	2133	2133	1874	1	1	1568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8tCaJzgviXC3TM6Jt8TkPGb7opWm9gQTCUR4URRJDaY1i7B5A
25577	payment	2134	2134	1874	1	1	1802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxX25nbaRJywvFsiRTZj58A8DHUMmJ193FqvPwLEqCiuWvqoHG
25584	payment	1397	1397	1678	1	1	10748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGY1axk9TU7qvbckHdKYqesQ9meuEn5iH22jkQDiA1jPvKMB1E
25585	payment	1397	1397	1678	1	1	10749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8RVGk3BUWMUNAtvK1f9sHUgUepS9vnGyUe2yfVS6KAZc17xq
25586	payment	1397	1397	1678	1	1	10750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTE411GVobFeRH6jNLofKeTjFnkLiHS3UceJReMPYxMM7wYaRq
25587	payment	2133	2133	1874	1	1	1570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5R2jxKarnHS5oBUEtF78GUQ84nfDYUqLDQ9SWYTydpSxGPkM
25588	payment	2133	2133	1874	1	1	1571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJVUzHUAgu1DP4Mz92iwH67Kf6du1xZ2NsKG6R2T3XEqhWruQ
25589	payment	2132	2132	1874	1	1	467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV6FNpd38RBLfdVjSrDVepTBiyeBSCsvFNgxhAqQ6V6mPgpXE
25590	payment	2134	2134	1874	1	1	1804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMqU4xqkgHRFeazow6by4c86tPEDgpiVQNoaEmp71zpij1ckX
25591	payment	2133	2133	1874	1	1	1572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkE4WX3A3BBg54nbFL3qtG3YhR3ptZcBTg69KCfywn54uDqGU7
25592	payment	2134	2134	1874	1	1	1805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCz9S2PJaR6mWyvHNN1wak9RRmDWdWN8jAJR9m6ffYHh9LkWu
25593	payment	2134	2134	1874	1	1	1806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fhnW6pF6xguCFnteQQD5QRWVZeSUamrviz5mNkmbTpfMxeyp
25615	payment	1715	1715	694	1	1	4	523957693786	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTGbViHAH6EB5zSE6NJ9f3qi8Kh9ksDXQjyjZZnmH64e8sxyR
25616	payment	1397	1397	1678	1	1	10757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzdVAUgjFY2FthV3wVYkxzoC8EAAjhC2SuouNhJko7pRPH5bJ
25617	payment	2133	2133	1874	1	1	1579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AKZCqhF5wtAJohVAK4NZJHU2YgWp9rRge1xuLTzLRMmozyXo
25618	payment	2134	2134	1874	1	1	1813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBKgCeaJvKRPL7QGEQGug7SGM9cicUGKDzMEW4esXYFxAiBAev
25619	payment	1397	1397	1678	1	1	10758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvq6L4RUnDd1NkhZ6r4He9tbPnJMNcUEfF4dyK53NruJ8jUfpG
25620	payment	2134	2134	1874	1	1	1814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAes8oiXKSJNxkQyoQ7Xv7zCgTSGYaPLqJB3ofDAM1N7AZHcZu
25621	payment	2133	2133	1874	1	1	1580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKD9KXBb6E1RfnAeoZT37uzdS5Wh2rinPcoBBACdXnDpcaxcD
25583	payment	2133	2133	1874	1	1	1569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCsAeQQXvNyPAArWCTLss221JHcAwwbhZBbYodQXxTJGiXuUN
25598	payment	1397	1397	1678	1	1	10752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfaET5kf1TjEFuVB6kCgkv7ti5XU5Y6ASm6hFjp6SQJMFsuSm
25599	payment	1397	1397	1678	1	1	10753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkzj3XTDbpSpieNxnK9BAT9qdQ4ngmfrwPgxdL211rXKbsJ6W
25600	payment	1397	1397	1678	1	1	10754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJuAQmUXeiKPYSdCnmMbyTf8Tb7hK4cxozd1gFLFxJYQZu5Lq
25601	payment	1397	1397	1678	1	1	10755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwphDtn15m2m1hZReereDd9FUkwrtkVxUKsnLNB3wwwgt5t5C4
25602	payment	2134	2134	1874	1	1	1808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR5NR4h6XeLr8qSzytipz1L4nmSbCfFjGhRe55ZT7EopJsGYxk
25603	payment	2134	2134	1874	1	1	1809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZBciVgqh9LQJUHTWRaEvmwEw2ACLr2jp5i9DCkmZkNSqopoo
25604	payment	2134	2134	1874	1	1	1810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJtiqPeMhbtAoCZ2mdRM9PEUfZPADBmkSJZ5R5Ti4JPhMyurXp
25605	payment	2134	2134	1874	1	1	1811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiGqx9LuHDpWydTVNaBX2sqHwEr85MBLjPAAzGjdY5dPNvkA8
25606	payment	2133	2133	1874	1	1	1574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4C1hnDpxedQkSVXpk73JUUnjJJdvX8SH8FWaESYEgXtQxe7Hf
25607	payment	2133	2133	1874	1	1	1575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xZL1y6kgeyDFoEPRfHE8EUmsj4k497z74dys8F8hm96T1bbZ
25608	payment	2133	2133	1874	1	1	1576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJ84F83SDXKXFYBoXdFurYniMe7qEfCVyagmdeeJfeRcKL4UQ
25609	payment	2133	2133	1874	1	1	1577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6CeKJFvEUa9Wp6fUpoqh6n1UtYjBcBK68J4o9Wt4kGyyoDst
25610	payment	2132	2132	1874	1	1	468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvuoKJNFy4L71V2awtzoRvszdhS2zVXftNnjKmFfKESbgeaMP
25611	payment	1397	1397	1678	1	1	10756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqKLFzbjtFSwuGq77XtALnEEeVVXXUu3jSq3cATir77TPyVmi
25612	payment	2133	2133	1874	1	1	1578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTKPmSYKNguYRiGAMsDW2PZ7DX78G9HgTtfca9jU6XdjhPVuu
25613	payment	2134	2134	1874	1	1	1812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25U9khB5eQ5YtbiB8iZ4kf6zZuEmSKMnsmuDmSG23FhrgTfEa
25614	payment	2132	2132	1874	1	1	469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94sCTenThHFBWPPAVyczYWtyXMRMcq7JhTar1tfQjPXKM25Nn
25622	payment	1715	1715	1006	1	1	5	3788185563455	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQVFL2rLb8bVW38cTke4gMR839tp8YKUxfG8tx1nE2j1Pay7a
25623	payment	1397	1397	1678	1	1	10759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgh8Nw3YQbNBgGgzGZRnwtLZ8myux9x5JjE4vK18nq5CdHncdU
25624	payment	1397	1397	1678	1	1	10760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR5kr4Uj8WkhTz1K2MwY9MijTzZAPtoHBqWTBEbexg3r3eRQEq
25625	payment	2134	2134	1874	1	1	1815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfaHUaYW7ucrJabpvhCR3jXCZWFb6YnJPzqN4Jue4dDseUyF9
25626	payment	2132	2132	1874	1	1	470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEsKiTXAxwA34euUmW8PCUzuP3W6XsAkZSs5gizMMHBWDmAGfn
25627	payment	2133	2133	1874	1	1	1581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKjf3bJ5Yxaa2JQU4kk16ZU87xjkkzUZvNjXFqdSdMrsmtTcV
25628	payment	2133	2133	1874	1	1	1582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7yALcRyU94o2gQvvmJwtxsYF8bipANacrMYrzoBEZZmJEfiX
25634	payment	1715	1715	1126	1	1	6	6788396072558	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67Nyj8sjw9T7rbJUo9JGMZJ2C7YVgs3fWKY8xtqw6qkwSNZq4
25635	payment	1397	1397	1678	1	1	10763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2Qxs8hTJNw6EgcM2zYnmRDpkmvjz4aXMeAQ5moxpAkaxNmug
25636	payment	2132	2132	1874	1	1	471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPiGJLvKoHHz4uXXZFmL64EjsFrJG5Ff9tEBMiNihnvPz1kFy
25655	payment	1397	1397	1678	1	1	10771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJ4EVdHMsphNieDC98sduYH57N8EwHWBQyRpaJHXhkoGnCBHn
25656	payment	2134	2134	1874	1	1	1825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPmYiVYiMDbuV5t3RxSuZEDvqB5LXD3YC7133JohaJLHL7hFJ
25674	payment	1726	1726	2188	1	1	8203	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqoGYtco8rZ5uxbfYfT9Bb8Pf6M8NsNWdJJKtq4emcKeqc5bjA
25675	payment	1397	1397	1678	1	1	10779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuC7k2uGHh9aXviAFo2d2oB24MC6JPzkn73X2Qd1u8SFeAsDmD
25676	payment	1397	1397	1678	1	1	10780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSzYN8rDcnNG5WCCJfHV8YMTU1hd4LmCXroKJ9QRmyhSyUzy1
25677	payment	2134	2134	1874	1	1	1832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrktY1csA58FW4JUreRwowkiUD4PxWvgM7PWYRFatHehu1nJb4
25678	payment	2134	2134	1874	1	1	1833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cSo8ayW1Gucf3pkcFWs2fkVDqzyNgXJ6dgPs5YpB7cDc933X
25679	payment	2132	2132	1874	1	1	476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD239vYNKQu2aAhoqxxnVxgts2NGNBHF8nKATbYJfSQoXExFMu
25692	payment	1397	1397	1678	1	1	10787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ze6iHHcPUGBmNHGrEQQ4LJ41Spmcu3yqk6LZoiruf3j5V2wo
25693	payment	2134	2134	1874	1	1	1839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTFQ3zGLti6u1F7aMANc4C5yzXc1kmXQo6uSGD72r3CVw7D46
25629	payment	1397	1397	1678	1	1	10761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcidcFJXeU52qMxbs481LzF5u82raBv8qU8xfu5N5P38ygqveJ
25630	payment	1397	1397	1678	1	1	10762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRU6JR6pVbb1R6gvQjyRWVCGz326E7jU5jHNA5MYfy5BSrPtb8
25640	payment	1715	1715	1246	1	1	7	4580266098492	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FrFf45Qf9kkCc9BWEu6sb3N7XidJEkPRQYg4BfAyNrTABh9y
25641	payment	1397	1397	1678	1	1	10765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA92jk9sAdqqZMKgzU74Ls5RZ4FBmqABDNewkt5pjLw78TLDY2
25642	payment	2134	2134	1874	1	1	1820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZtTBLke5JZBJLHGL26iKd8YsvcNUv8NvfxzG65X2w1dBprcJ
25643	payment	1715	1715	1372	1	1	8	12763318738043	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNVoC3grM5doENUcH8JiTAnDw9EFm65C2yTT96pWjCSfuvPCQ
25644	payment	1397	1397	1678	1	1	10766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdNGZeDt3N8FUR6fx2nNZfj1MK5XHLcdD3QnExywPqWmgAvbb
25645	payment	2134	2134	1874	1	1	1821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh1ahmq2dWQEKVowzTE5PLngm8kp43RU4BT6xfcaxvNeWmsPqH
25646	payment	2132	2132	1874	1	1	472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wDA6sodK5jkHw9QuBJxM9XZQhjLoRXzeXeFZKzmWN89fXwN8
25680	payment	1397	1397	1678	1	1	10781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCRtd96AQXZzeqNNpBg9i7NC4e4hqPayNcbdoec6nGaXjvYBNn
25681	payment	2134	2134	1874	1	1	1834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWn9pqDuVc1m3CNHuMzZiZ2ht2SrLRyhx18pNx6FCnPr6BhmA
25689	payment	1397	1397	1678	1	1	10785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQ81xbBHRJQiYoxCwgZTNhVaZ8U1daUvwiurEaRC8LM9YBbou
25690	payment	2134	2134	1874	1	1	1838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3qpF8mB4mVHQnK3jYqbHEhHBsRiuNjxETq4eEncZHdJc4KsC
25697	payment	1397	1397	1678	1	1	10789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXU7gekTVyJQHqhSXiRXf8CUmEeC2kPVdLrjYjDtrFFrgLLKL
25698	payment	2134	2134	1874	1	1	1841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYwzts6yyhvHdY8cpzjRj1Su6txTzvThj5BygezsKM9g1x9jR
25699	payment	1397	1397	1678	1	1	10790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMv5vfrMPwMdkr7kd9CKMWSuy8Ub8BfLDxdLodyw4wR12R9LSR
25700	payment	2134	2134	1874	1	1	1842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkoED7F7EbVLNTdVcsDuSnDV1BAUu2uQYGb4Pyrei3gst7k2x
25701	payment	2132	2132	1874	1	1	479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfUgQrUmzbvbCwnrqxXpYn7JhDbSFXzfHDuWw3b544QrtfZhZ
25702	payment	1726	1726	2189	1	1	8204	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8eqE1GkGkjnr66BQba6ZT6js29Nk4DPrEbLNxHEgWG1YEAbTU
25703	payment	1397	1397	1678	1	1	10791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cGTnRjhQC7dSaBa7Z2jrkCp6C1hvMB4uZZfKKwp7nev6ZMkP
25704	payment	1397	1397	1678	1	1	10792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuuaKnuuf7XoySEYNHfZkfCfJdJSSgDoZgKFmPJeR49ZEP4Hk
25705	payment	1397	1397	1678	1	1	10793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7MtT9cutJV2URdoAfibdHM3jvMiujgvQo3aQNJv7quEQDCU2
25706	payment	1397	1397	1678	1	1	10794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZn1Cjb7zZkjNmFYna2o42LimGx6nKdmvPWPtyzBEz7vhvALJD
25707	payment	1397	1397	1678	1	1	10795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTaK7mpMV2vq1X7PYjGzm9QgwWoJrt8sS28t41ifN4i8zATKW
25708	payment	1397	1397	1678	1	1	10796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2q3BK6hhhMQEVbWHoCvQCYgfSxs958rYqjWEgvRA42fUNXQ3v
25709	payment	1397	1397	1678	1	1	10797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFceSGzfd7dqM3Rc7EjEGpAGpY39s13ZFx5xoCxkjorwyGbMHQ
25710	payment	2132	2132	1874	1	1	480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfTLtqKX3GX23sarDsT72BjqSDvRJKewV4isAPYEg1DkGBbT9
25711	payment	2134	2134	1874	1	1	1843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5D8dGii6R3wmFuiN5RDrKB4izUJ1XhPwyvb6wC2A3ireU2WA
25712	payment	2134	2134	1874	1	1	1844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LvQrauVpcjSZmxX1gRtGWQPdtez56CW7NYpQRq12jnwVEESS
25713	payment	2132	2132	1874	1	1	481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTo1DyCHCdPuepP45whUgdfab1S9hph9mzw53PZhocw7tmV2K
25714	payment	2134	2134	1874	1	1	1845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDex7bbL1qU3HJCzvjAEY3ovPTUT1TNfaNkHQPjs8MbH2mcNAn
25715	payment	2134	2134	1874	1	1	1846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLbTznj453uw45ziYEUCQFkzLbTVtVoPa3Pf6FNVKjnaiCdCS
25716	payment	2134	2134	1874	1	1	1847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvWyJgrXeyWf6sGQipnk4s29rRySdxhzK3GuPgb2W18y5JQn7
25717	payment	2134	2134	1874	1	1	1848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qEgNvkevxQyjrQSaLk7XmjjxjaGckd83AWkMrfhpDTvw2cis
25718	payment	2134	2134	1874	1	1	1849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXxA25jKb3Q3Uzb5WVenJGHCZvpJmfYXLCffacaUakjtbWdVC
25719	payment	1397	1397	1678	1	1	10798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvgBtMDxYfhjqwNHzEHVTkLkAmfRXcLuPC2SxjB2PvUg1Dowe
25720	payment	2134	2134	1874	1	1	1850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvU22kJedvn6XoSxwZBs4rEsHv8dDyyviULKDVwKuniuDPSwVv
25724	payment	1397	1397	1678	1	1	10801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZogEW89iv3haRStzrRkViALUPYR8PrFjcbye1VT4eMx9C4dTXY
25658	payment	1397	1397	1678	1	1	10772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1L1BhTnoaFvCVcFnqJ1KfzYKcLgGWyuztLNzVVPqWqjkAU8rJ
25659	payment	2134	2134	1874	1	1	1826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuj8HWjVptFRtu56fxbaRrNFpdccGCLsw9PFgDKY9X66f1Pke
25660	payment	849	849	2152	1	1	1	18181800000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pdRLgNSVE9dFspckJnF1HJfdZdRM84ZseNucPte8i4yy73GU
25661	payment	1397	1397	1678	1	1	10773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzpSJYzhLsuBmWbF6DLFVDNve6W23a3sfXGE8wkNxSAb2msHc
25662	payment	1397	1397	1678	1	1	10774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFySbBykiG862oePeJR9Q6Uck9PBv6nzwYocTYa85YkjrXRHDg
25663	payment	1397	1397	1678	1	1	10775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uSii9NDh2vDVVpeq4WEsBSid3ugsayYd7ydskobLwqGnHA3N
25664	payment	2134	2134	1874	1	1	1827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsBsiij34TzaLVKGMXaam6YQezUPfYhCfkw4G9TCdnxEALnBB
25665	payment	2134	2134	1874	1	1	1828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDVuaefZevw8aC46tqnXBCHJVFdY9Tf4NZAhvd1tQWBujpeAX
25666	payment	2134	2134	1874	1	1	1829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZgD2BjsuNyD88Mm6cD3h1Rh1Wqqio15BgNUDcrUiWahQqDQc
25667	payment	2132	2132	1874	1	1	474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNfN2aBTeiJxqF3cpzVp4xc4mmkaeXhVbHvaDX26yTVHQbDB8
25682	payment	1397	1397	1678	1	1	10782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BytDFtXHCSShGDtKSNDmXsiz7bjxNCFWw4pxheFXqNkrNoF3
25683	payment	1397	1397	1678	1	1	10783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFoN8QqLtbVGNDZCEmpb1GeYQQNCLa8Cbft8pYGFC9PjcXKir
25684	payment	2132	2132	1874	1	1	477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT99W74LBAfujSJ6iznXbhVDgEVdjTTGK1HyWHEVmLxjALCB1z
25685	payment	2134	2134	1874	1	1	1835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPri4Xon7j9M6pqENo8dXk9HZALrXim6dq9ih21VUted8Urec
25686	payment	2134	2134	1874	1	1	1836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVVcpJLGyvDcA9gZEkHKSgmsFwf69vrWDLhszbTxS6FBCPkC8
25687	payment	1397	1397	1678	1	1	10784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpY28JHu9xuNyCjrW5KkR6wEoAtLweZNuz2icqs4RACf8qeSy
25688	payment	2134	2134	1874	1	1	1837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDgTRivysfVT9x42qban3z9Wm6mHq3d3xn4mEXqznXLPRtGBF
25695	payment	1397	1397	1678	1	1	10788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7x2rV1JYoXkWYKgjEQKPvcqQ7TZc3d5Y1gm7ad6BFXovZpBjD
25696	payment	2134	2134	1874	1	1	1840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTqiug42kfaYh7LweK5VRGtJhU5f9nSFTKGr5wZ7hya6KRLsj
25721	payment	1397	1397	1678	1	1	10799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3ZC89Mna48CEBgt7cDtdhi1ZUK34Pn88yBVaJgnzfjwxiwSp
25722	payment	1397	1397	1678	1	1	10800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL61dXjXNCmokGzEMXypzVM3LGN67cy5WByDQpkMrDAnKzmDym
25723	payment	2132	2132	1874	1	1	482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEfzpFuv4KsbmB18wZqBDSw78SfRAHjTEGiaZXQGbukoojAHb
25729	payment	1397	1397	1678	1	1	10803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qTwq4Cu76QVtjr1eM5vh49vzY4Y6Z4iDjP9LWm9MmESQX9YQ
25730	payment	2134	2134	1874	1	1	1854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs15ApHB8jcDG2mW6MFrDaktyYfx1bKLEu7iedGWByatEWJCfD
25731	payment	2132	2132	1874	1	1	483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbq6mfvvtwg2P5dpYbvWLXGrjTSgRAtJVnLJ5MACQtc4bzfRa
25749	payment	1397	1397	1678	1	1	10811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5vaE2P95j4dUfSQbsFYxASxLo8XB6jNr5rxiP58eP5G2e1ef
25750	payment	1397	1397	1678	1	1	10812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvvzB9w8j3P2AkUK5C2i4nWKCekgUUkEmP28cg8QEhE2ji4bG
25751	payment	2134	2134	1874	1	1	1862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBzjTLGj3umDeZskxUNTtfAuWooCA71dgMTVPnWCwBWmvZuXB
25752	payment	2134	2134	1874	1	1	1863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYUpKixqiQmNcSwa8sTezyJ8QgGpmoohEqFRL637apUpq27UZ
25758	payment	1397	1397	1678	1	1	10815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwz3rKZSdcDDnZVVdqPzx52ajHhLs1HbFt8Zv2W5nozRYxcXdv
25759	payment	2134	2134	1874	1	1	1866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFwGc5LkCSmY3N2nLmbzA7LT3GytFTKKbd5B7ahQmqkWUR4Mo
25802	payment	1397	1397	1678	1	1	10831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLtxucooRF8BAgS97tssrmxWm1GvrH3MeDdCVCzqqYRdsUP2Yo
25803	payment	2134	2134	1874	1	1	1883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31AJNcar5vtxCQCDsfoHoj6tTsJBCMsTHzjR4YSiLgWMXL4jH
25804	payment	2190	2190	1597	1	1	0	10000000	1000000	\N	E4YZZmcXsCRpcaxxB3FEydi3WJattSQQWWCcMmwR4TgJDk2CW1YMZ	CkpZ8qj2oADsvnx1q1z2of3XtNipCj2ggQ1m1QUccsRXsYztmrxBW
25814	payment	1397	1397	1678	1	1	10835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmsZw3jMpGraSPGWGjr9obTjZwd8Dpj43psBcyL129BorRfqoU
25815	payment	2134	2134	1874	1	1	1887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbE7D3Wt9Hbb8ngd5U2CYbkGCaJ5izvYyftb9g5S4EhguW3V1U
25823	payment	1397	1397	1678	1	1	10838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vwWV23GaZvytAokQCMtbHXJyug9XFt3Kf9VegniYPUWe6NUE
25824	payment	1474	1474	2193	1	1	17	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2Yuk7RtEnp43Zw8UmGgmwS4qNLnaB8c6RTUS73ELtFJHaidM
25669	payment	1397	1397	1678	1	1	10777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8HdicxUakfabQjZFYLkaQ1qMQdVQfctHgZnPEpKp8rz1ngN9
25670	payment	2134	2134	1874	1	1	1830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCffYH6kD3xxJhbdFBj43WhxQzuM5u2fVVjFiy7nqLKEz1R6N
25671	payment	2132	2132	1874	1	1	475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaKX9WJTssreCe5QxFxNvN3Xu48mDiybCPvz5gT9SZo8ucijE
25672	payment	1397	1397	1678	1	1	10778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8ZPn71Vk5UEwJkiMv9Ww1hhoo1oj13GWQ7wKokxj7LQioPLG
25673	payment	2134	2134	1874	1	1	1831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6FZK3Ab9DF6JYjvKUYJD3gmV9cpv2tQAFh1W6JVfjXh7BtPT
25691	payment	1397	1397	1678	1	1	10786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfG11kqpKQdaUXzuWa84ocyuSDLFoSPPmQs5BZ9vpMm8rSj2J
25737	payment	1397	1397	1678	1	1	10806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3F1XUfoJLuMofDm6zDqFX1E5xWMkxQSBgTUo12Bgd43v9xYcw
25738	payment	2134	2134	1874	1	1	1857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEHPGs18ryDuRTjZteguZdNxZjEiX9g4kp3cro3e7v5xEUXHq
25753	payment	1397	1397	1678	1	1	10813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9Riq9pYK58BWZLds8mW6djUKeycDGTPzPm6K1Z9LL9YVALJa
25754	payment	1397	1397	1678	1	1	10814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8HJypFTKjWnBM7BmxyEVsmAFdhApbFveJM24PyhmFhpVCRqV
25755	payment	2132	2132	1874	1	1	486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7RaNQXuiyjfouTdPyoASEL3BfZLRsZ2AwchWm33aeuWSVFaj
25756	payment	2134	2134	1874	1	1	1864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZc9WQkbi9UdihVpwKoPwhCyiZdyxAtDFQBszRspviHTSzUi9
25757	payment	2134	2134	1874	1	1	1865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDwBhXeLceE3CETatW5va9ThNCdF68a5oYdjdnxS29rZCqi5q
25760	payment	1397	1397	1678	1	1	10816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDTPt3pki4XYyKme3JocwwHLCyMkYqP3VKDdXqyVRv9TTYmX3
25761	payment	1397	1397	1678	1	1	10817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRa2z7aoBk98PLnm9Nokb9scijaoieHLA3LJ6PypwmedauQwa
25762	payment	1397	1397	1678	1	1	10818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJXgXqsnLLrR62D6YPmrxubKoHotQR1XqHWNgwYNP5KTP9j87
25763	payment	2134	2134	1874	1	1	1867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYTTg2zaC4Q5zHNwPp6MmLqtv4ATkJjr9VFgwUD3RMfngNXKG
25764	payment	2134	2134	1874	1	1	1868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWF9ti8hYBheW1GHUVyHPaw8BXsz3KLheEnzBCXN9k9oUx3SxV
25765	payment	2132	2132	1874	1	1	487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9pNSfijSM5U76LuvGpQVrM7nrdyC6XS4mgVCM28zGNTpg4wk
25766	payment	1597	1597	2190	1	1	3	2000000000	1000000	\N	E4YVcLG59cWG1h54yu3vNi5z8eXei7VNDc1FgCqkdS2wv4DtVs4e9	CkpYvGBGMargQwaXSVjipYodQQJdx8CXpKD9zPHbHxK5Njdd3opCY
25767	payment	2134	2134	1874	1	1	1869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpkq3NsSiKV2rmdJZJdmPPzQQqGDrnPz5dRBLvsFY3XkYaRoT
25772	payment	42	42	1235	1	1	6	2646259200000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJszwFdQc3oQMU2Y6hf1uE2Xr9eLWJtUzprEmWKFU2yy4XQBet
25773	payment	42	42	995	1	1	7	2188252800000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUY2nSrKqAbWXoQ5FxkTD3NGbtAmhnSFAp3WsWUGSKRTnTrqMN
25774	payment	1397	1397	1678	1	1	10820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2A9Rwo8PJPkhWj6CQzWzvabd9VqS6dUXaybyEPJv6J2PB5FFx
25775	payment	1397	1397	1678	1	1	10821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1xMALzfGoFtdoZQYzSyQN5Pd94o4a4xkCLcr8vG99Uiit4Vq
25776	payment	2134	2134	1874	1	1	1871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbh9KsVwSQj6gdsRzR148EQUN8xz2Yhm2uzf9zkiNPpaqaY134
25777	payment	2134	2134	1874	1	1	1872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrd5bLWj826QFJDBfZjKCvZzQ5qs6nw4t3A4uzUENyU7rsGwR
25778	payment	2132	2132	1874	1	1	488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2A6qxoKQYqu3zcsvyK75UWgH9LhchtTQLnE55GYP3nVSGx5KM
25779	payment	1397	1397	1678	1	1	10822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUa5Y4KynJpyQNiBFDioeerDVtTgZsjMjADjnzWASdWq3FNPT
25780	payment	2134	2134	1874	1	1	1873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkEzQVu1oEQnyquTPFxEkjjuaDfzYEsDUv6eN8X2t1C2nt24E
25786	payment	1397	1397	1678	1	1	10825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXULnXLWK2gBgUzsnutZazYXhVR71DX9SB1MLYb2ACRspf84gT
25787	payment	2134	2134	1874	1	1	1876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6estnVqvrcKdCVydUpotL1r7N2kQ2ACBy3SDhJbhA7WVaHMN
25788	payment	2134	2134	1874	1	1	1877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJWbi78EyeDbjXYNh5zpqc6pkuhCYyAp7NVverpNSRi9pZz9i
25805	payment	1397	1397	1678	1	1	10832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgr2tBbtv35qWLXdyW5essLfGmsPScHZVMR7Syrxuk1ym4nyB6
25806	payment	2134	2134	1874	1	1	1884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTCuqw6QWTrcDvvJnwyAFWzJCu5c2SdnVj7fx9J94YZ2LX99U
25807	payment	2157	2157	1929	1	1	21	162255000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe77jbA8W37hmueqWRiVAY9YSfWUA3pkDKE8c1YF3evkaS8dx
25816	payment	1397	1397	1678	1	1	10836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2FmgT3TYg8ypBiJtgYTxW5ZLhapVaV3XEvwRcdYBtYvV7qSi
25817	payment	1474	1474	2191	1	1	15	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6nBFnWdYBssFzVPdThiR5ivd94dPTssmoJhaQPoW1vGoXjh2y
25694	payment	2132	2132	1874	1	1	478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZatW64htc5XqCoNYty1cFsge2kHZwaHz3Pov17dvozUnWv1rJm
25739	payment	1397	1397	1678	1	1	10807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXwkPZjg17AgkqEk7TRf3tzURVzEuVEHgU3cAmefupfcL1t25
25740	payment	1397	1397	1678	1	1	10808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4h1bHaifFUZvWpVArsXq5HJ24EiJ2b3ZJk4KbgD8PA6o8bNi
25741	payment	2134	2134	1874	1	1	1858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtbLtzj6WQ6cMBx1VCGxSpbvAosKsQrBS46j1heXgD1HYRmhkW
25742	payment	2132	2132	1874	1	1	484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSVVBAjzwhzP1RGH3xQBURRELtFCGWPBQh49RUTVf7EA1sXoc
25743	payment	2134	2134	1874	1	1	1859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBJZdzy6Q56iQduYUaMpGsNWeHRfGyJBf9osrA9kHEG4AmDRf
25768	payment	42	42	1361	1	1	4	7372425600000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAoxtiZEixN1SLK2pVSpjrdft6S5FUAUwvn4XL8Wu68BgYtKrW
25769	payment	42	42	1115	1	1	5	3921782400000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLBVPLLAHqAJ9xS9FXLRAt69pGWwEZPMCroboQWEq92GFhCc6
25770	payment	1397	1397	1678	1	1	10819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YqCr4XVb8Lj4HQ8kVGANxQfhHN7KwhYinBM1NqUkJhB15rVo
25771	payment	2134	2134	1874	1	1	1870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknqw1dDTwdhqrPVgxamK1YQ5p8yMHR3BvDqMbfzcdUWnt463x
25781	payment	1397	1397	1678	1	1	10823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhAkhwKmEcBCtgV8EipQvwKAQr6EUYH81zWt9E9VoAQSe1soU
25782	payment	1397	1397	1678	1	1	10824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLfdL2wRT7NFHMTRNkimr7tzMqRrKvwzdfvPDvi3s5u1PAwZk
25783	payment	2134	2134	1874	1	1	1874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZikiTSX14LoMdmMwTFn7zkBBf7cjjGpdruHAg6UkrghwAfADB
25784	payment	2134	2134	1874	1	1	1875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQRmGsg3f5HTBEMrAX9UKWKaB8grWnNZFn1L9sadudbBP9Rix
25785	payment	2132	2132	1874	1	1	489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgWP1wiEdgrFgjR2q4b1Ek5aBLojJP8Gx5VEUXY5nGYbfiZao
25789	payment	1397	1397	1678	1	1	10826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEzKR3tiayhLyLMZWKsc96iCm1cnd7Y1bJwgsgpNsQ92MMxDw
25790	payment	2134	2134	1874	1	1	1878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVphQ3Krew2tTLDq9ehxKthWcL2BooggPZREBtXJ84L7sFsaiw
25791	payment	2132	2132	1874	1	1	490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxD1deKUGd7oXsf4nf7jf2Y5nERthCCzkY9NeYQy4akujb6DX
25796	payment	1397	1397	1678	1	1	10829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEMnyc2isWqXJMvWk2UR31mYBp2aA7pH87UfCZmnVY3FVsYbC
25797	payment	1397	1397	1678	1	1	10830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ReRF8iibDDYzbV7YNVzNNBb3GAtV56LBd6QUk3QxF8PHGu9Q
25798	payment	2132	2132	1874	1	1	491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXudWrmgNdPfXLd9e4vHpgkKBSCSnhSodir6pfXRj57DhrGzSC
25799	delegation	554	554	1611	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHi6Yr2pTeKZAC7FYXu4ocspYhHfj8vak1kaCZtHbn8pnYdc8
25800	payment	2134	2134	1874	1	1	1881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJmwbCMs6h5CkSHCZBfcrpzMRW3jmoWEokMucrR3ENiRsEXTT
25801	payment	2134	2134	1874	1	1	1882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cNKp7J2aGEuFimJ7RVSUC1Ppqfr2yaNoWYk3iaEmg8o24u96
25811	payment	1397	1397	1678	1	1	10834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnrcjPXe44S3xRwYjJmj1oxUdt896PPf7UK6ZFWyookjtDuz2
25812	payment	2134	2134	1874	1	1	1886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJupChsCQYeqKxDueJaqNmPBunnBDy8J1Jo8vdqavFFXoFhBG
25813	payment	1597	1597	2190	1	1	4	2150000000000	1000000	\N	E4YVe6YHEj4aA4ezSEaYkn1zMHYPNW7HWkzaudRUSLMMsBU6f6xbA	CkpZcgRskgtf3Ku6z8abgtHXtSJU8UtFRBvRJG9DfE9pTRXyJLkHU
25828	payment	1397	1397	1678	1	1	10839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwErPfu7uEHgf11FApwLbLaNP3v64pUzC8DhkjEYy2uKrnULxa
25829	payment	2132	2132	1874	1	1	494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQafJGf3EUQpVTuWJ94nmP6diaeXEZyYocL6UeGG8HQX1cUHu
25830	payment	2134	2134	1874	1	1	1891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54bXpkAunTMdmc5aac7H85QnHXHw8jXFqijmabXhCKyb8kASW
25848	payment	1932	1932	2196	1	1	3	598000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWC5ehA5MrTuB14D1LDJZySW9mpPkMskA9DF8x1oC64X5KUV3
25849	payment	2134	2134	1874	1	1	1899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTHtQjQQ5Smy16ZW5AFtXcBa4XcwkfAmvA7Qs36RT4u3JcHGb
25876	payment	1397	1397	1678	1	1	10859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnSXjT11xLR9n1y2oMJXY41C6jJcopB14sCpsyN1pwF55jQt1
25877	payment	2134	2134	1874	1	1	1911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZ5mqNVM7T7JWbD8NU8GKtYRKirBHL7oxoTeBSNQ14zeax1oV
25878	payment	1397	1397	1678	1	1	10860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Upp9mwf7AQabxAxgkoZ4Njr1gDXCZxRvc5AJnZau7tS6za8o
25879	payment	1397	1397	1678	1	1	10861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwD4weDggeHAP4TbGQg46xHWEkpJU27pUXVH8gXYgvPWvthBF
25880	payment	1397	1397	1678	1	1	10862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5dWRfE9EHrjZGxTyoN1XAEnos9TUgkPH4Aa5sKfY7z13diqE
25881	payment	2132	2132	1874	1	1	500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCjCQkVXvxCXdetywLXQDTRFdbJ7XasiLZteRpnnaZKc9KWiW
25725	payment	2134	2134	1874	1	1	1851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8zd993CU3XxDeNnXRaiCmD2xkviSSx7t7p7Heyen4TwqaYy6
25726	payment	2134	2134	1874	1	1	1852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDi42uK8r7cuwniUQQ9kHK9cXHhFdKJ7D42KYmnN86c3oVX7e
25727	payment	1397	1397	1678	1	1	10802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxJAj5YrmcriXP7GAyY91NjPwn64mUHHxXN8MS2NnfQDV5rWc
25728	payment	2134	2134	1874	1	1	1853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtgkDSz9ngvxzumZQd3g6kHb4tqmqd9DFjz6hjKiYNfisjRML
25732	payment	1397	1397	1678	1	1	10804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNt6kX8jZmTKCUQobnA4btktjWzSLgvBXRmazQMC5Gm4CqvVF
25733	payment	1397	1397	1678	1	1	10805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTV6z7iJYJNzT3Yaynhmaw28pL1ToQg5GsWznJuVinRToca24
25734	payment	1611	1611	975	1	1	1	2041700450000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEv7Ss6UNW3A1MC5BpjNZpQcAHXdZ2vJkhbXDGCUPvrftFNbM
25735	payment	2134	2134	1874	1	1	1855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSxKXwBFZ9YvuJthdBXRhEitpfMKaCb1XqAWb6a5ZCky7Y6F9z
25736	payment	2134	2134	1874	1	1	1856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgB3s6cvnf1wFXmHhBZaP6neFCXpuRwXc1p3H8VoW6useYKmXE
25744	payment	1397	1397	1678	1	1	10809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbrMD9d4EGkbrMf8fW7W7816VxcmWXRRKBhRzsFKwoXkTtSeF
25745	payment	1397	1397	1678	1	1	10810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9YkTXhPhWVA73YND9X6WPcEYQZoA3wPUGKjjfFDvB5LUP3AX
25746	payment	2134	2134	1874	1	1	1860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmhzR1S5z7ehqQtkfG9PfPCmUwwC3z675qiHtNEea5jqrN8Wg
25747	payment	2134	2134	1874	1	1	1861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiqK67hb4LJFhBzq5JQeMyzyvRnVL5VGiFNwV4SPmrm91oNfB
25748	payment	2132	2132	1874	1	1	485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zDDdCP8bKVxCJUyLsMPjq8kU9LtVK2vjKuam737JDbxEX6EX
25792	payment	1397	1397	1678	1	1	10827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHi2KBZUwHXtaXK8SqSexi9FqTDt8VMHrBNRwPLMnFEa9A52G
25793	payment	1397	1397	1678	1	1	10828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQYB3tZzfHaBEaqJZsjqkJ4RtpRTKub6GJFSNaLLfXD9zaYav
25794	payment	2134	2134	1874	1	1	1879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QiQytSwdv9jCj2g8yzE1oqxxgPWtv5f9iF7JnzZ3a5ig6Rqf
25795	payment	2134	2134	1874	1	1	1880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46oCVZa6pFiwMkhBTJByhzMgwVgG8v8viwXeF5PMPp3WB1R1Y
25808	payment	1397	1397	1678	1	1	10833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sPnRtisvk1mbtzcbxw6Vn8XSH3kbncj32nos9VMggqWyNyGD
25809	payment	2132	2132	1874	1	1	492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWogM3h8BDuzMSBnNav8QTL5VCZeMHgwLBn8ekUwuQAzmT3yZ
25810	payment	2134	2134	1874	1	1	1885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdECVECGVpsbqcm7xfPFgchGvUvLp3hd9CxADUNELsZVzvbsR
25850	payment	1397	1397	1678	1	1	10847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQEnKVfcu1gMHbDB1ju5VM21oWwpKNBopkMDno7RiB7aB2u6Y
25851	payment	1397	1397	1678	1	1	10848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXAyh7zVPRahiQRCANzFeLQA5SE2hDTbs2R8TABJfD3gtbYw8
25852	payment	2134	2134	1874	1	1	1900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MCfE7HQj39bNLH6z8sZMrjE1etwAVkMP2HyJfPeVDCvAhy6Y
25858	payment	1397	1397	1678	1	1	10851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GWMeSSooErny1Em5Zo8hUgTRdHT9SmRzt7QPVhXDiVnggAkE
25859	payment	1397	1397	1678	1	1	10852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYhkHim78MtkaWR77Lc9DSSPjrer4CHUEpCfQyZqA4b61gPUb
25860	payment	2134	2134	1874	1	1	1903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76FdJyAARfNP3ieREnjoX8Cb2D9MXpWgCz31uBoeQViD9jxbK
25861	payment	2134	2134	1874	1	1	1904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL4MBruXQpzqdzE5Wip2D4AvKguykZaSJ8RMhTvbDA841CXXA
25862	payment	1397	1397	1678	1	1	10853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbeuWHZfBjspZKgNnXvT325Pb3RvFnbBUxEkPTiVgxcWXUxbHf
25863	payment	2134	2134	1874	1	1	1905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrsZoBFkgH5zL5h1BgbHZVrXz7uorAVMF1xqVAoQwhXWpW9ber
25864	payment	2132	2132	1874	1	1	498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhdVvfxoYrf3ySAooFztUjhJ9MAyMpZ3KBszwCWympkbvCkAr
25869	payment	1397	1397	1678	1	1	10856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2QTRcmmAuzzKSohmRMfjxMJBh6C7KrRwVVz5FWyPcYEMPZFW
25870	payment	1397	1397	1678	1	1	10857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfuTeT4yjJacYbs1y2PQg9XNqo3vsjqr6obXNf8AnSBU1gg1s
25871	payment	2134	2134	1874	1	1	1908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPht47mJL7zXxPQMTknwNr4SewYd43Rg9dFEUb9YcfQ1hseec
25872	payment	2132	2132	1874	1	1	499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvn32nMLnoe2c64uRV2g3nE4UcsfnmDerJ9khm8WQvzkNewd4
25873	payment	2134	2134	1874	1	1	1909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmVkBF7RwkJRS3JFMd6xjapDCuwPTbL5XK6Lq4rMx7gcG4k7y
25885	payment	1397	1397	1678	1	1	10863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZX8CbEaXdMXj2dKFD6TwZzW7qkR6Twf5rq4hEgfHnecY9AHv
25886	payment	1397	1397	1678	1	1	10864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TJ9yoqSrKWd5z4xSbuFBJLRQrahzDH8pUhFcyLxXQSePSmMP
25818	payment	2134	2134	1874	1	1	1888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcT8f4qNrdqLRQpxjq9ghHJUXUK2FjXuFR1b3MzRhmyn9becXF
25819	payment	2132	2132	1874	1	1	493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvL1wUt9QHY4ofH7ACiqJwPH4AqptYUMKrHeCoajDUUdDtxrpE
25820	payment	1474	1474	2192	1	1	16	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa864C2aAe4oyVvg1ES9DAmTWkG4DNgfuz9W9erGE6pym4N5ccf
25821	payment	1397	1397	1678	1	1	10837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EXMJtETjaZU9pp1TTsugnEMk5PiinYNS1SSHbbSPgTfYw2to
25822	payment	2134	2134	1874	1	1	1889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6Lp4hp8LKnN6JGsTB8pDD3CHSVqSBnHnuP6UWxsAKHsohsW1
25831	payment	1397	1397	1678	1	1	10840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjChi35Tqd6cgj9qdVGAZycBG8y4CioGYXY9ehE6MVNM3dMdXz
25832	payment	1397	1397	1678	1	1	10841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6ceNmLD8swH7HL2Bi1gPkkDLS6BDqe2p9wp8Fkri5pjx4kci
25833	payment	1397	1397	1678	1	1	10842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWXVhLzkPywH7TwXeDVTjPEQ9eUDyFP5oKzAGAvExpCmoCGn6D
25834	payment	1397	1397	1678	1	1	10843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykWHME8bViN2WQoeAujLoNCkCoHVi4x7rTDqqGPRXyizqyQVG
25835	payment	1397	1397	1678	1	1	10844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNy5ChhC8S7opJrtKSvRt1JBm4MdYteBviNtXfb747Hqq4aFd
25836	payment	2134	2134	1874	1	1	1892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAdcTY8b8Sei12KLVTSSxZ8XAb6c1wPXoLxssF5Gt31ESq4iez
25837	payment	2132	2132	1874	1	1	495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5J1HXLXm9NBywRLyM2QGqjKJgv3hFnP8qnEDsnZthtZuKnsE
25838	payment	2134	2134	1874	1	1	1893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXyDmxsGutqqdHTWjwavDVhEukR6J49cbUjoKYtVw7kdghrA2
25839	payment	2134	2134	1874	1	1	1894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuhnGyxyV41SxUguFkNLFURW9LLuVS4W8UH4WrRyvbm5QREXj
25840	payment	2134	2134	1874	1	1	1895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yvYf12M4cKvpuCDxrJNB9NbK1FeYJZsgZP1mRRjTL9EhVXbc
25841	payment	2134	2134	1874	1	1	1896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGN79ibk88SN6hT4u76jUn3yvMBMiT8w3sfuQ1KSsaxPMxda3
25890	payment	1397	1397	1678	1	1	10865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEcSAwxGUHa38JcLKwb8vuybt1Snr6G3o192XacxHDHiHX8oD
25915	payment	1397	1397	1678	1	1	10876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnT4yKNFfeLi7ZPBYfTouQTaxGdj7Emjs6bMd5DF8tkmRmpgjY
25916	payment	2134	2134	1874	1	1	1927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMbq5hAPpGPwZ5sGN6QQVe2TRKUfuY5jasUqAPQ8nW5KWiYvg
25929	payment	1397	1397	1678	1	1	10881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5qR533AUaRmNnvFaEMke8BH8vPMMV7779YUAjmG2zTYHL3K8
25930	payment	2134	2134	1874	1	1	1932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFn16YLdS35TYXmSYW7ynKsoHHBT4kqD1iqXRLt5P6LByfpw5Q
25958	payment	1397	1397	1678	1	1	10893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TkMitjUHTB9R3WDZ3WcKNBao44wfkVTKvhebnnZRE6UDDF4T
25959	payment	112	112	1821	1	1	5	83000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHcDwjo5DVtnqKkSH9qfxtKy5Wz1di57Jz16PQXtQaHBjQRVh
25960	payment	2134	2134	1874	1	1	1944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XsRJksHYL3QEQDaenuh2xbHp8wzbMzzhui7PmzhaxPMPgQPj
25961	payment	112	112	1821	1	1	6	1904000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwHzrJzLtkuNeMWXb6pWka1pFo5Hyyj9L1akts76L9nvVKesv
25976	payment	1397	1397	1678	1	1	10900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLK8hfHjewfNeGEJS2fHK1Zv9hNMyhQsGrRKWkc9o2FwGmGh8e
25977	payment	1397	1397	1678	1	1	10901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5MgZysDohcJvJ8zijPBanTRRy76SDuAy3PXthEsJMHkqGHTw
25978	payment	2134	2134	1874	1	1	1951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQmf2kfeNoEPCC13NkZxSKmkBDceszPGShZevPvZ25ocDT7Kb
25979	payment	2134	2134	1874	1	1	1952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRtryq4sQZFy2XmLdWaqshb11iuVsr1LYnngLbf2ZKZvJEzoX
25980	payment	2132	2132	1874	1	1	512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXsnLUZNn3foaC6DBg8hadZrM9sWCcTsi3vCCfoGmapiEoxGSn
25985	payment	1726	1726	2198	1	1	8207	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYk2jE98DQHnKecSAxJd4iCPgMmLovPrDJV416n3iKgXB6v1vwh
25986	payment	1397	1397	1678	1	1	10904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDf5v4ZnFxEM3PoHzvwtNuQYQfS2tUNdx9vnctjGCDnjndfmv8
25987	payment	2132	2132	1874	1	1	513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYRtm9BaWiJadQhnM8nXLajchmTZknwkbVJuUs4tSATCCYdER
25988	payment	2134	2134	1874	1	1	1955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmrcA3mJrskxELpNEgdaTZjbhw2tePKKJCG71Zpoks1xrp99U
25989	payment	1397	1397	1678	1	1	10905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHMRYrvVjj1crdwNzLQxmpGu1hrEat1fTNt9A7yKT34szhgS4
25990	payment	2134	2134	1874	1	1	1956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW8hGED68195gPymaP8wLDAQRb2fFre8qjN9XaeKZJ2PbxBHD
25996	payment	1397	1397	1678	1	1	10908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55dfrupda42NPLxc9avzo2ATMtSBKBLrQKbFustt2bGrps9qC
25997	payment	849	849	2152	1	1	2	5000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXZUPq8BbTyQLvFW3wShZpqCBZM2EB438gahTuahki743suje
25825	payment	1474	1474	2194	1	1	18	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5k9bsYYmnS7dztAYkWFs4AUrweyM8QixxQtzvZg9En5zunWW
25826	payment	1474	1474	2195	1	1	19	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhs8PUB45hGDPHuY5TpY7L3jZ1tqzY3x31XnmUtPEovv3CbfW1
25827	payment	2134	2134	1874	1	1	1890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRdTADeA1bJxY3wTqJQ8Ndrhy8oMvChWzzAzXyTN9sgDjYRiD7
25842	payment	1397	1397	1678	1	1	10845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDHBy13HEL2U6jEhb9x5CDYqDzp6adfmZBmG1ot2r3my6jL3H
25843	payment	1932	1932	2196	1	1	2	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvXeuDau2UEZiVPmZMgY9AqABAAjD8ZA3PsHKzrtmx7uK3wCL
25844	payment	1397	1397	1678	1	1	10846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdktP3ecQDBYcdqg2tDoLWEMfxvbSkj7RGffTLEmbUQxHxt4hw
25845	payment	2134	2134	1874	1	1	1897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNPEXBGzFvuQ1yEYzTgyRUZjiRtKhpQcyRp6E1ATKb78mssP1
25846	payment	2134	2134	1874	1	1	1898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYv6MvN5FpBEW8svv6PQKA4CWCD8RpRx11zKBUSqmT9FZwFt62
25847	payment	2132	2132	1874	1	1	496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3ip4eDRCCYMZds5V9kPSFdF8saQFfbWF8kiEsqbTq14TRAqh
25853	payment	1397	1397	1678	1	1	10849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNs4CYGyu22UkBAynum9HsRq4cRpaY8JKKQFiSRBHvbz8V2jic
25854	payment	1397	1397	1678	1	1	10850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1qP1nM9sRBFWuC4emZJGQncu9bGCgqG5RHPX3rLadLd8Wfp9
25855	payment	2132	2132	1874	1	1	497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7zr4NqYxoeXcVuKnwEDCY1PtJ1M9GujU85tAWiYuyDTE5gabn
25856	payment	2134	2134	1874	1	1	1901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Uq1oKiUgCUe4F4HN5kTGah3CbozSkEvMfmBDBNzr4U2MvWxa
25857	payment	2134	2134	1874	1	1	1902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxSbvqnxRwo4imfugr2KcfkJw9DLwDJYUmuRP1eaDrKFz1AJw
25865	payment	1397	1397	1678	1	1	10854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3UCqFVrtNd7izU4CwqqEkzEgKH85Eird1E1n5ggmmwHds1FKu
25866	payment	1397	1397	1678	1	1	10855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDXLbV32yD1YoiQ9yC6VNgN2fYjyBWyngpBaCtu98UxAWqYKF8
25867	payment	2134	2134	1874	1	1	1906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5r6jrfj3kmNrHsvdP5mUjLxz3pswWnejZPtKPQnm3p3U2dw6
25868	payment	2134	2134	1874	1	1	1907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnTd8HZjnfiJ8kAVw5i1o7zLg8yExpsxrMudyDnrPj4t2S7rd
25874	payment	1397	1397	1678	1	1	10858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1kuysi9DegqTVTx5T4ZPCemSZxcnCUcv5CSd6rYaeJJKED8Z
25875	payment	2134	2134	1874	1	1	1910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6wJCCpQ5KcZVfYq3BvXVwGMpxLNUJ32JyeJ7LT1yu9qSpdYM
25891	payment	1397	1397	1678	1	1	10866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfJYZJuPaQc3JnkSjapRyZikyqUQVB9FEBMMXHs97cKvuuXWR
25892	payment	1397	1397	1678	1	1	10867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmF1Bz99wmkeMTZvCKuud4j3A9Z9cMCYCdefLKWxeLzwekY7rP
25893	payment	1397	1397	1678	1	1	10868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA2fydCnvLTuykzerg4tjcFuqiaNJbAkCGXicV39oZTdMfimi3
25894	payment	1397	1397	1678	1	1	10869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTbuymL2PeS6Gq8UvBkEUnj6Wj1DvyvG9JvzQwzrQhFUje7Hd
25895	payment	2132	2132	1874	1	1	502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVZdXpahb7oJjWW6nA1NrGnTGkiQxDbWVApsmzGC1vevwExMk
25896	payment	2134	2134	1874	1	1	1917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T34eJmMWsE9VZHj6nC2hZJc7yCGamEk4Uo8HgagCxAqNXMf7
25897	delegation	2190	2190	1597	1	1	1	\N	1000000	\N	E4YbWypda3atfZhudXvpUfcaDf1UYD6kjRNze5WueGnsMn2JQXz9q	CkpaA6L5oBbNubcKogesa7w9uoxJau1Rrt6cDUSjS787UqgypoZLH
25898	payment	2134	2134	1874	1	1	1918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgagcur7kodpsK5ncxqiSTycvAnvnRuPRZsCJfeLGLjkujvqe
25899	payment	2134	2134	1874	1	1	1919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApDgH8oLBEvW23L5f8PtpThFPrAXLWBqf1jrzskHyfQmsZUYv
25900	payment	2134	2134	1874	1	1	1920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXXLD5AiuBziDVPkpzzNkm1nRd4asmybxM3hRyivxiwHvNgqd
25901	payment	1397	1397	1678	1	1	10870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqN8vs9SAhRE4nXbS5mwPw2Cz6ZGJHJWJBqLcYhN6hGMgFbJqU
25902	payment	2134	2134	1874	1	1	1921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQdrzbSxhBoKmvMqiFYCaqgr8qkBdJkWXVFYLefWAY18oUVdV
25903	payment	2132	2132	1874	1	1	503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5DNsCgcZkkx6PQZZx626XsnqBgDurs5Njj8SPq8voDYap4F7
25911	payment	1397	1397	1678	1	1	10874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxPyhBs3CVKTrG1siSdXXUE31oATMqakQvQoWCUwiv3tB5bgv
25912	payment	1397	1397	1678	1	1	10875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLZ16E7bMcYm4BuZXArR1ULCKD1gP2bRZK4SR7BSV1L7GZJRo
25913	payment	2134	2134	1874	1	1	1925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXcpcp64SYK6VJckiakMmkpWRFPSeJD8i5Kri7c77wzu1jz7u
25914	payment	2134	2134	1874	1	1	1926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtHLrTLKPZbnzLVa9DAUz1qB6d4wHPqjB2umRf2bqYoThfneft
25931	payment	1397	1397	1678	1	1	10882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPXMKv5ETR7HrNhS2eWJfjGesHAUQoAfm8m7HAZ8bNFphQz4w
25882	payment	2134	2134	1874	1	1	1912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQQWQsvGK7M354HW7gKzcmch9Q5NkhPG2AirNdN9j5hjFSsKF
25883	payment	2134	2134	1874	1	1	1913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXiiL2cVCh3NbrrgjCFu9gUC882n1xXuXcfemD7X5gZKEkVBj
25884	payment	2134	2134	1874	1	1	1914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfN9MY2ij8U6WK5d4B9uWbhYMa6BUWVMZf2VvttZoGm26MGid
25904	payment	1397	1397	1678	1	1	10871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FRU7p5vUicUg8cWdLmah1jD5mqzmVjXvn1TVBYpVGifs1Pau
25905	payment	2134	2134	1874	1	1	1922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqeWcTf1vVvc42QKoz2r4q9kVYGziRPLUMj1r2h39hd7unSbKG
25920	payment	1397	1397	1678	1	1	10878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVddynK1H5yDFUi9DUqXbUpCuggb6ydqABZ9JvxKzgc9AWqLYV
25921	payment	1397	1397	1678	1	1	10879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekHyDpaaUnHBnKDEvQ4DmJ1uFDRa5FGvNzTnjXSLsFYKq3HKS
25922	payment	1726	1726	2157	1	1	8205	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZFWoVMV2DLS5AktxWy8RCLhawkxVCjo38c28HCu6hiDZMuTd18
25923	payment	1726	1726	2197	1	1	8206	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYidusLngXUWyCu4R9sKs47TRtC5wUmL1kV3oWxNDTk5HgFwbCR
25924	payment	2134	2134	1874	1	1	1929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNDxSn2ZE9DcQhgEvdXzJftygLK6AT5eKKexPNbupvb5oYJpq
25925	payment	2134	2134	1874	1	1	1930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKdA7mRce7ZKYyNtfu72B46MTfv3DmSKb4wcLSuU9Xf77tGkMK
25938	payment	1397	1397	1678	1	1	10885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3bsxBTTUH1qvLkp6v1hbdfWQ9nBpD8uf523v3LffvKCKqihD
25939	payment	1397	1397	1678	1	1	10886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1njUrk4WzNfN6sqKGGBPGrFEmiqRvYk24V4KwH6e6mxRiDe5K
25940	payment	2134	2134	1874	1	1	1936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSa1nCefYJ5dagJEXvkNexpdyRdw67qy5A7EQNdj223CZ25oUo
25941	payment	2134	2134	1874	1	1	1937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82yrjAR2DfKndr8gAoPvY812PunPvQcjykQmLE87jPju4qA6i
25949	payment	1397	1397	1678	1	1	10890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjU73JRb5VY5ZQmtDvPPNHYHCU1ZXEBryxdKQBxuHtn2Qx338P
25950	payment	2132	2132	1874	1	1	509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYparWGuAwWrLAktR2oAy9hgCUufXbo6M8t21YowSniNybxoXfC
25951	payment	1821	1821	756	1	1	1	500000000	1000000	\N	E4YtmZXB3QjBG7X5diSUBKkxjUPwbMS4YQACmYfGSqLvf4dtsQfpE	CkpZxeKZU8LurLU4bDntKjM9asCpPrHqr378B4KNwb4K3zyYf3CsS
25952	payment	2134	2134	1874	1	1	1941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9D8spi8qEqajfrLQUrEEXs4GoGoM2RHRbshdmqvXfz1gWPb5
25965	payment	1397	1397	1678	1	1	10895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgFFX4G92tuoBvBGdYQpLaJGezidPLVp5fkPjaFZqVxjNair7
25966	payment	2134	2134	1874	1	1	1946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjw9faffK9HYkQbtiK7sDVNvUeEWAkvMzcteaLNkXsntrcjjGC
25981	payment	1397	1397	1678	1	1	10902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyERrfYAViCo1NnzuKpr7PK3AyNLxAwLNyo81ZVMtYe7im4mW
25982	payment	2134	2134	1874	1	1	1953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgq3oaXiyvvNt6VZbp8dMCQPCkajvMrCiUU2KjZpvNbhF6F1m
26039	payment	1397	1397	1678	1	1	10925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoYymdqbd4F39gCJKhuxqxysMfmQkEHhVVm6zHz7rHhFVAQym
26040	payment	2134	2134	1874	1	1	1977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaV5s3bUmU5rnXfiKYxY7nR7TC8tMcMUTnUj3kHyXMsWKYFbSP
26065	payment	1397	1397	1678	1	1	10936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ExB5Ckm1R7Ffb482pS14t2eyJY3EnkVfY1qChs5jnGB2Ba6U
26066	payment	1397	1397	1678	1	1	10937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJSnm6c5WA5fsqLtPQxKYDEAaDv31tc9wM1ZsGYN8hhmihtVt
26067	payment	2134	2134	1874	1	1	1988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9LcqJQjcNwVyuonUpc3kMvQpTkxKQzipni5aab72FzQyJXBt
26068	payment	2134	2134	1874	1	1	1989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7yQXSyW9TQQCtHvgvFHktL52YsQbVQZhCqxDmWJychqpqnmE
26069	payment	2132	2132	1874	1	1	523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSpVRodAKquzjnWNkVSPipshe914wtWfrfeYkjAYvXAt6UNRq
26070	payment	1397	1397	1678	1	1	10938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzh5UrxYgaWT5oMJTV1FjCCcfq3WjKsY7iBhJKuyW2cskgkZ53
26071	payment	2134	2134	1874	1	1	1990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAWejPaEncDVxm6vNCwCCbNCs2a7Z6WT93jcvWzQVHSdn2Jws
26077	payment	1397	1397	1678	1	1	10941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPsz3d7F3wpd972Fu3oM8Xdeh9aYgTFFdWmmsVXDJ2D1pqANJ
26078	payment	2134	2134	1874	1	1	1993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEQQMFERZkUMzJfVH7fNucDwTK6ipGk2VUJriVDhrUSg7Cd9k
26085	payment	1397	1397	1678	1	1	10946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrJxq6sA3j7L9sgWbG25EsSpXNhPb7u3uEsFuYCLvQqDYpoBM
26090	payment	1397	1397	1678	1	1	10950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYotq92ZeBe2n9UfbicE69VTRWaqNgSoyt5K6nvMVTjFCCzDWJ
26091	payment	2132	2132	1874	1	1	527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35fGhAKzK4AYUjvLUNzQ3EY3eaEu3XQQ7cMHk96geLNTrAtWc
26101	payment	1397	1397	1678	1	1	10958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoY9vZdzqP5W5gnv6EQuEspjV71AQFymnSBdpPGeUjZRJCHMk
25887	payment	2134	2134	1874	1	1	1915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMrbvrUrcvcMQYujaaGG22BV5mQK7WX1CR9ybkwqX2BXafDCf
25888	payment	2134	2134	1874	1	1	1916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WLJNpH4TkRT5PqKoYLnvrakRFCMwHxxMXZ8YSvAY8PrBmp8E
25889	payment	2132	2132	1874	1	1	501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzozWkwvihfGwEr7A2bafY4fejvBtTxCc5zWbNVTXNZYnuRTth
25906	payment	1397	1397	1678	1	1	10872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLgt23nphUrC5e8NtNwjDY65gS4P9uRd45oGCHxygeZ7n5bUh
25907	payment	2134	2134	1874	1	1	1923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVLCFADDds4Jjq3YwJrWVK3h7wszhkBpSQhVTgattvpcQFWHu
25908	payment	1397	1397	1678	1	1	10873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRYnanzuYK1WAyLPdUEB2gjh3BXjr7eLPEdhp69HgrGP7AZSS
25909	payment	2134	2134	1874	1	1	1924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwerhS4MaYd2uPVn4EPHPY8UF2zUrTYqhQGa1sQ5WftCbvh5HH
25910	payment	2132	2132	1874	1	1	504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3uNuvQC4gGsGhvC8dEG7rXgpAEPDC7dFazu65E73ZWcRc2QK
25917	payment	1397	1397	1678	1	1	10877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwDS7Vdz717hz7L33nbTUcTwxAm2LBYftqSeZQ6nDcbDGjZv9
25918	payment	2132	2132	1874	1	1	505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzBqvMK1axsZBm9XErG6hpxb8XHjjvceAqk7dcbhSMgX7fhDB
25919	payment	2134	2134	1874	1	1	1928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bC4WDQh9vkTG2ts7SQGcPeXhrt91cgwt3FN1BoJw6XGEYQBA
25926	payment	1397	1397	1678	1	1	10880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpiFCh8EEpZeMtz3dbfSgF39LnD18HorhkL6FUe3eJSabSx7N
25927	payment	2134	2134	1874	1	1	1931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM6HLsDwuvpwy8HR2VnBKtY7Uswxtj9s8zCM5bBhErKHbrHBE
25928	payment	2132	2132	1874	1	1	506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ScjrM63A91Ab8HD8rDM98XELrXuZwWW816JnXJoRJHB3DXrd
25933	payment	1397	1397	1678	1	1	10883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGc7VqrGAWbXWrWGHniH9BwBa9RJQVR6wqqpqyquJ2UmJ68Uw
25934	payment	1397	1397	1678	1	1	10884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3uq82eYmKZnkfxDfBsFvddLa9KGPitfKTdpivFc9Fu5Jr5KD
25935	payment	2132	2132	1874	1	1	507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxf5b72uCuKb82urbg5D8giwJWZqCmFiEJhbpoWMPC8yfpAuvu
25936	payment	2134	2134	1874	1	1	1934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5rLFaGZA8FWUByRQp15ouLsno6ZfZ8VPnPuEH3cwGCPEYmr45
25937	payment	2134	2134	1874	1	1	1935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYog3S1MY723SMWT6ddW7drTUX81MqoFL2rT2m8XpmsUE21ZcSM
25942	payment	1397	1397	1678	1	1	10887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78493ZgHdYXnYWduaWCBVZ7vWqpzde2gPMRycpzPy2zUDzt2n
25943	payment	1397	1397	1678	1	1	10888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJsSTuopFt95NwPKqU5EC2nSbt1YggdQAr6uL44sLTLP2FJitX
25944	payment	1397	1397	1678	1	1	10889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyhsneV1htEcNfw3P35rGMFDGePezjNFdYJeopvq3SA6JVgXm
25945	payment	2132	2132	1874	1	1	508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqiQAE2QVdB7tDAvGt6yTHJpkonYWY6BDWb5bavJ6xjknGbPr
25946	payment	2134	2134	1874	1	1	1938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85MmKyVpXCWEKxac7ioP4yxC7x5PatAFCajCCSPN3vXSAKwcH
25947	payment	2134	2134	1874	1	1	1939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqAPbmGeKyCh8wAa7Rpj6PWFzRQ7JVvzE5ZgnWjm7BPJuaxbS
25948	payment	2134	2134	1874	1	1	1940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HPtu4tiQhxtzMPKXEPGe5hTsGkB5a2MUQAhnWvwWpeB4NjFN
25953	payment	1397	1397	1678	1	1	10891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8t85RWCrTvT1yzvv4NR7WFYSQyjBLs2KxAztpBGnFaJ5rCfD
25954	payment	1397	1397	1678	1	1	10892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXDQ4emYUFjAdTqMLbwxYGB4pUFbydxN9L4kVevDCQbhG5zgk
25955	payment	266	266	2196	1	1	0	613000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPGrXRCNbhoFW7BZRhF3rUEtEkHN5hceJ4oeUAN9vLrNGbSEp
25956	payment	2134	2134	1874	1	1	1942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEe3tZhsHpT1tgPWBAvdBu3KLkVVDGpaBxaHRNuv3P8JdbyNV
25957	payment	2134	2134	1874	1	1	1943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtZ6nWjos9jpkRvt7BH3C9E1f3rCS5Pm2PUWGHBVPyYKJh2bK
25967	payment	1397	1397	1678	1	1	10896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQp2BSTRvWKzeksiqg3Pwgx5AKiwLHMrjtonEVpD3sU3TaeH15
25968	payment	2134	2134	1874	1	1	1947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhmyKyZRyjocon9W4TFBdCr2bgH8FwAdT691FxCwVB75d4H8En
26019	payment	1397	1397	1678	1	1	10917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJkArdwPyo1AaVPgL4xt5A5qgJYfxdiUvf9teT2F5bdr1ahnB
26020	payment	2132	2132	1874	1	1	517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtW3p1dQowcucbDTyH9B47MLsgzvD5P8JfvNw2gxMPs48yrJQb
26021	payment	2134	2134	1874	1	1	1968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyH4RQDx6NW9R4TYWYi5xmNm7DFecqzwGnh4LwcCjEsKj9u6N
26047	payment	1397	1397	1678	1	1	10928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6pzG5EMU1qwZ5WpWTxAF8Pt6kH7icf2sgqhuubuaH1HTDq62e
26048	payment	1397	1397	1678	1	1	10929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVHrYMEXcQtGmEUwjUHYet2BZJK2yyynX4iNaKtYcbr5eGNut
25932	payment	2134	2134	1874	1	1	1933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPCUR6ghUACYHCHxEyYs42yCEsCSNB8F7L9KBpYMtfkRyzRKH
25962	payment	1397	1397	1678	1	1	10894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesaireuN8eWvTH7VaMonWW7CHmKfYzLzQR6Dt4sP9L5ErRf5m
25963	payment	2134	2134	1874	1	1	1945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7psViWT2YzrsyWMH9QqxxNfoALuqPotcASmvHyvtrx48SRHfg
25964	payment	2132	2132	1874	1	1	510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCbBAYTgdVQbyZDAsQC6XReUpNWr7aU5AEsDfFrdoMUG1FXdV
25969	payment	1397	1397	1678	1	1	10897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmyUGZbuXJvt8KCPotTyb8cE2QmUmZrycaqcRhKLiaQBQqDJ7
25970	payment	1397	1397	1678	1	1	10898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cZ93QeWWgXRk76Z8ZzCXBuZ4Rq2pc4RkeRf9D95ANdjCf1gr
25971	payment	2134	2134	1874	1	1	1948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4HzkdGeL8uCWS2ZRHXZ3wfN7j6uhk9rADVsLSHW9d9JeiGiw
25972	payment	2134	2134	1874	1	1	1949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQdHdS8uyEba7HxBL4AoctBK8boJPAd3NsiH74Hrfug5jg54F
25973	payment	2132	2132	1874	1	1	511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjhmrR7htfbJzEgQLWxDwFRpRp5ptdjsRPZBCyC4fmJCQFmdC
25974	payment	1397	1397	1678	1	1	10899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMHJZ53bEZ4Xz3S5LggsiPuFHwU9XGX4rBfWZbqAvUKFCzyCL
25975	payment	2134	2134	1874	1	1	1950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPLrbB3xFVMdmBxV24CwLSpBXSmDTRdrtGQucd7UgraFdGJ8z
25983	payment	1397	1397	1678	1	1	10903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8TbpvvXzHUJsansokSeTMjuAXEjZ7tEfCVLx7uLPMV4sL2Tu
25984	payment	2134	2134	1874	1	1	1954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxVKEBfjV3dFATM4tmfwKuywYJNFAHxt8VcmnY9pcADZdHdtC
25991	payment	1397	1397	1678	1	1	10906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxeaFfDCUtMBy5ccACrFRoh9xhELfMK8LiE1qSyRVzeUopWZC
25992	payment	2134	2134	1874	1	1	1957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTfssCSUqKetZDWSWmhmWMkGhjnr6Y7cGGWRrykgREhWRAGte
25993	payment	1397	1397	1678	1	1	10907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4Zbn1ND7VXJaJGqB2LCLcMZV8m7y2c5PfGhJu3uRgx2bzjXo
25994	payment	2132	2132	1874	1	1	514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WdJmi9KRAHdwDT8xHYMjK7C1Uf4e3PSLFV16CJmbpMr4h3kt
25995	payment	2134	2134	1874	1	1	1958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9DJv2VrArpW4K3g58CcBxdb6VL4eYruFyd8MrM3c2bZosiwt
26002	payment	1397	1397	1678	1	1	10910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgTZkpoaXxH4W6NutezGsR4CDCy1xviH8W827wkPWxV9sSNGX
26003	payment	2134	2134	1874	1	1	1961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtP95BHXCxGCkNCAnhnxu78Ap7XEzqcmSoy22azVuqKbRsxDc8
26004	payment	1397	1397	1678	1	1	10911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme81yx4TGzPgyF1q92xzLs7NimqQpCYbXZ7QWhyArcQ1MBvYv
26005	payment	2132	2132	1874	1	1	515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9AzdkdUC34beACrrpG4nNpNV2DfVUwLdUA56CeWzUzDy4yxx
26006	payment	2134	2134	1874	1	1	1962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMeQP2c4TCdG4nDRpGTMQtY8AUYqKEg7s4wDUQMQGN6YZU9mb
26022	payment	1397	1397	1678	1	1	10918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJp12wTbAfM1GZj4JCPXchzYoNNU1VjEcqBsgHHwbrxJCapdNM
26023	payment	2134	2134	1874	1	1	1969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hqvH2NyZj7opoVNdnULXM9jnNCfhgT6UtonmDjqRgCK5DCxY
26027	payment	1397	1397	1678	1	1	10920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYio4AUfherQoq5AFdfpdm5vR4FTqQVTYsP4WvnUxxzDQa35pGk
26028	payment	1397	1397	1678	1	1	10921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZjjD44AEc16mgYHR9cRbeWEc6QkadDZAdFX74ZtrQ5KeVFSZ
26029	payment	2132	2132	1874	1	1	518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYge6TS8MWximTxeFDXdhGaiFrDbhavDskNy27cXmEia6Eax5
26030	payment	2134	2134	1874	1	1	1972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pYkobDCTiCpZrj9hSP6XtSu3tVwd31CcMm9nz6CQLCGMrvkQ
26031	payment	2134	2134	1874	1	1	1973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrghp4Cd5aK2DhL4iY9SSezK43X3GV3pgfRFjT5SMytSEtC7p
26032	payment	1397	1397	1678	1	1	10922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1w5kJLYLgBPArBsSRVWjdNPJuJ48jJrv6tK35LjVuMZnyw4y
26033	payment	2134	2134	1874	1	1	1974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcyGSxndnwsXLfDfSHHWpmMd4UHdPNhZoikzUdXkHh7g2KgSPS
26058	payment	1397	1397	1678	1	1	10933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG8gNxDvA76MoNEqgtjqx7oNr4GQt32eSMWmat7zdcqBPa4aw
26059	payment	2134	2134	1874	1	1	1985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8rnYZbkeYQKUBXxV1kv17gqFXfdiFB4T79Rj1bTwHDQq3379
26060	payment	2132	2132	1874	1	1	522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQM9AscU2Dearu2ecYV9dM7EjhZ33eC5CxY8wgjxongFJ1wwU
26061	payment	1397	1397	1678	1	1	10934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6aTurLaLcVvRaajtAbRcmuooMB88BH6vPv1pEGCHZvkAD9Lk
26062	payment	2134	2134	1874	1	1	1986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyL3CeoMUJ319gPr76QjYbzfPJXung8qaYsvvcFGsuhhkiCxf
26084	payment	1397	1397	1678	1	1	10945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6PiSmZpJFAEC6SzgzsGVMtVEASbiV5Cvohtv3EAgXoap56GA
25998	payment	2134	2134	1874	1	1	1959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzB5oEedfkQPzFAuf6Em57DLQYzopViZ65fGN5AhNe35oLsDdW
25999	payment	2198	2198	2198	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9A1WZFAPBrtqELSDWgaNa4kRn8aUbt9yYAKgfpEZ6qhWpYkN
26000	payment	1397	1397	1678	1	1	10909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQtDgBbhYkJqcBP4f9ns6gTadDeq7ZDnYHvYrECQohWR2fNQP
26001	payment	2134	2134	1874	1	1	1960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohntpT7Qzi37i52qeLqTd6j6P21V26QAsrEFsZKCdAgULKnR6
26007	payment	1397	1397	1678	1	1	10912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PMQtTaHLSD8xgA6LJUQHZCzDs88oFUUfiMhNZXeDRXGFTLKi
26008	payment	2134	2134	1874	1	1	1963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnbckYezF9zMsdi1SdVcmAopVh9rTy541QWAfRyRXMmQ1PCwv
26009	payment	1397	1397	1678	1	1	10913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HPCz7s7wVdAHLQqCRsg7bqHHT1HSAmrpk2e2X77fMThpDeaY
26010	payment	1397	1397	1678	1	1	10914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t5DUvpxbrcHg73mxwQdd3KNQ7wGmJffmq9JLPoU1vrJbZhxJ
26011	payment	1397	1397	1678	1	1	10915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjxQPzU39vQCTRLkCp7e23xyABtgzvvLGrVzaoP6R5qFqu1po
26012	payment	1397	1397	1678	1	1	10916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJAg46exRMTiBbFQTEwbhZCG2zusKocLbaG94NWjrYYDg8NT7
26013	payment	850	850	2152	1	1	1	5232836900000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy8s7j7odJVjN48oTmXG95bhjgPF5e44cKnsgngPPcjW5uNyY
26014	payment	2132	2132	1874	1	1	516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gq7Pstv4Nmxo998BHmqshKByn65crgnNvHxTGHMGLBwBoy68
26015	payment	2134	2134	1874	1	1	1964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDbYdUuLxYM4ov4yWAWaubuZyHAtjYQBFew3pXDGnQK9EQZBw
26016	payment	2134	2134	1874	1	1	1965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qzHPeMWNqZq1QpNjNxMtew1yDETQrUkjXZJ39HyiahVXy4f1
26017	payment	2134	2134	1874	1	1	1966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7eP42AV5nMoc4uMfxm47GiMHAzawap5FBjjy8sbDLyNR5LEJ
26018	payment	2134	2134	1874	1	1	1967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfazTcPdazc7PvKdXdXnpKAfdw82DFuxDohxz4VWx6DhTZrpa4
26024	payment	1397	1397	1678	1	1	10919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZoLMuA2FJCwLYa2Ho54vZaU7fZYpRGmd6CLekpip8DVPsBND
26025	payment	2134	2134	1874	1	1	1970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbxQjwZcqTDS3Wi9u8pFJMKf1PyAMUH8ATyx1fps5CPEk8hCN
26026	payment	2134	2134	1874	1	1	1971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Tms7ayFNDKNeLvkStvvnKQoia3beyy7X5DVDpJj3EVqGF3XB
26034	payment	1397	1397	1678	1	1	10923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCwJpXWR8YH6ghc9F2By5CxbjG85YEzDPzTqdS6BPuDT5nGBw
26035	payment	1397	1397	1678	1	1	10924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxBxrEDkgJqKSTsHYh7V1XtWS6ZWhCYaLvNdQjfxzhiwwMZBN
26036	payment	2134	2134	1874	1	1	1975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa66dkWDj5ESUyVWLEfeB4u82hiY7bhdhDUr2TtJrVehVnnsKcF
26037	payment	2134	2134	1874	1	1	1976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNK9GrhbDELHKzuyceqMh6TBun25i96X61s3hiu3jXKah1trr
26038	payment	2132	2132	1874	1	1	519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJH8UbANxCVcLevSDuWmf8SWWLPGhzy2Mqy9hoWhCEV56znR3z
26041	payment	504	504	266	1	1	0	3000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZ73vAoMkSCuFfCSBfZ8GFmxU2kndWVpwqKaukwqd8GqtGGAt
26042	payment	1397	1397	1678	1	1	10926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfe75mkLycZgVdg1dkEv41wWd1zKGGuYx5GsU5dFbaWT3coEp2
26043	payment	1397	1397	1678	1	1	10927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbdDzWHfkpVRosj5SE8zrM1AaeFPAmeV8Qq13L3TjobkMGVYP
26044	payment	2134	2134	1874	1	1	1978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjkiv8Am8PNVvRYY1yv8kdZtuGbhB4upe2GXU5LDGhiELGGRw
26045	payment	2134	2134	1874	1	1	1979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmJ5EP5RRQQ8LbHfGEkRCrwYZAy6HseTodU845jSYZwc6GRMt
26046	payment	2132	2132	1874	1	1	520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBQzfvKdowWMcBMSdMrD9h1eUCXaY2tLnzuLQ1jN8Fmto9Msf
26063	payment	1397	1397	1678	1	1	10935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTz9LHKRu1rAN26BtSFo5gjLxHoxHKxVJbtJE5f65qFAZ116EA
26064	payment	2134	2134	1874	1	1	1987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBfjEukmJRG167JkWoKc6HFqy6mWhfSAzLGmhFzxfEA8BCWpn
26074	payment	1397	1397	1678	1	1	10940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oU14SPNGE9oZNoE5xy4bWeTgRVjGhLXzXTwjeAu3kjMZw8J2
26075	payment	2132	2132	1874	1	1	524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNr7vjMAtpDa24Qx5SiKisUQVJDF96gCFkXX5ZpHGabWi2EtA
26076	payment	2134	2134	1874	1	1	1992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwErYHvUkg1hahFoyzCEFE9Hwkci83SjJr6CV8HTUsDTJnM5V
26086	payment	1397	1397	1678	1	1	10947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxCqzq8W5crT47kzweHxy9V5pxtMrb3CoqrM9TDDX3MBGncnT
26087	payment	2132	2132	1874	1	1	526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6wUcCEf5bWfgDnXxwX3Fag3HHBetkLjnbojs7QC77HJiWwtL
26088	payment	1397	1397	1678	1	1	10948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsCQMYkvdc1N4wFdr6ghkNDLiuVq99YmZydfqAnQkeAS5svEq
26049	payment	1397	1397	1678	1	1	10930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M5CeVkdadSqgGpeyiDL2iNaY6nRufu2NizdrqY7nsWot1obh
26050	payment	1397	1397	1678	1	1	10931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MGVCSNusmuNJtRtePqDuEYuWpk3Zi5X1KoZyu2z4m4ou7npJ
26051	payment	1397	1397	1678	1	1	10932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwBmxfrSsThSnB13nnQcqcAexnZbQZzx3VMyJyTXESKDuKTw8
26052	payment	2132	2132	1874	1	1	521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ4iC3PAuXdkxqa4y7m77pQSQniMmaVX5CqjGyLQcm46DRVjF
26053	payment	2134	2134	1874	1	1	1980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPjrkJ9DQdoerqfTNX8rAThNVb14K2qQ2pBP4vtZkYYS5YvN1
26054	payment	2134	2134	1874	1	1	1981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bFFN3S3ioGZrsZqpGYBCBtrBDPspR8MAbnFxmcAYBrFckDzM
26055	payment	2134	2134	1874	1	1	1982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTv2fzxgcuVg22cu3XmUYRZTpt5WZ6fmJReqsUgbwDY9ih5tA
26056	payment	2134	2134	1874	1	1	1983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp7X9HXZZeketzDHuRMmpQQWwYp1yjgcPWuACEBkKYevvarPis
26057	payment	2134	2134	1874	1	1	1984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4844BFi7kXfxhat8qcmtVQt5SiWd8ijtzUWWR8TdhmpVtWcp
26072	payment	1397	1397	1678	1	1	10939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfrrSzJYaAJZmMVrry1XjvuJnGYfhCLJZ2zohU8owakwaqkUJ
26073	payment	2134	2134	1874	1	1	1991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9aUv8WxnwnpuX89ai9EmpJdLKp8f7j6uXVsHAytMqHamzjm2
26079	payment	1397	1397	1678	1	1	10942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbrWuTRBbxSV4ZHgNkAMbodGRWMVSk1WQQLotTnChYj993u5E
26080	payment	1397	1397	1678	1	1	10943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3BC2tkTL9x6fwwPAYrrBNw4e9H7gZvoya2jCAD2HJH6eWnu7
26081	payment	1397	1397	1678	1	1	10944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oNqdNxfpi5Epfq7Svd6asqVGkPNZBDQpVwfuTjens9AFHAby
26082	payment	2134	2134	1874	1	1	1994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffeNnVpWhLSXwJk2GTnjsC5cMnsFgod2F5ucPJENhWNXfrmzd
26083	payment	2132	2132	1874	1	1	525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiTosGxvbpFkraoF6zs7LNUCHfBNxDNYQY2omQGvLokYFteNK
26092	payment	1397	1397	1678	1	1	10951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbW61pDVKDxaSRWAefC2foLWmNj3iGRjnK4FEYihqmP47n4xE
26098	payment	1397	1397	1678	1	1	10956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvLCeRMmP9do5kkKSEmnnHnfDPwT7WuRf4oqfwy6Hy1veWHsW
26102	payment	1397	1397	1678	1	1	10959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg47gd8BzFT2PMCxp76w6NETXKDiwDuFtXQtJFSeAa14s4VYvE
26107	payment	1397	1397	1678	1	1	10963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRGUboxqE2Q3VvNPkG8ZnRbQQCvWGwcrVbwrDBB9LrhpeANnfK
26108	payment	2132	2132	1874	1	1	531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrRLPkDy25T7j7q7BbxewLPY1vUrjd6zZBDEeJ99PNk2w24Wm
26114	payment	1397	1397	1678	1	1	10968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZAXfBdLeLc5yyU8EJtMTqLiDeX4eP6GjxNNa3cmDYU2695MW
26118	payment	1397	1397	1678	1	1	10971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitSs7U9CfTU45F9LfBaznhUSzKry3vk22DrdBrb1kdSMSDsqM
26132	payment	1397	1397	1678	1	1	10982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaisEDMEdEdaTcWuomMQBzE8Q7xthnVBPHhXYU4BhxC4ut2mXk
26133	payment	2132	2132	1874	1	1	537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBQS4bdkrBzTQbUn9F5agtALyiTzwVgRKWRKANYpyja1govmr
26137	payment	1397	1397	1678	1	1	10986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdMGpNvwknkvbpNvbs6rCNJAKEKuPbJtZkeaM7s9gNpAFAV9q
26138	payment	2132	2132	1874	1	1	538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUTN31EodsJbSKZ6SkFkLAQ71SrygWxE6fo6CpmQXkiVtpN5C
26143	payment	1397	1397	1678	1	1	10990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnntfD2AyH2bCmZSpzaPZiwBNwrdMG6YujoPpijmhW9Ntdpf8T
26148	payment	1397	1397	1678	1	1	10994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwAhjZKEzRjGoRse7R3J3zV6XadDMVnQoySxAGM1v4wkerVKV
26157	payment	1397	1397	1678	1	1	11001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AXFPC9PfiLy3tjaekHzYzBbXwwCZ6nSVZv7KBNcXTJeqFvpC
26158	payment	1397	1397	1678	1	1	11002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmimDfeERszTEqTMyt7QGetS2GaqHiha3yQeFLSsbgrpbV8Qu
26159	payment	2132	2132	1874	1	1	543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNQgXeb97gqRJhdhs6KxpPVXbvc7MeGxr3SRv8JxTPDRXgiAt
26169	payment	1397	1397	1678	1	1	11010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy52MbVkXYXyYqU4wSwfnTCpstjWrNnBecqmMy9K5pd212Qgq6
26180	payment	1397	1397	1678	1	1	11019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRNdMP4qBNLCFhLBGWV9mVNgbUNx91g7iQAc3KjZf8G6zPufQ
26181	payment	2132	2132	1874	1	1	548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3FjMS8gyhgzg2QakzVvmCvdGgscd1o55v7izKi2sQu3z7P1Q
26184	payment	1397	1397	1678	1	1	11022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5hoXa7VVKMHGikySBsJks4uabkL1QiobMPmUYF3LbzfWhUWX
26185	payment	2132	2132	1874	1	1	549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmDetTh2XC8ghLL1qTa244KRWQnbYgKm2UGkxHGpMUCMPqc56
26189	payment	1397	1397	1678	1	1	11026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZzqxB6obhHJnfrKZixRbGWt7NUjz2psFNv1Gh8yrFVy5Uqpr
26089	payment	1397	1397	1678	1	1	10949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnGa2XEcapXaqRC6By483LyL7bMfmA2gPeysCLhd9G5jhWg9W
26094	payment	1397	1397	1678	1	1	10953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgS5FpM9vP9dfKmA9TmCXETNyvqKhq8y6DkqcGErCVmbGSWqV
26095	payment	1397	1397	1678	1	1	10954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr6eMXs7sQ7jmr1JAb6tVHX4F3zzyeBgkyv8kcELuZfyJuKqa1
26096	payment	2132	2132	1874	1	1	528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjymDV5k4oki3vpZ9YSLftPB5cfqHUhPFiZBE28EYV3Z2nYpB
26099	payment	1397	1397	1678	1	1	10957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVdBwgpFFCCMBYHxW3VM2avxVVWqaWAmcuVBGNYJXdhAmc9Lk
26100	payment	2132	2132	1874	1	1	529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtST692bnbksjFNkTmfgAnd15pRNHdtMkEXajwUjf4kCHg6eKy
26106	payment	1397	1397	1678	1	1	10962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ91yrf4KSgGqymzu1eM1iu6jpFoTTkW2MgeytcZBK19sP69qX
26109	payment	1397	1397	1678	1	1	10964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4XsrEqbgCmfEScUyyRJVXKFrEZ95S2C9tnDQUwEez7Bs4BBk
26110	payment	1397	1397	1678	1	1	10965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF29bCe4yqc4ULT9RCnT2UK16bmocVBg5ATJVt3WtikVzmtmpE
26115	payment	1397	1397	1678	1	1	10969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGS1WsNFXkvHBnJuvFFiN7fe62ppueXCJdjwqNBtpa3Djys6CB
26116	payment	1397	1397	1678	1	1	10970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJaRwVpZxonnoeVyofaAE5P4TcVHUr9gy8gDyd5r6CLgVeejK
26117	payment	2132	2132	1874	1	1	533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZ4E93ZUE3qLG4uvvTT8JLicWFUdfpiAN5cZVJwS4S8c8onYF
26122	payment	1397	1397	1678	1	1	10974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XQe8bcCauBGVUPHCvV3N4PzwKZKBJY4QoST6TkE5LW8tpoPr
26127	payment	1397	1397	1678	1	1	10978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSW4DEsiRUEhP2CXzYasUFXvWKJuQ6UcY8kkBokxztQLNfzKt
26129	payment	1397	1397	1678	1	1	10980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Xt3H21H8KeruTVCF4goieTbSaaiTpJqAC2HPRpjpjNzPaigs
26130	payment	1397	1397	1678	1	1	10981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAphua3BGHmpUm3H3JDkNF7offRcSGh6v2TDmtWgN4kKWRMDgT
26131	payment	2132	2132	1874	1	1	536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8yXRgGtcHD7kyiMHdXbhopgcqfxqQscSzLAWn8pUL65mdhk5
26152	payment	1397	1397	1678	1	1	10997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUX3QKYDhETVbhrhqncesJbxuDomdWGq8KMWPEtTLFoXxBZep
26167	payment	1397	1397	1678	1	1	11009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWXbAi3r27tfDmXFHUtgwMTWZDsWAXQQsKzoXzLuhzpPE7yjf
26168	payment	2132	2132	1874	1	1	545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bZ1usEzjJEAXJbBQ2idJD6kqnZDit7kwH843Bu72LhX8bJw7
26174	payment	1397	1397	1678	1	1	11014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGsRg4AWLz5AddgGVDcDt5VuzjZxx9Ri5B36bD7E5FsGALAZb
26175	payment	1397	1397	1678	1	1	11015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sEMRLxsgQDUf7Xw6cB9gQGwt78zQoZC6Mnz8vS1qPPd1vodC
26176	payment	1397	1397	1678	1	1	11016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87zcTx7RHEbPDLiqhCdjBdjZZ7kZBJ66ASJnwh1ky2hi8B3qK
26177	payment	1397	1397	1678	1	1	11017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSHA24145Emh1ATnMhFTwWsc2Xi4jiZnZf8iHJjRDpKvdMtKC
26178	payment	2132	2132	1874	1	1	547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwAHttRdWzB3zY4g5GFhGN3nZ1D9fS12b5Jc9XzbH1htCp7JW6
26182	payment	1397	1397	1678	1	1	11020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFixps5akkCCeDb7KurVFGotnvS9t7kZcEoS99c1btDcq2JK4
26183	payment	1397	1397	1678	1	1	11021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoTMZ9sCdMmwqcD4sMuqd9bGJ3DsNd4Xcw4iktpYtSmGDDgUF
26192	payment	1397	1397	1678	1	1	11028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFdm9LJbarTxQJvjzJY1AwbpfEfBqAzKcCsP1RtDXbGihxK36
26197	payment	1397	1397	1678	1	1	11032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQL72BC9iy2hVoQrHQdLU4TuNReEw4sRQerM8aE6ogxebtRyb
26198	payment	2132	2132	1874	1	1	552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwap5sCm5g6opkJUdhCMz5nC37jMSGYAysQJhZRBy8s79bjwMA
26202	payment	1397	1397	1678	1	1	11036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkgHtHwz12kTcurAoEFiJaejAAe7TudjgdRZLtoD4TuAS1Yk3
26203	payment	2132	2132	1874	1	1	553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mu8T5sy2CzCrAToxZ8rHE5RoksESPciGPtsGS4UShrejNwic
26204	payment	1397	1397	1678	1	1	11037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6iavHpRCG2mnYjMjUZrnExhQAWMkhjZhuUjw7BQMAc5zxs3M
26205	payment	1397	1397	1678	1	1	11038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrepTpsHvQcsTpdToVavwbcPH2bTGvKXfJGHdoxyNBmzUZDcYK
26206	payment	1397	1397	1678	1	1	11039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm8LXfoSSKiptkWtNpGVmKUBdSfE3v9eybv8D3nfzQZapmYHty
26207	payment	1397	1397	1678	1	1	11040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBkSsAhbPVbRubfPFXVGw3tJJLvcrYnMhhti9AvfGBJgUHHwr
26208	payment	2132	2132	1874	1	1	554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY56ekk13uzkFqPZp1Ug5DNpKzoU3cpxmqNGjUhvG6ZnYXxJng
26209	payment	1474	1474	2200	1	1	20	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfMCfNbYpvz2TMu5bPp9c21hERadhJRKiAf6ERHUkEF6ywBHU
26093	payment	1397	1397	1678	1	1	10952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iLSQSX4AHXsxAQNiowHFfK2ZAevbshFhNDwhygyAR9kG2JyG
26097	payment	1397	1397	1678	1	1	10955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoQvDmPzz6N1oWr9ovekW2NRxskjkwdTU7qUMdSLTtcc6wTg1
26111	payment	1397	1397	1678	1	1	10966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH66E5aHHkizbbqJSpJ3d6AyLPx5xY2TSGQVUYxYtZMLF1KXWo
26112	payment	1397	1397	1678	1	1	10967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXUfWGERG4zpRgmB8jTnaya4fTumGboLDXjoaNtX7QSSwuPBk
26113	payment	2132	2132	1874	1	1	532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXctHBL98RUSCssxLEcYCFugEigYrL5McKy5mB1wXTtnoJGRdH
26119	payment	1397	1397	1678	1	1	10972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EUwi53nff5QCDEdx1AnnEndNeFV3XBZXdDrg7mfgJPYypSqy
26123	payment	1397	1397	1678	1	1	10975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrjNes9tYZ1zpcM5j2YvdBZj4FvNjHc84iZQxR5BmenyktPJH
26124	payment	1397	1397	1678	1	1	10976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGeHCxFaqvShn21fT1oFAzYbL9peZHHzqf4T4w1zbe1Gzz4Dfh
26128	payment	1397	1397	1678	1	1	10979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mmyczCXdwMzPE7Jnkrn4ScVVp8Rw4EFYGbejd9j2B1PEGBqq
26139	payment	1397	1397	1678	1	1	10987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNd2ZCrF2CJ1MY9fvviez1v4PDQtv8EX9Er4sddXAhF6dCyzY
26144	payment	1397	1397	1678	1	1	10991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPK4HaevVE3CqMEvDzoo193gCG4PZ5RS73WraaB9dLZG4Rh5Bd
26149	payment	1397	1397	1678	1	1	10995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfHqEYhSZJxnp5vnAChakEdFABrP1CnWnqMuGye74hMGZDQGS
26153	payment	1397	1397	1678	1	1	10998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSh85pZ2YoTHT9jitHTfKG6aRga9WRpzdHRdPLMfqEqESg2Skx
26154	payment	1397	1397	1678	1	1	10999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNQJneh69T6CdacdJwGvwzV5FQkQcSuLCdabYZUw9bJ7mSnak
26155	payment	2132	2132	1874	1	1	542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUU2mtZg1hLmiWmTUYzbhe2XDQtVVsUijgtkztZqAdCQzqtP5G
26160	payment	1397	1397	1678	1	1	11003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5E1zrn5x8MPrJrFWiXe5XdpA8VxKEmduSetKLN2QkDXV1kfM
26163	payment	1397	1397	1678	1	1	11006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorq6B7wWcAU1XnLQuWtRKU53ZSUpHFZnnMXbASpR4Co3P1beM
26164	payment	2132	2132	1874	1	1	544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3yzR3a5xujUfdQK2eoC3g3WjJPSbwnXRRpmCXYLWp5BorYf8K
26165	payment	1397	1397	1678	1	1	11007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLiMNzrR2y1W3AuoAPf7hdy8usr97A1d7Cco3sZR4GJFXHeQhW
26179	payment	1397	1397	1678	1	1	11018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdAv2359SshgMMoxZQMKmJpiCviPdFKaVXuLUovgzkmFRLazg
26186	payment	1397	1397	1678	1	1	11023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7uEajmjGi3BvwnuEB8WTycsLEwPnsTafiTPBFKBsyitGq64p
26220	payment	1397	1397	1678	1	1	11047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVWkWXcSwKPojcwThustQMAJk82VJPpyh2Mp2DjNarFNswm3S
26231	payment	1397	1397	1678	1	1	11055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSMbQ9TJcCKs9qkwvfhLD9M7noooKzYScEs6nb4bAd1V4R8rF
26256	payment	2132	2132	1874	1	1	564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3iAR8iHtE6MwGjLZdrfNLQrhosKBg6Lh74xgt2UpADPj8dyQ
26258	payment	1397	1397	1678	1	1	11073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU87UQHs8qrjNnvgtua5epQG1u3KTVuCvGogDWDuDZ1jJLjr2k
26276	payment	1397	1397	1678	1	1	11085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYautHNtfVNcs3SiiKW1iGmsPoVS1b6n2w94U68V3GKn3mPrfge
26277	payment	2132	2132	1874	1	1	568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpt2UHs8jo7roRfGRPf4UDtu41VPuKkvG86P9fbGxBo7DuUYN
26282	payment	1397	1397	1678	1	1	11089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvPvwKJNty5JWYC31HexH193FffwrLkxwNVzoRnQvWcVqAuZA
26288	payment	1397	1397	1678	1	1	11094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUcKX311uiyc7r1WrKF5ue7Vppj9vEa6ZETpWVbryLQttPuEe
26303	payment	1397	1397	1678	1	1	11105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTeyKP9ChXJG2Q6JnzvvRAe8hEdzgNdmpK6Ydkhes6neRneZ2
26304	payment	2132	2132	1874	1	1	574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgeh3WJzFeYhLvNm3XVAA326VxasRm2dHg2Rnmmru7j5mM6Tz
26305	payment	1397	1397	1678	1	1	11106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNs2v9dBfdBndPdGodbiuMys5XeRKYiBYdpGabPBoUtBE6craD
26306	payment	1397	1397	1678	1	1	11107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUgcytmHRWFcJFT8JXZUtCZq1UBgk4jTd9mKTQwCWCjfwrz7S
26307	payment	1397	1397	1678	1	1	11108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7Vvyu12XELonRvZh12WTRUm5JYogaXGLhZkV1yrMz397ZSBC
26308	payment	1397	1397	1678	1	1	11109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksU92zVJtYkGZj4yFSmKpbVUMp2HEX43VV3CJgkKir8GX3dWh
26309	payment	2132	2132	1874	1	1	575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wxT5iNkCWKtoUtToX4fKnvMA8QjitXLMufcc3zYhhz3zsEte
26310	payment	1397	1397	1678	1	1	11110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQKi9MG2KD7QuKAaoPqhjXWqh1P3yxEp61etNZjTPznErF8EL
26320	payment	1397	1397	1678	1	1	11118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrphNncG3eVTBhNz8dRNswiFpvoiwZg8Z3rjjKbk3Mz95NUfn
26103	payment	1397	1397	1678	1	1	10960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Er56bta54r6qF62k8V5mMqiwKcrbcN1sNG7Lttn3BVhkhZx6
26104	payment	1397	1397	1678	1	1	10961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9R3AtJu5NPxwMa2Ca4GQcfzyBhXP9D8vzXcGFJdzLwZuEK1x
26105	payment	2132	2132	1874	1	1	530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpdPvjMQrxzgL3ufU9cRdD8M6udhFZAodkrFBjsFk76EktMdR
26120	payment	1397	1397	1678	1	1	10973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeHGv3JmLMhF8MeU5LAfPbd1hAWW97yo8deeSMRo71rLnojSW
26121	payment	2132	2132	1874	1	1	534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQufudQfwr279PbYZWak62e6WUQpv9wRKonU72CccpWN8dT7pJ
26125	payment	1397	1397	1678	1	1	10977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzw28QLh1jkoATyifuttaTMAbUMwsrtdfHJa76xnEGz2qkUYTD
26126	payment	2132	2132	1874	1	1	535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzQvyFUD51pp2T8NygdLxzX4ZxonJqS2qGt1XpCLMyF6tjB5k
26134	payment	1397	1397	1678	1	1	10983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJQr6sWiunbVk5UeqyQr98UHhGHE1UwfNivtz5fpLiFyvAMvc
26135	payment	1397	1397	1678	1	1	10984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LHvFWmvro7FveoMHv4nbY8sMD4NpftpW2qWHddyxgBaCGCuM
26136	payment	1397	1397	1678	1	1	10985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGAGfzsfhvXV5CtN3BZPkPbv2nbtVGhbtVRahZ4GRoA8HA2Q6
26140	payment	1397	1397	1678	1	1	10988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JdzyWCaskKgJxHN29eAJs5Stsw1X4Nb8fYJMQPWcjeEofYTm
26141	payment	1397	1397	1678	1	1	10989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57tRsFxxmKbtGksrzYWqTmg1k2pG7chHv11Wp6gmKVTtJZi54
26142	payment	2132	2132	1874	1	1	539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7Wvwj9FDPQKbrxtUSHyqcYxXQ95RWJHowBjoFrrnwkZSVeqF
26145	payment	1397	1397	1678	1	1	10992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9XTWcmUWtE6Sfedh7eY7xd8juwuvf1DLTggKJ8iqvGyne9tV
26146	payment	1397	1397	1678	1	1	10993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQsMRFwRbcFqaJEA26azUsoHqX72j2Db64RZdJvaGM2rwMKCXZ
26147	payment	2132	2132	1874	1	1	540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4ccCf5roEYSoELmFBcga5FK5Uia67qUp5omZJew2qVZcFLyY
26150	payment	1397	1397	1678	1	1	10996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZVSNd8MBPYthcyxgkJamnpuZ7pv8JrqEeJWQoAX9sgdauFHS
26151	payment	2132	2132	1874	1	1	541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNGpYE2TbHFuGhpVunPM8R6sa53Boq7hhWeWBLkfTRqZzvf6t
26156	payment	1397	1397	1678	1	1	11000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3f8cteV4sy6sDPY975bcRGiX4nyssy9SyZzhNUGPbg26TmAH
26161	payment	1397	1397	1678	1	1	11004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDX85FW2qkAGXCxbDhYf7iyeW955Gjj8vUnfhD9sMBByPTAeFu
26162	payment	1397	1397	1678	1	1	11005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefWbDYXck3SX8xHDY5kvVpu9mBuTGt88F3XiKPfXcBLsVGCcf
26166	payment	1397	1397	1678	1	1	11008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjacPU46LePMfuZRxEwFV95v4t8XLJ4ueX21mK58KmhruJTFh
26170	payment	1397	1397	1678	1	1	11011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdGo6oYvbFyhrbvtMQWi78CsnoHoTGjw8dAfhiwdXksjtaYLC
26171	payment	1397	1397	1678	1	1	11012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKtbkx4w7vZGKQZhtRvZWdVrDWdoX3yc1SfvvtdwL7vGPc8m6
26172	payment	2132	2132	1874	1	1	546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7pPevKEbYnVsdEus14YDRZE66RpKemcS1f9vtPCRhKES3yTj
26173	payment	1397	1397	1678	1	1	11013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHZBdKnVTgceqVavMkqpVEWbFqbQgsVZAA2TqzrBhg5f3FLJY
26187	payment	1397	1397	1678	1	1	11024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQRkzsP9nofNppbmM9n2AJX7CneUwXBswgMVb3fSUMZdqUJCT
26188	payment	1397	1397	1678	1	1	11025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsAXnCLLvAA3BK3V7VEjxpoJws7bp2q58C4DdFa4huWiy6cku
26193	payment	1397	1397	1678	1	1	11029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqNeUUFniBxKxmERhZK3Fym3DkSUaHRgddsVWcuWkQyQcwjkn
26194	payment	2132	2132	1874	1	1	551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjQWX6oEcvcrMAaFKjy9AEnvjsCrckDRH9FQSVtWMFrxr1SeZ
26199	payment	1397	1397	1678	1	1	11033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3624nWgeQznTbR79df2PnvktDvcsfczQAuSwgKHcx4akLEjRF
26214	payment	1397	1397	1678	1	1	11044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSP52wvyMuJV6mAKLqswxQxqHDd3yPG895gXrsoH17SjkmemmB
26222	payment	1397	1397	1678	1	1	11049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWicMiFEuWvicEe4WSmsbTn5oKknt125d8jNYmjs5UHWwvS3F
26223	payment	2118	2118	1726	1	1	3	1000000	1000000	\N	E4ZRcQkJZq6b67m9M9VYab7kt7xurGsNjwvMtAgup8Lcs2dx1osYW	CkpZzv18Nngd2oKrALERDdbdzarHJ2QqVfCsoQRy4zZfLeHACrtdd
26224	payment	2132	2132	1874	1	1	557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdXgWTFnW5eusoP3RtsE7YoU8VdMad1ziuRcoiCaiwTsLWcAR
26232	payment	1397	1397	1678	1	1	11056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmTTNuzmfEWsAzJzuUdmZgwMk9tZUgeuk62WykcwxQo8rsQR1
26233	payment	2132	2132	1874	1	1	559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdv4okn786odXLbLS1wchHh5iosns8mKH7GKiEqVvik7FuRVdH
26234	payment	1397	1397	1678	1	1	11057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMkdBPaPrnYF1XbxRjCF4NBHgBqdfsi1cKFCYv8h4rmtfNmsK
26190	payment	2132	2132	1874	1	1	550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93BQBDv1QZVWkdYNgXGXo5nzzr7QhMNoz3n8gmZumw9sAHKcU
26191	payment	1397	1397	1678	1	1	11027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNoH7v6BdpQEeRR6StzCvFmqqFANUzzPFv7RhPEtLJPdUMjsC
26195	payment	1397	1397	1678	1	1	11030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumie3CtrPWrJudozRub3eLSrVvfH8McAxMepCAbTN5BtUeWGP
26196	payment	1397	1397	1678	1	1	11031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowsbK6yV16ffLW51cBzpprsQX4atCqU13T7JrXk4RHSDUee9Z
26200	payment	1397	1397	1678	1	1	11034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzcgq5sDkarAYFPeW5pxBjH7ntuD2ytxzRucHZNXTmGM4DjXWR
26201	payment	1397	1397	1678	1	1	11035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczREPQpWhgPBTkAc5NhNuBSaEgDZ6EnEUGt2j8BkVeQGdGAXM
26211	payment	1397	1397	1678	1	1	11042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNa5ehnJH6NSXXvuvyJ8AyubEvMQsz1ouFW4ntTnkZjC4hVkQv
26212	payment	1397	1397	1678	1	1	11043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhQqeNXx6xANCJD2PzTsw2DcjQ6ZaKT4G3viesffWriy66N7T
26213	payment	2132	2132	1874	1	1	555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YRuwTG4dDypUJVqCXqFCzEKmPcUiob5BDVUeasPsuG91QtiX
26217	payment	1397	1397	1678	1	1	11046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMw8tXudahtb4cLgcLANka3MPuHPPc9vLxLBJRSu7M5DoPS89
26218	payment	526	526	1474	1	1	1	3500000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77Dajd1MDUy1wzBtH2cBiv4UYdxShHjpaCjgeKEgbR6Tc3BBm
26219	payment	2132	2132	1874	1	1	556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNWyYxWj2EUbb2CMABQvp3o9hwgQSxoYBzJfyP7wtJgZznaSo
26225	payment	1397	1397	1678	1	1	11050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwFAtz6rhsnHsd72y5in3agKc6V7PJunj6RnSfAaCVCwixD5G
26226	payment	1397	1397	1678	1	1	11051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpPHQwcZgjyTTipUiJ9oBJ7c3Hri1LixPtPU4JVF3aZCxt81o
26229	payment	1397	1397	1678	1	1	11053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoCLncwmssgUAQ1MiExZzRYGnY3vyMoNTvZ1wf15N73VAsvKi
26230	payment	1397	1397	1678	1	1	11054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnHtPdaKu6mt5imm7z8Yvpy3ARdbpMR32rNFzggd1pYmdiTLY
26240	payment	1397	1397	1678	1	1	11062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpRGSiA7uSCbewvVYskFUgBccVfNZRNQ9Q1QLKXeJMLutKFPi
26241	payment	2132	2132	1874	1	1	561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvsm977MkcKAciyoS6TZyMmqhUFay5k2D1SGAhd6jAiJRRaV3
26242	payment	1397	1397	1678	1	1	11063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczQHy3saziBBocR1CN2yGTbmj4gjjWxrv5Yubu3jrDRwe1DJR
26248	payment	1397	1397	1678	1	1	11066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3D6JaDqDgf6YqATG73Sjp7oqJ1NdiF17yP9scP2oR6tJidjW
26249	payment	2132	2132	1874	1	1	562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuosFSDyshZ4wwPDBTS29KZZyCGnN1jHnzEME1o2KqdhzCczuc
26250	payment	1397	1397	1678	1	1	11067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxjD57BjmyZf2BPfxo6XvLDNU1n5pJzqwMxfzXpqymm9ifBXA
26254	payment	1397	1397	1678	1	1	11070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3jnwaP1chcBZzivzNQU5NxRr82tBJmwbLDbRjjgZHCun1bZu
26259	payment	1397	1397	1678	1	1	11074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZGdeQEHV1hZrzuhmfeUiTEjQbU2mg558MgRzwH4Cjpn4CzSv
26260	payment	2172	2172	2131	1	1	1	1000	1000000	\N	E4Yd1BmvxuSwpvYQna5DCpkvJsc6am1hZ9U9yhxwnvtqphU4RzSmv	CkpYeeJ2neYC9YDvyCbnEkS8LTuEZZZAmWKU8V8qaAHiX9hTCwpnW
26265	payment	1397	1397	1678	1	1	11077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtkEtpo5zaVKt2TMLTgeb88A89fp5G7iAsH9vM2LCunzjJqwu
26266	payment	1397	1397	1678	1	1	11078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa154KJZzPZofTAXfqcs72LK9pq5K2KBYhTg1UDHhdZiAtQYLvb
26267	payment	2131	2131	2172	1	1	6	1000000	1000000	\N	E4YcxYWhANMuAaXHTgW7HeNuqyqUsSMoQ4HBpXg3VvCYhzKQCvAge	CkpYqZFnjPZV9Wx91BYoBrHWpHpSsgM8FULZFVscVYnod4ciXSk4v
26268	payment	2132	2132	1874	1	1	566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rr1ig6AyYdHjCKEhPDXZ8Bz2kdffgvhZ7zwPA1qmHCpi5UAj
26278	payment	1397	1397	1678	1	1	11086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4p5CtZgfBErHBK2qhDbxgQcW7tQZnCJQMoRvwr3ebafKytsp
26283	payment	1397	1397	1678	1	1	11090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyhFa5wGzgy1tuXwFgmxtBhedvSmpZ6TmGUATamDEeSpr8mLK
26287	payment	1397	1397	1678	1	1	11093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7a4A5KfdWz3n72VB5M9YC2Ndp39snKZ5trfZeE5N6GbhxHsi
26314	payment	1397	1397	1678	1	1	11113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQVh81PeWtgEvdxAL8QZBbBfYsercdos6aV5N33ym2A3TrsXV
26315	payment	1397	1397	1678	1	1	11114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKd7cxKgHvmPJkAoughEezt1PU3S2SoopYLqWuvn4UpZWZJsng
26316	payment	1397	1397	1678	1	1	11115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzphrLANkCs3vvUfTxBALXuHBxmvuGpYU3Z9C5C7CTa73DLw2
26317	payment	1397	1397	1678	1	1	11116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRDnpViR2Fq3bEnBUEgj9GC879Vtvf2QjNYZQk7oMCPnqXJ6h
26318	payment	1397	1397	1678	1	1	11117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU7FiTWWEYz7giajkcGdYQT1AEmRHQuG425fmiVEhPvp3KHxrU
26319	payment	2132	2132	1874	1	1	577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nvap1vuC88tvJhFrJvRXP6n39319GWSRyEPRTHjEPLNaCDqn
26210	payment	1397	1397	1678	1	1	11041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeNaqKvwgDNLQvFMKgtENEJpzLxgfN1WfReNvrRWgMuh66NeE
26215	payment	1397	1397	1678	1	1	11045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS7JoYoceFgvTvsCk76axUnw2Vc2ZJQHmHXExvvmyqU38sJnZ
26216	payment	526	526	1474	1	1	0	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtJDMCxNgoqUSApEGz415yWNT2AKDmVeBbfD1p7UB3MrW7MYf
26221	payment	1397	1397	1678	1	1	11048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeyUSNSFmYbBCWuqoUzvbkoKLZhiGEUGSC31Y9EFyrnEmoVAh
26227	payment	1397	1397	1678	1	1	11052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggi6pZaefk3NMtva91jZPRZkZyHC5o17JfMFLohWJrsz55ojE
26228	payment	2132	2132	1874	1	1	558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdxijLwsDAR6TgZTR96TywU1cAS21Df2pPxNDWZKfge5DcBTS
26239	payment	1397	1397	1678	1	1	11061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYux9Ec4d7P9zLP7fMJTH2NLDhoTCtb2wPnQrLvvYtaME3mWaiD
26247	payment	1397	1397	1678	1	1	11065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4VPob7ajVg9UtQEBchYVsETeE7Cx6vRyyyWzYRVeWht254GR
26252	payment	1397	1397	1678	1	1	11069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZzZcJ6xJp1GRf42PqirK29JKs7SMJE8CpGV5zPy6qc9DYXss
26253	payment	2132	2132	1874	1	1	563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBKXAroaHyQiPiXNvKo1fkCSFfWC9JYp7o2ZaQtC37HYrFV41
26255	payment	1397	1397	1678	1	1	11071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5M5viiQasd8SpkQUEcLejhAiWnH3MmnxD4fa8ffaSbQ5o8wv
26257	payment	1397	1397	1678	1	1	11072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcA49VXoZjUwogS3WhGAQrcP5zjeiFosTB5aMA1pD7wRS6kX7
26261	payment	1397	1397	1678	1	1	11075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ72YwzULrE8zB9APe4X2N532TTPT7eUSB2SuFcP4ccfTuyqwJ
26262	payment	2132	2132	1874	1	1	565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1w4AKtpMi8SgsPqUoeZjzw9x7wzXNywcGBfoLgC215j2tL4g
26263	payment	1397	1397	1678	1	1	11076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dgWoHcJ7crHyxvttDgnqU6ANXCfvcc35vjGf8S47P4wmSDor
26264	payment	1474	1474	2200	1	1	21	1502000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpkrKGNG2nzDGHdMBbr7Y7BxiNfqhDe3iX992M3p771CHrdb9
26270	payment	1397	1397	1678	1	1	11080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6iqQBiwJnFQgWnBr3ya4qNVezMTpeE5LFs9dizbsTowfGbrnJ
26271	payment	1397	1397	1678	1	1	11081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrkV4psmar3dyVuLZXCAbSGWZykznvJWz4reQM8SYKPzLcG7p
26272	payment	1397	1397	1678	1	1	11082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpd1E2uNSQosAe9KtosZ6KR61bJ43RW1EFcaD6kt5ai6TXkzY
26273	payment	1397	1397	1678	1	1	11083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnQK3mnq6RDzZ6oGXa9fnUTfUpTA2LmN2vzR1x7ekyexX3fiK
26274	payment	1397	1397	1678	1	1	11084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmLcJJVTMenCM3yXRCu4G1Bi8n2DYT5LaKpdKzxmRjLu3gW4w
26275	payment	2132	2132	1874	1	1	567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3j57RLpax6qZhamTzRSWUXa5hGb2Hj8HJzMZLAhixuR6DExat
26279	payment	1397	1397	1678	1	1	11087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcmWHmcHXLfbHKnnD9bH8Nnxfa21Htj2EtJAt5VwXQ2TdFdsLG
26280	payment	1397	1397	1678	1	1	11088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsiw3DcQWdbEsQMWzS78w6ibmdBRnBBBsYgdMLFhXErbnhjYi
26281	payment	2132	2132	1874	1	1	569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyC2F6Hn1YwmFZzZjBa6RB3t7YtPwaRViZkqvxYi5bVKyX4Vef
26284	payment	1397	1397	1678	1	1	11091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrVokuuF4KwPhDf7i5wQDbuPFJWauxFkAxdkHkNJK4PqNSwvv
26285	payment	2132	2132	1874	1	1	570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GJ7jZQenaPGKnTbgrCGzgEmKpjJ7jGiL7D1wK5smmwr9Y3dX
26292	payment	1397	1397	1678	1	1	11097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2sS7bPTxorV6xAu4dxkGAQgWxqS4WCJ8rGhbvkLyW5S9YxnJ
26293	payment	1397	1397	1678	1	1	11098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGz5jfjmTsRLBj2t112W366zhCKPhTeFSk7RWkvTyFV5d8km3N
26294	payment	1397	1397	1678	1	1	11099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xMVcVgR5uTFfBzo2pztxFkNVpehhNLLjc8YVArNBfTHRQYDi
26295	payment	1397	1397	1678	1	1	11100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7EC2d9Md4Ck3hiNcmNEk5FaDsSg4QHfvaRJeqASn1cRrSW5h
26296	payment	2132	2132	1874	1	1	572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwt1bzCkdgiunmc6dWkSyVTTeHVjdW9p1NSafCtaTZMuxKQPxn
26297	payment	1769	1769	579	1	1	46	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1VoDpyGfJziGvqiHwm5tWqtCNQiFh1L4o3vvB3nTgrS23C2C
26302	payment	1397	1397	1678	1	1	11104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyEnjjC87ot2e5dUpw5svUtt4q61WuuyCREfWjJkU1E12Mpid
26339	payment	1397	1397	1678	1	1	11123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWorfQNFc7TfQmW2egMPStEExQEe5K3GvTWkgerubLMAKPKFQM
26340	payment	1397	1397	1678	1	1	11124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbuKn8EEU38D3XxQQG3ABES8yt8oS4XgigQMNipfqGXuRAduk
26345	payment	1397	1397	1678	1	1	11128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZi3VMsbnGtdrpns4cKZcWhKP2MuMGRrvqpwrk82F1WBWBZoT4
26346	payment	2132	2132	1874	1	1	581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsdEJdCrbivqszFk1mi7XjN3okYGXKnhsFSWquaaqj8BEwVqbx
26235	payment	1397	1397	1678	1	1	11058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqB11JdJ4K8TRL3M1yq3GB5JGRY9sr1EtkRdH9K6VkNo7iFjJQ
26236	payment	1397	1397	1678	1	1	11059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTeUgJnoE3saVMCLTZkiJ8tgouFK8BiE7jFJSb326SHRLc9Sp
26237	payment	1397	1397	1678	1	1	11060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2tyoa55DBDJYD6QpKSVrsANE8yp3XDfZV37Qe74GjuWGBBKe
26238	payment	2132	2132	1874	1	1	560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcHFm9rMHVCqaWL1pzXa5c7wHzifdxZEQ2QqqZbjostAtTavF
26243	payment	1397	1397	1678	1	1	11064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjepQ5TdrhM1rqzDXpdTHKhgkzZJVkuMttmJ6tcNyUNtuQB9j
26244	payment	1611	1611	1095	1	1	2	3658709710000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCpvY6ZjH88J8YA1xTn7sxG4Adr3ZwsotohTouXhEJoypuNVP
26245	payment	1611	1611	1215	1	1	3	2468604340000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRtiTmDDRhN8riFRZ97zv2HADKwM9p1tcQb2D1YUPqwXFNFdL
26246	payment	1611	1611	1341	1	1	4	6878985500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFKsCHDcFVWSrwyu6wfMisJeAAWoc1c5vyXPcciru7BiQSGvQp
26251	payment	1397	1397	1678	1	1	11068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELkauXMt9w8vSzL1Xq8qzSfrAkEXtaKiNCM9qzh7KqUXsH4ks
26269	payment	1397	1397	1678	1	1	11079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2g7fYvynzTXwrjMwC84vLGJApVeJar46qcx1rkPm9SMYGKhg
26286	payment	1397	1397	1678	1	1	11092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Fb1cCeJ2HQc6YZwLnNEPUi9a4UFamEj6Pq8yYTYgfjDoMcf1
26289	payment	1397	1397	1678	1	1	11095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RedjcGzNFTny4dXaaqicE9pKhg6kRvDad4jGM9zyi2yY9r1c
26290	payment	2132	2132	1874	1	1	571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2cU3jhHzdDWFTCXTJLZgvoaJByTTLtuRPaaMLGtgi2z1j9hr
26291	payment	1397	1397	1678	1	1	11096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvm1NttMfMd2CwKq1kwPFZY6PD4e28cm5wRYUf5Ytt2WMKqVR
26298	payment	1397	1397	1678	1	1	11101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPfGyY8eAMwBATPCUb68hatsH4fYJ1nLWm3SfXQp7Stw8r51S
26299	payment	1397	1397	1678	1	1	11102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjG7WtEDLsGxboef9E8QMry47PqNA1WsqjHBPKBnahE8nptFSb
26300	payment	1397	1397	1678	1	1	11103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJuudP35PemLAnbfch75sdcLtnho7mMJv3b1QyWe7TzZfHkdU
26301	payment	2132	2132	1874	1	1	573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfD8ZaUa7MSpSoTWTZoput8Tfe3AxJAKQexB3Kkf9Q9pW1Anw
26311	payment	1397	1397	1678	1	1	11111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCo7TUegRwGCGC5xdfxaHi7aBsdoNAZ2c1SrT81DKFrKfSACG4
26312	payment	1397	1397	1678	1	1	11112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpgjQU2zCYLVVATS1Q13s3Tzc8Tm4HCqXyeCjWbntK7Dg9AnN
26313	payment	2132	2132	1874	1	1	576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSwTHqBGUXxHDY95CjEHFBsWmbRQEDs4zbftdp3F2wzZBz3AM
26322	payment	1726	1726	2201	1	1	8208	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYYzbRMUHoghNSw2H2Q6jXzoMq4jm8JCqbbKBt93MgxoXizKiST
26323	payment	1397	1397	1678	1	1	11119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pkLsEHC9R8ABezSAn4RdCbb9D5yawkPX5PwD4fJqvwKEyuUb
26324	payment	1726	1726	2202	1	1	8209	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaDxdK5KsbkGgXCQHr3B8PsdjZjauztUJP5YfwwUPHMoL5DPASz
26325	payment	1726	1726	2203	1	1	8210	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYnWXNTw5QYmAxL1sZmQp1Ri4wrWNrUyXkoh342bHNMYyJ3j1KY
26326	payment	1726	1726	2204	1	1	8211	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYZDEF9MiCyCiuXDeoy1CZMFwfsK44ocw7i2PAczA3gGMwhwNDm
26327	payment	1726	1726	2205	1	1	8212	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKju5keyo18JdSbYnnK4kNMTZHEDZw9eV14eyJ81kogjfR4Dki
26328	payment	1726	1726	2206	1	1	8213	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfLXf85ymTpKXZNPAuBULSfe2zjxj4UXdgGTkaqA8k9CeGCFym
26329	payment	1726	1726	2207	1	1	8214	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZejiEYnbZncz9a8TDzd4DuCHBiJxhFG9YDxKppF1nKt1CjYVGD
26330	payment	1726	1726	2208	1	1	8215	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZT7qzHX8NvbdY8UhVg92BKhwXcEb1vZfNao5nu37Ms3fbQr5xn
26331	delegation	579	579	44	1	1	0	\N	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsLocMb4XAziRmvnofo7CPYnnaJDDrpEuzaPyRGC6BvRnYyvu
26332	payment	1397	1397	1678	1	1	11120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQVXLmZGkoYSvo5GUdcU1tXzZbyyJm98ZDmCb6JwC7LU2sbD5
26344	payment	1397	1397	1678	1	1	11127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh59cYG2chH51F12HXuFEgb9CKsWfHGAfEmLDbqyNk6xzyXTf3
26354	payment	1397	1397	1678	1	1	11134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT2S2R9MM7tpn6qebRDQE8AQ5FRckih6TR49MZhRBPeduj4EcX
26355	payment	1397	1397	1678	1	1	11135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidNNhKVy6nj2jtoK5Kpuy2SyqPPhzXaEekvmwtDfGrdS62KUX
26356	payment	1397	1397	1678	1	1	11136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqbphPu1kTfYgKEttnHpJBbf5GJbxavmeHGGNzJN46YWVnbq7
26357	payment	2203	2203	2203	1	1	0	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	Ckpa2cdTwzAktAZpga8UvWSSzfS2HGMPk27bsTE6jCzSf616L1EfT
26358	payment	2203	2203	2203	1	1	1	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpaHf7psrhsjTCSNWtePritBH1rsUWuQ9XUtiKbK6hcw4yYM2w4W
26321	payment	2132	2132	1874	1	1	578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjDB6zm5pkPrTwpfPZuW74HE3BLqw57Jdwrv5cNqHgvx2vnmd
26337	payment	2207	2207	2207	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJsQzsVEmJWsMnraX3uxNNo9Zi85GmseNZBxP6n3KRrr6mzM2
26338	payment	1397	1397	1678	1	1	11122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCYDCcELNo29bWiiApTBLgWDYb1ZZH2ErhL79xJd9cN99fMFq
26341	payment	1397	1397	1678	1	1	11125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjBXt1PbBohbrwTF8TRWWLs1Kjt6S2eR9jadMCTsQHKaaNUEL
26342	payment	2132	2132	1874	1	1	580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1onYStEMLXD7F1w1wRsUbuBLYrtgZNsQAoMqvmk6kE5E3Wkk3
26343	payment	1397	1397	1678	1	1	11126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qodYziQnaENzoATQB8KSEso2vR2qT7aYriTkrcCzjfXtzvYw
26348	payment	1397	1397	1678	1	1	11130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DUv5zUoQwkqzNDb8ryfe4mVnibA5FZwyRpFfss7Y8vwxqR34
26351	payment	2204	2204	2204	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvKWfUByDMXFagxKoN9j7XomESDUTf7ugSG58nfpvnWgzXVr9S
26352	payment	1397	1397	1678	1	1	11132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6BR268HnNt9TdBNQ6BhPM8sDS28JviQLhX6F6BUTJU3qGieE
26353	payment	1397	1397	1678	1	1	11133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZ3k1qHuLSvQyAY67anVQZ5bhXkcETxniS7cAbU4VWuQogWf6
26393	payment	1397	1397	1678	1	1	11148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBcLPJE92g6rJvxUH7AXLtcAzJSbhbDC26JRRJVpgLMTTzKJp
26394	payment	1397	1397	1678	1	1	11149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYK8wHfYTw3MGZjRA7iEu5BDekP1HVtFCCb3gKrhd37jivcsX
26395	payment	2133	2133	1874	1	1	1591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiWmxrAqWRoXH8GUAtnWwDAwiXsZQAT7M7GY8cdHzj6B7C9iP
26396	payment	2134	2134	1874	1	1	2003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8hTdpWYVLRfBtyZtLPTewMNogyeUQeEk9gPt6uoD51SUaUep
26420	payment	1397	1397	1678	1	1	11157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwb3XhtK28KVTk1Y6nWCiJK7j22VoKq4XYyNGWC67dGFbmvz3x
26421	payment	1397	1397	1678	1	1	11158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aPJf2GZnpsNHRuaChoE46ZddeSYY2X1yVX4ivpyeZg83WGkN
26422	payment	1397	1397	1678	1	1	11159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtCnXQRS3wjxVGrXoU2Qkq7dTodWhUYcuU6fvnLv5BYvSMySv
26423	payment	2134	2134	1874	1	1	2012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZey4E7rhoCsAMe1eLwZtD1UzWqdGkmKs5JLyEFererLFYSwG2Y
26424	payment	2134	2134	1874	1	1	2013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdqAGc2FM1KDyG2jNgyAvfwD58kGkVZCoinFwLiWNXoETo38N
26425	payment	2134	2134	1874	1	1	2014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHniph3Je4r1s7BJ4b16bQpxXNjQJzeLDu5pwANi3iE7Y1mn4z
26436	payment	1726	1726	2212	1	1	8218	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYz9bKtf89bQGb7LVmMtNMyjJuiF5dwu8zVjtcVATbLzfMQGfsZ
26437	payment	1726	1726	2206	1	1	8219	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZMWPpLZcqNJBPD8cJV8Fj2cyekLYohgfe8site1RLKQ4W3KYqE
26438	payment	2134	2134	1874	1	1	2020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UcW6NZQ8gVds3Mm9pwt7NGDXurJ4LRsjRf8D5AwZN6pBLdGx
26439	payment	2134	2134	1874	1	1	2021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyBTfTxGDQcwdBCFwB1zp5hEoHphstYbLoAmt5vQQsGyFswDp
26464	payment	1397	1397	1678	1	1	11174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYac8sd1y6UD2tFxt9tox75Qe9SuBGduHrvb3hJg4s681nZEW14
26465	payment	2134	2134	1874	1	1	2029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsY5NGyc9UbKkacCknorBJsQurijapRjhGNzjjia1tjg9hWzgr
26466	payment	2133	2133	1874	1	1	1601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ie6nCQpSGp1fGvyg6zHUBJUg2yq4YjXUxq86jyHGm6PVwF7U
26467	payment	2132	2132	1874	1	1	588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQf8JDNCBsTAJuV2peBfpEuTnbegMsSAgD2skhD4oMZKHzqqGT
26468	payment	1397	1397	1678	1	1	11175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKS2y1K6GBLu5NNfwq1kAmATkojejhsezPF397cqBT1a4ibvc6
26469	payment	2134	2134	1874	1	1	2030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkznZiQqyxEyAU8CtDahoDnmUYpGYudsZw2XnH1QMbJA6JFYsS
26470	payment	2133	2133	1874	1	1	1602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXrdbP8oMyHhyabuak3SfwcJWV3uvqC8aSw95rtobheAVtLB7
26471	payment	1397	1397	1678	1	1	11176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7KybqCeZRxeX8g2QJgoU3hMzy5H6XXfeM3PGyekaAfxQ3xjY
26472	payment	1397	1397	1678	1	1	11177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RzWXXPrAfa8FJutQvKZa2dZv925e8BP3D57ZadX9ufjewvR3
26473	payment	2132	2132	1874	1	1	589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkftoxvDXNPqeuydNrYqdnRaS5SA23G71uBuS7VWgxQkKLYWo
26474	payment	2133	2133	1874	1	1	1603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKgG9TAauvR6H1gQaKH8KCGR6Crsk5TzDDoU1nX1dgQ3p6x46
26475	payment	2133	2133	1874	1	1	1604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mYj8tN1baTmypk5e2B6w5aGW47KZihn5nvsBoNyK3P3uHZeQ
26476	payment	2134	2134	1874	1	1	2031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wthpHZM7N8zPpbmJS8sW8BMiSXhSv1efMGTB2VF2LK4aHo4v
26477	payment	2134	2134	1874	1	1	2032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshSdrowE58RHmFfz1iG3WKcHZ8qgcfHLT31qkhPyGV94bwUks
26333	payment	1397	1397	1678	1	1	11121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHvwz3r3A8VavH5ZxZ2EmcMaRR8L8QaqxJgzQgP8DhnSvYyUX
26334	delegation	2205	2205	1460	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUdUJbmGSHejYHia5kBRJKeAyg1fthiJXXfDHPPvhz5e2Np3N
26335	payment	2132	2132	1874	1	1	579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRELAZfgEwc4mGUcxkbyuhmgt2HDncBZqzRhXtkdBbf6ztxK5C
26336	delegation	2206	2206	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnevb84bGVrtfdHab2Gn2gm3iQdkfiWhHd4EnpQMEN1FzxPVK
26347	payment	1397	1397	1678	1	1	11129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjer2Kn6sFNZzK1PzGpXaMx9MnaAGaXY4nxX2bsjGLSga3A1ST
26362	payment	1397	1397	1678	1	1	11137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cfFXdzXYuBeQLKsQAUPGhdrNb9pEbEgsaHwf8m7vYcxFvUsu
26370	payment	1397	1397	1678	1	1	11141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXqZEJnp4TvkoTCJegM6HBpwsDtf2sgo4S3xG968bmLU4gi1w
26371	payment	1397	1397	1678	1	1	11142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEntLVsgfVuAgqoGsxBAFHTBhuBTCN8e8RyavzVFbQ8zdhV7L
26372	payment	2133	2133	1874	1	1	1584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UGztLt4UUMJM8v2aqhaoFh8Ra5fAVpD7BJai15NZZDySwho9
26373	payment	2134	2134	1874	1	1	1995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVDPTvDbAzBFvnQWpBNcj9kyCSS3giqDtcjd7Rzy6wptDzxp8
26374	payment	2132	2132	1874	1	1	585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ED1oGepq5oJeJzQm9K1kujvE9syxvr4zV6kRV7GzrtEeubHM
26375	payment	2134	2134	1874	1	1	1996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWnfsJkdRHQYpDfJz7G6Gc7HqDmtup4Y8c1wtvMTwbYc2CSRL
26382	payment	1397	1397	1678	1	1	11145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkzsaQUjgtdfkzQq3ruhJw73MLVEBNQLCfCUeq5T1GYcZ9LsN
26383	payment	2134	2134	1874	1	1	1999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbWgCYrnbJq2CKDEMyS65uSfmchiwXBppK6NmtJq4W8MnLii3
26384	payment	2133	2133	1874	1	1	1587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv1etLQLnjKPpftPPbTaNmGi5pvzAfsMinUMCmCkkYNMr9tZEh
26405	payment	1397	1397	1678	1	1	11152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYtrGVKvaLaecFNjC1mPyda9sxNrT62WpxboLZKp9TmCfhLTd
26406	payment	1397	1397	1678	1	1	11153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLyNyc86o553bWLzRmX343Q54afm2tgoTy5WfBy8HAQ3NtxtJ
26407	payment	2203	2203	2203	1	1	6	111	10000000	\N	E4YTiE9LRQ1ER73UuUJXbqizqzzg7k3JN4wBsUvsN9SDpPVGzwbx7	CkpaKfUw5JqzhuukMovtiXNTYeMiQtcdQCJaZycDdm5cDMEq4Mksk
26408	payment	2134	2134	1874	1	1	2006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk81B1SDtZJjrH9gsnJQEsdjRs9VrmPpMA74JRZtzgkeFfoEm
26409	payment	2134	2134	1874	1	1	2007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcg7KRzG3fc99ZDY8rQcUVUK9A5vWpdYWHbgZBXeT13r1AB3J
26410	payment	2133	2133	1874	1	1	1594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6bU7V1fX4yNPbWsD5uuCUfwVqXDj41hTG1YLDkiDWaybnsPx
26411	payment	1397	1397	1678	1	1	11154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWsZAaVqheFn8BmX51TkvYFnLSUnX6DX8erryBW1VdMjo8LD2
26412	payment	2134	2134	1874	1	1	2008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoNiKimygCTZz5uMxTnr17tBUSpLLsW1poNYRtR9SNe6Lej6p
26413	delegation	2200	2200	1540	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsD32GcqPd5TjqBA5KAcud1mJPVaAYmedAS6T66kS5PPZk5TQ
26419	payment	2134	2134	1874	1	1	2011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRRwQcbcrNEUwJ6KPfALQ76FX1NpZ5hZAoV9CbhDKHFmcq825
26426	payment	1397	1397	1678	1	1	11160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaRJYy6cHFcgwzgyq8H5mTjq8Got8ZgdADEVsPw6YugJgJVba
26427	payment	2134	2134	1874	1	1	2015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDz3ZU1TqNB3khxQqFkZwtWmigSZeyPFHWBaUag46cKS2r88aD
26434	payment	1397	1397	1678	1	1	11164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXThLTPkiCh3ze3LwTZxbmRZzufK4BCeEyucnSzhBXmxY2q2TE
26435	payment	2134	2134	1874	1	1	2019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpegMbugQ5DpSFV2jbhvonHFMSL8mR3s2xpjWUjfm9k2WTjLdx
26442	payment	1397	1397	1678	1	1	11167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhN53wLdGU7L3zTAyDxDG5dsEdjNtS31dUFMc83BH1bWVCzKDX
26443	payment	1397	1397	1678	1	1	11168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdEoQ4wbrSP6YVgtBSUnvgsLd7XLdzVHjmou1EqXyZRG3Q7rW
26444	payment	2134	2134	1874	1	1	2022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhKyGPwvE6cypRcf1FTm5rdmRpiXF9AZ9MY7DmJZ4vUATjJMD
26445	payment	2134	2134	1874	1	1	2023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxk5KKzqSzypCURRwo5q3Rmm1b734PvfEk43bR5kHaBe6Xv6d
26446	payment	2132	2132	1874	1	1	586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2eWjec1jVSYqmK23HKEj57KuDYeckjHcQvUWo4ivaNfbBrXn
26447	payment	2133	2133	1874	1	1	1595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqgqCZ7JHhKS6CkoFjb7KaF1RgcYetCmn5F3dCHVh5Rog7DoX
26510	payment	1397	1397	1678	1	1	11187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbsePzZY7UrciUZSXnq1K9EhZ9JTX8Ehyzi7PtycFPN6Bsdf1
26511	payment	2134	2134	1874	1	1	2042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Tyw3Rg9KMGVtf2GKn2hkcjYTu2gumTNFjueBHDx8JRudZQ8o
26512	payment	2133	2133	1874	1	1	1614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbTJMZ7b3H28wJGCVRSw4PVyye7xrGhQ3eY7BAPUEhaJfNeWT
26349	payment	1397	1397	1678	1	1	11131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXDrPRpUQwALZkPRE8oYuR6CdhXX2tJMqcBRWXivUNVpEChxn
26350	payment	2132	2132	1874	1	1	582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYA3aafcowbH2mYBZG3wt7L884jjFMUjgJJSHDCvZLzjtukSjF
26385	payment	1397	1397	1678	1	1	11146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbKFWvpNEikjH2Fwc6ZvppPKaotvm7kBScieRTqCPRKtBjjue
26386	payment	1397	1397	1678	1	1	11147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TRadgs9qtWXUdxL1JdZuguPKHmrxZePLsY3NjdGsHJWJh9pB
26387	payment	2134	2134	1874	1	1	2000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfLHeyu1AM7GmWhor2XUyLyEZ8WKyLAXjL5SmN8tLB4zBtaKt
26388	payment	2134	2134	1874	1	1	2001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2E4y7RXeayisyt1CyCzqg5ozUdzU2PupP2QzYkYWhDoTKUSkK
26389	payment	2133	2133	1874	1	1	1588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDnY4NgiLai4XUWvNk9PnMHHrGHdZKZtGbJxq4CPKxnEuYXgW
26390	payment	2133	2133	1874	1	1	1589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvHvkSRUpELpkwYh5kRGVe9EKgwgDBYb8otdDCBTJpMzDn1k9
26391	payment	2133	2133	1874	1	1	1590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezr7YpJ47o3sQdUpUHB9ToVwRb74pkkXazk6SrC8Q9Tqty7fx
26392	payment	2134	2134	1874	1	1	2002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYoWdtyDeGRNxedyoGvKrAQYsPa3hnqqBjpUi31ypiv7f9qsz
26414	payment	2203	2203	2203	1	1	7	111	20000000	\N	E4YThmuirKrS7KMqe1RnMzpTLcWDEm35r7qayPpYhkPmL76rMMUVp	CkpYUTDpLykJuze4sCJAwymHm5NPnfMB6NiugMhz48rsK9Z6uaZTN
26415	payment	1397	1397	1678	1	1	11155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtDiXRJif2Ktmx9H9VLq35sVcP9Wguij9zAQnJpHMNgNJqmw3
26416	payment	2134	2134	1874	1	1	2009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ8oLGtLufBcpzVSFM3P1HrXRqb3JGkiaJr29R61Cvrhyxvqfv
26458	payment	1397	1397	1678	1	1	11172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QgSwYg53QjzJM5KVtmzPrC6JKZNvVfMKTVtzTWLVws2i1PF2
26459	payment	2134	2134	1874	1	1	2027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1tTwqeP4WSPVq53oqFLvwJUz1LmjoRJQtJYGTddzZ5Ldci3S
26460	payment	2133	2133	1874	1	1	1599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1EB5fppcgQtDgDKuWfGa6XtW2XhrZtbcjmtcuGbjw4buc5kSE
26461	payment	1397	1397	1678	1	1	11173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1TocGjUDpVAqHW5nEHqCjQWkWamsjaBdU83FQeL4dxAiCZqA
26462	payment	2133	2133	1874	1	1	1600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrwbAuDPgcNDXbkKpAa1ub5tpM5TMGRjuYknoVpB1hbvut1Sc
26463	payment	2134	2134	1874	1	1	2028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwR98KPrTFB9bEknjJrYRdxR3QeXUPumZKsLUDGzRQAX4fW4T4
26478	payment	1397	1397	1678	1	1	11178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrYDeAzEwch8djq2U4z64vmRyjdj85WKRm65G31xW6oR5xNY2
26479	payment	2133	2133	1874	1	1	1605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkBgwJ5PDk7hNPxJAeoUEaedGqkWWPNjCzjidR9pEXJJi49H62
26480	payment	2134	2134	1874	1	1	2033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnB3ofWGRz5hgfs6yeHRCsJVNnxdN87TB6hzad3qB7XKw8GiQT
26481	payment	1397	1397	1678	1	1	11179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYam6T7BFeuFJ289tGQPsJ8vxmsRMbuN6jYBDfwyhFn1GfHqW4
26482	payment	2134	2134	1874	1	1	2034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQoBjKEn1gZHCG6hW9SiZkE6hja3asFRBJ7tq6Vx3hPdqUtqG
26483	payment	2133	2133	1874	1	1	1606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbau4aAP7HKrNWqKo8AWrjxsAFfHySvaN1iGvvzHdu7C6CqEUt
26491	payment	1397	1397	1678	1	1	11182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKT3r1jYre12abLMwKRTGovvZ9zpB9Xb3kTAEjTG7eru46wzp5
26492	payment	1397	1397	1678	1	1	11183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UCsbr4HoGqoZhNr5aziVEXFoqjFgw8fp4oEb5zYjKdA23eQj
26493	payment	1397	1397	1678	1	1	11184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2J8AVPHN5vwtsfQMDBhc42wtFBU762C6n1z7CRVTEAH966umr
26494	payment	1397	1397	1678	1	1	11185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQft7JAGgK1X4wnC3JnfmUKp5y1SGFtzQcaUHxkbgzHK17oaF
26495	payment	1397	1397	1678	1	1	11186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKeuh31dBcFnUJdPsKpDacj2kf6bUNcBq1tiPQ6zmK5MVbRaC
26496	payment	2132	2132	1874	1	1	591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrf6mtd2BCCi9YutZ4Mpiw8LsFtodGjzYJAFZSdfSJ1Wt4Xcxu
26497	payment	1729	1729	967	1	1	9	2505800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLW7rgEhYCPxf4ZgcJXYyHBN8wCHoq6RTzskS7G5WjpwSquC9i
26498	payment	1729	1729	1087	1	1	10	4490300000000	1000000	\N	E4ZJMuGPUFJwJZ4YBvP1YXcYVFmmHr8ruyXYYi8zvpFaP8tQQokXa	CkpZRNpztafMUqybegbLSPGjuJYMdLuovP1bbqVCpMkPjRV7q8u11
26499	payment	1729	1729	1333	1	1	11	8442400000000	1000000	\N	E4ZJMuGPUFJwJZ4YBvP1YXcYVFmmHr8ruyXYYi8zvpFaP8tQQokXa	CkpZL16fSejdcQCRhWCRZoRg3HM7zBDcDkyXwiBykXMsEMuAMHYu3
26500	payment	2134	2134	1874	1	1	2037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCj2rK29thtZqbZLS3H1PEVLLP4WEt3QJYL4z5ZFC8ehgzZpu6
26501	payment	2134	2134	1874	1	1	2038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCqkfLzSMGx1TEGh7RPXqVYir98KAXRcQXmTHGhwbNFtj48va
26502	payment	2134	2134	1874	1	1	2039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrVG8L9UMnx5uZA1cyrQpyoAenK5Ma4bGvk1uKB5e96GJwMWD
26503	payment	2134	2134	1874	1	1	2040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1Lu9MrHtjPuCpLBi8A2r2CvJuXHfb1665v1z3rjtdsiZAoHN
26359	payment	2203	2203	2203	1	1	2	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpYntB7uxRh89xLTCssAXkPnL35eqvTEm3N76dpwbMKFj92FBC87
26360	payment	2132	2132	1874	1	1	583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAqePY2tHPXJh3jUjGikwuq5WBHsbd48mLCkzs8FhtN1PvQYb
26361	payment	2200	2200	2209	1	1	0	709000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqww2ZCbmYUa6MZgsHHmQN3TYFx6PNuYQqP4NszUy92w7xpNZU
26363	payment	1726	1726	2210	1	1	8216	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYSakUqEodW93vRQE664N94VsUxCQKszXgk9sw9iszwuLGFCgYE
26364	payment	1726	1726	2184	1	1	8217	1200000000	10000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYf9zQqyVRxej6CZuSiDtRF1XGD7oW5yM1WSbXAHTbKbVFZ52ha
26365	payment	1397	1397	1678	1	1	11138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfcdKTrGCgSgUT7cR7paMStGw9zm6TH71NLo8DW3P1A3kjydEn
26366	payment	1397	1397	1678	1	1	11139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidBvEPE1WQHwFYjAmuuwoNk6YrtZSsSP9ED41UoJwmmJapkux
26367	payment	1397	1397	1678	1	1	11140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZgUfew8oJ1Wz45Ery7rwvWHWUYGacDdBQ4h3yaCvEgMebPU5
26368	payment	2203	2203	2203	1	1	3	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpZzGwCREWoRUVqQBbp9eRfVTdBL3cpBVb87SaFCsUrb5R1AQ1vU
26369	payment	2132	2132	1874	1	1	584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXR5wYZjMe5MaTgup9GCqir3ZXD9nAiQhXtnVShePyuof7ofyY
26376	payment	1397	1397	1678	1	1	11143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1FbCRjKaXJ4i5y5vzFAW6FPdK2eDB3DY1G4LQzAk2m3oPXpV
26377	payment	2134	2134	1874	1	1	1997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZmcXCW4TkhBVLSEworphvZAfU7aLHFHgrcj6y4oQHR5Feuo3
26378	payment	2133	2133	1874	1	1	1585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdUV2uwV1Y6g5cfQ523zogKfyFbBwEaQpVwt4afxcKu1iXUQZ
26379	payment	1397	1397	1678	1	1	11144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmJttaQ1cZAUgoPu7FzyhhczYSHUimC3H1gL7esiK6c4JrBBf
26380	payment	2134	2134	1874	1	1	1998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1r9vjCtfdRpMDQ8JTWS2bdh3hR7r9yHMe4iPiALhM8xeyfUH
26381	payment	2133	2133	1874	1	1	1586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzx4B9Ukq2BkYa8SvQhsEVMUMD37pfMZyBLz5AZhBZkJ1Vvno
26397	payment	2203	2203	2203	1	1	4	100	10000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpYccefZu1crxAJcB4FhXT7S2sy39rRisQQK1LP53QHgPMhdAoHR
26398	payment	1397	1397	1678	1	1	11150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVF4jxT25P79LiuCjaZqiXySFPiv5cPKNoPNFVDKCik8C3H8n
26399	payment	2203	2203	2203	1	1	5	111	10000000	\N	E4YTFhibPeG7K6SQQ35rNJMo2EGY9K4MMFXTLsqne8Gg49GBDpAM7	CkpZHfZpCGz2RbwpETzDezk7BicmeELTdCa1qotVABptuHn3RYuzm
26400	payment	1397	1397	1678	1	1	11151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKq83jncCatqKByB583At9GNodxgUMfGKynZzXG58izGchafj
26401	payment	2133	2133	1874	1	1	1592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZpAfBArHsbxei9DdGG91AUFKqUpxy1b6cZWrAKSLV8spw1R1
26402	payment	2133	2133	1874	1	1	1593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbSTLF6J6mWBjHnWmH1CK9nm3DvUCD9ybpcAZdQMmmvaPgXSQ
26403	payment	2134	2134	1874	1	1	2004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkj7bGSGMBJeYFfJuVqbMe7zuTms4gSPHKpJRnQNcULbXtWDNA
26404	payment	2134	2134	1874	1	1	2005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNeCqDjAQTuGsqbbwntrQ5w3SX56ajb318nZMVAJhwRKm9Q6UD
26417	payment	1397	1397	1678	1	1	11156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXTcxDEfBsucGsQuAgurHJXmmTnYEqHnGLyBu8u6EtSHKdxqi
26418	payment	2134	2134	1874	1	1	2010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CFEy83MYgoJzrVhKSszXtcLUTZpaK89tu2rGbW3qPeG9ioVU
26428	payment	1397	1397	1678	1	1	11161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQHqETC33Po6zMvRavjEYetV9k6xBxGi4DneKh97wLeV5aEpN
26429	payment	1397	1397	1678	1	1	11162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoyAXWMVjmiy4Sxv7RokN2PPMCsgnWXQTKxqKqrfrd51aahUg
26430	payment	2134	2134	1874	1	1	2016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xFvRpYeApHyfHHniz81ZQQGj4mPtEKKcTp2fo5gicinwqZrV
26431	payment	2134	2134	1874	1	1	2017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFefUefA5cuMCaeSbkykL8m1dCRifycHjY33fJiTktPqU6uvKP
26432	payment	1397	1397	1678	1	1	11163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGthYjn6vXAVcTdABRAEpEcmqE1Y94nsuaCoTm1gCzbGyetyd
26433	payment	2134	2134	1874	1	1	2018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1DvpEuQ8fjrp4tpchoq6uaw7HCwrCpzjdNseY8FKYxNFMR1V
26440	payment	1397	1397	1678	1	1	11165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWwTPkTqsjw9E6t2Ao773q9PkWuxkHSNyzurfzNxpVQziqbh8
26441	payment	1397	1397	1678	1	1	11166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NNrxJfzYSku3eLpnMC5VnDZiQtzPrDnytRj4qMK7vxFkeZfv
26448	payment	1397	1397	1678	1	1	11169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYGmDXWyf3c2h8ZRSkwQRZp9JJd5GigZcABCBjqiCpgdqtZaM
26449	payment	1397	1397	1678	1	1	11170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9q62pti1EbzmbW3HKXNAhvVEbA1kiyJjMU6ec4noWx3Kc6YKx
26450	payment	1397	1397	1678	1	1	11171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkGcMRCJ6B2cK8empAWSzVHrR9DZZM72rjm9hX9hopAH5mLkfQ
26451	payment	2132	2132	1874	1	1	587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxspwfGDBBB9pxZ4V6diikpsBvSkichhAogVJQ9DjTkySczKd
26452	payment	2133	2133	1874	1	1	1596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5zimsMsEb1Hsxq56Tm4qfsnCQhH3fAu5StnhDe7q4hPDTcTE
26453	payment	2134	2134	1874	1	1	2024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jxJpaFADnUedn3CtpCm1jifYeqBE6UxF7FG3SiT41oDTT7qz
26454	payment	2134	2134	1874	1	1	2025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5PSzxczdrBfHM5UxkYmEvjFwytEvXQurkTshoJc2rPeanj5w
26455	payment	2134	2134	1874	1	1	2026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSg7QD4h2NCd77Gz4sx2BtEzfJTgwaWwQ6ryCFHYAxpNMV386
26456	payment	2133	2133	1874	1	1	1597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsHjjBWFAnCZ3HkeQLNvyLwKHLEeMhvSgCFwh7zctrq85AeJo
26457	payment	2133	2133	1874	1	1	1598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6csbwTB5ft9xyJqdrTa1WkbzdcSSjEcYm3VLdrp8mmstcH3K
26487	payment	1397	1397	1678	1	1	11181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65tWWWemtmKacZE4iUSuh5hMxXgZEpABKZ8MzXN73RJvfGacc
26488	payment	2133	2133	1874	1	1	1608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYH2mZ3N2EK4DaQSC8hdsBmSfCbANaFjKNTDRS396bpSLXp5pt
26489	payment	2134	2134	1874	1	1	2036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cLR7wiN4GyRwc7vXJzi9sFP4TEHB4BnYJdK1f9UMdRePLGAG
26490	payment	2132	2132	1874	1	1	590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxNTJUAys1C8eTzvcmjrcfjU2MQPHfxchgv1ABMGXY8c1vb2n
26514	payment	1397	1397	1678	1	1	11188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZteEeTUdT5zSBFVD6r9ASXq4aM4m1ptsjrDu2jEVjaFzkPSJ5i
26515	payment	1729	1729	2148	1	1	12	1842438880750	1000000	\N	E4YhKSNxjBMxJV1xfrkQ5TetPDfaDK1bho3nohc5X9sZ9zaxeNzd8	CkpYhsn4Sie1MvsoBJa8AoWGm21H9QMgLHuNPbi1ePEdzL3KNbtbA
26516	payment	2134	2134	1874	1	1	2043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSfZNA18wXuAf3NZ4qyXXSVfJTgkHSKyt4kY9Hh2MQkUtSNmr
26517	payment	2133	2133	1874	1	1	1615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUj2T4qxnLWjTvhn9NLrzDpMrMfHBpk3TFhRtFCE2xCixDvMo
26543	payment	1397	1397	1678	1	1	11196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvnnbVtDh64XNrEbVdPzZb9Rcrbzq7a8Y8G3PCQQHFuzka85z
26544	payment	1397	1397	1678	1	1	11197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJhvFjqGQW1GUwrLJbAkCACL4twvPiQkkkN5jfT8TzjyH4Rg9
26545	payment	2133	2133	1874	1	1	1623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3hu2ayFYPX5MA2v9FE2DEoUVjMsQz3QCkCVQTb4dwHk7gYRU
26546	payment	2134	2134	1874	1	1	2051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJqEeZisZs1yebCf7PrWT6Pmutjy4xbpvmtQDMHwpp2aoVRdc
26547	payment	2134	2134	1874	1	1	2052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYciVK4q9C3Gv8NQJs2jZJdjReGy5yFMtFgwhor7331WKwDyqvW
26548	payment	2132	2132	1874	1	1	595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUHY2ovmc7htRpE32cHGTKuu46qTwJ7c2sPUqBRCLuq3sYv8G
26549	payment	2133	2133	1874	1	1	1624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcp1cHFXxHozAcydnWoEQ55g1jp1nn5AeLMKb4bCKpfyRZmyuv
26573	payment	1397	1397	1678	1	1	11204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJapDY3wFc3J9QkSgQNprznuG3cFu6yEjzfhsKgdAmHZ8VLY9
26574	payment	2133	2133	1874	1	1	1631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDn7cx8AzfWqPKjZLZoQrCNqLXEbHYaH1Pxp5ku22hV2cqZhqu
26575	payment	2134	2134	1874	1	1	2059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxEEMJeWZQiT1EMbJkdLxHcVSh3igaEEoApCEMgyorTLKBxEJ5
26576	payment	2132	2132	1874	1	1	597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByjFsxYvUGZC5A2BLomsPsPMMkxZ95ptqwwaUBVtRS1vs33NJ
26603	payment	1397	1397	1678	1	1	11212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpteVSAWjjJLuP595xJvPrh4K9BT8qAJWDTmQGVoEQZQZ3KPK
26604	payment	2133	2133	1874	1	1	1639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejebPJbYevjVmSa7zqyA2WXdA332H1xUBsX6JrTanoR7pv4ad
26605	payment	2134	2134	1874	1	1	2067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJDrHCVRAZHs52Gg9hE8vAB4kYr6G696XBwTNbHc5295TYrJb
26606	payment	1397	1397	1678	1	1	11213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4XAi5TGYUv8QCiK1kNeqvdjJffWM5jCFFwDDHymoroQY9dpjN
26607	payment	2133	2133	1874	1	1	1640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWhTdVWCmAvQW6cEc4ThxnnAL2cWgzySk5YCfijfm61Vddniv
26608	payment	2134	2134	1874	1	1	2068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39Fb1wWr3WP4SpajakTAow4PMKAyaAsv8qhYPfYa89Nreybyj
26616	payment	1397	1397	1678	1	1	11216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD5UgH19MJzsm75GLRYxBLELdf4nPbFdYoXQDB9iYcTiF6F416
26617	payment	2134	2134	1874	1	1	2071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqmRBzThYFQ697VfsNcWDpkyP8tJuuBkDXBcweNsUTgjApw1Z
26618	payment	2133	2133	1874	1	1	1643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDmvhGs2KFGvJUW3azxuSYP1TG8G4wfcPGer9pEQTWjistEwrj
26659	payment	1397	1397	1678	1	1	11229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXeSU54L4sj1zN8ugLusxr4bTEvyqd168kbxjVVAhc1HtNyH2
26660	payment	2133	2133	1874	1	1	1656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9Dpw3H2bYCzyNqmGq4gLUEkfh7g7zXLCKq5nqeFFxFe2pMu4
26661	payment	2134	2134	1874	1	1	2083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtZDKnrNcoSwqKozBA21UkHc4mwwncyu1txukt2RiHnFXVMMS
26669	payment	1397	1397	1678	1	1	11232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe14PnsBT4u1WjjZaK87UpEESJzmpWRJSAX1jY1gmBbU9gt77Q
26484	payment	1397	1397	1678	1	1	11180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MLQR1ThCdu5VLfd5BLxWnf79r1kKyCvBURMoeVSVSFahvJaz
26485	payment	2133	2133	1874	1	1	1607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniaSEcg2JNDuuCX6fZfxqEdKtCgoiBYNPRMKnhGrnW4ZbNpaV
26486	payment	2134	2134	1874	1	1	2035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU6Jx6YS9DFHvF5hNoHhakxbpCnAKeSMDQPeeqt9KBD5EG3rE
26518	payment	1397	1397	1678	1	1	11189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jWTpYrMkPVLwKe1y2KjF3aeyUZDbJhYCpV2UWFpB7kzErKjL
26519	payment	2134	2134	1874	1	1	2044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdWg3WHeKnoVXwNr26UQpVeWU6QPZSACL29S4hX1Fu3HYbHSK
26520	payment	2133	2133	1874	1	1	1616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK8YFvLZ7tEVuQXP3MQXZUyNWxG7r79VisuvfTvscXTGK5Z82R
26525	payment	1397	1397	1678	1	1	11191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKq6p7Kwwq8ixNu6GKxUUNgQS4gwbki2g8h6vZniuvFuTuzdJx
26526	payment	1397	1397	1678	1	1	11192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8ZjEPdBZVuYcXFUYx5jLfV5U64Zpm4LaWnB7NFN7hwAejguA
26527	payment	2133	2133	1874	1	1	1618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxhsU5knEijv72jAo6J7bzEKfDCPbM4BQBKTSi8DefRA3QuSu
26528	payment	2132	2132	1874	1	1	593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG5vinbte7YGec5xbXm7KL2VxvoA7NmEKTJ8EaXVaiCrKZofdv
26529	payment	2133	2133	1874	1	1	1619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmS7ZHrfsoF44Xfd5MgzfzrRgcxUKyo3L1uLUgaSYk6aYe1fSQ
26530	payment	2148	2148	2147	1	1	1	971800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWXqeBsCpKfknrgaGsjj7KggfRS4528eKu8zYXWJV6sixE8TT
26533	payment	1397	1397	1678	1	1	11193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3EPeMBu62Eqzzo4VZqbtzf8iT8Au5Y9d5MYhURYv3oPKbcQBe
26534	payment	2134	2134	1874	1	1	2048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPw1tqUYaL2dKmqq9N7n5VhLDiJdkEAXugyaEMjAT3xDAPYvnt
26535	payment	2133	2133	1874	1	1	1620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDfkVyFffuJAEDNZWvarjo9nxCtNKNBLLXpJRG6kGVVwhTNd3
26556	payment	1397	1397	1678	1	1	11200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcT9k1vmhiWB7hVP4Ya46D5mUaReB3tyN4DaGLXaSUyvXYJom
26557	payment	2134	2134	1874	1	1	2055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimckBmhtp6haNT4J4Ffpybk6ddZMEvYa6F5CWNTPJZ36yEe7U
26558	payment	2133	2133	1874	1	1	1627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLfBfoMq5NubQ1MXnavwthv2mN59yXYdaFKNFZEfTb8F2dyHk
26577	payment	1397	1397	1678	1	1	11205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh1yRkm13L4DcVw99cVtJx2mjNo5GCvTSqcJ3pSnGzpbjEyX4E
26578	payment	2133	2133	1874	1	1	1632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG6ZiuHWxyXvF7irpKyJBwxkBysdEZkKLgmP1H53QjHYgMnJKV
26579	payment	2134	2134	1874	1	1	2060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGty8g2Stph1v5v7Gd5sRgQkghQwoHK1ncEH1JH44tnKD6WBn
26588	delegation	1502	1502	1502	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDbUFxqwPZ7CDqcutfttCod5GPSJsYfary9epa4zcmUopafGF
26589	payment	1397	1397	1678	1	1	11208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYvDMyD4r1dsEYDn7WC76vXqWGo1tFYtoH5PsF61QxJk1CNba
26590	payment	2134	2134	1874	1	1	2063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpMQqi9tW3nrR7Q7nXcnXxjekELWzJX6Q7WeMyKY5HqJMi6p3
26591	payment	2133	2133	1874	1	1	1635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3CSVtKVQ2SJjKYTWcYEcjJaiS7a6q5rudihvcKw8Zoc6yfNQF
26592	payment	1397	1397	1678	1	1	11209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYns5eUTkzbbAPPihXn8irNPE5J9RFoapeAQSuGm3MyDbEzHvwy
26593	payment	2134	2134	1874	1	1	2064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC6FUEfj7mSfnmq1HhvP6wwbD4jsPpbsZzsD4mjwtM1KpRZBBZ
26594	payment	2133	2133	1874	1	1	1636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3hUZ76TfcZ4n9W5yvPLqvYrxTNzUFhSsR4NnKYbg8j1V5FDe
26619	payment	1397	1397	1678	1	1	11217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSKfVhNmfWYWgzF1kYN6divbD81VjjYG3reRTmG9KrvVfGc1s
26620	payment	2134	2134	1874	1	1	2072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUby1yReyCRJohgMvNAnoVX2CTGM65wyvNJUd3tihxVBbFQZdx
26621	payment	2133	2133	1874	1	1	1644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqtcwD9FTGH7PgU7nhQmuW88voGHbPLDR9zXdctmMX67kG2ZF
26629	payment	1397	1397	1678	1	1	11220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTZ7NKvLANT57Mq5hzeEeyAmYiSmk1LgtMez7F2GnxdXGTMRc
26630	payment	1397	1397	1678	1	1	11221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycLxU1ZDQbozjuQwDAbQGPSpzYNK34PQLFKW3SWJ3oWjCEQ2v
26631	payment	2133	2133	1874	1	1	1647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYha2fBBJqoseUahGXnVAGw3D94VLikieQ77GjCcFeFFBYp6qLH
26632	payment	2133	2133	1874	1	1	1648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhn631PF2Bo5aUJ733V94Qf4DHU7w3JHD6pTP58P2mhRXSDVhJ
26633	payment	2134	2134	1874	1	1	2075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NPRx6pnUZm1BBomPZt28EN8dF9XRnwiJY1AmEuHUcaB3SjNP
26634	payment	2134	2134	1874	1	1	2076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruDVromeCJzQE9tboA4JMWnCzFr9o4GxhhHovMmY2U2tUo2rx
26635	payment	2132	2132	1874	1	1	602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmMY4CEVeyKaEEEh7ehUNDDYgTjmELMowDZDTATpQcqqDekFp
26504	payment	2134	2134	1874	1	1	2041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfk9rT4d4ymBg52gttHpor5ffawEwZ1NX3tp67FdyQHbyFTFh
26505	payment	2133	2133	1874	1	1	1609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJVwVTqYSRgQudU7HSxBJLhotiGkeusKcQeRE3DZdze7p1Kgc
26506	payment	2133	2133	1874	1	1	1610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypkyrQ2q7B9ZsJ5irj2f5tepFyDq77MmQ2q4gjro5YayswWhH
26507	payment	2133	2133	1874	1	1	1611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgy3QPbksN2acQv6pr7U4AWEiRCdYPtUX1TZxkbgheGENveLLC
26508	payment	2133	2133	1874	1	1	1612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9CdYMkQ4gvazJz5jsRmJx3WeXBjrRRcNAF5RdWB4sbNDSPhg
26509	payment	2133	2133	1874	1	1	1613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmoFP7XWAZyMJ1cS43LQiDuhwKjat64dqukjbw3RMdhddzVYE
26521	payment	1397	1397	1678	1	1	11190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRQtW7kGm46oERsdKzkE1NG7QMYzhLzYpNyQWWNhzVuqZpcgP
26522	payment	2134	2134	1874	1	1	2045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXMeSVUaMstkaw2UjnKRZdGwaaweqn1v4rCJhbqVJRjQM5pmm
26523	payment	2133	2133	1874	1	1	1617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNT8nCABBVrrwHPZowhYUTLx6WWm7fjjQ3gvtLfmeYrQExtja
26524	payment	2148	2148	1207	1	1	0	3029700000000	1000000	\N	E4ZJMuGPUFJwJZ4YBvP1YXcYVFmmHr8ruyXYYi8zvpFaP8tQQokXa	CkpZCESvUoLTUWUvUfitb2HMEJvmUBV8f3Y3BybNCtrE4y3VEAJqy
26536	payment	1397	1397	1678	1	1	11194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHstyWUhP7RqRtcjmcrj67Jzw7JJyDwceFC5UfAraTzyypvin
26537	payment	1397	1397	1678	1	1	11195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvfLMnRmWYfvrqgUDpfqqxGySDMVJK3i6bzUwLDGCf4oxt7QTp
26538	payment	2133	2133	1874	1	1	1621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8k8xcyQExCATxmVUst85Xk1Ru3NZKctyuHYmZbQsbvKSwegY
26539	payment	2134	2134	1874	1	1	2049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEDuZiyPGDERSXPmQS3uoDuXQBvEY3zahNRGxhRhcsRzG9c8J
26540	payment	2132	2132	1874	1	1	594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcmkxEftgvgf17caKQJaASoMoj8vUFCy2jDXTkqfboSYwYwWRg
26541	payment	2134	2134	1874	1	1	2050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8yaBDMRWTRhAddjD5mk3jviqjyH5sQs55CEMCvhJBTen3Yw5
26542	payment	2133	2133	1874	1	1	1622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAq76V4pydtwf9ED57oobMR9aCNP1HWyC4XtGdr9k6pts8qHa
26550	payment	1397	1397	1678	1	1	11198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mC6egGwYorN7LFh2NKpV68PvvvjNPRs6WTSUdGB7Eb8ipxA8
26551	payment	2134	2134	1874	1	1	2053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnypF7SUPKySFPJbFa4WHpEyJXFGraKzcnMFNNrgZkQ6qub6J
26552	payment	2133	2133	1874	1	1	1625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnh6X1kSdHx1tbHWZ6bvXnwpYvjWoCZEZM5sfGovxyka2CFrsj
26580	payment	1397	1397	1678	1	1	11206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XJswFT8gLPAWo5kYWvGCTRFzg8df6Fnmkdu9tdvz1SuQ1n6g
26581	payment	2134	2134	1874	1	1	2061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahaPar7vKMbAeExG9aFCNQXXYQNCBj4iogyKGdZxekmiG7miF
26582	payment	2133	2133	1874	1	1	1633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2CoksA3SST2cyUPJYiF4D1PtMMMJgkVeqpqC1P6UZDZw7pw4
26583	payment	1397	1397	1678	1	1	11207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgegARRn3tNymRseU8nzKtwe2ahTUStrPzKaEfVrnTjKPJSdyv
26584	payment	470	470	764	1	1	10	1009400000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvqk2gKi1LCkAYZYookcLVKmLUUmfk172WJesLG55MKUTWKQv
26585	payment	2132	2132	1874	1	1	598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjwf3LGfBcjLh9syM5csjzpayyRn7PAUW1jSShPikpq339CPg
26586	payment	2134	2134	1874	1	1	2062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeaxx76c9BzKh4RD1YcoAoihzdwyHwbNbLcXCUZFc9ExCjuExG
26587	payment	2133	2133	1874	1	1	1634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhxfZwM6zAN25erMx5kPfpLSg7wEdxJYppogfiF6Cnr79Xj6a
26595	delegation	1502	1502	1502	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBq3iN5vffkbt44XS5qCYB87JP7mEBBu1VnztHZ5hMz1fEqvv
26596	payment	1397	1397	1678	1	1	11210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7B3STEcoy1fxDx9RPojYscNAXGYFP4Ygk1Hcrfmss5UKmzwCY
26597	payment	1397	1397	1678	1	1	11211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xcrt5An9YvjneTo4d6jTGGZa7mmo1CS76gQ2donKtJUkjrVB
26598	payment	2134	2134	1874	1	1	2065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNz1aJJRLr2K6QQa5tLaY9rvnVjxqEGqD8myiJ9kCtiPpnWs7
26599	payment	2134	2134	1874	1	1	2066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWyqx5gf3PPGmXdmV4msPUgz1JLK8gV69kpAXXkbXJvrWu7vS4
26600	payment	2132	2132	1874	1	1	599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzub7vEqy9RxqRqfhBGcJuST71yFoxmsCU36qbsuxwhZbYkZRD
26601	payment	2133	2133	1874	1	1	1637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFiMoma9URJtLTzjnaEUkyAxsUo21JRa5d4nHVNodo5ZMzCGcg
26602	payment	2133	2133	1874	1	1	1638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPR4rTee7L4e8kvGokYGjZipS7EEHfKMDbHpkPzMFrRkdUW5A
26609	payment	1397	1397	1678	1	1	11214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmYt6MUstX2WGQZC5kbmpb9MojVehp94mqVdERp8vhAiFszQk
26610	payment	1397	1397	1678	1	1	11215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAna3WLf8HVFUf1NzxWsF7CjMC1kJXgoabTDs7nGDkdSYE2vud
26513	payment	2132	2132	1874	1	1	592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Qk7vf6MeSLWNvM1JLMxFx4VGbiToCGHK4iS8b27ph4azEJe9
26531	payment	2134	2134	1874	1	1	2046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2SosHGGz5ELp5kKXMLUsegbLDPigKdaSoPpYYC4yXtpioneL
26532	payment	2134	2134	1874	1	1	2047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VCZqugBPZCAaVSHBXaM4zTcmBg4rivWQjq9X2EWGXht636ju
26553	payment	1397	1397	1678	1	1	11199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzGHZ9z1jDkbzCjrRzGxpcKhHFEJwrhAaTMzZjJGLgZihMQYi
26554	payment	2134	2134	1874	1	1	2054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYFq5VAx3a22PQazAGMtsLcQHXEUNE1ERECHCVXxoCnV9sGpuD
26555	payment	2133	2133	1874	1	1	1626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBi1QfGN3SGStBotWnw7UtYTWb3rbGorABQ1d5g5y337YUAgZ
26559	payment	1397	1397	1678	1	1	11201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPWXgzra9FHEdYgGzK9dKz4thMjGTPtMs94kLHrDsXrP2B44i
26560	payment	470	470	1309	1	1	6	6450000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgarsSFGxvjPWLVMjMCdhciGDPs3Nv8EKxLA6ez7UeoRXsvdWE
26561	payment	470	470	1063	1	1	7	3431000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWkvXoes4F1nyWjM79M5XYyjxYXmrnbMZdtJroQU2gRSQa6kk
26562	payment	470	470	1183	1	1	8	2315000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAkXcbBjyVRmtJpTGcSGHgKLLNumGAK8nqSUCowekmfaPDLcS
26563	payment	1397	1397	1678	1	1	11202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzG7dFE2eRSdQC41XScBsyw1yuU16zi5THcRGUVbGCnUEaxAS
26564	payment	1397	1397	1678	1	1	11203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYWAFXCH49pRZqEsKu4f9aNsqDXZgMiFYZTqmzjGTifFg7JKy
26565	payment	470	470	943	1	1	9	1915000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumDLJhkoJPQSMXeQGc7tmiEiDpWuKo3ZWvphUqK2f9NX6mMs4
26566	payment	2134	2134	1874	1	1	2056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AGNUgfibAMvy9qWVErwFboSXsoES9RV3YTVFfMBiGJ1UHEDX
26567	payment	2133	2133	1874	1	1	1628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9YdqcA9GDpqx53QF55byrkox473mNYhygEvaDLsXCM5rRDRx
26568	payment	2132	2132	1874	1	1	596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjC8CiWgjMectCZYhJXbWVDoq5CEghkekX4KVdnPP4bJ4ibJc
26569	payment	2134	2134	1874	1	1	2057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQ7v3KfFSJW1Vx4YZdeVdXQm1s4ZMoHGPXYFACXopR53ph65X
26570	payment	2133	2133	1874	1	1	1629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZST6Th6cu1rApk6XGCmfwdQsRoNA5oHgFnFDKti9rfAFkPUtM6
26571	payment	2133	2133	1874	1	1	1630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurqBSzYZ2vKjtmGiKTViWo7epjqxnNf5iPd9xBdUwAMeT8KaM
26572	payment	2134	2134	1874	1	1	2058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHcKX4PvQ9dqsnDbpdx2u1Q2ghS5ywWz31iiEZ5VXQDCNXdg9
26622	payment	1397	1397	1678	1	1	11218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCvGDiXRPmVuTZwd7ipaBajz2j27Q35B9zWrrRwwZrz6wLcbe
26623	payment	1397	1397	1678	1	1	11219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJErCGskV8aeNKv4Tb7NedeqbSdLieDTEyuC93mrPqDBixo6w
26624	payment	2134	2134	1874	1	1	2073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUqgz2uuoJjLXZX5ETkm9hf4k3zikhwgiCDLQzPZTgkKZAqZy
26625	payment	2132	2132	1874	1	1	601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jYRs6U68xMd37LsDnZP6Ht6aqXKRazaHMAoPxrViRfbASLnz
26626	payment	2133	2133	1874	1	1	1645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiRmsbMeHz3QpGJbmtARr3YPW5VayBJ4Qjtse3JjhgDy1hzk6
26627	payment	2133	2133	1874	1	1	1646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8vWMWWQhJS98dxbZa7DFRGA5FMeGKfA6C446Xub4DV28oTbq
26628	payment	2134	2134	1874	1	1	2074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83BQMRFZh5wyZXqHsJHWyuMNjamJpDkdV2pE7JdckWmhJmA4f
26662	payment	1397	1397	1678	1	1	11230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CqPvFDLMXUzjNDdq9cD1giTnbRjWGbkU3Vwd1pG9GxJH4Zp9
26663	payment	2134	2134	1874	1	1	2084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7DwJEaT6qnpHPdFCoohcV2RT8Xy51pX5CeYMLAKWfGC4P5rn
26664	payment	2133	2133	1874	1	1	1657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutFuKqzBfUGctM1xMuWTvKYmRhdVu81bz5WNFzVarw7CdGXix
26665	payment	1397	1397	1678	1	1	11231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaPUuZL2L4H5Esci6MCayAkpasFtB6aAW6c1yeoRRdJ9FM3BDb
26666	payment	2134	2134	1874	1	1	2085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZYhDaLQGJ3xw6ugEsyk386i6MpwJuDFygxtHh1AR2qHJhZD7
26667	payment	2133	2133	1874	1	1	1658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTmwDVdrvY2mpCgvZNRQeDFBARcdCV7SHsiGW45AJ2Fv9SzSh
26668	payment	2132	2132	1874	1	1	605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkVpCLdwq2ajGQ5F82eiBGWw1MudpWHjH7E1FLTjZj6dwj9RS
26672	payment	1397	1397	1678	1	1	11233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJVXypeRFAkkJBtmRRcY2oKf66d1u831DFczat4wEirKxhC1D
26673	payment	1397	1397	1678	1	1	11234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCb6DoybJ2oTTd7MmhnQKaF45qRer8GrrdFTGe6HLRUtWLHuc
26674	payment	1397	1397	1678	1	1	11235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUyPGwerD3qriJFFq3LB7B5hBRyW99ZwsGsZYxDczf5d64tVAM
26675	payment	1397	1397	1678	1	1	11236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfjz2gUv8XGbp52s3FsWyLJ6ipboGdD7jHuupqBwTRWPWUpuN
26611	payment	2133	2133	1874	1	1	1641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9Ug4nJ7XT1FRGvtkPsACxe6Nxh5qZ3euJrJ47ei3vkdDPKVR
26612	payment	2134	2134	1874	1	1	2069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogQCDUoi2Qjxp6adWsN1F7t3e5ZMpGAcwTW1Vd4TghfZ4Ls7F
26613	payment	2132	2132	1874	1	1	600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPHG1nUBYY3rkkC4PvLnabbQMTnBTQ5iBf2eqPKnBL8dcVcbT
26614	payment	2134	2134	1874	1	1	2070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9XJrUpBhWfYcLKoidtSfT4vQnH5R49EUBaoV65U1tKYeAYg6
26615	payment	2133	2133	1874	1	1	1642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrk9M9qRjvT1uExmQnJKAbc1onm4VcDa138AFy7ZJVVkpp5Q9s
26636	payment	1397	1397	1678	1	1	11222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5phQrw8dBqVBuSK1vmMUpUCDBH6Xz2TCaoXfS8BCcM1jD5m3Y
26637	payment	1397	1397	1678	1	1	11223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdntQQebHRQRKQzBuryAugHniFDjbFVomDR1fFo5tBaZfjUzP
26638	payment	2133	2133	1874	1	1	1649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgT3eAX8Lcz4TsLhEDbxpMm2gdaRTLVBPYn695fiRYa5paZNGf
26639	payment	2133	2133	1874	1	1	1650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSE6F8Qaby2TsSGPQdyAwUZC9BduH8FWjNDjsMist88AT1PL8G
26640	payment	2134	2134	1874	1	1	2077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazXBU3aSsXYJDhNHGnFPY96RVCS58HGbMRJStt6oFuC6wTy2p
26641	payment	2134	2134	1874	1	1	2078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCMkh5QkEEMsF4rU9r7eVKYtv9cJQiySZWcn9hmzCc8XMzhWv
26734	payment	1397	1397	1678	1	1	11251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zfhKLviygxnjCvwepq68cQUCNytNJzyCx2AziCPD83GPRoa2
26735	payment	2133	2133	1874	1	1	1678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeL2VpeUBdEbvayWNuGSEGGoki7DVH9VpqK5emTWjwfBXkYVs
26736	payment	2134	2134	1874	1	1	2105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFDWnwLWGw65vdwRNhnnvQh3oL8BwUNYkaYNYaK8RWxxGTyUN
26737	payment	2132	2132	1874	1	1	611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzizP7xe7SUNaacEZDW7wYqekhqxLP33DRNcijP8rWP3Z33pu5
26748	payment	1397	1397	1678	1	1	11254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CoFsQf5HieqDRqh7CxT57yYbiQDoNqgJ9ECQ9p1yHA9vnY7v
26749	payment	2133	2133	1874	1	1	1682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Wc2aYnxN2Wsv5erVCVadPw7ucwtEULrpdfe2j6gDc7q1fKkt
26750	payment	2134	2134	1874	1	1	2109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyaeMxzzkLbjZ5V1F59Mg3Vnx1BRxa5RjkoqnKBRAKPVoTFS9
26772	payment	1397	1397	1678	1	1	11261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVPtemXR8z4fVjMGrFnW38gtuQ2qzqP1DH8fEDDFtFR9CBsKc
26773	payment	2133	2133	1874	1	1	1689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5YJ5t2VjEpj26DK2swcqHZ9UNonFSpNQC4KaKnVnwgCJ8vGD
26774	payment	2134	2134	1874	1	1	2116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPdr8pZiAYHVdSWSCoKh5qe1cAzdnX8mVYRZyYuvAs2nYLimc
26788	payment	1397	1397	1678	1	1	11266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYNeSHiPk3qJN6XEFGs6Y9pNRxjVjWCk7F3HkfQzagfEUNJuE
26789	payment	2134	2134	1874	1	1	2121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvRQs3CRCyrLtePspqqNPRr1a9LtJYo7PDgAvTM48nw3QxG4b
26790	payment	2133	2133	1874	1	1	1694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJBHXYvNHKefWVvqs6vpQAhfKj25mujDvP4c8BdwNZJ9yurvP
26830	payment	1397	1397	1678	1	1	11277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisVQFww8QfWFh3yF6CbpceV3Qnfa6uiaYeGyYRGVTFL4ciE1L
26831	payment	2133	2133	1874	1	1	1705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5mffjaVd8iwe3Bzjj23B2UCrk3xUDTtX4X7qUvsFPymxK866
26832	payment	2134	2134	1874	1	1	2131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3mrdDzYynp7TzQ8zWqqDTfUGiLwkppV1sB7jMLr4fqVAxvvPF
26833	payment	2132	2132	1874	1	1	619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnVuMLKjxn2UPH1Kie4nGUwmLeZ3DvEXSErGrBnHaKABXtivT
26855	payment	1397	1397	1678	1	1	11282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmr9u2ST1wzBVntosFJqM8ppSCYzaevEaWG349mT9etHedBkc
26856	payment	2133	2133	1874	1	1	1710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9LJ7aXGJYvxUCjCDtbvhif1R48MvaQAe257yca9QRN8CtFT2
26857	payment	2134	2134	1874	1	1	2136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXZrvLcXygQ8wmLhNKeTG4NQnGf2tBRfRuKZda5qhA3ni6KmE
26910	payment	1571	1571	38	1	1	11	71854038164	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYhUh7i9u7hQ3xerywDaTa655YoKK5YB4573X4xyyVt217ygTpn
26911	payment	1571	1571	969	1	1	12	547083452688	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYsbvZq7HMgmjBJoysgacAYLwksdgQcqZg5UKEFNkvCAc1RHLFa
26912	payment	1571	1571	1089	1	1	13	980368859808	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZ3dMemVgv9yoN4pbjEvaFk8rkzTdEVAJFrAvbiMKFPRHLWzMZr
26913	payment	1397	1397	1678	1	1	11296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDq8ebHyt7E6c4NAMvC4MxfLsZsW7FkAxRiiD8XPFxFmq5GH5
26914	payment	1571	1571	1209	1	1	14	661474404942	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZZvdfvaDoKatdW1TKNyD1qfmd2VNwmsdEA53v1aTj6Ex54zRe6
26915	payment	1571	1571	1335	1	1	15	1843257244392	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaGAKJYxKCERkzUGj9kDwQ5vb5t33LpsiPnn1v8ymikZXytfdyX
26916	payment	2132	2132	1874	1	1	625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTSRop1BMnVsdQtv2wGXWjRMEp9JoBtpm7D1UABhPxyZhGVAeK
26642	payment	1397	1397	1678	1	1	11224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqcPQRP4QbLzy2P3oSF9nBZzViPnA5SJrCXxhzhhRn5x3uAZx8
26643	payment	1397	1397	1678	1	1	11225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovudwm6iQ83zcwhNpiWToASimV9A8dc7D9wot4f75Unh9zfPm
26644	payment	1397	1397	1678	1	1	11226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38Sby2w58P78ah4CggAfhsaTFeebDXCUUKsw8HUpcLNc9Tr6m
26645	payment	1397	1397	1678	1	1	11227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyiPrAukZJ6prT2zbJHjpjioM8ThdMnuzFiCqBpgFpzH4zqqz
26646	payment	1397	1397	1678	1	1	11228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Zvv8JiV5EazbHkVvkzhuUXwXmFRGng8hkUFTtyuipBB48fcA
26647	payment	2133	2133	1874	1	1	1651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW6f3Qo98pMwXEh4z6oasvaFfgkTjK9MnCDQE7DUyCUEYQ1uo
26648	payment	2132	2132	1874	1	1	603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTcaMChpEDk1Bncf4iSThbuqMKUXwzkFKqu3jXznzaJirGxfX
26649	payment	2133	2133	1874	1	1	1652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcmPXPFzpDz6EaWkAj99cuDq2guDSw4Uy5PZYYm2tCMp9NQTf
26650	payment	2132	2132	1874	1	1	604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpu2RBf9sKZSnbmnPtU6eLhu7tQYRgjfNVaHSQPC58joX3xnC
26651	delegation	2163	2163	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXz5xeouPDJYerc8BCLHWYFNXThkChwexv6Sp1qQmTNswdyua
26652	payment	2134	2134	1874	1	1	2079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufFbAu3S6B2vBTYoQn2ndFa5VU6fwzVDLeLvxnaF9zbTcWMeN
26653	payment	2134	2134	1874	1	1	2080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyfP9LzfgsfetRWBAYqgDj4aRNkv3vNKMAnJLG3R8iM4Lfwtz
26654	payment	2134	2134	1874	1	1	2081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aBXyyo4XyMH3D3FF35Bdwn9orgpit67wqATpL4mLkeZDKC2n
26655	payment	2134	2134	1874	1	1	2082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUW867kTF5qZ2FDwBMQjTWmLYDkGApfbPqtQhuEKjy9W5RxU7
26656	payment	2133	2133	1874	1	1	1653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13dmBPkT7QM59TdfsKyHUArKRi85mxnWbYzH3GGRotq7mPurk
26657	payment	2133	2133	1874	1	1	1654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CKscTfnUNC1PaUZz9brE4najt68bYTQdmXYrRWqQCHwv6jnn
26658	payment	2133	2133	1874	1	1	1655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZes8jHR4wrUqw8ZYemD5g8MAPgJY7fs8j53RmYCiB1Tmen2913
26702	payment	1397	1397	1678	1	1	11242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fZPxHFf23D7dvXiU2gvgejw7pMQs7S7EXbALXsUow5g181WN
26703	payment	1397	1397	1678	1	1	11243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49jkfWiEsSjv5Q637Yo8z1pUERS2n6FViB45zmxQSv6pHdc9j
26704	payment	2133	2133	1874	1	1	1669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbthZwCUA17FsFudbtYDJZPVAbdTt3hNBYBdmairyhX4Prbuk
26705	payment	2133	2133	1874	1	1	1670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgjSRdrwXwWCVQypRqZyQW4UCACDraLVGhHraBptJxkw6g9mX
26708	payment	353	353	2213	1	1	1	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiqwhqykiSa8HNH8NDjChmSfFSspw1ifPXsgRMa5fpmHBMdvP
26722	payment	1397	1397	1678	1	1	11248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgN1vJo1c4nunNyWJzWB3wQkkfMzUNZ22tQLZd9i3x6Urnh2K
26723	delegation	1993	1993	80	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvBiynsUEtuLs8MVZWARf1czcNt5mHQSBinU6Ah3jA7L7QPSQ
26724	payment	2132	2132	1874	1	1	610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cAvAQNEaXqZmNEh6c56QraJNHj2MPYgvsvU5DEkhsX4KF7Nw
26725	payment	2134	2134	1874	1	1	2102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiUxoNyZWbAdaY7kcAbSpsaJ5VPnv2owfTneQYim1PrZNav7B
26726	payment	2133	2133	1874	1	1	1675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxUadMexpAK3wtFsUZ8uuMWuCqb3eFo6RvCNJn8yFu6hzpd75
26738	payment	1444	1444	2214	1	1	5	1000000000	10000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZh61XxEWFz5V79HP6my3i3hBq2PQG27h7XnSi3FkVCAAugDfuK
26739	payment	2133	2133	1874	1	1	1679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWNpjFeEDPZjLtW5usfBKEZdKaRFbVa2CoBvp3cx63yE2dH5c
26740	payment	2134	2134	1874	1	1	2106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Cs1UHQcbgSPVEeky1tpxDDs9TBXKVQwpTShciih1qc8Sa7ZA
26782	payment	1397	1397	1678	1	1	11264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ48MgS9gc6EWQc1pEYU7ezMJCsYN3mm6pTpoLks5hyhhozs9
26783	payment	2133	2133	1874	1	1	1692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvR76NkeJRPdycqZLhQALYRv69z5RYzQxCqNhHquWZ1tzrSFzn
26784	payment	2134	2134	1874	1	1	2119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTtpCbzq7h3MA4uVLwee5fSqyerd1y7d8s8929sQeKNYD3wA6
26791	payment	1397	1397	1678	1	1	11267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAhmbk8Pm3ww9GnaJKK6kEFu437TPPwPCMigwUsk37V2KhY9H
26792	payment	2132	2132	1874	1	1	616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKo6QmtehimGSCpm12aswM2csD2bJQKzdgVshA6gpHBrq7D3q
26793	payment	2133	2133	1874	1	1	1695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYnL1QeH7AsUaDAdP1aLThJSqq5tmKzYzzGXfipz3HWQjKfMk
26794	payment	2134	2134	1874	1	1	2122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkMDN2AzHx7fS145bD6P1XnrCrC9ogZcaNdiCBoB6EdbCXrWE
26834	payment	1397	1397	1678	1	1	11278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqartwcBEQzBitqDnL21se2iGxAR4oy7PR8RfFoyi8L6qCsfmP
26670	payment	2134	2134	1874	1	1	2086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymS92m5JCsw6w1cyiZQSjei5bze9NdoaojFP3sNX7C52D79A7
26671	payment	2133	2133	1874	1	1	1659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8mkSRnU8MXci1PjerTjXTbbqzqBFFTQ6rnj7ZN6wGzfhdwQ2
26713	payment	1397	1397	1678	1	1	11245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD5V6BVMtzMH3CrjVDb3HRv3mJSL89iE2MLQ5CkFByV6zkmPW
26714	payment	2134	2134	1874	1	1	2099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZbw7DeNmvFHsz37JbdscLodczWeuCQ4maJ6FjSrhT52fc3jT
26715	payment	2133	2133	1874	1	1	1672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8A5ViEvuc1z7LznsRjgw5znzrbGSpMBz3qrksw9pxJPZbwv2
26751	payment	1397	1397	1678	1	1	11255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4b6pcXQBT3vCCgwBvmVwidy9fWcsaU1TwwwFff4hjZhW4mkkc
26752	payment	2133	2133	1874	1	1	1683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9sbeo1719zRQ3jkKwoRxbcy4Xo8CAPfwbE1krnRnyGpDFsfG
26753	payment	2134	2134	1874	1	1	2110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PivA7N3TT7fNz1fpt5KhqrL8iy4qTcJj5M2xhP3hVvUQBE8Q
26762	payment	1397	1397	1678	1	1	11258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbzqyer2tAA4MbEnQFsafY1XskdcBrA14QjKzadLtM1T1usYF
26763	payment	1397	1397	1678	1	1	11259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLT1ZhXypjkJiLUEKZdS9FRHDaKog5R9CztYo8GnzYkBqxS4U
26764	payment	1397	1397	1678	1	1	11260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CoVC5mWyt1ravwoswsBGSkehtmQPLs27qsQhaoqwL3rU7oh5
26765	payment	2133	2133	1874	1	1	1686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmtXP7MziJVVRt5qFBBacrE6sUFH3Do5z1ZYi2UC2gjTwh2H4
26766	payment	2133	2133	1874	1	1	1687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyimJvRXPUuhjerKfSb3AdSGvCdFLpjvRQSjW6ru61YRnCqUj
26767	payment	2133	2133	1874	1	1	1688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhuQc3gAq8QskbFptcUGfEgkGv4o6XqCDVCGzMvzkgr3DKRVrt
26768	payment	2132	2132	1874	1	1	614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcPQpWDRGYbNozamGR4SVKiGxQEtEjGp2ndkPigzKrodrHDAg
26769	payment	2134	2134	1874	1	1	2113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVJSJb24sMbXvh2RmtJkthdfmgEJvHWnzYWqV4CAV2CtKf6Hj
26770	payment	2134	2134	1874	1	1	2114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkUMRjRs1Q52YGMvRNyqtjYD77iDsqLEvZK6HqZj2BtsuFFzG
26771	payment	2134	2134	1874	1	1	2115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6JmwLjLboy7BcY7cVGaQvsJC74572Fncg6EkF7WNxZGXNsNZ
26778	payment	1397	1397	1678	1	1	11263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpz3CEHpiFydWuL1CPByNhUEPbiMUbADGhY3UsbMHs3NC3dxsw
26779	payment	2134	2134	1874	1	1	2118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJGMDN8M1gHA3dgi7zg2GBfto5fM2MBBFpPhUjkHQTJer9HZs
26780	payment	2132	2132	1874	1	1	615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6GfDZNdfG78igtcNFDnEKmTjCQrnWGCzQKaMnGFttRr5NtjZ
26781	payment	2133	2133	1874	1	1	1691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpjLdsEgVvN3hd6AYteTh9dWfeYFBNWgAgBHNfHtZtzJxC7fp
26795	payment	1397	1397	1678	1	1	11268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNz5iHDrPU74Tz1wJeELKYmeoEg1DVmruztHXhxhNsQuyqfJjc
26796	payment	2133	2133	1874	1	1	1696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGEiMQtaQYEFE8HM8AWcT1xqpBG86iYfxBnnzj8NDVoUP7dph
26797	payment	2134	2134	1874	1	1	2123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyyNJ3S6X4b1myFAFmQ2zWzasMMjRxZ39ucCSwJniV9dVJM35
26802	payment	1397	1397	1678	1	1	11270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4nyEoC6McDfHvfg9sD7qydWE1HUCRCtcbuW89tuuDtcV2buM
26803	payment	1397	1397	1678	1	1	11271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiT8toDpT1ZAtR9c7nVwsVugTqJgGrfdfspAk5a4tJLDpQugbq
26804	payment	2133	2133	1874	1	1	1698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEriwT5yNS2hp2ZD93zf92VfMkQZ7koizSKXEotuaYkH6Vidg
26805	payment	2134	2134	1874	1	1	2125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLaEMjhA3CKPDrBy7aeoXEQUzhoggsQEdTRjp6y9V24GqSFVFz
26806	payment	2133	2133	1874	1	1	1699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqisy8MqusEhvQ3MPHmxg9ayHnojxx7YURHSTZ2ASEQKUk5JqQ
26807	payment	2132	2132	1874	1	1	617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjTFUsw8cXzhAGgEqrcZUESYu3cetJjW8mWTJqGkN5uzp7v31
26808	payment	1397	1397	1678	1	1	11272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9BFvBuayuLKhdw4NmzyiwRmwkDHAvbpanqb7Cu6uFC3DJvAB
26809	payment	2134	2134	1874	1	1	2126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxifT5MkfB5AMijKYEGVgy69NKTPLPxLqpKCEMJdQFpUQJ4Cu
26810	payment	2133	2133	1874	1	1	1700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQ4EeELk9N9WZUzxHS2DiE3JT5f86qtU8weS75CJk7X3TewF3
26815	payment	504	504	266	1	1	2	301000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuDjjk2Wc3sECRGV4a5SMmDgLr3o4EPEiZXJKCJPhzNtL9Yio
26816	payment	1397	1397	1678	1	1	11274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRMxok74f124x3JyBPftphpaYEPWUEcwXyv358pivGbFeYqa1
26817	payment	1397	1397	1678	1	1	11275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE1e62PQh6N41ar2Sh9ufQ3gMFhXD8K9RAVeQJuAJRujDwUQ5
26818	payment	2134	2134	1874	1	1	2128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyWUi8dLzRjqmTXH2iLgKGDw5bdQbMS3hdjvAhupqAWaHW8Bk
26676	payment	1397	1397	1678	1	1	11237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9PENw2UKzwdyxsQid6hNRQ7d7sa6QcXysP7rdgB9YpcfgJou
26677	payment	1397	1397	1678	1	1	11238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9b55kKTsUzWJFDTdqA3V587s77BEHRQECPdt4P6NgvTAK35hh
26678	payment	2133	2133	1874	1	1	1660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe2km4NUhf5Sfw58yLAbRmwYcgKEYxRsJUbAWoUCDgypGtVFk3
26679	payment	2132	2132	1874	1	1	606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXG6ZhdF4gNSKfyMW58nDowM1T2z8BHxsbpkVaPYLoByPh4YAP
26680	payment	2134	2134	1874	1	1	2087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4B8rLjVcb2RNCiD7wMJxZu5Dqr4wpHg2MyrJ7ww3SGgfMd7M
26681	payment	2134	2134	1874	1	1	2088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtsujw9HrhkQEiWsHtqKyeyPVVQvAWxGD4mdzCnC2d6xPKngk
26682	payment	2132	2132	1874	1	1	607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mjgCytxxSGodfPYB9mBc81K5mtzgtUSjN9GGaDj6w2MfmGno
26683	payment	2133	2133	1874	1	1	1661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HzCt4uBQUZF6c7ZeyyTLXCEP2w1dMidHza9YH8Jrm8QeriFx
26684	payment	2134	2134	1874	1	1	2089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MwcNzuGHCiDDenrZjQaUf7FbXiW52uXVbLts6R7zFNmkR3tE
26685	payment	2134	2134	1874	1	1	2090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Rk85ezzsCccPi8dovsmuZuQWECdzbdFeniMEAtqAAf13iRiR
26686	payment	2134	2134	1874	1	1	2091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXUpKc8ZyFnsbEv5yXhHv3dgPFKaSou9DZpK1No5cDDvWcAvQ
26687	payment	2134	2134	1874	1	1	2092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6ScH7ivuceuykbpUYyzo12Wve2iSJSX6WzAHQhAMEz1ME7rB
26688	payment	2133	2133	1874	1	1	1662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGTienvypGXUDKTjMoPJYFuoVEGafiR3d6J5GnjdgLcAKH5w6
26689	payment	2133	2133	1874	1	1	1663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1D6MXur95zNtVgQdpWtcX9moRrzuPiuwRqs28RrrupKm38dj
26690	payment	2133	2133	1874	1	1	1664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEJUYo3afNexR7PB6uDrWZKZZymaEMg5ongxtaYJzVhqNGJec
26691	payment	2133	2133	1874	1	1	1665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEpeW3wBHux8KWehH5AEDYvVwWFu1MCBv4WGJuYRGFDEDTcwT
26692	payment	1397	1397	1678	1	1	11239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNmurqU55xiSfv16Q9deJBKkaqE4eCumvUjUrDfaE84V21M95
26693	payment	1397	1397	1678	1	1	11240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDd1Gaxgqs6HxHn8JKhcGDiDBiKE3BkHzs6YUCtWkp7s8JBpiz
26694	payment	1397	1397	1678	1	1	11241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKYbmkNc6zjzFvwPMS6z2R8k8k7uuoEDMBkngF8CFJSHgnta2
26695	payment	2132	2132	1874	1	1	608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6EUoFJEYcqTGDvAqi1WvK7p4jaaPKH1p4MaqenoEcM4sYqnZ
26696	payment	2133	2133	1874	1	1	1666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP2CmAEthELiR2cFLiWhHKASvPaPNVtW4yFDLH1v6R2TEwhrK
26697	payment	2133	2133	1874	1	1	1667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEUP833Wu6FntANoDMQLa2Sg6RBAKoXPBMuw8JRVf6rVgrHeK
26698	payment	2133	2133	1874	1	1	1668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2tLioHgZSuKGDJ5zvTAULDhBvEHMM5VKAavtQjnmRzpNTVqT
26699	payment	2134	2134	1874	1	1	2093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DuZonv9Uvip7xDDqQTs7eKKQdJJTgfVrXt6G6UsEj94hHV5c
26700	payment	2134	2134	1874	1	1	2094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwnu4sPvWu7ZGKuNmiMrBwvaSmgp9JwGB24gCihPpG6J6cfMf
26701	payment	2134	2134	1874	1	1	2095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThXSf2UwdT9LLFvMm6s3ikU3AyBK3T8GELLbAyR9yADY5kouQ
26706	payment	2134	2134	1874	1	1	2096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWe3p7atqz9XBeDmGLxtrQmuASfkNNDcD4qE7GG7ZS8nkkAezg
26707	payment	2134	2134	1874	1	1	2097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bfJj2zJsopGubNNu6Zm7WNTiwRu935Xmw7jQGKYr6wpscCYC
26709	payment	1397	1397	1678	1	1	11244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQdV97GegkPZdBkEQEEH49ReH8nNgHYuXX3upA6nGP2mA1M7M
26710	payment	2132	2132	1874	1	1	609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTcVJ4BcuWD4S6mwnrk7ZqznqSyuvUqDo7fVYzfjogEF2wpXGd
26711	payment	2134	2134	1874	1	1	2098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECDfFFEgZkeo6MpYyxTS1yAyaFiWsrZY21Rqv6cnk2THKDpLQ
26712	payment	2133	2133	1874	1	1	1671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvZT1TgCm2RNJTceqAGhQkSVRyJAveANaCJcefs8zmHxqXagP
26716	payment	1397	1397	1678	1	1	11246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGu9Voi51YYL5b2VvtqFnaSnAYG4hXrQL6ycvaMfv3C4V1nM6o
26717	payment	2134	2134	1874	1	1	2100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXDwUZzjd3mWgwtkv2DFokeUZT2vsYXzUqAVxYUdNUJHtPZyU
26718	payment	2133	2133	1874	1	1	1673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYp98o9CbGx6Umq4xVD85mtUTapuqhTnVBfXyUyymDthET4GU
26719	payment	1397	1397	1678	1	1	11247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqympnYNueDtwKXorPvYAKbPBFLXyC9XzvXfVRZHhwChM4xm2u
26720	payment	2133	2133	1874	1	1	1674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHwu1aZDzb6q5nSgP9ATTDXCqkDH9Tgq9uAMHABBCpA4i62Ad
26721	payment	2134	2134	1874	1	1	2101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNjtjrrsaGnZXkqzLRg2t9smQWVCzffsRQo1CvTF5HNjpdz4f
26727	delegation	2213	2213	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhR1c3BrGWVgyqnvDEH1CnGi3YdVpPB7Tu5fXLPGSyS56gHZUq
26728	payment	1397	1397	1678	1	1	11249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWx3Pfu9mFcyyoz2HAg3hPfprDMEgU64F8bcTn4yc4RRkb8ff
26729	payment	1397	1397	1678	1	1	11250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJtkK2xXFg5fzj1Pk8HtZPjEoYkxXaBztTAFaa9vRYK2i1QCF
26730	payment	2134	2134	1874	1	1	2103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfQf2HaNtxGPhAJM6BemDqEM9My2vM63qmYAqe4GCMWraZSB8
26731	payment	2134	2134	1874	1	1	2104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPN7tm7tVNAfLdLFdhd4Y6dTCmPCYYDdMWgeRjjgz4wJmZyvU
26732	payment	2133	2133	1874	1	1	1676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHKx6KYaDUzE28eCkSCPtPXAg3RJigq2jL4KDcbHi28U69NetZ
26733	payment	2133	2133	1874	1	1	1677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HN7hBHG7tHLxasdQws55vkE6AZbkyS6jxnVoavVDGmdAUjir
26741	payment	1397	1397	1678	1	1	11252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfrM7krVv4BqV9XHfo8n8EUA6ySFcSaj5pRi2mbvqEaMp8zsg
26742	payment	1397	1397	1678	1	1	11253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa85BykUNL3gZKDcw6B8MMkXWjSyECnkGcLFgddioc8s8odKJT
26743	payment	2133	2133	1874	1	1	1680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiCRMJciF6LqJb9NYhVZzyuKrv3ZKjH5MVzcucP3nzmCT262SA
26744	payment	2134	2134	1874	1	1	2107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTG2pnbY4Tbgb647uvmCnwLHM6sxB5wvYCKBqQZtHvPTvPehE
26745	payment	2134	2134	1874	1	1	2108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKF4xgD9q8ankVsbBGrimoUVpzbWFnndY7czr6DY2n5ePLEzZK
26746	payment	2132	2132	1874	1	1	612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofCegGySaiFokUMzBP9bPU9PRXbQphRXJM1CarNZ4BEjdh61V
26747	payment	2133	2133	1874	1	1	1681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAjPVKMwbmZDzSWsfzy6CziyMUF972ybTSoDFDA82zN1DThhek
26754	payment	1397	1397	1678	1	1	11256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5d8724Kmjz3Tv1ZdGDfeqLUndSymjbpaN3qCh7ZiRPLQcCA5
26755	payment	1397	1397	1678	1	1	11257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzC7oaRyLPJddo2oaEKmh8wNkRrjAkwknaBi3kZb4LttZ4TyDh
26756	payment	2132	2132	1874	1	1	613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDz4oFTLfJ6AueomVf3hxbKbTEpPSp5HTxZfNZQifz1N64trzu
26757	payment	1592	1592	592	1	1	1	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmX28srnkTyE67BbNivGLd2xuR2KaMUHvJbBbrjYAqfUNdrJr
26758	payment	2134	2134	1874	1	1	2111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbvSqKfC4fBsuWPrTYiKA9t9BzYg958NjzVMHWGW1X24fPWqc
26759	payment	2134	2134	1874	1	1	2112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGoQn5smWfUwjdEAH67X1n9j9XQ3kPqGSjAWsUp4P3XQopJoE
26760	payment	2133	2133	1874	1	1	1684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7scoxmhHCsnnwsojTAnRRA6rSqi7B2TjDut8mGzEKGEvH16Nt
26761	payment	2133	2133	1874	1	1	1685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpkRc1PNWL4Aud2L1XPVE9tvocGLXzr1uug5Qk9FLJjxCVVma
26775	payment	1397	1397	1678	1	1	11262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmZCCcSFuFTjvzxBZf1Z1vffj5UmLcUCM2KeQyWRXNnmPhCmw
26776	payment	2134	2134	1874	1	1	2117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3MCV7E8S6EKJp8tbDzrQKYT9mdJKR3vNkieHYskrka3jwUGa
26777	payment	2133	2133	1874	1	1	1690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHb4EyfQp4V4n5jDJdcdxT3Z6QUyEQBUERiHSggNycnsL1zoE
26785	payment	1397	1397	1678	1	1	11265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH76vEv1aexNEyWDraGzXZh295TxSb4YfLfcuraArfP4ZT7VTj
26786	payment	2134	2134	1874	1	1	2120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdz3RUtXxEMJLDhQVzs8s85SYdJjdi1zParKToTp4L6d8ZzFWo
26787	payment	2133	2133	1874	1	1	1693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pbUa29osSrhCTGtgLTumVa3JjpMur7CsfdRC16nzpiowoLen
26798	payment	504	504	266	1	1	1	309000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyV1X6WBLzZimPVyiQs26AjSE4muMRN79gYcEZbTiVnsvsfgX
26799	payment	1397	1397	1678	1	1	11269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUFHiRybn4EpLCjYEqcMUs3vYv6rsrD9VXNnwMiZbtfAvySNF
26800	payment	2133	2133	1874	1	1	1697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjrpk8uwMz4zo7YTdr75hkML1A4Qb6yssyXD3qiSoa1WvQKsw
26801	payment	2134	2134	1874	1	1	2124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVr1HF3zc7sg65MgSwa9MiNosdjGyiBmJq55pGDAxsh51bUD1
26811	payment	1397	1397	1678	1	1	11273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFT3gUCpy1xLToWkfWqBrxHiX5DeD1SdNHxYjMFJC3Hz99nhk
26812	payment	2133	2133	1874	1	1	1701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMS7toKRLSJYaX8Y1awHFYJdXYUxkeKQXvbUmhw1HkpJKHMELW
26813	payment	2132	2132	1874	1	1	618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeD1cnPgXitbeLGArPvDEoUthMUGSRnieabLyacNce69hddX23
26814	payment	2134	2134	1874	1	1	2127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa37ajmggasq5cpCetWjWx3yhzjRp1K7Q4Cq6HiCe7kL2UnrD8t
26848	payment	1397	1397	1678	1	1	11280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdMHK1KTGcMUv3twmEEVrwGLXg7VcKD2nmVBqqJXeN59x5NpP
26849	payment	1397	1397	1678	1	1	11281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9873z8mCqhwwt9hg9rmiDWuADzkfqma9w3xtxVBE3srfeNJsK
26819	payment	2134	2134	1874	1	1	2129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8V1s5WwqR5aa8v36caEBuRzF1TeQf6ydc1uNHMJEyAwMPB5gB
26820	payment	2133	2133	1874	1	1	1702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGPpc7bbQgcgWj44p1kL2Sq72uxWj4VCg9KqR9Ch1XYTg9KCN
26821	payment	2133	2133	1874	1	1	1703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUmtnJwPT4iPzbDjawmL3YV4t2Qr2wJEF1x17mQk6CK2c7Q4w
26822	payment	1397	1397	1678	1	1	11276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUK7sEmoaRocsddziP6GRJn8m2DoYVGNjvpWrVFyNr2BDUtKP
26823	payment	1571	1571	38	1	1	1	83861377858	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZnwBobftuU5ZttVnneDuBhugnrU7ZuTTRcNeEe7gvW1Qne8z8m
26824	payment	1571	1571	969	1	1	2	638264028136	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYjdwTNueqm1yaXcNU3zQhZpys8CoqY1wA1TYfyT7XmEVC1d4Yj
26825	payment	1571	1571	1089	1	1	3	1143763669776	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZyFHVFZv6kfz2CLWnUchUuryDRbZj99fyAQJxz4UVVZkKcNjYk
26826	payment	1571	1571	1209	1	1	4	771720139099	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaLkX4fNtQjvxB8Zcwo7ZMzxPqLgh2y44dkaiX8dNDoXm3vVGQj
26827	payment	1571	1571	1335	1	1	5	2150466785124	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZpvkS58Qp6BNdYVLbWSUCuV334XWNKdYVAkoPBJgrkA6wjzgVf
26828	payment	2133	2133	1874	1	1	1704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQfkHwhPXW88KL8VJjXykpNrg9Zk9aQPErLMnCP7Rc38cbCji
26829	payment	2134	2134	1874	1	1	2130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7e9bqGEEqhaAw2fMXyc3oBnPBi714oWKytJqLEiVTgCmsxLhC
26871	payment	1397	1397	1678	1	1	11287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUfx7d7Ww3KWDQrZe32v5eqPf97uGTXLRLje82FabXiygSQAb
26872	payment	2132	2132	1874	1	1	622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxmtyNUv88AxF4y6woi94sSBKCg2kjRVyou6qpD3mpRwoaKYK
26873	payment	2133	2133	1874	1	1	1715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXrDD2DAmPxhL7C8v9oFHVqtt4V7rYmMhfvZgZin9hDeWW5v2
26874	payment	2134	2134	1874	1	1	2141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4AGgsjcqD4WJcrJ6dkm28eFXR3gnJFadT1G7336StYTR9HQ6
26878	payment	1571	1571	38	1	1	6	35946969082	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYSqZUwVunxp6kdSwsYwr5gDvQeKT7Ehvd7vdvXu65ZE8XTB8we
26879	payment	1397	1397	1678	1	1	11289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRcCUAaEYsj3a2CcazyYQ4299P115vsZdsaTJ5cJt5o7wfqWq
26880	payment	1397	1397	1678	1	1	11290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUBuS6L1munvGknPsaKFoS5K4QFENxLzyRRVL4kirS3suYB2U
26881	payment	1571	1571	969	1	1	7	273541726344	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaEML2F7Gf8SbHM7A7NfJvki4bUoyXcD5UfaehJvQWPz2qZzqHt
26882	payment	1571	1571	1089	1	1	8	490184429904	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZS9YyuAr1d1o3o33AhjsPChzMNQm3PTzZd6uAZM8yvQ7kkbrUy
26883	payment	1571	1571	1209	1	1	9	330737202471	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZj5sk2meWDbJmoKwoBHX8kz1XfNi2FxtCYGmTwVUiwaZHzkz71
26884	payment	1571	1571	1335	1	1	10	921628622196	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZzvWpszZ3iXvsAevmwK4YWbrZknDYMwmESXppys7FJyvsJQgbm
26885	payment	1397	1397	1678	1	1	11291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcL1RUJodGWoLDc7AAs4KE4kTd9abjEaAESFkmQKUwaTu8biM
26886	payment	1397	1397	1678	1	1	11292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpMhwEh1pUfpUXrxUh3b1tonbcGGb8qWvQMYN5zfG5P3QKdQM
26887	payment	532	532	1724	1	1	0	3590000000000	6000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpYkVjjxKkcwuduEbw4upahWKy1Rh3F2vcSZZZiqQbJvAL3DpdQU
26888	payment	2133	2133	1874	1	1	1717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVR3MkcGAQhxfeFrMQ6ZiyyRxPpu9HffXRw2XQkyRR9dtLKWk
26889	payment	2134	2134	1874	1	1	2143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47Hc3EhEBSv9Bpu4caVzrquBddB4XfWtcM1DFFUa1aTPvDHkg
26890	payment	2133	2133	1874	1	1	1718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMxpnaWEeTeqYuJdFZpNu4nWEWsSHYYV8GGnHmfXAdYVa5wU5
26891	payment	2134	2134	1874	1	1	2144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM91SkDyszwRkmzi6sborJ3eXSDEvkJwgDssgWR3K8qUz2MMUK
26892	payment	2134	2134	1874	1	1	2145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYfaYiyCPrmHtw9r1yjKDhXrp49Xawvtk71Jenrodxz9YD7ww
26893	payment	2134	2134	1874	1	1	2146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarrw6jw7P2cR5cVQU7zkoRw7SmYeZotR8Jf4uDnR56iP7RpdX
26894	payment	2133	2133	1874	1	1	1719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw9nKxmzrwHun4F54Zyj9QpBqWgs1LBgHAU8v7PdTqSo4js7tY
26895	payment	2132	2132	1874	1	1	623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21NcxHc1QnuhwTuzoBxrY1xnEtbJWDsQ6ARGbgFh7jbSp6MQE
26896	payment	1769	1769	1769	1	1	47	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6NPvfMLGYb1t7otyzDuTzQXzfm5LsF5HCRqkGf78PRfvDru26
26897	payment	2133	2133	1874	1	1	1720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6UB5dTDNvq49YjT7KxxQN1gjfKQ1zRMomtVaJLVUtP4jQfb6
26907	payment	1397	1397	1678	1	1	11295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4ndyT5PkUbzRWf1nfHHJ2MvaqWD989Aph9dZqkxbZ4c5f5s2
26908	payment	2134	2134	1874	1	1	2150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkbnKn6u54KiUvS6TZ8jgQ7XUHsERKRmuxELRWAjUxaLp5b4G
26909	payment	2133	2133	1874	1	1	1724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoaknVysGSDrE34iJwbotxV6NpGFU3CTDAJQAJSJme2cbVUdYY
26835	payment	1397	1397	1678	1	1	11279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm6G7icTU52bvq78HBvPeghgCdLdtcagiATQTzwL4ACzvwrBD
26836	payment	1749	1749	1950	1	1	18	2000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq91NG36F4Cy5GpyMukBd41kFTEV8amUZX3bnuy9omSfa1KVh5
26837	payment	2134	2134	1874	1	1	2132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDf77Dk3cnCrxfYELUsogcFa4f39UsN8e4rCeA1sZhTCVBHMtU
26838	payment	2134	2134	1874	1	1	2133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KiuB7eyUxjHvT9EFmrD2tiVBvHUVV9ajHzTJyDtHhW1NkQ3X
26839	payment	1726	1726	2215	1	1	8220	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZY5f9LGRWu6Gr4dwJXxuP6v67r9C9MaGpfesYJhdHMEv8rreSs
26840	payment	1726	1726	2216	1	1	8221	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZP61ePAgG5t4bsnfJnTqPATbQc1hwR6vEExLJDkiFKEj5YvJbb
26841	payment	1726	1726	2217	1	1	8222	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYay3yKEYZyw6s7C5HqLLbANgq8vwg6CyiE34npSMeAiavyYABh
26842	payment	2133	2133	1874	1	1	1706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJLTr5G6YT3sDstc95WNxppWBqhchEHmv4ZHeTAn48cXukjdE
26843	payment	2133	2133	1874	1	1	1707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEzDhpcygL36vUTLNkPrL8PJWhCN4UpG77TUQ4FzjSGaPdp2e
26844	payment	1726	1726	2205	1	1	8223	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZvNgKide4UdXhv2EEBHTCajguprBvGtBNrA2nyBYshRZZcdAKN
26845	payment	1726	1726	1930	1	1	8224	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSFM4Cn5GSRb9uXLbbk6DMgh1PD2Qtt9S3T53kRFaC6WkASi5H
26846	payment	1726	1726	2218	1	1	8225	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZcNZHFQL1oUQsAyTetHqERUFish3117fZGmTd3pc5LWyn3GnCY
26847	payment	1726	1726	2219	1	1	8226	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYhpwswM8Ei7VMdxqxiMvY1GtCX6WoXJkGsoSN35cR9ekrksZbu
26858	payment	1397	1397	1678	1	1	11283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kfqeFRUEJ4UQcdf9ZTmfHRMgPhzRuQcBKdGGjzWDoQbtgavn
26859	payment	1397	1397	1678	1	1	11284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMNAYhqwaT5if3V7frvJ8NAXf6wGEsbun6YVX9C79CnrLBZbf
26860	payment	2132	2132	1874	1	1	621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEPVXHfopQbjQLL8H4qPEXowBUm7kFQkZYaj59KPhQKKTYDhp
26861	payment	2133	2133	1874	1	1	1711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF2aSpVH1uTctnNKRwcxcNbJQWtJDWrCqU5EPZNVtP2JsXz5Dq
26862	payment	2133	2133	1874	1	1	1712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WLquigZLKZbufpypT5pauq38Zd7SKgatL2KotMXeHDfkCWBL
26863	payment	2134	2134	1874	1	1	2137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7N1VGLCzZedspG24MaU9rQfXi2CxZUuaatLPQgiV8oBFbN4RD
26864	payment	2134	2134	1874	1	1	2138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAi8uNtkCBnYUMmfZr7xmCJsN8476wz3XuHsg39b1WX9eYpU67
26875	payment	1397	1397	1678	1	1	11288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZTPMz6LiHniGrQSxjCJgZ6qAWVoJNQebavQL5wxQrkQko7Bh
26876	payment	2134	2134	1874	1	1	2142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLRixXhhku7udjaBEdH9DkWzKB2uH1TVcipcF3yK3sgi8W8Po
26877	payment	2133	2133	1874	1	1	1716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwKFT2vtvbpbGV2ymXbdbSQ9zJdt6v2kc7yRNmMv9ZcZqaocP
26905	payment	2134	2134	1874	1	1	2149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfB3nVPYrKDCm53TdZj68NU3HWPfTTFXzWtZtJCRzDhWq5kR7x
26906	payment	2133	2133	1874	1	1	1723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMY64sLQZNftLCHLr9ysEktSzYcSfb5EZSt3d8cLFND77PDp1
26924	payment	1397	1397	1678	1	1	11298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDykgeeLWAR7TxXPuGHDkrNyeF8zmYcRcuExMwT3wUarTomrnP
26925	payment	1397	1397	1678	1	1	11299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJvmF7shmxxC3PqpzedvPikeBauGxWQx4vE498nrhXvFwRmWs
26926	payment	2132	2132	1874	1	1	626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuB7etzbVY2b855cFWDiVLwjgSmiC88oDpw6SDCYsLBAHQAo21
26927	payment	2133	2133	1874	1	1	1727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24yKDTnMVNQ3Uxjitn4Mf2XbpHjx4PuFQUQXBZND7r4iMyc7e
26928	payment	2133	2133	1874	1	1	1728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4pCQiW3HSjfFbG9aVQPpg9T55gGaayNWGGEnkNMmYQCgFXpj
26929	payment	2134	2134	1874	1	1	2153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52K8fVu33wt71x6c2YJkyCuKR2jkikexCFPawKXHK67yRy7Tw
26930	payment	2134	2134	1874	1	1	2154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLj3HfeiW2HiEtoRYAow7h3tY9XieZHwnN2eZK46kuu2x7UbA
26955	payment	1571	1571	38	1	1	21	59979698470	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZ2ewukjDzAGm3FGGwvjaCbvuqwvAAHCrEbZrNCSzMZL36unLw3
26956	payment	1571	1571	969	1	1	22	455902877240	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYcqYuA2gdL46fjFjgDV6uSKeViGxPCpkQjGUfN2pitAWNpw81T
26957	payment	1397	1397	1678	1	1	11306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnobQfJiuaXPEdNJ85mgUx97EugK8je4BWdB2HKsq2TemvCkQi
26958	payment	1571	1571	1089	1	1	23	816974049840	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaKn3HhPvtsPtqthtmPa8PNaPsFH3ELK6cxVt53LsaVQSQ95Wsu
26959	payment	1571	1571	1209	1	1	24	551228670785	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYowo5goL1hKdBAoYTocRT9N57yJrdmWLhkHrSC42Sh7CTA74vY
26960	payment	1571	1571	1335	1	1	25	1536047703660	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZpkGzbfnLuNHcciBHUyEdwScCA4zpntW7tz47eiEweRZ4E68uK
26850	payment	2134	2134	1874	1	1	2134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgXQBgwxzoVaYFqrqzwb6gW9nLfk1LXZTCW94ab6MhKaZQzdf
26851	payment	2132	2132	1874	1	1	620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNezNUKQKRD8Vtud5NdZ74nHkEHKLth5Jj326vAaRZz9QJRNsc
26852	payment	2133	2133	1874	1	1	1708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVVbLurSgdQPhtyGdhpoKm8W4vm1FK7MZrXu5ueHk4PVaKcJG
26853	payment	2134	2134	1874	1	1	2135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Hn6F6Bf2ci3BCjsNqpk6gYcjfCXGgmnMWPFTDwySNzxQ9KDg
26854	payment	2133	2133	1874	1	1	1709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAP94gKFQh73Hog2YEpDHj1W9fnP4S45gmMxCy67AJ2AnEtz4W
26865	payment	1397	1397	1678	1	1	11285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmgq9z1xv59SZ1Bs8HpsYGUCYxpZvCExi23jZgZ8t6DzJTFor
26866	payment	2134	2134	1874	1	1	2139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPy3o5Hyygre5R2nFS8d2h5tt92gfH2iWBq4ZX42hpyv7QXZq
26867	payment	2133	2133	1874	1	1	1713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTjmarcuRrPf817Un9Pr94JQ8bCZsMPsZezk6GRpd1WzD5S2G
26868	payment	1397	1397	1678	1	1	11286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvZcnytH247k2pWX7QwNfFtoWoopk5vm5M5y8MnESBdndHfLC
26869	payment	2133	2133	1874	1	1	1714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQb8EbozEG3oQ2P2ANtb6xfJcXBKhj1j1cGmty2ZRMR6AXEPmV
26870	payment	2134	2134	1874	1	1	2140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHDYf7Y2u9EyAWWw6i7UbJ3KtVvpiAb1j5ePdZtcXQ4uwNY3g
26898	payment	1397	1397	1678	1	1	11293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ejwc2YA91G7iPCP2mvyoqJXkGcF3KqmSuVuxotyAB8kTvkTm
26899	payment	1397	1397	1678	1	1	11294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDYVUVvYPjwpf7k3eZEaerAo88KzFzVwjC4g2Qaw272Nfu6jE
26900	payment	2132	2132	1874	1	1	624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8QVfDUsKUFi57QFUHT84RoNibMxycJteX63n5UjRLDz6TWBj
26901	payment	2134	2134	1874	1	1	2147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6VijfpCd8N8UN8xZkLfDJyyaDZiLuqdeBLcWmQXYe4g5Hjv2
26902	payment	2133	2133	1874	1	1	1721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypgb8Pzdbvdi5PnD75FKQe7bcYGYKZJTFLnzyhwUFV3gJy8ey
26903	payment	2133	2133	1874	1	1	1722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZbPGvLCsWmXuB3QkMDhqenUwmaJdWYCJQX7sjftbAENmCdao
26904	payment	2134	2134	1874	1	1	2148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowXS9vCXZU3CdFFax3DphwpSp7igZyUYk4keUy5uprZFuUeVb
26921	payment	1397	1397	1678	1	1	11297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2C2kKZLzxXSz7G532HcRnhjj9VfoWUAsa3kBHBWM6Guoid22d
26922	payment	2134	2134	1874	1	1	2152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMhLCcqevLudmKHC9B5Athw4r7NJMqceSm7SVvRkBb48wPR64
26923	payment	2133	2133	1874	1	1	1726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrJhYJf7rfK2jq8NLanTdEWAqRXkYHiFndcuZ7TL3tCk1f9qS
26931	payment	1397	1397	1678	1	1	11300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZXjvwzs7JSrEenwi68hGpnydqDvKz353AtJZ1akoVFcr735R
26932	payment	1571	1571	38	1	1	16	11978839694	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaCUf9F4Eyvuz8AUvLMWbuGciDvkjgDZD8N4GLysiYydgrkj8qA
26933	payment	1571	1571	969	1	1	17	91180575448	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZYgbbcYNU8JET7z7LEG5CD2MGX9n6eSM5Cfwy2e29GacL46VAz
26934	payment	1571	1571	1089	1	1	18	163394809968	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaAPsdSKe3QSpYU2Vjwy5MESoqxT5twwuswpomkTxckMNVQtCdH
26935	payment	1571	1571	1209	1	1	19	110245734157	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYQ4DJhKanp8UmJkkxzW6ERupa7oNYcVXbXX1ikRXtUGQTWQjxp
26936	payment	1571	1571	1335	1	1	20	307209540732	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZ3qM1kVA42sy2NyzBbptCym7tRFyJYGzzZP8ZzQd6dNfQMpNaL
26937	payment	2134	2134	1874	1	1	2155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHFGzUnzYxnBVy8nVC4d9gAGP3Lu8wZeps451dDEcASccMYw7
26938	payment	2133	2133	1874	1	1	1729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFC2dNr42xjojjsnaJbvZug3L2m26Vm2NA5V3RfyTyRhcsTUCr
26939	payment	1397	1397	1678	1	1	11301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnNZKAotrnpTBaEoWfTNRaxMcXnhvDpoqdtCwE994rhwmbchj
26940	payment	2134	2134	1874	1	1	2156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxxcX567QkTddK1chk2mZUC2wse1HfqYH3o1ehyeyu5LZ1DpY
26941	payment	2133	2133	1874	1	1	1730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9foyhn1NzH7JGmSNJXEWtCcnC4sA14ur4ixUK1gWsHArW3Te
26946	payment	1397	1397	1678	1	1	11303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8QB2dGsReYgLRG6cZZQUdp66Mp2CGbxpfmSUHWvpfnRSbF1t
26947	payment	1397	1397	1678	1	1	11304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCS6D7KitL5ECHBkkzWRbvaHvKKMNSAMVTD3qvr4YNU1NkeUUF
26948	payment	1397	1397	1678	1	1	11305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFP9F8PzzyG5seCR384VbGGSZdgnbsSahw7i8Fe7ZKhNZ5pms
26985	payment	1397	1397	1678	1	1	11312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjFTBiqY3DT7amh1vxiR3FfQaGpXdCA3bWJcBBKYXzCQqMBrd
26986	payment	2132	2132	1874	1	1	630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQcvGvMYv7qSpzsdKuCwCa4eXBkpXrNqnjvAun4tT9L21bXdYF
26987	payment	2134	2134	1874	1	1	2166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxhrVRNWhqaFuKmT5xHppDLUAvsr2hYjiCuW25De5uXnwxESR
26917	payment	1726	1726	2220	1	1	8227	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYqKJj4Ydj435b4AvYodToozhRJ6Do6t7Dy7YohGsYudxumNmEi
26918	payment	1726	1726	2221	1	1	8228	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQ43bakwKtHRZ3ECzz9tEA4N3z68ef9yiQi2zQdEU7xuAohcGZ
26919	payment	2134	2134	1874	1	1	2151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjhkHRURwgM8oy4ndLYubtXdGf63YarSnvbZZ7GXXsJqYxKqw
26920	payment	2133	2133	1874	1	1	1725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbjXSDxMcwSrhGnYr8xCBwdo1JiuUJiB799EXo8XQHVZ43sbq
26964	delegation	2216	2216	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNZHp1pbCgofhUq6kRLC84VYC8Lev45fHB1ymQQT9rw3AyHsr
26965	payment	1397	1397	1678	1	1	11307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKCbSSRFnfdDPW9Pjc1PTXgPZJjpz6WrKUooyEzJbF46xGHm5
26966	payment	1397	1397	1678	1	1	11308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmQPeFWsJjYWbtFQDTGj2vVXMhP2tVSxvC5ErpQ6t69LGF97Q
26967	payment	1397	1397	1678	1	1	11309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGUqG7u88gqdmSp3mzHaubNVxivysg7JT4xJ2B3LZ1JgeVv6Ch
26968	payment	2134	2134	1874	1	1	2162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDks44vEnkUU1nUgRkVZLSUUBvvp2KrRDEUhCDrwSEYttAypR
26969	payment	2133	2133	1874	1	1	1736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKChWo2iRtyoKQS7k4v9EFuMNJehrt1JXdGXLcKPGd4BrxQ6q
26970	payment	2133	2133	1874	1	1	1737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCZPeC3vuw3vGLyZpsF4YjQ8ts9Ug7odx1eveoYpoqYQ77SGa
26971	payment	2133	2133	1874	1	1	1738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18VW76YNYqhK7iZUUSFQ6UvqaFMCivskqeXiNSrRMeu6td23Y
26972	payment	2132	2132	1874	1	1	629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Y1HYSpRfc4drBn8QVRGA4KooK7dpSfopvcuGho8ZSi7WAMND
26973	payment	2134	2134	1874	1	1	2163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzGrFzNajdyCA6pYiBaSoXu9FjUaQ393kLZHt4iaKibJJQsaQ
26974	payment	2134	2134	1874	1	1	2164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPUwVY7kHzFLYQxyXKf6m4Wv78paZnQppMBjWruDQx7U9ZyjH
27004	payment	1397	1397	1678	1	1	11316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccQY195NxqXLT1o2L3NtgCVY6TGgysKwchXudRYuUPQdS8Pqs
27005	payment	2132	2132	1874	1	1	631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLq4VcRhbGPprEzQzKhGWHN6eMYXH3Wvx1EmjicnLfyxspPDk
27006	payment	2133	2133	1874	1	1	1745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEiZjAf5kULJkR5sGqF3nj7P6zwcKyMjBxSGvKKbRAjrgk1zx
27007	payment	2134	2134	1874	1	1	2170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPHpG53Qwa11MenfzWWcvj9yAYo38rqPbHeQUUqNFq1waz11A
27008	payment	1397	1397	1678	1	1	11317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgtubz3wpDsVUfiKwWn9o7V1w3ZVeto9dqrBpae2vE6KsCD9L
27009	payment	2134	2134	1874	1	1	2171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aRp15WWsytaa1h3mojLJXyTpV7qi5F8cpYR3n9hAx52kPwCo
27010	payment	2133	2133	1874	1	1	1746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn9jLoFPnuQJiEoRNZ2CWUuKUdTayKPeF41KxCXCQAXM9XCAC
27011	payment	1769	1769	1769	1	1	49	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysuRcWqFAyPyhhs18Y7EKPtCopdgS23yYpGLrcWCnJWqrbk2Q
27025	payment	1397	1397	1678	1	1	11321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zFziMC8mbsKrG8qn3R79XhNdygxZMCYv77bDyAifZgsXqe2E
27026	payment	2134	2134	1874	1	1	2175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbBay7PCSBFKt1R16tPKGCtcMCKTJdYY78yiju2yPYE52jbzC
27027	payment	2133	2133	1874	1	1	1750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2yKvFZdKGTzTmwFF523xyQPd51ppN5MhvZ9ndvwmRT5CzAZR
27038	payment	1397	1397	1678	1	1	11325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtRoNr3KG4mb4BiNEAesAF4jHFzuViRgc63vGeMks268WXJfpP
27039	payment	1397	1397	1678	1	1	11326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNXPabZ1NxZQvVfWRjngDz2WGRvShax5CGdFjARjWrUCqh2cc
27040	payment	1397	1397	1678	1	1	11327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSvTnksWqiiLMZgSTi6CJixKWt4e41ts4t5ift8BC2x1EBBc5
27041	payment	2133	2133	1874	1	1	1754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbohsMgy53Xiy23VksK4YctRumM8gsZV1qqHfksdvpg5DrPx1Z
27042	payment	2133	2133	1874	1	1	1755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBVBsFrvXgpLXsnezbmPPGmwBdmEBYjbkpMKbhpANgG25tczv
27043	payment	2133	2133	1874	1	1	1756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXTGFPujfbXaP6ccQDyS9ysuixJzeQYJ8q7BbXniepfmzrYRe
27044	payment	2134	2134	1874	1	1	2179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfbdW4LuyTv4uaeEsGzh8yzpjyYejfEv2oyam3kSaaRD9bvRP
27045	payment	2134	2134	1874	1	1	2180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfnLK7mRHPTXweMND7RDqvUmPtMSBKwTDd5nguC14SxSBokeN
27046	payment	2134	2134	1874	1	1	2181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zVAPaDThrbZJQwm88WHw5nR69N1XsajVXHsEzXQpJUeDLLdN
27047	payment	2132	2132	1874	1	1	634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEsvLKEzdbDv8XX1G1mmmTmYm1EwHEeRUQzDA25nnWXJqJTR1c
27048	payment	1397	1397	1678	1	1	11328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9C7PvJtismyD7c2QrpBv3hMCS7V7j84jDJPpcWFCBSn6qbwAV
27049	payment	1397	1397	1678	1	1	11329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdoMufGjsaCLoxfvahkXJSuKE38wghCnWTBTaWdda7Uepbq1c
26942	payment	1397	1397	1678	1	1	11302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rQ19BpWPaVN4fgmXQTdmbqqhwYGKEmfGzQDofK1gYpVjxUw1
26943	payment	2134	2134	1874	1	1	2157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdJnMVnLJQsc67DVN7fJVGBcfFRmWQ9mFdwXgNdZJU3fwQv2q
26944	payment	2133	2133	1874	1	1	1731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4GjYjN4FPB7kZqAnUH581LSJf6rkBL2q3XtQydFJL8ZaiCtm
26945	payment	2132	2132	1874	1	1	627	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVKYkugEUyiFcm1tXZDbPaPhXQ31ZEnNEH4LYRW8KeEm32NY3
26949	payment	2133	2133	1874	1	1	1732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXbHX3YjhyvY4hD3JBMXPtRkWpz9JJGUgNmdScSVe5w3JavUK
26950	payment	2133	2133	1874	1	1	1733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRY8xfpxha51mG8yamx9aSQ7C8bCeAL9WFfoYJW7LWrpprW95Y
26951	payment	2133	2133	1874	1	1	1734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeUubrP8QRPUMGS6zYcJ1AMJ9kjkCfUYrJs6pWvYLAunrGssu7
26952	payment	2134	2134	1874	1	1	2158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGU8S4yB1B2fVSAbqPohV7ortrs8oqfXhfe3SoEzYmvEcVWpb
26953	payment	2134	2134	1874	1	1	2159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1B56h63af2wwcsPxA2Lw2QsvSPHwYu8fyKqzbGLsBFrPWqrpD
26954	payment	2134	2134	1874	1	1	2160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhAX75ytoyQJT8ikapCAPmGqdrn7obTjEfvu6sbe5eaPD3Xir
26975	payment	1397	1397	1678	1	1	11310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkuoGDrKdJNNevVcVnEqAqkfr8zCJkxRXRSVVKk8KpQVRYCBh
26976	payment	1397	1397	1678	1	1	11311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYop3HQdhDdTs21M8pv26KiVA3QP7TxiNRW3ncNt1JuAxY3MT2W
26977	payment	1571	1571	38	1	1	26	47928658776	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZp7vcJetSFqtKDVtfzPj6XKYePnT3r6tEftPfaDda9e2irDdoY
26978	payment	1571	1571	969	1	1	27	364722301792	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYzSpSuUypD95ykieYRzCcbdo351qgxH3j5Kjs7vSF6AowVnK5W
26979	payment	1571	1571	1089	1	1	28	653579239872	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaLZgHPCYLu51AiEU6znmBYKVDSmndW3s42ScBDCg6fqAtxMGKp
26980	payment	1571	1571	1209	1	1	29	440982936628	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYoHbwJenY7jPUZfC74ivp2DrhtvZhRtu7QreS6roZUvCSJsEs3
26981	payment	1571	1571	1335	1	1	30	1228838162928	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa8ijHdf8PEk9mnqrEAWjJzN7sUj7LU6hfXtpia4P2qbab4mLsY
26982	payment	2133	2133	1874	1	1	1739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZbUn6WheZiXqwYw1TeM8tWu6ffCh3s7ggxcHT6xHw6wuMQw6
26983	payment	2133	2133	1874	1	1	1740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeksFWEavP2HEanPwddNxkwXCCcYMZFsP4VDKLcVSWmo1Sahuf
26984	payment	2134	2134	1874	1	1	2165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mgsJwCnRanKQ6BZmT3ud8Lk9qVJGoetEWNoMQTHV7e4xG3vZ
26989	payment	1571	1571	38	1	1	31	24040329388	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYYyzRjyzwhorC4AWgkhKi6XJVRyMVdNqsoFdJdeb4qCNEUn9Jq
26990	payment	1571	1571	969	1	1	32	182361150896	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZWAYJqRdbDDgz1hYdaT8kwyy2jbTjsj4jv7eJd33GgnPZrJhw5
26991	payment	1571	1571	1089	1	1	33	326789619936	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZwzHHfAyjxV5mSj3E3KNN6HYDCCaixfUv99aEQ8gpUEiE7m8Cp
26992	payment	1571	1571	1209	1	1	34	220491468314	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZgZwN7NUJNmCHmMEmkKdN9tp8zDq5xbsd5AjTxmBHBJDNH14iE
26993	payment	1571	1571	1335	1	1	35	614419081464	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYjn3ZzmcUVXhxmxyKFW5uVW8kkmh7EzMUU44ALirduEE79KmkA
26994	payment	1397	1397	1678	1	1	11313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiZAv3eb2y6ztNhVyEeqWnxQugT9fivk4dE2h1wYaWAocZamz
26995	payment	1397	1397	1678	1	1	11314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9n1foWXzx2ZR9zGZtPZTB3NNzaL2CUVke553meqq2y8U118K
26996	payment	1397	1397	1678	1	1	11315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqymrH9JRpcXE9knwqvExzG9kWa6wBrzSD39oUn82Qq42ir7A
26997	payment	2134	2134	1874	1	1	2167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvbCQa1epnZ2wjc9p6x4hoLZArH4DZuEVaN6DSbA1FfxDK2io
26998	payment	2134	2134	1874	1	1	2168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoZJ2qme3fTukHFfKssobVjT1qU22mGC6GTcJhp8efuGE3jFZ
26999	payment	2133	2133	1874	1	1	1742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hkEG9Dqetc7nmaquu88rsS4VMz3jpHxQkrDnsU7xVDRhPFnM
27000	payment	2133	2133	1874	1	1	1743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRs1UQWRuEjbtXGk6nrvh3ipEY3BJkjZey1j9ZJUVRDGMVNht
27001	payment	2133	2133	1874	1	1	1744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsETnZ68kSW1Duwh8TTksGHXJKGiv7YvVrd5vubA1WmWJUN6j2
27002	payment	2134	2134	1874	1	1	2169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dHE8DC2vCcRBuDBUXgFYmG6fay5qL1goaiBFWNESvc8qcS9z
27003	delegation	1769	1769	1406	1	1	48	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMbi2R39b1jh2xPvbCVaRPxiw738QexXrNotexEBep7i7ZDou
27035	payment	1397	1397	1678	1	1	11324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbCSsVmcCKhQGd6quNreUA18VAjuQoJwhTusQ7pHy1QJDwjA98
27036	payment	2133	2133	1874	1	1	1753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JeFy916zL4pEkmThioXUjJhQRcAEGeE9nqwbZzpR1HCLrpmU
27037	payment	2134	2134	1874	1	1	2178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqrPZBUVK9ioQ3Qnrm2RuUmLtJUg88vW7hLWnd8LAzEBskSuo
26961	payment	2133	2133	1874	1	1	1735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvW69zs5wGVGkw41axZUTEK3BbDdJHJDTPdBVAavnSRSfxFLk
26962	payment	2134	2134	1874	1	1	2161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WZ6UMsR4AtCsAHniLJE4aCaur71V36mcESj1944ScT8dcTkC
26963	payment	2132	2132	1874	1	1	628	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3dvC8A8khp1EH4t5HHcZ1hDPfCeHmZUqPr6sDCZUSva2g6ZF1
27012	payment	1397	1397	1678	1	1	11318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbP892NsrrqtFKoLETUCNTEjvefFJd3RU3nSEJh5g12yPEBuNM
27013	payment	1397	1397	1678	1	1	11319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYascJLuwRGUjSkYhKSDMo6rhHBba1ztkgyyX5yHwszz3kLg5Ub
27014	payment	1769	1769	1769	1	1	50	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTC264MwbMrULUDyD6x6Gpk9EVzecBUZFUtdNLhSHgPJ6a6zLG
27015	payment	2132	2132	1874	1	1	632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmZqwUnUdKRSTeSupKjD3b73YevoQy225WWV7EZ4E452dpZYL
27016	payment	1769	1769	1769	1	1	51	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK2w3MLk5YorAzNqrLFmuu39qKupwYEjwA7SjBKtsibhnmKUaY
27017	payment	2133	2133	1874	1	1	1747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR961n9C7h9MyZp3LxLgGe84uw7MyqMcTtfxsrPaMCVB5uvMAW
27018	payment	1769	1769	1769	1	1	52	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4VLKWsQEQtNNENKjLbj5QhdQ9vFcQZ24ubj4v3xf2gMozy3b
27019	payment	2134	2134	1874	1	1	2172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAZqNjWEe8XAzcErWEoiXprdde2rBbetnP7KWuNQrftRJXeFA
27020	payment	2134	2134	1874	1	1	2173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKAaXjoCKspqV2czcarR7GyeNugLcLyJysAgJgiQm1BfWgGEk
27021	payment	2133	2133	1874	1	1	1748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHunDoa3zysK6ZWWumiDxS81PGZ33198wF2Rwe8b8sKLZYrJ5
27028	payment	1397	1397	1678	1	1	11322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMfBirW73gTWe5gwGUrdEpHzcgxuCtaBpinrYsbbELAtDQ1sL
27029	payment	2132	2132	1874	1	1	633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpUjaNtFWJ5st1ZwJhUNgLKKN33hs63vbGER7jdoFWutAspbVn
27030	payment	2133	2133	1874	1	1	1751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGinuSvX3TVFp887tpKYmyScxPywjbZmuEzeQBxhCne47mecFq
27031	payment	2134	2134	1874	1	1	2176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxNFQVUG48WHP68mwSNq8ZHHdp63Zb7yULccuvt9kdjQhc9Sn
27078	payment	1397	1397	1678	1	1	11336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NYmRXvKcb9RiqjtGYMNnETKyHwLyQnH1XCPEzhsW28Kpfzro
27079	payment	1397	1397	1678	1	1	11337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZJwVFaBXWAYuKaT9PiMTRDSbfTL52DFYWyXpA4hc56MZXUdN
27080	payment	2134	2134	1874	1	1	2190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsrqThU9nmisrPosriZvwaLi66LrFeBF6FQWrd8b13eBtDCy1
27081	payment	2134	2134	1874	1	1	2191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4HyCrVCVKSZoZicW7vDpATN8bx6S6J5LqtwQ1DuxKg4nK2ga
27082	payment	2133	2133	1874	1	1	1764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZvVV273w4ybkT2wWpLAfoFV28nRVDN1FeGLri3hgb8MB6gZq
27083	payment	2133	2133	1874	1	1	1765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBF7GdcFRe5G5vKCdLXFcnvdv6i7qUf8sb9sRMzf5P6V7F3Bb
27084	payment	2132	2132	1874	1	1	637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiifE5GFb3qGinM4d9pvtdogSrkQLUXLidKCKrFNxMWmHLKhWN
27093	payment	1397	1397	1678	1	1	11340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNo2uUGdQWqN2vwcAJb1YJh8hc6vFcEc3KuXkQjJhjpXZzMWY
27094	payment	2134	2134	1874	1	1	2194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuJyU3ytAjQ5pKjGchxvdgPbjNEyxmrqWVJqfZZyPyiwbPjoF
27095	payment	2133	2133	1874	1	1	1768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7Y6LpjbZWajm5FFL1VqBhp8NVeoxLoNYtpjm358Nogfuxiyn
27096	payment	1397	1397	1678	1	1	11341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHYmQf7SrDdo9b7PjeNbhp9dRdg2JpzkYHMhyhjfP8UyLhLgJ
27097	payment	2133	2133	1874	1	1	1769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBoaKYVvPqqPP9fJ6qLCeoebss3W5Fi82vzmjTt8PDsYTgZyP
27098	payment	2134	2134	1874	1	1	2195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mEDcaVuT3Q657DMpduLfypso54yoM8VbHHCiFkiNmSwBQm92
27105	payment	1397	1397	1678	1	1	11344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQUgJNjFYngXoThg9uRnX1FkUzY7cuDDd4UfQa3YHzYQcT3W2
27106	payment	2133	2133	1874	1	1	1772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcp8xjgHifYuXyQqWPeeVSzEJ1dYD9iHPu9itMjZ1RZeHd2qrt
27107	payment	2134	2134	1874	1	1	2197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuPm35DQdDEc7gHNb2rEKDnciSiqZrixPV5bZWXJgGz19TPk1
27108	payment	1397	1397	1678	1	1	11345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvxyoUJUwc9W4wZbyKT9MX121GHrXkB2jHr2oV2hibi3YsZiW
27109	payment	1397	1397	1678	1	1	11346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC4ZZoqGf7d7AVvVxMBDHcUNw8p9qSnzN7uabSmNRBu4Cmar4A
27110	payment	1397	1397	1678	1	1	11347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6CCPKhdFCkLCpgahu8Fh4qNwgroCGUdChqD1YvMNfdVirfsG
27111	payment	1397	1397	1678	1	1	11348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UptTd6wHV12UCZCuPhPrw6Q6nf5Y8X663R4qJjsoobCjPKNE
27112	payment	1726	1726	2223	1	1	8230	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYVQLE92a4ZDALSFScsKJSSaA1rBP3WkWJGnTQAJFTw8pnJot4a
26988	payment	2133	2133	1874	1	1	1741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8J5wGFJhrrnZgQHMDPYjKS3LGiwoZLvjWVr6HWHJk3oEBgGfS
27022	payment	1397	1397	1678	1	1	11320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazD7EBRPCFQEgT7AqMwTW8V949bvoJzd4uyQA3EEFQ5ttYb2K
27023	payment	2134	2134	1874	1	1	2174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHrKXNkoazAMcMLtQJr3vYZiNr2t5yrypYeKSgxUNBNLvGabG
27024	payment	2133	2133	1874	1	1	1749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eo3JuNhK8B5PGqaKUPFTrQGnz6BT19qPwVZv2AdiAJ2rTESq
27032	payment	1397	1397	1678	1	1	11323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPX2GHZQPMPw4QDTDzeodQbC8RePidQZU8xwVbQ4DvbET7Xmta
27033	payment	2134	2134	1874	1	1	2177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsg1SzyuCQEfQmg26Q4cvBkn6QwShHSBiA2jscjbweBUuxg7jV
27034	payment	2133	2133	1874	1	1	1752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2iwk496waQ88ebCn3WVYGfJv7VDkMPJGbknR6hviLHLb8Xnh
27063	payment	1397	1397	1678	1	1	11331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZge1fbWmbgb7MjJW42xcUCvmKfhJrR8APEPEWGZHFL6DHKBTpu
27064	payment	2133	2133	1874	1	1	1760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimjbxuTmYrUqAGe4buhEGBCFWgvzoYCGHDP1aDGFJPKRj4cXp
27065	payment	2134	2134	1874	1	1	2185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAQndDmZKQrnbbpbh5vbKrRQu1YqkFXjhesQwHXA6uAEcZrRj6
27070	payment	1397	1397	1678	1	1	11333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEPDm5hV34JhyCnNvFzbrrJyi7jHFKuQFxAwB2wF9yzbQW5s7
27071	payment	1397	1397	1678	1	1	11334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyGrNYXkuZZKoph8hyahQBTSTnaRZcsYYDCM3QCkaZDPaCt5o
27072	payment	2133	2133	1874	1	1	1762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuqDRXsaJmcXcE4Lj4JEzFVBYqXGkSofmfZEMsNRqS8VDBXf8
27073	payment	2134	2134	1874	1	1	2187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoohpneks4TrEGhinNNxPh3uMo3aowxNv7ihoMbP25oCmtbns
27074	payment	2134	2134	1874	1	1	2188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNuLJ4u6Y7oYKCidVVrLNHSMTysrs2rPBk9sEFi2ivgCMNNQy
27088	payment	1397	1397	1678	1	1	11339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61SqdSHdJYydGBtYvww1ZWCNLtZtrGgAk93mRb8cTnrvcydMC
27089	payment	2132	2132	1874	1	1	638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYin6U2P6Z6FR7vFmoDR3NDNnmCBhqf9y9tegKjW8K6vuXajffa
27090	payment	2134	2134	1874	1	1	2193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaM4t443Pz8JTuoemXquFDuoMN6Qj7QCDe1hThNzSoVa5FcyFf
27091	payment	2222	2222	2222	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovTTHSWftkP8mwp4NiJ73CVU8MPrLnW2j43Qch9uTFXKU29fE
27092	payment	2133	2133	1874	1	1	1767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4apCs7b2ott1mCfGLhvnTd76uQxsU4e6HjbaMVNCTuMF8VXdL
27127	payment	2133	2133	1874	1	1	1778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXTr5v2twwFFadtUMzCvy9zABLEXesUMGRs1RTmBYxkiJTbdc
27128	payment	2134	2134	1874	1	1	2203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Zirt5YeBQE6q9PpsDJFEabDtDm4CnQ4Vur28LCAtx93Yytbs
27148	payment	1397	1397	1678	1	1	11355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLiyfBeqmvhsh5FLYMEj3CthR1GYeuRhFhPTbGz3V4tzJXzBwV
27149	payment	2133	2133	1874	1	1	1784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1jPqMRMJnBseAWkgnbXR1LKe5E95NreGLeoS5CitpzGWXesz
27150	payment	2132	2132	1874	1	1	643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMffhVPYhYe7PpuM9sBuFjgHX8KcMusMygAEKLGE6pYDZhgas
27151	payment	2134	2134	1874	1	1	2209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vUvpRmyMP3LrJAdgQkvn9mMznAm5D94t2AqB714bsvzJcH6E
27152	payment	1397	1397	1678	1	1	11356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxyZ3cBaYwCKhLd5zLkposZeWaFA1Nc44C1wWoDVbAoYt8ESe
27153	payment	2134	2134	1874	1	1	2210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9cc9xDFRYxg6Asn5LznMdptFUD2CvEQJEDtRurzofAXzb9r4
27154	payment	2133	2133	1874	1	1	1785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMkQT9eekdgDrvhudkdAuQNEsUq1zYtN26aPpSD1diWv9FjhK
27191	payment	1397	1397	1678	1	1	11368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC1V2y98ehR9y6fifg3xVH3u67mtZJ9uHQuaBmN8Dzrar5TiH
27192	payment	2134	2134	1874	1	1	2222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6mdDsRtFkP5cEAh5tkfQKaC8cBsPv8Qk4MHX97ok3MimXKK2
27193	payment	2133	2133	1874	1	1	1797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMd7dxrBmDAiFvUWTQykXT6YzCkqkBSJjk39ecf5cLPAx82EF
27194	payment	2132	2132	1874	1	1	647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNwXKhi4YwQuHzhySRce2rVQw8KA8p3qwCENMv4NXuDkw4cAv
27202	payment	391	391	2226	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8XdsNh8a7hAAb8Vmzz87NJVM3o1goeTfsyCUuqCGLcw3Yjvq
27203	payment	266	266	1958	1	1	1	613000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu5eGXhts3Tfpyo8Dgj4GoR94QMi1vmVMk146qov7Yhf4rshSc
27204	payment	1397	1397	1678	1	1	11371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb2X3u2oyxjJEBPXG5NFDGSXFBVioDBaLhiUZDYpi2auyLf6p
27205	payment	1397	1397	1678	1	1	11372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJwFZHESWqj6QHLRGXZCnQZmVhMV4ELKvofRqTjhDBLG4MbLg
27206	payment	2132	2132	1874	1	1	648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdAZ21tbYpDUDpBve5oU9B6h1sw4tXHZdPuiF4aM6XMtEnJoK
27050	payment	1397	1397	1678	1	1	11330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqicMnu9Q2THSimqgaJLyDAyDhwZVjBsfBXjnGfs6ejomUc5V
27051	payment	1601	1601	1388	1	1	13	5941000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpaB19fbbS1gDABkBDrMEZXeXKNzXm5Zgf3qd8541H6LRVpCmaGW
27052	payment	1601	1601	1142	1	1	14	3160000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYnmdnueHnv1b86GGtLCiitord1uzdcoKVjVuMREKECkLCgfMZB
27053	payment	1601	1601	1262	1	1	15	2132000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZ1uVrPjvwNB7U6vSa9EwBBNtjP2VasWqWhH1jaU2o1JP4H3ckH
27054	payment	1601	1601	1022	1	1	16	1764000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZofXXCjvyu4D1TCT8G5cQE9uSJfns7JqoG3BJmGP1VnJSgc9uE
27055	payment	2132	2132	1874	1	1	635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gLS5gEN8ycrmcp5CG93ukXVMp3f3hJngjjMw5HsayYDfYY9Y
27056	payment	1726	1726	2222	1	1	8229	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZVtK5j1sv14X7uSyNmsC8a6bdnKQCaPmDd6jYu33WinJSMsUUZ
27057	payment	2134	2134	1874	1	1	2182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3acAZRds8NMb6d9Zn7cEMMkxYe1HygHEJAxzZJKKhSccrnzc
27058	payment	2134	2134	1874	1	1	2183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFC1yVyRzvcj4LLkRX4RrR4SUes5U3a9DFmHENRtX1GeZAjof
27059	payment	2134	2134	1874	1	1	2184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysn9zHGiMEqJJyCAuuL7puQXLqJuzBWGD2t1biQ6qpBc8wHiC
27060	payment	2133	2133	1874	1	1	1757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSvt5viXgQWWojKpJMV3ytHyW4VmNu1xt2aHXXuHTmMS8kcAq
27061	payment	2133	2133	1874	1	1	1758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEqnPT8MjrgwJ8qssteCERQWUG2KiU9QZDFENXN64c39G6CSk
27062	payment	2133	2133	1874	1	1	1759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzZpoEPjNX3BftDXgBwyNjJN3Vu3mFBR29oCTYD66y9vGtfJj
27075	payment	1397	1397	1678	1	1	11335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7qswjfRE3kQR83KSBxLwb4W8PZqvSoncWPZzZkdFMLGnSY1R
27076	payment	2133	2133	1874	1	1	1763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaADvpt7bbrgLRBuZtLfeeUa9zpVbRyeQJhgnUkfyyTAoJQMzq
27077	payment	2134	2134	1874	1	1	2189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAct9twhb5Kdn7b8domtX9pMx3LhsSzAQiC4DTcLiQ8wCpQhMw
27085	payment	1397	1397	1678	1	1	11338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZF7S5pHNyLUWo9vA7KSPs3gomnHjurL6xyFGa3EeL34KrsMac
27086	payment	2133	2133	1874	1	1	1766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuGGkTNwntAtft46B4M3RDs26SqYUc45KdwTSbz5A22CapVV4
27087	payment	2134	2134	1874	1	1	2192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxW5GoqC3Wu3Ufm2nZ37x1eyFGqKsE81rCJwfVD1DaMGCwM295
27099	payment	1397	1397	1678	1	1	11342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34sq8DQWvs2JpJLwL2XSjsxgZYrChhnzEpP4mhBWAuKvVZWMr
27100	payment	2133	2133	1874	1	1	1770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRf8RhWwVE2vnznvrZuyskcb3wKPxb6JuioD8yVkFt85RdttN
27101	payment	1397	1397	1678	1	1	11343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkuXajKYGSWe4BjPTEYN6rySw3bUktBMhs3AzKVDrzKc4ibFtu
27102	payment	2132	2132	1874	1	1	639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKAVVrMeNCs9Npdhm4oAVCrL1Kq83ofxn4Ek1GzwcE2Vdt96c
27103	payment	2134	2134	1874	1	1	2196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5G9GdhSQGjPRguwvYayZTN4TP4ZZQDfN7LeJ6bnHNddN6qouM
27104	payment	2133	2133	1874	1	1	1771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNiSCHDL9antY7wqPdzXUH2onZX9NbUQ4sr9zasvKXkUjD29m
27129	delegation	2224	2224	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLUcBrYvjUWL9edVwF4a48FfGe1NZ2WTwxkQ2ArApSVZZgxNQ
27130	payment	1397	1397	1678	1	1	11350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoYTq4QpbeXabfT8fTCKXE5woh8nmxaspT9qCGerx2Cv4JK2jX
27131	payment	2133	2133	1874	1	1	1779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBhcicDrRdffhqmrUVS3PMR7VnzgHqjssrBRbRbRv5cr8tCM4
27132	payment	2134	2134	1874	1	1	2204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XsW1a2QaG599QRc39NiG8hyFDwYRTxYhcrrZQyU2kLSRar9e
27162	payment	1397	1397	1678	1	1	11359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjCYGqQLkfeFPwtCJ4ipLhXPdEvJEjN7j6rZbnmCyRHUV6kzh
27163	payment	1397	1397	1678	1	1	11360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSguibXCaeuPTVzecQonfsjjqohneMqiEx7s73V2CTP4jG7HhW
27164	payment	2134	2134	1874	1	1	2213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmbHW6sYoJD7Ff6z21nRy73txr13AHJatSJCaTJX68ECLZi8F
27165	payment	2134	2134	1874	1	1	2214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnvgMS2RDye1zZjgRXS6HWf9W7ircgjN2R8E8285PG3ZaQ3sG
27166	payment	2133	2133	1874	1	1	1788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiprhzyUdPxbDREesqK1AwbyYYcqurVoEJgBmi7NpZcC6PgL1a
27167	payment	2133	2133	1874	1	1	1789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAyKv2GpRUNQ1JWhaeceeh1yWZxFMPVrAM7M6iXehZQvcYsKF
27175	payment	1397	1397	1678	1	1	11363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7fXB9TpXtZbDPjk7vp1tTdvvvZB174AXkxva1fseCwYnPyRx
27176	payment	2134	2134	1874	1	1	2217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVymckyxF2ivAZtTKdsc4KdgKYHPA6o6gRV4Ph9DLADDnDBFzs
27177	payment	2133	2133	1874	1	1	1792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMYrmrXynTmnvohbCeimVZCFURmBRjkca86ii7M6TXs8achL8
27066	payment	1397	1397	1678	1	1	11332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NGDEELs64TAaC75cgW7eJqVADMHMNSjxUynBEFJ8Kzu1YWWJ
27067	payment	2132	2132	1874	1	1	636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxw7Zogaq6dsAHMrvoXwYyLH9CaCrkejYTQcEESEPF15VXvYXX
27068	payment	2134	2134	1874	1	1	2186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYTELMvLAQEvATvuQrzGt3kFFTXrk1NxTFndevyrpPaEHCF6C
27069	payment	2133	2133	1874	1	1	1761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxx6PQw3K6dRUXRjmtCW6Am8Zzd3yJJbkaqsRoC9VNySXF5v2z
27122	payment	1397	1397	1678	1	1	11349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAGPVyZuRLxjLpxUfSGv56EfHcfWPQzeECjeC6zqVx8KgskEU
27123	payment	417	417	2224	1	1	0	720063000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoJougQbBYEBpbAg1wa2iW9bAMj7PZMMAPTQBNsmtZuetuDp4
27124	payment	2134	2134	1874	1	1	2202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTvnTuTa2CQtgEmBzB583AnCzd1XXhiywMedNfvQV2TuYYRrRU
27125	payment	2133	2133	1874	1	1	1777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFVGcUG38qGWp1THtgeFDJVPJNLjp8dng9A6igsjqFfZgiwvY
27126	payment	2132	2132	1874	1	1	641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMnK5FHjaVE4nfAEpeTvyhhDDuS9FVK1uV11Hk3sxUeXD8KRS
27145	payment	1397	1397	1678	1	1	11354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENzuisjg6fn4NEGkYMRmXymr8xH1Xf7ETRSsmrgmMc23e3wJU
27146	payment	2133	2133	1874	1	1	1783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQDA39fEzy5pFPd7XFU6cU6VNQ2BT8u9sYiyDcCDgbzseYXSw
27147	payment	2134	2134	1874	1	1	2208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjnAPATkkmrwaVjPRx42BjZLBxpTR46iM6Pqhq14arxNU9RES
27199	payment	1397	1397	1678	1	1	11370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkWsmB8n7NS5q8wb5rPfN4R4Zm8MShhystWcesV3NXDuRk7jB
27200	payment	2134	2134	1874	1	1	2224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGQipjWF7BSQ7t2LCC56hqvzVyb6GHvRV1k25DzbJjnvAHpeH
27201	payment	2133	2133	1874	1	1	1799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUzsJEpnTfuxGP87jgopHwM5fVExLyezTPaj14EJa1LAnSRkS
27212	payment	1397	1397	1678	1	1	11373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9e3CBaXVaJhLqwhuPjfxpPb4TXQkKBqzVDt6aW1krQ1DYatK
27213	payment	2133	2133	1874	1	1	1802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mprsZ3nsxjPAPRfCc5DbRQ8yWVUjRDkqYaebmkB839NrUGxr
27214	payment	2134	2134	1874	1	1	2227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBPyKbA76nhhZHkH4HhpCVyjc2bPc1dLbm2UU1vWc9SMVoTCc
27226	payment	1397	1397	1678	1	1	11377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59UkqA2dN1xBUG6AC2qxG2VW5LMmTPNi4x8X2QmVQEHJsftnh
27227	payment	1397	1397	1678	1	1	11378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JVU3oeHSFM1dz4F6ixZardVAypvAtxEBUpxcwcGKcaL3dF3q
27228	payment	1397	1397	1678	1	1	11379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPVrZwFrUDXibbPWjefM2oN1pdYD5eznotE5UpLzQkc7aTzFF
27229	payment	1397	1397	1678	1	1	11380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKWVHAMivNcKRx4huKBVnFxJtbXkqJm4Vdi6VpCWPcKL1SwGm
27230	payment	1397	1397	1678	1	1	11381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNoNU1gqH8zkdbDuWyYmB4tMQJ8YLeQcQtFxscP2rYf8Szouo
27231	payment	2132	2132	1874	1	1	650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaGr8MsqcSMQuzLHyVhzP5Kg838JiKuj9vkRC5taw3beqBZ3G
27232	payment	2211	2211	2225	1	1	3	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYo3vmcG46z4As7G27rbz5q2U4Kf9WQu5BraPzeJZEfvjQRhii
27233	payment	2134	2134	1874	1	1	2231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEE2BoNxfjrJjyYcQMs6soVrg2emyujQDmpcquQgQuVzfHBpB
27234	payment	1726	1726	2227	1	1	8231	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZUBrgBKmxyJLLftsKbE6dbyUbUtbNMxpgBPy1s2oQAWZQv353H
27235	payment	2133	2133	1874	1	1	1806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdfSF7F13UY5keTVnhY8KFRNsEi8HqtkJqKnLhcZ8JkyoyXpp
27236	payment	2134	2134	1874	1	1	2232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2DgMx4s3E5jz5TKcrmnhfApsvJdKPifgoGKaCyawRQ19tgAi
27237	payment	2134	2134	1874	1	1	2233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVcPLFB8UwUeHydG7HiJTAuq8tiRTkxFJsArmCoCrKRnMHTQ8
27238	payment	2134	2134	1874	1	1	2234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFgAKSvTSkZGCup72q66xWJqhkcJqMVCfBoR5HYvCBuD4mjQf
27239	payment	2134	2134	1874	1	1	2235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwm2kLRi2AHPBRcLRnzH8dt5bZmPDNVpy2G4LmgiBvY1est2y
27240	payment	2133	2133	1874	1	1	1807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLaJTPjYkaakrQJ7ZKbLbiYsLqFsdpRDV9Urkgfh37QJMZLR8D
27241	payment	2133	2133	1874	1	1	1808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXpKeVUvi8VqH6BWvu9Wiuf1Xqn4xK1goZYJAb1h1orutAMEC
27242	payment	2133	2133	1874	1	1	1809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqcXDMggga3NwjKMNgqVM6ptUUbp91m5itc66i6Lv764BELew
27243	payment	2133	2133	1874	1	1	1810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvdjU2J1TAiCCzBsGt5W43yPyZRYsZ8vYrUzJXwPrgtrgkHYd
27244	payment	1397	1397	1678	1	1	11382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2wup2fY5sP24e3vRfNEX2Jwawv5V9Nm2D55Xf9gdzjDMpxYw
27245	payment	2134	2134	1874	1	1	2236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTV7jiGTXCn3PwibWazdFinLMo26YePaM5Urh5zzKWmCmqMaV
27113	payment	2134	2134	1874	1	1	2198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8R2E3MsU7Q1W6rkucvZt34BDsZZzkQ6teyNCXFBJg8jKWpCQG
27114	payment	2134	2134	1874	1	1	2199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4Kt5zuZBjUVnbtEmAmP7owNMijWmNDE3CeaZbsyYbCsYtoid
27115	payment	2134	2134	1874	1	1	2200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkuDuVK8Cg3Aci56vTH2ZiQKk9DttgYytZTjPErAetXcEEhHT
27116	payment	2133	2133	1874	1	1	1773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKebGzEPeb4iCTX7iAda9xZ3sye6cLdoA8eWxDUheLsX1wMjX
27117	payment	2133	2133	1874	1	1	1774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhqqYeC9TJzcCdb6qJ3harn7nsXxcHsgvvnKso9YdSBz6wg3C
27118	payment	2133	2133	1874	1	1	1775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD98yk1J83kXGPUntAk71Dvd3HYLrp8KLbzqVLZbZqyGWatBT
27119	payment	2133	2133	1874	1	1	1776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzPpV8xzZ3vyyhtRgiHB8qakUjpeEqGMVxF8n58P22RkbQTta
27120	payment	2134	2134	1874	1	1	2201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcWDYUT3wZj2AuTcFuRLzuCQSR7NbYGJk5ycdXuW7pxn98w6j
27121	payment	2132	2132	1874	1	1	640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLauST1Cw6bQs666n2fKJVKoKZEj5m2NXFD35ohh9pVwV6XQi
27133	payment	1397	1397	1678	1	1	11351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZcMPajH3qYFDk5zYskpUBXrp7LYqekPPH1aVTaKJ6A8gHVCv
27134	payment	2134	2134	1874	1	1	2205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcc6VMhXUZkaDAdnS6Q4qrZExcsoNYYgyDAcVmBe3FYVowa8b
27135	payment	1504	1504	1697	1	1	9	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dDBfVZkd9eXhcCSFUyeStTKGijznbJaFWAJSjk6KJHGSpL3N
27136	payment	2133	2133	1874	1	1	1780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFzPNVnZD7Ch5wDqGri8af67g8LDTjghMjCHWQ57PPTPKF3AsZ
27137	payment	1397	1397	1678	1	1	11352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4q7DQBGXMUCSxRv7P4yVB6x5e7r5t4S1geWyzDm4K8gk1Cuhd
27138	payment	2133	2133	1874	1	1	1781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUp7eFCJWGWuSECRJNBLHyQAPAo9yxCm9tA3E4ZGUYrzkexyzS
27139	payment	2134	2134	1874	1	1	2206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYAnPQ2fjkSZMgfj9o2MLK2VR5jX3eZEw7AGqkD1wNStLWPDZs
27140	payment	2132	2132	1874	1	1	642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfAw71WEf7hZKJNsErmkoUER7Bi5oBm7gPj2jmr6V62HYVxPb
27141	payment	1397	1397	1678	1	1	11353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNvjFG694i1TpyjQXCk2FaGt1obraBQkdrMNn8y9KJA3MAxhD
27142	payment	1504	1504	1697	1	1	10	500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qDcw3BEYc6JQnGqEVp1Ggd17bfL28LaM2TsE9Dog5vWRVdCv
27143	payment	2133	2133	1874	1	1	1782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERoE8CgRxCRJLmHBLTwwWrnNVB8ax2xApLcGQHSSSmp5aC7Gb
27144	payment	2134	2134	1874	1	1	2207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQuk6gR3oAgakvEu1y3aw6TFyHGL7ciCLQKWei3S7fhx8GKrY
27155	payment	1397	1397	1678	1	1	11357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwymKbFPByw2XhEeQCGDxmZmdwr3A4WfFnAbqq2YoGCsxo2wy
27156	payment	1397	1397	1678	1	1	11358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRvpStQNvTM6PYiiScczZL3uGsKufBU5kgNe8qqbQANuii5hR
27157	payment	2133	2133	1874	1	1	1786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC568ZF7FWD5pj9tqkx4QGTrfSwgsjg75GpZYiKET9V7okLBQ
27158	payment	2132	2132	1874	1	1	644	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzg5RbiFBTjq4kkbhe5cUUFR836W1XErjvwgMWXpEHCreAEwD
27159	payment	2134	2134	1874	1	1	2211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX668FESrn4BLB2bCK7itKvoWMXPwA1rK2vkprSNAvzKVxjXDV
27160	payment	2134	2134	1874	1	1	2212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFhPJz6AePHSWUdwirhzevJzBBDHZD4mk5tKFk5jCoH4CR3y1
27161	payment	2133	2133	1874	1	1	1787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceDWGq7rGZCjB2ZR3gQ3DKNMzAtdpyCUa64navHLCdZiM6rwX
27168	payment	1397	1397	1678	1	1	11361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCg9uko9Jf8R2EtqM6RxzfTWKHGMqULWc9WJqZ975gLFbF7RPK
27169	payment	2133	2133	1874	1	1	1790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ynK74pMDytkGBzcwRbneiSY6Aynd9K33RRgBum94XbHgSPRk
27170	payment	2134	2134	1874	1	1	2215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ896rVuZ43Dva5b5tgj4sVb3b2ny9k9iqforq9DNnYaL54kDwb
27171	payment	1397	1397	1678	1	1	11362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3UpMXk4Y5J2hsSVg8EQgmmwRHTvMY9P9hHNXa9AxBjNUkmfs
27172	payment	2133	2133	1874	1	1	1791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57eyULiGsR7bHDnEZTztG4hQbjsCyndHE7VAv4okyrW3XHffX
27173	payment	2134	2134	1874	1	1	2216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrx4wWY9bzRkLr2hSkc23v8otk6ENFjbAuYFaJJoc5CSDDZcX
27174	payment	2132	2132	1874	1	1	645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYttTKVnssjgsQHx1ZnmDd6ZDUADe7Um9Bcw92iy4tun24SVH
27178	payment	1397	1397	1678	1	1	11364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcM89EbvxWbL8SgSFj3X2hV9u9NJKVhtCwNvERTA6MhLJxTT4R
27179	payment	1397	1397	1678	1	1	11365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kzMkT8CSQYPEZXbxRSfi3aw4eHAkCBQLQvWUTigFhxMwjNDZ
27180	payment	2134	2134	1874	1	1	2218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycEa6AnHGyJ2fqjYTajBayX5xdH23h5fVB4ymqg3vtvLxx6iZ
27181	payment	2132	2132	1874	1	1	646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8k741Da6DAg8AEAaaAPqNZstjiBb7Ky5MwzyRa9DHC1GvaDNw
27182	payment	2133	2133	1874	1	1	1793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLofgadvoHiJqjgwPynkJp3ewUyFZDpDJqqhJVimLttcD4vSPv
27183	payment	2133	2133	1874	1	1	1794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQXoBGMadQcGgHgkze4LtDUw48UaKRBH27VNJeMhQz5UAyNHo
27184	payment	2134	2134	1874	1	1	2219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4jSsgKuZ2fkFdNuEmMSv55ojZXfjuLbSFKryTKGzCoyvDv9z
27195	payment	1397	1397	1678	1	1	11369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPNGDn23kEMPX1m13rxFZsAa1jvbxLVeFfwnKvz8RMpZiYK6V
27196	payment	2211	2211	2225	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKWgBDECRZqc8Dw7sXPePc1R5Kyjyz3cpBhRZ9HpHStK33mRn2
27197	payment	2134	2134	1874	1	1	2223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzBgh5u9NDkhwgJthNrveEE7yMeQuCVTfknT3Gx6bMeymzTps
27198	payment	2133	2133	1874	1	1	1798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2G9kXVXSRiHT28nRvh7XqEf14cncVhQo67TYNoASVs27r1W6P
27272	payment	1397	1397	1678	1	1	11390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfHo3ZF49Wdz9DG9PZiRrYtt6tRJcvdLXnt1YGSwVZUeVTqfJ
27273	payment	2134	2134	1874	1	1	2244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjGwQ1YPCujJjfch6Kt5sk8NGuASTQut1R2bnEeoLVpKKt2W6
27274	payment	2133	2133	1874	1	1	1819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8fpGLAuXF3u3buKm1f1UaGZJsGmK1YyVwEzwFkHru3gtcY7c
27295	payment	1397	1397	1678	1	1	11397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvocDK2H2GNqVk2wNTxk2xCtJUBC5sxTDN9WAayMM8PinMXqH
27296	payment	2133	2133	1874	1	1	1826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPknMQgwUWibypm6rAfYNUy5yE3T6bg2Uu7gyTcHvtQgi1MNXL
27297	payment	1397	1397	1678	1	1	11398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N1rS2Jh9Yemav3xfta5PCFbYVEFJR9Mo5vsSJcwNDqN9WZxJ
27298	payment	2132	2132	1874	1	1	656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufvySuCjDuNjYJxiZo4LSxm9yS3z4LY2A8mdNvoXLvLraAkis
27299	payment	2134	2134	1874	1	1	2251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49CQ1Bq6o43wrcfhs3vTakuv5Zg8ZvZusiCc3sstuqcwMELiw
27300	payment	2133	2133	1874	1	1	1827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYvuxGix6t7r2ZcxDcyGxKtb1fzoN6jhWLm1M9UWj3WWquB51H
27304	payment	1397	1397	1678	1	1	11400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2r7uivabwdaeWey8XJQzUfmNW9EC6b5j82DQW63DUnk9urGMF
27305	payment	1397	1397	1678	1	1	11401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBL1z83odgfGhiSMHL42jbsuvGndLebtMmvFv4vucTpiGMZ9SW
27306	payment	1397	1397	1678	1	1	11402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWHVzh7C8fbUcvAdjgkayAkz46rEKCFeuaCnKJSVpW1pJ9NDJ
27307	payment	1726	1726	1982	1	1	8232	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYc1YBRA43YzznydbQftgiZ3HCm6tejQDPJkXNCjeTstf8NWSG5
27308	payment	2132	2132	1874	1	1	657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wRHA6ZS2bqksXHrBbvXXYEBdKiAfw5UQVRcUmem3KqafYXjm
27309	payment	2134	2134	1874	1	1	2253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHvPiN2bH8RaEuAfUPwNSdpSxQ6yJYznQd7XsR3F22JwsTX16
27310	payment	2134	2134	1874	1	1	2254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmnkkU3i1idtTLb571JQQHZbDmtpGDPS9hXtsLkiEEbV3ZNwy
27311	payment	2134	2134	1874	1	1	2255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eMgxQRZbkTfUyFxb8Jnq5F2EbtXq4pfe4h8fcpvV2UY7vX6P
27312	payment	2133	2133	1874	1	1	1829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfk7swr1eUNJ4xY29rxcZj7LrmFfCSRF97fcHBr1oXmmQmgwg
27313	payment	2133	2133	1874	1	1	1830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwFvvFpFHQFa3ALKKyso7pJLcLuz9yq87rcBbX9ZGVqFUzEZk
27314	payment	2133	2133	1874	1	1	1831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNxUy1zwrXhntEWcE9wi1aa2Dm8TEzY9bBRB3Z4iH2CAezMAJ
27319	payment	2133	2133	1874	1	1	1833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7nEqCqkTp9ZVvnHCmAKqZZn97gFT6x7BJW1y1c3pnK3Ea159
27320	payment	2134	2134	1874	1	1	2257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4VpT9R3NLRAX5Zyv4QoqzWqpDgNA7XAuBRDtnaofaCeRUCA3
27321	payment	1397	1397	1678	1	1	11405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa365JH1CgUXeS1FkaDRbLenkyvXvqTFZgWdfd3CGAWGFCgVdKz
27322	payment	2132	2132	1874	1	1	658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2osL9khiEeW2bvBnLSjxRMDGQVhQLHQjbYwmXz6NtCe1EQgD
27323	payment	2133	2133	1874	1	1	1834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgZeM8CZnq4NRsxHrTuuw6C5TY3n2iQwnXdSnyZKockfJSubW
27324	payment	2134	2134	1874	1	1	2258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHLQfAPmJqeL9dMftVNiNhdMQQX67w912roUyQUC68Zm8k2pb
27349	payment	2134	2134	1874	1	1	2264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEEfz2L6yNtnzfq8uepXkUQcLGfF5RqLNr6ka7bqThYjCY2X1
27352	payment	1397	1397	1678	1	1	11412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLGWrUy9dQAEkVrSjNH5jpJNabfVXjUMGLxtMiWdrNQ3SNrUK
27353	payment	2133	2133	1874	1	1	1842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgexTDrLk4yYftZk3XCYAhr2vWtB1gUdxv27kchRYsxknB8aF
27354	payment	2134	2134	1874	1	1	2265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhuVbzhXpe5D3r1rFvx9jQHMZw7zgv1u4MHzqrAC2TJHTJBEZ
27185	payment	1397	1397	1678	1	1	11366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dVMHCp8N2QedpHu9E9TGh2hRn852rpRCViXp35tsLqRFhHKN
27186	payment	1397	1397	1678	1	1	11367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdTbgiq1Le5gd3mXMJRnmhiZhr8iccc8QJGWYdYp3V5Kqj3o6
27187	payment	2133	2133	1874	1	1	1795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfV3EhGSTNseyNG9imTp5tSBQbjRhEfoXHq6JfANTwD3tQu9t
27188	payment	2133	2133	1874	1	1	1796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqx2S1GXZtSW5ZUYLUTpbCJ1AP6QzFV5epg2kUAtttZg9wJB1r
27189	payment	2134	2134	1874	1	1	2220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuXJrqCSLRwW2R61Dt7YKfvGMW3e2YFiu2CYn8PfGN3vJui2Lt
27190	payment	2134	2134	1874	1	1	2221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZam3JhnHsBj3UWMESHy4zusEgu6sbqVv6fUr5JQeBdAjPSczTF
27223	payment	1397	1397	1678	1	1	11376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7usLVhNWcmrETgN9S3U1jRHm7q2mQGmYbeu3VXdTN9DTwrdB7
27224	payment	2134	2134	1874	1	1	2230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQw5Mp1XzdKbsZbDid3eUdZcw1B4zyBfSimTvEvej3R32G7Rvo
27225	payment	2133	2133	1874	1	1	1805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkx7zLkqmGbHHh8iHXRPBRe3iL8ZPFsTC6WhKvERykdusp1MhA
27248	payment	1397	1397	1678	1	1	11383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYug1nUbsM4muUFbBJa9ekhoo2cdUkUgB9ZY3AV18XY6maEnEXC
27249	delegation	2225	2225	1645	1	1	0	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrA3dFK6GQ8K68W8wwnUsjyN4GyEKFBenYocuukjk6bAqGAqqt
27250	payment	2134	2134	1874	1	1	2237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpGG4V8dfUP2n68cqBxdhh6vvGCTGWyv1s7XqhPxLG4Ae4oidL
27251	payment	2133	2133	1874	1	1	1812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Xi3YEn4WLYX5EtBDuTcX7aKZmj9Fz4wCqERNkXv689nxKRXE
27260	payment	2133	2133	1874	1	1	1814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDBmRXfxJKh7WffxfaeHhae71HfXw89wbngsdLn1E9tcimco8
27261	payment	2133	2133	1874	1	1	1815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVkXobvJ74Zv87bTNuoru5BL1VEVLToUVNBA7qqax9yuvBg9G
27292	payment	1397	1397	1678	1	1	11396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCuU8MyxMsKEts7D1SDmSyboimdi4v2y98rP4pFvirVmQ1YDX
27293	payment	2133	2133	1874	1	1	1825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUW1kkN3P93n3i3v9sA8Nk5kbU17ig7H2hbPwsXQQ7hj3XNgL
27294	payment	2134	2134	1874	1	1	2250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpkx6d4HUfTz67ufyJU38E2HDcRy8m6xCou9omdidfW9joaZ1
27301	payment	1397	1397	1678	1	1	11399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDZg4rrJCtfhQ8ZMAGR3W5R9f2YKvte4BNjhSEjXxLtG4cSSm
27302	payment	2134	2134	1874	1	1	2252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHnvV29Mcabsm29d6ynKrrD8tw8mySu3M5FsXzRgx29kdPe8i
27303	payment	2133	2133	1874	1	1	1828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72jLy43a8H44Gpyst1Dn5yusR3zY7aoFW6SXCfMH3Z5FNH69A
27318	payment	1397	1397	1678	1	1	11404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghc6rRd972HtotmqaxFpzGfF1FtzhxsjXQjyZ5Ub5wC3SD4Hc
27328	payment	1397	1397	1678	1	1	11407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqLMBoAjRwCBD6AZxYVoGhawjgEDiKgsRqSPTPEp6oGzQgUE8
27329	payment	1444	1444	2214	1	1	6	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQrhCkstogbdWm8eX9oSsVB4hmJHrNdGTeH58drvanzPfivuH
27330	payment	2133	2133	1874	1	1	1836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsK26154Z9J7Dy9Tz67Ug9FdhaXq1JcTi2WFRLyuzQm9tJ921
27331	payment	1726	1726	2228	1	1	8233	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSvrVByD4J7dS3BzpCMwCCmrQnsmmjK2EQoUXUgmeZEu3EFkrA
27332	payment	1726	1726	2229	1	1	8234	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKHD2q4m2VNx629wT4YTyW1tdYaupANxauVaBLKQbYhEQhqpjP
27333	payment	1726	1726	2229	1	1	8235	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8SsFaDJzUwzvr1oKfkCoyi8Ce5eStwoAPn18SHtM11ReDdiMX
27334	payment	2134	2134	1874	1	1	2260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7J2eKQC132T9j4ZiGU1nA3sK1uGbd36PZow4LV2gfgACHdzS
27359	payment	1447	1447	2230	1	1	5	1000000000	10000000	\N	E4YfKBA67Fyih29oMDJHkWnfBZHwHmwGAS9TkjmntAh9TqzeUNjS8	CkpZDsLfnn27oCHtCBTKQ3V3n619AGBaczmihtcCezvpx3F8QQsYn
27360	payment	1397	1397	1678	1	1	11414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aY5uiVRdebMDs7wxw1WZh9LVy8W5ZTcect7Va6HHRB5d4mER
27361	payment	2132	2132	1874	1	1	661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXo385CNTskS6CSTc5S1bE9ACTTUPL9r66g1dzfbgDzcDwcdb
27362	payment	2134	2134	1874	1	1	2267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzR19rDkVQak8krYTxAR4TQPWgG2DUepGP2vZ88FwcPWc1W9bY
27364	payment	1397	1397	1678	1	1	11415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDk47C7d8Aqp4fNaSKydfcpdReHbZALEf9epvPSV69GxrkEH1
27365	payment	2134	2134	1874	1	1	2268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpxZEJZLd6AquqCcPwqmMRqhMV6KUa9XBPNbh8byLwnFMSrD3
27366	payment	2133	2133	1874	1	1	1845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCNxbfCkYHcjcHfxp1PH9JrV4jx16ufXE7ei7tgU3NNuEPH3T
27367	payment	1397	1397	1678	1	1	11416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2m5GriToEHc3Bsz1WCa3hGNAxW3deAXqEF5i9ntJtYAhMEdS
27368	payment	1397	1397	1678	1	1	11417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTygXz3k9e9gPAPqHxnouoGAUzhpDGsbuPJPdDrRcM5Qrbo8M
27207	payment	2211	2211	2225	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeptHp13DKb5jhfqXVqnMqr7vmWwygSLY9zJneC5j9nvQd7h3
27208	payment	2134	2134	1874	1	1	2225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrriz11JunsQe8XQkHTvVAVt6nUP6nYjkGXxM3wJwqoMahmcF
27209	payment	2134	2134	1874	1	1	2226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UnJiUA2Ae4TUwXUifH92VMEy99cpin8usxDUTWzQoB82mQQU
27210	payment	2133	2133	1874	1	1	1800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9h9C7WkFzkH4VYfFQaukVgVfyCbRmuDtRgRpbJ2mDpzuVjr2N
27211	payment	2133	2133	1874	1	1	1801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSHA7GjhvF3x718hmDf1UUXTw3crcvVd3BbhUXAC8M44nQ1vfM
27215	payment	1397	1397	1678	1	1	11374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8Yw74JQDq71MN6U3ro9qndWNLLiBUV8ePjVDWo6KXNzo8Nwr
27216	payment	1397	1397	1678	1	1	11375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGJdFp3ydx1gxiancGBMZxbEqN2e5vBQM6k6hxj6GNxQrQRKQ
27217	payment	2134	2134	1874	1	1	2228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjteuLJtJkpYRMx1P8W81bueZmGggSZwM7nKUgPh6MQBbHcciv
27218	payment	2132	2132	1874	1	1	649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJiv5ZcskkFPZLiFc4GTizxiioV6s5oFVUxn6jY8K5k2aAv1L
27219	payment	2133	2133	1874	1	1	1803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4kdEt57BKogUeiuGuk7s8xGZKDzgQTtSbqLiWCjzWvtFPEP1
27220	payment	2133	2133	1874	1	1	1804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQW3hsBiqvxwLoPfB3dVdGahGvNwvJLLxoqWvtP9dz4mkcz2o
27221	payment	2211	2211	2225	1	1	2	716000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7DPhyzETWVHirWgyB8tzydh6C3ZS39hpaXJ6FW3REkDVYS5X
27222	payment	2134	2134	1874	1	1	2229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRhaTZdLUHTvqEcPKR9WGReLiTjP67TUoXM6KEUkhL6FykTRN
27252	payment	1397	1397	1678	1	1	11384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6n936riF5D8itr4qtnPvVSgtRUFx4c2WgvFJA6ocXyXRfqPSJ
27253	payment	2134	2134	1874	1	1	2238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTUE4EqjcQFRJ4nL5bjL4y5mj6BZvVGM2Eq5UhHr3VHog7EBx
27254	payment	2133	2133	1874	1	1	1813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UceusxHjdn6epGXbvvCXGkqFowAiKo5dguUFAPZYzwPTLPJN
27262	payment	1397	1397	1678	1	1	11387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDBiohxBXVyL9BtvxFwt9FWAZ2HDwenFXo9sfqu19fuLFfHD4
27263	payment	2134	2134	1874	1	1	2241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXztzXB1FXhjxMx5iWvGASNJ3GRs3UnAVSeLMuop8sPZNAe3nX
27264	payment	2133	2133	1874	1	1	1816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQH4depXchnEgQ7s1sJ3JVrG8yR49Hmsen2ZpWradSCeBCuJj
27275	payment	1397	1397	1678	1	1	11391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTSr8P4yJo8WoMvyWJATCPvdzyqzFTDTC2j4W9byzdVpqbQtR
27276	payment	2133	2133	1874	1	1	1820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigYiMs8suU4JRGDHSGphsKggasCxs55LLQxE8tTDNvA7atU42
27277	payment	2134	2134	1874	1	1	2245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZoKQLR1KB4QNtdeRSi1yGxkmTDN6MNajnCUBRPaeVGbK4KW1
27278	payment	1397	1397	1678	1	1	11392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXDxftC91Mh5Wgb9ZfvQVf1QGr9PBEyp1wiK1FTkWSYREU3xh
27279	payment	2133	2133	1874	1	1	1821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJGxLkhP7bH8rxbzHyKV5tDoaVH4Ud5L9HBebr19sMyx9KtZD
27280	payment	2132	2132	1874	1	1	654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YYuBYe4ABxsxMjE2fpWr6xBiacxTCwUkRW9WoEHPjcBjXLDr
27281	payment	2134	2134	1874	1	1	2246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCuHfG96ZHLBDoSarWF5NMeZYNWZ5wb3zEXVZhBqNqnscrYHEB
27282	payment	1397	1397	1678	1	1	11393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8kaDq4SNoyy5BLu17VvzegAAZF9df3Wz59wCn3i4FQxVdBJu8
27283	payment	1397	1397	1678	1	1	11394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSgbDZjEyL97iEWQ4VbvUewLwYtFhHevKSLokLLCfdAQwVQsn6
27284	payment	1397	1397	1678	1	1	11395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTHxpN5a95Ss6AaWdCYrx5FwN1v7ZgPZKhYdtm2etzvg4u9LY
27285	payment	2134	2134	1874	1	1	2247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4ALLgu2LYvQcfUZouw1NumYM85X89FwvC68ikwoN7vCQGzAY
27286	payment	2134	2134	1874	1	1	2248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKuMtWfkhyTsU37wAebFhj8rbY8fZd4j1PDZiK9LoR41ScXJj
27287	payment	2134	2134	1874	1	1	2249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZJpLg7ybJTWwDwuWcG2wRRxenVGLwG8xvHFVJKHpp1G3uhmU
27288	payment	2132	2132	1874	1	1	655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwMeakoP7paR8ZT6BCBSLVj6hJ8AGPv7uvRnV52EoA3qxjTZS
27289	payment	2133	2133	1874	1	1	1822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFhqv667MxNhVv8fme8EJQsHYSdx7dr9wawvAm1CsJGSfYDPpn
27290	payment	2133	2133	1874	1	1	1823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjZ7LLQ9NDmJikjgdi4wxe5ReaKSPP3vAbkeBjQMrnTXFbuCb
27291	payment	2133	2133	1874	1	1	1824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftF1rj5iJFbChjrBWW8WW4PGdLmZ8gstfwkYBXTnnqC1b2ht1
27315	payment	1397	1397	1678	1	1	11403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrwrmtNN197xt2M97Ba2urmCW7KJ5xrPhkdgpn3gnMmCoA2cLK
27316	payment	2133	2133	1874	1	1	1832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpZ8aTp3zWZ9Qa51UfGtAdLeGJ642owUTTAfENG52v8ug6n1X
27246	payment	2132	2132	1874	1	1	651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2QdmsSJZeq6pPen3gdSaGWFDwnZdRgJH3Yf6inUnfBrwCQaL
27247	payment	2133	2133	1874	1	1	1811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwXhU49q8s6kKLmitjnygvQ5TS7Zjx2oqWAVpVFunRdycxbjkM
27255	payment	1397	1397	1678	1	1	11385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZketcWegCep38c8VNMTpFUHMCaxcRYu5j4Q3i9JpNty5Gs8toi
27256	payment	1397	1397	1678	1	1	11386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CDb7FCzTa8CfCG76bjA1n9yXackwMQNZamXVCMrQKSyWCKPT
27257	payment	2132	2132	1874	1	1	652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSZrq4YfvmAkKSQ1DxCrhPCGK2GgNxVERGNipcFsNQFdwdxEo
27258	payment	2134	2134	1874	1	1	2239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89GYD3oUanbmaonyjdR26qxctYhvM8vt67JHYc1Y2sByFKp7m
27259	payment	2134	2134	1874	1	1	2240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNnyBcMrdtm8x4Kj2MisGDPCKtbiDqaRs6aLejSNPrcdzEXg2c
27265	payment	1397	1397	1678	1	1	11388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWZ5MW8iG6th5HpuQRGddhgBzHFqKSsXtqyViH3Jm8tjDZawd
27266	payment	1397	1397	1678	1	1	11389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJf7cSogtg36Baxeece4Jg3AAnqs5Xik9RtvPknZYALsf89rH
27267	payment	2133	2133	1874	1	1	1817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9Xb5eam1iB96mowFb8dx8nxv2oSCC7EAENdTjPyF4jUjFLHa
27268	payment	2134	2134	1874	1	1	2242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjN3BhqwoLh6BdRs28n1mfE5Ep5wgsj3Xve8X1c6ZwtJGmrBK
27269	payment	2134	2134	1874	1	1	2243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pyrWEwnVkMGwRW8qHeLPxpmg2MBT8hoN5xdJ53qtJrRzjTbJ
27270	payment	2132	2132	1874	1	1	653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuuep1JY4srVDAiP6GXrKTJf2TVh4KQt7GHaWeyd8V47yPRBQ
27271	payment	2133	2133	1874	1	1	1818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFfAWSd7SxH5Dy9JBtw5D6mRcusbmRnH8n1ajA4jt5ExM1AUZ
27325	payment	1397	1397	1678	1	1	11406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVh1EQJ7prrrdp35CkLGofk3eCxnXgX9prP3RB7JfpKbvsugb
27326	payment	2133	2133	1874	1	1	1835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbMsH3KBWAmRQ1ZHJAWhUhZXgkEB2q2ZUYxDH29H6kzw7U5TU
27327	payment	2134	2134	1874	1	1	2259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvraWLwhpd5gkbA97gi5vbDic4ZEKkF5H9ciumxYMj5gxh8ngo
27340	payment	1397	1397	1678	1	1	11409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjcm7D1x3j255LhQdwHSGoXvZoPtNkUJ1jskzgarNearmWKCV
27341	payment	1397	1397	1678	1	1	11410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZia8Typdn2TvSEnNKXyhgG8R2Fs2teew7BAyF2L4UTCNU5pJXt
27342	payment	2134	2134	1874	1	1	2262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicw79dNWq8RgNrdVd1W1AxrEvev6ybopqqUivU2oTrukGixNE
27343	payment	2134	2134	1874	1	1	2263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWhRmXDizaJPANJLnutAwMYtRUQr8qjgU2NvAvFHEyYdzPgyd
27344	payment	1444	1444	2214	1	1	7	2500000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgBxSDW2qVY8wF2syCehdRFRFAo9LhgMG1UMHBBtr3qpEGLNs
27345	payment	2133	2133	1874	1	1	1838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4PywXeknMjAhEGSFGD21Smf5g8phrF9pjitRmbGgvWntT53S
27346	payment	2133	2133	1874	1	1	1839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhPsFxXCQ3FGpLNmLyq4kCHsAFKfwpZhYZATQs7MK7YCxtT7L
27348	payment	1397	1397	1678	1	1	11411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZxJpdKUDVsDLRPdezg5tVbhgoymLUURYyJPqTGqQxgs8xuXJ
27383	payment	1397	1397	1678	1	1	11421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC4TkKkGxPtcyUtqRufT2oxoLFAJLdsVHsSo4kC1b7LnSWpiT
27384	payment	2134	2134	1874	1	1	2274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3UUugXAmxXmmLHEuJ8QtveMhwn3w9SKxPLvRJ5ipXYF8keDj
27385	payment	2132	2132	1874	1	1	663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZTCbKzWRt4TEaezRXJp7DGm8VpPcJZLonNH8YXNRn4RDgP8b
27386	payment	2133	2133	1874	1	1	1851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoWjAMesHT7vG1QFLK8iWGTYysGsayBZvKah6d7eChupjqazs
27393	payment	1397	1397	1678	1	1	11424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZym9jejCKt8yisS6dQVUpiqYzVXSb9uFXUjRDS9R8veRFLRSR3
27394	payment	2134	2134	1874	1	1	2277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4q1dtvTdubNAhndW4R4m7mKFr2hEs8D7wYUMLRZnbmE9wj7mm
27395	payment	2133	2133	1874	1	1	1854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5arDmeHpyszvFYwvexhZkjiQ2h9VD3CF9cGBCfLTP6ySHJSeD
27396	payment	2132	2132	1874	1	1	664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB2sHGAaK8hpdFfYDZRBCErZfYRrF6Gvdj27ZZcJrvsqCkxxEA
27397	payment	1397	1397	1678	1	1	11425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxjfWM3FnGEQqbdBSDuwRS7JSVZAHjJaDzNC4fr2oMWRWU6pR8
27398	payment	2134	2134	1874	1	1	2278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSBdrH5mU86P8HFDb87ihfySCKy2yuNQUnbG3JwoEHV9bRiwQp
27399	payment	2133	2133	1874	1	1	1855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLg5LNhfKwxqLeNbm72MNNYLA7MhUcUVDzo51b6MsHfHjrfxE
27407	payment	1397	1397	1678	1	1	11428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAW4bDvB2UtSTnw6gw5YSzn6pALruce14tkxfaZyovbTiqH7W
27408	payment	2133	2133	1874	1	1	1858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqiyAaHQXvwzgrrkLc4EXUijRPiJH4ixdDeBDHS2aaVAdzboKt
27317	payment	2134	2134	1874	1	1	2256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicikrU7zQjX8FzcJsmTMxLcS8UhjDbK5hwtMPFSj1zMWMfYQr
27335	payment	1397	1397	1678	1	1	11408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsppR6UykLpu3eL1GpAuptnagBrMdd9YMJDunHzPnprnE2pDPM
27336	payment	2133	2133	1874	1	1	1837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDvGt6rgptreLtYxSnAvQ7FR973na6u5oebJvVdKNDxkeJw4g
27337	payment	2134	2134	1874	1	1	2261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjLf1ASNCK1gHNaxq1UaS9vs8z7PLw2DBALWHy9X6vmrWf8ox
27338	payment	2132	2132	1874	1	1	659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LKjVXL4uyh35Wei6bJ1ECK7S948v8Jt2SMfgWrULKS8gqQxZ
27339	payment	1726	1726	1982	1	1	8236	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwTCiXuZGXGfm2n27LPrqJxngD3CyMV72gd7jKxv8D2UndUBkf
27347	payment	2133	2133	1874	1	1	1840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YM3iH2tSemy2vHwJg2XFzMuVz4oNDgu6ProKFAYDtBEYa4j1
27350	payment	2132	2132	1874	1	1	660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZM2Cez5MFPLhd6AjoJEtV8gSofkGQqKNGZaLqc57v57gmkL6
27351	payment	2133	2133	1874	1	1	1841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmw33XZH2ZTYDPSdxLREurQREzsL9HC2HouHYB2xDkx9MMaYT
27355	delegation	2214	2214	1444	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfBJdXDQZ8i95HptqiJEKDU1E8VxtbstBw4uq3krJRKoHLi2L
27363	payment	2133	2133	1874	1	1	1844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTidBF3rvVQv86WibnFVNTpWctgNbTEp4tPDJTQrgBNVyfZ12
27377	payment	1397	1397	1678	1	1	11419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4GWhTP1VNU2EgKcNHWwcncM7CzmHnPh3XEDsXy6kSJH11itp
27378	payment	2134	2134	1874	1	1	2272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yixaN1ApHKzvvNsAoeft5VYobwNNP8MzgjX2cotcr9ZzavFn
27379	payment	2133	2133	1874	1	1	1849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvj2Gd68FiTE2jn8eJX7iPErb7oxvXtzHkBFgZm5rjoQrfn3v
27403	payment	1397	1397	1678	1	1	11427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AkofcvnSFTaBjH4vaoJfQV8QYtjbSrrYBcKspxPWAaqP1K2h
27404	payment	2133	2133	1874	1	1	1857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyCrz45E6FV61Gqs6B6bheYwN7LDnhMvY4zxpW7DY743GnksQ
27405	payment	2134	2134	1874	1	1	2280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmd7mNWQGdgqVvcu5yPoCNgz5vaMHCbym7xZzvEhe7pcDwjBc9
27406	payment	2132	2132	1874	1	1	665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdsQevWsmZrM7PhccWnPri1sSdvMSkP3mnhuPT9esMyah2ubZ
27415	payment	2133	2133	1874	1	1	1860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCPAu7frMYkZcM14nS5cHZjMBoKx8BtQAZa6NE8vHC6yRkh8Rn
27416	payment	1397	1397	1678	1	1	11431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohsqKhNH2jBsuRVALNLqEoK1CejjwkZLm4hoHDDCbFQSywcT5
27417	payment	2133	2133	1874	1	1	1861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmoj8WtAD8dEZ3pu2cVFNsjcoxy3qNvfq7tHrNxijjBiUc8d7
27418	payment	2132	2132	1874	1	1	666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWkLocV6PZzx8b6UbdxafuUXs3kwDERXwVJRPH8ZNZyTc33UAH
27419	payment	2134	2134	1874	1	1	2284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnAyndXnks62nQpVbyCxhJ8ZndUJYCKah2iCYRxz6vT5r96iq
27423	payment	1397	1397	1678	1	1	11433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJaZLfREEB5zJVmV7xNRWLVXM2RbthHLkFrML7Pn6rSGAESCh6
27424	payment	1397	1397	1678	1	1	11434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9QXUp4GPEUBxTLGP27fRAc12Vdft93eumUTTW68cj45nrnhk
27425	payment	2134	2134	1874	1	1	2286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEggF55WLvRnvfCfrsmfLS166ANvwyZ7vTVkz8FWN1VjjSyNR
27426	payment	2134	2134	1874	1	1	2287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfE417ftsU6jXHwU5zFvZXQX72cCFFNBUCYRM2RnQVQ5fnETZm
27427	payment	2133	2133	1874	1	1	1863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrePMVPG6Vd3e9QMUYZju9NmtqvT2YRueWV5kqZodFZdDvcH3G
27428	payment	2133	2133	1874	1	1	1864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKCpwSN9mmoUGFWkeB2hWRKwRcEbfjXcAtXLXrMXqesHkfQja
27429	payment	2132	2132	1874	1	1	667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jRJHtHPsTMpxRg4uRMHRXq1ModHf7JSmws6DvFDvdMZtExA6
27450	payment	2133	2133	1874	1	1	1869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuCDbxS2i8AeywUwLZMLBDKLv9yhSRU36wp48NabsLbHhq2vG
27451	payment	2133	2133	1874	1	1	1870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszFEVvgEgrBGFbdWSZ4GZzLu4nKwN8JUJPSkhDXUrs3SVZu57
27452	payment	2133	2133	1874	1	1	1871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncnynPLob6xioDijN5CdAsHjZRWvwPpBgt4qEF6i44TsPNyo3
27469	payment	1397	1397	1678	1	1	11447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpFK1KcTa3Bxi8XoBTE963trbB45fEvKY7pczYxvNEptVhD4m
27470	payment	2132	2132	1874	1	1	671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqaWfkGyrnuhx7AXEE2FAVdfRLP6UiFxx9RKkLhrvH1ysLbRU
27471	payment	2134	2134	1874	1	1	2300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2M5xPAesVhCApAAixLUX3uoQ3bxe51FgeRqq3BYYrsXpUSVaQ
27482	payment	1397	1397	1678	1	1	11451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLNdKJpoAh3DJhD7mDv9WsvyZ6pTBYzUQxC6LVaYZv15HE6mS
27483	payment	2134	2134	1874	1	1	2304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAE55xaKujgg7V8uL8aeDxcrp6Z54vE541t3jrHuvg186Lgvge
27356	payment	1397	1397	1678	1	1	11413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QXACQG8HTH9PLuvfRMEdJYvC91aaEZAYwkRZDvmD8hCHB2KA
27357	payment	2134	2134	1874	1	1	2266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2UyZmSz3gA7LVaVMySs63QjMW1LxXdxa22FawmG4ZsjQnpxh
27358	payment	2133	2133	1874	1	1	1843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLmGKE9r1vkk1DzkS2g9JcXUekaGpDt8EBbkH77mkP2PBLC7f
27380	payment	1397	1397	1678	1	1	11420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVZo98CVuhnmiJGnTdCRZhdBRmXdF1yxwMhCnaQtAVW2CxW85t
27381	payment	2134	2134	1874	1	1	2273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifdWdunNAaDCB92KqdxjmgKUrpQbLWPrgHnJkkwZCeCkTPaab
27382	payment	2133	2133	1874	1	1	1850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfy6qs79L3GshvDNqD4kAymHJByNZL6i14HnZZ74yCS4rnKpY
27410	payment	1397	1397	1678	1	1	11429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNSoL9H7YrXfV3oQFE7bVVmwomtHtgmhk7bax6t5bkJpF1Kj4
27411	payment	2134	2134	1874	1	1	2282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbi177B5VvQnTbdqi7RBd6i5BKnWSSNTzBg2t4pD51pFwHSTH
27412	payment	2133	2133	1874	1	1	1859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgk3HHXqqotvGUNDHBtC39F17T7UDzHUkP1YsDwegLe2gBe1T
27420	payment	1397	1397	1678	1	1	11432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3ytyJYuprFKDiRA8ed3EGNQL1th8ML2pGcAUqb5cwbQcEBtw
27421	payment	2133	2133	1874	1	1	1862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmvjzh7fEfprpiS6qdKdgJDJQ3USvc5ZunysVpMZ9YHSTJvmj
27422	payment	2134	2134	1874	1	1	2285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLoVMXZj9PmKmr3x2n8ohCEx3U5qCy17f12ViVMB4j7WW7f9B
27433	payment	1397	1397	1678	1	1	11436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDhayJAvxFJaGoKofZpz1Yzzt9GprjuVws2RYaANWudqHKHjHA
27434	payment	2134	2134	1874	1	1	2289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbds642fa2ni1mjtzcgoFoabmkDhiKCjVarN7wq8jweY5oLYT6
27435	payment	2133	2133	1874	1	1	1866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HgKTL1f2HCzyeqsikkMnF4gU37YgTBqReq542x6WSdW79t6m
27443	payment	1397	1397	1678	1	1	11439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMgyZmg9NGZgJBDkwPNT3mCM5qee7oUatw6tdL62P8Q7vKzUS
27444	payment	1397	1397	1678	1	1	11440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5E7Q7jYEVpohNKLKxCg72GGxbbg8Dnwd8fbexWQ6NNy4WCxiD
27445	payment	1397	1397	1678	1	1	11441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJ6v5esrskK6UJye7tgTq4urEsJApHKR1ZGmQbcprjXCr8p2M
27446	payment	2132	2132	1874	1	1	669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkgswVrBcWrJafMUNpuAfNADomHmSiepfp25DXQ4rWDUYhG5KV
27447	payment	2134	2134	1874	1	1	2292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9M6mKgn3rBDZF2WVFaBfgUCJvH8eg67qbDxtWDgF9oDuKkBMV
27448	payment	2134	2134	1874	1	1	2293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiJEHaG95WbTSjrT5kQg4eYxuteg9Hk4SUeoknaWdzNG54iBP
27449	payment	2134	2134	1874	1	1	2294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2NMpXwZVngRSXbCunYrKkgsWVxTbb4EGw849QsKTHgSgnCKLB
27472	payment	2133	2133	1874	1	1	1877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLL9XMkc4hZf8d37Cn3n99QiPiSoiRaevWSTRXMt6LCMDsWYMv
27473	payment	1397	1397	1678	1	1	11448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhN4btKjRYhwo9XUP6GPTU8TS3icLE6Euzvz8QJEixXuMWuhr
27474	payment	2134	2134	1874	1	1	2301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MMGyew6cmhkeH3wTPGBGKSYwVijSVNxio1tJJFYVUrnY8fxL
27475	payment	2133	2133	1874	1	1	1878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamBUbHoZMyGkhxGkti5hfBmP3aeTRQqx7ESHr2sB2VhUHpKN6
27476	payment	1397	1397	1678	1	1	11449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33B9o3fMaZMRNaMeBNHUSmUD4txExqBqbhAVp7o1RUzVUPvuZ
27477	payment	2134	2134	1874	1	1	2302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbkcxhzmb4qzrFLTKoHy48DQ2jRV5brHaJyWDqc9uLPww58a1
27486	payment	1397	1397	1678	1	1	11452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj7GHdFMemtUKfRCtZFSQu5ksA1obZzerxKFLhwLiNNY68Q3M
27487	payment	2133	2133	1874	1	1	1882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJG7tT72xPkmyWE583iqiiM2Re2wZvacMi4mHJv8AvqipUa3H8
27488	payment	2134	2134	1874	1	1	2305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHe6Q5Drz5F7XEFy5Z4PnDV6HhnruXTcD83gsDtpnmQ7T54z9
27495	payment	2133	2133	1874	1	1	1884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPKQtNYgddVErKHV4QfQ1i8po3uFfNmZUyJcVbnXgGpoUmM7K
27508	payment	1397	1397	1678	1	1	11459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLBgimw2e4o52WNKAhEWUBGErJdv5zECYZiHfTyavf4kdFNKJ
27509	payment	1397	1397	1678	1	1	11460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes3HmvTb3QwBecaAs1LDGawqYuW3LCp2277VcdWT6fNvSeVGn
27510	payment	2134	2134	1874	1	1	2311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGdCFdSGEV8ZaDnq1v43EP3mGqh9vo8dRnFSgc9JpsCG92vJF
27511	payment	2134	2134	1874	1	1	2312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr88AjgNVS5eZa9BwW2JffLgTSg1Xw8MhG4VPqeVv1YUAVvCy4
27519	payment	2133	2133	1874	1	1	1892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDdqLhUYQPLphAe2xgtZBgwv21G29DHizEhRRFbL5oaQBLXkd
27527	payment	1397	1397	1678	1	1	11464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqsiwnSoAc5tmqwn58PbuuzUN8YY1qfw3kdf5Vm71rDiBTjjn
27369	payment	1397	1397	1678	1	1	11418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJMTNGzbqDrzvbTVr9ULBpCYZdi2rPMdoQE7LcGiJmQ53BUSJ
27370	payment	2133	2133	1874	1	1	1846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxsWmopQ1161tJFuDN4HYijfpBgRfzEES7RVCkQhBdEWFH3ES
27371	payment	2134	2134	1874	1	1	2269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7aiPctdVtZ4MHnt6DNxqcqWL4RHdScQuFQSLvGubAqaobXVs
27372	payment	2134	2134	1874	1	1	2270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYJsMqbiiGrpmqRfKfR8mmCkxiU38AAJZQiLKFGSDTEckLmLe
27373	payment	2134	2134	1874	1	1	2271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZ5ZhiAoKDoX27ze1S4hrBC7dJKeRUwrvx4BdAv7LP2vyoBEZ
27374	payment	2133	2133	1874	1	1	1847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEA65uWBzXfvrTJdp9zBDknmwfmVHgn5xQEtVnCoC2AHE9R4c
27375	payment	2133	2133	1874	1	1	1848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkySdsFdcqAXARt6PwZ9kjTTr8AEah4gFffKz18BhgYDMeCi5F
27376	payment	2132	2132	1874	1	1	662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPNmL4dLRWegb4GRkCG1DUUgX12oghGCFe3LSVwAW8enaxTpi
27387	payment	1397	1397	1678	1	1	11422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3J7D1o4MArqD9BStB5HRk9nyuRsnPqFZGkMrY8qPScF9nS81m
27388	payment	1397	1397	1678	1	1	11423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhC7zPxrtWJBGoy5hbvyTwEQdxY64HwArUDiQ6N7zih3dqWck
27389	payment	2133	2133	1874	1	1	1852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AkWsC4G8N67wVMXBFjvUXGKTE5ZYsziPwWqYqLCyQxmsMAWc
27390	payment	2133	2133	1874	1	1	1853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8rEQjYAEM1FmosdSSruDzBqw8a3jndJQ1wn5TxLStSGgmCLr
27391	payment	2134	2134	1874	1	1	2275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6cxsMqMt7CmkgWPjCzZYqMgBTH2QriNc8Zp9Mmp1h1xpe7qX
27392	payment	2134	2134	1874	1	1	2276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshqRfW6KpfK73cQsrKrZZwejwLiZEN5sL7GnrAyDLiwdd4smd
27400	payment	1397	1397	1678	1	1	11426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH89JqBmBGfo6BexHYjP1ZjtmLNRTeCtQ4mPZtpEf4GLCZFv9r
27401	payment	2133	2133	1874	1	1	1856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoCWUXn1QBF4oLpzEPsBQsgafnvBwD7pDyVGYeTthsjXrejdN1
27402	payment	2134	2134	1874	1	1	2279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsD4Pi7p1A9hqoiENd9TJ75HTxBWKhVb1YXQMKwfJrBnTRUb9
27413	payment	1397	1397	1678	1	1	11430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2qscivbsQHCRn8qMwTVSNmibZ9yXkuYb1rLEUUU5u4yZjLMB
27414	payment	2134	2134	1874	1	1	2283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeFeWR8hGcqN1UorvMtCHvs43EHfeXyvMQNfZFWCaMWmj3DzV
27430	payment	1397	1397	1678	1	1	11435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDUFxtuyka2ZiPjj6nh2TH8z8AAQZ6daC2oxsyDN6mD6q2Tqp
27431	payment	2133	2133	1874	1	1	1865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEFkPPoazvpzZQMdQRT5uPwNKzN8VXqUPydJfrU2deTowk3Rc
27432	payment	2134	2134	1874	1	1	2288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikZHFdnDc7vmNeaLFBjmTiCtYhYwGs98H2CQm48JcCuJ2GkdQ
27440	payment	1397	1397	1678	1	1	11438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRWLMkFmXStshhU3uqLEmJZWhcvkdGi91hTsbsLHny7VKCchsK
27441	payment	2133	2133	1874	1	1	1868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoDaYLC1Z5exGq6fA1kPHsN38dY3dc6AQNPmh4XhhQ9zzjmKP
27442	payment	2134	2134	1874	1	1	2291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrVmvYvs27cXCwNC22w3psjJX4LRH5QSKoV1hMhoT5Swii55M
27453	payment	1397	1397	1678	1	1	11442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNQ1bBLy5NNy8PNF9ujTr5VAQ7AU5LGLBAuR7uznrBou879HN
27454	payment	2133	2133	1874	1	1	1872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5H92eunDcuXkGpY1hKnsgSj1ZmRGCxZQijssXqZVeAV1SyrX8
27455	payment	2134	2134	1874	1	1	2295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TVmWQC1PRwjuyGTWTGjEwydEAUZyN4f1G1yka5QWCKpc6bDm
27489	payment	1397	1397	1678	1	1	11453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQeFaPwePHLTsKmFAL6us9qEJi5253Bwa2LLvBSErKKbMYis2
27490	payment	2134	2134	1874	1	1	2306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpr8q9WC3FLst5S1UEHFXvqCqphFPRyWvTPxfcSSjj9CBMBBf
27491	payment	2133	2133	1874	1	1	1883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdDg2CrgbXYEJgrF2XoW4uZzcqUEDDjxfhPypDrP4fT6xstrd
27499	payment	1397	1397	1678	1	1	11456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8UYWUitNXQJB1Jf9ZXJQLPURgvuxgxWSsJbSKpX5oKE8uNZx
27500	payment	2133	2133	1874	1	1	1886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvpPQjD6Qoa3ipb2kKYWwrkFtVN9w9YJM1jy64xpoFNB27WXX
27501	payment	1397	1397	1678	1	1	11457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9ug9NrYrAnCodiXxskW2Fh7raoQhA8ZSgFGTAsD9vj67XhHu
27502	payment	2133	2133	1874	1	1	1887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2BbdbD1JCv4ZMpjwRg84gJPx2vBiSYiJpRYtttRTHu3c2fDv
27503	payment	2134	2134	1874	1	1	2309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqV3ZoqSEsm4nUHfKWf19GbRdtwfmYRMxkDNrDPE1fZNamVhv1
27512	payment	1397	1397	1678	1	1	11461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JBAjJj9voXurzWrPgK3vPfJRDy1DHBTcp5T9EYpouq3Kqzhj
27513	payment	2134	2134	1874	1	1	2313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqjjK95cmE1nK3gzpiuZmMwhpWtrN3c7nC4A3CPw4BkV5G67Q
27409	payment	2134	2134	1874	1	1	2281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bFCigPquwCfDCM6KhCowK2U5HBXhHDD9THiSbPu8haEdktEs
27436	payment	1397	1397	1678	1	1	11437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZow36cX2qXQooKcozdqn9L6mTuB4LQTABGQ5S76NzFKo8txeWD
27437	payment	2132	2132	1874	1	1	668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95hLLQE8KDHDzcmA7evjtmJYEP3L39HX13REtUVhaWf2Z3XhG
27438	payment	2134	2134	1874	1	1	2290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQepWDvCE2jNPFjqMTrGCXWNfeiaAcRU6ZJiQca6eDK9BGE7mX
27439	payment	2133	2133	1874	1	1	1867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YnyRBmHkZM8YK7jq8wWv1xcVcq67NRT1aKQdnFsRv9Kzaiuy
27456	payment	1397	1397	1678	1	1	11443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZURFBGaLDbvMZXGkPEoJUexKvghUWWk8ZRpkXz6K2cQR3cvYW
27457	payment	1397	1397	1678	1	1	11444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZMDAXL6PAQ4xKWrNRTsaZDe7qeD2x8B44YTTFMvZC2fD48af
27458	payment	2133	2133	1874	1	1	1873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt17uGoxTiwkkaK1QKLWGHJkGsu168k9sRVwX1U2VcQvy2yPWY
27459	payment	2133	2133	1874	1	1	1874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUhEBtxpnWKgHBdAvUcQr85PDsEydzKzSawLZXqqoaXkGoEAi
27460	payment	2132	2132	1874	1	1	670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQah3YguxTsQRZ4F2YugcsC88Sff7dH8oD1rK7gVKugoBh1aX
27461	payment	2134	2134	1874	1	1	2296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxteW8UEVVhcEQto61dVKLC1gUNDRA7iXNKe6qKSrG5v1jPsU
27462	payment	2134	2134	1874	1	1	2297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPMTBFekW8v9jK4iLg2dcrEgVkLZBeyscaCwCnuXGBFvisbmf
27463	payment	1397	1397	1678	1	1	11445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93Ef6G7cnuVKLAG2bnttqXc9Rffe1zUsRBiNHUUWMHbX47Vy7
27464	payment	1397	1397	1678	1	1	11446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyb3PzBZmvKpBBU2iwFnkFoBA5ECWeGWmFPEZRQPxo71VWz5x7
27465	payment	2134	2134	1874	1	1	2298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy587tTbcJfVzixqjA8PxgEuxyVBXqtwoDRprv5eoQv3MG5gHe
27466	payment	2133	2133	1874	1	1	1875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZdnkQUnM3ctH5oVD1hrRSUsXLruSpwPDLrgPppmsxzM6orB1
27467	payment	2133	2133	1874	1	1	1876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BmULF4CD7byNUG7EJ6USHaYtM1bPDdqor5NufVk5AixNYLe1
27468	payment	2134	2134	1874	1	1	2299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDjs4e8sizXdjsQYnrgzva8SUMBWP2HWJKe97KBDcCVP26k7W
27478	payment	1397	1397	1678	1	1	11450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6JBQ49eLywAX66s5hDwD398QWRkdoJ2BpLhz58BkST9r2SqiB
27479	payment	2134	2134	1874	1	1	2303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMa1aQ98AWrxLtReRS1pTsshN8yGNMy1pTFXaMf7huUyAGLkx
27480	payment	2133	2133	1874	1	1	1879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYeXNTmKDQEaxXuZsLi6yQtoBCipwgSijKEH2jC3gQBUa3gVZ
27481	payment	2133	2133	1874	1	1	1880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAxEyem4foZN1U3rarTXVnEAU4N6aapuGVP5BUEDCBhEveDiA
27530	payment	1397	1397	1678	1	1	11465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiDcuuxzxW5sLRvH52Uzm4jdCT9Awuc3C8G78Ropm4VKUPg3C
27531	payment	2133	2133	1874	1	1	1896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdNHStaqmzXnQw1FMmRcTf2cw7GUSB6YkDMT3rJA6TFkicDNG
27532	payment	2134	2134	1874	1	1	2318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Cd9T8kt2idfQ2C2x1MAXuX5Fq3RYyGwQtp4As5qwd7FiT82v
27533	payment	1397	1397	1678	1	1	11466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWqgCxuVANUMgqEjp3D6dMgQawdiEtM3B3dtGfkBL97QbZ7zD
27534	payment	2134	2134	1874	1	1	2319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkzsPc9sxYWogWDMWP6kYBytrEFRDfPevNtEQA1qVTbqiHEc4
27535	payment	2133	2133	1874	1	1	1897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4CiEHiY7N9AdR3R2FFGTPfGRWEzbLDhaJugrByTeJFXtewPxQ
27569	payment	1397	1397	1678	1	1	11477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36nfqpYke6Q9ncXehBRMbwWDnqxA4JMufVTngaE5w2tQxu7BG
27570	payment	1397	1397	1678	1	1	11478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWs1MjmsTUjXdcUoBmBqX3GtaSEB9exUhCFB4mCK1BzaWoBU6
27571	payment	2132	2132	1874	1	1	680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPaZNuvwQCrtRbCjfRvRhHnKLicqcGcRDqShxmQzD6XRi1RQQ
27572	payment	2134	2134	1874	1	1	2330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGbwzRrJxHQVGYgkmr5RhX5iS4nGi4QvQsdihoCFqFaEtTyt2
27573	payment	2134	2134	1874	1	1	2331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSg92CApcMdqtPmpzCnSmFBaRCzkwNBLyLwBkK1XotbRqmgYz
27574	payment	2133	2133	1874	1	1	1908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6KRR1Fwhk1pEFcAi3EUUhkfUksvT53C1f6uMAwbcEpgzd5xqE
27575	payment	2133	2133	1874	1	1	1909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGx8t74q3VTZpcMLpei6ZeM51QfFVooAmQQpm3T8qwWdGxLKj
27579	payment	1397	1397	1678	1	1	11480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQD9AyfYR736DxgZWMeD5WxJXyVTgi7uMnye6RCnY3qRjux5BR
27580	payment	1397	1397	1678	1	1	11481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfiqtT1zN66QjC4Zd74BhaV6RzkAdK5xvJtS5pK5wppv3EKSi1
27581	payment	2134	2134	1874	1	1	2333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TBDxHK3LLQwa9kKxsuaGz4bY9Tf3vZhnyLc3JnfTPVW3nVdg
27484	payment	2133	2133	1874	1	1	1881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPVfMJEEEqETuqE2k4KhQ1zco2MTTag4C4geVbMjYjbqqQb2D
27485	payment	2132	2132	1874	1	1	672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuctjgAXcg2cgW2LnF3XUeTSekFoczj7wme5J93aFzBK26Meor
27492	payment	1397	1397	1678	1	1	11454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzC3Tf8bHxTWRMwLUbvhK3a6rfQ5xkBMNPJmUNCvFQjzh5T1h
27493	payment	2134	2134	1874	1	1	2307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbckpTo8bw9MKuGBwDD65kHJ1ttqj4saoCKS82FSq3gPwHThg5
27494	payment	2132	2132	1874	1	1	673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZroJMXGi8GMqA9KQyfZ62tjmBn36YyCQmf4ycNm18ssyPA17oh
27496	payment	1397	1397	1678	1	1	11455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvaXkFAwcDdZEfwReUDppCFMivKLxL1YitXupRbPdDcVhrsc1
27497	payment	2134	2134	1874	1	1	2308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDdC9FKoGafhTD7L7t7NHZ9Bfv6MxUA13o2gftzHRbvRRKF1T
27498	payment	2133	2133	1874	1	1	1885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6V2CsWPtUC5WG5XYQVkyWvYLhYdoZngr68apfAovN3DxPe5C
27504	payment	1397	1397	1678	1	1	11458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDNiY7NqycdHMfrmcCH4RHtHhTfTaLQYE9APpkvvsCQ3KCuSZ
27505	payment	2132	2132	1874	1	1	674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZckf3oDfYy8QURbtr3TBthnokjpRYs495gtsv3ts1j4JhMBNqH
27506	payment	2133	2133	1874	1	1	1888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp3RVy5sdE478XuWFusxTXTyKYXaH9C65ynkfJdhzTcB9pzMeh
27507	payment	2134	2134	1874	1	1	2310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3ws8Cj7Rvwor5aXFijLn8zf1mjCDdgen3yGScciaxcLtLJFd
27518	payment	2134	2134	1874	1	1	2314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3BWYZtyM9M3NSj3MDH7C5LhfnDtSStC4cZHXcnobUbLp3Y1P
27520	payment	1397	1397	1678	1	1	11462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhx2g3gHXUxz575U1KNYosk8sBNKF63kijZB2qyYBfndPJG4BD
27521	payment	2133	2133	1874	1	1	1893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHJa5jLMtWtuoqiW84RPznp5AVHR17THj9WkgEia3vwq9ea72
27522	payment	2134	2134	1874	1	1	2315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uwCKzKNExgwmLZwXGkrSx2VXE6tkVfiduNUznf5cUFRuhsuq
27540	payment	1397	1397	1678	1	1	11468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVDGM33SnuNPU1kxW27xK7Dd7jvDtWLArwmb45ErumBLjnHgL
27541	payment	1397	1397	1678	1	1	11469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjqvYpo26iMKffCUHYsXYqQ1jE7G2wCCd13huYXeAz4Ws5acB
27542	payment	1397	1397	1678	1	1	11470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6tovHiTsjunB4wnNKsDNazYX49gP64qNsSKmb4eipP9GT4Cj
27543	payment	2133	2133	1874	1	1	1899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbfKiJfBr5JGRNQK3wVPuaX6UBg2PMr1bMFCz2wDS4dhcPRcJ
27544	payment	2132	2132	1874	1	1	678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNK2uF7CjrnTuFZfNZqnP84BeBgY3q7B7gxBWUJEjtogzsreeF
27545	payment	2134	2134	1874	1	1	2321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUwWHnBkEBhMq5PRyxRM7J1erB3HDBp8Qptp5yUMeCsVYGbb5
27546	payment	2134	2134	1874	1	1	2322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifMk3xCCfPYxe48xK64Bw7qtkJ9s4McVug2rGFWy4z7eNBoqx
27547	payment	2134	2134	1874	1	1	2323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfRPnLHBwgKd5vvAQJKLxge8qgdyMnKDMypAC98JvADwL3X43
27548	payment	2133	2133	1874	1	1	1900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9T57jtoD6WG3zPYJeZx79GGoJyE57mPdcdJHa8HWtLHTAmNNV
27549	payment	2133	2133	1874	1	1	1901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNHYHnNhjM1pQdcQEtLTBhDztbzxNqJEiWuYVWJjvXciueTtz
27553	payment	1397	1397	1678	1	1	11472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZids6LYVc5kvhhsBYWa7QDhWPNhCHEATDLyuU67juXX2p4xGfq
27554	payment	1397	1397	1678	1	1	11473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6d6NJWUVCYkHJ7yfqLarEteVcarA6gLAhrKAgu1SqzWoyZFK
27555	payment	2132	2132	1874	1	1	679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmYcrEZWwBcmhNcFe7qnPYsve45Ci6qBk6Pz47i5q7toLtCpJW
27556	payment	2134	2134	1874	1	1	2325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzyufRCAHHh7Loj7fMsDtTsCfTJYnex5NjnvY3DmWyd9NqxmB
27557	payment	2134	2134	1874	1	1	2326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPUTXM4o7sayq7B7bjc8PEm8qVymZWbeXybhKd7b4W3MeHEfS
27558	payment	2133	2133	1874	1	1	1903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dqg9m2Am1Lm4bm3S6yURaehpUh3PXTJJUj3eA4mNhdM5Yyns
27559	payment	2133	2133	1874	1	1	1904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6GHZdeK47DrnXTmqYHAJtn4SUK8aQuKTpihC1gRUXot7b6fy
27560	payment	1397	1397	1678	1	1	11474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxBo5hBVqK8SAUrx6KS3rda9EqrFJ7o3xqMocjXU34arRDe2R
27561	payment	2134	2134	1874	1	1	2327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5Lv4pVo3URsi3bvmxh9i6BXvfnoHQzJrxpVkHkgkFenEcsHA
27562	payment	2133	2133	1874	1	1	1905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcieYydBhYY7DL2k8GrbApV3amVJ1Et4uGewe8uZPficLwGk5
27648	payment	1397	1397	1678	1	1	11501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXy98MBwzNwpTG4rNceVFzU4iDtu4JpJo9VZhgFQmz5q1W4zwa
27649	payment	2133	2133	1874	1	1	1932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd33ELTpeNRY7Ny56UYBU4YGAaLNH1YtsCcKCGCXDNM5ybsBLu
27514	payment	2132	2132	1874	1	1	675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8myAx7wXAy6Vk2j8KEXBTFnKqzaMRxtrN21RXw4j8F8PTeko
27515	payment	2133	2133	1874	1	1	1889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVusrnaECyDHpMSGgJ3soMGCzcwmdtDML935JdUbgogHRQSd4
27516	payment	2133	2133	1874	1	1	1890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzXDvssfmLxiZTDP7NsUcBUTzbmdi4azA3Tj54bye5QVjFijA
27517	payment	2133	2133	1874	1	1	1891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzHtTMJk3xp8vSte6rLkxAbCHgAT7CLkikYc4WXUgU7X6Mq4b
27523	payment	1397	1397	1678	1	1	11463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBYUcQnpfT1Tc6W3dVkHV5VYvKVevgHzSSNqADnbFGQ7jbUn7
27524	payment	2132	2132	1874	1	1	676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWU34kmyS4xZx1JTu3UKDHXoaFe14gHsd42fTRbbJAERSPt2GN
27525	payment	2133	2133	1874	1	1	1894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJC7K98BaWD41Fzvm7RpjVnbUhUTt1Pe34E3sjnTQo21SFWbE
27526	payment	2134	2134	1874	1	1	2316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzD7YdWBjd8kYxKWGoUeAEk5SVNgkrzef6MZW1aP78CanzgYKT
27536	payment	1397	1397	1678	1	1	11467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjjTEKqF9VDTrxhAcFfjp28qVQqGkfN33NPZarWCcSX5D9eED
27537	payment	2134	2134	1874	1	1	2320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eecr6z8Vrde3grUucpD5Jwm2hiC5rHm1PMbJZsRZMGkjVaTX
27538	payment	2132	2132	1874	1	1	677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVqvVq8sGre1YZjPdeiAxr4ek2MZ5415aRCZc6e5ihGAufDrD
27539	payment	2133	2133	1874	1	1	1898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1Jxa59tzbhkwahmzQrnV8wxMYX2eYCWRsqcoTjWXdNqJwLuL
27566	payment	1397	1397	1678	1	1	11476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXCHRA61DC44qNEnGhn6dfgQMiAjHcZgZRp4H4LktPt4g7d92
27567	payment	2134	2134	1874	1	1	2329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjopWJdbkLt6PGad9JsZQRFPCQ76vmBrjuXSAPVEPq7MUy2dK
27568	payment	2133	2133	1874	1	1	1907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3GUrJF7v5yYjNUC7c3mAXiE4mUFkA3mayMz7HbdmbK7e1WVd
27586	payment	1397	1397	1678	1	1	11482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL77i9VMyibPF7kjJkPUxq9oePWeFnJQa4rDD2DP9obZHSsT7
27587	payment	1397	1397	1678	1	1	11483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDp66W4Xd6Jq3RNxt18CKjMYQLJvD5AmdjCJSyp4SFkRwFMpK
27588	payment	2134	2134	1874	1	1	2335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdPj4znPSw8RduN3j5emQvRow82r4Jv96ZhkFBBdANaHZEqY5n
27589	payment	2132	2132	1874	1	1	682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9gxaYxPmchb8DX5br8LpwGvFEqdCGedrikQJTUiEh1A9kHPK
27590	payment	2134	2134	1874	1	1	2336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSEb1yaRyQ28rkCkKQjBNyoRZ4Qh6jLtjuPtif2UB87nFFeYH
27591	payment	2133	2133	1874	1	1	1913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qwCJMet7nQxWPQ4boZ6wPH24M2bvQEhNQZobwM9emBK7sRSA
27592	payment	2133	2133	1874	1	1	1914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkqKcXzW3AHYRTu3qCxxLVDPu8Q5zaUdDiZcRqiiti3Gi2uUd
27641	payment	1397	1397	1678	1	1	11499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrUDnPHwMTcV8r6CZLmZUA5tmRsdwmPp4kmwytZkYuUxDYQgQ
27642	payment	1397	1397	1678	1	1	11500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7GfH5AwvB2T5oY4v2NmoT29TmqexL9Wgdx2q2eQ59D5UoJE9
27643	payment	2132	2132	1874	1	1	687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo21mkoKpoqmKjvtddUrCL5BfteYcSzMQG9rK3fcAoNhLB8dJs
27644	payment	2134	2134	1874	1	1	2351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21j1X3D8i87j4efqYcKW5YEfYU86KptYtbD1o9t6HhAwzyM9H
27645	payment	2133	2133	1874	1	1	1930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXjWSTBmR9N6uBivxkWY8iKUFMTmceRpKhDLmsah3qSqK1psc
27646	payment	2133	2133	1874	1	1	1931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfudCm1ECZZG3aUSgNmi6pN6hppuAvHBZMBB3sjzgfbZxfF4QD
27647	payment	2134	2134	1874	1	1	2352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMiBtujnr16Wq6AaDyj6fr6zfVPAnwMHPv1zC1a2HXVSQg1DF
27654	payment	1397	1397	1678	1	1	11503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXEmErtZeeapL3emmyv98LE48obnWrpE9X7834MNu6gfJcEcb
27655	payment	1397	1397	1678	1	1	11504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWadwvrsLp7yS83hEP85Wbu8QfZUT3LSYEEe43Z8pQpagBrZo
27656	payment	2134	2134	1874	1	1	2355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhVV8NhQ5gxqxydhuDBuz8xqhHvwAv9a66dDyMaDBbytAP42F
27657	payment	2134	2134	1874	1	1	2356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnt43K46jJpUuekfbwYFForJ8YJine76iQrxEK3JvztvdvQsK6
27658	payment	2133	2133	1874	1	1	1934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7U4R5zS2tt4MjzUrgbQKFBZWUysERRMkuQj32ESNXdczbPGL
27659	payment	2133	2133	1874	1	1	1935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPQNdN6xUb2L4ityjpa9wZda2Tgz1hj7qSy3sFudHVDnDiAcj
27660	payment	2132	2132	1874	1	1	688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwoUSQ2n7jAjxsy7vYmKeKjKy26YZJfa6yoayru2cnm8QAP3z
27671	payment	1397	1397	1678	1	1	11508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fZEggnQQ89keyenbeioF8Rg4AHkZhctCxFPn3CYuF1dR5Qzt
27672	payment	2134	2134	1874	1	1	2360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCvTP5adE2TR4hgUiVub3aoSssn7n9WEL2nASkn44R7PXUvH6
27528	payment	2134	2134	1874	1	1	2317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Dyu6nWQGpNFbGBNhip1nTaxy7utBwaWBFy7BdtSQzh6cL1i
27529	payment	2133	2133	1874	1	1	1895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kQafjR1Ld5z6HUXSH5WA838u6ypwtBuwNsF55Nvtjah88hGL
27550	payment	1397	1397	1678	1	1	11471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJwTQ62dNuKuiFrnvDjGeYxynV3zxiPZM9pKW1h9qfS7rVf87
27551	payment	2133	2133	1874	1	1	1902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zRmfPJXV5Cdd18bdr6oSD3YBw8FTmbKrXLQb23s12dDBCrGG
27552	payment	2134	2134	1874	1	1	2324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Gd4JYPQgdXxQKpVyCtxrH8ZxhVUAuCJrWqg8aUbtTLFsBhiJ
27563	payment	1397	1397	1678	1	1	11475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRMENKZ215asK5syNbT7MHNDQrsimEKy9kBcd134PCY5EFwPF
27564	payment	2133	2133	1874	1	1	1906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfN6wtseeHUMYa6tmezUGfMtuo12zsEsEhz3z4goXJDnzwCcN5
27565	payment	2134	2134	1874	1	1	2328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pmWSQ5kMeKXnBg8HkWWKyuKGrAT2ZCh8VL2Hxy7SPnKFajrE
27576	payment	1397	1397	1678	1	1	11479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQT2RSo6TQ1C4LvtWpcYbAD9Hfgce7cBe8vCvstbkRVXyh6ic
27577	payment	2134	2134	1874	1	1	2332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxtLhoLnzMwP3mk472NvRep2dcREje8UL1NtgMc6dqTDvWvFW
27578	payment	2133	2133	1874	1	1	1910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAavf8P5EPguDmsfwArwbzqTs8SETMZaoRx6NS7BRWDX8xWeXe
27611	payment	1397	1397	1678	1	1	11490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ117bhmCDSp1ioBb9ZTvxd8ED1AprvRAe9rZxTSyygcCjipga2
27612	payment	1397	1397	1678	1	1	11491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnyaK9XzjiFZ1ejjYgdKgg7zpFrUuAc4rtYZh3UJ9MWFKHXKrj
27613	payment	2134	2134	1874	1	1	2342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8McmeJYgdHqwsgdE1zqTywT4ppphrAu8JSNRA1tTyMCZFPd5
27614	payment	2134	2134	1874	1	1	2343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEA3XuHdqznyggntYKvS1C645tZyyG9PHtdMx4vVEKatn2GWer
27615	payment	2133	2133	1874	1	1	1921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZjG3Bttq3EP2t1Z9peD6iYJaknRkdvZvggm3yWUWHQR9PaDh
27616	payment	2133	2133	1874	1	1	1922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6aBLdJHcJvt5vggKB23UW9NcTZ4uFYjj6BwMHABGYP4DHremJ
27617	payment	2132	2132	1874	1	1	684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVfNQjzkRn1RigqWDgzdgWxTTr9njZsnTqChGMzQReqyu5FDG
27618	payment	1397	1397	1678	1	1	11492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gfbsJzn5jGmXQUH14AcuWimCK7jK4GP5u5KFR3BymqGu7i7d
27619	payment	2134	2134	1874	1	1	2344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYniRQsx6zJPMJskXUtWMWoUKGgLYvJRRiZaZc4GoWeKUTf3ujj
27620	payment	2133	2133	1874	1	1	1923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MAvirmxztVUjqsb8LDMgjr4CyDwWM3Hw86wYAR6bWAM2TZcz
27664	payment	1397	1397	1678	1	1	11506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQnGukT86QrMrwdohL19YPuYQAxn3a47ygZRSnz6EDQfgH9cB
27665	payment	1397	1397	1678	1	1	11507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oZZ3fQDxxuZXBiTgCpJepJokZBZEjwwMzfR6un1VJSzJEJvo
27666	payment	2132	2132	1874	1	1	689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJDjkn45pdqecePtmUmczejtgsG9i1QHHWeZJcWwyt8bMvqV5
27667	payment	2133	2133	1874	1	1	1937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sgCYgkqxaqwCuAZX4JravETU545NtPvvTEeZFBKXj5cka7KR
27668	payment	2134	2134	1874	1	1	2358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmBYYFpjtxPm4Taw3nrTs6cQU1nByUo9A3WcY2oCq8uT8pjch
27669	payment	2133	2133	1874	1	1	1938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkvrCHD6mFFcU6qKkU9bfpcymvZFgAahePURwcvjbcdBUtg8J
27670	payment	2134	2134	1874	1	1	2359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCn2bcC3vCpRB2zPMAnegMLKUFBT4J4YrNqiXf8AqVtychyNzq
27694	payment	1397	1397	1678	1	1	11515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLKLusEDT3QnQhLT6fppJTrmvaBnFTT2Yr7dQ12SmhQ79fKiE
27695	payment	2133	2133	1874	1	1	1946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8rTRVKNiYr2L15qYBf5x98NLuwX8HPvWgvWrGcS8a8YJN6Ua
27696	payment	2134	2134	1874	1	1	2367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuKXAxwsZbgH5snhbeTzL5vewuDSAiLQd4jpj7Gy21KPcgtDk
27706	payment	1397	1397	1678	1	1	11519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszf5FPmysmLR517Gz68hYBdiwEahJKVWppDUXHBR57gXU2ziA
27707	payment	2133	2133	1874	1	1	1950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTv41m1RaHMACWt9caHqw8SGakK8yrLfgyo4RX3XND7D99D2Bp
27708	payment	2134	2134	1874	1	1	2371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6tLqoxM6gADZr6g8gGcchjWamriW3NWUzuyPu1vzYtJg8doAp
27582	payment	2133	2133	1874	1	1	1911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3nJmPDpBb82C7AGcwwDDc31yAhcEaECcPnwTF4K7zQJHHRbE
27583	payment	2134	2134	1874	1	1	2334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHDRnNa77cQu3XKjqh84YMLJAvfuwKhSzCaj28bENhruQQn5G
27584	payment	2133	2133	1874	1	1	1912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiaLjpCqsr77cqxyQJphUsW9NtRFw5UJU9yeyiGYFXcFxvhRob
27585	payment	2132	2132	1874	1	1	681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCP2FH1zEeRra5uDdASJ4n7sBnA95KHndhEg6yiMVVBoiXU8F8
27593	payment	1397	1397	1678	1	1	11484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTov59BXYNdjKDzoUATjNhDq5mLjMqTbniXWDmqNLUUiDCVTze
27594	payment	1397	1397	1678	1	1	11485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzK9gLDwsa3sL5Ef8kkCqYdwS8uwpPjFBGArHBdgmrgYdha4A
27595	payment	1397	1397	1678	1	1	11486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXAwc8vZD7cSduaCAssERjewFUnYCxS5nLeir5sbBFTM2uiCp
27596	payment	2133	2133	1874	1	1	1915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU86qAXM27F1DHJeHa6thvA2D5Q2EYEAGSBu96qz5wwQ7x4JHK
27597	payment	2134	2134	1874	1	1	2337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVB9EptUn4Yr2taMn7HE88w4Gv9xHQqKWyS5G17WZ5yEx8TpLP
27598	payment	2134	2134	1874	1	1	2338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmtxo4DRU6FCSBqsVqE989vm4boKe2po5MHgerCqfPdqxHHhe
27599	payment	2134	2134	1874	1	1	2339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdYVXn9MBiAH8yziiYMD6kscqDZzs4ibAKvdN3YxRAjMpnvwP
27600	payment	2133	2133	1874	1	1	1916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8fyQETTejX25ndhLFv799d2BSoqsPRhHscbNg2hAEPdX9drP
27601	payment	2133	2133	1874	1	1	1917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3JnmjkMFvtPNFL1NCrmfzvNJfhQWP8zCtt6p3Se2E3Bj1Y9a6
27602	payment	1397	1397	1678	1	1	11487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTsVb9N2iuNW73YH2qu8w7cNi2mBPBtewTDAvaG6LrJFdkPa3
27603	payment	1397	1397	1678	1	1	11488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkvjDKnYQBJn2hmjNz5MBHtWvDeExxFEAJpyC1tE6ehChpVqM
27604	payment	1397	1397	1678	1	1	11489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHCk55EcAsXfvcNVcdsqGSvvjsPa5Bovs6ZKmQ94sFFa3kApg
27605	payment	2133	2133	1874	1	1	1918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHrABUVy6yDNPHy6kKXp6FJTjReiVJ18r8bkh6HvnxtVp1HVK
27606	payment	2133	2133	1874	1	1	1919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzsdAAQAbrMXHGetgFZszhHgFuWtkqHLMpwuWc4GkQYcDAPTpJ
27607	payment	2134	2134	1874	1	1	2340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxLSVBH3f22fVWWiwrzKUDa7qLfNLWRV94yAuqNcv8tGgmarJ
27608	payment	2134	2134	1874	1	1	2341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMcVsAHbLsCvcuTKWoeVXv7SJXpw9ME7XJyF9hHbtf2HgCSGSx
27609	payment	2132	2132	1874	1	1	683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FVhGJY2eX9ScNwaVRWkxVUN1jyiZ1ZpxmZxjz7nLuzQSQhpH
27610	payment	2133	2133	1874	1	1	1920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa85TGjP5bJunk2sBHZ7tf82Ng9Vurf31CWKBbn952ZGLLWzP9V
27621	payment	1397	1397	1678	1	1	11493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE5NfVXQUS4bWdFJYanvPjk1FhTZb21MZoaibQqkYDBFZk5m9
27622	payment	1397	1397	1678	1	1	11494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXefK2xMYUGVSQF3PCZDz15rAZiTHXmDJYa9BdqqdRaWiJZ3gN
27623	payment	2133	2133	1874	1	1	1924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQxex951FpoTrxXM23F69AMPxzS6VermCkPbxMBQZPW1bod1gb
27624	payment	2133	2133	1874	1	1	1925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqb55c4LgpuU8ddYwq2wFj8LqmAR6GaUTqjTJwFLGm1kupLTTE
27625	payment	2134	2134	1874	1	1	2345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2HbPRgNzkxbF76rvKm4VPXeDjQBT2eLC3y3XCqQVyoK5G74Ft
27626	payment	2134	2134	1874	1	1	2346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KnyJk53r1pJivVHZfSASghtrSrPAnXh9zb8P16n5FCv6uDBY
27627	payment	2132	2132	1874	1	1	685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhX3ZXjjYAbmx6VLE6wmYam9axEpVqA6WkApy5oUFCo9j44p9
27628	payment	1397	1397	1678	1	1	11495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzF1iCbe4E4kMJcpuoJq8xV3W8BnReXfVp71ZwamoiyG3mLonT
27629	payment	1397	1397	1678	1	1	11496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXt1ovfVKGWM8ncwMWUeYuGr7wGoKNTzY96WQCBPmxEfKdiqV
27630	payment	1397	1397	1678	1	1	11497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXseysJcYZ4EHD6BHWtZcR2dZo5wbQTZ3ykiQvQ7sBdTSEUv5B
27631	payment	1397	1397	1678	1	1	11498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwttiRnS7E7cG5dUdCjNypJwGdSEm4aZn9b4hjz5qhzNgPWio8
27632	payment	2132	2132	1874	1	1	686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxxfPptEz6xxaYuFLCeDGv2aGNkSETsUy4WYiaAeHEuzcnPt2
27633	payment	2133	2133	1874	1	1	1926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1wGuXQQccnxdVzXpKWJKjQHJFnCViQfGaGMG7BMA5bCSgE8F
27634	payment	2133	2133	1874	1	1	1927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrcSUiYt8vTTQ2c8yH5CNCCUAyo2ZfK8eb41STKFj3dqWzVgaC
27635	payment	2133	2133	1874	1	1	1928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5oMzNP4JYfRaqAar7i49aEZD15Xmjhnbx6oNmSNgoDgKupHch
27636	payment	2133	2133	1874	1	1	1929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5T437X7wRqUnt8TM4VABPyX7rY7hkPA8xBGGMVLce2QGyPYW
27637	payment	2134	2134	1874	1	1	2347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hyb3BjundapUXDs1ZmvhjFHkeh4pFn7SCKF73Hmbquctb5ZZ
27638	payment	2134	2134	1874	1	1	2348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMA6npHg4eZ91HAu8RQPfg1mFng93eNGteKSgTpPmMwFQgP2Ax
27639	payment	2134	2134	1874	1	1	2349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdfJSXSDTNWe75nSihh8JjRfU9h2pCtZfeE5LeGmNgCv2EcnW
27640	payment	2134	2134	1874	1	1	2350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UUK5PbgtB846VhsMkhEwWFMCRBViAa73Btew8Rew71iJgNXu
27651	payment	1397	1397	1678	1	1	11502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkwSSgEKt5iM3SiK6QLf6jDAVu6tTRf8kC3TvSNFkkCtXb4RX
27652	payment	2134	2134	1874	1	1	2354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSPv7WCiEV3qQTVYFkVURvoybXQZHr4UVkUKTP4C9badg1xXk
27653	payment	2133	2133	1874	1	1	1933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU35gGwMznVkX1ggztHSvaKt8Zp49kEnguscLzYu6zBmz4jeXM
27700	payment	1397	1397	1678	1	1	11517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wES5Zu7A35sJrCvuDSFFEM8uvQ5fFaDR6v3nS8Tm8K5Gr535
27701	payment	1397	1397	1678	1	1	11518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwuFuzaTFJni57pS1tVrsEDy9pZzcAX1MebMoYNDkJ4hcU6fwZ
27702	payment	2133	2133	1874	1	1	1948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCBgv1E5TnX5iKKXRTa1AmiWXuQjvU2JspSERw9ws9RPDkzxA
27703	payment	2134	2134	1874	1	1	2369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxyBmEokPMq1sjFX9nwJnByuUm5JhPEvhvaQjGn6UknkGRsh8
27704	payment	2133	2133	1874	1	1	1949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2TcsAZn65LThyp78y7yLQLJUBubDQ1rPLgZFEodoFLECxVCE
27705	payment	2134	2134	1874	1	1	2370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvXP1hisFnL7H8ZZgHGMcwKCwvJLL4EjS6qv7sc5aRs8L1kvJ
27712	payment	1397	1397	1678	1	1	11521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JkvNqDUMNziPrhKr5oZzyo7Fnz6JmLNpC1QoDQA4WKaJG4y8
27713	payment	1397	1397	1678	1	1	11522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgNyxoLtxGWyyt6cyLJhejaVVhFgSCmFamqUXJpp1QWhUFVoJ
27714	payment	2133	2133	1874	1	1	1952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7w4wHMDTvbdJLob2BJMiaDgvd9wpH3uJYwN3f9EMvxzUSUfK
27715	delegation	1769	1769	44	1	1	53	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQp1nHuS3SD3ycpqhkD55g9hVJrU87n7ggunu29zEpY36FrHaP
27716	payment	2133	2133	1874	1	1	1953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyigp2ZSY1XqG3BJxg57hz3GsRzi7TDCmnkFyDmSdWNzyBg3Bj
27717	payment	2134	2134	1874	1	1	2373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Mfm3bhehi1Rw1m6kjvzDxh9H68yYTEGVkAR7ZhpkB4mfd9sE
27718	payment	2134	2134	1874	1	1	2374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8vbwADMnYp4joDLzVvKnsqGyasD4rH9ki33VydM69TGuToVFA
27650	payment	2134	2134	1874	1	1	2353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBsxgSxkcaN6Bn37qAhpseWEH2p7YjE3kgf9ngFw93832faQwK
27661	payment	1397	1397	1678	1	1	11505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsA5xRwCAxUr9bGjejNXVb4ou5BVVMnPd6eS15fjhMV8CR92Vc
27662	payment	2133	2133	1874	1	1	1936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtnk4rercSSD54i4315jdahiX1kojP8ty6J6hYmMW7g3YCLnN
27663	payment	2134	2134	1874	1	1	2357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgpCJSsnqdCKxdKgBdzqXhPEVA7pxwrqt8zhv2jrvxW1Y38Yv
27674	payment	1397	1397	1678	1	1	11509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1RY8egysyhdzKxTSZazkMHfXF16Ykyxa1ETjgLovN6CZswgc
27675	payment	1397	1397	1678	1	1	11510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXGewPEMR2e7iKQizHXXL3zjZkqFdFLRejtJKT46rWwFfvFmP
27676	payment	2132	2132	1874	1	1	690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASgRgMPxUiL38B4tMLXvFPbSftB6NKTP8oUwHcNrf3baB8YG9
27677	payment	2134	2134	1874	1	1	2361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYN2Nd1rqsEvxKjASGfyFS6tN6cvwDJo5wEwxREN9X5QD7K42
27678	payment	2134	2134	1874	1	1	2362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53dwGimvKXdoKApUYEnMtPcsiuHaCrDMLugHEohKzKedSfSF5
27679	payment	2133	2133	1874	1	1	1940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPdWuvYCf1y2j1ZdJFNmkqQwGc4WLx727z9XWDGNvfed7LCJM
27680	payment	2133	2133	1874	1	1	1941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDDcs6xXyzEqopo1a2afJgbN3RAiguEtnudb8s2GokzGKDXNf
27687	payment	1397	1397	1678	1	1	11513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsxxBipJaHTFmybhUMh3g6b3ayGzyePTmd7noYrubizmkuDsp
27688	payment	1397	1397	1678	1	1	11514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNjvYPjkbWUG7rPhsCJypcdGfqnxHe4iPJMJ4Y9opzNWEjcsX
27689	payment	2132	2132	1874	1	1	691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgq7i2BRcRxT7iKG4tFXrB3Sw44ZcHC5vC5cxnbjuP1uXWbLHw
27690	payment	2134	2134	1874	1	1	2365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77zvYrbk895Z1Phj3kAdZT8BpLdhaFhznsR8ZWEPdYvBPQVCT
27691	payment	2133	2133	1874	1	1	1944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7T2kZvhU8MatW8FntdHSGAVDS5vCku5nBzDBWoMTAUtXYXByA
27692	payment	2133	2133	1874	1	1	1945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpVjwPzsMiZdCbGmzv4oPqniJXGKpevzdffDr2tiuKXq9HfrS
27693	payment	2134	2134	1874	1	1	2366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLS5Kjz1guUPn9CcPiVLDFQp3PBvfB9uMXrSSykZYuckVvsNY
27673	payment	2133	2133	1874	1	1	1939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8JKZB7b8uZLPBGKx2fLzJKWjeoXn5eQnebLYYHHVZULDpg36
27681	payment	1397	1397	1678	1	1	11511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShS4mogGtYvx4VCrLd2fBZ2uHKeQRa4mvAYRAVE1mYbwF2MeR
27682	payment	1397	1397	1678	1	1	11512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJwihcEKMpMBUo8buT6sM2PLkKFpUFGThVgVidCgqi9G4RjaL
27683	payment	2134	2134	1874	1	1	2363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbisPmKL8KEL5W6Nd5QQMHSUdzXy39yQjvqVBj9jzf3cNZef3
27684	payment	2134	2134	1874	1	1	2364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fok78progVrgDKfVLTBCaZSovZBrHgz7g826PmNy8cjKhjPV
27685	payment	2133	2133	1874	1	1	1942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZsXLYLPd8huWSaeqWeYMENnQ1eMiLvHhXMNaRxyA9uztFSYh5
27686	payment	2133	2133	1874	1	1	1943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhahqiUBLNak94kz2iMma6oygX2pX4J2tjNzMbmgp9zMsPFop
27697	payment	1397	1397	1678	1	1	11516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEkQttUtxfBdDcmZRRUQJUqJ6NPK3WymgwHMQBkewJPMgHmZ7
27698	payment	2133	2133	1874	1	1	1947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDVJM3vyM6oRmCxEfXsy4jsjfwowfojRwHSzZEisEJ9dJu43K
27699	payment	2134	2134	1874	1	1	2368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBq2Qhyptm4vQEUEuefKFtLZptgeScdoKnEYnMz9fjQMNtGCu6
27709	payment	1397	1397	1678	1	1	11520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFg6ab9m2dUKEL5GHVnJv5LobytzzBbJPcGjg21BbT76HGiEJt
27710	payment	2134	2134	1874	1	1	2372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwDDaFeAs8ePy9znNY696Hqtp7VxzvTuetEQmeDkGMPaUxiMX
27711	payment	2133	2133	1874	1	1	1951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxT6aqsVkkuDPp64KvUtJBBk8WMBpaPizLTmCt21Bh3bAAwLN
27719	payment	1397	1397	1678	1	1	11523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjU7dPLMDuQyMd1Q9UBDV4BDqVrZtDfPMSPR5RdrM4bAcRD6k
27720	payment	2134	2134	1874	1	1	2375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfidWES974ZLXTeZmgkjdrW9EH5MA3nn2bU1UwGqNDtwoyBJkL
27721	payment	2133	2133	1874	1	1	1954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfD64Cjc5qmhDzgE9zLRJ4mWDPhggno338cSbUiEUWMRSmXNim
27722	payment	1397	1397	1678	1	1	11524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu641Nx6R9ELDvQJZiizUMXm5KVwBNiTg5XWXNDVEdwF7SjYSb
27723	payment	2134	2134	1874	1	1	2376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQWVkwndYGGUkacnEsib5RX8VQfUeL2edv6RF2uQ95G2dkNCX
27724	payment	2133	2133	1874	1	1	1955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rh6CTRqtaytwCWRT4q16qAvTvYy9XLFApAdWBkaUYTTyANby
27725	payment	1397	1397	1678	1	1	11525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29KMWzrT2VfWrtTssJHxntbDQQE6aCvGgevBneHybhiuiyGKR
27726	payment	2133	2133	1874	1	1	1956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBXS38x6fg6fBG9vYLyoezRqme2SDRepzoFQZ85ZKTsvjLouK
27727	payment	2134	2134	1874	1	1	2377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvMKopF9zWuQcUSmXyP5trvBoctoP789DAJebZCQXTv9SVDND
27728	payment	1693	1693	399	1	1	875	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZDsSdZgXsyvwwSS59KdZRy9hmv1ohvF18Ne3a9HtkEx1K6v7VK
27729	payment	1693	1693	499	1	1	876	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYVzYztiSwumzXXwFZkiPBS6bCcjudLdEy5dfS5yYkATCVh2YSm
27730	payment	1693	1693	1772	1	1	877	267054264228	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZF5AA9aWRiyzfu5RgZUPdVxH9xqRaLkAtakBzqwCahCjPwpA1x
27731	payment	1397	1397	1678	1	1	11526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4pQa3hcFn26aFthqUSUbsAr9Huipu8Wx1MyCopCxyiZy2V6rt
27732	payment	2133	2133	1874	1	1	1957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRtbKpwaQXeLXfvSSgozaEdCqtjvtqV3CL5JdJjUcUkqm6aH6
27733	payment	1693	1693	54	1	1	878	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZFJCQaCsapdDwYqTnKa8Ltw34Uhu2yB7ExDBCKPgqqd6gZAJ41
27734	payment	1693	1693	710	1	1	879	2828327488	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa3uWWgdNpMQNUGqKwXi3NCAkw4kxC5XY6W5FUUk3jQWxqE3jFc
27735	payment	1693	1693	1811	1	1	880	102149572657	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaFPcvkQVz2b1tC2rVEJJHRK3LWhWHDjt1z1UULixL9JYzccukL
27736	payment	1693	1693	217	1	1	881	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZGWpkwCQBTEb1YWgt8eyCk4Tw7UtVbUn4HiGMoxcFKp5cngdpW
27737	payment	1693	1693	103	1	1	882	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZfpxT3mFmJw46RKf5EAdtYtGugxFpYy3saSqep71GwV7MC6Bjk
27738	payment	2133	2133	1874	1	1	1958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhS5KbCuT9ENugP7T5ARGZhCob1sgM2BXdx8oBPKnYeFjqEuA
27739	payment	2134	2134	1874	1	1	2378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hwvMhCt9Gq6oFhpAEwmK68xzBonpS8FZfdBVZEyDoAfbPSHX
27740	payment	1693	1693	35	1	1	883	10860777564	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZhnEAfEqQPyLf2kkhRgFg5AjJ9J39ecPs2GhnCMy1qfym5xvJR
27741	payment	1397	1397	1678	1	1	11527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnjgbTgWhHeVBiqhgCWnfu9a9Y2KWaiss3YW7NkuHuERpY9jB
27742	payment	1397	1397	1678	1	1	11528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15jrRP5U17HQUaXi9JEAWv5aiqWQenN9LfNYDWY4fKXjpdsCb
27743	payment	1693	1693	49	1	1	884	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaE5A1gKyPGQ6PUymLV3ZkpQtv4fSbFPB1FsYiaxsZ6MWQoXa4u
27744	payment	1693	1693	251	1	1	885	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa4L37rPtnmXRCm2QQaNKnc5Ack3i1KeUunc7a7ra61pNAbbDYt
27745	payment	1693	1693	893	1	1	886	173559138004	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZqSXBwZiCtu88n9UJp2phTLToCrsEpTRiUm299jCCS2UvAvh5u
27746	payment	1693	1693	320	1	1	887	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZL7SvmDTDcjGjDDVUNG9TrHSW97wfMoGzr4xmQMm2HpADEKnsZ
27747	payment	1693	1693	1030	1	1	888	509630166225	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZk9tdqoQJfNf5EkmJBnF5ZZ37bFiQeAHzyZ81bbLAwVg95egez
27748	payment	2134	2134	1874	1	1	2379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxaoMGcv7fCSxA5EFZQW64DQfG4HF5xy96w1Fvsf7x3TzKBD7
27749	payment	2133	2133	1874	1	1	1959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJfevXFBzp5xZdddV2RfAu2dGH4Yz438xfi3r11q6dJEJvR7g
27758	payment	1397	1397	1678	1	1	11529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkQCCvXoc2RPdgkS5486HGhoKu8YneD7xMjF2e9GWGtQpPQK6
27759	payment	1397	1397	1678	1	1	11530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTx9Pf2WDAHn2kVrvAGN5MrF5LsSGcyVhYERQcLbE7Y42rLzik
27760	payment	1693	1693	570	1	1	895	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa5kHCVJVoedBhaoJmsZ16z5p374EXyVmoxAmsJi6DbjGpUkWfA
27761	payment	1693	1693	225	1	1	896	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZPfQHGCdRvvkVJaoSbijdiVUXYG9WmHWj8Q6mcGaqsrtt8bgc2
27762	payment	1693	1693	377	1	1	897	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZCeBpjT5AXNbvxJzuQTNdq2mYZHsbUmVNfBLUpWkfh3x8UhJsT
27763	payment	1693	1693	560	1	1	898	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa13taFqGJTohy5ZouDD7pUSramWG4nyebhncgnxzjn4NL3TDmr
27764	payment	1693	1693	252	1	1	899	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa7wWACuT3rZsdyhysHzcCRKtEBGSPD4xBGBTKiEix1Ra6v4N9j
27765	payment	1693	1693	1962	1	1	900	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZdPbnZR5rgbWVNDUPg1SersHHdL5DHmVxSoyHjBDbzqbJjpcwn
27766	payment	1693	1693	201	1	1	901	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa9Czegx5g8Xo6E8cNEdtMCUtq1KzxmH8GX3kJbMFq3HsKBqyjw
27767	payment	1693	1693	402	1	1	902	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa7UghxsdswSfJ9FrC2Lv3LmzeLgZ8QcKw6ZMZb8SxWQ39r2hAP
27768	payment	1693	1693	163	1	1	903	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYWtrMRSXdYfMpuv3APxPoZVfzBoBqkeKnBpoEVypE4YJULE9WY
27769	payment	1693	1693	82	1	1	904	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa9A74GZKmQn7A9rFjyF7jPLE7fVCXqxBoFgs4ato8e3Q8LuWuB
27770	payment	1693	1693	275	1	1	905	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZqZdyzUzgf3hLuCExcR2BrxkqomDY8xPD2UGKumxzs6g2xVsyh
27771	payment	1693	1693	361	1	1	906	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaEYXhniJiDk8XEfieiPzeY9RJZpyy3HuKaE6vSqFTrdjkv5eDV
27772	payment	2134	2134	1874	1	1	2381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkx24DA3qz4aY3fjxvQYXH4PXJhms1xH3ujNWLjxA1nT4vzUvP
27773	payment	2134	2134	1874	1	1	2382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtKt7RvSqVb6aFzy6Rq6en27uicuS3VYMM77WH535bQm7jKL1
27774	payment	2133	2133	1874	1	1	1961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATJYkqcu2621vDPczm94YWGps7mNKYK9A1VsFMw1tKZ3LyTcE
27775	payment	2133	2133	1874	1	1	1962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygUJ1EaiziJ3Aop3AsqUw3PipUfqzS8KYxEFyyaYaVZAty62x
27828	payment	1693	1693	593	1	1	942	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ9ByUbMcC6j1nvsrE1HYKnTGPgUuyzuXXvoZPNoeUX6Bc5dfBJ
27829	payment	1693	1693	91	1	1	943	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYotncVSxPTfgWGauwZASPRqGkHKn9HDo5E2i9nLoKcAXGMxbDX
27830	payment	1397	1397	1678	1	1	11537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYjq4H76jZofwJ6e5YFkCaXUw7GaTVcxD2tKSbCfApSQA1FXSd
27831	payment	1693	1693	438	1	1	944	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaCMP3bEXhj6wQ9HLeRupQ7PP9rfbz19zHM3hBuB4VEbbmPENMm
27832	payment	1693	1693	339	1	1	945	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZVToEvd9qyqTfPfJTLrv5m1F1wpHG5YhVuKGZ7yEMCsuKJqWEd
27833	payment	1693	1693	601	1	1	946	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa8WDG4MMdMmi5ULaqsWirkQPphFjTDYu9NUJVMSomeJaeR2FWh
27834	payment	2134	2134	1874	1	1	2389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUEeMGrVxacMK48PRGVmzRif9fhkkKRbmEggQBajdWk1D51Gp3
27835	payment	2133	2133	1874	1	1	1968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEqgtDDT6KkAw14d6xYKHntEtrsuHy9zQogo2exrmyBfUQoLd
27900	payment	1397	1397	1678	1	1	11549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBabKii5saTz3TSDR9C5gu1F9ncJjnKyk3wCVq3hFPqySoNMB
27901	payment	1693	1693	304	1	1	976	37333922882	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnrSSUncJdNKFgbPMuBwfzu	CkpaKnP8becdqyjtjdke31haUTnbiMBEBVPwfGpYMmzqRTCpeLZ1V
27902	payment	1693	1693	206	1	1	977	37333922882	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtnrSSUncJdNKFgbPMuBwfzu	CkpZMVtULgMeaTatcgGE7NcLs7zwcUdERm8FM44FqFtZaBN4dncYr
27903	payment	2133	2133	1874	1	1	1980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhPqQCRUabhMbKW3MEhqvVxBENy4ZZxQA35CQgVGb9jXgsxpvm
27904	payment	2134	2134	1874	1	1	2401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwcBMiq6McksGmBRNcc2FiC1eExUuGkoKb5G2MtxcsEuqAcP6
27908	payment	1397	1397	1678	1	1	11551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGJCEzcF3G8Zed5VynUVv1iWo3r2ySqyt48wzxshmA2ouaxMA
27750	payment	1693	1693	663	1	1	889	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZkeMCHpkvQFAtR2AJirj9TExnrJDXoyh2tpoFXHeFQ9UiJovK8
27751	payment	1693	1693	390	1	1	890	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZdBhWc2aU3AczZuTNs3QrAcwoywfnWv1MtAbt71ZttdWE9Uiwq
27752	payment	1693	1693	108	1	1	891	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYmxtiZh847Vp3DNjS5zTfdwLz4iTuzQ7nYnzVLvxg1ip1Dx8b5
27753	payment	1693	1693	894	1	1	892	173559138004	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZvKEd5JB4RpQAEULK8BTLnEXEYHPNVXeiFauiFDN4YiJCqsptd
27754	payment	1693	1693	569	1	1	893	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaFSrkfMvr7zL3QbuYnhumvCZve6bFo8Jb8b7bE4F397Zk3wxyg
27755	payment	1693	1693	99	1	1	894	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZTJvX61EV539gKFQtxoKA5ExKGWBnnd8HL2nFTgJMW7HpcwdcX
27756	payment	2134	2134	1874	1	1	2380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xofKuYij3wY5f6J7pnamAxw1QTZpMsUnoQioNd9k8U67Vdvc
27757	payment	2133	2133	1874	1	1	1960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1GXNYo2UrQ3asFim3XomnEJQoU6EYRHt3JNq4cEd8vnDGZ9j
27794	payment	1397	1397	1678	1	1	11533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJKEYdJRMwAinS8SuChwzAbvbyZYP9oPr1DFATddk16z6eLVM
27795	payment	1693	1693	112	1	1	919	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZwDj1KaT6LFduPEvsep8PeUQezB7cXDXaDXg8wraK2BRCQvxjy
27796	payment	1693	1693	534	1	1	920	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZiTkAz8warM5JcjzZxH3s9P2EkJQx8kpGcuMdJommZA2Nt1K6x
27797	payment	1693	1693	245	1	1	921	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZoV3gQLNdrWH4ua2DAvYMDsHVTWpUtAhvXapBr59KtNV4TBvEA
27798	payment	1693	1693	421	1	1	922	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYQLyPjiDDaxZd9Qi72PGV9m3nYiSo14ggpv6jgvsfviauvcatW
27799	payment	1693	1693	620	1	1	923	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYdbNMJnxvk4EPKmuJiMgj2Gx5ujRFpdu4WErU2u5s32VtokQ5x
27800	payment	2133	2133	1874	1	1	1965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YpYq85eCTSLpXaG9i8GdHybN8cfHPXkK8ziCgjx1uQQDeBwf
27801	payment	2134	2134	1874	1	1	2385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNMacc62NQFSHCMjtHSSzEbgrTH9yScN2zHw6GBJKuNSYv8SZ
27820	payment	1397	1397	1678	1	1	11536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpAbsYTaPET7PbLYbG1x1TeP2PZKFEhTYwCRyhpYXGUZad9iq
27821	payment	1693	1693	89	1	1	936	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZp24GQC7DE9pAVEophEpC7MVt1V7827oachfjMrBpKgQ3Tbogj
27822	payment	1693	1693	186	1	1	937	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYg2VQofsd5rus7azisdXPFgUVYPp9jCnHcbhRKyXtTHqSwjp3z
27823	payment	1693	1693	383	1	1	938	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYS9c8gTihyvQKc8ka8JaZAxGzLnakSdVWve4TWmVQMhfBy9B2L
27824	payment	1693	1693	308	1	1	939	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYmJZXZirBNtxy21PGeb5QNshmAaj8VsuvByaSSN6QYGUaPSGZe
27825	payment	1693	1693	408	1	1	940	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZW6NhzovPRJNg7M1Zv5RBbrpFAYTitYoseZGPpxP4Vk4Qv9dUE
27826	payment	1693	1693	678	1	1	941	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYhz4qhqPxC7AfDysLMmrbYvUkxqddnfS3iSkVmDDWC5bEvCFSo
27827	payment	2134	2134	1874	1	1	2388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQdnqQc1xsakiJo3V3iY8uXCZE2ievGXn9ExACnkXDkBgTcZGt
27880	payment	1397	1397	1678	1	1	11543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUz5paxd45jMLTNQrmqGwH8zMqbj6YXhbrbzxe1DYTaWLwY9wB
27881	payment	2133	2133	1874	1	1	1974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqLHJnCg4EG4dvTigA52b9LyrdigxvDUQiB893BTd8VqL5ACW
27882	payment	2134	2134	1874	1	1	2395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfj6jxvVrCdpnewYq1L2PZDj55S5SrRsjDQC2544GtFoEAdmZ2
27886	payment	1693	1693	206	1	1	976	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYotg9kCMqA4ojFBA6HzdYR9CFLZqq4mmfLgiG9DXAzbB6GS7zT
27887	payment	1693	1693	304	1	1	977	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZPWcJSvkSxCDwZxMuAUYkrG3LaMgSNRMVmUT8youDGYgnX7D7n
27888	payment	1397	1397	1678	1	1	11545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkr5vsvHS8aD5V3iyNVwPR3zfTmSEd66fhTwXzVteVt19umra
27889	payment	1397	1397	1678	1	1	11546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAKG2m2vKkp9J9tT2DzGFZo2Dgv1Wih6TLpENcu78BYaEibxs
27890	payment	2133	2133	1874	1	1	1976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjVTdazMaMt9sjS2wc7b9adtfDU4kcnnoWN5ao2pHUdgHKujZ
27891	payment	2134	2134	1874	1	1	2397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYSLsghDxZxGjax6bP39ozScaCp68R12LrmUvu37HDmkdJZke
27892	payment	2134	2134	1874	1	1	2398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQc5eRyQthfQVkmfgrBa7toSdJhYtybbasfumrB9bB8xhKtdHD
27893	payment	2133	2133	1874	1	1	1977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffDW2Nrc5e3aESwmjztsPDEWZ1sxSKwHAGyCa3uqc6oD1eQmE
27910	payment	2134	2134	1874	1	1	2403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUYbMxpG1gXAxJmRhAjGy6XdatzZZJtugUjQXJXmvsF2afdRx
27911	payment	1397	1397	1678	1	1	11552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarSMMaWwk4XTeEqeG8p2VN2n4RD5RqBy6s2rKRYvz7dEuKr3k
27912	payment	1397	1397	1678	1	1	11553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKWC45DxQTkEyq1AxGPw7rBhT35gtc11ti8cBKXxDH819EPf3
27776	payment	1693	1693	309	1	1	907	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZAiidmtodi56eKYqjBjhTA2PhptNfhT9UGfg8hesQ5PuZHt3xh
27777	payment	1693	1693	2073	1	1	908	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZrpLDJvYrbPgqYFW5vBnebwbVGjH3sMVay5avhQKtw4XEpzqQS
27778	payment	1693	1693	452	1	1	909	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZatx43XqYDciz6vF8WMxchqNVLf2V1JotuCNc7GiDaHvQ4JU2j
27779	payment	1693	1693	594	1	1	910	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYV19oq7exGEuRuzuyjkQ5pq7j81Gt9Fk7gDvDWfAa6dyVuoukz
27780	payment	1693	1693	2181	1	1	911	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYbMb7RqZuFp9mEhUXfLuoUAPpdWBAMoMz4wmL3Vsc5tAUpD1Y4
27781	payment	1693	1693	680	1	1	912	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYtTVSkutfVu8fhamKEod6qaDLxrbPa3Bw271qmczdTFZPowUbK
27782	payment	1397	1397	1678	1	1	11531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wgTX9NjbyUBjQNkQ15eLEbaGGM7A74awuAJvbwyc8m5zi2cw
27783	payment	1397	1397	1678	1	1	11532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBU8ySMAb9HiacPK5iiGqwnbQRVYwvKBc28mporTqrzsCBMxpn
27784	payment	1693	1693	391	1	1	913	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaLBftYs9yJ64e2LZ19Z9BqPZ6sQxF6TaTX4dYZDJgz7WTY4TQw
27785	payment	1693	1693	690	1	1	914	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYnnfFYUG5RQLd3U9KtQPMo2DZqNyxLcpcsKKkyLgA32y6XKTe1
27786	payment	1693	1693	353	1	1	915	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ8nuzf2T91QJZgbG1Y8sSH6Js59k2r9ePpqExd9ALDngbgC8Ve
27787	payment	1693	1693	731	1	1	916	1131330992	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZLVaV2U96DfqCCTHqAkHnyHA94f8CyA4mfYzrwsAVriz8Gxnbs
27788	payment	1693	1693	2164	1	1	917	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZn1Q7ZZd4XmmPY6gLTw5V6WuHncwL3icJXoBM7U3KZNkaxCg3R
27789	payment	1693	1693	180	1	1	918	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ1ydaKXhFZbfxWVZnjxxvubbL84pkmLmFtAWfSNakrJ8uS7mQm
27790	payment	2134	2134	1874	1	1	2383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDfox3hWCKFsVPPcCuoptaZZf9J7fTtshS9vZZu2ipqUphCQK
27791	payment	2134	2134	1874	1	1	2384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkTmqw7FC9THFmLfwyG18nz3b8p7dmVwCahdazkXweLDth2F9e
27792	payment	2133	2133	1874	1	1	1963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNFn8wPJHmnXLi9C66WZJPxfsvpYfsLPWWGcoMEd4TyG8JUsZ
27793	payment	2133	2133	1874	1	1	1964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86KX2jCBowP8fjwcnaWnWQHcaZb2CvBaza9oo2nDqTTPCUt7Q
27836	payment	1693	1693	745	1	1	947	1131330992	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYsGBoYjeRBDeepwFgmxvYd4FEKfQzexH9XToM9kc9JHE1nxhrh
27837	payment	1397	1397	1678	1	1	11538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeYxFoRWzYEgmiZ4zGrjRrMCnTgqiudSgZqnrtjXUM7k3RwKC
27838	payment	1693	1693	150	1	1	948	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZy6vb6mkw341WUDzN15CzE5dWAAVgoqCVCX3yrZBw3wCNAgrny
27839	payment	1693	1693	92	1	1	949	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYsyMDonP2ZFtxWDJGCb6f8iHZug3vbdx1fgNRXBF38sxG2BN25
27840	payment	1693	1693	63	1	1	950	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ3JZYo82YTZHH3F2Q5G4EErheXJshpiZSsYnkp2TWerjcFmSXy
27841	payment	1693	1693	450	1	1	951	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZbw4ntertjJZMD9P8rkMFQRapqjdztKdCVa4gkwcEcCPFirSnT
27842	payment	1693	1693	322	1	1	952	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaDrafa9Y1fTF1pFowiijLrG4fawSqSAYBg6ueduaubMhGGmR6r
27843	payment	2134	2134	1874	1	1	2390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde4hnkuW8ssVepHZsHDptcsvZ14Tr1BwHbHWGKQhk7WkFkvs5
27844	payment	2133	2133	1874	1	1	1969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxSpiazCXYDKYJZYqyQ3wgBd9j68vjq6WNTPcFHzybefr3g2q
27862	payment	1693	1693	78	1	1	964	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZjniyMA7Nz6bpt6j9hkcM3x52fK9XCPPLDYjGAsKd5NU3xD9mQ
27863	payment	1693	1693	611	1	1	965	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZDb2UJiDRzHzPwXa2KNp2BnH2qRDYzRpaRV3fv6jpynUkhgwwe
27864	payment	1693	1693	205	1	1	966	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ33ARVai65DgEv82qtaNv6Lseq7v7PHzHtkpGdWGWNyK16LzxN
27865	payment	1693	1693	658	1	1	967	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYs9vXLjSRuHshVNFtkcfgZ8TE82yMQTH9Paz2Q5TskENPcGhvS
27866	payment	1693	1693	194	1	1	968	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZh4Pvm6AGUYPmareBPmZDwzZnM1y13KK1h5TUuhAf3AWD2UkJq
27867	payment	1397	1397	1678	1	1	11541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9rjWw7fGW2ty4Buz3nW922PBhAZVa52AfeHrY2FAfFyQeako
27868	payment	1397	1397	1678	1	1	11542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZUWaSyZBWTe3mqUAPDooMVtB7LuMLWGfc8JJtFj1VY8yxVKug
27869	payment	1693	1693	1276	1	1	969	958189855230	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa2EgXFc8qABXwWH4bqXyrmdbrmrq3ePCBV2dr5tGyCt48GVWpX
27870	payment	1693	1693	660	1	1	970	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZXYGBKVF6r2wpE94hv3rE4r1yejFNJiQWeF62TVkb6DQFCehVA
27871	payment	1693	1693	653	1	1	971	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZTgwucyQ2cf75eYcqawGjrEYViwzpTNy6vTqHh4VXFq4Y5Jv4e
27872	payment	1693	1693	622	1	1	972	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa4UF8isErv8jd6pv4Je5T1C7b6V12nHrUEcjtg1Kp7NqZEyTNA
27802	payment	1693	1693	352	1	1	924	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa44kei1ozL7CMCEPMQXTxnLdSgUvTHziV6PUSR7zbXBT7GT6d4
27803	payment	1693	1693	652	1	1	925	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	Ckpa7PnUeQgBictazavFsrNs4QtyXFzzbCeqv7DTTnrS9pgE1Jjof
27804	payment	1693	1693	191	1	1	926	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZkhfRfNWZvR6XuEZTRT2EegfpnpkFh1L4TJr4CU8rVrMCJBurU
27805	payment	1693	1693	266	1	1	927	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZu7cVQL4CFnbYTFJB6M4r9PBNq3K9csWN9oX4aiZY8Bm5yDt4u
27806	payment	1693	1693	1150	1	1	928	343857628251	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZRobk8TGkpoxoemTfBUjmwnVYHKHCvoapHQQvFZ5CywuWTkHH5
27807	payment	1693	1693	84	1	1	929	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYRoWCxU6uzFN4c4hEchb99DLdjvemniCfMfYt4aTzjDh2nusx8
27808	payment	1397	1397	1678	1	1	11534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHU83yGFs1gj5RrXxFaGcGcLUtrkfo9Uekr1H2H2rytDr3x9q
27809	payment	2133	2133	1874	1	1	1966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcauRweBTHdP8qRbgD62hX2hZzFa1cLjfq7jFDcDE6mqXm2Q6J
27810	payment	2134	2134	1874	1	1	2386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzywm9WNy1EwBpJ61ASMH9iA6c5g8URbebmtu3UVk2ZdHH3ujs
27811	payment	1693	1693	600	1	1	930	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZMWEmqST8BAvrkPy7gdp9bNHqkXT2Y6JoFd41oB6NChbJdp7JQ
27812	payment	1397	1397	1678	1	1	11535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEbJkjwpVQEAPzP16CM7RXhktiKDGVHf3Qn35uEJVYCXqWYmz
27813	payment	1693	1693	691	1	1	931	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZrQum93aAvCQtQf43Dsoa6etASonjQLbSyheend23CAj8K1B4U
27814	payment	1693	1693	2017	1	1	932	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYmW8UJWWFwrRLUqKAXth6bdASNjRTn5CVn39SEh5EXmZQQsQqH
27815	payment	1693	1693	551	1	1	933	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYSSGosr8AXPfgaQnVe31hAbA4odtGUBhavegUEkwxv14hbJ6tk
27816	payment	1693	1693	520	1	1	934	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZnK3tacoTRB16wHSUWvPtwAAgjz1e63fUw768fsreurtfVYgSN
27817	payment	1693	1693	392	1	1	935	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZ6DfPqj9pue5wV686ZMM2UosiKyiT8jWSLqTaKiA4TiZD7C886
27818	payment	2133	2133	1874	1	1	1967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzT6r74ApsLhuqFao75tq4zMfVX2H4z8HgUzsGeDMxL5UYjUw
27819	payment	2134	2134	1874	1	1	2387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7mGmNYx71c28vLeC6GL5cDPcjvEyipnDCNWDQ5j5o3rHYLV5
27845	payment	1693	1693	373	1	1	953	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZMoSMYR7f1yHcTHfZZB2CC1pwcadekzcXiSHPhK8RjeonC3UAw
27846	payment	1397	1397	1678	1	1	11539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8KLsVMUXNqnb57hN8vPniqNbK4wiLnxHz4nxuEv7eLsfJNRbn
27847	payment	1397	1397	1678	1	1	11540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLyF6LDGaTuyJaKXVQUqaFEfWsQnFpwR8umBy1KRCk1ghi39D
27848	payment	1693	1693	453	1	1	954	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaCdBJjm7c2xG9Gg3d2nskwcBa2ScDaq2Mrce3vc3SCE2oZrHtY
27849	payment	1693	1693	29	1	1	955	3959658482	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYnbu5cEB8vwzC5BsfVFTvrZaXCuYrLZy69ViNhtyouM3KWdGLu
27850	payment	1693	1693	138	1	1	956	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYrVDXVHwNwmZFveyU9sraHhiaGch5VSucxVoAZsFWEbw53wv5W
27851	payment	1693	1693	146	1	1	957	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZdP5dhsVzmSBJ45TLjUvYtCy7Sd4Evkb955dzBi6THdpfXjkam
27852	payment	1693	1693	395	1	1	958	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaH7Rs8CP8xjoeY5L3KWtgcCx7GEWuvqrREfCWpS1MkUAHRRaqA
27853	payment	1693	1693	587	1	1	959	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpaECwSRPvvEhFbjHS9w5MWjrVjLHmVrYVzcFpaeG4SqSxo1EV26
27854	payment	1693	1693	910	1	1	960	284393193579	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYR5ngUJ4wN3TLkSiWShFet1PHcvioc87nuE5QuBGoL1JT3vrXu
27855	payment	1693	1693	1961	1	1	961	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZFrrg6QB5RAuE3YftkQULsxgfUuNAXThXSHF3EQvQDX8AoC9Ut
27856	payment	1693	1693	500	1	1	962	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZa3Bcdjxd45qpkXPKzEiTZhkkvc9rt1FsfWEV4zNGQPf75C9gu
27857	payment	1693	1693	504	1	1	963	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYgwJGDrW4d23nM7eWN5M1XhbMzrCyjkuTyLujh6ZpGskFMDGFd
27858	payment	2133	2133	1874	1	1	1970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5UTrmtRrV3pqJnrP1iFZhi9v9rwDAkRjYL1NgPRaA11MgdXh
27859	payment	2133	2133	1874	1	1	1971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFD9FrTHWKfJVGWigz91wWJ8SuF1Ngsgg4kLbXGEv3HxYZ37aY
27860	payment	2134	2134	1874	1	1	2391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJsFuQHndtgVQqS6d1hmvRMnHE4RXgx84VTqFuP9yVRgb23Jq
27861	payment	2134	2134	1874	1	1	2392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtG9FUh5tWSb5CXZ5rgbzLMkXbezCnj87P6cHTMU6AB9tALmU6
27883	payment	1397	1397	1678	1	1	11544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxRsLnHsZ62HZZZ5uhUU19ueaLMWEvsLnHWS4UsAcRjmvNNMK
27884	payment	2134	2134	1874	1	1	2396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUaXDEogxwQ6xCzn7mKeKmSZUJ4FWcFxstSmBjTAH6wi97sR4
27885	payment	2133	2133	1874	1	1	1975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXfAC6fwQc4dz5qDfVqGZkgx38E9SkJAnnDXexqgETVhpaT1N
27873	payment	1693	1693	105	1	1	973	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpZn2FWcReprQR7E6Pi9dGLDMfTdCTZSG7hLANh3JPC8xqkru4uz
27874	payment	1693	1693	122	1	1	974	37333922882	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYWiVUy4NZAFZZGAPhQPxLHovbJD3TkN578YWLJmu5C8PXavL7m
27875	payment	1693	1693	721	1	1	975	1131330992	10000000	\N	E4ZG77bgQv1vadK6kvXaeS5EGEgNb2bPAJ4VQFzbibgWTstcc3f3H	CkpYqQwKZkf9wrzDBkoZ5JhmRdqdL5oPMDAay4RP6DNRWedTbLtrB
27876	payment	2134	2134	1874	1	1	2393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykXFdkmdqXRPjYHQk4EhEZCx1KRWpBHCBx88zH7ickvAWHfqe
27877	payment	2133	2133	1874	1	1	1972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4A2a4SXBRKuq5o1DtwR1tMm5LHdFf1MfKXAs6s8bBJWyhQLGm
27878	payment	2134	2134	1874	1	1	2394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGt7H4eiWP5Tm16Q7jVWgha8GUNW1n1mxBcphJ9x6RJnS4JiTp
27879	payment	2133	2133	1874	1	1	1973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZPM3qGH4nv5ekkSnQsBW3eU7Nw9rG77PKrwvvHshdvvf7SYS
27905	payment	1397	1397	1678	1	1	11550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GjH2pnVy3wYEn54WWEDPj7AaU4XcFyFAFaLvVoARLfdGJjpX
27906	payment	2133	2133	1874	1	1	1981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dxkuvXUGDhxKX12y5nxgJ7L1vxhPyZESnM7YxKhGkzTZKczh
27907	payment	2134	2134	1874	1	1	2402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7B1NDNNpnfXHhoVaeJPE54Q4CzDfCYjaYz4dRTKzE62N6B1Ft
27920	payment	1397	1397	1678	1	1	11555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQNfypyzC3RZCv7k12uWxrXTNCm5eqSjxzySuYhiZzNvAAjfu
27921	payment	2134	2134	1874	1	1	2406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWm3Dn9RXPpdCa5VgNRKdSrJnjoSSZ1qh4RRQiKoBP1H2mN1F
27922	payment	2133	2133	1874	1	1	1986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvvaWVZA1FTNXtj7i1SAbnfUie9XmsqFhRDwCDshkziEHAFew
27941	payment	1397	1397	1678	1	1	11562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3WGYXD4KQvaxxUDLDnmkRJr5vZqVpvqpdxPrc8JNajcQSZ96f
27942	payment	2134	2134	1874	1	1	2413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqaRhYMfbTGx1H4pHoExGitKCz71nMrkh2DtSipJaNsBZUG7M
27944	payment	1397	1397	1678	1	1	11563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXf9VZE7q8aha6EfQM8TWs2pC6Ni7LRYfSb5BDPEJUVQqwvJH
27945	payment	2134	2134	1874	1	1	2414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjJpL3YmbbkbnbeGfhZQou4FeZKpiHrssfEfMiC6V9eEVkZvX
27946	payment	2133	2133	1874	1	1	1994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qWkf8ybQwpuJwYYuCV6LgDA9bLN5ZwvysS4Q87tXP9pWrSQx
27953	payment	1397	1397	1678	1	1	11566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDd6EKjeiSWgG6ZGpiJvHzqCPf5LnWowLY2FPs2qUyhuFVNdHo
27954	payment	2133	2133	1874	1	1	1997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyXmjkFPTEGTiWmrmo5cJZLSiEjrj6RooMB27cmENsUJ7FmJU
27955	payment	2134	2134	1874	1	1	2417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDs5p1UR4uPVLKZToB57oWej4LEw8WMiHqACCbEPZqrmtfUpeF
27989	payment	1397	1397	1678	1	1	11578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDeS4sqdemW4E3gHQKS4Hkrymcfrxmwruu2imJ383XyFKB5ZW
27990	payment	2133	2133	1874	1	1	2009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwwEixsPMFvnSQ8EZU1nYDWTMwqRefuj8RKFkhMyMYo9wp1b2
27991	payment	2134	2134	1874	1	1	2429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcuTBqbCVZy47whbfVkcJPSuiLYWTNU8DxjPoKiasfsbHVJSjV
27992	payment	1397	1397	1678	1	1	11579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRE3gWF8qDDqGiMY1tP98hSx44feMcaTxigT1PCqMoqUkNoJjc
27993	payment	2134	2134	1874	1	1	2430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRt7326PaKn6tjhZpuCQSrhBHWFmNh1rTQAD2Bj4ktjSk6vCF
27994	payment	2133	2133	1874	1	1	2010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzbtNCX8XTNy5kMYkZAGBW5Z4X2eAbbm4AcfXXpNHzK9Eoh73
28001	payment	1397	1397	1678	1	1	11582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJGAxVZZvYdWkmZXzeL3m39JW9ntrFyfNn9kXFogZG566WRfw
28002	payment	2133	2133	1874	1	1	2013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18EYedvMxYDEfNrcnLTKfToRNMR7wqcSRoKd5NvZubHdfRFiw
28003	payment	2134	2134	1874	1	1	2433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8qyqZ8UGQ99evSsAXTMHcM3XX4eLRE8fCGtbYELj2FBrEi1v
28004	payment	1397	1397	1678	1	1	11583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZch47Go1qWHJtRvpfwsDV9tUZ9WTLHog4szpUMGnERVej5rK3N
28005	payment	2133	2133	1874	1	1	2014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HvN5NekXy5x9uPJQ1DvyYfHYhY1cRSP6PhF77GeRska7PPeR
28040	payment	1397	1397	1678	1	1	11592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6j1Je1acm3Jf799rjrTahtW3JoFNYhscdcmb2ZTKoJkSr6FCQ
28041	payment	1397	1397	1678	1	1	11593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNMwsgRgMKKrcVSyo3qoLfzq1CXMiqdEvGqSZN6eLAGz8PBxP
28042	payment	2132	2132	1874	1	1	694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1ZfMsC5SSLkLc7XCV9g23CNMjSKjbT8A2L6S86LYsWZYZAMT
28043	payment	2134	2134	1874	1	1	2443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzULZyELbTPjPnNxSbu6Ex4JqafPGkzE5ixYdoakpAAJWBruTC
28044	payment	2134	2134	1874	1	1	2444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KnhpXCMfeDA3uuVmgnF6r5tiJNLgDuaTt1vqKkMM35xxdAdH
28045	payment	2133	2133	1874	1	1	2024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHZ3yfrgsgCL6bUayom9GtkA51KeMaRUdFAjB52YYNpvgPyLF
27894	payment	1397	1397	1678	1	1	11547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghWrQVDUo6TfNXo9UfuDwLoiEzogKokYJWM6cjRfMeCvGZp2n
27895	payment	1397	1397	1678	1	1	11548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4PLD6FHX2sAfvsN1MpjzS1sGU3atS7LRvmezonLHGgCPLRhW
27896	payment	2133	2133	1874	1	1	1978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YwSiE8VAxetQ9jNgB2qTXVaTiDQ5PcNYU3s1PrntEvQWhTM7
27897	payment	2134	2134	1874	1	1	2399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8qRJmtGmV4A9mH7pFZMvsxkDbUw3T677cph5o8pZXvpcWSV8
27898	payment	2134	2134	1874	1	1	2400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9aAiPeKtowLRJpoXdiUZ9sJ4Qq5brqbse9g35vekd5kx3Dkk
27899	payment	2133	2133	1874	1	1	1979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAXHF7SiQb7kZx7HxuF6B5cgXT4iZsVqWNJTZr49BMZm6ECcf
27930	payment	2133	2133	1874	1	1	1988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJz8BCg1W3ePyEdyUkbfSFbeX21KxgMddYQhqaMGH93mwFCdbq
27931	payment	2133	2133	1874	1	1	1989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLe5tidqwpznytkoNN1GbvTFeuMnMkmUSepXYvFF3vFUzB7tVg
27935	payment	1397	1397	1678	1	1	11560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiLffeV2qAmFTjvtNNgcVKaqcQWi4VQvPvCKbfujn9AyCmcmG
27936	payment	1397	1397	1678	1	1	11561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMnQ4svGxHDgc85GhGfCTU1Mda7j4qiDFLWswm9TFtteCJdRi
27937	payment	2134	2134	1874	1	1	2411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4ESCooXdmRiFH86VgqaKZWdkqwxgRX7Z9aJU8s9NnsuCGs2b
27938	payment	2134	2134	1874	1	1	2412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZK6ChWSB2uitPWRqmzNHhpRCpmvuhhVdh78wPrxFtp5UT1apx
27939	payment	2133	2133	1874	1	1	1991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUt8WX1Do2feFet3WUGQVhdS5rf5EL3H3v3uAta5YjF1sCMSp
27940	payment	2133	2133	1874	1	1	1992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7XkAq2o1FWHDxEq11sucAryrEFqitsZMUFUUEG2Vc86221HS
27947	payment	1397	1397	1678	1	1	11564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgxN6TfP2accYmytjB3QYh1QJbedcKiiFfaUJV7VNdB6KFchr
27948	payment	1397	1397	1678	1	1	11565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfM6r2dzQy9hS1QYmXLbCspTBkoWwpJinVTqdDWQVWfL5AX8g
27949	payment	2133	2133	1874	1	1	1995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAS84b2hSPFqxFSTEhFDScwGPZ2qPsu5vn57kxfGjBwKVRWdn
27950	payment	2133	2133	1874	1	1	1996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqz5VjrGSWD2U4stvg5pYmnRGTKNYHjrdPhom7TEhdvxSEUetf
27951	payment	2134	2134	1874	1	1	2415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WHFTNCJyTbNWjkhBYPrYF6hVyez34D3B9Men8KaYvCF3pJab
27952	payment	2134	2134	1874	1	1	2416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEMHUPivey2uq7gYgMRv8qvrAgBmNWqVfYD8YDnHR5LMHEKHD
27983	payment	1397	1397	1678	1	1	11576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfk789Di4jSUt41nBHAbCpwanwU6rdbz9xNLBGBFYpVScePm2
27984	payment	2133	2133	1874	1	1	2007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasjPB3g8NzbcoL5d2jUbsM5H9BmHyp2m2YYhwTUggEfo21Hdj
27985	payment	2134	2134	1874	1	1	2427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupUhKa81kdRUcE8Q6CT5Fq1Wsh2XSyVJhqzWEGvJHTUt7pjLy
28018	payment	1397	1397	1678	1	1	11588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTPwsLXHSe94nVbKNknnTRx3z72vrFCUrUaPffLf3XaUrWtTC
28019	payment	2133	2133	1874	1	1	2019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjw7cuGwp1Agtgp2Hhsu8La9HGzMnhDDd3sjaadTYuALnhybsV
28020	payment	1726	1726	2231	1	1	8237	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZJ2K8H2ihhU5u8B499drJ3Zd15YiUvs71AmYRgp9AHKVcPs8JS
28021	payment	2134	2134	1874	1	1	2438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScQizqcWpMBChqn1dA3QXAQ1ZotLcqi7y1WrJZbeZjg7ScbcB
28022	payment	2132	2132	1874	1	1	692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYe5okZefyj15rXdDnBDPzpDCohC41SvqBuG6G3cfWYP4xZGQ
28023	payment	1726	1726	2232	1	1	8238	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkpk9f5NPewPUxNJFgL39hXE75r7SsVYLTzEq16FauF29eEZaB
28024	payment	1726	1726	2184	1	1	8239	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiMRSdxeAuJG23m6B2ZcF3MAt97NbBsCZ9WqRqCzBF6ptu93z5
28025	payment	1726	1726	2206	1	1	8240	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxBtxJQYgctkiP4GdZuB2r1DHi36zP3bcBdcFFAW73TAPsjK6R
28026	payment	1726	1726	2205	1	1	8241	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZmnSw59z4BrgGXJshWcJEQ2jS2MJFbEHvqoAubnkjm5TSWi8J6
28027	payment	1726	1726	2185	1	1	8242	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa4RkUbmia8bPKcNzyHVrHhfuiWb28BBsyAyFu9Gor1v9hw1wKv
28028	payment	1397	1397	1678	1	1	11589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW23s5bMvVRP8CwkwxzSN4qdFb3GmmbnZoYgwW5ingEL8T5Ek5
28029	payment	2134	2134	1874	1	1	2439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmpTiX1P1ovrFuBXgcD6qSq1bEY59b349T9XhvqBFwpVCcZC7
28030	payment	2133	2133	1874	1	1	2020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbtn4ApYiCn844SandooRs1BC6cyNzjoyJWhKao63KyQW8X5X
28034	payment	1397	1397	1678	1	1	11591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNp6m51CpFgphGFJjGSxMm9oVPGU1RP7Sb7JnE9xFDusvX7JX
28035	payment	2133	2133	1874	1	1	2022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8tSLMcsdxvvQpyBF88aJyqowjd7mszWWoguSBd9f7vCaPxFx
27909	payment	2133	2133	1874	1	1	1982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERAT8v45VRfYw45aDyt79uHwkdvmohqRfgmVLABjcrE2R5g4z
27923	payment	1397	1397	1678	1	1	11556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy749wCVGgMGknc41xpkUXp4ygu7dr3i22iUvg5F3Bb8xwhfKs
27924	payment	2133	2133	1874	1	1	1987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cnZsEttD1RUeMCrgcrD4bKobbpeBUdATk4rSefQtRx8QK6ZJ
27925	payment	2134	2134	1874	1	1	2407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5jmg9vAuXsbkLG5oNMfcaypnLjAoTwbXoWsmJERDwTmn4QUVZ
27943	payment	2133	2133	1874	1	1	1993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpq9nxkYAKyGCF9YaQURit8B8E9TgkvzLM9MmFzA6Ww1NyzrQ
27959	payment	1397	1397	1678	1	1	11568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk57ZLPkHxFrr1Xz5HKSPMQ3SSeNutTvBG7abjExVrAmMUQFCr
27960	payment	2133	2133	1874	1	1	1999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbX4WkkrNTjfwxFK7JBjtNoRvxvjQGWJi9XagZBUvkgE4arfNS
27961	payment	2134	2134	1874	1	1	2419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGc5HQViVRX8jFZX32gNu1oe5sb6RJi92TcTGUeCvBQgFtC65
27962	payment	1397	1397	1678	1	1	11569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQLnkpRPviGGtQWCeuAjVmyNs6riusqVCk7s9omDNmmZ2JwPu
27963	payment	2134	2134	1874	1	1	2420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWV4h2xobviFfXG55xNd58B5Drm2i1WTHkMPDtUH1XyXJCbU7
27986	payment	1397	1397	1678	1	1	11577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhgPmoQ9EQ5HxZsbC5C7wkz5Crqz31EmGPyF82xKxDvnhNDPJ
27987	payment	2133	2133	1874	1	1	2008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKS67XyVoGFVs2aKTpj2x6M27Y9kxYPpRsisoBy2jtDrzPD9n
27988	payment	2134	2134	1874	1	1	2428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cGTLxMmTu6H5N1WfUHPGpquui5CNymuLbQgr9KnmD7aLd6SG
27995	payment	1397	1397	1678	1	1	11580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK9JEN33s4TP64FNvQpw73W4QwjFWUYZpxxM4Qoqq3u2peMfz
27996	payment	2134	2134	1874	1	1	2431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCWY3bvCorqJ3TsBWwr4dccvrJuSW2kZNzuCXdzCMNfW1vtwq
27997	payment	2133	2133	1874	1	1	2011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfaZNWX8xpCxkn9HAN9nMrFHAnDJpqYUTnhynRQvuQyCVQv54
27998	payment	1397	1397	1678	1	1	11581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGSc6bnDHd93ycDtmH2fsQ4J1jvL9ohP9t7dttCR9hHMYvVXt
27999	payment	2133	2133	1874	1	1	2012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwApyESz8rcTWkQLWTb7empDM2LbdoWjcnGAbrC4JScXEkjoeS
28000	payment	2134	2134	1874	1	1	2432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojkZSCgvHhP9eLcYBWKCoS91Kw6uJwtnWQb9UG1WFUzCM6wNP
28006	payment	1397	1397	1678	1	1	11584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4qtsURMGGNzS1AAVsQxdSW9Gc82PQbJfHikbXaENvpY8oibZ
28007	payment	1397	1397	1678	1	1	11585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUN4o3XZs8E9h5DvoWDVsuBu3JbRgf3TQ2ZY8rA7g62baV4qB
28008	payment	2133	2133	1874	1	1	2015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaJfYC5pgFtJjnZEKaw5N9wYFxEDuxtQar78Mmv8ixAH1oHrU
28009	payment	2133	2133	1874	1	1	2016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAEwxsmLGNyVkDG2Tsq41SmzRpxJsHgQdBbj8h5g3Ztu8Ck9d
28010	payment	2134	2134	1874	1	1	2434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwc7ZkVL7NajtbdW5Zqkrb5wYsuQXAQd3EhFSNbVNTRwVr5Sb1
28011	payment	2134	2134	1874	1	1	2435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JQPryF6uoaMrtCst42yQKhQw3S1oGEaiL8kDYERJtnN8R5rd
28093	payment	1397	1397	1678	1	1	11608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMewAf1bvpWw5S1ed6zquSm3gzEQnME8HTRAusXefRMm4hpZt
28094	payment	2133	2133	1874	1	1	2040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjjiVHgn325cxoRqjCqud8xJnUJ89tgpP7Sx4epbZtDMQuE5X
28095	payment	2134	2134	1874	1	1	2458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrDtzwVNSEEYSG3Ks4ALYebKzEhqyy3BV8SPMNHgsddBP5zbg
28146	payment	1397	1397	1678	1	1	11627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFcpVw8orFLtKGsT5GMaFjNWxyEcDAoUoQrJo1hzYLBHHJNCD
28147	payment	1397	1397	1678	1	1	11628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa35sxD667NyEjYNcM8maGsnZsAmJ4YDauwYHQN5d6CeEwTFeTW
28148	payment	1397	1397	1678	1	1	11629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3aPgNxA1zGCccpPVFWkWD5AxS3ikcnPfkghBAzEhU5pZeSAq
28149	payment	2134	2134	1874	1	1	2476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7U1XYAyFgUrRJLcgMMJMD7nf1c3La2rSBaicaV28WM9SWFMX
28150	payment	2132	2132	1874	1	1	704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtq4PmWbLoUDKXVxr3t2h3rfzb7oNPFYq6PJu6A8YGJVnhmRgK
28151	payment	2134	2134	1874	1	1	2477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpSrUmSV2nBSarnXZQZ7FuLVsiEZrk244ezg7y2gsVbkYXgeZ
28152	payment	2134	2134	1874	1	1	2478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5P2uqtRNfpVieWci1PJE5UrpjfJWNYWV7SpM8WieMmxhcrHA
28160	payment	2233	2233	2203	1	1	0	10000000	10000000	\N	E4YVB8ToqRLaoEX82BXdNjrkZoDLyDj2bL6sqydKmPQFfUb3ExXwz	CkpZ21tdHw2Lpan9okBTSMihNAKJvGVKqsCxqFai5Ck8Kk6Kz7g5U
28161	payment	1397	1397	1678	1	1	11633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5T8GqkkjW3fMgQtyWipGwDxVqKmnLdhroE7FgqzSKEzrmtPXP
28162	payment	2134	2134	1874	1	1	2482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX1mv6pPuL7gLUUydifBX4KFPYHdqq8EB7P2v8GYJvxj9CXehp
27913	payment	1397	1397	1678	1	1	11554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMh6v9FC4CJ319nx7oYK4AeGpnZkxhhFopjqjrMPiAaW6A6tBB
27914	payment	1693	1693	1778	1	1	978	1000000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpZssCVHsDoazBhitswMqF95SYsG7EZVSLZJN3ZxNccF4tH5XKEs
27915	payment	2134	2134	1874	1	1	2404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmA9615tbBmHdGv6pqDNUASZszjuHJLtJ8p4q8p5uQb2Mg2VqF
27916	payment	2134	2134	1874	1	1	2405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FWBAn3RkTLwM169YzwViy5RMRxFjwz6B4TDp3UGuEP4ntYm7
27917	payment	2133	2133	1874	1	1	1983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD23Pq2wi74iL1JtjDCYanvvnduUNrooxChi8o9r9ZaG4JgW5X
27918	payment	2133	2133	1874	1	1	1984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAJDtae9hAVUmBsk21PQnzEpMzY8oqrxJ9nMzJw7FwvTrpXfy
27919	payment	2133	2133	1874	1	1	1985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZBK3x8Bu9GmCTyebYvn1x7qYo581qM3JSgRr96P3qaZkPJgva
27926	payment	1397	1397	1678	1	1	11557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKc4MiVKJ9ReyLNf9aX7RDkrfNdHsZKSAciN93DtyoZ6MByF68
27927	payment	1397	1397	1678	1	1	11558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhZ3MGUQDfMrvazZ463ioUHAPAZ5rVKYqR2gzbJSDpxU5X3oG
27928	payment	2134	2134	1874	1	1	2408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBFYtgmTujQeKMFdjfbJuzvLgLhosud43VoU9ehwr6pJBdn69a
27929	payment	2134	2134	1874	1	1	2409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQZ6KFwSxpaMzqjj5213BWUhwnNfuXvFZqCUHAojvKDY1BpKk
27932	payment	1397	1397	1678	1	1	11559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZByhpB3tJR7G1Gxzcz7iH9BcjaEXcKuhXJTFAuWYRJzHBPySC3
27933	payment	2133	2133	1874	1	1	1990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8seuzTdB5Fr53af6k4PRfvoRvmNgrvXzqMoq4R5Vbu9nMYWL
27934	payment	2134	2134	1874	1	1	2410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHqgcmiyzzk82dChGUgyx26UBazKGHEDvQbtxmKCXGX5aEST8
27956	payment	1397	1397	1678	1	1	11567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKkmEtNuPCR5WKADhGtBo2JquQvRJrvauSMCq1Gvho48RgzwR
27957	payment	2133	2133	1874	1	1	1998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuMCXPRi8yphiSwzRxx6zCpPGMkwHtpFyASRjkub8oWxRTSFtX
27958	payment	2134	2134	1874	1	1	2418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjiaGs4GjyHCSPRbapKNA749mKBSyNNVMCLJ2wTZpg5JBRcMj
27964	payment	1397	1397	1678	1	1	11570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyU5VqtsuHd1x3rGz6fNNvLewQFPdz4acRqgbx33GRCaj3u8Dg
27965	payment	1397	1397	1678	1	1	11571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyT2NtknspjcQn8deecLqZAZQHiJVLs9HJW3nNMY8YhVMYvfC
27966	payment	2133	2133	1874	1	1	2000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKTMJRfiM2YGw5Yk5tCzsG9YWK6VvSxJ9cqGiuGuZQRJrz4T5
27967	payment	2134	2134	1874	1	1	2421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLX8FYuKJBB7P69yGpyyCy3zKRJ3bLbXaJzwpFCJSvB18MU5x
27968	payment	2134	2134	1874	1	1	2422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQNDXZJRzharzctMKziMPwTyStjispaTHU1gEhCzKRjcPoUyY
27969	payment	2133	2133	1874	1	1	2001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nGvtcWAAzM1LZ3HZ44zbQRFdVaVCrnPK8LLCvpKhRA5huPm4
27970	payment	2133	2133	1874	1	1	2002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuz3JwMiXhNkv3om2f3HHNGgPk3X79wVhkHA9nbdUu5UvmxJNH
27971	payment	1397	1397	1678	1	1	11572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrJcZHJxocy4w3RFdiDHmHPXzMzWdiJPSF5xq3RpRJKiVMva4
27972	payment	1397	1397	1678	1	1	11573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BmF2WDJQNy8Va8rDPNDjK2btmuAARtYd8sA5DzK9iz1gHdca
27973	payment	1397	1397	1678	1	1	11574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCcKo8kXCm8HfGyjjBgGnHRybmYEkeJ3hDMkjpUqsjJQQwvUQ
27974	payment	1397	1397	1678	1	1	11575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6X6qpHNowDbCt4ueRdB1UkLXcYnCHZMCWMw8VmQiFf7ZTb4o
27975	payment	2133	2133	1874	1	1	2003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFg2pB9CaN4vURmGET3zR8uefSANFHdPryVndMejADNPeFdFB
27976	payment	2134	2134	1874	1	1	2423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbebGPJ9AfZPhZZhtUz97R9sNSKZgypJqpNWtB9SEpj57iRwX
27977	payment	2134	2134	1874	1	1	2424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquVakVqiKnKNYWeGbiCKfi8uTvGC5Ld9jkvwSh7qzm6k1LPoq
27978	payment	2134	2134	1874	1	1	2425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsZAUe7vUxUi87HvoyMn3MnbESgf1reHdAsTofXu5rnNAVx69B
27979	payment	2134	2134	1874	1	1	2426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9f86z9uvbzZtAs9xg7HSdcrmkD8VyQSVxh18LrnKbZNBiYE5
27980	payment	2133	2133	1874	1	1	2004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4wCQUoGpLmvx1ddKsEduhA8aojxzSzBdUVAajf9x4qN7ZYps
27981	payment	2133	2133	1874	1	1	2005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVnahhWaXMLxGZtJHuvwMbnen7pZPVrCjfa2tHGbjkcyVLeQf2
27982	payment	2133	2133	1874	1	1	2006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgnvg8Ztf2tNSvcNLzrKhnsYpMekKtRy1mRLTeB6g2xwZWcU6
28012	payment	1397	1397	1678	1	1	11586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m6nKfPxxpZ2bkGxJsM72YYjryRbGfwTwyXMPdcm8nBFuXZDm
28013	payment	2134	2134	1874	1	1	2436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD4J8QvSwfhWbbkVRGcWhEYVbwzmsDNyUHiahVvwDjCpTBazpJ
28014	payment	2133	2133	1874	1	1	2017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycgJxBxggT3GuNF2DmdLJzhwwu4KV1ZL3i2hRX3QeEJo1bLts
28015	payment	1397	1397	1678	1	1	11587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAsPjswcfLVgE6Q5tdMcWajSPt7tLmrRUiUwRrixgQsNJywmc
28016	payment	2134	2134	1874	1	1	2437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxWpA6p8C9S7CcX2fGFkAkeF16GMQXengkmWV1JMJ2BCxNHhr
28017	payment	2133	2133	1874	1	1	2018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTuoabfqAYqLWBHQ2Bd7WHF7P3KzTZmYe9T3icHkeaUsTZduk
28031	payment	1397	1397	1678	1	1	11590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETXMB5o74DvScC8WwJr9knVaLscdh2wBcoUZfPvZoeQkkz6u7
28032	payment	2134	2134	1874	1	1	2440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtBJdgdenp5sPzw7ngP7e5fh24g6U6ozrWUWVjAvRhqaz13Gv
28033	payment	2133	2133	1874	1	1	2021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSvydS9ysh6o29Fbt9tqfFny1XP1EqWB9FkTsC8jVQfVDFk58
28047	payment	1397	1397	1678	1	1	11594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49hPGAtxWp2MeXDbKZ5Gogt9bngm5QrdkJfG457utgqQ65ETZ
28048	payment	2134	2134	1874	1	1	2445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hhS1aYXZJz6tbLeZZ9Zzg3rhZ8XtRp3iphxiQFVR85mgNP5f
28049	payment	2133	2133	1874	1	1	2026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAE3g2LrYaH8k1eUoZ7gdB5EatW3ErAFPdEM4WYFdhfaeQKGSo
28096	payment	1397	1397	1678	1	1	11609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cN61og2bAi9M8MYPAVLpVaApmBjVVAVcsUhRzhCau9kLqwAx
28097	payment	2134	2134	1874	1	1	2459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Anbvci35ZBBGn8X6YRc3hvASeWw9DEA6ReXdrVx5F3b4Th6t
28098	payment	2133	2133	1874	1	1	2041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MyvL1U7mjEwoqUzWcYvQ7KVEyxarDSG62rLZeyk7hSGQ1xnP
28099	payment	1397	1397	1678	1	1	11610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzrPpK2SJHPdnLBFYByiuBpoVPPLhq9AtQrW22FisfCjhKzfr
28100	payment	2134	2134	1874	1	1	2460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRz7wRHaDSzjFHLyEjKsZ4rbgSJH4QaCWVpYgA2meYzBnJqdDX
28101	payment	2133	2133	1874	1	1	2042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3huwDmdVTGbeo7DGa1hw4Egs5r2WFaBnBBa7id3cWXeHamjJ
28102	payment	2132	2132	1874	1	1	699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ARHvRmjdyMP8MsAFpaBCidjTi2tcCTyMfG6Pq87DRz4DUAMs
28158	payment	1397	1397	1678	1	1	11632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu3eyukJwBpc7d1ZGX2HVrLHYPuC6rKgZQoHPts1dBrxg1qE5M
28159	payment	2134	2134	1874	1	1	2481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDEaaHh4NMMX8UE2gSGKg9Qcu7tiD3cFngAw8vfvHfpDvnNBt
28164	payment	2233	2233	2234	1	1	1	5000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZKNTBYRHGVHezJ9QSymSDBovmjSqhbcCAWWUFPNqB3ih7T9K
28165	payment	2233	2233	2234	1	1	2	300000	10000000	\N	E4YbP3REp71wXfR8mBqQN4qzeytRquD9PfhBN84X5o35L27aweUrV	CkpYttS5Dn3LLhqsknekxUQZCaB6W3jMiaQRiQFZMaWgMf6hdzk31
28166	payment	1397	1397	1678	1	1	11634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRjihJ2yqyr5HdgP8f2VkCguQ2MqeR3p6GsHTpgnx3VAphsdR
28167	payment	1397	1397	1678	1	1	11635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9g4WvAQYESEKDtaTHzWnpAqzj1tndLpmvnnx57sZVtuuuP9L
28168	payment	2134	2134	1874	1	1	2483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBngMHcRf2uERNgBUtuakNDsvfGEW8MZ5SvzxVDhkXH3P2ufXc
28169	payment	2134	2134	1874	1	1	2484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkENuzE3qUcCfjCem9dsJQKF967RUBzNV5cmfQhcYmYC75abpm
28170	payment	1397	1397	1678	1	1	11636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5BPKmZ2JJUAzgyHAah4fHTyccF8zKbQjE3wYxxwJbwkV1NyF
28171	payment	2134	2134	1874	1	1	2485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NQFm1kG3GGtk3EFETo6X74pgeysi5WuAn6iTEZMkMgbavMaP
28180	payment	1397	1397	1678	1	1	11639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjJX8GSeudb8uwaKsHkwub9nzpkR9rHLtuCcgKpszbCnojQxq
28181	payment	2133	2133	1874	1	1	2048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8SYTJoP7wpb4XBjujEsWrrPZvmbvKz1qy2e5suUNtLF144bF
28182	payment	2133	2133	1874	1	1	2049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjB7PGAFFFgLtmk989hngHTAYeyEYtVg3KC86PkQ6YdjLBUsRP
28183	payment	2132	2132	1874	1	1	708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyDpjaThVurrs6nFLz3fKJCg7mmuoAKNBQcgaWdLY9Zx4mXNV
28184	payment	2134	2134	1874	1	1	2488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKGbKyQFGSfY72wUupNWBA4SWZ6G8Xn1kkeSGq9SzTBjCJZ13
28195	payment	1397	1397	1678	1	1	11643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9Nv7RxaoREZQ81bfuz2yzjF2BqidtkCfn9D1hZZxnZ9rfvUB
28196	payment	2133	2133	1874	1	1	2053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmWxdhEyZCF5FNgjeHoEjEg6HF928PLw7nxLtWYdxF6LjbQs7
28197	payment	2134	2134	1874	1	1	2492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzAGuFZ8nf9LbDwsQmNKxAv6vDaQG5VfwMgfb8XkazvZvbJqK
28233	payment	1397	1397	1678	1	1	11653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbozP3o1SJcyCwfiDpEYJd2f1gZASYkybYvUgStA8g1xmVuKdk
28234	payment	2133	2133	1874	1	1	2063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6Endntjr5E34EeXBrt5tt42BuXWgBNgCtjdPXsu8AzZpToxs
28235	payment	2134	2134	1874	1	1	2502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzCNuDRjYbWV4EQEvAV4Uz6BDdsu76jkXx2QSwDYE4EQUbZ4nB
28036	payment	2134	2134	1874	1	1	2441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB94F27ts1f5dV3DoD54zmWhCYFUQ71PguoNSdWFjgX5Unjus4
28037	payment	2134	2134	1874	1	1	2442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp84A2BsyFzH4p7NJrk6tPLHBsHZPeQaASbyYahakEUkSrhGHY
28038	payment	2133	2133	1874	1	1	2023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxdvitkKVXY5wzbnGPArGPA4V1NtucWwiH9HnscD1FcJSi8Wph
28039	payment	2132	2132	1874	1	1	693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHy3TKYAGShfwN4a6Vatc6Ro7Vh4q2EgBLXtcV6HmDans44Q2
28050	payment	1397	1397	1678	1	1	11595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs7GskbnXQt1His36UBmrZ5FuvWGZpxaGyerbJCV4fiEVZNWrD
28051	payment	2134	2134	1874	1	1	2446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAspPMTQYEQQFzsvwPuyawLyDXMu7nRUdU5JmR2MTLgf7bYq9V
28052	payment	2133	2133	1874	1	1	2027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwrHWYeRRR4ZJkuT7treB4ofNhJ7WK4CUUoJvfCH9AfNFPWsv
28053	payment	1397	1397	1678	1	1	11596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wwHaEENFD6uyExAgWB8B9hRti1wAhsovTzcEZnrSdbhzyU81
28054	payment	2134	2134	1874	1	1	2447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpWY9XhVkjCzyxGMKmicLnPos3arnaUEw5NA6nsXXqLHCXFBS
28055	payment	2133	2133	1874	1	1	2028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJfH19WSSZG3FtLrXPt9TYuRGph2463QxycoxptjbrKCq95YS
28075	payment	1397	1397	1678	1	1	11603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpFbfqSyVD5SafUxzqpPKUq5vSu8FZNfckbEGw9Krppw5RKgk
28076	payment	1397	1397	1678	1	1	11604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwaGvaYqgSSkg3eSi2CSTojCzUnLMBukRi6Tt5oLSmNJ5QVVs
28077	payment	2132	2132	1874	1	1	697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYhKhCrLGDt3Y2XeWPH7fGS818rXgFUFYyrV9F8oeQtG4g8ZP
28078	payment	2133	2133	1874	1	1	2035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrBJA8yaBTp2drfJXfFpEZP5VtRJyohHLSeT9mspyx8hn26sR
28079	payment	2133	2133	1874	1	1	2036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4yWZQiViTBJv9LQE1KfuweCSHjyhEZtift6y4cUQukU4WngH
28080	payment	2134	2134	1874	1	1	2453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBy9CdEqSvkvh51WCYyiETK7hYPb5zuZmfBue9kNCPp5QgYFJ
28081	payment	2134	2134	1874	1	1	2454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGwnbXHTGv2WXyW3YFWxxnx53ssqQRRCu1LMdjKZFDUqFrFyW
28089	payment	1397	1397	1678	1	1	11607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xD2gsKX2X5byHPTsQNybARBCVsriMLHNepqsN4CNbfiTUSqR
28090	payment	2132	2132	1874	1	1	698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR5DzbybmymFFuEyyg9VotPmfS8aQHwQuJELzJeFdLQbPHkfsg
28091	payment	2133	2133	1874	1	1	2039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhMTma9fvA4Mp29d1jBuk97Az9CjgeT6Viw8uDosAZaJv1kvr
28092	payment	2134	2134	1874	1	1	2457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PGCFJ6s8MVAjtQKNPx3Sfr8mdEBQed82PTEwRSoykEU7W9hL
28103	payment	1397	1397	1678	1	1	11611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJJ7GSJ3jUEmkoymDUgBq9nLJfvMVnjr4QZCQ2tfcqEnSjqQez
28104	payment	2133	2133	1874	1	1	2043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThpvojjBKs7mjM5SyCZkWb4HRZBJ4sZU9VAcVKQBjVyX92h11
28106	payment	1397	1397	1678	1	1	11612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU8UMcv1yBkCTkL5JWaT2jn7bFTQWaLjA7FKwUWEfHfDE5wAW
28107	payment	2133	2133	1874	1	1	2044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4UFpLsVdRR9gsY6SUJhGamb9GiTdSQLaqWEBToWcxxr2wW88
28108	payment	2134	2134	1874	1	1	2462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv63JECPBpsJKdTmncTyKxEzF2G8ySVYHFwRF91ic3qqB8nEB
28117	payment	1397	1397	1678	1	1	11614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRm72tPaHG7DGUGPAFDm7Tw3ntfhuiVGZ8stciPHV4czoSvef
28118	payment	1397	1397	1678	1	1	11615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8Tu5E85P8hRHFTTSKguPHmgvYuj5E3cuJaRR5LkSwoY3jq93
28119	payment	2134	2134	1874	1	1	2464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJFyd2qehZURzamZaZxFjEVhJznxhQSBcC2F95A3wLay4RrKE
28120	payment	2134	2134	1874	1	1	2465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUt1F1CKV1gmy1oB8UELGhop393zNcztTfqR1R4Cgz6HDvJdEq
28121	payment	1397	1397	1678	1	1	11616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTh7DagrfHp4BW6Q8tnLAjms3dssuWv8QGUj6JJA868oUma5y5
28122	payment	1397	1397	1678	1	1	11617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuPqoKr1YDEzpr34WGxN59D9vUtyMnnG1jzJTiYU8trdF6SRx
28123	payment	1397	1397	1678	1	1	11618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7iJZHGBgN4NzSA5mFZVENsSYyqiA7XzasgZ35Z399h58fY97
28124	payment	1397	1397	1678	1	1	11619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyDmGdGZTiteZccUrnMv41R4kTfVpZcExSYMEbwhqLUrjkzwb
28125	payment	1605	1605	1931	1	1	0	1440000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbdcBvG8CaGTC5UyCEBeHiEM7ZnEMY8WrUtUfHM1GSgH8hyGbs
28126	payment	2132	2132	1874	1	1	701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSvXdxQ9zLWGCAyWQzFrDjmUL6kiTsvzjQJUK6c36TXphmAvj
28127	payment	2134	2134	1874	1	1	2466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrVMMPUmsWNqbWmCjmrVXa6bZBRFUsjkYCqjk6oR9a9otjaQg
28128	payment	2134	2134	1874	1	1	2467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYthsosPKNqDeKfHRzPimWwVZViYo5uabBhdSngw3rPAopBpFG8
28046	payment	2133	2133	1874	1	1	2025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9w3k5burZ97HAUJfNqwgf6nWCsCyDMC76c8rwTmdvEkkEmW8
28056	payment	1397	1397	1678	1	1	11597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dpKYyASDgDygKLkf92Gdzv7KZxkpXYCdwsi6qTtyK4Xz4JpL
28057	payment	1397	1397	1678	1	1	11598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4VS9e4kVCyJ5dxCgW8zxcYucph7Y6oYuYZ7bbMg5p1jJHNRC
28058	payment	2132	2132	1874	1	1	695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSg1oTT2EiQGAXnsyaQDyT11k2UsqQKpss9vZLp7JiXCkXb1c
28059	payment	2134	2134	1874	1	1	2448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTWMeKnwNfDUvAkwEV4onRVb2iJ7T17spRDWhBZknMozF5paf
28060	payment	2134	2134	1874	1	1	2449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwjE4CojPwrM1C377V8bGv9qHU6311KwBr2BQZUXL9csN2TcS
28061	payment	2133	2133	1874	1	1	2029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFe6EQL1Bz27SKbqfsqPpt3HLbKVZYx3G9DcfBGM4P3p9HhXf
28062	payment	2133	2133	1874	1	1	2030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPPE7NsN4DKzBmKD2qqe6XbRP4t2Uvaot3VgsL7iG5j2MvK6p
28063	payment	1397	1397	1678	1	1	11599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhxG8Vg5ynScEHMBp4rEa4AYb2vwo1rBCJcchwph4EjZ62kgN
28064	payment	1397	1397	1678	1	1	11600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKEbjENVVuodfrcCEfJ8T2bHjWWb8TaTpB3rMqZmrF6fv27JW
28065	payment	1397	1397	1678	1	1	11601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvz1pEArbz1nfgL5abLe7Xth6cfPreiKYtbrvTmX1NSRpmrv4g
28066	payment	2133	2133	1874	1	1	2031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJzEpvdbViKVtBWoRRXMcz8fG1cHa4rEySNPBCXDW2MLUeRNa
28067	payment	2133	2133	1874	1	1	2032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FXSb16gUxEPiRC3bsfdRyaTrD52pAh8CxLKJBZzv3fKx9abh
28068	payment	2133	2133	1874	1	1	2033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVm4TBHtpgiakkgo1scAXpxD5g66ahST4zbSuZBmKKjjuDZts3
28069	payment	2134	2134	1874	1	1	2450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWaCS3KeoXyRUHHNYbpGvPkcT5zCcrxyo687B27YV6siEw296
28070	payment	2134	2134	1874	1	1	2451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTDfJiQrvjF7e5erUgve7VHJsRZeGBzQazjrZNeCuik6CLmxc
28071	payment	2132	2132	1874	1	1	696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQbRbKxNo6kUBxhy3yqbLDFtf1jKhG8o6XJ72VbFmuMg1f5tn
28072	payment	1397	1397	1678	1	1	11602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRv8HKGGgu297PKA1M4xB7v3yxC1NEhTEZ5bqkxaHv5nTuqibQ
28073	payment	2133	2133	1874	1	1	2034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvk9CjgG44xqgctHr7XBMyMjgPobf3YtyFt9Vdb7ezz4HvEf7D
28074	payment	2134	2134	1874	1	1	2452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjQ4uuWxV7tkvgyKDVBUnFmoJy6s9GS3WQFrtnvyqRxnrE7CZ
28082	payment	1397	1397	1678	1	1	11605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWeXLzfhAwtU6DJGSXX1vViys3T1cdS2iMjw9vfyPPTfJKRTWv
28083	payment	1397	1397	1678	1	1	11606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8oWHvfL1Y2WYak2BoFzYJvbsrSfm3obmKewShWnq5k6NVhqBa
28084	payment	2134	2134	1874	1	1	2455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmD2STZkgFmsbWoDHjYdU55jsRsdxuhRTjii1qmVAZuwxwub1c
28085	payment	1726	1726	2233	1	1	8243	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZbBWoS9AkQJVx7Cm5f45p2zkMbZEP6KvwBs91eqdL8MtP5ZV8f
28086	payment	2134	2134	1874	1	1	2456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPCPR3hVnRf8x7Lum3pyEZkDsU2Rkws3gXUKAt8kWJeNbfxAx
28087	payment	2133	2133	1874	1	1	2037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMyrxQwasZPWXoEPmbaPVb6xQ86Y7euasnFxYpEhZd4FQPPqF
28088	payment	2133	2133	1874	1	1	2038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbf2eZQzS9tAoEaMAsyyBXho33gsX4HAETVHvf6iLcHpgUGPiK
28105	payment	2134	2134	1874	1	1	2461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCvFFvz7cnJXduEkaZx5Fpgha1hDyRrQqjxfxBthpQ3ijxKJT
28109	payment	1695	1695	1330	1	1	5	6430000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJzXRHjNN6j1XnJpp8oVn6E2qLQ9LWUgcMcwd4PhRVayHvR9x
28110	payment	1695	1695	1204	1	1	6	2308000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi7QTsA471rvW11q5LK2bpGusZkPxjy8UJs9VSjNsev83tbQsx
28111	payment	1695	1695	1084	1	1	7	3420000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcitphXceiT5QnsTQrYo9bL7Rfz2zt1rw8fhQEG3dPCmtrEdEX
28112	payment	1695	1695	964	1	1	8	1909000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6LzD5pcfhcpjfZUf1MkfCCCBgAzsSZj4xep4KeY5RqvZoLr7
28113	payment	1397	1397	1678	1	1	11613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevd3rMfiCSsk3pbKN61TxPBEHecjGdLa9p8qEM5uU7Y4Bmqrm
28114	payment	2134	2134	1874	1	1	2463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWyz2jQwvN5e5QCJ3EcStkF4EiSDPKjDrFwrQuN8qZvjVtGtb
28115	payment	2132	2132	1874	1	1	700	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubpSBECQMpDvQRUMBe8wRcooYDZDaZyjwcB3g62muUxwvASDT
28116	payment	2133	2133	1874	1	1	2045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38mci889zhagWgrD3LZbmtPUYU7FvUmStYBCvQ7WH7XrBepz6
28134	payment	1397	1397	1678	1	1	11621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfWm1oHYprdCi7AnEwZjg7x2Q2BSiizSLWAMnzpH68cwPsnze
28135	payment	1397	1397	1678	1	1	11622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNU8oqbsRNtvCajodig92E5PVQktLq5dwkXCdpkeWDFjruCdA5
28129	payment	2134	2134	1874	1	1	2468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9iF3LUxo6hnxd5kmbyY5DD6zg8TR1qGSoZjXLf38yku25ajk
28130	payment	2134	2134	1874	1	1	2469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrsZoK87dHBTZmT9jKaWb5vuVy8jXHGjsYZYja7jKEnGPxs9Z
28131	payment	1397	1397	1678	1	1	11620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5afzVEmRReg7SUxiMYNCUZ9nTRFhpJXEJ9KwRnsUcQTNTMqwY
28132	payment	2132	2132	1874	1	1	702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniTu4Y2YxBC8ejvBPoA9QKovwoqPztFYAmW8iPczKncNnCGbj
28133	payment	2134	2134	1874	1	1	2470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23mTEHvLoNxGYBFe5khSStpLA3cxMdU5cvpApyayxDVXY7Lcd
28172	payment	1397	1397	1678	1	1	11637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjNP4npt49Qy92A1nxegzBkZa7wy1JnHR7gFxokf7xSoaDrdY
28173	payment	2233	2233	2203	1	1	3	1	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xqgfY77y4nRjDapreTNGZPLb3BxafouDMZFMNrDkVgFzHNcN
28174	payment	2133	2133	1874	1	1	2046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHH2EEAyccbsXs7RNaQmW4yCa5ExDMCiQ5XYQEAfwdwec1Yjm
28175	payment	2132	2132	1874	1	1	707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxiJEAVzVF8368hLJ3rkZVMYYZRudmZUXdqvPWaRv8Ct69od7
28176	payment	2134	2134	1874	1	1	2486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTkvdt8WGCUoswdyUo1Qeaujoj8M9RSxfXmVbBuZXdPDP39H2
28185	payment	1397	1397	1678	1	1	11640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6G86R4RjfEJw1T82gMfCuWxa4yGPrwsnyU6U4BhWspYPRVkpM
28186	payment	2134	2134	1874	1	1	2489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpb1eZsNBq2xKvV85HKVmBf4Cd6C7ZcV88viU2uN6DEJfnrLCh
28187	payment	2133	2133	1874	1	1	2050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7km8LM2wCbX7b4Do9EDcMvKVzcb8QhxzB7iCztLszaE9K1z2
28198	payment	1397	1397	1678	1	1	11644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkqr99dtmNhFgPcrEeoz9BCgYQsaicEneq6qRHfH5njDmNuzq
28199	payment	2134	2134	1874	1	1	2493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjdZrAqfgpHCA8C1EdY8PY5pHu6BdjEyrpUzWWPv48z39vZ8r
28200	payment	2133	2133	1874	1	1	2054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw88aDWBBMctomisKC6znkm4W8tUu8aGDg1CwTney3s47JnFD1
28201	payment	1397	1397	1678	1	1	11645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhqiFS76363epWgKZmG4r8fDJRRvURVYUrVspreoKZnvGEAqG
28202	payment	2134	2134	1874	1	1	2494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkPXS9XaR7qAq3bkh6L8MLksKE2cRg63LznFpnJzmezf3XeKV
28203	payment	2133	2133	1874	1	1	2055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdwfU3dejkfN7EXmVEu3vDVGiy5pDT1ePmUJFhjuMmu9HUW6e
28211	payment	1397	1397	1678	1	1	11648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPqPu4V1AZSLDRCb5PNL4po4FCHdnd4Lqzi4wzxh4o1s4Z6wy
28212	payment	1397	1397	1678	1	1	11649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF2CkqLAwFsiureEFh2cw9yafHUSNhp3zvCbMR6PC5VeS9t7b
28213	payment	2134	2134	1874	1	1	2497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRfVbQjBHFnb62mc6hiWnBNt6xBDUiXrvfaE6P8eT9RwtvMoY
28214	payment	2134	2134	1874	1	1	2498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9sK5eHKFz3CiCzCT8HtMRRKDwyvjDs35M4BnNV1xSUR1oRnv
28215	payment	2133	2133	1874	1	1	2058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqMzfbeB6jN5Yupz7BKmm5BSjVeFUECPhc6rgGQTxof4p2rgH
28216	payment	2133	2133	1874	1	1	2059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpnfvUy6q5v6kf6yjWCvcTQyLtvopNWtdx5ic24cpwqSKLaxP
28217	payment	2132	2132	1874	1	1	711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyuiKhsUmT5ug2MrfDvfzppcg5Bo7KEmCkzyS7jrWx6rxWqxr
28218	payment	1397	1397	1678	1	1	11650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfdDC3h7qyvxnNyCN5uTWQJhk5WNqeyVyhvCqnrAF2jDAgHd4
28219	payment	2133	2133	1874	1	1	2060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnV6GRqZBRWF48kiWNxAhcpPiLAK1kgjJeCF5YT256iAk7q1W
28220	payment	1701	1701	267	1	1	9	215456725760	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZhvEYxb9YFZULWEw61khrHAqGZhTktZSiGQ1CKfe6n2TcnxdgD
28243	payment	1397	1397	1678	1	1	11655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAWA5HQNZjw5oyqLRoyyfe6EmZ54pVzaxJzLp1Ru7D3CWPmKJ
28244	payment	2134	2134	1874	1	1	2504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWznpX2wcZWGPRwjb69F3i7Qr3DFztepSsuAZUrMezZQj4hC1K
28245	payment	1727	1727	908	1	1	7	2240400000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHyZYBtFsbm7Mtm1pQ17kXMC6AUGz9LRJbDDtTnFQ5BFCkZbv
28246	payment	1727	1727	1028	1	1	8	4014700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKEbZc8LxUL6zoZZyxsmzXi2uueStbRKBnYpRQxuUqxkrKARs
28247	payment	2133	2133	1874	1	1	2065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwXULkEvM4fCb95cAKtDEYJhnAtP5wdN7fJwKC6gtb3mHaFj97
28286	payment	1397	1397	1678	1	1	11666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMzZWWPu7PJ6rBW6JALty6kfWEXoa9xwSWFoSzisSjsTzyLQg
28287	payment	2133	2133	1874	1	1	2076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTtsbQrVuqmtZdAgrWYNnoZpF2JVy7omc1zTHGfQM4VxwqKdX
28288	payment	2132	2132	1874	1	1	716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhMwhJ4jDUcHCbbsqCGQkiVNpx4PBAXKC1LjZro44vhxMXa93
28289	payment	2134	2134	1874	1	1	2515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidm8W5j2UiJEpzAKepwV3JVxS7htwKkd5gHcP5ohpWiTkq4f2
28136	payment	2134	2134	1874	1	1	2471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnR3Zj46kbatATyEpLLCLSW8z1rm2W4e6MiHkXTPyZCUBqGxZ
28137	payment	2134	2134	1874	1	1	2472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7P3U1cNVYgdN6D22i62rbveXToeAFCuYqkxjAQwReSAM6Am9
28138	payment	1397	1397	1678	1	1	11623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eJM7dCipVb9zSg47uAEyX7Yd3zpRmJfGidiKe5TXWGwnYeUm
28139	payment	2132	2132	1874	1	1	703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6GJAvJfhryqD9aELjB2QNA2PoXzmpC4USvGkvUjRsmwpBguf
28140	payment	2134	2134	1874	1	1	2473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgLmGtE36jABTvpqNLo1RkuaUpDdZCkM4w9kZCsjVabzYTkT1
28141	payment	1397	1397	1678	1	1	11624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCi2T4mJCNHZQXpKqhjnSanNEJSgRdR6VYFTCnJ5okNCsFgQLa
28142	payment	1397	1397	1678	1	1	11625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZG4x5nDPbWpufdCsLMCy1aWax3sXix9TBo6FiZZnDyMFk8pm
28143	payment	2134	2134	1874	1	1	2474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoaZs3e86xFZnpGu4VFGMCmkRdKDkG494tFP14DTRMKUMW5aBq
28144	payment	1397	1397	1678	1	1	11626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ8nZer3eEcGHxMdhg319R4eVAF4C9W1Fdcf1wMV32UCSNAddm
28145	payment	2134	2134	1874	1	1	2475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3zHk3hxgmAn9Ejq9SAqse6sBLdMqLz8PDGX4BUSf971HHmfV
28153	payment	1397	1397	1678	1	1	11630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcESnYWTh9dkeiBjMN3TGk1MS8As2xbHBxNQaJNwRfqAiXoFB
28154	payment	1397	1397	1678	1	1	11631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkQQGSxwfSfVa9QVj7sfeJwCVjrd8b33dJqWmpaX97oqPNvdu
28155	payment	2132	2132	1874	1	1	705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHVK55gLTPYsoJ7ckA1prjPB62bq57Wwx2RsYNhbycahJEP9P
28156	payment	2134	2134	1874	1	1	2479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzoSPvNZ47LLwggkxppfu1MuepzQh3H9prb2G6APCmQMPqjFJ
28157	payment	2134	2134	1874	1	1	2480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JnPmSXW46nxTxDexWBm9GRz6JS4hqTQoy6MqGiUnxv2UoCVM
28191	payment	1397	1397	1678	1	1	11642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWb6hHNVsjXe9PPD6nQhBHrMMsmw5LREKQhPiPKjmLp96wgPc
28192	payment	2134	2134	1874	1	1	2491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGo5RM8s2qBtrkSCvgNR9zozo3c9u2CDJB2ty6Qr4sLqDbGYC
28193	payment	2133	2133	1874	1	1	2052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDUDMVrW9QMS5skU5gHT2ArMMH3xMRgvtoAvknBrwmqpTKCpj
28194	payment	2132	2132	1874	1	1	709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXXtZQHZGwZzCvincaV7Qd3aMEgBv873dPquWkKnYv1ZkZTcg
28204	payment	1397	1397	1678	1	1	11646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbx9yYYfXA1Q84KnEwQXaz7gxxKrGPRwfiHVUdxahHk6BWZvbc
28205	payment	2132	2132	1874	1	1	710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkn4dpyXeRyNkAGCbQS2M7yrM1R98Gw4oiJ92ArgEomMChe5rg
28206	payment	2133	2133	1874	1	1	2056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS2hWtWqLn71cJJKMPw1nFTebUuF4eN4z1vKUF3CwG453sBkix
28207	payment	2134	2134	1874	1	1	2495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHBRQwShNPPLRs7AjqDQfknpX2tEQMyiSLjF4wLcjvue4UdyT
28208	payment	1397	1397	1678	1	1	11647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2Hz1EkSyp52LVsdJYGaNDkf3sfDBuyKQzdpzkLuG3G7xoDJX
28209	payment	2133	2133	1874	1	1	2057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenzjQrL7e6kDkKN75vT9a3dANvwzbjs569jppqqTQdmhXRfoC
28210	payment	2134	2134	1874	1	1	2496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9FUFRWttYVbTT3GnaMnYjbtHUbt6ATombDQi5G4guiE7xUvQ
28227	payment	1397	1397	1678	1	1	11652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wGkNwnUnfwCVQrjRa2X19YFH7J5FrvKoy5hRGyJiKSoGASQE
28228	delegation	1985	1985	1594	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa865bhPnFqFCLs22ZyZbi4iPWvYKuzjmySaGVkpAVCHwCNcMLQ
28229	payment	1701	1701	1042	1	1	11	2941224132904	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZHxFA2CeuBUnoFmyDMHoTnD9Q2611vM8XJWNRQ37fh9FzJySZP
28230	payment	2132	2132	1874	1	1	712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4GMz1w3QJZyTMPpQEVmmnedN6B6tWoZ6pisFh2PwdZVUuxXX
28231	payment	2133	2133	1874	1	1	2062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEeqbxEP2gG6Z61xseSPqrg6ucFtmZCCRdJgAZGHXsEuETs87
28248	payment	1397	1397	1678	1	1	11656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD56wSHWTnTUP6yApc7j4rGPVWwVakZtYGM9xN12696qhPGz77
28249	payment	1727	1727	1148	1	1	9	2708800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cLYYUKK1bRZYjx1gyAFMduqT3A9WqYcR5mmirjR21CZZJv5X
28250	payment	2133	2133	1874	1	1	2066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxq5nB2JbidPi8beEwcjW7Z4TxTn3g5XNUh7w9BRr8QYH1ivL
28251	payment	2134	2134	1874	1	1	2505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcJSzmNeVZPC1ZRsuqGnQvacedjTNQaR94SDu9mn2m7RZkNX1
28252	payment	2132	2132	1874	1	1	713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnuNaD1hrYiNtP1JDmFwFT4FnGh85TTvMjXMVqYAciSEpG5n1
28253	payment	1397	1397	1678	1	1	11657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSadEWdvtzxCK46Lq3WAKtTuHKTXfAX99iHTCf3DEmMtxZMkh
28254	payment	2134	2134	1874	1	1	2506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49AxDMQdLVkiXgqFwL1wS6DNTsR5vBx84FecHXMPRzqHTqMTr
28163	payment	2132	2132	1874	1	1	706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MAUe7FngNvHzPw4qAEFRuDrdDG5hKPY5242QzSzhcffV25zD
28177	payment	1397	1397	1678	1	1	11638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStYfrmWsuswDRwzoWKP1vKY4wSLQpTKX1YH1Qoq7pTWx6cNTw
28178	payment	2134	2134	1874	1	1	2487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjQZdF9xYt31eFvUy5CT2VyD8KyveuekBZM2aUagaudCNsV9G
28179	payment	2133	2133	1874	1	1	2047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ePAa7LPTQUvRKPQEvTp2svdof9HfmuNHozh6UXSc5rFLtnQ5
28188	payment	1397	1397	1678	1	1	11641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBTBJyNAwx5DDGxkDAXAC5kt7RYzES2MDFjh4JJWtMBAfwfif
28189	payment	2133	2133	1874	1	1	2051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCrfU3WygrSiwHJiBHd5EF5yxLQ51cUJgwEtyeu3rXYiiTpXS
28190	payment	2134	2134	1874	1	1	2490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSVZd4rW6JmtSsghWaiSH4ABTcWavdLzpUdfBy5UcAhKFzLab
28221	payment	1397	1397	1678	1	1	11651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68d8wDvBWVmVbHXyfWnXCxMyB5Py24YyDMkp81NF5U5AsXNQs
28222	payment	2134	2134	1874	1	1	2499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKpQFqVhhQCLjfXEMoJd3THuD2jUjQoRdDA7Jcfxywf3JCHXg
28223	payment	2134	2134	1874	1	1	2500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdp5SQbztjBgqA1DH3umw6Ue7DWJeweKx3LtkhnhdimKMpezm
28224	payment	1726	1726	2235	1	1	8244	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZob5gV8h8NxHTrN3LpJLCboenx8EjDbS6Lp2Cz2m2LbAYindQF
28225	payment	1701	1701	922	1	1	10	1641315957416	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZxtfSEfiSbRURUwqm9v2v6dfu8zinzLafQPN3uBW5CxBEKVze7
28226	payment	2133	2133	1874	1	1	2061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEBdMnMzxARoBns7JLmktLrkEnePFoDRnKZjg52XoNHHZafFn
28232	payment	2134	2134	1874	1	1	2501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oyRC1StdYvGGjTVTVSEGry2WLvBtZp3gQCDtCBj8hjG84bi5
28239	delegation	623	623	1460	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe9XB3VUELVKYWCRtXTAhFGctrNeR37L2C3w6qtL51DekfwzE
28240	payment	1397	1397	1678	1	1	11654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWTZod33itTpfG4mCjrfEaewsKdnmxkyy4kiEyyYThDDvL192
28241	payment	2133	2133	1874	1	1	2064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5wsYf644hqbnmtGseUNfvGb9ThtMdWvKumPyZtKKmCFd2fDn4
28242	payment	2134	2134	1874	1	1	2503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxGsmh1ZeV9nWZE871CMSUiUWgmyWkmwCUVXMDJHxsPb11zJXx
28256	payment	1397	1397	1678	1	1	11658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYff7fXV13Gfopvij5y7TYzSVNtFQft9TfX4jzM4ijBohk44NRE
28257	payment	2233	2233	2203	1	1	4	20000000	10000000	\N	E4Ycxyrg1Uc15DhdNW58GnVuLNTxC8XbJnZ2EbMfTWWw69PLv7iYi	CkpZ86oPXPYAEZw69VZGcBVtaFtkcSJUnU1y2pgu1hLwsMa2QUbFC
28258	payment	2134	2134	1874	1	1	2507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZAVfWjpV7Gah8Lst8WoVpU3HD7VRzNuB5KgFkVJUFCTZjAfVN
28259	payment	2133	2133	1874	1	1	2068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCWjKP64ncoWAvT7phJ1CiVBtM8RAoHPYKNJ5NxzdLQuLFq4e8
28260	payment	1727	1727	1274	1	1	10	7548200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTswLmCMr7QgJPUrD4tZdwuuJP4Pd4X9RaxwSdXtKEvzUqQsyL
28261	payment	1727	1727	1986	1	1	11	294100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqt8WRZctNH4MxZE5gpvjKUM891XZXiPMVKc7wiQUMjYhSv3b
28262	payment	2233	2233	2203	1	1	5	20000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjpGw7Q6BS1Quu1N8n3KtCvwaMLSejpLmf5rN3je16KeaVzsN
28263	payment	1397	1397	1678	1	1	11659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVc5N3QT4sSw7Loba1omaYkFNNrp9dBFbHAKvdhwSf4gz9SgoS
28264	payment	1397	1397	1678	1	1	11660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3JtDbk7zVfKaEKa62VCv5b1Ue19A34M8tyXHogrepEwjWSnNq
28265	payment	1397	1397	1678	1	1	11661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbd3ALfiuTRXxxc3d69xBfMHLPvWkcrRV9MtjDcPp2JLMGrbA6
28266	payment	1397	1397	1678	1	1	11662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuQBPH9F3RZtBMEta37XrTf5qEFQJggwpU3r5jMkLCEcoj49e
28267	payment	1397	1397	1678	1	1	11663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQF9stLvz3uxJQJ4K2kHB35Dyj7zSNEESXhYGu9ca6fYwg9Ckk
28268	payment	2132	2132	1874	1	1	714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiE7A94iJGEZMfJr5mrDw3JXcvV4QczPdpJhnLqULtzgLegGU
28269	payment	2134	2134	1874	1	1	2508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZTRRcczNcKFsMZuCcvsqq9taVb49SShNTrMxKqfx6PeMgVSK
28270	payment	2132	2132	1874	1	1	715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGTARhzKzr18QtxcMB8KFWvcrc8XYynfncYUSy35ZWwzipeCm
28271	payment	2133	2133	1874	1	1	2069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdR85TgJaadMFyriW3VQBzeHaq3Vhoa6DNdKCPaEtd8jC8rWVF
28272	payment	2133	2133	1874	1	1	2070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHNA5dQjGJTJDACv9bmJZ84Zyf1NXUumT8QnKE9WAuocrDg7d
28273	payment	2133	2133	1874	1	1	2071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVT7617CHKfhvc8DqG127UWzcECA7QiMNTJFBt8amMzHkRprQ
28274	payment	2133	2133	1874	1	1	2072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfctCLTo76P8ZFYvnA3FKxVBp4P2w43o9x4yKVR2LKsmdx6CRJ
28275	payment	2133	2133	1874	1	1	2073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuSHArw7AMwZcix523zcY1Wz2BnHDZnjbiA6Kcb4VkUVUfw1M
28236	payment	1726	1726	2236	1	1	8245	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYeWQxdSwRc94zrcjECpikG8yLsVt9WZU55SDiMv7LhJvr6ELV
28237	payment	1701	1701	1162	1	1	12	1984502530497	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpZys7xDEz72nV3xMhJdwpw986C676B4Jk6ortULxDu8LTqQRLjR
28238	payment	1701	1701	1288	1	1	13	5529992753376	1000000	\N	E4Yq9w37nd5CMkkFmMM4ncRQHP8Zet3aiMWp5xPszW3ofj5We5AYT	CkpYnq3knXYGfu7Z4Vr2F5jH3AxWnaf62h3f6oVHG5qKy3wqKt5q8
28280	payment	1397	1397	1678	1	1	11664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXtg3dKkkLZKMhoJ3F9dAK9FSfPW3whpMsnARD4i5U9S8XHvd
28281	payment	2133	2133	1874	1	1	2074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3YioqqnimpWH39pbUcWVYN1uU34vSveHszg3i7x59d8V7og4
28282	payment	2134	2134	1874	1	1	2513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnySPJCWVTcAweeErUQoqRgomXrDucwFU3gwi6rQvQpW9qTgL
28294	payment	1397	1397	1678	1	1	11668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxietbHt7MQGqS4QsaUBDY8fYGkzd9NLbwAtF76MA46DbFyvcx
28295	payment	2133	2133	1874	1	1	2078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMZGYaGXJu99xQr8uBP58ysqYgNtiqFAWqrUGUqHZUa5oq77k
28296	payment	2134	2134	1874	1	1	2516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TN9MeRTkhrbnic3HdmYBWgRsqEXWn8LUvXG4DCTaBDW9yjaZ
28304	payment	1397	1397	1678	1	1	11671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzNkPybQwPQqKj5FHaU71fmBv9CnD976tiMpWCjNqWXAxYqCY
28305	payment	2133	2133	1874	1	1	2081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39U3x44dFMUthQtkAPNfGdbcqVkBMKXBzXRhowX8ErQrcUWNZ
28306	payment	2134	2134	1874	1	1	2519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdu4xXrQHCYzHHYY5NaUuktUC9ThPT8BicZenWe4j848JQUcAS
28307	payment	1397	1397	1678	1	1	11672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABbhdywxwNMnxiRKoVR1XSDqtp41Nn9jpJqxYYDMgCzPyo5XM
28308	payment	1397	1397	1678	1	1	11673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZcY3bQgcCLjyruNEXBxzmQctBvuKm1biqg6hkHAWFpZJ386T
28309	payment	2134	2134	1874	1	1	2520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRSZg1mWkLoRgR4NrHR4Wt292TadkP8JmT9oCQDTi4XHfxQHf
28310	payment	2134	2134	1874	1	1	2521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsWBcx1rQM9X7LTyTx35u67oEz9H7g6DahDorbBbsEv4ioLEt
28311	payment	2132	2132	1874	1	1	718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zvrUzXBCd7RZXbCBFZ8Upk9YcE1TjJ9DnZpG4fSJkCW9VLe2
28312	payment	2133	2133	1874	1	1	2082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFN7WhmbTjNAehExkxoMHeZ6mPhZjEMpUgCEkUBFqPBg8Z1Lre
28313	payment	2133	2133	1874	1	1	2083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxDEB634nj1LSuxLXCUHcUaDMosbXBFEnQThShvxKLe8aneZV
28320	payment	1397	1397	1678	1	1	11676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDZ5wmMrMVUuX7rciJiSzwZ7n3GG5xvJYQxzZEHpgHsZjN2xa
28321	payment	1397	1397	1678	1	1	11677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHg4RuqZBciSxyRi5DEgkku95HNRETktCoqKQh4FU2rrYw5Gt
28322	payment	2132	2132	1874	1	1	719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuMfSn9EVY3HuUAxSeFLrLjRU3oGCerXqnRy6R1t6oRLZp3Xx
28323	payment	2133	2133	1874	1	1	2086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxErkLdZ4g7CbB3JzBpzyJcRcMfs78X1n3L1cNnbw78VimUxhc
28324	payment	2133	2133	1874	1	1	2087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVBJKFne9Vc5pa7cgZ2LZ9etMbmcD8y4e9LzB5UnyYtCLcdK4
28325	payment	2134	2134	1874	1	1	2524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2igPT5iEpeZ1FjPHBEpy3aMTboaBQvGyEYbiGA7wETa6aqbEC
28326	payment	2134	2134	1874	1	1	2525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQyWRskH4koza5Q3idVdVHMyFqJvt5smzaD2rwPHoc3FRPUuC
28338	payment	1397	1397	1678	1	1	11680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KuawSjzCcF1wAo92CWGhQS7mMYWQ3r5hEAEEA17oaP9z8hxQ
28339	payment	2233	2233	2203	1	1	6	30000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdygRFFhPvjw7C2UyicEr3c8inKdr4bBPwUKmmqDVj5xY6AUqg
28340	payment	2133	2133	1874	1	1	2090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqazqEoMtcjUsy552YU327s4VnPsJKn1qXC9FTMiL7UKrVySj8
28341	payment	2134	2134	1874	1	1	2528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHpdV7JK7U7ifhWG5VaPT9pTouDSRhoQi1Utnpyp8VjQNHvrt
28353	payment	1397	1397	1678	1	1	11684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQk6Dt7k3REY9DQ2zfmUPwSd9QbmgcTYSkubxYBvsdgVQevqus
28354	payment	2133	2133	1874	1	1	2094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjLi2kx9DTc39DruMMZ8hqHEwkcxVfqqtizUSAv55J8cKtXXC
28355	payment	2134	2134	1874	1	1	2532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoXtU8ifc1VkS82RmMu5yoMKaPLRNdySoGgUb3X3k46P9h5mQ
28366	payment	1455	1455	2011	1	1	5	576000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGB8pqMQdyDX171htLwCgnstspq4AZ86LRQzqTd474nw4Sfdvt
28367	payment	1397	1397	1678	1	1	11688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSj97C82HMyKGRHXSNfjZGPXUoSzuw32849tzWvWRwZFGswMS9
28368	payment	2133	2133	1874	1	1	2098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2RRbH5KxRzezFK6NdhpzyF642WeYi1CAmsDJTwhS7vzhJEoj
28369	payment	2134	2134	1874	1	1	2536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7fc6q5Zy82Ka1eBjUve8mqA9XiCZUX8qQ7DzSLzhd8nafz9mH
28388	payment	1397	1397	1678	1	1	11693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoapwStMLymr9dTdBFuRRL7W6tgUz1GraMY3nk6eVqZ2micfm5
28255	payment	2133	2133	1874	1	1	2067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BodeZmxQpvsFnkNrawc3sbcNwMEp1SfhAHAHdoFrdixyNngt
28283	payment	1397	1397	1678	1	1	11665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAEMKqhmyBa5uwqQnoUk91FR96gwgbxR5dJtr2kuL2ftnJay8
28284	payment	2133	2133	1874	1	1	2075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqUdzEcXY8LpDBxNZVsDGWS8DQvPeUJv8wsbTC138WwVUBm4d
28285	payment	2134	2134	1874	1	1	2514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiGZyJrZg6BLrtWrriDGVnYa3YE9wuhNZJy6PKEphDkt3DvX7
28290	payment	1727	1727	1274	1	1	10	7548200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PNrK4fwqPWU6fDV7SfBjXVXTCaP4orTDvcp7cjRJ7GjEzXYy
28291	payment	1727	1727	1986	1	1	11	294100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYm5KesxHmXSkVtApJ4iX22ZZN9qYJggXTPZrv4YD9zTc6qN2V
28316	payment	2134	2134	1874	1	1	2522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFUUYhzwxmHWEP3ecFFwsBjWyAZKW3PwtdKfi1JBUjbVQGYxF
28342	payment	1397	1397	1678	1	1	11681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCbcFwxfWs6qQPKv98YeU9kBCWWwzzp7cbCLPYJ9mKbAe3Lnn
28343	payment	2133	2133	1874	1	1	2091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzwR9WqASApnwjPWT1aJviTPfehawx9seqBt1YePJdy6BK3jT
28344	payment	1727	1727	2237	1	1	12	2101058999999	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9h5wLmygZHDtDnWj1jrRpjFz38t1Qsk3WwjDk7jNfbsi5JYi7
28345	payment	2134	2134	1874	1	1	2529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAta6Atx5m2P4MVz9gVWVXtkcoYCLkQu6Rt7DwJFGXy3NgEP3E
28370	payment	1455	1455	966	1	1	6	1485000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLezKu7hYpN7fozkUShGqaCrtpN9iPXxuwrSdJAuTmwGfUM8vA
28371	payment	1455	1455	1086	1	1	7	2661000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2s1GzJ32HCMsnm9MT693aY7SEkEfEiEpwCwdAzAXoLRULvsh
28372	payment	1397	1397	1678	1	1	11689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLH1qZUPB9ktzxHWy5VaYssGCGRSC7PMczv2DnCPiHB3TpV23
28373	payment	2134	2134	1874	1	1	2537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTvdmwjGZq1vGwNnRbju2bGHpcRGVzQAy6ABKTDrqGkte2HwK
28374	payment	2132	2132	1874	1	1	723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCLzJVSYRVRBAK4qPeAc52UFmg6eE9Pah5nWu7GA7sPvMmNSk
28375	payment	2133	2133	1874	1	1	2099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxxZW91SeFshBoAGxbHhnhAtxdi7KieKtrNuFUgzygRtKrZLG
28383	payment	1643	1643	1299	1	1	21	938043477500	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTM99vhazNCubWVYjQVv4moZmfFs9VBYPhLx4pqF9BBL3C95na
28384	payment	1397	1397	1678	1	1	11692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8iPFVtpPPfkV3yqWnbLezbzhGof6gGy1mPePwg7MALR8A9qPD
28385	payment	2134	2134	1874	1	1	2540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MMmsJLvqj4rDjsnwi5YPuUUsnczdegvPmoVbmWjPi2ThLiAF
28386	payment	2133	2133	1874	1	1	2102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuvka4meLroSb5UicSNRDCtnTKuMFbFPPP54F7ae5y2xeG8pJ
28387	payment	2132	2132	1874	1	1	724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM76Vp594Tj4C916xXcrfkwW33Z5bK1eSohmrYnMVSUMc8zVhG
28405	payment	2133	2133	1874	1	1	2107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFV4QPTwcdz2QQgFm8or29DfmT4krmwpEEMiYJBWBpCrRZVbN
28413	payment	1397	1397	1678	1	1	11699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLCVGruZYXLGxgH4FpMaZZSkz5bDhrixEd6g7PcWiPzgKmeYU6
28414	payment	2134	2134	1874	1	1	2547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRD74EwvNxMXBqdBKEujpP5MgEwwAvX1cVkJxfAuR66Z7pd4Ys
28415	payment	2133	2133	1874	1	1	2110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUmtCko7nRMaZQFihi47Wd9mjQsezV8YgA1C2JF3tMH8uDJg2
28416	payment	1397	1397	1678	1	1	11700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTk4SA2vYannWtDRzbCXkm9r8Jeca3FmXTAaK1Bk1M8yJiW84g
28417	payment	2133	2133	1874	1	1	2111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQhq9LBNw26nTtGirV5CDhdhWXa1zFdEQ29SuR8FV6m7e8Rt9
28418	payment	2134	2134	1874	1	1	2548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFTwTitGVTcj17wHrYbX85bLp3jszN1xEq6P7bAKWPXPsKsvS
28438	payment	1397	1397	1678	1	1	11707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXJJgmwmVm42GQ7JKCoSQkCty9zeczNjF7vhfGLwAFYx44HGt
28439	payment	1397	1397	1678	1	1	11708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeime63D71An8CGmadGTdst2Vp528WHDVZEZkWuRpYZ1oMygDS
28440	payment	2133	2133	1874	1	1	2117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrgfhBY4VahdykXphM47Y9qbEjE1oYhGhK1z83XYW8rK6sWr8
28441	payment	2134	2134	1874	1	1	2555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzrWaAspXFwWqXkpVz8tnrSpaw6K9kQ7ScXP91s6gMH2LKfjc
28442	payment	2134	2134	1874	1	1	2556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVncVkBQpRvaJSfnwVa7jLfFGWB27ekaMWhKLKjjgQsDjDsXv
28443	payment	2133	2133	1874	1	1	2118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDaKedGLtGKN6L6JDCLokATF84XGBnvA5BBZezpdbpzGADgUP
28444	payment	2132	2132	1874	1	1	729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuc4RToSxQBAMyQgNAiS2fZSML6zy3E7gmYZajg3HvgT75Q6c
28445	payment	1397	1397	1678	1	1	11709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCbsjebKZLBJuJ83JMZU7eQmMAQ8dErhNcQaw87xxrC51oHLN
28446	payment	1397	1397	1678	1	1	11710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLG5Pcre24HgotKgRuhbrtDwKPH3qQ2WSkJp7Utcy5rrgMBXct
28276	payment	2134	2134	1874	1	1	2509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgtissBjjpMfNHauTFVDG1PbkrQ61qdJzHQ8Xync6kNSUHimF
28277	payment	2134	2134	1874	1	1	2510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvFtng6ESyvg47XLUqCJgTDgZmBo7AzCXV6MLJZQdZNvCJxyC
28278	payment	2134	2134	1874	1	1	2511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMGUtZ4H4aw5ZTsHAfRBmGQtnehkHP9PJysqCmNcJvK5gYyXP
28279	payment	2134	2134	1874	1	1	2512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTyGfCppDWCDjeLusHpMsiHzqBtvemqCUJ6vqQy8gGwB2ycod
28292	payment	1397	1397	1678	1	1	11667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWs6JY5Rm5g8pqaJtupahCh5Gs6en4S9CgxsTkg9Ra8VVbux8
28293	payment	2133	2133	1874	1	1	2077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZed11fd44yvGZMKombtth6TaCRS3pPM3tGgXnSoBhyKRQqJDJx
28317	payment	1397	1397	1678	1	1	11675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nmz2NJZYHpfUhSnMCv467SXvtUcd1mru7h9LMC9xUCEjWQM2
28318	payment	2134	2134	1874	1	1	2523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwKfmQLZDs1DUoP9Gyxn9zmUbjCkdS8V1o7t41iGFeksPKE6Z
28319	payment	2133	2133	1874	1	1	2085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYS5nq1LkKCNpx4ftW5Ame6Lamkaf1Wg26uPLYGNucuSLLEsnP
28356	payment	1397	1397	1678	1	1	11685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVKBnBGuS77jbEjBp99Te9664nheLV9Rt3ZN3oGGiyS8b67Pz
28357	payment	1397	1397	1678	1	1	11686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJbh2NcekVSBJEKAJMkwEDJMsxwvoARMcVyBSyy37L3jsQQR1
28358	payment	1397	1397	1678	1	1	11687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9GSw4jmXCG5ne7UNCyz3QzxnSQhNSxp6gq8NU7VHMwymUdcg
28359	payment	2132	2132	1874	1	1	722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzdiSDCPKJSyL6BR4LFMmUx5gzn4f7qGUgyS6QBviXEF7Pf9pc
28360	payment	2134	2134	1874	1	1	2533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dN6XYXH98rtgkhBNzz69yFVH2Li9jZb1k6ECPK6PMeVtrPyz
28361	payment	2134	2134	1874	1	1	2534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFx7gq6y29rWowd3yQsrb92881YjhUEDc2o8VTVzLG9GdfwNT
28362	payment	2134	2134	1874	1	1	2535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaruF7nnRNkWBZh4xLMMvuPAo5syXdiecJdAZZA82HrNnhTmD
28363	payment	2133	2133	1874	1	1	2095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPz63c3uxGRq1nyTZ8oNK6jZARyDpUdA4LK2koMTCCTLn1MPJV
28364	payment	2133	2133	1874	1	1	2096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEV2SN57HGkxApu7vXsNyEWv2aBx2zPAw8hS8LQvtkVURhUdh
28365	payment	2133	2133	1874	1	1	2097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6U1cK58irYk8E8rqwxqxVjmLhyuSMKs4cLbtj7xupZ9EtTCLS
28419	payment	1397	1397	1678	1	1	11701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7X2o3yTmPSWHPpsAzmbTnFaXm5rYihJQYJBoX829Ao8TPNtTt
28420	payment	2134	2134	1874	1	1	2549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWBjkL9a8xQ2ZBboFsRhyjRVoXrzdU51FsrNhV44Bs8ddFf86k
28421	payment	2132	2132	1874	1	1	727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurgpMEfnu3bVPSPRpdwWHFPuKsk51ytAAxm2qzt2uqEd59Eiv
28422	payment	2133	2133	1874	1	1	2112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5zRJNuY9oLwgk1cxDmBXGHNyDLuBvSFUDMwES7VNANb9P2js
28423	payment	1397	1397	1678	1	1	11702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKu9jVShf59hefHqjeM3LacfBL8SV9FdTSv5uDJ8W4mS7JtQjf
28424	payment	2134	2134	1874	1	1	2550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4B3igmsuRqqKtpkonmdCd5RDRP89NdxDshS72zcfXxF3Tzbx
28428	payment	1397	1397	1678	1	1	11704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtF7TkNr8kAsXLBHva3mJiQhxM1BRBHuxFN2LPr3zra6K36mr7
28429	payment	1397	1397	1678	1	1	11705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapsAYrwagqxQ6nFvNdGXpQBCU7tKPLYe3WN3B7JNESvvpKvE9
28430	payment	2134	2134	1874	1	1	2552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMdqcnD72W1bM5gCA6sL5ybghHNXidifjc5jeQPXLDZMqqveD
28431	payment	2132	2132	1874	1	1	728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFopsLF1ZDoTDzhCXQNV5WkbB7zTU3BmZVf11noVC5S389WNc9
28432	payment	2134	2134	1874	1	1	2553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnLSrsADRbTYsWrWwtWRLyf2oQVzz46S1JCpmnaJgMN1wJ5FH
28433	payment	2133	2133	1874	1	1	2114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vtZs8XbTeL9LFRcbdWUEdUvXFK5bfDZo71ePdk6ACieAsDYk
28434	payment	2133	2133	1874	1	1	2115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57e352w7FTczxsy7c2iBH7f3HHPTgXmXHzRFtjtQFwZDKDzoC
28489	payment	1397	1397	1678	1	1	11721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRMph8vana1XoweA7a1LVp2Zpnv636X9DfA7ZojBjrPsCSDMH
28490	payment	2134	2134	1874	1	1	2569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6piwLNtrTGk9x4RFxFVBRfJ3ovpFtSMaoA5k4s1edUYNGYNj
28491	payment	2132	2132	1874	1	1	733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDHZU3pcBx5WSM9MY6SsgR6FVzQ68vhPmP1PjzCT3DkRiQEfr
28492	payment	2133	2133	1874	1	1	2131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2f2NWjxXHnXkZD9VUgtefQQxXRyuzwtE4w9skNRNf59KdbzPW
28493	payment	1397	1397	1678	1	1	11722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Qtpxjo7A83RnfDYdcNGXzPnEQ6oocNKRiRFKkSZBTyUYodvP
28494	payment	2134	2134	1874	1	1	2570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13TQCNHqfadLKvKmFMeog26KzRNMnrpHgrvfPoja4B69YhVmE
28297	payment	1397	1397	1678	1	1	11669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fZ66cs4C68FKqTghf7jz44AjoeujVVETNC8CcixXwd7XYnwS
28298	payment	1397	1397	1678	1	1	11670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHAAfqPBqRb3ANh7yKePeQqMiXcJqZHzVy3p6awnsqxGwyGsb
28299	payment	2132	2132	1874	1	1	717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJy8pFXdg6aS93MhVjTVhej5KDLHgqvwPqULuhaKyYec2YLZq6
28300	payment	2133	2133	1874	1	1	2079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69zShv9K2WGS9xGQbQN3WRGLsNbzDx6eKmpnMNQdBYs8LzoRL
28301	payment	2133	2133	1874	1	1	2080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFu8fDT11NLLt4US1eoVrbjZCaQ6MNAYf6TQjmCD8zFLWeLfn
28302	payment	2134	2134	1874	1	1	2517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FFVzH5wAZSwxjohh3nDbocEHsNfrkyEuRQbm1DkAo92jpo5q
28303	payment	2134	2134	1874	1	1	2518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKzqsGgqqC9JbRFuqG1uWTYuoHVSqQQvtAc2rRQTicZy7cQi7
28314	payment	1397	1397	1678	1	1	11674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9LWBJFWts2idznrojTetQ8nG6VpEUGwiLPc86yHD8xXDhq8vf
28315	payment	2133	2133	1874	1	1	2084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrn577c71spUE2UTByZFJQNrtmvUgNgKQtzURQ667Ph15BAaE
28327	payment	1397	1397	1678	1	1	11678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqprDSy6cHjhHdGTopJk1XofiiLKxTM8ViXZJ7q29iNuxZ7Ez
28328	payment	1711	1711	1001	1	1	9	2553500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpZBWnTxPNzqAXFiu4J4AXWnUSX6rceno44GqqpKfpZKSTszeppW
28329	payment	1711	1711	1241	1	1	10	3087500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpYva4gQAkCdk8jD4XKsH9oCs1o4YMDgtH2U4BACW3svmW1mmqgg
28330	payment	1711	1711	1121	1	1	11	4575500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpZTNYJqBWrSeRDaChjPnJRi1yPtc11KMefQMEcvAW1gd8YbjeuV
28331	payment	1397	1397	1678	1	1	11679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41tVSYip4KdkRqZFzWaUCZtqnR1E1jGuaKt9BLGRuCqAWCc4h
28332	payment	1711	1711	1367	1	1	12	8602500000000	10000000	\N	E4Z2hNPmvJ2uGBCmeWPj8VccQDYXXQ4aKdEfidsXoiqrnixfNrYRx	CkpaJ4WEeTAh8BC7arRNmmjdTQC5rm9SckzNeoJNmSKDw7F44eHNa
28333	payment	2133	2133	1874	1	1	2088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSNzCtPvpjB1jDVFefJg1VFBgmvFjEuK2m1XnKMrHChithMzh
28334	payment	2134	2134	1874	1	1	2526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyvsGtRhSVahLhN8bGVtyKSpnopXL9Aw2ZsyNW1Z81sNLaK19
28335	payment	2134	2134	1874	1	1	2527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmSqoWm8HWMWAgM8kz1LuZM8mkpYfA9WGYbFCLB9ba52hf2Ms
28336	payment	2133	2133	1874	1	1	2089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu88U9gUGV1BJtsgeWoYBV2JL51HGaChzzXTFP5yxCdd6Rk92m
28337	payment	2132	2132	1874	1	1	720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWcFqetgDUEHQSHZcU9yjSaFtDnyVBtzAeehThp26ayUANu2k
28346	payment	1397	1397	1678	1	1	11682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmLutoJT9n9cr7Qg3YFenpFESvZK9SEzriUfMBzu6sHLVX2LX
28347	payment	1397	1397	1678	1	1	11683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DZDRCywPTA4FnbAVcZzs1bQQwEroJdhfQpPmpdQuhawPxgLy
28348	payment	2134	2134	1874	1	1	2530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTt4wcTKcXb9Z1ncdrR8HYqe3oj7GeuHJsLmtVjosnSFeUNgXN
28349	payment	2134	2134	1874	1	1	2531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQzwPewBX3PkM88SzGQjqgDofixM2yf5j5eYVnenmoFeK2pWi
28350	payment	2133	2133	1874	1	1	2092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzW9iLzWexptUy2crhAJ52gKA4ZR8SmNRGChVJ3w4YA7b4j5SL
28351	payment	2133	2133	1874	1	1	2093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWt3SxwbfyckMFPkrq92dobd1xTgufhVdnCexNdXWXqMwMrC4
28352	payment	2132	2132	1874	1	1	721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27CmiAH1WqWnEA8yymhGZ6kSnyqFkymiJnieeCWpAXkRxie8f
28376	payment	1455	1455	1206	1	1	8	1796000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8WV9A3q4qC5BUyQUgCmBC1J9cqyCQu8Gg1gMFNCnhMRM288V
28377	payment	1397	1397	1678	1	1	11690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnCEmPBpCqxALEE2SKMo2Mc89vkf7PZXXfMx1BX2mxoq7uTrP
28378	payment	2133	2133	1874	1	1	2100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3ThuMUVZtXnuatjVeudymKh9CGwYqRnvuLAJJpC7CYzqFuPn
28379	payment	2134	2134	1874	1	1	2538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Qi4pupQrBKSjM3Q3jwZXBrHeRTcCHQVJi2knLM4TVGMTgc12
28380	payment	1397	1397	1678	1	1	11691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Tsx7NGTsj4tiFXGWpuU7F2h9VyWsYkXU3L7E3cj71j4HCYx3
28381	payment	2134	2134	1874	1	1	2539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3fLswP4h7fNdPLa3BcA4BwpMojFtooGGyJ2YgkxwD73XEHJ4
28382	payment	2133	2133	1874	1	1	2101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTL1YNEM5J1uTDtA3pHVQdRvcaow137rmZ1tPQXroGTBvUzdw
28393	payment	1643	1643	933	1	1	24	278413697300	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNWqPBt7r311LPzxoBaUkijfbBarwevpF7Q7STt6oRp8Kxovu
28394	payment	1397	1397	1678	1	1	11694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF31L6zqMcLC4D4aby3pMwzffgfcHevazqnxhF3eX9pYEHPfUF
28395	payment	1397	1397	1678	1	1	11695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPop5XotkTPeJbiWKenAnm793J8YVzGFVnrYUbYb5BBSsi9vwi
28396	payment	2134	2134	1874	1	1	2542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qpZQ6P7ptJuggnCaEQJ1Rq5TpBpsZKQGBcjNVN5vizvsKc2S
28389	payment	1643	1643	1053	1	1	22	498914960100	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpedELfz5UwFn36eh53X79e97MchVurfZEEtpk9XkdMf9aWwxu
28390	payment	1643	1643	1173	1	1	23	336627865100	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKs1fX6kWp4EwRnMACBgp7NTuNWsSJQsKVuyy1KSKfFsmnTjo
28391	payment	2133	2133	1874	1	1	2103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5A5fH3zUbQAqGPHdAz6GoP9bpPQpyTnWDVrfrDC4f6mYyPC3H
28392	payment	2134	2134	1874	1	1	2541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuVVEDr3VyvUoPcsXMAWqHk6ykqsWYYJAMPR4P9WZfq7HFD9Y
28400	payment	1397	1397	1678	1	1	11696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tnMt5wn9E9g2h3fDx2nGje8oVudc6RpcZfFueHp9mnLfaX9N
28401	payment	2133	2133	1874	1	1	2106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYas7RzUjvYP3X7tcPxTpi4WG8AARMT4dP71YhUgkvdKsWDJnbA
28402	payment	2132	2132	1874	1	1	725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNv3zDiUJ17izRJnPpFtv3cBE8pwZKPDnmTrPWyAuENnyLVCxm
28403	payment	2134	2134	1874	1	1	2544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNWC5wn8dA5CJng2c7qsAz5P2rh27EHNJuwhRvsxfxRszuYdu
28425	payment	1397	1397	1678	1	1	11703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19BMsWvDVWyTjbUiMsxqJriWnc5e7pmUPtA9ZzXQAtDMYZtke
28426	payment	2133	2133	1874	1	1	2113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLZpwjay56eo6PaAY3zvNRGY9THZBA1gvuP2CvKLpL3W9GpHy
28427	payment	2134	2134	1874	1	1	2551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSKNiwjX1ro5cE8vJZiZwAzn1EoCobrzSzguUJvzht3pt62BE
28496	payment	1397	1397	1678	1	1	11723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsaFrfmMD9oNZFCCx8izZb9fYs8w2XhHU4KfQEZt4eWWMABjT6
28497	payment	2133	2133	1874	1	1	2133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXiqgLpT3T2hAPfon9xbnEwDXipNbyYQX8BSG67Q5QJztv3Cc
28498	payment	2134	2134	1874	1	1	2571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLByvPdf8EC5zQ7JtuyzdgbjabR3eqjJ2ovkrNBGM79jNigP4Q
28499	payment	1397	1397	1678	1	1	11724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjTqgnmcq9ifkxQSchKz8C9sBXTVwSGR4ifoMKoaW2HkkMEWq
28500	payment	2134	2134	1874	1	1	2572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRpQbqY6tvgYjt1jNdNuQDSEfpBFuimwaLR3is95oDVSPRvLa
28501	payment	2133	2133	1874	1	1	2134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqd9LMS7VJ6yghzU34KxRiRfSNyrTPat8cLT4Kh9Mg1EF38NZt
28506	payment	1397	1397	1678	1	1	11726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5r5kYXRUu3wmy1ZZYKpjQokUxqKEXjdshteHhVd2uXvdaeFH
28507	payment	1397	1397	1678	1	1	11727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJGEd4ETsDUfbq8dLm2HVE45EmKwMeSx6i2zWxJwwasTQukbu
28508	payment	2133	2133	1874	1	1	2136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cVDRh3L3MbWzijR8TF8yamcPu66bRLKxHUthjesUdGXRw5oA
28509	payment	2133	2133	1874	1	1	2137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiS2VkPzvcAUA6j9zXJ1YigA5igD4JFSJv5DMBCKCK54vLTUet
28510	payment	2134	2134	1874	1	1	2574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUyzRmu4NepDvnRUwR1oWFveawY8Z5mz7vvKWAC8HBdH3Jn1z
28511	payment	2134	2134	1874	1	1	2575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHsSYowYwJs5hBRNpYphDp8FrBkbQyhmKBtdbrxaJ4DPmFSeW
28550	payment	2134	2134	1874	1	1	2586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTK51mnnKSyEbcEy2rVR5ju3sfxCN3C5iTze6qHkPkqfJNXg4o
28551	delegation	2119	2119	1406	1	1	1	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpYkwmKVeC2jLvoE79JAACPdVdRqfxm7QpRDT1eKjR9wjk1n44tZ
28552	payment	2133	2133	1874	1	1	2149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqoExgshUTEmGQ3JxBsFd8PxnDsMwQSCEqYoSmKj3QbnWdBsM
28553	payment	1397	1397	1678	1	1	11739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh47zi17qnH4a9brSKJqwPr51Cr6iTtP9SPwRYR938zqBShjg4
28610	payment	1397	1397	1678	1	1	11752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVykyvWZZLrZLQiywvMKZRzyRLMJEywDsx898ARXpQJJbtpAjb
28611	payment	2134	2134	1874	1	1	2599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHATP5oTQJfktTjoDBQUBv8o3dKr9DWGofUcbhyeBu38aqm4G
28612	payment	1716	1716	1070	1	1	5	4411700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq6v85uywHCB2NGKmCPB7Piw89kcE9qgdYuqzFgPRhNc3cynZK
28613	payment	1716	1716	1190	1	1	6	2976700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGf5Q5E8cpBRjSHHyKt6vfwdBMbRNJ4zT9SV19rGtGEnUiAYcH
28614	payment	1716	1716	1316	1	1	7	8294700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqKN1F2WMUcJyCqrQ7CxhVJCAp5WFbUasMW65hS7i1yiRftZU
28615	payment	2133	2133	1874	1	1	2163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYcVwLVFuhaRVcUtDfyp3tZrE4esTFVmb9u2hEXprB1C9DVtv
28627	payment	1397	1397	1678	1	1	11756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6BDFDLvwB3z1H7An7aqBR2aZi18BbKXk2mmzTvc9mD7kA99w
28628	payment	1726	1726	2240	1	1	8246	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYs4CtKbgoLg89QD9ivmiHm4q85ZzEUGMTydLejCWFwG2DaDZA1
28629	payment	2133	2133	1874	1	1	2167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpyoDA3md3iWQ97RgmMDetiULXUMdwU4WoAmKqJCPwa737Fr1
28630	payment	2134	2134	1874	1	1	2603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYm5JVLjD7j9Yits8tW96qYLrrJfSYybn1U2uEAGh6nHPoTsxD
28650	payment	1397	1397	1678	1	1	11760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5VTTfSy7pHgBzM33vvhb7HTEUNedo5YYdD8uBezFkyCdZUqqH
28397	payment	2134	2134	1874	1	1	2543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZ6dYBB9mCkaM3yZFyfMRCSoiJbmrpu7q3Ka8FYA1g9LuhVuu
28398	payment	2133	2133	1874	1	1	2104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLM6Sa53u9oH6qN239uevyQh4ZgeheRtj95TySnrhExtrqafh
28399	payment	2133	2133	1874	1	1	2105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWdL2FbWA64p3CtnYh9bLUiVot63jjCjoFiVygusyAM3Nk8kR
28404	payment	1455	1455	1332	1	1	9	5004000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiX7mXD1w8gkH1A4NUDBVHmG4q1FYovZEqj8HFAXBXEg6TfSbF
28406	payment	1397	1397	1678	1	1	11697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbEZcjDw137yTnm7aC2UgtLs7zDwHXvgnFa7shU39kvuw6wbP
28407	payment	2133	2133	1874	1	1	2108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKuJNNvyCugNseUgifF3vbzdqzqZb1XQCnsdzWFJvighNwmRB
28408	payment	2134	2134	1874	1	1	2545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxPyriuNMttNLUGXodP5b23MjS5CK6F2EaD4aKQQkcxsG9MJ2
28409	payment	1397	1397	1678	1	1	11698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LFNk7BSJ5MXY2otxjCQmub6RigmhDHhydNLNdLLoAASJ3UX2
28410	payment	2134	2134	1874	1	1	2546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxcfdkHj2H1AdNcKhUKnMWnx63hU1futLfAwrzPcPNz6wrCgP
28411	payment	2132	2132	1874	1	1	726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUJVtEee2zMKSDk4ixrk6uJ4JRBB4npmVRS5ktjAmnXSBPwax
28412	payment	2133	2133	1874	1	1	2109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNejGq41QspzgAncwZfnpBGscfKLF6tJ9rWZQeSPq6vWyFXCH
28435	payment	1397	1397	1678	1	1	11706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpAKnBupCSjqM9YJ84qH5WKVEPodeEpA8woFGTVTjk7WMnBwb
28436	payment	2134	2134	1874	1	1	2554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWd4QbFTF7S1uYptMqqnfFW61xjaUiLqyrpvwWgVyBZqJ6TtqE
28437	payment	2133	2133	1874	1	1	2116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwEPaTRgW9gWTiAyJBdzB5BpWxBusvkzDiNCZZJn4NkJEqGJ6
28502	payment	1397	1397	1678	1	1	11725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xMkxJwWRPFFrcbVog57uR1VS9QECLWAZ6A1fGf2MYpGxrFqa
28503	payment	2134	2134	1874	1	1	2573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRW8fqh56cmcyiWuNtvGNF6m2UYvd7iuhE9j7bzWMz4JXFHtjb
28504	payment	2133	2133	1874	1	1	2135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuk3pKTNLBWaF9HGRg9yNygLh6zHzkeSAuaHtNTA1bx14S4FNd
28505	payment	2132	2132	1874	1	1	734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAp7U1vYAQPJL8pVPFtKQzRpaiGBZ2u5XR7hmKBrE7bidmzQ1q
28512	payment	1397	1397	1678	1	1	11728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnBqqnpRZNJjERfhPZ41ybe8TFK5kErBPqfkv8rKZpEJeRJHh
28513	payment	1397	1397	1678	1	1	11729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX216mUHMtZZJrJ5LxJnyJax5jwEaYQTC3TTn1yTsxQYvPX8Cd
28514	payment	2132	2132	1874	1	1	735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58BmXNxkD6FwZs4HVmoKC1fyA5gW7rsiijcPDJCMZ74EFgfV7
28515	payment	2134	2134	1874	1	1	2576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwENHPUT3dteg5D5nSugfJEu9fuFLhSwHJdLRKLtXbmotygQaF
28516	payment	2133	2133	1874	1	1	2138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfXcdxFUuWMD4CWCtu28hRtXrTDdqq5a5whMMpnoKRh2Vjdws
28517	payment	2133	2133	1874	1	1	2139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXkPn4QuSmF7TuhkZTaQc6a57cnjCQiVgSscUWeo8VV8tMRM6x
28518	payment	2134	2134	1874	1	1	2577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDHxquQeZmUmR5xNcxSemPqk86HqFjdftEtP96BtyGWhQKZuv
28538	payment	1397	1397	1678	1	1	11736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgWCthcYyji1qsdNNypXjzhiCDkphUEKX3Yk3USE58DqwepWaU
28539	payment	1397	1397	1678	1	1	11737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpU7ntSWyjZ1JbbgXJrFXYWo349FwYWZ7G4LXGyKTVMmZh6sV
28540	payment	2133	2133	1874	1	1	2146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyc3pG8vTSZbLZfuDne67PzhzNrHwNjqbptEfR9T7MXxajmbt
28541	payment	2134	2134	1874	1	1	2583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEus3fxQeK9wjSkQUAqiaSEse8m99rrjiVJTVKFRkHi3pH3yTn
28542	payment	2134	2134	1874	1	1	2584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6Mufjh3XxJx547J7JzWmcWZPdhkJLz2r8KeQjWxwynYrvKJG
28543	payment	2133	2133	1874	1	1	2147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDN2bzHRzyzo1E5DqzrsM1RJm6hb88DgYWPzdMWogUpne33wS3
28557	payment	1397	1397	1678	1	1	11740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZMKeBcunDdNbbKa5p1wuY8jvy62bASYgFTMqTVqzuVAwAMAT
28558	payment	606	606	2238	1	1	13	1000000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQA8u4GYye3ZfPHcZGWscVb58Pqn4AFniPexzWNcxeF92oXRj2
28559	payment	2133	2133	1874	1	1	2151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPD3j3ghXNPHa4dJUJMNzoCV1nzuiZDMTbyYKmX4KajjcP9Sy
28560	payment	2134	2134	1874	1	1	2588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BippQqNb6RRXnJjN3Nf7JFQR5jf9UeScTYSTszRmsjxgiYXt
28561	payment	2132	2132	1874	1	1	739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKesoxPTBbcKgQuMA1875Gkwz1qRK3eQeK8yEgKM4NKstLKAVB
28619	payment	1397	1397	1678	1	1	11754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqBJz5HeaFodk9YnGfLXj7SXDWvu3RnSLnREFh85a64Xx7qpB
28620	payment	2132	2132	1874	1	1	743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd4hFo817LrhpV5QMg8msSdsP76ZaBZrvTL7HhXjPFJB1WAS9C
28447	payment	1571	1571	38	1	1	36	47944808776	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZoCtYU8mC3aiq4d898t2JyTYeqMLvwirsTZR51sS9W59QRsCTf
28448	payment	1571	1571	969	1	1	37	364722301792	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYi7Ah1wo5WRmjaGxbZGBounDuVCgPPqTd7utKuUtHiYhDzAGqH
28449	payment	1397	1397	1678	1	1	11711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXKheAipzGVkAnqxx1vDtNwwxtp1fEmriFqNjmWinHzqQtujA
28450	payment	1571	1571	1089	1	1	38	653579239872	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa5XsC5HBEYyqn5pnSzJneob5h7AgiiEuXS6RT5Fvbw87j7YmKc
28451	payment	1571	1571	1209	1	1	39	440982936628	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZMvuKW3sVuZvVt8bcfjuJg67fPTukwhJVVT8bMiPwt2pedgfwo
28452	payment	1571	1571	1335	1	1	40	1228838162928	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaHrJgfJswn8tEJ4Y1S6T7gW3fyHKYSQVbcd4iQgVj4Cj9h6Jai
28453	payment	2133	2133	1874	1	1	2119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4n8JL8nCHPgf9kfkFM16PshRbznyYCgeaGMcJHcEtLdTEfYNU
28454	payment	2134	2134	1874	1	1	2557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9m4pXzXQ9u7HDkk8dHCukFpFjKDdJjBtvGVMgf2EiM5qESAo
28455	payment	2134	2134	1874	1	1	2558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2j5uneNmm5sfuiZpvjvG9wMWyhXHNbUknQpsNcSMbQYYzqHy
28456	payment	2134	2134	1874	1	1	2559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ887fWJ6YBwXytbMsp3H3SGjYut8yFo1iKDYQepugYShWxYaAD
28457	payment	2132	2132	1874	1	1	730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYJciAjSbfgnjYdREE8bDpTrxWiLtbRWyyo32giFjpsD7dcWJ
28458	payment	2133	2133	1874	1	1	2120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEBimf5QdGGUfGRy3Q3teKn3rGHwoUuYW1ZN6TcGUFV1tjM7J
28459	payment	2133	2133	1874	1	1	2121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhDrVbagYRsW9vaBcYHcnzLnERUdPUkNdxS6co5mwakrp8TNm
28460	payment	1397	1397	1678	1	1	11712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLxkAYhXtYQ6Lb2RMWS1G16VMq8Si3iHKrCbco2J1pYDbnm5s
28461	payment	2133	2133	1874	1	1	2122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5892S1VpztTB5mSaTpZiDRKEFMd3ThPgSrZpQdAwfJurpGXnp
28462	payment	2134	2134	1874	1	1	2560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNrjzGPrtkAeePxaAYnBAknT8svwvBZ3cTCaS4ceGEkvht28R
28463	payment	1397	1397	1678	1	1	11713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXy5bZRtFahV8Du4i2wA1y84tJiWYRp2xXByrFrGHtzyTwjeoP
28464	payment	1397	1397	1678	1	1	11714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHYSDaEZ3kxUTrDKjNgQFaDU2SSF5pRwgowBoxdKfyCB8MCuq
28465	payment	1397	1397	1678	1	1	11715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rw7Q6juS9ENsqe7zCViC3oPgvMNnLcD12twJsgQmmF3fjbAT
28466	payment	2132	2132	1874	1	1	731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhuS6UMnu1t6txbd2LUHRYYyWokyMmgsR3WrkdirzvCDxEavb
28467	payment	2133	2133	1874	1	1	2123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvGgKCF4xk2DQR1Fj8tQrPQhgvA2mu32stRofkEMK1gGEcbaL
28468	payment	2133	2133	1874	1	1	2124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsMXu6dCDjYD2RAaPVNvsfG8dmnKkxHxPQZYdGjqFpFMdDzMJy
28469	payment	2133	2133	1874	1	1	2125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd29ySDezyFeVGDJWBWTTpwmkuiAhXt9aQYxZBw6h6VrL3G4ZC
28470	payment	2134	2134	1874	1	1	2561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwvK29uDjR6aju6ZL5M371K8cThKWLLyB3vRqaS7bM4pXN83H
28471	payment	2134	2134	1874	1	1	2562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNoNamtGcwF1FKKE9YqcPxJgMefJEENFRLhAX2Vn4EuEnVouA
28472	payment	2134	2134	1874	1	1	2563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8RKAL8CnvDoc8RaUZbTvZo15aaUJpm4j7upV5sRv4322jLTLQ
28473	payment	1397	1397	1678	1	1	11716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTDRoevmRaERQkSziUQEMnMkn5yPKwqw2WuU4vaLhJ9SL7kBC
28474	payment	1397	1397	1678	1	1	11717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHy9TFBb5GWV8xjpM5HUvL5xvrW2VTaqxD6YrRVE8YgrFX7huJ
28475	payment	1397	1397	1678	1	1	11718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTybg7pGjAmFvk3SPMphLHjZvyFbSLFiEuLJRqoYyFRce6NkkT
28476	payment	1397	1397	1678	1	1	11719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfkCqbKuFLhUrWJLtqz4XBpvbDQwejcDaLqoxYiLfX6QpGNEM
28477	payment	2133	2133	1874	1	1	2126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGi8RAvC4WUvHqfEUdTWFEVKiuCm6AjMQV8xQoNWPDeAxrPDo
28478	payment	2134	2134	1874	1	1	2564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdT8DzmZvEyHEkG4iVaXrovsTb2LK3nYrdodhfnUac6A3yE9Dx
28479	payment	2134	2134	1874	1	1	2565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4PbqZaKME3ugyPsDewteBRYFQNktmf5nXAH8Mha7TGeVXs9S
28480	payment	2134	2134	1874	1	1	2566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNR71UJaGduRoJUpAAkSRz4EFUt6xXBmDSLZVKnHRg2v1zaJT
28481	payment	2134	2134	1874	1	1	2567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5byq7MbjJZLy9TBaJspKrYQSYoVC8Dh8Zy292S7J5KoTGfavJ
28482	payment	2133	2133	1874	1	1	2127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKcgJdj6PVrnnTqHtztDDxrKMTXCRxgBu6TTYyGF61t1RvvVN
28483	payment	2133	2133	1874	1	1	2128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxUKyGkdk6mNHobCQpffMXTNQdBbAtCQgX9msUGUPVeS8787S
28484	payment	2133	2133	1874	1	1	2129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVB6ajoQjV91VyUTaM1318CEEnHMt7xqHj8EhU6vop6vB6yBMc
28485	payment	2132	2132	1874	1	1	732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNndhckbca67rSKNCHDLjXWPdJMUnyu8mDnAPfMaTe3fi2Ncg
28486	payment	1397	1397	1678	1	1	11720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegHHx1LStAyKg7arTrW6ozN6TXRUM7yQiRgkL7ctkHV13EcHr
28487	payment	2134	2134	1874	1	1	2568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwg7nWsmrYQXcDgumJQSivdhjJ9T9K5Zj6ioH3Vgdb3fYFDE1h
28488	payment	2133	2133	1874	1	1	2130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVftTZRWeQWFLvMNEKZ8sZVzUYS8aqutrYZt47BKMbsr91wup
28522	payment	1397	1397	1678	1	1	11731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzZAAFFo3GfCjKe93mFssqBN1sN44rzihbAawcVvgCnzspDa3
28523	payment	1397	1397	1678	1	1	11732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FVFEBxjYYKY97hnAXJr1i2wLzN1EaAjurjCtrbMxZkkxn22g
28524	payment	2133	2133	1874	1	1	2141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFCKd1tKkvUaWeqxAhJcHWeonoVG34MBeGDkPpv3KfGA6hP6t
28525	payment	2132	2132	1874	1	1	736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGVzeZcoacSnM8xctmi4fXX4vzY2GtkQsFhiAGSyy3vSgojHp
28526	payment	2134	2134	1874	1	1	2579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzHvQYEVxbwndszH7mWt6iDdBB8Ky5STLBUnzishmL2xjYXHA
28527	payment	2134	2134	1874	1	1	2580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVWWCifgP8h5BXxcMVdv9QUii5j3g4re7aYgFoeKtT2oatj3Z
28528	payment	2133	2133	1874	1	1	2142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWUfLh5qYUnEnPeompoUAMd7gvxVCw1dbtyUP2FR32exfZcYX
28529	payment	1397	1397	1678	1	1	11733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmwZzEPQcaD7ni3H3VjoesKPpj8QhdF1BL1B1RX4c6hpMJnKc
28530	payment	1397	1397	1678	1	1	11734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89vcJ7S7W8ot88BQ31WF35Lha4QXSk2zC21QwikD9XZxZfTew
28531	payment	1397	1397	1678	1	1	11735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkVdi1C8ueqaRcECkW1mqnszs6DEmw48C6GpBfRwX8LR3bEm5
28532	payment	2132	2132	1874	1	1	737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbgraLe3iadDkYyBCjJoMeL1bVDQMHvPkchqQShu82awWfkJ7
28533	payment	2134	2134	1874	1	1	2581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1khHwBPRmwPUo5FYkzMq8zvKMLj3W5ev3WBo4P46QrrgCqbT
28534	payment	2134	2134	1874	1	1	2582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPyNDUtyTcQtx4N4kRokNUftrgdao7rDZp9usk7epwDzc6GyBS
28535	payment	2133	2133	1874	1	1	2143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7WNQkeUXwrmaGX39gFYhpLeoBE1U4kBF4hutd7yx2gRZ5916
28536	payment	2133	2133	1874	1	1	2144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4qzbgfXULQzzW9vrDWEhwb5xbynAVZs5QCK4m5BXTqCBFNW4
28537	payment	2133	2133	1874	1	1	2145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7ooGywBvzC76KUzuCCUnQKNd58GE3obSSji5sjeBQd3uubJg
28554	payment	2133	2133	1874	1	1	2150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3wFAjbLU2GmAvw4PArcAgrwid7Y9pkxJLrT5phM83xpvax1F
28555	payment	2238	2238	606	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3RqJZ5otf2stCBLvG9gPKZ2xm7zYDvC13GRxVLDQ3kN4YTHg
28556	payment	2134	2134	1874	1	1	2587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa997sNzxLokzDJL6PmZ6tYkD4F3VS5KS3SYZj9HHWt2ASjYANf
28580	payment	1670	1670	1036	1	1	7	5157000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4K1yhYrPgeoZ6QQ3jM9xRkVL2yZSCXwDXLfnaVKfuGH5D8HCx
28581	payment	1594	1594	1985	1	1	5	1103000000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpYUGmHNMAjqiaDtNG4NaD5km9uyNfWoC2VKdZJL1DUZtKwnbuo9
28582	payment	1397	1397	1678	1	1	11746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJYh9iZobdyfGwisPNRaJWX8YkkvE78Bm8o4cSBB7a9Zp2WKY
28583	payment	2134	2134	1874	1	1	2594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotfrgzELVEsb7Qz95T5ABe27PaEHMNRgiLDa5SfzDy7PmidSY
28584	payment	2133	2133	1874	1	1	2157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6srynHsw5dSRZXn5EXGSsX6a5TMExSQmusBLUszRPPRa85iD
28585	payment	1670	1670	1156	1	1	8	3480000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1b1CbBjgGB3kcBudRn66tbv4RGpNQLTb1asxifLeNzYtu8Hy
28586	payment	1397	1397	1678	1	1	11747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXSBudtubxwjCVFqbdFrhnVQf3hpJ1xaWf1VRSGuNuvA6FjWL
28587	payment	2134	2134	1874	1	1	2595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjLRr36j2SEZj5VQexD3PF6iwFUMnqpYAVCYYGAqwceHBVoyd
28588	payment	2133	2133	1874	1	1	2158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuoVa838dWzaK73Wwcwt4utB9YbpTC9RqDYMhsemxZnQtqohj
28589	payment	2132	2132	1874	1	1	741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLVk6XeyS9inUmz5LWjEoFvFUSchF4RhpftQ4cmw2ASvB9FCy
28616	payment	1397	1397	1678	1	1	11753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJvXXxVJc7ovNrtaEXE6kTmRAhaqTR8wF3WhuHXSf2nqPhdfg
28617	payment	2134	2134	1874	1	1	2600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnWS6bVUWVWxXNUH5sdYAfYF87cVw1GxmpRg3V3eb7G3A76Bb
28618	payment	2133	2133	1874	1	1	2164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HJG9UWnL21PWb1xmVQ8z8fXw6Z9aYm2HdxNB4YjH73ERgRv6
28654	payment	1397	1397	1678	1	1	11761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3sB3bpyobBUSEVMzvDx3oDwyXHcYH5ZR5amU35PLbSdGt5oa
28655	payment	2133	2133	1874	1	1	2172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwy45fC1Kf2xcp9idaNcmJVbx52JvxitZyxuskqwLqWGVykZu
28495	payment	2133	2133	1874	1	1	2132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPCxxqMVdDniQxwokXagREASNo49dcbLEsfxHGvWxe5XRn45h
28519	payment	1397	1397	1678	1	1	11730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9PR5z9tHEAQgd6qj16s3zusJ8bqqP5LfoUzAdVAMJxCsMmAS
28520	payment	2134	2134	1874	1	1	2578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3Lt2AB9Ng77uBadoDrkwyTfsSYnY8Gv7Dop4SYhKHa3YUQmo
28521	payment	2133	2133	1874	1	1	2140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvxmpZMuZ51TYeG7AHek2mveLaMbdsHkuPrWekwwXUrEsjm8u
28544	payment	1397	1397	1678	1	1	11738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxPaVRLaV7QyC7KioGGSurqtjUYvDaSJoNZdtmZXvu7eUp2RM
28545	payment	606	606	2238	1	1	12	3000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBz91ccwsZbMet7qEeGC4qbMqvhhLva4BNjeuDzwT65VCbnKs
28546	payment	2134	2134	1874	1	1	2585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwytg6mZvhaLrPqDnKiwScxkpu3EPoJM4Utk9t7c2GuSGhrC4
28547	payment	1709	1709	1979	1	1	7	14400211999976	1000000	\N	E4YvmjpxdAWTfw4rxTCWcgVUSFrEooSJgByrHU9XwoM989GCRAVm7	CkpZM5TXmmPALtiA8opkQmqo2QZUZv1o5pEbVKnpy5uzwXffFa16g
28548	payment	2132	2132	1874	1	1	738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeN4Fdn2ypVfeF6RowWn8bzjbJCTMc4UkfbVBCWKQSJfNMVKV
28549	payment	2133	2133	1874	1	1	2148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2rTCLYgbdn6fi83ppt7aMzkCpgjK66BTfRM3S6qVJVPGqjA2
28562	payment	1397	1397	1678	1	1	11741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJTXHxoFmZ9zoSPs9pKR2QxS6KhbS4M47NBhtVzhPKawgUMPy
28563	payment	2133	2133	1874	1	1	2152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSsHJyecWySHmt6TKCtVU8e5TDJ57dtQ7M7XG7wuPPTETBdDrV
28564	payment	2134	2134	1874	1	1	2589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLw1cEqzfTmCbSz8cMxXxAwb5Cuf4vBTgis2EUtWjNtFvvZjt
28565	payment	1670	1670	1282	1	1	6	9695000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybhWq1gZv27ZaYoLpnYdLHjozWUzrktbbpCam22X45fC2bV7g
28566	payment	1397	1397	1678	1	1	11742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTKq3LTaPztHVTCpm9rniMy3XC96FNM8qbSfkNZd9kT9Lsxk2k
28567	payment	1397	1397	1678	1	1	11743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD13f2zKbmQeoTgmjQRsoUsWmPxyKbTGbtJemDptdDzGPCVFEB
28568	payment	1397	1397	1678	1	1	11744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjk4E7sBYUBPd4Wwjs6JWSiu2RsfMgaKx2mzcdbKPw8C2hQxm
28569	payment	2132	2132	1874	1	1	740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSDsz7JccCjx6ok5bMutPSz6MbiuZ1HJa24YhJjydT1WxJhnz
28570	delegation	2238	2238	606	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGoKJYDD1WazzZLLFVMmEdywfmwJeqmJgUPnACdxnQrLbRA8V
28571	payment	2134	2134	1874	1	1	2590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBqxz5gfk5aVj5pncxPdaQBrRZpfB3SP7f7H9oqPJyUnwr47Z
28572	payment	2133	2133	1874	1	1	2153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjTecG17BXVxmWogpSz3EPRYtxpZTS2f8BKM5Yd3yA4uYP5z9
28573	payment	2133	2133	1874	1	1	2154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCH9v8cJ6rsHdk4rekbD5mQVdFnuhowm8GgyxaKv7ejBLUxmWn
28574	payment	2133	2133	1874	1	1	2155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadfmbRv9TjRSetox4dDNFE9xPRPoX7CG2PGfaUNhAuyTJzqvo
28575	payment	2134	2134	1874	1	1	2591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKMk3HpnqmemczqJ1k2QYhFU6h9dWNLtpi9fF1PijMPUiFVGy
28576	payment	2134	2134	1874	1	1	2592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUifHGjGfHennbwFfo8BTN7XV4bU1BC1FNjc7xULfAa2E7y5vh
28577	payment	1397	1397	1678	1	1	11745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwAeVnDZiRhZxbXEt4JXSsExEw8bBXMXx7J7Jr7iY7xKTS8TL
28578	payment	2134	2134	1874	1	1	2593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLAtCZZdPLRdUUpktFoq7znTNmZUPofr89MYx1Gftqr5AFJpcp
28579	payment	2133	2133	1874	1	1	2156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2Qh9FnEPhd5t6EpiDAmXMNzYoLXn68Pvf5TJjk4yqZdCixF7
28590	payment	1397	1397	1678	1	1	11748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeymWjQ5nyYeocNn4723fxHcpQ38pEGxZr8bSDHYmy6YkgfpCs
28591	payment	1594	1594	1326	1	1	6	7680240000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpZTguoASPWmZJ551bo6JPHSJp3xSJZa1uCd4phTZ65xjGRGKABY
28592	payment	1594	1594	1200	1	1	7	2756150000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	Ckpa8eVAcbvZ8NqQjemMGjs31Afx9nPVGtaNzirBHu6WEc7qhuvXd
28593	payment	2134	2134	1874	1	1	2596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLkFKyPJVUbNWVbWjXiDarZLTizSy8aYBqXG8btK7xVxCzPyW
28594	payment	2133	2133	1874	1	1	2159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQ1zm9GTZPmWyg6W8swnZEqWkCqdLnEwKomj6amx6NMVkJiv8
28595	payment	1670	1670	916	1	1	9	2878000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj25YTxwosQUW32YCnsR1gXc51v1597TdPNdDm9xDof7PcjmSB
28596	payment	1594	1594	1080	1	1	8	4084880000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpYkrLaVS1A5qM19Lx2wGk6jSknGw8zqFnNqW9qpnrS3bivb44UZ
28597	payment	1397	1397	1678	1	1	11749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGNKqGGi1GZzSmaDXaDY27tQkix6HdtYaG6mXK5qNACnc9tpJ
28598	payment	2134	2134	1874	1	1	2597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHgA5Bc4ScFL41rmcgBSe77VpqBCt3RNBHjaENdLwnzYYTJ4i
28599	payment	2133	2133	1874	1	1	2160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirssxK2NtRXp1aSeWNdtJBGhj5YYhvSUfxTjoj5kHmmwjB3fm
28600	payment	1670	1670	1977	1	1	10	1110000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJAoxwpWSDKzDm2YM8XeBWzcyARaD4UmkwaydSTNSuaLSVq4E
28601	payment	1397	1397	1678	1	1	11750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PcuwrxXZuiCab6Dso7LjqiRfQxnFcdgdsgAQLF5AnRx6M1AF
28602	payment	1979	1979	1776	1	1	9	238757449881	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZWTey3ewkKNMh5FvbRF3MfYCmwLeJS5ZpArSuZ1VkxJpedsoHv
28603	payment	1594	1594	960	1	1	9	2279520000000	10000000	\N	E4YbQopM8tvDVdnG39WPRsFfBWppZtBwEozcEATgvabCz2xoTfUQo	CkpZeb5pXV9wihusNBLuoEH2nzeBXGKe5mPYU8PJ2NKL5Ps8YVzAS
28604	payment	1397	1397	1678	1	1	11751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDQGUT5jYLrBpSeacAL2PKPQTcVKdXi6a76zyv6F7owwU18fN
28605	payment	1716	1716	950	1	1	4	2461900000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jZeJwxixPEgX519UThohNYrubgysFu2Pb38Gzgs6rgKJd2qt
28606	payment	2134	2134	1874	1	1	2598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEZgjLDt8wv91RdupkNZsieMf9DLa9WVPBxt8e4Y3jWSYLWig
28607	payment	2132	2132	1874	1	1	742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5n373KhDtyX31W3Je3MwsnarsurLJGSRBMaSybNRF8oAU5HM
28608	payment	2133	2133	1874	1	1	2161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC57bmrkYy8VXzgDuvRDrpBqD1v7R4n9gQRbr7ftPaV6YYTrvK
28609	payment	2133	2133	1874	1	1	2162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwXqFTsdTerDnRZBEyNUVeAr6pTKEqsn5t2PWwkZVZeLZSpje
28641	payment	1979	1979	1776	1	1	10	36175371012	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZ7PAydKQS99FVcXQ6BqT1EBf5X7gmtfi6LYuoVwBcbpJjyWksF
28642	payment	1979	1979	931	1	1	11	1818817266997	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZqPmV3gbPJAtXb3ZaQNvcNupbFqK4hyVg6sJsZ5JuFAsZS8FKJ
28643	payment	1979	1979	1051	1	1	12	3259304959497	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZin4f468HBiBKEurkmGmhKDNGZdLKtVJpFReci6vrQNRRx6JKD
28644	payment	1979	1979	1171	1	1	13	2199118001210	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZ2Bgx7TkX4GbHATcfere8t4NoL2gEuezfuZ9EVLRKDxtnyjaAu
28645	payment	1979	1979	1297	1	1	14	6128037848523	10000000	\N	E4ZJEtGKo9Dkk1z9EPKohuULazxkZi79HgGyqsXZmYHAbPZnhovjN	CkpZ3p9mnaS7hSjGmABVn3GDA8D87aqsQ878DuoYpaw2rqZm8F8uM
28646	payment	1979	1979	1776	1	1	15	718941102856	10000000	\N	E4YrZixM92Xxfea6ZwvAF9pcWjs33DttyW6bhC1nxiGLqknyXSqMx	CkpZWLpWwhKn8quVv1nbCAAnssQKec4mXZPmKy2RpBRaR6K3vCaMu
28647	payment	1397	1397	1678	1	1	11759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiBfGHQfgbNzDhY89qXPFiVLY3GsDJkeooqEgrS3RuhhNAT46
28648	payment	2133	2133	1874	1	1	2170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFkZPuz6h4LndcY1TN7oeRjyiH6rhXGy99QPf5JspurgSfNAc
28649	payment	2134	2134	1874	1	1	2606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1wLrNNS5LaAv67NiPpSNGk3fVHfecc5hrqdrQ21UPmnLFofA
28673	payment	1455	1455	1332	1	1	9	5004000000000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4yuUxjnTBdrBBohKPuEsMzi1XyMba9QswgpAz2hcSFLEh7Mw
28674	payment	1397	1397	1678	1	1	11766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeboeYTmDcDJmdTv4RRibGRmeF5ABLDrqdWxw46ghY7wKc4e6
28675	payment	353	353	2213	1	1	2	650042116779	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZHBZEKwqFQiWKvgpRpVYdbwwP3adY3ha6QzxZgYCYGyg9rr6
28676	payment	2133	2133	1874	1	1	2178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9JrSpqKGx8Jd93YQUZjV9QWrFdpqQym5sQbzPMAULrcPeo75
28677	payment	2132	2132	1874	1	1	747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy88qzVF4Bb6WtzKvA4iPwgqJEZgRr8vX7QB9Z6zKNb1ssvDtr
28678	payment	1397	1397	1678	1	1	11767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjowmZVMLJ79xJ9Ximp64AMo5ctynHh8PBpWQtfcr1qExBM7nd
28679	payment	2133	2133	1874	1	1	2179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyw6qLni3tjtcxc2TAGLZ9v6WmoUNgjtYns6sUKsuie6e1nVp
28680	payment	2134	2134	1874	1	1	2614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrHacQ4RiASWCz6yEMUU8YqzJCkE6eFH8K6RZXyevcDaSpm8y
28698	payment	1397	1397	1678	1	1	11773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXC6GyWFDYkUMhGT3Qz6Lj7ku9eJVGyDK4dPXgh2g8Un5Uwh9i
28699	payment	2134	2134	1874	1	1	2620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSARkkUP8UxAmHRkZLLr7A1ChxYCFGy9vsSvbhtd4rGcNfJ85
28700	payment	2133	2133	1874	1	1	2185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkXjk9cEn5akQjXsW5G1fKkjLwx9KLnXXpbXkK3PsbHM9PYNw
28701	payment	2132	2132	1874	1	1	749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnwNV8r3iaTzoysxLTroTvq3fCTfFK4x5n2eFLbueXkoThN89r
28740	payment	1397	1397	1678	1	1	11777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5C151JhnGcqrWoT6PW2MfDw4DYZcnt1SqcNacyvsbbT626ZU
28741	delegation	2119	2119	1672	1	1	3	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZ6MFCNuneHNy1ZQDARgNjRLbs7hpWA64C6SrQbfxHdK2PwnyZC
28742	payment	2133	2133	1874	1	1	2189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE73CUJt7kwDMotWKz3rRGpVhEnCwfpmEXz9rBXsKaGUYieeb9
28743	payment	1397	1397	1678	1	1	11778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8N7nRPy5ZgxRM1TpSjEdhuU1m9jaD4ruaQP9yCzS36Jo7FDoA
28744	payment	2133	2133	1874	1	1	2190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZePLSDKeSMCdncazeiNfSF2b7FinK7BxtmUhLyEACUKDGe2x8
28745	payment	2134	2134	1874	1	1	2624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBv7GuhWVGg23XF9viz4FQyF7Bc2DFRft4DPcPniTzgp2N7mvW
28775	payment	1397	1397	1678	1	1	11786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTjDkAUDUgqdDcSzvUS6e1BEvEcS8cSiitHyaHBsshAvLY1Da
28621	payment	2134	2134	1874	1	1	2601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjkgKt4qqnK5KoH2bVD3GBmv4ZBCv3UJjZiq77QrrvoS1TTeX
28622	payment	2133	2133	1874	1	1	2165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwEuTBYzV3Zhq9M79Fz8YNQzX6E9Jf8hUufWHdp6w5hL7AhBZ
28623	payment	1397	1397	1678	1	1	11755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtB3sTRsgpt8AF7N8EF4d7JpbsgKrak1EaQcrmgQtpBszrWn7D
28624	payment	1716	1716	2239	1	1	8	2781956000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtgNtonNSHRNXyUemJvAMMPLxyb45nKaHjRwjAhzmTn616zCd
28625	payment	2133	2133	1874	1	1	2166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTWjTQ7QnUsBVTcwFq3gPpZkJZHVkN6KfjLNA8V1a7Kcma45R
28626	payment	2134	2134	1874	1	1	2602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DxAGgj5CgktWVqERbeUDzkreQdYKzUfmx295Gqpj1kzHfEwL
28631	payment	1397	1397	1678	1	1	11757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXncTvtwSfkQ8NczPQxM2CtoHhdhhnGXjAnW3XPJbRVB7jzD5R
28632	payment	1397	1397	1678	1	1	11758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Cc2L8kqKjW48KsfUAZySHwSZQgBQge7QwK2zvP3jqkRaSPkZ
28633	payment	1726	1726	2241	1	1	8247	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZDAWbX5LdMLZevEiy2KPDsuuFdxxyyLzUdpc8h1pRHAbJTgHXN
28634	payment	2133	2133	1874	1	1	2168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCc1hrXc5o2PZGbJf7QiXoD2fFipgEaYqJk4nvuTDG3e9idD3
28635	payment	2133	2133	1874	1	1	2169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzwDQttmj2U4b9tpAvyLZjMHVjtgci1bKH638NeGaQvSrQ1kq
28636	payment	2134	2134	1874	1	1	2604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrA8ThMj81HvvA2FvH5puVHtzjJxq59PNHQ8AHTnjWbGLCFsE
28637	payment	2134	2134	1874	1	1	2605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEuDM9DUv8EWx2KvjKFxwk9rAiQEors7KdrMPRe2Z4RDwcB8Y
28638	payment	2132	2132	1874	1	1	744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7mwq9ES8w33hFTQKyrUz1Pi1dKNTfukxhAKez5KmXQSmLmAW
28639	payment	1726	1726	2242	1	1	8248	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaH2bWezh7oZUwGyEvdWEhxpcfDtazHe8YDxcD6dKJNKCzknWcq
28640	payment	1726	1726	2243	1	1	8249	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvzaWE3GVuXjnJmMDQViWYGdgn2tWYyUGAuFaSpUMcGXBBKR4T
28659	payment	1397	1397	1678	1	1	11762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1RtM6Y9wHpmb9THwQD7p8yHVxBRTcFSACjj1EJVK1Txoixct
28660	payment	2133	2133	1874	1	1	2174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6CDrCvK83gW6k5K25Mkw1kQ3uuCnyvyhqqrGHkWKeK1Md2T7
28661	payment	2134	2134	1874	1	1	2610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHx99egsmbR2nEQQwNr53V2dxiMegyN3n1PhrLJ9etteDKmBP
28662	payment	1726	1726	2244	1	1	8250	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZgLgAyYifyhncT4qdR1D7vYSE17APuMJbBNG51CXYDCQE4opw9
28670	payment	1397	1397	1678	1	1	11765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMkkBiYwi3Zzoi792dujLCVAdg66P7AYV3bZ4SbU7WnqHczje
28671	payment	2133	2133	1874	1	1	2177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGLjCoeNPqfCH2dXgDpaqA41xF2uCy4CA2Nff2DZgT7BThK77
28672	payment	2134	2134	1874	1	1	2613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuC3beM5XwaREGSUmKJStuvsLZkf9RYiZEkWvAJm2oT2hA4WE
28684	payment	1397	1397	1678	1	1	11769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgV3t71Ff2Qdf6CfT7MNYDTBNqksfEkheG4udoqStUeLfVNfPa
28685	payment	2134	2134	1874	1	1	2616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamdqtJUgQSqLnu2U4rHnyxvQoQeXt7pAxrMUfM3UtyQr9WZTe
28686	delegation	2119	2119	1483	1	1	2	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZAvGg3hvmQah4YmrUC4r6u1WcMLwKq9bXjn4nijjK5v2JHNMit
28687	payment	2133	2133	1874	1	1	2181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8r5vJMtreND8Xi8Y4EUyS98bQos9NA6gYtgNnc1fhkMRSuFV
28702	payment	1397	1397	1678	1	1	11774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzRoHq5bQHyuZhRzL5oHpHmCYn8KSyUjivSUAD7oUWiLpygVxu
28703	payment	1694	1694	21	1	1	34	128580863891	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpaLAM35NqNBPcxpjfhVReLdXbV2o3BY9uwmNESBRyQTjvVbQy6m
28704	payment	1694	1694	52	1	1	35	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ28HMTSjrhGaUxmLah5XU6SbcQh1vZBJdXmnUATtuh3izFbaNq
28705	payment	1694	1694	57	1	1	36	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ2zm3ghFDoct13J3CdQWQZyvzwFt8AgJMGTCYd89SrmdAvkp7G
28706	payment	1694	1694	60	1	1	37	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYy1t5LFUG4F5CTqRjiF4qPpzgfPskPfNLsAeGAqwCM2ikS1wU9
28707	payment	1694	1694	61	1	1	38	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpaDEem4WsjL8ieCJzcsWcmn17iEHodrmKJHEU5ZdU3ZrFCZkzHB
28708	payment	1694	1694	67	1	1	39	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYjcqU81RBqeF8GY61kvBoSdoCc3diNLF1mKxXhGqoNdrYUyYX8
28709	payment	1694	1694	68	1	1	40	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa9tyjEvEWGLG8nVybwHSMqQYA1orNfu6UVvgYuxRENCP8qqy7L
28710	payment	1694	1694	73	1	1	41	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa8eXoYfxdTKrqh8ybRcEKLAtCJXKpB2scdSFeJEX9VLc94wcj7
28711	payment	1694	1694	81	1	1	42	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYQYfDLwuzA68VKCKnJBRuQrsyMcrGXpfhxFFx6KixXNb9kXLMy
28712	payment	1694	1694	129	1	1	43	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZhm8EPFL4G1dtD7opiEVQPoj2Lri6yansBybv8e6m6ZkinTUxz
28651	payment	2134	2134	1874	1	1	2607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdzhcxcQudpZTLdCj8VBeH3mSJdPYi1nkcwsXWCsrWTL1hTfR
28652	payment	2132	2132	1874	1	1	745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJ5R1zrNs2TPwnnR9aEHSzep7ATJHLik9eNVpma3EptVkoG9r
28653	payment	2133	2133	1874	1	1	2171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwR6DN4hkk9dBY3sheM7juPbeTBhtFAyWyTsXU3iLaNfPWsRLw
28667	payment	1397	1397	1678	1	1	11764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhuXCvjZYnH6Nnx9LkghGiRuCiXY5ChtYLfxDgN8D8BKBkDXLQ
28668	payment	2133	2133	1874	1	1	2176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUps56Z7aeu1VooVKPB8526jMTUgfHJKVeMZDLpMvjvL2VZjU
28669	payment	2134	2134	1874	1	1	2612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjeAfL1BokzHAKokRvXkVRazTUyN1PGP8rUmFz2bNDKawb2ni
28681	payment	1397	1397	1678	1	1	11768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ37ykuu2t7MUKEYFBiqkBdcwbYnWDbmM9SG9edkMtbi9s8jCK
28682	payment	2133	2133	1874	1	1	2180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN5VE7FDoD2fX8zAKyZdm3gZvn3v9p9JBLNVJL2fbrNcrJJqfX
28683	payment	2134	2134	1874	1	1	2615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYCP8QFLiCH56YFfADPNk18E1AHucBB1w5KrsGkmuX1t9Fipj
28736	payment	1397	1397	1678	1	1	11776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NubWRNpNsSEgZCAGmjVku4Rpbnrx3JosiczLCbiJW6PvJu9F
28737	payment	2132	2132	1874	1	1	750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMpCnkPdVPQGMs3CbAaCinBPfuLnA6AJRTYdSLmUSv7ryNJjM
28738	payment	2134	2134	1874	1	1	2623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpM4A2zMC9RvyBmJ1yMyTDU5LMKccsTq14GfWBtviJuf1AENP1
28739	payment	2133	2133	1874	1	1	2188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCj3JuVjsR2C9ejVkZyh9TFZEsCZxs9S1pCUEjYrtSbUTMfgEG
28789	payment	1397	1397	1678	1	1	11790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh3R5pFXbBFiTjLqRqiDs6Jr5ManvAA3qoeVcQX73TSLgvdDsY
28790	payment	2133	2133	1874	1	1	2202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDHfTX7QbNNxTgtRJDW5gHUfY3xpgNiGqVU7vRjLYDYuTJfDx
28791	payment	2134	2134	1874	1	1	2636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtmV18CPpAp98QB6kfXHeMj58hF4m2ymVVLc6DHWUFt2QYgrh
28887	payment	1587	1587	1357	1	1	7	11171270000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLeEsLCXrdEgVzEduDpYZ2bGReMQ1uG9CrFYz6LKL5ogybx3y
28888	payment	1397	1397	1678	1	1	11801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26Kor6gp4sxtN3WzMezXnCMEkzv72xJR6WTtrSRXS91zTKBmt
28889	payment	1587	1587	1111	1	1	8	5941640000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq2Ty8JSS1rcth4TVS68LoaG4GZiThuwYYRKcd8r14dgQbAnD
28890	payment	1587	1587	1231	1	1	9	4008940000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAezAkPcLC97meW6k9sW9xfHNr2K1BvLjZksgABjmM8qp9qhX
28891	payment	1587	1587	991	1	1	10	3315670000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1rM3gRuXM1LDjyZZY9HSs1kXRig2heEQcapigx8kuVbP8FHs
28892	payment	1587	1587	272	1	1	11	435250000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqQ3rZyJ9t3Rj4hhoQBDe6v64sqN1RqdZNEm7xE5gJJdAf4de
28893	payment	1587	1587	319	1	1	12	435250000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbbahRis62WkAz8mrkALziog8HapFXGBGMpAvYTppSj4prFeX
28894	payment	1684	1684	637	1	1	116	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa3LTwSio2qjWjThEg7pM4ZWgVAkTGayMTxPKpqM2exya3vYNW9
28895	payment	1684	1684	647	1	1	117	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa1iS4qHWiFbiWQpapeNC2SEMfsH3d5LLwwdSFpV645jCRbyctW
28896	payment	1684	1684	656	1	1	118	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZoM7nw3zkKKSZWkJ6G9xFc4iZGspEoKeztTj192n5XmaTi6cQs
28897	payment	1684	1684	664	1	1	119	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa8jdYpHLcjrdXwMyWRJtEiCHY7TGvHQAR2ju72VBU1Hjy54Rvt
28898	payment	1684	1684	666	1	1	120	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZE7tDYRvs27uUf1XmvXnZk9QxeZ8JU7L21YwYgUtbMwMpvs93x
28899	payment	1684	1684	670	1	1	121	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZydNqx9HCwk19xKfetLejqyGMvjBcY9EGQowF4NyLhgYUHH8Zu
28900	payment	1684	1684	673	1	1	122	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYx2CoAPmeUTfREMRLH5MtaGgffCUrp7QFWSbukDGzBBZwFVmAf
28901	payment	1684	1684	674	1	1	123	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZbC29r3TrYhUoSkya6oKSqmkrTEZD5x7gGEB7n2QtEJVEwFYtU
28902	payment	1684	1684	681	1	1	124	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZkVSppX6QsTxuLUf7qE6pQrMpGtYjckdjYTM4KbC6gAwoBN3tS
28903	payment	2132	2132	1874	1	1	754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6v1xkLczdDrCpCqV62DWwigtWf5378YdoxFaWsb4ycSB7HosU
28904	payment	2133	2133	1874	1	1	2212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVF6MPQc3BRCUQi7JLvYH6yNznWbYLoacZvQZCWfA2auVPzk4D
28905	payment	2134	2134	1874	1	1	2646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgra6XYpq8TW5fVvmxAfgjSnLrbCfLuiC4KeL3Cp4PbGJH89u9
28923	payment	1397	1397	1678	1	1	11804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eaXJZHT2dW8n2ejRgnoi3nCFmVQhmMx8bY5e4hQ57YKsD5Vs
28924	payment	2133	2133	1874	1	1	2215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcHVrYvueugu6BeUuXGThT66vNTExfvqQHxJgEShoZBQ5Xi75
28925	payment	2134	2134	1874	1	1	2649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSp2UbD9xpz4zjNmRA46W2RcsX54pVkvdHdGzi225Toec6dkF
28656	payment	2133	2133	1874	1	1	2173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4ZCgJX1hoSmff54ymiyJvFCemti7tGbz87ciJtG399tme9HT
28657	payment	2134	2134	1874	1	1	2608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxCEgpz3yrpJjvsyRKudhpXv6fY8AHJjWSqJpoWk971hK9LEP
28658	payment	2134	2134	1874	1	1	2609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYPpAas4rDhUCGiMFA5c5jN4oWR2uGowvgwwWdWR47MajpAHj
28663	payment	1397	1397	1678	1	1	11763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3T1uUaiNMAdDvjYbhreKSy3GbcG9m4P1oNNyyicgMPmfJ6sJX
28664	payment	2134	2134	1874	1	1	2611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULG2RsurUsFu9uPY5w7kjBHv1BdeYyknGajSx3aqtiEaoXWJ9
28665	payment	2133	2133	1874	1	1	2175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8moYuxXQa4XYKnmpJJVDCh73daGyq4gC6Z2ASmLRogfEkPtt
28666	payment	2132	2132	1874	1	1	746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAdBbD3NvZHBvzCg828eET4FQSgwfkNmmxK3ukLq9nym5Hf64
28688	payment	1397	1397	1678	1	1	11770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuS3Fon8J5WcnKyWKsBnMzdDuKasC7hRKQyKKXiYYrZoiugk3
28689	payment	1397	1397	1678	1	1	11771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSff1BavhC7NLmNZGjdbXzkUDEPei3qBVSA8AA2y1JqBJRN8KM
28690	payment	2133	2133	1874	1	1	2182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrhEqfd1Z9sTFeYURDQPwGvV3aCdvsiVDC7CstT5AGzK6e3tz
28691	payment	2133	2133	1874	1	1	2183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbKA3JSRemgY559yFKthLnRrmah9LVLK8urafrBipsFqfBVX79
28692	payment	2134	2134	1874	1	1	2617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcj1wVjPFoF8xiLhs2Yau4KbaYjWhC4W8sVk5xpMJEiXggmVrS
28693	payment	2134	2134	1874	1	1	2618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweHUJdQpw1yUzyiVYyU6SQYpCstwJbEYHLg1cMxHZBARX7A3N
28694	payment	2132	2132	1874	1	1	748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHz1o3qVsK7aqbwZEFindwp4o9oJHsz4icT6jCLPhUSBS5gNtL
28695	payment	1397	1397	1678	1	1	11772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUAScgApkZeViSu9WJzZSR3CF3jkTE7shmLpe1nn2xYXUjxGX
28696	payment	2134	2134	1874	1	1	2619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3nYsvc7rWPcmCcVdoJf35Ex9J2GMUPB3hrpJQJ7mmi2qbMqr
28697	payment	2133	2133	1874	1	1	2184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zTW5KsLTHdWLtA1orWce9XJgW31mBo8pxNW1byn2QCuA1dFm
28733	payment	1397	1397	1678	1	1	11775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhsePJoDNGcDcQN9ScbdMC5FBgghZmN1mRVtSWkH1bVpcwN7Aq
28734	payment	2134	2134	1874	1	1	2622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVTmK57phsSHCgGmJwnTAR1a6PGEeHxst16RMDAT8PsrBTc8P
28735	payment	2133	2133	1874	1	1	2187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA85HnYh6tFV7xdy7MXyxD91Ey3VExgVyyofpeRbQjhJ56HTy3
28786	payment	1397	1397	1678	1	1	11789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWQ7JxYdtcuLEJgvHKncr7KpDumto9s9YVondwiNP2qCR8PfB
28787	payment	2134	2134	1874	1	1	2635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BNAsjYd7UwU9881zPx9zBhFHv3LRnswuvKnSwh6dAEaihg9u
28788	payment	2133	2133	1874	1	1	2201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAJ3nF5Egpni8k4gkh5AiWsTk6FZJjjegfcs5B2fDAxnmu3Ma
28800	payment	1607	1607	242	1	1	11	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcViZZihKXGMqTXAGxHBRiG8VhoyTVsMchAEzKibbQqgjXGGX5
28801	payment	2112	2112	1222	1	1	0	2121135436180	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9mcoR2MipFjDvf3PbvqLKm2jCpzGZYpJXT7QdhsPjGtxqztf
28802	payment	2112	2112	982	1	1	1	1754320483721	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizhzriNo7B26MUPgJyCoVr1ZEdierY9oQF1nkwc2VkiMvQCDC
28803	payment	1397	1397	1678	1	1	11793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvMzjifKYNUGarTqHpSmWtdM3M1umVJbJGGns8HSwsMFYLohf
28804	payment	1607	1607	372	1	1	12	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4x2QVuT8uukmoyyWZNncyYj9jPAZC7ZoHQDJn6ucWPTyCerY
28805	payment	2134	2134	1874	1	1	2638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCbbW7NCDr3aaiLQNjgMiFot9TVVc9Pi9rj2TACpHUx6NWkFx
28806	payment	2133	2133	1874	1	1	2205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWJypi91tr6moag7Ntm1UpNjHE99W8qhZp7rCGwVVezcJcrqf
28807	payment	2112	2112	271	1	1	2	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiLzyBbpyNGVP5EZYAHZKSEuqaRBr5STQpR8oaXoNnk8B4NqV
28808	payment	2112	2112	269	1	1	3	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99F2SXp771XzGQQSuC9TEZrTrj77ae2oRPuJjAPHag3xvFMnv
28809	payment	2112	2112	577	1	1	4	239987370598	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvv4asNCNo64duUc9mTLQ5CchP9iESDMJvD36aHbygPrX5KaSZ
28810	payment	1397	1397	1678	1	1	11794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoFjHDjsLzZfP8jWijWpP9cBscGi6QoBz62jLonCY3xv5jMhv
28811	payment	2133	2133	1874	1	1	2206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmdrc4U8VSBv42Y3Gg9hH4Fr6qbhouCSyRhjFCbzYUdu3sWYp
28812	payment	1726	1726	2245	1	1	8251	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwFDvkG3dwpyf9Yd7o5yiX7acqstqzKH4Mzp5sdhx6rzUFAkMd
28813	payment	2134	2134	1874	1	1	2639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXWzTe1PjCWfFq9WoxVry8jzutLmEQC7ikMnyuxgddFn8yBR3
28834	delegation	271	271	271	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpwkbro1DLyzxmwYjH9rYbXiCig7t1urT3e61X8Ysj2zbFw7N
28713	payment	1694	1694	156	1	1	44	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZhPeqyH3JY5PndjSQeH7bEPCsBd8XsKHqagy4sKfUX2pEHD1Qt
28714	payment	1694	1694	164	1	1	45	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa7227zzYAxrnqzinhFDYBZmeZLRASim3TkGR6VvDSHfd16Ehsq
28715	payment	1694	1694	220	1	1	46	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ1q8Tnb7KjPX1e4EWZofkN6dKSMZUoqKRavp8Zz2PSSGzbyosC
28716	payment	1694	1694	222	1	1	47	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa67XbSvesS5vkzca19NtPHT8YPGLHkCzVqSwrv5MB9VSaaWdaR
28717	payment	1694	1694	256	1	1	48	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYv9aSTnPjzs9Z6gRajAyGXBeuTETh46trrP32Nk48pb6iKfKsX
28718	payment	1694	1694	371	1	1	49	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZmGeYV9rzLLsZuJZxHvxZ4w2CoBuDu13AxmyfhvpkdkBLACbAp
28719	payment	1694	1694	428	1	1	50	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZMcuZCsfRfLcyrB7P4B9Ey5GxwcK1ZoQ5eDUEbGNne74zUWaix
28720	payment	1694	1694	431	1	1	51	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa4nWmxAnb3nCcW5HPyhr87GRUiUunDyH6Uu8oqcTvQgm6oWgeS
28721	payment	1694	1694	432	1	1	52	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ26EYwYL1mhWNkNEvN35k245Aqe2RXZfKa1NdPX6js7j712Ro9
28722	payment	1694	1694	433	1	1	53	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZKCtTzmGuLwfqhXnit1skHGvrXEA4iFCNtCfVN9FZ5ogacFWUh
28723	payment	1694	1694	574	1	1	54	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYipnJBbiVEVJyjcWeu2D58kbB9wHjq7MYaoze3GqwQ9RhFX5tj
28724	payment	1694	1694	604	1	1	55	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	Ckpa3L8yMJASezHNv3M5wsAxByQmyaVmk6w34qrJVxbUne3RKWttf
28725	payment	1694	1694	628	1	1	56	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZS3r3Pxp6qSZxtRcjgCvKycor2P9DQDkV5rqC4xVvJ39fF6Qjr
28726	payment	1694	1694	638	1	1	57	260652896885	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZpCq1tsRrmdhhENzL5jvDHJ5EPQvD89MqVPfm5Ngqt2eHJVBSE
28727	payment	1694	1694	951	1	1	58	2028511623668	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpYiQSvdcoBtSuGnFd4hUxdsJXJ8Js1TAfGGboWNZa91Kt5eoKDV
28728	payment	1694	1694	1071	1	1	59	3634920777822	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZvByhMr9BNMDfJfwtRFCJyVuGaBRJx62hJn88Aq44ULoc62ry1
28729	payment	1694	1694	1191	1	1	60	2452616775776	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpZ26YRZoijCHZ6Gb1kkFcPT3YfApxzi2aAEv8crdso46375q3FH
28730	payment	1694	1694	1317	1	1	61	6834083260892	10000000	\N	E4Yvr9Hi66sASaDGw54ZXtjEbcK46xYGWDnEqD8ZRaiiNPt3pBcHJ	CkpaEEC8F1RkrNdckMY8smfHpmxgMGRsAxX5A8QJpjpkkkcVaPTVx
28731	payment	2134	2134	1874	1	1	2621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYcsEg2m3b92EAUQzqaX52SRzDMcQqPn46tjB9mhj4MFEgeyM
28732	payment	2133	2133	1874	1	1	2186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQNnVveKr87TomtxUXj3Tm3cwEvevKxQMfEerm7CMLWhoUhuu
28746	payment	1397	1397	1678	1	1	11779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhKRPXWF3T6qrcvBL3BitUhzX6rBAbNUgb8dGcySPxsUoy7nV
28747	payment	1397	1397	1678	1	1	11780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqd7ZtVVrXkSzPhnHBw2vdC1wzSN4cs51zq5ZpohcqomnpT94
28748	payment	1397	1397	1678	1	1	11781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMQJMTYkBiyrUb4ZzH6DLo47PesAVtpa5qNsEy6VezhCTTwYf
28749	payment	1397	1397	1678	1	1	11782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCrxWRDC65zXp8BigsgZ2Xi323DeevgJRmVR6dpPQZfdyXkK2
28750	payment	2133	2133	1874	1	1	2191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMZhqigctCkQ9ainAwVGe1SN9JXBRYrJxmwkES8TBo5S55tFB
28751	payment	2134	2134	1874	1	1	2625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZvp1Y57wD9cG2wkrj28ynVJmJXVF1gHzLmr7SfYbnCoTMgQJ
28752	payment	2134	2134	1874	1	1	2626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqe4RSvHHpYLEWWzDe3v8poNtfzcadGYdRx2Qbxv375VA3RKL
28753	payment	2134	2134	1874	1	1	2627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrsDtMEa3D2USdJWxejDoxuMFJD3t9Upfu6G9qS2sgKeySeRN
28754	payment	2134	2134	1874	1	1	2628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjuJvds4onLkCxTBnCRZ4MZy5vusrkmdpZVGht9tH229ZRz8v
28755	payment	2133	2133	1874	1	1	2192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9yo43ox2xERQyXJT5vQH67YGH8fDYQNYbVnAXZVHTJeAGVEY
28756	payment	2133	2133	1874	1	1	2193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNHCGZrtqkypMgcaseZZgad7cJhZ7pe6M3fgN9LYKQLyPAxpbT
28757	payment	167	167	1816	1	1	0	0	1000000	\N	E4YxcqkofrmGd6BUTHK1YjKa8sQmT2FXwcsSsK7w2tvdJBa2FGSLo	CkpZQaGY4qQXjoTi1vyMHX2UefsvncMnxAzh7EZnDAzEuEJoKp4e6
28758	payment	2133	2133	1874	1	1	2194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5Us6XWGXv7YFzeou58GuRWue3HpxFKMN5Cnbh6UAkocsNpia
28759	payment	2132	2132	1874	1	1	751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYsXDyp7jVcQY3oXKwrivgd4DgUUY6XkTjaUhAxCbgTXZHPT5
28760	payment	1397	1397	1678	1	1	11783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCuGFnEqWUMMhFu8KEevNXL7V5MgxXvcv5i8JFRhBjPxRG7jwo
28761	payment	1397	1397	1678	1	1	11784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtUEKgfkuGkzDeYtwYPSoTKzG1itcpvYDiXNaDh1Ez35cgp23
28762	payment	1397	1397	1678	1	1	11785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3E5GGFVD8xk2ZwZvtD14nHznJLSpD8X9JRb2HAC727mpDpcyW
28763	payment	1689	1689	909	1	1	7	1913777258517	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpYvB1wcTrnCeQEA1dkXr9T4dt8y9AohZA2s6WJcUBbJoYQLuYZH
28764	payment	2134	2134	1874	1	1	2629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ257spm3jSBhh55wFRuLmV6G7AhQFeq51U1caHUmo3LJohhGZW
28765	payment	2134	2134	1874	1	1	2630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5vUJXLUDtRG2wQacCgYYRvhz7wEqpahqhb5RjmRew4oGzBjh
28766	payment	1704	1704	581	1	1	1	318000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3a9PWLD9Pc11ZpD645XrWPXkVMXXZGdp7Uisxo7e2E8YENyQx
28767	payment	1704	1704	698	1	1	2	318000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkg53ta6G2GeKwNLw2FADwtzgND9tb5bfLLJoYisprEzKWYLvJ
28768	payment	2134	2134	1874	1	1	2631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJPJTmgfnqQpBec67bz72StFwRXdfK4HEthfY7rYi8M5RMwQd
28769	payment	1704	1704	742	1	1	3	25000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3qWnwRmtzser8biWYkj8S5WCdb6rfDAFnAkcSU75Yqsaj9UL
28770	payment	2133	2133	1874	1	1	2195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoSqZj8Jbm3cycxpTjss46drY2MMHDxPVu2w6pQp8N35cesdg
28771	payment	2133	2133	1874	1	1	2196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2vgiN8gfnbi3fnxkbMJXmFNzMRZv1ZGeXwxUyVazxqpYV7Gk
28772	payment	2133	2133	1874	1	1	2197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsDafCXXeSvgqjGGf9g5LC7nuCVqcPoaszmhgNrRgNLZYfVCD
28773	delegation	2119	2119	1672	1	1	4	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZpMFrJMgFHZ2pMeWeYnyLvgVVGJnR1yWZGcgyW61eKx8Lp9UuB
28774	payment	1689	1689	1029	1	1	8	3429472450019	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZs16p25qqMKURFrTeGSXS8SUCruqBCeACccpiN9Fxeq7XPQyLx
28795	payment	1607	1607	1102	1	1	10	3143727275810	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWgvDd1HfuonF5NiDsuwAho4T3WLQY5bdR6VjpN6prbUz2bxW
28796	payment	1397	1397	1678	1	1	11792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnS2iZDL3qhc6SdwHjn4jrEu8z2b8YtWSjKPgN5nJbcxWtm6MK
28797	payment	2134	2134	1874	1	1	2637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhPEBKpwe5N1TjXvB6vKqwHr6d63bEKtsLEJ85tdaCPQp7wt6
28798	payment	1689	1689	1984	1	1	11	1015330732316	1000000	\N	E4ZAGSXJ4SoaDoWgdpGBmRHywbkvHX1g7uZVVuPjcW6qorw5rPKCu	CkpYnbCSoHyUUhg9eBexrwLPq6HUwUKkkngdzBFzKvK4Mp3jJ7LCR
28799	payment	2133	2133	1874	1	1	2204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRjYk3QVWRvgcct3MCDhPpXj1SGj3Ld3ARLnABc1jWApWG4ypB
28822	payment	1684	1684	258	1	1	72	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZhQBF6sLWBGrbGTXmJJcma2rCYoVtvrYX9T1xe523T88dMAnc9
28823	payment	1684	1684	273	1	1	73	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ5HrRNKHLZgPdyorKHGJvfuo4TAEj6W1taNTgX9qLMntrb6ee3
28824	payment	2112	2112	2246	1	1	5	2603651968305	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRwiLxg6yjbD1mX9e4ijY81HeTYZxJ6coqNkj4u6JGHeJijyy
28825	payment	1397	1397	1678	1	1	11796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuc3QwosBib6mbxFfPW4S5p7MaTXxYY7L5QZRxpnveXKsAoy3p
28826	payment	1684	1684	292	1	1	74	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaFn6tPW8zbzrYqhLcV8j2pUBTAz2yXPXgKf6KNmqs9aW6DkGC6
28827	payment	1684	1684	293	1	1	75	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYXXYi87aVV2HomK8DsoBGQEgyEKQMGW3u5nzQQ52iY9YLEUCGa
28828	payment	1684	1684	333	1	1	76	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZQSrGNmVeK4u41quuW5BYqzKfttjiTZMimZHxRH5Lw9vvY9rB7
28829	payment	1684	1684	376	1	1	77	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ88QZDHp2Ax6qdzMK53dhTj46tciRwfn6h3k5vvrqU9xNoHAXJ
28830	payment	1684	1684	426	1	1	78	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYyWrxJ9NL5LYvsmcRWtKUZtvdU7AkAjae6SQs2gYdkRXkmZf3M
28831	payment	1684	1684	429	1	1	79	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa6LUdGkr2YbDcPjpphQayHFvUsSx9oTUU1UsKjQP5aJcr3DMvT
28832	payment	2134	2134	1874	1	1	2641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKxHpPgVFkqRsRJCAiHbavYjgHAP9b32dA7DQ72bnfuGbSS4G
28833	payment	2133	2133	1874	1	1	2208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHYxaC2gbBBuDbVmBM17ktRSZK5Wj7mS7exXniVfaBWKmRoLj
28874	delegation	1895	1895	1497	1	1	0	\N	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfAC4xM8PqJEXaQyvinBr2qMw6LRjNNiw4cCTSfnxUtiYRmJL
28875	payment	1684	1684	612	1	1	107	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZcV8x1JB8CAH1WsyGKCvWCtdDUQvCgRNgP93fLfEcet1erPCQd
28876	payment	1684	1684	615	1	1	108	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZUzevrMUvZm9f5WGr2hYJ6DEt9PJsiY6ou1Xw8ARaA3xcfBzzb
28877	payment	1684	1684	616	1	1	109	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZTQzQ5p3euvWvtsBetuEjnUHH82U447ZzJm17QpPM28SEFWjRn
28878	payment	1684	1684	617	1	1	110	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZZsK7RGcmcXQaRXH2feRfpQ1DyuhFvvATcx18t3TmCw6Nwq22o
28879	payment	1397	1397	1678	1	1	11800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxDns21Z5Tq94pioLzueM3GDhmTvfh13Rvqjwf5fWKtrhBcue
28880	payment	1684	1684	624	1	1	111	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaE2wXh6Qiv7fuchei6rhmay8m1t2PzRmkhKuLwsnxa1BZvRBvu
28881	payment	1684	1684	625	1	1	112	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZkahrWwiF9gYtFQJxkeJvw27yfFfAJ9Uw48G2EiPAjWkFqNhUM
28882	payment	1684	1684	626	1	1	113	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYzAkRkpPQHqMeuku1hWBcxsrMSfVeDQ1qz8SAy6RMjo2DDVL7A
28883	payment	1684	1684	627	1	1	114	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaBSUp9VPSH1oeC28nxXFv9KMUNej2Gv6jZLR1UiFmi8yvP4Tzm
28776	payment	2134	2134	1874	1	1	2632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShZBq21xhSMLoZudyDMDTnZkgpSsC9BkW6RKat7cAD3tPpxG3
28777	payment	2133	2133	1874	1	1	2198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYnwTRMKm37tp4ybAs5Lzg9QdpbcUVRbPxFLCnCNeHcHus91v
28778	payment	1397	1397	1678	1	1	11787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcC45g3Nd7WkLCaZ1uxf33BWJvip9SKwZAkkikFHpEtwnTNz7
28779	payment	1689	1689	1149	1	1	9	2313933399094	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpYictieUqn5ATcAfqcgTXzWUZNj1tXjnhVuQmJgJCfGEdbDBfe1
28780	payment	2134	2134	1874	1	1	2633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUysqAtNJBznJkPowDEd5A45Q9YUoMCAWbhPGDdNqbtgTQhtK
28781	payment	2133	2133	1874	1	1	2199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LXUacjpqLXtS9LavNwSDgWGDGtCRoCCo3QnftMCDz6NtHEbF
28782	payment	1397	1397	1678	1	1	11788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgcQuuUcL79KTj8hpTdA2PTYAq9n96EAuPEWmd8CUrkKHudQf
28783	payment	2134	2134	1874	1	1	2634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZTPQo2Rq3JBazUgxqhmMrrVWTpQw6t3LCGhwj3X5dpaER9ef
28784	payment	2133	2133	1874	1	1	2200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXPBtc1sjFnrQKTnfCKA8wJZF9MuPPdhj9BDKwgjYbQsxA4F5
28785	payment	1689	1689	1275	1	1	10	6447981160062	1000000	\N	E4Ypp6smaqrZf1q9ocYrekbiHUp2nXAXz4p4dtimPpfK4yqdCVUAh	CkpZrbxJeUtRaX3sRBMCz3jgerxdSL2jpiFBg3F56tGW2yCRLz9Pa
28792	payment	1397	1397	1678	1	1	11791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQK6suPguz3i2k8KwAT8cJNdFZkbHVmWw3m91eHDmaRaZqVrnM
28793	payment	1607	1607	1348	1	1	9	5910732493763	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtMpqgbpsgLiPLqJC584saPk8vp9wk4WMS6EMHfSgwSXr8jVP
28794	payment	2133	2133	1874	1	1	2203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvozh2fMCLzXE5UPWqbkqEGvV7bEfyGPgFWsPoLq4KQQsCs6A
28814	delegation	1981	1981	1981	1	1	1	\N	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMo11hpSzUDpo2LACguJgBXJzFwMRgvtSF8AoTsANxDTbSzmH
28815	payment	1607	1607	2246	1	1	13	83779133619	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4KiK9gwneY4M66w7WpCPCugxzF4at6Gu23AbaqxtkoY9pa6rL
28816	payment	1397	1397	1678	1	1	11795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvNBcSPHMnkwEopThqUGsv8yHCWK1XbshoKSLYtpomrjz537v
28817	payment	1684	1684	22	1	1	70	70843032675	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa6e9RZHp9w8vz44dpSsMiBVvJ7rQrVxCtVGEaoyhVBCRJ7hJtZ
28818	payment	1684	1684	190	1	1	71	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ38JVMk9ZGxcDU8GDTXELy9FPV2Wq4MDWfs8urgbcvoj1TstTX
28819	payment	2132	2132	1874	1	1	752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZProPrsV1JjFJFArhpaaCnvWWNTqK5KzKMGyvu7XLjTdjeqt2
28820	payment	2134	2134	1874	1	1	2640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcS4UhG4GECuxRGBSCpbJTQvbRarhrCMSZUUTFdXdZX9erNHi
28821	payment	2133	2133	1874	1	1	2207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUzphdWH2BtyHhuXMNooGcLKSHYctHujFXbA2C36ZVYSHR1Hzc
28861	delegation	2246	2246	1607	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZX3VPgA3UUCRyHfZ1aJQQE5CSWFsjs4ejrNmxmqWGX1d2hwYs
28862	payment	1684	1684	572	1	1	98	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZUCMXZo1x5uKZnujdTGV4EgAdHP6FS28F4DVEXWmp2A6JZD6kc
28863	payment	1684	1684	573	1	1	99	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZSBKEQevbwEUYwj7grCaq2vce24mzgiH3EoP7mVSPQKYJZ7v5M
28864	payment	1684	1684	576	1	1	100	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZLsBDR3FNsEi6ArAab1ZRm2pm2798jXNu5dDU1nVqUVWYBN9Nr
28865	payment	1684	1684	584	1	1	101	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ3dC28dsKTokDJq2zA4eioaZBnkBqpgHcPEhwjjVvCvgFZPd9m
28866	payment	1684	1684	585	1	1	102	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ2xHPYuUdqeWJCAvP1JJP9UCFq4C9D7iNVFXJVBzVPPnrLww4S
28867	payment	1684	1684	589	1	1	103	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZApmBC47kU9qZ8aAHNhxkYQFyMaReCSa2YHiJfH5Ff8vRFBikc
28868	payment	1684	1684	595	1	1	104	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYWHPQmeUZLcCXjEbDYrHqABiW8Ka1gV9B7bP4s8wLYdia54Ynz
28869	payment	1684	1684	597	1	1	105	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZnnnM2wqEPh5zRBvzvaEPrXvUrjN2GxGitQkBbbjkPkmTR3BGo
28870	payment	1684	1684	609	1	1	106	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZWDohBDCWAyFwrGTmCtR5JuquxsrkLN5j9XyDiZ6vVkn3ugqk4
28871	payment	1397	1397	1678	1	1	11799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7r8D885RZuCHyU2CmWNwQGRG9vf381SY9oGSyhUDWameEctMD
28872	payment	2133	2133	1874	1	1	2211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdp4nRp43e933a4hAdTCWyJoYpWPpbPCdNNPikNBxGgpoFabx
28873	payment	2134	2134	1874	1	1	2644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyW2MY7JuTRecpJaPMvQ1KbFi5M7qQra6G7pXCbJBPvm3H8nd
28906	payment	1587	1587	272	1	1	13	1332755000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNJRd1Bo6hHuHZSiRP6awxxcucANvZv9bjyNzhUgdumKTGRMF
28907	payment	1684	1684	720	1	1	125	6346236018	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZj352CNPWQS4EZ5FtdNwdgPBTeg1KoKsKDb2GShNzXsqmUWuXi
28908	payment	1684	1684	722	1	1	126	6346236018	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYzmZeZNNX9e8eu8y4raCmUXtPp7i6eepTJUGeTGic6rNihtBcv
28909	payment	1684	1684	760	1	1	127	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZzdXBRoLy3yNeNHoAZXSpPSHWpxCvs7MXYdx5j6Dd2hyeTbHMt
28835	payment	1397	1397	1678	1	1	11797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9H5JpgJJ7i78DhAgS3btB6WsRvJKJiLnB6nw83Z1Rwn7JU4VM
28836	payment	1397	1397	1678	1	1	11798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhV4VzyCqX9Xa5qTmt1AcfYTYqNLpXxTzvpbjbtjQxZRBvWuDA
28837	payment	1684	1684	430	1	1	80	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZnq4vtwwnvhGVv8ngnpWHZfSVc87gXLbKQkbrHiG9FBjqoXDBL
28838	payment	1684	1684	440	1	1	81	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYgVDZZ5ziEmib3DeBrpctgBucar9yVxdNED7QBHks5Au5tSY1D
28839	payment	1684	1684	474	1	1	82	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYjRGzAjEtXkW1QKDjBQQihaHoAPkpYKgeL2dcz5KbmKgN7SPf6
28840	payment	1684	1684	475	1	1	83	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYooT9B2CNVCm4ceA7BLWtWzhLAq1Ja7h8geLuVKvreakVQJsCa
28841	payment	1684	1684	476	1	1	84	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYteEN1BLqyVW7rARpigsssAMzvJubT67Bvo5ToXSXQAsZjzP7y
28842	payment	1684	1684	483	1	1	85	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZBudkipBYN9W5Wz4a7rnwvXeRhf5FouBoT7Mh8sUNWG4MiBnat
28843	payment	1684	1684	486	1	1	86	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYuiYXJCt5f7S2dfGQ8bQaKQziQHh3dCcJkZuuwuyk2PQjDJvHn
28844	payment	1684	1684	490	1	1	87	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZUH2pCzu32SbNJHmzAd12ChgiAv8QK2JUiW7QPN47ebDyxoKhz
28845	payment	1684	1684	496	1	1	88	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZja1sj1H8G7SJKjnBvWDTXyULhweeygVF4kkFPcnkk83RJTDH2
28846	payment	1684	1684	511	1	1	89	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZkU94j93Fsy1o8TZ8LoW4bQnapE3doCpgMzzqY6o9cN22BUvBJ
28847	payment	1684	1684	512	1	1	90	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZvUAYbZoz5fwg1DN6BtoEAK6W5sz2RmQM1b9iFWev82GidqYy9
28848	payment	1684	1684	522	1	1	91	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYvo3mreRauXAp5z61hUzjJszcuXfsbHtycgM7Hei4mCZEVL2vA
28849	payment	1684	1684	523	1	1	92	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZNVHuuG6B3pJyyKDYJggED8vbcMZBrJyCq9Yo9i9fn8QbmXGoH
28850	payment	1684	1684	533	1	1	93	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa549bRMzPsD3kCUUf838YPZCgWVLW4sqE2TnYTSTbRhKM8edy8
28851	payment	1684	1684	539	1	1	94	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZug8ZSWFjAzdsRsThhRzPHigavcqwLGhnV7fqSiFKn9q4Pgmi4
28852	payment	1684	1684	541	1	1	95	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZStDdXkRzS7B4mt53B2HKYFDC9KUA8QVP29vXyhcp9F2s4Rgwk
28853	payment	1684	1684	558	1	1	96	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZ9BBsidy2McQFibXTK41nSojxt8g1DWh3PiGQP9HUtZxcDfmSh
28854	payment	1684	1684	565	1	1	97	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZHA1TkD6zc8GnCwuBR4gNG9f5ab8GgwcZBCBMYmewemTXmuG3h
28855	payment	2134	2134	1874	1	1	2642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ953HKWrJmUrCvev4KsZaSvsM7XnAFbeBwVh2ZbiGyc3Uh3C2f
28856	payment	2134	2134	1874	1	1	2643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxyJ63VFqkxpsyYLQ2596yJBaB1GhDSxhA3ghvW24BN3EjLhaM
28857	payment	361	361	2247	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9jcQHeAHgDUnUxBo7BZ5rXuHojKbpzWxuiLwVHLJyV7vEida
28858	payment	2132	2132	1874	1	1	753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYoAveA7gH3hDCZo4YCF87zJnLc4jPEFosjMEA1naW7ZaSZvW
28859	payment	2133	2133	1874	1	1	2209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrY3R9Bfiya1vHTqoF3tKJW5eS74g3ZPY3z8QYk9UXSp7TU4J
28860	payment	2133	2133	1874	1	1	2210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8s9TuBKxUKYWVomXAUtNedq4ZD8yvdB7a7L2cFm7t1fLnXnC8
28942	delegation	2142	2142	1460	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbD63aYcGuoRDDbjzpe3NXaUvR3QgvcGhvSPyrDcxr1b6MJ3x1
28943	payment	1675	1675	976	1	1	4	2228000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpYh29nt48k5aqJeR6PGQ7y1Yp3gXTwviEQAtXP9q8gJ7zRsfySb
28944	payment	1675	1675	1096	1	1	5	3992000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpZVdpXmb3H1w8uebGnwaoJv3wqDKNCgDGqSZqYcU29bvTt5E1QD
28945	payment	1675	1675	1216	1	1	6	2694000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpYazAwFz9Ty7fNX5xnmrV9eVBQZTZk5JKHb1J8WBtQejtZ2Qbg9
28946	payment	1675	1675	1342	1	1	7	7505000000000	10000000	\N	E4YntFargcGqvTg9qZ7PG7HgjjmhEtQjSLBjwWmE18MihRNXViGeC	CkpZG18FdsNzgfhvBNWsosCpdi8hRomjx3fDvsjLcFT2ZkDwHSxsL
28947	payment	1397	1397	1678	1	1	11809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn57ENXL9rTYY2xgU9mgdyxzaVF1Wrj7nPfxFYXsNjVFtk7Aep
28948	payment	1397	1397	1678	1	1	11810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxDtiqxEtp9dNka76REBHxnNNC5hJsYpEUCHkBkoGFokPVkxJ
28949	payment	2133	2133	1874	1	1	2220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUxQzbi3NTiXhMLZ1miWMHSF13hjpWVbTBcxNtYx5jCgVyRDu
28950	payment	2134	2134	1874	1	1	2654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTEGpQRCXw1LqsG7xLH95izs4aN4D4gAwcPfW9JcV6kSwBLR3
28951	payment	2134	2134	1874	1	1	2655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmo9f2t93c67DJrhv4dvxJ9ZnSW5MbS5rimmPf6KKjDkkuMBW
28952	payment	2133	2133	1874	1	1	2221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7mHdME3BStiHtBKDZmaQxXp993zy1jvRpt1BaFQDnYjiwjDR
28968	payment	2133	2133	1874	1	1	2225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxFmbhwMv3svbaN6grxDhyvCnRnHG2X8cqGya5AXj8a33keUY
28884	payment	1684	1684	629	1	1	115	209425788612	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	Ckpa3W4czdNFT8s5XwH2oiTwkZjenxjprZKcntcGXmxS5qUY9LrvL
28885	payment	2134	2134	1874	1	1	2645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLLRcF6zpG9Td3kuyGMey6wuqz5yuBQt9Xm4H9mAMDMpr8sbS
28886	payment	361	361	2247	1	1	1	640000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPD2sxLsfYcqmHNLP5id7efbLKyMevXrtGRxZ78W2GNmv7UxK
28926	payment	1397	1397	1678	1	1	11805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jx85dnYNYG7HoCLi4iP43w3HngGgSc8T4BhXhYguF13Cik83
28927	payment	2132	2132	1874	1	1	755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW57es9eNYztTDGByXPCdqfbxFo8RNAF91cgRMc6c4WfxGK6FU
28928	payment	2133	2133	1874	1	1	2216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LZPNbAMUBcG98j3kQSfzvJ8JH6soi7HdfyixzcAkxcxDVsvE
28929	payment	2134	2134	1874	1	1	2650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDTeM64w89SKGmKUqrqP5wtJq2S7Ja7gyqxcGtvgN7dTKDZscX
28953	payment	1476	1476	1371	1	1	5	8601900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqTG1nsxjuJUZCLaPoRPrRiVuxXj1EeCF5RgigwPPrT1rNfQG
28954	payment	1397	1397	1678	1	1	11811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqf3ZJsu4P57M7PKcUqyzroxrEFxVRKBEZ557RtGr3hudvUZF
28955	payment	1476	1476	1125	1	1	6	4575100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGnafAfc4jMkejwKyVwuLKF3ro1mFgfPFSY7ScwZSVw4irnLJ
28956	payment	1476	1476	1245	1	1	7	3086900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSJXSotKZsXyBMACvTZhnyRnX7TXaSA15ji7uYNQKBk3VhBbC
28957	payment	1476	1476	1005	1	1	8	2553100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDvFKx3xh7JP83Xt5PLJs89fSe5J4BLJnyR8BVc6XZniJ1KqU
28958	payment	1476	1476	538	1	1	9	335200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8jRAtrS4iSpgGj6Z2csfhmGh9iJrua2ioADsSnYHfZEstkGNC
28959	payment	2133	2133	1874	1	1	2222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDpV3hFwcw71M6ph5sK6YPhZXYBFiJW7cWiQw5TEh8nBhQZVZ
28960	payment	2134	2134	1874	1	1	2656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3JQdNiecXjWoTs5zPXPhJrFXBPMmBjubgDeyyHvQAGo77XAi
28961	payment	2132	2132	1874	1	1	757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK67qZCgqk2WbwtCkAdtYgf2v6EWDjedhJFhjkTxQXP69Bk2d
28962	payment	1476	1476	538	1	1	10	1008137000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpqkv4yfKCa4DmRc3fR4LaMqCA9UNnU5JCJHMEr4Hjn6e5LCL
28963	payment	1397	1397	1678	1	1	11812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21qP2kYYcMGAYty9EgQAkE155FbsSUM27t1VbceHavTJiHGnQ
28964	payment	2134	2134	1874	1	1	2657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9JW4ppMKj8aaoGXuyLXkaNSAfdz46HF1SiFNpsvmZHWVWfHz2
28965	payment	2133	2133	1874	1	1	2223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LgTXo3jVJ6qtuL21czHgeX5VnNHjU7K9sJ5BhSPMa4iCiveQ
28977	payment	1397	1397	1678	1	1	11815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5v7f4rvmTs7F9V9VAin3qdzwKEbbBYbePYdBS4iHstcgDGty
28978	payment	2134	2134	1874	1	1	2660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw74UQ9YRu5Umer2RqEAFH5nj2HtzppEu9rvzjd5jhxiYuixSM
28998	payment	1397	1397	1678	1	1	11819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpBNeLaejFPSFwUVCQpT2wurdPz15gzWuaDAqT93KNuiBUAuK
28999	payment	2133	2133	1874	1	1	2231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZUbjfumKt8mreYPnN8AJFFkGEkEsSpgvFyhHFSrbWRcMpV2W
29000	payment	2134	2134	1874	1	1	2664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgqFZBnUb4Ks1ppyFkTovKMvxn9q4wTBhZUR8fqmnjYrHqeXU
29007	payment	2138	2138	365	1	1	0	48000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6XnqDcEkzsgHbjaqqo8LEazBB2AzhntW7cVg85jak57JbKq5
29008	payment	1397	1397	1678	1	1	11822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfNSm6bf2FwjLMME2itEotVrMMm4343cKbYoxiSvS7Z5FCdQs
29009	payment	1397	1397	1678	1	1	11823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtaidToMUfe326fFQH585NRLxYJeaKE6wAvy7HJ5tHB4V9jUmx
29010	payment	2133	2133	1874	1	1	2234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvu6g3VkvgY4zMaAYHojKxiA9dMUccDCfru9qrkAaLoP7YQ73D
29011	payment	2133	2133	1874	1	1	2235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBim3LszVhP3W1iCRqERs8k7tcv1E6TXhqnU3u7HfqEQc4SmF
29012	payment	1719	1719	1352	1	1	8	9830800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoTXXvN7soGPWKnVDFTk5btHqTEeHufPv59TWJsbzFosx49Uy
29013	payment	2134	2134	1874	1	1	2667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpAmcgLhXDBWz28M1nY3i8xnfwNEFeMMyhMumqJizQVXjuPDz
29014	payment	2134	2134	1874	1	1	2668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXHnq1VZKY1C6Kv8jwmJTWpVnDtcF6b4JyDxvvo9J8edDfQPDd
29021	payment	2138	2138	365	1	1	1	800000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWuhZEqUzmarnqc3tCErhNJT7TgvT5ScM1sHx3FRsb9PXpFz4
29022	payment	1397	1397	1678	1	1	11824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YeqK2YtpyKLRdgct9B2ZstDVKPfPfMo2gGMpxJYTYpgErMe7
29023	payment	1397	1397	1678	1	1	11825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQUsBzKV9ChLGXJDn9D68ZMHzyvoubpS151fJctnRBdDipZZa
29024	payment	1397	1397	1678	1	1	11826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQf9om6exMBfAJsru5u9LVFxH2aX2hVH5MMQwM23YK5sBWb6w
29025	payment	2134	2134	1874	1	1	2669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc3vJ171M4vDfWMUqPcbirQ3t3bJfJsK93nMT3QFonF13ivwS
28910	payment	1684	1684	763	1	1	128	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYdUYb7vceJbUPYDkgvXb9HMfgEcQ1FszFrb5omwLJeyZnQ5uuS
28911	payment	1684	1684	767	1	1	129	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZXDXgNSv8XQm93MYEmLMXR7JNUTXMBfr1jPRMfxQaf8vSzBa3n
28912	payment	1684	1684	769	1	1	130	3173118009	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpYxFFoNPBq85WndHh9rHz3t5gBymjrcbd66FcQZ1V83qxa8hFyx
28913	payment	1684	1684	958	1	1	131	1629879801811	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZjkL2BfRgXtcXiv8fGE7RApaz62xh1RzKzP4SPYmtMYop93dhu
28914	payment	1684	1684	1078	1	1	132	2920575236094	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZXuKMqw2gavF2z6yaH42BZ4gvAcRP1UqeGeQVdGoRTrgx4VMJX
28915	payment	1684	1684	1198	1	1	133	1970633950321	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpZBpjur4JHrrE9cupF79Lu1bqkDWmgeWYdXmhtjNpc64AtMYo4C
28916	payment	1397	1397	1678	1	1	11802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBo4bZtSKrUgB9YgiHEWNxYZVvpFqUtn58gP59Z9kYZVvffwTp
28917	payment	1397	1397	1678	1	1	11803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgK4EbdesF59rftBSCMuLfWKerDzrTApFmL6Ngp8u11TYirMQg
28918	payment	1684	1684	1324	1	1	134	5490994110854	10000000	\N	E4Z6ZsAsLdsnbxSoRRPF8yzsn9VGxqN2Thyghx4g9kmCspRyhmTRM	CkpaBxRheyQqxu3KvV2bGrAbUeg41tCbQdosa6uTUmW9QfGp4U91c
28919	payment	2133	2133	1874	1	1	2213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8c5rTdQXtFoTDHwNNmQj6aMq2whvDKoyUgNoWhWoiLQrGp2Pt
28920	payment	2133	2133	1874	1	1	2214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCRDtdnuQVZstU3tq86myDaqiHkmQJoPXJgH8s2oiKHgUKjog
28921	payment	2134	2134	1874	1	1	2647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKmiv4G99JorwyAQUM4YyJEn6TxKq2vWpwoSQcMt7XNQ4p8dt
28922	payment	2134	2134	1874	1	1	2648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLPiDouSbXxSqFPwhhb9UGV9dKMbYEdRbSYYuc1Rg9BvqaUUs
28930	delegation	1882	1882	1484	1	1	0	\N	300000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTBuCJywtowhEK8b2AWvgXwCHvtpXvxgs7hxbGXDjLjLwuAsM
28931	payment	1684	1684	2142	1	1	135	1780000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymF3DuPimcj9WVFAqUvj96m5odzrmuRBnCfJVUsKgJXZG1CRV
28932	payment	1397	1397	1678	1	1	11806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyvFfZ6HzkYw6S6Nc6SF4NK75Hpv8ciHUbjb6cVrpHBvNoZ9h
28933	payment	1397	1397	1678	1	1	11807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrATgxia9Zso3FYeLxKRFcAWTygxXQeCtyXtdsee8hsnHL2ZgM
28934	payment	1397	1397	1678	1	1	11808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSY6QpD3QfniQMxRC7Ca7xLY274WJhSTGKo2qz7R5CgTmuC7Xw
28935	payment	2133	2133	1874	1	1	2217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCegVJMZ9FidVrJKSLG64HLKQbBaUu7ioJXjCAcC2Sj31yu8y
28936	payment	2132	2132	1874	1	1	756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLcFCGTKAvkSVi91ujWXyMtmksgLmQJYm5J7HcRmMDeLH7V1S
28937	payment	2133	2133	1874	1	1	2218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa96EGsqCPoWvPzWRDxriHYGppG8VZBMYiVrXHpPXfe7Vr8Ludd
28938	payment	2133	2133	1874	1	1	2219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZskYPFYsvvPYV5igca1b6U1mM8FKzK2XgVUj35Rk8kZhvygx
28939	payment	2134	2134	1874	1	1	2651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjvytctKJiffWo1oWZBmpF96q4gYbWaWqjMHfbnXXNzWLkS15
28940	payment	2134	2134	1874	1	1	2652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UmqWEQp8eooTxJN98Z3dSR6LufY9ryPhzYbV4gGkuFUnKu95
28941	payment	2134	2134	1874	1	1	2653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18FfbQ55tfVFvn7KZjvrpnGFpUppmZH58R6rqC79SczVXWnap
28970	payment	632	632	1382	1	1	5	3686000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZdk7rgmZ8frNfcbrkRhDGRSV4FjA6VPbfxEKwec4DUYj9qmnto
28971	payment	632	632	1136	1	1	6	1961000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZCsp5jYkbsbLMUgMnLwP1a4cnn58eipvC8QkyE6qeSwAWsakLA
28972	payment	632	632	1256	1	1	7	1323000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	CkpZG7ZMyg2eapi9naYn3w8LqsyvK8QrFv7WUbQrGrqBxHYUAttaU
28973	payment	1397	1397	1678	1	1	11814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8hHzbuw9KSsX75DJrn4qKBtvume3eDqFE49PGA14jVmvFu9u
28974	payment	2133	2133	1874	1	1	2226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRGszKToyFaMQtWKcXwxxG6hHDs31kovouQEeHMcTResaMXaE
28975	payment	2134	2134	1874	1	1	2659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sbpFEDnN8eWSnWT3UhNVuKSSsGH4ntY55BnofmArBs84u5ML
28976	payment	2132	2132	1874	1	1	758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6muF74RogwCVRpNieMGD8wCmt5JXEoDqjNgdpWyHtZDU65X4Z
28991	payment	1397	1397	1678	1	1	11818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpdFGxCZy1BCeiroL5WQvcvgNbMeBws4zUQfpsGzne5oEpA6Q
28992	payment	1671	1671	999	1	1	7	2005972659860	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SwUM5gL9rnmySFGaUGxKMwB8RQSQ8KUKjGsP86ZgUBsW4SHD
28993	payment	1719	1719	986	1	1	5	2917800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqbhhkBtbL5BFxXY2vChibS4SZ63xLXokvtuePCkkdZQoc7rz
28994	payment	1719	1719	1106	1	1	6	5228700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1aDLX2iUiyJNUwab8avwQCYJEMaepmn4jJZyX5s9Umzcxqy7
28995	payment	1719	1719	1226	1	1	7	3527900000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2uh8DinevhEGxnddvVja7z6FmXm26gW8tiKRPojdLdediquB
28996	payment	2133	2133	1874	1	1	2230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcoELWcQqWXTLcSMj1y34mkPFHhT5Ko5od6eTECkb7YuhBCaX
28966	payment	1397	1397	1678	1	1	11813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dENau3dzHN32WgbGfFD95jBnAmvbAabYUixtuTdkEto81kao
28967	payment	2133	2133	1874	1	1	2224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVVNytccXkL6RPAHTrLCHv4PgJjg3HuWMRrcn8KCvN3fcS4Ut
28983	payment	1671	1671	1365	1	1	4	6758609896120	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhPf8eNytrS5sSKYSqAtVepL7X4DYUGTf6CGfgaBpEnEFG8Su
28984	payment	1671	1671	1119	1	1	5	3594685819300	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfFd6nw6Lv7B4apVfNAtFYpdg63LrTrRypDuhszez85wg5xJq
28985	payment	1671	1671	1239	1	1	6	2425406151450	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppyRRoaNziNxVScpvVYsw9unKVppMpAdGQztyftvLNDbq8x7z
28986	payment	1397	1397	1678	1	1	11817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevBJwqGzqwLGFsnHQr2wK7QxACExp4RrQKYjtnhUYedNybXc3
28987	payment	2132	2132	1874	1	1	759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7teu6HtibjGWgXAq73p9BDgyUsxt8zuqGaSwKZn1ki4nmLKYf
28988	payment	2134	2134	1874	1	1	2662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVpWamrU4ZXQhELGPYvqmJhka84LwtsPd8iDnYdcuKjzm6mPe
28989	payment	2133	2133	1874	1	1	2229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvUNS3HwMvtEppAQ1wgEA6Ad7bfE7MzPzsfsjSvApjkQbSJnB
29015	payment	2137	2137	365	1	1	0	98000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG46YdtgPwkrnARpoQqP8DsDPe94MgCTYFiAZ2xm8BZqMC4CDo
29016	payment	2137	2137	365	1	1	1	700000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2CchxtCHZ3ycD3w4zYJvCZMEEFGDXTB91kdNXVYFeYFCD7y3
29017	payment	1536	1536	1313	1	1	6	7373030000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Bof1FswmhN4AVhuvLZVkdFydPMojzLGrJM1nq5gavbw7ocfM
29018	payment	1536	1536	1067	1	1	7	3921480000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5FBVXQjkygK6UoonEkN93qJdbJkhWkgydycnhv9f6814wavqk
29019	payment	1536	1536	1187	1	1	8	2645900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskeQFJCXmyQyTziGSGsGfXuU7TAeRdubJCGxwAArsUvrSGEFY
29020	payment	1536	1536	947	1	1	9	2188340000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WXRMUWugcHPt31tH1AiPaJo5UfxVNVQLj12T2qvQZiBfJDPS
29054	payment	1397	1397	1678	1	1	11833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBBBx7HfAC1H1wk3m9s6q5m4d9kFJLtW4hmUREjwWQMKq2wqpg
29055	payment	2134	2134	1874	1	1	2677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11XXTDhz9UtLi9SifBFc3Qp3K9JrsAgFT5K9E34LVPQj4eymd
29056	payment	2133	2133	1874	1	1	2245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84UFGadzbvKUUcGJ95kGPC5857Pz3DSiKcL2pHU8t9Q9sGdGU
29072	payment	1397	1397	1678	1	1	11837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWNe89iChRsy16jfsrfRngT5GeJ1Xzej1z5QNoum6n2DD2Vyj
29073	payment	2134	2134	1874	1	1	2681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFfPPiWGgnAdUkztPMgD5S8e1XV4XQ7GUpeD4SQq8yFmHckug
29074	payment	2133	2133	1874	1	1	2249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ghyc8aLtop4AQwEoJ7THkecNEbSSKU78uXYFhz22DBjAj57D
29094	payment	1397	1397	1678	1	1	11844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpeVj5NkBBeGwD6zBaJJ3mqjVeLx9wgC24gd9GkHiZ8vSmYs9
29095	payment	1397	1397	1678	1	1	11845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSZSiG92UkELFSX6DGTHpNQTCP5CrCD7qS9ipxHsKUJ2nZchY
29096	payment	2134	2134	1874	1	1	2688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyhL6mQ7jVhKqdVFAbCJVoSrjVUnKicNgUaAkX3Gqm3BQxVDH
29097	payment	2134	2134	1874	1	1	2689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBBLAdCFh3E3Vyd69cSjnof5rbqzp6qGJs9FXFv3v3rYrFF8w
29098	payment	2133	2133	1874	1	1	2256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2ZDtV1c6jxqMBJmAWG7TM6h1HsKddeyRxLCL2Ak9xCDKGUAt
29099	payment	2133	2133	1874	1	1	2257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9s6r2Ejw2ZjuoZXhZMshqvHZa5UmNshAB3ghYSdaSf7hscSU
29169	payment	1423	1423	104	1	1	28	284000000000	10000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZNEa56TUoZC3EBC8dgUbcSjJhqSu1MHkRAM9vEzoUqmaWf8zey
29170	payment	1668	1668	1244	1	1	6	2981321000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYAfSaj1PrW92ZfLsu8ZY2yyqBegsxrxbqc45ZHMshHJ6Qiqg
29171	payment	1397	1397	1678	1	1	11857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34kq6uYGNoiStSDMSzFkMghJrqg35aGKPnLj6R9QY91Ctw7A9
29172	payment	1397	1397	1678	1	1	11858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViTDj5d7x6qbGBhuxnCe74kz3LebLc6SBemrTxnU9ecxmqnKD
29173	payment	1540	1540	1963	1	1	5	367204120000	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYq7kBN7XqmPnQTYgtEUK9WzGGJHLwYoDZ7Zy6iPjguhu1HprM
29174	payment	2134	2134	1874	1	1	2702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteyJ3fD7px6hb96hwkcueKkEoDTYroW2kVDAFXHwragc35g27
29175	payment	2134	2134	1874	1	1	2703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsq3TytD3mSkkSESVs7ERwZajDvBUYSoxHX4U6hG8Pc8SMp3Ew
29176	payment	2133	2133	1874	1	1	2270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA99MxFcY56xeK4TprgMXhwvas3ms2kLjoo5hjP52opWBeqGLt
29177	payment	2133	2133	1874	1	1	2271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtForyZraw3aCTcLTwgfi8Fzgd3QsvbEhHHit68jMym9m3gRLy
29190	payment	1668	1668	1004	1	1	8	2465751000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyWwtbftXFVtzbaTqrPnkBfFpH838mny887TmBTLqps6EcQ9q
29191	payment	1419	1419	139	1	1	3	338724292166	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBVzSNaxKwMvnqeVgKKaKMyYDyPSK8sms25rdPB78ytn77wej
28969	payment	2134	2134	1874	1	1	2658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTRuQWxCzHDsp9Qpn8AXKkQq7PJruBKAY9yrKBYPxRkPZ7mk4
28979	payment	1397	1397	1678	1	1	11816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnJpkXR9LWh9q6uZMx2U1syGEDSVsP3T22buSU1HqAHS1Yoje
28980	payment	2134	2134	1874	1	1	2661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJjm7xaBfTEULMPN3jW1KN6wAegzzRXdZoyJAZaPmsrakqHU8
28981	payment	2133	2133	1874	1	1	2227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aGbFZxN87FUxPEYF74JxgKP11RuxLa219b2vxPQxMJ9j1gH1
28982	payment	2133	2133	1874	1	1	2228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xXXeDSYan3tXuf1BygGTjFNsMUCagXJ9wF6m2UFUu4wSiCv3
28990	payment	632	632	1016	1	1	8	1094000000000	20000000	\N	E4Ym3Fg8GEHBqsDzm8YEJxDgmkFLke13VznEap9XdL8Wq8Qpx5XiX	Ckpa6wqScRpRQA8GJi53rmhc5JGBtPADcaNmuHERPrMmVkpYqSZLn
29001	payment	1397	1397	1678	1	1	11820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7CbLtovvohugzhRdpF6dyUQbUEmGzdNKXyWrD2fQn96qbg4Q
29002	payment	1397	1397	1678	1	1	11821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YWnqNrKQFZFr93uevWFnD2LnXVQJd5G9m8X8RNqR6GCr8u7p
29003	payment	2134	2134	1874	1	1	2665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3H2874iR2RaL9L4eGZqZbN9f1nr9zksQDYjZDRHrsPjjFtpLU
29004	payment	2134	2134	1874	1	1	2666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MLyPmT4MPD17csyHetvG9c4C9YoEmiDPFYiFkj2iQc5wHqLT
29005	payment	2133	2133	1874	1	1	2232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJgT2QfATtcFvLX965GygDY4wga6o88BQVxaLzHMhW1UjaSSmy
29006	payment	2133	2133	1874	1	1	2233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgWCyyhjmHP1QZkRF6U7ezs7GktCqz8GXdpiiWYDzD574G79V
29029	payment	2133	2133	1874	1	1	2236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3adcJcym7swfkueYVtC2bcQJbe9sufncCCTR3aY4wtFDpXMj
29030	payment	2133	2133	1874	1	1	2237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpcKyruY3ozy46yrc75Mv1BbjreJKpiNVrSN5Nmu3BEYs8DLb
29031	payment	2133	2133	1874	1	1	2238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLMia3T8VLUKPtAH99pMfEn7i3gNGXEroLDtp66NQbTRcmejjS
29052	payment	1397	1397	1678	1	1	11832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSMz9QyZ4k8ogNVJcuKud5a3qjxbVJFso65QE1VCCeTibDC4Y
29053	payment	2133	2133	1874	1	1	2244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtZNdDaow7bPvUqCfDme66RAF3KT5EW5gWLN9uf8twrAWJ6X6
29069	payment	1397	1397	1678	1	1	11836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAn4SdXVCQUmMiEcKsVFGK27vQUGM4ZMGqRHzuUXiDyKLWe6H
29070	payment	2133	2133	1874	1	1	2248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUyR7DS8sf6ZWA9tQv8uhcorgvoDyneWn9vsaQxGEfW6Yquu1
29071	payment	2134	2134	1874	1	1	2680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GvSinGx78qWm6gW8sUpnX9Wj91BHkyU4kc1BdY2aB8DMJ4mn
29082	payment	1397	1397	1678	1	1	11840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjSGdaqg7UrrGUsfMrQw4c8YFPqUNWweamCwBYfdtSKZeQAaR
29083	payment	1397	1397	1678	1	1	11841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuszxUwa2NxXmPyMvZPzMkwqSDAHndtPAD9AL5iz3d7Jus9oD
29084	payment	2133	2133	1874	1	1	2252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16Rs6Fp5jw8z2M2rjBLJ3D6ghC2VBMxUGsxhhSGyRabhtM7Gs
29085	payment	2134	2134	1874	1	1	2684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fSVtwRe1dPCAorXrtBiTRtkLenZgjcj284X5UyDjz1qDHzHy
29086	payment	2134	2134	1874	1	1	2685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX63p5mPYUAEEdKwUnuf1Lc8S6zxfbc9Bm85CGxjsyt9MP1H2X
29087	payment	2133	2133	1874	1	1	2253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yA6SRZ2zb3fin9Bcp49upePFC5kc4NRU4q1iBBoqToo3W7pR
29100	payment	1439	1439	913	1	1	6	1702636450000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9iwZ4xza2hmLEzegq7HxSa54HWQCSifMx6VVAqh5murapViz
29101	payment	1397	1397	1678	1	1	11846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNL8FLJ4bQNYPijnYa97b3pS2gbbe86D18gj89DjyD2oHhV2Cx
29102	payment	1397	1397	1678	1	1	11847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXcPYAuxY6bECxWaA264uWpiovds4TDHrv1HPS44FTothUPDv
29103	payment	1397	1397	1678	1	1	11848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZR6KjVWwECBW2P7UwFDi9gCiQd8BH9j3Fgha7yTWiQ3G1of5f
29104	payment	1397	1397	1678	1	1	11849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY89bHYBhi1e5tX9RxZVyNZYp1b8yujyL4Z9WWnEiYcSb9Xo7A
29105	payment	1699	1699	1773	1	1	6	7990000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXwexn1G1DRw4WMEdLfrzAaTXprBotaUUKAXBsysAzMUpwoEzM
29106	payment	2087	2087	1773	1	1	1	5759000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ195esV5d45Jth33H1tBcYYyXZN21ebwr6eBaWociD1pRNPfuk
29107	payment	2134	2134	1874	1	1	2690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTWeEPfgh9Nzq9KUJBuL8JXfjsHTcyWNbAnKyZcQxpkWTpiky
29108	payment	2134	2134	1874	1	1	2691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtz4P9voqWwPskguVgJdJ7uHj4NyAG5oCC2CUUAXeJDGLFKx9
29109	payment	2134	2134	1874	1	1	2692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsbLcN2SucJUNC2WwzpaBbR5XApNzNUxo3bUX44ScJqEVBT989
29110	payment	2133	2133	1874	1	1	2258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53rDMCCnzJMG4cz2wPdKhrZtYuVGy3zqp4em1JFXBofAA6dzj
29111	payment	2133	2133	1874	1	1	2259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahumu7jmFsg52RRBU2iJknUwhNo8BC5xdXKKEU1T5FenHKj5x
28997	payment	2134	2134	1874	1	1	2663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzga2B5qLpFVz7Bnqg2yC8DV1xqAWbA3L4LPS7Q3aPwgVU1niA
29032	payment	1397	1397	1678	1	1	11827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEAB3iAkMRkJnBgjtYrJVBHoQ12bq5KZSwgVaC3SN2gWfvKU63
29033	payment	1522	1522	956	1	1	10	2189000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpaLL16PTV7Gv7q43J4zSzSuL49e38mx35Czx9zV1WmpPwr8CMvX
29034	payment	2134	2134	1874	1	1	2672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoYU1BWiaMqyAy9YWdJyT4kjqCRc43cJ9wXNJXmsHDsDSwWh7
29035	payment	2133	2133	1874	1	1	2239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDPYpEiw7JGqowcnMJNqDNKgvqqL9Ta5UGL4UG8PweuMU6Cma
29057	payment	1650	1650	1009	1	1	5	1650000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGDu2Gn5PYdNn71rTdp9tBMfxhia712dEUsA18kLTPnCcgoY4
29058	payment	1650	1650	1129	1	1	6	2957000000000	110000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNbt5rddVSRc7LcpZegcheLKSjb6AxWfej49rtfaXG1Se9hnW
29059	payment	1397	1397	1678	1	1	11834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9e8DVB57CFWmYtVum4EreipXCayT5vb8RQKnVMJESBgB2tYS
29060	payment	2134	2134	1874	1	1	2678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpkfuPr5LCnXb1Wec94fYNzE7QSzXdBJhbM1Gpb4LnqZCoF8k
29061	payment	2133	2133	1874	1	1	2246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRkVJCeUg6qTptt7jEtV3McrvgG91YcgAaZjhC2HfmoHsCrt7
29075	payment	1397	1397	1678	1	1	11838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CnQv4sJGtmUMTWtUPbuA4jzunH9ZM1ztatkB8ALaZ4ddLCGr
29076	payment	2133	2133	1874	1	1	2250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rxc7Kpc9cgBNvL6LepLWN1abcC8cGTyciUYc1ah6G4vN97D7
29077	payment	2134	2134	1874	1	1	2682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6cGk2khfK882dqKcjTUTMQBFK3rN817Z76QnNx8yART7Js3x
29088	payment	1397	1397	1678	1	1	11842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFzSfL4hdKWqHTTqrZVKFzkakbJtfd2RYK7BPjDX8YHxWKpJt
29089	payment	2134	2134	1874	1	1	2686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6R7EcSZ762sWUNNaUPFyUvQJYTBSmitTk9qa9YW5aC4GUKds
29090	payment	2133	2133	1874	1	1	2254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3DTMXS29kiUqyQusJKtmEhDPzRBG7Lkhow5ZQ7tncXBkyQGX
29115	payment	1610	1610	948	1	1	6	2553056130000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcmcTMVbZoQG9ibPAPPy7Paf7UaDg5tWkMCpHhXtov9eouApA
29116	payment	1610	1610	1068	1	1	7	4575054700000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuCmkJ5FMHDv4DaYLgxHfa1NDesdHyagBnHdy7i6J1S71wmNH
29117	payment	1610	1610	1188	1	1	8	3086880580000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZ9hHE1rWKjBLTgZs985bryE25JB1Zv761SemKrG4q47ZdbEN
29118	payment	1610	1610	1314	1	1	9	8601867160000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDj2wzgLr7cYX3iWB83LGaLHdKXeLEY8DKqywUAYrWsmapsQ3
29119	payment	1397	1397	1678	1	1	11850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4zWCXXtMgfW8HDwda6k6ZzZcgWVkQLZfBUojhww54ARkoom1
29120	payment	1439	1439	1153	1	1	7	2058644660000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUjyt76dN6AYpi6XMqAcwVT7GsU2EPtC21nGvT5mn5dSDTBox
29121	payment	2134	2134	1874	1	1	2694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbgp6GgRMfCxf3uJDLz2zE7u9RGX4cCaYTkHSGAGoRSUc5qBf
29122	payment	2133	2133	1874	1	1	2262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTGhWHDvpZJZom2cWWrQzSTyi1agcjmy4tKo1zhDsViy6CgrX
29123	payment	2086	2086	1773	1	1	1	1983844699931	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhjo4aSpUgSizPzMxEH6tkHBBvZvRKpvYTJEXJYFZF5wqWc6y
29137	payment	1423	1423	104	1	1	15	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZkdJxiujfqkCb8QGQddLykhMbay6Bm9yDS7db3UQKc8fqTpQPn
29138	payment	1423	1423	199	1	1	16	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa4VRqyikFVPrTrTwT9YhkCZTSKkdkiVyJDKfhYqCLGFz1Y4Ljs
29139	payment	1423	1423	214	1	1	17	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa4g1ruhSsBiJuAPGWbvjLhAxDxHcNcVBHKzBpmXGbpy7SVGmMP
29140	payment	1423	1423	234	1	1	18	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpaBVEMHBGMa8DgGEkVk4QuhMPtJ1X1ZAjLdABjK8HdvddwfyAvU
29141	payment	1423	1423	282	1	1	19	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYSLKvZJ6ECGBk758crJDeZKa4muQVRUw5ztJi6Wd2nwMMqSN8y
29142	payment	1423	1423	314	1	1	20	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYqGhT99oyG34UXknrJF4TWxKK87uKCXPdTvMxtJ947U6aTMbns
29143	payment	1423	1423	323	1	1	21	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYVrkCqmGuLicb9R2DUu77cwTB2ARWoeqWEBveRx1QnwkxwGqsb
29144	payment	1423	1423	330	1	1	22	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZTL6Tb7WBSugqQZm9aRRTkDQvEHKPLjh8yb76A9kCAPurf71hW
29145	payment	1423	1423	332	1	1	23	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZBmW6biEcbv228BWyTjjM8bePoKbMKfh1CUTwHAoVXV2Revudt
29146	payment	1423	1423	334	1	1	24	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpaFtRzdaieZD2VSPKHLF3C414Bf6oqaCgZvXwhjBB45WZoGLcum
29147	payment	1423	1423	343	1	1	25	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpYocfkGHTdUNEAH72eGYcpfuCxT8ik4xs62u3VZHxjKAa5mfTQ2
29148	payment	1423	1423	559	1	1	26	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	Ckpa5QTnqLXqb65iubDTHhTzH6hLncjWa2oAQUxiBeJ2WzssDJRV5
29149	payment	1423	1423	561	1	1	27	368313173074	50000000	\N	E4ZMxgMigMGHR2MSGTRuPCZn5zGPuxfsbJmjbuDuHk9dNQSC1b67j	CkpZWUs4ZS2t3xuGSVUdgr3awMf7FULV9t3rHKWiZVWqnfh3Yyx1o
29026	payment	1719	1719	2007	1	1	9	835688000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPeYd1jzVjKZP3c4iBRQxHKKE6BUXagt8wKBH2yw1gyx8F2g6Y
29027	payment	2134	2134	1874	1	1	2670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYSrsYaYwK2CWuJ4xWHmyuJu8VdTvgEh2V6q6kdxcunMNbMF8
29028	payment	2134	2134	1874	1	1	2671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkv6xnrYb8WrBwu59aW8MhB5R2Y9nLgmfAbpeBPYFb6LVaUSHD
29036	payment	1397	1397	1678	1	1	11828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoV5TQWKhQtWtoHPQ6iHaQnXgdfze7srBqMmTU9BBxK6iCKKev
29037	payment	1522	1522	1076	1	1	11	3922000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpYpHnVnfaPMYgpQvV6GvFeUKvTV6fBjqDbpYQxWaRKsYRUfpZ3K
29038	payment	1522	1522	1196	1	1	12	2646000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpZLeCmAxmop9GQ71F2JwyNsRSF6Prf4QJKiHvmkN3LL7TdDG7Ek
29039	payment	1522	1522	1322	1	1	13	7374000000000	10000000	\N	E4YkszTT5NvGpZx6mZXiKkEsMfEdGJTHnBSAuK3ojQa5174F2nBjT	CkpZGD2SsHtdxyJKN7y6vpJ5UqWDKTG93yUWXV466UrHnFvGz5w6v
29040	payment	2133	2133	1874	1	1	2240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLhoVshPsXfyvyPfSaazGJKTJ21Jo1ARwn5m3h8AKfiaYqLSV
29041	payment	2134	2134	1874	1	1	2673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNPa6UQAZGshteg3wZHNovo2dx46XXDVdTbw7q3KCDHjrMtFm
29042	payment	1397	1397	1678	1	1	11829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5gB1B1pr7ce9kVNZCqU4B8dtN1ZCaSHoVKEvoGSqHeGb49TL
29043	payment	1536	1536	260	1	1	10	1152100999959	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKYQHCnvPaJrRAJcUN7j5D6tkKUrdxBgZa4gU5pw9QkSVpRZh
29044	payment	1397	1397	1678	1	1	11830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxb1cZDHJweXdnUXkhBwXZA2jnQ7FYCgdyh2Dfm5x8R8ZTMte
29045	payment	1397	1397	1678	1	1	11831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKs6zuvcabcSgnUDwgy2g5FNuVTXvu6K7HtMDNtohaK2EA5aB
29046	payment	2133	2133	1874	1	1	2241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCWwLSphj8Q3mFeP9PTS9NKrouX2pjqTGcukfzq6MKUnvXDpA
29047	payment	2133	2133	1874	1	1	2242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUE4YQxmJdqoBid1Mifrkt1APUNcWKVD8vWt1wXK4jUcRfLU7P
29048	payment	2133	2133	1874	1	1	2243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacG2GDHMyfWdduW8RFGbNHaN3rWW4RVh2UvXbQ1kptHtZM55K
29049	payment	2134	2134	1874	1	1	2674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJAPUF1Gx7cqriS4hfVt1Qawrg8UEqGSNx95A3X29qPKb3pU4
29050	payment	2134	2134	1874	1	1	2675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuM9Tt1KsapzxxQBr4F3tZL5C9tGYt4Y4Mgz21rSzxRzXNsseg
29051	payment	2134	2134	1874	1	1	2676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNnmZCp9QQjyESFBiUSJCSwoH7SadU9xLAgxb1tsg7HdZMhu8
29062	payment	1650	1650	1249	1	1	7	1995000000000	110000000	\N	E4Yh779zw5ogHYm4q8CeDU2cJQMFX26oAfBHUTgFmAbbEnJPndDVX	CkpZwjqMo3tz4cVuj5DSAkM2NYLFmqwpLYJVQFQpLY2hVSjQRGvjZ
29063	payment	1650	1650	1375	1	1	8	5559000000000	110000000	\N	E4Yh779zw5ogHYm4q8CeDU2cJQMFX26oAfBHUTgFmAbbEnJPndDVX	CkpZ8ZNcpmXVFft7fBewKKDxsT1TcsVJwD34mtJfAno2bWSHW8fdY
29064	payment	1397	1397	1678	1	1	11835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSDz2q8Q4vJ1dLRVSVMdNQNAvWh9yW634LQKuhQqRTkh49KxSj
29065	delegation	2242	2242	1276	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3h87e31MpbVPbPtjuiJR48jUv9gzmVxnSbQA8Ct8kCcXLm3ks
29066	payment	2133	2133	1874	1	1	2247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5foYMKKi4YivKcVLuMsE6fqfv9jBcyBsmHyiuiZ7CUPBxGMke
29067	payment	2134	2134	1874	1	1	2679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qG8PiPa9oM2dkiLJoRZiAFXoNPfMUwkcjtZefkr1o6rdL8iv
29068	payment	1536	1536	260	1	1	10	287270000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNWd57nLSqEUup6h3sETqKyTKcxGSUo51GMNYMZVJWEsaGKRU
29078	payment	1397	1397	1678	1	1	11839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJZwJDWKuDrWrRoqgcvLMzxifk1JsWZ7C1jJLyXqgKssunAzV
29079	payment	1659	1659	548	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4EkotcDRfXHyTx6wFmxbYyqg1vm8aLsioFebjtKZPYGWUDpZA
29080	payment	2134	2134	1874	1	1	2683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD7zerjoPjndqfpKFaMWoFN3yuPHWJngw8sF1xwoBZYguTPZQz
29081	payment	2133	2133	1874	1	1	2251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLPiCSgjvyWJBFoKDgzgjuGSqczeUgEwGLo8ChqGR4FW7CJfR
29091	payment	1397	1397	1678	1	1	11843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwXtm2iEQCFQsLrSd522BDt4XQnpmvt1kNV3J3yBjjXGvuw2h
29092	payment	2133	2133	1874	1	1	2255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpqRViBfQ5XpND67U91HYN8uyvRVYFVAuE7LyPKkJFfBrwEM5
29093	payment	2134	2134	1874	1	1	2687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3MDhTJuRYjbxoKeoVDENRhUW8AUuXQ4cm6dedw1g7NZctxRb5
29124	payment	1773	1773	182	1	1	30	272591071808	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ3Gh2JVQxS5HpHY7eu2RfxghdNJSpfG7uti6LYxTNjNPuywKH7
29125	payment	1397	1397	1678	1	1	11851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgqbfzGuWdYyRpTcBnY7x8rWRkACDNtTTPMQkJ6CSzYZ5MPgQ
29126	payment	1773	1773	702	1	1	31	181727381213	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZwi18PV4sPkL6yGuG9BfrNzUDRyGzRnCGt8J8LJnsMWnNgvRy3
29127	payment	1773	1773	927	1	1	32	2072969920333	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZbajLCZtxbyYKoNfN6ePqJMEiHe3wAk7TXFxzKH2C3qa3eFEAV
29128	payment	1773	1773	1047	1	1	33	3714744336038	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZCxZ1XtvstzxNQjZwaMXo6My8ue4V4Sg9NRjTdXB33FWS8cYF6
29112	payment	2133	2133	1874	1	1	2260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAbhhkZh4ezfRW6bWqgzWeJS3BnKLZd82eB3aXon4fUAneCR9
29113	payment	2133	2133	1874	1	1	2261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3sqtPTdKSv1Hg3YxjXwzALW31dNisvExT3C5TJrMS9uVBx8hH
29114	payment	2134	2134	1874	1	1	2693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1fgomGK89Efe4WHh2WuiTtNDbSWnukkVLSB5guNBSPggUijD
29188	payment	2134	2134	1874	1	1	2706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBPm4DybMArzvXHjx7pBVj9kcBB1ZuZdXnFetnT4XiMm5uD9n
29189	payment	2133	2133	1874	1	1	2274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ehjJfF6XLnw6Ps2LPDXqv4D86ibB4GPm89pJNujhh2KPsTRV
29198	payment	1397	1397	1678	1	1	11861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDWJuQrPNViZNCLcaNst6ZEWK2xxzSnbqpMcXKPjP7Edhmzw3
29199	payment	2133	2133	1874	1	1	2277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmyxk7KqJvQxvYEDbnJo8HWF9w2Bbxh57Js7JHBTAKjJezVdoy
29200	payment	2133	2133	1874	1	1	2278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzjAcwaPKmVRyj184xXbBGTimzGkMb8jx1NHfFA39Vmouzwn7
29201	payment	2134	2134	1874	1	1	2708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkcdQ9PU8ygixJD32T8bLhcDiCVHMgfXixNgQCFJxCS1rqA4T
29202	payment	2134	2134	1874	1	1	2709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRn92kimfur8D8KFHyCmMGZoU3KyZDK3yLAY6DaLA42W1Cjxm8
29213	payment	1397	1397	1678	1	1	11865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffkowD644pE9ioc2ygsowxNwotDRZ91HDFVvp76Sg4MKenLg6
29214	payment	2134	2134	1874	1	1	2713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxgUt8GvRex1DxbqJAcPJZUdiYtkZFhpv3FyJvQTaR7XSgwEC
29215	payment	2133	2133	1874	1	1	2282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvF94cH3NCqRj4Dei6SWY7JjpRMjZjEKbEx3HUakvdxp6xPQv6
29216	payment	2132	2132	1874	1	1	764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZYRgLAtVdBhquPdEJh8nAA5Li4te1AAxXDbp8976VFWYu8rf
29217	payment	1397	1397	1678	1	1	11866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZcBDmbLYuubQi9VjzbYDX71YimNa4GiVrBNrWBdYXLynkTY8D
29218	payment	2133	2133	1874	1	1	2283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6SHKC8bD7NRD1bZPix8b3xKTYjaHwyqQQgcLPa7BmWsGTjZe
29219	payment	2134	2134	1874	1	1	2714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDerGbMKqNBMQxkGXcwoGauX3ZTEZv7zZ856BxZWDvz89zL5eZ
29230	payment	1397	1397	1678	1	1	11870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8CCxYTz1r4p7mqNBswxPKT1FmVspUn6X9YtnzbUp8LcWGn8c
29231	payment	2133	2133	1874	1	1	2287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdpkE1jufeuSTrizE4C4bEnWRF1xLN8kQA95Ga2Pp8et9eToi
29232	payment	2134	2134	1874	1	1	2718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkFkEKenesQuZaG4W6ahW8AfeZnCGE4Wnpj19u8isRkkVmtED
29243	payment	1397	1397	1678	1	1	11874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqmALNjPXM3h9rLP3j8DWvme1JmHNKjQbsHF5piShckAvAmxF
29244	payment	2133	2133	1874	1	1	2291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcZVgfskPC1T2pnGdiyUyoG8hzmWCVo8iaSdEhdpFcxrbstgJ
29245	payment	2134	2134	1874	1	1	2722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytNqExeK8rssc57Bw5tz3RF7kd8m6FT5DpDrh6CftR31kz6pz
29263	payment	1397	1397	1678	1	1	11880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFDwAZTac3kKg1VXnbGwcX8Pt1wC3wWWVt9z6DaYBXDkexzbJ
29264	payment	1397	1397	1678	1	1	11881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsCoK2v64MNyL3tcpE4RPCuJHj18JGyR5xoxKFtJRbc63m2n7
29265	payment	2133	2133	1874	1	1	2297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wLNdTqyxU3JkRHtWBUwfBQp1Ef7h1fSeFgAPSaK5jh6zdxyk
29266	payment	2133	2133	1874	1	1	2298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQ1wbjg4abtW8ouF6cVgrdcXmiKp3ZHuSgp5JpppzQQKkaorg
29267	payment	2134	2134	1874	1	1	2728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBc28d3Vw8Hpt1hzB7P1s5ynsUXmFJDyv4AWkdwQyuFfPrHd8
29286	payment	1397	1397	1678	1	1	11886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HY7Kzvo9U1eQAaaVEFHD37ZjTZQPbPNmPChtzm6SUcnWhJnr
29287	payment	2133	2133	1874	1	1	2303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CDNviDCSPc967LRUkYff1F6wuLMp1StRFtQJueDq4RxpHuuy
29288	payment	2134	2134	1874	1	1	2733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3TJvZ4P44Bdk26fYto36pZ26qnswqJBZBYm7zRDk8g56rpF7H
29295	payment	1397	1397	1678	1	1	11889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqJkd5TrjQRRcrfjtFKHQ8iZr4oM7AQCTmUWP8XGTSkZMdJd4
29296	payment	2133	2133	1874	1	1	2306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyrdFDPQkAvSkeJWqfndgKFkDJ2JBa3xyY5aQcdpw6eLqU5Ct
29297	payment	2132	2132	1874	1	1	771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnkLGVjP6pegfi35T73NNfkvKPnUvqKAJ9PJDQFQ8WyFXawyc
29312	payment	1397	1397	1678	1	1	11894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5z2LRWwZfbYD6YtNjMDFEftrTg6gCe2djNH66akZjR2WY4Nam
29313	payment	1397	1397	1678	1	1	11895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHKAtuJVUfmQpAqN5oMTAKm1wkRjTDSnEiWpHqrcjoWTKF2PQ
29314	payment	2132	2132	1874	1	1	773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7TDX5YRqHfnd5FjQH9569KoMJXqqF1vEUC8rprLPRqBfsCh5
29315	payment	2134	2134	1874	1	1	2740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstgWiD3U3jWtAmWPn4w2PCQiwi2gtXK3qrAnegWVaBQvcowow
29129	payment	1773	1773	1167	1	1	34	2506412025033	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZNLy8gUwrgg2tTKgVTRrsoZUBNtEKH9ZqNg42N2N4vkGH7CChi
29130	payment	1773	1773	1293	1	1	35	6984339965506	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZPhGWsbv5zfo4e99Azovm2HNr8KadDEXC1faQBeZpCnGH7W2Kz
29131	payment	2133	2133	1874	1	1	2263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1GMhZNw2998seNUsY6cRKCExPJu7rQuNW2HDvjTjsS9QKvtE
29132	payment	2134	2134	1874	1	1	2695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1xJ5k3BV81vB6kEMyZymrCojEFE6qx9dgREuz6bgcVbZ2m2K
29133	payment	2134	2134	1874	1	1	2696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m5pwRhVCXkK5ZkXfYmSGtqUfE8cbiFbqvVsRc3BDJhMY6mA6
29134	payment	1439	1439	1033	1	1	8	3051109920000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSECw5PbTmQAf39ovhgL7zYacZxR72tyySQkXdXrTAXMtkaf1
29135	payment	1439	1439	1279	1	1	9	5736596390000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK18LnYSSNP9Rheusms78R4o11FqsqaJji8d6YYp1UAQgkYK2k
29136	payment	2133	2133	1874	1	1	2264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E6E6bFMwBq687gXRv1FKxw6Nqfc5f99EG6Bg8R4wgBoR92Yy
29163	payment	1668	1668	1124	1	1	5	4418605000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8maxeZWMe5Q9ctpc7GxkTdGeXM7A3twVXX5otopB9UEwKBSi4
29164	payment	1397	1397	1678	1	1	11856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDGfqRg8YoY5KFkeJezQVKCcj3VBHSVbpwb7dDxFmyX2U41pM
29165	payment	1540	1540	1876	1	1	4	352803880000	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKYvGrjcfmg3iv1fbU4kh3WDCukzranwPQoRLsvRtUzH1qCT9
29166	payment	2133	2133	1874	1	1	2269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBXySypzJxJJCdgvopPbyq9iVYqnCn9P11fALhfn7wrkC8etu
29167	payment	2132	2132	1874	1	1	760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNsjAMRiixNCNrFWt38TGJ2uHeKsgWEiFuu2MxvNHHyxb1MRt
29168	payment	2134	2134	1874	1	1	2701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNugRi9cLtckhjjPm6wUZcJUnEgEy58BvXpFQp3QCwBgk1ZgHz
29184	payment	1397	1397	1678	1	1	11860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJaaFuwuoZo7eo3iDwrQ1WCWo6FRAztRfcjRBKe5AzfRK7uKCz
29185	payment	2134	2134	1874	1	1	2705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3YBYxi16S1JQKbZdEGEWQzq1FHESCvYmP8gmJAT9obHJEj4a
29186	payment	2133	2133	1874	1	1	2273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzuUsf2sF1p5JG3BygbW2NmJjz4rFkZKhVRzA99NsoPokfNan
29187	payment	1726	1726	2250	1	1	8253	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaAwAaAMTNCs57J7sZaDVrkvdGdV55g9Je3AS1T5eXKoBWC1JpT
29193	payment	2133	2133	1874	1	1	2276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUs7NDUrRCM4UNiMEaRb38CVDehECr8nyuw8nyNN5eTz1GMFv4
29194	payment	1419	1419	813	1	1	4	2566101505173	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzDFjyAT1Dp8REdwHkmSWjxE12MQJ1TX5f8GzyiyEvM628Kat
29195	payment	1419	1419	814	1	1	5	28227091922595	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXoYSjv73KAMZ9RuNz9ePf9qmVExFw18ZqPfNaTTezsfrQ75W
29196	payment	2134	2134	1874	1	1	2707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFgvetxm7gkp2urkc64zRSeX7SxyXzSmHKj8p2muLyC1mXE1R
29197	payment	2132	2132	1874	1	1	762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Aho8r4dkTkj4Yfx8fxYsCBtnv7eRgWdWfnZEKsf3X95XcDz8
29203	payment	1397	1397	1678	1	1	11862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6uJfxA5NXB94eHjafm4xpPKQZitdiz8jBdazaDRjRnV9Xy88
29204	payment	1397	1397	1678	1	1	11863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqvBYBz5Rc2F7BpqLuPR9K21XZHAtNDRTHtLMo2X6Bn7xuZTB
29205	payment	1397	1397	1678	1	1	11864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4Q7FFxCUoYtboH1MkY3hko2gpsaqqtphEEJ6wTQJAsNf2i3C
29206	payment	2132	2132	1874	1	1	763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdHYdyv8EkDvnLSz8Z3rhA8dWRyuTVsbTDiqEBX8YRUxjVcKc
29207	payment	2134	2134	1874	1	1	2710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bXEhciYaGLBod66P75uBks3p6SP7AV8RQ3Y6hpWbhtTZZSJ1
29208	payment	2133	2133	1874	1	1	2279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Tj9TWH7CqpGf72i6U3khVF2DfUUYSShDWCsGQG43nBRQayMU
29209	payment	2133	2133	1874	1	1	2280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5m6rc289bxRk5jZZ47PJxWysEJHTGHj5NBcofpvMmuTHj4rUr
29210	payment	2133	2133	1874	1	1	2281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHvPk1QPyVKiwAr4aqBiw24wsR2CJZagDQYz6TdyyiwsAn8wm
29211	payment	2134	2134	1874	1	1	2711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBiNuLq1FyKkgbECV6Q5ramQmfxZfC9TejVBsYoomumib34uw3
29212	payment	2134	2134	1874	1	1	2712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HsqPLoRgNH84ctx9sWtU3c4jxvuizSHrNxY9ckcmABi46Qnd
29259	payment	1397	1397	1678	1	1	11879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbbCERsrgEdi21KswiLekBSo48cTCQ8VnBsvELdjPxaUzp75U
29260	payment	2134	2134	1874	1	1	2727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8GR5xwzG7pFkmC3HD41fjDSBe8tuSZd4iN4SxDDZ4gHJTQa8
29261	payment	2132	2132	1874	1	1	768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UA2G4cqbzStuY8Cy2585PML2gdU6bh6n6HCc9n4wvKXpAjV7
29262	payment	2133	2133	1874	1	1	2296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGChZsVrrqgbyvLY2FbYeo767joVAJWjMfVmSSEWytrFz8hukd
29274	payment	1397	1397	1678	1	1	11883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBrs1LQoskn9CbeFnT1s16sUf66ZUtoWykrfytvqdPyqTPa9X
29150	payment	1397	1397	1678	1	1	11852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTW1taM5qo6ufgCof8LzdJTF6ALzdNManw7n5a7D6W81KWPJBP
29151	payment	1610	1610	1983	1	1	10	1344032450000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyFrZiHBaRijsKALHXKqhmL3m3Ndo25JP6de61sVNDwv6e7Fs
29152	payment	1397	1397	1678	1	1	11853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeig8RLipbSbyhMiBrXcDKDvo1kZDudn4BjxN7YbeMStJWa8PF
29153	payment	1397	1397	1678	1	1	11854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4vhwGbTMd45LiC2jq1W67ahFFCYFshNH4hCUujzE9HGJnp1X
29154	payment	1397	1397	1678	1	1	11855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCb7smBdv5rcBFoz2KzeFDHZRodsAGZyrtUUGd4uaca4qd7fv
29155	payment	2133	2133	1874	1	1	2265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRvTwQTs7BmHRAs7NpSxbwG9xKUjKVkDwWYgWUXowm9iirGB1a
29156	payment	2134	2134	1874	1	1	2697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAp3WXroMB2Ks37BYiiKszvnpe5v1bXMfaRgYCWTpD9ivnE4FL
29157	payment	2134	2134	1874	1	1	2698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLBnyiD7ZKASByiRK8F5efwZ9FbHCmBoe2aZmmYV78a52L98U
29158	payment	2134	2134	1874	1	1	2699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1Q5yjpeQTH38ar4f3obcar7UHjFNHvt5LuJZRxzwv8RkQXYe
29159	payment	2133	2133	1874	1	1	2266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirG7MakM1nWHwCadqJkRLcnh3hFPf3JThFEd2vpy95BxScFdK
29160	payment	2133	2133	1874	1	1	2267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCQ49a2iSAqshem7xD93Z4JjoAvrSHuWxwZcH4j463DXeBc4i
29161	payment	2133	2133	1874	1	1	2268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5Y5Dp3Duo77kccdTy1UxUdWvi2udoJj1kJ6SeZ1pA7mwYDFZ
29162	payment	2134	2134	1874	1	1	2700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UDbPpNBKaWoyGLyyAEL6ppq1mj4QfBNQPpyD6xAGdhoMTQbV
29178	payment	1668	1668	1370	1	1	7	8307716000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5ZDpTTVV6kDPBi6pUoNCVdvJBM3LeFfLs8nss954z7sXupXL
29179	payment	1397	1397	1678	1	1	11859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYbutJzYR122wyBAhenPUvoHbnLFzxLmbH6ZHmErRnrJ2qyHa
29180	payment	2133	2133	1874	1	1	2272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbW3z9kq4g2K5nHXkqQMbcoksXDMQEUhHARfKgHS44mMnuE91E
29181	payment	2132	2132	1874	1	1	761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjS2nqMaksYhgxjpUxo1DHeVB67zTfPxgqWDhjFnvbnxpmoqAE
29182	payment	2134	2134	1874	1	1	2704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWpAAmWRqVe6ycp8h6aZ3k7smvFujF5N5L3chjW8Kh4qv53CR
29183	payment	1726	1726	2249	1	1	8252	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWVkiUFuSrSJ2hU3F3P5RZoUr5Xq99AuEGdb7JYqvCXLj3eM7D
29246	payment	1397	1397	1678	1	1	11875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1tW7W42AVyd5wKcBW4JX7dDJvpf45y6YZUYfsB8ah4iFoGDs
29247	payment	2133	2133	1874	1	1	2292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBYsF7GKDX2ybQonbP7D8RvySBMLGtimAXMe5poZdVxVb6u8g
29248	payment	2132	2132	1874	1	1	767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5AJec9DdRWJjwHKinhydspovY8YnAGQommippTo241Uz8sTh
29249	payment	2134	2134	1874	1	1	2723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBUJ7D2VTG8Q3fJkyRKahnnBhFFxKwpnumtGM5qEMUEvi6qVs
29292	payment	1397	1397	1678	1	1	11888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3P4WpLWQY3hxP188EQQeVEF5nFLhHgPxhCx41eFnpxtWX1TGk
29293	payment	2134	2134	1874	1	1	2735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2f9MNaFUd1STrEVmmVE3XgQvmLiYTdLdzqvvHGqUZW37Wt1o
29294	payment	2133	2133	1874	1	1	2305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSX9iV3a1xg3DYvCHBER5tMHbT2ZsDiiP1q7TToYVgkqLcC84
29301	payment	1397	1397	1678	1	1	11891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYinjwFLEQ5ABqCz2iomyKX9fWp15bQsFhj7oqhMyh6HoNg2tvG
29302	payment	1397	1397	1678	1	1	11892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4prk7pCC4EL533QqqrCTtGpgPyfmpXTbdVBceS9AqJ1G1yMG4
29303	payment	2226	2226	391	1	1	0	490000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCUckcZh8pFdCuG1rt2VVa7nSRazrhzsHuocdohqqdLxuirgF
29304	payment	2133	2133	1874	1	1	2308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBsoFrjebhtfZW66gTCKPSr1E4KEPUuq2YwEunbY4Uc89E5rU
29305	payment	2134	2134	1874	1	1	2737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN74fk7Hao9LpUZJTmDaGtf6TPPqgjfvNH5dQLEbx5obEYsZkP
29306	payment	2134	2134	1874	1	1	2738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAnRi7JGRhutxtE8N3iy6CZjxzeqxwryojXtoZvg4xCJXWRLC
29307	payment	2132	2132	1874	1	1	772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2R9khnfFvRCpZGUXnXidaPp7rj13u4EE9yF7Nh7A1oRAARfuu
29308	payment	2133	2133	1874	1	1	2309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBH4dbYV7PgtHog1DGpf8sLV15PigEsCzYUR9byWkDQqcnXGg2
29319	payment	1397	1397	1678	1	1	11896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYos6YVifYHRcb9QhnJuymqFzsGygRH8nwwVSJyujrzcZN4DyfT
29320	payment	1397	1397	1678	1	1	11897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvi4iGKMrqq6JqgVCdQehpdmNxFv2ih3jW6rmzZZGrHbkMYK8o
29321	payment	1397	1397	1678	1	1	11898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFHUnfRP8oX4aZTHMbQDjsM6okiT7o41Fa87xn4BhwTzu3Xax
29322	payment	2133	2133	1874	1	1	2313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXxwqWJNDvBUArhBakikGQp4Ufa9gh9wJjYVCdsJEmsiFF7vN
29192	payment	2133	2133	1874	1	1	2275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfzH2i5SUsTD1tA6ZuMd6v69jpb8uKwrMyzNdyV7rMZvkmC5Q
29220	payment	1397	1397	1678	1	1	11867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj6m6Han4Ft2qRaw4gqz7XCuEBRhrX6cVuUbpNggzbXijsT6E
29221	payment	1397	1397	1678	1	1	11868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL37ytxEhwEfZGjoyerX3bfg3pVUpVKz18dZPwwiZnywWLZG1Q
29222	payment	1397	1397	1678	1	1	11869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5RpLqJXkx7MyoZJtnSJuoQWQeX9286WSbpvD4ApBHec9tnZx
29223	payment	2133	2133	1874	1	1	2284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KrA5eMfMYWTME4sLYpmCXCfGzFFeHQbE9sKH9GGbjdumZN3X
29224	payment	2134	2134	1874	1	1	2715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrE84RNty712mgv9BztXpoNQKtfo4dcRB7Th5z4vThYUtLNfe
29225	payment	2134	2134	1874	1	1	2716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaA64wdFTNwLVwLhRw7jvr4Hs3yibzJUodwHd1GUQTGHRHEzP1
29226	payment	2134	2134	1874	1	1	2717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xg9T1nXoSYNJrwhcnkvo2fPQU8qsdQEJgRaLBYovim7zoeyS
29227	payment	2132	2132	1874	1	1	765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiprvxMuXWzro3WrxqH8kF9xwC4shQTcdcWFM7Cfjp8CWMYoWz
29228	payment	2133	2133	1874	1	1	2285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ShcRXHSmZJKAfebGkNAbfVr34W4vdjoQfcCiTS2QfJ1DEb8g
29229	payment	2133	2133	1874	1	1	2286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQBvL4ZbnnG9wAYbJk9MY8t8uiNZuzPAfLiXZRWt3RRo7KiKP
29233	payment	1397	1397	1678	1	1	11871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQZr48mxWazQeMFtcTF9kesD2VZREJZvA5rUmyDjd95wWhQLf
29234	payment	1397	1397	1678	1	1	11872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTnw6QycFMz3vhehaF1sm48MjKLqGjguJwGVtXCLBo7cz6cCg
29235	payment	1397	1397	1678	1	1	11873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWjj1isP4pqXHMdB2bL8JGo6PxzykfgY1VyMNCLCfd9s67BcV
29236	payment	2133	2133	1874	1	1	2288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3sqmEi9gSrbjZ7hwLdEXpiwKFNV5X3ZW1WPDTPe5rRa1vyBR
29237	payment	2133	2133	1874	1	1	2289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuN7WuKxFa2ns57NNo4NBjGgLrdkvQ88yb8jvhgvKrATqzzo5d
29238	payment	2133	2133	1874	1	1	2290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5FJMqbdxMbMogkf3amsMz6va5RbxEGrYeC852sAzFhYqTE5F
29239	payment	2134	2134	1874	1	1	2719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUdpmrWdK3uGQYFaatzGJxFxtzpRfau6ZpTCJLqk7aYVhPxex
29240	payment	2134	2134	1874	1	1	2720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9pohe1SFmn3b6bSLfncffkAKucz7eNs9QEEfgzRmdQJvDpr2
29241	payment	2134	2134	1874	1	1	2721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttwMXfzEFxxw1N8ZoEJwwj2ujAbQjm1o5gF7Gyte91ajWpusb
29242	payment	2132	2132	1874	1	1	766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAN95zjJf45NkMEhCeRoQAfbLaj3ASGpvVV92EP1ko2f54bJ3
29250	payment	1397	1397	1678	1	1	11876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLpDxcCzUfs6QLtJ3mBnDr1rRS2Lrp1dJY3ggKUY28Tc7L8pt
29251	payment	1397	1397	1678	1	1	11877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4LcMZHYcUFtUsCwcWhbE8HwPEvxCfb2xgxyMPa8PEHFCG9QDc
29252	payment	1397	1397	1678	1	1	11878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHhtBzK8kyTkWhTd6mPuUq2KNngUXRUs7MkkmPJhShK9fyWw5
29253	payment	2133	2133	1874	1	1	2293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotyckhMrUjTTH2wYjpWuva1jTUD4xTEkKzKm8SrkYWAjpAV65
29254	payment	2134	2134	1874	1	1	2724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxR7ikbp417DTacveq5rpbYV77CMgREH8H5ZjnVBP3KPA3PeN
29255	payment	2134	2134	1874	1	1	2725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4XYrSoiyWBAQyFeAb3hPfwCiFZhp9dBYu7iHbGUpnaBG8UAp
29256	payment	2134	2134	1874	1	1	2726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ55ZBjkNfGE4J6oZJpziVJFt1zPTZhXUbgfsv8LgT7Avf7LG
29257	payment	2133	2133	1874	1	1	2294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEsEJVCW3xrbQc9rhyQxuWkTo3vpTFEaiLeiCV6SznmDaWRYtM
29258	payment	2133	2133	1874	1	1	2295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtRGNFoWqvTicx59h1T24KJeFFsenSanAc1pNGAaVrpNjBymh
29268	payment	1397	1397	1678	1	1	11882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG4yU4UkknMSJvTQ8uxyFz1DDsPVpGEJfau9uHG97Jq33rvK8
29269	payment	1700	1700	1305	1	1	6	8590478876308	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpZKrNhdiVYnVjELZ8E1BzbMJEjzU2jr4eFaLN2M3z6rP69iriyG
29270	payment	1700	1700	1179	1	1	7	3082793744688	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYpNBcn2tfEEstSWCdhV8qbAbxepD6MySjRStdYSqJsgRTufSe9
29271	payment	2132	2132	1874	1	1	769	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUj7jcLvnAGXhX8rbXdkJGX9LMqo169hzQfKievMNZjG2jbSnn
29272	payment	2133	2133	1874	1	1	2299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrZJBV6h9d3cXpN9f56H7arvtMaS9xKG64v7ZY2ak1DzxjFkNh
29273	payment	2134	2134	1874	1	1	2729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyoeeccFfG9c9UWg1dWaMpx348qnW3eA7avxPbrbiYJ1V3jnB
29278	payment	1700	1700	939	1	1	9	2549676046680	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpYt8H93wKA6LoRBdB1uyNQX2ZJFC3FEbRA2oEvtUuwAeoyA2b6h
29279	payment	1397	1397	1678	1	1	11884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QYngzyTUAsVPuv91ML6E1i2feRU4hYZUdbGQpnKUjtgGFPDa
29275	payment	1700	1700	1059	1	1	8	4568997630008	10000000	\N	E4YhJ6ev66b7Y42GPAL7tPptyqwJhSche1K3vv1KSidaGvZpAR8sY	CkpZ3s6NwESRsHAgfLVwSUpzvMtkLGXwEuXPtGoMsDxADYfa3NvnM
29276	payment	2133	2133	1874	1	1	2300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJrVajwYeVQos6XEgmBsNShXX9o4K5xdnqVovsb98UFejXtHPf
29277	payment	2134	2134	1874	1	1	2730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyhJom3D7wQP5fNjZVC1ZZj3Syo4Fh9v9RPnstX2xhv9U8Gmf
29289	payment	1397	1397	1678	1	1	11887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67FVNDtUB2jb6nNY9GX5rHYUoLfhRCs36hGSLG1jDgMRfUWVj
29290	payment	2134	2134	1874	1	1	2734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJ6xUehb6QqM9cyjkiED5G9uybJmCzM92bL9TVfb6QPA4gi2o
29291	payment	2133	2133	1874	1	1	2304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnpQmPzXoeYuuLDQ8n6X8kd24RHUyCNJzWTvUxUX2nFDnLiCh
29309	payment	1397	1397	1678	1	1	11893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDKwXcxfQrkHGve4CpfYH1fuqUYuKByeqQC9gjkMuDHoMErgkB
29310	payment	2133	2133	1874	1	1	2310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFQuRNZdxquuXjjhj8Qf4W2Histb9ZTjGN2cXDBm552HDPk1U
29311	payment	2134	2134	1874	1	1	2739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMDyVKEwAd3DZvWwbpFC7TzgJoZzNCP9ygMJVaejKF2iUcA9f
29354	payment	1397	1397	1678	1	1	11906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtH2Eg1sGLZoz1TwS5apb4cQq6nCSWknhKbpwzo7GWFhTuGpP6
29355	payment	2133	2133	1874	1	1	2322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjemnj3hSbBJxcKMw6kgzvnhvWJt2pbjsU6KBjp1BbEiCLGmEf
29356	payment	2134	2134	1874	1	1	2751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwahUu1xf9qAGqxTWn8YTPVuz6d78bQDQGqDzazAFMdptNvrLv
29364	payment	1397	1397	1678	1	1	11909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xkfDxkhQ69QCkE2ZR2SZk6iWQV55DnxF9TmWeVPPsMz4egTE
29365	payment	606	606	1049	1	1	15	3595685819297	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqc2MdDu4LMZS2mFXoF7yqq6pfMSkrW55HEoj2KfmUsuzS34nv
29366	payment	606	606	1169	1	1	16	2426406151455	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiitrEBZeDHWxHshfHwfWjaBn6QJKn1SqNa4StEaiUJ3nmzh6m
29367	payment	606	606	929	1	1	17	2006972659861	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUEAxyYuzJ8FhmPj6StubtD8g9DAyy24oRADZVFKGGd3BsebJ
29368	payment	2134	2134	1874	1	1	2754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpJxpn1DxURiXny2HxY8dn4pGLnKnHPzqQcUHK381vNyj8pTt
29369	payment	2132	2132	1874	1	1	777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrtVqPk9eUr5CQ7QsaQfWGc1oMeWyGJNv7WcTpSqoT7LDphJS
29370	payment	2133	2133	1874	1	1	2325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SjxATzARKVEsKTPmGb7Cm3THyCinqbRiFLEfiJH4iciAmnpg
29382	payment	1397	1397	1678	1	1	11913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9J35ssRReamCVAYVAuC4fBf6334ooW8EWGBpVxJjpmxzSvois
29383	payment	1397	1397	1678	1	1	11914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLiii6TKiwFX1mkXgrQJhXe49xm3RnzfnNE2R6gxFnDmDDoVmy
29384	payment	2133	2133	1874	1	1	2329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfBnikVwcfqBq291U4xcpDCahu28P3TDSfpG4Fsinr9bN8zqUr
29385	payment	2134	2134	1874	1	1	2758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVtNPQ3KJfLtmPGNqykjd86umd2YqxtDsNzTGbf47EXVHiGzj
29386	payment	2133	2133	1874	1	1	2330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshR8rN6nWgFrneTvYEWcGxsbx2FvQFso7V8wyoNVJmBq8YabK
29387	payment	2134	2134	1874	1	1	2759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8z1M5RujTi882TS5FytyY55mFMscs44We9pksyM3fz4txL5zG
29443	payment	1397	1397	1678	1	1	11932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREFDjBTNrRvQfuE8rM3zyHJZvmZL2dGrguMpBP14iZv7agEcD
29444	payment	2134	2134	1874	1	1	2776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHDZBfVE3iSERfZtsN28Xnn75XG4j4aM3EfVQ3KvvNtYENmop
29445	payment	2132	2132	1874	1	1	784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBZR5T2gsaXbqUcfd74ERxtKu74m3NB6bjPB7ypkorMti8G99
29484	payment	1397	1397	1678	1	1	11944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwZMDrj4EbvxSA7U6zoPzfFXuTFcwePmVSFFvdcYHaAhNQadL
29485	payment	2134	2134	1874	1	1	2788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEv9q73RydbtVWhiXt2mh55XRQfUDw17heBZTAbi7hVNbAzAzw
29486	payment	2133	2133	1874	1	1	2361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8LRq2NQgDpByEFtGmPcHj9F65gR1xrazfSZjsuBF1k7T7mAt
29487	payment	2132	2132	1874	1	1	788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwX9SuiXaJ4n6BnwAtHsFkHAQHTcZk4rvTq3TwHVpSAAdmpX8v
29523	payment	1397	1397	1678	1	1	11956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEbKGMar8BDAawFXDRPf1Xgy63SV6AkbsFwq5nHtN4m5RaoPq
29524	payment	2134	2134	1874	1	1	2799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dw1nePqf49nNP4y9SddXWmcqXg1BrPqjiSQKrEU7uEF2eMLY
29525	payment	2133	2133	1874	1	1	2373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2WxuVwxasnS76euUxo2yuB3yH7evS1KJ7AYQ7LmFY9SsvXXy
29546	payment	1397	1397	1678	1	1	11963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPfXiUaF4TEfeGTdWhrtAJZSHWDB4kmrqQ5BQHTXTsNooFEybX
29547	payment	1397	1397	1678	1	1	11964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvjw7FwKSPGo1C1YaoPxPw3akgdJAsCF9tkYHthPH5E3yZH4A
29548	payment	2134	2134	1874	1	1	2806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVikYALR2Rj1Ra46QxSC1r5axSczJZGZx221y3ALUBz1dzsS1c
29280	payment	1397	1397	1678	1	1	11885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDq9zvmnVtYnidDk627FssZFxLB68zgG8nTzuB6GYBnBtX5d5K
29281	payment	2133	2133	1874	1	1	2301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNfKtE5P5bCJFvChzS6oLJEE9Uky7wLwu6zvMXk1fSAKVvqkv
29282	payment	2133	2133	1874	1	1	2302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42tab5cuWkMd9kCca29jRgP25rPWSjFfRVibVLmo8YBuNHASK
29283	payment	2134	2134	1874	1	1	2731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8Th1gyGvHgbuhffwMy7roox4zGufWy3je4KbUdvPmnhHuSG5
29284	payment	2134	2134	1874	1	1	2732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKxmKMNk4VwDKsF81vS4c4dJkumt9k2G9v1Zraq5c3JeDhPW4
29285	payment	2132	2132	1874	1	1	770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGnkeM9i7DEygT76fVbhvoJfNVyNzAPby658xCufbdDT46T8A
29298	payment	1397	1397	1678	1	1	11890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfKM3uN8T1CTXMWuef4JJie2wgExqkoGV4z6nsUnLdBKGd7wP
29299	payment	2134	2134	1874	1	1	2736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjMV7YKi69BkEsKVJJFKiV6P4BcfGjDKpVMwKTVJziJagKyg8
29300	payment	2133	2133	1874	1	1	2307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBvr7vusiSkxWTXNDiT8oDNVADaCuawMWmXXEH85WyK1dHz8Q
29349	payment	1397	1397	1678	1	1	11905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GMJRTD9Q8ufyg6CGrGkWg9VPofQw27BPwoXdUeYBHH1Nt1fH
29350	payment	2134	2134	1874	1	1	2750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFf956JFnc12KdXWFXchPPvtY22MZZmC2KqTnCxCJJMs8S1cH
29351	payment	2133	2133	1874	1	1	2321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1X7ooN4ZB8quPadHqCU3jWADuCETJSvFTPKpvJnMLUzH9gQFg
29352	payment	2132	2132	1874	1	1	776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRNjjHZFSWMrsqMT8avXtfmAq2vyFFqzknJzy6VsdTg6YhpTW
29353	payment	1710	1710	1280	1	1	9	9216286221960	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoK2rNMUgVtQe2niakkxrk9XKkRoEz2vAWJ9HmDSVUDrVU54W
29360	payment	606	606	1295	1	1	14	6759609896119	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmL9m4WKUTmivG8v56KKG6DETbp6VY9EuFoy69mtQQnpYn3sc
29361	payment	1397	1397	1678	1	1	11908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfUkdMHMoBZNQUzdAiDZFgR6tFqVBUaGSfLw6wCgwbqpvgryx
29362	payment	2133	2133	1874	1	1	2324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBzUFa9LFi2nS3tJ5D6LcsCNJ6Z3Tm86sBQCrE4jvdjCMxrmo
29363	payment	2134	2134	1874	1	1	2753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDz6HiQ2a5YoXyPwpZ5y9P9jtTVo69uo493B525vaweyT6E5iB
29374	payment	1710	1710	1280	1	1	9	9216286221960	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYJBWrZBXHpTCZJGAdvHP4y6MbYpeQtrHDYNEuKdxv2opjUQU
29375	payment	1397	1397	1678	1	1	11911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8H6mxZhW2fjeG6NkWsi4Es5pRwzMRxKrYGLGdaMdSNky7DoVy
29376	payment	1397	1397	1678	1	1	11912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYroqs78ZD9occBz5H6nY4j7v29icsPhds5nQFSzcxFca4g9sNL
29377	payment	2134	2134	1874	1	1	2756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RpeEJ7nAX8XfjktK9mnNDy2QW2S1RxgCwf35xTSs3kuLJmfq
29378	payment	2132	2132	1874	1	1	778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M7L1gLYarpfjXLFAMn31QsYNZ7YGKMNpNG4ncaHMDSCPwm6D
29379	payment	2133	2133	1874	1	1	2327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS9wu1G3KWPnsnvMi4JyR7rMmQs7nmLUdK6u3opWqXTJPcnYS
29380	payment	2133	2133	1874	1	1	2328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghS74HkwPDeC36BsKAfUsUNdmnMHb61NjcD1Gxc6cD34roS91
29381	payment	2134	2134	1874	1	1	2757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBBiEKwmTewbpvb8PypA9HJWghnDHv4Xs43dZyq2r84Afufky
29410	payment	1397	1397	1678	1	1	11922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAths3S9bRiTM7Wd7cZPAnxWrfKeKM5inBX86FKkJVmCkCmkfr
29411	payment	1397	1397	1678	1	1	11923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwb2bzKehxBPxnHMvansmzK3h65qwrJSXzf9Xvaf192ezyCpm
29412	payment	2134	2134	1874	1	1	2766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YwaNj8tzpwA9Efwb58zHrsAzNHE8K6gautLLGKEn4EWFxgGP
29413	payment	2134	2134	1874	1	1	2767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXufNUnXXY1yWdUWP411ftUh6pUU2m4bwPivJEyzLPjRGzz9p2
29414	payment	2133	2133	1874	1	1	2338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfcZtAmRp6B7tio3JLQXXk9KVWZMY69t7pVe89w9Q7VigBo3B
29415	payment	2133	2133	1874	1	1	2339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMg87qB9aGczDRsZsELritL1PAfQ9iDe5EpRtLVxMEhH4Fmd9
29416	payment	2132	2132	1874	1	1	781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcknt2kXQxL95KABzsEKy29rHGvctCNuw5AGeSsQBiHSmwFir
29447	payment	1397	1397	1678	1	1	11933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14ZdF3AiGqgffLQqT7vGetvra2fWweiMBniQukmMBq2bhwALW
29448	payment	1397	1397	1678	1	1	11934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5pW2CNbu3fTuBN2CmLB8sEbW1Xb5mgWhbFkSc3hLYNhDrVTR
29449	payment	2133	2133	1874	1	1	2349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhh6no9Yd1mAHHMn25B8pnWcq67NJ8mKUjawguqnYrDGRNJ3v
29450	payment	2133	2133	1874	1	1	2350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnM3E9tsWGRbTjPDGbsAGWdzV7a8oHyx7U61dpndm6omkd8ayk
29451	payment	2134	2134	1874	1	1	2777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTewT5xwpggzKUPPgK6hCmzmSqFspY3EdBks57QUyJDR7PLNY
29316	payment	2133	2133	1874	1	1	2311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUWiCsmewg5WBRANtNkPHz1AXxrbfCWaNVQYTNrMqAtE2j9GM
29317	payment	2133	2133	1874	1	1	2312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjStEifjXojaCW5tMdAiwWLZ8XrtH9ceD6aphE7Hg6MHHfpgeb
29318	payment	2134	2134	1874	1	1	2741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eTCx4ChhCteXGRcXrXrhWqDiAis7kSgutvMuhEQDkhWyphJ5
29327	payment	1397	1397	1678	1	1	11899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LuAhCHkeQNK8tRSpLZvTxDgDQGyQrkJrt8yrMW4RtRxFnM2p
29328	payment	2132	2132	1874	1	1	774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2UVVLpXGUFd6XSUTEVNy84g3D4oWrmhhBgoUQdA1yBUG1ih4
29329	payment	2134	2134	1874	1	1	2744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YBM1LshS8JvnWDDjbDqCKpAfn5yUDBYT2Q4QCkjLakVuDtUi
29330	payment	1397	1397	1678	1	1	11900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMbbwp1qjk9hsmn7yCNVRFZY6inSsQgoSYX44X8d3btPNL1UY
29331	payment	1397	1397	1678	1	1	11901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEJVoFd2HTGwx5WTGwi1RMRCGX94KQZ67Ks8LoY5v77J13ofA
29332	payment	2133	2133	1874	1	1	2316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5W1WBWhoAMXLiNaicZqefcT18qtPnhdHz4ToVJ2HWcq5yQekF
29333	payment	2133	2133	1874	1	1	2317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQG1fuDaNkwkCozMNgCukpop1pX85VS6PuZK7SEsu4Rb6BFhA
29334	payment	2134	2134	1874	1	1	2745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxNGtbgM7Zk8TC3MaGRcfWiRu9sNkxhy6s81TapdXD7RnTQNf
29335	payment	2134	2134	1874	1	1	2746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXqaUKvBGaGN8q7KWenZxugEPvyUhWqoaCC48RYMatWGMdHNb
29336	payment	1397	1397	1678	1	1	11902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4xQ23dGMQYCxUxQtTM95i6Kq7Df2ZaFYtWP4qwV3QxKL5ez3s
29337	payment	2134	2134	1874	1	1	2747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5cxXo8CbJ9PdXHZ85aRehE4F8L4waiw8tEbnReAY3Np7d9KL
29338	payment	2133	2133	1874	1	1	2318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vFhinLNMxTM5u3QHH6bVabT1Xvj8bfmX9VBcxP4oKkuvRHfS
29339	payment	2132	2132	1874	1	1	775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa223T794sh5D9cgVsMxobir72p6aVAfAU6vd2LtiWDSMYEBhQ5
29357	payment	1397	1397	1678	1	1	11907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKyYF1UBTkwJAkgXZjy25D8d2kduBb77nDY6CBXtEhWZviRao
29358	payment	2134	2134	1874	1	1	2752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTe18sDXZqf9svfieKGZSemafs37oiigqpdHj4xkZ1YTVTK5kx
29359	payment	2133	2133	1874	1	1	2323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9obq49PPYTNZ9RLexDFXaTD7UWtP6echNvioBFKYBGoX5qvG
29388	payment	1397	1397	1678	1	1	11915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqakArjExcNuEK49MvXLmqLiomrDGAVc6n1tZbef6Mqtc6krGJ
29389	payment	1397	1397	1678	1	1	11916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpk4XPX2LzWqoSQ6GZoHEawaL94h9BfcLE8vJLDGvEPCg27FM
29390	payment	2132	2132	1874	1	1	779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsqbVViK6zcLx6E6MGqb946P1rKRoiiEr1k8rjuHf3tctVxYvX
29391	payment	2133	2133	1874	1	1	2331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJRytpZQq4sBPDUFTXxda1MTL2x717saQEEHEFUDJeNXVnaVv
29392	payment	2133	2133	1874	1	1	2332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYke8vJWnnVAYFiwkPci94MYbtH9Ub1QTTX3RJzKb4M1uT3xAJT
29393	payment	2134	2134	1874	1	1	2760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopbcWBbm3kiyjgmu5HunaVDce4sY4DJAXPmGyN8S61bvzHzYv
29394	payment	2134	2134	1874	1	1	2761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYXQnQZYnFJnTUEjs3RNsBg2d36rZUitDthNH8Xi4W42zxJu3
29395	payment	1397	1397	1678	1	1	11917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ23QMU4HYEFQZ2zBv7ZGt1fkQXuNV92VmEFwFPAF9vSHxnNVpc
29396	payment	1397	1397	1678	1	1	11918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDySGbZXduuWEk1DPRtx19fRp4GwPMMn5UPqk9VUVtaxSQhHiT
29397	payment	1397	1397	1678	1	1	11919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmkcJj5UxAgysD58ZyPKq74CeyzHgdm1emYmxAe1z8Z5csqLb
29398	payment	2133	2133	1874	1	1	2333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmH6qP5xk2gzvVH7xFGL6CuJA6sofmTHdEi6iyKJmPfeYNTKrV
29399	payment	2134	2134	1874	1	1	2762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntbA1rGyRo6ouoBA51i8nbk5DhUFX1KFEk5mxRnMDxnxhpGQe
29400	payment	2132	2132	1874	1	1	780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDEBTPWCgb5NqnuzMwnf4Racr2moqbamoikCpkvF4cxhcSRiw
29401	payment	2133	2133	1874	1	1	2334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzY2f9cfTTDbpNrKpdSgyYuxFoF5gr9fRZJAk8k7WgcB99RYMC
29402	payment	2134	2134	1874	1	1	2763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uZcdM8xtLE6eXcJgBt7LNAzWLzpg1HwequX72QWphcv1wayB
29403	payment	2133	2133	1874	1	1	2335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJ7yrNZahwV44YPhSKTG6rUhVZqYwxUD6VwPb64DZJygFjuMU
29404	payment	1397	1397	1678	1	1	11920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZQC4qgrgyRuxa26mZKfyDCtBUhVMUVg8mwgbqv9CJDzzqCm4
29405	payment	2134	2134	1874	1	1	2764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrHwoiiG2dAaZRLGKvVpSgnwbtVu1ipDeoThU4Uux1AWw6jQbp
29406	payment	2133	2133	1874	1	1	2336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gDYCQg3V5K2zG22JSPtHeG2vh5ub8wMhUPQaTraDbb8dyreX
29323	payment	2133	2133	1874	1	1	2314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgoLjGYvvfd65sdAEYcUh1Yzs5UP6gudxno9eKAXPVwZ452rB
29324	payment	2133	2133	1874	1	1	2315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb99gM8R2M4FP9ahDZbVizBoudLxJiqjwyiyeNzQf14ZyEc7T
29325	payment	2134	2134	1874	1	1	2742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrx4FTKM3g2QsY5AcQV9jkV3bRyggn6y7XqwGHfgsyVTYSCbG
29326	payment	2134	2134	1874	1	1	2743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3njAYyXKZf1tv5qRXidPqAjzFMheUtJzMjYsrPcP7pWcNWBv
29340	payment	1397	1397	1678	1	1	11903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPwB3RbugLMRvo2DjPtWHKC3Qx7uvpvruoknZZu1pHqJSTUz5
29341	payment	2134	2134	1874	1	1	2748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDPGKeSBYq21eHZkTzNeyzGpJdKFbpt5ympboiwCe8gG6K2r6
29342	payment	2133	2133	1874	1	1	2319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvra19zPSfbdZYV6kzz8y6ADufx1XnLXinXu4M9iMTEVVRjc3r
29343	payment	1397	1397	1678	1	1	11904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8DrGiRa6yJmvmXb1fT7X49L9pnNqbHaFuLHBm5Y1jxMAHpan
29344	payment	1710	1710	914	1	1	6	2735417263440	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLzsMqpBGukLyrwDN8dZ8bGCdbqM9WdsycbVmJ5nMJLtNEt2F
29345	payment	1710	1710	1034	1	1	7	4901844299040	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWHpRoahZvv7ogVhLJ74jZN5M9tT1Y7kfTwmuBL6WhCqv7m9c
29346	payment	1710	1710	1154	1	1	8	3307372024710	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZyvhpo61Cs6i8V5U6EzM7uG6jG4TJE6a5VD6r4KW5XSZKs6Z
29347	payment	2134	2134	1874	1	1	2749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFDAMdD12rCf8ywe4QzpcxEQTyKULfH9beVUL2DdG3wj9CUfX
29348	payment	2133	2133	1874	1	1	2320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfqVxm13Enr6yscY9yghPrDSG4t8me37GTPjdJnC9aP54rWk7Q
29371	payment	1397	1397	1678	1	1	11910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RHubEnSB9jUMrT2MTxTrpJuZuF6ias16CNDUrxVTHtJL3YXR
29372	payment	2133	2133	1874	1	1	2326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQbu7WZ7zxMN973BspovNpJSpSxgQ96cmfdgDkRpcVdedrHxF
29373	payment	2134	2134	1874	1	1	2755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZui9tU2XkVpfTPV1TdxP7G7EfXNzc6LNjsWoP9JVRW2ScxsgyS
29407	payment	1397	1397	1678	1	1	11921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRcUkvv8st7aWWP3VnhDrnR7Cv3m1H8Aav2icH2RjiEoTSB6A
29408	payment	2133	2133	1874	1	1	2337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ46zC7Z423t21guKutkubPeBegVHcURA2eMQrpacP2uyHJfzd8
29409	payment	2134	2134	1874	1	1	2765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAngigxoWFyPvZ3fMBFtDqJ4incNkgC3mLMpjzTzkLdXRT6n1Z
29440	payment	1397	1397	1678	1	1	11931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnWYtRuKR3g3hYgYVpzmcAV36RhtswpZCwtCDtSsMf8tVKMnE
29441	payment	2134	2134	1874	1	1	2775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSwWwjSsTbPHPD3RqpgKAvPNdnsBztK3pYZauxDBbm82MupU7
29442	payment	2133	2133	1874	1	1	2347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa553cp71a4Cp7xsw1wBQePtmCLRs8JvPAcvEKkY9a7U9SofWEK
29453	payment	1397	1397	1678	1	1	11935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqofwwCo7U7CZkpNEAtYwzdXGgWSzD7n7rNTmQW4atMS5Fmdxd
29454	payment	2132	2132	1874	1	1	785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUWfnzLtasVqvkMrD1jVQ8KX4QHUWw7rT7dS1UEQqbcSsuPW3
29455	payment	2133	2133	1874	1	1	2351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eWebCGjdTx2ZgvVLGrYLdJdfyY3ZZrSZibtaV682kSERoZpC
29456	payment	1397	1397	1678	1	1	11936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtibVtLzYL48BeyRuL2PZK1xyBcHgvSWeGDumwB1bKxAX6AV7
29457	payment	2134	2134	1874	1	1	2779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrW18Gg5G4ZKHvP8X3ymXUjE3VgSLAsHzLZctYNWtACzEqtha
29458	payment	2133	2133	1874	1	1	2352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVHsBWBdDcQEdFZAZZTRD4xeYehu2JjdEVqiJt77q1Ybctdxw
29464	payment	1397	1397	1678	1	1	11938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYet8CKuxQqRiZPzhEGVNvvrebFtqdK4RRdxRTauCc5t2Z9TGRr
29465	payment	1397	1397	1678	1	1	11939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4VwZq2a122U97EvfWxygZt89wo7a5SKrCynkdAXa6g9xMm6d
29466	payment	2132	2132	1874	1	1	786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVEC18SKcMQQXafgJyb3kogtSFZ2j8m131mDL2zTLLEjRUbK4
29467	payment	2133	2133	1874	1	1	2355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkd8wUPRPmSB19RDPGiebfvMjxKy2qu5dANczLt4xxwcgj74Kp
29468	payment	2133	2133	1874	1	1	2356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqsH1WCWGCQavfsTA33epuwPtqs3ynHaDDkvrt4JhrEbB2sBPy
29469	payment	2134	2134	1874	1	1	2782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhuBPBw16wqFdsbAn3BqvRea2ADRzK9Yo5cBjUJHg1VZVaJP6
29470	payment	2134	2134	1874	1	1	2783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVabmumthfiHe9W7JB9kvrvaPxtxX8hDLScYhfX1hr81NEQTR2
29478	payment	1397	1397	1678	1	1	11942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48WPKQcdj9meUo8eMdvkYG6yNMVJP1TeNwa7SvPYDgnQQCjLy
29479	payment	1397	1397	1678	1	1	11943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7v8pgZx7vKpSpHkCNjKhn5HfP7wthdigeZ3eNBNWA655zkrz
29480	payment	2134	2134	1874	1	1	2786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgBt2yU8V1vYAjcFpuTDzBUmWDGFbCZ1471qYp7U8fYBmPMFu
29417	payment	1397	1397	1678	1	1	11924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLUtBfsjqSPeQgE6gpeNAWeMe15yfZ9YZaxV5FAJHG6BZhoan
29418	payment	1397	1397	1678	1	1	11925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwqdH4ris7LVyxbTDCm3XLjR6NLN9q2rVqwgFXRrjc5bwEdpp
29419	payment	1397	1397	1678	1	1	11926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKp91hbEcAY5sitUW1jWtFfKhtAZpULzpomvXfpsauBTzVaR9
29420	payment	1397	1397	1678	1	1	11927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8L9F4nazFnzRQHQCtg9hcc7s6ttYiStvW2WoKdshHidHAp2Kr
29421	payment	2133	2133	1874	1	1	2340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsA6J3RTwd8jWzhNY8NUJsSoV9ZP3zMab9cHUYgAt2CfSq1Jsj
29422	payment	2134	2134	1874	1	1	2768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNbwzmcwbui7JgX4BAsq7NXso4LQxo2tBv4tPYmnq67Ntn1kw
29423	payment	2133	2133	1874	1	1	2341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNrPbc3hoKspWTTXR6L7CAWdFVCSTHtzf5AcqYTDKefQtXXPp
29424	payment	2133	2133	1874	1	1	2342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNp21WyBRQJZiyStZnhm4ShHeuWgzumXjN75D3xwYhmWnhfvV
29425	payment	2133	2133	1874	1	1	2343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJSEse1mGqJaQ2ik6pMt1vbDmxeTuFs76cZrrf1F2EU8QBHzb
29426	payment	2132	2132	1874	1	1	782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17vonTwPLGHsYwnLEF4iwqFgetRKmK5cDuyZoEq5kj5LeR8RX
29427	payment	2134	2134	1874	1	1	2769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6V58PbKe9PfRjgrXtfhmDHFnk2VLH5K3P4aBvwkcaLDGYmEi7
29428	payment	2134	2134	1874	1	1	2770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxQp2hBjhtH7eLiG7wJz3T7Awp1wycsreTWNz5VgoJbDXmshV
29429	payment	2134	2134	1874	1	1	2771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9f74Ky62DqT5HHwQnoJCffX6fTo3LKgfa5ZHL1LV4sW1NL5m
29430	payment	1397	1397	1678	1	1	11928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEjHwpP4iVJaphqd1bEsJoRka157wsm9Ftp9HQCJ1pNxr3JMs
29431	payment	2133	2133	1874	1	1	2344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8L9gEzBd7kdfs2RMA7eekoJoQGkjWJgGXqdmHDKMZ3Lyxfex
29432	payment	2134	2134	1874	1	1	2772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6oPXYQdSrh4wvLfGAGgP8kY6vNxDFPU1EJuyuVjHNiwrTgLEa
29433	payment	1397	1397	1678	1	1	11929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzvea3yg4oebT7dt2jR2gc4EA9U679Cvz9pC6xJ2yPSUGQJf2
29434	payment	1397	1397	1678	1	1	11930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iSkaVoNh8v2Lmnq5Mx4dVRSJgpyxbMo22XaisaXQjqbpDiQP
29435	payment	2132	2132	1874	1	1	783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP1Xj8uABowEbXmXjVZHasCagKkuhX34HgeS8PM4nY9pwNfEi
29436	payment	2134	2134	1874	1	1	2773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicQWih1zBuQJrAcKF3z4oUu5LtLKardW9Brn5LeLmy1kkCDc4
29437	payment	2134	2134	1874	1	1	2774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDsWFbfYYExLbSQ9rmjxfXbTHMoUbDkVszQZEqnDYsuw6P5wu
29438	payment	2133	2133	1874	1	1	2345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUagBiRfVLoNhDExWw2ifR2ZrHGb6EN7WBsYVtV9ZYUimhgaw
29439	payment	2133	2133	1874	1	1	2346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNNxd8wAkGbLoEAJmNFnXZAziAiZ5DhYRiw8Huf1NeAHgPU5q
29446	payment	2133	2133	1874	1	1	2348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqPQs9NfmgBkrvVGxw5FdRb5aDfkpkmJAhsaE9kSwfxftfUUvb
29459	payment	1397	1397	1678	1	1	11937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqg8zA5iV5q9jXgvNVqcLvQSNBFY3SPpJdJymn1rT2fpkRqGR
29460	payment	2133	2133	1874	1	1	2353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe2F56wXyDPEUp6VhGQzzW56MPoPHPSeyHa5Kwm6YBd9ZNGpUj
29461	payment	2134	2134	1874	1	1	2780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxLuZJ2t47yK5QxKLAihVABWbimVnky1NPdovbnMnLgGCu2dv
29462	payment	2133	2133	1874	1	1	2354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Us1nhvyephjhhtPchFkcfgNN5o7RN5dbbLKFW4WGEF1QrPBt
29463	payment	2134	2134	1874	1	1	2781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANaTQySav6eWtrfgUPbVJsboxuXSKdavnx14KGNyzcbfa5qUW
29471	payment	1397	1397	1678	1	1	11940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBbJpo9ztUwoKPnAhEbnKgiFM6xaMq6acSZyamWKypBGRnNM7r
29472	payment	1397	1397	1678	1	1	11941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mPX1ieaDxkhwzzHKGyipMYqCBacMEPS5PoCsgYuVK9GyTQnN
29473	payment	2134	2134	1874	1	1	2784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDas7kdUyF9kJaNhg7wqpsiCACg2EdwwqVGpk7RNR2gQnM19t
29474	payment	2132	2132	1874	1	1	787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquWM7MZHEDfGk8TNai3BykmC8nWA19VVL9mKYrrYXuYqkwpSE
29475	payment	2133	2133	1874	1	1	2357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjTsrrLHutks9jqqMYrcGiEL4ETnP9NvfDLcJSd4P4U7iTqUx
29476	payment	2133	2133	1874	1	1	2358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfeeJZia6k52eHgCwyGsR6sXbrg72ufLE5t1ZPwVZFbZ2oZ54j
29477	payment	2134	2134	1874	1	1	2785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa164HAgMmELr5ExKvqxsDqSxFx3Sz77AKjKZ24tHrW6f8Ppxw7
29491	payment	1397	1397	1678	1	1	11946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXgDU4Dak1wVvQuaypn2B138cyZuucprY46T3Eh6s5BihEPJX
29492	payment	1397	1397	1678	1	1	11947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtNYnjaBZJcLGJb8WKMS9Z22ojdQa6yPYa4s2sJszaP6CmekW
29452	payment	2134	2134	1874	1	1	2778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6qDLuW5SVDRGSy9qaBNQwZdCBzAVURWxQNT7AocF7qZr8QbC
29502	payment	2133	2133	1874	1	1	2365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKp8f1ZiT1bNX7BcKLqUQJXd4c3ahWeYft9HKVdtyr5UdCrEZ
29503	payment	2133	2133	1874	1	1	2366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVipcsfGLS8vzQir5Zg95QeQEJqUN1WA399ZzRsgcknbKLs9a
29504	payment	1397	1397	1678	1	1	11950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJE6P3dj6RdGtknEEWQxcWn77mNsMFx3QANNVcA3r7va6czPwc
29505	payment	2133	2133	1874	1	1	2367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvznAy6tsJTUvhzskbWYXMxUg9JBAsFH7zdtTZxxqprwvPDh7L
29506	payment	2134	2134	1874	1	1	2794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbU3pLtoGdzjT5KAxFud6TxTMEdgG8LHDYferxr4fQ5HMYvZ6t
29516	payment	1397	1397	1678	1	1	11954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMauWFJpPikh22MXBGf4qM5rFxTnuBGXi6Az7KSyrgVuhAgr4
29517	payment	1397	1397	1678	1	1	11955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGdLpY3btkuN1vaTHfcBipgZozrdeoZaZt3ANTgg18STU5nf8
29518	payment	2134	2134	1874	1	1	2797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYus8JikpFsKMZZ7gLcmtkhexyQXc5NgCWbzgjSo5ijvukZZSAY
29519	payment	2133	2133	1874	1	1	2371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vsbiaksAP4uNWKtdmJRPpfHrJN8mCrTy3iaZ4RXBzdSEhgiF
29520	payment	2133	2133	1874	1	1	2372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwzJp5254EQ5f6FuAb3gKpctCjEka4HQNWekQ44AJedTr5Sm9
29521	payment	2134	2134	1874	1	1	2798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQkro6QRY1SjpvCdoTWMuApqGVEsNCNzALhvFZ46KguVojfx2
29522	payment	2132	2132	1874	1	1	791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAcCXksiZA5N4ggnDaT2EQmg1AsGV4TvhRjBfhcV9LLyU5boZ
29526	payment	1397	1397	1678	1	1	11957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqST4cHjNB4NxZvNSEL3qiKYCk4LsXY7DvsyRvxKbakeh1uWsz
29527	payment	1397	1397	1678	1	1	11958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouuaZJrvB9CC4Jc4wvtMFK18SGqFX2dhFP2MWTqcNZtjmdKBg
29528	payment	2134	2134	1874	1	1	2800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6wHjEcoaaayS8JMyy2AaLPTgoFUVS764tnBmveVT8ipYK2Tu
29529	payment	2133	2133	1874	1	1	2374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodv3Jm1iGXA8fqkcETBYNmeDZYpUmdnrJdr8ySR6PEPrBhNgn
29530	payment	2133	2133	1874	1	1	2375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtwZDshhCncyRgJkkrszgYDfbnu4CRXERCYRedyLTWGSX21Ru
29531	payment	2134	2134	1874	1	1	2801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuUzU5JRS32ERpT6wmrQ49NTvp6kzp9txwkXupz3XNYnep5mg
29532	payment	2132	2132	1874	1	1	792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByxvxzjtHxNxHMgrPxVZKcSvkERMcaswWGX3YFXQBDPDwkEJT
29543	payment	1397	1397	1678	1	1	11962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qQEw8RPrh5A7XGXJxGqfyt9SR1zZYxCq9rRdMY7DQ3c2oUbp
29544	payment	2133	2133	1874	1	1	2379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetzGtZv5dm9NwZZJM4S79RC9j6TY68R32FRBLarf5eTzcXJ1S
29545	payment	2134	2134	1874	1	1	2805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLcuQUEtfvpv33wCH34RrkFXbedqpC9U8sSEVkBMvNMt6dMW6
29572	payment	1397	1397	1678	1	1	11971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxEHQi7rYtLM9jBLERtdhYJq2BtJfaSkxGMgrtjvpMUYHAVkQ
29573	payment	2134	2134	1874	1	1	2814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPFpzYdDEo8yLCiDUhtYFaByPd5e1VQvzcu1Mh4cxC3JcCREo
29574	payment	2132	2132	1874	1	1	796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHFEogcJ9rgRSVp4SR29iGtrALqRbbVwpbd1ZmT1cRQDATVey
29575	payment	2133	2133	1874	1	1	2388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnteREuJcRW1WrNyL5QwvVQaGLdufZGsZSkXaCFYxvWkzzzFu3
29576	payment	1397	1397	1678	1	1	11972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8MNttVCUxyg8gQ3Aj33VcwKjwMUb7Yy6eQT3U2ydS16yQnpX
29577	payment	1397	1397	1678	1	1	11973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAyFCQmoVsRux3S2gTPTM4Ncnd2YtJ2kPfsjVEDZYJESw33Mp
29578	payment	1397	1397	1678	1	1	11974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjo3VShyoX3GBWLpbsDik8W8M144ZEvEFrHGbu3Kr3ffMJBWF
29579	payment	2132	2132	1874	1	1	797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqrLRCjMs8sKVHL6DFBTgqvzKnqzSgmS2T2zLxgQVYU962vd9
29580	payment	2134	2134	1874	1	1	2815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBd2F1CY5rf2ipk7XuYwxSTrFkaYiFjGAnXomd5vQuYasyxCeE
29581	payment	2134	2134	1874	1	1	2816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATE5rLKg6RF8wcNWCzB6fGxZ7ZtwNZMPvba1tFcy1KSuo5kh5
29582	payment	2134	2134	1874	1	1	2817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkqDuDJzRC5FNnEXp3k96x4bcu3m6QkTKyVi5PWUZNvU6Kw3D
29586	payment	1397	1397	1678	1	1	11975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZZZkvZKZnUhx5Mdvr4zWU3XkPRHCofpq7U2tMpMwExGae959
29587	payment	1681	1681	531	1	1	6	275757462962	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpYiwxAEUozoEGBL1keNDSyeVBMoKHWLuiuqx415MmhdLBLDQJv5
29588	payment	2134	2134	1874	1	1	2818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQsYNgFa7mRDaCPFGACVmsj7fLvTXCSKGLNEQic5RbHGRcaCGv
29589	payment	2133	2133	1874	1	1	2392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdUf6ShsC3WgWeLtcJSJ2tFPoKCRnLpCfu34C5zt3M3zDNqD8
29481	payment	2134	2134	1874	1	1	2787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVw3KVoydsHEAYs6f9RT4ViB2u7jcwJ1VdG4NhdSFGfi16iNS2
29482	payment	2133	2133	1874	1	1	2359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmF7tMsBP3d9cAQkuXXetmK8fB6cB1AXLmEkzGrwqC6KWz8jk
29483	payment	2133	2133	1874	1	1	2360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtik8zbJiLR7kSgjooVMa8QqwNCYiQgTtbCPY6ib6cztbWPdfC
29488	payment	1397	1397	1678	1	1	11945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4Voy7oeD4YXuQaov3HZQAh14zekB4njedCBuJypaGvhf2ZHG
29489	payment	2134	2134	1874	1	1	2789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKP7iz6da7zDjTFBBMnfctR12nKvyx2tufViupEStyJhrfTFwX
29490	payment	2133	2133	1874	1	1	2362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrj9MQHMH9EfuHmrtQYKmfE2a1tyLFmEcaczxcVadUuqz66uc
29497	payment	1397	1397	1678	1	1	11948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSweDKrtnPx8Jq3EmKjLibSwhfNpFYzC8CxSe5d8AoBm5DkbE
29498	payment	1397	1397	1678	1	1	11949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnsft4aCLAYq6FwysKSUS42YHuMxzVQ1MTgBG4dGrzHxibe9NR
29499	payment	2134	2134	1874	1	1	2792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtnuwoXgCSdDaroQWW2YCPQEZQJup2Nt5JNvLymJG8gScVdCBr
29500	payment	2134	2134	1874	1	1	2793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe3JD1V4Z4pNc4yC2yAGDNGxUeRX2bwhnevkWco95bh2EEXEiF
29501	payment	2132	2132	1874	1	1	789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dJZV68X1KfgKMQi6M5pQsKrs3SknTzDzny2cypkqSr4VE3VT
29507	payment	1397	1397	1678	1	1	11951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChtwMvdq5GJngDBP2nV5QW58YjexEGuCSeCKQpFdvszUsK8ES
29508	payment	1397	1397	1678	1	1	11952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUH5Fhy79mmSQY4AdnvuZSw57ujCNpYjzKmB9V76B2Kho7N6n7
29509	payment	1397	1397	1678	1	1	11953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8pmH67M6X9t7ymhqqHeECPg5x8XWint8TrJrgnNdL8TY5XNP
29510	payment	2134	2134	1874	1	1	2795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhavcVsmGL7U7TmXWFYgPX2fVu1Py1AjnMj4wKm3f42RK144gP
29511	payment	2133	2133	1874	1	1	2368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmYTdcacmPzBzD5AWb9irKTCFhFfgbcgdPgpfv9Jo2YCaKi4V
29512	payment	2133	2133	1874	1	1	2369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqu2W3hfQ9ThmLDiQPFizR1e7dqQjoQS1N2Jko4xpqSUqBj5sD
29513	payment	2133	2133	1874	1	1	2370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaW3Z4SinxhjHK46dPpymdM4PKY1xU2KD8MKgBgsvXmBM7oTNG
29514	payment	2134	2134	1874	1	1	2796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZri3jVjV5zFCLbGYVJNaMkoBUy5etD7gV1Q6QTKHtnLCpXy2A2
29515	payment	2132	2132	1874	1	1	790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsULiK9Agi9rrL8N2RDNazeVn7nNk3X6iEd8WyJRcvXstCWd1
29536	payment	1397	1397	1678	1	1	11960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5uCqGEJUxvWQcPxHacp5NiMtuybBAw2dZvAuVw8iHpFcWpVQn
29537	payment	2134	2134	1874	1	1	2803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrGrc88KjabqNGhmjNJSDuKnxrD2pAdTzq5cvry4tgruzUaP2
29538	payment	2133	2133	1874	1	1	2377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsg3r5DBVGfodCEduacn2kLhLawdhWJGkodzoFArzNMLhCpQEk
29539	payment	1397	1397	1678	1	1	11961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CY1nbiWukP66vZZYeFWp1AJTpYKETsdHYFzRs7wyq2TnefCY
29540	payment	2134	2134	1874	1	1	2804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjijF2bTS1KZ4YYv82Xt4Kiwivb3E6Dr8r9x19LJnPbQj9sRR
29541	payment	2132	2132	1874	1	1	793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTKH1MGzfQNDSSygYTGqNYuiYnGrdxDww76k9nGMJu4afFzod
29542	payment	2133	2133	1874	1	1	2378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBoaQ8WNyGAE2CjZTjv3HTWJ3uoRGvQB5ehSmatud5vL5qbgzL
29553	payment	1397	1397	1678	1	1	11965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4kDZrQ81w3eJPjEZAnCYbsdvJmM5vDVEQP9fvLSV5DqqVCYr
29554	payment	2133	2133	1874	1	1	2382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLKuYAH2eRgeg2rm5ZVcn8fEswAZL417eXUXCdV5qd4xMeDvb
29555	payment	2134	2134	1874	1	1	2808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvShHtNSJE4D69GC3So1NvCuFhNE4ccFcHmnLDSeYRiL6uAefp
29559	payment	1397	1397	1678	1	1	11967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPYTwEHaPH4xAvXtiimoSmqwa8j2x7RcVrwN2bfwwzn7vAVGb
29560	payment	1397	1397	1678	1	1	11968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXopxsdD9gUJCBT71W6xQm9BKEkf8SrchcykWB6RitWoZz5f4
29561	payment	2132	2132	1874	1	1	795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYr5LSEME4LoWw3x85HrQzbnxWsiB6aEDUvrzbqsuiW57ViYp
29562	payment	2134	2134	1874	1	1	2810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzgruGsBLLPAbSohVgPdzc3eja8EMzC5zr4XdXfdsyG4sBWPf
29563	payment	2134	2134	1874	1	1	2811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHCuDaFNYSauBcLPCXbbF9Rf5rTTb8fKJRayj6HivrDycRFR1
29564	payment	2133	2133	1874	1	1	2384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBLYGzr2FYW66KTUTuGuXsapmPY11yiRr8rGf3BNrmA7jSW87
29565	payment	2133	2133	1874	1	1	2385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMWdPpS5bLVapKuNf25tyM5Jd1sXKSnaCr5vPjaJgWWSBnd3z
29604	payment	1397	1397	1678	1	1	11979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwvH4eU1hhnt571Wo4YtkDQaK3BUuP5o9wu3tB7F9Avb8XtGC
29493	payment	2133	2133	1874	1	1	2363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6J4ijoaNwBDNn8dfdaPCkvVuiQkLgS38ZNMnv4WHWuHVuBw2
29494	payment	2133	2133	1874	1	1	2364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2F1RGFdw4kuT4THP2RvYBk8wE6hnGzqpFyHKhiXwokSJhEgb
29495	payment	2134	2134	1874	1	1	2790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszCFenLWrKp4nwEtLQ1x4ZbVXmq1A34McVfPZPp2S41cBYRdX
29496	payment	2134	2134	1874	1	1	2791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3yvBgDxekwLe22MT2yd9enkzN2msqA1xctqW6zpYRYQD7qnZ
29533	payment	1397	1397	1678	1	1	11959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSexRzkbYkfhKsp1XL4PcuvGmGuQSkcbj4Bx7V3xo89DGy95rf
29534	payment	2134	2134	1874	1	1	2802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqxpbDd7Ww2K7fBhDYKwKkASZWeb7katz2KPu63fRbMvrWMhb
29535	payment	2133	2133	1874	1	1	2376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZj7VYAkWRVat9fyXUwPVFZXUWDKghSZtxXxXwHxbrAWeGDFR
29556	payment	1397	1397	1678	1	1	11966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusSKL7U9AnuVwnq46d45WyfjgSS9ttJVRwgHoFqeKXY1NVakg
29557	payment	2134	2134	1874	1	1	2809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFocXCq4J7cSwq4PN3feJL8uDwarja2J6LobV3VmZcbPdazKZ
29558	payment	2133	2133	1874	1	1	2383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGp67G7b23YaL1ioEpUkjg3kJXsfCNgMqfdB1ESkCfinV1mwkt
29569	payment	1397	1397	1678	1	1	11970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe96kK1dHuYn2D2HEXUwTNmqAwi5Q1ksvbrudfJz9Du7TYnT6p
29570	payment	2134	2134	1874	1	1	2813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vg9Cb62cMmTvYa1c48Gzi9wzeMq76nqbpzGqJj33R7az1G1L
29571	payment	2133	2133	1874	1	1	2387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAiWqXfqGunkmRstq1gPSCYmA5Se1QBYdRdzmh3R5Y6shzEcF
29583	payment	2133	2133	1874	1	1	2389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYcVegy4dr6tV5enA7KhSfXv8i9LTon3cyDdpp8oQXV9zJtFQ
29584	payment	2133	2133	1874	1	1	2390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QiH5ycWbZ5hCMNtdHb8cbNY1P9JyzJKM65BCF7jNw1wqkwhB
29585	payment	2133	2133	1874	1	1	2391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1WJGeWNuzL1XEr8GTiUiDMpQCZfsmGbgWBjMqCeygzVKm1rz
29600	payment	1397	1397	1678	1	1	11978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24uejLzHftJorfvi2cs3mePS6RdpYbFf5THHAU7EMYX3kXfb7
29601	payment	2134	2134	1874	1	1	2821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMZAM2zi1sjHaK1wj4Wo4YvJ5PzYpwJ6ngkkfLeRzsbQegCEb
29602	payment	2132	2132	1874	1	1	798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kn2EcxUHdCntabFV3ExKQMWcSwhmXYrPtztDxzQ3XzhHKEw8
29603	payment	2133	2133	1874	1	1	2395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCMCLHrgaGnMtFsorhGmFQSgxLZ4XpzzibkmLdZ757GBUVeYws
29616	payment	1397	1397	1678	1	1	11983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUDZw5GUFFFyWpXpUf6CP5KxQHgiU5LBmC4wiaSnByx3orkSZ
29617	payment	2134	2134	1874	1	1	2825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqewFcEMouM3WTMvUdr1eNd9J5faqWp3GCLK12TkHMjzKg4eY
29618	payment	2133	2133	1874	1	1	2400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJg54ijMV9rym4iA4s8AcxRKb2WDQy6pfL3F9dERDq9ExwBceA
29668	payment	1397	1397	1678	1	1	11999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQz53aAUSE26T7N7TKsZXeKPo1b7VhYPpJBHsaMFT7ndTQ5CS
29669	payment	2133	2133	1874	1	1	2416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwaCQfVaoESqPWF1rhmrU36BzoxmeijCdQBxPv91eBkbo4BPU
29670	payment	2134	2134	1874	1	1	2840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ggoNSwvJUDPUWaJ89ET2Srvhj1xTncfVjnwM6ZrYJVbZ82qL
29688	payment	1397	1397	1678	1	1	12006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyUWNU79YCku57s8xWSLC5y16GBaeNbY6uiG4xykNtJbSAbzH
29689	payment	1596	1596	1363	1	1	11	8601867140514	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73sDgQFXN2haQ6natamHkRnyewpNtWCMPP4NgEJTDhzRU9Voa
29690	payment	2133	2133	1874	1	1	2423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5Frnws6EzhHhNLrvamyvzhVbHeYY8nyQptfBBzi5JTx6bnvR
29691	payment	2134	2134	1874	1	1	2846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcZnTaj7SLyYSKXJw3hjZHeh4WF3f6vh5jbv4oGwqXbDuYKQA
29734	payment	1397	1397	1678	1	1	12015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVB7RYaLqeNR6uYdW6quaciCB2kJoQ2HYrQLsSvLyvcZDfwZ6a
29735	payment	2134	2134	1874	1	1	2855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVatKidD6yz7QyFksuTebgbQvQDUaRpLy1MwS1powYqztieUM
29736	payment	2133	2133	1874	1	1	2431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8CkG9hSsAvQ4UaNPqDMTBpPSN7iFgVbKpXvqzMfh5aDHRYKP
29740	payment	1397	1397	1678	1	1	12017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8vq2wEEwEPKVYEPBhV3tsUuMtJXtAfrWTMVW3LSH1tYtapwa
29741	payment	1397	1397	1678	1	1	12018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjePJxHsYw1cTvbZyxySTGSNy7RJ5vF921BYUYZJSnF2nV6zck
29742	payment	2133	2133	1874	1	1	2433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShUbQCre5XmxooEPz23oXdGG7C7XRjexXunWWvfXzFVgwUi2N
29743	payment	2134	2134	1874	1	1	2857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVjBShsXRshH9rAmoApaDBKG5rRcAuWUsXrUjauAFzoMGCC5r
29744	payment	2134	2134	1874	1	1	2858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDWwC1aHBQSpoCqexjabhHPQxrL433vMeGzq6z9xWwfSVaxafw
29549	payment	2132	2132	1874	1	1	794	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQwSToVJAWnEG7omnKcbww2fqQdnnG1vq76542DLMrFi9Cs4c
29550	payment	2133	2133	1874	1	1	2380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfz6XfAGbDv4d1JmfPmgwxzjjG5TVP9x83kwmwDiv4jpjg3jV
29551	payment	2133	2133	1874	1	1	2381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXvsgCGD4u3pb2GMv3qkM1zpn2sSD2Sqf4oeuZtSsNPnGK3fcz
29552	payment	2134	2134	1874	1	1	2807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3dcNbHH4YuXjQbCgpvep3kK5PguF8ZctET4bASQ5RfGRnLpN
29566	payment	1397	1397	1678	1	1	11969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwMG8EhJXZMGe7VHtEC1NWciPHE3Q3oGnpDh3phtrZUpTjJRr
29567	payment	2133	2133	1874	1	1	2386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxJg4mBMhYs6jpzWHMNmiNTZ5hKxTBUhL3PuQoLhQguKmtzpA
29568	payment	2134	2134	1874	1	1	2812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAiSuxTWfGU6FUXcd7FdfjUCEseyMYM4JMmQ9hKVjUS7bFRkJ
29594	payment	1397	1397	1678	1	1	11976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfFvwGuRFwhZXYQwi1MuUPVDF4HFExEGeDUDoeP6QQh53DcbE
29595	payment	1397	1397	1678	1	1	11977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzaU7LYWiKJomX9RphMmac1LWDt2znTiYoALs9hHs8r5wMPZs
29596	payment	2134	2134	1874	1	1	2819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEQqbxtWUQootSNUA9DVS4xHiG2KtYh8UELEKMEfDkiQseSak
29597	payment	2134	2134	1874	1	1	2820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8uwdsmMFem86s8tin1G8GBeR7BY4XLepJ5M4YwdNLGGmngzZ
29598	payment	2133	2133	1874	1	1	2393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVK7bqyVf6Jx6Gqs26MCxPrmnn6DU1jUBtBG6GAFnLDT4Qe1z
29599	payment	2133	2133	1874	1	1	2394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpRK9QZ5ubTCf7RH3odzjn6jYyo9UssjFaZSYxDoEQj9MSVqL
29609	payment	1397	1397	1678	1	1	11981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKRSEqHq4sK2ZUo5o7aHDEfW4WP5Pd9Q375gDBV3RvZhreiiF
29610	payment	2133	2133	1874	1	1	2398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvWMq8vstMS9E8B94DCZPndMxt6mALnUoiqcxMrBYSn4Z6fmJ
29611	payment	2134	2134	1874	1	1	2823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXfSHXqAxkGw13hhM1uEZTjZZ4bB6i1FnTjZjCz9RkmtdgZSQ
29612	payment	2132	2132	1874	1	1	799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNAsDDiWAQa4ZVqrgfuuvKxV9mk1NM5WFzKVTkisiBYR2caSC
29636	payment	1397	1397	1678	1	1	11989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoR3wboP4iGB1fQ3N7qPg4pkrZTCp1zVZN2M5hTyEJD2jCyp1
29637	payment	2134	2134	1874	1	1	2831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabFHNU2T6RCLZcWmUjKMkdtyX75YGc2zncekzQTeLJgqaA1L2
29638	payment	2133	2133	1874	1	1	2406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzeRPF5qJw7YfKemzMWhKefKaSe9m5Md6vffF6xhUpGshrzBa
29639	payment	369	369	946	1	1	12	2735417263440	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGe6ADZoyBgrNge5toDpGcGaZjF8AqkTFjyFk1mJeT4y19bdQ
29640	payment	369	369	1066	1	1	13	4901844299040	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8WzGEuZNSa5K3k37kEuV9D1DKmruigZzSYwMdVvA7onQ7BCQ
29641	payment	369	369	1186	1	1	14	3307372024710	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfXbpranqp7S793DgZ2w7EnS3jaqdg5wQZGNUMmDdSsXoGfGUd
29673	payment	1397	1397	1678	1	1	12001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22u9jWDAdwyxtsxiekuAuvyxR2WHXj7E4q7ocjYzvjeVs2v8J
29674	payment	2133	2133	1874	1	1	2418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFN4VMcLWbfTjKGdCz1pTb2z3vCXG7tnNBX2ZhetXsY5hXWiE
29675	payment	2134	2134	1874	1	1	2841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9iyVHZQYEpcqHxTvfpSnYJGPVDCkpB5DVdeVi5RYGLGg5EAb
29679	payment	1397	1397	1678	1	1	12003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCD5c9C4j8p8w6WkcmUaFNK8HUcWhozRE4AS71xtawJ6TfMsHv
29680	payment	1397	1397	1678	1	1	12004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPbgo8JNCgLRGtrZero97Rq2snQubGcmuLoq9Z6dPcsLSv5u4
29681	payment	2133	2133	1874	1	1	2420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznAKvkAe6izaDDDvdY56ACy5wA1WmgazcXcna5YYUwKxjssfG
29682	payment	2134	2134	1874	1	1	2843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJXZdjvnWdZwEcWBQ4ATWEzUZrqwUNF3AmU7dUnxbRwYyHoFn
29683	payment	2134	2134	1874	1	1	2844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YhNUJmoqdfQgvL98uDeHAcYnUQ1Hc5KZ7UEXi7MVvCttyy9Z
29684	payment	2133	2133	1874	1	1	2421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSByGBFfWufxMapsLoNkbB2XYneCQsjgpVSSckk1SDcb5WauSF
29701	payment	1397	1397	1678	1	1	12009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg35BG8bDhQiBV2tZoWZqbqYnshVrjDdA73HAh9WCLET78S4M8
29702	payment	2133	2133	1874	1	1	2426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2hoB9N1w7CjhBdCw5sgCXgmvC3dwDb3NQNfPue73PqR4vtj9
29703	payment	2134	2134	1874	1	1	2849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDo6ZcXfqnyu9qqaiiKph7dMu5uqbrMiueYTWJLprZ4ExLSvMU
29707	payment	1397	1397	1678	1	1	12011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpiKhhf7sD2F4ygpzJ8dZMUrxsF8PbkMsxkkCaSD9wygLGnH8
29708	payment	1397	1397	1678	1	1	12012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXU7k3ikgcZR7QrVwo4a5yxBcpV5x6E2ahfRehJGPvwYHFCwm
29709	payment	2133	2133	1874	1	1	2427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwHmZLM4fvUbqhQQ1KpAa4qC5fEMjsRNttX8ctv5w9bZCDzdo
29590	payment	1681	1681	984	1	1	7	2097153235304	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	Ckpa2tn2JQqZZ82tht5VgmN36vqftoKf62oRC4nRvQDQMa9dYCf31
29591	payment	1681	1681	1104	1	1	8	3758080629264	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpZ1xk1bo3EWXReKGGGYUNTrK2CkJuDcxptJ45u9tukFGfifmkC7
29592	payment	1681	1681	1224	1	1	9	2535651885611	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpZFJcERitsN6ybafW6x1YNmaovCD1no1yPL8whaNyzA7Yg1ZNpo
29593	payment	1681	1681	1350	1	1	10	7065819436836	1000000	\N	E4Z8FkMmQRw2gD3EmWVxLMD3tgFxiAfe9DGYc48sm3dkFHTk8nYoZ	CkpZumFgqFHpUoKC7wqmX9azBsJE1Xmgg9YTYfUxtujT5nAkDSHek
29613	payment	1397	1397	1678	1	1	11982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFp7mZ3GsmpHMs6oRCsgUBjJwKAZxcfzgrCR5ofjm2DcWj6kQF
29614	payment	2133	2133	1874	1	1	2399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaKLT9NuTt2197kSkxFxqP77dZvadYwy6PWaAUU86Z3gDkHbk
29615	payment	2134	2134	1874	1	1	2824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaELgoXrN6yt7RnYMSgY4FHdXd5WCxzfavRzNQySzGDwsbuNTkj
29626	payment	1397	1397	1678	1	1	11986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgdk4WksHoDpz6NcM2P3xTtPH4FHRgocJbcRQesemdgYmiVRF
29627	payment	1397	1397	1678	1	1	11987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWKN5dYGXB8DRe6YapM9QNAgxc42AumSkSqpWM8n1V39EM8hx
29628	payment	2133	2133	1874	1	1	2403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrJi2GGD9GcDhPXnRqMfjJWRqNmt3wY3DCqXUGbmL2heqE3UZ
29629	payment	2134	2134	1874	1	1	2828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxbagoR5VrjXjBfY2RBMSdwRdNbqbNuVPTaouZschrFwHx1Yi
29630	payment	2133	2133	1874	1	1	2404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCdzbhnZgb9ZcMTUVjsLyuecZqGYvD2uLPYWCjEbsPbymr4VEn
29631	payment	2134	2134	1874	1	1	2829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJJeNF31jLWwLpm45P1hFxqXpJjKADvnzyWUutdE4Z9thvrsU
29642	payment	1397	1397	1678	1	1	11990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2y4nAmX6exXe5CHU1neVzBfpX35CBwSj53mKBqPeGajM2M5G
29643	payment	1397	1397	1678	1	1	11991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7w9j8nwscDsg4BtaGWeZF2j7maCb6Xo5Uw9F1MG224SPSn32
29644	payment	2134	2134	1874	1	1	2832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7zuvsov8NAUhYjm7grUq9yMjQcGTLhZUWv8sBFyaAyV73j3b
29645	payment	2133	2133	1874	1	1	2407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPxTPZQCyaNVBDj2TVSxLVNhkEnjM2QA4VxWi9FANbaHa8X68
29646	payment	2133	2133	1874	1	1	2408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAGQAntu2Q1FPN4P8QjcX73PSN2RftYz6M8yc4YaVfeFD8QZc
29653	payment	1397	1397	1678	1	1	11994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtkCAd1MgYjvq5EuHH75vmZ6ogSRSp4JwAky9U4i6uYYHWSKC
29654	payment	2134	2134	1874	1	1	2835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKahLBPhApB8MKjvd1TXUYqmquM69qNzMUzb5gdQ5VLLcdRQw1
29655	payment	2133	2133	1874	1	1	2411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjozK28QAMVRESrDZKsDCzcgpD4tSmpk6T2ecjz438PK5wS4o
29665	payment	1397	1397	1678	1	1	11998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKiWaLDr6wkBGFSQCAGfxN8evP2eVgkbUi2Z1JsAn4EChd8n2
29666	payment	2134	2134	1874	1	1	2839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZW28RhNefMFVXjKSCu1vEGaBh6uh4Gns6EsxrxKJ9tmnU3rM8
29667	payment	2133	2133	1874	1	1	2415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVby3n6eTWcDzHQyNBWpbux1Dgd6SyHEZ7V84GUEGCpXbYQvi
29676	payment	1397	1397	1678	1	1	12002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BVE2uUY2dEcz3DutitDh27drYtZNUjXEpjZkNjmFTCyJ4Y3j
29677	payment	2134	2134	1874	1	1	2842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdajNSDosPBxi2y6bD7KrgJhNzZzt7KAfXFce3bephsuPfMPWh
29678	payment	2133	2133	1874	1	1	2419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UMiQefu5WGj5Xg4HQ8qYA6eYGG2cRSwMkFzKdq9soc4qdRwb
29692	payment	1397	1397	1678	1	1	12007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi351NHayGHW7uEQVbHnJdgn2Px4oCcBD5DZEgmCeERS1zcQkJ
29693	payment	1596	1596	1117	1	1	12	4575054679105	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcxCiboKwTwVcevHYryU8gGNhCEioSkDStJ9iyZyXKbkeBG7g
29694	payment	1596	1596	1237	1	1	13	3086880556396	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtFDrvEXJyskipYEtNm1SzknVAsnjzazizZNsZHBp8GAvhLhS
29695	payment	1596	1596	997	1	1	14	2553056112550	5000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCAmmUs4w3vMuvkMwHi4o9tuphmHbffU43KzR1xXV436X5fn7
29696	payment	2134	2134	1874	1	1	2847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTzukrfpBtKsMexCXxWcb9uxCweRy9cRr66Sov4aGcL61JrdrE
29697	payment	2133	2133	1874	1	1	2424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZJeUKy8Lka8bw7x1Bm9jdvqsUf7h19h73DHVYSKpLiQgdRB2
29704	payment	1596	1596	1932	1	1	15	1344129511435	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9uFQkHp9FJxasXqTMzqedRP7xFbpMeiMh7nXMffmGGaZWFrs
29705	payment	1397	1397	1678	1	1	12010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAa6wwjGRkPpXWTQgNBuLTqw5BXLeYTK3TRtDwzWfNRHyYg8Z7
29706	payment	2134	2134	1874	1	1	2850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2oxB9ECwtAVDmzezjRh7Q2vUxD2KeLrHNom6Ee6CqVqF2V71
29729	payment	2134	2134	1874	1	1	2853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqzqiTZnDLxpKYxmT8sEPqcFFNRSrzNoZqv8EWPfhLT2TMPaQ
29730	payment	1397	1397	1678	1	1	12014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbgmZP3xgWnijWcGjxDpwZ2exM27kcDtga4SZvVQpKDUJ8oo1
29605	payment	1397	1397	1678	1	1	11980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk5iN62YFijVY4XB32cUthnwMQxnCo7M444nnP6aWWeyE6YfM
29606	payment	2133	2133	1874	1	1	2396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1b5NGM6XfWjz9nwcsK51K7trEh6hWivkDZSwtzUJy1TL8i7z
29607	payment	2134	2134	1874	1	1	2822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLczvF4NNJ1oxZSh1WDPT75DCE3mrt45cBSKLdemdR7GUFxqi
29608	payment	2133	2133	1874	1	1	2397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmh21d21RqnHPf9K2PBET7YQ6kJYwvN7e3Ak4iLdqw8bADWDP
29619	payment	1397	1397	1678	1	1	11984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGbzfzKD5JZEiheFxsKLh15dHqapsRDoj8zx4EdfFcHoNjV2r
29620	payment	1397	1397	1678	1	1	11985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAjFqhfWtD1FCapsCcYx4xexgSx2sS4xgXcgt3TQJJecHCUt1
29621	payment	2132	2132	1874	1	1	800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTN5FhPW4FNsucbmnn265xD6CH6xyiRescUtiLnYNPLZ1WJTec
29622	payment	2133	2133	1874	1	1	2401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDn9LBeSVQm7kT7vgbKgVF9bT1EYsr189hATUAVktGj3XbgSp
29623	payment	2133	2133	1874	1	1	2402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXBKaACDGq7j2U67hh9wjW1wXQZTB1FTUsVKexEAmxesQRA5V
29624	payment	2134	2134	1874	1	1	2826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuhYn6Nxsm66KqRXxtsJfdvS96AiYqAUqoEjHPhJ9wKLABtS1
29625	payment	2134	2134	1874	1	1	2827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YdDLAK7e4DjGUvKhPcUscsdHBRMVhPwyuoiyKAhcwXtBpYp3
29632	payment	1397	1397	1678	1	1	11988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzWv2kKF4fLbiqKo7YMBvW1jW5xhLNZntGojVeyXUoA8VTqK4
29633	payment	2133	2133	1874	1	1	2405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkJkQtDRC8red58QFbrdDqocd6nmPppNgDKXjaREL3BXHGatq
29634	payment	2134	2134	1874	1	1	2830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgv3BfrXcYjuu4QkXpShyrrjqaqpd9AcL8QM5geEEftgQokJt
29635	payment	2132	2132	1874	1	1	801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAHAer8VRAjZQRDWyyFTypZbmR1e9tMNmJed7Weu9EfpchjzU
29647	payment	1397	1397	1678	1	1	11992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGD8oBHsfjipZL328rU6U3zKrBSeP1U7xFFTEuSjhbjGqCgths
29648	payment	1397	1397	1678	1	1	11993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDLCbiCbS5rx4KHu2B6UFRKN7QqQpXT88cbMe3XrYZX6sYSeF
29649	payment	2134	2134	1874	1	1	2833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySptVgb7bF8AmUhTYZB6Tis2DnUNpzqAmVHqxgV3xRRX1vigb
29650	payment	2133	2133	1874	1	1	2409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWxzuqJ9K19MwBA81rzbkVm5BctM3xiS2bH8m2pUi3YdDyFGx
29651	payment	2133	2133	1874	1	1	2410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvP8VWNCMMM7rNSszqLCo3FWfGMN2WNrW8TD4ooi3zZWQwphw5
29652	payment	2134	2134	1874	1	1	2834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRQtpcX68aqpJXwCJxzYNt237ziXQmu7PK3koiBr338eE21WW
29656	payment	1397	1397	1678	1	1	11995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYTiBkXsDuNmshoBAJJZxfEJjVyimqPhyeBDBC3DRHHPvuKVH
29657	payment	1397	1397	1678	1	1	11996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3AEtU3o6EpWqeLwoRGVQXdxgn6zmvFzcjac5zUKfGpfN41WS8
29658	payment	1397	1397	1678	1	1	11997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKf2if4H5k2kz452dBkW5bydrrQRg41FXbzGG1KaxJEWXJwsh
29659	payment	2133	2133	1874	1	1	2412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEsFxfmV1yvc8ijnZS3uFApeUEWSVBhVam68yrZtBapKpxpMe
29660	payment	2134	2134	1874	1	1	2836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGmPWf5F9ZReSnASXcSTswEfW8gsZxKJvQpSXYeaXeYM3Dtqd
29661	payment	2134	2134	1874	1	1	2837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeinp3pkbRN5QxQ2WNyuEVV5Q9aQyLa2F3oRB85KyVhJLPHsaG
29662	payment	2134	2134	1874	1	1	2838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAihJDEthWyRMQm5xrbHdRpNaxhWKabTCDrQKoTVdtWkeusEu
29663	payment	2133	2133	1874	1	1	2413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUPHjDfUYv999zwC87AqW9HJpB4wTZc8d7HqtsXmNWzYdrhSV
29664	payment	2133	2133	1874	1	1	2414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsAXWg332foNohn7KBDFv1ouFe9bWXepRhS9AEqiwGWYztx7x
29671	payment	1397	1397	1678	1	1	12000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBWfya2o22UM8iL2cWHSATYv6GRZLiaujytJwDLgixtZHbBtU
29672	payment	2133	2133	1874	1	1	2417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7k7zjzcehsNuQpW8bs1YGoFuDSk37HV187HCQ1eq8TyjUbqyP
29685	payment	1397	1397	1678	1	1	12005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFczWUSa9cbkBXvQ9NQnNTeC3obJqcbcrA5mZXyi97epbzuJe
29686	payment	2134	2134	1874	1	1	2845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXnm3yh2eAaTBDHEiFNk9N2ysEaMBppUcfcLUxfnZ4MnPF55Y
29687	payment	2133	2133	1874	1	1	2422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GmPqb2EMeG1z8ttAWwGQk5Gv8fNKmZ1Z1W3qHct57NemVhri
29698	payment	1397	1397	1678	1	1	12008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT44Wz5PihKqB7tRaTvsiFhcDnRnAKTgbiYS6sXBdVmtGgMxaq
29699	payment	2133	2133	1874	1	1	2425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xWFzHFsPpgUk1tHAsFYsYDGYisntv6YzfV9kZPBKCBrhtQ8m
29700	payment	2134	2134	1874	1	1	2848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLsNJsToawQQPuZGr48QYN4CzpKcSjYG9XUD3gPt5JZk4F8dL
29710	payment	2133	2133	1874	1	1	2428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTCQG8cY7yyWVvXRWLwvDBhtiFgYPjQar2nE5oLpz3HQxNNpM
29711	payment	2134	2134	1874	1	1	2851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdNcTEwpxEdnNZ6zA7hDcDHP6vDXFc8xGrtyqSF6dSwMGd39j
29712	payment	2134	2134	1874	1	1	2852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtHj4qqbDdW5eWJY3KwrzN2Yq5amFz4Eg6czjKW84gQr4DnNC
29787	payment	1397	1397	1678	1	1	12033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR49QFv7toSn3BdpMuman22iASwbsAnMNRKYxuDhhx8r7sRG25
29788	payment	2133	2133	1874	1	1	2449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bBus2sjpV1jDftp65gBK2VuzZFby52P2uMyPFQGR8VD1ZYvH
29789	payment	2134	2134	1874	1	1	2871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7aquhGuMgRW4XUVR6KLiGHZNPHcng2vvgiLtx3nr8uUFBxLMU
29819	payment	2133	2133	1874	1	1	2458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRtQmq7RiLtTqMQCn3RQJsU9MqpWBz5BGJFiqBgiWHnrs8Nzz
29825	payment	1397	1397	1678	1	1	12044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8owg5UVF12BZPGsC8r6tUX6e9NdGJN97GbpHY4Wi6nnB8UFkV
29826	payment	1397	1397	1678	1	1	12045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhvv4xExrG3nnvGArTkKG1DPgjmj8PE4UNkyF4uUnArAJbHJk
29827	payment	2132	2132	1874	1	1	802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVutUWbbe3W1ZgndJ1Eid4MXS5aU6C86ofd997cDMA2nyDVM4q
29828	payment	2133	2133	1874	1	1	2460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSWeSry3QoSKtckxigPS6GMhJTqYCXhDDzEXFLpmafQV48Eik
29829	payment	2133	2133	1874	1	1	2461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfeNTwCKKpAFnEW9ESKQ79ENJ9CKV2szbk6j5US2xmoyhNjee
29830	payment	1726	1726	2251	1	1	8254	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZkS8g3WAYA7XrxnfKygsggLrnZr3oj7frpapA7UyrKCAx5HudN
29831	payment	1726	1726	2252	1	1	8255	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZTPpKwudi2FbRqSA2ZRQpC225QUYFZqfziUqwWoz14uJebvvSz
29832	payment	1726	1726	2253	1	1	8256	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZibuf6Vqd1e4i7aVKianXqc4hPyeYiEUUQ3A4bvN5mdz1nAEAG
29833	payment	2134	2134	1874	1	1	2882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6vPe6eNmeYwWMbtQiLVvZSivdb3U76HaEJfpPy3BUX1HnKPR
29834	payment	2134	2134	1874	1	1	2883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuMXmSfTGnnEpFeiRg7uBgCmubMVCsVwPMcLxmBYLs5freTrbU
29846	payment	1397	1397	1678	1	1	12049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAV2GdFA9Gbmd3TGMGBNxMRZ3GKKBQY4TMiVYqx6RnqfaLofcf
29847	payment	2132	2132	1874	1	1	803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsg32q3qc1j91TPHhU91igny8t8VB1BkecrRomQVP3SuUdmFz
29848	payment	2133	2133	1874	1	1	2465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMyuec5YjQTyVAayLzSYmboRHsoW8VwGAzhJnZA11PYyHHrc1
29855	payment	1680	1680	1273	1	1	11	7373028977568	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYQ7N5JbySgWubJrXFWsmEHPkTsqxJtdpJ37qpcYWV3bwugA1C4
29878	payment	2133	2133	1874	1	1	2471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgcv9U5WahSYzekkZnsyhipmWKW7U5Sc8hCzubYcp2UCi53VA
29882	payment	1397	1397	1678	1	1	12057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUsXytSoGoofeQAyFTjq7PLzZhownujn48xDRTUsaiQmJvN9k
29883	payment	2133	2133	1874	1	1	2473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqWN8SrF66zSGowXtqgSqAE6YbtHzjL1SVGcLEJ49qD1yNqaP
29884	payment	2134	2134	1874	1	1	2894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yoacacwE2f877DfAfWzrr5dRjEPffB9QDqAC3yjgH67hSfFm
29891	payment	1397	1397	1678	1	1	12060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetZJcmaP6x9JB2bSTdDT4ArZp19vsGmCyhC2yXne1Vnk3Pn3u
29892	payment	2133	2133	1874	1	1	2476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT11u1hXa9d37mQxZk4rvsdeydRJ6gFMJka8GsNQK1RR1SCDxA
29893	payment	2134	2134	1874	1	1	2896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KgBdEXjastkzvFXr2W74fv7qCvQXpPCRDtfKe5aVXyJnsrfW
29894	payment	1397	1397	1678	1	1	12061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicVABeJ7LJ1xiUYwiCgRkHGeBPySvtSjc2VXExbSX5dWk1SZw
29895	payment	2133	2133	1874	1	1	2477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzZ1hSPVA4x7uwMc1M2VNi6nnqSGcTYCNrrVyXpUzxtsj2gZX
29896	payment	2134	2134	1874	1	1	2897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNPKFLpohppbs9R9Wp4nCGoLJ66uELwHjinY4r53iPPy9e24A
29933	payment	1397	1397	1678	1	1	12072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQNaUKEuxn4Ndgno3ufFTbU9vVSL2xRm9qR1SCaPrnFyU9Tee
29934	payment	2133	2133	1874	1	1	2488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsqERzdsy54ZCwNBpB5CNLJrUraQVckeKCJD8BVo5hAakZJCA
29935	payment	2134	2134	1874	1	1	2907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYVSsGnepY8nPwaeEyb4ejBh4YLydxSetirBtBxUsctemYhEb
29936	payment	2132	2132	1874	1	1	810	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPi2wYuAEj97v5Ebd5qXhWBmjEX5U8xLRwgLsGkZcrodzdrmS
29937	payment	2133	2133	1874	1	1	2489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGCCDrHShKeqg1UAr1bs2qEDRqRHR4KkrwwWVF9tFJyfXRHV5
29943	payment	633	633	1384	1	1	5	8308000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZrfgnbx3asZANm3pNpnfCpsoKSXyBZiRzMkW4S1SMSQeC3GhRD
29944	payment	633	633	1138	1	1	6	4419000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZFudnAVStw7QCP2T6EThnsE9CPPJ9nak5zU6eMSnzwLodh9fEk
29713	payment	1397	1397	1678	1	1	12013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbxyLf1AQN6jw4JnshekM5PMAdSPbp22boUE3PbFf8s8s4wg4K
29714	payment	2133	2133	1874	1	1	2429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbecmv6m5oWusVfnLRtx1H8kXrKiVFux3xiRuMZ476SS7kLKC
29715	payment	1560	1560	135	1	1	15	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZ328DBcVRZ31geBjDy8SBzbVi9AaQSxazyWZ1XHHUZfZkEKiyB
29716	payment	1560	1560	170	1	1	16	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZc6hZKbgJRCxZik9NGVEVFzfuKMbYxy2AhL6KiT2ue6es1iLgG
29717	payment	1560	1560	202	1	1	17	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZKeCbxSCtXbcSwpLABtVCNBUgSMFPRDc4gHL9NVAN7BLcjyTF8
29718	payment	1560	1560	264	1	1	18	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	Ckpa62JGCKREXcNAxpga55KaoQeEYh7Lyk2oHz5KQkag2J4E8rZEr
29719	payment	1560	1560	279	1	1	19	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYeAKBpwpXs9xNrNpcNELBvVv3p8dSsZqmvrexPhuGsZZchRi4C
29720	payment	1560	1560	331	1	1	20	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZuGkvuf8PXETeELcph7X1VCUZZTcVfcetJsLhJcd6Nfx4kR75U
29721	payment	1560	1560	382	1	1	21	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	Ckpa2eWuV76jJSRynfz3zCNkrbLzUdph4yDxVXppAc4KfZs4mwcUT
29722	payment	1560	1560	388	1	1	22	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYYVcy817ynwCmD7sitZymg7MHhxwAL8y65NiTvs3cRuxRQCs17
29723	payment	1560	1560	400	1	1	23	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaBNvpquXtGhveQpLUVsdbTCpxsMNQ9CgiBP27mst6dyPxG4NDe
29724	payment	1560	1560	505	1	1	24	304833290583	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpaFhUKTPhbUCXS43vLnPwPSiha7sua7zQS6gzbgKgT2pTeEf1ts
29725	payment	1560	1560	925	1	1	25	2205680584016	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpYqqtW1JiZ672gjCKfgJcEyHVgrKrMzSkra7FsbwVsXX9MjgLmx
29726	payment	1560	1560	1045	1	1	26	3952560708320	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZNCmRHLLF7SaGo7TTEnSf6eUAvhPVRc3EtWHd4cmnsWV2zX35g
29727	payment	1560	1560	1165	1	1	27	2666871470228	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZJTbaqiHTj855rFwPRM7zDm4okXFRQHNwm8rvBToggicZRoCN2
29728	payment	1560	1560	1291	1	1	28	7431474476804	1000000	\N	E4ZMxfkj1CvEyUJ81RP8CHXmkN2niGjfgD7jdrBBXAcx4ciM5iEJL	CkpZxkNRWxx6VQzATPPXDQbjAGDebztAScEJRFmNky7hXusndkWe8
29737	payment	1397	1397	1678	1	1	12016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWDziRWfTmk7FnfSF4XmTSnhp9orG1SN8JfEAhYxFDQq1ZwiS
29738	payment	2133	2133	1874	1	1	2432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7B1syi3m5zNczMgPuGrchVxBwPb3KVHojyTmmjsGHw2RgF8Q
29739	payment	2134	2134	1874	1	1	2856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7vVvPgeJUYrXusLQti51AAivvQ5CnzPfT7ma9AFGaZ2pQPC2
29749	payment	1397	1397	1678	1	1	12020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76YvWyuVwTZLzUxuRj1K628dxbQYgabKW73qtqNWwhuFv8f7S
29750	payment	2133	2133	1874	1	1	2436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfWtwrMZXFduBPGrG8JN74YYVzEH1B3VPvumuP2GUveMmiysTz
29751	payment	2134	2134	1874	1	1	2860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3gmDf7vDnKKNcqyXrCV5BsmYBBXjWbLmqChUC16y7EyBKaJDd
29752	payment	1397	1397	1678	1	1	12021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYie5XrxRNcbRKNoBM7nGyaRhggVAo3FFMZcR8195uNqm7g7X
29753	payment	2133	2133	1874	1	1	2437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwYfrZU2vGYrnDHHTdGmX1piMcmaDPVNaRptFVJJAR2r2pj6o
29808	payment	1397	1397	1678	1	1	12040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EP93C1HHi1MsnfgNjydriUTr4Jmz8E6f2zMsU3YVKQHrZEZi
29809	payment	1397	1397	1678	1	1	12041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXepWbFc6KVmd79hV3YyLwFg1hfVgzB7xNK3L2GGydEk66pSXQ
29810	payment	2134	2134	1874	1	1	2878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWim3q8Pt1mZ4Yi8Wf8XTARfhMBBc9ASxonawU1ndPbDuyuRE
29811	payment	2134	2134	1874	1	1	2879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmvtMGu4Hf2mWmnUrh6xrRgoBkxdpTrLz78QRiD6fQg9P4BeX
29812	payment	2133	2133	1874	1	1	2456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWoWWVnrik2GCXbRsd2C1yC3vHsgZXWdTxX7YknuadEvyPkzn
29813	payment	2133	2133	1874	1	1	2457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKv5f8y7j1PL8JG6eZciJRMdS7zPCKe5B6RTPNCmrtFJBBinM
29840	payment	1397	1397	1678	1	1	12047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFoWChHCRtFeU7DT4gwhuvrw5pzczs4NyQ2QCFmJHSdLy7DCH
29841	payment	1397	1397	1678	1	1	12048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuYyV9SSZN4DKnvMJ9amBMvC6CsxjuVXKJf9KNdjorNzS96hJ
29842	payment	2133	2133	1874	1	1	2463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBuAkzv2pgCsuiJKEfW5n11gauPduhGQyUVCqVUpv52NeJkjF
29843	payment	2134	2134	1874	1	1	2885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUdVtH5c3PS5KGsAfc5jmxmhWyNBUQajKsz7jLcJtvnp4f4mg
29844	payment	2134	2134	1874	1	1	2886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEHvRyqj1Hz6T74sB8HVseppiVeNNTaM1xkDKSEswEHEbB3pA
29845	payment	2133	2133	1874	1	1	2464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VifUtnqDHSrGwuWut7EdSQL6JpLHBYFtGgV96dF7TZCBSv6i
29856	payment	1397	1397	1678	1	1	12052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wF4DWhrWzHoUXDVwivxakw158hA1ti4QDYBgNPZBETmd5ixg
29857	payment	1397	1397	1678	1	1	12053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqSYQkT2UYbjj5zpMcWPcXhagT1EAt9THG4QnUAJcJ7LE4MGB
29731	delegation	1932	1932	1596	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cMgNqeafNj424w8epixKvvR6kRmmr45tKtxtqu5DfVAbbRNt
29732	payment	2133	2133	1874	1	1	2430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZft3787f5DP2TpAFGPX9yVgF75PDXwRJiBUhXYjKh8xsyMmXqw
29733	payment	2134	2134	1874	1	1	2854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wMpgtnKBhzCKaZcqXzBwg7Ai4ezdRoN4xpdby3gvvdWNGNLC
29754	payment	1397	1397	1678	1	1	12022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nJBFnev6oHuLPzLu1Et9VKQAmM4x2tQ36KaL87CF9woug2Gd
29755	payment	2134	2134	1874	1	1	2861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUFmnh8HQ8zEfuXSixpeMuKF1UHXeFLB3haEbVQqPd5Z9SpbN
29756	payment	2133	2133	1874	1	1	2438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9s4WWfjPwDejDr2Tg7vpQnzZR6gS7igctnydkMsrXw33TyYub
29758	payment	1397	1397	1678	1	1	12023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eo7yv5oooRg9i1PZ4yRqPqck5JUep9zLBgvN8kgHGAYw9ewV
29759	payment	2133	2133	1874	1	1	2439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h3AQugGUeGJwGth3TJb6xKkJo2fjwaK3Vsv3FsdUYgMxdZpM
29760	payment	2134	2134	1874	1	1	2862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38JpxqXK5dqDaxhrvVkCSBAvdkVTprsgm2QCFiNHnM9w4vjZr
29761	payment	1397	1397	1678	1	1	12024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKcnmf2xpVGGsVzHNz4YM5rCxcUc7juysgk3aFaYVDdhEdP2t
29762	payment	1397	1397	1678	1	1	12025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZVPhc7LXPYDUYg4XqAXXHTA8xwkffEh4Ampf8hoBW9Zwf8K7
29763	payment	1397	1397	1678	1	1	12026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1FkaADDW284euwXjbZ4rk65bqVF9ZFMXUUfJT3S1QRF7ffnF
29764	payment	2133	2133	1874	1	1	2440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3HsS6hFAszXoQcQ8xR5qgJTWMpg6QmsravkhXRn9rgbNWd64
29765	payment	2134	2134	1874	1	1	2863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhqJJiCDyED1Jhn3EJuMKn9xvk5vCBNALQFQqBCWidhhruz1e
29766	payment	2134	2134	1874	1	1	2864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxr6SAdXXoKjdkECCKgdF3wf1hGTAqaQ5kbHJNjfh5MprtsWK
29767	payment	2134	2134	1874	1	1	2865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkRr5GnUuHPa2Ay3fx9GFsauqkzSjxb6GV9TyDYWKasUfTYfaG
29768	payment	2133	2133	1874	1	1	2441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmAV5H66fRj9YXgkwaw28FcfQB39Qiej1N6VQLMR7FQJP3tCX
29769	payment	2133	2133	1874	1	1	2442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVWNsF8d5n9SCHy4KGHgLwxgG7WproPFPBpXusirLXtRRGkDG3
29790	payment	1397	1397	1678	1	1	12034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLWx1UxQRE2GwMbV2Cavodg4ZfKqEYFqaUdmvWR4R9SSZh9zT
29814	payment	1397	1397	1678	1	1	12042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjxQ15FHrkKXU4aGbsfVCZKmu3brf7YUnECH94aRwPQemA4NXj
29815	payment	1680	1680	1993	1	1	6	287948143156	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYudURernuHcfkWw2qvuJxbXrATtCeBeboUxsYLZ5a6aedaCpAB
29816	payment	1680	1680	907	1	1	7	2188333810752	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpaCihHxBPhz48ioakMbXr73FXg195K51KnBuVtrMD2wK1cF9Ytq
29817	payment	1680	1680	1027	1	1	8	3921475439232	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZQtP75tzeHtVAM6Bk8e35e47Ziqjm8mpASpoHZriDdcBhmD6rD
29818	payment	2134	2134	1874	1	1	2880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiZnnLEFs557qrDf6HeL1Jc5ez3b9XN8tMGCvcVf1EckBy5V8
29820	payment	1397	1397	1678	1	1	12043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMQhkStgQVEFsXuzR7myLNM1TARMs8AK9JcB8kFmWiexjEbpN
29821	payment	1680	1680	1147	1	1	9	2645897619768	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYXGmG8DT7bueQU8yh7W8aCvs6okdY89BdGQ6Y8Qm8YuRZiiym9
29822	payment	1680	1680	1993	1	1	10	860000000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpYjJxvG2K8KG1r5BgYVSsNXSDK479gMcEZwRsxU9fT6YZtrn91J
29823	payment	2134	2134	1874	1	1	2881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYor1GG1SBPLwDQGhcYaYxFLvdYAJZgx6MCCzMPsH2s82intGNa
29824	payment	2133	2133	1874	1	1	2459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6DqZsTRJuGXn1sn9PHJ5ndhG2vqTYTyGHwLq4UuHii3wPvAE
29852	payment	1397	1397	1678	1	1	12051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNPYirar3hh92X4ANccwPZCtyoia7RvGUyqeBorUZcV92Ny6J
29853	payment	2134	2134	1874	1	1	2888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa46xJ1unhmQGXYiq67DQBWE6DDCLizXt5artqeykYoae7GW3z
29854	payment	2133	2133	1874	1	1	2467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDR6z19ipQNsGmrRYtrd49jUC1cXRXrdJLhpriQFcebQ6dbo47
29869	payment	1397	1397	1678	1	1	12055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwak1B1ZE8xdqwhGoDMv3pqpyN5KBzEbV1PeFHo6ncN7qNxqsE
29870	payment	2132	2132	1874	1	1	805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbB6iUDtjdH86K4WhngDn8jdYjAy2TbMAtipv6GpkNyxhdxUiG
29871	payment	1991	1991	530	1	1	15	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBw8zyJDiUXZZpoXUgH3zJ1D2jwtPV3qVsn5kN1JbotioDfVYL
29872	payment	1991	1991	675	1	1	16	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPs9f87MDFDuV5Bp5ARDYtBBTbrEzPBQjEwdMrm5o4rWX4WxV
29873	payment	1991	1991	959	1	1	17	2493452391090	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTQr7XCbK7qvX7htrK877gYyX66om2c73iBgkiWaDknFfBJgT
29874	payment	2134	2134	1874	1	1	2892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdX3gJ3nBSBEy8y96RcbkYaydwvcp64AZKLcsJZtXkSvnNUc8
29745	payment	2133	2133	1874	1	1	2434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcHmQ188q9yV3H4jw77viWfc6hwm5c8RYyYVDH5urhZa586DJ
29746	payment	1397	1397	1678	1	1	12019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRP5aqa4ukLJZkJAyW4W72MZMUq9FkaAcqqaXV6xLLVaHvUkW
29747	payment	2134	2134	1874	1	1	2859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzQgYuf4sQwzYvAJzDeLZNkugha12m3ByqMToDUfTWZWDV1PV
29748	payment	2133	2133	1874	1	1	2435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4nsgTAGYdeCZR65no1VgiQad9pM8EcdHGcWKCxQGVEFhBMvP
29757	payment	369	369	1312	1	1	15	9216286221960	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9pf1a3MsdmLPe5YJEZ1prXAkFDnSFFgLGb9TyQv1njaciqom
29770	payment	1397	1397	1678	1	1	12027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRo4nW1vHfiNQt2ocojkSKjhRprBwaZ12DkhkNjw7huWNenBRK
29771	payment	2134	2134	1874	1	1	2866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYWFgysTKJbTpqTMfKnEefN8bDRADdXN669pwydHNUCYxboGaF
29772	payment	2133	2133	1874	1	1	2443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eSqwnswSHPTmVMu9JfD2t1Br7b6RrsaoKdNKzPLjqSb4cn4D
29773	payment	1397	1397	1678	1	1	12028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmJFUszevp6jCQXQ7zESk2LX6RfKkDSmstbydPwz7oRE1T6wT
29774	payment	1397	1397	1678	1	1	12029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMa4EAm3saxx9R4pDztjQDJqaZU1BY7Cq7LrvAoL7EDgkaJCL
29775	payment	1397	1397	1678	1	1	12030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh5qejmV2pBQHuCXKydYssSFSyFywycKRMh7UbhGaRwvJyfYmu
29776	payment	2133	2133	1874	1	1	2444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjevt9HLqrcB2vgEz2RXdqD8A6oYvM2pYsm7J28dHWU46PuTKa
29777	payment	2134	2134	1874	1	1	2867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiXB3qF4HM53j5vEPaRVJCYY47oXj7sipTuE6P9mKN2au43vs
29778	payment	2134	2134	1874	1	1	2868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgekn4CCBoVx4j1B5Waou4EuhzTcDQmppFaEkgU4yBq9yMiyx
29779	payment	2134	2134	1874	1	1	2869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkPXR1Ce6N4foQhLzxLhWKpnATAvWvrjK1tfJvNeXvFFTBMaL
29780	payment	2133	2133	1874	1	1	2445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZci1Bmmw1JJHiz3pA2Z3mkEuK4EX1bqcgXKvLNczy2RNoCn6TQ
29781	payment	2133	2133	1874	1	1	2446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kWAaSw8EsbG61H4XGNCbzivgXR7D1jJW61jde7iWsb1nRSZy
29782	payment	1397	1397	1678	1	1	12031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECsit78aKGxxHw57V4CPcqzb8FNrkmBbsAVhgwafEXVKTMdDW
29783	payment	2134	2134	1874	1	1	2870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFY4Ax91tDDyFCPHntds7G2d4zzHGU4UAhSo47zHfjkXEeieK
29784	payment	2133	2133	1874	1	1	2447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZDDBbUCkAYe5BPF1xjwKJgojBFZVzkEi7z5bqSf7kMyqLuuN
29785	payment	1397	1397	1678	1	1	12032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgBrhnem1L8PhGycGHvrsjLnv1gFXeKu1ReTfNNuoCrgnrNen
29786	payment	2133	2133	1874	1	1	2448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcv2caXLqwWkY7yCoCSDPmvr1XFrS1B7wEg3fVzJkFgcHfwgo
29791	payment	2133	2133	1874	1	1	2450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh24VY1wqu32qbxC75mNBg1pwJdNGrFWNNHk2Gt4A5aLdnBq5F
29792	payment	2134	2134	1874	1	1	2872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJes95CTw6wPcBQQrZa1meT5C7STAGgB4LWZc5RRAMu37AQfRu
29793	payment	1397	1397	1678	1	1	12035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWemxR3MMprhCT1f5rxMN6vsxy71BWxme1jUEJLCtsCpeJBcq
29794	payment	1397	1397	1678	1	1	12036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnjereFrFhDf6SqzoUH9zBGq491YHq9ckXsU5i3DQrrrGgb8WW
29795	payment	1397	1397	1678	1	1	12037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRD3BbfPDGsasJiBfrFv1frhDRaNNvdsh1AKEUMF4w19A5SCPL
29796	payment	1397	1397	1678	1	1	12038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufBbsJ6AbEGXQfStptn2dUG4tKVjsm2ELXR935wkjVHMWvw9h
29797	payment	2133	2133	1874	1	1	2451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNM9xiRwbhHc4iFT7yZGzJegA2UNhe3wJjwEZHeES99ftqDSE
29798	payment	2134	2134	1874	1	1	2873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiF9JdPp4ydvLkFAvxwvcZqYt8vMq4HcmNytEJGSVPPs5so1eH
29799	payment	2133	2133	1874	1	1	2452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RetDaz4f67v2jmuQg1n94KWYxqdgHDBuxBBMLBNDQgrn3VUE
29800	payment	2133	2133	1874	1	1	2453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YFdqDRbUuLerERJqW6RUYsZKe45jNdCmbzfJhjZmtLmKbkkN
29801	payment	2133	2133	1874	1	1	2454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtbVb5NEiupL6fcQ7mAyJGoW9zbKVzq7DVWfJwQvTL8UdNqwU
29802	payment	2134	2134	1874	1	1	2874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgM48kWxan6x3RhtB8Y4veQpvKU8dgdKiWJbJUuNEKgfgVxGu
29803	payment	2134	2134	1874	1	1	2875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1f6fL3ckqoHAP5KbipfyHAagrgWggK4wPCPmJx7NRmLeJYJV7
29804	payment	2134	2134	1874	1	1	2876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmKPqq4MjwNBDt7Jd4tTxa9yKW8VPJjTLqPGB2Bng87chdiEW
29805	payment	1397	1397	1678	1	1	12039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXVBBXiMncS7LpAE48dxhDDxM5cTtkvRKxy4QeVNSfKJSu6rH
29806	payment	2133	2133	1874	1	1	2455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsxi8TeMdgGYZmpWH4WfuuX7v66oSfivRQCArsxHT58eZyEG5
29807	payment	2134	2134	1874	1	1	2877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpUMGvCJxMqoR1nBSygGugDaVYR7nifkXtBXxTWtAZJFAcxjj
29835	payment	1397	1397	1678	1	1	12046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhimNEQjfStgnAAFF853AfNLkebfFbxz2WwNMABuy4CFqHGTLG
29836	payment	2133	2133	1874	1	1	2462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuCCMU83wUzsrscBV66VS13g3WpoRBedvYxSHPctX5M4XD6pn
29837	payment	1726	1726	2254	1	1	8257	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYjsX1puCJskmpaCvpFi57abXZgehLxr4kvYHFKCEPo2TFc379s
29838	payment	2134	2134	1874	1	1	2884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7F67wUTdaabLPduVWc5HoijGhhe7o4z9Si9yRpHtixUpyQWZS
29839	payment	1726	1726	2255	1	1	8258	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZgveC7RHkykRA5S2LvSr6UY5pbXDJkEdTx4zjpeTsKz6RBFR5y
29849	payment	1397	1397	1678	1	1	12050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXj25MrAHaYBZjS25aQZ5FK46DmrdZ1cFWDyh8X6Q3ofB93LG
29850	payment	2134	2134	1874	1	1	2887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe14yQXhxQTC2vqu3cuh9tNMsq7JJB6QVjkdBddy8nXDgi4CC
29851	payment	2133	2133	1874	1	1	2466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmGargzFWi66qL4pWLRbiwTEMjjoinLWajjYNyNaZYrQgunD3
29863	payment	1397	1397	1678	1	1	12054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DoX7PUPCXyFKtTPVQFkxYbvwaC1KEd2Mzbq4opXRcd4wkMT8
29864	payment	1991	1991	83	1	1	12	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesLNwwg95mMH4N6cyKRX6RoRinQbTjhi6VkFTt7pbp4XjpSrR
29865	payment	2133	2133	1874	1	1	2470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bx8cFK68TgjEHtcR56XJpdSZuHCpHxD5qchFYAsDxFK9y1Yi
29866	payment	1991	1991	348	1	1	13	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrd6TNjR32q3Yo7RxosYedb7QEcsiKvRGRSuvtapWNXaRphht
29867	payment	1991	1991	380	1	1	14	327469103344	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFRnyh2KFTm6CUPeUs6vuc1cD3TLEaX23diNtzZ8GghPhgzow
29868	payment	2134	2134	1874	1	1	2891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4u2sVoC5TPW8ZKsXCsoUCgxRsipmgAgfLtFsAxCRvkWJD2AP
29885	payment	1397	1397	1678	1	1	12058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16jB9XQBsuDeGi9B3QCXHexzS9Guf2hegnM443gDDkfsNbwFs
29886	payment	2133	2133	1874	1	1	2474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXddotzHu1jZBmmS3AA7s82fHWvdf2EUW6gQY27EEzpQfsx8w
29897	payment	1397	1397	1678	1	1	12062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLg91r61zC6vrG5exiyKUqwF8UkQuPPUuWpNTqKooAHixKzj4
29898	payment	2224	2224	2256	1	1	1	1100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgZuUuynayrA4mxzvdLLjKnZpUuLgKuLbaWAtmFf268vGgmyXs
29899	delegation	1993	1993	80	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5NgfQnvyCezLG31X8WSwpUihEf79Totz5Qj6VoV9Qj51ZEMz
29900	payment	2133	2133	1874	1	1	2478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4pkL7fWaSdbmbirEJhsmUAkLsaUbeXixAbq5FsPcGJLmN4jL
29901	payment	2134	2134	1874	1	1	2898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxMt6Hyy9pe1dkMor5sE2adQ2b4MyS2fjDghCmZU88gjveh5u
29902	payment	2132	2132	1874	1	1	807	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56HTc9zTm7QkZX3S3QKPdX892TdoBbpgrLoNtumEjkwNFH51t
29903	payment	1397	1397	1678	1	1	12063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE1RB33ZKBgcSz1EuMTPcS59naM4dRJxvfmo7YvJSU4uxBArq
29904	payment	2134	2134	1874	1	1	2899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo1sqiXbdupaWGBuBrbJpap8V78SSMVaJr582r1JjV4cgt8X3a
29905	payment	2133	2133	1874	1	1	2479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeuEceQpUzDtfGJzUZPmqBZutEpKfUnXXz6FECjjRHQnJxqqQ
29917	payment	2133	2133	1874	1	1	2483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLNW4oQm3Q1bABTJWgfuDUbpd5AjcoQNK1UuEZGuFBSPzs4jB
29927	payment	1397	1397	1678	1	1	12070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbWgTTUrkJSKdhiAVobYByXjPQqR4PASnYzcSG5uxN1uqvNMb
29928	payment	2134	2134	1874	1	1	2905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6joXPuEeKKfJ9sxDNNU5ztYSDG93xvQVH7Qgfj2YG6afyZQo
29929	payment	2133	2133	1874	1	1	2486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKZrpqEeaJHZCsGbAMPhM6MPcj4BMnTpYTE5iou3E7S125AaS
29969	payment	1397	1397	1678	1	1	12081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowQLgzrhqXJ8aGbecpupAajsWn4LkvgjsNwWFN19SGePq44xY
29970	payment	2133	2133	1874	1	1	2497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGNnJBoV3CY5qE8fSU1s42suDJKrYjjCSuSC8WGcSEuDjCYm3
29985	payment	1397	1397	1678	1	1	12086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CjtK5GrAHjMCetMBSWPEi8EMGahJPJoTfX7qws4tP7om7WFf
29986	payment	1397	1397	1678	1	1	12087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fLkC1sWXagVMwEqmtJsRcdcjLMkFykw3DsKvngCaG3QZpKh6
29987	payment	1397	1397	1678	1	1	12088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvf84oGSgix5WJ36sa3Wbt3Y5DqK9DDCVCzuWoUKgkQnZRx4ug
29988	payment	2134	2134	1874	1	1	2919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7S9yHnvS2YBZ83R8jygfJS3TgsyWq8Tamj8VSLN4pTe2afjR1
29989	payment	2134	2134	1874	1	1	2920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yV4LQGLxozH8SWb89s77d2br5LMPBvJoaWHb4MQ3fLBqZ57Z
29990	payment	2134	2134	1874	1	1	2921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadd1HppKobNaSNXd2gKrNsKvNUr7HNmrTNECD6uivreCHk1wB
29858	payment	2134	2134	1874	1	1	2889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVk4k79eYPDf2HoNLJPJvAC9cFiTLv6WZhPFuZUq9wEf5LA6yk
29859	payment	2132	2132	1874	1	1	804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo31tXsfimLGFeooRYwE4auXc4QinRDKywv1JX9HN4ZThd6rJ3
29860	payment	2134	2134	1874	1	1	2890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TrbUnKNS3SPXqhSMHMS5CgCpSvL7HwShnmE8LixpaBhUkXjQ
29861	payment	2133	2133	1874	1	1	2468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwVoJUrJvgxRiBhKfQshifqKbum3jrT48eTf5GKxs6dScVe9M
29862	payment	2133	2133	1874	1	1	2469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjQexSPLWruwM4pjbcRiZ3BBPAQaDSEvUqdgRm9HcNeWWweuJ
29879	payment	1397	1397	1678	1	1	12056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxMECvPTM5ptUa6erfCz38U2cFyHFqk9jMjV1DF1NkuXeWuJf
29880	payment	2134	2134	1874	1	1	2893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3jauS9Ruhe6dkYZ2jt5cK3Pm5qY4JFBnbMcdpZC2FpkiGTGx
29881	payment	2133	2133	1874	1	1	2472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuypyLY1YXAYZi6PftmzGB7BQxCXnxtryYBGaaHXszXrdZFQc
29906	payment	1397	1397	1678	1	1	12064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquCSEei4GUJ5YPZ4gyBXd3k168ErHRB2PtxDpz9FYJUXfyzkz
29907	payment	2134	2134	1874	1	1	2900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxneBAaRLdSmspuLu737M8twVoK8XjJuKdE1eiKPsuRM5A8dbp
29908	payment	2133	2133	1874	1	1	2480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCMGGTqaKGXuerSvuJBRGikqARBXkQ4EtjeGw9xuAgknDmade
29909	payment	1397	1397	1678	1	1	12065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqTbuRDygmvJ8WakXQVqdwsvgstwXSwZGvgzMcKQBvQLJJ2Cy
29910	payment	2133	2133	1874	1	1	2481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDqNdYFnZHzRgLQfbHgG8SvYhTp86BsZ13xN8RxFc3hDAJqdi
29911	payment	2132	2132	1874	1	1	808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVbdYV4KkKiZsVitn4ixmcAvstBt3GQLs2bTxsdZeUiTn9H9e
29918	delegation	2256	2256	1498	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSBvt6RfP35LyYtJ5yf1HzihaiHrKMc5S78T5eLm6Ctt3te2Z
29919	payment	1397	1397	1678	1	1	12068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwiLVA5NKZVLbCyuBu2rrV3Ji3SotGwPsbFphY9eq959M8r21f
29920	payment	2134	2134	1874	1	1	2903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDR3sVfhVKAg79XRWihy2zQgwYUYDwcLkDQWCWGqd4wV8aQvw
29921	payment	2133	2133	1874	1	1	2484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQX6vwpbJid9YNnMNvxpyGgg8D9TvmunbbpL4WDjFgYT3wDNjb
29923	payment	1397	1397	1678	1	1	12069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcg4TFpkQSThSPNsgwfY1n7CFAXe4wSjMgjt9fFocjKj5o36SU
29924	payment	2132	2132	1874	1	1	809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSWZ9ngP15EVKNCawWquFoDuL7wvDnbuuE9kRdc3vQD6VJ1r3
29925	payment	2133	2133	1874	1	1	2485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaYS3EotNuT3ckpEGunbUski7YjSWmYainm1jLcJ4h4ypFZ7u
29926	payment	2134	2134	1874	1	1	2904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUBsp1McpUCrzvTB6CesZxjCs3nBV4HPeoEG5YngfwkBhmqyc
29938	payment	1397	1397	1678	1	1	12073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu45NwmHEvbJbGE5a3ibW9S3oKFpHQGTCWJzTt9wBETmRF8Cc7
29939	payment	1397	1397	1678	1	1	12074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJrvbmZxakZQozXsrzmTuj6PeRiM3RxagGCDjyZMZdttVmEfj
29940	delegation	1703	1703	1651	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrya5WSih9mQoyuRWoMT2Km3hoMssPqm86NSPDStWJWGZu6wy
29941	payment	2133	2133	1874	1	1	2490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bF6NqybM6piAkmmhgojBXBFDsxBT7E3KkD5H3ZhDD2hzwJZW
29942	payment	2134	2134	1874	1	1	2908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPgNvSLpzZ3LqsnmMqEzWZzGNgd19yHF5d9NyYivPQjE8pAr3
29976	payment	1397	1397	1678	1	1	12083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6CBaiq85c8q8UVZWP15AbW9UGFpBAGvTTaVaSRp4RiCjjQDh
29977	payment	1397	1397	1678	1	1	12084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDncvzyJs5eLr59W9uL5e4VoRraCL54QiNTdkf16njJr87fDG
29978	payment	2133	2133	1874	1	1	2499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeW6Sjz23L6TgKgHy1s6Y57dSrAWkcDTdV5wpGTYAXA271fhs
29979	payment	2133	2133	1874	1	1	2500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEin9b3DsJbNLoThZStxZe15FiXiixMJaXvD3wAgpEzqFUaLr
29980	payment	2134	2134	1874	1	1	2916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDWZqUVbQhyg3m2ZBHL6eoXmHrzHLv4S8gU82rciADGojFqEg5
29981	payment	2134	2134	1874	1	1	2917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgCVnHqVrxsD6tN2baditMHMJf9NL1tTa5UwV42oKLhJkcr8D
30001	payment	1397	1397	1678	1	1	12091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrj7xH8bkzVShGkJ6yvdfdACvhbNSYpQbD1WtZQ277WuoU9x9u
30002	payment	2133	2133	1874	1	1	2506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYax2NeuQbZEARFfK5zmLqtfH8bACUtNtBb7DxyM8D28jch2iq7
30023	payment	1397	1397	1678	1	1	12098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLs7DYAbtVicNcKRPNHPhy4H1kmMUgXV79kaZpuRXSy8SfTCJ
30024	payment	1397	1397	1678	1	1	12099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEbVoAvhEgPqqCMNMN4djvdnhpex2g5YF1LZtUHU3qcpNyyBg9
30025	payment	1397	1397	1678	1	1	12100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcazMx28Eb9qbVRL7RLr4NeudZAibwakyioisdqDrpcTAB4En
29875	payment	1991	1991	1079	1	1	18	4468245320940	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxD2pWXGzy9WEhyC1PooRD7ZYKXY2gNGx26KbLKCT7kyfxdgyi
29876	payment	1991	1991	1199	1	1	19	3014814154110	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2prTqLNdHMGPcnKQzpwiEqz1QrHwaZuZRTDVQn6H6qrEMeJH
29877	payment	1991	1991	1325	1	1	20	8401047702810	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJH5o899YsmrHgUTqYz11evKyujAiS3bWG6gxZb9HEv99RzKz6
29887	payment	1397	1397	1678	1	1	12059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYubRsACzssECsuh6dZYfUuTLCm7fmFuezudezhMo6MJ34pgnVQ
29888	payment	2132	2132	1874	1	1	806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYst2aEQdSznhiJU9vxBDNDovVkQDhGsksvQSdpLCQwgQPoK6KL
29889	payment	2134	2134	1874	1	1	2895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFwkLwGnPYJ4qxafw66ZDDaX9fymR8gJ4SdQxWvjGYteDMxM5W
29890	payment	2133	2133	1874	1	1	2475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk8hLEeQoM63yhvcAjGzBayJC4BmNVR2tuT3SQEJJzsiFcb5x
29912	payment	1397	1397	1678	1	1	12066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhsGzAwgXaLkrS3YhAXBG1iw2acN3RwAbADxzo99mqxEoZxed
29913	payment	2133	2133	1874	1	1	2482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzfwWJwJdqq8sj8Vm8jXDgAmbTMPDu11hiqNJJgoHKhReziHF
29914	payment	2134	2134	1874	1	1	2901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54mkqARTgiufjFMCF1ZLMW5QgHEAd2yytxbQrqv9XKKnyeH5X
29915	payment	1397	1397	1678	1	1	12067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwZJK1BFX5bCQ4eqWHrqMc2HmAwJmoxhMs8aN3EJCRDrP8DFq
29916	payment	2134	2134	1874	1	1	2902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjoydTiEYL2kZwukniUKh1PWBjnkzDFAa5aCHck5ULopDbUvD
29922	payment	1680	1680	1273	1	1	10	7373028977568	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZUG7PFw1mK4EtR6Baiy344hc9tHrUEFspuMkF493wSgW1JjHBk
29930	payment	1397	1397	1678	1	1	12071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaU3oKow5Sqhk8V16ZWoRs3wnzuFyeoEoYnJJskxVtEFFoBSJc
29931	payment	2134	2134	1874	1	1	2906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYC4qPRtEWY6e3PL7S61LhvWjQ81CqWDLwj2Ufni4xcU5T3sCN
29932	payment	2133	2133	1874	1	1	2487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXFZRyn6XapxoHBTsbsc3fjrjaw73WVmnmqhVTjFbNpmymroW
29982	payment	1397	1397	1678	1	1	12085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxYUrJDAg3wAThknYxijiqHoBjM7J8ABphARnwspK4fWzx67A
29983	payment	2132	2132	1874	1	1	814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZds7MUY5RpnD7WyLrGyg8sSvtvsvugu9V9GaHxvpqrQ5CfQjxL
29984	payment	2134	2134	1874	1	1	2918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MFeEHLGSMpYTo6rtY1PF5RZJwSF7JQ2EWdjyAJmMXCNahHJx
29994	payment	1397	1397	1678	1	1	12089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVqpQLoi1TZZtTzsKe4jQwaREcXxFc2tS5SvDdW43nbeMSHUt
29995	payment	2134	2134	1874	1	1	2922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmC6kJcdtjS4uoZkZLxymnTvfXWvqEVYAuuSTTxavsjr93BGu
29996	payment	2133	2133	1874	1	1	2504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSxAAWbJNW5VotkF4aFSeuu9r6yY3jzMZ5EkdLPbEym4JJAFA
29997	payment	2132	2132	1874	1	1	815	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfaRjjegGgx5nr38X1bgPAU1F85jJP6hpzUUAmJjUyzM5wzWBt
30007	payment	1397	1397	1678	1	1	12093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxFHMKGy5pL6Qj27RS7w8dkhSqMaNrm6wNvRQaD72hqbEb12P
30008	payment	2134	2134	1874	1	1	2925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1Vw2KrviiqT6Uw6LYHXeAiLqmXm4yhPJWwT38BiVDc5228CT
30009	payment	2133	2133	1874	1	1	2508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwYo9pgrs8gyx6K2AWCfieUUFfxch4HF38GUxLehVNmxDpbe5
30013	payment	1397	1397	1678	1	1	12095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTNkCM72Xt69aGK8jQhGebX9ZcvLM5ZXFW1m7YFnYV4BW9JoT
30014	payment	2132	2132	1874	1	1	817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV98KuWWZraX9nksAvEw2DPk5WNxCidATy4KzZ45Qmad8qxeEy
30015	payment	2133	2133	1874	1	1	2510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEJxdAvvuyhkQoY1fWB6kHHsNykWCXc6B1jss3NsHUGAmMaBH
30016	payment	2134	2134	1874	1	1	2927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZimNCAo4NxQAgZ4PgDp8TCiCQYv5pGHywN1P8cW1L1RgwAiyB1
30049	payment	2133	2133	1874	1	1	2518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi1Tcu2orcYjkHXfPfJPoxYr7H7t45kf7THs798RN1L5ZWtmtV
30050	payment	2133	2133	1874	1	1	2519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZze6zsZPR1tVY7oKb2RmNSScZqxVGCy1efxukHGcMKEsecTcWR
30084	payment	1397	1397	1678	1	1	12109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUR7wz4gmBYHVyCCBjQ7KbmvHwSvQAmyaJnpWLXv2vZ5ZHQhdh
30085	payment	2134	2134	1874	1	1	2941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSrM3Md4hAmAMixxg341p66RcWNLz62kMr7g9gVMbVXMDhzLP
30086	payment	2133	2133	1874	1	1	2525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJbPNTuQiT18MJ12ebQs6qytNpvjABA4uuiQVQChFS8EPr6vT
30101	payment	1397	1397	1678	1	1	12114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqv2DbNDDgFgKPpKKcLBMHpAZeC9W9qdnAtWewcRdsPCQhRuC
30102	payment	1474	1474	1329	1	1	25	6254623183360	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpaDA5xAthfEJRxqSxfDXZSC8UnGsNts9xFAzfChN2LbsvwAZXrR
30103	payment	2133	2133	1874	1	1	2530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzH6t1WNntSNKt3nRF9ydsHC3gsfa9FwzNdyHnDzoutKVTxSCj
29945	payment	633	633	1258	1	1	7	2982000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZMwNqUbcWjUFEDrd8PooSsqEDr3q1SXYvy3oFEXG38CKZQUht3
29946	payment	633	633	1018	1	1	8	2466000000000	20000000	\N	E4YttdXAwiCUuRrQngxQ8qbqnSUa2ZkhwTyj6Sd4Vhjws4m35B7Nn	CkpZGa3EPRizt7XMHbJww6V3qCNMbcQedcE8g8bM4wNYyehXVZGJb
29947	payment	1397	1397	1678	1	1	12075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2xaoQQ8uCWTAX9PW12TriH6HrDSs5V53gK5yru5iAQLE9RpY
29948	payment	1397	1397	1678	1	1	12076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomaakirjdJVbbXsYeGJtmYgUKeNzELHFirRXSgWtQcW6R9LNq
29949	payment	1703	1703	1651	1	1	4	10080000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizHuSpu1J219XRoJrvnJiXDLxQF5T4Dpge5HD2BtnTFVUS6Bw
29950	payment	1397	1397	1678	1	1	12077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJx321G2codz37iMSePF4NBbyPcEjMeLtnDsKxjwKjCH4WoHU
29951	payment	1397	1397	1678	1	1	12078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TsjJT8DSjN4QuctFU8UzbrDaTBbH61rL2sM9yJENzWQw3B3P
29952	payment	1397	1397	1678	1	1	12079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4uD5PD1oyQ1mzuWyTohsHGSbfPCKeJu9vCovGaWg2qEEinMR
29953	payment	1397	1397	1678	1	1	12080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MkJMaznojEbaWrBkTLQkYCehvE51cuWrbPUoFEHG5fXhDhpY
29954	payment	2132	2132	1874	1	1	811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVZnzidPArapfYcWjdPy6PpVQJZzdqUyG6waWurN63XbCWiwP
29955	payment	1726	1726	2257	1	1	8259	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZeUVP7wkWXgxGYZaMXXrzzpiMUq3L41WNF69GmDWsjnDpHHtDf
29956	payment	2134	2134	1874	1	1	2909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsUXbNLCzed1t8dA9FZ4fkDE4w2NmiXSERWF3op7mBB8ALJD2
29957	payment	2134	2134	1874	1	1	2910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3iB3X9xvJSr7cRYrDr193Dfu1qbDTb7nM2Mdeo1WwSMEgnRi
29958	payment	2134	2134	1874	1	1	2911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjs8z5A5R5DsWYyMNDzw8dU24nSQevYFNu6JDXJJUvSENficC
29959	payment	2134	2134	1874	1	1	2912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7ExKyDFzQd6JnFi4nmSqAaZR1woLaBe7XXiTKFevo38WbeEk
29960	payment	2133	2133	1874	1	1	2491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgupRAtdGvebMiMfKn3katCf7y917QwTX5EGbBztrH8oYndT9N
29961	payment	2133	2133	1874	1	1	2492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Ecsx6UWyNbeudTYk4f8VEo7FpBgJMP1g8Kb2etqgmMahgX7U
29962	payment	2132	2132	1874	1	1	812	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjEX4bRxVF2YRD7PUQTMrNnZ4PQtp69Bp5bXkFUEf8t9LFZq7
29963	payment	2134	2134	1874	1	1	2913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWFyZWHozmoFNfU8fiyJokpijtZ6wUHBep3vwwarZ38CoAvsu
29964	payment	2134	2134	1874	1	1	2914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbdTqiyexwknvxqcc2X1mubc9qF8QkZbf9z7sP9GBDRG8CCeD
29965	payment	2133	2133	1874	1	1	2493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4MTm4wbyJ5sCVnvxbLPKD9UZ9gQ9hjVmumr8QvPj2GaoPWXmv
29966	payment	2133	2133	1874	1	1	2494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1y4bpC56Pu4dTsYdBGr3B8GpzksTWQ524TysP2cerCKbmrpxT
29967	payment	2133	2133	1874	1	1	2495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5P1GZo35Hwv6qL4vnEpeBoPgAuaHEU2jHxnfwt2XyLWbSXBUZ
29968	payment	2133	2133	1874	1	1	2496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7Qvu6fLRMzMSouoBWqYbWyx2sc4qmAMoUz5NJcA1Q2VxhTMR
29971	payment	1702	1702	1651	1	1	3	9756000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKj7cqxRXuHp5YKvHMWYEgnUasHBYcYPBWpreFSekFKHKpsEy
29972	payment	1397	1397	1678	1	1	12082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRPvU5dQvgnjVZJDoSZGZQeTstVDQsvpqwDu12LLsLVvyfx8k
29973	payment	2134	2134	1874	1	1	2915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93Pe6zdbnyUFZemiSaKd7xCkjdnaUGGejbNayKzHdSv77Pqzr
29974	payment	2132	2132	1874	1	1	813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvaorTCM3DiSjHgcFCdQYz1YSpKJapWefrTJbtECNm6RoSus8i
29975	payment	2133	2133	1874	1	1	2498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3GCJoM9tK5kwNp9xBeF83tuwQ4QAVNZ5N3Q3Vzh7LRE7b3C5
29998	payment	1397	1397	1678	1	1	12090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjP5kGi66TobVTN9WXxMkiTCrKDAwSHR28yFmpFk7EbNKGKRM
29999	payment	2134	2134	1874	1	1	2923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgRPnqcEuXMLERio6WA1TsJBBNXbdLLFFqpnxGtWJzAfH7ueP
30000	payment	2133	2133	1874	1	1	2505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8LmxGm8XchNucDaEKKypDppfKP3QFPsyq2YuPMGyS8zCaQt4v
30010	payment	1397	1397	1678	1	1	12094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYFhyACpwrG1XhbCWZcUQffCFTpswY2ttpspoJkRMKQtYH3qc
30011	payment	2133	2133	1874	1	1	2509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwP723734PQ162kdowmk5oKsgmsFk4mmUXAr9g9EbBt9YaYmoL
30012	payment	2134	2134	1874	1	1	2926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYcxnLv2dfLfvxKNoTppUG22ZasqXyJmEWDmgoxSJvTH1dstY
30017	payment	1397	1397	1678	1	1	12096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWFV5bRDqWPsbqfkSHXF6TQg7LYn26DzDn3pUoRw8Xibv2fJP
30018	payment	2134	2134	1874	1	1	2928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeizaNEfAnjikHBa3G3n7Unfw1Ehh7YwzPpyDaP5f1P4i1uH13
30019	payment	2133	2133	1874	1	1	2511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6udVDMmSQcZL26mQHuz1uF2YepsB4wwV1T2fkCULBrkd5yVQJ
29991	payment	2133	2133	1874	1	1	2501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLggFd2RLXY22Ds5Rt2sXgQ32aXwf88W5wqSCpZK3tEq6KMaZZ
29992	payment	2133	2133	1874	1	1	2502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWNLonBVL6Rr8JZMQryMxJiugEesBLmUrpYKqBiT7gjhDdbT5
29993	payment	2133	2133	1874	1	1	2503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoQeLggQ3VRo5xk4cDWukHZLbC4RS9ZBa76DuNTvH1ecsLL8D
30003	payment	1397	1397	1678	1	1	12092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DjL69pHXwdV6qgXMpwi7diJSwVQnVcX8uXBEAkQjQdJ8sF7X
30004	payment	2132	2132	1874	1	1	816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEiwN1J8BG2uDXmmYoiUFLHk6gA8bXboQWdd7KbCtUSkmZudc
30005	payment	2133	2133	1874	1	1	2507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipDkDcCuDQkPhpBDo1CbmEYwo5uRRVoYLTLR5CFXYwxjXSv5Y
30006	payment	2134	2134	1874	1	1	2924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVygS9gpBPVnxuCe61EuoncPhxJRTq1aoJLZsuLcaT6gnnieY
30022	payment	2133	2133	1874	1	1	2512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmYkAwZ1WioSxbpEQWKPmHoDEXVK614eujoXGbT9guywb91jQm
30045	payment	1397	1397	1678	1	1	12103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsu951wzysbGuwYALNdNVhVTgg3fdhtmi5aJKMZfJ3fgD2EgL
30046	payment	1397	1397	1678	1	1	12104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWKsxinhpbc6uStWrztNccfwRyaBjEEYbt3FCKsMosdSDdGPc
30047	payment	2134	2134	1874	1	1	2935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DUu8uF7eJfAtTEyaA6xAY7B6H93NxS2b5iPLYKYmFohRyXKQ
30048	payment	2134	2134	1874	1	1	2936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQPYFLNAUm3UF47vR3vFoXtnT9Fz59aGqNgXBy2QwggRn11Re
30051	payment	1397	1397	1678	1	1	12105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEfh6i8pWD79vbNMbHxEBHVUz3UxubZNKvw3zRdyiyTRRTzH7
30052	payment	2134	2134	1874	1	1	2937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVYW1ZPbmrgHETQsLbwoRvvh8waSamsnjBDETC4xZVKbjNsAt
30053	payment	2133	2133	1874	1	1	2520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDNe8zXufSVrUJGttmfsRm7m28uW3dgzs5BsZEfxJ6YGAXxus
30054	payment	2132	2132	1874	1	1	820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVJ91TXs2pv2J2mrVWMddx9vJukeArbtV21g3vU2aRdX6pA9A
30080	payment	484	484	1073	1	1	5	1307000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	Ckpa4G5yEzScXRkRgNvvVJkN3T1ozbgtA7cZJT9HuxmoMwN6YzWgu
30081	payment	2133	2133	1874	1	1	2524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9p7aFGrrdLjUZv2Vn6xkAUHD4fA7eX6CCtroVj2ub2FWfGZDx
30082	payment	2132	2132	1874	1	1	821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbLjqburSHpUkLfEf4CPT1n4CYMwwAL73yPrxSmVZYXggpVAG
30083	payment	2134	2134	1874	1	1	2940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGm8hM4jWbfhUmMZ7J4e3K6zJ6oDTDpW949Ficwwd6imt2Z3hC
30098	payment	1397	1397	1678	1	1	12113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgKzZWFAPLqHvUCvNtg4WqVVtadMy1hskHPc82UKYBRvk25ZL
30099	payment	2134	2134	1874	1	1	2944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVFAXvGxa6Np9mD3bWPr8Du76qV1NkrwheBjdCXecRppwetsJ
30100	payment	2133	2133	1874	1	1	2529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFJAMDGW85wqQqwyyc9o5pbxoxdFVeMeC9wgEh3eKT53BfL2o
30127	payment	1397	1397	1678	1	1	12121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZintFkkLhx5dFUfetwdcmn2xkp473cY4SJ2Nk5L5Yzo8GD1tmj
30128	payment	1397	1397	1678	1	1	12122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nC7yJcgNqX95vtVE3W2agjoA1DxPak4eCrZtq1deTCqwEi37
30129	payment	2132	2132	1874	1	1	825	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKCnjJMdzyEQF5HSuK5iu1zmxQ9gnRL4GxcKpZ9QquCAiBQKg
30130	payment	2134	2134	1874	1	1	2951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUb1RFGHtHHgJsVBH4rz6oXpAuHUsb4t1pvCA8S1nnxDPQXoY
30131	payment	2134	2134	1874	1	1	2952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkX4YeN6LdQZmrepXuHh2iqgZ156bZtmANhvxfFkP73vaSpyrw
30132	payment	2133	2133	1874	1	1	2537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNYbxyJZd6dT5vnFKWaevXhsFPHpsPWu8eexoxxkAuuBkryYn
30133	payment	2133	2133	1874	1	1	2538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhyrvz7LG4wxKhi4regFwfAhD66hymjW93eP7PAHenkSH6axG8
30134	payment	1397	1397	1678	1	1	12123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKR7fFQCHCj1GeveTAr5nK9qop3EcyijPoj56ct7EFmhSVqoLN
30135	payment	2134	2134	1874	1	1	2953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGTjdWDd6cxXSpNio4zwhVdk9RXGkMEZ9cgQx9c9CUB7NbyRZ
30136	payment	2133	2133	1874	1	1	2539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2fgZzeNgR9jb4cqXqsYfEBbyKRUC6xERKB3P1kEGJPurfeKD
30199	payment	1397	1397	1678	1	1	12137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCnQyACDpyScp9PgmNFsVNm1scSJJnRHhV3XJYEN2GZyHfnYm
30200	payment	2134	2134	1874	1	1	2965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzTC1wroX3mpj1MpqdBtwvMSLZ66eJ6cuxZN2xA3ynhZPDMBH
30201	payment	2133	2133	1874	1	1	2552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxM5Q12GUjHg1JooKH5LzCSinfMJDLCv2oxZYgS333rjf75M33
30208	payment	1440	1440	1131	1	1	8	4157500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsiXcURGWicZ63hXV4Pnz5NfYgL7wohjGsNoSoRXyHVBVtTv3c
30209	payment	1440	1440	1251	1	1	9	2805200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwvqnVZNCgN9PFAZq58b2ogBGoLrzXePXfigSbGJx5wW8ASzb
30020	payment	1397	1397	1678	1	1	12097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphppHoHrCjKi3dpyU22ai1T8Sc1E5WMoQV748B4WE64MPwGRX
30021	payment	2134	2134	1874	1	1	2929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokxjVXr4ePqhMGDwT61EsVx3XLLF7YRfqkQw4Vst76mA1Ziyq
30068	payment	1474	1474	1203	1	1	24	2244185767620	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZTR5wsbCLEahZ11UpLnjX4JdZXoi6Ej2JxJ59Vw7v96K3tygG7
30069	payment	1397	1397	1678	1	1	12107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ebTqZfX9WbSwYSxUi3M9f2GxAPdQ3RoY5NcpEoVXwMBC9yZC
30070	payment	1651	1651	1175	1	1	10	3196278839126	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpaJd2Rubb8ek1Y5J2hGiKj5bvFxgtWP4umF4RqDYf3qgQ2mBbrr
30071	payment	2133	2133	1874	1	1	2522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhiZdj3uLLfcJ35UNaU87UE1DSbY8zQoca3gzJQz6mx93ufVN
30072	payment	1718	1718	1052	1	1	10	2287527339552	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A3XGg1saxhrFRx429wkNFe2wvd952xfPXNzJszNfhehs91n4
30073	payment	1718	1718	1172	1	1	11	1543440278198	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHwKP6CPYz4J6VKVWZ5muZEvJ9pJHVdQjHEpXKGyVihyd94No
30074	payment	1718	1718	1298	1	1	12	4300933570248	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEMW3ixPp8ztVPNoa3YxU5xY3WzRMUFQT3so1WKNg9zkBnRPx
30075	payment	2134	2134	1874	1	1	2938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkjjBAAjZiqWguR47ck3iVM1H2uFUWwrt9TiV2FvHc7qyjThh
30076	payment	484	484	1319	1	1	4	2457000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpaEEvMzgCM8b2FWCkcWuAPGXG7MG891e8E2r9UPAmvmQA1bnLon
30077	payment	1397	1397	1678	1	1	12108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84LVTPtwcQG6PBD7rVqW1kLZbL6sn9ZSCacooxpD8LSxDxq26
30078	payment	2134	2134	1874	1	1	2939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsfTe58aKvMm6Ab5ZQZ42JLyB7hyrkooJkYRuiWvedF66vEEuw
30079	payment	2133	2133	1874	1	1	2523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3CQUUaDbGsq2FUpB8GnPyUwxhrePxFxyCiBwCKPTk5RP7Bzg
30087	payment	484	484	1193	1	1	6	882000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpYW54xmeDdTG8tXvro9oCf493E5rQnZCQi9J2yTyBqTY5WJrjVe
30088	payment	484	484	953	1	1	7	729000000000	20000000	\N	E4YkxNha8sZLHffNHjKwAiy63pHuRg6do4ESiQch8Zk95DszRkRfA	CkpZrPq74jM74XiYabwhFQZTdx8c8PJEJTDA6ygen6wYs7ZNb4k9E
30089	payment	1397	1397	1678	1	1	12110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEpn3S2Gmoskh3BHwDmsKVY4HrgYhQcM3hjA7R1hzVbYHDhkF
30090	payment	2133	2133	1874	1	1	2526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA16hKyx4jXFZYj1dr6zvMs3BmBwaGp8YpFp6UJomrdaTXZuv5
30091	payment	2134	2134	1874	1	1	2942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrg38BuFiJzvpbuXRNCockBVGt8HxJS5n8ATXYe41DJiE4tsw
30092	payment	1397	1397	1678	1	1	12111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwBQxR6DqUm27y75vyiPZtjfToDTJb4tH3qXs8QcvMF8ULyo3
30093	payment	1397	1397	1678	1	1	12112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB7cPhRaEUxSgdNLbrKgNdVpZugjnQMak3eVuvbgusCQZWnicp
30094	payment	2132	2132	1874	1	1	822	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyNQTReEuVPGXGkfZDD6toKLtXqBPXhYwoBZrzaQHd6sDdVPM
30095	payment	2134	2134	1874	1	1	2943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaetb8ETVUMkBv5ErGqqC4sfqmc3rGkqLqVX1tW5qHGrSupo9Z
30096	payment	2133	2133	1874	1	1	2527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LnqEEsX4uvSUaz4vYXjMRHrMDBh7NdJ1iqFeXqdoVewkprRz
30097	payment	2133	2133	1874	1	1	2528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49445mQjMQWea718EDxk5W6KsoWqU1hKEhUiDpk3JKXdigD75
30124	payment	1397	1397	1678	1	1	12120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBjkF8DNWZy4qWAcX3cKaedbdjFHcxH7FKMeRB2rdXf1GZdjGP
30125	payment	2134	2134	1874	1	1	2950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxTrdrkeWY9EbyK1mBN9pRJvWfgRCvLUa1iDXaS3hwgPgNUNo
30126	payment	2133	2133	1874	1	1	2536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYgkjwFPHbrG2oAHTuxC7WTFPBt2pHgRJAZJK9k5jnsF8womGE
30137	payment	1397	1397	1678	1	1	12124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zE3hFivupmvvBzJUeL2pUvjAQDxofeqCCwv7ukj9VE1W6vAz
30138	payment	2134	2134	1874	1	1	2954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCbSHZX57BB5PVS4skvapDZRd8FwJb9NEo5gHdBF2xDWTyd4o
30139	payment	2133	2133	1874	1	1	2540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQHZh2owAncSf4CoXNxNsFefnGadmvy1j2tEuFkXHvxNtzq5N
30140	payment	2132	2132	1874	1	1	826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJqvJ7mjH5AchymWyb8qSTyeo8pfPp6VQnqmud19a5Tzjkh7r
30156	payment	1397	1397	1678	1	1	12127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruajrMZ9QAF5G9jhY4m2ux4Pqimb1i4smzABYG354pS1FSvwP
30157	payment	2134	2134	1874	1	1	2956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYUVhakYiWHvsutPKbLn7pZBL26CikyZmp23tPNtUkhiQgDxi
30158	payment	2133	2133	1874	1	1	2543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSQ94fq2rVfAazKiyiiyZZasbSi55iTju4AGQ4TCpqNF5pgXe
30167	payment	1397	1397	1678	1	1	12130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvHpPnQHd4JTFRiSJPLbpMgET94S1NUJ3RZazNiFWAynEzyWF
30168	payment	2133	2133	1874	1	1	2546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDT9WPRyauUaEkhhjXUaqSUcUsDMKgUKGZUhjEvxBKbJ97mUeQ
30169	payment	2134	2134	1874	1	1	2959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrxYAvQMcCvgtPgbm1BT8bYNWbBN3yo5oBrnvMKNhndwFrcMS
30026	payment	1397	1397	1678	1	1	12101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6o5AVXwj935cVZMAJwWuNh2G4BQNFC4F8jPQEoq4LqT2aTqbk
30027	payment	1397	1397	1678	1	1	12102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoDJjbCo7qF2AR4oiwFipThJrynDX3zoxSfcfxvSQWVTqtfw6
30028	payment	2132	2132	1874	1	1	818	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUuRdVvGHp8UhEXug1xbfAWxiSVP8W4tWJUnNcfxBRn3Zd1Q5
30029	payment	2132	2132	1874	1	1	819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXsZEjjpb2xgvrRk1zS39cx4jBENPa8ib8pBZ6APA4FEfSimmT
30030	payment	1726	1726	2206	1	1	8260	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYzSRuAyYmCSuRkQPiFvoU3egjhLDjr3uDTscwhSTtBnEa4Qy9T
30031	payment	2134	2134	1874	1	1	2930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQyUNS4DVN8onmBQLLvVoof2RoWBEoHSKqzCbRHYuh8GTfKNg
30032	payment	2134	2134	1874	1	1	2931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzuJzCPLhw1sNyacF2WhC6rvBnefwU69T3N3ugJPLVDYNxp4Q
30033	payment	2134	2134	1874	1	1	2932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajSSaTDCzjRsRL2U2XM41SyBipYb14cCTnDPgTojjEEvdgQ2Z
30034	payment	2134	2134	1874	1	1	2933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmNB6SvYCpuc4WqmHZikQ2Zaqc8aMUE2AyVJSBuSV9b7Zbc6h
30035	payment	2134	2134	1874	1	1	2934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcZjiApgnd8GeYw9DCjmXX7kA9bdkzb1pdn6NeYPi857hY2LQ
30036	payment	2133	2133	1874	1	1	2513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Y3Tw1YxDcpn4ya9rn1adgczRqWf5PGfGKinopv59MruUNaFA
30037	payment	2133	2133	1874	1	1	2514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa65PaLeMwodaqRxowP3LTYd7jDXUHKfYbbTbozie8QxHz1iJoX
30038	payment	2133	2133	1874	1	1	2515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73L67ogXhw7nFKb5rUHSu99kG4hQ8zALfqjpABuFtjAujEUoC
30039	payment	2133	2133	1874	1	1	2516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZV9BuP5vJQt2XZEnP38reookKvKUcg3GcjVwK7F2GPG478g9c
30040	payment	2133	2133	1874	1	1	2517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8aiEU6aDaTvKujWwJUfkgdw9rxZ1g9dZFmWXzwAKLJn1qzzVo
30041	payment	1726	1726	2205	1	1	8261	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHbEDmAT5846HckboWHcebyr8cTc5nCsmvzmx5f1scx1QhnpJv
30042	payment	1726	1726	2184	1	1	8262	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZMcvWwRSvhw9G6XY8YVuF1yt8njZnnspB1rupCRzQPQmXmZXxZ
30043	payment	1726	1726	2185	1	1	8263	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCeKAzxe4zzxv2FtmeiT2CKbFMKykb76Hsw7ChAfQQmtAhqeTT
30044	payment	1726	1726	2258	1	1	8264	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZfcQM3kgaxyztVFWzAc9xptXMaVWCPPDxQT5oqdYPEZPYddMAt
30055	payment	1397	1397	1678	1	1	12106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7krWLmNH65BXGD6Shqt11q7JvFKsBXw23FYufHTZVcGcEM7R4
30056	payment	1474	1474	963	1	1	22	1856091315180	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZDJtoR4xoSDhzSQgLkcNaSGXpvbsLhfx47yndohY8WBKmfVcF3
30057	payment	1651	1651	462	1	1	6	347494240603	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZxfKLqLnsrG8u3VBYURixnSD1cALeMaYbgm9SDFrHYCHMF3KTe
30058	payment	1651	1651	754	1	1	7	5265064217	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZqvNbYgEgENDTj4xtmg4AiTGTCUmSwtvpzjNoVo887X1cZJseN
30059	payment	1651	1651	935	1	1	8	2643535789138	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpYgXxbBs7vb8WJ8MGLjyPmmpcwZs584NgcxAxtY2zLKUxhYu8k1
30060	payment	1651	1651	1055	1	1	9	4737193484311	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZ9TRZ7wVRDq3SSMYsqEsTBASwR2AV6W1sLnt9vkJfFbXnjKH5e
30061	payment	1474	1474	1083	1	1	23	3326099733820	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZyvaeyJ3tjbCRZRw4a4LsZcGJpAp81Qd8egp2XifPcqK2Xnkdg
30062	payment	2133	2133	1874	1	1	2521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVsQLzZLZRZv4DtLpQXQcshtxARjPuENn7ggmrXpLfDQaNYy8
30063	payment	641	641	1090	1	1	12	3758374800000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkd1Ur6EK4XPQ4XiEo5WkevYQjLrV7U1X8cMVzEwsLVBWNkt1D
30064	payment	641	641	970	1	1	13	2097075600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK28L2ySpmJA3rwRFkW5EWcCjqvoRQdir3sbcM5CeMTQ6TQPPE
30065	payment	641	641	1336	1	1	14	7065241200000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxbUkeB1nAuQomgLuD15Nhqr4LKQATFXx3SNtS9GwVoSGBvmg
30066	payment	1718	1718	932	1	1	9	1276528056272	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SBg8dKVyvbKk57NfkAuBD57hCBCm6nixFWfYYU5L3JrgyERv
30067	payment	641	641	1210	1	1	15	2535998400000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJD7etuMPhygpo18omqGLjxzj3u7huRBaY5Y68sQWyLu3AxCF8
30108	payment	1397	1397	1678	1	1	12116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXb5Y89YyQ7jF6EE3nXDafbcYzVLpbtyCdjcjTp9NqdUR2TuXG
30109	payment	2134	2134	1874	1	1	2946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfcidwhqEsj34jBZQqXtdMsySMivtupdH6Hh8D85JyRfemcug
30110	payment	1958	1958	2259	1	1	2	499800000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajZZCz1JCSNbdTbvuZnPPCjNRSy3VLKTZn86PXekxN7PRJewj
30111	payment	2133	2133	1874	1	1	2532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbrrp43qGzJgppez5WWQou5yjE9AUoSq37LGZRYTVAMdb8TKY
30112	payment	1651	1651	1301	1	1	11	8906715182489	10000000	\N	E4Z2gV7MyJzJe2z9rDhn1Cyd2GBLvS2Uo9wdJnuuV16FVCTG4C5h9	CkpYW9zHcRBg7ApxsZyfPubLTVEiuzbFNMJShmsYp5SQMPnCCSsFt
30113	payment	2179	2179	2260	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvAFrwSVvoau9z7LYCCxTge4nyG5gXjrLuzHBhreAahDZg6rH
30104	payment	2134	2134	1874	1	1	2945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhkRTkZXZJTzapF5vs9vu1d5eKySQtwfsCB7Aj3Gxf5pmeHBg
30105	payment	2132	2132	1874	1	1	823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoaLDgAhyprQBSroMAmQowSBEYZF43tFoHwtVw3dqZnWVNANh
30106	payment	1397	1397	1678	1	1	12115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx57zJ6aczGD1pJ5RGfZKmPb6agVA9E5tMiUi5NVgk3pdnbFaA
30107	payment	2133	2133	1874	1	1	2531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy7qekLdnvsgsDmkeEHjZPLAvjsAYV6BZh4TK7K48YXp6Sxcrj
30141	payment	1397	1397	1678	1	1	12125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMoALck41JwCdjpHg3PzAs8jUxWwQiawwU2fgQ5AFxiAmiixSz
30142	payment	1634	1634	13	1	1	9	21728930621	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZhdbJmGyjtQNxM2XACzyLbJMSYmvdmyeyfk2hzKvVUp6ptoD5t
30143	payment	1634	1634	19	1	1	10	10866801244	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZXg5cLi9QmciYjuq3wNEsZqBQvQ2tWA975Qw2FNeCuy4whJAiM
30144	payment	1634	1634	203	1	1	11	308344317995	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYTSxbQXS5xb5RRJz5wkLMW7NQ7AknX1VnnTXgjFNxA9bibYrVv
30145	payment	1634	1634	241	1	1	12	308344317995	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYdLNbg4d2Gn4quZ9YHo4nUFPg6oKSKeDipWCvy4cFueCHaK1xL
30146	payment	1634	1634	313	1	1	13	308344317995	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYVaQdgaF4XrH5rHoRk2e55wcbrvpMbuENLhpBBYhxN3tSRKJEX
30147	payment	1634	1634	965	1	1	14	2286444226326	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpaGFUtvhCfLH1bX3DGj7VExGG7fDSDwU9vRpBJPRzac4dMtoms7
30148	payment	1634	1634	1085	1	1	15	4097288463320	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZ81jdiEFZFQb5tcvejMQocsNQRX3eLsGCGqmfRhhpnSRY8aZXp
30149	payment	1634	1634	1205	1	1	16	2764522170436	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpYXVvQYKiqjGiigEE9JmtqxBCUCw9N8GNgkFbPwG8a3avbf1X71
30150	payment	1634	1634	1331	1	1	17	7703586835568	10000000	\N	E4ZHxZxFpVTBmKv3338ca5wrfhQ7mYssNZZLiQxPNQvFLgDDwEE3C	CkpZuFJCYobVTg4DbsZvKdGDjYPqsyQoVCiLUkpDZ1qMTBFvfmAR6
30151	payment	1397	1397	1678	1	1	12126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJrdAzsHtjycAH1rXXGd4GiEga3Hwznr32pzftHEWonhPVbZCr
30152	payment	2134	2134	1874	1	1	2955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRiDFEcuBfFBoZEwWtuMVsR8MXxZoEtuXvk1wVANGtdFeLb4y
30153	payment	2133	2133	1874	1	1	2541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk93r9GMQ3CL8qyvSuRXiZaVeQnmNa3o1d8Q4dhU9mruuMNdvw
30154	payment	2133	2133	1874	1	1	2542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdM4exMTWaP1XC2CHgiRovpzqD6GaHbktLy4aqKnYoXsfT1Nd
30186	payment	1397	1397	1678	1	1	12135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWB2uWQ7vFzRmtah4jpXmfu2Tbusq4FhBgPKvUk3gzYrEcf56
30187	payment	1506	1506	2037	1	1	17	684000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHJhADB2FncoW5owjrvCn5RPUVrqzqspUSMMMjC6MBngr3DES
30188	payment	171	171	1128	1	1	5	3336766309110	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpZ1FoLFYVU6asGeaj25sCTUbu8zUMVpXsuc7J8Ro3C1YDSBCTTV
30189	payment	171	171	1248	1	1	6	2251382718519	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpYgR9UaSEaAKSKmbgnmjAXscC5NbM1VTXTrn4hXSSe1Y9J4eEUk
30190	payment	171	171	1374	1	1	7	6273678126963	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpYYGXJc1wyVBcZ3YKj3QuUG2rGxDdaLdzxA34ijP4JPXjLamxTg
30191	payment	1506	1506	1373	1	1	18	5837500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfPMouN4beqnhURi7mNJU7iQcn1g1kMGZHp3UpMGokk2GNrwy
30192	payment	1506	1506	1127	1	1	19	3104800000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAs85VtRmozsnyQunadkn6js1ESJckswWzbN5MJHsgrUno52o
30193	payment	1506	1506	1247	1	1	20	2094900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdnqLEkibXvCX6LPjEyU2SdLkKMWDYzYHAdMRBzyzdjFk8e69
30194	payment	2134	2134	1874	1	1	2963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzrzZw99ze4FPQwkt9sxwuA1ZRPw3kqMBHhBrjQyTbtriWBCw
30202	payment	1440	1440	2040	1	1	6	900000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSNcuSoXrp3tWMbi8C8me8g6K5n3AMxQduKFUfJFHK5Z5U9aXM
30203	payment	1440	1440	1377	1	1	7	7816700000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtWpSemeFn6NN8ghAFkdjFYxrZaaXrz5rfWukKiD3mopip4aq
30204	payment	1397	1397	1678	1	1	12138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDjSN58qxddse4hfvhuUgxRSkutFAfoLpNMEPVTmJPyGcxtDjP
30205	payment	2134	2134	1874	1	1	2966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tuoikC5YfEXKyxSgNjudAdcX8h1g24zXYyQnzqJpo1umQt5L
30206	payment	2132	2132	1874	1	1	830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvY2DrbLzMaaYzsfVURH3fHv9bPgPtxyhBXAxsRtgxgF7Ae95V
30207	payment	2133	2133	1874	1	1	2553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbk39CmRjVThgPE9hmtdFQPtc6EevkkxNRLnrmvdcRJHLTmyZ
30214	payment	1397	1397	1678	1	1	12140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBp3dSyZjoz2YVhfhiE9vsqxd7Ekx5PJ2f1qwqGQaspZWEN6St
30215	payment	2134	2134	1874	1	1	2967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ253dNLdYy1v2DSsHEUXtUFEi6rm3e8urnCq97it3SrMUBGxFt
30216	payment	2133	2133	1874	1	1	2555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofyBDJfyYH6aSnpdLnTJhSdGksb4zZkGxwZv3fQGT6E7uncsq
30217	payment	1397	1397	1678	1	1	12141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgzVn1emS1abvqDYtF2LNmBAmGBQbzMFStvP8hVarBeUQe7x4
30218	payment	2133	2133	1874	1	1	2556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7wBu655oDYbfVJqvvAfuAGDGQNATBo44968HbKr8snY6YASo
30114	payment	1397	1397	1678	1	1	12117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsFJA15XsseZobbv3EgHGMqdv3R7DCqhhoMc7ayTTMAkJDrwT
30115	payment	1397	1397	1678	1	1	12118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPxPgWKoiaTQntX1f4WEjYRatC61L5McJZJGAmt3sSM5Sdccd
30116	payment	2134	2134	1874	1	1	2947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmysipFuQKLcDZpsf6MBWL99hg2ELKzPA6wxszXUKAs5ChDkb
30117	payment	2132	2132	1874	1	1	824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnrH7ybn46PFB4Y3LTsJqPTsoAXu7mNGfXqqbno2qgG9UR8Qou
30118	payment	2133	2133	1874	1	1	2533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYYQnM2QK4uyTCvU9AUxLnk2MFZzsh8vzsaesshcK8b9TDpSh
30119	payment	2134	2134	1874	1	1	2948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEX6H7jLuJPBQCqXkE2vsVi6eRi2368bJcztMGsaFHCXbt5UJ
30120	payment	2133	2133	1874	1	1	2534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6dzDpPaNgYRfaXpEHit2TANgJnrBE2JvCeqTJhVgdamHGz3t
30121	payment	1397	1397	1678	1	1	12119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZN99WnHSMGXLsZ9tVuLyAaxhfmCQzuTsffBGkWg2STnUEKxf
30122	payment	2133	2133	1874	1	1	2535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqTQYcmZpdgKCtuADc1AVCyPujakevck7PVcCzbWU5t1KcrBt
30123	payment	2134	2134	1874	1	1	2949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5KFQkGj2e2V92RtBDQ5W9P2FXFAGokGUiw5dMTbpeLF1QrJ4
30155	payment	1474	1474	1329	1	1	25	6253623183360	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZjwuncuNXTdBaZdkUhegAv7PpPTztspehiKDkiWZugaXAnmgfc
30159	payment	1702	1702	2003	1	1	4	1044000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVD9zuAX9g5KAvPBECrbNuwkRXg4Uo2y5DVgj1P7sFXsBLZKc
30160	payment	1397	1397	1678	1	1	12128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzi4252ZBB4iHihUqmNCGisURHR4VKf7ZnVCumhja6dy2ujogz
30161	payment	1397	1397	1678	1	1	12129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyfeUCiann3TwnvTWKtMGVbswmironi6gdxfEk3YeCmtXnhzK
30162	payment	2132	2132	1874	1	1	827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCUeVsQRVHgmeoL6jgXs4iamRCw4q6P9ujKZqKmqp54Cz4p2n
30163	payment	2133	2133	1874	1	1	2544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8kh2SXsyuhBAp6rDLArNHPQJi5k4iEMJ8UaJLKQbFkhzPu3j4
30164	payment	2134	2134	1874	1	1	2957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpyZMSnE8ViRdEMexqvx3Wg6Fq7LK3Ee5uhPUcQnUbGTB9iyq
30165	payment	2134	2134	1874	1	1	2958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeEu16bAtBhb4KjSfcMqRPrZvCvpWGdHWxZaFchZqzg7D1Tpw
30166	payment	2133	2133	1874	1	1	2545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAzHUNRF6AKZ2ejHKgGPwTLaw5n55LgaSbjYs2gGpexTuBt5q
30175	payment	1397	1397	1678	1	1	12132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqb62aAPHiXoavWweozJ3ezBctS1F7Q13oFVMcjtVgwfwWWp7
30176	payment	2134	2134	1874	1	1	2960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw92eAmheDVfh4QdQnVag6do5MFp8KSJVVh4xwDVoyQNPUrDhH
30177	payment	2133	2133	1874	1	1	2548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhYGiwbj9zS1cjforPqEjvjvtbus8uc9SPPTs9yVvBHRoFU9P
30178	payment	171	171	1008	1	1	4	1862043673602	10000000	\N	E4ZMz1UwDGxF9EUN2MEC1pH6nWrkteDnamBWEfZJwKWutvQq7c3Ht	CkpYVoQWeGwPGV3Eu87uaT8oqSKVnVkjhkWtsf5me4fiKYhAKx83t
30179	payment	1397	1397	1678	1	1	12133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNVntvRhC7tM1HciNoLpBSaUPKBgU3qxdUBeaHwDFXrH9VMUk
30180	payment	1397	1397	1678	1	1	12134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKozo3D9GfHYQLnZDGGrw7iks3ZMKWGcZLugTrnysfBfsp1xW
30181	payment	2132	2132	1874	1	1	829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjiNxehMcu2JWfyKcBSZahsR8e9HYrsSSthkpbvdNZZE2gU1KN
30182	payment	2134	2134	1874	1	1	2961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82rbtZU42cWB2S5v1QWYpqF626WYTUYusaGq4nxGiqyarbXR5
30183	payment	2133	2133	1874	1	1	2549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pFeNRpm2YQWrGykZGygY8j4N16wNg1dZmgSpMghhiZg22thR
30184	payment	2133	2133	1874	1	1	2550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxUDV2LtphHmHKdudpdg7r7C4VkeiJVyux41u569EuwPt4Tp9
30185	payment	2134	2134	1874	1	1	2962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJDEom4BkLjoZ9q8uCDaeCHpFLkVoyboDrNiaSZZtfGyFp8fJ
30195	payment	1397	1397	1678	1	1	12136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLka99YNL1WD4S5u1tbPmBYQGcJz4TUjAhaWqvrFiPagtcGjg7
30196	payment	1506	1506	598	1	1	21	227430000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZAUGmPKXfQr2cWoHpacvZQ76ddx5cYW1kVMULXrBUrjVaPVD
30197	payment	2133	2133	1874	1	1	2551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZET7ebGhkX9e8wPtyPpJEYcbiUdr3SThytYYfezaYdikPX2ypj
30198	payment	2134	2134	1874	1	1	2964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZueivgehHc4dkEY1yJc7Bc3DrFpGrPggPXiz951gz82M8ziyRM
30213	payment	2133	2133	1874	1	1	2554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcWD2oc8hKvHPVy3cY6UdHYb8yjJrG5eSf69Eg5oh4zkGd43L
30245	payment	1397	1397	1678	1	1	12150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAJzff4peHqKogsKMds11NPg8rFRPtHBH9PGhMHFxhczRCyFk
30246	payment	2133	2133	1874	1	1	2565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY25sjxaLQqYkgpMj96wzTNP7fHunCAjD7r2UAQceBj6EdC67X
30247	payment	2134	2134	1874	1	1	2975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoFvRMxFHkhbsef5HdjSoxdgYjXcf5FApTezMARTpYNy6SpGT
30170	delegation	2245	2245	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G8FdY3oKVLYzLJZumJyD3idV7TrRPvtNXkgeALQXLJPAu16x
30171	payment	2179	2179	2260	1	1	1	90000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCptn4svD6NXSfRBwtqxNL183DFX4NjkW8vdHeNSFMXyHGKCvv
30172	payment	1397	1397	1678	1	1	12131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKufxseBido5tdowdXL5cxKvM7D3Z5nPDewMbv3wSu41KeF7oh
30173	payment	2132	2132	1874	1	1	828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9APmt2gArVAGjK6X1YbxxjaxNvyhWtiSwYtbj8c4bACYMZms
30174	payment	2133	2133	1874	1	1	2547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQCVPmZmHYxDjK62NMUwj9aw8CxMW7qFotbtK1Y8PoFpX3tYF
30221	payment	1397	1397	1678	1	1	12142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgz5PTogC7ZRThJpPpdueq2tsk7279ahPuXwdvwarW7s9PqZKL
30222	payment	2133	2133	1874	1	1	2557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVJDEmpyeUEeB8M4z9gBfzhxpXCGHa7xkPWZ77YroAJoQP3kPs
30223	payment	2134	2134	1874	1	1	2969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZQRGYfCdqaZwA5qeqseZq9dARTg47A8pQ3ZvMqdisxoFgn87
30242	payment	1397	1397	1678	1	1	12149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRPWF8UecqLQFXDJK72b8Hf6NYhyz7tvZxsKKT5Hv3UWLGcPp
30243	payment	2133	2133	1874	1	1	2564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSTi2A1t9j4H3MSmTLnhuPg2CxhesKupQdAKB1ADciVKu3Y6b
30244	payment	2134	2134	1874	1	1	2974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeWptWxVTWNCDUZTzRGXGDHLjTorRY9H613oC97diwHPvJMNe
30258	payment	1397	1397	1678	1	1	12154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5weSJK4fbygBPyWkz5ejatQMEL6abhnSreomErPc6MHhkLzmo
30259	payment	2134	2134	1874	1	1	2979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2RB2BX2vTkV83w4BJzKqgJF1cRktnbBZaAYcD9htY5UopiJQ
30260	payment	2133	2133	1874	1	1	2567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2eYDoU6XmRT4NKnrNwoaCo3cUhRcGvbjhdUxNC45wSFmmZpSs
30261	payment	2157	2157	2157	1	1	24	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvvFeCDnHKvVpkZy6foye3gWmmkhmZDUtRtuvPMFyA5ZDdyRy
30262	payment	2133	2133	1874	1	1	2568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1XF2J8RMZdQgwEtqQQ3iAhj7W33H33TJpcv9uY5vWc81awPB
30263	payment	2133	2133	1874	1	1	2569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZfzYQebL9pbVLqD8cjuuT5xQRAzjueUQZTu7ML9HmW7wUKej
30264	payment	2132	2132	1874	1	1	835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkZhgXyUGWfz86BgT1jqipRSkZqivEZBgs9yA2mp8Vhi3ge37
30265	payment	1726	1726	2260	1	1	8265	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYd24H78ptupFsZFVuApvzKY3KBtWzGvtfCcw2y8ihL3WepqcyM
30266	payment	1726	1726	2262	1	1	8266	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYj5SX5J6Sax6jU6gNtdP4HNpzjMErujeaxY9jaj9MDQ9kYyzbE
30267	payment	1726	1726	2184	1	1	8267	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgo1EmTUwLUXE7Zi51gKHxKdRWqRFZhibepc9mucrW8SUrBS3c
30268	payment	2133	2133	1874	1	1	2570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRo985g8Z6QDGfd9eUdrEHCDJKCvaBi2hUswMavKBcDGhZizr
30269	payment	2134	2134	1874	1	1	2980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5A3jDYexE7Njzfq22FCBKbYnWHCDjUf9TBuzpGf3UDPdo31u
30350	payment	1397	1397	1678	1	1	12168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAivL7LzphXD56PLt1uUpinzqSfoJkVGRhKsaNAV6zcggyS56
30351	payment	2133	2133	1874	1	1	2588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2KRoKDfd4tANCuiNSAwGG21iAxNd4VSLCseDyVafC5J4qFE56
30371	payment	1397	1397	1678	1	1	12175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5oWK9ibwpjkfGsrCT9kEMwMUKskaCVD2mppQj84E5AkG6yry
30372	payment	2134	2134	1874	1	1	3001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicMJtV8qLDhPtA4cdBjseTHw7wW3YaEW8HG5cCHNQZMXPoP5V
30373	payment	2133	2133	1874	1	1	2595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR5JcaZsAWKdjhjidPtoWCcrVXQsNQx2sUUH1HiCM6aPDBess
30374	payment	1397	1397	1678	1	1	12176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXqVtDsS8CBdyiafyrPFV9vACjVKXS6AQk2kKL82UhV4qMYDf
30375	payment	2132	2132	1874	1	1	843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbmTfq79J92NYEaYtFsnqMsR6i6LvdeRAgPWtP8a9LEtmpZyQ
30376	payment	2133	2133	1874	1	1	2596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrUiPtNraPFR4TLFddH7G7Du26ofcHnzYNsMgH9H8CASHpGwV
30377	payment	2134	2134	1874	1	1	3002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzkxtvyWArrR4c58YsC5nQPLneFULxUfWYKLRBcPWrENemBxv
30446	payment	2133	2133	1874	1	1	2617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAmb8NKRrgGqbPtvQxpnJr2jVR73rqwvmJoXP2a92ZBQSx85i
30458	payment	1397	1397	1678	1	1	12201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXab9drTyS1THhVnmgu4nhHCurggDB39ReWHGBQyGTA3zsJJ8y
30459	payment	1726	1726	2267	1	1	8273	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYbd1P3Y4tf3Ha3UJLDESUft3ekwL4LTAovCR4E7tkhawAdUUJH
30460	payment	2133	2133	1874	1	1	2620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2h24fqT1jTmUDA816Zc82Y9zFKTp6KaYAGsqtu7ZvoCptXP5z
30488	payment	1397	1397	1678	1	1	12210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t5rdfqJ4nDMuFSeH333oyDNvZ3msAWD6csPy4uhfkEBqK7h8
30489	payment	2134	2134	1874	1	1	3031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZbvXLnQSsGhUVtsdAvRKi6Nqo6K4vsZtUjxam5LjN6teoQfm
30210	payment	1506	1506	1007	1	1	21	1732600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr44JeBKTqSxxS9nExZMDhpQ8BH14pFQ6px1z9Ei2o1i5gPtE2
30211	payment	1440	1440	1011	1	1	10	2320030000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kUHzXNrDUmS12TBw51WSJWPzffd42BVpCmByeunxQq5831uC
30212	payment	1397	1397	1678	1	1	12139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZjRQXtQ2wFTQtgozox2Snrvp7AC8d31imD5b5mgDPYh5Tc8e
30224	payment	1397	1397	1678	1	1	12143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyqm7q8puTqC7zgysxyMcX8y2EXybqw5YCM6okTV9QqcU7Eab
30225	payment	2133	2133	1874	1	1	2558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZfarpqLoRuPjp69Fg4hDVivNoG5XuRSVcWZsptdbSHqgBK1P
30282	payment	1397	1397	1678	1	1	12155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2JXfFvdacFCBVSsN1mAPbejms5XqvxsDcgWSG6wEHWECheJh
30283	payment	2157	2157	2157	1	1	27	300000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5MZMP1zVLkRPCg8UHyUq92XkF9BY2a523PRu6yz4GRTyvpAo
30284	payment	2133	2133	1874	1	1	2574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWxjmbGXFAqG33hJnYsqEi6yzTj1xe5neojgsNNT6jbUiBkm2E
30285	payment	2134	2134	1874	1	1	2983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQ3Pn8rM4HZ81Emkv87KMDu99FLvZsYKdcGqZxxS6eevvnMpq
30286	payment	2134	2134	1874	1	1	2984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaw2cH5wDz4jgEtur7hQhn5XQdF2uhFwMxC95ruAoSUp6Bt4Sg
30287	payment	2133	2133	1874	1	1	2575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJAeHW3k7mFG4eT77YxgtARbx6qtUoujLHT566Ca2THf5NeAC
30288	payment	1397	1397	1678	1	1	12156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBbEDssNoJv6SgPcXsL7dP8Qtk9g5NrwufffXWv4e617Rc4jD
30289	payment	2132	2132	1874	1	1	837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYAoC3QghZPoPC6SQf9FaMQ17oq52cUU72N7c1ixHyFmBivvQ
30290	payment	2134	2134	1874	1	1	2985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBs4L5JNLayw2dARhtt1N4EcxGroWZvEA3Bc9Z5eFcJE8MdvHk
30291	payment	1602	1602	1003	1	1	5	2461875540000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUy62f23tv1aC7sYMoZFJYS1ZJ17su6Kzti8R6CdvseCeE3cnb
30292	payment	2133	2133	1874	1	1	2576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVCCsqMpnnvv1DXtFNcZBgvyVBwyi93XpfrS7xBSUk9XznNFE
30293	payment	1397	1397	1678	1	1	12157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuE27FW7Pmdwg5JZDc3BP26MH5W6TtX5CwmAiD1rnouNfQQPB7
30294	payment	1397	1397	1678	1	1	12158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySYbC9wazrv7hihZQgwqBEPSuMDLyxqsABt9cAPMdktPZbMP5
30295	payment	1397	1397	1678	1	1	12159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFxdkN56sprVVzDnXLk34c849uoCXjoFX5HqcSd4n2nauX76b6
30296	payment	1602	1602	1123	1	1	6	4411659870000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkA7APZmieEoFmqYvjqFSB7zqVVzh1pDdNaXkwE8NVUZ688rh
30297	payment	2133	2133	1874	1	1	2577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVWorir9kWuSAxAXNgHbWTd4qAkht8DvP9UVwrLiWQRdwC8L4r
30298	payment	2133	2133	1874	1	1	2578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqekebLamMJHY65hwfQ5PspP8amB3EoCaaLGhD8cA3rVhy7fz
30299	payment	2133	2133	1874	1	1	2579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaTaVoLC2Dwro1egT8V8E4pyW8jz1mcty9UMgCB3aXbmfVMaf
30300	payment	1602	1602	1243	1	1	7	2976634820000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbX3pUHNyK4EF3GXkMMbvyLPpzCsoyX8WSu7buaJd1mrMPUk7B
30301	payment	1602	1602	1369	1	1	8	8294657600000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQC7ubXXEprFKi6k27kFZDLcRadi4r2vLUeRsSLLKfWfHdvD6i
30302	payment	2134	2134	1874	1	1	2986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bvdBmsYd6u5Lc2v9Nk24qiX9JjxNBByJrkdWLygrvrqnfgnT
30303	payment	2134	2134	1874	1	1	2987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUMkquyuATT5AXKogLDR1bXsFTZTFci3XTcBK2Sv3mCGWamZg
30304	payment	2132	2132	1874	1	1	838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJWws3bbnfRrkCsdT5PzM9irTQ9BwUhdy93gZbVwdsRT1WSf31
30305	payment	1397	1397	1678	1	1	12160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WhD5vUZrUypXujrnkgU4RBbnnw13d1A8poU1iJwdBfiwcTgJ
30306	payment	1397	1397	1678	1	1	12161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7C3GQ9KnaPHpRz3F9DUGunBsRCBmPWXADoJaVWDVVa4LUcqLy
30307	payment	2133	2133	1874	1	1	2580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCWjNfi4KsNUiGK9wJYcBBb8z2SGcT9wTgnCxob5f5qj71FfT
30308	payment	2133	2133	1874	1	1	2581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7L6sHAamrVCUWiXTjgbwWKohhvcUvQjWuqigwA5memnNxsNA
30309	payment	1726	1726	2266	1	1	8271	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaFjHFN4uXWwmPq4V1JWmTdebNmbREHHn3KAsUUg7v6QmEuWLUg
30310	payment	2134	2134	1874	1	1	2988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUtVdxCT4Yk3gGv42hokj51TUqe6PsyABGxT5B8ebJSYrUT8T
30311	payment	2134	2134	1874	1	1	2989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRJSGgY9zdL8C2rUxF5kVXweBSswxMM3k3ADjF5bB22HaixWY
30312	payment	1768	1768	1308	1	1	6	7297200000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpYmQQcDg45YZbPjBiwWmYrtg31WTYh9H3hQCvLwQkFxvQ8dnaDe
30313	payment	1768	1768	1062	1	1	7	3881700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZKf8Fmzs3HaTGQT9JqWHp78Gogs9Xzb8YhP8eh8pRTudL9ziPh
30314	payment	1768	1768	1182	1	1	8	2618700000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpZmYQaRDhuDtiY2W6HE1NRvYLvYxGi7x3oJ3hgea6bTLGX3scVh
30219	payment	2132	2132	1874	1	1	831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEzSqGBqbT4y5kFkcJz2ZAWSDwRfhbotHPSTgmHex3FyqjZEP
30220	payment	2134	2134	1874	1	1	2968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtX7wQd5mVnosXccETg5GvcvCYMqvpxwJQzRXUy7kkuxZSqH3
30226	payment	1397	1397	1678	1	1	12144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqC1PTWyK7djaJ8TdvgMkp4b6EfrB3jqANHLEvKsSFgc83f8C1
30227	payment	1397	1397	1678	1	1	12145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhkPswLFnfCtB75iYo9U5Pqh137Pvn1RKpwLuxoFUFxom2dLw
30228	payment	2134	2134	1874	1	1	2970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYadyRofLJwGccFs99cH8TU8fhNvACTEKYYB578Vx1GkfUGz8d
30229	payment	2132	2132	1874	1	1	832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbiYFcaHx57bvdVVLTz6N4GKbYExqpTcSNTW2X9so7By6Veox
30230	payment	2133	2133	1874	1	1	2559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5BpyRWEnsAnYoxJtkmHUVL41Srdxh7XBLnEcKjcnzTrf3nfW
30231	payment	2133	2133	1874	1	1	2560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoi6U61XpPCnove1QqrQ9FutcYdSkkzo4XgJPz3ysJt9UpZDBt
30232	payment	1397	1397	1678	1	1	12146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzS6CoJpPU9ex8694JPVdE5Fo3XXwJjkrQk9NgraddoVzMoUq
30233	payment	1397	1397	1678	1	1	12147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3waBKKKWR4gaPuJVRuh58NtX9fuzHpt9Rb2xieNGALp1E7ZUQ
30234	payment	1397	1397	1678	1	1	12148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4a53oQCR76sP4yiC6X26J5uXBy3CqZPFhGv4YNUBLiz8LxDeV
30235	payment	2132	2132	1874	1	1	833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9jau8FxhihAvguo57YkX3RLuyVPnocx846PccihyupusZvhH
30236	payment	2134	2134	1874	1	1	2971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY27SAjFNsLwEHcHHSKEermn2NaZBKisn6MjrDfwPM14nNjhgf
30237	payment	2134	2134	1874	1	1	2972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7n56pw51v1MXsvjEtJjzbXXaBBBMhi8BSa22WjjG853Zr8zy
30238	payment	2133	2133	1874	1	1	2561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy35Q16x1iQBBbFygh3QsgFnBMdxjCqnFALEZ2Fq44dpS7S1DH
30239	payment	2133	2133	1874	1	1	2562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTN2nk2QFYW9yBmcYt9ePzaRgeZi2NYZkC9UmVknMMY2Zxg2m
30240	payment	2133	2133	1874	1	1	2563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq8crdjFBRdkS5yCyUf8eoRoZ3TR4ZEWo3U9PGTVh3dfPNA8o
30241	payment	2134	2134	1874	1	1	2973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8rtLZBWejhzNH1BTKFjsWgXmyFzr4viMQkqNNurwb1impksi
30248	payment	1397	1397	1678	1	1	12151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyHcabaPKMPnpdijbGWJMSyabj7ewdPJM7PwCG3sxpA7AxFWd
30249	payment	2132	2132	1874	1	1	834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAt59KYSA7wd4DmiHHV8QMDeXUGiYYbx74FFSZynyAA6QECtf
30250	payment	2133	2133	1874	1	1	2566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqeDXCd3p1hb3FAo99YUU1zmuxgyJTYCGardtTbsQ8YbrJmzp
30251	payment	2157	2157	2157	1	1	22	5000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqUaBBGthx3MyPbwhP5PLhNd1HTZcQqTTAJT5mfkVcywKwyEQ
30252	payment	2134	2134	1874	1	1	2976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKH1PAc46QPh78cvWUJJHZ8TEACRrKUsSm9V1LaSVu3QNhHnoV
30253	payment	1397	1397	1678	1	1	12152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnrM8TYMVpXM6SYVfbjLgpmn5rUtnE5WwgEVpcji1SwBsnqq7P
30254	payment	1397	1397	1678	1	1	12153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY52JGjUb4XcxrnoWPF8DUfBAGVtSWaf6CLoGvQdPK8ZBSLZqj
30255	payment	2157	2157	2157	1	1	23	5000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoHMz29EFYFTRnL5eVm2sot9J918iHByM6RD7AjYuRAaSks4K
30256	payment	2134	2134	1874	1	1	2977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLpXbuFtEFd5ZkB3VFqydibFpUeAAzFXHjxfmWhy25Jp3Pi43
30257	payment	2134	2134	1874	1	1	2978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJAFHy4efmKJQaKVGLX9f1AvZUhs5mo61nty9uyzmgnKRiuvT
30347	payment	1397	1397	1678	1	1	12167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1CebxCghgm3vubE35wYfC5jXnJ4F5d6fn6dywhA4GCono62Q
30348	payment	2133	2133	1874	1	1	2587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzjDbv41iTwXTammQfFNG7BKsunzDejCUBhRJ25V6AKKdN8mJ
30349	payment	2134	2134	1874	1	1	2995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtmENXFFEp6MiHWNAiwgUnixVH2apN4stP5tD5CBKfadVZ1DfZ
30359	payment	1397	1397	1678	1	1	12171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKSu3cueTAYFfmMLb8SGeXCMjjbK7vZUuZXGrkj1hU5DWoumS
30360	payment	2134	2134	1874	1	1	2998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6157Q8TBc23BNMx4162KFXnPruTgdwe4JcugdtpAYkRCnssU
30361	payment	2133	2133	1874	1	1	2591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zcXj7tjcxBioSvv2tNkuDbqeWDyEVt9bnnuCHeFNAbrXCb5w
30362	payment	1397	1397	1678	1	1	12172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Bj4QpW7ZDu9vrBMxfhuW3g6wZhLbJhKktDtj4s5sH7DscjYh
30363	payment	1397	1397	1678	1	1	12173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vg5sjrz3cWEie3EUX2PADsdeTRoKimABLnCYVbayusBE2Pw9
30364	payment	2134	2134	1874	1	1	2999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMbNXKZibMSzgxhDAoXvP6ai8D9K1ZMU15uWARTTeM1Wu6CPZ
30365	payment	2133	2133	1874	1	1	2592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJamf1gQkZZNvjZSWaeoNNaAZBV2gMGtsBurdAMBH6EdjP2j3
30270	payment	2133	2133	1874	1	1	2571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfk8Y69TXoJZvFJ5n2Ur1a2qYjVyTyrVbGiU5EYkLqKoE32RZ
30271	payment	2157	2157	2157	1	1	25	40000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdGJP6ER3KyjT2JHxGy6LoZdRxLuNZ6J5QwMdR9xd8uHkXFQU
30272	payment	1726	1726	2263	1	1	8268	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZku7U4rncN79BvoUznVGjQptgL4rMwa9hbn1n73AWCAPDfF9AC
30273	payment	1726	1726	2264	1	1	8269	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZA8L33UP97Wfq94UWk2Ks5wkmPJjjU9mXeNANqGNYd7BxYrevN
30274	payment	1726	1726	2265	1	1	8270	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxEMYHHAjEWynGQkxoyhwvZ6gBoEWbiWLGLSb6NsK1cmC6m25g
30275	payment	2179	2179	2260	1	1	2	80000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmtYxrNJCCK2Ys6ZuscYeNkcciGrhJptAXjJ2pWt5P5MBBDyYW
30276	payment	2133	2133	1874	1	1	2572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMDXeiLQ3TJJw7axqHeWo6pPervbnT4snMoGx59WmtxPeRCSz
30277	payment	2133	2133	1874	1	1	2573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEnza1VBGkEbxMMWkvbX4zYNbq8E5qjQzZ1Tn7XoiJQiw2UFr
30278	payment	2132	2132	1874	1	1	836	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTQoFg3nfMoxi3zZ6EdoqDGmU2d2HcmjZ23iNWWrhEhL1nMYXb
30279	payment	2157	2157	2157	1	1	26	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWSwWPwkSe68j4e5pMkQe9KvhhEeGT9XLGZSc82W5PyG3SoQ3
30280	payment	2134	2134	1874	1	1	2981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZinJmcmTAcyqgYURNvQXLeJu8CuzgSszp3vtyx5u3oFjJ6GD9g
30281	payment	2134	2134	1874	1	1	2982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38efCxGELnTr1NckYN2UsVkAnWcoYR7k1SgEC4Xvz8xiytLVy
30356	payment	1397	1397	1678	1	1	12170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ47KZNzNwYt6P6RvFk7MyEiQKA7pHDedde6zNGRkRrGr4g2ct
30357	payment	2134	2134	1874	1	1	2997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtYhscCdd45waASNYEBJBPfzgMx2ATmAodcs8tvH9Yd6fQxAk
30358	payment	2133	2133	1874	1	1	2590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kCCoQbadTbiAHLvQdgxmV88KwAgPmp4MCsV4AHPaoDWohSU4
30389	payment	1397	1397	1678	1	1	12180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83WkBMGaDNBCDrGVb9sjgYgm3caa4neWCV7xtjyQNXAQuYjgQ
30390	payment	2134	2134	1874	1	1	3006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73iAKRYaawfn4U2tRjefYz1UT9G8Af4JDPkSeadQFf66PBFUv
30391	payment	2133	2133	1874	1	1	2600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg4x2MfuB74PyS7rcdqs9yukHcgRCGJbSurHX3byQjhBvpXrgh
30413	payment	1397	1397	1678	1	1	12188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkqtRTZ23yUpyvaH4oz6EShwNyphqPNvw3ehW664nqNsUMxVa
30414	payment	2133	2133	1874	1	1	2608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dtQC7GrjKrs3knn5xpi6uEmz84D1NYWw2Y9dtVVsgNo6vFby
30415	payment	2134	2134	1874	1	1	3012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwDGMRV3o8oCYHG7eR1TEwjk2eAJo5KrymEpRuZ7tBZqUbUFWQ
30425	payment	1397	1397	1678	1	1	12192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FMd6nD9w7K4ipKKQ5eKAaNiKbzeyXajrc722vx1Cjvk3TKiJ
30426	payment	2134	2134	1874	1	1	3016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRHaHBojMmaob6QE7qHs9JhjyfR2oztG4HiaQDKpRxx9JXP5K
30427	payment	2133	2133	1874	1	1	2611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZijpVWP8YbjZCXz6uGQwMnsqgdvmvJoF8TvBUb2WLxdAK5vmc
30437	payment	1397	1397	1678	1	1	12196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNGT8NBSEtug6fu7gkJCPLpqzfawXF2ahSd7uEFEEivqnHGSd
30438	payment	2134	2134	1874	1	1	3019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVP9sbmnwpPPuKFiyA9UkpTY4vi9Q75hK9Q8QsgDV3iq1E8h5
30439	payment	2132	2132	1874	1	1	849	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSSjf7k5Uxsb8GgKBc1wntcszKhykqEyrZuyxELwzA8uF1U4P
30440	payment	2133	2133	1874	1	1	2615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcLSqN1Rgzai8fv8S2feFxLZ4Vv4oXQVVpRLZW2AkufLjZDdH
30474	payment	1397	1397	1678	1	1	12206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQSmF9yM3Cs2kxQ743b4wz4AH3rZH1Dj92sWSb3Vi2UKiLuXY
30475	payment	1397	1397	1678	1	1	12207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgq7ivciD4tJzM6G8Uob8qxj2rrDZ5ppLCBbeAx9zB1rKyGuU
30476	payment	579	579	1469	1	1	1	90000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTnNbDHDbuGDNGtXDeVjy5XEYbMi575uSjMbghq7L1XkLRPPm
30477	payment	2134	2134	1874	1	1	3028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobS7A5VnHSap2zRsTY5FRs42kzpao24febZCDKTutcxbUfzwc
30478	payment	2134	2134	1874	1	1	3029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaWbx96BoRmng4xTrcS2x78fbCp4HjUT5NL5uvbrNTfrtPAoE
30479	payment	2132	2132	1874	1	1	852	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYG6XLCBz8JHYSjE6uHQ9GXva3wefMqpuvn9n9d19e2MZL5wbu
30480	payment	2133	2133	1874	1	1	2625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPDQ9DWZGW5LDDfgRyV6Wze42gUHPMjXYExAwrebA7BcHLTbY
30481	payment	2133	2133	1874	1	1	2626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5PnzvUXg7H5SbpbcEFAb2EA5UWCJsTeaVxmxSLqgxvbrzA5vN
30482	payment	1397	1397	1678	1	1	12208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HVJ3jhrKeEecbmt6U5tJK7NBFDdtzjmKpVmZHe6cHyGwkfpj
30483	payment	2133	2133	1874	1	1	2627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgz5YYj89Craw3pfAMTcuqJfH8KZufa5uvcY627hxZgxPHf86
30315	payment	1768	1768	942	1	1	9	2166600000000	100000000	\N	E4YhHDy2JEFUmDzaQkAdxsG8MZPGUHgtQ6ZSvK3P3iEyJm6nRm9p5	CkpaG9ZJboF3z7Kh9Aydw9XmMAyuTjHBu7suzFdxZ2hD6prXefSnU
30316	payment	1397	1397	1678	1	1	12162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdKT5u4fhSVKbPsg11yesuyEeBjmJJhLi3E22NziJhJiNySbD
30317	payment	1397	1397	1678	1	1	12163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcmzYzvNS68BHgbvWBFoCqgrTWiRxaQuPAHmiUfJJCNXxqqMY
30318	payment	2133	2133	1874	1	1	2582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoapGgQ6Kfdxj5gbcEzGS5SvQZeEjfkRL3iVgQYZQrdkC1nYuu
30319	payment	2133	2133	1874	1	1	2583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4pBR7USqZLqByJPBKaTTsSxepCYf9f6b6jGz1yEcSuu44zCJ
30320	payment	2134	2134	1874	1	1	2990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq8PN786Ek7itTtthonXRwFSKrut1NkmHg1M1nLGTKehP6x4E
30321	payment	2134	2134	1874	1	1	2991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLoFihHrcFRAxGTNxK4wgb3cfB77eMUQcqomseargH8197Mgq2
30322	payment	2132	2132	1874	1	1	839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjE1djNo4Wq1QygatCfTESm1BBdp32GrfaWjvXC8KZYi1458m
30323	payment	1726	1726	2262	1	1	8272	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzoEK6RJdNS8PSDTFetCwLJMZosvC35V5bQ6noDrKiSsFZAKgE
30324	payment	1762	1762	1307	1	1	4	9067760000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpYgPj4qrzRBJRXoLVtZswJh8xwNHQU7Fiw84GNyfh8b2LmhPGSZ
30325	payment	58	58	149	1	1	7	364670000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmfkVNG9YdMJ5K83khCHbofJJe4GTZLGyo8wrCCeYkNw8AFsoW
30326	payment	58	58	1281	1	1	8	9359710000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYot9LgBeYVJkQGHYtA3h3MXnPAJNq2hom4QjAFghFnwZRwwwnp
30327	payment	1397	1397	1678	1	1	12164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVeTARQSgYc1JjFJRXsfzMv6D2Ldx2p9vz2PusULYrwEwvKEn
30328	payment	1397	1397	1678	1	1	12165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSVkNqBEmp9FotqDGokKmffqYciLaVyQ7sr965Z2YDMCuWHpC
30329	payment	58	58	1035	1	1	9	4978130000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rqeXhR7bW6Q7a5uof4nQBN2YuhUC55FH6vHWRMRPj9cqZyN4
30330	payment	58	58	1155	1	1	10	3358850000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMGYn4DcQzcVFjjzh79v3VBnwoLNTNSMPovUEw2aThMqga1vD
30331	payment	58	58	915	1	1	11	2777990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoa5BN3wQui6nn9vTQnvFcC3wkB4jMieWuRTh4QMA45N4Nbbcq
30332	payment	2134	2134	1874	1	1	2992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZy3VUQoLAhLw2WUXvdM44D2D96YY9MZG5CLFjhj1xAiNHkZAJ
30333	payment	2133	2133	1874	1	1	2584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6g2HijKnejTNJ7eafzN7Yz9YDRmksXjEuGuSN7nQpstm3oU2K
30334	payment	2133	2133	1874	1	1	2585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjH865M1Ea5c3gf9zHhmtHdvxQtJpbjXBFcyxG3JQ4THMhtTfc
30335	payment	2134	2134	1874	1	1	2993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUnAXKVmBrdPVFmXbntTG26o59avSubjjoqEaVj7FAwhauBGw
30336	payment	1762	1762	1061	1	1	5	4822850000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZrUcpKz9n5N2fhSFtVXMWi4HamVbeCvzp7NFumbiCx1WvgD5AB
30337	payment	1762	1762	1181	1	1	6	3254070000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpZDBozEGrLJTwkhbRWZnVpw5DP3SC1TG3cvXBRDYbdCPFD655LR
30338	payment	1762	1762	941	1	1	7	2691750000000	100000000	\N	E4Yo3wYixtPNDCHzGCt2fngxkhWmByaKotsxzVVraHCj9AGKMeJQp	CkpaCfao2MeRk2PpMYBoPeMq7maSNFSDWfMgQywMZbriwRsstQhnQ
30339	payment	1397	1397	1678	1	1	12166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7ai65RXoi1Meczg2CvJ9C5ym4aWC7QgPgGz18iMu6cZjF8yx
30340	payment	149	149	1283	1	1	5	7817030000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bWccTeGz5mZLR1t6b8Fy6opJDBJbFmckgagnnZ1XjL4DisHL
30341	payment	149	149	1037	1	1	6	4157630000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDGVV3dmr9PXnD72vYS6eEkRcBLgiU7m5m2tGz3cKWSyPtYgs
30342	payment	149	149	1157	1	1	7	2805240000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbN9hFuoCXkGnF96mYdMqZ422d5hiqKqtYVH2qJDe3QBJduNpd
30343	payment	149	149	917	1	1	8	2320120000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqSUiv3dYkKHGcxrG2cVsFKGPPdH5d9QXZ9exqzxVPtEyrPC8
30344	payment	2134	2134	1874	1	1	2994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSYNvVP1j2nXvviPsTVs9bhMs7RfHfnSavJjwsy281iYgEmfKf
30345	payment	2132	2132	1874	1	1	840	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpggFfzXCcMce14dja1zANQhFgkETgRvBfciAbVS21KE9KMLq2
30346	payment	2133	2133	1874	1	1	2586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSYFf2g9fXpY5GCxx9AneyUWouV4jXUUsRxzs9VbLRo2WABjw
30352	payment	1397	1397	1678	1	1	12169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SNPh1JMk59idijzWZjMgBpmfLDumtD15yamQ2tCAAmzEWJNP
30353	payment	2133	2133	1874	1	1	2589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2LUWZw3L412omGfhiVx1Ast81L1KoyRiD4ydyEQR9cZ6hf8m
30354	payment	2132	2132	1874	1	1	841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1AFF3VqjoWm7od8HFZTWFkujKouCKoWb8VHdwkV55uMSfZYm
30355	payment	2134	2134	1874	1	1	2996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gRjTErcwzGDJ3bwZuzu6Ahw3jV4P3V3haw7fyqNBHHJaFPkU
30379	payment	1397	1397	1678	1	1	12177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzp4AqChSEhFSeyAzxVsMhQ3qPFVbjGCavjErvWkCwf84SZcX
30380	payment	2134	2134	1874	1	1	3003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe2PWYKfYRFmaje9DWSs9huUKGB3RF8wV7UJMyHvDsefUYTNTm
30366	payment	2133	2133	1874	1	1	2593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zP4ucxaAD8uc45C1reT71dcmBwGMBkkGb7peCjckMFsnGfiT
30367	payment	2132	2132	1874	1	1	842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEfG8Ndxe6vvibofzMhxGSoSTgC5qWv5YnqkUxn6R7FswYtWx
30368	payment	1397	1397	1678	1	1	12174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBkSM3GpUukUxpNxhcoqtobz5ua7uuBFHGBiXVGBbty6YsgX3
30369	payment	2133	2133	1874	1	1	2594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqe7kTikKQtB5AVaNtV43c2aNniobeaAqSfVwxMYw8sAtJh5v
30370	payment	2134	2134	1874	1	1	3000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vPimepuaj9iDpM7ugrtpuqAJ7HX5zGzZikn9ymKQR6SaFiZY
30378	payment	1651	1651	1301	1	1	11	8906715182489	10000000	\N	E4YrxmECj9jBFuK3whAsuDD1zE6oyBZqz34VtzTDXK8r9T9XK6L7z	CkpZtyDGZxVo4BtfiZ1XuGMhQ3LYcDRuuwSM1UTRgFhiJ5MPPiUzt
30385	payment	1397	1397	1678	1	1	12179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9WGKr8gjK8ksYWaEQP1xrzVm5jqWUpYQKBXAGKHfbyHwyHyw
30386	payment	2134	2134	1874	1	1	3005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXVVPj7DvDS4cqjXDuKLsJHUVSTJ1hxcertf9rMjZACC4gC6o
30387	payment	2133	2133	1874	1	1	2599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PxczwSTMwoDneJrtE6tAHFgFGJgEmTT4iH7dJ4273qFcqPDx
30388	payment	2132	2132	1874	1	1	844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54WpQcfqZZ3MtKxdwWXiFoFe2NG3XzLu6taXUGNrHwt1vYhdX
30407	payment	1397	1397	1678	1	1	12186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvyGxWhLSC8Q4Vw9vx6WT8SELn72RHCuPLESEeUWbdtnRzGqw
30408	payment	2133	2133	1874	1	1	2606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Z2jwgv3kiC2EWiMTHDcZyRkMb8SYDf3BsWgzRU5NqR4epFib
30409	payment	2132	2132	1874	1	1	846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2zZAkZ4wuHeAidcVs89xUyzporWEwtT7YBQ786QENsNw12XWt
30416	payment	1397	1397	1678	1	1	12189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhQv3Q7Yanuw8tx5dZGCjVZYMcB4iPyHtvN7WmgMyK7nk96N9
30417	payment	1397	1397	1678	1	1	12190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQzBwv7hCfxGYSmJujHpnoYu6PC7NAFiAfM4Xqf9RMnKd9vhQ
30418	payment	1397	1397	1678	1	1	12191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCnk4u6hJfdzoNcK6weYUuEC3jQrU6oN2pFfsdkDb574d1Ci4
30419	payment	2133	2133	1874	1	1	2609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJk8u73BroQUALQpB7UF1AgrCdKi785KKqLaviH6QkXxNtm2ht
30420	payment	2133	2133	1874	1	1	2610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5n3BZMrieVaSBV7yhWASCv7bqpAX9fQioHrVibNp3CNWcZY2h
30421	payment	2132	2132	1874	1	1	847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP58GzH4ihLpiE7aY1cjVZiL2XLLd2ZUco5EeVHJNjQK4FpRyG
30422	payment	2134	2134	1874	1	1	3013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vjP99Tbkssarqqj7yzfbsZ7Vy4H4Ez8T8R8JEapoCdFZ4QGG
30423	payment	2134	2134	1874	1	1	3014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhAvGpQVPoQLe7Jg7ZBrBZJyqBmT3Eu9QXx3q2N14EHnCy46d
30424	payment	2134	2134	1874	1	1	3015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZnt44x9Zar3vECvPh2NykRE7zteWZSNgpV9MDSjv6kV9McPk
30431	payment	1397	1397	1678	1	1	12194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJru329s7M1mBgZZKh3tuy47nmcjNkJQZ3Z8Q19p5Q5Mtidtv5
30432	payment	2134	2134	1874	1	1	3017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddXHHtxL8vMxzhxfDm1LAVUQCoL5TYPtgbe7AnMyYAHmMRxKv
30433	payment	2133	2133	1874	1	1	2613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oyXcSdxDxPmg9atEPsXebKyJbei12zWnCmSDdD5Ws83wdW4c
30441	payment	1397	1397	1678	1	1	12197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqehzK6MosLuGs9YyFZTiPC9B5id6XiDwMgGVmaRLH93Q1DuxY
30442	payment	2133	2133	1874	1	1	2616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiN96HsQRif7i4cUbrNsRSiYpNS9SJ1aCsxEPQsVURVfWiXJs
30443	payment	2134	2134	1874	1	1	3020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6gxjUGeP9TjDrH1vdU6SehLcMfjuyPS24Ha1G9B1KUXPruy5
30444	payment	1397	1397	1678	1	1	12198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP8H9wkYRofKJxFx2qU8ww84PmKxXM5FX1fugo2okfzsoFwxP
30445	payment	2134	2134	1874	1	1	3021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFZCgxNhMDRXXmkUTk7eTMPnBX78LZSiJM9kFhHReRypwwyBz
30455	payment	1656	1656	1097	1	1	5	4412000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxUt3f4CceGUEyqK2uYJRFKkBQUkQhUKZAtnwi2oAKAvNJL1S
30456	payment	1656	1656	1217	1	1	6	2977000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8EFE7eY3js72dY9LZgaqoKhU2Y8DAKhFScJutif1C1MgyA7d
30457	payment	1656	1656	977	1	1	7	2462000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGtRpzsAE3sXU1z8dsZiJatw7yjP1sTCaZXYQiCsm8TTD1x5f
30523	payment	1397	1397	1678	1	1	12221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4R9yMbiUSGvoDTwUGju4KjZEFEkv5JUNPre5mLidA71hryFdE
30524	payment	2134	2134	1874	1	1	3040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5MiocfpAVFFAgLDSv39MwTZpHmQsvAVBGjLHFqoTYeCY4x1n
30525	payment	2133	2133	1874	1	1	2640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmi8k8zJSTpSSrEHK2CUeJrUphg7GrQredW6gTYJA19Jz1Evvz
30529	payment	1397	1397	1678	1	1	12223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8m6BHhaY7rmXC1u2sdXLLp67SD7SzzqEiXAtE7yu8ue4peAQ
30530	payment	2133	2133	1874	1	1	2642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCpgXZsEKAvPEpbzZqXcsUbPdFmyGqrKJUtisg7c1mKmuf4iP
30381	payment	2133	2133	1874	1	1	2597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDvxz6y3NKvVvDuochDK7Ltb8yWTAuRWDp8vf8gKGy9wxfmVf
30382	payment	1397	1397	1678	1	1	12178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNsyLEAMzeNGVjENre2VvycfRUMRpyHcUNgW5vD42usJuHNdb
30383	payment	2134	2134	1874	1	1	3004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHnNJTdxbwaLbum1yRMWDCxoDGJs3LuKLBHdbWVzoUFH3mkEh
30384	payment	2133	2133	1874	1	1	2598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtfYKRv5fhZ3FqxaYEP6MuxFVqC7qCrSkDe4BcWf3KoJz9sXN
30392	payment	1397	1397	1678	1	1	12181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sKSb3qmGv4jmrTHb8eenXPi3zHfSiQW3UYtBhRgHt5xZSgvM
30393	payment	2133	2133	1874	1	1	2601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmteqX247tZ88jgETHZEuKwenGKyfD5kt7UiUGfMRBPVZgceX
30394	payment	1397	1397	1678	1	1	12182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwjSWd3SwcTp3YBETHAHkvWN2bw4voWMVS3PvEtwjRV6ifbFV
30395	payment	1397	1397	1678	1	1	12183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFCVFnAa75NjTTGzFx8xYvf1CZupxentCj4syezM37M4BWpzR
30396	payment	1397	1397	1678	1	1	12184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUj7cQoq1gFUQyFF5JMpkVZi8BC7MLwXmbcopzbowzGueCH6F
30397	payment	1397	1397	1678	1	1	12185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhdoRRHkZJPjLJvVp9affz6Q42bpbyh3WCK8hn8SnJomuGhaT
30398	payment	2133	2133	1874	1	1	2602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8GMdbAssBRfm57FwXxsWmtmT4GPy8ukRhTiD1dmqFmRDpyES
30399	payment	2133	2133	1874	1	1	2603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNymJG6iJ5t3HsmXkwXRZ3nd9pnTCm3SDdK322SiXUzAarr5x
30400	payment	2133	2133	1874	1	1	2604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMb6AExDvS3ARqFxvM1zR4hkxXwbTnoB2DVsanMQjC1MkYSJH
30401	payment	2132	2132	1874	1	1	845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZba8RzdzRWHuRXE359MayLfeHr2RmQ3kbfuWyngVfvtzVxebbc
30402	payment	2133	2133	1874	1	1	2605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UQJnWf2m4L4WmBENWu8HxK34GnV8LZtuBbvwUKsdhwkDzebR
30403	payment	2134	2134	1874	1	1	3007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKc2aNYR1YFZ3Ln3RVCob17VtmzqMEkvMz9EnzHWArN4uuegx
30404	payment	2134	2134	1874	1	1	3008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qTsPavHZoeAAwzc7cMgdQkgggW598SXsXeDrFycg8YH1ZxSv
30405	payment	2134	2134	1874	1	1	3009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHSN3vQQMPJWoZUHuM6ywcFTQFrsUV4RGbH24KNwAW8RN2G2U
30406	payment	2134	2134	1874	1	1	3010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KZ2EAMmEJsakR6h4XmYsy4o7Yc6nXQdmzWz43CdYuccUEhje
30410	payment	1397	1397	1678	1	1	12187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfud5ahQvkZy1xJkxQUXUF1XH2aEP1vnbL3idcbN1WM4anwgg1
30411	payment	2134	2134	1874	1	1	3011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypyvmgMRZUJQxMq4LD4u4Haf2qYn1LnDPnQsJsJkgSABSBmof
30412	payment	2133	2133	1874	1	1	2607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqtohuvUSLRA6x2Fn1onb8ofSLVgRi4HSajrQuTAmprqAh1HL
30428	payment	1397	1397	1678	1	1	12193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoxGn57LV6HnP2xqFbPz63JPmzy3qJwTEe7QPMbp9Zo6A392k
30429	payment	2132	2132	1874	1	1	848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhepHAHiLx8CL8kGw5rrPQeBeiBsq9RAotup7XAmFD78Q5njn
30430	payment	2133	2133	1874	1	1	2612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNHXtt5X5XvzrJH4vxvJygYhkFGDCKFdb2fYRkgYn9n9mY46m
30434	payment	1397	1397	1678	1	1	12195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa351VCtqTzxyMbhCmrC9GJ8xuDZWsMjPUtCLeyaxJELumwqPzx
30435	payment	2133	2133	1874	1	1	2614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oMVrZwatDAGYczxWkFXcZeZVL6eto9jN6TJBDLziQ37YcnCx
30436	payment	2134	2134	1874	1	1	3018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92menNf9SyQdCAayvA2fybpeqbJKFyev9dvG5iwsM5VgcQtNq
30447	payment	1656	1656	1343	1	1	4	8295000000000	120000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPiHkx7rcjUnyDqBYfdevvTpo8XDW2J21TWJfj5AcxE8DQFYr
30448	payment	1397	1397	1678	1	1	12199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UuVz52CSk1hMBMGsutZWGQ4x3w2cwa7aYUHR2HsTDP4px5ng
30449	payment	1397	1397	1678	1	1	12200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9njaoreBNL3mX9hTWrcL1qqv1y3eUjHP1gedkQkJTcz56CaFU
30450	payment	2134	2134	1874	1	1	3022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1QnJgqnG5ne77ULKScCsv1THZWt9bBbJHG7tpwnyRATMonBB
30451	payment	2134	2134	1874	1	1	3023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwpKmBFpgQMsXn6otAfWHBN1eFSKsmnPEw9vFFfEj3qd9vxnA
30452	payment	2132	2132	1874	1	1	850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkpv9AL1hZaM13unbFqTVKYtuKKkDBAuvJX5n6UWiMUbLMLve
30453	payment	2133	2133	1874	1	1	2618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNP8eCQYmWKXCdU1SJsEvJZSXcvnc5Z9BsUnNTRFN4N65SB72
30454	payment	2133	2133	1874	1	1	2619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabyvejguRWtJHifFLiX8iqBGQ4f7dt5443aCgbuodFNgyRUPf
30461	payment	2134	2134	1874	1	1	3024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbbSKVK4E972UF9kGLLAgYEErRPMU47vxiPyreC9Esrojifxn
30462	payment	2133	2133	1874	1	1	2621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrzcMwZPvEvr96g5vvg47cQUtfrgKbDMbFXnN2iAWxPCxeUsW
30463	payment	1397	1397	1678	1	1	12202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDeizYv1LGBfbzf6ikWQY2YJr8CCKhyYqKJckxGxGgPgGeuGH
30464	payment	1397	1397	1678	1	1	12203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb61jaW1AgseioZBkQUuVfSZ2uxumzNJfZ4k5MZcN4KivHPAgx
30465	payment	1397	1397	1678	1	1	12204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmRu5UudTUda7YhpC9zNfkpZXYoEoUj3Cmr56NbtQvH3RnU87
30466	payment	2132	2132	1874	1	1	851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgXNsNu4g3ePxewJ1qfLgjxPyX8kCT8HiVnruAkZJbsaW6mxM
30467	payment	2134	2134	1874	1	1	3025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzwjLcVZNGSx4oH5buGD1nGnA9EdibCo9utYJy8fkDSbnbyexg
30468	payment	2134	2134	1874	1	1	3026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvaNpSgezktKXfpGmL8Vxtu9SCZ9rntHuZ7CYxTTuSUmKRqoB
30469	payment	2133	2133	1874	1	1	2622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHitTCzLzeeaJNpXhCjyhxCL3pguHNzrMz6nSnbtBxjoUEZe9v
30470	payment	2133	2133	1874	1	1	2623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFs8YWp9eUaGu5sMttFPH5ggtnPdaBhN8D1refEmNQXHyfEbw
30471	payment	1397	1397	1678	1	1	12205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXFV4PfUmL8M6vkLuhVPR6vQCajwpMmiT11i8WzADj54VFsLfr
30472	payment	2133	2133	1874	1	1	2624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBxRv1xSPPfZAP7JrNRPrm8bdUgCmg7mzP7hn9yxVq1RRta8p
30473	payment	2134	2134	1874	1	1	3027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqwVztYHrh4LfhDU55xZH6c7GdHRew15jpdR814JXZsWXtP1u
30496	payment	1397	1397	1678	1	1	12213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxXEUZwS7vFjAwYaMReu9beyvQv7MYGh3UPpK5248dMQj7LMx
30497	payment	1397	1397	1678	1	1	12214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1YP9ufyUhWxFYDakyDJRC2uRtdypV5BN2rrXA29HdKL88xKA
30498	payment	1397	1397	1678	1	1	12215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvK8B3Y5hyuHe6kUyregyXD7X1rFGkRCgHvsGETpiwaGMzL6Mq
30499	payment	2134	2134	1874	1	1	3033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjiqj46TJurew4tPVH3oFZXS6tng6CDynsiytTLav9rrUtoa7M
30500	payment	2134	2134	1874	1	1	3034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyLwTXo4gemmnG7wFd3znyNCT9vqBwyQKsBjeLpKbTs936mvo
30501	payment	2132	2132	1874	1	1	854	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy52k62xVm1sYSepw3GASva2R4DNoC2aioybx1ptKeQ9n4Dytc
30502	payment	2134	2134	1874	1	1	3035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1t5Y6RX64upktRj9tNB72U214QKUgcarzw6hipi198QpYJWut
30503	payment	2133	2133	1874	1	1	2632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJetUkVHGeLMr993ef4pyKbmi85zFDeyyopAKFPMsxYp7iGaEu
30504	payment	2133	2133	1874	1	1	2633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqq1EYYF38fzvUet43UXkkee7HsUxmKRQvD9Vk8jxkAW7NNdq
30505	payment	2133	2133	1874	1	1	2634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPsh4SSnBvaejcw9RP5kRmyUJpUHFHR6NNKwapCvZBooeqteT
30506	payment	1397	1397	1678	1	1	12216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQftfS64R9ywyXxUn8rZPNo5Kq3iLAVX2PqXgE7GBjqoGU69A
30507	payment	1397	1397	1678	1	1	12217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1sWWihH6W1gb9BCen8kmavs4Y9QHnwhgmUqUrfmkRRqjJ24zV
30508	payment	1397	1397	1678	1	1	12218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ADHRve6Kb29bfdRSy4a3rJ7UNDdNmUqNuM64R9SdERRfD6iW
30509	delegation	2258	2258	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXQKzkk9huEFQowGfL1hHn8KMf7KngHajznUSx3QPKZ875qnj
30510	payment	2133	2133	1874	1	1	2635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAi2d6xGRMzpqzK71BJELEgkwpvSMDcr8768zhGDBJFisLUyR
30511	payment	2133	2133	1874	1	1	2636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1NhmFddDVn8CFXvV7KwK564uEBupuNQ6RDBnELR3ZiMRi6Kp
30512	payment	2134	2134	1874	1	1	3036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6UY2mKjMWQCoQWitdgttZkNVG5GdVBLPcZqTtehrVRKk9xdD
30513	payment	2133	2133	1874	1	1	2637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPkGyJoymG9N3LW6e1jFvqen9SGa8wHsFfLYwqXCmhjR7YgK8
30514	payment	2132	2132	1874	1	1	855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4RhhZE5ixTSxgjEtZDp733xcdyHpqA2yc9toQjSgfkYqfsAs
30515	payment	2134	2134	1874	1	1	3037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcYR9nr9mvPEMon6m7Fb4UVcbTMABJh94TNvaPB3w2Kp7hrAy
30526	payment	1397	1397	1678	1	1	12222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6skWK2ZdbbXek4gqMt1kPRBZisbeEsMjqra5R5JoU2aUMf14x
30527	payment	2133	2133	1874	1	1	2641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYun5VXjUqbp2dQGopHkF68iWXi83azNodTCxmerdt3MGKGSers
30528	payment	2134	2134	1874	1	1	3041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6riv2MDLAwhkkaUv4B7ADmhzXCUzXP1WEH43CvigyWo8VYrdy
30484	payment	1397	1397	1678	1	1	12209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDDYyNbAZ1ePmLfeZpzihddDKpySsoaXrJBHR4iXoefswoVrb5
30485	payment	2133	2133	1874	1	1	2628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMuHsuA6oppL4Mh4mbs4ejKL3DbMSKa2pKKX7hZnVHojwTMGn
30486	payment	2132	2132	1874	1	1	853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9yzuQZZeysCujtff6vMkPktEpmv8PvwbT9jAvbp4A9Pabzf7
30487	payment	2134	2134	1874	1	1	3030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucwPyBX58nLVcEMfVerCFvP7VkFQGbfF89svmwhnzaP9DsCed
30494	payment	1397	1397	1678	1	1	12212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQ9yFi3zwbBAqgi2pYhcSUQGyii6W8QXmYLTQMRnsCu4cs7WV
30495	payment	2133	2133	1874	1	1	2631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmBZeHpNn9ucUkUAVfzyVw3Zy4zkJiybHVndksSRhY99pUo65
30516	payment	1397	1397	1678	1	1	12219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75WLB1xgB3hSTjdMrKMGsHCU2MLWwCP4UF245VZ2C7hxuYmRr
30517	payment	1397	1397	1678	1	1	12220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dqvjE4CRLK5NL4YKY8btYwmb4oruu5SjUMEWCGHxYMvMsH7o
30518	payment	2134	2134	1874	1	1	3038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjBmnr7ojgPrHcz3mCjnr2yaLALoqJBRA17drW4tYCSVE7red
30519	payment	2133	2133	1874	1	1	2638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHcp2M1QVBq8DstegghWHQ9ujGAFTsZbMqAjs6KhgWeopjtan
30520	payment	2133	2133	1874	1	1	2639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYov44JrDs9mU8BYSiAuPgaBzkvStf9v7pGD8e6QBojybnKkTg7
30521	payment	2132	2132	1874	1	1	856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnare6tkNvrNTbrYLJ5gAYJgzuqJmv9Ruj9tsyoHpAuTpxB3e
30522	payment	2134	2134	1874	1	1	3039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwxbbQHmHJQayRBCKBNrTSQsBgebzygGcmJV1eyvUzxj81nki
30490	payment	2133	2133	1874	1	1	2629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYG5tc3ukTH9zjtJ8RbL5jJCj4jKK8BMUABb9cFVjtNG7p8uwt
30491	payment	1397	1397	1678	1	1	12211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoApEWr9vCdvCH9wuWDLfamqjLTj31CZ8TRGWnCG2jHE7E5uj
30492	payment	2134	2134	1874	1	1	3032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTrdEEvUYN7aEnxEE4YsTybYeJUKNycMqPeLyVohogYpsdxUV
30493	payment	2133	2133	1874	1	1	2630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwbgvFp5Yh5ohq42rM6rNWa8BueTgHvcSGHtCw6JTDMspZKPEU
30543	payment	1688	1688	780	1	1	42	642526519000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYXH26H6oG5dRoTQXtXaATFyBp9bC7dpyDfjuoFNhYDpWKxwvBL
30544	payment	1688	1688	782	1	1	43	5140108190000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZndQx23rg4oJiSQmy8XYutDdzbXwoVSAqQajqkcdipGZ8H9ihw
30545	payment	1397	1397	1678	1	1	12226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXoLhjmQWD8nqmwCtkvp4ixxfYySB2kCV8gzUaLfNmwHseNyw
30546	payment	1688	1688	785	1	1	44	467282970000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa1KSjog8GqaDv3BzenFXf86smtwPcZTQLq6JKAs4rXzjKd6gzV
30547	payment	2134	2134	1874	1	1	3045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZf3uK6EvmMBawSUYZcPRpvx3jXzan4cSmfbyNZBydGrpzArV
30548	payment	2133	2133	1874	1	1	2645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4LfVXheq3opxRhsAh8hx7gHwV96SMr8pc1PVkuZJgz3f5gRX
30549	payment	2132	2132	1874	1	1	858	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9d7W9k9Ee6uujhsf2UvtKmDwkKxWpjpnzM7STwB1tCRBTKMu
30531	payment	2132	2132	1874	1	1	857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVo75DPq4Dieodae3nF5mSKjZtifsFP3fjD8bUoLjF4yCXHQ4
30532	payment	2134	2134	1874	1	1	3042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTD4okdCdsBHMTJDBp3CuM6A6T3vA5wUNfW5pJgQkYFFLQ6zB
30533	payment	1397	1397	1678	1	1	12224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQEpZ9KtrVRRH6aAYQsn9dDSJ2GBFxJZ5JXd7qt4xdLGwR7yf
30534	payment	1397	1397	1678	1	1	12225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjiT38WUqcT3Z4GxoLuLdf42B2Q2VDB8A6ubpdCBLGMobo9jF
30535	payment	1688	1688	31	1	1	38	2772739792000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZGyAh8VRyomoHJgniJwMRN3YsiWahXLDn2nzstGCT28ufkizy8
30536	payment	1688	1688	32	1	1	39	154821582000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZKVy1w4uoNPXeicq248QSgVmNdh6WgjCCdgsN4vuCvT319o3y2
30537	payment	1688	1688	40	1	1	40	138783659000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZmQFqVM1xJEzRQ6MPYmP5qXnR4anRZUMAgWCsouTw36ukgDGb5
30538	payment	1688	1688	779	1	1	41	58411553000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZX3ZqaTf6Emz3Zkrrz6nftYkogMPabUwVWAQJNEFoyDvkXxpve
30539	payment	2134	2134	1874	1	1	3043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSNjzCpBuEEjm8pFPo11v3fyjkKHSjgZR6xZ5vQQ2Nig3M7BU
30540	payment	2133	2133	1874	1	1	2643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9K6JGzCLHGDNaV8FVRhtPqmLpheSe8f9JQfnTwsapwYbJ3mvW
30541	payment	2133	2133	1874	1	1	2644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiqSMRsKTf12hsHVVfP5bcDV51BvTNsu2A7RpFHXJNJEzLewc
30542	payment	2134	2134	1874	1	1	3044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZes2vM514hDFuUuexjCgPuRu7twNh6TG61Hyxu7pB7LSquCABX
30550	payment	1688	1688	786	1	1	45	5140108190000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZghoZqdawojk9y7JxM2H2bZo3MQN49jJFiriz1W5mh35vK3bUv
30551	payment	1688	1688	791	1	1	46	116823105000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYjgh83r22Proy7d8RV9RCv7xcEiNCbW6f2c3t7XfCgTA9A2bZQ
30552	payment	1688	1688	792	1	1	47	1285053038000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYWxBTsapwM52ubZmWNfQYvc8xRAUe5MaU6TxQtSQU3BUTatwV9
30553	payment	1397	1397	1678	1	1	12227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DLB1hxs6tWeHG5dZapeskCdx7qTKiB7EpEEECRCT3kUtqb8q
30554	payment	2133	2133	1874	1	1	2646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkz7cMJ1Rfoc7wPscjCeEt4y9e1y8Py3KumQ8sFPHhriGLVQr1
30555	payment	2134	2134	1874	1	1	3046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUbuDPQyCahqeuzHxiqD5eZbJTnxJkjp3FgYp2JsuZaicxM67
30556	payment	1688	1688	799	1	1	48	29203159000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYwMsR9Qa5aSdAYR7k2n3cEA1SPwicwLxstA3Ze9BZgpvmofTzN
30557	payment	1688	1688	800	1	1	49	321234475000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZqtKTKT4gX5bJCuDkB7RP6NZvdWSnR9QTeSefc5UpUC61Y8s46
30558	payment	1397	1397	1678	1	1	12228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aM2azqmtCgnN9fgp6SGGLABuk3DtCV4p4jE73XghdB3Swhsx
30559	payment	2134	2134	1874	1	1	3047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGwGQ7LKaSiyUq6nHzgXZUACLqyiMKzEfAt49KKQbDPmjhajY
30560	payment	2133	2133	1874	1	1	2647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGNbJApTQVqngeSkticA4rjxHa7Pn7LGU65Z9fYFEdFe3HC6u
30561	payment	1688	1688	801	1	1	50	29208562000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYxGB1HS9ozNTRrTywSw4T8dkrDrkSVFqroJNXUEvdjLzUegw6k
30562	payment	1688	1688	802	1	1	51	321293907000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYpETB7wPVhfSjRequoTqJ3E8Rpzg5Y5NysqzBHLWSGu6jC6X38
30563	payment	1397	1397	1678	1	1	12229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2aAhDsUVdQAK9fTE9bmp4yLz9KCFJgCAihBBsKiE2jw9GEWrf
30564	payment	1688	1688	811	1	1	52	226049323000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaGVRpmUbDPNo4AsGeV79gJ8T4D6qNXUNn1MpTfgxhyUPdSU3zj
30565	payment	2133	2133	1874	1	1	2648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSCYGHDq65aZt5gmQnNYMAdPKBLZacmURKfuo68iYhDkqKMmx
30566	payment	2132	2132	1874	1	1	859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ97P6WAS2v49EGyD6GovUoCpom77pMvwvBDmwfzvdBUXBFrCD
30567	payment	2134	2134	1874	1	1	3048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7jCk118fNnP1ZK8mPbqv8vD2Bt6RZ61v2oh9yP6jGwRkctXL
30568	payment	1688	1688	812	1	1	53	2486540387000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYXTwvVBfMgyU8eVQ78FqwDBJ3PDpcqMkrVjhCTXmnSoYJ4jg3j
30569	payment	1397	1397	1678	1	1	12230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEeCrk1YZp1NtWbJL5RAySdL1xTWUi9dAoXrtYUp2a8tKHkZ9d
30570	payment	1688	1688	823	1	1	54	3627304092000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaAJfHYHamtF8VBhRaNWnAWQLiGZqpBLPTwpsrdXiizSwbnVrk8
30571	payment	1688	1688	824	1	1	55	39900310192000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZXfETzBtTLHcMopQqB14d3YXNHgLF7ieHVind2kDHJsmrQEJr8
30572	payment	2134	2134	1874	1	1	3049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ58GSUqJZCp3dB6BvLsqYWF6sSV7ACRW2K68my9FztfdCgr3X5
30573	payment	2133	2133	1874	1	1	2649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBKvoFNs8h6NQDp6XEKvLiWLM1qfwD11tXuree2v4wupFW3R2
30574	payment	1698	1698	556	1	1	7	323571171738	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZPCBr7gBeiBXSWmZtfaVWRy3XoJmuQiaYenaVFhwdzbq2V6Tdp
30575	payment	1698	1698	930	1	1	8	2461875537096	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZijk95CiRPzvmomjC4t6V2YnRZ3Eg5rRDoo5PiRrDtzUGaS5Uv
30576	payment	1698	1698	1050	1	1	9	4411659869136	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZSbJaM7FVEVF7YCj389n89AH4FXqQSTS72xg6rd9X7poiiZUcE
30577	payment	1698	1698	1170	1	1	10	2976634822239	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	CkpZMoM6BWC5rpikmXaUTZMhxWbLSQWR1LM8EgZfyfLQzLui3UbTC
30578	payment	1698	1698	1296	1	1	11	8294657599764	10000000	\N	E4Z2Y3UreAkzbtoEnaSntwEgaxKirfJji9LZCre2YJmdH6XsXGpt4	Ckpa6pH8mCBzN7cTC7JzuTh5cWfF1AMMFWDjXJ9RXGhUB7wPbG1ws
30579	payment	1397	1397	1678	1	1	12231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMiCCSvifzTJDaL2pgAsD4eMnzYehrcBMeaZjMs6UYRGExxD5
30580	payment	2133	2133	1874	1	1	2650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttTHMNAseEBaCEGu6yFk55J3qCqAUZd8BjufP3grqHfZV2HSX
30581	payment	2134	2134	1874	1	1	3050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLhM4ES6svq2HWns6FrGHEQUx86KwLshoNiridL5SMhFen6qH
30606	payment	2133	2133	1874	1	1	2653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAppRBK6w64ZMQsyN3csyVDSwTFGZTAcnmvJ375GYjMi3dNMkS
30607	payment	2134	2134	1874	1	1	3053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS85RaGiZbpbdsUxrCSG16wyjNMyCuVBuiKPA2rCg97R7QFj4x
30608	payment	2133	2133	1874	1	1	2654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQ8BjFmvMLehVChTMbuoDG1oE9rsoApkLyeuSqwuUYfAuq5DC
30609	payment	1679	1679	865	1	1	59	716090223000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZo7TDX6nPz4M7LSk6ojjcsT7Q645PeeNirQSpiHzGhT2GSmdBw
30610	payment	1679	1679	867	1	1	60	4361150983000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYrQfxujHM9B1ZRbtC7RBxrDRysnUBgFiq3KP1Jxrx3CXHoWrg5
30611	payment	1679	1679	869	1	1	61	466391177000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYkr8dtmSohBs4ivkq1b9CMni7JJRsU24RrWN4eoXewL1349KLB
30612	payment	2133	2133	1874	1	1	2655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGy94V5fwQhnp5VH8rqrLbyMMy8FtnEtRaoFzjatcDPTSvWFAW
30616	payment	1646	1646	1706	1	1	2	1436000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouXYSxFigU9EoACLGV7Gzt9tezbE9huvqM1eG5XMEYCsNUy6d
30617	payment	1679	1679	881	1	1	63	1049906718000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZu4feriLLnXFgHS6dNWf5pRSb6LFWHKw4SSf1m93SRvTR8sBSR
30618	payment	1679	1679	883	1	1	64	161524110000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEMehnWF3JaeKMRYisYbnB6v6CyykSade6Uzj1UadKkfxUhDA9
30619	payment	1679	1679	887	1	1	65	482083245000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEhoP5G5qTuFMw6XSmi2br2AvgPKwGSor1vEF8fwUvkW9UkHJQ
30620	payment	1679	1679	889	1	1	66	404683045000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZn9tQGdUxQSZHgWpFNttwBPRvgQPF9yicrUQeioU7oGs96HDKH
30621	payment	1679	1679	891	1	1	67	888382607000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYaqDFNXGZfFfPeYEtnAgbW7sVboEZVZbBW7Cn6HnMBJU8gAnLY
30622	payment	1679	1679	897	1	1	68	117188973000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZnpud22m87VhjWCFN3vU8Ty9jZs7SiV9Ymaat4XPYEBJoKYoWr
30623	payment	1397	1397	1678	1	1	12238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa464ULyxvC6HpXNH6PYfreBu4VUwoAV6eGFnEb3cApi4xnuKA3
30624	payment	1397	1397	1678	1	1	12239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvGTFxyJSToRjMKp5DPLec1WL2Mxtbnqp32pTmNRhCQYG61gD
30625	payment	2133	2133	1874	1	1	2657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEHyrgwwhSCp4YngbvACiuB8D55uND9j4sKsjuEHh3aBxuj2N
30626	payment	2133	2133	1874	1	1	2658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ62Xvc6pTSn9pbDw3APoC37Lf7UuFSPVHfAL9aziXaHMWph9J
30627	payment	2132	2132	1874	1	1	862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hjtxws1N2uNmzCFo4ccuWv3LZWnLhkMK97HKBQFnqycgRhNu
30672	payment	1397	1397	1678	1	1	12254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPw3YV6byX7Wm4XCR4WFLCp5nE1D4DFQSo8s5fjsc5UCXEvhV
30673	payment	1706	1706	451	1	1	20	258838378919	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	Ckpa6xds42PhudLWQLD2HktFG1n5gxSdL9cUhJGpN6sdqVJhcXofM
30674	payment	1706	1706	487	1	1	21	258838378919	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZtSatGXwEUP6Ddod6upmkJWGkqdgvxntGp7SxdBTmV78W9MUSp
30675	payment	1706	1706	744	1	1	22	7843587225	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYVdWZj7E4fLrUgV6NQNPvErRK7DLsA5iRg73m11RqdeBEKmdAv
30676	payment	1706	1706	988	1	1	23	1970446865596	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZxGxWYHKUnqTa9z3ksZqBoy6TbSrZgzTD9WuVWiZKWVsKjaJ4K
30677	payment	2133	2133	1874	1	1	2672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MouDwNiR5JSjjUDq435Xk72dVrQLg3aJc7B5e4WWtNbJQGvd
30678	payment	1397	1397	1678	1	1	12255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGq7Qb4WFrTwR87FJ7ygQJnGkj1YwZTTE8yeqQAAKhSeKtwF9
30679	payment	1706	1706	1108	1	1	24	3531023900360	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpZsYHdv3QtzEdt4iJQS7Ji3zYmNgLdnSLzM5qXHnJw12ow2yBkk
30680	payment	1706	1706	1228	1	1	25	2382452186180	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpaEqr2bPtzz1xEzNtZe2sx8QbBaHYgqTWKFS1F1X9Vm3mUSHJh7
30681	payment	1706	1706	1354	1	1	26	6638914852680	10000000	\N	E4Yzm3sHSjjtk8tQVPuUgwzPTf3eEGTwnxgPbVTZidrKdFYWBHwVL	CkpYTNBUzsNTAVa6eVWi67m25tJmnACYbor1LoFW6MY93w3vDkYWP
30682	payment	2132	2132	1874	1	1	867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGzzqdMHVgsFB1bsxRGjVtLMqTqs4Zj7MLSAh2LTAU5pdTwLY
30683	payment	2133	2133	1874	1	1	2673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3ZGVM6dTCKAZGx4o34CubSa1EEDUFWetjmuFYjKsraTRS3GL
30684	payment	2133	2133	1874	1	1	2674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyikNJz4pQiqNteGC9wP55mYAUBQpBF5SYVUVCVj5WNhjS46u
30582	payment	1397	1397	1678	1	1	12232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRBqwi9UZM84rWr9R6Nu9aoAFSHwdccZLMTSNwtkPnM4CyhXX
30583	payment	2133	2133	1874	1	1	2651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRD6RKnvLKkmUoTer7HdDfsLG1op5RCgCHjuC19sYqSg9XoSM4
30584	payment	2134	2134	1874	1	1	3051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJSGRB7KDqneA49EgjmyUmGmp444ADAw7ktJfaBSWpyeNHVER
30585	payment	1726	1726	2268	1	1	8274	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiug7Me2KW2saYV7uV3XawuUeNfjqqocARw5g5mPyZjXVpDLNL
30586	payment	2132	2132	1874	1	1	860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRhpuReF8bLPpzBL3bg8fuLbYpVMf1WLyu4izDn5aGEzUbvzg
30587	payment	1397	1397	1678	1	1	12233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxXgX8PSTgaUQ3JsJzJMZhfcC4diMFcxZdkKmtpJRwzJDnkur
30588	payment	1679	1679	1	1	1	50	670905944000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ79XUib15DtQJmNtDM6k9dmPooJuMvwzm8BiAoT5fBAWno4ZmR
30589	payment	1679	1679	841	1	1	51	150172196000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZPr9TdV8kybQWN9vCWwPuDan8AR6m4CfQV15MvZZyKJSdQ8NQp
30590	payment	1679	1679	843	1	1	52	279975125000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYZkU8pprLBdMYzG2nk4v8CyLZqwATUknxj9BSUKBw3snmY6bDH
30591	payment	2133	2133	1874	1	1	2652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsAMLDAbZCepuTXJce2WGwStwYyu6YVT7rqmnkyzCKi6qUywd
30592	payment	2134	2134	1874	1	1	3052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt65qpgRR2XMdxtqCuQUcAnvFeUruHwuRxG8frWFo8ACKZ1489
30593	payment	1646	1646	1706	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpRPJqdfWtHq3T7bLaEaXHuGiJmv9rasYmAFswLevyfs9QQxr
30594	payment	1646	1646	1706	1	1	1	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAMBoeVV5DFrPeUcPND2jcLUpTFLP4jkWz4pE75F6tQ6u34Rt
30595	payment	1679	1679	849	1	1	53	2072884136000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYUoX7yQDZmby5e5RZUC6g8N22MMfXMfFwjNNQwLBefjGm6r7Ja
30596	payment	1679	1679	851	1	1	54	4015489386000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnQULWQKBtzY8DJCKXgsood77xaqvk3UZn4XemeRnm2vDPbrK3
30597	payment	1679	1679	853	1	1	55	442772314000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa9QrEssPm314FEXpBfJGr1wtdDezofJ14ErhkmT9xjAy3QhRj8
30598	payment	1397	1397	1678	1	1	12234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXCZCrmg69qM4gdo6X1KSUtCwRMWEgxG9oi7vfUcixKVn1DkY
30599	payment	1397	1397	1678	1	1	12235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmKeM3oRWK7y9GtHmtdzWQpYr1LKG6do2eeR7g76ybGLtgo2Vh
30600	payment	1397	1397	1678	1	1	12236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pfbUHtt6JfYXo8UgiA5gUVk4KEVnnoN1b7SpspDXSNBuhq6i
30601	payment	1679	1679	855	1	1	56	234209960000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaDp5kShNXNK1ZAwHTbdNaYjZLd7qF9LbTN8tEP52qaMeKvwnTY
30602	payment	1679	1679	857	1	1	57	590556915000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYSz8S8yWs16cyttUaPNEoTxYZS9GkcoPtnih2Yyv2R8HokinXH
30603	payment	1679	1679	861	1	1	58	815696758000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbEtbYhwprfUxWEJcUtFJoYGQE6x13nxKqsanNr4L8cv7RpcmD
30604	payment	1688	1688	2177	1	1	56	6984200300000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5uVtHU8V8Uae8TUT2z5qxGE2WMdmsE5v6R9Hvokp1GYbsWbuD
30605	payment	2132	2132	1874	1	1	861	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2Gkr2tH6meXipntgy2MsaDkmMpRKVBbJNfK2wm79iVSkFJ4z
30613	payment	1679	1679	879	1	1	62	242286166000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYgpjKsEzuDEaLZce1ZcQJQMHTmGDS33ZxemZRFs2TwtKVnGFyF
30614	payment	1397	1397	1678	1	1	12237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEqHLPKRU7urpyo9x4zSU9JBfYiewNEwjhV2qryPJuURPVsY7
30615	payment	2133	2133	1874	1	1	2656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tQQhg36YofRXg6weDK5r1UeU5Wf3UDHp9kJdwm2rwb5cgBBo
30628	payment	1679	1679	899	1	1	69	69855947000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYfvzyzZXuaGfqnHwamw3tfzeVPdDf82TyJFFy1uJP3rW8JRueF
30629	payment	1397	1397	1678	1	1	12240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BBvr7nuVoEa64rQFHvAAaGTMrXoUhT97pDSETYfpGqB3BqP5
30630	payment	1679	1679	901	1	1	70	209981344000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaEpPTC4q5SFu8dukwjpZUmwq3vEGm5CcgxSU4C7aPfzDFJNdfy
30631	payment	1679	1679	905	1	1	71	755125216000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYnJtwVzuGyyqnD2ns3Rn7bmmfeEjqsgNrMWFRHeSzxDsN7B118
30632	payment	2133	2133	1874	1	1	2659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZsmj6i5F4D1buuUysHsd6P3qoj1iP2E8KjcRkPtNSMe6jT9W
30633	payment	1679	1679	2177	1	1	72	1260038800000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ42GZoM3qjRD8vxSU633jXb5JdfzTdrqWB2e9pLn8xcpCrN8tX
30634	payment	1397	1397	1678	1	1	12241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJ3oDUFGbP2N6ku5iz9Ew79kYgTPTrUZxc9tzXKLzeDtwKfWz
30635	payment	1397	1397	1678	1	1	12242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaoGtJRZdizViJuR1Sk9qNVqY7AwZeoavDvSkiUJoqyp5AKXwD
30636	payment	2132	2132	1874	1	1	863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC932W26c6NWZEsUGSjhi46MmL82gnXqQVQ98Dq3p3xS9vyov
30637	payment	2133	2133	1874	1	1	2660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAdzM7enn2LfpBtTTtYrrxG2P9GcFnDWpPrLTeTS5oeEESTLC
30638	payment	2133	2133	1874	1	1	2661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4KcgBxytGDy97fbhVW1M345mAwvKLD7tpFZ2d9vrong7uCnv
30639	payment	1397	1397	1678	1	1	12243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCBwM6htsV4fjAyLPynpm7RX3Bsqzb3fhg8mYKFJSD8m7hyB8
30640	payment	2133	2133	1874	1	1	2662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzXmYM4yWQo7uGTUqCzM1gskVbjAzku8kLyoEgzWRMWVPwojh
30641	payment	1440	1440	1131	1	1	8	4157470000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8s9XSQ31X4wfRLn3n1M9oQSLQHsf5ydM6T9NgRQBU38KHJLw
30642	payment	1397	1397	1678	1	1	12244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YmoQxXN4m8uDuTZ8HDqJLWF2DXTZVzvN33EreCUp44QMcCgE
30643	payment	1397	1397	1678	1	1	12245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVtLwFmtwZYbGzqukEVZ2BfrvSTZpg6GmRprX8QuEASqe4Rae
30644	payment	1397	1397	1678	1	1	12246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBtNozPCwB13hxy29psqUX3kSTkpzqNrDZx27hqVdnCXw1SxzX
30645	payment	2133	2133	1874	1	1	2663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJxXbfmsg1PRcJTmAEuwF4qR2S19cpvdHnABoWVGnZksAAJXs
30646	payment	2132	2132	1874	1	1	864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJC9keGF7Gz7QZMnyBYToPNoMXvtXfLwpjXoXvwUtGTkurGCy
30647	payment	2133	2133	1874	1	1	2664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5nsGwuu8aYWHEEgrbFR8hvD9c3daHvfWPxYubJ7EZNSfARfw
30648	payment	2133	2133	1874	1	1	2665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYricGwzpeFxEgT2ksVfr2hRjJ6QGiYqf27Q1PjNmp1sERZ5jtv
30649	payment	1397	1397	1678	1	1	12247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7KjE6D9KF51kntY2DNqcp5Hm2uv8zRrpUW29QtdbBvVawT8b
30650	payment	2133	2133	1874	1	1	2666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5ezdQb8MK8dEJDn9C7DVdZmSb2oP761r8EZ5oYjD7sSTWhqj
30666	payment	596	596	1981	1	1	7	200000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpYrYjx2RdZDopo13dpyQ8ggSr6NoWKZXHaAZprqVhpQXM16i5SN
30667	payment	1397	1397	1678	1	1	12252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMYFHT6QiFekNu2FVkyBeB48hmaj7RS1KPN6TLWMZhUjhcUhD
30668	payment	2132	2132	1874	1	1	866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTRj6mJ3EbXVHiuM8fwuGMwXCKNS4sTYG32Yk67TL5HKP7qwXe
30669	payment	2133	2133	1874	1	1	2670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRUPYU3jWzamaJDBhP3ynKFKCFUM7DthK625vwC7Lspy3VD2e
30685	payment	1397	1397	1678	1	1	12256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4scuxMC4Ydq6Y9DUHYfwaDYgyyhARLjNHiqDWYcRSbHL3UDB1
30686	payment	1397	1397	1678	1	1	12257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fQRYJ8ZcYsy44TJP7DhyMpokeiwpF3iFYL3tuTC6wWk5xGgr
30687	payment	2133	2133	1874	1	1	2675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8zo4jifoKLChvP2DYGVxtG4GVYitNYArsvV6pPsYvQpAceME
30702	payment	576	576	1355	1	1	4	6878985501703	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYYSxEkQdy4sKMgsWfzPxBZQj2PuBCcCKr4ccg4DUQEkJyaS5Bb
30703	payment	576	576	1109	1	1	5	3658709707202	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpZSy3cwkTCo5G5MGZ2DsD1ytpiEehp1cFn6GKwzf4cD9c6ZopiN
30704	payment	576	576	1229	1	1	6	2468604344390	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYrw1zSFpuGQRvpUmyCghfH1aqQ12KxqLAaa5uhCtMNoK3wmjjo
30705	payment	576	576	989	1	1	7	2041700446703	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpZQVU55vSM8idwnvcXrzL6tUB59F1XbZUAUAbvccsQyTT5JNE6b
30706	payment	576	576	576	1	1	8	0	20000000	\N	E4YnoR6m2Jcq1cYiQjNH1b5UquXaSAXHUf8DTMrKpzCDMp1P3P98j	CkpYtw5rDrBpq3567hm6zNHZwKgZrrkzh43oVXNdS8cRyCbsrAugR
30707	payment	1397	1397	1678	1	1	12264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwX3JdoLoV2csieoUX7cJwcaFb26hMSPRGWMS8N3kc4NpkcZW
30708	payment	2133	2133	1874	1	1	2682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCoUogbYjV8cvESKdTHmPi29iF9kZbv2wPPFeRha117BbtT9oq
30709	payment	1397	1397	1678	1	1	12265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDJ9akzEmVZWfz3n9PssHTYmqV43kCFgwSiSAX3scJqsFndev
30710	payment	2132	2132	1874	1	1	870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZycR3Stc8pWMA4nw5dBdMwXyUojnsKJQM3f1oGJP7yWT2mL7x
30728	payment	1397	1397	1678	1	1	12272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtEGBRiesKYDenADQgM1qFph2uTy4Ufzdp2AeN1UjkgBd4xiK
30729	payment	2133	2133	1874	1	1	2690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4ddrrpR1WQ28mL3U1dgx7N1QGXYLFNJFegvaTiWVF7xMD24p
30741	payment	1397	1397	1678	1	1	12277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfyysAC5UA6UWwpYyQyUNueQS1aAAHMiXvg1WUtUDNXif6PUq
30742	payment	2133	2133	1874	1	1	2695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHGKSdpMkA5bcw1NedAz1WQtJWAvtzAMwAqRd1F1sCRyFSyV5
30751	payment	1397	1397	1678	1	1	12280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQBv1pyMvp244cPH6sMjFF3kz2b4vgjvaEkf3x7TFdBZ3UtL9
30752	payment	2133	2133	1874	1	1	2698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcZUteUYHc2HJ7t4zdXwD3hy7f69FaNmDahN3q9rW775oFkhK
30758	payment	1992	1992	596	1	1	4	1244000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZh6y6vxHZccj39LRFv4RLMNVHpswwG6SjQYEkSju7cb8N1iC
30817	payment	1397	1397	1678	1	1	12304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m6nAA8u3TdFcGNhjwkrQvnaZ3TZmTer4eQABTMGsWPp3UyGn
30818	payment	2133	2133	1874	1	1	2722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcvkJpSvcTCXwBdUckNYwaGwEPn8bkA4JAmgBj9zcFVbFhKCj
30826	payment	1397	1397	1678	1	1	12308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYV2iJbMk3wFE8rdCsr7zc8zSq2HXcNLmHfd5ygCLHAJZBrb6P
30651	payment	1440	1440	1251	1	1	9	2805000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj4uocWTB91e4aJw6MyESQoPVapvQKBBfLzYdzKakXShQ51oc
30652	payment	596	596	1981	1	1	5	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjxejT6rvTaD27swzkBDSUBqf3KqzeiXC4MD5uNsPYja8LyXC
30653	payment	1397	1397	1678	1	1	12248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXiy1GXQx4hBuspAKPPGtXNUQc8SMqTmCJqcp8ysNEAB73qUg
30654	payment	1688	1688	2177	1	1	56	6984200300100	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa1ZfhfDdXKmCsQt2dF73Ru8DYFHBVWdSNihVUtjHGpiVgjKGen
30655	payment	2132	2132	1874	1	1	865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqyWH4GMWJkbVu493aHqb4GzRJncJeZaDxD6E1tdcFfw4cjcNo
30656	payment	2133	2133	1874	1	1	2667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yCWAqwKzDiUDeLHdoc2EkF242w2kgYAgy9gWFdJk2GFH5Twn
30657	payment	1397	1397	1678	1	1	12249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFhnrZ9VV5xoUekmjkf53xoHdkGQAzrcpCj2uFJywyVGnZ3ff
30658	payment	2133	2133	1874	1	1	2668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzAdYFnG9JVPZbSDWeGtETmfhgRXuR9bQTbSmVwEnej92NZ23V
30670	payment	1397	1397	1678	1	1	12253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhi1Pmv8txzXcFGfdSGFVT66tZA7CorXqSgab2g37LZpq6HT4Z
30671	payment	2133	2133	1874	1	1	2671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwhGoc63x3Ep4RAJ4P1xTcLGHv73XYApY2SQo4YwUCFiBAMqF
30711	payment	2133	2133	1874	1	1	2683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu18iAZUuogKngw58Yq3uQi1w9KYQQd94Mv7GjLs2jGK6xpTd
30732	payment	1397	1397	1678	1	1	12274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvd5kvKSC7AsWFB3v7qsiCv5L8E6zrAnJvhyAUaCL4SrXQ43u6
30733	payment	2133	2133	1874	1	1	2692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB25xwPxeQet3Lu3QrJmAuaCZoWdiCE9CMRH6PQbTyWBRMzonN
30734	payment	1397	1397	1678	1	1	12275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVd1JbMuGEpZavBsm9pG18stFPvzQ5CtG1a7iBqryieyUtE1yd
30735	payment	2133	2133	1874	1	1	2693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfy5PFqQPPS1HpxT9EW94fqsZUY4abs9ZknEbaLKQZjVD7v68z
30736	payment	2132	2132	1874	1	1	873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhaA293mJnqKxMcHXapN3tyiMMam5cJpGBpeoH5QigL3mSSrYm
30737	payment	1992	1992	940	1	1	0	2371000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpYvBfMTQQRSBrPTEb6nScUgQRDZ2DXLaUjF1ubqVgNZDsTZGA3r
30738	payment	1397	1397	1678	1	1	12276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTimNQT95ojttfV3dQQWPnZqHMFF5W9nCvJkfGNMr2QVHsEixB
30739	delegation	2268	2268	2268	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwMLNtz3xH3fo7QPwW1pnBS3iSZhopnueo8FB926j5GP5hAc9
30753	payment	1397	1397	1678	1	1	12281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5syDSju8zZMgnnGUf7S7n86hGzpMiKDrEqTLicMt4ySsiLvp
30801	payment	1397	1397	1678	1	1	12298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcQtHRybcdDgHB8manF3t8RiqYzSoCXDhP1XhVkhRKTWnq8mw
30802	payment	2133	2133	1874	1	1	2716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSedUfKBucFMLuVCksJWHX2WEvV31RiVgHemkp9CJ21Xwtsuv
30803	payment	2132	2132	1874	1	1	880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxKnvNoFpRHp47tdkK7eTuUEURY45Q1npbas8bBxSqfximfUJ
30819	payment	1397	1397	1678	1	1	12305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuP6f6A8Psi5oEUTwF18QzUHnCquW2VQ8LQpWEXtrChXfQgAJP
30820	payment	2132	2132	1874	1	1	882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3aSDsuZcTqYX3EUCpZhkSh9LcJvzvA76Apnr6a2qmCUGXAPK
30821	payment	2133	2133	1874	1	1	2723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCw3bs94yXp85XLTbgxxgVjS9iY2EEJ3mFExUnKZi5swDkcEV
30856	payment	1397	1397	1678	1	1	12321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrA9X9LejN7gmiDLHm3UV3VR7GbU91ra6o2UKesmLnjmZF2Vmv
30857	payment	2133	2133	1874	1	1	2738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbK6XBqFriE9zyyX3XyAWJrukf7eqTBGoLudR9ZstkL3jigjaJ
30865	payment	1397	1397	1678	1	1	12325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3PdGcwWrTKHk7w19yAkzE68AMNo7tegS6f7t4yAckZGKNHPr
30866	payment	1397	1397	1678	1	1	12326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7JrbxKWsY31DbpVTY1afG68GYCMn4Cif8uzgkL9GLykPSVqY
30867	payment	2133	2133	1874	1	1	2742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrb94wgnu2y3tx8cMb5yY2FmSC87RDrvnAFoTJvSYS6NANF5o
30868	payment	2132	2132	1874	1	1	888	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoYEz66u1pr3Un396K4WCw13fpcUnWL2CFfiCL3QZYhJnWJsQY
30869	payment	2133	2133	1874	1	1	2743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLG38HufGYKVtfHLVfPPcUuwDZhit6GKKtkgdWqfNbd8Dm6r8L
30886	payment	1397	1397	1678	1	1	12334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZJqfwwHGwiLfKectUqMbcj6o49SxSvCF4epCUfirT4sTkQQH
30887	payment	2133	2133	1874	1	1	2751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXhHtL8k9Jnm1WqS4DX91UEEezyg6zrgi9dcwNq8TpNbLoPbE
30892	payment	1397	1397	1678	1	1	12336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUKXVZBztdH8bGFSwdTt1HctiJKMP6E3eDjZAsgGUrnENMhzy
30893	payment	1397	1397	1678	1	1	12337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8FSXUB26dW5uoKjScRjfdqPzmK9mxm6R64g4X1u3QFt8e6tT
30894	payment	242	242	2269	1	1	1	647000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGbmBtfSQPrqVoaFLgQnmc1ThxxiwwEpe3rzScH6G1kxGE4EXV
30659	payment	1440	1440	1011	1	1	10	2320000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ6GUZVi4ksaZanowrf1RXkqaaFFYp92apSw2HKydsKkSfjhS6
30660	payment	1679	1679	873	1	1	73	4361150983000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYZkWNYtdPMEc7ZXaRYdPHG6bJPkuZgz6Upf5HZPe9QkxHYjEKc
30661	payment	1397	1397	1678	1	1	12250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgBY8mvPFw1DMr8ZkxFQn7JtBtR6WF8aHhS84SUYQoJuLC9Dg
30662	payment	596	596	1981	1	1	6	100000000	10000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpaHvzhgeTzzV7pjdizhbK8YY8cKiF1D8uSbCXa8xJYrP6YyKBAq
30663	payment	1397	1397	1678	1	1	12251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eDmcgskGwpyChDqkidx5821Bsr7Sa3RWPM5VGLg3dC8rYbDe
30664	payment	1679	1679	875	1	1	74	382273728000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZGQ7JWSt6DboHtiCWWg7YfFnYbxnotnEGvNenxxMhRnESTXQcP
30665	payment	2133	2133	1874	1	1	2669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNypfdcZQCDRskzmEHcNya1DdbcmTV5CMXVdEf761kmVQiFMmE
30721	payment	1679	1679	873	1	1	62	4361150983000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZsPpo2XXQVf7ySAFVALdAcuYCXWWh9jzUncrzRRMFeyyUuq7ku
30722	payment	1679	1679	875	1	1	63	382273728000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZxDfYbjpmXXZoRsMshk8UN4AT4QnFkKyueL5qJEWdMFpEoFgXp
30723	payment	1397	1397	1678	1	1	12270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2gjQ6ZKHF3RMCpD52ngDBn7vh4q6nV6vZ9HuEbDH38Bc8ZMA
30724	payment	2133	2133	1874	1	1	2688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLaSKBUEYYGSFMo75deqXtY2Zjz9YRf4rqLqMKW3t8sSTFfjv
30725	payment	1397	1397	1678	1	1	12271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkoqoRpFFQfrGfpxiff6w9H43GJiLdvoYZrGHMsvqxJC5bt4v
30726	payment	2133	2133	1874	1	1	2689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadTUYQE4U5PLG1CGsp5xkjopXuqAWe9MDKwsxpyrqzm56jtuk
30743	payment	1397	1397	1678	1	1	12278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9g7Ha793h6G11cvyqpcjQHbaEHQKmi6nP1fSa7Mi2P5Bnshj
30744	payment	1992	1992	1060	1	1	1	4249000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpYpaqW3htza48LmRHDFt2KfMTzcwfd7N3DDgXfCGjk3WgpzW5r4
30745	payment	1992	1992	1180	1	1	2	2867000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpZQYW743JdkR997wNJxy4zG7hVnpps52ndyVZeey2pLVJt2zUUZ
30746	payment	2133	2133	1874	1	1	2696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoaMFtWJQ4eDSKEjiKQpsFPUVAV8qjNZHGxHWDzrhgUHbBxZP
30747	payment	2132	2132	1874	1	1	874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtQrC7toNz5NbcXWg6CNXpUnQP9ydfn6SUY5aGCeXZQBn5Y8Y
30755	payment	1397	1397	1678	1	1	12282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8G4LEoCBNQaQUvsJn5wNARy2njTku3gGa6mhrs214QuoN55ry
30756	payment	2132	2132	1874	1	1	875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QzSpGodvEuy2gyaJbehwMGQSxLgsnur7cCVsRHpfiNCZhUTM
30757	payment	2133	2133	1874	1	1	2700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebLJXxiQe8uJZ8xs45xJDZX2EbGsTg5tmZiLah8tKLBzDVg4y
30763	payment	1397	1397	1678	1	1	12285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjSAsDcc3LVJ61PGCcd5V755c4LnRYtgoFi1wcbUjTrt2Z4XX
30764	payment	2132	2132	1874	1	1	876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCALMoKVLe99nTW3C3QK8ux9KW45xPihxpkxdSgTaPSNr1dycW
30765	payment	2133	2133	1874	1	1	2703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTyN3MjKuBX4vshibuf41JoBeieuVhLGVL44jbB4euVkYpSxCN
30784	payment	1397	1397	1678	1	1	12293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYxp8LhVeLP3UZYPStKkY5NhjFDnUoJTXBgf81uWh4nVocdzT
30785	payment	2133	2133	1874	1	1	2711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppbbF4jyyCW6fE3yFZDmTZkwLeLJesRsB7VctVKyXnjAmfHhj
30786	payment	1705	1705	1234	1	1	22	2138396100000	20000000	\N	E4ZEAoxpgrTwhADcAt4cDzEGgVnpAfLKEA2jMu4twtTqbBWFv1XuM	CkpZxHvXHT5DjyxGdTW2bq86ataKy59AdNUg5dAtR62rqgi8ULZWX
30787	payment	1705	1705	1360	1	1	23	5	20000000	\N	E4ZEAoxpgrTwhADcAt4cDzEGgVnpAfLKEA2jMu4twtTqbBWFv1XuM	CkpZGp7MLum2AgTTQXELGYrA3MQEiTE5fDKX8hoH8WryaLPG7Pq8o
30788	payment	1397	1397	1678	1	1	12294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyF6PUvjRYKi3Z1suCoN1PB8a3qihoZmWeeC44agLjajDNd9Z
30789	payment	1397	1397	1678	1	1	12295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgJ8ePc563J6qHf7Y7PoxSwZZMmMKq2GyT8pSSrjfqtdFVE6y
30790	payment	1397	1397	1678	1	1	12296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErBmfxKzgXTMsivSF9yFBsoyyNu6ribHLt8MBrYiYhzZd1YRu
30791	payment	1397	1397	1678	1	1	12297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpnqCbGnnG8damJJAcMrtsyQpjJDNn6PF9MAgL3cCULdQJPrN
30792	payment	2132	2132	1874	1	1	879	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2fMR4XDhuKtVG42xMgvw1gcUQZsoDGzd1SLfzgfyFqbte7Jm
30793	payment	1444	1444	1381	1	1	8	8294657600000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZNTiSL6LX8TxJ5oZHv7oCFXatTDk5xzdDEnWQeWjasBDMHJDBP
30794	payment	1444	1444	1135	1	1	9	4411659870000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZ8WNfYNBPxRHdgasHkDDBLaXirLuuSZ1S7r3ceMuQ39e4cXowe
30795	payment	1444	1444	1255	1	1	10	2976634820000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZef7fnM4aMGFvsCVvZcxyXbuaMXWSU8jGEq9HXmjspD6wJQVFi
30796	payment	1444	1444	1015	1	1	11	2461875540000	1000000	\N	E4YppzNCrUaiq7LTcKqYcfztT6xLdAo9mPxmBAAwc4BwEcciCVrax	CkpZkeoTVsGPWK4sm5ttQHDwnkTV3Kjp24U5879CNeUwgXAQPLuQS
30797	payment	2133	2133	1874	1	1	2712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpKZm1jb5A4H5gEGUBaNVhYh2WQDrr4XCCdyH634ksHk3qV5P
30688	payment	1397	1397	1678	1	1	12258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnMZpQ9gAbYcBR4SZStvJKg5eV9GYTtD1kQ1XWWv7UDPcbkJT
30689	payment	2133	2133	1874	1	1	2676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJJcFJCFSmg1bN51JdNQJQJGEf6km31zD7bi83PdUNnLNwzJK
30690	payment	2132	2132	1874	1	1	868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuibFfxitejx9TkCvPq8jTuDEjjNmSPmU9GpefYtgjoJQP1d2i
30691	payment	1397	1397	1678	1	1	12259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUDRSSFdPtke7m5LM45shvqaF2m6rVbDwSK22pwhersJA2kMS
30692	payment	2133	2133	1874	1	1	2677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxTk43gQYzRAgiRwousdyrMAo3i86bTmomfh2xYBuNWjsXTTb
30693	payment	1397	1397	1678	1	1	12260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnC39chWzo6TC4A4uuFTDTPrfQHwGgmGEe6AXVvS2V2UXuBEc
30694	payment	1397	1397	1678	1	1	12261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHt8VBGvmZU31FnhLkjdK87x118GPTVdk6SpzBbURwcf8mXjg
30695	payment	1397	1397	1678	1	1	12262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Km8hr8JUCgXyQA5fZVUJygk9r8Z8L4Y6cX9DG1BUQQjeCfdC
30696	payment	2133	2133	1874	1	1	2678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1EU2x8F6ZQYcsNDcnCvKHDWEYUhuM3HrVL7bSBxBfopguBjR
30697	payment	2133	2133	1874	1	1	2679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzJ3YS8K4i4GNrDkdYuRZNM6TKjZGsC4vzMLdixUpohRpNprx
30698	payment	2132	2132	1874	1	1	869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEB9GjioWfbYe6EVKnfWcSrMmvhxUoGhP6cyYiWNXbyKUKvEq
30699	payment	2133	2133	1874	1	1	2680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAE7RkuZZevPoeKTNZyv88FJXj5BF2gkTDf5QAYWdgzM174Tx
30700	payment	1397	1397	1678	1	1	12263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsddrHQbFzqgxmQuP3GwEeFVnf4jgMsVv3oH6KwQmGGeXYZr6Q
30701	payment	2133	2133	1874	1	1	2681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuf3cvQQjp2kgp1jYoG9zCSJ5r4gSxgYRbPsp7CZ1vATFSNEKn
30712	payment	1397	1397	1678	1	1	12266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3F9kRFm7jG9ozoRUTqtY5cchjqbFnAnshRjkw5XADXjJRYGSa
30713	payment	2133	2133	1874	1	1	2684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5VqLaAktvZfvkPmQnBfuDvmVRzRSaZkn3cGfkuzFkpYBTgY3
30714	payment	1397	1397	1678	1	1	12267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpcmMkUPmd9i1Y8e2cDZy6WeRes7t1EgDDeUofH1kuTVcMnZs
30715	payment	2133	2133	1874	1	1	2685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZmrBtmcxgKMe31mA2fGjqwKwrWUFqUR7yjybjtWwdePHoChW
30716	payment	1397	1397	1678	1	1	12268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikxJpr2rSAjRYNwr3XZ3LPzxnwE6gGNTMDeRTk2ZNK4N7Zief
30717	payment	2132	2132	1874	1	1	871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJHNuFhnikM5kqEapNzCzLMq5etQ5tJqP9GV21ZhhDbNU5qiX3
30718	payment	2133	2133	1874	1	1	2686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44MxGBM9rYGLY67aUUCJULtpxAuQVGx36Jvc9ANtXBkFcdibs
30719	payment	1397	1397	1678	1	1	12269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qZvXb9eJgiYPoh3mNweufx3iepn1o8r5CRDuSUvCBdnS2yxA
30720	payment	2133	2133	1874	1	1	2687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejC2tmp5NjmHtqxPGgkjmfNabT6fAwb8cSUhKXG3yhqLxxUM1
30727	payment	2132	2132	1874	1	1	872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1rdmC7RyLna5LwTnX3SSiZvj5cEuV1BRRAz4Q2EMotQSmLro
30730	payment	1397	1397	1678	1	1	12273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7ZfRkY55AWd9pEddyi4Aur47FH4XcSdnSBih6HQgysCjLb1R
30731	payment	2133	2133	1874	1	1	2691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVKefYXeazFJtXTwKL13gWw3U1B49Jumfmtch3Xc9Gscb1biN
30740	payment	2133	2133	1874	1	1	2694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckbWeDBfWewxjRYWG7GsMYQFAP3pLACEheQCmqVnoyb1pzHEj
30748	payment	1992	1992	1306	1	1	3	7988000000000	10000000	\N	E4Yq6RVQWrWqfqhsjduwtZ96dvY25cDa2M8JpWPQJJTSHmi9Y2Din	CkpYpeKaoDYhhoBu1ZNowd7XdJCWmdGLyNXUzFjsTfxdq69LiWvvk
30749	payment	1397	1397	1678	1	1	12279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK2ephzztmQtCKyjU4UNw3cQFvBgUs8WVU2FyJwTbWhppwJFkp
30750	payment	2133	2133	1874	1	1	2697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC1Lrg2x6iuHe4NJbqY6NGsCXmWRiqP1FB7vinrpiNaHcdjXgz
30754	payment	2133	2133	1874	1	1	2699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKmrjpsdJA4eFs47jgqFMvQT5bzrhCKtWM7KKkgkdcs8K8jqF
30759	payment	1397	1397	1678	1	1	12283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktoC9mYYpMVy8xSiYhsmWw41W1Q5GAkEb6rerPiyKj9fXfTWk
30760	payment	1397	1397	1678	1	1	12284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDiwJemekqSqn5iKWWtunEen256SwWAWiK4ahryHBJ4qSkyU6A
30761	payment	2133	2133	1874	1	1	2701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrqRK82hzXGqgdVHXohzKPU3b8QDfn8ZhQ1SXTrrLXgRgVA9D
30762	payment	2133	2133	1874	1	1	2702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zs4JY3C9vBFAQ4RnJ6EnNm1DfqQpSUb47qSHaqfz6KwgLdbA
30766	payment	1397	1397	1678	1	1	12286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm35Ky4Zp2oVNVC1ptfcic17ByuEGeKsh8f9TNuzTngdo5pCmz
30767	payment	1397	1397	1678	1	1	12287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKLANtKvqddic8FVTWThfdCcEdNihqPMafukt8AHvzEwcRJKW
30768	payment	2133	2133	1874	1	1	2704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvtHvqKpRXnVfQ94rm1BBmH2FWVjDugqEeRksPbU3pfYydsGL
30769	payment	2133	2133	1874	1	1	2705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtSF3MToqHMujoLhHaEzHxkHvFqUEHAi97XczgicT7UiDHqR62
30770	payment	1705	1705	994	1	1	20	1768615010000	20000000	\N	E4ZADNPtAsHbh7QT321ZjPMfenp9LDc6Rqv5F7zCT2vQGcFpAJfaX	CkpYYitpzmKJQ2UYmr2jk8VL2Vr5j8fcsS4u2D8wtNiKfQpgRQcqd
30771	payment	1397	1397	1678	1	1	12288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKHDKbgFBTShFMde7bD2s1QwpGLA2NBk7QGEYwbxAEu1p1w8h
30772	payment	1397	1397	1678	1	1	12289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYf8mPGxmo7s69WyknZ5Pg1XgqdGJFdvVRQC5KYpvtbVQrEznb
30773	payment	1397	1397	1678	1	1	12290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGxCTx89t3mpqFcJZ3S9oVm9HPnE4vv2a6JHEUaBoWWcudgUQ
30774	payment	1397	1397	1678	1	1	12291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqY1G2vCmLXGwUhy23Kb2KrMXYEHcbnDa1otsRjBhu9KxggEF
30775	payment	2132	2132	1874	1	1	877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhynPbhBzwnvYxJTjiaz7z92FwKLLpGx93GmeKjATjJ9XgmbRB
30776	payment	2133	2133	1874	1	1	2706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpo2AbChXieEZPtrJJUmqXA4t8ADyHBrtYZH2QYFDu4Z4gyWnh
30777	payment	2133	2133	1874	1	1	2707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoMJc1iUS8yAH2rzvzH7sXf15FL8GqgKJbsFMo9k1s9u6Pgi4
30778	payment	2133	2133	1874	1	1	2708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfdffThAcVUj89nwkzU28cyofGnxMkvZehp1QWK5Bw35gC9fq
30779	payment	2133	2133	1874	1	1	2709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86ZQsEbAgLnuea8wkptM3ePbQPgz4HASaLNeK8UzdG1tATPRv
30780	payment	1705	1705	1114	1	1	21	3169295350000	20000000	\N	E4ZEAoxpgrTwhADcAt4cDzEGgVnpAfLKEA2jMu4twtTqbBWFv1XuM	CkpYw4Jx11rmXTGeo3TRpzzptMdpcm8H24MBJnoSPpTtaV8sLGDX4
30781	payment	1397	1397	1678	1	1	12292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFm4Pv3d4sANTF58L6AqmtqYYyyiEjhCW7gBAZyFfQFt6Wm32n
30782	payment	2132	2132	1874	1	1	878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNxrguX9UiSeTsDTqEXoku1Rdasis6xzGupWNrKA18zG3E7xZ
30783	payment	2133	2133	1874	1	1	2710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssG5gH4NxzavvPAzNpRvmcV8kogPQWHaLmmcWvCBV7j6cRMcv
30804	payment	1397	1397	1678	1	1	12299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4e3i2v3UfeSKFktvnMKyCw8t7nvrLv6F1XGoCZps43vZvU3R
30805	delegation	1932	1932	1932	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmrqzJz3sUggrjoE2nghHLovUFpAdVgKSUyqvsjJBFuVsiztp
30806	payment	2133	2133	1874	1	1	2717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5rvAioJDiYisTPiN1h6yu2ZQnYhYLqrHQL3ZrZLqP5mgynMP
30812	payment	1397	1397	1678	1	1	12302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHisFnt8U7po48hkfQ8pkX2U8zbiioemn2HEeQMrVyTx1DzNeg
30813	payment	1397	1397	1678	1	1	12303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkMb9rKhSkpNmgqRtCfsr4nnx7ZBAUY9UyrgZCfroZ8ds7Vbc
30814	payment	2133	2133	1874	1	1	2720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcybbh5AwFaSMKsebBAkRXaNFPCUN3Hxp18auSVb1X1S7X4EK
30815	payment	2133	2133	1874	1	1	2721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoVZUAoFes7zeWQviMKHrLjezPUcforpyTXf1ZwJizbQob6Ft
30816	payment	2132	2132	1874	1	1	881	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFdKSKmQ44oCTum8w4UdHEkYdDzrs7JBz66Ab7JHe9Zz3KgD8
30822	payment	1397	1397	1678	1	1	12306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKy2k2tQ93A9nwBMdKvtaEPL5pfpgABX5WXyDs6xVByGBtweoE
30823	payment	1397	1397	1678	1	1	12307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAbH3i3ojAM4v9RJfnrhyfXGzt59L15NKoxKonFeY8mTWpyUP
30824	payment	2133	2133	1874	1	1	2724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEsRrdyRPWtpxv8piFUuMjM18Anszm5Zu3SifGgd865wtgNiu
30825	payment	2133	2133	1874	1	1	2725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmdWy15EY2bnWEgg852k7B7X2YZWUwh4YpcXB5CkYXfwEakd7
30835	payment	1397	1397	1678	1	1	12312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpcw5CwSZdMYxJUkmUSNn2ppzma99BkugUCKnZ8mEvhhCw7j8
30836	payment	2133	2133	1874	1	1	2730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNe9iYC4rx2PMABEcKJ8EAyh4kBUkT6iiEEiYyr2r6yz7eugoz
30837	payment	2132	2132	1874	1	1	884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeoCcorVcj2ydjGhwNFsFo3cDiGjTt9ZaCQ1fybdvUh9mrAvW
30861	payment	1397	1397	1678	1	1	12323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7tXvvM4Bgysrg6mUvPUKKG48ruMSCTMtW8dFEtax96KG2sfP
30862	payment	2133	2133	1874	1	1	2740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuzZfB1iPSQBBgc5wasAKPEsBAdL3g2ZoUdJP71YJGdSTmyKp
30870	payment	1397	1397	1678	1	1	12327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfU1Y2tpHN3Yvdf87UhhHy7hug2qtX3hjqh9kwHubjC199aWo
30871	payment	2133	2133	1874	1	1	2744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbehc4a17SAnUbcic7gvxd8L97XUMzs2uK2WGLxtyZkYXoUhJ
30903	payment	1397	1397	1678	1	1	12340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynsFeJTTL1oACpuQkZawhH6Eq4jiKANqg85xWiBT2hVpsxb9o
30904	payment	2133	2133	1874	1	1	2757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRp1H1bPYhLafzQdh5cyrUQXtLGEzEBMA79hJ5yLyydBxom2q
30916	payment	1397	1397	1678	1	1	12344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUc2rg5LYfAK8sbSDbQQkymp5nHA7EiiMSZUVfjji56a4D2hnF
30917	payment	2133	2133	1874	1	1	2761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhq5vtyNg8mgUymhPAst6MhRQdNT2RMUWYegbNGKGJM7zqCae4
30798	payment	2133	2133	1874	1	1	2713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEEjQaCqzAtL4HeRFrVRDESXqpH79R6DZJZGEHMw8FMuG64g6a
30799	payment	2133	2133	1874	1	1	2714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxb68jSi9esEVT9sNFR2ugTd8kjBU6PE6JDpJdzHoqu1krgL7
30800	payment	2133	2133	1874	1	1	2715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfAKyRFgTgWYQu4pJqA66MJhnkyhzRqjtpUW24KjQg6rcGDWWF
30807	payment	1705	1705	1360	1	1	24	5958825460000	20000000	\N	E4Z8LaS8LkuffUp9RmLsMzNJtB3cBUYuoo3A8X8MKoS7HhHvw8jUK	CkpaCUUGimtxtA13LiAdSmvWCnbbiNT6VijRS1XmHCachA9h3ZxhG
30808	payment	1397	1397	1678	1	1	12300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTv7xCSaD6utJSdMFxHewcWoeenJvhHmbbdndRDzWZW1tRaef
30809	payment	1397	1397	1678	1	1	12301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieJYGUdb4BnobwacEmFZ6VhWkRMHCLuAEfBz2ZurKuvTrPF9Y
30810	payment	2133	2133	1874	1	1	2718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGndBxoByBfgZ1eSgDLhWwjgstqJdi8eNm6UqTW4PreeXeSS3
30811	payment	2133	2133	1874	1	1	2719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3yjkWxfhmnAbQLvT3TZZds9k647K7gGrXmdUsD8CYTj5542w
30828	payment	1397	1397	1678	1	1	12309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ55y3WL3vx6ipg3WJBLQYdHGTq4Fo5DbvAPYjecanquUAjYyz
30829	payment	2132	2132	1874	1	1	883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRW7hLrTzppDPP57M4k3apb3TvS3MRhBoR4fwpdmzKSMXrZyP
30830	payment	2133	2133	1874	1	1	2727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1bV367yXs3ZABPsFbPY9AeB1qp9GM1NLFLQ9juhKAmpmDnnR
30838	payment	1397	1397	1678	1	1	12313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjHZSPpvtkiKvhZF9TprtaU7A1axEdDtWARE9jKSuKG2Sg7KK
30839	payment	2133	2133	1874	1	1	2731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aLfxmPjUXJx1Nsy779owGB82azct6QVFUWzqvp14i2cMWfdy
30840	payment	1397	1397	1678	1	1	12314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vpWT8xjZApkJmqybUkYQVzouCSN4tQSG1rWQ3GNTgDFNZPjn
30847	payment	1397	1397	1678	1	1	12317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Dby742hCUR3vm8hf27r9haRJ2rqoU2Xhw8MYepKb2Z1KDxek
30848	payment	2133	2133	1874	1	1	2734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8AXtGrm7SKf8GLQF2tfqf9nnKhaGH3qBAsqtYZtbBJnP4zUJ
30849	payment	1397	1397	1678	1	1	12318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56rUeGPdV7d3DXA8LaAcguv4wpZr3YBd5SZxemRxEob1wWYiE
30850	payment	2133	2133	1874	1	1	2735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPQEFLk4cgPZv7o6uRtsque1syhxyRtB5u8hKgGmy8SMRduQH
30858	payment	1397	1397	1678	1	1	12322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9LVNNVhCWANsezhR5eMXYigpE1QWqzdiPeFiqYeSJP33uG5Kg
30859	payment	2133	2133	1874	1	1	2739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PUTQSGYrdyNPG4QSM4NhqiCspFDyA6qt1pXUQaqmWnLD837U
30860	payment	2132	2132	1874	1	1	887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFEG6APccgCyDoMfP144bAnght1iQ5127ACJbQBjAgVyAdWxy
30872	payment	1397	1397	1678	1	1	12328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgooAdn89s7Mp2jKcEFXh6xGcREdh2aP7rXzjD8fm3X92dDms9
30873	payment	1397	1397	1678	1	1	12329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcrKwZw1LvReEBvoVkbucPn1aJdBjBUhQTwof8meTR5ZBUYQb
30874	payment	1397	1397	1678	1	1	12330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZacQgtChABFqtYpYwW4z8ZK9kkKy1ZKsSy7M6xE5akDo8D3zK1
30875	payment	2133	2133	1874	1	1	2745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsQVudPDoE2Uu5t9NpLTz2a4BR2dSJbf4GhSw6xJckEkgsbAz
30876	payment	2132	2132	1874	1	1	889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYEJ12GvZr5W44QaNR77mEMgSnFSmoUuL7oUatFBRpxKEzUGE
30877	payment	2133	2133	1874	1	1	2746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpeGZpkYWxL885VnZNKVLZkTwx2n4uBP4nFM7jEzZBJJ7zKFV
30878	payment	2133	2133	1874	1	1	2747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpt4bQEiizcWQeJtxRp4XYRec5DZkVA94gkpmhBcvMVGKY6W7
30879	payment	1397	1397	1678	1	1	12331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHcnxxphek3JzosHxVLnrA8etxnNstVxZZC229mUQJxbpteHr
30880	payment	1397	1397	1678	1	1	12332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFAWSmKW5dZhJaCkXsDnBksou794vsTwWGTSoH9P5ozCzYjDt
30881	payment	1397	1397	1678	1	1	12333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqo8RBnYDa4HAoYH2yZtMrbg2Pxy1uHYKCUp5VpKirVHSWu1SD
30882	payment	2133	2133	1874	1	1	2748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TGwz4XuQQ5faZnGpQqMHohhS4w81MoWMjvJJRhnr3BK3ncLU
30883	payment	2132	2132	1874	1	1	890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4P6CDhajbQBFJvLoPMaWySU9B1LrmzFtLJPEFFCrZ5VGCa7vy
30884	payment	2133	2133	1874	1	1	2749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zrwvfWD43QfcZWQSWxWh2UTpZPrNUnknbcsbM42FTJ2qWv8s
30885	payment	2133	2133	1874	1	1	2750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMktBJkF65trSosGAG1GTsCSxTJNMkGb173ezyABaEuhhSQj61
30908	payment	2039	2039	1164	1	1	3	3087600000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpYx7xKYYDm6WUBxPdWGb2UfhmTgYAvumxTEtKX2jNEvteLQwtSx
30909	payment	2039	2039	1044	1	1	4	4575900000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpZ2JsgPGVUW1Gj47FESnFFjERadUzaaQYobb15F6Uzm3c78an6f
30910	payment	1397	1397	1678	1	1	12342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwtfpCpjbfSSYMRkUBT17XrZfukqhoZKFEGKTtvgbUeoDhugP
30827	payment	2133	2133	1874	1	1	2726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTBNPiZhYGFcr3qV3kEsmDMPX4QzfmH9BTdm4rMNB5z3Zdxvy6
30831	payment	1397	1397	1678	1	1	12310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaa4bxBAHswifEsDaeeoxZu1pyBKNrtbBroaVQppDbszsodbo
30832	payment	1397	1397	1678	1	1	12311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrz6KA8TEmJvNnepDg9LDrMPrRX26RqPCD27fmxY2YSAF3dUK5
30833	payment	2133	2133	1874	1	1	2728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCemCL5xERx1QKYGRmwZTmaWWzA4fUDsvgmoFkMqm3ew7tp2s6
30834	payment	2133	2133	1874	1	1	2729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3yGSc88r9jnJbnPUUYRUqHvceqMBZSFxY5amUFgS5gY6eA6o
30841	payment	1397	1397	1678	1	1	12315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNHmkdMZRcnKMF5c5C6C78cDDjdPCziWjTtDKUx1UMEDomXhE
30842	delegation	149	149	58	1	1	9	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5r2Pr14HUvo6XZxJywQjnVuXWTVjytXvZhYcshU2Dd5SrmuTt
30843	payment	2133	2133	1874	1	1	2732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxYivfy7r3bLrnCMKKi4P5Lk7m7dm2YsMfT8bKBh6Y6xqSFKx
30844	payment	2132	2132	1874	1	1	885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFbg7v3LJVVX1NXsRF34WFkCx4ET9kLX4Ukj3xkq8tfrZDA56r
30845	payment	1397	1397	1678	1	1	12316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JtTJfdbW2K76bqbSG4fLbAygjkGMKRhxP6UL7HpFU5wmcvrW
30846	payment	2133	2133	1874	1	1	2733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4VfqCRh5mcRkYrxiLoDYeBy5nYHfgBL671uCF9CpTmgwr6EH
30851	payment	1397	1397	1678	1	1	12319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVbnTCuz36n5QfqxJGNtymNqLcs48UjKJ7io2LCZAf1hNhvfD
30852	payment	2133	2133	1874	1	1	2736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xASJbvr9FaaSv4FZssrq22nxxkaM7RawpTRiYErsL3TwpHx3
30853	payment	2132	2132	1874	1	1	886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsUuBqdwkjiSxxF8TC9nCogrNzxXR2gdfPeTuWZV7gjf8PXcf
30854	payment	1397	1397	1678	1	1	12320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEDtTApJ2ZnE2rKCsjy6hoTgb1MHF8qTXGFhKZDoieDzFKXsm
30855	payment	2133	2133	1874	1	1	2737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTM5Vt3nuxPqvNNdYAVEEh7EHmUWzugBXh4rwWFcndBXqe7Bc
30863	payment	1397	1397	1678	1	1	12324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa67nnfbrnv1ie1C2hq3fdYUKu4iTVYTQMd51ibfgtsvPceexM
30864	payment	2133	2133	1874	1	1	2741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyCWVnnWsjc1KCHyxk5yqp6BcjWHGhkipFb6FX31iK3B17J92
30888	payment	242	242	2269	1	1	0	3000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11hsD8Gz4qydHBfUSt7KNWRcRucEHh48xsKAazvVmwhgP9zTA
30889	payment	1397	1397	1678	1	1	12335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBFAo6hHnhLGCPZp7SgzNXbzLTWxHdhV6H1SxZqsKAMK4Y7or
30890	payment	2132	2132	1874	1	1	891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoa1j9c4ekELtnP5JZhdsvMqETFyUA2WmLFhph3E7MTCSGSHLM
30891	payment	2133	2133	1874	1	1	2752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdxAUKxmYGMVYgJBHpuYttjMJeXGA1Aj3ufBjGHGC3LHFE8Xe
30899	payment	1397	1397	1678	1	1	12339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6krNKPtTS281cX7NZg61J7wjC5QDNf7uZhpCkLjteUfydE3c
30900	payment	2039	2039	1445	1	1	1	2000000000	10000000	\N	E4YXduXJHkEcC5XreEX3NJXDUpsnt7dMpwyQuWdfL1Vu4DdwqCH4a	CkpZxi9qeuGn5fdycwDyiAe2RMLA8hkvmqW1TLmmFd5KQJxvNpetX
30901	payment	2133	2133	1874	1	1	2756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9g1Sr96kok9FrQ7TBH7twdAmPPd1jkCywV7mae44AJQ4wBU54
30902	payment	2132	2132	1874	1	1	892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa91CzJd3kqt3mVboiiebLcSFEjWaSqZx8idqFYe3izgv4fVixu
30913	payment	1397	1397	1678	1	1	12343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjETAT6y37qUFY5mDYUzfeEP8xbz2ehkXz7rTGH6BY2GRkt6R6
30914	payment	2039	2039	1290	1	1	5	8603000000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpYwx1H8y2fGPrNvFLGkkoef6qwGXe7vZcwhTnah5tNqvszDUTPq
30915	payment	2133	2133	1874	1	1	2760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4RLFjQN7MeVhVa97aPya1yL9UWNmnMhekoxMHDZZizGc6212
30951	delegation	2270	2270	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6y7n2fPtBDAGbBRzXcbGp6pixAM4VH8H1UbSwJdqsKPymAo4X
30952	payment	2100	2100	2271	1	1	2	3000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuuvuYtgP7dxvLETF22xmXZHMmABQyiouMnw2hj4dVinvWPpZ2
30953	payment	1397	1397	1678	1	1	12356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1SviRwSuQCjW4no7CLVAVLEAYzQWsvia7VHeiwQSBPJHBM9D
30954	payment	2133	2133	1874	1	1	2773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7uekzxaUdCNBrsmwwaZw728VTgXBqcWMsvrsBbWSHWMAxnmGJ
30962	payment	1516	1516	1168	1	1	14	1278313790000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbA4TEsLf6EE7Nqu2AQyxon8YuFoyCWhVrLerYVc1k7jt3p2r4
30963	payment	1516	1516	1294	1	1	15	3561956390000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLbfL5sciYg4pF5DYJwHng2n176fbx3aaMa6GWtFiUnmanPhco
30964	payment	1397	1397	1678	1	1	12359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uuzSRHQn8BFuGHcuifccXs9aoJGr9kqThUqgMCbCFjp4PSPT
30965	payment	2132	2132	1874	1	1	898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbagDrp1KMNmfhxpGBVwE5Z2TxZkaHgoweK3RpUfJHsfqKUUEx
30966	payment	2133	2133	1874	1	1	2776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEu9KuKT8CTjNJMQ8NGQTSamSmT3NUkPRYK2xi8VfeuZ8uXLYg
30895	payment	2133	2133	1874	1	1	2753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtM7XzKsMD6XFgoZtsU8SEqKNRg7AhSBQWGcq9uRyvHEypUue
30896	payment	2133	2133	1874	1	1	2754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaq1pFjgCB77nGfCnz86T9rJeBwhFXDdeJcTmYJgLQssbUQcCe
30897	payment	1397	1397	1678	1	1	12338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEk81D22REDFDLnjoWt7E4Zqx3hfbyEn42HLNnoR26315eBjPY
30898	payment	2133	2133	1874	1	1	2755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pPyEwSFi6iw8hyizb7PjeZPQgvoju9h2ye8T3EmVJEVJuhrR
30905	payment	1397	1397	1678	1	1	12341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKnoajt7jdva2hmPAzV6Q4z22LndsHBGMVKPzCUNJR65DSM92
30906	payment	2039	2039	924	1	1	2	2553750000000	10000000	\N	E4YhFUnrgdUs8tJxUbhYygDMtJTvRYGPBMQt1PDfqSo1NTXmrf3fX	CkpZT2Bmu8FJGKpmtHb6xyRBuyRcrTP1qFMymZjCteDe431Vdoefg
30907	payment	2133	2133	1874	1	1	2758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4zJ3wj3jmSQuS86x7ZEAAFn6cEfhccJ3y6SQoH2eJHbpSYF7M
30918	payment	1397	1397	1678	1	1	12345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvGP1xLojxksSFtPz74Tk4GBCCp1cjZeZaeX1EFLJG9nJP3Tg
30919	payment	2132	2132	1874	1	1	894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRNoAUwi2aDFm9ckE2mU4e3M5kKcdGhAhMYzzExwNdYdRpyBS
30920	payment	2133	2133	1874	1	1	2762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPuLDgZt2JrQyZHyM7rJbXThuir9ft4hkqT5KPGLPXWZDSVkT
30942	payment	365	365	2270	1	1	2	700000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFmmLXPp3jWwUh2QVGU58sTz9Jg9aicBy1he3UChQCjYfnC92
30943	payment	1397	1397	1678	1	1	12353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyNA2rsjbJ6tXqiQ3fDynYdWQTyoNaEHW4dKLQiSEe7DwPvaZP
30944	payment	2133	2133	1874	1	1	2770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ECmThh4cCfkrnbTPmotJzsKneKJv6aNkqjN2BzshWvYRVsV3
30955	payment	1397	1397	1678	1	1	12357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASZss39Z5Q2eGiYKAKSxjYdr2pwhbnC3mcamJ5XoNpHuCtcY7
30956	payment	2133	2133	1874	1	1	2774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7NVM1BetEKHk1t31p8PS5F4on6mSvDASVWivGvSVMMUCZV8yi
30967	payment	1397	1397	1678	1	1	12360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxheW7cPcyGR9TCXavBuAM6rZDooA2giuKgCkYppDTMVvBLG1
30968	payment	1397	1397	1678	1	1	12361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2knusNi3XVoMWoSMLs31AYExX6NfVS3y4FWYFoYQPJqqgP1J
30969	payment	2133	2133	1874	1	1	2777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG1n9b7GuWfpoWvNGLXihFsbvW66HoN898dXxhkFnRjnjMsaqx
30970	payment	2133	2133	1874	1	1	2778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjGFyEbuios9NMGK1x2FSBnw31Yoo4NGvT9SfbDuqQoHbG2ey
30981	payment	1397	1397	1678	1	1	12366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzw6XSUn2sqzoDgxdGxwNpArA1nAXnnUnHT6QVCetQChZXNBP
30982	payment	2133	2133	1874	1	1	2783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofkKi9frCqKUn1Ch2noDFhHycsWkkBiYkBiSdd5LQshexCrGZ
30987	payment	1397	1397	1678	1	1	12369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPCEE3mxttr7TamKuYPZRvDsdxWQkncUei59FUavSmngm6vvWW
30988	payment	2132	2132	1874	1	1	901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQuQKB8hxJT3oohV9CNhoXEyo7dNoBPRq1kh2BkPNQijNpZCo4
30989	payment	2133	2133	1874	1	1	2786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zjZgYpmixK5iFAveKMyvjsNWzoPpZftF17upog4sdBujvvSR
30992	payment	1397	1397	1678	1	1	12371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgAiF5j11KWB6aJYNdXWDi4CsVtajdFNCPwdrJWZNM624GvfP
30993	payment	1397	1397	1678	1	1	12372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJV1wTvPFDhrE5mFyyexfuzQB3PmcbhqeHcAxvCX4RdnEDy5xJ
30994	payment	1397	1397	1678	1	1	12373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuWgWdTHH4tXgBKw8r9tvs3NWQQiHH9XX31V4q3PA9M8Cw55S
30995	payment	2132	2132	1874	1	1	902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgTWLATibXwLDsmJFe4waKxR5g8MKyVztschYyPunABsyKQNA
30996	payment	2133	2133	1874	1	1	2788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17pqQzdfmuX1fL8qr4eV15PfkcsEr1qb67cxrTigSdeqWsGKE
30997	payment	2133	2133	1874	1	1	2789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT2WQ93wJUfgeN3Xuc2rW5rsAWm8yN9nz2XaSGkV66ug83ZE6
30998	payment	2133	2133	1874	1	1	2790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1tzMPDZT1ywfTNr2vWZMoynfC8pQuyVYNBZdSKyzn49n1qRF
31008	payment	1564	1564	588	1	1	9	468000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjmVTYBTPN4ozv9ejXuXomwQJo3gZiezEv8yPFyhpmd4WVhK7
31014	payment	1397	1397	1678	1	1	12380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWDEJngHTVqCzU5XMqi4Zf4eRKWVkprykTG4N8q14RhLcbLDY
31015	payment	2133	2133	1874	1	1	2796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhBXGpVZ7SvZiVUnKctk1YkbF5pDBJe7PuJtgH4fYEVqGE6QMh
31016	payment	1397	1397	1678	1	1	12381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXi4BZ7w36YEmgoaw1drFf13Ak2Cyr8TPu21NN1VDrJm1y2Sj
31017	payment	2133	2133	1874	1	1	2797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwRKNeWqLiyJGfspqWVr7pHgfmcnxcTw288MetwTwpNWVkwGr
31026	payment	1672	1672	2016	1	1	9	1328000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbHqFN2twVxeb9wAxNUwQJRKZfiNa1BtDd9WVwJEgqBw7W9Lm
31027	payment	1397	1397	1678	1	1	12383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKZZWYs7VWBBw1MMQCfX2nPx93Ap7HwJ1Nsq4jPcDEGTQxzc4
30911	payment	2133	2133	1874	1	1	2759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8eaWSdGCygR3psUCWg8DydLXc7U6q65qWMa6YjzcaKZiGtDW
30912	payment	2132	2132	1874	1	1	893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSS5vgzToEu8TKjXvF7oNTyCmRd4oH3HPEqbUm5B3TZwyd2po
30921	payment	1397	1397	1678	1	1	12346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CWjjG6JiPZmXpADMaNXGMAVYs39N2LypWCshv9LKE2k2gtE6
30922	payment	2133	2133	1874	1	1	2763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtaz172QxrZG8EaEFjvhHFc3CCYnABg2MkBcDPMXvNNygf3Rz
30923	payment	1397	1397	1678	1	1	12347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtn5WcGCNSSHvPuKkZ3yoHBTfcQy8BKSAiMUsFg6iB4RYjb77H
30924	payment	1397	1397	1678	1	1	12348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDwPtVRCP4xKH6bT8v5BLqDJdLP99o1ydGw1shEKJGy3u5YAM
30925	payment	1397	1397	1678	1	1	12349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaLRnEvU2auysodBjsYQY89hUQexAuF4vHokhTVMBvPCTNx6qf
30926	delegation	2269	2269	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaziSnZXyUa6ZoFbSMWLCsXggChvpDs4cmVLhdGb3EVsfKcw6
30927	payment	2133	2133	1874	1	1	2764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtE3dJMtNkdMV63UiJTV4VPc39N6S8EAUbpu4ZHHuTiTXUn429
30928	payment	2133	2133	1874	1	1	2765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUB96CRm1TfH3wTJY9kmdtRwxGvM9GsRW3894Z2DKT2VaUBGP7
30929	payment	2133	2133	1874	1	1	2766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriGizDD3eR5mpTJ3qAVezuGD2rHeaBS6k5LJs2thWq4RS3pNo
30930	payment	2132	2132	1874	1	1	895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFN3H2zSwfWJNo4tng5sdDM3M4dHKAA3MaP91FNxS4rgWBqfZ
30931	payment	1397	1397	1678	1	1	12350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL8NCix96VmkqyfKeuzDH6FcFr7TBGBuJgr62134MzGZDk83s
30932	payment	2133	2133	1874	1	1	2767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFf7Qci4EwUmG8ojPMtGvh8yZvnWnenQKenTVXCZ8bHSMgHuLt
30957	payment	1516	1516	928	1	1	12	1057268060000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9U8eJVxtqTCHAPJt5ToRCSEoz89pWJRu6VYgchVY7QQJ6np18
30958	payment	1516	1516	1048	1	1	13	1894536110000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6ARGwTRaNQf78GHP3PUEj5WB6EngHciQwqgPM2czGoS2QKKw
30959	payment	1397	1397	1678	1	1	12358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9p88bCJi1DiAHE1gBtiYnxS8TFLUtYBFvL2GtxcCJs7pQ49nD
30960	payment	2271	2271	2100	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8yxWSWXUpyfyvJZKjbqMizhGxnQSW7fqvHojS1NeihNCMmVHk
30961	payment	2133	2133	1874	1	1	2775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GXsVHrNDtdrBVunFiSc7b1xesxwjYCfVcUwBasoTWek94Qet
30978	payment	1397	1397	1678	1	1	12365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdZJLepoun2cr5EJpzNuxADmo93ncxE5ThBNNoBCrDsEEkvpr
30979	payment	2132	2132	1874	1	1	900	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpy2rqinXHcQAgPipPS7f29AempGUiG8myVxxNkA2bXjkguxz8
30980	payment	2133	2133	1874	1	1	2782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZme9aGNosnrYTjNxhm6uQ91fabMYhrgY4g2Gmp5J3Yto5GMnGx
30990	payment	1397	1397	1678	1	1	12370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQ7AziAux1ntMmbqhmLDjAc4urTm5fGSXPENFgcNJPCWmNPsW
30991	payment	2133	2133	1874	1	1	2787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84QX4YepcHaUqTD8YHViiYkz6bsAvwgtDf5W9ArBRuyTFDb8b
30999	payment	2100	2100	1958	1	1	3	1432000000000	30000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9CmsfBnTLQevpwwHrfonNPV6c4jiBPcFwXkGbJNcdfNJSLHz
31000	payment	1397	1397	1678	1	1	12374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcge73gAAricBdNGrLDiwdo3TPrhaVv2wkFeqS1gWfQUQGRMHT
31001	payment	2133	2133	1874	1	1	2791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAx9Bye2pof5Yt8c33TUrWZpQ5H6Bu3gCSWLSyjsdygXaNXsL
31043	payment	1397	1397	1678	1	1	12390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiWEQbez39thhWN5NsNfbwSci1JReUB3g9jX31B85nEnkeAPA
31044	payment	2133	2133	1874	1	1	2807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWfPS3CX3D4DMv1hasnBQdMjCnWuBUzGdJmpehDLVUAsgUUpH
31050	payment	2133	2133	1874	1	1	2809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7F7e9yk5Er7qzJZ4BjrQhjL7fnh9iodeymqteLdEhQBpueLN2
31051	payment	2133	2133	1874	1	1	2810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYMqyTWe32nwX3Nqcqbp5Hs2NMzgGZtXE2Q9XJQJLcJHxk1Zc
31065	payment	1397	1397	1678	1	1	12398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoz6cNPbDqL2ABNEx16UZtNt5M91foiWtqgBxwqaZ8yG8pWru
31066	payment	1397	1397	1678	1	1	12399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftciFsps2hY8DHnxnH3CZheQDoKVNTAmNsuemUGm4AxzPaP1y
31067	payment	2133	2133	1874	1	1	2815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjKyLf2sdzvzEV4rAZrdNiMMB871iUxu1zsAk3DA5vzsdwywZ
31068	payment	2133	2133	1874	1	1	2816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5Q8vKi4pzWLrqWbJmfBczJA7YbSRvnGXZFwSB7Ju7d3VhxEw
31069	payment	2132	2132	1874	1	1	910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKeXSb7cTxdH7jSkTJsLmC6FT6n9X7smeS9URwuLfN1skL8MYd
31077	payment	1397	1397	1678	1	1	12403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ouBP27qso2gDYpFYqLWoB14qcqKB8fMfsMfZd914d6P2vcS4
31078	payment	2133	2133	1874	1	1	2820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeza8QNEvBYMsqv1TfHC6pkimiSvZM62gdVvmffHr7NQXiBjV
30933	payment	1564	1564	1338	1	1	5	6145000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmzNu2hcEvNTPq2ZrzzHWMdzdpexGED5DbF5irEF3287iZ3m9
30934	payment	1564	1564	1092	1	1	6	3268000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYni9JBHcC7M43LDf6aGVYWVwzRCQkZB5ND72mytLzMQMyhCfiz
30935	payment	1564	1564	1212	1	1	7	2205000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcRK6vEf7VkjG8aZ6XN3U9FpWW7EJxV8pSMDVmD1ugvKavoh8
30936	payment	1564	1564	972	1	1	8	1462000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTpe7QTmUyBBam2CKeMX5pn6Q6kBaiJuHWQo6hQ1HcEtbgu8B
30937	payment	1397	1397	1678	1	1	12351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTD9FrC4eLmtWsePVbNAVgtneTd2K7tyBEmdcwdgxzqAp7QjP7
30938	payment	1397	1397	1678	1	1	12352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYc5ZW9gmTrac5sddafRsgqm1qfTgSdv2s7Y6xVP37rPGiPCW6
30939	payment	2133	2133	1874	1	1	2768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ivCK7jWzwwVmGhatcV49ySXurHibMvUdqDqAE5g1WzpasrX3
30940	payment	2133	2133	1874	1	1	2769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kCEmCyrYJ3w3fnpPyjWbnLk767htSBdoW9J1ddSQUxEPseFc
30941	payment	2132	2132	1874	1	1	896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GLL1p38w4pjGHT4FR3YCLwpAUTyPyieXwWhj7r9o6LpKrE51
30945	payment	1397	1397	1678	1	1	12354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvheXzPwReKj5MBnGSE2y6xDWSkE6cYBeWmHxrfPySX8uJJCr
30946	payment	1756	1756	1516	1	1	5	7792474350000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmhVPjUPs2aqPNminQfkSNc7TXk2QMYumGC6bJzjqftRp3Yno
30947	payment	1397	1397	1678	1	1	12355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEXr78Cned2SKwuuegDc8MpBYA71V2Keib1Xd1faFPMfqh7NB
30948	payment	2133	2133	1874	1	1	2771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYd2aiTVVKoQm4Ewr8iQKMNu3F5JTYjegi4N7H4PizGtHPZ8X
30949	payment	2133	2133	1874	1	1	2772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw95wTQb9oz6hJHcEzHULnQ3YvRxG8QhdW1qw7BxqJXjgKHicK
30950	payment	2132	2132	1874	1	1	897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZSYwwUErLDFinUHrNH26fKSq3Nbv77KBtmTgZjffBXnbUykG
30971	payment	1397	1397	1678	1	1	12362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzWjmuPJ5ntsrcmxzEiRc2zd5swLYkFvywMh8bFZBb6hHrFc1
30972	payment	1397	1397	1678	1	1	12363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58H4p93hdBMwWFPAjJp5e4R3E5TYYgFAERccwJLwxMJYRirnU
30973	payment	1397	1397	1678	1	1	12364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYithPLz8oQBBtn1E42X7SQqWYVoMvHHrm3x964oSmP9mVuQncT
30974	payment	2133	2133	1874	1	1	2779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMGsswRuNPYDEH6aFawQ8tx2Dy8sx8YP6waMCyjNJLMAsczxNt
30975	payment	2132	2132	1874	1	1	899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSgWEkrG1wtPrhp3B9buRk41Br3i94cz13p19fRVCdVs8QgGU
30976	payment	2133	2133	1874	1	1	2780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaoDsxRgSJSVDDra65gpJmEWfAG87aGjkwqv7YjYoZvBj5SVn
30977	payment	2133	2133	1874	1	1	2781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5Wte9om5QnkaEeSk7Rs4vYV6xo64Nen4gwHN3U5CXNzZu7Ak
30985	payment	1397	1397	1678	1	1	12368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKUsgQirMskGbNGSJsaFzFEYRGrD3aTsDUa5sPqcgRcThgJzo
30986	payment	2133	2133	1874	1	1	2785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCSEYy52ybxFaEur3Hw13g2a7v9L69daLveAPPAkryhXsA6oh
31002	payment	1397	1397	1678	1	1	12375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdr1aUu6Ls9qmXLYUsWV9hbXS3FRvavVAkEdzuAKEZC127gQU
31003	payment	1397	1397	1678	1	1	12376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4iBVGNAFgB3BNZdUYkueEJNmDrDTZi3U3W1xD5DanuASSSTZ
31004	payment	2132	2132	1874	1	1	903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5FocFu4CUNEY2Ak2UoMEv5rbofornB9NhQMYREg5J9FZmXGk
31005	payment	2133	2133	1874	1	1	2792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYinH8Rr7NmtCMSUeCqWuetkzrKzbyEzKasbs1mHut6AaC3VLct
31009	payment	1397	1397	1678	1	1	12378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7qgU74Q44ish4VNA1NApEUt2EEXN5UmqpoUrJww2Yv3CjqD3
31010	payment	1397	1397	1678	1	1	12379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34WXzqh23eHQBNguBQv4pcBiv8sh9pKuWHLgjG1i4GfJkgzRY
31011	payment	2133	2133	1874	1	1	2794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgkpAp4vgZaENkTCdL2WtNQHBZhxwpMPFXieHpcZkRFkRXhFN
31012	payment	2133	2133	1874	1	1	2795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDkv2eT2CdEUkLQmoKi13K8TDVjRcrCfdxJSGbyqx57U6bMnm
31013	payment	2132	2132	1874	1	1	904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCMVEWTsLsMA2K98k8aeB4p5N3BQWcDoeqGmaxUUFxLKY2c6Y
31032	payment	1397	1397	1678	1	1	12385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSEvj7j9VW1jjhQhWvv8CHkVSSqYSMRZo8sHGgq8j7coNDztr
31033	payment	2133	2133	1874	1	1	2802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZFG41B5r4tipZWhWBS8kKwRk21px8XYf2iV1RXBhnrUjXxEF
31038	payment	1397	1397	1678	1	1	12388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPskdEK4Fvff6gUvHC5PkvLiA8MGVvkmTw4znhAkVofJyDCqE
31039	payment	2133	2133	1874	1	1	2805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEc5KJpCFhNJYdCNzLemxCqQx7LVfQMCuuVT2BZhHSwdU1oi2d
31040	payment	2132	2132	1874	1	1	907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY5XoWQ9Lg2ZP6cuHw5s7Jg12T7Kk6vV6eAJRwo4XQVcefgi36
30983	payment	1397	1397	1678	1	1	12367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp13ENaxC2bi2qkJxGKkyWVrhaUdLVvUqScjX8LV3GCmvYtGsZ
30984	payment	2133	2133	1874	1	1	2784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXHm8rsJEocp4q7YFMKHgHxbTcfXWSSkDiSU9zKTmpood95pi
31006	payment	1397	1397	1678	1	1	12377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsY1kQR2i5RoJL8TEN6QZy6V2NtYtRBxuyxgThA7Rq4yshUHXu
31007	payment	2133	2133	1874	1	1	2793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9JhwGGRK6s4N5Hn9aRvJGVXafXJNs4piiqH1NEActEEwLqo6
31018	payment	1672	1672	1285	1	1	5	11571000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5KzdrPTeyrCJEnT7ssfZG2oU3jVKSY8f3GBWx6vKLwe46KNs
31019	payment	1672	1672	1039	1	1	6	6154000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRjxLeST5JZbZZHws7GGQ6tbiQftNM8FWDjQ1nk4aWABV2HtS
31020	payment	1672	1672	1159	1	1	7	4153000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4ySmp8yGopJ9wk2bizvrnQtTUWoE1WPbvWPy6QJQW8SNSJET
31021	payment	1672	1672	919	1	1	8	3435000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTz1Qen2LaSLbJQLL4vEJGfrdGsEs6Dk6kASsjnZsrJRw3Mrrr
31022	payment	2132	2132	1874	1	1	905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuWapFwcJyhHj4rPYrfN6MxMT19rJj696Tqoph7nkyJu6k3by
31023	payment	2133	2133	1874	1	1	2798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2GSxBVboGW86of7by2sEBBRxhc71f1XsoPVYuABP5PiHUKYq
31024	payment	1397	1397	1678	1	1	12382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGzS9XHdbyqWtpnqLXh6QgLJLxKrrAgzUEtVBea7A5aLD2siC
31025	payment	2133	2133	1874	1	1	2799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkVYuVE9KVY1HMwG3N82kZV7GmQ7pb8gHjDZXW67HR3gVQncTF
31029	payment	1397	1397	1678	1	1	12384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqK4iR4dSB9LbpAmzwdwdrVivj641Jttipzp28pbAmuuTf57z
31030	payment	2132	2132	1874	1	1	906	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjQqFQ5sEx9Cjz7VqTCFgtP7Pc7rvukJG1Fa2fuRqjJme6G4W
31031	payment	2133	2133	1874	1	1	2801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqbiRwqWSwKBqYywMxiFwGcbh7hJpnszw89Pyq99Tz6PgkiPK
31034	payment	1397	1397	1678	1	1	12386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsVjb4fDvbiTth7b3Dc9WT4kk5MYhZgtvLoAY6n7X6Tw7BSgP
31035	payment	2133	2133	1874	1	1	2803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46365xszcDQ7MjSPtQiWosjNGiw7V9PqQo77SBmPqSNZ37VV1
31036	payment	1397	1397	1678	1	1	12387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSsm65VKmwN5eVNvmH1eBuzbVVTM97NSpyo8KzmY1HaoVJuyH
31037	payment	2133	2133	1874	1	1	2804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQX7NQqJbT9zQaqzXVFQBcYZoVJz1kwqxjvWmJgyadoAFLQRq
31045	payment	1397	1397	1678	1	1	12391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uKE7z6S2xA289hbJ4kmuu3JFCNZKrmMAwq4c3xtCTT9aQZ1Q
31046	payment	2133	2133	1874	1	1	2808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYY1Rhv9yezcmaaRAPsxJ2Sf1oCVoC8sUToUAqxt7MHz5fvXq
31047	payment	2132	2132	1874	1	1	908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpcQJTA9o9qbQgzQbFP1F4cqSWCjM8E4XvYPuU7BDrLQjtn3z
31072	payment	1397	1397	1678	1	1	12401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUN3yR2nTPgpSEipiqZxEmvf2FgUZmMbBvQ33Ur5fY489orvA
31073	payment	1397	1397	1678	1	1	12402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPBJbzK4hR9cMUsVanFSVt9xGWMgv7iGKH7fqzWsPy6xka7VM
31074	payment	2132	2132	1874	1	1	911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JjxRQnZRforTu8EGeh9VQCk1qhvAMExHJoxok3D3CWBCo3HB
31075	payment	2133	2133	1874	1	1	2818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVwYkkqEEzMVHuqewcNAxoxaje8svV912ncXQkxiTHsHaZwTT
31076	payment	2133	2133	1874	1	1	2819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipecBbFKN3vWWNeoZHLbkX7TKDosDS2wffiqF2mvD9BgcaBhK
31109	payment	1397	1397	1678	1	1	12416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrtyLDfL5K4Yorj9ncRWBoaC95jG8AbmfTTuSkbAFaUZjEXkm
31118	payment	1397	1397	1678	1	1	12420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFrAvY5EDYN13s25pZ6WRFW6t9y53bZtWqjUCn1D2UhEF96NR
31119	payment	2133	2133	1874	1	1	2836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAayUeb4be3UbGji5pPXbHEZZc8kxa3GzV1FeZrEcGRsakzK3
31138	payment	1682	1682	1850	1	1	6	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcWkDkbvBV826x46tYiMGEp4q43cYofRZ6ijykusfMHESuoPKG
31139	payment	1682	1682	1850	1	1	7	1000000000	10000000	\N	E4YZaehXjmA8VjXa7Y1uHa7djBifMPV9GTxWQphJnnfFLTSCg12FE	CkpYq8xn2Kr787pCEzYrgBv3y863mgvMXk5uiRLo6Z241xiZNFnmx
31140	payment	1397	1397	1678	1	1	12429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxfXT2YCA6amhtPwiDMd4jSJ7VgYZFjbp21oAQjJ4JKHi6Xy4
31141	payment	2133	2133	1874	1	1	2844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfrJ2b7SRjsNJDzLjybHC1wyayG3VD77GNHHLRzHYMPwTX5JP
31147	payment	1397	1397	1678	1	1	12430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bgkuJFvfjBrQQ2VwJWvFLULrP9AHxquyLhhN8bqjmiyeTnvR
31148	payment	2133	2133	1874	1	1	2845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MRKCsaDWNJHcDP3HQMm1jDYNSJVbXLTRqKdFtmmX5uRLhYSN
31161	payment	1397	1397	1678	1	1	12436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqiC1NZ9K2QR6mh24UPro5G7okmyNr14CydpmntWen7Jbv5hGB
31162	payment	2133	2133	1874	1	1	2851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSfwJHKKjMSxa98tHzYJoJzau3rpvuMQRuemTVK2PZ6bxXvN4
31028	payment	2133	2133	1874	1	1	2800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qesbZ4kPcg34ec9GPraPb9odqmpGsygwZh4GKmSBTgcCGBt9
31041	payment	1397	1397	1678	1	1	12389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwPPpqih3x49LPrYahBeeQPkwyjraNo1pAZxeuRo5D5JbRAhF
31042	payment	2133	2133	1874	1	1	2806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84nizRWbwoq5tMTdbenZChSA3ZzBysb1exXd3FT4584tAb6AX
31048	payment	1397	1397	1678	1	1	12392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yXdffprd8M4zXqidVccS9jkb1qqEqexSEBE5PFLyr1YTcYhJ
31049	payment	1397	1397	1678	1	1	12393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPEND8miEAY35cAFaWRPZrkDcqYrY4MvRZALvCwHePsL7XLpM
31070	payment	1397	1397	1678	1	1	12400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnHVp7RSZLRnie75mkEEZn86s8exRVvdnLgng3iScEqbUit4m
31071	payment	2133	2133	1874	1	1	2817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGKpUbDrVAFvGJx81GThGEiVSPiEAQY9e9HjTUhgXGqgxuMnB
31082	payment	1397	1397	1678	1	1	12405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPK1hagqjbsqxYEvWDMt3Nmeop743SbymgTLyC8TAVUH4BH2y
31083	payment	1397	1397	1678	1	1	12406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehh9YadpSdngck2vtDHm9ieiCxY2SifB6L5K51tu4q8Z65S2h
31084	payment	1608	1608	1289	1	1	4	8295840000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMMFdesq7gg1W35trK4zVCZ5kib1aDyqxC9GXL2DXghWKvjxM
31085	payment	1608	1608	1043	1	1	5	4412290000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8K529X5L26Jx6VSJ5E8aXBJ4cc6xTWmfxwDsvQbMyEMQcZ7hB
31086	payment	1608	1608	1163	1	1	6	2977060000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeA2ebSdtBgseZo5UBUn7TmEJ1H73Wh4TM6wLpGtHnUjJF235e
31087	payment	2133	2133	1874	1	1	2822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyeeWchLCb6pi8dioiQr9rYeDLyaZYiCQ29vpcfebxwiTue49
31088	payment	2133	2133	1874	1	1	2823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5vouaB5enNdFtD7UvgG2WfKb1pPNujTyQLFNmY1JHSUStcCM
31104	payment	1397	1397	1678	1	1	12414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTej8SFSucAhqpS6AyJXb3zTX6GKRf7wbAkp8LipjRUvhFoiL
31105	payment	2132	2132	1874	1	1	915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBicpLqcs4jgz1y38Gh2kSUsWLMNjKez8VHAeh8UGWnTD4ksm
31106	payment	2133	2133	1874	1	1	2830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWwQVYFXtcQem7cCgjAwecT4QPeXkULnW6VMnHAk5iasuZtAeN
31131	payment	1397	1397	1678	1	1	12426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRoYwL5qTwbRng6eAPd8xgh3HJp38j2os29sqLaufCgwgowoZ
31132	payment	2133	2133	1874	1	1	2841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22PWzNzh8PB2w5KaK7ox8EPb1dg6VgBTwnK7YzFqod6ysyhKn
31142	payment	1850	1850	1277	1	1	5	8203400000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpZbC1hs3pfwypK7RP8imUAZk43hzWYgkjs9UpW4y6s8tuYc73Xb
31143	payment	1850	1850	1031	1	1	6	4363100000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpZYPs8hvcZA9QuiB6ndwbRuD4w9NWVtu2MAiCQSnRYgQXsXD498
31144	payment	1850	1850	1151	1	1	7	2943900000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpYeknPCxnmhZmaR1MzYVMzXdUWuhL2ASCcQmLWZFG9nnfAoEWYW
31145	payment	1850	1850	911	1	1	8	2434800000000	10000000	\N	E4Z6YdLL8D1GpeCHYawJAfQ9hjoJXMJy65S3ChS7J8UaoZMj5Mh4j	CkpZc6wHKmFKYpHPc4tfMAzQ9VJv1yrLXb83tmUH3JmHAHHfVn17B
31146	payment	1608	1608	923	1	1	7	2462230000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzcGAeEycz4Eb8Jpc3nh6Kkpu9RPg8L8dncWg9y5o3JNSFMei9
31149	payment	1397	1397	1678	1	1	12431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxt8tKmooZRETkumCXBCKtqfd41uXpNgDLM8hCyChkTzVwsFeN
31150	payment	2132	2132	1874	1	1	920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rMfuJaMHDYarGHqjUvsMGx9tf5nhDtupaUsjcZi6wtdPA6ia
31158	payment	1397	1397	1678	1	1	12435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6v5932dJAYXSVXbvceFDnyqYwAEbfycrFMbwoYwgP6LuUW18
31159	payment	2132	2132	1874	1	1	921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ566uJ481JuxouvKrbsM5Dp9hLdZdz1TtwyS8UrrNYrccXQZJW
31160	payment	2133	2133	1874	1	1	2850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzRRUSBMZC6k5xscT3rJfrJBsYg4HYXYRTWdhc3tBKHWooi1q
31165	payment	1397	1397	1678	1	1	12438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfBqVG8aNzXiweV8X7tLwWkLe6Au5s7GVzUY8yTNU75q4a3Fbi
31166	payment	2132	2132	1874	1	1	922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR78UmzchABd89CHVTQSe46NDyYEnPKQkwEnddipR33X47N5Xt
31167	payment	2133	2133	1874	1	1	2853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHytTVwqsRixkM27GpT4mEjM6zoGdv2a1oGefvpQHe3AwpKXS
31168	payment	1397	1397	1678	1	1	12439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTewhRokiqYBhwDMGFNkVBHpQzQC2skVVV2D8ixd5t3YYrQbp6
31169	payment	2133	2133	1874	1	1	2854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZad99ii88jothHpjgK9NJhUUkSmGRbmuqrrMCivb95FzUH5MFC
31172	payment	1397	1397	1678	1	1	12441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gymCGANFzASxTHtiRneu2XpyN6fuqDVAqEAtXHHrn2gvjRbU
31173	payment	1397	1397	1678	1	1	12442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPnarUeLsUudqZGjwTGrRea27icSeud626nDELuzAS8uWPnM6
31174	payment	2132	2132	1874	1	1	923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRzXQfZDPFGPjkxoEoXqNKVaDANgWjp7ikdDnRJt3S3Esy95h
31175	payment	2133	2133	1874	1	1	2856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK47M7gJaGBe4MNmihQ9YV2yz3hYAVF5Vtp9kXcR74ccU6pXTK
31052	payment	1714	1714	1300	1	1	7	6528397663348	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZzGqw7tMKw9p6A1mJUZSR6xDaeP1cMDkkLwWg1PHujySbUxDuu
31053	payment	1714	1714	1174	1	1	8	2342791801152	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZnJe5zMFLWmJEaoYZhDG2PzheirXBLxLHcBiEid5RKfrQNCnzm
31054	payment	1714	1714	1054	1	1	9	3472243384940	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpYrTtUiUqvRxCfsaBSfneKduAxX1WT2gytBZjhr43xR7NzpnB4H
31055	payment	1714	1714	934	1	1	10	1937645081856	10000000	\N	E4YdDe6qCZirr77KiQGupV2tRFqXvK7bLPobwFSUiwGLTzCt7c7Eo	CkpZSE48FQLyPzdLbEEpdb9UbdnanSUUVznCVm2E9HKXrABn58fQ9
31056	payment	1397	1397	1678	1	1	12394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2Um2vua6Y5y2mshnRsp3r7UcLKPpA2m21cRavNsubLRsetUL
31057	payment	1397	1397	1678	1	1	12395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe9s7pFKRUzUxxnpEi4443iWCiJKry74fxcHUrdDymWeBdo2H
31058	payment	1397	1397	1678	1	1	12396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5yzwgjbCQfJNYGhDERaxPH5QWNGTSA2qRecYX7KsLGvS4L6T
31059	payment	1397	1397	1678	1	1	12397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCbG4osb946SoqgZB9nH3MbeyuWiher13pxxTnZ2Xb9gbwDpbx
31060	payment	2133	2133	1874	1	1	2811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsQvMc1fhY2m4XGNGEkWFyFCHu3TKuWCiVFPAqRgUVftNDzcnc
31061	payment	2133	2133	1874	1	1	2812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iSbdKJQDjVb8ZNWffi7AjCiUrV7BZ9kh4BUUw3w26MLskX11
31062	payment	2133	2133	1874	1	1	2813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWzHxLNvRDLeEjdSaQ1mPk118yLhZirrQKa5hhjCF3mGg3YPs
31063	payment	2133	2133	1874	1	1	2814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk99wS6W4BtL8ykzxcbTUkEuHJckuPV65HMumFyQ8C5uBxm95V
31064	payment	2132	2132	1874	1	1	909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEXuGRp6AYpe3Y3vhy8nj3YTNGUmuaBXMBoZBFMNLXVQ1pLKa
31107	payment	1397	1397	1678	1	1	12415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLiMAoG2Reyur67JhdUx2zX8NbXjNUCbNrHHne8EFjjYrqoNa
31108	payment	2133	2133	1874	1	1	2831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCsP5n71wPtqvHgBs5v8KBfGQx6ae3ig3RgeqNFDRU7b249PC
31113	payment	1397	1397	1678	1	1	12418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hfQ17BXKWYS3CKQe8u5CnhzihSTgWL58qVupskynbQUo6q6A
31114	payment	1397	1397	1678	1	1	12419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68iRdFuMPz6jmYgcwzSa5WqohNtbN1n88Y45grBqbDtGaF1tK
31115	payment	2133	2133	1874	1	1	2834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoir1FTUxkhvchgY7EFhxbtjo4nJdAGjepfXFqHtXLdLzGiBW8
31116	payment	2133	2133	1874	1	1	2835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgmux8WH9TfUkGygB2MNpydHjusfUnNxpLNQWhW1qYeWx7rTb
31117	payment	2132	2132	1874	1	1	916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3guaMGiJ2Z9stYZupNZesfFnHm517EDmjHLxMpHxYvLF3Sbo3
31123	payment	1397	1397	1678	1	1	12422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtPLe5uoeV9fw5buMvxPd2noy8EJZmCurKrsri2FQZfKrKcG2d
31124	payment	2133	2133	1874	1	1	2838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5NRw9dWNHku2HMnn6UXXStVXSkoMdgNMPDAvZDxobvC7Hqenk
31152	payment	1397	1397	1678	1	1	12432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbq7GT3KYxh4t9UEKW2dXuMZkvuhq4YxU7G74GqmkGJL8p5KZ
31153	payment	1397	1397	1678	1	1	12433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUfJiRV3CGFKqCfbT99ppHtMS5iAKHzJEWTzY9czmVgvxgLYo
31154	payment	1397	1397	1678	1	1	12434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeC94fUZ1NEGeUCdfrt1J9Ce3fLkNAiDMpeREooB1eyy1L89SE
31155	payment	2133	2133	1874	1	1	2847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FMSg9Psw28k9UGFr5171hLn5kfdFDVKJAdEw7AveuKu1y4NQ
31156	payment	2133	2133	1874	1	1	2848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtjzgd7sdzBjikWo4QaeXPvrs2wTtFNh943kHhgdH7LaDoNbM
31157	payment	2133	2133	1874	1	1	2849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQ8mcKxTWbH8yZjEeHJKQqBSbe73yRAC43j7F3HYdaSw3Q1ap
31177	payment	1397	1397	1678	1	1	12443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiC83q5LJbtk6moWU9TtcAnwBfykh6L7g2zDR724Kda7ftdVZ
31178	payment	2133	2133	1874	1	1	2858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uL2dXMqfM32aaf3h9u1fUw3tMgR37V7vHRYjiawYX6oCyts9
31194	payment	1397	1397	1678	1	1	12451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2pzHSZPJBuFYSfy1i38cLvMGFBwgqzGwbgMcp3hW8RRr8Gze
31195	payment	2132	2132	1874	1	1	926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipi2Hh3gTYTGmvScgqrbyhvk5vjrRVgjuK1Um3QzPGp9fKwnr
31196	payment	2133	2133	1874	1	1	2865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Tn2vWhXenYF5fbSMa2w5zh1HAPG8qTQx6ToS6tN8Lr9TNq7E
31209	payment	1397	1397	1678	1	1	12458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojoJ3QbT24xzQ3os7eaHiLY9JQCfffsNAUrsxGKnXzhk2p74S
31210	payment	2133	2133	1874	1	1	2871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3ezjyY5CFN9nqGtux4UwzfQycScUgWMReFD1qSDMuo33CajW
31211	payment	2132	2132	1874	1	1	928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwezpvmbztKjMCk2ewzyhsbzgbJrUiZwUhT2ACaX6BkfwinBmh
31227	payment	1397	1397	1678	1	1	12465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhQHNYH6gSSknaJjPTcJRbViCLnKbVtReUjWvWb7Vrs6XA7tj
31228	payment	2133	2133	1874	1	1	2879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPNSc13QcwwWE7mpkEHidrFHeiUPkXSd9a6bsgSBPBUfmPTHr
31079	payment	1397	1397	1678	1	1	12404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYro4sfiWKFwsku8gYK7f24VMQvRsPoAx3NaxHRBr9QzmgednjN
31080	payment	2133	2133	1874	1	1	2821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU3NPAdQZgvyzBY4fWwSdE2VBYgb68zkEj3nzAsq7CY9YXSKU
31081	payment	2132	2132	1874	1	1	912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBhTwwXjCt6E6ECM6ma7XCbGv47N8eCUJFhsXfetN2eNQbpMe
31089	payment	1397	1397	1678	1	1	12407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAKsLsrzb82dR9dtFvfaSJKvQoV8cRYhZ5CFWo6JAD7q6MJWR
31090	payment	1397	1397	1678	1	1	12408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdX72PqmeKhQGvXurfBXbAF5qSAKAqNsUJnJ1aWfkd7RT3fMes
31091	payment	2133	2133	1874	1	1	2824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5a4CZ1xmisGiNX1qj52hG2TQ3Po7Z2omAUiZSsCkGAQ2DA8vi
31092	payment	2133	2133	1874	1	1	2825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJYeibKbz9MoP9AVDATMY69QZxqJFMVcZr2QBpdP24rTHkkFYa
31093	payment	2132	2132	1874	1	1	913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWQAKMGqmwBs7zCChiCk4wQPSWFBmR4eZ8en67Um6gsw25xtt
31094	payment	1397	1397	1678	1	1	12409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMieEdiz1vr1CRojVw2ndGuPyG2KLuxCCEDFdmzcF9MJj9zCh
31095	payment	2133	2133	1874	1	1	2826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvX9qgiDe2jTjxXv8qSqCXvANhFQb55vGQm9Yto98ThVoXFzo
31096	payment	1397	1397	1678	1	1	12410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51qy4M6Uep8xhpxGQZvoCZefaGNTofC3PHsCXdEUwBfLGXSHD
31097	payment	1397	1397	1678	1	1	12411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCf1sR5t6JUrtQspogonkLnhLTVMcMQGHuRwLKjKH3qgJEBB7
31098	payment	1397	1397	1678	1	1	12412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ29mwQMyq3ckhLc2XRkN5NvgZC23K3NoqxemsJMkxArWt7x1zY
31099	payment	2133	2133	1874	1	1	2827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpPuXEyyh3e2ubyE9A5SHdc1TWYxb44pyt518tndpSURX7mvu
31100	payment	2132	2132	1874	1	1	914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuEgyZXBSVUf9561feNLcHLmPNWdUZ99Xs31hj2P6osbyk5Yf
31101	payment	2133	2133	1874	1	1	2828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FLKkGX6fcQAPaCGGdCzt9nvoxog85vzCWiJmaJ8Rd1oHaFa7
31102	payment	1397	1397	1678	1	1	12413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyouxhV7QVTzjMB7hJvSYYfhRwbLCismkc1Lvn3xp1UfGzVKq
31103	payment	2133	2133	1874	1	1	2829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14gkhTzRZ338pPiVt4BLZbxVsCEk7Dn6GY7Q21K6bsXuDmHVm
31110	payment	1397	1397	1678	1	1	12417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXyj2xrRzAW9jA9qrEiyxuVWEunwBu15LmVJgVunTWVQBwWGP
31111	payment	2133	2133	1874	1	1	2832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhpJVTzTkspo6RsKXDYQo56NzrWx6i6o7EdTtyGKzxJN16cBY
31112	payment	2133	2133	1874	1	1	2833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9T74pRamiDbfPhPmrfDBAevgvvGa6EhAMecEZ7XaSgwyy3uUu
31120	payment	1397	1397	1678	1	1	12421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHq3fPEYiiRMuwrTVXuE35UVPHhVX3ebsgV4MQaLF3ZYp6R3Q
31121	payment	2133	2133	1874	1	1	2837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcQGTh48hc8vPaZF5sfM5mZmFYjxmzDL8ujukmSAhhD8h3WRTM
31122	payment	2132	2132	1874	1	1	917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDDs9UY4uCzDMzua2B9TraXX24ruvYWNKHxLJRke3HuhBTeEH
31125	payment	1397	1397	1678	1	1	12423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdRPaZPRRj9ktg7M4fxHP1L8WWDXdakz4PPhbRX9h9BABa2cu2
31126	payment	1397	1397	1678	1	1	12424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZBLSRs14YBWuGY6HEpgW5dgAphnWBSE4BaE4VqVA917YtMm6
31127	payment	2133	2133	1874	1	1	2839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dyUdoxn4apBneoP3CStkRe8ZxxYS5hj57DeSqPR1eDjxCmbE
31128	payment	2132	2132	1874	1	1	918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3n53YkqPnoDYNYRZ56hZzE81wDnhPwTVrkbkwNK8GDWzhgnz
31129	payment	1397	1397	1678	1	1	12425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYRNpibRMARmvG7v3a8T7BbxQwaYTNhX7faqxxXLL5GuC4CfD
31130	payment	2133	2133	1874	1	1	2840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmbVMxJEy6pZnZsNWrA6w6GNymbpoqN7bToPFvfJxUaZ28ZFh
31133	payment	1397	1397	1678	1	1	12427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSwSWZK5Gy8zu6x7yXDFCtixTbWzUzoh4ee9wVq4TMo64veUS
31134	payment	1397	1397	1678	1	1	12428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSUiUTZFi5VkLTUUZ7c1762bY58gUTCKS4zjF44RbpwsPKDjsX
31135	payment	2133	2133	1874	1	1	2842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQB7S1mfPNRXSbWfPZVXHmbNWY7vhzzZWZa8PJPiTdfK7qQXPt
31136	payment	2132	2132	1874	1	1	919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NFhNReT8Z5WF1dhWd81FQbvqZvmdzbj97u1d4aMJs2hxFywx
31137	payment	2133	2133	1874	1	1	2843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HJZyRPXx6J542gZW3AsobvBDoEx5Z6MrHRkeXDner74MkCCp
31151	payment	2133	2133	1874	1	1	2846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2mWEANyxzc7HDERbVZq69Gg2GPkgCwWqj3hicvPu3HPUmS9V
31184	payment	1397	1397	1678	1	1	12446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzzKkut1esA9kRm66jWsotHVW4cNoY1m8hgxNNUQWqaj2Y4Dt
31185	payment	1397	1397	1678	1	1	12447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34sTWQ8HbSVXbeiCfDk5KefTeaFNDNUpHS7njTq9FJ5CyjNb4
31163	payment	1397	1397	1678	1	1	12437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeeEspqfMYgCkZ8ZPkFuECMPYhN9mHFFQeoSARBgrLyZw491i5
31164	payment	2133	2133	1874	1	1	2852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZHB2epQKtVRWenkjoZPjdaU5e4AzQZRjQ7XhUrnMGAAdF8mg
31170	payment	1397	1397	1678	1	1	12440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dnPqq8rapysbPG5vaU2CQwTK2Pmi47cy8qzGtZy1tKxkL8AX
31171	payment	2133	2133	1874	1	1	2855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHKCSAFLU9goXoXaM7rLqFkCFjvhBFHmA5Pyb3t531nJT4xoE
31179	payment	1397	1397	1678	1	1	12444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD59MRoPrBnkwhqxGYJzzQ27PmmiVywh7FRsvfr5c9UQ6Dnx34
31180	payment	1397	1397	1678	1	1	12445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdGWQGJgaxrV1p7AsZYL3NmmM6rAQX8JxgNXLeYa22TPwipiU
31181	payment	2133	2133	1874	1	1	2859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfodSzchTRzqBHMA3z8mse8LQNVUTTXSC5H9RsZGoawzPfem6
31182	payment	2133	2133	1874	1	1	2860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HNShS3AxVPCsf2CiBoz5ciPRrUhxf3nMH1NYcKwi51HqchTR
31183	payment	2132	2132	1874	1	1	924	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoziCWqPFm5VM11UW6KxBd1boSFKj7oS8rZxbuUJ6KnPsvJUi
31188	payment	1397	1397	1678	1	1	12448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3t48Cvj1BQUJj7UN55KcWz5k9TUyY8yP2McZtD7dzsAVBtmZR
31189	payment	2132	2132	1874	1	1	925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudGoanqA3idEwsRG5BqYASmWLdtVDEobVFDArfVSuMeozzyYx
31190	payment	2133	2133	1874	1	1	2863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZ9oYwNi8rndWJjMmPozcjfcRnFVhSshBPcQELLuBv3j3kUN3
31212	payment	1397	1397	1678	1	1	12459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4egUJ84rf1FMzkNG2Kg5pwZKyj2iGtjNRxBTa13eoXTntQTsy
31213	payment	1397	1397	1678	1	1	12460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8JmXK2J73sS1m6iV2mPwQLU89RmuW2BZ3yECvj6VrT4UZc4n
31214	payment	2133	2133	1874	1	1	2872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPU769vU8F6oNHjXMNoqSasiL7JYoUxrdGFN5FLwkGPTEEzHuR
31215	payment	2133	2133	1874	1	1	2873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPDAMGdQi1E5R2FCkp1qdVn59E1z6ordjWyEF4xyykvzNuMRi
31219	payment	1397	1397	1678	1	1	12462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4fJRTXdfNh4mVusvinkGJeRcjKr7HDn9jH2EZZbZkJXUDGQ3
31220	payment	1397	1397	1678	1	1	12463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5FVhTME84yhu4yj6Vrbhh4yjex4TKEGqTSc4sd2sEzizQD6gy
31221	payment	1397	1397	1678	1	1	12464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx52HT5qQWPaHbQfoHuLNbXJMWoaoKFijkuS3B2xFi6cDz9pu4
31222	payment	2133	2133	1874	1	1	2875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKGmjuM8gXBL5Vbc8LZqyR1UvsJY3fmLuj2dSzhZX4KgDranx
31223	payment	2133	2133	1874	1	1	2876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwzsaX6WZMp9VDuZamagKm2QeMYMtQknFSdzUuFiGSa7yXZxq
31224	payment	2133	2133	1874	1	1	2877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKhhv3toWTLcFNj5zta6HK5T8kBPA1D3rkNEpQzBqVgwDgF3X4
31266	payment	1397	1397	1678	1	1	12482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAWb3VBo2qaFjs2j1tsPbDKzbwQB68tzZQpTwAduVVr9JKQQz
31267	payment	1397	1397	1678	1	1	12483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNYAXYNUn8PTfTfYHDpnDTPC2eq6C3FYMAN7f7FxAXm4BEqzc
31268	delegation	1932	1932	1596	1	1	7	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrHDV1PYh7RZ4d38LdUihpy2iDqkqKoCEiceZnxNXmrF7jtHL
31269	payment	2133	2133	1874	1	1	2896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUiYYPCKwsAPd2VB9L4Ywa8dq33HicbDjUZY9hpoVmyorkBDLM
31270	payment	2133	2133	1874	1	1	2897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RSfRgDiigjV6hGXNWsFLVUGBxfheRtH53Y2cKJGg7tVXoBUF
31277	payment	1397	1397	1678	1	1	12487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZ6tGdTgBLsGSWUbxbFdN2EDfkGXPBn2FH6oYBQbQXspMMfa7
31278	payment	2133	2133	1874	1	1	2901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12Asia3HmgDVDxdX7xnCEsiCGDSDr5JhZM5yjbW8P5JchhiSp
31287	payment	1397	1397	1678	1	1	12492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWW5aq2rHhjqz3zctUuBYCFrPHesJVixsLnPj4P8y75RmFRd8
31288	payment	2133	2133	1874	1	1	2906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjSTEoDLtyqiEBczk6h8hfR1ssxUXLvjsbP2YPgqePXRuczeH
31304	payment	1397	1397	1678	1	1	12501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWPiujhH6RZU4kyyctYqSW89AEfzxiZQ7SWY2qLxZRmwzzDMm
31305	payment	1397	1397	1678	1	1	12502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonTXS2NwGDDgskzx96J39yy7bjGwaF1SrUq8n2XRJaKsYamjP
31306	payment	2133	2133	1874	1	1	2914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3qwrkrtCqBJ7w7hH3E1PS5CGPDvU3GkPEQNptjQGVWUAmsjH
31307	payment	2133	2133	1874	1	1	2915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrZhVj9Ud42V4LZsRQ4kxcaRRcdU2SnyYAhQvbpEVSLwxhJjif
31310	payment	1397	1397	1678	1	1	12504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eUnewFR8kJQ34vxbFsKaec9HASUWTtM3o3mAM4tCPohMFD4n
31311	payment	1397	1397	1678	1	1	12505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7iYRuX9SPUxitRsR11gNqN59tvRCF3n2Ph3dfRL8Stua3FXL1
31312	payment	1397	1397	1678	1	1	12506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFUKfhtXxNQ6rSihzPUfvwanB7UBk8hu5Njzz1WRZ6HYZ6z1p
31176	payment	2133	2133	1874	1	1	2857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wjCr2u1yekyX2x47Qxu5n2ENMiwXaCTbbiGpBsowUWWF3DdT
31192	payment	1397	1397	1678	1	1	12450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEQuv8fvfFuDYhxZuiR6eaNo1zhQJGbv46UnBK4zx2S31hVVQ
31193	payment	2133	2133	1874	1	1	2864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9nZrEceKUmfuWoxyyQavmTcBrgpN9JPjaBdCnwemaiVVy7MCc
31201	payment	1397	1397	1678	1	1	12454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FZs3vLwVUVAG6anJazzJk7fSVPazptuekKgrcLkfScMXzwjc
31202	payment	1397	1397	1678	1	1	12455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcdXV23s1NKcJrc3jJqSTJ4ib8jPbZaErt957sx8FGQdEGh5cS
31203	payment	2132	2132	1874	1	1	927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKcV2Hjeq5RkhPdjtzcFHye15vRpAzCQhxfhdZHh25FddQpYn
31204	payment	2133	2133	1874	1	1	2868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykax7tqp3LJC1urYh4AovdXvpPxJELP4CM7peri9E4xrYno79
31234	payment	1397	1397	1678	1	1	12468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd16QscwexNR8Mp5ArHtmwmyYNDiZCyKiknpWqZQAwVkJzuWGd
31235	payment	1397	1397	1678	1	1	12469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97ksvDYDCPDg9qyAGSmEm93iNJq38RaWFWcijcuJP7ynhvzJ6
31236	payment	2133	2133	1874	1	1	2882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9c3ZXF861XQVRJmNrJR7aAvvxUZGj9qxA3BgSYes7ekLL8TPi
31237	payment	2133	2133	1874	1	1	2883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdq8NzZgfKdYyyRAi9BC6wrrsnCtQg4aiQefaM4F6aepE5GtP
31238	payment	1397	1397	1678	1	1	12470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFRrWzhgSCFBJ3AiEqQk7SukMnJd9FsfiZJ2PVZGZrTD8hPvz
31239	payment	2132	2132	1874	1	1	932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPdSR9GKiwSeMqw4UUfYVYX5AVyQw4d5jXYzNVFGkBo5swcM4
31240	payment	2133	2133	1874	1	1	2884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2N3urdpJvkX1nBqfZP3MTNSsYSgM2p2cNQkSGNACupFzE47Wg
31247	payment	1397	1397	1678	1	1	12474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2GJFEgqBi6GMtTxbiKvVUuoJRa9CCfn5jYCBWjQ2R1fKu7oc
31248	payment	2132	2132	1874	1	1	933	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnKUaKxonfBWcaLjYBtUc9cVnR2mhAstJqgZDMkxQcdUwtD6J
31249	payment	2133	2133	1874	1	1	2888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqG7vdukUDE2TdVeS6AXq1HMYgAE1KAPoapJvw99yhWTYifjAp
31250	payment	1932	1932	259	1	1	6	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBTrgtpz615cEofo48fahBVHksyvEb2cYEsYnFafYTr4k9xiJ
31251	payment	1397	1397	1678	1	1	12475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NgjbXP2AyfgEdiXG7fYtgBuB4ZYYHXj5f4X8uq6c1JHgJTg9
31252	payment	1397	1397	1678	1	1	12476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa41BvFwHC49hR8tT5nix6aRJHdM3Uzv5AfgR3hXUeDTsueVYpX
31253	payment	1397	1397	1678	1	1	12477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeJxjUtu4TmmfcLNK3ok7LJXjAemivLB9eZXmWPKPqisnyoFpw
31254	payment	1397	1397	1678	1	1	12478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hYMAnqsmEpe2GRw5pxbtAgx5GDsm3e8rdPyKn8nS62FoZ32K
31255	payment	2132	2132	1874	1	1	934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaJ8Vu2zUuizFropS2w1gEn6PondUS4qnukDetbB2p4WzRhPe
31256	payment	2133	2133	1874	1	1	2889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkxFRNUiYTEvLwUScM3SVAwDuEn1uJHbiVyzYdQodNTb4PpqE
31257	payment	2133	2133	1874	1	1	2890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKjT64YYdquYJrt7bLmVHFZzPbY35JnrsqUmA7fR6RHvnDiwQ
31258	payment	2133	2133	1874	1	1	2891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM9WNmDQCBPm8XsmPTricHi1yAWTStuRunRhVqsrLD6CjWpsFc
31259	payment	2133	2133	1874	1	1	2892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wFgr6XGcsCDEmsR8hiMwNmuogwAKJSKTvoUPgqHVM6hcXTs8
31262	payment	1397	1397	1678	1	1	12480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFihFXa1rFkFDUfP1aYVoncG9WBrgMAye3hYKA3J7bgTGwoQfa
31263	payment	1397	1397	1678	1	1	12481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcK42Gt4zYcaZRvp2gLEsrucsXrzpSusLwHEi5vbfP6ZsMrXM
31264	payment	2133	2133	1874	1	1	2894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2CMKH3uRMuwzFyUqof6AMrPsR39hE3NWXDvQVJcyTH9owfTP
31265	payment	2133	2133	1874	1	1	2895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKxRZb2xiDbZRPjMnxz824TsKMDKEpnt4UwEBw8PkH2duqAYgh
31273	payment	1397	1397	1678	1	1	12485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUSXRA79NXuUntdaR3bTbJxqVgqMgCC9RLA6D1cfvAkh4oSpf
31274	payment	2133	2133	1874	1	1	2899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3kMCaWeALPpn7qwjufs838BTCn9B9thv3y78WoZbNkahadVj
31275	payment	1397	1397	1678	1	1	12486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cyTAntzgYWjMbjAx1tcg3sn5KmYxDE5XaSdTBsGdg2SYk3at
31276	payment	2133	2133	1874	1	1	2900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8u8avHiezqZe6icXcqiJrtjofgRmjDryNty6vU93kjwmTKtzF
31279	payment	1397	1397	1678	1	1	12488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSav2sfeeBN3epsvdyYnAfquTjM3BYYsApxBtgQdnC4LZ4R8u
31280	payment	1397	1397	1678	1	1	12489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzj91JLm2dVb1PTRsUT5ZuKWH5m1JKLP8ejsCVv4tNNnSPN8GS
31281	payment	1397	1397	1678	1	1	12490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmhqWrfEBqDvaK23REpCWCvXqL7udBSHUndQBmZhJ5hJn1N4h7
31186	payment	2133	2133	1874	1	1	2861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPd7EXcPpjoYW2LCG7u27Y6QFb6YxS2cW2icev6bhWKvM6vRTZ
31187	payment	2133	2133	1874	1	1	2862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TuqKVZsiBP1WomdXYGCG9uvNU3EMou2maoJE8h7zvzNyuEf2
31191	payment	1397	1397	1678	1	1	12449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQw7XGWyaLRXpBVgyFARgJArFwwcUi2FWKq7FzDBNtU7qVUVkX
31197	payment	1397	1397	1678	1	1	12452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrB9dwCkHSw1qXBEHSpeCd6VP1XA7wZ3Xgywps7P2gJAzSYxDv
31198	payment	2133	2133	1874	1	1	2866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRAShLpKsv64jXb98hpNhmJvegN8aJ2FmYuardnAxazPhfjrK
31199	payment	1397	1397	1678	1	1	12453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDoxhi1QkcfpbK1DezGLeuRNNcnRzvPinVCCRtuj7poTgZuVon
31200	payment	2133	2133	1874	1	1	2867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5ZCJdiQ7K7oKCX93WCRA44ME1uPtdpRamq8fPuWjABfrNGu5
31205	payment	1397	1397	1678	1	1	12456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbw91L3GvJUsXyiH4TbyToLE61fYud2Hqq1XvuyUvQNNZYR2AP
31206	payment	2133	2133	1874	1	1	2869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bwvGse3qNLw6QGMq9bMfQM5Dfx5h4nmPUdF7522dAYk2Wpy7
31207	payment	1397	1397	1678	1	1	12457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9ZfVo8nnMT1Wgx7LJg94abQKHvX8tYJm2hiUXvmqmaBdugAR
31208	payment	2133	2133	1874	1	1	2870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgFABxHKjLU5yW3W1iwdK76ZU15tCAChihZCqzGpnK7Ujd6Jhg
31216	payment	1397	1397	1678	1	1	12461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpv94PpDfjEdxuoBFNsNqFFZh2BjxQsyeWgq82ikc85cv2Qt1X
31217	payment	2132	2132	1874	1	1	929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVorjw3KRxmvHJokaJr4TARCkdiWdZRzMqMsstLNtULAx3WABL
31218	payment	2133	2133	1874	1	1	2874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDBbdNmwDq5uq3F24gGFfYK9bftcHoxkZdmpBzYsT9eKDTDvG
31225	payment	2132	2132	1874	1	1	930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXnzhnvGPvttStFwdYNgh8tSxwQbzMzzQgg9dr7qvR2RJaxfS
31226	payment	2133	2133	1874	1	1	2878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFwFK6D6j55dDmd7K3ncqSWZVJ4mAsQPVMVzSj2gJzBMcnJHB
31231	payment	1397	1397	1678	1	1	12467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGh2ZdtJshjDt5ppfCgt6yS1VQfemtYC58EyrLyXvzwbWaP1m
31232	payment	2132	2132	1874	1	1	931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1GjE49wmVk7qJhppuGDDNKTTHZZK1pRBtWDrw3acGDHXTHrs
31233	payment	2133	2133	1874	1	1	2881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKVg83CHWnVDycjqWAJMQKVsNyiUmv5ctz26ZTMEckG8ADHBH
31241	payment	1397	1397	1678	1	1	12471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQEA3NBqvVTVgJed5FnFW7Kmt4p4SZ1EExvoNNBruHJBTJhXx
31242	payment	2133	2133	1874	1	1	2885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCUQ7Fw2SnrzpEK1R1rL2TJJuNLehjWkHoRTGBwwNN4aRxAJi
31271	payment	1397	1397	1678	1	1	12484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSS9TstNs7cwnv21M5THQ7PDZ5oLToWiGut4qKgWim4UEAYZB
31272	payment	2133	2133	1874	1	1	2898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEC5R6JWPQbafq4QRfKgvHsJti2MXmMe2dE1idABnyHdjbSsTe
31285	payment	1397	1397	1678	1	1	12491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbSsDEjR1QqLv4v5Co1gQAkpi9ZThKYrJyMrnN69PyyXrJZLU
31286	payment	2133	2133	1874	1	1	2905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSqD2HAHbBLx1sB7um1A1fk3rEeYD8fhccwNVj2yMSaK5CeFhS
31293	payment	1397	1397	1678	1	1	12495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPQB7hPgfer8kAuTDvskVSyJB4d9qujzXZ15HfAEaB9GpyS7e
31294	payment	2133	2133	1874	1	1	2909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8rxY1DWaxvn8J4ty7uYPU7X8z3EDWsW91k9uYQYthzjQ6XxU
31318	payment	1397	1397	1678	1	1	12508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXz4qxD4oqP9Q7PeqXapG2ndPhfgo6fctHzqPfLjrxPfxbu4g
31331	payment	1397	1397	1678	1	1	12514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsnRgTMrSCYVHiWbudJzz63dxrmVCJzW6sv1c532WGY1K7aSG
31332	payment	2133	2133	1874	1	1	2926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9cFFXAJTwxHsLPqMEvbQFr9RTjz8mB62LhcQQZQZh6Pf4L1A
31353	payment	1397	1397	1678	1	1	12523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnQvHm7TY1m43pVm4iYti3E9zfxwYzMScWZpu9zHU4GG1BfGh
31354	payment	2133	2133	1874	1	1	2935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYov7yNdFfFqLkphJjRLfnf2dw2XaaXsrgkcU4rePPr9TPWNmks
31361	payment	1397	1397	1678	1	1	12527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHR8CEZkAjYp8E6K26Nc2NKtUoEGjSvHiCSkjPM2f1DQpBjZp
31362	payment	2133	2133	1874	1	1	2939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4AbyMGTn3918mSWZxaeSsyFdHcVnhNJftkihHwq5wkndPjo4b
31363	payment	1397	1397	1678	1	1	12528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpbKEW1Suk1pGR3PoPXw3QaEWoQ3VozWz4PgRyeGgkDKUrthLa
31364	payment	2133	2133	1874	1	1	2940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3ZXizLevoyv96tAbn989ns2kgjihQGJyKxqckWGxHaTaEXJD
31385	payment	1397	1397	1678	1	1	12539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKMqqiC6C9Z789oqRzRBm6iocDePm3eGA19tvqBFbAFyYhPtr
31386	payment	1397	1397	1678	1	1	12540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8r4Q1t9npbRaMHW12Et8CTvC34opRNWprwNQqum7YAvpRpJF
31229	payment	1397	1397	1678	1	1	12466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJGDpSKRvFh9PT5z6uUQPUpmMnmBHXT5663xjv9JyQ762w9Dc
31230	payment	2133	2133	1874	1	1	2880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eZJZUcHDxdi7y7Yp7HgQQfoxG6MXPcGxC36yU5rSd5KNK94n
31243	payment	1397	1397	1678	1	1	12472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsgpNqDrqqThJ3GnTywz48yVWrrF5JfZ3Y6W67ssHjJpiv8Ut
31244	payment	1397	1397	1678	1	1	12473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW6dXsBgqkFAL38G2QxEbkw5qSN8L9r9W5oA87DeidM9nq6zv6
31245	payment	2133	2133	1874	1	1	2886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJw5owpBLQ44AtUKMzCBNTno4jR1BSFN6tcNuA3MH1Zn9tSEa2
31246	payment	2133	2133	1874	1	1	2887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8Tcjzu2J37Dvi81vQLGhyDMXaCc7XVY88gECqc38zopy9VaW
31260	payment	1397	1397	1678	1	1	12479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9G7MQktUiTD1A5Nrk4WKRnQVZyZwTGBVN29ykLws7gsoDw4U
31261	payment	2133	2133	1874	1	1	2893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFaaPppJZaEQi6iYWpzMtEYWvkDfkPHByeA36NtgtqVhQv1ZS
31297	payment	1397	1397	1678	1	1	12497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRDwH2AdTdQkWzehnycYSydF3NaVYqqaeppjdYfPGqoSJCQtkB
31298	payment	1397	1397	1678	1	1	12498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxgfoNFg6Ls9yLdkXmn8nBKNvwNVBBuDNPtVj7ce82ZGUm9U9
31299	payment	1397	1397	1678	1	1	12499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnRF3q3BJ8mzBnymKzbErg2JZUfEuKucQe5MZUaQiH6ZK7ZP5
31300	payment	2133	2133	1874	1	1	2911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BsRkVBgsEMQWyZfDshNV58qUh7uqLaLdtPBZ5MDd3HLKwM6h
31301	payment	2133	2133	1874	1	1	2912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ginmesgawvTYwPwKBojfd1xbzmK5RaajT8gqPYdrp3AXpfmC
31316	payment	1397	1397	1678	1	1	12507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZHfpSb3eVhHV9V2eNAZ18JDXUZdLWcUVGEmRR3AiCsjYzpwD
31317	payment	1740	1740	563	1	1	12	17475000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpZYr2M4pjUkNewwqb44wngC4aFHF5abqFt45niygHYxqeEgeANr
31333	payment	1397	1397	1678	1	1	12515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrYCyKnzG9x6RRoo4YtvC33DGYYjexuMFSye3Duooej3Up9VR
31334	payment	2133	2133	1874	1	1	2927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZK661ptZ3m69GnJGsaJMKWNNuK9onkgqcLPVagKUBawgzgsbD
31357	payment	1397	1397	1678	1	1	12525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa35y8oTARqhMSD13n7xtvVxkMHpegr8v5xPK94rk5SMt61uxN1
31358	payment	2133	2133	1874	1	1	2937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQwfjihC7H52wB7sTiC2CoTJ2cY44BxBcntKg912yYHta4b2U
31375	payment	1397	1397	1678	1	1	12534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6GmbWdE7fLLYHNc85Ci69krDrnRvynKeLAx665uFieZ8HpFxk
31376	payment	2133	2133	1874	1	1	2946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSQjsEBJYBsExBgj4VrhJ4d7T3DKjc9PiYQYEvQ1hUMgyGVJR
31389	payment	1397	1397	1678	1	1	12541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsoeG5dmQXgUUkK9QDDY3nHCKv4cpddSwKzZmdfEJ7pT2bNscZ
31408	payment	1397	1397	1678	1	1	12547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa932WLA1QMKf5AsrBgZRLp48mNKVGqEeAAkaeJAsHPoXvgnqE2
31409	payment	2133	2133	1874	1	1	2958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDoZrXj6dY64zffpDnRFdRmcWuMQPxWaNnqf2k84Q4SrtnJS3z
31510	payment	1397	1397	1678	1	1	12579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJctU9X9R15jiX6s74snDPCTs8aLDNR4P9a4KPY3XNhZ1qHmi
31511	payment	2134	2134	1874	1	1	3069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWULNkkpMxBQ619G6twTHsLyxGtvvn5hXqhUBxbAxkjrKauf12
31512	payment	2133	2133	1874	1	1	2988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmMftB3GAfPn849CUj8aRHXeTm2NRXGWoaR5veQRU6PRg7Hw4
31539	payment	1397	1397	1678	1	1	12588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYi56hPXCesd2bDCEnHc99jZPTq47q7Ax84SqXHRjFpbkLPdVj
31540	payment	2132	2132	1874	1	1	941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGk4BkGDkoSQcc2piQzaVutUpQie5q9yTqwmYsPN6dxmJZ31HP
31541	payment	2134	2134	1874	1	1	3078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYgBUkuymb4rqePFssavh19bK6r877Fe2AKY1G3aMSxrM8hcxb
31542	payment	2133	2133	1874	1	1	2997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9M24GztAEc8VTLdGVgQ9JNe7w2jBrP6ANWEPJPXthhzGoaA4
31555	payment	1397	1397	1678	1	1	12593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJicYB7t3pZxSxYKZwnpSz2ByCiKEdNsBMnfPAxLwpiPVUPgGi
31556	payment	2134	2134	1874	1	1	3083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpdCEDeELAwtwBc5AUhNaWuNabJoCF9QU6YMAzayAZXBuoosb
31557	payment	2133	2133	1874	1	1	3001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9wmev3XGvA89QLbZj1eAH4Y8hvf6WDeGMckULUspRMjAFREc
31558	payment	1397	1397	1678	1	1	12594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAprSoiu1AQ73avX6hshHZ4b5kmuiVMx2UVRHj46hBjUYAFE5w
31559	payment	1397	1397	1678	1	1	12595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNooAmPkzc4zFu1VScGBRfVhtfSDUKZFDvJrAuNGY75YAhYog
31560	payment	1397	1397	1678	1	1	12596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTZNb2EbE77SGHo2JeRuRboNNRNf5R7FE74faegst1exviVPA
31561	payment	1397	1397	1678	1	1	12597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmhtyhZgm5wv5DhYiCKDMpRNvnZnVyiYhCsyaGQVxiv6Jncbb
31282	payment	2133	2133	1874	1	1	2902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCGEaJcQ22yFffrpiS1XCwiyYcFcsFmSCNj11HWCaQvmt5kLP
31283	payment	2133	2133	1874	1	1	2903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYtKvY8axURWcuskHMGWPequJGydaL63UakABzdUt25HEWDrW
31284	payment	2133	2133	1874	1	1	2904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstsJSZg8PKhFzcA8fZkfTzt1Qp5RMvUbb9234NvaUWWeRQ7ze
31289	payment	1397	1397	1678	1	1	12493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24fpDD2PxWbnZxCMEsjwVYsBQXiPsLf9N118Nu22PywJgzLTe
31290	payment	2133	2133	1874	1	1	2907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZVfJVY4GMw2y4S3LVCG27k9MUuF6ZBuXjkfv427ZVP2RymQQ
31291	payment	1397	1397	1678	1	1	12494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBEn5Brfp1e5NMJDGwntzeEpYcoU468NqFSpHsuEjKGVBzSSy
31292	payment	2133	2133	1874	1	1	2908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1k4fAbetDPbukNQGaPYJiijEWM6yRUwVCtgHNMkQoRyqZQGW
31295	payment	1397	1397	1678	1	1	12496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTHmEMTm3Av2T1cTFHVX3BeVczfZCm54g569moLKad9NNJtps
31296	payment	2133	2133	1874	1	1	2910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSSJHBsYakVJx9JQZBjmaBnbFuFYvMvfH62hgruejBa3kTNHDw
31302	payment	1397	1397	1678	1	1	12500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrufY5bBDxmfi7FYM7tDKiFkTonL2CMp8eDp2NeuuhdyKoFN1
31303	payment	2133	2133	1874	1	1	2913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRXMNLMYgrWDc6m3Xr7sPwaYut9zdDvEmyVrBPE7HsdeExPSa
31308	payment	1397	1397	1678	1	1	12503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpJhPV1d4kjNqD73FjpQeuYJQopmNN7jPQ8vtvm3GeMYqXsxN
31309	payment	2133	2133	1874	1	1	2916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6fni9i8T9PecBVPaFkLeqNkdV7VK8e1HrYsLzKJVyHTuZzdRJ
31319	payment	1397	1397	1678	1	1	12509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5NmPc9jXMUKSbALL2a2TtQ1mWRTZ52qTf9EjVpd2Hy68DQnoc
31320	payment	1397	1397	1678	1	1	12510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1MRoPaZWHxV5Ko2AoiRX41zbX5KhaLiQRZUGM4r5pL1eGThfn
31321	payment	1397	1397	1678	1	1	12511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bLXngeUcZLPwcLrwdy812ebLor1UcNX2zPki2E3m3M23amfm
31322	payment	2133	2133	1874	1	1	2920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJntqH7dccMgWJ41NP2p44CejaX4bF9bKPNoS6qw8ei2WAYd2M
31323	payment	2133	2133	1874	1	1	2921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3WCmtyyqnxLLLmG3xt3vmgQxzmyYHg6mX1jVTYz8ox3o1prC
31324	payment	2133	2133	1874	1	1	2922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvkhhPZuAeqfkbwafPeAzaemQpryNF1huuQSyqAHQzK1t1CDu
31325	payment	2133	2133	1874	1	1	2923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERirsbmD88hfofv8SBkkwWfKqFNZit7oxeRYgZke3CFb25sp1
31326	payment	1397	1397	1678	1	1	12512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQseoFjNps1d6yggqWyzMQoUDoK8w7JgMv7KVnnDzRp887bZFc
31327	payment	563	563	1359	1	1	11	7988000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpYWcU38JaCqb6wmBY4doJDkNDcFjjK73ixcvV967dXVZTK52ShB
31328	payment	2133	2133	1874	1	1	2924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zp7pPg2UcyhwzLUPuurGcJUBdhXNJJ5rRGJNnUJa8jB4nBUf
31359	payment	1397	1397	1678	1	1	12526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4TYkttcJ2SvSKdgjfZ4jk8TfKubN19FhD5VEGv9VzBtRfBuo
31360	payment	2133	2133	1874	1	1	2938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuf33BJo5m89qr7vBqZAi9PETrF2ZMU9wBoK56zWo6z5ZhBpnt
31365	payment	1397	1397	1678	1	1	12529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKB3pWobwPbFKiaqEvnPLrrwvpJB5NBHr4WuPPGHwTYG92QGx
31366	payment	1397	1397	1678	1	1	12530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnkgw48T4pXmdiczjWGgAiXx1qAyLUnC1tJPy9vAeyKRZcq7K
31367	payment	2133	2133	1874	1	1	2941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtbgCzGgLx5ePYTgkaP6tjLmmsKkKHqHUFMdEVThbXkLJ3JfX5
31368	payment	2133	2133	1874	1	1	2942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYb6XMy933nfrggZibJVuQZg64ZCpNG23ydSv256DmwjgPe25
31369	payment	1397	1397	1678	1	1	12531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6N1xJhrrtporhdYFxLNjffY1hMbcdJQarwQMH8zu6LjXbdN1T
31370	payment	1397	1397	1678	1	1	12532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YGDashksdyds8Th78u8YerTBkitUorVZhQJ1pJS1zjpNy111
31371	payment	1397	1397	1678	1	1	12533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvMVmkrdLMm8F2axvH3aPRqhyE8yc1wmbVJAr63Gd1rMpvLRa
31372	payment	2133	2133	1874	1	1	2943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7MBpLRUepciewSgNBw2ecB2LGjqjtcXTEPkfKGaFQ9SPZcJ5
31373	payment	2133	2133	1874	1	1	2944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYMPCbPkM1eJToy2n8NnFXXjr8PQM8esivDM3xF8HamM7XyHN
31374	payment	2133	2133	1874	1	1	2945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp5V4ZwTeSS96WPZefbtxugV3TnkH2zdnTgSWuHkvjYspASTdG
31381	payment	1397	1397	1678	1	1	12537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskyvwakXmmPKtsXBQyrdY7n4qR5bwNdfgcJjYspsrR5x2G7Jd
31382	payment	1397	1397	1678	1	1	12538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtKgHBiwSSpoDRyQFtKb3RHfcc6A4WxrvaARGQzBuMF9YAXGB
31383	payment	2133	2133	1874	1	1	2949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQ2LDuzM7UVMPUcoDcuRPHjM793PJF4U2Ttm36egQUMrRuRtH
31313	payment	2133	2133	1874	1	1	2917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6QAR3QsS7iGWjtw7EpYt38xeXcnymxMptkgJ8jZynjJph2rb
31314	payment	2133	2133	1874	1	1	2918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2sV8fJbjAxy4VwZTVA7AmS6kRD7CvSom3Qy7XZffXuTBMSxND
31315	payment	2133	2133	1874	1	1	2919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokQLqyvVh5t2vJVKyH7pyGzWShoAJY299246aFhrEKeCXftyr
31329	payment	1397	1397	1678	1	1	12513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJsQ1yvMc9TStCeR8185S5AjNUNDp3Fmh3CsxbirtwU42HzZK
31330	payment	2133	2133	1874	1	1	2925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3Wqs7WF3H4RLjZt8u9FiCz1kpx18cLP1nvDdQz8UXjLpe99a
31335	payment	1397	1397	1678	1	1	12516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4UL44CxLzSPvotNn35d6xaFWTBGC7z2ujtC7HhwD6ELAQpmw
31336	payment	1397	1397	1678	1	1	12517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVJ6AoehP48z3bmeWK7Y6oFUiQgBoguDwiArwH27TWpb3TZid
31337	payment	1397	1397	1678	1	1	12518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xn7PxvioejDMf4PcwLDf35sbFCoF3ZisZuQLthSTgGpJttNi
31338	payment	563	563	1113	1	1	12	4249000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpYcgBmL84nF7n3tYTePFuKuxbz7w47kFvQUcqYSSiWwFMR8BeHh
31339	payment	563	563	1233	1	1	13	2867000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpZ16epT7kTgrv59iGnQ3xrNdfhUmQ19jPRoiJabFTCqiYH7Dazm
31340	payment	563	563	993	1	1	14	2371000000000	2000000	\N	E4Yxn7a2N1WSwk3u7JjkQbWSZzS5jbGtNE9WBFkPkXYtxs8kcLePk	CkpZpZxnvsJhLybAEYUCtAfLZ1X4UKAXXDEUVw78b3q6enG5xhnNn
31341	payment	2133	2133	1874	1	1	2928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcr3Ymedo5vT3gj1rZZU265QZ4CVkvFAk6JpR7kgFpSBuFENWY
31342	delegation	2247	2247	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRtJ7NVuUMxXb5HNR4CEcc8VdA8Ey7sAG2abxXZ9tcVmmK7KN
31343	payment	2133	2133	1874	1	1	2929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4fxNxzuJeXYJ7nzJHsJAv6upfhjW2beK4smx9QMY17GdU8Wx
31344	payment	2133	2133	1874	1	1	2930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4rFLiKQZpucUN7hfWgYBm4gnXwBS58AVP8WWA7utYpZFQdV6
31345	payment	1397	1397	1678	1	1	12519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vBBCJeHPAVo3kMThMXFhkQsbybuPk6Jz3JE43nfa9JcgHH3N
31346	payment	1397	1397	1678	1	1	12520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpLJowPwUk7vK9KNchrtRJRVreGYNW2PzYK7ivbFTZZorAGwZ
31347	payment	1397	1397	1678	1	1	12521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX36CbvjrDPco4yjRBAsromSsZ6VewYRAkT3t8UFoYwX2dRyiW
31348	payment	2133	2133	1874	1	1	2931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURXXiJ85XzXUJnhvpWtfg9DkbZAoSRxecH1GMbKHbBGDJoH51
31349	payment	2133	2133	1874	1	1	2932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9EANmTKDLBinoJU3GmVuGDdKty2Xy6RBEmCcqyQMSi8FFhV8
31350	payment	2133	2133	1874	1	1	2933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1LKEjdsznk7WSEi7aX1KsWzYWtQ1112juS6HUp9nvzvU6J1iS
31351	payment	1397	1397	1678	1	1	12522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTtTBuhv9Uwbw6e2aiRg5bWeFYEbEmhcv8DPZsKQJCoDYgkY5
31352	payment	2133	2133	1874	1	1	2934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLb8fdm1QHxebRRmpuC3SYhAfvBiSeT4g39oaM4qzRKAV2vDG
31355	payment	1397	1397	1678	1	1	12524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNDGdpMKJ1q7nVCuakHgaYMvJYqipp5o6ierATBM3iSaEFyqR
31356	payment	2133	2133	1874	1	1	2936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeHavrdCrh1buiyuq7QoNvYgVvnWbKxEgMKVB6G8JfZvchUDR
31377	payment	1397	1397	1678	1	1	12535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnjgJ1Tz9Tr1mH2RQqCKMRr5HhsNZhcnRtHeptb4w7sexNS66e
31378	payment	2133	2133	1874	1	1	2947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNxTAyhote8QKSYfkoJPaoX9bUuCq5RbR2upRPWmMMVR6R41W
31379	payment	1397	1397	1678	1	1	12536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwUFuqxftHUj7mjs4aNuwrSSFTtEbWdzSSDhApR1fDUHKUFXB
31380	payment	2133	2133	1874	1	1	2948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKzEEPGqP4f2C1yvoRArcZx2R4x4SbR25td6nor3QhD4bcfdx
31390	payment	1397	1397	1678	1	1	12542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYxWeSDhQdZ65shBhtnn15xqQuatzaV2xgRe8ML2HrUZ72th8
31391	payment	1397	1397	1678	1	1	12543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwp9mdwSAzEjRhfxZtitkB1HPb3yGYXSmudZC5N5h9hgRuSjQ
31392	payment	2133	2133	1874	1	1	2953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpndGxZd3RzGQDYebhvHaPtrdQJsWr8D2Qr6mo85a6AHxG3SU
31393	payment	2133	2133	1874	1	1	2954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKNjDfbPrUdJo1CLbCnaRAxdrx93fKmjMvNsGhTSppiNvkp9e
31410	payment	1397	1397	1678	1	1	12548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5u61v9228nu5iTjb1t12zFxd6qdLmrRGCha3yQ9Aj2j59YtXk
31411	payment	2133	2133	1874	1	1	2959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Jhw8jr6kc2HJYnU2wH6coQy9mAhwXKVSWdC35ErqJ4GAAvjb
31414	payment	1397	1397	1678	1	1	12550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVqrkJTNvuywYL3BQ1ak56ADfjMXxG3aHu34BrJAgHQtTVRU1
31415	payment	2133	2133	1874	1	1	2961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkHPCG5sC3cBYExEuRPjEVWd2vNp9CpguJwfJX7cXszYr1UuG
31437	payment	1397	1397	1678	1	1	12558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93X7uL34iWpdjvLVPbaRWRvJBKDyFYHoLEtZDw44GbB3JfRyV
31384	payment	2133	2133	1874	1	1	2950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcLS33RmS2ev1ryqk2axBmmJSehZ7tFL8wmjY63WrXujbHhA5
31396	payment	1397	1397	1678	1	1	12545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QzTCzprx7PQqcVd8KQrosi55NoMviX7JWN5kR9sWyzs5v7nn
31397	payment	2133	2133	1874	1	1	2956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnKiCyE1oTE29kX6N5a4ybcT7pnh1bfGwbvip6LR7huoFXSxn
31398	payment	1397	1397	1678	1	1	12546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMajLY6fzeR1KHC9zDEpyJuXe8aHZwu3n7uxsMhiN4fiwHK3g
31399	payment	2133	2133	1874	1	1	2957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9FumFUm1Mkg2Vzv6ybjmYUc483LLi6owhV17EL5Cr7LNb5Sz
31416	payment	1426	1426	1364	1	1	4	9524000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJLQxpS9gtSQwZhUKXqeBgLrypU3Cude7xoeewfTeRQzuJBqz
31417	payment	1426	1426	1118	1	1	5	5066000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8Mztcx79ixb25gZH8DmTo5nnGv28sR8oarvWGPNjk75vg7Ji
31418	payment	1397	1397	1678	1	1	12551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgpstWc4ybPML2gDiNvjQ1TBf2ZBqpCfSqfy6k2HZVTsjdmSd
31419	payment	1426	1426	1238	1	1	6	3418000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXkmVDtCEyf1MkafFER9Nnefq1xm6tkm3V3AVPdWfaj8ZgHU2
31420	payment	1426	1426	998	1	1	7	2827000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uxXJcxNSdMQCJexG7mEnvsKti1Xp21rNR3ko4C3cCmEpp43t
31421	payment	2133	2133	1874	1	1	2962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKPbe1RNrn9CLw6Nnr3UHSphW9RRuSzdgqZhgzZC99oQaR1gfv
31431	payment	1397	1397	1678	1	1	12555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkYNLtagWCfQH3M2vT4ztoTcps2XMTo8AfY4mnrx5mNVPk7Ga
31432	payment	2133	2133	1874	1	1	2965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp2A5vKsa9gAosRpZHK8DMA3geaux8s57xtrtxh29MKjSWeYyw
31433	payment	1397	1397	1678	1	1	12556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYwzi8RNyKvNYF3zSefUX6f7UzarYq7bdvuF6UhuNLUthrRc6
31434	payment	2133	2133	1874	1	1	2966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJMcxo8WyUxJqiBrHU3SNz3HpNECiRe2erGSyH7hsocSwYksf
31439	payment	1397	1397	1678	1	1	12559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzUAsPVxgDrJmZgBrnwN6y2DELfcex8pRUranQwuRCS7rRaNe
31440	payment	2133	2133	1874	1	1	2969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2xtPPErw7CpuRFYjZiEgcBBJMBe89b8kYL3V9TZPV4A2NuT9
31441	payment	1397	1397	1678	1	1	12560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquaZpVCiFLew4K5eh7mXdDUuaMY2Gwe98BmKBkmDBk44ZbnLy
31442	payment	1397	1397	1678	1	1	12561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZZSP8yLBFVQfBdwf64yBTkJP5ZkbkyVrzyGkUKEx5bEJtRGL
31443	payment	1397	1397	1678	1	1	12562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4miQszKjBaNXnjmNZazmqfYiRtm1fsLADQL7Wfrpe7xNdqdZg
31444	payment	1397	1397	1678	1	1	12563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyAinguwcG7GJdQhbRVsLQT3drq5FSvUDpmrLwaPSj3PTNBZy
31445	payment	2133	2133	1874	1	1	2970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVZCmzejzsZFsqGvD9MQ4WD3mxKHJKPTBoL6XjL5rKcXdFNZV
31446	payment	2133	2133	1874	1	1	2971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJmJmp29bFRFMNiboJ6NZFq5Mm4UoXKGZy8B3LyXqofTKQGJz
31447	payment	2133	2133	1874	1	1	2972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69tW6xpX51PQPL7ryaeWbuJiEPab8qHepD3WDqLtWdtw3kRUi
31448	payment	2133	2133	1874	1	1	2973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JnbdroVRMoxrgPgATa2SE9P5So2CdGF5nvAZSBoEbxgkhvQy
31497	payment	1397	1397	1678	1	1	12575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6u1g55fRnhfY9FnCKvDXvCswbgNSCqxPBTgTevPq5xNQbGEA
31498	payment	1397	1397	1678	1	1	12576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7SPSt9ypRupEdx8HsLts2vXfQbzZ6VAxMjrnSHgtsJg1BcKr
31499	payment	2133	2133	1874	1	1	2984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLRCUL52ZKGcFwnyw4ym2txJeWWRedLNcZzVpnUCx7posWvYj
31500	payment	2133	2133	1874	1	1	2985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWrvFedK1B8PETUuL9BkpX8fQTdY2gaHU52rXpzticZdT4DoV
31501	payment	2134	2134	1874	1	1	3065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrAjF5oe4wHnPm8KyMn4ti5Q2mjMBL69MNSGeRdqWpCfty4Dfm
31502	payment	2134	2134	1874	1	1	3066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWny8iRdpKPWgrLyEwS9YbWsoFh76B2qcjpQKNLro3ZuZ29ZF
31513	payment	1397	1397	1678	1	1	12580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQWaSw7hYfth3jPZMDAWvExtc3MK8Ay44EDJ6TqkopbboS52Y
31514	payment	2134	2134	1874	1	1	3070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77yofEqNEHJ2rCRC1kTsnUKezy7LXmL4Phpg6XLJbemjLYoTH
31515	payment	2133	2133	1874	1	1	2989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq9ratyvMUEbuyJLpg3weQWGTsshFB22nTCRims2YiDcb6r3Q
31520	payment	1397	1397	1678	1	1	12582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTH6iEK6743kURtos2v7LiBvSF89WioaH5rNPAYRiadHakpaR
31521	payment	1397	1397	1678	1	1	12583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfR4Z4CXa9vCGdwwbQMgchyvCZJHmmzNMeHdhxF2eQMWARTtts
31522	payment	2133	2133	1874	1	1	2991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ6w4APQvBiUFuoaxQdwSN5B3eUpScSdgpmGzjf82NvWXiGvoY
31523	payment	2134	2134	1874	1	1	3072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYaSNmqkmT5ey4Gb98TDdodNJ4FSuQr5b8HurcENVZqrGa4Y7d
31387	payment	2133	2133	1874	1	1	2951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEnNy32Mp5Ju4hb5JxKHAaJP9yqDVWNky1KqNN9yooHZ2MYdMH
31388	payment	2133	2133	1874	1	1	2952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjz5EaoyvEM4Fy9kEz53rUZcFF888ZDgCoXyCdWTG5hsfL2VMv
31394	payment	1397	1397	1678	1	1	12544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhpyCadUYEyQgUfHynfdZZBzwQgDoQ2kbccFUxeMezBgYuZcw
31395	payment	2133	2133	1874	1	1	2955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvejpxTNwV2iEyHEwRZUBx3gUBweYW42gXzpqqYBd7ZnxAZBSY
31400	payment	1471	1471	1386	1	1	4	9524000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxro87qoVQtmmaQTDuQXYhkUdiYTvfVM8s4FqXUV2Y6oHkUXji
31401	payment	1471	1471	1140	1	1	5	5066000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFejNqZTbxBaLNV8uVB5w2n17jj99euJrDqtzfbWPkwkjo3VzJ
31402	payment	1471	1471	1260	1	1	6	3418000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzScxFA51toRbbZ45UQPJ22An7Wdey4GuZkRAKjSdqbcYotmt
31403	payment	1471	1471	1020	1	1	7	2827000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbrsKp4xE4q3D5vM1macMxd743hujaNmT1MNhUUg2uiZSebEB
31404	payment	1611	1611	975	1	1	5	2041700450000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4D36sRmFuVjnnYuFAxsPceHKo7UC5wqB8W61TUZb5Ed7nsgDb
31405	payment	1611	1611	1095	1	1	6	3658709710000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNxRWxuDpePThPdpdywF5Zq6XogFQfxCSb3ekW25ahoX5zqet
31406	payment	1611	1611	1215	1	1	7	2468604340000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbwXKZKVHCv9kWAZeYwR2a6NX38vVme3VH6yuwuSRnAiQeP3c
31407	payment	1611	1611	1341	1	1	8	6878985500000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1N6UVuVm6T1gouW9hUVTwrCbp5YdBbZiExzqdoMjV9qDErck
31412	payment	1397	1397	1678	1	1	12549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsgLXNYRCGHzLK7vUEwYWUqGPz2DoEU3ZSsb28pphBU1YqWjY
31413	payment	2133	2133	1874	1	1	2960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BLbM9JnwqXogiEYcXzwQ5sK6Xok13Dve7qPdxbhfvDKauzna
31422	payment	1649	1649	1383	1	1	4	10446000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9u7XemP3L1RAQAknyL71SugoZGx9A7P5E13xkT6PfcYT3PSHz
31423	payment	1649	1649	1137	1	1	5	5556000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRTzANSKj62z3dMSmYQGanfhSwsQT6wECbCFSt7k3EVphcHq2Z
31424	payment	1649	1649	1257	1	1	6	3749000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRN73JUN1fu6Mozc871dG9GKk3rjwdBxddKy1owCq7QGBERFhn
31425	payment	1649	1649	1017	1	1	7	3101000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRq92kLGXCCqju6JnBnaSM9zo1vmh8gtyF3UgZ5YjKAcHngKQ
31426	payment	1397	1397	1678	1	1	12552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxcxPrBeKGxpn72Dz5WbDPC5ET5XDp7pHcBHP9sfgCe66q4iB
31427	payment	1397	1397	1678	1	1	12553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1VR9j5maeZ7pjfvSS4QTsFCGewcc5C4AR6hVaEMmUG5semFL
31428	payment	2133	2133	1874	1	1	2963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEjZgsRLLEnEZAA9SJbbVGXNRkWA5gSM5kJfvQM78oVm5pHyB
31429	payment	2133	2133	1874	1	1	2964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE1PQRuBLYJ4UqvDpMzakqfJkJFy3HemfyuRc49cckTVZ48Rp
31430	payment	1397	1397	1678	1	1	12554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aYPMX8MDdRaLaRXAPBSdEhKDJMtXZJStbskVH1ppSv5Z8Siy
31435	payment	1397	1397	1678	1	1	12557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJhNUyFAtbWyLnC9wwoqoj2uRYPSUAhKzuDyZF4YDuonofe6k
31436	payment	2133	2133	1874	1	1	2967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bqNCPKRdCcpzYWxi9ajH8Tc3umppPTNt6kuvwmGesXBHyso1
31449	payment	1397	1397	1678	1	1	12564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBvSgNsiBJaanjLrVNXQ7qykK8dbeEMGA5WfXRJtqGsoj2QwE
31450	payment	1397	1397	1678	1	1	12565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfLj5bKwYczesq3QrdELLBgtggzrsnACxh4YZNyYXcjhtDGPX
31451	payment	2133	2133	1874	1	1	2974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJV4ux7pXEVzeoD7ChaJtTev9CfG9DA54MbU6LMf1DmMVh3Rc
31452	payment	2133	2133	1874	1	1	2975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXymZxQ3PYmubXet4bNj9AHePWBgXyuGWeXvWGsrg5R48xDVn
31455	payment	1397	1397	1678	1	1	12567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TnTCmbSAtcf6k2st6Ue7rCSqzhHrLVAiF8S5idJ9SFVrkKbi
31456	payment	1397	1397	1678	1	1	12568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDw9s3ygLVmeYGvrdScgsdHRSV7b72yBiPorLS9KVZ25BN7d3
31457	payment	1397	1397	1678	1	1	12569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CLbSbePix5PhxzkUi8WGG83RMhRQQckirMsMn3QCusf442GU
31458	payment	2132	2132	1874	1	1	935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntu4RC2x5uh4Eg8Pu2Js36ebHo93mxhLTq1EEbAKAxy2PaKCH
31459	payment	2133	2133	1874	1	1	2977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfD4Ab7apWuz8iG5obiPNV1Y51TSDh6E1FWcmG1Ph2d4bUCVvv
31460	payment	2133	2133	1874	1	1	2978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHvWXixdRU7PsgAM6WBJuLyPgmkgcq9uPbvcTy4SPUQQcaiGD
31461	payment	1726	1726	2272	1	1	8275	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa4Tq6vwyirsa2rFBxQGRN1XgxbLhoAEBPGkerBQYL7WyoS3MSa
31462	payment	1726	1726	2273	1	1	8276	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZYJhVkshFE7Ahx5xYyENuX87bcjPVA6FiHhK2ZUT7LxNjxGwtz
31463	payment	1726	1726	2274	1	1	8277	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZAtuspJLkZMXn2vU4sMhqj1knFwD4N1PQ8Kzdckn9Hr6KfCGcs
31438	payment	2133	2133	1874	1	1	2968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFeBVraDFRx4hC1VUn2BwW9E6xaW7UEMZsDGWCAUc4oBYRXDQ
31453	payment	1397	1397	1678	1	1	12566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwyQA4Hj6k76dd98xvRtF1fJboEc1WUgJEWjt859ffUZ1yJmE
31454	payment	2133	2133	1874	1	1	2976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr9VYa3d1LENzaJvy26LPhjK4wi9zGZ7UH8JqqDiMKTbtXbVgR
31464	payment	1608	1608	923	1	1	7	2462240000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgEHEk2pZ3vL2c2pJJfg6vXCQaH6Th4vdD8UpRos1woqZarYV
31465	payment	1397	1397	1678	1	1	12570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWsBHKsHNZa7DuovPmpvi9pMPHYqyF3JUz8Pi9NZoYUoG47kt
31466	payment	1726	1726	2275	1	1	8278	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ8NqQUqCUFP2FB7jjXLhfo4i3YxX56yy7uyhk2BMKFu7fzZbxc
31467	payment	2133	2133	1874	1	1	2979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRcHjkHVeyjJg6Srfs8S5ZDKexdz8n9PgdzNCXBGnxAvQr1iQh
31468	payment	1726	1726	2276	1	1	8279	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa9Tp4sa9mzKE6byCbn8RM7Ws2NpdbuGApA4Hhf3f3N5zG7QJT8
31469	payment	1726	1726	2277	1	1	8280	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYwrgKckeYKzJBBSwg28Z2BKTnCgS4heptXrpFwK5zeqRNYxd4p
31470	payment	1726	1726	2276	1	1	8281	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxQhYz1dHNX1M2nGGpSG3FPuFRbfwcryTLcLXou3hndvMVuc5s
31471	payment	1726	1726	2277	1	1	8282	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtEXjhTVrBhSYKKpUWYkqpKhP9LgCanZiviKeJmVWTYpWatpPa
31472	payment	1726	1726	2278	1	1	8283	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYo4m43FruNZHU9opGV2BRjJ5aKJAJXDP7rHPvZJt7J2XhwecrL
31473	payment	1726	1726	2279	1	1	8284	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZLk3V1K2BaYrzxDtSwMWgWycY4bJyf8WtNYndCZReus38juKjL
31493	payment	1397	1397	1678	1	1	12574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNe5jNKG8E3V1HEr2MbbBf9xkkUvZk7FjG4TrZt8wTy1uUHd9
31494	payment	2133	2133	1874	1	1	2983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwVzw69szXigXmTLsU5kAcZ9Vz8DTfu5Y3DZS6CNCYjrSHrh6
31495	payment	2134	2134	1874	1	1	3064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaGFU8CtE7BhF1i8T7L42cX43Lo1DvN37CYeFRJFi6AF32XCw
31496	payment	2132	2132	1874	1	1	937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRk8KvqGpheYo59XvoMMDV1d3No33awiVZSTfwmew6xtAsDK1
31503	payment	1397	1397	1678	1	1	12577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhA8Za6pnF2q99UZEZJk7MttT7nNANzoUHpnwTKJMqs2231baH
31504	payment	2134	2134	1874	1	1	3067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRthHsSRbep1t4mJPjoQWeavEzKr1MTLVtPwrGEaVsVEMd2L7
31505	payment	2133	2133	1874	1	1	2986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AtxXJ4VE6mb2uZvp641rWQ79q1JnsB93ntjjDYAcuvzh6LdP
31530	payment	1397	1397	1678	1	1	12585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEtKXAYAYwDM4EFwnaTrCpoY9qYePGSf2PA4HDzHzLcxmsc9g
31531	payment	1397	1397	1678	1	1	12586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMzhgw9QnHCutmKurUhZRCnoGjjcBeEjDyoGhoiLepsTLqxyh
31532	payment	2134	2134	1874	1	1	3075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUXq66iKFkvBUSuN8W2eb52b2U98m7K4iymUBc8kpACQdtbGTp
31533	payment	2134	2134	1874	1	1	3076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWmxffNSxivTHpqVg7ayQp5qSPB8mpDiAmmYVo3TrhHg6ALuf
31534	payment	2133	2133	1874	1	1	2994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3rHcHnwpYrWYk7WeLt89LKz2xEPaC9BBMXxQPDBAaM15pDqD
31535	payment	2133	2133	1874	1	1	2995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpyFW4vDNXCv9QHYPtMxScp115z2vy4zFnUrQZCEht7j79jUJ
31543	payment	1397	1397	1678	1	1	12589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkcSov5v16vxrnUp8o9mbfLk5h6QUNv4K5TWpWyyXDcs3x6F9
31544	payment	2133	2133	1874	1	1	2998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkwKLsiqCU4cDhk8Z448yqeJMrUkc9vGEpQuGWcZ1usKyfyKAq
31545	payment	2134	2134	1874	1	1	3079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa98cMe1KtZBtWvMvNJEoHq9Zie4ub98jneaAKsLJEnfQhkVs
31551	payment	1397	1397	1678	1	1	12591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGid3hPBqSbG7tSyjYdsuBJ6iPx3Tb7QFZz3hpxfrro9Rxg3Tq
31552	payment	1397	1397	1678	1	1	12592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjRU81oYtKNEAnLaDzBLfLM4GZbdf1nUjgMnGhA6UYZeEGMcx
31553	payment	2133	2133	1874	1	1	3000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqQp3RegK6c5J8EXRi6m7TsKBsbdRgMBdAiK4NoEpakZQALYg
31554	payment	2134	2134	1874	1	1	3082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuWA9hxAtcqyCeHX3q9LJKpA68YncnjdHNKsSjT3UYZvydyEb9
31579	payment	1397	1397	1678	1	1	12600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSAY4r8H4xn89FVRvXfLrw6mxvyhLK3DrwKRZ1rYMaUiSypG2
31580	payment	2134	2134	1874	1	1	3090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkZLthM3KhAQRHGK4HrTKPV3knAdP28Fbj3GVCsEZ6XMRrmX2
31581	payment	2133	2133	1874	1	1	3008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1qpAnpNRCLXyCkU2VbHFRYhtGznXELwAhimy4CcQxk883svV
31589	payment	1397	1397	1678	1	1	12603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLzsPACrFH3AdFah42BQkSjxEShen2n9ciWfT4aFngncrV3L8
31590	payment	2133	2133	1874	1	1	3011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnU8Q6GDAXSGGEBKUz569CTXP7oRi2CuD5mUivzhSUW9SLu7X
31474	payment	1397	1397	1678	1	1	12571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3FcogX4KzoJu7R7cCRFVsqnxbLK1dXW8d5GvAHzKTRnL1giv
31475	payment	1397	1397	1678	1	1	12572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwtBppNp4whgSTmSMfFG1MTGaMSSrh1vC2Qd4zWEbGTGJ3mdEJ
31476	payment	1397	1397	1678	1	1	12573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkTUShvVFBnpr4puNNQ8EkvTzTVQ6p36UQmSuYjaR2JJC7zzY
31477	payment	2134	2134	1874	1	1	3054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7j1zQJKqMJFLu4YLurwLjysf7yGMkcU6yTSNfG2u5RJ6wM6jt
31478	payment	2134	2134	2280	1	1	3055	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LegaqjS4w6fuHwtUYmhRgDtgYkigx1v6Y8WCv2e6BjhWFfrF
31479	payment	2134	2134	2281	1	1	3056	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZG23shDTjgvU2dspyq1jQKHvuzvMtYoZ2HRHgbB6Mpfc4CJR
31480	payment	2134	2134	2282	1	1	3057	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUnwTK7WurjfvWWiBJEYAcsx2LJCtz8YMcALyMauGDTQmR2so
31481	payment	2134	2134	2282	1	1	3058	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64FY1GkLSWwNyaPiLiawnumLof4ukBt2j6d5u61WSxfnVvZRn
31482	payment	2134	2134	2283	1	1	3059	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAJsFtQ52B1h3pSYEN5ZnzfXQsqo3WQcMZ9g6V4W8soGsCmiA
31483	payment	2133	2133	1874	1	1	2980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uNVAU66MGam5u8T2pgStdUcG72f9aFQzqZeS2XKnrcgxii9R
31484	payment	2132	2132	1874	1	1	936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxidZZeWo7pjSPiaTTeYXVtHowvscUCJF4tR543LLwhEkP1QHY
31485	payment	1726	1726	2284	1	1	8285	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa1BKgPF3byFBCLJgBF8ZzTjKY4svq6eYMgQKUkSGwfSF7LgRL1
31486	payment	1726	1726	2285	1	1	8286	1200000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYuTyK8ps6Ye5c7kKXSNnovXc4BRp85XuAdGdLaY2rLQm1itN7z
31487	payment	2134	2134	1885	1	1	3060	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9bFTvH7Vc7UyM67FMxcyenrmcwQR96btWLRYzDJE15GH2Ap3
31488	payment	2134	2134	2286	1	1	3061	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cEJav1Cvzoj3qpSHT4wJjSzGn1i4MhJQJQFFHfHMqCaBvpRq
31489	payment	2134	2134	1874	1	1	3062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41p3oKB9W9Xi5HjxaLdV4PW8GApEyxnqcajDbfaDWaQzRtcdH
31490	payment	2134	2134	2276	1	1	3063	1200000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5kMSunt3r7h1SJtcZczhRvZXqLfDTske5hpArNfCBGmyZUU2
31491	payment	2133	2133	1874	1	1	2981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzCb4ouXMJb7Uy22yoY6aL7m4CGd6EtDViLi7eMV7kXroSnAn
31492	payment	2133	2133	1874	1	1	2982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6s17Uez7R9QjRn91nN3Y27LTvsbztLHpzcU8afFnWYvKuiotp
31506	payment	1397	1397	1678	1	1	12578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzNZJsBkciUdLCi2qgvQnub5nJc2ALyU6S7mHHx8PkgsAxKRq
31507	payment	2132	2132	1874	1	1	938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJmnP5xjs7MZJeuL2mEvmHYE58Xz224yc82awjuUgtAHdJbEk
31508	payment	2133	2133	1874	1	1	2987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KxkSsyKTB9fi3bKLDUQGiYNNuNMZE95RQ3V9F83ADV6513s6
31509	payment	2134	2134	1874	1	1	3068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hH2tRMTLJr7PNW4XutpCoRV8Wm7RvCepFG47A3KTdCHCxXnJ
31516	payment	1397	1397	1678	1	1	12581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFx5mHkKGfUWSLBj6n2pUDNrCxSxPUxuGZJyk12pdDkaE2tUz
31517	payment	2132	2132	1874	1	1	939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFu3NYfs5s4rqY1zGvuVGnTgr2EmXk2EL4YA5ovKBEyXdgw9D
31518	payment	2133	2133	1874	1	1	2990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7zuHuUDtqVHWE8hnN9gkFeNdjwkZLh9usZbMVxbEVV9qT8Ct
31519	payment	2134	2134	1874	1	1	3071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKwiSaTfapbkUdn6Xaj2svxsix8gn5SrphJe5iAWRdC8CXin3
31546	payment	1397	1397	1678	1	1	12590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbzF4g7c6FxqprNUuAC6MMsExkWzB41xnjg7Kp2EXG8iGi69k
31547	payment	2134	2134	1874	1	1	3080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKazZwXJBLF67kPeDvJnYgeMxEF5o9RMBiSkQq3Mv1JY91smeS
31548	payment	2133	2133	1874	1	1	2999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTtd1U2UHbHmDteThSNMzZUNAMKPcD1pUP5bzueikvVwKNGM9
31549	payment	2134	2134	1874	1	1	3081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiL8iRaMDYCZYw2Mhb7z9WVVDToz5M1fpesr4a97LeqkyWhcR
31550	payment	2132	2132	1874	1	1	942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wwwsLCUwwRnpKNQPPiUDsf2AxiZoa3TEUhjCq2EQqnAY4Rma
31575	payment	1397	1397	1678	1	1	12598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjb4JCPEM3dB11SxV7GoMZZTSZAFB95sBGgNnRY8hAxLkt5wpA
31576	payment	1397	1397	1678	1	1	12599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKazhrzfyEGEMFtAbHr9gmbuXNPwsQ6aEoNBo6Dc11kGe988aJ
31577	payment	2133	2133	1874	1	1	3007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFCJqie9FLwVFgwRbmWjnbkYXWoi4oXuYeVbLXWne3hcmp7vr
31578	payment	2134	2134	1874	1	1	3089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiywa3tLAWEs6KvHBJzrn2QMfd4bWeG73Sgsfq6xkEUBkuEznh
31607	payment	1397	1397	1678	1	1	12607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaQXgmsWB2tSeh9tXRHBcsEeLbUjF3TDrr2yn8csratJDVfg6
31608	payment	2132	2132	1874	1	1	947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh41A8dhhGEdrqTUN9qAkTKsdfaSKKi3WA2jJFVznkyWJABQ1h
31524	payment	2134	2134	1874	1	1	3073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ533enGNHbNunKsK7eWQemL1rxoN6bXzyvP5uo5anqKxJog45N
31525	payment	2133	2133	1874	1	1	2992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidixtccBJfVqNx6ScP24o2Koeq8KzuVQNghHX7JeMj7BuT7Ai
31526	payment	1397	1397	1678	1	1	12584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwdVUimAZfTPK5k4F6kdfmW5q6CQNG4u711gnFpqatHkkKZja1
31527	payment	2132	2132	1874	1	1	940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbj1QWnNK3fedZ2EhDr5gmivMemN1AQjr6VBKbr3e3tVd1ebj
31528	payment	2134	2134	1874	1	1	3074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BmbiDgJjP6hrnxq9bhgG5A33rDYHgT4jkwuiHWWjHGp7VhbW
31529	payment	2133	2133	1874	1	1	2993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgU76SzAf9ZudgZ6jMpt3X3mc74FbLTz3fyuv6zFKUmUCLzDX9
31536	payment	1397	1397	1678	1	1	12587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kD1Av9J1TwetgWxMGCTGidEUVwLpHTtskkTj1D5hgeD598Zj
31537	payment	2133	2133	1874	1	1	2996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wbWuTX6MHBTVBVtYE6SiZJPbhr4J4iyeK58im3b7nZf7QSfZ
31538	payment	2134	2134	1874	1	1	3077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSwErmAun3pFizdWwXLnCpoMPaHPkwebPVABuFqDf9y1NFyJAd
31571	payment	2134	2134	1874	1	1	3088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFWePYvKGdiDGghw7uBxinphKtnARgtpsFuUkLWMtiKmupypM
31572	delegation	259	259	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxdNt9cnYdU1muyQwKDKi7dzNkBF2hTdeasehgKbyassU8Jmx
31573	payment	2133	2133	1874	1	1	3006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzs6Je5b1DQ18dmdSULRuErLY1Z5bpGGLU91Z8T2JWfoC6vV2
31574	payment	2132	2132	1874	1	1	944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZKfTmnhQAacUvcq2ovQuSBUgmxhzWCoFQUk4cJ5ytdpNjZWv
31586	payment	1397	1397	1678	1	1	12602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCt6Y38ppdxTWiKAnrpQQRhCLdgYr4iYtVCCxQyJPRCxAWTvW
31587	payment	2133	2133	1874	1	1	3010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLRkaMDr5xm6TqerucfrqVbbx5eFCs4bhSyMZBnMAfs7ade4G
31588	payment	2134	2134	1874	1	1	3092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLeteBSYdcBndE2LLzixn1T7U566mE1ud1b7pVad9VmU2CFbe
31597	payment	2134	2134	1874	1	1	3095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQR9QnDCeUbrKVyuqqznUYxuihh26qrbh1Zdi95N86myQ3Py8j
31598	payment	2133	2133	1874	1	1	3013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprpJCudS8Aefbadnv6QykajDFmmwcW8VZiJQ7vGihGZQj6ua2
31599	payment	1397	1397	1678	1	1	12605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcLajYYF5UjxEHRZWBHSk9CutSidGhT9PsE6saQthEPhtNm7z
31600	payment	2133	2133	1874	1	1	3014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhC69wKCjFaxhbWdfycimSefwKXmuYEeG5oSdvjBer9uW1gC5z
31601	payment	2134	2134	1874	1	1	3096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsokgLSvv99LfxC8RGumzDMNusme1BRf6om5DN6E68gjQhMUav
31610	payment	1397	1397	1678	1	1	12608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSddh7sQQMeaH4udDMgg3GDUkj8wbAZPVJDMSbMrNWg3WpSsAw
31611	payment	1397	1397	1678	1	1	12609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA2MViJyX7vU1bdBMznT5ffSqs7x35fC6pq1tyMSwBYmityjF
31612	payment	2134	2134	1874	1	1	3099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8foCkRReYz9N51fn6h8J4LQWgxGUK54Aopza1bJuWZLwwpNr
31613	payment	2133	2133	1874	1	1	3016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYU9KyRGWkEof8wipabnjqMeZeWF5EffKQ9UoqY3BTKQhUZx9A
31614	payment	2134	2134	1874	1	1	3100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTLu6NKyEvpgiQFucpurZTeyWpnrHDxQZpMx6aQgoz4mvQJNi
31615	payment	2133	2133	1874	1	1	3017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDay2hE3cx9wrB3CHLCCApRwwuV4BeVaVAeBswvsWyx1qGVfbp
31616	payment	1458	1458	1323	1	1	7	8296000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZSc1jUXcF9s6soZGnKhWHsb3oCr6XzNbteDkC3eUNtLnLPhSiZ
31617	payment	1397	1397	1678	1	1	12610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNbGRg1GkvMugub8eSfQjNEFWBEGJ6z3Tb2dvu9BbvCGUdnTq
31618	payment	1397	1397	1678	1	1	12611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJ8Wmup8UnawQWwg8X2cJWGCvW6V3b1jf8C9traULbWACTwaX
31619	payment	1397	1397	1678	1	1	12612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLf1Z5M199Qk3i5fFWdH2tgkWsdLjH3jwXeT9bA1ddHT48K5xf
31620	payment	2134	2134	1874	1	1	3101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStErZxBEA6RD84hvmuX2Pmy6uVYu5zw24LXcNqCxE9TUTH65p
31621	payment	2134	2134	1874	1	1	3102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRn3bMqF7B97UC82eDwCmMB2Ych2p26CiocKRhL1fZDzDDT5ie
31622	payment	2134	2134	1874	1	1	3103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3fS8D8Yt7Vh36mbCiztoQL5tcaL6zS85RrdbizFSZMQ1Rycc
31623	payment	1514	1514	2287	1	1	0	20000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3NSNZ1Pq7EEdUoov7WUGQ9s8K9HReJvZXGiZULtMtJSH8tVd
31624	payment	2133	2133	1874	1	1	3018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4awmFaNxdix1fWsqRwasMiiTTYgfTSyDBTc79kJmdef9ishn
31625	payment	2133	2133	1874	1	1	3019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSg3rPTfYHDspQ3HNcQtBhMq8pqxMNsF64EG5Z66Yq8nir4FUo
31626	payment	2133	2133	1874	1	1	3020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJc4J4qCvw6ejmQs2nCEchaQmau79CwjNAMfCdcHHznT8RpBd
31562	payment	2132	2132	1874	1	1	943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTPvGzESRZUwt6uUNEB7NoEBUy2fWMrvLif9zi8mM8mUefsSu
31563	payment	2134	2134	1874	1	1	3084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTHoFH2iypQ6dopvxchvDoqQ8v5FQcuJjgB94VHLhNsfPyyHm
31564	payment	2133	2133	1874	1	1	3002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDEAa5nBFPvNEhdPkzaY6uFiyQaieh2NhhjtAU45ci9P3hDBKC
31565	payment	2133	2133	1874	1	1	3003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLfKsgz4CeLjdeJiCZeAgnpifSNbgXE1XFgWyF8yhAz49eBjS
31566	payment	2134	2134	1874	1	1	3085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSVyfCaD7bFov9tJnaanqt4EJsZmv2KHFoX1dX2REZqBQjph4
31567	payment	2134	2134	1874	1	1	3086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5axiXVbuZ66MEAAEyncMHfH9DpQ9cb8rpfcNMrNfSP8kev7y
31568	payment	2134	2134	1874	1	1	3087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6GfsX1BeBvYi2PTAcpgXSBerEu5XRVJqRotM51jqmSaWkQsU
31569	payment	2133	2133	1874	1	1	3004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8zkxY9PvVgFYj5iacM89YNfCrWDmPXwSAJ285PbPoCBxqHqf
31570	payment	2133	2133	1874	1	1	3005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGR7F6sWUgjkYiq96VpGYkFZduBgGohzrRiAGV9ig8AFruVj4
31582	payment	1397	1397	1678	1	1	12601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRcfz93Epj4WrbSAMntxrCU8EEAm2j8RP1jQP7pyR1XCd9pf6a
31583	payment	2132	2132	1874	1	1	945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNemsFE12oRMQUaoS12Xncin37bM9Erhpdo3dvcgBLPDVEru6
31584	payment	2133	2133	1874	1	1	3009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLcDPnSCEJavi3wgQVecQPn83YK9jfk2BxtXEMRYAnXUqhuzR
31585	payment	2134	2134	1874	1	1	3091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gbG5q84oiHCGUF9gPGy49mysstg5ZWfKFFQb2w8CMtTPEDMB
31628	payment	1397	1397	1678	1	1	12613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGTNpECMPDPGRwtc7AvyyL1xup9JxKcnY7mSovL79Q7kyYWwo5
31629	payment	2132	2132	1874	1	1	949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVtvjTU7NvRkv9aTrWpD7e2JLkPEQZBkPxNFUHGb7Lj5WNdwC
31630	payment	2133	2133	1874	1	1	3021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TyXB6dqs3sjkg7aMppGBbWs4qSAB2auyJLnGAY38sNJyGYXx
31631	payment	2134	2134	1874	1	1	3104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1G2JaxKctxHbFsaKUfQNpkxYEaJtcCnNyowchByYaSspBaj6G
31642	payment	1397	1397	1678	1	1	12617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pYheXNa4Fyv2TfXqcJVocUXb7Lv3ZczfH7UGESANMFXS5atM
31643	payment	2132	2132	1874	1	1	950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfEiJP4439JhKtsZDXrHvL7QTv9qah8qKSPggqoujzDJgmQxD
31644	payment	2133	2133	1874	1	1	3025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSseiGgGehrFApkQ53C5KfC7HVVYa7eQqcLfBBcvzyMDr7W7jW
31645	payment	2134	2134	1874	1	1	3108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1BMLWt5WbJnJmvX4Y5Qd7n21XCxNGW8XrK1zxqS3eth7DKQV
31649	payment	1397	1397	1678	1	1	12619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowfaJ4cS4gu2JYnH2jNFNM7PN33j57xJ33UjLdEuiE8K65uWy
31650	payment	1397	1397	1678	1	1	12620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEr1aaXEcdimzBREvbbbKNVxSRPRR3AiseFqm4VdwWMdLa8Eoy
31651	payment	1397	1397	1678	1	1	12621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6UXyL7seWMwUW9PTJyQ6mb8h3LDrrXxyEkxFcMnibQAZepYy
31652	payment	2133	2133	1874	1	1	3027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYREq8YkPHAdvst1MdxFH1Pf6DvWTsN7VNvAnRB2fFhrraumvtN
31653	payment	2134	2134	1874	1	1	3110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9B2fSZuac1adRLSUx9QWLmwF9aLCqtGns7RxJBTQbFqsRWPo
31654	payment	2134	2134	1874	1	1	3111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVXeJDgEf4nap1dHMmq52iuZaD1XsxCVLaBmoxFVagTHSdNe8
31655	payment	2134	2134	1874	1	1	3112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDapatb4iPTGawhhmQ3JsMKKVYmnHPMKRrUPUBag8pQer1UBZ
31656	payment	2133	2133	1874	1	1	3028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMrVeguBMVQqCh5AaFrZERVoPayag11xUF3C3bigzwGBcn8Kh6
31657	payment	2133	2133	1874	1	1	3029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwsmRehw8Yr42ACnfgVcYQYd55mv9uqQmkh9ugZgm5WhdY2Zh
31658	payment	2132	2132	1874	1	1	951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQm56E4mkVUZZSmNex3G7YusbM27dXJ3BWoiLYRAkMaZLotat
31678	payment	1397	1397	1678	1	1	12628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1qinGjpNaD7oSAtRZJD9UydXt4t35cuoxTTyMsbKogzx4QTs
31679	payment	1397	1397	1678	1	1	12629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2Hs1jHcV95sRFVGA98A3taGxtjcA5iq2DcV8yxV9cuBXnWTe
31680	payment	2133	2133	1874	1	1	3035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChpAPH3QetKrEEYn8GDZDRzigNXSKfeyzQRQJ4SnksPQ7ofH7
31681	payment	2134	2134	1874	1	1	3119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpuySk7HTgfSVkXJ7iRYxQYC2dX8XdYwGCEoi1rKwqzsbWAtg
31682	payment	2134	2134	1874	1	1	3120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQ77UrK6FpUWL6wBSp9vLKCY6bVAHH7XpaahkuAfc3XEy1PGj
31683	payment	2133	2133	1874	1	1	3036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEu991oJmoW1jB3hX4AAnsms1oRt8R5jeoyfFDk9R7mEhyLfQ
31688	payment	1397	1397	1678	1	1	12631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHiohDoAiMvJMCtVaT7MtLcFZeBXqpP3nSHAJBdoGgmDmj7GR
31591	payment	2134	2134	1874	1	1	3093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4h6Fcm6PbW2zjaW8r6Zx7VNPoji2Rxu1ts1sBZVY9AN2F9kAu
31592	payment	1458	1458	957	1	1	4	2463000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZakxnFs6ePGVYDotQ9a2gzoF9g5UJ4MjuoJqKZnb8ebzafLKVZ
31593	payment	1397	1397	1678	1	1	12604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4t4rV8b7cCgn2MQCkkmqoWHWQsbnW6rcF88S5i3TXYFfif8RU
31594	payment	2133	2133	1874	1	1	3012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCeJaBwAdbtNcXSpjVqBsHJ1hHxbSr1fcmPgLMfEQYk6jNqxq
31595	payment	2134	2134	1874	1	1	3094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPsjdyTA6ZcFogHAVtaNQbX4EUzorAPPf5ibEStajZ8jnWnoj7
31596	payment	2132	2132	1874	1	1	946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsu2UeJiT9qMEgiFZJB2WmgrwZy9WuJqfVjwENVUNnmcqwY7x9
31602	payment	1458	1458	1197	1	1	5	2977000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZyGDt2QUEgTAjvwMZBYYHRaNdqKAatjDrpyuoG1kCMXQjtTCEj
31603	payment	1458	1458	1077	1	1	6	4412000000000	200000000	\N	E4YjCe7EiZsnfuNwWcnXN3WxGJpfJhiuZXD9Zos5w3YipSVGEY5sE	CkpZ8WmEXUGXy8hsyVnGSjRHGZve71yp3FZCtR5rjZDyUDuuT4gB3
31604	payment	1397	1397	1678	1	1	12606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwds8Tp79wtPKV8eN3FbGqqRZJtBGMX3E4nKRYjLxGVcpQNfLC
31605	payment	2134	2134	1874	1	1	3097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5kJhY1gxaoNVDQ4mzH1jFK7KjgKCgsByacY9pXa1Faf8gcHS
31606	payment	2133	2133	1874	1	1	3015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hJdhxoLSsVBdNxKeZyiJPz5GdGoPDHuBWtHsTe4vcvH4aFrs
31659	payment	1397	1397	1678	1	1	12622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdazYfz88UsyjZ3WChXcbrSWqZgV2kaXdtJueeZoyJ1Ja1V6hf
31660	payment	1397	1397	1678	1	1	12623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EQJrTDBoit9kEnvZi4LFxGTv2WSpbA5DWqWnCTauqh5VyF71
31661	payment	1397	1397	1678	1	1	12624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2Q5F12qCkG6P2DqMRX1mg8FYYryUUh6WknkjzMbcMZbr9dLX
31662	payment	1397	1397	1678	1	1	12625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6P7aNr4r51s4aSjpDHX4m2pUp2ueVBXVRzvRycnFquUEjfxr
31663	payment	1397	1397	1678	1	1	12626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyfpRMtTFYCH6x3JpA2oAiXoWx4u8VNWpS5JW84E61ZCcmzNa
31664	payment	1397	1397	1678	1	1	12627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNLuniSqA5nM3zsZKX4W6g11dNvwdsNyc2PSwLicNGwSc7WaS
31665	payment	2134	2134	1874	1	1	3113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYfXtZRv39dwwTCcsKiSJ2sroMcSMnQ2t98sT6C38DG8ssGZ7
31666	payment	2132	2132	1874	1	1	952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqDEHMhpvEjd4cYikBWBvH6riTaJnoqMer2jrLkmMwkCjebp6
31667	payment	2132	2132	1874	1	1	953	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9vfbUgLD3hr7VmxBZGcAL3qqcsRyERRRAvB4CXPqeToxFeXJ
31668	payment	2134	2134	1874	1	1	3114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ipnWtCgo6N5qvWv5ueJ2cbqnDuXB7jHNmYNU1oVuehrfPmTt
31669	payment	2134	2134	1874	1	1	3115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Yd2wP1awSftkvM74phrFS1WMaXpTSayBd8ZvZa7qNXLrdRg
31670	payment	2134	2134	1874	1	1	3116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZaxjE53vLv7sFhagdFbZhYkSadvcyy74V32H74pZcGbntG3jt
31671	payment	2134	2134	1874	1	1	3117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3ZFGYjdeoCcF2QNmN9D4Hv7LVSrZzXHyyz8MmWehaxDsKwYm
31672	payment	2134	2134	1874	1	1	3118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXuDp9wC1NyUi19gNSDx3HVqGYKcGNWaKH1x9o9hhNL8koHWc
31673	payment	2133	2133	1874	1	1	3030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLCyWyc8XqCyPBaCq26BbHYgRzQ47YN9Fvyawo1xtuZ6mU7WPZ
31674	payment	2133	2133	1874	1	1	3031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiMJ6RS4SWM2FdDiRJM8Q18czXdQ5eDRioFcGgrxm6MqhHy8s
31675	payment	2133	2133	1874	1	1	3032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNtQD2wjs1zkKoAJpTgjy7Sf7sBajifTuy4RYM7oemKnSWjez
31676	payment	2133	2133	1874	1	1	3033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPURw94MYDNiqomDhKSKCquohLK7zTM8AgG5unLvXy3baLYr9
31677	payment	2133	2133	1874	1	1	3034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuccrwgjMvfthNke7ToqxpMhNKrYsrQC3Dm9PiqDx2ACGsaGZ
31732	payment	1397	1397	1678	1	1	12644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGPXAVN8VWC4GXT2bVF3yNjbj3F5eeCD2JfLk2HQjKXvxvWCe
31733	payment	2134	2134	1874	1	1	3135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TkRMQXwd92aDUWZPhBEEXQkTrSZcrMh76Navgcej1v2BGB8Q
31734	payment	2133	2133	1874	1	1	3050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJzrJoXHYcLYMVz2q8fF8iC6of5wqVnc4kzwFAq5w5yruGuqV7
31746	payment	1547	1547	683	1	1	7	287000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZpb6snricKW4zdjHq4ZmZttWUzJ3YwPSMn1TsdmaYTUTCdg8bj
31747	payment	1397	1397	1678	1	1	12648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2HmwfDsFgMGQ8Gj6XD8cQEHoU9M8ZeaXnX8h49c6dV6AybCog
31748	payment	1397	1397	1678	1	1	12649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1iSE6Bzq3z7PNEZoSJFtgDgVrv7YhoknYarqhZVRuRiiJJW9
31749	payment	2133	2133	1874	1	1	3054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmvTvJe9FeL6khiLh6S41tjHwgsgwZqFj8qaCfRDthgGaXJZJ
31750	payment	2133	2133	1874	1	1	3055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkY9QBszPxhs7SDqsT9syhX9ETZQeaQJYHwLxeGxZQ6vM3BQC2
31609	payment	2134	2134	1874	1	1	3098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqbDytJ57eQ1e67dwN4gtK5b5oJEX1VC11Au94qidDbkU6G3k
31632	payment	1397	1397	1678	1	1	12614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiG8uLj3pjQWwpNQESZcR827aCW2yHiDyf5r7Zne1RcFc7MCS
31633	payment	1397	1397	1678	1	1	12615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2kMy98XBc11BPM9SCi3bbZT4chhBc27hMRhD4Kk8ZFSneWq2c
31634	payment	2133	2133	1874	1	1	3022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA7RegLmNUqiqAckXMZWzfRhSei21tVcymwLjQDcgZMJeTh4bv
31635	payment	2133	2133	1874	1	1	3023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bxni5KVpeKuHSqXpoPBAHDL6TLkkcChzrP9WjcsL9aDSHKNn
31636	payment	2134	2134	1874	1	1	3105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAENKh3fVsdfgqkZRcDP3mzwx5gdoMKrXz6e9fybbATbVeZMeR
31637	payment	2134	2134	1874	1	1	3106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHNzNzJBW5YDbeeCL26FWhXGb8Szr1r71CQAc2FS4JDVC8Run
31646	payment	1397	1397	1678	1	1	12618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiemRgQQ5s4GMzmHDat7gxwfcUD6tDVht2evu9ULYm22SefWfS
31647	payment	2133	2133	1874	1	1	3026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aBy8KfTx9PULVn8N8D9AdVK4imEW1t9LHf6vvp2JBRGujLBD
31648	payment	2134	2134	1874	1	1	3109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizdJdvZRUM7QvqGCKt5RUJup7Zkt2JYgnxg82ayx52imsijYe
31684	payment	1397	1397	1678	1	1	12630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9BhUjQMp2FPQ14bg8RJb9kQPhURpv7i8ndLu5U73Cx4N2DUq
31685	payment	2132	2132	1874	1	1	954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCFzQu9mYQEfjHJaEEUoKfgHdKU4ecddpEsP1rXeaZeNe8WoQ
31686	payment	2133	2133	1874	1	1	3037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqR1hci8NMEFjnPWZ8KQg8JdsXwh9JiGGji8TxHgzJXVxJAn2s
31687	payment	2134	2134	1874	1	1	3121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwt8eWsWEKrGR3TV1LDzcsNrwXS4WR3GnQh8GcLzSFG32FFJCs
31702	payment	1397	1397	1678	1	1	12635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsmzcFdqzFx4578Zhx35sUTXyyEs2C879wuNHq2qg7fn3Vu1B
31703	payment	1397	1397	1678	1	1	12636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHdssGWj6v8WwG6M5dPKJcsG5AdyvgmSjM4GbtPFbT8T6G8Rz
31704	payment	2133	2133	1874	1	1	3042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89R7HpFsn4v9ZcDJqPMsPzwvELJPcNXfvhWpTbYdxFYx8d6Mj
31705	payment	2133	2133	1874	1	1	3043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZLYTNaxQvB8dSWnW9h85MTVxhuJMa9wEKnJwHb8cPomASvyG
31706	payment	2134	2134	1874	1	1	3126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9VTGdbrDKdGwTRFF381koL6zbDmZAtGTbGAdQSD9rsouZSmE
31707	payment	2134	2134	1874	1	1	3127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxPRpu31kuq8GwRhsRbiL3a1LTvXNDgzgQCEg28U1bskA1xdy
31718	payment	1397	1397	1678	1	1	12640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLRB3Kb98VupoH6sN7MzQHxHvcVLifTsxexS9YKAAxziYcUXW
31719	payment	694	694	2288	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8s1WrzcaSdHGJzCK53Jj5pVXmAJZCvRHtvnxCQsUtoAUd8ue
31720	payment	2132	2132	1874	1	1	957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdbRYzbNn2zvVNAfRgyqnPJVP6Yoh5e1Zu28LBFLdhfuj9TZ4
31721	payment	2134	2134	1874	1	1	3131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmoJx2PNGAksooYDxiKSbmYs3ZeQeTc6xfUHYLgUfZaCs3Aq6i
31722	payment	1397	1397	1678	1	1	12641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyY6V1CX4ErRyQeVSKHjTN8rybpKVWwPDHvdeWDU9V4XH83RFs
31723	payment	2133	2133	1874	1	1	3047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4n5WZteVQmg1kaKmbPSrMqdSChVrs8NXey7pdMKBLWGANQfGW
31724	payment	2134	2134	1874	1	1	3132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XxxEdKb9Hiwgnu3u59DuhCy2qu5CHFDnvJyDgubkTif88W2e
31779	payment	1397	1397	1678	1	1	12656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5i4XC1hpW6Whu6FM1ehEg3HPWvpBGYQwf7X37tjKbU6MMLXMp
31780	payment	2134	2134	1874	1	1	3148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcvQ66f4nKzGsHn3pimPwETonCc96FdjnSP27aTSmhK2CA6f4
31781	payment	2132	2132	1874	1	1	962	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHuKTkQWgTSt8YZ7ic3exoP1kvbTRgBPBP6egfVJCFzAzAbc3H
31788	payment	1397	1397	1678	1	1	12659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVSiWnXzS81mP7PQbWeszpS72M5LaR5dDx7uhd8wjF5jytHtP
31789	payment	2134	2134	1874	1	1	3150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUsV3gaGpy9jVhaTRfCYvdnSXRNgRg4bzp1tUx1Cn3xG5mHCYS
31790	payment	2132	2132	1874	1	1	963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymZMYKYHTniF5YYkx8vebg3hzjc2zJSRjWQW4UPz1s3PkB7MZ
31791	payment	2133	2133	1874	1	1	3065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14G6AVKutdDcAp7jAuWqg4krxwXmYZhHExkcXvU22Q2BtaVmP
31798	payment	1397	1397	1678	1	1	12662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsdXDMBaLtmgpKvGb6owJc9xAtgwereLBFK8jkJXs5YBGnfv4
31799	payment	1397	1397	1678	1	1	12663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WtFWSEz8iCWJoYGTk7KLeKLEwYRvFfgBcymLeCd1uir5WAuY
31800	payment	1397	1397	1678	1	1	12664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6rbpt5jWkXPAiXx65unCVdSvFBGUP9QNkKpaqrnWWRk3pkGF
31801	payment	2134	2134	1874	1	1	3153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSS6Ps9Cok9Nexahr7e4d3EuVSYQXtN5J4e4wZSroEEvdaBYU
31627	payment	2132	2132	1874	1	1	948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLT63rRxjZ31gVW1iJww8fM6mJRZBNTDriXumANLwd1q3dpr2w
31638	payment	1397	1397	1678	1	1	12616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5v3Nh4UpWTAnA9SnMPFpD4g46FgcSEBv5FhKG2i4MEm1aUrg
31639	payment	2134	2134	1874	1	1	3107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGhPPBtoqA4U6HsyULN1sr6u31HNSmAhN43kfkL6Fd6BGN8Nj
31640	payment	1514	1514	2287	1	1	1	700000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQwao3kqNW4btxRwNKN8EMKvMo2qW9YkTHFaJ6Xgmu5ePtdNx
31641	payment	2133	2133	1874	1	1	3024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVxMZLEAaAnWE8Daa8QZwAGYt5ERVcWkr6P4LjoaWauLCL11j
31698	payment	1397	1397	1678	1	1	12634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVVX8c1kevHsP4RX4riztw1jjGTJcrMZmA7jFcoi3Af3eAbNr
31699	payment	2134	2134	1874	1	1	3125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgze29fgQ9fRrJ6oT4RSF5GEYLsHTSf47D9cRQuc1EX5sDm24
31700	payment	2133	2133	1874	1	1	3041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGA8EsLbTPRDAfKg9S6iYnACoQM5vVGj4bhHTPoU5o5mwAhB9
31701	delegation	2287	2287	1514	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpi6Aa7LN6fxCZiewvWkzfEBxkyJsKtisMhkmk8SATTzTHpgo5
31735	payment	1547	1547	683	1	1	6	1000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	Ckpa1WXUfHhXpX5aokMxqDH4DhtSBu6gAinkRizBjnUVcPusz6MCv
31736	payment	1397	1397	1678	1	1	12645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhkvzS7125a2qrfnScmi2AM7bJSmiYEGXVrHHchWhDteEa2cor
31737	payment	1397	1397	1678	1	1	12646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFN442JWMkzj1Pd7VZZXFEQ3qJXsW7HScgBwoV5NQ7Nc2gRpXf
31738	payment	1397	1397	1678	1	1	12647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmtCKKfLtEmDQ5j9Jh3uPTuDdijqhZuJAQvjk8zLa3c98g6tz
31739	payment	2134	2134	1874	1	1	3136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctHtBvYMJByzDXQXtzfAp1r4ujgEJCKvR2RWeDhBpdigBAfeB
31740	payment	2134	2134	1874	1	1	3137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD26qgTzqpBwD7tNkRtNBhmsw5XtxfPifMKtQuXfWbgoHoQ4V7
31741	payment	2134	2134	1874	1	1	3138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfqbuGvaQCKbEHB9vJeojMWrbUj1PoT4NfKVLv1F81RVbBDiv
31742	payment	2133	2133	1874	1	1	3051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQSofAQdyhJxS7kNt1PhhkUvVXC72p8FuCVnNfwcKkPbqxm1t
31743	payment	2133	2133	1874	1	1	3052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSejxRf8kYFohBMwsvepvVVbNT13BKyy6nexnyhrbga8CyRvPA
31744	payment	2132	2132	1874	1	1	959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpjBo2UXrcfpYjLnmQ1hs6NJaAk8bmE7FX9LHKEeBobesitJH
31745	payment	2133	2133	1874	1	1	3053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNMbmiVVJfYSiV67Boii1osJdx2ejhuDmbTETvCJWXPbSFuu8
31757	payment	1547	1547	1012	1	1	8	2189000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZPbqb6iMT4vqQPya225yXMCHkPjebnCHGCoUnU4drKCPMnFh1M
31758	payment	1547	1547	1252	1	1	9	2647000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpZckufkuMnkbQTxPJCGt19VDCUDTJoqQZratLEqmBonS6YqCu3c
31759	payment	1397	1397	1678	1	1	12651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCYoaqkYjsDWSrVEEKWBRsqzgDzLFqtgv9jggCj7ZBv6fBdPF
31760	payment	2133	2133	1874	1	1	3057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWiJ4uD9nHQjC7AcPspLkNr6jausc8JCaadWs5NZBn9CsKwP6q
31761	payment	2134	2134	1874	1	1	3142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSxFRNsAzZxB1msbYPsx4tAoysa3oxsY4j5J4vcz8Ce2VF8Pp
31765	payment	1547	1547	1132	1	1	10	3922000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYqKbBqduq23kuefgfzrZtCDpr7xAm3QTCXoUEUEYeMQipNbUUk
31766	payment	1547	1547	1378	1	1	11	7373000000000	20000000	\N	E4YhKrqFHwVVNppuZmM5MVpNQWGAKRLxnNVHbEUNjneCAdkR8sAFW	CkpYqUDGo2Nb1Md6wuBoMz8GXRjPmAYgCX7uWRwLVAy4fiVTse5Ls
31767	payment	1397	1397	1678	1	1	12653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixazzxjWr5jYuSFve6kcgMTwvf5yRHnJhr3WAkJooUx79ooac
31768	payment	1397	1397	1678	1	1	12654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrWMJuapANKYj1NCxDV6QH9xYne6H3rKLXhMBGaoiT4tHKbBo
31769	payment	2134	2134	1874	1	1	3144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTAkSimhkHugvBGYdTs4S5iZG2wdoJ9cR223gJcKD2gJz3Pyqr
31770	payment	2133	2133	1874	1	1	3059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRxtL9FJvcmpkoAFgECgKjVQibHXEeKVyDiwgnsBcomqM64kP
31771	payment	2132	2132	1874	1	1	961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GnrDHq9T4oFeGRmCNCekaap9pTuyvWirA5enaheh6ndwYeET
31772	payment	2134	2134	1874	1	1	3145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wDmbRDqjwDUGMkpZBtJsRhF7RXfbTgbqk55X54f9mN8owL4U
31773	payment	2134	2134	1874	1	1	3146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3B5Yuz66BF67zXUPnFw2KdQ6o9AQKQECFaAhny5Ajab8Gq4D5
31774	payment	2133	2133	1874	1	1	3060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7BVMc2NrCpRSLGXbiVAZAetyNojer4H4unBwiqQMxgokSwkD
31775	payment	2133	2133	1874	1	1	3061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYew2sbk55G8YpzaMnwSh6ZV758EAvhMdKNsiNU3578HyKh7Fsk
31792	payment	1397	1397	1678	1	1	12660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vHqE3apWvRpKsnnBDzKGhi4tNEgzJuzVY766QdWmruwkzj1Q
31793	payment	1397	1397	1678	1	1	12661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKWXenkFoLtDYGMRD37oMfycNGVSYLYj9dPcAVjLhK8qkdEHu
31689	payment	1397	1397	1678	1	1	12632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjszdQc62vYPzy82FGtWi2i69zThi5kyFUMdMQBXPQvYGhx4hM
31690	payment	2134	2134	1874	1	1	3122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEiheUa1R8U6be4FpCHH3qRkG1oJ6tNmFJ71b9S8EtWAodSZc
31691	payment	2134	2134	1874	1	1	3123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrV8D8EYozPhxwijVaqANpSmDHyJyXWNMJXoepNHWwijpvd49a
31692	payment	2133	2133	1874	1	1	3038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLh5vusPbbtTq8Q39ShpiQ8UQYwwmAWMhGawG7EnZzAiYZAQEY
31693	payment	2133	2133	1874	1	1	3039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCoYDBE1jvQPzc4TxuhGMBN2t2Q36isvzVtCqnnyzuRWb25mn
31694	payment	1397	1397	1678	1	1	12633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQ8BbmLdWVapSwMTP74kL8rYdo9SZ95C4weN9nw7nAZttWVQt
31695	payment	2134	2134	1874	1	1	3124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEYp3FmHj7QqdJveRrYxGgdq6zGgvYkw2DCxha9GNp4c9gT5L
31696	payment	2133	2133	1874	1	1	3040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HGtVYTC68NdtyGjrm2ddnC85D7MDX4RESFuZF1DEyiJNfG9E
31697	payment	2132	2132	1874	1	1	955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RNc6BV4k1CHEF6N4ixA3M5sRvxrjAWdZEvFqUnrp1WqNdhf6
31708	payment	1397	1397	1678	1	1	12637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpj18yDFky2VPkrRDBGXkmvFoZuCBqkb1gLasRP2mL61fn5Rsd
31709	payment	1397	1397	1678	1	1	12638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsFkgv3x8wLNdLWXfQwYgjAJ1Bi8FuxC3QCD81RBGUHwgWaw1
31710	payment	2134	2134	1874	1	1	3128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqCx1UYbjf5Jwa3eDModpGFkGCFZdhtQvATjhquoPTKKWDriX
31711	payment	2134	2134	1874	1	1	3129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWfbLTedpZjGwhWtKemdACHhqSrT4Chpk4CXV2gi5b7Txdrw3
31712	payment	2132	2132	1874	1	1	956	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHePr6Q8xG7XY8QjvThXgMLNXo8Ln4BJog8mEUzEfhEPxcPze
31713	payment	2133	2133	1874	1	1	3044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7rhSFRDfCcU6gz7HUHb4g5BiCEPC5hqipj8BhLCLy76x9Gar
31714	payment	2133	2133	1874	1	1	3045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSGUe46aakUFJZxFcvyQiPtNyngYZh2ruPvHNVCsoRRjqb48z
31715	payment	1397	1397	1678	1	1	12639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DNPAugwbYdmGxxEbDsnDGVkhAA934ekHJCUiA8z26pJAwaWD
31716	payment	2133	2133	1874	1	1	3046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzi6e4wVbBwjJrdZ94w1Ebvq8mnYKe9Lpe9MSuqz6PVt8yzYo
31717	payment	2134	2134	1874	1	1	3130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTQLXQpFSKApiWBZ443NYtBRY5Ld1Ebgg7K7V8xNZAywC6yVV
31725	payment	1397	1397	1678	1	1	12642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzfHNVwGbAMP7RM1YGxYgD2goGNWRwBFH425naXczLT4GcTZGj
31726	payment	2133	2133	1874	1	1	3048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxcrK5qMnc25bYtmPfRk51un7ihV2gFYNq7anFS9ubBevKsZA
31727	payment	2134	2134	1874	1	1	3133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAagxbiQiscXYS5PCJGRJ4oWT6QGnkaejWQNwsx7m4mPEvXdRH
31728	payment	1397	1397	1678	1	1	12643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5nQcUZBjyuySLeAbbEeMWukcgGvZichU4ZR7UYhue6g5xBto
31729	payment	2134	2134	1874	1	1	3134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT8a9tuqofsTFKz8tN9kbhsTKmnL9eQbxfmMnvDNtaFdKnBpX
31730	payment	2133	2133	1874	1	1	3049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDaXp5VWorHVEZbHshbEQDa71zLCeZhLyNdPURBFWa4BVN3Ws
31731	payment	2132	2132	1874	1	1	958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQBA2o1EP4Y8EgE7ZYn4LvZPJ1zUbB13Q4cv5PFaLA7nXshUL
31753	payment	1397	1397	1678	1	1	12650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7u8oEPPoR52duKu5Cv7meUjDdGQqmCLF9s1eZqhHwV5MhaQcs
31754	payment	2134	2134	1874	1	1	3141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuePPAQpe22Gr3paBs1YtQPHuSTUXeTz7ATb1FqMVqwyFGgL5
31755	payment	2133	2133	1874	1	1	3056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLaiCox2u52bmApN5AA6Y5GhnGrXoNeKxwanUjt8C8MZEvdV7
31756	payment	2132	2132	1874	1	1	960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpgm4pNzyfpLznaPHNu4H4K4UnEjGfrG3MQzkULKBTMKbEYTG
31776	payment	1397	1397	1678	1	1	12655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDX6D7U6La37fCksqhj8oVfjaC9KUKNxvUWBfLVfPAwKqax29s
31782	payment	1397	1397	1678	1	1	12657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5u5znhdkcTx8PcYHG19Wjn1tGhqegcRZ7a1FbCE7zdCNqVLSS
31783	payment	2133	2133	1874	1	1	3063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZd1a9KuCsjfWApTehbKaMLrikWoQPHs5eLKVbzqoPtUzAdJoz
31784	payment	694	694	2288	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1M9B95c5QSJvDJHCHRzXafb77x715efkXxMfQsp7NNkCZebZ
31785	payment	1397	1397	1678	1	1	12658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8w2u8yUDAfh6VxXrNhzPsyn6msKAam37UefJSV1UXuVXRjyzB
31786	payment	2134	2134	1874	1	1	3149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddu61fyBAV2JBoWeZTetcsFTiP3GRkVvVApJHxtXjNgMAHzub
31787	payment	2133	2133	1874	1	1	3064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjs4qzZzcXFgu8vGBRvcisqMUuqXCDEX6kSkuCW3rEeZTUWjau
31811	payment	1397	1397	1678	1	1	12666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5Xw43UPhtToarcbhYpgWjHoLsUybSnSgBRZcGiUjwa7Cwg3m
31751	payment	2134	2134	1874	1	1	3139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2KmLj7pVmiM3mN8XnbvMRufdk191XXWxKoGFwDmNiuRMBV9F9
31752	payment	2134	2134	1874	1	1	3140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumGJAD6rWhBrKztLP88TVXtzthYYEa6SbG21zPb9exxnH8P44
31762	payment	1397	1397	1678	1	1	12652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bvJ8mWrGCTdrjR3TymnRjWVpvb5ge9L62BXpxMozq7cGXJwV
31763	payment	2133	2133	1874	1	1	3058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzx6JtcTwmybqNjrk4MLrYPvn9VEtqFRqx5oSqp1BiAuMLLcew
31764	payment	2134	2134	1874	1	1	3143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvw9QqgmorX1Yxna6XiEPvz2HUUSEWwnjm1TuPu3prxZBncy6
31777	payment	2133	2133	1874	1	1	3062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TwHR1W2zScMXh5wZaF12pSF4sNGiynHdxKoqWphPq3TmJbSV
31778	payment	2134	2134	1874	1	1	3147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjXLas3jHDWDS3FnAQBG3zUwDA3AscyiKD5LvL43xzSyqtAja
31814	payment	1397	1397	1678	1	1	12667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFr5Wc4EQKTUthrWQ9ruMtYqh2UpbSnDemARydN7SfEVLmbiS
31815	payment	1397	1397	1678	1	1	12668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5BSjebKLxu8LUpDHkwVPPV8gwvifcwByKYphZ47HvvfMzvp5
31816	payment	2133	2133	1874	1	1	3072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU64zMoqRqfjdk5wQuqS2Hu35BVjMsfZc3S52xQXf8te2LxtLt
31817	payment	2134	2134	1874	1	1	3158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAQcvdvo8THXnxHkpnKqs3vX18ini8X38WuGxSxByRaEMb892
31818	payment	2134	2134	1874	1	1	3159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnr4bzzAGJULcCb2qADU4BKhfzv6JwLzsrrEGM3xfqa3nrZnw
31819	payment	2133	2133	1874	1	1	3073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRqQqLnrDbRJgwW24snkFPbqNUM7ZPzCpGVSfe4YS2Wi4AKwW
31831	payment	1686	1686	1771	1	1	9	293260680683	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpaGb2kbY3YTuqts4ewXpZgs7Hc3XVWqWdiB1XXqkjqdMvnMrwGT
31832	payment	1686	1686	195	1	1	10	289185790016	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYw9xdsJjSy6Q6TwALF4SxoEmk6HLmHBpZGTm35i4urWVDrPKRR
31833	payment	2132	2132	1874	1	1	967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnydkxAQpFHEvDiA4DRJnabqSEYuedcpXBiRio5P8wB8h9RDYr
31834	payment	2133	2133	1874	1	1	3077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNuDYYgtH9HYURpa5REU6DAB8iEjaZ6dpwjsfufvx7Hpnxtcf
31835	payment	694	694	2288	1	1	3	510000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AEBpWThAK6jE8U3aJzJHxzgHC3VUpJnT5vYyNAYXp3XQAB1P
31856	payment	1397	1397	1678	1	1	12677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEp1f5pr7aHku6voT6hj5uogEirGzpm44HdCHsxJ9QSUhFx75z
31857	payment	2134	2134	1874	1	1	3168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1km3VeotdnLnW72RfZGELuGoHxQmexykZsn3N4LsYYsFyfXdy
31858	payment	2133	2133	1874	1	1	3082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1qm8kvh27fVECfaQJ3aiwDkNoqa4Bm424oUi85vwfhwimrzx
31866	delegation	1686	1686	1579	1	1	16	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpe6B47uLz78iSuTECnHwtRMLGv7WWta1krKV7tgDyvETK91R
31867	payment	1397	1397	1678	1	1	12680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8NTWjCgMwsjcdTB5oLWuesk6y77meazComudUxq4zTvVSGDJ
31868	payment	2134	2134	1874	1	1	3171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAwcm6fYyq2v6UqDcw1qveJsFLwcM23Cpq3BhZxjtgsteNrLf
31869	payment	2133	2133	1874	1	1	3085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fAaeGHZLSJS7yGNHR8feMF6FDD8EdCBBgLFsx38o4Pmzmx8P
31887	payment	1397	1397	1678	1	1	12686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbGN7dU7gByuM79TtsSVR9kQWHg5T8WkDVawGjLcUnnS8fHc8
31888	payment	1397	1397	1678	1	1	12687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPgy6aoW5XkFNuXisknYMHtoqk74cNTzxdWPTvSSuwqCRFDch
31889	payment	2133	2133	1874	1	1	3091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzYUmVWF31s4GA3EWCAZTxGsjbyqEsjKgiYmmG3RdZ4VHb2q4
31890	payment	2134	2134	1874	1	1	3177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYboPUSMu6hzVTGYjZ8Yt4Eis99QzVyNWcbPj4QnEh6cmPjQvgq
31891	payment	2133	2133	1874	1	1	3092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUxvCGqA4pnnK9R9UtWcEoNQEbyQYF3wxYgaW6Tv8cM1HGZKY
31892	payment	2132	2132	1874	1	1	971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMM7EdTMsUGhstwLcrMkLqjJLxK3qzznJzAdtovXkLaeoNrjtX
31893	payment	2134	2134	1874	1	1	3178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBv7aTkuB8XoZkDCN7jkpwhcoKfysYULJvgKeVDzAdDdZCnUD
31917	payment	1397	1397	1678	1	1	12695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjQZ1WXzuj7QrPK2982V75QwE6gTz6LMTo3MVy1mUNhNJZaNr
31918	payment	2134	2134	1874	1	1	3186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfZJq8SfGHRy9bgu3hx9hoohL52xn9hKX8TMpajX8umon5E5H
31919	payment	2133	2133	1874	1	1	3100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBHfp24nCqDAzHj7VYSaKH8KW1MA4gT7964JbobzuNHwCNh5X
31934	payment	1397	1397	1678	1	1	12700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBHC2mBmwiQZ453VaXtFckReK8EpmTPR8QSTtzHKUtYL6keEE
31935	payment	2134	2134	1874	1	1	3191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDsiYynaPNnn38cVCtxArRsWoYvFLs9EYcWNT98tzte5ejtg9s
31946	payment	1397	1397	1678	1	1	12704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYViPg9LUHppXBiNqpcscwFSSDVmdUvUxERk8fqGEczXQPK6RfH
31794	payment	2133	2133	1874	1	1	3066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2u6RVbSbqHDdvQwA4kAv4drDs53gt7ayUKBU8MQo1qLcUJ5EK
31795	payment	2133	2133	1874	1	1	3067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXBaYC67SW5o5KFyGhFF5S3cGtFEsFSfc47ydrccWfUh4e5Bo
31796	payment	2134	2134	1874	1	1	3151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vtyf8gxfVcHLZVBCnnGp9oXKocb1sGQkkZMJ7SgoV2mVYzjF
31797	payment	2134	2134	1874	1	1	3152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigsW8EvRvd2JGr95MwtDmvCxHGb5MH3qMLCsbBCyyAUhy4VZe
31808	payment	1397	1397	1678	1	1	12665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSk4z5JjRrsY3YYPCrQ6KMa8RMApQt2rvVSqmfneCHeEcV4fyD
31809	payment	2133	2133	1874	1	1	3071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdaTJoA8EKEUBgb65o7QXBDERFHCH3EazqYHHWHGHs4nYNZuRR
31810	payment	2134	2134	1874	1	1	3156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJnKKnFSN99KJXceDwxJp7znAtEeuG3xgguzW4rVxTa4Hfnpu
31836	payment	1397	1397	1678	1	1	12672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3MBxWggR3TjSFfH5DWUGLCwtwvLt3sg7mc5bp7ZZZNec8sSa
31837	payment	1397	1397	1678	1	1	12673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeovzsWzuiDp5m7bcqnDf6YK8qvX3bV77HoeDuTznvUFx9MEej
31838	payment	1686	1686	291	1	1	11	289185790016	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	Ckpa3P9PEPxyPKNM4uAjaUiVvGrdTdqv4M7xc9Qxk5PyrWbjHRjCx
31839	payment	2134	2134	1874	1	1	3163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPQNzajXVT8rbVnwxicASKqqKpLwoR7k8nw6crzaMquh63nZ7
31840	payment	2134	2134	1874	1	1	3164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ecwgHYDV41bG9WU7ppdZwJTWU2LufPGfXSEWvpsEAo83Pe4R
31841	payment	2133	2133	1874	1	1	3078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5cWVtwdbBey2oVud2r2h45ZUu8C4QMiS4utnmnHeRVY1DHyE
31881	payment	1397	1397	1678	1	1	12684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkCqc7Aj3XYsm28gZZ6NUQdfJzzESs5Jke3PRJe5Z5GgWyGxx
31882	payment	2133	2133	1874	1	1	3089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCRAtsoRV56nmECkPenfSEhQKB4g3WKp1mffsMtk5AVk2BY1P
31883	payment	2134	2134	1874	1	1	3175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJb6iZyRchTjTNwD5m6DzhkrVuBzjWd51ZYFpGKgF4JpsNZpU
31894	payment	1397	1397	1678	1	1	12688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RMjUPWPcjcHYGC5R8Xp4WFZLrQZ4fBPLG1xfKdqSKHuGbLUv
31895	payment	1397	1397	1678	1	1	12689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcw99s2UUT1PwBsLb5Yq8tmUAZuufQufCvtL8WuXo6wS4hJ3uF
31896	payment	2133	2133	1874	1	1	3093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNrqUMoytVeNynCykwgnMSBTMEUCRwXnJBh4RyM8iMWjtvhq7
31897	payment	2133	2133	1874	1	1	3094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRX9Jx1p6bcfFyiRnVEHUnRY9ct28Yez3J2qx6Ng3yyTRwBEyM
31898	payment	2132	2132	1874	1	1	972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvrbqPpbmwhmjGS3rfQSTamu4x1UQc7kiGLmSTMN2JED37Ts1
31899	payment	2134	2134	1874	1	1	3179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zR95KbDJJThhKQbWS3NR4DbZgyw6ifbTjJgc9Lf32LAiiJ5o
31900	payment	2134	2134	1874	1	1	3180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6srxMgWVq11stEznqkrRE5TQZ3s83TWkUz298btqXyXsQhAA
31907	payment	1397	1397	1678	1	1	12692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vFM2c5D2oejqEXVBKbkg7UCoF8rRcMP5Y6azrCXs8QxCKGnD
31908	payment	1397	1397	1678	1	1	12693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVhvUu1E8MXiRT8dfgtRT3yL5kWcUQcRBzKmQCKZusn9T2ZQq
31909	payment	1397	1397	1678	1	1	12694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdC4ks8bpnsGgyTBW4LfWRBPiSKgnW2NYnXW2DAvjbpvBfKwGb
31910	payment	2133	2133	1874	1	1	3097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6dEfMPJVFFBq3BBpTYAc5gx9k5RXvjj5k9paogcoUQBPAgp4
31911	payment	2132	2132	1874	1	1	973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseVU615v6tWR9XJJ6raSLXFPxZNHNPHi22nUaQMRdWyP5NpTq
31912	payment	2133	2133	1874	1	1	3098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJ75pWraCvF2WpqRwTcHuzTd7Nz8sxrbQvnTf3KgCDjaZ3pVN
31913	payment	2134	2134	1874	1	1	3183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4LKBcnmYejGzQtghFB3JXpHJpPLHA7PzLgrAyCKKGAsmAKzF
31914	payment	2134	2134	1874	1	1	3184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1faVruotZsZRg2pzbdsgYydW1g1nDRam3RioPGnJQjjx1H3N
31915	payment	2134	2134	1874	1	1	3185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQp1AC8NG5oJMzhoZnwfUhTwA5oTHzgQqzWV87fj2JUUqiktj
31916	payment	2133	2133	1874	1	1	3099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeqXwEUHkrYD8E8SVjE4vYwpanYUhrv8uyd6DCRVh1i2Qfvm2
31920	payment	1397	1397	1678	1	1	12696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmsBE7F83SPQ4Mqb7QAyXiNXXTiUsRjz65HH1Dv5mKzssnDhG
31921	payment	1397	1397	1678	1	1	12697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9gku993UpBirZZ7aiLhQZm2FbQuuAdEFtEk4ruGMA1p7Mp2c
31922	payment	1397	1397	1678	1	1	12698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZPLDQXqbfBPSYm1HZeMYfuz2zYgtAxL8Tqi6sEebN39RW8LV
31923	payment	2133	2133	1874	1	1	3101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ63tKonjxoK9MTnJcnbwFzgAP7LZKEcjybQfuUwAody4MJ3ki3
31924	payment	2133	2133	1874	1	1	3102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGjkNpNQSKwg1PtGz59fviBvTBAffxPGYH3WG4mQ6sh5SoC7Sq
31802	payment	2133	2133	1874	1	1	3068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXmySaPEPxhYZ29S1fmcUF78AeRMf4h8AxnM76rQAo6zEXmZM
31803	payment	2134	2134	1874	1	1	3154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgFXqAizVzD2ZhzXL1yM4PkCmGKae86hutfFRW5r1FLurV1cx
31804	payment	2134	2134	1874	1	1	3155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUeSLDxV3GE3sz4PTemGwG9r8pAnZFaunK5dz9RHYwH7NF9tR
31805	payment	2132	2132	1874	1	1	964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3DPfWhMSkghTR2PSSDqUeWkttCX8X89jViZShus6boLkBQWA
31806	payment	2133	2133	1874	1	1	3069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDc3Y5jDKWpLZFC4DjYDueS4xczBgKJPQN6uNym5mse8kD6eXm
31807	payment	2133	2133	1874	1	1	3070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1ihxTGRC46ZV2AsxeiN8HY2PQH1xUK2ihN5kPVTVZMzxsTkU
31827	payment	1397	1397	1678	1	1	12671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwHiUVaZxrfGLJ66qXBk39ddzgiSEY7ohvMAtx8CdJ6u224SR
31828	payment	2134	2134	1874	1	1	3162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaE7q3wxzbHyRJCwe1WQNTQ3e8wN8JehqZFhokWddLE4socQx8
31829	payment	2133	2133	1874	1	1	3076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhinxBkpWNDf6TLVAwuujk4wN5mdQE5tTXSxuhV3aJbQpH2Yd
31830	payment	694	694	2288	1	1	2	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvEVYQZKd5U7Q62vDGw5cbxs2C81YVHKtXyxo3HN9EGKxi7EL
31842	payment	1686	1686	1023	1	1	12	2201908885700	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZg5j6K3tcHs1gLSoAqXsGhUCgv5LcBPV47DgyCBkSPQUU8QaWM
31843	payment	1686	1686	1143	1	1	13	3945801857225	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZLRDy1fXV2wZqSshwpPUhZGr7yKZ2T75GwNXSMgVyQfTNUXMKu
31844	payment	1397	1397	1678	1	1	12674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiie1eGLm9aGsKHzaVcfQzsSULUHyBHyGTXfM2ezacx9Ym74G
31845	payment	1397	1397	1678	1	1	12675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5LvQQmYZoyajGEVWd3GTwz9zcZMEyn9qNzx1RwPK6Uhap1ms
31846	payment	2134	2134	1874	1	1	3165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvkaGixfN4XPR2gzAAJzyyAQH7sNhoa64haakjXBmyKS3Kzb7a
31847	payment	2134	2134	1874	1	1	3166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaRJUMXU4KCsXx4tPgL9v6Bu9SBcdNwaXKBzmhxi2Ww18B42q
31848	payment	2133	2133	1874	1	1	3079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJVEfGGGHZfoMEdm6hzptbGDrr78AtCJmDnxKCKETXrVRXrrkv
31849	payment	2133	2133	1874	1	1	3080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpiRmkoA5cVvCv7p885iJDfE72ft1WYMDTKCemjwN2Qjtrmuo
31870	payment	1397	1397	1678	1	1	12681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzZuy3kCbjncn6be5haVbGf6Kh5RkmEBapQk3rADzMhp9ZSms
31871	delegation	1771	1771	1579	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DEFsE3kXv56ggGk6Lmbaxb4FyiKFpQxWuf3ytEfPveuzKZrR
31872	payment	2134	2134	1874	1	1	3172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfj6MKw7FGwPczqJgDbrJ11xqn4AE4GJpi7qtL2uhT81RvyFo
31873	payment	2133	2133	1874	1	1	3086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZLrLaDJm9YLTZBiwne8waJEXYnnRxF5gWsFDShnxM5qCUjcK
31874	payment	1397	1397	1678	1	1	12682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14U4gtqXcd5mkU7Auj3qi8UJmHXjxDzrNNVhzwEzRCpCiDq5r
31875	payment	2134	2134	1874	1	1	3173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaagTcPVY8GktPn9k6Ggq3ieYZ2wPx5fnVvAtPzDC8zp1ZRqsZ
31876	payment	2132	2132	1874	1	1	970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrcddV4KseKWQs1e4Cf4hFg2UydPHj4rDz25yzjHdzYua5yYU
31877	payment	2133	2133	1874	1	1	3087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXYpWJTCCGDt8aS4M3MfbroxeWFx5LxkYyb8SrxGNtRZ2RYZb
31884	payment	1397	1397	1678	1	1	12685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSLnKUbqw5R7HWvRSCfdnHnzkSij9GY4ncmimEfGvDwGsy4Si
31885	payment	2133	2133	1874	1	1	3090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLRyWxap15cNLXFedg1rqSzcEBrmBCv5uz7ynDrwDL78JvDSU
31886	payment	2134	2134	1874	1	1	3176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdSVAor6Zst2DsTyrjfGHUATjiLFqTT5Q8MznLLgmnLuTwP6S
31904	payment	1397	1397	1678	1	1	12691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHEAUyZjwmoxJDQEMbWywF4or3wgMBQ4WDdkaeeLXtRWeYtehe
31905	payment	2133	2133	1874	1	1	3096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFyG2Ps8o5Jk724x6pSy6eHYdCyaUbzsT89mj8DMFFB51ZUL5
31906	payment	2134	2134	1874	1	1	3182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuVFHK7Ptan8sePLNzq2GLQoq5K6MVygGaRRppTBZbJJKrQN6
31930	payment	1397	1397	1678	1	1	12699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2txiH5GRTatPjrWU4weunQbnvjUnJCdDJPatcwRpTje29h7gj
31931	payment	2134	2134	1874	1	1	3190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMdw3mgzWkmows7bs5knhicKposPu6ZQKf4pxMTJKLm3Q8NxV
31932	payment	2132	2132	1874	1	1	975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNvVHw9TnRKc982RWBLp5F7Wn6C1vc6jghGC56B8WfQtYKMSYX
31933	payment	2133	2133	1874	1	1	3104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSh4o5p7LuM13jeNKnkaicWMgdYXJaWgmpqL9z5pxoqXRYix2
31943	payment	1397	1397	1678	1	1	12703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyiHVditgVG88kKzUVigF8TGRbpL1dmvMj9YUSxCP6hoMjmMzy
31944	payment	2133	2133	1874	1	1	3107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkCmnQaw45VXyUJywcsujSqpaBJX4KEW9qNJTyDPGauRHATfYW
31812	payment	2132	2132	1874	1	1	965	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFgpgV8KQSBpVkQheFMZRvBvc6cJ2FXmFBnNjuJ6q2iQG7wTP
31813	payment	2134	2134	1874	1	1	3157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQsnuPwkQ1CwYwN46u7ZNDpjeEPh3HpEBc4mvHZyqvon7VtzR
31820	payment	1397	1397	1678	1	1	12669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ozcjVeNPY1EkJP8JSKpJtEmf5i6cgyVUiLZW2DRCKjGnPRei
31821	payment	1397	1397	1678	1	1	12670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxmjVUUmHX6aNp8UXHtrosBV54TBUgmYTWsEe9oDddrLcF7gR
31822	payment	2134	2134	1874	1	1	3160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUTVBttZtvWLWf5dBt5drCCoNCe65vo7CD731cikXnUpUFStB
31823	payment	2134	2134	1874	1	1	3161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GTUL8uJNgAUCYruK5AC7UQLrVWc1gSw6NBe84GmY49SWrd6v
31824	payment	2133	2133	1874	1	1	3074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVqFnDt4CnCkQ5i9DDvzr17J197NJ2RYzW1xHDZMTCLmimJGK
31825	payment	2132	2132	1874	1	1	966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUbeHhyWuL95HWp9uyeXdkneSvfYHMMee29LqzDKFY6k2n8WL
31826	payment	2133	2133	1874	1	1	3075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8gTnvNYMc3fsGFmcZ3o8JC2kZJGE64bTK3QKmjEAdFtPB22wy
31850	payment	1397	1397	1678	1	1	12676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRyztY9mz12fYuD11mUAUuzkvRQSPwrCnR36u2eWYN7a4hE4D
31851	payment	1686	1686	1263	1	1	14	2662311138725	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpZiPRUQQfnbm373hieTJX73ygbVGufjf8nqouK6WwYfhU7Lwik5
31852	payment	1686	1686	1389	1	1	15	7418766707575	10000000	\N	E4ZCGHbmy7R1CPSQQqFHpk7NS6EezKsVUhQ7DQtzypQbSbW5xMGHo	CkpYafaQ5bKudF1CeXR5HDGPBMbEzBP8zB8jWK247UtR2QqZLXFVG
31853	payment	2134	2134	1874	1	1	3167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9vSHm5qVjVrWcET9FKjVNuJkzSb46EG8Ajd716Y1QoUdeEv2
31854	payment	2133	2133	1874	1	1	3081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7hgE9xBaR4HnnCiRFQHJbvdNLG43Qrg4UQKoZfd2CFCysUbB
31855	payment	2132	2132	1874	1	1	968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ojcGU3gM6hkwyC9Jf2TftoiGx1N8DQEzeEHTkeiNV2pPUVTg
31859	payment	1397	1397	1678	1	1	12678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TZXz2KgbCyQvV6qeYoE6gyBeHVetJuRWUYtbYajaiTNgHnnA
31860	payment	1397	1397	1678	1	1	12679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4XupxggivBn8ehp9KcJQVEXHmzv4dLx66tXJUQ39hFZE4ZeG
31861	payment	2134	2134	1874	1	1	3169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbMKoNrMkHzXHoJ31jyqfeMGn3Hc6U4cBJ1FfwxhgqPPm7onh
31862	payment	2133	2133	1874	1	1	3083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54yh7CZNn2cSkiKiRdVjTVTX1Vus3Ngu8nUANhnbKXsQeRZff
31863	payment	2132	2132	1874	1	1	969	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5F6B4ddhWMmyXMqvEo9tJoAnVugjDY9BL36ZuG7XFSyykZqTK
31864	payment	2134	2134	1874	1	1	3170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSooAGoixrCLb9XU4WJKUDkSaVg8VdZuozJannn2fzjo9SFE7
31865	payment	2133	2133	1874	1	1	3084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvF6TXmUZvPWPwBopqgaKmehus3avtRXjjrT5PBHnKc9MGY3u
31878	payment	1397	1397	1678	1	1	12683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhj2UrCbhaNqCMJMf4P8ffLts6XJeapvd3XkHRBzvdXnYeykUv
31879	payment	2134	2134	1874	1	1	3174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5jUw8YtU7fKSCAGYBVfnmF4zr94cxjTeJn7eedtC3YRLVoPG
31880	payment	2133	2133	1874	1	1	3088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUxme8n63q7HGqwcgzbDCsbnNB9iuZ75e4hxmzZsSFsG3Z7jV
31901	payment	1397	1397	1678	1	1	12690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbCAah33ViBeeb4K3YxRncBeNXjJjCJGbPVeugmXj1qta57PR
31902	payment	2133	2133	1874	1	1	3095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdoBFLyUGyLEn6kBiJTMRn97TEACaQFRM4rqN29xyBWMESrwxi
31903	payment	2134	2134	1874	1	1	3181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4ZTKpzvrnmbvwFSVgHUbztuA86yhZVBGZ7MfGF6B8rL8ybDT
31949	payment	1397	1397	1678	1	1	12705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZGfD9KvermFqcvHU3yncuvyjzEHwaGtrod5bmutkDeRe3DK6
31950	delegation	885	885	1483	1	1	4	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XMU3D6JvVAJNYyosD2f3CD5xHQT2m2L9pGeVpn8buQNarLja
31951	payment	2134	2134	1874	1	1	3196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyamWYxKDYqJcP4nRxZCBAUsbKfqMhqLPoHUddaEckqRSHp93
31952	payment	2133	2133	1874	1	1	3109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBtDevF6F3jXVxa14VvySqzj7pdSTAiis3r1tiDkYGY9zETut
31956	payment	2134	2134	1874	1	1	3198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxhDbqecRQFz429Bcy2EsYH2Dnqz5D217iMquQSwMi2igVEvk
31959	payment	1397	1397	1678	1	1	12709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvvFQtEYvsK8yt8H22DUTxxtqsAWBuefQATdUJ2iVMkEmYgdt
31960	delegation	886	886	1483	1	1	3	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq11SVNv9fvPrFCSXyyDiy3G4JeFaE79CUBdvGGF7J39f2Wg2
31961	payment	1397	1397	1678	1	1	12710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCznjVfXy1SLrXcwD5zv2Hs1MBCWZ48yhZL4FZvLHKKjssEC9
31962	payment	2134	2134	1874	1	1	3200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpfeHpH2U7EAcmyUW8xpQso6g9fna1WCgonVzYVxH3nVw1zpZ
31963	payment	2134	2134	1874	1	1	3201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnKgLeSoZBJPkA8xcva5RRttLXDkbjgiyzS1GFsk577nC3ui7
31925	payment	2134	2134	1874	1	1	3187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXZRYNaqYMnATzdYHbUmGA5xWKHQSvySzUZAHJBaaRPdN1diq
31926	payment	2134	2134	1874	1	1	3188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHZ4Ny3HLfBS7zZD6F6AZ4ndgYLevbJjZ9tgT1nEKZGGmDMqg
31927	payment	2134	2134	1874	1	1	3189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXHhnN1RTChS8TpzVNs1DzcBhcPMe1pFvk9BPfB8hQiwf3LjF
31928	payment	2132	2132	1874	1	1	974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeoE9w8Tax8U3pFZycbmv9ZCpjvBSqLWivm726TVm1QTQrDa37
31929	payment	2133	2133	1874	1	1	3103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UReacGVaSQ1aMoSsDYAwFvCETFWK4JoXZXNprbKWeWPvHxTN
31936	payment	1397	1397	1678	1	1	12701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3TxVX1LZ2iL6HHFzBEz1Qs28ksAa4h5RAwexAkiXGsmEEGC2
31937	payment	1397	1397	1678	1	1	12702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAnrGBjLsBqU4TxCPE2qMeCLZRpQejTPRncst9mWkgkVXdgvH
31938	payment	2134	2134	1874	1	1	3192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iFQZ94S79KJSZspfzrdhvFDnNBkBd6gAVnqvRNv1gzXT8vh8
31939	payment	2133	2133	1874	1	1	3105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCivshnkaMA2e8i8yJA2gPYASJX1RVhPBS2CgCuQfeopvoSBz1
31940	payment	2132	2132	1874	1	1	976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXyD1CddPyvTXZoJLcMGuLbGFoeTq8hsRncwshp8WaGURnFKA
31941	payment	2134	2134	1874	1	1	3193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9Hc42PsxZQ1RcJQf5uUYTZDrAsymNxDwdQZZzhcAbkseq3MV
31942	payment	2133	2133	1874	1	1	3106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dgxNRDSn91Y3d2GwMC1Fe4DgRaTG9TeSDPQWBbNTY6ZJoYTE
31953	payment	1397	1397	1678	1	1	12706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPrz7QZR8bNvQNKjK7gkgQgq8ZxDr9cHgPKKsxZfio5aTZrW2
31954	payment	2134	2134	1874	1	1	3197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2e3kZ4f9BH72eePusL8e6nbCkuasZuGzgFKzHMNhY3SwxHmB
31968	payment	1397	1397	1678	1	1	12713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBeBiNKC9gxUoA1vZCJTZeLsi7jdnnDbK8sezwzQQC3mgLtZep
31969	payment	2134	2134	1874	1	1	3204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxRvwBmRWD2d63EeQvDK4Vpzpzn4NS3exbcvV5ASeX1GLEPkz
31996	payment	1397	1397	1678	1	1	12724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUaKPNp8aFenDHaLkUz52Vtx4M4i3mxtx88ZLWPePrcg1Sh7w
31997	payment	1397	1397	1678	1	1	12725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyCGv2x4vC5rFYDDVvvtYXXQ9Z8neFmm2eitmYchfzDKq8MUC
31998	payment	2133	2133	1874	1	1	3114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgi5W6rKyitJcwbfuBN4GWLV1dr2vKmA1ETCWBqsF75WqEbd8
31999	payment	2134	2134	1874	1	1	3215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MSqW5RLDXFUYq8YyKBvqjAdQejye3uGgtx5Jusq98SCprsP4
32000	payment	2133	2133	1874	1	1	3115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirziuSPzngDMuju4myH7g9Mjf8wBGjM4LJikJUxi7E3LwDvtZ
32001	payment	2134	2134	1874	1	1	3216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwnZDMgckDFPKQKCSedzMmaHATSCYATP2VNPFZQvo22xdwDsg
32012	payment	1397	1397	1678	1	1	12729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VFieJv4AS52jbpuyEKAtxzxhBvggapnDRr3NTCx99FNtNKQj
32013	payment	2133	2133	1874	1	1	3119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4mMjyr8MW5ke7RWpAjtaG32HzbseBvnQzDJ3BGKPNeGvck18
32014	payment	2134	2134	1874	1	1	3220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6KGDPpmtfTTnR12pYytXdjpRUpjiB3YTAhhVc6QkNgtCUpQx
32019	payment	1397	1397	1678	1	1	12731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqBJyCrxqrtCLogmyeHhSnCFunfkn8pzffJ8FrEkacuddsRqw
32020	payment	2133	2133	1874	1	1	3121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwsiWR7JPQ4EupzpCWR2vQbagaL8y2LAunBQTGVsZDkFpcJND
32021	payment	2134	2134	1874	1	1	3222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi2gntHSG2FxsWrmitp5McGeapVUByjXMtCoQcNA3bpXjsEiWn
32022	payment	1397	1397	1678	1	1	12732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDRzjipa9Fn4EnrxLk8DFpAxy1NRNbgJ8ZmR9dabeJ3VCioRE
32023	payment	2134	2134	1874	1	1	3223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ637dP63FvzDAVJCbDY3WdpKXymRsQmCwrC22QS5NH8xaGZv9R
32024	payment	2133	2133	1874	1	1	3122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtxcat63FGR8mhbwmu4xzFfwpuowpaHVGN7MTyegKFVWNEMVe
32031	payment	1397	1397	1678	1	1	12735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xKSZ76doeGqiQTC6Gy7otTt6jaVgH4dQjj7PoiG1A72wNyRB
32032	payment	2134	2134	1874	1	1	3226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNJKunAyUXoAuCzNFNeGDDKt1cpAw3f1kJPEQAQXTHrY9RQPk
32034	payment	1397	1397	1678	1	1	12736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Q2V9vTTuUQFznWaXQ6V4jH1gpmW66BNvQoktJC1prGmU52nS
32035	payment	2134	2134	1874	1	1	3227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ475DfmyNd9EWVMV7KtGnjGHrTXyGwoGJHPsoKZKhT19ZyFa7w
32036	payment	2133	2133	1874	1	1	3126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMygV8Kiki7guExvEVapFncM7dqgapHemheYSsw4zSYKzSeHq
32074	payment	1397	1397	1678	1	1	12747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWmYUysN11Vrf8pkU9AFawuhw2ro62K2yh4zAUoddu1Npwq8i1
32075	payment	2133	2133	1874	1	1	3141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wq1Rae8q5t2f1EV1i9fqZZZWyjqBNHWHwqkSWyHT3a9BuaBH
31945	payment	2134	2134	1874	1	1	3194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqFzQF2ZRJd8S1bqD5yBUAhJR9tvJvgyRixjqEAkacYZ7a2N9
31955	payment	1397	1397	1678	1	1	12707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJAW5vWkV7sSkycRBPsimJJySeXHxJFdjWGAUB3QQpL7xYbZVe
31957	payment	1397	1397	1678	1	1	12708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTMFZ8Z8wqBiW5AQDn1ppsr6fpv5ceBYk2s6QUWJcta1tDmrM
31958	payment	2134	2134	1874	1	1	3199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUKFXy7EocWA3d82RNeL5YawF19kNA4jDSUGfkX65Fm9Ty38i
31964	payment	1397	1397	1678	1	1	12711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8svZ5oSEWsHaMiUsiHNRSxSaud6eLTJLTjcq4HMy1XEomy92T
31965	payment	2134	2134	1874	1	1	3202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsLzAymBWhkrUYV2REhpjbEbdPBgVD3md6mtpWz9bSEqQMJZv
31970	payment	1397	1397	1678	1	1	12714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5VjUzwTdesBzcn7tn1fYVtx54zwMhFwf3HnnJwhtru1zY8Y6
31971	payment	1397	1397	1678	1	1	12715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbbnbZgjiAinsa636mYQ2YKmaY6EhjVK5bea2SxmDG2ZVjYaR
31972	payment	2134	2134	1874	1	1	3205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRcnLPXoqVhG2143MNPrbG2jQMe3pLRVDttB8PF1zHge83z1p
31973	payment	2134	2134	1874	1	1	3206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZanboKjePNekiPPY5SxYsadXCUGhv6z4yrLiY6heBfMTnVhdrx
32006	payment	1397	1397	1678	1	1	12727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJrginc2raoxco8TxRvEwBWhjoUCwfMWaPa9HC3KiVvJEuQGj
32007	payment	2134	2134	1874	1	1	3218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxZGcQG93cR199dkx1NQ3d3tVYgzwC4KHvZEmkrCUvF6vhHVJ
32008	payment	2133	2133	1874	1	1	3117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6u27WL27i8hKcsxMciEJgdXFrtNFzwCgp4BCFBWhngLkvkReE
32037	payment	1397	1397	1678	1	1	12737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjvftb7L3X5GVcb2zACYUuFWrTnYbqPXkAJ9GiDERtdFt1o6sk
32038	payment	2134	2134	1874	1	1	3228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKg1w2axWvtFhRjAnPTe75Po4cKH1wdPJtL6LJQxhrf4Nyix1c
32039	payment	2133	2133	1874	1	1	3127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyiPTFpZpow1XbLcUzagSTNojEDhkPp15ZADJpzaFTUZWWY5x
32052	payment	2133	2133	1874	1	1	3132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQDL4kgMYDpksef6P1j18qQJyAnfrJQJk4BBWmsLRc3kDddjd
32053	payment	2134	2134	1874	1	1	3233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYA3cASiQHQznzJi1vm3wFpqMvRKNCPsHymmcjiYQa41GFuqz
32059	payment	1397	1397	1678	1	1	12742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDVmTtEmtzHUsWoGUoWxDLxsFuxhcHrxZCweTF16dwceggjaN
32060	payment	2134	2134	1874	1	1	3236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQRjEs8mcNfYz6ApqXLxVazzbs9feaanvTzYMgX17jatCKg2b
32061	payment	2133	2133	1874	1	1	3136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUn159cDY5Az6f449tW9KfexMU7ZM5RrhW7MA56rMbC2S3Npg
32068	payment	1397	1397	1678	1	1	12745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGwVD914W5L3QPxS237BPEQRxLs9QqNLxKKojb8vp9VG4KTcA6
32069	payment	2133	2133	1874	1	1	3139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gQ1BbG2R4Hzhmg8VNcZZH3Rc76vM3VrDaDUunkXpVtWxEmfR
32070	payment	2134	2134	1874	1	1	3239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHimQHJvN3o2AnM7setk1JAjRAu23pmJxy7jf5kP73FPUmp3uP
32083	payment	1397	1397	1678	1	1	12750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5Fw8Qz4FhaoLDobiY7GRqrb4nD85BKgv9KU36T9gC7VH3r69
32084	payment	2133	2133	1874	1	1	3144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwxNkz8EezuR6yvRTKdUrjS6NfiZLVD93KWK7t4StqkzfwjvJa
32085	payment	2134	2134	1874	1	1	3244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7Mb3NcyxpAvjn9Uc21Q4P6eaYFynqpfCwhWi6Nkv1r911T4u
32108	payment	1397	1397	1678	1	1	12758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvWihS4ZZihXZshRiuvQfA27nRXntBL2bCRx3tZNbZ4gicT71
32109	payment	2133	2133	1874	1	1	3152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeGkmSjSCZQw6xXeFieddc5F8JYHebgdGEdidC9eNMbRNvCnZ
32110	payment	2134	2134	1874	1	1	3252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YesEXdMHjku6AUSXTWy6fVzUJQq2W89NUwnsyApsfVuogCWW
32139	payment	1397	1397	1678	1	1	12768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszQ1dvjeMgALkkiRGn1nERX8xczEKVSvzPHmiHBGmdrw8gjiM
32140	payment	2134	2134	1874	1	1	3262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRc7YEACf4kNoXP8UUm5pJvDJk7V4jkt82biX8fB6FRdc5KqD
32141	payment	2133	2133	1874	1	1	3162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQ9MqT4P15UQaRh6oFvMxcWSYbfdzpUK6TSTFwGr7MVfhwt5x
32157	payment	1397	1397	1678	1	1	12774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BfuF8cBiYGTHr4NgBgnJFYMugodoTmyAVgfNjX8yztzaRH6g
32158	payment	1397	1397	1678	1	1	12775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi22tshtEP3eZVQbz8XTeRYo5zT9RkRDgXHNk7MVscb7aEr6Ha
32159	payment	2133	2133	1874	1	1	3168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AbTud3BwE9LKXyKEjFUYgZN5mQa3XgoRnoxpNYAK2oFa2Wch
32160	payment	2133	2133	2289	1	1	3169	1200000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBzegNfYe6c5kBpNiMGVkyoHJunh5FpRf35djaVf5RA3CKCrx
32161	payment	2133	2133	1874	1	1	3170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUF6wcdtwf8H7CR3g7qJAymXNs2bWNFipnhAVthT6mM4gKsme
31947	payment	2133	2133	1874	1	1	3108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZycwyudb8HMiJ6TKoPsXavPCxYCbcN4Tisi9G37M96fvNdJK
31948	payment	2134	2134	1874	1	1	3195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcCX4YpZTJBKDFLqq9ynisiw95v8nS5A6FWubKSQVrZutWPKn
31966	payment	1397	1397	1678	1	1	12712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8uN5SF4LrV75eKTre1ZSaxHMFkSFVGopsNagbyJWJyHSqH8t7
31967	payment	2134	2134	1874	1	1	3203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6MvGGDKAmeUtsmqprAitg94cLhaW85jWiMYiw7iCsKvnzTc1
31974	payment	1397	1397	1678	1	1	12716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvYMQV9opMKNVUUt3oA1WBo9soB5zAeRE5gjHJQrjDHWX56zx
31975	payment	2134	2134	1874	1	1	3207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigkUUzy8SdQxCftES4vit4pEYnzF8k4y5oN5GKcwvHFn8udW6
31976	payment	1397	1397	1678	1	1	12717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kx7haNqWTxBs8wtVanh8Coh9Daq99owF8CegLo2M3Vs8PoQD
31977	payment	1397	1397	1678	1	1	12718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PcAstiRF4t3gEXAz831prVJZ4KddUdRnoPXryyP1ZonJStfn
31978	payment	1397	1397	1678	1	1	12719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShwLDRQejMEqpBxN91DZnsYW28bW9QFrZpWHMVSijGJFRmwgg
31979	payment	2134	2134	1874	1	1	3208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB98QCWtX1veDoDVxFwrntgLML2G9TY986M2yNhM6HKXzAzipE
31980	payment	2134	2134	1874	1	1	3209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6mmatY84xtT4By6K8JQ3E7LxxMPnCRUqbGxRk5jGNwuZKJFD
31981	payment	2134	2134	1874	1	1	3210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEci6hQjkpXgLsw9DxGKgS5chSVVvBuKmtBfVE7pP3qaD2wpgv
31982	payment	1397	1397	1678	1	1	12720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5mRPwmT8nFvoLh97tQkUySjP2DbCRZayp4QZJLRRiNaGcDsA
31983	payment	2133	2133	1874	1	1	3110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWBS34jrbt4b8ww6x1RhGGnbKTwdZkmFc6YZtcMdUcMVEDKB8
31984	payment	2134	2134	1874	1	1	3211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeS4GPu2ksW3ED5vK55Ys7c3UL2GZQdp8P1BDQHH7oDH45ZzuU
31985	payment	2132	2132	1874	1	1	977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9otU8MnfQtveZxSTSNT5Ya3Va4x3noacsCBkLMt9o8fSsyknB
31989	payment	1397	1397	1678	1	1	12722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpurPAJ7siTDLZUea5cvMTa3z4g8kMAFnkuikr967YSCnZvqn
31990	payment	1397	1397	1678	1	1	12723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3sjaKAHjTgWukuLXR63BhbwnL3kfjKX6NVoNK4DAFinRhoNt
31991	payment	2134	2134	1874	1	1	3213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5ioarehNtoU9MUcT9EztFSdbuygfyC9RGV1gZTTTitWn3avy
31992	payment	2133	2133	1874	1	1	3112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQDdtCy1Seuc5XYiBa3WXL6TVU6yLQfg47qhmdUDRtNTf8C7SS
31993	payment	2133	2133	1874	1	1	3113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPM7oMtNLCHmj45KtGzshuAJhSKEw2FB14fyftvgGvvuZNZEoY
31994	payment	2132	2132	1874	1	1	978	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9AhQntWW8CcFmYikCkGQ8Rz8GMypsRM1148AtMet9waq3uJR
31995	payment	2134	2134	1874	1	1	3214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLdXGyzJPhFthidRtXZ4ZbfBG9oZZMbcdpfd1gajX8WkKaHSw
32009	payment	1397	1397	1678	1	1	12728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwv1BrjCfC6o4oTzmvDPFck83y9iimmDKTNE2zFaRFU9iN2Wy
32010	payment	2133	2133	1874	1	1	3118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdXmkQm3cC2CgcATD6rSY69BxvJv9iebzUjkqQ8fgWEfdwMSD
32011	payment	2134	2134	1874	1	1	3219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCUubKRTTBGqYfmfB46BwZhmMgFDt5EpcS4mZKZXc1gJ8twVz
32015	payment	1397	1397	1678	1	1	12730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1bSHwGJCLE813ReQP6aL25xvRrhK1gaY7PHMUB2sZMRD6KCE
32016	payment	2133	2133	1874	1	1	3120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaH8695N1Maq7185cFba8scp4hNNEKqfhGPP64Rn2vYXqDMSvD
32017	payment	2134	2134	1874	1	1	3221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfmojmFx7vnrEtwLichUa4J75mhjyh35Jp2nG6K2B6if589S5
32018	payment	2132	2132	1874	1	1	980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmzsotJvAybEr8Y9B1mbEfc4FqWphTrSn7ubWn3prKNtkajHC
32025	payment	1397	1397	1678	1	1	12733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijF79EGiz4njFg7cus7iv81UXRSg4aZf8xYebHagWFSgqzDwV
32026	payment	1397	1397	1678	1	1	12734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuT6aZ7K45bCM5RoGWgat2zdDNWuezm9FbzHRRJq5PUTeQBy9Y
32027	payment	2134	2134	1874	1	1	3224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHBm8F5K3s5SAGYMBMWMCdYV7nEYzADQhSrDyXX9WntQogiVd
32028	payment	2134	2134	1874	1	1	3225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpgkx3PasxNzAxvjDdixGrwXC1VQGGPNXbq1CcFXYR4xvgc1o
32029	payment	2133	2133	1874	1	1	3123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgQ1gGEoLZPpXy1QStqxzb7SA37wVR5Ye8qVBWB2v1UteR61j
32030	payment	2133	2133	1874	1	1	3124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjgptfZDyZkZqpiRzLvUnv9WbxQEHb3aZMRegjQrcNxfSk2Cq
32049	payment	1397	1397	1678	1	1	12741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzmVrcKfwxZwpGGxu7tHyLaheGTNX87mbr7URrcbB3fqjKiup
32050	payment	2134	2134	1874	1	1	3232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehTtrVidPQCexfwsRKn7FjPUye2EeEBues46anorz8DqFFHet
31986	payment	1397	1397	1678	1	1	12721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjbZq1BAtKFDiwEqGEhK9nAhCGzdFdDE2eoPNSNfUTkt6PsdKR
31987	payment	2133	2133	1874	1	1	3111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieeqW6crUrjhrWN3wqvTCY4uGmHHKoNidyaexhefxTA9VE9xK
31988	payment	2134	2134	1874	1	1	3212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwYWTiNyD54EdgaB2MN8YwJae5fbR4WF2fzwfNDipxH5aEhgv
32002	payment	1397	1397	1678	1	1	12726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvcV3eqRykMgLwNcVDQzDSK7mD4ykWW1tqP54e6V4pQ8J8Ysdr
32003	payment	2133	2133	1874	1	1	3116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnY6omAtWzMq5uTnN6TY77W35dEPoHpgxHxkEqd47DxVY4v4Y
32004	payment	2134	2134	1874	1	1	3217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdgPf8T5YWmZ3CY7bkTMwh4RHyzP7Kj822jBPYwds6fHuPr3A
32005	payment	2132	2132	1874	1	1	979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6wWMkkeg3mV8BWGtEqvxRaovFEszuScvutFcaF6f47BXnKeYh
32033	payment	2133	2133	1874	1	1	3125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXL2piUrrwTwY77pquEvYp8zgZYzWDdk5fB1vGs22GnpGszBLF
32040	payment	1397	1397	1678	1	1	12738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKG36vmffZ3nwkVN2g2qxvZc43Di1u4ZbpaNwzNhugDT6fu6uJ
32041	payment	1397	1397	1678	1	1	12739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiweHrQU1Lfp4mLRes8qaxnqGWNQUjdm8KyedghdKbWhDWdXKW
32042	payment	1397	1397	1678	1	1	12740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8Uv3RVxotfXJpAZ3ULPyGkNb5FQvip5RrXaVR6L3pXayoLoS
32043	payment	2133	2133	1874	1	1	3128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZHysAbJpcy3SdeDf6encw1xgLabkdjhV2CkJRmndjUgFoUzu
32044	payment	2133	2133	1874	1	1	3129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckokUVVsmBcgKDPVtar2KMeq2T1oBmtSwcWu6Ww61GiJigie7
32045	payment	2133	2133	1874	1	1	3130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdYS4yNzg1VPQfR3mihoJcTktHwzBKh3M8bomP2Cib9pwPCP6
32046	payment	2134	2134	1874	1	1	3229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfkg91oNTfRAhh6sPyhzwY2q5pmte99HCTV6dHCwyP3sYgQ8s
32047	payment	2134	2134	1874	1	1	3230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHziPhEcfiiwcCFt568i3QrrxutfK3gMFDzPGbjCp4Jq5L87C
32048	payment	2134	2134	1874	1	1	3231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnD36B1xcEN1kt6sTbhNLyh4zhFSvfmSvSyjLnCa2ftYDdtLg
32054	payment	2133	2133	1874	1	1	3133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoB1WUuNFgto7bJ7j1o7bGZJszdegENCzTYJYEivfjVv8hnCD
32055	payment	2133	2133	1874	1	1	3134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNBqvpqwTvWHzFALiEmrHB88X68bGQyERQHfqUvR8Z7GNv7Ts
32056	payment	2134	2134	1874	1	1	3234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5eXWGf8RMthXTLMF8tnijcsJpFZWRtUpJNo4NHrNP7v4zP1N
32062	payment	1397	1397	1678	1	1	12743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxMVbHR2FwdabjYNW471k1xrP731jj7FznyN2CMoPCqDiJrKc
32063	payment	2134	2134	1874	1	1	3237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9aHftfHcxtjitKhU9B885XPPHxLsCLUyoZEpDzi6iLiePbvq
32064	payment	2133	2133	1874	1	1	3137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmr9ukgbC4EyAkFZqN5tiXm6eakQGj7S8XidvxcJ6L6JJt4gkB
32065	payment	1397	1397	1678	1	1	12744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9osnckTee9aQECE8Wms5MqNMxuW7n2kkTXvJgqmWEnKNdMZGt
32066	payment	2133	2133	1874	1	1	3138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLP4fwesQ6fVsnyr7Ecxj9V5TkoRBEE1Q1jDKPTbgGMiW7DVX
32067	payment	2134	2134	1874	1	1	3238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHopCMfYUePzKkQatoVXpAvfj8Mqyp1UDRVvLnbNEFs9X42mrX
32077	payment	1397	1397	1678	1	1	12748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonxw8xB7Y2DLtb83FJAuZKqbY7gjKyL36jNJ5oodtPutcZJCN
32078	payment	2134	2134	1874	1	1	3242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsjbe2JV6WxcMXn3uwAJWPa7fKmFaY2W3UkhJZSugwgpjDvud
32089	payment	1397	1397	1678	1	1	12752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUf5a3hQm7shNrMgKXup5eJd1ZgUn7wfqz14RSFN4xMMdJUcJm
32111	payment	1397	1397	1678	1	1	12759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLU9RBx7o9Bq2q8P148yJhQ6oub7LjU6YyPeP34d21nAnbAYj
32112	payment	1397	1397	1678	1	1	12760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhix6CayRtkDYyUo2aPVggmKrjjz9YLqdcYM6v3A1Agh8Zy2fH
32113	payment	2134	2134	1874	1	1	3253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMjGQHUh5qEZxEyU2T18eRxuZY2u92Gwn4jojEsMb99Y1EYCU
32114	payment	2134	2134	1874	1	1	3254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYbmtNTYuZiAs4AqLAjpsr1Tf1x9wUPnixfsVtPv2PaMcCiKw
32115	payment	2133	2133	1874	1	1	3153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8EPRwLDndge2f2c4C8nNm3yXeVhZ2L966WGwTpTuJWL3n7Pi
32116	payment	2133	2133	1874	1	1	3154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPB4NKFheP7LyrZZ8oyufRXe3vrq2xGzSNBW3ycAHdUjJqE1f
32117	delegation	2284	2284	1483	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoxaNU7kpemr5WMKu4PJJce1za7VnzbJhN64kvkFugw91qZGg
32130	payment	1397	1397	1678	1	1	12765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhK3YfhuEM2weM3qx6PFbAcjJRxdyYzvxdxGUm2xbtrjyaU9aJ
32131	payment	2133	2133	1874	1	1	3159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TJ4HoQZjHZJBonUAvYFpBt2sWuA3sWwtD5eg1aTxMM2whscc
32051	payment	2133	2133	1874	1	1	3131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMT7eYjooS9HaYyDJSgchooA7QJaGAVbbcvN3K7693f9448Lg
32057	payment	2133	2133	1874	1	1	3135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAAH23DZzAuKFkQ58XateTtJjXYvWFSS2bo5732Binkaoj7ED
32058	payment	2134	2134	1874	1	1	3235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWDiEyBdQSML9v55u5ZUSBjnL9vFoNtpcZAsAc9ETGnw7fy1k
32071	payment	1397	1397	1678	1	1	12746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRp1rox2GPycgCmNfh7zkW4CEouBtaF6yNdCvQYwRVXW8Vaef
32072	payment	2134	2134	1874	1	1	3240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLfroXJQKnL8W1kW6MLhqR9DMA8NroS6XHXaZZ2yceczJz1Y6
32073	payment	2133	2133	1874	1	1	3140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83GzzMzXnQBGL2eLGZoNorFxZ61s75ygDriPdigGHxNeoa6j8
32080	payment	1397	1397	1678	1	1	12749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFZKVh691fFJiZdmmpFGu5QxHUYVRrLurQk469eNaGS77j8Wj
32081	payment	2134	2134	1874	1	1	3243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2goV1DNb4wLSmNWWXbpQAiio7AZyvP5ddTr6Apq6gSyoHYiz
32082	payment	2133	2133	1874	1	1	3143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkiWjrV7kjaNB6HRvkhkyY49iyybDWo4KjxtXPavvSiyirEqez
32090	payment	2134	2134	1874	1	1	3246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphcj5xWPfBsHpHKdqDfCaY5uPo7vnkqVHeWm17sUzFjP5wWeJ
32091	payment	2133	2133	1874	1	1	3146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4TE6JNqWSZCg1HPwhVdiHhfkF5frumUmxHHM86xvCxCuWF3k
32092	payment	1397	1397	1678	1	1	12753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVYv4PwUYQ8wtGdicVmkvQbJpMTmsY2pAQdfZpUipdY25Lanp
32105	payment	1397	1397	1678	1	1	12757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeiHhDozv6F9bSXm89hZzRgCTSNgZmc2wd9agSK4JSLo8EqGdr
32106	payment	2133	2133	1874	1	1	3151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8envg2DmUwWqMLkfYaK8eJtB6EjuL2iAKwh6B7G5JK5nb2Wx
32107	payment	2134	2134	1874	1	1	3251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1TXPuwkDb7oeULzwWdPabY8X82ZEWth6L491XvtFnkMDH9dR
32124	payment	1397	1397	1678	1	1	12763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ34Rd1KMnHCvKYKvTMZVe6kgJV4Mm8UkokYA3FkhvLuBgtm1hY
32125	payment	2133	2133	1874	1	1	3157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9A3WnzRVag1MghECnS5tM8dkRMEqbemArN4CKAwSuPkVSBvss
32126	payment	2134	2134	1874	1	1	3257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmCde1a35qTAfBFqXF9KBN2UKJ8V9RmG2PTqFuFFXLErgn5wT
32127	payment	1397	1397	1678	1	1	12764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWt8nJodPvdc4GGyjMp4jB12sbhhqhcbPUVB3nscBxpfFNzhKF
32128	payment	2134	2134	1874	1	1	3258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9YBKUJaFHzjE7AwxQdDRzbMwv5bwR5QcnvtRDMTtcL8UQm5H
32129	payment	2133	2133	1874	1	1	3158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJh6MscNBZUdy5k21jGcGn5f2HSCsudVxmKBFXhgjxuTs1puR
32132	payment	2134	2134	1874	1	1	3259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7LYRyoSDyY1WUZ5mMxE6knmWrLTvUGjTJX74fzHPnEYJ3tUp
32136	payment	1397	1397	1678	1	1	12767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HuQ5Zzvn3Tuzc4xnUoFWUeyWvhkCYzG8R4JmhuN5tmvp8snc
32137	payment	2133	2133	1874	1	1	3161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaoTjJjAQowgdWypo4tvqRibw4VAFWhpqR5jHv6Ampp3JWhjz
32138	payment	2134	2134	1874	1	1	3261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQggn8UjPcBeU31nNH1wMe3wURVSVZkJunCQrbEbEKpnuh1mG
32148	payment	1397	1397	1678	1	1	12771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8SqUFQfRM7gyLD9DDZkwT4Hp4Z6iaJ5Wj3rkGMqWYgwqE7fE
32149	payment	1397	1397	1678	1	1	12772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJG6qssYJTsoSqszFbpvUkCSANGbFrCJYU1YrJkj2sVqYrCTzs
32150	payment	2133	2133	1874	1	1	3165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD7LPMicX3JN3ShgwecLnKzUbnFP3PxxvUtQbxYiNihV4KNwA
32151	payment	2133	2133	1874	1	1	3166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLSV3EYiduPwCUM4LRicBSyZk4sroX8d3SARxEN5fTJMh9tP5
32164	payment	1397	1397	1678	1	1	12776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbbgrW339AReyqSvAyJtAkekw7P7fAyhutQ8y9LygB7QhW3Eo
32165	payment	2134	2134	1874	1	1	3270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzgZ3ZjSSfbwWc1wTeskqFe3zWm4kqY3k6G8AXXKXAfL76dti
32166	payment	2133	2133	1874	1	1	3171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEW9rFCWhPbL9y8a4oeciJbugaqtLwmEHMG46Te94JsyzonySf
32170	payment	2134	2134	1874	1	1	3271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkYMdbGZauEojJFfB3uGJrapaDJpQQpSaSJUdHgwPvhLZqri1
32205	payment	1397	1397	1678	1	1	12787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUengzybvoscq6QCwwtUFiySQEC7K17JyiEnvfYyENKjTvRPm
32206	payment	1397	1397	1678	1	1	12788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8de6Ngrhwwxqz8ysSKeRXiAVfAME7JYKPCphBzUCmyTMjjVNz
32207	payment	1397	1397	1678	1	1	12789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFTeghtmTaTpGZZ3EW7gud7D6XmFcv47Eksb1sv3Gsc8TWpKAX
32208	payment	2133	2133	1874	1	1	3183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbjJsocnUGH5FLUDYuxBxw5UU2sfcknY6cRzHybJrUj4Tah7FQ
32209	payment	2133	2133	1874	1	1	3184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVB3VGKRMrxQd6fLaoeW9Xv6jdnZBoP4i69oNa4Yipdn3E6zPz
32076	payment	2134	2134	1874	1	1	3241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrm5TyqRKxunHmGbMP2i5AxLnwHgLbV5KbSW3cmkXTsqR9o6c
32079	payment	2133	2133	1874	1	1	3142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLtA9p4dvyXnMs47qpqpfhXgrsEt8jbeqbw7otBALcshaEaG5A
32086	payment	1397	1397	1678	1	1	12751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuapGsaiYH1PwScEWWMvs3ZizM7WbZ2MY1S13KJTuP9kdsfJBV
32087	payment	2134	2134	1874	1	1	3245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpKUjrRdWgi4QjdjVNwKcDECyufuegB5r3yzdeqfriWWL244H
32088	payment	2133	2133	1874	1	1	3145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfE5vYZ7dmp6kxZm8Naa4PbdrRH9233itR2L8Rrw4tzFD9nT3
32093	payment	1397	1397	1678	1	1	12754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nsBKtgSt1WMZCDt9dUSshArwYExz5w11zjGWshSMzFckET8k
32094	payment	1397	1397	1678	1	1	12755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg65AVQVS2xeEfdeYfRtqhFt7HzS5AJQGVGF3J1Ww6zvFLc1S2
32095	delegation	2284	2284	1406	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSXbUvQXAB6BUguPEXhNRQABLa8S9dtoSirt6ouMJsPtvYu4f
32096	payment	2134	2134	1874	1	1	3247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JfQveLkEkz9yw9PXJP6MFUnA9dQxEJzy61Y9dGaY9R43hgsx
32097	payment	2134	2134	1874	1	1	3248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoX2iuYBFiob7yBuA8KLV3BCqWZi9HydSs222cGS61pi8n7Chf
32098	payment	2134	2134	1874	1	1	3249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7WUqVBEbbSEWZezbVKKt9kGxZ5SoQ99JwtUEz46HDW7Yfk8X
32099	payment	2133	2133	1874	1	1	3147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTeDgGBNc3yeq4ntDbdSzTBnwgyCB1Ypq2qsVfjUTqi2LLsPS
32100	payment	2133	2133	1874	1	1	3148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphcP9A7ZGoYqUrrxc2PR7jdSbDPL98J8RrkZSXGKy78778Abq
32101	payment	2133	2133	1874	1	1	3149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfB3fikxLHgLRFAJyWjnYEhwZPsysCXQkeFQMJCGz2MZ2r1LeV
32102	payment	1397	1397	1678	1	1	12756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUSpU2Jpyvpmd4vRhDdjmAcewAp8XmTbtxep6Na6BV1GbSd1d
32103	payment	2133	2133	1874	1	1	3150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJJQKwxVYkB13qcAfTdQV8jSNLGjzJbT3AbtDkUv6vZCHRsoY
32104	payment	2134	2134	1874	1	1	3250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw82aTUX6FLa4hxsX5W3wXueFZz9L7bRx6UBCjDafmKaVzbv1d
32118	payment	1397	1397	1678	1	1	12761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS8yNHUkRg2rd5zT4ttU5FUAyG9Q8cvkpML36YP1EgsavWVbH
32119	payment	1397	1397	1678	1	1	12762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7KF6GV2pCqU35ctFv1GQdjPcVu8Xos4i9GFMQzAsyPXak4sf
32120	payment	2133	2133	1874	1	1	3155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMyQZPDoRLrDG1U82J5cfvoVJfKKkWwVMr92LMGfNUD11PRgP
32121	payment	2133	2133	1874	1	1	3156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtvcZBKGXMXnF6gzKC5Sbweu9k2pEhizBJTk28cYYSo9SU171
32122	payment	2134	2134	1874	1	1	3255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3BBcRCFuV1VivYcBhyYb8EKYdHQnobXpfbvWUiCq8DDhwnfF
32123	payment	2134	2134	1874	1	1	3256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJrovee1ACTGBuThs2MY8yYGpAUxpXX5PKoViX7RUXxj1wFPX
32133	payment	1397	1397	1678	1	1	12766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVx2KxMYebQvGNuCsUEFVy5j7XF1TAague6v28e28TxSQ9c2xt
32142	payment	1397	1397	1678	1	1	12769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbUDJorW5s9eUyeEHf9S3XpEgoAb4EMgMKGpgs869q1bWtbtd
32143	payment	2133	2133	1874	1	1	3163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcDD4ZS8goog7MsvXZfzojeaQapTHJwfvGG8Mv2Br4Kbv4Gdv
32144	payment	2134	2134	1874	1	1	3263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnjCCMuMEaYDWaWWVrmNrVnF4igYgwSZMf3E5XtvzRTSaswvX
32145	payment	1397	1397	1678	1	1	12770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpTfDJEZovKuZnWiifhxQHnC3Cz3udLTXhybFqvd1wh9WW4Yw
32146	payment	2134	2134	1874	1	1	3264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpbgjqSjeEsvp19f5VMPgnCTVwTJocToxtRT1FWXQ47PjMpxn
32147	payment	2133	2133	1874	1	1	3164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zkmBxGdEktUi9ABthxmUsLWpCNNFwxnnVZhUM7GT1WqJbCzn
32152	payment	2134	2134	1874	1	1	3265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFSrmhV99oSvoHCMoCGBNTxcoLWrQE6gfDBdPfLjjnhTYcj8R
32153	payment	2134	2134	1874	1	1	3266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFqJQQjxGHcAg5b8Q9MBiweQWqDtz4CJHtHiPsjmMDk5vytaH
32156	payment	2134	2134	1874	1	1	3267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2dpX7Wc3aQrqD5kn8M1T9Qg2GNahb4XuCqREG3odqrEqwLjX
32167	payment	1508	1508	1021	1	1	6	2552379382616	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZKYNeyMi6yyXgYQm8i8Uv3ykX3Grss883SZxXHrUyq7tr9NyHS
32168	payment	1397	1397	1678	1	1	12777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvfpkSNmHq99vhm42r4beSvYddSVXK1w1Jg2HLTUbCJ3TFjnS
32169	payment	2133	2133	1874	1	1	3172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98yav4TWPYQKDpiRHUQBPmmzLMyXwCdiU597VvM7t7zGPStit
32171	payment	1397	1397	1678	1	1	12778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bP16H3qeYtuTUfv7PKhH5aYBLt3PTdE4g37P9FNXcpb29pCP
32172	payment	1508	1508	1141	1	1	7	4573841984852	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpaB2Rj4B1jXgTKmpmtNFCfgiLxhYaTH9b9rACGQkWLzC4mEs8F3
32134	payment	2133	2133	1874	1	1	3160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAYfoj9RjHm9J54tj65M5wgwfNrPUuXS8HHaezQtCghRYxxJz
32135	payment	2134	2134	1874	1	1	3260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6moonKFNqQRADi744PxNHTLTt3fwW7ghuiVPCo3uoea8xaQR
32154	payment	1397	1397	1678	1	1	12773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEf6AUgsdtLZ5iwoWJJEdzUacx4iS3XnbJ4dKGbS6FhZ7AB4K
32155	payment	2133	2133	1874	1	1	3167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyo7n9ShrGrWoQGz9GjLEtiLVnmm1c6VbDc3YYCqeXkt7UyBza
32179	payment	2133	2133	1874	1	1	3174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQvKJ228iaYv6asjEafqKXEXbybhAfDRViEsAwTQ1Xrq8g2PF
32183	payment	1397	1397	1678	1	1	12781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzH435ZJseyLbob3kqRiBDeHPvqevVXnJVAfkPfLnyAWgyNzUo
32184	payment	2133	2133	1874	1	1	3176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXC94X7J21E4Ug8M2q42t41GXNkVmwY14VCDdQTa2wWS8WsPMT
32185	payment	2134	2134	1874	1	1	3275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VCAiYTx3LU6HvREr7agJUoo5KKpziFzDsmED4LxBVjvpa1VZ
32189	payment	2134	2134	1874	1	1	3276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRMZq4XQ7La6oxRpJSQ2Zd5vWZBkoFcPnQbC4jvLfiveMC3F9
32190	payment	2134	2134	1874	1	1	3277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4f2oeg4pz5xJ7htrGTCZp6jwmTMk11Ghwxsxotaan1iUVY94S
32194	payment	1397	1397	1678	1	1	12784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXaKruiRDGt7GUrGp12NB4YoboKXEsgTYPReYQnJ7LND28drU
32195	payment	1397	1397	1678	1	1	12785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEtv5bWvAz7dBjyv1p5A6yDehDsQidA18VDcAwZYNnL6tdcbo
32196	payment	773	773	1508	1	1	0	3801812300	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZs6jwXaLrRHH8RiZUTah6kfGGys175BqMgVypkYFA7jCigbsPK
32197	payment	478	478	1508	1	1	0	251569611955	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpZws4TJqtpCt1KVV3wb3ht1b9xBvgi8pJgRJWKpkUABt5eWxNz8
32198	payment	2133	2133	1874	1	1	3180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1dNCsVpiFQM3TjQozNp3BS2iJrYrx5E2ajiiBjaW8pEVcUw2M
32199	payment	2133	2133	1874	1	1	3181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkN2ycd4JSKkY4afMLgnctMgSXhQJZurtV6EEaGy5DTRVBpGox
32200	payment	2134	2134	1874	1	1	3279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xzhcHpfG4MCBR7JyA38GJ3fij9iJbF4aR6iJV3aDMcsiA7jN
32201	payment	2134	2134	1874	1	1	3280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqwh1REGzes5FeVg2LQKviQMthuwj3fwLME2QAC1cspPAbpwr
32221	payment	886	886	1483	1	1	4	0	10000000	\N	E4ZRdmB7ixZTk2KWStWBZZSMhXh25Dg7fzatagZfFovwNhvBtfisG	CkpZRDxAud9TvWwX7PfCTmiYjFpcw4CogVwDpSJnMih9oiMJCKu34
32222	payment	1397	1397	1678	1	1	12792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WVzgywwdVpdjdAhYte4HGaiCXTjBCNycRqD5SJr5Zzp5c3mh
32223	payment	2133	2133	1874	1	1	3188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdt56CSgEWdziKzeENb13oMWnCLSnsqiCvTa2W8rQx1fGQsBbf
32224	payment	2134	2134	1874	1	1	3287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoY4iZuUkCME4pgS3tQ6zhNBt18xYpu6omfT9Z6TnJ8bHSsRs6
32230	payment	2134	2134	1874	1	1	3289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVMV4La7W94wwj8NVCboKFLMgMU2AjheSCnZazDk9UtwLTeKkz
32238	delegation	2290	2290	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsdFkBPsBVA6SYaYgbdXuvzzEFqTEDCBdja9ZU7YqhPnoKtwi
32239	payment	1397	1397	1678	1	1	12797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAvPKYbR18VNz9uERpB5GFvBAUspVxgNmeuUzMb7weumCQEaWz
32240	payment	2133	2133	1874	1	1	3193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhSvgWpGsujYsR9kJoyiCQe3fau5H6yWBDfuKEUGnUPSdoLkf
32251	payment	1397	1397	1678	1	1	12801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajvv9zkLqZznusMiQV9JDBCsntfVTiuuTZm9YD2NVXEMqfyoR
32252	payment	2133	2133	1874	1	1	3197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfusuMndAQ7b9tQuWN8ibgzRQMSdyxsRfV4V1dnX2E34Ee35c
32253	payment	2134	2134	1874	1	1	3296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaU4MehqZBayf4XHpn9kLj8oeW5Ez5toV5QSQZfgKHh8e5uaR
32261	payment	1397	1397	1678	1	1	12804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXQV9gFBN5n22PssE6Xv1vW2WvaTdmkdEpp2YxoTxsCfzZ1Zi
32262	payment	2134	2134	1874	1	1	3299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdzw3Zt3ZLmcSuJE2tufFwj3BcUfHyCLddaT6G2iptsySRBd53
32263	payment	2133	2133	1874	1	1	3200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57o88z2gRvPBJZ3aD3cW42YHMyR8bHkJrYaPvX9gpY3wQdcf9
32296	payment	1397	1397	1678	1	1	12814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45GUKYXvXxh9YxG2R1iuP2jbXwMXaAGc4iz1T14KpDrH15sUx
32297	payment	2133	2133	1874	1	1	3210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQogyuFRAjjQ8iTQHnQkMGcjxv2PeyS16X3ZnVQ3XnSLdCnmfD
32298	payment	2134	2134	1874	1	1	3309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ViHQpdqUrNLZ5rmipdMd28SDdnTyWAn76nBYMQhZJWVjpPsF
32335	payment	1397	1397	1678	1	1	12827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8jQQaqWLNKabR1p8tS5TzoZ8BrHt8qYn6kpK6fS8eAqQ8sXY
32336	payment	2133	2133	1874	1	1	3223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiQDARpbFwdisqwc4YXL5pRczuxXHg19eFv5wKjqFiG6atGKX
32337	payment	2134	2134	1874	1	1	3321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxZYQ3wJmKXwuipD6CbfX9gZf3yTu7bLQs19fFfZS2DVq6TVV
32162	payment	2134	2134	1874	1	1	3268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnoF9kvTDkKgAShRLeGGdBMTfcAF3wj3MC9AAf3CLsCSg5ytk
32163	payment	2134	2134	1874	1	1	3269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtBVNMfPp3XJZEH25dfukHX6mRr6AP51hdiuknNvgAnuqPdd5
32176	payment	2134	2134	1874	1	1	3272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZVDrtDGoNWGDNW3u4CnNHrenSFrfeT6fvKJqEKd5gK8snkvr
32177	payment	1397	1397	1678	1	1	12779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoGfAQU6PRorgwrfoHECzFw6ewwANaDo9MrucHZPjRCjjSM6v
32178	payment	2134	2134	1874	1	1	3273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBQA1jKZX38uGwci2HEGjHhdBhEq1kE99ifX5JvAHZvcjpsoA
32180	payment	1397	1397	1678	1	1	12780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7Skkhoa8uqvZriqSvZhecFEi3i1FoeoRALzsU7D4aULKMZaV
32181	payment	2134	2134	1874	1	1	3274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrcP4VXhz58Er4pF5XqKaqDsEdM39HHfNS3Cx3VNdVigVUPRM
32182	payment	2133	2133	1874	1	1	3175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKv5DpFizpvDdToroYnuDzi1wc5VZuE9Dkjr3s5NYV6jv1gNCF
32214	payment	1397	1397	1678	1	1	12790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYke5xUQgPe1NvgTBmGrHJGaZ6Da8uYgXfEffcqm5343bNBg7D6
32215	payment	2133	2133	1874	1	1	3186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjveM32FYJugN8WMvD8gTfDfJpue8czVUeQ8fWkQZNe1MSG94
32216	payment	2134	2134	1874	1	1	3285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzMipDFdKnzx4KLK4VyQwbRMP2Pj31fxvKu1VWwQgtBqDzsSi
32231	payment	1397	1397	1678	1	1	12795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCZ3taBzUZV3kpqRCMyzvcnuCV9fqNTGkQE62A5fsFqTdpJZ7
32232	payment	1693	1693	2290	1	1	979	1100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZu9sr1B5RJcdCN4dx2P9gZihQ94kmPgoKb4Ux6hkFVy7m712Ag
32233	payment	2133	2133	1874	1	1	3191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYGQb8yCdTviAcH6TTzuUHnAQNzKxBwwuNSdVjHGSs63WMzug
32234	payment	2134	2134	1874	1	1	3290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJCKu3erR8idffabYDZ6ZQZXotkt1NpsLbTgg7rP2wWHQoLqP
32241	payment	2134	2134	1874	1	1	3292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeAuh3rDyLCNdLPG7t2QxeiYkJn3FXCrDEiGRMgEgvvxhGxGoU
32254	payment	1573	1573	1958	1	1	5	200000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPy2dSCnRYTYwsqugSoeAH7BigfJ5NevGXRnszJw2YpT2ddWhF
32255	payment	1397	1397	1678	1	1	12802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnGKwLtCb1jrZDDcFeB5qMETasmrdkEEmuKgARDz5nGta1ank
32256	payment	2133	2133	1874	1	1	3198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQjFVJCrXQ5WF2stsTPazTVof8y82Z8KGA4pBz3HbmVzkLFfr
32257	payment	2134	2134	1874	1	1	3297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQ5E9iXXiad8XTxbjxMrZU2z6mGTB819r4ujysPi2jghXwjdD
32274	payment	1546	1546	973	1	1	6	2188340000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpaEnvytq1hebPbycJ2imkFj1QuDw2UrPfNZ3nfiM8oefXAGqUZC
32275	payment	1546	1546	1213	1	1	7	2645900000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	CkpaLCzZzpig55oNNmwkMjk6PPswoXDWKJA5dhDhkoMHp2g5CZc3d
32302	payment	1397	1397	1678	1	1	12816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTtGmsaNqramNBYzYWSQzdTT86P9WbZSQbhZiKvjtgMWknroy
32303	payment	2134	2134	1874	1	1	3311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzuNMpvHqQYCNgrgrxYyLHxryR6BLXW4NB7nYFD3Qyo9Aj5Rt
32304	payment	2133	2133	1874	1	1	3212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8fbtpouCbPYnQGMC1v2uWYN1gQyRB2qi3z3N7Sp2pgTQk6oe
32305	payment	1397	1397	1678	1	1	12817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2em425ibf89PVJ35s3KgrHtuGuvqCwZ2FqqAbU8CtXxbbwpZ
32306	payment	1397	1397	1678	1	1	12818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeydmtnisLtRferjAuE3kRAQeBg4kuVZuUoCrBtJQGPUUTwBZ
32307	payment	1397	1397	1678	1	1	12819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FscHyrWRg6DYFnuZ6BSGyaNcR2Hce4EMpojR1TBhaFJ5AGhU
32308	payment	1397	1397	1678	1	1	12820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwif6qooLoYGqYZ1GaybVTVNPy98312Qk69NWPsWbRZzzTNN1S
32309	payment	2133	2133	1874	1	1	3213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzUihAe95qMXjEV6AsWUisENrBdG3CHtgVwdDLGHJZWN254Qi
32310	payment	2133	2133	1874	1	1	3214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2VpkkbnungGU2w7g3j2tVm8mahPwTxyNTDN256GcTq1Z5vDxd
32311	payment	2133	2133	1874	1	1	3215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHGiFHY9qNK8oMV6ZnL9Bon9SJkFQtErc8pQfSsLawEJrkYwK
32312	payment	2133	2133	1874	1	1	3216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLHQMbr1Pzx33iW9iogo6YSbdovqiTxWQ9BkccWwCvkord48E
32313	payment	2134	2134	1874	1	1	3312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6uELK6zzKpXMwEp67VwkWDgWePC5e74KvByWG4mZDsvqgm2i
32314	payment	2134	2134	1874	1	1	3313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSFS4bBWaBhbHvoY6aagrpUmm5tLGnmxaSTw2VWphTRvUevvg
32315	payment	2134	2134	1874	1	1	3314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURbp7B81vXk1puUyH3SchMtvbfzcbGuZUjcpWcJ8dF3ugmWRc
32316	payment	2134	2134	1874	1	1	3315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUXT6Z5PcNZow2CijpaiE7H7AKzpepQHXs7AM3e8MjoFQhYp2q
32319	payment	2133	2133	1874	1	1	3217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGd5VrWWwhrLDKqDoH1LY7HES4Fv7Tag8nomnzm93B4i3Yrxy
32173	payment	1508	1508	1261	1	1	8	3086062327432	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	Ckpa73GcbUEThbHBbNcMJusVhs4PDAvoQE1nvjRLpUQHcsNybvcs8
32174	payment	1508	1508	1387	1	1	9	8599587072748	10000000	\N	E4YiuwrGh5WDwwNT8RrZvvjhAwK2Ho5q4SisnVVcyr6rRy8K27Urz	CkpYmJre6BxKpiXegJ6Go45bZiK5ADdcQkQz8s1NTSyA33SvBHX7V
32175	payment	2133	2133	1874	1	1	3173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxM2EZj1j98i8Zzvjhb5XXoQfe1vZyZ2wfADAbNCJNDmkgYHf
32186	payment	1397	1397	1678	1	1	12782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GnuNmukVHHiBfonHKU3Sj7xw24ec72AhsyxX6AKYBn6P34HC
32187	payment	2133	2133	1874	1	1	3177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cYpn9obuN2pGfMF6TvWvP5P7oDHmNbyLVWGE5uSEkGAkWtaw
32188	payment	2133	2133	1874	1	1	3178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoPmMsgn5eWeMBa5Cs1XGzwTCEhYFKSu9Hkh3Bi4m39K6yKQm
32191	payment	1397	1397	1678	1	1	12783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamY92buXh3n6V5xDSZanGyWKfw5pKq48RScLBZo1r1o6vkQy4
32192	payment	2133	2133	1874	1	1	3179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAAqyyC8gXZa6hg3Kw9hioSuHjpJcDNCu6wfdDmWRr8DxNNK5
32193	payment	2134	2134	1874	1	1	3278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6C2QS4WUaZRDejiBTdECiT452LVuT6yvrHWNCQG18LtgBtdvq
32202	payment	1397	1397	1678	1	1	12786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5pCeGy4YrMadfvrPnYSGzdMWRfLqmsqii9y4M4vGHhvcNbbKz
32203	payment	2134	2134	1874	1	1	3281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VvE3sJbygvtPfLxCBrfAStqoTEmjrnfkjiQ6pxZj4xFkFfzj
32204	payment	2133	2133	1874	1	1	3182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwnZYqfzqvsCv1xcZXgUkqKtJ1QpQL22ZrTRYWSpEyncGfT8Y
32217	payment	1397	1397	1678	1	1	12791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWz9mF9p6CgjzbcjKnCbbxjnkobgiYPDfzdvYdDQ4rCFDzBnW
32218	payment	885	885	1483	1	1	5	0	10000000	\N	E4ZRdmB7ixZTk2KWStWBZZSMhXh25Dg7fzatagZfFovwNhvBtfisG	CkpZoRDgvZhP2FBj9uPqBfePnxSPXT7CNQrsZ8FHtQBCbbvDe1Xrw
32219	payment	2133	2133	1874	1	1	3187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk69xtXaymJkLEbqt7Nd8Bk68eiubcULgyXt92sMEu7RQ58qvJ
32220	payment	2134	2134	1874	1	1	3286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkTiX5r5omieKXwJK9YbFkvDoa2gFfvowe4pdwJty6EwsiRfHF
32228	payment	1397	1397	1678	1	1	12794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5N5GrVM1oEEXyXpGfEi3eE7R2QgyhivLAxuMWHN3cdRzzi29
32229	payment	2133	2133	1874	1	1	3190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EUdyd5873sMdEZJiihVT7bsLnGBVa49D3CTnyBbuyeHNvzTy
32236	payment	2134	2134	1874	1	1	3291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6Z4SLLE2t9H1uSASstoPtFtFDtHyTAKVwyfxjQngtoxXt6P2
32237	payment	2133	2133	1874	1	1	3192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwD72FgCSjNrPGx1hZ4woBovL57aT9dfTkAtXscwfB1x3pYdW
32242	payment	1397	1397	1678	1	1	12798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEEALTJX1EExcNjQthJG3RFmj2UXh9kWo4pC2gvVJNmy6zQG2
32243	payment	1397	1397	1678	1	1	12799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4EA4VNPZaxoUcHPr29VEyAwwFGGcsLbYrjBGvZN61kvj12VN
32244	payment	2133	2133	1874	1	1	3194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwr9puiEP6BwVxqwUDR3ViJNnKAopixQ13Nc4QSx5FkLDDako
32245	payment	2133	2133	1874	1	1	3195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqUZTkzb2GYDDtBizd7YRpM9w5mLxT14MyUvurcgQFJkCZYYH
32246	payment	2134	2134	1874	1	1	3293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoc7kQmP4URQAjiTDNWFa2pMxW2gYU6jgnnXAbnbwhQAAk2g5
32247	payment	2134	2134	1874	1	1	3294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjXd9HLviSU2Tc8Ce3XfywreN2QCGC8S6suM7yZ82h5C61Ytb
32258	payment	1397	1397	1678	1	1	12803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8Z4rxQzLJCwXSgznuhyRffcfhjKXtiTxo6TrxWDMw9PG5M1k
32259	payment	2133	2133	1874	1	1	3199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNDHzZNQbjAGW8zTFKZ6FufWv2T5YvQUjzP9acbd98oPFPZji
32260	payment	2134	2134	1874	1	1	3298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzugme2aHkfQvw3yM1j8m2VbFdUM33bPBuiRKLSoZjWyF7S1Xd
32265	payment	2133	2133	1874	1	1	3201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMZ1v5qzeThakkNpmLk4wzoqtyWErfHCcQN6Y8BRgkctJ49pz
32266	payment	2134	2134	1874	1	1	3300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8fJ2AKd3o9Sj4fToUwzWV6uerJZ5CcFdn2TPah326MAWwBrT
32267	payment	1564	1564	588	1	1	9	780000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2eXrgYjcGYDBTDJp5KJGBDA581oqWJw7e8CuLPMA1ERfiReNh
32268	payment	1397	1397	1678	1	1	12806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYogWAGEcTsuWi9rYkUhSCSrKTbh7wZk4ee2K7fgVkHVifE67LD
32269	payment	2133	2133	1874	1	1	3202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9wYiyVaAjEBu9A7JGsqXVWSjuEyM5otYhTspaLSMWvxW7goAS
32270	payment	2134	2134	1874	1	1	3301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EVfZdDNDXnHg5FbgiQKgQF7wGy761BSksemdiARGKxp4jXiQ
32290	payment	1397	1397	1678	1	1	12812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoPGDHGWT9GuZVow2sCnQr4M7ko6b3MMTQjvj4vQWEskKkBaN
32291	payment	1397	1397	1678	1	1	12813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNWgUPqQ2heEnUwg4QTrurnjyHT1zT8gUfPJTU8LGbfJxnjcB
32292	payment	2134	2134	1874	1	1	3307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FBxFsgmPz68ELSqjfYf6HjUzDEwuiivW5DTZNgPBFGUfZTFD
32210	payment	2133	2133	1874	1	1	3185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyMFnDehiPzvFLtWu6UXUHHtthX3FR7QrJLfhgp3FubQ6jp2z
32211	payment	2134	2134	1874	1	1	3282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxamnuP2LPti9S6sQNteqHs7oXr5JfwPZbokQpDbwR7YTGr3D
32212	payment	2134	2134	1874	1	1	3283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G5DY5GC3SaswadD3vz8QkCGHEiNUMFmcyLghupDE99S6iVEJ
32213	payment	2134	2134	1874	1	1	3284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkp6EUc5b9BpohEWsmE9YJqTd6MRfpRasPSrVv3KazQjdDGakY
32225	payment	1397	1397	1678	1	1	12793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZesQSFRZJjj5MCBEXvfEPSrWcNLApS7Cg5zCbFJpRJhB9kh1it
32226	payment	2134	2134	1874	1	1	3288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6E1QUT3KUHgzqR9u3SsR3yNDrHV2YsLQspdpufJeEYmtnGJP
32227	payment	2133	2133	1874	1	1	3189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDj7ZC1BFp2RtFFSDBtSXipM2h2H6RSCLMF6513Z6ceLdc1tN
32235	payment	1397	1397	1678	1	1	12796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecsShKT4BeM8b2Pwr3oiQRRS9ZAgd9pjJe2LM4opgcZUjhe4W
32248	payment	1397	1397	1678	1	1	12800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFy1ztd5V2Td3Ssi3ixgA1Zprj1LeWj92B4mm56gWDTHV4y3e
32249	payment	2134	2134	1874	1	1	3295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1DF61ihQuwu8rZDke6jKdAsAmDmwVEz2wY3eQmehSX8Yd3kq
32250	payment	2133	2133	1874	1	1	3196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qR6eYjWmAeTaBLuFCqTBYvNitT3Xz7JWZXuyzKuKp2v8PV3J
32264	payment	1397	1397	1678	1	1	12805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuQ3ziYYipM6tCEDjiMCpA3BbCEnX62VtLw8aYqWqpQ6ZwEic
32271	payment	1397	1397	1678	1	1	12807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqLVyisXUtZ8iTFEbe6P5Jd28JJfHKjjFTPV6egELVm7o2KKj
32272	payment	2133	2133	1874	1	1	3203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmC2b1whWkStRM9CBCp7CyJDMZQ47gCBxoevaqefqiKsfFerQ
32273	payment	2134	2134	1874	1	1	3302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEhxjbgcf3LXbMhQE8tV96CKJ51pMMMnWZDeVEzHFJe7fmfg3
32276	payment	1546	1546	1093	1	1	8	3921480000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	Ckpa719EziyTxFNV7pJA6ZR2abvMhBTKrUo943ofY52AqVwBiFgGu
32277	payment	1546	1546	1339	1	1	9	7373030000000	10000000	\N	E4YizKguWPYSRsh82zdxSx5H8pDPNtqJYK4u1qLGesV8VgNVtSMSv	Ckpa2k59uiTqCJPinV9VQ75P7vCo8pDCK5spLGFav5ksZxYdRGkuH
32278	payment	1397	1397	1678	1	1	12808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLVd76zMVwmBvVSV51eNbY2pt3wYsFAV7xuMG8M33Esp1B2wb
32279	payment	1397	1397	1678	1	1	12809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ7QJXMZ4HmqmdL3BfMHkCQeb8dqahpHqUHxCJmCJ23JLKdjtb
32280	payment	1397	1397	1678	1	1	12810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwiP9bkJoNwUeq1kYUizKRQbwA98gL8eBX5RdbNX3E6qfTFTW2
32281	payment	2133	2133	1874	1	1	3204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrthLLBFvZbQBViNhbbybG4d9w7xzkyRJZuRC79kueL4tMt8TW
32282	payment	2133	2133	1874	1	1	3205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEPg84xiqfF1YbNKDqw71cEHcP9WtW5qZNqKvFNNnikLtNcbJ
32283	payment	2133	2133	1874	1	1	3206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacuFc2KmnTqVnykPTWX5ocfGYGXAnMceuArd1SdigL8giuFXz
32284	payment	2134	2134	1874	1	1	3303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQK2Nod9FJ4QAhM4e3gR3JyiFaFgtHLadQoVZmh98mi19cuhU
32285	payment	2134	2134	1874	1	1	3304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HrvxcFVys8JgANFGatpthdTkVWAXUBKkG1ygtFJWRWSCYFK8
32286	payment	2134	2134	1874	1	1	3305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDbZmrxkAmLFg3x7ksybBnyzNPJHYYvui67Bj9wYTRwQG11TE
32287	payment	1397	1397	1678	1	1	12811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKutsGNhZzLn5TC1MpXtmSDp58jeptXwmi9Bc5oP5LBeftaeVu
32288	payment	2133	2133	1874	1	1	3207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayrc6aCrSFJvnqfYHN98K5gXT7PyhUpk4k6YgiBWs5rC1DsiN
32289	payment	2134	2134	1874	1	1	3306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9LEeHPoGfaVj4eHVZWYtKrrGNHaPdcQyoz6TTT6CqgQ4aHrw
32299	payment	1397	1397	1678	1	1	12815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2jC6DQB1TWw7Fw8sW4gAuaRsjau4oTV1HcM2eD5DZjGvqk71
32300	payment	2134	2134	1874	1	1	3310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgmnvMWfmPk3hvMFFLFHNfMKwrPBsCG4TKReehcNQ3T3EzYFW
32301	payment	2133	2133	1874	1	1	3211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzhEANFFqyJdZjnuScTt3j81HmfoYfydipbppWQC9PKqSmSUR
32320	payment	2186	2186	2291	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCyHvHYcfDCfNBfRsSQzf6FM7gCW9uRbttY2ZXJwrv4SpJyor
32321	payment	1397	1397	1678	1	1	12822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZwrtGLeUGwpNuJFCKYvJoTV6FqRwH4cSuwfSwhEY3C5xg7xq
32322	payment	1397	1397	1678	1	1	12823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xSHvLvkc49K8QKvpJ9hWAtmJjJJXjY92cngwpUe6wEVcMDDo
32323	payment	2134	2134	1874	1	1	3317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUpR59ZAJLtSicP1YS8bBvX88DRvHzVs5qbC1tjULACxhFGcx
32324	payment	2134	2134	1874	1	1	3318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2KnqVbX4cW9JX8aV37Jh5iAxj4YqECziWYrsGVxTNCGxzF2PA
32330	payment	1397	1397	1678	1	1	12825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuPyF3aLS9y4wWPw5BMGLvyUv9zqPqwyreD7cH6QcrhpyKe7V
32293	payment	2134	2134	1874	1	1	3308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgH1NBx8LvALzDVwz5zaHFxmbWet3F4K14bYLLXENEHjo9Gf78
32294	payment	2133	2133	1874	1	1	3208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3CqEAvfAfhZ5aeTBP3aK4JxGozCk6imTET76B7LUfNqfsAKZ
32295	payment	2133	2133	1874	1	1	3209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFP7pmBfX2VkWXoR9vWDiHakcX6G4J67LZ4SZQgJqtGTSXKLq
32317	payment	1397	1397	1678	1	1	12821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BrWkFUhqQ9vehCxQLDdi1wgjgBaZJhjFok53NfSo7Ax2xWyr
32318	payment	2134	2134	1874	1	1	3316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3Sv6usqxspNuSmeJvXa9uj8jBBXNVReZvX7VJz4R5U5SapaZ
32325	payment	2133	2133	1874	1	1	3218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLGLuDwnsgwvWJ23RrNVd2qHAucGKbyS2ymrJXQue3FEDPFMc
32326	payment	2133	2133	1874	1	1	3219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4RRUqEEWvK8cH5w2LaBzaCueDKYg2RwNdcJJq86QHJADknUr
32338	payment	1397	1397	1678	1	1	12828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeBMQqvi9nYKk35We4LbE4jtWTFNeMWMXEUChHgCUjkanu6nq
32339	payment	1397	1397	1678	1	1	12829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbcXsiLC4MQEvoXuyXnQvZojpYQTEA2pYVy6CaqWqsepwZ6KFJ
32340	payment	2133	2133	1874	1	1	3224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXpo9PzhX2YuYzKYaJy2Zgeps1xt7pn2RBXxk4MeM1YRJNcNT
32341	payment	2134	2134	1874	1	1	3322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PeENpzQy3X12Ecu8A2nDpQFkWpUrd7ScqQa6ZaCQ8GEZmZ7P
32342	payment	2134	2134	1874	1	1	3323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqyPXxyA5zrzVZc5CsES4wBirAPxpQGkbVYTpHH7cL9uu7iyR
32343	payment	2133	2133	1874	1	1	3225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPTE4kqL7fddNP7P9DhKhJbYaRYwmkDhLa9Z9JZPgvfL7TKaB
32344	payment	1397	1397	1678	1	1	12830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKNbSPBC2mCfSgxvEocbG8yrWyCrT9NoEfBqnHyM1iZ15Q53c
32345	payment	1397	1397	1678	1	1	12831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZW34BEPMunM2EyJuQWMRWifdUQvU9MW7QFmPmVgcJJ7b1hh7E
32346	payment	1397	1397	1678	1	1	12832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqrTjqpmFbGPBZg2j768HcHwzHv39Mf1VfNUKrJ6F8WiqSu7v
32347	payment	1397	1397	1678	1	1	12833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHpbhKuLJJEvBSBB37GLakH6x9nWz4n5pYLm4ywb142rhAmeW
32348	payment	2133	2133	1874	1	1	3226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTSXwjVKbyXrPQ6JahVwcUKTJ2znWaUZ3bNpiB4N7erscQ9Vo
32349	payment	2134	2134	1874	1	1	3324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXoSGBCcw7URMf6ivxZ6YKXNmcYXunkgpx3kXr5fLsfDJUzPjR
32350	payment	2134	2134	1874	1	1	3325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6hCL5vFjsJPxY7RzQsiezYd8duybhdhU9Ka4zpPWUVnf13dj
32351	payment	2134	2134	1874	1	1	3326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR5tPkbS6Ah3VfZUcMBXYKuxryjk5mgTViX6Yq5gKf3XEUHmr7
32352	payment	2133	2133	1874	1	1	3227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShb3BRHoQrXvH9YwYVjzMNGoX1wCzMAudAg9zHDWFt7hTS2cm
32353	payment	2133	2133	1874	1	1	3228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaULNQg1EJ9YmG6R5CaUQjasoVkgdacC4nn6DDDyntsoir3yte
32354	payment	2134	2134	1874	1	1	3327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwynrZr2Uwmqc1eLnt68wcdAdVmkS9Pbv1QSEeXosrUfWQife5
32355	payment	2133	2133	1874	1	1	3229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHF54q5dPT2jnSEMAhSszqiLZwJrgEcYPbPLEbWv9nejid9CK
32362	payment	1397	1397	1678	1	1	12836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFGrroYtewfJZe6M27uvshZTRfFy45Nnyd42k8n5qoDDaKF7p
32363	payment	2134	2134	1874	1	1	3330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpCTtETVXuqMasaZLJQvXiU4gZTyPH1T9isDsV8fGfu7FpzAz
32364	payment	2133	2133	1874	1	1	3232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuaA3aBKrg3qKzYBxJJp1UTsa85x91Q8kPVuLqSbLB6S3jDPud
32365	payment	1397	1397	1678	1	1	12837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75eNDmLirP9Pp8iPgH4bWZdNZSNRvXuZu5cF6bikPZxf7ERSM
32366	payment	2133	2133	1874	1	1	3233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNWmE2jkoxgq9xWZRib6nyDTD2fqjnDMz9JHmBamYiwye7MpP
32367	payment	2134	2134	1874	1	1	3331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBFttU6GWwM8kHHYuRciDQGD13zv1ZAudN1YYcUZrjedqpR2c
32372	payment	2134	2134	1874	1	1	3334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKYEe9oBjLFXF7mPWzBvfxsB5tXyY6LvcX1FdFvkwWCWE4eMY
32373	delegation	1877	1877	1442	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7w8utGP7MxgTtoqV67nQpvhKrhDPeSjAEnXbgZszEvfAwJTw
32374	payment	2134	2134	1874	1	1	3335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNvpj5BkMFwEhwxQaPtcSFMNRHvb9Hq8aZaAqx8npUQLf66M8a
32375	payment	2134	2134	1874	1	1	3336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrfFB3rXUEW5R6HL8aXgxvQMb4rhNdYDB4wHedxVdPkno44q4
32376	payment	2134	2134	1874	1	1	3337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgKHUQuoit6FiqaCujaphYk2RcPEg5N91hVD5u3kBkL6jxAk4a
32377	payment	2133	2133	1874	1	1	3236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcRCD77uGiJjGPKiMvTdaJZkcndWSW5bu3a2HDbHjSMgbzZ74
32378	payment	2133	2133	1874	1	1	3237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtzYU4Y5U68PdUAgmaPZGizZdZ8qd8niM66g15haS6iLtX6Nf
32327	payment	1397	1397	1678	1	1	12824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFc42PU9BS5QQBHmFdXCmewkNskVaqXbJLPzLoh2DwxMsDJTYB
32328	payment	2133	2133	1874	1	1	3220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmgKXMX2u7Qd9VFBzZTMNTab5e8uoTprDgsuW64KsgFjSPt5e
32329	payment	2134	2134	1874	1	1	3319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbniiJdnqssqpDXDzt8RWU3WssTNRPuMV53zjYveeanWxgPHc9
32414	payment	1397	1397	1678	1	1	12849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWzH8pRcfeVPhFe4qQ3XM5nY4M8wHQTSsJREvoxMYVDoeVMFf
32415	payment	2134	2134	1874	1	1	3349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9LnfBYMXbGsyzcsLutJQvDxvhEVezub38GcZKtUSn38nGaKM
32416	payment	2133	2133	1874	1	1	3251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFE6bf1afwSRYB71ybvraN1s5omTvabKnM62okdZuzKnubqiwA
32426	payment	1397	1397	1678	1	1	12853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJDB8T5M2yRocjpex9mTLqFEyEwDenPKVFWvy6EGp8kuTNvkn
32427	payment	2134	2134	1874	1	1	3353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYir3MuuBMf94iZpCEVKZDA4ZpUemZAYQXPaV36zaTFGpPh8QMY
32428	payment	2133	2133	1874	1	1	3255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHdeddUe1kavw6HeYzsMaUTvTJUjB66gtVwhaxReLpVz9XdWc
32482	payment	1397	1397	1678	1	1	12870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTe6VbYr5yC63fvUE98GPvF3m1GDbvQByCoz26Jm1twDPEL23
32491	payment	1397	1397	1678	1	1	12873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvBTT3t1gTPgcvrV3rWKRJPHo3MpuqyPqSTA95ixzRReYpNdT
32492	payment	1397	1397	1678	1	1	12874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZUrJJnRUK2yewTuntTp1XU2Gc6Zc5GtwGhvT7M6DvWrjB4Y8
32493	payment	2133	2133	1874	1	1	3276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqSoC3MXPGNdMcVnnWgqULMVh9rhmYySLroNMJG2PF5eUs2zK
32494	payment	2133	2133	1874	1	1	3277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGyuJiNuE5Y9B2eKgCQKkMYHj9s4cUQ7vAn2tgXCffK93eRwi
32495	payment	2134	2134	1874	1	1	3373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgyh1na76reg8KRADXr5mKfgB2nd15DGNJ3tJagqxEkg9LrzX
32496	payment	2134	2134	1874	1	1	3374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXTv19f5q5pvvhKnEP35xxa2HV61tm7iwaTEVtdrHbH6FxuHi
32509	payment	1397	1397	1678	1	1	12879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdzXdDD8tgFJntcqHUgYBLgUYCbXQz9LpCuBZWapJjv4SJMMbU
32510	payment	1397	1397	1678	1	1	12880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFnMRD2UqYYrwQPge86muq2cPC3yAPRDbs49uMp9dxRDEwe1a9
32511	payment	2133	2133	1874	1	1	3282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPio1wTy2hNmQAYrwNKTKYhKr2C3ubm3g3tzbHyPtiMHcbKiT
32512	payment	2133	2133	1874	1	1	3283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdVUdqVZxAQvUVxK7d3egtRoKqDTHE34pPjqn2Y2Di7bLdVFv
32513	payment	2134	2134	1874	1	1	3379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyngGoEvSCLwGvsM7iSUugPbiyxx3qznNtyFrEQ7d1s7uLvjuR
32514	payment	2134	2134	1874	1	1	3380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELL77ENTYSZds7qByspcshen3QoK4uuRcHcB5zLXCYiPHBPsN
32521	payment	1397	1397	1678	1	1	12883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75eo51abN4ZGurwGmTfPZFuuFNzQA9S3yL4TniWza6wegEppn
32522	payment	1397	1397	1678	1	1	12884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdFDAty7sbwA2rCQ1eHCEE2eVLMgPYQZfvYjqixqEi3UjzPGE
32523	payment	2134	2134	1874	1	1	3383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48DYwVRLmUcok2GbScaeyTSxN8Dz4XKcgRfkzNPUMExzqfwrd
32524	payment	2133	2133	1874	1	1	3286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mp24qVbcPGTcdAjDXMphbMp5ZMtCAE5DcASmNuuXRXPqHtPC
32525	payment	2133	2133	1874	1	1	3287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbknUz9KGAiYCVm88TUUos6AdJPCMfHegNeRt45witFuJwQ21m
32526	payment	2134	2134	1874	1	1	3384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqNsxMG5s1657i47RJLvXA4P57yvxNbAFh6qio6MKPAAyDz4G
32545	payment	1397	1397	1678	1	1	12891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMH77DJf3WjeCgxGvcQE5579Fp7KWcN345GsN8srsMtM6HkR9
32546	payment	1397	1397	1678	1	1	12892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZHSD6senLkGLUUuuaZX2Peu8w9q6LxdsK9vHabh9ETGbhsYq
32547	payment	2133	2133	1874	1	1	3294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcNgwDXW9Ripq9eUMWpb7RYLxkBYqk4UwCMZMFVoEeuofMsBA
32548	payment	2133	2133	1874	1	1	3295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdzJe3HCzfUTeocrH3d4nmxbuVy9kLAitqJCWGTGowtStodnGj
32549	payment	2134	2134	1874	1	1	3391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2vcp5HPtH9UNknaoM3Sjum3DT42eBZmVy2eDfGfv6kbAsjk1g
32550	payment	2134	2134	1874	1	1	3392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQd1sCNH89VGpNL21ZiKUejFFE8iSsFtLSuuKMy6U9H5gfb3bs
32572	payment	1397	1397	1678	1	1	12900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9h2PB2c2PWtuPQsqYv7AsTE7QKM2KMKekEn42bfcGLpSr394
32573	payment	2133	2133	1874	1	1	3303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUC4eky7KpENY21YfsS8X6PaWboA4MNhzcs8cTAS3kn3G5UtH
32581	payment	2134	2134	1874	1	1	3402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTq9fNJBzdURu4FHXgU8bAPb3LnsNwhk7G6KWL8ZzgXeDkPHkL
32582	payment	2133	2133	1874	1	1	3306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXkZSkEbPLcuc8RDZNQ9u21szC1WqxwMN4wbo26sZe7gptWN9
32331	payment	1397	1397	1678	1	1	12826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa274sjx9gQCp3FvDmD3hSiGnkybrVWe9PV7HYcvsgkrbeo8v8d
32332	payment	2133	2133	1874	1	1	3221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQHEwSPcyCT1Bg3qHpqPAbZk6U7GvRRF6iyohBr8VsxhPXWRW
32333	payment	2133	2133	1874	1	1	3222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQ8oetWXMZKEXQC9DURVmZ6iXqfTcuDnt6ZDStja9M2b2Uyxh
32334	payment	2134	2134	1874	1	1	3320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhj9W2GqhvqmReDKr1RU8mxwtmgHHWtZNKi2HJ7esRhkRdPho
32359	payment	1397	1397	1678	1	1	12835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHWdnky9BuYe8Wa2GZczAuCTuhnULu9iVvUdoka6UzJVwpgF2
32360	payment	2133	2133	1874	1	1	3231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvV9ziscp7H5FJVMQMhKhbhVMJsk7E9ppV4TvVbzmpfqgsKwY
32361	payment	2134	2134	1874	1	1	3329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrzSxs76mQpue9iRWBhTjYeuiMuXqDkRFbgTsz7CXbrx3JVbv
32370	payment	2134	2134	1874	1	1	3333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSuhhTSzwuEDqMxgqikSNZW9biWWFtQQdwaWhFYsPjgC2KzQH
32371	payment	2133	2133	1874	1	1	3235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazPbQuXa83hW1FQWG1nKaMSUzQAAUt7fGmfG4hpbHi7gMQCqG
32387	payment	1397	1397	1678	1	1	12840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqzycak1vn9hWGxCJRqM6WuwQjBGGHyHDSpW5SjfiE7sHJsCF
32388	payment	2134	2134	1874	1	1	3340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoJVyHCxVX3r7E1Lv55keNGLL7SdLZGwhx2gLD2tgoHZQxvny
32389	payment	2133	2133	1874	1	1	3242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDqwNSGCXfWNBL1WzfqD9mgGXN7oytqdWL3srnzGoeedcgdkC
32390	payment	1397	1397	1678	1	1	12841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTn61WF8ijrKpD78yBM4egQxXhwRdggTqzNHokgRoFHNz6yi8
32391	payment	2134	2134	1874	1	1	3341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVt3xorUYpSY9A2h689pqZ48W9z2Qha4XVrpuy7UWreEH1HehC
32392	payment	2133	2133	1874	1	1	3243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJbo57HgGtSwoqdVQk6eN6FUsfTMV9V1ocHrNeru4GHqpVfAZ
32399	payment	1397	1397	1678	1	1	12844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGUyrDKigZBewVg75CvJrWXLVXcfotLqLeA5idshGsNhWjayu
32400	payment	2134	2134	1874	1	1	3344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iBVjV97aDxFnenzwuApFLUDWU3oMEGG33teXX85gXHqkR7Ct
32401	payment	2133	2133	1874	1	1	3246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUdYiwGhTG3Mjm6aUnqNToorvo4qp51bzBSYiaGvSor8JRAQn
32405	payment	1397	1397	1678	1	1	12846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkZZquRZJqBrG2b1uuYvZLMByhLKYX2497cHj1GgedJJQV88E
32406	payment	2133	2133	1874	1	1	3248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfcPbyUYEREhHm7N8J9StzxVW6aETXM4zGTn4k1cY14RStyQp
32407	payment	2134	2134	1874	1	1	3346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HyHesBXnS7NKWBra5RYA4BoAhBCMf4oXit3Y4fVpH2ymz5Zt
32444	payment	1397	1397	1678	1	1	12859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZadTNzkqu14GAS5EuTnrn7XXPxMTHa5r6nDgySZkPyqjtZPj
32445	payment	2134	2134	1874	1	1	3359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8gqk18otfDUos1cSvfAFBNNPBgRTqqLWqe68N6VNfhE9tRds
32453	payment	1397	1397	1678	1	1	12862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7x5V9DnQwTFBYmzm8HmxRhZA1WsZacJhyWd2v8Q8K3tybwDni
32454	payment	2133	2133	1874	1	1	3264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpq4MBBENFQjLMccuN38Ye1GtKSNMGwMbANr4VxzTHG5j9ME1T
32455	payment	2134	2134	1874	1	1	3362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyahfmC8ihvUJndqGCjMLaTvgsTRK9q6LHuX4uk9EAHrMT7t8q
32456	payment	1397	1397	1678	1	1	12863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcc4qjnpJ6BKh6bTvVhVgJXZMRoC6C6LBoW2MyvdiH96kcYzWH
32457	payment	2133	2133	1874	1	1	3265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZY8u4SpVFwq7ykKK6umS7EMSjezeDdazN5HSnUgWdmdhdYic
32461	payment	1397	1397	1678	1	1	12865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsMqm5JVB2sG1zw8WGL9RDURZvG1iPEE9KwyedR25ZNQ7d53H
32462	payment	1397	1397	1678	1	1	12866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3tjqyNpZbrtpHNoa6XRPXm1EH5Swk6aBLNz7gH6Vh3Xqn7vf
32463	payment	2134	2134	1874	1	1	3364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAuR14RexgwK6eUAToWLCfNuu5gGm5EDDrpH1rHFNuQ2rxzZYi
32464	payment	2133	2133	1874	1	1	3267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCnfr4HjELVzkQWvzBQCuHzy3ku7WT7bDkvn5xoRHZQcRLRiXb
32465	payment	2133	2133	1874	1	1	3268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpos1w9RnvJEoptbm2qHd9UWGiH81oFxquDRvGtTXAboi4pUxs
32466	payment	2133	2133	1874	1	1	3269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD5JzRFNwME343GRzzovBobgEEHjZQ1QKyB7HuHxdk3UQyhkrn
32467	payment	2134	2134	1874	1	1	3365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBZ7e4mNJbKGfJVKDFUZXEB44cV4GBhrE8iPeQv1mHn37eHQQ
32468	payment	2134	2134	1874	1	1	3366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZDY2aAWU1FzSYpRAg7Porvi9C3Sr74JdjRUHhsq4jxepVgyc
32476	payment	1397	1397	1678	1	1	12868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVXsjn9iF2J7SSjp9U7bbLWycj1AJc5xoqB6JjQY52oVLpB3X
32477	payment	1397	1397	1678	1	1	12869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdo5p113wNWjyX41uLi5B8Xt5SBi53aUBDgXDmSVDipwFxSGjD
32356	payment	1397	1397	1678	1	1	12834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pfK8F77vSA39BMsJiLHAsGuPEodoQs96WivZiJY2KzPRYtvY
32357	payment	2134	2134	1874	1	1	3328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Ly73HA7EkBeW5kPzcPmV8xq3vhd8gECkRGk4uWE7jyXsCcAE
32358	payment	2133	2133	1874	1	1	3230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeQkr1T94TuKNWdh7e5dhA1ZLHnq3sEDJ3zYaU5D5hiXW19iS
32368	payment	2134	2134	1874	1	1	3332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmjaXHiSTWwJqXHE4uY5x3oiRye4nVgcVT1jLxxsjkoRzExuL
32369	payment	2133	2133	1874	1	1	3234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrekUC7LU6RiN8DKqGziTNCeMgNRk7SefZVKduxTbMf2znRY9
32408	payment	1397	1397	1678	1	1	12847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTLeu5muWfQNE1qzzFQo9FvqYqmjStrsanKu7D4xwggXJqwhA
32409	payment	2134	2134	1874	1	1	3347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoypN28WvmzgK4FqT1fhJJnXHbH1YVXooQd588MEmz2X5bXjBj
32410	payment	2133	2133	1874	1	1	3249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtA33Zux5h4bBePgkHqg3r23uNBcGYziffPFvJKcaJ3NkhUSF1
32413	payment	2133	2133	1874	1	1	3250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnpYRojEr1hWiefZJFeLbeKDwSUV42VWooHnKr7oCEeb8631p
32417	payment	1397	1397	1678	1	1	12850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvma2KidQNeLi1xhcwpq77rrm2LohDW6ruwE9pRDci8CvDf3C
32418	payment	2134	2134	1874	1	1	3350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPatvCaWZGBunFncPL3VDt9omxPJWz4RpKQTEZdnGY5vfntF5
32419	payment	2133	2133	1874	1	1	3252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaASwsMMN5uAu72VMnoBZBj816uMeFazstpF2fLHrwxt6JubagE
32429	payment	1397	1397	1678	1	1	12854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGb5DTs2wfp3Jw5gj9prXXUdbdLPVK9LdwCN6dJ8My6aoi2Ue
32430	payment	2134	2134	1874	1	1	3354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpwGwBRgtD7qKB6szzTY1nbhHN7vgdWvQ7odALZtLCiSRnB5H
32431	payment	2133	2133	1874	1	1	3256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiEJkypZVwifw4nh2xxeSFTUdGWk5866bfF3toAKGQpfHeRCr
32432	payment	1397	1397	1678	1	1	12855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVjirdhZfV6h3WzZag6vyhvPZtALDndEyrX98WrXC2um4WuZN
32433	payment	2134	2134	1874	1	1	3355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8vkU16o1B1uWAvMF5XGmFpgkMk59APsVEG9YSsGkWmCCxgMy
32434	payment	2133	2133	1874	1	1	3257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBAtepGsgpQGvVVM4GcvGSoBWCVumSQtZkPMssdC6NeG49jeH
32435	payment	1397	1397	1678	1	1	12856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC7FncvNHjDb37NQEujibBswp9z8mrHDWVt87cnG2FeeHpmYa4
32436	payment	1397	1397	1678	1	1	12857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSv9TRcPT4bR4WV39inh33Tjd1vtLkBGq3hNJQpqw4DHdbTaLw
32437	payment	1397	1397	1678	1	1	12858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzc4rCGmnuqSKXHKHryKsaTAvKAWPPPbYnWXmD3GXRYWc8s8yp
32438	payment	2133	2133	1874	1	1	3258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFsBffBeKR1KhGLFwhuNeajfixurzVqXZ4x2cDn8gCV7pDNeS
32439	payment	2133	2133	1874	1	1	3259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVbjGQ6f4vBfh2RtrT3XVa2X41yUNcDRCHQHYqyGdmmTpQoa5
32440	payment	2133	2133	1874	1	1	3260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYik4YRUBLwiak6nr9WefneJyzq262rhMLooJVNvRwtqj6nPt99
32441	payment	2134	2134	1874	1	1	3356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFx6FvxVfzoq55wy3ywXLfC1ToH54WiJQn5NWSiHGGwbZE8Ukb
32442	payment	2134	2134	1874	1	1	3357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSg6gSdjwGRFkpfNViuU7bX5zWdZGM6EUkxifMC29hLsYAB2R
32443	payment	2134	2134	1874	1	1	3358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9ZDJjLHewiN9YQj5ZJfoXyz68FP847se7dAUULbyDWct6uFe
32458	payment	1397	1397	1678	1	1	12864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxF9MeeHcP9569XG6NZNQAxtRS4RpUf34XvcF2Kw73S9E6sGd
32459	payment	2133	2133	1874	1	1	3266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNt1Ww4mQvvmbAy7xCbPbEdgtpKSkorPTsiMfSYHQtUrNwAb8
32460	payment	2134	2134	1874	1	1	3363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgSfr9HXoZ6AXgChVFTGYPmUJ92cwZGcJCHYqXD199CUVycAZ
32485	payment	1397	1397	1678	1	1	12871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy9g2Vxw41jFojpAzx1sFz5tKM3gkzBEKK1bdGAehEvivpoNEM
32486	payment	2134	2134	1874	1	1	3371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfXwkBuVWpoSv4ut8o13kJyEo43uqEzFpW7gebMo9QfeVobf1
32487	payment	2133	2133	1874	1	1	3274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKo6RC5fxH3hsHsMLdZRTP83gi3JW76qCQSggrx8YYHMuvYunM
32488	payment	1397	1397	1678	1	1	12872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGqqUUZJPUp7dBYKrVKeJKL3cgyZPZ3MRFXhDtQLmsAs8qagy
32489	payment	2133	2133	1874	1	1	3275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvY5cUpiowp46evuLzPgJT71CKRaUeAkZ9szzpc4fitzhjUonm
32490	payment	2134	2134	1874	1	1	3372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6sKVzPELSW3ETE7UQqvgn5L6cTVcPi39ZPpQFEePqd6WVjDB
32506	payment	1397	1397	1678	1	1	12878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG2XEs1gfvHCoH3W2FWqi6uDkHix5YS5yEaJ5UQAcef1g7sGx
32507	payment	2134	2134	1874	1	1	3378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrNCQYsH5JaqNcJwh2CKoqrpMY23iwNLrwzLmoRcu3L2aU14D
32379	payment	2133	2133	1874	1	1	3238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWizLNfZKgNPGBqksUZxXvg6tBGUKBTK3i3RMNFTDSWzS6TcnG
32380	payment	2133	2133	1874	1	1	3239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxqnX5W1xf1ktWte3wmJGiDAGTo3rQbbFdMetkd3CFD2QHk5K
32381	payment	1397	1397	1678	1	1	12838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRS1c9jnzexyLCgzUdDAdyD97YaJ31QV476vaLtnG6eXfZSWNN
32382	payment	1397	1397	1678	1	1	12839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFxhK94973BAsobqPHzmS9mFivdxKb6MszJsTYkvyzbpFK2bC
32383	payment	2134	2134	1874	1	1	3338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjARpJ9NdhB9ksweW4EJi5EB7h7AwGcWJVhz7kC82TkXSVcSY
32384	payment	2134	2134	1874	1	1	3339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u7vbF1JJ4t8cmCJoeDA2kU2sAVCYYUZB1idpDjWDhDQPtUKd
32385	payment	2133	2133	1874	1	1	3240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3rVzrjw9DSLRsJ94XGAaPzycsSSHSsSAbPmCDyjsm8UKoPnx
32386	payment	2133	2133	1874	1	1	3241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwa3wf35GLsYctwpEQzYN5YCH5HU5Gc1oCFNU7DqPdAMVdZrAa
32393	payment	1397	1397	1678	1	1	12842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtjr1EsQrPdqVMcqa4jMJCQXHs2SjiYyLhJa1V4584C8grt4F
32394	payment	2134	2134	1874	1	1	3342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcpipq2e8SKmsAkU9SNYmRudKZLg4S9VSPz5WPF5yq6a2ZVcrY
32395	payment	2133	2133	1874	1	1	3244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNit5VVhiPbLsAUbzGkEtz223VFJrSxrKuh5tNMkif2mhEXEC
32396	payment	1397	1397	1678	1	1	12843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpiLoGMs3AvrkPrQu9yhLztiFX3WYboZvZEmV3ynSpb7bjpGQ
32397	payment	2133	2133	1874	1	1	3245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkixjJtq7f3mVq5W5effdKcbQQNNk63aC4psymXyKX5PqbRMuZ
32398	payment	2134	2134	1874	1	1	3343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiStH1arhLsWv4zXzTaeF6qiadSCsWKekHzU1cCyvrwf9Lbowq
32402	payment	1397	1397	1678	1	1	12845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7xqUDZc1yekMouBZkAJFZ5f5jHMRoyf5XQeaYj17zrHbSzZ6
32403	payment	2133	2133	1874	1	1	3247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9jeneKrWzz2Qdvp1kJ1EHYF1s6TmWG4GpU1DD1xXgJmRjhtv
32404	payment	2134	2134	1874	1	1	3345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBeFD4MARCRTxTNUreFhaQZozAPuitpMZxypAxJASM6mYW1M5
32411	payment	1397	1397	1678	1	1	12848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4AsbTBt5T8N2vHuKgUnDwVDC7fQczt1YUoJ8PEvfYyvkojN6
32412	payment	2134	2134	1874	1	1	3348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwheMos6ZWfU3m1efJogugVmdb9xP175UL9ecAAvxAPhd9yq7
32420	payment	1397	1397	1678	1	1	12851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxijojjmqWSNUJsLcgb8AcBy9En6Sgea58RJ9NB9LU3krvg2i7
32421	payment	1397	1397	1678	1	1	12852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgeGvmrLXzdiaY3ej2uww1pLT5DyE9UkDEGkVo43DYo3f4Kvd
32422	payment	2134	2134	1874	1	1	3351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJgXTvyaFaSbRAPQsAuupeQ1wdDgUE4E5HBcioSBRpATWsyuZ
32423	payment	2133	2133	1874	1	1	3253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZ1tauW5ThaeFgGv7JQnZfaccfHUie89T5p9VE7x2foaKzRrv
32424	payment	2133	2133	1874	1	1	3254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWKY8kpdfR6XMS32PPHKzxYtbGuYY98KutcD4CuxQtVzGGmNg
32425	payment	2134	2134	1874	1	1	3352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3ar64JcZrq5hdyrZ4qgx3vdQHN2aXchY7vMLpBjibNmTzEtv
32446	payment	1397	1397	1678	1	1	12860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7oMJ3XecVSTGakgpiQqcX2mrn9qr98R9GN7XuzK6RCdVsxrz5
32447	payment	2134	2134	1874	1	1	3360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hNyRE4g1WDYV4tyxEbAdRaiJFsPsdQxd1r8KGZXKtEvmanS2
32448	payment	2133	2133	1874	1	1	3261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArjTyrdDdcj1LWftsfuYZk3QV6kxvcmUPrJs3cW7hmk6Prpq2
32449	payment	2133	2133	1874	1	1	3262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2YARwKtvbo6cdjvmn765BvvRXWACRKv2ptrewnv5RBQTJKQc
32450	payment	1397	1397	1678	1	1	12861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXfWxvjrhcRziA2XszqV8fhJ9vufR8tmkSRheSre9jqQvB5w1
32451	payment	2134	2134	1874	1	1	3361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpYAC5q7bQ6HLCTx6Whpk76EA25769Rfyh9iejmqaw7V9WE3Sp
32452	payment	2133	2133	1874	1	1	3263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34UjpnBHur8XrqQdtahzTuhwyd6NsMnQz5QVz5meT3kdxQxSk
32469	payment	1397	1397	1678	1	1	12867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXq5VvMx7k1CJHYF3f85ZWSdWiSTPLzPD917HKeo4gXDSf75tV
32470	payment	1573	1573	1318	1	1	6	6217000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUHyJFYHWxTTvwXKTqvMnjt6X3Y484MoA9jpVJmH4s2tHna6W
32471	payment	1573	1573	1072	1	1	7	3307000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVKeGaRxEtyusCm74y5FHewF35gY4qKiS2LXYPuxXXeCn98q3
32472	payment	1573	1573	1192	1	1	8	2231000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgV8iZidpAade5sg1w4CSoRFuhqzaTph5kunqV9YSuwZCy7Bmi
32473	payment	2133	2133	1874	1	1	3270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUu7ZKKnBHH9JN4VLNHp12Pd4pknocfxCRupyhQ1eeYkABQyb
32474	payment	1573	1573	952	1	1	9	1845000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGJE63XeYyhehUzsFDgCiTF1vg8xoRikpPyu183NaPsMRPKzF
32475	payment	2134	2134	1874	1	1	3367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSf6Ab1uR2CHCoLCg4S61BLwNSWEkig2oN73h7jPVWEJNMdjh
32503	payment	1397	1397	1678	1	1	12877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBV16Zj93pvZREJpq7SH95FxSeP73UPyojsAZ6UcgzfSsu2VNc
32504	payment	2133	2133	1874	1	1	3280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyNC1CYNtBurbUguKP26ckVFkGZaQfnLeV2zD9H4hGBEZ7YyU
32505	payment	2134	2134	1874	1	1	3377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XNVu7b9ZiKfvueXVjB2BJFpKyh92w6xksF9724ai6KhHyvAb
32515	payment	1397	1397	1678	1	1	12881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2soTg8PYv9i4zyMckFAYG6XjE6YTPeRDEs44kwVSnzaKhrcc
32516	payment	1397	1397	1678	1	1	12882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6gsaHvY7tp3TrN7tAarA7JiWbxWZ8bkSLUNKtyj89dcGTmiy9
32517	payment	2134	2134	1874	1	1	3381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz6phinbRfZNMsN51opjbm3DAxEKNL4Qnx81SoWxn52JABNuVw
32518	payment	2134	2134	1874	1	1	3382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ742gRfySifEqWQemKRcixM1a8BrbNHqMjPNGM1E8fhDEmumdN
32519	payment	2133	2133	1874	1	1	3284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQY3DbkQUjMpTKnktamNY7rFnRKiVEAe2qZDLqvUD88fnxtVSp
32520	payment	2133	2133	1874	1	1	3285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYmgUQwPQtrAhp4hgWLZyMYfSWUTP4wj3GVvrndsLa4DHnrmM
32527	payment	1397	1397	1678	1	1	12885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYivctbWHEStHcoaZesJe1TA3Ay9msBSro3oB15qN6G2jzXYmvf
32528	payment	1397	1397	1678	1	1	12886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbQGvwDVxrEoyicJpq5dQvqMDVNs2FMcx4YnBMACwUY5DmoLJ
32529	payment	2133	2133	1874	1	1	3288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHyz7HPauF3VBWkrDUZPwaVUJidhc9wEre2jGiByFw5EDK6do
32530	payment	2133	2133	1874	1	1	3289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYmCdBYTFeyoGcvrGC8jScG6ZQiE7r1U1pe78yBgypSW9oA3S
32531	payment	2134	2134	1874	1	1	3385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwfEnnaXYntpmzBX4SeD441nhqSkqLsYutuQokS5uUBiV6AcJ
32532	payment	2134	2134	1874	1	1	3386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyQYNhqEaDPQeom3bpSNeNAQdcibYfi4zZ63ZgxMhPxd5EJHr
32533	payment	1397	1397	1678	1	1	12887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5uWYgfNiEuA3WCNRjZGkcbxaYxrdqqrCJcTZ1Zq8WMkoubp9
32534	payment	1397	1397	1678	1	1	12888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndgYQp7kPFbxGUsR78VVpciKJKCQAFTXFqZNEWbERQxv7csCG
32535	payment	1397	1397	1678	1	1	12889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zkztqCnDYPwEao8H6aqZn9hc79BxHnYpvxLyjUDmG7N6Azbs
32536	payment	1397	1397	1678	1	1	12890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4X1CazM5qmYo8NpPEHnYmSeXF7hoeTZw5ssqWvwGzQK9PVoHJ
32537	payment	2133	2133	1874	1	1	3290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8jj6kUzZ5QSorijPtz7dzeAsZMLVeyVP3jPTRYyjo2yjLntNS
32538	payment	2133	2133	1874	1	1	3291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDYoVMhtefE81Nzk6xuKWcwoysyniKFvupNsZsGa8oB56Nio1
32539	payment	2133	2133	1874	1	1	3292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6wvMKNbSQ468Fkb6PPLdEb4irruXYEJyQrm91BAsCVywgnRg
32540	payment	2133	2133	1874	1	1	3293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPLbN3YjKGsh3LQfLh9P6AEF8hASr8VxgU8jAiS3phseA3CPc
32541	payment	2134	2134	1874	1	1	3387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7hXE1QZAu2QA9QTZK2PC8tUPVSbKqYxMypm2gMQL9fhZnBNd
32542	payment	2134	2134	1874	1	1	3388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNtvmKK2PrndhK7zdYWUFtV9q3hX5AzSyG3ELVWz9smL5CbdT
32543	payment	2134	2134	1874	1	1	3389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGjNGJCCvxSVTt6HvDBm1rxtMHtbTezS7gzL94TcxfiwSspku
32544	payment	2134	2134	1874	1	1	3390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWL3hEjyMhVmski2teddagvWG5XNFUySicBmoWu7CSjX9sq8D
32551	payment	1397	1397	1678	1	1	12893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKSnzHiBgEm6CxGL4nV5bBF92g21Ck1k3VAMRh9QFPn4ckMef
32552	payment	1397	1397	1678	1	1	12894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktahb78hNM3E2fsVi8THGwD2FuTTCm6EQyoWvAisbThDKYv9p
32553	payment	2134	2134	1874	1	1	3393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuRRkyjfkS78ESwcJ2rd7Hg2rSiWzyWPbbeTKmQUN3CAuormHs
32554	payment	2134	2134	1874	1	1	3394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFaK9XcEwB516SCRk39EVNrqoEDKQqENikKeG18Y54fKGXnZPs
32555	payment	2133	2133	1874	1	1	3296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGjquA3oG16xHCuLvUPwcBHwznmPk7EgoUMYDcxojk6igXMEf
32556	payment	2133	2133	1874	1	1	3297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVyekTghqkes3nUqJ9kdNzzounUuAJbmyzqDXkc6bbcir4Zftg
32574	payment	1397	1397	1678	1	1	12901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEARCL5kEbjmtRgf6cVke7MJSE6mSKkXGxL69ighG7uygFsd6r
32575	payment	1397	1397	1678	1	1	12902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGRzaQjXvCskHPr2jeSS7kcn6K7BwXsr1T29UjE72aeNHndr2
32576	payment	2133	2133	1874	1	1	3304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSRApqNUthwCY6dy3npQ7bqZnEXCPbqg9HELmqJJsgyXif7gA
32577	payment	2133	2133	1874	1	1	3305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDwwbRhCKtgdHHjQTUhVYUqFZSGDKeoj9P9JRzCUP7w9aEz4n
32478	payment	2133	2133	1874	1	1	3271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bHYMsxh5ivtQUnnNGC4fKoxRUSynfnTi8mkdqjYZ4uAo7NVd
32479	payment	2133	2133	1874	1	1	3272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvJxj68tHjtfVrWcENrYm35tmqocHWgwF7QbDFZKE54X2jPARG
32480	payment	2134	2134	1874	1	1	3368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJ1bf2dVuoVWvrqZ3ia9XXgzVyb4zXjKKVwcVB9sN9WhRAdg6
32481	payment	2134	2134	1874	1	1	3369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBB72Pfcn4Eu4e6uyjXuCztn7mhFCS12CaWKtBXFVmN2DofZo
32483	payment	2134	2134	1874	1	1	3370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZwxR7xd8uB58cUorrKC2VprkmxqDaK77KhcyTsivsnpyxxug
32484	payment	2133	2133	1874	1	1	3273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZipbQViqtXBoBzpLj3cgWwhVvxxfHyhT1uGvKtrBUaJFnQPkyb
32497	payment	1397	1397	1678	1	1	12875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2fnKeqXhXa56CSUpuXq4ojXp7pNfywowzgo8PnnRPVkfDtdc5
32498	payment	1397	1397	1678	1	1	12876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjPCuFijFHJt2JcEoJaRmnTb1azVBHpRs6XWK766NEzDLNjzq
32499	payment	2134	2134	1874	1	1	3375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmuBkAQ1UQFsdu2bdhfWhv5cKAvxTTgNqe97sZX5pDVLutTMi
32500	payment	2133	2133	1874	1	1	3278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDRTLr2jLy4joFDU3LuxdLgEGDCNMP8ec8tbpAxABRKuPU4Uf
32501	payment	2133	2133	1874	1	1	3279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmgRajMmE1zjbgudRSo4egL17ZSinFZtL5R7RzR9Xv4J8EJ7c
32502	payment	2134	2134	1874	1	1	3376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAhvzaLKq72QvdQzoHz4wXZQqU1XAcK9hGu8ZWxrXq3CbYxWZ
32557	payment	2134	2134	1874	1	1	3395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZech9s6yzWMfbSVfrqsbKqZHwJPE4RPkkM2L65fVDGXC5gQFkm
32558	payment	2134	2134	1874	1	1	3396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJwJoRuomP7sovjwX8KngbV1DqmqGGjniEtD83dsVMyQBX8qS
32563	payment	1397	1397	1678	1	1	12897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYz1SZDfPJzBhiW5FsNM86FLNpqXTDsPEuifPeH8iiDqaLZkw
32564	payment	1397	1397	1678	1	1	12898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYHaMxLZk32KWCG6Ja6iGB9EtJMofUEBX3fkZ3B3dJ2FquW4K
32565	payment	1397	1397	1678	1	1	12899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9GGpkkLNxew7B3hnwyDAcbpK7e1SYM3WD3w3eTrsFCjCVYc6
32566	payment	2133	2133	1874	1	1	3300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYds3GYa8JGQ4ATSpoDXRX637U346CNthXqf8dYTyNT6Wik9JLi
32567	payment	2133	2133	1874	1	1	3301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ymro1u1sf5FaPBPhEchHpXXWYPYfc3g2z6G4mvRjyo1h4bLg
32568	payment	2133	2133	1874	1	1	3302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Lk4nJ9Kb6iQk55xxo43zx6aQf88Q9w4p8N2Xw2zSCYK11pVa
32569	payment	2134	2134	1874	1	1	3397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWqS6eMPPjUZLXwpiYfeciT27HtSknuQbkShKApFeWu1QmAYH
32570	payment	2134	2134	1874	1	1	3398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvXTNsSD3o2sYjHtzKPhZyKMAz8wUdmAj1gaxXAjevWQsWPet
32571	payment	2134	2134	1874	1	1	3399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCESnPm3GQ6w7whfc73yi515hTZrnKrQwTBsawzpZK22yfCjZs
32580	payment	1397	1397	1678	1	1	12903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HVG6xQMJVhoSUWqdeQJVSMjZ3HRwTRPHwuginQdtodqphvCF
32583	payment	1397	1397	1678	1	1	12904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3acFarWXoN6vPctDiXx1nCAQZHSS2h6KAmttfWQYcZ2iHrTk
32584	payment	2133	2133	1874	1	1	3307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPrypTYYiandgFMWNuhe81odQhHhYkgs3VHUUBQFECrwScU5u
32585	payment	2134	2134	1874	1	1	3403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp69X2yeFmnzWv2m6kGTs6fCgUnMJxucCXdHHf6Xh9wKoucHEV
32610	payment	1397	1397	1678	1	1	12913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoty6rEVeit3nhJ4jFoPNx6FyniCwWAWWffEoiS26E25JekaTE
32611	payment	2133	2133	1874	1	1	3316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwpEt8rRsF4iEpYi9eDWudVU4Nm43ippRFfisxXqC5sUBpuAn
32612	payment	2134	2134	1874	1	1	3412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCgSZsRv7cxWnY1FmTXvVs92RwM4XE4bS38TBKk8hh7qNqjYb
32622	payment	1397	1397	1678	1	1	12917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWj4HeAQcdqkRQ27aFwgA6uSQd4RM2aKSPPKyyDLFZ2Eu1ww9
32623	payment	2133	2133	1874	1	1	3320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWgtYmzbeGXSSPqn78hu4bprGHp8a2qav4fZFaickrcrHEtRk
32624	payment	2134	2134	1874	1	1	3416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgmuXXUepKmJ3XnFYWYngg5gThw1rm49kFyxvUZ5RXicWgCj5
32637	payment	1397	1397	1678	1	1	12922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HppaQeKy8rwJbcXgafjVNL6bbmc46f6LbdUDcSmejZBsQU6x
32638	payment	2134	2134	1874	1	1	3421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3YGJs4c95oBDrT3rxt6w6Mw1edDwmT87afia2kDxSsmkizbG
32639	payment	2133	2133	1874	1	1	3325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbm8ii6S8oGyqXU2JvN3gp36eYzQeEG3LZE4aSn6hwUFGK2UDf
32652	payment	1397	1397	1678	1	1	12927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9BQEqpkiYrr3ieVA9cBQpCWntmPPXi7gtv8fZccRNsEPkZm7
32653	payment	1397	1397	1678	1	1	12928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdchW2Ee3PVRRSgA3koyywQFY5mZ2LxdMuX88dK7fUmL8QpXAA
32508	payment	2133	2133	1874	1	1	3281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXnE5BmUjvPtimCsnk1Fd78tHb34EWH3umJvoHsYjDz7av4q7
32559	payment	1397	1397	1678	1	1	12895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABAYA7EPm4MnAnQrADop9k5QRPyNraExnF4avUvUueSSAkGVQ
32560	payment	1397	1397	1678	1	1	12896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgDdWWqkxTQapS7cH3cy9WqU7RAwpyXLbU3JQXfHDwYGWJ46e6
32561	payment	2133	2133	1874	1	1	3298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpsTdprDPXTHnnemY9k13GBC39bGUNjrK8qgJpPyvRdzRH24T
32562	payment	2133	2133	1874	1	1	3299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFyBC762m4HFEJgyyTDPV8aL4628fy8UxnLZjCdj9XThHCYkS
32586	payment	1397	1397	1678	1	1	12905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqtALNme2GCpMXziAXAwwuhGbCbun3hhbMm4a1b3GoiGeJru2
32587	payment	2134	2134	1874	1	1	3404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQp6pAvKEs7tjaqPiRdkDF5nQfcSpKBpnjUyhvuX4D9kyZvzr
32588	payment	2133	2133	1874	1	1	3308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDF8asrxwAU8S7TRUGu2e6FtVaZnMrSHycn58N2dQujnJe6bp6
32589	payment	1397	1397	1678	1	1	12906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHKaYNsjEUqg8oBHmMnNLQaS71G4NA82vYcSjDhn9adxZoaoc
32590	payment	2133	2133	1874	1	1	3309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoXpkMercRWrjohdTjeMyMkAD46Qfy9us8U1ycmGnyEbi2rmT
32591	payment	2134	2134	1874	1	1	3405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61nPoSKijHQVEmywtdybTVukkvUmHsvMTwizMc14S7CZZxpuT
32607	payment	1397	1397	1678	1	1	12912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5abeJkrfbGdmk47D1UCGNTGaLrKv7MPhAczZCx1MJwFrPYgfE
32608	payment	2133	2133	1874	1	1	3315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrvvANmaNQnYrEUds7nSVT2G4bqcsbEoVBcEo6P1RKmmzFZic
32609	payment	2134	2134	1874	1	1	3411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqptXksWsY1hiwh5B5WqPWhpMocHbXj2rXSYRwgSNWx6BKd3ci
32613	payment	1397	1397	1678	1	1	12914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEN6SnuRoYfR63bvidYrVusqrFzrUENo3oLr2qBfspCCU8Lif
32614	payment	1397	1397	1678	1	1	12915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekXoWDBR9XCac19YthpEoniGgXEsHFzxKddxRjSDKTeZPxFVr
32615	payment	1397	1397	1678	1	1	12916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvPX2LmFrpytgWUFLfASztkACSshtjSq6p6V3HfCfdUsLY6BL
32616	payment	2133	2133	1874	1	1	3317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtcs2Puo5GaqKDWZusmWKDfaTgd6gjzPVAijt2qWP8Vb2uSfQ
32617	payment	2134	2134	1874	1	1	3413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWHKWeSe4cU15dKwQ6oAEXoCUNHif6ZvVYPm8CwDiNZfzbnZR
32618	payment	2133	2133	1874	1	1	3318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5z7BQMUD4X8N317hZqkGpVLAnHNMrKczWvEfmqGG1mpQFXEfM
32619	payment	2133	2133	1874	1	1	3319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXbPcaupJ32hEUtoVfLH2U8yLorrCWpiBeHY696UDNizyt2zz
32620	payment	2134	2134	1874	1	1	3414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNwPeS6wjm4JStYuC1xqinBoTMnN3CqLMNHHykSZH2CuGhr6N
32621	payment	2134	2134	1874	1	1	3415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkknfPQULJt7JQxytUxqY7UN7HBrVesjd85ehtkFPqr2Zhgg24
32631	payment	1397	1397	1678	1	1	12920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSzzsg4f4jCBqvMdcbYDtDGEpoPB6fpXJ57WijTvLxeD8Aj3y
32632	payment	2134	2134	1874	1	1	3419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuuiJK2ujQPETgJPqDLRoGWf9ge49z3dP27A3H3gdsBCc7Gp2
32633	payment	2133	2133	1874	1	1	3323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HCL7fVPxzeZZp8vLCSXnrGWFsCcucGznQ7uk2MLiCuFMDfsL
32658	payment	1397	1397	1678	1	1	12929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfK8kqD9EZFVLEBxakU3oYfKFFBepsRmiaWPBtL3jLjs6yjKx
32659	payment	1397	1397	1678	1	1	12930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCbi2Rk2C3HJp8nAvDcd2PvFP1XSkqZq2ppwh9X4fLj7MLtxH
32660	payment	2133	2133	1874	1	1	3332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78Qn9RahGHBAKUWJ9iQrqD1LSPhxeh9VukJhjY7SMrNR5tpgL
32661	payment	2133	2133	1874	1	1	3333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDZE6Bju86FjD1W15KoFsBzyUxCoUFjYSeXBBv7ZncovjjiQP
32662	payment	2134	2134	1874	1	1	3428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJzT7sveLASjgreP6Qb9kdKuSfERCirBMS3WGvsxqJY2Uizyv
32663	payment	2134	2134	1874	1	1	3429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHu3u8KCfwQxFiJ5T4NNvpYjeZKroLuAawSoMdjcaoiaWhy2Z
32673	payment	1397	1397	1678	1	1	12934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawznHagLkYX5BZNor8AfMgxXrZY4fC4SAQpp4bQXW1iLisxLG
32674	payment	2134	2134	1874	1	1	3433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgvV78vPE5fQ3E1e4zwW9amZmPSmRALqMfLKaqhUA3fF6k88Zp
32675	payment	2133	2133	1874	1	1	3337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBw4oQNXnNJU3fRXfKRwQL6Wh7huuzm8bjEos2DuoFtR3d5Qt
32681	payment	1397	1397	1678	1	1	12936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgsLXpcAoEyEtbDy9a4Mnv1AzQdsyRyLBtQa6wruQYW15SYw8
32685	payment	1397	1397	1678	1	1	12938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfrZS7tMC32hHW6RRt4tjLBuJTQy92bJYLQPbT7eBv8Z6ygzr
32686	payment	2133	2133	1874	1	1	3341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EuBrZTxu3zCzSq3zYwN5ZsCdYFY4y6Pr6irPP2M79uveU2gh
32578	payment	2134	2134	1874	1	1	3400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHnvhEUsx4Ji9GH2x2YiFjntKt495QFrozs7kNm6GojqtGNzB
32579	payment	2134	2134	1874	1	1	3401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4B1KiFRc3eRiyJzvieAEJvYx5zrFqvFhX13uVMHpEqkTSe8d
32598	payment	1397	1397	1678	1	1	12909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYgBo9qZfSxtL4BQWgHVA8bPGVVZyyjZpKZarPQUWQxs2E24c
32599	payment	1397	1397	1678	1	1	12910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDyRvgFshy8wC9HAxCfsJnUyAbWNvGUzYoiRqpJS6r1sjwo9K
32600	payment	1397	1397	1678	1	1	12911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ15sdqCSm7RFTz9Kg8wHxR6jLXGx8xuG1UvUMzzQkJKDC6LDhN
32601	payment	2133	2133	1874	1	1	3312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJeRcZun4ico5y4eBethZSS3aGgyhS6SBByKka1frnQ2tqvFUw
32602	payment	2133	2133	1874	1	1	3313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiU1AeJNwgQZfc8HtzStRP6pPM6acBirSQXWruWLYeRLZAXH5w
32603	payment	2134	2134	1874	1	1	3408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzeHmXZQqXydWBwNtrPy4tuY51D7aRMoAHaguPm6MepTTePVo7
32604	payment	2134	2134	1874	1	1	3409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKSQE2CiZLXgWtQeLNWWuvWFi2eULMbC11AmLYWmgVuEM4yDa
32605	payment	2134	2134	1874	1	1	3410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJRiqT4VEWvXe2EcKWTqSoR3gHfD8T3WJWdNeV5rUTfms5668
32606	payment	2133	2133	1874	1	1	3314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hEaeH2hv8oPuqbgySaEkETYDzowUyp39VJcQoxusLfuoGNBC
32628	payment	1397	1397	1678	1	1	12919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjDLSJ9GnjYQvAfsGzTJtQ8a69C4YWHKrm18toj1h9oXVu8bAa
32629	payment	2134	2134	1874	1	1	3418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8tm5CdhabAPpDcUc3pmEaycramdqtqBMmMXJhGtbTbJzPfpt
32630	payment	2133	2133	1874	1	1	3322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6dGVbEv58ffAxqHbpvSm9m3EGpKGa18CTjXHHb8q7RW2hwoK
32646	payment	1397	1397	1678	1	1	12925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFRnGEYaRmMbU8a8t7B7DJm7yVf7bWGSNATchExX6CVKhgTtk7
32647	payment	2133	2133	1874	1	1	3328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHceptWHzQrAMC3aeDpzCxDz74Qc6qAqY2MRjkfHbYj2P9Hs1
32648	payment	2134	2134	1874	1	1	3424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZE1Fu6zjNBA4uxCmWZt8tjaRCQMSWWUDTp3QoE7AV3F3vbv3
32649	payment	1397	1397	1678	1	1	12926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPi38iYnpdHHCmh9f89oGCmajC1HmxAuRczyps1zNQhJh57t6u
32650	payment	2134	2134	1874	1	1	3425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo5nFa3tfdohZ6CFRkSyHCrMmPyczQZCUKmBhUEeEPQ2RQqnh1
32651	payment	2133	2133	1874	1	1	3329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7m9SyXHJBxSLot7wW2gFFoFyVHUikVy2hQGmYdYv3pbqnu1W
32670	payment	1397	1397	1678	1	1	12933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23dMFrTZCKoZoyb1AQYGiPrxnvvusSenhbztxg54FpzQru9ve
32671	payment	2133	2133	1874	1	1	3336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtr943W5vJV7Ej7ZseA7hj4Af2EC4kLwdsLDTTkWUwfqk9LdWu
32672	payment	2134	2134	1874	1	1	3432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PMTKtL7VUm7QUJT342nTH6djB6r97wKRmsNZ9joY5QUCnsDG
32682	payment	1397	1397	1678	1	1	12937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH77bVJ5CYozqEV6atfcFMb6597vj2KzYfNVwimN5Y3jTEtf3B
32683	payment	2133	2133	1874	1	1	3340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7X8GYru3qLTDmRBJQjELN31VU4C8SpT9Ged5dSNjm4rbS35GM
32684	payment	2134	2134	1874	1	1	3436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9e6xtWSz1vhapcSz1TpuY8Vf6Kh45YGmigU1ppbScd7dFwQu
32694	payment	1397	1397	1678	1	1	12941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kmAWaGJPFWVwk1hiRdqz4c6wtfSPZ2mQ8wJzaEnKd6m881rD
32695	payment	2134	2134	1874	1	1	3440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2j68yqXKFwympTca34bqaFDLCrewYeSHwaYvcbnVHD6HVS4A8
32696	payment	2133	2133	1874	1	1	3344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gsNBDqrjQSe6WpFAhWRUKCycsa2QsDnsfDDoMRua8S9nZ21i
32703	payment	1397	1397	1678	1	1	12944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJf2cLS9PEghiKUTCMpx58YtoduaegDnzZDaQpCQjhAB8qpgXY
32704	payment	1397	1397	1678	1	1	12945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1DpYe84WL45TmVybvWa4FviV4QeLTTqQw76PffzDHgm7jRhZ
32705	payment	2133	2133	1874	1	1	3347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM2PB6cPy2fGRfLRotAyAZz5k36XPNV3JWTAj75V59FdKH6HK
32706	payment	2133	2133	1874	1	1	3348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3fSiZ9SwKMsB3Hqa8ReYGcoRCFg8MVRZ6of1H92UxdKGDgQAD
32707	payment	2134	2134	1874	1	1	3443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUpRQAHPtJJ2qT1TxgQVx8gbo8Qo4gTgq1cosA5BoQdSPGxPA
32708	payment	2134	2134	1874	1	1	3444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddvnUgaEy1heBE3vq3vKRNT57jx7HMHFxMpWshKPfcKMajurf
32718	payment	2133	2133	1874	1	1	3352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWNqNacdWs3SKU7ZTCb147bEtHuRrSFHevsb5HzDhL7q3wGUd
32731	payment	1397	1397	1678	1	1	12953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAHpcxGMTRfXY6cySCX8u1YmtsKnoHUx3vTrhxFhqxXQobHX3
32732	payment	1397	1397	1678	1	1	12954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnA2aGvC2EjBZ4DVHQvMggPJ8uhyKCzLZ3r3CkjU6phFjmddxd
32592	payment	1397	1397	1678	1	1	12907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbg2czQAL7goJRuzDLfMQPie4K1MfjJagbMwzHTFqHABdoY67R
32593	payment	1397	1397	1678	1	1	12908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVnsEVq96HY54hZCXViGBAYerCLKHC1U4cgXcFy1c1PLYYTRo
32594	payment	2134	2134	1874	1	1	3406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2wsiYFAvJG11GCPojpbWLjpBCLTj4PqYSTEK8AwNhtThw7og
32595	payment	2133	2133	1874	1	1	3310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJQLBZ6UrcjvAywZf8SKPjWcEsbNjBgvEQ3s7L7DdHE2rr2Hz
32596	payment	2134	2134	1874	1	1	3407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjeToVsYL1nHNCcrYruBEZt2RkPtsH42oy57jJf6cucXHoqnPz
32597	payment	2133	2133	1874	1	1	3311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQqec6Xs1JfHW5QdWoAJCwjUqmp16sBzus7SyA8NfMPvDeXtg
32625	payment	1397	1397	1678	1	1	12918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyUcBAnxJUSUbFUrztiLnYtRZhJDerCVvSUdCzJMNueD5mdAV
32626	payment	2133	2133	1874	1	1	3321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dzxGrKHegmTJFZgqe5GThUhpiFw1FB7aY4n3LwtiTcB5Prko
32627	payment	2134	2134	1874	1	1	3417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuscMQce412hk7WV5KhrwVyw1QjFd3dDL7yXZ5VSMeiH2fcQZ3
32634	payment	1397	1397	1678	1	1	12921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShCywZVmxoY2VN1ugco6bXdH8VYngiXWpXsivJRuLp842Kvui
32635	payment	2133	2133	1874	1	1	3324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8HdYDNgs64BN8JmNMLVMg6CnqtdPrGJ7WP2fwmCrTez4mrtD
32636	payment	2134	2134	1874	1	1	3420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4c7jrBNubb6CA6XMb54t92Xu7qMXUXMGrHpfb6cFsLH9EqGYw
32640	payment	1397	1397	1678	1	1	12923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HUCiLBA3C2FiWu9Nx3iryTrCVXXc5YXJC2eipmLdBcyr2oW6
32641	payment	1397	1397	1678	1	1	12924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQMZCDyB3ASZ1qTgEkMdTh4sZJR3SpSUiqB5Q7JSn1dssorZ9
32642	payment	2134	2134	1874	1	1	3422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZML2ktL1WWse751Vk4L6FPMx3KBm6W6vrhWwWwNmLhqfASZNpY
32643	payment	2134	2134	1874	1	1	3423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTCoqg4cb2tU27mR1DZaRF6hL21uvkrVZtXKk4LhNYK8kTULFd
32644	payment	2133	2133	1874	1	1	3326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLspJLUhv2Fma5NjYB6RqA6D6YA762DU98gywNMeXqiFXGwLJ
32645	payment	2133	2133	1874	1	1	3327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhHUqvDjrix3pkoWgRVKGHsP55SpxYfSgQpzyACthCZSt17Kb
32664	payment	1397	1397	1678	1	1	12931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBZaRZvhxy3YyxTcuXNMeuW8mD8rnzLqcdChjvspgKXzb5LVx
32665	payment	2133	2133	1874	1	1	3334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfXXstPbw8C4cyFyXAk6dXKg65cWYxmmTQ9PAGXRM1fgg6vjzb
32666	payment	2134	2134	1874	1	1	3430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBj2tYGoh2Curabti69QjUC3sbMMKUdUd8dkAnBJ8yt3mCkP45
32667	payment	1397	1397	1678	1	1	12932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaETBruF5rHVncKiGvKzCXYTdTH3L5k7aax64utn9VKaq5cxpKb
32668	payment	2134	2134	1874	1	1	3431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVyfprbag6g6QhyCqFoWPNTv7eATG81UbB3Q3uwwDTbgfMbSD
32669	payment	2133	2133	1874	1	1	3335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzp4SyRRdFvNTbGr1MJc8BpUJ9qKSBj2QyT7DynhKGCQGibBrm
32676	payment	1397	1397	1678	1	1	12935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruhmAcHZDDrc1L1cdQhSU4KEJ7wzAyg9MaLCEiUZXY9FkiD91
32677	payment	2134	2134	1874	1	1	3434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7gmD6smLtiqsjdFq7Mndd4Rg38pgWcr8HL86xkapv9WkuV5m
32678	payment	2133	2133	1874	1	1	3338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rXxrrdXyqJ1SJQUueCMMhm8E7cpSitrkuj27SsGrL6g29SEQ
32700	payment	1397	1397	1678	1	1	12943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnB3En4mr4tRKb7sHRjXSngsvaf9BsKgrzkYYB9RV2Vyjvhhc
32701	payment	2134	2134	1874	1	1	3442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcEuYinKDrDYy2dGok5qB6EtYS3ztSWXdRkeyRQmpGXSXDtum
32702	payment	2133	2133	1874	1	1	3346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBnop9mYrMLjDNPFy9h8RtE3RySVV5mmaVEw3pashf3NAvR8d
32712	payment	1397	1397	1678	1	1	12947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGCPjn5bvopFA6wBJEF5kzfDh9dN4RN9oGgjdEQevnRAnS7fP
32713	payment	2133	2133	1874	1	1	3350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBu5jFudDi7mXnkadd3JVv9oy3Z2Ni8hRWhYQdP3Wwod1skCrs
32714	payment	2134	2134	1874	1	1	3446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsbot8c4ynPH7KGj3bWCboSMQ65z7dRQqvAZ3G9i2Z1t1XbHk
32715	payment	1397	1397	1678	1	1	12948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1WqThfXx2dzmW4JKoi3BvXLNLvXHuK6J9a6tgxyDZDjbuEPa
32716	payment	2134	2134	1874	1	1	3447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtd44qZYXosZE14DtZZDTnQgjxJ2WsWSngDoF1thkyq4mg6SR
32717	payment	2133	2133	1874	1	1	3351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLaJBHFVQ3Gky6PfFnuqRoeCrQyXR9mvYnwbF5nQZzs16y5qjv
32725	payment	1397	1397	1678	1	1	12951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYBcsc7175iU4kAJ46VohK9B7JwcPjrHYTX8VC5DWMzW6T6Cp
32726	payment	1397	1397	1678	1	1	12952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZx57Ptd6b9XyN6omc9UM1zKQqHmVXww9ZVxQTfQiyTfV6z8ck
32654	payment	2134	2134	1874	1	1	3426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoooK1cPV5E9AyxQJDqPEPtp1xpwFweQkdqE61UbQbYfXAo3Yo
32655	payment	2134	2134	1874	1	1	3427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sL36nrxbirg4tZNM8W5jov3Ab4jdrpUAK11ghsNW5LGsN2AK
32656	payment	2133	2133	1874	1	1	3330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhN2tE9LCkeVUaNBuVdvCoctdgfRxxd6TC6cbGYPZiMTFiB6Bs
32657	payment	2133	2133	1874	1	1	3331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPvGw1FkA4obh8pJXxf2jVp19AQxtoPVg3eFEhSB8Uqcjz3iu
32679	payment	2133	2133	1874	1	1	3339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFt22Wux2FLF8SjPxGM5Bpmu4UZAbDXM5k3FTy3PMbgPjjcX89
32680	payment	2134	2134	1874	1	1	3435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNCWkBfTFUNmATKSEBaKwmjrSR71E5bQk8Pt3WEUexJKRCDGB
32688	payment	1397	1397	1678	1	1	12939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY71on8WjwEpR4eACtNskGNKttmdzHzMD45KFrTfMNoFVtRcPS
32689	payment	1397	1397	1678	1	1	12940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZxJ5vYGGnpBgUBHU4SgfDzZ3adyGCX6nu1Nojcg5YXutrAjK
32690	payment	2133	2133	1874	1	1	3342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxrm1McdzhNazTGtpnt64rqGAhikGywM4NdV14NDJCJaHK8Rw
32691	payment	2134	2134	1874	1	1	3438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXNoHyENZhjiTTty2Awm93ceJiA2SvT6gap3bRxUd18Qidf3F
32692	payment	2134	2134	1874	1	1	3439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSuodmWnUGR7CyE9awSvw4b17LpMtokx2GwEMxy6CVbze2b64p
32693	payment	2133	2133	1874	1	1	3343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKa4UE5BR96aAeANSMKPvpXg1qvhWuTuHchi5So9kqd25Bjr5
32774	payment	1397	1397	1678	1	1	12968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjByWSLkeaGcbDCJJDa2d3WPvxT8uuxxjGgQP9HEaC71qW3YNE
32775	payment	2134	2134	1874	1	1	3466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAwHM8TmUexTwL2Tjt1hCrDptKAtDQypontWtLLu3dXgy7hoLx
32776	payment	2133	2133	1874	1	1	3370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjvsCqWV9CACKMoEwPBXc1S65MqrENkjd2ugnB8kYcv2tgdTtL
32784	payment	1397	1397	1678	1	1	12971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvfrX7S91eKU4nTTV4JF2zcyPFztSpvYFnyk3oiG269FkU5SA
32785	payment	2134	2134	1874	1	1	3469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ46tGTyPuuZPBuGBJdesnfsp7z2Dye4eTH7BNUir7KyDwxgWZ
32786	payment	2133	2133	1874	1	1	3373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcovFUTTZXrPm8uTLkZdfHt3co94oPaxWC4yosZMkkFtcmym1Y
32829	payment	1397	1397	1678	1	1	12986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwGxbJapqeccQGaAM1DtJYAT3UtHPKRgUCMuuhbuEJGvRX2QJ
32830	payment	1397	1397	1678	1	1	12987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoARSgW5FD9o33aV46t8CtjGww9hg1m8abXVqAep24tCfGTT5B
32831	payment	2133	2133	1874	1	1	3388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyrGPc8p8Pssht6VQqoieSv9gkjPgYkPe4iiZ1oivxGG2MHRB
32832	payment	2133	2133	1874	1	1	3389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmkjiyVvYduS11yFNqBVtGn4gAgRiEdcXfBKcMVyx4yPoJ2zK
32833	payment	2134	2134	1874	1	1	3484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4vMqFuECgUouV8wJvQB6mVtcX9iBVoPRUEeqyjt2yUTeJ2Qr
32834	payment	2134	2134	1874	1	1	3485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xPSLpwjbUZ3Cc2dw9Nn5p41JRK7vkFbVckw7hqjRnbvM6T1Q
32847	payment	1397	1397	1678	1	1	12992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiwqBN5r4e5Wi1AdMqjy71ZacRfwSh33QmHoUJkKYj7vKouva
32848	payment	2134	2134	1874	1	1	3490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9thw4ViMGCvjV1XNj9BFTmFHZsTkCPHRvZMkuALcuRGztVWqG
32849	payment	2133	2133	1874	1	1	3394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCe7RQ9Lkvm3q4ZoDV9QpaNydx2gzBoDTVPLYZ5EyZUey7zAjW
32870	payment	1397	1397	1678	1	1	13000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzarfDbVJCvsaxb1wcDQamjQxxNvoz5mQyQG5sggaSrdeK8gW
32871	payment	2134	2134	1874	1	1	3497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BS6kUDUQSMhoyvQqNLcxcq1koo9M11STdrxa3gqiDWz84p24
32872	payment	2133	2133	1874	1	1	3402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9tpmbGqUehWGzgJjZagML6WH3HV5e4Cpf8qA1qgprmfwBq5R
32879	payment	1397	1397	1678	1	1	13003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNwAJtkuGJKNsVRMnjfm6Pfk5iMN4Wh67vAD36kXUnrumvfmH
32880	payment	2134	2134	1874	1	1	3500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAujybHGfTCWKNELACBSVhPnF99FxiM8wEimJ21t7kFfGFoy9r
32881	payment	2133	2133	1874	1	1	3405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dXPMVywLdXyRD1Tt794Tnt4KxPbeBDDjripaQKQc4NspeoGK
32888	payment	1397	1397	1678	1	1	13006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1HmpBkiHcgVgEhnpVgcp43gAJgZRVYvWoGYFmP5oeBppWfat
32889	payment	1397	1397	1678	1	1	13007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC74cnSYuGwNdAwRWXXJaPEPAy5mUYwF2Vh9pNTc2i2eMC4TX
32890	payment	2133	2133	1874	1	1	3408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxDALdPs31TqQW3XtWU2xdB9SJETop7i57a5VQCzJMko3Nmu9
32891	payment	2133	2133	1874	1	1	3409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgpwmY9F7FY3avXdLZZawPb9qTjvWZ32TK2twHSQMy8v4JQmJ
32892	payment	2134	2134	1874	1	1	3503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsJD2FxbNBbAdSpNs385t7Lk5tceaabpSQs87NnRL2dwYqTNSj
32687	payment	2134	2134	1874	1	1	3437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9eXvdPEoN69gkFYtj8ziCfHa88EsLufU3Hc11y7YN8Rbo14c
32697	payment	1397	1397	1678	1	1	12942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQhoGSZ3SK4QXoKLw6RJKEqz5tx9EhG7kJaN8ERFDeya77NuEQ
32698	payment	2133	2133	1874	1	1	3345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqrPz7UqsbDYxdVMWoaUNyKBaneNSZkWkA1CV9uWmDjvXEYsT
32699	payment	2134	2134	1874	1	1	3441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCj8HM6DmcZrEsa1AydBdhHgsPyUWWAazvXc9RYq2k7t7H4AP
32709	payment	1397	1397	1678	1	1	12946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupGPxXA934aNQLBfCyF9UrYXkQAEUZqixH4qf2fXeB6CJDBRJ
32710	payment	2134	2134	1874	1	1	3445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMTbHws2ndFaxs2paT8dSYtzH9K3zF8i6srUbDTL8wEi5RBxS
32711	payment	2133	2133	1874	1	1	3349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubxNBedTum4a74GToJVydYh1bqhdoJBMNm5Ps8ioNo2qLrKhw
32719	payment	1397	1397	1678	1	1	12949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaETvv3CyssgGpube3KvFSSVmwVinmK4agnAXTCwigpLzcF5V
32720	payment	1397	1397	1678	1	1	12950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4ReA2tFSXya63AcmNRsjL6mK1TZJjzLSA35qZtRtpTvVo4ES
32721	payment	1932	1932	602	1	1	8	10000000000	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68hNNLGmamdRA8QRirXgZVV1KzEdgdLrc197S6awGes2yM1FU
32722	payment	2133	2133	1874	1	1	3353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXLZNP9XyXH29MARJHKVcYFW3t7NYDpNWfDC5Rt9jgMp4Dy9H
32723	payment	2134	2134	1874	1	1	3448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVniE56kPEhdte5XEwo9zAYqVkZ1egRxYj8HzkYxhNatSZS3c
32724	payment	2134	2134	1874	1	1	3449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxFUr1S6RP2XAt47uMA887nvzgvqJxJGBF5rPQwjmzCGkEFFVe
32758	payment	1397	1397	1678	1	1	12962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgUKp7eBJRZRYGqF9TFwGGajQr36h3zXuBdA5dRuvogzveco8
32759	payment	2134	2134	1874	1	1	3461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG15UEi8Pna7docq12G8Y5Z9m3ACsAYyGH8mpixbhq7rG6UsQq
32760	payment	2133	2133	1874	1	1	3365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziY6iksSARgSvyDTLvuZjagHyvdqc5s6MrULWes4V427bivxy
32764	payment	1397	1397	1678	1	1	12964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjAR6FpLLkWspvUSJkh65joaSrUWm6oAnc2RsexL8zNLbjFpG
32765	payment	1397	1397	1678	1	1	12965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vDhkLxCYTyBWxWufJ3Wm3pMTGjQyzsrPBGaVkYHK5Mc6Pqp5
32766	payment	2133	2133	1874	1	1	3367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgQVCcqZhxzdKZsxiNwrWTzL7gwnGK9Awkoi675VLZM59ZvFF
32767	payment	2134	2134	1874	1	1	3463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqUE1DV1QUmzCaLWeGUECgkWKxzE6rgeQRCwDN3YwwjPHC2fi8
32768	payment	2134	2134	1874	1	1	3464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGdwmP78Na4ztbVGb7D1btsrp6yTdpQtH77qRN2cYt9BQuvPA
32771	payment	1397	1397	1678	1	1	12967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZBR6UEKM7hrgRNVKDvQrM7zftbv2iC23mywkGeopz2DiY3KV
32772	payment	2133	2133	1874	1	1	3369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTK3HVurZUFPgfqFAfvPgruY5K6vX9RPW9b1y8D5Ecf1pDcGAi
32773	payment	2134	2134	1874	1	1	3465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAobVFvqQoNStaSYCmTZva13VCM2APeT5JYsQ4m7j3qLkZaBV
32790	payment	1397	1397	1678	1	1	12973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QepYgrxBAcxNvsTmznc4BQc9bGLR8RfPDci3ofwNvyq7auN5
32791	payment	2134	2134	1874	1	1	3471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfiWzDpTzagfhxyS7Lpd1TQH1jfSiTLzf9QdnfkcY8swMB9oDA
32792	payment	2133	2133	1874	1	1	3375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsKQQqEYbfTk3XHydpHkBvaR4uRmBw4fRRP7us5qkavejd5nLz
32814	payment	1397	1397	1678	1	1	12981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvrixxH6Gjwi87oPDz7M96L4EwLaeXXCcEYW6BsBCJALRZHsJ
32815	payment	1397	1397	1678	1	1	12982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjpaYmDPrpBXkrK2wUCWfVUE5qhoEKGWMxEUVBY2ygtsEYnrb
32816	payment	1397	1397	1678	1	1	12983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKT5bexQDBMZ7P8ophTzQesfeGghh3RZ2bgrcYDNxGE8H35gbb
32817	payment	2133	2133	1874	1	1	3383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSWzrzY82MUUoZiSR1L5jwKkeXxqELZxMhBYi4rsM165b5PDA
32818	payment	2133	2133	1874	1	1	3384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisTiCDUb3AmijpZSMZp4EDGBNsNSqczWwiUNf1XwX9pBsXQTn
32819	payment	2133	2133	1874	1	1	3385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2enJCux4s1LyG56CUgA3WFnWErjd75gUkf6NYrGaEqycZx5dm
32820	payment	2134	2134	1874	1	1	3479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrooRx5s6CiBitBttX7gZ5mXQpnyAqy3uT25Cok7HNGqxD1ZXx
32821	payment	2134	2134	1874	1	1	3480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevGVRHebXBaSGiz8d2dXARFyaXsAraR9smZYzZc31zL9Tx1be
32822	payment	2134	2134	1874	1	1	3481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmZFbcz6xuMMU7baGYDQZXGExTkbDgzHCx8YMbcVaLTqygJKZ
32826	payment	1397	1397	1678	1	1	12985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgsbEmnCZjCrSY9VpGqfEGRiZkjMNB621PhLryxe8RcnhYFu9
32827	payment	2134	2134	1874	1	1	3483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEm1fsQLxLbd3Psv6WLRPkEjPSAJc1BHYzH46pJfvAnCkUvwy
32727	payment	2133	2133	1874	1	1	3354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbFM53TeF4KQdKkgLsiPrYGTxwjVapAxzztddBHeasEKiCr6W
32728	payment	2133	2133	1874	1	1	3355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4rDPCdL2z8MqRNHi51FupBzHRDQ9Ne1ynT43D1FVcUCXg1QN
32729	payment	2134	2134	1874	1	1	3450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJj3Uub37X5ZSg685oARsk4C9yBsyzotnUVvPNjt7Lyizx517A
32730	payment	2134	2134	1874	1	1	3451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfnPQ5X3cggf9ZfesGeacANsQfbpDNw4SeVBGL7h5KZbThzQC
32761	payment	1397	1397	1678	1	1	12963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjesDiVqi7a69aBZL5eXob4z2NGwLm9aLZBDApwKqNFnwBcnaS
32762	payment	2134	2134	1874	1	1	3462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GPUEP5E2gVEjsQ87snwsS8YagBKFztCEuaLB8ZmutzYDkrd2
32763	payment	2133	2133	1874	1	1	3366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLqoL82TL8dmg13EgPLxaH5scywXCzg8qm3PqUvpwsS1rkqfB
32787	payment	1397	1397	1678	1	1	12972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoN6bVbXvv5VupdCSrbxQvtzoa3oyWpbmrumPdYudKk7i3aWwh
32788	payment	2134	2134	1874	1	1	3470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7hwTSziqsPpnc89kqrpYnk5w2mMekuvLyWFgNma2xFTmb7yV
32789	payment	2133	2133	1874	1	1	3374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXMoYW1j11KH8yf87qkVSCnfBrdvXuiLnfxX9rMiB3k45rBQp
32793	payment	1397	1397	1678	1	1	12974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxbEeHgFtSPnsvfmHJjNmPEyM5CzS4XmQdoYzYwDaS4Ekm2AH
32794	payment	1397	1397	1678	1	1	12975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwx6zFicuLSDmzQNbzcaX3hiGS8h3rFge55yF6Ph4a2LVuorA
32795	payment	1397	1397	1678	1	1	12976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBanMnwXuie9ntNQE9gfE5UEBWKwNRRsoqicFsDWPsU6gnpfZ
32796	payment	2133	2133	1874	1	1	3376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9N3Uec6UjcmFo669N4ye3UFYNACnwQZAEo4SErAgsXA48u4Tx
32797	payment	2133	2133	1874	1	1	3377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERUWj33oB2j9iCG5cs7Pp1yYVUowwLUHQpotY5J7mJVxNhHzT
32798	payment	2133	2133	1874	1	1	3378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvgjieyfeYKFvVuCbk8amUkQ9FR1SMyz3oGKUHaiy3u3t5o5N
32799	payment	2134	2134	1874	1	1	3472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2xijsLFpPyGSkMXojyutTWcxXoN8cKjx2r3z153Tc88Npruz
32800	payment	2134	2134	1874	1	1	3473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg57GmA4dFTXmTNhNgL6PEB3KPTNc2kfkAcbNY7qAgjjZEgMUi
32801	payment	2134	2134	1874	1	1	3474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHH7g43KYn7e6mXXJVuNDjGopkjPv2i1kCLc4ZvouH6vBCbMc
32808	payment	1397	1397	1678	1	1	12979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqM6y4FjA3wHgMThCfTow1k7FP1ZQ5ZbCNYpr8UxF2LW3Rtwn
32809	payment	1397	1397	1678	1	1	12980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdwNHuzu1eb4r5tpGSc9MtbXY8V3QRiBo5Gd3jBo8R9MH27LS
32810	payment	2133	2133	1874	1	1	3381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmjioqUZYJa5isvgnk9EhaeFBCwkvFBiU9YZ2kHEgwHiDwcWM
32811	payment	2134	2134	1874	1	1	3477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2Qz7mWhRoLcEfprRD5wdFfUi3jkVCVKXgyRSBHF1Yth2rJb6
32812	payment	2133	2133	1874	1	1	3382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHt2YVZSrQn2sDVUfU2uU96oxayNV3cnnLyrnFKZ1CuYYA3k2
32813	payment	2134	2134	1874	1	1	3478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCekNMybW5vRyZAXXLr6PSL8fEwrQCFrzyHNbW7bG335o8RYA
32850	payment	1397	1397	1678	1	1	12993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFafGzA6qTfV1ArFCzbhNCYjnKPQmR8ALY8HT5jZvH7GMSQok
32851	payment	2134	2134	1874	1	1	3491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikxycNTa9FpzbJzhVLWukwgmX7FUJXVUafsn8bcgiRRNaS3K9
32852	payment	2133	2133	1874	1	1	3395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiGiz4kmEEBWcnJuX2pt894SJMKVAc9WXUr9kF8pq1WnkexZE
32861	payment	1397	1397	1678	1	1	12997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SB7q46ZVMTbVxiDPqBxjAbEstTg3RXAG8qTKQw5WCnk44rM3
32862	payment	2133	2133	1874	1	1	3399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDqyxDUGgRAhA1GEJ3Ev4FsymRzkTQ8A3Rft7hcDNJCy2Q3H37
32863	payment	2134	2134	1874	1	1	3494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoECRuVKRBPzy7JRGVd8WkzEGF11T7SZdQfzKk7cWKEX34uSVN
32876	payment	1397	1397	1678	1	1	13002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEaTUgxMJkuiF6djwZwquDeCWmR6Jt92Y7puBV2vqTJawi4f5n
32877	payment	2134	2134	1874	1	1	3499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ475z5e9Z22FULVN72RkxbGbcyX2KXt1sCbjE3zHx8tsWw8KiZ
32878	payment	2133	2133	1874	1	1	3404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKrWRwQa2D1CMDmkKvwQ7kEPivRnkB2yJqu1p5rNGJGSAUGhd
32885	payment	1397	1397	1678	1	1	13005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGrKXh7QjLarnMyJ1ZNeXzvENftdAshMo2Pybp7VcJUW4os4T
32886	payment	2134	2134	1874	1	1	3502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyajUjBGoVqFEMrtsmdhKizaUi7FNABRaPUBwTrVVQwnTx5qMo
32887	payment	2133	2133	1874	1	1	3407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6mg2rfCUnpkhtqQymahcYHj6qWT4AxNGs4ZRmqpM5zhHUQmQ
32897	payment	1397	1397	1678	1	1	13009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YJaqkN5iKd9nRttKvNXMAcuwfMaD21L8jvVaMjuqzoCDuapL
32733	payment	2134	2134	1874	1	1	3452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHQP7LWs6fnb5pPUkmiUxW3htrCUQRHdtRXamskrnKWa56r6Q
32734	payment	2134	2134	1874	1	1	3453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3VzLsDgmvowdTmMzDbHiukG9DSy2kkeh4AMutzozRGUdptQo
32735	payment	2133	2133	1874	1	1	3356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98dvn9caTGPfM6T4BHK9EUKDPUK7nkiKe2sXBJjALwqTgcAFA
32736	payment	2133	2133	1874	1	1	3357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx76NTFjTC6AacYAW8iK5F3WYALfZfw4yTMgKHKyuSvLmdPPmG
32737	payment	1397	1397	1678	1	1	12955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrcgBEWhfnxMx5qwh76ggdSvncAbHpaMffHHqVPRuW555p2NU
32738	payment	1397	1397	1678	1	1	12956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82ojrJutrWdLxtNpxL2pYXVB1pi88fyp8vbRyC4hj6exn9QqE
32739	payment	1397	1397	1678	1	1	12957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWf6Do1AufwW7wS4sKvAHFTPTLJFbJhqjBis3tJDBm2aWj2Fq
32740	payment	1397	1397	1678	1	1	12958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYH17amEbasavDRC8JemjWXziopXHCpEjjd68hpLsCmJAVrUk1
32741	payment	1397	1397	1678	1	1	12959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmGtxNDxK9TwuNoPraSqACMqVUBtRX8L35bd8bpcGebfgYJU1
32742	payment	1397	1397	1678	1	1	12960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmi43mZcvAmFNuxgTwRyuT3BpRwoEnCjipU7eg1TtwTHfD9P5
32743	payment	1397	1397	1678	1	1	12961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmfRysK7hvruivGTATNQNE86AZZo6RYSXYzGxKXuT2C8kVSBu
32744	payment	2134	2134	1874	1	1	3454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaszqZHc9eSfKv2gDepT57pEvtLeeo4W6FZTNc1p2CNmjjRDDh
32745	payment	2134	2134	1874	1	1	3455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXY6qsa8D9USxgarPU19uoLUVhuSQdAyuFoKPbCpt6VG7kC7K
32746	payment	2134	2134	1874	1	1	3456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvgHQHhxGgDtoszJaPyFEiBh8sFFzLE61v4BrokGHk7wi5QDh
32747	payment	2134	2134	1874	1	1	3457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9XpzDVz92ZvxcAte7K8NA6yB3WrN6rrJRY3eKJF756ZKB2EV
32748	payment	2134	2134	1874	1	1	3458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCbFC97wuDsgxEZDVuTXiu94vjPNFV2LNFTmV3j3KcM5FuKQu
32749	payment	2134	2134	1874	1	1	3459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVWxi4rDeJWecpNKLYFd9bSPWsL7oCzHFWKctUEvnSD8GSnBW
32750	payment	2134	2134	1874	1	1	3460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiZHjL3BuasMVWt9bi3TUwtAqLEbkNLDta5NGsiGeJvstC8F4
32751	payment	2133	2133	1874	1	1	3358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAJTGeb7FgibCQCfqhm1oBq8XTD86nN32ipmkAveb9nH6QFFU
32752	payment	2133	2133	1874	1	1	3359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfesFW2n6D4sC5f23KEnrpPB7foRHnSpVfLFuKMM6osXVuTh7Z
32753	payment	2133	2133	1874	1	1	3360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAGvNtjPofF5LvumjAS22fRCJZbJwoQXsmQQuLoRaNCkD9Gb7
32754	payment	2133	2133	1874	1	1	3361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyPJrHT4c6VWfnpamedo9P3z5NtxFhTAb5B1Bds22S6fZEkhA
32755	payment	2133	2133	1874	1	1	3362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4MWt2aVzhD32ciSHRmnhKN9ktTs3X7M6RYz5FWmfEZ8H9NGo
32756	payment	2133	2133	1874	1	1	3363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrTSL6bUT7MjgNtgsF4LuC5B9KqnByjtkyih2tm2EfuBuKfgp
32757	payment	2133	2133	1874	1	1	3364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSu4XLTzmhhZJkSggLygKhg355ZSxfJWVACHgvnVDV2kC4n57
32769	payment	1397	1397	1678	1	1	12966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpX3wMfLx85RvghTbNxXPjKo2bi9m8NxKiLS1RxZmVf4LQxigT
32770	payment	2133	2133	1874	1	1	3368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYDcuTymqVMwtoWsaxiXjB3VK6q14uyFHfgDB8w1y9yMmzzVb4
32777	payment	1397	1397	1678	1	1	12969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmJ3zyf1oxh7U1QSJFCU2YKFQwQx2HGoAiyNKuFoNYL3QA1hy
32778	payment	1397	1397	1678	1	1	12970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aWacQXoi9gfoSka2e9cCK2yR3WqFdann9PfV4mFKdWgiviAG
32779	delegation	1932	1932	1932	1	1	9	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2jut279t3U7BJRxipwc2tZ25FoHx1WScU6Hhc7QVEJWaWe8e
32780	payment	2133	2133	1874	1	1	3371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpuccCdxiDd8yxstJF9frVZsiCL74Ne4x8PhNvMdZFhAp7p3F
32781	payment	2133	2133	1874	1	1	3372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsEEtCPHYarPoRiZEH5nurhJ6N46UvdiuNZDpufEQqXkBSh7F
32782	payment	2134	2134	1874	1	1	3467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UeojDGLGWKEy1QstFzY96ZVi2L2jDN175dMqiL1nH1Z4vFaE
32783	payment	2134	2134	1874	1	1	3468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3y6S2GijzciraRZEG3sJ1PCB11G3mMaLZFFJWUGokteZkrxK
32802	payment	1397	1397	1678	1	1	12977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZDxY1ePeTLEb1vDvQSHrZojt2LWkxJxp5noR9xg9qkAKwBfW
32803	payment	1397	1397	1678	1	1	12978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2itE5LyuM5e7PHYrvm8FwisR6gN7aHR5hjJA4nXgNP6HbAf13
32804	payment	2134	2134	1874	1	1	3475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9etrdbUZ59KCmimP1gNzecLB25D3mBvxN7c1XUioPDbZ8FHF
32805	payment	2134	2134	1874	1	1	3476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ74b9YiW4TgALrYYavEkHzEyKr1bEkxNmr9QW8bmZZe1ng1fDn
32806	payment	2133	2133	1874	1	1	3379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcSXKCEqb9zx8JFGVoVcZopG9Lc2QSnNaUzzBrPaj57CLnrFh
32807	payment	2133	2133	1874	1	1	3380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7AYsq6KRnvHrexMDSiT6MKSJ5Uwk5KBZ5CySse98LcPmmPuo
32823	payment	1397	1397	1678	1	1	12984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhbRJy9EW323gpFz5nuxaq6TzrDM1Dd8f6coB3jHXfF11Rwuw
32824	payment	2133	2133	1874	1	1	3386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUMgyRkSSvDUVN6SaZnvBtoNs2USKzpcGZJg8Kcr1ffy2Hr15
32825	payment	2134	2134	1874	1	1	3482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdZEPgcmLkFZdDDP1kzcbpgr1mzqikAfM2P8WH2vShBVxnKKE
32835	payment	1397	1397	1678	1	1	12988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7Yn1nXPdNfnBHAHdK5znWQ8Bxotr4r1XXAipuQJqYmJb2BZZ
32836	payment	2134	2134	1874	1	1	3486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHCFMtCGkzVHuDnBh28CwnyQV1XaSBWYkcGbRi6Aq4TXypS6P
32837	payment	2133	2133	1874	1	1	3390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqacN8wMqnxDNH7FKweXocG4Gu7GSdAZ3sW9TMiDqWFUu5Bib
32844	payment	1397	1397	1678	1	1	12991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhGbE1fwygCT86tsjPNC8CnwMrd3wcnBk9KrDFgQ8Lpyiy7fZ
32845	payment	2133	2133	1874	1	1	3393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqtuMbdBQxSBqxtp8ey5Hx58xZqVV4zRUHuNkwiCxm7CXTGWM
32846	payment	2134	2134	1874	1	1	3489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56BKSNobfMZ66hHpYNpzW6A4BZV2hrpEteGcXv1GV1i8YtHCC
32855	payment	1397	1397	1678	1	1	12995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuCgeHVDu1ussY6oKGv1wBKAvLs7RKHWuZNu6wxRPfnMXrPmY
32856	payment	1397	1397	1678	1	1	12996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKgFtBWiDDiZvWi3hc4EDNd6v1nnAG9j1Kof2Y7gyhTrVQVge
32857	payment	2133	2133	1874	1	1	3397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibiF4KaNDdbGyULEnFNvpW97BpmNLDrBrUrnhWtYoFtE4EX5t
32858	payment	2134	2134	1874	1	1	3492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrP9X4pNxge6ppeyU2swTk79GVfELMrRjovP2T7GLDZMYLtBL5
32859	payment	2133	2133	1874	1	1	3398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo4uL6ndZL5CFq5SJYzZJeXkrUQLvnsCnQU7fXcFrd5N8zCb6
32860	payment	2134	2134	1874	1	1	3493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLCA3EAoGEhBLNdt98kqgJ6dZD3RTWPNMovvXJpkE4MTZUV7E
32864	payment	1397	1397	1678	1	1	12998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMkz4J3UJiiKYDnXmYMdx79q5n9EYBtK7mTSquhYMKSWYtfDC
32865	payment	1397	1397	1678	1	1	12999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghgDw6BE5jECdDrQPbbHpgvVVjAUmXMGA58hLLVFSsdft5vts
32866	payment	2134	2134	1874	1	1	3495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdid2HG4dURABn5TSQsyYerLsXg9nUic3Yx1kAuzcQ1KkyXV3H
32867	payment	2134	2134	1874	1	1	3496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqSX1iv7yeoeT56fLVMJV3zL9N9TLgJN4rjfAQ4kRmSiSiqBD
32868	payment	2133	2133	1874	1	1	3400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2S9pmD9kUBpREkjaRUgr1T7TCRqfkuMMcV48JEB9XN1vVfBWN
32869	payment	2133	2133	1874	1	1	3401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpszydPpN4AR8NrwAKhNXnkXapNjrE6HWQ9B1yJkkho32XaRzs
32882	payment	1397	1397	1678	1	1	13004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjprtu25EZbu2QV3uEHvK3FjCncHgPP5by9DxfFeEvTfRgeS7V
32883	payment	2133	2133	1874	1	1	3406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfyibRHQhoE3aDMz29ZdBSWDVBDEAJjRwzfNBSGeTJNhQm9vD
32884	payment	2134	2134	1874	1	1	3501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjUj2enP6kLVDcM7641bY6VASkHYdi8wjuQUwc9UQD4q98hkM
32894	payment	1397	1397	1678	1	1	13008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa22pNCSx9dQuCMzCC6zKaybUd4yukU2oCBEsbTmNSwEP6GKoa
32895	payment	2134	2134	1874	1	1	3505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAM6aKCAqwTiQMGGqXn3Qa4VhtW9SXTEAUMTeFMVzRc64MGPJs
32896	payment	2133	2133	1874	1	1	3410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtq6sqTMjiqMTP3fCv7Yj8weZid4cYFpRnJjVz9APZGTTsVYK
32915	payment	1397	1397	1678	1	1	13015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDFadxx6qa33CnA7Vsw5vjnmU3mDQSC61roCWKKEoz9LvfdEE
32916	payment	2133	2133	1874	1	1	3417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuXNdGLAHBmCjzBZmxRRSiEA5PdRiP86FHBHBn58qbJ86XdD4
32917	payment	2134	2134	1874	1	1	3512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHRaXvKLJR711wtNGNz1SULNsptQbPrnG57dB4aZbyWZFaejV
32953	payment	1397	1397	1678	1	1	13026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvtoZJH42QHVHW3ALTt8vMgoANadcoEXWzcWg9PF3wQbZtAGn
32954	payment	2133	2133	1874	1	1	3428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUhpmZWnoJT5zEQrqH5BkXRgv62DjWUpxWaN7YmT48kuGcmopb
32955	payment	2134	2134	1874	1	1	3522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHmCZoahCFvniUxbmuKgzct9AM1xyWXSa9mbZ5JrggbJL9Qse
32956	payment	2132	2132	1874	1	1	983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuaY98KkW7xkGjTZNFdAKt5jNpYrXEMYtDYwtLzqzxbXqCoEZ
32963	payment	1397	1397	1678	1	1	13029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHw7cTYCN4Ab6jjHCZjzC2LHekNNVaKSdQZbfDc4DWpW7RHpt
32964	payment	2132	2132	1874	1	1	984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGR9X7n2aGtQKAggw1rTvGNAbR1gZU4haUDYe3WkkXahrMZJsA
32828	payment	2133	2133	1874	1	1	3387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxSccpAg5DfntFyXwxW3dStcxHeuU2oRFVpftHJoXDJrfpAKZ
32838	payment	1397	1397	1678	1	1	12989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbd2juDw42WFNRvVeGXggSiM5g7nsyexApbVXxphbKmfqc6rGw
32839	payment	1397	1397	1678	1	1	12990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ48Eu9PdZNEE9dhTaikkqnXebNNbshNRsywu8GyHnG7b5Xepw
32840	payment	2133	2133	1874	1	1	3391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxDAQxeMQuh2cZRwvdY25XfZS8FZ1ZTS2LhXP1C3i12AuPYtU
32841	payment	2133	2133	1874	1	1	3392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSHJzva6TMjR8qnFpRuJ2wWYnpoRf7KWCPTHHUVs5nMYMQ6SX
32842	payment	2134	2134	1874	1	1	3487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YMEiJMpv4y9KzC5yMwYwaLLPx3FVDY7ZigVkAYEFvviR7RQb
32843	payment	2134	2134	1874	1	1	3488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRkgCgo7jvzC6DGXBzEhNyTuZMuxPyED1z2S6T62yfSm6K4a3
32853	payment	1397	1397	1678	1	1	12994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36mhR6CYcVHwKAuiPtpXji9V3eiD2pY5DGNgYG2kDUktWEkz6
32854	payment	2133	2133	1874	1	1	3396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kmqW5sRQkZm6LoJCrsZ8Dt7Fv1VRKKEvGGgF5U6xF7LgwSo2
32873	payment	1397	1397	1678	1	1	13001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvx7hLGp4u97dQMGfiMtcpbCzwoX7Gzo8iT6Mq8Nbts6qLyR3
32874	payment	2133	2133	1874	1	1	3403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSGVEjTaJfqNjmPF74MWLg1Z872KZFq1UcMbyTN6UpwD4M4Sm
32875	payment	2134	2134	1874	1	1	3498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnBMCk2C5Vu69VTBZxZD1LVeZ5JPAtUCeFV4wiJSXC15x4Bpa
32900	payment	1397	1397	1678	1	1	13010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnb92q5LMKwoPNRwyvA5iY9Ma1cx1KP3vJsHLNN8A98kb5QeS1
32901	payment	2134	2134	1874	1	1	3507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPXP5dVUF2sB8bjwQtPT7cv2M7MCLg8zE8TkfBrTNjLb8sCUe
32902	payment	2133	2133	1874	1	1	3412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXH6nrj4KmindnqQ13yFEvMyfLUKnqdRiqN8eSqZrdXnKquLut
32905	payment	2133	2133	1874	1	1	3413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPDksgWR7DBf5sbXcDf55A3kHyzdGQmhMKfwwxMZ4NCTErNnR
32930	payment	1397	1397	1678	1	1	13018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKY6wEvgzebsK6drNYt8LVyFLA2DxGhk8HebWa1mawg1Wzy9U
32931	payment	1397	1397	1678	1	1	13019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBqXoJtUKJsrGb8aj8KVoTBswmyNx8Hzbak1DGan3S7oHKptF
32932	payment	1397	1397	1678	1	1	13020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5pHg5xe6Mm7BDQYZvszFteZhv8xruJrHuw94Y88G1LXpe41d
32933	payment	2133	2133	1874	1	1	3419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3G2WLQqRz4az5YkpA6x7uKxj1xRQT75wdeV4rR2f8tGk45CP8
32934	payment	2133	2133	1874	1	1	3420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nzwQaFjxvdnZR7VxT2uTGxBBJbHBb5vnzPoLuigPGMRzJk8D
32935	payment	2133	2133	1874	1	1	3421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5F3BrJqdjqDNSTd9zbsabuZkNTmZiyxMzWohuF5jmH3k2MApS
32936	payment	2133	2133	1874	1	1	3422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCgZnw8jB2SwBGRapFQCbtCHeRnwkN5JsdNXw3VX4doaUdEMV
32939	payment	2133	2133	1874	1	1	3423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRMpRDRk2UjPxC1hoNAXzPXPpq8eW9FDqBoVu6WgwwNrzFffM
32940	payment	1397	1397	1678	1	1	13022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWZnFBYJGTrJAzVFYKJZ11aerE2aM7Qbg7UKYn8ZoSAeCsQgB
32941	payment	2132	2132	1874	1	1	982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTQELBUzSA1cPMbY8NCqGCU15uxmf1Zf1n5rqXqcFRLj61myJ
32942	payment	2134	2134	1874	1	1	3518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JmYZUeYrA4EgkxJmUYBbKrE4rkHSV7AjAg83ATFBEkdP37cr
32943	payment	2133	2133	1874	1	1	3424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4ohhbb3dbWDwtECiQWHupMSZ8rSVxvCecZQiHyAptZqnPPeC
32959	payment	1397	1397	1678	1	1	13028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJxt7xK9cHe6YrAm8yucf2CLUTWqcftaFyihMDgJCmKEqeLPt
32960	payment	2133	2133	1874	1	1	3429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCrFj6yUS6y6ULg92jNR36E7ySCxyz7LVEkbkUY3ptqpDLa9A
32961	payment	2133	2133	1874	1	1	3430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvP1b1wPYB3ANTsakhXbsFGN1uZPXgNwcAbUB3A2cCXZY9hYmt
32962	payment	2134	2134	1874	1	1	3524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPvHCn3DvjSMVHXrrZAbnV3H1dvAgyNtGNZPKgc2tivxNW9eN
32983	payment	1397	1397	1678	1	1	13035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCryYp6SG4fzwcHGico4XfUzU6n3uLW7HccFRb664ARPAYToDH
32984	payment	2133	2133	1874	1	1	3437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRxm1RD1BV9DXrWgSYZWVp4CtWRPTh9we7wSMN8xDx1guS1Ez
32985	payment	2134	2134	1874	1	1	3531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1bGMiwWfZn4yjy8cps6MPUfnkPDrub2UY6JBeyttnDDh1eLBA
32996	payment	1397	1397	1678	1	1	13039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKsPrqcMnmnBbjCqCHSJesneLApwWRkqSbfQ7jWwurXxhyjZa
32997	payment	2133	2133	1874	1	1	3441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD11CVwWdSBj6xB5Eq9gJu3KJJF76GNFHfKMWf31t1Y65q2Hya
32998	payment	2132	2132	1874	1	1	987	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDY4G9g4jVbF39AmtrzWwwaSCYUgeYqZ6hhmTp86qkvHaa3LoN
32893	payment	2134	2134	1874	1	1	3504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHqE4eQiZLaMt7jkbfbnXo3oVv42oJG1yoLFwrMYfkupdoBna
32903	payment	1397	1397	1678	1	1	13011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9tR8WNtJUvhM24zFoNuPLaYAwz6RfthCSQz3YJzaoUZhhz2w
32904	payment	2134	2134	1874	1	1	3508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDBra4GvqmiptKv4DFemzoZabycMct2Q5sEfzj3gCvAw3xSHKq
32906	payment	1397	1397	1678	1	1	13012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysF2uuzYqB6Cb9aNhjnJaJo5Hs5tzkGXBe8srfkYipLcu68ko
32907	payment	2134	2134	1874	1	1	3509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtcLaguAKQy2PcRqWCYwTAL8C7hBpruGNGzSYdTUcs9HN64FKC
32908	payment	2133	2133	1874	1	1	3414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Q2pwThMtN2VEsUe8cycHQCvwFEdnDiEte4vQxkBZUr9VE7tU
32918	payment	1397	1397	1678	1	1	13016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmymadoU7jcGVuVUHpTrDQdheeB8imrZoXwWcuYxpb6wukfN24
32919	payment	2134	2134	1874	1	1	3513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyQoSN8FfL5MCAvtcAr9yjLYLDRoqWncVsz1bZ9MsttZYx7FN
32920	payment	2133	2133	1874	1	1	3418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKc3vot6c1BuHptntRzv8AWv5H8fJusErF8JQ7KrauVBT3jDYp
32923	payment	1724	1724	1303	1	1	9	7681000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZW93qBKpbSpKJxAotM1efdKgGGtCb2qyfRqTS3e2wagrB2Ze9M
32924	payment	1724	1724	1057	1	1	10	4085000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZA4LPiuNyrn1T6yaEgspDF4Vm7W1F3sBBdfpjcimA8euEBqgWF
32925	payment	1724	1724	1177	1	1	11	2757000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpZ5aSsowMCucEhkuTcxnWTEg1KvckD17Y5qa3M771o6Vt5Hnf7e
32926	payment	1724	1724	937	1	1	12	2280000000000	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vPkUjothgaaEogjUKob47Y4Rd4xRY3SDY	CkpaJH9CCSes5tZzXszfDmeum9Dhcn5NsfkLRcPdnAB9rpDLEbVpn
32927	payment	2132	2132	1874	1	1	981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThmuHACWBtj1cAfDfqCd3p73nKk7LwTxSGrJYSpEkmSGmrrs8
32928	payment	2134	2134	1874	1	1	3515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqera38ZGw1YL1Ac8K7jYq618yvpvJZip6UsC1cssxUWwmvcG2
32929	payment	2134	2134	1874	1	1	3516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1d3Cy7SSYKjuXZwKpDJAYsoHN3pNgM3zxDiZxgqCzbT594VU
32944	payment	1397	1397	1678	1	1	13023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfybmZffFoTT8yc37opY1etSxkwsamC7EhAGNeJRSKuCSZhmsd
32945	payment	1397	1397	1678	1	1	13024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWW2qnXLPj6WCPbbFqVhuosKVjXxHQW1bsHpSZTp5J1aG6Jknr
32946	payment	1397	1397	1678	1	1	13025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5YfAWBrCH1rPcoueaPrnvHgcz6wBLqvESJfqzpwGphW6epdC
32947	payment	2133	2133	1874	1	1	3425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMnjbcUkEaQKcFD5LodWrGMybsc8eunk6MK5YSDZ9TNanyred
32948	payment	2134	2134	1874	1	1	3519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQadvq5BtznYCk1w5zCNQftzyDfeCDd82Mn9HuSUDYaLRH4Er5
32949	payment	2133	2133	1874	1	1	3426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZK3ymiyrUVomsgc5Wb1iXfNGpBJFJXsZLp2xYHFKQb3x5Dma
32950	payment	2133	2133	1874	1	1	3427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikAPSAfbDZhXz3VMqHmYUVxP2MCGuDczP5oqjWLqvfw8vmYFE
32951	payment	2134	2134	1874	1	1	3520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJH1BN8efasECBGnzWfWiU5pETpK1RVbvoRmGQL6fh9my4BcVu
32952	payment	2134	2134	1874	1	1	3521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgvLSLeK4Y8m1aY71eCbYNHjHQ5mKirFQ3xKRXPdWBH6Jp8Bn
32993	payment	1397	1397	1678	1	1	13038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmszLGt7fZyZr4A72cqynKiJ1ccrgC8c65CLo7f394DibxFU3
32994	payment	2133	2133	1874	1	1	3440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTr5XPyuKxBauqNY2fvuX9VXbatiqxaquPdf4k3w8jZe6orBZj
32995	payment	2134	2134	1874	1	1	3534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSumhMKhv58jC5UKZyughCe3pkaMEzCRK41AvZiRnK8vAW82K
33019	payment	1397	1397	1678	1	1	13046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDRiBVNuJHvQdqzAZa5UHdxUgwtPfkmK2P6zKfvGS5RZHPeum
33020	payment	2134	2134	1874	1	1	3542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt48LEdkn3HBXeJVyTJ18qvLVcz7iMtknkx9WGhgVuXQSu7Eta
33021	payment	2133	2133	1874	1	1	3448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KxnsDGStVsHvFjRXk5H1SDeETA4ytVNoQFpv5XNPhqfjtYnS
33022	payment	2132	2132	1874	1	1	989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQ9HR9gAF3s8uEN72Ea5jwdFWJkikmb4FNMXRoSRNhH9xFWhZ
33045	payment	1397	1397	1678	1	1	13053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUefNrCnWb49PiYePyZCR6p1ZHdpEuNHNwebbJHAQDcYAzX3bM
33046	payment	2133	2133	1874	1	1	3455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZtQNPtbNjCaDWPsydE4gnubTU9viTFtWv4eLws76LaA2AvaF
33047	payment	2134	2134	1874	1	1	3548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2SR6etD1GTLkHu1gwL85ZiGVJjRELG8pqhvsXqYQoAptSkr8
33048	payment	1397	1397	1678	1	1	13054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfqam9tDT6N1xRsHZMoPoJ5Wn768d62a3GZBC4Yrqa8JsEVAS
33049	payment	2133	2133	1874	1	1	3456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAxTq23Zr575YT25g9d2mEVKKiFzWpna9Uv2MxTTmVv65hh5h
33050	payment	2134	2134	1874	1	1	3549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBy3Ndhr15q1Vv3FJbh3jenRasZZU8vDmqJRemVwGKFgLocWhb
32898	payment	2133	2133	1874	1	1	3411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevPVqw73gcGJjJHi8dcupUmUquENxCzYVYEAdJbotkja3jkwy
32899	payment	2134	2134	1874	1	1	3506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPWJ7r2VRBQAB5NARsUrjqCWRqAT83E1BsiyNi7rj4RE8d44e
32909	payment	1397	1397	1678	1	1	13013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpNjNzZnJ4cMya6wtb8MAbpoAUfWNh3ZfUjz9r1AV8NCZUyMT
32910	payment	2134	2134	1874	1	1	3510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo1sjbEyfhfrTDTUTLb4dU9BvLznCkpsbT5iaVrEFQ2dgaHvrQ
32911	payment	2133	2133	1874	1	1	3415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKd1HA9jDDXoMzLk9CnYHCGr5hxVmqhmustENKRhM7Y1iCw91
32912	payment	1397	1397	1678	1	1	13014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRdgBcSjEtoxRCirK6wwK6JtfLMtbWHPRP6aJNavQQnuad9ERz
32913	payment	2134	2134	1874	1	1	3511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezvejf1vpF3Ej4QVe75txyjtMrwCr8C8dnWXBypvaAMGevrhZ
32914	payment	2133	2133	1874	1	1	3416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnefN49DAuDWm4qYiPFFSMy3qQr7bcTMuJE7arhVDwae1ygMR3
32921	payment	1397	1397	1678	1	1	13017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEmaWiLdK4hNwhegStyqLvKcA8ZWKAi2cnKotnzXMsUSPea9v
32922	payment	2134	2134	1874	1	1	3514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhMc4gNeCBgc2PQerXJ531a39cLQ12Wdi8R8TbdsrCjAhyS52
32937	payment	1397	1397	1678	1	1	13021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZrtAWFZKjASv9RjUDUChzLHV5qhJVwRLQWFmnyaTtAhbPpDn
32938	payment	2134	2134	1874	1	1	3517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxTV4w95g8kwydjvR8JUV6PrppofGFD4Pzt6GPgS4VwnUfozQ
32957	payment	1397	1397	1678	1	1	13027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1LDaQSxZbA53yfYE1dH4zjhvueQQGPJ1GhST4m7w1xyYdrg5
32958	payment	2134	2134	1874	1	1	3523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSCE4LT2sm3SaUg2HfpMD36WpBQXj91XJAYgLPw6ad5P9eXWb
32986	payment	1397	1397	1678	1	1	13036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYRuKFBAmKw5ajMWm3ZWqUsgFJEBwi91yqovFTokmPGsUZVS1
32987	payment	2132	2132	1874	1	1	986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqyMDA9WsSyUWTD6gD9YRK7Da3LAhnbdM6458j1HzrRVUw5mr
32988	payment	2133	2133	1874	1	1	3438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSiZA2AfRWq8xd9aqrpC2gNrLuX5ZAro357YHdoBegbaao7yw
32989	payment	2134	2134	1874	1	1	3532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEyN7JpBkME3dAeQNa1QbLJRtQiXHhGJqG1fVMW1jsCCkdK15
33000	payment	1397	1397	1678	1	1	13040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiY3TUkVfEMzea4nRxm4g81zXyhiJBBzChD6NGZKtU1mHNJ3Q
33001	payment	2133	2133	1874	1	1	3442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJXj4me4nvFz9TABxkoa2hoEVfGLHtUbJ26sGHuPNkWR3j2ZW
33002	payment	2134	2134	1874	1	1	3536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMjnZ5amCoSvor14keBo6Re73X34aYuEdSRmPGuRpXCVMmDZm
33003	payment	1397	1397	1678	1	1	13041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5ksVeu338wiH9sxCirjyQrGPQVPEhv9W88Pra2s4bS6Ti9s4
33004	payment	1397	1397	1678	1	1	13042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNA4cQ1NHozixeBfG3k45qBvvtdphgZr1MAHrAJRVmvDJ6JqC
33005	payment	1397	1397	1678	1	1	13043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLY2b3qhVpFNf6WXFLTFHhn1pztvdFN7r1RZdSh4myX7bqDyaL
33006	payment	2132	2132	1874	1	1	988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa17c4owTmGVdqwYzXrVU922wB9pZ3Wh2ooZCbQ2xqN7vuRgKd
33007	payment	2133	2133	1874	1	1	3443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuu7BuwXMSonEqBjCMDhKokVHncHwGDq6kttmaLFkGigF924V7
33008	payment	2133	2133	1874	1	1	3444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYte4USMi8XjDvqCPh7j5jnAHEbofTy7aj49mqYkFDqK8aQhb4A
33009	payment	2133	2133	1874	1	1	3445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9NZJZhr6bH5MFHczhcYv9EXLcLEEyTPuKMen6CwfQWG3NYsXy
33010	payment	2134	2134	1874	1	1	3537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHbUSU4Yz7tZ8dHXeqbqsLLQc9Qx6Xae8JfGYxTCrhUGmQYnj
33011	payment	2134	2134	1874	1	1	3538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvBSmTCczNYXY1QNLNLwMVrxhETaMYJHbR83o9UZfaA6azrbV
33012	payment	2134	2134	1874	1	1	3539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JytrfzmPYNmRD5aF2VdeQ1Ayz8dDMV6hsc41NRZp2inPd6xi
33023	payment	1397	1397	1678	1	1	13047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzRXsp3sPetGD2G2NdHLwViVDXFDhfkmDGX9c93jrTAyP7teSd
33024	payment	1397	1397	1678	1	1	13048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dhtSAqgNfA9h3JAqdc9nV3drFRHVHaswCMS6rinoTnHMDb1z
33025	payment	2134	2134	1874	1	1	3543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT55P6xmFsdN8SjrSC3nQcM8oSsnP8oAXMsrw2vdiJyd43PCy
33026	payment	2134	2134	1874	1	1	3544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKGAq8ZFz8z9uBCjyv4CC8ZWdRBiuS4uFU8i8G9Dqs4soX7F8
33027	payment	2133	2133	1874	1	1	3449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSZBxRK8X7uDHiFynpf9ZSc5wYYhjiuhs9C3Mmriqg4fq1ytf
33028	payment	2133	2133	1874	1	1	3450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThdzKv57ZWA7vCkSd948EZaysRYDjNuF8y3aXwWvP69MNG1pQ
33039	payment	1397	1397	1678	1	1	13051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeYHMhkQ9ymRz1HZ8yPkHaK3BqqBzAxmFYcHoMEeecqQoHppX
32965	payment	2134	2134	1874	1	1	3525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddNCiCjUMb9cC4vGFwEnngDQpMaskEysnhhDvsUUDQbkVVJaE
32966	payment	2133	2133	1874	1	1	3431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzTq9KmVMNEqoWQseSDc5jsSW7W854zzthJ8QE9b8aM3WDzr1
32967	payment	1397	1397	1678	1	1	13030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdjtEcZGSFvx8awTpvhhHXfba1k3DUp3BVAKqESKwWQ7ziC3L
32968	payment	2134	2134	1874	1	1	3526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkEEpMP7qn64A2JWznDBcuL5faopa48kQ7fiTfTNpo3Kdr4VU
32969	payment	1397	1397	1678	1	1	13031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfh5wP9JgWHsjg7YaVV7C1eUxneX8jDqWvYgVJXamQainpVYs
32970	payment	1397	1397	1678	1	1	13032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bKd5t9RUTDgrRjiXKNjNAi3qq6FfZfyiPYjTdujBALaHxD96
32971	payment	1397	1397	1678	1	1	13033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvXG13bivXgLgHBKsPERRiYtHkPdBfUswqzmwHQyATywFuDZQ
32972	payment	1397	1397	1678	1	1	13034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1NGwzFCJ9BLPw7KvLjyd8cEyJHbYg7hLaGsu6No8JvGDWubk5
32973	payment	2133	2133	1874	1	1	3432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2Z3fXoHgKBHCh2pN1ErnMqWdhqFy7ekYhDg7q3FkHKj3qA7N
32974	payment	2132	2132	1874	1	1	985	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEbmiVp4jwL7VX2YNab3DgLKChXotQVmEKH9WEcnRmmf8oGgv
32975	payment	2133	2133	1874	1	1	3433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZneiH1oVPEAKuEUqHfPSYEPcPWHnPoNER8TfkcSUH629M4mFSc
32976	payment	2134	2134	1874	1	1	3527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqanVrbrFEfRjnK5Ef1yxGn7EQcpcRr2TPGm3fHnXJdZMZikDY
32977	payment	2134	2134	1874	1	1	3528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNxYVyNLfGrfzUuATQQVKTgrwhVynoJHYHShPE3YPmqXK5V83
32978	payment	2134	2134	1874	1	1	3529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxqYy63N2FAui6BddsF4fPNGKbxy8HC6jDYcB6E9XUkznWCrT
32979	payment	2134	2134	1874	1	1	3530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZzxgmZiAfjb46v1MZbE9j7R4DQrVzrPRpRLsvBfjxK6iZWBo
32980	payment	2133	2133	1874	1	1	3434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6z2Fx9CwjvSju87j537M5wtqp6kBk33xjy3tT5q49sDramPFP
32981	payment	2133	2133	1874	1	1	3435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqzk3vWfjy8Fx6iNDB7hQBjWdqdW1HQhsWphkgxkkPbAjoNpF
32982	payment	2133	2133	1874	1	1	3436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ngV14GXjvbGQF5mpqtqY7hoo4M98QT5Jce9QrbgPm7s3LbE8
32990	payment	1397	1397	1678	1	1	13037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8XQNgcrjbBXTvsRTpc4SD7gN1hLUfpMVHnooV7Ua6Rz8sehc
32991	payment	2133	2133	1874	1	1	3439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX47gYpyonTvEn1HiUfWQvt36kKQbEzSsAJfSfTPCz41VkDBaL
32992	payment	2134	2134	1874	1	1	3533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2jg74n71JoMaD9T8QYWmVa4MWWfumYjD7krMqesK9XgBrjtp2
33016	payment	1397	1397	1678	1	1	13045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQScYvhMN12Rk48BHTexvLvbxeZBNRkrVAD7riYjDViaRZdNfL
33017	payment	2133	2133	1874	1	1	3447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLgK8iw88PLDDzMCrcd9CSEMp71fokPxfGfv81zG5g8r7USfF
33018	payment	2134	2134	1874	1	1	3541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcp8CeXbsib6wY7zUayYucL4UhnMRJBC2Xq3ixUxXqW8ywgmeu
33029	payment	1397	1397	1678	1	1	13049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrzhmusN4eafc461kyKcNZdk7o6PpgGNHQHmZvXJYM12epFZom
33030	payment	2133	2133	1874	1	1	3451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRZRgSeucwBjpEjjhgfQ7gN6bjYS6E7yULGBGqnUeEXXNivS2
33031	payment	2134	2134	1874	1	1	3545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBPiESLg1eNsonv88ZkcFdDusX6njJvfEnphTaCExitWuTuEo
33032	payment	2132	2132	1874	1	1	990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoixuFwryRviNU2iTuYFcDNosuZATFgxSyUE14od76chiF7PYv
33033	payment	1654	1654	1340	1	1	7	8295000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZ6GAtvB5UvfbYtbXWTnS1V7Zsz6BoF96hz3nv2uD2QLrC1gvmd
33034	payment	1397	1397	1678	1	1	13050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP81FeRPfirtrw4BLPmMQtJJENRXmyT4HpQ3Y7siW7vknNqD3U
33035	payment	1654	1654	1094	1	1	8	4413000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpaEZLwocahcsUJ9ETLN36M1ynjPs9HKPenJ91aX3N8ictrqsgUB
33036	payment	1654	1654	1214	1	1	9	2978000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZcAgJwVPoC29qgp2334QYfGBiYm84EAVqrqj8Bx4YoU3vmYAds
33037	payment	2134	2134	1874	1	1	3546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1so7x4Gm1Ht8TKeKosTTpDhizNw3ojjG1ppL5Bxa1s3PJ8nJL
33038	payment	2133	2133	1874	1	1	3452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa493tmbYNGm9WejMX2pVkZiB2BFz6BvX49dyyP7awWzeBnckSh
33061	payment	2133	2133	1874	1	1	3459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJF6roGzbySQAg5gNr4GFHBjjTL3KAEwKpepva3sYy8XG9TMAu
33062	payment	1397	1397	1678	1	1	13058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpyRZTr73rZYwSNSQojgpb7cWqfSKotjsGTkXKMQo3rRQDfqH
33063	payment	2133	2133	1874	1	1	3460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjP1EQwCnhYdzmbpu9eyMj82BVS2jW4zQYfS7mdTKgRZJxd6G
33064	payment	2134	2134	1874	1	1	3553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qt3qneerMiDHe6PCGv8r1apLc97Kqs97mJPnAFLV234Fc7zc
32999	payment	2134	2134	1874	1	1	3535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsd81w4rH6GnqfKuYb3byC9JAooShqMnJqj26pNQFqxJZKFg8
33013	payment	1397	1397	1678	1	1	13044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeHTZiTYYB5tA61BcjeetdHkyNd4tecmPjaKAAdghUUkmd9EL
33014	payment	2134	2134	1874	1	1	3540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQaUPbeK3T3FCXzy8zmqwVcr1qVDwsX3N31y66uQyPyfAmvNxV
33015	payment	2133	2133	1874	1	1	3446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HCGew8AU3Nthu4jaxbFXAMZbh7deZ4Q8Qhd9MwxiT7RNuXWk
33051	payment	1397	1397	1678	1	1	13055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFzzLcFTsShMaRUakVtKUV455vaDN4pwJJknx6fDEPK9Xa7nn
33052	payment	2133	2133	1874	1	1	3457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3iceucGymuiwh3zHJ3Ht8wcC85pqdSU3zaa3if6EtFQvJ6Qy
33053	payment	2134	2134	1874	1	1	3550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLrjpEGh4vYLk2uJ24RzKRnFU6ZJEUnFmEhujstdCA8M9yWU4
33065	payment	1397	1397	1678	1	1	13059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvujpvArU8udWSyoaX2X2g5uvK2zBPgDT98Ta8w7CjK5TetTC
33066	payment	2132	2132	1874	1	1	993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9a6PedWYDAyvCrnHkysuc6acwwM7rbxHRQVZXe1j7Avt4KBZd
33081	payment	1397	1397	1678	1	1	13063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXAmpfTmBcUghwZGgEKd6MAzKHsaqTv9CNxwAMYe3CHGXCmU1
33082	payment	2133	2133	1874	1	1	3466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Kt5hrKKYWV9G4WBXp7U36dhwHE5ofuFvUDJS9KFup41ys3Th
33083	payment	2134	2134	1874	1	1	3559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqpmL3ZPWfnkknQqXPUcdZp3ckfzf7QvmSdkHUEnbM6e7GeBP
33117	payment	1397	1397	1678	1	1	13074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEV3SYYJvydHrZqY16NFAFQrAPCKz8eRhs4S9Ln1yGcEc6wnnd
33118	payment	1397	1397	1678	1	1	13075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjFPDBbJMHeDRbeyZgMmrNa9cVQmTDR2AYxGenDYYnpfRuxoB
33119	payment	2133	2133	1874	1	1	3477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbwdLxRYKGx4PHaynZBbrzx6yEatXfTEq2t5HqJEF8CmtX3i4
33120	payment	2133	2133	1874	1	1	3478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdrxKYmWSoPgSKcfY3ATCB3GdWR6vZuXkHLHRHKRBjHPvSGzb
33121	payment	2132	2132	1874	1	1	998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovhSChfXVwz4ebTZ3RZqjD273pAZUwbgzjTiS8iBZs7gG7p2U
33122	payment	2134	2134	1874	1	1	3570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CKtUjRPdE7k1d1JPKWmyXtdgxj3mQne5x4AMfYu1GvxjCqcQ
33123	payment	2134	2134	1874	1	1	3571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZetJEsUscCWPhibnt4WAuTBijR2fAUy6BkVf8xqZwwwTmzWj
33128	payment	1397	1397	1678	1	1	13077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbbk2mXe5DoHtqXfECq9FsW7DLcrSyFkQzAvfUnizcXZjas17
33129	payment	1723	1723	1120	1	1	7	4487000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZcXjFC88nFXSjNJ8HMY1owkMuBJYNtkWzbZS52jsgfpubD86Qe
33130	payment	1397	1397	1678	1	1	13078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JhTNf7GChacapf9QuvWFRKAkCXfHLjsgcB9gzvN46iurhGyL
33131	payment	2133	2133	1874	1	1	3480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsvDPNKj6u5hFrqhm2BCsGriySxE6SUpJrqsVzNXa3YMbQF1i
33132	payment	2133	2133	1874	1	1	3481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdovThwAA2gmKP41bupA3toqCTqz8jLT3FHTy1Pt7eukmALnoB
33133	payment	2134	2134	1874	1	1	3573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyGxAcQALfhDYtXUTqir8ZYgrwaoNcZtxDhYKmb93VDB83qLR
33134	payment	2134	2134	1874	1	1	3574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQNexA4hycDd7E9BK826HDKrRzDLUb4j3XT419ro8ydfwbZWX
33135	payment	2132	2132	1874	1	1	999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gm8CwCoZ7cHqNj8UqzxPjnZjMYaXHt2Enx2fi5DoBjfDpHz8
33148	payment	1723	1723	1000	1	1	9	2504000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpYzMSX8bnD9qmEnWWcJovWHuVrBtwL72X9e3tppidv2MbTeHMGT
33149	payment	1397	1397	1678	1	1	13082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7iatvapdoRknfGGDJYih6oHdJHXfy9poogjDv3W1x2aQV8SC
33150	payment	2134	2134	1874	1	1	3578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Xg6m3UjcUG4WrKXLB8vMVU56saQ14mHoGRbR8zdRnn4mcPnk
33151	payment	2133	2133	1874	1	1	3485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSYBDTTP4RYVFJXQ3M8GBfqdXrkcmJU9hjAehWp33Fn7WdGxK
33180	payment	1397	1397	1678	1	1	13091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPuBrKJNZyEhuYUvKSG3ivbTxfF5ccJyxbz717c2V8tbvKkaX
33181	payment	2133	2133	1874	1	1	3494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfna6dLww3uYHk1oRu9L6ka2VxMjzGEbDTYvmiNyUNJ6ju7zhx
33182	payment	2132	2132	1874	1	1	1003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxoYjNEgfjV9MM715aBctxhqs6a6cj2N68mBiubDhUj9TTraaK
33183	payment	2134	2134	1874	1	1	3587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrFhJV9zEGf5eyfGrkRTLt3u77KZKhVfLv7xW1fqwM4Yqnr5s
33190	payment	1397	1397	1678	1	1	13094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQ8TKqW6bZTMdW65wyHVYsgoCf7ay2qMhoEoUoFC1NvqrBUAj
33191	payment	1397	1397	1678	1	1	13095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjuJeCem2WytJEx7NX4py44CmvbEBv7m3KcfkZxjDbAN5HHH6c
33192	payment	2132	2132	1874	1	1	1004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLdAhNA7gegqqHuRrag9wXHMRSkYSVjr3D6HAcnF9fVEtnHm8f
33040	payment	1397	1397	1678	1	1	13052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgXjbd6g1h2NC4QMw2F55Q6mdkjpRv8eBj7kFGz9KfXKUgYtF
33041	payment	2134	2134	1874	1	1	3547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwcPvxxCpTAVp9oFLsGyXfgBrdrHp7xiQf9AQn2CGKRVMRyyU
33042	payment	2132	2132	1874	1	1	991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfV3bbZG7Ujn8fGP3EKM8BPmeJyyhbMJPVrU4nKaH2HMHKMjE5
33043	payment	2133	2133	1874	1	1	3453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnbKnSDweDFQHRd41NDp75RQRpsLmmZgV6AT3McpFevQDbXZC
33044	payment	2133	2133	1874	1	1	3454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADKqgdeXq8Go6yc3PJ6eFK9CeZCqp9ym8AFgFHYzxR6e4K6Wx
33054	payment	1654	1654	974	1	1	10	2462000000000	10000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZgsWmkokR5TZ3AZf4xFnEWmkgXJirLLDpBwGEgAJjVA9xyoiis
33055	payment	1397	1397	1678	1	1	13056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiANVivCDqMMS3mPvXpyY5eXVn2ScHuLmMvx45wTZdhc7XHFAZ
33056	payment	2132	2132	1874	1	1	992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7huytpQB18DymS3uGJgYyewABi4Dk1BMJq6gKBgnE3rPKvJEK
33057	payment	2133	2133	1874	1	1	3458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPXm2gs1JbSY44Dwk4Xc78hPMrjBvgZXLFF6rZ9MnxKxSkfLi
33058	payment	2134	2134	1874	1	1	3551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePWJcC5fUW1JiRsUx2j7NWKM15ep7XGJXNcLi1vgGZgceSPAh
33067	payment	2133	2133	1874	1	1	3461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxf4E1xeiEioGReEDmkM8TdkvAGzNFnQEGn3K7hu9PfVKWBn4
33068	payment	2134	2134	1874	1	1	3554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFWq2UmhsuEPMxc1KPBk9bH2qsbyAN1kWkoy2LpzioywYW723
33069	payment	1397	1397	1678	1	1	13060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPx6beJn4nm2RJQZk68waxbgTXciebSZVSsGjLYhLiFo8wB4s2
33070	payment	1397	1397	1678	1	1	13061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2i9pXE7bBSftvdt8F4R6QDcr5eDGoUUiZ3vULov5BVMBeADhW
33071	payment	1397	1397	1678	1	1	13062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBiz5WRjh7f6EgRbY3UYaDXPxbfqFUxNKce9vkT88WG4NALex
33072	payment	2134	2134	1874	1	1	3555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxxrGmkFpfqe78Ma4i3sxb28VeC8LUkv2wFFuwpctu9firKWC
33073	payment	2134	2134	1874	1	1	3556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwGWxHSCKWxJjZqDpsaaG8dxsrpmjJMz51VDnKgnPoUN3ZZWN
33074	payment	2134	2134	1874	1	1	3557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mjX1NZGv2Wx4aEPWhwMwVw48mTB5Xe7AgkvZt8Gejww8CUih
33075	payment	2134	2134	1874	1	1	3558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsxZzF7UV21c76ySNy9GAywQMnRC4dJkTVS6R23Zh8iZNkjJ1B
33076	payment	2133	2133	1874	1	1	3462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47dVjuWeWcLcqiJfdBvYWyMhu6tQkt94eegJngvDQqaPNgXD2
33077	payment	2133	2133	1874	1	1	3463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhneRGiNRMQppiKmpdDRctcp48w7ncSqSPa35ma9ZZPc6uNdEw
33078	payment	2133	2133	1874	1	1	3464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmu7mFik5eMC8AuaVketruuarrksPSnbFd9Yh4mx8nv1E9ZYn1
33079	payment	2133	2133	1874	1	1	3465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rSSwyqK3mQp8VZEX4TSVVhPnkxxmWD3rwzLzrWdwV2vgyeRA
33080	payment	2132	2132	1874	1	1	994	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVvqpfzC85pNTAg9krh2K35jWXgbkynrbTLb8z3oKbgf37ssR
33091	payment	1397	1397	1678	1	1	13066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPvhtoJPWqN5yH1a8bStfqZHbnb3Yyo3dxPKjL1BPZBiCCWfa
33092	payment	2134	2134	1874	1	1	3562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtxjjDQEQ5JMYHSmRrX2y8ehttDFh9UvR4EJNzDJWuwftpHZh4
33093	payment	2133	2133	1874	1	1	3469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSNPdbSL4mX2jdsSN7JMb3aaYbd6GhNDLSNRTfRMJwDoruVn2
33104	payment	1397	1397	1678	1	1	13070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj36QiCRPkh2ZtxHF9YqcykwTvwsnDGZDCeZgiUqfXd3ymhSNH
33105	payment	2133	2133	1874	1	1	3473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSZVqJeANad5WNZJw2NPR3AsEVq3gL7diEF3BKpZ8FzecbiYS
33106	payment	2134	2134	1874	1	1	3566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZze3mSoEZ5ie6FBLpAq87tnVv59r3ukobaVm1m8ewwccTs5b8J
33136	payment	1397	1397	1678	1	1	13079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc38h1K7Xko94xzv3Q45EaQViFhzPAfFrkpgT2y95RwNdfHvon
33137	payment	2133	2133	1874	1	1	3482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUc4giuoqKVa7ArDHHzzyW9d4YjpY2RnhJZB6Y96VMPaZUT2y
33138	payment	2134	2134	1874	1	1	3575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFKCNJ3ZyAB9WuAwheaLzcPAmkFATMZKsqNyk2tzThXVJJvnr
33162	payment	1397	1397	1678	1	1	13086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4iyaerTSqP6BcLWgpNmfTnAt4P11qfqfKQ8RkdgrDyYLQVhN
33163	payment	1723	1723	723	1	1	10	15000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	Ckpa4T4sjftFJQ6ppY8cv1s68fSfmZhk61o5kqHFvY3BZpSJnJBEr
33164	payment	1397	1397	1678	1	1	13087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4zks34nR8ktJQLzdFFYgYSjaim6KeiBNd7hDDfJ1fdNBSFoZ
33165	payment	2133	2133	1874	1	1	3489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4gLVFwAjXXrj2KSRLn3GnXddvXxrQyMP7ipd4zLwfikPjym1
33166	payment	2134	2134	1874	1	1	3582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBY2jyWNf11iYAJcjLg4B4eh89V1jTLfVuEf3XM1cD8uwSoxYy
33059	payment	1397	1397	1678	1	1	13057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwD8g4kVS4xzW2Rw5pTBfr3LdzN2KV5yzEwnQQskGXCYiLVmZP
33060	payment	2134	2134	1874	1	1	3552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUQrJd5Jnur5uJ5wBicZVddJpV5Au9qtWg1bJfLqQg3bG9zzG
33084	payment	1397	1397	1678	1	1	13064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSN2c65MDksEc7oByuGnmYxnSgRN8QiFup9VFHLS1W2FWjPi8
33085	payment	2133	2133	1874	1	1	3467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYt839DQxnS5WmVcE6Y2qAZZt5jJByERiDE9vLwG8XiBGAVPh5
33086	payment	2134	2134	1874	1	1	3560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUgoWN3DR187cRzZJxKof29aNca7nfhLVkFCHxSaQJrN9kjyr
33094	payment	1397	1397	1678	1	1	13067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJU4hL67WZ4H2GXxhsFU8qTw9zryjNiYSgMk6xsiiuZdJmGaoZ
33095	payment	1397	1397	1678	1	1	13068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHpwzC97o3TJqj1EwX4hRujWXsrLAMhAqQ15KpqXmCJ1JMc83
33096	payment	2134	2134	1874	1	1	3563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9CskJasQY8Mt6M53vNQ4PSUUJYfKbicrFAg4MRpGkEaBkxQX
33097	payment	2132	2132	1874	1	1	996	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDK1CnGFZ1rd23ziRFY5HLoBATc1roeN988Ek4w9ZSjp1m8xaM
33098	payment	2134	2134	1874	1	1	3564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5afZP7V2A8afTK7dtpGsAPrXfqVM6Ke61Xatbin7wNhXbT4v
33099	payment	2133	2133	1874	1	1	3470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36T9M4uoto18JDWsU3aYJzNNwQ3vhCozPSm6bx19fsyU1wrYz
33100	payment	2133	2133	1874	1	1	3471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHtgxdxDD5d2hFhFG5PHg3B4ML3TiCbhuM7sqmQ3WL7arLPjF
33107	payment	1397	1397	1678	1	1	13071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQ47eWbKuXEc9eTQ757gTXxT9HfGreURpjazBRNigWR8eQFc9
33108	payment	1397	1397	1678	1	1	13072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFMuNCj2iUjT2MNZVYrHEgksM4WtpKobLdexhZHSipSPBfSfL
33109	payment	1397	1397	1678	1	1	13073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhSMyqnd149cYQTvewxgdC16GkQpZ4MQy1eSuXyE8Un8oPgUe
33110	payment	2134	2134	1874	1	1	3567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYnwGq95B7QTZPEiQzbiEEx4YDRdTNnYa6azozPLpVngGf78b
33111	payment	2132	2132	1874	1	1	997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95X8dUfRRbSQqHnEjKxpAHptFd68jyUJdeDDuVPYY63TMDD7o
33112	payment	2134	2134	1874	1	1	3568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAT48Xu3p9WCK3F2yi7PmwnoFFSnTvyPRDv8aWwwiwkA3cWCWH
33113	payment	2134	2134	1874	1	1	3569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD6v3Vw8oKgwj9EaoYiwLK5FtPmAVQbuMxJE94xVbPuVCeii3
33114	payment	2133	2133	1874	1	1	3474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwufdpXyyMTSiJtom7dLExAB1dUEdkWnpKWH5ztne4Uz7H1Qr
33115	payment	2133	2133	1874	1	1	3475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkpK2D9wy955dBQEHSZX6NSSbCTMdiM82xE19xoYVE79DyPMt
33116	payment	2133	2133	1874	1	1	3476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwciD582rM6KLrqWfu1PXJzWebdxfB7MAePtCpphVak4TYC5tD
33139	payment	604	604	604	1	1	0	500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapCPCpV6CN94TTKH5mF8JkfrneePW2pKKjmuJ5rYdH5ji4KkB
33140	payment	1723	1723	1240	1	1	8	3028000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpYYtt4bn7t41ofXvkd8jQ5NTYFxozw5xTBeBqUxREWiAwEVqE9q
33141	payment	1397	1397	1678	1	1	13080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9hdTomZ5wixjRZvtdDTMaqWGQ4CT7qwR7AiA7vVRQJJ1mwhY
33142	payment	2134	2134	1874	1	1	3576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNaQpbsCg5THxfcX35o4WB91eoykUALEKxa2KNNi2FmqYbTig
33143	payment	2133	2133	1874	1	1	3483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8nPLd19KckQiTX16b13hGhrcWHMHS3gsD1XJfcFzmCWAuDjsS
33144	payment	2133	2133	1874	1	1	3484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyqCwG4AfBPaedSF6mEbhaNaY8VNFAr8n8Br7NN3Zz8dSdgg8
33145	payment	2134	2134	1874	1	1	3577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBxriuzrtUg2ku89iT8JrgaSUAu47i7GZauxnCKtDXAFzyPNt
33146	payment	2132	2132	1874	1	1	1000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKcnXNv8Q5mLG66mW6bAy2QPuFPdxeMr1wwJnxezHYBoLVTWc
33169	payment	1397	1397	1678	1	1	13088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcf8gmNQgnqwByLmiBnAJQTkgLFPnrv9pSCaxRUyfpsM3gffR
33170	payment	1723	1723	2293	1	1	11	2048000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZaHkYpnZBRcZy7acHAe29LPCpj2wuuTAFC2nSW1eZubrTjAofT
33171	payment	2134	2134	1874	1	1	3584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgjKba2WYyUp5TXNGfTB4cHNKybFnGFRsjwCncg5to5GVuCtp
33172	payment	2133	2133	1874	1	1	3491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRTgqwtgShJ1rCZ8xv7FQnNrPXdJtng2cj2gKveBifeUeEKPv6
33173	payment	2132	2132	1874	1	1	1002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJW4TWDnM2x3vUh3seT9uECudis9iaSyvJVQj3sCPiYRYyns6H
33187	payment	1397	1397	1678	1	1	13093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjBfffA6C1xBnE5xqYgf69CVmZDKSbF42wGsyjQ69LdyRRFHf
33188	payment	257	257	1546	1	1	0	1244990000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8z7gAkx4Lga5zrTVJzSAyYPHZEPfD4RRmYET22g5Hv5at86L
33189	payment	2133	2133	1874	1	1	3496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWA4Tywr6yYZc7mytdbAUX18xkdsdCfYr4TjAk2rXxzysEWpiY
33087	payment	1397	1397	1678	1	1	13065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2ZZeVN2uJ5VLAA1WH5GXCH4qXFjxt6sZ88FeV7NhFqgWgdMX
33088	payment	2133	2133	1874	1	1	3468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXHiNbVvjGcVwUyFmGAdC8GPyp5c4sp57yDMmyEaQ1GAgMsAL
33089	payment	2134	2134	1874	1	1	3561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3oTAdRmd4jUk8MoMe9hav5Em98e8NeqSSUaUkk6jpY38kbd6
33090	payment	2132	2132	1874	1	1	995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFE7Rb8YMbjCYKcyoaQD8hTpqaVeSDcSVCaqojnvf5VtKTPiwT
33101	payment	1397	1397	1678	1	1	13069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gTbXVUj79UHxjt2WHcvHmgYeVDpa4fKJqyUJsZVojkzAvErx
33102	payment	2133	2133	1874	1	1	3472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3SqinMjjnFELW3yghLxwDueXxVWZPcML8fyL7T1oMsFFmKHV
33103	payment	2134	2134	1874	1	1	3565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvM61XAwFBKLoughdgVQXfriXgxupxMTFcii2XnqDLGbfh26Fr
33124	payment	1397	1397	1678	1	1	13076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYubkWmaQUr3fvkqJDqXD12auszSFsA5nyFq3qp92vrA6XpjyKv
33125	payment	1723	1723	1366	1	1	6	8436000000000	10000000	\N	E4Yf4DN9A4TJYuGy3EC9drZPM6SJLFJ75Bj7ffjJrSJigWLdwtGZU	CkpZzDb2cik6KGZZeo5EdNvPvy3VEzKvwzdjWB3FRxCreSF85RcPD
33126	payment	2134	2134	1874	1	1	3572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFqFX5bknTQu8Fs2pRRGDT9RxAnzXaJXxMvauEysLbf7HuEcg
33127	payment	2133	2133	1874	1	1	3479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxFcJqDGbdxBeoj175yuPYbkiUzs3WMWrr8L3yqfPx8RLLbVe
33147	payment	1397	1397	1678	1	1	13081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4aRaF8u7giUriUQNYo6tGoyZ7wAopbGm1CRoY8H17bszBhnQ
33152	payment	1397	1397	1678	1	1	13083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4kiJcF4v4Au6uTZbcSnqJTW4hZQHnVV7jxL2dnRi9CfwWS4kr
33153	payment	1397	1397	1678	1	1	13084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytzmenmDPfDc4A1w4M49yTSSgrZJoWWo7jhQY2aJxW6Q1mPrt
33154	payment	1397	1397	1678	1	1	13085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaNb9A31TsVhTByqM7SmeaupUguVVYtXyJCFnSdNYExzyxU9g
33155	payment	2132	2132	1874	1	1	1001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkrcuFn9drizJDKQLHQL7JGKchqJgSL74CJxZ6H94HWMmdAJn
33156	payment	2134	2134	1874	1	1	3579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqaPtB8TTkx8sWZrxiqb9fABHw7rtPafJmytfxySAvVbJzCtv
33157	payment	2133	2133	1874	1	1	3486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtyMyKZeB7YSzfFH1mQapNswohK4eoWj9A4oNyzG1t36uDCue
33158	payment	2133	2133	1874	1	1	3487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9DDRZLmNDPccgq6mAT11j98PYDHqzSuC8bELvGy6wA3AEaRxJ
33159	payment	2133	2133	1874	1	1	3488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaE9azcTuGAxaFHEoXHVQA9ccpRrafrgAEuhd4XqY5kRHZSSL6
33160	payment	2134	2134	1874	1	1	3580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn91DLTY2o1Css2cjXPMc9PZw61AFPfAiQVEeQ2K7EyVLXzr48
33161	payment	2134	2134	1874	1	1	3581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPGG6iAgqr5kTzuhA4615csaqKiS6CyrMbBsUFue3BHwtpPXY
33174	payment	1397	1397	1678	1	1	13089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACsW9hpxx9osZmPL6Wn6f9YxSjdA8AtTi32XaV8ThMyGB9TJr
33175	payment	2133	2133	1874	1	1	3492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9Wctz8qRMzDNPwLpoBD7DYaMzETHk1QLTcTWxWmCzSVtcrR8
33176	payment	2134	2134	1874	1	1	3585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVr4dMtQ3A8eUo8r9drJrMzWHCa8UuiAamDGum6yymDqiL1HW
33184	payment	1397	1397	1678	1	1	13092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJApZUn5mtDBQ1f92zqj2ZHdHE6PbrUG5uEKQKh9YDArJ2J32s
33185	payment	2134	2134	1874	1	1	3588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeKf585memYu9jxsNLUtdUJDmbpvE51Pj4LYY9495SiE3kXcz
33186	payment	2133	2133	1874	1	1	3495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk91Vsje2YcXFMLUVE3nJkTAxpopL6MK2rTEQzLVDhLtEYpZoS
33197	payment	1397	1397	1678	1	1	13096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcGG9nTRHjeyz2wqzR8LMHpkjf3EWsvn2xQRD82JUKrF6HUtG
33198	payment	1397	1397	1678	1	1	13097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULvcB4TKxnGU14qyTC9znMMZRPevWifimkCiVzujwmKYv9Jfm
33199	payment	2134	2134	1874	1	1	3591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvSt3AjuxRitHMsKNm6HLNcLd1kbouCcBgL4QgHnW8k4Fj2hz
33200	payment	2134	2134	1874	1	1	3592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQimS3m5GHyg39A41EoEYCPP49wsvkDzemQVcaBGXMBK1Aeygy
33201	payment	2133	2133	1874	1	1	3499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDX9LyStGHpFpmBsYfShypxuvjodyooe9mAfjEvibNpT3XMsLT
33202	payment	2133	2133	1874	1	1	3500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1CgCSv2zVph34Ek3gCuy1JTQGkCxGniPxe44etowMoMHJ65q
33217	payment	1397	1397	1678	1	1	13102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1ejDRFFbACYoPT2sEVucooBJkPvYmy5EqcjFidMkMxBANtRu
33218	payment	1397	1397	1678	1	1	13103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Cwy83MkrPYja3mMn4qPwJsCU58Fd5ECsgFerco77yWc18sbT
33219	payment	2134	2134	1874	1	1	3597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxSSAGAqq781fG2aXCksKvbkxsZ3efqRDB3gvMwzriAJiUBN1
33220	payment	2133	2133	1874	1	1	3505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1f5Sda3U859k3RwTRJghQE8ZMEbvSmNhAaEEr66Gu63MEssD6
33167	payment	2134	2134	1874	1	1	3583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTPTQNjAYEsygWSZyVEsWrzJwSNC2C5kHGkpMk7R23gK3uKWUD
33168	payment	2133	2133	1874	1	1	3490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGdtrrzdmejR4hMC1jUQu6ydVZF4QXkincUW2XxUS8v3gADLTs
33177	payment	1397	1397	1678	1	1	13090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZts5DAcmEeSaYMTYtDzvHkjeHa21jrL5sTNAhr3dzTTLH8Vr68
33178	payment	2134	2134	1874	1	1	3586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd8Kqggp5BPcrwr4wRaHWewjLTMoCDZQSBrBv8P22D9WSwa3tJ
33179	payment	2133	2133	1874	1	1	3493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCoAXJHuytzCTR54YwC5rtMhiUZXsz3o7mNSQkTc4mWnHgEc8
33223	payment	1397	1397	1678	1	1	13104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ153CzJKkRt5DqWnrMyqA69q99qHQc9L2vWZe1eQYXRHt5rwsm
33224	payment	2133	2133	1874	1	1	3507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdaMycEqxy94BCxUf4sqH9XUaC264Dtv4Z1Tx3zATybJkfoGg
33225	payment	2134	2134	1874	1	1	3599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1HtAozt7XPF4GQzAFdy2KzhuYFgQxJXMJ7Dx5ZMA1sQFDj6J7
33237	payment	1397	1397	1678	1	1	13108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvdk1t8FjSf3TBA23Bw4vgRu3xN7e8ptQjanyUuxnVK3dfZRd
33238	payment	2133	2133	1874	1	1	3511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg9sZyi1MRqtc6aFhUdxGXH1UqM7fqMVaVVcEJ4fjRQVyLn9mf
33239	payment	2132	2132	1874	1	1	1008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnF6nrQeswqRSQCak73LugjYfKnYGJeQEU1mZhmD4kJPHXHKdx
33240	payment	2134	2134	1874	1	1	3603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGn9katesUdz2b2weoq3Pcn8TwMebzg4TVUhVnio5VB6etTMsd
33251	payment	1397	1397	1678	1	1	13112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFTtZdxTWA52b2rJAxCzqVmRVEwtKrt1ahuuG9R7kfXaHEP8t
33252	payment	2134	2134	1874	1	1	3607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUShbN7ToXzf1FgGThS75cNs1uSmQ1FceiXRtaKrKYmaEFiXH
33253	payment	2133	2133	1874	1	1	3515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p3ZCiaYT9fEHJRGTBzrSZGMieMmQTJy2pSWGL8iQwe8hSBLa
33257	payment	1397	1397	1678	1	1	13114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZfRUsrt5FqUtTCnt1vd1B1GYBtvpeV9Uah9STCtCCwgYCsTY
33258	payment	1397	1397	1678	1	1	13115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMr3BysNjQsF3pZAuTTFxD5UakBvJUdCGmn9K3DfVYPm6ntiP
33259	payment	1397	1397	1678	1	1	13116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJnyRorQ8bej9EZtdc3tpNGQNm4wJFfVzsbhoKLjw46Eh2UcY
33260	payment	2134	2134	1874	1	1	3609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPTmQGCgTnwbff5bVLDww92AQ3PmQCn5Y9MTEVHoXER4vgsGr
33261	payment	2132	2132	1874	1	1	1010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqeHtQzRiKuvJ7BGhgin7wHM3J4fbCmhBjucTJDZX1edozkqBN
33262	payment	2133	2133	1874	1	1	3517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dzSx2LxMLA6J5hPneHcvH5bRYVWFpWTxF1FGZaCrGQxn4qed
33263	payment	2133	2133	1874	1	1	3518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1rwYZXWHoRramYSMAGNeEMVQMidzNQt8JrSJKBHbMEqicasK
33264	payment	2133	2133	1874	1	1	3519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSN1gaRwaizoLXLkBMntTXSpFve6Hv4QDeEJsfkUxHP5VRBDQY
33265	payment	2134	2134	1874	1	1	3610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgp2aKeKyHDJ7W5oABhGCS2s3GZveBq2qHojXb7kgfLZTgeiwG
33266	payment	2134	2134	1874	1	1	3611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkB7ocfYmYDNFPqw66BE541p9PYdACYmvHPcQbgD28ogJDFLi
33267	payment	1397	1397	1678	1	1	13117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyoVsjUTXDoXi5seWJgECmQo9so9XBVyjE2pBK45YJMumzCiy
33268	payment	2133	2133	1874	1	1	3520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCAtmGGVjsaJ3CkATh8Qm1EtAjjz2fWvb7xztiddLPkxuuTZVk
33277	payment	1397	1397	1678	1	1	13120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktfepXMx7vF5xTMqXgPmdvVF4sdjiv6TPM8E63NDbNkLpSfg2
33278	payment	2133	2133	1874	1	1	3523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4pwZpEE5bC1taCqr5k3Sg5TE7a6vgiLRxvM2GFSMhP5pgwQe
33279	payment	2134	2134	1874	1	1	3614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5wAxFNXgrJeqhwuM7zdeuQzojQWtPmvPRn1HeDHfmf6F1TFsk
33302	payment	1397	1397	1678	1	1	13125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdp9V4spimZwmS5b9KiwAwrQtm4V3hk2aap59MbkhbAh9cQgzg
33303	payment	2133	2133	1874	1	1	3527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbjqJGjwSjSmwE8Ww95r9Hr3kSduDWzY3EcG9JRG9CR7SxiuT
33304	payment	2134	2134	1874	1	1	3619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXGYCUrABogwM8dS4XiTCY4cwvLe1pyawtccv2r6FtuUy1jjV
33305	payment	2132	2132	1874	1	1	1013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRnWEYLiST2c12npGkWKWaWKr8PxuzvqSrRzLDepsdRbF7Gn8
33326	payment	1397	1397	1678	1	1	13132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28kN3CSLURzcU8UvgamthrgaMajboyGuvh8m34RUn96b47Hac
33327	payment	1397	1397	1678	1	1	13133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhVz3KrVDRjwDUaAcNb3sRwkDZJaD2G1nth7rRYUMvNvgTuAhZ
33328	payment	2133	2133	1874	1	1	3534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr47g3ZFKxVPdd6ypHWegrDK138yR87hR3zgZXRm6J1PVujSrw
33329	payment	2133	2133	1874	1	1	3535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtamquLsDgfiiC2JHqBUxprc7vnbXY7nnD4peRgadmBdbsEwyA
33193	payment	2134	2134	1874	1	1	3589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqy7RtqwBdekxwSqgtg5UrdJEbQGxVveYxr5UrCvTdhG8KD117
33194	payment	2134	2134	1874	1	1	3590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6KtNwBTDD5aUAD5rcx3nk3dBhiao1BhC5up9q7toArNuyN3zn
33195	payment	2133	2133	1874	1	1	3497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7f9CZW2vyzidhmHv4TNrw4FT9uoaCNrRa4CkYaVweD425CxNT
33196	payment	2133	2133	1874	1	1	3498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAjKJ1D2ymXKrQuYLKFkdRNm9ENEnDQgMa87mCDBv6KGEaPk2
33207	payment	1397	1397	1678	1	1	13099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qg9xxWYZRPnAdQ8dHNRb8r1Y9sCasmo1TodYyfWGKXPPnGvH
33208	payment	1397	1397	1678	1	1	13100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBSpHRjCnD7nfD8RQgwi9bXsrDak1mEnZFpadAXoXtLuwUsWZ
33209	payment	1397	1397	1678	1	1	13101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeVEGnjwKeBHa52XSuhYyniFkEpsRxVGZWgvBBkpx1Z2sFdpi
33210	payment	2132	2132	1874	1	1	1006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFyRY9BYKQkmirE3tJQvqtd1vWWEyJaZdnW3Z2nmgEgKSkCTS
33211	payment	2134	2134	1874	1	1	3594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZj8nkAxRgXBFXE7JqT8UJ7XRxcGs2xf1ucKW9Rh2E3RYJSSb
33212	payment	2134	2134	1874	1	1	3595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRnUYSVfTqUeXifmEtxxUZqUDwUodiMm13KoyEDhkwvFxK4nX
33213	payment	2134	2134	1874	1	1	3596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSDiJJtvxK1swwCdSrUwrFGQmREDmR5g7FEskhoxbG9thouAg
33214	payment	2133	2133	1874	1	1	3502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7imwE6oekvcxmDLZFPqhRd7nG8GvXJ4N7GJo4TFQ4K6o67vf
33215	payment	2133	2133	1874	1	1	3503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVB86frmjCVZEvMf26R3SbywHBSEKRJUtFxuC4cCSK4Xz2AGp
33216	payment	2133	2133	1874	1	1	3504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbVyvvBawtyUsZe2uBfiJvmATJTyLvWHdEEWMWNkpbhUyD75z
33241	payment	1397	1397	1678	1	1	13109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ceVPdwW4Gzv61D1jxV26fv7GBYmQA57NgDYKQXFoB25bj7Ki
33242	payment	2134	2134	1874	1	1	3604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jvdLQoyAY1Ykax4BNGj6UX768sAqxDLXoexKwzLywowbFUyV
33243	payment	2133	2133	1874	1	1	3512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYjT4DuXWqvB7YAZc6NmK6z4m45JE1gVXWSQg5PKor5JiBMzA
33254	payment	1397	1397	1678	1	1	13113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSF2JqbGBa78URhDZdEgfvmCiuxr9oYWnMdGwZgS3ugqBJVS7U
33255	payment	2134	2134	1874	1	1	3608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDCsKYzPWc3CSTzPk56rRCdy5fXxoNU2eNngeRReJoFLQacUh
33256	payment	2133	2133	1874	1	1	3516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGyUNmoGoWYxGXwffThh6Bndy5sE1fa7u182zHxgbAXv6EPjn
33280	payment	1696	1696	938	1	1	5	2254080030000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gNVeWb4wn8j2BfAvpxGHLkvE5w22Y98pwTLVZXPNay1xGa6s
33281	payment	1397	1397	1678	1	1	13121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCygrHXmrRca8McmDi1TtKgY8vVdr4ML7fBCAJQ7Jfs7pAt15a
33282	payment	2134	2134	1874	1	1	3615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hgdGndSaiyHjKjHQqrGg7kvG1paGfpVQ8jCRjWCaHrWAW8Jn
33283	payment	2133	2133	1874	1	1	3524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMj1KBokXZwMnCLhDkgWc6f9qgCbtA4iP6DG2NGa3wSdE9uWC
33284	payment	2132	2132	1874	1	1	1012	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrqoJeUk76ubQV41rr5boHPZ128GJWeQ9EUFvuBA4BcreJQsu2
33299	payment	1397	1397	1678	1	1	13124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRow9NgHEF3D2qXF7r6FCkk9EX53TctM5SdN5RrXrZmacHn7y
33300	payment	2133	2133	1874	1	1	3526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwMVb862P9mavcVdgnXEkqpgfGHKFDy5mt54L3KQK4Auvrkn7
33301	payment	2134	2134	1874	1	1	3618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Jv4EfGDx5cmMxW8isWegxCRWMgCUPga5NzwUMA8vLvckpYm1
33309	payment	1397	1397	1678	1	1	13127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKZecbzpddC7J1a1jmY8fMpom8muMgCHUtxpQT2Lb2oCB4EzB
33310	payment	1397	1397	1678	1	1	13128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTUgt6DaUuDu1AhVFiDMniynthmp2xqjh5QfRF4eLac8952Mw
33311	payment	2134	2134	1874	1	1	3621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yojDXwAsu2rXu75fYkZTWaiGHwz6JhEmX6WWJnqAm5HwEZ4Q
33312	payment	2134	2134	1874	1	1	3622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLirHFxx52fERXdqo6hm1bfiY6PSeSBkXvVxKqdjjtz3xRBDDz
33313	payment	2132	2132	1874	1	1	1014	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWcjNEaWAEknyXfwYT439u9Hnkifrbc3DxHHa1gAswfQQsyBA2
33314	payment	2133	2133	1874	1	1	3529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF96hSbWfD7EsxQAHEtWC6xzqCdn2VojJmKEw6jy7r1Lgptafa
33315	payment	2133	2133	1874	1	1	3530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJrCWBbzHE9UmkNk9Yi3pbtekDuRa9EQSzt2dia5zC5reEC9c
33316	payment	1397	1397	1678	1	1	13129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7S8WCSweRePhGLukdryEN4yqziXYSwfHadA39mMdhT8fgdmyT
33317	payment	2134	2134	1874	1	1	3623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsLUwhemDJ8dZGuabDcaxGtda7GVxoKN6xXBgF5MnKRGym5Ab
33318	payment	2133	2133	1874	1	1	3531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9KxPbFTUCGYarzF4qZLxwTkUfgiuHZPXj1FMHhy8Du94JXMb
33203	payment	1397	1397	1678	1	1	13098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkqBGeQJA14L7QdHP1N3xbDR67LcfsfqhjQr6WuDdxmNxPmkZq
33204	payment	2133	2133	1874	1	1	3501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCSePvAoWLTmgQeJ46oQnr5FwZNT3eejQ35DpePGRsXh8FEg5
33205	payment	2134	2134	1874	1	1	3593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqDiexfU3uizPe1vyr7XxLBuBwkTZELDUY6WC31LsSB8mCGcJ
33206	payment	2132	2132	1874	1	1	1005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6R2QzyngpD67pPsMWJmUqdL1ahfwdMPux5xZguNqgFYjiPvj
33226	payment	1397	1397	1678	1	1	13105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVWVFpfje1p5eFALZzjQNzhQ8AZnjscLwsf19m7CRpZDD6DgD
33227	payment	1397	1397	1678	1	1	13106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFS3eYzJV1JvomjFyxBzTDHDQCGveQ9JaGFvsA75cRohPKnP2L
33228	payment	1397	1397	1678	1	1	13107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv79qxxqfDQKB87Hv6Vz5hwZj5sYmoZHeYvg55nWeRE7jhJmhN
33229	payment	2132	2132	1874	1	1	1007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWnCH8FJoxVHi226zFXyC8TYGkiok2iRCqGA5UgFR2Jm2BUiZy
33230	delegation	1885	1885	1885	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvdjXUANmtJcP3Y33ZqAa7mt1jhhxZD3NEE3CoFCFFz2X6GheM
33231	payment	2133	2133	1874	1	1	3508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbVvqT99xreeF86vFc8LuV2uotJUV44YsjoR4XCCFmJZPk7T9
33232	payment	2133	2133	1874	1	1	3509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAcuHYumumoLuCkv1YqmLyK44PE829oXmNQY2Gke6SXBwxAHh
33233	payment	2133	2133	1874	1	1	3510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMoy258JMoWjCqe3nUhqgghYLWgDVR85qRiAQPv6H2VhaMj5A
33234	payment	2134	2134	1874	1	1	3600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoRpzKGs1Ge2cEg5CRGcGAtBBfsEo4JDQqzDz3wxBmdTttHw7
33235	payment	2134	2134	1874	1	1	3601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KtBaDm9cyqHUWZvgddw8M81aGpK39m1giDRukGuwyieZ73Za
33236	payment	2134	2134	1874	1	1	3602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuc7TFYKqCxnyDVUJVECqPpwbvieNxBp8JnhzcjJvBoRyrGUwn
33269	payment	1397	1397	1678	1	1	13118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtSQHftqFLyJectrnfFisY6rkBzRLKDVEPpBvyZ145z9ajgED
33270	payment	2134	2134	1874	1	1	3612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1kBdqHmjew4dzpzwdZ6PBME2pgA1Soo3pyG6HYaStvoCAmx8
33271	payment	2132	2132	1874	1	1	1011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgWeDz7RLDkhLwGLGFUZfkNFGo8vTpTCL9T452wyCG5LPALKa
33272	payment	2133	2133	1874	1	1	3521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiTf6EDwCnU87vtA9c9ZCcyUoFqDJJSa31aDNtuRrWdiAmEYi
33273	payment	1635	1635	2294	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzysxcyUr4RZpCfN9THjrVobiPX7KjnxwVvrcvRLAZBFpGZycz
33274	payment	1397	1397	1678	1	1	13119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBQmQoEjQzvfZULVCAVDDXwE9W7JDnYFK7cVo5nz7P6nRECpm
33275	payment	2133	2133	1874	1	1	3522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNfdSTZ8Zr95BmspEmkcwM57b9WJwtq1m6bNTAkheC1NTkU5y
33276	payment	2134	2134	1874	1	1	3613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EMK2dtXcguLQGFEYqpTzsvDnTetLR3qtUzRtDcqhQchg67ZM
33291	payment	1696	1696	1304	1	1	8	7594543990000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVJGqWZxPc83ddVvqFLUV7LQT8BR1hDnGu9PLt5EUHGDVZQYx
33292	payment	1509	1509	954	1	1	5	2188333810752	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuJeXHi19fdTgGNa4gg3Mc5b5R7KLa9q7MbfmxFo3TF7ft5yX
33293	payment	1509	1509	1074	1	1	6	3921475439232	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKw9p1JYNeYnXMmoFRu9BU8gXkdDqTL9QZueMpPA5GYVjcC9ox
33294	payment	1509	1509	1194	1	1	7	2645897619768	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQRzzkrWB2Zgixn6waRZNNqNrkSdfwXUrJQnMC5eo5qed2Cz6
33295	payment	1509	1509	1320	1	1	8	7373028977568	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6BDwr6LEmKajbmwRpkEBssyf1iAc1pqiu5arPVHJM62EVxdN
33296	payment	1397	1397	1678	1	1	13123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTZh9c5NgRQcFFkPjqngs476BxU33RFsxwpVL5Nnk4YRksoqo
33297	delegation	2294	2294	1635	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRc4qZHNoZsRwhS1LyR2zrquX4Sfd7xDUxhmNuGLKk8eoEpxK
33298	payment	2134	2134	1874	1	1	3617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYLmP3zgwTo8nAaxZ74R51qiZGXZTJEytafxtK6781XWvSewK
33306	payment	1397	1397	1678	1	1	13126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2BK69VyZMPEcumzJ9jFtUfM7jTSdEwKkqt38FGKtfjojC86F
33307	payment	2133	2133	1874	1	1	3528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhSQ71okQFx1ZF1wUH7cjJBB7tCQk3NpCGGU8d9PjZcxerpSK
33308	payment	2134	2134	1874	1	1	3620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mheQZXjgdm3cERKLiqTfZJhzqAs6fftxkj6cQmXUVFBPad7W
33335	payment	1397	1397	1678	1	1	13135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUDgz1ddbj4QvWpnWhRRVB7yrUbUSV4ZkQmxyAjFCKvNzKzR2
33336	payment	2133	2133	1874	1	1	3537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSUhEuSTJrMQhNfD4YYwRyN9vBJfyMREFcmSrgDUevGbki9fjn
33337	payment	2134	2134	1874	1	1	3629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nyhJyGqk5KbYmQiGVhzrk7UJS3CbVedJhb5qexoG4e7SBTsj
33338	payment	2132	2132	1874	1	1	1016	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mtS4i5QbzxX6uC3aPzoC3iZFDnTtERvMarUudCQBaHmFj65Z
33221	payment	2133	2133	1874	1	1	3506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3LVLWCGuDmviWjQMonKW9LiCX2bswUERJWrLGDNednbeJ6RP1
33222	payment	2134	2134	1874	1	1	3598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnNBS9tumBrip4YcYZLsxbMT5pP2dgHVMYDdaraS7uyQCnY65
33244	payment	1397	1397	1678	1	1	13110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDHJuzvvXRCKbNt4Hfvz1xSYBUbPEuargVohCBVPQTcTF4oXg
33245	payment	1397	1397	1678	1	1	13111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbxyoRCcjWhE994XCpL4zK5cSsc4DL7Tfh4BaM947ojYntugJv
33246	payment	2132	2132	1874	1	1	1009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkUneL99ERFYvh1NzzdUHbFTmN2dp53VMAr6rncjdA8iYC342
33247	payment	2134	2134	1874	1	1	3605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKC4TCwkiexwAnAMqhHhfXUUv7wTfpmzVASXY6b9bpZ6pxPmZ
33248	payment	2134	2134	1874	1	1	3606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4t7dXaVhQwVB9ccCayimC2geU2Qk11hfySv71tx7ZN9aMuaS4
33249	payment	2133	2133	1874	1	1	3513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRAL4gohsPGqeurVLGewY3RsSLwZXoQfphGSkM2iJFF4pNFc9
33250	payment	2133	2133	1874	1	1	3514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTri5k6UkfPvK1RGMcJxeSayBrVaofqRznshRTmT1vEjQL5UWD
33285	payment	1696	1696	1058	1	1	6	4039292110000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4zNzsNTPhFKNEBLN1JgDay8kanFeZjziCwSAG2dWrGAeaPkr
33286	payment	1696	1696	1178	1	1	7	2725390870000	200000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzQeNfFGKzHzuPDGG9MGs2ZCkNKc5GjePg5i5H3qfPXyem7p7
33287	payment	1397	1397	1678	1	1	13122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxipsNi1xP7KaqpKbQXTd8TKgQZ1LvycreEfaPKuTF2tPbdm6W
33288	delegation	2294	2294	1635	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvxdCDYCQCcAyLAVF71TAcuiDWkA4T8JbFPgyUiTs6pw1N6r29
33289	payment	2134	2134	1874	1	1	3616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sYEf8b9NwryrEV7eZiEc6cQCS8Mgu2fdDsxNy2HGjHCmiNhb
33290	payment	2133	2133	1874	1	1	3525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhvABkn8AZEz458vSDDC5ZQV7tMknad6TjT6ZhNQwEfach3dx
33319	payment	1397	1397	1678	1	1	13130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyH4jMFc9WxkkcWtfrc5Teq1iEWjESXpcspcTfjgZBZPscWtYt
33320	payment	1397	1397	1678	1	1	13131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTf5LRQwqdbajazj1LVQCpkt35aEVPSJdLvdtmY43uJrqv1k8T
33321	payment	2134	2134	1874	1	1	3624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sBn2KLgY3UcciKirTrc7g2ZpADcejtdDRRgDDr6RuL4HZP7C
33322	payment	2133	2133	1874	1	1	3532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1ymt9ZRhwBvie7xNni1x1Nkz4etavYTnC4GUL93vjLnm83kc
33323	payment	2134	2134	1874	1	1	3625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbXwPJvArVaMWfJ9ZXvUS1ggdw7MWALxVC6vM1gotFFU7A2QtW
33324	payment	2132	2132	1874	1	1	1015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7koJAGeVpvitc2VBdxMuYDAsUEiM8DWXcWAJ9H6sErzMfn1P5
33325	payment	2133	2133	1874	1	1	3533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsCtrFuTjjY77uzkCcZbyqj7nSznwkMwxa9YHWWP6KnLGnLLR
33332	payment	1397	1397	1678	1	1	13134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9gk4UnPmUCmi6gg3aTHDVxHcNxtXcoD7ZU7DFhbvQnM6eeqA
33333	payment	2134	2134	1874	1	1	3628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkaaB5hCzzGNDQqzXrRvqiU9PjTuWZbMJw6VJHDA6cDbrvLwo
33334	payment	2133	2133	1874	1	1	3536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4ZzdEq9tAFcyMqoCPpCbXURsdPCoFxHqPWSjMUozpXfPz1Vn
33345	payment	1397	1397	1678	1	1	13138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUk8pJcNK8Korv74fVbxQ7oCnK3TiBHos5ftzVrToubrGtk6J9
33346	payment	1397	1397	1678	1	1	13139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrT6WWuyoAb9fN3xCVP3kVYEt3MVh1J7YTjN7SyR9YpGCcW9QL
33347	payment	2132	2132	1874	1	1	1017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptM7vXUgzoG47CWRtMYdBCRVFs6gSKmdik6MuEtinH3StrYsP
33348	payment	2134	2134	1874	1	1	3632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEQUqGnPByoQ9AYHQ4xZ5Ghdca1hC2sACsHQYkPSRirggHJK2
33349	payment	2134	2134	1874	1	1	3633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLq4YCop6U8U6B1u8SP9bpYCU8ebFAmXQdc5YnZYAqEurA5fQ
33350	payment	2133	2133	1874	1	1	3540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDUskQbnihs5BTdFTDiKf6jd6ohEjHfX7GcEbazfZshEian11
33351	payment	2133	2133	1874	1	1	3541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVZ1JG87LkxyiVLvNpWouKD9BNn6EAWbCWRQ8DbR9ACHVD2GB
33360	payment	1397	1397	1678	1	1	13142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqxon5Nzh6QDqLqEskw6yUviEQEZdYru1urxmuFt6Nu4H6oCM
33361	payment	2134	2134	1874	1	1	3636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXt3JqRmdmNhDw1QrpZE1ddkAWC4FAVfZvL73dzLeMxfhfGuYt
33362	payment	2133	2133	1874	1	1	3544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktfMzyousgvKQNN7hHbsfhKGhsSbwXQAyU7sPdmJVH2zV8php
33373	payment	1397	1397	1678	1	1	13146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfLgpVJd6ZpZXFZAtZtPvVHifYcaypZSshkYGGrrcjQAhJDE5
33374	payment	1397	1397	1678	1	1	13147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvaVhzWiwC4oJv2LvA3fKgF4A4idPBgqMptBJqXa767GK6DaB
33375	payment	2133	2133	1874	1	1	3548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgfxnBdwgeE3ESvPAc3NamkXtG3CPfnioszQfj366wVyg3VrT
33330	payment	2134	2134	1874	1	1	3626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUU1MXr8hgky3Zp3RjA7BBdN5PJiA8zH3ZccWnwtygXYZbn7Q
33331	payment	2134	2134	1874	1	1	3627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6SdzA4HkcG43qYShVHqCKc4k1Vhh4s5RGBCK57FSVTGLJ4UL
33352	payment	1397	1397	1678	1	1	13140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAwyrdgV3BweX9KCtUpg3tRBRVhjbA9BRbexcjxvsMVVGfE1n
33353	payment	2133	2133	1874	1	1	3542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuaUsHmfCP24uNsDmfQbjUWp5QiVujo3L2iVduJ3g7krWaYigP
33354	payment	2134	2134	1874	1	1	3634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWnHBzCoFHK6hpg6g1zRQtXF97zYjxaGtvcZMRq8cXpJkfGx8
33369	payment	1397	1397	1678	1	1	13145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjn5qk6pxQtts5UwyAyGXPcJ5a8SBqqLCP76NbSiSVo2y56CAj
33370	payment	2134	2134	1874	1	1	3639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2keC2597KZkhfYr2qDeWCkobTVNfVK2taZ8rrJzbDCGkX36W
33371	payment	2133	2133	1874	1	1	3547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbGJ3B4BA43iCG1oAtmXSAhKTxdUL8Gj4eMDMcKmMjhoGH3WW
33372	payment	2132	2132	1874	1	1	1019	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmTZS8PfJgb6XqqA79RVMgsSYByTHmfQKEnyPQEM4xd5t6do2
33380	payment	1397	1397	1678	1	1	13148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fNY7ozdhVtPjzK8BPAKbUQCYBwtxk36jPZoX3WsPwP4Wz748
33381	payment	2133	2133	1874	1	1	3550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyiGNr6JRnem54nuGJvC3zkZzfnS9gT4wWf9F9XUgixMMHgDV
33382	payment	2134	2134	1874	1	1	3642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhVm2SxNWMkhKBS3vxBr586UyjJvymvV8Vs1vfKRrnR6daqbA
33383	payment	2132	2132	1874	1	1	1020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSaU9WYGZXERTRdERuuPjv42JcR2JEEsVrdeqhz5iMpJGoYb9
33397	payment	1397	1397	1678	1	1	13151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTqQtJws65iriXtrZdKohEyKK5qYCNX8gRdX3VNP5557hYnkHM
33414	payment	1397	1397	1678	1	1	13156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqLpW5V5VppXuXQDpMRVrirxUekTNvqvRGj69wnMmCK963gT2
33415	payment	2133	2133	1874	1	1	3559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHH2PRHb74egkGU4qFpFB1VCtEfq2P3wM29hrSowsJGixyfAL
33416	payment	2134	2134	1874	1	1	3651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsih4mppidomCj4mBPuJbsCgq3nzeUUroM6JuexKA8yYM1CuXV
33421	payment	1397	1397	1678	1	1	13158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfuQyrsXP81CZxeueKEYxqmBF5u9Dwn3ETRNjAcRVTq1Sdwct
33422	payment	1397	1397	1678	1	1	13159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdAGUm7MpQfXpHj76nvVuniPKUyxamENMbNgLUFhuiGYWe7RvC
33423	payment	1397	1397	1678	1	1	13160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzCzssuC8KcBo2x6SvvPHUjbamfZBjttrVUuQmqaes44JhHU6
33424	payment	2134	2134	1874	1	1	3653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzBeF8cWGcxSPk9JipLha4nkMDoFYtKVfwMUix24oJZuhcWZN
33425	payment	2133	2133	1874	1	1	3561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtEexQQUfwMvKtMoaAk5bN4B8YPBG9Ngr9d7MJwwX8a8rEy1HE
33426	payment	2133	2133	1874	1	1	3562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmu5Ba7tMqwnbVg4Bxk1BT4pAQGQCD5sDTENxydP877k7LpW1
33427	payment	2132	2132	1874	1	1	1024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1r3T8w52ZN9GDse2jWZZmEuRKhtaP5GkpgReueSPBX6BrKn95
33428	payment	2134	2134	1874	1	1	3654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4zoQLUXL9SrfGL9JxauE1s6ewXtSwwVkzXH7qhwARwfdmb1rN
33429	payment	2134	2134	1874	1	1	3655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5wfwpjtSQK4UZU7srzkoTE7oWrqcNhxFGdbPmj68LzYmp2bTo
33430	payment	2133	2133	1874	1	1	3563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wEN7DfYuVGFpJi3vmt6WjfEqHWvicozscDJZs5g5DhxonFaf
33446	payment	1397	1397	1678	1	1	13166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1FvNLE4TFkYb9urFz53BrJnzuvjoxbSw5QuSBuE8DAmNbvxR
33447	payment	2134	2134	1874	1	1	3660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStZh11UCRhY25epeEdhAbpknFyrxryYHPbmQEsu9eL4aw2zMu
33448	payment	2133	2133	1874	1	1	3569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZfhkr9Mx2L43ThGoArvsCGNBfGVc4NCgXvtyKwbD1j5fSVVb
33466	payment	1397	1397	1678	1	1	13169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqR2KjhB41FQjVCMDZkV2ibtoYpJjDTSPYti7RuL13vQ3qjXUV
33467	payment	2134	2134	1874	1	1	3667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKq8oQ4oDU4gbYBT4Y7AJosYBuC2Y8gmyLCAtYvEQNWQfTB6SE
33479	payment	1397	1397	1678	1	1	13173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgj9V2aZuWFhVZhumN7kKtqwGy7VeUgEGv1bGBNMjYngyJP1C
33480	payment	1397	1397	1678	1	1	13174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVd9FtFKku1bt58gvTt5WZSRe6DCga54TrL5e1zgL7HNz6zQ1
33481	payment	2132	2132	1874	1	1	1029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftdQc1EvcUBLrMYrRc3UHgwjtfdiLyyhrh5J8tGSXa3E7n1RR
33482	payment	2134	2134	1874	1	1	3671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdR9T2DsYY34qTeem4mvHDhvr2HUSC79KryEjcTHBJEbFRyM91
33483	payment	2134	2134	1874	1	1	3672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5YhEMTDPk1ntCj9crxB8skZZhWbd7ubtdAfqhv5H1rCU3sRv
33484	delegation	1865	1865	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoBN3iv65ba61n6vpw8DaZqmAfanvCdb491AfkSPgrhfVemBm
33339	payment	1397	1397	1678	1	1	13136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtufKRQMKGnRETrQBofBN8Uo1YMx9yq5UM1tFwVBsicMVk8eg7
33340	payment	1397	1397	1678	1	1	13137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsArm1BVDQQjSC9PqMQjK19kd4dxzsU1CUtSA2yEj7dwHPx7Ha
33341	payment	2134	2134	1874	1	1	3630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYj2iCVXNTsCkvp5hDQGUjDjBCxUpxoFn2n3bkKXqmyShRxws1
33342	payment	2133	2133	1874	1	1	3538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2Eacy35YtXRF3rC9gJwiuRRweWBtqsvmrfd9M1R8ymNVJPbu
33343	payment	2134	2134	1874	1	1	3631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGtvi7zDioh9kiaGwRzPnDqzR9ssTNCiyPpfCqTh3JkJzFJGs
33344	payment	2133	2133	1874	1	1	3539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMraZQEqrhyBdsqwmfkGyfvDUEQpoAUkk7BBUbS19F8C6XYSX
33355	payment	1397	1397	1678	1	1	13141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZQkdeJaZCq9fC5Dt59eMx6vAB2HR8pGd7yaRtZv3q4ZppNs2
33356	payment	733	733	640	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisWQMZKjFNEr4do4hPQK4p6crGa9aLyHFqV2XHY5XVQdH5rpR
33357	payment	2132	2132	1874	1	1	1018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNYEhNRaTshyDn14CfWA7WdMy1ur8oJS271RUanv5LGhfRfGc
33358	payment	2134	2134	1874	1	1	3635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNVSqQNQxvuM5LHwoGQ3qKyyDvJXYWQJCcjBRVtMqwuZKvoZb
33359	payment	2133	2133	1874	1	1	3543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8w45nKEU9U9fzLNvo219iTEew1cXMG1hDMaGE6Tj1Uhyx2z9z
33366	payment	1397	1397	1678	1	1	13144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EauNpsJPqAXUHPskH6xA498rZ7GSMNAVL3JphUg59A1CGHx9
33367	payment	2134	2134	1874	1	1	3638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzp4mr3R8hWrc8Rd9JoBb6KeGwQF1p3eXmox8MGDzrZNS49QzZ
33368	payment	2133	2133	1874	1	1	3546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Tb3m6yUnWJKZRipzYDSWVTBYnm5QH9pzXx2rU48qDXyPybry
33398	payment	1397	1397	1678	1	1	13152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSH7PVMWsAEnuwqzKyZKsdE9tRUPrVwZGhqCTPWTLDy9ZBXNrv
33399	payment	2134	2134	1874	1	1	3646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruKSjezRVt7tjkBYD9YfiYbsRVhMgTopSvZveCckHLXrR4i44
33400	payment	2133	2133	1874	1	1	3554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5adTWhumC6VgYhHmbW6FS1AQvBmLhYrnz4wJbzYChZ9gHYXeY
33401	payment	2134	2134	1874	1	1	3647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcfQs4EVwRCgH57iejuZvMBp7M9utEBQzMUJ5k1EGdtWwuiJk9
33402	payment	2133	2133	1874	1	1	3555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvz9RWpE1GqaCaJX6XtBoBW4RZacHd1gp2etAgQfyNVjDrREhJ
33410	payment	1397	1397	1678	1	1	13155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYty3vkuW84YmdhQh1dMZE62nrSFNQwqTDEngYTwtx5BdThi1Wc
33411	payment	2134	2134	1874	1	1	3650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWp6yCxKYjf9Ad2juzhYKJXsYAFYH3bokdfMoGs9PPCAyP85LB
33412	payment	2133	2133	1874	1	1	3558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXMxX3eqrpDcawbqqFgNPUo7dHzg692xFsEU1enumpWvupXyz
33413	payment	733	733	2295	1	1	3	1999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdPNZ1dLav52HY3PJNtFGEsjc7wg1ZnFBbekmwk7Lpj4Tt6da
33449	payment	1397	1397	1678	1	1	13167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqeX34CduvDR91qug98pAAFfDseazoNKZSHhzyfRnkukZj2R9
33450	payment	2134	2134	1874	1	1	3661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZgE8H5sq29buL67EvFk2S47xPpegvcNajNWSqD2wSUc1p93gC
33451	payment	2132	2132	1874	1	1	1026	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdLp1PBj1iiUkSWCVL4pW7Srbcdm2xHxSxcuJebLWtRY9VkKh
33452	payment	2134	2134	1874	1	1	3662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkCdwCxyHC3jwWNhXyUTA3FQpfp4ApYVpR8pZ3WjCGjb2uSi9
33453	payment	2133	2133	1874	1	1	3570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZox1swPzW3UmDcz29VE2Rq9XVoodyzS1569JnThK8dmctb9Ct4
33454	payment	2134	2134	1874	1	1	3663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hPF7ka83ZcVfd3wjeSsQuFftpZkdinaSZexnNWch47cNeZZZ
33455	payment	2133	2133	1874	1	1	3571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8j5oRXrnAkUJAHAJ81xvbN3hHqVctDXj2iUFtQKFWR28X7jGP
33456	payment	2133	2133	1874	1	1	3572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpw3VTHCdpTQU4pkUwYcbXL9arzsqtgaPBE258XuAkXae9enrU
33469	payment	1397	1397	1678	1	1	13170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3YxXNYtyzV2V5mtBU1BDs9byuUTnFofP1AzD6FpUiDN2HxzG
33470	payment	2132	2132	1874	1	1	1028	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dp9iM1xxZXCNKoe2TRrXC12oda75CuFWK89van9ciH3cvMhj
33471	payment	2133	2133	1874	1	1	3577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQcYMAysxTAJQn4xerYDsHA9fMrbSiGd4sxsWZ4eV2ctGRKBd
33472	payment	2134	2134	1874	1	1	3668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SjUyJy1coLqLuJLyUb2ZrCyMqBZ8os7pWhjdUbKYkRk9kHx5
33531	payment	1397	1397	1678	1	1	13185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCKHz5xfULegKWVEBFHhXGb57W5usgCLBiDb8z1ao2cWNQYxs
33532	payment	2134	2134	1874	1	1	3682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZu9omoJwY7WxE4gDk6iqM8KAjNt4ZnwnSoGFejsroagLvbML
33533	payment	2133	2133	1874	1	1	3592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCB25QgmKmUmAYm4c7rByMXk6tLzCV6Hpx1fQVQzM9Qjwpfky1
33363	payment	1397	1397	1678	1	1	13143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpWz5ZyuCxuBrwUg7rVT95FayR7HXFFNkUAL6J5CBhptyJUC7
33364	payment	2134	2134	1874	1	1	3637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCUuUjLNKseA6KiKmZejhop65ZXAb7KEvpNFswzJtXucNCtEy
33365	payment	2133	2133	1874	1	1	3545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErTbqz1P8uaEAD4RbCmKhm1K6nMBDYzZqyn71bm5TpULGtmHB
33403	payment	1397	1397	1678	1	1	13153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupr5GeK9Ry7Kc13KdrMs1WjAhhGRVdbDCaRMuMMDrXVuTAHL2
33404	payment	2133	2133	1874	1	1	3556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwayrHp62fKLkUcp8i9DpTwPxGkHF2UoSPA4DMp27zh6TpcRo
33405	payment	2134	2134	1874	1	1	3648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmSvBX4NFWm78HtQXssj4p5fLt4e9jJzq6rVqnsLFAapeNd7H
33417	payment	1397	1397	1678	1	1	13157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1tPZvNYEb79CQv78H4x5UfWDRBrcNne5EVHfX7eTapFCkKxM
33418	payment	2133	2133	1874	1	1	3560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bvWqYXVgi7pJzMhZHDrjJPDQpDJ7i2goYphX4jmxPUztsf5o
33419	payment	2134	2134	1874	1	1	3652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbpAWNKRvXXBCC2qJWcrA8p8AUL5ixUHKkShcJcNTpUgWF1gX
33420	payment	2132	2132	1874	1	1	1023	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNFAV3aBbmrkvc8rMvTtoMvWevCgMF4YxmeXFbGq5jTBQiKMi
33457	payment	2134	2134	1874	1	1	3664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPLeTKG8g65vECYPLL3nyJQQKo1GsDAjucWo2aLD3ZgJEWX9v9
33458	payment	2132	2132	1874	1	1	1027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQS89dvQU8heZTP9VURvDRjk9JQEnKynr4s1JQjrr15USP3zh
33459	payment	2133	2133	1874	1	1	3573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLamv91KmfgmhJdfr7i9frS1Q1kUWFERm2WbYcQnpL2Z2YhCZ
33460	payment	2133	2133	1874	1	1	3574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRxdmCbop84PenjoJEPJs88pPMWsKiFAXyh9RJKexAQjjfa8sw
33461	payment	2134	2134	1874	1	1	3665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtmrPn7oZFc8msvyqXSTbxuVPMHGckmyKX7E1WUtEWUhXP3xA
33468	payment	2133	2133	1874	1	1	3576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28ZH7KjM7DpLw3dMofGHF5ofGTXmf4TXUm4eFBFNFUYQQ6RYK
33485	payment	1708	1708	1139	1	1	4	4822844614039	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYadckLzoVfDggCx3U7bKSUeR6ErE3BgK43DYrGC9e7Z7sX5gBn
33486	payment	1397	1397	1678	1	1	13175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHKSnRy879UXfs8f1GJoVuFDBVHTX1F3GbsfbhmpC6DpYkSJn
33487	payment	1708	1708	1019	1	1	5	2691332407011	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQWmF1ATdKrPZb2r5PAXwAf2CZ4ZFmovCn3rtmgyHCN3AkEV5M
33488	payment	1708	1708	1259	1	1	6	3254069363049	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpAiC8TEJokJmy7d1QgKWmKv2r2pWaHPxgypkBxw7G7toU37sh
33489	payment	2133	2133	1874	1	1	3580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwu5HTCxvmnU9ewzFV55WnAWNM7JFLNWtFpGBrB6TyyFZgjZki
33490	payment	2134	2134	1874	1	1	3673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZioZAk5spB7KR6XD11NZ8EdWLDJ2a2Hy69wVyjtyF22YqNLuwT
33491	payment	2133	2133	1874	1	1	3581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFV8CxHnfUS7N97UKZm9KLJCBgb18VQMbuvzRehMqmTHFGzZ4J
33492	payment	2133	2133	1874	1	1	3582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9c4Snrp18VBndsn2GY9QMemc5aTgVfjvTTfB7DcUJnAnwrkP
33506	payment	1691	1691	192	1	1	5	395486009902	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpYjS4sdjQFBsNm2uQferSpPHktpYnVFvddbdNTsgZmzoRzcAiDT
33507	payment	1691	1691	918	1	1	6	3008958989784	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpYfSenn2zqsUUsUCDaxgjLXiyrunfV9oz93Yri26ZeMZYracQAQ
33508	payment	1691	1691	1038	1	1	7	5392028728944	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpZCmaZrQP7ojxmRNw1Rze4msYpMNDs1gD53b7zfMH7XJ3rFx8a1
33509	payment	1397	1397	1678	1	1	13179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN92kU3ZJE34iTqHqjpsnJnstkp1xtJXmeNFHemQuZ8Q6ybhah
33510	payment	1691	1691	1284	1	1	8	10137914844156	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	Ckpa2uHzDkp57WmraK617W8QkYv1u7CCgcaQsP4UcE1ZpjE4eFjN6
33511	payment	1691	1691	1158	1	1	9	3638109227181	10000000	\N	E4ZCEw5mL3JEGmk2zyWJoBU716cVq8Bfgk4NcfEcSTyjT3xyAuNjs	CkpYhsfwAMKQquRbRWuMXKfSwt1NvyAJP7y4qDF6Tf136MaZEuw7P
33512	payment	2133	2133	1874	1	1	3586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPWCygxpnjs6ywnWbmG2wFS6pBvdxzEV8taxbQBCxmZq2YF8j
33513	payment	2134	2134	1874	1	1	3676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZhbSdA9CXBQLDcqUxeCSBPv4ysaFCxXB38H7KAKrzJk1438y
33541	payment	1397	1397	1678	1	1	13188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LXULgrL8Ms47tjyddxDvFkeRNzy4B3LY2MGBnW9GdkgjMbCc
33542	payment	2134	2134	1874	1	1	3685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsrBxzY1wM3ADq59Z5Lkm9ZFWtwVSEUvS7HcpXwxTkdpWyYJ2k
33543	payment	2133	2133	1874	1	1	3595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCydGU3PvsHeK5RGAfx9E4BCWGj9Us72iLYiRV78KufBJwvVj3
33566	payment	1397	1397	1678	1	1	13195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SoxgdcMqkL6h4UeZjsn8Q4U6C39oAdgfjnShkqyt5LXWrKTz
33567	payment	2133	2133	1874	1	1	3602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvfafUoYxkhmwqphieU54GE4h9fvDfKZN8QoEhCZTVwZziR1p
33568	payment	2134	2134	1874	1	1	3692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxvNJwuQLo5D2Y3Gh5yTCnBg1E7KoHtWBUy9a5DGDbMewA1gj
33376	payment	2133	2133	1874	1	1	3549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRFvRVA8dhHoiqhYYJiQs6BUZ1HxsZ8Dn2Tg1KjJYfhtv2tdnR
33377	payment	733	733	640	1	1	1	718998000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm99obvLR66pj5Q6XKCnbVL9okCCddY2aWxjeZqQ2W3EeQjvyc
33378	payment	2134	2134	1874	1	1	3640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EQyZksAC28TWetHwToUjzXi4WyBsycKWSxZq4JvNo9Zn3Bzk
33379	payment	2134	2134	1874	1	1	3641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLHNvZY7YJJvB1wUVPghwPBMLry3N2oLGazoPVnWsTnvx7Qxz
33384	delegation	733	733	733	1	1	2	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKw2HSj1T2iN5RQ6WC4JHuSfwtZ6pvnu8BEQbRN7Tw19R1Zdz
33385	payment	1397	1397	1678	1	1	13149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCjpdumiZJANTLgEf51cKn3AZhU79R2wLMHc6yHxMmXXMXAyc
33386	payment	1397	1397	1678	1	1	13150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7G4A93XKaJt3nN5azR9HSNEYZ3618tTYv5qsK6KAVxcNmFDaG
33387	delegation	1899	1899	563	1	1	2	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCS7Fsqcj1kyTEBRmvH81MvoUPv2bGmGHNRpWeBjZ5ueimzMQF
33388	delegation	1740	1740	563	1	1	13	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvrsLS7e5VRUGrt3ZmoEfqo2bAX2VaXSo6dqhTAjzMdMAsTPw
33389	delegation	563	563	563	1	1	15	\N	2000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaxuRzLXDRYs86Wg9TsnZk51G9m8w1XZK5Zha2S7PCcZpZsru
33390	payment	2134	2134	1874	1	1	3643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmV1J2JmGkwzggY313nnYuXpQN31RCU9wkvUK8CvMiHpJiQ9C7
33391	payment	2133	2133	1874	1	1	3551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNR55LCN2WE6zBuptgBZvJr5J21UE8jgB8FS4Yh9Tuh43NhzJ7
33392	payment	2133	2133	1874	1	1	3552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmvXCR83o53immPKTqS5Mf9knvQEuBgKuJTuDPTs8jobNaaY4Z
33393	payment	2134	2134	1874	1	1	3644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGub3DHJHczLFa6nxrc2XE5RLvZyRDwAMS55vAQFHgRNuLtfW
33394	payment	2134	2134	1874	1	1	3645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMF5eTHhkVuHrRGaUB8zBAy9Y8ZDaoSkcAAm6rwxame52AQhy
33395	payment	2132	2132	1874	1	1	1021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUH7iSH5fGYncspSA3tvXyaYVud8iJ5SCDFCNANP98iAeuqwa
33396	payment	2133	2133	1874	1	1	3553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABTWezVZyfWdexpmbHcah6NCWWfaVZSsxoe6NtsCrGo3Si84f
33406	payment	1397	1397	1678	1	1	13154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA86ybQ8YfBEUFMsk6RdTMf7tW7QBFHVSbPCzzG1CgubwaR7wh
33407	payment	2133	2133	1874	1	1	3557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBu8MhHzMs64gbFVBafSiavGXfynZt3nYvD7bGPP44YRDNQhuK
33408	payment	2134	2134	1874	1	1	3649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPLsiGKwg8gZRnfPT9GLFaiT277Z7pcnr4QJ9VudMq8w4Qjs6
33409	payment	2132	2132	1874	1	1	1022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7CBFtSS6dg5qGcn25ZxypFrGVF8LyzSTbSLe7cj2nVSHxXEB
33431	payment	1397	1397	1678	1	1	13161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6wjT4pLCfqe1uYDRQAsgymg6b633XAvV2vixUeWjPkfwecMR
33432	payment	1397	1397	1678	1	1	13162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgQ122LvhHpLCMVABVjzE4jaGuQuJD2Xkw6CCbQJahkypXKy2
33433	payment	2134	2134	1874	1	1	3656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQQfP86iWwAep1dp3dmrzhKhkiQRxhp6ytYQ8VBaBWXQ47ZEW
33434	payment	2134	2134	1874	1	1	3657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqd3HzuCwkREAzLhUkrbJXajCqS5ngcaAS7qzcdq41JstJvQXm
33435	payment	2133	2133	1874	1	1	3564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FMxxU1Xt6uUMQjae7TDAr9mXMNU6AgWqXEKS2kr6QpZ65RFz
33436	payment	2133	2133	1874	1	1	3565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzt9fs8trYfnCPfid6JBUB1RJwABpsvYXNfT5bvSoGZ3BTruki
33437	payment	1397	1397	1678	1	1	13163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvCTyMU67GZcHPR16z4mQtPfzEN6X4HgQFSoTkCgpxnCv9pPZ
33438	payment	1397	1397	1678	1	1	13164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjA5hqYfBzW1RMfqYiZg9eHEULzkFbCM6pBmqDrSynUokTAaVB
33439	payment	1397	1397	1678	1	1	13165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpq4U2gHVhckauVx1skEPHsrH55aWaFteH1YzUHmEpMPXDXDXK
33440	payment	2134	2134	1874	1	1	3658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoMqytpUsAuhBDWASJt6REsKVSq6qYytRndjGh3HeD3ThEdZTR
33441	payment	2134	2134	1874	1	1	3659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbAubxCyBAcNjPTXXwrHafFuL75r8HACZjTCxcax23TtitcNrw
33442	payment	2133	2133	1874	1	1	3566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vfngqf7SQugrpSuuDNbVdBBJEvtfkgvgnNfuER4Zb59pQoaC
33443	payment	2133	2133	1874	1	1	3567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW69VnaPnuXwRUiB8Ez3bNScAW9qoJaah3SfQ1xo2VuXGAFkKX
33444	payment	2133	2133	1874	1	1	3568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JWtzkSkaYu6Dm4YatzT7UjAmYpt5W9Cfi8mz4Y8nfeZrWSWN
33445	payment	2132	2132	1874	1	1	1025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FGG5Svv3dEZn4PZ9uArPRW9Xq4B8GTrMjS2PXsLUXXn2dima
33462	payment	1654	1654	974	1	1	10	2462000000000	100000000	\N	E4Yj5AfhBW2Cdd2TGuxqbeLPY9jT8hXktXJy12LqEt1nvHb2fTYfu	CkpZZaRzbjvRd9xetsziTH4CN19biqh55XQkJfmgZLU8yqvJsoDfz
33463	payment	1397	1397	1678	1	1	13168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1nvit1JsWyPsZDGZTorJzfFoah79WxCUqUatKFGw9rL81iy6
33464	payment	2133	2133	1874	1	1	3575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpsfFg3B1fK23p6myyzAqr6WNjzwsxGeAtTd2MbxWbxE1nmKQ
33465	payment	2134	2134	1874	1	1	3666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGG4cuxToE16NUHJSjzatHVVvak7Eqd2GBHpSrM7pRbcffbWu
33473	payment	1397	1397	1678	1	1	13171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipgKr3XvqQWbw1XQBzC4doBXc7kZxCBjJBKJ97E9RzWMmwbDh
33474	payment	1397	1397	1678	1	1	13172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JY29qwSPZQZa2YFWbdVnXszgMZC5VXQEepryqLELvUdQHqog
33475	payment	2134	2134	1874	1	1	3669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKQ5qEiW3YEsstsFVwKbEvqKupxssMQGMQ7s1TEdxTUpoPigQ
33476	payment	2133	2133	1874	1	1	3578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQC9BeHwwFTBbHXmmVqEs8ZTytbE5wTGpDV6o48SQ1waNbPrae
33477	payment	2133	2133	1874	1	1	3579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZThXY9difDuHuok17iGn3RXowuP2CAs5z4n8aaYsBfTNxLnW
33478	payment	2134	2134	1874	1	1	3670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFvi9Ya9UQzWXpUTd1ZgehfsBSgi7PhyzjW5ubcpCni9rRnf4v
33493	payment	1397	1397	1678	1	1	13176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPxuboZj1jAbiekzvATDZFXqaX1oh8i6NU524gVRvJGL4kdrR
33494	payment	2133	2133	1874	1	1	3583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMvHZoMrAPKnQBP9XXrRBrjjgazA3k4u4MZScF3irrFPysXY6
33495	payment	2132	2132	1874	1	1	1030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1wTFn6kcUg9stx4Nfj8xTxWVrps4RKJDZY49EarPyAjcQw5z9
33514	payment	1397	1397	1678	1	1	13180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGMNE7bT7vjwoYRMyHR4tVVzmq5kpPfVozsfovis4ci4GMFiv
33515	payment	2134	2134	1874	1	1	3677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ3yiRJU9ephzsg5T56UnkZE2gQG5AyvFbHqFdh9kftLCordj
33516	payment	2133	2133	1874	1	1	3587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfKXd6Xxb11ybpKHYGFnD3SNuTghyUVsMZwi6L43yeXkU27pv2
33517	payment	2132	2132	1874	1	1	1031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TpfGYGZzD3ZGNVatbmUrkwHcH93efYWifpR398WRcsDwfoU3
33524	payment	1397	1397	1678	1	1	13183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5436aNJqWyaXsgrVE59Fu7HedfWwSeg9WmHcMzDgQ3DXnb94
33525	payment	1397	1397	1678	1	1	13184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTYeUNKB6PHARiTUM2gUuoQmgtU2mhtVRpycNGF9hEwqJ2DJM5
33526	payment	2134	2134	1874	1	1	3680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4LiutP93aEcsHvuxWYSHqeF22Cx9p59urNjPEvUSrxcHvrTX
33527	payment	2132	2132	1874	1	1	1032	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SVBarBCp41BDAE5epaGmJBcSwNn9V1jS4U45Ea6Ux4jZ5F9T
33528	payment	2133	2133	1874	1	1	3590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9je83UeKfFNGwZrMSdeYmNk5dpexLFjrbJvUmi2ybVuRtqkUY
33529	payment	2133	2133	1874	1	1	3591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCTmTAqG4d3Q56qNM6LZexUQM97CWWoGooStjrhiSxCW2DKRG
33530	payment	2134	2134	1874	1	1	3681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSJL1YN6eYhzX4nKxeG2Dusc6Y9XW55msk9C9h64RNm1D7Dgc
33537	payment	1397	1397	1678	1	1	13187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw3VfWu41kyekMthtrj5wKDnKWqsUfudRWhDpH5soAHbmCEDUY
33538	payment	2134	2134	1874	1	1	3684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPujAFuYvTm6PrpSYR3zXeqQyHNPYBkSmaPPmGm8bwsu5icp3
33539	payment	2133	2133	1874	1	1	3594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPimUjmTbdAsM8oCmxw81zqFk6W9bpy3qKSrrJpXSeXw8ZDXjT
33540	payment	2132	2132	1874	1	1	1033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjniiyzh8GhmUfH45eBFvsksd1see39HAZK1fkiYEotp9FXwu
33580	payment	1397	1397	1678	1	1	13199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3c5Hj8tKtdQKbPzAEN7Hv4VZ3LC2TFGdJRTv6sL4KPKDkRER
33581	payment	1397	1397	1678	1	1	13200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjV3tkAAVAMeHKS15yrW682LpSnwGXyGz7USupLd6rmyzpUYgx
33582	payment	2133	2133	1874	1	1	3606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUbztdndVU4ZmKnXMHPhiUKWW7yNeWokUXWNLZupF9VJHyGhk
33583	payment	2133	2133	1874	1	1	3607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJkaKaLtXA7s5DNtvTYMUGLBXDwsijxHofAPFHgMmXvT97Mu9
33584	payment	2134	2134	1874	1	1	3696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYXcjrwAopMdw69EMu71jCj1MuC8vrHPhd5vC64kNgjXRQRTE
33585	payment	2134	2134	1874	1	1	3697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcgrHmMG6Pq5m8XCYJ1U5FVxaJC2huwYQjUYAso139qqsow1B
33586	payment	1559	1559	1353	1	1	7	6755040000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrLeHawiV5DKtWJzWYF9AZQpGBwap5fQ6qsEXUTM3ijMeZrHG
33587	payment	2132	2132	1874	1	1	1037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPs7gyJw8FfZaUp3tAAnt98nXpGUspbeQKRqwk4yocTSarCbu
33591	payment	1397	1397	1678	1	1	13202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL1b3uPvnYmforkheea4wHg2X44TpcorGk2kPMZ9NZbPJczRUc
33592	payment	1397	1397	1678	1	1	13203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikJyVK7yBoMPtap2W31F9QuMYqUwWdTAsPeDL6zSeA9tPD4sr
33593	payment	2134	2134	1874	1	1	3699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkaUsoDjZx8kjw4pFSV61MSzx9YQaznqwa4gfdi6aQDBNTVhd
33594	payment	2132	2132	1874	1	1	1038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcedvYowJhJfsWAAK9niWVpxi5AAqsmngr8vvX9YwXQiuojJYX
33496	payment	1717	1717	920	1	1	4	2969746104288	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	CkpYUCuQjJpf75DnU1CBbvMejHv2TRYWfZZsdvQo4v7UgmCrF5as4
33497	payment	1397	1397	1678	1	1	13177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztqCGNKuxo8mTFA34oPDKsQNpt5TL8UnS9fhgMHXALNYnm44N
33498	payment	1717	1717	1040	1	1	5	5321759574112	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	CkpZi6iYVeQ9tqJr8ydg2M4tfvddVqtotRvovEg3ePUHJiLnnfjnB
33499	payment	1717	1717	1160	1	1	6	3590697228192	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	Ckpa49agSbpULbnKThJzmzux5bNjqNbeo8Nk3WkSwLN6kLXpqd58d
33500	payment	1717	1717	1286	1	1	7	10005797093376	10000000	\N	E4Z4TxNqXutXZsCkg9szJieyHx5TriBbREFSiRtbjHarr4KEGVVTg	CkpZJeUTPom9DKSMT9XNvFRKPhcEE8RSMxo1Hs7K9ixWm3HPoTJfC
33501	payment	2134	2134	1874	1	1	3674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVZqSrfiqJEdmxMbaJFqgxTrxoNsVa5VpMcP8SdHnBRzGGUat
33502	payment	2133	2133	1874	1	1	3584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzi6FmonpMgLfwPcxefxdSCfPiB9CZWX6Po4cCqkFagmRWN9n2
33503	payment	1397	1397	1678	1	1	13178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEb3wYpHAYyG3MU9k5N8MxCiNrgfVYCFvmAzAxDktQmd5ockS
33504	payment	2133	2133	1874	1	1	3585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB633vkepHb8Mb2zo8Wa3NvexdP8XGkmc9jBYrAVrY7SaXA2bP
33505	payment	2134	2134	1874	1	1	3675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHA1Ugz7hpkzoHY7pAkT5uLUuBSqgr2NJyPUfjzAk5PSSpB1H
33518	payment	1397	1397	1678	1	1	13181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKDkauryieGHkxFnRngQqE1Ph9sEoz5WPKfsZuSjAA412fWfd
33519	payment	1397	1397	1678	1	1	13182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZenKx4NyiV3t8TuxhHQMZ7FWhFFELSLPSyjnoT34mhPSBy3DQR
33520	payment	2133	2133	1874	1	1	3588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRKNFXhzXgrauCM7rdahqCdYpWNcevRAF3uQ9kYDzG6uzLCUeA
33521	payment	2134	2134	1874	1	1	3678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMR1i4ZX2sqDmbReXqWZisi6UcKcxkCbj48iKkhNnKM3BHNBc
33522	payment	2133	2133	1874	1	1	3589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeUunmJC3CMa7uMfgcADimdBBseQ9KZFvcS2fodnFMJtjTvL38
33523	payment	2134	2134	1874	1	1	3679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2qMeimNcxaJLNUH1UNRpbNQyEXyLJQkGfWJuehZqqvC6ZDnPE
33534	payment	1397	1397	1678	1	1	13186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGfJxpEQicot1oZSmkgPY6JuCFhveZPyGxWiv5HDfr2Bd9PgB
33535	payment	2133	2133	1874	1	1	3593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7LsBwP8Zr2azAyCGSGhsbj3kNQiNicbUdacizxNS34u2NLER
33536	payment	2134	2134	1874	1	1	3683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBv9EtJL62iMZnhhu1AfuVvow2xraPN2kQzJ4WGvNRBuu7zVsb
33544	payment	1397	1397	1678	1	1	13189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD74d27YkiYBd8A4yewPwUX4e2kPfkUBdzqJpumTmx3kNS8BZs
33545	payment	2134	2134	1874	1	1	3686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyRXWNXtERKXiec3zVox7VdcrPkkadm2RdswojbhL9MBiLd6V
33546	payment	2133	2133	1874	1	1	3596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCeFnwehJ3jDHApQX7CDEwAcKdMCumxSEmyew3eDL8f5ZHA774
33547	payment	1397	1397	1678	1	1	13190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdcmAMYmYycT6ptjqL2GnffRTyGZSS5g21Rj2kMm9cMRXJSba
33548	payment	2132	2132	1874	1	1	1034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvvuSXfHRaq6tKN6HScH7Ar2rFNsV7fG7bWLpjWhmB4MZSBFb
33549	payment	2134	2134	1874	1	1	3687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Bi5f6jwyqqE3Rai5gtkxVHVAiE8Rt4wwj18EE2SsiWvny2ck
33550	payment	2133	2133	1874	1	1	3597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hZWUBaaUB4iXKFgCkdX7ADKDfr5UdXWeZqSTw2fE8QiijfHQ
33551	payment	1559	1559	987	1	1	4	2004930000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP5fQesWxE8HRAer4sbTiQipFnaJfufYE9ULzrNmNt32Mj6XE
33552	payment	1397	1397	1678	1	1	13191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNUFFy4UCrkb84RgQT7U8fStKULiZ6curgNvRGbJqmWmzDsHq
33553	payment	1397	1397	1678	1	1	13192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAgRqf3dLfqdUriRW3G94HMKftd6E3NS9jWQigqanZ5V2fwqp
33554	payment	1397	1397	1678	1	1	13193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7cnbJb6RT197JcNsRQxD5EKZQ7hhujkQViiuAuZL3n3v33gm
33555	payment	2133	2133	1874	1	1	3598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgPwBU7b8KQ6CbgNURA3tdoSmMhk2pJbEfrAVaoW7nNCpDUwZV
33556	payment	2132	2132	1874	1	1	1035	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4dZ2p5NWxe1yFQHQBtCnLWa8Qkz7csjMtfSW3HgSHEGXfPzd
33557	payment	1559	1559	1227	1	1	5	2424130000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCUAZ4YkifjwUFxhtiHBDzix3kjCRiPTuNrCUpJLVAggLGU9G
33558	payment	2133	2133	1874	1	1	3599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa817eDpc9M6CoyMV5nQcCHnT9tG9ZMwfSY8q2cSvDHzhN3mxS1
33559	payment	2133	2133	1874	1	1	3600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27a4ncuTK5Tf5S862vSoKyPM77YQ8R8XpUwjBmayMw9F3AtCo
33560	payment	2134	2134	1874	1	1	3688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9N2yji6EnehTX9QAfFagFZdnpNtzuBxdzKfNcYu7dgtPjfnd
33561	payment	2134	2134	1874	1	1	3689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgGh8NV615SdSaKjbvdCR8GofmdbXVrY9F1dHQX48rMXSc5kuH
33562	payment	2134	2134	1874	1	1	3690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXbH3gTMG1CtrAcSXXSyVofh5iQW8VVWSQWCRhfnpPPNZC5WL
33563	payment	1397	1397	1678	1	1	13194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk1qvdfa1HKda1EyLkzDD834xwDmMqR31vW37M3Fhn6jds4rh
33564	payment	2133	2133	1874	1	1	3601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGS1RPuF2T3cX6DdJgU7SAbumveWpmFc26XiCUc4dnp1L1K94T
33565	payment	2134	2134	1874	1	1	3691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmniPpmvHpZcHvz4X5cUzrSewNL7LY9QEip7Ed1b1EV8UN86wr
33569	payment	1397	1397	1678	1	1	13196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnVTn3uJ2ALZSsgjHAD7iASqcXtSeC8FET8Q4ioxrFvpMAdgmN
33570	payment	1397	1397	1678	1	1	13197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VKxZ6nZuCKp9xiok3XFXVsoDra1VC2WXYzigXsdDBTaecT9w
33571	payment	2134	2134	1874	1	1	3693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQ5FZRKVRLUVy17i6pLs6GqhJxp44rtWazd2DAk5shvb5A8ES
33572	payment	2134	2134	1874	1	1	3694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2MAA8aHwe2wcKf3SkwZsyKT5aELew8KcDoUhzihHPGTPoWWk
33573	payment	2133	2133	1874	1	1	3603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKnEL6SgcseJMcvCytikXKdptqcAmCLHKzgXGqHB4PGACRBmJ
33574	payment	2133	2133	1874	1	1	3604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMuymQzn7PUzMKN4movqjbESfk38fqA5vfoUuF4tHECquifR4r
33575	payment	1559	1559	1107	1	1	6	3592790000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjD8fwcXfdiTGb52U9YDL6EzBNvu54MWJkPrzeCRhF9cdxW7c5
33576	payment	2132	2132	1874	1	1	1036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrZNrL4Ua7r6sJsM4h8EbvGdcm8bw5gaiKhqp58WLMWu6zwG2
33588	payment	1397	1397	1678	1	1	13201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdbyFUUfARSnM5A6C1NVj8bXGjf8ssVGVkjJcAff9X6Sv2M8Z
33589	payment	2134	2134	1874	1	1	3698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnh8ZjRT7W2zetB4LB7gDPEP4txPvYWsBz3E5wYPY3JN2zxxZ
33590	payment	2133	2133	1874	1	1	3608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTFbuzZyWBiK6isdLiTL4phQvHVsn6hPw8goPtxpytBBD1ExT
33600	payment	1397	1397	1678	1	1	13205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkg8maqZ3uQbSusuBLZkzjcz7SzpJgXaGwRhR94sqxXe7wq4p
33601	payment	2133	2133	1874	1	1	3612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPjNCrJh7ucA3iuua4koXRgrMLEd6iVhXZ9eKs6FW64TBms5s
33602	payment	2134	2134	1874	1	1	3701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihGsn9yojyciZN39fCSv1Py331xY4vqrZpGibQBK4T6Fu9D7p
33603	payment	2133	2133	1874	1	1	3613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxTns6Uk3JaZssE79ohPGURyjf9NnYGeFWAg9umKg5CsgQxwL
33604	payment	2134	2134	1874	1	1	3702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqpEeGSRpKkmRJFPTstQhhey5BxF3HwrjdVLoyrnhPawEXu9B
33653	payment	1397	1397	1678	1	1	13220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEC4Eh9ztZC1bVjdDnXfnnVWdD84GU4FS9d5UksLnwNzcdpEEN
33654	payment	2133	2133	1874	1	1	3628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ21xL4SXHV3dZPyDELv7FnHgeJFnX4ibhjimhhXm7iU7LgKdF
33655	payment	2134	2134	1874	1	1	3717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaK28wuY1noywWmZ5LULdGHs3uttrbJcrwLUe9HoVf7PKnRd2d
33577	payment	1397	1397	1678	1	1	13198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHdpKAjYds99CoxzsWxYaTxyatKscVTetUFWdbjbsAeNTrw4t
33578	payment	2133	2133	1874	1	1	3605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdvyuChrHLiQtnSe15Gm2mc7V2DxAJu5ah81Z2vxDDLLEqGXf
33579	payment	2134	2134	1874	1	1	3695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJqhBLaNaz2urntsVt8WJ26TjNjv3gi5W71siKywpaxMS7dA1
33613	payment	1397	1397	1678	1	1	13208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY59xhBFMqDJdK2xRuQx4HN2T94mdwKNqBygV6NfhUNieUEaq2
33614	payment	2134	2134	1874	1	1	3705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhthQMwY1SKbWWeTkguPYpHhJGdX4N7BHKptn4iXPsxUVwtHCk
33615	payment	2133	2133	1874	1	1	3616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzmiTWxC1A5wnEgnnGg6Nnph4tDocevKQxM2QecWU5umJcgFF
33623	payment	1397	1397	1678	1	1	13211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhBKP6ZoRNNbzBc17Z3adszrW9meEFCbyxx8rFGnykif85EtH
33624	payment	1397	1397	1678	1	1	13212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNmtoAjruuvm7iprj2XbJ2ULM2RP7QGPwdLQenM6j3EeT8czZ
33625	payment	2134	2134	1874	1	1	3708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVLi6Y7ef7WKZ3f1D54S5doJoHVSCzRNiRg6EGq8owMYbdpSR
33626	payment	2134	2134	1874	1	1	3709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYvahY23QRgfxiCxBYMrJaaNSVVbyrGbiRD4mHQZRz6Lh16hF
33627	payment	2133	2133	1874	1	1	3619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTXpM5f5yuZKxKtEGprYrTpHrrxktkenHwvFWRHNPmjzCkVFE
33628	payment	2133	2133	1874	1	1	3620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPs8MYVmWdkQukQvykwiT12RzrHtqvoCTv5xLeaVBx4t7krZf
33629	payment	2132	2132	1874	1	1	1041	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3Ayy2vqoSMVZ1GfX3PFehEeWgvj3FtRxvMYKHmgx1kQg8gU9
33595	payment	2133	2133	1874	1	1	3609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rYdzqaEvuq347A3iCbr3MS6RF1xy4tsZxdLtRe95j1q8G4ur
33596	payment	2133	2133	1874	1	1	3610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDMirR8CejxCRXfNUoxGKA3Q1by89tj5Wq9WpgQo4JCoJYuL4
33605	payment	1397	1397	1678	1	1	13206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6zT491CZixiniNVniEFhJ8VkXQugb9ANRPGxuLUq8H588TU7
33606	payment	2132	2132	1874	1	1	1039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxMWBEqyieLTSSLcTcrV9eJn5kA8wMK6hFDKDadoCdFNyRtiw
33607	payment	2133	2133	1874	1	1	3614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hQJ2TgfudL5VBy32A4oFm6FA7mNRZZPjgWCWoCiWYzcDxbyL
33608	payment	2134	2134	1874	1	1	3703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCqVkfT4DJpbQbHBLEVFjbK9N6HAgQdRgTzC5y4iVPU1BDMyQ
33609	payment	1708	1708	1385	1	1	7	9067753615872	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmai15BJju1di7mZuzbHzy163mMtdURxJAaNgLyBz1SAi9uiX
33616	payment	1397	1397	1678	1	1	13209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhM2VHMw3bdpJc1bfo2gypSkcDmmspVcrT295jQV5aFiEnqdU6
33617	payment	1397	1397	1678	1	1	13210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRxLeZTGbNkLdg5bxfmXn2rGdD5rNkGidWvJqCThtbkEdtqxR
33618	payment	2133	2133	1874	1	1	3617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2Qiq2FUg7Uy5m9R3MHXLCzx671BZnE6nE3H4n4SEzre2Pf4H
33619	payment	2133	2133	1874	1	1	3618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEW8u8vpwcRZgpnY5zrXx9v6kYPhCYaQu3KpAGxd8PM8phHmB
33620	payment	2134	2134	1874	1	1	3706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JNifmxtNcxzCavAPfX9VeLgwoPsUnUFP5DjQp4k5D9UXDptB
33621	payment	2132	2132	1874	1	1	1040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrF9oKvUh4JDoDHJvyZsVrwjRXYJzv1D7vWEVxUyF7fTmy2VRt
33622	payment	2134	2134	1874	1	1	3707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtiBPiYmcBxm2Rr4VA8vuVcs4RyYThu8cK7RXctU8Y1zVK5J5i
33630	payment	1397	1397	1678	1	1	13213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYconrkQR42jVxP6eDvhjDu5HacNSuTitNerKUcFBmpN89hzWAk
33631	payment	1397	1397	1678	1	1	13214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aWD8AHFQMwT5BQSp1LopoG5XNH9Uxpuw7CkdP4rw3igav6CZ
33632	payment	2133	2133	1874	1	1	3621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZim7AX9mmK2RgPkLWz7BLYYLgpAKbYG6aHjGJGtASGLrRy3aVz
33633	payment	2133	2133	1874	1	1	3622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2m9HXsf4JgQi15R1F8CyP7JSZLC4UjfdJwXH5cb58qvLfne7z
33634	payment	2134	2134	1874	1	1	3710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QgwjWJhU1B3Zw2j99sJeBV2YzdBdp2N55x8hGxZaH5nZdFTx
33635	payment	2134	2134	1874	1	1	3711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZC6Qpnh39pZmFddFyArExA4vGNNpTwkbXbR4t6g8iy3yXdton
33639	payment	1397	1397	1678	1	1	13216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRbeJngngJyCwLUPvAbeQ5EtzHiFKBPX5Woj44tFzkNxgCbpVx
33640	payment	1397	1397	1678	1	1	13217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLKatfWVSzsj8JLg9U8tQvBJvvQtiixcmW9vy71pjBXjLoBcH
33641	payment	1397	1397	1678	1	1	13218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56QigHv2URk82uwJTnntLXMx5RmdP5TZSXrhWYPQqFG5Q1ocZ
33642	payment	1397	1397	1678	1	1	13219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaxVkViZTVck6zifiDJXX6NDg6ti5p7mYiiHmfNWJaARvxqVx
33643	payment	2132	2132	1874	1	1	1042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwV7pDCnijEGCzyGq1F9iCQgNmebRnq1qMYfmDbCEaqvBwhe82
33644	payment	2132	2132	1874	1	1	1043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmzLdjjhxQfeM1mTHmKMVLdTH27MHGyKNxuc6fVZ4foDwZ4oT
33645	payment	2133	2133	1874	1	1	3624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDAHroRTuZn9e35XJ5ppZb2QhKnAFrw956VF5zuvMFr1nfJQxR
33646	payment	2133	2133	1874	1	1	3625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzVxJHvgCwCd25ciYH17vp4vVDQuaGZS1WfJ1t39EmrXESgSX
33647	payment	2133	2133	1874	1	1	3626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBom2bXkU1dSn7dEr1m7NKYWqpjYzrgE189GcuFJbUfMofYFAd
33648	payment	2133	2133	1874	1	1	3627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9B1fEmNKfaVKkzYcoJzTAY81sm8n2YjQRvwvLxyp1z2jqbum
33649	payment	2134	2134	1874	1	1	3713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzqu3QwHB3rmqk2WE5ULaUS37LbAMM8otawkKxTmPwzSrHYosf
33650	payment	2134	2134	1874	1	1	3714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5YJd1Y6ePQG5pEQtpkHMZaGdvWVCsn7aM8ikYp9SgdmTLMkj
33651	payment	2134	2134	1874	1	1	3715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACmFVXQymKNgb9d2BARk89qMaNRdGAC8MSZGXJFUVnBjr3KFX
33652	payment	2134	2134	1874	1	1	3716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaVTqFHJ6SG7F3h8whniZ4Hgsi1yBZ69U3D2SKeKZoy4vrA2A
33597	payment	1397	1397	1678	1	1	13204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfq9CLxPr25xa9ioYCyRESiG4gUvSzXetjK4ax4JKWGeaPVM9d
33598	payment	2134	2134	1874	1	1	3700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjR67bR5cf2AukGSMtnKdEoxficwpD9RJYduRPVnbqvPJJEaj
33599	payment	2133	2133	1874	1	1	3611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJbzfVAtZtuW5Tg4icnU7i1you66E6k3JEZJah4y6KvZcLe4h
33610	payment	1397	1397	1678	1	1	13207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfNEHmk1Q9LsA8ym6axBcREUEo6GT8o9djPsXx9jE9wP9tGxe
33611	payment	2134	2134	1874	1	1	3704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirqDTDtHVXPZdM3GeZM2tGZDpNrTxctomF3Y65nxhmXoewmH5
33612	payment	2133	2133	1874	1	1	3615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEM4utTUrZehfUtWFi8vuqVYseEUusx9qHGEsPRkHwMqRN6ZG
33636	payment	1397	1397	1678	1	1	13215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSy9sUC7FEyx798a9KxbJseCf7UAeoQxPSx3kRq9aTeBkfiDfW
33637	payment	2133	2133	1874	1	1	3623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpgM1MQoTM5Gep9ipJawdLSbFBapfYGgSFgRbhzvoDCrNcHBdD
33638	payment	2134	2134	1874	1	1	3712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyD6eQMTuhaoVaPzKTZ6NDAPtEqSE54MWae7yedfjUJjx8apdK
33656	payment	1397	1397	1678	1	1	13221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ3qo3LbS8w9UHc32mBEVD4Y82o6jsgDLoFA7x7VhgSwVZ4UM
33657	payment	2133	2133	1874	1	1	3629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHFL8LSYigMAREmM9yAJbGCdDpZiNuKi2DGAip4THifUBUCmo
33658	payment	2134	2134	1874	1	1	3718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRxUQ6gNzRpt6JVZDoiCpv5E8f2rhTbky4TjzQWeVVk2Hm1NV
33659	payment	1397	1397	1678	1	1	13222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeCsmmp1dD4pXeactdHxShrhRLPAcGmmBq7wXfqMGeY17Sa9c
33660	payment	1397	1397	1678	1	1	13223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfz2zC6Jd54zD8W9xFPkMYwufm4pmQ9jFsu9y2sXimuiUfADiz
33661	payment	1397	1397	1678	1	1	13224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6EnMKk6XrR5KCnPRMBSpfjBqTPPEVDj1rXmYu2XumWPsp74J
33662	payment	1555	1555	981	1	1	4	1458502504352	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZSQQwp1iwA1ZfypoDANX9ZSRvqQtRYmEtMhY7jJynwV558iNoF
33663	payment	2134	2134	1874	1	1	3719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKRsDEqAYJH2yri6NKqs6iCN7HVDue9KYuXmVCz7Pe4fhjGrw
33664	payment	2133	2133	1874	1	1	3630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19kFGoSUphYHKHg6zJeo838RuFwuuRNzYLuschR3GcJJmPK9R
33665	payment	2134	2134	1874	1	1	3720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzGUANr4Gc8rtXTvNc86aUiuHUgCzhAkje5u8XQsuwLFMdwKV
33666	payment	2134	2134	1874	1	1	3721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1WgMdvrHQz8wYgPkWYhS7WmViUsKtvQkMSdQzdEW1exknKtc
33667	payment	2132	2132	1874	1	1	1044	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3whqNWin2d8XwmWzVE1ktStt9AeDVZw3fvaPL97PB8jKqhzo
33668	payment	2133	2133	1874	1	1	3631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBF8bbMonNBvGBSsULEWdR8LMYiEn4YkuY6iWzuC6jLDnQfdt
33669	payment	2133	2133	1874	1	1	3632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4faLqXcbBmqdHg26ut8w55onP8sqLFzzp9qdWYbyn3SFzxMKG
33670	payment	1397	1397	1678	1	1	13225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynyofqHfQ82vCiCyULjmuSJZH3TEhbtLT6EcSReWtDTh9aS6F
33671	payment	2133	2133	1874	1	1	3633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzwKSDXqCBqxZACXjH54zwzHk1Jsw7J52BZgD3ioLVPR687kj
33672	payment	2134	2134	1874	1	1	3722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKJx949FYd6pH1LaqiUAFZFxcdsK6KsMJTKpPpJhZPUKbm6Vr
33673	payment	1397	1397	1678	1	1	13226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtbgmmPKPyxN24HXLmM5n46DMcXJTr718DC3st9ashCQVuXmy
33674	payment	2132	2132	1874	1	1	1045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4roxmdWFMTHRuCZuLPsGUvKw3VGTLHECusG5WaSVatVFJcYq
33675	payment	2134	2134	1874	1	1	3723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2bxqMe83qdWr6ewiJ1p9EWH9dynXDRYsJGYz7qVC9fXJCWvQ
33676	payment	2133	2133	1874	1	1	3634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNLKubHn7RiYk9K7X3yz6HApuJNbRAEEPCx18oPXTkiaHLav4
33677	payment	1397	1397	1678	1	1	13227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvup8JVemt4cbhWPXnFfP1XzWFZ8Xk3C8aoKMn6SHbfH41qJN8
33678	payment	2133	2133	1874	1	1	3635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSG8X81EgJYBBRi9kE83PHDN23tuFkNCjLXa7VUA67Pa68VqS
33679	payment	2134	2134	1874	1	1	3724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPjsBTKMojiiUPXBZBzQztsdfzyWBKeu29ZM1RcmJKGAxjfyV
33680	payment	1397	1397	1678	1	1	13228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZf7H7ARMjEqm1kMCRtLcx2gq2jXtHcffzaoeseHoaM9jh6NCY
33681	payment	2133	2133	1874	1	1	3636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBVT3SoA9hLWEK3DnExBjNzHbMXcN8foNGgpV9rj5GJRfWhKC
33682	payment	2134	2134	1874	1	1	3725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT5XzgZGMXxyyiVwBNGyuWiTU3vAWBLvgRVhPWE3J2ZJ5Z89Pm
33683	payment	1397	1397	1678	1	1	13229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZTTZLnvtUzQXkEPKqCi3h52mob7Kd2JcvJHRWqr3nLvzfKAR
33684	payment	2133	2133	1874	1	1	3637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP68yK73oU4F8psyGSPWSuDwkdZKEW973wMQEXacwUNTfpBRPS
33685	payment	2134	2134	1874	1	1	3726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc2gd7J7esc8Fyn61Gc1jBmfqhjJpC7UNS5m1495rhetSkpV9o
33686	payment	2132	2132	1874	1	1	1046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdREbPEM7CzP91z9PCJZEA1yYmjiyHeZNhFbpfZyjPsLdEgTr
33695	payment	1397	1397	1678	1	1	13232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEULUrY9GnKicBcTQa59whg8wvxLwphbFEhLLAqN1UNaqBupo
33696	payment	1397	1397	1678	1	1	13233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MVD8UJXZjCRMeUAWNA22p6n2RRwN4V8AN4UFwVgp8RNibGok
33697	payment	1555	1555	1221	1	1	6	1763464187104	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpaJ7mW9KP7y9XjCpj2ddVACRaRaNaWGUUWrdeyAQaPKdwGY4W7Z
33698	payment	1555	1555	1347	1	1	7	4914049755856	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZyiNxoNKK2Qj3JcADA3TaRPa7ZeKURoLnTETcPkqFu97f2sbWX
33699	payment	2133	2133	1874	1	1	3640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSjM9d7bkgxpvRPALkvSUsoELHz1KhnNbAeTWW1RoR2W4Stoh
33700	payment	2132	2132	1874	1	1	1047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRGPwkrmr3YqyFTYrDqskT9dSRLz6ZwpeQDnvFszndYxHr6cJ
33701	payment	733	733	2295	1	1	4	717700000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VqvZNDhi2v4wjhqXz6ySXuFhhDGssUCFq7VcD6GTAtzohtga
33702	payment	2134	2134	1874	1	1	3729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqN1wQhZyW2SpqwQFuyW6jhVQqduoqvEL4jTewSapZSWhwv6t
33703	payment	1657	1657	1098	1	1	7	3578560000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvhKwAwnZRPSFrNQfE7f6Frf6eJ6hG2kZ3fGuCCujpJcvjqBXz
33704	payment	1657	1657	1218	1	1	8	2414530000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLJuLS2LBEgQMU5pQTihdqR22ghqCJhMUSusbhLwnPd2VKPzr
33705	payment	2134	2134	1874	1	1	3730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUhbmfRZjfzYVmACcKGYjP96Tv3zbNsioAuWpVWQW8sRzUc2R
33706	payment	2133	2133	1874	1	1	3641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86hu2kRM7jfy4ry8ejGuf5Makso7KRVJGo6HY1i3BANwdree2
33707	payment	1397	1397	1678	1	1	13234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUUCxJcASysjwGUBPaGVPoAABDXerjdMFNAYMEUWhmdEuRGKN
33708	payment	1397	1397	1678	1	1	13235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFEXqijMMZQJWpSHxawHFoiXAm93KT5Pm1Po1tbzNcobDKYJW
33709	payment	1397	1397	1678	1	1	13236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSL3LDhSNQk74myhzGtgV8Cec3voM9eCT2GKumWKfK76XQao1
33710	payment	2134	2134	1874	1	1	3731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs7FJu3Qnds8GburrMT8oAb4cCMRuGQpbAMX95CWWVR9GpxeS6
33711	payment	2134	2134	1874	1	1	3732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDxQKpgmMUWd5Tx9rAZSZw1EwkW8EkNErB19zCswmnrrtnaHU
33712	payment	1657	1657	1344	1	1	9	6728290000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEX94u97NKVYymtQn5gkgzQeZwh799HCEsLKvu5Ppu66aTBZ6d
33713	payment	2134	2134	1874	1	1	3733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5bVn2CQRdgvt4xkhSqSu9teWBNVxew2xrfT1vpLyCMUkpBCA
33714	payment	2132	2132	1874	1	1	1048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBGnPvfjmoGcpTQEoiKtK2bHAfhGGefjrtqnhPFrzctaoNy4g
33715	payment	2133	2133	1874	1	1	3642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7CmxEJgS4onKdLhjHbrECRLm6XjZA7scJB4va8M5WdUy9MP9
33716	payment	2133	2133	1874	1	1	3643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVd5xuWmZabnWvcAyyDP55kMkSKc9E1BVZ9rCzsrNe8Bss3fVg
33717	payment	2133	2133	1874	1	1	3644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBvAXvVybQ2UZXznr1uERNiGmjrPdnEmJCUGg6MQtabCYfpSHY
33728	payment	2134	2134	1874	1	1	3736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWSZE9vCCM5ukpyX9dfv9oFrLNPHKDZRyJKUYexJjUj9pk8NQ
33755	payment	1397	1397	1678	1	1	13248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoL84W7mjzgspNhNfG6tDBCwHTxurMdp4KQt8Muuj5iYa51Tff
33756	payment	2134	2134	1874	1	1	3745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiC4aTMxMQdJiadVDU6AyojCtExN5sS9yAdVTio85TEJXGonmS
33757	payment	2133	2133	1874	1	1	3656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKKLs6fYVLjMkyfSf716afQTWczArTngMtJDNPcRG89scMjzC
33776	payment	2134	2134	1874	1	1	3750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5U7cNHz3qoHmEuNTTeEJ9aTus7zbJoaXQjzvjVpKJBQgSo5wG
33777	payment	2134	2134	1874	1	1	3751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7PQZ7vgZDLC4QRWegkSmT6PFpvqJWA5yUMVgB7x944aFvwKB
33781	payment	1397	1397	1678	1	1	13256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPzkzWRYxiBy1HZCYKyNNsDYyFCwNzjRpXEUcXrXXJm4F7g2J
33782	payment	2133	2133	1874	1	1	3664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuGizxGECFFhjyF8TCkinei5utc8g4WZvB6ED5v2u154idREa
33783	payment	2132	2132	1874	1	1	1054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xzxf3SW5XHxg4gBjDfJ5fW51p384b9SL9ucAKSS5UWsxXAew
33784	payment	2134	2134	1874	1	1	3753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXocxQhL79i9FwHFh3opDRqHtQzVD8LtQagWmMXhEMB5A6t2k
33794	payment	1397	1397	1678	1	1	13260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9MSafk3cJQ1dnHjqy9nE3TDzNQodSZYDmn5oL9pX6J39rhTr
33795	payment	2134	2134	1874	1	1	3756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwHxuECqpk6zgZE3H9XuK3R4bBzyoVBMqhnBzUhzEeizxpiw5
33796	payment	2133	2133	1874	1	1	3668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QF2GF6r1fB17hMcFgK1vAQAL1CRsndMjEvRqpea2oakGD9o3
33687	payment	1397	1397	1678	1	1	13230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKSEmt593Y633qjuMzNyL49uXgfRAFNUMojDSzzrTLZDLTnUV
33688	payment	1397	1397	1678	1	1	13231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtJxLDDebtximLMMwo4odzGJoUyZsY3w8voViN4nPPzPhhehS
33689	payment	1555	1555	1101	1	1	5	2613623991344	10000000	\N	E4Yh8R6WoDcSBMscD1uwLvENEa8Xrbs77QgeHS7oVqMeoAEWKnz1p	CkpZnkfD2edrGAYpxCB3YknCCG1Na9JsprP4J7HA2f3U6ijx7iHTr
33690	payment	1657	1657	978	1	1	6	1996980000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5qT9cEtAvDzXV8SzrYK51wY9pPY5WomwRhxVf4SaHezNpgYt
33691	payment	2134	2134	1874	1	1	3727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeyXwYYLyJsDxXDQmJriTR9GscjBJxDZbSaTQYgG6p1ym8pch
33692	payment	2134	2134	1874	1	1	3728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMvZKCBiHwnAmAYwQKfnrNw5ShDiTkDQTHmbLPgx1KgZMERga
33693	payment	2133	2133	1874	1	1	3638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaxjUmKa5nN6bQc7ud6zG5NYqUrCxoNcEjj4oGPS3yaRfxhyy
33694	payment	2133	2133	1874	1	1	3639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnt3buyv9655ckheNUy2b2UoPAC1Ue6HEUeQQqnnvHb9w9dM2
33718	payment	1397	1397	1678	1	1	13237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ561guEvmN5Zd5s3PbS6SH88p3NeSaHy5UgABgc5JmTuzDb6WW
33719	payment	1397	1397	1678	1	1	13238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCMJZAnvaY9ajCFVFv4HWMfikHq1KFRvoSysPTeZeAi2FcvA1
33720	payment	2133	2133	1874	1	1	3645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULLuVeYwvrcyVFyyrNbak1C9RtRpj1FfV4mDuVJfzfu8QP9sM
33721	payment	2133	2133	1874	1	1	3646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBm6RkfgAgBYLp4hKb3u7QMABAdSuuKEDzDn7GTgpVvdBgap4n
33722	payment	2134	2134	1874	1	1	3734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeWGLLsxbSqneyD5TRQv5LHu8xasDXStUxhHxCnPW1CoHvqFM
33723	payment	2134	2134	1874	1	1	3735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkR1z6b9RtdFGW19nPi9S89Riq3kUNMWDU9deFQrA2AdAErwja
33724	payment	1657	1657	2074	1	1	10	1122000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Tu6HL3W4f8ybXsALGJL38rkUvH593NYSRCARN95sPHLv1fYY
33725	payment	1397	1397	1678	1	1	13239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNZHHxP3xE665254CBABQN87yJ73cENUtGunX2Px2WWYGghzr
33726	payment	2133	2133	1874	1	1	3647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwxoSQgD2C9bc1GunfNBABKT1WaoR944NCabm52NYXDFyJ1Kf
33727	payment	2132	2132	1874	1	1	1049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UefTxcSbR8dhwnWcUnSsp72fdpuWFtvfnomVB4CjhV7GTVTK
33736	payment	2134	2134	1874	1	1	3737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VYLSs3ytYufttwD8fqvbbXCK2WXBiQKYbAo8yh67rBeBvE2v
33737	payment	2134	2134	1874	1	1	3738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm6nXBh2276j44Er2UBGvUMkJ7qqZSXcG67g443ZAceL31qHX1
33738	payment	2134	2134	1874	1	1	3739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVKFyEUfW6L7eLAK8Jo5wZgVG5EM1HadGXXihBPbsufo2P1j7
33752	payment	1397	1397	1678	1	1	13247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq6UQVkEntcUXYRnV93MKM6MzMmpS3n5VQ6SF1RFVHeriqTaiL
33753	payment	2133	2133	1874	1	1	3655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoTezwHcCCsPcYrG5AMdtBvfSSE5QUuGKijkbNiCMbmgfn8mj
33754	payment	2134	2134	1874	1	1	3744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJDn7Jf2Sp5WeqtVCWc8U8H46vhPeHMh7NjVzHFnGS8PqxcvE
33787	payment	1397	1397	1678	1	1	13258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRecWCDz3fh1Ymd3aRqbYxhJV8qew9PTPh6EymXWW7pDBgvbFt
33788	payment	2133	2133	1874	1	1	3666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xoUBdk6wRk3GYkuH1yfx4qbvRS1X5d5yD5SnSfBV2zLBTgGy
33789	payment	2134	2134	1874	1	1	3754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqGFhHsSzkMaeSCgdqdmvxoKcdY1ev5Wb6Ud4e3R3SpjnEbsf
33790	payment	1397	1397	1678	1	1	13259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbzo7auojibd6FCdxxP5ubwsQA4B5qNjHrtRHUi1vDJZsNVjS
33791	payment	2134	2134	1874	1	1	3755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJJz9vBgxGkUY1HyRBpjtkXQ7Jy2CudGWGBCx3Q8f5xCLTs8G
33792	payment	2132	2132	1874	1	1	1055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZGLJzv9RATxvJCszjPvWEst7D1S2UTQc2tPFS868rk3GXTat
33793	payment	2133	2133	1874	1	1	3667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vsQtr9c6h7TxDnCjEF9DoNsRGzCsMyximoe4zdHpvG85akbe
33800	payment	1397	1397	1678	1	1	13262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPNEye7XGAKbjoBEf5CH9vL4EX173xH42QnUfuiDttykFFwMi
33801	payment	2134	2134	1874	1	1	3758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqM5VY4AcTH4U7RxCttFoRSyfzURrCHMXzzV8vcedwyrQJhvc
33802	payment	2132	2132	1874	1	1	1056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7GMsbS5eZMzz9kfUUaS21Prw4nidURsfrfN7ox8Rsi5EdsTy
33803	payment	2133	2133	1874	1	1	3670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ9QfwB9EhozYfEnhTHHG7TGwDzWDQBgKbhYkz33g3v6PtEGWx
33828	payment	1397	1397	1678	1	1	13271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1Xs5hStkXNLCchfq4Jcibsd8Nn5DPbUmkxrqg2DLrzQfhEmz
33829	payment	2133	2133	1874	1	1	3678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcd8VXKW9q8G8Pz9v4MX4hB5VHPnNYmSbPEEdPKNc2pEtzF6GA
33830	payment	2134	2134	1874	1	1	3766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuf42jB2C4Acf3L1y49y1e12RejjbBBwCXqekqtNHZ5W6WZob
33729	payment	1397	1397	1678	1	1	13240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgxKG8QPb8vRpigJuKBXABJhe8pTCFcuzQbX573ATitxopFbh
33730	payment	1397	1397	1678	1	1	13241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPHwrTbECFvRuqt6wrTsxVayekKG26kVyjAuGQ83YJ6QzePBv
33731	payment	1397	1397	1678	1	1	13242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ94wKV3HEDxh7UUxLyjgMri11DH6vv79eJiaw2Z9fFM5R4H1q
33732	payment	2133	2133	1874	1	1	3648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHnynW8jiC7XTd1ZWhEdwY1nrCRgX8aVCNycRtLuPRuC6NNDJ
33733	payment	2132	2132	1874	1	1	1050	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CUcswnzeKfjbw9VeY9AHfPGAccn1wBsguDfwaHDMAT6QiZpy
33734	payment	2133	2133	1874	1	1	3649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKb5Pq6256Jyno5QBxxmm6c1EjeKRpQdr2vf8GeZFTbSFXv94
33735	payment	2133	2133	1874	1	1	3650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPQEc7Cj6eb4YbyAvU7e27xnebAuvA6tgXEUqg5TCRqmz78xU
33745	payment	1397	1397	1678	1	1	13245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn5bnZ8Sd936So687cs93rfKhuAxuzMsXF3ru5zF7dQHnGivVQ
33746	payment	1397	1397	1678	1	1	13246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNbTKLNW3Ph98Ywn9UVb2sFC83fNiJwp3ThHHic2gN1DjUw71
33747	payment	2134	2134	1874	1	1	3742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNdhAoJzvGYZG3Rj61nkZYwvMuNRziqQw5uzMdSpo1vN5oznJ
33748	payment	2134	2134	1874	1	1	3743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumi1bV8YHRPpUMxP7dDNc5Dk6xCPFAHHteLnwbGS2LgrHanW4
33749	payment	2132	2132	1874	1	1	1051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqf4SjDWCgF9TnNijSme7i9kvq7zniN4LRv7Y3eknTzhZjoabA
33750	payment	2133	2133	1874	1	1	3653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveSP9bCx8eY61n5v2VUWr7niwWynXqtJf1BuCDmZkrRxdcWcq
33751	payment	2133	2133	1874	1	1	3654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFj25aFKMKStE5wCUdYBeNNwzyTVxJMW8rqYfaQFvnYWLC4nr6
33772	payment	1397	1397	1678	1	1	13253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGXCtJ8mshbXT4LhmjtHAZLq5a2f4ShipX7F7WA52BYHPLFk3z
33773	payment	1397	1397	1678	1	1	13254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHkZoQNKomwKF5w7Cmn4Crutp2WueasL1y84qFBMcahEsugLB
33774	payment	2133	2133	1874	1	1	3661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaMLs5ZfkNEsmsn8AtWhDUpTYeaYZ8vYjurc5vagQWSJBrXru
33775	payment	2133	2133	1874	1	1	3662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtveBDqwvjB6FPWjBbTtgsKGtMnfRfz3San7n3nz2k7cPUkZr
33778	payment	1397	1397	1678	1	1	13255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdpCXvhNnyGEdevaN2gd2DHFMmQHAMqV4nhNYT2oKdLQS75ke
33779	payment	2133	2133	1874	1	1	3663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1nJptrNdJMX4dib6f2FUvn2VPCaJiMQ1qR9v6w3FYWfeLSor
33780	payment	2134	2134	1874	1	1	3752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa977ms76o88V1Ls5v5CWN7BgHadRFXfsxMk4L6iWj9W1aCFhf1
33813	payment	1397	1397	1678	1	1	13266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwbehWL3JSr5gqxe83HZg3WqpWVCKndZW7iniyQUQmMBhziY5R
33814	payment	2133	2133	1874	1	1	3674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QBUwpmXHFBW4S5oKtc2uzYKDSvNanVs1jB5vG41UUCHc5Pgk
33815	payment	2134	2134	1874	1	1	3762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhksqJgRose2T7CrK8EyoJntfG5HxdScs3tU74NroiYuKQ6H1
33816	payment	2132	2132	1874	1	1	1057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUc5DCgYRmvBpwAo8Zbcx33943HVm8o8xbAjRgU3NYaM2hdkJN
33817	payment	1397	1397	1678	1	1	13267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjuVgRWGbxBnqYmVAN5sNrEfQkQc5jr8XnWPVrsHWKq5LVZaz
33818	payment	2133	2133	1874	1	1	3675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VoS22mrodVVBCyQ3RVFBWxqYVfuweCu4b5437wwiCKpLfEJk
33819	payment	2134	2134	1874	1	1	3763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNPGix1yxzME2zMackWZAf9op1u179sQCEJnAQ2skHH8kVajh
33827	payment	1397	1397	1678	1	1	13270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTDFGoLhjda5wEfdZXbfWdSNXmeARLtWZ92LAGaHaifV39HHxL
33838	payment	1397	1397	1678	1	1	13274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuqa4vfTpGda58J7EnapNu8CbtiZhENnBR51kn3PNBsvdp7pL
33839	payment	2133	2133	1874	1	1	3681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VP2eCGhdX7ncYE1Ptx4o3HJBHUygArQoyaMA2gnknsu6WN3J
33840	payment	2134	2134	1874	1	1	3769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Mgko5PRAaPkBr3x1G778hqZjuzW6kaNwBi8FJxKhUjUFyRER
33848	payment	1397	1397	1678	1	1	13277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBSXfxX1LFb5QiFBAyeLfVXwfhf7bRP5utPCQpuhp2ey7U9fY
33849	payment	1397	1397	1678	1	1	13278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nVmgU5taigU1FYDXtzg42sufjGENx9gk2RgY1C4PxkzuwkKJ
33850	payment	2134	2134	1874	1	1	3772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZcHqGL5UZSUvFprdxqcc3yVm2iKPXzHT4zcRUyhEYSV2czcqC
33851	payment	2133	2133	1874	1	1	3684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYZGeTu4YbXDiWCbEQTFRm3tzj88bZz2yrheob264zZ1r5DjL
33852	payment	2133	2133	1874	1	1	3685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNdqEgM4oQuC62KSJenQ3YeZiWDUR1tQWLR6ChY7Ro46LxZC9
33853	payment	2134	2134	1874	1	1	3773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpaAiymM4ZYAoM8ynrdwrWX9YNxtrJ2FdBxfx6CwoZsi5pTfP
33739	payment	1397	1397	1678	1	1	13243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4bXkRTA7u5x7QTm5PiTwfcrhMCfThDrtihB3myC5mbPvFyqU
33740	payment	1397	1397	1678	1	1	13244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6erEofnFX56usFTvkoArrCqssZGR1Ac4qWHzZtZxLDZH4iYDK
33741	payment	2133	2133	1874	1	1	3651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaG9qFZsGoWETZnP92S9eiGHiFpUYeXcF3seDLkRkey2PekHQU
33742	payment	2133	2133	1874	1	1	3652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSzZu65eEBLuCjQsJKhzCjnFyd5maSuFxiALs1bkLN8p4izkR
33743	payment	2134	2134	1874	1	1	3740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZknzyi1ej8xREBvnqoHc87WL5sA3pe913q3bWPeMWmAtW3mWPu
33744	payment	2134	2134	1874	1	1	3741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1iY9nGnnHEAM7AU7BkVXGcN8RtkjZtWQiX98MPygiNxCwZz1k
33758	payment	1397	1397	1678	1	1	13249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQELnEjw5caHaLuUK3FoCtV9ocD2mneqS7UUrfjUWFq3CoSznL
33759	payment	2134	2134	1874	1	1	3746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5oCpGiahFE5KvAPRtPWaHRzazaduCNp6SEzKBSvDyx7zfNpx
33760	payment	2132	2132	1874	1	1	1052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2YgoTxBjK7QijLwqJe4ZfixiycLtYRyy54DjBmMXFtgmxtaH
33761	payment	2133	2133	1874	1	1	3657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBjKxtAMSdBAaA3T6B2MTviGiSNskEXib6Z9gPK6AjCPjNUiv
33762	payment	1397	1397	1678	1	1	13250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1tfgK8ix6z8NcMyQPc1d16RUz4QWVnpbX5WN2CzZXXNcyJCHv
33763	payment	1397	1397	1678	1	1	13251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNiHvEnc54wp6Mo1CrYh1mx9BG2vKFcB6xuRThaCVmXtUeBHcH
33764	payment	1397	1397	1678	1	1	13252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8PE7foJwQ7ue9xiTn6esot9sBgxA9HAZ5DB7NM58qfExzDGmP
33765	payment	2133	2133	1874	1	1	3658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPALAToQ9zwFz6t1JBdJwqyZ9oGt4tZPG9q2oaZ9ymRfFUbLi7
33766	payment	2132	2132	1874	1	1	1053	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRMY6s9bHJvxC36ZQMCLSzcTa2YDRRvyD4CeE6u2a3x2XKBxm
33767	payment	2133	2133	1874	1	1	3659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxvGXULbgAxCRSuaKUS4JporkEPVtX6wi7RyJXSQZajp3ZE14q
33768	payment	2133	2133	1874	1	1	3660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYVBVrjSFPsxFPSVUH37zgqtbuWyWS4hiAy97ujkf3HbUFbPT
33769	payment	2134	2134	1874	1	1	3747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4kjAQyDnDB5WScrnKk5CEvXzLhzUmqGjMdVokiv9LvaELgwR
33770	payment	2134	2134	1874	1	1	3748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdMtB9RRog6bjLjvCXQiLf7NMFyEjFt6SE3tVvpvCqCmq8W6a
33771	payment	2134	2134	1874	1	1	3749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhTvd3DCCRLRPwtDNefvbhs6CAH53rbRsHgFkHk4JMiYmnjGuf
33785	payment	1397	1397	1678	1	1	13257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16JNor8kpcH1txQUfCrwhqE9UtkpbFw6mKwAPEs6jP4ECA8xJ
33786	payment	2133	2133	1874	1	1	3665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7A6wGyKWdHQJkhBN1RSLEAz3JZ9YWA7PBCh2YCTE3UrLcgQGM
33804	payment	1397	1397	1678	1	1	13263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmb86oFKsG8F2ZnDenLLy7ecXB8UDG2XkV3qVTHrheXKRM3LBu
33805	payment	1397	1397	1678	1	1	13264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbVey24nn6SWQjMDecVYRWcvf8LqmRGrC2YuzGUWNn6Mg4eh6u
33806	payment	1397	1397	1678	1	1	13265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEgiSYfG92b4GPygkizAj19UtZHidDw5z2XNxomJVtG6Y87gmd
33807	payment	2134	2134	1874	1	1	3759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89iJp4tFHbtBz66N2ry6TmdmBJf5pZNDzCK7teVD5LhajQJA1
33808	payment	2134	2134	1874	1	1	3760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDoV4iNSpXhv4EcD7icn154kY3QzhuMFyXbfe4mwmzHSix1Tv
33809	payment	2134	2134	1874	1	1	3761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRsLNtvopRsHWS9EPBYirVPXKcusKoZqc1JHyayBeGj8QQfufJ
33810	payment	2133	2133	1874	1	1	3671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdippo2pLeH6tAm1nXw7R6oizYxN6NP88LcWmF3ZKN27ejFHbh
33811	payment	2133	2133	1874	1	1	3672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKfwYgX44t68ESUYmTN4p9AMGRBdbis4VufFuQk5bPYUXrPj3
33812	payment	2133	2133	1874	1	1	3673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoei4SoStAnVQDx9U8xn8uPPtCRYiZWtbe1FNDe8rJn5A781h
33831	payment	1397	1397	1678	1	1	13272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVauRAd4xJnhb4vNCfbMXuKKmdp89DLFBmZ1zcMyPLADt13qC
33832	payment	1397	1397	1678	1	1	13273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvDFPMixPTdN87UAH2UfLJpdWP3jBaskFDfmLC9jpcihPB7io
33833	payment	2133	2133	1874	1	1	3679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDBh3Y21owpNiAEmEa9QzB46PMtWkxbzJdTQxp5gKTpV5RwXs
33834	payment	2132	2132	1874	1	1	1059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxzbxeD7jv52NNHtLcvqWdMi7tKRzVp1Qdv5iVGWiS4PiKrAz
33835	payment	2134	2134	1874	1	1	3767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa331BDc7FhohMWJHqA2bg53653qFhrDEaybDVKnZco3h7ZfK9V
33836	payment	2134	2134	1874	1	1	3768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2srVimVJNvffPKTwyt6Xy48aVnvsXT94hcoMWYsbGYzmPtqh6
33837	payment	2133	2133	1874	1	1	3680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKANY8BVKVQSJSHbELCFzF9FG4Y9mEVty3gZ9rYVqrAxGYTs9V
33797	payment	1397	1397	1678	1	1	13261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYa15kfQjEnbDuLEEFk8YpiaEMneVVy5PFXuQHoCM3jdPnZ9V
33798	payment	2134	2134	1874	1	1	3757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yKCGRnPdr2zYahFoX1KTF3jnjADMGBo3gUnY8fq9zGXCcwuq
33799	payment	2133	2133	1874	1	1	3669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6abh9FG87ot5Lvh7zR5LftzANyZmysbSjUG8251nAqBfAPmx5
33820	payment	1397	1397	1678	1	1	13268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8H3YNJCNGaK9AnJS9aTVkt3q6koPCnojBrPVB8pLK8EWyYq3
33821	payment	1397	1397	1678	1	1	13269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL7qKKXpXrgVQkBa1th3gS311EwNExvpqrBEHaAu3iNqWtHasg
33822	payment	2134	2134	1874	1	1	3764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6ZW273zeaKJUY9cwNvorPmfKkM7bYMftZQQRu9JXGAYF2ig4
33823	payment	2132	2132	1874	1	1	1058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYkeLQAVKnESDGRKXJpXAGr4ihhLiiqSo87sGSx7UMDrDhH6f
33824	payment	2134	2134	1874	1	1	3765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw368SaJRjheDpDtYvoNBrSiBpnDmjGN4Wd16doXtHX6E4vwoa
33825	payment	2133	2133	1874	1	1	3676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFmkJjfFHnj8fDqFMuBhgXqYkiJrXvnNg1yx8TE1Zcf4XcyfAT
33826	payment	2133	2133	1874	1	1	3677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEY4XvarUvwKMPF39EQNS2oZztQY8xKhZe7aP4W8Q9NF2fmD6
33841	payment	1397	1397	1678	1	1	13275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTymF5njZC3eQ3WyyuCHUhUap31k27jc8dJRZyEo9SXG6Ezsc9
33842	payment	1397	1397	1678	1	1	13276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mAtKSWyUz1jNUjpFahRTUEmMiFnEkh77FWpMi82DnATnzszZ
33843	payment	2134	2134	1874	1	1	3770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLuhMxWgarBDGyfmzYB8i2APK2WvPCKpyE5WHaTHU5xFAYBa2
33844	payment	2132	2132	1874	1	1	1060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAQcbvruQWd2CUtA6BkaEfxJdX2QN5pn1mn4rae88x1E7tgKie
33845	payment	2134	2134	1874	1	1	3771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeAdk29KoH4E4g8hE2bDGTJErhG9AZ4pcR95oUov2dfYikY92
33846	payment	2133	2133	1874	1	1	3682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoDgfYXJZp2w2wtyDwEZjWZYp5JQT3Pa1m4ZSkEqcTpgnDUjE
33847	payment	2133	2133	1874	1	1	3683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7UMiL1BbkVNSijWhThEfTNWmiZwEyBtohoib6G8m6GXkxuk3
33872	payment	1397	1397	1678	1	1	13284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9e2GM7hvF9Up1VqbbWXRhLMi29nWudYqVNUcxj6TSBkJFQ7b
33873	payment	2134	2134	1874	1	1	3779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt599Uy2MSnXhJE5DFyucxyo5zPqr8BXPyz2n2KY96CHB1f9v9
33874	payment	2133	2133	1874	1	1	3691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTpjsB2dggEGqkVK2MfaXJafCtX3FtWmqxhjwMFr4KB4kGZ1L
33875	payment	1397	1397	1678	1	1	13285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttiLZif5qX2qXEW8YMi68MPsGkRsSgambfcSU8PEJqQ11cf8c
33876	payment	2134	2134	1874	1	1	3780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWP9mEGHPrD6KYES3AwmTJ8Dm9Hy4HwEToTiSXN2rT9D9i2yTW
33877	payment	2133	2133	1874	1	1	3692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1t4qEPdm7WJUeUf5Vm6sHyZfjEyESXogrPE6m6jo2wLYhqCz
33888	payment	1397	1397	1678	1	1	13289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7M5C6GDshpZBifRfJ5CGV3jfSY83mieWpvYt1HZ1DBSfr9355
33889	payment	2134	2134	1874	1	1	3784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqr137WepmBsLEic83qar5TFyWMrQdj2AHH5kypBtyVZjWaZEg
33890	payment	2133	2133	1874	1	1	3696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgyaJUGqzbZrJKXBD7XgzmA9XDsMo4xnPTrakQToZYnVHzVq8
33891	payment	2132	2132	1874	1	1	1064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6yDyhdvQ22ahiK2Lqc1GgW5JFPijzv9Mjt4r38xZ4tQKDtZ84
33909	payment	2133	2133	1874	1	1	3702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqneUJvLXfkAWsd7oyrwjJS3PdoHdtqscv8s4xqT7R5fJgp4V
33927	payment	1397	1397	1678	1	1	13301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcz2WRh84L5hzTmJz5E9RXFdYBCDKWdpRiUyg5DmjD4uFNhLR
33928	payment	2134	2134	1874	1	1	3795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKiMT2i2uKYTbtU3FYYariXw9jDkFNa8TciK6Z9EABnMFtNqr
33952	payment	1397	1397	1678	1	1	13309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDUuPmvqLbPm1fKd6iYP5Bq6FHJkZzeEoEr5t7jwMVzY6ELrvt
33953	payment	2134	2134	1874	1	1	3802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKHgn4EWmrNDw5Ked1B7wuT8iaCpB3B9DP949pXjQiquMoT8a
33954	payment	2132	2132	1874	1	1	1070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kqTJcMKoK76LRCpWc3ak3kBkTSo1w7u4LiJesBoSnMegjBrz
33955	payment	2133	2133	1874	1	1	3716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHqZnfNETMatq62SEE2WATU7PRhmjS5b7oY4NWK3v4p4kM2pb1
33963	payment	1397	1397	1678	1	1	13312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMzPE29RRXEn7Bkp9ZAPFio8bzPtux4azDvQXnAwh87yh2tpi
33964	payment	1397	1397	1678	1	1	13313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2m1NSwCrf3AAXZvNbxzyJAGkGnfCFkj4LTyH9zd1prMNYCMbG
33965	payment	1673	1673	100	1	1	11	432510000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpZ2vJHESNKMi3i6S7gh3fWh7FVMfMP6v4tG2dZ6McK1ohVemMPP
33966	payment	2132	2132	1874	1	1	1071	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAab41bFUReEstWqcL6AqJSkbjUyL7MRWmS1hGDTNQEKn3gyP
33854	payment	1397	1397	1678	1	1	13279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4URUoXkFZgRm2eUwNBP7yZD7xLSj9oMzuRSjPt8Kfg7TEBuV
33855	payment	2132	2132	1874	1	1	1061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1GBw7rHDUsAro3gxJeMPy3ijREwcUHNSRDuL7dVMXe74NMMW
33856	payment	2134	2134	1874	1	1	3774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sFfbpyJbeftfugM6AYQEoQNKyb7MjCtSUGzw6jGTedSmrX7H
33857	payment	2133	2133	1874	1	1	3686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTJD1gd298a1G5UVckF59peREeybUpqQQ528Y38T92iscd2oC
33865	payment	1397	1397	1678	1	1	13282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3p8GMHQCkrkCtBvmQ74URux5sbkpHq25SBBDaqV6LwQRRR1Na
33866	payment	2132	2132	1874	1	1	1062	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8AGRWexmrX2MWh3NX4uQBUL2vv1SeEUpsXq7gNmq9G1fvYes
33867	payment	2133	2133	1874	1	1	3689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkRSBMkHD699SH1L8bRUJFa9JotD95Wuxf55MEQXTcCN2coSV
33868	payment	2134	2134	1874	1	1	3777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSUS3DpAK5CQfvu8HGnnhq4Fkd8Ct7CRUVsEhtpUFCLrTM9GF
33878	payment	1397	1397	1678	1	1	13286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXY3RwiRAvzn8VZjDPZ8Wjui5ia8iPm8VW5Lvq7diRkk5eEnx
33879	payment	2132	2132	1874	1	1	1063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZM79LyYyLCJqJrgeyuLiqxYDnSiW2jv3E34fmLyD7mXrQe3tB
33880	payment	2134	2134	1874	1	1	3781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjQwE7wEYjjrTV3XGd4mtHXwxw6zkK9fncmXwQABsvGczSnZh
33881	payment	2133	2133	1874	1	1	3693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKCf9UANuG8J8q2RhKDdnTHtaGv8PXiaCmT1SHr1xfgbguwc9
33882	payment	1397	1397	1678	1	1	13287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQVmAvWQD1pqfDLfgnAhpH5TDn75jwJkY2rrPaiPMijvGeKqS
33883	payment	2133	2133	1874	1	1	3694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKn1gzKRoXpfDFaFHxATBj7eXkdtexvckVxTtTQLK7eXZ8FMP
33884	payment	2134	2134	1874	1	1	3782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4jjpgdi6e1arBCYCCaL9h2pgJA9E9z5BgbndMRQfJ7RtNRHN
33892	payment	1397	1397	1678	1	1	13290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQXszocNUioeAyMEvpGenoDjTLPcapKYSSTWA3bMvPHUiQh4E8
33893	payment	1397	1397	1678	1	1	13291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RqYuMVNVsvMhKHhQzMtUQR7zApeBD4a4Uns6QUwz5he4M7Cs
33894	payment	2133	2133	1874	1	1	3697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRnuf5hvYymb5ukiJWAweS7MBeuvwFNq1kq3V8AaGSwh56sEF
33895	payment	2133	2133	1874	1	1	3698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmznSSCPs4jfJpSrrSQVgr5fdVE7q9ibMGFLoRy7PgnQYr411i
33896	payment	2134	2134	1874	1	1	3785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTHndLjXsUK696u3u1vGKy7xdXqnWNxRopeakaGyFDH7PS8X5i
33897	payment	2134	2134	1874	1	1	3786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKi2JBUzGAaoU5L5i3SNCis2aHjSqiuE5yUrCn7WsM2LzMx3gY
33910	payment	1397	1397	1678	1	1	13296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpoPe2zV6NhQ2csw72eUyGSAxUNXRmot9dq7NX956VYVTpkwd
33911	payment	1397	1397	1678	1	1	13297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBkjDmeXD2Wd9JW1hGDWTkR39qb1GE64skuG3ntCS98zpcbQa
33912	payment	1397	1397	1678	1	1	13298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaG74RygXdZ7XPJ6XkmVvFW6oSqQrN886AqUUYcvdmCKnmS7Km
33913	payment	2132	2132	1874	1	1	1066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenWmt1W9xcaqxBWiaShjdfKAXjfqnR2SaJ6JgfCffu2pbNCWC
33914	payment	2133	2133	1874	1	1	3703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3e7N9cPTN8LtNYtr52ZftqUEMh26QhjLhFKMvfCYLey8zLGvM
33915	payment	2133	2133	1874	1	1	3704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo2ySJpLvoYrrU5XGPXjFRjN3mKB6hrUFKvhKHiVxpcric85nJ
33916	payment	2133	2133	1874	1	1	3705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozBe5vnDeqPfz6kpTpVjMLPHu4SPnvCo6PumndGZT9seGgrUL
33917	payment	2134	2134	1874	1	1	3790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTeUz3Bw5BRXhVZkMSay4bgHHtywQTxAKJXemPQqNm6jc1SQr
33918	payment	2134	2134	1874	1	1	3791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfECgygZCnUrHhQinaYpYsU4fW9BdKPEs62Ttz8vTPR1WtwaJs
33919	payment	2134	2134	1874	1	1	3792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DU5RmVDFdAZW6UJKcZBY9HJ6ttG5QGPemnjQ2Z12vPVmmNet
33920	payment	1397	1397	1678	1	1	13299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYay4CYRiY3Ju8sacUB8onVxGkjRev2NxotTv8hhf5Ggb2r1w2X
33921	payment	2133	2133	1874	1	1	3706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7moTc68E5YX8pPQ8JjC3MpTtKu9dE7FshTEBY3DjPyqpvPteQ
33922	payment	2134	2134	1874	1	1	3793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcMNTUBX1FJcW8RhUygQapPK94hETMXftAchdokDxNv7F2244X
33923	payment	2132	2132	1874	1	1	1067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2rhngm9CMnuz4S5qmthvtHcL42M8JXaFGV1WXAVXwcwFQKrdh
33929	payment	2133	2133	1874	1	1	3708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpxUSVLsP8UrTcjuQ2bcqR18QYTRfMYtS3orK9FdM4ijf6XgX
33956	payment	1397	1397	1678	1	1	13310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBRXif7N1kY5xA562tv6TYsXewWQLr7CcV8DkBGVmKxmbEYzBu
33957	payment	2133	2133	1874	1	1	3717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrn9jUXJs4SexoSnaJRvwhxaeir13vc6a4CDcwCT3YN7D5CAkX
33858	payment	1397	1397	1678	1	1	13280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyaYAT8sJqEdpW18UCdHyi2EWw9vA1cDDpTWUjWXkQD5N5dGXC
33859	payment	2133	2133	1874	1	1	3687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDSoqhv83XnFSzmNdAc8aqgnti2yBCznoaSbDbk7KVGLBdTvQ
33860	payment	2134	2134	1874	1	1	3775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosrf4JvpZGx9ucrh4GdbShCJKc5Fycj4dHY3KTCTSgP7Bbeec
33861	payment	1397	1397	1678	1	1	13281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXWaBWEHUBDeFjg4RRaBD8i3vf4afnDWZASPNZ1Tv89fEkVryj
33862	payment	1560	1560	2199	1	1	29	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbTPTUfSmokHjfd5eX6nyUfsgsv87SaDy9hzRhC62dpzdkjgR
33863	payment	2133	2133	1874	1	1	3688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi6SAqgwHoS7gSWjaG87PSPnpBNpYb5ScpReaW29WD4Tmwoni
33864	payment	2134	2134	1874	1	1	3776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAUAB9Gy28sT1WJKk5zjWdaDfTQWsVqjhxTG3GRGbE9xpta5LY
33885	payment	1397	1397	1678	1	1	13288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtH7FLxHAXjVi3cwr2NzySfY5EuESCzwUgAzNCaKHMpsKvQEKQ
33886	payment	2133	2133	1874	1	1	3695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmrotGEGaP2E9q7XK55uRLALdPuUgypUx1KKAmvWkBc5ZcArY
33887	payment	2134	2134	1874	1	1	3783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nfiHwSFkerHNseCiWgdNf8ABAza12EGLCgmFKHneyggwXVMZ
33898	payment	1397	1397	1678	1	1	13292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLVjCnAvHupXiBr1bZdCUcg1LC8d2bxisQeeReLxfHFyggcHA
33899	payment	1397	1397	1678	1	1	13293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHCXN56yJBLjTLHR6or2F9cguacLxqFner2fhVtcFkbQ4QWSV
33900	payment	2133	2133	1874	1	1	3699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGKk2Cvvgk4cqCPMtQcKPfs7kd33Y74osfr6xPmVA1Qtr7eCL
33901	payment	2132	2132	1874	1	1	1065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsGpMDdAE2VCyFR6qFj5akj9PbGpkXQoWJqkcLMWS9qQFkZo8
33902	payment	2134	2134	1874	1	1	3787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3i4QXU3qd7m8Cmf2t7cVtRyueK1iQRoQDEwV1VhScTBN5k2n
33903	payment	2134	2134	1874	1	1	3788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoPAmNcVGZsYjVP7sfxGd6oi8wzLiuCdZtVnNWsoy9oBsD5sKG
33904	payment	2133	2133	1874	1	1	3700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzkQB9wL7vXHqCfFVtkZcNGZu3sUvAhV9RN1kkG82DrbwxrSs
33924	payment	1397	1397	1678	1	1	13300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZnZqsVDQ9qtEnA5RbdsYW8vNYBrS51wMv7Tve9DjEM84hFHkC
33925	payment	2134	2134	1874	1	1	3794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNcH9oFHtdH4kxuN3GY8GkcQHtZb7Zkm9cptf7p1xaEEeotnD
33926	payment	2133	2133	1874	1	1	3707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBJ5wBihNrRNuKpT7nyWtXQrwY1vzajM4K65W4SmHPuaeRShr
33932	payment	1397	1397	1678	1	1	13303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh3ps6Jph3UKXRrLFvSCwWcrPXZApi3YhdPBZBHt2fDfLDbiH
33933	payment	1397	1397	1678	1	1	13304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCaznCt37ZnKoqYKgH5o1rNjKtziHFgTKznJXnbaAhFaTJcRgE
33934	payment	2134	2134	1874	1	1	3796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdetSsJEoXoXcpMaGhi1DTGLfWHGSbbRc3CJs3NG8FKgTGfBhK
33935	payment	2132	2132	1874	1	1	1068	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEMHnk7vsde6gBJ6hnTCuc4pyhNBD3ZpvgjUWuxSpAeatFdgb
33936	payment	2134	2134	1874	1	1	3797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPjUv61v7dnxB4ND5ufPnUgNQRDnPP66sqfoFpRi75q7SBzon
33937	payment	2133	2133	1874	1	1	3710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJs9MCatgrsM9HTqR4Xq9Rc9vfYUG3g5nynVUmAy8ko73wKU6v
33938	payment	2133	2133	1874	1	1	3711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XSLQ7XnFVaXbwhVHxUMkVBghRFSuFQJAJNKCRjTogyv8XDva
33946	payment	1397	1397	1678	1	1	13307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoKZhjabbD5LCkKD87BNXN3Ef7QvPngR6XSmHxfKkZCUdtU28J
33947	payment	2134	2134	1874	1	1	3800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHrUGHnzjXEnshx7ujxBsXhB9axA3YtM8sukZ6vWkW2zE4jb5
33948	payment	2133	2133	1874	1	1	3714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKUCHCxgyGGYTPT88kmgFQCLzavg5GMwVDiHBW5Mewfh3RkKk
33949	payment	1397	1397	1678	1	1	13308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmAuvN3T3nprsacXqPW52eqEaETsPdqYAfRTAqy22EfQzBrAxw
33950	payment	2134	2134	1874	1	1	3801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfJWtXCgW4C1wunTFm42YHA2NQcwVhfDoGtQ1buMheVP1s6hH
33951	payment	2133	2133	1874	1	1	3715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrPptuqTPDe9qDgoEuhCqEtYGbNQfdnToSQVZZX7MDTRy4W1F
33977	payment	1397	1397	1678	1	1	13316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmo67DfNFn4apxNnoKrsoiizC6r5Y4yDnRzmqSFojkTE7ikNx
33978	payment	2134	2134	1874	1	1	3809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLDKFxikAV2rpR4fmtRR2iNDdCTRbfrVkVmmWhiGvSe76Jbg3
33979	payment	2132	2132	1874	1	1	1072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWsLu5wqw5Dhpc3Ct9VLkjbQpPBnRctbNgUWg34nYaThkRMot
33980	payment	2133	2133	1874	1	1	3723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCoYv9kA3o5KCZ21FPfE16mh252U2NDLCibh748Xuur9wmW5MS
33981	payment	1397	1397	1678	1	1	13317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAW2ZnSNzhWGkEuqRK4exLaAU8BH49WdGJ8k9DtkFnW5onrou
33869	payment	1397	1397	1678	1	1	13283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQgfACLNnozJYTZs2FMo96bL7FerTDynbtVDdHhTUYpCLFQEH
33870	payment	2133	2133	1874	1	1	3690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrwL6M9hGoWg9HipNAmqGHzqHfzz1AytJ5YRWhq5b7MUX89Zf
33871	payment	2134	2134	1874	1	1	3778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5ujqLMKDLGcaq5ipNTHDTYnnw88iuqqrfMfpiZkY5M3FUhCE
33905	payment	1397	1397	1678	1	1	13294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoU6AkbS9e9XBKAoptzfsg5tA64Docnbfe9Kho91inejvdKuqm
33906	payment	2133	2133	1874	1	1	3701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRkyjD6AYGMxS1nEcBh9oasWE9tvbEWhqFfju2iJ1eYrig5TF
33907	payment	1397	1397	1678	1	1	13295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbn92ZMcaCKDJY5hgGfw82RhndfNdo9XXFfomPBbCwfwuapLot
33908	payment	2134	2134	1874	1	1	3789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5VgiRhh6oxCgSN4jeH8zQgdHnbURucvgJr7ujWNwb7QX5edi
33930	payment	1397	1397	1678	1	1	13302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWg6eu3fF8oX861DhCV5uj8t7EWqVGZasNWqZsZodkXUjWFUn
33931	payment	2133	2133	1874	1	1	3709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRaupke4JHqDVpNe5arNL3EShTFrnejNvwP7gTSfw55uZSGDWu
33939	payment	1397	1397	1678	1	1	13305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3yt1GX1mQf5FJD7w8J6i7mTqcgky8c13uChRUw7jMryBj7Lg
33940	payment	1397	1397	1678	1	1	13306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGy7vPSAg6ZvWt4xB1nTjqrmst9couopR9zjs6TUZ8mX6WbC5w
33941	payment	2132	2132	1874	1	1	1069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RLto7XHVny3awnrS57axHG2uvKwPLENrpPLSHkn9Hgdzfpb3
33942	payment	2133	2133	1874	1	1	3712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmi2V3aS2cs3QmmhDCoGaadQ4tbmfAdNMzJWBPGYPGnGgBA8h
33943	payment	2133	2133	1874	1	1	3713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5Sc2AJSZUcS3j8RRZPy4WaqSneHSofusc8SySzR4kazNUr5u
33944	payment	2134	2134	1874	1	1	3798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9C3otBaLhGQQ2MUFEJhvk3HPAvvNgvoR1bGjcPbRwsu6rHvvk
33945	payment	2134	2134	1874	1	1	3799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5G5p7CEX1h5HjMebXMvV8BHXfXiWtYtR92WoVmo2oGs2pYFZb
33973	payment	2133	2133	1874	1	1	3721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhdJdeWegu8XXyVHQ4ZLGzs6ZonNLvEvXUVsrXJbyJ4zgi4Tv
33974	payment	1397	1397	1678	1	1	13315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaR9GrxKwwupoRa3Kfgz9PGv35LDupf3Gn4bLrVRcYusRjaEDg
33975	payment	2134	2134	1874	1	1	3808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hbDwrr9gCCPqpmm2791TvdQccdsvou8eXK3AUgouTPURd2iq
33976	payment	2133	2133	1874	1	1	3722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDambnxpFeKNq94RSFAaLNMvFgGap68te1CsXEA5PvJVGNVSp2
33984	payment	1397	1397	1678	1	1	13318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5Daj8FYKxn3kUF49GTT1s8FGkmUk2iAeD3QwZhoTiJZ79swy
33985	payment	1397	1397	1678	1	1	13319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtv2n9AoAGqEw3W7cybehXYY7oriPG5qNLMkq6HrSyEoJBfAzP
33986	payment	2134	2134	1874	1	1	3811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvxCNxnDBWfiF26UkMdNeCCDbKm5rsMvoxPhJQ5e449gjb7R5
33987	payment	2133	2133	1874	1	1	3725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAsYEzWdMH5CgdQgjhX6P68rVnDKD9hafRDurM8Q3EvWuXfu9
33988	payment	2133	2133	1874	1	1	3726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF86x87wt8aXZTxkubd12YrzZQ4ArPqPait9iQPCmjm6XQiNSe
33989	payment	2132	2132	1874	1	1	1073	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegt876EUvQ7UsFZ6WBocdWVSZXyhkcZX6v2uSK7Y6esPSu8iY
33996	payment	1397	1397	1678	1	1	13322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHZnFFE2JpbSngC4NWr9dscmmxPMZMrdiR6mi99rbmbUuQSfv
33997	payment	2133	2133	1874	1	1	3729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKb27Hz9josgsVwqxwRgmHMbGNXbuvMjowMTvEs4XbxBgpERh
33998	payment	2134	2134	1874	1	1	3814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYbmeJyX7UMhZCkEcRZmEsXn8S4sEj6R3iTTFZVCacKXmyEiq
33999	payment	1397	1397	1678	1	1	13323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgywLWjBJ6ggK6x1GPf6cfTUgkPRdmudLJ6pEcvohWTZV8j7b
34000	payment	2134	2134	1874	1	1	3815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCBJ5cKQq89Zf9sZ74bvnae1he8A1EdqUN7PxFektLB3s4bzEE
34001	payment	2132	2132	1874	1	1	1074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUT6PBDgv5Mv6sHsiWt8RGEzFYFX4ydv7YxJfB6pUSjzPqM95
34009	payment	1397	1397	1678	1	1	13326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBA6joWVeffSHgF1SXUywTHwjcaZ3RssPAEKm4a6MWw39mTC6
34010	payment	2133	2133	1874	1	1	3733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3h5PDXpFoyXmcziqtCvzv9o53RGuaRe4sEjckSz9ATLCRrbs
34011	payment	2132	2132	1874	1	1	1075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQe2HA2jzhTGQGeD9eL3gmw6aTns3U3HC8jfV1CqX3d9x6TXX
34012	payment	2134	2134	1874	1	1	3818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcubsS3dN4cjPxUaQxjWHtbDwxrsUP2VfS2hSS5eSwKN8NgCj
34015	payment	2133	2133	1874	1	1	3734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZad4Ghm77BWaEHMWqMm6NTNqwZEbRiWnChXyWDq1S9EqZcdYBn
34036	payment	1397	1397	1678	1	1	13334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8sn3n46hvmycngQCx2swPfzYToRtbYn6a42vh7jww2DVzv9p2
33958	payment	1673	1673	144	1	1	10	432510000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpaEqpnCud3b9qgUDXXDuGY8gTd6SWxUbVeKd9mQB494bkuVFcJ3
33959	payment	2134	2134	1874	1	1	3803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMmr4kvmttwtiM7dW9mpqB16ubwPESj6J61Lhag8xzYuBUek7
33960	payment	1397	1397	1678	1	1	13311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31oktBkxXxbkiA2M651y9Ldb2msZnpYYE6FxvYD5JBBmGYYR9
33961	payment	2134	2134	1874	1	1	3804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnJXDy1HnNvmrvMNBMraWZ6w8XpE9hgyKY4doRQH7C6cu8Bbr
33962	payment	2133	2133	1874	1	1	3718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk8phPn7oPb66UTVCbvkakWAxKxRKQJXBvWeyjyCtxiNaqTQC
33971	payment	1397	1397	1678	1	1	13314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnT5HBjucSGb61QQyhGC16riyeQeDBsN1dCHmprjT4ToT8tYg
33972	payment	2134	2134	1874	1	1	3807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9B3VQHRZ69xDRwGsumTwZ1sT3MDNqx6ewKm6XEv3dsSckgZuU
34002	payment	2133	2133	1874	1	1	3730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbkV3YT9ZzsismpQUMKxjiiJKkgfoEbodjnT8tGGPNvRYCFT2
34013	payment	1397	1397	1678	1	1	13327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1kHpWLFZvqbpnzTrXx2uSZ7vgbCXn52PYHddkwpFYqUPZp4h
34014	payment	2134	2134	1874	1	1	3819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnAyZ6r2Vaf4YkZct2omRZwckXX1hJgZo5oakoqhPxRWL3SXe
34086	payment	2133	2133	1874	1	1	3746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs25AdFaB6zMnYqVMZeSWiQ4BFU6jSKBt9EyDFzSkjGPd2KZLD
34105	payment	1397	1397	1678	1	1	13342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrvbtJEYjSqMv2MfzKBT9DRDFs4RUTCGyeaXityrwJogizRocJ
34106	payment	1693	1693	453	1	1	1024	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaH4ZEe8ib841Lj55JoNFAQSzCPptGywq8EtvB7qmsWeNwzGUp1
34107	payment	1693	1693	283	1	1	1025	46739092394	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaJVQQYypQ4R5igCRP99Kkfm8qr4ZJgV3uBYC5WxsMLLkiYWmQH
34108	payment	1693	1693	308	1	1	1026	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZBtjXGrJFyH5z9Rp1BKzPfBsdtT39U1HzxbyEB3wo2WejBeMWw
34109	payment	1693	1693	201	1	1	1027	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZhaUUEbkUrsXExZ7617wuQbo6f7vTuvpXqaMd65QRdpXvLP8fz
34110	payment	1693	1693	748	1	1	1028	1418018119	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZEipPu7kxQP13dHahPE5vvwE7UBLUmw2aaJp3g8sobaWKNiUyq
34111	payment	1693	1693	35	1	1	1029	14861574594	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZhdq9bXHw5koMESAJWtTjDDCzfGZcYY4KoSk5F4oa9E3Ruyeun
34112	payment	2134	2134	1874	1	1	3833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJMrr5pdinJRVS2G2VnuauRvk3vfAB6GXTnd9goSjmsq6K2V9
34113	payment	2133	2133	1874	1	1	3749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFBP2CJ2vD3yd7PKXJoXAGKySz9wmc2edNLpif94CsbjRinh1
34162	payment	1397	1397	1678	1	1	13350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwF4bHjQ5zAKnKeoCmFd8EktpssEWkRBaQzVL3WBvVpZvHa1Y
34163	payment	1397	1397	1678	1	1	13351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRL3vG9ruan5XtSW5j4PqFwDecnjwkiwT7LbxqiY12Ao2X1HQg
34164	payment	1693	1693	587	1	1	1056	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZUCWkvu23K2JCmF6KPP7jBXk9BPtiBTQKbhHRLMpDRZBFmmC3S
34165	payment	1693	1693	238	1	1	1057	46738858702	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaLKoKjzCxCAsS6f3Ax5yuVr5mk3SmwD9iDUA5QHgyXXKR36wWE
34166	payment	1693	1693	392	1	1	1058	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZhRzVYkJuZ1vuMqBbMwXXb4MRVUew48dtDK26wpWyKDxUySxWv
34167	payment	1693	1693	578	1	1	1059	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYvy2FibZcig7wwf9hUuWhyvgJZryyHDbtBAXwTSkkhCYTdy8oQ
34168	payment	1693	1693	408	1	1	1060	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa7ejgHAddDank5McAcsuH84WenB6XgdzoCckrhYzLyXwD9tGgS
34169	payment	1693	1693	504	1	1	1061	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa4W6PTk95DGPGeDgwoBn4scR5UQEQVroHELDXABf4cB5Ut2hXJ
34170	payment	1693	1693	611	1	1	1062	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa28qK52iHeBfi8b3ooAtrFDwSsZuSrgLgpegLFXv4rR4tnHehY
34171	payment	1693	1693	500	1	1	1063	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZCRrPmgD9UpECpZUx97JrrqXxE7Ak6ehCuzsNvmAMRgkKimwv7
34172	payment	1693	1693	353	1	1	1064	4148160270	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwqWbY1jEnii6A9suEoTbqWQ8Nrn2cxmUhD5jtuBTkf6Ad3tv4
34173	payment	1693	1693	301	1	1	1065	46739092394	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZLpKMsRirikECnVzTPcg9HeEt77LAotFjWmrEpfrdizfrx6Sfb
34174	payment	1693	1693	601	1	1	1066	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYYtYsuGcRGSV8VxbpYzAhDdhQec6sq3n9pqLnhGY1iSbwsxogX
34175	payment	1693	1693	1276	1	1	1067	1311619300034	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZN6FqyswqoZuGor6W87mkE57EqvXnafmPmueeMSayakQJCqAMe
34176	payment	2132	2132	1874	1	1	1082	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZQ42PcxzhBCmqCfziNMnMByBNHp94MviMNnYwkQ7jZsQgQLv
34177	payment	2134	2134	1874	1	1	3840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBRRZRkDPyKoDt2iVusyFFBqKipexDXQVuZNZiDtMyPVzmHjF
34178	payment	2134	2134	1874	1	1	3841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cTiP4Pq2M3dz61xL1YX3ySCxk98Kvo1URecZNAqYswKqGsPK
34235	payment	1397	1397	1678	1	1	13360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUCnqWCBVv4wJqnnWr3T2AU73HYQW6XtzdrGWB7ixxTjMpKeH
33967	payment	2133	2133	1874	1	1	3719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfY8jBwjaJELdzN5GcoW4gF9WgtUbkz734JioVeivwuppVyUQo
33968	payment	2133	2133	1874	1	1	3720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQFLryt9yWBfvrUzhm4t3zCgtPqMDQ2LM4uPFTNdJ9VCriFpH
33969	payment	2134	2134	1874	1	1	3805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZDfEkDYKSMYsjauQxWXsduENFgJoJ3ddD6LRXixQYXpoZfVr
33970	payment	2134	2134	1874	1	1	3806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqU6dHs4RL5jzPLGZburtDJ2J7xnjXtbFAeJBABpyJJ5HHeyd
33990	payment	1397	1397	1678	1	1	13320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAhfPVLAG3yMbZjC8ruHt77S2Fx6arHYUTL3g8132bkJzQTBu
33991	payment	2133	2133	1874	1	1	3727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbf1gtW67xy1vt2YhuYxvK5BwM2NVpqWKjcF1e2YFCyvrTW4a
33992	payment	2134	2134	1874	1	1	3812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8n78xSW6Zcn41EsXrvmUZwxgTGPfRhG1tw47eHjE1zvPJCGYt
34006	payment	1397	1397	1678	1	1	13325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16bvpADCt5gKt5RgbDypyBcSdtQL8y8CB3GEWc9ykibzQm2Pi
34007	payment	2134	2134	1874	1	1	3817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFNQmBWxPsFv76BcYwnY1k53rLjQuYkZjsVoupEGuTVuoSodj
34008	payment	2133	2133	1874	1	1	3732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4fSdK6WcxcrndfpWTvN5wickEgAnedQbB588uXHj6UyBsCEi
34050	payment	2133	2133	1874	1	1	3742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurbTQsJhX4e6AG9kcHUXwPfcguEx5pGrBSafdtNjDCa5nuMX5
34051	payment	1397	1397	1678	1	1	13336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WuEjXtnby168p2eJDR9N69wNgQ5oGtDA42SoULeTDmpBxCBq
34052	payment	1693	1693	653	1	1	989	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ8JRE3Yf7QSLMbQYzxdpAbJNAxV4JtdbcF2MuzZmmCvfN2iTwg
34053	payment	1693	1693	373	1	1	990	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZXa8uzewu1tWpsN3bXA8XBNw8b2G8upu9Tfh6dwDPZWC4S8s9U
34054	payment	1693	1693	92	1	1	991	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYfetP7mGwR9nuBc4RU91LmjzdyGWccbanomjoTaa9CnihkpJTF
34055	payment	1693	1693	710	1	1	992	3870201712	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaAJ68vQn9QxbRRABA7uDBxD4iBFn7fem8s9gRWv2v387DbGs2a
34056	payment	1693	1693	1961	1	1	993	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaBMShPUWaD96SDJZZMsMABNGPHnHJoAnSFuraaJDhbj8DQVF3t
34057	payment	2133	2133	1874	1	1	3743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyQYvuPQBbf8sFMFKfwuxWgiQKwp3vXGTZcXyKmjTUa7Jm6xv
34058	payment	2132	2132	1874	1	1	1078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtK6XyRgJHhJncgNzXxeTQMvBxEwGbinjQXDTrMewm1UwebsDA
34126	payment	1693	1693	225	1	1	1032	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYsowkYgTertu3HFVLvmh4wNzCeobUc53EKuceyvLsvHNUUe7tx
34127	payment	1397	1397	1678	1	1	13346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn29mt7tJ8svsTcrEae9ZzQSJX2VnQ2M7ZyxBkYkZgB76YjWYc
34128	payment	1397	1397	1678	1	1	13347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEXzr7wyBTdxKGFz9AFPreTqtZmA9p48yjCwCCe9o3bT9d3y9
34129	payment	1397	1397	1678	1	1	13348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgzZE9sEujAuCLFirasLwRUftDJFQHpmsVw9jemDVhrNEV1mwF
34130	payment	1693	1693	2164	1	1	1033	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa388s3DnoQw5A5CfBeLfv7cvZp3r6u3JzMiJ7UhGh4aYPT5hyc
34131	payment	1693	1693	99	1	1	1034	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYTxBzaJmgG7kFAuwLoXBwjzVUhByU9hqZFNmtFQzoFTJpjuvJr
34132	payment	1693	1693	206	1	1	1035	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZnDgRFPdfK5yM8TH7aRBm9hkA5vJEtDr5PWjwjfEXcYwSdx94Y
34133	payment	1693	1693	122	1	1	1036	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ8ggUS4jApDJHCVKKcwUnH8srhdw9vv1pfxxRmZt2CHfWKy6U6
34134	payment	1693	1693	443	1	1	1037	46739020166	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYwNpPb9P81zvTWRhFzPPCMVYZj7PoWAKymW2iHxAj4xWrK72z3
34135	payment	1693	1693	691	1	1	1038	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZYrkE1Geo8omRyhbfu1kBhk4cRhtch3aNrvp74JvVj8YFzSmMF
34136	payment	1693	1693	377	1	1	1039	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYzhQiaLoJ3ssqrPryCxDVHLpr8DwwYcst54H64gTBbWLa22CXR
34137	payment	1693	1693	49	1	1	1040	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZToRUmxmhqFbrNpFtFebTvXprdfS6XaSE3rw6bcMREySWCzXLB
34138	payment	1693	1693	530	1	1	1041	46738815506	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZR4oa8pTMQMQUR9yonyJMuUdDnKqEkqoGuozx1ZtiwFhMCfifL
34139	payment	1693	1693	893	1	1	1042	237493315876	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ1PCbrupVCgL4wBX9gYBtk23cfD8gfVYfAQEvqDX6jjSexi3Vs
34140	payment	1693	1693	54	1	1	1043	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYvxBDhHu1sPr5gEG7jAcnjg2eQBkkSrro8JBuyp2gUvn3nVCET
34141	payment	1693	1693	217	1	1	1044	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaEsKeCXqr31SBriESLqBxHtWDDvZ8Bmkp1bG227FBRAPBaK9Qh
34142	payment	1693	1693	603	1	1	1045	47249337864	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYw4uDjdy5NupUgTAvQhb8U7c88BNHoN11jNYtW5bVupgSUHTYy
34143	payment	1693	1693	165	1	1	1046	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYe8qq9fDgE8ocixvpEF3SD8pN7xVicXFWKL5rE3yT3V3vhXkPu
34144	payment	1693	1693	194	1	1	1047	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYsM9s5Pnm7pv1uzdAnugrLnEqY8xbMFjjkqS5hkjREtHn445c5
33982	payment	2134	2134	1874	1	1	3810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshUGhiATQVem4u1TYWLpKUm4bQxr1sQzTjsATipo2gTnE6oJk
33983	payment	2133	2133	1874	1	1	3724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwek5k2zcdRZBxnLv6ZCTvsBeRsZEQ7y8k6FAxRPTwbwwHjECv
33993	payment	1397	1397	1678	1	1	13321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Vdc3CPi6yRT1tvTFSKefz4Dd33XZp7VAVf6NkewYBffM4NYV
33994	payment	2133	2133	1874	1	1	3728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVBhfeWbqmv8BGbGHfTfsQ4QD27wRB9xoBoJbNupzNHMWqCBq
33995	payment	2134	2134	1874	1	1	3813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5A5F7gejH2Zq6RuLBgJBJKxUyYAeiqKoPnuEPAkxQqZhV7Ymu
34003	payment	1397	1397	1678	1	1	13324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYor9dofNpqKY9NUoKeG9tP6mHbq5oMbhC2XQdAVAK1ZRKM6PK6
34004	payment	2133	2133	1874	1	1	3731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTibYvuChx8n5Ykoaf4Qrt91x4fSp2MJZNnMvZoJtFS3xfxd8n
34005	payment	2134	2134	1874	1	1	3816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtPF6QHLdT4aq6ZNFCfg4w7gpV8ffHdfMnp6EiNQYMPRW6g4L
34016	payment	1397	1397	1678	1	1	13328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3srGKFoFpArHZN7KEkDXRDK7J94HTZotbmcz9fsy2fJFSquY3
34017	payment	1397	1397	1678	1	1	13329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoUSqMpiL8ekm4kHMzw8SdXhdeHg7Ma8vFYrNCkuxRSZ1NDgP
34018	payment	2132	2132	1874	1	1	1076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHmFJia1Haao32jhsK3sVNVWnVVDksJUYsdsWxVWMh53WjkKV
34019	payment	2133	2133	1874	1	1	3735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yQdi96N9a7Y2vkSvfQCDMN5HxPqzpEUojwTQNNBEaepGYnRD
34020	payment	2133	2133	1874	1	1	3736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY3rcN7BLN7pALzVJoqhBGNbc5ziUQsnsJAAjD6aLu2LcEvGy
34021	payment	2134	2134	1874	1	1	3820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMHRgQrjq8hkiH191dd4aRRfcD6a7Zu9xChGDEidE5RNY6E3s
34022	payment	2134	2134	1874	1	1	3821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzhcnm3FgZbTZqYP6jXvhXKxh2GYvo6XdJLkfm4dQtbfLMULQ
34023	payment	1397	1397	1678	1	1	13330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJte2gwcfvwgWeLqbDWxAL4eMkdcn55C1gjidTHCXc4XEsd3UC
34024	payment	1397	1397	1678	1	1	13331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1eyrTyYFCtby3GPnVfdrXPuLMTDxxDX2iLnXzctjAdhdmAuh
34025	payment	1397	1397	1678	1	1	13332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYttmb9Fhx82B3C6boVWBhNbXng7WJcgGciWovy4L95T41aHHdv
34026	payment	1397	1397	1678	1	1	13333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKdbmnPgQhRfrshqdufjrfoaxXVVTDbCPpstLxgd7hsU3k65J
34027	payment	2134	2134	1874	1	1	3822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTksoL2a7E4PTHeroLfvbfmUQTgQ6f5iZ62s1gGmhxuDQQN1Ur
34028	payment	2132	2132	1874	1	1	1077	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4kRGsWg5FhMnEUVR2AJ2taBTJHMSzqqTKfFZiQ31ejs4RtpZ
34029	payment	2133	2133	1874	1	1	3737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Mfq2uxvQau6QiehgMVqjtUdGBRCdhPNPfkLfDwyJUJnmgH2Z
34030	payment	2134	2134	1874	1	1	3823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8H2ZYh1KTALeh7q86gG4Hc7gmmf26hhpwmNw8ddXLzfHaNfqn
34031	payment	2134	2134	1874	1	1	3824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxd52fv9tzftFSbZnUkKH1ZhGLjKB8PbBdkYMmL8TjoiHowri
34032	payment	2134	2134	1874	1	1	3825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwg4rnPUrs9pYFyExQsMw8esgdYPzntw49teQNHWcv1dNpmKcz
34033	payment	2133	2133	1874	1	1	3738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZy4yjKFwYw9H4RaWjKXeuwsjGzPQfwbsQCws74uvJ8UZbHMF
34034	payment	2133	2133	1874	1	1	3739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RBLysNtQt7KWGZirXknmdygeVQnorte4RqPZixkcqWxb9rBV
34035	payment	2133	2133	1874	1	1	3740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdcNquEGiXCoDwy3qbbxQqGHsCaD7itUjbLhPDmuNVS6Ug253
34087	payment	1397	1397	1678	1	1	13340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZXkfeaFdfb8KgBnpjvJmHTs9vs7JXavt2D5Yc2RYHRFa4uvn1
34088	payment	1693	1693	1962	1	1	1012	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ6qUT3ex3j98FfvVa8GJvbeJMwRQg6qU6a5Xum4TYnG1ACRFuh
34089	payment	1693	1693	63	1	1	1013	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZNue3dkJRWFt3WoJEFn2bKun4eQnPawdRf6fs1f4bU887aVTuY
34090	payment	1693	1693	1150	1	1	1014	470689915171	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ5C9t3tnqWzkFKoJUXKEUBSWfJeXN4YFs3oTLGBSy7b6tJAtvY
34091	payment	1693	1693	163	1	1	1015	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYdpDXksBQTexL6ZjK2WTtqEcQAubGsv8zEhJ43ydUB4hyyDH17
34092	payment	1397	1397	1678	1	1	13341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrKKYhqpngS5zTPCJR91YDegZmAAgZkxdj2KT36Bivzfa2Fq3
34093	payment	1693	1693	78	1	1	1016	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZjbpYc42WCosHBS5dGJFxGtF9X2W8tkjZyJNANLinFp2NcDPHt
34094	payment	1693	1693	678	1	1	1017	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwUg1wVDrnw49G7odqZa7jUyqCnL9dE47Dr324AuSAvK7qy45D
34095	payment	1693	1693	108	1	1	1018	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYe1vyjLW6BAQmmjjfkHt4D9RGtpYjFjE7qhcgyBysTpPDunodr
34096	payment	1693	1693	745	1	1	1019	1548080681	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYga5XwWzHvzQ3KG26NTUjWSTHynTrgWakWC8Lcto9REZbFSwaR
34037	payment	1693	1693	2181	1	1	980	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa8V65AV9bNK4m2LqVCPgDutF1GyDeh1bdiSDrAnYjYpgdJoFLd
34038	payment	1693	1693	438	1	1	981	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaA7XubvNizJLpvDmADnkQ2XT53yDcd9Evout2X9Dh4uw3tw9hp
34039	payment	1693	1693	262	1	1	982	46738815506	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYjkqo21zJBn3D6HLeMrCPMHqHanoULqoenJxyeDMDVeW35mvUR
34040	payment	2134	2134	1874	1	1	3826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZESGwmaY6msrrimBz9v7phdNVKKnepvUTWaaminptQCjLbQyEh
34041	payment	2133	2133	1874	1	1	3741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6WWCzQH1tkitXUZUaEffF953aY8hHe6ic3eSStwA4KAHXQox
34042	payment	1397	1397	1678	1	1	13335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzDddinFzM4c1rDZxDc6UL7Pp5bGEqbmeprAcXYJQKJC2ZPpEr
34043	payment	1693	1693	240	1	1	983	46739524375	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwSKPbpcktzfDDottAhe6Ut9dD5bMNHoArNrD6oQGMfK5r32uw
34044	payment	1693	1693	304	1	1	984	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYftWY9x8h8LJetGFMYj1qJ6rMaStqYQ1gNNJQNRmegERWySMKc
34045	payment	1693	1693	562	1	1	985	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZSFAYdLdLzsd3gmgM4swzp9NKcvNQQetKoy2wZnpxGKtsBi5GZ
34046	payment	1693	1693	560	1	1	986	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZHdVXr3ZqbS7MCrn31bQLqSHHjTpTt3cpcfVc5r4HV3DdqbMNW
34047	payment	1693	1693	441	1	1	987	46738752480	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZqJaXUbJpjVrx59a7cGjsoMaxs13Lvjvi4ZXR7zCVvTUzQyjcR
34048	payment	1693	1693	1772	1	1	988	366855802461	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYVf2KSAikR5o6ByPSgsuizoNenR4pCYVjQUFh1g3aPNGaKwpmi
34049	payment	2134	2134	1874	1	1	3827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86j2ypGRHc12vRGaxWCicQ8LEKq3mEP2C3xfvTzn2yyBADqjK
34059	payment	1693	1693	660	1	1	994	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYaWMVWkR5hQEhVx7umY1CWB5jRfV5cKa2YGaqNgwnr39hLKZQm
34060	payment	1693	1693	395	1	1	995	51084516961	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZLbTNnHBq9KCNypFW6keSQ3mRyXaoqPFQCUL9JD2S7a7cJc12n
34061	payment	1693	1693	394	1	1	996	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYzsYH7sNuj4jq3QW5owRWM6mVoxWDS2ufFtswYsedWYqXxForf
34062	payment	1397	1397	1678	1	1	13337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vAD1vBjvRmJpderxjjDS3PqnLYuDBDpewnSxVNSYPt5yeBiC
34063	payment	1693	1693	29	1	1	997	5418282399	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa8vU5uUa78A8zqFpNHRJYTeJMLKtz6EPJUFBWqEfAK34T3eunQ
34064	payment	1693	1693	251	1	1	998	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYigDyaCRcDV1gQ3NoiTpgk8Rh6SzM7cFYUC3vb3c1fcpyx8vJr
34065	payment	1693	1693	91	1	1	999	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYvt7Zdme4arzGBwFn28YwHPrae4x1T3gPsKf5c8w9rt3ejJf8h
34066	payment	1693	1693	89	1	1	1000	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZN8VUMcC7RcqWZnSkox1ogwNYz4JKJsPbX3Aywi2BGigCJdXuT
34067	payment	1693	1693	1811	1	1	1001	140322344508	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZK8D8p9CLbRgLHyzW6oanwJPYVw8mrYr8QL5hQhAfUJ1iYnraj
34068	payment	1693	1693	84	1	1	1002	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYVvYGP8VcdGwnX8ZkpHz9DTshbTXSnc2KWN71iXCWZ2XnqrGbt
34069	payment	1693	1693	390	1	1	1003	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZnndhJbffUgxwwbuJc4tHDhbTYdW1o4nTtFiJL3xorcbaUqrud
34070	payment	1693	1693	910	1	1	1004	389291954470	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZMe6MUmKyY2BME52kmjbv3Bmy6CRd6GuPgB2hyeCyNx6bS24U6
34071	payment	1693	1693	658	1	1	1005	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYtagNU71hvFgiUwcr8b46aisUzzFQL3c5SG5i44vaPeKnCdmBY
34072	payment	1397	1397	1678	1	1	13338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zSWmzR6iH7jTQz3MF6X3igQzYPtoy5WuoLuyddy2N2f1jqVy
34073	payment	2133	2133	1874	1	1	3744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJdqM3ZQKMvqeqsSJAzzZFz8GGf8J3nBePfphhPus8hZBo5yS
34074	payment	2133	2133	1874	1	1	3745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiThSJALbjHKdpShp2rfqt185foXZLKgijJS6fbHiKqx74HDRB
34075	payment	2134	2134	1874	1	1	3828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrb6yugkUWbo1WgCDCf96BiPNySCvvGuBss1bncfmeAXBzXnUJ
34076	payment	2134	2134	1874	1	1	3829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkzGbmesiQHzMPyWsGQpshpMxHHumRL5HRa3NTRNum5JFe9Ly
34077	payment	1397	1397	1678	1	1	13339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUnt7s1VeygVVthzFqWjYPmegRVEJwbowvzfHNbgK8KKcgk2o
34078	payment	1693	1693	150	1	1	1006	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZxwjvxyoNgdcYzHbpyJZwZEDaTjvX8SHaaP88YD6SVxkNkHX2S
34079	payment	1693	1693	154	1	1	1007	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZJWY83oPknwMfG1UZxSaDpAguc2pCt1T7degvNkdDoLiBFrGWw
34080	payment	1693	1693	593	1	1	1008	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa82XcY1fLgPuHUgX6Q5nWQ7qwgikWKUiwE837BMt95f1n3Kgzc
34081	payment	1693	1693	180	1	1	1009	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZUurj9bZS9AHroQyvjvgCtcmheDu6ffpb48dSqeMTzxshhorT2
34082	payment	1693	1693	711	1	1	1010	2126180928	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZxTSfcGzm3G2nByAqswdq9YH8Rb5hZtiVfBHNaGa9zZr551FCz
34083	payment	1693	1693	245	1	1	1011	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYjyB2MHyFm3jNetKMrmkakijvp2tDCL9P1EkFRHooV7VCE85mc
34084	payment	2134	2134	1874	1	1	3830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTbhvRLVyAQte1JTi7qwNige6w1UeG73LCsysWLYAoUiF9KC4
34085	payment	2132	2132	1874	1	1	1079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fBzyWtRtam4qLnHS7jDMRDkVJH4RUnPaf1mBLcmrtWAsFciM
34200	payment	1397	1397	1678	1	1	13354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspENrn3T5b4PPTYnkQvy9826k7KwQK7YeMBojuaC34dSLYbK6
34201	payment	1693	1693	352	1	1	1080	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZFg7FKMzQGgVqrGPSWmUzfFUugNN8i2t5zWQ7mvDV2p8CerPTg
34202	payment	2134	2134	1874	1	1	3844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYYv6iB7qWbB1RxNBVd1urVQUxgbcXYBXx8ataU95BZWGnbzfC
34203	payment	2133	2133	1874	1	1	3761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZegjLoBq58ePKEKNG7YhrQKLTEorcJCsy9VYunJ239XDY77tVJ
34204	payment	1397	1397	1678	1	1	13355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A1YdXxADxsPQDCMNYRdbx6n66yBggjLdBgbpdizV24cc2sT5
34205	payment	2134	2134	1874	1	1	3845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGR6A7RksQQreayRjt8oN9kbGGQ7sv9YaBx8nQK7teage5idp5
34206	payment	2133	2133	1874	1	1	3762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLGJckHvk2Q55X8ssDAtUcf11DBxzyfbcWCd9TWb5DF9s7xDxi
34211	payment	1397	1397	1678	1	1	13357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeG5uVn6VGSEgGp6JwRpYoTFYbi2zTwz55UVJdUhJ8dCnCQnmg
34212	payment	1693	1693	663	1	1	1081	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZomiYNJvPoUvwtvFBQ5YgHweyU4WAcysrVmmMBrMsYjTUDEA2v
34213	payment	1693	1693	266	1	1	1082	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZiLVHDmEsVFPa6axPLMH8ReSwxDh5LovQQgw9QY4WM7e2Bb4aa
34214	payment	1693	1693	191	1	1	1083	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZsZKEajWF3doeQ1ibijgivaFBX29f2ywDdPhYSmn46AinHZ4wS
34215	payment	1693	1693	379	1	1	1084	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYcAoSJRLgvPMgu5mY61NWBqVNUo97ftH6zEcUmtrDpe6FxUBwM
34216	payment	2133	2133	1874	1	1	3764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9atyjHC95gC21VymyCKyDdmjqJ6JMmfoaoCies8novYc1HcK
34264	payment	1397	1397	1678	1	1	13364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVo3SQPA66LiWMjSbscWrdeiQ7cazj1vJSgn5uN63qrEyUJca
34265	payment	1397	1397	1678	1	1	13365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeaCLH9oXkYvzXkCaPD2qE8ifcH5WmYAUc5iZA7cRXDNaeTSe
34266	payment	2133	2133	1874	1	1	3771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2z4FUgQDDHjvKG2gVNXqzH2zrNq75jU51rD3qJ5BBeDzgc8st
34267	payment	2134	2134	1874	1	1	3853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZCaiKmEgpanWXa42mgDuR9vEMHaddJe4n7id6fPm4GyKLQ1B
34268	payment	2133	2133	1874	1	1	3772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdDHn3Hd52w9vniLkF5Rw8fJRnT6deimBH7p47navtLMEL17a
34269	payment	2134	2134	1874	1	1	3854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDb12SaKTTB67Radh19T8wvnGAi1ab78SQqoPjcUrZBFGAN6D
34277	payment	1397	1397	1678	1	1	13368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjK368UnbrnUnLvhP1va4GwYsCaveYmtEC2ftohgUvgxec6Mqj
34278	payment	1397	1397	1678	1	1	13369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2AQvBeYJDskinqYKbwNje6Lzsq391qcaC6cs9PWNdWczYB7F
34279	payment	2133	2133	1874	1	1	3775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3V8BWcafKR7QJMCUrLwFyVZiMXc4CsEq11zJkroYrxKv9gyS9
34280	payment	2133	2133	1874	1	1	3776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSg2pC3NQ6RwLVNsMxcFEc9bAvG7385MPp8NTzKN399NjehpJ
34281	payment	2134	2134	1874	1	1	3857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dYGZNsoSjfKujbMLpSQVDXoBKqBgKTcbvYsxjuWKQHLBy8iP
34282	payment	2134	2134	1874	1	1	3858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPRVmPNeKd8mmuSGCqCuHpVHJLtQdh41QvN7QokRninM5NmBC
34325	payment	1397	1397	1678	1	1	13380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiLpNqcPipneVtgHAKhCkZ9MuWH2FacRzndpKqo1yQRiuyDaVc
34326	payment	2132	2132	1874	1	1	1091	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjiq36cMTDimjW7tcmdRnacYfBi9AovqDukkg11J51crTaJmdB
34327	payment	2134	2134	1874	1	1	3869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLE2fjv36txNVqUWa8hSTEHSmekuUoLtsMPCqyM9PK1ZWZJzp
34328	payment	2133	2133	1874	1	1	3787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqei9ERa3XoqZSZz8itmC4kKwF5jBDGdw7p9FENYHXPC4rE8z
34349	payment	1397	1397	1678	1	1	13387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7bdDUNRWvKYjVovzZhw4doGRwsuPXfk7w59RijcZpiPWfabc
34350	payment	1397	1397	1678	1	1	13388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAndnUigoZgqvztS68EytMPZDPA49TykQYnohdRmKE17FZKywv
34351	payment	2134	2134	1874	1	1	3876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHh5oASqnwvGCVSJ8PcsMaD4CCVjoXobSC7hSd7AJcMArKSBo
34352	payment	2134	2134	1874	1	1	3877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxDaDUypMP445CFSsFWU2q51PoVJLvm3hNLysnmaM13tE7cRw
34353	payment	2133	2133	1874	1	1	3794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29aEqbCMMdBLFYYq1mc9fB4RGPAmwfqeyHUSLSAPgBnDuESq7
34354	payment	2133	2133	1874	1	1	3795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmFTGjhXhNHXS8ZR7UwxZqcehD5oeQtyyxPJLp44ChMmniYVs
34394	payment	1397	1397	1678	1	1	13400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpruH3fboj58d8G5K5DLKyQc64a5149NYQNo6CBkbhahb6PpEa
34097	payment	1693	1693	600	1	1	1020	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZEBFUJsiXLnvkgtndNfSGpoVoMuunR5dtSPcwijHjFjuSKMhkp
34098	payment	1693	1693	112	1	1	1021	50979715941	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYiuWLvPRrrtLJnvc9afrTBgciMfrpm27ssZZFEdR1KuyWxtkz2
34099	payment	1693	1693	103	1	1	1022	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaEH9pRSkfjnsHvojyzmLMeMaGc4rkxx9P1LTTcLtBHRVNsxgEC
34100	payment	1693	1693	383	1	1	1023	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZacFfHDLTZgptXA3r7AtzctdJhV5xrHb89myvphgbjcrof5RKH
34101	payment	2134	2134	1874	1	1	3831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8dNGoonwrPoRQfvMXrHwTCVnowfg3SvuMLeSR931CCnb8sgK
34102	payment	2134	2134	1874	1	1	3832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbtqruL78BcxePMQWFDQ8VEQPequjLNM31drjzDGyQ5jwJvEf
34103	payment	2133	2133	1874	1	1	3747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsYXW1iYXEGeRpB5jDWUEUdy3uyzDm9GyRHx9p7hMPx8GdZDb
34104	payment	2133	2133	1874	1	1	3748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQ4HAsnpTYRq2nn2hYbdRV8uN8Sf7ZQkgQ8csg8rs48nVJJc4
34114	payment	1397	1397	1678	1	1	13343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCU8DJRVriF4NEuVijndrGu8GQkSVdBivk4dLh4bNM38EAk9ZQ
34115	payment	1397	1397	1678	1	1	13344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttYpEwV3Jg9E5r9fCWoxVcr64th4VXbEUgFU37zf3YgBEUQHL
34116	payment	1693	1693	2073	1	1	1030	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaG3mJYM365rb2MLk621A8CNGcMxvAhnStrk1cRALSjkwtCqV6q
34117	payment	2133	2133	1874	1	1	3750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfbo9cZ22JygkoWm79h3nGqYP76XwstuRf6UU9NegdmiLzADb
34118	payment	2132	2132	1874	1	1	1080	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFG9F5Z9oGXPML7k5VoYGx5gf7J1JvD5DhKMkMvFvnPMgqkiL
34119	payment	2133	2133	1874	1	1	3751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkUnVw9w8hF3vTJBbwbbiU8eNTLmB4YSG21zvGnrna8EWxFUW
34120	payment	2134	2134	1874	1	1	3834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsexLYhW92CBwFZWvKAWY4i6rtn8DVzY46Qry3dJ92xByPQAy
34121	payment	2134	2134	1874	1	1	3835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ589ade4c1z2K4jVBpKWaghvMo18AocAMZm355BqiboRevwi3X
34122	payment	1397	1397	1678	1	1	13345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ahFZVMnLpStz6yGGm2MNsrAhTcAvgftrcvYM82H9FnKKmPXt
34123	payment	1693	1693	237	1	1	1031	46738809135	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaE4jAHEsGasjY2VP8F84iVRzBHu5TEo1YSUENXaaM8DtJg27Ns
34124	payment	2133	2133	1874	1	1	3752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6UMLMCRFQKGK4UMPDdwS9tsegdDegLokJCgsES1VfxRgxv51
34125	payment	2134	2134	1874	1	1	3836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YPpvacCq3D7kSHBtP7yoXYDUjq2Kb4wCtoSka71vNx7doT5h
34179	payment	2133	2133	1874	1	1	3757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2EYRhAcv9NCeFFdoQgchJXpKzixnJo1oVwoS74K5xtdtocMAt
34180	payment	2133	2133	1874	1	1	3758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCwZcQjqwi2VqUcJyURCHzFTZabjC9RYyBjf8XHACrqfQ8WiN
34182	payment	1397	1397	1678	1	1	13352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9fYjZWSVTBmUuCLodqhbfRp1VJPhkNky1efwRZa7kpbiNAiN
34183	payment	1693	1693	10	1	1	1069	23057065816	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaFMfUGcXzSxuBT1Ezf71nmwYoXWAxpAp7MGV7QwPQZgiBhUEUQ
34184	payment	1693	1693	421	1	1	1070	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYQwJFPvUa4JBTBBVBH2T3hghg3eXGcy6sGuCEpFu6ZvW6YdJeB
34185	payment	1693	1693	620	1	1	1071	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZgCnNJQWNGFNd6uVFJ7t9dvLDdMPTW7WSuAFrKPb5jEu2938bx
34186	payment	1693	1693	594	1	1	1072	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ7kEKUxWNj3oToDt57MxVKGeBGyLti5e61aE6dyzsXrxvxbwT5
34187	payment	1693	1693	622	1	1	1073	4148160270	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZwR9G1rc5EWBNvZhWfKegD5btotXp5AxYSDZ3iTvxosx9QyBrZ
34188	payment	2134	2134	1874	1	1	3842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUWQEdVPXySrE8PrHSxseozpRABK8A1r67fukPXB7wqaD2DM8
34189	payment	2133	2133	1874	1	1	3759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsaFq11GwF7LoKendyonbhHRx6CvPWqsLpybbBmve6U5TvGdZ
34207	payment	1397	1397	1678	1	1	13356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqgubPVqyCT8Y7PrW8wbRaeTEYeHZKQUmjYBwDjYNWuYrPEts
34208	payment	2132	2132	1874	1	1	1084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyoB4jRttJ9fCZJNQgHm4WzJWsU7NzWDY4ENCNMQMAdibtTsX
34209	payment	2133	2133	1874	1	1	3763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2u753wAEjGuDPL873bWZgswBFwGrCyigk9GEmcjewNV81cu7P
34210	payment	2134	2134	1874	1	1	3846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwr7zpMnArG4nj9YbLeuaphn7WkQQwieq2xUChQCscWPyJkWP
34226	payment	1397	1397	1678	1	1	13359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4b7p7Tj5NDKHg1CJqjShG6ZhzEQ5rmR9PzEwMcpj6f6YGuxs
34227	payment	1693	1693	499	1	1	1091	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa7Qy33d4d3LosgV6dUTCZMsFidYc6PZ4zgDuNG8RjqmEmu1PmQ
34228	payment	1693	1693	391	1	1	1092	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaHdJWf9CnuaxFvTaR7Ysg99gQLBriiboM227qB3S8E5KF2nzKV
34229	payment	1693	1693	186	1	1	1093	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYrTz48dBnW5TNksRkdBSEt3jQPkEq3R3zANdkCLzgiPkm4Nodc
34145	payment	1693	1693	339	1	1	1048	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYXeqmyYhTsFF1AobjsqiJFwfUVa1BpT3sjGcAWBV6f8keXw2Lb
34146	payment	1693	1693	105	1	1	1049	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZpiyJXutgmv8ozeFhPHXvMjacgYn9mBBuBwQU1KKVcRoigyVhe
34147	payment	2134	2134	1874	1	1	3837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmRAHvqqTyWgbsuEjQ1fLhB6ge9bMVsaojy7hkAVujUEpUJs1
34148	payment	2134	2134	1874	1	1	3838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGnr3hexVi5S1xNKShaeH4NiGudC8ZZcBnLU8xAiK25kXGyoS
34149	payment	2133	2133	1874	1	1	3753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRJ6hyaNQkN4iCDJwLbCNXJ1CtNCoxdNy86q62ZiZXGNGi5hm
34150	payment	2133	2133	1874	1	1	3754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h1RQ1nBdbt5pCNGpCJoJ3Cb4wzQMXV5SNLV7A49XV2McFUXv
34151	payment	2133	2133	1874	1	1	3755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK426JB2cTwtDjzpxZfaM6d2RKei1YaeJkiesi3Yuz6cHZ4xQM
34152	payment	2132	2132	1874	1	1	1081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ88wSqHUP1k13YPXdQ6nQThquNHqdtFBrbDCUNR4XjSBFb2po
34153	payment	1397	1397	1678	1	1	13349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdZT1xx5E93AmiRhpKYdu1ZrEdUBe2aY8i9JYNvpxNU5R6Sgf
34154	payment	1693	1693	322	1	1	1050	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZzLbeBzyMyYYbSDuS3R8d5L1WhhjRSoj8CtQr8u8Tx3E5upnKc
34155	payment	1693	1693	252	1	1	1051	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZTXBrFs2mSLwhXUphK4koLNDMhcaCpupm8SQK5getEaxACUusC
34156	payment	1693	1693	636	1	1	1052	46738745395	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa2hecq7Ki9M1HXjnrCHG74q1qQsxTj7mgqgHiEAPW85619YjfN
34157	payment	1693	1693	1778	1	1	1053	1416401776	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZgzmZFRgLTmEBp5pnMG63sPnqKcNVHcQE9MJse7cHghRfuaPsU
34158	payment	1693	1693	146	1	1	1054	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYk8JXyukaFjeRM2X37JqnNqYwsFusC2gqwM5fGcjvLik2vvvdZ
34159	payment	1693	1693	114	1	1	1055	46740685762	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZDfhMxtLqWtPeGbfFPxn4NCK4UAMxtJDVMtnBRo6vRT5dghsHT
34160	payment	2133	2133	1874	1	1	3756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNtQU7LWzBxmffKQhgWHgyGg4Jk9dpDcbMXLaDn8gq84SFn3y
34161	payment	2134	2134	1874	1	1	3839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf23CNLw6trVvwpQ2KgVvHAW55G3mtzg1Vc9UxCxxmo7UvXHFV
34181	payment	1693	1693	450	1	1	1068	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZexwQVLV3t9hfzNfmfnddMZ2GVjXCEQVZCaRwRUt2Y7gjpU12K
34190	payment	1397	1397	1678	1	1	13353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPu5LPhMLdzgMfJtNikuW8Xd22QyE2Ktyi45E1webnnHxZwYo
34191	payment	1693	1693	2017	1	1	1074	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa5R2z8uMWvNqtfoBrurbuSTK1C9yyHjhVUnGfxgwNVYouuppyi
34192	payment	1693	1693	520	1	1	1075	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa3vWuy2ScLSwDhm1crxoWgkj8ZDZwndJjuFZSYLt1CrwuNDFo4
34193	payment	1693	1693	452	1	1	1076	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaDfJWsg5nGAqxcmmzVK446r8fkAQ1GdVeYKFGhK5NAMFsJkUtD
34194	payment	1693	1693	652	1	1	1077	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYxm6xgbY4a33jMJgrQeLbUGpo49VBdo1Mgo4zaDWEjDqqoxrms
34195	payment	1693	1693	354	1	1	1078	46740437906	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZLzNayUoB3qD2mfbxXhe99No9L2p5hek9xCw9yJet3E3Z2HYyG
34196	payment	1693	1693	569	1	1	1079	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ5XNtCkDb2uNhKQ8Xfm3Kmdei9uZr1NLM5PoZwy2WLM9rotwa7
34197	payment	2134	2134	1874	1	1	3843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84UxohGibTZyhC4q1SBSsBwjRybHB5s3JCbzFf9kUio85rUvP
34198	payment	2132	2132	1874	1	1	1083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsErpki9QaLzXTnoBqNrRRwRRqB8JgJW6HoP97rWzmzCD1iYnm
34199	payment	2133	2133	1874	1	1	3760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcmwMkHcKDJNZ9dRo67Y1NHiTMwnw1uiXQYzU3DbsxESzhzvq
34217	payment	1397	1397	1678	1	1	13358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiU856TpS3TBUz7w7dk3gg6SwQEti32djgvwiPTg7DFHB7hUd
34218	payment	1693	1693	551	1	1	1085	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZHXvQn9csJyRLa7rxBUxj6dfMUtqzJDvTGcrARhFV65sgnM1Mf
34219	payment	1693	1693	366	1	1	1086	46738745395	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZw2AgbJWND6uFtjS9zyMPYszDJUVYntdtBWeCgEYhYWikFLgxo
34220	payment	1693	1693	82	1	1	1087	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZGMLmVnHom3Wowb7ttLz3cow686pYMTLjFYhoKzicnhYAtrwvb
34221	payment	1693	1693	680	1	1	1088	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZL3VaqDmVbGvQhixSEgZgsn5faSW17QnSVuBbj7UiKzKYdxJcN
34222	payment	1693	1693	342	1	1	1089	46739524375	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYXesco6UxTZEYrwrRajUxQXB1G3DxfDLWWkTpj834bCcNa4Jau
34223	payment	1693	1693	361	1	1	1090	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZpCwVPNYWW7xvEg98HTRUQZuD8S12k5YzKfdFpvd4QroyggSgU
34224	payment	2134	2134	1874	1	1	3847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzm1JnvHdsveyTe7Qm4dZ7wVKb9jbYZN2RzbCJsLhVUmKX2hoz
34225	payment	2133	2133	1874	1	1	3765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8jdcH8qQ5T2GWQy3kpqPbZC1GLv9S2SR69nHRtCQrkAAPqSTC
34260	payment	1397	1397	1678	1	1	13363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzxnzf2wMkpxv2ZyAJKNXyqdFs9Ng2WptggfyRNkdKQGkbuPN
34230	payment	1693	1693	458	1	1	1094	46740437906	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZtZ644LngYFKH8qciH8tYM81k4MgxLGUGkf3hiTZ3fh5FwZNVz
34231	payment	1693	1693	327	1	1	1095	46738745395	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYoKucq647egU4oWD5ZJRX8o7bL3PuzY71LikhWQ8xwkz3baJXv
34232	payment	1693	1693	894	1	1	1096	237493315876	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYpRasdCtva5a4s1TjQhpWGeRwGSHYbfkSgCvNZmb5HA4kBDM1W
34233	payment	2133	2133	1874	1	1	3766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6rTaxU1YHnZmNDx2h2BRzmhEVqkeg9WYPug833ADct21JHaU
34234	payment	2134	2134	1874	1	1	3848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfX2PPNfMLmeCtFMXsyBteMCvLMKmfzmn5eCQaxRCfo3tyWQL
34257	payment	1397	1397	1678	1	1	13362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVCruMjkcSiDHqcgrrgcuu9UU4gpe6fRJvoR25f4NsSBBqhcw
34258	payment	2134	2134	1874	1	1	3851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgqPjojYdQ31ijhvrm1si7UCqcEhrEP4PBMSo83SoUrmLnFGv
34259	payment	2133	2133	1874	1	1	3769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgfpyTnRAG3Es1xHYAcrQgTuuyd5h3gPQLEFA8aUtNL2WRYxU
34270	payment	1397	1397	1678	1	1	13366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWZNxKEMmqTHLaZDKAoRwUD2jmiFzJmUrjBgNyCT9ENzG1J9W
34271	payment	1397	1397	1678	1	1	13367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKmkNC1LMxbiUcxePXCdzrneE8bJKDUr96xRzH2wvuBfH6mCG
34272	payment	2132	2132	1874	1	1	1087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhzvCN3zKSGFChdaxvJAqDE8ZU4G4SRCyok1M5khMAcs8URKD
34273	payment	2134	2134	1874	1	1	3855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eV6UKmXYWPKoTg8aGJt2Lwp6JTQuT92v8pnvPKF6EjPEFeUo
34274	payment	2134	2134	1874	1	1	3856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfs7iWCRJ5NhXxC8NsJjtqXnGoyHYwM7YjjhsVsuf3QiNYZmY
34275	payment	2133	2133	1874	1	1	3773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGkEkzmPeSbDBehaQLX5Cxyee1JKiN9SvPh7rwNjPzuDJ7oMf
34276	payment	2133	2133	1874	1	1	3774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTk8L3YFkuM6SyeqmVzrAP9sFmdefjuF14EorUnTw7UecowPbZ
34304	payment	1397	1397	1678	1	1	13374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8PTjT6xSRB3mdybzSQQpjMGu1TaQvppLtbYqBXJNNVK1jnKN
34305	payment	2133	2133	1874	1	1	3781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUivZ6A3RGxknN26idmuF348cALoyw1J6V4pQpHDofTFXT8t6g
34306	payment	2134	2134	1874	1	1	3863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3SYLmZu28HrXWgxuKogBSyNqU9tuH6c4RP9CEyD9XusEvb6aP
34323	payment	2134	2134	1874	1	1	3868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbWE687pxq1erzkA2DbtEUgVx3C6C1FqeSc91YK83hwG9wQENy
34324	payment	2133	2133	1874	1	1	3786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCurJ33iJNcK2cF6iEYnNZLxstYZruehdBTdmvMk2G3nmYqzB
34345	payment	1397	1397	1678	1	1	13386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBxNY9ZHyZKb52M1Kbe4CV5i8i9wZw65MTuM2mtR9MTbseacw
34346	payment	2132	2132	1874	1	1	1093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGhstTLYmhaMvQXFU8CycBj6Zwn1igDd4LE4aHT2aScVSBSA7
34347	payment	2133	2133	1874	1	1	3793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzw7Zvp7sPwHwtWbCH7vSZVXZ2y24LstXwRfJX1Fff9A5PUEHT
34348	payment	2134	2134	1874	1	1	3875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGxAzSbbj5zBENpife6jeKehHKH3JWTEj5Joc2Cga8sxT5Cq9
34358	payment	1397	1397	1678	1	1	13390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXC7i5BkNpKjyCk7HdLa2bwKqYPZtp4jYPDdVkve8KcoTtxqSV
34359	payment	2133	2133	1874	1	1	3797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3royFBjffTWbzcL91vz22SLgkuwmbC9tN6qnJzmAxve5NMfS
34360	payment	2134	2134	1874	1	1	3879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbay3QFiqZwXWHUn33K6YVEQcEQP4Gq47HcFMatEYWUzv5h5zx
34361	payment	2132	2132	1874	1	1	1094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArEV19toRea9gCEbdyys7eWrjMwAnwmeDn1whBbhgXQwQGqzw
34362	payment	1397	1397	1678	1	1	13391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Fn6RJbFmaBsGK3HQkU4SYBQEWYyfS7GhuDDerR7yQVZx1Cdm
34363	payment	2133	2133	1874	1	1	3798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHUyrSgKZeC7QRo42fykX6e78DACSxkZFjyDD3C8Ya6Zt6ok1
34364	payment	2134	2134	1874	1	1	3880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWkxyapd5sJFeoSg8W25qJWTRfvkqfi4fAbXTNa2raf77aKMT
34373	payment	1397	1397	1678	1	1	13394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMvn3gfmmqGkzeEvn4yATwQDp6vnibTtvAEF9nGc5sfnBqbTb7
34374	payment	2134	2134	1874	1	1	3883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5jPGd5bLeLwdQLXFvdo9arbb7RzxL9cnCGVhMZLc3vdK7MALk
34375	payment	2133	2133	1874	1	1	3801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4Q9jc1nxg12vzoMXpkNXm5ixNEkaxsdXiCpWQy9RkyBCPyeW
34376	payment	1397	1397	1678	1	1	13395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszXU8u7FQ7qFwc6fxMkrcu3TfFBLQWTqF45wJXpffNsHpKztG
34377	payment	2134	2134	1874	1	1	3884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiTbfy9uC6C6CtZh64LyUY1zpXXk1SdyxTiXANrTLQ2zS3of4R
34378	payment	2133	2133	1874	1	1	3802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvce3GiNb2rFUKT5Wges5gscymi9UARwECzzPhTGgNStHJRtm
34379	payment	1397	1397	1678	1	1	13396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqz64bbwwQfTjhrFh21cZ1D4UnuGYxbHDyEMCMyzr5NMgWBrmp
34236	payment	1599	1599	921	1	1	4	2643535789138	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQoiytELGFNNhtzWpakM8fthQdkDo1adVYn26qqjn6VmukpiF
34237	payment	1599	1599	1041	1	1	5	4737193484311	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG7nk43arLZQ9n4sszgtTfNdx3unLzsw7N7BNCcaccXdowDix
34238	payment	1599	1599	1161	1	1	6	3196278839126	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFmLhyz3eQMEn7k661wZvZkSJZDM4EmYiofwyBZrjKQn3rjNJ
34239	payment	1599	1599	1287	1	1	7	8906715182489	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14QQvcnchxs7oKPkAuDmVVhLjCuvz7USzxyArN8uBS5rByQkZ
34240	payment	1693	1693	570	1	1	1097	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	Ckpa5Z1HunynAybswfcrVrsV1s2b1v41RCiN4fWmgDCjPfeybdadJ
34241	payment	1693	1693	399	1	1	1098	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYsbErxVZ6TAPYJsWUbqMg5SzdKj4P3M98RXj7J6u413Ti9Kuqj
34242	payment	1693	1693	721	1	1	1099	1548080681	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZ3r3L1t7hnZ359jCF6Uewj3kHi6DNHCZ4kGdPRfJHYXSWDASfq
34243	payment	1693	1693	534	1	1	1100	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYniRHe26EgwbTYB3NfRWf7g5rv839hMZr3dnkMDyEEA6TN1JXE
34244	payment	1693	1693	731	1	1	1101	1548080681	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZjeFxTH2KoJVUULejtybkLsyVwBuzd2veNYmQAWHhH9AbN17Lp
34245	payment	2132	2132	1874	1	1	1085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25Vs89gs6qYy9h1kTRGeB8ZJLrqa4Gk17CFGapsD59aLBSbte
34246	payment	2134	2134	1874	1	1	3849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBSzHVRnh3sYbiLYSsECVL9GwrMQ7LTo8jtdQtJ7zZhHrTjJ3z
34247	payment	2133	2133	1874	1	1	3767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJP9S2ZUAW1XKP6LyAmD1bVtqzjZA94ZbWjwMt1v9ZVnHGCwJP
34248	payment	1397	1397	1678	1	1	13361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUADHLw47i6jim8qGkXe5GGxCzPCJXpfTznYYtrz9iZW79js4S
34249	payment	1693	1693	138	1	1	1102	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaBdur9i3YrR4RkoRUPDb9qWgrZaFkqHUiEADEjVVQ28p3vqyjs
34250	payment	1693	1693	402	1	1	1103	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZKzgpDhiUsuUH41L5UyCe5FKWZEKPwiKLSCo6gAFJoAwY1tKgw
34251	payment	1693	1693	275	1	1	1104	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpaHfDEqfen7Du5wJ6tymFCeWd6V7Dfzmf1SJk3gGwFw6FS3t5rx
34252	payment	1693	1693	1030	1	1	1105	697607846969	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYWU8S11HBMRGn5bsny46xcTpX65ScgGRG3U7Ve9afZcfC9ADCg
34253	payment	1693	1693	309	1	1	1106	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpZGC3Y9nawuXN22xcKG5ktwLgJMkQggj6ELynmbXG5V7otGf1pG
34254	payment	1693	1693	690	1	1	1107	51086662692	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGS2Ys1bVCkF68LFNyUoz9qJJmqFZCfJ9N	CkpYj6M7SR9NLzseoDMDCMgywKmujMgB4t1iSPfsh5jNWsPnLrdVW
34255	payment	2134	2134	1874	1	1	3850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8WFzHDHaMP2uY43UnUSouoJwPUztRfNXVM8Ck5WbLEpJCs9dR
34256	payment	2133	2133	1874	1	1	3768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3gY4cV4z9dffKDn7ngfA1sJh4nYNSGGeJc4MyZzkyhDk35PA
34296	payment	1693	1693	320	1	1	1114	50887527308	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYcQQoQtYe92EaJYUom2da3rXwqWp3PVkxqtHKi8aKVYhZvg1Bd
34297	payment	1397	1397	1678	1	1	13372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHQpymDZYedMuECMKF6X42D27EATHN5XGVWiqdeE3XrVC5baL
34298	payment	1397	1397	1678	1	1	13373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhv3wjoMYmMNZu3b4mMKVZyCrMDHwnD9kMZa6qwSH6g2AcgzY
34299	payment	2133	2133	1874	1	1	3779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVcR1eQDdFuiY14Jk3xhKz4fs69X25NtvC9KsGaMcFuQLPAS5
34300	payment	2132	2132	1874	1	1	1089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFaHVmNTDKw7ejnGqHuSVmAz4WwTcwqRXBTgaGJY6vvSkeY7p
34301	payment	2133	2133	1874	1	1	3780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGU5uNcHRB4Ln3erD3q5hZb3nBBFEZym5YCJbs6eLufAFFGe1r
34302	payment	2134	2134	1874	1	1	3861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvTi6PyJJujCsaJbTT6wEJSz37xmT7Rdm83DgLvxYdwwWGi3P
34303	payment	2134	2134	1874	1	1	3862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kGtWZJaL2L3byDPHQopb3GFPQQqaef9cDfZTPVuZTFEwqheN
34307	payment	1693	1693	1811	1	1	1115	1087616978	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYZkM3Zv3eGEGGBxSBChEg7gScdaVJiPTVE3sBqqS1bPjAD6W58
34308	payment	1397	1397	1678	1	1	13375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNwjrWg7yKhYbmzKft8pbFyErab4pvfvZ9Fv8pJ6eBHGbXcWC
34309	payment	1397	1397	1678	1	1	13376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPNSySEWg9HLA5F1WSo4tjYbQu63jgPLjx9KDBbkFD96MvrdB
34310	payment	1397	1397	1678	1	1	13377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZVJ2ibutCL4yr2FwuXYN87sTYF9z9c8Wqiru3zvDV5dYj3LX
34311	payment	1693	1693	1772	1	1	1116	2855319911	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZZhv9tZKjr7TUayR6c2TcRApLFKVbazpu3uR1jHocQ1rbLAkRz
34312	payment	2134	2134	1874	1	1	3864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1EhU1JPLor5uM6NzdaieaoHkRJyX9nTMMB4SE5dMJjcmE3zyu
34313	payment	2134	2134	1874	1	1	3865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2EBHLm6taTD4AVAdcpJhrY2uSkzbSZeqzGyVfr3HuBJBg5Hs
34314	payment	2134	2134	1874	1	1	3866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQQfpy6QXr1FCpJ3nJZi8AuQDQC8znr7XyCB53JQ847FFKiqN
34315	payment	2132	2132	1874	1	1	1090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxD7SPUi8Fif1X3QmKoaZQi1RgXFmRaEusPH3jDgZPdJwmSLdd
34261	payment	2132	2132	1874	1	1	1086	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdrc9h2YjikfrUCf97Qcq8vTbJdz5d8YNNScm37W4j3ZHhcomz
34262	payment	2134	2134	1874	1	1	3852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBJgCk32FH5jRb9Xc7ffAVLyNisQBBxBfGjgLGmeCJ6wuC16c
34263	payment	2133	2133	1874	1	1	3770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVYNC64wwhLyaJiFgMkSquQoP86h2Hgcxba6HbVWHrm5KDmy4
34283	payment	1693	1693	312	1	1	1108	46738745395	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYWakLDM6e3T8axpb6DL198uVaR3ngBRUh1S6nvtbsPrcoGJgqw
34284	payment	1693	1693	1772	1	1	1109	2855319911	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpYwaRfiR3UfvKwcJRePvMXFYkfyT1KzdenD9W8EiVHYzsqMaQGF
34285	payment	1693	1693	1811	1	1	1110	1087616978	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZZzdukryWzN4EeJ962gfjWrh3fHwJK1FaMX4voR2GJ1dHpUE2X
34286	payment	1693	1693	649	1	1	1111	46738809135	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZQqasXpXypCzSoh5jVAqezdTWUr3T2Jw6ZwyD4n7brtLirUugF
34287	payment	1397	1397	1678	1	1	13370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7fyoUNwsr2P4GSXDcfWcvn45teaWrYwq5aXUwwcjccADrbNW
34288	payment	1397	1397	1678	1	1	13371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPSxTpKw3A7KyRdPMUFHBN5EHKTL97tHZbBdjNV7gi5CXQ5uM
34289	payment	1693	1693	205	1	1	1112	51086662692	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZyW4LeBM4EdXHNPnW1aia3kBTrLL9d5PcnEK4VQk2iZL2sVysD
34290	payment	1693	1693	120	1	1	1113	46739382744	10000000	\N	E4ZMwM8Nm1aCcJiZW3FKWRwC4ZRiSBYVpUdP2dPtuo1RRQbQCwpyJ	CkpZcfRSg5GrX6SK11P7uPkQk4ZVRDf7CQ9mB8D7QGYV9wRXUbPNp
34291	payment	2132	2132	1874	1	1	1088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfJuNjytZBHoErRtzEj9x9SPQfVe8j5Muc9neS6FFbg7WRFDe
34292	payment	2134	2134	1874	1	1	3859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYATn5rsrYw6GD9vobmyAmTXAMAwTHDREfAGZtpokknCJTqxF
34293	payment	2134	2134	1874	1	1	3860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJupJhWWGoeoDbPn89RsXyzphgvUGdZscs3NmrPDecFoTCX3Ke
34294	payment	2133	2133	1874	1	1	3777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYYDoniR5NGSQeaPzonoNcHERuGTTUKZokpy918NZSsciUwdB
34295	payment	2133	2133	1874	1	1	3778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZopLF9MRPZ5K2xSZyqp6ybPvuyvUXos1yy4RzbXMYo1vBapGNB
34319	payment	1397	1397	1678	1	1	13378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKMr1NghyCiCBKZ1PKvptFET2Rq8zTgy41s1ZytYG6rhPsKJC
34320	payment	2134	2134	1874	1	1	3867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCkgLCRjdLFE9KoMbUYCJuMjmpFuaMxurxBG19Fd57VS6zVWz
34321	payment	2133	2133	1874	1	1	3785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9TGqEmcF389f27bi8Jnzjf6HAW3bYbvZHgLSH8d7si6Xtt8tU
34322	payment	1397	1397	1678	1	1	13379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzTjFMAYNbWHzhGMSzG3uqW38nCgdsoongsSQDnjaTdLKaL8u
34407	payment	1397	1397	1678	1	1	13402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTBL788TUGtcc3xhBThkC2158CE1uDHSRbXXYVAMadCwdA8oU
34408	payment	2133	2133	1874	1	1	3808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiijAUrPDhZ8yVfpNkBsDPCcsuktBa5u6Z1PwK6nrnnoXJDnZ
34409	payment	2134	2134	1874	1	1	3890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhR4LQ5RBFtNRD1vvfSdxkxnUGkvzeGbhnmQPw5doLmW74LSY
34426	payment	1687	1687	1866	1	1	6	14175294119770	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHVM13DkHxwSatUCg9CpVruEY9aUCihKXevotP5WfYH8qukru
34427	payment	1397	1397	1678	1	1	13407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDi9ZySpSpWtFdsKCJqbTn6BuhQjLDDZTd6WXPSPjQ2gce4At9
34428	payment	2134	2134	1874	1	1	3895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwjiBoUAsiNp9GfPd3qM6r6qRevDc9xRYvVBkj8XuwsfELJNX
34429	payment	2133	2133	1874	1	1	3813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmw3gSPJrmgVcXjB4iVCTWppcBJ6F5xxsRTLUv2HKZU9uiRjDz
34472	payment	1397	1397	1678	1	1	13417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeW5Ptbsd6FRi68TJpxx38uZjgqwqHNthJwPxFeFKUqhsqtp6
34473	payment	2134	2134	1874	1	1	3906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wnou4FoZ6A7jxL3caLpFPe6ZnyhkoArEiBpdJuNQjFCF5Uq1
34474	payment	2133	2133	1874	1	1	3824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7puTUtx64CoE3mo4psCxUYWc8kbsooAhHrBzVDsvyinWYpeM
34478	payment	1397	1397	1678	1	1	13419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWbUwfA61RJ3tSEp3D5dns9J3j6gw5kpuXGLhS9JJMq2VyC3C
34479	payment	1397	1397	1678	1	1	13420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvhzgZUMHLNWkMiUhcepUnfscwbBjysoDg1VpUGzUsC8q8CnGe
34480	payment	1397	1397	1678	1	1	13421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVjf4q9HQWiRWy95qdL5GW13JBuAvkaazNAkkntDb8nkeBWFK
34481	payment	1397	1397	1678	1	1	13422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkyTbCXqP7DrsyESQyJpuWKibHFQLVD89R8YNPDMhJ3vF6Ct3
34482	payment	2246	2246	2112	1	1	2	2686401101924	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHBK3PB47r1RGqqRJ7Mw4qoL3ps7amE2ojCQFKSSXuTfqdNbgt
34483	payment	2132	2132	1874	1	1	1103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL5jcfzkqDezNvLSowLkK6FfAyjaVpAeRWmRR1A5NARmQS62X
34484	payment	2132	2132	1874	1	1	1104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSoh5Wfot9vtHB3m4FeXsq1N7rRoFWJaqgvWwwUZ1Q3KQ9bHKX
34485	payment	2133	2133	1874	1	1	3826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGWJm6X6apBst7QYxQW5W7M2NzVQvWAxpxziqmzxPCx3BUroNa
34316	payment	2133	2133	1874	1	1	3782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fisg6zMht7yt9EWhQZ5y99TEfBYm4WCmZi8m2t1oqzEJ282A
34317	payment	2133	2133	1874	1	1	3783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpY6y8gdMXMMc8s82v7epG8URwNwntwVc7UADKrrtd9pFGD54e
34318	payment	2133	2133	1874	1	1	3784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8dHX5tK2tUifR8h2YExTuMQshEhH2WRqZ3wDvmUQ3Ejw3nEa
34329	payment	1397	1397	1678	1	1	13381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8NseJJApdcwnp5QcGJ8a1ur2X9pVFxWeZoChkfqP92nMPVcg
34330	payment	1397	1397	1678	1	1	13382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcPEwFZWU2QrQWoafUwCJh5pMs5QJNuqA1rSJsDydRFzYMFNfF
34331	payment	1397	1397	1678	1	1	13383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xApTLjPqooM2bjszyyZL4EyUkSQgTdQAzJtkE2eP2p1AciK8
34332	payment	1397	1397	1678	1	1	13384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFYRK7qhKxZqTqmeLZqxj6WQg521MqByoHLJXgiFaM7AA9owB
34333	payment	2134	2134	1874	1	1	3870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAMChAPQhwv8XaN8YQmifgLtojAx6Mrc4hdqPmoJqvjTMMXET
34334	payment	2134	2134	1874	1	1	3871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2VMGznec1AXE1pRFReMbicMSiz27ARcrJFtFHTFavyV7WoMAd
34335	payment	2133	2133	1874	1	1	3788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGr29jSrGqTCaSZ3F7YsmsF1ErkaR5vsPFnATvhKiXjvvuhAP7
34336	payment	2133	2133	1874	1	1	3789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mYcCqcorbo1vHmkdac6yLYG6nLQFBkTgUcT4B58ZMCJVPKC2
34337	payment	2133	2133	1874	1	1	3790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4stKzTGQhPQzPK7nSHRsEAZS9Fv1kVQmBcVaXpZFu5NHX3sLa
34338	payment	2133	2133	1874	1	1	3791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JED7e4ZixC5r2TKr1mKm287y3f4nNnLcw3WQyDLr3SwzvJBt
34339	payment	2132	2132	1874	1	1	1092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnuMwkPZuxekbLCNSXECN1gvvw19KTt3XzLQ9Q6CB2x2wJT1D
34340	payment	2134	2134	1874	1	1	3872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxs9XN4t2hqJi85nrBz7bV1291Ceq2X1spPwJNu35fz4JhYDat
34341	payment	2134	2134	1874	1	1	3873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGVW3FhMNLc5U39wkHoyhFddiJesTNjY7fU2VPJXxzoJ8bw3o
34342	payment	1397	1397	1678	1	1	13385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcK5i1qeLuqDuGxyx4NZKWhYJ35ZspYX6pFuKEP5duXLZcM7wV
34343	payment	2134	2134	1874	1	1	3874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbxw5ReYDDegMz9ts2zLJGZJoS1GiMy6nXszivncjmf74hU5vn
34344	payment	2133	2133	1874	1	1	3792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbCe2Qmv5MgPznH4jqw2F1ZYM27xf5PxSUPRBqFKwhuEVXpki
34355	payment	1397	1397	1678	1	1	13389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgATUxwuJMMu71D7KD1qhxTacftqryDJZUs8ZrHe9PM1HK2myT
34356	payment	2134	2134	1874	1	1	3878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5FqUJDAkWohFwsKGe4XjorAAnR3rT8Xsg5sd9G7qTqKLm2qg
34357	payment	2133	2133	1874	1	1	3796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLbv7yX4GVANtUJXWL64CzNZHMZAJeidmFn5BArgGSLmDjFaq
34365	payment	1397	1397	1678	1	1	13392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCyr8GGKPMtXRnvKnvxYRnwy4EvgzsUchJEhxzhRkYTVXgEfZ
34366	payment	1397	1397	1678	1	1	13393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hvcT6Bx1zdmYFwXMK2VyM63GXyjTmmKWNyAyr4EegeStcdE2
34367	payment	2134	2134	1874	1	1	3881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcPctUAfDGG9Mkzup6Jf2CsuFR1XzUtHTEfbbYwwSwHPx9EbK
34368	payment	845	845	2297	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3ir6ybDYK4szaL9rL5xzAP7AhPTbhuvakvq2rXbAjp3kRz37
34369	payment	2134	2134	1874	1	1	3882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHxCUdZHZYMeysFtCh8NTJ76z1RPdMFMUtH3skEqE9KmbZTqA
34370	payment	2132	2132	1874	1	1	1095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QYUvF9fPtun6YGkJZftEWpBSk8HTFfRxnc4UpUCCPZsCpufQ
34371	payment	2133	2133	1874	1	1	3799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSH5TtRxXVrG7iiKBg7keZLiQ2EkT9R96TojkoLaUPGDGkZB2D
34372	payment	2133	2133	1874	1	1	3800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcs7YwFr4rZZD3Y56LeV7ZjByadtYkYYmQg6y3XpEEKG7WVjr
34397	payment	1773	1773	2298	1	1	36	82793760832	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZk4Vkkeu1K6RfNtkVrEDAWVWU4VjfyVCEWCt9FRkqTaymicNbs
34398	payment	1397	1397	1678	1	1	13401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFkRL8Wmk89T4eQfSqetVwjpJQhk6GNVABGZ9czT4diCBTZ2f
34399	payment	1773	1773	2298	1	1	37	55195840554	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZxDrCsfhfvpPRmnmEqF7K1FkWFtCBTgzCnd1JBSBuUXwY1vhEA
34400	payment	1773	1773	927	1	1	38	629968031574	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ2vYefqT23JzQT9yLPUZnErcDD96TnNTgiNVWkMpBCbFG72Vuw
34401	payment	1773	1773	1047	1	1	39	1128897315014	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZ8xo15TJExZvza92BfDcyUKQhFFhtmAGBvf745L9XiBLRRKtZ9
34402	payment	1773	1773	1167	1	1	40	760442349765	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	Ckpa8MUvLEMh9evWPhUZGzRVwRgzXJ8Zs5vAUYJwGNSviiSMhsZHG
34403	payment	1773	1773	1293	1	1	41	2122515554495	10000000	\N	E4Yrzy9crL7NmRyoA6Fu8bpm9bRDBc8CHZF2VYQBNt1YFd47GaHJv	CkpZJDmaBZCk5xFDpd4Tr4HvRZVWbcC3TNdS81ttBosx8ysuLWyEj
34404	payment	2133	2133	1874	1	1	3807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFkinxgCyW6GnwMtn1i7bHqgHzzbbvkaGvBHobB9ViKKt2AQ1
34380	payment	1397	1397	1678	1	1	13397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmTLQbXHSzYmxYPmfUKPhHG3yQ4P6JiowndqryxgjpEmjHDUW
34381	payment	1397	1397	1678	1	1	13398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGUQhiH5rV7bMeREauSJyefXTf7csfDCJnCPaxYmtjdgYfEDo
34382	payment	2134	2134	1874	1	1	3885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA36EBMxeiEuQnT4r5s3hDFf2rgnFLzs9pFoGER2N6tEDAvri4
34383	payment	845	845	2297	1	1	1	3471784111139	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDQjWcmuWfgkRswHiT4HvWki851ng74pZWQFcWGUTu9AJtKpC
34384	payment	2132	2132	1874	1	1	1096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSWVHsadGjW9nGssLYDrTNP6hE4kZqb3dv5KUL2yU5bVAovUq
34385	payment	2133	2133	1874	1	1	3803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQT8VxEKFqjSSYEYk82XRfa2V8gmqu6pjJvXNEZaX3kQzmpPzz
34386	payment	2086	2086	1773	1	1	2	3775000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsPekRZznRUP4X2q61CekEz5SbjSL6zc6BtDcWtQbdnGpFTyj9
34387	payment	2087	2087	1773	1	1	2	1004872852234	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdBB2qzez5UuD3wn4bDxMC5jhyza7AhR1JojerURQ33o6zPzZ
34388	payment	2133	2133	1874	1	1	3804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49DkcyoKk6fWyYz7xCxFTWCLaUe2JXkSmA2Pc45UTvorW6tca
34389	payment	2134	2134	1874	1	1	3886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NnUewFPkcDRyRT27gF3zdKuMrmevye2zsMZVWnDicmBUhjUq
34390	payment	2134	2134	1874	1	1	3887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ogXAaJaVQvbqWA5XAPiQfjtqp9dCgYjGJ2mMVsnRoiayLnX5
34391	payment	1397	1397	1678	1	1	13399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYceeX6gWNvH4en9KKrY5JSux22tpzTRNYaSUezMYqwkw8mMXCk
34392	payment	2134	2134	1874	1	1	3888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6Mg7wv88fTphL2xraHW6QaepeeFcEPK4X7VmGEvis2hYYM55
34393	payment	2133	2133	1874	1	1	3805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRKRb42f3YiuTqUfps9fjPNJdAKFt6QyHHNyLUbM7uAhebzNS
34421	payment	1397	1397	1678	1	1	13406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5U5dsv8KyT2ScHewERC3rPiXotQHFK9q3JePi6UEJJ5ctaad
34422	payment	2132	2132	1874	1	1	1099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Vw2ot2q3sAzq78w4t1WRkjyqroKYkHThJY3JNKqDS4MUjPLg
34423	payment	2133	2133	1874	1	1	3812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLdoMPBCsp51dUCCGTY7UJXQ8pnccFuC3RbBSj53PBfP7aaR8F
34424	delegation	2298	2298	1527	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxjwvj1uz5xZVRcr8XoEUp8xzJok6HLVnrCN6wwQpgCoDDoP3H
34425	payment	2134	2134	1874	1	1	3894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1d8fh31taGMbUgBL6djNVypaWdqcAYZCxccm7W1q9JLi8uNNS
34445	payment	1397	1397	1678	1	1	13410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpF5fbi7DPbNRHVcKcYEzztTmVsLEbEY6qKw7eJnFtSDnXkgUu
34446	payment	2134	2134	1874	1	1	3898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnU6YAE83YJAdu3oemL72w9HB3GZQLhbDnf62DrgMmyjYRCjuA
34447	payment	2132	2132	1874	1	1	1100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsoHdKSLDeN4Fi5kdoUiRfZAZN1suSrUUG2EUVg45XtScJy8nS
34448	payment	2133	2133	1874	1	1	3816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaqn6fLfbboFerADhhV1YvXdE2xhQviY6w7wHQw2T83rMs7n7
34449	payment	1397	1397	1678	1	1	13411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQud2ooXUq6MizhKfqpZDUnBVAbhdsqW4wqPtEurPA9yh4MtF
34450	payment	2134	2134	1874	1	1	3899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvtRRcNP3qcvHKvRqqYoNnn7ezyEdcGmAJrN7V5XeJiZrBzT1R
34451	payment	2133	2133	1874	1	1	3817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnWEWkAo1vN8x3LBN3NgPcBGUNUq9wf2ykWdC8x3mqsNjXt7t
34452	payment	1397	1397	1678	1	1	13412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnGDBR5UXpu8hBpG496Q7nXxb89SfHXyDq21Cyqg65GsiYzxW
34453	payment	1397	1397	1678	1	1	13413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQs4AzvUARyq9entFLJ6SJcGfefJHuatPMUk1nhJVtcNkHBNC6
34454	payment	2132	2132	1874	1	1	1101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wR9XBVh7snCdkaTZ7iuUy5cjzaWjGkk3gWS4nWfL3REbjN9a
34471	delegation	2246	2246	2246	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpqmFiChYKyYQNa9gi34SwphuJBAp5G8ngJhxorTpJ5W6U2cMr
34475	payment	1397	1397	1678	1	1	13418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFs5mpnmcfJ62x8YUDMsCL47yjgA3ywRe8sNq2Ss1qKB5eB7h
34476	payment	2134	2134	1874	1	1	3907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXr4v7N4cyrhQmdXWzx1w2tKxb3Mi1yHFkASiJ2rnJTSmCLJp
34477	payment	2133	2133	1874	1	1	3825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZADtaip2xxgGYFcis48UjZnntTW8YAWrx38wAbRtUT4DuW9h
34497	payment	1397	1397	1678	1	1	13425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDxi2ZUywf6U65PPofSU6N7MiPErADzgp5CBcFo6tzX6ExuyZ
34498	payment	2134	2134	1874	1	1	3914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xvhMtYMd2nWxpiWwcZQp4sPaAoDmx9JFmqa4ogivcdpU3t2N
34499	payment	2132	2132	1874	1	1	1105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoD4xP9AzxJcMTBJN9jnb53eFz3q7pGBmSUbYzg4Txgcrjz3Wy
34500	payment	2133	2133	1874	1	1	3830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kX3bbqY1ffXrYR1ffkbHcM6ZWdBh6NFtnQrGQgmpS4itzqnK
34501	payment	2133	2133	1874	1	1	3831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiASZo3x7TrTzPBN7r1gnxxburtPr6yhmohTK2JwiY5eUnW88F
34395	payment	2133	2133	1874	1	1	3806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rvzr6vbQ1r3Wv9iHx7a3XD74eQoqotXQdmsx8vMTsfi8n4qc
34396	payment	2132	2132	1874	1	1	1097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbib4GF4WC6eHfnKLS4NnteiuwcD7wuBGKbFegRxqTyecSqmnJ
34416	payment	1397	1397	1678	1	1	13405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pMcqvELxcr4ZmmuFPctmpztcyKgDhrGViPgGDnEuh7sSNBu6
34417	payment	2134	2134	1874	1	1	3893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SSgQD84t2wQm3ibQiGeZKJwDPUA4sYJSsdek196mLT7o3vUr
34418	payment	2133	2133	1874	1	1	3809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PZ72U6knviEMTwbArN3V8iMVDayaBu92zivN6baQcN55gRXY
34419	payment	2133	2133	1874	1	1	3810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGYXdvqm9gY9G9HX6mzHrxh1a8oeUSdmX1wFyLk79wYzm9tzx
34420	payment	2133	2133	1874	1	1	3811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJZoD1axMzCTeWA9AvbBqi8eUraT6uf5NdxGk7Pqs83LvHboP
34430	payment	1866	1866	481	1	1	24	139034079529	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZp8cnoqXkPr9oT8Ty3gfmrREUQt8rm8MPNKnQiCNDJ17ZSfPGg
34431	payment	1866	1866	734	1	1	25	4213153906	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZRyfFYK5gEijmV1zqZv1TQ2M38tqCEeh8CddMu6WxKNqhTGJRY
34432	payment	1866	1866	845	1	1	26	1207770791681	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZq23SZXYBksh1wSHyzWkAidfSkjvSW19GH3pv6Y5YckCMkv8SC
34433	payment	1397	1397	1678	1	1	13408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktzHiziuC2HTPGc6ktnYdX9GBgKHEdSWqCKPg3teLpLujxAP1
34434	payment	2133	2133	1874	1	1	3814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFdw5KGJzLfVEKCVoDxpSWa6YdunPwHPrt9jRavy92ebAFYST
34435	payment	2134	2134	1874	1	1	3896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2BySjyhQQi6x2pNCiEB75KqEPHbo2mTxKjTnVtHqJu94tDHN
34512	payment	2133	2133	1874	1	1	3834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAkVg5eaxTQvc4WpbVuihbLNi4HTybEZYR9WoLgG29mxk13Fw
34513	payment	2133	2133	1874	1	1	3835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZarhuNWCQ1RshrTgRbGeGNN4nhiGAdAj46oi33Y5Po1BnWzyc
34514	payment	2133	2133	1874	1	1	3836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLhq8TezPp88aw21k2i58cvRwt1HvE6gwCLEvXzivMYGPsu4D
34555	payment	1397	1397	1678	1	1	13442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGk2EgWfRpB2yee84DZCWycjqeby6jf9natENHzoUDn4yJVeKC
34556	payment	2133	2133	1874	1	1	3849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnwDTgPhNg34BzZ1in417bGPbKEsX6JAjyFCHtt2Pb5JHGJps
34557	payment	2134	2134	1874	1	1	3930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3sAgKY9ibxEV3guvg8wfPrFE5bEqGy7rsbp4mmwe4mUfMERd
34558	payment	2132	2132	1874	1	1	1110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEV2hbzVbGG7iiabh64TBvsUUhZgLvRx1rJ139BBw27wyvdLNA
34562	payment	1397	1397	1678	1	1	13444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEFwEbkQuAghjfRAiy85WJm1EW6BpXxSUJNaUGphawZpfMtBx
34563	payment	2134	2134	1874	1	1	3932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aYBtGW2Qj4ZUceHcMstZwaJow3eT1rE5ZwQqpiGAuVjVUENX
34564	payment	2133	2133	1874	1	1	3851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9opeQKKu6hUVwYwwZoWkQinpZFsBq8GwkNFcLw7oaovYMeiP2
34565	payment	1397	1397	1678	1	1	13445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSinRBqmcFRVmzR3tY95kS2b8rJMfQyY3B1GRPbtpdDDR5ogh
34566	payment	1397	1397	1678	1	1	13446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdTSXxLZghh2EucnDBbteQmbuUpYbw93c2ZBYxignEtDf8frx
34567	payment	2133	2133	1874	1	1	3852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXCaCd3WU35AJbGmRyP9Thv8viwKn9naPiq4zWKg9A6h5JAj1
34568	payment	2133	2133	1874	1	1	3853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Gd87YmNXEQ9g2WN8KkvsWqVCzJjq6QDtaf65NTRqrsiX8h82
34569	payment	2134	2134	1874	1	1	3933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMACHDpNgk6kshwnmMEZZsd6KNTV21dvfbcvirCzPMXUywv28
34570	payment	2134	2134	1874	1	1	3934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxYpMfBkMCQwn6iiQh89GeyvzDfQhqHLmMQ4ZzgZiQNgi7FAf
34571	payment	2132	2132	1874	1	1	1111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5d6JkeicSDbZAeZqSu3wX1a1DfPXG6yPU9jgCXSsWNRN4e7Sf
34578	payment	1397	1397	1678	1	1	13449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqrKLvmLesc8fL3vegQgK6Y8ttsZhsraZPuJS3KUpQZv685X5
34579	payment	2133	2133	1874	1	1	3856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFLtmXYSt1juuZFxYdtATomFQDNtazhQL1CXifQcJmaQypgKw
34580	payment	1885	1885	1816	1	1	3	0	1000000	\N	E4Yj1dXBXdoJ27GYatUhiLhhFHo8WpTkFWQCKwStkSKBsLxy48hon	CkpZVMiwUeEt7ELHPfLvr1YvVDcSgcGCSQw7a2inL5NQU926RTbsk
34581	payment	2132	2132	1874	1	1	1112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbEX6Uwaovi6Zac4KrF3cXPdqmyhd2gK1VvWgj3fAK8mpAjS9
34602	payment	1397	1397	1678	1	1	13456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyTX7n6t1SnJRS3rg4v1iXMqNErj7Zr5Q45SwvzYFxTVi9Zfj
34603	payment	1397	1397	1678	1	1	13457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUaRnWcQpcJSoBtrjiFR3Ucp4U7FeVbBsnQP2L2rEzv2uwq8Q
34604	payment	1397	1397	1678	1	1	13458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DDgo89L1y1aqDewdyvLMQVoaVTs6PD3JpydEY5YQRtN3qZDv
34605	payment	2133	2133	1874	1	1	3863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFX3vpP5p34pfhUXMDH5jEcYeiW472q9NWWDCJrJ28UQMF5tan
34405	payment	2134	2134	1874	1	1	3889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJxjUqP4NGTtswttgfgPj17iadErPFYa5ymqESPQv9wDfBCnJ
34406	payment	846	846	2297	1	1	0	3473785111139	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi46yE5FcyP2kBWfxXazokhp2YjJ1dcxL7TT5hfGX8twENKZ1m
34410	payment	1397	1397	1678	1	1	13403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB94aqaxPQ68926g6F218xXxLXHR4V1wygetTCYRWkrvuaPdQG
34411	payment	1397	1397	1678	1	1	13404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u9x1XsS8kcePb4GDWoatFi9RinsR7x8bcrHmt1bzRt8RGCd7
34412	payment	2134	2134	1874	1	1	3891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbNKAHorC7Bu4bX1jP7wAFwoWpiL8AVJ5RC8PiNxAMw2PG5eV
34413	payment	2134	2134	1874	1	1	3892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6c7GP7iJizvsnGwMZRTAevu2ND9GYajXbsWPvWfGw4vNVDghi
34414	payment	2132	2132	1874	1	1	1098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZVvG986ea4Sk8mtXYVwNTqkghrHLvrj4wUEbmnyhiPRXLYbR
34415	delegation	2297	2297	1647	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnHBTuTEoWBzYUQfDVpMWAN8M88i7MfBuy7hh37VMnTYfWgo2
34436	payment	1866	1866	846	1	1	27	1207770791681	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpaBiupEPkFMZRp236BgTZLgouZ21hzwg2t5gkEp9XLscpHJ46qX
34437	payment	1866	1866	936	1	1	28	1117902708752	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZy9MXdGyQfypECUkYLgM8GpqJSVGHi2NwyfwHDAWnz8pxEsgUa
34438	payment	1866	1866	1056	1	1	29	2003272075893	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZ4MzGWue2aSZwoT1D11vwduSHna88mvF8nBEj352pbYUvp8qt5
34439	payment	1866	1866	1176	1	1	30	1351647587623	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpYe3fwsHVA8uDojWvvbkJefAJj97PP8mLAjbFVJ2S7U3GksdwUD
34440	payment	1866	1866	1302	1	1	31	3766486184719	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZTCesgp9yWyNm5jBW87t1XYHfbSvwmLg6gcMbUzXZY48RyXd2z
34441	payment	1866	1866	1687	1	1	32	3835744910	100000000	\N	E4ZLG1BiofwMp5g3XFzhWjuZDaATLhmVWGY2kxgx8ySr9yTRkjVNi	CkpZhKU6ddp13THMYkR71E54xetPY7WtMcKCZgsF4uZixNySmedGx
34442	payment	1397	1397	1678	1	1	13409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4chHUSAWj1sRRLEKghr4YiURLLEkS9jg2GgkQM9fzJ4WMFb6
34443	payment	2134	2134	1874	1	1	3897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5Vj1eD4uTRb1fZsqTiHR26iijqTfuuTbDzpEmHNrdzDvKmVM
34444	payment	2133	2133	1874	1	1	3815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbYzuABUQT31cR2a6FBcVUoJ9pr7pWC3VCboXvQmkjuNXqPTX
34455	payment	1397	1397	1678	1	1	13414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cse7o3p2duqskeRYpnV2vUyBEi4DESniope9uaLVj3jQuvuU
34456	payment	1397	1397	1678	1	1	13415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZEj8h1Z7x4Xna6S53gXaU7SVoPpnfUzdqZ667JzRxwmKWMm8
34457	payment	1397	1397	1678	1	1	13416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNR7qMMTptdqngQPXJ3S7yWAfamhDNU1pV1d5nHg8GpMy2E2X
34458	payment	2133	2133	1874	1	1	3818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVBnp5x98oUmX4baYqTZg9qWgZEUt4fZhzCxKs1AKV42NLYqE
34459	payment	2132	2132	1874	1	1	1102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKai3C8bspi1eR8n6YB7e22BX5U9NfZNQarSZfE5iU1mahcqJc
34460	payment	2133	2133	1874	1	1	3819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmB6JBxPtNahsfie2wiiUGzpGsTVqy1tfRjowu87KCejGtacq
34461	payment	2133	2133	1874	1	1	3820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8egKKibCQCwKaGYCGbVBCk4MvBFUaPjRJxyMrxBHmuY3GttwE
34462	payment	2133	2133	1874	1	1	3821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyo6pWqEfZB8Xx4HTTpcF3eUaBGw2vYEyDS9tJx9hW2Qj7RxVR
34463	payment	2133	2133	1874	1	1	3822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcLJScWY5MhLyavW8cRtkcLooigZTWZNnqeKuity6DTbQrZxv
34464	payment	2133	2133	1874	1	1	3823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFmXHH2ne8P3L7iNFE6ZTos1oG7ffwUoXQuwJYz6kgRHsz6yz
34465	payment	2134	2134	1874	1	1	3900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEkjbsQQjmExLpL2geq5aRSSaVTwimU6Bkt6uUqS3DM8orHFv
34466	payment	2134	2134	1874	1	1	3901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixQ9TFjVhKcc1Vt2jxE6x45NgzgVUvtwmWrkng78iBrDguqir
34467	payment	2134	2134	1874	1	1	3902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBaSoCrgt64dSwZvqD2T3WjpP2HNgdtwt3BKVT3BWLHWFtpRJj
34468	payment	2134	2134	1874	1	1	3903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtmzgiggWo6MNukSgpzLMEy8vZQ4ydzQzpBmp11ZRmrhvuKBS
34469	payment	2134	2134	1874	1	1	3904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzrgUoFhCT3x4iKXq779d7j5TW3PDyRkkHPS6yz5q3AtfgHLNc
34470	payment	2134	2134	1874	1	1	3905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotdG8AQ6imakyH6RvASZzmDsEwZ2basHJwC8Sea29bgZ9Akds
34493	payment	1397	1397	1678	1	1	13423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdKZUVVhdB1fzzDqK8KsibF2CYJEY4CZWxuGmt22s1xohZii2
34494	payment	1397	1397	1678	1	1	13424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvu5LHygreViVcTpZhvHxfyDmiSVTdeMuN22qr6saCriE3EPJ
34495	payment	2134	2134	1874	1	1	3912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRRFdQX2YmX1cv6A5rFTZzYVrERdY8LfSMMouTkrZHg9WHpQ3
34496	payment	2134	2134	1874	1	1	3913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAyYC8TfvS6xAjsjp6rdotPSga9aveWF6tdnYx6xdC6MmbqXP
34518	payment	1397	1397	1678	1	1	13431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2e7jmcCQjUXigKrvmWao1DfDmkuwMMHx7rQFhzMsgqKAiTbZV
34486	payment	2134	2134	1874	1	1	3908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1M6PhsBPkgyxQC58uKbU2nARVTivzti7AWDkBxauGDNevLsmq
34487	payment	2134	2134	1874	1	1	3909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrscGsngqMd9WxwnCB8XMyqxDAL9VFnM6DLBascxaKr1zyYoSK
34488	payment	2134	2134	1874	1	1	3910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwaNY3piJZUJEvCW5prTHPBkuLAV4DiNMV6U1Px8esdxy2kpF
34489	payment	2134	2134	1874	1	1	3911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdrjpKgrFmhN5boYnqwy6HJo3Ujpnairvx7fQKPLieXbSzGC1
34490	payment	2133	2133	1874	1	1	3827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEQnoAQEXepJZq6Fhff8wecFkMezF7Jdp6EFJxscJ7kfRiy7H
34491	payment	2133	2133	1874	1	1	3828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTZeNJGDV2ZM9eLE7FNGfZwB4WtSJoL6DB1zwDRqDWAP6FcV2
34492	payment	2133	2133	1874	1	1	3829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEfENjn2YotGCi57VsbGmXQgAX5aHBiSKr8pb9tujSGXHux7iA
34559	payment	1397	1397	1678	1	1	13443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtorpvqUBjPbzn5bzTsTnvQR84WBVYhGa6SkRVg22VYEvvf7t3
34560	payment	2134	2134	1874	1	1	3931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bHudjPr49fVcxBrgSAFfyAveNFgRPtbDHifrV5R3nCKAyuei
34561	payment	2133	2133	1874	1	1	3850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLahkRTro7nXMm6iKBFM2P2BjwbqY9PE2it3wWyYvRQhPd4cS8
34572	payment	1397	1397	1678	1	1	13447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFHT65GHVy41Dbvnguf5dDinnbN2gdBxSFtKTjQ8iTX4TJYU6
34573	payment	2133	2133	1874	1	1	3854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVgC62veTC5j5TvZvvqLdYctNFiJ6AxHQ96aP1e1ypzXAtKQM1
34574	payment	2134	2134	1874	1	1	3935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYUmh7mcmQYhsywdgBohEK38AEjUHdA9JnWJzQ9xeijmQfJKdo
34585	payment	1397	1397	1678	1	1	13451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYado3YPew1Vpo12xecvnRQNRJ6nVar1eXqGJQkbT4cPMmC2Dtz
34586	payment	1397	1397	1678	1	1	13452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sL4cAKfWLcoEvJYGzeadnEZPQnuDvZaRkffj7fFQRwReNmuf
34587	payment	2134	2134	1874	1	1	3938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpw97QBbiD2Zj9U1uFhCJ1Lejsg8SDHeivEdyJW64urpMgUg5
34588	payment	2133	2133	1874	1	1	3858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjMgLSBmSN9DanmxsGiFX8hcK7EAqBLn69huukrKkUTNw8y5g
34589	payment	2133	2133	1874	1	1	3859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXh5xiTfAunoHjW1djYtKjSypotxPeXK7eh2fQa7VcCSBNELcL
34590	payment	2134	2134	1874	1	1	3939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk88bofPLmRkQMvUbHqj8vusV9QqvyUDeNrie7uu9PWCNzWrXZ
34591	payment	2132	2132	1874	1	1	1113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbacqpi4D99FHvBvNGLKRXmdindRyQFvJ5Tzbu7WzLK8bb63u
34592	payment	1397	1397	1678	1	1	13453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kK8ZRJLfWg5eYkvt6NVRq1Q1BQrddbynNto1e9bAyrwvErxj
34593	payment	1397	1397	1678	1	1	13454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNgdikEhJ8FmChsfrzBBydhdG8RHFD7P23AvC7ryLhsidtzfp
34594	payment	1397	1397	1678	1	1	13455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbV9LP4i4XFPKkPjjDHE8m64sDTYXLcNqoiuUfnxFnqHbDQCk
34595	payment	2134	2134	1874	1	1	3940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSuxqRLbVCC8PGsdX78nSq12o8KvaXPGJLEQCpSCDjG8uLmsS
34596	payment	2134	2134	1874	1	1	3941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTgqgpKVsYVtT2NgW9F9BLcBZ4YuDTYHgUS4pws61pK3eG27d
34597	payment	2133	2133	1874	1	1	3860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehinVbo7mRXFuZ1QjLe8BQ2wY9n34egBY15fxCELBPS4sZfer
34598	payment	2134	2134	1874	1	1	3942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmpueyaQSCTEErerKA4RsLfAtBiNnHFRn54JrvXm1tpjQb3SiU
34599	payment	2132	2132	1874	1	1	1114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgN4TKyRHHdC9yz8NgtNLhdeQhVKZf38RiZGjTC68f9GbTM9F
34600	payment	2133	2133	1874	1	1	3861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa31aTPQ1aKgwUSLJ2kDujTMEJZbu7zzQMArrhJp5Lx4ExySUKM
34601	payment	2133	2133	1874	1	1	3862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTuHxYcKRF58Wq23Yq5ii1d48uU11JFvKopbUnNfjLQbD3xD8
34638	payment	1397	1397	1678	1	1	13467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmcYZSLwsdpLdNUbmySVJyu9L9VfTaZsJf2CqRX7hCvpHontnr
34639	payment	2133	2133	1874	1	1	3874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrStMLJXLKXZGUaYLqrPc7TnLU46HXZZ1VzKcEZ7tZsmpAFiG7
34640	payment	2134	2134	1874	1	1	3954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbM5Q3vxDbA1oqAqgQWpQsd2MC3Hoef1xPVMEeDd6qsQbWqXAh
34641	payment	1397	1397	1678	1	1	13468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgYczgDiXKMTLRjVw3yeMTjDX84u2mdbXAkWP1bzXK7M8NQx2i
34642	payment	2134	2134	1874	1	1	3955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4egyCffqj8gZboGr3Q8ZvTZTPfeuzJjbkH6ytdgP1H48r8x6m
34643	payment	2133	2133	1874	1	1	3875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCh4tp1344d73CSwGG6RkF5KEHLLqqzZT2uRQRJkWGPUJhBofB
34660	payment	1633	1633	1264	1	1	9	2124134764356	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZ4wJJtnqcLWHXBzzPHo8pZNWLiusj2o1Rx9dvC3EVXxkbwddXs
34661	payment	1633	1633	1144	1	1	10	3148172569418	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpZLoUzsaeGoUFTSmd6MH4cp1NFJ4TBP4ovRjS5pN2qGhnjJgoHw
34502	payment	2133	2133	1874	1	1	3832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHW5mJy5pDyn3vrH3H5Z7V4cD1FaRTGv6P4e57EZeSBjyavN73
34503	payment	1397	1397	1678	1	1	13426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXJeonvvVGedKE4f8dfL6XJ53ePCjxanUmU4p5kLWvyHLJruF
34504	payment	2133	2133	1874	1	1	3833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBaoyJAW7arXGsHkkhFA5Ej57VBB8x1h8BUno5nVRxttbMEA1
34505	payment	1397	1397	1678	1	1	13427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNeh7pHoaVzo1n4qfEUvdcrL1sHPDTdTc3ZECnJtqUv7wcBGj
34506	payment	1397	1397	1678	1	1	13428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXyfcD6Fx8pxzZbWxAbqUVeKMmH1YuXDJ87uyPXR4znMBJUhQZ
34507	payment	1397	1397	1678	1	1	13429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSexikx5xyqoHmGxkms1mWYNMYWKxoU9Zv5vXNCpZjJtu45qq
34508	payment	2132	2132	1874	1	1	1106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5PtMc3StUmYSuMBWVizPXkffmVsD245vxWE5RRWUeq4Wjatd
34509	payment	2134	2134	1874	1	1	3915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrTg4rT1SkqYtqo34w3a994DVY5pLTsvDkcUVi6Vkwus63G2JF
34510	payment	2134	2134	1874	1	1	3916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YJUnZENLWN8YwetgcksEBoG49vfsX8UcrCxrBpCpunjopYdP
34511	payment	2134	2134	1874	1	1	3917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYroKVn7aCZgbN7RhibspAxBHaKXiDcwtUiCQ777buuZKa7vn6m
34515	payment	1397	1397	1678	1	1	13430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPZKReR4u65do1NdxrXKN3cY9QDgiwep5PVVJCoY2C4dk5buF
34516	payment	2134	2134	1874	1	1	3918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsS25DZfxdStCbmQkyNAK81nxZq3DZQutjPHuZBmvNL8yURwa
34517	payment	2133	2133	1874	1	1	3837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPqAiCmdrNybG9BXHpbopuvFoMz6bn5TLtCPMgTBBrsCRiAbd
34532	payment	1397	1397	1678	1	1	13435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDUECyCTvyZkNWcgd5ZWvSjoyEcLBvWGE56R1R2XBKLPhtvMQ
34533	payment	2132	2132	1874	1	1	1108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5WSm9fjrKoaN9ho6xcYxhm8i2UVWagvbQL5NayjorLsQrms3
34534	payment	2133	2133	1874	1	1	3842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYijGh18ZscDDFykq5AsirDFtQ3rcph4hj3ZNcbbUhXGJjHG5o
34535	payment	2134	2134	1874	1	1	3923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9v4QqJVRMpzE4JF54A546x3yevndNACcdBKrNrD8ErZ8A3Da
34545	payment	1397	1397	1678	1	1	13439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWyhScohRMYZRPrDcfoAiDuiRTX4canv9AmJK7X4uiz2f4VNi
34546	payment	2134	2134	1874	1	1	3927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmTqCDqkHPzS4jhhKivB8eXK9LTS1dzH6qP3xY2YmHvqkfx2vw
34547	payment	2133	2133	1874	1	1	3846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqU5HT5dvJe5n49jviiJsZeUuTYFbUh6t2M9JZSVCKVDMBkDk
34548	payment	2132	2132	1874	1	1	1109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCZxRDTFcY2JtQmMmQmSCt8DCNXLnT8TDYEcb7L4UYbmBuNqw
34575	payment	1397	1397	1678	1	1	13448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMLYmSaJjZE5kzwFpB3FeXCo8c9VFGSuYDAJV2PxXYHULMwN2
34576	payment	2134	2134	1874	1	1	3936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqt7ufq6pwpaECRgvu6NLBKHTrdChTq4abx6XLRoio4JV9r6kJ
34577	payment	2133	2133	1874	1	1	3855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZmMKqzohn5JZqNEAc1fM1nKz9J24t4ccYv4SfVkw2Ysj5S3N
34611	payment	1397	1397	1678	1	1	13459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYU5BXUMxM6J1nrfSkgQg7bsMHzaPj1JSrRiAzDr8aq43JW8ba
34612	payment	2133	2133	1874	1	1	3866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDfsTZuNxZcFRCAmZTNSCG9TjG3YrNq9Qi9NfT3opJBxHXEhd
34613	payment	2132	2132	1874	1	1	1115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf84x7Xi19XSBuiyaRj9YSg8beW7PxRJTKbY8iW69jeXCo1KWR
34614	payment	2134	2134	1874	1	1	3946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtTNjAoKbD2YikvyhzjM342X66byGdJiRPVZ2zqG352YKFJPCf
34615	payment	1397	1397	1678	1	1	13460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExmKF4ypneZCNodvdQyuijrpDbeqNtuhBbMR6LwrEiwMLVyja
34616	payment	2134	2134	1874	1	1	3947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFF6N2LvQdvXwGNE6GdpHvoXNN1Wc6xHVjRdXw4FZ2kLrqs4y
34617	payment	2133	2133	1874	1	1	3867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoR262pEaWRZEGSjM6nkSG7hQg3v3rU5oFokMuZh9QuZK6M5t
34625	payment	1397	1397	1678	1	1	13463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4AQ5bMmwRUR4UPakqopxbQzPaqNuSK2voooLLNLyXsJTWwVA
34626	payment	2133	2133	1874	1	1	3870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJDygRoh678HVqfaM9jYjcUED1rh6HZsmnTzkdAyrpwLiVers5
34627	payment	2134	2134	1874	1	1	3950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykdwbjfwWJrncuhAJE5hZceTJ4wMvrJJt6tAdbSDEByEa7Px8
34628	payment	1397	1397	1678	1	1	13464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1szeeuxUfZ4ecVwJ8S9u3prfqvVsZw7gbyhLqG4Yq5bBX24Q
34629	payment	2134	2134	1874	1	1	3951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzN6TrfKGm8C384noEtWK9Mrk6gtcHo7Uj21wn2HhpngtdSc7W
34630	payment	2133	2133	1874	1	1	3871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRu3Tm1kDPNDWXUjjQEQm3VNxEbuWF1VhpRbgkrgRFW8e3Uz5S
34651	payment	1397	1397	1678	1	1	13471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83Pt8WNHnEH2tRhuEgMw13n8HGyizuJakhfXxXkx1HhvTUkcn
34519	payment	2134	2134	1874	1	1	3919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJpnL19GQ67CyiBNhFoE1fzVBvYZREUob9H8yorwTMpLCeRzS
34520	payment	2133	2133	1874	1	1	3838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnt7E5KRjLxnZuBR7Q3n6Z3iecf8ie3fCRfpAgPNshkpWvbKRQ
34521	payment	1397	1397	1678	1	1	13432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfbuoMoZ5Yk3Ba34oYyfg6PkpF8X6SjuhjtBN1nfwNtFXwnr2
34522	payment	2132	2132	1874	1	1	1107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSQeGQ83Xdmys2uZwFeEANCMVY3oexBnzeDDAsneyajoEZKy6
34523	payment	2133	2133	1874	1	1	3839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XYve7jFXBgDDhe6WB5f4qAyVjfxc63cZDTgJAub3SWYvSfNf
34524	payment	2134	2134	1874	1	1	3920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT4psJXcUCw4UsStuGeLfsYDif5q1cBnqMommHFE8Y8mq9gPy7
34525	payment	1397	1397	1678	1	1	13433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkFz6UD7DyxX2am2X81W6DSPGk2p29vXNYJjisCDhstbcAvj1
34526	payment	2133	2133	1874	1	1	3840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjr81HHG5XKS7KvNcf8hsC7uoGcZ6b6f9j7kxMXvQTTGUBs4P7
34527	payment	2134	2134	1874	1	1	3921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrs8LUPkkDahZuEFUTArMiYV28oNZqjuVh7oMf4WYH9BnBHWfd
34528	payment	1397	1397	1678	1	1	13434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybB6xDMVoG4QLnqqY1kk7UoLzwz7XAajUaxY8Jw5Gz41VT8qd
34529	delegation	2112	2112	1607	1	1	6	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2xoizmG5mu2qMm51J4BkCD3ZP4UU18x74QaXZHXfeQcg9zfMP
34530	payment	2133	2133	1874	1	1	3841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6h5S6FtYxDtkPgPsSmceLF4NJfiRs5regRK8Uq3iqvZhEE7Z
34531	payment	2134	2134	1874	1	1	3922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32sMnFuQi5Re7JHzHBKCEGAcvRyBTYG67aAHtsS2rFPh3XkDV
34536	payment	1397	1397	1678	1	1	13436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSErtmsSCn5ZWgoxHWrHDwCbTXuWLKvWSyNGcHCUuGsDX5N3oM
34537	payment	1397	1397	1678	1	1	13437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcs5Nn66gjYdHbPLk9J8G7JrcgkqiFGrdfPdpU9CMm9NbjWf3u
34538	payment	2133	2133	1874	1	1	3843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZxXh84w4ThyYTnqXwS7sxLJx1HRmXrrfbYYCBxeQDnTMRcLs
34539	payment	2134	2134	1874	1	1	3924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrycPR2waU1iJUSRpJPj8hhGPNizQhegJiUK9uunWfqbKRPsxk
34540	payment	2133	2133	1874	1	1	3844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4pUhUWV7Szoa5AnSmSAXqPkE4iQmSQ2GezVF5JXxvuaAeh4Kp
34541	payment	2134	2134	1874	1	1	3925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAAwXecr8PpndLVHTdHqAZm7gCGK38i8vpXz9ERJmP74oT8sCJ
34542	payment	1397	1397	1678	1	1	13438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDP1Nrcbo3ZrVPVwGYgkGbZaAnkzme4fGAxi8YsaRARbqScV64
34543	payment	2133	2133	1874	1	1	3845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSp2z32u13nB712sg27mkdrntzvXtfTW6iAb6Y5e68nUFsbruQ
34544	payment	2134	2134	1874	1	1	3926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAztCPJhuZYmwgqUz7mgMoXKmJbERqiA7xKzn9xDL9brRWoa9N
34549	payment	1397	1397	1678	1	1	13440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6idXoHL7aDpPvryz4t7kdy7Ye9CkAgUGDqCKKfAd6F3WjFGR
34550	payment	1397	1397	1678	1	1	13441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAqxxPeniPMFSphFm219cwC951VqRYJvoswiKtgc2ym36Rbvb
34551	payment	2134	2134	1874	1	1	3928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcoyuyLDLTbQtkrru4znq5jmHBqwUkGK3CbzKwdX6AdzrPhac4
34552	payment	2133	2133	1874	1	1	3847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeykwy3nvXWSMZVuy86ZXjSJFzpwcev1PpQxy6oGevBsefkvun
34553	payment	2133	2133	1874	1	1	3848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMUEZHSiG6wD2pJPKGYzksFiYAnnxghj93c3TNnrJL5fZAVaU7
34554	payment	2134	2134	1874	1	1	3929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7vB5GqtH2tAzoQSfsG2SRkrHaVB8ZPimSqtDb7z3vnhVGroL
34582	payment	1397	1397	1678	1	1	13450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjYxMFRBz4T3HtedMnjVvPNEMYgYPQS46sXf3PVKcfK7ccjxtk
34583	payment	2134	2134	1874	1	1	3937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhfpskM2giJMZDaoz56fBE3yjK8vyjmuGrKQz5a4tuf2BKVRwm
34584	payment	2133	2133	1874	1	1	3857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6uLy1CfATS8DJEBrnDByu7owsNkdvW9ypqP8FEN7wCfx8GQU
34618	payment	1397	1397	1678	1	1	13461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGBfJCbzzPG5SDhsr3s2eJco7U4w1at5ujSfR3AjfzUb56WZhb
34619	payment	1397	1397	1678	1	1	13462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnG6n9bxnF1hLsQpiLDTe566SFY1MvMQe3jqhTNaTR47cQACR
34620	payment	2134	2134	1874	1	1	3948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrD5G1cTVG9dkSgZDy5ZyyJ9B4oTj8rHLhTHP7MJpRAwPTZj3o
34621	payment	2132	2132	1874	1	1	1116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xbyfYhoWTf7BuYk9EcVhpy8XxZEhcddYqoAMXXSFi2T2oji5
34622	payment	2134	2134	1874	1	1	3949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgzk3KYkYewwdookgq4LyTXaiuTW8MWSpkdquBve7dFYwBZS6
34623	payment	2133	2133	1874	1	1	3868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zeso5mBqim92uqMpLapUXUN9fJKMKjkv1Lp983VabpHLMRfo
34624	payment	2133	2133	1874	1	1	3869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDCwbFwkasQSUrbvobj6YUqUuhAYpU6eq5FpFHqRx3iUmdcC4
34606	payment	2134	2134	1874	1	1	3943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcDa9RdRqmt3n1atz9EdvDwkbbUjmRoME3V1te9h9yKLqxAJey
34607	payment	2134	2134	1874	1	1	3944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUpSLM3Zd9vyeuneBWoW62Jtn2dKv4r8BUZpBverkg9DMVnMr
34608	payment	2134	2134	1874	1	1	3945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbzaseCgETmZkrj8f4v24udtk3Uqx6DEdu7QS6DgTEvX155iG
34609	payment	2133	2133	1874	1	1	3864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53946E2pn5sfxaC977KCZ4KDNSMUMW41cxPyJjhhcbXhznLgU
34610	payment	2133	2133	1874	1	1	3865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjunxMijGiZ49S4PtsUiLMfkpC8jM91TVzqU4tjYy6Jqwdb889
34631	payment	1397	1397	1678	1	1	13465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ELcfNV3CXQde7ByJChguPFyepTN49nvwexbv6U2zJkRhAN8k
34632	payment	2133	2133	1874	1	1	3872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNz7BUJru9ki3mxiQwzsY96Z2WHc49NKeUB2ii5GA33cpvxWa
34633	payment	2134	2134	1874	1	1	3952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtJ5cEEdxXuGvBYdZmpdnf49vMnTLj9GqUqjn4srfxVmV5zaj
34634	payment	2132	2132	1874	1	1	1117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuQq7XpAbAu5PHbdHfmKqaMraga1tebpUPwMFF1hDB8cNyPUS
34658	payment	1397	1397	1678	1	1	13473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9N1jjhCMu8YGaDibFhFh4D4NSaQF1Uh2atMsfDZkMN5kXXsy
34659	payment	2133	2133	1874	1	1	3880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcL8RSVsDcW17YmzcjF59DBA4AcxfbnNPJ1wA1acN5AK35rY9
34686	payment	1397	1397	1678	1	1	13482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3eAVizt2EWgfdWPCLuJ5PE1gR2V8vRQgKJkT6zGFTxaPzaaT
34687	payment	43	43	2028	1	1	2	80000000000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYoGqdZ8CaNmLwJketFWxcKK6djohB29H3CGAzzb7T2dYLiTUwd
34688	payment	2133	2133	1874	1	1	3889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYeLkAs5KgFWhJKXBezFf3BRDqHN9sbLTXnsEFnPCcx4GkSJF
34689	payment	2132	2132	1874	1	1	1122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vCURGs6Mwci6mXnhooBJAoKNQByNwvZfmRs11J7vaoQe3FZg
34696	payment	1397	1397	1678	1	1	13484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYGS9FkNAQzUuzLdrh2mRovBLXQg9hh8j8iaQKXQDy6Tft8px
34697	payment	1397	1397	1678	1	1	13485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRqUQWvqL23WpCkDSjLvE4zMcQN6ajPCDxfLH6JTJnMnv7dhu
34698	payment	1397	1397	1678	1	1	13486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQP8psGDHNRdRd3xrxC1f3aLGFXSR4PSRPhADkDx4uauSUPf2
34699	payment	2133	2133	1874	1	1	3891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25oQzkeeYtrRSVRNb8bqaKPPMV96BETm34mbd8cmxzWQcM7Qi
34700	payment	2133	2133	1874	1	1	3892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPZdJkV4irc7Af2gPNTiKzQjAGmu6whR9ctxEraiSpMcyCBm2
34701	payment	2133	2133	1874	1	1	3893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZxkmW5SPHMdJugbHDMSqgjehbxmWet2SyXXW1pTpsuyaLBvm
34702	payment	2132	2132	1874	1	1	1123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpaX7guvntNTN2yadyPkTYghLoSypF8hXGeyPRW33ctGLwb8Fd
34705	payment	1397	1397	1678	1	1	13488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1sBadLjq8eAH2bq95AvuezUJbq7w4XpsS3QaWaHcRvCpe6xUP
34706	payment	1397	1397	1678	1	1	13489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGdgGSd4Hic29XvfH4aRKiMFW7Krj69VjiqbBfPKRLZ52axx7
34707	payment	2132	2132	1874	1	1	1124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkcjCEvqWFJYn54BUnhSZuxfsWdKYJJD8hKsm2pMW7KJ6kPfP
34708	payment	2133	2133	1874	1	1	3895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zjSRFW9ounWUotzuHpWYigbBUeNQRuW4xZR2vPoTFrDGR8Tj
34709	payment	2133	2133	1874	1	1	3896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHsrjPXHdEFPLYR5AE2jD9EasChWD6Mpd8vbuBtwKv71JGSgc
34716	payment	1397	1397	1678	1	1	13492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD6v1TvgZ9XQYMs8b8Z1yTJaSeos4fTCxiTWVuUxtConaGN5BP
34717	payment	1397	1397	1678	1	1	13493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EwPWjknKhqwKvBQMKvssVx4sSi8Zoh55PVRKV9ob25p8Qoyf
34718	payment	2133	2133	1874	1	1	3900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBJksToSggSxq7WCbe9DzwdRjDVwmzbBjdCwSJyfDnP3Nz2T1
34719	payment	2133	2133	1874	1	1	3901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYqWM2dKJWynzFTXjGUfMQJUDksG461Jyp5RJF3zcocMARfkT
34727	payment	1397	1397	1678	1	1	13497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeYgMEtiEcSVD2BeM5yGWu9E7reXHfyeGuhwzxBGX8beYqfET
34728	payment	2133	2133	1874	1	1	3905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5eBsNej2pP9ygFjcoe6nkBU3dKVP23rj1PRbrAmtjLprUJS9
34747	payment	1397	1397	1678	1	1	13506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLyEtYERppu4U4WvgoM4rAbtick3URT9qyRV8fxiFYGTqaCcx
34748	payment	2133	2133	1874	1	1	3913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3j97AxzByj5ieUyFrtUgW66cSs55LyS4FjyrWBma3fjmpzkj
34749	payment	2134	2134	1874	1	1	3959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgzhDmYgodG6GoisPnLv9K59yCf6xho9JSnJjqrbQ58yxPgXH
34787	payment	1397	1397	1678	1	1	13518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vYxNBYdnw6bEB84LwoTtfLTWgPPv2fHiM67V5KzwjL8yTBwR
34788	payment	1397	1397	1678	1	1	13519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtALX9TTAwSCqBXBhjmwCm9r3B2TwNR8v6oL3QjkSGTHPSMJ7
34635	payment	1397	1397	1678	1	1	13466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLP7Qfx2HzRmeDcpLau5vizMXB9coSkZSAxQQYaNLupPYoPKgw
34636	payment	2134	2134	1874	1	1	3953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJW8SLcog8AqhK6Z9bn9faPA8JTC2LBY9Az5Pq1kAY1pZP5HQD
34637	payment	2133	2133	1874	1	1	3873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBgrEd1X3vk59QDDkyx6D3d4u9sAsdQVj9ch5t6tEc7mZZxcY
34644	payment	1397	1397	1678	1	1	13469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrYAQzzgkU6rELvDVFcJqPaMkJyfDWqJrrS1YZYaBrrRSumSiB
34645	payment	1397	1397	1678	1	1	13470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZqmPBs9jZKzraztUD268FXy2ZJTpJQUCRP4rpWM2Bu7G4KHV
34646	payment	2134	2134	1874	1	1	3956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshyRhna8XHnP4K9Fy6d4js8KGFEHAPDhNuhbzRnnMQWrWY5Na
34647	payment	2134	2134	1874	1	1	3957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMCVtaehqPQZXjLaBzzCsHbn9X3M2jdaX6p7pQnEmUorpu5XU
34648	payment	2133	2133	1874	1	1	3876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUVWgYNUuEaZNJQ5ZokpqZYCF2Rrje131vi7AdBwquXDvscqT
34649	payment	2133	2133	1874	1	1	3877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNARKoU9ocUvSSLoJTpW71WE9rKdqMvr7MhHCGJntHQkaiVBBY
34650	payment	2132	2132	1874	1	1	1118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89pyyrekDzJgBZk9Q4eLqdSjryaJLjJzdpdt18FbZPzBtVfGV
34671	payment	1397	1397	1678	1	1	13477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNuwm1F86MuKXt2znmdetAtDgCvqToU6fSzjqf1VDbvnVLWKZ
34672	payment	2133	2133	1874	1	1	3884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCKfGCwdjjffTymU5EvBwL1YkSsB5Lm3sfNHcYg11PnkPerVq
34673	payment	2028	2028	1310	1	1	4	7338894580000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZ1tthRrwxZBT9MV76Uoj3UfWLoYUaSkQ5y2iqLPVKVFFhzD1SK
34674	payment	2028	2028	1184	1	1	5	2633648090000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZtCskPisvxFnSWuWiVaGUxAJ9h7YwyRYA1yJQYPSLKw4sXsWzP
34675	payment	2028	2028	1064	1	1	6	3903320460000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYZU4DuTDgYXqpweDNPzd1DvrpQETyWDENb9M8jreQaGmb5eiPU
34676	payment	2028	2028	944	1	1	7	2178202640000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYcCc7kfrQjuk54D5shRyifg58htHmxic1z6PHWzkhnsa5YLv9D
34677	payment	1397	1397	1678	1	1	13478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAcbi6LAHxwStkuEjbLaZSLmkuiTp9xCzTrehmMCCtydicQ5C
34678	payment	1397	1397	1678	1	1	13479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuuMh7V6KqtAsVm5aDM9snH4eBXgpvGPmr1yBwvKLJzjgjJtn
34679	payment	1397	1397	1678	1	1	13480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarpJ3pgERLipn8oh64LQVo2zEMXCyzBHgiLxpfgVimC9c6x8k
34680	payment	1397	1397	1678	1	1	13481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUztmJdCJY1YRYnaSJrL6UV1cC3JcuLzjfmH9K316W8cU6P9B
34681	payment	2132	2132	1874	1	1	1121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGYaMSydTuFo6D1KJM2xfekKFKV8XitEGT6npBooQ4vu6pqk3
34682	payment	2133	2133	1874	1	1	3885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2LqQ18zMXYRnecQYzv62k2nuwd3B9ieh8ZP1uT2CBYZMj1Vs
34683	payment	2133	2133	1874	1	1	3886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s9PwjvNYcxdFES3GconKD3fF31mV461CLTr3fQnmhn6VHSqo
34684	payment	2133	2133	1874	1	1	3887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYWMSvGaV9mi1Q6QtYQKBaPzBSHsqr3TC36u62YUfRRLLKAzG
34685	payment	2133	2133	1874	1	1	3888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgC14SKnwJZx4LnKHF8LtBGnscAunxJdF6JgRoSwqaoReec2C
34725	payment	1397	1397	1678	1	1	13496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxEeBQ4ENFni6uZRssR6nJ8Xn1qr8tPaAgN8hULjyZEehtnE9p
34726	payment	2133	2133	1874	1	1	3904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxTD517peaypJXrdWx6yn5FmTEudjUb6KNnJHzDqWncanzvCQ
34734	payment	1397	1397	1678	1	1	13500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hNmRGA28NhiLEZMT8HsTNNoZPU1cTkfm9Pp9EQ7a84yQrWr6
34735	payment	1397	1397	1678	1	1	13501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbahaN3j7m8RtgGc74XJP8AUWDFELAZ2ZsQQfGuAYVqqfkisAn
34736	payment	2133	2133	1874	1	1	3908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfyQ5S2SxaGiSwgjXpzRM7hkpHHmdYacazHtqHNFqmNDtAPTF
34737	payment	2132	2132	1874	1	1	1128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZwWZdKjoJqhRhgExL1fXzDskDv8f9L2CsiweYLWp6HwKtYDh
34738	payment	1397	1397	1678	1	1	13502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZanYSEbSWtbJbzNreVepFcVDqYysLjspzWMLnoBrhwF8H4bGp
34739	payment	2133	2133	1874	1	1	3909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJsyG4e4Ng61da6TW4npd3nY19JDrWK5CWRQyY4pdvcfAh173
34750	payment	1397	1397	1678	1	1	13507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56xAzT3vQhhYZWUqtmkMz4MHMqKEoRujKRkgpk1UCDqDPxGmW
34751	payment	2134	2134	1874	1	1	3960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hriyT2sadkTbm2dP7uFNAqChLgV6EdBKNs9EDUCDw99ygnds
34752	payment	2133	2133	1874	1	1	3914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpPN1xdgTkZxLM3bfBnxhfbcNPaMq1442KyT34Wb5VA4DtwBC
34753	payment	1397	1397	1678	1	1	13508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1HQ12owPSL5HGz7UkuV4p5QmuZsY6nPXcDozW5ocB2odMN8a
34754	payment	1397	1397	1678	1	1	13509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjsEeScr5PUg1QZiKQjAdEaWxsrWxUJEFVYPYnCLUFhSvJuip
34652	payment	2133	2133	1874	1	1	3878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvEKK3fTDCUQAwEopKXmnbdWABJvvD8eDGFi2HWGqHTyVc6Bd
34653	payment	2134	2134	1874	1	1	3958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bN6asMByiymPjcbBAxhhbaALZX4VYSrfNrRMzyHU5a6woQVR
34654	payment	1633	1633	1024	1	1	8	1756801128175	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpYyddoUoVJUUGYTLMEiXMv5HY1cSJxTqTgeKutJYWA3aokDRmNu
34655	payment	1397	1397	1678	1	1	13472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiLsQo6Xc2BkPa3e8PTNZEB1bKdkqbBQ5cAKkpjstdDzEWzSQ
34656	payment	2132	2132	1874	1	1	1119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqv6ZyA4UHEvzJE3cMtFcpmtsUGmb1kYz6EA16hFau22nj1ccT
34657	payment	2133	2133	1874	1	1	3879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuq54UkJFVM2cgdhczuuD8oNCiGcfKEmSptZWfk83GoN1NMD4T
34703	payment	1397	1397	1678	1	1	13487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkACv2JwuupyfVJNXwyWPvFiM5Zcg28to4ifhU73wF4x2tbRwY
34704	payment	2133	2133	1874	1	1	3894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJWBXLm6oaEByVHGu3SUyFWFtuh3DKrTnPJ3BAVnkWTb15fHr
34710	payment	1397	1397	1678	1	1	13490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4LuQwL7tBUiAD4LTZNKCUmgKPpT8C1fk9xpgfTWPDzjZH35ns
34711	payment	1397	1397	1678	1	1	13491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz14Ek3kunpsAb5My9HMoFQdAepegbq43oxYpSyJcw4afTJUcd
34712	payment	2133	2133	1874	1	1	3897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXvoYJHeRj1Et5Fp8uNKkek4CfB5z1DubAUtmkVbs8z7t2bz7
34713	payment	2133	2133	1874	1	1	3898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbM5ej6UBUTsXkXjQm6MVj4ERz7hm2tCZrbjYPBg6SLjvqcEv
34714	payment	2133	2133	1874	1	1	3899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFnYLxxN4K4qbMvNzPd8wUrUSepdDdEmueHyuxjkrqS2zMW3q
34715	payment	2132	2132	1874	1	1	1125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5h8EzATJ8tC4Yc2d8qkNhLh8VWNzj54Tdh9ys5VZ52JjyPkEF
34722	payment	1397	1397	1678	1	1	13495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cAnRkgaprPGg9PspHvSVHL7Hkdy96f4XcyBmpj6Q9QHQ3Hz7
34723	payment	2133	2133	1874	1	1	3903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbQbEtKtiRqRak556JwPWwMNGanC3RfbQNtLUJ4dLsXGLCAeL
34724	payment	2132	2132	1874	1	1	1126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEGGqDSvRVtHhHTJVuX1rkhm5DzXsYf818QPyPcYXAvFVURQ1
34729	payment	1397	1397	1678	1	1	13498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEo7Gr7MQbgY1m1RY69hF8quRhiKN5vcXFb6JFcfLnw7251Wo
34730	payment	2132	2132	1874	1	1	1127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraf5B5YV2ymspgmYmBPeyYshEhQbMp1d88r57DUSazvjvfQax
34731	payment	2133	2133	1874	1	1	3906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvAAB2Ho5ELRXfbyuViUHqemHmWj7vhvLFvomFyxgW33h7MhP
34744	payment	1397	1397	1678	1	1	13505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pBKp5VuLhxHgfkeQ2hwRa3KWzQ3vfvZmY9daiZ2nx3x1hx1E
34745	payment	2133	2133	1874	1	1	3912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDW6yvtCyhkooa2tCKCMSmEf1Me9K94LBTyUb2uqYFuN3d4eM
34746	payment	2132	2132	1874	1	1	1129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBMG1jJNrfCw8tBGT3Lzj62fqtj3K7tqQ6rnvq9F6WpAUs62Y
34781	payment	1397	1397	1678	1	1	13516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB85FrpYb5SM4PomXUxpSdTNsHwtVeBixFMjtM46LuJ78bnqh9
34782	payment	1397	1397	1678	1	1	13517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcpsFUb42sUoX2WCbQgnDxPtwWqAB4NpJ1Mc5X5qbW4sLGYGA
34783	payment	2133	2133	1874	1	1	3923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDQmfUB5Rj9p8BXQLD2F2svfsFteZcDMmjF2PAnkUMujVnEho
34784	payment	2133	2133	1874	1	1	3924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdPohP1WLf99tUMUPrYWgokJXzMSke64PSMK7cz4ogZcRMerSW
34785	payment	2134	2134	1874	1	1	3969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNyLrhwfFc38bFrbua4mZ1TPa1FJsg8FjxnZnQRoQssoEsUQ1
34786	payment	2134	2134	1874	1	1	3970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyvvPXaf1vrWvDoZbE1oB3yVE7fHV2nZA3ASP5sj3NuJbxUiH
34794	payment	1397	1397	1678	1	1	13520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bYZCtPeGzB8GfUxGYy5CX8w4hNbWKKc3tkj8SLHgWQjcTg7L
34795	payment	2134	2134	1874	1	1	3973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXgutjxmgfTEf67zbci6wZYxmJbrqGwsZqDxS8kwLyz9qEwNc
34796	payment	2133	2133	1874	1	1	3927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPC3f9M4oqboTjCmM3QwxZSeSmKahuGdC7iJUKARsQAD8HSz1a
34820	payment	1397	1397	1678	1	1	13528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6t8wxq9RfyDCdXHgAR1GwC1C3tf1UJwgtpMX9sxwptBGb3r43
34821	payment	2133	2133	1874	1	1	3935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUKtv8bXYcdMVNyWuB4NwsharxakQQNLrNeBvPUhTXXc69kAYV
34822	payment	2132	2132	1874	1	1	1136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEkDfeWSpkT3hu45N5zZvgVKP4gBHFxM94e5KVQkdCg1H84FT
34823	payment	2134	2134	1874	1	1	3981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gJ7pSk4ySYpMbygat6haHq85gA2WohiYqLRY1ToyFEaELPfj
34833	payment	1397	1397	1678	1	1	13532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3w2LXXGXihmEHhb5NroA8eYkg22xj1ydgDbaoERqXcW6WBot
34834	payment	2133	2133	1874	1	1	3939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdr4gFVfxJkSe7Z4f6qtpLbqvQs7Wf97jdAM3F3ebdirdkH8SR
34662	payment	1397	1397	1678	1	1	13474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFomaSCBD2Cxt8j3jxYVSbyECcE7hvjPWMkCqzywUSJLVMJsrJ
34663	payment	1397	1397	1678	1	1	13475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qMufBnsDdcEeabPrVWd872JoSdy33D5shQQTbvry571hyEe9
34664	payment	1633	1633	1390	1	1	11	5919090388412	10000000	\N	E4YkrdSATLa9fEhTs7wndS6171bh3GqrTMRibcm1phYhQHfuFWzKm	CkpaHUoMEyozjM7gk2RomABpCbApnMy9cKg68jMwyySe7KmCBwTbX
34665	payment	2133	2133	1874	1	1	3881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8M9Q2K1cpbgyCTv3mtJLrfDJL9XVLSs1pBsVfnyKzK6AFz2Dc
34666	payment	2133	2133	1874	1	1	3882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKTLFXPvWgPrdWdNrLkJuTHoRBjuxVuY7jmTneNTpHo24ZZXF
34667	payment	43	43	2028	1	1	1	17201000000000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpaJYZqMCzdcuvRGeRgoR2SrJpMqc3trLuSvhTeqB8M7yFr2r9r4
34668	payment	1397	1397	1678	1	1	13476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9akUgdHjiRzLkD9UBr6ifoEnEUK8hp4gfQdnQk5rHPK2qrDB
34669	payment	2132	2132	1874	1	1	1120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyUyDYsH62KYs2tsAsBfHaCqDzPtknY6JXScor2bkHq9wWiEf
34670	payment	2133	2133	1874	1	1	3883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JhRXpdJvF8f7T7EanCNDDQoszuMHWuybFT1cxpcgpxhVgnzC
34690	payment	1397	1397	1678	1	1	13483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgF2HzXNjRLvrYw9zcMviZJkZk4XJ4xbHGZYVDey8r7AE6JG5p
34691	payment	2133	2133	1874	1	1	3890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYReXnKzN4juHGKqZYD8U1JJNdW71Dp4Tk331mdK4m2GKC5nFyc
34692	payment	2028	2028	1310	1	1	8	34134390000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYgxzrpJ4U6Vpp7HqJC98TPyJ6jq3ZHnmJq4Qy1kBzZK92pyti8
34693	payment	2028	2028	1184	1	1	9	12249530000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZEALV665YSK4CGAD8nkpAjJSdbqFPRWeixwLKn3Jq8L3s61AYA
34694	payment	2028	2028	1064	1	1	10	18154980000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpZvYZd1Je6J1GZedwamDaA38URms8L3Y2QeRPWTheqx3bMxTstE
34695	payment	2028	2028	944	1	1	11	10131180000	1000000	\N	E4Z6htYsWvGBXfHaNmqWF4bvTiTN4cMz4jcSrcbGmiBK1TYWks7Hm	CkpYwQKb7yX1hRuiEX6FPyGbT3v89ctSU9nLHkVUZWmEVFj7yGSPE
34720	payment	1397	1397	1678	1	1	13494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9PPaNuDr2h1UZ6gwq3KpEGDfBBzKKUvhpUB9Rw9KMYk7uPSk
34721	payment	2133	2133	1874	1	1	3902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMQQwcxWu2PaZTnxtGyHhfJym54HTbRVDyBBditwFFzQaS6nS
34732	payment	1397	1397	1678	1	1	13499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouZcyjCUMLFvYVLwDMbVBrfx9qYd1sXsLYWi3Bte2jwPmWkLq
34733	payment	2133	2133	1874	1	1	3907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7FWUx93mB9hsFJY5i57v2zZU8skKQaKjm96R8gYDFKd7yEt5R
34740	payment	1397	1397	1678	1	1	13503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dBgJYsycFciAdzGETh2C2ukv4x4nYnDowkCeEGrQzTuwA6XQ
34741	payment	1397	1397	1678	1	1	13504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcz9Ca9ePGDZy816yF62DHVhnVepM1V33FHU2oKQWGjXjjrZjj
34742	payment	2133	2133	1874	1	1	3910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgYjEzhNVEsw8cP5JTQfM3unmWx1Na2pLSAMYKaMpVpjmHzL8
34743	payment	2133	2133	1874	1	1	3911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLR5HJwe5HnefH2MX64h4bMHqRsLh2oW1yHvuPU3rkwAyooGit
34767	payment	1397	1397	1678	1	1	13512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uQBzp1T1KDWhPGwgBmpPAisPSZU6CfUbLPqHqgL54ivn4FGc
34768	payment	1397	1397	1678	1	1	13513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrdrkzZ6s8kJsYuX5YhT2Cc9YmJ8eHni5b8GPYeJCYoiXPjYFT
34769	payment	2134	2134	1874	1	1	3965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnzcHvrifizZTGMm8UUFvnJEcsudX9AmGSAJGJHhBE96BPSGx
34770	payment	2134	2134	1874	1	1	3966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQ7GxL7Z14CzXm3nnXPwrK5qqrUaMkV6f2NsYWr9d4fzfWv5d
34771	payment	2133	2133	1874	1	1	3919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFdiBZNKeYfZQxvpDBDsWFYpygMMg2dFMD1Hy87o2vyYpyFzW
34772	payment	2133	2133	1874	1	1	3920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjUHL4XzcDpH7dkwvrozbSdhKH97Zd7nJUvfiFmFKmp2UkYtN
34792	payment	2133	2133	1874	1	1	3925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZhYXa5UrRJfRF8H7ZUmFDcB8ZANCTHjpKzRiBEEHA4BRGynN
34793	payment	2133	2133	1874	1	1	3926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpivEmi3JxfkEcnatouQqy3DEgi2NuJNRnxLoBCZz9mBXQ84L
34797	payment	1397	1397	1678	1	1	13521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7pJyQSdHeZmZLaUGtmfCwTVnNFBfZCT7T1D4gegRTZFNq1gW
34798	payment	2134	2134	1874	1	1	3974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDxiEpUPmH3LCKfWCxxPtWsukoJdYYWxtyipSrbDCPTdKNUo5
34799	payment	2133	2133	1874	1	1	3928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHp9iEi7BPZ4DyKctgqZ2pgQuQza37PjmH4q3Ed57t1nou4rD
34800	payment	2132	2132	1874	1	1	1134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzmnYZ8ZJaVv9DWQL19zjPbc2ma7f5HrqCPLeZYjKQkw9Wnf6T
34804	payment	1397	1397	1678	1	1	13523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRSe29dMyb7CoSrpc68uWEzdCyeMaQUeGHc2NZsi1qqkx6FbL
34805	payment	1397	1397	1678	1	1	13524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvs26gmA9ZLFPfDyABGYzT1MsHcw76YzWHnTC4rzXeeQ3679G8
34806	payment	1397	1397	1678	1	1	13525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq2xkm7oDkYWWaBykTyk59f9VyfrTSzTpPDNFCNRU48UE43RMh
34755	payment	1397	1397	1678	1	1	13510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKVjkB8YTaUeJ5Lh62bUiJMmvrUHysU9UdXcXTg657WpnFrrA
34756	payment	1397	1397	1678	1	1	13511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PCuvF1AnnZ9LD4GA8n4ZQfiAhFYuZRbJSgjF4gUhnbPYL7xf
34757	payment	2133	2133	1874	1	1	3915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrkTMqySNNBsTyFtLG8c6Av72CBecL2o6ubUyh7SmrKQKCdEo
34758	payment	2133	2133	1874	1	1	3916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShEAFwBn6FhFLUN6RY6dAbTWiVmHBAayAoSDvY7urrWxMwn1M
34759	payment	2133	2133	1874	1	1	3917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwhkFVa8qLDYpBkVmnDP3jzANpRuWTvr4ZFsqJSaE33J7usrQ
34760	payment	2133	2133	1874	1	1	3918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ98dzENDX4SuXC3TijoJL6pwsf6xypjcLZEXnpKT8UfemeEYe1
34761	payment	2132	2132	1874	1	1	1130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHw4jRnLPwWiRWXsBMC3LqYWDfuFYmskUsrUfYRL4Ubh5RSSQ
34762	payment	2132	2132	1874	1	1	1131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUnBrRgBp1pg7nAFHHC3d4pPgVkfyR3cjVbPUtJDnbb18EoJZ
34763	payment	2134	2134	1874	1	1	3961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FyMmuu2QMajNCKyA3odnN7XxF1S1oUd5PtgjSzk14EKZeehM
34764	payment	2134	2134	1874	1	1	3962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4WDKVmVto5fEz49B91SaWCpBRutyQ5AUaFiTyvekYUG8YBvnj
34765	payment	2134	2134	1874	1	1	3963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc7n2CJNvjquvCgBxmBjLpsumthmNnMtwrhWJUCNLW7db2UFoy
34766	payment	2134	2134	1874	1	1	3964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQkajaWkoyrAGGCYBMoxFkdiz6ZWs5DUmowAgdciphfXRBQDxL
34773	payment	1397	1397	1678	1	1	13514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcf4GSfsqZguz7UqfhvVZEVHjU3qudzUn4EqkL4CNBSvhjcZqb
34774	payment	2134	2134	1874	1	1	3967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Wr7r8eLjXP8C9rpiVB48pcPYiTSNDDS1HU4EqFfkxdGBvjPa
34775	payment	2131	2131	2172	1	1	7	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	Ckpa6oUQ6NNM18iWLgW1TAc7ANeRToxpEvAkedVHJmTGxKtyTP2Po
34776	payment	2133	2133	1874	1	1	3921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4kNPCHVVPJPhZuKkgYVvSkbY8DtJFxKYWLigbdNYTLk4Eecg
34777	payment	1397	1397	1678	1	1	13515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGfRELnRxDZ6yvSsYKGfYzeSnUBewC5akvvRaVZM9H52hj5FxW
34778	payment	2134	2134	1874	1	1	3968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfGYncXNtwRCT4FNbNkAeFjqQ1px3LmqgmTmijx5aCVPyGXLh
34779	payment	2133	2133	1874	1	1	3922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrLwkpTxBw7YfJ9tzB5fm4C2eoiQZZ1KB9dDZjLYcriLTyKJP
34780	payment	2132	2132	1874	1	1	1132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvphC3QGcC7jNZ4vr8edKUVFFh9HrAZADr6zcb4JcPx2bZjYh
34801	payment	1397	1397	1678	1	1	13522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7XgEirBKSGEV3QXYXkQEYobbU6oCEpny9Y4KB92uBu6N2Xb1
34802	payment	2134	2134	1874	1	1	3975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCn8GcqubpqA11BTBD3CxYm8Qj1i1nBP3TJoYyDwpB2kuhh3N
34803	payment	2133	2133	1874	1	1	3929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3xq7JAR1DJLwwTdEYMuYLRJHqbxfdUvSiNDP3UhKMjkDvYDv
34817	payment	1397	1397	1678	1	1	13527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG5VRu9GNK4PkR9SrFjF7fYxcnVPat3hxACDpo3PVs6b3Xqwyo
34818	payment	2134	2134	1874	1	1	3980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZugkqd19RQXeMdMYxi1sURrak6yLRarXncv1r5Nm99cmNw39wp
34819	payment	2133	2133	1874	1	1	3934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d399RsnFfikn8vGrSemmuoj6oCVT4MkX6VJ5jfuUGvz8WVYn
34830	payment	1397	1397	1678	1	1	13531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffL91cGCo4Q5dsfj52gS3bfyGeK1jHhvwaWodrZjjdJSzM1yQ
34831	payment	2132	2132	1874	1	1	1137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkr1H2mzHRTmHjjmHcNAG77bpbq7C3P2t8xEa7HfbeTJPyddqi
34832	payment	2133	2133	1874	1	1	3938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54jShVHu3nNkyuAW2XksmhugXdvzNB7UifrSqGJyefgF7Eguo
34838	payment	1397	1397	1678	1	1	13534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mh8QRKw2nHGUH5R5F6UFJX8dKHpormQSbuFFG4bDD93ryxHv
34839	payment	2133	2133	1874	1	1	3940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMBVoWcvXr4Ae73khz52j4EuU5syga322VWX3oGNpF1mhDxJv
34840	payment	2134	2134	1874	1	1	3986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AVpq6zq86PpWN8H3brUY1LZjfh23qFMQxLMuw5PwjBPz6Xvp
34841	payment	2133	2133	1874	1	1	3941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91N7JjPb2VsVjBNnVbfB6rzShzDKvWtdqMLDF7FbWbXJRntCh
34842	payment	1397	1397	1678	1	1	13535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsLh6Q76JTSCkEWVNuq1bECMJGBQS8T4ReCC78BeqeA92G7XR
34843	payment	2132	2132	1874	1	1	1138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2YMEYgw5BqH5NW54tmavtLBUs9FcUZSefA2qc5VoBYy3uewA
34844	payment	2134	2134	1874	1	1	3987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWypXtNnbMGmtHLYTVLgkvzrerz82nahv2yhVwho8B5TmaFvc
34845	payment	2133	2133	1874	1	1	3942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaT5KTKqe9bgE6snKyRLCoSuvLaLYZNGWiAaSqsEvDDhG1f4h
34852	payment	1397	1397	1678	1	1	13538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYja8UgicZxNVLvjpaqWeXWbZmcv4cPB6zb7GQEDhHuKwgynuR
34789	payment	2132	2132	1874	1	1	1133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyr5pRDxbdpE2JbDopdyKXn925v9NKR1JwDBdnqhmU4rkxdiu
34790	payment	2134	2134	1874	1	1	3971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBJS4h6Jz8PmrXKTxkahSdWhcssyk4mWjnRv3Ys4t1tRfe8AG
34791	payment	2134	2134	1874	1	1	3972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTrU1o6oXjx9RUwsGvKTQs5w36c7qJsQn332hLDVfoxZPm5PR
34814	payment	1397	1397	1678	1	1	13526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1HZphRTo4DkT267KaW2MdczptN4yhzHCYK6xdJEhehmKnoPN
34815	payment	2134	2134	1874	1	1	3979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKknnpiFeKQgQ2x76XKL4gQf31Vw2tw5baKitKtbES3AzriEa
34816	payment	2133	2133	1874	1	1	3933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu61sWpwE2N5rmGzLwnmPbi4p8bD6XNLWwkUyw2GhQsDx4h31L
34824	payment	1397	1397	1678	1	1	13529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5c3A4gYe1NhXbkcU5WcVRAKtpNNpuM6umAqwBasdSfD5X9gQh
34825	payment	1397	1397	1678	1	1	13530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU5qThKtaMRRcQfcxukdmQGXN75o1AzWSZbr21rvd9XA696yMh
34826	payment	2133	2133	1874	1	1	3936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5w9G88aj2ZhGS495B2twsAEJnm6xaWuNsWSLTQ8YJugfs8Fc
34827	payment	2133	2133	1874	1	1	3937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFZangC8Kamxp3PenRWesoqKYtKb3q6sjzjvCr94sgm196azX
34828	payment	2134	2134	1874	1	1	3982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGLK9vLGZfaU8zCFCpX3BBhqwiBESEbxQsPHUfXWrrsSX3E2p
34829	payment	2134	2134	1874	1	1	3983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrbaFxB83b61bLA8i5AEGLiGajcJHRt22rJRk7Z5aQrkjLA4o
34900	payment	1397	1397	1678	1	1	13552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9CgHURHhNppLAuHDkRYJ6eTjDoU74KurT4cueZZQ7QWgQ9Gd
34901	payment	2132	2132	1874	1	1	1143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTr6DoELiVnAD7aTptDbLpdaZRGUCYrAE3EFxhjPSF5mgYXf33
34902	payment	2133	2133	1874	1	1	3959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkueFX8G415sq5jLzoHydFj44C3tYrncd94ps7coH18aJfuwJ
34903	payment	2134	2134	1874	1	1	4004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoknYzd2naDe3iqnNDfgiWB5ry1npfrQBZdYT4KrzVFToA9Jzw
34946	payment	1397	1397	1678	1	1	13564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpC5jeR6eJiw6FnB4JmtZo9yMmXhsntj92XAoBs7ufPE5yWHX6
34947	payment	2133	2133	1874	1	1	3971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcDjH7gUUs59KdgQ4BUNhJAK7Y8bvyq4G2QxHiSH3TKoMrNUU
34948	payment	2134	2134	1874	1	1	4016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87B2Pemn9qmnhgK3Mxz1xn8Na4N4Rtsdf3RqRNbtCNXJXyZUo
34949	payment	1397	1397	1678	1	1	13565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdx5PSaiXzW4uFZg5bD1zC5BXsNBjpRHcJF1Fnxus2SpyQkaf
34950	payment	2134	2134	1874	1	1	4017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdT2XHMhJwBbVLwWzgwQoJihShRxh6yfDa2sV2zrmHoFJxL9Aw
34951	payment	2133	2133	1874	1	1	3972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiD4fqwFkX9bfqhbp72c6jq9vyTBuRa6nru9rfP1H4GLKsX2M
34952	payment	2132	2132	1874	1	1	1147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtapSFBbTbE9yNrgXiBZUcJsGR8M3n2FYALKhiswGzJUb1tyi
34959	payment	1397	1397	1678	1	1	13568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEA7qRp2DuhZ2ZsWa7itd5maPQtexkU96Q432a43PsmWKxVAB
34960	payment	2134	2134	1874	1	1	4020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSaHB5JaVMz41no6gNAkTNYQZ2pgDqqoZVTjcSdieU2GJyoCD
34961	payment	2132	2132	1874	1	1	1148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxQWYyZtwMmib98B2gdQt7QsXJkRTWGAeT8S16cG59DUCxJBnh
34970	payment	1397	1397	1678	1	1	13571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BdB2W7mPk43SP6DFh4Ptz3x2UoTFrCe9SVfvi2vNhiyT9h79
34971	payment	1397	1397	1678	1	1	13572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2iutmHB4U9S1cU2FeR6PeDYpCbR1ZeiSHL3PHRpd3Gmi6q16
34972	payment	2134	2134	1874	1	1	4024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwKKqHvF5Qt6i6hgBxuUz68fkEzZPZJWLB5ao16ZtXnQdvqaT
34973	payment	2134	2134	1874	1	1	4025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDP1a2mp9SpPRdnFcwN9uTRQd3LAvg8CxWDKveX1bXCafCsBya
34974	payment	2133	2133	1874	1	1	3978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusyw8aZ4192TQpxUmWvxuHNSeWqLNx57hcQ2i8xqQ9LQuSqTr
34975	payment	2133	2133	1874	1	1	3979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTFP6oQrj2t14FZa1JYL7zMMmUYB8GHBSsnWY12Ri92iU5zde
34976	payment	2132	2132	1874	1	1	1149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AgDaiV1doPcrQJ4SR4WzCkXGzggcza67BZHyVRUDHGB4suG1
34984	payment	1397	1397	1678	1	1	13575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjUtsfvr7oA2Q92c5zUa78wB2r37MdKiBjQ4BQGmECgLQrAvrx
34985	payment	2133	2133	1874	1	1	3982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYbvFovfqk1U14xwiD9RdjYjyg67qE3Kn7o1CTLAgkEtm921s
34986	payment	2134	2134	1874	1	1	4028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihH4Tr4GaTMkd26Jk7XZ5m6jGf6hWRtrSbEsMoJrNxhmhEFcf
34997	payment	1397	1397	1678	1	1	13579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamJMZpj6BahrPcq83A1d9qAhAuLxoBV88dBgZE1DMQ2K5HytG
34998	payment	2134	2134	1874	1	1	4032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvMPGqCmBEpYvv3oSoiba6ycKQmHpRSL8Le71TNs2MwUARxCcN
34807	payment	2132	2132	1874	1	1	1135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEZwCmLdWb2dEyroBJWizEPkSHYWTRj8H19wqs6mzGYuHzWJj
34808	payment	2133	2133	1874	1	1	3930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFjXs1R1wgsCwk9u2BqguqjWrGbpyoV9JcB8hDCQX1KygfYkc
34809	payment	2133	2133	1874	1	1	3931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX2CApyuivgY7NVQCdJgqyzaojdjLB7aAeUYcy7XELdBJsdneP
34810	payment	2134	2134	1874	1	1	3976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMqmqS4GNdqQT4w2B6ScCcZvhAGWAQgagZNDvChGjsVesdJd1
34811	payment	2134	2134	1874	1	1	3977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9cU7ZRzZUrtGd39xh5iNXRoLbg9KtDB26bAsoFiiViNQ9nsFy
34812	payment	2134	2134	1874	1	1	3978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UtmxcmdHT9zQBzGiRrWriJjNmUMyJMaMEfM4xFZSqDjwMoVh
34813	payment	2133	2133	1874	1	1	3932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPb85o8EJYj2G27WBQ9Xn1hP6kaeNRi2aTfWcYmcWyAMbqT5x
34836	payment	1397	1397	1678	1	1	13533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6ckvQY4v9bRQcK4cs9WZFsXUsAWbRrDwR9xbhdb87eUFbkFm
34837	payment	2134	2134	1874	1	1	3985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJCfuHqeQyya8zaCEvpDzHgxz6QsRymSDR43V6tHFBy4t2TPH
34883	payment	1397	1397	1678	1	1	13547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaRT8zqt4aYiEyHgrCGiyA3LjJCqW613y9RovBknqCZ3GyCKB
34884	payment	2134	2134	1874	1	1	3999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmekB1E27vCFi8V3PxTVXM1yZunT92JWZuZac1eae7VNfpkX4H
34885	payment	2133	2133	1874	1	1	3954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsBo8qyp2ibu3N16gCAbm3PVB1Wf8cmiZQqMXPFUdz8mUDeY57
34890	payment	2003	2003	1651	1	1	1	353000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafL4i5dpCyqupHQrAbPuNPwoqh5uw9FMp8cVWMTu9tBSNmntb
34891	payment	1397	1397	1678	1	1	13549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXPQVhZJT3pRnNUKKciNmRyAygoUyvtUkQpgT1bN4Jfj52ESf
34892	payment	1397	1397	1678	1	1	13550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFpSDuYxJUQmmgCPYm5vPKnLDsYSWCN5zohXZv4RCfQy3SgXn
34893	payment	2134	2134	1874	1	1	4001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmsM3DqHsHg2mvVFWEfJK1rbStZsZCVzbLNKtsPLYv5JFdjVn
34894	payment	2134	2134	1874	1	1	4002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqwJkvk9AzW45tqkb4Ly63FSSzDsKLywPyxM2ECs42cuCZsGi
34895	payment	2133	2133	1874	1	1	3956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55CMmq53mPAu9UFtVKVbQ9dxZtWqu97mtEjfX6xeoURaeFqVk
34896	payment	2133	2133	1874	1	1	3957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpo9wK32gb2vQ5L5gHuqtsoZJKDffZWsAjmHRryHUfTUFLNWP
34904	payment	1397	1397	1678	1	1	13553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfCQ5VJQVJQPQn5kLwf6HiXab6LEjD9UuVxrLimTqN6PSN3xA
34905	payment	1651	1651	754	1	1	12	5265064217	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpZuWNKfPLWRGgWd3sg97BEbXYMVRM1eE5hXduC932GNzqtWfyEp
34906	payment	1651	1651	462	1	1	13	347494240603	10000000	\N	E4YmEfpGDPkRdfwiHcgQFdf8Pkc3L1uG3VeDonLXmCbagLNhhJptz	CkpYTr5y4DWYj4cYuwdYpSUjC2zE37Rhf7gtWHBTKTK8Qk1w1KocF
34907	payment	1397	1397	1678	1	1	13554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CCrhHX2z1Es11DeaAWpuEC4P5NUQqAKA1UvPkYB9JaKtRsYg
34908	payment	2134	2134	1874	1	1	4005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjW36M1FQGWvWnTGkYttWExMRzYorY9kUNXecaFzbNCuXaADG9
34909	payment	2134	2134	1874	1	1	4006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC28QejV9igboBHocdC5ouS7ebBuX5C9zFZM4KvXYkaEnGa4gK
34910	payment	2133	2133	1874	1	1	3960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLaD5XfHdu59YzzYnHZQ53oiVRtwy1PA3hj2bTSq9HE4ibcpT
34911	payment	2133	2133	1874	1	1	3961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6u2VXSoUikJvuadwND95G33PNyxuyDxh91PdChEZjpSztGYb
34930	payment	1397	1397	1678	1	1	13559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hPy5hukRWopLHJEnEfAL3oHYHXfkMEfC8P1JEix8czn2SKNZ
34931	payment	2134	2134	1874	1	1	4011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1KDp7iQ6oLKP7sYt3XWAi3KhpMUcdFMideHowq5yqUEjJ81S
34932	payment	2133	2133	1874	1	1	3966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNqNiXzKDgHH1yqxrGjj6jQq8wrsFgeoqezW9bvrrMj1JoBTi
34939	payment	1397	1397	1678	1	1	13562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUSNH7iHBDwFtwF2EjuR6fguF4bobXXrGP6CNKFh3PFdNNZjQ
34940	payment	2134	2134	1874	1	1	4014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4ALJhAN1MeVPu3WdvUycqa9sRouGYW6CffYKNNwsPhPM3JkK
34941	payment	2132	2132	1874	1	1	1146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ192Tt62rfxwnQvFEbzSDoRw4S4EhXjZM6QbMuLRbiHSvtvMvS
34942	payment	2133	2133	1874	1	1	3969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kCXSxeccM8b58rAPat1FS5MxVfCrYKDhXZr1VJKhJhKWELHP
34953	payment	1397	1397	1678	1	1	13566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHQwk18EpY6U8C8mw1g4gB9MfCpsHSSbPmx984WYEhhwWXLji
34954	payment	2134	2134	1874	1	1	4018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGS7zUUKrvFquT4SogFPVLRt74hWJ7uDtnGNXvzzGXmHQmA2r
34955	payment	2133	2133	1874	1	1	3973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3h64Br2Ah9aJ3822PWMXj3qduitr2zgaWV3zxrCFGGgxuc7x
34965	payment	1397	1397	1678	1	1	13570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnA8z1wVnRkMNcmJnvjuMvu7SMnTeqKFqLoZpANeBvHcMVQsse
34835	payment	2134	2134	1874	1	1	3984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLifA65ydoqAGFQJtgdzWD3TkMfMbcJnRhcS1VZ57dxAYnRj7
34846	payment	1397	1397	1678	1	1	13536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BxALxh2rDcSnh23c9NjwcdfJqdrucUiD4P9cxYYKpdXLqFtb
34847	payment	1397	1397	1678	1	1	13537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEGwGM9TbVPMwstyhYB3XdFyG4ULbpHFpHEqYe725gXpktmbE
34848	payment	2133	2133	1874	1	1	3943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiztQ4BeGydWbth6Zq7SMexdWbUWgZMseBPAE4jERe3oVgRoyu
34849	payment	2134	2134	1874	1	1	3988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNJZ7USj92uSh4dUURAfbzAuE7o4FLNARtfh7YPnCXwHF81BV
34850	payment	2134	2134	1874	1	1	3989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWHCEEr3xr1Hxx6eiEvuof7A5EtnDDaXrzVatLdm7knzKyjo8
34851	payment	2133	2133	1874	1	1	3944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtC9Cq8SVjEDhxeoBX1bFMhKCMCEFBJmVetoGC3co2f61ysYzM
34873	payment	1397	1397	1678	1	1	13544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXWJesWyL19tV6wiBDUUP4Fy1zhFNAMURQooxf4wBZpKBeAoW
34874	payment	2133	2133	1874	1	1	3951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuo8QLUiiWgQ5uKG8t8ZoUonauMKFJ42TPPWbJDP14x7NCqonU
34875	payment	2134	2134	1874	1	1	3996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ193Mdd1yTdzaf5og46wQRHGRoaNX9WudidwLpG6uyjt7zi4Wx
34880	payment	1397	1397	1678	1	1	13546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQZKr5sRXBEP8HCzB54tNkDoBQdLyzFGPnLRrA6eYCSRiubqL
34881	payment	2134	2134	1874	1	1	3998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCjaaS8jwM22kUg9ojws1koCAENxNNPVuDSegsjScc1rBdMPLa
34882	payment	2133	2133	1874	1	1	3953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4haKr6tfTVybGzHYVcPUaNpdViopY2arv7Z6cBrtyQNEUjmc
34897	payment	1397	1397	1678	1	1	13551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDEV2SRHMe3LpriZ9LC9GaxLTTy7hKarr9vwfE1fanPECvFJjT
34898	payment	2133	2133	1874	1	1	3958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW94HZT69RC5vZZQeDLCuHShSvJw9jwJMWKxKkV7XJ5XTHtFJQ
34899	payment	2134	2134	1874	1	1	4003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Q5YPPczkiLb7X35uUixk1UNk3cvZ3Ef2HRpoFtBoas7xuREu
34919	payment	1397	1397	1678	1	1	13557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJeFsVdW6Tfx2frdtTC6io9H8eHuHEUY36QXCuYLdSgRhixG5
34920	payment	1397	1397	1678	1	1	13558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxFa2LZ6my4wRsKL9nQ613Qo5DKE6s3hKVCk66LmZoB1mj2VM
34921	payment	2134	2134	1874	1	1	4009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwVPLzFuNKNRm7gcjZ8YShRVVpRbwVYRbY4QXuVxCmmu86nQj
34922	payment	2133	2133	1874	1	1	3964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtZT9Jp8pgda5b3a8QS6oNXhCaGbiKX3wx4FW6hRmEENpMWww
34923	payment	2133	2133	1874	1	1	3965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHow9sovjBDKtZUeVsng3p484PW4gbaSGKyCH7Bio2WxhBkHA5
34924	payment	1549	1549	1362	1	1	6	9830706000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqTbodp7L4CJzddApcaU3gGR76kBpLUwHPvs8NE6gz8Tdxa23
34925	payment	2132	2132	1874	1	1	1145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67FWKLApSXRvbBjsZZGeqCJvprRkQksWbsmTztWT1WGShdPrp
34926	payment	2134	2134	1874	1	1	4010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCM17M4U8e1VedbunSPA8jSToBLwTqyewH9YnTB4DrYyMdNb95
34927	payment	1549	1549	1116	1	1	7	5228634000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBh7Rj5uWA3TX5YJDtogvK7EoAFCyHCmWsLDEYASKUZJJhGuM
34928	payment	1549	1549	1236	1	1	8	3527864000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19eFFtPfxeJdDq4mnkaAwcdccggBShLrPYnbGL1i5kkCijfR3
34929	payment	1549	1549	996	1	1	9	2917779000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcNEUzGyY1h9nYz8x8xFtNH4sFRePPwfqVpWGzb2WZJTHZ5u6
34943	payment	1397	1397	1678	1	1	13563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk78gpx4t29CZffvmhtUAE3hMupWy2DHsJh2UKwVauxM9Bjoi
34944	payment	2134	2134	1874	1	1	4015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8jHjnTic4mQUGkDgabmFKvRHfnYNpGwXG7E9Xv8czUPCWYqZ
34945	payment	2133	2133	1874	1	1	3970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQnsiehye5hcogJnpz61HpYkAPNYSjnhev1X59JccPcUCvUkt
34956	payment	1397	1397	1678	1	1	13567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosQDs3EywmfD2YS8FfY1qPMEB3J4RAjCqWdJjQzkXqof5e61V
34957	payment	2134	2134	1874	1	1	4019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgeSoUTC4gghkuhpd8JCqF3M28hyDZH8ombykUEBEU37BSkFs
34958	payment	2133	2133	1874	1	1	3974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87uXwrrNXw8wUsDH9QYeQ2RQDhthfZZV9P9fzwzfRYjwoSssq
34980	payment	1397	1397	1678	1	1	13574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgvErhgZuVf6q9NjigXvovoiBLLNuHM4bTAxpdjyPUSUkia22
34981	payment	2132	2132	1874	1	1	1150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9CmpR36ATMhEyFsLsoBALD1pZSNmuyrEVPBZmSWzQ3WizdmZ
34982	payment	2133	2133	1874	1	1	3981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfeteb2k4KWCyXxSVRUMC3JZxFA2oWkuy4XJbE7b3mAoVqfzL
34983	payment	2134	2134	1874	1	1	4027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4AUknLgEELKkn2xGuJcVBZMDsF3kbmrCFHfFPawFP4A41j6C
35004	payment	1397	1397	1678	1	1	13581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QdXV2TnvgKPPyxhnrmACq2AdS13XrMKewLEd7Y6LdENADjgX
34853	payment	1397	1397	1678	1	1	13539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdbC1JKStQGjy4xi5bbTbPFKGtaDi4FdpgRezf4NhceuY1oBU
34854	payment	1397	1397	1678	1	1	13540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwKYf18De3ML7G4Kr7nZ472NXnW7veqAb9zrbbSoroPFW3y9q
34855	payment	1397	1397	1678	1	1	13541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZio9VSH6biPt99JACBnpVxWSvXq6EJo9udXDkLhpMZ21tHMFrj
34856	payment	1397	1397	1678	1	1	13542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2susrKQeSNXsoCsCiP5iFPduytp8iqSarvHWQUv83GMzAQihZ
34857	payment	1397	1397	1678	1	1	13543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAiZ8YWedxA9s7rs1LGQEdTHqXp7oeaZwTKrtjG8HHYdy6v6m
34858	payment	2132	2132	1874	1	1	1139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU3ZpkeKCGaCt8vZPYn8G3U9EzqgVxo9tSTATJwBqRPJbjFDZj
34859	payment	2134	2134	1874	1	1	3990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7ZMg3HU15eS7TJEqdTh2TGtVU6EXtUiGAz6WZmAhm1Myd5VX
34860	payment	2134	2134	1874	1	1	3991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQA3xJKYbJrYs883cBh2rg6VJFYvn8zuRkx1dHeVe6yvsdwp7
34861	payment	2132	2132	1874	1	1	1140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5iDertuhmyiaEfbs2BTUjrjZNkruVWs9HQvsRvzSuq2oenYB
34862	payment	1549	1549	1549	1	1	5	1200000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQE4G6R3K1yRaNsY4MZMwJsw5RXweyQTA4ERfbBJTsLKmxVRhH
34863	payment	2134	2134	1874	1	1	3992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdrBUpqCRtM2Cya6pTh6kx9r6dfQQdG8eaUuMNMkdffvbyAbq
34864	payment	2133	2133	1874	1	1	3945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtYPUUUFxfsQtv4iLG7RoDPcZEDoGmuvsE16eNkb7MQ9aaUDf
34865	payment	2133	2133	1874	1	1	3946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUHs5GGUnK9L6wxULeQJrzmN1kZRemVsWi7634DfxYfFMNoBf
34866	payment	2133	2133	1874	1	1	3947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsE2m6y6PZuDJ7HXyRSxsXA6Nbher28RHXtT4J2RJnho5oS5o
34867	payment	2133	2133	1874	1	1	3948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErKWDcBVbrYpLg3S5oHMF79YB3cdWmf1C5aeEckJwveZaE734
34868	payment	2133	2133	1874	1	1	3949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhovkCbjU4Hy7oAeo1bVreFuTBTmnWGpNm4kKpAAN3j9ucrRjw
34869	payment	2133	2133	1874	1	1	3950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hCvGcDCgTd9ww3q22ekTjJYtDZxFXbQ73u4kzhSjftgatswk
34870	payment	2134	2134	1874	1	1	3993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkN9Q69gZEoDLMxeTgpV1oPGsxaiBuhNftJseijS6xTQSrnVK
34871	payment	2134	2134	1874	1	1	3994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaGqA4oAdHr8ZCzEL8ppcZTqzh78LbyaM2sWBRkRNtPMixsBCa
34872	payment	2134	2134	1874	1	1	3995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYENyF1YRxkjTPrV3o8zH4WgekKs3F7oJfxC5H9ufpkVGAkSRt
34876	payment	1397	1397	1678	1	1	13545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAS3PzWrNicnSH7gvqktxS49MGaCcXvedqynHDjQnMxXKG7eHE
34877	payment	2134	2134	1874	1	1	3997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGyw5jbQTweNPeiyPYSwTBi9j4q456yqzgNzAdTytQ6WSpQ2S
34878	payment	2133	2133	1874	1	1	3952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uVMmmQbb7pCpNvB8xjC6R76xiptgLtMmKz12vQJXDABPRKZU
34879	payment	2132	2132	1874	1	1	1141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ic5nrZRVLswaB9UZgg8Nxt3Ghz248WCMidjyJkY2XCWjVdsh
34886	payment	1397	1397	1678	1	1	13548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEds2HA1tLVxVjRkM4X1LM4HX9wNSxZMdhdBEuZAzEmLMBE2M
34887	payment	2133	2133	1874	1	1	3955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHZJq9BEdot3HSuMTA1GwK7PuJgT1oYcnVbKGWR4BdKMAdq2Pm
34888	payment	2132	2132	1874	1	1	1142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs482Lp2z7KjTgg6s5741YNSz9SVBgdL2ddptRTt1Aqd14eG4d
34889	payment	2134	2134	1874	1	1	4000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvmPvLWHgeMgf3BvY5XaDj6gPuMVY3eDQFacYzrJZzTJBWxKHK
34912	payment	1397	1397	1678	1	1	13555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXS5uwLxmAAELMcdLSkFn8bNpnjttq3MozL36Z45LgLv28CeHw
34913	payment	1397	1397	1678	1	1	13556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEoAXmNTp2FtmVh5iSKgdVLQ31EKxrNeeEbLtzRJysY6b1YAz
34914	payment	2133	2133	1874	1	1	3962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKyAg5dM77iGDQUh75D1JEjQKKj4tFsDLsCAUwNxg4d6dB9db
34915	payment	2132	2132	1874	1	1	1144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4Bt1Ay1vBvWMZTXTehmnTyumM5wEgJzjJqLHqABh594KqJfM
34916	payment	2133	2133	1874	1	1	3963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9QgFH8WPC2oaQNwquwV9t351pXZcoHpqZ9ZKgLUhfj2b5FcJ8
34917	payment	2134	2134	1874	1	1	4007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEGQ9t3dN6ULGNvSYAXNBe3nWJo9g3AD6mfwpfxJVUxDzi2Hz
34918	payment	2134	2134	1874	1	1	4008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtLS5PiEE1KVqJWB71hfV2LhV6AH3wwjj6wmYkrG82mjABCyY
34933	payment	1397	1397	1678	1	1	13560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFKGMx4QYSXM4UEHhKjeKKRAV7bmEG1VY8aR4JoErgF71Yuh2
34934	payment	1397	1397	1678	1	1	13561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEjofbhGxmVHUsWGo4FyZRLxdFVLrTRf6Lbed1tTEstVrGNDW
34935	payment	2133	2133	1874	1	1	3967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFV9VJRV7mLu5t1osnhEAaQHhMSPqzJwTJt6Lupgq5oqGkpBj9
34936	payment	2134	2134	1874	1	1	4012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5VWE7daqsJerfJxFkbzCDUa3PaaHxz3JRcV2piftiBjNgsoa
34937	payment	2134	2134	1874	1	1	4013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPQKVAJzhgjbsKrnX7Yy2CWn5DycGHxngqGiEJVUmvMUXQVGp
34938	payment	2133	2133	1874	1	1	3968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCPPrkpAiyzdgW96XkBySZn6V81RyWMyfhyiV8jwGpdnWKNr3
34962	payment	1397	1397	1678	1	1	13569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4hJscbeZdRWxFKrTAsFg9gHcSsxdj2n9fooQ6gonCp4jXbbK
34963	payment	2134	2134	1874	1	1	4021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gHzz2RUE2pgAD6bfRLwu25wjZq8mmH5GKQH4cccsyfiJLeTF
34964	payment	2133	2133	1874	1	1	3975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2HZBDcwrsVHvHhVfkxkXdnuqNLUmc7ogDip6Gansq4rHqKUbG
35013	payment	2133	2133	1874	1	1	3990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa593KtYTWv3LXVUb5mnYKp76bmCXekfD3KEeAkUa4LJuhR9rDi
35035	payment	1397	1397	1678	1	1	13590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqWcfu7Hjhe3S8vf6j2SAcKb82S7QBqwhBYTwG1vZeYZB8qQy
35036	payment	2134	2134	1874	1	1	4043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZER8Cd15oeGnS1n5MqXTcnHDvar8nhwBat9LyXMd5kNcYYcn8k
35037	payment	2133	2133	1874	1	1	3997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEe8ZsQzUeJmBCnMARoAAmGD6f7o395sUaBpN4pRAmNiovCdvQ
35047	payment	1397	1397	1678	1	1	13593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqE9PtkyZCFULJF9bU9mnoBWyGwBBxQ4XEsiSZUwTwUtg6ChvN
35048	payment	2133	2133	1874	1	1	4000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJusxgBjErsnpYw29XWSp4TGMvPks8Yb3RvtNf6DKGAgBRMBxs
35049	delegation	2119	2119	1672	1	1	6	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZKE2gUWn3b9D2gasjJD42xFHz2GWxnEiEK4UJ7kBf5AHAPB9fh
35050	payment	2134	2134	1874	1	1	4046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgVgmo2EpTp2UKoAEeE4UhGbtVpGaC5TqneUkyyM4kMy8NGfX
35063	payment	1397	1397	1678	1	1	13597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKe4XGMnkD2iPLdbVbJbaPgzLcMLur96BjFWKNCwxWjB9wb7Uu
35064	payment	2133	2133	1874	1	1	4004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvd9SN1xGcZuoE8dmgfVETHJFgdGHxpLm7C7jQBuNGeyFiYRfw
35065	payment	2134	2134	1874	1	1	4050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYdGV84HgZ4jkfwVbfrgjDbbt4LsV7cVbkFYwUj9M27q76AxT
35083	payment	1397	1397	1678	1	1	13603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Sjmi6RL9rUvp1s6MQzC7z6dMVEiF5mwQFoUFBgXHVBe5pWAQ
35084	payment	2134	2134	1874	1	1	4056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc5ZEgfsGJZchgx921Jewswt4cVESy4nGEDLSYPC5oj2HqKhB
35085	payment	2133	2133	1874	1	1	4009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GWCmAA7X7L5WWduki8BpqRnmGSxNgZKbMhRT1uBDTqs3pZsK
35099	payment	1397	1397	1678	1	1	13608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLdbxaFRUbkePbjH4vYE6CcZbMnXypXx1Q9VM4nNUJ9i1jBq7
35100	payment	2132	2132	1874	1	1	1160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsRfMZjxWWDayGzXPwMDvEQEyrqYEzBwHsVzkVD48TgpSfVpy
35101	payment	2134	2134	1874	1	1	4061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNB3thViuKjrqRK7QyKqdYBb2kUTLMftkBD1YcriDyKhgdr8Lk
35102	payment	2133	2133	1874	1	1	4014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vTbB9wiMJ5nb6yQh3ahcBU3DNbfNX1f7kBQFSSWHiZo852cz
35106	payment	1397	1397	1678	1	1	13610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvX2wcAgWTHGxiuYm5dNCvZvhNQVuNXzT3YStwCY4CzePn7s44
35107	payment	2133	2133	1874	1	1	4016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkrCFAnSXzW6LzfsiPYjMgS6md4TfsULVJRZx7zA51YeBUNtZy
35108	payment	2134	2134	1874	1	1	4063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLemUkQSgJL9XdD2huaUQMqJyLQKSNFmVZy8LhAqJatfon9ka
35119	payment	2132	2132	1874	1	1	1162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkfq1aTXT1KTLJEw1qL5ZFUyRpPakYrCtJNmwyufKPo89pXLU
35120	payment	2134	2134	1874	1	1	4067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHQUaiSZtMJLSrUSGECJV7Vb4hqfXyJpFfdiM1EkayXYoh7SL
35177	payment	1397	1397	1678	1	1	13629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUcctexV4BZy5C9oMZx65uhtvhU4LEbt6G9dhmWXaTyXWHozR
35178	payment	2134	2134	1874	1	1	4082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCcrb1a7JVrHZEYTwmrjTiKZdNV4Jfe852ocvVBqsqB1QQ4KQ
35179	payment	2133	2133	1874	1	1	4035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARgK9iJyPXcVN5Vf6qyE4KWKB6BjhynV4tLToww7PaYg9sdzN
35180	payment	1397	1397	1678	1	1	13630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjpmiHgBrDAcfSiPFCtoGHbj7PPTwJjdCA3bKoLW9f5GckS3f
35181	payment	2134	2134	1874	1	1	4083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjL32mtdQqeQQjZpMz1ngkR9d3xFhkTCgEE6JZrr1zJioGtzFk
35182	payment	2133	2133	1874	1	1	4036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHMWPjbxFR1VmXbQyjCzL7wigczTMNjygcsUmyu2rQguztrLWs
35190	payment	1397	1397	1678	1	1	13633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSJpufn58CXwqbAVmRGPD24tEkHVaeo6mceuwxcb2MqvrgCR9
35191	payment	2134	2134	1874	1	1	4086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyhRWPzyKpZAWwFqz3iRJRhokxRXZYNeQ5KETnCYo76bydByS
35192	payment	2133	2133	1874	1	1	4039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoiaWmqU926khCbd5bmyPQhQXLmgU6VsyQauiTU8w9Zk7JGKm
34966	payment	2134	2134	1874	1	1	4022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNp1rvWn4kv5F3UGtsQt7mkpM4xUP8ppKtaHdZVhHibxYy4bb
34967	payment	2134	2134	1874	1	1	4023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRX9wBmjt8Ws7tPXqttRMu4pVp69BGY5e3SBkKRqPPvNLdADV9
34968	payment	2133	2133	1874	1	1	3976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6coE5fv81Dfxb7J76MFTwYzqgK9BkWu1bCSBYc6Tm1TzzgG5A
34969	payment	2133	2133	1874	1	1	3977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTM6gkzp8rCAi8yshq4dR9VJtbxWdznkzzkiBF3KRmxUSu5K5e
34977	payment	1397	1397	1678	1	1	13573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3L7rJGJfpYZxAVcMKNQiNjosXf7iVDFVkX5r57eSWaeTrbmHE
34978	payment	2133	2133	1874	1	1	3980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRJVoM5vtznT89zDSuvQP22MMBX7jPY4FbAdujjwdE1FzoNLhH
34979	payment	2134	2134	1874	1	1	4026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD2Z5U31z3WScNaP8x5rGAU1Ub8wxbBNkK3u8f4jnRdML8PuAr
34987	payment	1397	1397	1678	1	1	13576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4YtyWfwiu9sQBRUuZpx8dccJvkA8p5E2QnQKtvodZuwPc1ay
34988	payment	1397	1397	1678	1	1	13577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQd4GdtL2vWbmd8XZ6KcWXk9WcDeD22MqYgNN4N4BwiDPKbpx
34989	payment	1397	1397	1678	1	1	13578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaErW9Dh8caV2GEQqXdMeVoRR8cQrwiYaDyJScz8k1sCWtHYUG8
34990	payment	2134	2134	1874	1	1	4029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hmgNSWorNXAHbvR6BrXY1tNTLXbTWcqqpuHAEjMqw1amCy1B
34991	payment	2133	2133	1874	1	1	3983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRkYoxCzioLXukVHJQZRC1fGHmP9GCg6Zh8BAx19U8hVeaJtc
34992	payment	2133	2133	1874	1	1	3984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSuJwRBLTsLvMp6WqT5CYx9AS2LHA1ZsSfQUfrqkANyk6kkZTk
34993	payment	2133	2133	1874	1	1	3985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1uKKn6YqdEd16s7kDsChpjebZBt7GGnZV3bzcATbHoD94pRVK
34994	payment	2134	2134	1874	1	1	4030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaioXgL2RW4UJX2aP5KL5bN2q6BfQo8xtAhQPzKfC5Vu6HyJEQ
34995	payment	2134	2134	1874	1	1	4031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfGbosG3ucvMvXXovp6vrUaAi66Wx7hHo6DT8WpxfAHY771P7
34996	payment	2132	2132	1874	1	1	1151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKH4u6EZ1KizUcaZXwLSYiTYPyCmJfwZYyEGL4TQCt4QgXEsZH
35021	payment	1397	1397	1678	1	1	13586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa64qbn7AQ6brtuunDQfdfKbHTpE19Nbunp6tumRtqheSrWVuca
35022	payment	2133	2133	1874	1	1	3993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEA41k8deYaYd9S6zrVHtME9uhT5RH1ZQYLbnzMMdRht1y65f
35023	payment	2134	2134	1874	1	1	4039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwwZHFGEE7DYEcukXLH4Yet9oFM9TmisdABKHM2jEzJ2gzQq8
35027	payment	1580	1580	2300	1	1	0	60000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXk1MDYoyRELsEVvaXkQzuEPuqQmHRXNzt9nEYEp5wcQs3yfcm
35028	payment	1397	1397	1678	1	1	13588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVqXKuSNNQ7ZDuER7WUMd3TDGcgNaaFkcx99oSk2PzRi7bXkd
35029	payment	2132	2132	1874	1	1	1154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTKn8ZwrvpDMHNr8Ry4E4GoCnBKuAVyXr8RFC4yv8cJAr5kVu
35030	payment	2134	2134	1874	1	1	4041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnP8vXydvWEgdRAYfhFqoCSdRvqa2VJYJnWPMt1LHqXpZ4zNcm
35038	payment	1397	1397	1678	1	1	13591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQVwyNY9hbBxmRtncdoeuRkjJPNQ4pLZ2nfjJ93dQaUE5UWJX
35039	payment	1580	1580	2300	1	1	1	2100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JcXxGrZaeX1XKpiuisbkUUiDpgPYq1hxrFwGjXGrZCxRd6cu
35040	payment	2132	2132	1874	1	1	1155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJ5wc31hmx9RQkMqofnt7YLH26JQv2kVNvGZGak8LqEqjgTDG
35041	payment	2134	2134	1874	1	1	4044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzfyD45fY5dQxr9dm5Jhaq1kXdF1DchvWNDi1WW5Beb3FJSSX
35042	payment	2133	2133	1874	1	1	3998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfZ21UPEkjWtNjZ95mby39qhbRN7TYYHmk6avHsaPL3H9JDob
35060	payment	1397	1397	1678	1	1	13596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eiKYf4Scjb5oJqsuTuju2W7pZWx53nBF9oB4nDFG7Yd4VxvF
35061	payment	2134	2134	1874	1	1	4049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSTjEZ48zyLc8y5NAZLhs4sG41xGCYa8xX9uwczPqSmTchA7fm
35062	payment	2133	2133	1874	1	1	4003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ebeG6j8s5BoXpxaPCecQq9Vcia4bEYtnAwbvWP3mMTf466cQ
35071	payment	1397	1397	1678	1	1	13599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2UvrWYQrVLWEVvyv6mUS3Vm9u88vh9aQ6miuktAWMvc82vNh
35072	payment	1397	1397	1678	1	1	13600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcisCqruSyx4TXNiSaRKdKFLowVSsY8p1Z2rS8mVj7BNs7PNvU
35073	payment	2134	2134	1874	1	1	4052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYijhCdM59jd35mBv1vu6ihEQfS51QbXCPbB4d2RafE1byGyWp
35074	payment	2133	2133	1874	1	1	4006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFm9qEFNrX7rYPUU8zhW44X1yaDa1QtYoaCpGEarwkamoUnG6
35075	payment	2134	2134	1874	1	1	4053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7PETMHHgM2jeYdyFhcJc5WUedQReSBaEsfVKdvBurV6MXT5MD
35076	payment	2133	2133	1874	1	1	4007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqpmrJd5D7hAzQCGUgJvbh1siqneDRiS7vJT3if7MkZD6qBkK
34999	payment	2133	2133	1874	1	1	3986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLAhmEUwSueiVNvSKaMdvv6PhVeGoKoA3DVRZ39idKMFrA3c4P
35000	payment	1397	1397	1678	1	1	13580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDEwDKLsDnvnmgZRYVRT5hU3W7un8g7jgTs5aZXkeUy6koBZg5
35001	delegation	2119	2119	1672	1	1	5	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZ7wTDXDrZQeNQKLTwfpjF9Wt2htwCEjmb41UtABH6dK4ep9XDJ
35002	payment	2134	2134	1874	1	1	4033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjfqU1g4YgJTAK1UERy8ziiTAKjx2g27digjjsHp14FyfTfSA
35003	payment	2133	2133	1874	1	1	3987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLQns6ZZutTuBirvwrCxNVgn8rj9i7tBFqchJCUDYwz1KaYCQ
35011	payment	1397	1397	1678	1	1	13583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLNkMjWwQF3PDm4uXZtfLdyXyQ1Q3NUfnSiKiTSt28KMvxCb8
35012	payment	2134	2134	1874	1	1	4036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2jrwTknFaWeoA8Uge3zSQGXeb1F2K9tyxD2FF55A1P6p96FK
35032	payment	1397	1397	1678	1	1	13589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREajR1ANZThav7P1AGcfHxdy8DqeSi4VGymWTYqahq9mLWqVB
35033	payment	2134	2134	1874	1	1	4042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWy4Zv8wuBndCJVy1aSQvigB3eMjx6e78gZU8FJUozn9hpmP5
35034	payment	2133	2133	1874	1	1	3996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybAJ5fDNocQ3JS1fRb86FVNaPRWKREfqNbcLsbuV8pqfEJbSP
35051	payment	1397	1397	1678	1	1	13594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RPuMLZMjUKJwgoeAnBpcs1UyrD8i7EsRKdxoMppULJHKthYw
35052	payment	2132	2132	1874	1	1	1156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbjQ4AU4FhzLnnfxY93w7TA5bNofAkjkHpUXMPP4dUW8oFmzV
35053	payment	2134	2134	1874	1	1	4047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJezzXCZZq2XKcmuciaaZFJTVUvZ2vv2AmQASBMrYpTPkAXDk
35054	payment	1603	1603	2302	1	1	0	1440000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa845XEqMuG5FVsWWevS6ja2KNusBvwXyz9oFYQ9JTNm42gd5x8
35055	payment	2133	2133	1874	1	1	4001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqbV4nWMzK3MB5jSNipYggNaubb8zWwQJqQrqjCqvquKNdeJc
35066	payment	1397	1397	1678	1	1	13598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo58Fqdhz6BaGUreR6uekGF6FodwkJz1z98yza5RJGVv5LdTdG
35067	payment	1493	1493	2304	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsAh8ZUKs8ndTVoWuaUyVcMMHpmzUbTdxCyqvRwwMt2zwhEHQ4
35068	payment	2134	2134	1874	1	1	4051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYu8qHpYQ1hRqCzh6d4TnKQEusEmrHZEkNHpZMYqc1ci1rfKwa
35069	payment	2133	2133	1874	1	1	4005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxfzJx8r7FmCVzxg9AcowUBTqGcEkuDBvBuVJkHsGev4dhiqr
35070	payment	2132	2132	1874	1	1	1157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8WUTkZPaQTERs2NAkPCGrXkdibCZNQdPkCkc8q4qgWYWeKJV
35077	payment	1397	1397	1678	1	1	13601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxm5dGYxwcmfVpxaD52wYUMZZ8xeFgwDFZ1tz5iQpwL8EP8uCC
35078	payment	2132	2132	1874	1	1	1158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhn457f1nuDC49DRxatsAELD6yLdSpbNrJpWUp5sMFBArpi8f
35079	payment	2134	2134	1874	1	1	4054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8vMyE26HDMBbzigXheJ19sZUVxj8CGn2NCB175bTRHefzTaS
35080	payment	2133	2133	1874	1	1	4008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuT12ubhDa6PuH9QLigeA7FVeK1DY7UrgtkVjHgeMGk3qxsp9k
35086	payment	1397	1397	1678	1	1	13604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSdtHACDd8gGfAafJpjTfEsvnTDsm8SRr8amBxYNqtx2LBsrk
35087	payment	2134	2134	1874	1	1	4057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGE6AxEuPQ5kWrswMcNEraBn9bviQvSsqyv4E8kaHgFZJ3QaS
35088	payment	2132	2132	1874	1	1	1159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLBu63Ah8SB7iVFQeMaX3FBGr2T9v5bzFY4FpoeG4RRfJmmJC
35089	payment	2133	2133	1874	1	1	4010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QJ7qXGb1D2SesaBRcMJPCe7upFXdXmivpWxzLWGCZFJvKHR5
35096	payment	1397	1397	1678	1	1	13607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyi9AoPtgBvxzEnPn9MD1ojtiQFWivhsLdu1crVuNeogwY7PK
35097	payment	2134	2134	1874	1	1	4060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8n7h2YEJ1r3C6Mr7vxVcMhNwy1BKGkwjXiyQPUzptGuMArmhG
35098	payment	2133	2133	1874	1	1	4013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCrP55hJVBBTyu1CyQwDxMcJuxVi9PzawAirxeBCnVHvKQFAu
35116	payment	1397	1397	1678	1	1	13613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZxaBXLgHxA2xR768fvinmHzeNDfnhq5B5zeeoiKMbVWZihLX
35117	payment	2134	2134	1874	1	1	4066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxqWHcAJnb6WdR6M3yEFXPczVdnv5JHB2o7LDTGB9SScaJEoc
35118	payment	2133	2133	1874	1	1	4019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGTUGrMkxwfWL8iStYZdj4jaj6x4pi4PQSRZzQtc184uVFUcW
35121	payment	1397	1397	1678	1	1	13614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKW8ANC41HdX6yQwxZ2ovnj2JMDYbWJsii7mvjShoqKvdNENjD
35122	payment	2133	2133	1874	1	1	4020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGka45UNwjjg2LoKW1X5iiJCCfkqXXcqNW7pagAWL4WrLh4Zn
35126	payment	1397	1397	1678	1	1	13616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6exet6oovjBVW9Qo1S4MJkonvNWrZUtP9mdbY3UDdgUp85EXv
35127	payment	1397	1397	1678	1	1	13617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDshTW4kmPkpjguVqDQo5EQauzkQtA9dKSztbPTiZw59d2UkZ
35005	payment	2133	2133	1874	1	1	3988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdfxCvabQMvdDG67BGSA4rXq6RQTmU1ToMeMcEs8VBx7xp45WF
35006	payment	2132	2132	1874	1	1	1152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqunhmqEgGV9JhPX2DbNdeVBnfEcUkieEZRQ6C7kWYFoB3CTVj
35007	payment	2134	2134	1874	1	1	4034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3v8LgRpQfmRJJ8BdZYJ21CXRbvU2BoKiK54KveZhbNLqtLwEG
35008	payment	1397	1397	1678	1	1	13582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8k4esCWi9uZWSjtagskaPNUiHAyqU17EtjCr121LSB26AqiEp
35009	payment	2134	2134	1874	1	1	4035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgiUkDHM2pD5wSEjB6UL1izTvUzTbwhLjrfkWTRDaGPN6bTF1
35010	payment	2133	2133	1874	1	1	3989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTx2A3Gm5eawMHmFkksfXJCH9RJ324Sfz7TH72wzKAiqLEwyJD
35014	payment	1397	1397	1678	1	1	13584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBYuzqFx4aEDDXPd8NDVtDJN2oqx7swPEX8U4a4ouo4qRcUib
35015	payment	1397	1397	1678	1	1	13585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9y52kQhqrJ5hFJYiWEtTVpfKEvRSNu3oFabrUrtf4TGUa9s2
35016	payment	2133	2133	1874	1	1	3991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRxFmetghuCyXv4Snu4D78vLRjA3EPwbbwBTDyqcHGDnGeb4e
35017	payment	2133	2133	1874	1	1	3992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkdG7QJRFcbGP7iUtHKCBhr3VGvUjnPJJU2Z3APKy4UzXz38u
35018	payment	2134	2134	1874	1	1	4037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCmS6mTMQZP3nwChTrkjmzkyjQSRH76YQGayqNWbtG5NaTKxu3
35019	payment	2134	2134	1874	1	1	4038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HWB5DuDBTP33X5ZP6TS77Amg1MpYWnzD1omLjd6ES8JeqrW5
35020	payment	2132	2132	1874	1	1	1153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDw83hzFKZZimAdsyR3jTq8m4cRCQi1qBoBocD1sVvXhQLbnW
35024	payment	1397	1397	1678	1	1	13587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnaWwGKaXRGx2GqpJoPgDt6qDHaWaGR4C2ggi2CesMo3fN2L1x
35025	payment	2133	2133	1874	1	1	3994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWFnryonMyxsZKnjCHZeKPFSehjRPnhp6x3BhbetR4gQBCQGHe
35026	payment	2134	2134	1874	1	1	4040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFPntnZnk8dEWMtMT3yJLonCjh4yko64g8MewJEFJXqZ4mpFz
35031	payment	2133	2133	1874	1	1	3995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXba5mGSKifEoLDGdkJNUmX1mVhqAj3mjtk5vbVKvf4rS1Zvqo
35043	payment	1550	1550	2301	1	1	0	720000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaqJKSs3R9rmwjW1fnkQxkTgcBNqrcw7QKReFuZmWYLpLApNo
35044	payment	1397	1397	1678	1	1	13592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytNkwcfnBeSZp2Um4bemvLBZkNm6KYWsjUw2g1DvtQLEGYhfT
35045	payment	2133	2133	1874	1	1	3999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbVjzgsJ4j1ryHxA6NyTBihDJY56YgfpAzNxaMtdDtdXJWfqs
35046	payment	2134	2134	1874	1	1	4045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegRprkDYp3PvyCKJqhBtJKrytppF4o7gvcewWBtjEFRNGtueb
35056	payment	1397	1397	1678	1	1	13595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUC2GmgACKLyY5AU6SqXvN2tzxTGtSutnkQjX4EyoskyjupvWQ
35057	payment	2134	2134	1874	1	1	4048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQXNC4k8sUxx6JzTWzT87wPUQYHZHMxC8B8HVyg73up4Cg9aL
35058	payment	1531	1531	2303	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtJUya75hDooBAVnPFywKRNxNLDqhpupMtYvgEjGWYG1C1EKH
35059	payment	2133	2133	1874	1	1	4002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtB3BjbRKmD8obcao9MrFyZ4sGBUFpcvvKQ55oT6gtU4RbyHd
35141	payment	1397	1397	1678	1	1	13619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GVDPEnii1S7jvKXrh1N869F6x9LXpP7U5eYBVQfvMHapJMCu
35142	payment	2134	2134	1874	1	1	4072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGAR6oreF15RFzA6qCpvdEGQKXj8XF9eFNtzGV2GWJaFsPbegL
35143	payment	2133	2133	1874	1	1	4025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7VdrKgozj6Tebo3netVNNQ4aKfuiB459PAfnq5utKVJB2jPR
35144	payment	1397	1397	1678	1	1	13620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr4nt368JmX6aYghNTRPnPCPdD9SMDezuhJ2cN2N7Ejb7eMHr
35145	payment	2134	2134	1874	1	1	4073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTb8D5eXwNdMGAnvAUJnbh19Xj7e8pwJTmUf6KzQ16786kXBU2
35146	payment	2133	2133	1874	1	1	4026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRghW4bVdawuqu367ATT2pxpz7fgn9VrKXUZVSFJSMsu6bQCe
35157	payment	1397	1397	1678	1	1	13624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhudLpjqG68bKioADHCppxmkr5LWaWDBMfFc1cvv7XCA6oyTXE
35158	payment	2132	2132	1874	1	1	1165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHBh67SJb1hMJjdtDSzoaxuhrGVsGk5Nw4YDWfmdGteXwyo63
35159	payment	2134	2134	1874	1	1	4077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMQiFfzM8Csga6LJ3m4hfr1jzjk3moSYEbywLtRjdHHkvodcd
35160	payment	2133	2133	1874	1	1	4030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXEjiGzJgknW7F22iwXMup8wCpf3268DEBYkkbfGbRh37msY1
35169	payment	1397	1397	1678	1	1	13627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqqFpb53SFrhek2sdQoymTNR8NkfnzuytjChisswMaLQrVpf7
35170	delegation	2297	2297	1647	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hofP6fCawC2aZqag4MpEvK15udQyne1wd51pChKJiaB6ggZg
35171	payment	2133	2133	1874	1	1	4033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ko8KztwpEU7eBygoUyEGJ3A8Kx8qsuiqEg948DutpyC9Sj7g
35081	payment	1397	1397	1678	1	1	13602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrD64GSu2tFdTtLdtVNtruZ4oYB5UXywp1MDyYDkUhgtZtvWJ
35082	payment	2134	2134	1874	1	1	4055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5AoPpKhhKJE9FNmGA4dSptw4mT9wBiDCDi9jjKebnHogYaot
35090	payment	1397	1397	1678	1	1	13605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtSdMSrRF2BBXuKhPmh3Ziv6g2WzTJqpp5Ct7hNKFJxkVQM9sZ
35091	payment	1397	1397	1678	1	1	13606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskiKsU5f8PGJfinXdSYjPciuEUh57raydAu8bNqRqohyV7YwY
35092	payment	2133	2133	1874	1	1	4011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6fWK7EptJ4vx2EPTmG1sM5jBtChzv17G6rZTKdd64UaFtsz2
35093	payment	2133	2133	1874	1	1	4012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTowjg511TGEBeScsr55RKpcU7sK7dnS3ka8C2c83jeV4YFZVP
35094	payment	2134	2134	1874	1	1	4058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Ezy45osJnbK8yU4tcr6eQjGHssv6hwmnQEXX8P8QSRPGYEt8
35095	payment	2134	2134	1874	1	1	4059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXjTbqkh4eJGLHRuQMJptcJZ1naiuEGFMP1xgXVEjeiY619Qm
35103	payment	1397	1397	1678	1	1	13609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5xnboswjk5S97spXLWsrUtomtdLJkbANoffNy35L4eCDc9bQ
35104	payment	2134	2134	1874	1	1	4062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbZmiT9QnzerNS894Ttrk395iWvZxgBsZHxK1AabQhi3B8TRU
35105	payment	2133	2133	1874	1	1	4015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3z1zW1LAUJy8oYRxvUMHr2sUpmCYYXpN3RZtW5aFNqbUxmZht
35109	payment	1397	1397	1678	1	1	13611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6trAVZmryLq5hVreJCjX4Sk8TdPW3eG1Y3J4U35qJTRLRVaD
35110	payment	2134	2134	1874	1	1	4064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6iWVTh3mg38mi9JZKewgSi2N9R7x46uxPoBbmpd2CkoApMFET
35111	payment	2133	2133	1874	1	1	4017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnzhm3WEFQRQ8pYYniAVZ5Mu9a5Aj8RH25hxJdM7JkupMxN2s
35112	payment	2132	2132	1874	1	1	1161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKDzyw3xKuDgYp3Mmo6Aho3Vu8R3G7Kys9XYHhuhBZ3jmbDTL
35113	payment	1397	1397	1678	1	1	13612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGmFAE9TmWjeTXPF9m5WqaTw4L7DNoQ6b9XUz7QTZBq72L8Um7
35114	payment	2134	2134	1874	1	1	4065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMLrvoSScakbVXybfcEpYkyqBNLY8ThHVGUh24Z1TLWUHC8ib
35115	payment	2133	2133	1874	1	1	4018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKn5Pm2oK9SQuqdXN5xzobcxFRxouBNdWQENHJi7pubCz4V53i
35123	payment	1397	1397	1678	1	1	13615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiN3QgbuEXMtqtrpVmDYa7Ynpm3WNtrTuzcyMZhCynH5HTFy4
35124	payment	2133	2133	1874	1	1	4021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNiCReRp5zriYZYjMYs8k221J9iTaAz9A3KvvPJwir38Bi6jQc
35125	payment	2134	2134	1874	1	1	4068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1yx3kM2qcFQ4RTud4dL3b65Qsmcg6YasneqsM5pxFLc7vUhn
35147	payment	1397	1397	1678	1	1	13621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGYQnaztfXdBsBuyckfsA4Q3r8Yi2FdQeC6hUQiH7rqpwNM8m
35148	payment	1397	1397	1678	1	1	13622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFA82CsJHSrB1cajBQQ5W3dbTRSqVMQztWgM5eGmJyNv2VF8p
35149	payment	1397	1397	1678	1	1	13623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpngyrSNfo3Wt2yfvZh5KgZDW4wobF3mfNxrL6YxKeub4bdpk1
35150	payment	2132	2132	1874	1	1	1164	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdnYk2Zk5d8dQAAK6338uFFFfLd8AjjvMLavw8rvMbgFrRfcF
35151	payment	2134	2134	1874	1	1	4074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLS9kTwypoP2BuPHRDPCG18GpU3MYSwuZnzXZBLVEfz4tsf1j
35152	payment	2133	2133	1874	1	1	4027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWHWzJBptMbWyYR2TPLEJS2JVTMNPxWFbwdC1oda9a5oFZ9m2
35153	payment	2133	2133	1874	1	1	4028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkq8fZDsoqTMkdA1CavxdwDaY4pud6YAmyhwtpke1ANAb4ziiv
35154	payment	2133	2133	1874	1	1	4029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpKsdHWQPTo12xqTsCZVycaEvxY2Yfn6rsHXLCRjChEpmUc5u
35155	payment	2134	2134	1874	1	1	4075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9SVeHUA4e3jbaTLNaPVZJzZgp3fZnHRk6FuCCG7JHDXsUZB5o
35156	payment	2134	2134	1874	1	1	4076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtp5M2UQvysD8oLcTuxuS23EX8CGoVcCf53kATp6YUwhw8hFJi
35165	payment	1397	1397	1678	1	1	13626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMn6sLcUhYmw1sZ1Ei8TrESpcdAqS9KbANWxyf9aXdypwWism
35166	payment	846	846	2297	1	1	1	1207769791681	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPR4t2eeXQEani3nLoH4FR34dbCihE8NhSMioEQwHiS9dZ1os
35167	payment	2133	2133	1874	1	1	4032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbK581m3Rf4CyHVPjHnbCdzBx3qYQjGMmX9xG3EL2kaSmxxro
35168	payment	2134	2134	1874	1	1	4079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dEoP435QDGmHHgL6UfpEKAQJ2rnC53RPcVyZwxtyJ1BaDygi
35173	payment	1397	1397	1678	1	1	13628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9iZWJNLk3in36a4SpgQkhA743hitkeiD72qTmoNqpeDAJaAqH
35174	payment	2133	2133	1874	1	1	4034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDgDwJtCStxepdmCoJoKPXY1vfnyjaSGcv6zdjZmfW2v6X1v5
35175	payment	2134	2134	1874	1	1	4081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuE5UGWZrBq7xpzkQgX9iDGmDTLhVCNPzGFxcsCqDCymCQvgp
35128	payment	1397	1397	1678	1	1	13618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCdUtCKojGghM4tgKMfhHFHAUv3xT2N7b95WJ3jM8zuDWi7gh
35129	payment	1422	1422	715	1	1	7	7313670138	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpYpNvtMMUtR8tyFjMXzQUPxJTJWh4PQ1KnuVbpGXY3CX29vKPkg
35130	payment	2133	2133	1874	1	1	4022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMXybq8TrdBaTQDd6AVURNPc1uNv6YmnoHWQN2TQQUou8rQKY
35131	payment	2133	2133	1874	1	1	4023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvKQsjdDH2XTEPKZjfCDrRHcPNnUkZf3YcGsH3JpJVmNm5E3p
35132	payment	2133	2133	1874	1	1	4024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoPiQHDVvxVLMMjuPTpuTj86RetiM6ZU3u7DsQzi9DJhnWbGV
35133	payment	2132	2132	1874	1	1	1163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnv4QadShCcQHCzDebcRugiDzLzxP6RU4Fzi4YPZvkYc8QskC
35134	payment	2134	2134	1874	1	1	4069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4nK8ZfG33UkZeQvekrATiXxi6oJMjCqgDgTfRpomBcTfreqK
35135	payment	2134	2134	1874	1	1	4070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUJoL5YYSh9bmZoGDpbRTwsY4HyyDRRGAyTipHWWSTNXXiKk8
35136	payment	2134	2134	1874	1	1	4071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cqNgyoHcFJDQSHGrkBH2ZD6VQSzcq1HZXsv1SgVv9QWvNi3W
35137	payment	1447	1447	1345	1	1	6	6195160150000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	Ckpa96cxx5z83Fdk7RZef2ygc7i99gJHhCbFJ4GKWqxo5t8XKmF6D
35138	payment	1447	1447	1099	1	1	7	3295005140000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZNiBoWVocmZDfh4EpryPdh5FqP4XjHdUF9j6FYDy7PW9CSFoWz
35139	payment	1447	1447	1219	1	1	8	2223205630000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZxVEZQBYFgDrn8xiPBUeAcahKkLrLr8su8xqWgf3Veyy5MgpBY
35140	payment	1447	1447	979	1	1	9	1838739340000	1000000	\N	E4Z6PpTr17Q3ZVN4xzcvTfe3KYypjWUDtp1soUurJPw93MDzZniEJ	CkpZPB2n8gmbJt4y6uBDQNb9MRSuFJJen5kMARGYEJykQyKLxfsLy
35161	payment	1397	1397	1678	1	1	13625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa117ZKGZZqQE8YfHP8v9E3KZcEr7vhuwgD7Xt6YHE29mkDyAsu
35162	payment	2133	2133	1874	1	1	4031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPKBuwwQv7cK91LeaDyw55AXhUbDWnQM6GGRXuY2bfzfKvcewm
35163	payment	845	845	2297	1	1	2	1207769791681	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73SS1b2srA5mCpwJPLLLxDGDsUkYPBiuMBFdG3LEBfLwH4rDm
35164	payment	2134	2134	1874	1	1	4078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dEk3wNZHEbmxE8B2cgXp2BLRvSmNYVDePa2DD1Sqze9JbJ1t
35201	payment	1397	1397	1678	1	1	13636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TJQ4ywvAdeGRGyesKqQzACvh28M4EKBNy9dGKtFuNvtfPr6W
35202	payment	1397	1397	1678	1	1	13637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQ2sdSgiHXx8dXJLFgbbtXDktg8SDysdiPUXg5QDbnSEZ8zgd
35203	payment	1397	1397	1678	1	1	13638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCsXJTJeKcB1HxfbpUwziJT7Utqff1xMQczHuJRQKjmC4D8Gy
35204	payment	2132	2132	1874	1	1	1169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxyYyRDoQ1ViMuLftpX1KsMCSkaypbnmC8TCiFEYRZyT78dioZ
35205	payment	2133	2133	1874	1	1	4042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxvfbNMj1fkjstCgrFz7Whe48L6ixPCnHyZQ8fuUcnZ2snW7B
35206	payment	2133	2133	1874	1	1	4043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qeg8MWj41EDBRxMoCrwKKS2XfR64noYzeWp1vCKtxrAAsSu2
35207	payment	2133	2133	1874	1	1	4044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqZ7oL2MoVuqKmLjuPL2TnyoQeebXEiEqe83yWJN5m6GnoeS6
35208	payment	1457	1457	1391	1	1	4	9830557440000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpSaK7VQi1hVWN2m6Z1QeV9vAF6nw9k2nmdgDauPXpuetkvqj
35209	payment	1457	1457	1145	1	1	5	5228605440000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wGWvxTPW4a2SGqKJPw99PiPwSgRExbjSabcccv23UxbWT7Wx
35210	payment	2134	2134	1874	1	1	4089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgVnHtnWV6drgTeGHrW3wSf8WmWxk8hmgxaqhYsbtPhoDa2YK
35211	payment	2134	2134	1874	1	1	4090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbtM8drQzcCy8DLydyHC8psGn99jxTJrdJiQF7GiceiJZNmsFg
35212	payment	2134	2134	1874	1	1	4091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcHbFbJj3oySKudAi5pX8jJExU7JPpcq4XHAzn5kgGyNPH2Yp
35213	payment	1457	1457	1265	1	1	6	3527688960000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQjqwv5wUe68fbbHY1FifJQTYWKe6irYTL3iGfU95Zj3XBYvr
35214	payment	1457	1457	1025	1	1	7	2917670400000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8kNTfUpBSzEpeGwocRvkNVRR2N6tpNXQuoaCHS11hsUMgJPA
35218	payment	1397	1397	1678	1	1	13640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd425uqQZzPusuuTNZ3DFJYuimzXg3NqxQYWLxAAG6ch82SPXi
35219	payment	1397	1397	1678	1	1	13641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYn2zCNfUPFQprhQAmvpnpCVbLZejvhxaBLEN7urmWHozNRoB
35220	payment	2133	2133	1874	1	1	4046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiX8EeR5gYSyyEeKrcF36PbihaYj2hv4A7gV3GF4WRy6fgKaP8
35221	payment	2133	2133	1874	1	1	4047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSakmby8ronHNm1DfAE2GqQWTKBZsDbARXeWAtCf2pKZFN7Zk
35222	payment	2132	2132	1874	1	1	1170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirPDYQ45ZQyDJhi9FLggihjbzbvJkrfQ967vToZupPtVQXxoN
35223	delegation	2119	2119	1672	1	1	7	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZ61dxrgYs1CdaC2iuW9eLSi2ePVTXTBbQrE7tNbrcwrJj7qMrk
35224	payment	2134	2134	1874	1	1	4093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvTijSeKeytgoELo1drE9N23VQ97ciueZeFMMJdVm8TvYA97a
35172	payment	2134	2134	1874	1	1	4080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWbx4rz4SGidJNBEukAs2AjH6ae3XYEYSZrJPWBRrw3hB5ytc
35183	payment	1397	1397	1678	1	1	13631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRPaqcjDCFrL4xT6VrvYCfEpYaPw6kvFAnJmZM5vHQDBWk7BE
35184	payment	2134	2134	1874	1	1	4084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXFhty57duJ5bzYcsa5o3kJ4PrcbhDDisems3z7rQSRHNKwf9
35185	payment	2132	2132	1874	1	1	1167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt6vfEC9i3eH2p5FVQzq8M7rw2zvSGemSFTrhiQ8f4fhwaUtF4
35186	payment	2133	2133	1874	1	1	4037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZJJWHk41kY1cXzEhuK6ipseeyUkM3RmEwCnAeZPkohPud3Mh
35187	payment	1397	1397	1678	1	1	13632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4qAPwLeaaeLUggV9sAE3R9tmEqd3kZpeE8pL8rdTgkQ1ehXx
35188	payment	2134	2134	1874	1	1	4085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9G139dBWoxRHbKc6Z8QGZ3nCjqRsQosNaquMiR7qnPwkxywq
35189	payment	2133	2133	1874	1	1	4038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaES4C9jsLQukZH8Vp9PkzcA1zM2zJDCdwDMK6j5REnA33Sz2a8
35215	payment	1397	1397	1678	1	1	13639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYUBqAaSzesdL9YAakEPGRot38TRwucPq8cbsEGxaLXXg5qWM
35216	payment	2134	2134	1874	1	1	4092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8m679uhSzNVFnXyt1MLjVk9w4BZYReaQcZw7kJqE9PsZAkU57
35217	payment	2133	2133	1874	1	1	4045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7VhHD3TSLadNYvxmcZdNCDZz9K81tSEwu6dZ9Qb4NgQhJKCD
35229	payment	1397	1397	1678	1	1	13643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JdhjhEMjLqCGcbPcwGRYRAUeyLnkmq1VDdpbJE38ZyXfBtkb
35230	payment	2133	2133	1874	1	1	4049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbYopEna5GyefADQm2cnAnwooMCmja8Ny6HLTBUJkRKMNkDZA
35231	payment	2134	2134	1874	1	1	4096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTZjFWpjDWVAoN1u1megnqrZG4QTE8EQ76yRFTJL8f2feE8xi
35262	payment	1397	1397	1678	1	1	13652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJFuf7YQUuqvXoqUtdjs6FupbWptbp5hY7gE7NrNpS4V4qzYX
35263	payment	1397	1397	1678	1	1	13653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfukFmMkBHJhGqbaZXNsC3wRdVs7XjaC3F8UKxm4VScD11umwn
35264	payment	2133	2133	1874	1	1	4058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspSrjuc66XL3fcVYzzE4owWHPGBm6dBwhyShxNegEL2wUAtgK
35265	payment	2133	2133	1874	1	1	4059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBNKpJkBn62eavYBYxrbpVUEb66DDUC7xjaCWh3WyngeH5Xpi
35266	payment	2134	2134	1874	1	1	4105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ec954q61hF6wv9r9bekzKMaGi7Qrye8HynuiHDXN4LjNypdn
35267	payment	2134	2134	1874	1	1	4106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjjaHapZMNryQw6yFEjyFCde6S66yWALEKceRx2wcSMMp6bFL
35297	payment	1397	1397	1678	1	1	13665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BPVSsEXEj2rLq7mZDEAXz2UEmKhefZ3V2chTaGN8t4jQhPNC
35298	payment	1397	1397	1678	1	1	13666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54kZxdizCWVk37CLfcQuWUZfARYgyTxARutHx4CGmh6jF7CxN
35299	payment	2133	2133	1874	1	1	4070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1Evc6asUmjKg71AjAbLLCUp7jKxjWp1mxnu1hf5jpBStv3Uz
35300	payment	1422	1422	1337	1	1	11	6538636350539	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpZsJs1jC7aBMGEXYQGk3sKJGiM9tjqZF4knqYfYCpKj4oLo21Ab
35301	payment	2133	2133	1874	1	1	4071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3L3nqUSDh1K31Sh6fjVhL5mAjgu1TsNwBXWuhftL87FFbn2w4
35316	payment	1397	1397	1678	1	1	13672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnxetUCsKoAFATDkTHXZwo4AP1vUgw7gRvG1j1G3WaksRf1ki
35317	payment	1397	1397	1678	1	1	13673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJxLxXPbdAFWGqCsTHhrMx8RhKR1M8QMv6ehtQDnjrgqo4Y2Sj
35318	payment	2134	2134	1874	1	1	4113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5SektyMQrq6ai9bNUCkSm3SWuqPycqWEt8ahPYhCGnSLYiXmz
35319	payment	2134	2134	1874	1	1	4114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMUAgfXPAa7vdCtekLTj8xPES34bgwetD3L7koacJjJZvVnvu
35320	payment	2133	2133	1874	1	1	4077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbXif97wH8443rXgH46xma9VUgsPr21u3yb7W6Rs6zVU9SFPQ
35321	payment	2133	2133	1874	1	1	4078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQcoHoESDpnrCiscg6V7kr9ghUZEpSPSZvfKgnuRTYbrfL7GN
35322	payment	1397	1397	1678	1	1	13674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYueocADUdEiwhxZxNDR77yVGc5Dw9gnyfn9VdnWXZStGCpkRcr
35323	payment	1397	1397	1678	1	1	13675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXTwBpfUHtnwHPQzWCgEri7YoMVFD8fWaCb4T4Haadmnj9Pwg
35324	payment	1397	1397	1678	1	1	13676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRCTMvCwxeViMta7o8pGhgrAiqR9gBKeUgxW6s8w1DsDDuw1B
35325	payment	1397	1397	1678	1	1	13677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmk5rX7FhRQBgC7smyrYcHqyg2UouwfdSTWHHdtjGVLTyYhJkY
35326	payment	2134	2134	1874	1	1	4115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYySRANpX8UVv9rFeWhUbCM1XVmryRf4pKZuE7tMpDfXJuR6qak
35327	payment	2134	2134	1874	1	1	4116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSne2A9QWN4aP9dtyJX2wGDAXDAP6CZAFEkLESQEagM7S5TSkb
35328	payment	2132	2132	1874	1	1	1179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBotEE86KMchvMetevLGmgnei5TrDkDp8hhNdU9xSkeQ8poDQF
35176	payment	2132	2132	1874	1	1	1166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4xfH92wE9uUdJkxNuXBHnAAxUyJQRymt9m9s8dG4UYJ32J87
35193	payment	1397	1397	1678	1	1	13634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLKny28TMipaxFPFXriA9NeoFRhWRVwaosDyYhtVFBQo23xTP
35194	payment	1397	1397	1678	1	1	13635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLBjpfuqdNmm5JxcPLMVkjSznHMZAJ54FNozkTKujQba1FAJnx
35195	payment	2134	2134	1874	1	1	4087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCRFzi5WGyNPiPpZfW2CgrGNMEELp8EPr2VDtAxmbDJFnQiHRX
35196	payment	2133	2133	1874	1	1	4040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQttUM9uAvRTajrKyF9HPeKrZHp2ZYxZQjtmcnjZtDP11xUQ7Y
35197	payment	2133	2133	1874	1	1	4041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggjtWr8VamuBF7YZLXWRTGB2t3gLnCvphgJtefeD8m1UxrjM3
35198	payment	1422	1422	971	1	1	8	1940683950333	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpZWeHMbYUW1gSQPgnyRAYbvdgSq8t4rtM5HYC1RaDbD1LwY2mrG
35199	payment	2134	2134	1874	1	1	4088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZamgnrzpJRYRMgBkCJBTrMdwSdSxQKCk2xgrk6cNjQCuzyw7Nc
35200	payment	2132	2132	1874	1	1	1168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmxwwFGoWiJdyNxYsqa7LCiVQRBeEqLNQtT7iGyd8SiXxL8Pf
35232	payment	1397	1397	1678	1	1	13644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9mPfVFrXuMr913VXojr1h13vcRjTLeNL7PiHKUBmtYFsKHxp
35233	payment	1397	1397	1678	1	1	13645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUH6VNh4CzvSc4aY9R4SnXsdx6tbxMDP56LvPUqS4GWmpSY9Yv
35234	payment	1474	1474	2305	1	1	26	5000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiHogT9cDDgD1rBj11vt7covF3Gbr3gz13z7vDc8moQ7wgLAV
35235	payment	1397	1397	1678	1	1	13646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2UprnA3DUUc6mhRoDj73EArBStjs1a97v4HHGoGMdRNYdfbb
35236	payment	1397	1397	1678	1	1	13647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCdbDv2Bo4tNWq4VfTi5Uda8weBTVLisBo3g7WdyfZFh8cv79
35237	payment	1397	1397	1678	1	1	13648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhbZSopitL94dvgBvT3JZ1ZnkATddVQiGV8W12o1iFfrhFRzy
35238	payment	1422	1422	1211	1	1	9	2346466073716	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpZJ2QVXs5MAiMNP32rjSirpomV5Q36wQfWxyNJ9ChaaqPCtCa9V
35239	payment	2132	2132	1874	1	1	1171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg1Yw3VeD3EaEoA6r5TmAToWnxqpyk54DXW9Qu4RZK2u5yTmWC
35240	payment	2132	2132	1874	1	1	1172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHY88PNnJ8ENVdTwXcuwukkBLetnPrqVzq7v838ydWhNcdd5k
35241	payment	2133	2133	1874	1	1	4050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuwUKMhNvyQhAcJ39kBPkWAGoUqJpegqGeAyxB2xzu78P8Pz5X
35242	payment	2133	2133	1874	1	1	4051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGVgsRgtNZTJBGPSSQ5HiBrGApvyUR5atTTtEwkgR6UxFehYx
35243	payment	2133	2133	1874	1	1	4052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45nnXC898aj5EvDmEcwfFueM4mY9sXJmSvaYo5qXv72eCa77F
35244	payment	2133	2133	1874	1	1	4053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbybVxkaVNV7K7SGAnYLypwPFPPdxrGAx5AwzR9vKsv5U4JN2E
35245	payment	2133	2133	1874	1	1	4054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdRZoLL9F9okWjHexK6e1xkdELYUtVQ8LcXgKc53qfzgjKw6U
35246	payment	2134	2134	1874	1	1	4097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLf4rqaYVPMah6b21KD5gDPQe8kXQKTFftR3QyzFipvDgnNcg1
35247	payment	2134	2134	1874	1	1	4098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMg4bcZLUQow5w95qBaeXkCMRGkqdsdEniMQbmzh8H4EdFJr5
35248	payment	2134	2134	1874	1	1	4099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4y1dWJKrx4JrMCC2xgDsdCRfwJuuPAGHSGkqM5ML8hehyPYXe
35249	payment	2134	2134	1874	1	1	4100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnhoqdnrq2ZmsCdhDNATcYHF96kKDbg11589fmaf8s65UZSJz
35250	payment	2134	2134	1874	1	1	4101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9krNgf8QLQDRsxvzy62UzQf7WteDNtFN4R4wS4hjmRixXRUi2
35258	payment	1397	1397	1678	1	1	13651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgjSnXE5eKABEGNBf8ahfcsybuB11UAMGz6Eiha1GCD7JBvVnN
35259	payment	2133	2133	1874	1	1	4057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1yRwaSdCqL6UGgKkeQ4CT9PK9RH7ooe8gfVBmPKMmxtwBXqA
35260	payment	2134	2134	1874	1	1	4104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2aRtYqDncjTQPHo6T88mQkxqtyp3Fq3aNewVQT4vN8oCWuxL
35261	payment	2132	2132	1874	1	1	1173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnR69QqD341kgVmvycadL2TE23FkXswr6R1uCWpzVWh8aqep6w
35270	payment	1397	1397	1678	1	1	13655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwGL6f6G87MdLAUYJXzhTxBsKVrS1v5x1hsnPTVPRN4QiYp4jD
35271	payment	2133	2133	1874	1	1	4060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1BvsC8gHyMrwnkj9BKmxLV3vfBw3A3u4QfzgtSQ4BnoyxCqJ
35272	payment	2132	2132	1874	1	1	1174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJPSovKqgw9QQXXnyg8RgMeiLRenwFfVKaYGA8j3RxgtYZmce
35273	payment	2134	2134	1874	1	1	4108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ivgocZg8usg1cifv4NNGAUJsb6x4PvB4u2xmP6Ezz7r5LhYs
35274	payment	1397	1397	1678	1	1	13656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7BmEURTKgquDCHdbSEpunfzDqRmvVYH7uAcx9xypP8a2yZ5h
35275	payment	2134	2134	1874	1	1	4109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBByj6M4zT2uC3dQF77u3oYwxbHRwjW6SZ9f4h8kDcvE4Un8SJ
35225	payment	2134	2134	1874	1	1	4094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPvkqEN8NVcRRYRMwWtWscjAYzHSjSYWJ5iSJaGX5BKU6SzAG
35226	payment	1397	1397	1678	1	1	13642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8iJ2DTmUpKRdrjibauZEFQzstt2DhHTmMHbs5MBC6ZmDX5SxM
35227	payment	2133	2133	1874	1	1	4048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUW8vDz6BKRbx31sZVfodRpeNkcnt3vKhKYSXp3as91EksjGV9
35228	payment	2134	2134	1874	1	1	4095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVcpHVeBBcemPiq4LXSaV6vfFRBo43H1AteUYh57zQmQYQ83Nj
35255	payment	1397	1397	1678	1	1	13650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqEmnHhYh7vqk8sivRafz1bHA46VEWPKa7GS1Fct9shuNk4M1
35256	payment	2133	2133	1874	1	1	4056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6JTQWJDsT9CHF3nE9Vjfhc8anBx4GujAGJhyazM27AVM1jM2
35257	payment	2134	2134	1874	1	1	4103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt31wfvEdKh7FnvCGdyCNrVKZLCdW34xwkkQSBgk2Zr6xxyrD3
35277	payment	1397	1397	1678	1	1	13657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJp8Ymdq7TYP6uwxkYvDmzUMkVa9g5fGiVi415f5hehmivaxr6
35278	payment	2133	2133	1874	1	1	4062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8VhHSe5gSEXu3b5J55MEbjyfpEsyob1fzcUNJLrQHEmLeFdPp
35287	payment	1397	1397	1678	1	1	13661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81pfwWpitUFzM7Euh6DTSdbyEFFaMnd9Pu21MvmgJ8hRitaZU
35288	payment	1397	1397	1678	1	1	13662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRponXHWZSdS5Po4Ca5qCE4rT52P4UWvp4yYfnUkQo6f4NNN5z
35289	payment	1397	1397	1678	1	1	13663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgoEjnA4qvYHqbarp9Sgjr5Az5jQW53BVrCe9fqFW5YdwpLzx
35290	payment	1422	1422	1091	1	1	10	3477689011215	1000000	\N	E4ZMr5JYgAhxSqENYcSK559PQoSDXGXBLazTNnLzC7B7vKcNE5qBv	CkpYmVwxARfrzLX9fyvwPwJWMfeepazEHHDj55uu8hpAA9LPNxRSZ
35291	payment	2133	2133	1874	1	1	4066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7LfESJxWPRxEiYxc6NKUa3g16rtcoP2yU2hjvZMLtoE3mbXf5
35292	payment	2133	2133	1874	1	1	4067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsjAE7maeecg759rCSfWQvTaR9e18rz5QCVgaTuYpmmSp86tX
35293	payment	2133	2133	1874	1	1	4068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEVRtiG6nJRH5eJQGbV6nVYjyaH5XH7hkquQ4qgkXpL3oW5oV
35339	payment	1397	1397	1678	1	1	13679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJwFsQc4cyKwSAQ6QrSgmWrMRGFiVMmLVyzHVLQbrEo62682t
35340	payment	2134	2134	1874	1	1	4120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHxPs5vj1JMxA2Raw4uM56rA2ygr15REmLcV8ACRZiCrZJJQX
35341	payment	2133	2133	1874	1	1	4084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVXeGeM2Gasr7unbHqoDrtA64EeiBHg8r8vvJ1CvSzt1JbmAn
35342	payment	1397	1397	1678	1	1	13680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yqKXo8jgWhxqF46ehRUyWMEM5AgzbqxxoUpcTPNcbNigsBML
35343	payment	2134	2134	1874	1	1	4121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZao9JuvX9mT5mKjRWoPEaJiRcMaUD1wm3bgZ3FvEGbY4Spw3pn
35344	payment	2133	2133	1874	1	1	4085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhFSQQkWzidif6MMkD4mJoT6SQewjqZa3ZPrcRZmc5e9isQba
35375	payment	1397	1397	1678	1	1	13690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4ndnWsEzm8yPodpgdcATcir9mmLUSKZ6h6y4r9yrKunoAcEK
35381	payment	1397	1397	1678	1	1	13692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxpUSTCQ27y9itb39NUXx5x8pwzgnRxtSs7rUJckYhHhBGhZ9
35382	payment	1397	1397	1678	1	1	13693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKYvDvhchoF7FqYDAsgkahGS6c1Kbosy3ze517mLQBdsjNrt9
35383	payment	2134	2134	1874	1	1	4133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1JdcvouRVBqVbqC9XSaoRfYW3yGVgn2RWJoA6x9PPdtKHosX
35384	payment	2134	2134	1874	1	1	4134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBV2AwQ7etn6T3GrqodGkXZ6goqpxzbCs7QE6VnjrndKiEGwFs
35385	payment	2133	2133	1874	1	1	4096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcm1QmH3oyQgiMpnkEPWBdjpoUHUrB2fScu4cTSx2AYVxGfyjF
35386	payment	2133	2133	1874	1	1	4097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLfKjbKcD2ZBTf2ueQVTmEqrXtCFeWw9vXGrXL97qgN9DG9yn8
35424	payment	1397	1397	1678	1	1	13705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXw9LmuwZkakWmJ5yXXXinikDwaK3p4Hd4WCmHskAx79VaRahY
35425	payment	2133	2133	1874	1	1	4109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayqLSwHZGbDNE836JV3NcffbVP3FCHp1GgWArH11JBkwB3vHS
35426	payment	2134	2134	1874	1	1	4146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxAqKWqYUdtddQinQXhC5kEg2iYqSNaRqPZfRhaappiskTrUj
35449	payment	1397	1397	1678	1	1	13712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2uxHw4FYKCGvCPM8pj7FY5ofB3ifZk6E5jVWqaHgWxfWbMqu
35450	payment	2133	2133	1874	1	1	4117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusZ1QvdP8Jete9c9hhRecj3DQ3prerphVzurrEpqjrT2bthXw
35451	payment	2134	2134	1874	1	1	4154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3xKYfuAR91M3GSHZoCYz9MSexa5L4zzxys17Fhr64JjtJZhLF
35452	payment	1397	1397	1678	1	1	13713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3yWP6RHw8EdqC1kBCNLHLvqbFhSZ35oiYp5wqqwYKcaHnzzt
35453	payment	2134	2134	1874	1	1	4155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2NSVarzAjYtfLggPWAGhBxNU7ghueoW1qZnAD2itsUAkCCPz
35454	payment	2132	2132	1874	1	1	1191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgWC2FnourW1wKL3aFqyAMwNh5hkwxsaM9m6y8JxtvrBgrLYJ
35251	payment	1397	1397	1678	1	1	13649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxPQL4idxkN7hyq1RaMkT7ReeoYVXkqtnPyjQ4WbyHiMmX2WG
35252	payment	2134	2134	1874	1	1	4102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSB8EigW4dkm1fyCSwGr8XwuoowBsQCvgydBgAhSHCWsuPhiX
35253	payment	1569	1569	485	1	1	3	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXMH6qUaz3TDNqQfZsMKBRFdXZZTc7JixkBEYnuzaDhCMBDzX
35254	payment	2133	2133	1874	1	1	4055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TJRXZQthKLwUoUKzprt4do2qQyzcmf7yci1LNeqysNJgRSt5
35268	payment	1397	1397	1678	1	1	13654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcL7pxxLP71ejXikH4hjMwyfdrScK9Cn1cqFtBYsFV5TYonciA
35269	payment	2134	2134	1874	1	1	4107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4LdTmnytQaFtV13z3djRWUQop3FQwRy7MdwtadS64qLbAKA6
35279	payment	1397	1397	1678	1	1	13658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxJYWDRWFYD7JTv6cBwtSWF89UvY8k51TNvGhdW8wN8Fnst6k
35280	payment	1397	1397	1678	1	1	13659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjEP89w8SZoaevp4gGxJsyZ5hJRGrkTbZH9k1GxzhVd25DmqY
35281	payment	1397	1397	1678	1	1	13660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWiSN1y4Fnie39qgdUxyWCAXKWXo4ht5U2mKbCZ5qZuHVKnCh
35282	payment	2133	2133	1874	1	1	4063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnTxoVjkF6R8jRmkMBPNwxxdHQkAjDbZYLd7mEY9p3EF3dWZc
35283	payment	2133	2133	1874	1	1	4064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y3FnJZ2Q42CKtCdPoC2GAqfYMkR7F63CEJeDneBqatrdCxtg
35284	payment	2132	2132	1874	1	1	1175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGchjDeb19rH5hfsewdVxJiLG8FwU8WDvKMSkbH9SfXG9r8orc
35285	payment	2134	2134	1874	1	1	4110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzEqMpnaf1uyryHaxeWQCtoo23PeVTN1myXUMbTducMzgBtye
35286	payment	2133	2133	1874	1	1	4065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCbuYznrkqDkTjtCLKWRHANmLKSh4RZzaT4xoQ6xrrksWWBGZ
35294	payment	1397	1397	1678	1	1	13664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKiQRGaUM5gcQG15B1xv3Em39zrjVcR17uecrFwJQPE26uSdW
35295	payment	2132	2132	1874	1	1	1176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftaaMnhcGzEADQEY67Qj2LRsfY3eP9aWVzGsuD8Cw7E8FEUPW
35296	payment	2133	2133	1874	1	1	4069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswGruewEQwBzL3xy1wNq4Hs67kaaSgGp1EeiHTgu4zrciVpFz
35302	payment	1397	1397	1678	1	1	13667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrPCqjtV2dQXENuCuoBCmWfJAwUz67NhGBECmUThdqZqvKpJY
35303	payment	2132	2132	1874	1	1	1177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmUchytUmBGta2DRQfoESrkT5eQoRembLKsYt5eTZYCj3izAx
35304	payment	2133	2133	1874	1	1	4072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Gv5YvYDASPyX9aXkNCBdwyxVGfUJbrUkXrNmDmcRe6Sg7jtC
35312	payment	1397	1397	1678	1	1	13671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbP6BFLs6zba71aWjhsMKrh7CCqnxURbWFNFR6GahCoX7tfqzp
35313	payment	2133	2133	1874	1	1	4076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjNfZoHfUHHcHSX3cEY9Nq9enR7Sy2hjVijPrdbg5Juoq2Z4Z
35314	payment	2134	2134	1874	1	1	4112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsThTZAKt6pbffWi6y4rsihMpek73ZmttpBV79u2Dmkr5fB7Vk
35315	payment	2132	2132	1874	1	1	1178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3rhrBHJJEjNrKDED4hdyUdcNLCYiX5AN1obiTfLBzSdTxAL6
35362	payment	1397	1397	1678	1	1	13686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDCys8MQKsdzgnysHaoEVNjLhtLSvk1Li6WZAy3MRjw4XjgnR
35363	payment	1397	1397	1678	1	1	13687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSjXmQexiJYnaW6mf1jX7mBcYvxwcvzh1c64oV3dKk32Ca6fd
35364	payment	1397	1397	1678	1	1	13688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNtWGSCAEKQVgj5CjSeqpQ7Eh1XGoNjj3Bb6FCBYimS2JYc6g
35365	payment	1397	1397	1678	1	1	13689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjuBW8jgj1SpT3BrdvsyL4z28vGaRe6Ub6oY8NSS5F9MyrjLw
35366	payment	2134	2134	1874	1	1	4127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KBCs2BS95x3gTX62dwVYikUxuRNqP8ZAsnyUHHrgXMcGqNEV
35367	payment	2132	2132	1874	1	1	1183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUicZsiX4xVvg5z8Qr777fvpKpyopWr1F9SoPzYfbstJsdLNX
35368	payment	2134	2134	1874	1	1	4128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqu9F4QYsGCu5uwkH3hrBfoZHsNZGeGiu5BpBk7wxUNFSMc5P
35369	payment	2134	2134	1874	1	1	4129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5E2apzCsK4RPZrUZLxCTypf7apq2TfMJtWYfniWWkUmec1fwy
35370	payment	2134	2134	1874	1	1	4130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR4pFmmpSEA1wrcJJkth16p8aDxrMbmPs2cioTP3NCBhto5Qj2
35371	payment	2133	2133	1874	1	1	4091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ucy1CNVqmQKRCvFWyW63JvSQUKep3x1cYUwFeyvSGu8KP2XS
35372	payment	2133	2133	1874	1	1	4092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJCVxUSGMwyK5W8M26CBxRWPDQa4pzkpi8Jm5VVqpY4gEQutFm
35373	payment	2133	2133	1874	1	1	4093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYZVb8tGCZyVCscafMrAQLXQtjr4i6Aj97MVvsJ2VGGnwdpkk
35374	payment	2133	2133	1874	1	1	4094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQqDzGW3QjK3VBAjr6bU1f4RNBszAYUAtFq6cDeLsYUcGV1dL
35380	payment	2132	2132	1874	1	1	1184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQKZFT3fPWFNCEALJtXEDquLQatnJDBhf7KbuZnBYL3GBkDTF
35276	payment	2133	2133	1874	1	1	4061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8RYrdhws8YEzDyofyp3cEcoEywEU3rgdvDzrA9PWfE4yBAKN
35305	payment	1397	1397	1678	1	1	13668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HCRJs9pBBADstw38NN7yMwUxdud1HhVASWLcTBQV1haHPwTJ
35306	payment	1397	1397	1678	1	1	13669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjP1Srado6qEp5MYRwxWuLh5Wf2tXmsiB5J3pEbLTi2HksACWa
35307	payment	2133	2133	1874	1	1	4073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirq2cGbjMs2JMEHWQZoGU4Gba3bNvwgAJHZFeHUw89pLxUvZV
35308	payment	2133	2133	1874	1	1	4074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39odxJxHfNcFh74vuabTCE5chopv4iEsshEmqP5XszNRFKY5b
35309	payment	1397	1397	1678	1	1	13670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFLVyALwAVhHJW9T22r5WVJcCQsWFkEp78fcsvD2GhZ2ipVfE
35310	payment	2133	2133	1874	1	1	4075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15edjYcq5hccLs5ZDE2iN33tzMkYkvQ6FARQeaSukBbXhTcDe
35311	payment	2134	2134	1874	1	1	4111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKhNH4mjqtgTvzyQCFU6vtLckfLnrmek7MS1ZKsBRQviGeywKM
35336	payment	1397	1397	1678	1	1	13678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjFTdWEHAWc66sf6JyHckLQBdrdtS1FruvwH2dxUdGBg6FrQLK
35337	payment	2134	2134	1874	1	1	4119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmmNYaRPw3WyPekTXJPxZ14ZcM1MLdMxuhdS1pZHdZdCxymsD
35338	payment	2133	2133	1874	1	1	4083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJEtPTAZiBBsLoEStoWJavtJtVsRYhu1Jo992UwjT7caMRasrb
35345	payment	1397	1397	1678	1	1	13681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGikWKTdVk2ar3kFM3wGSQvxt1sdto2w9sJcz1SMEVTHKvhMc
35346	payment	2132	2132	1874	1	1	1181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbdTWKgWpFxgmN1opQpp9Pyf7pnsH6yZszFYRszMLtVuk9E1X
35347	payment	2133	2133	1874	1	1	4086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dTmhmmomLREAJaNjfV1kFNG69JPFyBQny22RHJqye4zyJLKh
35348	payment	2134	2134	1874	1	1	4122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPLPJgx1AfNc41aZP2r6XnNosRkBaLJ5KYktZD7acxcqGjoN9
35352	payment	1397	1397	1678	1	1	13683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoAeJLvX5zMPXhsAUVCEfgFJ5aZVQ4K538SuHMZzVb8wojxjH
35353	payment	1397	1397	1678	1	1	13684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJsvMujVUNx9EyX9QNTye2JMSbGHe8hkkqtqVG3sSN4HDmzBx
35354	payment	2132	2132	1874	1	1	1182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8GvFgN2T3UmNnxYeLrVk4497t19eqKenSbKq7ZenXz89ed2Y
35355	payment	2133	2133	1874	1	1	4088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxvSwP94qAYAu5CTx8B4mh3AREQrSSH9rqizSQC8N35JZp9S1
35356	payment	2133	2133	1874	1	1	4089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGyn71Rf7Fih3phow6bJNznhHrew1wePbDWCFfyX2YMuQVSfJ8
35357	payment	2134	2134	1874	1	1	4124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa146KZf63i12XDvTS9uP5xkTh3rRhg2PE5wbEWAW9d4r8CNJ6n
35358	payment	2134	2134	1874	1	1	4125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUq4Ndr6wz8YML4qraLexbScicJdzKbu24NvnQc1JWKgXFnYT
35378	payment	1397	1397	1678	1	1	13691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDf94GTBmnnpUWXHgRv9oQc6FAx5LVfeADWKXtTCEyEPqEYABK
35379	payment	2134	2134	1874	1	1	4132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxYTtAy1TXTpnQjAdjjeCjS6EpBdBe4Go1dtfuobmBj3NkVMH
35387	payment	1397	1397	1678	1	1	13694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1vADosZgJSVauLgvU1BPMYVzi3EZWLSiPzUYm1V4eJBsJY9i9
35388	payment	1397	1397	1678	1	1	13695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6AMtAAC2BdZDSd6Mek5AUywmxDvoAb3TXykgmiRrSvxieVGg
35389	payment	1397	1397	1678	1	1	13696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn38pZfEbkUi93S6eVpG7Afwpk58yhZyvHCvBKvGsxySNKZVft
35390	payment	2133	2133	1874	1	1	4098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkY44FgozDD4v72otxojHUEDEHFtE2s3NivnTANpeWG8vaAwc
35391	payment	2133	2133	1874	1	1	4099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaL8JviPNwXyUX5HfzSKC4RcURabnKo7bH2gnCMwpa5gfFx61X
35392	payment	2132	2132	1874	1	1	1185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy2z6miG1Co3m1HqLu7w6V9ANZTdJy5jq2e957Mdh8SaLa96cy
35393	payment	2133	2133	1874	1	1	4100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4iyhBfBCirVvPXafL32jBJLE2f85zQvrbaAnAYsx52uU2MTaB
35394	payment	2134	2134	1874	1	1	4135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGEUv4TjvDEPoo3tcuAbZTnxaFvM3JaRWgGd3sWLa5YrK9yQe
35395	payment	2134	2134	1874	1	1	4136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcf7EMU5N6EX1u2yDRnbtqpu4jFFPKbAu4KHohMB4A7iG8DtLu
35396	payment	2134	2134	1874	1	1	4137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxG94ePHPAVgX1dtXD2kJ98JmGmEpicTcHQDu4VQ5HMaVyKJHs
35417	payment	1397	1397	1678	1	1	13703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvUqXA3Jgg45Ge5CWSLDn2cU9okmrzAMMxemPY2MjqBZ7uB1q
35418	payment	2133	2133	1874	1	1	4107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmHwMdDRWeHpDr2Ji7sKXXoKTukNd8FqY9Ck1oXzoptRFe5cm
35419	payment	2134	2134	1874	1	1	4144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEXKEGDEfk7hjcc9ZS3nspduAXUdqHQwwzEpbD3JRqPYEXPKT
35420	payment	1397	1397	1678	1	1	13704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvT4hm91oxmWVt1y8PULHD3EZJrW8YAVxJ6uqamsEmZDEsvduM
35329	payment	2132	2132	1874	1	1	1180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkA2j9KuMP5LEKG6EKCqkJvRGXHXWpQgQo5znNsZbKArzGypy
35330	payment	2133	2133	1874	1	1	4079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuY8jz5TzMn38fcs9xd1AcdDTwjyRiXytDjhPDyqv63MUARpL
35331	payment	2133	2133	1874	1	1	4080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJa3kgXH9EaRTA4PhML3e77RavA2aNtqa35jzKFA6y8PR1EuTf
35332	payment	2133	2133	1874	1	1	4081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqMejzjqbMztYqDb89tJK6rSRTV95hWPWDJ7GgbqS7xQHJDxt
35333	payment	2133	2133	1874	1	1	4082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFDAbjWhFksDF1zHT6K2GyBfMoSQxsBSm9tgw2ueipdczt7XN
35334	payment	2134	2134	1874	1	1	4117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNbMezAthJ8aJQuNFfPnxV2i4T4rA53usSHXxYBeYvfSsTQPd
35335	payment	2134	2134	1874	1	1	4118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzrGEyApzCaGsPBycVyXAvkAe3cVnnYy11TaruaPyxM3miLDY
35349	payment	1397	1397	1678	1	1	13682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aTVcvSt86ULtjMsurMJ6Vfs4bomxbKD1ryBNDLJH9YQgxbQ7
35350	payment	2134	2134	1874	1	1	4123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8ga5vr1jWkVU3tVdWKFPWEAaoUuJM1S1rnDTzXsNqKTVXS7K
35351	payment	2133	2133	1874	1	1	4087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNCcyzJy33yr6LQJkmaTQLiG4H6DU5zvK8BQLkwogskzwquen
35359	payment	1397	1397	1678	1	1	13685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6EC74oGXmrDh761KaqbcSXha1BuWMX7cwP15pSc5v1gMZiKT
35360	payment	2133	2133	1874	1	1	4090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KvcNKrSstgPW5DQuKx2s9qZAq2XMMQLVwN3f28cXM1vfno3V
35361	payment	2134	2134	1874	1	1	4126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTL5D9LP4MAJrmAbTv8dEGCikkh9AudYsSfgt3qxKeRzs83Moq
35376	payment	2134	2134	1874	1	1	4131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZADHqg6JpaRykYktP5ugV64WEd3KiNdZb4dM7T3pn2xG2YMuex
35377	payment	2133	2133	1874	1	1	4095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZJeQwHPQLEhy3M3856Sd5tbt3wKg9rsg8Rrsa35CH75czeqs
35397	payment	1397	1397	1678	1	1	13697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgoUnhah6TdhxsmA79tMTq1s9nJxA7NqGysmzhjDuX1TzLAes8
35398	payment	1397	1397	1678	1	1	13698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEM8WRNkcqoRiyWn5rPyd1Wyacbosr223yaCBtWwqFFjyRG7yi
35399	payment	1397	1397	1678	1	1	13699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNKhn1FkHeTqxf2QyZW4me9HhXyBarPeBhqRKwn8siSuJBtEJ
35400	payment	2134	2134	1874	1	1	4138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbyqQ17W1qtSfMW2fxV4WdYw4SWLWGoZ4KcbxoQevrXc6iRY4
35401	payment	2134	2134	1874	1	1	4139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhFvvV1SSyoQFiTQ6vbrLmU7E6Fi6teFCB6HDskwcy5Qrckih3
35402	payment	2134	2134	1874	1	1	4140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPPDn113aVwqwvReovisWntHNzJ2ABb7bkby6m29H5kb5ohv4T
35403	payment	2133	2133	1874	1	1	4101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8579JBAZJd2DjWHHDYTuTdmRw8DaU2Lv5j41kpuNLUzK22AUi
35404	payment	2133	2133	1874	1	1	4102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTVEVk2yDBDu3dgNmrHTdMzzXeS77G5hK9Kqp8rgZx2pmHjK3
35405	payment	2133	2133	1874	1	1	4103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgagqFUygpDERgWXsvYFFtHbZCSkt3QrneB62BXqmhRymdC9xo
35406	payment	2132	2132	1874	1	1	1186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLXGE7bCxis5wKxii9Aa75vP1cut82DxuaBSHydSjLmQC1REU4
35427	payment	1397	1397	1678	1	1	13706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbs23crtM5kEYjR5ArsgoPhJVw8fZUm67jWVHaq2WPm68ot688
35428	payment	1397	1397	1678	1	1	13707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx1tA4X6KhjdsGXYWz5ceAFtBM17SakDxwVuJjaAtr6jiz9LRi
35429	payment	2134	2134	1874	1	1	4147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9gp5E3agGF3mnNzuCAczZtPNAGhZgcWtArMw1kZiNigS5h6f
35430	payment	2134	2134	1874	1	1	4148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNCo8wQaQGYiGCHXii8Ha1mDtMfuPpQLaAGhc7spaq1P5aXwD
35431	payment	2133	2133	1874	1	1	4110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiu2dgShyUHYfGJJ9dR8YWzXdi9UDcmHV5LV8SeZpPTnPjyFNs
35432	payment	2133	2133	1874	1	1	4111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN84moSNpj4qV54i2Nbv7FuE5fnDy3WcaaeqhtxpMF7ej7xEs3
35433	payment	2132	2132	1874	1	1	1189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrkXBFQJC22LDySZgQVudiFJ2oRYUdt9XtBvUHFTW3pyQgiaC
35434	payment	1397	1397	1678	1	1	13708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjYJCkFSjoN1S1cSRt8ub3trQDdnZyrbDALAwH5AXEwFSDpQ4
35435	payment	2133	2133	1874	1	1	4112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYac4EdMuLXRej5LMRBY4rAUNhDNCujJY3sRokcpiH87Q7LpPUx
35436	payment	2134	2134	1874	1	1	4149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsACUhiZkqAKp373tyUfvf2znB3BHPxwJRfeMDXMJzoMrkNcHw
35439	payment	1397	1397	1678	1	1	13709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9B62omEkuNMqQp7ab4p2paLcfyxoc7pcbQaeVvzg6mvwKo9K
35440	payment	1397	1397	1678	1	1	13710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr3W7ExtWRHg6NLRFNgWsnyhVjcHtixSBt6eEmQsYMrHY8jt61
35441	payment	2133	2133	1874	1	1	4114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHiZzcib3i2cPNWRpY6ufrAHFzn9FrAVainzTwwrpDYQjFKS3H
35407	payment	1397	1397	1678	1	1	13700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrYZtBTfUNivcevoyCGZWdpKCLQ5sH23cTnztUzkiKxm3NxMF
35408	payment	1397	1397	1678	1	1	13701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs62sJ31ti5E74wwNoGXdfHs8ydqUBfYEYuLhXJDxRXDHwLZ3V
35409	payment	2134	2134	1874	1	1	4141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTP6786JY2HR6ghkMUiexiFpw8civecmHDiD4MoGjSe1Jk8Wvn
35410	payment	2133	2133	1874	1	1	4104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkNdHUEh9MZ3GHAafmP5XSR24iUuF1VbeDrmYbP11TUMgw15M
35411	payment	2133	2133	1874	1	1	4105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe1EB5b4i2C745H2srLEq3ExbCzXmi9z6PksqKTqXAZ3RurDPW
35412	payment	2134	2134	1874	1	1	4142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6G6fzFpnRC8adFDHP7Q5jT5uGN8hw5MShTTAWD3nUxnPBLPJV
35413	payment	2132	2132	1874	1	1	1187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XjebPftdeMZfLCSX2nVRvWbeCJrhoYwqjNicgPSUef3pPm8G
35414	payment	1397	1397	1678	1	1	13702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzjYLhdQBt1jGKrpbeDTw2zoJ113FzWPXww1wwbtv4gpYz4ba
35415	payment	2133	2133	1874	1	1	4106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyjkLeb1wBV5N2QyX1W8VWYU81m5LiWLEf8Cfcm8fSrKRbzmd
35416	payment	2134	2134	1874	1	1	4143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVkWPXdkfauedpkugkmscuXpnBBitbyWUyQXYQUoSnL7hxL1A
35437	payment	2133	2133	1874	1	1	4113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVqc3kMtshCjWqCKt8voyhCMwmc5YQQyBmkZrHbH9cXoTngxx
35438	payment	2134	2134	1874	1	1	4150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7stykdiQuE2vHAHtoUwdFHVRuLDihwVM7eQKPNEdY9B42v59
35462	payment	1397	1397	1678	1	1	13716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1gEB5kiyMYrJrZ8SKJfwDW7qdmA85H6hX24NJJx2mvtPhcyW
35463	payment	2134	2134	1874	1	1	4158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCeZkuXYA4D2FfX6BJbiX7VF84YWyrjkw9zYPczRPH3A9KBFJ
35464	payment	2132	2132	1874	1	1	1192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyo7T9hVbhEqktqXwwj8vCPzzvqHpBtvZkpo73DFVNNWkBTXX
35465	payment	2133	2133	1874	1	1	4121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiE7NCcCR4k8qQQY2qaFmYZb2jZEmTSnjz6FDv5tErnQr7qUp
35489	payment	1397	1397	1678	1	1	13724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvt2s1mNdxpB1zs7tALBrHQ36kWuEEMPMr2kfZoSQAGhQm7XzG
35490	payment	2133	2133	1874	1	1	4129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdt7wXLQVvQaE5zEJdooL7mvDCXKkEeiZxmKwX9f41xVqvsoiZ
35491	payment	2134	2134	1874	1	1	4166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG9EVaYiLz5a5qtFpRptspGXvhU8sTB4QbscCcmHos6nh53VX
35514	payment	2133	2133	1874	1	1	4136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRyEEtdpFzByJn5M1cj6cWHsmVd2XJYsygsvxGkUPdAr5Vco4
35532	payment	1397	1397	1678	1	1	13737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9Z9YkADDLV3n8NLsL1vtDELeZ887bX2mjcHTB8JM1zjBtgS5
35533	payment	2134	2134	1874	1	1	4179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXCAkqJK7Vvh6eP7djWGvDMPUXZc7EF5zpWNG4xCr4eTtJkot
35534	payment	2133	2133	1874	1	1	4142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwMh41sNBvzF6pRoR2XynYHDUxX6U9qEMd3ccWzrnoyQojqczd
35545	payment	1397	1397	1678	1	1	13741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEjrsACvKJsioCn5YL841Su9ykaDnFxBqBdWKvszstoHVipNkB
35546	payment	2133	2133	1874	1	1	4146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVedK8tR8eHmk8xmYKrqeYE5bZTMAisgmgZY5u7eEzYE9cqbS
35547	payment	2134	2134	1874	1	1	4183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hF2z8RY1pUWiqLHBZRU3hnhq9bhBY4PAdpVNygUASDdQCtoL
35554	payment	1397	1397	1678	1	1	13744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSez6h8HXzfb8h4ttt3bPMzCb5aZs588SbMyGmwSVYeqJABxgn
35555	payment	2133	2133	1874	1	1	4149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZhDs6HXruHHqgDgYdrjKK9i6ZVpEuRbt5yQ5yPLwLrPHXC2Y
35556	payment	2134	2134	1874	1	1	4185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwatjDewcoYapsXYeMX3th6R68GypqhR14tMyJ334Hx59pwWU
35558	payment	1397	1397	1678	1	1	13745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2BJhGJ7FK6capvXoVVETF9TsqccHuXq7J85btq8VeRDQjo1z
35559	payment	2133	2133	1874	1	1	4150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ957r1V8MJUNehfuPoztwcpAz1BCUtFmLpC1Sh29Ad45tmiqXR
35567	payment	1397	1397	1678	1	1	13748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPJaeNnx8PiAAi1L49o7aNQSBgMy8XV5rhnVuu7sgbBTrhtE5
35568	payment	2133	2133	1874	1	1	4153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqUFWb8JHwN2Rosuj8vX9SHgFXCp1LPirFZ1m6DHrMLqzx1YP
35569	payment	2134	2134	1874	1	1	4189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCE3sEVFHXoVPyH6e3perA2iU5GXN3ajTeL6wLi8vB1sYddUPL
35570	payment	1397	1397	1678	1	1	13749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ491v67Hpfh1ovz9xzysKVc7qfWtQrCf1uTnbetYD1aBq96RB
35571	payment	2134	2134	1874	1	1	4190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYZCj7GR44sbYXggKC5tawtmsqPTnVYnUKaoLR5FYRcWpcuBL
35572	payment	2133	2133	1874	1	1	4154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjudfcwVyuWd3jumfuUD3wJq6Tu9joHUnTPmckMj3jtf9D2AK
35583	payment	1397	1397	1678	1	1	13753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshBsVLg4twgeQqXZA7xR4igFPZsdRPgTzZBjc1CisGERU2a1N
35421	payment	2133	2133	1874	1	1	4108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZffPiZD83FZuiys98rLAzz6tFt5agQz3fuY5KYHiD21TKabnx
35422	payment	2132	2132	1874	1	1	1188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwzKjUNctY5k6jajaSTSdDHtB61k434ejMWeoXwRznQimFdgcj
35423	payment	2134	2134	1874	1	1	4145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAxR33k2rYUZXvvx9sk5JSogPDTpYJ1CckT6eiuY55m1Z6dvb
35456	payment	1397	1397	1678	1	1	13714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAhMW1dTR3JGTNMv89jVmDRiwUQSgNL5LJFFsEfhqfG1wK1Jk
35457	payment	1397	1397	1678	1	1	13715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2k7DWtHq9WqT6Bve2ZwGNRJi97G7aoob9ghD8ekv7L6qkAaU7
35458	payment	2134	2134	1874	1	1	4156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgp6DuTW4KPnNq1V8ZPgNUJ5QpKRwk2cgd3XdwS7PNrcfVjfeN
35459	payment	2134	2134	1874	1	1	4157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPHVFZd5YkjPm72nysv3anHFbkAmTDAEUBZXj3HtGgssXrY1n
35460	payment	2133	2133	1874	1	1	4119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYivmoZFyH26A8fH1AyNkCh34Ljw5H1aXrMTWyBQ5U1sYVy8xFn
35461	payment	2133	2133	1874	1	1	4120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbz8QgWQNETYqW2anf8gAsCD7sSjUkyAJ8BSB1N23gybAP9w4c
35472	payment	1397	1397	1678	1	1	13719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppFHiSdJ6WgZbz1oTepcyTSg8w2sCRmWTmzUUHd3rKsbVAAHC
35473	payment	2133	2133	1874	1	1	4124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWh4YuCo763ZQdtHCirgF4VajD6UpQF8YVic2yWwy5tDjN6ZuM
35474	payment	2134	2134	1874	1	1	4161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcW4RT7ncR4SjbjLCQ4grSTqDSDez1xpw1UC2bFVGontmwXbZ2
35484	payment	1397	1397	1678	1	1	13723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvzCGiKsxwVcZRmS5XyFiLnZ3FrLxceXcv2RDD5c63X6dcuHm
35485	payment	2133	2133	1874	1	1	4128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcMw1t8yDsPKxKvL3GfyGPkyMLGqjLNw7GnTiHiWRuEJF4k9S
35486	payment	2132	2132	1874	1	1	1194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomNQEixzN9ui8JcaQ7JJSPmYCRiYNQhyhgdWmnFFkujpYpuBG
35487	payment	2134	2134	1874	1	1	4164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaamesMUm7ctbpVm4kr5FaiZakBSwSY8vDDkuFV3am323bsyf
35488	payment	2134	2134	1874	1	1	4165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6z2zrm8iV31nJg6ZCDQXQD1yYvTP9j2JCAYTSWykd1txaU7M2
35495	payment	1397	1397	1678	1	1	13726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZxUi2PdpnJoNz3Gfx3Txhk6RbMoJ7fiiQ4VzL9Rmt7xpNs6o
35496	payment	2133	2133	1874	1	1	4131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4tf75QZrRDrwmhwpSg9xjPQXERzGDKseMit97955q9oYHyAX
35497	payment	2134	2134	1874	1	1	4168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwBrGzCgDq3dzjv7KPkcpiYhYDphRvBoRGcnLSoGLoNxAhscMV
35498	payment	2132	2132	1874	1	1	1195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jFDWDhYBP8wdrNGDuMRVEFmxyKLcLKCP27yXR2ju8orEjioF
35512	payment	1397	1397	1678	1	1	13731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ39Ne39WLo7bx1mpjEExjnZ37URXc7qEkjZMDaz94xrFvFgDP
35513	payment	2134	2134	1874	1	1	4173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFnbUccwHnjbRnLoiGnRvp5eqx5R2GtUm4xSvszEFeo9f9FSj
35548	payment	1397	1397	1678	1	1	13742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkeWMGaCMLkx9HJit1mUuZXbRNAQEAmconWA9Z6NoLpPdQo2f
35549	payment	1397	1397	1678	1	1	13743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5cthGFmbo1oJzTBJaMkm9uLo9XseFCBkidndMKjEbuqyVHYA
35550	payment	2132	2132	1874	1	1	1200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBbtqJjizGf3kSsZiaiqwZTtPrGpit9o3rQDQZEPQVm3x7HiX
35551	payment	2133	2133	1874	1	1	4147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZug2xEXdFS6wXhahabWutKQVJ9hzQoEnu9aJQ3RWPNkVms32mU
35552	payment	2133	2133	1874	1	1	4148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4q2aGHB9BzBprtckVWkDJvED3jrBt8SjaqbBHRoZKCHFxmuS3
35553	payment	2134	2134	1874	1	1	4184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AtoXESWyNgqiXvT8s4x5exAa7rRUFH1zkV9C5YLac8VebQwk
35564	payment	1397	1397	1678	1	1	13747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuTAsYxRGkTHuT1FPtYjcVyT8nXCwqerUw2FsM2tuS9dGecpQY
35565	payment	2134	2134	1874	1	1	4188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhHL2Ts9rzCARoAnqz3kmyzDp3Q9c5FAm5L7uoA5MeHMkghmF
35566	payment	2133	2133	1874	1	1	4152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQoU2G4RxTw3Pho7ZzPDLQEPVFp2SZprLmwSnt3JCca9rZnSE
35577	payment	1397	1397	1678	1	1	13751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61E96Sy79UifZaZbLUQq3DpjZdCAS2xZAD35RdmestFBstcQS
35578	payment	2134	2134	1874	1	1	4192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrFHy15AHLUENEXBvR9bXMa2Vko5rKhx75bPvkeJcMoAuFEvM
35579	payment	2133	2133	1874	1	1	4156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8DZN7pVV7Ge76mQR5RZLpwLfdN3rkJQj4EwtWVph7rUuFG6uW
35621	payment	1397	1397	1678	1	1	13764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11gyAWrTSHrhvW2hy3fazrcPqgGFkTgKzb6wxtNey947RjL5Y
35622	payment	2134	2134	1874	1	1	4205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZog4JSKeM9VSAyHUWpgHn4nCdSRF7BzeY1cysCdKi2wCzxnL2d
35634	payment	2134	2134	1874	1	1	4207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbr2UEh57gs67z1URVBNB2FAc8WhcUNWUFVGpxfJEommjPiYWs
35442	payment	2134	2134	1874	1	1	4151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWtnBmdNpC7Eso8KudcihXnp4fvUfQu6myb9jF7aYkuk31uar
35443	payment	2132	2132	1874	1	1	1190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXUgDWhjdaLtKd8xLKeDryNSLbcUekTmBKmB5ngX5j1WTFxkib
35444	payment	2134	2134	1874	1	1	4152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu2jLK3jFBaByvHdu6RnesQYaBivC8UcUq8S9v7UbfnBJw6Q7H
35445	payment	2133	2133	1874	1	1	4115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6w6pusrxgevpFeFKeGiiGmTVWXW71xBEAjjb7gEcgA1wYW3u
35446	payment	1397	1397	1678	1	1	13711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuK836MAd9afv7Ho79Xmz7yAp5HAXgcmj9JGjCbiPjaWd9MJeH
35447	payment	2134	2134	1874	1	1	4153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxdqsXSyLgdixBG39inyTtWrrnocPB3oBTWc2sP3tpRAcFS6g
35448	payment	2133	2133	1874	1	1	4116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTx7413YD9FcbaisZBXyRGW7gfES81tJv8znWLhipWY5zdyPG
35466	payment	1397	1397	1678	1	1	13717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ePiB1y6wYjxS3VkcGZPCAP7fEQhTQuZQtu7p5Y4Rt81edbhu
35467	payment	1397	1397	1678	1	1	13718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrkZbYUHiNpDRKj6PvfKARPeLCZ59GmpS3LYwqpDKRJUg7MZq
35468	payment	2133	2133	1874	1	1	4122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6W6V9azeTbJmy9ihqhib3K96adxTSzmDFP4bmt4CYo8nMjXzJ
35469	payment	2133	2133	1874	1	1	4123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3dg1YtC4wDh49uC5248RCPS2mknhKFYiEk9irjCa4gtZSqFRz
35470	payment	2134	2134	1874	1	1	4159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgnUAcCk88bEkpuD783Ywk7xezCdCxBXinxTbyFGtvm13vpUp
35471	payment	2134	2134	1874	1	1	4160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYHnCkwNRospBVNswG237CMt5baUvWXrkdX3TUZWNacxB9esn
35482	payment	1397	1397	1678	1	1	13722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe58pTa7Mv1G7ForzTQpY8SdRF5BHPf2CsaecthyrusVpeUkHZ
35483	payment	2133	2133	1874	1	1	4127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbi5bBPDVsTN9psXpXMnSbCwxXt54eLjEAYHvRuEqGmS2o1BiP
35499	payment	1397	1397	1678	1	1	13727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR5jsUwYFJYyg89ATKGz7QANwvpied5muFPTRVfC19xP79QG1E
35500	payment	2134	2134	1874	1	1	4169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4iiadGHUBr3josEWpMfvn6xBXmaQVhb91fS2SoKDjScTXc6s
35501	payment	2133	2133	1874	1	1	4132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSbGrDixndfdmUkWNTwgFXFf7AVGHRQKPBLoyPpUdonfK5PXx
35502	payment	1397	1397	1678	1	1	13728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8Q4tJLDdJPriWSXNgEoXqeH5LsvrhQGGoeDH3jTYXTs5MZ8Y
35503	payment	1397	1397	1678	1	1	13729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ3sBFNkjaLGhnE9d74fdpWQ4kENeZn5BCqF4pByEpcYXhrh96
35504	payment	1397	1397	1678	1	1	13730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xvGZEDwL1Jefm4RWoVzpLGwvHoAvUGppfsvQSMyzBdcgGbKc
35505	payment	2134	2134	1874	1	1	4170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq9rJnQ3YTRXrUUyGRnz2GVmQPoHXjPBCFgG2Gs94qkUxi6UQB
35506	payment	2132	2132	1874	1	1	1196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEx8mX4zQQThUSmgzk9v1Rnjw4iTFWreUEFbPMmBeHiFpG76Li
35507	payment	2134	2134	1874	1	1	4171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNDHoacUUjE6D65SVZjLRmrrZu2WQjFovixPaV9C9LCMDvP55
35508	payment	2134	2134	1874	1	1	4172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ37T62UPhwi1QijUx6kau6gxTx9Bh3wH4XosdHu3TvaBbMhxr
35509	payment	2133	2133	1874	1	1	4133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kL1fHWLYnqPc5rdoE3p6fmJquAay3oDb9AMYVr8HogKp91FT
35510	payment	2133	2133	1874	1	1	4134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGN5rH6eJ6KjUce6kbuo5XCxSSC5FgRSGZxx7D4s1VfTT9XL5u
35511	payment	2133	2133	1874	1	1	4135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqxWMkYhSvvK3n917pYwL1u77gEdQUrp8c6ytMnrRZZRqCYyL
35515	payment	1397	1397	1678	1	1	13732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33csXwf4YYcogSnUPhYQY7nb68BvbfDjqzsiEHbWJJHRW9x9s
35516	payment	1397	1397	1678	1	1	13733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3et9rb4rSzRN2jDiMVqG8mMYpqP5QmAkXHq9DprkX2GJYBgn
35517	payment	1397	1397	1678	1	1	13734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK91QukCg65onXdpxKGBjX6npAfdizxSchV95iefndgYP7utFH
35518	payment	1397	1397	1678	1	1	13735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRp5xBomYTsZWPVNXuu2ruFqmQCgbXmMhy8221fs7e6DZTqx1
35519	payment	2134	2134	1874	1	1	4174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvWkcktte2xRSjxUoSozq1MSGDxNoePVHEKUqMwmfq6o9hDyL
35520	payment	2134	2134	1874	1	1	4175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYunoFGfX25vDzBeQKPsp7aN7yyM3ed99CxTi23cbSsoYM8Vy5j
35521	payment	2134	2134	1874	1	1	4176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPZyUnWFnUxRvZN4iHqGYz2x6Yg9R8hCGXExP7yyU9oQkiWsa
35522	payment	2134	2134	1874	1	1	4177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81fN4a9NN4GtT9ckToHDjRsPsvUg8nr8KLDEPS91EHFLDJv2b
35523	payment	2132	2132	1874	1	1	1197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ADVA8KnFsDQGscBqK6WurRV7Ae18pL7Kp8SPpHv6khrckpzW
35524	payment	2133	2133	1874	1	1	4137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8c3B61hMzQEyaQb1qj49mzVFJKCBL6UTnb4czMdSiwEpF5AS
35455	payment	2133	2133	1874	1	1	4118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7riwjWYWDwDFDwZZnBNoHu1antxdKPQ9oCm6pMRLe5wHEdt33
35475	payment	1397	1397	1678	1	1	13720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpg1kwRSyZn6Jvj5DwXABPgqm5jrq7P6Wa2gwNGNotzPJGr5Yd
35476	payment	2134	2134	1874	1	1	4162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhqatmN7SjbwzW6eZvAycZ2jVVLSiPK7cSvdDm9iYz4RXCtFf
35477	payment	2132	2132	1874	1	1	1193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YgyJrefVx95N6YT6aqkCc9x4G5tuG3XKQDxRGrzBf5JyaKjo
35478	payment	2133	2133	1874	1	1	4125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa787wZLMTm9PkuDpv1YUdhRK2QivhnZj2qbrPk264xgrWkKVQP
35479	payment	1397	1397	1678	1	1	13721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUjyhDgsTuUR9y42sSuS5gELy8VA4LBWa6Zz9WJknkj5tjaNc
35480	payment	2134	2134	1874	1	1	4163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBt9w5wNBkRboahzLAtmxa12sFcKfMgsm4vLqzwpdG5PGdRDD
35481	payment	2133	2133	1874	1	1	4126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNQM9JGGfuhBqUnSUEkPaS9jgjMB9L2han4FyXiaoW7x6MqJG
35492	payment	1397	1397	1678	1	1	13725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnqeCWyJrXqTH8JgZgXSrxCc5bbqvKcxc7HLmrve3tsb9r1eo
35493	payment	2134	2134	1874	1	1	4167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSg4i7HnUTcPfWenJQc1AUCGhmnXakgN4KPvtvWK3dBq4URhEr
35494	payment	2133	2133	1874	1	1	4130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnCee5b9TEnr4E7Mnyw7RuNKEhdisMp4t1EioVvX4a3qLmHU7
35528	payment	1397	1397	1678	1	1	13736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfwZQpC1biatM7HJZiduKKPns55anEjnYqwWQiqrxJugWcG6j
35529	payment	2132	2132	1874	1	1	1198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHoSgFyisqKL9aTsnmEXJzqWkKARXCDLtSpyTdRKddFbWHw63
35530	payment	2134	2134	1874	1	1	4178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxr1PHDEnbVWNwaCqp5uLnHgQkb2yKrcDUwvzm8rJxgMHAoYv
35531	payment	2133	2133	1874	1	1	4141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbqikWR1uRM58FYxBAnkmNybGNuVDjaG3fZETRr1EsFvWR9tA
35538	payment	1397	1397	1678	1	1	13739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4duUFxrMb5MV1AGcptDN2764qd9cG62SK4UCvwtSZgc5swLR
35539	payment	1397	1397	1678	1	1	13740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJNnffbzLUFyhM3unA2FHsbk7FM2JkPK8vKW3ZPcURPVqG8Ai
35540	payment	2132	2132	1874	1	1	1199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu44SVCcVygrxQztGr1XKMCF1GKYDjdSWbJ8vgiyBMdK79xFia
35541	payment	2133	2133	1874	1	1	4144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZ7qL6sPX974eecQExgX4KaLMNaKNPwQ5GpJpacCQjJVrYrtw
35542	payment	2133	2133	1874	1	1	4145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMU74zKe9cH13i5dMudFyngQt16cB8GGYJHfsMyHwwj3gkgsCt
35543	payment	2134	2134	1874	1	1	4181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeu3mkeXA1Krm2xMKXmJ6nSYCrChNieRrK26dmroNyz2PbG8eb
35544	payment	2134	2134	1874	1	1	4182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmRywGEuKKvujsCNfUEfvTBTJw6VLRMV6da4Xp4TjjtHuU99V
35557	payment	2134	2134	1874	1	1	4186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifHN9HbEQmYt27KJkm3QJXu9vKY9sotkhwKxTF3pHzWJSLe9C
35580	payment	1397	1397	1678	1	1	13752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpKMFHDK5gTHFDH9mqDfLV7kcr8oT8j7BEW7enirrqGora7QDH
35581	payment	2133	2133	1874	1	1	4157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzw4ZiSs73XkUMigwpXyDxNZMrsHdaXgfuPzDvD9T3un62JvHq
35582	payment	2134	2134	1874	1	1	4193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGSfig9Hgx49itSgNuaC9RnHm1QBqzij1XDJXTN72edV93ALK
35587	payment	1397	1397	1678	1	1	13754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVt7atSxPicA1RFNHP34hVUb75A43HYAhvsZRT6iPYKzdSeCj
35588	payment	1397	1397	1678	1	1	13755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEYoRowa88rc6GsyGrhbvUTjHr5hHdoT32K5sqjoHzfEiQEfRV
35589	payment	1397	1397	1678	1	1	13756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWZeReZ5pJnTGvc8tKBNNirmw2FYPki8vcA3Nm27Unrf1bXGx
35590	payment	2134	2134	1874	1	1	4195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQFCS8jRd4x6GAZ2e5othR98qaDSYkpnyZXCMniDzsiMCSVEN4
35591	payment	2133	2133	1874	1	1	4159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSoyFweVHswf1LZktfUjQSgDReAmQSZ7LSvCckscU6zCz75b2X
35592	payment	2133	2133	1874	1	1	4160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBGRsisHNvoNBf95DiuYku8RJxdjzMuMZpcP3eBNiL5JnSx6X
35593	payment	2132	2132	1874	1	1	1204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnv6XUioBRAr2Gvyz6UxLB4tZiViAfxaLL7PXrE4w8QQ3Uz5r
35594	payment	2133	2133	1874	1	1	4161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziFG425LegS8rpYsUB5AWgiY5TobPNsWPjjgUvPSJGeyZSKVR
35595	payment	2134	2134	1874	1	1	4196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rSJWGLTinSA7VWSyseJdgz58Aqa1hvk3aFyi5FadHYd532ye
35596	payment	2134	2134	1874	1	1	4197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ukwpeWvyFvMbHCfGEucqwRDXyJ4XYFuyVtMjryHQy6MKxmkc
35610	payment	1397	1397	1678	1	1	13761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2CyYtKoX9chf2KpzyEW4PHroYAwzGhfXTNWfaPZQkYCkxue7
35611	payment	2133	2133	1874	1	1	4165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMonk3XdGUC9mfEubQJZSXvt2K32hk3PhkhNYM4pwqC7r8DBg
35525	payment	2133	2133	1874	1	1	4138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3VJjfHB4Q8YxxHzZLXFLECGjoJ3iQLdRySCx8opQrbfqQ8fF
35526	payment	2133	2133	1874	1	1	4139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzxsuj5HUBkMhBiNCZzrmYM6p2JdrJSajWcNXRKrHgDzM7VYg
35527	payment	2133	2133	1874	1	1	4140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDBS32gByTXLQuupiFtLxCSHdXCqwK3cM3xUsS8o5KeFKMdNEw
35535	payment	1397	1397	1678	1	1	13738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4B7MPEYvAAX8uyBA1itdZe9XmRAQPnfdNJrnF8sAwTG9VpaE
35536	payment	2134	2134	1874	1	1	4180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1aMarW8oT1gRHPwb6oTFLiTMNpm6RskHGWMSwgtaW4WFxcEw
35537	payment	2133	2133	1874	1	1	4143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7QEJduDDGqHJpL3V5QbjqYqd3s4MztvPJt2CeAhA2aXLty7e
35560	payment	1397	1397	1678	1	1	13746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYVoGf86SQNczmpxNkycuTNNJSgM5zyUimTRn4zWXsqUHUpa5F
35561	payment	2132	2132	1874	1	1	1201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYfjfQGsQtV7Ec66LXiUmw6mWbUoht3btfzCwT3Cv9ktpdYsj
35562	payment	2133	2133	1874	1	1	4151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3LtLD6gzic8DHApadzLELqTDcQhwtw8uteUBZgFNun8zviHn
35563	payment	2134	2134	1874	1	1	4187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhFiGH7KXreooYdoxoDHAjFLAdrUDToPYGtsnsETTmFBtyETk8
35573	payment	1397	1397	1678	1	1	13750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuM79YSrHQbP4SZZ59F9mVPiSoZK6keCo2Vsi1s2f3KFPrDDAn
35574	payment	2134	2134	1874	1	1	4191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaartFZnNdkwbioJjbT3pTAjc1dDqdi94o6ru3RSYHMNQs7VG2
35575	payment	2132	2132	1874	1	1	1202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh92aYHix3QauMuHHJy5dnXZSRAebjcxaNiENSkh5cNaMK99pQ
35576	payment	2133	2133	1874	1	1	4155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKhfh97mCcZuT1xLfjfoD5SnU1ijFcdABNLsfKGHq9JcysphUy
35601	payment	1397	1397	1678	1	1	13758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqrYjWpYyHrJ26LYRNZmNP4AWfaxVxotdsMaMjhDY7oY98EU2
35602	payment	1397	1397	1678	1	1	13759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDy6oZnYbGVXBYfVzRP2zHymxh6ZTCk8BxoNQhiT6XZxdQftK
35603	payment	2133	2133	1874	1	1	4163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzjuezYWYhKFGUrcHecGDWM8mSnkQBxSxU7j97VdCTJCvpGuW
35604	payment	2134	2134	1874	1	1	4199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGwGX59ydcJTMJxZaSXR7rLvCHRLdMFngX8uJtM1Hkp6UzHzV
35605	payment	2133	2133	1874	1	1	4164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGMDBC2khpZhTnVVo2ZF6HzzQ626zcYkjJeXXraNjeWt5Urs2
35606	payment	2134	2134	1874	1	1	4200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4pN7NmQX225pbD8Kw6AY1yWmsDGAq1YN6EVJFXpqM1Ah15Eu
35620	payment	2133	2133	1874	1	1	4168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNQNC6R59zAV8FmUGRk82eaS9BBD8KoN9yx3AysEmYxcM2StP
35623	payment	1397	1397	1678	1	1	13765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiZ9wziFFuqyz4JFHdp9z4wtZwcGAqGFEXhWmDnoR8KhShBht
35624	payment	2133	2133	1874	1	1	4169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQjYqRKuoxyvnsTwXAx3MLXjvUaTzqyKyafL8siL3YbfBFRM7
35625	payment	2134	2134	1874	1	1	4206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZAH6FaawtfrLwyxJiNudjyrCohD1ewmS5bnN1gvJBJMGHAGs
35626	payment	1593	1593	1346	1	1	4	9818000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvTK7qi6cXu3nKNPrQxA1FBNq1aHTZQMwQVWpDKKx3xYHLAJF
35627	payment	1593	1593	1100	1	1	5	5222000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJeBJ82RK3Lgssh7kSjV1v2H266aC18ncJc3TFnEnXwVESgZM
35687	payment	1397	1397	1678	1	1	13784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjqiLgGzDyqzjZbr1BebN6EjJmAGn5zZRz65ofxv2UAhKkpg3
35688	payment	2134	2134	1874	1	1	4225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohxoXh2fKbgYB1zLgboTDCkNDNya1Qr1xWBpkGmbW5Efwp9Fr
35698	payment	1397	1397	1678	1	1	13789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RWRDjeeCWidUnMhtCzxdHV7xLmiGowARnYLgnFguHUKiUiqf
35699	payment	2134	2134	1874	1	1	4230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRp3bSYVtgHbf8F3QorreaPi8rG5DDfAssAWZ2nwJSGWMipgKX
35708	payment	2134	2134	1874	1	1	4233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjbS3uddhUd9xaepgci3umkb6kM5tEPHwL9YfMNMmuCCiz6MZ
35709	payment	2134	2134	1874	1	1	4234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxynm2JET5st3xo6s87YQQ9WyVRTrhNbqYukwcNLQesTanKGYr
35710	payment	1397	1397	1678	1	1	13794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqaKuMYSBcN45Lnnv4GFeFPgav6kgbY9Z5QNvfpmgDAAo2j7e
35711	payment	2134	2134	1874	1	1	4235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmxvqvJhxRGKrtNDL1brVu5iUbJWwdYmQG7V1EbqtYYteYKM3
35717	payment	1397	1397	1678	1	1	13798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiX2Zn8uPhh61EvKnxNbCGb1rzajsSAVsrcxk7WrLPRTM6ZgHa
35718	payment	1397	1397	1678	1	1	13799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3DadjikyAu7ng1KzFgbmxsk31Bp96nRdWQ8fdjFo1cmdTsn1
35719	payment	1397	1397	1678	1	1	13800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2D2GCrUVeEzu4odMXzQxtRSWKfwVjCErSNz8g2Rns3gMby5h
35720	payment	2132	2132	1874	1	1	1217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKgQBVd5BuuiU3rHCeTS5Y8LyWmZEkmpZL48SHaLymZB36HYR4
35584	payment	2134	2134	1874	1	1	4194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpJSFvkbSYVogskP9Y6Fz6GuKHhf697u4VvxZVsh5945TSKbo
35585	payment	2132	2132	1874	1	1	1203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG4wbgkQmJicj6WGis4LpSgMGNDwz8kVntqATiQH9HY7vz8EdN
35586	payment	2133	2133	1874	1	1	4158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQh5rcpnUFb4VBmiW2mtj1FFksvyq3wwmRmGszD7Btp4ztC7XR
35597	payment	1397	1397	1678	1	1	13757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXDpQsvkW2MJV2JN6cbLijaf7L4me1yXCszfWyexv21AHFEv4
35598	payment	647	647	2113	1	1	2	209325788612	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLNnKdydudQopwbuRYUWmXRUWQoT1pmrv3if4hG99zQ24xVNS
35599	payment	2133	2133	1874	1	1	4162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqrv6a3Y6853TgEp9a7Pg5vKCen949rLUPRJk2h9pQSpsUVp8X
35600	payment	2134	2134	1874	1	1	4198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKo8xvwoSDwmJ2f2msqTsRvA4M9y7GRwhULEujtBuaW7Q5Xpo7
35607	payment	1397	1397	1678	1	1	13760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRPnnYWvVLQYY8xVSzmHqkroa2QS3ToRqgHxG1fqYmzPrjiqA
35608	payment	2134	2134	1874	1	1	4201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5pCZkm7e5cKVZANosMST2VwGSuNXYhT3479P1t2Ga9E5SWR5
35609	payment	2132	2132	1874	1	1	1205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7prBEx2zUPgJ5Zm2LcLWaX3nTxwkqDndMe2hMnjisFT5NVbFz
35613	payment	1397	1397	1678	1	1	13762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ndkenEpq8rvpe9CqD64KJW13bmh1fvgunBvS9AC5EWThpnHy
35614	payment	1397	1397	1678	1	1	13763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaErugwx8UCGnJg4PPdTkwJwjs8dqNKAUbeX2Nm9UQpYyx81hQ
35615	payment	2132	2132	1874	1	1	1206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYMKJMyp48YMznTasRNvuNNp8wizDvPoEcYnim94Yk2yVnsVm
35616	payment	2134	2134	1874	1	1	4203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX59PCGHT5PjXBu9nxi9CuojcnNcZtetNBqe7yo515gE4UHnWe
35617	payment	2133	2133	1874	1	1	4166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Xd66Dj5sFHDRTYw9YLCoptQP1ZGnx7pVBtyNXamXS4EMEP7U
35618	payment	2133	2133	1874	1	1	4167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn8ni9o1XsqwrU26XMbMg5gPNFVm9iFe9F6SeRzGJ1j4twCkVN
35619	payment	2134	2134	1874	1	1	4204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHA8AEN7cYMzBBvecxazZngibzngyCRwu38P7Mtd1uksTKmvkV
35660	payment	1397	1397	1678	1	1	13775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7JxHUmH7CJmeMwfRFDYgC9BfXHcXa4ahAzykfV5MWxRTT2jzm
35661	payment	2134	2134	1874	1	1	4216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKMbWAcsEQGQ7T9tRFbfyq3UTZn5nzAKwzErhtDFPk3tnzFF2
35662	payment	2133	2133	1874	1	1	4179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLCXsJgGNbSmTcKd8uQMDhuynusNXWPL2L3YQUQbZncxS5RdmB
35673	payment	1397	1397	1678	1	1	13779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcioaRbLcWdmxKkGYYKn8UUkR1MseWnQL9mpnmCZoKWgA6guo3
35674	payment	2134	2134	1874	1	1	4220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxkATaWETZvzzWo1PAk1hjFPHEgXmgc2nkwDFAmRrUU6BCb7k
35675	payment	2133	2133	1874	1	1	4183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiNwHRyVEVcaH8Ka87VBTG6pjy2BQJcRHhoQmhFgxC6cDzKJf
35682	payment	1397	1397	1678	1	1	13782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59KA6G5rumu7uk2FW9rxni411fT3aQqPCjFtBPHTtPMWKWavu
35683	payment	1397	1397	1678	1	1	13783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sok3uXbCJxRCLpLzoiskkTSunvkEA5kHGxS5tDiDvCPJSf7Y
35684	payment	2132	2132	1874	1	1	1212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3jzUJLtqHyxftMZ2cvXQ9k7qqACVmcxSaQrGer4HhqpAxeGdT
35685	payment	2134	2134	1874	1	1	4223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64EEHpdd4q7XxTtWT8MMX8EvHTavDKqsKYfz5YxdZM4RpPjCb
35686	payment	2134	2134	1874	1	1	4224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfQfqaXEkDW25D28EFUwgFguU2M9VihZpf8PzhzAUsc1FicYj
35705	payment	1397	1397	1678	1	1	13792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXuVo2QRZqHY2TQm6xtv5mCvwyzrKNB3o3Crah5ra9jR47d86
35706	payment	1397	1397	1678	1	1	13793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4UuQ1J5SpPvSSWbKMbg8myKDVo6MUGbuJ6HgoX1R3nwQJCMD
35707	payment	2132	2132	1874	1	1	1215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE35L47YnTgXVVnBTW1H5Z7Q4K92XQJ4pvSgqyKu9CodFQSkf1
35735	payment	1397	1397	1678	1	1	13805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfd9Y1zgYLbZ8FpkULKPpK8kRigpn8tbrqhf8Ey75vPPxL1KF
35736	payment	2134	2134	1874	1	1	4246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvfMYuMHkGDJV65bRiQVbwGK5v2nXAWXLez1qhn5uERYCPt3yQ
35740	payment	1397	1397	1678	1	1	13807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1Zip83pAz7MgJrUSL5Htt6oKT7R2LLDfmgHRBWKDiFnmUHRr
35741	payment	2134	2134	1874	1	1	4248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAkvxPsiHGozns4Nw2bbzDYAjK5qGRH7WjpyU4yZV9XDoYM4wb
35742	payment	1397	1397	1678	1	1	13808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJQ2n81guD1986sC8AcB6ZEFCFRM87ZJZZBTeXU1FCjWBZPta
35743	payment	2134	2134	1874	1	1	4249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYxpgNyehN4mnkDuUh4BqucZR9ffN2p9Act45TWn7pgvjmxnf
35767	payment	394	394	1483	1	1	2	0	100000000	\N	E4ZRcRStMSwDV96GvvD6UyJUY6U1iADGpcAGSfnVEDdaezvrNR5fX	CkpaF2m2Y8GbbyLfkT6LoExLBqUWLLwYbaEukK7uRwEGX3pHfcgih
35612	payment	2134	2134	1874	1	1	4202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRDR9xB2LmszcVHyENRNbWh44ja2Mb24ryaBN2NykSXp5LhYsG
35628	payment	1397	1397	1678	1	1	13766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZet7jUmfraLiK237WJL1vXdvTu4caPkGYrddkrwxcL8Dr3dxFw
35629	payment	1397	1397	1678	1	1	13767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PZuWsJERTSAeTtBNVHuLFh9j8JmcqGK35m3L7vAVcBs25MtB
35630	payment	2132	2132	1874	1	1	1207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1oLGHJze6MYaVj6Jy6PK7ebrNCYP9PPizVNs3rWVgpC3dh8W
35631	payment	1593	1593	1220	1	1	6	3524000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFHBAMseLJinUBdrnXk4TpUdj5ypfJALtALgD4GhDePa8vVMX
35632	payment	1593	1593	980	1	1	7	2914000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ3sCefT28Rv4E5CcRKAm5RxJS32dJvLzpf4piFMykFNF97sxV
35633	payment	2133	2133	1874	1	1	4170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEAoy7Ch8JxeDm2MYXPrrVTvgpM4PKzvVhdiCC1cXbdvWS4eb
35637	payment	1397	1397	1678	1	1	13768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5SM6A856c9BTteaJNKcGYiDDFReecXGmZwcSCK1MhN1A4zPD
35638	payment	1397	1397	1678	1	1	13769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3KqjQiUaNakj7rFhaATQwhersvbUKKYRV1mH5th5PdiW2Vsa
35639	payment	2133	2133	1874	1	1	4172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8PStmVpASXNAofbvrqMLTPrVWWkKqsCCNrcnoH3sNKSY9PzD
35640	payment	2133	2133	1874	1	1	4173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkYfFiJ4wpndGa2TTE2UXyeU4nD3AaGXoCgy5gsRKqDEyrh3Gq
35641	payment	2134	2134	1874	1	1	4209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjspLJ5Xh7r24znhy7Fki6ZCuHexhQ1dR4KLPh4GLa3siMbwUU
35642	payment	2134	2134	1874	1	1	4210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbjrUq5xzEy3oohaxGB2f5o3aBnWRsUo7ooy8eKJuD7fw4b772
35650	payment	1397	1397	1678	1	1	13772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZututdKmmdpK9YQvgL2iTvvffK1VfXdskgJrcnkbcHtPVD7ukE
35651	payment	2134	2134	1874	1	1	4213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2iEwsqwuPaXWj4tqHEythZRABQ6jbuUnMqn9x9KBY5Jz6VEDF
35652	payment	2133	2133	1874	1	1	4176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NdGR26iNxFts1hpwzttiNBAX3SC53fjHuypfuKhkbxtbszFY
35680	payment	1397	1397	1678	1	1	13781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDvBc79NHxA23mciHAc5fMAgZmZEmJy4H8vNyC58DvWi8MM7Q
35681	payment	2134	2134	1874	1	1	4222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyRDL8H8LoP5XZhoob9dGeT36jYVXebnnRDtRQcttBj49HjKg
35689	payment	1397	1397	1678	1	1	13785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7Yq4n8MU3TpBQAyX7T469AVuwxKNhcPvpc92vYV1Zn5PkFGg
35690	payment	1397	1397	1678	1	1	13786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkh6Mcy5RZtCoKGUTcYzrskoJ5nFDpDEYHduhwE4bwycLwk5RC
35691	payment	2132	2132	1874	1	1	1213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoS2YZ3dEPW9qqrNqPH7AfZ8NVSxxLJZJxxUTuBPThvPRWmFBH
35692	payment	2134	2134	1874	1	1	4226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKRiyAbDSwQhEder7WKc6mxhH3iFvBzyMcySXDPMH8QeW4LjN
35693	payment	2134	2134	1874	1	1	4227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTJVEmh4sqSLAbJ1XroMLrCgGwFXdRcaLrL5E7fMf4UBA9J27
35712	payment	1397	1397	1678	1	1	13795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjpQ9AyDrdx1mvAxV44iQ6oHWPJmf45ER3pDbLwCZfic7iFtt
35713	payment	2134	2134	1874	1	1	4236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAxru26gTDuxQh7f9i42MYxx1MB57tA832qnebFbcDaw4D6ta
35714	payment	1397	1397	1678	1	1	13796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMaHMLEaGghVmMCWiuEiF6Sas42HMFMVPqyFp4p37Wug69H5B
35715	payment	1397	1397	1678	1	1	13797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZwREAuJ92kW6FmqAPP4emePPr9uUNkhANvgZdfQNsdYxtCFW
35716	payment	2132	2132	1874	1	1	1216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBbSaoE34E23CTDVZaaPcZwTiF2jQZqjpyFARqcRXrxji9CDc4
35721	payment	2134	2134	1874	1	1	4237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBD2Trz4ZsyZ2EWGujMonE6LcNVixXzt9zNxb6NRAFoE9X5ntK
35722	payment	2134	2134	1874	1	1	4238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAhV9x1XGeFwaJc1HWqpNFEgYHvV9dvS5YCR22pdBgA7nAqju
35723	payment	2134	2134	1874	1	1	4239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmU1oEgtraReA9iTos3AESezkNnP7C2RTFae9bZhRYUqoU8e1
35724	payment	2134	2134	1874	1	1	4240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngBBzjes9yHvHd4shxzXS5CiCy5oFpEFWpWaCtbhTVSq3hsZh
35725	payment	2134	2134	1874	1	1	4241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbk7cWFw7bGyWGDnByvDd9opCQPsifJgBpMaCtb8K2QKixTWgE
35726	payment	1397	1397	1678	1	1	13801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4T7fi93rkjNTinXsLbWatJw6kkGaG7LKHaZt9b7merdXEeFor
35727	payment	2134	2134	1874	1	1	4242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6QLjjDUBBgxSsUZpbkZkbzmCgWV9VtVNxGQ2T4SRRCcGJARf
35728	payment	1397	1397	1678	1	1	13802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLdJyTA5WqvFPbS54RpUFGWE4ug2fAPoYLsECXyUh7RDq8T9K
35729	payment	1397	1397	1678	1	1	13803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5A1rUBtHqGe6DhYEamXf3KoLLiN8YTu6VeBHsshnUjSCNa4G5
35730	payment	2132	2132	1874	1	1	1218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdo4CvJWpWNCo2FHGj1Vj6qHfNxGbFzQ9qSvXQZ3oYQZpEVbay
35635	payment	2133	2133	1874	1	1	4171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMpTNPaB6W3YCu16iGpRr1zXjUfMAGGNVyHNAyVnmXwgB7nMb
35636	payment	2134	2134	1874	1	1	4208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVpV7T2LgCTRmtDHwnpuZDxrWJNi9YT7evM3y8PfmSmK1Q3LA
35643	payment	1397	1397	1678	1	1	13770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFpuH1i4dvt96ACDvfAbEDbh4cvSteW4PoHdLEo9P3EEufAnn
35644	payment	1397	1397	1678	1	1	13771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bGiRyaJiugRvrRccDWar3C2EtBe2LUULD2bV6dYhAuDJQAh5
35645	payment	2132	2132	1874	1	1	1208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM38Pdsd8h3iUBZoGD29R3MZLPdjvA4AcnXSxnM4jugX6oU4Co
35646	payment	2133	2133	1874	1	1	4174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdNtoeabWMiYF6VKzveMMgoezCiUbit16mukZP3CHQJ1MFYUW
35647	payment	2133	2133	1874	1	1	4175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnkwyrbeQri2pQ9SFcsFp4VShUB5QEkCbwPTPtKZHgXkbQhHr
35648	payment	2134	2134	1874	1	1	4211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnVX1FD7HEVVp6ZEEfXU8RTuVpqKAHeSh4XNMXT2zV1wzjUwM
35649	payment	2134	2134	1874	1	1	4212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvot3bz2kXLS5kMkL4qCzYm7c7vUxMmSisK5KH4PPQM9zn1tX9
35653	payment	1397	1397	1678	1	1	13773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfQBb9LRY1XvSjXDgrWmBD6z3L2uc5RG55AvQ7mMJavGKHRrW
35654	payment	2134	2134	1874	1	1	4214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkNhrmut7WjFCfqmPe724hKYR9dii1DL4qp9SSexBSnfADgU5
35655	payment	2133	2133	1874	1	1	4177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTRXpSkri8gCoAQhARoSo4TViFG9FuGadVHp2C2H38VXbtPXi
35656	payment	2132	2132	1874	1	1	1209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4s6FFrY8kEkFuhA2CD3mrmRKbEsWPyv9Xej822yWGjHajkuU
35657	payment	1397	1397	1678	1	1	13774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Bq1i9P5865u7zcpSVrBEkkGCzj1G9aLM6TEv6v7ymM1Bcsar
35658	payment	2133	2133	1874	1	1	4178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZARvio7EJZimXZLN2oCH18m79oo8jmMa79d9Uxe8smHyPHg8fR
35659	payment	2134	2134	1874	1	1	4215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCSf9aCsbS6c15xJqb1SJiduSQmkbisZYuVUk3Bc6wGuzBgtsV
35663	payment	1397	1397	1678	1	1	13776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa156DWGQVu8FDGiVwUz8LwLvoX3crzDWAJZFydNYP42QpeTCyo
35664	payment	1397	1397	1678	1	1	13777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXXj7qhT8aR6mskFhhgVK144qhJC6RWLTid9nAvw4WwrPWiao
35665	payment	1397	1397	1678	1	1	13778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjgDymiuZxHD79ZzyRn7Msou8D1JLEWyEzv3RvrgaYFJ8uutmS
35666	payment	2132	2132	1874	1	1	1210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe1s89U7DJcAo9j2ULEWomYk3vPATmLAqq3GHLSuzgwbdDAhM
35667	payment	2133	2133	1874	1	1	4180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccbT5S9RpGE2iBZwfXi8VMG4hGe2bZLaWFa6ZXPY8St4iGJex
35668	payment	2133	2133	1874	1	1	4181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaBQHGWxZpT6UyYf4K3N1Z8s4N9sCjFQqw38M9WFMQ6MPu2HCs
35669	payment	2134	2134	1874	1	1	4217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFiVxoeZx3GLpRU8nwdo4YCufCvQ34pArCWtQ72D4WzQs59DAD
35670	payment	2133	2133	1874	1	1	4182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksQn9tacfHxXr7qKJTF5FEKwtjVLNpNEPTyVK6Q8pHeKSwAhy
35671	payment	2134	2134	1874	1	1	4218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCob1pgEumQPHEq6mmPMzYrDY55XReDq2mSMHj5ackxDRn7Gmm
35672	payment	2134	2134	1874	1	1	4219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PKUrmTBSgz6FLpn95oU5kcLot66d6qQ7He6x7rs2pagnRiq1
35676	payment	1397	1397	1678	1	1	13780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbhVNfTNX53QP3Y1ZqV5UyUkfdeGLNeL8Xci4EFsf2JjWuSr14
35677	payment	2133	2133	1874	1	1	4184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqZ67BVmKThjvzLQQHcXppeKRNBJDDBQqL4sYCe9nsdLiGL1T
35678	payment	2134	2134	1874	1	1	4221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWWkgRDNoykbCe8UxDjjoVBe9mfL6vwfP2j1W76WBUePfPaMr
35679	payment	2132	2132	1874	1	1	1211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmr5w8kHfqzUfciWawhj1W7BLf52JTDBoxpeUaZMo7upKTDopB
35694	payment	1397	1397	1678	1	1	13787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvipX8AG6rEjYxCxV78DkDD9oyPobkAteHgwEjXHG8PesewzVv
35695	payment	1397	1397	1678	1	1	13788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Q4nakxWtsCec8m9G1emSQHVZZ1ow6yvw7p3objVuWCRsGAaC
35696	payment	2134	2134	1874	1	1	4228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1NSvQwFLrPdob1xvbsWnjRvzNN3SRWPboM9MAG8ZhfhLSa9s
35697	payment	2134	2134	1874	1	1	4229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJvDrf7r1bPSxZZL3XT3UZYwjtxQ17zcD3HdU4tFyLAseRu2A2
35700	payment	1397	1397	1678	1	1	13790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdzs2Mb82bhN1zRyfmfBDkoFvBw9Zk5dEbQm9FxjDoQrqK9Fw
35701	payment	2134	2134	1874	1	1	4231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwEyGhayrHVtMwdVBmsVuHy25GcV8ozt6EyyCQFLccQAYj162
35702	payment	2132	2132	1874	1	1	1214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqQk7eEhaa2MpNT7QZN7tf6rPF9ABerMcJCzEmVAD6aceD3ev
35703	payment	1397	1397	1678	1	1	13791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzqmucCqNRD63Q4SQ2QS8Q21Zw3zjBUrvxDQ9tgxonSVwkotj
35704	payment	2134	2134	1874	1	1	4232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU4uFDTEXQaYJPz9Gft2SwUxXaxY5KCKQvB8pj78EUr6oNiw33
35744	payment	1397	1397	1678	1	1	13809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1n1L5WgfU7TRCutT33cqWfSy2Kira7PV5ppAh1GJ2E2SFmAe
35745	payment	2134	2134	1874	1	1	4250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkQuhSDX2yHV8VmvEviBfYTGHHrSAc8n41kMTXWjsunMbdVLX
35746	payment	1397	1397	1678	1	1	13810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHYf8KFS1VfASzQP5XwPLJAJi5LwAcvXb99c7i8H35qNb11E5
35747	payment	2132	2132	1874	1	1	1220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUPphkS9L28DRiHZHqMRdgQDTE1TUaBByG29edCipP5Coedrg
35748	payment	2134	2134	1874	1	1	4251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZwR6YFt6iAx8CL1nwBjmdVZcdtDQYkUai4K2Mfkw9baryxnH
35749	payment	1397	1397	1678	1	1	13811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTfykF9Bk1aRFgGg8Xauqf7qPTch6vM5qJGcLf5P6nPmcdZNQ
35750	payment	1397	1397	1678	1	1	13812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49RSu5fWK8u32ZruW2rakZv8LjNADpLcKhSZmg68V5yzTgn1H
35751	payment	2134	2134	1874	1	1	4252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYE83TQjYyH5vvAvrqZdQU9udgwHfw5kKHKLxWKkBNQwWgCk5
35752	payment	2134	2134	1874	1	1	4253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUHRAsDXesSjadNNgf1tN35s1fLWMXxHKN1YkA7xVRHkNycmn
35753	payment	1397	1397	1678	1	1	13813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxUAmyhkceF9imnNmuFa49ZMfP1GjoJTdWKxDb8dmWHF83qnpv
35754	payment	2134	2134	1874	1	1	4254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhr5PTKmYnXeNWCTv82QGBZTVtKBZM5F1aP4DZVdoGSnzFD8e9
35757	payment	1397	1397	1678	1	1	13815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSfVCK6bPTJKBDKo1HXPWD8vHbmDZUPLokCffaKu6P7UArtrm
35758	payment	394	394	2308	1	1	1	45000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZod6RjzCo2yt3A5hssyfFzqgDak7sK9kg6gA9XaqKhpk4Nqcq7
35759	payment	2134	2134	1874	1	1	4256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61LsG6vGSi6eswNP8SGPSazg7QWWSsZRm93Vw8YvWGY2jz9mq
35762	payment	1397	1397	1678	1	1	13817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVU6DspV1WnWTFrEnYaGQVxcXPcoVRhoaH4NLzZwF9goYMHc7e
35763	payment	2134	2134	1874	1	1	4258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzSxE4B24jhki43FaJAQheVwcroVysGPwKef82XknBEJugAgfa
35764	delegation	2308	2308	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpaj5YJ2h8jeV1mkcKm3f3KRXqNSq7uPjGp3fywuuv5MkQetd
35765	payment	1397	1397	1678	1	1	13818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W4wrAQ7uoqtATPYF3uZEtCAykZDJMLub6SBmxTkrPc3qZYCt
35766	payment	2134	2134	1874	1	1	4259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpexiXzXfKP7otLF4xPQRwsR1DdULTXZyVYsLuU352cvQPv3rK
35772	payment	1397	1397	1678	1	1	13821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHiFHBnMYHsnL8D6T647LwYcQe7sdrVhLsAckBJGEWHs7jbTk
35773	payment	2134	2134	1874	1	1	4262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2qwPXsuhUoCpEKcjYSUaMAHjdJnKAHYAkMeuEExmCu3CsYN3
35783	payment	1397	1397	1678	1	1	13826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNcfLJC5WFYY4wrz4KFApgmtxidhsuJEA4xDNjdvrFDNiiJZW
35784	payment	2134	2134	1874	1	1	4268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQXRGqeUv5TayMyGFyWV3GWRdRcGGjCZpU1FqYzuM5Mt1YGva
35795	payment	1397	1397	1678	1	1	13832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12EVd78HNp6z4dzAKQwx734w5Fd7u2A4ZbZjuxV95MvdPUygs
35796	payment	2134	2134	1874	1	1	4274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimokeXGMEfmGynWooS2qK6ge8fXAD2SG4tk7g9m9W3NnT6Xrv
35797	payment	1397	1397	1678	1	1	13833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6M1YbpBdgLSy9tJ529Kzz6PwLFNHvExc5qe4YqFEmASCgQ8fK
35798	payment	2134	2134	1874	1	1	4275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaJCmPXHk1N1wPQ64dAHsLW6Y7ivs1555U6bDQPvXM5Ea4LB9
35803	payment	1397	1397	1678	1	1	13836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9UXPLiqVatrbJNSiAFi9wj77WvVLDM7EdEUuDBYHAtdPWFxD9
35804	payment	2134	2134	1874	1	1	4278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHiXL79mm1gfBUnotPek5amwMi6HzvUEJrbb7cd8xAdnVnLP5b
35805	payment	1397	1397	1678	1	1	13837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudp4Dcka4rYG2vhCjwXPpBY61Dk7DiWSEFpeV9puZTbbi7Now
35806	payment	112	112	1821	1	1	7	88300000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJcdXriMEFBrnrSiZADK4f8eeimbPxvLaG9p4ZunJzpkm4iun
35807	payment	2134	2134	1874	1	1	4279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZG4aLmHEgbvn9gLcZ1X6FFevyKGuaFd1ymYmj2taoiv5MgBwc
35818	payment	1397	1397	1678	1	1	13843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHjWzBNpYg8cGZnuG7Dd5ppA6bYu3cmCUaRYo7Fdv3LVik4kU
35819	payment	2134	2134	1874	1	1	4285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgQNLzgY3dcKtr8HGvp9UwABwqancD84ofKsdyLSVodVFsAhGx
35837	payment	1397	1397	1678	1	1	13853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5eG68EpKgLHsN5kvEyX5Moa5BCVjjTuNTdiPvxD5KV58inxS
35838	payment	2134	2134	1874	1	1	4294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCX6T5qW9bcaEwvYAyv8mSNLzPwS5GuSQ8vcbrjUmpGyTBatQo
35859	payment	1397	1397	1678	1	1	13864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo1YJHtYiVLNdKFQEBCba7dY2qU6e1NfXLh5m9AsvFjNdTXpa
35731	payment	2134	2134	1874	1	1	4243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mqb8gYgyFc5JbkBD6QFFuuTrbZJy9xXi6Ki5sp7TAv9uMUnq
35732	payment	2134	2134	1874	1	1	4244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD49DLUzkf1xKYSw8qC7rXGWNoSh7pVUGe5YNFRK6v24EU6TVZ
35733	payment	1397	1397	1678	1	1	13804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHp9tgH9CE71o3SGErEn9geFy1ekaURHYmKU96VeuMiF5fBKkj
35734	payment	2134	2134	1874	1	1	4245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBh3d4X4tmPi7KH7BcTZ7KSx3RUrXKLQf6wfRBVZeYpJrJGun
35737	payment	1397	1397	1678	1	1	13806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa7845jWKaPpd6RCmMKC1CN4zJN9ojCqFrBsJfWat7BBGQsBXc
35738	payment	2132	2132	1874	1	1	1219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPw9HsKdbkHRCDa832zVtUhqqRxAVnW4WLb7mVMaW1QgfqJqv
35739	payment	2134	2134	1874	1	1	4247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuC19PoiCGEpZXMmfYiYXZuZuJJp4VBtYyGtEUqjiS8afa3nz
35755	payment	1397	1397	1678	1	1	13814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYup1ZNyBVUikPNL19mMq22MpH3X2Q6WpKJKs7YEWepdM9rfZ1A
35756	payment	2134	2134	1874	1	1	4255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDgFiNFuwKn9CzTMJm3ZUwm8z6pmcPmP87hi1kMvpW9SCnhQd
35760	payment	1397	1397	1678	1	1	13816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTx9W11EUx74HH94ni9pWVzuUjd1QWHwaKPcpgSsiW6ZZyHAYU
35761	payment	2134	2134	1874	1	1	4257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHffrdADzRdpZYHftkULkPxB5j66Sn15oB48CS4sEPo5HhJ2n
35774	payment	1397	1397	1678	1	1	13822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCTLPsrDovL98w38QGaawNmy9mpzTy6qpzMgzU2Epp15KqgMPi
35775	payment	2134	2134	1874	1	1	4263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPcT23gc326M4ZPG1v8EHVE4EuXSNenQMDazs5HFY25QF3UnY
35779	payment	1397	1397	1678	1	1	13824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMije2EtNTU5XiVtTuKQxdApD7ECQ99dninEEBqhSh5aUoa7r
35780	payment	2134	2134	1874	1	1	4266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1U1pzTeNhSUEj7eUs7vcDuKJoabxqEYJs4ZtKkRXcnmmAkwgV
35785	payment	1397	1397	1678	1	1	13827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWE7d4kH9XNhJ79r4hyXXiY33uxnYmwJJDsKEzZnjd1ZZPksUS
35786	payment	2134	2134	1874	1	1	4269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAAmBakruoeR2Z4WmtvRUNqsckNaEBFCctvMS5aFjJ5SxJpS9
35791	payment	1397	1397	1678	1	1	13830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiNZjryqCj7JJZa13bFgtfjQXHJDJvX14SJGVBq5CQ4QaHYKa
35792	payment	2134	2134	1874	1	1	4272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpswVbV7Btfag1rytqkNv4uYSUYn5CyxAri1WtafYS9rSeLBt
35793	payment	1397	1397	1678	1	1	13831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggKbrjB7ihPro45nt8WnktoTg3HdRLjrDTKWJJxfpUV1tt3zh
35794	payment	2134	2134	1874	1	1	4273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAkRZjZpmJpk4398KPuMxYqmWLsTB1yvSRoZw1KudQodqz3Yz
35799	payment	1397	1397	1678	1	1	13834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KcUSsqVKd1EGp7vjXqscF24Rb9Eqpe99xaxLkZ9pZNa1rqRo
35800	payment	2134	2134	1874	1	1	4276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrKTd5MxiSgTdNM7qrBQSxWJ7g4DP8LhPAjZ42FtRYNTaLrtQ
35810	payment	1397	1397	1678	1	1	13839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hJtTQRCz8Qkp49yQaWAuPmbBhmYrPEaP4uT23kLL3t6D4ihP
35811	payment	2134	2134	1874	1	1	4281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpj8r6R9DqgiGnvgRqQYYy9B8BbLq4Ztm9bPgsCBfBJjVbLcH
35827	payment	1397	1397	1678	1	1	13848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qNwsuExuqjuCfo4BuQdTJrc7JzqmtMyoW3jr8Sw7ik7zcy7E
35828	payment	2134	2134	1874	1	1	4289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPj1HLHYcutoKP7RUHSfpBSjFtgxoiUEBurgB9tDpSJnT8qwQ
35839	payment	1397	1397	1678	1	1	13854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBCkhJQMN9KjVoGuRD4WErCDoHMu7qnWLkSAyDCtxzr4UfKDR
35840	payment	2134	2134	1874	1	1	4295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34uRuqsbFGoEqQZUpaBXzk2hAiLNf357SgQ4to8WZ4GwMqLc5
35865	payment	1397	1397	1678	1	1	13867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwtriNr1QpLdQPPXQAu6bYacij1ste2bx38dM6SpAtTQe9TWY
35866	payment	2134	2134	1874	1	1	4308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMvmc7CfCUdUVLNuCGHaAnhP9hh3zDf33ySnVo9U6H9Ds7xoR
35867	payment	1397	1397	1678	1	1	13868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3LE5T7w5PkiQMZjNFXy4xViYM4bBZc6fuXUSfXK2uMjfdCyf
35868	payment	1397	1397	1678	1	1	13869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zA1bgyp3MY3SiCRQSrWreHMya9ousMsfLx6B8U3Uyukbut9J
35869	payment	2134	2134	1874	1	1	4309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk6tSAzBh6izvR6NNNx5ge37KAcQ5kRSSqQmWEZaErCCVBrjM5
35870	payment	2134	2134	1874	1	1	4310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuwvRZ7CaUkUzQcDEdu8VRocPyVGiQChW7v3oiS1XDb1df5kzt
35879	payment	1397	1397	1678	1	1	13874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ6JEXEzVkK9e4H3CwymfkDkCiQHZcxarBRP1HboGkHzvuhNot
35880	payment	1397	1397	1678	1	1	13875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGde7PEHwHZdXh1bAo7gSRaBBbhC1yxfWEy5ixeGaBx1PZ3vCw
35881	payment	2134	2134	1874	1	1	4315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGMiKLQk4LATtv8pgFgxQ1UVdK4M32nUazaxLvEEfJq3gArig
35768	payment	1397	1397	1678	1	1	13819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkcFZ4tChogWABuaG7973yiXRqTqUr3eEp5Z78KMznUJmrq6Y
35769	payment	1397	1397	1678	1	1	13820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMR7KruSmGWSPUQS3or4segzigZjE6R8x4DpSACPc19oLEjQE
35770	payment	2134	2134	1874	1	1	4260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZGY2bWQ78DapgLEgUe6NMt6frGTHuoneYEN1bnWeV8GrhAqv
35771	payment	2134	2134	1874	1	1	4261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6H7TxLdWpVogcXNnbs2nZEmd1kkaSLLX4S1ZjwAr9wXgW8TvL
35776	payment	2134	2134	1874	1	1	4264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY72pCNhnhLM8oyZtAt3fD4ZZfrEC31QC3WiTKt3sqjbcsnM1j
35777	payment	1397	1397	1678	1	1	13823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHM8cxtN6a1LvuJzAux5CK6b5i8dqdpLjJ9L4pSEPncNhVRRE
35778	payment	2134	2134	1874	1	1	4265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGPSNqQgBeofXhR9sZPbsJh56m7tDyhdvzTnqUkXdvve1boZv
35801	payment	1397	1397	1678	1	1	13835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG1SsGuKjZNyzddYc1enS66RsPNAnY8V5nFhNQHURE3qfuXhvz
35802	payment	2134	2134	1874	1	1	4277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqnLpeCi1ikBZ6hZ1aYcJwvX7WdR6zLMh9DNrjQ6PL3qBt3oB
35812	payment	1397	1397	1678	1	1	13840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnniG5sjU2MyQXa8UjmyGtPMvBjjLR9vYuFSUgbAjvgiWworw
35813	payment	1397	1397	1678	1	1	13841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMhCs1w67zF94nMPv6cCP2i5rxB577MYT67yU6GoWMNUudBps
35814	payment	1397	1397	1678	1	1	13842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYijpwY25mZ63y68EsgqU2i6ecbJEY88cgxTNmLCijjyVDSpvc3
35815	payment	2134	2134	1874	1	1	4282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQkSzvCq74sEJmQPCmeokoLjY2QzZx6XgABjw9VM4fCibxYiV
35816	payment	2134	2134	1874	1	1	4283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCavHcie5dSUoKoWcR5BHuj5fX7ceKj7wM32XxesvPBEWd8Bht
35817	payment	2134	2134	1874	1	1	4284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfM44bQiroWP3xxJZtNDaxxXX3TPTxqT2c58M5TaC3mLcdXe89
35824	payment	1397	1397	1678	1	1	13846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJxSZg6rQ5qDqC3VfgB5ndn539d1BtKRNJNXjMbmKzD4WLCyw7
35825	payment	1397	1397	1678	1	1	13847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUuzMicftfB8KaqR6knMTgpnMoKpHvLSVBeRWvCawKvf9HM414
35826	payment	2134	2134	1874	1	1	4288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnY2FiNpjYc9Cfj7KgFDCQceEH2s4KFwEjTtSWQRtwi2fZv4rH
35831	payment	1397	1397	1678	1	1	13850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsr61hpCNFb1ymJ4cW9LkmmLjbthjyh7kTReJ3ds5qn4iEvuJ7
35832	payment	1397	1397	1678	1	1	13851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZArkbvm2DwwqMJoemh2S1xHFFDTaJEvicmmzyBHhYSB5NKuSjw
35833	payment	1397	1397	1678	1	1	13852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXVKtFgHTedDMDaed6VQ2Ra1c6JFjpqyVfnPXHJ8i4kWifg4T
35834	payment	2134	2134	1874	1	1	4291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtqsKaVFGZ7k9afdspr3yWst3jfn4mFCUVUaJFLtwq5XZk9yN
35835	payment	2134	2134	1874	1	1	4292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVKjSH7XKXT96WpzokjeihB21FQQmJBMputWeFQQGCA5fPmZc
35836	payment	2134	2134	1874	1	1	4293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALWKs8aQk2MN4NXvy6YYsi7g2KisiN9saeyQuod53j5DjsNen
35841	payment	1397	1397	1678	1	1	13855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmn8XFfSKBwP7Rf8PBtDC7EDeRcF6Lg9RQS8zWW6Yq2umHD8wp
35842	payment	1397	1397	1678	1	1	13856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxCAskxLEFhwQKeBbkETjP3T9JH74XMZeKekZ5q3L1YEVH1wC
35843	payment	2134	2134	1874	1	1	4296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjwRp3qx95TsRYkTHNfqR6LFY8YYh5ZqFjEBUzx6uUNsVhrWT
35844	payment	2134	2134	1874	1	1	4297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8cbBJPvfbxJPhUzLRd8R1ZXqs6PzhPAufbeiCvXq111VsZzb
35845	payment	1397	1397	1678	1	1	13857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpUh5zLMRqEM9izh4jxd3b3PDX64MJXf565qQ3d6eCSfiWaw3
35846	payment	2134	2134	1874	1	1	4298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGvQTjWTLFAeCdjmPpTAEZc85h6mY9KELRFkpDutTj1Ew2T8w
35847	payment	1397	1397	1678	1	1	13858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rhij8r5hHFz5w8bQ4yppw8JHZBzDjibFpxm5Bn3dHnzgc2Jr
35848	payment	1397	1397	1678	1	1	13859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75qMUvWgR6p5d58oNnf3XmsBBSWJz5GPonCC51xCvJ9F3MXH1
35849	payment	2134	2134	1874	1	1	4299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XjHDKYWpUGzKLhXXW1q59MpRqfWtFtwXWCY14CqegFMZxfoi
35850	payment	2134	2134	1874	1	1	4300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCHBDtoZKDRPtZzfSACXM2PW5kYPLjEVz3DrsKJv7LqWTp9BnC
35853	payment	1397	1397	1678	1	1	13861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6GTNNFhVJs1Hm8REEyRHXjMwRajjfDuruohPQvH2bD2sqThy
35854	payment	1397	1397	1678	1	1	13862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfDaL2Kht24NbM8j8yXxWnBa98gq7mRSEFK96FhPQLE5aL1e1
35855	payment	2134	2134	1874	1	1	4302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR5p58ukvbWRbzdpeAZz6kkby7EJGnoZjX2vkTXMv1t8R1R6u
35856	payment	2134	2134	1874	1	1	4303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHamxGF3cuw8XahFCazg6Kxz6CpXpHhV2raUTJUBGh77Lwmanm
35781	payment	1397	1397	1678	1	1	13825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiE66RV5NT92pheGnoZRSYzu7Xtt5ZiJdZWnbCRzVtDviPeh6L
35782	payment	2134	2134	1874	1	1	4267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncB8WGJmR39w9Jj6PbR6z32yfmRYp3jSgBEpkg8bMWK5wDE7a
35787	payment	1397	1397	1678	1	1	13828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAs4U5JzPf9c4fjTA1xjnWkQDvruDWsng6E8xkCw1cLH6bezco
35788	payment	1397	1397	1678	1	1	13829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94QQfum7S2tp9SAbKfpNtkMyYZ4LaevVbb1xjWLQhc8uRQ9FQ
35789	payment	2134	2134	1874	1	1	4270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7j5RqnFasATupHi628RNeVXhy5FvLx53RNpgswXDmM19h9ta5
35790	payment	2134	2134	1874	1	1	4271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kDhSF7KTgJK7VKExqL5sT9h1S7RmYRtfkafikZJMNEFzgzwo
35808	payment	1397	1397	1678	1	1	13838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVtm3okrbuLs6UFwimUisi8op8pJ3LcR47MGLnBFrfZUDrpdX
35809	payment	2134	2134	1874	1	1	4280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3inxdHPEw7fPN3JDxqga7r9kP4H58U5FpXAkEvcnF4dgsDf7t
35820	payment	1397	1397	1678	1	1	13844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBokHp5UVRe5zTiJgj6ASSJyWLt9nn7EHyo7DAquN6zsqw5U9
35821	payment	1397	1397	1678	1	1	13845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ5ebMamBK9TtsWAXU7om18DroWQRvYwDLK9sZB5w7TBonNb5
35822	payment	2134	2134	1874	1	1	4286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4BKCP2QwNWumwqhJMiTGbT753thbewtMwWUi5Hqjase33aNB
35823	payment	2134	2134	1874	1	1	4287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4YU7636P8KuGN57Yg1WyzuFgh3LEC6ZtSkpVEZRDts2bXsBN
35829	payment	1397	1397	1678	1	1	13849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdmi2AtvP84TgCDApzZt1xYApnkJJtEKpshWpUdiJz1uK5QT6
35830	payment	2134	2134	1874	1	1	4290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ggVY9CojWqvPdYaDCQgQrKhixQDQn7zkMEmqqG9qsWJiXCvN
35851	payment	1397	1397	1678	1	1	13860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdxs7aCzPM7hHF221HcjoaTCkmrhFaxHowEtgY2NRE2C2cPVLb
35852	payment	2134	2134	1874	1	1	4301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSXNskDRka1S1ZScupYyZsyRL3TfwVF78y5zqN91oRUmesaYa
35863	payment	1397	1397	1678	1	1	13866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWw1bjHQBFfYPhmXCfbrzzcWx5N5jKgoNpdaFzd9wL4E76V8Q
35864	payment	2134	2134	1874	1	1	4307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCymca8DThLCzLLs6xkjS8HCjPKLu32sKXepxTUjaxpYsfL8R8
35871	payment	1397	1397	1678	1	1	13870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnw3VBv4gJBBk1fHHwuDPot53QbzgDc6FUetgizX8AfmNw6qo
35872	payment	2134	2134	1874	1	1	4311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxCxQiVrnDLuKzEHmxYqwMu9BXBYLuSDMHuP4EtSMHv3P1TrmQ
35893	payment	1397	1397	1678	1	1	13881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi74SAyCBMphF4m4ri9JSFETjSAwqPZQh14xpp3zpdH9PkVj23
35894	payment	2134	2134	1874	1	1	4322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3AieMoSzNpGgTXhnkc86N1xF1MHcrwb9VXuLrEhD2MxhjokXH
35929	payment	1397	1397	1678	1	1	13898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjHrHCYGtig2p1g9LmyrzUgC2LZotsKgBR5eRU1AiKFNRP2Pm
35930	payment	1397	1397	1678	1	1	13899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNoxRjNuiU84HARHES7NboGB5n2RTLykBr4wqoy75hxhPvpuop
35931	payment	2134	2134	1874	1	1	4340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQndmq9fc9iMg6zmfPZGmkyLzuihpbT25ZJQnhX1B4z7oh6gh
35932	payment	2134	2134	1874	1	1	4341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMRV1YUFGXKx2NXytHnJSKs86msPYvKAwG7PJ8CAostzvUSnP
35933	payment	1397	1397	1678	1	1	13900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5pBaRGjXkH5HGXCiZ7qLBwHzHTg4eAhmtDup5B8v8Nm2LuC5
35934	payment	2134	2134	1874	1	1	4342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sCDCHhf4j836VCtUUSq8wtuBcKCBdqPKRaXHuEX71ZssA7bQ
35939	payment	1397	1397	1678	1	1	13903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTaGcHoWxBjo9XXziGjRUUb2aAZtpMnAKVuZe9up3X6RivHb1
35940	payment	2134	2134	1874	1	1	4345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MzrbuWHa6Dksasu9eYQFxXqiegXtC1JVpJnrc5L1EDYfeCvJ
35941	payment	1397	1397	1678	1	1	13904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbRDrs2egyZoD9btp12WtuTDQSD3t22LhSvQjnsh3pwNZHUgL
35942	payment	2134	2134	1874	1	1	4346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcR64NyMWS6JTtaL5HQ9cE7dReDytQ2AjnbAKUQt3H5CNVjVu8
35965	payment	1397	1397	1678	1	1	13916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHKWj1M5xSEv76pvwLPve48X3C3668ia3EXYyQQ3aSLF1WsWN
35966	payment	2134	2134	1874	1	1	4358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fG4L6ELfwZaBCrXq7CPnSiKRKZNuaqd4cvRiSPzwCLztLXca
35973	payment	1397	1397	1678	1	1	13920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhNV2efKuFfczZVqu1t6t4bAg1cnDWa4neKJf3t1kqKcKAw78
35974	payment	1397	1397	1678	1	1	13921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3beusNimSN4h8ABvCxegyJhMNAVR6N74T9HFunW14pQp74AZ
35975	payment	1397	1397	1678	1	1	13922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8sHL2uyBFXavAPu3tf17AdPVeMXTr3rMe2m43Sb8fTKZniJU
35976	payment	1397	1397	1678	1	1	13923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqzKGw2QP7xCtaQ1x2hDpaqwNbKKZ5oFJHMK4RKs12WcnGEtSx
35857	payment	1397	1397	1678	1	1	13863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR54gVeN6C3CiK1nSnww4hPR7MFYczZxJVpxsooSCydF2L889
35858	payment	2134	2134	1874	1	1	4304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF1gJb65DhaxycarYxZ5LqbAp18TTNmiDETjkkpSCphmreVRvx
35873	payment	1397	1397	1678	1	1	13871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsV9uk21goTMfyvr81nqZffPFnT3ZEwNh7qD8MsjvhapadPMth
35883	payment	1397	1397	1678	1	1	13876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenJxjwJHaUw56GhRN8p8VLoxF32rxh6ws8o68PsBrReTxhS7m
35884	payment	1397	1397	1678	1	1	13877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJx2XBtruwaaCCWneBan7LjbT2a77ZVGbLhJArwngBVSQxyi37
35885	payment	2134	2134	1874	1	1	4317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpVk8CdjFQk7TcqrgYEfhLmRCK5MerZFgrJ4JFenwJNfRHwFZ
35886	payment	2134	2134	1874	1	1	4318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2WxwdbXQsNYkvQQGjgLo9j2RoNF8aRHeYiKRWB4xd732BxFuE
35901	payment	1397	1397	1678	1	1	13885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGt8J7zwVQHHvE2789oTsRVU7SMFyNpFCoCK8rBsZ1eg2w8KS
35902	payment	2134	2134	1874	1	1	4326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhagUktsA3TBn1o6yGTM2S3kyY4rK58pEC4d6ezFdy9iije8xh
35907	payment	1397	1397	1678	1	1	13888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zC9qQvzHB3j1LvaFmPcxfx86aochfSzxFMjJUQNBc7g3Y9bt
35908	payment	2134	2134	1874	1	1	4329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvs1BJy5j2He1HoLfoWT2V7PGtddfZmemFxphUTkvBQvR3NTFi
35909	payment	1397	1397	1678	1	1	13889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYA4mmkkN2np2S19tYPsnyZ9iYKozK3Cz5EWaq3Kuk2Fesjnya
35910	payment	1397	1397	1678	1	1	13890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZnpQiXKXa9Qjdh9tDirEhLfcBTfaG2PtPo73E2DrAEpRWx5zf
35911	payment	2134	2134	1874	1	1	4330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1KaP66ejQpNgLPEpfrqH2mtYMS8LHUXFmifH9h9bZdbghsFs
35912	payment	2134	2134	1874	1	1	4331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoXJH4n3TAAV362xw2SXRTtdH6VRBdpTg3ajcAWC6WvdirauX
35920	payment	2134	2134	1874	1	1	4335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYwTqm6UQpfnKkbSdhjpZ3MNwtecNwPQ3NKeMGZiKujeR4RbaK
35935	payment	1397	1397	1678	1	1	13901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDHtFCTuhZTzH2z5uhZ6zQh2gxicY2js5GnKTseJ6TygueJG3
35943	payment	1397	1397	1678	1	1	13905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYiH5QpeRzgpye7dXgpwpNuaSt9LAX1U4tuneKdcZZBGCR6mdG
35944	payment	1397	1397	1678	1	1	13906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1xkKkKY77rYf2vdwYkP5FF5dXAcJnjGpZDkB4QhKziXJ3w7X
35945	payment	2134	2134	1874	1	1	4347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1kK53xrjz7LtmCEnygCyQf9fq3ppKkJP3ra3q2GuJ3Kk8aUg
35946	payment	2134	2134	1874	1	1	4348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUbirHi9oto7oF39KqLuwTGcxscqyK4A5NmcLmVEoxQiun6kx
35955	payment	1397	1397	1678	1	1	13911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiopSvpNSeUWDtXxooyDfjwfQdG1BvfZgfA7r3JwJG7Lgzmduk
35956	payment	2134	2134	1874	1	1	4353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW3VQ1gAPYz1F1evry9qPNMHMFMhMzZUxhim6xowubth3dfVE5
35959	payment	1397	1397	1678	1	1	13913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBqWNJ23iruiUmBDWQgGPVCLcBvokxatf5iiTPcgYBgTjwmh6e
35960	payment	1397	1397	1678	1	1	13914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkLW7Ff6iQpSF97tK6aSs7wXXoU5LadP7og3qU3Q5cm7ZMSAA
35961	payment	1397	1397	1678	1	1	13915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrGygGuY31aG4mfJnPgbMArV6fpmArp5p8czBd5AD6J1EeSrz
35962	payment	2134	2134	1874	1	1	4355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQh3WEpWhamB6Q6X3vYjdcmsovkVDuUBYiBwUTNgZo8HwNcnh
35963	payment	2134	2134	1874	1	1	4356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffDcwEnhGUe4ZP3ocn3DztYsvwZjdQC4MFprxaFafZgbE5PG7
36013	payment	1397	1397	1678	1	1	13940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDEJX1kmSrxofSX2kdWVr5rroDHmtaofUuVmKQzrSjmz9SBKt
36014	payment	2134	2134	1874	1	1	4382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XuW7rCZxCQhQghjxBu7toKJNzmFdH3niZcZ8LcDfXLGdyPfc
36021	payment	112	112	1483	1	1	8	1000000	10000000	\N	E4ZRecsFV5Pfqmn7wVUjXqhe2cDujJ6mzdpwMJfsZqh6GNot37QfS	CkpYdTWuUoeXFfi4sxd2boS3eP8UXyLuYpfzRR7EjKRHsYRNBqMdp
36022	payment	1397	1397	1678	1	1	13944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZLPpWmH2rtebVGQt9kJwyvEXFN3ETatebR4KE9333U2fRHAt
36023	payment	2134	2134	1874	1	1	4386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAsASyWEX8tSThfPTkFEwSCyNry5PZh7kDNsw2P3xRxduSYrN
36026	payment	1397	1397	1678	1	1	13946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N3YpWwac2o752uA7pLuGpXzJYNedQ4xwvnUZM2tRpzUeFRe9
36027	payment	1397	1397	1678	1	1	13947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ732ud9jERatx2pe1ErQTXBLfChjFhie7Y5dambLyGjPLME1RS
36028	payment	1397	1397	1678	1	1	13948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvoLLfaVw8CbefEAfY1ag7zvJ3xiQX38dDNVMaL6w4169RyVvg
36029	payment	2134	2134	1874	1	1	4388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2C276Kapz6Jqf1WYKyjHD7TyJza8KrkMbWwgLuUr2kpYWAMr
36030	payment	2134	2134	1874	1	1	4389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjE15w3BJZBrYLuucMamQy3j3sfYurefwc6kn2PUhMHhACJqbh
35860	payment	2134	2134	1874	1	1	4305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtW2bqR1ASsNurVhgnx2KonR33vahgZvNqc7FhC6zdZAbicwxL
35861	payment	1397	1397	1678	1	1	13865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjTdqugyNWdCzALTP5b8EnyNSJcXiz1ksDw6w299dRUpxyy1N
35862	payment	2134	2134	1874	1	1	4306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZxZdZFAJgomqykGDeRVCPfbPcqh5zGj19ejHQs38WxtLA2pZ
35874	payment	2134	2134	1874	1	1	4312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMEA8Xmq2vf7r5Ftcy9BMkEKGru4mzxUDDv7iuRRTQmr7hPah
35875	payment	1397	1397	1678	1	1	13872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnw2fvsMjaHKuJy2gcbJmCHreHPbE1VdHXrPZbfRitQ4ewUAWh
35876	payment	1397	1397	1678	1	1	13873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NABinSNpRkD6gjmFUzTYfbGMz8p4zB1J3wYQQvyia9iYt1EJ
35877	payment	2134	2134	1874	1	1	4313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaAViS9Ldp5oGdnh5UuyndBcuts8WPD1qnFJEFjwpsQEPPreti
35878	payment	2134	2134	1874	1	1	4314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjEHK6vqMB8m4RRq8rBqeBX6GkaJDtHqpJEVvbxW7ZfRpw4W7
35887	payment	1397	1397	1678	1	1	13878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhumAHrBmVq4dsxYvx4o58ZgFAt1shLmfdCn1fDhDwGFJzszju
35888	payment	2134	2134	1874	1	1	4319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruyYbvL4Qbey4YvE3NZ5uXtjUGAzNawfcw68k8VXm3ACEJgBT
35889	payment	1397	1397	1678	1	1	13879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadBe1Tpdi3HRFFwKsDAMGwY6AjHsdRbM8KvCc4sowc8MSEEVn
35890	payment	2134	2134	1874	1	1	4320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyon25er7w3eZwZe966fouKVxCyVzqeAo246E6n5HUBwbQgxX
35895	payment	1397	1397	1678	1	1	13882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhc5FMdRrcMNjFjrQJ58j9K136oM11zkj66WxrMfhHRy8Zvnpk
35896	payment	1397	1397	1678	1	1	13883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbn2oR8BYg2fs6rnmL2punfUy1Kzhk87y92uA2eKcfyXRpXUe
35897	payment	2134	2134	1874	1	1	4323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGUwLudXwqwCcDDySUjUn9YuEsBV2iFUpk3oV67hY8pS1jqkT
35898	payment	2134	2134	1874	1	1	4324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnGhcu9Ykiupb1CRprr7qjGhm7KjiEWU7vtvrhHYZcW6y7TxY
35899	payment	1397	1397	1678	1	1	13884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVoU1ZZxZXh5PjDWtHBjQbSL4dCYi3gFqmQGoxoQrhoazba4x
35900	payment	2134	2134	1874	1	1	4325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7k4ZUcMdvPxSFGGq752M1SMPaBcmKnzPVqkS7M3MTetycdiqk
35903	payment	1397	1397	1678	1	1	13886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYRkfrBkBvkTpPkNDxp1hwSa1tjSFDjv9fWy8pYkg9VQ8UMJw
35904	payment	2134	2134	1874	1	1	4327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEiYsVDBLHgD3k7ttrbn3uuARA5EJncoJNsMbxmBSvUsP42DRX
35921	payment	1397	1397	1678	1	1	13894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyP5m6C48uyvP1h8ZTufzXXmyePvGHHZiFaccpYjzXxUqEdMVG
35922	payment	2134	2134	1874	1	1	4336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgL8otGu2xHAsiYkbvXkuCXCQQdjdJr6nQmosiXHNrVR6PaevW
35923	payment	1397	1397	1678	1	1	13895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLHxJZY3uwTTxbo5ZyVHZtPDhNUrA2wpaGbYax1rsYMYJe9J2
35924	payment	1397	1397	1678	1	1	13896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSpfawTpm4qsD6xwkNyjXiTDSNR792buLCbFwsy4oCRaBnSrE
35925	payment	2134	2134	1874	1	1	4337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8nY9EEfhBpjpYEqQ78KAJGYNMMfcaXucLJLhixc4vyYQzqjy3
35926	payment	2134	2134	1874	1	1	4338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsr8tHP8FqakGZ2b9FDQMDKtP7XSKpES7pqjzyzCa83UPhxgLV
35936	payment	2134	2134	1874	1	1	4343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnwHATGZs37izsYkL4aS5indKRBrKhvvfUmiPirT12dHzofCF4
35947	payment	1397	1397	1678	1	1	13907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKa8m5sHD8t2nAKCg2W1tDnebsy8uyuUm2kr6253dJbUYqAtPL
35948	payment	1397	1397	1678	1	1	13908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2ZGUrKJiRrbimeHgQS1EjNUBEygWF5VaMTBkNSebQzQLSnbw
35949	payment	2134	2134	1874	1	1	4349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5qA9DsT3rv4izMbi4TDBR6Z9EmqeDgcP6WZyiHJRS3B2mke2
35950	payment	2134	2134	1874	1	1	4350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsiiGCgqtfBjr6QVQdYaYyEyTpXEMJpGT3tGMgTAmXFY9MnisE
35951	payment	1397	1397	1678	1	1	13909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZj7qZs6VhBraxLsafJRTrM6NWMhXNdyXMqVzFsGAeyeJg7Tpw
35952	payment	1397	1397	1678	1	1	13910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNQ7c5pDHqQjMhh3jBZua5TfjKjB3oVjW6zkG54BJDmbZw3Wd
35953	payment	2134	2134	1874	1	1	4351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zzaMTt1qcfxCPZx4u2ei2P2351mQV96LjbKxmxBmg9AVqZ3h
35954	payment	2134	2134	1874	1	1	4352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xkmfhAByzuzxYaXRaLomyKyHcSVsvjFpMoCPqesvdQE6gQRh
35967	payment	1397	1397	1678	1	1	13917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8SmEz1MxksjW1Jm58yssAMZMKkW3GwqQHaKHitAzLwYt9Lya
35968	payment	1397	1397	1678	1	1	13918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5piNLcEKBFw5XJNgB4txKSxyxLicDVbcgMPMzFLgfo5hQd7Ct
35969	payment	2134	2134	1874	1	1	4359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMnwTc1vmt5t8tWTtFgaQgqpKdc6NRQssbsh42PmPZ4XGqdpB
35882	payment	2134	2134	1874	1	1	4316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAatLYs6oQ2qPKngw4TcWqMcQR1BX5dpubHMvLXj9vekgiL3Na
35891	payment	1397	1397	1678	1	1	13880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvFhBQuZQdcFkfuKn5Uh55K8FQY5o1XCmLPhXCXs3CmovMjoJ9
35892	payment	2134	2134	1874	1	1	4321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zPz6xc92iYJcLnidRyyZx7zttvacMZcUoGPYhhaoDvevAZuT
35905	payment	1397	1397	1678	1	1	13887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6gqJwgZkHWDt38iqgiyoxcUC4Cjgz2Nc2GAz1ZY5CrXLzZaQ
35906	payment	2134	2134	1874	1	1	4328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLMLS2C7RLGZEnmPA1xrxQUaEqUw64JQE3hyukhjbsvK3WXrJ
35913	payment	1474	1474	2305	1	1	27	195000000000	10000000	\N	E4YttBNNay2NVjheVArEr4evBnsdSS5HWBjFihYmGA9xeJ9Wy24E7	CkpZk7J9iUNYaJr7LDpWgVKhhKhuwTXkTqa55HsSHcrFDnrEu4yba
35914	payment	1397	1397	1678	1	1	13891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49ZxySZFXHAZk4HqioZFUmGvVhvXxfgqbFX3ML5dmWJELt85s
35915	payment	1397	1397	1678	1	1	13892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNvvaPiw2rBLNS9hsw5rji9vU4JxFCXKq73s6T8iHAkjQwQU7
35916	payment	2134	2134	1874	1	1	4332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvrFT3YnaEpZxDGJZtmkvCfV4AtSTve1tSySemTySfhWy2LJ6
35917	payment	2134	2134	1874	1	1	4333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkrEvMAMEbcCxFWt3MHsEaoGQcP17mTXxpGcvTdGDruDYKT2C
35918	payment	1397	1397	1678	1	1	13893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeorgy8SBLtfSCWNccDRoq6Cc11eFzJsB3SEkqPzpYjJePM4uu
35919	payment	2134	2134	1874	1	1	4334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxEjaY3qzsDaWpeaJwjUqk6ajfrtAhi5t9aXMtC2mAAjrgCWf
35927	payment	1397	1397	1678	1	1	13897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDuXsaMXWiQ97pBEFEwTE6xGgsMiZPeDuSRAxu641pq6HLvnB
35928	payment	2134	2134	1874	1	1	4339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJRvUqmpdx5ggXHh8ycpYpCYGPm4jZ77LxHyxvXRNdWGUEViA
35937	payment	1397	1397	1678	1	1	13902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutuKp6tfKSwi1t5Cjj7ZJJsiuLUXpoMPeNDKhWtEugPkQTn8q
35938	payment	2134	2134	1874	1	1	4344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88iervuZyX9wGVwaMo3J4rT7JuuPETXcHy8jPCgfbQhzZ5Lxr
35957	payment	1397	1397	1678	1	1	13912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1F78MqF6yqdUAPoeFERgkNeGutWkBVL7Pu6nR5xuTJfC8KbW
35958	payment	2134	2134	1874	1	1	4354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTuGwXAoxwKKN5GRUDKNsmfHiasJ8Sfdf99jAneVm79S3sZ5S
35964	payment	2134	2134	1874	1	1	4357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZViVGMHLP9fpYSmo9pCJKfgapXPGcf4aF5kty8ge33yqA8v5Tg
35971	payment	1397	1397	1678	1	1	13919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi43thyvsY4L1PCRWq5nz45KCFozGmxnhd7B9fotryYaK9xwK7
35972	payment	2134	2134	1874	1	1	4361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa7bnyPo8Bkg1zRVPBQ1pVSgnCp6sfM1EJ9VeC3Fx3LJ4HwJvk
35983	payment	1397	1397	1678	1	1	13925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPyNEwFMfCEtw3xhiYXRWQaHbA4HbsPJYHDMC7mZc1WJL8vkc
35984	payment	1397	1397	1678	1	1	13926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5s4TdVbkS265ifmh185RLDpuvftvGPr51fK9CVNvdMhAi4QLT
35985	payment	2134	2134	1874	1	1	4367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYyLjNX2gAPCcpEcFT75NVvrNJ9nsHNzBkVSUknZdZwSLsEXB
35986	payment	2134	2134	1874	1	1	4368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRt6HT4iHWCxjbNGkyvZZMk9Fk3QQPPLUJSSximUt6XgFc6Vs
35989	payment	1397	1397	1678	1	1	13928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQyA3EXhbrSRBK7owUvbqZfQBQpYhgYkdYU8vS8f2Vf5UBzJCC
35990	payment	2134	2134	1874	1	1	4370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GCMu3HtLL7s1A4xviM1eMYyP1vSmNK1HcmzcE2EmmSJTQHjK
35991	payment	1397	1397	1678	1	1	13929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1UGNane5X4JvgvQ13VZqiFVWwicJokxKPyKwJV4zuaWpG9zQ
35992	payment	2134	2134	1874	1	1	4371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JbPdThnp8gxZnjXhLh8iWjEFcT5MSYuorB2fUS46cEsaKYE3
36005	payment	1397	1397	1678	1	1	13936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xuu6aE1qWR19wjBSTnbSUGdrrYiKkHy8qHtxFfc8igJwcS2Q
36006	payment	1397	1397	1678	1	1	13937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GvKSt8xRJmxWdppJ7WHx7PmUeyVjr1crNvzXADMZE4HeosB7
36007	payment	2134	2134	1874	1	1	4378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ738k3PMJf3tw9LDityfUDBJ4mL2ErVHZUZUCDfDjU3b6qjpm1
36008	payment	2134	2134	1874	1	1	4379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BxQRaomUgtsX6DJgfa5YZ2UKiHUK8Ndp63xkn59bf9sbqK9P
36024	payment	1397	1397	1678	1	1	13945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvGtPpXWiHbEBHizWB1F2C4FxKqY5s66VnZJNFjHgdvHRY2FP7
36025	payment	2134	2134	1874	1	1	4387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCxjy69wNUPMuiQvUj1nLXrztYBaL8NGshGg6P9sJtMpF6v2X
36032	payment	1397	1397	1678	1	1	13949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAWMCawfrBfX93LJvba5KoL1kd1iSd3EHYrCia61KyLcJ45g3
36038	payment	1397	1397	1678	1	1	13952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFNGTEUpGFpxTHQNfK1mVFGHoCkLUQCtJaX5LaUvcwrTQzSUS
36039	payment	2134	2134	1874	1	1	4394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFW7JG3XigYZAUPcxDVvQWZ1bqfwnYK7cVWJLnjJuBJuGjh1B
35970	payment	2134	2134	1874	1	1	4360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRscbLdMYuDQAzn9GNHLTkJtGKFnB5RHFhebTxiE1X5kfc5xK
35987	payment	1397	1397	1678	1	1	13927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cQYyqte44Aoy2cnudKgp6F8csbWLCsTZgcBf6C8mEfP5HBQN
35988	payment	2134	2134	1874	1	1	4369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJx7ZHGHs6ADQiHNWTuSCtaSqmZaH2iYYDNskFTKLEqw2fKCfP
35995	payment	1397	1397	1678	1	1	13931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZKbUNZumtzAmcGdGfj8HN7mE7C83b5epTzanmdgfBM4jbbaE
35996	payment	2134	2134	1874	1	1	4373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKxr4ijpwGcjvrTCduiQYir4Jgoc9oGZx8Lgh4GzsgGfVVDnnG
35997	payment	1397	1397	1678	1	1	13932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCbWFdX6PvZ5cfksrpQHttF6G2VAXDJQUyMvcWg15D3ATXiBW
35998	payment	1397	1397	1678	1	1	13933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEro8Mde5fQZQyFrhEhEpTD4c8YELCdAsR3vmjr1RzeDKEGx7k
35999	payment	1397	1397	1678	1	1	13934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkyfsnS9iP1DHiNcGsWMJaHpSPKB6w7rReWsqDBXFjayafooA
36000	payment	1397	1397	1678	1	1	13935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6EycfFHEHsc8Nmh3YpFwHn3UsGCaNPZEKyttD7xMZNoBJnv8
36001	payment	2134	2134	1874	1	1	4374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfVHLRQKkvfEpzZjdZdUT1b2wUEiHfUawcji1oqJhD4jGaiFN
36002	payment	2134	2134	1874	1	1	4375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8Xp5PizBFHP3iVZTPPGHRQnBfynCC9jYkGct2SfuuLK5Hrdq
36003	payment	2134	2134	1874	1	1	4376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3CTtujCyLrDSRWS4S51wvSkLJnqJoppmo79xspVV21sMaM6K
36004	payment	2134	2134	1874	1	1	4377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqYMtp2eW3gvbpoydWGfDhKg2qeYBbCmP6eHRuVMNJpfDNPmg
36015	payment	1397	1397	1678	1	1	13941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxFBzQ6Q1ygxrniou5Ncx2jz44NETYtkPv6moSLomKkwrmWSS
36016	payment	1397	1397	1678	1	1	13942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfWBQFBBQrasue4asj3S5VkSsjzu9JuELnRPL1VyPMRF4UXUj
36017	payment	2134	2134	1874	1	1	4383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZSEacfvE1aTkFD8e8EALb6BPVnTf7jKMCJuqTxTJKPiuajhE
36018	payment	2134	2134	1874	1	1	4384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxV4rGZeVLHjdSMuk8NHW7yYwKdxoa5mGW1BVQZx5WB58Dtpqs
36019	payment	1397	1397	1678	1	1	13943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxmqiS9fbtvfcMYwULB5NQUtsx84FiujYbzk59959k7M8Raw3M
36020	payment	2134	2134	1874	1	1	4385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hiJ1P7Q8p2BvB6u8JCnqbDRMibcZeBjVVG23wR3CzkczRoZE
36034	payment	1397	1397	1678	1	1	13950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJzo7K6ctbNiiJdRknKV1YcGM7h1he9krwtEhTE7ihgL6ZHxc
36035	payment	2134	2134	1874	1	1	4392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyF2yRU4npRThpXQQZ5bXiMaRPZrfwhd8PUfPzFzXxwC4d5Qv
36050	payment	1397	1397	1678	1	1	13958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEki11y6G1Jt5gSSs9WSmnMJyBm1bxJc22hgbmtdUfR5672oT5
36051	payment	2133	2133	1874	1	1	4185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm1w3Qws82AViz3r9N8eLZEKfLsDcS7Qk55KQF8wWJMGApsKGt
36052	payment	2134	2134	1874	1	1	4400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRHrFeZp7asXw7riTwBtfov5336jnaRwRmWqRbEAVKP4pHQ5d
36056	payment	1397	1397	1678	1	1	13960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSn75uQ8t2NrsEJ4zeg2uoQtDxzN4R5ao8eRWX5TsfCFq17wR
36057	payment	1397	1397	1678	1	1	13961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzdBaRSAdng1FvTGCvJSd18bsdRcQT2eLBNwLGyezVM8GTK61
36058	payment	1397	1397	1678	1	1	13962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRUjxJYc36VK3wUuQbp6k5zEYYwb6dNbvGaCPkz4kPQj2gXx9L
36059	payment	2134	2134	1874	1	1	4402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMbRV4iBwFLxYGC8v5D8PbdBpUmaXE7DQQB1iXefdzjFPirez
36060	payment	2134	2134	1874	1	1	4403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRKAzTtJqreDGdRk7dF6sQbGNR5EwnXpirRhQeFtWBG7okUkm
36061	payment	2133	2133	1874	1	1	4187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoRz3tgvwvK1MnJJn5CGVN8bYbAspSsHqvnqrtFKtffBeLbtK
36062	payment	2133	2133	1874	1	1	4188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mf19SpcrsuN31dGEV2xVdanGBPDNJWXQgu6eJ6E4THTMaa2m
36063	payment	2134	2134	1874	1	1	4404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrrRGFfjtoAWP76YGDcQfBWSEEB1Lyg5K6Fh3SEs889ocNZwE
36064	payment	2133	2133	1874	1	1	4189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7w4iBjaSPrVrTyKHPT2nqnxyUXcEnoMEebXpwkeL2JMJYpXZw
36104	payment	1397	1397	1678	1	1	13975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKnRrjQJoTJAYUyAv2A9wVqzAuWuu9onG3CJs6mFB3MQCYDMJ
36105	payment	2132	2132	1874	1	1	1224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyJjSDnEWkJ8r7NaxbShBwzdcyXa8YVMVP5bMJihNMv66XdVp
36106	payment	2133	2133	1874	1	1	4202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9KJ7z2bJSUcsg5mBnnSYfhFAGJ58mNtCsrRtsaD5YxgepBFD
36117	payment	1397	1397	1678	1	1	13979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ULsniWACHE3pPwXFBAAE3ygGF4jj5VMhDhyme4yynHAditmc
36118	payment	2133	2133	1874	1	1	4206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGk8GYU75QMLyx6w8iBrkLWpGB7DMeatv3GC6J4HauQ5Y8gdPJ
35977	payment	1397	1397	1678	1	1	13924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuNQ7ox5ac2vbjbTqZwAFy4MJ1xvNziScivWDxWhXHaUVGsFwx
35978	payment	2134	2134	1874	1	1	4362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvUh7nLJhFeLCpfRnnsPeSyoKRRnSzr7PAtxP56e4hCLXW8af
35979	payment	2134	2134	1874	1	1	4363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJ92LFAq6pVH8oQZ4bszuMGPHcQyDuvSp2cYV4Qf3XubVty6J
35980	payment	2134	2134	1874	1	1	4364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzY5C4QRskRg76vzbS4PSMSGqdgDDNnvT2SeBoKs1zAUM5KXZQ
35981	payment	2134	2134	1874	1	1	4365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa33yqQy9H6Dn3NJ5oXmzjXRREyf14cosX57xHRasYeYXZK2Zz
35982	payment	2134	2134	1874	1	1	4366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82cDoYN35ta5mgbWTNnvG41YsQfPswV3JPk1SrmKcxiz3xKDF
35993	payment	1397	1397	1678	1	1	13930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKt1dba6jpSPFJg5g3yFL6CS7xZaQLUcwxLzUfkx6cbvf27qFW
35994	payment	2134	2134	1874	1	1	4372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JHoBzFJ7wGdCpa9SWzd1FFpHvYouwMygeU7GjgayPYPQChuF
36009	payment	1397	1397	1678	1	1	13938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkrdfrokAzzcU8iANiHANb15P2dC1YtHKHQkPpXa4N58cRdwu
36010	payment	2134	2134	1874	1	1	4380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCP7zMsYMK5PajKvvz5Vu8mH6takC1auY5tf3R45N1XjiJupzz
36011	payment	1397	1397	1678	1	1	13939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXaZvjExw98CHoaHHCACyE6UkTt9fcPL1FMyeqWhB4r5WJpvaB
36012	payment	2134	2134	1874	1	1	4381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVnf9oQA3odYUVwbUhn3i3RXjPKSR1Mdrg9NJCZp9KfBDAT3d
36033	payment	2134	2134	1874	1	1	4391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8ynStELAGZdmeDwKBeHYs4usrEwKHDbPH4BZZLeXXoJbjTHE
36036	payment	1397	1397	1678	1	1	13951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqgfeM17HBwRWDZ7v5V18JhxSnqGmJeivCS8LfXka1eTsKJv5
36037	payment	2134	2134	1874	1	1	4393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLoVTuAMxMY5Y8PJrBdAxD7fGaWaMwAkVCaNwgXrQEoJ7i1zQ
36042	payment	1397	1397	1678	1	1	13954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2yTFByrU8xmpfhXp2LVTanfMtHxsyQj34HYk8VqYq8oFnM7s
36043	payment	2134	2134	1874	1	1	4396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSudBKwhCDMomjn1uPFvBeTu9JGf4fW5bNwigvGhy8RBCSPgnF
36044	payment	1397	1397	1678	1	1	13955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4hkTriiX8GgAyMHep7kR7Vhfkkxc6GWJYu98scajDZMW8MCe
36045	payment	2134	2134	1874	1	1	4397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gTWGPXb6NbztjMC2owshp4RY4ocsRwPGQGH81At1oDQhyofy
36053	payment	1397	1397	1678	1	1	13959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw17kGgemT8jWmfFLZmBBX4Jpa7FeECTJujppoJ5938rb9J7y2
36054	payment	2133	2133	1874	1	1	4186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesKDvsZcFDX4KoksFXv1chjvQsM4vD2aRcxk54MZhf2wK8EJ9
36055	payment	2134	2134	1874	1	1	4401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4p3p2k5y94jnymvYxNqgkUsqo84WauCWhMpc7LbPahinC8w3
36075	payment	1397	1397	1678	1	1	13966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVCb4Cun9MQkbZZxZfoJbWVRuxcBLNXykVWPviLMqmTvTqRHh
36076	payment	2133	2133	1874	1	1	4193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W1X1D8rva7XnbJg31dbQjxrimSbbwijS2ZLDcLTf7g35H7tx
36077	payment	2134	2134	1874	1	1	4408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5t3puV7WY8DwVSULAot2DKMKA6vPii9YGEkQzSZkfLJPDk8L
36078	payment	1397	1397	1678	1	1	13967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERTMMgr1uNoevzTPXhXrUiQzFKTjp5zyouiAvW5nodKvcbzJx
36079	payment	2134	2134	1874	1	1	4409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPLWNBF9AofFFXfxwzYNtTvR1riqLqw3smYXL9rS3akmakzbL
36080	payment	2133	2133	1874	1	1	4194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttiCnPzTjFimhkWc8D5MfX3K4TeXB2PHcKXGEAbWVjePdW2sL
36088	payment	1397	1397	1678	1	1	13970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFNEY9BJ8NxVWiTPn9nEBfoSzB5tDuJ7jt1DV1L4JxsscBDpW
36089	payment	2133	2133	1874	1	1	4197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8neChHaaXfgxWWBpmR6SCaa2HewuURZGAMuN99LdGzgPD3oa
36090	payment	2134	2134	1874	1	1	4412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA2mqGpCbbxLtDcmwCaV7yEbzgZGaHB8bqvmuPijWgBYdG9DDH
36101	payment	1397	1397	1678	1	1	13974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFiQa3fz9uww9FLkPMK6BrCgAQFT5AMys31ozbiWMUfDTnRRBy
36102	payment	2133	2133	1874	1	1	4201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Wp4CmxqwbupX4GdeFqzUzCbCfQ9P1XxqKSQuohncHgvu7Pan
36103	payment	2134	2134	1874	1	1	4416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBUFGPHE3JfNVeyW962Afmy4T5BySyo7iraznxxzjz5aGc7Gom
36113	payment	1397	1397	1678	1	1	13978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgj4s8fnckC35LaqD8XUCMTW79gf1KM753hf5ejau9jVX47fr
36114	payment	2133	2133	1874	1	1	4205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sFEEBdfkAzzmB7MQ5zC5nPTqn6ocNbRQi9ZAkjL7DVpT9m5k
36115	payment	2134	2134	1874	1	1	4419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8r3NbnsQAfe7j5ZKq63d8gbo3VPfEitjVpYN2CzurY6voxaf9
36116	payment	2132	2132	1874	1	1	1225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwESiny9CsagNWSNoAierrnuPZE3MDwrD4y7DC9fkXbfiZwmg
36031	payment	2134	2134	1874	1	1	4390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVxtM8y6Huidpc5M7q8ezyir1CUhADoqpWua6Dn7UPSG9KUN8
36040	payment	1397	1397	1678	1	1	13953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv25JBNGnhXmBRnK5WuTP8Dash4P9XY7Du9qpgrB9cy2JpLuaa
36041	payment	2134	2134	1874	1	1	4395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKnkR9u7xFGCjpTLgwbxnka8FXT48t1LxBEqHakqiniZt2uuL
36048	payment	1397	1397	1678	1	1	13957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBTxuxM3ZB26syh5ZbjoEoGJEQfLCd6cZtWQZ7Qku7Ff9KRCj
36049	payment	2134	2134	1874	1	1	4399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9JVfaCqnS2GhiUjpwBuGBXekdPVLMDsSGHyJsCjugJqUpxRY
36071	payment	1397	1397	1678	1	1	13965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmACwJvqjV3hVRf6FQPyEwrEFTHUNd469QLVXt7NuDL9QFuHZ
36072	payment	2132	2132	1874	1	1	1221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXE7FAkH989MvYjA5XJPrrQ6JVbzqvywwNaBA4Qrf4atbuTq9
36073	payment	2133	2133	1874	1	1	4192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GfSpM2o1yypuNrBKDYrdb1qfcE9LpDojetcgyDF2WYrt1cSh
36074	payment	2134	2134	1874	1	1	4407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVW7fXAN3nvgVvHSN7U4hYh6kddN5GHAEbX61Abs8oohgWwkH
36081	payment	1397	1397	1678	1	1	13968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVajyaSPH45KvnvsohzQghKpx1pgsfD1ToTFRfChz8PCaBrUZi
36082	payment	2134	2134	1874	1	1	4410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiF4eQwzy3zKdyVQ3iuHythLkVVFPDzfDeHVNugER6EKvejmA
36083	payment	2133	2133	1874	1	1	4195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZarSp6tVoQirhUnRq83GK3pfS5fE3ZRdNFVeAoLrA9Y7C5kcYH
36084	payment	2132	2132	1874	1	1	1222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MgTSmXW91tSxnVoiMYtbgensMQFkBSTsGZxo6oGLq272Z2qT
36107	payment	1397	1397	1678	1	1	13976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AcNttCaEDpDTPR46MG6C9eN7gS6LyD7pxxSZDvmzDNb7nxi1
36108	payment	1397	1397	1678	1	1	13977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9PM6B1dvfh4T2pqDZW1K8QiKvcn7kvAUMs7FcCHcvWbPEevi
36109	payment	2133	2133	1874	1	1	4203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGrSrbqhBWTstJ2VcXzmvSDzTQ7L3yXktM8Ah959siKH9jf7a
36110	payment	2133	2133	1874	1	1	4204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg9MCtbHAT5nQyKNB4HH6BzfrrTyakU18sL1AgUPjvP8cYfDf5
36111	payment	2134	2134	1874	1	1	4417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7o5huDWgbe5NvbVWrVq6ALyV2y58eVuijgfC6mWsK9P2MTTiJ
36112	payment	2134	2134	1874	1	1	4418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRpGy8uDdmN4pKW4qhHrk2J56XeoiV8EkQEwX8jZ6fS2xUtmd
36120	payment	1397	1397	1678	1	1	13980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQ1rG19tiWxTbFhHtDbRqStMTyptf6ZFt5PNpjb1aR4crH46c
36121	payment	1397	1397	1678	1	1	13981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZUQQraVAeQE5u2RygJ3wsuJwPE6yRR8bA4FwNWNcZo1UPm1iv
36122	payment	2133	2133	1874	1	1	4207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeckoH6yt5MGn8t6pAgPB8D86xr2cAztApDR2VnLVuDFhq2Dpw
36123	payment	2134	2134	1874	1	1	4421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXPMKxDYJfMEoWScot4CgPUPjmX5q9t6UXTzZu2dF8A1bgpVE
36124	payment	2134	2134	1874	1	1	4422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrvrDdnfDkCx5nqMoVhokacR4aagJBrGqCUmPcx5CjRWD8VFY
36125	payment	2133	2133	1874	1	1	4208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8oZhZRUhLfwcR1c6xRt9ojVWBUGtdWFed1BnFu1PzPYeLumpu
36130	payment	1397	1397	1678	1	1	13983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXfH6zvqqeZUdYrHaoyTpUyrx29w4JZCcrY7uc7tGC3zWhqwp
36131	payment	2133	2133	1874	1	1	4210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqR1Kntzkamn6VrD7UEAkZx8GPPhx58Xxy1c52ok4hCTcBRkD
36132	payment	2134	2134	1874	1	1	4424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2e62TCptzDN4jibWaDE1zpqimQE8hJqKZrk8mhmwSJJCpEQq
36140	payment	1397	1397	1678	1	1	13986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QMsjctG3GDHtByQfgCnugBZ8U2C5sg9Me8QAjaqS5EW3NEvd
36141	payment	2133	2133	1874	1	1	4213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgR82ybxbTLgc7sUhWBBQTYvTrsnj1mxrF1NRrPdGPwaxNZGM
36142	payment	2134	2134	1874	1	1	4427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4u9JQARxwCVwKJxnEnk5Gnh6hiKEXmuvFUzC3FswEzkDgQnA6
36143	payment	1397	1397	1678	1	1	13987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDaDQzWP5fukgEr8fSrc8sn9y4d7DLNouoXqYF5BCWDKwM9VN
36144	payment	2133	2133	1874	1	1	4214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZidMjwb1ngUuDW1vF5JpocMjLDREHPUzgf9F6DQRjagv1e6y
36145	payment	2134	2134	1874	1	1	4428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuzr7TncUiKhmexijJri92Wo9wAx893RRcjbTkgWxaSGr6qFEX
36155	payment	1397	1397	1678	1	1	13990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZY2NVhGoNwpAdC8snb5DcpKy3VA5Kb5MkaSZ2bfmGc9GiBzW
36156	payment	2134	2134	1874	1	1	4432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqorWo5ToN14ZTQJska286q3FhxE8d42tp9MVr8kDZeuUdey5
36157	payment	2133	2133	1874	1	1	4218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWGm2hibJ5UNNqHu9cDDzZvS9GcUMHsgrJBWzkwJge5PbYivx
36172	payment	1397	1397	1678	1	1	13995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmU98dNcfh2kBKXjrmPdvSVQ8Wdu3nHynYttpxHueBkM6r2nBq
36046	payment	1397	1397	1678	1	1	13956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfV2TaYe8KNg7xg6jcDjn68nZevpoJg3pYjMStvWyuDZn9fpX2
36047	payment	2134	2134	1874	1	1	4398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7zQ6cRWWy1m8mHBBDNS57Wi69eTJvASb5x4yrBo6HCyftQZi
36065	payment	1397	1397	1678	1	1	13963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4J8YRMgiJryr7kszGnQRKUa9XC12dFusDesZhrdPNqbjLY8i
36066	payment	1397	1397	1678	1	1	13964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKMo8VnPSYqbJ1kbrUpT1RvuCkegUCVwqpR5diErfFGDMYtBm
36067	payment	2134	2134	1874	1	1	4405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bNCVZkD3apNFgBNYhnMauxVvhNeF5nJm5jux185zBtqJgKzh
36068	payment	2134	2134	1874	1	1	4406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVGxvEV92wdSBZGxwh7mBuDCBRx1EAusqWsR7nu4kpWiJgQQv
36069	payment	2133	2133	1874	1	1	4190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78moDQKWPRDqARk16yfhPXxDdFNUnD9Z17kjRBLpmrVdXM9gq
36070	payment	2133	2133	1874	1	1	4191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZun68CLqcSYw4Bo6gVnx9weqD3NJhiyLEpfNg1cJ9AWFfxwPJM
36085	payment	1397	1397	1678	1	1	13969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFjmGSooPXkugHfGfBKt7dogabjVdWuZhnB5JGncRJhHnjNmp
36086	payment	2133	2133	1874	1	1	4196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUKfBJuKSX4yxVQHUTfZb29tr3xHXc4pKTdCFpajYAxe7Nfbp
36087	payment	2134	2134	1874	1	1	4411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9CqGWoPt6E6tkTEUQKJQMBWP7qEnnuDwCmm73iHm6Gie4E2t
36091	payment	1397	1397	1678	1	1	13971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YSQzid9Gka52bQBDyM8zHaMPfoMPA5mBLzaCTbMSYSSfT4WD
36092	payment	1397	1397	1678	1	1	13972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vyJYbezmM1iNwNrsbw75jHULFKEpZSmm2JgSS4xn5kGviSVt
36093	payment	1397	1397	1678	1	1	13973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJm1BzGPAp2UxK7UvLagXMbrUj6kmmRqnUpvib9J24hv9vaVc6
36094	payment	2134	2134	1874	1	1	4413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg2XpJLQBtCq92wmEU7iR8CXQzZPoE8kANLKz21BdCiu76zTm9
36095	payment	2134	2134	1874	1	1	4414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXVHZsnaVR5vEBegdHPymy4QnXhZXJ9MFB8UUv3UJnyJzrk1c
36096	payment	2132	2132	1874	1	1	1223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5VpXAiHKCxVbGZkgKs8UgqLYYnmQNEZmNJHCfLJsd8h2sfEN
36097	payment	2133	2133	1874	1	1	4198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYug3XCVEaKaTAeZERapgjtA4CGKh4Ns93XRSEmdyMu8XTis6c
36098	payment	2133	2133	1874	1	1	4199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpPEq9rMLG7RghEY3ztbC772agfuMdbnABLkjWQ2KMUbdaq3j
36099	payment	2134	2134	1874	1	1	4415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfsxGQP7atQoQUZNqRFqC64UJHiaRBAkBjokVYtWpGJjmRQyb
36100	payment	2133	2133	1874	1	1	4200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6PpJSJJ9oujLdq9DPcVuvqNxTE37urnxhsMXWDEfS2gMuzSC
36151	payment	1397	1397	1678	1	1	13989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJEugHeG7WcqmYNq9ZbN3qEYnE6S7zpKtLsZ8T9oA7gFrKXSX
36152	payment	2134	2134	1874	1	1	4431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwdSReYFsDUDigdj4JJFvDepJGWGUi4z7FCPqyTEHfNMBba9F
36153	payment	2133	2133	1874	1	1	4216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkphdRbTFzYMzsfSbXsZpqnswM5v5LUAuZ9GChrfwfQx72tnE
36154	payment	2133	2133	1874	1	1	4217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6E4h4cZwo8SBS8QGVodhEaipfAoAooYdeHG9AnmVWeuDQoHH
36162	payment	1397	1397	1678	1	1	13992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurkfoazRjm5ayBYiCkg5JY4YUYcbNHWdKmm5cqUzA9mBygbbY
36163	payment	1397	1397	1678	1	1	13993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrqeFT4mTALWFqaWKovtjUQmUMwUvjqMhndcYWr3MZoDCvQi5
36164	payment	1397	1397	1678	1	1	13994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyXje3H6wmio8ooS5fGUTpBV7dHdgX9ni4fsnGUReJ4QSzJNC
36165	payment	2134	2134	1874	1	1	4434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoaErR42f8BQteiLC62hKFHFbTeyB8Eyrjv38DyZqtavbrk9U
36166	payment	2134	2134	1874	1	1	4435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHr2yYgVXnLh8gbEMrfXKkfeq6KuiX3eZbFYEzKBVSsNr8tfS
36167	payment	2134	2134	1874	1	1	4436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9MWWhyi3RNVqtATwG2BNxcrXPwfNg55h4kmR5QzQVy17LdMmF
36168	payment	2133	2133	1874	1	1	4220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZboi4hosvzaojacHv8WKXTa19LdecCGM1oFTdkRVRScyako6tc
36169	payment	2133	2133	1874	1	1	4221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM7a8f9y1qz9KwpCAFau5Q1QBBZYh9phP2AcJLkmu8R4ZkUimD
36170	payment	2133	2133	1874	1	1	4222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiR3NEkKBLJ8pTycbMBHUgmF5fpDQFGyBkMVgcutbniCShsxm
36171	payment	2132	2132	1874	1	1	1230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9rptnQqqWei1vZC1b68vWyD3uoQMcufMz6hmytXsojt55YbT
36175	payment	1397	1397	1678	1	1	13996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRRB3Rp7dMrYgH5GXYVrFWByoPKKZHX2cLt6ZytHMqYh8Dwfuz
36176	payment	2133	2133	1874	1	1	4224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QEG3HWeyfjjgHWGAHtCo6meEKC4qfDneErJkPgqgJ4ENqqG3
36177	payment	2134	2134	1874	1	1	4438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjBtmDXKc7kuoC8ka6Fsg6oTysJZ6jc6h6L7zUKpBCqgXeN4i
36119	payment	2134	2134	1874	1	1	4420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9X7y5Sf7eZiUWqN7csRNgbSeQmZYgMCEV8M2rRHQfTUerG6d
36126	payment	1397	1397	1678	1	1	13982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSySKf2GnwSdskmjSrubHVvrP4VRz6a5BEoaojMpHew9TLXg2Q
36127	payment	2133	2133	1874	1	1	4209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuX1kAqUfRQ7Vj3QQvPYEVufKVDXZnaS6qsyYEFL2SMRxM1i6
36128	payment	2134	2134	1874	1	1	4423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAoGTkTZKCnLigjcG3f8UhSZJemXpyTmuxdVARZGknK4DGgoHk
36129	payment	2132	2132	1874	1	1	1226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAYVMHLgW8ofmFcc3XCTDk8Dc5vAM4mbMok2smuCf2dtuJqKx
36146	payment	1397	1397	1678	1	1	13988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDhzLGgrcxGnkmfw9dTKALPJgMmJnAj3iK5FXdRm3A53TmFad
36147	payment	2133	2133	1874	1	1	4215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbPB2953BJaNU6QMfGe3pS7TRBD1FvcZGr4XEYUc3HN92WLL4
36148	payment	2132	2132	1874	1	1	1228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnZpvBDp3CLKFmAXamJUNRMKRruHB91Kr2PdgwV7RuRt2YYYx
36149	payment	2134	2134	1874	1	1	4429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmLcsBtP2yWGqWAYPcWD6w9pxZJpg3HQo5DapyR3jgqmE7n92
36158	payment	1397	1397	1678	1	1	13991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVWSeng4V4Voqdmko7P3uRAT5DqXPAm1V1RNB3yiejyCkXpHs
36159	payment	2132	2132	1874	1	1	1229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaz4d4jffLAupRZ1qLMbmDSEuSRz88PnQrh23AM4La4pD4iXXi
36160	payment	2133	2133	1874	1	1	4219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ub9pvAdcUWbmemF67vyAAjUizwHpSixA9y9CnsKufLtywx94
36161	payment	2134	2134	1874	1	1	4433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7PxgbgX9RuU2YC3CNpBsZqP71hxk1me2NJWrEYrw4ak3yKBt6
36196	payment	1397	1397	1678	1	1	14001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2EBgSoPc47XknGbsiLTjpX7mp2BZXrHj4kPujVd7oR1zz9c4t
36197	payment	2134	2134	1874	1	1	4443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiFkg4z96YypMBvN4miK6WKhsW4CL4nd8919hfLQ4ksTXDchu
36198	payment	2133	2133	1874	1	1	4229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9fAHW8rAdAgcq3faWTByi7kcn2hTu8XPAcHRHvZvLkez6gZw
36199	payment	2132	2132	1874	1	1	1232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRu4DU7JWT1NF5eWL6o7V1MXBoVVwZG6YYGd882yC69ViJ7ah6
36200	payment	1397	1397	1678	1	1	14002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGGEcCPkyxYW8hJrH1iEEf8BvH74CoAQjwQM1Zb98ui7D2DjJ7
36201	payment	2133	2133	1874	1	1	4230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRBFwJd5GFQGMk41jJY8maw2XRVg7DLoKZeXZ856RNpM7pxNvG
36202	payment	2134	2134	1874	1	1	4444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPmwAAyk6RiPK4DcjFuoxJKZ2FAJKRfFx89Br8gMaf7XZ2fcR
36225	payment	1397	1397	1678	1	1	14009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8H3GZZLhwLSPs25P8uL2nCrunyUtKWci2gQTmJh9H6wF73LWi
36226	payment	2134	2134	1874	1	1	4451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7Zhm3WCivWcNu5JSQtxKFT69Dw4thvS5UXdxByabLMqMhbvv
36227	payment	2133	2133	1874	1	1	4237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jdMgKpM6Yhrja9ZcsxSZNR7aFhNvsFj4cxKsEz4He4Cs3Ch5
36263	payment	1397	1397	1678	1	1	14020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSUebhDiYfsEDKB2VXiLKPBWsWVMDvYRBvDwX16FbYjRyXqX17
36264	payment	2132	2132	1874	1	1	1238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3kXMC7iEYYMoDoWFm9qMUzX9NXFSS4m7EtPGtTvksriyv1y2p
36265	payment	2133	2133	1874	1	1	4249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1o7YuSGqHMokXR9wTH3xBBhhdg2kBJyBK8DuaZ9f1MP2UDv5
36266	payment	2134	2134	1874	1	1	4463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykvsY88AUGRzkqYiBofKbBd7hyz5x6vd6eDJbD4DgeryPni2S
36267	payment	2106	2106	1448	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdqNRT2UwvxVeqdFASrcScuieMV1H49F34DTxtV4RyQWiQ958R
36268	payment	1397	1397	1678	1	1	14021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuB78ke2ncaKpVVjDMrfVbTTfkzdEhg1fhgYYyXSCuyhHQE7N
36269	payment	2133	2133	1874	1	1	4250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uBtY4MXYyCzK8dYVso35Fymh2i9jusrXWZgbqHHtuVvAREar
36270	payment	2134	2134	1874	1	1	4464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC6jMiPG53XNuRECz86BYpr7FkjSLGzqeXamC5ktidnLW4CGHt
36291	payment	1448	1448	449	1	1	15	212000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfgBir45SY9qXXLKn3Vb8rm2aEgpqgTsVsGY7mVihfm4EE2ZAX
36292	payment	1397	1397	1678	1	1	14028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyop8W7HF3tgc6AiBr4eHvNsJLoAmPDi9GjL3gP4jL2yCJieM
36293	payment	2133	2133	1874	1	1	4257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEiFDgny5EDvmod4S3gJPBMGpZ2FtwoXFjsLagLA1V4XonFnM
36294	payment	2134	2134	1874	1	1	4470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2H1Za9qZqQUJLuNpyBeAqSTVe55uRMoVxzKrbZ2xWPwpB1gs
36295	payment	1397	1397	1678	1	1	14029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBFGgaGbUsLWLK61svySBrw5vu7N4mjYcRV6mf8LAhgXBM4Xo
36296	payment	2133	2133	1874	1	1	4258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXq7RCiNnL5ZPbFFBZqWaF58KHVa4mY95yhG3hQfNgQXC7kmY
36297	payment	2134	2134	1874	1	1	4471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11KGanAu1DvgoeVUXCAYXSn3QUvArV4h1kCF19AqGCe2CFZnS
36133	payment	1397	1397	1678	1	1	13984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMEMd8x7q2XoxCw9z5wR4TW5agpry3apR8NdSe9pp1GHnwMSX
36134	payment	1397	1397	1678	1	1	13985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkHP93WKB8hwK3NQBNi9cf6p3BiyYmfWGQxx7ngKqd2mv6QCM
36135	payment	2132	2132	1874	1	1	1227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiVCHgvgG4r7ZUdcJ4xmWWcaKR4h3Zi7Aa8Rkwkkrq1hv7FY1
36136	payment	2134	2134	1874	1	1	4425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsNGTtDVc2cSCUuGNRDdN7CDz7wXdCZak93n3tqd2SoyDCS2Zf
36137	payment	2133	2133	1874	1	1	4211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzKWpo2yCdi5sooT3akTZQVMqfMZ8T8xbUkgBBiLgd5MDaTaL
36138	payment	2133	2133	1874	1	1	4212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3UXrRkA69CpY9BKGqnNHFCVUNykrzrgZLduvPbxrTUxi1BrH
36139	payment	2134	2134	1874	1	1	4426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJLrU744NpgaLFsXQoHx7dDSZaR42VzYk5VNmsi4DA4xcgqw1
36150	payment	2134	2134	1874	1	1	4430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjquxTL3VLGwRep68qX476YNSUJF4SSVYgTnBkFB7WsvWn45Gh
36235	payment	1397	1397	1678	1	1	14012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzWi3TecuHrPeJMDAYWADaFpiP2Pm7doXekQvv5doNAn85rtmU
36236	payment	2133	2133	1874	1	1	4240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbaxjdkcTMGe5D7G9DsqcVVsAndHw9m7HLGjXgcVKhN8KhbD9
36237	payment	2134	2134	1874	1	1	4454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywCENdnkC8yYJZ6eDo4E1QpNbjVXbtSrDWdCBM9nUtYo3Yyue
36245	payment	1397	1397	1678	1	1	14015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhC8jCRmDfFtMZz6PvmWZtpXziUeqfoiB4uK3tg2J7z6zzk39R
36246	payment	1397	1397	1678	1	1	14016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LuuzapWD2pVbZbX8MCP16fPARUy9zgiQHsQ1gh1GWxiS3Dvg
36247	payment	2134	2134	1874	1	1	4457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1a98XaHd1Fg48YEkiT4sLGNoWVHgTcATwStSW37RrXWy7uFnG
36248	payment	2133	2133	1874	1	1	4243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuECn45g7HMMbJ7sL5et49sicaMHtcjBDPaxFEWBYLfWK7vmG9
36249	payment	2133	2133	1874	1	1	4244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wLYnG3cPRj5exXfSmj62fwXnMzwikgeVcg19xaabVNq8E9za
36250	payment	2134	2134	1874	1	1	4458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wCXNCDJf9epz9Sd7qosAkiuqssDcu1KrBoFQTCn88y6ZrFeq
36257	payment	1397	1397	1678	1	1	14018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcoDH6V8ZQkoJWnNSZ2RieiT5t5NmmJgVj2vbfDbaT8WoFh9mC
36258	payment	1397	1397	1678	1	1	14019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4FJ8tgcgCdfsiQyqxYB1ww777WHrvVB9ZW3nMKSsGNDPFDe6D
36259	payment	2134	2134	1874	1	1	4461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhP7L4W54k2qaGXTCiTUDqipct7bpWUjvjBUqFDdbGyF1j1qkq
36260	payment	2133	2133	1874	1	1	4247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpmGfeh57LVD7wGodvMqTePJTuTayqHKzZG9d86FiabHBKYaqk
36261	payment	2133	2133	1874	1	1	4248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaibZQ5fV8pH1iG6Y2xpdrqdmU1m5vEgGv11eA44G5ZbaATxv
36262	payment	2134	2134	1874	1	1	4462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAqkRxMtBHeqJKaqAUP4VnFLnTGgQH47C1rSC9XvhPGiqf7fcC
36271	payment	1397	1397	1678	1	1	14022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDDpC6z6ikvXWzCcPXtffYCJsGfKLSYnVqryiQF4MExtKLzHig
36272	payment	1397	1397	1678	1	1	14023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgU5LS6VHNLpM6zNofETQ5FdGShRZvfSXJBcp1tD5ZrKz1kZD
36273	payment	2133	2133	1874	1	1	4251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4GeZuuXrgihj4WJXaaD4SULJrwZzhcNW3irmWtFHhY986CzBQ
36274	payment	2132	2132	1874	1	1	1239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHqZdGVy4ctexMFaqEksEjvYHdbSWErpH7qiA4PkAoqWM4v7BH
36275	payment	2133	2133	1874	1	1	4252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgonJRd5WyW9HAh6ArvMMPayzsAaxV7YgBqb1PcUwBPgiaJ5co
36276	payment	2134	2134	1874	1	1	4465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTvLR8JHpTxutPFRLFwgNomz2T48NFhBTQuK43rsXred2BscE
36284	payment	1397	1397	1678	1	1	14026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhL98DPQ81Mxx7WgVBbgkbK12BfQHvCbSveBoxo1Y5TLQ1pHq
36285	payment	2134	2134	1874	1	1	4468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbxxBZaoXncDoYkzwhSw65XhhrezYU4iovwvJcNjfA4DZHD2L
36286	payment	2132	2132	1874	1	1	1240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1UGX6rnBokfvsbyBuR69GtpJzsVH9tGvQNgzfaMAH5TtkZxD
36287	payment	2133	2133	1874	1	1	4255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjH85fU5AMEamGyzkiHfZ6vTJjjxJZVtd2cXwYV3GWys3Xbrj
36288	payment	1397	1397	1678	1	1	14027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDhjqj5ngjpyoD89EP17NJCNXyfQbtxZzhu5yoMEVaZQB9Udy
36289	payment	2133	2133	1874	1	1	4256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvDFn4dRzqbaGrstiwCFQhkm9ypGnfqTYvYtaBM8mYd6PkNBD
36290	payment	2134	2134	1874	1	1	4469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvoVcmJUbCy5oiUE38zXiYHxrpirmZ15HZppNkw62tiAcRH1eM
36325	payment	1397	1397	1678	1	1	14038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQfyrFg7rv8yPanJejvmx9P4kdDR5MP7bHUi8VnBYb5d48nHR
36326	payment	2134	2134	1874	1	1	4480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfk12NxBwWSAzRUoYUCWqkxjBcJ9h1ha4nb1E8okuhp9qoJoGX
36173	payment	2133	2133	1874	1	1	4223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BqwFaAFB87QkaGuH4CiuP34JfoBcx4ZekAyCs4gHmNifD6p8
36174	payment	2134	2134	1874	1	1	4437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6TqCgSk9ur32r9t1wNv9f7a7RCPaHSWpLDQWnCZygCw1SoSu
36205	payment	1397	1397	1678	1	1	14003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqfWR4xmZ3EGwCec59ekvhWQmAoJ6D21oYbLfmthgHELoqeFo
36206	payment	1397	1397	1678	1	1	14004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6cakEoqUtqosDMFRBnaDnuWBiKWMvqYQnt4EcDBhc97jxb1Vr
36207	payment	2132	2132	1874	1	1	1233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiBw23ZxEGQmcrCozuXYJtfiN2EQdXTaJZCzfNUcKTrnqtFFq
36208	payment	2133	2133	1874	1	1	4231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7UYLXUYaH4uMV29feu9p6otoMiLNjPTm5vaKnUKtZL5s8eJ7
36209	payment	2133	2133	1874	1	1	4232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHMmH12HXu8UhcmrXfgbW2jiWWrowM3FQDnuiAdWvGxzy1gAD
36210	payment	2134	2134	1874	1	1	4445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7hin7AnY8mq2Fmediw9LovmZYqukbHBLtz9mBw8rMJPVLDha
36211	payment	2134	2134	1874	1	1	4446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYryfi1Fi2DGpEGcc5v3Jk1waRaWt1HBuK9nJFs2Xvb7dTZZd65
36212	payment	1397	1397	1678	1	1	14005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDx3PGPa9JaiyBJ8BtywhdQeNvQeB363b3ciFPVvGyy92ToAv
36213	payment	1397	1397	1678	1	1	14006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkiBHVBZqAfdLhTiMJKHfDpTtcb9G2X4Ch1sg51GS4Cuw1gdhN
36214	payment	1397	1397	1678	1	1	14007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJwr6aBKEhKu5H7aDqLN5nQoCnmuxQRRofvpAMo4psb4pJVyK3
36215	payment	2132	2132	1874	1	1	1234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpXAeNsfRFAEgJbgBwHRG3wnJDBBaU68awQ7vLWUfeK33me71
36216	payment	2133	2133	1874	1	1	4233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaPX6mZ9R8CTnxxFbhGT5oRk8fcwzKFqadPnnjRFa1xZyPnjb
36217	payment	2133	2133	1874	1	1	4234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMyv4cHWEGZSbJKB8koPWwLrDRLRpgMQnSfvF6gRCo1k41Yir
36218	payment	2133	2133	1874	1	1	4235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7SVxWuwZGwtkKjiRv5cEZYXE34avRKR7SWAnuTaNgqibbSSX
36219	payment	2134	2134	1874	1	1	4447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHArDHi3Zatj2KREeWUJcN2R4dpdbXpYUhCASrh7xjfhtCcYyn
36220	payment	2134	2134	1874	1	1	4448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSN7UyxMhoZLZ2PJKxRVJ7XDwzH1k3Qpj6yekLQg2MbWT96qU
36221	payment	2134	2134	1874	1	1	4449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJEEh4RMbpxTNJEVhEwPhtxq65Hou1AhPiUCSpijWa7qLw4rk
36222	payment	1397	1397	1678	1	1	14008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2boosyQ9fvutUsdMbwSgBZ93QBbMPsYTfKfJMcSvBjmCSq7xN
36223	payment	2134	2134	1874	1	1	4450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWirMA9C3BsLRuCaHFZTEuYjmTRW27A4m543fkgKx9LEHHDzWh
36224	payment	2133	2133	1874	1	1	4236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bchU7EXGTShLqW7JJBAQJZdiesFAaUQeW64NpVE2RSDZJKYe
36228	payment	1397	1397	1678	1	1	14010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTGc17aE86XdXrsR1u2yEnQFHbdLysqn7HGsja7No4wyf2mBbg
36229	payment	2134	2134	1874	1	1	4452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSfv1Mmv198xJvi5EuYK6eKwjTHjfwokSdmsvQpXRZEbbhNE3P
36230	payment	2133	2133	1874	1	1	4238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLqdWy9ETvuQ2bzb7JZwzNAYE46BefV3dLgRsX7YzQ1YN88ff
36238	payment	1397	1397	1678	1	1	14013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6VYN4rAPcNdR7WScPy7tW5umxvWhq1Vn3xt4GxnSpRX7D1Cs
36239	payment	1397	1397	1678	1	1	14014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcaaPaxkf7f5inrYPcTMpZF4b5UuPNouZzszTvVYqAtoFmHR5E
36240	payment	2132	2132	1874	1	1	1236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhnGsuDJAKfEKMyah9C2j8Urb3Wi43kUtfkJDNbHtMXdDs9y8
36241	payment	2133	2133	1874	1	1	4241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMA7Yrf63Ud4zjiZH5zhBtf2Asd5oMFpm5HxRL7HEQmFos7VwM
36242	payment	2133	2133	1874	1	1	4242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHq5jwdSKiZJr4SaDiB4vJnhC4YvXQSnyeiHXnRiGDTnPqrRL
36243	payment	2134	2134	1874	1	1	4455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PCjws5f4y57drwYzXydPXf23YaSnBEuhwj2fYcmkUDZp3T3W
36244	payment	2134	2134	1874	1	1	4456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg7911J9Vy2RsSp7RdkPjuhZ5W85Y3bfzW3Qr8vN3PKUSCk1b3
36251	payment	1397	1397	1678	1	1	14017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG83y113xSCJsoAZYzUHg6SLxqqxCDPE9grzWuZCK8ZsdRGdDg
36252	payment	2134	2134	1874	1	1	4459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4Dc1VagBLjDQuQ8VDyi8YquVhjYhjJXjg6Jci7LK7fEJDi7t
36253	payment	2132	2132	1874	1	1	1237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTJR5sCHj7PTd74r8X6BBMu6pwUa8NSVbxufnyMuzQwD9Ynup
36254	payment	2134	2134	1874	1	1	4460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZippgUG8oDNiHmXdELBtihw6pn8JuRdV3XzbUaJ8Ra2eoZzTUc
36255	payment	2133	2133	1874	1	1	4245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvn6MJc32mvymx1L8uLstB5VA7X3RzHCy6i7iGNXQkjtPpPsca
36256	payment	2133	2133	1874	1	1	4246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3MB8P6qrFZSHoTrpe8Zrf7LnNnf7o35K89iQJ56rviDNBoRa
36178	payment	1397	1397	1678	1	1	13997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hszU84GGZ3zXV19DZgEx2FMKJLAjPYLLnQcrRVS2C166MSH2
36179	payment	1397	1397	1678	1	1	13998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYet4PfVEew5LQniWdCi8yK3ZgHcsRRidroFctFe28mzMjjL562
36180	payment	1397	1397	1678	1	1	13999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfxckURYq9y3ZEYZWAK9FJv3jXQZ1Nu6tPejdG61YUcxu97osf
36181	payment	1448	1448	945	1	1	8	1609000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6MtzHDC5U9iyLmkkzEx5JEKaT9fYRNF1U2GGgUyCJdhTCJ8hj
36182	payment	1448	1448	1065	1	1	9	2884000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpqq9nM6J4E41w7JoWnDMwqf8vEyroEUjD3ewgJhXn32foWaK
36183	payment	1448	1448	1185	1	1	10	1946000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBkmmXWFxvZTMRgzWC66UQKQ7oentuxA2kHFvngSCjKTg3Ntf
36184	payment	1448	1448	1311	1	1	11	5421000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ2RTiNTTU9qgfSa7sCerqVFpFdN6EXdfjQgpdtnrMEdg1TDvV
36185	payment	1448	1448	489	1	1	12	212000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nvnkqRKC35UmQuyjJwWJTNPrDitRz1TbxtaYifqRWcV2wFN9
36186	payment	2134	2134	1874	1	1	4439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFiV5ci5HP8VsBCDDBq32Zj5gA75FY826xpytFYDmkskuzNym
36187	payment	2133	2133	1874	1	1	4225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVzmwa8qLXEmYb9RnyB1UV2eFycc5WnkcuMUA7RXVVjBBjDnL
36188	payment	2133	2133	1874	1	1	4226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9cWL1coi3tpyCtZnxJnMDkUA7sDBeVF6i7g7AjGJGxRr6f3M7
36189	payment	2133	2133	1874	1	1	4227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1x8tZc5uHzQoGU6j1KGreoQEVazwjdF8vtE24yd6JJnRLNn69
36190	payment	2134	2134	1874	1	1	4440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWDkc9TzhXRdqFeh1AkPDYqoGntghTJZgGnXPKvacXZT4rMUd
36191	payment	2134	2134	1874	1	1	4441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZSgPPa8fZYXLBPbB6bdixyttybLvae37RGaS2soX6RCf7ioae
36192	payment	2132	2132	1874	1	1	1231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzhPg8eZP4ZkGd3YuqoyimU5fv8FmPUeoa85u5xatxn1YWrzH
36193	payment	1397	1397	1678	1	1	14000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEzJgyg3o4KWhebyqcDq7Lf4aNgPmmrTDAVAb9XS5NDERfyJwY
36194	payment	2134	2134	1874	1	1	4442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQVsErQZkYPYJdY1Xj1mf8TZjNiUi1QK72r7x6njaNjArGuPF
36195	payment	2133	2133	1874	1	1	4228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbqCCsN8TZrX6VoApE2Ry1F1uS3poJYRDqbaJ9xLGg4sgjPr3U
36203	payment	1448	1448	741	1	1	13	16000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHi3C9GGiuYcAYBduTWb2kBKaE6siLMQmqYeTxxDu3hkJSEag
36204	payment	1448	1448	730	1	1	14	16000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQSthuExPEVw7QHrLC1NYK1NSpDvTqWSzBK9hjYo3JVL34HFk
36231	payment	1397	1397	1678	1	1	14011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93gUMpnz5z4gSnUCRv79g1n37SLsZmttMioFbC5eww33YiTxb
36232	payment	2133	2133	1874	1	1	4239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzti3S1iYigVaMLJJajJR1EpcAnrRYdC9acBfA7x9RwJgoyDE
36233	payment	2134	2134	1874	1	1	4453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpmV4qCq87X3qoX5UHvhtnys77AN7aYLijEHTk4KghNwpVhLJ8
36234	payment	2132	2132	1874	1	1	1235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ARusdiAAgzoGedFPLZvAiyd45Bg1Ay6gMsERKjiMR9vwaKwm
36298	payment	1397	1397	1678	1	1	14030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkACEmky5h2VeLHatCjtcDZmJJYJkqBfTKv5v2tDebaxxtwK6f
36299	payment	2132	2132	1874	1	1	1241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBAjqYQKVnodEA673AryFE5ekcU5yVs74HUPx93QWAp5CJoMe
36300	payment	2133	2133	1874	1	1	4259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWNkMcgk2jwm12UV8oo5xBzYhCGKjYtCuxFhtL2AeG3u3jkcGk
36301	payment	2134	2134	1874	1	1	4472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMcbHDf4an9xVDHWTiXPk6yYv1mDDeF73Upq3bBJPEzcYfku1
36302	payment	1397	1397	1678	1	1	14031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHNUGWbrsV9r1SKjeZPrXC2kqckKJYggZgrKgUnH18PNzVZ93
36303	payment	2133	2133	1874	1	1	4260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPAJEAqdx6sgcayPgFBUKhKHMdbhjTtUTF2emKSyU3YkQca7q
36304	payment	2134	2134	1874	1	1	4473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTYRYed1XtdaSruERsLweiHvUpAB3vFtMQsJxeuGKMBunbNJ9
36312	payment	1397	1397	1678	1	1	14034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbvHhKApUhGRkFhYMGYjF3r69qosDBSan1EC9Vzs4hu8FixdHa
36313	payment	1397	1397	1678	1	1	14035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73M52V8WejXDCLCTnrvGbduwmnjNDxg3ajbizrdypTSi3cHRJ
36314	payment	2134	2134	1874	1	1	4476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UVYfPbezuyxK6BdaNtrFXUUNHz3SCUdDHrXVma3M7cEErRWC
36315	payment	2133	2133	1874	1	1	4263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2YRyiB6cyVz2h1nvi27erweuQ3LjxSwSa4tt5qyNHXks7QU4
36316	payment	2133	2133	1874	1	1	4264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQJ36QwfZeFroWaNRfmuVd7dWVhCjXRkDcopZ1KJT4Y91YkDK
36317	payment	2134	2134	1874	1	1	4477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuhCoN6TF42AMgZRDavchGWt4hikLLsst8bQeQqFTRVxkoPra
36347	payment	1397	1397	1678	1	1	14043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3JpffhmSzukiFSnUxkhi6fEKo9bR3vXPDLv6ApuawtRLypxc
36277	payment	1397	1397	1678	1	1	14024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12xSjJzojrdDLUfw9ymtAtHvMeiGzTdW3TLd3cqwhoGY5fbAq
36278	payment	2106	2106	1448	1	1	1	5759000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcqRKo7DfTxSPAMSPj8BjqTeRpn9cgQ5Ee3bqowHyAfV66sdDV
36279	payment	2133	2133	1874	1	1	4253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsraZeAxgFEwmSGYVcLosZmjsrYJzWfHCet4kYbXVjDc3M8ghG
36280	payment	2134	2134	1874	1	1	4466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93SA1Zwn3fmmwpVw2h8KTyknSgf884zXrE1QXVgQV4AcLneYg
36281	payment	1397	1397	1678	1	1	14025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11TUD4WVnfrnUVaff9XAWvpvM6T32d2fxYHRgycQSfeABtBPi
36282	payment	2133	2133	1874	1	1	4254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDxVt6rjiB3FWFSTV8fprFwtwEAvbPJmyV39ek6xKzLZ2kFyn
36283	payment	2134	2134	1874	1	1	4467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYckvtscbSGBKyZ5XrYyeEStiBvVFKH19isFEJU2VH3j4mES3K
36308	payment	1397	1397	1678	1	1	14033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtnM25X8G4CcqcVxoDmdXLfDH9wLmouGy7yNbcgHbmWvPnxEK
36309	payment	2132	2132	1874	1	1	1242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSw6iiB2cFXQRPtVWmHgeX8MScW8Rw4TqQ58cithSpDLGokLX
36310	payment	2133	2133	1874	1	1	4262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5uF97bjbNsMqsb4CF4RqCZjibcgpkLhDWeiVaSm35Bsfm2wRZ
36311	payment	2134	2134	1874	1	1	4475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpaJtoJFPkH9QYVNQfA24aoSwWWbMADrQzsh1EDPPehaYpoms
36318	payment	1397	1397	1678	1	1	14036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfBweQWrEMeaSK1Z4v6X5u1fHwzgVjdVi7wrrfumaytirZSXg
36319	payment	1397	1397	1678	1	1	14037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXD71MNRQ7A5eJhjspeyFaNYK68ShT2pd6JH3gQgzvzTqteu1
36320	payment	2132	2132	1874	1	1	1243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCx8Yta4EvaKkuW2T2BcwQ8dN4EQdwAEGfMQF9xeYQet3Denwf
36321	payment	2134	2134	1874	1	1	4478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsso42svjLKQJwwvmRcW8rMbsYk5BRDvWKxhooytUQxnBXL8ad
36322	payment	2134	2134	1874	1	1	4479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9QWhFoDv7um8AM1fMzDNGLNHDBhoazdP9irxCrxSmqoKEt6S
36323	payment	2133	2133	1874	1	1	4265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4GAXBtw7gAibNVeVp579bAPTZc3rrzAbZdaX6uRWv5kXLvAA7
36324	payment	2133	2133	1874	1	1	4266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUv8n8HDwahyFcTGZhvNBnVSbb6mNyWRHnmF94Hk6h4rwU6RZ8
36360	payment	1397	1397	1678	1	1	14047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jTpbMhH8pU6ubsh7VNovRoRPkR7H7yiPwGq42PCiAJihNiwE
36361	payment	1397	1397	1678	1	1	14048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYMjzCi5gPTpgqdgL4URGmVWDLSFiuEhFEoYUGNZA2AadCXxYb
36362	payment	2134	2134	1874	1	1	4489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZjZMfsLErrBetYSyFCCnx1MGHiW13bMofDW1Y4EMNu3csGTa
36363	payment	2133	2133	1874	1	1	4275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFQVarpXXEEmR89yEjKCjB4MabfcQmUBbXBLzo3d9SRz3z3cs
36364	payment	2133	2133	1874	1	1	4276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxJmdcQVxG1KUkFffEkoGk98fwVmAEV8Gc8p2rWWCSQjKtemG
36365	payment	2134	2134	1874	1	1	4490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7wK3gV9dDmsrdZiU58GK16GgwAoEfPiB9YjnJ5YfCW92e2Ec
36373	payment	1397	1397	1678	1	1	14051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxRcdwr6kE8TbLUBaMR38uLNsWEn7pqgSzpyeXvoS8C9nJ4my
36374	payment	1397	1397	1678	1	1	14052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNwfHLQdCGgw2grjaGEJ1beiNmvyxkcXsJssfaHWeNd2rmBAc
36375	payment	1397	1397	1678	1	1	14053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkeGmedrdF96bFyVynTrmgp2AM3Fgpv9kHet1md8srUQv1bkze
36376	payment	2058	2058	2059	1	1	7	720000	2000000	65535	E4YfNhcFGhzepDr2rpFtdHPupyPZxKT1KBCHGW67DSmN2Gwp3Pn9x	CkpaBUCkR45ndfg2rRQzvTTg9RAZyecQGP5W5KY4xGJHuUgPHfUT8
36377	payment	2132	2132	1874	1	1	1248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsjfC7zuveZBaw6f9giNQZGLgDVK6eRtiUMJgS4YHRjCz6qqeH
36378	payment	2133	2133	1874	1	1	4279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUKqQzQa5dnGhgkvJM6ym8kTZf36uLgXu5zv3eL5rCPP9czXm
36379	payment	2133	2133	1874	1	1	4280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrLxN5xFis898hLMrbf4ykdMXgHbZjFYgvmQvFG1HW35KaYVB
36380	payment	2133	2133	1874	1	1	4281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNo6J8WQNUkzhDjffsQdXxDHCsWyeNULbiH7eEx642w1eqCU8y
36390	payment	1397	1397	1678	1	1	14056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqUzrX1UFDGoexfokD3nNcRDSf853xvU7yBYtHXLeC9uGf7Ph
36391	payment	1397	1397	1678	1	1	14057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpP2Bw9AKHP8wm1aN9saeFoYnDww1Ud9Fz8C4vp2zVYVYXGcak
36392	payment	2133	2133	1874	1	1	4284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpgsdk8PGz8CQEijnikgdP4JFFwyojV9KPKtKLaqjjMHhbUR7C
36393	payment	2133	2133	1874	1	1	4285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVGbeJD1AA33resUeEJVYQvho7tU9PuBUNhWL8n5hjdkLMLDZ
36394	payment	2134	2134	1874	1	1	4498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnJG5Vt9PkkLvSAZZmgmbmuNvsG7cn3ojYW7dVGeTMfbEDWiF
36395	payment	2134	2134	1874	1	1	4499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrCFWyJEPfhVz6xpBowYwV7JZ1uKN2qbg2GEVQm3nnzrPBaLb
36305	payment	1397	1397	1678	1	1	14032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4UXP7zTyt811tJDnvAtCiXsmKzWWYKyMVN2tgiqYax3uuoNq
36306	payment	2133	2133	1874	1	1	4261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoAUAw5Cs3ncy5mBeMY2fbk3gqKAf8uNA4aUiHEt25eU5fFgC
36307	payment	2134	2134	1874	1	1	4474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyCtSMGGen5FSeVis2n2Bxar3rBRKnrUCcq7X5BC4At68t1M59
36327	payment	1571	1571	38	1	1	41	60133319501	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZJ3jmWAB1awdToR7hbxqm6L36wTzEFdy2rdQ8Xmssr9vCpVf7c
36328	payment	1571	1571	969	1	1	42	454723066176	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZoLmxTdW6p3z3AwK4h9ALv1p2XFgYKDQhmB6uryzoCkbwf6YFX
36329	payment	1571	1571	1089	1	1	43	814859838524	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa2w3owJoAkBudDhWyDS8cwV3soMtxMtWS8Y6HK5hNoYpREW2bK
36330	payment	1571	1571	1209	1	1	44	549802170281	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYgti3jrw6nku8gt8zYfwYPK29utszmJgzkmqMiYcaCt2gTze35
36331	payment	1571	1571	1335	1	1	45	1532072633172	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZmM5SV54Vt95SqpyAh2snHjJhcGmu9qnegrRDyo6Jj7hoJxhDw
36332	payment	1571	1571	1571	1	1	46	8872572333	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	Ckpa7VyFXo5rQmjKXxDWUpHN8LGrKAnWtCahzNGPfkutGAfECW4KP
36333	payment	1397	1397	1678	1	1	14039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGt19rjw4M1gDZt15HcGYT41xAhziwT7VDaKYnh6CXFP7XabK9
36334	payment	1397	1397	1678	1	1	14040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdffVLtX3J6gcTWq4XWnBWw89fkWQqkFx7ihFwzcSQpCm58R54
36335	payment	2133	2133	1874	1	1	4267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqcv8o2XcQcdgaC25mc4eESjVb1RDjzz8SFPTUK4AQfPW9dJx
36336	payment	2134	2134	1874	1	1	4481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdccae4sRMvbdJu8CgM1JqMhmYzRHzqnedo4BCBcUyVUB8sxP
36337	payment	2132	2132	1874	1	1	1244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXUPU6AwWiqA3yAG2df75zYvT1pR6qaRqZ9Fsp6JJ1XWSHup5N
36338	payment	2133	2133	1874	1	1	4268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8a1yiyRPkFAD4SEbLaNdW4Sk9LPZ72UsLcCMrVCmVK7ejjTA
36339	payment	2133	2133	1874	1	1	4269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1q55tzk3wL9brEmSdURLpbeaRFuiKHAAU1uTJrTeoVn4sTrW
36340	payment	2134	2134	1874	1	1	4482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZidahAENMaUatao6WKTuBKKPJK8sLPL1wxqnN7hZHKqAtaNWWk
36341	payment	1397	1397	1678	1	1	14041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyx5RJacy8QqvDZaL6FtiLRFvkwCRBuwQW5s3khr4ny7vTBH5
36342	payment	2134	2134	1874	1	1	4483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrCNVXEtDtH8dUi5gCLYekEq3r2sRBMFVzoVjnUxZ85oLugGR
36343	payment	2133	2133	1874	1	1	4270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNdCm2NySkVi7svhGHRN2fh5wbCW1RwufZRuHNXJmu31xhM5j
36346	payment	2134	2134	1874	1	1	4484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq34W7S3ricmuVmAzwoF6H1xi3Ssf3J24MoWMNiVGWQbBU491C
36366	payment	1397	1397	1678	1	1	14049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3i5AoRJRGpEp8CuSemfUR7CnAbPred9s4h9uuaP27VKppJWmo
36367	payment	2134	2134	1874	1	1	4491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd2zGX3k3jcy19dsH2pBgUcBenCQ2prQmfjGykYDUz4cvCg5ZS
36368	payment	2133	2133	1874	1	1	4277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe2LSQBvX46mEZuW3B4pV7u5LEgdwPWC2Ye7djGWVbGLR4esW2
36407	payment	1397	1397	1678	1	1	14061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyS6PEqugCd1MCKXQgj7yGGg6CFAHPpjfeRmM5YxB74uiAjBy
36408	payment	2133	2133	1874	1	1	4289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwg1ZiKKMovtajykJVx5BGBF61D3rNPPMLp8guxB59JZfcme9
36413	payment	1397	1397	1678	1	1	14063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzR8Jhg1gnCeMtrA4kRk9rLXgLsT2fZyikXWEMixHdUbWc1Q6Y
36414	payment	1397	1397	1678	1	1	14064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLRZBtERWX5kmNhwnUDzQvjWczEmsAiD9KuhyXLCrw7ETFgx4
36415	payment	2132	2132	1874	1	1	1251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYevriEY5rMXuhSCx6NWdnSUJAu9skapjRERdwYDkUuxieMuwoy
36416	payment	2134	2134	1874	1	1	4505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmS9qKq4hpNXAAHeGNEhY6sqw2LDjg4LDcQmQwRRHQoDxLKFD1
36417	payment	2133	2133	1874	1	1	4291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvi3w78a15guyS6ptLKE1fj9dErrR7dmbVpnQk9r6iLpoM35R6
36418	payment	2134	2134	1874	1	1	4506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKXHyMdMYiKpUHnvHqa5CkhfCR3Ecs5fckp9rb2gQtY8Wu1zr
36419	payment	2133	2133	1874	1	1	4292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1FoY5UXAeumdp12pRGxsHrpbrSYa4j7iXotE4FCaf79szB9Gr
36429	payment	1397	1397	1678	1	1	14067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnbtufbrXHtoUb9vsR5Lz8HTi7F6mErTSVSWjAG1BgWn1kQzB
36430	payment	2133	2133	1874	1	1	4296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazAHGRirueHKEo7PC4jjemRFGCuwLhYpkPY2G5WSK2eBT9BXT
36431	payment	2134	2134	1874	1	1	4510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgmPFdxiCNQjod1UWn45yXokEc41w9KApnoQC6L42Gg19mxnp
36445	payment	1397	1397	1678	1	1	14072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNrErFWPnTQfeJ1zhh7ZE999fkRyTCnLra5rhEkxCYqno2dzA
36446	payment	2132	2132	1874	1	1	1254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRcGYMybZgeVBf7NszRnS8tg1sp1y3wPMvvg2px8aNXdmg8qn
36344	payment	1397	1397	1678	1	1	14042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhDpHqwNUdLUmJe2vXokoQnx7Kyha4Go2Z7yDP1Lwqjr4NwuH
36345	payment	2133	2133	1874	1	1	4271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17Y3yorf9z2w2K3pozYxoPktCQTiBg8QAcjN6uwpsmxGky2KP
36369	payment	1397	1397	1678	1	1	14050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xfhEssGzEPGr8ZCgHcuWExWUZRHHCM8CVPwwWUXLnXv8nbWy
36370	payment	2132	2132	1874	1	1	1247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUpFVvg1N9ZNkPRoKo9LEuWoSsmXZReaFczydPFYsQnDRiPhr
36371	payment	2134	2134	1874	1	1	4492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZZoqJUr9SSRusaYXNVQZRzbCq5V3ZpSHooX9mLKzKiRgs1Gu
36372	payment	2133	2133	1874	1	1	4278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowBvE6ETAAMaRZToCvPH88YttMJqeCtMEkbskaKCvXmpUt8go
36381	payment	2134	2134	1874	1	1	4493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQD2ji7zGR7b95SnVCacQqf5UuDLz9z6c2D5FCA3mnVZ72fAW
36382	payment	2134	2134	1874	1	1	4494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcJEDJEcwYZcVuj99ZErc23auxyEmU9VPXY9y64H7hAPCqrVJ
36383	payment	2134	2134	1874	1	1	4495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfuD3RtaXE8kXnbeFjrvYyf2aaiYRvaojGpYbUxrtg3hDTpir
36384	payment	1397	1397	1678	1	1	14054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuFH7cVL2YNg2GqGJR5XrDq6tAoNuGTZxCP4T1qmKE8NTRDDfy
36385	payment	1397	1397	1678	1	1	14055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZBLvsDyaRPonqUUoaDe6zZLYnz4yXk99Tms9ows9LhVBVjjX
36386	payment	2134	2134	1874	1	1	4496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTWZhPbH15qWA4tv9vJtL5exSgthsHJQbp8Ty1tRSThbyqd7i
36387	payment	2134	2134	1874	1	1	4497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspuexEgTVuiCytPvhWS5rZfYLdWdigLNEgU5NyyfCG4kNVDgJ
36388	payment	2133	2133	1874	1	1	4282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNrxsEVYtySr4XdGmQQ4Yjtm2VpxYqt38AmWoSxvtVGi2UezP
36389	payment	2133	2133	1874	1	1	4283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgikhrd4G4w7CtCuyb1Z4L7pxMESJXS1Tj145XFTuajoZvmWA
36397	payment	1397	1397	1678	1	1	14058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJVZtu2exZhPLKGWU4SXAKJBi5En6MhFcFmgdKjYcKJhxCFMd
36398	payment	2134	2134	1874	1	1	4500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQ75FLtXVuDiWoQmcpmXfKMPWhvEaGCbBEB7tVPxtZyePjqmz
36399	payment	2133	2133	1874	1	1	4286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHietm7M5AQ269LLpKDg4tDssGYCmL23zxdJEDqfzzQVvMnb1
36420	payment	1397	1397	1678	1	1	14065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhVhkH9givDpXhH51YRsc5t3cf6A2ddZS6bKniz2BVyY6FcLZ
36421	payment	1397	1397	1678	1	1	14066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXmkb5LQEPaHZYAF7SQicUTnjerAoY29R2avCGT5YrNP1Lw9Q
36422	payment	2134	2134	1874	1	1	4507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfv7tSKxviB7xm12fUzoBurozNzBoNjdQgKkF1Y4xBKpAdWuH
36423	payment	2134	2134	1874	1	1	4508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEQYKWXyVmUEhxQJ54f6HAaAt3VVueZP6X4ob92AuswhqKMov
36424	payment	2133	2133	1874	1	1	4293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh259JEqt7m9JzeGYysV9eZDNY5awrfr6SBHKRm94sYBkTWVhL
36425	payment	2133	2133	1874	1	1	4294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92Ewq9nLoZ7fjqKdh7TJ1gVn6mQPL1dC52ocHkuKVNUrQhfkS
36426	payment	2133	2133	1874	1	1	4295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpekcdRUMDjhAVLPHJcstrd1aW4mP36UZqxZmfWBQbJiJ9LiV
36427	payment	2134	2134	1874	1	1	4509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjcYzeQU7U5CDkygM2EJEmNHu2vsoBcke64qD6wdGwaHGccqK
36428	payment	2132	2132	1874	1	1	1252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9xp4dvjMy7S9p45psCxN4yHguU4yNZNMP57Z4eu2Y8XucWi9
36432	payment	1397	1397	1678	1	1	14068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jY7fpBToLyYQdksPvPBoFbM1VZy9Qy3Wdfbrr5EX6T4T8mva
36433	payment	1397	1397	1678	1	1	14069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYoP6gC65zUv4jyisUZ5YcfQJdP2CD9YnrLyddpJyg6npBULMT
36434	payment	2132	2132	1874	1	1	1253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYxrVzL2MzYrnBYFseQApwMQC3Zc5b3P7FPVbdEokYCTVjVqc
36435	payment	2133	2133	1874	1	1	4297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9um96sGfkuY3xVJMPb7LmTETE71n1R3WVBqUWH98Tt5qJ5wr
36436	payment	2133	2133	1874	1	1	4298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvLTxBaYxJhQxMkdnrv2bU5WrYukDazNXDKgFc9T52p3pCetQ
36437	payment	2134	2134	1874	1	1	4511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEFwZqvevLDudnsNdq5imrvpmEzv9eV6Nkf2Smt6oa5Py7dyg
36438	payment	2134	2134	1874	1	1	4512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4W6LBPQwpHESsUokBsy41wRPTeD1V2ys6BEWVTbCp87pzDLT
36439	payment	1397	1397	1678	1	1	14070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5eXjiwewAU6zuUV6a76nwQnajxA6UoPncn7TA9NpdPQMysvp
36440	payment	2133	2133	1874	1	1	4299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8k87is1mNw6aDxHp5bGe4KdErbCQbhKNvBCDjMhANi9AqRQw
36441	payment	2134	2134	1874	1	1	4513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5wd9vDqiRUeFbk2wnehHHi3HJbDSoiGT3ni2WZh5JGJ36j4t
36449	payment	42	42	1361	1	1	8	4300581600000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYx8r9WKXoAEyf2Vz7tiZqNeKxtgz3MQjFUpz32EfVqS3xECGu
36348	payment	2134	2134	1874	1	1	4485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfxVVtgsrHnzEuikVbWUXcx8GogmZZJeCk6CSwfThXLtU3M5d
36349	payment	2132	2132	1874	1	1	1245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWr6L5zmG5BQdibXBww7wonfKo12zkvk8JPE9K8azp3xXFdMs
36350	payment	1397	1397	1678	1	1	14044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqWvuVUhiDna2WPvJroLaJ7Z8CrtNaeyqnJtJDuhXDp9ZQTVJ
36351	payment	1397	1397	1678	1	1	14045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXpBh6hUsUztqWV5q6M4oU3xe997nz3sGUVHHSF7H1F6UPAY2
36352	payment	1397	1397	1678	1	1	14046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBLRHpGQuYcv3zPCufzbNmB5oQVm3o3pNqjLm8cUgw6FjjbYB
36353	payment	2133	2133	1874	1	1	4272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZu9VjPAkcmhDhx5KbfMvyVmmKbK2Rb1cvxwnNq4bVo9B7xyY
36354	payment	2133	2133	1874	1	1	4273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64DAxnmVGb8Vr7Pmz9WFdEbCct1Fktd1Bd37PLWZJG8pjTezf
36355	payment	2133	2133	1874	1	1	4274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEC9JNCAEmR5fQjhreEZEmvKLdqr8Z2176ZEnPwgDmESjSfGN
36356	payment	2134	2134	1874	1	1	4486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2XcZeTp1iVhfBkYfzKASS6PSnaLgff3z8jpaq7opudBgkQ3j
36357	payment	2134	2134	1874	1	1	4487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2pWNs7cNoCKA4MwsVR2NCGD8S8AiGnUyJVmDkH9sfi99cfFN1
36358	payment	2132	2132	1874	1	1	1246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJ4qx3jgZDiVYfjtUUPm5HoY8iaWRZNvjL7pim2ZySiqYZyGT
36359	payment	2134	2134	1874	1	1	4488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzT8KJ697t5HAEmnZz62d54yfc2vGiEYWBkNWBsxGti1Dqiw4L
36409	payment	2134	2134	1874	1	1	4503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5taoupFFUqtEvyaUAUrRvATpmcTzhcM3LegktWcgSpzR3jhHR
36410	payment	1397	1397	1678	1	1	14062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ovAUWfdirw6gNmN3g5Lpo95LJ477N3CJ39W6NeCvmcjMPt9k
36411	payment	2133	2133	1874	1	1	4290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZun13bbksQg5dYEcVWnHqiJPWCL6Ha22hR7ftJLAAZF5CmTGYL
36412	payment	2134	2134	1874	1	1	4504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxaRQMJ4oRW6tXuPEZ51NvVz6TYeeHd79wbFrjZUGB5cZebyFG
36456	payment	1397	1397	1678	1	1	14074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkgsa7Cs8BWFn5VZzRUcfYvjW6TFPyEjKN2er8KxGuEuppUUE
36457	payment	2133	2133	1874	1	1	4303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RJsRAXzubsTMNuHcRwQj5mgVjGKZc3pC6k6fDx9ubiFttSi8
36458	payment	2134	2134	1874	1	1	4517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2quRYkReqg2aww9Zdy7Qou5ggppYcTWUqcZ3rUehiLX7yc6S
36459	payment	1397	1397	1678	1	1	14075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3StB25iaWzmqbDLbSxPpK7wqHP64V5v8ZCx3GFuaj4PxsytkW
36460	payment	1397	1397	1678	1	1	14076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLJYhvL1AHs2VwAL9PcL9kogiEby2qT8Lp3RWHBCRuoXwzd3y
36461	payment	1397	1397	1678	1	1	14077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtof4n6fXTCW7cQTyDS7ksrNuNNJ7zEj4zq6FkQ3zEaVpjEiHE
36462	payment	2132	2132	1874	1	1	1255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7cYRK1Ym4b23kkqpuVHA1AmAGgdFiLHzShCNo64S5BhtJCba
36463	payment	2134	2134	1874	1	1	4518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5WVK7nKU66KNSmsGc6LQFjgHHBtWNtwmJaFfDJ6KjnVtitQ6
36464	payment	2134	2134	1874	1	1	4519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1tgg5LXBWwtkxs9yA9Ndc74VhHxaSC7vVNaQTVudio5AzVEB
36465	payment	2133	2133	1874	1	1	4304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGHsWgEhdaHBNV47TsGBmMzQFEZbuea9b8LX29M5WUpxESAMFe
36466	payment	2133	2133	1874	1	1	4305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoD7pdHTPtBLE9ZczYktxAGE1E2yMwo7UGwAveNCVSCydMuTjN
36467	payment	2134	2134	1874	1	1	4520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzQ9fGWCN7GAVguviFhZfxmKdEoJrt8GjaTRhH9YvAv8MttfFk
36468	payment	2133	2133	1874	1	1	4306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WPmndvFkjsxuv8x5v6gnVNeuUafxCHNCajAFtKSr1L8tX5kd
36469	payment	1397	1397	1678	1	1	14078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLksvqfGTsjAjzF6k2tn698BVn2p8DEEon6FE9MMdCh5o6qUb
36470	payment	2133	2133	1874	1	1	4307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJqywEkmWNfszCiaFfmZThVC1fBiyu2dHySJdri1bmkQH6W1F
36471	payment	2134	2134	1874	1	1	4521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTqg7nxQRUThoyg86VXDmZVG2xWb6nj89p5EUZzEMhio63dUo
36476	payment	1397	1397	1678	1	1	14080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAt4VeNKSq93JR6scTEGHKp5iiRgjpczMAXK6QeAqFEhuzv71c
36481	payment	1397	1397	1678	1	1	14082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdCjZHimpJSDabxuCfRpoVUQxxBNoxYJtYXhp1ytc1p2aSh2F
36482	payment	1397	1397	1678	1	1	14083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1AQusXNpPPV88Qwxv7D9VJAK4fkCMBMTSAfwvNXaUWLgEyowE
36483	payment	2134	2134	1874	1	1	4524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYAju9hsmaehW77ZZcd8K3KeETNgR8ikG6Y9WGtcnpfMen3Eu
36484	payment	2134	2134	1874	1	1	4525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6sPpUiaYpe6xQLmkypxRkw4UkLxZKSjUUSmYy7gLjibecRx9
36485	payment	2132	2132	1874	1	1	1257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnTT5sYK8pyxfq8Da4ucXToc7Dttu8PnKmDLUn6UgAUMpgpJ2
36396	payment	2132	2132	1874	1	1	1249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7gftf4vf5g2Va258R4GHy9sA1CgrSJFK1Eu2CEWQfG2Y9RDV2
36400	payment	1397	1397	1678	1	1	14059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRScY9uBkqrVzN7h4t51fJ3bMCMBLSQWk1LogoXNpXCxJyuJPo
36401	payment	1397	1397	1678	1	1	14060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHE6PUiLKW5H4rVDoeGHE4qu4c6yzCwFQmzswmHXqjQQqK44M
36402	payment	2134	2134	1874	1	1	4501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCetWWSsJBKtkigHexLCja8V8fkcn1K8YduqaK6SV599wCWsA
36403	payment	2133	2133	1874	1	1	4287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTyZxRzNTJLW8EvbpGwS5uQfN12Qh8LVsF5qeJN7e7TBLGhTD
36404	payment	2133	2133	1874	1	1	4288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oABuMiEDUJBFb4AUhse7K1JMBFhuZPmc1Div7MNFnShbavt2
36405	payment	2134	2134	1874	1	1	4502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNUc5ZPrkPpdaZCeF294wqfWcdSqVaxZNkpuJ4YmHh1FyPY6p
36406	payment	2132	2132	1874	1	1	1250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxP3RygxNRsxPz6ytG3V9EvK5huGs9uyKGZQp1WC5ejLvY6TtN
36442	payment	1397	1397	1678	1	1	14071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXfbhn4nCFKrwE5SCSKvx3sk3PsTAfaAJ4vFQji4zp6JNad2k
36443	payment	2133	2133	1874	1	1	4300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdbdjekPs3T2wyf74w7eAwD3ogugeZtZYKrm2dr1AYN5hKnhVk
36444	payment	2134	2134	1874	1	1	4514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7K54Yqb4HtVDNB5Taj41gCQGB2y9ZSz6fUN9ey3UWXr7iLcpk
36477	payment	2133	2133	1874	1	1	4309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCFxHKvoMkBwgzit7N2Tcc24gzTF2CPHadgNyubsbFYNiecD7
36515	payment	1397	1397	1678	1	1	14091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPbYKwNAWTSBfYRPxCjNe1NNDHvSphoTXNtSA2bMSaVevGR2U
36516	payment	2133	2133	1874	1	1	4320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDPXoDA29SGYsyQnxYsKWrpvik4s3EjgqQaGwHGYRNMTHMBRg
36517	payment	2134	2134	1874	1	1	4533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJq5jvVT2qBmRP3fF7vXD2Ak7ACPK6mF1rrLHSAE1MC43WMqz
36528	payment	1397	1397	1678	1	1	14095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqw3ioDhmPRXdJZSLXR6o92YugGLbyi8G55TX6U7sVkveMdbNp
36529	payment	2134	2134	1874	1	1	4537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7ZaCvupoGjG7wwFqnGVYPWYy6GZbS7BbWxbCxcc78DuGCETL
36530	payment	2132	2132	1874	1	1	1261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1ecqHp6d3RJgxwVtiji8T22LKGoF2PCjW8GfVKzLhYbSZuAU
36531	payment	2133	2133	1874	1	1	4324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i3GHKbYpe4cHH7xcFFmemNQtrtU1QJhBHAmt7M2MprpTZVCp
36556	payment	1397	1397	1678	1	1	14103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2n3axhwJeZAEcZMfwiM9hJZeYfLw752QRRVrGkgc8RvucRF98
36557	payment	1397	1397	1678	1	1	14104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZarNfw4hS8N1CNmoUNPvBVscJXM66tQ4cAJAQ4bkzP8ZWaV5KV
36558	payment	2134	2134	1874	1	1	4545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1W5gYKfmRWB6BSjSkMhTeNd6UWcMWSAxPeXw5gqyxjB6PcFP
36559	payment	2134	2134	1874	1	1	4546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoGS9jNqcQTHDBndX86Br2u3NFMLzBmseDvuqGrPUYdXfC9Be
36560	payment	2133	2133	1874	1	1	4332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eLVjqRBASnXtFfmRhbq6Es5RGHT3oQ2HTHwshsjA4dBNrmZw
36561	payment	2133	2133	1874	1	1	4333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEkgFppEYaVqMWvXnb1KvND9wmHB5JMzNwh6aKWGbxinjMdeX
36562	payment	1746	1746	2309	1	1	6	2741644000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FBtbETFUDRro6QQDmMWRc8jP5WtzNzUtwJmGwL85NJkpVGDB
36569	payment	2133	2133	1874	1	1	4335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZafVk3buQYth52WvMgwjzU265MnKAfeG3YvtUUye3J1pHcTLMu
36570	payment	1397	1397	1678	1	1	14107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zEHF3RuBcUL2pfAXuajB43VCMJBPo6iDzaVNtnBnZqeJMPDx
36571	payment	2133	2133	1874	1	1	4336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYheY9rvkiYtfMjJpHit8z5MkDQWvQhnmBKMrvWPefJcoS7Pmnv
36572	payment	2134	2134	1874	1	1	4549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoV9iLYoZAUDzpWRuzAEGZfz1YDK1kPYxLfLL3ufBsfDa9aKGz
36580	payment	1397	1397	1678	1	1	14110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHVTLd9oWarUatbmjVDY8kyTdVGXWV7PfKmvhtZpztQD4rNWNR
36581	payment	1397	1397	1678	1	1	14111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQhmE4N2nZkSyJzU7tmtB1FEpaJjKqSnciqAzSXmTJe9fjzi8
36582	payment	2134	2134	1874	1	1	4552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQA8zA9ch5Mw2Ej9xLhwcuEwiAge8ajAiPFChiKeAQFGq2vARB
36583	payment	2133	2133	1874	1	1	4339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQCfZDPLWCDh5xQGdoF1zsXxjw9SA4dwRbXXJweYYuoGHtKSN
36584	payment	2133	2133	1874	1	1	4340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6X9DGSDoWnYxiyvzCZw8E9eqWCTLH3cLKoznHhrTKe26Az2WZ
36585	payment	2134	2134	1874	1	1	4553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQLgdeQxHTWzWiZkg2Engnxq7Gz11Gc3uX4DmHgBx6sgXn8Cv
36609	payment	1397	1397	1678	1	1	14119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGCNaPtDy3DwQ3rotuVmoxTXh7spZAwdVE5VJ2XpJtacarkPb
36610	payment	1397	1397	1678	1	1	14120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNNws6aaWxTLFsQHiNmRUSsxq7qjnno5Af3Ht8gn3FjEUBXzH
36447	payment	2133	2133	1874	1	1	4301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqx3UQDarpSWxXu42tY6jupDkc9yYVDTkEn7MF8r8SnLcf9oz
36448	payment	2134	2134	1874	1	1	4515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxZKcxq2RuE2Xhom3iFyWZuKGUdhtUX2CFgs9dMEynYMEtzq1
36478	payment	1397	1397	1678	1	1	14081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ktEk6oyKMzqfCQXCF36ScbqNmcoPPqo6FUeayZDvZz4VE1FQ
36479	payment	2133	2133	1874	1	1	4310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZ1DNVqzFVK8umht6wmEv6qSKHtN1HKXrFpeWDbh9PbZ8A1tH
36480	payment	2134	2134	1874	1	1	4523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fBz1b3DcpjFWuM3qXkppyYzRPzAP1JSqFxkB8PtxAnDh2GrU
36491	payment	1397	1397	1678	1	1	14085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzHpxTDjCC1zxNGVqAwv7fkiJhsYptCikgRbLuo8zWqQEQ3Yw
36492	payment	2134	2134	1874	1	1	4527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyKr5RvC4uJnfMoaiBDHrCyxomHCVFxAsAP767NX1NceXaWe4
36493	payment	2132	2132	1874	1	1	1258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4osQSE1smnvm7tHuRswSVoy5aG6766xwhZv3XVV9FLo6XjDr
36494	payment	2133	2133	1874	1	1	4314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAE4tTQ4jqpXdaKzNKUqpL9NYgdqW8qcmU5RwnhpVnsuJdh4Li
36532	payment	1397	1397	1678	1	1	14096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgzPZZdPY1kzVtbYh6JLamZVMg8uFJRaKyrsfZ8tiYF7iiwt7
36533	payment	2134	2134	1874	1	1	4538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XGYL4g5Ub6FRFwo5AcQoMeiHMPMAAKbq2EUeGp2wSGkenWQ2
36534	payment	2133	2133	1874	1	1	4325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZME73vTU9vkggvQkDWo4AC5oNAhHKZrUYTZPHVQdFLAj5bhjw6
36538	payment	1397	1397	1678	1	1	14098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxN6okdhg4QLpwdwwXctu8EfpgEdAAGP4KYCh8zZFneWFBbM1
36539	payment	1397	1397	1678	1	1	14099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7LWpz7TZA1w3Vr4WuEVUe62eGB7E5XrUMRg1QBCwYyccD5rLi
36540	payment	2132	2132	1874	1	1	1262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieCqMNoAHqBHjXNYakUQ3QffcweM2kHmsdEZhNVK61LSYbX1z
36541	payment	2133	2133	1874	1	1	4327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXAD4LWTTNfDQ6tfdvwMqJMvCsKzbBUypdLK1JnomSHzZYmRf
36542	payment	2133	2133	1874	1	1	4328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZ19BeLp8WauE8y9r1A55bj8EV1k9QAE8puL6Y3sFqMLDBS8n
36543	payment	2134	2134	1874	1	1	4540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp4373nVUAHmpT9AvBEyy5ktzjGVV32aah5WduyDFSd8WdiMgA
36544	payment	2134	2134	1874	1	1	4541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkDPxVJgkcUWeiWmWgUTf1mTzJAaeXrXiBrvowhxdSSo6J5sUY
36573	payment	1397	1397	1678	1	1	14108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUe4EcBZZnZ5T51HXY7x8wuz9Y63Q135MtFExfCMrhbVqijMK8
36574	payment	2133	2133	1874	1	1	4337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkswknb4m9FJNBrHuVNRSnVUefMoS4q8VWGfG4jRU24LgKVEa6
36575	payment	2134	2134	1874	1	1	4550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYnXsxM2sxKZmsyUs6H1kytYyNP5n49L5a9WVFuQWmPAdH7co
36586	payment	1397	1397	1678	1	1	14112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjUGpGFma8uB89kedr9aLPYwhYGXGfgEtYzdmMwNXk9B8Wsjbi
36587	payment	2132	2132	1874	1	1	1266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj85E1jPqbdem7jL2jVWv9vPtvZsZrZxXGPyvqNX4TyyGTrDRu
36588	payment	2134	2134	1874	1	1	4554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7K79jpmVk81dQGy2mxhWCLfx5FzsEoQNps82bPeUKA3Wjoge
36589	payment	2133	2133	1874	1	1	4341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL13oCj2XFmUe3mUQBtihFPPUQFgotHES9kPmLjoTYZDgfyW12
36593	payment	1397	1397	1678	1	1	14114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYCcUaXRPe5LYfXpcBNfs5XkcZ2GjLm9ihGx1ihgU5ff6iPFC
36594	payment	1397	1397	1678	1	1	14115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb71KqT9msJE2dKbQei1so4ggPiX6ETasr2Vdj279qxkoqoUX
36595	payment	2133	2133	1874	1	1	4343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopBReWKxUJ8jQyEfYEee8KbMxjQjMmyGWaodyhH43oPobps1J
36596	payment	2132	2132	1874	1	1	1267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABwY4B8b5YyTngJnrSrqQ34sWCo7CYEPCFXxu3BDnpjFuf9di
36597	payment	2133	2133	1874	1	1	4344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMZSpXeBwAQudqS47Wk8eS1sFatvHAN7qjbDb2hGfUjiturAG
36598	payment	2134	2134	1874	1	1	4556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKRU1eaTvqrmjsbQkpodegNuirgGa3RCTVcfJo97QTpHsgVVA
36599	payment	2134	2134	1874	1	1	4557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7iEk5KyhruD273MZwPEVZpxpA6Ad6LS8EBYNWhh3osSFiByb
36600	payment	1397	1397	1678	1	1	14116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8pUzHu9SjqpiieGNmNE7xo5iwMxyWTeQcbsvNj3EeDKa1eGM
36601	payment	2133	2133	1874	1	1	4345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNX41wWVaUEUMXytiA1QXK5qZP4PHjGr8uC3YJ9rQKH3otqvX
36602	payment	2134	2134	1874	1	1	4558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkpGidiZGxxQSRB1cTGG7u4PjATtNoaKopu6CRiGwTA2rL4dJ
36624	payment	1397	1397	1678	1	1	14123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa61FAejcZDLy33JPbKNWsmrVdsP8TMPdQ8mN4AdxdX4sh5i7nD
36625	payment	2134	2134	1874	1	1	4565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwUseAxHryufAz7iBeGZGxGJkN73deuzCu7CeBrf8DWifNniX
36450	payment	42	42	1115	1	1	9	2287706400000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVgKk4uXJvMbYYcNuxvDhirQQ2F8VeWBkyV7NAHtBYXmNMshn
36451	payment	42	42	1235	1	1	10	1543651200000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQKbvoJ6UTHDADXLwdTNHjDTdSBpcUb7NqLZduhgSs8yntN82
36452	payment	42	42	995	1	1	11	1276480800000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabZi79xuTrEVjvvqA5wSVUG26SQ9aN1Nq2KPZozaBh9KfDapW
36453	payment	1397	1397	1678	1	1	14073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahNYamVJLUFE5acW4MRAQwbtH4MzFqZhK299LGZ5rZtL8QsEK
36454	payment	2134	2134	1874	1	1	4516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEFNjCTfaybuHvUjRbMELWhFqkonCWHcRz4AJ51nDiAUDVJwWh
36455	payment	2133	2133	1874	1	1	4302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBAnUo8MZfZFUDGxpd1pDD4vHrRi5B86Y2BMHkxUDSt9e7ZLw
36472	payment	1397	1397	1678	1	1	14079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWLFbCppf6CyAXNjYXGnWuS8fbbym4bpWTxq3tnGUicF53XyZ
36473	payment	2132	2132	1874	1	1	1256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeKnYhz41RV29WtgAL44A8E5TFwYu22uJpefQq95GrcaEBJTx6
36474	payment	2133	2133	1874	1	1	4308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xdBEAP7bhAXZuQJBfi7ywk6PRZLarib6w9Z6C4DbvfYRjqNZ
36475	payment	2134	2134	1874	1	1	4522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSXQis7J8Ne7ER1JYB3w3t727cpLp5kSFD68KqmBtjb89wxcn
36488	payment	1397	1397	1678	1	1	14084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZioBbx4v9eucqoLDKaASdin7muvHbdiqkSJytP2uHWWnRoaGd1
36489	payment	2134	2134	1874	1	1	4526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk63GaETbjzDaRSS8pH7xdLUpytNuVP3dbcq9Vw6WyB5gexM84
36490	payment	2133	2133	1874	1	1	4313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6eZuRnXEa56SqdCgoFse4jqCidQ9S3YVdiM4siBge7XxbLJy
36503	payment	1397	1397	1678	1	1	14088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxjt5tvp2E7reXpuaYuNNP2N3HsAM8Puu5BdsL7sAqBj3X7GM
36504	payment	1397	1397	1678	1	1	14089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1z9aJFucfuahgECAGHFrzHi1Eq9z94YynPHpQDZKaGVRikfEV
36505	payment	1746	1746	1075	1	1	3	4569000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYX5eEurirm83uPYkhG1B7AUZDAyUXmdTSghU3xTquFLr4Buak2
36506	payment	2133	2133	1874	1	1	4317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oESksU9Pgv3eaj1hq7VSVPTuUKjbZUFPdBVkUZeKZg23bzGk
36507	payment	2133	2133	1874	1	1	4318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDADXdsbYpRxweNcFfiS2gzXTfDfYXv371RVhsLeWXbnnh7GU
36508	payment	1746	1746	1195	1	1	4	3083000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpZqGfjUgpURziQ2joUhSWQ9h8qSaddSWfixtMu877d7Uv6vHxgF
36509	payment	2134	2134	1874	1	1	4530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4e5LWNFVQQFzjebZiyHuMYLBnwMaA3p9voqKQ7MuZQHgAvp5t
36510	payment	2134	2134	1874	1	1	4531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Q7KcpjEzkmpjPVzcorKH3EEtjni5fTHcjX4GSZeHkENP86cZ
36511	payment	2132	2132	1874	1	1	1259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLjsrbwfowJhgGFDzKBDuhQdC3iq3QsZYbrMECfNaPtyXpDmCi
36518	payment	1397	1397	1678	1	1	14092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FS1E1NNMHrTkA1e2Y4NvK6Ejq5jmyBYsomL2M4euQDoMUFVM
36519	payment	1397	1397	1678	1	1	14093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Q5iQ65TXCrZpU8xDiwsBRNyLXd1WKfqVYyEdV7cgU5PdcXzW
36520	payment	2134	2134	1874	1	1	4534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb8ighaazgxsS2cBbWtCbMnDGWAzhDSapR22mqL3aT1qdrsZP2
36521	payment	2134	2134	1874	1	1	4535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4uD2gD7xe15tG5ax9LWnAB7AcrqK2Y6PxmESdx6gEGB4MdEj
36522	payment	2133	2133	1874	1	1	4321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwTPMCXw5mc7U6yhWcEGZq4ux1sTbx6rdXPnFQYvZUFagzQMH
36523	payment	2133	2133	1874	1	1	4322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xmJcA2DCr7ZjVSm5WAJRZYyxKuYwzJFrsQ4MdeRKRzR7jbt3
36524	payment	2132	2132	1874	1	1	1260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpJPNJYogq3cyUGa5HScC4oGE2K9EegtprYYe7RsnuzfeJecD
36563	payment	1397	1397	1678	1	1	14105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACiwKA8WMTsQkbZtqCLTXUhXcY2J5pn7PSis3iQuyRLZTYm3H
36564	payment	2133	2133	1874	1	1	4334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp1vEsKg11ym1sSG9szKp7H9MrREL3xwrYjdgWVtQpErjmrwF
36565	payment	2134	2134	1874	1	1	4547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8N4zQhviszU359UDuHUJVKe3evKad4bkU9ibwMbYAizAo1K2b
36566	payment	2132	2132	1874	1	1	1264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PySBX8onF4BHUZev1NKPErTcrGGuX5D8FqJ9nitodJyyGxmY
36592	payment	2133	2133	1874	1	1	4342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEQUtAuQVmHF5iF3o56NHTsRPNaQEbiEA2Zfr9BGAqauddmTk
36617	payment	1397	1397	1678	1	1	14121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RyoUKmhL1rURnXXJFJ7w7rMsqtKXqrdn1TSwbddyHKMcehuG
36618	payment	1397	1397	1678	1	1	14122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZGPzJBN1u5R2LANjAnxHJ4oC2fwkUJP8KZxS1sYSDqDDVe67
36619	payment	2134	2134	1874	1	1	4563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKmW3vzn4apcbmDnZWur24trjyzXuGPGjRoktVEXBD7HBipgY
36620	payment	2134	2134	1874	1	1	4564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzj2ysM9m3XWunDoaBR3hGLSr36LQgCdsCqw5zQ6SMouo83Zf2
36486	payment	2133	2133	1874	1	1	4311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSKHaLf1pCCw58JfbNrxi2LzirFbwRuejtvcWJu2F7XBELSkLp
36487	payment	2133	2133	1874	1	1	4312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHnzPZ4hQRiT34VDtEcQ1n1tvXFYdVBfAsQcpVHctX9X33Uuh
36495	payment	1397	1397	1678	1	1	14086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1i7LNW6BcMxi8kadG1eWmpkGPANbzAKkrywTqPHe5unnQwFa
36496	payment	1397	1397	1678	1	1	14087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWScG35qTURTPkTQTRuAD3FR5aH5XS9Uqg7v4BwGbzA5U3pmx
36497	payment	1747	1747	1321	1	1	5	8591000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpYQRPikVpgfXdYEEcUhgmou6Km7PnsvT5TRnBB9WgS65seeADa5
36498	payment	1746	1746	955	1	1	2	2550000000000	1000000	\N	E4YgzVhvXKMkkFthDwasJG9dqayc4mJwmcWdrHxJb3ksPyg5LiHro	CkpZM8bJiuN4B9s7f6kyyxd6RfJNnR4bYFjkCjZ5U9yNWQLidvhKf
36499	payment	2134	2134	1874	1	1	4528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTNiP6h6PsAgKbaPX8KPtnLWuaBao3sJVrFqk2jnwB3ssjnRD
36500	payment	2134	2134	1874	1	1	4529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GFSRLYXZD29S9biLZnwKWitYcjWPJYWkgjEP1YFqiUqw7Hor
36501	payment	2133	2133	1874	1	1	4315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKo2PgKsrh9jvg4owqa1XJJwHdtGv5wHuXpnAwcVxPBhTYe2o
36502	payment	2133	2133	1874	1	1	4316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLgnoCdCYAgL1FpxxdZKJxErxkvoEbL44fc2LFtfAzJBqEmvt
36512	payment	1397	1397	1678	1	1	14090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBM4oRgyEFQXcqFuKXJ7zGZ1A7vJ2j1rR2RYxp3ARVEmUfLqA
36513	payment	2133	2133	1874	1	1	4319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjckGK7x3io8zpYrAVVsnZsMmy6gEVsJtFHv2dHXsH7L2MkTy
36514	payment	2134	2134	1874	1	1	4532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzAYB9GQHZuuWozXZYoegNH2MGohFp1GRAFUvd1YMx1y7vDeC
36525	payment	1397	1397	1678	1	1	14094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXF2qxHE15epgcgSwX4j4g3Lr483GrfUdHJ2svtbS7tEXPwEki
36526	payment	2133	2133	1874	1	1	4323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYGENdSfprk9RffVjmvNurLsxyJz4ysKfJwuZQy8okQBBN381
36527	payment	2134	2134	1874	1	1	4536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5mt6TY1GhX3b6iFo6dmAbJgPbxdwpJwL8yg1TpnfC2mDuLte
36535	payment	1397	1397	1678	1	1	14097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG6b3K9hCTUBE6WfiZCqYG5pjTvwg45v5WRreceQrDcgpHFymH
36536	payment	2133	2133	1874	1	1	4326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnGeGd8BbyVHoqcGS7btbGWd7tcK7EKWcwaoNPDEvUWE422jx
36537	payment	2134	2134	1874	1	1	4539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83VGxqfQteUVz5YXz4Mutkadh9Gu1ZTy8qnkbAUGRKLFPb4i4
36545	payment	1397	1397	1678	1	1	14100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUaQUa1Kfe9gTKhaSfSUC3bDKxZ1EjmunJtzVv6AZwZApCZMEL
36546	payment	1397	1397	1678	1	1	14101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3VGJXwZoFmQ5xZshetZ1tZB7R6eRVAvRt7k3xd85AS4mm4yy
36547	payment	1397	1397	1678	1	1	14102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGRCdBvXQiWBu5LG4xVhN1Y8i6nBwWPtBLqiimDjTmN3JJJEt
36548	payment	2133	2133	1874	1	1	4329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVyJGuiWVxvna5iqsVej1qjksEqP8LVGefNSUFpq7Atn5Ug3cw
36549	payment	2132	2132	1874	1	1	1263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFeuksMRG26VwmWEcuZLhPkv679Wos6uZhyFo1xdjKhrnhHXW
36550	payment	2134	2134	1874	1	1	4542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNN3vF5U66jf8PrkR8s75VJfBdJboYNkuh7pMWmHPd3T94bp4
36551	payment	2134	2134	1874	1	1	4543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTj2W9HqqXB5uE85uGwZqBxgPxpkUuUmFhMDJ8yKmJ9dJeJjnb
36552	payment	2134	2134	1874	1	1	4544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTaUgLF9vhyBjYjRR7P971WEFAJgtFRLjuia7wPDvSrwNZvZE
36553	payment	2133	2133	1874	1	1	4330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGCEMUHNAEsvciWr7hzNCbZRP8q64XYHpCV3pvGziYCjbUrbt
36554	payment	2133	2133	1874	1	1	4331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp48U8nEEjLdHrg7onNdguxZrwxtjfLvEdhSJUzyq94ycggwf
36555	payment	1746	1746	2309	1	1	5	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUh3w1DShagg4jRjUNnAscbNomURAM215bHSegHdZCHMRUqet
36567	payment	1397	1397	1678	1	1	14106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kJLDDsnPK314UQRAgBf7vWMx9T1KK8SttezsJPE9boAYjDPK
36568	payment	2134	2134	1874	1	1	4548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAS1LF6fyqJTw2MjwXDdPUevjy88C3vNehuoe5NnarM3wVoUW
36576	payment	1397	1397	1678	1	1	14109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiu8LJEMLN9YxLYC4h2JrUsf1qqcB2MR3qD6ypjaKscdpmi7S6
36577	payment	2132	2132	1874	1	1	1265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMzznewohqsD4hg5eamfphHF6QATrqvGr8zvRo4YxzG5cTCTq
36578	payment	2134	2134	1874	1	1	4551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuchHzuVKScXPmXoN7n3FFF6uP76QGRw3tJ3o4iRSXF67432af
36579	payment	2133	2133	1874	1	1	4338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoLduCKSd7Sdskzpz3Ky3bqTeBK3WRnJFnvSo6ZLnpxXgVGLH
36590	payment	1397	1397	1678	1	1	14113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYVxuTUnXa68hc9PMiXMGcUv5ePcz4Tv2uYRaTtA8tkfiNShC
36591	payment	2134	2134	1874	1	1	4555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnduJzKrzyrJBDEXtDQaHDcBdyXPZb5HmFGCMp1uHuY7ryPJt
36603	payment	1397	1397	1678	1	1	14117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDEwHKCugYnaV2nkzZSdTw8fX4VP5353XRj4xki2Se83sSPQ4
36604	payment	1397	1397	1678	1	1	14118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApVDL6ZEBk1D2GiYQrN4VQeTCYCtrQvPLnBuUCkfzYQXG7jkc
36605	payment	2133	2133	1874	1	1	4346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPY1DwwdGHuA4w9CTkyKNuiJzZxCTYujby2qx94sySwsNKsLr
36606	payment	2133	2133	1874	1	1	4347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECj3Q9qTkrFrSpq5TGAcPPMyGTocSoqvtV2vJbEerGz9C7fop
36607	payment	2134	2134	1874	1	1	4559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLRTL3MFnNo5ecVRYkeJRyiHSsNFibmXNJweTuMnUi6YJ8tuM
36608	payment	2134	2134	1874	1	1	4560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdYSs9SLbvCPgqi7XJpEiNPdWWYVLMr38gP6xdAPKnC4fRXBNL
36627	payment	1397	1397	1678	1	1	14124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytcTamBaKTcdp7jyL86Ut3XkaFR8An3tsbZy4wuviAzvwz7g4
36628	payment	1397	1397	1678	1	1	14125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLZb96gufiDgQAWKAJw1SNifNffV6vn9eDw9XZVLEP3CC9v8w
36629	payment	2134	2134	1874	1	1	4566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRzPiaoDdGMrdQ2AsNzbYrAM7xTWRSnXShsHNj41PTcM9qwo7
36630	payment	2133	2133	1874	1	1	4353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZL1Vi4at4kiqD3VakdDJDBzrbPU3xYaWDzSHuGbYdn6g6akN
36631	payment	2133	2133	1874	1	1	4354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1xWnkV7xq6aHKKu49S8V6ZZT1tUUXXg5QkxUFeVBa7824bTe
36632	payment	2132	2132	1874	1	1	1270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q82kaTFAoUoyw4aV2PUuoUQd8nFDXwzS1NFkAdJSVTkKZRRj
36633	payment	2134	2134	1874	1	1	4567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFMamfHraStfurUsFiiUUXW6HD3oUW1bKwqS67W2u1cW3Wrmz
36658	payment	1397	1397	1678	1	1	14133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKVVCTKkvbzeedwuqm7isq8W9ZvTfnkAPBjRoVckvBZAtE1i9
36659	payment	2133	2133	1874	1	1	4362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjAt6kRULZY4GRYq5Eq5nEdPRSvNPGA8GYbLniCvjaZDjmars
36660	payment	2134	2134	1874	1	1	4575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGiDjkPHVeoDqGrtdZQC1zbfTSAD518yN9Yre8hu1hUmMk8eF
36661	payment	2134	2134	1874	1	1	4576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7udXHkz2x7VehX5j3MXaXbRGNdB4w9cDeeg6jfNQ1tyiWaV1
36662	payment	2133	2133	1874	1	1	4363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dBGcwQ7xo2BYPDhQGw9gAkqtoS8nq14fbbBDCWVfjeEWiUHH
36663	payment	1397	1397	1678	1	1	14134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjEo6q7CNeZrPqQcqvYFtuz2rq6UjwPVvRnCorKQZHrRQSHDhN
36664	payment	2134	2134	1874	1	1	4577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzSTRFzd5nCDq1ivFtkDEE89Xb38KqTGS2cVuZW2d2bJLmntRN
36665	payment	2132	2132	1874	1	1	1273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u3Q8kvnp7UrQBzD1P4wnWvSmhJiWzatxzgZfcbVyN77X1Puc
36666	payment	2133	2133	1874	1	1	4364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaLK3AGNTQJgZ5RqDCG4BkRuqDtwgrUQmmPnhzv3so2cEJhNU
36705	payment	1397	1397	1678	1	1	14147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKESsfG8HPJs66ACfGP7zn4N7QHno28p6FG7yamYEeKt6J65J
36706	payment	2134	2134	1874	1	1	4589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKsZwEPJDKQtif4hDzuY6886s2TdrWArUW9DoVquES5Mbim8K
36707	payment	2133	2133	1874	1	1	4377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoNKkmiitv5udbAWXWKhgjxKFf9GTao9iwfjg6jnH9P1AYYFM
36725	payment	1397	1397	1678	1	1	14153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6q9gPhzFKY4djNicvg7wyKxh8nngnPGTfLRDNdF5WFsV1xs2
36726	payment	2133	2133	1874	1	1	4383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXKyDiPwp4bRGBoWD8QNemrY32RaR9FP83e6szie1CSFgAfNUD
36727	payment	2134	2134	1874	1	1	4595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Z6rVL6MuXhaGcTpjMA93PcRRRXnK8F6AXVcwv1jjsA4XYQoZ
36732	payment	1397	1397	1678	1	1	14155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgUnLVRzdRLDsedNRRApSHDavkUoxuVBU5sS7VQGUGYusmRUS
36733	payment	2133	2133	1874	1	1	4385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkVV9JgV8ysNs4bhPPFcNqzaZ5469kTFaYGosRNRdCF7vQ3QYo
36734	payment	2134	2134	1874	1	1	4597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucFUDqZJkeHGAgi4VoTa77t4QET1ujjhqCmX5usL7JXTWm1Ad
36735	payment	1397	1397	1678	1	1	14156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGb5KdCTX3tZ3PqMNvosPZ8CQPj5tEKkjP5Z368bSiX2LMj89
36736	payment	2134	2134	1874	1	1	4598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vGGEeqGk8NUV9hPhiGx4KVmj8LXVdNhgkJVT2StdP28et35M
36737	payment	2133	2133	1874	1	1	4386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87dUB2fWce7B74zHcdhVDWQgXks9T5XmbBTr2jMMgMjawYTXz
36751	payment	1397	1397	1678	1	1	14161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yDSZyx9nHTetjSm9rn3WwYAftWAtgiqZAs1byRnxcUBnzbW7
36752	payment	2132	2132	1874	1	1	1281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnpZe6LFwoZ4doo58vBkwZRE4BnS3DgoazM7NfPhbuzKiVckP
36753	payment	2133	2133	1874	1	1	4391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8ugdHhT395dUdoHANpt1bQjR1N1YRN6suxQZzsiZSqCmhzWr
36754	payment	2134	2134	1874	1	1	4603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZVADZ4LpVg1PPVHRUJqm9Qxo97Yn1rFnXdAxZaLShpUdR82z
36611	payment	2132	2132	1874	1	1	1268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYYtCYcGbKEAmYphPZG4AUhPQ5FmarMb6w6BXMXKaVvbWSMMA
36612	payment	2133	2133	1874	1	1	4348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJL2aqCRobCKXRGdbjeeZ376po4DnMirNuHoV1vswSQ3hcrkr
36613	payment	2134	2134	1874	1	1	4561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZabdsQER6bcCuSS7CUfE9wkWHTAzEutsF1NPS4d4tULQUohmpb
36614	delegation	2309	2309	1523	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbRPKTmoAwMf6xzQU6aPjMCaVmEUDBCnQcFR8yx1wjouYCpB8
36615	payment	2134	2134	1874	1	1	4562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMmnSPsam8XpfqYXBjh7QtumWHRbgJt8jCsr7GJnNyrXJPiy2
36616	payment	2133	2133	1874	1	1	4349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhcVXzGuURfAYQXTjVAis3Vp5bUoFxQstjB1rByKpwszkb2m6
36653	payment	2058	2058	2059	1	1	8	930000	11000000	65535	E4YXduXJHpgF6kDkDDhiVGB9nQBNMCnYv2chn7LPAYkFfSWSoEtdr	CkpYbjQ6GSDgy3kVVmhgYGzveH76ysTfWVvJMEL4AouaTLm1wsuvP
36654	payment	1397	1397	1678	1	1	14132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTFswfffSHqQVUfBHpqgJygHsWNxeQuFJurEyAtuD4SVFS6Cg
36655	payment	2132	2132	1874	1	1	1272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wK8MqKeGWFDTodw8UGwXeVKfpb6GDVtpF3itX8VwbT3rMxEF
36656	payment	2133	2133	1874	1	1	4361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwMJBNd3XzqitovX5c9UTpFmvSdiqdYb732LQ6uGVeqJWuCyG
36657	payment	2134	2134	1874	1	1	4574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFqixv8YiMj47AdkUfGtqsovj6qzm6FfhR1w6DGYXLYaGG9tSu
36669	payment	1397	1397	1678	1	1	14136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1P2HD3T7Lnn5nqs9QbpD64dNFoUD96Ue5UXzNmQCsFq5jCUsf
36670	payment	2134	2134	1874	1	1	4578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4x5SoAQfWn23VMsw58LAcmLaU3g8KoFb17C25cyCp7XUceBka
36671	payment	2133	2133	1874	1	1	4366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJF6yGZWMaZzm49CbKd9cmEpqoGY1GppomtWs9tpaGCu7KKW9b
36712	payment	1397	1397	1678	1	1	14149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkb36Fdj5pLwPFEn4mDnc6SF9zd7vVLvs2BmJgewSfWdh5SWod
36713	payment	1397	1397	1678	1	1	14150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpUYr4ExEo3RYzKUqurzDRjzXhRAqJ7i5ghin9HNTB8cB1Zu2
36714	payment	2134	2134	1874	1	1	4591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWdxxqTtP6UAZvriccbGw4oc14sdb28xQmMzNYbxvGJeRSwFXL
36715	payment	2134	2134	1874	1	1	4592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfrdEY7KK3BkaMZ43s7ZqZSWNm86hoQVeiBk72tcnCN3eAUqSC
36716	payment	2133	2133	1874	1	1	4379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmhbuDtcbAgqR4RbTfXfBgiiXbgbenzDuisKs4WthvsUJ4cneV
36717	payment	2133	2133	1874	1	1	4380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYaQqao5Q97yVmh4ZwBBcLbZkCGAzEzBt8Z9HKsGt755f3RJmL
36728	payment	1397	1397	1678	1	1	14154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmcMTVA1cSPMpLajetiKhSLMJA2hB3eMfhd94i1kzSV4VCgCX
36729	payment	2133	2133	1874	1	1	4384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJzwNvN4kKjZPnmRuEJYzutsBaJV2biMgF8wn3mzJGHrjTE3H
36730	payment	2134	2134	1874	1	1	4596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBTGgyzSLjbTmRuqZoX7pj6oEAozBf3UUm132nC8ruYjRwX9T
36731	payment	2132	2132	1874	1	1	1279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7z2zUktT7PJUBZRFpfpfd63JxrNpA3v9YafxvhETJ4uy4mRnS
36745	payment	1397	1397	1678	1	1	14159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvpJqjzeevqC2wGXyZDTHTziCng6pEzKj41t5qosb2KGVJ8BF
36746	payment	2134	2134	1874	1	1	4601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBkDbrZoZwgeFhpef3dALhjRPGETor3D6DvGfrMy8XyW4EmKZ
36747	payment	2133	2133	1874	1	1	4389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8TSEffjzk9LPQDx42AfELnsjJyoFqDnxgxiGCGmVMsyncwvn
36755	payment	2133	2133	1874	1	1	4392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdro9i8oN7kRMf6mbHjMoZk6rrUjEMGn3r1RrLKtSqEWKJ2CEJ
36756	payment	2133	2133	1874	1	1	4393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuRe1emWGJs4ijf4fqnMdQbjRkjrXyiZcv6xLAWvfBvSj7jcwK
36771	payment	1397	1397	1678	1	1	14167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCQzy5MJAHxPhw3cjKgdWYccmPVjzKCveyhVc13TSBueYSZwze
36772	payment	2133	2133	1874	1	1	4397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjGny7tuskCnfQtAvf8Pi4zjJkF5AVeJm8NMKqgUaoapXn1CP
36773	payment	2134	2134	1874	1	1	4609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LBFEQBYLNwY4Xv8enQ6wQEeHHsdNieVWU1s17TCqfTMeBi1Z
36781	payment	1397	1397	1678	1	1	14170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaEjz9LZYHrHgdFucczMsHgSSEjHNRjxUagEet6akXuZK8wmgQ
36782	payment	2134	2134	1874	1	1	4612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfmpsh5MYe9sFYiaEvWNJ54vcGS6H5xWQnoSCvL1Msdc5kMt2
36783	payment	2133	2133	1874	1	1	4400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXEQwbWgi8qXBWNVaLHpk8kY4m3MAH8LPH9a31gWLTFKi3Up9
36784	payment	1397	1397	1678	1	1	14171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9anzdc1bxirPmaCsPTBzRKzqWEZUzue36hSM4ncrc8g3TUSwz
36785	payment	2134	2134	1874	1	1	4613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8xXiBdeHjXUzpbWc8Y5z8kZGmG2xSyoqPsDpYDTojX5gPgoV
36786	payment	2132	2132	1874	1	1	1284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirLw3CqsFpXUMt8y4vhTpgfsuQi3fSFpmrGkLDJ1cV21UDw1X
36621	payment	2132	2132	1874	1	1	1269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZpwbvjBnPT9oHqzAiA3vvnuc2x48VWVLmJtXgTAQ3o8CpbYE
36622	payment	2133	2133	1874	1	1	4350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgnfRUYbw1GcDbqbsPM4ntkxWDTBGZGDvSs77y1a8GpWA5mhK
36623	payment	2133	2133	1874	1	1	4351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjNwENTeerLMPxHNce8zBtyzDyLJm83as5ra7tdCDHjsAEnbEr
36634	payment	1397	1397	1678	1	1	14126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHMqJf2g74ZgpkFC2f5vCQbozrkxCwfVdpvFof3sw3p5CYNJh
36635	payment	2133	2133	1874	1	1	4355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKaFLinBFmihck5qoxxEPvypiqAuE34C8XfpaCY9yGfRQkyYj
36636	payment	2134	2134	1874	1	1	4568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQifCikTSZJWXJXXjmSYVueiipdpjgF1YzHo5Ndv4HqW9ZM78
36637	payment	1397	1397	1678	1	1	14127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqLmAPXfN7fZ9Rc5VJ7af5HR2jtfnFxE61wBCjfg3WigdB4hpx
36638	payment	1397	1397	1678	1	1	14128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEk7aQu1scxQy2yC37UFGXeSRXJSaJxQuRy8jUEHKZTtrHtaR
36639	payment	1397	1397	1678	1	1	14129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BmU7UzSHD4oCvcW4HvJK7a8neTqMuUaqD56zG9Tjr7Spj6KC
36640	payment	2133	2133	1874	1	1	4356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19t8mFAxifWRuBhmNzDEfdY7D62P5r5B47GLPAAJeAoABLcNy
36641	payment	2134	2134	1874	1	1	4569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6GcHBLaMyxupZfMFkwrv2BGsHiDD8mAksqEkPyGmkrxBNSE2r
36642	payment	2134	2134	1874	1	1	4570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWA4Cen2y6pt4VXHre9UnwVtnkDZ9t9aPY1iZv66Mgu1VSrPpw
36643	payment	2134	2134	1874	1	1	4571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwYpont8UDVxp6gGDxZhrCon4Ttm8pBxAMqpPp7MXrTKqGtzb
36644	payment	2132	2132	1874	1	1	1271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXJ5CAmB91Q9UH4aMhfxbxvK6Dr6dnnk7hXNN5anUzUfshZuXk
36645	payment	2133	2133	1874	1	1	4357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUabZjHH16gBPycjLrNRCCjUuf7jc8EqirpXi2xPZyV72L3Wa
36646	payment	2133	2133	1874	1	1	4358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxaegm6cXJNsBb1erBe6RghUhqRU9MEmHqQn2Wz2vL4aKmucUB
36672	payment	1397	1397	1678	1	1	14137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZ2fJBxqJ1YHzUTNjHWWi4JZD8abPoQw79NPWogN4CJDGfigH
36673	payment	1397	1397	1678	1	1	14138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSwockrKDWj13JBuX48sHaqUWtDXtJFXMLXf25hTg4rf4Su17
36674	payment	1397	1397	1678	1	1	14139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfQC6jWwN7Ps3oe5h6HghejaNWatudCk3FLt8pJDp1Ybg2ejx
36675	payment	1397	1397	1678	1	1	14140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwZY8f4JfNVwmaVzds5uFp8RFUwEXNc2eT3tfy5s8qSnWGzU3
36676	payment	1397	1397	1678	1	1	14141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sXdRYenrSMpZYc8RbMaytqLHttKjBV7aR67Ei7JYRQh8GWfk
36677	payment	1397	1397	1678	1	1	14142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwFjTPnG2uchnEWhmnEWYqaNyqRBnYnUFxyy2jJr8vp3xmQL6
36678	payment	1397	1397	1678	1	1	14143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5MCrooXKBrhSk6rvjW81Nms8uV9GXHxBspJQFywgBukmQPZr
36679	payment	2133	2133	1874	1	1	4367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjnqjaCn7ULoEYkGbDJL1fSByWwc4UexBHpe1xJwoXutMijKj
36680	payment	2133	2133	1874	1	1	4368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPHQUrjj8ocxvyZjXLmkSwQXs9ybF5Qpm2umtb8bzpNL6xYgm
36681	payment	2132	2132	1874	1	1	1274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupLpWqu3tPPvJG1yfqHTyfmYbRuqPUV3TD2rvcT8w5Y5pEVdR
36682	payment	2134	2134	1874	1	1	4579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6dsxT9HdifubGXG8KP9nW8WcPaew8P3yZf8r81J11d8889XK
36683	payment	2134	2134	1874	1	1	4580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgYZTj3hmpLUYhwYUvE8xVPQkjhMiZbKAQHGFE53rZHzjEyDDE
36684	payment	2134	2134	1874	1	1	4581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN26mV2dSv8ow2sngWw31p7yjnQSRA1M5P2qFNM8Dhayk68YQp
36685	payment	2134	2134	1874	1	1	4582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA53TxFrr67nQ6V2vbGbKJ3qQDyqxPiikNmfmM3FbDQq1Akmzk
36686	payment	2134	2134	1874	1	1	4583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZieBRXTF8D9QpbtxHVjWX2tAAkdBzdJ241CpQJ5qDPRBHuyqBE
36687	payment	2132	2132	1874	1	1	1275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjSJkrMuZ1R4kGTvU1z6e1MDdiBgkJJBxD7rtxTyPCgk8TDM3
36688	payment	2133	2133	1874	1	1	4369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwsqyWqQVkyuxRsFpqqevDHDmQYb1DsqkxSPXEKB3mwxzpUaMG
36689	payment	2133	2133	1874	1	1	4370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqrjdSU4DsNkHsNmXkVH1CUkRLPTxjsPMEwgEb98RUSgxmGbr
36690	payment	2133	2133	1874	1	1	4371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnG2nrQF7F1tpeddTca95ziA1Gmf9HdoSdjnrH5CH2XDVAQCC
36691	payment	2133	2133	1874	1	1	4372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUTPGHVMfyzVH4NWdzCcb9JtqEMUR5cHfufjEDUAWqmKjG6GJ
36692	payment	2133	2133	1874	1	1	4373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7izoB28LuNcNY62LwchzBRuBvPHWUUMkWKXU8RNsrMubnQZyC
36693	payment	2134	2134	1874	1	1	4584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLwei7wBYTqCfC8gsYh7RJFTSuj8FgAAGuYNLWdrpGa1dRs99
36626	payment	2133	2133	1874	1	1	4352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwNdmqVyKRF1GPjkeyLsqqCFcrhpR77PLNP5AZgsbwiNStaTCV
36647	payment	1397	1397	1678	1	1	14130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumAoTGGiRnMeGjCneo1TRMepi6VmEgoAPdVMSmWcUU4vQPUWN
36648	payment	1397	1397	1678	1	1	14131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqa9VjQhoMhAdtyqbTdvgYGSt6Vc9xks481v5NJwSKaiNssSgY
36649	payment	2134	2134	1874	1	1	4572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9ciju57CirAQiEstJSU3iesoezqr5fiiteotgYcWcTxvt1jA
36650	payment	2133	2133	1874	1	1	4359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChia9QU6ic8wMHGD4JYgSKNL7ntuoB4nrirbQt5p5YTjuj77y
36651	payment	2133	2133	1874	1	1	4360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMJysPnXRKynVde2p8XeAUx6ewMFRnJr5HLdCBL2jKRiff61q
36652	payment	2134	2134	1874	1	1	4573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiheUha2BkoAGsAnbd5hEx4V7EytzXXbW8ucnkP6Dc8GAACQxm
36667	payment	1397	1397	1678	1	1	14135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPCdqkoYhDobH3zFxA7GgfezkLKSyBS55xHbx4FBboGBcjC5Yi
36668	payment	2133	2133	1874	1	1	4365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWb8UJSSbsnQ3iWPX5bKd2FvjxeBjq3UHDNSNTmkNSccU9MWkM
36695	payment	1397	1397	1678	1	1	14144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbTpfpg9z4U9de1Y1jmkr2aqb1tSCUFe2taBEp1EwGJD9T1Pv
36696	payment	1397	1397	1678	1	1	14145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqnhS3zfQK7cfbU79kjDa6NTPTPasv3yJ7GbAh15GByNgkggM
36697	payment	2133	2133	1874	1	1	4374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFEBQwBRaNzu17zewayr4AYsKv393sUXt9sRbhMJcZxhLCJ7n
36698	payment	2134	2134	1874	1	1	4586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbGN31foHYTsQuekGkNRDFDXnCRxjjN6HqG9itkR4fs2RDdwX
36699	payment	2133	2133	1874	1	1	4375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGnwdM4S8HTxsFECpJVTT64Cr5REVub82poUh4zEZiX45NP7d
36700	payment	2132	2132	1874	1	1	1276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKQACWUkrUi8CbVehk4R1Pz2bdERKncevHjA2kWAHXYYGDmf2
36701	payment	2134	2134	1874	1	1	4587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhYZxYfWEA1mFznxrqm3EYzZFnLeB1VTcHbcfUDKwrA919vkp
36738	payment	1397	1397	1678	1	1	14157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sRV74U58kLN38n4MuQUMvb7pME8MbAv44CsdzTLzvsdvqEb9
36739	payment	1397	1397	1678	1	1	14158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQA2Ay8gmFK4yNCEAePU6bHY2zWiN1rQXT93uaTToRpehY5kj
36740	payment	2133	2133	1874	1	1	4387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrn9SjhEq8xLbfUVJpPFMWeNP9y6i4NdppJ3jFEREa5V4ZEor
36741	payment	2133	2133	1874	1	1	4388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoWEzgM55bM4xGAT2t3Tkev7oXeMYZRjUkFxXjvYECjZNtV4W
36742	payment	2134	2134	1874	1	1	4599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19tDVALx46gMtYsy1G69qWsh89QKWU7dVgz8CDtmw2dY4hT3D
36743	payment	2134	2134	1874	1	1	4600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4GiWvKWT7585UjVLQFXBRfzE5e6Ky6TZisgUMcSxGwMryjyCo
36744	payment	2132	2132	1874	1	1	1280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVp9Uf3FnzGmTDqYBWS4gqBbeU6Xz9QR5sXYvg4P4cqKxZuEK
36763	payment	1397	1397	1678	1	1	14164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4NhJkUANkjVXK1m7TVUhgXw3fEXMrnj9SCt8Tog6vCcaKi7R
36764	payment	2134	2134	1874	1	1	4606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRYRvUcHVGsGT5Wat8mbvMdtrf6knrpejEEXGXcdhUYNrZucB
36768	payment	1397	1397	1678	1	1	14166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzgL59Utfwx6WPpQZtAgFehWSMB5eEEA3tVqfx5Bs8e6rGUGV
36769	payment	2134	2134	1874	1	1	4608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTMZasv7CwDhYz8MV2AS4FTKFxUDwzwymeFUBuLJez8vswEXE
36770	payment	2133	2133	1874	1	1	4396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxpwho71gQcoQ6nw4WEuNz1etddLYj2vYz975FzGkDyY4H3QV
36794	payment	1419	1419	2310	1	1	6	1000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxra2fuSZGdjXX748FPtAZuAa41PA16A3ruFRzYhxyXjkUGQjV
36795	payment	1397	1397	1678	1	1	14174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtE1sMNoyReVntTSPkkK7k2M5tv16PqwYpfM8szLwxiAnnZRD6
36796	payment	2134	2134	1874	1	1	4616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLzbdesY9hp2qztGRCAbow7oTpXvAHuvs8s8wDpv7tDMvQxCP
36797	payment	2133	2133	1874	1	1	4404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutyL96Z1kBVepHbF9KFtRyK2vbv1WicjgG5qxq8w6mX2cnPFf
36798	payment	2132	2132	1874	1	1	1285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaK8VJQfhHZHd395ATWtAUUKRkR8ZdFnsdq4eXerfr9wz7EFE
36799	payment	1397	1397	1678	1	1	14175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEv5KM5X8aEnWS2dzPxVGSSuAfaoSjYh6N5LLLBypuEKrh8fKY
36800	payment	2133	2133	1874	1	1	4405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bQ6xe6k2fz87iu4YuGjxomhgyo9PbqRPc4gHChQDzU45nU7V
36801	payment	2134	2134	1874	1	1	4617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu8FQrndFWDXiBHSPuPGhmMPyVJfbHCRBoD6YCrsRy95s8F7J
36808	payment	1397	1397	1678	1	1	14178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiDq6dooLruMKgfQoPyJ2PT4Qs17zjYsYFpg3chjSxrJgApf1a
36809	payment	2133	2133	1874	1	1	4408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDyg9JFoeVjAX22aDnCcuRr4nGCQiVm2ExQWVBAdaF7DQShwDY
36694	payment	2134	2134	1874	1	1	4585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Qt2vqUajdzouVLKjJie4fWPA5KHecLkwcz9ge9fWkkDM6Jsj
36702	payment	1397	1397	1678	1	1	14146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5R3HT5UEQcNZLCPKZVCs9TtHQqhNbrZEf2jCiU5Usjf1JnSsA
36703	payment	2133	2133	1874	1	1	4376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHaqqLrQgT93Cvkg4iaqqxY2tKZvPXi8BzWSgbRkc8kknVYhk
36704	payment	2134	2134	1874	1	1	4588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfydBkzU7TiSYuit1pBPBuDSFA7peu7YemHrWEgBKwegaqQPEX
36708	payment	1397	1397	1678	1	1	14148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqZmeiF9aLMVyxFLNuYUx7dZUXzAKPRB8YrYGxXA2iKxLsG65U
36709	payment	2133	2133	1874	1	1	4378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoT3t4MMTYJP9kT3JsDy9CzBBJHpaQYn8oDMRhmZ2gfg1Jj9i
36710	payment	2132	2132	1874	1	1	1277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLzggBkyfnYWmNHgz1AWo2Lj7Um5r6xsTd4BrtCpTu61zdEME
36711	payment	2134	2134	1874	1	1	4590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzwu1m2cBfQmZ56gQZfDTtXV1n1LmJsBW6hWtgZyUnyQVwoD5
36718	payment	1397	1397	1678	1	1	14151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3hSNTuchxqomMH7qCoandgbWDnCR1jivXxyArHwfyHtHWJijX
36719	payment	1397	1397	1678	1	1	14152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdk5xisKBDyx2MrWRVbEcm4yw5gE44xqsnVKSNWCwU62m1G6NY
36720	payment	2133	2133	1874	1	1	4381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnWHfiRuTZSG2bBTqiFMSDKQkFCmEi1V1LqKPAmwxd1aDKJUA
36721	payment	2134	2134	1874	1	1	4593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbwrMQpVnHeMUaT8Sj5AiWWTbWyNKDDmagFcoiHhs6DAXqGZC
36722	payment	2133	2133	1874	1	1	4382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6q2DERvqMRwL9UzSYCqWtPXeK2GHjLtuzdXU8ai6NPP1VziwP
36723	payment	2132	2132	1874	1	1	1278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzFM4YTZm9sqV1WyGggdQsgxkvUorGPDCUPWuwaYX9npRSgtd
36724	payment	2134	2134	1874	1	1	4594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUX8tw6xjVpjd7VSC2Vq1QdZWXbMjGxa8PQmnLMPqFoaV5vMY
36748	payment	1397	1397	1678	1	1	14160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUa2h7LeLMjJQCepU4AR7n2Yg8fEpjxihgAbyGSd9xz2YDHVe
36749	payment	2134	2134	1874	1	1	4602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFvZuMT1xfYHMv5wn8CpKmnEjLFaQChPzNrjYKA9fTJywhH4wS
36750	payment	2133	2133	1874	1	1	4390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYukWu4zTmLSW5nVRpQQjo5MyHpRyUMXQQhoCfotTrTvfCQ9mL
36757	payment	1397	1397	1678	1	1	14162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgxors6THudbRsNysvM4Rh1cqATWQ7ZuwmbXHLbxPkjpEvuBo
36758	payment	1397	1397	1678	1	1	14163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7F3SimiAzhj48p87LuX668XnBPBReTvfxjmeutnswPNeiosQC
36759	payment	2134	2134	1874	1	1	4604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1o5LZZsAVQLxvDYY8pFZ7pUqbXLfB4sgHXrNR8KCkaTuvTRkn
36760	payment	2134	2134	1874	1	1	4605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVSUporr6QHenJAYK9aYdCyaD7mwKDJWwsi5VYisGNd75o2gP
36761	payment	2132	2132	1874	1	1	1282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABP2JZwxRPbavL3WDLGabfF2LvCuSgT59x3nzHVwMiuLvZFcW
36762	payment	2133	2133	1874	1	1	4394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubBCxFCcTHT9ZHLzeuw8Bgw7mkJuwaSEX4x2CCEP9camyfUrE
36774	payment	1397	1397	1678	1	1	14168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyH1uVbSdo1yZbFEi2cXikZDcAvMbDApK8ir5f2CDytdRnBTB7
36775	payment	1397	1397	1678	1	1	14169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMXg2rfdeZdJbMy14ageYdvnBu8VumxhZVV1M1S6aSYRWZvyf
36776	payment	2133	2133	1874	1	1	4398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRTYivZBhYH8LTjgCsWU9y3c7ahpfqXjRswSqHRedDoFMNwHk
36777	payment	2133	2133	1874	1	1	4399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYpXj2RB4tP7E9787C7nPNfpmj71TvUxsX4B3tgvrtBaf2ZM6
36778	payment	2132	2132	1874	1	1	1283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7evGsP4HNkWCTriKfWXmKLP26Fut4wKLTD2MW5Sw6Nn7FU7J
36779	payment	2134	2134	1874	1	1	4610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKPpzm9wJvAZTCicg8XxKHbvJHsYSACw9pMs35E4LgFPj88CZ
36780	payment	2134	2134	1874	1	1	4611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFG6MrbWqYWikQz7fmdWXstVg3K2RVpsxVeBzMNZAmpm8cCMhz
36788	payment	1397	1397	1678	1	1	14172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6KqjNzAHEdWnxM7aRncdHpZXBEo4cFbCvb6uJpNCQdkQ1Sbc
36789	payment	1397	1397	1678	1	1	14173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3GjD2dw1mA6bF8F56zNwqKoKKb8LFhA7mEkY64uPUGDzYZ6yp
36790	payment	2134	2134	1874	1	1	4614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgZHTDWeGyyFx8kbJZHT2bmvAjZFp9WzgTGXGQHeEPctmgsRA
36791	payment	2134	2134	1874	1	1	4615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMtDV4DZENfCg7VAyKsWpK5GFjeaLDVJ949gu8JQyoptM7qCq
36792	payment	2133	2133	1874	1	1	4402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jpKZWRSjLgf8yBvop8vJJWntyehcXLPi5QyKGxsKvj1VU4zP
36793	payment	2133	2133	1874	1	1	4403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTjU8FjzMqRH4Xm94KZrh9he7uzxeTLmXvU3KjpTD7FxqHotXX
36805	payment	1397	1397	1678	1	1	14177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiR7xm2PgkFPotnoEXeL9bvoqKjTZgmTXRphmQanoNFQHL2Dhc
36765	payment	1397	1397	1678	1	1	14165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqXWjs72vQuNWnzXnGEPjpXJhGu2imeBdkdbx1vo8aAAhYU4p
36766	payment	2133	2133	1874	1	1	4395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9sibnDLrqJVKmim4ZfhiAqjj8ggx7tLSeopbjf5Ls1sWEcwWs
36767	payment	2134	2134	1874	1	1	4607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5fo7HDgUMVf6DRBKvnumKkTH4ab6KL72VXqN3iibgoFQ3usC
36802	payment	1397	1397	1678	1	1	14176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgsZJDER4gWnLkRzFMwQVRCmepV2VUxYGsdJp9KYBmsdpp1vF
36803	payment	2133	2133	1874	1	1	4406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDgdT8u6cFCMSU5wUNG3fXrrDYrRGhbz4yM9FMf99Dvebw1ct
36804	payment	2134	2134	1874	1	1	4618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKCQqTQrXtNDdGm4NciyG4XZY9TFNpDykwfiVdrEcSCCwb6Ch
36812	payment	1397	1397	1678	1	1	14179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Tdob1QaptZwksdmarQr659Aktz1aSsrkm39D8nMfAQA5WyDJ
36813	payment	1397	1397	1678	1	1	14180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGX6qSgxnWGN1UxCES7Yv6DzHYSpCm3wwcs8JRmGxV6n3abnQZ
36814	payment	2133	2133	1874	1	1	4409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY6SuGM49kwhaVX9uYxb7bfbiCkmmPQtP3JcMBf628dG3gvpsB
36815	payment	2133	2133	1874	1	1	4410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7LC8jCynXKangeuao558Nj16BBcHuPss9iPZv1ECzUMGgcRc
36816	payment	2134	2134	1874	1	1	4621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb2gF18u8AoFAju8C3JrjKcRbtx1sUvERyuLqNnHYMZRtKpr9
36817	payment	2134	2134	1874	1	1	4622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrB1i4C2rKFEbGXANU7CmGaFnFqUokXSansfmYeZkKZFjVu48o
36827	payment	2134	2134	1874	1	1	4625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVxSEcVD1mAwMevwTpe99MDL5CSZtAu4wubKtbvyCjFqdXyyU
36838	payment	1397	1397	1678	1	1	14187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWocKYgSfnb1KkTcGyp9MwZqnW7xbdxrvt26QsZWuTAf9eAM1S
36839	payment	2134	2134	1874	1	1	4629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqt2j1jiNsDarzmiciKEpqH5HRJe92FduobwiPJH3szeuey8e
36840	payment	2133	2133	1874	1	1	4417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHW3tu62k2MEmUdrSUju1h2D9MEB8YFLtjVGqn3FKhxoUxGanV
36848	payment	1397	1397	1678	1	1	14190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUge2M1e3h6GQ1qopfw3vtifeb3xSg17QjiggBMYWu8kMJ2EUz
36849	payment	2133	2133	1874	1	1	4420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSppBZ5DTEMTBkAYC5DG9HC6sRUSaRc6YkbZcQeQECkJjekG3u
36850	payment	2133	2133	1874	1	1	4421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdwqo5MP2RXSLm91igHRUkt6egMZJGxAonRtceF1yG1JYHHKL6
36851	payment	2132	2132	1874	1	1	1290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3Lu3ykXdmay92Tsnot9uLeMu7s5oWbv628A6JoEVJasHXU7f
36860	payment	1397	1397	1678	1	1	14193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvegLbYhT2tg75wEZXS3JQVMAZ8p7X5NvSBedoYiAfQczaKhVa
36861	payment	1397	1397	1678	1	1	14194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkbrc15CcnnQoHFtGDe4GMwii8W4AxGRtTDcWFBZCR8zJM1de
36862	payment	2134	2134	1874	1	1	4636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBh6hcyzgqxmSamcx9cSg2UboysC5ibpma6vDnQFgMXgKyazw
36863	payment	2133	2133	1874	1	1	4424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUKbBnv5ZsRFJjofRRnDtr2ntA8h6egArven5mRqoTWApRqoJ
36864	payment	2133	2133	1874	1	1	4425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUg2pzKYZSSX96EQGDE26v2vEUFRsE4updwN1aaAdF421jKLSw
36865	payment	2132	2132	1874	1	1	1291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcLt5LhBhSbeomTLcHnZ6X9LwQX3Mv8ajWe7X9tKDbQJrfKHz
36866	payment	2134	2134	1874	1	1	4637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZudsyhvWWjAXftzU6Tc7QzGZtTS5GmrqReeiG2qdcT43w6HjvH
36877	payment	1397	1397	1678	1	1	14198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjQrgNixVXEfweRA3k7AmwwtDR7YF1BheBU2AU2P8DD4qA2UB
36878	payment	2134	2134	1874	1	1	4641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyTmW74hhEZfgofGNSjYq2gQoknMW8Tf7L6y8N58tKR2ZL53R
36879	payment	2133	2133	1874	1	1	4429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRz2wRCDxjxYM9A6wgcYG4TGRCNdRED4URuGYWJwnLn3zuNMQ
36890	payment	1397	1397	1678	1	1	14202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqjTtxy62E7uXCgBALW7wkZfYJBGjehZyRH1y3ChD37d3k3RL
36891	payment	2134	2134	1874	1	1	4645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMm27Dd9uWwc3cXzoB5DQdQLjbwnHCcF8kSMzbBq9VFbQtB4f
36892	payment	2133	2133	1874	1	1	4433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8N9vexiPVPRBufVn7FaojdfTYZdsX4UHU1dbpQ6AkMsmzpZ8o
36900	payment	1397	1397	1678	1	1	14205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJCq8FN7cZqgvUeV4HvE16FT6WNPrqGevV2tJkL5U3AKr7bQS
36901	payment	2133	2133	1874	1	1	4436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWSHEgSrw6ckeQZ5nMKSQbcJrVC9uJwUxj2X2BuhFeQA9Kskt
36902	payment	2134	2134	1874	1	1	4648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBiAeWXk66MsuhoBf8bzp32NhV7QP9Ts5LsLfsmEbERCENfap
36903	payment	1397	1397	1678	1	1	14206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyvpsgFc1jhP5Ue93rEdBbL4ph1kqaygvzRcLmxzDJg8eNrBB
36904	payment	1397	1397	1678	1	1	14207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPwGtif7JEqt8cR7SCqKyfGvUdfVBNn4aE6CjyzUMMpXPKHRK
36787	payment	2133	2133	1874	1	1	4401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oH96YbGdVAbme7AJorc5j5yqvE4vZMNJ9XnpriJVFJq4CkEa
36828	payment	1397	1397	1678	1	1	14184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp94D99LXmfZG9Ca3FGf7R6DW5wsJt8TuXdiWJ2rjEogopLoYE
36829	payment	1397	1397	1678	1	1	14185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHbQzw5iZKs6MUtN6mYiyocJjSfqGHUwqpAQJwRN7UDpVBuWu
36830	payment	2133	2133	1874	1	1	4414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcd2VYcHKm757tPk5zn5eixCGdsPCgD3Fgar4nW2w3MXAurqq5
36831	payment	2133	2133	1874	1	1	4415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUypFqdBBy3xJrCEFCsjzSVS3ukoeMVzN5Dcdz2VTFvTavyEe
36832	payment	2132	2132	1874	1	1	1288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AQU65cfHHxfcrSCNKv7EwQDEy7CALNwBQKcKC1yKTip6uvtQ
36852	payment	2134	2134	1874	1	1	4632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZ81uHQy9Samt5WSZXKDZGLxPeJGty3Kdnmdc7kDNhyfcN6qv
36853	payment	2134	2134	1874	1	1	4633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1X2v9GURtacJqZRMnSGZGg46RmWVk8tkQS5GfSk33uutKPYt7
36867	payment	1397	1397	1678	1	1	14195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiz7HRbG4R9a2kUPvXN36TGiYErY2YUevSuottMVyzNzF34fQV
36868	payment	2133	2133	1874	1	1	4426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zye9iEYfGPMmyyxTsn7zh4qhj3dY2RT4JKoRqQoodfcpVUkq
36869	payment	2134	2134	1874	1	1	4638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9xd4U4LJGHZPLK9KHvjFZviar2zzYf13TxNNZCo4JipFzVNuT
36893	payment	1397	1397	1678	1	1	14203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7udQEdQwmixJQbHSUva6gCUE9HBXNShi2KD2Nizqcve8ypUv
36894	payment	2134	2134	1874	1	1	4646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDUgjKULCyKBsmzXdmvZb6AnW1RtEDgDtpDcfKhK84Jk87K5m
36895	payment	2133	2133	1874	1	1	4434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAuqm4ny137P5HZ13FWo1Rp7f1PFnv2hqAyCto3s2mnzFbbp8
36896	payment	2132	2132	1874	1	1	1294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCe8dCCvH2xv1Df9cGVzBjyi8CmyvEwkazwL8TdR6MEhZN7LE
36913	payment	1397	1397	1678	1	1	14209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSbUSC695uQkiGT4wjiacXEabei5xR8ovMdxF5GegsJCp43nJA
36914	payment	1397	1397	1678	1	1	14210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFfXQ3pCTXqzsfn4g7WCBniFXGRa3Ce63x3psa1nXfbhJqQmu
36915	payment	2132	2132	1874	1	1	1296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCZZBUujT1BgFkHBRpPVWRDCenvujeAnVaktqMhaaBQS4oNH2
36916	payment	2134	2134	1874	1	1	4652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk6jRGdcJ9FLTZusfiAvhrXgpJ4ZgKVdzrdS34JSqjhBhXXpn
36917	payment	2134	2134	1874	1	1	4653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMX1ysGxm2uUYXU9P6h7KtYzEmW5s9WM6ZkwVWEvuDjjenvHC
36918	payment	2133	2133	1874	1	1	4440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsvEXxJj5RFt2UVtgcNnzSBBebUm7rPwwhM7g4HQNmtnSB4Bb
36919	payment	2133	2133	1874	1	1	4441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuq6tQtCS55H11o1SZGRppUo8LbKKgJBfJZrdARPRnbHzRWt2
36929	payment	1397	1397	1678	1	1	14214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjt4N46b2jMCHzdJxVhNwWiPMq643iDq1DHS4CbpqS3n2JWvi
36930	payment	2133	2133	1874	1	1	4445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZkqXjbxfd5R75d51myhZg3pGDkoHx7oAuNPknf7mni1YGBSE
36931	payment	2134	2134	1874	1	1	4656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzmoJGgwA2v94dGRkYBTWobPLkpMi7t1U6EsTGv6KGXwLKUzV
36952	payment	1397	1397	1678	1	1	14221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptPeMCV1doRetvbWvG2AC1762xYXx98U9nXk23xNtJE3netai
36953	payment	2133	2133	1874	1	1	4452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44pqUfZjjxqxDhgpupRALQewjjNRJMKmiztxxNHTLKCRUfwhP
36954	payment	2134	2134	1874	1	1	4663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXxikG4VwCzyXGXH6DSxGUDcVdN3aSnsjBSacMhRrxXVUwgq6
36978	payment	1397	1397	1678	1	1	14229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZu3epDsY5rPjgAoYC9XRCPYMFyZsWZXGEc7tZvUusaZaqpDe
36979	payment	2134	2134	1874	1	1	4671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtdUtoJ4enrXJrkY5NEzwkNTeWnXggGxJAxgnuvKRszJujZzNp
36980	payment	2133	2133	1874	1	1	4460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnVbZE7vzucwBe29JSPfsYcTrdDkBbrU6ZwYs4Y2msGxS2bWd
37002	payment	1397	1397	1678	1	1	14236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZzkcPXSPUPqMqiBbYkJ5C7f3jJa2VPNWND4HYAMYREqLEAZH
37003	payment	2133	2133	1874	1	1	4468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHYMqCF7QfSSet1wdQRofBgxEYLmc92J2SqwuiBg1tGffMU3z
37004	payment	2134	2134	1874	1	1	4678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tAnvGQRErPnM6SgS4Mknh8XVNkcxJd1DiiQ2UXREEaEZ84rK
37012	payment	1397	1397	1678	1	1	14239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ14BhELEzdeyC4J2DmtXbD8pDsFhUU4MUJmGMHbfqeUHCeyrx
37013	payment	2134	2134	1874	1	1	4681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GQX7r9i57pjXVCuY5ywGbHqnDY82V6h9mF6Nt7wFxriskN8M
37014	payment	2133	2133	1874	1	1	4471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo7F95qrcdYgx47aDJvhK7wPGpV2ciSofsAvW2Q8HdwhjG6BF
37020	payment	1397	1397	1678	1	1	14241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKNzVXfDpiYKGnh35zFNtd5wUYNUEjiRbYoVEiGEzVN9PAyqk
36806	payment	2133	2133	1874	1	1	4407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yWCoUmL9h8dFqYViHzwUizz8trULJdwirbE4yNCb8NGg2oWo
36807	payment	2134	2134	1874	1	1	4619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwYrewFCbT6QWbxsuPVPeTg67MQVzpmsb7Yi5mcG1bMzmXqeQ
36833	payment	2134	2134	1874	1	1	4626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQZ4Txr9q8Hc2UKsJ8ghYWVq95x66CCYX2pFpAEHhSUhHg13P
36834	payment	2134	2134	1874	1	1	4627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjPHCUHkHUii3GTBMEfgWNqJ7eHCc1oyLDehqyj1ZgfQSxAqr
36835	payment	1397	1397	1678	1	1	14186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT76DDq49859deor3Ta2jFeQqXGHKUw5QFNhsrVMRmiX1HWjLN
36836	payment	2134	2134	1874	1	1	4628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHNn1adoN7K8TX9Ww25kveMR8tzD827kkj47JNoRLPS8xr13F
36837	payment	2133	2133	1874	1	1	4416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxh7KAqPLUr6xmYkFjHFxTCsK3TfdJdR3t5WMTbqqED5J6n3X6
36870	payment	1397	1397	1678	1	1	14196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuHCRmLAnevTkosaxn2sgHemxqUZEqTvw8WFMdneghUv62i8Z
36871	payment	1397	1397	1678	1	1	14197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUW3Pi82yk5owZZLUUCzEJet4NVeetPBoeYuRRhxQqSkxgpq2c
36872	payment	2134	2134	1874	1	1	4639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMJFyAVjMWMg2b3E4ULXRJUKoHLC81nbqgxkvR2QUHjbHQqUa
36873	payment	2134	2134	1874	1	1	4640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwesQNhBgu6wsRp6NTirG9wf5vJucJqPndGW3gPRmnP71XkZvn
36874	payment	2133	2133	1874	1	1	4427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfuhhUkztbS4PJwdvTBzCU6Bw6PWQghMFqwS8599xyvFWMW9u
36875	payment	2133	2133	1874	1	1	4428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgD9VtWmS8A1CLNN3UJaq2QGwZbENpAmPBLxTHnY3ejTnaXVh
36876	payment	2132	2132	1874	1	1	1292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtgY12y85uADCGFaCkqWCErMsiHxDpdjYdF5mcLai5s2pRwTQ
36880	payment	1397	1397	1678	1	1	14199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4JmV6bjJXShCNKbBDTAnJPJMy3mo5KRh3MVaECqXaPXpzLoA
36881	payment	1397	1397	1678	1	1	14200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7vBtjvEi2pSc4Mzg7hMrVSmH1yQFP4f3GgTd3yhu5X4PVpD9H
36882	payment	1397	1397	1678	1	1	14201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7m1j4QV8Qa1uurZskQkfwxwz8kE3DvtNTbphjaZ1qUrkFk5j
36883	payment	2132	2132	1874	1	1	1293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGwS7C1LA5agG27Cmd3VESTTYFUR9bHpKCFRUaqd2R3AsJrV5
36884	payment	2133	2133	1874	1	1	4430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKkfMchjhfMyT63GJySDks5RUDc9eJabN3Px1zcFGxxY4ESfE
36885	payment	2133	2133	1874	1	1	4431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnA5dZWXGjW39go7u3fAe5uyHfRAdMBzaEhL8E7uZwq3fAHuu1
36886	payment	2133	2133	1874	1	1	4432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU4JJksBq6P6Sz11qG696516WrXgCeRGxmSp5EyMVmEqPGMxvs
36887	payment	2134	2134	1874	1	1	4642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kP6kQMQG1sM2jTvZGms7Fm46GwhxR7oxnFxXhB87zr7sQeAp
36888	payment	2134	2134	1874	1	1	4643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUHSKLZGFq6NLgXCXauR4DscZaEwoTs1ZhZGtgkgzbc2qA26c
36889	payment	2134	2134	1874	1	1	4644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURnfSKLHHVfDmUa39L2GrgyRvU4Qdr6CWPjMDaATQrDg9womA
36948	payment	1397	1397	1678	1	1	14220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehkCYGs6Seizj6YaTCo5NMQDRp4Ln2eBonV16tbJGhoRMairq
36949	payment	2132	2132	1874	1	1	1299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9w2atprrgPnTquEvq8mNESNbVVJd42yM5nWFoNkmS6mNTLvBL
36950	payment	2133	2133	1874	1	1	4451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovEctHtaDGnyKf5rchbNUbYfFhEpX89NnwnoXayvKSv1cUEvh
36951	payment	2134	2134	1874	1	1	4662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZow9nvKWu78e1GHc6uqoYprPNGcC6AYJdW8KhwGwbSQZPKr3zX
36971	payment	1397	1397	1678	1	1	14227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4eTLC2Rwvc3zV27NcuxodHw2E6AUZWEYPx6QxyKJREaEwYRXS
36972	payment	1397	1397	1678	1	1	14228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxx1iyyyaCPnbfR51vus9vPBoyarP2kKinMTfJ3AYPssD8Tbb
36973	payment	2133	2133	1874	1	1	4458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmP8eDfBmcQoRgbc8KkBygKoSeZ6qehmTad9j2FkSgGeYBQoQ
36974	payment	2133	2133	1874	1	1	4459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuudjDsJ24QN2wpsSLLqG5VG6M7CQiSBQedxf6tsB8qNLrfHX3
36975	payment	2134	2134	1874	1	1	4669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaH4LbvXuB3Fc1VvpwsuuGQTSFtuCA2K2aQNncxPh9wLDKQ5dm
36976	payment	2134	2134	1874	1	1	4670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbSWf992s1RDak1qj2c5epnmgN4WMAMB1c6EL2dKLJv198TVy
36977	payment	2132	2132	1874	1	1	1301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ff3ozy91bo8nEK46TsMFzDYN9FFpJe8U7zCDsLijPS5GNP3U
36981	payment	1397	1397	1678	1	1	14230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEDGCRjuJAWESuWtYZ4eHMLhm2LoVNZrSAsMaDw5zkdYNjLbY
36982	payment	1397	1397	1678	1	1	14231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yeEnp7964jEGzJqJu2b7t8EvXQBXXdbC8i2wsmmBqn2rN81U
36983	payment	2133	2133	1874	1	1	4461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ7cGMWHurAmEkiBgHQNWjfDad58jo6Gdj2jf9TrJQb8osBpS8
36810	payment	2134	2134	1874	1	1	4620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZicfyCL7Wn1tezFZy9nbhj4VTx7CACv8B9byjJ9DWeDb6ooE
36811	payment	2132	2132	1874	1	1	1286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWaw8pNbqmu6dWqdceWt95ySexhsUKRdN4sCKu9A5pskdcMLK
36818	payment	1397	1397	1678	1	1	14181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cdTsXkPNWTZEeFcrsvopgSWTsxDBgAAjggC7GkwFFQ4rYTsb
36819	payment	1397	1397	1678	1	1	14182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHYCn2mimAaK97xFpMc7AMAvxL3JA1hVJ1CnQ5WZQP8QoMSw1
36820	payment	2132	2132	1874	1	1	1287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrbU4FT8au7jNgDPPoRyrnf7SjTMx4ff8kBmJ8nrcuL72prAb
36821	payment	2133	2133	1874	1	1	4411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3EYqhKeB3Pmq2pCsKFf3y1TSRML1w3uYW5JoaTcpxRzicPkh
36822	payment	2133	2133	1874	1	1	4412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvLRcMDfNdkqy1sxFVCgN8cyowkjYnuAgu4jTRYGueow8E89p2
36823	payment	2134	2134	1874	1	1	4623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zgCsN1vhU6Ek5JmZHS55uxbH45jriVvuJaqiW1vN3omCAJEE
36824	payment	2134	2134	1874	1	1	4624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMCtXZRq1BwmD6bM577PBVpXhYX2g2bsGEydvd3X915LXYcxj
36825	payment	1397	1397	1678	1	1	14183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMpYbe7k7LejGPemNPpEP64WvPaXh7HrG9FcVPD6jv54pZAJBX
36826	payment	2133	2133	1874	1	1	4413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6BPtPc9r9qep56BVCbjJQYHbgmCSvq2fxb93KZvjxSXeDJoP
36841	payment	1397	1397	1678	1	1	14188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEfpTK1VijPFaHx1ocpZvP3B6MJKvpCkSGFwCYHnz7Tkg8Ng4
36842	payment	1397	1397	1678	1	1	14189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWwkZmUxpLw6jSuoFY2W2skf7ECmTWWDqLFWwezcJxEqxpdMx
36843	payment	2133	2133	1874	1	1	4418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZREFsEWLs2VAfRzefw1tMiYqbsdu2i8Sp1Z6GTwaLC4pDZ8Eih
36844	payment	2133	2133	1874	1	1	4419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYut5jGmBV8oqeRxXhdkY2koaMnJqPp7gfN2XhBUMV3SNhjBbk8
36845	payment	2132	2132	1874	1	1	1289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowe22WvQuoBerMtXJmg8dHnGc4YcjR7CeBCqmNoUGxSePygfy
36846	payment	2134	2134	1874	1	1	4630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXXcHE39Mg8uNStjwXVr8n5jHkVcwES4ZQHGvkDkVr4x5S1BA
36847	payment	2134	2134	1874	1	1	4631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwvcwieDBWQWEgUnNZA9jyi3kwQzFSqDoemVYHJojPhty1pcs
36854	payment	1397	1397	1678	1	1	14191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfaS6WmHEj6j5MwFHnHwQgu4U2PRsGs5pcP1jXPfbju9G5kGg
36855	payment	2134	2134	1874	1	1	4634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5GfTVDQf9kAyN2TP9afu9ZsFvfVmMm56Z3iDkc7nFdr6gmHd
36856	payment	2133	2133	1874	1	1	4422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4a9bgq5TMgCepGMBBM6F9knyM6dmc1aGP6BGQZNAR841KTqnQ
36857	payment	1397	1397	1678	1	1	14192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVi4FCAU9AhYpsKCjfJz2KtcrnEV8rRcqqigoD2BP2VoJu4jF
36858	payment	2133	2133	1874	1	1	4423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu8E4FRjcTJCxrGYDwHu3jCGeHAAY1dwaSyBHnJCXBbQx8Cd27
36859	payment	2134	2134	1874	1	1	4635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwdBKKv7oUHvH4QRKnXoaG4VCKG8Hf4P9HuCWX3qZ1meXPxJsf
36897	payment	1397	1397	1678	1	1	14204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7n9hFiaGqRzGAaA3HVZ4N1Hdr6FC42681sZJVpqdrSY5eeJ7
36898	payment	2133	2133	1874	1	1	4435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmdLJbWb6A6znySf47yuRGepr5aAZd1igyQBEc8vE9QChxuZfZ
36899	payment	2134	2134	1874	1	1	4647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBr4d1wm2ceYY2mbHsCxBBgDkKgjGmjMZHjcTy3LHpDFSX2vW3
36910	payment	1397	1397	1678	1	1	14208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtbQ7tBeyz2syLwftq9GvUcr7y5AqRouWrYG5iL7HQ75nHZe3
36911	payment	2133	2133	1874	1	1	4439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAagZYe2jFnfh3APW4zAdYx7hNvut9B7FZV3L6ZPNeKsUKwP6
36912	payment	2134	2134	1874	1	1	4651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92Gj7xjqjabxGPDTdrQyNdo4U9RUUm6pA8SwZEdDmk5qmccNP
36920	payment	1397	1397	1678	1	1	14211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qQYqRATND1FpJmVz72Y39L6WsxhfxkivLGunAiMitsfAxK3E
36921	payment	2133	2133	1874	1	1	4442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhagS5nUzX1Swm6srmy4vGWn3X1GBNEpNpBjSTR4Y2kaaFLiuL
36922	payment	2134	2134	1874	1	1	4654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8y5A2msYKm7uMgKNjvszM7iSuxf8wuULNHQ6Z5qYDA345u243
36932	payment	1397	1397	1678	1	1	14215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNcDRcrRBSZCZS7TVkF4S6p3H5uM1yGbYb3BKV27Cx7CVhZn4P
36933	payment	1397	1397	1678	1	1	14216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uSkB7cY6JpjpHJD2kk9YjbY5Z1Rszpj9BLQ8xYbLPvWEKPQo
36934	payment	2133	2133	1874	1	1	4446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnMASeC4hgtpkJ7jQrHkZyQRQUfL73v8hMY6tkoifuFh78bhuT
36935	payment	2134	2134	1874	1	1	4657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHXptxft8B1ANovgX74Jvfkc2rgy4kSYR5VxZtqZSsW6jdg7b
36936	payment	2134	2134	1874	1	1	4658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxXTXVkqEYRixiR6i1DhHD4LhJxCQDTJhZm3WddXc8N55knyD
36905	payment	2132	2132	1874	1	1	1295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVcyvUQ2gvMwedyQa739JiQXStyJwk6jv9wmN8DfviAdXxqXV
36906	payment	2134	2134	1874	1	1	4649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQS7xBS7Mo9qb9W7LR4GaWpK5y87iSBDBoA1JLDFcsnofgmKmS
36907	payment	2133	2133	1874	1	1	4437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LihtvSGzdRoZaV2ig7VDV8SHFVYm6ru96ndj4L8npUiDhG7A
36908	payment	2133	2133	1874	1	1	4438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPturqThHRYeQ3YxDjsXkfH5MBkJ66cTuXD6MigjoLSq2xM72
36909	payment	2134	2134	1874	1	1	4650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBS2EJmtWfgVx4novvho8Pjjw5nNMTtz67NhvhMJe1RMXqEU31
36923	payment	1397	1397	1678	1	1	14212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrV5oTRQiusSiiYVBg4fkD7kmcVWLxisQiSasYN5UhoVwxbJca
36924	payment	1397	1397	1678	1	1	14213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9kUtQgmbNFXwFV48TmVRnmFtXyraGPXdJmyYx89627HhcfWPZ
36925	payment	2134	2134	1874	1	1	4655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cGBBndCvG5JQLrMNEsL8Y27GEsKkjd8rrtNUfc281ZFfbXE7
36926	payment	2132	2132	1874	1	1	1297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7KpPmFWRVRGVb3WgzkLD82TJdGJ7fbTZ6s5YqLbpDyE5ummt
36927	payment	2133	2133	1874	1	1	4443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7w2PQwCHDD8CHNnquuyoeEqGySv5kAve3ck1p2LfM5MFe2C2g
36928	payment	2133	2133	1874	1	1	4444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xDxhZVeD9Dzv2w5rpXuXZFdiA7S48nQeZjMqeqsuyizwqE1G
36962	payment	1397	1397	1678	1	1	14224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Qs1FeVpbQjc8cQ4krBe6N3Vu5vh5PBqTrjEJtqz1ZL7U7cKa
36963	payment	1397	1397	1678	1	1	14225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvaKY9QzDNjg7sqXD82szwvoVJUGkW9DEVd9cSYK88bT2xRiBH
36964	payment	1397	1397	1678	1	1	14226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhaLmcviXw2Cw182xhkzZ2PnMVgbHBApQWkK8pFFjjqqAxgHv
36965	payment	2133	2133	1874	1	1	4455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVmgQbLKXkvf6rXG6dj6vKECACHQcY6otvCQzbLR2xMdHNsNy
36966	payment	2133	2133	1874	1	1	4456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc737Qvkm2LLh1KoEbvQU9dYeLT6NvWT3zMGsYCfGCjik1HS5u
36967	payment	2134	2134	1874	1	1	4666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VAinnbs1mhR3x1YC7mUEmjgBTaTrWy2K2vDRJST5aZQ1iPph
36968	payment	2134	2134	1874	1	1	4667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDftzbEzNDPJYWqm1M6u8LAGvi54MPHNaPhSUAw6E6FQNYuCYW
36969	payment	2134	2134	1874	1	1	4668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2wAiuQPA9GRw27ZFPHbuqZkvDqJ2cet9FUDfA8Ea69tgSqmA
36970	payment	2133	2133	1874	1	1	4457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzhNpUt2VFvgzL59EbN61MgFsqsTzBtQV2d4JCTKAmq3EZThj
36991	payment	1397	1397	1678	1	1	14233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDexxRpNdrnyWp6kKtZkn5Yrw3zELhdMtjMh9uqjyuSnZMZ5jJ
36992	payment	1397	1397	1678	1	1	14234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EFxumJuu5sk4LtpGFszdi3KhS2LCcTUr9dzC6xZFRFAktR9N
36993	payment	2132	2132	1874	1	1	1303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbVpwuWYQAjwq7xq59xFnPrXXDMqiYU3vkDnXb6jQZpVrUaEc
36994	payment	2133	2133	2311	1	1	4464	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEFwZshcRmNPxiZocqgHFpMfTNv5LPYoXAm5Fcrm7LhV79wijF
36995	payment	2133	2133	1874	1	1	4465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqtCLJaWDYtz5gGKbnQqan95vkAGeX4vCE5yiA1bTSzis1J7D
36996	payment	2134	2134	1874	1	1	4675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuU6SpxRzyghrPk3mSiYnqkPYgoEXuco7Pb5Dq1Rdrebvcq4T3
36997	payment	2134	2134	1874	1	1	4676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3Mxhb1JTgqogAroLmkARq2ygxfaHnHku8VpTZU8e36CvNdtH
36998	payment	2133	2133	1874	1	1	4466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAc4kPCwFvVX5hPGM4UMG5uAvKrhcfYBGUXVfR2AvLvprkY1n2
37015	payment	1397	1397	1678	1	1	14240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeghHDEg1duFsRSxJjyRgzhYFMj4oARd9LtmsBfZjBh2GnSNW8
37016	payment	2133	2133	1874	1	1	4472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgAzQJr3TRZgb3mKwH3XdFhz9ccBsLuRQTEUs31zEeQuQkUhqR
37017	payment	2134	2134	1874	1	1	4682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQJcxwpMAdSraKYpiVoNcJ1xgJexGjPCZZ7mkPjZJixfL6NtN
37018	payment	2132	2132	1874	1	1	1305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtuiqk8ksJu8AThQquAA1KMS7jGhf8qKEkhFhwMDTy4pE5t1Eg
37042	payment	1397	1397	1678	1	1	14248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeSE7Eg2rwpj3AFEmnuD6YgvLW6s7MgEPSyLP1XaF8pRR5Ttp
37043	payment	1397	1397	1678	1	1	14249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXY4DtE52ivkjnzbYtQwrfjSB9iaq9battBrhpqWWYf5Co3SQ
37044	payment	1397	1397	1678	1	1	14250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn8wZk8aXPM4bAEF7o73By7b7K4tkdstBN2SFS7YEJorYxN3j
37045	payment	2133	2133	1874	1	1	4480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGoEK98KTXPscykp1QQ35ZhL5jK1SMRHu45SBqAxGfMdhDwXz
37046	payment	2134	2134	1874	1	1	4690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhhGkuxHqC9M4iRLaWN3QjW3kbseX2T85FP8aJK66hFPDEzqcR
37047	payment	2133	2133	1874	1	1	4481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcUkM4Np7wJiwq3pKUv2PKYPtLrqoXjGgGg7zjJ77whV3rZzT1
36937	payment	2133	2133	1874	1	1	4447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyutkT8H7PP6CjGjLLwq83vnkgUhHCeKH6wW4m5U9XCExbdfFB
36938	payment	1397	1397	1678	1	1	14217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Mp4WJcePRV7u2JCSZALTGvrD3bXV73n66w2ct22pgoGe31aG
36939	payment	1397	1397	1678	1	1	14218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5hLyfgBFXMNUYon7oo696YFdhkDna3HVuPGMwk5y8ymz9avz
36940	payment	1397	1397	1678	1	1	14219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8Bva7KkM8aNm1kp6KxiL6dWQtxjQRHxe8wo6AKg9YCiCLD4H
36941	payment	2133	2133	1874	1	1	4448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhtg3ntf77dAozzvKskVXnmLdW13HsWuZ1o9LuZ4VBqo63Fvyj
36942	payment	2133	2133	1874	1	1	4449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJm12af9WP2A3dtCfgMtKgy7yViRRjzbqPfXsTwwB5vnvrYAx
36943	payment	2133	2133	1874	1	1	4450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuskV76ymi4afa9ZUXJBdp3Drj7aVECuXejfT4z43vUkzef6wA
36944	payment	2132	2132	1874	1	1	1298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLSPmZkZ6GnQBbyivFx4QnTdpLKVABpd2op2tSqoXdddjPXR7
36945	payment	2134	2134	1874	1	1	4659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HAVLe3em7anKPhkyQVEp4PZjsc5tMNX1eacxZdwn5vb4MGUQ
36946	payment	2134	2134	1874	1	1	4660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYrGzHrTHpNzKS43XbDjEH3uD8t1fN2NRZXusVKDDpajPVbT7
36947	payment	2134	2134	1874	1	1	4661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2CujdfDKuMjJry59Kho2B8gAwyK5SSCu4JkduzPEKsFRS58N
36955	payment	1397	1397	1678	1	1	14222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnWkQxitxA9ZnSLLxmmVf7K3VKSAv2fvDY6DgiFKEFQuKRt8Y
36956	payment	1397	1397	1678	1	1	14223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gTazeMSkuxsym2uvaMwf35L3CCvfHrhoguW5YxwvtXq7s6mV
36957	payment	2132	2132	1874	1	1	1300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wSZs3tpTRL7AfQ7ejUnn4LVkTM67zuSeziSRstr5CBke9zs3
36958	payment	2134	2134	1874	1	1	4664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLFX17ka3aaKoHZCWM3eaAL5LXKtWxCZDJNdUWwctkHUZTfRi
36959	payment	2134	2134	1874	1	1	4665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVybA19LqnavZHodrxWhCTWqETuDsAskXsUUs8CrczksJHAou
36960	payment	2133	2133	1874	1	1	4453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKA8AeV8sJzkD5chA9gt2QPX8Y1T2WMqpPZC1Eo62oUbzbJCw
36961	payment	2133	2133	1874	1	1	4454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxuktAwyUYidrBMfSTobjyTs19mLvaCuXtd8JnKGMsBPFDCPF
36988	payment	1397	1397	1678	1	1	14232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEYdnC9QvCEuXaQd1LiH7p6WiRxrTk3LR7UoFroHWxdMU6s5s
36989	payment	2133	2133	1874	1	1	4463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJGo8jQtoRWoMdZ7LpPQTemuPPcdn6a6dYkZqcii1j4JCwUv9
36990	payment	2134	2134	1874	1	1	4674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWULMrdiKAA7meEvVFW98ofngaa497UKDaZ94E9P4P2k5uf7N
37019	payment	2133	2133	1874	1	1	4473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMK8H1fzFmmch3hrZ4vtEc9z2gDuohw6ysG8LEzow6XWcjcp3
37060	payment	1397	1397	1678	1	1	14253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmuceUk59JoqDkUzYzy6g4MrT5RjbC2g75zUkffRC7cfPLo1L
37061	payment	2133	2133	1874	1	1	4485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZZRr3xyskzyu6Gv1r6fUbc9LRamyvAmiYw1K7Zt1Yq8AAjCd
37062	payment	2134	2134	1874	1	1	4695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgohBvBb4GgdiT9hdD6onRUEy4MbrEEGNBiw5329sbCQeNAED
37069	payment	1397	1397	1678	1	1	14256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrP31VNxXXWFrAdmCfaVgjYoJjbPrypJueUFbvmDFJ2SSLRjba
37070	payment	2134	2134	1874	1	1	4698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxaeEYrowEtTZct5fJgTAc8X8SgRVQGpDxqRcW3koat8UWFce
37071	payment	2132	2132	1874	1	1	1310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUh3UMsyndtRFxYzFrNMFjCRYaAXshmwfcarz3sqhiszv3QyWm
37072	payment	2133	2133	1874	1	1	4488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rd5kQBSjWLeanLDSGxVmGNfKhA4nYtLBGuSzpQ2xB9T8Avur
36984	payment	2133	2133	1874	1	1	4462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh94GQrbDBG8UtLnYWMLoUNCD8ohaDCXXpXayWLYwwecc94k3c
36985	payment	2134	2134	1874	1	1	4672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdor1T8gsQQUhQM53AYLhV3FxU8AV6Mi3pmtS7BunA9qUhx1Hf
36986	payment	2134	2134	1874	1	1	4673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1m7ft4e5gFddqAKVy6gJr5AP7wMtf182vUfDi1RQGaSJjpX9
36987	payment	2132	2132	1874	1	1	1302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VfAFDxqqeMDqVLotXgDbUeWDHR2ZENaomrJoPk7rKr4hKQLY
36999	payment	1397	1397	1678	1	1	14235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFR1AE2eW1QHKXJWkqxSUv3DKcuoQKEEVD3i1g88NRo1KLiL9G
37000	payment	2134	2134	1874	1	1	4677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDbpEDrJXtAnjcMWrMgPiwAa42YDnenKAxvGoAMHpiQFJCLFXS
37001	payment	2133	2133	1874	1	1	4467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtmdkXsSzwGtVJ61DTdwsJ26KcB1Ftt221UsYxKKh5J2ZBoiuU
37005	payment	1397	1397	1678	1	1	14237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6xkGk6qcGYoiJQy56yrNkbiUhvYd2dpjAGp5rKdiryhZqeL8e
37006	payment	2133	2133	1874	1	1	4469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpn6p82bgtpHeDKCv5VafyA4K44F1yduYJR9y3aBqX4JxZJZKj
37007	payment	2132	2132	1874	1	1	1304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfTWGztpVbPQFevHma3r9JxAgycpAtcAEUaKhCsbKdf22apWE
37008	payment	2134	2134	1874	1	1	4679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfdkUUZg8mFYzq3hqdZN8ZQ2pxr6Mjxf2MjGG3MJ9r2FbX1J2
37009	payment	1397	1397	1678	1	1	14238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUgPLm4jELWP6o3LXCtjhRgqD6G5FbaJvh7DCCdah7MUt6JA9
37010	payment	2134	2134	1874	1	1	4680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHyAGePBYRP9nRTQdTmzzRrLBsH6TRCP5S3c96UBtALSLHhgV
37011	payment	2133	2133	1874	1	1	4470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAF7pVcGy35NvBoP5hPQboyM4b5xjm1FUEBZz1RG28f2uHA2CW
37056	payment	1397	1397	1678	1	1	14252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EVNyjz3EYRkNiD6Ep4gRckhCdH4fKF4MdDbBRcovDktwcv4d
37057	payment	2132	2132	1874	1	1	1309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGjTgRSQdWZ7o8HoympNrVkygzBjiEfKuqjbCRT2vxRa9XyrA
37058	payment	2134	2134	1874	1	1	4694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rB7WLf6UFc2kbkZKyiHLZKEsawWUjqK9NVjyq28aqrRSrGrX
37059	payment	2133	2133	1874	1	1	4484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANakKFu2mmdf9hxCCeBtDiVzhhfq64hZeyxKm1d2rw4vFPXmc
37021	payment	1397	1397	1678	1	1	14242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTvW2EFvN12pXATFuvFhjm3cLhd5MoECoWMkevCwxKUDv9MXv
37022	payment	2133	2133	1874	1	1	4474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbkEK3o9obmztJn9EEsChU35jkf218niJFuYUeUNpGeeVDc8k
37023	payment	2133	2133	1874	1	1	4475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2oZHtZETLEn9DjyFERwweSaYDKFxz22mtfPrNdtAjrdSXjV3
37024	payment	2132	2132	1874	1	1	1306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu341vT2LRVaTTU63iwUK44J2vCee4c8LVCKBqZ5RwAwy7ubhC
37025	payment	2134	2134	1874	1	1	4683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxJESq9Rm519A8EKpyYko4cbyTpJuqPNBiJ5N15G7C6V8bcGR
37026	payment	2134	2134	1874	1	1	4684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXHhR849TFnGbS8J6yr4cqENdKvPFqAQ3LKH7dczxZfix9Woqw
37027	payment	1397	1397	1678	1	1	14243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssTMr9hAxXFSoXf6jJ7C3igFteCbzTwLcgfWw2ktpizDcX6fp
37028	payment	2133	2133	1874	1	1	4476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsMeR9WKtofT63fFnXtpDfhbQ15xv6wdpBEgxfFPTACbWXPYH4
37029	payment	2134	2134	1874	1	1	4685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMAKY1WVPzM6LdQZ2wZEJoHJAjcEJDiNLm5yi3aCkbCw1hSAc
37030	payment	1397	1397	1678	1	1	14244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjB76WvfQZVJAaMXgr3XtYzvcwi5NaBY55sqo7ooWuyejMXTAP
37031	payment	1397	1397	1678	1	1	14245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi23XWXzTgwsGJxKKJodAreRpxQ51j5diRrArr5p8RuT6CrEtd
37032	payment	1397	1397	1678	1	1	14246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAARUjnFrovECgPe2fV37bV5WzqCaNm4V5qtgCZKVa24i2tWj
37033	payment	1397	1397	1678	1	1	14247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18V1fBgpbSbx5icXrZrbUU66PAUdMwtxH4QjzhpBrt428Ln2u
37034	payment	2134	2134	1874	1	1	4686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyQB84LdfdsKLeYL36EEN3WjjCJFU2qhX7LjkXWqPofZaroRN
37035	payment	2132	2132	1874	1	1	1307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cRrb6Y1e4Am7Jjfqc5oRHnWA1rBhQu4iFojosoFcRxrEDoea
37036	payment	2134	2134	1874	1	1	4687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAm3HDn183ggF8tseZEVJtM8tB55C9N1Ljxktdc32uinJgdUc
37037	payment	2134	2134	1874	1	1	4688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgqXwifamyp4nHVdMnCUS3LocyqjkR9FWi5nMmBCMVb4FvvLr
37038	payment	2134	2134	1874	1	1	4689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoyeQTfuuhdowgZGMvQzZHuiw7Sgge67FUd4GTTfuTSx9Z1Bv
37039	payment	2133	2133	1874	1	1	4477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJEGZvRzrJScnnTfrrFeqQEqgbMCHLPGX2qkJSis8C8kJ3apo
37040	payment	2133	2133	1874	1	1	4478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNTwMhs2vkrd2N6P5AQ8ufb7q8SXBC6iaEqzoBufRMaDytaeT
37041	payment	2133	2133	1874	1	1	4479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbFayX23adAmrQB1U6Sox14j4FHG3n9v4o3vkh3WtWZZRKMdMt
37048	payment	2133	2133	1874	1	1	4482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2KAFqvbr6WH29EAzYCh7xABzn9An3k5LHerxbuHj8CC5ZpKgH
37049	payment	2134	2134	1874	1	1	4691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRxgMDYgfZE4mKv6P8rLDzka5fqEVFuPs2XtNZYsLCUQHZT3F
37050	payment	2134	2134	1874	1	1	4692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5TSiZYJZa44Z3YPsfbJzWQot5eFnBdttAaXaWdaeddBCm3HC
37051	delegation	2119	2119	1403	1	1	8	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpZxDugQN4rohjPg7RVngjQdgicpVvCienGh4jkmEk7ATsYJfELF
37052	payment	2132	2132	1874	1	1	1308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFgLa82668j2o84C28m7ccR452qWDJfxsyBWhoU5DoXdHfYvfb
37053	payment	1397	1397	1678	1	1	14251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFXruWunA4qkaPVoJtuC3aUHKUdheYMxDhcedGs6TfJ5SZ3hH
37054	payment	2133	2133	1874	1	1	4483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazBS2G5X869dbN1Ss8NWzxnEcQUpYjn9kwVyhBTnx6f7Jyatc
37055	payment	2134	2134	1874	1	1	4693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmGy9WQYgfSg1HwhYyKAYHtdrAQeksuRjPFXhqgB8AJSSW1Bb
37063	payment	1397	1397	1678	1	1	14254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBxSJYU9ocF6TEFSj72g4x1yQJx7wmsptoryeXihWAPNyCvpZ
37064	payment	2134	2134	1874	1	1	4696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaHdDfrFgweaHvVXxB9qmXwZJ3yjdDUNjrhM4BLbckvtDzD6FA
37065	payment	2133	2133	1874	1	1	4486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDMteDxt3eCAhGF4rGfLJe9T4V3fLrTpfccq4YsPZyveqQCm7
37066	payment	1397	1397	1678	1	1	14255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7xfwJS8J59Fn7oo5QDdDDyVtXT7VUHGSR3BtZp97q2ncuAVU
37067	payment	2134	2134	1874	1	1	4697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNW4peccbPVMWDrEK5F4NuPotJT5puHby4GzDUNkZsNmyagU2
37068	payment	2133	2133	1874	1	1	4487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZKXHQwAYWS2vwfyG3aTa34L1kgjQTo5bGSkzaLaqBGDgnk9E
37073	payment	1397	1397	1678	1	1	14257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbh9TakjrqxE7msaQQqPzvpegADggNatrSSASRfGtXyZaAkURA
37074	payment	1397	1397	1678	1	1	14258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbwTs2pm4ANqdYLhVMqhk8TnSJKzdp1yvKtYCaMVMXBsye7Q9N
37075	payment	1397	1397	1678	1	1	14259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpcJPbAX67HNvb5VvNUhsKNNnhBsNYP8n1Z8LPuwvpGE7Kmac
37076	payment	2132	2132	1874	1	1	1311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeCDfmkk3Azv3SMz85aeWVxs2zjJLwDmiMygaZLevBUKUWGQ98
37077	payment	2133	2133	1874	1	1	4489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEiLhbKhhu8YRsNWsQ8vNU9RMgBQP78F2n4UD6BSpjNvMgmoQ
37078	payment	2133	2133	1874	1	1	4490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1RtiaQmiu8iSTEd3BwAdW5TNWaqNk2RN45dgq77oMiji3LnJw
37079	payment	2133	2133	1874	1	1	4491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1FhVT34W5kMGewiMuwYPU3kMpJ6QemmgimXP4QkmKZYkp5Snt
37080	payment	2134	2134	1874	1	1	4699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzLtfgdpZRCK4ndrKTJkHzNeD2rtCvBByJ4srrMcsUQAM6c61
37081	payment	2134	2134	1874	1	1	4700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdB5sK6ctHtMDEApm8e9RWC5sa8K7hq8aKFxLSm1SfBxjhP8tM
37082	payment	2134	2134	1874	1	1	4701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeRwrEXKVdPFrvVr2Hj2HimyrMqTJVH682e8tqrXAYEEbniog
37083	payment	1397	1397	1678	1	1	14260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3cKAXzbpRtQSKhEpy2BZr2sgnBieHjTfD5s6Q6vCPsn5ppe3
37084	payment	2133	2133	1874	1	1	4492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKb6uFwgZMN5vgD9KjpvadZEqWQnsvJTkstv4hLMTUrvZY3wEG
37085	payment	2134	2134	1874	1	1	4702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqMZePDuobd2yWTbs4pZidoXpNHCsQUJ4XXfB3oNNVsdrQGd5
37086	payment	1397	1397	1678	1	1	14261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskbyL1QK8GtnDperAXpQ7uZdNFm7tDbNrk39urwRNv3D4cAMj
37087	payment	2134	2134	1874	1	1	4703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoQD7dz3AqgFuV5FsgQACNXWCsouaWs3vhNZGVKX5ay2yxGnd
37088	payment	2133	2133	1874	1	1	4493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirYsC6UveRyUKDXN9gh98fS8vjrVtPW96FNH1kwMGhVRNLw8M
37089	payment	1397	1397	1678	1	1	14262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1RHgYzZGZCKcPDknCAVWvQwFKNPJxvPfzaWYC848GhGUhDwt
37090	payment	2133	2133	1874	1	1	4494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1aXkuT6CMYnJXyCXutD2o3xQxWz4D2oBLatQGmpmhWYVyoEW
37091	payment	2132	2132	1874	1	1	1312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcok7rDr2tQh83njNrWi4fibf88FBRCkgzGN2YCNt98f3cw4t9
37092	payment	2134	2134	1874	1	1	4704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43Z9p4PmR5jV4ukqquAZZoA68u2n19evYTqjeHBKYFY1qpuPi
37093	payment	1397	1397	1678	1	1	14263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZAc3HzX1Fx38TuhCdbLcZqHodo7wgVq6xBrpDqyPx3p6LMWU
37094	payment	2133	2133	1874	1	1	4495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmeSgtMjNPahPDmrqeXYYKBn8d8vYPeHQCvDR2a99xGV3ad3S
37095	payment	2134	2134	1874	1	1	4705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3a4FkLvr5mMzQdpU234QiBmuz46vm9i86BtBM51C8u7CLwmqH
37096	payment	1397	1397	1678	1	1	14264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoe22kuEytva57Bbuvob4S8zUmy1vj4Gg1tP4o6MdRb4KKKcc
37097	payment	1397	1397	1678	1	1	14265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcsRpom39rfGUnW3EiQFaTq5sFMEXzb8ihPojacZY7U85H9Kg
37098	payment	2134	2134	1874	1	1	4706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc2X2B71qJQXjYSJbsdsEewM3jkGjPezcsvf6qULgeZkmKETpu
37099	payment	2133	2133	1874	1	1	4496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcT3AgxkukiUfdyBUz1MhPZwAbem2Yy2kMzBBycQ9Q9JtPcg5q
37100	payment	2134	2134	1874	1	1	4707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgR4Y7puDxZ1pm7QTTk3VcYxtUKdM1VS6ieta9jCTWW8phJYBf
37101	payment	2133	2133	1874	1	1	4497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BXU3nqCPhTyHt5WRS2Bywy5cWxKrCsTT23qWjazX9Lvz5qvP
37120	payment	1397	1397	1678	1	1	14272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuL4br8PoxRNwi7orH7mLrJAagNCidw626LzmMfb2jJEizsiCN
37121	payment	2134	2134	1874	1	1	4714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQ2bNZv1khKc2BaATNtdQ7M7832PnW1FA9fSjUGPFrP3bqAnK
37122	payment	2133	2133	1874	1	1	4504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjoVCZZZkkStEJUzicJmeF96jZKhAfQDmPtzTANKKw9yUT3F2M
37132	payment	1397	1397	1678	1	1	14276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQ4rkNBD789j93zdr9CGRERiXYJs5gYKXEEsgs7DkH1Be7KNq
37133	payment	1397	1397	1678	1	1	14277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnjzBBs7jddcfWfXSNPpFrnum9CJs6YJtM7tsazY3YTXPRYK5
37134	payment	1402	1402	34	1	1	33	285090975225	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZeGaM6myp77bQ15je8PHZtzgZnKNFLj7Nx4X8iAMvKbvz7Xavs
37135	payment	2134	2134	1874	1	1	4718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtU6ghVtREj2arQ8nN7bomxtUVmmvkwtnhQp26R5Gw4dcXzcDh
37136	payment	2134	2134	1874	1	1	4719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXL58xwspc1Bvgf2VPczx96pD6JD8iLdy7UeeLB8AYnPzLpGzq
37137	payment	2133	2133	1874	1	1	4508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBJxxDDgh1hGsrfNbufs9jVit6HFnq1NMJ6i8p7bxdWrehGy8
37138	payment	2133	2133	1874	1	1	4509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkHvd6r47U1CWDBAA3hJtWi6aZNe928RyWntDGZZ49XYAMvCL
37146	payment	2134	2134	1874	1	1	4722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgh7u6HaMtJ5tpDAWpFH7z4jAM1a5RMBsNN4coc27YfvsbbhC
37147	payment	2133	2133	1874	1	1	4512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5uS8XRRoJEry1quo3oj8pehS8PLe2V7Q1twMj7uvbquY9829U
37179	payment	1397	1397	1678	1	1	14283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGjqsCmMUFHcxUpd7b1tDapyrFBEAoWM73YU13XfLxvB7iKhD
37180	payment	2133	2133	1874	1	1	4516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoYHvbyxyKGjB6aihkUjLRxhhaX5sKnhqRE963u3twzQwS7TKY
37181	payment	2134	2134	1874	1	1	4726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfveaWDC2cG4iW1fAgRVGYBynwFEyHKxPnmt5aBSx8PP8YaYYC
37191	payment	1397	1397	1678	1	1	14287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7RHXbaU3tV75xRmBRSwV5Xw4315rVZ3yLDs7WWEjTzNqjPrvY
37192	payment	2134	2134	1874	1	1	4730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnkdmYjijg317on3g1e9Qr7UueN8Syf1o57p7UqLMNVpd8Vv7
37193	payment	2133	2133	1874	1	1	4520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5M99aD1fQwuhwrTkMLxAQHBupUn4B9tiunzYE8uDAtuQvMp2Y
37199	payment	1397	1397	1678	1	1	14288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6MRL8Epy8X7hJ2fqsdiEFxD3fScoyjP5cAiprR1oBJuUnz9T
37200	payment	2133	2133	1874	1	1	4521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHuYPwKiwNenYr6JtyWdVRX95toJj64KSd62jp92aRDpfaSKr
37201	payment	2134	2134	1874	1	1	4731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb8bQ1A9PGt2xiy6Ua8uGmfNngBBUM8awpzbMCgT44wrTyxv8
37210	payment	1397	1397	1678	1	1	14292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRkpJst2GLVrQjPx8eBEQgz76iKfmtnivvTg9tEPiZRtGBcfo
37211	payment	2134	2134	1874	1	1	4734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTBd3JNS6AtVK2b5pr7RkSZR2Ym8EioxTwdyUUzjNhNMdks3C
37212	payment	2133	2133	1874	1	1	4525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7N4JAQCDQP5uyuRmh32VKBTH8a16Pt8r1ZdUJYggU85c2ou6
37231	payment	1397	1397	1678	1	1	14299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzNd993Sa2wNKkT9hz6LTNbfnNvXATTAGAYebZFf6B66pdtNrN
37232	payment	2133	2133	1874	1	1	4532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5LxJNdvyf4DJzVMDS9MY57fA8XRtxaLRPwVnc4NwWSv4HBH4
37233	payment	2134	2134	1874	1	1	4741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSr9kazMCbxZ16NVPtsUsjDFTUYbMfMUC3pzXfZnxEw5wHxS1
37234	payment	1397	1397	1678	1	1	14300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCPgp5GYCqsj4kT1qyMAbj8VDbNS19MQVzFH957uxsvDzdoRJ
37235	payment	2133	2133	1874	1	1	4533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxEVGkjaQ6z2xmDSphDsU3wND5KEFzQgVAhECoFSvuxR1fn3R
37236	payment	2134	2134	1874	1	1	4742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNGyiZGbkTnfvrMWzkMQa4LAX2rmuQzGEBUZWYCuTTWHyYDYo
37237	payment	367	367	1933	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXNZ9RQqWayyhpXyx9kpyTPiLLh4t8eGkaQhWUCpStA3xyomL
37238	payment	446	446	1933	1	1	0	719000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfpVkPmo4A3MbsLvUr5p7ea4Cjbd2sACYS9RF9F9UBhebPAUQH
37259	payment	1397	1397	1678	1	1	14308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAPjS55aZpP9CPobTgyn4DA35PKc4rpe4PXTEgQ6BJ8vePrUFA
37102	payment	1397	1397	1678	1	1	14266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL8PQxWh3U1hZfnAeCFwaGYuF4DKbaEvZ7GmArqyE7fK6m6Tey
37103	payment	2134	2134	1874	1	1	4708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9sHtaRXozek2hrLFBf2bp6nvgf68FDVZeQUx87pTNDBGiPNYn
37104	payment	2133	2133	1874	1	1	4498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGAww5bRUPzpz1Wi5KgGcfQ5SVn7LghbnnSx1zBhdkdRfv7Xu3
37126	payment	1397	1397	1678	1	1	14274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfzK7EbAJFX5rVTDd83RotnbKStU1aF14mRFwaESQS2SXusfJG
37127	payment	1397	1397	1678	1	1	14275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycEmDeCrbbeAX2aHxww3kfvSqbkVCdh38uiAfRfapFxV4a9SG
37128	payment	2134	2134	1874	1	1	4716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sP9b1cxpGQGsQYgEWnmfbTCozr2JzZJbjYtCtsJR2Ky8iF5i
37129	payment	2134	2134	1874	1	1	4717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhNaCVozZ1VpPSkp14uFJ8on9D6P8ji1sKSNMT3AT2QpwSfHX
37130	payment	2133	2133	1874	1	1	4506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1fMTnxPqMaheoP6r9VsRLYtvbvsx5aJXpNPi8sXwo2LeWYdd
37131	payment	2133	2133	1874	1	1	4507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfC59SicCtPw8gZw2ejXbrj268myNJoAMmZoX9MnbchehZacGf
37161	payment	2134	2134	1874	1	1	4723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKog5qkw3bJcH1MDTWf2o2rESQyv6LofWvcPdGzSh89JtNLY9
37188	payment	1397	1397	1678	1	1	14286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEeFABr3zmYqf1o7zftniDRrnM1hqXVwBydk6JW8UVKBPiyuBC
37189	payment	2133	2133	1874	1	1	4519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64UsLNFovXFaukXzahL9s6depGRkqXHVVNiR3b7bsA1SBZudj
37190	payment	2134	2134	1874	1	1	4729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTT3WPwNqjv7hVsfDz6FECGby6BaLqFPJPPMpuXTpdqHCWgw3j
37202	payment	1397	1397	1678	1	1	14289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMM9PzCQQFWybpAoTjfbakPYjjkA5Mn7G64dnrbG4g4sAveCa
37203	payment	2133	2133	1874	1	1	4522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdhtzGk8G9HqeF8tC9LavYiDvDr4EsomcpWsYp3STwpnWUMRqf
37204	payment	2134	2134	1874	1	1	4732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjKj43JcmR1oJi2CtpzLFp8xvqcAp3DgYJMWDozdsr5ebTL5Y
37205	payment	1397	1397	1678	1	1	14290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQrARATcbedPNTPde8XoBFg3Kg4rV8M7t1DrykiUTKnQFDX8sA
37206	payment	2134	2134	1874	1	1	4733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUfCg9a69FiSAFNkNxwUtRfNS6j8JsmoFh7RnbsqYAYo91ucX
37207	payment	2133	2133	1874	1	1	4523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmJU4rbzCQwdkzbctsTfmLRebcfJZGhgn5oEbRfv4boxxWWj9
37213	payment	1397	1397	1678	1	1	14293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PAZtqHPECEC92FHrwaM3Ck86dzeAStQnHoRRcrDXaLkiaRhS
37214	payment	2134	2134	1874	1	1	4735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJfAtv2qEinDeQQfVw6PSGmcyxxxjAK4cDTYowwHbbhJ2BAQz
37215	payment	2133	2133	1874	1	1	4526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwytqZYD9Ui1Ta2UBpEtoCpRGweqtXpPgGYHdfNDjGrbNBzXvt
37216	payment	1397	1397	1678	1	1	14294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoYmCHGkR1bVDP9LhRmFQQr3c7GEnPFMaQ1CQxTkZqyP7fJYW
37217	payment	2134	2134	1874	1	1	4736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8NKp11MbdZHZNheEhMKAD5QzQAYi2Z5Ea8fvJryMeCYhS17t
37218	payment	2133	2133	1874	1	1	4527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMyRBS8r1nNhxWvtMUKG7ToBkvdnGFT5UdtiLbK3LfTvtJnz2
37239	payment	1397	1397	1678	1	1	14301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNBXyb7vMzBrPuEYNeAQx2aYtuseAYsA9qNNsXjabcU14ZhaZ
37240	payment	2133	2133	1874	1	1	4534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7YF834hz72jbvYX4AgEcepxUUaMzpsZm6v12doqoKzafdBHE
37241	payment	2134	2134	1874	1	1	4743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhA6hRYNu3rxzAFBKtUVZanZDGa4UDB1U3kjt4EKxiczmBuXLX
37266	payment	1397	1397	1678	1	1	14310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqD8oWqvW1okHKohJ2SZ18DfhGkhnhJ5Zw7Qzd9a1XzRVr6Hcx
37267	payment	2133	2133	1874	1	1	4542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLgqCenu3grjdtRyzwmfWkPjkQfbqNGUpN6vgnWWhvsDkHauC
37268	payment	2134	2134	1874	1	1	4752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizkT6TL596eW8PD5rwL3vwSfXSv2ZWZhd4hXgf1j3b6Lg2W53
37281	payment	1402	1402	1268	1	1	64	4256613899	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZCV2N2Qo3HXHXZJWmiBMFFqCg2PF52972Uheu7ew9QERdY2V87
37282	payment	1402	1402	2081	1	1	65	897022998304	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZ1G2AKwf3F4syvPq3Uci1mXFUnPhftbouB4NoQBr6FcPVcLZin
37283	payment	1397	1397	1678	1	1	14313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvQyGMib85swexGvLoxqULTJXdgYGrG3rALrccFKhfXTm3Dgu
37284	payment	1397	1397	1678	1	1	14314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCebDRAmb8XwRUjgbxpE3baQ3fknGXrkvpSzicDqjzw6KGycp
37285	payment	1613	1613	1349	1	1	6	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKtwS3QcSvRkd1PpKRRQwgJUxAk2whrzExwjTjmNoJps11a59
37286	payment	1613	1613	1223	1	1	7	4718192200000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3SCWoTy1S2bWedt1ddrXeoY5q1SoH27BrR9ZfHqHVsKoSRDH
37287	payment	1613	1613	1103	1	1	8	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6CxNBg6qHgHXL1wNixECvbTCQ3uJ73q8QXoXcC1h5NZPtWev
37105	payment	1397	1397	1678	1	1	14267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpKGiCTva57baV89tfP3aM6uUpW54tdGMppaALyUz7eN4bxqWX
37106	payment	1397	1397	1678	1	1	14268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaK6N3yVZnUYaVMfFvpFtJUPYgCu5LU7BhN4ga6BcAyrvgxZ2w
37107	payment	2134	2134	1874	1	1	4709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG48o1o9uR1mhpjVRt2dGuqCDmUcEkvA5DbSsSad8PigrebdY
37108	payment	2134	2134	1874	1	1	4710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRR8FMVs6oFHEncn575x8BZEMgvMnNtvXvdLVZYe9KVnZhDeS
37109	payment	2133	2133	1874	1	1	4499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg37naSgdKroZFbVV257ByQEY1ZeLocqSzG3tcm1QQmoK2iVw1
37110	payment	2133	2133	1874	1	1	4500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pyPR8hQxdxKcGSsDhZtp2G3ECd6ijwcE8NdUn3b3qDrX1iar
37114	payment	1397	1397	1678	1	1	14270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcDs8ExbFseu7FhuSj3TQp5PjFk1rqycQEioEgFyDHPaDeXfk
37115	payment	2133	2133	1874	1	1	4502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkhQScrXbXCc2W3VtN8qGCLA6B4rhSwunNwsxGr5v6io2mSrK
37116	payment	2134	2134	1874	1	1	4712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyiH25aGTFkDGcYyQJUPiDs3Pon3oasVDaKUbFguHmQMKYPYuS
37117	payment	1397	1397	1678	1	1	14271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUB4QxbL6mnfp8DMvgfys367M9W75geapV6GSTH6ScYZ3fwTt
37118	payment	2133	2133	1874	1	1	4503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEF6UZ1pzWEYh238gynqcxjoCqZPmT4SiqbP6FwCTQ5gJLE2X
37119	payment	2134	2134	1874	1	1	4713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYPsxuHDS44tXMRCcbR8qqZs1kRTpxDkqD4douiF8PvGHJUoW
37139	payment	1397	1397	1678	1	1	14278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG9bpCpo1yWT4Qb9qx9vFvkdm4wuXaDmSNUeot3fkT15pBcGVA
37140	payment	2133	2133	1874	1	1	4510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFkTTca4obtnjGsqRjZFdjxrrmVi3yRmbNe1RKV2rT8qGrzyv
37141	payment	2134	2134	1874	1	1	4720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVYgN2eBvgMhXbAWQWYaFthB7jZNovybwCDZcxXCSZVfHKeLB
37142	payment	1397	1397	1678	1	1	14279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQDV2WxQA2E9sBKG2svRQTD2KsGepCJ3X382rpGzs1vMfdoFW
37143	payment	1402	1402	795	1	1	34	236482970434	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZXcihZ1EpMSbGazNpJf9s4odtbX34esXujoXDD1WDDv8a1SEy5
37144	payment	2133	2133	1874	1	1	4511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjad8MrJStdLZVmvX66ZWTD1nkrbss5XhwzVK7Sbfeb4xo4Zt
37162	payment	1402	1402	858	1	1	46	1394170478013	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYuxRVK4EyJYzcxVYT5AjKYGGbESuggyi6e9sHvFDBsaFYwPsKf
37163	payment	1402	1402	862	1	1	47	1925674410275	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZFfJHvcwrdmXpyzxHXFj9BvVasMycNd3WAoDuJf3cACwL3KU8h
37164	payment	1402	1402	866	1	1	48	1690526049926	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYVje1Wd1r1CGAxkK6NJDg8DA7rSPHH9EshtmADBqvBCDtzrco9
37165	payment	1397	1397	1678	1	1	14281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcV9CWyzhnFtvdERy31viYdWTqnySe5YKsUwoAah6N4isjxryA
37166	payment	1402	1402	868	1	1	49	10295684968407	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZm7eUoJHJM9c4VV5Aikzd9kUHyWkmZKjZuHpvRDJYoYaiUpeht
37167	payment	1402	1402	870	1	1	50	1101043429532	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYgNugGkN3LSCJZuqqWh5XYmqko4cnuczMjkAuryAEuSG1Vw8ux
37168	payment	1402	1402	874	1	1	51	10295684968407	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZkQ6oAdTj5BykHRePWvGw7feFopF7eH8wQmuU31wNJGM2mMpri
37169	payment	2133	2133	1874	1	1	4514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpoV9STFRiadMH15N7FyDG9sSmLuaTezmBen1pXkQQN8Q4VDcM
37170	payment	2134	2134	1874	1	1	4724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WGujo4FCbhCJn1ugasAvvMUhK4tZg7veJohz4GKZmWbbgfWJ
37171	payment	1402	1402	876	1	1	52	902461274761	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZDvPRfrzhJfkFL6AAk83gihHeig9KnpjizhnLsRm2GJ843uEjX
37172	payment	1402	1402	880	1	1	53	571982498068	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZ9YVKRuUer4ayHTKMxZ5Y1XNzb1gCeLTrfRtmEWgG1hxnHp9T3
37173	payment	1402	1402	882	1	1	54	2478590825119	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZx2mgv5HpY9FeyeJo33XMR6CgiacMBEJKdUg119MFhjiXpMrcY
37174	payment	1402	1402	884	1	1	55	381321665377	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYk7oHuRf2n2jCdcs2cwFBPPWeHgCv2RzwYBWUwXJQU7ETZPsge
37175	payment	1402	1402	888	1	1	56	1138088829319	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZBPkuYtJJ67P3mtesZfRkotTqbUqKF9A7N9fjh9h6Ypik5NswN
37176	payment	1397	1397	1678	1	1	14282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2yGgBa7e2rP66UgxmV2GFW3kDKfeRus1aGuGaBHGJRJu5PqE6
37177	payment	2134	2134	1874	1	1	4725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcN7XuGZJhZyAa1mmr66Z6GF2dKL8cKCN3YFx39GUGj8TojsRe
37178	payment	2133	2133	1874	1	1	4515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcEsH6DZDq77A66sM2z2bZhNvWQ1CZxSCmieQv9PXmApLXrtv
37185	payment	1397	1397	1678	1	1	14285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxhG3kT8z1mCWNE4j6usDuyKSrTpu6K6KotcncfBxqDb8qf2YP
37186	payment	2133	2133	1874	1	1	4518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCdqYxeW6m2gVXmkaS5kZL8UXeax8PKhZYTJeJ8AnQGxdXdjd
37187	payment	2134	2134	1874	1	1	4728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8U9kr83CYkGSHZrJf9SkdbpMovmveThpVtTa7JjxBEAri1Xz
37111	payment	1397	1397	1678	1	1	14269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2xsgP6YcvAPDTQZKriQEFo6Fep4QQXwxHVfumLA6EzbejNjY
37112	payment	2134	2134	1874	1	1	4711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Zczb5H6av2LTfnZrocpMgLTVGCtbQgLvcUUv47rqR4hJXPgC
37113	payment	2133	2133	1874	1	1	4501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkgdoYNt79UPbJWfoRQH47gf9DzbAjiufaNYWUL3wXtxanQqvu
37123	payment	1397	1397	1678	1	1	14273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSRHkp64mh1eB9y17GEgwbWiEYpyYtHrR3vhyS7jD2FD3QDrE
37124	payment	2133	2133	1874	1	1	4505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdXB774QgDRmHY5N9p3QKwjuLhoGAWLeFFQ4aqCXz16fUJZq4
37125	payment	2134	2134	1874	1	1	4715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6tMmuX7iq8QsbiWpfttLucKaaJNwz6Hbxe8cZmWxzzDpGQpg
37145	payment	2134	2134	1874	1	1	4721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67iU51aSHan7AbLgf3WJ2C4c41wphxKoknw8onkbqi1myM9Td
37148	payment	1402	1402	796	1	1	35	2601310404775	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYhxMz1MjHEbtPjWKVt6cPVq37fTTG7Z7BNhg31m4S8MdaXxXnX
37149	payment	1397	1397	1678	1	1	14280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSWPxBvquxjrKzBoKSo1Kju2z9y8DKaDhEWSzwFHMfkjLC7Qi
37150	payment	1402	1402	807	1	1	36	112018249127	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaFgNScehxAmxyirZRU8rJGi2LHy7DxdnbqcS8DXvcoyQjPvS3b
37151	payment	1402	1402	808	1	1	37	1232199665392	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa11JNCNAYgcH3TvvYfMsXSxTFJtwyogejfNhYHvTP9g8jfVaxy
37152	payment	1402	1402	809	1	1	38	254214648680	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaE8rSCxiBe8BzWHRZbSzLSH4xF8WLJ8DVcLfZRfzcjtvVcrNNd
37153	payment	1402	1402	810	1	1	39	2796358695487	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaJJDWYpxGB4tWygsnNbw5fNbHutGTkCPWUzyJUEGM5ekp74NKe
37154	payment	1402	1402	842	1	1	40	354522378719	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYSuXMe7sgF6ZvrgxHATdEARtj2rYJJ7cGQLbJbr7WGsWkFbBm8
37155	payment	1402	1402	844	1	1	41	660957553337	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	Ckpa8WFEYFhkNoBVn7LpbYESiMUqKgahsa6hdNfCqfDuwxf6gpUpr
37156	payment	1402	1402	850	1	1	42	4893607702216	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYRwYgCToUreDGpYneufkg8CifQF5aHaiuJq76FezEqoSqG8Cfe
37157	payment	1402	1402	852	1	1	43	9479656602039	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYbJohjRDLWfaCUQZaC8NyB2JPZn6DgB7wDoS99sqsF5anUmpd1
37158	payment	1402	1402	854	1	1	44	1045284668996	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYx2KXZEAGNg6Hm2UbuNEUFZVHD3PVKoYS1hDitNaEFxc4Bcqiq
37159	payment	1402	1402	856	1	1	45	552916414810	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpaDdAprqGDKYbzkKhhBxh8JeBr8AR5p8KrULKDaD5K8CsHGeAw8
37160	payment	2133	2133	1874	1	1	4513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6hB7QbuRWDzmbS9RHLb1eHcvhPcWnXMN2DWAMBaovCux1NPSa
37182	payment	1397	1397	1678	1	1	14284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs4k4hNnMvxYbEY8NQ2cnEGeppS6zd7Xo5jGWcrmMqLiu93jEC
37183	payment	2133	2133	1874	1	1	4517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9Zk4zwWE49VKh523wSr8zeeYAUEEANMcydryadJX56R6kBkP
37184	payment	2134	2134	1874	1	1	4727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXC4nM7k5U8BfAAoErhkhPjmUD5oEw159KP3oudRCvK8b7Gs8
37194	payment	1402	1402	890	1	1	57	955364571550	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYnf8ND6WHAjZ7TSSLpahLtF1WWN2NYbovw66wTrgNtU4KBKEJG
37195	payment	1402	1402	892	1	1	58	2097269159705	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYifE9ZGYRMDg1WPviF7VBdkCiRVLKUrcBypMsRcD4Bxw3cwcQo
37196	payment	1402	1402	898	1	1	59	276656494634	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpZN7eX9AWuFpj8bdm8mPWn4PDKvF1DnFxBAFCHwkicxaiMBmYsZ
37197	payment	1402	1402	900	1	1	60	164913993808	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYg4KpFnfxv34ZDLEhJWeNxH7eD8UfzmWQgndAYsygchMtDn5RS
37198	payment	1402	1402	902	1	1	61	495718164984	10000000	\N	E4ZJKG1VMe5w8rYDwZ67vV38HJQgiVEkerTo86qiYxm7NP9estkv2	CkpYXMEaCDXgrSjMiZrGFQoXTgp1zJ4fxTZiHavDMjzxHWFQt1vz3
37208	payment	1397	1397	1678	1	1	14291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVg2jXGToBTNvnYzQYxMD2EvkeqRxWH3zsvYWxvPRk8Cd3LDDK
37209	payment	2133	2133	1874	1	1	4524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwe8ac12ZfUnoe7uHzJN8LMiqR1pgkvkJkRBj4V8VXCNfaZXAi
37219	payment	1397	1397	1678	1	1	14295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22yHUq8zyyyMVSCN5sutj6aDAGbpxQtXctFGpnQhaQA8kb2qo
37220	payment	2134	2134	1874	1	1	4737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcretTDyo7hSi5tV8YWCKC8yYNh3MzX8zNdF4nLBQFiBkMsu9
37221	payment	2133	2133	1874	1	1	4528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyTL7Lu3NFYjPWFJDqEbkDzjGC9jwVxRNF6bJpTyQ1LajGe8W
37244	payment	1397	1397	1678	1	1	14303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkyXyBQ1w84CGKRJzhhicqvsQ9dnyg8pGB8upt2ZQQpj5EDvR
37245	payment	1397	1397	1678	1	1	14304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2tgQ9F59fPQ4yCM3yF5XTRJhwNWzyQe98hsBLEZyDZZ6y1Nb7
37246	payment	2134	2134	1874	1	1	4745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoxRNzFe6x2iChmjHTnT3SHRTtLpKDFy8Av7hmED92pXf6gzv
37247	payment	2134	2134	1874	1	1	4746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAtWzTQqsMCLH2ZdrJSXkgPCxCFHsWVM78K2Bdp5SSw5zJUGG
37248	payment	2133	2133	1874	1	1	4535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJieLEcGNLviVK88Sgrt7k2pKH5eZsTb3c2WQRuLV4dJow3dw
37222	payment	1397	1397	1678	1	1	14296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWBtqfW1EN2qcJeyQ7G7zK6YcfAnevEm9yN2vbKiqsgLoiwKw
37223	payment	1397	1397	1678	1	1	14297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwGa91fcbcb85ZsmEWmabVSgp9JxrWJPnipCmkhVJfV3cQTBE
37224	payment	1397	1397	1678	1	1	14298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoKcRsKqSSCNG2yKEUTj3sEZ1yfNjszn7kbGVe6xhVZFGhHcb
37225	payment	2134	2134	1874	1	1	4738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbBKBg97V2gy1cs83H9CxF44BqCNQn9wt4jBvWzePmjYMP2Sp
37226	payment	2134	2134	1874	1	1	4739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTzsfkNYKWsPECjkB8LTwZtcxb1DpqGpUGLpAaSwe9etqjJmJQ
37227	payment	2134	2134	1874	1	1	4740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5F8ZaAdFtUvhVfPR2LdthnRok2Qdknk8jMWpp8ySS8nsZh9R
37228	payment	2133	2133	1874	1	1	4529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jFAT6fNtcJEkzbEh4mZRG9mUqYFGQ9aQ5e4jenp6ZjGtfgDK
37229	payment	2133	2133	1874	1	1	4530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfPpLdgAN8ciqVjhfh3TEHEUQ4chfBYZdFDHFtxUn2dZK9CFq
37230	payment	2133	2133	1874	1	1	4531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFexEePGC7VZzPT4oAqMbL37Q5XtzcYBopmuNwPJmmZHbs3UP
37242	payment	1397	1397	1678	1	1	14302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJ213rcxNkQC8hW6qftjVqGcyyJv68NqEPa96LgcJYFxAF6ib
37243	payment	2134	2134	1874	1	1	4744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoYFPUzB6XqzLkPrcS2w5yoAgK6BeVx8TrRhdwVqXPuawNRXk
37250	payment	1397	1397	1678	1	1	14305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnxSfierL4gD7AEiRucW2Zo5mxYtRVY5HGyKt3LGSo1JM9HKN
37251	payment	2134	2134	1874	1	1	4747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnb6LHhpJcMucpPf1hdmqoGRvcAvAbFHmRmi61mUrA8rR5BMN
37252	payment	2133	2133	1874	1	1	4537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLGv8sFJRS5yTW41ZB9Akmo6UZ7n4CQ62wJrRvqYDHR7FPbk1Y
37253	payment	1397	1397	1678	1	1	14306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeLFXcZcPwKsMQTEU7sdacSaqUZZxockKCMKtfm138A7cG5Hw
37254	payment	2134	2134	1874	1	1	4748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiWE2aaYUmyesXBdCF7Pri1dUThS2EUMjbfp7iytc1Wvq3yWf
37255	payment	2133	2133	1874	1	1	4538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZLzYFALbePPjtgp1vZGZQVbGQ7gdobsyUcSjb7UhGn8xrc6q
37262	payment	1402	1402	890	1	1	57	955364571550	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZLKpVw8E771MuRPMKg4oZFVZwc5rnSZqTGzPrumX5wTg4LVMTr
37263	payment	1397	1397	1678	1	1	14309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTYhNGNn8BEAEtLdpiUuEaAi9DgYjxatKLyb38ougTwbQCHmD
37264	payment	2133	2133	1874	1	1	4541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbVjTTvAtwnQEEbDhfqt2qdTy3iiWAXhKTfbffeFpigYv17jr
37265	payment	2134	2134	1874	1	1	4751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8BNc5XpuFxoNkUNNkwviWzJCyz4cEFAhJeqDU6vZukCyB7n9
37321	payment	1397	1397	1678	1	1	14324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrjpXPh7tLDgfLfE4p2R8Vg3TbHzhbDK9v2uDobPNT5GPgCBR
37322	payment	1397	1397	1678	1	1	14325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVZwjpRhi2faq8GuAQyYZUbS1gCAwqpfwCmoZeJDnyPA7fLMf
37323	payment	2133	2133	1874	1	1	4557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaENjo9ZmDQZKnXrA6vSVpeZkTjnbfpEkcmsAgJtokNkYwiWz3
37324	payment	2134	2134	1874	1	1	4766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM5UBHG6g7SoxPqg9nDaMRsDifBzzb3AdRjKTWFJeeanWpMXtN
37325	payment	2134	2134	1874	1	1	4767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJdc37tfEoLhx7x2TuciQQd423kGjwFYYbY5DY8vkuU57Kc9qJ
37326	payment	2133	2133	1874	1	1	4558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZekqve4MGb9eFkoz75e88iaTtbmrZmDrdVhHHAF8fM9FucMZYc
37332	payment	1397	1397	1678	1	1	14328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcEsNwiK7B7fACwoLhdihv1p1x8zdXJi7YekCiKB51GKF31AKP
37333	payment	1397	1397	1678	1	1	14329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSjx1dz525bkLGLomtBTueRRxKmss6iojV2Bwa48sYoQj6cMK
37334	payment	2134	2134	1874	1	1	4770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEe59HkMhxQ5AyNtwHJgXeLRLF2AVsesN3fdSKxHrbTxp4Y8k
37335	payment	2134	2134	1874	1	1	4771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJRsvNYBc6Xc1YFkeJV8fPtD5q9wYW35qaKGQR7S1txVctEEQ
37340	payment	1397	1397	1678	1	1	14332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWUBJnShqb2DcGztdLaatvkoQx5w4ZGvxUoX8hgDXmsHcGiVo
37341	payment	2134	2134	1874	1	1	4774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxN7iCeBbqWhibtSKPSX7H74JnTuBMvtb4rsvNnEhA5jVL6CY1
37372	payment	1397	1397	1678	1	1	14348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUUz1uYBGKvq5AdFcDwz56mrxrUgx76bGKzzmE5fxbq3X8RuN
37373	payment	2134	2134	1874	1	1	4790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYUQrs4Vs6vQPv6MNVTgTQNTPbA6S6Ed3ALjTiDcG5R1e3n6n
37388	payment	1397	1397	1678	1	1	14356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqfqR92WncaZHDbNWx56AE6QWsHuhyJnzLCMKBPKJfjc4NqzH
37389	payment	1397	1397	1678	1	1	14357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG17FQK5W4QBa2AnxLvCSCnBpTpPczRiWohKsUrA3FzztsXzz
37390	payment	2134	2134	1874	1	1	4798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqHkWp3ajC7ofuKpxsXiMWJfqKQCjJ3pw1GYXmdk2w5YDfXgP
37249	payment	2133	2133	1874	1	1	4536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzH94qqyXNcYTfieurMGieTgD6kwPUUsjcJwYaEdXvpABPXUBC
37256	payment	1397	1397	1678	1	1	14307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHA7aJCQtwPgqPjeGJpayTDwDc2wBaRMHDtA9GJ9r6v6h8QT2N
37257	payment	2134	2134	1874	1	1	4749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbzUEzKRTL3HW9FnztpwV7e9vux3LULvCEQFsHnFnYUyAeoFvG
37258	payment	2133	2133	1874	1	1	4539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiG7WgaJV2N7ZoiY7i3TqchzZGohsXHKBc3LfxogscuJ8ReAZH
37296	payment	1397	1397	1678	1	1	14316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvJvJiCT7pepgXVhhWDtfvQXgPpyKKwnpADc8ZpTkz6GRaGy7
37297	payment	2134	2134	1874	1	1	4758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqs9WdGuFy2CQqxZ8Z4VPMkw3JPueoFNahuuUdbyTpyLSnZMp
37298	payment	2133	2133	1874	1	1	4548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmXghzobmPLSEZsqKXQg1SdyJpRn1i1rs9JwftzvtsiWn5qc5
37327	payment	1397	1397	1678	1	1	14326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSsDAQZA8vEdm2UHNLsMB3eavzro5pAiJi2oY2zyZzWCYBPst
37328	payment	1397	1397	1678	1	1	14327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3fC9bTAPkr2bbVhxQzAFNBvkRiHQT7rcZ61G3D5HEHvdMTJiL
37329	payment	2133	2133	1874	1	1	4559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSD7UbTKrz5dtoR3bWWu9LdDLjjck3Bq19A3MA6d5C63DhKsat
37330	payment	2134	2134	1874	1	1	4768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dEyWm2zHCci4VfWqUPCQrh4sSBTuJj6y2HoFfj6cQdQ4t3AY
37331	payment	2134	2134	1874	1	1	4769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mAfRCQ6A42Hw1DgQpsAbYPoTrfHUVNvGn97GyCHdm3gQ4brF
37336	payment	1397	1397	1678	1	1	14330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TtcpnQuKE8fm1xujkdbPTs92Bd5zDsyDQ9hJg4ViUtFSzBtx
37337	payment	2134	2134	1874	1	1	4772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKhqKxMhHsQeb2PVwEAtf1MJUyx6xWcrdjNXXvVBYypJCWFsc
37344	payment	1397	1397	1678	1	1	14334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgfitPhLWp2T7crzgjSHcstBtz3PkaczRq8FSJmWR6kJjP8Qw
37345	payment	2134	2134	1874	1	1	4776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLajregqTDo4A7ALa9m9AdgNMUtPunKLB5btx4LaBbTq5thzH3
37354	payment	1397	1397	1678	1	1	14339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYps5xY7KEq8fRjdSoV6DAqjVHMejJBSd1qbP3HSHYkePQUjnQ1
37355	payment	1397	1397	1678	1	1	14340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9nfw5w27PSVby2L7t8FjstFvTWJfpV6EjuemvruTZpsDVLsjL
37356	payment	1397	1397	1678	1	1	14341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwJ9jnXAe95NLXN6S2o3H5ETqhbKhjKnu8nSydvqKynxes63Ks
37357	payment	1397	1397	1678	1	1	14342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw7vUjpq6Q3pLLTV89VDMrjCG3647tnBXRyWgqx2bnVLRP9w8t
37358	payment	1397	1397	1678	1	1	14343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgDS5t6ucekdp1UbGpEANBMLrfT1qFz6xpXab2czkHyptHM4q
37359	payment	2134	2134	1874	1	1	4781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULPe8P3uQs6SJccsYSWHP6se2DS3fjW3vs4N6bneBnGs3GaXZ
37360	payment	2134	2134	1874	1	1	4782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNtxzfyEyqabHf58HBgX8oRSYgvQk1gDKmLUbgUcG3SwZJV5e
37361	payment	2134	2134	1874	1	1	4783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvLTPAxB9tNbuGS7FbQapv9gcxbkVTGGByVQXcrrhReWZ6Wh2
37362	payment	2134	2134	1874	1	1	4784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCb9vzpxbDKazU9Vtw8EKBW5FHerjNChyB3HsxAmDk47HUAmDM
37363	payment	2134	2134	1874	1	1	4785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGHf7oe1Vevp5vCD2iZD25zAQDzD6BVSB4R2dRkeeheNTkiyQ
37370	payment	1397	1397	1678	1	1	14347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB9FWiXrFGZH2SLcRRCQsLpJcAnRLnL9PXY5q8S4GCv3KSFfp
37371	payment	2134	2134	1874	1	1	4789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qvCcUo6MHXTyHhz1KAecHEfxjAG4zz5dNadwyNbFa35cd8Yf
37376	payment	1397	1397	1678	1	1	14350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdLGNbsB84pWH5V2aRNJyPZAHNdvRheSKXe3oQpsC9g6KbWsj1
37377	payment	2134	2134	1874	1	1	4792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepKybRvpFG31rNxHeTxzLaB8HYEPwPYvNZ4RgpL2t7X4yKvhM
37392	payment	2134	2134	1874	1	1	4800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNshdrPfvTxHiM8ieX3Vn6YNj4utg9tMBVSMJad9ZkBgDcagPP
37416	payment	1397	1397	1678	1	1	14370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNtgRKSxjLqwv4mc5WLCocsyuRmbGA8DkNwra3cEAYZLWjjsq
37417	payment	2134	2134	1874	1	1	4812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyrSpUXJdc934LoZBdnT5T6ahdnVV7ZkkQfEsvUXypBjZ9fXi
37424	payment	2134	2134	1874	1	1	4817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGfKuwirWdJiBpKnd1Eg4uAYUeqnGBRA6Bi8fe2VhUoqYiCyG
37439	payment	1397	1397	1678	1	1	14378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5Pe4XcY75yuxNex2FRNyY8byiNdRFvo4QXbJHLBJDcSDFCco
37440	payment	1397	1397	1678	1	1	14379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSDxbsC1brewNvBQWpyAyxpYEKQYZjESMAEE3W5DLuamdNmkn
37441	payment	2134	2134	1874	1	1	4825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxQbCjYHouTWM8uACk87YdPYZQB7pakPGbLwmnP6LGPxpVU9n
37442	payment	2134	2134	1874	1	1	4826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUH3eTtzUKRffgQzYeJXyEq77TgKPnwqMgWJazY9dHAcpd5Hmq
37260	payment	2133	2133	1874	1	1	4540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhr6vDb17QG9DZAMYurj1FiPPDwE2s5fDqCykT7eihWBE1iaqY
37261	payment	2134	2134	1874	1	1	4750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWNfUYRD8o7PGK32F9CPS8AVALQG5ANG6NpLk67MZur3Lt1zQ
37269	payment	1397	1397	1678	1	1	14311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvmB62kvdf7SsojGo2jaPgCcVXBCtzroczWQxXL3Ceiuv5dvr
37270	payment	1402	1402	892	1	1	58	2097269159705	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpYpXL5TJeMXKkCk4MGygaRzc55oKvhfPavdLP4o87pPhw1YkYj3
37271	payment	1402	1402	898	1	1	59	276656494634	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZtkwE116H6iYypJ9JAoeEpwW2jdqdNsifTiTdwW9ZCQKb3fknE
37272	payment	1402	1402	900	1	1	60	164913993808	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZeKFkV44zgYKUEFNNvFJsfkJ1y7aUjAtEjCHGS4jFgYPk1qtn7
37273	payment	2133	2133	1874	1	1	4543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYwwrGYmAnhXQJReiSF94hYXbvAXz1Q3zhz1UXRXkHeSnp1vfM
37274	payment	2134	2134	1874	1	1	4753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNq3QzbiQi69bAMGLLKFZfBM38D9q71TDn1s3zSmu4Wo8osJv
37275	payment	1402	1402	902	1	1	61	495718164984	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZdMSiYsN6fwBhxkX5yk9JMRmo9rKeZSXKZJg6qKvqy7EtrBB2U
37276	payment	1402	1402	906	1	1	62	1782678785752	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpZtXvraeTXbzMmLR5pjEFmwqbiWbemCUbhMi2NPFU5bkFAUQeKP
37277	payment	1402	1402	1267	1	1	63	398419064786	10000000	\N	E4ZLG1BiofwMp5g3XFzhYUzSt5KoLCtTVjFSCD5sEru8SQLbiLiJK	CkpaBaqQNwJim2s9mdfqJZ7un7XVA1pmkskLBM64GcnvZAj4sX7GG
37278	payment	1397	1397	1678	1	1	14312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNYMjsjLRCc89mcZ1F1FfsZtsGo38zFRhypqUpvjhVXyHfY1R
37279	payment	2134	2134	1874	1	1	4754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JKnP7DQbkEx3oHwpbv1BzHotwBKoD8UtTuqXysw5fs5FpKJM
37280	payment	2133	2133	1874	1	1	4544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZT3iwe325SeWkf1meoUXr7QEvtcv8pnaSY1Sb5UvMeFHYGHX
37293	payment	1397	1397	1678	1	1	14315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCECfxJATwHbrc8mDakY8gqrXpjRnDMMgFUYrpDmJRMQG9wXeT
37294	payment	2134	2134	1874	1	1	4757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYWnjzsA2tkq25X1fyovcGLd4kNGm7eryXC9HXmxuvDtbW7eA
37295	payment	2133	2133	1874	1	1	4547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKa6ax9BWYUDoTWxSupm286dnGZEFj4hKaaSNUK8sRW4zhzyMu
37305	payment	1397	1397	1678	1	1	14319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAR89zHDyEWZaKGueFfhsYKpZFYJYQxGKXDrQ2We1bBc8g5qiw
37306	payment	2134	2134	1874	1	1	4761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bo9w8GVCv3QmuvxZJHsYKxahdwewcN5hfvZRv75dC89y7h1i
37307	payment	2133	2133	1874	1	1	4551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6M7UnLxbXBoKzd4WFcQvFLN1h6myLTJsFu5AEBhQyD1mZvrT4
37308	payment	1397	1397	1678	1	1	14320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYohvjq1e9MWfRyyTgtNhnddhbYyvQyKoJeFw36wpsk85fgSg3X
37309	payment	2133	2133	1874	1	1	4552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCspaiwJSUrJe9Lsmfapy8E2o9nBW7VHUnEnB8BhoD5VSGEew
37312	payment	2133	2133	1874	1	1	4553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBPKbDFX2hhdmFSYzgrWHUjKBph9ZffoJMNxgVdTxhL4WLcPLF
37316	payment	2134	2134	1874	1	1	4764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMP9pcdHGiaeKZpvMpNgXuMg53bbFQpV9jWfbfSwXQSeTkfQq
37317	payment	2133	2133	1874	1	1	4555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhUQrBAYJ8Q4CW5r2XfReddwffW7iSKV3mjUaj67653kVHxaR
37318	payment	1397	1397	1678	1	1	14323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2NsCX6PAYxyEJDyVq3AwuKRhtQgRFdYh4KfkQxBuzD7mSxyD
37319	payment	2133	2133	1874	1	1	4556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYovmZaNiP45iN6hT9CdmWyB4PQzP2eD9EaAJp8eMkuzuFfzCU4
37320	payment	2134	2134	1874	1	1	4765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwyHnXWN8abMbsNXxkm4fj9itMHubynojqNN2LQoxUP6etw67
37338	payment	1397	1397	1678	1	1	14331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFh3SJECjUpiiKcH5VHpmH52JxGQobemaYYd6jHAXyooKejJ9a
37339	payment	2134	2134	1874	1	1	4773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ998woEvm92MW4nP4x3oQVejFF6cduFNCzqoNFPTrdeVtw5fWm
37346	payment	1397	1397	1678	1	1	14335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4u9kU4t3YqyLFqopM9CNm1968fcZHAxxqcd3ZRnQyrCKsUbBn
37347	payment	2134	2134	1874	1	1	4777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHm9TrR1kXbRg73xUqzgNGnifESwNyLiGpCtLcNHWJkrGmhPKc
37348	payment	1397	1397	1678	1	1	14336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiPTP9m1y3cGbBoPRqU1hu9WHGWHB2s4USCdok7gz8UGmYPpu
37349	payment	1397	1397	1678	1	1	14337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZduhviryFsSmgnhWqcVDs2UwfWAX4cTz4NhEAZNQUz5ti94jnK
37350	payment	1397	1397	1678	1	1	14338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Q3KT1vLGSb7SARPVcZvx6MLLjN1MvVbNjXrYrhoeK7NcYBzE
37351	payment	2134	2134	1874	1	1	4778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufSa29DJGn5gmwqpxM1TbLaarWZUYZsDrpyYoT1xViU7xLVSv
37352	payment	2134	2134	1874	1	1	4779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLNotLeEUEyZoRvdYxceDaQrrG1gPyeAwGGckZ5moe3jY7CCG
37353	payment	2134	2134	1874	1	1	4780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDMD4jXmFWtpk3y3REQfV7ujqx5PXPcEibT2LjqsqoYnSrtRr
37288	payment	1613	1613	983	1	1	9	2877287500000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiBHs1MpVhoYaJJhxJ6o4ohjBCyGNozY9jTv3erh9p5rM7xrq
37289	payment	2133	2133	1874	1	1	4545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKMonf4KoXeKthxtvjRrcWbocRgV99ovUAi21a1WZ4qBwJLmz
37290	payment	2133	2133	1874	1	1	4546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2na1KRu3PL3SANSJMQjrFta8rbKXGSzNBJxGiFDGzRXpHW8Lm
37291	payment	2134	2134	1874	1	1	4755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAP1KCnoH5KMRKQb3zaGT4573WCtSzmty5BXZ1jbMmYJxW1sr2
37292	payment	2134	2134	1874	1	1	4756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiUG1ZC9wRfHBnhEYKTMBRjs2wWPeZ7TJSnGLDG3Wk6am2A6P
37299	payment	1397	1397	1678	1	1	14317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn8Es2Y5U5VoeGme1tf9kAvH7XHWuftWd9t7gBRF4L4bRfTjy
37300	payment	1397	1397	1678	1	1	14318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdfR7bpdMqdxMHhucBTtQW2ZQ2tJ7BnZ9LBXkLaf62W3rS1bt
37301	payment	2133	2133	1874	1	1	4549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKrjWETnRogKSCQXpKLohViDDGGvWsQinFWXM6N3wGnTKF8zss
37302	payment	2133	2133	1874	1	1	4550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeWButgcTvybuyKNzcZMTV3KLy9RxG4jJpjV4hw2kbYQCGRoUc
37303	payment	2134	2134	1874	1	1	4759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YHJgaXii7oiYMtGi1VBkfrbmJmUFNPP8njWaf7EZTqtPAtfG
37304	payment	2134	2134	1874	1	1	4760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVRLasYmwRWmzyD3NUNejQZ2JgQDWG7cNyvRxA9T8WDVJ9Cyy
37310	payment	1397	1397	1678	1	1	14321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTJNbVUUwfwPgKi94ksnRrWeuyLruTdZikMbeiEERCuS9a9G3N
37311	payment	2134	2134	1874	1	1	4762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGdVWPtYuq7dtJt6DqmpSiWSazRuPmzYpP9CDw9EiYr1n1xkX
37313	payment	1397	1397	1678	1	1	14322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPoWxxKa4Cc99ZwfUJrW1eKuwLEADe7uVvz5PgvGHvKdtixK2
37314	payment	2134	2134	1874	1	1	4763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGG8zaD7a2YzdtAZpe9kL93ydRmzTWsHWNDsinUDCJ9qUGGtP
37315	payment	2133	2133	1874	1	1	4554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBHv5AKaoftF69NfWBMHjshkE7KKbXAU7Y6UjfUAmX2Z78FA1
37342	payment	1397	1397	1678	1	1	14333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6479kAp1HA1t73pr65L4CGTTZ9owh2ddRGwqqxkYCXbefSawL
37343	payment	2134	2134	1874	1	1	4775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPfaScSfNfcVHZhXMxc9cLFsjbhRe9o8nsLmHF6UY8jyVVjGp
37364	payment	1397	1397	1678	1	1	14344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTGybXyTS9nhahmoiuRTYNJgWuG1HaSq4hHFK2TiPjGkwNtzNF
37365	payment	2134	2134	1874	1	1	4786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwKQ9VZSnZEb6r7aAtvfDvXktNsa918xBPtBBhWQzLMCvPt9B
37374	payment	1397	1397	1678	1	1	14349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpHxCWpipMbPKGE6ymxJRFD1G4ooNYbHZ7XygSMpqkvU9u7Ra
37375	payment	2134	2134	1874	1	1	4791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqajbPbKCnsmNZQ68tvR7qDxoCcaJju9tMTpgJqzGrHmfX7Uc
37393	payment	1397	1397	1678	1	1	14358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApVjAdTo1SzdJvWwu8voh1pPEZtjFXJKgebH21UsQVacyfgbv
37405	payment	1397	1397	1678	1	1	14364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdysAgP9uEcGfuqWs67kn4hCDm5JEn5aoFVz5ELQ18tEAcKToR
37406	payment	2134	2134	1874	1	1	4807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgucUvEic2N3hMustubQkS3S13g4t5E1gYaM3YrPdq9exX25ps
37413	payment	1397	1397	1678	1	1	14368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GxDqkxkDSMsrbNdFqJcoFHYmS6CYPfYwWhXcLHSDx6FVsh7j
37414	payment	2134	2134	1874	1	1	4811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxgwxq7kE7RksXsJN1w6tjVrytExXt5b7MfEPtrNpReGVtYbt
37418	payment	1397	1397	1678	1	1	14371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Hi4NgrJWRzg8Mw3YWU4mnrxuePeJBYc6MRspY7wNqJ7zMwqC
37419	payment	2134	2134	1874	1	1	4813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ17gdnTdKukchm8XeS8VAbQGHKpS5t6iqaB2mxErWBehCwndVE
37451	payment	1397	1397	1678	1	1	14384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2QNZQjPNxRJ1teWmejUSTQKS3WnQRSpUBiXL2PMwcQY253xp
37452	payment	2134	2134	1874	1	1	4831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3i8AiD7XxMT2yHbLER11U5sJBifGQ2fLdq44YE8Gxg4UwrZWv
37469	payment	2134	2134	1874	1	1	4838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPrgjWMZVHtpVCMR2UMa1VfmZtZXtMxJcQJC92Jq9J9aeUEsY
37470	payment	2134	2134	1874	1	1	4839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNdehXzcGY9dWjcZEwtcWFMhyq5ibaCSpjyKPR7PXUEqduMtn
37473	payment	1397	1397	1678	1	1	14393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivRXdU7kaeZYPch3rk8xS8rVvHZERxJfjtyMpDujBnidG2ugh
37474	payment	2134	2134	1874	1	1	4840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqtvcSAw1MEa1jXgUbXS8374pEEvuQTaarHeWEhgNeLYVt7Kc4
37475	payment	1397	1397	1678	1	1	14394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEchRDW3joSE4LbyJGaVPseKVVJ6yRQ56Gjx1HrU9RMKdJXGXj
37476	payment	1397	1397	1678	1	1	14395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBXW8UPJyMHJMNeyNqxEnDqPLYgF2GSjbT53cbHLVBoh5yQdx
37477	payment	1397	1397	1678	1	1	14396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3geMEVJfvUNV1Be3WRoW4yn7XjZwFp71dwpg9FszLYLLATd1s
37366	payment	1397	1397	1678	1	1	14345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxXP73ZUiFujEk6GW5YcdUxbvoeWGYT1fUY6qnHiBE7cpWoYK
37367	payment	1397	1397	1678	1	1	14346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUpgeXU7rqXLTu7BsiNe66HGB8bpUtoJxrfLCxm1DTAED3UQV
37368	payment	2134	2134	1874	1	1	4787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytvhY61beM74j6kQhQQqWEydsoRSzmDvcBqzerUguEeYbwUFA
37369	payment	2134	2134	1874	1	1	4788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvy9J7qbnzE4CR1hzswRLrDcxdujEFEwfLUEYTzxfjCFEz682
37378	payment	1397	1397	1678	1	1	14351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPJxKD685mQTKKcf3kA4e9Uj9nLYQ77WXpvGRZy3DwHqaRgvL
37379	payment	2134	2134	1874	1	1	4793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuw4x7vSXxF4CJ9nsPmWNkTu8HtUHRPMoGckgxZuENXeSaf2Bb
37380	payment	1397	1397	1678	1	1	14352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDFVxVbUWQECJjt2quBd1PiCfhtCat2dXmCDQYSSpr7XVUcub
37381	payment	1397	1397	1678	1	1	14353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzTkSXr6W3zYLMUQSeBGANupXSNPe1G5qCLnMFVrFX4KZXSxb
37382	payment	1397	1397	1678	1	1	14354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu87b6azsELfaT9euvRS87a7Vdt6WuSUH26M6pKp7t7F6gtk7f
37383	payment	2134	2134	1874	1	1	4794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKxyQtT6mgcqWracUsCpvqndQ6XuRgrg4sHJKcjFkuxFoJR4S
37384	payment	2134	2134	1874	1	1	4795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGTdky8j48G4sGSCm2bKudR1kuJLdLuhBcaMWmHwpdcDqQFiG
37385	payment	2134	2134	1874	1	1	4796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1E7SPWjfrbjafyW2da8aRDg5ijGWiTRTdfcDHYcf15SKT4Ue
37386	payment	1397	1397	1678	1	1	14355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAN7UPG3sYp8XCJmSbVCptsmzrEKNbfpekUdNyjs39CvVU8LxY
37387	payment	2134	2134	1874	1	1	4797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxJCtWHNDr9SRnSKHAM8Tr3VEjXugHuSgPfrTq1rhwpj8PJgR
37394	payment	1397	1397	1678	1	1	14359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFKAss9aohZp5tZ4tTQnVRwViwf85hv6TnNbGkAantrkrVWp5
37395	payment	1397	1397	1678	1	1	14360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgDW4Z6H2heq2CMGPU9ajU7miSx6h3Q5i9RedkADQWTw3zX8vt
37396	payment	1397	1397	1678	1	1	14361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuccJ1bU2FpfQW9ubMfMcDBQWVqLXW8N9xtPPetMEvvgRfFBW
37397	payment	2134	2134	1874	1	1	4801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u2dgGMTyP4fAunbVUZ7gBYj9zQfgwKWxEkn3M3jeJzKRB16x
37398	payment	2134	2134	1874	1	1	4802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3X3Uio1iRyzUYvJ9cZrPFfgp52mxZrZy5bWgGwMcxJnEGtj2
37399	payment	2134	2134	1874	1	1	4803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8n6oLvC7orm97JeX89ay54axX6DQgjsyqec5NgUE8jGqwvdB
37400	payment	2134	2134	1874	1	1	4804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBYXNxrqNN9WwGQEYf4QmpxXt3LPf3RsbBHrFJcXtnPX4cxax
37401	payment	1397	1397	1678	1	1	14362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcc2Xz61coPT5Zh5Ptf1YQWdaNwM2G1y6tct12ngZGQ8ZNWEm
37402	payment	2134	2134	1874	1	1	4805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsFQgvcD4E1CFHz9NFEQniq1kZp6i83Hs3GUZKSj9trbVnVFHd
37407	payment	1397	1397	1678	1	1	14365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sYieX7GoRecboWXE3FuG9DPfoAqMiVfyKH2gsTtwp5QcjvGs
37408	payment	1397	1397	1678	1	1	14366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45aKfhA1mdcnoV61t1LDCGrQsYAMqTxaSHfpPNxR2SbWjkDvR
37409	payment	2134	2134	1874	1	1	4808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmhah5xrPjjigAapErsx75H4rdYuwCfNPLdG8wRKB3fndSmNR
37410	payment	2134	2134	1874	1	1	4809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrv2WtC9LDwwb4AYy1HjSGhCcLprVDLNwgAoDxuVVhS9guiuzw
37415	payment	1397	1397	1678	1	1	14369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBodmMEmwmYGZNd4S6WXu8FCAcigBrTC3AaFAxxgzi56TV6Qb
37425	payment	2134	2134	1874	1	1	4818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnLEY3bbj52SrWRkDooZwHvZbij9cMJcfS91LWcgwcQkzqu2gS
37449	payment	1397	1397	1678	1	1	14383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEicNvhSa7Qksx4S5AyospX7V3T3SQqsvQT8qwHLVHg3h5PPL
37450	payment	2134	2134	1874	1	1	4830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBetdTFqHH2A6hfKhiFhjVhrWbHmetBRHEkgKHMXw7NH1u7842
37471	payment	1397	1397	1678	1	1	14391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSB4iUpdZoU7HPLthdAgrhsnYZU9oWDutYHkMkhYg2mPtWyNN
37472	payment	1397	1397	1678	1	1	14392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9QC1d1shBz7AQm4jbsQn38q75G1dgZqrmz63qPpGo9LEVNMD
37481	payment	2134	2134	1874	1	1	4844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJH9jNSnJnjCp4HC1kxse187Gk9ZQJEbHajnjmx4u5snFp5Gi
37482	payment	2134	2134	1874	1	1	4845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiz6Mvpqu8Qd6Y9efSrdE3QPXrvCxqCAfiNmcYtZbjcP8fcFW
37485	payment	1397	1397	1678	1	1	14399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAxaDeyQ2jL2DtRkLLnUTtpVYqYGy95MDK1TnjqjkjLN96x2K
37486	payment	2134	2134	1874	1	1	4846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA1TYUrQfQv5fHihno55Tt6drVjPSfehyQSik9UPT2Pbsp7hn4
37487	payment	1397	1397	1678	1	1	14400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnuRrTPJwGBVKMQp9XAB5uzVxvLj9LxgaVMM6JjgFYcrwkYKng
37391	payment	2134	2134	1874	1	1	4799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngijDhgViwxWxdvDPnz1TxZSUgsgH4PoxMN6PfobCcM7FPufA
37403	payment	1397	1397	1678	1	1	14363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfMQ2AUke38cEEioWXYWCDzRWzpKBGLGiSUypiEJoD3H6wHD6
37404	payment	2134	2134	1874	1	1	4806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6i4RXsiyXLtYsSJeQAieWhDvV4yAvA2cUif3d3CrDADY39yb2
37411	payment	1397	1397	1678	1	1	14367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71gjdr2umSCMWLxawjA4aS2Bd6yju46XdvRgcWaYgTgrW9Fnp
37412	payment	2134	2134	1874	1	1	4810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPQES3GgbT9BqUuogLL45qarCSzxWESidkQznyBc3Pv8GThUr
37420	payment	1397	1397	1678	1	1	14372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALqYt15AbFawtL6xhaSNqQLqTrbrb6SrSN5eEDYQjYqMTGkBf
37421	payment	2134	2134	1874	1	1	4814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzK7rwTax6VR7cmDZSLkCQujFrza5jKLQmAJzYqExaNmK5Yvz
37422	payment	2134	2134	1874	1	1	4815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1aF7BarJ8S8g52yBxFstibu66AtCczrgWCEGkCurT2c5BHfP
37423	payment	2134	2134	1874	1	1	4816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJE2uUypf2icrHcdBVHJL6F2ikDpBmTj8J3Gd8eETt6XjHxNA
37426	payment	2134	2134	1874	1	1	4819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLc1FFLMr1vNMrwjmtLLEfmbJitXgaug9rksYrpvzwPHDn1MB
37427	payment	1397	1397	1678	1	1	14373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNMFujJvgKo1h7DxNgE1gpbvwpcKwHwoH7qjjerMH65Wpw7ws
37428	payment	1397	1397	1678	1	1	14374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsAaXXRw3WZuffhyHRJcGHNYvrFHe47k7Nhbg163yTTVGszk3
37429	payment	1397	1397	1678	1	1	14375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTzGbVsiYKGWLR4Pjg8k2cgjyuhj3DGwrgW8EgohrBeLHMPry5
37430	payment	1397	1397	1678	1	1	14376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Do5MbJ25iQyezzdnj7XRT1Rfhp8kshD6CCUMiQAtCxdq3XGx
37431	payment	1489	1489	1014	1	1	4	94510000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgfJ3cELKn7ABtb9mYHfdpGwMS1ibD6GCZy5nWU7dRhK9rEJc
37432	payment	2134	2134	1874	1	1	4820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczQ2EmXCUTcNwPr2t2HRxKwGiSKbxmmLVvgMZS41CoUHKi3kp
37433	payment	2134	2134	1874	1	1	4821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGGHTGpNEg6qTZvCJ44CMJJN5kixNynWEJVEJtZ7eYVWCWR8WM
37434	payment	1489	1489	1380	1	1	5	703940000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpNMVLfAVnKBmPrvbGkVLEtPCRde9iPXMefqbxFRPD7nCsQTvy
37435	payment	2134	2134	1874	1	1	4822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxG7b6dqWrwzjFqA9BvjfZH5yLmt7yZwjQ9XoVNS8EKxF7JZzn
37436	payment	2134	2134	1874	1	1	4823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7VwMtwn58xSREeHAv9rxsxsxYVnuCFcqqbguSz5e6U77t9Fp
37437	payment	1397	1397	1678	1	1	14377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJ619ydMz2ThEYcqoSnoi9MG6ya4WGVpQ1a3KPgJvhKvg8ev5
37438	payment	2134	2134	1874	1	1	4824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFBgBoMnj9NXxmhG3S148TfLCQvSc7ajdN7hpCy7aRNvg8Brn
37443	payment	1397	1397	1678	1	1	14380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5cwaererY6siDvEKnTantBuPxh1iVBXCXZupd3FWKDzULRni
37444	payment	2134	2134	1874	1	1	4827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhSWq1PnNnrhN5zseZgpiNC4MSXvC6hUFLsG12pqNJWZB3Hauv
37461	payment	1397	1397	1678	1	1	14388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3JoPTCB8MksAnGG6HLC4h8XKyoqa6ePzWJCFZ6F365pCtnQ6
37462	payment	1397	1397	1678	1	1	14389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZheSBy8RfWD4TFWntxpDXDGsrR9SG9qRsQx5xGjQ7aEC16eNjC
37463	payment	1489	1489	1134	1	1	8	4084870250000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehJP5MC32Aot2S5Rxw2ysjF8gZHxBffmsmdEo9J6hvSLZQgkn
37464	payment	1489	1489	1014	1	1	9	2279514390000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJU5Ag6EenQMz8ACKCr3hhU4KXJa6Wki4cLWHW3rME9JE3pCR
37465	payment	2134	2134	1874	1	1	4835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVk6GZ9oyw38WEqfYoJF4wThPDhbGfaDPpfAHraBLEiirfmJV
37466	payment	2134	2134	1874	1	1	4836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kMj78tVHM4ZjLaXXGhWw7tY5bBGVk3B571a8HZYjz1XXYmqH
37483	payment	1397	1397	1678	1	1	14397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8Pn5nvX8hjncyRMbC4Nhs4D52f4c1EKT2GDeenC266PMAL12
37484	payment	1397	1397	1678	1	1	14398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcszHRq1KQrZStDK1e53PPS7Kz42SmVdoVS6YEnfPjyXQb3PYs
37500	payment	1397	1397	1678	1	1	14406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7hix2Wf9679XywDbRnyYZ6z1dTgQ3NEZtvNNQPSWoxHr4Pedj
37501	payment	2132	2132	1874	1	1	1315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWhaemdfFZXGjKaHs4fXQRpmpT3dyJDty8guBVX5o2GSFdn2B
37502	payment	2134	2134	1874	1	1	4852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZty5w1EdD4tZiAG4wK9HsE5Kn7QP3Dun9YahnTmWBjcCfsuWQQ
37505	payment	1397	1397	1678	1	1	14408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDRYqJxH67FbJ4RCiQh598Btd1XsZAVEhjWE1YXGwouypAHU3A
37506	payment	1397	1397	1678	1	1	14409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwzTaK2st3ecQYY5zn7wzg5avpTwrRcUQzPa33WuLnAf7Zt4Z
37507	payment	1397	1397	1678	1	1	14410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTHjZUzTQEfZPLEWBr8novYspchA1S2qEAAVvZVoi61danQR8
37445	payment	1397	1397	1678	1	1	14381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLndMu42aUZbZp7re8Xeo83NhtGWJgdpykeZEH1uB7DNEynXCz
37446	payment	1397	1397	1678	1	1	14382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2JyMPGrx8g31B5BuWpA6Rds7Z5MHjvzDsvpHzQdZsn5m8ZFv
37447	payment	2134	2134	1874	1	1	4828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgv95KXM4wXqjSems1wQTfGmkkQjZJTk5nXi6o4vRc92irpJd
37448	payment	2134	2134	1874	1	1	4829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6YPnztohAJPinnL8ikcXXw55e6UkHFbzcrrRwfoqEo75MqAL
37453	payment	1397	1397	1678	1	1	14385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitGxcXqTDe4eW5619phG3SJy7mJ7QKwykBVtM6dFU2FUWRZo6
37454	payment	1397	1397	1678	1	1	14386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqLyxp9tG4gUsVUsEf4eFpekCeKiSXRHjCBbmHqSiB5wHH9SW
37455	payment	1397	1397	1678	1	1	14387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMWXYfydK2VrZiN9wve8jzbRX1ejgt4mNixYNscvqq1jJYffo
37456	payment	2134	2134	1874	1	1	4832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9ZvpDstVpEahM9oCZ83JHujNduCBbPH1pXTd526zVdWE98Mf
37457	payment	2134	2134	1874	1	1	4833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9oHqakgRPp6eVfEVmX8m28DVt7iPFDrVL14C2FaELccMVamk
37458	payment	1489	1489	1380	1	1	6	7680238520000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbAnjxmY2FuwVedreEivtqiQ4zGKUtxDMaPz8R7WKt8DhNXEso
37459	payment	1489	1489	1254	1	1	7	2756143350000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNNGZtizQR3pzjEQrzpjFJDqkiS4ssY5oQ17YnodbmuXTvGoa
37460	payment	2134	2134	1874	1	1	4834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeanRRDE4KhAHeHAK78yGW6DNfGVNWt3tcsmPRPzCsDtNcooFX
37467	payment	1397	1397	1678	1	1	14390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXpn8yV4n2V7Ldo3hz2cLqZTXCGnRbPtyWa6AStfPpRzJXT7n
37468	payment	2134	2134	1874	1	1	4837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFTTh2nzda2JSDQKCpjdLaCmwffJNFPYVZKeVN6G1WfALruVy
37522	payment	1397	1397	1678	1	1	14415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFQaoE3yhpF3uEVCbkfUtpREMgd8k7PYXR7H3tKEcYxRAp4Do
37523	payment	1397	1397	1678	1	1	14416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwFtGgWUTFfqQouKEuVC4PKepoKyuY4oozYFhpZEtcFFqgApZ
37524	payment	2132	2132	1874	1	1	1318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrG1h5BtMnxdBCsU2EVincovyb2wZ8VPWXwjk55JkGAUBW5Z2
37525	payment	2134	2134	1874	1	1	4861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQXXjaQxt21R6x2BxaJ2udzMN2599BXeBdSC6PaBguAerFnYA
37526	payment	2134	2134	1874	1	1	4862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQy6ikmwiGMWaZXbfM3TgisjTVQ8vmUBJXWwfQa9Jcr3fuo3C
37535	payment	1397	1397	1678	1	1	14420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWFYWjgQoZbXM5uoxwSf2g23Pzz5PtSAxESns2ajutbas1e5T
37536	payment	2134	2134	1874	1	1	4866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBwJPEmknWuXxsBVpDVXUSTe4bb8bCFywfbuaTH8Yn1VeMhRKR
37546	payment	1397	1397	1678	1	1	14425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2GXUwScYRLtfRZxWRqdy9VEpHaSJSJ6QkDQk9CnrSUyQNS39
37555	payment	1397	1397	1678	1	1	14429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmJ7rDS2GduZzGeJHwfRGk7jaky6933edUzst8sSnnTZKEF4aZ
37556	payment	2134	2134	1874	1	1	4875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefSmoYHkbdDEhHBZmQHexPNaT6JbCv5zdFXTTzRstxAWQ3e7T
37557	payment	2132	2132	1874	1	1	1322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypxCN8xEYkmeK7SGXgpaAu7pf6G5gPeeEQC1hj2TrtWQedQj4
37580	payment	1397	1397	1678	1	1	14437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4hYU8A82Pby5ojxB2dcKBZsMHpWLJuAHv9iMry6h9yQ59aJm
37581	payment	2134	2134	1874	1	1	4883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyCJUCztdmo4XQUWSap7uAZbD9FFcmCssSV851NFemtrUJLoa
37582	payment	2133	2133	1874	1	1	4566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzCdiYbNEhehQYraY5aDMd6SNYo5ydu6guiE4uEpHj5Js8BQz
37608	payment	1397	1397	1678	1	1	14446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfwvTRB5fqzhSuJt11AJLEzNVZKCRNHXjEovzVsPyGfDiztjav
37609	payment	2132	2132	1874	1	1	1327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLJr1qGqytnzhFyGg9VBJtuYsLuc4VTshiXnPUiwjLyTRVuQE
37610	payment	2134	2134	1874	1	1	4891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SpgLRM8tA1sE39FUDYd9WnjePEBCH1KLxDLUdkwfLusHdsBW
37611	payment	2133	2133	1874	1	1	4575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgewsD4XqrcnKNeNbK99rEK1jvJQAwLRCwRm9mf5DPQcto1Use
37692	payment	1397	1397	1678	1	1	14470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENbuDaLrNhTpDUZJZh8CJaRamu1wBDoAxxLTp6Adi8g1AaNMn
37693	payment	2134	2134	1874	1	1	4914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXb9ZbUoMvrwJkwbBbpRkUpekzEiav6wLK1FgXRAoHXdN5otVS
37694	payment	2133	2133	1874	1	1	4599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHanGsig3iWkjzMuipGvQEsj5T4CX2Jd76uyfc5xnrzk1PQJYy
37695	payment	558	558	2312	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ2BFeJ7DCpKEWz54fEzw1AUieemKiHLkwUhV4crvepSh7UDHo
37696	payment	1419	1419	2310	1	1	7	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYufFypSHaRjxLmeDj68awMucCAYo93RmEyxMrsNT4rHzvgWWgL
37732	payment	1397	1397	1678	1	1	14481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM6DtkGX6HrifRpjMJCbCqVeAojMfKW3acAemMXLTkuobz6gma
37478	payment	2134	2134	1874	1	1	4841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx5b7bMH7eHY4LS2RZuiubdqMmxuZvrKpBajAk2RKvQyPFAzH
37479	payment	2134	2134	1874	1	1	4842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EkBsZ5yGjLPrexzR3SjyJHX4DozC7y4WHCoYvZWzpQe9yR4b
37480	payment	2134	2134	1874	1	1	4843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8ncrYZNXDEuLUNBHLSQx1cRvjxduRUgJ4sVK6TPDUoE4obN7
37488	payment	1397	1397	1678	1	1	14401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVrahEZjerVCti3GGXEWHp2BqosA7JDHZvKhsbp6S84yKJkx7
37489	payment	1397	1397	1678	1	1	14402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaMUf2VBZuuvkqsWomyFVPQNPAdcoZdkRTUUwQ6ALvsfnBUHJ
37490	payment	2134	2134	1874	1	1	4847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmFj8A7R7k6XzFKhtFg1PomN1mJULRnHiwbcoeomrhfvPi6Xo
37491	payment	2134	2134	1874	1	1	4848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3URRpginbLCDL9e8LG6BwAvuEmfbeZE8yLWFReumjPpNY4nak
37492	payment	2132	2132	1874	1	1	1313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbnkJkR7TwDmAnwE1iPTvYDTzXuNX95gEpa1pADacvTiRGzcG
37493	payment	1397	1397	1678	1	1	14403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNzTjpKk4yYtT4AruwPqPVvupRFGaEGJggbUnfRpR5XTmg8CH
37494	payment	2134	2134	1874	1	1	4849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEBUTQKs5jzRNPoFqrWY1aTVq76iQh5mLRdviqiKDZUiY8q7X
37495	payment	2132	2132	1495	1	1	1314	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCu88jP5S4YAgTXRx3jt4EsqMXCt5fNdRevke5BwnZm1RWaKH
37503	payment	1397	1397	1678	1	1	14407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKWyucxHuYgmEwFinQ7T5dhkEoXKbEddV6X9Wv1276SAxvGmb
37504	payment	2134	2134	1874	1	1	4853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYAqgAMpYPEDWAa8ucXjVk51PWvqQSstVkdNbLoHTJXxGn6gxb
37520	payment	1397	1397	1678	1	1	14414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecAAwwaeuEYjmFo7CQN7mU1FivcqkeABAaFdhSmr7r2uPuLFN
37521	payment	2134	2134	1874	1	1	4860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuX4qJrCriTy793kVkbLgcEtwJ4BnP73Hq7CQGxz6fMeaMRNf
37547	payment	2134	2134	1874	1	1	4871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUfVCVnHqxzaZhMVjxCQMCHWCAUGECKJ4SFU8sHMuYWywWr9a
37548	payment	1397	1397	1678	1	1	14426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCLLHRFtXhjDzmsrvXDB5zg9WTrtcmP6NCQhxCS8b7b3wEL2E
37549	payment	2134	2134	1874	1	1	4872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuPpDcDodp2x825tzBhbz7VqsH1RdKZBX7koFXqwHGcbaB8uM
37550	payment	2132	2132	1874	1	1	1321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcnWspz8pJQakYXMP5gK1qAfpr3nnEWj1TUmAMRCKkHVT96z24
37551	payment	1397	1397	1678	1	1	14427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZ2Xa6zyGGZos2ZzkXydjVyVYhZVjnh4rKmps8hq8RYVZBNJP
37552	payment	2134	2134	1874	1	1	4873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTg8ozzwe8x6Qinr2Yv2HfdjfPryeEuUvPrnqwu7TRnjnTa2Fn
37573	payment	1397	1397	1678	1	1	14435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVB3Gcf4fgTDFvaYfuPdAipT9wVaaSKTVN7dGEYDr9W3pQ8S1
37574	payment	2133	2133	1874	1	1	4564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhw8MQ4HMrQstLtMpKvAHt39TZPAbR1bjvr2xBLLimQuaCVohF
37575	payment	2134	2134	1874	1	1	4881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aye1nWwNzburGbRsLZSSuGkgxNV3U5f5VKD5bRXLzaL3GEYn
37602	payment	1397	1397	1678	1	1	14444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrenTQFXb8ozAnvTdSDohjUJmwbYcKNM4kZWM9tKwNxuNbez7V
37603	payment	2133	2133	1874	1	1	4573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtN1gviAdhNmFagDJU9Q8sakiW8roJjVHKTer2VbcR1rBeKpA1
37604	payment	2134	2134	1874	1	1	4889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDH4fsKcdwY1eLJM3bcpHVoNtWJqjZhFotXMCRSEza8qfjXNcX
37605	payment	1397	1397	1678	1	1	14445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeu9LZsQcVWtH6yF4LPgvFMfbcu311tbt9Y5T9dx1bcWKaWMBV
37606	payment	2134	2134	1874	1	1	4890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeVmZxrdvs1Eky3HXFRSP64Lbi1CTWyAtC53gSYDoKcwSmDXC
37607	payment	2133	2133	1874	1	1	4574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhW3B2jt8bKa7L4ahHBjt7TQQ1TWPzSjQhLjAoGzRnJWSZ4To
37628	payment	1397	1397	1678	1	1	14452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcAWpTgGgcAckgZucYdQBtiVJ6FGkvfEnLxhiGETyWJC85DMdq
37629	payment	2133	2133	1874	1	1	4581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfG7Ck7Bh6ZZb2HNRPQ7k94SjP2nf33FaTqXrCJJ8wYQvgJ68C
37630	payment	2132	2132	1874	1	1	1329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKcBpKTf5p3Y7rRk96Mtd5B9AMfnCGe6qMwT7aETRSzG6oLSN
37631	payment	2134	2134	1874	1	1	4897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Y878K9TaU5xRjQjW9HjW9VqjZHGK5zYJ61hpPrx3fW2NDGL6
37632	payment	1397	1397	1678	1	1	14453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqowV1aUqu9NMwmYApVps2QVniGDNbUaYwEMHkHYfEXq6ptNu5
37633	payment	2133	2133	1874	1	1	4582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczCKxFp1Vzrs6Dib1wotjMwm3obtKyxVhTYo8qFPk5pvuoVGK
37640	payment	1397	1397	1678	1	1	14456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoKniEXV62anVdLMySNdB9AUvrc1SvnKrdbn6NZQBSzo66hfM
37641	payment	2132	2132	1874	1	1	1330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVGDuZ2NiKQaewGCaUYA4SudPpXsPGJ6cz1X54Td4uyKF8dGrR
37496	payment	1397	1397	1678	1	1	14404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3umYPFppMLydXXvB1TJKsLB8fNZPFfKRhM1wvTbEpXJf6kjo
37497	payment	1397	1397	1678	1	1	14405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpcCmBwGd5JR3Fudy4bUUHikM7YkQjcKmGYT4J6dwms9eX8xT
37498	payment	2134	2134	1874	1	1	4850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzQEMUKFJeFRFonWsXrtuyw6kg1skTPQ6xvT9tzT6VUVKvcN9
37499	payment	2134	2134	1874	1	1	4851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JAmoq6xFgBtG3JsS13zjMDr211Naz3zKKvZTBkfip8ng1d8f
37514	payment	1397	1397	1678	1	1	14412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvenKWXy2HiLzKeEWEZQpPBwvwBHFJUvuLeRtsqGXVML2ayYHF
37515	payment	1397	1397	1678	1	1	14413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6YYFUYzsMerAaKhyjP3CMte1ExbfXvDuwE5bzgh9EaiT74Px
37516	payment	2134	2134	1874	1	1	4858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLNf6ycjK1ijbB7ASahtbg4d4VxQeYQnVoD5hFSrMJnt91MwK
37517	payment	2132	2132	1874	1	1	1317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNmbomTfKjAgV6rTWQPBYmGTLgygZZbLpKh77giRhkBqeHKQH
37518	delegation	1925	1925	1401	1	1	7	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsK9Uc5TDkMgHnkTwd2CQD5jKnzdoLGTKi9cBTiGPCVH1odZu5
37519	payment	2134	2134	1874	1	1	4859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3JwPAhCeZBPCHTSX8oxvZyMS3wPktT833Q4me8vhFYwwy1Vh
37537	payment	1397	1397	1678	1	1	14421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbe3eWYXYRh8BScdbWLX7N48TVg6tUmpAHSaVbhbSBP9sarva
37538	payment	2134	2134	1874	1	1	4867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94YV7c8gipxMR555GUQaYZXzkGyaJTkyYcPb7fRZB3nwdfzaD
37539	payment	1397	1397	1678	1	1	14422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUG5TZyBTPRpuiqovLN2sXFPXsCd3t5vtYmKiwjUReZhiB9cgj
37540	payment	1397	1397	1678	1	1	14423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLR2DoF7oxj9AotbhHX972yu6NZUHWvqefkMKB9CuCmeQtJoJj
37541	payment	1397	1397	1678	1	1	14424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JCWyNywT8Vp8TFWspsbBBvLi2UTRU5xLDUhnRPka5J4Vj3Ka
37542	payment	2132	2132	1874	1	1	1320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzRvVGfE36d2RgV6TPwupqzyg8hc6HYNzBnNRBpx9t6BbBPd3d
37543	payment	2134	2134	1874	1	1	4868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24YC89jwoWxCZzy1CK5iai71wTh9Gwu2KpssnysBeFHUsyYmp
37544	payment	2134	2134	1874	1	1	4869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHoLvUZ5RGbhgksWAuC8EYC8yD83WQqofabqrEn9ahihtW9H9
37545	payment	2134	2134	1874	1	1	4870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCsx1iAt8ivYv5RTCtr2FeVfeq8wpKP1kZB1K1hMb6d1Gk93G
37553	payment	1397	1397	1678	1	1	14428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgnpV8WYrSXQeus4MKEdUXZEDtiWxvQWHjTPcKyUKuX7P3q1RN
37554	payment	2134	2134	1874	1	1	4874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaCuYAuRrCZcn2KQT4tZsgrkVpmtmoQCpwXk99RV7Vkxxrzr5
37563	payment	1397	1397	1678	1	1	14432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYei6YRfKHTMohxfLEwna59ebCXWLLJXthtJk5vvqSFscokmbYZ
37564	payment	2133	2133	1874	1	1	4561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXsQt5jkehR1KhtYUe7om7ZfjhyTBYuDJU1z7ovRmw46thmhJ
37565	payment	2134	2134	1874	1	1	4878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmapp9puj1HmAcRDEfLPhjzKCkTxM66iMVBdNz7wYvhjwEm3pQ
37566	payment	2132	2132	1874	1	1	1323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhHgHCrhgAHZofHKL7oSjEvFEMohcBu2CZBda7P3pZHykPYdN
37576	payment	1397	1397	1678	1	1	14436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoqpB7yvRi6qfmfXpQD7ChCcH6foQDMkAUpwkZGY5dUYFLs5s
37577	payment	2132	2132	1874	1	1	1324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhuMPxCvtbE5cRZakgDckmXT7h7YbdeydCbUxHhsdUYcEphrd
37578	payment	2133	2133	1874	1	1	4565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnCx8TyV9KQv1Trq2dgseLca4XV6qfYWah4mP8rMpiUUjz56z
37579	payment	2134	2134	1874	1	1	4882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHQZkzwQSeRbxdBHrGxpAn2Nzjz6BhtRuYWUsyzq1XZYAjRHH
37589	payment	1397	1397	1678	1	1	14440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wJQSJGjSyEpSch4zHPYGGiiWn2U33hGa4vFBn1Kj5q93rVhH
37590	payment	2133	2133	1874	1	1	4569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5nQwHNnNGn6i1N7HHcqK979RKRu5VL6w8NR3XNLAmhuQGDYi
37591	payment	2134	2134	1874	1	1	4885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ372dBjTdCVfkghAV8EUQh2syaXEuq6AkDTAt6C3AmhGR133TH
37599	payment	1397	1397	1678	1	1	14443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKA5WfJynftwmHjebyAa6gxxqB3eA1SnAJP9h3HNt6e2JAaPc
37600	payment	2133	2133	1874	1	1	4572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYno6GeKR44KPxPu8vfGYwBaZXAS2FX9zrYdPsx4G1ieaaNR84p
37601	payment	2134	2134	1874	1	1	4888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxDk7387jzA4oV4tvB7xTBgkhRMzkfNSJb1cY7tbapRdXkENMc
37612	payment	1397	1397	1678	1	1	14447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsBJ6dBXqgm3pamzwSzuHf9jcyHuWUVvquXLqrrX5mjLJnbET
37613	payment	2134	2134	1874	1	1	4892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2sZhz2WMFKzJgmTE765auHvkVZRLT7dotVckduRWW2MHi4Lu
37614	payment	2133	2133	1874	1	1	4576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnKC6i4qvM42nB8nYKLTcjX4pAcBq7Mm3fmzrdnRk7A7ii4gg
37508	payment	2134	2134	1874	1	1	4854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7fhLrXvt8Q3qjtqaf2NEWCSYUVgm9Gj951qfHQP7VTs2hWCP
37509	payment	2134	2134	1874	1	1	4855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhESrzMubekQZZfMuYRB3usjbxuHU3NJJpYiyhMpmHPePRDQJB
37510	payment	2134	2134	1874	1	1	4856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuKUTax46TUd4GnGFV46Y7Zkq2ZEK4db48z47nqyHjVieWwcS
37511	payment	2132	2132	1874	1	1	1316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD3bnZW2GSgesER7p4CRJdXtq3WA9pm3mVDghnP3hrVfJiF2b
37512	payment	1397	1397	1678	1	1	14411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYh9VFRQksjU37uxbMk5JeWWHVgqRTNqyiDHab8Ttn2oTiCf2F
37513	payment	2134	2134	1874	1	1	4857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcWFWV6t15qAuQWHhLfUzLKo1grxJphCJDCyMHASgWykCdtsY
37527	payment	1397	1397	1678	1	1	14417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8D5msCSoKhYc5uUmiu8gFBD8x7SmGs7t45ejEd2SQ2NsJbypp
37528	payment	1397	1397	1678	1	1	14418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVN8jevnmfwcJdAFYZuBN7Tig59FP3b974wR7GyZZTRgGhVDcM
37529	payment	1397	1397	1678	1	1	14419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXdZ4QcNw8ALsurfUhDtt4RmCgTDJ4JTyz5PQAN3mMMgqimBG
37530	delegation	1924	1924	1460	1	1	6	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDTco1fvsLEPwryYgCvXhdTAuNfF77FfSVLKQ1jMyUXgQ9Xdq
37531	payment	2134	2134	1874	1	1	4863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWhfGNLPhNMsCNdkZLAibSipK7VjENtEqaNEesmDV5aErd8m3
37532	payment	2134	2134	1874	1	1	4864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtipYaM3KMqdtdxAzn6DXJENSRjtYqzTzrnmqnARSnBfamop4Q
37533	payment	2134	2134	1874	1	1	4865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSaDwXmbjPyzq73D9JTHZRw2g1NMQYnCoVJ48uvGx7Qr4MsTrx
37534	payment	2132	2132	1874	1	1	1319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6sRNXAQ1A2oszdbtWhYV4uq7n4aN8KgMn1bU8oy8ipc29qwRQ
37558	payment	1397	1397	1678	1	1	14430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDfzup1Zy7H2WrujWdBDswW323K6cZZ4rbyQi2ZWkTmkGotjY
37559	payment	2134	2134	1874	1	1	4876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCUDaWxzbhho5xqsoHHnPdtvDFpfLQ5YkAYGymLYa71PkpMF6
37560	payment	1397	1397	1678	1	1	14431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiHEmMySNz3TiGpusw7LKyWmSaPkxXgLJnHjzJdgCF48orQWA
37561	payment	2134	2134	1874	1	1	4877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYosunnyeRrk1L6rbQpZTUJhT1tDMaby9nSTumR1W7Xt14G9Cej
37562	payment	2133	2133	1874	1	1	4560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKKsWQeKqh5ATCH5r3hE7aiAAznLPo7wXZsKQmnxHGDMGFQgH
37567	payment	1397	1397	1678	1	1	14433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vY64pQExahCDY2vWwbQ3TnxP3eBeogmpoic19ZS85SZsDf9L
37568	payment	1397	1397	1678	1	1	14434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtowxJC6xVS4nSGaqhoRznGK5qY2GxWjpvATp84M8czugcYGc9
37569	payment	2133	2133	1874	1	1	4562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAx6pAxrcKDu4jpNeci4d4yb8bbEDr2DQxJqaVfi8doJVSMqW2
37570	payment	2133	2133	1874	1	1	4563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5Jhp36edDLm7J2jauVyKEx6bqaKh7gV6RouBtpzuaZSdaTCV
37571	payment	2134	2134	1874	1	1	4879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCnpzcyCiZmaZw8gPG4WMcfqS9h2LFcFAesgoC8fX7MKPN8dN
37572	payment	2134	2134	1874	1	1	4880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhVAdcNDuB5EXmd7yioavmMuPAPE1mGQvqyK16jNY9rhG9DKzn
37583	payment	1397	1397	1678	1	1	14438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUnGJQQjw9oq7iYRzZhkyYqzxT3j83FRxwHCMQj3h3dJyUdi8
37584	payment	1397	1397	1678	1	1	14439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGXNuMa8LxMd3USdWhEJMPQ7C1t7kFFkEDuxbXnLLDCoSduqo
37585	payment	2132	2132	1874	1	1	1325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhusnsGroYB5SfjmQViFMyHPGvoG4b8Xoqxa8VbnXUyBjEhozA
37586	payment	2133	2133	1874	1	1	4567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ko5eeoHZdTVp9nL3xJPNYE45ibQfwdZg3CB98ggh9JzYWuKh
37587	payment	2133	2133	1874	1	1	4568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyZWur51nW7F93d7WCq1jSsiC55aBt7Vo44WHKCsQf99Z58E8
37588	payment	2134	2134	1874	1	1	4884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBXpFQ8wFBgvoRmGG6Q8FCCppw8ND4m5nVBmHfJ291vohbMuwr
37592	payment	1397	1397	1678	1	1	14441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZraQRZi1jTvsEb1kATo8N3Fc9yfvBrzTehSL9Ne6PoAwKM4AX
37593	payment	1397	1397	1678	1	1	14442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyBjvQbCMmhmZCu7YfRp6m6YeHouuXo5PwQTBMotj2roT8JCg
37594	payment	2133	2133	1874	1	1	4570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcc1fbba6iE6RWCP9MVRPVBtNdrNVe7mE498AaCT49ETD7QF8o
37595	payment	2132	2132	1874	1	1	1326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQ4dDsabRtLsPrGpJjUUfTRpS8dkH7uK5AKY7tYAzEBRWmPgV
37596	payment	2133	2133	1874	1	1	4571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xVp2rPYXhkAdrS1ehpSTo9YFd2fe3arGuk1G7bjZ7BpPHvXZ
37597	payment	2134	2134	1874	1	1	4886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXmqw28zxUk9EMCXUguLNuwV1YmyY9bdsp5jETSNQ4qEzVatY
37598	payment	2134	2134	1874	1	1	4887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57t5N5sWxDhqf2kb6RjSTnL7e9SCzjFtomJEQ1TBVhHE3P9sf
37615	payment	1397	1397	1678	1	1	14448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBdDKcYmhkPD1ggHP4aqVBsMZZMxE6pB7R51pxGWQJxt4a9Dq
37616	payment	2134	2134	1874	1	1	4893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jkEj4VyPrHiRaSTTFodif7uV22gkiJdWGLVQkzzAH9R2Qg7B
37617	payment	2133	2133	1874	1	1	4577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZCD5jkZq4MrWY7XYXfzwBHHsLxq9XPpY1YiHmB4ADEsJnCg1
37618	payment	1397	1397	1678	1	1	14449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdH1rYBm6otUrs1z2dVQCTxTizYCpK4fS9zZrTnWkLBq95Tvmi
37619	payment	2132	2132	1874	1	1	1328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRf5zXXvfjFzVWZjZXR4VXTswmoRCcUJJsXvspsASGE8fvcSSp
37620	payment	2134	2134	1874	1	1	4894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Q4mvRnvdkyawBzn7ap6dbhKBVCKn8B5rcbhsy4zCdFc1NeQK
37621	payment	2133	2133	1874	1	1	4578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zdMmfuTk4Qgi2ikYtfcwGHmcsL9kA14GuBe13j2mG6VjqGXk
37647	payment	1397	1397	1678	1	1	14458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCNupTWSssvcHowQAHbCPssHXGHAsdhKKYFsLWwAnvYmuy528
37648	payment	1397	1397	1678	1	1	14459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8nri2SACiDkhyLfC56uwzvJ5hRCSCzMGbyLTN5KwzC2a5E1mP
37649	payment	1397	1397	1678	1	1	14460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyrz5Ui3uPihewBpGCtb7qgDX7jUjS8imXYTZM65ogBQogFCb
37650	payment	1397	1397	1678	1	1	14461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWMxjqsFhKCr4EU5YMjAP7jUWDrmZ3JoBRxNXGfPBrAJRpSUzt
37651	payment	2134	2134	1874	1	1	4902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ353Htz5nFXnLeN6UYdT4T9ggDnoTV4u9dqZw3spcv3wkzM2p5
37652	payment	2134	2134	1874	1	1	4903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThGcz8xGn2H6XNyDwmK3Zn3m2vbXoEYJ3R9hRf6wiQNiseV36
37653	payment	2133	2133	1874	1	1	4587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNicopNVLNFg4fqD7Uvde3j1P8fXpag45nSS9KzwZsE74dgu9
37654	payment	2132	2132	1874	1	1	1331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMshLbu2EF31tyy8JBkKfMahBk4CPRUYm2Ufv2ZHSCgXtMFWsT
37655	payment	2134	2134	1874	1	1	4904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JRiNZYxK3EA3H7r7LJYDWipKR8UWHBDLVFAi4qg1sF4JaZCd
37656	payment	2134	2134	1874	1	1	4905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPC8cAekj1kLpvejKNZuRVdguWDvednHyhbugzmRWhWsptgrbX
37657	payment	2133	2133	1874	1	1	4588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzdr8PxbZZCcqxELsf7m9zGcoDS2cvUFrtkKEVWn7MeBcQaY6
37658	payment	2133	2133	1874	1	1	4589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwpzmMbXeC5ymXZ3Xug3f2Eqmk55sQctsuGj8AiKPYuTPgaG6
37659	payment	2133	2133	1874	1	1	4590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVoiNNPfVmLbZYfq7cLLwvJMNa8jU6RnfxYpWNq3WPver4pRD
37717	payment	1397	1397	1678	1	1	14477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJAmB6tKzrG7UDYvVPD1ZdmvAYo2pAGUErsPrpYTgj6xAH4NR
37718	delegation	2310	2310	1419	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEn8GX1d97dnFC2V9ARXUr9B3oWcfwooMSVrquTr5Ukq8s41eN
37719	payment	2134	2134	1874	1	1	4921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfo8i6oU2JgGunF72meEe9bAHdzj7axMNNJeRPKaQmzziiERCW
37720	payment	2133	2133	1874	1	1	4606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZtPP9hgLNBnwnLjXz4ALxEDfTzX1U1XFZ6DcEThoGPkawpkj
37729	payment	1397	1397	1678	1	1	14480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGpmXgxpuWo5EWoGHaMVi1Scu7QhgmXDmNf5W4UZwRKZ5gwDA
37730	payment	2133	2133	1874	1	1	4609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RKshQEmqEfPTnmgd8nMDyC7br3mxBRgbWZQdVdNoekRpV6fS
37731	payment	2134	2134	1874	1	1	4924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGeJgF2Qie4iA189Wxx2tN1DSNPysquV4UjZkwbW97jsbDM4o
37758	payment	1397	1397	1678	1	1	14489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNsEjecjfSF295LBQ66u1yBArWzhwEHNQb1FocDuFis1ATBGVX
37759	payment	2133	2133	1874	1	1	4618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgy8PbfMKwXcpMcaaKsyYCgDn9ad3bhYt5MKmRPaYadzYQuGj6
37760	payment	2134	2134	1874	1	1	4933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpgvZqWQSxHHY6uS5NX6WMsuaaCmuADiLGvnnbyuCyi7X2DFn
37761	payment	2132	2132	1874	1	1	1340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2sjSaqdSBhawywqUg4F97tjnKeV4DP66kFHki7zKWMWDPtGvk
37765	payment	1397	1397	1678	1	1	14491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaw2q9FuJd4TVzd8EhVg8V2Z8ydaRuGUQmdUBAJawxNipzTMXk
37766	payment	1397	1397	1678	1	1	14492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6zL56MLVeNSAR4ebKmNcDmDz8vkFDs3fo12itFa9AMocFSJM
37767	payment	2134	2134	1874	1	1	4935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6uTjYnBrrUZrFA35dEWpHitq21pqKKszVKyfWTd8vT7QZzra
37768	payment	2134	2134	1874	1	1	4936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjq3hZ5ZgtmacosXfyk5BpS68pJFVGXx6YmdfF6Cww46RDyPE
37769	payment	2133	2133	1874	1	1	4620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CTjDcymG3AAbigJtxd62QdHPBMv5HcXTpeiwJ4fFNcbVSdNs
37770	payment	2132	2132	1874	1	1	1341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB76Huxho423cX9iwvN2rJzc6YNcfshXQYzqMtSLML7N3BxbjE
37771	payment	2133	2133	1874	1	1	4621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRQPndr5ZHGDmkj3hvPBEv4mnzvrJ4Wrga6ZUkN2ZEpSC3NJb
37622	payment	1397	1397	1678	1	1	14450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8efX2D2VXBQLEtgJXYKQm5fUfDfY6fTjjLho3uiEA39X29pX
37623	payment	2134	2134	1874	1	1	4895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoaNn2QeWXzePDbxSvxjjPxK6a9uqnRjQxbuGqo9H5BpYnfKs
37624	payment	2133	2133	1874	1	1	4579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2rHvzbjdCqm72rLu1ywMjiAnZrJYADNPDDSqjYf4jurDmiNL
37625	payment	1397	1397	1678	1	1	14451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaiD31x2ZWdTiiMp26PMtismiD6efEtC2uPkZsaxSTN7KvFfJg
37626	payment	2134	2134	1874	1	1	4896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQB6XcNeV6ahmNoREH44xjiyRGfa47eBoFG5hXKAUZ7T9a7qTb
37627	payment	2133	2133	1874	1	1	4580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx51P9e7vBbp4fq9EBqw76BiTPdLDQYmg3v2GFoh59Uqpq6KTi
37634	payment	1397	1397	1678	1	1	14454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmP773hpofQ4bojTPbuvgQucV8FE8aUmiRNTPSEEYMJGvGZy8
37635	payment	2134	2134	1874	1	1	4898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpsLWD8111ffPSKL9Q2wdhfwPCME1PUYaxmyZTfCZaTNPRUsd
37636	payment	2133	2133	1874	1	1	4583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KD3My1HGVtA9FJkWk7XExeGGU44UEQ7SBRJvPJWnQRJyLnWg
37637	payment	1397	1397	1678	1	1	14455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZob2RwpNJwjYnKAa6k1gMbMcVPpbZzYnHjCqzYuJa1VVXoeLHc
37638	payment	2134	2134	1874	1	1	4899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKD1wxfd1D2gPVEn322LrYSPGRo1fVcRAojwrg1u7M2pJKg4u
37639	payment	2133	2133	1874	1	1	4584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiEpUgYpsX6dmG5fgRMLEn63vGuKs8reozQ85B9NV7Z7c79n7
37660	payment	1397	1397	1678	1	1	14462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwyoabyYKeaRuxLxx7F9Y3cLSpCjEFpKgVaZjTuyKj9jX6La74
37661	payment	1397	1397	1678	1	1	14463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDyLfU9krwyBcr4xLyvy5DwFWFPvcBNoTkat3YCZsf73j5JSxx
37662	payment	2133	2133	1874	1	1	4591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEVsbCTqLZWzwfT8enE3mL9GwXenMUG3ZmFEFEVbpW7irm3aa
37663	payment	2133	2133	1874	1	1	4592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NmD5KPmtX962o3yJmpFdj9bmsbZGGCiiTnwrgogFSCqwrkQJ
37664	payment	2132	2132	1874	1	1	1332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T75vJu3tsVZKzxBZjmkbxMsAymoErrghNac5NNshGqXkZDZN
37665	payment	2134	2134	1874	1	1	4906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGo8Y9z2tZad5CpV4v58PhVo4nwMqJw2bJLZbw5QSb82Gzyk3Q
37666	payment	2134	2134	1874	1	1	4907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTs54YN8fEj8FZyVjdcnkYBogfPbCegfXpKy5NkM5CY3zBMv7z
37697	payment	1397	1397	1678	1	1	14471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZYbESSgNCcpGNHs84FB2KtdBVei5g1TViMQNrkk49qtLQzfq
37698	payment	1397	1397	1678	1	1	14472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8AA2q6TqJsYg2Q3H37SC4o6EMajQGPNJfwn1xrcfY6obyFWS
37699	payment	1397	1397	1678	1	1	14473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATC5vemYgcY5WrHrQPpv777P3oHu23rFLwcwCctkf4VdV7CHV
37700	payment	1397	1397	1678	1	1	14474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMm2NxnKzjLwPdTZVDgRdJWdCbKVYhPgYsNdbeJ3Fogt8TgUs
37701	payment	2133	2133	1874	1	1	4600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVixGtHrCzv66hQSifSd5ejAarNq5qwYCNgtsenw7VxRQ4KfK
37702	payment	2133	2133	1874	1	1	4601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZczaEYoXCfBWS8coSxxMCmeEBaNVw3Vi7QJgL1vH84Axg8XJK
37703	payment	2134	2134	1874	1	1	4915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwoC8mLpqwKbP2rcw2rDpFqTBmWFQokvXmd5nmigDZhVkdXuV
37704	payment	2134	2134	1874	1	1	4916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKdnEY2vZRoYkqGGs9vA3XLcGWs9GbBg31st9FVDEjgZp2TCu
37705	payment	2134	2134	1874	1	1	4917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdapZHTV13Dub1r9EJaxreyM5yEKsVUWuJ5oHJmQLjjw3NQoVH
37706	payment	2133	2133	1874	1	1	4602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocq4LF5cNP7YDiv4wnzhoZeSN9yaaYFeoGnN3i3TskazR8vsH
37707	payment	2133	2133	1874	1	1	4603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYems8HWbG9gTUMJu7rTqbrwsoBKtA4nQ2AmZNrUP9vH6uParnj
37708	payment	2132	2132	1874	1	1	1335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymvAbtdFWfWr49g8bzvJ4HbaAjGKvANppsPX4LjDj86fB6TKG
37709	payment	2134	2134	1874	1	1	4918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtDMCYGkwLBoH9EuH4EyM5r2YBaGz69RN8FViNUhrShmjjc3t
37710	payment	1397	1397	1678	1	1	14475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrzHe26BNusZ1Z9j2D7mYexgqr4K5o5Ej3BM5XA7yWrYd84Vu
37711	payment	2133	2133	1874	1	1	4604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3k8eeuq8kN8uPkTz5uGSnjWsEymBBPg7TK8NzJw4iaEwJFGU
37712	payment	2134	2134	1874	1	1	4919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8jzeDfHpQs21RDXrPbmVmMs2E2nBy4qdxngwUG2M4DiXgFEAT
37721	payment	558	558	2312	1	1	4	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUf3SxXTzoHLTi8xYdTEuuwYT8eWPvoafFvZ3g3vPMwEvcTvGv
37722	payment	1397	1397	1678	1	1	14478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYvB5XJ8hKDLJGv3jyvQ5yZGo2KbLKTmoPNngcvzg6CXRM87y
37723	payment	2133	2133	1874	1	1	4607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcQRiBXvQu7erv2Er3K3FvYfW8nUtB1Kphj1TfcZLS1kkAr9M
37642	payment	2134	2134	1874	1	1	4900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuFWA7S1aLz5HYC3JoeAe7p3FLGnb2wESqMYKLJ3ksZ1hhDfk
37643	payment	2133	2133	1874	1	1	4585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK3grKwEbvkU8BJNj6XEEHb9TzUd6HxYFYdwTwvYmufw32rWgZ
37644	payment	1397	1397	1678	1	1	14457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSLyH3wtb2FLN7SZovY2zMWMpNB2n6TiAN5XEJDsoavr3VjhWe
37645	payment	2134	2134	1874	1	1	4901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFye1ysZovPRhhnAz9wVVktUkKwzcaajrtE7TAWWJycQMhYZW
37646	payment	2133	2133	1874	1	1	4586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDDqg3YtQB9b9Pj2wN5jWZqLJAz6TRkJvjxV541A6G41zhW2Z
37667	payment	1397	1397	1678	1	1	14464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKiAUN8nbSrpbL5hcEikAKbW5nDQC9gtXCGN6SeKG2THSpmx9
37668	payment	1622	1622	169	1	1	5	407542749587	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZtkkBsjTQ6QGueffxGMF2RczSaLUxSHjA1do7oJg6Yy6rCwT9U
37669	payment	1622	1622	990	1	1	6	3100139565232	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpYogXYyvR9uG1MQKgm8haSkGjJA4mAdFdGHCssdvvRzV1qeE4be
37670	payment	1622	1622	1110	1	1	7	5555423538912	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpYcjr2J1Y9kCNgfD5kdSzB9eevdr8hKJ2NoX71z3hzRFr52WB8M
37671	payment	1622	1622	1230	1	1	8	3748354961338	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZBWu1aw5Hw8FgfefLvn64Z7X6g7otidfnqUn5eZzZ69kpfZ62b
37672	payment	1622	1622	1356	1	1	9	10445124384888	10000000	\N	E4YxspFAsKZgNbpkNF4m8n4nqb5XvnWid3UKSf6NRWhojSk8eFveh	CkpZWBjpTW2RYpazJKoFrGXoTgukLFrAG9PwtQ59aVSmzBRME1JPb
37673	payment	2134	2134	1874	1	1	4908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezHz6jSAaK3y6cFErNsszuoVSxNmVQEHkP78tNsCNWi18mx4u
37674	payment	2133	2133	1874	1	1	4593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqkBbzNvfYY5CkPzDSr7mKA5uaKGNXN57XmxC6UXdap4NSFmz
37675	payment	1397	1397	1678	1	1	14465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkFC81CHuWDW2zb6B3WrHMh5ZCv4drnDV4sRRe7AUK3ygt9nU
37676	payment	1397	1397	1678	1	1	14466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMTohJBxaVe8yJVEpes4Y2Kr767NkqPRrHsA5jx5eAUuev9yN
37677	payment	1397	1397	1678	1	1	14467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzqTRcS822Exdm3GqdhaiQc94f1hfUdsdMW8YjY3xXjAtMMyB
37678	payment	1397	1397	1678	1	1	14468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWevDcsCaagywyGSwhYTrZzu2gQvcXLjf9npGKKfamuTRRywj
37679	payment	2132	2132	1874	1	1	1333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjVAMtiUoESJjA9NvjStUdLyVycYXLT3j1zyopcXcZbTR85VFD
37680	payment	2134	2134	1874	1	1	4909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnha53fXrn4Ymyyus5skTPkAVRx1u66RgU5NBzAqVu9fzScLY
37681	payment	2133	2133	1874	1	1	4594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8BzzsYZVgHm85Dkp7MSRXcmSwF46FhXGRnN9p84DfFvCgFFp
37682	payment	2133	2133	1874	1	1	4595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXNKEu4zNq5hBjysBY8SBkuqo4GUHuzep3TNjWJHpNy3jdWFw9
37683	payment	2133	2133	1874	1	1	4596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1ixcTMRf82kREHLJ8t2BZc2BkTaHNCP6vi5Jwz9Dw4nTzDz1
37684	payment	2134	2134	1874	1	1	4910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAFeEmQ7rvbjZqUbhRoir9bfDzAqgg7c1762DUdyXYZEsKsDn
37685	payment	2134	2134	1874	1	1	4911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiweVJYZ3r23QcDcDz1FHbSSzDb6ucsg9FijcEZB9N2Zq9LXR
37686	payment	2134	2134	1874	1	1	4912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTknFcTy3L4w3hurVd8iCGiWep3Fj1w82Eh4cBjKNJjpS3dRx6
37687	payment	2133	2133	1874	1	1	4597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAcnWqJgAxhMEJQayJaNqNhPZB9QpMVarfFk9fXUD5DPrKuwi
37688	payment	1397	1397	1678	1	1	14469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAksSZvJ8JmCzWZJb4jPo7Yve5GpRj7H2jhzGez33PtYFnyxuq
37689	payment	2133	2133	1874	1	1	4598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5YYo3iCHR2vFp54msPSmyfUr1FVD65qEFCSj6sEAVBp8XUV3
37690	payment	2134	2134	1874	1	1	4913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZad68AaFpCwS6tASXVTU6tjRjDis3zFf4VKxjmJQ8c5iJpfL5W
37691	payment	2132	2132	1874	1	1	1334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHRyM7TUQZSv2vWvgzjw2epYWWkhF1ssFecV2Mj4Bd1N8QoLS
37713	payment	1397	1397	1678	1	1	14476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8KTS91xqzVGzpUNyabKyNcjyZ4EwLGcNCny83LDn9z83KSW3Z
37714	payment	2133	2133	1874	1	1	4605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCu5rPk1Cm6EBNt9E7zfs1cTi5LHDVVwAzTTWnqtFFJwD5pp3Y
37715	payment	2132	2132	1874	1	1	1336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTqWtoU91utANi1QMQYq9cubk1r1Mk2oH9YLKhdraXYchCH3E
37716	payment	2134	2134	1874	1	1	4920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJn7WscqUYGpd1uFBwafkBLfsjGeiFDJtWxp43A95GxDKkAsE
37787	payment	1397	1397	1678	1	1	14498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJ1nnHFDKDi9427UuUJ2mLA8YyfX6Y2oPKXXEBkTUQApnEAtY
37788	payment	1397	1397	1678	1	1	14499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33gktkAAF6fP4XxQHzRFnKw5bHMRLbEvFJs5uWFJJYiiwXuav
37789	payment	2132	2132	1874	1	1	1343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzKEzVA3kbuk7xPEm8pkoMdqRNg8jqULKXt2SAGXmeJyDu4kCG
37790	payment	2134	2134	1874	1	1	4941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYZSzD86kh89y7ou9xP2bQWepjPxecwjQoy15qSEkNFdM6iAa
37724	payment	2134	2134	1874	1	1	4922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkMtDEFLbrJMVdf3hxZu1exdqWoTzgGuFudeaLQHx1tiia1Y3
37725	payment	1397	1397	1678	1	1	14479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeL7GdwpkW4G5SA7B2UW3u94C7L3gqiPWYMoHoKcRxJZPawZW
37726	payment	2134	2134	1874	1	1	4923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqBiuvTHWyib1p2cL5H88rg6BpTq5EruxfGx151DkK67vbM4PL
37727	payment	2133	2133	1874	1	1	4608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw95DsWXJwP6TZy2qsVMApJkTu2Wg91ZwEJuXga55nd34rSxid
37728	payment	2132	2132	1874	1	1	1337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwT5hLrdbCYA3ePkhsEsfEL94d3aN9UZrsF12zxSHjCzuzFax
37739	payment	1397	1397	1678	1	1	14483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3ceRXnzhaLdULyEZSG2jj5q9ME5mXAC9cbfuzjCYBgjBd82R
37740	payment	2133	2133	1874	1	1	4612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnB7L5Rzd3jyFzTh9FPyKXQNrQ9uXxAMbasgBqsD8Lq7Kd3X57
37741	payment	2134	2134	1874	1	1	4927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQmPDhAJ1BsAgUNdbwkdxibwcZEh2tdTkF2uY22QteWghBCri
37752	payment	1397	1397	1678	1	1	14487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBF9xLDsxwuuefQLSmTaPyGznupRt4oeoUcHD9aiJCovdQbARp
37753	payment	1397	1397	1678	1	1	14488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPXemyLp2hJKVm7NZDNuwiQgDFF3c1LjnMJv9YdDfZFXbjf6H
37754	payment	2133	2133	1874	1	1	4616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQkx6xzTy8cBuHcbkiEVnNMbXfMjjDydkitGu3kdDoNHeaW65
37755	payment	2134	2134	1874	1	1	4931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwCwtQLckNF7KB5fxHWFe6j8L7tqpZm5cb2VFDNp1wtpXu3LW
37756	payment	2134	2134	1874	1	1	4932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK28ryji1VytNmUNoAHykhKnJJymn4WKEKqDK9M2oLawcjwDoX
37757	payment	2133	2133	1874	1	1	4617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23XgHXwTmVi14ZnQXCKwsMczVCkG3xKnZE95AKsD6DYswZ8Ab
37772	payment	1397	1397	1678	1	1	14493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCW6fTrCfHVcPquEj1emBdLGdfRVNt3eSDnvnkPXLca5Qvh2gY
37773	payment	2134	2134	1874	1	1	4937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdZQdBct31FeM36Kiq8sNQHEYFjE5yz6du3PYyZvRQ6gp1u5VT
37774	payment	2133	2133	1874	1	1	4622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKywdED6WtJDFS6FjLmYRazF2hZQ7ueHkP7SuBjcqzd8o6XqcU
37778	payment	1397	1397	1678	1	1	14495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKb1gWbdYTysgwuP6oxzginQgkxJ1oQ2QmbZrBUGuynJffrJq
37779	payment	1397	1397	1678	1	1	14496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywHuDPfQtwEeJmJV5PMTpFU8YwacSrQkpobmfswWsDYRtLZK3
37780	payment	1397	1397	1678	1	1	14497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Jp5tvjsXniWTtLeE3WoUbfxEKuK6qkcXDVbzKnZCcdMjzyAx
37781	payment	2134	2134	1874	1	1	4939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpErWWQjr2yAH2jb93QimNgKKqHcfKFu5nDiYNbAWDVXKnJ6P
37782	payment	2134	2134	1874	1	1	4940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE6aNC19A2ZkSkaPKDvr9LfVk4NvUZd9QFWAvf9YER6KSobKc
37783	payment	2133	2133	1874	1	1	4624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZskz3XaZ5z38so24kzr26V5oRfaFwBbJqjULpGiAJChjv1f4rh
37784	payment	2133	2133	1874	1	1	4625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEP2xvU7qpjod9nGRUKrdLd9H39NXMHYDqEPhkCKdkWrbrheAL
37785	payment	2132	2132	1874	1	1	1342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzs4sCxezMtwepfuJ4CeyXerNSWeDgXXhRGBpGzB5JpnHQDcY
37786	payment	2133	2133	1874	1	1	4626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKx3CddsdwgCvxt8mNJAf8jM7h7Y1BAXTUA3DEUR58GhjHK98N
37804	payment	1397	1397	1678	1	1	14503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfToNGpwZJq9zxr5EsCGQ5NhHuy8crqTLBQy7MPLCdeBZdHvd
37805	payment	1397	1397	1678	1	1	14504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyY2H8jVXNK3Z9zhih8eacrXaAdGEjU3TNb8G5jaxCdAw5XqC
37806	payment	2133	2133	1874	1	1	4632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEa4Z2T1eEJCx9a5TsapEqr75QeRSMVbo8Rs46GJT3jxhMzm4
37807	payment	2134	2134	1874	1	1	4946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVMPJv7mQEMhNKXVdnKeBgBbqKyiNNMQABs54LNG2K5hXBjakg
37808	payment	2134	2134	1874	1	1	4947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3UsR9pPFEk4CuBzmao8Tfeg8iGyLnzmQtWZFyNQJzmZMzjKMu
37809	payment	2133	2133	1874	1	1	4633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBizZxuLByPLjejB8Ld5A3zYXNUCqUws4rv6uJCSZBzNfEDKKM
37810	payment	1397	1397	1678	1	1	14505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGrtQEEoRSz4KyffUKkAVs47x74JTqUd1KRgfpQWj8oSz6eu7
37811	payment	1397	1397	1678	1	1	14506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQihyHrgFiS3kZ1jeoocaaXpkYRUw3CJPAQ8ApPXzvunNMaGDK
37812	payment	1397	1397	1678	1	1	14507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUn3aa7H3CZH6UePWgiu3R9EkDAEgBtNsXF32C2ENQkJE8VRx2
37813	payment	1397	1397	1678	1	1	14508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1c8dwPJgq4kBpJ2fcH6EhCW9TQz4Bss4ayJdkMeZFRzr1qzsW
37814	payment	2134	2134	1874	1	1	4948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbBbpCnMp2dBMFU381g6ByAvKvNKbVMSoMLBfDfxsNqo9iA7z
37815	payment	2134	2134	1874	1	1	4949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV9PDzvpv6bfKMX6k4vuraKsJHS3LAQNYGFJjq7wqRmZkx782R
37733	payment	2134	2134	1874	1	1	4925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZEMTWu1g6aRjusL7RNikEg4q9hpJJj5xQUwwj8KApfEL1VW6
37734	payment	2133	2133	1874	1	1	4610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFn7cA9yXRhCq1Beb8ypqHVM2dHP5diazBvcrzXQfGsBweqPNp
37735	payment	1397	1397	1678	1	1	14482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSXKJij4TNqGUVLNG87zFxJzx9rAiupvPf6BsuLFGUwJ7uygb
37736	payment	2134	2134	1874	1	1	4926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5MBjKyXaa41xxmu82saMWg4UQspCSKc6cdvCVbRppMTACwQm
37737	payment	2132	2132	1874	1	1	1338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzMC4jguCNYQUagk2bGihE7dt1gZj9yZHUjvLqD5uttLJiwY2
37738	payment	2133	2133	1874	1	1	4611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8tznMW3c1sffPCoBmDF3KwZY3YXfwarh86L9Et9dXtPSm8QV6
37742	payment	1397	1397	1678	1	1	14484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiH9kEpwmjDcG5gb5WE8n3PNyvUiSorqTo15oW9nSgUVbh1wcZ
37743	payment	1397	1397	1678	1	1	14485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfpigRvEFyUG16DT71jurmRGCFk5yEaLLQjoyQv1xu6h1eFK8
37744	payment	1397	1397	1678	1	1	14486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VFXd9sSu7cW5oCmwnXeTj8vymCRsenpsHack3Dc3Mjk59VZM
37745	payment	2132	2132	1874	1	1	1339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSdXYrqQsmEHYPaNPYpu4EwvNVjnMuobwikrYsPuLLYc5qYbXU
37746	payment	2134	2134	1874	1	1	4928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtePcdVwVEeiqBHa5jmW5QnZHLcLdVQab7imh2EkyKLaFxahj
37747	payment	2134	2134	1874	1	1	4929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW451kRUB7Jw2vEhDxR2QnYfPsmQyf7UgEommaMrtyYKD2qgDV
37748	payment	2133	2133	1874	1	1	4613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mFruDoYE5H1BGSULpdgU835VLMUT1DzSrkduCgFU2dXxpkm7
37749	payment	2133	2133	1874	1	1	4614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK534sbHYXL41EvyYDGkSToYsmL8agXH3AM8vNBfWMbWszABxD
37750	payment	2133	2133	1874	1	1	4615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgfHdXgJqgc7htU17sEWZAbgZ7dc4SDBSLPpgTSAYbHwNQMBt
37751	payment	2134	2134	1874	1	1	4930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcn15RsBXMjAvpnaMsFqKcBFc5jJxVcG2Am5PLKk2LNPmx7qXg
37762	payment	1397	1397	1678	1	1	14490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywVeNc4Sn9Cb36Vhq6MCiUfKx5kHvoswKvHEjzPUNFSr4dn4z
37763	payment	2133	2133	1874	1	1	4619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhfvyLXCGZSe9Y9eaHjSfjVmvV8Kca33DV6iAzG65GUsqTKZXn
37764	payment	2134	2134	1874	1	1	4934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsJWVwpTAqoinpyqoztt4xhUFsPjcFHCGYaBNLG6JpJTqTgrs
37794	payment	1397	1397	1678	1	1	14500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LrPSuid5zjr5cvcYtepiEvK8PynGU9hEw4vr8H7vTjRjMJFn
37795	payment	2134	2134	1874	1	1	4943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gvcPhaXu92W4q1CRkTSvUtftjHyBrB6AzYXenofirW7D5KtS
37796	payment	2133	2133	1874	1	1	4629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRyH9JzXuf7S59EstRdmuKxMqGGXPKmJLYvraPwR6hJSNwoKg
37841	payment	1397	1397	1678	1	1	14512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBi2std8DFX7H8MNSpnktMijVLXDB1ejvkrLsNU5WpSR2DqeY
37842	payment	2134	2134	1874	1	1	4958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcUL5TwNXR8gxAYdMBSFFT6N3BviScnVnT7eJoiK58DyP8dTwA
37843	payment	2133	2133	1874	1	1	4644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aGK57ppsqQaq5aoR6138HaiZzr3kyXvYZ4kpcr9CDTF7f5tm
37848	payment	1506	1506	1007	1	1	22	1732600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ25SmhWQ6ETDzXWZ4txm3xTogY2geTSiGDsD2yxd6qe4VSCJs
37849	payment	1397	1397	1678	1	1	14514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSH4reyAWm3nA4N2kjoRMw7VpMrDhzP74SWWy8wqa8STzuGy77
37850	payment	1397	1397	1678	1	1	14515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGzWypBsGGYnvDoufb1xcEX23MLxjJa4kjzacxVfBpzsY97NsV
37851	payment	1397	1397	1678	1	1	14516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NuEWNJYF9ZT2z3uNicxsYBDEjjLTXK1ZFcPVaKpH8ZDcUZHh
37852	payment	2134	2134	1874	1	1	4960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9FWHkqu5uFho6qsJuKsZwPaeN8uTshhS8RGgUhm1CVdSWMEA
37853	payment	2134	2134	1874	1	1	4961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7hFPash1a44zkm7FHWVmcDHZ9ZVwJH24vBDarq27HmWpvLmJL
37854	payment	2132	2132	1874	1	1	1349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq54e6prFRyByrmpcwEVewkh5RdcCkXK5rjTa4EvhcgiUWqdj
37855	payment	2133	2133	1874	1	1	4646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFcv7ZduLcvPPqaYymLnPfAsumQ155JEv1QGofH89mAegrMJY
37856	payment	2133	2133	1874	1	1	4647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj7QiLa4BKL52Eh6MUutWTe2q6dJxfh1V6cEbsZGryjYrDeYq
37857	payment	2133	2133	1874	1	1	4648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvsjgkirZYhpzKpsytEJSmy8XyWBN5Xo2RN6gwNYUWUTaDgFn
37858	payment	2134	2134	1874	1	1	4962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLD6KZjfjmt1GTZ13SZJAfXYmpWt2vfbsRMizHzFMhE3K7GQ5
37865	payment	1397	1397	1678	1	1	14519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBsiGqD9MH7CYnBGX7T4gYW1mfmQkd6b9pyzezYRB1aHNt8tJv
37866	payment	2134	2134	1874	1	1	4965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzimFvZjTGNze8zpnePcEaVv2ARDaQsBRCiP6kKb6baDE9pijJ
37775	payment	1397	1397	1678	1	1	14494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrpDdqJQvhJh7PuUgD4pXsv9v6HDxFhDPEZFucACRe5VUq1p7
37776	payment	2133	2133	1874	1	1	4623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nLVzce8yo1QHKnhdwRuwFrLivuDsKEQ5ws45DDxsefk7yohJ
37777	payment	2134	2134	1874	1	1	4938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbAB4TtD3yaANHXapBNHELUq8SzmtzkrYNcCG42pASrXShjWk
37827	payment	1397	1397	1678	1	1	14510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzA7YdcUwUhpKJi3ixTSF5v1HMMDiFbcsEBsywpRGcjiUdJJ5b
37828	payment	1397	1397	1678	1	1	14511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCcFNEcL36kKoQuowVWTbrirjPNwCAsBD18caZ2WR9jVVNRNk
37829	payment	2058	2058	2059	1	1	9	610000	2000000	65535	E4Ys2i2Sv3a28ooHGo6ybLhtGZSW1xwKayuDCkdacvJvNigvkAVkv	CkpZk9L8xxgS7HQg939PvZeA1NJBonhrE7QPhd4G56NoWUEhZBLTy
37830	payment	2133	2133	1874	1	1	4639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Bv5PZkVLzKUMxcQgk576b3dCXSLgErUFrg84AP9jyfQyFVN3
37831	payment	2133	2133	1874	1	1	4640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUNy6idDvx1qcuev5Y3Dptp63cLpQUAVdRTTnC5ZXaNzULz6Mr
37832	payment	2134	2134	1874	1	1	4953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtJgCfYLJxrREQ68uf4EdSKo8KeKXGpfkbcbvntA45cfhwRiY
37833	payment	2134	2134	1874	1	1	4954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGn27FAY1a64QsBdNMixLLAcoAqs82mpR48GxV4F53YDjAsquh
37834	payment	2134	2134	1874	1	1	4955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdg9rBAXX7LEf1fTt8et2qq93QbzoBCZNct9FJbUKnFgYyNib8
37835	payment	2134	2134	1874	1	1	4956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzA8xqkFb57G6zZCAq9eYhr1KsN5trVbCHRfszx7ZxupsCt9o
37836	payment	2134	2134	1874	1	1	4957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLSHoc7n5wAFTMuRfdkajCQXhbJQXMHB1kf9iq6qvp9fvoVHz
37837	payment	2132	2132	1874	1	1	1347	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzvhPdNsUQz17Jj7Riup1UpVifi3zc5tMWwohyAtrYBKAYK5A
37838	payment	2133	2133	1874	1	1	4641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm5gyEZxBxsuw2JsCJvSApudSkE1D982ZmwMBWWASn2aMzLQ3m
37839	payment	2133	2133	1874	1	1	4642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjU2zR4JFSQ6vbStK5GNY83AspTuk72Xqms9jAeqS2CbC3GbSc
37840	payment	2133	2133	1874	1	1	4643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoBYF3fnH7kwgTFXN1VeG6CpQmmqpRfCQsW7qEvddkHXBTuyn
37867	payment	1397	1397	1678	1	1	14520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkJQeiL3hn6B2TXHHKjK3XCMWkRpb6gthyrRghwSFJ7kFc1R6
37868	payment	2132	2132	1874	1	1	1350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgMvRJw3ZcpcdLU7Tx5n2Rb71U393hfJx9pgvJcNzJ6CdjzSw
37869	payment	2133	2133	1874	1	1	4651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVPDNFL59uLfw9V67rLEfvw8dby6stnwZLdNNfXns5F4mpBs6c
37876	payment	1397	1397	1678	1	1	14523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpbBjk8Q6HR2WvRU1AGGqj7BkwPUmDqgwg8abnAZiwnXjxo1D
37877	payment	1397	1397	1678	1	1	14524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEpbZZQh7oKXcNKdKvUyCq6R3W31Yd8w1w26wJUy6t1Ze2phe
37878	payment	2133	2133	1874	1	1	4654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJAhMTUgJmT6VbSKiPxPRe7LRgtY2oM916LPdBZEvKxrxvacg
37879	payment	2133	2133	1874	1	1	4655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjw1V8196MpUUoihpbz4hKPpHLun7haWd5y729q5LafNMfBgB7
37880	payment	2134	2134	1874	1	1	4968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCD64HsVTAJdGBTsf1EosNF1SbW5ngnBdN3VtJc9FFRd3ZiQP
37881	payment	2132	2132	1874	1	1	1351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgvkqguNLiAD2dbNjNQGH6JiKWQtdyRfzs1uVbTyGqzU3RxNR
37882	payment	2134	2134	1874	1	1	4969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4Tzb38boLq8ddbLz45mjDqtCkewAo2r5and5r3ou4Vj9BUkd
37886	payment	1397	1397	1678	1	1	14526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaenYUQbbf5sykjoW4pC7fmxtV4B2vd3BHADHGvMaWfSiiWEH
37887	payment	1397	1397	1678	1	1	14527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgkj1HFbPMFeT7ZvxytBxdznRoCoZWpW3iXL6d1wX1Q4EeJ318
37888	payment	2132	2132	1874	1	1	1352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSpcRtazZB2zUrjadCqQjiQjzSsBnRe9pnZXDdKLKAt6n4ubq
37889	payment	2134	2134	1874	1	1	4971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7d3pEEjVWJ6C7fdNBx2F2muN6NX7omXAuK6QU5aoAaUXXcDE
37890	payment	2133	2133	1874	1	1	4657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52o6SzMVqe6WR66icqEi13GEgVJFbfP55skhHKVNEDSKcs9nT
37891	payment	2134	2134	1874	1	1	4972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcaYhoVRjmGLhehKF9rVrgPZCLwTzfetfE89RFYTnU8sUqvZR
37892	payment	1397	1397	1678	1	1	14528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiSU9Vqyv4oiiPCWrKrFw54Egv74dUKNdm7gv6W4JVVEkLWhc
37893	payment	2134	2134	1874	1	1	4973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTsVjrdQvc3nt121SMD8T1gYd9FFU34xBBW3FQVh2WqfdZDRw
37899	payment	1397	1397	1678	1	1	14531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhwaaFz9Yvov4u47mud2vGQ6UD5PevWCkQ9tjQZfUACgf5GHS
37900	payment	2134	2134	1874	1	1	4976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabSpeWoq9iKnoPVCt379ibvA7NkgBvpG9tSase4TkJo7BEQ5S
37906	payment	1451	1451	1292	1	1	9	7986000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	Ckpa5Cd7JJCGWav5S26jJrPiqSA4o2pFyLM9t76NGPNJERqdy7SwR
37791	payment	2134	2134	1874	1	1	4942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkWZLxrqZG6od3RDu4AxA5ENriLg4kNqBEGjacWUwx7tPnQc4
37792	payment	2133	2133	1874	1	1	4627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5Bh5quHdp9SsjbnAVhTDUDpkF9SUeFPW3u3HpUVWMfLvQxJv
37793	payment	2133	2133	1874	1	1	4628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBvZqEgdoM2oKpE6UCweNfdBz67Le3rza9sVmLmDF9w7nWKza
37797	payment	1397	1397	1678	1	1	14501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVhGLpTfwxgZiZTxv4cKH8p5bqjvCUt5y8D9iCUbsQUztd2oM
37798	payment	1397	1397	1678	1	1	14502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwnfNghRDf3YrT3DFsCrSrGXLvspUCTwN3ZCLTFtS1y5oJzrSj
37799	payment	2132	2132	1874	1	1	1344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSE4ZAuMskbuTTFVjdV6UdunN4Zwm7KiqKrX2AP8PtkjEfBY8
37800	payment	2134	2134	1874	1	1	4944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeVWiQMXsuWaKoC5bwy45nhkdWi8AUi7WgzS3vpXiJWMGxwfH
37801	payment	2134	2134	1874	1	1	4945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPnaEEimJW2xHr3KK7wdeqAdPXjG3FbAu6dULBYEQTumg5qXTQ
37802	payment	2133	2133	1874	1	1	4630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZsdpM1FEEPJxXTW432FWiDt7Tpgs1CkRodH6q3cNtSaYKJeX
37803	payment	2133	2133	1874	1	1	4631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1QDB6DjWFmRqYQzitukw5PXbjSUB9wYVfyn38TdR1zTB7XrZ
37844	payment	1397	1397	1678	1	1	14513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39ro31HKr1GYnGJMDkvwMSjoAw7wG4VNpu59QAgciZtKaTNoW
37845	payment	2134	2134	1874	1	1	4959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZ1YMmzCkcndeSPEZT6Gqx3cL7GxRbt8234PtkW4n1S8hjz6m
37846	payment	2132	2132	1874	1	1	1348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4ye4PPbryokrheBZHEkdp3A2oxV8uP3J4kLj9AL5976yiDhk
37847	payment	2133	2133	1874	1	1	4645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt29BNx6pFpPWmpU56g9rAbmaZCEoK7XWB1rJa9KTXdwVuAUwf
37873	payment	1397	1397	1678	1	1	14522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABedwfrW9wU4PQEtuXj7tRjxUzxyAAAWQG8oDzuaUQ8P1Yu7e
37874	payment	2134	2134	1874	1	1	4967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFdVveorXR1qu2Sgpkd9tYoa5gogE3jow87C4U7dEkWDouUuU
37875	payment	2133	2133	1874	1	1	4653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMfk4mfU9i7sygWRoMUVWetkodpJk8bbutvvXPSaUenoXJZQm
37883	payment	1397	1397	1678	1	1	14525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVMv1wPuaT5sZAVDvmaXHtgXYYf2i6FMd153XfEdFHWeMPGHK
37884	payment	2134	2134	1874	1	1	4970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeHmtkbmAHJcsnYozmE7fTVgx7BtNFMzmwJz4gPR8XA6ijJCho
37885	payment	2133	2133	1874	1	1	4656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNofKHpozik9gd2KTRMVPBWRwwgMBjFmhTtAebXVBx4Xs6c2t
37896	payment	1397	1397	1678	1	1	14530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkKZhZYKU95TtP6wyefURCxRTjPc2GAct4x4p2NDHc9MAmmFfa
37897	payment	2132	2132	1874	1	1	1353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7eANgA55SW5EpruaLKqfkgqakUNs3mxxFzpNgdhCKcqcvBDNU
37898	payment	2134	2134	1874	1	1	4975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUYdhsMmauTWpuhuu2HeMRXaNQQ1vvAdnyW3utX2qhgGc3PZGp
37903	payment	1397	1397	1678	1	1	14533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9nDgagfVVVkWhqvyJCPRVGwoyCPSMwd1Mmhf7ypAg75kUTeP2
37904	payment	2134	2134	1874	1	1	4978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSRgBSERdB8FybYjpjmNLuEEficQoP2QYvYRZgVUsVtFMQimi5
37905	payment	2132	2132	1874	1	1	1354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMSxF59Rwiwjj39Y5eeGzVofug1fdjFbpz5TuE5XgTZ4mnxS8
37911	payment	1451	1451	1046	1	1	10	4248000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpaDk6Q1Qqm6zNAMx8thRGW7xJJgpj551Djn2ZXQGowU5aSGyWi6
37912	payment	1397	1397	1678	1	1	14536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDUya3TcXNHHoLxgwiNNTEfinTWRDpXQbbtCrQfnKus4B95Jw
37913	payment	1397	1397	1678	1	1	14537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgwAokm5DqvqJSQJrdDR6KSEX653p2UE454JgVVZeVkeamqkS
37914	payment	2134	2134	1874	1	1	4981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzMyvhUwSgkH3EiYm8vKxvF63bgTnhFwKLMuuBUBs5dJrj3rLo
37915	payment	2134	2134	1874	1	1	4982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR4Jw9umyk4ZX2FGTzKBbhwBcGfaeyrjLrStoZEfUZb93gNdfB
37916	payment	2132	2132	1874	1	1	1355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzTvJS6JpRgaRPqYgErinFE33H4xz54vZdxDoSdC4yhtjpTBKQ
37919	payment	1451	1451	1166	1	1	11	2866000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZPjxUGn1N23U7R89WutAJKAncs3YhgqTTMxxh3ghahT1cTj4f9
37920	payment	1397	1397	1678	1	1	14539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA5hFBwDfCXfpvNSAjwRcqv6vhcUWgYd8HqPNFCx38wiN1VX8S
37921	payment	1397	1397	1678	1	1	14540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuieubCYNgCW7oUUZjey43NCBTCSpYFg5wiWyw2rX33dmbX2sn
37922	payment	1397	1397	1678	1	1	14541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhjjHxG9phEwxmzQSiX69NRhf3WRnnPvnMnVgX3cqzsfgFEyn
37923	payment	2134	2134	1874	1	1	4984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv6VZuww8dkJA4AaFPuFBeS9xeXYr61LSFDjdBUGC5dscHNEfX
37924	payment	2134	2134	1874	1	1	4985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8Zqoj4qnLNkKrCtrMLqkQe1ZRVhtf74pwSndvHp812ZkANNs
37816	payment	2133	2133	1874	1	1	4634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7kSrg4G8Ug1WtZBwAniJ6QSyNtC4Dy3aZWYQEgHTvFDYFW74
37817	payment	2134	2134	1874	1	1	4950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWWxWqTUcJ1RKiwpLqf8GQwEVHjXSLNMrdeSp9ajo1Ma8Mobg
37818	payment	2134	2134	1874	1	1	4951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPh7mcqs7Mo6Dh7fuhV2sgCDAVgJ3Hsr76bvmsBXmPVLyAPVH1
37819	payment	2132	2132	1874	1	1	1345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphShhykyCqXgkzgM56664a5GXJZM9oR5pKjJarT2faU2pFVHX
37820	payment	2133	2133	1874	1	1	4635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdLm4Eocvckj5h7NGVapPBaApmtEFKWSU22oFbiNKDH8HAxNx
37821	payment	2133	2133	1874	1	1	4636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpb5AwMa6Xd4PbBfMGMqyfovzttzdG7gcD9BZuUBtNCxfU4n7A
37822	payment	2133	2133	1874	1	1	4637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64VVPoPGeLk2AddgYBFyfy6fEVXdon1hTLQf4JpigjbitReW2
37823	payment	1397	1397	1678	1	1	14509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpCcLcq7wV4XEb1ZVFZd9sWWXi93K9zGAqc9f7WP8hv5Lnd4C
37824	payment	2132	2132	1874	1	1	1346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAu59goQTwBZaUBHhpYZRtjvmfJ9iyb2FYd3ifVLpvQckLhbbX
37825	payment	2133	2133	1874	1	1	4638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2FC1TJ4L2bZca7CP2jrRcyHrfFRy9HSUrMqs3v3zFdjS8xYw
37826	payment	2134	2134	1874	1	1	4952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3Eziyw5SPYBtSdRv17G4apDQjmGnuwKiMZpF7BGEGSd4shXR
37859	payment	1397	1397	1678	1	1	14517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvhbzvSimi5ZAwmi1eLqiUfqha8v6wwvd3QXr3oCmS2SyhHfM
37860	payment	2133	2133	1874	1	1	4649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj5E2Pv5Py3gQV7pQRQKxMtbpRfsppw4Tp7EjpWDdGrb833tz
37861	payment	2134	2134	1874	1	1	4963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGtGwWudkFVQ4Le8SroXCyFaFJbhAwfYS5sNHqN6m6gCcn934
37862	payment	1397	1397	1678	1	1	14518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzuRxV9nFoPqy2syiPz2r1HYukKhGpnXp9sqFxPBhvLEcSioQ
37863	payment	2133	2133	1874	1	1	4650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpTiGosHyYkEPfcW9B9pyWuJB6UEPcjoekgFk4nzNgfCUas61C
37864	payment	2134	2134	1874	1	1	4964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9nSNMJo9YJZnhCg3w61k7pJvUAuamHB2Dopujmdn4bmcJdFj
37870	payment	1397	1397	1678	1	1	14521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmPQETJ8RA8HZuuWVZgxVshTuQ8dd9tviJPNt8yXUauEwM8eBW
37871	payment	2134	2134	1874	1	1	4966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhekUBY2eHvseG4qF8srvUmQ5Zmk92dcX49R5AUF4jGRBVhnu
37872	payment	2133	2133	1874	1	1	4652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DB9fca1a2CZcdtjvwAFnADqTong97mVXmo75tZ7PPNfmVg8L
37894	payment	1397	1397	1678	1	1	14529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqEENbZiudBgC2PiB6L3rc69h2GXUkiPsn3NvvfPuCWu4WKVtV
37895	payment	2134	2134	1874	1	1	4974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4ZakryUwf74B93qvg48oArRnWyGhbPBXVkTXRcBT8qGrqyyQ
37917	payment	1397	1397	1678	1	1	14538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1ZkzeJPV27quccd4uVsJkwdhe3dS42qzDjM3wggpm4vBsp4w
37918	payment	2134	2134	1874	1	1	4983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw21fqaHgMmufEYpawXTgRPfLPB4U21Y9z7a6b1yQ9H9MfEpVd
37939	payment	1397	1397	1678	1	1	14547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM6pzDkX54PnGLAWzMxz8zecco34VCQUFwMLndGoBp4kzHfz4Y
37940	payment	1397	1397	1678	1	1	14548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbZ6L2WyatokQqZvUokcuqr5cn4x2tcr42ZCHveNgqJSQcCc1
37941	payment	2134	2134	1874	1	1	4991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQR2fLZubTe2W1NEYw37WeQS6EQBZNvVQHzhpg1yFDRvGEhHre
37942	payment	2134	2134	1874	1	1	4992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UaXSyn1gLQMMmRWLyjy7ubyUC15fY3GgiT4TtqaAkwzaw5y9
37950	payment	1397	1397	1678	1	1	14552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XYoQ7vGMqj4h5n4PvFfa1Ayuoy9FdCnGLjVHRHVxkGVaLggS
37951	payment	2134	2134	1874	1	1	4996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEn8tX2k2ZxJxkXKJm8beHb6rzbW1ikcDDEFdz6m8M6Hp2wP8
37967	payment	1397	1397	1678	1	1	14560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvddv6sJ3Z1N54hn7hjA9xaKv9RBYNrPigcFvmdnVHmiLP7ezf
37968	payment	2134	2134	1874	1	1	5003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWHoMwjQfnU3mgBMvokD3UqZsrRihDuc7GFYruhQZJ9LVzkigF
37969	payment	2132	2132	1874	1	1	1362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkcWy5jfVRnVdN6PdgRKQPi4dr6U4bzuP9mfa7purrXuomH4b
37978	payment	1397	1397	1678	1	1	14563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc9kLkXy3meAigbmPa3rBR5wimUMTjccvKvxsQfF64BG4wfbv
37979	payment	2134	2134	1874	1	1	5006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1X6KpuKrjQgawUDHir9APdgTC1m51Y6Rwzaej2DHyU8UyWYzS
37980	payment	2132	2132	1874	1	1	1363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLCNF2Y35LaMAiKRuqdG3Xipuq5AwSte37gZcap7L9NK1BewR
37988	payment	1397	1397	1678	1	1	14567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV78KJMFmnWvqktEJ88Woy1oYGU3Q8j3eEWzXgZyik32PPFFem
37989	payment	2134	2134	1874	1	1	5010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvZQNhxmnWkL47QyLbjrLZ8a5ZfiQeGUhEGDTUyoVDtLsfw2Y
37901	payment	1397	1397	1678	1	1	14532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1byvS1akWw4Uw4LWvNiXjeLr1hbK1n4nMbhdmwEpYT3csTJt
37902	payment	2134	2134	1874	1	1	4977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVKYLLwZ5h8ZbtX5NpSXpUmChRtkJgGEYJU4aL1CN14ZisHpcf
37927	payment	1397	1397	1678	1	1	14542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzzsrDg38Ys8yDEZwzHDJhhgJjBR9dca1uv4rcTFcGpuVFyTzn
37928	payment	2134	2134	1874	1	1	4987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRp57ZTYeM5wdjTBYjGJx8ahtMoh8UzpKKFCWPCto84k777fX
37929	payment	1397	1397	1678	1	1	14543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhHSkLXUcxiS3x4oH8kZGpo7XpNGkrHuHEhMFLBj55SpzAUDU
37930	payment	2134	2134	1874	1	1	4988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9yJQQ4pS5SisMK2az8uAiY5GDzScujuGdKRvCyxUTYgSvBWi
37931	payment	2132	2132	1874	1	1	1357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNR8kaFeh4Pqx4sCVufZxYQXr6EPM1oFArm2mKWNyhxDdqJL6
37935	payment	1397	1397	1678	1	1	14545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ825AZesVYz5BqJzNfdeaVceedmQsG6WP9CGby1F9De3REEeyD
37936	payment	1397	1397	1678	1	1	14546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSvxHwinQPhah71jZn6zavmXRHrPATDSegnkbVkrimSgQnDrE
37937	payment	2132	2132	1874	1	1	1358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFKXUNmTexc8igQTvnow1WDXVL5bWPyZqG3TNkXEWsrafgYqE
37938	payment	2134	2134	1874	1	1	4990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsovBPS1iRTmJjMbUkNwp6dFk78zXoKb1nmnp5bu3jR919vVK
37952	payment	1397	1397	1678	1	1	14553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1YwUJGRDSAxQvxF2etSjXaDgjX297BLVHHZsstksdYxhf56iF
37953	payment	2134	2134	1874	1	1	4997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgD1WzPwyNzufjiAn78VCEwmyobP38YefcMuXFpLkJ3nzxvU5K
37954	payment	2132	2132	1874	1	1	1360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G9FzVUQdTuLf5g9UP8cgciCbtwCJMK7TkHEyo2K8rFtnRXwp
37970	payment	1397	1397	1678	1	1	14561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZht6yim2WcBKzqV6Zn9gBnxbC1UKhShprgzLFxwXNJVyZ3S8gZ
37971	payment	2134	2134	1874	1	1	5004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEJ4rgLsQh6VygDB2kQv4Eh2NNZyHtZXv6Dugv16kq5C86ewC
37972	payment	1397	1397	1678	1	1	14562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtYWhja8fBu3T8bxzrF7X7XRag1kgLNUT39rpo3qqFzcqRp41
37973	payment	2134	2134	1874	1	1	5005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYFC9QTazxdBqmM6egttmzEDeKjDg9qnKrmK6qmw2zA7eboqVB
37974	payment	1611	1611	975	1	1	9	832171175084	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11qL3KMS7dWVBjRobRUmpcnNi2FZBc2WgkxRcRGwK7E6a54te
37975	payment	1611	1611	1095	1	1	10	1491243621950	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz99ChVfxJPWcGB3a8s2yfjAazeParwitsqSU4NHkAMiRfV972
37976	payment	1611	1611	1215	1	1	11	1006171799398	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYF8MBeiypFCvRN3J16r9DoQT6AADiZjbc3N2s5Ym73BHET7gz
37977	payment	1611	1611	1341	1	1	12	2803787161811	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWZ73GjhwzgTZZNg2jnPWqes2GKQv9oK72qWsrmpZ8qihEoG2
37982	payment	1397	1397	1678	1	1	14564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZHHPt27nrFZxDqtPDHLfh2ajDm7h82GyfVxJBYXQ9ggVvQWsy
37985	payment	1397	1397	1678	1	1	14566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWDEDfyZ2Yikvxcf3st2ZZjcFYGjMAXmZQuJQWRg7z87fvv3X
37986	payment	2132	2132	1874	1	1	1364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyWX4aHBQEBDtUkc4YZTYnF4LLRhNEbxuqBp6w275VzCbJpyHP
37987	payment	2134	2134	1874	1	1	5009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAe3mGKrCZpAoCh1BRGmrYW6GybHvS5kvtUQ4v4inQ5AoNSsrd
38001	payment	1397	1397	1678	1	1	14573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkM3r6JgYEM1TKtcwtCgD1tvEr8YTTmCWjSarddWKteSWXUJNM
38002	payment	2134	2134	1874	1	1	5016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rQNbp5vSevtw3pRbxfQL7Rv4j3K5RQGAehtXwrTkKsqpY3Z7
38003	payment	2132	2132	1874	1	1	1366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoguMRmgpfQPe7629T5RV2XDWJJhHtFrZqrNgTKajNvVMNfR5
38031	payment	114	114	2003	1	1	8	6000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyA7BZGpJ1LaHugTnzQU8TNxVBWgXUDsjA8BTTvEN6hMgH8uae
38032	payment	1397	1397	1678	1	1	14586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXrS1iriJLPQkML8dqWfFZ9ptQHPgRfXkLyYYpfKEnYHp2r9P
38033	payment	2134	2134	1874	1	1	5029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1HVrkE27m8YazY2W1hjmpX1onvLSnmNqeTMqMkPbdYWDbwi3
38034	payment	2132	2132	1874	1	1	1370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWzXw3uzP9QXnfumxg8tXSfJznLa3DDb2tRZDsHbMnUAWBoFw
38039	payment	1397	1397	1678	1	1	14589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHcWL923VVrU9R2PpsiPBUokef2TCdShXcHzbRMAUekgMKnMq
38040	payment	2134	2134	1874	1	1	5032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeiY1UozptkX9tzD1Ec3bZx2uz8uT3SDU3WrUcxRSv6FsMEYfp
38048	payment	1397	1397	1678	1	1	14593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6AgxDqqoKYVjwVmXgKdJFhDyWzYbkem6k7bZ1bGVxXNPeMv1
38049	payment	2134	2134	1874	1	1	5036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZAGrg4ctMDsYFZJucUwV3Ck9mpWTjrEyUuDmfx7Lim7KqYAah
38050	payment	2132	2132	1874	1	1	1372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyq7QDNxZdo2rrLd9cN8NKvP1aRQXVLcXHGPm7L6qqD3uW48sQ
37907	payment	1397	1397	1678	1	1	14534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jcuy53ny2pa3cJ3apC9odX49osAAMsqCi28a7o7WBhSzyaML
37908	payment	1397	1397	1678	1	1	14535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR7JcR4WMvkvpEmEeussavBLxBjpZoAo24bY6JAG3YmmPBhrHM
37909	payment	2134	2134	1874	1	1	4979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxntnR4PJT4KudzceSHbo3hjhBSJ3A4Y4y5QRBjRMG7c2PUmV
37910	payment	2134	2134	1874	1	1	4980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxkt3i6CBkK37CYXZU9UGUnCW6pkgaYq1qCivu5PTPa1Hmh2qU
37932	payment	1451	1451	926	1	1	12	2371000000000	100000000	\N	E4Ym9k3d4aQQtaupEqUG7a9JzXBEtae7ntunS5ULQfi1Ln5kbDSSy	CkpZ3pqN7tPR1NaC7cDWoFUSc1boF4SB8RiQUmzEizbF5FpAPy8ci
37933	payment	1397	1397	1678	1	1	14544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1igSB79BWyxS7cqZvaQY3yVCwxNDYppRhRR5uiqSwyBav3Pij
37934	payment	2134	2134	1874	1	1	4989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKDcHfzFfiddjstHhPR97X9WuuXnWKNLJvBa6chNYuJ89kkry
37943	payment	1397	1397	1678	1	1	14549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Bq9FXP7oiY6KJQgQpMnub6LNivst4xLBJc7mVM8cVBq7K3eK
37944	payment	1397	1397	1678	1	1	14550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpAtMk5UQuEy1oahR1xa3vzSpCeHgAb6ySVNbtpwQEgfHPkGvB
37945	payment	1397	1397	1678	1	1	14551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfbzV9XcKxTtevCpu69UFtnbBuBF2W1ty1CkYtNeKozBdV9w3
37946	payment	2132	2132	1874	1	1	1359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdggYWoXkSgPiymgvVRA6vVb7LNKGzCgPGhbDewyxPv8kLZw53
37947	payment	2134	2134	1874	1	1	4993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCAFrtwB7rgdRnaPX7FSCgm3jZh3tiYMAKp55q8FxaUuzfs9HM
37948	payment	2134	2134	1874	1	1	4994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQCMLSPA1UZ6b32oVG3A3Sq4KqK27Fw3QK7WJvXvBZx75dwNs
37949	payment	2134	2134	1874	1	1	4995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9KQpBiPwdDFya65hqyeFBYzyMq7pFPwgJSeFKRNPpDnrVncb
37955	payment	1397	1397	1678	1	1	14554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSBxZcoGJMv8mVbjNLUZhDPKqnQsgTPnoUFV3eXwmuhwsXHdu
37956	payment	2134	2134	1874	1	1	4998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXsw78Jkc4rfnaLpB6Dau94YDFEUDKQ1EMoA1mk3uV2ayWaZT
37962	payment	1397	1397	1678	1	1	14557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQNjYQt7wkKhm6BMKnmph17bMrmzDsw1eQNACjo2UoHZ1TBNZ
37963	payment	1397	1397	1678	1	1	14558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtz4YuZC9nXSiew7Ffy83bxWzH1Gp1EVSh3Jyp4bUGydbcss6m
37964	payment	2134	2134	1874	1	1	5001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxB8ZtwA3DkW4y2U75hQefjdL7k6MrSwUiDAHpTc957BMV22AY
37983	payment	1397	1397	1678	1	1	14565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEagR6xAf9pzANPk3Sxk81y9nrt7KtccgG9wnV5m2YBG99kfc
37984	payment	2134	2134	1874	1	1	5008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNj3JaasRmfxqj1KF44wUYhh8ZuT6vbmgoQdtWZ5NnD912RRo2
38008	payment	1397	1397	1678	1	1	14576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYirztc3gXBPFWEdQo8P6grYxnKJeMNxUFoaKZ3wSjpwGgzvxHV
38009	payment	1397	1397	1678	1	1	14577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqy9UCPT6u2z49sQtwQtaicGPaAAMoNjpJjhgnZBJy8bb7Nut
38010	payment	1397	1397	1678	1	1	14578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodVUdGG9teBRNMKFoKD7fmnHPTdJKfPndJRpSnhPpwRsX8im3
38011	payment	2132	2132	1874	1	1	1367	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3NovGUqqfy5hJzkWs7E1UmUyjfZMw4pW1YS9HyFiu2Fxe9zoU
38012	payment	2134	2134	1874	1	1	5019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49EUToh8GPbRZTXcP2sVVXpeXk2DzPmmWAi55RzxX2vG8zhxg
38013	payment	2134	2134	1874	1	1	5020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCMUG2UfpDiMWrALszBkxwwPSpHgxxQbXgJPPjysTaBHCnus2
38014	payment	2134	2134	1874	1	1	5021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwTwTNtKmHEXopRffjsNL91Qh2GEtQip16kD2euBd2pST4X1b
38020	payment	1397	1397	1678	1	1	14581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZof6ZDCcfFcFaUsjLzY1Rx2TsRhEgr84sCGYRCdJwpZguDJBs6
38021	payment	2134	2134	1874	1	1	5024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pTKcfiSZuvXHWqadiorVks8wtkakstqr4p7nHYxwzcQswsqN
38029	payment	1397	1397	1678	1	1	14585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHLhwRsS8MYUf3qZ8bXX6jwDvtXsNDzNkRknCEscL6ZfEUGLr
38030	payment	2134	2134	1874	1	1	5028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7c3RrKS8hq6Q9QicCSzLtfSpMQuhqeV1LTMigLV6pveUftBd7
38041	payment	1397	1397	1678	1	1	14590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZLhGJh72Y5TkqpLbQ9KfGEmKeobp5BBdFy1pkTW7gTuG4AfB
38042	payment	2134	2134	1874	1	1	5033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxBUaJYE69tsrhCA5eoCT6G1n94JyVtfvUMJ6eEbG4B5C8Uys
38043	payment	2132	2132	1874	1	1	1371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfn1cjhXjjs6hyxy6ccN1DPgSNBouZSnjnzx8Q2kDH9tf5PYV
38081	payment	1397	1397	1678	1	1	14606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmchrj11WkVjhCSHi2ngeU8reFhW67MXt8tovQmNwge4CwQs2g
38082	payment	2132	2132	1874	1	1	1376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhX7wfoUmN3ZSfaS7adLh7bPb5YxJWcm5YK1RR7VR6snbpqNK5
38083	payment	2134	2134	1874	1	1	5048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54rw6eh1xFDQAGdF1xh5bnLUCtRtcBifpumqCKSjMiCCorC2a
37925	payment	2134	2134	1874	1	1	4986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73QPN7qgmtp26iURVGmbSHDLmVHLPs66WMrBBecSnCnzkLiKU
37926	payment	2132	2132	1874	1	1	1356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ae9A6cG83hLtnGgzhDUnE2dLmDcb4WXAsKszPuwePqAg8nmc
37957	payment	1397	1397	1678	1	1	14555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmiyJLZc3mi33HLDsKEuK3vX9bCpuAc1RV3m7ASmi55VCUgTPi
37958	payment	2134	2134	1874	1	1	4999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdPYqZcxdTEVJ2FX5bPZpjHz82gsANwBD9SggEcye3gM4eCbf
37959	payment	1397	1397	1678	1	1	14556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXchsg74N15ot7MSd6tyAUQKfVHjdaDNPt4FRPc8NunTqKtqZ
37960	payment	2134	2134	1874	1	1	5000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN34zmC4eVFZtJfgEmbg7HYKSdMPr9ogHTiKvBJbdJkER6LwmD
37961	payment	2132	2132	1874	1	1	1361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLBnj1XgyxiKQ2g26BHRTxEJ9CJGQcFPUU4W1qfpHKbm1maUbQ
37965	payment	1397	1397	1678	1	1	14559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBviVTKQT5STJm9xk2vr3fbFCciPgRzoBTaq1KKJTmiTiubVPi
37966	payment	2134	2134	1874	1	1	5002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJiwSMxBhUs47qCmtuHBaN6ZkdixQbgbWDVmakcrpVHQEjTQA
37981	payment	2134	2134	1874	1	1	5007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XCm9X5piM5NYib5PxW47iLdZnnemTFHUCX4Um4LcfdSNWAE6
37990	payment	1397	1397	1678	1	1	14568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZ2E9ujpmKGwwjZq7v4pSPk6N46VVe2PWEJZpRxim7Trf88Cj
37991	payment	2134	2134	1874	1	1	5011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUyAcieaeHt1T7ds5Aaj8AVqi9QxR4tyJzVCbWwjfPGAkhoq9f
37992	payment	1397	1397	1678	1	1	14569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhvZsbnsoQPiAPJvqKfoFcnoFVUFFz8sQEXVK4Yu4BR24T4T4
37993	payment	1397	1397	1678	1	1	14570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9CoMkajCycYfmqc1L41fRnx3vL7N8KFjqDzpL3SkUvfjwc3Cz
37994	payment	1397	1397	1678	1	1	14571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdf7mHuPB9tNjEzPFohEAgBneyQCXn3CFZsJnip2rb2siehKWN
37995	payment	2132	2132	1874	1	1	1365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8eWhM4x8QfEwJM71oZtpS9UCAJvm2Cd3LSeQXSWyMBhoBGYTR
37996	payment	2134	2134	1874	1	1	5012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLzj7a5ocas9fb5BVV2gEyyxgZmqcRDcouvAAmkeWSzx9Rufu
37997	payment	2134	2134	1874	1	1	5013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wRyztMP21kycqjG4n4hu5vH7Ca6hbN9LoEfwuRqTC8oXXeF1
37998	payment	2134	2134	1874	1	1	5014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqbMf3tUModv4Ria52S214xpt7Zate7uMT3RsQQQd64PzJDH4
38004	payment	1397	1397	1678	1	1	14574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7AUQ498jX5YRXE5DRrrp3uXzhn7tfpPEVL8zKp5x6vV1T7Kd8
38005	payment	1397	1397	1678	1	1	14575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWrth1ns5CAzCatQJpSajo9Mkzt3Vidhj7UmJRkkZKFmfdw3v
38006	payment	2134	2134	1874	1	1	5017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZak4guevpwmhhNZxz3g2apSgWwFoBqysBoy7XzWiFBFcV8TwHm
38007	payment	2134	2134	1874	1	1	5018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxNTrpu6eATUmGJvCYu6G21mUMZ6Y9crAJSZpV9cbT2iVF4cw
38015	payment	1397	1397	1678	1	1	14579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSZPRQ8WA5R849JFXiUJ8sxthCge8U9yAaDgPSH7d46CdQAa5
38016	payment	2134	2134	1874	1	1	5022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoA3ip4R7ifQudB77nnax5UrNFxTiGPLitoNdbQ2azHivSS52u
38022	payment	1397	1397	1678	1	1	14582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5LeAJbop2Cm1pXdzk2ShzuKh3eBdJppPG4URdQkoRHzUUBUEo
38023	payment	1397	1397	1678	1	1	14583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2tuxqbMG125hbGwYNtbPoLYcu5B9UgSNF97yv2iigFAGULX4
38024	payment	1397	1397	1678	1	1	14584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ssELRHLceaXd3FaQeMVTtYC9u8ykDhhzyKDXc6qVUS2CFGvD
38025	payment	2134	2134	1874	1	1	5025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUcpDMcvPfEjTSvE8mYFfSmUs59svjwmgRUperFfEMFQ6rcfDE
38026	payment	2132	2132	1874	1	1	1369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY9r8YVgzPQNwURWqDz3E42pYsh6bdWCjeN3vCpRJaPeoHGNYs
38027	payment	2134	2134	1874	1	1	5026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPswqkGZSQBKaa9USRPe23tv7sFAjq6RzeGU5RfCkVCnDzAqP
38028	payment	2134	2134	1874	1	1	5027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntbWfXYtyFK2Zby2K61oaQK8VXwb2YrLxmcnigRfaikNpJkwQ
38037	payment	1397	1397	1678	1	1	14588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4vz6ak8TyMEBuH5BsrBs5Kofah19SbbuAWTYUXaRzCDKEjDA
38038	payment	2134	2134	1874	1	1	5031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Bz9b5RgfwnJzcChpDXuFnEYsstVxbTkiQngakDfmF7cSpFmW
38044	payment	1397	1397	1678	1	1	14591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2U58tbU9pe4hLAH72AHUTyd7aqKopA2QsUwudZ1rDRQxxPnM
38045	payment	1397	1397	1678	1	1	14592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uhysQUTnz7ZKfduBLFRuc5uZeypzGDMV7rY8f3XLn9RbzDeh
38046	payment	2134	2134	1874	1	1	5034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZquEN97ZNpa8BHmu945raQdFFpMYYKxGWrP577CXkeWeP8V49p
38047	payment	2134	2134	1874	1	1	5035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3dNx4J3oHMubMzV5vaYWDQdbcDaFxN9chkVWunhBd8LfZG3A
37999	payment	1397	1397	1678	1	1	14572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbjfjvYkFoFoSbSf8BCGVbQw3y17oEGw4qQLUbe36nQ4cmQ5cG
38000	payment	2134	2134	1874	1	1	5015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNDKNriUQuAD4Mv5pog2ddR8DELz8yT29Un6ACGFG3KYgEiVHb
38017	payment	1397	1397	1678	1	1	14580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNT8RzzMgciof5oxDjhac9awT46CKM8P8MmaA4hZ9bc2Gc75u
38018	payment	2132	2132	1874	1	1	1368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbH4eSCqkVkzHbyNiB3tA13uoEDZDUuxinnjHdQsSUnx1jLRG
38019	payment	2134	2134	1874	1	1	5023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWR75Mi6rwpkKtmmpw1ep518aZHyvXe2FvMeC41huoKQeMtYnG
38035	payment	1397	1397	1678	1	1	14587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvcCoCEKh26KGebD3j4N22QQciAwXNy9Vbk7yihvy65XEcRRe
38036	payment	2134	2134	1874	1	1	5030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVD8aHVif9z8Hxef2a31S4PfsU5oHxXpWuWFiL1tZdbXk61xF
38054	payment	1397	1397	1678	1	1	14596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE3ebb5PFKwsR98A42c2d1JXF4AaT2t33qbwDVLz18sHutxtT
38055	payment	2132	2132	1874	1	1	1373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB37nmv5UkQbD74bpq4fxKtw7GPK24LgWBLECtv8qwqNKT9XQE
38056	payment	2134	2134	1874	1	1	5038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvv7W6acnnXwZq7hJpHvuZ4eu3yn3reGT23J2KCGdZBUQtyAH
38061	payment	1397	1397	1678	1	1	14599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjicCkPu3t7DfFKCh9htJNio6HBc3pLoZj8tWTz7wQLovG26mL
38062	payment	2134	2134	1874	1	1	5041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWHDoWqeKSJqVtJTdwX2mw1qFNVXo2nYeTDxRw4e1WRmLjguY
38084	payment	1397	1397	1678	1	1	14607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXbxQWqPfWwtqL2yFtdr9TwXrMBPA3FFSpF5psFaNaKq65bGdv
38085	payment	2134	2134	1874	1	1	5049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFAshwvTuXgvUpBVnd43BZShmAq3fdsKWC7p6m2NRvjsKMzCA
38100	payment	1397	1397	1678	1	1	14614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemzvctmbTKHUyg9nUBQseKVhgwWrzRsy7iwgCzBfzcgLQAS6s
38101	payment	2134	2134	1874	1	1	5056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZET98uhJixpzfAhfpjHBUsRD64iV1T385E9zYvpuhPWL8ybqz8
38125	payment	1397	1397	1678	1	1	14625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaARsdthJCFWxGGCzXcKXQA8rbpWjW5CBttLJfGkYX9UJDrvpLH
38134	payment	1397	1397	1678	1	1	14629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4zptSePBs9U7nmDvJJj3DayaAqzd27Q5Wt9ULTfEGsYS9UhP
38135	payment	2134	2134	1874	1	1	5071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZymwLPSJ1Pd7ZKB44swaJKGB2UthH6xC6jHb1m5tLmoiaPGj9a
38143	payment	1397	1397	1678	1	1	14633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKe7E7AAeYYPY8QFFKL63rhUN32MNDuycSnrZZokhQPxQd45xq
38144	payment	1397	1397	1678	1	1	14634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkoMKFbKbkW7AHgMugdaAjbxYRXYB6uquJoT3Y59J27K515rY
38145	payment	2134	2134	1874	1	1	5075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9FssNQjpn17d8sTu3NKDPngcdHCY22FitjUf44cuJWBArtGD
38146	payment	2132	2132	1874	1	1	1384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzP9a22h9A999xMUPqYj49bA8mpFyAyMB6EjkCoYR7Go54vGor
38147	payment	2134	2134	1874	1	1	5076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7i4h9g1AFNyrC1rFxQR2N8zCwgEkVpW386QnXyrqW4AcYdJfR
38150	payment	1397	1397	1678	1	1	14636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMk6o6xbJBG1Vwusiawxd3s95vsQvFpvfD2gj7DgHJTU2Jd6p
38151	payment	1397	1397	1678	1	1	14637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcfNFG1Zq3oA55AMGpp2J72F5fBPQUMdCNBz6qQyfJXyEL5wi7
38152	payment	2132	2132	1874	1	1	1385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7pTUwMCC883rpeZwS6ER8vCZ2gqhQrptzMhXkJzDUgujaVNc
38153	payment	2134	2134	1874	1	1	5078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYffs96axaLE6qLPUqyv93ZuYK6285Rv58VWFSQ1s8nVwD3QdE
38154	payment	2134	2134	1874	1	1	5079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6tuiuygHekBP5MYEThCz2pUXoJdKkydAo73bzPEuBtaVhaNL
38155	payment	1397	1397	1678	1	1	14638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NMt4ugEhF3zqseZTN5L1UdKWGCSHv4RLYTbTHfKbJ92rpYuv
38156	payment	1397	1397	1678	1	1	14639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAUQwCFPQKmGVA68vsoFBRxyxhMdTddk6ZsBKjmaTWCLGKAgZ
38157	payment	1397	1397	1678	1	1	14640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHR9ogbPJk4n7VY9QDVTDnjL2EQ4nqpWEh9WqYdErMrcb7BZg
38158	payment	2132	2132	1874	1	1	1386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqCxbs2zyok6ZdkekBS7hDRjUfPr1msd5DineUaNtVhNQfP1Eg
38159	payment	2134	2134	1874	1	1	5080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpePsDF7JpYHj6L7jn6yNv585DT1JacR5AzAK6j4gS56UWFSi
38160	payment	2134	2134	1874	1	1	5081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSYwoNBo1wZSgubngGVvd6U9dUqnbtYknPgbDCCYasoctwVri
38161	payment	2134	2134	1874	1	1	5082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1MpKFsJ7TFGEtsoWE8vveUQjahNsnLgDvnMjzk2cg6B4HEJY
38178	payment	1397	1397	1678	1	1	14648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zvL4zDMi7VtCWdrkQxtR9Cjvy95NBYB1EKoHNRixungVHFxd
38179	payment	1397	1397	1678	1	1	14649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTw6fyTQc1WD4cvFF1WNZYBiBCFFsxGPu61Yj7T3CS4VtUH5Pd
38051	payment	1397	1397	1678	1	1	14594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvVfG9xsSoawczUZu9rXe6D1TmSDtPvg42dkhkkopksuY9yjr
38052	payment	1397	1397	1678	1	1	14595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZupGZ9TxP4JYEmSR9eg5B3JTAscYP4StTLYjkpFkGurYzop2tn
38053	payment	2134	2134	1874	1	1	5037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjEbucoe9HDn61WziXTxggus6sKXhnxuEugZWheaDSCGSvb8Z
38063	payment	1397	1397	1678	1	1	14600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54f9iavbgqJmyaAfgCDz3PvrKYiXVtzRyjwJmj76rxDMNfShg
38064	payment	2132	2132	1874	1	1	1374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfqso4hCBm1hVQpskPV95aoS1t8GoJemePQNxgfkiofKKL3qx
38065	payment	2134	2134	1874	1	1	5042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyXN93hgoeN8e6rZhxPcnRtn7w4VRC3EnKkiPwBje6XjHscS8
38066	payment	1397	1397	1678	1	1	14601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjkFak4C7ZYqu5jwqN79qUsJfUk6rEz9YZCzWMb1UL1Mo2KwR
38067	payment	1397	1397	1678	1	1	14602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vtD8mJ8G2RF5s6QhgnG9JCVKmmYfW4Z2kwFLsNJW1goPKYMu
38068	payment	1397	1397	1678	1	1	14603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUFeg4zea4VQ7d3p5mu3udyyCyB5EdQsEuyu99pQXkJFyBfTyw
38069	payment	2134	2134	1874	1	1	5043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRNNZJ9qbRHWjm7vnb5cwhNz1nkTv2X6S5ET6Z4dDzZuZCFte
38070	payment	2134	2134	1874	1	1	5044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1LcRQizpDcVMmSVF34B3sSGCNtJ7TfARFZ4gBAqURnWCHusPt
38071	payment	2134	2134	1874	1	1	5045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrgK53jUvF3fHmussQSk4j2xmRXK7vdbH8RfHtvkJNXKaxHdp
38072	payment	2132	2132	1874	1	1	1375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHWMifSWzpgitJFb9PRzkiEkeMZqexBott1QMJQj9m1sA66Wr
38093	payment	1397	1397	1678	1	1	14611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqJSzz64o51o8Qzxv2TerTpY8mwtx2xJmPNBc83ePEECCqZvTD
38094	payment	2134	2134	1874	1	1	5053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjm89nckdeCXgmaucLifsdiFvEbJzSBrQzhRGe9j3DSPqqGGND
38104	payment	1397	1397	1678	1	1	14616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjb1EJEcBAYaAZ1G12ta1Dp7nFiidUv8eNH5XMakRe1QDshu9f
38105	payment	1397	1397	1678	1	1	14617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pgZDQATbSWj47zsywzApnmjJT1bHgwg9ww3cjf4RAin8viLC
38106	payment	2132	2132	1874	1	1	1379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYyh6ZUgAGDXH7qsY5vHJS4Q7TN4BqiNfDa6xx4d5SPLomK3W
38107	payment	2134	2134	1874	1	1	5058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfdf9nwazUxpDmkbEZen17WK4A74Gm9mNtjuno68zrN2xJeSeE
38108	payment	2134	2134	1874	1	1	5059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYas5tnRTx7co8pbhZJ2CyGUNKpum4WmG7y1axpZpu1xVFN45ST
38116	payment	1397	1397	1678	1	1	14621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJi86MPixcJywjahPqrha9AXeLFZV8174VfkGM1K1un4sbpzjt
38117	payment	1397	1397	1678	1	1	14622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVk4EA5myPyNTK1Q8QbrHQs56k6CtstfZhvjb8yjTsTckLpsg
38118	payment	2134	2134	1874	1	1	5063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenXJEkEpSzuDdP4rn8P4m4f2zS7C1PiifW1JxUcTdaRTTPZZo
38119	payment	2134	2134	1874	1	1	5064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvKit31R14ecRSr23TBWFQKqsD2EdGMfL76vSYJBqxghw7tYk
38122	payment	2134	2134	1874	1	1	5065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6ena5cT792T1A24wvdNT1gWpuNkoHeFdJGnqkaiRmcsDrUjm
38136	payment	1397	1397	1678	1	1	14630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5XW44LYq8T8VbTkzHGKw3yZWDfKYeqpaxWidvwkthHgEHwmS
38137	payment	2134	2134	1874	1	1	5072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddg5T1AcAzzxJiQcZmbQfaj171Gybu1p4Vq1LJg5J7hrELEWp
38138	payment	2132	2132	1874	1	1	1383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfvEAveWdG1xTfmYYJ4uovkVogifgcv1fhG2DZX12KUJoB8ucw
38171	payment	1397	1397	1678	1	1	14645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88u1tqhRtep9BpxrVLhiqLqcK7urMx81JaXwyviapEuLhVQHU
38172	payment	2134	2134	1874	1	1	5087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdM7Aqtq3db1yq8QyZ8VH8C3zoNaU36yDSCEQCgN5LdRZFW9W
38182	payment	1397	1397	1678	1	1	14650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYks6498W9qfif7AGFiA2GPCAdmsGT1nG3MgsR9nXTyKUsNgtXe
38183	payment	1397	1397	1678	1	1	14651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZE5ov2QhXUawtAEV4GRY5c4wQjpx22VkCrM9Lxao8i4P87Ym
38184	payment	1397	1397	1678	1	1	14652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtniPHP9MfWA1ci45na6bdrtAK8foNJs1ijaky5BM8BxPVMbek
38185	payment	2132	2132	1874	1	1	1389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSuC6Nd2hLagKRsZQKKTYikCxzbZqpSDnRRASJnGN1ZHf8obQ
38186	payment	2134	2134	1874	1	1	5092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQxtk3iSXLeLR3EyYTmH4CPyPMh1nXXnvZqqaCLbMmkxGdzmU
38187	payment	2134	2134	1874	1	1	5093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZSRHPbcT7KXE1zBrDFRMb3A88ASpHGP7kCJvdmiDY6oJpgTM
38188	payment	1397	1397	1678	1	1	14653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LA5rX78iW4WyGWMCgrej2osxZvjwXR59sCV6bJ7UPkfQySxQ
38189	payment	2132	2132	1874	1	1	1390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9Fb1hcdexr18YhfWVLYnxsMVE47fJyRoecAG1un3tKNvaXdv
38057	payment	1397	1397	1678	1	1	14597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1onBceKLjMiAsHQkG56q2brRG3fG6ouQBnydFZDQuupAo51w
38058	payment	1397	1397	1678	1	1	14598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfv7UePHCx6sZw8kSebDFXbcP6p9uggvfcCAmxUzjJvUaRH5Yo
38059	payment	2134	2134	1874	1	1	5039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhwy29JYsmmN5HNPz1HjczEYuNVrPbD5vk4nJhEm4WF9BTFCK
38060	payment	2134	2134	1874	1	1	5040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrNMfkZTBGdYfXovoK7rZyU6P7DcMjswYpknk2Ny3Q1kgvNSZ
38073	payment	1601	1601	1388	1	1	17	4053000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYdQXi7qDECAHQo98zXaBRKXtAu6u8SZUcFEJA2b4gmJmgn9dmY
38074	payment	1601	1601	1142	1	1	18	2156000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpZQa3TGatwdA9QoDSMPs1UPsHz6ZcYeABruAzhawjR5Z2e2iDaj
38075	payment	1601	1601	1262	1	1	19	1455000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYhQ56do5TcWzwtJGQu1EzVPiDsuUVsjK1oi4mjF2jULkxJrFkG
38076	payment	1601	1601	1022	1	1	20	1204000000000	10000000	\N	E4Yq6R5xp2bhBJW1rzzDmf52EVaXatxbCL5JHNN7VkQXhxU77symu	CkpYwAxaKGA27rNuMBReMC4LcHBLcFEgvhxN3dokDkHC58GW6oWsZ
38077	payment	1397	1397	1678	1	1	14604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqeaYF2uwQBYW4t6sgRY2Bxp68unqyC7x4eKmXdbuLjhRrdcz
38078	payment	1397	1397	1678	1	1	14605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXwW5CKvfqJxRv2LCfNAMM4gwFTEMM5uMMMuf8RP3q4VjhE7A
38079	payment	2134	2134	1874	1	1	5046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCf3wQtzC5AYzNJ39AQo33xcQmb95UoohdcLoPNkS7gPzUdWqt
38080	payment	2134	2134	1874	1	1	5047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnriXSstiXswd7kyQGxEto4TxhWwqsSzzMWZghoXdcFGDz9cMT
38086	payment	1397	1397	1678	1	1	14608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3x89PmKHCoFHQF2CKqjn99RXAXHgHENE9x755taBj18jh6uuB
38087	payment	1397	1397	1678	1	1	14609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtADxC7XvJdPGxErwqhQWqu4FLVoo9mQdGeCJe5c2wm9njtXcj
38088	payment	2134	2134	1874	1	1	5050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hrAsQX9MxcT1EMU13oHgwDND6niWi5QbLvz7HsAdYPg9wkt7
38089	payment	2134	2134	1874	1	1	5051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZA8w93JY1MY6tLycRANpBXcD4k3hhVcdZ4ZR8GhPjBoPfNNq
38095	payment	1397	1397	1678	1	1	14612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANJfWmJSgXY6RACyJaDGGPR2gBPDJSoRHLjNhESmXD4nWXpqb
38096	payment	1397	1397	1678	1	1	14613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFypmiXpEQL4vGo9gF9XCfhQZdPmyo8Nm82tjTwfkAZ7LN8txB
38097	payment	2132	2132	1874	1	1	1378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrHD6viYsg2okPeQ9MtyTWCLTQzDTtJzeNEGWUpc3dMSvFVCm
38098	payment	2134	2134	1874	1	1	5054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAUGnYMrgQSnxza4T5QV6Umq6NpBAqgL71iA8gzFJkN16zQ2b
38099	payment	2134	2134	1874	1	1	5055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnB1gn3arudKgbmapU5EwqmiDEkhBn9yGiucViLNKN1rPNj3g
38109	payment	1397	1397	1678	1	1	14618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsws8JWSvSd88mdX4WsxxZ3RMHh2HZmpzzR3ZeqCHZMGp2nFvf
38110	payment	1397	1397	1678	1	1	14619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GeMMyvxNndMxWotyYXLhdT5WD53uiUo5ocv8LvxiasrEFpy8
38111	payment	2134	2134	1874	1	1	5060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbEDhAPDwkS1tbgg6ZzsCp4BtKAQDBfLHzLgwigmeXmoCCsMu
38112	payment	2134	2134	1874	1	1	5061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu2HAQyaML2gxio5LQAu5AUM2VosH2BTM22pU59Y2R8HXsrv7K
38127	payment	1397	1397	1678	1	1	14626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77V39UWWjyHwo8pGgCwpTHWXMR4ukMMUfAxRcJ9LLPLvTFfhT
38128	payment	1397	1397	1678	1	1	14627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKehv7cTgJTtRdBnCxtyELjJmKWxeYA5fTtLoAY1DzvUNAX94
38129	payment	2134	2134	1874	1	1	5068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCfXWWptWZbfjvbVNafoim7kY5exkQ6arDr5H2C8ttFC2663C
38130	payment	2134	2134	1874	1	1	5069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMcgaYFYpFs8mGJ5ysPpUqniSomwrm33hxp6K9RYmNPnbi6N6
38131	payment	2132	2132	1874	1	1	1382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zz3A1YUAtiWWnEEM3S1kuectpH1FHpQchiztuYNoCjoiwZeZ
38132	payment	1397	1397	1678	1	1	14628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyr5kNj11omLyCQFXwvv19C11crxuKdNMEtnQ3jJ4yvwxYwBq
38133	payment	2134	2134	1874	1	1	5070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kaYZ8AfkK7yw1FdkxQjsenx9PTidVHtZmLYsYiVQmgZLFAZL
38141	payment	1397	1397	1678	1	1	14632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgPoTvLhEZUw2FeW1z3AenEbxL9tTT84cSwW7HnMZ8nF5p5wq5
38142	payment	2134	2134	1874	1	1	5074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCs8kC1h88SaocZ7CNF9yc4CdKhTVHPGKTGvosFXYt2jaLenU
38173	payment	1397	1397	1678	1	1	14646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSmt8wcxmo55dq7DabBSi7UDqLXX9CtGXjmBrHagqc4WmMXnv
38174	payment	1397	1397	1678	1	1	14647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrqDexwi4HiktEur1NeQydkEV9Tv3xEg9TA3yAb3eDQho3yS8
38175	payment	2134	2134	1874	1	1	5088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgBAyduV22wUa11L61LEGrUSrmkbXHWabCDM7b8YP2YVZdH4h
38176	payment	2132	2132	1874	1	1	1388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KTdGeqEyahL3fxaY19UTf5UzahAk8DvCSEmWzP5YrV5ZL3iy
38090	payment	1397	1397	1678	1	1	14610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjArcxuCUGmKKGLc9CYo4XQxX1skm8m1nv1mTpizz4ogwz3YTH
38091	payment	2134	2134	1874	1	1	5052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMcTGcQaHqGsva5HWjvAUhuA5UWW5xNpS6AGtMvXCBEDdKXag
38092	payment	2132	2132	1874	1	1	1377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4RT3YKzHa9gcipSWUrNG3xjknbm2RPDCaQQieaYxBSEZZPSB1
38102	payment	1397	1397	1678	1	1	14615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpZmxujTQKxgmibZQPMmQ4Wdo7UTGPjyR3ZA8HUBDgoiXRj2A
38103	payment	2134	2134	1874	1	1	5057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKhYKbEjbZ68aBbJGakTWn5GLoSMeq1K34ifuB29c8bHn3M6a
38113	payment	1397	1397	1678	1	1	14620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8VVrA5s9xqJfWGdHGNvpvP6RDLiDShHQ6B5NzaHMF9aZwqWYu
38114	payment	2132	2132	1874	1	1	1380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTWAnZCLmEExEopWWWcJNezRqCtqSG7c3QAFWLdimCBzp4aNu
38115	payment	2134	2134	1874	1	1	5062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ4uXwV6VXHYUokmsgkywjwRCEzUYwNMk9vC1fythokJKmLRDY
38120	payment	1397	1397	1678	1	1	14623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qH6VCJGD8ajAQfMt7BtWfPURKYpKe2KM6eyhBfbrw2YihNxh
38121	payment	2132	2132	1874	1	1	1381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSgV4SmPxw1hYJdAUFc3WiKM2C7vwHN9hLqCzLgKnjTb1kw1m
38123	payment	1397	1397	1678	1	1	14624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCzvyZPN94LukKYap9JqHxpEPfWqmkjoLed3SZ6gmZ1kmjCmt
38124	payment	2134	2134	1874	1	1	5066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEr5QKymxKKCMaG5BZ8YTo3KNmrqbL4yVSG8kCVN2aDMfNCUr8
38126	payment	2134	2134	1874	1	1	5067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1TEZUjf5Cq1T9Mo4rDqBcoyn2P2N9yyxDUZGttnv1T9UrbybZ
38139	payment	1397	1397	1678	1	1	14631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8PrahsYDG8zhYRokfjQZiQGBW9R2oJpCrfxGBh2n9zdc2Eb9d
38140	payment	2134	2134	1874	1	1	5073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ3X2r8pbyaCUDyShEs42h7JbwrNBp2NBbA4rgPoKdCqT56d5u
38148	payment	1397	1397	1678	1	1	14635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkTZUbmM1YyMbQreoi5dfQQjRZU4GtVJPvNcK44AMr28moyh9
38149	payment	2134	2134	1874	1	1	5077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfirMMR7vzLPqMjq4TvoAu7qgYPzcwoAFeptqymYipLte9V1ou
38162	payment	1397	1397	1678	1	1	14641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyCgaq2LRgAGDQRrmEwa9nhLnNyBm6xuKoBLdEYmLwYDA4jbnm
38163	payment	2134	2134	1874	1	1	5083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgse7kGQMyzro34pTNHhxCAgBFP72kEfmHQyGW8BiL9kFjG9a
38164	payment	1397	1397	1678	1	1	14642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs74Fhe3SVFzNtt9L4Vb1HjgoRRLZo3MKvoeRqCDEnKAxdSces
38165	payment	1397	1397	1678	1	1	14643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK5GdJcvwC8SZmf8HtVb3E9jFqEEADKbWWjMkPwFwE6sLivGXS
38166	payment	2132	2132	1874	1	1	1387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUAM7ww136L1QtopfNADXoi8eVrQdLzdoMg6TJzbQeQo5Lz4S
38167	payment	2134	2134	1874	1	1	5084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VEjDEMBnjFzVcHgRLDxoXwQHcbVNZeW7doirqjdRXQa4K1nd
38168	payment	2134	2134	1874	1	1	5085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn9D61uaFDmDEkgigqLPvJLrmu6CnWMod76BBPQakfQnynUBnZ
38169	payment	1397	1397	1678	1	1	14644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMKz3PigXubPFRW2XqMvUkw9PF5ZESq7Qzh7DZcNPnhNoLmB5
38170	payment	2134	2134	1874	1	1	5086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYerhqrfK1jsaciXqXDxLhGEruqxP24sdVxDvHWWVz9yCdMwUZy
38202	payment	1397	1397	1678	1	1	14659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYz6CoaCkQE1dbN2tvzkEqMoQNs8jhBdKvC3upP6TBF7PxAu1h
38203	payment	2134	2134	1874	1	1	5100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHW3LnU6JB4hvMYgaLQUy1zzdxjnG9xxaDajU1FfwNw6VAnNpS
38214	payment	1397	1397	1678	1	1	14664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDVtgFMiioQkGhNY8XEZXChYEBc34m51TXC7Aeeirpc7BH5CE
38256	payment	1397	1397	1678	1	1	14682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuh7h49NEKNPysdde8sxYLnXPtRb7wiWWp29X6J7M1JGu1a8Hj
38257	payment	1397	1397	1678	1	1	14683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QoR9yraxRYQvNyZXirCobuZSP6L3QuNoZP6KgRQzCsRMce2r
38258	payment	2134	2134	1874	1	1	5123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMttM7Fin1oxgU8Fg7BURDyA4vZWe636HDhdbMBG47z1NUhxdN
38259	payment	2134	2134	1874	1	1	5124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoJFjJ3REhJHXhHHP7E7ZJRhQsVsxHDzbagHMHRmTGQq3FS7q
38260	payment	2132	2132	1874	1	1	1399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBhESF1KPh8rX3mCMPwjqKnorD6RrnjX2LcWSHjMC7Bh5MYnx
38276	payment	1397	1397	1678	1	1	14691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1QdMGECBYGTaZgxajJT3bmK4zM3j4pM2eBcTHejkGVrf2ReM
38277	payment	1397	1397	1678	1	1	14692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqtPXLYLBNTFqk3AfZPS7aE1vRfjx42SBKJKVP5gGccZue91w
38278	payment	1397	1397	1678	1	1	14693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFoq5YF3oNy9hcQwVzq2CAa5BHTucYe635Ygib1zk2X8axvU7
38279	payment	2134	2134	1874	1	1	5131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtLEKfcRDkub9fY5yKbucSyfiPvdmNXM4q4rjvz4GohAq6ozH
38177	payment	2134	2134	1874	1	1	5089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeDoxvta9RLKya9tDS4ESuNWboeTB6Prd3wFouW6g5x5Dgijf
38191	payment	1397	1397	1678	1	1	14654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEk9VR11fuGPmrzE28saUoZBQ7E3M7TYRVM5os6okxWHrDLtFR
38192	payment	1397	1397	1678	1	1	14655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDYSgmuzpuRbVXMGvQohnW2YKRo69WLYEwfz4EkZRycNohMag
38193	payment	2134	2134	1874	1	1	5095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5jhhe1BrLX5zCto8G8aLzcziPzYkkByobjWF6GyGTRrNzRpA
38194	payment	2134	2134	1874	1	1	5096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YbuA3Zcyw4dUfBYYr2iCtnHsyA6CdUUPMeGPAuEdVs6jKXKT
38211	payment	1397	1397	1678	1	1	14663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCK7D28EaqUo6YmrvwzuMZvd6K29Lme5Dc8HNDuiC2gkohNcrW
38212	payment	2132	2132	1874	1	1	1393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVceAAUHzt52g2Z4tTi55xZEEZQw6WeKq2nLhuRvaooLn7S44U
38213	payment	2134	2134	1874	1	1	5104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsppnDs2JYzr89LDtaKh16HVpDEZrMZztarNCGDksD7fSy6QAi
38221	payment	1397	1397	1678	1	1	14667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJ794MGgpzsELv5F4QnpDCf9hEB1JFgZsDCb7VBSJt8WMjDue
38222	payment	2134	2134	1874	1	1	5108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQL8HkdCvHqR8SHzzE8P6sJpUxQTiWNiqwj7bBF3vGdheSgJQV
38239	payment	1397	1397	1678	1	1	14675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rhbcKCjkLMzv7GrrfiRfrLyBwvHb1BQJz5BX83zmWvTz4isT
38240	payment	2134	2134	1874	1	1	5116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM9LfyCGDXs4sF5KYdCq5ZCPs6uV3ayvyoP1uWQop3FosQ4Gh
38241	payment	1397	1397	1678	1	1	14676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyNKvH5HSBxUE4ienpgo45VNtAyp33gRTJr1NCCuae12b8Wk1
38242	payment	2132	2132	1874	1	1	1397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2YfHHsnDT2mFhkcYgWh3zKyX5nFutoMWEnwn59gi8HbFdEEx
38243	payment	2134	2134	1874	1	1	5117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkzYFwAC4qbqZareUFGECpCNGAfdkkvXG8bRRhu6rBAcDgaa2U
38268	payment	1397	1397	1678	1	1	14687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh4Uc2pMUPmQj22K5EMxsdMrr89nof3HiD3Abqzbz9X9T4tVS7
38269	payment	2134	2134	1874	1	1	5128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdnxoNsJMK7WsbxhWjWrSbnBVCXy1Ui8yWXSCh2k8dcHqnCoH
38270	payment	1397	1397	1678	1	1	14688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtwG1REivAQkHr6eDxA93tu3KYpkuHwkexn6HoVvxCJrE3xZQ
38271	payment	1397	1397	1678	1	1	14689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tzbTkbYzhuo94Pwv38cJTRKPHGwiajTD21ezJegf5WtNBJPN
38272	payment	1397	1397	1678	1	1	14690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMeao3HgyzKtKwg4kEGDxFdMmNsiKWanQxHh8oFYTKUTVUbC9
38273	payment	2134	2134	1874	1	1	5129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdNq6G8GHgs8PPcrgvNToEuWMu73vFbSJc5ns78mkKDuVNoDr
38274	payment	2134	2134	1874	1	1	5130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbydUThWt7pR55NcsFX1AWVLaFQh9cZWctkExTeo31F4PrUsao
38275	payment	2132	2132	1874	1	1	1401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQrZRnfWx823Y5jzNN9CfGsCLpYnwfY38bmVzXWEEDSsnsXVd
38287	payment	1397	1397	1678	1	1	14696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSYAgw3mNcSiNcbSMJF8QyDz64RXup6L5hfHcmVjkveeYrbtV2
38288	payment	2134	2134	1874	1	1	5136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYe2X7dcvMjAGtwqmpbLHxtQy3eW66yXRNEUtu9DGKPGPeXLn5
38289	payment	2132	2132	1874	1	1	1403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpFqCAXqXF1AUWRo9ofMJSQhWUGjSDD26ZUdXfCit8hLeLvLG
38331	payment	1397	1397	1678	1	1	14710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomJiiEWSySB69n3ggTt3cG7sXo8mSH8ri9a6xtzN7cUaYC5kr
38332	payment	2133	2133	1874	1	1	4669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGo8TzsA5E3fkpHcMisCwAK6zJMAh2tuJ8z2zp8Q2RbbSM39z
38333	payment	2134	2134	1874	1	1	5150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1A1K6B55XRBKECW3zb7jZraMTQGQcFzTHVbDGgfiVybKGr9S
38334	payment	2132	2132	1874	1	1	1407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqYHF1KHtZ8aDtiTRQQzrVevarKf91oJCNoMnbcn8VSGucvRE
38345	payment	1397	1397	1678	1	1	14713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbu5RshSYcgrtL7FvDpUCdxR63F7zRqAtCTmNLYd8W7iiFaKG9
38346	payment	2134	2134	1874	1	1	5154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPQ2eEj3Li3dW2YE2dShrfPegFAtu53DaLiFRM1eXEz9Nfi6F
38347	payment	2133	2133	1874	1	1	4673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKui3g9W4R2KDLLrk8P1C2R5FyyUyAFsQqErKWDLZ3XmtRUhs9
38354	payment	1397	1397	1678	1	1	14716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5B4V3WgZ88VNLwwahWiB3BKizzatnXadFr3NTLgWEc37rJMX6
38355	payment	2133	2133	1874	1	1	4676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyvZHEDvM3VYfTXX4TdaB9GxTpNbemTga4jorTkR8dJC2swB5
38356	payment	2132	2132	1874	1	1	1409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPGzrCd2qxLA92rs8HChwTHKj2DTmgcKYCr2Byn3Tv4pzFaJ2
38357	payment	2134	2134	1874	1	1	5156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5GheYk7CWq1c3h8EuTCWeDE772mMT3oUuyRvuLU4CiKAXvhK
38370	payment	1397	1397	1678	1	1	14719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rYyCr7yWBcJQYytrr1kuMggaJxSJvDR7r6YXYjcGZsdWj5Q9
38180	payment	2134	2134	1874	1	1	5090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKU14btLdoNajoeLHrGZkL4YaDwrsFUFZ5qMo6n4xAzgGeHhc
38181	payment	2134	2134	1874	1	1	5091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpbA6aUECCf3wvUNgKVNJ3qGvWH8qUk9rBzcTUGBJsePWUBcFa
38200	payment	1397	1397	1678	1	1	14658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvE12A5p8mgLNk9S4Buvr8cpDrtKQpu7LxzNusLqBeT7sq9oD6
38201	payment	2134	2134	1874	1	1	5099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmC9khpPfKyrLYwdx87ybYJ7dz7yHYsbYha4y36VJLjZofBWeo
38204	payment	1397	1397	1678	1	1	14660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmCgq6c62hVLVgmHjn6RqS7NcU51fe2ZYFQA8DpcuY3SnTCmCj
38205	payment	1397	1397	1678	1	1	14661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGwMYjxo47G7oDik6ZNFfmTK7wmVmJibWki3dB5fiwK4476FQC
38206	payment	2134	2134	1874	1	1	5101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU72GNm9Q9rMYpHne4gtrAmxC6LJfZ3ePKezBZdLYWBEHjyNGS
38207	payment	2132	2132	1874	1	1	1392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SwtqaFtBPgYfkRwohHnLTTopTkhEK2mMLyYLsKG3caqnUuuv
38208	payment	2134	2134	1874	1	1	5102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZraFCkbh2c1Y5YHyGhnGGezVthUNZEApzt44hrPheGKgeHkmY1
38216	payment	1397	1397	1678	1	1	14665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEXiSgy8ouLebzaS2vW1qXmU73SaE29XhB14GRHh15SpLmBe4
38217	payment	2134	2134	1874	1	1	5106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKMKxg7LDN7QxeFabM4YeQUScEjuGtZbXiZwWQb6xcGM7ngiH
38227	payment	1397	1397	1678	1	1	14670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzkYBwU3hQChM3QdAbtR7oiQMnyteCr2iubnJ8MvKyx4PGwsWL
38228	payment	2132	2132	1874	1	1	1395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwZFx9faz1J4dG4M3qD2RRuW2qkKyPtg1ghPK9zJBPWtu9TF8
38229	payment	2134	2134	1874	1	1	5111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrsyiVc84R2TGhX63Qhar5jtNejvwTkUPVyu9MyWBVVwDtdXK
38230	payment	1397	1397	1678	1	1	14671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT61BLNSKAkLF96nDv7KWQ1fZuHatWdnBHtwTvLAfU4oQSe4Ns
38231	payment	1397	1397	1678	1	1	14672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHBq2PAgYwC9nbReyzkFAfycWZRTCtcbQijUCCjDz8eV7Mqhzx
38232	payment	1397	1397	1678	1	1	14673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ku4YbTgHLBr7svkgLANGHe7R1p1bEWNRc4TBCSqLJpodHiZE
38233	payment	1397	1397	1678	1	1	14674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApDLcGNi7apsWk1toJQuVUg9iVzYWefhHWC2FpPa8QwiAxySF
38234	payment	2134	2134	1874	1	1	5112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrNdQka1YPBQF9nShBm9uePgvuypjWWPYk6UcFhtb6b4rvtAL
38235	payment	2134	2134	1874	1	1	5113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8krBPrgohSaviMHKgiaiahLwFEdfub5ywCrYwSz7BQphN1v3
38236	payment	2134	2134	1874	1	1	5114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXudt4YqGpN94nHmUciFpSx6EUEponDP3tZ6rMDB8cirQ28Mjc
38237	payment	2134	2134	1874	1	1	5115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnPCJUamynqdj4226QW16BzJx9tuY5YSDq5md5Q3jkVQVkEVt
38238	payment	2132	2132	1874	1	1	1396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXmLpmHKQKkwjZArWW5ZjaxYvKtEe9VKuUnhP3NS38pUJWFVo
38246	payment	1397	1397	1678	1	1	14678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xXFfQnGqvD7ommrNE76roT5TnxtXvmgNrvD7UfEQaDE74APV
38247	payment	2134	2134	1874	1	1	5119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZru3y4jiQiE7dYjimWkPfVKYAkJqPZWWZudV2ePXZpRxYjrLjk
38248	payment	1715	1715	2291	1	1	9	255757211465	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDUmPkVhMNrusiFoPYa551VArAocPJBq887DgGYU3ubw7t3XmR
38249	payment	1397	1397	1678	1	1	14679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgWSzXyLcGDSpoTDRztUC2CbFa8BWMX6YJjD7yhiVM3JgXEMk
38250	payment	1397	1397	1678	1	1	14680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXGfBEftagZTJMF6bBJ1oLyEimedxSoWh8x6v15zWu1VxbUhT
38251	payment	1397	1397	1678	1	1	14681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDccoz8odRkuUAALGxgX1BDVGLeofVzApRaVrCfVEJfwo1GYKk
38252	payment	2132	2132	1874	1	1	1398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBZiBeJeAeBNNWVRktUVRFQb5WV76UxMusy64j7vfHtaoSqCa
38253	payment	2134	2134	1874	1	1	5120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVfr5KMjKRubE2FfFq7JigPPyuHXHJAcugVxcGfyqhVM9mHhU
38254	payment	2134	2134	1874	1	1	5121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtrJCMqo4idXofKGXDwxjqkCvwGgSYkcWVn885KTuJS3HPQ7Hc
38255	payment	2134	2134	1874	1	1	5122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ewdfwwSxYfSYemZcfCgCqJtwBy5efSvKyxjBb16Jm2AzQ72a
38431	payment	1397	1397	1678	1	1	14736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqqGsv2YXUrYSf3hfuQw8Dtg8hATAsn4uri5kEGQrjsk5Bm1uo
38432	payment	2132	2132	1874	1	1	1415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYre8TurfJwwZKpm57TPiKn2SgauEAQAiwbssNGA9dfVa9xSoqr
38433	payment	1673	1673	1002	1	1	15	3286920000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpZGWWpf1zSRsa3zdtHqouA3wZDWPJE21CeRZiMwLRtETkhGi8Q1
38434	payment	2134	2134	1874	1	1	5175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTr9apfJSRiy9BWSFFXYJq4ZLogJQVXYcc3GbLxAkpUcyWaNXk
38435	payment	2133	2133	1874	1	1	4696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZugDvwSQ7qavFd8RvEA43H3ADH5m9nrUSGQtTkaK6LBM1SYK4E
38190	payment	2134	2134	1874	1	1	5094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5XgyJPDwR5XuyCfoezXnawFprmp6sUPPFsmY63QnApTFXe2M
38195	payment	1397	1397	1678	1	1	14656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVjJyRZYmxwq4dZEZCqtny1BRE6jDpUTR1wSPfBftugDVYvv5
38196	payment	1397	1397	1678	1	1	14657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5FY5zfZRTie6P3g1k78FHriH4efdJQLAK236F2oDKB6Ww3Yp
38197	payment	2134	2134	1874	1	1	5097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFL9gbhxws32w38xjysdWNU1r5mBtUgVrJvgWe6wLH21xgo6tx
38198	payment	2134	2134	1874	1	1	5098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhYJMnWUy9rffxetvTFEsYr6mWMesApjAbNLoWfuxKzdAgkbvv
38199	payment	2132	2132	1874	1	1	1391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDVFd1BsV76qfFkjZGiXPKbEyyaEu5ykHfU8C53Y1mw9F77FC
38209	payment	1397	1397	1678	1	1	14662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBqH7j6dt4EgHsyjqoDaQNMuztrcHDrxNbnHshoiemzfiN4Tp
38210	payment	2134	2134	1874	1	1	5103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6C7c88WcMqKNHhGYFiaxqoxGaXgScvkLpuiCnH8eTJ22rtEKE
38215	payment	2134	2134	1874	1	1	5105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpdmssLeT4bjBRDy8dw9qa98vmKgXhjGm6p1ng1Eb4yEjUE28
38218	payment	1397	1397	1678	1	1	14666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXGJw9sfCABLa234kPEVjKfpfUMTHXM166QbaPBD2Jnny9ut2
38219	payment	2132	2132	1874	1	1	1394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXiTCCdrcZsmSfMuxgHUBt7GmEoW1XZFR8CPh8P6CiPdD8EXw
38220	payment	2134	2134	1874	1	1	5107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JhoGR1RF8QTS8oVGbwbpR4SPNyBbNBKeqiuQXkFjcWuZfGHm
38223	payment	1397	1397	1678	1	1	14668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9D7BkTw9gXq8BL89NpP4msKJK9XC9VkhDLG8HJEj4mSZUUASU
38224	payment	1397	1397	1678	1	1	14669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtidssVBsHztXuZ6cQzhHAxYq16JDLY5iLn5ztN8WMQGCrJnqX
38225	payment	2134	2134	1874	1	1	5109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeRiMNcCpmffDqSfwVNq5gc5q1PaQswx53GbXXmDFpN9Y8PUr
38226	payment	2134	2134	1874	1	1	5110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wcze9zMcV8SogAdbqDpVCCdjUVzSPfQ1qRAVJVoRF7m4Xwd8
38244	payment	1397	1397	1678	1	1	14677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZjo4Xxixkrv4SGho2AmjsWSuFwqWybDXgLd45k8PYWR3VJbw
38245	payment	2134	2134	1874	1	1	5118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3oioJrbC2zobEiq2J2qAruzEkdLJAH1BG34rFdY4evLwwshB
38261	payment	1397	1397	1678	1	1	14684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpsaN8nUrEdBEtNKQKptEvNJ95WYJEMcScGwvNp6vpuG7hC91
38262	payment	1397	1397	1678	1	1	14685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrayC7858A3rqRwFGE8H48anxawoZfPivwucTiE31rEbQ3XU3
38263	payment	1397	1397	1678	1	1	14686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzq2SjNSPc1LKVUoxVLretEwRmT56vTbe3sgstFu3v47BkgmD
38264	payment	2134	2134	1874	1	1	5125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdvGR9b8Gf6FuJJj1N3dwSa6ppiUe5WZWULJ4RwtujAPfp1bPk
38265	payment	2132	2132	1874	1	1	1400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuCaMFwTpcFijUK2HBKJeDec3SzXXVVAMZaeJuYMkcRDMzNab
38266	payment	2134	2134	1874	1	1	5126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoPL5DSfMD82afmyUn3EsH2TwygQd4ozVFEUbqSmR8aRdEg1HZ
38267	payment	2134	2134	1874	1	1	5127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERyX8bbG33sAoqgDYCidjAYsmuZ6ka77Vib5gp7PFhUzBmutz
38283	payment	1397	1397	1678	1	1	14694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBFzn73VZgMNAUQC2Fr1iZML6tcWR4FpuCaqrtvKdKsjY4wir
38284	payment	2134	2134	1874	1	1	5134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehL93ajdTa25ff9E5Tv55D1yE9Z6cddazzqRx4EdsnUkdbqC8
38285	payment	1397	1397	1678	1	1	14695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8v62GJoKHi1ZFaFhtfqqZzCAMEewtiE6VaT3ppNYpeoeSEjw
38286	payment	2134	2134	1874	1	1	5135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdzrcGrSThefNh24wPs18qa6UQdmpV6BZLuVSKwSYwfA8RaFq
38290	payment	1397	1397	1678	1	1	14697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwdLG2x1xVfgucS2izHjb6KdjYq5VDi4b7gKqa2pVcNpGvtHYN
38291	payment	1588	1588	2068	1	1	6	934000000000	10000000	\N	E4YTEw9DPJsj5rGzuVMgYiqfxkCZif3yXuBN2Ey1bTHC34hmeEdX7	CkpZjFr4U4tQTCxZwBmthxsif2vYJjNLtEimYDFT9aD1tgAsFXtnd
38292	payment	2134	2134	1874	1	1	5137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyvJdfFTU2xX14yg1fsWg5Cik1dVuz1FxwuDRLsnxBYRSYN9M
38293	payment	1397	1397	1678	1	1	14698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXBhDotVasHmU4aQNPV2NtvcC4h7e3A9M376VySCsg4vLHLHJ
38294	payment	2134	2134	1874	1	1	5138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwsNnpbF6BXiMF647HqKA5pma2DZabBJ6ATvW2kCQW7cX3tvF
38302	payment	1397	1397	1678	1	1	14701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Jhm2bsbRGcSjgs5KBhrMToXLxDmBJakkrrHBhDaKHNwaTxjF
38303	payment	2134	2134	1874	1	1	5141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXycFFyCBRpsExVEQUguFLvL5dp3EYbgoRxPrLv8HjjP5RmPLB
38304	payment	2133	2133	1874	1	1	4660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsJRSfnUWGyPZCMSFGe9ExQ3DSvmQTkBAALSQdehwgX61p15a
38305	payment	1397	1397	1678	1	1	14702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAS7jZLvyb1SH8tz7a3TVNX9SzRuPS6Gao6Zhc97i3ehUz9fnW
38280	payment	2132	2132	1874	1	1	1402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73d5VgD7ykKtqoqr3wCDL13h5VJFe1fp6xHX9byrSoKBJq1Yq
38281	payment	2134	2134	1874	1	1	5132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFw6V1ffRNLY8UvX7XqS3BPrM6ixkSqhY5gXgdNnyaQ8AnTWi
38282	payment	2134	2134	1874	1	1	5133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bP3c72a5XcShUmQRMhMj5TeZZaWgsoEVyqfcZLHX2g3cFppD
38295	payment	1397	1397	1678	1	1	14699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtdohv91NtoCKapDJzgYifQgbEwD66iAKWm8mwiwL4XaJVYi1
38296	payment	1397	1397	1678	1	1	14700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE6xs9DaRALJGZ6pd7b9vpNGGdZHijpKZTrmYsQLxTDPT36Av2
38297	payment	2133	2133	1874	1	1	4658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9VuUhYe7g7b3iZUdLdtDhjfqCe1pY4TBzAJKkopi4koRHkTwo
38298	payment	2132	2132	1874	1	1	1404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5EX8DDcqVmJd63Rr59zU9j7TPgqD3dw4oGdTWCPX2Qyefcx2
38299	payment	2134	2134	1874	1	1	5139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfz7pRsnWm1WuqwW9fmhCzjDSgQiJKT5vdpchh6RQZbRUwCYuM
38300	payment	2134	2134	1874	1	1	5140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAzMw4JfRrYhxs7eFZmK6uTNLr6uCtph3pydmeFv9uFKe4Ps5
38301	payment	2133	2133	1874	1	1	4659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRBfBpmZK8zr7kRfk4ibHiMwjf1EQ3VTYLxLJWugr77tjKBt7
38328	payment	1397	1397	1678	1	1	14709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwrsVVr59edzPDeDncxQYY3meAAAGJhhY16M3CeEweg9dUcf9
38329	payment	2133	2133	1874	1	1	4668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2LEt4J9RQkDVG374aBJg5k5qLiHBtuYSe4DJMPaY8TjTxzDg
38330	payment	2134	2134	1874	1	1	5149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zdUqo2Z9jqBw587bdzb79E1DF1AD9aJCsv7R33ZSZREoC3aH
38335	payment	1715	1715	2288	1	1	10	255757211465	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjpgXpu4mfCGWDHi2ixsSinCGG1kZdzvNLkt6GKp7wGkoBxkG
38336	payment	1397	1397	1678	1	1	14711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckpwNdSb3zsMw3PjhjquyJQAqYUha53bKfQEcxL8vCrzbTArW
38337	payment	1397	1397	1678	1	1	14712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2mBoyPxNRxPCCvDzvNeU4NLussyWmNtyXZzPkSYmy2s2dRtZ
38338	payment	2134	2134	1874	1	1	5151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cqo5YRNjvx2h1paenhvbBqziEFj9rsQk774ngYxvhXeEzgrg
38339	payment	2133	2133	1874	1	1	4670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMQmHa6sZY2BMiwXfkhcE67N5ce8axGK6ndxwpisZTJ8vtWXD
38340	payment	2133	2133	1874	1	1	4671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZD9AXdErZccnVWUjPUVix2eYS9ZaPWgSAzpbzv8QXteAqooB9
38341	payment	2133	2133	1874	1	1	4672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXuDPXhMLkqFyhiE67zFxBB3PD2tQMFSkXcVASvMLQUnBU6vf
38342	payment	2132	2132	1874	1	1	1408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7SFkZ5VG2vxKxsKwvpNbPxUcSD1b9g1VAEP3nvFCb6x81kwB
38343	payment	2134	2134	1874	1	1	5152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3PGykWKdY714cxftsX7uBJ858SC6MRpY3i69Lx1eRzr2WmDD
38344	payment	2134	2134	1874	1	1	5153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9ERz6UJvvArGPhSRASrHcmBfQcztSwDRJMjPJAjUuywJvmPz
38348	payment	1715	1715	50	1	1	11	255757211465	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxRRmY3EZum3G6WogJUdTxFcBse6jxtoDTeVD6hWxQdcYdqWb
38349	payment	1397	1397	1678	1	1	14714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpKVBRMTti5ME3H6F9E8V9Xvd6H6CxY3Fv6ZDXSqB9pnbteLnQ
38350	payment	1397	1397	1678	1	1	14715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtyRjSDQ9T6bqzDhFGUvcXDEKPuVeTFtJAxfKQhFgCJTvBk7v
38351	payment	2134	2134	1874	1	1	5155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnDB8P7hPmZhG1vZUgWMTVdVWkTAPA1ntS2JQ55v13AWoWSYB
38352	payment	2133	2133	1874	1	1	4674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GB97mW6q2DdHLU5HvxJno87H5yzoUETib7iDyS8hPURdvZXv
38353	payment	2133	2133	1874	1	1	4675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXP5o4FMDgm6bmsYMMGennxmcb3ajnMfAJMbYEbEKMvtVF9Hm
38358	payment	1467	1467	1010	1	1	4	2318317728055	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpYt4ACZCrPWwvmQkrveFY5W8TZVSzHavYurcEAooPR6RWPMdY52
38359	payment	1467	1467	1130	1	1	5	4154405505340	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpYqFyZSxpU3F3bY39KEv1mCMhbinMUs5j2mLxmcD4sy9ViMpi6o
38360	payment	1397	1397	1678	1	1	14717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQY276NSxKKYB4qW34WkV4iXBzwtG88rTx77MSBPZKGxKTDh3
38361	payment	1467	1467	1250	1	1	6	2803060176825	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	Ckpa1i2M4L86WHVNMJ9mNMsEXzmfDXveX9mZGNfgw1MwHbRboSXqp
38362	payment	1467	1467	1376	1	1	7	7810976416950	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	Ckpa3PjQUM2a18bMUCx1U9D8SRYUXBZKQAmMGDAx9HGUxXVDkft2C
38363	payment	1467	1467	1467	1	1	8	13370322795	10000000	\N	E4Z6enx6fSyP5VjJTKeeCVSRVRyni3RN5MztMZ36WqsPB9LqtWskZ	CkpZrgM6U5r47zde3BvaaDaBifbvFE1ZMphKroo4pyBNz6jrXKEZj
38364	payment	2134	2134	1874	1	1	5157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBN5EGYBfph2ygxpxtVDuxPZ2V7sH57BAgf1YK17RmTnfu8Eik
38365	payment	2133	2133	1874	1	1	4677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25sJJP6HFMWrdb4qjpk1yL7NxtJxRQU6UbAo3qmEcjPh35Vxj
38378	payment	1715	1715	1246	1	1	14	2236874141124	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgN9N5aAGtprBqkrN6aY8nYNk6dPqHXmxnJm4mosWGq14FTKWm
38306	payment	2133	2133	1874	1	1	4661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCQE5z63cZMRyo8njiRE14jsHa4QNk97YNSiccrcrKpYkrvre
38307	payment	2134	2134	1874	1	1	5142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznEAUC6dPqX6pETNE7HetPhumif12LRZCsdnu5hvegWH7Wtai
38308	payment	1397	1397	1678	1	1	14703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUENCtdUTdm755AJpJicDg6neZUprMkRXADf76VRb1PjFet2Kk
38309	payment	1397	1397	1678	1	1	14704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbE7dr7W4qJbfTNyexDf1xiZqRAjcpQEpYiyNWpHq3KAY8fWD
38310	payment	1397	1397	1678	1	1	14705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYge3BU2Cf3irWZFGruveNEoqcKcW1YemnBeMPCJW3PSPejhEf4
38311	payment	1397	1397	1678	1	1	14706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzsVTRczc3dx9YQCk4ZJSqWyq93aZi9ApRDFGRowNfSrhq2xGM
38312	payment	1397	1397	1678	1	1	14707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhDknmp98kQsx9vFV7NzYyWrs99K4yMAP73NzV7CNU9kiH8oY
38313	payment	2134	2134	1874	1	1	5143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQpbWm1o76esKk9KscsaffSdWivjzhEtD7AkG8jDdQekmK6Q5
38314	payment	2132	2132	1874	1	1	1405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22xXCwBWxXqGttLmL46ZSeyf195vy6xaVCVdQqmVxTxXg9p8B
38315	payment	2132	2132	1874	1	1	1406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmPVLodkyfPfKyEbicRMvnMT7aRDQ87CsM9qA79M1JMiXmd9q
38316	payment	2134	2134	1874	1	1	5144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2g9P45ecG4XP1ZVGuiKFhEkSiMYNGrwfSf5UoayQQrwDsSD71
38317	payment	2134	2134	1874	1	1	5145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyyoscZjNfWPeBZEPgBpU8dtrmpvj5XwEqGjXUbaP8vcQFLeC
38318	payment	2134	2134	1874	1	1	5146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCobBAoSAhf5Te86GPCGm5KUbiSHy5ukH8xyK453anqgNS79FG
38319	payment	2134	2134	1874	1	1	5147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEj1p9w4EEX4unoMXGb7a8yaSmQX6qfL9wnvK1tfTFHN13qzgH
38320	payment	2133	2133	1874	1	1	4662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVt9i2GF1sx6KkkHSZyL4fswrqzX3qyiy3pQJ3AqMcU6EfZ6N
38321	payment	2133	2133	1874	1	1	4663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazKG6uxb42BWvbMkNPhVrPDJbzHZ5wVUVrmeZAEswUccHfNyB
38322	payment	2133	2133	1874	1	1	4664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHTpc6kWwobJNX6HVxXxibdkCJqCpEYp6HdzBRn5T6Czbq8rKt
38323	payment	2133	2133	1874	1	1	4665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgrVBY7WHVi9j3EguFsDRDLRDheTStYJRJoYhEmd5zBFh48XN
38324	payment	2133	2133	1874	1	1	4666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMksVmUi3rxXoTxdsVp19yTbtUePrw38TEYsWmuoJghsV44xd
38325	payment	1397	1397	1678	1	1	14708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVx45WURrcmFwjJ2et5RSWrEDP5y89NL7LfWDJ9ce5FLtATTJ
38326	payment	2134	2134	1874	1	1	5148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9HCTubNxrNLhMyvgE87aA1Ee9XUu7SPfVUoURMmXBRMAvvYm
38327	payment	2133	2133	1874	1	1	4667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFoRKKxWxd1gidW59qaiCjdVhMXQEBBSxJqdA1jAkiWz7h6zP
38366	payment	1715	1715	1006	1	1	12	1850044112385	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfQM8oGSUxbM6qaEBNyvKdjVvZfTQJTpue9fwhCRdArYo7F9kE
38367	payment	1397	1397	1678	1	1	14718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJ55GVnDjyVQowUvgRg8gn7TCLH2ZnHTjCX4gWy8ukjUz4sZa
38368	payment	2133	2133	1874	1	1	4678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8V224Q5hReHqpLuJvxGTGeTfxvJLUuSDkUxtXELgznXCfadq
38369	payment	2134	2134	1874	1	1	5158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVqfuQeZM8zy1LBrMntQg7p2cinzfywaLpoE1fXiL6apBWtSy
38374	payment	1715	1715	1126	1	1	13	3315263198226	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TBCX4mzimDmX31UKpJn27hekXuKkEWgdb3xtZ2PAK7vybg46
38375	payment	1397	1397	1678	1	1	14720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEShx2bzLbRmhzfqy8fh1E5EcWHUW1obtH7AhBKyCrtSvHyjuK
38376	payment	2133	2133	1874	1	1	4680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5vqTqVoXvTRuZmQhPHwyajqxpEtQuPxAzxaCL9bXLkXvaaBQ
38377	payment	2134	2134	1874	1	1	5160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNR9RzFY3yWSrkSw3rxwAmF3c8E1SzduGjPKSSukTWHk8rJdv
38390	payment	1397	1397	1678	1	1	14724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3ghqgXLcLvky2uUSeqQSzYTdT2cqo5tCrJ2rxSMzWFowe2sF
38391	payment	2134	2134	1874	1	1	5164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuKhTXuuoQx1auy97HoBUJUQajQGg99aRNW1xLiz9PcaMcN3w
38392	payment	2133	2133	1874	1	1	4684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBSkUTsjiDC6Kfy8wp9PYqnzUeJ973wiAHZMc7EqSZCyntGC6
38393	payment	1397	1397	1678	1	1	14725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhaS1VsY7URNMP2LFYYeWwFsBF2qMKcbmkyF5SRyDrFj827K4
38394	payment	2133	2133	1874	1	1	4685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXvVtyEzX7in3X3QQhgY4M5f65qLiuKgLVByqg8TwHcAhfEHd
38395	payment	2134	2134	1874	1	1	5165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqc9B7w6euFMKaNSceTKFvUmPpTa1TxNwAPUeNfmsVSdvvhCrK
38401	payment	1397	1397	1678	1	1	14727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPQi2rXyrDWETViqSSgeK4P7GjxyPjJ1gz9QnDcvXQndU9kuoB
38402	payment	1397	1397	1678	1	1	14728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkesnC68LmarJrnCghqVp2NgBT2A9wA9jWP6RED5C6hR3UDXdM
38371	payment	2134	2134	1874	1	1	5159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBbgfKBiDRd4wqtEvkhvAaAdn25A1YLa33TuJiazcENB1qmTU
38372	payment	2132	2132	1874	1	1	1410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVom5HxgMAcjzddcmvNBnBhpXZ6zB1pd9zjxVRL5k7a6b6g9wQ
38373	payment	2133	2133	1874	1	1	4679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgWcEvaxcpTXWRwMjaFWSynUH7QDWzWFgbVVwAYHHVqvSuqMd
38387	payment	1397	1397	1678	1	1	14723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5PuomYPTxdt1NWCB7wEksmpaQ1XsSHW8SBYPBQg1U4N3HjbN
38388	payment	2133	2133	1874	1	1	4683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxNERV8pUAqh9bG7UUGQxh72tyLHkPyS5pBSZvsRPsmEK4pck
38389	payment	2134	2134	1874	1	1	5163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2Ru3j3Pujpa1gyN5RDVmWXLGQQNxG9Spgh54pkpWGfm8PeGd
38396	payment	1397	1397	1678	1	1	14726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkJ6k8GfpjLMS2edyEhk8mAmd1HjRD5VoP8RiGNYPXBYdxGRo
38397	payment	2134	2134	1874	1	1	5166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDKWaMtuPAfZ5bTWARxHvaNcdgr6EtP466K1WpPLAhrBLwWu1
38398	payment	2132	2132	1874	1	1	1412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbE3NtWK2MSD9mJa5TyAyshguyiDquyj673nCsJk8ya6jY9fU
38399	payment	2133	2133	1874	1	1	4686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFHDXkjWwf63Hhn4cqFAXktCTt2gWBKVD5yo8YNPCw3NQ1pu9i
38424	payment	1397	1397	1678	1	1	14734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnkmp92zuJKYZkwfszevMpVPfTpvBu896mH48R1tGnTu11Cq8n
38425	payment	2134	2134	1874	1	1	5173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnAvAqfDNFfGnb72RtWMoKK9WGPteQGnkNP7A31S6CLyXUZMf
38426	payment	2133	2133	1874	1	1	4694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbks7USixkKQA7hLs44zSzDdTzRF4NQUnPM692cmLDg6fXMNr8
38427	payment	1673	1673	1242	1	1	14	3974190000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpaFZM7Q4bExCZsw13U8nFVLLEH4kmmFrh6mGpVTokFYE2UCwEWd
38428	payment	1397	1397	1678	1	1	14735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhE6U5bw5976D128KA8ois6dQr1kPU98T4N9itcFgqQNLKLec
38429	payment	2133	2133	1874	1	1	4695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DzQdv7a4RyUCMrJBv2EfCwkFJFk1jRfZ2H59vZQAhvfCuoC8
38430	payment	2134	2134	1874	1	1	5174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8aPZWACqWEPcGSww2MgEsbPq1BzYMN9S6H3183bt31237jdfx
38463	payment	1397	1397	1678	1	1	14745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkpfDJ34CcX7a2xgE4PBEpQEypEM6ndV9EpoY5k8WYMhUu8n7
38464	payment	2134	2134	1874	1	1	5184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVF1SGzYbA97T6HuohdqhHUFmq6SeYNXQX9dLN3cSXtdLimcZ
38465	payment	2133	2133	1874	1	1	4705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaUktiEgf6kbhKyia5fWQqSTkkHHZk5ihSFTK5tbLWXyqdW17d
38466	payment	1673	1673	756	1	1	17	6540000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	Ckpa1W61kvGYT8ykyZrpP2dv8P9RCRKCXTevV9i4uXExjwgHXphe6
38490	payment	1397	1397	1678	1	1	14751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuk26BKqd2eCn7WT8nRmAJTtvcs9poTvntfqRLcbj5zZ3VsF2w
38491	payment	1693	1693	301	1	1	1124	75500642221	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa3m6BQh7uVWhPKJ6rUTvXgjvs6GqvKV5tVMXo72ipYri5JKxSu
38492	payment	1693	1693	339	1	1	1125	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZJ4r6cuz6VcHRXs48PyCC9bGoph7saKV32Y6pPdrY72q3rSrtS
38493	payment	1693	1693	601	1	1	1126	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZpozUBxJKvzYECUCZqc5vzQfoPTdx36v6scjxwTpEkSEsPe44V
38494	payment	1693	1693	1821	1	1	1127	76205579462	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ5QZdAFqi2Kcc6GfwGxzM8PVG9rG89GvsF7EBppCiSdSysq8tG
38495	payment	2134	2134	1874	1	1	5189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWnXZCiaFLTA6MbEdZwhRxjfWAZDm5CD82qXmaovgCdn3dmRZ
38496	payment	2133	2133	1874	1	1	4711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFCCkzo9HHo85M52MdBmEGPd6ZF7N9QYKH4Q1T5hL8qrL2XcZ
38497	payment	1693	1693	408	1	1	1128	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYdb1QaDy5zxeNKqbz7RcacxkGULBN911UNZQGkrdpRX5uvYib4
38498	payment	1397	1397	1678	1	1	14752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNEa8bKtqYitMf9B7E8qMa9GvdjQt5Gj8xNPcpFmgbyzdh4Ln
38499	payment	1397	1397	1678	1	1	14753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPvx29h3NmnVeF7Ka3BEmPLaEJHr6PerQDPEdzNipCtzMDYtR
38500	payment	1397	1397	1678	1	1	14754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFtUFcKMjnPfUQ8899nj22v8o9xMLgvSBWigA8vUhtn2t6Q6S
38501	payment	1693	1693	322	1	1	1129	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGfVAH8sHRKKCFKAH5Hep3NdoPA4skEGKS6FsYwGvGXoA8AAT8
38502	payment	1693	1693	10	1	1	1130	37245551582	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZGhs9LBDih4sZ15ZdngDk4VUc4fF3jwPsiVFLFDQKNQZRZiRJ7
38503	payment	1693	1693	450	1	1	1131	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ67Ly6SyVMMrBfH2yU35tYzuKHaqZiEyAmJtZ99pr9J8w4Qjff
38504	payment	1693	1693	366	1	1	1132	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa8GoPcaHwryA7tvVJjPfikSxiz88LoHD3CoK2webUGzCMhMP9X
38505	payment	1693	1693	587	1	1	1133	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ3wxoZfZSHLBmCuWWfAH1T9WBiMaoZVt6TZtws4eXYUHfEgc57
38506	payment	1693	1693	500	1	1	1134	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYqfrHrgQHH1MHfHwmuaPvkn4C5FFt1MqXnq2T7u7uUdHpTcP77
38379	payment	1715	1715	1372	1	1	15	6233248686021	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq676wnvjgsaYKQ5xPP4yNYpFkvXEJPQPcfWXiYXjonw3DpEpn
38380	payment	1397	1397	1678	1	1	14721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdr2Fbfg1BhhphqMbrP2tycuWVQE8EcG13VtvKtK59Bd7mG6BV
38381	payment	1397	1397	1678	1	1	14722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKZC8N3WUkves8CjjFgz9hkk2zNLrBr85mP7k31eixwm2b6ww
38382	payment	2133	2133	1874	1	1	4681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RhPedfPh7Xm7WZntL5ioyioh9k7ynXA7uvvDUT8Qirwd7Cy8
38383	payment	2133	2133	1874	1	1	4682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsRkzES6c3959Qo954pvCPBct1RFjSQZt1BakzeJ8UxSMPmf2
38384	payment	2134	2134	1874	1	1	5161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZES3FmhufAVcYAQ9oLaCAFhVTYYYqKhbGsbFn1J9RNs7rdjVYv
38385	payment	2134	2134	1874	1	1	5162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2X6sfdYsxVBZ6zHnU7pnJK1ev384xwTk4nPZNCcUiekvpQhfZ
38386	payment	2132	2132	1874	1	1	1411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRHjEUt8PnrDCeQFh4rxEeJgZsHUsZJLWy2fsc6ueZ3zzVNcP
38400	payment	2133	2133	1874	1	1	4687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhg6GoNQBybUrBZsFZZP8J6ZKFbkSV4Ry99AFXGwtaLs3NbDVx
38450	payment	1397	1397	1678	1	1	14741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqm6sRskxvKXhXu5AEQVJ4aPGtk15bJkVSPEb4BmBW62ZkEPLC
38451	payment	2133	2133	1874	1	1	4701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW9KMHSphpYGYjTQ8kKyCm9jda96s8ALcaonj1tMErDtpBK9T3
38452	payment	2134	2134	1874	1	1	5180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95Tt7GtzDuTC7UCfLH5ryxusnYARsQqJ2FH4wfCgUyw6VJMPi
38453	payment	1397	1397	1678	1	1	14742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoYqf1SnJJ2QJitm6HPW6vuhibeXoMLGfY8yFqXhbNF43XShE
38454	payment	1397	1397	1678	1	1	14743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY3z8BRaUmox8krbLdYH4aWbQaG815RvD9rtaLBsDhLspUX6Fs
38455	payment	1397	1397	1678	1	1	14744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7fphyHHqe6NR1nin5Q2zBEnFFpyb2fDhYPfEj184yJ5N6uhkQ
38456	payment	2132	2132	1874	1	1	1417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ca8QHDGbR3VLmrk5gjAvbQ86WqY1vHCBLFXgt9rpzK8hCXC9
38457	payment	2133	2133	1874	1	1	4702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXbUAv6jpBoTmUj7fBQSpuzLXo3MeDGVSQYNhCyTtwio1nzr1
38458	payment	2133	2133	1874	1	1	4703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZuwbZhnSCGjK1Mby5FUnXZybRKpQfvBr7PKYDqkBNDZvdoYk
38459	payment	2133	2133	1874	1	1	4704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRRscoiewrgEeznXG8du8zipGLkuyfhEGtUX3hyjajynemKNu
38460	payment	2134	2134	1874	1	1	5181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPchjRPtK7RvJfVyJRtj2LB2Xv51cfDKaMWVn5tnWxu3bNh7q
38461	payment	2134	2134	1874	1	1	5182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUJQtUxdmkNdtGB6T76aD6aqp5rAMx5Wb9pV1bNGfB4CS6tqF
38462	payment	2134	2134	1874	1	1	5183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDc9FWGrnHadhqhxnHnCRaji6wG6iHg1TmLwGNYUBiuAGx4gok
38467	payment	1397	1397	1678	1	1	14746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkc1Jq4A3zSFMaCL3bow9ePMh9zQAwRBRAMgKKUh6Y57ZB4yPa
38468	payment	2133	2133	1874	1	1	4706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKbXmygQnawtiRw85uBRD4DTXMgW7c8jCg4MREsSv2wy6gRJa
38469	payment	2132	2132	1874	1	1	1418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9LULRyCB9rDoDPTou98jf9FSomZuyb5UoT1LDc2WzjCf1BHJ
38470	payment	2134	2134	1874	1	1	5185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi5LtbJgsrvnkrNGkdbAYWgtCxaKaE1SRSZqFiskvVdE21p6Nb
38482	payment	1397	1397	1678	1	1	14750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbjKxwsKNANSvDiniU6HU8koqM2bkcrgUtRKg5ZPQMk2TbxjY
38483	payment	1693	1693	1811	1	1	1119	208337588999	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZnHV8Fo4tNNLMaLwV2QDpkdHAFsNBwxJ775yKFgaZ2XiEHWfxz
38484	payment	1693	1693	283	1	1	1120	75500642221	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYUpyTz5Ln5ygnL3fjB5dhn9bqNAzex32vgMyfq18NtCnSV6REV
38485	payment	1693	1693	308	1	1	1121	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYYiMMrfRq5ATHC5NM6SkrvfWN8zMZjUmSbumXNYW7xBQP31C2H
38486	payment	1693	1693	186	1	1	1122	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYpCGU2uhwz9UQrMCenWTCAtcXAr3w6hJFnBQnfGwWwXtxMtXbd
38487	payment	1693	1693	392	1	1	1123	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ2ADiaeRFpFCSVHUWWb1qngdnFa2ituGcNh8nQEmZs2XN1simC
38488	payment	2133	2133	1874	1	1	4710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEPAqePtAQ2VrXEitUfvSJiRT3zSBJReuoJXanT1snfVXm5Zra
38489	payment	2134	2134	1874	1	1	5188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGtHji1unaXyBdKzHEavV96bZAXkRp9b47LHHTD6SvJRHPpZCL
38643	payment	1693	1693	1961	1	1	1210	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYex8rgt6bspkFWoxrmCa7stG67oubHmPzWvjmiKsFNiYgwza8W
38644	payment	1397	1397	1678	1	1	14772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZitEtjCYsmfpAaMaSwd8gtXKWWkhLUGi8beVUoCTQ3EVJzJgM
38645	payment	1693	1693	658	1	1	1211	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaDLkKTifi2kjsFPanNnNn1Yk2HpHejHFPoz34BdCBrtFv1sMHm
38646	payment	1693	1693	240	1	1	1212	75501340026	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZBnroWBzY8BJ3CoAhyrUbatfzTo8fVPBB4to3MSNyaBBH58Lqt
38403	payment	2134	2134	1874	1	1	5167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckJvemfv9g2YvkohXBzZvF7iNo2A73LR5Bgrn4sWDrRQuNo3o
38404	payment	2133	2133	1874	1	1	4688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZwFfaGzebm4KSx7NfjFzemphSY7FZqAksTKqByYzugH7FFmB
38405	payment	1397	1397	1678	1	1	14729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ABRUq9KuXxCWRbfacsN5ya6iir9ULm9r8JRZkktYmbtQPdKv
38406	payment	2132	2132	1874	1	1	1413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRmxVsRsuTzU7p5uLmigosBG15GLjGb6W8FEVMDFCe2Gwcw97
38407	payment	2134	2134	1874	1	1	5168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJ3zAVG53AadrGUUN36m7zrLBxFqq8AbL7GtMA72o3seh8tiN
38408	payment	2133	2133	1874	1	1	4689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7385tcTNLhsYG3zia5XN8JNPUVJ2K6xduVUSJLqTu3fBhRdLy
38409	payment	1397	1397	1678	1	1	14730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDuTcKXWVpu1K5GCcnW77iaFkHF6TaPn3fERFvfLtk8vzP8JJ1
38410	payment	1397	1397	1678	1	1	14731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CbY3cVTMS24Hsyd4bQdSk8NJ4ACFuw8kidDXpEB9KcZ8Sd2T
38411	payment	1397	1397	1678	1	1	14732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdPZotqfaiwzbPzTkCV78PCroHQmqiVPVDhb9sBi1fPqL8HmBY
38412	payment	1673	1673	1368	1	1	12	11074430000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpYanzzL3u29vFTXnFkTLrhsCEWkUDhy3NFKtPgKQB2Psy7e17tN
38413	payment	2132	2132	1874	1	1	1414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXwcC8sxB9Wq9QxsvM7trfURmgBnHzBjXuTxRKBDmhs3xfHFm
38414	payment	1673	1673	1122	1	1	13	5890130000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpZ3gRoz8nX8L213gvMih6MXgQUsdxpEy9GtNNtxn9fYw6ynDXc6
38415	payment	2134	2134	1874	1	1	5169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVbrzux5n5kgRNXDQRp7KH5YFAsP7pu6oJ1AxyXEvjmxkh8ie
38416	payment	2134	2134	1874	1	1	5170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkPASQE2NNvnTpFt6v5axCRngbiU6doApcWxUiHbfSdPSYAyWs
38417	payment	2134	2134	1874	1	1	5171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezvvTkbd8MkQc8xpY6woG4LYWvgQEMdnSBzbbSCd6icEaR2kN
38418	payment	2133	2133	1874	1	1	4690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQT3bRSXGvZbSawJTiaYB63LNSjNP8cWNhPP1HvFytDzMpGT2z
38419	payment	2133	2133	1874	1	1	4691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7kpbLB5djnfZRpFMAXhGEHjWQwKMHfVvcADZsTEued1GzDnW
38420	payment	2133	2133	1874	1	1	4692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANrkNJtAWXZYuZi7WpqyB6wN7uc4mPWdsM4ADvrUEQBZBQ6Jm
38421	payment	1397	1397	1678	1	1	14733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9PenFngr6aUYaaNXBVHFutGtT3kSX1qCRw3zBxWE5aitnYMtK
38422	payment	2134	2134	1874	1	1	5172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmptB2UnbXobxD4G88NeXusvqo8TuYiSDeq6bJ4zNmYNpMoD9
38423	payment	2133	2133	1874	1	1	4693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnaRE3U2ReMC7QCYkMgU6uXTqAo7Dgw6k5JMcrVnQoZ4xibov
38436	payment	1397	1397	1678	1	1	14737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdFt8VCudYQGEstV1WBBFqdTGcpsuSiWQPjpqJ8F4D7MGjQecp
38437	payment	2134	2134	1874	1	1	5176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XVikWP3XvyGfEVgutLyJKuRgEzAmRjHUHM22HgFjXymueKfm
38438	payment	2133	2133	1874	1	1	4697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VFq55snQ7ew8uyUAFJ392aKMy6qWAFYiKB7JnB7gqE8GxUZk
38439	payment	1397	1397	1678	1	1	14738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4Wz6G8uynnXEW9DYxKXk5FPcVaiydVDaUK4dhrYH5jUjbJJs
38440	payment	1397	1397	1678	1	1	14739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwdE2gLvkFCKLrkz5F77GxvancqrBf6KDVQJdgTMLx35czpK8s
38441	payment	1397	1397	1678	1	1	14740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVscLFx7mWAwijA9GAz5vzfha5ikFUsbXpG9BKitryxdiKXv4
38442	payment	2132	2132	1874	1	1	1416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPd1GSVy64m8uhGbB2UXSSJZhP8ZvLN4V7ZWzWtxrb7zqyjXF
38443	payment	1673	1673	23	1	1	16	213080000000	1000000	\N	E4Z2WL7Rj8NjhUjvLNHVDFc9RjePwH3a89d6qTF1LjAMnGwQXXU4A	CkpYkBvath6ELPRmqr3NkPyi9e7Ror6gLM6SKU7UEUPjB9tNgTjYZ
38444	payment	2134	2134	1874	1	1	5177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdBsFqBBCtCuD49qnUGVMzsKbFkDxk8EDX3xLQjVERSL11Fr9
38445	payment	2134	2134	1874	1	1	5178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BGLyMQbP6ErVMewRCyNLXQG2p25dVwthXb8VCmvEfeo5j6ZG
38446	payment	2134	2134	1874	1	1	5179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55QGcykwcAiPF12ZV3WXvLusDGCR42rg1gVkBDVjVUxTaeLuB
38447	payment	2133	2133	1874	1	1	4698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9V3N2SiRRXUAbAVm11MBmvwSgm3UyMvcmfdndPLwjRcATwqj
38448	payment	2133	2133	1874	1	1	4699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfhP4VZMurx19Umc7wfJd26R3waWT6vUdpBoxdX7XEJWbd7zo
38449	payment	2133	2133	1874	1	1	4700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpTWv7Sdbb7kRMVn7mdi3XDLZLViFm2ssZinMRCUuDzhcMCJA
38471	payment	1397	1397	1678	1	1	14747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i63eGqN71oKDAL1BXh5BCbD2dCfCAL37W3PUnn2LPGYyKiYW
38472	payment	1397	1397	1678	1	1	14748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEzuqFJ6CQ1tCgVkfXN1f93z7yBVni795JyRBwvda32ixiifF
38473	payment	2133	2133	1874	1	1	4707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9jQUG5bjs2W92pg7atz5QbcqbRVmSh1SyL7htWmeE622xKwr
38474	payment	2133	2133	1874	1	1	4708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5cec9ZvQWyLpbmDqnLYJiyLCvP2JdQV73r7PWbYaoqhBRGjc
38475	payment	2134	2134	1874	1	1	5186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz13WUwgC7hNteqP23GXAqZGkHxk3KeyxcspT244gZjz9KH6yb
38476	payment	2134	2134	1874	1	1	5187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZVoMAVxM7iqVsvQEhiM6b21k77dD4xJ7xcrtEupKjp52r6Yp
38477	payment	1693	1693	245	1	1	1117	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYZ7cYrejAbVGqxWf7nHc7bDuCKZgY6MgzrxSiE5vF3jy8ac7NQ
38478	payment	1397	1397	1678	1	1	14749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFcYCxQP39XvwT4tSCZQfugQqgXK2ekJMk8saEZy3K279mr4pM
38479	payment	1693	1693	2017	1	1	1118	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaHtAjrvsFmHXap6x6ufs5SJWdYVtbbXTRLRKZahC9GvNfPPHJy
38480	payment	2132	2132	1874	1	1	1419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcVXJtEcipdeyExpMLa8PSgFHN3jfEori4bvYctUVgDdkqnnp
38481	payment	2133	2133	1874	1	1	4709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NuAXF1waynrvT9pQHCL882FRbhootiqVD6fZbxt5n11PpgQg
38541	payment	1693	1693	120	1	1	1155	75501111237	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeZKEKAKQLrAvQb1rvmPCt8De3iY61TSiVQKDSmJrbJyGmMM25
38542	payment	1693	1693	320	1	1	1156	75501085869	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZTKCkXzE2MypKDjSF1nhxE3iF7CV6B1ytiWVLYb4i9PST9krw5
38543	payment	1693	1693	251	1	1	1157	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa2HQaL3ALfBaQqam89nnM16gFt8rftduY47RsvUdVEWoaGrzgJ
38544	payment	1397	1397	1678	1	1	14757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jAQdzpNhyzz4oxC5u1KXtqmZAg27sR5jWZUq1MhXuJPLVAEg
38545	payment	1693	1693	312	1	1	1158	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGt9wjMHSafuT7z5UVeFAxmvdRMCLZqbbedW2iYZupKJcYCJjB
38546	payment	1693	1693	663	1	1	1159	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZqPkgigK7sASnK2Kh6GH8syXnD1yr9GB2pnHbzV66Zkk9DQnbH
38547	payment	2134	2134	1874	1	1	5195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMc7DNdi13VHmK2UHqqhUgvrGaE1ocRTjR6VMSCAtRwPFX4tc
38548	payment	2133	2133	1874	1	1	4717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qfWos5zTY9VYFAPLYU4YACnhSR3AgtyChGHybDgAdgmynVkt
38563	payment	1397	1397	1678	1	1	14760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQerNtnBq6BhahgrTboYpiYSuepnp7v6VV9V1AAsD7Y7gfTrhM
38564	payment	2134	2134	1874	1	1	5197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUAi7THGynmKn7x4ng96a2MTb1xRRYRwSZKcRBypwnULstUZz
38565	payment	2133	2133	1874	1	1	4720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUp7dXLFgRCD8YrvYbkZasmiusPgq9h2TgFJUS37r7guK6BHuL
38566	payment	1397	1397	1678	1	1	14761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xn92Qadirp7qWr7zAvPeJrcEnumth6R24oLF4T3P4stiqXXg
38567	payment	1397	1397	1678	1	1	14762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFW96zzAX19nLsqqdnFZzAXXi9xAcfr6AVkcDo6NyRPhWchwra
38568	payment	1693	1693	309	1	1	1168	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZoJANTkgGXDwMxFScUZsuVUJT52UWJSW672VDrSoj6DtZdmPsD
38569	payment	2132	2132	1874	1	1	1423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLeXfdAYi9xuPQuLJ9CJ9MwMYbESUnCVC44JYvR7e9ND83kES
38570	payment	2133	2133	1874	1	1	4721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6owWptTSQsSQ65Nae2trYs7rAJQBvatLRK3jRuW4Xr2XNUkeG
38571	payment	2134	2134	1874	1	1	5198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAYS1a5TZo83gbGrB85SDmtHSVtmDfgft5t5sdMTFXcTwht9wb
38572	payment	2134	2134	1874	1	1	5199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUvHHcd9U4bQD3eALMdFrDjZNEYvwWLKehd9gJUUQKUDNGqKbN
38581	payment	1397	1397	1678	1	1	14764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpHH5ZPofG1KWv5qgqM6pkdoM1k7AHsyogDaftqAPJAVnPEApJ
38582	payment	1397	1397	1678	1	1	14765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcw4ddixKSWfgNsfMc8c9VVEvqZ7TzzARtgzuqVDj3SG7XhPRu
38583	payment	1397	1397	1678	1	1	14766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFNLYHL1UQxkHaWDWCSvbg43yjdZi5iHXXrt74RNCNHogHS245
38584	payment	1397	1397	1678	1	1	14767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvS2ySqxYig2ZVUycyR47b8y81j6hP9xnkXh1sQt56LHNcTXm6
38585	payment	1693	1693	458	1	1	1174	75502815709	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaJsbkLmddGyHDX944aHswaKKg7xj69CuxCcPirS4VJtQvKNWdD
38586	payment	1693	1693	391	1	1	1175	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZkpakaYFm2z3gbmLTrYmjL34pQq6G8UMRwzBBiM6hN5GaAWkFa
38587	payment	1693	1693	680	1	1	1176	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYopuXrodxK5wBE4eENBTeBRi9MkRQarG1xFfTum2giUsmBw8C3
38588	payment	1693	1693	690	1	1	1177	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZtbRYzAuqTEv6fkrfHx4cnMUE7shPnsA1fzjW7KpXNBVL3kKo3
38589	payment	1693	1693	2181	1	1	1178	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZKM5rBJwxrS82kyhYYB1U5RGyEigSPnZSidNw6wFqc8D7KWkvY
38590	payment	1693	1693	327	1	1	1179	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYpS5mgMSKwcCbP4pjjokLSbUm76e5HXbzdYCF3CB6cMApWLKrF
38591	payment	1693	1693	652	1	1	1180	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZZg1RC8MVN6acNvEwpapfU52vjunkSwdH2yWFVv6HNuN3o1YtV
38592	payment	1693	1693	266	1	1	1181	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaAZH68qDtAp5jZCBNbJYBkjKbpcYC1896Wa6vy6nhubwbnzQDN
38507	payment	1693	1693	611	1	1	1135	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa6y82jFjqMSWh1cGo5H7MeZBgFHuRp7hMDiJhPKJi9P4uZyB4d
38508	payment	1693	1693	146	1	1	1136	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZLXAmGQLT9VA1rBX6fs1Y4eJiAss7aVP9641GpUTigeTaVGHZn
38509	payment	1693	1693	114	1	1	1137	75503216089	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZogL3gE8LNK8rx65AqdyHnbdS9Zj2aiEnN2qrHQofyfSS9kfcH
38510	payment	1693	1693	443	1	1	1138	75500525541	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa794KwfGDDWqvJcJe5Khff7rabNwpu2mMJYDAvZRdLT5WrCbax
38511	payment	1693	1693	138	1	1	1139	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYrehCPxGd7aya3byq1UPNHVV1qEoxwSVp5wxr6eY9N1cqzQfZW
38512	payment	1693	1693	205	1	1	1140	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZU3gRJzqF6BXzSVj3e3S7vd22WRVegdDrUANRXB4UveKA9AEFz
38513	payment	1693	1693	578	1	1	1141	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZWxxAgZUyo4ENHJqHZAxDgvSEnsEkdU6sK7mt8TVPHPYz8rUsH
38514	payment	1693	1693	649	1	1	1142	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYQ1g5XFhSGzXq6LfwtcBWkr9RNGTpwpdr5uGevn1LcqRka1HCK
38515	payment	1693	1693	504	1	1	1143	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZTrehEX3YkhnL5P2cVkNPWwAujbBsmER93BYdAd36gkvRkGz44
38516	payment	1693	1693	1276	1	1	1144	1946786843988	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYwD72rVx5Th4uD1iC4F3a6NYCjr31yPAg4FuXW7shCqv5FWDzS
38517	payment	2132	2132	1874	1	1	1420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8K6yrBRMaJCsgeqEvfM4vaLNKySBQxXqJKrgPAY1CpfTFL4DY
38518	payment	2133	2133	1874	1	1	4712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoNEhgHcarCV39epTKGQj3Xeyj8KcgJeqCgLdXtjmUo5P13NLm
38519	payment	2133	2133	1874	1	1	4713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkdAMrAopzJd5mNjpTcG1pDenZ5ukJK1ivK71yaXWToUyM7ZT
38520	payment	2133	2133	1874	1	1	4714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SWx6PcZfLmXRd7ZoH9dEEyDtXpT3oyfiR8FXeUXW63MpfuQj
38521	payment	2134	2134	1874	1	1	5190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMeVAL7XNdCCwugdyVucSYkUprHz4hmRXpMvd1pFYM8BzPfY8
38522	payment	2134	2134	1874	1	1	5191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeHJ31RrhchNpQGdKKU11uZnaheYsmz7sPkCA3XEPG4oZ1UMB
38523	payment	2134	2134	1874	1	1	5192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiXwbmDB8wcF6u9N3tA7XcjLr6yyZc9gMLPsDx3ppSX2ETGPr
38524	payment	1693	1693	194	1	1	1145	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZEoo1wej7tskNauMDevVdShd3NS9vKCeNkjgY2YRYxbXNqJQxg
38525	payment	1693	1693	399	1	1	1146	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYwqRkVn3SLcHYPdgYaqyUaxedDVWkf2RpBXAo51R4ojrtEvcTY
38526	payment	1397	1397	1678	1	1	14755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZ5NZpiAtCfYHqPif72121gzH6WaWrYf1zymFvsbzXRZWDafc
38527	payment	1693	1693	636	1	1	1147	75500081692	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa4Sur6Ebbav6rGYmaTHL9JE3coYKcamfjeMYJEjTt9RVrMdG2b
38528	payment	1693	1693	721	1	1	1148	2297659444	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeRfCKAR2VEVqbx2kZoSezTVQScirB8L7VcohSFrzBh2dR3nez
38529	payment	2133	2133	1874	1	1	4715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnKD2Asx8CD1pb5b3hynuuPoSAADn9xWExE45y8dbMgRpsGJh
38530	payment	2134	2134	1874	1	1	5193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQiFL4g9RDkFbiz4YsQbBvz3ZToXEDrAjXk2R6jXmdrtQJ6Sy
38549	payment	1693	1693	1772	1	1	1160	544674052897	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYy6oKvCRAxqzKbgu2134f8Q3Y4PUuEzn5CVkwTzHcxRbGbvDRY
38550	payment	1693	1693	354	1	1	1161	75502815709	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYqmr2NTezoHFfXM9Xw9GVjXUrFSznX1JSAsd2dpDzzr1PTx8Yk
38551	payment	1397	1397	1678	1	1	14758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3X8wTwnpY1J2hsoKZPNs6SDUL5hM4v8rpL2fN8zFi6FTLQsb
38552	payment	1693	1693	570	1	1	1162	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa2zGDF39nVVvHD3zmx7maKxqUAcaLJKyugDBqTmtgM73NQMkKb
38553	payment	1693	1693	894	1	1	1163	352487287519	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaHu5x6eFncHXkndNTq7y1DTMpwtCR5LRWGgbX5hB5UTYQKb7Zf
38554	payment	2134	2134	1874	1	1	5196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbPwgwa2qxi4hU7oR488E75zPs17X29QV5A8WZUvi2hTyUenF
38555	payment	2133	2133	1874	1	1	4718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9p5u6PgQVtBFwpmhmNggc7bM2vHaBHuoEpBnpgHFrSQjeMMt2
38556	payment	1693	1693	569	1	1	1164	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYVU15rd9tfy6ekjDok4RVcoWL9SvNsnLYqsxgk8WwnS3BfVU8H
38557	payment	1397	1397	1678	1	1	14759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyYnwif9X23rRLmSfPeeUkEZNk8oQKGrYHdfYsn1x4jouE8Uz
38558	payment	1693	1693	390	1	1	1165	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa97rhQsPo7nK2CCsSM3RAuKDjD6y25xeXE71Ca5XSrGNCBP3AH
38559	payment	1693	1693	342	1	1	1166	75501340026	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYQ2qrDqXBdiSNLy6p4kDA8ECeGUfybNYjTrtqaYRriUc5fdu1o
38560	payment	1693	1693	731	1	1	1167	2297659444	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZLU69Ptzy8bLhrKas81Dv4chAdaaQjPzCgur5cp8YmkY8s57PH
38561	payment	2132	2132	1874	1	1	1422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCheF9azL6KobXTHb8KCKRCwSRRdp2MZR8mS7W9TSzWUvVk2dL
38562	payment	2133	2133	1874	1	1	4719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPRgvFZngkWhPbiSKUZ6sR1JSPd4m278t222omG2nqLqYoZfMh
38531	payment	1397	1397	1678	1	1	14756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp9Yfs5Be1op4oJyzvJoiFFjJN4taBmeJSKUrpMdBoXRCgzjZq
38532	payment	1693	1693	105	1	1	1149	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa35u9C4cqahjuT2V6wsU6B3ksBD2ripWw3hgasDQs5DHA2h8bY
38533	payment	1693	1693	206	1	1	1150	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaG1P6GpuNdQHZkzgrdYK31DSzoxFZnsu5zXmWfLK9wLGcJJ5z5
38534	payment	1693	1693	710	1	1	1151	5744148628	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZa36JRRQnDVjQQ3GaVchxJe3VL2akySG2b5FGR7LycUQbs8dDt
38535	payment	1693	1693	499	1	1	1152	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZoThuJZV6p8WcoRZ929Em3XAKnhh99gB6KGpMMnM7DmEPXVjn1
38536	payment	1693	1693	1030	1	1	1153	1035432902448	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ7uWarfeG1ywhwFg41rDX5iof7GYxvrTuzeQj7yjcwFfjtdnoU
38537	payment	1693	1693	238	1	1	1154	75500264719	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYdisdDdmxEZVd6BLYfZpyEYTina8j2R1RS9uNUpguq5zhmnXBd
38538	payment	2133	2133	1874	1	1	4716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwpDnAcr5i5D6p6EsPKwXMqrtBSEBVN61KuWZNLbuyxQVKsnd
38539	payment	2134	2134	1874	1	1	5194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyxJXF2FUwGPajQ62Jp3x9wzuqfKtaTuZcb2wxp64J2RLwYy6
38540	payment	2132	2132	1874	1	1	1421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgUD2wcaWq5PzFkjPdrNUJPJUiSwfkDnNQ4EBmzUwQiB5k6Ee
38573	payment	1397	1397	1678	1	1	14763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcS4Eism9eRWr8MAbsRLSAk5P9Mg3npszGJtv5Ywa7j6Nh2ew
38574	payment	1693	1693	82	1	1	1169	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa2QHEdMiBP5bRZagNtJut3LMZMMyB2MNbCzjh9vfweodY1YTnf
38575	payment	1693	1693	361	1	1	1170	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZJ1uHSnp6MRxaBqvpFG1H3pRTVBFC7wbuqHoqbvhUysN58VwJy
38576	payment	1693	1693	402	1	1	1171	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYgPqCkCBYx2QDJEcq6ofMX6rok27mJjhHGFgSqjx4xb2FZqdz7
38577	payment	1693	1693	275	1	1	1172	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZwpP2QwaciBzhKTewnyzqZULyoLmGv86mMiUKVaUZV1ZjYJpQf
38578	payment	1693	1693	452	1	1	1173	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZg7mt2NCp3Q625j3DQADvRnv9UeeLiDrstnojR2dE2ZU2UVTGR
38579	payment	2133	2133	1874	1	1	4722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDrCWbRyhrZFh64hH6m5f7MB62rofMDjQzYmKHhoKDBJx4cBN
38580	payment	2134	2134	1874	1	1	5200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdGFLCMysPNbhbkZk3JxPPTxXQLuWjwf3b1QUiJKtTVbdL8Xh
38634	payment	1397	1397	1678	1	1	14770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMEK3AW4zDtWESvQLXbihuxamfB7u8ZmwP8GjLvhQ7WXhoumF
38635	payment	1693	1693	29	1	1	1207	8041808080	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaACtFoJSHhZMRPHAoWAmpQQAyGHKsdakbZ559LapwLwuQyJftj
38636	payment	1693	1693	593	1	1	1208	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZFDWWLGKSpMgjJRuMW1zizqzJTX6HLXdzz2VDYveW1zz9zybec
38637	payment	1693	1693	154	1	1	1209	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYqAPTmTCAupXekm4rw7YhKnzJ9eNJdfPKvzQDEVK4kZt1SY9Rz
38638	payment	2133	2133	1874	1	1	4729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ14gYwee75AHYasQ8GFw6f9KM6pLXNvb4A36sSz3o9cXDfaB7
38639	payment	2134	2134	1874	1	1	5207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTMT3LKCFENDXcDr4CzQaJk3SNA1fVwvTA3m3gG8RD1ntQJiT
38650	payment	1693	1693	262	1	1	1213	75500194937	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYsThQKSBhC4wbXfqKy6bbDCRpXbLtQhvVrR9AadU4ma2sMonjW
38651	payment	1693	1693	660	1	1	1214	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYrUAej9pVbQ1j2aZpAH5MtKZAikc899BY9vfsyEgVUkDJv37Nr
38652	payment	1397	1397	1678	1	1	14773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoFdrFTvN4QdzUari9tQZUTHLgcAePBwg6iw8opbbNGpCzEhn
38653	payment	1693	1693	304	1	1	1215	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZx25qY6WZf5CWFew3xLf9jEdNZuwZp7RtZYtyYJF6fVyGvJHCr
38654	payment	1693	1693	441	1	1	1216	75500093132	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZHCKBoeFzR5YEL1tHrTsAmPu5iRnDw9UJmUEXnVkCgYfv9LS9y
38655	payment	1693	1693	122	1	1	1217	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZWGe58xRiLpaQZqdLUJBgpF2h1z1aTn1wgBgCotd3eSN5pqPdB
38656	payment	2133	2133	1874	1	1	4732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcnpwwjTVvwFDjb2d61Q3xLeN71vRkZBdF1CNp2ReTno1DVU3
38657	payment	2134	2134	1874	1	1	5210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJE6MKRRctCutHEtQCXKcfa3NsJbELSp2mc3FZKdQTvmAVC5rf
38698	payment	1397	1397	1678	1	1	14779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MkBw3Jh9uLDs17GjCBH24ZD5rwLCKhSe9PjAj5efKPPxcNnt
38699	payment	1693	1693	237	1	1	1242	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ6vLbRxrkH5991ienhufMPo2G6RhmHeUJTSFEWMKXyywUxnCxp
38700	payment	1693	1693	2164	1	1	1243	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYtMgpXoNBjXHt31wHiNa2xJrpjTVGtCufSXxAgQicDrC41qCHf
38701	payment	1693	1693	165	1	1	1244	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZZs8obhBPfwZnBXY8KUS1rxwf5pB25w72FLVh8jpSVwrCMhKRK
38702	payment	1693	1693	600	1	1	1245	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZtbZowqy3e8iZxZrcMe4dgTNbqVJfhWvwvtHuZ67rnSdKcFbzu
38703	payment	2134	2134	1874	1	1	5216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1SWKUZiPy5XuHMCXxX3cuKHKpDrsP2SUEPjNTmAvuSPSVYed
38593	payment	1693	1693	352	1	1	1182	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZPxKP6rJ2JVsFj88a2qyFdD3awgP8kURKYritut6Ce9FXPNHfT
38594	payment	1693	1693	534	1	1	1183	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYb2cJSGBYNrteTaztcJVKW5zuWKvSQ8rBtX6RyDCJdjHzso28B
38595	payment	1693	1693	520	1	1	1184	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZCQHuiU6eru3XQ35ZZJuncgp4QDuXXR2H45ZJir7m5MnHTJ4Di
38596	payment	1693	1693	551	1	1	1185	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZFzwq57bJ9HepH4HHYVng6QPd9E7PSPnrHmCoU1cFXxpSUGWfh
38597	payment	1693	1693	191	1	1	1186	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ3Fb5ZC4C36hjmvoZSosuxwhPRZ6sPjTd5zwNKziewhoMpSw4c
38598	payment	1693	1693	421	1	1	1187	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYxLN3BXeqGJ6fcmGxPP2Z9PPXyTVVesy8Vd5KdrsvviTyeS6fY
38599	payment	1693	1693	1150	1	1	1188	698627211744	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZCHsxgfqcydEuAjpm6CBBPcwJ5qR94R9o65J3Uf779oFpHyM8c
38600	payment	1693	1693	84	1	1	1189	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZhMPRpzaCuidEusoSoTKAqzYwaiwfxaStzVW1wk3mSpnu93oN2
38601	payment	1693	1693	379	1	1	1190	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYY4YkW4JqByJQsdhPvqnNBWpjRMm1ypxoAakFVPrZme4nHYZbi
38602	payment	1693	1693	678	1	1	1191	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa86s372ZiE74iucGdSM8tGBorEyZHkxcKzUqoWqudXDDdSXbu2
38603	payment	1693	1693	89	1	1	1192	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYidFg9JJ8mT1tLRGQ3NnCv2aRhL1tup9iGMu1pZMaPdSSqdukn
38604	payment	1693	1693	383	1	1	1193	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa9cxAvQkrXCY6undo5T485AggkBeUTiof9pnByQBzjeoKLet7T
38605	payment	1693	1693	91	1	1	1194	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYSncqq6WU1EeYdgXDnHMNyZNu4HtmtGgr9KbBwhuMTJaE7AGWS
38606	payment	1693	1693	438	1	1	1195	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaFjHnv8wJ2oJcp6w2UohbHsbapoxjQebxRBZWXwfkdUoJ6JCep
38607	payment	1693	1693	745	1	1	1196	2297659444	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYZ5t52RKwnunRTx5LqRb3mKxvmDu9VDYktee1xpPhJbZijeezN
38608	payment	2132	2132	1874	1	1	1424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSiwKhpW2cz32CP2xKjd2wgnCoxrU1GsSHvMZR3qgFS4saETC
38609	payment	2133	2133	1874	1	1	4723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSrbLjZsTt1c3CVKpBFSZiMePWR6AyJh6EQFZCoMfX2RFAUFd
38610	payment	2133	2133	1874	1	1	4724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RqtMEUxK3LahmEH6AuY4HkTBLhi9U7QsfAtktPcWJL9A9kGL
38611	payment	2134	2134	1874	1	1	5201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45je86PHJmT4Zf98Q8ZgfJ5ZqwWai7oQ9rAG8iypmVut5FUu5
38612	payment	2133	2133	1874	1	1	4725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtPoxkQpoZ6anYzwQSzvZNwNP8fnLaPoGE6WMdjRfN42cD6qt
38613	payment	2133	2133	1874	1	1	4726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfvJaV1s5SoKB2QmJUgWKP3MCHFki6Sm22txC2CcuBaMddrFV
38614	payment	2134	2134	1874	1	1	5202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhuXXXrvtMUNg9bDMj7ffNikaBwQpS9E5WtCWQZdTRL4MUzGx
38615	payment	2134	2134	1874	1	1	5203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7BZtkkpSEKidxLJj9kgdj7eq1ByRjtEpuPz5KXFhGTRwDijc
38616	payment	2134	2134	1874	1	1	5204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNQvq6g66qDUGoPXA1D9pgasqipYEj6a3Eo3sVf1iW6e3zvSB
38640	payment	1397	1397	1678	1	1	14771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjF5eQwnqaiScMcUY9q414cQsKo3nDNneyMg62h5EEUdwNAK1
38641	payment	2134	2134	1874	1	1	5208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaE7rCgAqJMiKuMK2qCGBpju1DezxW5981WcVWx12qPp4MH9s
38642	payment	2133	2133	1874	1	1	4730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhHGTXnk8WvifeMJjVkb1nFzBSnK3uRQg68fTLoxx9o78zkqM
38672	payment	1693	1693	35	1	1	1226	22057530746	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZBS1eFiSSKGhC636eQ1ASviXFTpjWkEJLC2YQiszKCnNyLBepP
38673	payment	1693	1693	49	1	1	1227	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZCbBNBSnMe5ydy3ev87awY8m6cBsC9GB5ezcuPQL71zMJP4yfs
38674	payment	1397	1397	1678	1	1	14776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pFM7gRZJYgBt1baHc9ssf1xRcab4eAKkyqL6PsWs8agjyGr6
38675	payment	1397	1397	1678	1	1	14777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3DzneyVHfcyQU9f72Vg8uNA2xzfBzGbB6KnazJxRmkZ8CqAy
38676	payment	1693	1693	1778	1	1	1228	2288014596	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa6EJDGPMcqKSN8JiN3jSQksWZZcpobyYz4bJDfWBzVbvFoCtnp
38677	payment	1693	1693	99	1	1	1229	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaL1T4UpEPFdbJ8GgRrTi5CoFNycWiKMmD97xR4Thq9zXiXryqD
38678	payment	1693	1693	108	1	1	1230	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYb6xxGrvFwTJGzZfWuDNFzVg9cBNgzkiVU9Q1sSbZ1tyBnUDcg
38679	payment	1693	1693	252	1	1	1231	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZHvwaf1td21RaBP6ZXheUvLC9DRkfccgzXpSnLHdfqmXiiYRKA
38680	payment	1693	1693	225	1	1	1232	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYznTfpPyJuSrqLXVKvmuiRs8bmRGNWLZuG4mFAZfHj9AQpWB4b
38681	payment	1693	1693	377	1	1	1233	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeUz44S4HrDhifDBjdTQgNoJ3W6Un16k7zegZtWmyTXAdCbzr1
38682	payment	1693	1693	560	1	1	1234	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZRxtyjaiRp17ZX3YknytxLHovRwWfykdkYPjUEya3nqX51ZU2K
38617	payment	1693	1693	453	1	1	1197	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZeViZczhbRHGypFoMWwK1woKPHdfo7i29fHJ1q7NRN8sZ7496i
38618	payment	1693	1693	373	1	1	1198	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa4AqCi44GREtgbCCUw6zMsBZvYZ3i6LF56SE52sRvteeqoLWvs
38619	payment	1693	1693	63	1	1	1199	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa1yYAAFtm75FiRU25rG58TL5SSXYWDo5cDnF2pUf2pkUD8jJbd
38620	payment	1693	1693	150	1	1	1200	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYWZgeH2SggTRyUF6pGKpdsyXq84WmGNJQXf7nWdYwPxdSf14wH
38621	payment	1693	1693	92	1	1	1201	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZLBTTNHmsy1rG4JTEd8467UZh4VqdTk9yE34wfUFkk8fN9DeqE
38622	payment	1693	1693	562	1	1	1202	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZWUmeYXEAeAkt7iNKEFXMGofsEJUcsf5vXWAFnjez3CbawyzZz
38623	payment	1693	1693	910	1	1	1203	577811301963	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZ1zqz7ELwBKiDLc4Q2CfcGfxC2737NxjmXu4TCCqUfoXTsi5Mo
38624	payment	1693	1693	711	1	1	1204	3434555899	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZQAjwA2trqVuPeub4zpiowsY7JsqQruZKVqhHPFmnyeCf8wmvj
38625	payment	1693	1693	395	1	1	1205	75819295835	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZNtXgnxVFpbf4dJ9VGUk9QUFxQrotzxxGQxMehgqPWGvZ4un6s
38626	payment	1693	1693	78	1	1	1206	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYnMUmYGkBV9wSgkH7MtV95VEa528duncoZpBkex4rkT4CZp9e8
38627	payment	1397	1397	1678	1	1	14768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRohasYmAWACbCBPhNeBQZKCynxZuLnxNtgi2wijGAbfcmeZq
38628	payment	1397	1397	1678	1	1	14769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxNkf7SJdPcigMbnbwq4o4efd6DGcwcSLET2zihbVtMgZDWSQ
38629	payment	2132	2132	1874	1	1	1425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoe2xa7cwh7rUz6NkyDFre5xnbGQkzurtVrHMCbktWsdjg88SH
38630	payment	2133	2133	1874	1	1	4727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1hgah9hMbuWASEA5W2uh4rK8iLAugoM7SevyaGoLuFxBi1ia
38631	payment	2133	2133	1874	1	1	4728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZepG4B1jhg3LzPTSDaGRhdmEzCcqkXWiJvvtEP1HzWcRF8GC
38632	payment	2134	2134	1874	1	1	5205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2LCqKxe3NqYn2rXWERc4byrV493d2xj5VoJzPUMrLBGzZqSJ
38633	payment	2134	2134	1874	1	1	5206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwMnqSb4Hbhdro3UBpRTuG5tmHwRWmFNRCt3aJa7TSwMinUGt
38690	payment	1693	1693	163	1	1	1237	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZuh5u5eyE91XoKRsyLaSuyDDBhT9r2WCc2BPJ1bSFT3tcKhvbE
38691	payment	1693	1693	1962	1	1	1238	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYzjmcJPRgUt2mUmt4HnnkbpxWxQP5PjbazCyCY8aSTQXwgv67n
38692	payment	1693	1693	748	1	1	1239	2290615270	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGYdEpGk5eTrxEW5MTLqAk8vrUArDGbBqkRQNEvHE3VfGUxdgW
38693	payment	1693	1693	2073	1	1	1240	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYUjritkoge9iDqZKuiqEZTBYfe75EyCRUTeSzFW7xp6QQa9jbz
38694	payment	1693	1693	180	1	1	1241	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYj7bdepMZGDwJeaFHJAqV5JCZ37vHBy5e64dRCVf2mrdpQz7Zi
38695	payment	1397	1397	1678	1	1	14778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcWj8cR3i9FEL51ugKx8zzjPifLLLcUJ2sBnvkCsveY8HuhzK
38696	payment	2134	2134	1874	1	1	5215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxq2kTEXfLxtZC8STjb9QW27mVcumS9Cja5iEBX5br5xqUTXk
38697	payment	2133	2133	1874	1	1	4737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YMskeWskdskFKZWmxd6ciShAaHcBZ8Q2U6BxxxvSfgvrodvx
38706	payment	1397	1397	1678	1	1	14780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qcTKMBrdZRk96fi7iLp8R4f6MbVWPJB11a6iLWZVMWCarywC
38707	payment	1397	1397	1678	1	1	14781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9mNZnhFFaRyFhL5at5NnrCc9JcAzWA2Efzu8krKf9gGZ2guY
38708	payment	2134	2134	1874	1	1	5217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWHTQRLoXA9XaZXjZUkCN5V3YJ5TURWrPZHDu4BayiMoDChqg
38709	payment	2134	2134	1874	1	1	5218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5wfcpQpbmLkzbx2s19iAAHdUiWdyiVPhdMrGvKM7qswoNWBU
38718	payment	1397	1397	1678	1	1	14783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvLGmuqwtW5jgSmne1RdxSPFJeC3MAYMjxjdGsujNRwftBck1u
38719	payment	1397	1397	1678	1	1	14784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6V9betucYGwuTytKYZDA3LFAMnYdDkFcJPrWCZPVrpWZjagTS
38720	payment	1397	1397	1678	1	1	14785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5scpYtNidmBgRCJEq8tN8S6HYvjmrB6eBcpAh5J53zrJaF4Uh
38721	payment	2134	2134	1874	1	1	5220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6KpgfCJbhKfErtAVf9afPHVqXo7gRCVapUdDinxcBDDXEDEoz
38722	payment	2134	2134	1874	1	1	5221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2GWUTnvfNzzqf4Pr9nGFLewKM4cPECmdUmu3WodYXR1r36PRZ
38723	payment	2133	2133	1874	1	1	4742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsAvk7mt9PB7TZsFEPhc3gjXL4ZSb9MW9257BTuGJfmRNz76n
38724	payment	2133	2133	1874	1	1	4743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbik3cVBRaCFCgGcheYJUcsy3nkBfiRXFhR7MYL4Cb4av8DwZP
38725	payment	2133	2133	1874	1	1	4744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oMG5JH5wS8PL7SuxQrmwVg28x6AU1ySSn7ypaAqk3LTnqJY5
38757	payment	1397	1397	1678	1	1	14793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB329xtzeGhrT37R3fB5KJs8AjXhZjQKNdGcai3yfjPt2WNApo
38647	payment	2133	2133	1874	1	1	4731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtLbH6V9wmRUNLhaugX2Hrjt8TguMjENFwPQQwT5qWMTo54YQm
38648	payment	2134	2134	1874	1	1	5209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzh5fX5XF5gThPaRdVEE2E4J9zhbXcTiBuzpJVpCHcMVFLviva
38649	payment	2132	2132	1874	1	1	1426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdvLWC8FebYy8LrUSfJ8kHT1EcTX31fTLJK379WUFGZJR37ZC5
38658	payment	1693	1693	2308	1	1	1218	75500184646	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZE1aDWxzknr6JA7wcc7qL7Bxge6WGPDn9yuFKpnF2JRWQFWcbr
38659	payment	1397	1397	1678	1	1	14774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKAZFkV31ycfbgTEMmfS2NmanVhqRhvbfjuo2wZWdrVWSNizr
38660	payment	1693	1693	653	1	1	1219	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaH3Qy4CjQf9ybx5s73Y4ZrzcL5oasmHtuVytZKHTQoTL5Jbyt7
38661	payment	1693	1693	217	1	1	1220	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZtnYP6yEp8iKWTWSDxRzrUgeKzD7fEXs8UYM8JcPLKBqNEDxsr
38662	payment	1693	1693	103	1	1	1221	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpaGUjSwPVkNi9qJDjr94UT7Uf6mnMVM3uPu7Y6dhCqsuvAAuWjo
38663	payment	2134	2134	1874	1	1	5211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdb15jXMLxNGG1vNZDKD9y8zyTt5xK537ndW8FpoWd3BUPavbP
38664	payment	2133	2133	1874	1	1	4733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrrJCYg16BVv6f7Ek4eNXqJQCnsAWbZEiEax3BtC3XSncNdCr
38665	payment	1397	1397	1678	1	1	14775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfBv3wuDJCcDoke2vADGK8Vg9ZMTY4HnttLvgTRnGPCxxiYdP
38666	payment	1693	1693	893	1	1	1222	352487287519	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZaW3Ja9Q8y96XiCquFCrweEc6h289tgMhf39mmR8iyeRxQxXi5
38667	payment	1693	1693	54	1	1	1223	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZR1TiTW6H4smEa6nrjdZA8hSYmCtV3WCp3Syqk2TvmMnu4fYkK
38668	payment	1693	1693	530	1	1	1224	75500194937	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	Ckpa6g1pEtTcjrFA4Yqvzma6i6rgmNzLYRrgqDCVkK6RfwfwVFaV8
38669	payment	1693	1693	603	1	1	1225	76324874328	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZaGL5aeDDfA1j6FFyeQfNLqs7FaNnFRC4rzN76C1dhJ9oe6YP4
38670	payment	2133	2133	1874	1	1	4734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSt5z2qy4Jxu8VAjeDRtXrdvQNsPrYmUKABCr4qQrtYb9Qd1ad
38671	payment	2134	2134	1874	1	1	5212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EMJoDM94unUDtqoH4vqqiQU7pTDHNpYTzByfHjCb8cd8xPs4
38733	payment	1397	1397	1678	1	1	14788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqxLg1G6yPZkjSV3DbHpLwSP5gs7TSx9fkrQJugbqQCqU1sv6
38734	payment	1397	1397	1678	1	1	14789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVe5XxPgriQLJ3P77yfDH1W1nSk25VPyuf238BF28GDiSyWsjL
38735	payment	2132	2132	1874	1	1	1431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqBsjNFrRWGHoRyHmfAQhuJ5GmWA36jRdnuLUfSVu6Xqc7VpuY
38736	payment	2133	2133	1874	1	1	4747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WmaixrkdNpdmVTp837BmG88aSnZkwftT98evEbjB33nBMdVb
38737	payment	2133	2133	1874	1	1	4748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYnSV12HwQ4GGPhNqPshjFKDcM32TdY2cSUbGEUrnYPBtYYtJK
38738	payment	2134	2134	1874	1	1	5224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspZ54hVf9icWQ7RwzS8RyjEFwhjsNofjbJ8EiQfMPA8UQsnZq
38739	payment	2134	2134	1874	1	1	5225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vQqbQtSETvKAc7MaS3HbG3ZHuCxvbzjbDtZLNRgpXJTNd5be
38760	payment	1397	1397	1678	1	1	14794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLb7bsp2ErA4wvVc8PnMCqC7AKvi5HskLk48TfepDGrrFG5DEG
38761	payment	2133	2133	1874	1	1	4754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGGqMcvk62gCWkQj7pieu7RrNEtU8SNQPjtzigxF8XMU54kyN
38762	payment	2134	2134	1874	1	1	5231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPrdTwnXEe38EBhgkh9Y2T4c39ue4LFCZSjN9ZJ2xfQsCJnRK
38782	payment	1397	1397	1678	1	1	14801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJy27wHm3HZkbQr7XY2jDKKytbNukKJe6UTQgK89kwUnfbKsj
38783	payment	2133	2133	1874	1	1	4761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrq4BKmgeGsBFekgFYJfNTkv6BezDSZnKFd35qe4q4AqXBmnL
38784	payment	2134	2134	1874	1	1	5237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND3t8yBRXuKBosnxhZsFP5HxRcXywDuK9APwrum955K7CjPQk
38785	payment	2132	2132	1874	1	1	1435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZstbzosqHsu8uhuFB9gBwdkXjDrRYCy6EPteoBL9mfxJVY23mL
38806	payment	1397	1397	1678	1	1	14808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg76soNVJm43T6nTJ4RH2fspH8TKAv78guzCdNqqDewDo4ZERc
38807	payment	2133	2133	1874	1	1	4768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pgmyfLnzYq9MXNzcZ6ZegJpSCGNb8hVceprSq7moegJsmus2
38808	payment	2132	2132	1874	1	1	1437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrcBc4gVJZcBQF2Kxw4b3mDEVnFhNQbStET6u6qRD2NtyxuWWk
38809	payment	2134	2134	1874	1	1	5244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88EvbGWV35Cpn5ms4sfYWX1kJQCpRQqXtAFEFS2ev2zCjr4td
38830	payment	1397	1397	1678	1	1	14815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLd3igizDy1Zzd4eQyLvbAc89bySx2mken6Wj1ffjqvVTCPzGu
38831	payment	1397	1397	1678	1	1	14816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KNscdSrQYxBQiarRaguWrvvkP6tXDbv2kCdDvoMYTaxG9Qqu
38832	payment	2132	2132	1874	1	1	1439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgp7CJqf39BoeYgXWo9FybUkW9kFHEd7K4vXXbfQufvBiV7WY
38683	payment	1693	1693	594	1	1	1235	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZjPrDySa9XxDSGnaEPxv1nzeH4jdvR7EzdxLidDP3n2b3KZaad
38684	payment	1693	1693	201	1	1	1236	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYaFU8bLcJ8yuxKGr1AMzqVgEDQmNXMgQVRrRpmwAs1gymYfijT
38685	payment	2134	2134	1874	1	1	5213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQjaEwtbFTQwiTT4jx85PwzTEznAD8mv4SNkxUV734kdnXtkrZ
38686	payment	2133	2133	1874	1	1	4735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsSSvbmTJjWq9JWBFAwoWMgYABrhrZ6suXXemakX74SmXAkJX
38687	payment	2133	2133	1874	1	1	4736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVbgfZSQfgzVapLU8KfCbPh5vRNJSMaxhgTpyXbQt5AKkJdQy
38688	payment	2132	2132	1874	1	1	1427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStz99VUpWXkcGwG33Efem9PKJT6b1yH9FmxuS6nMLk2C3X4U6
38689	payment	2134	2134	1874	1	1	5214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHGTkH9J4xG9e7BEKGiZ6sJD9xxYfMJkW1nJ7jtVbKfAiRCwj
38740	payment	1588	1588	1392	1	1	7	8758476000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpYgWM59dyjYVxZCbMzF1JvmaKbStr9LG5kq4jr7L3jGnkKgs1Dx
38741	payment	1397	1397	1678	1	1	14790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQdghczDNE4iNdFhBo5DgnqpE1r9NkeN7tLzHVWzXXcukfMGs
38742	payment	1397	1397	1678	1	1	14791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodc6WYKMsvqUE7f1genCwuRoogwGUL7yzKRK2KcP6C3cRc16B
38743	payment	1588	1588	1146	1	1	8	4658350000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpaH2xrtYjQjjfhxs4RnhWbo1gsfcufGrYDm1u2C4CwTesrmd6Rg
38744	payment	1588	1588	1266	1	1	9	3135636000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpZTmkd7j6Qk5oEmQkvPXBEfQGnKxZ2gzXVnv6uU2DjYxozM2eRt
38745	payment	1588	1588	1026	1	1	10	2599538000000	10000000	\N	E4YrvzehZLkNaaYPCXmLdUiwftLCRD53jizGTrnoByarPQMU6ijez	CkpaJ3G8fZBXkBtxMpjTD9fdEjx8Zv9cs6q4aTdykXruqiJujbXDK
38746	payment	2133	2133	1874	1	1	4749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYr4aVkE4w46JAxrKira9iUFYtByPQFgPEYf4ou92838gtaCWr
38747	payment	2134	2134	1874	1	1	5226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqT7U2QAaWQRJGGtWV1f4FLht7d3KkjqPXpYKSazbAVYL6dfL
38748	payment	2134	2134	1874	1	1	5227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmxcr7kr1VTHYZhG7BdBMtze6jB9NH6YYZKyQ47VCLtwQCoyws
38749	payment	2133	2133	1874	1	1	4750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzF7MdbDRRKnJB72AxQt15c45y8tmYcSDVhEqcYedxFae2EaeH
38763	payment	1397	1397	1678	1	1	14795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPBkWGobgF8BkPqyi4BQH4jbMoWJBckxqh61BUkKRv8eJxFFh
38764	payment	2134	2134	1874	1	1	5232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxEErQW2M1gfZTy5yQU1CQuJRd8R16b25S2kPXPS8dBSxXpMN
38765	payment	2133	2133	1874	1	1	4755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fDtW7zRHqXXdsMqF3jP6oJwaexBvEEer7WRWmv9rPTeigdJL
38766	payment	2132	2132	1874	1	1	1433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mZweMoqy8JsSYqXeNGVWsAUspBy3J5DAJASFCZHiCJDJEPu5
38767	payment	1397	1397	1678	1	1	14796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzXWeQjchqUws8u8Vo1qbScaE4dsdhXJeTgsGDqQbQVizGdbxa
38768	payment	2134	2134	1874	1	1	5233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdn4i3f1x7ViAAiyY9ttWaNsNE76BkeADJYPtmfezktquRGD1
38769	payment	2133	2133	1874	1	1	4756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZf9vtpShuGCF5J8XnF5czw4L7kGYinyFJwHhEx8uxawzZzzF
38776	payment	1397	1397	1678	1	1	14799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp36xFXnQzznKtpXVTQSsmNAobDQMbSaZJPYddfXQa2wGMeCrz
38777	payment	1397	1397	1678	1	1	14800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeyksUXfEABbGf9JMuSLLXemQu6tcBV2oQ3qPCmJWNbn4zLJBw
38778	payment	2134	2134	1874	1	1	5235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPi6R3wgiPUM3vEKW2gPg8V3pw4wBwapWEDx88SZjQgSQJyykS
38779	payment	2134	2134	1874	1	1	5236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NPu5wnY8nMdjfPmKpRHCTQxzeoBAKhnnkVpdfWRaaHy8FHR3
38780	payment	2133	2133	1874	1	1	4759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7bUUfxca3ZL4RumLWg69MFQqiW1CA79NHGk21G3KxNBKNBMM
38781	payment	2133	2133	1874	1	1	4760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedxMWYytyo4K8euT9cVkjSKdwy6X4KzdugWQxzWtZFi2UBMwj
38786	payment	1397	1397	1678	1	1	14802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBc4wEnpo4fm1rme8ZxtxvkBFNS3Yb8c1tW4FbLc6g9xpuvs8E
38787	payment	2134	2134	1874	1	1	5238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqrP9e8QZHSrgti69AMmNjjN76peWdPwce6MW7e5UGjapisxE
38788	payment	2133	2133	1874	1	1	4762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39iAF1rJ767ci6PEsTfmjH9PNarf6hrHZQFV2AWuBchGFKi9h
38810	payment	1397	1397	1678	1	1	14809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEX7HDcAYR1dFcpp6wxBFxEHfMSmksEBA2VoDMCyZt64GGns3t
38811	payment	1397	1397	1678	1	1	14810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJSDNJxLSGxHCoYFFzAoYSrSoNWNve7b5Bi1A5xXvn8CPtW5F
38812	payment	2133	2133	1874	1	1	4769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGme7sY6YnRviDtRfr7F9wHe2cCNH5kf5NcuiFQW1oJFnwrNZW
38813	payment	2134	2134	1874	1	1	5245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNMvBa4RE2Tmf9pA1JrMNurtkaBe3ssdzbVkEWDaaay1uNW1di
38814	payment	2134	2134	1874	1	1	5246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQW8siqJPaWHauBiSLU1gjLxUtcgnC29y2jnz3mic8nrgx9xgQ
38704	payment	2132	2132	1874	1	1	1428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehE4BKtrMHAkHR3ttfkkBVH7s5F8DWiqqfc6tiFAMTt1DZfsz
38705	payment	2133	2133	1874	1	1	4738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYuRBpcgFJTboxRhjRMqS7K7vhFTpAVwxYqmqj98MtR3NXDGW
38710	payment	1397	1397	1678	1	1	14782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDNHQDHg1dhgVGJc8gFkqftxdk4pvceybBK3R8y8YA3j7Qwyy
38711	payment	1693	1693	691	1	1	1246	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpZbimugdWNeeXDWGL1F8itDtWcLcDNQLXGGmzymnkamPMzRrxM2
38712	payment	1693	1693	620	1	1	1247	75822761977	10000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzMmdcm7Xt1dg8QnvLcrtD	CkpYXXPWGcpAd33Uo9beRDbbZgSjXbEKJZUMuibbFzkTWUynyfme8
38713	payment	2133	2133	1874	1	1	4739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtPMitH9mXqjA1V9c97JLdCimX8cGjrg8gxpQvx7HVhq7vDof
38714	payment	2133	2133	1874	1	1	4740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrb4QMXtbmvNtFLEBQ1tJfFeYpASyHS7Y8oYvbZZAVD5yHK3dX
38715	payment	2133	2133	1874	1	1	4741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbwwBauCJkFg9B6qGPAjkpiNBuzZBmPxWcgzjtFfBNtJvnAg6
38716	payment	2134	2134	1874	1	1	5219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjDGZHYRrcWFhDr8xZTgmLB52KgEu66qY7xsisUEGAmkRDLR9
38717	payment	2132	2132	1874	1	1	1429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1MdE3GmRx82MhhefkhFPy8NpAgnkToUDQd9ZUXsYz3poTvJfd
38726	payment	1397	1397	1678	1	1	14786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEK8Bf9Rvez84KsQaPUEi85g9QDGkHHQ4HiKcfsjQfG7ioECK
38727	payment	2133	2133	1874	1	1	4745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GBGC889MEjUYxsEfymunn326KhHMNWo9vv9NK9SAVSkZSjyy
38728	payment	2132	2132	1874	1	1	1430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa156R5fQZXiTkK1EsZ1VMMeR6SUbebVc3qf2xWadwrzx1Wg89m
38729	payment	2134	2134	1874	1	1	5222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCxbmnfUnH9aMsEQZDiDxZR5SfPE9qKb9WXe169CNeK5aNXWik
38730	payment	1397	1397	1678	1	1	14787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tY9pBbhMTJDUvPGcCQp6uz73UHfVt61fSYTpPNEG6cN3YqcK
38731	payment	2134	2134	1874	1	1	5223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsa9m8FTTkQD6WL2KMYic3Jcc4VxbHRTnrDHHADCUYMi7zsVUN
38732	payment	2133	2133	1874	1	1	4746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3RWJv8VXSBDDGyCCeCHJmaTShJm3uoXBicS4pk6t3b2rNWN2
38750	payment	1588	1588	2068	1	1	11	1008000000000	10000000	\N	E4YTFNBSyRTHCEHUAomtPkh3z4eBATkV57MctCcuHuEWepGushD5s	CkpZdZMpCoK23eTHEbaprhSWY5Cm3KHs3fZzXKoVosg3awy7MQa6r
38751	payment	1397	1397	1678	1	1	14792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuBCG32Mk67uNF3QShHVixWy9eY8Lf7LDjRydS6zbAP15Hg5Ag
38752	payment	2133	2133	1874	1	1	4751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbBUTr6pQ21xVSPLixsY9PnyqW5VvdYZND2h92SgxUgQGfFcBB
38753	payment	2133	2133	1874	1	1	4752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfDrhRRQmbYxdXHbH8Gux2CPLTRYc926Xz1hMskt7eTSU546B
38754	payment	2132	2132	1874	1	1	1432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktJsD45tMwXRPJeALC2RAEqugM3ffmzCXDuukcfrYKVfXAPrh
38755	payment	2134	2134	1874	1	1	5228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVhX1GuLGuZxG1AwCNrdXXiiAjDWVJDb1siyTXswie1K2FNLk
38756	payment	2134	2134	1874	1	1	5229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7eDMQcee5t9wM41D4dP2ipto9viQNDKmrzZ7AdnsH6UMAW4aa
38770	payment	1397	1397	1678	1	1	14797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3JN9jJZQiwCKHwp2Trd6PkPgFKLJ5ReEEjjt5Qdy8hiPEsw95
38771	payment	2133	2133	1874	1	1	4757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZC7Nah9S6J2fKkhTDipC6qicSeREfU1WQyGKAoi6qTxc6M1gd
38820	payment	1397	1397	1678	1	1	14812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqM4RF1ZgsxRF8Vp77ypcHqqctXXaYWNfWNGmBeXf4Va5BJgZi
38821	payment	1397	1397	1678	1	1	14813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGL93padfkG4PBqqGXdVfaT1qZvzz4ZgV4vhscRsqrJ8vdCcGE
38822	payment	1397	1397	1678	1	1	14814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHE3NXJ3JVbpDBgtUuRcCk6a5RMPrqwKj2gCMRcqu7JGre5CE
38823	payment	2134	2134	1874	1	1	5248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm6BzJeZS2XJV7mjxU7bU8TFaaF4SGsqnyPAcsPoQDQMECbzue
38824	payment	2133	2133	1874	1	1	4772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqJtv7Fj6UGe7PffJ7dcgcormbFNHG2j6RVa76VEVKbkCLTyHY
38825	payment	2133	2133	1874	1	1	4773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GahkUo3q6YbsaaMATDJt3g28Rrad8NaWJcSZVaaSamsU85Gj
38826	payment	2133	2133	1874	1	1	4774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4BTJzdfcqpdqgGrBE64Z4k58bbU2GeU2bsk5d5zKk2tx76M4
38827	payment	2134	2134	1874	1	1	5249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAEP6zrr33uS588u27YV2UmawKtGrbazC6ZcwqEB8c1bUnhQcQ
38828	payment	2134	2134	1874	1	1	5250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTP8Z2KqyWoLHNUvXWQSND6w4NAmJBC46rdtL1wFMS46enrUfr
38829	delegation	1926	1926	1403	1	1	10	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7n8b8PALf8wQdTUq6UiY5LSFZPg1wSwgaUdNRcDAchSqte5R
38840	payment	1397	1397	1678	1	1	14818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9CJwbyqg8ss9rm2R6MmnuQmAbgJ1NGd9qbCknYKRHKyh4MMH
38841	payment	2133	2133	1874	1	1	4778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW3Aku3Dsx5TkwrdKK9p2FqBKbcdqrsTsC4aB1T3qcTkPR3b7
38758	payment	2134	2134	1874	1	1	5230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hbogpYpjpbv4mpEJxQ2pJdjMZRa446qxNpfKZ31aC2wGmuVa
38759	payment	2133	2133	1874	1	1	4753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqzHxjYxxiv6U9XPRZ4nrtfEp5SmHb34VEag15mNDVmwuqR9T
38772	payment	1397	1397	1678	1	1	14798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1wKboVyJy7BAvKXt4CRcRYGNrGeRhcWmJvfTADft1thDJ811
38773	payment	2134	2134	1874	1	1	5234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgehJkYFXKCH5PERGra3RS31Qp3tCTvBrN9T9HkbyxEwASUgD
38774	payment	2132	2132	1874	1	1	1434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYytzh4NHDEEUSUDQ3aGhEDvXTwxU2ctfNAr8ENj5yefkCnkWLf
38775	payment	2133	2133	1874	1	1	4758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5hh6Db91oMQhoacgikcZ2r2s9HgSkCEqAV5KKHLHpTx5J1amr
38789	payment	1397	1397	1678	1	1	14803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYaHChEuHRGmuK15ZcAQoGCXFH3ZTQq8CVBgcZuevS8cPN2Rd
38790	payment	1397	1397	1678	1	1	14804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNL8nmUfbCKSb74dEC4D5E2GEBP2UsrJJS9djxaygHsHGB7rME
38791	payment	1397	1397	1678	1	1	14805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpJwGYGsyCCND4fxhjx1nTA4SfToxbLYBxhtyigaDhwQNaLbQ
38792	payment	1397	1397	1678	1	1	14806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiay3HZdEa2zXL3by51TPppYeA7EPfSvTgVpLi2SEJdhepY5d8
38793	payment	1397	1397	1678	1	1	14807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSgM3No3MwJbQXrEP2fdwy2Jq2q6cAhwfUqonzupbh9YKaDzX
38794	payment	2133	2133	1874	1	1	4763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7mZARuftj2c3Fd7o9boRNM182v8YmtVPxEDDaPeq3uhYEwCA
38795	payment	2133	2133	1874	1	1	4764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkdBiL8fuU68ic1WifX6aKnXD5fq41TUPepgLZzunajqPuZR4y
38796	delegation	1926	1926	1406	1	1	9	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6m2CGR3ztHPBb4fqYPXiYn1JARdRM3ruPMYdgmacYe3qK9UVw
38797	payment	2133	2133	1874	1	1	4765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBBYi2fJQzkLyvkYQJKndp3amihasueBtUwyRqNW8Su7J8MSM
38798	payment	2134	2134	1874	1	1	5239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6CTuNdfafB6TTZcLMEQ5V8A6WUkSNTyKy62yT722o3U9pH7b
38799	payment	2134	2134	1874	1	1	5240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocWBoqBWNxaFw5MFzXRCr8K1F96mJ4tLWfDvYo6tQcrxmSusa
38800	payment	2134	2134	1874	1	1	5241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkTDpoSoATAVfxGaBqxuLTazw9ubZFkzm95hKHHmC7JGY7SVc
38801	payment	2134	2134	1874	1	1	5242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwRcetWmps3UGWGkSQAb5F1crHC9kq4bJx2dSedw6GF5RqaieN
38802	payment	2134	2134	1874	1	1	5243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZRyZFmkSB2MaM8wzsPxq59QDAe7R99G8rzQVkiRCnta4kwP2F
38803	payment	2132	2132	1874	1	1	1436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FqsbzGb5yo4icCRgHPFVz8Yo9Ai3tgwmN3L3sHnEJkMXQkKE
38804	payment	2133	2133	1874	1	1	4766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyQLv3frmk5uWTxw1H7gGMzyjD5Dghwpm9DHw5JQ3gmcZBFtw
38805	payment	2133	2133	1874	1	1	4767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7LRWY4vgHmcGnrMU1ctcqV5ZJ4BrN4BfaAKfxkbB2p9JaVSe
38816	payment	1397	1397	1678	1	1	14811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJfUrLXvFyQSFJbTAYHBipsHjrB4ngkHgbXSrhmh1C4ws8orL
38817	payment	2132	2132	1874	1	1	1438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVorxiK4rWhdbCFQMhnZtAo66uuni6vTYKahBqzGYtRCNSFRc5
38818	payment	2134	2134	1874	1	1	5247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGPo1g8bgF1N1sa8UVYTXAvqeE422Hh6NYtSa4bYMNVHpN6un
38819	payment	2133	2133	1874	1	1	4771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cZwwLDphJzVPAzDTwUhBhDw7AZBBhqav5F28VLbfm7JsC7g2
38844	payment	1397	1397	1678	1	1	14819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPavuHF1X2RHrGeCBW66gsv5bCziq8UMf52MFifqHw9mz6NjZ
38845	payment	2133	2133	1874	1	1	4779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSPJKGQMD8rYE34mHffxYfKieGexZSpXhmUj7dNMXLfmq9JcXn
38846	payment	2134	2134	1874	1	1	5255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NBkRRqz8bKzV11Qv9wNYM95ds93CKBdFcL7m92BEdbvHbaHX
38914	payment	1397	1397	1678	1	1	14837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3qDrofb3h8NtnkRY1D6UbwfSzFmU1JhpsVGoGbA33SFJjQvuX
38915	payment	2134	2134	1874	1	1	5273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnd8XTGhCZmnceRRo4PBvXqSgQCJYTTZpM7wNciy4EuHSLS66
38916	payment	2133	2133	1874	1	1	4797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPB6uKUJR8VDLMqz2ipUvPKwCB2xEpWfmqJ8HYiGVrXWttnf3
38937	payment	1397	1397	1678	1	1	14844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQyhPxVh68YCfzFjtFN5oHTq1U8MFDkbKVC3Zj5jFm5mUYSSi
38938	payment	1397	1397	1678	1	1	14845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBokeD68sSmaeY2FbFiEaTqvqxh44uN98dyKnLYTbBPatQDtXY
38939	payment	2133	2133	1874	1	1	4804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Yv7ghmt4TsEQmEwzgqWjG45w4gGW41m4Dj3ovu8sUjmqavcg
38940	payment	2132	2132	1874	1	1	1448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYTqWffg1BN7ErGsX9cyw5PuhkLJQdNfCj6V4yDmrjZYxNA2s
38941	payment	2134	2134	1874	1	1	5280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCoYjPSMWrJn5R5vTFtVt7zcEYUajJuafAbPLCRcxPtyDXBR3s
38815	payment	2133	2133	1874	1	1	4770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVYoY4Tx2zkcHa8VB29Qut6BDQyvabBEyLZtTZsT9seL8zkPR
38837	payment	1397	1397	1678	1	1	14817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLxbHKW8uiwSfkN75iB16am4NTxBK4FfFbfYqdCMDBXd3cBWU
38838	payment	2134	2134	1874	1	1	5253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY2VjZXJQWKf8WiiFxCVdLpbsciUJbScGiJ39zrPEmfx2YjHU
38839	payment	2133	2133	1874	1	1	4777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJeGyMAkmeEFFs1HDUWsuxs23ZnE1ruF9Ju9tUB4XWDr8DHER
38851	payment	114	114	2314	1	1	10	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBh8TRw792EjQHX4iLZB4u6A7sFq8HAscmTkwD86UBHtXzhyX7
38852	payment	1397	1397	1678	1	1	14821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTxaSgRznLPfrp2DPa61vzbe4ffNcLzgGSMbEWUgBG7SNppfV
38853	payment	2134	2134	1874	1	1	5257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYfxPQGKdTszWBckmja36qp4keGKe7tHdiQCNYukREQ4cz6sdk
38854	payment	2132	2132	1874	1	1	1441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAFkK9BuMAxjVcPxBZX7ks591xc1C6ie3y8sVAPRtWEwRsMTN
38855	payment	2133	2133	1874	1	1	4781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1UzjdRaJ4gYT8FTxJ1A9dRBDSMxEbdJCynwSko7WB6p3R9b5c
38869	payment	1397	1397	1678	1	1	14825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZWP28zRGXP7aL4HwSawygE9N5PFTaWBqBF77g78Az77Zk7ND
38870	payment	2134	2134	1874	1	1	5261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNfJW7SGJ9BcezYyAbvC8KQXUGqL3QXhSoX2SdHNJ3EPYX4vF
38871	payment	2133	2133	1874	1	1	4785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSTFYrfz7AHCCWsbDeCixH9WbWwqismsDa5AiWnWiACPhJkSn
38872	payment	2132	2132	1874	1	1	1442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVM4kWrPxREYfYFzuNggTTWsQhvq1m5G6BQ15UUKBBNUQhUeu
38879	payment	1692	1692	1860	1	1	5	67001000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr4tjYregdSCRX4esnxPkK4Bh2pd2UWs4nZqQiNMi1Gnix5Vax
38880	payment	1397	1397	1678	1	1	14828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFijbWF5PMBhkzXCx1HtDhSrhnUck1MkBDULwtVjU4VUpPPvC
38881	payment	2132	2132	1874	1	1	1443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3it3SaQg1k8CTC9VQbvRGkQcT7vhT9dVK6zUKqdBfxeEt3gKX
38882	payment	2134	2134	1874	1	1	5264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4M5La1Pt32ajDb2YTRCZUjY1d68GFeJLz4ZSCPb6yZVe4M5n
38883	payment	2133	2133	1874	1	1	4788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpqCBbPFWVQaeTZGdyohka3GpBfPmBne765w9TYzJNpFp8hDbo
38887	payment	1397	1397	1678	1	1	14830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfjhUSR6idSL4J7RSvQtr5vJuV8hnET2Wezo6vkqY2BCDnDWP
38888	payment	1397	1397	1678	1	1	14831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjXGD89LLkgDRyqcVysRBjbjimzzHTwxqkymcQdQ1Tmawd9FJ
38889	payment	1397	1397	1678	1	1	14832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgkNkymX3ZLjRzEkKeeTVEtqvuX4YeuMSeuU1ChHW1eTCvuF6
38890	payment	2058	2058	2059	1	1	10	90000	2000000	65535	E4YZSJm6ocX1bjCpvP61P3HzTEaepBNYhnSeq4C8cPHiv43qUDfFB	CkpZ2Lzfie7tPc6tQV8K7u7X3ncX8VB8nZZYem2bf5rRKGaNcSJpe
38891	payment	2314	2314	114	1	1	0	1100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbb1LegGnvQnKDrDGzt2QYzQKsWJ8tL3avhtwprxX4JipX9pxw
38892	payment	2314	2314	1950	1	1	1	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7cJrWbpPsZymag3QzzUKcAQaP4edwCs1HrTw5iWeEuQzDYTW
38893	payment	2134	2134	1874	1	1	5266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFeLjHp7Mf6dNm8eWxBrgjQkvq6mxUjgFRdz3CVRpJFwM2UN7
38894	payment	2133	2133	1874	1	1	4790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX2p9oRdDfMfnnLbpH54E4YXquWy5qrn4RcfHLS6uAWMXsXvCn
38895	payment	2133	2133	1874	1	1	4791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLyBqMGhSaucJFGJyTdthbhjBFnJ85XSnCRmaBmejdFCxrFYVf
38896	payment	2133	2133	1874	1	1	4792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjfknzPr7pVWk3T5fqZjVX8sSjBU6J8JLjaSwQ71SZV9RnEmi
38897	payment	2134	2134	1874	1	1	5267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbu6YLncD6jcrRdu5AvSfW75dr9DyjTwLtCJeevKgiwyRxzjR8
38898	payment	2132	2132	1874	1	1	1444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBsmWfjUhssR4EYTJtR89cqf5LaYY2TxmVvKMBye9phz8zue8X
38899	payment	2134	2134	1874	1	1	5268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKWTcrJNPiEY6mb6VaFWFVVvjAXiC59Qke6gpir6tToBV1SG4z
38903	payment	1397	1397	1678	1	1	14834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCvAx5DNkWCh8fGB2F7BKgyHNu5XjEraD2enbSsLNC6B9nizU
38904	payment	1397	1397	1678	1	1	14835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmws85FNJPwHRfzdc52fgkW5D6ym2T6tJrxzYTZz5khqT2J3dc
38905	payment	2314	2314	1950	1	1	2	426500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFAqLnnWsU3V8tio3CojcFWqiwJHG8Pn9YiKDhS9P9ifAQsASe
38906	payment	2134	2134	1874	1	1	5270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPCua2kyXHybBq59pGwLuHVNa71aNi7YfjJFk5pusBtjxbvEU
38907	payment	2132	2132	1874	1	1	1445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkAXqmxZJsHkH71ZxsxG2HS3qjaukHu6QtSj1Zv2gikCxiqpU
38908	payment	2134	2134	1874	1	1	5271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLHMUVDuHXQQa9NUsSqVxuof3NjwxhCB1u6P4NkRgrUKRoQTt
38909	payment	2133	2133	1874	1	1	4794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3j2DTn7GbRSVSUDUcPrHPprgQkVqUrEMLbA8h9R5GZuUoYyKh
38833	payment	2134	2134	1874	1	1	5251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qHeqTKUs487ap3gck5vYumuBiyWSXLFVZgM7iyYYqffZ5MJS
38834	payment	2134	2134	1874	1	1	5252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdiiJ53ZkJtbHtFkapL4wUneCuEJeubcSf6Vz4d2ehjRQnaivZ
38835	payment	2133	2133	1874	1	1	4775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2ri3DE39iLrdr1ULDzMbcN3dnYDxDCrGfwCmZ13W1ta76nDk
38836	payment	2133	2133	1874	1	1	4776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjKUYvmxWrQfcnjMj2KzGewbxWSGYMZqaoBEyXELa7vMiQzTD
38847	payment	114	114	2314	1	1	9	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSzLwZrK5Xyxm8Jysfhwb257J5KDmktFKWvNkfTYUdgMUdWfd
38848	payment	1397	1397	1678	1	1	14820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYto9Yt1RW4tCmYMtVEDMTsJFRQ4aEaX14kPwjQsCex8p5rJKy9
38849	payment	2133	2133	1874	1	1	4780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1GWmBio9QS9m3B7d5WRshgJhGipkagsyfEEN5d8d4GiTerDBp
38850	payment	2134	2134	1874	1	1	5256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB36twEbGAU6sNz7dcxmUTe6Hyr2YMK3VrRZd2jZSMJEQRyjaj
38859	payment	1397	1397	1678	1	1	14823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenEmqN8gY4QRRqPqKtBg9LvpbVUYTYnb7F3GLdTzPVCPsPSqB
38860	payment	283	283	2314	1	1	1	121000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGwWRydipzLk4MxXx9X6zH3Fe5Q1dBhydi6AosBjUDiDRB4rP
38861	payment	114	114	2314	1	1	11	116000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLv4xz9xWPWMqTKGF4yLv1xaCcKUZQ4iBmps2GPNkSYmUkYcy
38862	payment	10	10	2314	1	1	1	61000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3rtSE8rj6yqiWxjt3SHJ8iHC83Wavfu7ezCTRhsL2mchn9Rz
38863	payment	2134	2134	1874	1	1	5259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF7mVieN4wEag47DrMk7GMEMqsAezMzvDYDnbAaodLhaX7HNSg
38864	payment	2133	2133	1874	1	1	4783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEHtpfJiNGV2C7kT9onYy2rbewHfjQgi57LzbBcxHFUQ9DzEH
38865	payment	1397	1397	1678	1	1	14824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6B1ijkVk3p84WFGLp8bsLt3ziYN7BsHysu964xk3EN644L68Q
38866	payment	301	301	2314	1	1	2	130000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdBGVjBKFDyKrR3KBssmmkDFTgtuwRUunVgp3WUYxRvd4MfJJ
38867	payment	2134	2134	1874	1	1	5260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshXE19mZ3s8aC4PPCsdnUtbr4xXtffsh43h2tBv9SmC3y2svu
38868	payment	2133	2133	1874	1	1	4784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJNjBCJm6brxKtLb3eq4oLRJTToegYY3JJJeASC86F98PttbY
38884	payment	1397	1397	1678	1	1	14829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iht1y7tp9bsBuxtK43P3Bzq4id2Y4ypGQ2umHbwKaWpmQdL1
38885	payment	2133	2133	1874	1	1	4789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1zmcSaQN2jT2WLWoNfpmP51oLkBBSpCyqJfKRRvhutZuGU6Z
38886	payment	2134	2134	1874	1	1	5265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGHxpj9oDCKinPXFT6xh17nyECvoVfj74E9yENGKZXJUEYknM
38900	payment	1397	1397	1678	1	1	14833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRW5K49tHRtjPRs2k5gJeJn6uNNSFkhRcmrEECDXr7NhiAZRg
38901	payment	2134	2134	1874	1	1	5269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQXtheyzEHuqBX8aVGiGEmNhjsHvjuEQGGY2ZKdHJ8cpY9eWs
38902	payment	2133	2133	1874	1	1	4793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGJYWNGryqnMWFgKDiP78ef5jURkEE9EGi2Ni1pEF4aFheAXg
38944	payment	1397	1397	1678	1	1	14846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF7RNcfsNPFK2GF992Mvqm73XEfmDzRtKRYGwnv5ziEagW8Wdi
38945	payment	2133	2133	1874	1	1	4806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcBwLGiNoTNZv9SWuZWH77nh3qYFa12DLAYE99DBBJeAYjUSh
38946	payment	2134	2134	1874	1	1	5282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSL3u5mWzBG5DGvjqea919EHBUYYtFQ4oXKbsQFVBRUf9kEGD
38995	payment	1397	1397	1678	1	1	14861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJiuSCpthsYTJ91Vj8rsP6GWeLufoiPJL13fQwYrkJzLHkE4L
38996	payment	1397	1397	1678	1	1	14862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnm7gA8GgSWQisrz4KpsE5W8UHvvWgHifAotgQWeraXvah88z2
38997	payment	2134	2134	1874	1	1	5297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrVsBMCMMqsNXxz4ux2TNdhoW9c3NkY1tCRnoH5B6dKSxdiuBp
38998	payment	2133	2133	1874	1	1	4821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmjsT5DhasWmJyKoV63zfvBYZFpX1LnQT4oANaHcuBbv7pNiJ
38999	payment	2133	2133	1874	1	1	4822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdHARLy6KG32MwhZkmfowQW4m4Uv8ff5HLW5x2Q34PFK6mSoYK
39000	payment	2132	2132	1874	1	1	1453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRNqqbTsdKyYVW3b1VmUE53RJs5E5UNeWXWTS9nmX1S1UU8B7
39001	payment	1769	1769	1769	1	1	54	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycEjm2JVMmjDxU7sBmcNV9VR5EneFebddRW8j9SJhDSE9atrR
39002	payment	2134	2134	1874	1	1	5298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZoZCAHChQTrsQBaNoCPchuCm5svs1Dmjkt3Ypi3jA5AioyDU
39003	payment	1397	1397	1678	1	1	14863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa26s5f1vqSYoiwB8McmMB6GXiZtn65LEzEVqurjP4MFMwqQxU
39004	payment	1397	1397	1678	1	1	14864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfNFv3tbGoPGqBWExcB7rA8PkSoT9dE6HetnzwrbCM5NvomCx
39005	payment	2133	2133	1874	1	1	4823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJTdq438sn8xJV9BXhXPg1foJABY7PTKkSUoGgRPaDH93CcJx
38842	payment	2132	2132	1874	1	1	1440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYshvbDx8vWKMztYcUvoXR92PeE2M4RLXfAZ6etbANTkLCAgUi7
38843	payment	2134	2134	1874	1	1	5254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRWrTnNyzNNxQXBGzsx5cMNczxqbA4y8oXvtprE5WqbYcdDMa
38856	payment	1397	1397	1678	1	1	14822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCKoCWZPZ83DhE7got6jdK2fsHPfKpgPWUamWsVNnj7dvMxc3
38857	payment	2133	2133	1874	1	1	4782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccFGYuPpDtefYnCEGHnRwNDSvUcCix1JKUTRL69syVpbx3zR6
38858	payment	2134	2134	1874	1	1	5258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsx996guVdATbEPTG4CF3EfAeiZYzRtSW8ByF6ptEwX58gNC6A
38873	payment	1397	1397	1678	1	1	14826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83nuKtncSi4CsZwzbVL5fYUHAoCC1bD3seVB3ET5M7R9AgrwT
38874	payment	2134	2134	1874	1	1	5262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMhoXskdVtq4mYz3MbUxgHxaT2Vh7xwV47fdfZCbGJnLu4Bzf
38875	payment	2133	2133	1874	1	1	4786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHujuAsjEbeZhgU1hi4zpZPvt3b97233CJAJdFRRzUrjzEou3
38876	payment	1397	1397	1678	1	1	14827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7DwJDvWxJtYMjKqVHBszm6WrmGa7EkSEvuGt6LSDmofmEn6V
38877	payment	2134	2134	1874	1	1	5263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2b2GSktHU2Je4Venirh3Dnh5Q7enaTawUchEGqhSdRXaAVAN
38878	payment	2133	2133	1874	1	1	4787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbGt1qSVjxFNX12Wj5Av8kQsbbXJ6ibxuzJiHrPT2nhLwau6WW
38911	payment	1397	1397	1678	1	1	14836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBU8RXMqVyDcmrY3D8hnuwStYRpy54E2KGRv6gNQ31VPubVwK
38912	payment	2133	2133	1874	1	1	4796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAjcTPAYmMNafeMLppnCZ5pn9CqVw5h4qk1TjHFR3A8u3xzJm
38913	payment	2134	2134	1874	1	1	5272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjL76rR5spm8a1ynyMYRWYaoikrRx4VTEN4cguK1D2Rv2bvk24
38924	payment	1397	1397	1678	1	1	14840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRHGt8C3PBfwD62ZTviG17VQjUBAzdqKoP3WjTQiqrKe5Tb3u
38925	payment	2133	2133	1874	1	1	4800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwhqCZ9B8i1Q8gDdKBgzrmEjiS5nJhmTTdE9pLRUYEYTZsWYxS
38926	payment	2134	2134	1874	1	1	5276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCL35hzK1kNyzeF1WeW5U2XHraDe6bBW8wb1ujuuHgKSBUSCmq
38927	payment	1397	1397	1678	1	1	14841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapceHNp9DwHcCQTiPbGDBgTpYAnWdpQDy77Zwq21vDmHCZi7u
38928	payment	1397	1397	1678	1	1	14842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytGWtXXjSf3xJkAQeF3vn1LXbS6L4AiYupw56Kg4j1v7kDZGM
38929	payment	1397	1397	1678	1	1	14843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYy98nYjM8yzEarDXoHmMPmRiVj38ZMSB7qrR3ffooERdVS1W
38930	payment	2132	2132	1874	1	1	1447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkUcdSfDrY5UpLu4VaA4dyC6BqJjREMEdbXoh6HVPVDmmWKiiJ
38931	payment	2133	2133	1874	1	1	4801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFiEUHBPdfV7oYvzcmGZh5fzQgX5SHxgLGPZACyCRFqGMj5hd
38932	payment	2133	2133	1874	1	1	4802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZvKFNjpSBqcPEziy2uEP1GQWg7YGevo7WV67PgVdGKwe8nhq
38933	payment	2133	2133	1874	1	1	4803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWU7E6QoUzHVN7LkMZxgnTVuGVyJzC1BGhLuBsqU6RoTLMxnQf
38934	payment	2134	2134	1874	1	1	5277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv2Mbhi26ub2vXC71i9jdHeztRkRJehC2N2pmJubjaJpgTKbVN
38935	payment	2134	2134	1874	1	1	5278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2j8HC388qqfLGDfdQzKVWE3pYbbzkrAb3R9gzCqEF6hzHPaTM
38936	payment	2134	2134	1874	1	1	5279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouFBdWyDPefAGkQK7JpcNUEqNQEhnoH27VJNGfMpL4mDmKcZK
38971	payment	1397	1397	1678	1	1	14854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTo9An5KAmu8Bwf5j6kDQWgB1WycykVPUkVS4NszJJc5ic9D4
38972	payment	1397	1397	1678	1	1	14855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvstEuEKjzqSjdeeabUbTfH8HZKESqv55nA67G4vSbZDAnN1Ua
38973	payment	2132	2132	1874	1	1	1451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyU7utEAxed4fxMwj9Skk3D1ZoJSoLidhRmtgPT2n7NjUD7Aa
38974	payment	2133	2133	1874	1	1	4814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZRBgzSy6pTUKQxVee5S2xJSW7Qy8Kv92a4j879dEM98Ws2mz
38975	payment	2134	2134	1874	1	1	5290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3q3Gghkix1B62YqUhdP8hzB9N7ZLm7DpkTx8MG5qMenPcYj7z
38976	payment	2134	2134	1874	1	1	5291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SViHAVRKbmxrfUvN4DzjL6udEy5GtdQW5tVvrYki33UWWe2K
38977	payment	2133	2133	1874	1	1	4815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xUN2mDbZeqq7TjGXYzZMwYxL4dDseNzw4oSNk8qYuVLr7G33
38992	payment	1397	1397	1678	1	1	14860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCdub1AWTCCxSku1mbv9o5M2nQvuHmvY5tnsReS5tcpajWGzK7
38993	payment	2133	2133	1874	1	1	4820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxKNHrCoAeDUh2ALd1ihrWiPfE47vMu1Eq63Cfh8Zw9rq3df2o
38994	payment	2134	2134	1874	1	1	5296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc5SrBW4685KFkr65GA6i8tSHYMDtybLzXpsXE5GscD7WHhszZ
39015	payment	1397	1397	1678	1	1	14866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesiupAen6dyyZJ1Ntz8WCPTE1gHcMsF9ak154hMAmDRWGMBde
38910	payment	2133	2133	1874	1	1	4795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPKQLf7YqZ68p1e5UfqyRUXBStGA3x92ZcWVxUcsPxB29tfrE
38917	payment	1397	1397	1678	1	1	14838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJugtCpYrQcDYFCWBywPFH1jWWcWCBbyGPc6wBzXYvc58DyJ6Y
38918	payment	1397	1397	1678	1	1	14839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkMsMZKha8sbnJkHwQkYGhd4K7sH794d7fD7m8R6aSrC8g1BE
38919	payment	2134	2134	1874	1	1	5274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUvZ9BzfCDPFNAoz9MNcERL5HXNTWzNdJdo3cJmVSNS8vN4Wf
38920	payment	2134	2134	1874	1	1	5275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfXauRcVEJH8m8fHXeYTicEX1yqDU9cJsD79Pi6qkyErvTDQR
38921	payment	2132	2132	1874	1	1	1446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzagmyMrps72DkDa5MZFBLrFhkkg2fShWGztnYWBzzWYUmycp7
38922	payment	2133	2133	1874	1	1	4798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDNPh5CDXszzV8umq76az3n24j5FvjRgMKfCk3B6xkGbtTETUz
38923	payment	2133	2133	1874	1	1	4799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwy14sMqCNq2sd33dt7qTRjBpBuTBJfy3SA8nU3WWcBKvLrEzx
38947	payment	1397	1397	1678	1	1	14847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuk1paiTDuJLemuG8cEs5fvbwfDSdewv9nUqQMuG1Ur1gkJHb
38948	payment	2133	2133	1874	1	1	4807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydmLtDWJneh61D75xRYabHfada8M8NCJKZr3vz9R7BzvyArZn
38949	payment	2134	2134	1874	1	1	5283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpjzNvSTHeqDQ3KZKhz5sGSCCqFkjHSZYi6zVbbpy4TuFVrfn
38954	payment	1397	1397	1678	1	1	14849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAef8cSXC6tWBKkRoDxSdBcbvRsMqiLhK8mEx5Jf2D8LdhBRU
38955	payment	1397	1397	1678	1	1	14850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmqmEF3ipuaNMUNrSdzpjX1n2aqkD9jFD4wTD1VqtQEwq7pTLr
38956	payment	1397	1397	1678	1	1	14851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHU6ChVCSvt6xaPo7NBRutk7JBFwfbKuzNRBmZoZJrjqMyBww
38957	payment	1860	1860	2152	1	1	4	67000000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufzYaxMv9w8wtTcXzNL2HzTzXZXK3u4VD387BQbrb8QP6KJ8F
38958	payment	2133	2133	1874	1	1	4809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3ySaQno2yZSj4KMYnHNDgy3fVErGxf1TcExj6yisKSS7GVBQ
38959	payment	2133	2133	1874	1	1	4810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZsnKbgFa1XpemGgYHeoToyTjyZx4574KipXggV5ajrFNWN3Ng
38960	payment	2133	2133	1874	1	1	4811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBSTb7rrtaxf8N3WZuLvnXZwAbva3A5cdrvLpf6NeUj5UrbcY
38961	payment	2134	2134	1874	1	1	5285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFvQiNMKtrm1YJ92TfqTUYen7JXtVg1xaRu12CCPsNPM6TwT8
38962	payment	2134	2134	1874	1	1	5286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZeqPeL78A3r3T6pgJ9yMUDwrzE5BfzTjWKvRh1h8kDHEgsfRV
38963	payment	2134	2134	1874	1	1	5287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFhYMunL3hWvzeCjoUTyjTYTMyUZc4n2m2Xhs6ntGZW4YYd1wg
38978	payment	441	441	2314	1	1	1	122000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQ6JiUWqTCHAJq4KQNb9UvpfdtrxpU1PB8VJLSXNwFNh7XMPL
38979	payment	1397	1397	1678	1	1	14856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTPNcZWJu9K3pAXCJumcmHpviszFq4tkchwocPx4GfUK1BzgW
38980	payment	2134	2134	1874	1	1	5292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeE8KWG4GVa8pRuqTg4x1K9ovgToRnHBR1AueFtLo83qU6yVn7
38981	payment	2133	2133	1874	1	1	4816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87gTVdenAKhgDpcmDDmRDwqMEM6WYBHjdAS2yFXnkpA3jw1Td
38985	payment	1397	1397	1678	1	1	14858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrHwqyFJoFJU8igdo7K7JA3z3PeDtj4QrMEReijZb4zkhUk5s
38986	payment	1397	1397	1678	1	1	14859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGyTMkmqLT9KkjuqSppZVuDLNi6z78TYfuQCXqx56ZkDe5Yf5
38987	payment	2134	2134	1874	1	1	5294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSczjG7BkQYSjnsQgVS3ku3sCmTUgocH6X2wn1M4mMdcjnFpfx
38988	payment	2134	2134	1874	1	1	5295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKGQ6M9VuX2KFXZgdobcfYDjRKJZXDa68tYZswkkgxoDr4qiQ
38989	payment	2132	2132	1874	1	1	1452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7rfBQxd1mmCohTWqZtJ12MGJSAyHCyMgm571PBZcoF3GNbNoG
38990	payment	2133	2133	1874	1	1	4818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPho6twyPFz3LY749NtTsTSTKJj7jYyZgLcqZhXrpxJ6okx4u
38991	payment	2133	2133	1874	1	1	4819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE69499C9oZJzqJKtdAs6DLUhH996MRArgsob7Sv7ahgtbdftR
39010	payment	1397	1397	1678	1	1	14865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwsYcKrb4ESDuoxLEo3mAnUdbJzM2GSzA68gUdaGf8FPXasTm8
39011	payment	2134	2134	1874	1	1	5301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7ywA5AbhepdJ1ePVV4QXCJAD7KskFiruw2GtA9v2D2JVuVQF
39012	payment	1769	1769	1769	1	1	56	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWa7TV32nWvyZFQBfgKLvNMckEXrCxjFDjF3zyjV4HyJrQiRkV
39013	payment	2132	2132	1874	1	1	1454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa82h8US2g9JcdFXrvRr7fvCwAJwmQZHa2AQCdPYgunqsVGu3tW
39014	payment	2133	2133	1874	1	1	4825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENQt9Pgwd5f6dg2xET5YwbVFp5Xr3n5ttZ4MTLp1YX52wecKZ
39018	payment	1397	1397	1678	1	1	14867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRusxmt1Ep4Mrduhpmpo4zGQgcRgcALS1AjupHwKiqfJ7qtBAn
38942	payment	2134	2134	1874	1	1	5281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoShA6uCuTNX62nyiaxc73BGqf6yBNWZL7E1CCHpufTwDcWJX
38943	payment	2133	2133	1874	1	1	4805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFh16T9Et4SdmAH8MsvYYhjmLiGZPLoiWT37nuUo5JftmEWG5T
38950	payment	1397	1397	1678	1	1	14848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7db8R3wHcPdeNob6UZc8vEiVzPQ1zEbGJE1pJaFF9EbzKQ3y
38951	payment	2134	2134	1874	1	1	5284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbGLNupCSnRAUkJ5QaEG33xFzxqARbTuuXxoPhGNtDZ5KsWA22
38952	payment	2132	2132	1874	1	1	1449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43hkb6W8NY9z6XBn5iEL1uwWJoQvPpepCMfHGQvcdLbgDNfZm
38953	payment	2133	2133	1874	1	1	4808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpZB4QXQSvvLLgrPA6Cs2hRibxuaFEgRbAttQ9MJXjsdpDLiex
38964	payment	1397	1397	1678	1	1	14852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLNQ2mxmXnoX3ncAdsNFZrArpHvovwF1uG1526rmkiVDEtRET
38965	payment	1397	1397	1678	1	1	14853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcgosZuHnBeThD8CTgMJWj8KdT7cUGNyDo5wF55KDqFBfgcuP
38966	payment	2132	2132	1874	1	1	1450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7c8oY67kVaymZ9nJKvqbYaM8NMuXRYVzs5HQWtnnxsvxsSYno
38967	payment	2134	2134	1874	1	1	5288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jkYdy7h3FB6mbQp791csrn6zmQNbke9bQgz1JnXWe4eBgQwK
38968	payment	2133	2133	1874	1	1	4812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbY1NsBu7fmJrXaDhKSgWoWMMGCBXUiJ6VXGy7sxqjetiay3P
38969	payment	2133	2133	1874	1	1	4813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWhfJSRXzbGM4c4LeBhy2CnwUdYLB9jJkGPiSa4geQEo94zef
38970	payment	2134	2134	1874	1	1	5289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fDFmBjhnCmSd9cvaym4k2k7ceV7kc9DJ6ub2yCWB8Yzj9ho2
38982	payment	1397	1397	1678	1	1	14857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiiWKZ36d3BsLSEp5S1qxLKY4ULccX9t3XqNzSsat21r3U61V
38983	payment	2134	2134	1874	1	1	5293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAbFo3hR1WakAPsUU4Ke4ZpR85sKX2ffBZnVzxYqHZ4VCkPHr
38984	payment	2133	2133	1874	1	1	4817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiBd6W2qVrp7VNYcZXwuh1d812ZUd2azYZQ5JNHg65nkv6K1u
39032	payment	1397	1397	1678	1	1	14870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxx7jkHknQGxJWmPPpLZHdhucNCqZWRCTad1nTjvKWz47r8Ag8
39033	payment	2134	2134	1874	1	1	5307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYmhkGK9RAo5pjmK1SAkZpqYhcaMQ7XJaKY7yQS1GYZvGixGz
39034	payment	2133	2133	1874	1	1	4831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwm9bew8hbsXWDRbuKWB75eGeY73jjovLENd51emAzmxXb95Ti
39061	payment	1397	1397	1678	1	1	14879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Dqp7pySRGndtxGXsa4xTDir32zehWYNQUuGsCdoPVGnPN8BF
39062	payment	2133	2133	1874	1	1	4839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvgmsfcYMShh2CfRUPfJbcFMvaFkg4tX852iJFyJwLGLsmF2J
39063	payment	2134	2134	1874	1	1	5315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q1uKWaFNCdkJpUzxs7SgLngfY7bvjhU6fvpibmFd5fZdoD67
39105	payment	1397	1397	1678	1	1	14892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqfSmfRZBWzrBQCRFKENPgmzctet4Dy8X18dn2sDoLYNoisez
39106	payment	2133	2133	1874	1	1	4852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXKgLKVMcRGGQya8bmXGBFJG8fVsBQLZsf59ZX1SnvcSR75Tk
39107	payment	2134	2134	1874	1	1	5328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqbgktvkdKrRx51yAYSJUX4SNo3JRU8aouni1C5DeyW4n6Wzg
39138	payment	1397	1397	1678	1	1	14902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcq4jxCQbhHd3LEySaRnHHuQxjgpUevY94At5rgBDVdrJHXkL8
39139	payment	2133	2133	1874	1	1	4862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD2hcbghLwcaTUZqtRxDN8ZXXeNkuSALLydtb1WwveRGmtR31
39140	payment	2134	2134	1874	1	1	5338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLQwLdbBF9dUAMBK7NywRMAVr1HdV3JUDopp4FLbVUWQ1Y2GW
39141	payment	1397	1397	1678	1	1	14903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXqjWjTk2PZBprE8t2r24fQTVcsDmpxYDDwqEPAtUoVqtKN6v
39142	payment	2134	2134	1874	1	1	5339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMaK2u7PNnFYymk2tU1WnxPFYZPCL8ofK5HZvnHxNqt4FpgMY
39143	payment	2133	2133	1874	1	1	4863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrLNY5RUFZa9Uqmm9vF9FRQoURsomfa52sJwBZ5GbcVyNnwye
39148	payment	1397	1397	1678	1	1	14905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtcXnkYin3KX48cCeL6su6xdRrS8rMhrwGbULD33TSaTM1xexr
39149	payment	1397	1397	1678	1	1	14906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwGC98H5UmRh7NXc63jMWuPUVBdtBqrzyfizG2TbN7zDPdGiEZ
39150	payment	2134	2134	1874	1	1	5341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1CqVTCQgVG84tyRnVCncrMX4baiMAXqTDVz8ivuQm1AsEgEE
39151	payment	2134	2134	1874	1	1	5342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSA8MTcYzZKoiqLP22gFaRUKk3rT7mZpkbW1kokAi2z3TPFdP
39152	payment	2133	2133	1874	1	1	4865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPqchSjFxoHzaG7hf7r9YrJWAR2qXNe1UvgzZYqX5fydJzCLu
39153	payment	2133	2133	1874	1	1	4866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSawytbxnnaobTH6XKo4sBJLBmRXcpkbZXJuZY4kdMeCBFkik
39174	payment	1397	1397	1678	1	1	14913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnL9tw1u8WpxxRgZJjPVMEkEmx3UkaTartJg9qjDsxQuMVpyy8
39006	payment	2133	2133	1874	1	1	4824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLCFFEWCFuKSC81aXLBcjkRTxAfcDCpmV8d4VMAZta6HcbiiS
39007	payment	1769	1769	44	1	1	55	1200000	1000000	\N	E4YTEpdaHPs4eTMVQZCGJbzJjCjGMTdoq6YYKipHpkPnPm6RzUAHe	CkpZoggFwpjR4CNxhpDkgtUugY1km8n4HYV7qMPZT5u2maiPhuHh9
39008	payment	2134	2134	1874	1	1	5299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFWAVm11Ky3moqV5Sz6n4NLTqJqywKAT9XYQLDBU5LWAcedeY5
39009	payment	2134	2134	1874	1	1	5300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQBSnafsBrrRFqhRsR45NbUhQJ49BSHqPmXVCZaie2RZzTfaHV
39035	payment	1397	1397	1678	1	1	14871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6g2vMgPZVjmpksgbTGKtQqRBg9TfrFz4vxZkP3fBhMqv8CXb6
39036	payment	2134	2134	1874	1	1	5308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3rNod7w9Qrqrk96WJvg3tJLiABHfzKfX5h1CyGRidWkKeKZ2
39037	payment	2133	2133	1874	1	1	4832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJroyWKyEaULdu9v6GhFZETWE3CEdDrbsejX21bN6hjYJvWBTk
39038	payment	2132	2132	1874	1	1	1456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbv7yzXvR6K9ABnZmQZniJfNH68SUtRzNARz9fbpBo4Vb4jsuV
39045	payment	238	238	2315	1	1	5	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAe5N8by9gemENkZ3Ea4kVsbKuLkGCriZSwtbajQejABfzCRm
39046	payment	1397	1397	1678	1	1	14874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9sE2fhTjzbszfXjy5BiDdKXMt36a4253csc1vPGKTfc4SkAd
39047	payment	2132	2132	1874	1	1	1457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkbJiSDSxyy1VEpZxQestj8pavoqrqMzz6trybSqjXbWHbyfY
39048	payment	2133	2133	1874	1	1	4835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5C749EvrfKzxSqUfSb1gVuhswAdLWfpnZX4hkg7zWPjUBvEd
39049	payment	1397	1397	1678	1	1	14875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknGWarohK3bXKYX7W1CqdUwn6gBswcQNRChMWXM1JmWD5tnCZ
39050	payment	2133	2133	1874	1	1	4836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6gzUnPrvVHztUqDX87wWDUkZ44pRL4jqGU4UWyN6TwpHmjPw
39051	payment	2134	2134	1874	1	1	5311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiy5iiBCrnjepCdo9oHfZx1yKhhk5avV2WHkeg6sWM7FXyF7md
39058	payment	1397	1397	1678	1	1	14878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznxfc2S3ifimFjgyAcoRVWyQJPhnsN6hyCXysd18EY2uuCJLj
39059	payment	2133	2133	1874	1	1	4838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFwb1U194K9ZYsX93K1qWa3NGk6ipakvBKo8dJfbQd4Kpdu31
39060	payment	2134	2134	1874	1	1	5314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4rB5AzEZ5r55FRDmcjsiLfDppz27RaxZeqLwSAKArJJxwdKa
39072	payment	1397	1397	1678	1	1	14882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfWuyRvbRTsFDis5HuBgQS3jLQtYGf312gowUx5JniR74zVbv
39073	payment	2134	2134	1874	1	1	5318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHiuxH2cKGhqFZGrs5vG2XkWgLMvLXJZNhGpwnuqr1tfToUrSW
39074	payment	2133	2133	1874	1	1	4842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncy7zfsQMeLWAbCW6QbxjU61csrjoNvZ8NiY9GAnVNn8My3fi
39078	payment	1397	1397	1678	1	1	14884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnBExoxP9hsiAiscyfCbcpWnjD1ZmsR6ebJdt2ioEh1wu1GQf
39079	payment	2134	2134	1874	1	1	5320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2pvdzNPp1sihBeaX7H6L2x4tySmECDyYQHCEUbrpq2xUSba3
39080	payment	2133	2133	1874	1	1	4844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumPKdyx2f6BzpeT8bWLxk54kAh3PebtP7Khq4txyq6f5kWzLg
39081	payment	2132	2132	1874	1	1	1460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPkuiFfp63pSES4Des56V2L7qGVTLQwK5h3yx7Dh9JeA3ZKcm
39092	payment	1397	1397	1678	1	1	14888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK7zUwb9LW3ioJReJ1GpCUi2V8zQjW8FTbTv2BRKeYcd2SpTeK
39093	payment	1397	1397	1678	1	1	14889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxC84kJtTMQE4Wu3kb9gSwj9RvtacimzQ4K4yx3m5qYTDFWir
39094	payment	2134	2134	1874	1	1	5324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZZSNk7SXeUcn29Fcu7ieSVTZMzVNbKaKw4jTyzxTiQ3cpdNh
39095	payment	2134	2134	1874	1	1	5325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKVmGarhgZcUacjX9ePdRYyorqasQNFqUSvPb57tg7AhQQCSq
39096	payment	2133	2133	1874	1	1	4848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdmW6oCJSH3BHUJ1iRZTg9MxMUHJKNt66Rs81oGAtujtzL8D6
39097	payment	2133	2133	1874	1	1	4849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqh4JWqiU8uEmjWH1gDpEvyqmkxRBNLZckpJXkRFpSftapKew6
39108	payment	1397	1397	1678	1	1	14893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKCvaMrtRYmjkFbDDeFGSQxHcA5Wq1KZJvpnSCradXpMj2eDYB
39109	payment	2134	2134	1874	1	1	5329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRBs3o1hbvK47s8LMsv4KDBQwqndCY5CNgXNgowjz4w8dgVab
39110	payment	2133	2133	1874	1	1	4853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe6qtG2prx31wvUX9kMgXuKhcNH2cmjm153vpVWwgEDaCJJ1C7
39118	payment	1397	1397	1678	1	1	14896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Fr7qxrSiKNW1nS8gQcrUqx5Qxnu1wScR9WC43Lc7vaZxhjU2
39119	payment	2134	2134	1874	1	1	5332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV6s4CxmnsZm8s4JSC2CasW8vTbNtcNMGfHfKVAajiH6CUZAVJ
39120	payment	2133	2133	1874	1	1	4856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWnfgqAe6PfWgrTgq9RgooFqmKUX41wTY5YazCMLqXZN2AXRb
39125	payment	1397	1397	1678	1	1	14898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3beuiBo457JHTJj3fsC2hvTVLsY97fxKwANR5WRw3UyKscTHP
39016	payment	2134	2134	1874	1	1	5302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdsXKJAcHgugdZVRQPzfGV9jsJJwXT5EyTtqiyW2tUoBx1Lfi
39017	payment	2133	2133	1874	1	1	4826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcvemkP94pcVtUAmJvQZzkNsTP8JdrF2yaoPATQCdYiBNAgYP
39039	payment	1397	1397	1678	1	1	14872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLShaKaEP3hCAzWn8Q75Agae3UUJVrtooXateJdgqebjJWmssj
39040	payment	2133	2133	1874	1	1	4833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfTnqWWrZpNYAbLLNZ4toUHLRg8CWGcmuZKCRTn4DzZ6d7cZd
39041	payment	2134	2134	1874	1	1	5309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3PsRJg5Qibd5V3CNP8ngQYMYjap9TxBQjD9Y8oyX1fNLuSuo
39042	payment	1397	1397	1678	1	1	14873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79mpMsWAM9HdDYRv44y59ZBd2m2wqYz6kjqdR1dkJQwXAfWmC
39043	payment	2133	2133	1874	1	1	4834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLk5oDmXfXqBavBHKooDWQB4aDnpu53vQ16G4xfezkMmAJWJw
39044	payment	2134	2134	1874	1	1	5310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLw7rwfiZDeCkwWyDmPkGppoVqJxsfnkxaZeM8ztS7p7V93z1
39052	payment	1397	1397	1678	1	1	14876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrCYdJzpkZvSZHCujgv7JDJFYw2vEZai1wmp9bVGNNf45JLVv
39053	payment	2133	2133	1874	1	1	4837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiphnkUv6HHguCWP7UtJsd7YEPVabkZo9ScmNau92EH1YrbwUq
39054	payment	2134	2134	1874	1	1	5312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAfVGJbE81Ty6EBvsndnQjAQZKb3STUt8txjd6qkr5Z9Rxcstq
39055	payment	1397	1397	1678	1	1	14877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXBYWsQhtkjD5KcazCeuxqVhwPAUxybhXcSboA6z5haHu7h3D
39056	payment	2132	2132	1874	1	1	1458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZJLH48VzpdQGbt96stk5mhB1ceeMRpHjcvpWCZZ4RWFxfSCp
39057	payment	2134	2134	1874	1	1	5313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrCmkoztNvHrwp6yrXNVHbAoxz7EgHZDArfiSNLyemUru9pe4v
39075	payment	1397	1397	1678	1	1	14883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrL6uTT99G4zfajJeHqanJePVNM5SDYgA1SopvdoeZCAwuNB7
39076	payment	2134	2134	1874	1	1	5319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguUvNNuRVDwicH4HDSxRaZ9oj7JbNbcBmJrxfSFDaPpNwqpDq
39077	payment	2133	2133	1874	1	1	4843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiWKSytWHQQWSVMs4kbcgvgP9k1isvbgbEFoRhdXi8XjPz7Xy
39088	payment	1397	1397	1678	1	1	14887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZizivFAYmSAaocWzGFfbsGqUaabbfstyF8qmoPjSxm5ib5Huux
39089	payment	2134	2134	1874	1	1	5323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULwaff5uMjxZqJT79aL9wihKXCw3mCzjyaDQtGWe9YodkDBcb
39090	payment	2132	2132	1874	1	1	1461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CgrkLsRDPntZAYoSxi43xArnbviUVAW8M4SKvfhMhULjtSDE
39091	payment	2133	2133	1874	1	1	4847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3sRCpcYAvUBqXc4AttLYNhdBJ4gKeoc1PjD1Mj1k324khrS6
39098	payment	1397	1397	1678	1	1	14890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFQd9gXd5yGJDbG132nQ22CqAMfKdnjaP1AnaGNnq3Tdee4Xh
39099	payment	2133	2133	1874	1	1	4850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9MagoemDDtS9a6VhHT99u19bAXjPhgNTu68GtXYFASxUuw3h
39100	payment	2134	2134	1874	1	1	5326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVEzL2sALxwxzTjy8YdP2hoNAptjcayXZmRfnLGrDSsti2P8L
39101	payment	1397	1397	1678	1	1	14891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCnbBeG34hg3yDxTHuFUoPHzm8itAK2ZP2NR2pxkZQNBwBb5i
39102	payment	2134	2134	1874	1	1	5327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4HEjEzx6HL3cegdpjMtNfRNhsZwZuQh3bp7Jsecgmg85eC8E
39103	payment	2133	2133	1874	1	1	4851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8JNd7QpAq34ztswfQ29tXKmPtLrzRDaiCjPjRJcSRd3h26vbE
39104	payment	2132	2132	1874	1	1	1462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRhrS9dG1FVhk8TgCYeyVsyZrKZg7w4DXMZ7QEW53qLoSQQ2J
39128	payment	1397	1397	1678	1	1	14899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHJz6kmN95gxWZcCaujoeFjHnvj5rVayACeQsiEpDUdwjSovk
39129	payment	1397	1397	1678	1	1	14900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYsepZ1whr4hBrYw9sZZMTejEWPDMJhzERH1rSMXxXKVxWq8i
39130	payment	2134	2134	1874	1	1	5335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXdvzcUaY5EbpHFMhAMAMFJnBNGMs2do3CfgiviLWfrYk3FsH2
39131	payment	2134	2134	1874	1	1	5336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj3qatcsT14GbMYdbNmjdcW2EQKXSBji6JPbRTT6YXr4ptRzHp
39132	payment	2133	2133	1874	1	1	4859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WCJBmCuF9XhFUHB96AeHuNG7UsUaGCSzyk18TSTCu53Mk6XV
39133	payment	2133	2133	1874	1	1	4860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEUiebLKVcUUcajib8apJQBPvtEunxWroSeJR7vGuUzJsPZ88
39144	payment	1397	1397	1678	1	1	14904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJntWH2MV35KntKnD7K5HnAELRL1R9iqygn3W8fDjHUxvBuyH
39145	payment	2134	2134	1874	1	1	5340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoS1rDW6B5FEq21SCdXz2vnNpg29hKs1Wx1eC8dS17fcHN1Fu
39146	payment	2133	2133	1874	1	1	4864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceeYm6sopX97j34Nx7o6yuEvNj3765Rs2rY5XnLJcucEmC9xo
39147	payment	2132	2132	1874	1	1	1466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtLwArU61teCW5XQGCP9BrEfoPLBLA4d6rwmpbJiQNa95REJHU
39019	payment	238	238	2315	1	1	4	10000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFEPzmgCrgMu3xC61HxmjSydAktrMT2zAPvazbS3xm5twRWdb
39020	payment	1397	1397	1678	1	1	14868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmVetoViJbzXoVXPjJ8vMuaJw5Kuic3gRLHdbB4dbHhnFUN5o
39021	payment	1397	1397	1678	1	1	14869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5gjhE6q523g2jibbgbfFjTFT2YMN1CnqHbvkqnfAyxG3HNsg
39022	payment	2134	2134	1874	1	1	5303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAiv9TjD3XPwNKiGZeHY5yhCP4TUoQjdPq2PaTYbQA2QkqS8N
39023	delegation	1769	1769	1406	1	1	57	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63U4dZUQFAA6KLbCzLY1WcDVHwv2EcyGuh3sD9HxASjaDwvmH
39024	payment	2132	2132	1874	1	1	1455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CGWqaMiNoi7t2YKo4ME3v9qAkqF8u5uCksBn3mbxYaD6b7QU
39025	payment	2133	2133	1874	1	1	4827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HuBd79qPjKV5CussApmTSUDV77JxZyaawaPmLiQSB6PWS1iH
39026	payment	2133	2133	1874	1	1	4828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswYXnAqACoLFKFkUGmVcxLTpuvCEVC7qQydMEwoLahK5Wbda8
39027	payment	2133	2133	1874	1	1	4829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnE2UJPMgCDUtWN9gYkrjUwjsFQRCAT8nzzUGyHAmgRd8xy5xj
39028	payment	2133	2133	1874	1	1	4830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVPMDC6PP6GVYSfNsWfEKdHzpRd66Bn52rabn83Vdgt9ugST44
39029	payment	2134	2134	1874	1	1	5304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCvNqRvDPESA7wBdL1P2EQYB65pF45cxThQ8dL2cx4PgA1sss
39030	payment	2134	2134	1874	1	1	5305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhe2xFxj6niguSEtFxCpw9ih9QSUKmaVHQhJVHKCdBVHXS2DiP
39031	payment	2134	2134	1874	1	1	5306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnVQUdiMNdVPiHZJXsgWhCAUDFTxmuyp8JERD3853sA77FHRC
39064	payment	1397	1397	1678	1	1	14880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4YxzSeArYDKCUhLEkSjPGXmbnRcNW3ucipBy1PMCt71qWnpR8
39065	payment	1397	1397	1678	1	1	14881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnGY4TS1eNNnVRz87y4gaRkTfsD4epKSydwt9SQXKaRGfD3Cvw
39066	payment	2133	2133	1874	1	1	4840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJMiywiYHUE81Ndy3LbgMfAdyS5Nc48hPSYoPgN73yqj2aMPL
39067	payment	2132	2132	1874	1	1	1459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7jT5adyFkSLe5yA5QiJrXF1osikXGrXD7G5YLBByHSESXjHf
39068	payment	2133	2133	1874	1	1	4841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGgkqsLQUu9KZYtsxkxHg6ZhGeL9aXFLES8BLX5c2Vdht5ws2
39069	payment	1769	1769	1769	1	1	58	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZ9pQgM4TRCieNPjUagpAN2NkvygNjMEJCRfTvWXfCZZJyCxV
39070	payment	2134	2134	1874	1	1	5316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSC3iemrZeGGh8DqAbaN3ssBsLdUoQzPBsv978oU8KshXPQUc
39071	payment	2134	2134	1874	1	1	5317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DB9LndpRtoe74TQwkFbT2SUccdp2QbBB14hzCVWnj6GwUm4V
39082	payment	1397	1397	1678	1	1	14885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyvwnagKB1HAMcnYVwy2ztjGVoynpkXwMu3qWKzSTPdoPDg8Q
39083	payment	1397	1397	1678	1	1	14886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDhbZUuP49sSHzfMZWqYeHZ1uACEweMPkVBYTbKks2ZvnNsb1
39084	payment	2133	2133	1874	1	1	4845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSmsptUHrHJ8rdRBnuPc7U4giUGaoBD86xcBR6oWk1iwRDsz9
39085	payment	2133	2133	1874	1	1	4846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbohNA1zRu2hRE6UXC2ihsLkqmxWrBZqs8tJRMqCQwJW3BAQJs
39086	payment	2134	2134	1874	1	1	5321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH8Nu1tiHaLq2uvKSBQj5Fi3TJdpPPfTZTaWCRciYniySpFSyq
39087	payment	2134	2134	1874	1	1	5322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgrZJGHgPWmHuoB3iyD5g2hhE76x7Tf6jvhi16FJh7z3FRBmp
39111	payment	1397	1397	1678	1	1	14894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBQRc1iTeNX6Bz2kcbWnJKCjLhfLCYpzpB459KmLpwaXN3suy
39112	payment	2133	2133	1874	1	1	4854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrU7sPrAb1eepGprejPCiNVNnGzgmng2LRFoVzqyUP8oVyYK1
39113	payment	2132	2132	1874	1	1	1463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYct2SLfaobUZNLfS8xBKFHRNBfXnfJ1avtrhST7AK1BwZXDstM
39114	payment	2134	2134	1874	1	1	5330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikQyvTBYhVvbTopaybHbrRxtW9QAxydLRRMUbGBqimPwxfv3G
39115	payment	1397	1397	1678	1	1	14895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtcMgBqXJ8WfjtaQdGFjmoFeREzDWhT92i1WpSNRKBPzzi14K
39116	payment	2133	2133	1874	1	1	4855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjYWCzYirxm4da2rypd4i3PAzQDR6CB1soK3TwWFV8x7o9dAx
39117	payment	2134	2134	1874	1	1	5331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBpUjV2u1s6jGrzTSNTgezKvZXY4o5HMKcJvha5qpNgwQiRr1J
39121	payment	1397	1397	1678	1	1	14897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdN2RhAC5LcQpKLj13VEQkWAsommXPb7Mu4hPYh2G1CvKuWjd
39122	payment	2133	2133	1874	1	1	4857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFQmatMfCBTSPbSb2JCzQt5yAcW7g1GTdwZ5FSKdKGDJjchPu
39123	payment	2134	2134	1874	1	1	5333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJjZgPA8hvdair6gYyLbUFkv5AfV24Lt4f1yfhiKHdMLY2Lgs
39124	payment	2132	2132	1874	1	1	1464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAD1GiAionweXJ4iU8U5HxrPXwipRViJDcxPUpcYa7ZHcEhDXw
39126	payment	2134	2134	1874	1	1	5334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWnePwu7tcLjgGknUn3hAX1RxG67auWUUbfzutfDxR4M76NA8
39127	payment	2133	2133	1874	1	1	4858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwpFJ4TnsQ9LTC6LgAu6zGXaQfR8RU1oQ96skXnEqjYkf1ALzT
39154	payment	1397	1397	1678	1	1	14907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykvb1Qbd7Zn8qvmX7HL7BuL3gFWrJFsLoGMmMGEkJtGKxKz85
39155	payment	2133	2133	1874	1	1	4867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjwvBXL55n124ooxT4TedEzSJ4vzB7QfLvtTBpjiHBzmcKz4C
39156	payment	2134	2134	1874	1	1	5343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rbqLUaFdym1zCckPfaUGkf1UDTERrViUgDCu5wJsea4VfGyb
39164	payment	1397	1397	1678	1	1	14910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY6YhNX8vTMFTwzKryRQfVJttBuGdruxEeFtbZ3BGXGXxGTssy
39165	payment	2133	2133	1874	1	1	4870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSH8kZ5oGFC7CHm8kTTSkEWLGaffvE4gnxom5zuXdxFR1jdnoi
39166	payment	2134	2134	1874	1	1	5346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2T6FDrZtRAYSrJqJfhnGK7h11SYVbQ7xLcfLpXidKojkhz9N
39167	payment	1397	1397	1678	1	1	14911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZB2nRSHvmx2z3WfAmZwiaYw3t5yv8ACBhDKM5S34F6ojce2h
39168	payment	2134	2134	1874	1	1	5347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUEjN5AX9HsJPDy5JSXWu5NR6okAFhgvyQMMpgCXdnZWFJSaJ
39169	payment	2132	2132	1874	1	1	1468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeq4suDgJJDUt54xzUgCkcTtEtyP98QGZDQfMztdUjagLsD9Yi
39170	payment	2133	2133	1874	1	1	4871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEeQ5bJYhakEdUkXw6pV8bHEfQUHAM9WUzS5Y8FwQiWgE513zJ
39188	payment	1397	1397	1678	1	1	14917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb6o8qj8RPGVfApSDevKHYy4qVFg3VY4Ra5qyPSK5bgeeGVsTt
39189	payment	1397	1397	1678	1	1	14918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6j3ZHTrYxisNHy9TEsv79ikQDD1qUvYqc7i31AVHxYHxkztCJ
39190	payment	1397	1397	1678	1	1	14919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGs3jjB5XRWY7y57MbpKf8mWM27gTNd9zx6NwEw76MqGwkYtWn
39191	payment	2133	2133	1874	1	1	4877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5jvTfe6jvCMJPaGFZXETTMsboApQbJbCw8MGCEZp63qoLM8P
39192	payment	2132	2132	1874	1	1	1470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuFMebgvQoL2garwAQAW9J5FcDd6QxW7kLfSTEdAsHXNzg8E2h
39193	payment	2133	2133	1874	1	1	4878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUhoAe3FfrcNgxiyr7VkQaYeFLkjBdnLQpt4zaAvskdxNkZV7
39194	payment	2133	2133	1874	1	1	4879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSZjraKuLHMAgYpBnzhNw6gZME4Cr3YRAXGcCykP5CyTU52Xa
39195	payment	2134	2134	1874	1	1	5353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jhfKCQ5ZBkGVxUhj9bvqyRt5a2DzKcGjpceAYGzkLxK1L7CM
39196	payment	2134	2134	1874	1	1	5354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZWVWBMT4TqkeMNEa74FUNwRLuoyfnuMrE4HZ6yTrSZjNVZht
39197	payment	2134	2134	1874	1	1	5355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQc22djk2g8mM8ZypX7NvRkGVxrhfiqj48Eth5pjNztjpPwVA7
39218	payment	1397	1397	1678	1	1	14926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQicC3U7LaYsc2xBPbrKZESN4xnMTbJRU75RQcbJh56XzXNyf
39219	payment	2134	2134	1874	1	1	5362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekziotsgGb6YvkWS2nYffpC23bPZsB8b25ZTDHwDepFx7fGoC
39220	payment	2133	2133	1874	1	1	4886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDAjsUUZzGFDkpht6LJDFhsaVEHUBGUacKZmDa8j9R6oiRQbr
39239	payment	1397	1397	1678	1	1	14932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1fUoGZLxSREz9LNiw7enUsWoSAyi8Bt42oRagCEnJA4HdpQJ
39240	payment	1397	1397	1678	1	1	14933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ybUKRpm4eCmMEwfPLUWKb7aMTUGJj3nc9dXrMpNi6xFPmsPx
39241	payment	1397	1397	1678	1	1	14934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfVCKnsGpDvU9JqC5T4sAmJGNe7dzyc8g8aXVvmHnQrdEmKVx
39242	payment	2132	2132	1874	1	1	1475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFmS93kKjajNJWuj7PJb2x3Xq4SqSGSxyQuaAvSdTFq2B6E41
39243	payment	2133	2133	1874	1	1	4892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9EqGp1159wYu1G7Sf3P1hyW2Hv6kh5K3izPQYrjgZtPngwfa
39244	payment	2133	2133	1874	1	1	4893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5L7YKnqaXUt1p9fJc2WAs82d2pVQWiwK17kfNQ9dmBaLmVqLv
39245	payment	2133	2133	1874	1	1	4894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgEWMtxYF2cN2oGewXRe65Fc1dfYx3sprYXddhqdDrY8J36ru
39246	payment	2134	2134	1874	1	1	5368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjWXuf7i9tQvHPZkFRL1hyrjrfXuMZnHResiBuNe5M9Qxrz1C
39247	payment	2134	2134	1874	1	1	5369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo66YWZjrjDM37TYZ66uPjEcmrAT3czPAfeps6XHp2L1HtuNPQ
39248	payment	2134	2134	1874	1	1	5370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4HZkzXqCtj8jPwvmJfJLSeZv2eUBH9287ADhnv2J9fBE1RXYJ
39249	payment	1397	1397	1678	1	1	14935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4LuJtVZVjAqDJ8RUK5vXdwyRtF7ViT2VVSwiStWsc1y3FYR1J
39250	payment	2133	2133	1874	1	1	4895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9by58hs8uVFWef7AbRCcfGELAgrXwAare8wYg5WPCRvcoww6
39251	payment	2134	2134	1874	1	1	5371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqz8QH2NSyVdsNtWeHRp3jehjgsPpWDSZx4aTnw5NtTdcC4jAV
39134	payment	1397	1397	1678	1	1	14901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYwzWd1w2JbnLeDTtzDX7rpP49xJW3YASrs9gw4iBEcvLssXH
39135	payment	2134	2134	1874	1	1	5337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojeyBABPppWz2zZ7Pki4e5c3ffXfqPAsGG5JyDfrqH9SBZPqq
39136	payment	2133	2133	1874	1	1	4861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7Jpwtr1fp1CSLSTiEvKeBdxo7UEVrowzEvZMDqUxCE3qdo4h
39137	payment	2132	2132	1874	1	1	1465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEmu45TFxv3PLYyRujw6DLqBNfgTKH21MtbEe13Tn3XcWN4n2n
39161	payment	1397	1397	1678	1	1	14909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7cJ2Zrin2t5zjcny5rbyJTQAjyMPQavCTkusWnB22BEjuLZJx
39162	payment	2134	2134	1874	1	1	5345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6CQ9insg5HaRix1F5BtYSy9hpLZE1N5hhC5TVRCKoHddSvaA
39163	payment	2133	2133	1874	1	1	4869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XawJ4M1RVmuX8q1rTZK5tN3MLu3iKjY7v7pwwLYno7MhDdYA
39198	payment	1397	1397	1678	1	1	14920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGzuQ2ppPp5CQW3cGMUPeV8U21rS1hKWuVf3nx2HzX12VCt7K
39199	payment	2133	2133	1874	1	1	4880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV69XJpzX2pZ32wJBc5KbJvEvgM7NRkXnGFGD5uXcLtb4fVMCy
39200	payment	2134	2134	1874	1	1	5356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1jxZJDNLuCcvJzFoR4BkoZF5puwDR8oozgzFcBXdeG7GrJGV2
39201	payment	1397	1397	1678	1	1	14921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7gAs5np9B7Zc3fftsvsDCmm7Xqc8b8eCq35LA4Zvh6We1t4G
39202	payment	2133	2133	1874	1	1	4881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWZ7xw2GePbKB3kaS3uk3SggfNz2ddBfw5r21FSxBxc5BZ3rj
39203	payment	2132	2132	1874	1	1	1471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7ixCSzvmDeN2q31FkK3SMi6Z7qgtERhhTHTje1W55BHUuXKF
39204	payment	2134	2134	1874	1	1	5357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWE2ndCUTDF5V12awYQyViPdAznJo2d4Cr6Vv4rfsccCjUWVcK
39215	payment	1397	1397	1678	1	1	14925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyh1tmH4dtKx4AxshqZUVyhaZD3nac1zzNuaVKvQGYJLttEbYs
39216	payment	2134	2134	1874	1	1	5361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaXfaPSMCk8eVHAsck7xE9AAXTwpbfLEXdc2BQ8UA6t1Auz5Vj
39217	payment	2133	2133	1874	1	1	4885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rDm5h8oYcvKABY4K8AGwaSbtmkzJdg51rFoZt29fTjvSjxHT
39252	payment	2134	2134	1874	1	1	5372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9REwGtM4gTcaLMNH3earbwBasFWxH5T9zwYB8ZvkmWmiYgGx
39284	payment	1397	1397	1678	1	1	14947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutm83vDbntBjNimbUmt2KvvHygv5h1K3zn2chW43pheBGVJjf
39285	payment	2133	2133	1874	1	1	4907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSCkpvTCaUXhnFoi7XF9qkyyRhz158BaC1Qxy7JiHKW6D7bZC
39286	payment	1397	1397	1678	1	1	14948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurFd1KWUA9o8tHZTMtP2v61NBwLEvPoJn6s68r5yH9H6oeMdf
39287	payment	2133	2133	1874	1	1	4908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQuXu8UJpMcCGm2Pnqq86fN9F1Bbr7rJ7tibduzTDtDADMzzm
39288	payment	2132	2132	1874	1	1	1479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTYrt1LrXPG6RmDsNFGapiYser9UjkcP73d76XHqiH1rq139m
39293	payment	1397	1397	1678	1	1	14951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE6AdKkEPhDynE4GqhdEhw5HbXrHPc9nBZ8xe5cbsngVmMchE
39294	payment	1397	1397	1678	1	1	14952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7i9LD1w8Eq4rs5kDnH8KmT6eK7PJpcWQcGkWtaSzP5yonGkdJ
39295	payment	1397	1397	1678	1	1	14953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhKQVumztZ9UQxc4bgj3FtoKa1pFGyLtPwvgeRZFm1Q9kkaPD
39296	payment	2132	2132	1874	1	1	1480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUseQibGvbR2cDbPDn5ros3uteq8uyLk8GvRPkYBxW1FS6wX9j
39297	payment	2133	2133	1874	1	1	4911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDuUmWQnS5sYZH7gqNJZX9PjiWr7E4h7EfqynxNMYjCGMKXjx
39298	payment	2133	2133	1874	1	1	4912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa47eSXbkotLNieLU9WcqnBJbMU4vtQRzptjndCLGDSMGwuYyhR
39299	payment	2133	2133	1874	1	1	4913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JgX1ejmx7PNfJLy2hXMfbCPrXZeAoScFyvFT7mn6SMnV3x4k
39300	delegation	2317	2317	1600	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DqUaSyHus9UpYcZqtjgTbKizeHQYrmUumMzGqfuRTpC5tPgf
39301	payment	1397	1397	1678	1	1	14954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBHCp8pqkXRHACrL6aY1ztKReoUmVZ41TRcQE62yXJdjt87Gjc
39302	payment	2133	2133	1874	1	1	4914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEha2deCxdSRTud6ot7YzUzUpFkHriV94evM55Nuv4M6d9Cfn
39303	payment	2132	2132	1874	1	1	1481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbTg2rjYRnka6zpdFokauhVabDYJ6ZpY8pDFaVfXtXz57XTED
39304	payment	1397	1397	1678	1	1	14955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNSnaoH4Pn2jXFBiazCAAdfET1VPGgQzwnXCAnZGWvU4mqBug
39314	payment	1397	1397	1678	1	1	14960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcc43JAEQdehXjfhjdZZyVD2Q5StcUhT7UsJJ1Wfr3W81dMzq
39315	payment	2133	2133	1874	1	1	4919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgRKnr2pH1vJS132vbFASvRbZGXcQ9cJmiPDgPEhdgmNQ8nn3C
39321	payment	1397	1397	1678	1	1	14963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8fN4TtTV4STs9EaZUxURDrN9k4bE1LJXwNhU41shfUhHajYp
39157	payment	1397	1397	1678	1	1	14908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUM9PenGoprQJFgbtet6kpdShYbStHcZCmhzytkGinEVYU5M2
39158	payment	2132	2132	1874	1	1	1467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQs6f2HAN4SKDf28nVNm18iVBGKUttSJMcKhkwpBqEf42ohMCi
39159	payment	2134	2134	1874	1	1	5344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJumdZ3YyM1r99LG4toJvP47zwd6Eaoa6XEDJgWA3NLt95eZn
39160	payment	2133	2133	1874	1	1	4868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvWeVpF8WJ4NQTLMzhjQwherMjfQwTdFEDXtDKsdgMHo5ynXX
39171	payment	1397	1397	1678	1	1	14912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ63rcYdEbT4DeLtwe5jAHEVfQSRGdRyFJ5vDhkx6HYNKz1DVT
39172	payment	2133	2133	1874	1	1	4872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR873FyGQUNDpppD2mqbvCTLLFnJnJWRYejz2DrA3SUjPLkGmm
39173	payment	2134	2134	1874	1	1	5348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBxuUtndxtUbpcHxDCdV6qtKnyKEMzKGkvqThN8SrK79ErhqU
39185	payment	1397	1397	1678	1	1	14916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqKUnnJzrsNy8J2J12zh3kZZArMHCphvYdGjDQUKusLCEATBL
39186	payment	2134	2134	1874	1	1	5352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZSwY2VKw6N8ot5JHY2bj8yuKuw4HK6LV9dbUwTHWKApd81aD
39187	payment	2133	2133	1874	1	1	4876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnoE1Jbt15nxKRrm7BosyBJhHLiS6VgrqbgGN6gMBrEfrrjWT
39207	payment	2134	2134	1874	1	1	5358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMYy1VHGkX6ky9GZbwqjVpVepQt1tw6RaYWCjNrKLrSSN35fR
39208	payment	1397	1397	1678	1	1	14923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurwfGaRUZDsLNStUTvQWKjCGoEuA94g2zf1vpcQkiWPS8xW5H
39209	payment	1397	1397	1678	1	1	14924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeY7Cc44kTKGdZyCCWcTmqAF5J4twx8q14ayy9MQb6qG62daFC
39210	payment	2134	2134	1874	1	1	5359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcwjtNCsMHdUfpxukrCHteJpf48EbyNjYcuXQrCNS3ii8xFar
39211	payment	2134	2134	1874	1	1	5360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TvBoL2MPKrRsJbYvWDUrw6eazc6uxyoBBbDrhyFjZEew8XJR
39212	payment	2133	2133	1874	1	1	4883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhxRwh9CqUMn38K63eLCfFJ3KgaE9JArLr87oPMbDLxB4vtqR
39213	payment	2133	2133	1874	1	1	4884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmu9HvMCLYrqmbjH34FrT47PUTZxW3xEzrbp1SjRS1UJuChbs3
39214	payment	2132	2132	1874	1	1	1472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYHtVhrRbbuUZWjwh4vc4CDGRouSdLgYKB5kpUh8FP3Wzgu94
39224	payment	1397	1397	1678	1	1	14928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrpWWHYLig3KLTwRpP3wMS482vBo8ykETRp54CQVAk9vz6CbHW
39225	payment	2133	2133	1874	1	1	4888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3C91uiD9B5qBgkbQCSU2gAwokEQFnsFkRZZGT7z5199YyvviC
39226	payment	2132	2132	1874	1	1	1473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVxz6dJiTN7fxdkFGttHfVg2awVzZkK7HHUnGSZdfG4gfEnQi
39227	payment	2134	2134	1874	1	1	5364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPPXoUfiJCmytBuDvSrUhHbsqtF4wkrtwGdvm5YtFRcRw5D2t
39258	payment	2134	2134	1874	1	1	5373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUL9ceewqffXaPGS3j7NHCWz1qhnt91gzUbS2FfSZeN8Nky2P
39267	payment	1397	1397	1678	1	1	14941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaW71n4xCL5zQZZsNd1PVBqDBMuGcdRU94VpUgYvWgXSnnGuQf
39268	payment	2132	2132	1874	1	1	1477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkyR3rrL9tThvSr73y7HoHp4HxjrMU4iDnPYo1sp8MykTf6uu
39269	payment	2133	2133	1874	1	1	4901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcy8FF24XdCTE4UEHACvqigayEGKT7cFA32UKvD4MbRUvAXZU9
39277	payment	1397	1397	1678	1	1	14944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQ6UC3ZSpbeLb9aPW26BRT8t6asW3GcVvwRbH14QkH78riB4X
39278	payment	2132	2132	1874	1	1	1478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWLh9pyats1C3VMFYHT3vbcR6sLfY49UcDwSXwQQajLboNbPM
39279	payment	2133	2133	1874	1	1	4904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddjj1isV9iQhe3YHk7udpstKzQC5Z2pr4dxoLfg64FFo87fyn
39280	payment	1397	1397	1678	1	1	14945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaYNRWbV4UL2mgWA6ifRmLShbRhLeVMPFqUZ4kwdRb1aYLf3J
39281	payment	2133	2133	1874	1	1	4905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgvANgwdVrvHj9QwA8XidufQ7CmoJ3rBakz4uaSxDTyHLcfmj
39289	payment	1397	1397	1678	1	1	14949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXp27DEb7inkSCoLEWkqQ3RbSucJ1k21YEAnRvLTbNMX6rjWUf
39290	payment	2133	2133	1874	1	1	4909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd9ynsK5eE5Aec4bug1LeT3VYhCuxo5ise4NNgTAcFoWu5R9Qw
39305	payment	1397	1397	1678	1	1	14956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3yAzZ2Le8QekXz4xRFhNQpBpGpR21y7fwwJ2uoZBkrm7EfCU
39306	payment	2133	2133	1874	1	1	4915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqSBUD5TKbYEwVvu9fjVn2mbBXNtYSu1gu8xqDapGCAdKQTZe
39345	payment	2133	2133	1874	1	1	4931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6SndczVXUoGGTxsButYWaY4VxonKHw53BPequFkSQAZ71Hc29
39348	payment	1397	1397	1678	1	1	14974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFNCYfEx9cAWRiZY49VpUKMMPfgheq3mVe9Ad3aNoYtQozKYG
39349	payment	2133	2133	1874	1	1	4933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrUYdjvXHbJvXiLQnLusrNxcHnLyyqRpBYfTgBErqVwVbZ1MgB
39175	payment	1397	1397	1678	1	1	14914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqSQ1W28dZeQ9uJ97pPPqG52MpgYdxjjcbbRqy9x6XpMHiysZ
39176	payment	2314	2314	1950	1	1	3	122000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2CjjCsNiEPPHuqbYsHTkW1c6o9hcScfzMaJBQhQabkP2qizq
39177	payment	2134	2134	1874	1	1	5349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qgH3gV3Ufcx9cCupebEyfJVE293Pyh1GXesB9LXogVN9p8GN
39178	payment	2134	2134	1874	1	1	5350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9HS4gyqNUziPVA3z14J3qUZKESqP78ZU7AHtXBwzKqkzd5Ws
39179	payment	2132	2132	1874	1	1	1469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Acd4Tqi7npWE3B1NFioGhgpRNmd8UoFtbWJbTeoWZEGhDdwh
39180	payment	2133	2133	1874	1	1	4873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJth96uhofVxi2QZxg6qy6yDF1ajnHUhkHmy1t242t7H6ttea
39181	payment	2133	2133	1874	1	1	4874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahYvQnJMfm2HJtnF8nrvkB6a7HSmDLY3DaboUQXAbXsr6ngys
39182	payment	1397	1397	1678	1	1	14915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP94cotKypQth8WJqC9X3xq6bAyuND4pbDCqD1BQhtEf36suQW
39183	payment	2133	2133	1874	1	1	4875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqVEUHB41PiC9f8qqci6zYSgQ1sCjVHx7xGYY8KMaatniKCHGA
39184	payment	2134	2134	1874	1	1	5351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3GmYpNZxxye88Ckm9gjcCE3S3wDkM5428rdj8C2zjqgEu9H4
39205	payment	1397	1397	1678	1	1	14922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjVF7r8xuWeXGXDysRuSRCDSGJtMKQs5Y8b49VPHN1UcyEy7u
39206	payment	2133	2133	1874	1	1	4882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuKnMb7cTRq36EsQfbTqdb6F4bbRKYPQP4Zn9HftPiG7XzWS8
39221	payment	1397	1397	1678	1	1	14927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGMb11CLxA1UD4Sbq3Aah2o3x7kPpFjRgkjX5SbS9j2Cundt3L
39222	payment	2133	2133	1874	1	1	4887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6k4cckBdXEPf5JAsNrNzjH37LFn7cgX9X8Dj7g53UDdXPvh5
39223	payment	2134	2134	1874	1	1	5363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76APzzQduZUHJkoDpHJLDuC9G5NtKrTACouQkW8HQu1XnQvr5
39228	payment	1397	1397	1678	1	1	14929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83AhZRgwVcsVwpNXgNf6TGNkySGgKS7iKPhc7bviLUEgobwTi
39229	payment	1397	1397	1678	1	1	14930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpMMTngD4RuoihuFafJGATm2vqBB1kSCi354y9JkEdDwVW5om
39230	payment	1474	1474	2316	1	1	28	800000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhaTFQKvEM8yooqWAr6euAxoaPABoQvV1njXfnAReBDxus1BvT
39231	payment	1397	1397	1678	1	1	14931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eDya9CHuwZ68pWjhSTwSPTTtauBMD2qFHPhZ84zuV2jvTJV5
39232	payment	2133	2133	1874	1	1	4889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtxHdE7pTHsrTsdzowb6Bmdyf8gXqXMfYU2igBXrVdEcsPj8R
39233	payment	2133	2133	1874	1	1	4890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkQc34Pf9uEUvqXW2FHhdzdrHYFS3kiDiHELXBkd89dAvq53m
39234	payment	2132	2132	1874	1	1	1474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyGDVZpRTCGGoEvvVaHesda2dCkVjkZZcLcsWnsHZsJmZMebD
39235	payment	2133	2133	1874	1	1	4891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dxpWer7iaCW9DdjWeDTTaRXSFJUdb3ZqfUtCrhuC4NNrHqNL
39236	payment	2134	2134	1874	1	1	5365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV1qBoCdkKLgodaaEUWGc6jqYFmY1ywaddxxBtvdYKN3V1W7nJ
39237	payment	2134	2134	1874	1	1	5366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jKTtnCaTU1FJD1cSF6GBCot2naJikoB3TiMGufGw9DWJLTpm
39238	payment	2134	2134	1874	1	1	5367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDRkC5eTLTpwpspyLXno3PnhsASTvddMShV1UDK8aAEuLEDtb
39253	payment	1397	1397	1678	1	1	14936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmvM4WGuZrDvmZEkmtNDepsU2VLm2R3GKiDG7uGko4933DvoT
39254	payment	1397	1397	1678	1	1	14937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2SUbNcs5BAfFy18w4fDKuzFiq9ZUdbQJdso3iMZfgBswfrW4
39255	payment	2058	2058	2059	1	1	11	363000	2000000	65535	E4Yu1DNec4Wsdr7F8UbpezefvoWzBuEkJhARCvsX8REgbUGkdXef3	CkpYRUrT6NGNZbt6heAYknZWkM6zSe2NAmo886hzGt8RvFXpcG7fk
39256	payment	2133	2133	1874	1	1	4896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyXBHoKVS9oRfF23Vvd93KPK3xxPcjCFFynMUmNUqGzs8mQasE
39257	payment	2133	2133	1874	1	1	4897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVuwTKvWiHkH8ZY52coL5XHw93VDUYByomsrzPp9ax5GpVmgkf
39259	payment	1397	1397	1678	1	1	14938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eSPERBBU6beEb4r2R2WphEF8jELZm9iQF6mPuZxGsViNj7xG
39260	payment	1397	1397	1678	1	1	14939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSujaomNMbnFzXVo482Jtg7W9sfs93M2Q69NErKyec6cXE8Ww
39261	payment	1397	1397	1678	1	1	14940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9fvLYND8He9SfzKaUuHtk6XJt38doxM6B9Ui7shFf1PBJuMA
39262	payment	2133	2133	1874	1	1	4898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjJvNPVhjqg4YqCmymGKGsp3sbw53LG8gB8WSuS6TSeax3yBs
39263	payment	2133	2133	1874	1	1	4899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVop8dbKBdVzyJt6eDjYeqTWCsKy4YF3kUFv5EKi8fi3epFBEx
39264	payment	2133	2133	1874	1	1	4900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVK6HgfgUnhMDkpinhawAuWzeEpCcbCj9pxNpcmDudmSAuYpa5
39265	payment	2132	2132	1874	1	1	1476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzMpDB4FE6dsiQNYTCUkwmnSqRURwGyrB1QRKLBBVbWK1HrEJ
39266	payment	2134	2134	1874	1	1	5374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6XXSnGGc5vcoaQFs2ZDSPBoYu4J1M8cDfD9wstnEY19KTocvz
39291	payment	1397	1397	1678	1	1	14950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBFyZFDKPifDJ2PAPq3NsiTQ19ku13Sgw6vL4BsapzPaWZcDU
39292	payment	2133	2133	1874	1	1	4910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4MHAK79chbRBRnoBx383GXy4Pvq82vHNig3yV3KtrKrzg1Nr
39307	payment	1397	1397	1678	1	1	14957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ12W9pVx2NGy5MFpNNgSin2rTe82PEmJnc7KU4hiYsMWyj2Xd4
39308	payment	2133	2133	1874	1	1	4916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWamiFLC84FUv8zw1xDsGYeBeb7eB2CNcq3AvcKsRTairpcp7
39309	payment	1397	1397	1678	1	1	14958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkSRQiH3iQJDXzCmrCqEA7pxWCkjA2RzHH4HRyyjrGryKUsbEb
39310	payment	1397	1397	1678	1	1	14959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nsmKZHCqx5KE52MgzRHv3kzkapD5icq2FjWRDnDCpH8YEer6
39311	payment	2133	2133	1874	1	1	4917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZut2dLGwpjJZsuNKFMrrPfAymVSeGwJdLrT7qLXomDuymHDh7r
39312	payment	2133	2133	1874	1	1	4918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhsa7V7M9hJGMQ8pdAyX26qdEG2m2heV7KJ4BwsjQGc8bquup
39313	payment	2132	2132	1874	1	1	1482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YbfEjUEUNZQrr2jHcJZELsgB38hixKGMP2z3ayiBVxiwLGWK
39329	payment	1397	1397	1678	1	1	14966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd4MJRYJhSZLGja1vdcFBF7wWiwsduGjYeWR5MKFBrahc6xK4a
39330	payment	1397	1397	1678	1	1	14967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrjxEfiUmPtk7xRVJ4UGxXRhYSmo6q5EAEjrM1KxG3t3BQZQH
39331	payment	2316	2316	2319	1	1	0	300000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqk3N41sppkCifus9jLspoG32YNuKcE2q68SoDgX9AMqop57t
39332	payment	2133	2133	1874	1	1	4925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCpqnqXw4zoCHHoELfXUEZ4tc6yY3PLn84t8DLNQ5LPDL6Mmq
39333	payment	2133	2133	1874	1	1	4926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSGdkfyrQeVxkgHKkT4zJ8ejENmJ46m7tgcVHC4qG7UNsJ6Th
39339	payment	1397	1397	1678	1	1	14970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqWbd6SHN35F9gXwktcjrhg568odaahuKkdSyz4gmPshFqpJi
39341	payment	1397	1397	1678	1	1	14971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcV6rQjCxwMF8U6kLo7g43svDA7B2fYBjfxRPJdq7Gr3u3ExYW
39342	payment	2132	2132	1874	1	1	1486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFrZM1Tr3rgBVBP4tUtihgL3RNYXBiKjRVTFWk812Kyg87YuX
39343	payment	2133	2133	1874	1	1	4930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkSh9HaeEpH6y4zacQDnYbqsPPRVNmtXwzYj6B4ck62ELKX2L
39354	payment	1397	1397	1678	1	1	14976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg26a8iD98uK4hTqtemgc4mKTCXQpmHj4iXHFNp7tvNJCNLS3R
39355	payment	1397	1397	1678	1	1	14977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJc8jBeWbKYEAwpkbqwCXnrtzg7VjqBnZ7msX5meHqijexKgJ
39356	payment	1397	1397	1678	1	1	14978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv13mfXe5vczzon3EkMhTXjszc5rYmSTz9cytuXfLeHaT3o7qi
39357	payment	2132	2132	1874	1	1	1488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mVNnBhxDMYm1CkddjKNf867iPKiDjr8YTpSKbx4EkLAytm4r
39358	payment	2134	2134	1874	1	1	5375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFvafCcxRDemsZDhHva36iPeMnjERWKriXsEiQCnVGHoNK3UT
39359	payment	2133	2133	1874	1	1	4936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oSH3Kt9BJrScWCnKVKcTrbyWPbVXgvBuC8QBC1AvhCTwRXQm
39360	payment	2133	2133	1874	1	1	4937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeS1rF7fVvAWraEW81MvW5PNuWoPxBpJ4UMoMNeLrLZKGNAqEB
39361	payment	2133	2133	1874	1	1	4938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQ1VPpf9WGyGDDWGdeQukg1icfRMyTiwHHcRyqUQMuNMKc3xm
39382	payment	1397	1397	1678	1	1	14985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhqwtY1bxZXws55Mj3Lc8kCjSkUBoNxJDLg5oWTxzi64Zvhhxh
39383	payment	2134	2134	1874	1	1	5382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPi5MmNeUBsAMwkVE48xMyuht35jV8nABwkXtVnsFLsnn2YtZZ
39384	payment	2133	2133	1874	1	1	4945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedJx9GhtvJs6NtBaHawDfPrHfGyBMjEEffzoEgBoh6xGwVuUv
39395	payment	1397	1397	1678	1	1	14989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitVNJRHZVxGGGtd7kEdphCnpRydvEyXr6bGU5S3TQXRhJk613
39396	payment	2133	2133	1874	1	1	4949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXqvJppFbnmtbAKUfBLKxLTHkoCY3r1dcAoC1AKyNyB15vY3w
39397	payment	2134	2134	1874	1	1	5386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QYxeCsp1iY8iMkjoS5qWJWh11JFRmcFveaZX6y1Qen21bviB
39408	payment	1397	1397	1678	1	1	14993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGQ3tvjADDvyzQpKwPiSWHfZAJo2ZZgCybj1r6hGTgCgANKod
39409	payment	2134	2134	1874	1	1	5390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBjSfbGLiXP2fNzp497DtFyDPrrDfQjZrQ4F5GEujdMqPBw77B
39410	payment	2133	2133	1874	1	1	4953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1WbFh5G8LS4wRmhXWZMBwopvqhUVRq78dLbGh53xHrN5jSBw
39411	payment	1397	1397	1678	1	1	14994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC4Lzc71fMZaaT664yZBG4wWzp4BRB3VoUUqrPRpS6sdHKcjS
39412	payment	2134	2134	1874	1	1	5391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsFgjs7P8AsLmc5D1Z5Q8tBMETNbMkkSHBUXF1mptKQzN6VL7
39270	payment	1397	1397	1678	1	1	14942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7VsuLSExuHETK1ZEbYZy6xkmZjnPZby95xZKwwV4hxqR4QiH
39271	payment	1397	1397	1678	1	1	14943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmqv23hXnqHRaiHjN6MaHMcbyycPojKfi4KzgVPCYLpKQL3WTK
39272	payment	2058	2058	2059	1	1	12	717000	2000000	65535	E4YTjY5nNsRcKfU7CDHjDQftrpWChzPWQQE9kR9cYKBjuDFosM87c	CkpZ5R1LVTugWiuVf9MEPcuUQaw2AgiadjAKqT3KoatUc9FRR6dKK
39273	payment	2291	2291	2317	1	1	0	255755211465	2000000	65535	E4Yo4NHtB17XoGsJdkQqtZGN2hYKQW6KyjTYCxdBjckWFqPbNbqA3	CkpZhw2QTGz3dBCoYimyqJTW1EVPRcepzFCbeg9uTQ7js7oa2Zb6U
39274	payment	2133	2133	1874	1	1	4902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KmFgMtrC8zBZUtFYn76bRbTL5ahK1kUDdTFnGwfRjBwsZGoG
39275	payment	2152	2152	2318	1	1	3	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGgQFCS2cKutRHriyqsKTRMZwxYf1xA4obSRy46mWovk7pMfT
39276	payment	2133	2133	1874	1	1	4903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKRqSmCkj1nHDjaKPKwcRsEUJiXEj7RVccukGu63fFfpXU2jj
39282	payment	1397	1397	1678	1	1	14946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbWqmKer4GjKoW9jtv6pmNkG1pMac2bwELUcaV74A7CmDb3ew
39283	payment	2133	2133	1874	1	1	4906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk5HLvk2t8wq28VmJ7v7VYGdtgxYa1nRBCDsx1uLpWQnjazd6u
39316	payment	2132	2132	1874	1	1	1483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX8CeerXW6DFRyzSW6hTbFftMLommYFDFR5u32yu1r4GnVAXV
39317	payment	2133	2133	1874	1	1	4920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrZaGCFWYTF6xYgcDroUhLmaszaADZTLHanjqhqkmshDSPGvg
39318	payment	1397	1397	1678	1	1	14961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwawe5VyPp6191WNSjDKzAEHMCp6iFsqBHnHcEV8iMZ728ECV
39319	payment	1397	1397	1678	1	1	14962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxvfRiHjEYkwT7JEV4cmSGaE2hfhgdvQxnSainVxGx6rPmN4h
39320	payment	2133	2133	1874	1	1	4921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4aTUiv1mP34mc2C6CoumgEuEsWsUM5YaUStwUmoaMsj77LP68
39323	payment	1397	1397	1678	1	1	14964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC6nUpkUnmTuThHXfVRmxBF8XPWDHT47rAkFLUUmKC5cp6bQe
39324	payment	1397	1397	1678	1	1	14965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBDengBpH735AbEU9AKFunag7g16neuY8cyNYo3n9tRzULZMN
39325	payment	2133	2133	1874	1	1	4923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMLh2vRigiysY2JMZgigJ2LA26PWznQePXmTvYDEymZizMadV
39326	payment	2132	2132	1874	1	1	1484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5MXbeZu2TPgmEJa4gZsD878LdrmZRUE3Q6dxaMJgb6pwEZN9
39327	payment	2133	2133	1874	1	1	4924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXwKqhoG5oUtKUuxzGDLTVsMN9P6Uyeb9qmpJg1yuQ3YobPiZ
39328	payment	2152	2152	2318	1	1	4	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUfqU5oP7dGibYUBmEWC3qFoYhRzzo4WXSYgeoJBDF1RPPD3o
39337	payment	1397	1397	1678	1	1	14969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYCsfWz8HeRRYFjFywXSbNtoeb2rwMCKT2W6L8njyagp8PQMr6
39338	payment	2133	2133	1874	1	1	4928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFqZSMaGyrfq8y2tVxrx7SroB9hoY8chGsCHFFJzCSuDaQLpH
39350	payment	1397	1397	1678	1	1	14975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWGt8AsKdDjXKYEh9fED9nstxcJRZUZQKFeYtM19vZY2DTy1gu
39351	payment	2132	2132	1874	1	1	1487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vBf19bajwhrPL4EjaFwEm82x6vLhyzKazbVfA4xahXXRTyuT
39352	payment	2133	2133	1874	1	1	4934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GeckAuWyW7Ye6BqHaGB1hRLsu2gnfquhqHVtk6NgCNovc2mS
39353	payment	2133	2133	1874	1	1	4935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUhThfhJHdAn7JwvM7Ne2A5rfMReTBHM4JQHiNwRZuBqsj6a1
39365	payment	1397	1397	1678	1	1	14980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzFFZqMYqg3QtH4ANDhPnhUvJdn2PJtDwQ9TsMhbWP4HNKC3H
39366	payment	2134	2134	1874	1	1	5377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwaKt2UZend8MZ4K7DPkTNm9HfQ99Hp2ocjW3q9sYNhavU9KpS
39367	payment	2133	2133	1874	1	1	4940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkb7Jg1jtmf3jBpGayKj7EHNPRrE6t34UWy9SZnNyATvvxqnmY
39368	payment	2132	2132	1874	1	1	1489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZN2Xvgax2ixPydcE9iq9DoEzTgDnHV9riuLLVWyEgLEecf7p
39378	payment	1397	1397	1678	1	1	14984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpTGuCKpqBdUGsgmQg4tnmGRbiwF1m483Ye3BQCNEZb8Sq2YdX
39379	payment	2132	2132	1874	1	1	1490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7ERe9hXzJ3iEB35dyGLLwWkU3HZzv69mGdaviJY63ZMj3GB2
39380	payment	2134	2134	1874	1	1	5381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfE4KPTB83rMoomsaohKnpQbBCJdCuDaTHwBuS8UYJZfgzFn33
39381	payment	2133	2133	1874	1	1	4944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2Mqg1zdbUcVFxizTkgh3vZQh8LPuxPqXwHFnbu8edQfNDahs
39388	payment	1397	1397	1678	1	1	14987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLDZrjgPsFfhXTyRhNJ32XT4mXYyPUuciE7sMcho84PTCyBca
39389	payment	1397	1397	1678	1	1	14988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcX3domBLqPnFy2GbqJFgmCKp7bq4mmCtr4DjzY3xTLmJjKz7C
39390	payment	2132	2132	1874	1	1	1491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefDnz3aDoWHN6Ei8WVaRp1PrJs8NEySivY62wWTfdcnYoiC26
39391	payment	2133	2133	1874	1	1	4947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgR9mvommRjRxHdgsTx8sZ93rm1yo6b19UygDGRM8v5e7Myig
39322	payment	2133	2133	1874	1	1	4922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4nEZR8ywRRxRZFnjBVuhU1ugVe6oDCbep861KENsBsD13cPkE
39334	payment	1397	1397	1678	1	1	14968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUB8hfmejjr1WBstSPJMh4cXGX5QvoY7SgUXbnATWTEc86VRAz
39335	payment	2132	2132	1874	1	1	1485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfRTV9F9oAbRdLiLngFu1qiJFey31NrdrdQKZCz96PogN8364
39336	payment	2133	2133	1874	1	1	4927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYig7erqgD2BH3hrR8TBaVvKDorPGa9YHJA4PJeT5uNy2JvLbb
39340	payment	2133	2133	1874	1	1	4929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdwg5TzKktSQWqP5PcjiEgR9FudXVGd5UqdZWEPsNEqaZG7wc
39344	payment	1397	1397	1678	1	1	14972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4EYqSMWZzhQYDqcDJPH6VMkEXzbPkwY8vrf4Kg5thoXv5WTsH
39346	payment	1397	1397	1678	1	1	14973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSLKaNwnCqzorY2dmxAjHG6MfkuAYkyXuckrdvjGLRmstcYSr
39347	payment	2133	2133	1874	1	1	4932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8biyt3x2AepeSBcbCS7ZCFibg6K3bMj9iFCWRwumnA78W7pJD
39375	payment	1397	1397	1678	1	1	14983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifehiYucTMKSngFSFkHvr7wap6PQhw5zfo58dsJB5owTsPWKb
39376	payment	2134	2134	1874	1	1	5380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphiCtJdgTBgbHPB3eTooH6UtNyo2dpuPNPzyz3nLtwKHBEpZT
39377	payment	2133	2133	1874	1	1	4943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwk8hxEHRGhozkM1sMafBQ3oy7h2tsTqUqgSnL8SVHzNR7i8Yg
39405	payment	1397	1397	1678	1	1	14992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGybcfcYUNLzDPhXmtP4buYV3rdxk1aAjqfiiWZa5HNsCbb8Fi
39406	payment	2133	2133	1874	1	1	4952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhZEWZfyhv235Fb8KPPAjhYENEuVBQ7BjaMKzTHDmennAMDgY
39407	payment	2134	2134	1874	1	1	5389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLYHutzgSWvbWGCLjwz7hEGyCmAFH2irQFNRmYT8gGRs9MN1d
39418	payment	1397	1397	1678	1	1	14996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2YBxVtfDcSRLfmUkqYkd7PY1c5uXnsTXzsKy4KqnsEyUJZnN
39419	payment	1397	1397	1678	1	1	14997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xD86k5uKraXGkyWueqfQm7Lyi4NW54rp23ZNHhW5STABUS6x
39420	payment	2133	2133	1874	1	1	4956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXP11iv9eNd6hyUXcpcEwyLiR6QpBZvxrKLnN6VYDGhKSHLw8d
39421	payment	2133	2133	1874	1	1	4957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4VYP7NTpQKSGXiSSEuNfCYA8pqvrN4GAV3KKLX169tqa1WQ3
39422	payment	2132	2132	1874	1	1	1494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnCtye5wUzoHBFnza9R3Ep83GKzaCFgzZdzxALZDJNF2Bqnrx
39423	payment	2134	2134	1874	1	1	5393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFDcnRD9ndbA1xRo3RcBkvDuGWFVYH7TTWhi9dn3VJRe37Bfk
39424	payment	2134	2134	1874	1	1	5394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHiCa4dsM2nxTWWvirqX86BTWiFZjU1FumQMxfV7HJoeVUPRZj
39431	payment	1397	1397	1678	1	1	15000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKYT6EnZyUVfa1HC3FcpQaL2s9Lnn4bAQ81KcaFjUb25y4VXa
39432	payment	1397	1397	1678	1	1	15001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7adeVT2cVc8P8QDKcaL85RPtuFV6FagHs8RiuuP4ZnRxMketx
39433	payment	1397	1397	1678	1	1	15002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBLMYioj8913RpT1ZYRKD9mtRoHNmHivzop4ZUeATNT2yN6DX
39434	payment	1397	1397	1678	1	1	15003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUvP5EHbygg9oxvD7C41wnECazE7MG8AwS924tA8ZzUwhGLih
39435	payment	2134	2134	1874	1	1	5397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLhZHfho91Fizi8rbAmD6RJs96Y1FVgXrA3mLVVmUggdBh1Nv
39436	payment	2134	2134	1874	1	1	5398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMy37JHo79Ckp1MfL9gtMJx6xH8nFZHybvy8sCDvYnEg6WxCGd
39437	payment	2134	2134	1874	1	1	5399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEg7SFJykmZQn6ogRyfBHZEwaqGSbatT5niRrvc3W5r9kKkP2q
39438	payment	2134	2134	1874	1	1	5400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfPdBDVGDSQDur8GZQVVM9nkbi2K2kGw15QDz1wS2zVKdmYDV
39439	payment	2132	2132	1874	1	1	1495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKv9cEKzGMr6YiEfDiRtR5qcxPSHAhQNrwpcsSUPqURxdnttV
39440	payment	2133	2133	1874	1	1	4960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKzsAZDKXH1vCz4fnf1BCbo3Tn3WzWsDtCXSmH2r2Rg5VEksWB
39441	payment	2133	2133	1874	1	1	4961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTuq3W1UXzmx5Jyqm1paJDvov3WGMaixjjgFQC2UNwSnmq5ybE
39442	payment	2133	2133	1874	1	1	4962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeggBcty9C2CegTAwgugJNj2PV2CZY8N7C2qBTvbDxePuQXpUv
39443	payment	2133	2133	1874	1	1	4963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Sv3uWLw1uLDbsbXmhL22pdi2ZnkCdbNqZHjbmcSWJF3DETyY
39448	payment	1397	1397	1678	1	1	15005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMg7E5ebHeyy8W4cVUuJ9UoPmMxnHSzfd7e6dmzCjnRxDnkYc
39449	payment	1397	1397	1678	1	1	15006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxc5QNs5UjykEc9PgyjsY2aFX5UmKdoTScSbbrkgr6NuTvWqrL
39450	payment	2133	2133	1874	1	1	4965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLb9Bn8vx66aVz6z1vBP8fjcwrmHN2xUmtLeJXd5hMEznPqiw
39451	payment	2134	2134	1874	1	1	5402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvTgrbrXuTEAxuWA2sQq59HpnHwKVNGzvN2NPgPKnd539EuuQg
39362	payment	1397	1397	1678	1	1	14979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNGSbiz4AkjaFKM5Zmpd1QpdpMhLgSTkmVmZ7m7HLMTywoh6dj
39363	payment	2134	2134	1874	1	1	5376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXACzhSoqknC3if4a46RQ1r94tvxfBG7aTqygTzGhuiEgbZhj
39364	payment	2133	2133	1874	1	1	4939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb9q9qLjVxHYfSggyrMquba5CSDgV8zB1xMMqihAtfELfTV5nr
39369	payment	1397	1397	1678	1	1	14981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PAMzzhALwi3T4eXPBiSuQYGgdFUUz9ii3oiRurh5Q5FQxTWX
39370	payment	2133	2133	1874	1	1	4941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX9pRga8XKKf2bbD5XQ1aHAWvM3eAb2gEs5UUZ6gJDXhWi2BV2
39371	payment	2134	2134	1874	1	1	5378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZAtUFYojHYSBYYwys98vHGdFxZgsjxA53orKDiYg6V8ivEEG
39372	payment	1397	1397	1678	1	1	14982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDfbfeRCoQFhHg897FjhgGrc5saBJbjNqLuuN5QizQr8zy5j9v
39373	payment	2134	2134	1874	1	1	5379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXfSYF8vr3miRJyHrYwWLaMKemeRcoEjjQmyP3nu2HYTSZNSeT
39374	payment	2133	2133	1874	1	1	4942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFPJAxUBwYjaRRxdMi9nGdnUmfr2THEwpfn9uxjtPaDphkszg
39385	payment	1397	1397	1678	1	1	14986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsA6Aptg4yELFH4VVwhVTLH8gYCUgEjakU91SixWGnSenNBE5k
39386	payment	2133	2133	1874	1	1	4946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX4WsqwcFbcaPxZw62BJRDRJf4zNTBaAf394XrGp5qnZe8aX4Q
39387	payment	2134	2134	1874	1	1	5383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9y5JJRcGU1GNnHhdY5HcVpWkRYwL6TLgCZw7aseHp3tvPrCj
39398	payment	1397	1397	1678	1	1	14990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQcrTsLokE2ybrnrezz9L69SGbTznBzkV8vNvW53mz65X1kdk
39399	payment	1397	1397	1678	1	1	14991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipMkWkd8hFXgGmUQiA9AbWRsUWbAi6xiGbrTdrqJR65FeyHmj
39400	payment	2133	2133	1874	1	1	4950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYtV8FmCwhNb2kHShkaip5VRooQ2xieztTbyhEyhswurPq3wQi
39401	payment	2133	2133	1874	1	1	4951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTEN7EFrkdEFYpNEvPrPGQkUbBvdk4dZAJEeFLzQM78dNebWqA
39402	payment	2132	2132	1874	1	1	1492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXWWvK4tT9Lt4XoEndcUy5YKDeC1Aw8r2oUBtj4UKSR5v9AXT
39403	payment	2134	2134	1874	1	1	5387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1XPFEcYPUnXfxLFpyH7RCxoY6zzpD4nJW3zkiExadYsgdMJv
39404	payment	2134	2134	1874	1	1	5388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCX4yDodz3kTUhufL5dUnFPNw834ggQaRXnZH9McCr7RdVHF8C
39458	payment	1397	1397	1678	1	1	15008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzifTiVuKuMLR82v4Se2uoaMDUF6FiFmgTeiTQRi1qPD1R8PA
39459	payment	2133	2133	1874	1	1	4968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwfuUukKMZDar6KMpXZ3ppvubmmbhPkavKA1GsZzDawA2Zbrd8
39460	payment	2134	2134	1874	1	1	5405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgZroNAMwniwSTLaAkUmnqDgUQymEanN6aV8raR4oQRK6awoB
39465	payment	1397	1397	1678	1	1	15010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNmtfZG9HoUEqDixAhzo9zXkepoUwuZD74t7cuZ2FFYGRCCgC
39466	payment	1397	1397	1678	1	1	15011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DW3HA9DxjGLiCaiaUeEAKFDZPQG8uiweWHWCcGcQtpW6NzvD
39467	payment	1397	1397	1678	1	1	15012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5BA53fmPzUS5Rj2aLwXbxGTHeKTq49ACWeUbHTt3qurBTkNua
39468	payment	2132	2132	1874	1	1	1498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGfqk51B5UU8RHyJdhmUKBYgSPziuq5SnfNq18CCvoMCi4eJ3
39469	payment	2134	2134	1874	1	1	5407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErLYFRchXdg2wLqsHb6NaeBNS2uuDmFfDiNwwWtyCTHzpXEGM
39470	payment	2134	2134	1874	1	1	5408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHd6wjj7mhawUhjtH5pAzksHdYhJ9xxePoKoedbZnP6AxdmH8n
39471	payment	2133	2133	1874	1	1	4971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHLJxLygPP9iQf2nAYsXcSq4cUdgkLtF7v8XxJsD5u3jTNAB9e
39472	payment	2133	2133	1874	1	1	4972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiRCakm1TnV8Ajo9As52ZoApWgpNYHSfnMPX1eDnGtLEYC6Rkf
39473	payment	2134	2134	1874	1	1	5409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBGd5vNnmWhUXvhGXsdqQ2zBzFP4xAPX8Bn7VVkmzCuwa7LAM
39481	payment	1397	1397	1678	1	1	15015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gA5zXxLxKydDgfV5ApXH9XJfuXB15619LDPFjS8UF1fjdStw
39482	payment	2133	2133	1874	1	1	4975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksgrzyZH2jyyx2jxZh4bzfa47ZeoJ69AMUu6ZwkhAzBcqehZc
39483	payment	2134	2134	1874	1	1	5412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSZwTaAiJpTPq8PjjMREmwrjS2vG5Zao6QDVrbyKqiMWs1C7R
39506	payment	1397	1397	1678	1	1	15022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZQgKFphin26Ea4RKMtEvfU1y1xLKTUGfTjVQgQw3Zkt2fLP2Q
39507	payment	2133	2133	1874	1	1	4983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGLinRCun8xbRpm387wD4dXJ9eU6pJiudKfZDy3hmZtJDNsLLY
39508	payment	2134	2134	1874	1	1	5420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdA2qF4mqUPwBY38Ct1iAV4JfH94em4dMqEjWr53cHqheEu36D
39523	payment	1397	1397	1678	1	1	15027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvWh9MzFV2QiwRedj27fNaeNEx9bx9BtNqaZfwpXPWDfrEm7Z
39392	payment	2133	2133	1874	1	1	4948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmg1JXnVD75ESPiygofd7NVpL4sqCrDegSGqzeGoQmDnW2Yrew
39393	payment	2134	2134	1874	1	1	5384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv54j1yEYcR7gZ1zHMPmg732GnsdgQYfU3WVoNhRdRxEisYi3K
39394	payment	2134	2134	1874	1	1	5385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeeEGsLZj8TvCdrjTkSNCzGjEbcQmkytPE6f1nfJhwLxx6ph8
39415	payment	1397	1397	1678	1	1	14995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnamcsquKM7BJ6QVP6sc6RNQVb12y3H5nvom76i1FbqLEBpgvQ
39416	payment	2133	2133	1874	1	1	4955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXnwjbxHmNgSdZThg9VwB9RXK4Qdj4wUw927dmrSHk1WKsXcd
39454	payment	1397	1397	1678	1	1	15007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrzrjR2fikLTYTKsYdyrWW5h6nWj5mmHxyh2Rov6dSuLp75t9
39455	payment	2133	2133	1874	1	1	4967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsacmazAYWVmgcDVMSPid1xRsEUdAfZ3hXvmi8Eh8XiQYQiSG7
39456	payment	2132	2132	1874	1	1	1497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqBU2wtaSiMUMLnhWW12Vmc6CNf45bn65p72xd47RHPxVZsAi
39474	payment	1397	1397	1678	1	1	15013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3CpTs6y6nUCGBKpXtLmj1ycEZfCuVHWu215ub3bt3QbDb9xoc
39475	payment	2133	2133	1874	1	1	4973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhj4zD8TpjiVeHp1W9sQuASi1M7T5UvCXHnCWvxV7EuuyYBkXf
39476	payment	2134	2134	1874	1	1	5410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKP5SiLEkNLGM3N3iwbpqDSYXnZtDVaP1amaExzkCVxWpr96YH
39487	payment	2134	2134	1874	1	1	5414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfUpKRYPA6BAfFzTjBtyv2Uk68DJdFQwHj6cPTYNdXnJe9msk
39488	payment	2132	2132	1874	1	1	1500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYai7Ts7YRY2QRsxJFtK1VzHZ9GMRf7G8GuaFBS6DVKdauQPpkr
39489	payment	2133	2133	1874	1	1	4977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t8bKFZxLtgx2Rri5vJziXZrPXrTgWhvVeibm9HPnwKMPjC86
39556	payment	2288	2288	2320	1	1	2	774743211465	11000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTcF5LTHifdVZ4eVUm3ZrtsbUB7VDoZvi82N5ajmgWupkuC2Q
39557	payment	1397	1397	1678	1	1	15036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvgZ6zqwvbcPyvrR2fggUcFzckxNyFtDsDqDoYQnLFmB9mfFx
39558	payment	2134	2134	1874	1	1	5434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnuCeY5YZP685QMwKEPLQvRa79ib65doosQiH7pKjeKLiSpoLV
39559	payment	2132	2132	1874	1	1	1506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvu62kx3eqsZ3MQVw1mayQifvGFFFLpDkWbMo6hBXUG5znRLTE
39560	payment	2133	2133	1874	1	1	4997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVj5y68qARSonVCxxh587CWBtwjmyciLmzegtHJ5p8vpRcRVd8
39561	delegation	2026	2026	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJefr2AbaGT1bXpdTNtSaMCmLVr4AAhiirTNYpT93m3Fzn5b7
39562	payment	1397	1397	1678	1	1	15037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzoViFj7ACejR4bDWXVrbQ1ettzCTHpB4YUN31Goh7xZ9jY92
39563	payment	2134	2134	1874	1	1	5435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzpV8EFDr2W9UmZD1sDD3kxJMoUR4oTEaYGcHDeMRBAqohXtp5
39564	payment	2133	2133	1874	1	1	4998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ngCzfn2d6tSS88YDpF8vVwhYHhw8695yUX4DmvYQeR76s4PX
39565	payment	1397	1397	1678	1	1	15038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhTQW5juQbPcbeRCY7gtsLkpybvpSzqFWmF8XdnW5he7CBEWF
39566	delegation	2320	2320	1600	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbDycsyk1XtjcvnwCLHhtZvQ8WwvwWA6zLETe6ZL1Xtnh9NUx
39567	payment	2134	2134	1874	1	1	5436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHh9MLFjdDrAsWtHTvMu5aMr2VbfwhKysxg7j1eDXw7pqyxHPE
39568	payment	2133	2133	1874	1	1	4999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u2TDVG8gw1FfgxKYT1otiCSh3QMpTmgqiDqpSEE2jcEDt7ny
39589	payment	1397	1397	1678	1	1	15045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxQqRFRMbqCVP9qRfVS6hLouChfqLwiCAYrgng9VfizrWkfuef
39590	payment	2134	2134	1874	1	1	5443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAazh2jSWrFhsnrcS9XrXQ1vCUVc163FDPWepDcTAdW94R5fVV
39591	payment	2133	2133	1874	1	1	5006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTWqXS8Li42sRuKrvFo1hJC586XbYT8W1sGXrn9yXBVkB8iwV
39599	payment	1397	1397	1678	1	1	15048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTbyvLcVJUrWT4Z6Tc2C5WmuRTHdVXBp8chU8Bs6U71bNwpbA
39600	payment	2133	2133	1874	1	1	5009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4eGtZvdisZep5e6b9o6froZkEPFBjeHtH7FNqy9XCvAvMFE2
39601	payment	2134	2134	1874	1	1	5446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKiu3DVtNZ63i6uuiLZpEAtC2s4F4H6bE4soK8VMhJYLyEoo4F
39605	payment	1397	1397	1678	1	1	15050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98NgzdfqHjtxP3KRs5HNmf1iASDoSXv93ZtVZjD7d7HUmKeKh
39606	payment	1397	1397	1678	1	1	15051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUadu5oCHRRu2v7e9ua99hWFe6Yo4tHpJY9kbVVRWmWXQL1Fh
39607	payment	1397	1397	1678	1	1	15052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S5Hg1QxjiUebnB22uDHohnQzaA96Z3vANF79nTFy1w27QJt8
39608	payment	1759	1759	949	1	1	7	2412918710000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpZdGXxQJucv2WXUxZk61iV2nEsKeMoRYPw4nTcV2f6Y452xdLyL
39609	payment	2134	2134	1874	1	1	5448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWAYeq8qxRkASvJS78RfAZmpARpeZA96gDrxG5YpZ1fAmWAMV
39413	payment	2133	2133	1874	1	1	4954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jVJxsrqhAmarPBDCqcvKj21uRKaSKznqsoLyMZs1rkPGUyBL
39414	payment	2132	2132	1874	1	1	1493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGeZn6UjrkNF8AF4xniVM3dshL3HZAUKzPwQhu2JBFECkvnaqk
39417	payment	2134	2134	1874	1	1	5392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnhyDXEmc3PEYdtYmQhhPcUevKE2n5PFgbCQdwqAvFXo5k7CZ
39425	payment	1397	1397	1678	1	1	14998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPeXwUXBSy4egpg5Ss86CpD7HKHcPM6TkMmbewQZjXJdi38fv
39426	payment	2133	2133	1874	1	1	4958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjHYdSyyAGCDZ7g8KZ8nMaYKG18Nw6CrzzbNRX1cZwknrXHiT
39427	payment	2134	2134	1874	1	1	5395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84Y5sz2tgiFskbHUxZMY7PkVK7XLaB49nwvomVdMVCvgZivDR
39428	payment	1397	1397	1678	1	1	14999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG59oXS34S2hR5o3GoY1Bumo8AhpXLnM6dwYwbs7dJLRzCT9Nr
39429	payment	2133	2133	1874	1	1	4959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHDG4duq9sPHthD2WQc7hJtrjZ47jGdMfSL98t2hma7t3jtSrt
39430	payment	2134	2134	1874	1	1	5396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwKjEMvAMFpiC1XLxEnaj2THneMYWrMaiyEkGHm77bCj69rPoN
39444	payment	1397	1397	1678	1	1	15004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfZXEsZGtfKNsAsx4aCdhxekrSBR11DXN8A94KN1QHKVZXvLq
39445	payment	2133	2133	1874	1	1	4964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4urSsiUAx4QPLbCenPuNmcfKrMv8Gsj2eQ79HiYYkdGgWpwAc
39446	payment	2132	2132	1874	1	1	1496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceymsnS61VqjhwTg2Kv8aZHh1ttXBjgBZiZ4cT3cNajcRQSxj
39447	payment	2134	2134	1874	1	1	5401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa32pTPLf4kPqHEZEFZyxTKfuf8Jjy3aVT2egKxaJrbANCHrJhx
39457	payment	2134	2134	1874	1	1	5404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqLRutJSWn9BsSLYZnL2MBmK6eC5MQFgn9P8DhxzBsFiyHJfk
39484	payment	1397	1397	1678	1	1	15016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsao2cRFTxZAuUFjpKt4PcSD9gPFkUkb7iLMfrGRZwiqDB93a9
39485	payment	2134	2134	1874	1	1	5413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzsgD25nABjNnxWvfs7WraQ5k9iU3FsUkqwnJKwHP1VBdJJNcH
39486	payment	2133	2133	1874	1	1	4976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5A24S4QvGSmiAk5NH21m992KpM9ThsQu4bmGiAWz7QMcj9HzW
39490	payment	1397	1397	1678	1	1	15017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc46M2WtY1JrVjmkPmxCS2LGXDMLzG2ysaAzjJ3rmKSJycdEr2
39491	payment	1397	1397	1678	1	1	15018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYuMfe2J6p5iM4EPDaovYGq4KDtwhVsn3UkFxCPJKG7MGYua7y
39492	payment	2133	2133	1874	1	1	4978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanyAzUCQwktSgzac33qHJ1RCRiUG8AViHmS8PjajgCJ5VmjAW
39493	payment	2134	2134	1874	1	1	5415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmL9GEb3w3EJqKoTf4NFZ3P1uhAB8c76p1zfEFRqa7VSj8Jhpb
39494	payment	2134	2134	1874	1	1	5416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGG9GqNamR6sRHmugAyxeEGZCmzKufqALHNvXgq5eg21CFJP7
39495	payment	2133	2133	1874	1	1	4979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJj8bmiE6faAke4dzPUGKuhi5uSurFFa7YSG1dBbEr3xqiBRx6
39496	payment	1397	1397	1678	1	1	15019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcRYfzfcqdXGS1eyfuckQFQVkefEVjJfrSW5B65i8rY9H6YHm
39497	payment	2134	2134	1874	1	1	5417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoNqrUDgVDrRo6dfxDKG24nx2L3LsnahozTcrzhZULtWepDKs
39498	payment	2133	2133	1874	1	1	4980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJY5c4a2rD7bqme4JBT7CHkZfBpvu2gUWNVRGQp3T9Mq6XBpjv
39509	payment	1397	1397	1678	1	1	15023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUwdJrfSMYTDLqZkGyybRKd3Tq9jgDtMFGsxuK9oE44KNkLNg
39510	payment	2133	2133	1874	1	1	4984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihpPTr7VP6UYprx8u5pQ9LesDstXEECvbFzbfM18fBevNHNNT
39511	payment	2134	2134	1874	1	1	5421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgPgAFjoSE92WQfJvNEgS1eXxD1UpDewoTsPaLLyq3GqzunhY
39512	payment	2132	2132	1874	1	1	1502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH353fPyTTFr8VnDKa2YiQZMjyEon64PUJXMp1SwGSCs7PrYAw
39526	payment	1397	1397	1678	1	1	15028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFm1w1BLbkGBDyhoipps5DuMjc9cXYzwY4pSArQWRyZAhJFfdy
39527	payment	2133	2133	1874	1	1	4989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvgHhHAEa2HzzvPW3nDyfB8Z4mGXziXFHP54fwKA6DfuDYB88
39528	payment	2134	2134	1874	1	1	5426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2WCQyWu4G854vnjH81zEWzwzcNrcDMbdRVyxYLz9tR7wfswC
39532	payment	1397	1397	1678	1	1	15030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fw8yhUsYJZ3D9Ljb3fgw3MHJuB4Mji1Bbq5QcwLuHBVs6jy4
39533	payment	2133	2133	1874	1	1	4991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEqBCexHJ5Z8t6VKkCa7eu8UjSQsdB7avAwAYTSfPmPUMhjf6
39534	payment	2288	2288	2320	1	1	0	1000000000	1000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4LpsrHyTn1AVbBcuf5hqW8JFqT19D36BqrVXLaJ59qKAWd6D
39535	payment	2132	2132	1874	1	1	1504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXNs9s8PnJdoKmQsUZ2Fd3nySzm1mXEGrtGtyoTEMepKJbhCP
39536	payment	2134	2134	1874	1	1	5428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncceJjxjQ7n96X2bHz1w79BjmyMu6npUAWnfXvdqPwP4QYTUq
39452	payment	2134	2134	1874	1	1	5403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8o7d3fwUACTG99cPLUXodrqLSPjB8tsruGEugbR3uGQEpLSzh
39453	payment	2133	2133	1874	1	1	4966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjzpF8MRHuTDwXwwJpxJ7HKZD8Y1ikdBPa2HAtDC5kxPRz8HF
39461	payment	1397	1397	1678	1	1	15009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1DVfEo4cqr54VkgxJ9GUVNYqmPFHJ1LceaTL4tvMvRjrRUVDU
39462	payment	2134	2134	1874	1	1	5406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzr3XBGxFSwBQCFr7bvuBvt9dYzpjALtpVqkpdvULiCZsEAqk
39463	payment	2133	2133	1874	1	1	4969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb2AuAXYm51nhq3ZNSpmXJnVZKvasdTgjbsVafmwG3Z4qbr2Hv
39464	payment	2133	2133	1874	1	1	4970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRsyCTBwXNGK4isnGqVikXQbTmotsXfu7oYuReuVDYAcJef4Z
39477	payment	1397	1397	1678	1	1	15014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToPdFgdwuCv2z6cgLHP6amJ2MJvRxCXmaMxsbsNgKkUbtHP8C
39478	payment	2134	2134	1874	1	1	5411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCFo6Letb53JWRkGnNLUG1XiN2rjCZGyJt171Kcy8Zbchu6nZJ
39479	payment	2133	2133	1874	1	1	4974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwtM2MNZLXfgGTZnqyGF7qhsjaotUuD3gytL9S3aEs7VKxqqa
39480	payment	2132	2132	1874	1	1	1499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3pLyRr72EwKdwCRYcbd7SvxBMw8yyDaUUorqa3T1BYCpqK62
39499	payment	1397	1397	1678	1	1	15020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhxLbDesBcacpJuTah6jFF3WDzHC2Ay1NEJFw6FK6N7N6hq5kL
39500	payment	2132	2132	1874	1	1	1501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUTYnxS26syhdmSkYMsDdo1gkYgxwQtw4uD7YeWmdBVkuHuwP
39501	payment	2133	2133	1874	1	1	4981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwEU33rui3NXyx4PZqGoUaaSF2bWhKaAwga9Gfj6r9dUv2qBd1
39502	payment	2134	2134	1874	1	1	5418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGXtUjUjrrKKa8zu6i3hqRY3GKJSMU6CMsJsUyKWvjkwZZHFm
39503	payment	1397	1397	1678	1	1	15021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC72hg614Kr211D71wCRbDUNYq3CQU22xUSt4G7FS2M12bBJE4
39504	payment	2133	2133	1874	1	1	4982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFyDyZJfZ3N3FEKgW9YT59NzcdpthwWJyEetSUbArLzZGF6LK
39505	payment	2134	2134	1874	1	1	5419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAi9NiFgUjFNmoh35KEHF4QxLTNodjasSGmubdYRLhFchh7G4m
39513	payment	1397	1397	1678	1	1	15024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsjz6oC9sJCWa8yDsBug3H8bWYoDiPcmpqUiJjUxrGUJZHK8N
39514	payment	2134	2134	1874	1	1	5422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ61dYqyNXeJ1nSCDKZeWAnm5WtUDFFVKCS6VYLV5sK9888sSob
39515	payment	2133	2133	1874	1	1	4985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6a1t36yujfnAoMAtXUNbds4HbdVVNdvNHuBycar5DymPYex6
39516	payment	1397	1397	1678	1	1	15025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfSztAJcbnDfadQaLU12hY2nHt4csW8Zkdmn6BzkWrM5mQkR4d
39517	payment	1397	1397	1678	1	1	15026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mej4D5kzxcVSsY4HBdexXR9MyZfNiKChw8VEjNdf83Z81uXk
39518	payment	2134	2134	1874	1	1	5423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjv1B4Qqg2g1SdPP4pQETGRpk19UxqSeyHPtRFMAFPYGe46Pv7
39519	payment	2132	2132	1874	1	1	1503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLVEvLUnZePTPeDeCr3VCYLSEL5Rc6GyxnTEmT6GTWVAsV34J
39520	payment	2134	2134	1874	1	1	5424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU6JsPMNVF33HdssBZhPSYR1zRAYrc9VPrae2Ty7HLRV4i97Ai
39521	payment	2133	2133	1874	1	1	4986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRHzFnktX2ngLoJqzHDFK4zYBMa4JPa7iB2xT5rZNMyYdjHch
39522	payment	2133	2133	1874	1	1	4987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHe93LGYpu4jjpX22ewSMhgKUNvnLXAP5Wf8vt6x2TJP3jggW4
39529	payment	1397	1397	1678	1	1	15029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXUctp4e2ed48T2CA51kyGcS5EMzuPh4VXc5K6FGiarmohUR9
39530	payment	2134	2134	1874	1	1	5427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMyrtZx4NcSZfFeYM6VinpJadqE94oJjKo6gZUNHegkQ7HDiL
39531	payment	2133	2133	1874	1	1	4990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9rSh6iLerMavs3b9ZB212hGw8GYwcE56Y8oL6ZzX4Et86WJy
39543	payment	1397	1397	1678	1	1	15033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUKx6kUoY8BfnCRCZjeEnybDatpcJihdjNaDVetJMLUt1BD2X
39544	payment	2133	2133	1874	1	1	4994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAAUWiUKDVBRn3H11KZEQ4SXDNAAzan6PzwAAVvNKQEgwLCwA
39545	payment	2132	2132	1874	1	1	1505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVwAw696U3ee9MfEzuFnxuzHmKkrDzJBp4GXt15JrYBcaefJGU
39546	delegation	2119	2119	1403	1	1	9	\N	1000000	\N	E4ZCRY2P58mHy4hmVjz97HpkQeWf9W9WauG8UbFPqKnY4dn4oJosH	CkpaFmYDrT2xFwJRSNKSQoKLshK5342dKtvC5vX1FahjcACmAQyTw
39547	payment	2134	2134	1874	1	1	5431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7zKpm3i8gsVfwXpSJVKiqmHUUDskjufU4aWUJWkpPzpeeHdD
39548	payment	2288	2288	2320	1	1	1	1000000000	2000000	65535	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYikkqvsZudpLrP9qH7LrWfonYabKteuxwqKWpYAFQhfeT6zGDF
39549	payment	2134	2134	1874	1	1	5432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzza5YcJiv89emaiWoWB4VbcNaGqqZvSzuCqJcPmcVvTrFZnNx
39550	payment	2133	2133	1874	1	1	4995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8n9NyTvVgekCFggeUGoWkp1TmrVPyKC5yz4ZQmVqVAPs5GCn
39524	payment	2134	2134	1874	1	1	5425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5Zn9viqSnZ4yzYkUpAiTr9xwJHPkLvVKTnsaUbtD2rY391uA
39525	payment	2133	2133	1874	1	1	4988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69UJhGe2d4FrNCwGjSaa3U7RJnZMNFNk7bfwTppFAa2LY9v2F
39537	payment	1397	1397	1678	1	1	15031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCnT9KJooMUGbRpFmj5kqsKwgPMsf4aSAxwc9hVzmVRSPsvLf
39538	payment	2133	2133	1874	1	1	4992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTUp5mQTstGsH9LZWLAco2WGniZwYiZEKNhRYrt3TdKpsEZSi
39539	payment	2134	2134	1874	1	1	5429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoToVSxjZgmr5VGDUvQHUoaA6qFjBYHBiKjWgiH1jpXj5U7tpt
39551	payment	1397	1397	1678	1	1	15034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjadX7oPDxU8XUH9aa1oZaJoCRyVduWyjY459JQTp6HMi3zQK
39552	payment	1397	1397	1678	1	1	15035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDQQ5Kmp3BzEGLp2wTCHDovLM2uTic4a3aXXqUqn5rFmbcqGX
39553	delegation	2320	2320	1600	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkW99ysDL5Q4gTxh7BV5AHfKzKzBgX4c6gUjhgnBdQW2sxwXTC
39554	payment	2133	2133	1874	1	1	4996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFoPwPhs6zZhuQJtQUsmmWFDMPfdk6DoKATL78G5ZRuiKRjff
39555	payment	2134	2134	1874	1	1	5433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CZC1eM5eY8uMEgYXE96RCnLszNKQphfhMakAiJnTQFJwBcHC
39569	payment	1397	1397	1678	1	1	15039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApoufyyet5URNVaPQpG4x4XpJjmjUny93gBkpWHeybbepqnCZ
39570	payment	2133	2133	1874	1	1	5000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uBRmSNiPAbFgnYPNFyBKURa3mvPCFE1WKLukhJxEaYN2jBCq
39571	payment	2134	2134	1874	1	1	5437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLMbZ1MnzJvpNQ3RoraJBBxJYatDykw8uzWdka2nFM1ncx4AL
39579	payment	1397	1397	1678	1	1	15042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhwMgFJfDJF8MCEHn8WcsV1sv9ePUFELsABUcJzRTgotNEUJ5
39580	payment	2134	2134	1874	1	1	5440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZVZvpoyVzGqMTG8UC2ZRvqH15ZYr62TQ3qtdPPweWzFoMEno
39581	payment	2133	2133	1874	1	1	5003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYt1bcBjcdy3eryFvqRf9fGXnZdxXC1wmUixTzxyrgeDxEWco
39596	payment	1397	1397	1678	1	1	15047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEKMM1LM6YHor62uqzVvxG1nRf1nx42RVUge3KVV7xEmianiz
39597	payment	2133	2133	1874	1	1	5008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzQbsmBFuqpjSoTizr8GVo71ThCMPzAfMfN8LGRcpTKRy3H4Z
39598	payment	2134	2134	1874	1	1	5445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4A6ob4zf6DpChJdUAxECUdnapQgZceiVgkAKta5Xu5iUCMdC
39622	payment	1397	1397	1678	1	1	15054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZti2iEBQXSxB2tvPEEunQo48346WE7b5k4KVYnprLHoXE1nP8s
39623	payment	1759	1759	1315	1	1	10	8129710000000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpYXdkEEHfagZJSLy2jFJKKdbJVR32wmwv4JKrowkRLzKAYRc76f
39624	payment	2134	2134	1874	1	1	5452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEAFHjbES3pwEVRiKpqgqZBsUAXRWmTrsxCMN7KqqP4zLgfZNY
39625	payment	2133	2133	1874	1	1	5015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNCs7sNJeKHigCKwErKKFqa5RSropve64YR31nhiLawqv9FJF
39638	payment	1397	1397	1678	1	1	15058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJ8QKaqFzkmkjY8AZbk6HA3B1PT77QpY8vKsckQBdi9YbZqme
39639	payment	2134	2134	1874	1	1	5456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXrnwHsRaayUCyVyMg76q6VNkZi3bEVwtPDy77hWaJpJpcYpmA
39640	payment	2133	2133	1874	1	1	5019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2h6nw4jafPjhKHhm4mMV7MVEdPqWJuTUg1XhmabxQV9oFbRX
39651	payment	1397	1397	1678	1	1	15062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYARWQi22Te1DdqFhrSe7z2YWXvkcVpQ9qeEQJRxFLLXjTGhdf
39652	payment	1397	1397	1678	1	1	15063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2chguKPu1gSuXATcZ8mCaYwiEDyWjFNgXrZ5eRRoC6axpWugu
39653	payment	2134	2134	1874	1	1	5460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebE21CLpNj1fZHcBhD8ZgQC9RdyaBGAAT2cMwEZ7L74KrsetE
39654	payment	2134	2134	1874	1	1	5461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSp17ZKWxP7iUD89jCCYeNKZyPmCE31Q62wBdyBLWAeRPVzRwg
39655	payment	2132	2132	1874	1	1	1514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh9vx5MGHZHYuEDRRH5quSVQ1FCbQ9LKvziLSQtPXMx61HhyYC
39656	payment	2133	2133	1874	1	1	5023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtNgtNwYkHNcqNxM16dxGJA8Ny2oXSu9bcNS1hSq9V4TrG7YJ
39657	payment	2133	2133	1874	1	1	5024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkimQvucjJG1KYZkBXxvJDVffjkQ18YvbTS4Sr1rs28gTpn1Yv
39668	payment	1397	1397	1678	1	1	15067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACAME8M2oBFcCmB7uWbTkLYUrhq9sPaQwC81tRnqegLP4TAiL
39669	payment	2132	2132	1874	1	1	1515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdH3nqaJSTbvSh8TqpzC65UDhLa4B78ikUEGZqLfEzAD8N9J5
39670	payment	2134	2134	1874	1	1	5465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu6poBqLpeRsH4oGArUw6KX2JoVE5xfxWvLP7XuVimAUHnQE2G
39671	payment	2133	2133	1874	1	1	5028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXn6HYeFigDbEP5MtAEGabcuQ7rAx7TkCij6jgHkPZt7ADfea8
39678	payment	1397	1397	1678	1	1	15070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvcWGRrwQY9zQTwDKdFY6vAvMTBmGLmppA4GmQJuPFyN9QAXbh
39540	payment	1397	1397	1678	1	1	15032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTMNZNwHGeEPhDXGQHhsmCSRQBmz5P3cdvwBzNRijiWsXgdC8R
39541	payment	2133	2133	1874	1	1	4993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ946gRxufMprGUx54uQsr44mZcVY7MfFbFW7kR4s5PDN1HMatf
39542	payment	2134	2134	1874	1	1	5430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDa2ohD56mMwxeYMuxN5UdLr9Ez9dxVwEys4Hx4ds7PWG8MNfy
39582	payment	1397	1397	1678	1	1	15043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqzZeAGBhT2byZDHK4znPsbCRxaY1rg1rffvybgYEemxYK2ME
39583	payment	2133	2133	1874	1	1	5004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQfby52DcYeiUMnt2FoCgDL76Vau1qSLBq7yELHCEF61RoRLdM
39584	payment	2134	2134	1874	1	1	5441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYarg4bbdhHiwRZAYpaC4uP4YT798d4xTXBCZF1UsX7XFzskzKG
39585	payment	2132	2132	1874	1	1	1508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdESsJtZg5DGDCi2DZp5ifZPge5v2CP8PjWtQaXDeYencxFGoC
39592	payment	1397	1397	1678	1	1	15046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCxaK9TRhMikgCYQjfrTusDErQU9GN3aERUMTXi6BsB6YPCLGr
39593	payment	2134	2134	1874	1	1	5444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3beUrEtKNkwU5Xs2FkUnZ35nFjgBMiDHqBs7DwZVwbiwGJ42
39594	payment	2132	2132	1874	1	1	1509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYngDn2jsBhTSWKVSQKGHMqJQ1JCFE5DWxn5esfpqrsNKLKiT33
39595	payment	2133	2133	1874	1	1	5007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6wo389Q4F1qLnWM1scVssdUWdhRqpdgNBsVUgrPVwTkMfwaU
39626	payment	2186	2186	2317	1	1	1	522850000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGzXWphTNPfsZwEHWUsgBkKUNyZY7BVYnqCR9BrexRVSRuYrs
39627	payment	1397	1397	1678	1	1	15055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunW3tuayaMLZDiZ9eRjLYobKzBWbhCtXnbFMckWcZ2weQFTG9
39628	payment	2134	2134	1874	1	1	5453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFascjWZJkt3BUJkMf8JfoGvHaYX1dEnyuYQkpwo2MdVkHUdJg
39629	payment	2133	2133	1874	1	1	5016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHQCth4oLumEU4ty6QumB582jVnwB7aipJ2RSGFXjPJts3fXB
39665	payment	1397	1397	1678	1	1	15066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8EEhfrXP8zoG15vxh5ZEcZsKdnDK4Rmx3zeRobbXvnhXfFBPc
39666	payment	2133	2133	1874	1	1	5027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehrB6F9gZ1T5aYaYndA6WhpG6Q8Ua9RPurKWUBVno5PsAgMEo
39667	payment	2134	2134	1874	1	1	5464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dDJ4CAyHj2fVxz8qzkyoe4DztSTr8jpSwnaK9fLExchJ4eAh
39672	payment	1397	1397	1678	1	1	15068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwmCKjW3uwgPPgCHc8c38nF3xUbZGJtqaDT5gCBJtnbiJ7zVH2
39673	payment	2133	2133	1874	1	1	5029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewBPDFnuqkLRPA2XfppBVJQuwZUAv1d4tD8vnu7WtnaXRxcPg
39674	payment	2134	2134	1874	1	1	5466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2GkDzxnJTjN3PR2GZNSmCHbayq2ENRvVbT8dSgHgb75J6rjCq
39684	payment	1397	1397	1678	1	1	15071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Du1NCM2FzoFaazGM58Wv8ib2yWREtayWWFpUnPPgHf8fDJMi
39685	payment	2133	2133	1874	1	1	5032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJN2eaDG3ZcxpRen3u2orcGunEhGoTYwSyt5rGewa7Rzh6mPev
39686	payment	2134	2134	1874	1	1	5469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRz9fvgWLkGMaUvUwdt731j8cjzSa8fB5yryJfG43Kahod8QDH
39687	payment	1764	1764	1208	1	1	11	2468000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpZogdtptdiMLiDn8eKkreokhWvFTajYZXiTKVbnmjJA6HUMRwJ6
39698	payment	1397	1397	1678	1	1	15075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxSrmpNojz2UXgvN7u7bqtYXHTZ394iGQ1sMTJwk9HqYPuVXn
39699	payment	2133	2133	1874	1	1	5036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQks3cND5osTxmzqiULxZ58xXG3enyYSt7Y4okaL6grRCnGN6z
39700	payment	2134	2134	1874	1	1	5473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuH82NS6PAvcTCNBYzjmgf4CCE1eZKUiBtkke2fbwTZDm9iVAQ
39711	payment	1397	1397	1678	1	1	15078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6rs5tyuJdHfR17WB5CU6FndCsXHm3iy3JKfJfBzB7E29Mxeiy
39712	payment	1397	1397	1678	1	1	15079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFG1yXqZgjv77EVtq5dHBkLJVKeoVbuNAd8Wc4qKGK1nLTtx5
39713	payment	2133	2133	1874	1	1	5039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRnD24ZnVJBZwkhdYvL4PJbPAKe6dgNrZBzy8UJ7spFDWRufx
39714	payment	2133	2133	1874	1	1	5040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSyBjbafdSmtXjG6HZnJPYZAQtJQHCKbK7fJ5tG68R49qbNYVy
39715	payment	2134	2134	1874	1	1	5476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibd1zHX15qJa7dBYSNfb1VqmkuvVpsaYqvWNh4LPJ8dU9nYTZ
39716	payment	2134	2134	1874	1	1	5477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5EX3wdQVswHyayxsdckyX2bgs2HPvNVGFBgw5BCEXgc9K5noY
39717	payment	1749	1749	1081	1	1	21	4490000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	CkpZr65d9Jrio9oJDQuYyWFMSTPPaUCxUMtTDJw7Q5Vzz51V5t5Cz
39718	payment	1749	1749	1327	1	1	22	8442000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	CkpZVUUgyPAdupjShpVXjo8R6NBXhZj1dQYQUsSUEmVVczyVCZBKV
39727	payment	1397	1397	1678	1	1	15083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmax3VcFn346bKHxQgJ55u5H1hhDi8WCSxJoBg1wmLHsF6W8E
39728	payment	2132	2132	1874	1	1	1520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt19XfPMrL1TR2yukaM3NdRoLM5iPC2jghgJfXEticE5iAU1Tb
39572	payment	1397	1397	1678	1	1	15040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATgddePU8PkqZY2oWQXHKFAT6pGDxLRSidRLn4PgyyotS4vdN
39573	payment	2134	2134	1874	1	1	5438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVNihuCwDYHaVuj9KtP7Ff8CC8brnjBdceSMAQC6sX9HTgJCgU
39574	payment	2132	2132	1874	1	1	1507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtFcbjYnki1WaxE6PjZMsRD7o85iCKuyoaPKfwwb1K3Gy7fWp
39575	payment	2133	2133	1874	1	1	5001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBHEgHHLySxq38xDybK4h19Zg5hmoB8TMUUNY5KDT84P1uMBe
39576	payment	1397	1397	1678	1	1	15041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXu15AforxoV8fBgCAFuc9eoTCowAPrbB3aqRarmJ1xeu1dvg2
39577	payment	2133	2133	1874	1	1	5002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsj1UXeK2G4cQkLTrcqF1PYhX8Rtq58LenNPnzdC2TzYTMobEG
39578	payment	2134	2134	1874	1	1	5439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHVFLWUfyfJmFHppYugVEWYnaZ5Ta7DYWBD15QhK1oNdJTw2Y1
39586	payment	1397	1397	1678	1	1	15044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWaWmpgVcZUz4XGKfGFDhUrzYkCwK2F4YKjYRLWFKuuub555E
39587	payment	2134	2134	1874	1	1	5442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQQpMtcGkK5DLYrk4zn7oZxJaPoNiPuXuD9cd59WEGnTvvSGs
39588	payment	2133	2133	1874	1	1	5005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmWBzBjXr87cTGohXU9AXyDFztjGdrXRsmUBscnEygWsk6xinn
39602	payment	1397	1397	1678	1	1	15049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmACcbaNf1TB2yQnixxg2bvSJYGeQS7jZ8ViHcHRcwZ7QaGt9R
39603	payment	2134	2134	1874	1	1	5447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnfHEeFJGXcC6hBiiQhiWbn5TCNWVp4aAXMTYo5Ntgq94YEnuc
39604	payment	2133	2133	1874	1	1	5010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqyyfqCWxied4tEm5hAMe4wVfrK7aKb6txUU7gCRmfr81BJ4n
39648	payment	1397	1397	1678	1	1	15061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEt39bLoE7fhMz8V41uogZRD5ZkuiZiRJKDt4E6ZUh8ANexJrn
39649	payment	2133	2133	1874	1	1	5022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZydByXr4cZRYgwcPR4RZ3tvFbjnSsWsNT3jg2uA65hfUcVhVFo
39650	payment	2134	2134	1874	1	1	5459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6Qe2qMwGLgfoDxTQzD1CmG9VJYGm4aq339SFG2e2JAUe5cue
39658	payment	1397	1397	1678	1	1	15064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXEmBgVVZFzVgGNVYwtDd4irknbTKzoDNjmrubt2hyEszmYr6
39659	payment	1397	1397	1678	1	1	15065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdW43MEPQX8Wz19H5F6rVVpozs2CvXZoWrR7sinT2viwHKoCV8
39660	payment	2133	2133	1874	1	1	5025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBjKXK7BDDMMwvg1rouPnRHFoxUeCzuDyoUx8HdgNwcKUob9A
39661	payment	1769	1769	1769	1	1	59	100000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhD9Cr9XhrWAA6rabkHxdHUw2iK77SEz3DKLmdPygNZNZJaoP
39662	payment	2134	2134	1874	1	1	5462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmcR8F95cQRzdSW9SE2bJPDXcT4F9ad7i86dF3GukCbzQYRZCX
39663	payment	2134	2134	1874	1	1	5463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEs8mkL96x5V31qTRy5CEwsgdxk5zQruLniA6umPnpsH5r4K2
39664	payment	2133	2133	1874	1	1	5026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTJwXZfgbQdJjUV9DU7PQr7TNR5ZB7zNRpAgbmzSJff3mHhY2
39688	payment	1397	1397	1678	1	1	15072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7KYhpyqRmuTN1Zh72UpyvYiCazNG5bjLn3o5VWYoVACcnzTAa
39689	payment	2133	2133	1874	1	1	5033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7ospajTZxZhMmYkstw1HuM5nmqZGgTggHikpr821sH27EqNg
39690	payment	2134	2134	1874	1	1	5470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuo91deFt68PPVHS4npUGgQzwL65cQ9k4z3ESN6GRhDUuBeJF7
39691	payment	1397	1397	1678	1	1	15073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyr2YZ1tpGHD8B1148W3cnUATRJm4zNBiKeKfRAsJkLA2FMhCQ
39692	payment	2132	2132	1874	1	1	1517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYt7Lwhdfe7Kf8muSxnDNXiYoeYRLD1cQur5589Mn54YRTgiqg
39693	payment	2133	2133	1874	1	1	5034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxe4sjwqsUQ5ZJr26JkUMmkk8fwmey9xtYRCxm7JMEPoJte8a
39694	payment	2134	2134	1874	1	1	5471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSXCcdyDawq1L896WT79JS1z2FcEpNEhsQEKXRKeDa2ADUrH4
39701	payment	1397	1397	1678	1	1	15076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tis3JJ5GTASi4cAwx7WcHq3fshGa3wFTa6JxZjzE9UKWW8JX
39702	payment	1933	1933	1749	1	1	2	1903000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXpJG1pMsmP9YYsixkLiygmhSE1V43xFuqdWCFcxzNX8VVVAka
39703	payment	2134	2134	1874	1	1	5474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GZ6qpdVTadNFPNPdZQSJ5jweXQBH39kcMe7YCvoZn4nVk3Uc
39704	payment	2133	2133	1874	1	1	5037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZ4oCb7MJ5jvPAYKUDL8d2PmvowHMAc3Xx17LqqqVHyKUFv24
39705	payment	1749	1749	961	1	1	19	2505000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	Ckpa7myZr92hW5PZ3sCajhQRe2CsWvhrCS3NDaJYSV2M2bp1TUnc2
39719	payment	1397	1397	1678	1	1	15080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnja4K7B3Ku43wbNbiKwFEgj4bVzfvCYf5bgSHrZ5vREYdniZi
39720	payment	2134	2134	1874	1	1	5478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxPin9qW9p2YWoCS5B4YkG223mfgAsC9vzPC1iXuHfh26rW72
39721	payment	2132	2132	1874	1	1	1519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHtNcEn3StNz5YKxe273dFN9kL6h8pjQQarQc4iyRkum5YkbY
39610	payment	2134	2134	1874	1	1	5449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgzNeqhCZaAqAx1mXUNo4VaSgAJA3uQF5yYPabc8k9tRAZ8sgS
39611	payment	2134	2134	1874	1	1	5450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPC2F769h1XJecore7F4yjZ4Q3MfKzrd5bq9eKxF1URkUMXFC8
39612	payment	2132	2132	1874	1	1	1510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5jBR6Ucnk5ZXAg1FjYSBYqMjz8UyqLrVtKTyctfZFAxwvj5Q
39613	payment	2133	2133	1874	1	1	5011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATJJVYiAyNUPc4jpCrhYfiU57FaJD8KApeqYxw774nx2xLSRo
39614	payment	2133	2133	1874	1	1	5012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp42JJRy1Mdd4VbqxBwyHBHTqaQCuafLV6137J4zKBwbj2cbQm
39615	payment	2133	2133	1874	1	1	5013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNzvtaWCWdPrTUVCh8WJbG899z35Y7x1YkMtqp3ZUfvG1WQtU
39616	payment	1397	1397	1678	1	1	15053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wUPVBNe16hDdmnzZwqDyzURBHhSTHNrfJPVjYk24UmZW7nLz
39617	payment	2133	2133	1874	1	1	5014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8kKcGDnvvZvPA3M848fGiYWxXcoJFcpg5qrNTdLQUptDaThJ
39618	payment	2132	2132	1874	1	1	1511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikN6k6LqYiKnbUBmfP5aGQLpnTH3FEUenLUAFVt6QPi77krBK
39619	payment	1759	1759	1189	1	1	8	2917441500000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpZjnAHgUPybfWoLFaBdiG7n8BdmtKieVR69vhUaincbJNKDaAUw
39620	payment	1759	1759	1069	1	1	9	4323929650000	1000000	\N	E4Z4Se97qrPzFGKBLxAJ1qhDXPSPr9BuUt5H5V8R1fV1wUiMFDFib	CkpZ67RPGVgp6JAGjUTxA4Hsh3bJuJMqjxQGtVfGyd2oqhV25F6eb
39621	payment	2134	2134	1874	1	1	5451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnj9dzecrqW2HruvR7JD8R7DmbCWZTetDDpZqT1GPbfWR5sD3
39630	payment	1397	1397	1678	1	1	15056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhhuBt9UCbQ9MiXRo9Y7x8Gq6EV7ZocikjGwJ29A2dMkns88HR
39631	payment	1397	1397	1678	1	1	15057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpVDTHdX2QPpQeEcgLj8zmbaiUxDUAxXf9nkUc1GxJmHJhbC7
39632	payment	2133	2133	1874	1	1	5017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGcKf8eWP1ZQPcpwDS6eRCRqmj5oy8be827W1y2FWPkb4zs6iU
39633	payment	2134	2134	1874	1	1	5454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMVW4aYshFk7YNU5vGBHxfx7c87RUDMJMyzry4yYrNVNZLU2jT
39634	payment	2134	2134	1874	1	1	5455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgd1obAGWZgJVxwwm3t1kxXejNfg3XwmJniGYQbq2is9zFPYj
39635	payment	2133	2133	1874	1	1	5018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnzkUdRjmwnqZgDT9brGaGvHsYArYTGhW8FixpV14xuG5cNEn
39636	payment	1764	1764	968	1	1	8	2041000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpZyiz6K5zqD87Y29RWSHr6wK8Pa5HcQarDyCJs3dD2cgXjTYfLf
39637	payment	2132	2132	1874	1	1	1512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDuDRZZVsWiALDJCRDahJWV6AGQSFH7vEay2AQbC6yzotTbtg7
39641	payment	1397	1397	1678	1	1	15059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLGWMy59CvCttPBS7D6WEsddNWfLCSb67QVJ55LbHgGCgGB7wr
39642	payment	1397	1397	1678	1	1	15060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEK8ax7JxqbJkh1KpxKvPP4xw2yEzffv7AALZ95m1UGMYgMgUZ
39643	payment	2133	2133	1874	1	1	5020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZnwHMq4faHK9RDYjMsYmQkmLznea2iA8qXquA2gMCzd5KYQb
39644	payment	2132	2132	1874	1	1	1513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAHKbjro1KpLMThfJZGZR2cBtBLgrKCRdkgN1vziPPi9338Mr
39645	payment	2134	2134	1874	1	1	5457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSJsnNWh8J69gLio83c6F3objaPSLY53nyxoWopftKRNzP1sq
39646	payment	2133	2133	1874	1	1	5021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkLMLWwCgiF2itXfXi6S6LqENS7PQc2ZseaPmQJ44LGk9Xwhi
39647	payment	2134	2134	1874	1	1	5458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbquyK2sSXviZ6K5H4W8dUobMWzTm3Beaivn5JjEhF6YnNXBU
39675	payment	1397	1397	1678	1	1	15069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQ2a5T1p7LuBLjLBmLRKNvZwRE8RneumzuUJYaucCDRV5hpYe
39676	payment	2134	2134	1874	1	1	5467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eAuwMeYompbB4GjNXcNqmmJVpF9X3fDPHBuKKeE4renuXrRZ
39677	payment	2133	2133	1874	1	1	5030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGF6DoYEhgbMhjcTussFD5DgVb9kGYURe2S2JSJEXTFfMjSMr7
39706	payment	1397	1397	1678	1	1	15077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM2hGFTnLihjrfsbsc8ay6kkWnXvfWC9PH6XTThsNJF4n2i6rt
39707	payment	2133	2133	1874	1	1	5038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgS7LLVtWkykv4NBc1mUGm87T3NRX9xyFgFcoe9kcdqvqAk6Bk
39708	payment	2132	2132	1874	1	1	1518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35EX3u6saFyjxUWPYrCTVZEZHTPQEFEcYoMBExpsnwPAU8A7G
39709	payment	2134	2134	1874	1	1	5475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHdkPoYaYZGuUnxNmfShbfi5Z9q2LdUNNDPWQKHEZmn8u7KMQ
39710	payment	1749	1749	1201	1	1	20	3029000000000	1000000	\N	E4YmGRzDAo91JPksYdkDf2a2M1Usxf1cn1bgnizMqWtdtTKiP2ghE	CkpaHg2WEnbFQ8upBsL7gWqFp9fPLwBxF1EN4dGvjm3RHL1xjkWDS
39723	payment	1397	1397	1678	1	1	15081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WG4NXyGq5i4erDJ7WQR3VR87LDTQWFEjzz6xbvyFySTMqDNw
39724	payment	2134	2134	1874	1	1	5479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xYHvsdmWB4TLkgkvcnNJfHH6Sd3h51cMv3er82Cb6SzZD6G8
39725	payment	2133	2133	1874	1	1	5042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY38yC1HzV53H9dKRLtHWtT4JJyot6rbPgpYihcmsPJNuHCrV9
39679	payment	2134	2134	1874	1	1	5468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAiipddnnAEpc59x9YpVB2TWngeEPYeTt1vTaCb2E5ecEeAXP
39680	payment	2132	2132	1874	1	1	1516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQzufdRpBeNtt2HE3uYXwZ3CJx54Yc4Q92YsnSphMTJzwtncgX
39681	payment	2133	2133	1874	1	1	5031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6X6v4fAhvKTNH4vZhg8BKD6dmVrzKahTw4Rh8NsKTo8TbkHe
39682	payment	1764	1764	1088	1	1	9	3658000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpZi9kezX6NaVabkDo1ddtDzFPQscbeVHV5LkCeyoB3X2p6URHPJ
39683	payment	1764	1764	1334	1	1	10	6878000000000	1000000	\N	E4YkzbDMGcD1YSgm9jTykyCiXHnDhWFtvPgrrWYN5LreqzSbckRu5	CkpaEkAH9f1QjGW7aQ2oeasAEaMAY1qWMDBRsRksfh5PyFBKs2xi5
39695	payment	1397	1397	1678	1	1	15074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUrBruD7MDPM7WFMoxq1YD7p39gEo3afrVTsARkXkcr2yNnZz
39696	payment	2134	2134	1874	1	1	5472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQas7T8b9omSqhBLVUmK8c5f4pCuxnqrZ1RPwV7s4ZLGBwRWoA
39697	payment	2133	2133	1874	1	1	5035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHS28UvnJAkTxwBN4HnKfigmMozAPaeQcYyj2FTiueuvEt839
39726	payment	1397	1397	1678	1	1	15082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hH7XURDnFSmbNgZJSqQn5vfJ5QWD9F1JRkETVidD9JzZ8Fzb
39817	payment	1397	1397	1678	1	1	15110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhacV5op4d7zYNYtdowa1DMegWoU6gYEbd1bUMFop2pkseY7LP
39818	payment	2133	2133	1874	1	1	5070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfsrNkkSw6FTFA9UobntLPTtBJJpvwEUu6CMPKWesK1KZCAHzz
39819	payment	2134	2134	1874	1	1	5508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXSEuAd9LHMrbMnWZ3a5TXjKAm55iujj2TdXXFoLWLUNF5amQ
39820	payment	2132	2132	1874	1	1	1528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxgoDL7U6JQXJH4UqEYKe31LJPcCqymx4F2HR9BKNMJNhKSJg
39834	payment	1397	1397	1678	1	1	15115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5bFCHhCkcX5ViwP2XQ25tV9rpVcqC6VSfoJhW4m8MeNUWWJt
39835	payment	1397	1397	1678	1	1	15116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnjQMpY84TUp3ENHJKAf9zW8koVxRV1tKzpwhVNBQFXbrymhv
39836	payment	2134	2134	1874	1	1	5513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLf7J9i8Y3hZe7Kgv6AtKP8qy5w5RNBFCSSr479m5MpjLEZdb
39837	payment	2133	2133	1874	1	1	5075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YwJaJCrQ3G7rCEDwxhJbRrmeTEmVtCwa5GTEqzETP6nEyK6v
39838	payment	2133	2133	1874	1	1	5076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9PCfV6HExTQ5JF2Q7zVgr7JWxjUR2DWmJanmeQsjMutW625R
39839	payment	2134	2134	1874	1	1	5514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNqv6sftqY75AN3rQuHTmvBShhDoqtdzzJmK1YEaNVKhVDs2b
39859	payment	1397	1397	1678	1	1	15122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQxwYuhQASDmLXBJfqFUWjCur1StDbwQ3S2575Mjm4MTBows1
39860	payment	2133	2133	1874	1	1	5083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7dc7bboYpoisEkeaH5CuHczXmsBQ4royS6sZsRzGEVDzGFmLD
39861	payment	2132	2132	1874	1	1	1532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Zm7YEGZJobRD6LoqmBiEQLyPEhUnu3xPetgAAnjheePAU2RN
39862	payment	2134	2134	1874	1	1	5521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJyePvPoybWMyXAU5QJDguNGL16zVefKPT6ZypwZNXdXha3SR
39876	payment	1397	1397	1678	1	1	15127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpMehm9mtFD4ymunEneJaHRbzWMZSvYbCUo7u4Q8wTcJKubYQ
39877	payment	2134	2134	1874	1	1	5526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesagoA4bFMMagsXqHmHRxzAWNnhjPYkxQLC5akBc4MXTrseZZ
39878	payment	2133	2133	1874	1	1	5088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZxowtjF5Qc7kDEJ1k8RBdQqgFKz7gvgFRoibG7zEUoBa91e3
39882	payment	2132	2132	1874	1	1	1534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiax9SexK8zRaCrok3mK6aSdZ8gcwzCApBJduWqRvHd4bPYuQB
39883	payment	2134	2134	1874	1	1	5528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbQSGKUKwzP1kxuuHpcCDr43oaKJocZEGg4r6xS2Kt6sPTN6d
39889	payment	1397	1397	1678	1	1	15131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UqZcNo51sSSUJvF2WMrj6xveNLmDfWWVvXm2FPGSfbWzmyKB
39890	payment	2134	2134	1874	1	1	5530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzJuBR5LeYZa1GGTs9RyA33BKyX28vxEnKiLxfpj5h1qEYnAL
39891	payment	2133	2133	1874	1	1	5092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtTw9kYoHa5bFWnaYoUMZLhDMCqHJbcxpCGPJZor48EQtecb25
39892	payment	1397	1397	1678	1	1	15132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRordwt1Mc7pizXE8CE9vtpo3YK44qotHVp1KEvjUzykyBCg7x
39893	payment	2134	2134	1874	1	1	5531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwCJU47nYfmH1hHuAZM3ik83zSz1GfDFFnrQnG6PoBRdLcPS48
39894	payment	2133	2133	1874	1	1	5093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxihnoN5ZvR2PGVZtNkzRBCNYhWYiYiLPZKXtLv7SGej2Liu9L
39895	payment	2132	2132	1874	1	1	1535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMu66UVrJ8kBqtrkSuLNMXvcgVPxcp81FZWJv2xHjWNRYgRMBH
39918	payment	222	222	2321	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VD7xa7iURE2Be1ejEUkcN894v87UStXSJprCVdgARetyeAF5
39919	payment	1397	1397	1678	1	1	15140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFthJNVCWTEh5VtcjG9UvvtMyDFEUEVhi9NVQtgACPKhUt74vu
39920	payment	2134	2134	1874	1	1	5538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5jgNRokVbe4X1j5jrbehGJRRJqwwhcfMiwoAiSQpxnMi5zvET
39722	payment	2133	2133	1874	1	1	5041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSVmnxYLMkfCMor8hc5wAf5dduYYfq9CaQmZsdczaEbb3tq3C
39733	payment	1397	1397	1678	1	1	15084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpdioc2cxZTmiEmEgZuo8hEgcvtRkHCiGJvRmrbQrJEJ38Knc
39734	payment	2133	2133	1874	1	1	5045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKaT4bjq52GsJkAmEAsfi9AhSgmRV1ttpipbswfHmszry6RCa
39735	payment	2134	2134	1874	1	1	5482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyGA1dYs8LjEcNdj4E64v3HDng8ZYjJRyCp4GHRzTB4Rt2Bie6
39749	payment	1397	1397	1678	1	1	15089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrchoavbiqnXxjTZPxiCmapjfpNvUNfcbSxZZHijZXKcmLNdM
39750	payment	2133	2133	1874	1	1	5050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp9rUFcR2uiJWa8cKHWtkBCFTXViyjYisGKrE4ftqVcwT1ynb5
39751	payment	2134	2134	1874	1	1	5487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3fX5mhAPBj7KEJMmTh3xxpGBotZGw5Ue6qoQU2ccK4jnrhfC
39752	payment	1397	1397	1678	1	1	15090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugTXmbFcZr6b51GChomFu9L7YcKSuxkq7zBtEKKn4hmufxheh
39753	payment	1397	1397	1678	1	1	15091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGYcKQgtWnW8tG9NeCZ5uxUbm5s5i41RijPVNrVgfmCfq4bdcA
39754	payment	1397	1397	1678	1	1	15092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKagfY2Y1HkodW48Maery17ugXsKuwyj3y3ghjEjkGcUEMpEc
39755	payment	2132	2132	1874	1	1	1522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSvHrTedwosYzSWw5sxw6FUdSPRGS6fnskQJ1Hh66eob2DjUA1
39756	payment	2134	2134	1874	1	1	5488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXqRRZ4ob26YoxeWfSYRyZDWcDYJw1uSn86r1UNXCjvhKEttn2
39757	payment	2134	2134	1874	1	1	5489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCXcDF1ePRWhnjVcubBbHWx6ANAP4XnPdZtFMhmBqjocNJCau
39758	payment	2134	2134	1874	1	1	5490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNtJLf7rGS7Dk374dAKe7M3WCSfFaUjtwDohNuuP1nedMuCPjC
39759	payment	2133	2133	1874	1	1	5051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuyVvMvRMeHvub9zU8Zvjg7WGz3iPvqvdokM4hCTc2qh6CDPD
39760	payment	2133	2133	1874	1	1	5052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8haQjVY4K3fZP9P69foFNMMtw3fFDYxgiFdJj8ZYrzX8ZPiR
39761	payment	2133	2133	1874	1	1	5053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeBEazsqJegJD5Pp6aHfSZdhCGTEvX66PnXbkQRZazm9UyXP1
39762	payment	1397	1397	1678	1	1	15093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRhfFrMHVH2RQYTbwJR3Xk1jfam1Fv4ekKki8wyHhUqLaCdY8
39763	payment	2132	2132	1874	1	1	1523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7k8b7NBbQ62AoM4tMh1eqmBjzobSh5bZiP3aTTF87MGJeACo
39764	payment	2133	2133	1874	1	1	5054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfV3op9VJAugQRC7uD56CEz3g6fdPaDCkYjGu6VLE3RYj8rBqp
39765	payment	2134	2134	1874	1	1	5491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiDDKa9pCLgApJr5wJ3GfDoRj6wEta2PU4sFmjNHYa9kvfA5T
39766	payment	1397	1397	1678	1	1	15094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6QLpvY1KNBN2uCHkzFZbMrsoZi9VfnpNzfBoz6LUwkmzPkGT
39767	payment	2134	2134	1874	1	1	5492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3rtnhqMJYgFGsz2hAxgB5bZA2c398B8sGhGBJTKhMGMWTS8y
39768	payment	2133	2133	1874	1	1	5055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5bpKRRJ7jR5Abnps3rvUqpxkA3jYcLRFNx669aePqE5q3oEz
39775	payment	1397	1397	1678	1	1	15097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsddEBVJ2Tk1VF64p2F4fJv4PSP73JBZ49KAuyg2oHozFXszPX
39776	payment	2133	2133	1874	1	1	5058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQaP9NP7vWVnjaCckwE6zLF3QqeGMW6QtpDCbrR4Cnky22Mqif
39777	payment	2134	2134	1874	1	1	5495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTkU6vwkwoT92U7SKbyLTWcWYaXXsWGhjYo6tQLiVwzToumzGV
39778	payment	2132	2132	1874	1	1	1524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7ZmZZshLNyCC8uMCuVtyvmYpg6KtuAxc48PJACzkeDLDUETs
39798	payment	1397	1397	1678	1	1	15104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZts2pgEtohyW3Kb8Q1RcwtrTXUtwCtY4QiDQoaK6WBS16ytN74
39799	payment	1397	1397	1678	1	1	15105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXoVgwq4epESsSufVayPfsLjHhLQtbMh9xExPHD19cyCKPURfu
39800	payment	2134	2134	1874	1	1	5502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1KK2rg1LHgMqeva7pLrEyFTER4LT2MbaB4mFJmE8H7XuinEk
39801	payment	2133	2133	1874	1	1	5064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuR7UwnS5d1z3pjLZytw3Fm4xuxR8XeJPsMYZq5Zm37umnBEnk
39802	payment	2134	2134	1874	1	1	5503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2bmQ4MZfNQj6sPHG6S6Kvd3Bz1AQm1Q9iV31B1xEA9qAjzyM
39803	payment	2133	2133	1874	1	1	5065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPfmwN49ygq36AzraV8LhndKjKHi8dyGTZ9PDEe4wAMyv187q
39811	payment	1397	1397	1678	1	1	15108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZPbrKxisTmxqi7bjssAZVSqcXrA8jc8avEUxXje163coTckQ
39812	payment	2134	2134	1874	1	1	5506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiR7pET7E3cQcLJhj4MFfkCCp25oHU2WyukdopHBWJDiuqepUC
39813	payment	2133	2133	1874	1	1	5068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmsWBVMNBPfhtuvV72isYMyA8tgfNuxZzV9CGWQezfzgpzXGpg
39821	payment	1397	1397	1678	1	1	15111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qrhG8Jr5fFJgo43VaWJuq1yfgrmfXQvXLtQb8p1NBj4hsR32
39729	payment	2134	2134	1874	1	1	5480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzUEPhEMNtRZWwGvj8K6r8zZNQeMqZSRnAM4BWanGg82e5rYi
39730	payment	2134	2134	1874	1	1	5481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeJ7db4mg79awzNCUmd93Btff4wUGYQD1WuSFbnaevt1fh17F
39731	payment	2133	2133	1874	1	1	5043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKr7114UssY5BpuVKDKfLb4Roj65js6EYKouzbLU2KSH8ARhP
39732	payment	2133	2133	1874	1	1	5044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBFKNH9vVNXVEpMoSUejBJ1ev1sXsxM64dBmuKyh9HL38hFjL
39736	payment	1397	1397	1678	1	1	15085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AtoYiNn99gBgKGPpVVhHEvRaui5XFfMu2UdFvyikyNhbCBgy
39737	payment	1397	1397	1678	1	1	15086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3T8PWzbSeS5ua2ptujJduFMTxJsCdFkP2DanBsNkZiAxkWJ3N
39738	payment	2134	2134	1874	1	1	5483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYusisR6qDo7bT5vy9GLxreSrB6HfnbJXEug14VCzAtmMYVVhK4
39739	payment	2133	2133	1874	1	1	5046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG5oC7rTQEVWbGVAh35VmarHSSjfRaBqzchKsZP4FcrknhLqD
39740	payment	2133	2133	1874	1	1	5047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfUgKRy46Lunj84EG5hSJgMJji4YKKEr9Te7A2677zjAnCxazU
39741	payment	2134	2134	1874	1	1	5484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVq8MsXczVBJiXBQM5ZRn67SUtQnaSnV8J3o2GyxYKTmjAbfYW
39769	payment	1397	1397	1678	1	1	15095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwLJV2veT1pdq4rchPGdTqbJR45yNPeLpG8LPGB1ykWouan4vc
39770	payment	2133	2133	1874	1	1	5056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6cAfHowC7pVQ7aFSgmybnHBphC8qSx9Q6viMx2oL3jMdAtpD
39771	payment	2134	2134	1874	1	1	5493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFm7DvAcjtT4y2duLRgKgKHa197Bc4YK1djZCCvjFi1kepyaDB
39779	payment	1397	1397	1678	1	1	15098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs5FArGwuUiXURfa4MjoodarQQKUPEkVP6qCoe6i51hnrLpFgR
39780	payment	2134	2134	1874	1	1	5496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CQAcXsYQjVgLKF9SbJ67yvLcZ5gJNdqPKUgXooi74csELQPa
39781	payment	1397	1397	1678	1	1	15099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLWGCvx55ZKm8PBmRgGGNA3rvmsea83VWs5GUDNEaHVypHHX2
39782	payment	1397	1397	1678	1	1	15100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZes1cx6SMv1vDrL3L7bFnRte2no6Hy1RBL3upyi2qSDtiYC9gn
39783	payment	1397	1397	1678	1	1	15101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N7YoNJD4VVHs7aRPkxEmDLotGVZ3Dvk6LRim5aG9jdnnX8zb
39784	payment	1397	1397	1678	1	1	15102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4gDwBNiWjdd4xE4WqnXea3eqxBmP5Uwszded8NstvVX2RMeP
39785	payment	1397	1397	1678	1	1	15103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTqb9Ay9RBZyaXk56fUQuTaU6AbT2e6JJf3Cr519nRBaU7UaR
39786	payment	2132	2132	1874	1	1	1525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBUi5sRKjoDFVzUfhamiiH8h3W5NepnEJM97zNcY2R4w8jtfL
39787	payment	2133	2133	1874	1	1	5059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuX7zAZXt8dD4oErybhCu56CXBMjDZALxJbUyZUwHFDWSYzdzt
39788	payment	2132	2132	1874	1	1	1526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbgTZhVn4qgYeixrWYBDPxt1getHu8cJczUTK96pXtfd5TPrF
39789	payment	2133	2133	1874	1	1	5060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbfEU36hSPhK6GDcpkibM5nnezvdhzfn8MmeeoHEvkzofC7Goh
39790	payment	2133	2133	1874	1	1	5061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR3YHaQC2gtB27wrjzebZr9JbCEhzKpLP7aPYe6uVvpiGsKcKJ
39791	payment	2133	2133	1874	1	1	5062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeY89eJPSd3K6DQvt9L5BRAfkQYvWWGakPTXyAYLC7Y4TNGQGy
39792	payment	2134	2134	1874	1	1	5497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwezu61qfjBHffe7z4MYGkyjrKhGMtpTNBeJ2XG9oDKqJekvv
39793	payment	2134	2134	1874	1	1	5498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmWyfKrSAm7yMkmkjRUZuC9MBhGt9uQqyRKv24CUwtDPGE4a8r
39794	payment	2134	2134	1874	1	1	5499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7aepVC4MvcnEPvT3Nfm2ZCMkfAt9hcHojiqyXjUpTCTkjPKS8
39795	payment	2134	2134	1874	1	1	5500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBB73A8e5TBJ4Fq6ttwG5NHVo488iR7jA4XxLrgQS29uhJvHt
39796	payment	2134	2134	1874	1	1	5501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc3pWgmNGtUZpCakTpWpVLf6jqVfpaTXQeUkqxKXeHwNkvniwZ
39797	payment	2133	2133	1874	1	1	5063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHwApv2Drkv2EFNkixLH4tCaiSupEaixr33sAxyD7n2fzq6Knx
39804	payment	1397	1397	1678	1	1	15106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozr5ojNu2uF2kxQdHFCAVaGoqu99QuFmtWa9to363E78iFdke
39805	payment	1397	1397	1678	1	1	15107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmKNbtFz63vAzrWAnFES5gR7RFZKVbYq8sE9g6WGimZV64Nd5
39806	payment	2132	2132	1874	1	1	1527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDv5icx1hXm46tjoUXNqmxV4UeCaCqvqiUUZnwCEi8LABRyCC
39807	payment	2134	2134	1874	1	1	5504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpcJiYXVs5KjjLtG5rooB4Q6imobiqUz8JVFYKXrHxauKptnp
39808	payment	2133	2133	1874	1	1	5066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcwEpkPSDDMiUjpznXgfYxX2d67HfGpeZiqfr3giF9uyKvNnK
39809	payment	2134	2134	1874	1	1	5505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nth7N4WW9XgRUaFgpPRDfaTDCEw9TREftHL1ijoe1N9jwuA6
39742	payment	1397	1397	1678	1	1	15087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzC3NzuiwTSqSMyty9auhu8sxJJ9cjARRLHY89WtCobvN8Ly9
39743	payment	1397	1397	1678	1	1	15088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGj1YzxSvspeojQjdBVfABawvMe1ay4bWcexX3X2Yf1VUKxuS
39744	payment	2134	2134	1874	1	1	5485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6E1UA13uqAMbH7ChALx8aahjfQLMhYzXPSBGNDKgv6Bc86DS
39745	payment	2134	2134	1874	1	1	5486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8h5TDxmxnrUNJVe2yGSr8M9Cf9iU81hQ6tc5qG6qdLEHN5i2
39746	payment	2132	2132	1874	1	1	1521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjLgZzw6wFPsxgon66bguitHMUTbquRAr4DYxUtjKMdAW9mL3u
39747	payment	2133	2133	1874	1	1	5048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryKLmCwjYPxow68YyqTveNJhKsnT5iAHo6jFvutruRgAMrgze
39748	payment	2133	2133	1874	1	1	5049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9agfptMTMy7a2Qt85vxp6RZ51Li4hVGQfKuQcgfgmPcq83RMw
39772	payment	1397	1397	1678	1	1	15096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2oFHemqc57ZQViM3LzYuPzvXPqhErnDPMEjjF3N3n4ickJRe
39773	payment	2133	2133	1874	1	1	5057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbB3SEr8dhjSUDCqY4LXVq1sJJQsEskjQhxE2VwzkXdct8WF4
39774	payment	2134	2134	1874	1	1	5494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtb8wCFHzk6c5YhGr9pU5Fb421g16xjZLbVr9opqnRQGAhRmL
39814	payment	1397	1397	1678	1	1	15109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmLrnpfneWX49Zg1jeFTsKxK5v9GkaYGUmAU2dgNP5S3iWZyW
39815	payment	2134	2134	1874	1	1	5507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwTVua4jLcANoGwJCpU8WXqLN5RPqeaorRUXhgcm1a4HE3kdn
39816	payment	2133	2133	1874	1	1	5069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ794wgrCJY5VnpNsyzPQwAVTEZmvBzebv4GUfTWPeEPykBMC2M
39827	payment	1397	1397	1678	1	1	15113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRSfeQx1cMy15U7WdTSLKmFejgMJET7Xd2bSq3QyU6oQanjfeo
39828	payment	2133	2133	1874	1	1	5073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBBHziZPdBMFz8nd64ZFecm8Sj3UaqZdYM9rTUtcPY61yyjxa
39829	payment	2134	2134	1874	1	1	5511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNttQzX1Z74VBQEF6rDmvHvhcHdygftdjXLeYMhVf6N92WP9J
39830	payment	2132	2132	1874	1	1	1529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgRm9NoUofcHx8JSNNY3JivTRe5gPsZz4gTyEGFN7PcNRkRDR
39849	payment	1397	1397	1678	1	1	15119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDzNbyfMv9ggYxxobDphUG6j8P6rktWHCaP9oWs9x1wUGxraJ4
39850	payment	2133	2133	1874	1	1	5080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAC4sKpcubYJztTCJzgTZaHYLsj9qrvosjwLugJFw127R5Gux8
39851	payment	2134	2134	1874	1	1	5518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvY1GLYUPfzLkEUWgNKnUC8NSPTpuxfwCSrGLVwzCTyDZQopiG
39852	payment	2132	2132	1874	1	1	1531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5JcwcVbdTPvvMtvXWRoPHzA1Ajgmh71KsfNfRN8YQYsAmrbh
39863	payment	1397	1397	1678	1	1	15123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZ7Hsyu8XyUj5PLRGZLZqCyZFDKhnzcbavequc7noNpdLsGeq
39864	payment	2134	2134	1874	1	1	5522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhdpDG5zQ81UU9n9BMDYfnBBh1wGPEwsoSGBa4rRSdvAovTm5
39922	payment	1397	1397	1678	1	1	15141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEA2bmimvHM2a5n2oAmAmob7v7JwHTHMsYEdsVb9mm1ssBFzSQ
39923	payment	2134	2134	1874	1	1	5539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQGi4gNKxKeFwhaKpXSFox5GhRtFFZN8UE14vKtm7mKJpHcdi
39924	payment	2133	2133	1874	1	1	5102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83Uh1yBDs7ZkjLj1XmoRT1oJYKc2g9t6QPXkxfcyrFNE8xtmR
39944	payment	2134	2134	1874	1	1	5545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsdaqMNubdFgP68y74SrEbNrneneV2fKtZUeRgssSRS2sxMAZC
39955	payment	222	222	2321	1	1	4	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWeGmdm6Dwvgkq4ENpFL26B2iTPsa4uqsZW32icy2KNaigKVL
39956	payment	1397	1397	1678	1	1	15150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRZAPgUK7ozpC6TJW1ibJRjtxfpZQAGARefs3qwumJL7prBNL
39957	payment	2133	2133	1874	1	1	5111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfW8c9JKDG4iDn5kqgHk5P7WjouBAwsUfT3TsDQgCQSpb24cCB
39958	payment	2134	2134	1874	1	1	5548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuotteKgkRfHsQagkJ2bj5j4foJuVKzX9emKzsxp3nGokkJHBB
40011	payment	1397	1397	1678	1	1	15166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZDC8buaQHSPpj7W7HV2chyzx5BpLcSC6Z1kmdsvqhA7vv4GZ
40012	payment	2132	2132	1874	1	1	1545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G7XHCcZG25LVLgyEY49aGWE5vgDbPvJPFefQ6ig9MXUvpzZ1
40013	payment	2133	2133	1874	1	1	5127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEv4jdzQWDDrHVd2cZiSn9ZLBvcaG98wRWWbjSTeRzicL5oXm
40014	payment	2134	2134	1874	1	1	5564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDqeFeXT3iongzdV5vBaxMapvtSRvDagUQsXmV5dAoB5qjuj8q
40025	payment	1397	1397	1678	1	1	15170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iHqLkYBRNKzErcyKksMLN2fuWQSSZcC1bz4nzMLzBmmSH9Ts
40026	payment	2133	2133	1874	1	1	5131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxdgJXq7M1SzjewDu1EjsfPwHdMoKn3ZCSzuvtijqPBEptsGx
40027	payment	2134	2134	1874	1	1	5568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhGZBpx1ndFQ2WUbjrzK21sKyQ2PdenzznJXx8snGNLp4reXgB
39810	payment	2133	2133	1874	1	1	5067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9y3SJSkDcoRj36kxmzsxdMje63rQeiGzRE7Z6jQhRaufKjFZq
39825	payment	2133	2133	1874	1	1	5071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs92obPVJ6n8vqjrKddQKYyvrmuTPeiJxyBaoZNpjLsBciLvr6
39826	payment	2133	2133	1874	1	1	5072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11rahcCCdG97aEmeXez9EqrNVd1LMkwTxVVGYb88g4wnZwHeZ
39831	payment	1397	1397	1678	1	1	15114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZ3NLEEX8CVFQkfFutVdbiDadiRXB1bmY8oLeGBMT7rmZm5JH
39832	payment	2133	2133	1874	1	1	5074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbsHPhmz9w3tEJ23SyhupSxPAoMMPH8sLUAuJD8SyukmtbJfU
39833	payment	2134	2134	1874	1	1	5512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGBndxeZXcxdg9RZY83W29cDuhqKHTNHK33tdfT3NBdJbv2HC
39844	payment	1397	1397	1678	1	1	15118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzbG2oF75CQbVj2uTceuKgFbAjiB91s1RE3fkBvZdaZKBE3HvQ
39845	payment	2133	2133	1874	1	1	5078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQMrinQx28n7oLgisbNHYW5HGqXYZLJ9GPyyQTJhEcqhcPp9X
39846	payment	2134	2134	1874	1	1	5516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1N241uTXMDEDsE6FMca4buXGnDqcyfLsGTshTz3JvDvLYetDo
39847	payment	2133	2133	1874	1	1	5079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMcMGLwKejPeq2AVLvskGGiJXapDG5BcyrZJ1So9NFvmkQ55n
39848	payment	2134	2134	1874	1	1	5517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvno3XB2eL5cJ4pFiocqKQmqK8LXWJhytb5APbLrKEnWQoP64M
39856	payment	1397	1397	1678	1	1	15121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4paPW1kG4ULr86obys6ZP61d5mMtFBBVB3VWs6jYSp9BSdAYT
39857	payment	2133	2133	1874	1	1	5082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4VQK5buEcjUQ7UeoSxnPRjVSHaCwNKacCWHEu5QZoaUY6vCAD
39858	payment	2134	2134	1874	1	1	5520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebqLyhTWV64tWqAMs2GfubkYMN7vfHxCw8opppD5Rk267kLMr
39869	payment	1397	1397	1678	1	1	15125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXjkUqD9orWsSFCJH31bzMhEgmxp2xUHq3rWpjRoTu7oSamcb
39870	payment	2134	2134	1874	1	1	5524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3rAhVr98Yr88r7WAmu9jfM52q7vBCdCbPpBcNanYPBCU6bs6
39871	payment	2133	2133	1874	1	1	5086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFv6vEAuRXPk5My22SErjGsiamRXDV3PPCsg3FJJFiV71Ytmz4
39872	payment	1397	1397	1678	1	1	15126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsgFKzck1FaMeE7SkPa2Dhc7B68BxaEKmSnrbDhdtAmaqam1Dv
39873	payment	2133	2133	1874	1	1	5087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYin9kZv7TDTSms31SvhkA6WwH1caBjHga2JvzLia2iCw8SRpqy
39874	payment	2132	2132	1874	1	1	1533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktwNzsL6koQAuQaJbFCZnEWsgScWvn6K4mW4inGaCmRYSm4dg
39875	payment	2134	2134	1874	1	1	5525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1mafwRTddwmEkatV92gMGJLZWAFnx6BxF9SsWebUpmXPXiXcv
39884	payment	1397	1397	1678	1	1	15129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NnuTjUrt8dEKHvu8FYZ6J2MbfzSd1wwxm5dCJZGMjJNZZCo4
39885	payment	1397	1397	1678	1	1	15130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEjbm2gkcGYp5bX9K38kp5XNY8eGH8JVrS2c4JHkZLdszXity
39886	payment	2134	2134	1874	1	1	5529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8HuTyYwR6yGotYyViboezornxKuEsvCoMytHy81afYU3HFeEc
39887	payment	2133	2133	1874	1	1	5090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmEFeHajQ9ms36dYLek6FNraSfYYkM3tCnZJZurBrAytw5vQS7
39888	payment	2133	2133	1874	1	1	5091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBSHoWiCsmzwrBky8MsXmMqPxjdgvKNWqae5NduwYFz1GFSve
39905	payment	1397	1397	1678	1	1	15136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYighPQdXUZQXuQ93RdEUJTnXoLuLQrJftmfmAg22igaUZ7SEQK
39906	payment	1397	1397	1678	1	1	15137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PFLJ4hTr28hvqp9hB9U67fA9VUb7v9nxS9bTUHcsAEvQ18rR
39907	payment	1397	1397	1678	1	1	15138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7id7SkG6uGwmznahF16wS85Exq4qQxaMpnNZF9RgetW5Wx4k
39908	payment	2134	2134	1874	1	1	5535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqttmUqWjCFQq2mAJWCTJTbnJ3rv6hPBDRU4idtmUMEB4dSAQy
39909	payment	2134	2134	1874	1	1	5536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwdAriuMwJaYYfwyDWCdztziQhX6SfRT9g18emiR6nUU1LoPR
39910	payment	2134	2134	1874	1	1	5537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWu8vfXpfpWgq9ip7eGgPhhdmetzFLqQZDsAcCNhzMnN667vL
39911	payment	2133	2133	1874	1	1	5097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJj7XQyhr6gXVhvXEkkFCUxPbWsyP9QEGHSuoEo7ZSxTtNp76j
39912	payment	2133	2133	1874	1	1	5098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrBr3mF1uELmzfe25PGAZ7wsibFRgjAtZK4kY3X7ykBTnd4RVA
39913	payment	2133	2133	1874	1	1	5099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2Rqg399MJDBVFSYLkDKP65oBLRtmw9B9MkC8PopKrAe2xUmF
39914	payment	2132	2132	1874	1	1	1536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZQt2XSRJ1BLuenJZMKTvyUciPWTmZ7iZkU79XCBt4gC6hQYH
39925	payment	222	222	2321	1	1	1	10500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv38PJmAgSwgu1Sxm1Fwhv6mKYB7DRrPrAJgawyYZ4i2ay2Zhu
39926	payment	2134	2134	1874	1	1	5540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxmGjq2v76G7hqtM7uJShPWmv98gKjBSY6FMQog4Sw1o79r76
39822	payment	1397	1397	1678	1	1	15112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwo7ntwGcq4v6M79iZn6CpkqhbC8D6p1MYyiB4L8GF7BuaRuN8
39823	payment	2134	2134	1874	1	1	5509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirs9dKRxvRggq7YrDoVoJcMsRH5R7rTHSSED5uQDuBWSz7BHJ
39824	payment	2134	2134	1874	1	1	5510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGvf4Www6CMdacE6SAPBzLXedGqtsJBP19rfuZgarFNzxwXT5
39840	payment	1397	1397	1678	1	1	15117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7LV6eNevfJ2VzLMugfvxdFesmgJtFA7xvDRB5XkSbW3Ess2N
39841	payment	2132	2132	1874	1	1	1530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGzvbqPiXmJtm9iuddUGRmpimi5hvkJLjK4tXCWk8MAygHcbgH
39842	payment	2133	2133	1874	1	1	5077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQnh4ak9CRV9kgKh8C9aNZq33AVgWKzBtRr3RjuzJqAD6Wgze
39843	payment	2134	2134	1874	1	1	5515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArBCWrmc8WuQhhYx3RwRA1gmKZPUubXxtebkEYNQbFsAckSn7
39853	payment	1397	1397	1678	1	1	15120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnqWDsc9cdvWtqm9yn9yRhvJj7AxQZ1nxo6KK433HuFw87gbs
39854	payment	2134	2134	1874	1	1	5519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtfQPr3AVYvrTTVK9NWM59CuvSwFA2M8oscrjehv3vhErhhNax
39855	payment	2133	2133	1874	1	1	5081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUJLc3yw2FbHVypMmN5F4WnZHQVYz71LmQQ2ewk8ozubFmgVL
39865	payment	2133	2133	1874	1	1	5084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NnHon7VkTVammiUUDkLECMssmcdFs9yMRznq1s9u4w1Wpv4i
39866	payment	1397	1397	1678	1	1	15124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaJiQPXfr2oEa9gT3P2dGQFwR7HH4eQ1DfV28fDhes7qyVznbu
39867	payment	2134	2134	1874	1	1	5523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnwSWKDWJRtUPqvhNpJTcioA4H87tYSRs6atF84LYjhJ4joPt
39868	payment	2133	2133	1874	1	1	5085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbXXhoTiGPLSu6fPavj79yEn8vWCj6gZCibEiCTWuGHxccFhB
39879	payment	1397	1397	1678	1	1	15128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGE53RNNvtKssHa8n11QjvJwPgeFd1ZRDMuN9ZVPB9T8c8N14
39880	payment	2133	2133	1874	1	1	5089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQBkqgxvk1a5H91JpXJuwfmnFrnczTy65AUZ6ggQ6rpKxp22H
39881	payment	2134	2134	1874	1	1	5527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRrSyVa31DXJXu6a673WsBxyxx3WNSD9N3KDyhsV8omevakRY
39896	payment	1397	1397	1678	1	1	15133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxLL4jaEXrZUpAhNNhj5g85M1VJfTotbmth1VtMnyrq76dtgx3
39897	payment	1397	1397	1678	1	1	15134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsvwoiBDHn8v9Mecd8ERR1eXTg8FkBrwmDm5et5PyFDSePgqG
39898	payment	1397	1397	1678	1	1	15135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhvf3zsfNQJKFvEKPXZbGdW9a9G8PRiEdDDeKMpjrKa2D2Z6F7
39899	payment	2133	2133	1874	1	1	5094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWQ1Nvp8ABqtSYbc7wiUc7LMFBjeW195FQBFWYHbzsD57rtEM
39900	payment	2133	2133	1874	1	1	5095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgFHFLbGM1da7G2rMiuEuiEw6sEg549bhniLugLuhtU6yNfUt
39901	payment	2133	2133	1874	1	1	5096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVeYcAbwvS8uavRWxEhvwwuaUYbmAHPofie5kWMXPqhMLsRqV
39902	payment	2134	2134	1874	1	1	5532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQpeJ9BB35xbtoWX99cW2tiRfes1CJHMuv6jWwXXmqnQ4JGxY
39903	payment	2134	2134	1874	1	1	5533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVjUXigT9N9s5WHHEe3XhBqz4fbcoTo8Jt2JeQA7vnwTH5q1y7
39904	payment	2134	2134	1874	1	1	5534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjpre3W9TuFSmfFF8tMFKFRnM8HDVxe7GNxKtGJmDuVnykGJh
39915	payment	1397	1397	1678	1	1	15139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiAtbkZnj25Zs6UwBMhhnQNmL6NdUj62aRTB2AJ2g41tn5eUvy
39916	payment	2133	2133	1874	1	1	5100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpHW8iJKc2VvPeJTgUM3P9FX7CwQjWWsNHfZMaqtLHgdkxPGk
39917	payment	2132	2132	1874	1	1	1537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ywmZUExeuZ1JGGsxr9C8aKpqiYpxPmEqABVhRtM4mzZesFHt
39931	payment	2133	2133	1874	1	1	5103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1nQ64EXBGE74c7QyE6gLeTMoJZJZdV45D7zGwEENrsbXx9mpQ
39932	payment	2133	2133	1874	1	1	5104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcREBHKWhgUV89j7EudqSZaaVkJ19XRLK5g6JME71JHBeM4NgD
39933	payment	1397	1397	1678	1	1	15144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuF8A2j857M8qVa1agEyU7mK68cr94SdpKN8jpxiCSJ6282Rz
39934	payment	2134	2134	1874	1	1	5542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSc1kEcm59rs9Tc7zrdDogRmwDGjTTddFp9EKNXAxA37P42Tn
39935	payment	2133	2133	1874	1	1	5105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHBkPuP9uaMWw1MGHnuaheN8VNE9BPYTeBCenjciV1LD8RKdE
39945	payment	1397	1397	1678	1	1	15147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXyzedsHYfrcKi6rcEoaKWgPVcqQGk6znoXczHH7sPiPEiWL4
39946	payment	2133	2133	1874	1	1	5108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtudsRcv2x6yx1GTeyC6DxPDojXLfS57Bt6tSWm1Zsr3AdE5v1
39959	payment	1397	1397	1678	1	1	15151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR6Pc156dz6a8egKiLgrbob8Zv459PCxeLC4op4f7nsPaDnTmB
39960	payment	2133	2133	1874	1	1	5112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQa4BcdxEUL14ngcRtHxcVBacVsyeaye2SauZ4jktypg5evM8
39921	payment	2133	2133	1874	1	1	5101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMRx9Ve6HDaezTxBm75giDZ9gqQkJba1PCLoW4vK5jHrRRuoz
39929	payment	1397	1397	1678	1	1	15142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJYhjxpQa75vfkSwwq1aeSCcfTDrUc2wp32zjBiBDAjBsTC5S
39930	payment	1397	1397	1678	1	1	15143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtkutP2BMWLEeQyk4oKFEzkfxk6e4YC3JvCikHL9THXqQCTdT
39947	payment	222	222	2321	1	1	3	20500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVscJPdYKdabYjuDnzm6F2P6W6hesCR9fg2WHcqdNTGgu6djF
39948	payment	1397	1397	1678	1	1	15148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5DeLz2iHJNP8LAA7gq3muZvvk6PYMnLECkERQ4GVE91mv7z8
39949	payment	2133	2133	1874	1	1	5109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPqgwVAMnnPuJTFGrYcBkWg2nWhWsaB2dj34oL9yXkyuz93qf
39950	payment	2134	2134	1874	1	1	5546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bRiitxqzncUPviPHLWFmr9gqGoF1aRubqv6Y3uFCVZZSaxD3
39976	payment	1397	1397	1678	1	1	15156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6KWnCz8KY84D2Whr8UWHtSu2F2ghcsBtvFd6tof6jcoqJzUYc
39977	payment	2132	2132	1874	1	1	1542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ24xmmbvwjvKc84VWXV6QBLDVRQY4Sr7EC9xXwQpso3NWjmAP
39978	payment	2134	2134	1874	1	1	5554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyc34GQoEedQ7ZZ1pnF8pddDQZZyq7B6wQAdrE2uD3C936RrhP
39979	payment	2133	2133	1874	1	1	5117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeTDgAEnqHCLt5QQRZLqZyUm3yFfRfPy2K4k5MKELk5o57k4m
40028	payment	1397	1397	1678	1	1	15171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHCSYrXvcdhpNEue7Z5u1HJAcmJ6HNChXsy7HTqVgkFoG1otK
40029	payment	1397	1397	1678	1	1	15172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBbKxWoY7sEsfJe4eQUSbShBa8CF7SjUKzKkWEuAnHTR446HM
40030	payment	2134	2134	1874	1	1	5569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqX1tcSFPFFfR7Yvjw3QgiamNKS4B9CAbG9RFK2SQk5zo1WQHD
40031	payment	1791	1791	2322	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLgPRizQKdDzqawmsJXm8Vrquf1bLiJ3JDrE8U2gzLzwHeqZ8
40032	payment	1791	1791	2323	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvRaceSpcGSUSUNNoipgyQBYBhhay8RBSMMMxY5a7REHK6744
40033	payment	2134	2134	1874	1	1	5570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHotXXYNaFGSYYbCDx2vLjSuG8DfqAqtLmjMHEE4mk5YvrfLLq
40041	payment	222	222	2321	1	1	9	55500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1MmAYuAYSzUbXRcf8LBPq1HtkPDieNT9X5uqaHBGCcFnLgeY
40042	payment	1397	1397	1678	1	1	15174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjWrdawVQuoX2urW48LoocjSbdTYjRABzfSHH1wRctmG78jhue
40043	payment	1397	1397	1678	1	1	15175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2akFEnqkcF3Y1i349y8EJ3aG551FPmwFGLpWKTJWc9nr3iGT
40044	payment	1397	1397	1678	1	1	15176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN8SVWACWkiZdSMoVvAB2EDnp4rg6DXa2k4S2whVGAjSqBRTUH
40045	payment	2134	2134	1874	1	1	5572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJjiYH49KMrUDodEQxprSmoVR9KfPNpWfmi7hzHN39CwdmiPo
40046	payment	2132	2132	1874	1	1	1548	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEn7Asvn6K9YXbovKk4ubdufNkvfAmavKXEE6L7DdeboAr1iC
40047	payment	2133	2133	1874	1	1	5135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs3Pw2J93H9N4QBjwrRQArEjdKACZcSus8duAFZSMWFZjaQ8Nh
40048	payment	2133	2133	1874	1	1	5136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9iK6USRehXxAmgB1pqWBESQHa2UV2psxgu5oyGRHamur7z1i
40049	payment	2133	2133	1874	1	1	5137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbG4xFPw6R9KHvwhxeUBRX3FQd8N1qY6SubzjHkydJiDhHXHBR
40050	payment	2134	2134	1874	1	1	5573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvj4YJ12kBPXRpATqnw8EUksbDHWMHStksELACvLYf6eJH4c9
40051	payment	2134	2134	1874	1	1	5574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwMhhvqEN8QSNvbrAKyMCMA96hkprEfxgqNKGeoXma81ipMea
40058	payment	1397	1397	1678	1	1	15179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPJaHGTL29ZNgPpTfHM1KjmKq4S4RPkY7duZDWPZt6T2LyWRs
40059	payment	2133	2133	1874	1	1	5140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAciVLwEHmdUT9VFbxXFPD9dVJCTf6obNVHWXEQMqeoah4FwQ
40060	payment	2134	2134	1874	1	1	5577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzE6JhckKH5yv8CTDu18mBFK9e7PLjFh6C21gdfYsSLANkSPQ8
40061	payment	2132	2132	1874	1	1	1549	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwUGfLp6HDNMYhtHAEnG7NokRkQU6fevhhhj1F3g5AbX96eauX
40062	payment	2134	2134	1874	1	1	5578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7YtLdjztxzriZkVwM7N8s7L2jd5yzotcazd3gD9NWEorWvRf
40071	payment	1397	1397	1678	1	1	15183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfHNtZ26rSZGXf2VonFBToSXv1SCi61CVmYgC1ExZm99pMsSn
40072	payment	2134	2134	1874	1	1	5581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3Sm8NkfMA8zGqkBkw4uA6zw4vzCCKfJzpnbmz4H9eF6T1fit
40073	payment	2133	2133	1874	1	1	5144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsdC94JiP17brRqkCzKpLLp7fz2iKB5kZsVXnCJEunv4a7YJij
40074	payment	2132	2132	1874	1	1	1550	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2H7sprsdRKWku2KaiVLFSTMabESHm3SE1bvZRY1bVvHjmy8a
40077	payment	2133	2133	1874	1	1	5145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQZSAopakidQBq7V6h87ogHP6d5hre7XUNMa4BRYZhLi2xURu6
39927	payment	2132	2132	1874	1	1	1538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj2WkEvJTJVdpMKcnEM282fmjZVSM8cMo6cJWa9LAVtnv2hGmG
39928	payment	2134	2134	1874	1	1	5541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dauzz4egWyn4DbEuLBbCQZiDYnBUNYPTT8o5fQvpUTWW7PPb
39936	payment	222	222	2321	1	1	2	20500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFArFaXjrPVwQuUGwSMix94ptFWxWqzKAwzXBNqzxzxmSMbdsk
39937	payment	1397	1397	1678	1	1	15145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeU6vXy7YwQ32x81TDuTZZgV6MRtazE9oZ8QR4wadZhc8QL5QW
39938	payment	1397	1397	1678	1	1	15146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqF2nwvHxkdcrcPxsZ2ZttUdAPGkmavzXmnBCrgLD2msqFigZx
39939	payment	2132	2132	1874	1	1	1539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjiEWj9jtkbovpsrXb8Fr2F8c4vr8zJUAEWQzkGq1nP4VsRkR
39940	payment	2134	2134	1874	1	1	5543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiRZ5Py45vGn1n26WW9vA91dsfM791cnykifXVfHiHHLykeyV
39941	payment	2134	2134	1874	1	1	5544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXqrh4sBLvwU6YTK7yxjvFoc1fUaBfjp3xPzWmppJCsrXpKwE
39942	payment	2133	2133	1874	1	1	5106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDp9cpCFDvHV7vsaySzRyVrf3uUvnEv9XQCKdJJzWTEuHqRqC1
39943	payment	2133	2133	1874	1	1	5107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nkrE9YQwgEqMmB3c41JjbMwu3qfU4gNGx2mLJMiZrQaQd8cU
39951	payment	1397	1397	1678	1	1	15149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFrRfXFupmEZAf8pjnyaCPiNLMhuUsGQVFfi1udvjmE8FUGR1W
39952	payment	2133	2133	1874	1	1	5110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhCUuoyMH8AhnEUq4s29ouZ8JaWp5XDCgHsXd1SzRtDzQJYk6
39953	payment	2132	2132	1874	1	1	1540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEoGgFJPxAwCvi71b8vdCrmGNQkJ5eKcQyY85DgimEJDwMCrh
39954	payment	2134	2134	1874	1	1	5547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLC87crVueFbcrNYGqVn5ZwycjaLHgaLmf9jF6hZqMDvKrHDCp
39980	payment	1397	1397	1678	1	1	15157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFhAEFdEmEZiSFVsQ2hAPg1KhvFvoV2QgZ6eknUrecWanyD2Xj
39981	payment	1397	1397	1678	1	1	15158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNskCHaqCtKdFJH7vJnwTDFY83s2znw2QyKSQUMZxh1QX4nLTh
39982	payment	2133	2133	1874	1	1	5118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwosawGANpMdNH1GkDYy84J4EpJxofDbUfBgUrDHQRaDBCzbSh
39983	payment	2133	2133	1874	1	1	5119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZkCSoeZqEttp9bi7YDzGTAX8y1uhymfAf677zPo1R7DNfe8zH
39984	payment	2134	2134	1874	1	1	5555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKV3v5kHC2iTF8F3vt3unL59YiT5y6qKSoy8J2NQsYAReXogt
39985	payment	2134	2134	1874	1	1	5556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZ5xriEcRf7afeKrj1CMQqd4ekg2eAYY6ewA2yLnayzkK4ua7
39986	payment	2132	2132	1874	1	1	1543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhE3hrg5qctcYB2RgCfV6PmZskLkuWjSa6tH99y6DHvu2RTpSs
39987	payment	2134	2134	1874	1	1	5557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuGrbRs1boaJCyJojAsw9TGHHr9f7MvpedQX9cbMZavvAx4RX
39988	payment	1397	1397	1678	1	1	15159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMaz43UhY6gC4ST7Xgi7shmMEdvWtfuSfrRV32kmaU8vPhUQF
39989	payment	2133	2133	1874	1	1	5120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqjpV95ceZU94XFyNHAhHn3QKQ3w22j6nJkApiZJd6McmGE9Gf
39994	payment	1397	1397	1678	1	1	15161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1A1g8kpXuY4nAXPMqG32hKcTCD65SYnk9zuLsBMDpWx4Db3va
39995	payment	2133	2133	1874	1	1	5122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzr4Pdj7FUE4m9w2Hq5RiuSWYvukXz32euYqiLxW7biB5yzqn
39996	payment	2134	2134	1874	1	1	5559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLH2vu74xAytkxEcYJ6228QL484vhseFPM47fH2BmjmiUHHooR
39997	payment	1397	1397	1678	1	1	15162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsFmhnesidSmKo78dTsC6iWQvijE8K53HWEbk5ud7pTQFsG1S
39998	payment	2133	2133	1874	1	1	5123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQYtUDh8YTadgQ1Ea6GVciH9hNnvJU5Ugao5hFzarguZpMURP
39999	payment	2134	2134	1874	1	1	5560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6HeMhugHBvpZ2Tempuesn3TBUkPrfirzB1YyZi2Q7SAjXqiuB
40008	payment	1397	1397	1678	1	1	15165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgyxtjkzaU99B7ZtWFyjrtEJ2cNCg2UTG1tk7xq8joMj8DeQS
40009	payment	2133	2133	1874	1	1	5126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRme4PXDuAkWH83q5mhCdfji9cr4c6XbkEVCYUBJPYsABaykqf
40010	payment	2134	2134	1874	1	1	5563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQUJRT57jkmV7Az7QvsgHLAV4wSecsBaWDk9LAd3WTDaYsSLR
40015	payment	1397	1397	1678	1	1	15167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMU9SnSW1KvGE1Zpwv3sLb66y7hxRP22XNikmEytPVitt1R9R
40016	payment	2134	2134	1874	1	1	5565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRtJKDTUDYmHthEcyjNbJoqsTkK3naUb3MbzkCyJCmmq5YThv6
40017	payment	2133	2133	1874	1	1	5128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeeKSUYVJ2xnrour98UgwQk4QEJ8J7ND3XYNgkEKyTai3eHKy
40021	payment	1397	1397	1678	1	1	15168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjXEzrvbmvxwwaGYSQnjHp1SmfB3THY6pwZZGoqbNUCvnyZsnk
40022	payment	1397	1397	1678	1	1	15169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQgbQrsjjMRj66wvWsSaX2qfceEyP5oLwMhRtkWDz2NrSS3aJ
39961	payment	2134	2134	1874	1	1	5549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqmaKKHjR4fupbxeLNYGMjgp8jMwR2eguDGpf9eizHvB7JdFU
39962	payment	222	222	2321	1	1	5	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Qgs8CDQ7EfjzeR3zavBLgfX8c9EtydoJMfPjXeGrLEV2vXBX
39963	payment	1397	1397	1678	1	1	15152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86hYyoKfurvkJNRBtUxPp2bMj41c5dbVDQuZbeHsQJCDdbW3n
39964	payment	2134	2134	1874	1	1	5550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQET1esPgaZ3H99BQU2hDNaZYq5A6QX7wiXs6XAqzwZ7VTDE5
39965	payment	2133	2133	1874	1	1	5113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1XuUb9H9uMr2YDf7qxkDoXJYDAhc1F5XHEF13bnjfh2gWEH8
39966	payment	1397	1397	1678	1	1	15153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLmcoB9CocKGJz3SASZrD3Tdjei9v5bkmynoLuXMihVwiAxtG
39967	payment	1397	1397	1678	1	1	15154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt8455PZSHjmU2NYF42C538yYw4REFZKKJ2priFZfhE9FXsh3B
39968	payment	1397	1397	1678	1	1	15155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZcULYPiTXgTmu5HXa8RJ518fA1aYQzssk8EJb9Qp4DsY8XsVo
39969	payment	2133	2133	1874	1	1	5114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXngjdkXJEgSCbVFCjmH2b1AQ3K6GpK8eM6HJJYxKUthDuoqC
39970	payment	2132	2132	1874	1	1	1541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJJXzpuRmb98sij9UoazazHVRmgSYpYVVvEqAT2S749yMc9xt
39971	payment	2134	2134	1874	1	1	5551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXERQMF9J8q29BkUeAsZmiduSSutaeF8SmskT1UJXQy9ro1Xg
39972	payment	2134	2134	1874	1	1	5552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNJTVfHomu5ecPcCB8duyofhgQH99cW2JHPNBU4CfkpugpZrX
39973	payment	2134	2134	1874	1	1	5553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Q4DhgHubzFqPQRYvYEpS4ogTUUNoZW1rDnrjXozgi95QK2ow
39974	payment	2133	2133	1874	1	1	5115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGq7FmcXwyTSeT1tT87SDGikTYZfcLGTGLoZg5Bsa5VYo1Q51P
39975	payment	2133	2133	1874	1	1	5116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWt3YaeWvEHkiANUtL7oQfHoS1PoVdTw6w1QPKntUdSWjCqMs
39990	payment	222	222	2321	1	1	6	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5uwh7WBWMmX9G4A1YJqYeECa9fGKw4Amt6ZGPdmUZQwsoMQNJ
39991	payment	1397	1397	1678	1	1	15160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSthK9nQ4q47zKVjg8PWYgRPUAd1tywuBGTuJvZ8TfyyWCdA55
39992	payment	2134	2134	1874	1	1	5558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsTiMm6yMXtKJssYgdD6LZrTev9Vmq5RUknisWffFffQqi8sY4
39993	payment	2133	2133	1874	1	1	5121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqtMrrUnZwJnAKS7QZDeVKUtqqamVzmrVon1YZ4vR831AKwz9A
40000	payment	222	222	2321	1	1	7	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Wasb3MTfbtVqpTHkWFnzc9qnttHX7Reoq4E2j6Tsd3QnSb9M
40001	payment	1397	1397	1678	1	1	15163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKASpwBoypAMEUQ7NF2jMYgkWWTzSvFwtVLZGMoNXom6eyNoYk
40002	payment	2133	2133	1874	1	1	5124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ydAarAdtgm35txaiziJo3Ee1GWUvjeGF9mmkhYaju4yPnNLQ
40003	payment	2134	2134	1874	1	1	5561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS2uimGnYjSkJ3pZidLLaLBimitX5sTVpPAQTkBGexEazHTQGZ
40004	payment	2132	2132	1874	1	1	1544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkD1twa4vUzqFdusPicBQLoanooMiAUvZwxERLGbPxQ6oDL3G
40005	payment	1397	1397	1678	1	1	15164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHRpVBVhYp3iAYDVbJQvrCEdjtgB6U5yfSDetNsN3MPMvZj6Z
40006	payment	2133	2133	1874	1	1	5125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoiSnWP3qSXb4AbRqrEfQAQTyvAMyHvkGyVv7VS7LDPULXYa85
40007	payment	2134	2134	1874	1	1	5562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9GfVWuNMmwkCxvkdEvdRfWiiwDfA2NMWMVuLJcZ5ZXTXsJrP
40018	payment	2132	2132	1874	1	1	1546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGP4D36uw9FpQU24Zr4pHWKySeHJLRxditnqMsXMbS8sMQnXk
40019	payment	2134	2134	1874	1	1	5566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv87PWLdwXrhHnGMVCu7NPFGop7JQrbKomEeJCiwt3uP6WiPrd
40020	payment	2134	2134	1874	1	1	5567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iSse7NRQ6axuRuACwJKDN9HCni9WRzwaERA6BqSLqQMvbUn5
40034	payment	2133	2133	1874	1	1	5132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmX4w8WCJ5ruhBLKoYhjvXzt6Rrf4mHMKAXxYjLLQXQwznUB91
40035	payment	2133	2133	1874	1	1	5133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHmfEWn671zmnHt6rx8kwaExJLz6t1zkDM86oMvidiFzApu8jy
40075	payment	1397	1397	1678	1	1	15184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFwhhUkpkMuN4B7o1WhvwbgrgxBs121px5rRmyuY1ps7Re63J
40076	payment	2134	2134	1874	1	1	5582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoFjBx8eYNev2c4g4wvqSmNmLJekNMxDRRkbvm7jexy5CkLpz
40088	payment	1397	1397	1678	1	1	15188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uNJ6fcSsXSv6k3d6bVhyLxYDSrHGbVQGKcyq5TaZ5otH1V1o
40089	payment	2134	2134	1874	1	1	5586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy5HiKVuXLrJqWwqbiZCJgZVoTaSqCVxMbnYHoLuvC5Gnyxdy
40090	payment	2133	2133	1874	1	1	5149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRKMKf53QjDhpfKt3uw3r46dQ2C8tD4rvDky3NPjYgxB9pQMy
40101	payment	1397	1397	1678	1	1	15192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTGe3f12zZgynL3oZnAvJ7GiBoqqYBrQAwGh3vgGtQfXvvJRX
40023	payment	2133	2133	1874	1	1	5129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdpouEyy37TN13egJXyEfZ4AdU1qTiwJKom2FXHour55Gyf4Jf
40024	payment	2133	2133	1874	1	1	5130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXa2qpPCzwRkPtCHjtZFrKXfJTPGmAeTcYL4gmET4P1cqRPVq
40055	payment	1397	1397	1678	1	1	15178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vxijSM2zu9trBG2CmAQkqMEDxvP5WEPWhFJVbAkKE4pJPRnT
40056	payment	2134	2134	1874	1	1	5576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjN3cQkUVPEhH29AhPaXsr99UTM9mHRqT7omfKVVuTc7Y7YxKV
40057	payment	2133	2133	1874	1	1	5139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbhkbdFRjWJ2mVquek8CmwiZMS2hggWzH5F3fkM9E7xE5hLfc
40067	payment	2133	2133	1874	1	1	5142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqjcXiEfbh2Bx4Y9hrpW2BQYiU5NMc11gYje68UVUqiBLFf3u
40081	payment	1397	1397	1678	1	1	15186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ovrubdygznFB7UMrDmuJa6TrDrCAUziLhurGSRM1da46GHyM
40082	payment	1397	1397	1678	1	1	15187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsbX3Sy3ijpXgDvHCXiwg6SwDYAu6UxJSmt2mWVP1MprQLfBS
40083	payment	2133	2133	1874	1	1	5147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnSGWmXxDELzBygtDLEJLa82tmpajpfB4AFjekzNN2fQiBPwCJ
40084	payment	2133	2133	1874	1	1	5148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHaWYv5wMYq5oHMXJ6HWtFVNDwi2bxGcU2aYPwNphd39QLrWH
40085	payment	2134	2134	1874	1	1	5584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCesReZJUxJfUABuptbHQLSoq3wJMBTMAMCwEF7oV13cCxcEyP
40086	payment	2134	2134	1874	1	1	5585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfj9wwqT6BEGMHr7GM573ej91sEwBkC9xwnKdteqD8XnXWNQB4
40087	payment	2132	2132	1874	1	1	1551	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHtXSrLFSCfL6MpK6qmo9kBQ3wVfB1hRqQxpY7PzwkkT1AEUH
40091	payment	1397	1397	1678	1	1	15189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4VSCHKt1B7dkgvdKJS4byKuXFRn9tyy8WKYP3HRfZjtt1F9Ks
40092	payment	2133	2133	1874	1	1	5150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSi2WS8XfsRYLsXsQdMvN1XFEtRfhS1FETPeTgcCqwY6gt9Ki
40093	payment	2134	2134	1874	1	1	5587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39YTvpmLfvfburknghQrLPJcwupyqS5kCZC3ZSvBc3LTQ9gra
40094	payment	2132	2132	1874	1	1	1552	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94wHHcT4jzTbHVB3yd1QyrGDhPwV83TcwRvSNCZwfJdYF54qJ
40104	payment	1397	1397	1678	1	1	15193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRN56UyWYfiLMY82t6aFtSGRbiV41oUFaUFhPjBXfDEzUR2DYX
40105	payment	2132	2132	1874	1	1	1553	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx114PwL5opnS4UC5CLdP6SZXLdye4XUpFKZ1GPyXSRBb7jFBr
40106	payment	2134	2134	1874	1	1	5591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLezQdnBRQTfSMgtdfwwZEebcMLRzKYWAxFxFUXUwyZXc4Jzh4
40107	payment	2133	2133	1874	1	1	5154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9nU4ih6BKvZS3TRARbv8xDsJ79ot8FL4c6hktrsJ5DUPueon
40122	delegation	2321	2321	1483	1	1	1	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3aotTng3j1TYtSaX6S9xXZaFppzv6RUJubT6WisdkM2XEQCCp
40123	payment	1397	1397	1678	1	1	15198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQM3Px9Ht3oeiXLnHSmfRkZwfkcNKWrPFKnNKWs7SY2n5LPoQT
40124	payment	2133	2133	1874	1	1	5159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7jzqMhq4atxjs2Te1eLR6cRYcZ2wXSgpoY85X1p3F9P8EewY
40125	payment	2134	2134	1874	1	1	5596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeHZ7fmW2vyujrsPj19XBkGHv8p6tGA1Fd5H1Mq5ba4L9kGTrV
40136	payment	1397	1397	1678	1	1	15202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKPDiVzSy4ptrQFArrWKkQVvSzNCkX16VzrtVim3ech3NHE5K
40137	payment	2134	2134	1874	1	1	5600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPypnEky8K9MumwS93h4SddSiscxWuFx7Lpep7nGt2NL3SAYdi
40138	payment	2133	2133	1874	1	1	5163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpPie4LFeoUsx7Cr53a3YY8x9yVRwortfN4expyvFFvSk8ufLA
40149	payment	1397	1397	1678	1	1	15206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypXHf9HYzXARXgg8ex61UwZnz1DprG7WovTQPVSseseyV953L
40150	payment	2133	2133	1874	1	1	5167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYPSDfFJ3Ytx6X46VTa3ah9nd1P9sT83VZLXLzxWiiogzRBzj
40151	payment	2068	2068	2152	1	1	0	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmfgsWVivXkjaPiRjz36TejVqknkbNLMPFiTkZeyuvqGaWARFG
40152	payment	2134	2134	1874	1	1	5604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzAdPdvAHsjUP34MRjEwnhE3e2cdTTkckniQVtM3j7bKFvTLX
40162	payment	1397	1397	1678	1	1	15210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28vAMvvETX4xmZdS3KwDN3CZ2wAjofH6QEi2vvbcikaetzzsT
40163	payment	2134	2134	1874	1	1	5608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3zEdyEEs5DwdgLTxPceT4GA4c3u4YAq6ojwKP5nJZSDsSbpi
40164	payment	2133	2133	1874	1	1	5171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYxMksY13fVQ9sAnB12FciPUfv5X2hjZb55L94SbHJb5p8UXs
40183	payment	1397	1397	1678	1	1	15217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjLPnLjXDb8yv5HKSJt3eo8Bktb5eYNkfjNq9yDcs1M8RDCLx
40184	payment	2134	2134	1874	1	1	5615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr47VpXiuzminahwR4TVNZ1vrDCsrdhJ2qQG7NaAftkdmov97u
40185	payment	2133	2133	1874	1	1	5178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwEW1A9EtZhRvwK13nK1VEKSkMVajotxQXeLZ7PJJRMFBCaHD
40036	payment	222	222	2321	1	1	8	120500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQgLutQmwn1GgYKpZc4uWY35xrLjkEkoCRhqGkTZrUdtXCxwd
40037	payment	1397	1397	1678	1	1	15173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2X8iMQUsNqUFgWszKexyBbChcopwdePegyARsXUgNdEYmuK63
40038	payment	2134	2134	1874	1	1	5571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5qbQbjSUWZ1dQpfw78i39bEQhx5ZMm97dKd9A7eJZtzCUu3m3
40039	payment	2132	2132	1874	1	1	1547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGP87xm6zmuF9jh2P4Khbz1Hus97U8jryLYRAffetB5UA4P1UR
40040	payment	2133	2133	1874	1	1	5134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNKaaXRpiZsBRXudS3gfzKtKKiHXgoefkEy4eN9duGmHq93TY
40052	payment	1397	1397	1678	1	1	15177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL56NYf1QFe2SMp923qPj8F7s4jnzQpoM3ZQBPkz9HHaYxMafk
40053	payment	2133	2133	1874	1	1	5138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNrS5sD3omTxGBViT8xcmU4sYtS9rsHWqShfwJh3zzZAkxxxv
40054	payment	2134	2134	1874	1	1	5575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3WGQUrEaKpAuYoXN2Vfe9L573Z4V69yXrbN51d4XDVPBNVZc
40063	payment	1397	1397	1678	1	1	15180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5J9fGD63NcXijJjRswNPwvPRyUsPJjoNdiEMriwC8mSGu5ZCu
40064	payment	2133	2133	1874	1	1	5141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7QSg5FWJ5utNxyf5JVikB2FfgFTedETUJuwDG3xDxBnT7wkh3
40065	payment	1397	1397	1678	1	1	15181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtKTj6YHhN2JPHsMQ3kTV9agS69wBARChRHYGeMg8ow336qcY
40066	payment	2134	2134	1874	1	1	5579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFVj3VBFJzgojN6fZpUvrBm4YNAD8G2oMiSCs6TCFivV5Swy7
40068	payment	1397	1397	1678	1	1	15182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnuV2u9Sx3sdDcTWXtcvo6sFUKSxqHEKxeTkUwFSHh4D2ktmQL
40069	payment	2134	2134	1874	1	1	5580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZiMvxssWEk5W2gpuhvfxWTAPNhyFjjWbubgFDnVFNU3FieDN
40070	payment	2133	2133	1874	1	1	5143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qrwF83d3i4x69f8iRS5WwhHRVfyb3aKAnwvUx6ye2tYasc73
40078	payment	1397	1397	1678	1	1	15185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBotLKjw4tnecvkC6xKJb8xd6CVQxXyKEmPYRGR6j3jab6C6zm
40079	payment	2133	2133	1874	1	1	5146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhpN7evMwSZ9dZkdQmRGXbBN6vQw5ti68FKrU6zmqLVA7ZMW5r
40080	payment	2134	2134	1874	1	1	5583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoEhWvHwjywM8HdkDLepSH96zDaoFLoW57iTN48egLytd8WfMy
40095	payment	1397	1397	1678	1	1	15190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiPugoVQ22EKwVRKgox5BmQcDvBPp2YtADDZHZp4B69NQ7RciB
40096	payment	2134	2134	1874	1	1	5588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbaGbUJsLfVAwvtycPMhSmB5PoPjdM2THn9agQoAJg6sKMCtED
40097	payment	2133	2133	1874	1	1	5151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbHzqTDpqVwAkG9rE6MzCVvmuCoKvLKHpd44U3YEScvK7uB7R
40108	payment	1397	1397	1678	1	1	15194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZbbU4j9pWuacwYhtzGDEt7WxA8vRqmQKGuTwfgVdJNtQJJfy
40109	payment	1397	1397	1678	1	1	15195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnvKh6JXRaqVoRmRRMFV7caBbX7FxtGgPhcuYLVNW7aW9sU59j
40110	payment	2133	2133	1874	1	1	5155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcbdd44Vi7GqmNEB7qkEDBbqiXcm8iXdFXMTrXCmQnnD38CsE
40111	payment	2134	2134	1874	1	1	5592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN96KNHmryQU3qPXSVzrNwstvR1q11k9FhVbjr16b6b8qxdVrg
40112	delegation	2321	2321	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR9WuQkqDEWyWdcMLq5c7m2PbaEKXjfnYKbPz243DfY45Hf1R
40113	payment	2134	2134	1874	1	1	5593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKsmwQVf9RcgbJRyaV8wcMCoeahecG35g6muT8Jzp9BJy24F3
40114	payment	2133	2133	1874	1	1	5156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9A43xurxUHGcKQAEx7MTWM1EtP14Fe81YVbh1BenA3cqqEy6f
40119	payment	1397	1397	1678	1	1	15197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdNjC3Naw1qT5L8ZAKDfSSFaaK73wM7wQzTd159B5RGtq3dHfY
40120	payment	2133	2133	1874	1	1	5158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVKeRYbdiGseJJ9tmVEiAMkEo3hzwyXQN91Gr1n9h4KpHcPQGn
40121	payment	2134	2134	1874	1	1	5595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqoEynMrVGkBR4MBb1ZK78W4RzfF5GLAgzVv6FShhsRhSt1Kc
40130	payment	1397	1397	1678	1	1	15200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiM5jv4v6c2yYsmvpnNSbCTDdehNvruBz4qv83GirLCZFw3UcF
40131	payment	1397	1397	1678	1	1	15201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjyEXoXJqnNUCdTwcZ7AB6e35752yJMTzADDVajJ7CoEyUmuC
40132	payment	2133	2133	1874	1	1	5161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPQEtkt8qdaDPruCefK3NSguQ5Y7vQKK8gi6fiCVEY4N3fhKi
40133	payment	2133	2133	1874	1	1	5162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBCJpYJ1vkWMbpCcVUnWSaToZYU7MX11v5jpck8LzLono5Cnm
40134	payment	2134	2134	1874	1	1	5598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2aQjTWQ8o7riAHjovTNtv19rW3fZZL315s9j1ycdxZwJ6USzh
40135	payment	2134	2134	1874	1	1	5599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsS62Hbi4ge4GTQMMXjB41J7sNBEKpxbCBzMkuo1V6SQcQLYwU
40146	payment	1397	1397	1678	1	1	15205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ5sM9uQhqRVb6CfPjTzqCvEC9EmRAQYQNk63UiSXHBLu3Csg7
40098	payment	1397	1397	1678	1	1	15191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1JS9gbW5nBNxJqozqf4R5APNo5sfPUQjmjJBLDPUXJ4nnM92
40099	payment	2133	2133	1874	1	1	5152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6D4a5qVWYQaULVBgKTsqx2KqCNjJfjcvSeEJA1C3haVeR3DS
40100	payment	2134	2134	1874	1	1	5589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHt3VeZLzLbA3p94yCCcgH5VqVRjE1kXvVuY8qGt4UgXPoJGjm
40118	payment	2133	2133	1874	1	1	5157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxbqjbU3o6GCdbH5VvnTqdG5KZTMTWbe6cYaGxGUyspH6j8pHf
40143	payment	1397	1397	1678	1	1	15204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XcuZTruVRJULTkA5c89vH5GinymKfVGwHtYwMCRNah3CgsXp
40144	payment	2134	2134	1874	1	1	5602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbdZhYzBRZ4yZDq7TH6ZSrjAJDFyidE5sXL1hvRGAPpho4ErNR
40145	payment	2133	2133	1874	1	1	5165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzLeBDoUe4imngnXZgNFR7tMhaUKUvBXiM2pnd5mKhMmEmGDv
40153	payment	1397	1397	1678	1	1	15207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde19gjz6L4hXeKbdrp9h2Wizjn1H4atLWG5PZLQrQ1XiYAMmR
40154	payment	2134	2134	1874	1	1	5605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqSx4GQ2WzJ8P5ytowzW3KYFyRqUgezQZ3tjTp2fU5pfMQFVj
40155	payment	2133	2133	1874	1	1	5168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEiRnYrziVFwwWdu9R4TipHEksqvwZrz6qFekyDThzZTpdiRMC
40165	payment	1397	1397	1678	1	1	15211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsRSL913xoTriGRbEmv1Aa74awFSAWmjo4EhZU4vZaDgskZFB
40166	payment	2134	2134	1874	1	1	5609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5mnJVMoAtgjZok9wpNXwHotmfcJC9eFaeHHJPpoMTjE4kiyC
40167	payment	2133	2133	1874	1	1	5172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYL7QiRvBHnMi497A3s4qGSqJvWmesBodsmESMZ2Wk4QoQc9i
40168	payment	1397	1397	1678	1	1	15212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDwVJWXnzU9rDb5A5PL3fGTZp9b2hSuwDNAQbAbwnL7KiCKjS
40169	payment	2134	2134	1874	1	1	5610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14QrPaLNgQnY6rnwJPDAw6N2EqNhQLdR7MVx8Y4U8CX3bBnKd
40170	payment	2133	2133	1874	1	1	5173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUeNkFaX1AN55ovFksoQYruZcn6k8PQKhHkwiqCwwggeaMJQa
40174	payment	1397	1397	1678	1	1	15214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcncHfXLgBoZrpRkASgFba7xaN6xKEKxdCZXZudfrb6uoKtPd
40175	payment	1397	1397	1678	1	1	15215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuEJ4KDLJPZCzp4KuSocEUpdGhZY4S7ZUeZ2tn2eXFCV8Ci8v
40176	payment	2133	2133	1874	1	1	5175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDxgnP8F5Rp8UvQ8tB8ro4tFLUj5WR3tafqxTrgEPPt3B9o6E
40177	payment	2134	2134	1874	1	1	5612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZadnVGafwHC4RNKff2TBRT1yq2inXfCfXZAyjTUWZDU1m7uiBS
40178	payment	2134	2134	1874	1	1	5613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GvsL5eohjCeTMuzTh75h7gue2udCQK5MmAGkLip52nm1Tt2D
40179	payment	2133	2133	1874	1	1	5176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkFgu6vJYrZ8rj9hXdiAvRhBJaEZbTRod1wcUPYgoq2pQFsXP
40192	payment	1397	1397	1678	1	1	15220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4BbjEDwQ6DrvfUtCE2FCFErTQmWF8PGT1Le14XTXPm4vccb5n
40193	payment	2133	2133	1874	1	1	5181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3FvBrfZt3j3ZyVHheXcYHcZGF7SaGF18ETWxEnZVh3iGU9BP
40194	payment	2134	2134	1874	1	1	5618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqgVg8XEi62ZJTspJ2KvWbToKnr7p6SACRmMhfNA9TP6VKTWe
40195	payment	1397	1397	1678	1	1	15221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpLrNr4Md3MrGsmLSK3vXJCrWWm29H1HKqsJCaW7GxybKSiUm
40196	payment	2133	2133	1874	1	1	5182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyGqcqtgd4bk23go3doDvMJ2AG3kjyTkJT4rKC8takkLPHr577
40197	payment	2134	2134	1874	1	1	5619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwSQ2DTUPn2wJEuL4dSpsn62biJU3HQWinEQYJdMEzUqoDmQL
40210	payment	1397	1397	1678	1	1	15226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWqhNPHXWQAqKE2xBW343tgzjUzXwUMuX5g8DsBiDojwjMDK6y
40211	payment	1397	1397	1678	1	1	15227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTJt5c5o7p2gc9vw5XqpY7GxnAyRCwpjvwyiKzgFXDKyKjgis
40212	payment	2133	2133	1874	1	1	5187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba5syZ5fJ1G24Hab47viz3vBRdz1dzGGokps3CqzCm9w9pKvH
40213	payment	2134	2134	1874	1	1	5624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLFJhyXpL2pbduwwgzu6e8gKWpfkK1HhXtx2xpHXcsos6WdB4
40214	payment	2133	2133	1874	1	1	5188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSjNhQSs99WU5AmZPQ5mZmevhpByiaAoefV3XPXzMxuSkAWKU
40236	payment	1397	1397	1678	1	1	15235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRaBcwN2JPref3E6gMAgVmA2gZANT9wauHQZjeQ5U3JhCndgUA
40237	payment	2133	2133	1874	1	1	5196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMZA8pZphTo2ur8AxAyNtcXXjDNV2AnQp6R8W2jfGSSh7ZFd3
40238	payment	2134	2134	1874	1	1	5632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiPwXUBsfZVkvvkZLedMVh9StKg96GuUBamn4jKaycpqJSFeE
40258	payment	1397	1397	1678	1	1	15242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWbfcRnswYv25F4HWb6jAkAVb2viRkfpScafq9q1Uab3FPRXp
40259	payment	2134	2134	1874	1	1	5640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSsPJvxvtM2qoDkVzwtamAMR8kAYvuoLMnqfB2iN7hPKNGRy2D
40102	payment	2134	2134	1874	1	1	5590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1N24DJCGFGtwW5WCuS37G5KZsjrTzf91WLwZn8CtuqoH9gxX
40103	payment	2133	2133	1874	1	1	5153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzwYLsac71dpPvCQXg2usMLGgCpouSKMwLaZMsy4M5ruAVq6Y
40115	payment	1397	1397	1678	1	1	15196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnyRU5wHi7ZGp4aDa3KEptnLZFsmu8gMPTSRywDbUXK9aw93ky
40116	payment	2132	2132	1874	1	1	1554	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs8ufhmn9RnrAMf8r7G8SEEdYsHubZDwfm4yeShVfX8s9KxXqW
40117	payment	2134	2134	1874	1	1	5594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DyFtmBdbqePhQLNtjvAgZLRea2jgDHgEKbctCWwKsxRQPwu9
40126	payment	1397	1397	1678	1	1	15199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF4DDSweShtR4RDHjWymBKK2qE1WACkxGmEBdpLw7vnFVTnBcn
40127	payment	2132	2132	1874	1	1	1555	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36EXZQnHTFXDVeiF22Z7aN1Jm1VimcsKDbAuC8K1FYdjDoQCz
40128	payment	2134	2134	1874	1	1	5597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6WtH3LmVQ3BMH1jWo5ZmFFcGyzVmcwDSH6BWjuR1jnz87BopF
40129	payment	2133	2133	1874	1	1	5160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrwgcYqs2Y9AdgzFM87wjREoQPAeHtzCDuTRqfZhczm9xyaqux
40139	payment	1397	1397	1678	1	1	15203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT6fqFW8nD3x4r27SxQ3GeBsG2xgnCGgZf7cUbRyZta61LMhxh
40140	payment	2133	2133	1874	1	1	5164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeEchUgmwcYVer4rxzjc7fhxPQdUK8FvJyVmchTTvRvCtHSCGZ
40141	payment	2134	2134	1874	1	1	5601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCP5CYEmqycU34gD3UM7fX7pXtA5amn3Cv5MxLHe4DKNzE99h9
40142	payment	2132	2132	1874	1	1	1556	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKANNxrqBXXA8dFoWtfHn7ENXMCHw8QDs6yUu9dAtZd7R3mzc3
40156	payment	1397	1397	1678	1	1	15208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhw6vNVWqC8jqxcvtwUxnMT7yv6ZDj8Yj9tUtkgJBiwBdcqP7
40157	payment	2134	2134	1874	1	1	5606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHzqQjqsAtoiS1mmT25Xozg9oMyBJuT3PFLDr3X1fXNvJJnDrn
40158	payment	2133	2133	1874	1	1	5169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6YX4cw5ZfzxMgCziSZTvG3rP32s4gxHa9mhggCacDvgjGai9
40159	payment	1397	1397	1678	1	1	15209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1Fh1Pu2Ac3HyZUcTcQ8Ad14spuiddb7fxfMtefHw634EcLhV
40160	payment	2133	2133	1874	1	1	5170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn26NGQCKRSno4VjXbREwee1wDd1WuXpxruwX9YMC7MXmbXsXQ
40161	payment	2134	2134	1874	1	1	5607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMkjkdJgZCzA8pSEjRuCrqXZhurKNJcqnVP8hpzayrJPoXu3D
40180	payment	1397	1397	1678	1	1	15216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYQJQz5ZeDr7VL9GbtUhS51kKhDzp1yjC99KfGvTnieq4vKKbA
40181	payment	2134	2134	1874	1	1	5614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaCbingPbiDc2jEZjSibJofnUNuG17PUg3qdWjAr9BJZjufZvK
40182	payment	2133	2133	1874	1	1	5177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmebAAszVoPmCYR6GtLvmVbq5uk3UDS4tS4e5d9r4D17Kz3F5
40189	payment	1397	1397	1678	1	1	15219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWxZFeD3KheqVoCT5TR2yfei3AfCJytjjuPZw2xNQMT1J8Wqz
40190	payment	2134	2134	1874	1	1	5617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQKJ4qPZxBuGw4hb2xiM8T9EeUoJZgqRETcpg5RcRhnvVuDYiN
40191	payment	2133	2133	1874	1	1	5180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz17jV23PEcJzyTVtytsNaC6bBf5h2oVPAQqdHG1zrPasNQw9Z
40204	payment	1397	1397	1678	1	1	15224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcREiYhbKPXVoDDHQYenSUMHaXAC3k7Pgt2hh1xvN5jM55PfJg
40205	payment	2134	2134	1874	1	1	5622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyzp8MsWJnbCzVoes81W4pFi9PVjoYK2f7qSK6D6quiVu94gwM
40206	payment	2133	2133	1874	1	1	5185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa637XwagxeVLQq14GYCbkPBVmNN37He4NRXZPpwZb9ksz6s3XB
40215	payment	1397	1397	1678	1	1	15228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ete1bNd5ThjbhtoVpy85poLDnJ3wSZSY8WSoms9YYGZK4NB8
40216	payment	2134	2134	1874	1	1	5625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9tzZMQcGFSg3xNuZ1kFY2NKrYh7SbTAe1YbiQMb5P4Jd1Y7L
40217	payment	2133	2133	1874	1	1	5189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtowtT4BhkthmLa4bwue4jnk11nMgHYCuoUaGy4QjA9RnemVL
40218	payment	1397	1397	1678	1	1	15229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMBcKnawVsvexN4VEUKCKzxs736NPNzhLNwMoZsR1YuxWycA7
40219	payment	1397	1397	1678	1	1	15230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGNEU7p1tHTwhnKZAnYV88uBXzy2ZzQrJo9RPKtLm34yrMWgd
40220	payment	1397	1397	1678	1	1	15231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCcmvQtpaAjc2eVmRkbtwr3nQTNunHJ2HSzH6fYh9bxfFviuNv
40221	payment	2134	2134	1874	1	1	5626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3EHEuwPwap2zeUhzhk2NPf7fWZZ1YFVrGCRAM7uRwpuY8ivpg
40222	payment	2134	2134	1874	1	1	5627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNsZF3UUkMbSh8Y4sFt4BLq9dq8V7ZSEkLUtSF1JFYzPnggAS
40223	payment	2134	2134	1874	1	1	5628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6jon533Cft3qhHzyoCqmnmze6iCW817PZnRWECtFaJ5KtZtQ
40224	payment	2133	2133	1874	1	1	5190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjSp5JDiAUGkNHpJ5RE4FMkZnZCPextHyb1X45Kvz7jV69aZ8
40147	payment	2134	2134	1874	1	1	5603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUoaFbSNLNRGnoLszq5eV8WiN7ZeCfDr8URQhWSbrcuifFNLx
40148	payment	2133	2133	1874	1	1	5166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunRCdxg6kagiaJnkdXK7Jou3GreUFJjXVmFEZDCGn9u5kN3fc
40171	payment	1397	1397	1678	1	1	15213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzNrZaSejXDMvDkzvVHpHSsbcKe7ySFbH3djS3EXcPH58BU8V
40172	payment	2134	2134	1874	1	1	5611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYj1AtLVEfN2T4PtmCGakNSVARQLHXWzhuZ5W8G9US4BZ1xAqA
40173	payment	2133	2133	1874	1	1	5174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZrsNtzxfiy6caXR1kaE6a9mpzzittcCaVg55guAArt1wyWo45
40186	payment	1397	1397	1678	1	1	15218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8dtXv7CVetptgx2S4DGqnKyp5sKJww3xUnck7aV7c2ALRLfjG
40187	payment	2133	2133	1874	1	1	5179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnzhCcRQQLwU8PaxEcKEVdzTQLK8TUeFx9bXRgr6iS1GopMRaR
40188	payment	2134	2134	1874	1	1	5616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWutRYr91wT5Lk3GC39JN4Yy47RSAUBtSybCVvcQ5KM4GoDR2u
40198	payment	1397	1397	1678	1	1	15222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCnsa4C3D14ZUMAcfdVCk2PppqdwA83QNDHjoAAU9FbPSxkm6u
40199	payment	2134	2134	1874	1	1	5620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1QrP7sVGdHTQT1Lq3m9KB2s8HxRTWgRyLHomB4zMc7PPK8nu
40200	payment	2133	2133	1874	1	1	5183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HUBnhpkagPpSftMedAUVkUhTu6sgWA2MsMMv7UkrndRpJXGb
40201	payment	1397	1397	1678	1	1	15223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2SsuCmKXTpqD8sGVZvpanSknRQLtxYGWujkjJD8nAWhfuKTf
40202	payment	2133	2133	1874	1	1	5184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxB4DQejbfRUh4hG1va3FKouWfTmS9kDbk4d79WZhhiujmYSuH
40203	payment	2134	2134	1874	1	1	5621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8C8GhBbqkW9oxUKAspJKNkNafL5QWtEpWr68pTN43tUu4t1Gb
40207	payment	1397	1397	1678	1	1	15225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFbJcpjkuC6SQKCXHPfxZgRAoonhniZUeKhftn4EdhZkjBzeH
40208	payment	2134	2134	1874	1	1	5623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsVUVbuB9HizUxgQv7iPWT3YXNpu5pJcDnEb3rh815RGFR3Hs
40209	payment	2133	2133	1874	1	1	5186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3SJWTzZuW7psGnQeCavpLox8XctMreJ8U6oKaEAZ1SgZPx1D
40245	payment	1397	1397	1678	1	1	15238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNDAt4PDsjcLx4yHhXnjuPh3dhVQiASanMtMXzKRsKHNuKEa5
40246	payment	2134	2134	1874	1	1	5635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoeKeQQbqyNwkq9HoCHS8abUx1YVroJkKzdhRY9dXboQhvREwA
40264	payment	1397	1397	1678	1	1	15244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21khJTahTWFwGiFncew3DjDGjWjdVVJRiiGqtHAkdkrCX1ztF
40265	payment	1397	1397	1678	1	1	15245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE5AefUz4eGqVv1QonXNKk27iYjm6UsaSTWN7nrCqBjLyQew6P
40266	payment	1397	1397	1678	1	1	15246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBfo6CobNN4jAcX4xhz8s8XKLZk3k1NUNU7q65E9DgrLxMwK7g
40267	payment	2134	2134	1874	1	1	5642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvS1DWH57B7eR9pevXG6q1MJFvQnAML9ePogQvRPe774wCLXSb
40268	payment	2134	2134	1874	1	1	5643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokWiNvn922tPtHC7NDj5J12KALryeV3b6NKhQZCL93P7XfJhJ
40269	payment	2133	2133	1874	1	1	5205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGLXCggPiDvCEZyPu6Cu3jC5DYZuYanY2SQcFdbfuUDFzLtULZ
40270	payment	2133	2133	1874	1	1	5206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCyKwwGRWyYDG5tA5Te1hPKrbLqJ64E5eX4jAa9B9VxbGr9BYB
40271	payment	2133	2133	1874	1	1	5207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFa3SRSNXAoQaFGWzJvnfLaPbJywuzAnzQE9tKGvmpTANdWxk4
40288	payment	1397	1397	1678	1	1	15252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4r1Kq185y2Kh3WdtRy6EEMXofHQHFDtEr6Bc5urD3ECTXNxRp
40289	payment	1397	1397	1678	1	1	15253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrmdqQmxhSBP3skgHryWrozeDEViPKfUUqu9XBhsAD4A3z8r6
40290	payment	2134	2134	1874	1	1	5650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnHkg4PuLsmM1Wo4LAXeq1jFUA1PTvMvH917dJqcaHuoq82dD
40291	payment	2134	2134	1874	1	1	5651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLM4Lru3h3LQMSg4LffnzcCtUMNE43zAZebyB71JK3copDev7g
40292	payment	2133	2133	1874	1	1	5213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6USXwBd7XzWp9QXVWtRZpA7DvNSTNHNYB6AqyhLjDuFCSqu6P
40293	payment	2133	2133	1874	1	1	5214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNhGNVpXjoCg8PwWcBqhvFNSTbWoUjriYkPxRoRzaQPmsvgJE
40297	payment	1397	1397	1678	1	1	15255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9w4D1Y4LyJuMaySZjbefT7SHXWX3fxA6KfhBT2TGCubBUbsbr
40298	payment	1397	1397	1678	1	1	15256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjECqmkvwhDCmpEpWTkTYSWKaZuvmhn5nWzRui1gbP1UCsaLh4
40299	payment	1397	1397	1678	1	1	15257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFtqu3EPw43dMD6SNNKnJDXmPbntThigDQQUFHPbDSj8zC8f8V
40300	payment	2133	2133	1874	1	1	5216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6NRqKamoE3opQ1Etm9tXMNNQpuMr4xpnNTqdKfZuBiGeqScG
40301	payment	2133	2133	1874	1	1	5217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmhHDdtk9uz6atsDBwtZVKaVV68XkrzB7EhtnMJ6AyFtW9MkHU
40225	payment	2133	2133	1874	1	1	5191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPCACM521BbPsakEAt8cxMj1nwgpp4yMhTdSte9JSckg2Aa1Kp
40226	payment	2133	2133	1874	1	1	5192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUQj9qKG9T4uXRfo1MCBMpyPfyyHyiGJZi76Rbnv6UjWyFV3vV
40227	payment	1397	1397	1678	1	1	15232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLuDXwZ4sdyX5q5cd7UaGfWNoWLwEHMFtNRqpCwiRvFNWEKEck
40228	payment	2134	2134	1874	1	1	5629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB1i5fgLYVjWJtiFhmjaufTwNT87wE4aU8v7NGfCRBr9GwrJf
40229	payment	2133	2133	1874	1	1	5193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgty4cCdQPpV7JVuQYq7bHfS7cQNkoGpJHyqAtrCRm3eGT9VC2
40247	payment	1397	1397	1678	1	1	15239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yf15smS2iaGAqJC72ShcSwnkMrVjSsBQfcDmpehAZyK3qqB8
40248	payment	2133	2133	1874	1	1	5199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5VJVHSizk2ECuWvoXSGp9R63q3joYyhFvYULrWcFCfyhBsVk
40249	payment	2133	2133	1874	1	1	5200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsTaMhDaPGw81G1otPy7vWiTUaKatGhheXrmN6yjiGXBc8tYd7
40250	payment	2134	2134	1874	1	1	5636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDkj3Vg8SRJV3f4cjWQUe6sogu8NzhZCdiukp1xHVueQVoXVm
40251	payment	2134	2134	1874	1	1	5637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduZVGXZijzFWkw1AyNd5pJbFJdJJVcz6r9dtoAZNheyZFPPRh
40261	payment	1397	1397	1678	1	1	15243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZhTP5FMP4RR34kd6DDQBUfz6UnWFWdNL7L7Z3oYNy1yVWNTv
40262	payment	2134	2134	1874	1	1	5641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXawsVEqRya7yBZFnKfWHPygyHqLeE3YtHdY1a5Zb1Z1RoRQS
40263	payment	2133	2133	1874	1	1	5204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzLJC9WBRSBtNwGGGNxvXxgpYdBXH9eHMDeSYaEQFbPMFiUvx
40272	payment	2134	2134	1874	1	1	5644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoerb3s6rQewisTsra759ugWgUbRt2GBSL7XrMfcDMeHucaxj
40279	payment	1397	1397	1678	1	1	15249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd44oCkRE6Qv8BMy6EUs9zk1the8Fq2jQjYy43DNWcDzUXWnYQ
40280	payment	1397	1397	1678	1	1	15250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYum5jts56NpJRcehwEnrZ3C3v4Dm8WixEkZn1M3XdAZKwdH3
40281	payment	2133	2133	1874	1	1	5210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafbawhYyiMkYERYGw2vBNQBKb755utEUPXUEPQKTfNP5Y2J7b
40282	payment	2134	2134	1874	1	1	5647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaUqCypkUrnZq7KXariimrtMofF7vhdgRbQ1qhhNMzB8nrj2B
40283	payment	2134	2134	1874	1	1	5648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptS1qD24QfSxUyhz35ZyThNMKcmZGowguaM4dvihiwVV3NWHB
40284	payment	2133	2133	1874	1	1	5211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aCPTjXtC4Lg9nWi5MnbRcvBpDDyntQFEK8EK29WDa24sqE5h
40306	payment	1397	1397	1678	1	1	15258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6bJWrsR8vzDFRk9b2KFmSNMhRbpXucn8fjEWsHASMDYP6avz
40307	payment	1397	1397	1678	1	1	15259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdZ9Gwxj5dCd7d9qHioigGLpo2bi9Uhaxyb7C5YWBbvipYxjW
40308	payment	2134	2134	1874	1	1	5656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzofdhk9iVm8ewq7ogLbHTxt7fr6FwKGstoTyt6yfwxzRNVjos
40309	payment	2134	2134	1874	1	1	5657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5qW5WbDeJmLST6y4PGjiWgrBLF6uapXBHyfnh9z6fGRL119Y
40310	payment	2133	2133	1874	1	1	5219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2TvArD5am6yRWU81Bj289MC3FCNa6W6KeQw4WrPZCGoGvbpw
40311	payment	2133	2133	1874	1	1	5220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHtijGGfDdbjr2KWNjTAbv7JMNzPeBiBHx6TznPNTxDVAQibh8
40324	payment	1397	1397	1678	1	1	15264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpiuHe1rDzQ8sThzT5NBMnwCBpXLeTyCHS3iP5ePvMF5YxfUZ
40325	payment	1397	1397	1678	1	1	15265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6aPAJ2CbYaJ3SToWnc54JHfmSqA8dgt1aCR8jcWjeZRY1zrm1
40326	payment	1397	1397	1678	1	1	15266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRuaM4XeqNkSPBGGM6ccqMGrKLkMMvgvHgc65GiEFMoE45L4F
40327	payment	2133	2133	1874	1	1	5225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHeFLyoM3PSnK4GkJfJGd1S2q6KjkwNo11ij6kuzB7ajvD9ir
40328	payment	2133	2133	1874	1	1	5226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXP5KZDDc2ECJjqEpMjYb4fFbzr3JyNyeAPriVMVmz7pCqXPE
40329	payment	2133	2133	1874	1	1	5227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSLGjAes4EGwRxDMqHcWpd8wQgnNRJnpno1ePCS8yK8PJSVmFD
40330	payment	2134	2134	1874	1	1	5662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJvoA5nhLnnko9pqC8CYRt2nwkRvAZdQAc53poWsTbsD4MHn4
40331	payment	2134	2134	1874	1	1	5663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ENw9mPeiJYHCdkocmoCaG1in4MZX8oekioSVroHejtPMaaVr
40332	payment	2134	2134	1874	1	1	5664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVwa79CyAfpQqxzaBH8jP6DwPeMMJmE9WbyWWZ26hsX5MVEeH
40356	payment	1397	1397	1678	1	1	15275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGiLDKhiwhBsCbkXWwegbHKFd7hcp9aTCAdy7KcihVxS9YDVP
40357	payment	2133	2133	1874	1	1	5235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYep9tuBeRVojM8vKsMAspQVQaXgA6t5nFcrMNcbFTJ7Vd8CcvR
40358	payment	2134	2134	1874	1	1	5673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpajEtbLpPMDVHyZsn8JhBo8dMbHV1VXXMeCtF4J9x4C2f82BX
40230	payment	1397	1397	1678	1	1	15233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBENpKA9xN7PyLjrDiXhpsvF6iU7xKXZvuZKAkgct5fBuwei6f
40231	payment	2133	2133	1874	1	1	5194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgbBHudpDVkqWXaCHStTywUSrmTRJxrhRLdDh78ySCuVdYHq1
40232	payment	2134	2134	1874	1	1	5630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7oE9pLfvGfmXXR3ZANjKwNUoE6rG4hV9Zea2KqXCN64juwc9
40233	payment	1397	1397	1678	1	1	15234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81yF97W2UpLbC3Ee5cVH71wzck6HCAo4X1yCctTTpSxj3WoaA
40234	payment	2134	2134	1874	1	1	5631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSztBb5Z1ijx38QGiH7eShwgoWtYR23iDaBgkLiaJo1yVgThiK
40235	payment	2133	2133	1874	1	1	5195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJLM4rUKE1uRGLzVJYkL1BMq4xwU9CeE3UPNSjaHnQTR1jNkL
40239	payment	1397	1397	1678	1	1	15236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhtxzvEZVjDZBm8nJvEB7bHpdtv7KP8vY9f4X2EGwRfpv1QdY
40240	payment	1397	1397	1678	1	1	15237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5Xxbp9mC3b3Ym78DgWiEjN9gGTRLCifX5p5nCzBAFea8HoU5
40241	payment	2133	2133	1874	1	1	5197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjCYCBLBJqmhphNoUzbu5Amyw6doNbUyUWL9UYYV5Hnah5RDFw
40242	payment	2134	2134	1874	1	1	5633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUi2TYwZ3h9WrBWf33JbmWpUhKHEMbrb6y5rQBJwQcEt3P7zY2
40243	payment	2134	2134	1874	1	1	5634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaCejw5N6aW2xWQZ7dzTT6rTK4GZQd5Xao8knZzEsTBWe9eiq
40244	payment	2133	2133	1874	1	1	5198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1JdmZ7wEDxRR8YkULCkTASAcyH3CGxjLjNneV29tNAmMx9V6
40252	payment	1397	1397	1678	1	1	15240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3h8jeTmo3T5dTPBrfgmaXJnRKpNJPf9FPFp9W1pS3UwTJQuy4
40253	payment	1397	1397	1678	1	1	15241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkN8QQb5qhbRkqX4guaPpPY4Tp3VjSM2ckwW6rvwZf3DMe5jmm
40254	payment	2133	2133	1874	1	1	5201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftGAg2jeNMTLxCrA9pAkwW8aXYCp3jt5Rr4AN3SZQ3ctsJo33
40255	payment	2133	2133	1874	1	1	5202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBYiJh9qH3NZAPjRSfC7ccNWw1WnK9EN9XAgcUPjMwZs2YkH6
40256	payment	2134	2134	1874	1	1	5638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZympHaTFNzdw6bX4QjdFxbZK7n1ZapCULwEjjj1uYp2WXriDYy
40257	payment	2134	2134	1874	1	1	5639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWAcvWZBz9PMT4ma2KDEKVoSwrqxF7ydrngy1eA4LX2NpoV3N
40276	payment	1397	1397	1678	1	1	15248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdRdEipRHe3ePVqEy9JUmYkddG31Kc9udPr62RxBFe9pGSiv2
40277	payment	2134	2134	1874	1	1	5646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAFdnD1p56vUTK1XxnwQxLf98CFhxnwuuCaCnm7DyXyucZX6a
40278	payment	2133	2133	1874	1	1	5209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhm2g7s8YPNZ3t6HJ9uGBAGgPgXNgZc8wVJQs8tiR8qFjMDCRz
40312	payment	1397	1397	1678	1	1	15260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWrrstL9o9AoSbXmxs5Svej7Pqv9NJvwt2AxdZY6ym5ytaXvMo
40313	payment	2134	2134	1874	1	1	5658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRaWodo7wZXZovV3BHNechwYrhYxSEL1iV1KRoSjF2uBh7QXG
40314	payment	2133	2133	1874	1	1	5221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB52v97CJmZouL9HWHcEmXszuwspnVY8kRcvaRAHZJgcUYsaMr
40318	payment	2134	2134	1874	1	1	5659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ174mMEAaN7FJmRwz6JRkxTw8a1ybCC2LvfK34Xk4LtYo1LkAw
40319	payment	2134	2134	1874	1	1	5660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqtouVdAvzuK7udgGHcQW9DFjtdPZsY2E1pdTTd8Qi6PjY4Tn
40320	payment	2133	2133	1874	1	1	5222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyyxN4ERPh4PhuMM4Ne1fQD4FRV8GyuS7SyGLKif71oJ44t56
40321	payment	2133	2133	1874	1	1	5223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjUauNQ2XPohMbQdh47TBbq3kRFsZ1NmhbqvC4d4HAW2XjuuA
40322	payment	2134	2134	1874	1	1	5661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwwbABtn2wjpMKWRJLNTGqKXDiS2sm3TzfDF77bgTMtHysUTs
40323	payment	2133	2133	1874	1	1	5224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59qsM5ooHPrZoR8TvvwAWjt4UcW2mngBcEMJYkPAcBWtHpEGw
40336	payment	1397	1397	1678	1	1	15268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnt1dYmLwwaC5bPzups7sHCt7QGP8EoG6BsT7wFV58mLGq6w1M
40337	payment	2134	2134	1874	1	1	5666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtp6CM7HiitX2wfYpTPVFE1Sa8cgF7E25yxGnuCEcF1yy8Jr2
40338	payment	2133	2133	1874	1	1	5229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWGWBEVtQdk53QuWnw53ZPzvAmSt5nHfneTiSFHX4MbeugKfJ
40360	payment	1397	1397	1678	1	1	15276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPAEPk8Qv2chqmN6WTpjaCAsLfGVkP6gpEHYG8pX6NpDkoHHk
40361	payment	2134	2134	1874	1	1	5674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97AvyBk2YZaQaC8XPMkPgAhaGX8hkSXqpRx4tF6dt7eBSv3dA
40372	payment	1397	1397	1678	1	1	15280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu7RgzzR9gGW3d7nsespN14YXp6kwYrRYNPHfmrPNPJMM6sNoy
40373	payment	1397	1397	1678	1	1	15281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYkjdcRpzNQEPpSjuUoiT4XHRoMtJmup9rk6LMXQ25YmCiwSt
40374	payment	2133	2133	1874	1	1	5241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXVz2GBWrxtodAjRYutMHKtBg6pmkpGw5sj6nYPQtWauRtg7L3
40260	payment	2133	2133	1874	1	1	5203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9ak9WUpozBpuVNZhzyZrUo2mFE4WzoY9L9zw2ZzjQD6ujebx
40273	payment	1397	1397	1678	1	1	15247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBSXQMbFB5bzHx4x4BCVAYUwaNdcwLaaGjvnHiPaL6rxM3fv9
40274	payment	2133	2133	1874	1	1	5208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtERBRbfDaamWVNe939ECoynZ2mQh4w4gkTm5zgDsjJsVzUbB
40275	payment	2134	2134	1874	1	1	5645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa11Lk9hDjpS7FG3FWLx1gwfhxnVMaDBf7hzgVnktXYgWTMba5B
40285	payment	1397	1397	1678	1	1	15251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjk41kgzasEEacRBc6yh4sw48xh6f5bF4vEnByvMfbAaAXcgyo
40286	payment	2134	2134	1874	1	1	5649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnW18ba2E9afXjTyXWQHwcY5NVTDe99ELrosbVHPbbUz3NiAR1
40287	payment	2133	2133	1874	1	1	5212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jMPTggphBwXipzQHuxXLsEPEGDdvCYrRckkrZuhsidiCXiaG
40294	payment	1397	1397	1678	1	1	15254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64Hzx26w2fqaBJHX3yngVnAemwcw5RjfKL5fgBB4XQMr4FWBa
40295	payment	2133	2133	1874	1	1	5215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhcsWgey8u1tUfWQfsVzRQ9hCRJZAqgkULcN4CXBzfKU1mdEjD
40296	payment	2134	2134	1874	1	1	5652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvhwnNKvba3E2AKafZbg3d7cU6K5FZ11cxpcU4APXXjVAxgYq
40315	payment	1397	1397	1678	1	1	15261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDRDgQxKW2VCTw6Ki1sHuyLULvfnp36kCjasENXWqz4mJrM3a
40316	payment	1397	1397	1678	1	1	15262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuvBBy1hpkvVN56e6kBV4kYTphHQqTZf51ei5KHt15oEkEMTKb
40317	payment	1397	1397	1678	1	1	15263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1pymZWKeDsWMhMEJFTHan7tRqaR13VtooxHgas9rfqfTH9Mfu
40333	payment	1397	1397	1678	1	1	15267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4i7bHU6HBmC7gjUzeSbGTBWB78bRW9AXCMigq5smgNMtL1168
40334	payment	2133	2133	1874	1	1	5228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAPPoWMBFNK96iBZ1cwFtkgUxi58ZDBqAv2tHuPg6MFq5Xta6
40335	payment	2134	2134	1874	1	1	5665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNaDJc6tCSTW5PvhtoHKXRLZ5gVnfxoyVNvEcdTiR5yWc7REX
40354	payment	1397	1397	1678	1	1	15274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLtGR1YNWidUiiXgtb4PmdGbZCxxsc5SieZEMWccYvYRCFckX
40355	payment	2134	2134	1874	1	1	5672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvmvNfTETK8X8qTsZxPQ75nQtMTedJv8YM5n6Qtcz2Uqoqwg28
40366	payment	1397	1397	1678	1	1	15278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQ7jNHzTeK7yKtfFBM4RaZ24pjSmQ6dqmajwTDMpFq9sLknaC
40367	payment	1397	1397	1678	1	1	15279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqA5P2T7FmJK6DN9V4KFZrT63Wt9vJQYdiRWQCCf4GcmxhykEZ
40368	payment	2134	2134	1874	1	1	5676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbra3iUCvnbFeyJ37XsLymHDorv5XeqVeVMT4ebXCLt3D3Uacb
40369	payment	2133	2133	1874	1	1	5239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjFtzNdiACFTkWh76grQwvxzRrjxu81Sdm5afHRE7si26XiUs
40370	payment	2133	2133	1874	1	1	5240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjwBbnqJVQapnUiEiL3WSBX1GMk1aU25F8U8Ksz6veA5cSoJD
40371	payment	2134	2134	1874	1	1	5677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4yxDrgPHKKrYeEiaiebGaUNKeQCdv6a9NKAsPudGJC5eQVpx
40378	payment	1397	1397	1678	1	1	15282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqBPEoQ85YzZLCxYBkJCLHNjHSxifpLnPGSsfZecE5Ss79WFb
40379	payment	1397	1397	1678	1	1	15283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExSkV4EpMD7ryzTroT1Uo1xun1Qiqz5XHGGNjw7YdPCZizB3y
40380	payment	2134	2134	1874	1	1	5680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4f1PA4s5BMAbpCDEA56Pw9uBU7zTf3u8ngBhhSxRsEYyigVVU
40381	payment	2134	2134	1874	1	1	5681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1LgJrmJQ4RxpQDakBLwS7mpDUnQP7rnmNoSfGZunYMuNpU7Z8
40382	payment	2133	2133	1874	1	1	5243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcGd4PtqDW4NZjXhFsUyLxGByJ9AZ8qHzus3UKW7GAVQAaxX8
40383	payment	2133	2133	1874	1	1	5244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9zF8WfGp39kKx5wPzJbPgvRVD6AwBsttF8qHU1cKxHdXGx8Rn
40387	payment	1397	1397	1678	1	1	15285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcEmrorry2qj9wE8y8gg3Nym1GqXn35QxGMgUhRarp3rMzyfS
40388	payment	1397	1397	1678	1	1	15286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ERaowFHNWAbSH9Uhjn3YSdPkGfH21cxUS51Ug868nWtcSyHe
40389	payment	2134	2134	1874	1	1	5683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sWjeLemtPFZFTNcmEQ38kmeUYfj9DBoMzpMHC5AeSPZJ3Qb4
40390	payment	2134	2134	1874	1	1	5684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC12BHN8vXa1R8t5yofpHhbNybxgG2Fwph5jHU3qGPSEEQAsj
40393	payment	1397	1397	1678	1	1	15287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQinf1rQPjoVU15h9nmd5ocsnbnyZdBRUkqWksNTHaN7c9GgMX
40394	payment	2134	2134	1874	1	1	5685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeM6JATmSgr7EuZPiEWjDAWC9BsFFnn6vo4ZjLD3c18Ei2UAR8
40395	payment	2133	2133	1874	1	1	5248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGLn6SoeZgE1KHgTACqiosL59jBirgeYLZPt62WSiqtVbVr3D
40396	payment	1397	1397	1678	1	1	15288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiavM46bRbrGJNbkZSUJZnn6dKfs8A8PWB434gizFmyz4sw17
40302	payment	2133	2133	1874	1	1	5218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpj571iDy3tio6eKaTfCyFsfo8zu5MU2uieGs8sWBJfcSEEAmE
40303	payment	2134	2134	1874	1	1	5653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTX7NSx6L8k2v6vx6JCJzP1oNFZ5pUz7qVfVv8BkGWPbrf4SyD
40304	payment	2134	2134	1874	1	1	5654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39pE3gzGJjcBCGPKv2oViaWH9igmKMgf18jnL8hi46kefHLkN
40305	payment	2134	2134	1874	1	1	5655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgfWmEBY3iwgaDbESyLLXZoUPyqGj8HpJTggFye71vdBhexok
40339	payment	1397	1397	1678	1	1	15269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkgcYg13e3JV9UmdcLvHEt6cphRCuW49aa492C1AKKKshjUwB
40340	payment	1397	1397	1678	1	1	15270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRxjLsfsgmfVUo53firtZzH13YEeZNKzkKiLsqRJSctwNv14b
40341	payment	1397	1397	1678	1	1	15271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuPgb7NYDaSBi3jSkDvCT33UwF9rDim14PQqbDYWWeFuAPJBm
40342	payment	1397	1397	1678	1	1	15272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPL7keiRCTCtCp2Upkpxky5Dt3M4ezKy3d1zc4yeokZdX6HUg
40343	payment	2134	2134	1874	1	1	5667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWEVNYF3YhPW47iW6fPXbDpf6HxaBby5wbw2M1S7acSzWEkhiU
40344	payment	2134	2134	1874	1	1	5668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurz3JpwLayZQifKaWnDFd5wwcnw5VXPykjepczMiZuR9u5kxK
40345	payment	2133	2133	1874	1	1	5230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexEYeQEMKKvw1EdaSemTBG69VS1xuGF2MWmURLpgr7xFte4Bn
40346	payment	2134	2134	1874	1	1	5669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjao7BJS8NyDe9FAFCD4bmGmiNGp1F8QeoaJE53319uEod6XTK
40347	payment	2134	2134	1874	1	1	5670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJyywwb1dJprJmMsECguf1SqmC21vQcZ2w3ixoaKHsqArkm47
40348	payment	2133	2133	1874	1	1	5231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5bq3VuBmx7Bx6v7D5qAwtSW8y3kFTHAsu6PRqTdG39m1Zh7J
40349	payment	2133	2133	1874	1	1	5232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkhdtbbXTsSv797nZ6MwR9S93CNXynP9w67gu5u4ToN9vx7TS
40350	payment	2133	2133	1874	1	1	5233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4u4njHDHygFurrW35Z6uKcpANvVXpzCdWXGYF3Gg4xHtjbiM6
40351	payment	1397	1397	1678	1	1	15273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU51mAS7UR7ds3D9f1Y55YL3ixeygcyrAvZtKDEN5gxmNih2GK
40352	payment	2133	2133	1874	1	1	5234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchYuMykC9abGKVaKE4QXqCZpuDR4AY4RCwKv9HJVrUYbigd2e
40353	payment	2134	2134	1874	1	1	5671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hgpBKtjYgVx7g6GbUMwbQsBFUxr73B5zumrsijj1bRgXDF1z
40362	payment	2133	2133	1874	1	1	5237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzknnXAC5i37hZ1KEg3CdbpyCUSRdfT2Yy92Z52SVeQuqmuut4
40363	payment	1397	1397	1678	1	1	15277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MnmX54NBTxD3LgVH7AS7c3X1phG9jvoR5WbmhD9fdry473yY
40364	payment	2134	2134	1874	1	1	5675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRJs3Z3p6XmSnMTb6ZikYFZjAfEiXEnUcxrBmnZzdcE69Vqps
40384	payment	1397	1397	1678	1	1	15284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTkLZ1FM7XxPv5XXJ42Ubn7Y6Tf4eYsh4UQcL5RyWAzY4CEx7
40385	payment	2134	2134	1874	1	1	5682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsP1fxxMnVikXdyNPS91TTioYbSiX4YyC9y8gqpGei6dSa6imh
40386	payment	2133	2133	1874	1	1	5245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGSjqZcirQT2c5jbLXchXkmDo9RWcyKeab4FJZiueYiHWyRRQ6
40391	payment	2133	2133	1874	1	1	5246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQoaffXvXU7iTaf9YJmoCGqHKSfezVNoEA45JoGDYPQmyuYfeA
40392	payment	2133	2133	1874	1	1	5247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbEvYqRfR6QMSFA1vNPuxccBWiLP4ZnBBK5CDr9KSbvfm4hbN
40399	payment	1397	1397	1678	1	1	15289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GwoTaHXLdG2AQZrEcv4EY9LmtUobT1X8zZ1AM6M8ixCZuNpj
40400	payment	2134	2134	1874	1	1	5687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ68ysG1oysUjtrsKAupELU1dncbuVoXKYktgQDpVwYFti3xVPV
40401	payment	2133	2133	1874	1	1	5250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKHBEzRAFGxyhS3mFfZaKR9gEAELubGJjgihS4bRjgXdE8VFR
40441	payment	1397	1397	1678	1	1	15303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWAZvrCob3z7eHMcW9MSwGa6uhEww9kKWhtQbsATkUJ8Dmw6o
40442	payment	1397	1397	1678	1	1	15304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufZrR85oDZHnJYK1ZZvzpL41k5aRMyBCbZHHhqwG3u44Ermk3
40443	payment	2134	2134	1874	1	1	5700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5jfbxCxiAWrzwR46YEhAuLSoy6rFnbESYxPGKzY2sX8mRj7b
40444	payment	2133	2133	1874	1	1	5264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ6BZo7Gq1qmrECqg3BCb8nQkzz53q7G9epAaxCRvrst63pWWG
40445	payment	2133	2133	1874	1	1	5265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWNN2mP5jeECVh7zznX7iCTKbJ9G9r2MCqdVP5RDUeXJEMbC5
40446	payment	2134	2134	1874	1	1	5701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL2zd6NfqGSQ22j3BMNM2cfos7UHAXQ2Esjyr7otx7Y8YLntuc
40468	payment	1397	1397	1678	1	1	15312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKiobJMRNJC4Cpu4GtdPA13yLL7i3w7QQyGgeGMdtMxQGy97t
40469	payment	2134	2134	1874	1	1	5709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNGHcByeB3QNsLE11fAAoLtFwXjBJUaDLajss9iK3F9NvBffv
40359	payment	2133	2133	1874	1	1	5236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1C6aXyEeeV3mwNtUp2PFhLRSEpi53FBsgTp2A7Tcp5Zj9XWZm
40365	payment	2133	2133	1874	1	1	5238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1dnGN7UbFPGya8qq5oF6BBbdK5t51QMgwC9aYgfvjeW76bZoq
40417	payment	1397	1397	1678	1	1	15294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81g9mpYU6bGwVWDCSAxPX2WqdeQYoBNSG9PnqmHuq3LTXqy1F
40418	payment	1397	1397	1678	1	1	15295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWKXMSiiWqwvzfhNBTozq5FbG76bNekdnTLAYPS4p3AXPA4LgE
40419	payment	2133	2133	1874	1	1	5255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3q74erZNvjz2cnH59mnncBUohsd8nVxhuCdX1eysmfPXySrV
40420	payment	2133	2133	1874	1	1	5256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEymTm1CM8NQuZu4Acbyk6CBQZKxaEBFdgNXB9VR6MPYGfEFWq
40427	payment	1397	1397	1678	1	1	15298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHHD4X6GegEye2V9Lk9jhs9FgVbab71sWa4iAtqT8fdRXNvSV
40428	payment	1397	1397	1678	1	1	15299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwUCMYvLXtj3c3Cjb4P457Xx4GhqfAuuvx7dqZwKVF16fmMRJi
40429	payment	2134	2134	1874	1	1	5696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vbWxpi5WLaUUCPkiwTaCLcrjYXWXS32GQ1gjbgppxMGzz9Su
40430	payment	2134	2134	1874	1	1	5697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dApjeQhaLThCFP3MqzvKpj7TpES74LazhsYxQwRwpt9rJrpX
40431	payment	2133	2133	1874	1	1	5259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLe4gC3x4YSYMy8FAscnLvUDwW5dYKZATKwQhyBAYPEPx6hVhA
40432	payment	2133	2133	1874	1	1	5260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYubGDWTtYSNSSC3rgc7Rf2FtngNDjD1wGUJ9JrFH9V15VJuX
40474	payment	1397	1397	1678	1	1	15314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoSitb9qBhQ7YHtUYxfBYADRG7oZrkmJLPa2ZGG4aNq8BNEU3U
40475	payment	1397	1397	1678	1	1	15315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg7r4UvycAxLY2z7ZJ4dmtTi6cwNFjgp81T4sQ5wg3exn7iPp
40476	payment	2133	2133	1874	1	1	5275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLioJAQn5PWACkiAoPffWwyuzMBHn1GF4fykvuHx7zG1Xy563
40477	payment	2134	2134	1874	1	1	5711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfExLf3Vtce2Q35MF6D9oU8RJxENsWKvzEwkuNE9f66boQqg7
40478	payment	2134	2134	1874	1	1	5712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYReJAuJwD1ZcJbeR291c8wExZXMZ5zaH6Gn454adXskfdeCXwm
40479	payment	2133	2133	1874	1	1	5276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBD6k74paSGm5HLHVpPG2Fyw91H71krwJ5JFzGkdo2xasEXsK
40486	payment	1397	1397	1678	1	1	15318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhbxmTLNTZtjpbkgztVrJdUysLDURvzZsTKrPKbN5enH2d2eR
40487	payment	2134	2134	1874	1	1	5715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQtmBL4iMA7f9SJoNhGfJMF4Y91gGvAzbDaspW4ADdMPJevbN
40488	payment	2133	2133	1874	1	1	5279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXmgo7ntezuygwRc1ewtsokpzDWtipw3ophEKrbsYxVfQ4ovr
40498	payment	1397	1397	1678	1	1	15321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DxnfWkzg2Ho2bzwTVL1nmVbPhQmjgLrrGcnT7qbHeytBCgCQ
40499	payment	1397	1397	1678	1	1	15322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPhN4eLVtVnuiKHNbnoosxSDSpomyeL6Z3EojNSFVD9GFdKwE
40500	payment	2134	2134	1874	1	1	5719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScSPDZ1chEPLcupX4XCpCEckC3ksTP9ScXRiiabb2itHZgohZ
40501	payment	2133	2133	1874	1	1	5283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVt5pZp8Ziqa7yJMcXin96dmwC9DgJWLrwezT9dzFJmCSFa2Qs
40502	payment	2133	2133	1874	1	1	5284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8sLr2VawT8HX46EfJrMA8mNEKfKwR5q1x8C4ZY1pMduhQ4nj
40503	payment	2134	2134	1874	1	1	5720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnup8bhkpKnhKdMyJCj2A2JWERL5k3TQjDCG3awoQgFSTq61T
40535	payment	1397	1397	1678	1	1	15333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoYAReysEWwYViMJb325MKX15tVUMf2XnquZMWpZTy9yFufNp
40536	payment	2134	2134	1874	1	1	5731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaX6vE8rSTjrEDnU944TjbkQTUvarhc1yz7wLYA4uhNtKyUUkg
40537	payment	2133	2133	1874	1	1	5295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAyeHxSJntseGNzdYLSaLG9G3kHvohisTsHHqpPXJjR3tHTQiK
40553	payment	2133	2133	1874	1	1	5299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8z6njS7BoiVPjkcCHrN3ptWtheyAB8FPj7jUgNTm7ZbCSe3rq
40554	payment	2133	2133	1874	1	1	5300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4KooW7RKmHRwu8Sgvuxg3VWfeLYKbNGYNsyrDtEJgP5XhnbQ
40555	payment	2133	2133	1874	1	1	5301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFzALpLaLQ7Cupw771PateVWmYkusWYCxEL8Nk1bg25ZJaNiT
40559	payment	1397	1397	1678	1	1	15341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9LGsbnTMV8p9irgPp5ShhzYK6JKko1QhoMsAn7gbA18DdGBg
40560	payment	1397	1397	1678	1	1	15342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjH2tawoGEdvV11sRnaPcpZE8bXwynk5U1q7oniost78D6Z6k
40561	payment	2134	2134	1874	1	1	5739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLtVCeGhxzMiZ741H2jBBuqi7Wan9e3Q8tJBPek3AQAU6SoEh
40562	payment	2133	2133	1874	1	1	5303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43YzJDhAmpExwR2PohVZQLLHp7S8nVibJk3C9Yx2GduPBjYhN
40563	payment	2134	2134	1874	1	1	5740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cJVWzua69BFy4epnbcZZ4Yje3HVYDAUu5adLMRg3KWAf8A1S
40375	payment	2134	2134	1874	1	1	5678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ4tetWoUCh3jcBy7niWTQv4NqMCpS8kmdDasS8sT7J2asMdX3
40376	payment	2134	2134	1874	1	1	5679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwssB8hDUsdqwyHFnJXJswjxBt4dsA9UvA8rhVVXwrCWPomShF
40377	payment	2133	2133	1874	1	1	5242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkAeNQfR7SaVNsi4tbPJnVbgeJtYg65aF3MTj3Cx7ZEXWdWMyn
40409	payment	1397	1397	1678	1	1	15292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYViZDaEnepvspetNHfTCTKCHwV4spy8N7wFoAFtkv5WHZ5aXxE
40410	payment	1397	1397	1678	1	1	15293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9jYcv42C4T9UgWnA4qwyYTsVvtbtsZ11v6kVgHenNfnkczDg
40411	payment	2133	2133	1874	1	1	5253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTjcw15ai6PMfjiqiQRi94Uv68pfQEkLExxbnE7RsvpAQesj4
40412	payment	2133	2133	1874	1	1	5254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqfbN2kGkcQL1K9L6HNQCpLVLGQ8suG4jCmLuZYnmxkeF1QxUM
40413	payment	2134	2134	1874	1	1	5690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspTCacXXR4p1zn1jq89tiaHFjpsAjZLbMrTQM5eGduNJk9jdT
40414	payment	2134	2134	1874	1	1	5691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjwx5x3C2FVo2jbYRDPUSpBpqHgxGHvmFHj2RC6M4N7TNyumKJ
40421	payment	1397	1397	1678	1	1	15296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtVTGKMoPf9MJf2swrhH347LEkfUbsF8pVW5RyM75W7AjiTPd
40422	payment	1397	1397	1678	1	1	15297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8NncQRbmZh6AuVtJNZmzaynDMxkg5JoJVAaxaNnLLxq11G1p
40423	payment	2134	2134	1874	1	1	5694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypRHAAfs2cfNdiTNbDzbWcBoPNhE9kXjdbasJsgS3pMeHRHB8
40424	payment	2134	2134	1874	1	1	5695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuTVpwtmGcT5986FjdYXJq3XSgtyQbWAn2PQbQncPZGR59EUrR
40425	payment	2133	2133	1874	1	1	5257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UdTaeMH4tcfgN9a1EPZBRgmkVZATpQUhYbzPKzvgk3z2RCJB
40426	payment	2133	2133	1874	1	1	5258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVUT7BqEoVQybbS9GDZTHtzS25YHm4K4MWwyf3X2ugpvohwrZ
40433	payment	1397	1397	1678	1	1	15300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYHsHFEskKvTihBmmDNSK3WaG5Tv7psEDcfyvEEQMZUTPDJF85
40434	payment	1397	1397	1678	1	1	15301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHHX3FxjFBDqdrVFspYHi4RuTdYdwjzgXJaZnSxjmg5rbvyui
40435	payment	2133	2133	1874	1	1	5261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPUNLYxrASHMu7SewWvuhGeoPXRYLdQwXfq1ihB9jrPuy3bRi
40436	payment	2134	2134	1874	1	1	5698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGzAN3FPXcvE1J5irwadgaeTVVHheY1zSeXqSAhqpv1meCCKk
40437	payment	2133	2133	1874	1	1	5262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmmvmTqpZuMAMhFEoCKzaKNeYkkpW6s4uNcdiMcZ4EqLsjbB2T
40471	payment	1397	1397	1678	1	1	15313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAK2hnKuGUiWJYZNsuVfzrm8hEinNxzya6fRHSwZ8uTvKHpxPf
40472	payment	2134	2134	1874	1	1	5710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFHmUQi9Buxgoc6qcWSKQyX5eUUtw7HniDhHbHGj9ZunAz1MgS
40473	payment	2133	2133	1874	1	1	5274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4YnSDxq9rjffd5gxhRs9pToptcsN4cedSFsgxMaayZJ5pmgp
40494	payment	2133	2133	1874	1	1	5281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPPgkSRzjmSZiEzZUegkAsQv5Sss5wvcqCWUMrAHn3ygq1uyW
40504	payment	1397	1397	1678	1	1	15323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCxT5VGRBjhfQaTv1uYarwQurcS3kxwKpE9JpfpzfxNPwkw1B
40505	payment	1397	1397	1678	1	1	15324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1DG2Fs8mjg2C9j7jZp9KbTUL6t9yHBf3qWFz5aERrUjiJvPp
40506	payment	2133	2133	1874	1	1	5285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41mpBbZuJHKMM5iuqz7aaa8QveDav4SVLgzACvrmn87sj7ni6
40507	payment	2324	2324	2232	1	1	0	7980000000	1000000	\N	E4Yd1e1vqgZzrcUmS5XMqvrsRutuiaxZppt75fqnUuvxEY6JGDur9	CkpZ7jgTUWsgQRc92usE7jMjxT9T23F4oizi3Kmpw422vqu7iNrv8
40508	payment	2134	2134	1874	1	1	5721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCNos9mU8FbPL4kzy47iV83DxjmvnaaKWh2eZHtxwXd2WvU5Cr
40509	payment	2134	2134	1874	1	1	5722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVSBu8Ur2Xj2hNHYgxXLbJJyfhRbugXYhRf7ueTenGR5f9ZeU
40510	payment	2133	2133	1874	1	1	5286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCUCnJaQRc2WDu46df6rjazhaopwyeCQT64wDzBBCarUYMtvdt
40511	payment	1397	1397	1678	1	1	15325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuq52eh98h2v3fLjRfrNFp5gRjGJrrs1jVnGrhHjhW7vYHz4MC
40512	payment	1397	1397	1678	1	1	15326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbpeacdT3CL33jVZDBmPKErT7PAjBS3K6gJmG8tkqREEgYGsU
40513	payment	1397	1397	1678	1	1	15327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7htaDX9mzmf9RUfzrKi6XWWKjMwM36c3y1Xj9EhirA3keqF2
40514	payment	1397	1397	1678	1	1	15328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7P51Mki1eUSb7rrrdpw2LDyahpDSPLsitEE6BKtXfXELmkKKj
40515	payment	2134	2134	1874	1	1	5723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9XgAigRAp1pLnsyr1Szqab3xAaChCpqqCy95ppsuVttjwe1i
40516	payment	2134	2134	1874	1	1	5724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyx2tJfqokiRCr2hQjD3Zf4WEYSWMnKmWdUJn1m3YWjbCVSc2o
40517	payment	2134	2134	1874	1	1	5725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9gPF1TD7nX46DXxfg3EQuninDf3R4RHnY9uWBDYBdSE4BP2j
40397	payment	2133	2133	1874	1	1	5249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnkwQkEvUFAdaLu1v6KS5TDvT5jypZC4r7vo4zfmayENxMpZB
40398	payment	2134	2134	1874	1	1	5686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzu33WQ3RVLg5nZtDjVPTNj6wyZyJ7FMBHHDTNrMNp5HmecwG
40402	payment	1397	1397	1678	1	1	15290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCVKJygA8WNuzVBFqyjQvUykaRrH2Gayb6tkV17dVF67cv3pDS
40403	payment	1397	1397	1678	1	1	15291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2PTpVuyQeMUqomZHCmrbVTvHy33Y5cN1BV5PFmN3EYBCggAT
40404	payment	1159	1159	2232	1	1	0	10000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4yd2yMTowBtEfK5HMhYvPwJ7v3ExGs9QuMhjof2fT8WmcD5x
40405	payment	2134	2134	1874	1	1	5688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pBzVqtYYVZQ3JSrZMjhwqYe5kd2nqNFRjrahEkjNb1Q5uVch
40406	payment	2134	2134	1874	1	1	5689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurNRoGe5gr881yz5PPodUDmYyAZWRNHwuahn7tcyDvQBNcbbn
40407	payment	2133	2133	1874	1	1	5251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1TvnhMYD5BADAwXYAutg62nSUUZJAmD5Dt45brJKfScTRNYsV
40408	payment	2133	2133	1874	1	1	5252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eZQnhJd3D4WzSVQi1rTvLwwMQUKtNgq46Y7CLSbG7Kxgi4WJ
40415	payment	2134	2134	1874	1	1	5692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRw2JSmn5Zj1jjpat81DDA3Yazzf5ogeT7cZgYHfbQNFzDh9K9
40416	payment	2134	2134	1874	1	1	5693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcPr1sD74oSh6q8h62QZmAkwzvHYTu3RrYCLN2Uj7Ry4sqdww8
40438	payment	1397	1397	1678	1	1	15302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjspEYNSm842ziGFy3QTYpGkawZKZ7DMGBKP9TQNcT4ExfXois
40439	payment	2133	2133	1874	1	1	5263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd8qDDpfC5ZUB8ikU69ABaZRst72bA4keauw4saMiP2ZD4QZxp
40440	payment	2134	2134	1874	1	1	5699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzbctgy3SbmiDdYderrhE4ig7p24m5PE9WEsySPcy9tUmHbGgM
40447	payment	1397	1397	1678	1	1	15305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS5WiE6XmdyNUBpvp7PAYzLrDHMcQw3iFk3upiLxjYD2VGgAux
40448	payment	1397	1397	1678	1	1	15306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1sojqxkkJTD8WxHtgjhwwyMCWgjNFEe6Kvo6mfJeemuZ735PF
40449	payment	2134	2134	1874	1	1	5702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYuMmUpq12o2a3xdSijLLUt9KjQoj2YULzkh6FUagwwMSFWhjP
40450	payment	2134	2134	1874	1	1	5703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjyjjxxSujwXvne7bCxdDVaHCHJcZAdYmqWCeEZmdtc2EXdEE
40451	payment	2133	2133	1874	1	1	5266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWu1pq9ca2PNKVR71VqWNFPNxD1b6Vq8HNh82of1PAPHCQUa2c
40452	payment	2133	2133	1874	1	1	5267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Mn14jEgfG9BD7eGXKKLoY1TVsRwkQVrf4KouY5JwjaXf6F8d
40453	payment	1397	1397	1678	1	1	15307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUW4csiTN6awN7qNXnBAuJzh3JZugfbVpYNryuM7zZZctJRCt
40454	payment	1397	1397	1678	1	1	15308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1fuwE8MaisZHN8MXK7izMsH2ANdEyVrFEsFHPpQF3aC6PfaN
40455	payment	1397	1397	1678	1	1	15309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf1sCkQ1MJprTeB9nSD9rb8XRWoss3G5UFtpXSTAfr6WyBtRqg
40456	payment	1397	1397	1678	1	1	15310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZghd8pyEguFHvfg1KyyRkbbRF5na9vH9hebNU57bnqhhXFPm3A
40457	payment	2133	2133	1874	1	1	5268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjvc1c6rdtonwfeTZXp5o4JrGGxKYm5TaWv8J1WKRi6vtjdpt
40458	payment	2134	2134	1874	1	1	5704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqF598BPUuh9ngxemSJ2FgU1EYgoEkKEYxCy53UjBNdp5AjE9Y
40459	payment	2133	2133	1874	1	1	5269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkGtDob2tNTjxUvftg4nYuYzJbLdorzitqtSs7rGzYVnxdSNV
40460	payment	2134	2134	1874	1	1	5705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXznPxATjRkqkRuWy8QUYoC81xM5pSagbPrvnfpscRwwKAJ3Gf
40461	payment	2134	2134	1874	1	1	5706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrj9g8qyPMYJTf7zcY4g8Fhke8MZFQfnDySbWGiYzA98vvWNr
40462	payment	2133	2133	1874	1	1	5270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGG5NBDngM3BeJnbvmxRVpjMd1BjqdS3GKrPw21qJwjzbnnJn
40463	payment	2133	2133	1874	1	1	5271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hk1mxJJVdvG8PbRVANoqFm2oWJSvu31nVYGVPo6fgXAuijwJ
40464	payment	2134	2134	1874	1	1	5707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE34YQmpo7UyvRSqGsw1yJb9hZmeGgue4w97ncS3RcLoCSMRft
40465	payment	1397	1397	1678	1	1	15311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWREgTQM6sxyBzx5e9zTFKvghMumi6rWTnKzVMoSK6AcsiztQ1
40466	payment	2134	2134	1874	1	1	5708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDYgFNqeQsvhm4Qi9mDR4PfFiwtJcwX26xWEJTBJjDMPZVWao
40467	payment	2133	2133	1874	1	1	5272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWdSS1BGLrukSaMRaeN3JiwprVNXQSdK9xPwivBh4Ur9ZM8Dz
40489	payment	1397	1397	1678	1	1	15319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYESp6yA2Zo1cfT4yXRiKap7sGRNEyiVYpu9QGW8cVZ9v5xMwN
40490	payment	2133	2133	1874	1	1	5280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCz28MUSvDBW4RfSKy1yK6GTWzq8SyqTfy4UxEHnU86qu1VcDR
40491	payment	2232	2232	2324	1	1	0	9000000000	1000000	\N	E4Ycxz4E4dR5cxtnk1Qj7tkYy116G3xif23dhXPbQHhsuLv514mMv	Ckpa1GhthVXi8xNYFUyQAkSbhx5b1wUb1KvvP6VbPuqLzY7HFGyc1
40470	payment	2133	2133	1874	1	1	5273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbsfNWZT8yXmUQt33WPPPmgmYV5XNxm1rZVToJiXyZ4KNot2ej
40480	payment	1397	1397	1678	1	1	15316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjZ2MKabCG7TksqBzazZivKnzsBxqPfpHZn4kFYLie7V3S9y5
40481	payment	1397	1397	1678	1	1	15317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYSn2SpoXj763csZ8FeCgRXS5m8FA6en5bBsnvuuDaoLdNf3Z
40482	payment	2134	2134	1874	1	1	5713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeEdHhbZcNn6goycUSwLmCxaYdpkrzchzViskdPwqbkXfXuc2
40483	payment	2134	2134	1874	1	1	5714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvame7EspN791x1iSahX2X74eC9Px5Lh8GYy8F2ZwqmMbzxe1U
40484	payment	2133	2133	1874	1	1	5277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSP3DybbphE9vJsutJNq6exhUGe6cs9xzaXRW6Np3jSHcfuV1d
40485	payment	2133	2133	1874	1	1	5278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqpmcCwuArVxPBtPwE84TGz9b19o71Hi22sfZt2t3yp7nHy1E
40493	payment	2134	2134	1874	1	1	5717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpXdePfQ1sW6UmzmHGQFnE9iiejt33ShHEtyRNHs7QKheVJmNh
40495	payment	1397	1397	1678	1	1	15320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTjGK3jb7pH2rV9fqX3YEWC6NMzcBcNDUGjw3RKNMpMgMXiXx
40496	payment	2134	2134	1874	1	1	5718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgR7d6YgvhNo3D448hPJrzYZYyYf2SgY7g2nhUWPqtTsrpiUWS
40497	payment	2133	2133	1874	1	1	5282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoW5ExNBhs3vCs9kwn4pwvS4PdQrVD7CWEQ1zHsqYd8wJn2H9
40529	payment	1397	1397	1678	1	1	15331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkcBnXhAAmfd67UqvQWJNjVHuVScJxicqK7rgNEwwyDy8nGHCf
40530	payment	2134	2134	1874	1	1	5729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd6gcUJrY82sWvzEwRU4vL9JxkTUPtYnXHNZpWXRizTPATkge3
40531	payment	2133	2133	1874	1	1	5293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCHB7yKGdu6qQx1ACyguVgbUwJg1icvi5joMmuFS7oErgKmck
40534	payment	2133	2133	1874	1	1	5294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgGWnr3iTPcoUfi8UjqV6y9ckwEGLwMdG9EHJzWpGkYmS6mjc
40541	payment	1397	1397	1678	1	1	15335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4tYY1SgLM6GUuKkhukBfwrnDra7qDJgqepsxVxFaxgoj1dPEf
40542	payment	2134	2134	1874	1	1	5733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLdL1gpnJwcCXLLwbv71kCfBwRc9y1GMPG5mSLDb4DcFiigan
40543	payment	2133	2133	1874	1	1	5297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTmyhZGXSqyjsvep4eazDLt5LYG5UDzasU4hsw4Ai6YKyehB6
40556	payment	1397	1397	1678	1	1	15340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjScf39szeYdGzA3RurjmbK6RnseZBajWwzTGJirXjzPVaCdP
40557	payment	2133	2133	1874	1	1	5302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEkN9EgshZxMGSAM9MhDZR6F6XLzFfaGEfSUsDMxENahVeuYgC
40558	payment	2134	2134	1874	1	1	5738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJR8bR4jHUKeBEZqTr1ozrAKsDZ86onoLhkjq8ckpXXS7UWmra
40567	payment	1397	1397	1678	1	1	15344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4empdQpoMfA2N7M7EM5sDUrveG4yJboCB3yqdu5aJEbWVURfN
40568	payment	2134	2134	1874	1	1	5741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtbBkX3QmwSFG7Yt8iPzXXJxwvNmw9jiDcwKtEZU2rDMvqKCp
40569	payment	2133	2133	1874	1	1	5306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGC3sFGhjfnwLrTUJbo1ksVmAUBLzJ3N3SzRrjSFd2xMc78sBL
40589	payment	1397	1397	1678	1	1	15351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRPMtXps8874udGDins8k6mQ1AwB69BUocmRdxEjbHa9a75mx
40590	payment	2133	2133	1874	1	1	5313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoArawhiSxy7f9MEVvirRxowoeapCDVGy9xE1zv3US5Rc7MhV6
40591	payment	2134	2134	1874	1	1	5748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLH564CdE54jUzdvXJRL2XtWzzipZatTk69W1dZMn25acAuwPY
40592	payment	1397	1397	1678	1	1	15352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxz5xZurnykaUWNQjqntGMCfo2LSm3rMG9qdgZwf36GVKsLy5
40593	payment	2133	2133	1874	1	1	5314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLTPMVXJEcE2jVffBjRzzPFWTc34dTGcUtdKcffmjjFLd3nPa
40594	payment	2134	2134	1874	1	1	5749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGamEZCHTm9eki1EswgR6C28qHfQ3u3qEyS6VEsRwGtiqX4cff
40614	payment	2134	2134	1874	1	1	5755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhX6DE85k2sJECNZKjUvLfHpFhavpL3UXzSFo8qeC3AMJn4Yka
40615	payment	2134	2134	1874	1	1	5756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3VfvxxVdSkRfNuoMdk2cedpC9T6736iPmYXMfnkqLCjgUZj4
40616	payment	2134	2134	1874	1	1	5757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVUJDvhZfJ9ZHZRwJRjrF4S21L7rpDjLC7eNBzzKRz2J1EmH5S
40623	payment	1397	1397	1678	1	1	15362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t4Gyru9U659TK5WGKQRSkURaCoM8Jw3ZUZuhFwAiDUGdPteM
40624	payment	2133	2133	1874	1	1	5324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWm9rDCUzUmMZtkMMjQ3KWvEzLct6CU9yJHJdPfWY7vGpkW9Zo
40625	payment	2134	2134	1874	1	1	5760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9BzfmxPsHhMaYwZbWsNhqHhMwCLdj6nYr4oCVBXWAvjS1e4Xf
40638	payment	1397	1397	1678	1	1	15367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7byt1ZLakQKYCExhAbZzUadzb9pWt1W7bB8TExke2iQ24BCc
40639	payment	2134	2134	1874	1	1	5765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbNoFGW7D9vrJNqgJp5nJ7dUFurdqDgr5aZtsgSEeSxQ89dGa
40492	payment	2134	2134	1874	1	1	5716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4mgziCTq5Toy6Hvde6xZTHG3XRpz87HtZh4NZnzKdRZDT39Kr
40523	payment	1397	1397	1678	1	1	15329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4m79dH4ZbUHkm8iTBfpgox4JoUK2jrpXU6hRZ2YuBmchkQ8W
40524	payment	1397	1397	1678	1	1	15330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3HED6pwq4GNTa5pLPzCrEThWvBnoreQNjfrZrxz5kA4UAMuD
40525	payment	2133	2133	1874	1	1	5291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6qWfksvhgskoDgBYpLfXvBdhmETCpjWN6T4wUmrhrSiihAyg
40526	payment	2134	2134	1874	1	1	5727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3CmKora747hTyBH3gHQdBRf4eVioVKEddECxkBw99iCSMQWe5
40527	payment	2134	2134	1874	1	1	5728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbJV8W71WctMH5fNgrnjEqocwWnX5xWxGQE5WWaDjArmWrmpoa
40528	payment	2133	2133	1874	1	1	5292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmT4pzHPhCWtBeVw2CXuSDKWHUWoZHmEGAnBEio9HMEX3qfmrm
40538	payment	1397	1397	1678	1	1	15334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQcduebb41ocpkA228uqZfAMtzpQjvGHeYUjN4XEHXgU6ZD28
40539	payment	2134	2134	1874	1	1	5732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXcSSdAJv1qbpuSPnfLRMG113dCW4vheBocMvA35QZpWqbEBB
40540	payment	2133	2133	1874	1	1	5296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkseQeonBQDWHtQ9ov78qGaKva1mrvkwv7hc33CwWtsKR1Hg5y
40570	payment	1397	1397	1678	1	1	15345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vSjPpevXQT1fcjhMLKhog8BAg1zoabLuTNbmMwvpVWEsGEsc
40571	payment	1397	1397	1678	1	1	15346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa52tSy7tRotp3nGoHMwyQ1XX4m21poV1SuF4oAo37MzQnmCQDj
40572	payment	2134	2134	1874	1	1	5742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLJaSpvKA3QFXi9NdJFaomfEiEK6rAyA8nx9MAU46u2zJcxKL
40573	payment	2133	2133	1874	1	1	5307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiByvM1VfpFkTB9bZJPE9tCeQYva9dUxGAD759biwzqn2ztbi8
40574	payment	2133	2133	1874	1	1	5308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYToAZ9mxYfPLQhXF1igZY65moNN2AYf7YY1E1yHkc14ftmgdLu
40575	payment	2134	2134	1874	1	1	5743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8y5NL8wrgW5zmEG5WMJshMLZ3TbNjs1vBAP4XDeQnkMACdEuo
40576	payment	1397	1397	1678	1	1	15347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpBjSHTfZaPvKkbDwkugHifPUMZtQMByUTqbyXD1QJ2FnTKVP
40577	payment	1397	1397	1678	1	1	15348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVdG4qbfMJyN4CaS5Cz9LRHvEyyMWiCmqcfLgdAwbxBT9ptzCh
40578	payment	1397	1397	1678	1	1	15349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6Jf4UmcAkpnDy5t2FDgFfqoqycS8DZDkNxUcqRqWWirLVV8L
40579	payment	2134	2134	1874	1	1	5744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9i1ubYDyTvC9JATaiWqtpkjF7MGFXMX13bQyP19pY6YrxFMR
40580	payment	2133	2133	1874	1	1	5309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJaT1uRV3HgeJ5LRTv1t51h9KL1Txdqdmr7rBd41unTHfZQemE
40581	payment	2133	2133	1874	1	1	5310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRuFm5NWJVKAThGgHiAWZgnEUCsTKULdAPM22uyjhrLyuVQzUH
40582	payment	2133	2133	1874	1	1	5311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRejgorFuQPUGXf77MaTh5S5rogjEHbDc23waP7wGNVtMAy6N
40583	payment	1624	1624	1764	1	1	1	721000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtNcBW4Zn7HM4DYqpWgcBAn6Wx2im5rrNqsMGr7gddtdn6r22
40584	payment	2134	2134	1874	1	1	5745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9gLfBZoLoGDkd1qVjJrwv7f4Z2pwzerLSRmfgkRcgyo7wQqi
40585	payment	2134	2134	1874	1	1	5746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9D5qz9pYrpYgeUKadndTNi6CCDwCrTqGa3xHi2TSGEj7fmjPf
40598	payment	1397	1397	1678	1	1	15354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2teXQmSjMSyKtFNh2gGYKrrdwtJcBiUJrzP26aDo2c8sAWrF
40599	payment	2134	2134	1874	1	1	5751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzebBz298LBd2MctBR2kfZPVfJQ6DSj3UNVL9Vrg7TqrZUGMY
40600	payment	2133	2133	1874	1	1	5316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSo9wjKeCCmEwmnQ2RyoBnB5TVrEeKzmqfaVmB32Yyb7oMuGvE
40629	payment	1397	1397	1678	1	1	15364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyMF3LxYyaG8ECw59yUT9YKfHnC7QFFYwWdAs7u5Ax97qhVzPw
40630	payment	1397	1397	1678	1	1	15365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1jJQr7xHN9r8SomrY22LoFxSur5PuFGWoNpbEvYyieGz6Gekv
40631	payment	2134	2134	1874	1	1	5762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9J9RjdFYhzqTTy33wdFq9WFPzyeceMX42HAsEJRCur57Q9nJN
40632	payment	2134	2134	1874	1	1	5763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dgwqTPec2PSdjZ5xB3z9d9Rfr5ni9RPwHEoJzCzh96cFefD6
40633	payment	2133	2133	1874	1	1	5326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC96Hp1ea4yiAKmSCbh5hmP4ehwFVm3Jd3nBgjP6PvfLFTpxe
40634	payment	2133	2133	1874	1	1	5327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLtTSN6BhDDvt1Qvpo9fGpM33gx3s8PwtNppjc17NKH2YAjiv
40677	payment	1397	1397	1678	1	1	15379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4kEfWGirrgqPKoriqpRV7bf8EDJnNdVVjDNbbVR5V3MRg66ki
40678	payment	2133	2133	1874	1	1	5341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPhvYYRvWuYVfH7TocaKxZUXFxvtKGHPv7PvSKyKXe1EjddM1
40691	payment	1397	1397	1678	1	1	15384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzpdYe9sQzRoQKujZsMJGw2sQGYEee8yUnf39Nzo8P6hyrbX4M
40518	payment	2133	2133	1874	1	1	5287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfLT8cN4ypEZC77HoaaQ8FiU3x4Q7HJck65pRP86tTgcWzVGQ
40519	payment	2133	2133	1874	1	1	5288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqxxmNuYy9Z4naGkPBt42RELWfDzDKY1xqU8ERaaEtQEmsGZ8n
40520	payment	2134	2134	1874	1	1	5726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMuGoh5UbnuqPMuJvAhTUS9fWq2PgJ3qFmqiyp29Udjuhujaw
40521	payment	2133	2133	1874	1	1	5289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8McSzzLc3v8Q8xEepxrjqNmJ6P6fmktz6xyppnKiTik9XzqWs
40522	payment	2133	2133	1874	1	1	5290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQC8acsVg6iZHUKjtqnCuX2sEYpSrnkZCWESaUNgsZcGWMYef1
40532	payment	1397	1397	1678	1	1	15332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfYpj1JqJimEUY8knNKjNSpaeWKMwpgtPQiBcwkoq6LhpCBy2
40533	payment	2134	2134	1874	1	1	5730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa132i59w7Q6vru7W4HLCHvD7XiHR5RX3HJn7VjG4efNsN76jDE
40544	payment	1397	1397	1678	1	1	15336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9rXJCyk7ZHpETAZvimREdPfJHQKgQPcTZC657Hn2FKxfJV1C9
40545	payment	2134	2134	1874	1	1	5734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuyXLERiWjpCYGZ9s1qubGQYNNmJ284gPZhzdPjJsoxjmyuuUW
40546	payment	2133	2133	1874	1	1	5298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnL9YLhBhr7TXfDuVTTpzgaLTc2HDyAsUP5E5KTYfJCZdhGzh
40547	payment	1397	1397	1678	1	1	15337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8PV77XWJ2qNytoxN2sZ1afMT25PdXpC9aE42ryfXS3fGDxra
40548	payment	1397	1397	1678	1	1	15338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Aa2f4zZYwHZscAZqp41VmQsfZYLWS97TML3W1gtV2gHXNRpD
40549	payment	1397	1397	1678	1	1	15339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDD7UQ914ovrSADYW4ErLsrHAkAD3coNhNNEZMbVM9ERYLG2WE
40550	payment	2134	2134	1874	1	1	5735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwDae5vLNx7KTN76F2CbygyzQzEDwRMkst646gciuRRRr4FRTK
40551	payment	2134	2134	1874	1	1	5736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pKqovZAg8F9cAHtrkmvLiBz81vwHMaVc7huidp9ox59iLc3L
40552	payment	2134	2134	1874	1	1	5737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJijKqGdJVKEgTT8a1cg5sXiWLdUc81K7tELR4J3JMP7esrRYj
40565	payment	1397	1397	1678	1	1	15343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPZuQgP6pHKyjy6hq9J8AAsS7xe4HFKYEqc2CRW5UWrfRgtF6
40566	payment	2133	2133	1874	1	1	5305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqGRSvYQfxSe4hpSdYNkfxxvhvhRK5dibAw4hdSUND4L18Ffb
40608	payment	1397	1397	1678	1	1	15357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi9EJ5h9DVhBW21nL8MGKjNnEUdgQuNwDgmgSg6BsZ9k6JSTUb
40609	payment	1397	1397	1678	1	1	15358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tjP6BT7WdSozmobXFYiwMxDr9kH63gpyWRXAwX7FYTWdFmz2
40610	payment	1397	1397	1678	1	1	15359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg5JJ1v8sTwat95np3iary3r9v1dTnar1wLQAu8uXWWc4G3tJ1
40611	payment	2133	2133	1874	1	1	5319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiRz2zBY2rJwrWj4FX6Kma8KTtvSCafBbGWMpQzkJxEXRLsctD
40612	payment	2133	2133	1874	1	1	5320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wJ91nZtVYH1xCWgV1x2ASYCUc1jKsCTVWCGVqeWYFE2byQw7
40613	payment	2133	2133	1874	1	1	5321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqnpo2958BMYSLtiLWUErxEti1eZhzhr9jmRruoEjdt457renR
40626	payment	1397	1397	1678	1	1	15363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbK8j5zbyoGH19Gpzhgh6Pybw2c1RTbr97rvbvQr5pNowMRvY
40627	payment	2133	2133	1874	1	1	5325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLxtjhU59hfzefC47EtnEyMiCaHwASxPPStNo6uYmybkmL4gM
40628	payment	2134	2134	1874	1	1	5761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1AmeiC42nkVMNPPUAHcrUhAdYuetxSVtRLuUotHVKJ3Rwzyc
40635	payment	1397	1397	1678	1	1	15366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ABnzciSJjH3Eyx2fui6iNHxwBVojLuGPqE5JUXAjCUyere8p
40636	payment	2133	2133	1874	1	1	5328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeVgGrL2s5RttvDa8EBsMpr1NmhavD1fY5BrdTzyS4X91m3GH
40637	payment	2134	2134	1874	1	1	5764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABKna1CQVvQnLeRjHD7m5pK4m1JWhBLW3enJgjb9eX2XybvdM
40647	payment	1397	1397	1678	1	1	15370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQ32virebomyjNADSSpZyHiq2cDBJHAWwBivkSLGK5iUD8kVo
40648	payment	2133	2133	1874	1	1	5332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzkdnLAbUgD6zv6tcykpRcEmvPUNUbhH1fs7vWgZikshdB6by
40649	payment	2134	2134	1874	1	1	5768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHxcVNNzmezX3mWUN3RCXYxpDKnGVWxbkSN64vWMcCuVvPCfi
40659	payment	1397	1397	1678	1	1	15374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGygTQa5MZnBMR1AuxC3JKTLqCnjuBvdCMvPzmDFdx3F9hxKUW
40660	payment	2134	2134	1874	1	1	5772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2vVBtzDq4qkpQGhezouxXBDcKzv3VdALBdcAjRUAYeUmgWfz
40661	payment	2133	2133	1874	1	1	5336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh3opM4gKUVH5Hr1WFXxPeLfEN8Lm6Nc4PwP1TDa2ePTkM6wZ
40671	payment	1397	1397	1678	1	1	15378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9A4XNXC9PRBzcoKmRPJfpN4EHGNhHcFuMHNyD65CKLWtQ3pc
40672	payment	2134	2134	1874	1	1	5776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdg5tBYn8j8vRj3JDNdK2wHSn8qLs8NQ1W4xJse8z6xfkZxoW5
40564	payment	2133	2133	1874	1	1	5304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCDJZpYeo1QjzJu3NsTtMd3mK9zTPVYotaXusS6xinb15xHBT
40586	payment	1397	1397	1678	1	1	15350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRtkznEsqyUm8Lp3f4CrVLzsFEsAue7psUTSWw7iAyqGLPLXn
40587	payment	2134	2134	1874	1	1	5747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggasKZdZpGMYDu1p3JeUYCfP4vYAGtSNHmWjQo8de3yxE1zBY
40588	payment	2133	2133	1874	1	1	5312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqjUR76sk9agBEWhBuENbdE5Fy7sUosjvELNiB9aYWLHYgnxs
40595	payment	1397	1397	1678	1	1	15353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiSRaHsCekPGVvsBFQtgfw5CePSavZQdeMyh3Vx1KV64vTHQ5
40596	payment	2133	2133	1874	1	1	5315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXMGbeHnBYds7b8hiJXyS67DFLUdBxnynRiBH3w3FSbpeXNMc
40597	payment	2134	2134	1874	1	1	5750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGLWoDGCuzCC5LnJtJExHQmPLgLTrwEmDoK6VPKQwkXXSX9CHd
40601	payment	1397	1397	1678	1	1	15355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJeujMikBV5QquXYpyzypPsA8GwuLPVakZTYdHN6zz2rwnEGm
40602	payment	1397	1397	1678	1	1	15356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYWNZrLxQRYb21gpY3nZqhpZTzEZ5xZp3yG9yFv2GdzNpqUGH
40603	payment	2134	2134	1874	1	1	5752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJZ8dApMY7ydyVuUzXAWTFUCxvf69PNwheF1JSuP758wkrrfe
40604	payment	2133	2133	1874	1	1	5317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwVDEjvbXrfm929igRa8CNNWmxtBX2Yx2kBAamM4sjvP8CQK1
40605	payment	2133	2133	1874	1	1	5318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXW96BDiF7s6MFoRGZFNR9Yo2AHtyKvPG7tADaF5TWX7EAtqp2
40606	payment	2134	2134	1874	1	1	5753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFURUopdDE1Xt4E4JQq5S7NBNcGGpBJtTHiEBAuAUHBVwqdZdy
40607	payment	2134	2134	1874	1	1	5754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsrQPikGvZGNXAXUg4gc6tsKEtwsv1kwW6EEuxYh6DpMYNQyCP
40617	payment	1397	1397	1678	1	1	15360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhYkFoMT55kFhtcU9zuPhuD62UD5zwvARiTihWA2FQE7xRCor
40618	payment	2134	2134	1874	1	1	5758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYxUAAGknCSeaawYG6equW8tLwaABxBk66aDJpJnaD8pngRY9b
40619	payment	2133	2133	1874	1	1	5322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc4Mu3QDnPydP4MFL64hVokwd8rsuYDycsEf7V4WzyqXQN7EUd
40620	payment	1397	1397	1678	1	1	15361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdXjs8ApxdVC3aDV2Qap4epMqQ5x6pHadtustrito8sE3oZSN
40621	payment	2134	2134	1874	1	1	5759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatLAwW3VSskdEpXPJE1mPhMGCt3BNwPae5uHBUpGcAA9S7Ysn
40622	payment	2133	2133	1874	1	1	5323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5gg1KWwBntiRJqDnPAUWtrX3eEqw7QPxt8y7kAKN2ZEbZiAv
40641	payment	1397	1397	1678	1	1	15368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaEcxCSPLMmNWxDPgCHQTK1QPjQQzV4rFDGbavcMDPsXF5C49
40642	payment	1397	1397	1678	1	1	15369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uBRWK8EzisT3K4p37hxWPLTbLkN2pYwV2bkJkVXJjewcfDkR
40643	payment	2133	2133	1874	1	1	5330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxRdyPtMdGMsXGPQ9higXTE9Ah123hDgNS2qCMMYYKJaBnduF
40644	payment	2133	2133	1874	1	1	5331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4cYc218AmvqNy3FKu7oqrymeg7G3r6dY4GFT4tkoPNkx4H23
40645	payment	2134	2134	1874	1	1	5766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXUqT4BPg2xtmJp6Yhc5vddM5PoHSHF2Nd1oaeApbPZqjeE24
40646	payment	2134	2134	1874	1	1	5767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFbv3Ap2LuVJCbit4uFYfeL74ZKsNaoyKCunSpAXkEwx4vUod
40650	payment	1397	1397	1678	1	1	15371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkNBkXTzcfjbcCSMchGFNeyeBSVTZadnTsN86mA1Y5wfyagkZ5
40651	payment	1397	1397	1678	1	1	15372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkTm4bHpinQedPcToKtW5EfEkxYnPVkBk8H3iBxS3i6i8Vx9M
40652	payment	1397	1397	1678	1	1	15373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc18DE3j37oswiMLTpbbN2hkx2qSnosT4BgvVU58jK1G99QEP2
40653	payment	2133	2133	1874	1	1	5333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtHZi28WC2Xr2NuKx3vFeJwEwLx8UxoRGJVXDmTQ45dYmXT3st
40654	payment	2133	2133	1874	1	1	5334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm4rwy9GkWAFeaafNezZbMUpJSxebRzPsaRuCKELwcTGQoJj34
40655	payment	2134	2134	1874	1	1	5769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmY1KqoP4cqrzJpQ5jeZWtZTAVehu5iQoo6bGvANoChSshoFsm
40656	payment	2134	2134	1874	1	1	5770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpATTMW317BBMnwMour85ZUQxkyBSWKFfAo1crYtuwDs1i9ThY
40657	payment	2134	2134	1874	1	1	5771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNcnt7EmnxB3gmzzJTgLBmKBL8cKVxRntGvVb8n2re9e8Spw4
40658	payment	2133	2133	1874	1	1	5335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqiQLZsrhcdXF2CFV4Vy2yJoTdrmNzp9UbWJEhqgo8naDWzynz
40665	payment	1397	1397	1678	1	1	15376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRWoQ3E7gxUYvXua2CjBqadAySi6Lca1vMsdJczsxGiZH99hf
40666	payment	1397	1397	1678	1	1	15377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8bgJLoEAbVqU9nFgi7mFem5AWF4fV43pVTNhfHjqD1A54k6kx
40667	payment	2133	2133	1874	1	1	5338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhTvT3UVZXtSttf8kS99SiJUwEn7GEeth8o6H78intE5nUB1p
40640	payment	2133	2133	1874	1	1	5329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRipKuzcwvF97RF6HB1GsQ8dEXUTcs9dWj5RXgDo4jnDx75YuB
40662	payment	1397	1397	1678	1	1	15375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4yN164SbAprfDxJNc72UJST4vpdqf3c5DLjkAw8dCbXQhTZ3Y
40663	payment	2134	2134	1874	1	1	5773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwmnfj3h4vN6L7HR9VxQf1TX5Z9bXEhMCR3ZwXPhN3iQd6eEB
40664	payment	2133	2133	1874	1	1	5337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aHvLdq3baDFVh9J2SzfhZkMpAg7eDHqryPjcsVFLAiqhfTk5
40700	payment	1397	1397	1678	1	1	15387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVEHc8ZRwxfyttNegGwHjp5pr6LSi91w6FEGFnMKsCnSAGFN9
40701	payment	2133	2133	1874	1	1	5349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBvKBh7cregn9UCGXH7Y5UCbKBnzQyPwmHG324DYrfRRGHA6nC
40702	payment	2134	2134	1874	1	1	5784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuiHQdXusetYmjDawn1cem2Ujp7WeXzZdY9e77GkVziLNwgyhJ
40721	payment	1397	1397	1678	1	1	15394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYupgZ7YiwX4LR2QWgRrraZPcLzB8epj1cwtRZ6rGBrigqdKyYs
40722	payment	2134	2134	1874	1	1	5791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDEeHaUEr7rjyZRBGNXguVAhm3Mu3j1iXY7HWA59YGpKYCEjd
40723	payment	2133	2133	1874	1	1	5356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZLj4MMW3UysULgz6tnGwYGk2m7JyNAb7imNeZpVdfrGH9B91
40724	payment	1397	1397	1678	1	1	15395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfWogvZyhVo9ioZscwyL59u1UCyaexvmQ2HxyfveHHimxTUig
40725	payment	2134	2134	1874	1	1	5792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcED8zzZ95Moo7A2M6oAvqnyJ1KYkanqpwCgWLpH2PRUyWRtNq
40726	payment	2133	2133	1874	1	1	5357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zyETMGxddzTAKGmFxuW4KmEKTwJisebMjayML3n3DKLM1YRA
40771	payment	1397	1397	1678	1	1	15410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5wcTj7A2CZs1PnXbJNZYgeCiUZRdcJTwV5DgGLRNM3R9t8xh
40772	payment	2133	2133	1874	1	1	5372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6BcFMDNYdbSC4nu7EuwzxM9rYsJj7DNocydfX5r4qEPkLL5Qq
40773	payment	2134	2134	1874	1	1	5806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7yQZq47uHNa8nK2yQJFavAhsLmvQ4p5t3Au2wkkKG4z9Z6Dp
40774	payment	1397	1397	1678	1	1	15411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRqqY5LeX3aq6WAmBozJ5eeXHbVGh3auduUyVEcwFFNUttcLL7
40775	payment	1397	1397	1678	1	1	15412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBY1391SYsXaZY6v9DHHkQUTGAKX3T24nTPVL9bYHuVYGK5Vfu
40776	payment	2133	2133	1874	1	1	5373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbSf3aHLuXTGgP1qZSzaycJaRi1GC5Va8Uo2yavf34mXvK112
40777	payment	2134	2134	1874	1	1	5807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHhuyHcGNiPrrRLn5jaAqv6694Ve5CUemLPRrBpfVR2HimNYp
40778	payment	2134	2134	1874	1	1	5808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQpiViiMNy3weAio9s1FbqdmdP4gBDZgfuGkUVkuhbcpmkQSN
40779	payment	2133	2133	1874	1	1	5374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE76X8p4zJw73cLWHn98bSVg43R35bYKUTRrKfxjT8DM5VcPHB
40807	payment	1397	1397	1678	1	1	15422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhsZ15NSDcSrRrnrMAmxRooxZYt8JRNKtdf8yRpDMKqC6rGJU
40808	payment	1397	1397	1678	1	1	15423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe7hQPBG7cuGcoDpvoe4ZET4gaNYFuk9zHEm62i2FyQxZkd6o9
40809	payment	2133	2133	1874	1	1	5384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Wq8bq2A7a9fNSkCRPQ4q4jwSBx1aTCxABohYxpMQV4ZYbgjM
40810	payment	2133	2133	1874	1	1	5385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRETyHxui77P6K3KJw9tW1gzLX9jogXMTcRg4AUC5ecaKmeHe
40811	payment	2134	2134	1874	1	1	5817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQKTKVSjo88WRBUbKt6EJk4WsBMgbCQ4h1b6yg1zHgkY9APuy
40812	payment	2134	2134	1874	1	1	5818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYLFSMPonP6cRk8t6rw8K8vMRUPkhdwH1mzm3VHPURFL4L11Q
40813	payment	2134	2134	1874	1	1	5819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxtaLUqCNFfy8ixhwCfvNaWaiEXqgano8qBBoERHtPj72ztwT5
40668	payment	2133	2133	1874	1	1	5339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfxxxVKRQiBYD7mLz4Ne8Zk516T1Mw6B9pePisJDthsaUEXec
40669	payment	2134	2134	1874	1	1	5774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLe4dYTmvhw6gVzXdthNpRnXy81YwAATKt2ue5yBpdYsLAmj3e
40670	payment	2134	2134	1874	1	1	5775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1g8sZRXQPk8edh3CGvNFUgn9PRmPLqXQcAyFEm1PADKV8Y5tP
40679	payment	1397	1397	1678	1	1	15380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBK1njvz9EpHaFUPhMQvz5CtcrK1xERpAJqmwmPV3JoDSMqBPi
40680	payment	2133	2133	1874	1	1	5342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3te38qD9WA9iDm3iq7YQuW6aB7hFyXhC9yti5D8EEuGw9PXT
40681	payment	2134	2134	1874	1	1	5778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahL6v9aWKJWhdLYsRuAUwuws5oXYDdBV4koF26ciAVvWdn9oW
40682	payment	1397	1397	1678	1	1	15381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GKzwDkH8QWdf2d7t9pf34uQN5jctVpirTFFoYWq8GoSgZaUq
40683	payment	2133	2133	1874	1	1	5343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9im1ciuxymf3MrTWmimqNqCK9tV3WgQDpopAjvGJyRXK5dar
40694	payment	1397	1397	1678	1	1	15385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1E2Df735bCVD2iZ2CdcTFnuSzNhAUhiBX8sKt5uCBiiRrpaD
40695	payment	2133	2133	1874	1	1	5347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmaaS2PYVS8buSmW6ahBq39y5VSCuLVdEMBpVEwRsCdtKcSix
40696	payment	2134	2134	1874	1	1	5782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUXmWBLcCxg4nUMsqsqNs9noNVnK7zgXQhty9GjrtnobzhV8K
40727	payment	1397	1397	1678	1	1	15396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oSx8tgwdneZa1qK8en4QfxBLbbmk6vUQEDrVndqMWvLs8S6r
40728	payment	1397	1397	1678	1	1	15397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoR5FH3nA9qLadPTALcsaC1FGCCFgHPhYpfPEJu9pVL1W3ZXo
40729	payment	2134	2134	1874	1	1	5793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuam8mf66ot4QcUzsHbrCAwu6M3xQFauKU45YKe5BF6GCjm84o
40730	payment	2133	2133	1874	1	1	5358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybvwB1HRfU8CjURoUnfy1TQHYDqpAbaxHbU7AQ668K5vbZpic
40731	payment	2133	2133	1874	1	1	5359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYtZpDXLDwkiH1S2kuGtVan9LorRdWmsTNb8UuWWQ1d8E7Lgx
40732	payment	2134	2134	1874	1	1	5794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqcv7a2C8XP3TP64KZ6VsujGCwWqzKp9nQUvEUhXPeYbwgega
40739	payment	1397	1397	1678	1	1	15400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFdF7RHyyQca1CYy8STUBfeKWDWPnAQ4rM1P2F17Zs1Z7bEqpz
40740	payment	2134	2134	1874	1	1	5797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMCmsd2vHpXaFUWcxMS5FGk9uif9TbK63EcP3M6wWc2cdD6HU
40741	payment	2133	2133	1874	1	1	5362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcJ3QpUCNBRcdDjx2DoZZJTWJxTwd51XUGb48WGAxSmE7PXzSi
40742	payment	1397	1397	1678	1	1	15401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PaS7MrnufmXbzLvUwrRuT5RH6dz2nbKGgqVx8qY1WfCmW5qx
40743	payment	2134	2134	1874	1	1	5798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64FwbSzuFzDb4fF3ShDbgx8M1G3ZcXz1otjhJFQWL4fyW6ohC
40744	payment	610	610	2325	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ57hDRGne2RPLd7e7CqwDiU2ijANSDKwj3YkpWwFtfuHzfd5y
40766	payment	1397	1397	1678	1	1	15408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoUgdjJNwvfiDnxjqeAfTveesLjYz69fmChqatd5bxp4fQ2KN
40767	payment	2133	2133	1874	1	1	5370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkzwF6ohvuaSq7MYHJd5D7DG9vMeyQ8C3BHp9Q2FkNtSBDYArC
40826	payment	1397	1397	1678	1	1	15428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrAEcZYQQTM96PJkP6WJkwgTCeBDZeUqdYvjAVYocYpkvJGf5g
40827	payment	2134	2134	1874	1	1	5824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi6aFUuJ2ZGdsrB4BUjtURcvgc359bg1YT8QHb8hKhgDXh6GXX
40828	payment	2133	2133	1874	1	1	5390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXQVgKnyWuFub7yF95rff88YqFAae1iwars6whDtKD4pcudvb
40673	payment	2133	2133	1874	1	1	5340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrARjj5BQPP8ffVVZRkAEzfMo7LVu6HCHwjuUWihixHCjCMgBW
40674	delegation	1769	1769	1407	1	1	60	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1x7pNjRxzCpCsLA8YsyADQFRxWJqk6cSpBBoLhAX8Sw62MFy
40675	payment	1769	1769	1769	1	1	61	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5p7PcTdLMome2oNiZHxN9y7ceQ586wxU71TosrkLRmC4f3Aqz
40676	payment	2134	2134	1874	1	1	5777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaq4pkhgzmQ2reFakDjfYy6FXERmKQ8JKqVu1yiMuwrJhg6iz
40684	payment	1397	1397	1678	1	1	15382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZNLacAypotmW5K8ZmsJ7LjCpPQzjqSm29AfJR1DNScQrCS6L
40685	payment	2134	2134	1874	1	1	5779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHrqVo4WsWuaHJuR2R1eqCMqQzvQonLHk13MUFoB7ziJHYmVX
40686	delegation	1769	1769	44	1	1	62	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsaxCx9SZFWywsxSPFUcsvgcRxiMZK7mWHuLGd6A1WQqr8ng5s
40687	payment	2133	2133	1874	1	1	5344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9REGXqiFKGNDuTcvisaBJFJvmPu8f95NJdsuVWYwLyPQh1qt
40688	payment	1397	1397	1678	1	1	15383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtbHP9YaMAWaRUqcNHdVuPz18AP4wfAmgFDPVVotY7wtf8678G
40689	payment	2133	2133	1874	1	1	5345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxW2VQW7nBGHh3pEA6Vv9QugCtdTcbmiFqGvrUy9svcgq7FR7L
40690	payment	2134	2134	1874	1	1	5780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5vUCKt3EnYgf9Kqy4n317RpaB31iZsVrEZLvEeWcn2HJGGPCy
40697	payment	1397	1397	1678	1	1	15386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcarWN9Abwu1G3DznqrCsFuAnbU7cjCbwqXz6mqpFTUbq6dkK
40698	payment	2134	2134	1874	1	1	5783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZf3gyDqkxnTRREz9vP1GG5RggFgNRDdxFcWH8yhNx9iRS53DE
40699	payment	2133	2133	1874	1	1	5348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3GLgWmaXX7tmCXYe68vDQXxMsvqFE1UT7GRcvNr67cBbLVdk2
40709	payment	1397	1397	1678	1	1	15390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SDUDedJ8yxJTutHRJvtkcQjXzWKYuQgcYcgBCAUNzuDbZ3YZ
40710	payment	2133	2133	1874	1	1	5352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEoe6bjK4XQjrtquAZG9pcs77Uuv4udjwxyfPsGnxqRNLvfQu
40711	payment	2134	2134	1874	1	1	5787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPY91y7cJiMMPngVH9GsMjW4VLXmzAn654nJYrwPceG8gNeRC
40712	payment	1397	1397	1678	1	1	15391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9egxMzcVdCqBZdPHTU8tWyeDEjKQq5NpBsTXZH7LArqGRbuP
40713	payment	2134	2134	1874	1	1	5788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHZRQKjcXFdJ6GqqQi7Mf3WJLVJYd9ESGNkT48WWYBsLmgdmE
40714	payment	2133	2133	1874	1	1	5353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1oBVLpQQezv9XMv9nf1u9j6w5Miip6RoYKSz4GKD7ShiweA5a
40733	payment	1397	1397	1678	1	1	15398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGdgBgbvDVsSafzTan8tsrmSt43gbJTt7q7Bb9Twfh7oWoTjX
40734	payment	1397	1397	1678	1	1	15399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtfdsvpgDYwAYnPS8VKcZ8dL6n8by263WLRNxrqRNBP8ArCUf
40735	payment	2134	2134	1874	1	1	5795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC49q3tJKq1QoRsfhqmppXZnxC9mNPucTgMmtEe6h8KL6rJPkH
40736	payment	2134	2134	1874	1	1	5796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUb9B28mcDLGzqxNcg5uYHzvbq8teruqosy8MKfNmuEGdSkfJ
40737	payment	2133	2133	1874	1	1	5360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Fqdw97KwPxKZ6ngcN543jpqk2bp2ZLh8mwwcxPtmYFQVu8NT
40738	payment	2133	2133	1874	1	1	5361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRaCjD45K2G2Y2RXmpKZFT9ZKH9NfMyS8seW1K5Vpa8xMwjDJ
40745	payment	2133	2133	1874	1	1	5363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJd6WmhwU9j8QzAXe127hbN1JzebzzcMB2sMqWTiTrZ2DVYgDU
40746	payment	1397	1397	1678	1	1	15402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjTuELaPamkXKUgrSL8JUWCYrh4GEZyTYGNn67XNwi15GDUem
40747	payment	2134	2134	1874	1	1	5799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFffPoHvK1VGw5M6R38UXXSrwRR46vjxjyCaNJAkGA4Buy1xaW
40748	payment	2133	2133	1874	1	1	5364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYVuPAAQ5Z2KrjiXbD9MJVg4MUpsf8ZqzWUvZvcwNAiWGnW7W
40749	payment	1397	1397	1678	1	1	15403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtxhj125kiP3wVBRjJit6C1Qvi8pUuxvMbUsjCwxURoCdYnvu
40750	payment	1397	1397	1678	1	1	15404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRnkEMxWcEYpsfydE7rhBzJRb4KnnLharS7PwkGFu7zdHfnA3Q
40751	payment	1397	1397	1678	1	1	15405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9WFuQwx8vz1DAHwAZNBcw1yiGkobhe5ezCAV5fbUS63W1EjN9
40752	payment	1397	1397	1678	1	1	15406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGoU6P2HtDJKXVBeNE5Gkw3pTEbYx39jQSLS5HSrLyfH8EbFW
40753	payment	1397	1397	1678	1	1	15407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9FodLkMGDpPz2BfnjMYpxZKF9exW6uxCiV6vp61EjYwoxSRcL
40754	payment	2134	2134	1874	1	1	5800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpXAvhH9yDWjJnf8CtPVaFZimckjJ4RGy6pYwEraNwLTD5Q9t
40755	payment	610	610	1718	1	1	1	1438000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkfmhohzcEh9dhqtobct4dGP1nwPdQz69Gq3w8HrU6eT1jYqSF
40756	payment	2134	2134	1874	1	1	5801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnyyKZ8afmCZyBrSLCvU3cH2nAnGhCtBrettmu6kFbjP5VR4a
40692	payment	2134	2134	1874	1	1	5781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKG4cQSkFhySrRpYEbYp3cQQH1rxBb7t5ahpD7Q5eTh3sgQNr6
40693	payment	2133	2133	1874	1	1	5346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJVx1zGBrfsTNBUxLTnAqwpvNGNEuWeBzWa7GDaS34qZkCFhb
40703	payment	1397	1397	1678	1	1	15388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbbK8NSGLs5bz2QMLPqprF1JpwNRMuABfZ6CjSYPqiB2V2h1C
40704	payment	2134	2134	1874	1	1	5785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoE5iFNfjutTW2BNb42kgk7gvKjAdCFByHVXLvehda6MCujhHc
40705	payment	2133	2133	1874	1	1	5350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwZov6YV351WsXWhkYG8v5sNz8BjHPfsHF5nQjV7JfVBKv2Z4
40706	payment	1397	1397	1678	1	1	15389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzncu53KbpvWwfXb1LjuLLoPF8xNBdgc9YwHTZirPUNvCyHcjG
40707	payment	2133	2133	1874	1	1	5351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFoqxYZQsKxu9CGNdkDa3jQRrWHW5FoNPbV9mUzjkx287AQkJK
40708	payment	2134	2134	1874	1	1	5786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyqq8GNR8sTHKZaUSgFTbL7iC8h2SA5ZSCTmjM4pvFJi8VQ41d
40715	payment	1397	1397	1678	1	1	15392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkcdZAx6c583cyTY7WTNPmK7Hfdz7aqPBkh3tdmzZL8ETSyky
40716	payment	1397	1397	1678	1	1	15393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Ziy7XjHXEAgJDVUSrq9S2uiFWFvSL9n9z9XEmKHdPmAmycsw
40717	payment	2134	2134	1874	1	1	5789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVoEovEQBBu8Hgb33E1h7paMMupmR5xYvWLqGbjwDzLKHX73N
40718	payment	2134	2134	1874	1	1	5790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDkntSq948zyuKupqfqe3sg9Auexdsgp57EYkDf5C4HPNQ7FU
40719	payment	2133	2133	1874	1	1	5354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZW6NjZ4fubPhW4QKdTkMvJ7VU2qd849NADqcGk9gYac1T6JF
40720	payment	2133	2133	1874	1	1	5355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDi8LBs4GV3BVnEXAupxdfJSahHk3nor2o5JbN3SHP4XdHtKu8
40768	payment	1397	1397	1678	1	1	15409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAdT2F28DynEi2GVyqp5pUHgUx4L6i9LSqTijm9z8SGuXiexZ
40769	payment	2134	2134	1874	1	1	5805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gdjRr8MbnzVNrba7Mn3CerL4pZGGTWxCZd58nvLizv2Pa9rH
40770	payment	2133	2133	1874	1	1	5371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMvsCyjzbPaUbF8769xH4jByHoUgw6LZKpXPbZhd2o31BQi4yF
40780	payment	1397	1397	1678	1	1	15413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibP91KsjN77mzW5KeXqAEzdJ4D9B46fz1UUCQrcBpHpKrtfo7
40781	payment	685	685	1933	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxZcdPkhk3xyE7bS5e3jUqopBptokD4QNnNTV3MfRqZA1vr5v
40782	payment	2134	2134	1874	1	1	5809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpUGSrnyFGJ7xC6gZipwx1X7TrS9oCf4GF9YU1hBbzPCF28tZ
40783	payment	2133	2133	1874	1	1	5375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWzy5LTKhk5jPbrNQjMJwUAZhZgQzTaMFu6L4bLpbwgkPVzG9
40799	payment	1397	1397	1678	1	1	15419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbec2XVnqRbwSJpCiSaxfkfoemAz2muSnHcmZLZLhRTbpKce4
40800	payment	1397	1397	1678	1	1	15420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFhdU4oCh8um1KT5KrJfPMCt7dhYyvamstLzEaUNSRfQ6Ro2y
40801	payment	2134	2134	1874	1	1	5815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZYggRNme6EYX913gCwitVbZDbvi2XovXJpw5Xi9gwtbLtznm
40802	payment	2134	2134	1874	1	1	5816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZozQszShk5KHqkxHe4Q48aJhjair8Y2qa6czotR5rCjKCnzG6F
40803	payment	2133	2133	1874	1	1	5381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnNyxf946XcdJ2wvcdDnktHz8XhMqxpKATuB8CvfFjSxY28TG
40804	payment	2133	2133	1874	1	1	5382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVh4k75kDYroXLsYibPC3Ssirjvjt6YRdSFjKSh6XNeFWkkcDh
40805	payment	1397	1397	1678	1	1	15421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhnHei8jAMCawqMdLB49gWDd9xzP6j4apFUqXFZDTSwe4KfS6
40806	payment	2133	2133	1874	1	1	5383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzXAUvJ9PUFJdwHzpkSVbrPqYDaDLqjWwty1XQJjWh7V5XMpX
40757	payment	2134	2134	1874	1	1	5802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUG8FAfWhdCGrNsx5ZccZNnaRvfJ9gbWSC2dWa2MZx3wKT49g
40758	payment	2134	2134	1874	1	1	5803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpK1AkPwuGHd1VCrxoZR3Mmon1WzscsHEi9ScS5o2XVNghnpn
40759	payment	2134	2134	1874	1	1	5804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ73KBgaWwuPYK1LLMaHKdwuXRy3QN5RLpoRG3tpemPYJ3NAaR
40760	payment	2133	2133	1874	1	1	5365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHCmVkJTWBUCS7KySpZFNg6oRKBiAi9ozf1VTYepZdd3XugAdj
40761	payment	2133	2133	1874	1	1	5366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1yc8EHmwCpz3VkSN69FeNn3kGDPNAJKfJBLaCUc6njt8P7rw
40762	payment	2133	2133	1874	1	1	5367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6wFUmJjuEXZRLEPwoHBkMaETLryDLZ61nZdT9ZZwj18UjTP7
40763	delegation	610	610	2325	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSqYQ6CdJbqjpYaoR9ukaEbvxx2CGskDYtkydYCKRzGrats2Z
40764	payment	2133	2133	1874	1	1	5368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkpqVFbcyGy6hQuFm7EhFRFRG8fPtQrscyeiAuar4FFrxDv1B
40765	payment	2133	2133	1874	1	1	5369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkG943zHWb3SqW5KPKDQwHrn5kFDJMfLjr5ein6S5gfDAUgb7w
40784	payment	1397	1397	1678	1	1	15414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTnPUAty4PrYiJAiisQYbkobhuNJ4z5LSqfmWrVLcS5CLNe55
40785	payment	2134	2134	1874	1	1	5810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfe3jxoKDZ7KXkEsxKqK6ZrwpCansEXKqAwvpdvmCskJT7iVpt
40786	payment	2133	2133	1874	1	1	5376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvEGTwD3aVXswmE6WuiViYjKySonfoxuwQGkhmBnXud5PtCNgE
40787	payment	1397	1397	1678	1	1	15415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxzAFcYRNaadgNsbMKY5PUxMdJRhwPNDR6AkRHXkcD2Sdc2UW
40788	payment	2134	2134	1874	1	1	5811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPNK514qPP2sehttJ22ZivaN7Y9UfXqXm8s5x5zkGC3R45UWN
40789	payment	2133	2133	1874	1	1	5377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXUctj7hHAfnzLkbibqPqBQXDwB1iiKacfZkz2RoPQLoFoLWY
40790	payment	1397	1397	1678	1	1	15416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyuJYPXgf9GLtMEayar6wrnKme4wBpMb9rBEKyYXcgjuMM64Y
40791	payment	2133	2133	1874	1	1	5378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF95yxskVj3vAyNdin7Js6YstbQh6kF9ZbVNqwDc9eZHxsFzwn
40792	payment	2134	2134	1874	1	1	5812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbo5h7YfXPDV7KR4wk2gnKFoqwUudx8ytddKWo1hijdK14Hra
40793	payment	1397	1397	1678	1	1	15417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRCJeKj8Uxhx59ZEdp7c5YCrye6g9eKa8iSSsQehnyRg624yQ
40794	payment	1397	1397	1678	1	1	15418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3d9CLPKB5DEm5ukekW4mnetL3JnGkK1HdLQSzbKzKL1oJSFCj
40795	payment	2134	2134	1874	1	1	5813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjo9ovuepDsjh6DQ7hMMYVdbjjuY34zWfKquqNEuUwN26gkBnf
40796	payment	2134	2134	1874	1	1	5814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkW4Kigm8UPzsyrkEyA1YuKS8mqKx2qiNBGhCY9oUZuv64MJsR
40797	payment	2133	2133	1874	1	1	5379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpDAwBC2YGNMhoNR2EL2qmXqL9UQTshqtbBfyVsjLtyxVrQQ9i
40798	payment	2133	2133	1874	1	1	5380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3nCnJXE7Exrfgsfyw9yEEe9qMUy6xaxmBvQWSwiHHM6Le9ueL
40814	payment	1397	1397	1678	1	1	15424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBe35TxnN8C2T9n3w4Ktyd7ExGqZ2F34U3z1yWG8KNoAaez7EB
40815	payment	1397	1397	1678	1	1	15425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRBFncgQwRco2WxHrWqQFQ4ja4xFrvbn8U6WfoabHfaom8QwB
40816	payment	1397	1397	1678	1	1	15426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdbdEG7yVp8Fdv6GPXVawxkZx8V5tCjdLNFKNrUXb4tDgSTeJo
40817	payment	2134	2134	1874	1	1	5820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDRMkhHt1mhLrwerqxrmUzhqkzxksN4vBxTsRZ2qxx2WR25JG
40818	payment	2134	2134	1874	1	1	5821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFCqPLbv4JepZiPD8CTFHJej3PuY6MrKC1SmqZ9HRRQtZypPqA
40819	payment	2133	2133	1874	1	1	5386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtw5UAs7ewfYzjWRGKqF9LxBXC2zNKLPwpaptL5zVwqo8zSrsP
40820	payment	2133	2133	1874	1	1	5387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgxNxMjaXVxRzgG2kkcVWgrbi8gJS1nrzPXx2TemB2PqUZpDq
40821	payment	2133	2133	1874	1	1	5388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfhWVTKwEak6AEF1RCdTQfkwxH1a4UwyZxJz43Ry372XY4Nb4i
40822	payment	2134	2134	1874	1	1	5822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoSLSUpuwM7YNUfqFZ1dMtFXdW7RotQM17VF2y7Y8RapDqtKs
40823	payment	1397	1397	1678	1	1	15427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQannPih48x97f8qgLdSFXaNpKbrvGtJJss1yavBQ6C4MzkCR
40824	payment	2133	2133	1874	1	1	5389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtnwohUqwv3pLDPdGsHnvq6pSwmWAcbDgymrSSnwWioUSCzUo
40825	payment	2134	2134	1874	1	1	5823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTxLgSmMRUpawoTV6ttWL1roRjb8Akb9nWSNJeEsQiLUbaAoZo
40829	payment	1397	1397	1678	1	1	15429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEg2gbcQeNuLZFRZhxEbABXmJXFYtPfhhhY2z3vq2eo2cUpBd9
40830	payment	1397	1397	1678	1	1	15430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfZrqnMbMeWbqJJBzxj3f1Xn9h6DV8d3X1XiuiR89SmQREHt4
40831	payment	547	547	2326	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU18Yw6VqcKu4E7ia5UehWP6JgsSzZ85WyHhCT1oWEkctBoWkR
40832	payment	2133	2133	1874	1	1	5391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEvvQeCAot2CuPv8kPhMGRHLoqkiuXoqkbeBe5poUQUho58NW
40833	payment	2133	2133	1874	1	1	5392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLJz7ejGuSKP4NAA1oCYngEJk5UmRgVcytRTA5HoLykgP7rf6
40834	payment	2134	2134	1874	1	1	5825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhnf8pyzPawfHB2yoWsCBSWeJBTWhwBU38Sahwcz6XFZzwC4m
40835	payment	2134	2134	1874	1	1	5826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYA4BRKg2XoSQHHCEv7MhjfUGNFzFFy3Vw9NXKf1yVaV5dNPM
40836	payment	1397	1397	1678	1	1	15431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdfTEU1vUbrbrxwQtWyzTW2vb8joHZTtScRovxqhEtzrGh6VM
40837	payment	2133	2133	1874	1	1	5393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHbkxHXGh3NCeaTu2TJsBURTLaQxEUwUyBFx6cvPeBWeVJjyf
40838	payment	2134	2134	1874	1	1	5827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuR36fegTJwkhnk8G6tjffbUcrrP5gtEsQqt3kZm1UMVRg5wMY
40839	payment	1397	1397	1678	1	1	15432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2frquWbbzp6znoGmnsFiJKDvZhsDyj77bZ46inSRtRYdvmSU
40840	payment	2134	2134	1874	1	1	5828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgQUGBPerjCEhUpbiQB1LVBTNABiuuT2iYoUupXhbaX4d58aa8
40841	payment	2133	2133	1874	1	1	5394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZD7S2eZjTkcZhVrxQt1asFVVvDAd8gye1cJAtWUAWREkQjofe
40842	payment	547	547	2326	1	1	1	719000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcC93kqVX93Ej7n2sFfMfFvZUGaGcSqGnNmrbiSnAc76ejmM3G
40843	payment	1397	1397	1678	1	1	15433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Jqwg8kgxqE2xbJT5F1cz4wUL1byTKtVkJQua7QDr6RGPu7se
40844	payment	2133	2133	1874	1	1	5395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUUdbjD4Bd9wSS4rK6rej3bKatvLNfNzJ7ZifwDjjk6fWo8Qc
40845	payment	2134	2134	1874	1	1	5829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy59M8W3ijDzNDGi15RbiHNP4Py4uR1n5MnBJLreuQBS3HqC1T
40846	payment	1397	1397	1678	1	1	15434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdjmB7GB9cawwrNiYToagasLq4Y1feLfPBr6oQA5NgupxKKtY
40847	payment	547	547	2326	1	1	2	4000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBbCyoVeeHxw2b35vS2qy6w6SLzJn36Qams7Zjf1C4twEbGyu
40848	payment	2133	2133	1874	1	1	5396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjyZxURw1m6W4tKoFm1tRUagK8xAMw1jHyqn6kPNCAVpEs57g
40849	payment	2134	2134	1874	1	1	5830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBPkioDcNTb6PQeWZTTANYLnrd8tvaYon5j1BNxYrwEEJwepG
40850	payment	1397	1397	1678	1	1	15435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpuTtzZ9Qx6HZQ3wwMQwnAoZAnxMo9jivSjoizaAs73qSBx9s
40851	delegation	2326	2326	547	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6bh7dXuVRN9fQLqZvsWhkpBWQSmJK5sN6xvUKKtvA5hkbNk1K
40852	payment	2134	2134	1874	1	1	5831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmnuGpYF88xoLWpURXcZ3aHoTh2MLh2Q6KR2q1ENLUkkMYZCK
40853	payment	2133	2133	1874	1	1	5397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tyE5xSUJyZqiYiEDusKGsnyZyEQU2rXd68CchZ82wNywCibq
40854	payment	1397	1397	1678	1	1	15436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY1f8BQmJGuqzRe6hs15YSz1KA5Wd9qVzUB6dYhFLQc448hj9c
40855	payment	2133	2133	1874	1	1	5398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFQS83qMfqUiCRCxgUGBbuBb5uZeHEDADVm224b2efxSpJUmr
40856	payment	1397	1397	1678	1	1	15437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTG8M95oTof8t2nH2az9nDam3CByj4RjNCVLDMLX5CNzuSfTtT
40857	payment	1397	1397	1678	1	1	15438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk73e9hZqig5yGJqvn7M1p7ryZxE62ssaLN2HkvC33wucT6ML1
40858	payment	2134	2134	1874	1	1	5832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa52NwZfPafZy8M3Dhr58PZPaqZTy9AainvCMFtKzi1vGBrYRP
40859	payment	2134	2134	1874	1	1	5833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfYNJkmsdAm1DLNtwVU16SRL5qvvAJ6fDwvrYNDZH6JNkBnJQu
40860	payment	2133	2133	1874	1	1	5399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nLSysoaRgaGoVSvE3vT9FhyTxc6GpnBWBSMbh2iiLgvkVwPn
40861	payment	2133	2133	1874	1	1	5400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aDcRR3Xj3nbzYTv71Dcb31y8HpzeEa2iJ6xhz1Gn4YMaQyXE
40862	payment	1397	1397	1678	1	1	15439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfv9ydgytD3TrjHo9EChTp9gS2LKPnxJFfCdK5RCLS3ZnW4h9K
40863	payment	1397	1397	1678	1	1	15440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26yq8wBh56Sja7eMiB2TCg4RpiZw3yLVTt93kjK22Aq5qiHTk
40864	payment	1397	1397	1678	1	1	15441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEngH32Sm51JXCgj9tS2N2bKmxPGrQAAA9eP83R8LzXMGdBSt
40865	payment	2134	2134	1874	1	1	5834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB2KbBHy7BLywztiiAa1Sj35j7ALTzZq5bqXAniPvVCBbbaFA
40866	payment	2134	2134	1874	1	1	5835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTUunhS5mukm25xRev6vnjeHcpZF3qiBtsvsMc9kaRCFvg8DM6
40867	delegation	2030	2030	2030	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kPYZUC8ysaHcNXCyJpdihvkFBbzthjsgphLZTzZNuomQTzEk
40868	payment	2133	2133	1874	1	1	5401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE867xzcMcikfJx8dc81wGL77gAjEv75JTTPTwKEDCcXrmavJ9
40869	payment	2133	2133	1874	1	1	5402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFF37Vp7MG3Nm9g8vs9XjApBr2zKrnsNGs99Yv285YanZynSa
40870	payment	2133	2133	1874	1	1	5403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HCmP672nWosuXDyJann3bYuHpEd1ESV3D9LJQ69qfqQ6FwT5
40871	payment	2134	2134	1874	1	1	5836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL5MsFhbg2r2vKSYDh4zRMJRUog5PpvYPymkoJtJekm5vjhw1r
40887	payment	1397	1397	1678	1	1	15447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpMf3q2VKUg2CZtdrn3xPXEmSZx8S8Y92r3oi2SVHw1Kym8bW
40888	payment	1397	1397	1678	1	1	15448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hTvyo3QYVKuQ4HyggVKHnxFEqQPd9sKjju3mhyXzfxLRegDT
40889	payment	2133	2133	1874	1	1	5409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVpBaujzX9rgGk9YAn2DemDivJRESGd51hxZsaJrMPmvbo31ZW
40890	payment	2133	2133	1874	1	1	5410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GCbJP4z4zc3hm4Jb7GFD9gzARgtRbE8gAiqnS54RquGbRVKT
40891	payment	2134	2134	1874	1	1	5842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnjqw5EnbPXSuR7o61uHP36cSJbrjvg5gZA85ytuupcnLqRaCP
40892	payment	2134	2134	1874	1	1	5843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTfPw9ivRwUVbN5CHNzht73GQdtWL8v4EE7RScSgBLF9GWdXS
40893	payment	1397	1397	1678	1	1	15449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKwb584dHt3vrff3LTSX5fZoxDbxQKPzo2646iHZtoQL5o3Xk
40894	payment	2134	2134	1874	1	1	5844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDeJMBWDHuPxzoXsnWopYYztxPzLF8CChRubyjcq15Uxzg5ucP
40895	payment	2133	2133	1874	1	1	5411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXYCZyAZAUr8CN9LhRGc7kHg99m3j9q7ifK6XT6MW9PmYSeR9
40902	payment	1397	1397	1678	1	1	15452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMWqpsUaYJV1CYotVC6FGAr8vCjbLKuiuRv894KtvpjqHBzNA
40903	payment	2134	2134	1874	1	1	5847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgddphX1rQqYuWXzrY8kqP1Mr7JY1seDbC3G2pHr762dYMVcy
40904	payment	2133	2133	1874	1	1	5414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoonZA81nzmcsbpNHcXhmxwBLEe7macdJfCkfsFGSQoBjLFBf
40911	payment	1397	1397	1678	1	1	15455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY3F4RNAVxZvGVRAhPjUfeNiztKBLRTubgho7CRAsD8aD88WB
40912	payment	1397	1397	1678	1	1	15456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhML4iZtpvscEavdTyNh7d2wnt8vGYBr57xgTaesR1WJM7Liem
40913	payment	1397	1397	1678	1	1	15457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRFZcWiuFnXtp8P6XzuKTpAv5eQLUrSBTL5vvP5Lx5vqXFGqu
40914	payment	2133	2133	1874	1	1	5417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZtgfwVVbQauWDEPXFYUtmnHf73UeMsgT38URzvrr2rr56NkMN
40915	payment	2133	2133	1874	1	1	5418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12cAmsb9umhYhTEf7p5Dxn61Pd4rFq5p8p38FvG4JkXF8C3Bx
40916	payment	2133	2133	1874	1	1	5419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBEw6yWsqktMu4nHVp4XxoBCX5sxAzbDcG84MNs3CG1g7e1ic
40929	payment	1397	1397	1678	1	1	15464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mqDL4vfW7yhMcrA61UFbDiYWg4GKhCQcpqtxSmGRRq8p7YEx
40930	payment	2133	2133	1874	1	1	5426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjdUSyRoG2oFvnbPL9urigTt96yKugFJxNPc3TaSafeUWz6NY8
40931	payment	1397	1397	1678	1	1	15465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKpYG9NNLqgCw26zNSxLDbigq1suNem6NE3PkEATvnDJU8zW4w
40932	payment	2133	2133	1874	1	1	5427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYNJFRbNqmGngi8W5UP1ME3F4kg1hH3Nk4ZUXt3STmeUaKPsx
40964	payment	1397	1397	1678	1	1	15480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQD5er6RT3FBfzCUiENKedeCLR4PyzfHRGnLV5CUFzC9ARD85
40965	payment	2133	2133	1874	1	1	5443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33QpsMBnBr7GKgwBFPhwXpjrtcWZQn49Mm89AGAjys8NCg122
40970	payment	1397	1397	1678	1	1	15483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnn4Y5HJ8BCdSYkMPeefcuoBL8VD5T46GnhTkJsKDLoHbDK2ec
40971	payment	2133	2133	1874	1	1	5446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLF15C2Kkggex6rhfswfJVLE2yLxV7pCcjKRAMHz7jUHv2CpR
40988	payment	1397	1397	1678	1	1	15492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMLseBLzCxYrXjRcERHZtkfXCsA7fJ3FZAWTE9EZ6oDBNnkmu
40989	payment	2133	2133	1874	1	1	5455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3h8hot4bEk8XHmmRv6ii25u2wsFjfpBkNWH3sCXHL8GTr4SL
40995	payment	1397	1397	1678	1	1	15495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxB5Ki9kFPMgB2BujVW3sp6BMEcK8BTDyLhe8nsZdyBpvPW9o5
40996	payment	1397	1397	1678	1	1	15496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEzBkUg1TFjVj64UAeddfJnh7sfFTzTQv8Q4vm8Sm57YLGyfaQ
40997	payment	2133	2133	1874	1	1	5458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5bAkhFKDz9QoqYX4oisniXrHUHmxQGfqDYeD4zQurXFCK2UdC
40998	payment	2133	2133	1874	1	1	5459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjESDgLtjdVMKPMUixbiwvZrXLwjRjY4vDrB8GYvnWVrRGPW8
41017	payment	2133	2133	1874	1	1	5468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxn4bzwZ9XJoqMLWH79Ty66yr62H38oRAps1fBHpjdwCDvGss
41018	payment	2133	2133	1874	1	1	5469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHR8aBNbtMEkBVnhx3tPZd1W4MtqGU6rY8Ern9n16FZUeD2Jr
41019	payment	1397	1397	1678	1	1	15507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPjiXS3akpptWJV7MoGC8Sj3UZxruvmFXT1LUUKRjFahvWQnm
40872	payment	1397	1397	1678	1	1	15442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RwKZv4HGVsSXD7otZ8L1AD1Ha9SYg7YQVvBxAGgvpLxVbBDh
40873	payment	1397	1397	1678	1	1	15443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5DmHdN8EkrdBKYM3xR6d2BqUJZxGuGPPXpdcEKVU4a6PjRmso
40874	payment	2133	2133	1874	1	1	5404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX43et8eXLBcoZRi35zchuAvKjjVbKtkg2QtqAWsGdes7qFGCj
40875	payment	2133	2133	1874	1	1	5405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ8i63qe2T5GyLCaPZuvUjuD5jcTK2jzGV33tbKBiEFgXSvPUJ
40876	payment	2134	2134	1874	1	1	5837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDVXW87NvmwPaaMMYAb4CMruR1kFjLokhRqY816Xoh6Y1bqMo
40877	payment	2134	2134	1874	1	1	5838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubmLSW5E9SMuTU8tUtXrvy4rEFijdso5kvoGBUq5aEdWKhgH4
40878	payment	1397	1397	1678	1	1	15444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gepX1T97KYqYwoMqcPfhvPSZWgtnRAZGcKA4QDoi7H8unpiZ
40879	payment	2133	2133	1874	1	1	5406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTawhcfkCpx7efR3Wga71qxB855mqdsV1YNSYUB8p5zVLdMYE
40880	payment	2134	2134	1874	1	1	5839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2CFgZx7T7LPCVhcRfozMzovNBigmaZEAvpAsy9Y46DpjAzf7M
40881	payment	1397	1397	1678	1	1	15445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGHpM8GBpFjDbsdBgTe4ax5UfGvtYz9pbBoRwPXt52YykybGc
40882	payment	2133	2133	1874	1	1	5407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYizwWsmgjzB7nXNWLSNi8TnbsrmJsuzoQ6yxDgLwvgJ3iYcRQB
40883	payment	2134	2134	1874	1	1	5840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHyBGYdUgzR4wTHgdsNdx4Szp3xX9odbcu5LpSuYUMkNngmbPo
40884	payment	1397	1397	1678	1	1	15446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQs78MB8FMRkyNYeCN8MpBeNkL6CbYeAPm8SS4QPeGA43xBQWu
40885	payment	2133	2133	1874	1	1	5408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbJoTUrjyt2PHLaKMBx9y4wYabAfYPPAwkZbZjXToi8tzNNVU
40886	payment	2134	2134	1874	1	1	5841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PrwLaHLQHbDcfgD5hnTt7xZ3RdD4JwqAJCsqAJY2uawSmK7q
40896	payment	1397	1397	1678	1	1	15450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNmFZQL9MUCuEC3c1T7MMj2GrQwMYYrRsbHvZXLM3q2G86cSS
40897	payment	1397	1397	1678	1	1	15451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPHDS9E8sBahTSPeJuHUyT2B97bfT13c7nwjrn7B6p7ZZReoXs
40921	payment	1397	1397	1678	1	1	15460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWC1zNE9Uct5STsSvJZd3HbHY4WUvepDHTbiNHvkSLqAmgHbA
40922	payment	2133	2133	1874	1	1	5422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG48ztnp63sDnPkDJKi1eWUKCrdPR9NmLtZrVZdDsNnD18NHWt
40923	payment	1397	1397	1678	1	1	15461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EWmMFjFpr51SBnGeSvV1dSMH7bk3TJsTvMDjViG5L6HGW94J
40924	payment	2133	2133	1874	1	1	5423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1VoB3ywubBTWG7NGFuSTxeKfC2jXCDKRyWagxhXPmxMXyizj
40935	payment	1397	1397	1678	1	1	15467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8RYydSZWd4UXUtShwXQjzEAAJSNpNEMK1ydGpvZqgtr5Rf8St
40936	payment	1397	1397	1678	1	1	15468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8MWCysMW6Ka62XhBbmxSVkwwyfkYS2j2mheWFzFe8RnEUf3q
40937	payment	1397	1397	1678	1	1	15469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDbNBBUGYRwKXKt5KdVhYShmYzjEnw5uJhBdMUatxAsDd5e7o
40938	payment	1397	1397	1678	1	1	15470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLxdrAkXHXRQYdjHrar7N9qeBXv4kTEWJhSsQEs2ZBgRy8if7
40939	payment	1397	1397	1678	1	1	15471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5ULAuNcYuM2cZmN5wupXAndmZdPufsJtuq4nnPJmLcMoVXmT
40940	payment	2133	2133	1874	1	1	5429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrB9aAFsixQnwDvs8GAtrL4JLHrAkvyy3x5UiLtikwrheqtdHx
40941	payment	2133	2133	1874	1	1	5430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBPVfRaMdWQPTAFwVBZJXGCxCqZjyuSehNdnZi7AnS1dtZjTH
40942	payment	2133	2133	1874	1	1	5431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrtoik7YQrSggywuE1J666vcXrMFvL7uhWWMLBMrM4YrazddWH
40943	payment	2133	2133	1874	1	1	5432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVzsybXte8nxPdHrZRtnojok3jepTV6aBCByY14UMYhs9Yozg
40944	payment	2133	2133	1874	1	1	5433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YPfKdLoNKHkH5oEXRXCPuNSQ9gvip6x5Aeskzr5rhVxPCf7g
40945	payment	2133	2133	1874	1	1	5434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5K5itx7iyfrYFWvDYpLNsqr7t5aD8wD46TJSahzY1brqFaNxS
40946	payment	1397	1397	1678	1	1	15472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuJsWGrXYLNGVxwv8NdidJpkepz3zWYcw3rpQZwRdM4GRrWXH
40947	payment	2133	2133	1874	1	1	5435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW2FqJxNSuvBDtCMv38DZUD2n5p63BW1nuHQEohrcAYt5DCYKP
40951	payment	1397	1397	1678	1	1	15474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXmWZDSU6d52UwktiesDWd4HUSdvtUeobXSXq1veWRwYFucjda
40952	payment	2133	2133	1874	1	1	5437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVHxTm2aXUENSq5NVTk1rPa8ahNBkuBf7CMLm8gpZT42wYkxLY
40953	payment	1397	1397	1678	1	1	15475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtJt3MNza1g5iumXfkCL889m4wkpQmFjvTimmPmRFQ8AJZ2bZU
40954	payment	2133	2133	1874	1	1	5438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeisWrjffxQRw9dUFa7oC9TmScuMAmMAwUg15gzXf4Lk8dzoVu
40898	payment	2134	2134	1874	1	1	5845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynQ7iXUqGkjPGmBc1M1jbP2hCMCnkvQztuxhWUueayKtrP6df
40899	payment	2134	2134	1874	1	1	5846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtY4zxtBkWXkWB57xLwwYhsWbsReHajGiahn84XHiAcfhUfBYz
40900	payment	2133	2133	1874	1	1	5412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Zk6ygnk5ZnVw5dYgnu5WvM7QnrZwbJEGr3VUTt6MdhqpPWfk
40901	payment	2133	2133	1874	1	1	5413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YawwLv5GAqFvAzmaK4WrvAAVwWZBihSmcSGymtChwJ6ckfWp
40905	payment	1397	1397	1678	1	1	15453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgWBJJuAGvgbRkAt7JcomR7YPR3bxUr1qA3xozyFUjVTQreuh
40906	payment	1397	1397	1678	1	1	15454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEN3rZAsDTeWDW5ssTQWRJ8nEErauD68XQqNgBa8EitE8opUZ
40907	payment	2134	2134	1874	1	1	5848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsbz4iNynjpLePmPh4cU2Ro9wD5xtNAhWU7UFuWWvTfJ8SXJX
40908	payment	2134	2134	1874	1	1	5849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVpBiYbuthuJJpvhaAErgAso8STEMoVpWmQXDtGPuBaQXwGEA
40909	payment	2133	2133	1874	1	1	5415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKxzfRwKYWMmJN6emEWwGfeMPpQbQ8ePWgoPQxXXvQGgWhqSHZ
40910	payment	2133	2133	1874	1	1	5416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVL7ubqLXQhkL3YU9LQkbsufG3vVLS6b61rNXZX3YM4nuTMLP
40917	payment	1397	1397	1678	1	1	15458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZviEZhbQTQDt9mxCpKUg2DKjvzBcVsnzt91NVcfCKHaQJLZ1eg
40918	payment	2133	2133	1874	1	1	5420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLYMmKD2twKAwYgJGcpo7tiZNaJpozPF4EPsGJ1N9KftUWvxE
40919	payment	1397	1397	1678	1	1	15459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9JQGt6nFuzu4szQkrroEVL6tJds9YSE1xnSP9zjMU6yXpwmfU
40920	payment	2133	2133	1874	1	1	5421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YK8eyCsfDD2Gfep5rUk9Bn6vCMvNpmtqy7M9jhZxPytmr3Fp
40925	payment	1397	1397	1678	1	1	15462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVE2cQhovHQ2kGP2eRudZ1afUrbHYWM5iiDQkhTyvaSh4fRLn
40926	payment	1397	1397	1678	1	1	15463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfhLP4uJQYRVGakxJfzYtJqmqAq5Yw9ApJ25urpnMvNZQe6kS
40927	payment	2133	2133	1874	1	1	5424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtPYqNRg7LJRtc5pCe8F4Pg6ZcEGQtbpXHsSAtsfKduRCkyUe
40928	payment	2133	2133	1874	1	1	5425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4iHcdpowMTDFLjFLKmeteqQzXqDqjrZ5fbY5UDQk3M3Un8Hs3
40933	payment	1397	1397	1678	1	1	15466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfde4aYpJL1nHtjKaTgoZ2rkHL4x3RTW7VpHdrCbS3gWGNWpa
40934	payment	2133	2133	1874	1	1	5428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfNQCXrRZ2dz8EdnRd6Dx1ngyWtPbroM4EgUQ4waLs9rrPebR
40948	payment	470	470	2327	1	1	11	1010000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibKd9mfoF958ejP1tJ24FHHNFMbaa6npseRoFGg36MdSNSajR
40949	payment	1397	1397	1678	1	1	15473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjxyDuemmTbN4XAM4mjKaQ34kCwDEMUjL3cwsFm7fRNszkr27
40950	payment	2133	2133	1874	1	1	5436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PB5cYvv88Nf26g7XPZXyVpHM2Mh7cHttS3nPwmsjHrZcFv7b
40982	payment	1397	1397	1678	1	1	15489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaXMfD4wFjDAZPdhEvTzwb3pYFezEUYk4RxQK6jzAmtFiiYQz
40983	payment	2133	2133	1874	1	1	5452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5LxVtjiUNAbLEdRvLHi9WZnKRhYEa5R8jerdCiTAqeF7fu1af
40990	payment	1397	1397	1678	1	1	15493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoBJbjKm7DxmZq22biwQr6YuBmLsxwKoVDYEoTJKCJQaVyKiv
40991	payment	1397	1397	1678	1	1	15494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyWy7yuGaxQiEdxqJWapCd7wsYhGfiNuv7KSSPRVSKsBGSp6R
40992	delegation	1678	1678	1397	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3uC4J83jZqsxWPZf4zxS5kXAZybkZ8ehu6HmZoeox6hsRiryr
40993	payment	2133	2133	1874	1	1	5456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkeoe9orfEwx5iaxuriy7JeNq7kbg6j8RYre8JfBtzPFcp4JKX
40994	payment	2133	2133	1874	1	1	5457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHB7oo51BY8keNi2jAayG65gg2VnTC9Ztybfy2qHkbZGTQnWw
40999	payment	1397	1397	1678	1	1	15497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAbcDoKVWTxLNH1dPNpePz2deQTZi9CqnrPGKHbN8Kzg1jmVy7
41000	payment	2133	2133	1874	1	1	5460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLeWtAR5LqnLhw2tRTTtbGSAXY9634wZYcE11kvTCbP3E889mL
41009	payment	1397	1397	1678	1	1	15502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyR5pwExQdUQEvE2HpDoNK5TgKKMZ2yxUMbufgyi6SG1mGqVMn
41010	payment	1397	1397	1678	1	1	15503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtdgQN1g14ZHMCkNz1w5JopjB8KSvE6kcqxAzbitoipnoXDzh
41011	payment	1397	1397	1678	1	1	15504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMhnRfpkr3tRRzXU7KWHq3W9wT3uBLm2GP4MgX3FkmRYAPA1Lg
41012	payment	1397	1397	1678	1	1	15505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsAAYEmEz6bvfzHFuM6v7YD66FzB6orUcBQY4GPc6kRd9ZaL2
41013	payment	1397	1397	1678	1	1	15506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXRmny7QF9JAQE67Tn5LnGVnM3Q1K6oVm3dbMyby5Z94AFo98
41014	payment	2133	2133	1874	1	1	5465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSg5XVj9t1nqUzyoJGCqMPRLAGdUfp2JyhcK155msQZ3pmi76p
40955	payment	1397	1397	1678	1	1	15476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGND5sLTEiF9Qj5xrcMVzQ7niYPC9RKXftUXo7jBs8PKk1KQh
40956	payment	1397	1397	1678	1	1	15477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetqHdmNB8tbfJpoUYcLdQoTa7ADmtVhNWvEMfpPTaoAWRJaXK
40957	payment	1397	1397	1678	1	1	15478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcuuiavSXiw48WTAjPSEiVo9XVTpeS3stXoiATbT3nCdKv4wd
40958	payment	2133	2133	1874	1	1	5439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqN3Bucmuf8nWWipwsAtdJ8uMC7qCn5SUmxo1DnouFFa8Tw7aK
40959	payment	2133	2133	1874	1	1	5440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCFBuQg2Qi1nEvgDTmYERcH9jTyz4WS2xEEvr2Z9nBof3UuLT
40960	payment	2133	2133	1874	1	1	5441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2aRJ2aiCXngx2jWFdRMCD8rivfmkiS3bdKSHSJciBKW147Pfm
40961	payment	2073	2073	106	1	1	1	188910070	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1wucBAyNwG7iNLZjuxuDkDjZVC7CWcpomVhrMsJDrVtbCiBs
40966	payment	1397	1397	1678	1	1	15481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmg3tUACrjfiK663evQ6h7bs6yPXFRRN8tV4Y4V2dpHZqPc378
40967	payment	1397	1397	1678	1	1	15482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDbNeiSnxUQXyLAyKvCCthX9dAPzEhg6k7qa9TL1D93ntVoACw
40968	payment	2133	2133	1874	1	1	5444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLfDx5J2atdNKP4fKjMJfxTatEqcJPYsx83DjjwTfQQGhfV7J
40969	payment	2133	2133	1874	1	1	5445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQgvSkaWU3WYivrGeqaat7VuRsmj3U3p4kS4pR6oyheL2khYTH
40974	payment	1397	1397	1678	1	1	15485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeTtN4oFCidrzr7Y3fgRTejYyoDDrbbqPXZuvTqxtmF7v1xkT
40975	payment	2133	2133	1874	1	1	5448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhqsDpjNfnyVaF5PH35oDJXyi2inqMQ7YNsKgchg4w8m1CXhN
41001	payment	1397	1397	1678	1	1	15498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4s83vRuCkDxjP1AaXAWAYSXvsRLJUbthHiHpnXZGc3KShje8J
41002	payment	2133	2133	1874	1	1	5461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnUqCK2CdmhyUdamfZDYHj4o2LHKQTp6F4hNodCo7o5C2EenBe
41003	payment	1397	1397	1678	1	1	15499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZngk5DL3sm7VSrrSW1BMDUjP9emkVHbUycY353NBpRir3fAB8
41004	payment	1397	1397	1678	1	1	15500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGfVEEoFXLXx6VuJ7h45jsCxzB3FBoaxLktDyfwRX9Z57KbQgZ
41005	payment	1397	1397	1678	1	1	15501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguMvdhMhSC8HPi4f8yk8Pntny3QDxdFm2vA8ksvvCrosHGHAW
41006	payment	2133	2133	1874	1	1	5462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxU3aX449MYnbtqaiEfGFwzwritiTZp4gwE9tgnrLsiFRqn7r
41007	payment	2133	2133	1874	1	1	5463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2veEodLdxyuDkQktRcyqYB2wQ59XPVrtVUqofD4sU3TpwRMXk
41008	payment	2133	2133	1874	1	1	5464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqrJ8qL7fqCKkc1sQ98nZn5Gr4RBNdzbc1gnbaDhVe6e3GTEw
41031	payment	1397	1397	1678	1	1	15513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLT5uem1KjpJ6HpE2n5CDj83fUjAPxXkTFt9owpDK7F2YgUj2u
41032	payment	2133	2133	1874	1	1	5475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYekhPDLDCxyQXi5StgvabBjQUTeUovNLLmf8Tf45rAmWeTtqKe
41039	payment	1397	1397	1678	1	1	15517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPuMYPD3aed1xMj4hipo1ycM4fwgdSEALPsUbwKtqjrQgB1MHs
41040	payment	1397	1397	1678	1	1	15518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2h1JrvY5UwjpN1nEbkh4ZHxVsbaksmiTanPpar15TYEJmgMEo
41041	payment	2133	2133	1874	1	1	5479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3EVyNuMC1wCRUWjT4bM51QTgWJxrWt9oEdNex1p456yZov2i
41042	payment	568	568	2328	1	1	0	720004000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoiuBE6JCKovoiwe1b6fzsmWYQNZgzkkneqQ9o8wwBcnUJqCu
41043	payment	2133	2133	1874	1	1	5480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmUWwvNzbW3m9d8A7Es2zYyKitE4bxmdcT3pudg3MxtqoNYggi
41056	payment	1397	1397	1678	1	1	15524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54MBm7HmuyZtuKLmKdJ6rsFwHTP1G6wU1oy3Vd796DWVJ3nTs
41057	payment	2133	2133	1874	1	1	5487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXcZ9kGaWjhusvBxWJkuJS6x1GasPAqWsZRRgFVkffEvQXNsW
41066	payment	1397	1397	1678	1	1	15529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLKaY8gUVFivBegg9X6UqGxvBaHbrn6VYP5uzH2GUCPv3cyuwb
41067	payment	2133	2133	1874	1	1	5492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5yHojd3TYbLPUjwnePeHAAtFg8BU3fzhA4ecwY5iwnzQhoey8
41080	payment	1397	1397	1678	1	1	15536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qHNdfUK1HuL4aTCvd8Xg5r1YDg3Brdd2XWwnvqEZrMmLhDmL
41081	payment	2133	2133	1874	1	1	5499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDEJdMtW5z1aNH7EneYRESmzdP35efj1LsGYFVpC2zK4UysCx
41082	payment	1397	1397	1678	1	1	15537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLqaS2aNkQXjW4CVFuEqUrryCYekRmScZLDwF3Er2zugbZpgZ
41083	payment	2133	2133	1874	1	1	5500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcPfz9WXwhDdhihjkjKt3bckY3AwYgVVGqXtQKz2iASnGLhH1M
41086	payment	1397	1397	1678	1	1	15539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpfMLh77AjFgPtCc2G54fE29dXkKtJiW3qeSRjd5VDT8gPAWjs
41087	payment	1397	1397	1678	1	1	15540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKrKXSdnHaPbXVnuwdc1HqJdstqeH51bMcztNawSfyUkuUVDdv
40962	payment	1397	1397	1678	1	1	15479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cdCqCs6zhqZ4EihECWwYKTYq8bUQPUhknPWjdTHAxJKXdXG9
40963	payment	2133	2133	1874	1	1	5442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uy74wb86ZPzDGesv15oVcQyoSzGZJkLtLGoE1UwXmsrUhusU
40972	payment	1397	1397	1678	1	1	15484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XbKvCcxyifdTouZVfuaamefz3Ssyb7K8kANPbYNUii4hPqYP
40973	payment	2133	2133	1874	1	1	5447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUh8iya7z3aiSRMan7p1Fo8CV3tC81cZ6HaFJUsZGZ1BtcAGNb
40976	payment	1397	1397	1678	1	1	15486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRB5285Y3A5v2c5qtkj179FLCfbXeVCtgro3GP4gTDgqq7q8p
40977	payment	1397	1397	1678	1	1	15487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErt1yzMVxiMC9H6eaJP3UTGiWZDbmjoykSJekYzxhfEWG59LC
40978	payment	1397	1397	1678	1	1	15488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtNn4iQFXatD6L3H4cmKQsh9P323tFzXgeJHo4TMfnhFAEzJb
40979	payment	2133	2133	1874	1	1	5449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv62nNWxcFBoyemEKUWN3rXNrJ7M72dUT47eYco1LDs8dAwcUh
40980	payment	2133	2133	1874	1	1	5450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ146eoNr8yN8EnE3nVoDLbym4f2U5qnLsHVUaSzd8HxcghhZEX
40981	payment	2133	2133	1874	1	1	5451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWhjBSyaDYg3PevhRftFKtzZ6STai2cXpBGzuPhXcZ3HLhjbD
40984	payment	1397	1397	1678	1	1	15490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHXGHnxzNci1TvSzA786fHHpgRXgCuZdmT5yYiLeGN13fgkygk
40985	payment	1397	1397	1678	1	1	15491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDT4z86AJi9Kk4p4JL8BwJmW1ocVubAjux2iY4enMBEg82jKz9
40986	payment	2133	2133	1874	1	1	5453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbAYYSsiKnPrpbo7ahcLPszEk8RxDeeuwRL9tXFRs9rSnkwV2
40987	payment	2133	2133	1874	1	1	5454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa87tZNPEh6Ja28UkXkWS9beqyuyaFsnoy98wBdfPpEJT8mbePz
41020	payment	1397	1397	1678	1	1	15508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMdoKco5KVXn5r4wzoc7tHG9daQm5r7TK24P4xZuBbTnmXcBz
41021	payment	1397	1397	1678	1	1	15509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2Vq8DARpFx3pLMnmqJJNBVYsFysmP5X9d4c29BdzprNwcPww
41022	payment	2133	2133	1874	1	1	5470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9Exz3sK62KPwEwh8LRkZskvCqH387SSiCTzpj8Do1Qwe4DK6
41023	payment	2133	2133	1874	1	1	5471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5umHk3oo5W5z2hrdFAwNjxGk815LvapC6CwUsg2z5qyzUq6my
41024	payment	1397	1397	1678	1	1	15510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3H5NnNjBwMZfHQM6HQZgJVK8oNq75ouQH6WZ8s3aBsFeJTY7
41025	payment	1397	1397	1678	1	1	15511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLicfak5pGNaTDaP5ADYHHJocFYgvmByH3bDHGyuYCfQRhCrR
41026	payment	2133	2133	1874	1	1	5472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPdpGXudiRAPh9sEWGnPsf3XQa2hCwT6M58UHW2rqYJETZg8os
41027	payment	2133	2133	1874	1	1	5473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQvUzzp3AweNM2RLuyXS2bM7B5FK29ciGqRuwYLhHiRMvtMbQ8
41028	payment	1397	1397	1678	1	1	15512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdGgEUH4eGkEw99RRoS3QXCxHfkfvbuKot1NbfWDWN1SJ3EpaL
41029	payment	2133	2133	1874	1	1	5474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTtFs29wuBwfYf3gtsAN4kVBZPuRs3hbj3XxFw9cpAyuotC5R
41037	payment	1397	1397	1678	1	1	15516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2TqNsc4VVLne1TaKcTZGd7NVeUarwcv3fRYAsj4QoiXhxXbp
41038	payment	2133	2133	1874	1	1	5478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq26AXbYupsL9bCmS9P2isTNrzPd27SKxkp1iFf2RJshRa4o85
41044	payment	1397	1397	1678	1	1	15519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBoDVGC6M1sWCg9dY68wNGF9ghzmKVdKtC3bTKQ1kq2jtQbE4
41045	payment	2133	2133	1874	1	1	5481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJF6yVoT7ycaBFq93eEJLM4q4gU4M9nQSuhEYvriFturMQ5Z9
41046	payment	2133	2133	1874	1	1	5482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5apLHoQGrLiC93QWWtKEg9U9YABPNzhQvApcdRNVA587C4RU4
41047	delegation	2328	2328	568	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ46KDLy8NuukC8RNWTB2YwDn5DrhzWxoAEKBA7zqnc89TJxRZ
41054	payment	1397	1397	1678	1	1	15523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbnddcG8K5LXGTaH9FW1RaRajd1UjKwcTH5xFHGrXaD5rtc9RK
41055	payment	2133	2133	1874	1	1	5486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Hun1y3cBtXeV55vczt6tPukZTkmM2Un9KtqgAZv5PPxAgpFw
41062	payment	1397	1397	1678	1	1	15527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCbX4RnQV3iXa9DPBEgxmbYzM5tzMjfWXfCh1SavqfsXdMLCix
41063	payment	2133	2133	1874	1	1	5490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WSNxbEdhEXbyA9STaHHtvmsEPX6o9FNqx7ZnZAtx5oDtQt5i
41068	payment	1397	1397	1678	1	1	15530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9JLfmfwGj5Lne78xfjYcPhctLyshDdDScdE6xYL8dwkAei1B
41069	payment	2133	2133	1874	1	1	5493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGX8wc2cqbure45CfNz4kXFekhT9ppBmyTHALQ2MRaUpwWx9LA
41078	payment	1397	1397	1678	1	1	15535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56kqAWZFpEbMG8LUJV2yH7QsDEoWdbybZSy8G42gXq8Mu5mad
41079	payment	2133	2133	1874	1	1	5498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTge9KuGe4MY7DQghf4rAbN7qmfMHJCpySWiN9fhFsyBuvXihz
41015	payment	2133	2133	1874	1	1	5466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzi4jVMUWFVR2CtHM2ZWh8TVyQm6MLAFckkLxdYQJxJBJYMju
41016	payment	2133	2133	1874	1	1	5467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQjBeWTNjgPBUg7KuPkWuDHnMhSTjzwXx79cAfz6DtQfysQ1f
41048	payment	1397	1397	1678	1	1	15520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xgQEqcpqJotkz41SBNcM7HvLLeJB4o7jExsA3GNB2LAQZCZ7
41049	payment	2133	2133	1874	1	1	5483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jYBmntxfGjCrucYTRhQXyDnzXseTkYdYsPW2rxEuQQYSxQfS
41050	payment	1397	1397	1678	1	1	15521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Ftnjuc2wRs11aFpf6KPTr7e1hDo59uAKN5XMKmvr7rH4RuyM
41051	payment	2133	2133	1874	1	1	5484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqxpes5JiCq7C4ADFZ26ydQsSE1KTE7XE3mRuX237SYAA8Uyn5
41064	payment	1397	1397	1678	1	1	15528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZD5GpFcfGmXrupUdHxm8M5HkNLVacPnzPZBV1ooku97kVhY3e
41065	payment	2133	2133	1874	1	1	5491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG2o28yR1RW9p39CWTSzvsrm6QLfbajBvrAZBiCvUsCNHKmZ4
41070	payment	1397	1397	1678	1	1	15531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbgh3PHYhGVeZsTHyWksEmk2moYnys9A7Dr14LB2Qhmp29eVa
41071	payment	1397	1397	1678	1	1	15532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmbyniYorPNZaogdojgnz3PodEXgtE3EdS8xMNMGVgTYyrNYr
41072	payment	1397	1397	1678	1	1	15533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1a8qe1fVyeXA56ewQj3dzXyALYWeyvjbVhiZiMP5KjqMM9FM
41073	payment	2133	2133	1874	1	1	5494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvBmDZTdnqeNUrY1LJzqRcytMfU2MYzFUGg9XW1GxVm3hEcoCU
41074	payment	2133	2133	1874	1	1	5495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEbZFGkmzAaUdKh6oyzzkkqLRXph3TaevCk95pTZLW14wLEtM6
41075	payment	2133	2133	1874	1	1	5496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWoBTMMmYMqo62aZMTUNRK9cVmE1koR5MD94kK4JnwHnGUTXiu
41097	payment	1397	1397	1678	1	1	15544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqRd5ZyJD1d73KLKQUUSBVfZQGgCJPS2GJZBd8otEn8uiY5bJ
41120	payment	1397	1397	1678	1	1	15552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiXVaaTPTnFwNPGc8hWvyjhL194KTUb72Jtm3hTmuzpcmNG9a
41121	payment	1159	1159	1726	1	1	1	1000000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgXabYKB2PbGGdDToQAu94eWgdzrHiWXcEpUxetPht54Cyi1d
41122	payment	2134	2134	1874	1	1	5857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY7z9S7x5iXEC9a4dhVCZPaXULmMvY3Ghra9MN1Rz2eyGq6V38
41123	payment	2133	2133	1874	1	1	5515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUmtjDdNFtjS2bSHmj6KimAh4D7P4epZqEWdAUDUapUkKp4dP
41130	payment	1397	1397	1678	1	1	15555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtJboyijgEX4NG9ZQ5EA1LwrABzAZLrVPgeycp46icDwhcGrs
41131	payment	2134	2134	1874	1	1	5860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfnNPny2w3agWR8m2FRHP2XM9yZxeEKwqMSskKdR3siRCycD8
41138	payment	1397	1397	1678	1	1	15559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGnccdh2yXbMq4u2nKmvBbieVRhRHiey8Uar44GA2Yspxec87
41139	payment	2134	2134	1874	1	1	5864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tVea3P8BPHgC9PwSWyr9ibmFFfkisZzmkJbtEpwdHMcTC7YF
41140	payment	1397	1397	1678	1	1	15560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQVAuTHNP4SZUF1JWDWW4mSWn1HVZKE4xTuqQyyrMQGLt2JVD
41141	payment	2134	2134	1874	1	1	5865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXPzjr3yAMoYEGKncAKNoUpBgXhz8GeambQiioejucNx1Jktvn
41148	payment	1397	1397	1678	1	1	15564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGSx3PXjGSvWiu6nYQdZRD7QdqsphtoUzHykYZ6bzDtq5hDC9
41149	payment	2134	2134	1874	1	1	5869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrjqJrCPiAFnEqtja6utZ6MCUu67KtEbaLkv29NZCvbTPTCk3S
41150	payment	1397	1397	1678	1	1	15565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8KTV4AnT7UsFqmMakyFPStjC32rMoFWwfvL9qq9EvQCUYJUM
41151	payment	2134	2134	1874	1	1	5870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzy2rjYgaRifzL4L1SA1iq99dHHwY4VTCJRVRwP5sVmr4febWi
41158	payment	1688	1688	31	1	1	57	2515428052000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZSwWQsRmbj434PQvdV4rFAHXpSamnGcKF4JyJS2r6x6Jbbui6K
41159	payment	1397	1397	1678	1	1	15570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfc9SAuNu9WQadUemTTwxQFrfLWUNYUjrPwwYmNrHUr2Z2ihox
41160	payment	1397	1397	1678	1	1	15571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaQkW5CzMLWi6hxh1PHtvdNnSUuHDDcJSqYw46jAkouSc4rWWb
41161	payment	1688	1688	32	1	1	58	140454056000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZhi7LH3qLZQa67vCr2sWaKxF2Y4bN8D7cYymEyWULJtrp6uZx3
41162	payment	1688	1688	40	1	1	59	125904461000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYpZJpk3TkMSd6ptyAQoVR2VFFtzF1e589zCN3VbMhBvpuUXM3t
41163	payment	1688	1688	779	1	1	60	52990929000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZMHUHL6MNT2C3w9cYi2ak6anKL1RKTUgM8xvQdzCv5paKgzzm7
41164	payment	2134	2134	1874	1	1	5873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMQRDzpM1aS49bzL56aaXC7PZFxF7YdzwzWpnkxdgFwYEnZ8N
41165	payment	2134	2134	1874	1	1	5874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1hnGjFbnKdrje263GsqNbn1fewZNqquyw3pJS41d4KmDMzMe
41166	payment	2134	2134	1874	1	1	5875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFa29BFboJR4v5DFmz8rbGv6J1LrhYDbNBCpwdx9T3XE8yAA4A
41030	payment	470	470	2327	1	1	12	124000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JH18MSyjnSAVhNtutpXwg1aejbKQ9jdx1UR2mrH6mpBzqJPy
41033	payment	1397	1397	1678	1	1	15514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDyRkRiQbLXccBQG3bBsPkgvJDf5euTFEUaAWvNDyCAkffwzzy
41034	payment	1397	1397	1678	1	1	15515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeiQNujymReesJGD12Lkq9URXmnQM9QLmKxDhKHcn8C8qZhEU
41035	payment	2133	2133	1874	1	1	5476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWyYYZVvJqbCc5nBShyD5NZG5tuQyRgMKr92xwszVg5YoUZ3g
41036	payment	2133	2133	1874	1	1	5477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcBKCjBpkHogawYXmoHSF1cDv8CCKAtE6m4Frb77mCpUjuxmS
41052	payment	1397	1397	1678	1	1	15522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BRLd7hWj26yfbhM7biQdMzJFUt7HjY8c6jZRiMhb3kPfwax7
41053	payment	2133	2133	1874	1	1	5485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwHKsvzgtUANAskxQuiGvS9m8RYU1CC9t3EckZ8CMbHhyNEKk
41058	payment	1397	1397	1678	1	1	15525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVFjXYxnM4LNkka1YSF8ich1QrXpdpLKTHvkg7b1TFsWAN9zv
41059	payment	1397	1397	1678	1	1	15526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYbricCY4vAQ5toNJ3LfPkPq5KbeUvbB86qhHJrpSFzmyLvdex
41060	payment	2133	2133	1874	1	1	5488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjMoTPLgp39Cmm5LdTy4xDRYUA7FUJdzX1nACuoBiY6a5TBQ6w
41061	payment	2133	2133	1874	1	1	5489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWEwJPSWVQ1Usntf2Tyvt9Lj2De7eKqJFw6Zf8w81sHgaXBzW
41076	payment	1397	1397	1678	1	1	15534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb97ef53AHt6X7HyhCJFvgk7WZDa5uLyWZvij2UXfCJPhkSCWc
41077	payment	2133	2133	1874	1	1	5497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoJ5VQev21BFavoKU8MKNNBQUZfgahfD3HSMwamUqA1LtoY4y
41095	payment	1397	1397	1678	1	1	15543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJ1pMU1q44c3WrGVGkPgzWWnKcW6RsAH5kBt5mdL6H2Z3w1cz
41096	payment	2133	2133	1874	1	1	5506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1VYBFaRNRnEUBBkLf5dQ8R1zi9gi1vDRq45Sx1L6RfpitVUmW
41098	payment	2133	2133	1874	1	1	5507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDe6qJGUwnyL9eRAedd4H2Lg9aQU7JRdQTRtsfLfD5TgHNU9QY
41105	payment	1397	1397	1678	1	1	15547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyx3UrkQJEHGaBo4JW6SjLXd5FRvCoGZG4zBVxM9RCHZa463BC
41106	payment	2133	2133	1874	1	1	5510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAZpY5c7EYkf2wu7Jn5C53KA1P2Ykri6fqGNuUX8ndef8KMSW
41107	payment	2134	2134	1874	1	1	5852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCAMchYTuFqo57JgEwZuR26d7EWMMiZQniJFJR8kjirLDTjGAk
41117	payment	1397	1397	1678	1	1	15551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyCmXPnfdS2kgsCjKd2jotQ2rVMCWVB639PKeuyWWuXU5Fuf5h
41118	payment	2133	2133	1874	1	1	5514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LkJKTmmRGXP8D7Vc9KQGhUDvCpCUW3JdZJ2Wpe9BtzW7eGN4
41119	payment	2134	2134	1874	1	1	5856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6LtWmM4tonErZnaZ5w7XzXHES6LoPKNSRWQyTKkkbttDHytGG
41136	payment	1397	1397	1678	1	1	15558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxLdm1HYW53J2kSmRvUR1SNuCsaQCdKKJXvgTAMDFQajHP2Qr
41137	payment	2134	2134	1874	1	1	5863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wdo4GqmsSGmsBZXqTw88CANFnu1GKUZVLMYKWgkNG5crWbCN
41142	payment	1397	1397	1678	1	1	15561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7PKyqoVPSmozk8m7Wkptizgh8ZrcrfXUS2pxY4DUiBfgwuNQ
41143	payment	1397	1397	1678	1	1	15562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdCbUc4HtUDXCuiB4MLo7B5hFe7ttUaYuVkKssKqHt9Lh7RpE
41144	payment	2134	2134	1874	1	1	5866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhoUXAEbe8NUiCFgb5aHwjLFLDVKn5oDWYDyZqNBJX1VqUFZwq
41145	payment	2134	2134	1874	1	1	5867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJDimB7UHXESKrj9UCcEaiVTurJpWH8cw2w5PKfjkTPRYRztD
41152	payment	1397	1397	1678	1	1	15566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPXt6k3Z7SjeYMcfuxwHQQ3sX8kPtigXrDjQurY5LPg1mBELL
41153	payment	1397	1397	1678	1	1	15567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKX4utf5G24Lz6QNoVwU3zh1BCQY3v7dVpMmAkgANkH4YrkBor
41154	payment	2134	2134	1874	1	1	5871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDatopzdgGiLC79a3Ajndet9oUddbYmUYRsySsKvA2Avz9GkdC
41155	payment	2134	2134	1874	1	1	5872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsgb8NVHDzsfZyWC9Y8vkzgFZU4AkxfviqmymsXmsCNuoZmuk
41195	payment	1679	1679	1	1	1	75	843431070000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZEKZnGwkt7Y4zH2d82GEMu3FHPw9BCZba8159RZW3tnehskkoW
41196	payment	1679	1679	841	1	1	76	188789348000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZuv8HN782YfWpxrpUm4BrLAWGA7s8Ad5wSkUjWRMBufkVZdMHX
41197	payment	1679	1679	843	1	1	77	351971422000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ7qcAoLZr3AaRto17RJKGaFBDbCYHkHBph5jWsezAb3befqRng
41198	payment	1679	1679	849	1	1	78	2605931429000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5iZ8u4VqPXjDAiNAfCWitvsD8WzBN5qkWPXsV3gbepWrBQkBu
41199	payment	1397	1397	1678	1	1	15577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TZ1tXHJXBQbiyxV71pc2faApVjRWyZ1kRtAMV1ptccUEJpsB
41200	payment	2134	2134	1874	1	1	5883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfUDrSZj43umcyy9Hr92aRMixfZhhFPawucctJb2z9VEDJjNnn
41084	payment	1397	1397	1678	1	1	15538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXTn9vkBzWApTeEcYHiwj9U6w6rzWcFz2e17UuUZtsyZm8Lz9
41085	payment	2133	2133	1874	1	1	5501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeiYHKMyoiYRNpzgYQAFuy5ayxb5V5GnwxGMfW1K2WYagxytWw
41090	payment	1397	1397	1678	1	1	15541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8oN6wE41wznDDnYJof2fPBdmPCx7hj8q456yyA12cKcim5Jm
41091	payment	1397	1397	1678	1	1	15542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRfhSobTEnhgAcM3cZ3yL4qTD9h3ajvD61PW2hVFggQMZAY5p
41092	payment	2133	2133	1874	1	1	5504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmg7fLDQmo5Bn4bhnTPYHSsMyLGLvTtRwz7DA8NM87ESk1M4ue
41093	payment	2133	2133	1874	1	1	5505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBrdSsr1SCSV7VM98wBAuEbNeXSjCDj2ryGpA7C9jc8kCj7aQz
41094	delegation	2327	2327	1403	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XhCo4qtcG2HTKaSq2KohF7QeYQPcuhjFgXvHu5TB38LU8SVv
41099	payment	1397	1397	1678	1	1	15545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJdonA7jHjTh98y6xJgAh7S6SdgsTpJKWmXCVPbPWySqUDjN7D
41100	payment	1397	1397	1678	1	1	15546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgovhAy2mkK7bf67TunA6mhjJe7cQjtxTVKPUoJhxmFTzxFfji
41101	payment	2134	2134	1874	1	1	5850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo6aC141uq8WqDEi2PNBya8WP25hPYQfyPMhwAm6iycYjxzAT4
41102	payment	2134	2134	1874	1	1	5851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfFw4betxmKkYS716VFXDzbcMvuUwq7pUMSNXQjp7LTg9F7Uc
41103	payment	2133	2133	1874	1	1	5508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCCKxMMBUCD981fLSAb3kKQM1JWa11PuuuGS1PxWkMP1YzTzc
41104	payment	2133	2133	1874	1	1	5509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM5PFdjwdg8MsqhFnbnWqLvVAzvTU6xAv7kWvizv8ieFCNoxU
41114	payment	1397	1397	1678	1	1	15550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdpTbyP5UTZtQcLxQZRSQmRy8uZqXpHVebiJzveooEtrW7Zx4
41115	payment	2133	2133	1874	1	1	5513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5inWnMzBnSM75uXLKGNrFiXUULj4RVRCqrjbDoiiAR87uSCme
41116	payment	2134	2134	1874	1	1	5855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnWqMznei164wJbTUTWacmCKvCfoosSRgaarkrnnuUNf463jU
41127	payment	1397	1397	1678	1	1	15554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3TMjBYS95B9f4e4nwHpBUQNxwuUJo32S4Tc1bzJHvt6JA6sW
41128	payment	2134	2134	1874	1	1	5859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhJMuYirycFAJw5QnrV6CCsjnvsHidYf2JghYmV1bPrTLUmyFD
41129	payment	2133	2133	1874	1	1	5517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFBvhEjyHD7VMp21VezftugQRHoodBkzGzbHLXVz6tCfyPBGYm
41146	payment	1397	1397	1678	1	1	15563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpDniNeuSodvS97WnkEaoWztJSwAQVmSBN2jeENMbqMbgVHaG
41147	payment	2134	2134	1874	1	1	5868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpRtkiKQVJ7sNTzaTvsswFtkEhURdTboVXGwi4K6NRxgZyShP
41179	payment	1688	1688	801	1	1	69	26497992000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYdR9YQrkjgkuK6kRbh1U7XHuwxu2ZgqzmGiWwjAKGf1HVz3D1w
41180	payment	1688	1688	802	1	1	70	291477660000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYstbiyeJjh3BUXRRzH91cDCcgXaqgUSvPa2HACinUumRuvgFBm
41181	payment	1688	1688	811	1	1	71	205071825000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ5Wm46sG685jpmvpHtnFz18wVkjgDwYbq6Q2KHMbmZgJHXe3E3
41182	payment	1688	1688	812	1	1	72	2255788106000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZnv3hzLaFoMWfpzuGM5ASocan7GTcsk94mj2KLU7PLLMjwapxA
41183	payment	1688	1688	823	1	1	73	3290688327000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYt7aPkXZ4hXDfHW7DtjZSP8DqKp3AfHcGJew4m375VJVKfuduZ
41184	payment	1688	1688	824	1	1	74	36197540012000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYtkrhsJfDWTGAwMyBDMhatGWa3AU4LVvspozL9q4L3cH6o4oge
41185	payment	1688	1688	1900	1	1	75	126000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYz1QjpYKQF6upBsb8McCqLEZmsbKRKVUpfJkZcS4wjtsAqr3bA
41186	payment	1688	1688	2177	1	1	76	6264057581000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbP4UmV72VRtMFh9NE4yxoawVVpA46B7uvsWshnTU6jiHJmKdJ
41187	payment	1397	1397	1678	1	1	15573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFiQA8vqz91jwjKg81rPDEFjurTB832RohJHHhYdMQHaiUsh8Z
41188	payment	2134	2134	1874	1	1	5879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVv6qRPY9AVaqw87YpKwf4AScLrJd6WqyeiF6JSTxYcbZLSJ4
41189	payment	1397	1397	1678	1	1	15574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25VWKNtSPriZ4EjCrRq7AmSvKdpAxpEHsNumN7JRwpP4MMamr
41190	payment	2134	2134	1874	1	1	5880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVyoM2wKpAzYnkDdFN91vrsj4CqknQDW1BhvX6HsX6Zk3RyYP
41191	payment	1397	1397	1678	1	1	15575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1g9bmUKRuujAKoLm15Ho21WjnwcLD8xyWz9MfguGQybwyC3xY
41192	payment	2134	2134	1874	1	1	5881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDvhXAM4dCN4aCJk122qwpJtGdxwsFKiiSGP2bogekdBeauppc
41240	payment	1397	1397	1678	1	1	15588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrUBGYMwmavMdYPet5vYYXUAQCRjVRDn8B6kjC5jdCtSyCiDN
41241	payment	1679	1679	879	1	1	98	304590654000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZMiShYPphTNKw13mN9DkkjCQbutjF5wA23vXEftkcKTaMHd1Jz
41242	payment	1397	1397	1678	1	1	15589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa775NrprDwStzpEvHYwK7KrywpjPz9SoD4iAgY6FXGeyWas7S6
41088	payment	2133	2133	1874	1	1	5502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7kcf2UrGT3axwYHqYzy6GfJ2TUFXH8WUP7PWoCxX39ppA8vp
41089	payment	2133	2133	1874	1	1	5503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQDvz1YxYXUB43mGDwzhzwksBvN5PENbN2u9xx6nKwzTwY7Wb5
41108	payment	1397	1397	1678	1	1	15548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwksqubeWvb39MSCuKLGpgisENdEyzpaFKy8gzCKpGLr9yJs8C
41109	payment	1397	1397	1678	1	1	15549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7tTzfyPrvLTUJ3vRLrhrxwpsUNPxoPRTo2yxw8XdPVPrf6Vg
41110	payment	2134	2134	1874	1	1	5853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fvpPQxenK3JUiRVNnuLa4Zk6ywJxLL8rjBo2BktWcFU8ibLf
41111	payment	2133	2133	1874	1	1	5511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLC5egXYQxGtLDp3ckJc8xq4KpZW9XyAHfHRifRpx2r9nTzYTz
41112	payment	2133	2133	1874	1	1	5512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmCsrBXG9ZxFP7GA7AvTKMuArMCyv1v3P67faKLPKK1riu4zz
41113	payment	2134	2134	1874	1	1	5854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBR7VQBV5jbyLjnmgm61xhJ7dEBQqWQJd4ewuC6eHVbpTZEkPp
41124	payment	1397	1397	1678	1	1	15553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWDmMddvhdiu15bTUVHWwGyhXyUVzabM7x4L1qFDveMeTHZ1j
41125	payment	2133	2133	1874	1	1	5516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSaLaUUUgTqCVUiXThhPU8jGDmkZmneY1RffLR7ReGtSQekgE
41126	payment	2134	2134	1874	1	1	5858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjc7K2BiZpqMsBsC2NJ3uziP22a2rctGvDPeesWxSdtt7UJirD
41132	payment	1397	1397	1678	1	1	15556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvfxnZb4sL7ik4ktKS9a3Zd7rfxywBhnFio9udhjSmv5z9zG9d
41133	payment	2134	2134	1874	1	1	5861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSmmBRsfHAuwKpaX8C5xvWe1rtWBBdjGPtWFr1LWJUBegHfSQ
41134	payment	1397	1397	1678	1	1	15557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFPkL1M918osTDdK3o8LGBcKF8bPSPGDDSmW2b9dB1y8zyqZU4
41135	payment	2134	2134	1874	1	1	5862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4fUNs8RoJi5KZsmDFqhp9zf2ufVA5xQhCGhuHGfyqbAR1mhc
41156	payment	1397	1397	1678	1	1	15568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujA9exn8LKbwYt71GU2G3vE9nVePM4y1aqSVAMKb9ggWKHuMy
41157	payment	1397	1397	1678	1	1	15569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGCtYn7rgmWHhohoby2KDSe5owD9N6hx9pBCUQVqd3khM8H3VT
41169	payment	1688	1688	780	1	1	61	582899713000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYZPKoR9ZmoeQsfuLhp1XxoxAhLSKhKghCofh3NghkAAATtWcsb
41170	payment	1397	1397	1678	1	1	15572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuDUowGhrtSU38SAVgxCW5x1B5fJ45PZgiLTxC5hhAMyzeXeN
41171	payment	1688	1688	782	1	1	62	4663103394000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZNhxesCkADubNGJmhwJFRAjDxPaouX8LNjf1fs2XRdMkZqE3yg
41172	payment	1688	1688	785	1	1	63	423918860000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa6aG2e2JE7RPMCueqFoXWdx74PVKX1YanAH4ebzahRttzLcYwF
41173	payment	1688	1688	786	1	1	64	4663103394000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYWGBPpVTFgyZJ9gRrufRatGhufy4L4jpaCSh4kgVeoLYuHDpsa
41174	payment	1688	1688	791	1	1	65	105981858000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZH3g9DhbYG45LEpMWfP1cSJVkVnbmZuVWdqb3TEEvzPGV5NejY
41175	payment	1688	1688	792	1	1	66	1165799427000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYU2CYyGh9cFWnJZREkofWpcS9cb9rZiEYL8ZBfxXuZhUmhP9hR
41176	payment	1688	1688	799	1	1	67	26493091000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZoe2Ut6eG1FUH5Gt6JKoDiYUsWBHoYz1KJMzTLwEVXDV3EDhQF
41177	payment	1688	1688	800	1	1	68	291423743000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYdr7g5Ld7VuqYwvFXgpTW3eSeSxq5bVgNr3AEwE2AMSzi5fHwq
41178	payment	2134	2134	1874	1	1	5878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnweohqU5YRckDQQVzgmEN4bdM8QfGBruoi8Ctqg3psKkT65mZ
41212	payment	1397	1397	1678	1	1	15579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3DudpBETzXLSCaz437mwchYunQ5WDoS2E9YLz5bNrjtEtkbJ
41213	payment	1397	1397	1678	1	1	15580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmZvYnuDnU7MBhZpmnufa6mwseeEsVY6GNVhc3NRGSXDxTpQW
41214	payment	2134	2134	1874	1	1	5885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRqXgQTXaToNKBHHAPf1VJkE5PdpZBRSDXQS9UPz7kRRfQzwV
41215	payment	2134	2134	1874	1	1	5886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmarBvcP2e1NzspUEhw4bNtpggczRsisvmNCLdksLGErCF6D9
41266	payment	1397	1397	1678	1	1	15600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5eENnYi9Nt5DDHVcFBoNa4sYGh4HaL6wsaTTx1gzar6Z5tZrm
41267	payment	1397	1397	1678	1	1	15601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Ywa8wd2WXgDEa6dAmmniWpeUa4FxAgK5iDPzTjkKqxbkW63C
41268	payment	1397	1397	1678	1	1	15602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYev27TEHAXvUwDLM6ZmnismwHGytUAuuNjhxL1GDjBfyknmgFf
41269	payment	1397	1397	1678	1	1	15603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSUDpZz9VpCjaqS6aVG4NsuEhheXzoM8v3ciiUdCKRek9Liu8K
41270	payment	2134	2134	1874	1	1	5906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEFkSTMBHtXJUMoBSDxgCiGWErxDVAHggwm56A4iVnuiRJa8z3
41271	payment	2134	2134	1874	1	1	5907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa25a9PmnGkw8P4MGpAQP9omNhaELRxoowG2Np4wQQnonjQT1PU
41272	payment	2134	2134	1874	1	1	5908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrLPqza79u2CGWo5HuTJpd83RgyuwAcnjq4VtWZhM3x8HTAJNu
41167	payment	2134	2134	1874	1	1	5876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrepYnqmYDyUrFJGYozTvQXKSsCwNEiNgdrixU1U3wQjcUwUU
41168	payment	2134	2134	1874	1	1	5877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2UBom7WCJqxxnWedj8u6VPieW84eDUmZtra3HSwZ3JRYGTMmU
41193	payment	1397	1397	1678	1	1	15576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFeKLYgWSeeZufUTGRgSKBsjEvXnS9iZ3WRqBxYsRk8kWTDTK
41194	payment	2134	2134	1874	1	1	5882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyh8VW7f7MTfMyitgFB8Hzn7wsGtEEHerffSohSgHTCD7KrKh
41216	payment	1679	1679	883	1	1	88	203060436000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa7sMsXAPA6EaPKeM5myUyinZzkup9AVVR3PWEtz2R1pYpycBKS
41217	payment	1679	1679	887	1	1	89	606052146000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZcKyktKnh38xyhtxHZv5GY6VBpHJfcNWaC1F19WVniTU6ZsfxB
41218	payment	1679	1679	889	1	1	90	508748293000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZQRCoAGhaBQsbMedew6hAnYfwBQYGLKt8pup6QyeCAHYj9Xbeo
41219	payment	1679	1679	891	1	1	91	1116832396000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZyKAnhfkquM8V1P7fmc9PNem1MjSg4vPcbReQNfS94qSHNjxSZ
41220	payment	1679	1679	897	1	1	92	147324407000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZ9ykXGPAEAC3La4CintMrC8QsmnDJ5UudzDt2dzvQFgd8eN6Zy
41221	payment	1679	1679	899	1	1	93	87819577000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZbb3hBEuw8aLQxwmb5kRffvSu8xxSJACfU8in9bwyJEQKRLdeY
41222	payment	1679	1679	901	1	1	94	263978566000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYjFiVyMKiJ8jKsjw2nsTeYRAaQ87MJqEeSRweiQRTYTTaCWUMV
41223	payment	1679	1679	905	1	1	95	949307537000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYVAmv1DmYLqoMf5sFANDmum7PccfPWQWDbAQYrziLy2aaEpup4
41224	payment	1679	1679	2177	1	1	96	1584060900000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa7TmmEYR1CZ2YD3aA18EnrB1GPrRw8iWZQD1xvwYSR1PBCG7Du
41225	payment	1397	1397	1678	1	1	15581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGc8iQCPoPjjz5fqUSaCuAwaAusM6H1AxrsG4GWGSkcsdDhZ5P
41226	payment	1397	1397	1678	1	1	15582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtEzzN2gMvcfNLnt3cbAe54FpqhGZE9Lpe4kw7xqGqUQQtxr3
41227	payment	1397	1397	1678	1	1	15583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi9eRbcEVZhtbE1vYCJYdvD6aJoGfujAEeyJfaQevMotMjdagm
41228	payment	2134	2134	1874	1	1	5887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwk7DTQr33QkspikQqFtqk6MDzp6swyuW6xXFNDgx5L7iKKSvW
41229	payment	2134	2134	1874	1	1	5888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr21t3Tt7iweCZTcXKn9mc4CE2ud7x9taSMACJMbHYLXYtLNsf
41230	payment	2134	2134	1874	1	1	5889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy99NQ2ayQchHJNgsEjP2W9pj86kPuAxvcFszUHUACKZeEUM3f
41231	payment	1397	1397	1678	1	1	15584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3MUHJizHXPwf2bupcq3PcaggSchHt7Vo86eyxGpNWWAYeWNn
41232	payment	1397	1397	1678	1	1	15585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBNvEXKB9WBYPSv9kcqtBLaXREzwwCLpAgk57qrs7CBRR5U837
41233	payment	1679	1679	875	1	1	97	480576364000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZDAKSc7zGiqJ8CxzGCwbFK9X1XQNTKuhNW2HtQ3NKtLgCQVcZh
41234	payment	1397	1397	1678	1	1	15586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2NkTdymfAgvUyh12Nhk51typbtjEp7VWv8aBn21bHTyZHsgj
41235	payment	1397	1397	1678	1	1	15587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCTFQC5mRudNtRWpUHdjGyHQ11zBzVsQoYewBwgj73S7uC9kP
41236	payment	2134	2134	1874	1	1	5890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJyhnkNKFV1CWBn8qQFV1eeofsQ3kC5MUdcbu38sDnvvzC1NxW
41237	payment	2134	2134	1874	1	1	5891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUYpEVGc3sYgCsZvHdRXSEE4KDMATTbPzU8LkXkMceZVKTymj
41238	payment	2134	2134	1874	1	1	5892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mXMR3N6tVGiCzrVBXuu8dAMrUZVPJ3PfuU9CxJpA9D3J8rYD
41239	payment	2134	2134	1874	1	1	5893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkQyazWVnQkLdcwWXVTLqtp3RS4Cg6pEtzv754uh8Hqo4ucsm
41254	payment	1397	1397	1678	1	1	15594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVcHh6qkPAHcKJofYQkSAZXmd4PxiMihh2qoyQcLRQCxccKZdM
41255	payment	1397	1397	1678	1	1	15595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCkmegpQn2JoWpfsTUvgAMi6YBdzeb455MrDUD23TqDFWQmyQ
41256	payment	2134	2134	1874	1	1	5900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9FfbD9dX3JngE6cvEqg1uPKiYCTjqeYeB6kZRN31bveemDmgh
41257	payment	2134	2134	1874	1	1	5901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvFkVG3nQbM4BQ4mJXMXnN86DF2yv89yTx9HiW8R64hN4cFeX
41258	payment	1397	1397	1678	1	1	15596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTW18efUJJwXfiZ8oVQoKjVtV2iPGEZZDq99WHjED3gmgHBzGh
41259	payment	2134	2134	1874	1	1	5902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNkU6WRoAqSHr2UC77KYgTFkwC9rjYHHwVRqQijk9gz1GVXgA
41264	payment	1397	1397	1678	1	1	15599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagfMfLQT7zRmibzipDUgfbDy7hEyatdVMpM75wvnit17ZBAEh
41265	payment	2134	2134	1874	1	1	5905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNRjXDHvrP6zQ5UDq6C11MtVzxG8qkCjKecw4t4MYExSV2xP4
41274	payment	1397	1397	1678	1	1	15604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHzGVimyv1R8XqkrRPG2W8uegqR2vfxWu9dchikdbQNKmozSJ
41275	payment	2134	2134	1874	1	1	5910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcmZBVWQSyn6L6DCW18s9WhzKApNsmzw5YZLrRQma7LfampKS
41201	payment	1679	1679	851	1	1	79	5048082432000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYafV7JKX3jLnfEKiK5b7r3D2Z5XSMd1gbNMj86rvs7i11cNWKN
41202	payment	1397	1397	1678	1	1	15578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGAd4T2amJ8g3AJpWBP3sbqEed7meRe6Cjx9HnnBjG66g6T7Hs
41203	payment	1679	1679	853	1	1	80	556632312000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZsSGA3DZzZvbQVzEFnnWBwfQ7qfuGq12ESvrL5nrWtVJYhmsYd
41204	payment	1679	1679	855	1	1	81	294437632000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa4Mj7tvHEKLvTsFGYJUYM8v1K28tzEpEWMbb4eF6ZSEnsqNDk1
41205	payment	1679	1679	857	1	1	82	742420089000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	Ckpa4UhSGMXu6DbGG2M71UXf2nxepRvfuDKL8UW7fmcXxsf9cyAoN
41206	payment	1679	1679	861	1	1	83	1025455200000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZCgnfxbNbkzhxiDL1X27vkRSnHiAEWgajZM3C25DLWnBNbL2B1
41207	payment	1679	1679	865	1	1	84	900234598000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZpa7x4FYTTjiTndDr46oyv5c4Ya2bdRSbTXrDnQUiQJfMruVQ4
41208	payment	1679	1679	867	1	1	85	5482631766000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZWBfP3BtELtHnyxKas3iGDQZNEz3WNA8t3avvgAnx66nTS6CzP
41209	payment	1679	1679	869	1	1	86	586324824000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZo2CfjTxnwZk5ASMZkBqN1Fx8pKM9JTCmBuQQJMp7egJKrXQ3j
41210	payment	1679	1679	873	1	1	87	5482631766000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYjAwpjw81Fv7rNW3CpCvtTFR9sP2czVjuKHonBUaoKyfyuPLPj
41211	payment	2134	2134	1874	1	1	5884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtwZwdnZS3tge8YpjNDicEpkK22aq83ir5ePCusg4f3reosZk
41246	payment	1397	1397	1678	1	1	15590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRr8tvBYujgwExSLergGvJ7yCBfnYyxLmx2HJoLbRgfEHYidm
41247	payment	1397	1397	1678	1	1	15591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENcguujp2heLpMVnfckhnfm74d8zkwMngG9pwejrHKv5DEn67
41248	payment	1397	1397	1678	1	1	15592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawXmXuHgjX13N6KVW8UVpdGHX6sEBX34Fahausg7Sxxq49fML
41249	payment	1397	1397	1678	1	1	15593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryG8tcvrrpDEuWiwq6VFTtWh1f61VkXoFmA8v6cimemFgU8ed
41250	payment	2134	2134	1874	1	1	5896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRF1atVR3nNNdRbd6fRUvwHG47W7YiVdDAeb8Eb9SvaigkAnr
41251	payment	2134	2134	1874	1	1	5897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxLsXLFPjPYYZdbt3kA3hyMLYZaJHBwrq7PPZZ4wwaq19qx9JE
41252	payment	2134	2134	1874	1	1	5898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xRTztbQbgaBnBZD8Ln1Z5E3FHtk4MGxHFXcobBTdzyzn2fjx
41253	payment	2134	2134	1874	1	1	5899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYwdYJd5d4sivJgvtK1BT1zMfmXtarE8tpmjBy8EcvjxA4G6t
41262	payment	1397	1397	1678	1	1	15598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzhci7eBeu8ZZdwQ8LxodKcWvRfeTz3zAkmZRCPJkzfWpWrAb
41263	payment	2134	2134	1874	1	1	5904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77NuR1s83xD3mEewiqnKgkt7BppBm6gdqGVDZPt8aLbEy3k46
41276	payment	1397	1397	1678	1	1	15605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH5qt9JzNQjazcjdvXrw466km1anEKXqV3Vk8HGpytx1mxyFgy
41277	payment	2134	2134	1874	1	1	5911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEwVsciSF8xUAs6remkXNNirraMvPbGDZg7ehxi7NdU68QAVB
41278	payment	1397	1397	1678	1	1	15606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwi34o6wRsqQMYQrVz93DMqw3AJstRm6kMjNtKZjRNhSNabsG
41279	payment	2134	2134	1874	1	1	5912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZokX3Wi1ZbLTHCQo8Hfjwg7A8XSw1H6FvpFEByVVXXwTSufM
41286	payment	1397	1397	1678	1	1	15610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQQRxZFzZQu4BrPrrEKAmUeuFej9aPonWU3b33nN99G9gsknZ
41287	payment	2134	2134	1874	1	1	5916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDxNrAHcRpuHypFemkDB5f6LYcLADXQomewDxzjEPVWAJGo6h
41296	payment	1397	1397	1678	1	1	15613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxJJFBa4Ny4iggCdQECiWENhM9XnYrZ7qGdw9XRtEpuGbJ4px
41297	payment	2134	2134	1874	1	1	5919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbkvs51UT7iXJ6VBUJ4jZy7nB2qcsoabDENcVJroBTJqm7ehf
41312	payment	1397	1397	1678	1	1	15621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvk8MGPVhLQk695bWApvVS2VqXNPNQNhtC4wEeCTe9wJiPVhmH
41313	payment	2134	2134	1874	1	1	5927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofcVmwYyspphWN1ejh4C2PZamfD8D6vqKMjZFpb6rqvuETzgN
41318	payment	1397	1397	1678	1	1	15624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYajVjqffvVnLVTJ9CM2w6Cy63Ve1JL2xvwLKALTAFP4uNUqf3
41319	payment	1397	1397	1678	1	1	15625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5CvVJUnweFc6Vohb1actAZSFmKyPEqqFMpe5re4txTjmFkRq8
41320	payment	2134	2134	1874	1	1	5930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GMo8vSZrCewfSDanQX23ssQULbCsi73pWBb8wYB37XoW9b9Q
41321	payment	2134	2134	1874	1	1	5931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhHPnvgSCxevZZxDChrZhenzfq2nttSGNqxJw3tagPeGvM3NdN
41330	payment	1397	1397	1678	1	1	15630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUd5ycM2kwGJH3p8vwbS7Nb3AopnT3yA97epGQrV1RrKj2WDQ
41331	payment	2134	2134	1874	1	1	5936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzhcBDPhssvcaXBK18B4x3kpATqPLfrjBY277fw2ei7nLwHneZ
41336	payment	1397	1397	1678	1	1	15633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpR6ZSjUauAyJR5iuZnmEo6Nkpsh8DEJ8yAyTdaoC2Le6wrTEn
41243	payment	1679	1679	881	1	1	99	1319892832000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpaBDKGRnfU4HNSgdmqkmSRqej2spEE91BPjuAT3U6YXSDAd2Kgm
41244	payment	2134	2134	1874	1	1	5894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq4iGABALz1yCaaVGb8B63o9mUt8sUZKemWkiW5QW3DvF1tVkv
41245	payment	2134	2134	1874	1	1	5895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGkGNJ4h8WNXFpmi5dzED56SNuDyXaDjG9qaWAAwBXQ5BnaA6W
41260	payment	1397	1397	1678	1	1	15597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzWex3LfeJoGEebfbU2FByfmp6zDRJR6SjMCkY7F1rnokmBZe
41261	payment	2134	2134	1874	1	1	5903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCU8gQXTudmGHvXh5odzntcooL6LzM9VBaHDsxZc7V8tFUVenC
41284	payment	1397	1397	1678	1	1	15609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXoLXGjMmPdeQsJrnwzghNdMaDJDWWAy2zMUYYYJCpmj8V2768
41285	payment	2134	2134	1874	1	1	5915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pCBf5aFjFiND69G4ZY7DLbDkJZtY6vwMDvnV1EwPt265KExq
41288	payment	1679	1679	875	1	1	88	480576364000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZjmbZWt35bkqTTFmtGa1dvi3HAFAYJjeU3xf7VtKyHrzm7YVhF
41289	payment	1679	1679	879	1	1	89	304590654000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpYtDjAUk354xaNX1LCVnpeFC2zNf9AzvpZaowdsTRE3NQoBV3KU
41290	payment	1679	1679	881	1	1	90	1319892832000	10000000	\N	E4Yd7qwaRCHR6t7i6ToM98eSUy5eKKadQUPZX7Vpw4CWBvWyd8fzK	CkpZDSseU7ygEPMHFECErjPFBQHise9roxLshV8oV8Q7b2RJ7XZgR
41304	payment	1397	1397	1678	1	1	15617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZw9yELUK4Nen6Rhw2ptLMpjGQ8zDPDzzmgkumd948BDRvjUS
41305	payment	1397	1397	1678	1	1	15618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdy4udhLR4iDc5MXaVkXRwp29Ze5xAH46Eegrbtr8VHyp4jpCn
41306	payment	2134	2134	1874	1	1	5923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqsdi7VmsxqrZQvfpV8Hr1DeGgymTwujtGFX6wfSRvi1NRkWo
41307	payment	2134	2134	1874	1	1	5924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2Fy2rRjdGsmkzajDtqQ6nPqMmjNTQ6u3MmD7bEAUA3MzrHhQ
41314	payment	1397	1397	1678	1	1	15622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtPdbF2UmS7A2dVgsaa5QcUZ7X88MykaTaneszJKby4prHLTK
41315	payment	2134	2134	1874	1	1	5928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBYxtNncAZA6v1gKcwnPvvgZnjzNEb8JeA8BbUFUaHpJkzfqt
41326	payment	1397	1397	1678	1	1	15628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3N9QBT7yxA8KZzFypuwGzV7LdhcET1JM78XSSPzNdYDy4R5G1
41327	payment	1397	1397	1678	1	1	15629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwbCfPKLLYtWHcD3sq8HeS23rrh2qiUDtwUuskpmch4qhdzyhU
41328	payment	2134	2134	1874	1	1	5934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnC6rtT66ofBbUKofy2HvnchhzD741i1g1kLNn8jHAfurgSG6T
41329	payment	2134	2134	1874	1	1	5935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGiCVAStmW5pEosCP8srttvGW5hb5TPWGC1SYrPDtH5nTPS5h
41346	payment	1397	1397	1678	1	1	15638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFT5JU4Ry3dg1G7xw4wLDq1QLvQqhWPFzFqWno7q77Ls8EmtP
41347	payment	2134	2134	1874	1	1	5944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQacqEaJAyomv1ARaHPMT8pjKSwEcMqgL2D2viC1gt5NDRwcx
41352	payment	1397	1397	1678	1	1	15641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2RVxnaU2ux8FFpm2Z7DVDG2h8UtkL2i8mDwZcqGFAE3HX7pwm
41353	payment	2134	2134	1874	1	1	5947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8E4U5HmoQTFpVPofyaRSyxbbWjvnFExuotoGcoBvmHKK3Hsm
41372	payment	1397	1397	1678	1	1	15649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg2MDZbgTjRKm86AhpGrSWht6kXGSFyWDBdc2vCT3NePgWUJhR
41373	payment	1397	1397	1678	1	1	15650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL814z6TwA4mELVAjVmGx1qJAWjW4NQcEN57y2JT8kvuGWYWSE
41374	payment	2134	2134	1874	1	1	5955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoQgrtoqbBEQfDHc8ZTFAJwwjZCJ32VfCG8aBmNWriWnqQVhd
41375	payment	2134	2134	1874	1	1	5956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoWfgH1AdaqFAf18xtN1ox8D1taRUJFt7VMepAn6MbEo6u9Hg
41376	payment	2133	2133	1874	1	1	5522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZigS7aYCWLahqmj1sCrPiHXPz9VG8UUs2EAZCki69M3twTtNzs
41377	payment	2133	2133	1874	1	1	5523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf6sf47pzKziFxGBmLnfobo9Uv6Ds33oWaqbLwNb5LuNmxzcGm
41383	payment	1397	1397	1678	1	1	15652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsU1JELA9Qxk54qMVZfENkscuyEXGf4meUKJCBYcsG23t48BJ
41384	payment	1397	1397	1678	1	1	15653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WbXwsQryqbvhYrn7f99LmnHe5sxkZHVJvxkhtzUqxpFa8Qx5
41385	payment	2133	2133	1874	1	1	5525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoeMC4MAVdSSPmZMCNCerXcGxRon4o7YwXXekkD8UKLmsQAiNC
41386	payment	2134	2134	1874	1	1	5958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjGX5WnR6KkbC1ESLpXd2JohnYUhyZ4nPSAtcf4Pb2yG4VShCR
41387	payment	1726	1726	2332	1	1	8289	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwArxgwCGcF9ecz7B1xhazXQLcpTqSZV7Tyiqj5PREuu4Co8HC
41388	payment	1726	1726	2333	1	1	8290	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNEjjn4zriXZczfQMKsRCNkdYC4G7qnsAwwz7zmr31hryfaXPJ
41389	payment	2133	2133	1874	1	1	5526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyey5HK8pX4385cHrngYfwd4WkNBVSKgkoQKAYTptkm8EYbAKk
41390	payment	2134	2134	1874	1	1	5959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YFbLMjCjhdx6qQk3dPYq8y1EcunmVHpkk3QiPnQPRLXxHAaU
41273	payment	2134	2134	1874	1	1	5909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBsmLVg9PDkPGfq2EXaN6HJqo3RU2dmusQb9ctMPPwL66gA77
41282	payment	1397	1397	1678	1	1	15608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkZhWA9JY4atjTBsZnBphLLvVhtwdcpTCxrhBG8AJHH8DSCe7
41283	payment	2134	2134	1874	1	1	5914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVHWGfC4pGzbhcX64UKcnxSLT1TBXgbg2g92yZRfMmz8ZWYjV
41298	payment	1397	1397	1678	1	1	15614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcbyhQhz4DHDnxMs5qJyCiPQedaeUS6qpvZ9eV4MX8DCA692n
41299	payment	1397	1397	1678	1	1	15615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nwpnH6SmzAZtDcw17Y4gs7jG7q9y8aVa2PhpuLpxUfiYGLGY
41300	payment	2134	2134	1874	1	1	5920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7jz6HwqcNHxkkHsvFnn1k7dL85FBCP6U6xaxHf5v2dTDgM5dn
41301	payment	2134	2134	1874	1	1	5921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtCFXzL7zkqmp8JDyQobUZxL49Dq9xSPkzR49da3Y1H5GuN2o
41308	payment	1397	1397	1678	1	1	15619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFdSTKEgUkJAtKC6V8DgQTSbUuPNZRZWB3xZtNsnAivR1sYR6
41309	payment	2134	2134	1874	1	1	5925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs2Pn55raJzksWA8ugZCiwUETdLfHLH4KbQEBUP6B6Wo66Lmm8
41322	payment	1397	1397	1678	1	1	15626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdZZSzUjWNNAF6EqWwGYTpDDZMJuaaK9kz5CMMVVGFtonKJjC
41323	payment	1397	1397	1678	1	1	15627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDvgTxX4SCuRBThG33UyFnQ9aaEQ5Nmt1debemXE2e7P2fVyY
41324	payment	2134	2134	1874	1	1	5932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJkDfQwxPaqLFzAUHZtwfXqSWd9tJSgAVrGLi12mBC6AC79bf
41325	payment	2134	2134	1874	1	1	5933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrQnGPk7KprAL6hExzaMNmZd6FXSUBjV8smoYo4G5X3PodAu7
41340	payment	1397	1397	1678	1	1	15635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5iuStPSLu7t4mYkxD7Um1TwnLpguH24XavLHLWgHSbSQPXwk6
41341	payment	2134	2134	1874	1	1	5941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpFEHr7WKg7521VSSQtAZ3PLsGpQshmoKnfQ1ciEaeYzCe65p
41348	payment	1397	1397	1678	1	1	15639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbVf9bUiFvYMZ6zKuLp3YM9xCDHD6jTfXnAw9z9UaX9iDVYgYY
41349	payment	1397	1397	1678	1	1	15640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78RPYda8EUAnWzEb2zrbq2aZtRoo5c88a7wSy4Xb3u8CeB5w3
41350	payment	2134	2134	1874	1	1	5945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkZByk2U5trEYBvGSwiKtK113NuWWnSpPFjHNarnwv3Dz2DgP
41351	payment	2134	2134	1874	1	1	5946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRHFNobd3FSSMwFYxViig1fvF47HJvQUfJoLghfwHsBHErzw8
41356	payment	1397	1397	1678	1	1	15643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39Ki8R5nfMffYh2VzfwFvkMgP3Lz2rDwW2DECthxoNo4Cg3W8
41357	payment	2134	2134	1874	1	1	5949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjipjoYGRxjtzEgdxeAY7RSK8n5z4c4Td7ukt6DxaQakstiUgD
41363	payment	1397	1397	1678	1	1	15646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjDkEtHyrK8uovJnruH7WBb199WtNwk4sWkXUoFz64bYCVjxe
41364	payment	1397	1397	1678	1	1	15647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6nFsi1gNXisHJCp8JULnfHh82qQbgyabaWGkjAkb1WZYQkCr
41365	payment	2133	2133	1874	1	1	5519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoWJuwmqy1T4CqUBe2e5UHZyRM8mb94frr9781bdmcJcAPk9hV
41366	payment	2133	2133	1874	1	1	5520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRs39DLE6Z4nemeJmaHE7zd8cZcQQ9iQNhrsRZ3cGUES6L2sX
41367	payment	2134	2134	1874	1	1	5952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCia8mpd46ubUicRrbKDfS75mbQgV4jNw8pE1DWmJ88Uf68PY
41368	payment	2134	2134	1874	1	1	5953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkpTHQ4RVfExGobUtpG8J2n37EZYKHdBN5MBZhDHg7meMGGxPH
41437	payment	1397	1397	1678	1	1	15666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYez2JHCzivDSVNm5cX9f8mfRzxzMA1pNZ5G94HfARSjjPJu9za
41438	payment	1397	1397	1678	1	1	15667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzwyG1JnaB2bEvHeYF2DmKUMUuFY35rw3c2nUZSwSA7GWj3WP
41439	payment	2132	2132	1874	1	1	1559	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEZnGANQNeP5nug9FUvEFLcDdGdazmC1pQ5fYiejDqggRcVtw
41440	payment	2133	2133	1874	1	1	5540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdhYR7pjk348AF3ix2G3GZYSWUNonyeetf5cF6y1xEGKmhGfd
41441	payment	2134	2134	1874	1	1	5973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd18U5CfYr72EMDC6RhgCfHMBQPYdxRjujSK6ND7QTKe1KWQAe
41442	payment	2134	2134	1874	1	1	5974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYACy9zgViQVTfvRJc9uMi6FAMfkde3uE8ky4SfWXkDDiBNgj
41443	payment	2133	2133	1874	1	1	5541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBV4c9RfsxUoY1po4aMhQDjwK9MrfXw6XBwGqKKDW2ehjgCvT8
41451	payment	1397	1397	1678	1	1	15670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WXLZ1upBUwxwNV8cKa6s94BeXDa9Ra7bAZC3Z9fTPevxXxzK
41452	payment	2134	2134	1874	1	1	5977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkjq8ngip3hh7gFTtHPRUWGduQUhWkgJyHkkPjRBKRhEPzoqt5
41453	payment	2133	2133	1874	1	1	5544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXK83cwBeTTXnTJZFndMXHi1ni27Pftt6vfhruVjtwBFzTuNkB
41478	payment	1397	1397	1678	1	1	15677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBogFgMrqkJSXDfUbr4sNvyLyUbo2rC3GcU47tKYX4grfGFSbi
41280	payment	1397	1397	1678	1	1	15607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWMTb4RwnFc4VMajLR1UYU1dk3qihi3bXVdmnZFH3hSav3ukX
41281	payment	2134	2134	1874	1	1	5913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqX6Wame59nDVzq1wNv7vqWiuRkRFwZPct7hMKP9nXrSykxaeq
41291	payment	1397	1397	1678	1	1	15611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4p2TfKr4VxvciR1j9KdTqVQt2g2TMvgjvKJPSZS286Cecnext
41292	payment	2134	2134	1874	1	1	5917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjxjir6AAjLu3kvCWr71z71nZKD113Y9NwEiTeLSRFpkGSWLX
41293	payment	1397	1397	1678	1	1	15612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ8pNWP9EgKopYnC2WCJ5GzXaAa9HiwcTPQvuDxZm1tv8kcFeW
41294	delegation	2320	2320	1600	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqc4UHy8xCUqNBXknVZUaPzauPEsbe43iQM35n9uUqBTRYYUAv
41295	payment	2134	2134	1874	1	1	5918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqHbvWuPUCBM3UqdfaWwT5U7uwh9Wz5gqwfTJF3dYPWAKUbiNw
41302	payment	1397	1397	1678	1	1	15616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGoZd82HojE6cuNcMf5LCuZhhbkiMkDFxMw6XRooFiSKF81AP4
41303	payment	2134	2134	1874	1	1	5922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8hBYdMKPFvCQ158KM5tDxjTHgpkB8aURLjnhWLbkRHa5MzAP
41310	payment	1397	1397	1678	1	1	15620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBzYw655coCE1BuQWbdDJF9jfnUn1MWSUDnh6gg4TbkscvpQHa
41311	payment	2134	2134	1874	1	1	5926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGGrfwAV2FT49jhfFuweLRE8AYQ5yWjhVyDBbYrABfDDZ4Fb7y
41316	payment	1397	1397	1678	1	1	15623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivyxrR7bVZmRwX7QD6PSVEHaX2sqaWN2AatiWJa1EYA6qeNiD
41317	payment	2134	2134	1874	1	1	5929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48B3fWCkdLZFaMeZKRyUR2BdkxqjY1QianphJ81oh4ZpqfPks
41332	payment	1397	1397	1678	1	1	15631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnEJ1kAnoQ5o6AEDpKMp3P2PrdBgHytNpBK17bGEeUvhy1HUd
41333	payment	1397	1397	1678	1	1	15632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu35mCzJcifB1pLdGE54ThFvsZPCeBSWSSwqNJjcsrP1VZTKcf
41334	payment	2134	2134	1874	1	1	5937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyd2GoYGvfDEcPpqMetBoKBwDKpePqBRNSycMVsb6pNY7BMPDh
41335	payment	2134	2134	1874	1	1	5938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA6brDTQTsfzxbVLsbVnnKE2QybmU4XFtsM6Lp79pjrvsVLMW9
41342	payment	1397	1397	1678	1	1	15636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAczZvVDZ6nQwr2uaYpCMA2FzKfafpYb4q5s9sB66Nt4qSBTUJ
41343	payment	2134	2134	1874	1	1	5942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjT1jL6kUJ876XhJMDZTYGLpoZVsPxFyRfNc22XUBejVNz7yg5
41358	payment	1397	1397	1678	1	1	15644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWM9nGZyH1zeHo32X1PPxDo6PMe5zDrD8YgJ1yq4rH4VYCWa1
41359	payment	2134	2134	1874	1	1	5950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPXDW69v6UKSNCciQ36N9dqVLC8gdbJuMDB4nKEhFcsV5thbJ
41369	payment	1397	1397	1678	1	1	15648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqifeYY4d7oytTP2wQnQSmHtu3fP1mmcSbULUn8L7hKaHf1vgU
41370	payment	2133	2133	1874	1	1	5521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1pfBXE6k7m2c4GwfWvrztf8j7d8VQam8cGNaS5r8SKise5UR
41371	payment	2134	2134	1874	1	1	5954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsSWpBzwGFaELfdzSic49YikgWXD6z2ajrbKLBNvVTwHKP9f1o
41378	payment	1397	1397	1678	1	1	15651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1SL4J7XfQ2ZA4z3YuKpFmaezAUg7qNc1Lp19ZpQZ1dnU3qCH
41379	payment	2133	2133	1874	1	1	5524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZR8XPJ1kjVRa3joE7fTvb7fcS4dxw1dd94wvH3DSgiH1Wok3A
41380	payment	1726	1726	2330	1	1	8287	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYxZKu47QtbCKF6X3zgMeoGgzRcujD3iAPFoDSqGoN4gm8r2KjP
41381	payment	2134	2134	1874	1	1	5957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokZoBSRd9b4vZYWP3LggvzGtobceDhhScsJfHNRBSmDyLfYAV
41382	payment	1726	1726	2331	1	1	8288	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa8JUrxApKmNeQijoJpDL54wWeBsgUejBnLGCBtsDqPw1JXXXR9
41397	payment	1397	1397	1678	1	1	15655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWc8TzJ9o7ukm96dMnNt2a4NkzxmDZuYqQLTnE1bMarp9AeSY
41398	payment	2133	2133	1874	1	1	5528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSf8ozj9KoLX7DRnXFEiK9ZGBdhvyTTF7WjfzsthR4FhGrL1ji
41399	payment	2134	2134	1874	1	1	5961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCcum6PzUnGJgWPKCNxfffvEe14ajwsHzSTQf6uKZ3a7YhgGL
41409	payment	1397	1397	1678	1	1	15659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjs8kMptkCDR4nAVTcfdY9e2j5FBP1N86ZYwrrsgZ7kq2tvX4e
41410	payment	1397	1397	1678	1	1	15660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZe7aqHeWw8WvfosBL8wDSAWRs984eS5SzS7bWiBXgFgPW5id
41411	payment	2133	2133	1874	1	1	5532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9k2eu8PSow79YCHR21nTXUJ8vSCmMEd7NvLjKSF44QbtfCjs
41412	payment	2133	2133	1874	1	1	5533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSrFE5EMYyjAYERbYET46WZBHsGJe6DBndu6nBYwvLS2uYGU86
41413	payment	2134	2134	1874	1	1	5965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMufzuYKCBtiTkYxcFs7RPY1nrEgmw44ibkpXa7QNqDTafBDk
41414	payment	2134	2134	1874	1	1	5966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRektL7VALeCZkEUBXZCDKatpXTk7MypssBwQjakxEKgMKba5y
41337	payment	2134	2134	1874	1	1	5939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiitUXzp4rAiNHjfFV2NQ2ZZ6FzNuv8Lo6wwVDVtmENzjwchDc
41338	payment	1397	1397	1678	1	1	15634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7ZUtvb8jKY4qQCzrqPu1oy5hXutqPuhr4zpcSyQmydtfUf6J
41339	payment	2134	2134	1874	1	1	5940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9FwsgPADyJ9cKWQj9Fs1J92GHVSwGwYpekv8NTuBGxU3vj8A
41344	payment	1397	1397	1678	1	1	15637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p8krfcC4NAAQeGkFYyRdZsfdDmi1fpbz4RFfzKSA6N1N5ZeJ
41345	payment	2134	2134	1874	1	1	5943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6fc6Zua2UV9BihGpPe6DyGeiq2NhMMPkWiJrv2hYabtC55aX
41354	payment	1397	1397	1678	1	1	15642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3cFFdyxoWKB28ZjFai1AruhxvUHNbC1DyJUpX2115VhKUiqa
41355	payment	2134	2134	1874	1	1	5948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUWi854zmpTKbjoN7zbLqrPx2bw49E9EvSjtGsqCJmsqtN7oZ
41360	payment	1397	1397	1678	1	1	15645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDBpxS53pt1BNNiyWoTX7QQZ7wJZ5VkNLGVXwURgYmcqkHggyA
41361	payment	2133	2133	1874	1	1	5518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDUgf5ZEyGfnZ8gVAtmazi3V9E97AFMmY7tsTW5pwA7aftgFf
41362	payment	2134	2134	1874	1	1	5951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrc6XrhZUngMNo7YwAsJZZj1XLedMjTjL69VaeCYz9xzMwgBC
41406	payment	1397	1397	1678	1	1	15658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4j8ZnrvPS3bef3qcvbo2uu2bJ72SSUxGxujZM3mXxKRDkPGQy
41407	payment	2134	2134	1874	1	1	5964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeorSmQnqafeHQFi551UAt5Tmdt6TSXZoEgGEimM4i71gxuQAw
41408	payment	2133	2133	1874	1	1	5531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNRzvv8cFKoKz5wNbyL5Tpufa9owm5jLrCpZLtJh8qamGUPPK
41417	payment	1397	1397	1678	1	1	15661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjk3A7KyreADzrg9VAdcWVC1PvuNdw1hfsk3yhHENsHYDLk5xk
41418	payment	2134	2134	1874	1	1	5967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRubvgSZtXe95hfXaw1Mqv5DdQQ4wE6EYSjkzyJubPfRrtepkF
41419	payment	2133	2133	1874	1	1	5534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rv5PzdzqhAPNDBAgue6GRNMnvJhZbVeFBM9kw9ayDjGyHNpD
41446	payment	1397	1397	1678	1	1	15669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBcQ5WvDLXLTyP7n8wBpc3cYaRCWw81smSX3dtpL5tdYFC5JJ
41447	payment	2133	2133	1874	1	1	5543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYDaYFYmNZoggo4T8ZUr6PFn83URt6LBvuLiosCxaJApMpAtf
41448	payment	2134	2134	1874	1	1	5975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9mKXdvn97CvKeyvcc3KcVevnrm8SyU3n2hbLZpAvtVK5FgCAd
41449	payment	2134	2134	1874	1	1	5976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvT2NadP8QczPgBJHBqB3EUgGJh2XucDediASsYK1zEVrFn5a
41450	payment	2132	2132	1874	1	1	1560	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykLPUZ7G7VQZUGx4JTaa48ZJ3iZSaBj8asnPSYPvav5e9GA59
41473	payment	1397	1397	1678	1	1	15676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSPjWjWa69Ypqr2kFaV8rHhqHvkrfvfm6Dh1qmu4a8pfYj79S
41474	payment	2132	2132	1874	1	1	1562	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgD8gBUR35UepAWz95WVnHJDZnQawSY4beBWzmgtZuLthAgYb1
41475	payment	2134	2134	1874	1	1	5983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7AGeG7DL6aBRvfreVZBh3j7HiMfwQG6hGLfJoVK15aRgysh2
41476	payment	2133	2133	1874	1	1	5550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySkhHtTPg7s6529NyEeMFfUq2yDQzj91VNakb7kfsjMQhmyMG
41477	payment	1726	1726	2340	1	1	8298	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa6ejGt4wvQMFHv9wVE6jm1RMwNbGnJ3k3eKMMBtqi1L9QdrQaz
41495	payment	2134	2134	1874	1	1	5989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtkFxkDGVXcZDSf7S1nTP9USrdYnvaBWos4Lyo8wQFsVbqWnJH
41496	payment	2133	2133	1874	1	1	5556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2eWTH9dK5vUZkx7RXsi8imc1VYXxzaWr74sp6KjAfLUiJMy3g
41514	payment	1397	1397	1678	1	1	15687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5N23Y4uYJYFxjBs6fT1eKk3gAKsKE18qsXiEGScgosGjssHnT
41515	payment	2133	2133	1874	1	1	5562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXiUMat51yf7s6Sve6rdCQsALN9nVtdnBLxkC36V8Hw26vE7we
41516	payment	2134	2134	1874	1	1	5995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwWFGgZDveSJ5YbauWVPVBS7e1jBPxrmA3gfcrvPuKaaXgT6Hh
41521	payment	1397	1397	1678	1	1	15689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8Rk2raktDJc9jG4K1SvExfYgBEox8QpR4eQFwcMZuqhrfnnP
41522	payment	2133	2133	1874	1	1	5564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqBzaJPtxawy9XVwZDe8jdi85oWtjJHFurLcjEQ1r4rueJ7qW
41523	payment	2134	2134	1874	1	1	5997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7DeuJwLxzzBcSLfALoMJqPvQP5AZy5he3Q1AWmF74uDgFsJmQ
41527	payment	1397	1397	1678	1	1	15691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRpMPS2dgLsMvVuR2g3t8Y3Re9W11qasTRckiEbuhw8NVWbVj8
41528	payment	2133	2133	1874	1	1	5566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAt9bq9EDBkBdsF7oVtNNyXsZFawJVN3HNivCVUv6MmiHBELC
41529	payment	2134	2134	1874	1	1	5999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZav5CBc2dDPBeVV54z8K5yJgN3cAkhurpaYfbRq7xoitVvb6ae
41534	payment	1397	1397	1678	1	1	15693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SNHqxMPRSeSSQMA7KDpt3pZjV9u7MLiErkLr5LLsWfLsqbNF
41391	payment	1397	1397	1678	1	1	15654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgWSBXBzVQAfEE9zsPdwJa4QTesQk5GMjPUFiGXFLqqPsnryz
41392	payment	2133	2133	1874	1	1	5527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZFhSDYkC1V8jiVfMnWFRFzqTBZUT78LNaPWUqcZDdnKvxqL9w
41393	payment	1726	1726	2296	1	1	8291	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZSb6BLGiacMMbeSg6pBumpEEYUBRUpfD3DKmENSCogVzjK72hY
41394	payment	1726	1726	2334	1	1	8292	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiev8CBzyqHonFM6QC1nuhK3ebcCGiKs89AiexUEX4279UM3Rj
41395	payment	1726	1726	2335	1	1	8293	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZUgtYjkEqDDkbko6RtY3PxXySkSacW549skXAhkt1GGfMhhpxW
41396	payment	2134	2134	1874	1	1	5960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGH4sZPAbMCWvUNDMGPFJCMYTCnQqm52FmmjTtiUQe1Ntkh8f
41400	payment	1397	1397	1678	1	1	15656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvCnDv1k4jnCXvqC9R54RwT6zZhyf7EPuUZqeZUJZQ9SvdGtc
41401	payment	1397	1397	1678	1	1	15657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwjmRv1hF8rhZ3EMmME4WoAP2pY1TmMgHfJZ75LtFT913GSS6
41402	payment	2134	2134	1874	1	1	5962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYv3iJgnMRZyRSrWMXmCrz1QWB69WeumdtwGhwKAhVvEEtUdr6
41403	payment	2134	2134	1874	1	1	5963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZJfLH3fqcEwVkuW1Sc4GTwQGARwdbE2dGN1q2TMrpvoWiAv3
41404	payment	2133	2133	1874	1	1	5529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2J6DmPKQeGwcVzF7aK3TghuQPYqm3eAwoia2MqNyvsHrXcgsb
41405	payment	2133	2133	1874	1	1	5530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfe8jTE9rt4CJDHoYX9evhY2djGQkNNZARX8f7Wtxr5WXdcFXQ
41420	payment	1726	1726	2338	1	1	8296	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYY1isagbBY7VnxgmL1ZrsCo9hLVoHQnxScztN2VCsa3wWpZExD
41421	payment	2133	2133	1874	1	1	5535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwsPGa3Z8oRmDsV9TVFXMih2TVmsHfEhQCZkixKMwmKJUkCuG5
41422	payment	2134	2134	1874	1	1	5968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62wTHmFQTt6ZG4XQvzYLC26648RJHhineCx7d2479u1wBEpmK
41423	payment	1397	1397	1678	1	1	15662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjeFJKht6rr6Xa31QmWDcRyPimdNxwEbD31eFeNJb85SE5EH2
41424	payment	1397	1397	1678	1	1	15663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeqvdCGaRF7331nT7kRyqJauoVHWdmFRb6WvMnDBvqUUKQgzrh
41425	payment	1397	1397	1678	1	1	15664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RbMMFv15ZUwqkamA1nPXwX6eFK7QVwmMJyHG7Exu1stBj4Hd
41426	payment	1397	1397	1678	1	1	15665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAPwpQDUN8dQsZDBgLsXaJeufKvgsBXh51snRSGToFAfpFTyU
41427	payment	2134	2134	1874	1	1	5969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeJA7kJX9kh4RjXX5r4gMH7r5wNLsrguqBDChYJRAnezXpT9w
41428	payment	2133	2133	1874	1	1	5536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYLHYsknRb6aC277s2swesUk9HhEeWQx13bw78BVeGbcncCjU
41429	payment	2132	2132	1874	1	1	1557	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppyBnqmKVGNvHh2nRYLi6YmtHa9FVrZ15Py6SpArow6xKtTTu
41430	payment	2132	2132	1874	1	1	1558	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVZgyJ8QnkLgd8coMNLKdnS2DGgA7dWATX9SXyPMGYN83RW5nm
41431	payment	2133	2133	1874	1	1	5537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9repmCUfgf6Sa4Sy1fZuC93LeLtDvtDydHzJNcA27PV2RBTaH
41432	payment	2133	2133	1874	1	1	5538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo6HoHtyFDhQWvU211un4wEcqf9NBxU6kqFiQfkZFmEKTJgoEU
41433	payment	2133	2133	1874	1	1	5539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBJwrDhbSF3Gnj97CSFH46yTp2qNzM83dST1o1P8a4T64rrC4
41434	payment	2134	2134	1874	1	1	5970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCuuDUGqFDydpbKpxonroMD1AXsemwTsz8drAa6CKhzPaWUUMm
41435	payment	2134	2134	1874	1	1	5971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrT2YuyAyhQs6N77We6nfkhj8XKXtLZNvY57sdSaahWVAV52ok
41436	payment	2134	2134	1874	1	1	5972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWW2eaNLBqKMKeZREmghg7MbfjFLHWNM9hrwbS4jiHqtHVK5aB
41444	payment	1397	1397	1678	1	1	15668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1N8VqFav3AG8wVGyGNAod7QkNDknCBXnhBQpcqy2jFWJdg4fx
41445	payment	2133	2133	1874	1	1	5542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsbTVrHJyVHR8CgpcFtpa39NCLYn8S7dzRecfqGqeaobLQz21
41458	payment	1397	1397	1678	1	1	15672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbLL6W6jg5Hzcj7ySARSr4mQcGRjJpqkjWhtw46sQtwQsZ3SW
41459	payment	1637	1637	2329	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgEoK64iVFCXjyF8pCrF7CtMnfurb3hWWkDbWhuerkP5CAtvy
41460	payment	2133	2133	1874	1	1	5546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs59vTpqxhcvWdhB8YaPYF5zqq25QQuwSNPSgCj2GyMfCSZM4X
41461	payment	2134	2134	1874	1	1	5979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTrSJA6LNT8tZqwKtYJh8gAKUqotXUNj53GVP6tBWYAWkZ977F
41501	payment	1397	1397	1678	1	1	15683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjKjNkHrEyoNuCe6KXodNQ3W1soUeXcwwDjG13fc7xrenahnk
41502	payment	1397	1397	1678	1	1	15684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNXDVdVrpPEiiUn5BEb6xfqCfRjS66f2NdUVMcFq6B4ShWWcEc
41503	payment	1397	1397	1678	1	1	15685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHDJpH3Jr2e4vPnN49XBPYz9mok2Nou9tGHkRs3ENH875Tqom
41415	payment	1726	1726	2336	1	1	8294	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaLevaVLNU9CDQW882aQ2pHksUB29yzU2GoE1iBxNT9y7wWQZ7P
41416	payment	1726	1726	2337	1	1	8295	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaJLX4YYtpAG8aakne7FTLCVr3Ak8KZqNSeCvo61RdMr54JDyvQ
41454	payment	1397	1397	1678	1	1	15671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptQ9vbeGtvyzNS31r29EDFfnW27Qsy7SnikBo3hVutdVeP5qE
41455	payment	2133	2133	1874	1	1	5545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4NurGHYXrVBhdGaWfYjoSGEJkqpNv4FdDQZi3N9XThJmKZZH
41456	payment	2134	2134	1874	1	1	5978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Ww8mdu523wctHLMFFi1M72UNFeYd7d9PBfFEpJxNu9TmDBXY
41457	payment	1726	1726	2339	1	1	8297	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZaqe28PfoHtXvDWtRkSKcnkAqqzZxnYb8E5LFLfUmrJjbdGXmu
41462	payment	1397	1397	1678	1	1	15673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11fN1vqYRA9ThB2f3Xk82aQQ7LQrpXEstHJ6Xo1ANpo4Y8yXG
41463	payment	1397	1397	1678	1	1	15674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMZjxZEYbdpHQzyucQPmh7jNVoraXxYfeAFSD359yLFTAx4mv
41464	payment	1397	1397	1678	1	1	15675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdyvseKoADMyTpCnkQaH3gxgwRrDkCRWxfVwcgXukXfbgvApG
41465	payment	2134	2134	1874	1	1	5980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZAwQfB9hEWRGAwQd9rcMvWbx6hhrwg83UFW8o2KwfxwrsKXQ
41466	payment	2134	2134	1874	1	1	5981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc6751dceP7dZtcnHxZvUgQH8ZsB8Mk2buAnNBUZs991iJuH6i
41467	payment	2133	2133	1874	1	1	5547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPGFiRcMxRVEA8w9dc52CisD1d19cF9zgjuEqED2ENvYh6AWhQ
41468	payment	2133	2133	1874	1	1	5548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwvFWUDky1kgTksqZgjyC9mnQCPh3ASgi6b2sBTMYxpLwNSM3
41469	payment	2133	2133	1874	1	1	5549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh17435dsm7dJ8GGnGWB7iQapWkhRuxJJ5jF59uZHjTJcEHwU3
41470	payment	2134	2134	1874	1	1	5982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeEc9hYStY4DgZmjS6y3PoYz5xCcGaNR578PVYVKpraXvtqQC
41471	payment	1637	1637	2329	1	1	1	301686177819988	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgiQZimRzYvrwM4suGorXycdB5DzNyP1LqEEWrXZBhnjGnPbkW
41472	payment	2132	2132	1874	1	1	1561	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3Qz3cqD9t4hyUxjS4nkqfxJ7U8ZTpgh1peXp2qftK2mePTVF
41484	payment	1397	1397	1678	1	1	15679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgu3mjc8FUtYyJ5xiAsCmErNgAh9FY3uVHGyxs4KKsaHojM9z
41485	payment	1726	1726	2341	1	1	8299	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYQ96NTD5ny32HMSySU4C65y9tRuR6rA1wrbRKsUJZeQrZerYUE
41486	payment	2132	2132	1874	1	1	1563	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU2dRRXmZY9pSn19LeNyBwr1GtJJn4tvzkcngGz3XAmDR64k8V
41487	payment	2134	2134	1874	1	1	5986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXswDGy5u9sMcfNPWsDt9qMzTJ2L5jMQQkqjyZazzgYDBG6enD
41488	payment	2133	2133	1874	1	1	5553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9zcnFzu3qW2RZw2rfAepAYvB1CoHBSipkK4zFVhfyR9qg2N6
41492	payment	1397	1397	1678	1	1	15681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQB2fs3NQiTSAmtxDAmNJq1c2ceQEAuUqvwjzdzvEzqNCXEeBq
41493	payment	2134	2134	1874	1	1	5988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2oMyt2Gmhtv2ne5iMqDVhMv9a4RXQMQm4zv9hzsxKLH7wgyNx
41494	payment	2133	2133	1874	1	1	5555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYBSLNNomLsHzft9aDGwNCPwmmUEy2nzESxRkxbCX1TLKfcJr
41497	payment	1397	1397	1678	1	1	15682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuq5Jqg9pA5qfVz1is7ocKR5jeKFJhjK59iYT9SCe8d7YxijPX
41498	payment	2134	2134	1874	1	1	5990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWft7MBWgik9jnnuXUyPAe8WZHFPJmrKZJ1RwTBZVoH3ARbvT
41499	payment	2132	2132	1874	1	1	1564	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu42mHbJ5zEi1TENCD3hp7kBsWRAmGX4nQXKufH2EBB7jPxPCG
41500	payment	2133	2133	1874	1	1	5557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHFKp1P5hUMedKMM334hrjcd9Cajqpu4bcbnoJh5Kpj3qWo4Y
41584	payment	1397	1397	1678	1	1	15708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1RB7yBiitkVvpJ7U98PMqY67D9wq98T7yGqaRbYS8TTMqoF6
41585	payment	1397	1397	1678	1	1	15709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUty2WAaWSMQ2KF2y8fMzFGoqPNFKxEynDVoE3hc4d4hZjFiFt
41586	payment	2134	2134	1874	1	1	6016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6t2rT4RNWw5R78FfxvruVJksFqXwKks9TCfyms1emzEUTJCh
41587	payment	2133	2133	1874	1	1	5583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6vM1y7Ah3GAPoapudCwYbVh2mrQrizJfL46ruBumEXYBMRtzA
41588	payment	2133	2133	1874	1	1	5584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXgJuaq894anb489TSPZr2xHi9ta8sgSo9zrLRzmsmt1kRPwb
41589	payment	2134	2134	1874	1	1	6017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQq4zeSWMMek8BGbXQZq34PM6jcJwfL4PZ84JiS3ASsBdQCHET
41590	payment	2132	2132	1874	1	1	1572	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZNecWe9EjBdF8XnathV1BuRJLA5trztTxMpp55r2Pev4TkK2
41594	payment	1397	1397	1678	1	1	15711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejCAzKBspcm8RShQ2L1amQKsSzG57Rwe62y9sLvXaccW6A1Pr
41595	payment	1397	1397	1678	1	1	15712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4xnsitAZZF1rzy4CRvrQNyeNCzXKyR2ZhqNWUp7X4cH1fYcgF
41479	payment	1397	1397	1678	1	1	15678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhpv686RHwxkbvJ2i34ftKtSRtHonDFqiippbb4pmFvpGpCChK
41480	payment	2134	2134	1874	1	1	5984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMPvr79HRQmnHYfQFfwpWa529p1EdCD5pmJFAdA2CGarotoSn
41481	payment	2134	2134	1874	1	1	5985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFCdzaURLGG49UKaZ9Cg7LifMrQqw1sw3QaaZPLKb7pPEAEDe
41482	payment	2133	2133	1874	1	1	5551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9CfA5cp7UbjM8h3kE6qGmJ6JJSTxxhbpB1gXhsohtMcN7E5m2
41483	payment	2133	2133	1874	1	1	5552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa15CsnJazWaw8zgdYdahvzV8PNJV6VRGjqckJcz85sY34JWmzL
41489	payment	1397	1397	1678	1	1	15680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1n99b8EC4m7jDAXDCNT4CdegxoPGqQb1Spdh5uu64Posr3Rtd
41490	payment	2134	2134	1874	1	1	5987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrdrQbbGYj3MzrLUW5LWdviCwvTngtcoL7i5aZKwaPgMAKZ9h
41491	payment	2133	2133	1874	1	1	5554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkytYoy4z5c9X8ZyzQnsEewNtFx61NCQk47G622Ezvw6AbXVXh
41517	payment	1397	1397	1678	1	1	15688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFN3H9SPxY9WG69RAJBDHcg2cSdRRzhkwJahSEtFy5NAkF45EK
41518	payment	2133	2133	1874	1	1	5563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc153NQda1mY98vKdb6i7mm6zyKkKTw25hS9nmPXefhjgZ4F6q
41519	payment	2132	2132	1874	1	1	1566	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzCyFHcGCdHJsZiWYyBV66F43cLbuhogsGKWbsVkMkcgt2nctc
41520	payment	2134	2134	1874	1	1	5996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Rvpto1AtJS7VeJxURS9yvZCxkV9UT3SzGHkogVhkCyNKdcR9
41530	payment	1397	1397	1678	1	1	15692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1nhZYGnR3F78Hv46pmCm5sMj3VMdX37KY17AxqpZxoasGcr2
41531	payment	2132	2132	1874	1	1	1567	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnf14nuuvAn7c1xsuHWPRewAbpKEMkbHVJ6nCd48QRQ1ZdaoE
41532	payment	2133	2133	1874	1	1	5567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fucqXYKr1yvNeafAdgajBRcj6upZubYHG8wBUVYjHmEtePdJ
41533	payment	2134	2134	1874	1	1	6000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGSrhozdA47ouXMP5fmWAZBkpsDc8dTPJXsjvoBUnivQiNCxN
41540	payment	1397	1397	1678	1	1	15695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQiwub76DvLkoBJBPDJd4f2zyXeSp27u1Yx53kKnUqn1MbvfPb
41541	payment	2133	2133	1874	1	1	5570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbxGJ694BaLTM2ie6sJr8XJ3hpDrKfXhYUCzXsnFamciXyz22
41542	payment	2134	2134	1874	1	1	6003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMVo587Kj8vwwT842NdDMW4HPhXm9vJ3e2hfdETTevhwpzNKR
41543	payment	2132	2132	1874	1	1	1568	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqW9SijcX2TP2oN1r9M5XJn8mTLhmHy5D7n2MVxYMQTpPdZyv5
41544	payment	1397	1397	1678	1	1	15696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZNWoVQNVrLpbFfNa1fxyvDyjELZcMX9zawKG3cu8m95inE24
41545	payment	2134	2134	1874	1	1	6004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQb1R8nSu8aczxekDEscvKpNxv2DAZfujV9mVrgA8sSaxGZZ8F
41546	payment	2133	2133	1874	1	1	5571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGwucGard7npWaHsBSE3nudtEsyf4Wa98VxtDQbutdTpCXB1H
41581	payment	1397	1397	1678	1	1	15707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYziioz5JqSkrL3oRzhqEbJWzrhrsc2AkgKbvHvtsuqiFqzhxXM
41582	payment	2134	2134	1874	1	1	6015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqd3Z2jBgevcPx2teTp7HK2ppkaCtuJMyoReeKr6HFn1uSfRXb
41583	payment	2133	2133	1874	1	1	5582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFdfzFMGNuMNyXQTdbwA2wJ9LRRYVKKdfxhq3jxokVmUvXBEGs
41601	payment	1397	1397	1678	1	1	15713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQSxCwUcBEj58vrrdRfm9dvopr7Vq8KzFpXNrHZMVdCo2tgNg2
41602	payment	2134	2134	1874	1	1	6021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgn4tuvtJBuEPM4FV6tSUa2mXukBb674nraL4xaLV68JiYShJz
41603	payment	2133	2133	1874	1	1	5588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Pp7KJQSnDxYkwvzRt3apNgxjRgfkJfZAH6v9J4d97B7UZwAa
41624	payment	1397	1397	1678	1	1	15719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fCtkMCorJ2kfQeUrnH1j1iM9G983S2BHLJQ9tCEEWrHCQ6in
41625	payment	2134	2134	1874	1	1	6027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3bDWris9tRUyJaujdWhxcAsAYtranHPZHxdJo5REhVY9BS9b
41626	payment	2133	2133	1874	1	1	5594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpExR2bBqKmT348KxmqCy2tgFvwfthJUpLLMtc4erDH7LiYyW
41627	payment	1397	1397	1678	1	1	15720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHgNrJcHs8XZXsaoFGXTH9osKHg1dFehh46R2cyE71rR2p464
41628	payment	2134	2134	1874	1	1	6028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDi6uJo93qxQhvHu5pfsFNuzze8jV9dm6K5yFMBZRdAo2CsSS
41629	payment	2133	2133	1874	1	1	5595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxb2dw3qqjJA3afXsZ8wsP5jne4TgGKNRYHwptXyUwdH52GuzQ
41650	payment	1397	1397	1678	1	1	15727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGiufjPZKKPgeXQSn5bzfPyhRAWgtRt9TtZa3nuMyfEKVxPRqd
41651	payment	2134	2134	1874	1	1	6035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVy6W9GyoLGGcqLscRGUcjgp6ScnBW7SZuE32U62CSnGqax7o
41652	payment	2133	2133	1874	1	1	5602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLSutBtsydb93yLyVRGZnXERqEMFDr1TbxpbMESJ1ri8sK5wYH
41504	payment	1397	1397	1678	1	1	15686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcexFWnBu3eKZ1y3VN6DgV1aFDVx9US1NEBvd9GN7TYMEyrxh3
41505	payment	2133	2133	1874	1	1	5558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseppCBS7h33sceLpKnYMtJykFSGamhcgJi5rUKEGvyfeeea1o
41506	payment	2134	2134	1874	1	1	5991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbRcawzgiMPYQJ5NUtwLP1yB8c8WFihz5QPfewCA8nTqr8i1Z
41507	payment	2134	2134	1874	1	1	5992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgZHaFhzceFSjfiGX2HCmpKGN14NZVTzPKsfSvguinLPZ5m2d
41508	payment	2134	2134	1874	1	1	5993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYDxBUeNE7NRUfMoYCTMm2347PCMuieoMavT9yeqKUw7AMcoq
41509	payment	2134	2134	1874	1	1	5994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpVMm8tj7D7MmEpJ2PGUHfz22iGnaQLspSQomEqWuxpZrb13q
41510	payment	2132	2132	1874	1	1	1565	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyagCg6EG3ciqW7n1DUbVsFs2ZxqNoAdnFigwmqPo6BTMkgaWn
41511	payment	2133	2133	1874	1	1	5559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9886kT5EaYWPWttFCW4vbUWHV8rXWdhVXhzedsSyvRm1TUkS
41512	payment	2133	2133	1874	1	1	5560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBpHwwkRGn3FtZrXvSWChcL38Hjd8eBQ7jkQpXwGxnfgs5FRD
41513	payment	2133	2133	1874	1	1	5561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHdDX3EG4w6GFhMiMzydYSKFRE1KAi4vemtkAzF1os2AWXarp
41524	payment	1397	1397	1678	1	1	15690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhzFRqtxfKtwnq8KumbiGZmoYCs7txXTZJPjtFQiPAKCVXXdS
41525	payment	2133	2133	1874	1	1	5565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3sac9zFMFL3B9k1cpN4UpZRdHbfweFTij4kBjTopn6BSX5T6
41526	payment	2134	2134	1874	1	1	5998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkX3cL3FiJx2HwRUkAshGWknmBBNpKWN2qKoyp3GaPnSUdYae
41554	payment	1397	1397	1678	1	1	15699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYEP87n9NjFnRJRRH41y1ruQa5sT2BVmLGQM7RdpMs4yomcR2
41555	payment	1397	1397	1678	1	1	15700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dNw24JY7x1qVkLnckT8XuUn2gZbsEaenabNpkSrt1AWyYH8L
41556	payment	1397	1397	1678	1	1	15701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhZoVGG3n3txbVmsMxPdahiEe6AGdNn1NZY3JTV4ynDY6rKcY
41591	payment	1397	1397	1678	1	1	15710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYThNzNqvSRSRCDoM8AoG8QXvaYMaYkcNQMck4XcW9Tj7k6UFgb
41592	payment	2133	2133	1874	1	1	5585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9syRpQhfcorzGJFwD1cQK68Bn7v346K5wg6Q4ExCNpDETvVQ
41593	payment	2134	2134	1874	1	1	6018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDY2nJdZTsa512pZcMzCUxunQrpZhzktyBsSJesJY1BFkA8F3M
41660	payment	1397	1397	1678	1	1	15730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAc44jxovcukTFegdJCUxcab9PaYVHi1pcL6B9je7fdvg47AmR
41661	payment	2133	2133	1874	1	1	5605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSd3MC4Rgsvpgqz8P3eJJ5s3ek9U6hJ2yTuigUHs69iK1UwKHG
41662	payment	2134	2134	1874	1	1	6038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ6SwWXutmkBDBireqHVa3eHWrZP786hoLCg8T1DZ51xv6uKp
41682	payment	1397	1397	1678	1	1	15736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3vkQocJTyV9UqXwwVD8dBUmfKuuBqTwGBdq5Hvr5Ae5CNrw3
41683	payment	1397	1397	1678	1	1	15737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKwY1eou7ha5A7UmQxuRSpN8NxQtvhhVpH5pdtFFvC5wGzSbq1
41684	payment	2134	2134	1874	1	1	6045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2CmVesFtTCgVvuwHJMkE972Zi7aq5baYMPyNKwMrdJxuJV6J
41685	payment	2132	2132	1874	1	1	1581	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRcyY3s6agp2rQqAv7vsVK3Z2fbGQwr1KgLNzxYVE1icEinUb
41686	payment	2133	2133	1874	1	1	5612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXXGT6Z4Kc8WcBBGyPPcobrWi3NaBpvLqK4o49fBEEx78s8aY9
41687	payment	2134	2134	1874	1	1	6046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TU4dsw2c7SzKL5rkkg8BUk1bfP9Vp36apW5gABYr3PZSvzBG
41688	payment	2133	2133	1874	1	1	5613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAYLd4fFTkyZgbqVwW61FAsTvpfqoyTLQ2ShgpBeqdoBc7b9T
41731	payment	1397	1397	1678	1	1	15752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGULGHkZUdhUAZ7Upfkquhe1gNicpu1Arpw6jtEcVkcDSPo7A
41732	payment	2134	2134	1874	1	1	6060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQS7fzeaFTT2FosZZHFs812KfES4RGdStZbPJzCNamS2VRZs7h
41733	payment	1397	1397	1678	1	1	15753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJqz3XrX8DtnSjGCSi5XY1YhetUnMZ2vMBAs5prhYZg8gUegsu
41734	payment	2134	2134	1874	1	1	6061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDesHMovUDeAoMabiYRqnH8qn1M7Z2VSnJzsek6YZD2MSmT3Y
41735	payment	1397	1397	1678	1	1	15754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgi8xVooyD9GJs3au4RxFimzrKtsDv2TbgZdvgTAKJBtUeo1xo
41736	payment	1397	1397	1678	1	1	15755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46eW237BBwEgNvbk1uiWdZstqKfiH32Jx4J2wbkjxiNwFcQdq
41737	payment	1397	1397	1678	1	1	15756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFFNzDq6Z9LoLwc7ohSnJfnCsGE1oyFv2GQX5GwJ1dRrAiu8G
41738	payment	2132	2132	1874	1	1	1586	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQkeLUq7u8CaZwAG4jfnnh4L5bXFTFFgkT8deuQK81njSTuFV
41739	payment	2134	2134	1874	1	1	6062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5gbSETdHPKm3UbTTDVBrn95wEMArhwUW3E25wtRia4Gim6Bwt
41535	payment	1397	1397	1678	1	1	15694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaGM6fTasCJERrqicx3LErok14bFRBrx77qWknFuAFVFSU1oZm
41536	payment	2134	2134	1874	1	1	6001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbKN32Lww27C3XcaCZfiwdBNbWqHm61Gdm5Y8tweK99qXTxR8R
41537	payment	2133	2133	1874	1	1	5568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofqJNzYrKSWaLciUMSAGwBAXbT5a8shfvn563ncVajjF22Avs
41538	payment	2134	2134	1874	1	1	6002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cuz71anSDNFz3BGJpVsMSHp1mf6aq46f7TiNRCH154YvJcnW
41539	payment	2133	2133	1874	1	1	5569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YqopVRwWvfTjFbmGD6L5Cuhh1KVpoesKVzJqJCocrqFbV9MM
41547	payment	1397	1397	1678	1	1	15697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93KyU2ozYxc4hqA2ieA43CQhSJaiP1YW8HZpErCSyA9TK7Wzk
41548	payment	1397	1397	1678	1	1	15698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4C5BjnSUEjEUjxZjE2AbTK6imsr3X5qsSCSPb2ThRVaX4KYQ
41549	payment	2132	2132	1874	1	1	1569	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkPY5KpvJPrhKm5FhAyCRQ7AKVignUCc6oRFSUzmSsA6YETrND
41550	payment	2133	2133	1874	1	1	5572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxZuZAyQppMPpsD6Y9ksiS6xJUHCuFsiw8U6AfnVZHcAKHrHFF
41551	payment	2133	2133	1874	1	1	5573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVs3HXyLt8eNzB9Qbrv7U2N9ZMmn4DeXGeSYErTKfqoHy8GDoV
41552	payment	2134	2134	1874	1	1	6005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5f2QUHttQQ3qEeJ9BtkJjVByzER3AtPGqC6GHzBxF4k8t1XY6
41553	payment	2134	2134	1874	1	1	6006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WKPv9DtFFBZdHr2b9kxCWedME8hBzCzkXA68vePFC1R4cZwD
41557	payment	1397	1397	1678	1	1	15702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFN5mGF6wcUjvLhMRQtXsWL5EmCVdu9apmS9BzYPpftEQpHQD
41558	payment	1397	1397	1678	1	1	15703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEtUXdEE7TGw7Pyk4RnuxwKsdWj8iArFEwcBW4hSHJrTXk1qL9
41559	payment	1397	1397	1678	1	1	15704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8yepLZCRAsD9WZJ1qiBiQB9vXnfuV4rtGd6uq32GWqYCrsRK
41560	payment	1397	1397	1678	1	1	15705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVcBezDQtBaFyswUuL38KWRzu4uY1VxZchcQ7DXdFXWsW1WvU
41561	payment	1726	1726	2342	1	1	8300	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ4JY8e7SuVdH7iro7z7JNpEX75ohNe4U4t63gbXo3JzAGsJSs9
41562	payment	2134	2134	1874	1	1	6007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwn1t1kjAdCDQq1KpPLyeWbrDW7unrsdn8QmaZaLASNppdjay
41563	payment	2133	2133	1874	1	1	5574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3AfNmJdfLmDN7GQjHqJRkJPLZ2rkYtP7AcPhWgALAHiwBMJc
41564	payment	2133	2133	1874	1	1	5575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqpV8W9cqMC2Szay4HnQTgyeDkgRxCQNbMDhRpc4qWxGDRVnN
41565	payment	2133	2133	1874	1	1	5576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoocpJquzFbE4cQsrBvLJJy3PMfHf5Go9xipTagEzkS74rFk3
41566	payment	2133	2133	1874	1	1	5577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQpcfX9NQhwQ8DssxWtvu8TcAtxAhJ4LFSyuDpikrqVVs1NfFm
41567	payment	2133	2133	1874	1	1	5578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsR6RShbqnNXrpAzPgLVVicAPMNuCW3vYJdLxK4KjYZEsJDoKJ
41568	payment	2133	2133	1874	1	1	5579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4rd43XxDast9iYBGJxJHBh3zLGiSg5mwPEeMFDoBgsGJkS7C1
41569	payment	2133	2133	1874	1	1	5580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeRa6AAnyTuwiZXpm9HMazJVHNWC8vuLZ6x4eoWp3LLwy3yvZJ
41570	payment	2132	2132	1874	1	1	1570	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmu4wKk6SFYbKyJo5faTei9Pt1azupoDNezHGgHPM8tpLNDyLN
41571	payment	2132	2132	1874	1	1	1571	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3CkoqvknHzfwd7V6HDPupb6UP3oJRg3R9aVU17g23CRGKpPrc
41572	payment	2134	2134	1874	1	1	6008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshqEPc4vEwqFAMKsVLyFTyMFpKA6Mjtw7jfgyGS2kB7BDoc6s
41573	payment	2134	2134	1874	1	1	6009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnubAkcSnVJxjQfA1GBc9UjPQPF6ZBWTSE1wQpX8wij79mzt3
41574	payment	2134	2134	1874	1	1	6010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyWHnoQN6hp8HaCWby5dUmoyjbsGxEAeoTYW83ojDa8DzyFGHh
41575	payment	2134	2134	1874	1	1	6011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKdMG52ApBhZ4y9pcWtBAJzNQADTLYCpWtgAL1A8YLG9Y7XhQ
41576	payment	2134	2134	1874	1	1	6012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgJfp2UFXnZzop2cqxuubpFc3Uf8iGi862wiEUJvXYToJA58o
41577	payment	2134	2134	1874	1	1	6013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHVUSE62yHV9QvsVZ2x8eAxrTWuzGzzBN4Cd9rHQwR9GHd3os
41578	payment	1397	1397	1678	1	1	15706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdsUzc7mt3gLodEdk3RREGZwwVC2MJTdvtk69jSk4rSxhWzxT
41579	payment	2134	2134	1874	1	1	6014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncjosiFp4bJRg8adhKyWsSMbKtgMfSYMqbqd7jmZoLJ1Cim3a
41580	payment	2133	2133	1874	1	1	5581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5m5mTwPQSjzmD5mEjgjU8rVRPzxAx2KvGV1cmKyV5Y7kZhVWG
41604	payment	1397	1397	1678	1	1	15714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxHshrAfeCZXPUoiToNqrgQ7aZkxR6iz2uEmXE94Nhj3Ge94qf
41605	payment	2134	2134	1874	1	1	6022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSccKmjEK6r271pKXTPc7qo15WKyWBDF6qDKXjjNtpE7f4kCqM
41596	payment	2133	2133	1874	1	1	5586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaBSyvhkzFKuznbuNZQg4LDtiGZCNtGB8vT9rqBRqwbK9kq2D
41597	payment	2133	2133	1874	1	1	5587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEoXfBUoG351hHcaub9RaJ7ZmcURzfYnUfj1tbZRh6QJzPAYi
41598	payment	2134	2134	1874	1	1	6019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLZiRAFxSiGH2qkWFN6zXA6CbYdS7tGffumETMqvwFYFyS8qUY
41599	payment	2134	2134	1874	1	1	6020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRcVyG6Famk95TUrGFpXPwMQEHeHhJp49xaN6duDSazXAy44n
41600	payment	2132	2132	1874	1	1	1573	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZruAdMcN9jBoTvRewkks7PbYQcMcNtXzmVjJAAh85P2nRHJmg
41630	payment	1397	1397	1678	1	1	15721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNyWXwfxRkyaQsSF8nReCRte8M9VBAZhMWJSwXFukvKSB8CDP
41631	payment	2134	2134	1874	1	1	6029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoKhdh53tDbda8d39Fqeg9EaNf3ZxixhoV74Ax9U5kkQ1SaRW
41632	payment	2133	2133	1874	1	1	5596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJVLbyEHNMTjgpY7dra5etmkqVsWWEJuwKGU4SgA6qRu2Geit
41653	payment	1397	1397	1678	1	1	15728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDHyTFiFzfHs4YgKHukN98jJX5ehSkFWndWEpP2pcyw9ZBRt9
41654	payment	2134	2134	1874	1	1	6036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfJPhcY7hzY2Gb5YNF5pTZjPpv6B4XNyi7hFpWuqX7RJX62pUa
41655	payment	2133	2133	1874	1	1	5603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoC4fecx3t5AVwhVx852Pgm6TngatXRstK6jfggDtbxg3y84re
41656	payment	2132	2132	1874	1	1	1578	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7SUoHPtwi4veTQUhmhPQVZSRR1vwmKPBT24U42t4HdeypbLDU
41689	payment	1397	1397	1678	1	1	15738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmNKvzAcNFLS8gkxyqCW1UAe5Jzp6oFrTH8sZ2aHGmHn1QRxo
41690	payment	2133	2133	1874	1	1	5614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkN3f4mFgiGScZHo877UJd32TFVV6BU8imKeJR8G1dDNaNn8XS
41691	payment	2134	2134	1874	1	1	6047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8NcmMyMb3nMy1HSVwYpVbqwb9qpi45XbBgsWBLEkGkNZcko7s
41704	payment	1397	1397	1678	1	1	15743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZubNVDKDjMbXKvZZubdWgKKed62eE7nVWSSCunbCaXnaPm7KAw
41705	payment	2133	2133	1874	1	1	5619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwK3PqdowAirtRipwUQati5u49i5PJniUgpXvAiWJkrtLnfh4G
41706	payment	2134	2134	1874	1	1	6051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NGd3KnjeHQN9DdVYgX8GEqMFGhGdaZzpNZ8w3pmdSFzdPzuD
41717	payment	1397	1397	1678	1	1	15747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS25gQrt5Y4wXWbY4A4BRiWGXsJhrccn5ump399qGhA3kn5qDJ
41718	payment	2133	2133	1874	1	1	5623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZizp2wpQ1B6w5UhbLU1QHV6TVrSzbamFtauaEB4RNn1zdM1AF
41719	payment	2134	2134	1874	1	1	6055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuTUpZNJzTohPu3QDDLqz85FS9VGDako3uuP7UF2GJmc4VvrW
41720	payment	2132	2132	1874	1	1	1584	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDT9qYmzpcpx2i6RJK85SA6NHBfrXkhFmxoHzR2HFxLgASwxh
41724	payment	1397	1397	1678	1	1	15749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYioMnNySqJzDCEuXNKwrPHuqcvpeLE3uyVTjf6mpJXXH3NepzF
41725	payment	1397	1397	1678	1	1	15750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr75P9Y2KLZ4TPz2dQ2ntVsTTK7DJkXhsUCb1yAUxtXHbKaQdv
41726	payment	1397	1397	1678	1	1	15751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa8dz1muFTkyrLgLnhWib3qt1dihFNaKEmoCTbW1ukKKvj443S
41727	payment	2134	2134	1874	1	1	6057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9szXSR9KLp8xDVggxPAdZZRp5rRFeiJX8fBcUCfxHKxiC36e
41728	payment	2134	2134	1874	1	1	6058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7X2HCUhpXAwi8Dph21cU6Qw3umaEPSqgMpJTt7rgepQxTCUN
41729	payment	2134	2134	1874	1	1	6059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbZwNAcWxQMHVZmeXtWetY7pxb473Grx8LbYVzysfd1FwLe4F
41730	payment	2132	2132	1874	1	1	1585	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwDQq63gXnCnooj2mgPEt2W7Vh7opGHVdFoccDbPjNiphqvWou
41747	payment	1397	1397	1678	1	1	15759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKWknGbbpFPLyYxkTBFJE2FDLzvv4EVtCawSHMYgjYe69fGc4
41748	payment	2134	2134	1874	1	1	6067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmMRLCXNHwUosjN51C2Ws8PkWptNMmxnBgF5n1PE92d7a7uvX
41764	payment	1397	1397	1678	1	1	15766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKqMnFY4c9dseo3k76orMydG6ejMe2KD9HazwEDQLaTRrDbr5b
41765	payment	1397	1397	1678	1	1	15767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcV8GXfW52sg9H5Sc2GC1YJCWUucoFKKmysMievZcHYYb56Coc
41766	payment	2134	2134	1874	1	1	6074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSHJFMZp4gwCsEoXaAai2HbxoqEf2S1m8TZ9Rq6hiY7yidy3B
41767	payment	2134	2134	1874	1	1	6075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRR3Rw9TCL7HKSC3SNaKY36xwv4jUYLy7sYc8MhzJeRe2oRKQ
41768	payment	2132	2132	1874	1	1	1590	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7wMEm6VhXX2wabT7wFHdfExgvy9KZ3JhKk1hugHAmZEZzvu5
41769	payment	1397	1397	1678	1	1	15768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5zMJw84VntPbaHYKQER9cx3doLFJrhEHEEgdz4HRcNvj5SxYw
41770	payment	1397	1397	1678	1	1	15769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdC9MZuTbL51EbpunvWXzZr4orCwmyxPu4ben5C2WNPTasgmtS
41606	payment	2133	2133	1874	1	1	5589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7Hvv8cmEh5fqQ9nEmFp4doGmpNwfbut2vJe6NohbQzeD91Sn
41607	payment	1397	1397	1678	1	1	15715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYmuvVNDAAQ53ha8dgQEdZ5CFgotSzSE2vkruD5QyZQ95mkSM
41608	payment	1397	1397	1678	1	1	15716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEqkXabVL688HhhYVFr6onX8nbEk1SrDBfnM474eu359bAh8N
41609	payment	1397	1397	1678	1	1	15717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uvgmwu282RBmZb2wKvYoKzGaFqY3YzBWeN8rvcCzNq7rxU37
41610	payment	1397	1397	1678	1	1	15718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLiMDNoPpyxgSpKgMddTMkvDhBJSWbG6C9sDPRgDqnRbGh9iV
41611	payment	2132	2132	1874	1	1	1574	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fwqn2geQPaecVE8iSnEPszicdkRQHrckJ8NEQB4qA9WvWgu2
41612	payment	1726	1726	2343	1	1	8301	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCdRBPzv8uwmCJ7KcdP6KvSrCWajHQiqdPjbhJTmoRrQXhWJVN
41613	payment	2133	2133	1874	1	1	5590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwK8CzHV66TiNodYkXi1bhwpo1CYmr6TDdnZ5JkTtyyi3C9gK
41614	payment	2134	2134	1874	1	1	6023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUApuwQ1s1VgrL3N4XaKyir3Fhg27p8VP5Uh7ybHhdLzhTUiY
41615	payment	2134	2134	1874	1	1	6024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzWPrf7TkvURMwTZo1vGyFtkWGigzCTokAcwVLDwz2j5wpfFYm
41616	payment	2134	2134	1874	1	1	6025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXw5Rc5XJZHeoFqWT8myMAnaps6fdZDVYjH6FdBftXjHaFBKgS
41617	payment	2134	2134	1874	1	1	6026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXARUxQ6HLnLuEsn2joeNTYp127TvW17pjjxrsmZznmeKg8QV
41618	payment	1726	1726	2344	1	1	8302	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZm4vmnEXw5zLHxm7igpnRQXCzCLtfXMu166kAot1b1FU8KMgYE
41619	payment	2133	2133	1874	1	1	5591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsztN41d6gMFbG3xPceRKks8fGkH7f5Fw9YuSjvSrewcBJH7A2
41620	payment	1726	1726	2345	1	1	8303	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZtFNfE29FCPqdMsqsQtPNpWMAHx3nN7SFz9pcQiyh1qQKf9Ehu
41621	payment	2132	2132	1874	1	1	1575	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94B5RDsbiESo7t7vaoCB8b22NbFHN6hh9QuKGTrSfq2EBamFK
41622	payment	2133	2133	1874	1	1	5592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTDPEfdqZKvJz6zrx3FXUELLQKom2d8mrbU6rgx759irJar4M
41623	payment	2133	2133	1874	1	1	5593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPxkdce3Xfs2C9BzQxyRxSDam6mE2ZGUcwyQfvJqJF7UaSJSz
41633	payment	1397	1397	1678	1	1	15722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgModNLf6GNXTNR8HfxFMcQik9JuJDc8XomnLy7oYmBZvMyiX9
41634	payment	2134	2134	1874	1	1	6030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhc6nMoAtA3hXwfWGxxPJW41rgDYERfANf6irV2fpEU9pGmkBD
41635	payment	2133	2133	1874	1	1	5597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjZdmVtjrMDTmo5TCU3tQtwcyterpgLR9235NbxRWJ55UyvKo
41636	payment	2132	2132	1874	1	1	1576	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uB2zwho9qNuvLkaJUeM2fUcv5kx7i9YHC1Fh89MdYaAxwReA
41637	payment	1397	1397	1678	1	1	15723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf88CBi478uvYWojxkVkTAoEwo953CKbRfou6Np5HBGZxNob3H
41638	payment	1397	1397	1678	1	1	15724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeQaJyCfRcFcgtkQwUpf7PpS6EEzjhGao6hxK6niaHvpNJX4PV
41639	payment	1397	1397	1678	1	1	15725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1JnSW8wBA6RU2crQWpXcZsMPVpTaWsVr9dmNGvthvK7BKQxq
41640	payment	1397	1397	1678	1	1	15726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkmpuxbzCqvCvPoHAmXNzjfdV7uoLNEm2ktHwyh8GUECPKkGj
41641	payment	2133	2133	1874	1	1	5598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVRbiQQVpUr9ceDoVVciPrnxvWkHrVJ3YdrCoqb6xbtSyAZof
41642	payment	2133	2133	1874	1	1	5599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQxcTR6Hw59j3WDGn7GqttthiwPEHZc1FMk5BdqAgMvZxr2y64
41643	payment	2132	2132	1874	1	1	1577	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk1MQXbVgmqyVqCXTD4rCqCFrJANTeLraLo6qYkR9ngxqT3zy1
41644	payment	2134	2134	1874	1	1	6031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgtAP5JjaDjjTHuUEHDbNYwUHGqbFedTgWAfgnr2QEjMNhVSUk
41645	payment	2134	2134	1874	1	1	6032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSc676eXwraQ2ydYREmpiTxeNDAhH9wfp7TCWSn8jSv7dfNWKW
41646	payment	2134	2134	1874	1	1	6033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSRYoF3jHiFgnGQS1qmzvbNz4p35NyCbGK94p3SWZFTR9FGcwn
41647	payment	2134	2134	1874	1	1	6034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv3v6B5oLGy3FgSNBHksNhaSVf4uJEY1QVq2q7Mn5sUA95zCWm
41648	payment	2133	2133	1874	1	1	5600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGuQj8JSihZYDmik9P5r9vFbPsRgVhqUEFNfHKsb8SdMoncz5E
41649	payment	2133	2133	1874	1	1	5601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ie8B9GduvVnx9QuYrT4HT67LNyVRUdBQu7DWDYnJhXMZoAv5
41657	payment	1397	1397	1678	1	1	15729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcC1qa8DM85LASLPWgfd8yudvwqbQd3DfxCBRj6JCTXvAkJ1Wt
41658	payment	2134	2134	1874	1	1	6037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbu1jLHwmVrEFfT8Zp5ou6UkHBvsXNxF5aEYpJCYnjEeRRq9gb
41659	payment	2133	2133	1874	1	1	5604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmx3uWHLh7CDyd76LFPpHuAYi4qcsHhEokNNXCAsiqNN9pFkQm
41663	payment	1397	1397	1678	1	1	15731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcsfMrTq95MXQ2VBhgZpfKot5C64qzB5PA33A2PnSnQqwYBHXY
41664	payment	2134	2134	1874	1	1	6039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPU9M8akEGqKYbujF6nfk3exGpR7F7ABLfhGioJmjkCguZZMg2
41665	payment	2133	2133	1874	1	1	5606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwuSpfN22sytYdnuUGJBcvwwY23TdGDngFdDtM4BeeK1dt3qy
41672	payment	1397	1397	1678	1	1	15733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KqVFJS1NLs4G8XggmZSUKuVdQQ8tbDQesvFBgkdCBkPhFnUj
41673	payment	1397	1397	1678	1	1	15734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCvACeBAJTLGGsw935da9JNinSugxSHDtchqExukVGThHNHTkN
41674	payment	2133	2133	1874	1	1	5609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaekN8JomLCsrEKowsjMfik9SDnRgaQ5AkVeKJi4pwmZCfZPUe
41675	payment	2133	2133	1874	1	1	5610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4dKvuw6Ryoo6zXNE6ZUwHJKZ6cGKMPSk4C5mbvjftNyieQEnG
41676	payment	2132	2132	1874	1	1	1580	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyUQfXm3SG7X1zuD1VDHz7QwdXBwpuoJfxBpBtex7DP5T9H2Je
41677	payment	2134	2134	1874	1	1	6042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqpDCwhw6tzCe8QBTdKM6WJSRqCF1RsHY5uVgqofKKDPoLEH9
41678	payment	2134	2134	1874	1	1	6043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBxz6rgRFUyQdpDHkSUiRYQJagxcJZ4dZj4qj8GonpbZzDkZK
41679	payment	1397	1397	1678	1	1	15735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRTurM1zgwz7aBRvKejk2X23KqHAAni378182i4cieJwBwkuH
41680	payment	2133	2133	1874	1	1	5611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNB9LagrTLxhRgPAXnciWARB1BaVHWkqmsNhu3E1mJxDazfbrm
41681	payment	2134	2134	1874	1	1	6044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHqbdwb4U3EYBPAMzqAMSkfZp2Au9gWuR5HgBSaWfVShApBpM
41692	payment	1397	1397	1678	1	1	15739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3ZaHvZAb7gqyTRxACXBWxKCuzaXXMWbjgYkSXUJmatPmgpAK
41693	payment	2134	2134	1874	1	1	6048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZeHum9PrYu67wzgufScfVPxt3qTVAPMtrbHFZ3HugP1MCtTX
41694	payment	2133	2133	1874	1	1	5615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SAkMQ8cFidCrtvXZKXzntQyantA4uXFjCGvfH1hhfVD7Xutw
41702	payment	1397	1397	1678	1	1	15742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagE7qpc1wKMB9RiJXzTAuUEyTjFwqD8bAcic8tzgtW2Xbpoqw
41703	payment	2133	2133	1874	1	1	5618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRVw5Xi3HP9MXyqNL3M1iuuCuTfiEvtwrsqMz3GNFdYkzLk5Z
41711	payment	1397	1397	1678	1	1	15745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MiTmDL8YocWMDJCpqhnuajQGBR8aSfLsFqVJZZVHhMfpqvqS
41712	payment	1397	1397	1678	1	1	15746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjvpJzFn3EEGKZK3gaCyGUZ8fDwuw6VvoVkwHPXsqsdv23mB3
41713	payment	2134	2134	1874	1	1	6053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5nFUJu6zkuVGfYkrBmfBVNe1fh5GLB35b62tNYwWyycFeKjR
41714	payment	2134	2134	1874	1	1	6054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAxxsrNkzijjtsfi9seYGFDfcuXEyxPN9cws7YiEBL12asLmUd
41715	payment	2133	2133	1874	1	1	5621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3hp9zoBY89tU8W4hSKwvpLBgkTCcv1HWmEPCSUYuxoQQXVHZS
41716	payment	2133	2133	1874	1	1	5622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9DqLpzVr1xoV5kpe35sXBGmZcGHLKbYwAxmszVLYqJfoqYVS
41745	payment	1397	1397	1678	1	1	15758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuUX9CPZ2xPWTVPz9FGZnfLofyLtAZH18yHJu2MeEy8NS9Luu4
41746	payment	2134	2134	1874	1	1	6066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuzCkx8ctcgap1sSeWUPpKQDzB57iZKSB2vt5fsiUpdw3HsJR
41789	payment	1397	1397	1678	1	1	15777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV3NuYfTSvdzwaMK5BfncrT5QSXrafaj2dGPXiJrjtbQADmJb
41790	payment	2134	2134	1874	1	1	6085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLxg5XZ6nrNrRm99mhMwh9JkKXbiz7iczni5abShQfA5EcvvA
41791	payment	2132	2132	1874	1	1	1593	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiQtrwBk16RSZad48AUCsH3spPNQpRovxQ4p3EsBEEJBE7hn4
41801	payment	1397	1397	1678	1	1	15782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNtXHpiRknfjBq1jSRyRwUYLahH7iA48hDxcU2HMK2s5t3Ftb
41802	payment	2134	2134	1874	1	1	6090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnvpgYeKM4u66RxmV7vMKvSbwq11Arfk5EcK92UMx9oEvFdjoC
41808	payment	2134	2134	1874	1	1	6092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEB51VgMBTo1DkVDWqjECGM2hdo68qbLvPmLVKYoxwNebdUru
41809	payment	2134	2134	1874	1	1	6093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyPThTuAS423j7Pj975xEfN6TwJ6XgqGvo6Ne3yuBMdtzDLsAn
41826	payment	1397	1397	1678	1	1	15793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoL4CXXLGw8Rc6Gkt3GPkw5ux9PcsqhMwXbW4F6ado31Z9mSAs
41827	payment	2134	2134	1874	1	1	6101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntqUA3Bwn9CFWAyQCgpY2qCssPoTe1Xw2HqNXsoZPUPvYJ81X
41850	payment	1397	1397	1678	1	1	15803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoz3pRgu167pNUWNvkjoCNVUkBBrAjnwNRZHnSRbWh56qx4Bcz
41851	payment	2134	2134	1874	1	1	6112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTST4y5AUck32xHWk1BF391jtRc5xEptzYGzWEtLa8HwctHjB
41852	payment	2132	2132	1874	1	1	1601	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoC6U8mEvqZ5hmDkqF3FFgxBQ3pDhps7hN6zyPa4Gre4vzw6L
41666	payment	1397	1397	1678	1	1	15732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5i3BBxtXDjKAtC56QRH95tnemYKX1yckKjyJKmBFDmU3AX4J
41667	payment	2133	2133	1874	1	1	5607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTrKrLqZwoCt8JzRKYfzoA8WsvMMpL4koM41a2S31Tiw9zBNTf
41668	payment	2133	2133	1874	1	1	5608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4CuNdzD6hJgUGZh6Bfr8QQK2vaAbP2tLa7nq8UTwks5UM7xD
41669	payment	2134	2134	1874	1	1	6040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBS88CZhpE8AkvXaBEGzhbJphF3tzJmjyFymjwgqdoTpydRVf4
41670	payment	2134	2134	1874	1	1	6041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3aBeWtt1LNrof6kyiuKcYv4EcDqU8cdzaWM186KHQqgpkZEAH
41671	payment	2132	2132	1874	1	1	1579	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXWQoK7mFikWmRE4NvhWQQmncxCMwWPKcYyUHWP7fynnA4SVw
41695	payment	1397	1397	1678	1	1	15740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqfyHZQVHQzYRPdzUJbpzpHRYSTjSq8VGG7x7W3jSEn1TG3E6
41696	payment	2134	2134	1874	1	1	6049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4HY8noB8nytrjS39e84ePbPkwX7DyGMiGtZb6WX4fjCmdus2
41697	payment	2133	2133	1874	1	1	5616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhVd6GxWcpSArPoMhywF7d9t3Ct1hFUMVc98q6A99Jc6nq3yA
41698	payment	1397	1397	1678	1	1	15741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC52xGEfxY8DthYCAXem283eLWqbtqFi1WqWH5UJybbSD6fpFb
41699	payment	2132	2132	1874	1	1	1582	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtRi69cnDqbsjmvqPFZFZMu83Af1ui2LvsaTViLjgMUvBGpyM
41700	payment	2134	2134	1874	1	1	6050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCxRpqzQMd6Utxe3AJKayiVyTg4RZe3dMn5jcS1vL6vVb7cjK
41701	payment	2133	2133	1874	1	1	5617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcFDLRfoJGoGDh2CWG6YmBiTXTj66SxykQTQVvfjmXcp3ijNp7
41707	payment	1397	1397	1678	1	1	15744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaPq4jnQHZqd2t9bZj8VDvYWL8zvqHgRUffQcLi7Ykm7guH45
41708	payment	2132	2132	1874	1	1	1583	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzg3pj62Cdk6dpcj1gyCFJsyDzRCbeFsd6JkCnshe2xfwYrZ3W
41709	payment	2133	2133	1874	1	1	5620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7CvJVyBwibUP6zAN9dqFa5f2DnNUA57FhLYP5XYYsxx3ViTwt
41710	payment	2134	2134	1874	1	1	6052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jXHGj9m7vvRBUhvQYxbPGYPqNuq3NZjj7nxuL5JWS5K7mZqz
41721	payment	1397	1397	1678	1	1	15748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6gKbTVstkjfng5SaZ3kdRphG6H3bPB8BqSU3VVbjU8okfSAP
41722	payment	2133	2133	1874	1	1	5624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsfmN9KBfxozHAXxvPyXAM6Dnnc2kktbgGMHea96W4JkErZSx
41723	payment	2134	2134	1874	1	1	6056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNdfZ4aEGJPMTGHiBiHoCYo3ApxtzWzbu8a7AX5NCjMSHur58
41742	payment	1397	1397	1678	1	1	15757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGhPkFUfzE84LSHcVvresABKkbgqa6ebPYW1SqAJvjXLxvLGoR
41743	payment	2134	2134	1874	1	1	6065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWtoE2Dc23SFf6NhKzf9yEMNRZ2GHT5Mcec5hkpbZiz9TkDTJ
41744	payment	2132	2132	1874	1	1	1587	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoEkQ3WKnFk81Gi2XBQThv6rzTBowrRTB8ruxA8DQxWTXuVxe
41762	payment	1397	1397	1678	1	1	15765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Rb8QU9hHDhbmZbsesDpjCnPhtvWq9znuFfe3KsLWtesGmGGS
41763	payment	2134	2134	1874	1	1	6073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8e8yVsEJoZpbnLN8C458YWDv1G4FBzViUty5qftNc69HfFKr
41775	payment	1397	1397	1678	1	1	15771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99h1afo1j6WKu4syewwBQS7avtqn3YCUXXShTtNdZfvXe2mgF
41776	payment	1397	1397	1678	1	1	15772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF8h1LJaAemTp8WQeaHEN1iPxMA4G87WBCZzJGXLCgHki5Mwdf
41777	payment	2132	2132	1874	1	1	1591	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW3WnWWxHPFuf8kKzBsrjUGy3mgCHPtdJbWCzhG2YwXSVBa8N9
41778	payment	2134	2134	1874	1	1	6079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEQ8LCwzakwcrmPC5cMossNCEWZD6ik6HcgUUxv4jRJp7RMYik
41779	payment	2134	2134	1874	1	1	6080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZStsh7AXfg9rUzc4wSu2n8pjwDdy74jKDhuRN3A3uXaZ5XmGt
41810	payment	1397	1397	1678	1	1	15786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWzuPwZvifCQ4TyDPZwHRK3SNKBqHH1x1SuoBQCNZbNTUBKGzQ
41811	payment	2134	2134	1874	1	1	6094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNkkykQVMSSFj7oDSNczrhrf6xmFFqJmELaN6b4VptMD7BwHK
41819	payment	1397	1397	1678	1	1	15790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWEmRv9g3ywMcGjsKJYSGwCEk5Bgvhd1K1psnyxVboa3n4h9f9
41820	payment	2134	2134	1874	1	1	6098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcegcCzjS3KNDPeZHsNMDgXvtop9PZNnbC3k3kwV51gKT9shRH
41821	payment	1397	1397	1678	1	1	15791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmo8hZVpcs8P6PaibZUtzujVCV4rVJLtSrcgrt1NQH2KFwvDN
41822	payment	1397	1397	1678	1	1	15792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZvJJJsiDSHjLsXacgWpU1kpfGBUsZt4monRKc1mPH6pc46NL
41823	payment	2134	2134	1874	1	1	6099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUckWQs7RdsRfcYpsJBxcoqoe2TxQ2Y4TmUCYnDsst3pULcsRv
41824	payment	2132	2132	1874	1	1	1597	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPoVLxTTBbDUbynuwxjQgJo7E3A3d32M8nbBS54FXtAB9gTYG
41740	payment	2134	2134	1874	1	1	6063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JBmAEfSsCtKTmwj3XGgQRJ9pi62FXNdejJKMQTWVHgoH86A1
41741	payment	2134	2134	1874	1	1	6064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxjrFVTx8zgdsDjqwnXAZ5MwsSfXnwc7s6LCeHVz1sE39Jvqdz
41749	payment	1397	1397	1678	1	1	15760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs14vrrL7SKV3CZhp3gW24aWDDiwxjD9pzafDRtSvCCMDkuTej
41750	payment	2134	2134	1874	1	1	6068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5TjuiiETvdoiUtBDM3DYFiZYhGwBdMUwyXdXV2ZX4PpGZ3XQ
41751	payment	1397	1397	1678	1	1	15761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2MikxEbeqNLuj6idXThj7xnfnhyHiL3hyR7Jjkj9vp3Bvcye
41752	payment	1397	1397	1678	1	1	15762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6T1XM2uPK4CrLpmeXfANVV71H3BzPcMsLUDwdsM1GSBT5Y24j
41753	payment	1397	1397	1678	1	1	15763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJMEjE5HR39a4MwvXStRm1AhzHiR7ckZfp6RKmCz67WgFnrR4
41754	payment	1397	1397	1678	1	1	15764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9j8VppAdEBDvWdvUiwLHoTJp7TNJRJBprMFjjAVoqosVVyVb
41755	payment	2132	2132	1874	1	1	1588	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbTqqq1JzBjWdtWmBtC7LxBZNEmqQnKhQa1b7PEPuABzWak7TN
41756	payment	2132	2132	1874	1	1	1589	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeU9oesmHgkXRs7AATVMKEUSLgKGcdkTJdFE1rbkDPesHvhUCq
41757	payment	2134	2134	1874	1	1	6069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh97JEURT6V4f2cb33W6VZ29hTnuThqiA27kXnxqYnTuh3yo2T
41758	payment	2134	2134	1874	1	1	6070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsyNSYLr7myvGHJhyYJVPd8bQHSpj1cbfBbqKtowyB7UPkLn3R
41759	payment	2134	2134	1874	1	1	6071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPh5uQXxUL3tU65hybCxJNPdxsimP2rijmFeeoR2RoHiRVQVzd
41760	payment	2134	2134	1874	1	1	6072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1agMPDUMF5B1vNwx7w3s8xQZg1wNwoWbU63BUHw2X4RAdzJdR
41761	payment	531	531	1681	1	1	0	683260448682	1000000	\N	E4YeQrG6kS6kyMvXAqguD1aZaKYBMWSMeqMZs2nVu5aGFWqfJTA7d	CkpaDa6u461wTAjcgUAstuc1Us2Mjue4RbYdVj835fWZD8VTzDAJh
41780	payment	1397	1397	1678	1	1	15773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoPpim37tLDEHbD1QyvXLmGiEyk1dh1grSNNuShvZA2ess7y4
41781	payment	2134	2134	1874	1	1	6081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzdJrKv6yYjfhjnpqRgom93zNbQc4yS6dnwxg3E6H2HTYgJgK
41792	payment	1397	1397	1678	1	1	15778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3f6nz47pdo7wNKxjY82dGdQva1iFeubKCpd7DB8oSr9KMqXEz
41793	payment	1397	1397	1678	1	1	15779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkEyrcoEWQPxfLoUdPRotXzyYKro5jFji7vtsdJmPaX5t3EoC
41794	payment	2134	2134	1874	1	1	6086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ysyvVRzhMvsnPAQtmzjepXPrvNQYxMYotQb8TqyteD9F94aY
41795	payment	2134	2134	1874	1	1	6087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKDLACUQsPSxpewTutBJiRiA7SKMvoGMRQ76ycbvFJPhXCnfp
41803	payment	1397	1397	1678	1	1	15783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX11K26onbmD6NNv6GSkrL8xrwMryjfqD9Hrbhqzj2T3avBKqW
41804	payment	2134	2134	1874	1	1	6091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYueJ8pk7KPVhWrwiyewBPVxnsj8fpTnfiWhbAkN4jkD4exBGLf
41812	payment	1397	1397	1678	1	1	15787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKj4GuFpJYqfXET1H6BTTyEuGRseT9FcTT1ZTjR9fPFLn5Botj
41813	payment	2134	2134	1874	1	1	6095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBJphcM2DzjBF5t7btxaTMKaEGix2T26kwDFgRUBBv2xHinep
41814	payment	2132	2132	1874	1	1	1596	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBhXq8Bx9NrF9HE65f3CTvduuZJEFzcWs4bM1n7k2TGRdJSddV
41831	payment	2134	2134	1874	1	1	6103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZS25sijbz2e69YLJdictAQvt9F4h3kd34NA19MT6Xuy538kH
41857	payment	1397	1397	1678	1	1	15806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdkCDZeB72tkNzMgHo3nTTmkZ3MpwoKwsWH6iWNZXvSUr5SkWc
41858	payment	2132	2132	1874	1	1	1602	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYmH93C2AVwaM1gE15tf4DQX4zoeRLbQJsxtoiWk98TB36dvDS
41859	payment	2134	2134	1874	1	1	6115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC77n7GcW4n8WmiivKZb2XLSSH5uYmBBe3hk7T1VYPRNMF6N5n
41873	payment	1397	1397	1678	1	1	15813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa42TuKxY763ezLX2eDFWaPR2Qx3g6tojordmu4MGgAEJEbUWL
41874	payment	1397	1397	1678	1	1	15814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgvkxwYW4fzkamn17dD9QGrFcURrPhy1VYjgFkknAenS8vbqM
41875	payment	2132	2132	1874	1	1	1604	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPLthAJmkASUH1PVqzMbVQz1BFLWokBfGyfEnsa1LAooSzi3Y
41915	payment	1397	1397	1678	1	1	15825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsPjehj7UNrrgRA24qSqxn5mS61T7kHBWabTaDTXPcs6o5vJk
41916	payment	2133	2133	1874	1	1	5635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWUoCbHCr9vg2LNPuARaThiESK7MTTyTVtqPXLySwxPUVp2D1
41917	payment	2134	2134	1874	1	1	6134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5rx4Zcju8zECvu3RcghuXt5eUrP4uvoyT8dSqRhfD75Jb7HDP
41961	payment	1397	1397	1678	1	1	15839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJX2MDKeMS5TgWYwWocnXYXLTjXZaNT7GebPNHv26qUbwpy1NR
41962	payment	2134	2134	1874	1	1	6148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTkK2bkA9fAy7Tuod5UPXBGkuUw4qWR2w4N9KTRk39iJ9P9bEV
41771	payment	1397	1397	1678	1	1	15770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf13wZMRAjCdo4jyWCDejoMkVVGm5hsSPFf5cXBpeR7gT4onpZ
41772	payment	2134	2134	1874	1	1	6076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzNbjC24PGcQD2NYg7nLRtVWZUrwMeHKpfB2NMKCPmWy2KSmP
41773	payment	2134	2134	1874	1	1	6077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnM8M46SoR6eGRqN1426yoDRwkxBvCadUNa3irCrTrEAYCXsY
41774	payment	2134	2134	1874	1	1	6078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTmeoyCD4FkfCVx4QF9yTHp4iPxze11h49mkm25iY9gGHom2r
41782	payment	1397	1397	1678	1	1	15774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjjeiyyhAsc7S9HSo4t39LrYMyXCDpfNiiQfKC8MWCEzY6XaW
41783	payment	2132	2132	1874	1	1	1592	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4wsZweBZJravfTesox1GgTjA3tCiFtNGrwWTbQ4yVJQBPxcW
41784	payment	2134	2134	1874	1	1	6082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTrveQjaZoq4sDat17NRZqoiwcrcJT37NA6pjyCcCnmzjyvwv
41785	payment	1397	1397	1678	1	1	15775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvmM3UpPju9jBWdWsbyA3d1bfUYtMbuZ29ujyqPfL1KYqeKiZe
41786	payment	1397	1397	1678	1	1	15776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC5LWFe9JjbayeRf1tNTVRQwEumnhDySrdyzRsfjgeofEgNFLR
41787	payment	2134	2134	1874	1	1	6083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8B44et5rkzM7WBFXNKzrc3XTKb5aFRq8nxqMh2MQGQP9rAjjR
41788	payment	2134	2134	1874	1	1	6084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGV3VGiaSiyP9MMRC2Db5WdfJAT92kQf8Qes8KBjhtm45vzTVT
41796	payment	1397	1397	1678	1	1	15780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgUafkUSRv1ByfoV9TGABpD7LGA8bEJLrH5KF4n2pcRSC45Yg
41797	payment	1397	1397	1678	1	1	15781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVGAjizkLkGZr4wAkjaEzKpsPSyA2bDBJDF8Eoxy5whVhjYa4
41798	payment	2134	2134	1874	1	1	6088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqTsambshjws2ub9YVNdJSwxpPP8gfLDz1TdpFnt74XjA5cfc
41799	payment	2134	2134	1874	1	1	6089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdywCJRBh6Dy5CHNrJGqR9GQqpkcneazRKf5mB2eTmsMwH3HKq
41800	payment	2132	2132	1874	1	1	1594	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uw7ksvwsSBGg2Hfd7US7skucHg5LJZuU4Qn39pfhjxLe3Pws
41805	payment	1397	1397	1678	1	1	15784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKDZVKc48HkH4nD99E7euJLaTVPL7rTxW19Z5x3KzdsJZxY9N
41806	payment	1397	1397	1678	1	1	15785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYezy7jeYbVXbPtKyCW81TwKEzjxCLgH8hRpuvdA2TpHPDJ119
41807	payment	2132	2132	1874	1	1	1595	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEK2KnGFcFY8HfpFcHZC6ym3SVRc7hgdT5q5drUydnyHSX58o
41815	payment	1397	1397	1678	1	1	15788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBE2XpeaLZCMiqX6kqq2pYXdL6f85dXnreY655QAuQekENpPER
41816	payment	1397	1397	1678	1	1	15789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJmETvs9peRiDEG5gbE3RhkMu4RbDfm2zDfncXDYi8jVpqSCw
41817	payment	2134	2134	1874	1	1	6096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBTScJCsjcsKL8mo1jvMhir2Jk4jBfNXjVnFHQzEja93EMc34
41818	payment	2134	2134	1874	1	1	6097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9m2duu3jNzrpZTrXqjEjshmWzLohXV57tqNoS3mA7PGBHWAY
41841	payment	1397	1397	1678	1	1	15799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQryYHhVbYUQhfv9ZtpdZDTgL1ZQty9eVdqnHcGD7MZy7gp6N
41842	payment	2134	2134	1874	1	1	6108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPtcJPA6Qps1mGJCqe67kT7WfXkFtP9AMLNLvqszkrTgE97Jh
41853	payment	1397	1397	1678	1	1	15804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe3Vke9DBuoeCirw4nNMcqoDTHVucuAVnb1gf31MCosSPHB29e
41854	payment	2134	2134	1874	1	1	6113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1cKTQnqYwqsu3KCcMKAjdiYs8AMpKn1ZhCYPZdoFJ456RzZqG
41876	payment	2134	2134	1874	1	1	6122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDDYHLtUiUMthh9J9k4vfhKc98bgTTH9xixxiyndx9GjdCT7k
41877	payment	2134	2134	1874	1	1	6123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgUZPLUgcjFUV7QoXj1vGqKyAywDicZXEeMHfGynn9serqwVt
41882	payment	1397	1397	1678	1	1	15816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxw4mkUm4LWWeGPGmSsrRgcZeAHbE9hCWNLaUCkZtXhRoiMRK
41883	payment	2134	2134	1874	1	1	6125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsVsg3aYp2N7Jtu5KtgTBR5jVaqTXovFp949frtN7WRfBpRz6
41884	payment	1726	1726	2347	1	1	8305	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZP9YrTouqAF64xwZSMka8hTwihL7JXDiKV2fRMkxGLWioVYDvC
41885	payment	2338	2338	2346	1	1	0	90000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5wgQk23GwcErbiYJ3XMgHvrbdEy9K7TJLPXhAwwsemRzNioe
41886	payment	2132	2132	1874	1	1	1605	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysbXFdhi4Xj7qTioCbFB5h4KusXhpffUhWWtYb3UDCnNn8dX6
41887	payment	2133	2133	1874	1	1	5626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAWrQVxb7f167SCttd9dD7npT3VucJnzihzHY72ergfaEddbaS
41908	payment	1397	1397	1678	1	1	15823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZf6f7JHSDW72xqCJmFKRhiXd6WjrGmQ3unxMLkRtvREvWu4r
41909	payment	2132	2132	1874	1	1	1607	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4tEH8vJGGF16UfHZu3RwZXp4V8CHcXYpcfiqL3kP5AJ8aUhy
41910	payment	2133	2133	1874	1	1	5633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ft3q2gms2mcyj4k3iazw5bbFpCotut1NyNdBrHj2AMY1KY3d
41825	payment	2134	2134	1874	1	1	6100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zt1SLyfmtcRGC4SDWTm6yqQPg66q7aeocCqYtXJrXwzkCsfu
41828	payment	1397	1397	1678	1	1	15794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpYZgH5RVBkwU9P1xAGfcLMpWzJBNbkU7nMjpcj9dRcGzwXW2
41829	payment	2132	2132	1874	1	1	1598	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5TaHB8JUTfcdyFnNpqTBpz5SiKFrGVrsiNCpLsR919KBTHKdr
41830	payment	2134	2134	1874	1	1	6102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAMAsp7dpVLtvAuTF95Z7hpu4ztam9MtrJenWFceifV82X2KT
41832	payment	1397	1397	1678	1	1	15795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnMVekkKVRQgjPE37YzhVwGA9nWdLVyWdj5Z8WrAzuCjpHF2F
41833	payment	1397	1397	1678	1	1	15796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZaTu61A7TaC9SH5Bd8ED7D7WK4pXq6wdTk8hoKj6THGJTw9gz
41834	payment	1397	1397	1678	1	1	15797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimHSr2iseJF5ua6mExX1WnSpec1z1LBsqS5wT3cCsrSd93yAy
41835	payment	2134	2134	1874	1	1	6104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmp3AJcKo8qeCxmNxwzrRFUR6yoqy3EruAJnEk3xZ7bU43kqE
41836	payment	2132	2132	1874	1	1	1599	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYasxJv7UUXFQRYPDb1YxXU78eQunwDpvNmEEmS6pbRy1oK3WYz
41837	payment	2134	2134	1874	1	1	6105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TsRcAgHKS8fFBPwrLHtoGmUNGib9Tqgqesxwrq15gRyNPk8J
41838	payment	2134	2134	1874	1	1	6106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGs6BxwYCRgAj2bRUwtxBvkHzWF2usqDFiTBWaryq9k2e6nocF
41839	payment	1397	1397	1678	1	1	15798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHrmxcv478DsUmy9Nhx9Ne7h1Qvfempsz6zLWCutttVUfEUGb4
41840	payment	2134	2134	1874	1	1	6107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEq8UrhsGQzP7QmhwhGmHFikjcYor6L3W9fR7Dkn94EEB7api
41843	payment	1397	1397	1678	1	1	15800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvb6e9fPUJYVxTtVMhEUmCNkECEbjZEebyXoMZhtH8Uh7c17r
41844	payment	1397	1397	1678	1	1	15801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUaujkoN8Nowv2Chy7MgSZc5kHMuP9paRSzovUuQzwXvcG9od
41845	payment	1397	1397	1678	1	1	15802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBvTxgSwjA7KLEsMqZ8Qc54RHPJoHsd58rXs8SVUuqXrso4aa
41846	payment	2134	2134	1874	1	1	6109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMjMvjaCFwQfjujkk7meF7KViWFGugkFhQktpnFhgB8qFmVt4
41847	payment	2132	2132	1874	1	1	1600	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9TL48ASE5bSdJxhVwX1XMGWJMAg7yNKiegdfXFvtt68fHJLn
41848	payment	2134	2134	1874	1	1	6110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9c4VvyvpL7Mm9Vue8nJ4jdyahRcMjsFThSqzF423SNRnmEejM
41849	payment	2134	2134	1874	1	1	6111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFDGr5JvuLHVsJ9Ec64pT4RXEymL3ZLme8r2zxVn23a6Gh8ou
41855	payment	1397	1397	1678	1	1	15805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgyHwztsQMAN94ee2JBCehkjpCGZDesyBC42wC9et6f165RTqU
41856	payment	2134	2134	1874	1	1	6114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQKbKTeqhCNLaGhJGcGGhPz9NvKTUj4iLfV2hpDCdpHqBAqZj
41862	payment	1397	1397	1678	1	1	15808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9ZhBpV5MVy3u7EgGAuG8ZPgrPeiXFMc3Y8zePtNfGsmysWqM
41863	payment	1397	1397	1678	1	1	15809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVAU8fUxPJdJXzTHSMjtC4YTc7f2zCuzPphtE8Pg4bNYgo9Yy
41864	payment	1397	1397	1678	1	1	15810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QXuSkCzDEznYAQgRHRZ7EUtJELDhZ2J1EDtTjTmwH9N2FFSQ
41865	payment	2134	2134	1874	1	1	6117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGCaERyXBbTbjxXdmEadzWGxmVmWa1Wdi8iFR58GLe2DNA8U5
41866	payment	2134	2134	1874	1	1	6118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uSve9K9KKhd72VAoWjTPCz5hMpsMKYyMdQtbp4QyLnnXEiCi
41867	payment	2134	2134	1874	1	1	6119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmGfcGwgUanhmwRN51pcPjo6tKcfdvyuwvdNy6VmRkCSTb6xX
41868	payment	2132	2132	1874	1	1	1603	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz4bjKf2X1QKu9S25DZSTfVGLKqvLFY3iHetxrJnxgBVZMbzJG
41888	payment	1397	1397	1678	1	1	15817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzepheTksAqbzaL2ACiW3m8kGLbNG7UqotHzLpJV3TKNXppmSe
41889	payment	1397	1397	1678	1	1	15818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBayZXcGCPZvHv9Lvi6RfNtAT4htDn2EAUdRVcqKCBvraRKRyY
41890	payment	2134	2134	1874	1	1	6126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXZbfdQNYg2uz81TFvPCB4DgNifSP16f26RAZtDqq6Stna4jW
41891	payment	2133	2133	1874	1	1	5627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvQVpq3WMD9DcmqeCW61wFs6BkCHCSLAnHT98XTGdjYrBAhno
41892	payment	2134	2134	1874	1	1	6127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sgxHJJs7RuiFAJxwQq8HeLnf517dNvoSfovyYDLg43dTQmTa
41893	payment	2133	2133	1874	1	1	5628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5w4RtbKuUhznPJ2e2NM8bkqDejnYHCc5DCmzqdCxfxmAPNDct
41902	payment	1397	1397	1678	1	1	15821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZmxmXL3e23rnvFypFUmGZVSzRx4JQHAGS2MgYkUuEtnWiztif
41903	payment	2134	2134	1874	1	1	6130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGcV1Ubfs7sYBgJvRjfc17pKT15sCGHGB3TLUCwjMVCj44MXVa
41904	payment	2133	2133	1874	1	1	5631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcGBMDeNFqpHkTyFmzNWGgvfm3uqATC6wXsXLXBwxvhD7XDeo
41860	payment	1397	1397	1678	1	1	15807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLC3u5W8jWnUkghoUBCpWdDkTa4vZhQF8rqdFqFdKNRkHCWLLV
41861	payment	2134	2134	1874	1	1	6116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4x1U1JYfepcymX2vNLRV6CerDKWfV2QJJKfhp2qEvbbCkh4Lt
41869	payment	1397	1397	1678	1	1	15811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEg2qFuuMEWhhvVTpeWrh2v2aPKu9ewvG5Phojba6dpSMFsdid
41870	payment	1397	1397	1678	1	1	15812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsNb5scR6F6DGL9yNybwmyFZ35TNsgQDRpkYuJ5b9zXbafKG4
41871	payment	2134	2134	1874	1	1	6120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn85Xdo4R4fSxK9umMZ8JhBgjBpXesZNeUULHAijUBysZdQrTE
41872	payment	2134	2134	1874	1	1	6121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tH2743tAMBV64fci83ZQbLKVhWZzv6xZEFzC5dzovw9yaotp
41878	payment	1397	1397	1678	1	1	15815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJN31vivcxnR6ifdYns3D2rz2qDeDAMLqh8YiK5AnH5vt9XjS
41879	payment	2133	2133	1874	1	1	5625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5AisSsC1yAcJ8vuqnqBXwXHbv2hx2ANg24fi4fcB8dg7xXke
41880	payment	2134	2134	1874	1	1	6124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ25fGMS4FNYoW3V5UBnpUTqiTUHF82biVumkBjzbGWSrw1Ynz
41881	payment	1726	1726	2346	1	1	8304	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa5cRa3RRVLK89weSgVVofcJGiXztSuvK4MSVjnqvk8p1bwXU7Z
41894	payment	1397	1397	1678	1	1	15819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoTS37Vt9VixU2X7yqfW7GZ4xR4pB65zm18L49XjwZHUVZJ13N
41895	payment	1397	1397	1678	1	1	15820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFEzthLWMu9Lgr1JEb42uPBNMUH7vovsTHL3Qb4gHAvq8fWmr
41896	payment	1726	1726	2348	1	1	8306	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZeLjdYrseqCQ6bDzDaATFQsrvyLZdspJ4x6khjqVeueLMvt1Fj
41897	payment	2132	2132	1874	1	1	1606	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonbaKbLu1HKvwp8TsytRKKB4KsAyvT7UQkfF6U2PKga3aL45A
41898	payment	2134	2134	1874	1	1	6128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VHF6HDN6WbpUVpMjtQRATevz38CzxF61aN7tfH4hka5pV6x1
41899	payment	2133	2133	1874	1	1	5629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9igjyMbQ8LkBkc7VDQWbbwtYX7oajdfNgXURQWp8tvhYgKWz8
41900	payment	2133	2133	1874	1	1	5630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHQpY5Y293rBNJ4JMAymXfoTg25dMJBPe6sVv7rT4QB1jdo9M
41901	payment	2134	2134	1874	1	1	6129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTMa2jTyid5zxJAGuYvJS1QakCApFZk8Seh1nCYenrN5QpU1d
41912	payment	1397	1397	1678	1	1	15824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqRjVVVWsZ58N6e7Qa8VujJt6AjdHP6cEYUoyPVqgTJBgbAUHJ
41913	payment	2134	2134	1874	1	1	6133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wdNd2BrMKijV3MQPFGYv4dTEkJcEjj1vhhwBjXUZkrCi9Lws
41914	payment	2133	2133	1874	1	1	5634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8g4MfaMVNSweeqDJ7T2h6bQVZ35C5tw6Sex7g2bZ8XJ1To2K8
41931	payment	1397	1397	1678	1	1	15830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbuGrwCv4XnmxT4J1244UTHu6gnLt5WbJLw5D8aStcQzMBuq7
41932	payment	1397	1397	1678	1	1	15831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZ9dKUAmi8pg698NZ1rAGeNbNZVmRrh6fzLC31wy88yzbcnyv
41933	payment	2133	2133	1874	1	1	5640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsPyaCNHKowAc8aRpYgqu9WeT2avRrFib4aWkKtA4n5S8v5JXk
41934	payment	2133	2133	1874	1	1	5641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwp25Yi3KGzBPw6vi1cJniqwnJXbeN8j9DpGMCM1CjdjvMtNTB
41935	payment	2132	2132	1874	1	1	1609	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qc4xHmXmQVVm44c7qX7C77BiGppCYdP6ypV3eL3DQQWvhYHJ
41936	payment	2134	2134	1874	1	1	6139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNrSCrw8Kdms5UaDpCZH2Qh5zSKEHA7ovR9SQN3EmgnBqoGKoa
41937	payment	2134	2134	1874	1	1	6140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjtwfdEdrLi7QfbSB5g8A3BMPGTeUYKn4n1GnNCLxZMXt7F4MA
41938	payment	1397	1397	1678	1	1	15832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkivHhxmQPnK2iPHkHgaQjPBbAUMdovsrqKVAJRUWNQMYpdK76
41939	payment	1397	1397	1678	1	1	15833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsvhLwEX9zTVjJvNW4Xn94e8qTpRgEnr6D4fDcyZVMYbEWy2m
41940	payment	2132	2132	1874	1	1	1610	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQYKhaDV6ScWeX7CU4oY6fU9nveudN3fcu3WL2oeVcCx41JZ2s
41941	payment	2133	2133	1874	1	1	5642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL2f788WFffmzMxATNLcdQ7jq6hXEz2TjPHSyAMthGpGYTw55G
41942	payment	2133	2133	1874	1	1	5643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMN54vUpGZQ1moYy8zm5UHSXMZutANB9Rm3CpmPD1q8YnhbcFr
41943	payment	2134	2134	1874	1	1	6141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PTGsxKnwUhkrd5vFSi7ubHJZJBZw6gb5YEFYXNg7ZjJ25LTY
41944	payment	2134	2134	1874	1	1	6142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSxvkcBU8VqZsKX8saxygtX2v4nn58zB4fkQetAMhvucemEgz
41952	payment	1397	1397	1678	1	1	15836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6ysEkSNUFFHxH5Q59DA6rZ3WTFGSCMqRKrm7NXbzqmFxwbnW
41953	payment	1397	1397	1678	1	1	15837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTkKnQcueB89GSNgALYgsFiWeLGotAvTYaVYny9EcjwLkdFxS
41954	payment	2133	2133	1874	1	1	5646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuzm8DQZhvRVrFgbBoaD6GgGnEkUjVJf93med9YqivEgG4WCV
41905	payment	1397	1397	1678	1	1	15822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrab3hFNKrwQVVCLvGxR6if3WycLAjMz1goyqy4rVkwaVCPXyk
41906	payment	2133	2133	1874	1	1	5632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7fpfnn6t9MJxEgcsyJ8rW2Gk2cwPdHQsR6ZJsWTAAET3UFezX
41907	payment	2134	2134	1874	1	1	6131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCejQiuqiobGNSX1wvrw6Ukr2rqF8QugdyMPXs5AXv3B3BT7J
41925	payment	1397	1397	1678	1	1	15828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpArKHXismBGyxcC18j3KCaFUFhvsGLbwUUb6tqb7bQHKz7o7
41926	payment	1397	1397	1678	1	1	15829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGVGrW34EkTcZ7Truhg1XX4Wvoag5CZPGm1We1C7NSY5q5HFH
41927	payment	2134	2134	1874	1	1	6137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv6pmFtp7bY6bJ5xXQ2maBVCmyug4Vv7qFiWWv36LHZFyDVuxj
41928	payment	2133	2133	1874	1	1	5638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9hwRUAXxt98GE9VExyuG8yo4kjkGzichMWictzdrRq76FNni
41929	payment	2133	2133	1874	1	1	5639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYfpkC81f51gTjpJvXUuM5hUKLD48aCFuuk4wXwNQSGiQvL53y
41930	payment	2134	2134	1874	1	1	6138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aUFUManPZ8zfJcUymcaXquvEQwhcBHEkpYsc6cDXVZJgXzg6
41948	payment	1397	1397	1678	1	1	15835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYij1ehAVVxBftERCfJ5EcQXQUom1oK1B33DYR7mmLwk1tJ7ihg
41949	payment	2134	2134	1874	1	1	6144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm78j3UvcRMbuda9fViEbxdDw35HHSu4SjLEGTzKTHANdeZ9dm
41950	delegation	1741	1741	1561	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5h8bXp9F9ZVx9AAf8kG5q2tve1kDjqq33Q8hEQPp5L6x1aA8
41951	payment	2133	2133	1874	1	1	5645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnPCZmnHe6td1m7RXziv9xhDSHgYZ77t8eVft5FVaFAyAXgyvB
41965	payment	1397	1397	1678	1	1	15840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTmdKsVUknhSSWo57fuxWrQaexr2JrD3KGPk8VTrPZWMgCj5z
41966	payment	2133	2133	1874	1	1	5650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxi8KSoZxFkvyqMu9HC7d3Qa66Bx86E7LDxgMLusdG1BQsmfDc
41967	payment	2134	2134	1874	1	1	6149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaruZZ3Fr4Qbgauusm31XDqc5AxQ4gEXt8eE6sYN8SaxGCSSon
41968	payment	2132	2132	1874	1	1	1612	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2KPY5xpQapsCMDcc1cK8qmokYHXeHuRWyLT2YUWWF5RXY1o3
41989	payment	1397	1397	1678	1	1	15847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ426ycyx47uG6JtQcBFKmxso775Qi3HvLtAuqTZGk7eiQMRRLV
41990	payment	2133	2133	1874	1	1	5657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcw3n51wKodSDDeTzEvFXJKn1GXhy9S5sXEs5GPJ9zJGBmkCcJ
41991	payment	2134	2134	1874	1	1	6156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBXTD8tgASGho2xbZHT47ns7wPXuzDfCSYpuHEiMDb61G3H8T
42033	payment	1397	1397	1678	1	1	15860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHm31aTTTgnuJ9ge9B9zUGLp2ZWdAUfpeDGWPFDKdtQsu9f7zM
42034	payment	2133	2133	1874	1	1	5670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNGmMUQEpEnU5EqrAos8pCeHy1HihiTptG4zmkL8QNvqaqaqx
42035	payment	2132	2132	1874	1	1	1618	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJwjGuYJ3BRzbqSdBvu9M3WL1CKap5MgvnZgqLhb6RSArLs6AE
42036	payment	2134	2134	1874	1	1	6168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpF4ALfnjZGAGFotBcHTNr5j9BBKnPgHDW4krzhEDQwBB6G28x
42040	payment	1397	1397	1678	1	1	15862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhmPjLNgw9t8sjtG2d983zhGn6GmUgDyyfjQw9BL11szv87hb
42041	payment	1397	1397	1678	1	1	15863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmMUYEXH55CEoHeUxCtcsEVtifuguRzjmerNVzU8zuhoLcnab
42042	payment	2134	2134	1874	1	1	6170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZExfL2MUDKmAMNbfCC94FJdrKVpYFaZuFKHTAEbU6q9GmWmQsB
42043	payment	2134	2134	1874	1	1	6171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbB4gURoCUYP4z2fHbqhS3yrXHoM2UtjMMVgkU1m6vKdYek3N
42044	payment	2133	2133	1874	1	1	5672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMz76Rv5eCYE9qN1gW41eYTEzDrEUQh3bu2SQWMFWkX31ywEM
42045	payment	2132	2132	1874	1	1	1619	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsXRNqeCV2nmczgLE7ij51fD5YN6EbXW4SZcRg7ZMHLYHGTUXy
42046	payment	2133	2133	1874	1	1	5673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCR8p1FCvN2ANXbQjGMvRfXvSTeSufBs8DaSVf3x2V7mssx96
42047	payment	1397	1397	1678	1	1	15864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwix6b83Az6KBgts27A89yDJJEcUKLu9qYnKS7GtrCQSqs4wcD
42048	payment	1397	1397	1678	1	1	15865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAzr3aNWdYuPHudWTjtVGjFA8R2fLUjhKWMY2vK5wRkrrU88h
42049	payment	2133	2133	1874	1	1	5674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3jrfjbuixxHVoG9XAej2aRLKScUoBBuypXU4QaEUwtczwFLC
42050	payment	2133	2133	1874	1	1	5675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiyQm9U7qrMjnnd7bkV5fXkAfB82r9hxhycqoygd7GC3TSaoN
42051	payment	2134	2134	1874	1	1	6172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemMEfu14y9h3SwKUPzDmTsLMm7t6yRGZ2oPThcAujcYqiD8yL
42052	payment	2134	2134	1874	1	1	6173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWJkrrwekreTRc3JEUXfmKs4QzgBYS5zQ3NepVyrzEMwhX8jE
42070	payment	1397	1397	1678	1	1	15871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMhveCgy44wCyRcP9gSVdJDmEnHPMLn77J2FzpUa61U4crXF5
41911	payment	2134	2134	1874	1	1	6132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3efDBH27iPmkWa9aR56aCT69HPPyaAgD9ShbVxtFeVkXkjUqb
41918	payment	1397	1397	1678	1	1	15826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NQrdhB4N7DjensX6pzpBgt6tSd7yg6MSWfTPWfGsaJtTUgCp
41919	payment	1397	1397	1678	1	1	15827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41HhoVBgNZ6iHPbi5WKi4wkRUVCvvw4o8mMp13mWCjEF3DJ7Y
41920	payment	2133	2133	1874	1	1	5636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw5ZW6KhAZc2iRUdkeiWZd14yr12tgYkvvYYYEZKM9uw3SZBSo
41921	payment	2133	2133	1874	1	1	5637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiVXchxFMrUifBSkKPFjB5pUyStaUqXTzBtFC5vpnkj7U7JwZ
41922	payment	2132	2132	1874	1	1	1608	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ATmuQFBeHVxUdR1BR2hpfpiNjYp5r2hcZokLakDRF6GcTDNv
41923	payment	2134	2134	1874	1	1	6135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFr25mm2eCaqcM4g6PQFKgVmXHyWeMEwN4BCHdc5dtjVeeHN8E
41924	payment	2134	2134	1874	1	1	6136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGjPB6giy6vVKGnPP624KHBDKNx8V4SGpskeGwmvRQZ27oiUE
41945	payment	1397	1397	1678	1	1	15834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfEQET8xPtVpa7So8Ap9PQ3tr95L6pwyGQcHgEriQnNkKFkMvN
41946	payment	2134	2134	1874	1	1	6143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7UVzg3d89eoAz8geY8VjPwPmgAiyERtWjT8Ze9x8DXmTVB2a
41947	payment	2133	2133	1874	1	1	5644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fxCE5or6A7TdRQ2qaP5S7rUFbWreraYYP26bZiyrASq613uQ
41972	payment	1397	1397	1678	1	1	15842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb88ENfNF978yHcHLz1EQ516rhb4Hj8SjBLFqhWTkbJrCLN3R8
41973	payment	2133	2133	1874	1	1	5652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdz16fDfkKncJbbRd3ovHWxZnEfSMNcwY734ZNWcYMYm66CYpV
41974	payment	2134	2134	1874	1	1	6151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgy5uSP2aq85VQBF71JQy2pa7r3e2imYFXAQqz2iXK9h33nFi
41980	payment	1397	1397	1678	1	1	15845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GsjZPYVkmnB8A4NSQMq7URUq1nXZnwnR2tut4sNYFPBrtCbW
41981	payment	2134	2134	1874	1	1	6153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPToJE57S5W1reas6JRxw4dicsxcAFyz7ijAvxFddzRK3g8AzM
41982	payment	2134	2134	1874	1	1	6154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUYAg5XWEQkyJ7tQgvPcrLY2KBdNbUXfqg2fHMq4i8vAEPbxaR
41983	payment	2133	2133	1874	1	1	5654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQD6xfLysxf9ZrgcQpU12GE41FVFv8FZyAnjEQkaBGsDevwiH
41984	payment	2133	2133	1874	1	1	5655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgEDRjebxVZcx8MZToMDLDD8EetEcmoSMgtv9CLHGQAdEw3gr
42024	payment	1397	1397	1678	1	1	15857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVt9pEatqS9yUcmi3SWyasdzKoPeL3WiK5wc7zKjkigFDqPBeR
42025	payment	2133	2133	1874	1	1	5667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhn62bSLmsXSB1zAsmS1bEvoDvodEmKmfSVaUW1KcLwvFKWQWy
42026	payment	2134	2134	1874	1	1	6165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLNbpZoNoYgTTRqWB2a1E2F95AM4ca84Ahk7y8hPcSzAmwL85
42037	payment	1397	1397	1678	1	1	15861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyaA2mQqAo1Jv1Mn6RS6t6d3WEYQVY1VamyF8omJ3osKE3ZqB
42038	payment	2133	2133	1874	1	1	5671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMQ3gA6ttCsevcWjCHxVdcy9wMXHxG7CSuBKDEsZoN9gyjNc5
42039	payment	2134	2134	1874	1	1	6169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFi6zFhvsndK9RiF6QBzUi3uau7kgpsPz2YHKensRtfvyfJWik
42053	payment	1397	1397	1678	1	1	15866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9dcoYa53f2mcaH89eXjDJzcAnzysQ3gDcdQ9LTGruLFq9WmYK
42054	payment	2134	2134	1874	1	1	6174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDxx9nUJB7WZ2j5Q4tZLSwXteTEbqBsUXBxHgEUs3jxBG96ad
42055	payment	2132	2132	1874	1	1	1620	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzScox59iefjmQ3dkXLpXvXbXezuzVk9SQnG1scn869TQHS92
42056	payment	2133	2133	1874	1	1	5676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98XLm63U73yEDk8VDx5Z7zUd9PiG7dXpwUwsJ2pi8X7Kzp2bn
42075	payment	1397	1397	1678	1	1	15873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrdwN7CreKKdZmSuFvXCAeB9FNDh7TgZurEiWguMucEvkKmS9
42076	payment	2134	2134	1874	1	1	6181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1MUsaCfxysqBs64SPCd5xgkGMGfhLN218V7Ez1iDCuxARoU7q
42077	payment	2132	2132	1874	1	1	1622	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DRxn6Gr32HiEKVfRWD1BGo8BPXWyQNRd13XwtLNRWWoUmrZu
42078	payment	2133	2133	1874	1	1	5682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Gh9mxxKbAzpZw9Rheus3mdiCv5gdWYGGVqw1pPwCB5g1CFkX
42115	payment	1397	1397	1678	1	1	15884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBivTSSJYL5kEP4bQvrfxX5kX2DmtHvmZdsNEpztUXiH6G6EN5
42116	payment	1397	1397	1678	1	1	15885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEcNQHNbjY1D7MPdjrNnMDKBKpXcf9NxLDk3Uf2GiEsncAyFV
42117	payment	2133	2133	1874	1	1	5694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsabKEcZ6vkmtZAZmQj7LsM3yxBmbmHCGsEXt5D9vSZRaQTpXs
42118	payment	2134	2134	1874	1	1	6193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETJ6jb1gBFYqss2QgoE6na6wPzBedvSGRbPS2Nav6XjPHBLw9
42119	payment	2133	2133	1874	1	1	5695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFhC95RhrpwNjXcDdDNp9jUcuKvHzG5AdRC4ieX33Ncdu5G9W
41955	payment	2133	2133	1874	1	1	5647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEoY3e3fj6uwGnMRfj4TXvGY1TZcjjhMgxXFgU1zwZTneuLth
41956	payment	2134	2134	1874	1	1	6145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8C5envELXUJSupaifJ3TMWB5NS3i6BhPtXTuDwiDtsB1fsnm
41957	payment	2134	2134	1874	1	1	6146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMNhf6x9PoTrmNJwGW6u8dS6HdNPnv3MKWvhcrZLKeiWzbJsX
41958	payment	2132	2132	1874	1	1	1611	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeadUCQk6BMztRYA7UpyNY9vGXBs5uQhVxGzzpm8QHnnLq4H6
41959	payment	1397	1397	1678	1	1	15838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkn2sb7FviT9LpXisPGJQhr4NvKa9z1dtMNBT76y7gSvwiWNN2
41960	payment	2134	2134	1874	1	1	6147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsT4vsinFGdmxi5pSaLrcNpcEu4dA5aVjsXfcyQwe6iz4gpB3h
41969	payment	1397	1397	1678	1	1	15841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvdwUKAJ8M1gQadTzspoM49mivK4h6cZc8txDbZng7r1KR41z
41970	payment	2134	2134	1874	1	1	6150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaPep8nfoH3ZxFqDsNaBpjiyMTfzLx5GFUSwkQoN9PUPZ1aUz
41971	payment	2133	2133	1874	1	1	5651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEgidDAmihC4Lsy3d6Gwy55cbvLyeRwhMB8fbRH1ZZuR7dvM2p
41985	payment	1397	1397	1678	1	1	15846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR6ugVuqHTmzC8oxfifRB4qLH51KBpJMn8NMZ67BUSEBF5G315
41986	payment	2132	2132	1874	1	1	1614	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV4Hd776w3ZQBKfqiwdWR7DtPyNmLuT9UWvXuA8BPDzuP3Edb
41987	payment	2133	2133	1874	1	1	5656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZzXwxU24LtJeQX1jSq6RwpVHnKp4BvQkCnco7HWnjXSu4waWK
41988	payment	2134	2134	1874	1	1	6155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQziS1JvNMzkcTiiSQry7an6tyXtQuV5EvrBRHSbZn6ShxUnq
42010	payment	1397	1397	1678	1	1	15853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoVefLANquSBjzaRyCAEfJkih7SiXExf6DiB5UWdDMnnv4tPv
42011	payment	2133	2133	1874	1	1	5663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfy7MNhyNYNYrg9n4BBUHRwkCk6VVMFsUk2EsY3cuHgu8u8RVT
42012	payment	2134	2134	1874	1	1	6162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1TsAaxc1AJL9Rjt8vFg6P89Ef56oJQ4Wtc7kxgAMfz1m8aeu
42013	payment	2132	2132	1874	1	1	1616	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZTjss7EPdDmySJPMVeaQcEAqU3JmripLCSf8FvfrijhH6umG
42014	payment	1397	1397	1678	1	1	15854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBHQZoBFtRnAV7LSRBBSCckkS8qA2W7UPqnk4cQhTMa33Dcxwz
42015	payment	1741	1741	3	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtB6DeHM5KtTD7iXMACJmEaNvnFCfsFRFQ7nPjPb8GVZPnqXFA
42016	payment	2133	2133	1874	1	1	5664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAEAYBeMiVX5iJHyKUJPz9CcUtieD6rXT4Gnw69qikfcUVQsqa
42027	payment	1397	1397	1678	1	1	15858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYts2MHHQeMs9mBxoD74GD1NtXza217QShsR4c1txr9Gxm2jJb5
42028	payment	2134	2134	1874	1	1	6166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxwQqiuJX5K3FmL7mqrGdogSQjuRkUKA1Utp7Ra64nfTtqqG2D
42029	payment	2133	2133	1874	1	1	5668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyURs1PZK85Hf5eczPac2iWqqrNsBeyaHJyC841cjBst3yqUE
42060	payment	1397	1397	1678	1	1	15868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn85Gafr8sJzyKHz88tdo94e3oBpg98nsKYyShmCky4qRrdfq8
42061	payment	1397	1397	1678	1	1	15869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkx4E1WepR9oTiWQyNXs18EBWHZbEiASaXEEGvQpq4mjPDNqzq
42062	payment	2133	2133	1874	1	1	5678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ksDELoqH8Boe9VeBkwiYTVfn7vyQcPzw8QxUS7yjkTHb5NQu
42063	payment	2133	2133	1874	1	1	5679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQUk9StA2amePvZQRLhPjwipCAp4Y398GeFBMHQJyEzVkYMZH
42064	payment	2134	2134	1874	1	1	6176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZsnTLiTzd8m7WUrVnFLLSwDWizuNYdZMvHtrCgKCeW8CY5RP
42065	payment	2134	2134	1874	1	1	6177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7YxGvHkztkHmT5JozaTuCmogdUJv1DF6PojnkpYTSivdSvKzP
42066	payment	1397	1397	1678	1	1	15870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMJinja9bXSmyrNwVxVephC8xtXpfiM1WKitGY57tFUbUCgHx
42067	payment	2133	2133	1874	1	1	5680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqWKx6eaBHH1mszdoeKJojrsg1uUag8MQT22jHKQ2SDU9RcSK
42068	payment	2132	2132	1874	1	1	1621	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBQzH1gSSe8QRi3wkaBoHgfVGnJpZpRefu9EmYVuq5YG63X6o
42069	payment	2134	2134	1874	1	1	6178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa175fqsekxec5ztqnkN969Ucz5AK2XmEWuWQVApsBGkFN8aEL9
42079	payment	1397	1397	1678	1	1	15874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fYuUQdmC3mJJ3JJcRj3oznAH1mRZLcKTHa6H1bbcWLRsWTmv
42080	payment	2133	2133	1874	1	1	5683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdG75PF7Ds7QLQqo4VNw6EttgsHNrrCoL8hmAYx3brwsFrxdL
42081	payment	2134	2134	1874	1	1	6182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAwm2N5X5Sz7uS6ZcE1xvqxFC7NGXk27v2kjAjwvDipMyhEDf
42089	payment	1397	1397	1678	1	1	15877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLu2N13YCEHfnLXyz1sfbSWbMskWg2uMipJuxfo5wWzjCxHcW
42090	payment	2133	2133	1874	1	1	5686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpcq6KNNmeXgmzCSybuHYg6fZZ2b1N5zoFGrmbQNBCpHsuie7
41963	payment	2133	2133	1874	1	1	5648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSchVC2ff7tBteto31AtyS7Q8yvyqCu95WG2Kt4AdKFFpfUk6v
41964	payment	2133	2133	1874	1	1	5649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRdYHKBQE344V8HPEQEmhNiFy1mpDdUnsoRYopum6CTqaAtdD
41975	payment	1397	1397	1678	1	1	15843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmfY1vjU8aoa48YejPwqJWZeqF8wLAFA1R68vyPHheMv4Pdki
41976	payment	2134	2134	1874	1	1	6152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG22VzbFmKM7qwPb9CeWNBfgTuQBPN3VTWqoHQFeqtZj2cC8J6
41977	payment	2132	2132	1874	1	1	1613	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWispCdSsCduf1Z2euEvfrg2BJv2F2crLCNrUM68NP1qDUnhQ
41978	payment	2133	2133	1874	1	1	5653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8R6gAecS2dDpGxWGRwaHPzknFioH2T3iNhGhutdjFuKjRsba4
41979	payment	1397	1397	1678	1	1	15844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwppSxozRj2AZmhVmbhRQbpzyz2FvLB5gYXUEmMwLL9UyMAHaP
41992	payment	1397	1397	1678	1	1	15848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyLdVFCqa26c54VUZKV5LMGyeCN5WcFZB44MJspbjBtj7yzq4
41993	payment	1397	1397	1678	1	1	15849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGQXz8Bn97J4XyTKwPXBjR9sg17wyEGqkhMHuzy53Ku3JHDH8
41994	payment	1397	1397	1678	1	1	15850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJbJi7gyENpqMRQwmmsZwvQSB6z1rVFTZ59oPdKom6dV7ZWA2i
41995	payment	1397	1397	1678	1	1	15851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZba7ch7hG5hBDvbexoU5bviKgLKxxWydnoAXy2QaWmsxNrcXtv
41996	payment	1397	1397	1678	1	1	15852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudwfrnbELErWQ3SX1tnet8paV1T2f5cC9wWNZxHG68u8gSu5b
41997	payment	2132	2132	1874	1	1	1615	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqUaE4hAfYnPU4JBzmiPzoSpbZwL5B7JbCBfecdpkK2mmWtvm
41998	payment	2134	2134	1874	1	1	6157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrJHxRFAFxn3GPi6KtzZprcMztcbzfTxtdK2fPZzPxoahsaT9
41999	payment	1726	1726	2349	1	1	8307	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZWtNNe6Sowb3paLyV3sTQ97mvP5gxK76apKWiP6uNeVTHTJUcz
42000	payment	1726	1726	2350	1	1	8308	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfVGX2zLtec9fp4zo61VzftMbajXE4C4CZhudiVDYWzQ8bcQYu
42001	payment	2134	2134	1874	1	1	6158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAnVDqaMZthXyYTPcrVekjtf6tEEZF56tbPhcT8N1ohmHzVdQQ
42002	payment	2134	2134	1874	1	1	6159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcBAnSnsx5hG28s7zW2Ac4M8Vu51WYHreMyGqWvJ5nPVSnwLYM
42003	payment	2134	2134	1874	1	1	6160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA3CeUJ4FbBJzaP4QrzGbhQWbnqy9YRKRwvfjBiaKKqeXBu3vU
42004	payment	2134	2134	1874	1	1	6161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfcz3Ant3HEHRquLhXCtSn3teGH8SeB2yz81WNWbZXP4T5fnU
42005	payment	2133	2133	1874	1	1	5658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJFiUC9XdoyJQKQ5nSkbdTsxvbCvT2VUY4bedVj7CDhfHDG8h3
42006	payment	2133	2133	1874	1	1	5659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzhbtHJYBw8EQrA3DWXeneD3GWodEGKLtjJtNnTBTb19yfoc6N
42007	payment	2133	2133	1874	1	1	5660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPeRAQPACsPvrAMqYuS1qwNBz7zUYxRNJaGa4W3zgP55sa7DC
42008	payment	2133	2133	1874	1	1	5661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9uC4u16JWK6atwbRkdZnmEgaddncsECyk3jvzYevfDvC59yd6
42009	payment	2133	2133	1874	1	1	5662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPgDjm9XpAH9uYANsuLU1y3e8k8WVjb2WrQC7msARKjVkexkh
42017	payment	1397	1397	1678	1	1	15855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJu5zKFSnFAVRFqPFGPQxiGFSkwyyEzbc8FMFBQyNF3G3W1x8H
42018	payment	1397	1397	1678	1	1	15856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF6JK2cYPoxWRyJUJhciFvqX6nnGEk3jXXR8yUYrQLPdS8otCh
42019	payment	2133	2133	1874	1	1	5665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvrEFM9LufZb9JKQk6aq1cUc4PfuRBpUbsyDxZ56DoWamhDX4
42020	payment	2133	2133	1874	1	1	5666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXsqvXZm8mP9BUXKghegDZHWGb887f6Rr8q5U4FW4fineRpap
42021	payment	2132	2132	1874	1	1	1617	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2meiofJtcVniemDgB2fXbdWJNr9fpj82V2h9JgCrNhCKFxbZ
42022	payment	2134	2134	1874	1	1	6163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCkGoGNP7j1kjS8NNiaahgnMQSmws9aft4bdBnVKUKmHc1HMm6
42023	payment	2134	2134	1874	1	1	6164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvN5w7Vfhew8FfWsFcxrVHz5A5wpmg2p7pn5T4RrEWUav37rDZ
42030	payment	1397	1397	1678	1	1	15859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqQiVnj1bqbNBsFRe12xQbnDPaLfVFkrKgnmBqzF8tDGXb4mPL
42031	payment	2133	2133	1874	1	1	5669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5RtLKFUodhvmoWqhtZm8XxUrU4q3iyw7pgBGnKQnYP4hfAc2j
42032	payment	2134	2134	1874	1	1	6167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq2Woem7jNDD6vaTnZ5sk4j8f232hdJZpbxqbt8bbWRpjpsRC
42057	payment	1397	1397	1678	1	1	15867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiJzy3xrN9kFQPDJcT3rowdqYJCSwUsZYrikMjj4e8NAZWc96
42058	payment	2133	2133	1874	1	1	5677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEneueT2RgSFtjwsTdPgeVP1MJkZQb8b41qwVRvaKqSiHdtmRy
42059	payment	2134	2134	1874	1	1	6175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitCARSQaR9VksqCgmCTqDrHN8ErGV2ER9HtbjwBQiNg7kmqbJ
42071	payment	2133	2133	1874	1	1	5681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgRQqnFFrZpd2wvFtzS6xc4dPK8mHGm6VkExHNgyVSvQ1wLhF
42072	payment	2134	2134	1874	1	1	6179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1RahYb7iM9hpM8XkBTZ3NLDGvmxfye6rbn6LHE3xwSwmqdgV
42092	payment	1397	1397	1678	1	1	15878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXaetgW27ndJUC4NBep8q2KhRp5vBGusihUKZtnTHH7sMWL4N2
42093	payment	1397	1397	1678	1	1	15879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV3uG8D8zmVkjYSmRfJnA7zbeV6HwLT1gUrP4g6qT31D92d53n
42094	payment	2134	2134	1874	1	1	6186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepXq1mpo2TyFDfqGkCpGyT3nsmQzZKmvVkFx6FhH9ExmSZXzG
42095	payment	2134	2134	1874	1	1	6187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVeG2U1F6mExkRJqVMKBSDuH5xU8j1XsnGiaSogaBesgJKm8ax
42096	payment	2133	2133	1874	1	1	5687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKPbAwKq6yS87KmMADiv5EJcsZocatyixnyRdUehiRMVuTHWy
42097	payment	2133	2133	1874	1	1	5688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCH29WFVqm1hKGEb9FeAqnhceRZdDqfgK2vSzPbqxJ3B56rqM
42098	payment	2134	2134	1874	1	1	6188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsoBRcRH1HMQs9RVV8Jjvu4e8FdzPJUULjaK3jy4SfTxQFwEFG
42099	payment	2132	2132	1874	1	1	1624	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42MMkXRygpudbj2UmJXgJuYbdiR2SsWKhvX6F1FW2QSNbC8VX
42100	payment	2133	2133	1874	1	1	5689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7CTQfXhQCPNzYKv4EknGKwq2PsFpwnWLTSwvFFa7v1Y1yn4h
42104	payment	1397	1397	1678	1	1	15881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKaXi6SLStL62M1tn63KXC2gTv5cKiETv3MtMpDDKEGAAGLMP1
42105	payment	1397	1397	1678	1	1	15882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDe8eKYyeTwBmDoKnPi9NnhUvULC2ffyvUSppy7zGnRYdcHmB
42106	payment	2133	2133	1874	1	1	5691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVZbNU7CdNwb7uTTADew1Qvq16JoU7KWRNcfr8hLJPPEGAo3BK
42107	payment	418	418	1950	1	1	0	100000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3VZuEZKvsxvBTBZCgd8AJWbQifxG5mS2RcCGMzkxX62bm2a4
42108	payment	2132	2132	1874	1	1	1625	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTbWkxGBVxPLYVJQG6b21oBBNZZHYvu2YSXGyv6wJD7JjGvM6
42109	payment	2133	2133	1874	1	1	5692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZympDpV9RFe8ypPLmm79zXtVp8ohehM7mbo32BYi9oxMwS1ed7
42110	payment	2134	2134	1874	1	1	6190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7VEDXwLQSdSHEjFxp1FmUhwRY8vpKGcyWRBD6HgdByMDitnQH
42111	payment	2134	2134	1874	1	1	6191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLXGN4khkMpuFBxmRehqKJVqcaLBt6g94P6tRuiktKj1JgXRY
42112	payment	1397	1397	1678	1	1	15883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEe66pyLx55j1NmHVjW4R91xvnmMsk26z7Q44KYUfMxGS9rNF
42113	payment	2134	2134	1874	1	1	6192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK41d3ZSQchV39TkhyXMtWUSLuhQcyZqRFtEUDixG2Gvpq46rh
42114	payment	2133	2133	1874	1	1	5693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3XhiXBhKyj7FDUwpr59yrX7JSa6ZEVugxg5EtVXyDCSXYwwUD
42190	payment	1397	1397	1678	1	1	15905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANE2Jw7hTVVvjA4KrP3WrXrqEMr7HGwUar5YV27juhMdmPZbp
42191	payment	1397	1397	1678	1	1	15906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9AoaMUZsa5iFiGmNt1BAqdmvMu4qMwTkc4bExDch7cWv8zxtX
42192	payment	2132	2132	1874	1	1	1632	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLmadpByG7UHk4fGdp8R3PdJdZetUsPbWzRu4WiPpGYyxYPhf
42193	payment	2134	2134	1874	1	1	6214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmR1wHjDsBWtSiVymyi3u8FMsG3qhZJR9pj6vbkP11ZtYdHAG
42194	payment	2134	2134	1874	1	1	6215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXtnqfrzLEXstLfbRdjK9B72xSPvZRmNuJebhn2ywWzPhrosqP
42195	payment	2133	2133	1874	1	1	5715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1sUA237sQDXZivTZyavWG7LiwCWMgpfj23Jmc8ipasEbDST6
42196	payment	2133	2133	1874	1	1	5716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaULqS8X74npZxNf4pLL6McEAvp22WpC1urn3MfDYqQVYkGWzk
42197	payment	1397	1397	1678	1	1	15907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHwDQ3GPbuDUB2k3Di2zrwHC4J661g5bFHpWUNQBS9LVJuqs8
42198	payment	2134	2134	1874	1	1	6216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjBvt3TgCSTJMm7pwJaL5BJTW2BLK4QrnkiP354nm1bx87apga
42199	payment	2133	2133	1874	1	1	5717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4fwuN6N7pBJBNYNQjuyQALGQMhUYNqNsZ2mMcVM7ydVzjLxKz
42210	payment	1397	1397	1678	1	1	15911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9jj4TeyigSutzTtvjD8JRAi1guRURaMCDybg9KknR2qLgmUf
42211	payment	2133	2133	1874	1	1	5721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KprCQY2hTVEThk8EDe2BDEf8HDUTsy48XD3XHFhvXFMN6SnG
42212	payment	2134	2134	1874	1	1	6220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqfw9NMa9j1cgjtpnZ49ZcrLincKgQbAQr7kpN3j3kho2Ueib
42227	payment	1397	1397	1678	1	1	15916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzeDy3L8qM875xFbUMZFko2oay12UVqYwrVb8teUvTqLpwGAf
42228	payment	2133	2133	1874	1	1	5726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwd6GmuiwdNCdMj2i6uETLbAC3vwkNxPdsnQV86QtJgrCTcJxB
42229	payment	2134	2134	1874	1	1	6225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwqwrm41Fw7wvnayu3tMHZTBUKzpuAKq1Tafs9kf8MiQPKAick
42073	payment	1397	1397	1678	1	1	15872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJu7EVmA6wQtNemcZe6eRU76naYhcb1UC62VByG2DBMs7NPg6m
42074	payment	2134	2134	1874	1	1	6180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmUpDMcRTxrAtoeuS9XDyDE8M4VGKQWRxek9BGHtGKmjANvR6
42082	payment	1397	1397	1678	1	1	15875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5fBZeNonuJRNkcFM2gHGGRgPuHVkuoa2c6hmWjc1JnrHiuEwV
42083	payment	1397	1397	1678	1	1	15876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE4od41EomEbuRhGDvjDax2hVsfH9DGHRtAx9yEaTP4eVe1xxs
42084	payment	2133	2133	1874	1	1	5684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYco8x9aGYdnmK5D3BwHjQSgwyoZArPxNqmBstFaWWNxhb9TZfS
42085	payment	2133	2133	1874	1	1	5685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmzT2a2q1txKcTCGrF7J14qYVcxsiMwbv1dpFMa1dTPsAMUaVu
42086	payment	2134	2134	1874	1	1	6183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBoEMb3WM4i6DmNodDRr4TWUTrxaYmwtvTexPRMrGtQqK5qc7M
42087	payment	2132	2132	1874	1	1	1623	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYr6Su3Ym4yRGC4NWvqx6m2gt12iwyaJ96gUWuCjfmfqvB79H
42088	payment	2134	2134	1874	1	1	6184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAbBHWnNNvZcLX52SBBU9MPVPeCirHM3eHCg2wWS7gx6z3jegF
42128	payment	1397	1397	1678	1	1	15887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHttZ9dNFowwwoMU1tjK7ZJSWtNTHCC48q9coec7dWz2ky17fy
42129	payment	2134	2134	1874	1	1	6196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuPbrHMUqDZUwActzU4fXWLjFU2eu9WrTVA8DwXPHbTsQePfG
42130	payment	1726	1726	2353	1	1	8311	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYfkmZ3U322EsFEZ7qYe2dJpGM4jRUJhEtPzQz7GJyxAyw4Kuvr
42131	payment	2133	2133	1874	1	1	5697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwPSXYxgpa65oqQzhG3KPWypv6CfiMxjooQ6GMmWvLUJzXTDZ
42144	payment	1397	1397	1678	1	1	15891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5GqGfcxkp2NKm9dzxMHpzQU3fBtwB56c6q3sxTooJQUqeWmgb
42145	payment	2134	2134	1874	1	1	6200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCGWEgT9Hy6YbcH1zTgPXMS1pNcPyvMHanWvT64qL9axRm84f
42146	payment	2133	2133	1874	1	1	5701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirfth8mQpw2XMfALTridN4J8TALELBhFRZzyMFCmimntHtfVb
42154	payment	1397	1397	1678	1	1	15894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztJ9HzT3VN66dxeddrUtnXg9jqhBuGVzNg71yeqEvw4s3H8zu
42155	payment	1397	1397	1678	1	1	15895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkUWzhozRYo1FVH3x3FxJsD3c7hu7UciQjrp7uv6LKJxksTHxS
42156	payment	2132	2132	1874	1	1	1629	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6S6jYZnkEQERpKVctKz1ekpe25nczvfBTPiSHrdRP29v7Zab
42157	payment	2134	2134	1874	1	1	6203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQeJkMztNpJaGoshZHJLj6KZv94fA5Guz4dFESX41LL5owuMe
42158	payment	2134	2134	1874	1	1	6204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeKfC6ouw8Ewbv4j4AnLhhzVKymBGMrHqTzpgXCRMDEyNyW47
42159	payment	2133	2133	1874	1	1	5704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6G5gFWymbBcSwAwaowffyDTHcm2c933utyNbkohdcfAeFHGNp
42160	payment	2133	2133	1874	1	1	5705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMyHD6BfvYPYDzCjnHNrWmaP6oHHGxEuf7FeF63a6Y3AX4Ub7T
42167	payment	1397	1397	1678	1	1	15898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDZDiUa3ukMoubDQZhSkv6giZXKA6DWmt5maqg78QaKJAUvAW
42168	payment	1397	1397	1678	1	1	15899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEMNEoPnpTvVD49iDxEkf8c6oPAu12nw3uN4C6wpBqT1UaJYEn
42169	payment	2132	2132	1874	1	1	1630	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiijxoWi33X2odvcKuoQ8oNwfwH7mRBt9yLTSXCK3dHLVzBQxF
42180	payment	1397	1397	1678	1	1	15902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXeRJKnpWjCwjZnEkbAEBVzhCbzxnaB9uv2ksuKJYy1mF3Vzu2
42181	payment	1397	1397	1678	1	1	15903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3H9MWagzokbZ5za4uc9g9hVm4eDPmkRJLcmt95MCAgwK12CX
42182	payment	2134	2134	1874	1	1	6211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvwYTcriMMK9ETiigbyNweRgT2m9fwgDA72DsuKiJsDjTrsPi
42183	payment	2134	2134	1874	1	1	6212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMp1sNdfNnpeD6C2zJGeH3xEPBy8uCGQu7Faq783PQbSFvJM3
42184	payment	2133	2133	1874	1	1	5712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNWndQWG25XrCQsrcwhtGL32fn6SLz7pBAkCrVbd8wkJ66dFG
42185	payment	2133	2133	1874	1	1	5713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLSDeahVoPsDgpmufRUUAtSjrJegGWZwLfXGp9e7ny4cwTpJgY
42186	payment	2132	2132	1874	1	1	1631	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANBUkuP8yLky8WM7eTQTvaQXHgDRFSDrtFR9FoWtb4V4wjbqw
42207	payment	1397	1397	1678	1	1	15910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrj3hVdXZnGtno8prtcfsak7FTg4rdB7mKxApNd8wfaQKkYrCb
42208	payment	2133	2133	1874	1	1	5720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRpCE8ewvCJEMk5MpMeyioFQQvT32aPsvVDtytfSGvbJiRNZwk
42209	payment	2134	2134	1874	1	1	6219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFcVSd6mRJ54HuqwffnycAXo4zEKR4W6PZervBd3tDbSTNyhPC
42213	payment	1397	1397	1678	1	1	15912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTGyVTtKSWkDhJ6UydsCPhqweUbjhymTT7Wv2919Cn8WUj2dUA
42214	payment	1397	1397	1678	1	1	15913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuhsN5sbarxx199X12QtLr5f8FNDYSuqti6FrE4euqM6AGkR6S
42091	payment	2134	2134	1874	1	1	6185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPrdknzcRmPGBpAT2KB56wjhVhas1k9y5GRBS3n4YiDpyZ5PQ
42101	payment	1397	1397	1678	1	1	15880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW2BhkjVRzPrGNF872iqezWRUHYLunM5kosBrHrekKtirRncEW
42102	payment	2134	2134	1874	1	1	6189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7aKJHpw24ut7VSo7WrYz3ZYmnVDKdjA4TKGEmhE2zwV2DTXz
42103	payment	2133	2133	1874	1	1	5690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19NmmhgsqHHczg7UsFS1YXAfvpTq1BctFhAjMMNDNcDNGAVmq
42122	payment	1397	1397	1678	1	1	15886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZntWf1KCoxAzLYmAMiekVoJsmAXhLJhE9y6FaLS1y2r7pAbrUL
42123	payment	1726	1726	2351	1	1	8309	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYhPYJwfNbByFogLbmVtDD49K3SRDxx7Q46aXtmfxGuuvxA2Jja
42124	payment	418	418	1950	1	1	1	310000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrL39pVqY1jACdBSLD72LaMXzBWxWxgw4LfcY6PEBMEt1p3P5Y
42125	payment	2134	2134	1874	1	1	6195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1aP8ZpHoVedspDi5S2Bdmk4Vrp1DmBbFoyzgbEmH29w49y6rN
42126	payment	1726	1726	2352	1	1	8310	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZEcmLXmSPDZ98m83CbvmynJNz56M6dR8CJjCmhqCeWyJNvVQub
42127	payment	2133	2133	1874	1	1	5696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKTusecSeA4EwWP7LuHf9dQi3UDt46FY4RgjQRTynPXCyDNLdM
42151	payment	1397	1397	1678	1	1	15893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDRf9HNRK2Zawd2NN3EetmW7N9JMuVoTXwVECDWPUwfHBqoYG
42152	payment	2133	2133	1874	1	1	5703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTp6H8uHx2y7zNnvR2X9dnZMNZoHrvACfuqCLDKAaXHWGWcycA
42153	payment	2134	2134	1874	1	1	6202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CGucRU6AVQAYHpMMBvTDoRSwnoq6BWPGXDBwt1mxPH7YC4k3
42161	payment	1397	1397	1678	1	1	15896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ87BHSNeQu5VodNp4uzgMsamL174wZfvuUnFW39FJJAVSWE1w
42162	payment	2133	2133	1874	1	1	5706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpD2ZWnjXWDK31Sh8vFkxLBxpzLooiLy9dgQggfCXQ8QCyJ82D
42163	payment	2134	2134	1874	1	1	6205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG8efnSvazTLoRAmKPy4vDZVQuoRuiaQWMqaLbkosFncXtxq3D
42177	payment	1397	1397	1678	1	1	15901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZscBHEzc5wvaesYfzLXkjM6jHUb73fCEkbgz7b2hLUHxbfrnPa
42178	payment	2133	2133	1874	1	1	5711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQwDq7StaCq5vhHHUYWoWaDXeGNLGh9gDPA2XtFmWfPLPdvRk
42179	payment	2134	2134	1874	1	1	6210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFWeqWjndiUzpXBAxtVxqnhNg5oJMW1ywVMa4RHN1QV4wQ8zN1
42200	payment	1397	1397	1678	1	1	15908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr5oV31NKSsRKZRM1CTuxd6H5CkNHivLQQht2f6XYc42E6ALvu
42201	payment	2133	2133	1874	1	1	5718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoDfroarToTgcXkDxgTWLGbbkvWHwT2E3U2oUL5Fxyvx5ifk4P
42202	payment	2134	2134	1874	1	1	6217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxXfwapcVQCiY4jnujWYUu5113dt1hqfmb8QdZ3oNctwGSUtdu
42203	payment	1397	1397	1678	1	1	15909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfzJLsQMZDf2h77bXDT9Y9vVAtLubeN76WDVmnUt1wcbFP9Ez
42204	payment	2132	2132	1874	1	1	1633	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1tFiMgSofWw7Vsy7HHj66wuK3j6RSQHTZ99WEktWvhA9vhXt
42205	payment	2133	2133	1874	1	1	5719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJqNqgCs2xm9yBdo7yhDgnLhvrn2dQnNaWWPDSufWLrZ13HxFa
42206	payment	2134	2134	1874	1	1	6218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4QvQkVctGnNQYaD1Bei43mgpSXzpw1vz35euFvdmXR8y3Ac3
42230	payment	1397	1397	1678	1	1	15917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDpKxUKJfkE5Us5bFfy6ydAaEeg7Dg2x12Krjuw4yf79xi8Wj
42231	payment	2134	2134	1874	1	1	6226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpzvy6jE4msNruqN1hZfYhB4B6LyyrS6gA85CxWbUHcAZDr5Z
42232	payment	2133	2133	1874	1	1	5727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUmj15YKQYAqB7SxPbY1romwMSc3TZ3JoWDpPnxo8sJNG5KcLW
42253	payment	1397	1397	1678	1	1	15924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9BTDN94y2L9ZqtJqcHAjgmH6gJvfRFrVYxucHprEaabnXSAw
42254	payment	2133	2133	1874	1	1	5734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMSpWhd5dPPRFkjuNvw8vmqhBHdDPn7t7e25crm7DbfpobCdA
42255	payment	2134	2134	1874	1	1	6233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZtwqqb8UvsgPqkUNHQ3Q9zk3RiUZ7GVhe1PXqw1GAqifw74R
42260	payment	1397	1397	1678	1	1	15926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA8CZ4XHGgwAs75yztccR9MyDPSXTsYD5Xy43oHDapmYSdZtAe
42261	payment	1397	1397	1678	1	1	15927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1DC2DKnmqhdYEtLdDpWQ7vWQL5ji4BqoehjSmWc1FXhn8446
42262	payment	1397	1397	1678	1	1	15928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYgyYmXirGB4SyBHF4sntJdB2cKfXzxcuccjoG3hY7Wwp3TnN
42263	payment	2134	2134	1874	1	1	6235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrAR8jQccuBUTx8ZGCMyWSsuqGuPUGfwSbgrvVA3xBr3t27BW
42264	payment	2134	2134	1874	1	1	6236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKEorXUncmqfD3y5ML1QBQ5mo467D3DUJe52PsDhTJfj4oWrmZ
42265	payment	2134	2134	1874	1	1	6237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2etWWdtBAEMttL9qnPuv9hBySSmVXZwgJbbLkNAFyK4ge2FDi
42120	payment	2134	2134	1874	1	1	6194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZqfUMhjNKyA7qDPKYavCoovVf4EdrbiU79A6VASQiMAyJbw7m
42121	payment	2132	2132	1874	1	1	1626	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkftVrwuuJ5WwzfYrYVuk2tG14nooBANNnFRjrqzYZG3NmPoy
42132	payment	1397	1397	1678	1	1	15888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bAiuCN3ScJxyeZhkeq3aMR2T7tnuXwLV5HF8swEhghF2WxdM
42133	payment	2134	2134	1874	1	1	6197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrPRHTiVu9e5JkMigdA1romjazQGrzKtGapwKa1K4zPDbJ3pm
42134	delegation	2352	2352	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnSfzaiBxWzXb6pR86iuVpRnB4NYEcUEezZAgwQwiSvhANQspS
42135	payment	2133	2133	1874	1	1	5698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXwkSumPj6RkTDJNpib2YxkYWpksj2sT8nZf3wyqPSiCz8ueS
42136	payment	1397	1397	1678	1	1	15889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaeKWnpG844nbAmjRFinRXCCcuRqE1ZzhR7HJXajpXqUYrjdo
42137	payment	2132	2132	1874	1	1	1627	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8viByCNtd28R69nD5cWGDi62SrhdeM1UWmCkL7mCUb1CUx4Y
42138	payment	418	418	1950	1	1	2	310000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeSdwSPunPxoByWScMf22PycMiqccqLrV7RBFLXqja1tTjjsZ
42139	payment	2134	2134	1874	1	1	6198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikL9qALvcRd4dLPXsY1RZ1QHB21QxXxGnfAjL9fx5cgJeWG9d
42140	payment	2133	2133	1874	1	1	5699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywJ2SxprxCQitd7b6fMV3v4niP56MbcoMxWxsvdps6oY2D5KN
42141	payment	1397	1397	1678	1	1	15890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpkAZrYAGzTevApyzA8TgxUPpCVw9qKNz53imF5oabaVHruYZf
42142	payment	2133	2133	1874	1	1	5700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8yYWJCCWSdZ9P6DjDEvoxc7TWsuEjdDrproKnTwiHVqcLAdV
42143	payment	2134	2134	1874	1	1	6199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVar1JHrLsNv8R9Zosi1FQdQxUxtgGcPZHsvvuDdN8PaQSDzjV
42147	payment	1397	1397	1678	1	1	15892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLEs7ZLZyfVTJQenV4moukknUxALv5o44UWcSbZsR8BhXHQn33
42148	payment	2133	2133	1874	1	1	5702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKuNysGxUdATxg6dih2idP5JxryvHP8q6Qzo9mJhyLhgiaPG1
42149	payment	2132	2132	1874	1	1	1628	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkffN859ec8eqnWt6RHS4WE7mvGdBvcoyzYQ1qczx6gU1xL23
42150	payment	2134	2134	1874	1	1	6201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfN5VhCMEHuBrTos2idUKHFGwApEDAxTqgGENwzipG2nqAUcW
42164	payment	1397	1397	1678	1	1	15897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ZqVYqKrFDRxFFysdYYGzWxShZ3SLeBN1jBrFJZHR9Qk93AVg
42165	payment	2134	2134	1874	1	1	6206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdquQAGZJ99yZDNRSBJXoeH3GZuDdcYhTENNEEy8poxbcVrbxw
42166	payment	2133	2133	1874	1	1	5707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5P6GWt5WrRJq24jL4KZusZDMr4KMtB4E4YqJTVNuP2yPbQb8B
42170	payment	1397	1397	1678	1	1	15900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56UfFFdjU58wJMRbzKrRJ1UZahwacJVj1qnpPrM6uu4PpL8uf
42171	payment	2134	2134	1874	1	1	6207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKNXTYEQfT1RZ6dAxFoGiRzwBzUfkKeXvxQo5Z2U8bweA7EQ6
42172	payment	2134	2134	1874	1	1	6208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWg2Nf5LKXkwHkyutdxzNXpGZ3o64Ne8CDn3w21vkQyj9P92G
42173	payment	2134	2134	1874	1	1	6209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJqyXUKnpj2AbMGDKyetHtmW3zHDFu8hQwFpueyaT5X1rSuc2
42174	payment	2133	2133	1874	1	1	5708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA3QsREsuo9WWNL6iGHruWJ6k5Bk5Fnsbaq5PDn4abJqURbNBC
42175	payment	2133	2133	1874	1	1	5709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77zxFtYW4UngZTmVhFYeFVQKTLjESe7Yksv7oPVxoSBvadSaF
42176	payment	2133	2133	1874	1	1	5710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAaKXgLvQpHqFMsyJ7mFpHwHa9yt7Fq1J5zupKHzsdECkLFEEX
42187	payment	1397	1397	1678	1	1	15904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9fwddngvBR8woTsTQg4YSXVFn2XS4Ercihh7A1GnKYYnNUo6
42188	payment	2134	2134	1874	1	1	6213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49G8cKxhYgoyTX23uD5L1LCa9NKS1JiwD4qCydTytysNncf5r
42189	payment	2133	2133	1874	1	1	5714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAG7nJtVv8qjFvnk2Zo6Gk1iS9VQ3kfKQKdK9AmvhnpgPVP7pj
42240	payment	1397	1397	1678	1	1	15920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUUBRu1HMgCscnwaCP5V2Zcj7EocpjBwCjVC6X2dj52sJmLRE
42241	payment	2134	2134	1874	1	1	6229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFf5zqrNrDU7YSzEdBLpPRVMpyrs4HXYE4EvZRHrhWY6dD8ttZ
42242	payment	2133	2133	1874	1	1	5730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZorH76uTuBSCdYP3YyMdbByLYP6vZp4j7U6p2r5uyVkePDBxQe
42243	payment	1397	1397	1678	1	1	15921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4Ha8XR9SwJBRMXHWxDoEgGmU5VynJJGUJseC5DKeUNbYiz8B
42244	payment	2134	2134	1874	1	1	6230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6XjWN4nwbUyDNdFtQjJ1EpPL9QqJaxLTdE1N9qECntHZjav4
42245	payment	2133	2133	1874	1	1	5731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvF7bFTktiwEiyjBkg7uiPguGACh6qEFxMMQ94kH4DTPZ1UL1
42256	payment	1397	1397	1678	1	1	15925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYRCciFUrB8NvrUacYijBwEbeXc6e8JzKX8uX4ieK8cKan7c9
42215	payment	1397	1397	1678	1	1	15914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFb6N7j7Tzj7K6b68XFErieH1RctsPG8SKfaYRobCm9CUZxdNF
42216	payment	2134	2134	1874	1	1	6221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgUxJbsvgzidFVXge1A1Ke7VYdwqPMFsKDs6nX9tbNYcne7Q73
42217	payment	2133	2133	1874	1	1	5722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriXr6tpLMSiPPXcqc4MbK4LLZb8WSXnXyPcKzxhmw3v6oKMmn
42218	payment	2133	2133	1874	1	1	5723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7w2WpK9qeoRicUyvTANjuESHXhvwNsRspdrvb8ztnY1FYB1in
42219	payment	2132	2132	1874	1	1	1634	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmt136Mizn98e2v3WxgnFz9yzswDGMz2BsM5anCxFZNUTvidY5
42220	payment	2134	2134	1874	1	1	6222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5RKoKctczfQZFErt9ArWheewq8xBJ8xS2CQiEctrVvzbyfFe7
42221	payment	2134	2134	1874	1	1	6223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWd35aWbKM1iVKA9yJeAFqJ2qPNRgwApEE4aWWRsiANivWHf1
42222	payment	2133	2133	1874	1	1	5724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHs5XZMfNv1ZuTS8taor67frJAA5wtV2zD8eTjVrWzrLDUtE8i
42223	payment	1397	1397	1678	1	1	15915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXqnLos7yb6BnEWzwDAaop25Kdgk3UooaefZBBgx7FBQWmR23V
42224	payment	2133	2133	1874	1	1	5725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVF2au3DcfBDH1Cy858Qr1qjnsnQoi7M8LQ3LNgco75GChd3qR
42225	payment	2132	2132	1874	1	1	1635	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAehhWxCtpqMYSYrBiEMSDK6cXJjb6oFN5cC8bxtudkK5rTDT
42226	payment	2134	2134	1874	1	1	6224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFYSkiT5mh4gL3L1nQCm7uF5ALd8dzNWhBEwT4735UbAF4fWBj
42236	payment	1397	1397	1678	1	1	15919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPg5iwSxA4uwWphNpCcNv9iwb3kxy74yd6xPNHCAbZCMspWCQx
42237	payment	2133	2133	1874	1	1	5729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEtNA1KAhUbyj2WKS59vQfqwcdRSiu5mU2Kn8mYoaLE3TFz9L
42238	payment	2132	2132	1874	1	1	1636	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUXotyw3uzuDTk3GuT9oUnoW6CQocUyBGuqSGXAVmzgZiy4kE
42239	payment	2134	2134	1874	1	1	6228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJsCMLYBZeS6bGM8rpKJT8Qr5AjsTw4hPD154HxkspmbPUT2m
42250	payment	1397	1397	1678	1	1	15923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRz8tVRxjEhKB81qov1ANVahs433txY7VGid7UwMCeKLWeF551
42251	payment	2134	2134	1874	1	1	6232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrudGC4B9CxDjmF98VDqCLWYhiZ2QhN7PQpmAnjJXjum7oNaft
42252	payment	2133	2133	1874	1	1	5733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPDqJAAHfNwK8EeMPpzSDSDmaF4QMB3MaLPWthV2ET7D4GteL
42289	payment	1397	1397	1678	1	1	15934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMB4w1UkNFoHrzo5Z1VUyxMXdsAgLxQS71kgu1RqGuCp6tHR52
42290	payment	1397	1397	1678	1	1	15935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGyJ1nEnaZFpc7gtpntZkHA8oTmhPA1421BJx9yQdRw8cLEWk
42291	payment	2133	2133	1874	1	1	5744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2YaWk5APSaCmegfoGCMrdkhwZ544i2d3p6zEWP7N92Abhej3
42292	payment	2134	2134	1874	1	1	6243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhzYUreT3aaPvd4xBBrGZicBNEqm9zbBp4s4LmqtEPWdH8z2k
42293	payment	2133	2133	1874	1	1	5745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm3oVLn5akbyMaY7cvackDWovW5Z1nwPmmPULrWGbPJBLyFfR3
42294	payment	2134	2134	1874	1	1	6244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuaPQ8dmjfmL1hw4Joazid9qfSsEKmBciL4w5fUwGndshZbqTx
42295	payment	2132	2132	1874	1	1	1641	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFHy3a8QkaS8bJ7huTGQLWzVEiA1gxfshE7rmkdCYNxH93Bvi
42298	payment	1397	1397	1678	1	1	15936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6HsBXyGMvYn5TSPXejLMmAjWodeZpD7wmXm86KnmNYDMsfAa
42299	payment	1397	1397	1678	1	1	15937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1XqXBDYZMiVsCCYFmCQXemDvTxWnpMhNNWUJ86QoaLkyodTXt
42300	payment	1397	1397	1678	1	1	15938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaCnwNBpFEw28apBxKPGJUxHHyBMom3eLRqiY62D6rZGJJH5h
42301	payment	2133	2133	1874	1	1	5747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSbrpQFsQeHMBvGPephKiyG3fZrrdyyRtP3hPKx4NqbZqfChj
42302	payment	2132	2132	1874	1	1	1642	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqood1VewSvAMvtSLTtmNxcBNAtU5UKhM1HbQ51zzgaczgp5a
42303	payment	2134	2134	1874	1	1	6246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79mMfBaFr5njy94PKtGVBnZqzitxsLdDqpqqigKQ5SuGqkVqH
42304	payment	2134	2134	1874	1	1	6247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKsxxsRVfix67CjYfjA16DxfwoDov6d1SrrWdGuEtfyqBxqQZq
42305	payment	2134	2134	1874	1	1	6248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZzX5RkZL9CxAQs1XNkewPFfq44oyMWQDHKcHjRb1RtnKyyghc
42306	payment	2133	2133	1874	1	1	5748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxfrrMEMEEb3PuKJhA5GJfwL2StzyfBPvU6K2urWZqA4EHJtJz
42307	payment	2133	2133	1874	1	1	5749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWqD6S7ErUC2ZinhRaC2vKdehVxz35M4pYZRakphHMmWGzLZN
42317	payment	1397	1397	1678	1	1	15942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPYDvQeB5kKW8acdsZa7eLDs56ZBzT5uQz7kZFYpJw7Ub88sF
42318	payment	2134	2134	1874	1	1	6251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeh19yqTY6jC8Gqvmj9HjJow3x7gLWwSMhDcUaMWUqKzzfzzbi
42233	payment	1397	1397	1678	1	1	15918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FxBnzkP2qAVmCPdY7NUW4npEaY1BijwHvgNT7hGqmA1qMnbj
42234	payment	2134	2134	1874	1	1	6227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6DZZ21DgjDauNG18x76zCVFEfMEigzKFHrhX6yM5vJzaj1HA
42235	payment	2133	2133	1874	1	1	5728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbVcByGjXgSvKuNQQbGu7ZuRxq7Km36LpsKTqLALQZ1Smqxxy
42246	payment	1397	1397	1678	1	1	15922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk9tEHTsY5BFe93qAKUR5koSpbKJRzQ3gCqVD1HFBejMCYeg6t
42247	payment	2132	2132	1874	1	1	1637	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4SfAzehzA7y49TYm99gJmSWgZduin5JjZQfmUuY7fXdCNiXt
42248	payment	2133	2133	1874	1	1	5732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLWm7PGfv91ZEhpFbuJ6BW7bFGL2fCGJd5hfJ6Tstncs7j9vTX
42249	payment	2134	2134	1874	1	1	6231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKiNdRrFJeiEDXqJDRZgn1UgJf7ArwB3pj61a3HUn7PSjtiEAP
42269	payment	1397	1397	1678	1	1	15929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFqV2b59ZiDpZzXsrnfsunrJeTRV9XfytzhAbf4csMJJj4QpBw
42270	payment	1397	1397	1678	1	1	15930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9NqwPrPXKnatsWqo2dFb6fckGJ8T8szExGEzZ6dtzKraSy4g
42271	payment	2132	2132	1874	1	1	1639	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqFcdyMS3DPAheGpubUN5cUGJ4oMqu6u2B25rPkUktBf5nAFG
42272	payment	2134	2134	1874	1	1	6238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Kn2HH1tJ549QSnHVkhEofCXqjWkvobjB3fZGwM6FVx9nZZBL
42273	payment	2134	2134	1874	1	1	6239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6h8DBAG5QQrGhj7Ebifwew2vANCqH3Bvn4QJdzcGrGYisLyvk
42276	payment	1397	1397	1678	1	1	15931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgiqefVafm6EDkpHJrzXS8EBb7EKsQp5BVVjKTjP4SFgiTuMS
42277	payment	2133	2133	1874	1	1	5741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ94BAWsKBDvUG3JSJqJjZNDS21jRtQ3RJVc9ZjyYbsYaFL4Dj9
42278	payment	2134	2134	1874	1	1	6240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiajD2KCVmmgeS4zhArtWVMxmLSVNb3nQZnx3QEtyY2i7yEqvR
42279	payment	2351	2351	2354	1	1	0	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5W8PjXm7E4u2JrAiiETLa61oZvNJZdXHZ65q3L2Ymc2qjpC2T
42313	payment	1397	1397	1678	1	1	15941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMEfAD4CTAJV2Y2xgbFRrHF9SNPuVfm6iXsvrQyzd69QgjCsN
42314	payment	2132	2132	1874	1	1	1643	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiasSCjwMxs15GyxiGiHqM85zXnW8Lyh7bWdfnQ4iX1kmMWfUC
42315	payment	2134	2134	1874	1	1	6250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHq9NXe1rvhrRi86YSux8DyLbHbTVxc4LsR6sJj8cFJfVMPcge
42316	payment	2133	2133	1874	1	1	5752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeXBvAuHxju9Y1esNxVbvycps57QabyptgwTSiX4gxMe3BcpQ
42343	payment	1397	1397	1678	1	1	15950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbJ5LMkv4UBknvxuLH87pTREKfcQ1pqdoU1MibKBWMVorJsB3T
42344	payment	2134	2134	1874	1	1	6259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSfHEuFC2aJu2EuY33okeJpkfbeLiqbwmrJraQzwbc8HoMQoL
42345	payment	2133	2133	1874	1	1	5761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJGxDRQnnyq3txCaTxvd9rm1Yypv5La2CEWbrPphPruWLwJcoG
42409	payment	1397	1397	1678	1	1	15969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpZbnznuQ4ZiGjNk7AoY4U7ezXLaMNyejNWVVzHb3YcDTeL5V
42410	payment	1397	1397	1678	1	1	15970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZftnDfDaNceFtZK5ajL45DtY5oQu17yMtwkBEgb1Gw2CrmGpUe
42411	payment	2133	2133	1874	1	1	5780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHTwMfjp7ANJgGeSZrKit3LNZhfVaxKhCvyGeWswcThFZXZvt
42412	payment	2133	2133	1874	1	1	5781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cjNFMtaMUpq5FTFtSepWL63buhre9y8GkfgPyE9YH4SctrL8
42413	payment	2134	2134	1874	1	1	6278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3939rVLFd4ZQK9hKy2U8ggjSMjcMs4koxqiiUG6BK6h3dZXaD
42414	payment	2134	2134	1874	1	1	6279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7rutQDeCxWNYpEsS6YyBJodBGuF1a4xx7FYtdgrSr6kobEczK
42434	payment	1397	1397	1678	1	1	15976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDgZL3DEcX8Lgi2PC2FBaqa3BDQ72z1BPFMTLnUaCS6sMShJs
42435	payment	2134	2134	1874	1	1	6286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6ufxNEFZNquTGE8zRzxo9XgaecTqn8CB3o9wxh2vWbnmJmeE
42436	payment	2133	2133	1874	1	1	5788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6sDfU1LEV2BtTPqkLxJVsCizX8ACUJZmVUt8B1skHTVHyGp4w
42462	payment	2133	2133	1874	1	1	5797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmEB7mjtzUh4AMVSwdFkXApEpaT8z55b1MHGQTPU4RTpD34fy
42463	payment	2134	2134	1874	1	1	6294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSU6a33uvXnDdMbuSM36pAf6YCmYqdCmdGGEz5PVnEw6NvThZ
42464	payment	1397	1397	1678	1	1	15984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8mdyroEQKkX8VCR5R1oDYSrLKvE7EmndhHT8UzFkXgc5tGKd
42465	payment	2132	2132	1874	1	1	1657	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHYB7fdFFB1auT8S8PBtw5jRJxjYJF1yQv59hgpnEgMetWgXx6
42466	payment	2133	2133	1874	1	1	5798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLXsAxNQsPYffTSyUnposvVWQgqfXnAfjuKvULF9pME5ucmB7c
42467	payment	2133	2133	1874	1	1	5799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZiQcf5Tv7pR7DkBp3r1wjG3bW355VJZQdiUKHqKhvtZGV6XMP
42257	payment	2133	2133	1874	1	1	5735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyLqKnBViiPKxMdLB27r6b2oy6f6S9MwefF31Cinwa6Q4VT4G
42258	payment	2134	2134	1874	1	1	6234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12Xx2nwZZ2qMZryJijwgfbQmR52gVXwmDNLdKoeexZCCLrA3i
42259	payment	2132	2132	1874	1	1	1638	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tabXsj44joYzmVY6tVeju7dTV8wEDsjEpJfHUsU97mEV2oYQ
42308	payment	1397	1397	1678	1	1	15939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzQfRrRWzQBtnVrU2urQ71nKyVBu9xkoJPjvzS76LiQt8GGcE
42309	payment	2134	2134	1874	1	1	6249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCn2ASR4VNZZnxn3p1jsQR3ALxFgVBBYnytjtrGEeYEFKwEHDm
42310	payment	2133	2133	1874	1	1	5750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8gUoLEnoHG5gvXg6UKs1znZBoJ4dccgV3Rypa9PTzJxRpzqF
42311	payment	1397	1397	1678	1	1	15940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1g65CMi65vAHH3N5cNGpxk9528oEto1a3vT8ruNj7biFyNhij
42312	payment	2133	2133	1874	1	1	5751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXo8FneRELRYxHoC7bb3JyXsFCNE1v1aLbyxU4iabFyH1uMdk
42333	payment	1397	1397	1678	1	1	15947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFoNYx2JK9Bdc6EXaqmwDJi3Cja3LeTUJ4fKdkDczw3ZFi5Vi3
42334	payment	2133	2133	1874	1	1	5758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdW1PYMdRVXNRYKuZxb4vxVcCyC83zy3T1mEeMFmmhHLFxed64
42335	payment	2134	2134	1874	1	1	6256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pKV135LYYgrE7PaC4o2CXbFLafqYMHjpoh43j9mZB1ArKrhF
42349	payment	1397	1397	1678	1	1	15952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnnmMwQoXzpDM4DFPD3BZVYYRjTFn5iDfpbC7xas7PTu4qMZ3F
42350	payment	2134	2134	1874	1	1	6260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaAkp8axZuUwJFTYa4BfALgtFtgUR4apvdQBDqU3NbkrudfPF
42351	payment	2133	2133	1874	1	1	5763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yaco8TWBUXkCNzCMRwTWBTC8hSumoPioHxKmepqp6YadDma4
42352	payment	2134	2134	1874	1	1	6261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9S36BfyPvxLiAC8yWTFN6d1LCWy9faGPAzoXQn3fbRAdtbLxZ
42370	payment	1397	1397	1678	1	1	15958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWhsH5LyUSoprM4FM9QHX9ymsusveRuCeiK93VYbR7cT6FDP3
42371	payment	1397	1397	1678	1	1	15959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzTR7RM6G9DBf1iGxkcrZgLbmKXPQxc8sj3wmzL5iT85fADn8
42372	payment	1397	1397	1678	1	1	15960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MEV8jZR1FG5WdarBJZfwsf7dUA7D8asE5Cqa6rduJQGXekFQ
42373	payment	2335	2335	2346	1	1	0	99000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMSK7vVryZzpcWcJRUigkJV8cFYKvaQWYjiuT5kcDvmZQZyCX
42374	payment	2337	2337	2346	1	1	0	99000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6xKjtpFA7RRdNJxymkq5dJ1QbVyTK6E6aWu6A3jr8RiFRxZ9
42375	payment	2134	2134	1874	1	1	6267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzL8f4Gv8j452hnaQ2z57uTzCtd4xNd8oYCYcAnG7h1EjA5iso
42376	payment	2134	2134	1874	1	1	6268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRviAfKk1hjdXQiBA8tqKjSke8w8KkW3Dz7udPcFNHxMqLMWJq
42377	payment	2134	2134	1874	1	1	6269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx9jaG9AMKQxZGgbycoKfPtNcUEsJMCcTGvJkKuSCe6HFn1KUB
42378	payment	2132	2132	1874	1	1	1648	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1eKCcjkTHR351dKWiYLcCVsC7LjYxUoBUj4PhCANUWwThMVys
42379	payment	2133	2133	1874	1	1	5769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDS72U1NwwJ4jfzE3ytEWVj6TRxcj6MHbzBuxamthzeq1kjJUF
42380	payment	2133	2133	1874	1	1	5770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGrGd6WN6LNxL9TmYYzeKJQdwT1ma2krvNZAxgaKGCYeSdR214
42381	payment	2133	2133	1874	1	1	5771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUobJDoUzPk7hMirqX5t64wvmjLeGV2VBT7MQH6W9nraPHmnJQ
42386	payment	1397	1397	1678	1	1	15962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcg3mQGdWewcMBP9qQ6sbdKZbgSfBtGfAwgQ7tuX3nMsW7NYS
42387	payment	1397	1397	1678	1	1	15963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrySuTYhzrHVjndWySJh71SXBCb5y3KqBJ1WRGNFpJFzZuZ3L
42388	payment	2134	2134	1874	1	1	6271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXLsafycMrPWmzSyhbjHqHBikFnyZqsAr2hR13yuLKEmXByAs
42389	payment	2134	2134	1874	1	1	6272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYptGcU2UfdaTwhd7SHZzXsFxGbXouY3YJBbf1Y9m3NJQ1QHvs2
42390	payment	2133	2133	1874	1	1	5773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHJ2jQ1uLZN8vu39oCFQSnDRf29T8ZdvKqx845c3a6G9AjpZC1
42391	payment	2133	2133	1874	1	1	5774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUzK3BNAGMRmNQxnn3K7nC3QbsSsTqYjYS95gtMiwju97NMsx
42405	payment	1397	1397	1678	1	1	15968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJTVFDfJ1LkhSMaPm1GcsUU58pLA6eLQa1UqimGECEmbv6MQF
42406	payment	2133	2133	1874	1	1	5779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ84mq24938k1VQ4PpDAZ5En1hnoh8J7grdVASa4EZ7d3qb3jDg
42407	payment	2132	2132	1874	1	1	1651	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5Qarq3TpW1nENgSeM5yMZn1K7NtAqCsxokCLgu6PmnFS5SPG
42408	payment	2134	2134	1874	1	1	6277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4DqHY3iy2sFWCEbdYX1WFbCdKviFRiCgiKXRd1U9Md1hQGPvM
42423	payment	2133	2133	1874	1	1	5783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCQVfxLJUf5MiFxfMCaijx9Kz6iqwNaHgfPmgBjTtX8SfSoXu
42266	payment	2133	2133	1874	1	1	5736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Fb5euiy4At3AuGYXoVzJ9kfdp7q9CkJPSJvAVGEdM4mYd4Uc
42267	payment	2133	2133	1874	1	1	5737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6gViMTimFBUG6To8ZNnwDmAiynFcWmW8W7r1Sj6hAkamUXtuV
42268	payment	2133	2133	1874	1	1	5738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjSpFqivpPsoNREh6ShSzQX6L7kCDiH9Hzc2if937s8pTy2qtd
42274	payment	2133	2133	1874	1	1	5739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRR4E6zBvQbGhZP1GusE8qvUFyaxV3jjRNaTYEPFPUqPJvbUFU
42275	payment	2133	2133	1874	1	1	5740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevm4EJaAB24LrG6aSNh7eR6aamnVWZjHm52JhYmc8EZSzzRkn
42280	payment	1397	1397	1678	1	1	15932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1X59Wu6kBZzjiZTVbB3wjmWJHhWrZbFGH869ydSoQFdXMUE9
42281	payment	1397	1397	1678	1	1	15933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYwN6xciRohFe6WjJbg6H7wRsTKwcG429XsEXN2RWQtcF2yx9
42282	payment	2134	2134	1874	1	1	6241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs8bzWxM4o15RHqrR4wEDngZBXkTix7yvG9jLJvKZ9rKLRqJ7w
42283	payment	2134	2134	1874	1	1	6242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqYyhEeC6hWe23xZY8rb5i77wP4fHgJkjVyyiM8B5SeadyWTmN
42284	payment	2351	2351	2355	1	1	1	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaWNRjbgvPYGeMcWrbSpX1Gk546Eyn6bnknTXHCqtSxRco4wD
42285	payment	2133	2133	1874	1	1	5742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkpTrRr8grWkiYZqjxpQ39qRL8nXMsP2AGJPnwD5Hz7QBPqXc
42286	payment	2133	2133	1874	1	1	5743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKUj7hzjMurrqRKSx24Pu6Pxagj37GNG7brgrU3s9nRbHnrVYJ
42287	payment	2351	2351	2356	1	1	2	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsyq8XStqRewqDG2X9hD4KQLN1N2YB2Qn6NE1Ziae8UYu3qdd
42288	payment	2132	2132	1874	1	1	1640	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxW9Nk6wZSXJ4hkjJPTojYPtWZ11jkEPnavPe6U8sqmYWtJFsv
42296	payment	2134	2134	1874	1	1	6245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnoiBCwtJyCLjSisXzCFpY61M89ErbGPRU1FLsL64EHkT2rgAD
42297	payment	2133	2133	1874	1	1	5746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bi7a1mfKbv5kLrQTyeZVKQz8K9Gof93SBTdj9qMydKf1yfVb
42320	payment	1397	1397	1678	1	1	15943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkrKZte4BCGEoCBmpPrvFeYkQcVn8wTVTETNxNAZv9GHvFXvy
42321	payment	1397	1397	1678	1	1	15944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWJosm2dE2Mrz7X8XbW3uRgcixodgNByNvCXtcEB27EawG3LH
42322	payment	2133	2133	1874	1	1	5754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwvDiSK93BKWVEnN2Cpy89PkckAajoqYcE5Aiy3AGZ7FkpogXb
42323	payment	2134	2134	1874	1	1	6252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuP12ZEnAysiNTDVDnmfHNb6EXxQ5cV5KFzzkbcjVboUtxAVJZ
42324	payment	2134	2134	1874	1	1	6253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7b1JKifCtbsr8upZfueoKYnCkkShMMZfTuBW42Pefxu2Jf7dq
42325	payment	2133	2133	1874	1	1	5755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wUDPcvyMLJxgnDzeiLcvLtM1LN48PxiGjmBhej4iCA4Tw1Jd
42326	payment	2132	2132	1874	1	1	1644	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa98jdckXEtqCK43CGGLJjQB2Ds55gJKvqA9xtXVkFSVP8q2hym
42336	payment	1397	1397	1678	1	1	15948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVd8HPKX5LdZpEqfP6jjY3S8pH61fGZx8jt8VS2AyzYU7nMrCa
42337	payment	2132	2132	1874	1	1	1645	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRGvjYXYKYCnFruCxsfsowPQLZjHVgQx45Mhbqqd3LCVid4C8
42338	payment	2134	2134	1874	1	1	6257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv4YTf1MYcyKDyb5m2L1Cir22SBrByHWauNUTuK8utqRTgk6Rj
42339	payment	2133	2133	1874	1	1	5759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42oiayYmZxdt6fKRLGJrdXESke968k19NxCT61r5an5a1fiQY
42353	payment	1397	1397	1678	1	1	15953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdRYGC3GmcXoGTYrZVaLbFgdu1DUAfa6rooVzDP917bHYLAVd
42354	payment	2134	2134	1874	1	1	6262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfumC7v3XSntrryioyQGxhwbKnQfeR7Rhi5XhbNetiCe4Zafa
42355	payment	2133	2133	1874	1	1	5764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8CciZ95gqvueVV6BHKHrocyUS4nQNPDoYiaJWqXw4m4r5vMT
42356	payment	1397	1397	1678	1	1	15954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnCkcBVvL1VVHKNRHo4WstsVMR3sZTivkpCQ8kxUqqNWbRCoVV
42357	payment	1397	1397	1678	1	1	15955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSPLQcdzawpK1HthRarqr3yiV5K2if9a9tZs2bjbHCkQtAVs5
42358	payment	2132	2132	1874	1	1	1647	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLZMxu17hvSwzmDLCVSeqE2zHQHsVxxCmwYzfGHHN3G2be77h
42359	payment	2134	2134	1874	1	1	6263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBn41uBKJWtPigZeZA5yEbww9d3qsb5YrZEv4vKVjKtkVhsyz
42360	payment	2133	2133	1874	1	1	5765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3jFGw6QbFzt6goAMR4n7UqaV2VrY1a7CVnD3GeZoDqouYh7k8
42361	payment	2133	2133	1874	1	1	5766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Cg7FdTYWZ3f6NATw2kPMxSyZyhxgR7KKHuqt8sN7Js1MRxvT
42362	payment	2134	2134	1874	1	1	6264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUfJsPsgidhUrWq8ZRVSsYnS5hUXTaPmBd8m1tmZpfnibSBUU
42363	payment	1397	1397	1678	1	1	15956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrfLbf34zZ82QD6jdqN8FTf94BkTAAYh32UMs7hfTnFLQPsP1
42319	payment	2133	2133	1874	1	1	5753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5x7hu7KMPGncBjww8fB4XWF6cntRHwmyFvKCV1jDrLpjYmvqx
42327	payment	1397	1397	1678	1	1	15945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRVf8GnvDPiNeJZqv8sZ1iEgnfgCQaCPS5MWVr6rwgnwNE16zm
42328	payment	1397	1397	1678	1	1	15946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfePyfJ9tppNurQywc7HXkod3N6LosHhY7zQmDZC7xdB22hiF2
42329	payment	2134	2134	1874	1	1	6254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpwxj8MQx3wPecGjJX12G1HAAJrGK6rtbV6z6EizyTijntW8z
42330	payment	2134	2134	1874	1	1	6255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFaPxVUFeAoULMhQoVnkmTMoS76Up3a24mi7kpsDkGCcENvcR
42331	payment	2133	2133	1874	1	1	5756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkeVhSguFDaMSzR5mBKih6BgvZ2RbzK5XiJow76wVhDN97tUE
42332	payment	2133	2133	1874	1	1	5757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCne1RzemgSbKjdYMnjcEmWp4FpraGw64f2e3PCV3e6qJ1Sh6
42340	payment	1397	1397	1678	1	1	15949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHMc3A74RGYrQSBafCTQMQnc9Wr4PgWhv4zPzFT6hEZPcpJzt
42341	payment	2134	2134	1874	1	1	6258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZnxpazDPEjSbExXGa4FauDSgpohTx8RZBaCrVkBffFn78SWZ
42342	payment	2133	2133	1874	1	1	5760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxbpo452CdC6YDhAzGwC1L7uEpUh49W6WBd9txusxepc3jua6
42346	payment	1397	1397	1678	1	1	15951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3JkqJtvPseMSfSfvKbGfef3VwXY6D226i3L9x9vPE8UzC5Wm
42347	payment	2133	2133	1874	1	1	5762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtC3mj5CJfz1z8vLAK7HMJL8HxuEy1A7aAu54V4bX3zcUBtsm1
42348	payment	2132	2132	1874	1	1	1646	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKxHpB98rXTRi4qDECtHS19hk2bCbw1XtwZnAfMdCG5RTTb3nk
42382	payment	1397	1397	1678	1	1	15961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCtdgxfq9Pccc2nmvJChTqRuD7aMaEFfasGRhj9YLDU5SqU5P
42383	payment	2132	2132	1874	1	1	1649	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5YanBZoyKY5Jqe1dVPZQhzG8wNmDdrXHQHj3E7qThYRUs3W2
42384	payment	2133	2133	1874	1	1	5772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjz7DMwRPn1yCdM9HfqGy3WW6gm11hvL4tfo7Gc3AtoLRVGBM
42385	payment	2134	2134	1874	1	1	6270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4sxENQERz1xYZwmy3dgTYYJPLwEssCZYpiyoMgbkDJcSwkXr
42392	payment	1397	1397	1678	1	1	15964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpidaAoTXuKhaGXiRpeA4iZvFoQmPvczknPwFija4hj2d4NQ83
42393	payment	1397	1397	1678	1	1	15965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByGBySFQsQkPNpv8PJAXR8DDCvoXgBeVS9vFcTje32i34PDeN
42394	payment	2134	2134	1874	1	1	6273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj71WRrKjBAEvQUVsoa76b7DPBUqTgJGs9UvEop6ht3Qfkp9i8
42395	payment	2132	2132	1874	1	1	1650	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7v9Cxdo38knf36Du7pfgF2jygLtKdwEwQAeGgMBaSFTJDyVv
42396	payment	2134	2134	1874	1	1	6274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4s23VnF51tnSwSY9DaRkbqv6ikUsvnNgCsMWLQB4we2GGhw2X
42397	payment	2133	2133	1874	1	1	5775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NGaYw74ZLDFXYZZFHF4EbaQiQoXTEEYjgrF3Tr8iRL7fpDgd
42398	payment	2133	2133	1874	1	1	5776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp5mUdQdhHUVTymcsok241W8b6uQoHF2ASh6UMKwJtsfLty95K
42419	payment	1397	1397	1678	1	1	15972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3rjGLWpTahQr1BrTp54wig71Hdy8Fvjesy8EQDtzGqFSELfuX
42420	payment	1397	1397	1678	1	1	15973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3H6hRUJjxhRcsiDFb5N2KhW2XtifTbQeHRTnUqLaFwED5qQmY
42421	payment	2134	2134	1874	1	1	6281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5TsjYfTUK1RmL1Tvc3ZQ7g6KraLffBmr42URpSgrNdqcq1Rg
42422	payment	2134	2134	1874	1	1	6282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXBZGMSQRsBHfRPW18g11FRQfJ51oSW3pwgJpGU7ujHCav8vg
42425	payment	1397	1397	1678	1	1	15974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAeG4n6ikF8keZCpK3kJVXcQg6WRqffq1JvXEtBhJz1R9VEfp
42426	payment	2134	2134	1874	1	1	6283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTeP4tjkgCwvnbeR8XFqwZNBMrFY9UB28eNCPyCPTxXJj34RS7
42427	payment	2132	2132	1874	1	1	1653	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmtkdUASGhb5HxXtTq68yA57b9tee4vkuMMxbLsGmnoGZLLGw
42428	payment	2133	2133	1874	1	1	5785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf8r5Ui3UZHk2L47JZmWVkoizE4dGHruugNKtKRyUTkuGP5f5L
42447	payment	1397	1397	1678	1	1	15980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQMxxswMaxLbEe2nw8wGTjSJXkb6nbdD9FmEM4RBtV53KTvNK
42448	payment	2133	2133	1874	1	1	5792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYo4RBs2o1LeKfQD3iH6fBud2TNBpuqiRewoNZRCGgx1chwoK6
42449	payment	2132	2132	1874	1	1	1655	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtywyq1a55YQnQUjDPfj2eCtz6JrHqiePvRJsvAv4exb3JEs8
42450	payment	2134	2134	1874	1	1	6290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9vK13PQDWkheCMac8j971tz4Djyw1VPLYvgvwc7pYFPcrEKL
42451	payment	1397	1397	1678	1	1	15981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9f4oP9dUPLigVEPZm5UVehSMB2R2qfR2siNFNrAacMxdGjrsQ
42452	payment	2133	2133	1874	1	1	5793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4g4b9LVK85GzY2L9WZTV5iBHtLeG2Fyuk2QmA6CagUBEgijs
42364	delegation	2338	2338	2346	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT6mxMtkAaYsqun6gvvApgpLXThcUFM4k22vXoySJmBN4Zq4xH
42365	payment	2133	2133	1874	1	1	5767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQzfPFHSDfXDvQmCUCgymdxLFU4eDqTbycFDntSq3xn8XRqDt
42366	payment	2134	2134	1874	1	1	6265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSEhbkogchLEkKxGhzVPtTrQXgqSTBvXSEqXFyHDvhsvUQAyr
42367	payment	1397	1397	1678	1	1	15957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMXt3p2euYf9VkoUMGALZP1WeC3yERVA1NmGyj2Pu4C2Zs8nmb
42368	payment	2134	2134	1874	1	1	6266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdFho7sd7FQdyZqUngvbvLx4VBmjHeX6XZUZPVwNRVhgeRq3mn
42369	payment	2133	2133	1874	1	1	5768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAJ3ztnhReFCXpeZ6uAgah1Hi4eTK75kHkKRF3QNqkpcfjJwou
42399	payment	1397	1397	1678	1	1	15966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbmc7AxayocdgGsyh2YQUwbYQ1mSGco3GtdoW5fjChCkqDNsEa
42400	payment	1397	1397	1678	1	1	15967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfycKS8dYDKgmiwyL8fu5au2uFPWGz1Lqi4LKZLyGBvfjpFYLt
42401	payment	2133	2133	1874	1	1	5777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg3rwsFrjvUrxkdQDnhLenb6ghCw69FU72Ei2WUyJPqwK25DgV
42402	payment	2133	2133	1874	1	1	5778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PsFy3U3cKFoBGD8hDK4FtYoUkDYvNvPfFcw8fBof7oBc3k9R
42403	payment	2134	2134	1874	1	1	6275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzXdgNRxn3jTThutQvU3yuGoLzR1MqgSBe2TGEV7orKdgwZys
42404	payment	2134	2134	1874	1	1	6276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXgfMQ2RFEdi6jKvEPeBQwhtwhYWAZZA6a7DiE5D69iv8cDGB
42415	payment	1397	1397	1678	1	1	15971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssH2M9J3N2R6EU41uz142AZK7Ercd9To9n5N3gRpgvMygAbyD
42416	payment	2134	2134	1874	1	1	6280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMEHcmxLSA6pHCrs4YAX7aXhMzD7tvv5xNd4N8MsH88Re8Rvus
42417	payment	2132	2132	1874	1	1	1652	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaEQrr79BSfE8TAmLAVpxCUh54K6KuhmjRM36u4cs8zpNPJt21
42418	payment	2133	2133	1874	1	1	5782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42uJLG7eNnrShBYncMm2ndBkEwSaqm1GHNffFUTd5jPUbSGo4
42429	payment	1397	1397	1678	1	1	15975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqJqdZcwo6kDjW9aaK4JNg9vh9FcLAmZxSVdKkqbSsVHEfpCs
42430	payment	2133	2133	1874	1	1	5786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XbStt6zBAstU1dCCBNSNe15ayqLPDcoWxT17UsEksdwLNMDt
42431	payment	2133	2133	1874	1	1	5787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqkVpFYzkX8ePeCRSgbXurQoyjerwoQiDqEV2Hw8EFDdtJhkC
42432	payment	2134	2134	1874	1	1	6284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKWLwbvF7ma1zK6LTo17UW1gKZhqP1uiktoDKLT2bBNco2Ckv
42433	payment	2134	2134	1874	1	1	6285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrb6Zuv9vuVHwRQRNSYBGLYYLMLX4DxWwuvwdovxkGg48jteCm
42437	payment	1397	1397	1678	1	1	15977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1Vw3ZB6sbsZnZCHvPUiNpEsnWruKCAp9Pz6sSHUkViR9B8Ri
42438	payment	1397	1397	1678	1	1	15978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa937TmyEyEmEAfWYcjExk7uTNvv6Kc5zD5ZwgWyWBPUBZLweSX
42439	payment	1397	1397	1678	1	1	15979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUswvEXqtwDhPp4MG6z4qXkKadgCjccyHQW2btbFS41zVkrPC9
42440	payment	2134	2134	1874	1	1	6287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PrvuGzuTCQ2avJokHgCNKs8BAvCNsdzXwHxMMPW7X7DodaWD
42441	payment	2134	2134	1874	1	1	6288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpJ3epkm7j7rytKbf5EnGh7ZwgtZL4LuQGLdqUbvdB7LebM73
42442	payment	2132	2132	1874	1	1	1654	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCWXCiFW7dZteEfGxrn1KtAzy1DS8hKNdKjALxD3UN8LkHQMm6
42443	payment	2134	2134	1874	1	1	6289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5jBNgC5JD58n5G44WrKFAFQT9daZXGQdC2hz26gg3yBLrDNB
42444	payment	2133	2133	1874	1	1	5789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLLBXgkQpJ8cPAHKAff3xxn9nFrPe4t9HJUAfsYng3U9wyhrT
42445	payment	2133	2133	1874	1	1	5790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeAyzfKBD5JdrNN9Hie7ft2jk137kRPgNuxmam4dHVysVj7Xf
42446	payment	2133	2133	1874	1	1	5791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7fnd5H4V1ykD62QPrMYZSTbpP14A6HR8LEcvV6YaCiPEd18Ea
42503	payment	1397	1397	1678	1	1	15993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7Qqx14kTxnKgSvuKTZmMLoKJ2Z99T2FZ5mo9e6ogyRgi2Ut5
42504	payment	1397	1397	1678	1	1	15994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbWPdJ5Kr9tDgXcAPYspBvye5sJhcdWb9smEpgWPiMmbqsVvSG
42505	payment	2134	2134	1874	1	1	6306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjasTDffk4D8ggKsqfzWDkaUgBSFqXBi1RmkavNvLo7m2cKPe
42506	payment	2134	2134	1874	1	1	6307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFEULXmRTzorrbq9PzPCLX58nD7D18eCWTn3jLFyx8b3tTjM3k
42507	payment	2133	2133	1874	1	1	5809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDk2aqVwmL5o2Pg1J1mBgCBzoyRvxxuQB9RFC1FghSFMZ6QAga
42508	payment	2133	2133	1874	1	1	5810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa42K1tSm3YPue4yj19YmaACAip1qpXpH5KT3VH5nvbqAADtH6h
42509	payment	2132	2132	1874	1	1	1660	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEw3gnuapEmN35SsNgjstXWCAF57wZtqauVjeYsc5nGCd3P7Md
42424	payment	2133	2133	1874	1	1	5784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wcCnfHCPEUtCYXwR3pTfrn6gtMUSts3RkeUpeqwPJt9UKDoE
42453	payment	1397	1397	1678	1	1	15982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZScY1gEniEYrCgi9yaSBRU3gF7PU2qxCw3P1buPtGJ8joHdj7u
42454	payment	2134	2134	1874	1	1	6291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNxzJhbd4qrw7nHk3N9ioZbuQ4CyRNu4jrqQ767hNGQRs6r2j
42455	payment	2133	2133	1874	1	1	5794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZse6pJQBYpQ8Peiq3HQrtGjyUjZS4W6EDyXaXhbRR3RjzfQKp7
42494	payment	1397	1397	1678	1	1	15990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZax5JyGGGqTvLqStuoZjd9z922nuovuuoBdFoEwrY6sJXnyx7H
42495	payment	2133	2133	1874	1	1	5806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRgJ8RH2UBFbLMeVbVFkZYh1iLfEprW6HUbDfKCccT2V8VbJVK
42496	payment	2134	2134	1874	1	1	6303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZjT8xUqzXiz7cWNNDzBEWvoHYFyheE92KzJnM9ceQx8oFR3S
42497	payment	1397	1397	1678	1	1	15991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfeX9AXrfC9pi7kNNYkk5rqd15CuGCLET87egWGw8obQuddpt
42498	payment	2134	2134	1874	1	1	6304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduGfZdfHxtGMLfbz8UE1nsJus7MvfuqPSrTLPzJPrcZUGagKf
42499	payment	2133	2133	1874	1	1	5807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bmqSGAjmqLKxegQwAm53VyVjbeu7G841tKytttErtMnooast
42510	payment	1397	1397	1678	1	1	15995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjynH9Y7ydAwJJmm3p3fVUyUTt8zpxKvZq72vN6HNGvRTtSfq4
42511	payment	1724	1724	2362	1	1	13	1000000000	6000000	\N	E4YRfJDjVKqwGS7P419UqpceVMLr1zRrjbeDz5ZtJPU9gHQ3nDgg6	CkpYgPNxodk57epELbQJMCQTSxSBEeSW5LDDQ9UJ72qSUQUyoWF74
42512	payment	2134	2134	1874	1	1	6308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT7KXT1HKR97Xv18XocksNSBA6qfCKBGH2JjP6cVYVApsf5xyM
42513	payment	2133	2133	1874	1	1	5811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGB8xmqgEPHmAAo8Q2qEp5SPJY9PnfF7qHFpUswXEhKamRdy7P
42523	payment	1397	1397	1678	1	1	15998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpZR6EnDq2R6a5ZQpVQaDuGQyzyuQMDaby3WisgABerP43Cos
42524	payment	2134	2134	1874	1	1	6312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe7LmVsXjXiXfG71vQ99y5kdsMpZHujDukzJNtWakuFFr4vrWi
42525	payment	2133	2133	1874	1	1	5815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2grj4Mt9yTqiuYRxCcFhMrJd3CQ53qp3F5anePwFASjSVdrc
42526	payment	2132	2132	1874	1	1	1662	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nSEJGkPed5wKG6myH2JpzgpKrktVC9mdvm2sCvPLY1ABx1Xk
42546	payment	1397	1397	1678	1	1	16005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYr8pJdW6u194Kzc1689qmZTiiYRaYwc7my9P2n6UWHdnXjJec
42547	payment	2132	2132	1874	1	1	1664	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxc5xerTCBVMM9jAbJt66RM45hCUcww9DW1VupJC3qJ1heyH1v
42548	payment	2134	2134	1874	1	1	6318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtckdN5t7cqXg13p3tSNwVyQRdyuFNetLH5K8EtMMRMcryZQU
42549	payment	2133	2133	1874	1	1	5822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sRyh2cMYxTwyHhg7MsMbTyd1UEU88ga7qxVgk7cGAPq7ATQj
42563	payment	1397	1397	1678	1	1	16010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCh4iV1tDrsi6rsPSTdreB1YFFqGGZ6FE8v5LqzVYce8LG7em1
42564	payment	2134	2134	1874	1	1	6323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4WNw7s343SP6A1QutATrVv1MUcw5nZFuHHWdLdwMKpVDLs8z
42565	payment	2133	2133	1874	1	1	5827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNnGmbWu3x9SFi7C5zdKtrNcfSvmHTbNDgNnHZV6zqLPRAKnp
42573	payment	1397	1397	1678	1	1	16013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrkeq31p1KeLSyrp2m6aPXACBiFwNPf2WT8443sokQSA9Cueg
42574	payment	2133	2133	1874	1	1	5830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUEnY9sBD66Wb8c5fPmuaRfXBn41yagMTZ97qWMySAgERKq272
42575	payment	2134	2134	1874	1	1	6326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rivFyE1UXGtwjwQ3aQpZf6Y49ADCabwM5WhXsTcMxUhuYj5a
42586	payment	1397	1397	1678	1	1	16017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8ctecRdKuyHXYuVHVfXfttxD54UprgiPFqhyk5gvqh6EbrBe
42587	payment	2134	2134	1874	1	1	6330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXzKzfodiQWPh6eAFqC7Epu6CHbN3jwqZGNfBxULAfFxq8gWK
42588	payment	2133	2133	1874	1	1	5834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszWAGK4tD4n91SsRxDFC6U5rDBezitPm59kusNArNh5f6sxez
42609	payment	1397	1397	1678	1	1	16024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7EQGS79uTs1xAVEpEPNAbFtkvDEsuDYCNT8bcwDfESXnwuUri
42610	payment	1397	1397	1678	1	1	16025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SkWwmmWuxQcqFiCmWM5C4wfpmpWL7PqWgt8dG1AkJLQGTBo6
42611	payment	1397	1397	1678	1	1	16026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbmc6D8TgGfL3Gy53VADJYAgMvnmFAyAsb3UhTzc8DBgRRcwjN
42612	payment	2133	2133	1874	1	1	5841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRf5wSKYZrAFUjQPDXsWqh77fn7Ld8JWFA9hCQLQrAP3gvUhCp
42613	payment	2132	2132	1874	1	1	1670	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYem2WocAr5L7Do3tQ1EdjtqBNTZD6JpppWnBpChw6CyQorEBmd
42614	payment	2133	2133	1874	1	1	5842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCaDQiMDVNfWSDQz5SzRcy4d68bXeFcT3Pt7gUZnFyqj7iX7Jq
42615	payment	2134	2134	1874	1	1	6337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwGycrgvC5Mz6UyVwUCbe6D99QcnwPz9nk6dHcxnQs54PQsLv
42456	payment	1397	1397	1678	1	1	15983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGRM7pfRYycvSJA2ht2SXGmoUMJjcyeusZbyJ7ktsTSyLcduw
42457	payment	2132	2132	1874	1	1	1656	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGemxKawX4fVYMWsNx3JiLtZsCWEh4emnZ1H13unDRvCZk8c2V
42458	payment	2134	2134	1874	1	1	6292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH94fNATLWW9JAQ5jwLnnwvmpg2VGQAgTAkjCVspvsU3gDbdN
42459	payment	2134	2134	1874	1	1	6293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPc59uztoKfWg1sqHZmrtnmNr1Lb8bfLm5tV7RuXPxXJZnTKF
42460	payment	2133	2133	1874	1	1	5795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikbfuFj2X4iSA1fSnzFJifMQQiZdFjdkEy3PyJhSMj5M896nc
42461	payment	2133	2133	1874	1	1	5796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpFyGBnf1JVJkmq7nyVsfpfJe49oAancyetvBkAuCQbRtJm5MH
42472	payment	1397	1397	1678	1	1	15985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXvGzs3WCEAw9TyUL1k1NWkqtnh9SaUa9Mo1uAG3wzMRpq9nv7
42473	payment	1397	1397	1678	1	1	15986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3v5hREUbaU24aarCL68FezTeD8eCjiq6njSFG76mHTpAPCC8Z
42474	payment	1397	1397	1678	1	1	15987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBzMuW81tekdRm96NLXNYbGTk8aA7uvmBVK42DvyYMuPUyJ3v
42475	payment	1397	1397	1678	1	1	15988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzFcM6omVQro25XujWY5tF4xzre7kn2J7qmy9xrMr47smu2T19
42476	payment	1397	1397	1678	1	1	15989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmtFKBtYFxzbimqpobhUV7dvMgVBHi2aDW5piDyvc46yaYraY7
42477	payment	2132	2132	1874	1	1	1658	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUgvwqCNK57pzuZbL3vqJRABdzP37Zjnxs8z5GdczPoSa8yeX6
42478	payment	1726	1726	2357	1	1	8312	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYvk4kVkymw6SguAHZNRfc6YqHdSxi6Q9HMgoTELwapnGS7mAEJ
42479	payment	2132	2132	1874	1	1	1659	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SqtWpZSXRgV6p2ERpHtU1rcnKn5Ydm3wWY12cmY3csH59Eyg
42480	payment	2134	2134	1874	1	1	6298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2QT7yZHyKCsrHzHMVeHXCDQgSWXvqkBe6SKY2yKfMHiCw7pA
42481	payment	2134	2134	1874	1	1	6299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT777EPLDojBYfbrerVv4Aa7YdWfE3QMRgJpHp781aNG9NV1rG
42482	payment	2134	2134	1874	1	1	6300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtxnxdrXVpRgn7TkhhnCFuTpCZ1W24Y694KApyFtMMMozhgJU
42483	payment	2134	2134	1874	1	1	6301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq1LJQgVnRoQ446pfZ9sSTcvQvmDHz8QbmntuJsXoZpcj7Shg
42484	payment	1726	1726	2358	1	1	8313	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZZphB1H6tfSmVUroYqrxTn3Qk6dMe7ZWNhrLxqXxdirGR8Fpxp
42485	payment	1726	1726	2359	1	1	8314	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZT8WMX2MXiR2Dsn7PHAu1eNw4JYwZLmEzcRRyoWFERH5BNJ9cU
42486	payment	1726	1726	2360	1	1	8315	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiLNL7m69BngXuW2a2WHHHYWfeW7jtdeccZT7ArRqjKmpY7HMY
42487	payment	1726	1726	2361	1	1	8316	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdtGvQqaLSggwsUcKUnurr7wjv9RnN89mAwkfxWnuyCD9qJiTE
42488	payment	2134	2134	1874	1	1	6302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnJK1YRC1kinxAm1V26hYZVdjb9f8ci8cUJL4VqbxWR4HZrui
42489	payment	2133	2133	1874	1	1	5801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8acpZNC7PWhaUuE3UGttpDnWxcojkeefiq7E2HrYRgLQLNpx4
42490	payment	2133	2133	1874	1	1	5802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYah59UjAtZaD86iSXTz3P7i7oyR2AmPeZjVUP5yepUKkmNToE9
42491	payment	2133	2133	1874	1	1	5803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhjRjb6L4o723Yr49Yq7W5BFgztRov4U1fGzmDbhiEFfi1EcP
42492	payment	2133	2133	1874	1	1	5804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2c1B1hRBzLUSYcNXkLwHaZSrLCnBo6haSLCY1kfnyQP3bRW6S
42493	payment	2133	2133	1874	1	1	5805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDv5tku8vT8zDKNPVg82yFSGNcMGCLhPKbdvJDYRtizRoM4FH3
42540	payment	1397	1397	1678	1	1	16003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAGkqRcU5VhCeF2wN7pRZfwFA2m4HbvmWjsY4CimEArYwWjgo
42541	payment	1397	1397	1678	1	1	16004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnuZb8rfsN8KgqVptn4exHWRQeXrJt7kwcnwwoV7ssyPnaRih
42542	payment	2133	2133	1874	1	1	5820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2swfsXGsDARE5kUmDzuydKYg6H4xfgAtw89W8TaiuwLZChEmQ
42543	payment	2133	2133	1874	1	1	5821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AXBhnEmeENg1sgF22wvBDjkBkpxAtP84JWrVtV3SAGNeHsBB
42544	payment	2134	2134	1874	1	1	6316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9P8Qc6R26GtgmtcrTX6zadsk1D9bKk34orvHodGtDALDEycwy
42545	payment	2134	2134	1874	1	1	6317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ZS5TtH5uGchqhPTWa5jXzj3fttWJib9nsxbcCPjtSWcRtE7r
42556	payment	1397	1397	1678	1	1	16008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWLrHGv8E5qRwXSw7VCDJG6CmaUsFs3JmtrkJii3GYn7C62g2
42557	payment	2133	2133	1874	1	1	5825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfv5hcvqdBfQ6dAMVFguH1EeTbzy9JT38vhJ5tDzg4SsLZsfGt
42558	payment	2132	2132	1874	1	1	1665	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmSMB3GNEjvzHoEL2A2cQUHLPmj6ecFf6Eg1hJB2iw9X8DBws
42559	payment	2134	2134	1874	1	1	6321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHhr6QtbSz61CHctWPQwWKSH8YgMSpLZWNwKoTsuYp621t313B
42468	payment	2133	2133	1874	1	1	5800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwZmGMEXmeP5PRBZxDy1xYBnp6kTBLLhk7nNT6YjFL7BqFX9D
42469	payment	2134	2134	1874	1	1	6295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB622qsgXwMvVUU6GrJmwzKhTMx9E3N9wNxc8TjBz1T2xXvURv
42470	payment	2134	2134	1874	1	1	6296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSHJz1vhmE9ntCewEjWtDUo7nSPKZzyRWAP6efxjbKK2Uvh8j
42471	payment	2134	2134	1874	1	1	6297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjoaSXWrS7WumD1DRkMK1Vpv4EFy24VvVUBQqMji8gF1gdy5z
42500	payment	1397	1397	1678	1	1	15992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMhekPdTCpbnuKDnJwGQh6VHBTQXQAvYhCeCd1GBr9U3wSvbq
42501	payment	2134	2134	1874	1	1	6305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYc4BUUqiARscTFXszKqyeype1xPsr876ukBptao9HcCnWArei
42502	payment	2133	2133	1874	1	1	5808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKuCx4kUsCxa3aryDQWN99L3CZPLddMZaGrVUosiDWghB4fJ5Z
42514	payment	1397	1397	1678	1	1	15996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PXdGsTMjNV8Www3E6QVT7B5mzGrT418geWen3Q4uzcz6Wy3G
42515	payment	2134	2134	1874	1	1	6309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ9wXLRJ9yxWt2R7MWrtxRfwxU99bvmLw9FSHBpVT9ihKsV4zL
42516	payment	2132	2132	1874	1	1	1661	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtR7aRvAr5Mxw9u3uqZK9bt9cmnAirBDc27SLUQfsJstP7Hvq
42517	payment	2133	2133	1874	1	1	5812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5M9hqEjWQnQzvszKYMSxSnhq4vS7hGwMCBfxyzdPiHp9Am9rq
42518	payment	1397	1397	1678	1	1	15997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzKP3cygHovnq3DccdvL31pRs7LKzzoagLjcDXRybctNhV1cv
42519	payment	2134	2134	1874	1	1	6310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4guuL1mDrcWb9UP8CiBW7agsJhjiEVNPu1LS9aQMhEWpCaYP4
42520	payment	2133	2133	1874	1	1	5813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxVEfGzDYRsvFRRD2FQ3J9NkZ4mcRZkurdCvRaYjjrcLZiDgr
42553	payment	1397	1397	1678	1	1	16007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcvNfMH7c721oEx2EzcdMGBqrTTpuNnnHgUEs2rSmgewg99TQD
42554	payment	2134	2134	1874	1	1	6320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1i7BD4bZKXLriJuFi95ZKLTAUxqYAQxwvSjEknXSvHojFwdC
42555	payment	2133	2133	1874	1	1	5824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2fLX3iwA38fYjKqtU4Uesa43jixkgK4Zfhrd1GEscmifDksK
42596	payment	1397	1397	1678	1	1	16020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24dnrQUgyh561U1uZXKcFSpVgBJjsscZje96BbWHbCBHLCuVb
42597	payment	2134	2134	1874	1	1	6333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNDfyWFyu2R7gKJfzyXetyzCAFrsVvYC3RgvAUMmXm33QCHaC
42598	payment	2133	2133	1874	1	1	5837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCBSwb1mUdMzeHLoFU44SerSwucxnZyWTajUPrGSpfJsJ8t2r
42602	payment	1397	1397	1678	1	1	16022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1cw5CJ6ybJ6KU76BfX6NNFCsVeBFVnu3vHCicyPhn3QdVTFR
42603	payment	1397	1397	1678	1	1	16023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Ah1ZzPL8aXWE2HJ4f5QvUXtvgotEfVS7hMw4LoFpe1ceg9Kz
42604	payment	2132	2132	1874	1	1	1669	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrMQt5Na3h5jZH1QEu5sX7ey2zmeJwnm1SBUR9yj5XE1acxcd
42605	payment	2134	2134	1874	1	1	6335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg69itqNAyCK7rJwPGs1vymHMJ65mDoC83SmTae1iGbfztJGDA
42606	payment	2133	2133	1874	1	1	5839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD9avvSjvPPTUMocP1KwAkmH7j4CKNpXXTk4QmGpTv1r1ojhuR
42607	payment	2134	2134	1874	1	1	6336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo1SSbe8WVGjLpTwWSSJZV67FLw39bQMmgpkt7LVjyBfhV1Qia
42608	payment	2133	2133	1874	1	1	5840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEDiBQ4FFLWDJ7fuXnvRPfWFycjczE71Cs7gNroN6BVhiQTYkF
42618	payment	1397	1397	1678	1	1	16027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MLi3Qg5Xhnsr6VEMojBrUstRmEZk2ZazyBby51iJQSfjXMCk
42619	payment	1397	1397	1678	1	1	16028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFeFTySfftRGaA9wL9x561kBYUA3Di7iktUytPYK7NmgMxy9Ho
42620	payment	2133	2133	1874	1	1	5843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsnk9s35T7eRutwLPZwsXBRvFPowG69jBGHVCqtCBi86Y2CqSb
42621	payment	2133	2133	1874	1	1	5844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq4xMVNNiASqMMjeuNsa46sfxH1yoHwAByLSMLceKrNFopeyRZ
42622	payment	2132	2132	1874	1	1	1671	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmRuv19tg39dB3JcHLFdddgZYhGohpL8MDH2zQNHZxtiJTAwc
42623	payment	1726	1726	2363	1	1	8317	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhatWxqEYnJiAg9FRAP7Qxg1iX1bVJMMTtA15SYXaPmw5jP8p9
42624	payment	2134	2134	1874	1	1	6340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZQp4WQF6UfJSxsZWq5AgrkMsDHtg14Qq2tbvtYp755rLSu36
42625	payment	2134	2134	1874	1	1	6341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8AAMJYji7Nd1mSQcR3Ho1DbjRMDuG87QK9noqhsainNqrX8bn
42629	payment	1397	1397	1678	1	1	16030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6b6zGEwPkivVcmygkuhie61rs34giQZTbXhiPEPThW8YPyvRv
42630	payment	1397	1397	1678	1	1	16031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsCV4HZ9KTKE9WNmd4TbPwC7sXudN1Uoubq4gokPnMQzsLZyRb
42631	payment	1397	1397	1678	1	1	16032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu6FCmSEQ35JNFsEtka1X37mradVfsgdxjFY5FbcvCq3JAS7oJ
42521	payment	2134	2134	1874	1	1	6311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkXDsWGRvrufgvfnKf1GJm8b4GEHoFQJQj7wpCgRFZpprX92po
42522	payment	2133	2133	1874	1	1	5814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorQK6xx2eF9fH62Q6mdEZ8LfBkMLfx7QQi8UEgJhzLpdLRuS5
42527	payment	1397	1397	1678	1	1	15999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkaazeaffWwWo5gJQGUN4wCG49LYUnUx9VM5Fh6CkDCs1KYqcj
42528	payment	1397	1397	1678	1	1	16000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLUJCMxVXh93e5Uf4CReP8xPeBG7ztR1qL6emaTeUM2bw1AYer
42529	payment	1397	1397	1678	1	1	16001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7SEycf4Ai9VmW52X651MmxdM2hkxuFC46iPwp239GP9bG7SN
42530	payment	2133	2133	1874	1	1	5816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUL3h6VXXg88DtTHt6QAj515Efcuk2n2biMYvKajCsEgc27U4w
42531	payment	2133	2133	1874	1	1	5817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4RRgT4ht61uTSDwA9nZQvzgVQ5vhDVm7dT1PrL4amfDdxdQb
42532	payment	2133	2133	1874	1	1	5818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEFjtbMwKj2gnoPSD1W2H63HKsD45QuErHxxrpUdK6zP8p3es
42533	payment	2134	2134	1874	1	1	6313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXc8jucTmTp3pDo62b1YtiN8QTD5nzVm8wDL4X876FxMh3UP9J
42534	payment	2134	2134	1874	1	1	6314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkjWDU1LmNEKLxEfTCVCcPjoqJmTMj8VRcBZ3LhVkcrhBBABZ
42535	payment	2134	2134	1874	1	1	6315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWfhBT8KuZPkyM3G1mtLqSKqsTQobCCwX7wTKzJ2w5cnpNvCXL
42536	payment	1397	1397	1678	1	1	16002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWVKCWgZfY8A6fF4oAQHQK3YUgFs93RLmnqqvMU31cqozswQbt
42537	payment	1724	1724	2362	1	1	14	1000000000	6000000	\N	E4YRfJDjVKqwGS7P419UqpceVMLr1zRrjbeDz5ZtJPU9gHQ3nDgg6	CkpZFVy98ppDQH145k5wRV5NGQgv6Sx1B9xsGA1yC8ZXwKazzqTxj
42538	payment	2132	2132	1874	1	1	1663	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgWuBkeC1XHBmQSEzTansw3Nv3vMLdQaNHGum3iZZc7wQAxHGm
42539	payment	2133	2133	1874	1	1	5819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHvouapJnCvTwayqwqLYUgUctAM6a7m1x5GQa4UZPAcbwMxs5f
42550	payment	1397	1397	1678	1	1	16006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2c3EFdyfL63iswTgE65Yge5pSAaFuKPkydseVXQnjxefqw7o4
42551	payment	2133	2133	1874	1	1	5823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvgo1P73vARM5x7BPwdKt2MXt22Hba3QMoa4mRR3buB1XJ85Eq
42552	payment	2134	2134	1874	1	1	6319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa77gBBmnvVLyuddvAqY6AJWYabd4BUoaQkho1RGxKmkfMybbL2
42560	payment	1397	1397	1678	1	1	16009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS14dyefiu423BV7WcvKHvseyZbzebZydvvG2aCSEZmi2h4kHv
42561	payment	2133	2133	1874	1	1	5826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYopR6KTf7frzqy4juoengz3jpkKBhZ3adPVBu3EbYfjmQLmd5V
42562	payment	2134	2134	1874	1	1	6322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZztKGNL87iQNaqaG3zLDfH4EDnAps2apgWm4jnrUeMQ7mZ84UT
42583	payment	1397	1397	1678	1	1	16016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8qTVDSYjotzHnccZTQkcqT8FcgEdKgg7JghmMNRN3Epikjqn
42584	payment	2133	2133	1874	1	1	5833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5K2KXnf9y3AVTQmPPrxSG9fjfwJkLXEu4H3Ri4g2J6ffeKkjk
42585	payment	2134	2134	1874	1	1	6329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBD4qWbeYLTPEoJJu4ioCkA6epF938gyvCyQXpUb98SXG412fV
42589	payment	1397	1397	1678	1	1	16018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPxunNogLR8xA6ss9mzJBhQ243DHWr86xmAYwaJhUXMpRbgDPS
42590	payment	2134	2134	1874	1	1	6331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVndZ6q2Ds8DHRRfopceTZtv1DSFYv69uVguDNMYvFcHH8VT3F
42591	payment	2132	2132	1874	1	1	1668	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6P3jd3UQgdKzw5YMXuc5ZtQhBNR2TCpmsmNhEJdT5MQtKSRv
42592	payment	2133	2133	1874	1	1	5835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZyZMtbHYvRHT5FuUqEq68qEUtYy9cDeqaStVZ911M9kGYWVC
42599	payment	1397	1397	1678	1	1	16021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj2gexkRjcwRt2rK5bQo1zsuprk2dTMMtpPxBgmjkEfxKNqKLK
42600	payment	2134	2134	1874	1	1	6334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp6BxBbYkf4KwAzYvWp934Bz7Mv7xJpFcWuUUbeBg4kAgKnZHx
42601	payment	2133	2133	1874	1	1	5838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwW8eu9PJGvvFMoCRKLZsHrG1kCMKJPxZZPhkkqiGwnvHzrUdg
42626	payment	1397	1397	1678	1	1	16029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LFkUC2cEGUcpcrMazk5nPWhV1EUCC3Zy7NXnxP11WZ8ePRDV
42627	payment	2134	2134	1874	1	1	6342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfRV2bHjivLaLQxrFbYEhbwhHZLEaaq1R9gREmMwrsRjt34jzC
42628	payment	2133	2133	1874	1	1	5845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gyvtKRhK1sTcVH9JzxmgEcBRWPtYoKBVVYngLTJfHH6WQdfR
42643	payment	1397	1397	1678	1	1	16034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKBHMFWX5AV1EncTxUSwdSGHawt8jcVdB1NCMSpw2BXnrcHvK
42644	payment	2134	2134	1874	1	1	6347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBDp9vuRK1UCXXUrsCJi2CW9QSQEkRaAxfNr5rdq664Kynn1E
42645	payment	2133	2133	1874	1	1	5850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYseA3ShYruaXCPFLUazBdJLDb1Vg2KzyeqJVJfg2ktUmEUttAy
42653	payment	1397	1397	1678	1	1	16037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMJdeekLpGScMtTkq2uPfdrEpdCZNqHQ5aq39wMSmfdAtWN4d
42566	payment	1397	1397	1678	1	1	16011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCKcM7XxiT8c1yqs2QpVTeCVojdjfMaD1JkFuGRZrQsSzPKVK
42567	payment	1397	1397	1678	1	1	16012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSpqYGajYgsT4HsawtjECchDNqMAmWN4cmxbWgCRz7UoZfvx1
42568	payment	2134	2134	1874	1	1	6324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3q7J95mhnotAgPbEuZnxoXLoeXubEA9VxMVmY8nfRpRhHMJVu
42569	payment	2134	2134	1874	1	1	6325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnbR7e7ePa7PJfwMaC2vXwc6HtCXE99YXhVbSwZpzDmmBMeyMq
42570	payment	2133	2133	1874	1	1	5828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGkFm2zEifmzKpCdxZzEXqMiRyNVh76tzPLpybh76DQE6RH8P
42571	payment	2133	2133	1874	1	1	5829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1CZfKMRv76kPkPgziDMKwJ4yeGJV1VdBFgSxSGByhuivqatb
42572	payment	2132	2132	1874	1	1	1666	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQspaPuWLjogiNCxKYo2tBuYev2zeCFqQ8i5QLXfKsgZCWi65
42576	payment	1397	1397	1678	1	1	16014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNh6WsnCB5CHoBrZHWAcAPTYzpGTkioeTfoqYT1EQmPvMFffeQ
42577	payment	1397	1397	1678	1	1	16015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7a15xdn5RJbTYLtbNWJLqdPDes4YZCksSjFEPwg135tyeSLov
42578	payment	2133	2133	1874	1	1	5831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wq4onT4tnADyXxcb9eFv3ryHW54hvohmGJHhdPheVS5uWdco
42579	payment	2133	2133	1874	1	1	5832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJNAgg9ZaPKb34syydv3Nyb8yDaU3WkVPhDU4hTGvo7Y2Ccxw
42580	payment	2134	2134	1874	1	1	6327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiHGJRPWDmM6ZmgojTF1W4Rdc9JP79DoaZai426NHRtPMc2ZW8
42581	payment	2134	2134	1874	1	1	6328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGLUxd8mESrjz1ZaFsyqRXKTukwmceJCjWiZYygGkPcTDgg2y
42582	payment	2132	2132	1874	1	1	1667	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1bZxmSanqk5rAXL9XuRer4CFCLVCFZs36DGQRdYvXRMEYoYE
42593	payment	1397	1397	1678	1	1	16019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdG8ZgCwjpDYm8yGYSx6nPN9dnaYvGzn4nxcgT6hUjfKgSffN
42594	payment	2134	2134	1874	1	1	6332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BSMyzMuRRbHTe38do1t4mQuoqdKT5ih9qfBBF36fXBgevVTy
42595	payment	2133	2133	1874	1	1	5836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFk34AxFm5TMyFjh1dDUrgcayD18W7Gm34bTMADfuRzEsdjRTH
42646	payment	1397	1397	1678	1	1	16035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9Dz2E4E4ShMb3fGbPv5YiaVqRCxkZhg9i5RGA5zCHHvP8mCSH
42647	payment	2133	2133	1874	1	1	5851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZdzJqE89XP86J7Q4R9XSaiv8b728JmbxnZAxZgYKz6UJN6hY
42648	payment	2132	2132	1874	1	1	1673	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjg3hFRnjdyWJ6mV9VGHwHiQRDNwzZkr3KmnYFhxtsGGtZn2Wx
42649	payment	2134	2134	1874	1	1	6348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHirAuS6zkuqbGvywDqxdsGsm9vbge21q5EzGgnXugNk6wEHai
42650	payment	1397	1397	1678	1	1	16036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKS2xKdBvRYB1dtSgiCuyigMvapaMMUVu4d3RrCreytvw2WFp
42651	payment	2134	2134	1874	1	1	6349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKR51wc3fozu4aWzzHSr8p3JfA2hBxp8YexRzxow7ChUBrQ7S
42652	payment	2133	2133	1874	1	1	5852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMN3pkRDJgyJu3t1uZ5i3eY2buGSgLdFSZR2LX1Lo1JKVzRCvC
42656	payment	1397	1397	1678	1	1	16038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBgREzyvjtkXdCdvWKgFw6JXhQW3qB3cgpjgJLbKc8yi4ajcP
42657	payment	1397	1397	1678	1	1	16039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbAYfEQNCReegv1cPzKamKDnHd8coeF94YxXgqhKf4FjzEWJR
42658	payment	2133	2133	1874	1	1	5854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3CdeZTbK4Wh7phhT9rKDzUmwQpVJcFjTvdsePLjJNH51QoxF
42659	payment	2134	2134	1874	1	1	6351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL2eT1xQ6KnH5qZFCCZqUt7w1fXZgJKPkQccSSMGxweoyXUNLQ
42660	payment	2134	2134	1874	1	1	6352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAMG4FMHrx2Ys5kLeBAJSGV8NwgGnyJr6CqPCCutRqt2C8JEJ
42661	payment	2132	2132	1874	1	1	1674	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeADuXNfcxhHgSPNme7ADUN3KrM67HWELto1cQRMMvPguNRFS
42662	payment	2133	2133	1874	1	1	5855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Wxg47acFSZg5c2PHdUqToDvRJaVyszwS1BC7jkpG1uZtfPs7
42757	payment	1397	1397	1678	1	1	16068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdECg5nzF8A9yiXsmoEBMEjNkrqwVTtLuaaitd5ecuMQfenssp
42758	payment	2134	2134	1874	1	1	6380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVKFEDZC9WP5K68LhGn9Zgg93MVdBzCjg376GyMNAwUJchBiV
42759	payment	2133	2133	1874	1	1	5884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrjXokXoXNouRuoZ4SnEGtUpvdeYXYq6tked2kvRybbJBFrbwQ
42767	payment	1397	1397	1678	1	1	16071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6qrgRuU1s3epkDo2S1eX6F41drviTuL9N3N2RGWabx7zRmBb
42768	payment	1397	1397	1678	1	1	16072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmYdiyEVqjhedoUvbugxKF2DzeXxChee8WNhA425zRGCuPUJS
42769	payment	2133	2133	1874	1	1	5887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTKhceteT3ukzYLLY3GncAZGe9cxbMKz6eg9NRy8NUzPQ5vRn
42770	payment	2132	2132	1874	1	1	1684	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmse67h7ipnV8XRdB7d4ffmGEw8Qfg3RDoRs6u65m35wMe5D8
42616	payment	2134	2134	1874	1	1	6338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSjabjpsQy3GEHemaXU2gWWCww5qHQYJTyGivDbHykRmpzYUM
42617	payment	2134	2134	1874	1	1	6339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEGXGiXrMXwZSUoo1uVpesDAd36mnMvk1ju5HudoQEJF8LPdP
42639	payment	1397	1397	1678	1	1	16033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRtw9kxj6GhRBdqJPfWipqHtSQworCfojV5xaGc8WJr6NVjmu
42640	payment	2134	2134	1874	1	1	6346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTrVPQHAGNxrhPvHdBbk6bwSWCwqfcwDptaqufEivRZgz8Yci
42641	payment	2133	2133	1874	1	1	5849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX56tdcv9AhDNTSphtRDEVcfrAQTz8nr2V99GVz7c8oAqG3PNi
42642	payment	1726	1726	2364	1	1	8318	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZyDVMs4TeAowdi9ERxLPD1sWYsB8URfPJuu9rdHybUyC5hNXre
42663	payment	1397	1397	1678	1	1	16040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAb5fEnWgwqoSXCgVwt53i6UjLgD7QtpbHLJ3hLsmUCj3AKZ4
42664	payment	1397	1397	1678	1	1	16041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Xho94aS4c4w1CbDsSMfsybdpzicAfpyBRxeYT73d8RG7Hifc
42665	payment	2134	2134	1874	1	1	6353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWDYGA9FAB9pSsSXXXf6ZeEkWNjDaVkefrAVtJrc5eKr8De3q
42666	payment	2134	2134	1874	1	1	6354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtMttSPa8f8sUbjf6gXN6p8qHJQQuTNY4Mrx4J2cTFUyZTdVYh
42667	payment	2133	2133	1874	1	1	5856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtXf37vFUfe4m19dzLcQR72HgiNja6E5wibsGQ1BZu2YHLXK4J
42668	payment	2133	2133	1874	1	1	5857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2QmVpYbWNWuDgTdqkqarYg97E57ct9kCVU8WazVVq6vYZbKfj
42690	payment	1397	1397	1678	1	1	16048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTE2CvuvSJQwmGjqnxohJeZS4udB6RpTeFbfbiTf5kqz4Pqo1Q
42691	payment	1397	1397	1678	1	1	16049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmLej97gxTN9Aanh2zqiQsXwfrJUVU5KYHbJMLehQXKj7pQvR
42692	payment	2134	2134	1874	1	1	6361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRGrMMnr2vjX63Sfh2t5w1Ron5b6cV3ZoEdc25N5CTb1qNWreW
42693	payment	2134	2134	1874	1	1	6362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQNVCuZSt78ckKNbsAZK4jbzksRgiyb5RRLKf46ho4rgAypsK
42694	payment	2133	2133	1874	1	1	5864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSWvRFqEA4UUPV5WQNazhvJf4dWMW2o9a3KkdYkE1T1NDVFHt
42695	payment	2133	2133	1874	1	1	5865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqvWGbLpSNPkHbxLsiG647BM4NhZFd1gjC6WZNq4NMkEzV6xS1
42696	payment	2132	2132	1874	1	1	1677	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9GS1yAS4HBGVvF8UVWcC2LhYGZDHPjCPy15RSNeZ9zG64iZ6w
42707	payment	1397	1397	1678	1	1	16053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8EGQKXJREmysKypT9fVAmQgcczQrBuMYgRpfMANTPu7tw2EXM
42708	payment	2133	2133	1874	1	1	5869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHbCXTDMCPu69YmTFUDYVpcb59Ee28EwLHm5U74MQg4FzagTj
42709	payment	2134	2134	1874	1	1	6366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebz2cAJoetecwzt7qX3nbgb4LdKAF2MR9Xsb3FZ2xYdVMbUUQ
42710	payment	1397	1397	1678	1	1	16054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWbvsMXV7DCDzcUc4MiGurtUEv2Y2zKTazJv48yqEWBXdwGWR4
42711	payment	2134	2134	1874	1	1	6367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXkmUWsYcZwA5TLAxim91dx6BHe2YivG7B6CWLeSod5wxiWRLW
42712	payment	2133	2133	1874	1	1	5870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGSUZXbixrYmAZZKU4s7CE6XVxjvrNg77mATMYXzQdrexL3CF
42717	payment	1397	1397	1678	1	1	16056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3BtzD4sUha7RgoNd3Xa9TGQ3EPNrgP8pw7ygtqr8KGUYhqwTN
42718	payment	1397	1397	1678	1	1	16057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa518JEeKqCavWY9rdk5xRUw7zXwbQerJJpcoKmtmcSXjdqbM9u
42719	payment	1397	1397	1678	1	1	16058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQj5U9ft1AvmHFabKD7uNZAeFw2pRcS6TJVEsccLosmVy4KUCc
42720	payment	2133	2133	1874	1	1	5872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2QYVaXHixeNhRTzEVa73TiyTBmDtkrfWxmL3vWERW3mcnDyj
42721	payment	2133	2133	1874	1	1	5873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7du5FvNMJNKJcSeBoKysqSiYX5WgGQqt8eDtouFKTwKouJWKD
42722	payment	2133	2133	1874	1	1	5874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dXoU7wYdaB21vdpTuyfmtB91hs8yCQn9HZWdB1gCQQ1Cgf6R
42723	payment	2134	2134	1874	1	1	6369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2PkRqk2ouWaivtmhbiNVBirfp6zD8A5XKTRt5wJLJ1ZJP3nTe
42724	payment	2134	2134	1874	1	1	6370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRjnQnUwLLgm9sfjFNaeZnwwizhEBKTYv48AfxKKnkPdezd2z
42732	payment	1397	1397	1678	1	1	16061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYksyK5tMc5RNTDUyDkjEasg24638e8o6uSXmrCUZ7SLWyLRka6
42733	payment	1397	1397	1678	1	1	16062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnxKz1nTuVk4C1uB1RBfpbqYxuXFwYYNLoBoAC6VtRFGqNBfJ
42734	payment	2134	2134	1874	1	1	6373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyJ6ma4UK8fJwDUCTbVrTpaF7VcibJ5y9p8piomrnPGkCLKUM
42735	payment	2132	2132	1874	1	1	1681	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ62ffwxydbY3KP6pLkPMPr9v3VTqjJTtQk6JcAPcAQ7by1GBvB
42736	payment	2133	2133	1874	1	1	5877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZti3zT6LBP13UeJ2CFnVFSWmLRLvDccoddjFFce6sAhHrXeFwq
42632	payment	2133	2133	1874	1	1	5846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7SKMHy1wQNtHpmxvyQobjNUk2n3mN8efRWDQFLq729dxrgNk
42633	payment	2134	2134	1874	1	1	6343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsey4wW1CskRkAPAo1PrTUT3KaCduE7awyvsFmZWK62y6bgVu6
42634	payment	2134	2134	1874	1	1	6344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPVmKmr14Fh5QpR2YewgewVNGtfQNSc1hBkqugAmg9rAJ2x9a
42635	payment	2134	2134	1874	1	1	6345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHNK11RoTtoaye1zFzZvJny32AukCEN3hYtm3GGLQuzqvmDMw
42636	payment	2133	2133	1874	1	1	5847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw8giiXWaBhz2qpkaQTN3eUEzaf5HYySnEUNfTFnwuaMgN9y3H
42637	payment	2133	2133	1874	1	1	5848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2PMwiLDpxRBpDpdojh88gxvcZ4zw2MTZUh1TNqGBeqg6Nsd9Y
42638	payment	2132	2132	1874	1	1	1672	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzb4YQ7xjmYJ3i7MAhh7EPGshwaKB63WsWEjGW3igWLfX5TDev
42669	payment	1397	1397	1678	1	1	16042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFWA9HEDS9g99YmeaVZ8arCdED6G9XAdmmRhaGR8UzG3qeqD1
42670	payment	1397	1397	1678	1	1	16043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSy4g3Dhqq79ZrxHaSLYkdt25xvdSPvgscSxfQi5BycsnM2Hh
42671	payment	1397	1397	1678	1	1	16044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnRo7kzmYNGKgZ7qRUPpAKUbuuXTfw7FNAPEJrDDa9oeageP2L
42672	delegation	2283	2283	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrRUnhZbCho8cB6czBbhnVw5hWFuJe9H7adD91CqMPSVoeXhB
42673	payment	2133	2133	1874	1	1	5858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqHoKLZR4f1vuAmRGKuPEajmxdMgrTA6XPV24wtdD7t159C3V
42674	payment	2133	2133	1874	1	1	5859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpAcdAsVHBMNMZsAqTZJzX7CracNaGX6gvtooZ29EeRXqaVtL
42675	payment	2134	2134	1874	1	1	6355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQt4mLn4GUyWM8wWMR9vw8BdRs7Hz5JsEm3GmMSkMf3YRhHYb
42676	payment	2134	2134	1874	1	1	6356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkQRtRa6CVmyXpyGmVCYujNviXztdB4hPb56e2LRwa3XBhTRYQ
42677	payment	2134	2134	1874	1	1	6357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xbLXbZTcgSkKnYnXuHEYfGLUXfq6Vy9RMt8DbL7KFtc3PA69
42678	payment	2133	2133	1874	1	1	5860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JdK19jnqYrFudRSsnWzfHJtwdS2fLtBqAVBPujbBDRz6Uqef
42679	payment	2132	2132	1874	1	1	1675	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLZNdk7AEbehfQCRuLijZTVUfyJNAwc66EkPYMYwcGQn7uUVpw
42687	payment	1397	1397	1678	1	1	16047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZav1iVu2UG2ZK2UxiGMN2NAh1Npv2KiKrthazX5yq8CMeVcYz2
42688	payment	2134	2134	1874	1	1	6360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVERdbGoaQqDq9pUzzycjxZbizxKEzBsZxarKLwoLZAz8iftM
42689	payment	2133	2133	1874	1	1	5863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLHxTqEX4gTqwBezQXzyJfWUdi4NnwqD1ekPy9q51B48HHje3
42697	payment	1397	1397	1678	1	1	16050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXDYT2M47v8UhZQJnJU845w9tic4BjgSiXzTe5b8suUTtobMe
42698	payment	1397	1397	1678	1	1	16051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZc2x1r8u9iagEKWAE9mVMqq3BvwNwfDg7gcCDJ6L7PfRHvD4
42699	payment	2134	2134	1874	1	1	6363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYKrm5ePuz5ugLEBr9eKtyRdGp28isGMPhFQYHw8iRi4c5kL1L
42700	payment	2133	2133	1874	1	1	5866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaBoucDhNefVg47XUkMUK7Ch9BCPKVBZkno11SzNCgyXwFk7N
42701	payment	2134	2134	1874	1	1	6364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9Sygivk5o2LbPWq7REPUguPyhR3EKfzjnmtV1LQHHuGML3Wf
42702	payment	2133	2133	1874	1	1	5867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBLdoQ15NrddBQgaBkxZVifd2kAwM4uHdiRJVrXw4jn98hYWG
42703	payment	1397	1397	1678	1	1	16052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6JtFEpQiNmuERnpi7hbZADSXPqMksobrR1pa91m7Ej6Ghcmf
42704	payment	2133	2133	1874	1	1	5868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5hsVi9EBkKdtpoJViKrvoFY8fkemmfvySEQpxwu9KBytr4MQ1
42705	payment	2132	2132	1874	1	1	1678	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcic76J2dKKzMnxUkJUrpu6VdbpjKsdEWWVV1WnDx8BtFBqYiP
42706	payment	2134	2134	1874	1	1	6365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJhASaAcZtSaxrPhPzydNGS7ZedvT7W7wysvC47YEMQ8YJLQ9
42713	payment	1397	1397	1678	1	1	16055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRrXWqcsdk32p8Mva6uz1VbQPSJQUPytNFnfBVbPVLzQVmucAS
42714	payment	2132	2132	1874	1	1	1679	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxc5p9hkczy285aYhWsGRPAQYzyhkx46EscFEjbVMjpU1nPkry
42715	payment	2133	2133	1874	1	1	5871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8UH2dAzCTBB2TNcxRawB5vVNchqdrFyG9sYZF48NzPmG7Z4Wm
42716	payment	2134	2134	1874	1	1	6368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQas2PuqYtNeriweK9GFDQHVwLFwVHjNAaz7jQUrNQWQy1gHB
42725	payment	1397	1397	1678	1	1	16059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDP8So7KdXJkDyjEkZyPCtKguPumxAN69xfbZyvzZKDYn5pJg
42726	payment	2134	2134	1874	1	1	6371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJ9wvtF45CZ2Vk21hXNqJe4mnCB9F2N1PnDEW9uBvbnEMGZD4
42727	payment	2133	2133	1874	1	1	5875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvumH8aE7XqJkz2ZPsrRiW5Q4odsLq3WsATkQSpveMWHS8WYdp
42654	payment	2133	2133	1874	1	1	5853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUdEUeUNGv6iYVin5HMEzERXnc1QfvaeKWdEfPh84yo3yhndBb
42655	payment	2134	2134	1874	1	1	6350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4BMYHbbiK8iURi9bCFvHLWXbxCNwu93pbRBVgHnUhyqvQCa9x
42680	payment	1397	1397	1678	1	1	16045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWQwrtGve1LVUvEwtRx3466b1xbzQhuBjxuCefLrsd4ms175k
42681	payment	1397	1397	1678	1	1	16046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrTd3ErzRkprsRf7PJXxX1PYdSbzem1AfxeytzyMETAyin6W1b
42682	payment	2133	2133	1874	1	1	5861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZ8at8f8Co5TT3QaVsnzdy5hboEYyw8QDLZ8DjsdVHJ7rChjB
42683	payment	2132	2132	1874	1	1	1676	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYox733TiDszZF9ueQGf5Q6nF8AgjDNnGWCPoZ9JHSmCyzhYtbW
42684	payment	2134	2134	1874	1	1	6358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5xsWRgDisCnhQKVVC1arSLhNtKeL1QkYXbBsf2nczFq1CUXK
42685	payment	2134	2134	1874	1	1	6359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyPuTyaor3dVWvs5P65AFBJ7GCdV1HuUFDX4VLQ69SWpAhofJ
42686	payment	2133	2133	1874	1	1	5862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYbdUGe9wk6pVtWHXfN7inKHbAYTsULAji7TCvQpCv1FRFhig5
42729	payment	1397	1397	1678	1	1	16060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGADgAqRbkYEWzN5vr1WTDKpDPjwDkXnvV6Nqdx6QNC8qgix5w
42730	payment	2134	2134	1874	1	1	6372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7WTPyrsKSaV6GfrR5t7VYMWWZNaV1B7XY5Qfq4zTWkNJu8Vq
42731	payment	2133	2133	1874	1	1	5876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gxRQhf2Hg7wt4LjqaYCJRFetgrbHxcE1oi77DNu2cCgTupEP
42739	payment	1397	1397	1678	1	1	16063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6d8XEkJ93ULt4EZrH2qbArRipTBHeBa3RChbi4mHDXkSK9DxD
42740	payment	2134	2134	1874	1	1	6375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqeJXYnKyzSCfjDxUwvuhJeVJmphFfwAhPfYp1vHKT1maKadF
42741	payment	2133	2133	1874	1	1	5879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrBr5sSL3XiLPoJMYH8rF2kA4uzXMWAZGDJ2ncCWTcL79VL7xn
42747	payment	1397	1397	1678	1	1	16065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzq8SWmnMem4Uddn2mjHLY2w1mMjbkmVy1Hs3AE852Mwpuojko
42748	payment	2133	2133	1874	1	1	5881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiyyXjpHQkBipaFvSbeZKPeDYLYMqSwbJG8rCjbRh51nfJDFoz
42749	payment	2132	2132	1874	1	1	1682	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6HaQvSDZpWG6C9smctCeXrjiE3zyy7Kg5dVr4pSLQatKyYfr
42750	payment	2134	2134	1874	1	1	6377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoouYyFzearcNpKorMUFT91qAiREfC7kpwj26SPzmsDHc3VPLc
42784	payment	1397	1397	1678	1	1	16076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJfrML4Wy32Qr51jRMAdMW7m7WM19AiY93AVXGFg3DAAvhwcB
42785	payment	1397	1397	1678	1	1	16077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgt3uixY7fYfjpgbowDwBVaZGC43rxnUpY5yq8oCBioCteG1Ya
42786	payment	2134	2134	1874	1	1	6388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjJjKTEH2qQTZB9yP1wgXp2rvv5J4itNThTfqSTXmuwNTTUAz
42787	payment	2133	2133	1874	1	1	5892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6xcS7yK32tUHqdWnrzp7gWCb9D2Lxi4tkKHzUtQdTbp2veMKQ
42788	payment	2133	2133	1874	1	1	5893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJn3SayQADh1cjNBcVUrC8hGbAfY5irAjJtyZxAqwHQGvyayyS
42789	payment	2134	2134	1874	1	1	6389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnLVE2NCxsMgLLm1MxrUChaxLmWRpU8ayiqYYunf9w5VKw6kG
42790	payment	1397	1397	1678	1	1	16078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL99HnPDEBmMNT5f5SJKbDjavLbrFA8pqgBuxPQDDeZPNCbBaN
42791	payment	2134	2134	1874	1	1	6390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTMqna9V8Zxv5ZWERZwJczt3gD6BdyNEMbTs5vy7RshGRvWvN
42792	payment	2133	2133	1874	1	1	5894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6JU85pTModXoiCUbb6ndzuJTbe2PnKSTc3L1vzCtGTDjX4bk
42839	payment	1397	1397	1678	1	1	16093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvytRKzaGQbrPPnbN94sDKKnG776KDjqcVHWfrXWVdKJeRPBeX
42840	payment	1397	1397	1678	1	1	16094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPwz2oHZi5WbAmptC8bS4aHwgcQQznhkumbPDXhzoow9ZfmVye
42841	payment	2133	2133	1874	1	1	5909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTzUU7w4REAMkqmaZfgwhB1mHDnUErCor4uQ5iQzNFeHGCmtYC
42842	payment	2133	2133	1874	1	1	5910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3LU9szKMWhHkr9Lgj65LLLw5SNUzew2M53AzTgpqGsuYshKg
42843	payment	2134	2134	1874	1	1	6404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PruvjjRc91nCcP9PUWd4GyVjDUaaBRfwpy6bDnTB3hQtZKNd
42844	payment	2134	2134	1874	1	1	6405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4miSt9kyCoHj2bbuUPdEwix9jrc9ZDrkHhKGxaQkNfcFQN3iB
42849	payment	1397	1397	1678	1	1	16096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjhL4nnxXbXQA2C1UnH1BVFyhgJUgFvpsA1vXHUotMf7E2AKWZ
42850	payment	2134	2134	1874	1	1	6407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYavurh7aiqHiNebzB1fqt1QrZbwNDjRpxVAwfFYwnngT5Eog
42851	payment	2133	2133	1874	1	1	5912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9HrUTuSncAkvQE2yJQHg7NFeNeiHCzu975r2CcHpm7bHvkvx
42852	payment	1397	1397	1678	1	1	16097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFj9B87UfJSNv1zUzqey3EKe3e5TWK28AP1dhqM7ehpohP4hxv
42728	payment	2132	2132	1874	1	1	1680	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAotnBhYyLBzrZPYpnvVmT7Vd9eyHeszYodmpeUofU8sUcWpGU
42751	payment	1397	1397	1678	1	1	16066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgX1iQxg5GymNdSvZSK9rMxiuqyZ6ekpHQtvr1NVpjRmtqLher
42752	payment	1397	1397	1678	1	1	16067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4gB5V4kxX1LaCunggQbeuy1eikTqYd2TtZbZ43xkee1QDaEq
42753	payment	2134	2134	1874	1	1	6378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ988AQhu9SAtGi8nF8GVsLQ8j89QAQBxM2Q1i9AfXfdfwhamNo
42754	payment	2133	2133	1874	1	1	5882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJT9KkkLkgq7KUXVyEhs5f6SqF5ZFndW2XDFF1RHZ8K95C6Aw
42755	payment	2133	2133	1874	1	1	5883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHjWpqkDb3X2kQsyEQ1FVPfzjHRSnniiLjavsDQGA7Cv8yCmF
42756	payment	2134	2134	1874	1	1	6379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEEKLq8TUXTQjdx23syKoe1C16zEobVeQ32jNceCW56QFcQQW
42760	payment	1397	1397	1678	1	1	16069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoi5WfQpAkH8euuGeUCD2BppTNDZ4TXZTXbmNndtd6RUciRV4Q
42761	payment	2133	2133	1874	1	1	5885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BoVgVEKrcBkjbgvwKk6WVBhLPKoHhs2LKKmqfTKZCZ8a1mKo
42762	payment	2134	2134	1874	1	1	6381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9HXYkwWodmSxBDEYhsSaZkBdg8JJMqCzCb99dKwRNzta5AkCr
42763	payment	2132	2132	1874	1	1	1683	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWKacPJUv4ztmBm9gfFRg518eMNA3RfmNLeVJgNTCYPfmCVZ8
42877	payment	1397	1397	1678	1	1	16104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRXavH7ZtJKWZdsfEke8KCZjn9Y473NUKsUjpo87FjMkTvgkz
42878	payment	1397	1397	1678	1	1	16105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSYBxT8Ugbm67FPE6eidU2xTyuiiqTQwUi8mkXvvjpjuLMYyL
42879	payment	1397	1397	1678	1	1	16106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtngposThNtx3L8HajHMCMXXoWb61XVbXwWMixM9anCyFBL3t6
42880	payment	2132	2132	1874	1	1	1694	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSQ2pk21VygQnRTacKHWKbrxJXKovZ59Fdafck78ZPfRqAeEvJ
42881	payment	2133	2133	1874	1	1	5920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ywM8NpUACE5Gf2BYDDpjZjHwoGKUvT7BokuxmZDa1NxKWqoc
42882	payment	2133	2133	1874	1	1	5921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB9gq5kFo7M22LyRXa4fmX1GCNBZkHWKDaqHvDHPLrEeFStsh5
42883	payment	2133	2133	1874	1	1	5922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFwSmg8g9m4usu858LVLLiLyKESUHsE2QoeV7yShYtCpXg3pb
42884	payment	2134	2134	1874	1	1	6415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkoT86JSwjvL1eELBkfQ1RD3fFwVvEb2Vzs3mDZKPDCZM1e6FJ
42885	payment	2134	2134	1874	1	1	6416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEy6FKgCG4tGqTsCpLN8tdrYwBtvRLJJ3pKk5rb4c3em36Kde4
42886	payment	2134	2134	1874	1	1	6417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxt5wNdZkKp59pHVMdvkqAPaDiKVxRyNoWZpiQkpzXnnypwnpR
42892	payment	1397	1397	1678	1	1	16109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcME5CKTNAemHJGq8uo3QkcQMMo9L7gAvWUg3A9E1q7798oTp9
42893	payment	2132	2132	1874	1	1	1695	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqP7oBX1tjZC6sxdQafLxDSfrE3mrMhsPp8myoTpcoWnT4nBRs
42894	payment	2134	2134	1874	1	1	6419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzir1pQP4W1MNuQ9cXgexNB6DSfDxuZEDYbVjpb3untiUK4ue
42895	payment	2133	2133	1874	1	1	5925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7nCtB5qZkoYCmAZEGUTzgaW78zUCWhb68asBZyxBTCzWymEAP
42920	payment	1397	1397	1678	1	1	16117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMK4ZdtpDKoifmMCLpCccLwRdFEsDoaMgJV4vzUh9LkSc9kfN
42921	payment	2134	2134	1874	1	1	6427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UxofCrVP6SkF65622XYFvHQizb4XpxDPeTNpreo3kZ39T2xi
42922	payment	2133	2133	1874	1	1	5933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyZ4HxPJXi63AkjMZS9MR12E9of2fiGkQq5npEKrx4ouT1Vsj
42946	payment	1397	1397	1678	1	1	16125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy9uXQWEBkxeRtjjM1gGLeX1o4xsKZi5gnwYbqwrx6LNZyzY9W
42947	payment	2134	2134	1874	1	1	6435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5i51gfVAfzr9kma83YCC2WWtujzx5abJdU7oyPaaUgQxYRpDr
42948	payment	2132	2132	1874	1	1	1700	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbX1H4DjXhqxNzgb5Dz5d8LCbY39WXvRHaz6D4gB73nsed2yJ1
42949	payment	2133	2133	1874	1	1	5941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFc5bqVTPUPctkqZKvU6rdbRDyPmRFAmeMoLZSWHLQaCQiEAzQ
42950	delegation	134	134	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8jgtcELbcAevDoDaFE4fhHK8c5P52uAdroA91mmdS4aDoXVQ
42951	payment	2134	2134	1874	1	1	6436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX8bGt2C9mqC4yd8XcwZAr9Ptn9t7PJLRG7V2iHXgGhDxEmm1o
42952	payment	2133	2133	1874	1	1	5942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmVtTGJzSbVu4M5Mx4z2CwhAPvn2i7bbep14c2ijD69FuCcBLB
42954	payment	1397	1397	1678	1	1	16127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsWqbCTqT1Dj4SvKhFKTNrxLZWN929QsfhD2wAAorQw8QmvUVb
42955	payment	2134	2134	1874	1	1	6437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2hcnCdLShZEhwRF85sRQiBqienaRkmiPtyY8JWZ2wficuAJB
42956	payment	2133	2133	1874	1	1	5943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoEyj9menZMAGbD5dexFAW8dnBKKY5q4B3sPgyVKrPUVhCvn7
42737	payment	2133	2133	1874	1	1	5878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSjwvRXbM2pmJEFS9SGxhfoijYPrDCdqoQ7t2Bs33fDuMtJv8X
42738	payment	2134	2134	1874	1	1	6374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5WTvVe51ars4cFeWg6eTgd9LrfBLgAgeFb7EjPnpKsyppNuz
42742	payment	1397	1397	1678	1	1	16064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXx36vyPk88UW9DaV1sLV1vXA21PxHuKgPzy8t757dRVgPnMy
42743	payment	1726	1726	2365	1	1	8319	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYi3pmUcNBX5VytuJkLhV4GmZvm5fXjAx45u3GbDKRwVQonrJFa
42744	payment	2133	2133	1874	1	1	5880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36aRcj6pBUdGKMuqLW4d7mRu9zyKg53op3D5z9YsKgn3DnPDV
42745	payment	1726	1726	2366	1	1	8320	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKXj7ejcp2gHvaHSAXYMGEiHb1TPoJxZepu3PazwDwFPLuk8kg
42746	payment	2134	2134	1874	1	1	6376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9xmLTuQwWorjCp1pJcKgyUXEDZwT798iNEx22MrcHw6do1ww
42764	payment	1397	1397	1678	1	1	16070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGg2qH82Kzu2Zc5snZ7YdhJGZyxjJz2Mqczgctxxz4QG7Z3bNb
42765	payment	2134	2134	1874	1	1	6382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxUrLU43opoNMBZ8EaT6hYnt7LAkREKvRi62xcKxwJWSfjFSD
42766	payment	2133	2133	1874	1	1	5886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsM6pxKpJxAURvrHyxdYZCpswRPLvR6ENoMuJKmZuR1jm54cd
42797	payment	1397	1397	1678	1	1	16080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJapD8kXc7HK9MjLTgooLr75xS3wiWBqdCYvmEuxERQUYCXox
42798	payment	1397	1397	1678	1	1	16081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhBaZiFC9v9JJ8S2PzD72VMYrznJjE93YFzao3Kqo478rUoKN4
42799	payment	1397	1397	1678	1	1	16082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSDViNtNdG95cXCmjrC4PwZb7x7m1YpdKEHMGA8FVVfboj4ga
42800	payment	2134	2134	1874	1	1	6392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWFyWxZZ3vaaJAZ99T6HJ55AXswoQaoXZDyFt7CKcUfab4Ass
42801	payment	2133	2133	1874	1	1	5896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVFjcikruMoc83Z7qduGpqgRbfCM7PDzFEuBpUn5P8x16NF7zB
42802	payment	2133	2133	1874	1	1	5897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6KXLgrfY6Rigpdzs1wAKq9ESivx7ZBWqNKeu1ArUDDBX8qhe
42803	payment	2133	2133	1874	1	1	5898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmzjSZc5dBDR1vk8uwZJL6BwqjuX7fUh19UCnGUiGJjsYfzYB3
42804	payment	2134	2134	1874	1	1	6393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyY82kpSh2shjCkuSP6K4iZmcAfukMg2QGNPCsoyZ9MPjqm6r8
42805	payment	2134	2134	1874	1	1	6394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmviRdSvuTmLpfyCj3D5Do11JBqmYNMyBAgddKbpNop1QVh7L
42806	payment	2132	2132	1874	1	1	1687	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAp7jr1peRBwJTfQtDTe76Q8AMgiuH3gQAr9ce5M9zvh66kHyJ
42813	payment	1397	1397	1678	1	1	16085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBynHJRYm36xwRphjzYojBnu9Ayht42eXLi6oP9RAjkmYD44E
42814	payment	1397	1397	1678	1	1	16086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyArk3X8Ha7QoWk4qvXtMHcfnN6Y8u4LF77DpjuK7xkkPvCQA
42815	payment	2132	2132	1874	1	1	1688	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAxc43BA4XXBvdnZtrG5Sdo3MsQoBgiRny2ntTr2uYSvYJWPL
42816	payment	2133	2133	1874	1	1	5901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8iD3nPZ1jK2WvFLwxYU5HUuXBZKGymi648J2nYLrexDSyvJU
42817	payment	2133	2133	1874	1	1	5902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DRnoJYN4PBzEGorppKFgQfSz6vo8X6Mfzdh9sZZJyWrvoSmB
42818	payment	2134	2134	1874	1	1	6397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Qj8DdzjRwxxNNnMAeEtr2cqQ5orDj9QWtMqkxfiiQfRLpc4S
42845	payment	1397	1397	1678	1	1	16095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZCvomJX6thwiqGJyEyzS9ksMHLz9hAnSHXHX52Ghx82K8aRT
42846	payment	2134	2134	1874	1	1	6406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiuzemZ8QCkM8K4jL4zxsCVErSmVMVZGpHrw8S2Jxv43ktfaQ
42847	payment	2132	2132	1874	1	1	1691	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLweC31jyua1KQLt9PZQgm6XroZkwp7yGXUPts2bGScwWtp67
42848	payment	2133	2133	1874	1	1	5911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwTGcbv8rHJt5hLEBLbopMdwk36frWoSjURjiy2XwUuLT1kEBj
42874	payment	1397	1397	1678	1	1	16103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJkv9Jay2vq7u2TcybrcJRDkZCZnaD4NLXWChmQPEyy4cs4qNE
42875	payment	2133	2133	1874	1	1	5919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYH8Vhh29k9ffkanPWszywbb4z7mfbSXjkzpzMLWxdatR6eFBQ
42876	payment	2134	2134	1874	1	1	6414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Bq8HCdabKyeNAHEjw9AWRbqqxS2UYhftfguQP8NbMyK3LoD8
42910	payment	1397	1397	1678	1	1	16114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUuxkdjWnNjhydBK1aSKA18DPq2egTRf6eoQduM1skf6t1KKny
42911	payment	1397	1397	1678	1	1	16115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyhnYiQn33iqrzvruAgf4VTwAycoF2t42MiibuLBf1toKYuYa
42912	payment	1397	1397	1678	1	1	16116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YGGYYVtezbLzjKTT2bdJ1eVkHhFG6nADToWrapGJWFr9waU2
42913	payment	2132	2132	1874	1	1	1697	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbr2Tb2rgpn1PRSVsKho5NrqpEaUU3JEbm6yHSUxAtZAPekDh
42914	payment	2133	2133	1874	1	1	5930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PjaMULvHtJeYLiRcDXCqARLRgAFAEyuNNtEVViQFUR1svXwJ
42771	payment	2134	2134	1874	1	1	6383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPhZ5utxp374f83sWLhKj9ChcX1k4XfTNyzHP4SXtZtwmjN9Lb
42772	payment	2134	2134	1874	1	1	6384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt2TzYVLwmuSomhyPVDQdSgKdcGKQ1Hh9EuuQnSdaBFB1nxk3E
42773	payment	2133	2133	1874	1	1	5888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbZb3uANyyDKTCtwCXXPxy9X3cDmjWMazmNhnK3mia5BpdWPRv
42774	payment	1397	1397	1678	1	1	16073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv82P5jV56Yq848UCVUR9EP9zV8ZQMUi9SW75aoyVtDfR8jW8X
42775	payment	2133	2133	1874	1	1	5889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdgpTqcbEt6jAyGZwE9dcbV7fgJCdzq9wjQrqJmYohLEY2scV1
42776	payment	2134	2134	1874	1	1	6385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqwAZ2gCb9aMUqHSMb6DvmQ26mYqPXPLsAo6XDuvwH12L9WAA
42777	payment	1397	1397	1678	1	1	16074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fWSHCFArUy5QRNbGJtPUFn6nFbPSL4PVryv7ko5j8wrSzFoW
42778	payment	2133	2133	1874	1	1	5890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z4LUxfGzWABZMBYNzmmgBEBjHb3SGJDFgjH6RFs6m1s26tkg
42779	payment	2134	2134	1874	1	1	6386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmbQCcQZNtvgbPT5PJF4BmBjE8VTGvVyNEtqxomJwYPkfxujL
42780	payment	1397	1397	1678	1	1	16075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQUxXbp6WxUV77XiEeHB4Yw3iqzVbhxstVFsjyAXPaEyxXqZp
42781	payment	2132	2132	1874	1	1	1685	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabGZrKyogwNpCvY6dvmMdNzJgc9TqriCFsUKuZGd6fTvU5Bzq
42782	payment	2133	2133	1874	1	1	5891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaZTnL9hP933NyZRNoQGhDt6bt4FTXYrivCvNpNWmQ3RoQf7z
42783	payment	2134	2134	1874	1	1	6387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtQGEbb4ALX88mQjDztx6vazCxK4Kn9TWXZKWBu2FniGEi9iaV
42793	payment	1397	1397	1678	1	1	16079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzueLzV8Mv4c8LoiCbFupvSCRaddLpbYBMhZqQvhUcTHRYsVSG
42794	payment	2133	2133	1874	1	1	5895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsnTMXqJUMhFgeZMw6xdfxScnV5KRoaXjwNuu81ygkkEx5zQ7
42795	payment	2134	2134	1874	1	1	6391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNT9XcjirQCdWoP8DgUPiU5dVaaHk6X6r6WRBFAxNkM2noAZzH
42796	payment	2132	2132	1874	1	1	1686	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXhYZXZ787dcG59SgFE6DAur1HMsqjemzMP64kakNjznv6b7n
42807	payment	1397	1397	1678	1	1	16083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmpwFgVYx4N7FX9Bj5KTRPnQ6VVsfg5rKRhnzLS6Ad2FUtvHZ
42808	payment	1397	1397	1678	1	1	16084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr21oLBMPyo6qLQ18AgVjQuBtsrcWr8PqVhmCCrarMsW7VP82z
42809	payment	2134	2134	1874	1	1	6395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmQJYtTecUpdXNa2fChKgZGvTUPJ6CUhCSnN5k3YJQSDR38ntg
42810	payment	2133	2133	1874	1	1	5899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhhV7ZNgJdWrsEJDZ32gWWjT2BxmGjg4sVHB7Dyh7zW421AFa
42811	payment	2133	2133	1874	1	1	5900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGehMDb9t9VUUHfWVnrZhS7toDxt7hwxTCZvn4SNHradqAo4W
42812	payment	2134	2134	1874	1	1	6396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWP1fgXEcJqa2wssKtxrECZM8u3GL17jfbZLTD57CFCfa5t22Q
42819	payment	1397	1397	1678	1	1	16087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA4JE3njrxt9AxnvmNELqgrDANm7jNPjB5SMRH8Lmox1BxKbUK
42820	payment	1397	1397	1678	1	1	16088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p5kM1vNnsULrUz7RyTgqeyRuXejTFK8QZZNf1A4mgAVs4Y6d
42821	payment	1397	1397	1678	1	1	16089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSpvuAmUB2paobdEz35NS1pdfLU8dwWorwiSsNV1HHmQ7h4MYU
42822	payment	1397	1397	1678	1	1	16090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsp3CU2b2mLXTSBSPbpAkWDik53t7ejYrdUzX8nq1QG2cTAgj
42823	payment	1397	1397	1678	1	1	16091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18FAnhU5yoiwEz71wxwf3CQRSVYJnYQ7fvMNDXGxUt5fp33FT
42824	payment	1397	1397	1678	1	1	16092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmQGi3B8gYCZP1wkcBtnrTLZuJxtL1HSYqz4jKhAJe4n61Qbc
42825	payment	2133	2133	1874	1	1	5903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwunJdFdPmRbJXZ8ZVt9oAakLMzwVtfimcK8HQA6DzSL3rScH9
42826	payment	2132	2132	1874	1	1	1689	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9fkFtYd87tkQvWgt3NT6zJm4s9ouKLw82HmLDvVgWdEHMvEGE
42827	payment	2132	2132	1874	1	1	1690	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KP5ow62hcat2jE8qBSKWUSfhzioDfTHjCHcikg2ihxgXBnG5
42828	payment	2133	2133	1874	1	1	5904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCiSQQUhtxWSo293pqdqk5o2k9CC21EqLtApzWw98jusf56Fv
42829	payment	2133	2133	1874	1	1	5905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ERFBULeCHNsxXpWSokNqA8H3areicX2D9nxGfu8b5mAfxtK8
42830	payment	2133	2133	1874	1	1	5906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt3Qi8SvFoVuDYDJJfpH5mfNmEtRLn957TCxKAyKm8KD54GTFb
42831	payment	2133	2133	1874	1	1	5907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7BXBmXmCK1Yzs5eMrP8bpuFMTwZq3wjMwbNoCGikCQ8AZAwAi
42832	payment	2133	2133	1874	1	1	5908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6CzxWDZ1XfpL8HFTnbBvJyj7PcEcbMJ6BFQz237viuJt8SkK
42833	payment	2134	2134	1874	1	1	6398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JCXUgqsjqs5qgrFk8D4BXU5iS2DhqXTdSssfPQ5uiv2PSyZw
42834	payment	2134	2134	1874	1	1	6399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SeBpKTFu9CYz5KUmXThv42cJoN64miwCC2J7MhYioNXDhcoV
42835	payment	2134	2134	1874	1	1	6400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgP7qf2Gra7wFwJh7H25KwTsQEtSFWh3UHU42VDUN6x3DaucW
42836	payment	2134	2134	1874	1	1	6401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcL4LvfAHwmfXFAphddM574CqD3jtkpdspgKysrvcZbEKL8Zm6
42837	payment	2134	2134	1874	1	1	6402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1Z352D2u5wM6jExL58tQrgreC8764aK3T5jQiECwXq55Un5p
42838	payment	2134	2134	1874	1	1	6403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvq8Qjtm5fZoTZjgfqCFs8zSXckSYpfVRvWXUc3jau77LL9ZjA
42870	payment	1397	1397	1678	1	1	16102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMYsoKwk83t7VfKmu5ThuznQzUyzqgzAjj3HFpFUtYgoUgyBB8
42871	payment	2133	2133	1874	1	1	5918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXPCtNf45kp9eKFxkcgF21J6oTbRqh5LWChNxnx5cibxFU7Myg
42872	payment	2132	2132	1874	1	1	1693	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVfT83z1upcrPStGFJ2EHpq6zbLRtTBPBYUEH3PzWn1HHtpf1
42873	payment	2134	2134	1874	1	1	6413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKoioLGNEZV5utbTwsT65wuBVwi8nWVL3TCyvA7geBQWQfqcDF
42887	payment	1397	1397	1678	1	1	16107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXYR3m3vdVvhS5AXmo6LUjRw45eAAAoX8vMR4wd12NCUgH3nh
42888	payment	2134	2134	1874	1	1	6418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmygBadR43VdBE6f2o5Hn7BgLWw1oVXroZyNxPkujdT7t7BSA
42889	payment	2133	2133	1874	1	1	5923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58i4TWZyk13UJQNJyRpeXj46aQVB9TTGuL3JTX4K5hcYK3FWf
42896	payment	1397	1397	1678	1	1	16110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxEBJkbgBaVbXx9uqWGMEm1rdvQyfbAKpPJtakbAQxKyaa51Zx
42897	payment	2133	2133	1874	1	1	5926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCWhGh9GAtUFYzT1SXj2EdVN2HR21hDmQYkY9Vno3nmAT1CKdw
42898	payment	2134	2134	1874	1	1	6420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9aATUv4WP41eokn5ArdVuBDeYEeB9MN52GMkSijYWk62JEZCz
42899	payment	1397	1397	1678	1	1	16111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYN2nPBhLuZcNifVDkxZ8nMn2aKsmxBJuAfzmADxWxLt2aNrN
42900	payment	2133	2133	1874	1	1	5927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtZ2U3xcKykhut3ANmCpJstJd3cccRfYM6buReDejEkYHxUNim
42901	payment	2134	2134	1874	1	1	6421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLHJRj5KW27DzAQWo8Lw8yKnxje4sF4r1kP12CewPsjCE5UhyE
42906	payment	1693	1693	134	1	1	1248	100000000	10000000	\N	E4ZJ3rmurwsMFrSvLdSAGRqmXRjYeZt84Wws4dixfpN67Xj7SrRLu	CkpZDLSydovJCnsN27jcaQYiaWQJPytbosxfwhWJn8qpL8pFrX89T
42907	payment	1397	1397	1678	1	1	16113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsod3pEWLB9nj9us9dVHfL7sFeqBrfvMuFnKk1hpxfxZuoy63
42908	payment	2133	2133	1874	1	1	5929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVWh2pKdeawSzU2F8pRkKek5ufPRcefN6kts3ZSfo9NEA9B377
42909	payment	2134	2134	1874	1	1	6423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowXnqNcu66SC5hsCdLdxS35BfdvVvoYi3xkaQVpSRtUmvCT4A
42923	payment	1397	1397	1678	1	1	16118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CxUMt7k3vmboacRqtGd4YwBVFoEjRf6wQMzE4RTbzVkG9jrM
42924	payment	2133	2133	1874	1	1	5934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmaJDJbKwYNoKM9bhwjQwtwxSSkJMUeYC3CRYndJFhMD4ubJD
42925	payment	2134	2134	1874	1	1	6428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJNGPDEDeLwzzEc7HxfisjoLR3qS72aheGJtVqCjRb5yZwTcMV
42966	payment	1397	1397	1678	1	1	16131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB9cafPNEZfppvvFYKP8dYCPLaCsTxLEQkEAFsgAgSqCSqj4jF
42967	payment	2133	2133	1874	1	1	5947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1rTx6uTDS839FakDoLDfR8KHJ4HjtBU27Kk9zjSFaH7BzHW6
42968	payment	2134	2134	1874	1	1	6440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4v6CjMfuPLRoPuZKX49YTR94cjD3gSo31uvAcaZvYuoyWvSU8
42973	payment	1397	1397	1678	1	1	16133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUsHZWMgNWqbtiLgS1W2W4VRjYMJRYZHhuuAgrHNLKX8rFuU2
42974	payment	2134	2134	1874	1	1	6442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfcZGkS7AFSYQW6umGKrBYCsrwcS3B72MHdmQMufSeThrugxa
42975	payment	2133	2133	1874	1	1	5949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsHNmtGtipEFPpn2m97tcmz2fjGzPfCUePx87LUpvL3tfJxrw
42989	payment	1397	1397	1678	1	1	16138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWm1jfsb843G1LZGUEJotwVwVZvudV2zq2TXzCNuqgNgDv58cT
42990	payment	2133	2133	1874	1	1	5954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3d931T9L3kcCnLYrfUbPqmP31jsrN9qYRuLPkrs3ezrKtdGqh
42991	payment	2134	2134	1874	1	1	6447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEn3tT1jGYGd157ZheCNN1qptbJJaEA8iJJSuYFGGCujiEfKbs
42992	payment	1397	1397	1678	1	1	16139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8aShMWo97oxiH2JeVEwQ5sfa6n4d8No2jPoJ3Vg2EcuYWQ2LN
42993	payment	2134	2134	1874	1	1	6448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXnJSgUBGceyJywPxrf9MpoYUNUgPoasatvCoWLXq2P19ebFi
42994	payment	2132	2132	1874	1	1	1704	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT65sNP5AYhHF63qrV12gwuzk2UGFzoQ9HY8by3r28L5cCWWT
42995	payment	2133	2133	1874	1	1	5955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj14a9yM3wdQomTNUrTnbL4UwhuJA9zFGrkzfpMHGdsCQMzS5s
42853	payment	1397	1397	1678	1	1	16098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdiDcnNyfgZewxaKaw5ijKKD8ByYPBHUNRXsmtyijxw2DfemEE
42854	payment	1397	1397	1678	1	1	16099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ifF3RwXTA3yo7Rs8e8QXg9goc5HbtNBeJt8qzrePFZ8VAS5d
42855	payment	2133	2133	1874	1	1	5913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaQT6XTfxmuU3HHgTA5qJR7CzsbKaFBcMGu3sFpNv4fx6bVJE3
42856	payment	2134	2134	1874	1	1	6408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYee8vo7kBf7Pr4w8327FbvtNck3SHF3zWPqTveegHqp13VcPoZ
42857	payment	1726	1726	2367	1	1	8321	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZuUhzfzwXMQ16eHSYdEA7HwDq3zGa19HMr1D8ddVc7ZPEZBCkE
42858	payment	1726	1726	2368	1	1	8322	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZoSkDBFnNT5cs4VQ28T5j8Nnc1noLSSvjJurmYPow1h2nyGtxP
42859	payment	2133	2133	1874	1	1	5914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7psZ8fSB7Y2DpwP5CVnNkweXuJTkNDNTiuAon8PYWBaByUSC
42860	payment	2133	2133	1874	1	1	5915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLqGXxyxfMMte5sxXScbAY7pANvfpGXWmNZM7xXvSwMYakwPR
42861	payment	2134	2134	1874	1	1	6409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88gTXMnL5KSAhYAkwk43cu2yQ5gXoMFh32BCeEgPRZR38FXkm
42862	payment	2134	2134	1874	1	1	6410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89ZZbM1DKuqyFPm3dZ6g4BmeSJtuvDTUZLb9i6REtXxt1eivT
42863	payment	2132	2132	1874	1	1	1692	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRmP69VHwJPQe9LcwaJKJSkrmVjB5LW67cEyrQWS3FHLoZMdb
42864	payment	1397	1397	1678	1	1	16100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw7nXw8TrGq7Djac33rr3wEpcHEBPSbWnFbFeodmJDsR96P92C
42865	payment	2133	2133	1874	1	1	5916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaAV2oQ95H2g7PjfXykVja3gXSq8d9j2AhD2bpLoGGpAwrvzJD
42866	payment	2134	2134	1874	1	1	6411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7m3noTnALrdnffSPvX2x55eyfX1usvnVFt84mhCMihKHvFLst
42867	payment	1397	1397	1678	1	1	16101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbDXjKnr67xR7VNsecKKJMBDMAjG9Aw6EkTF734MZp8HMV6hcS
42868	payment	2133	2133	1874	1	1	5917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCcQFimkvEwV6U1L42XsUhporKKp2BZfBFT2UqGEcAbG42vTp
42869	payment	2134	2134	1874	1	1	6412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgaXULikDnkKXqHNfi8NkcTEJ93nsmnMSvkqQmkay2DxGqg88P
42890	payment	1397	1397	1678	1	1	16108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazfTYx5DgeBrRjF2kfy4XkDzh1zJMUEA9uoDUehDughxUk8VL
42891	payment	2133	2133	1874	1	1	5924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwpYkfs6uBRsD6P1EFCY8Zv7GztJqw89bdb9Xn6JSkeQB1wDps
42902	payment	1397	1397	1678	1	1	16112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGiJAv3jd1eVsHPpEzkWtzG18t6ERnKxDojZUN67bsm2HnJHwe
42903	payment	2134	2134	1874	1	1	6422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmsC3kLEhp9mmJnEFki57ekPxNkosANnT8GZzwidjFZZrCFi6
42904	payment	2133	2133	1874	1	1	5928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdd6ncoAWpiFEgZfDk4AmKh5zV2VTL63d3m4r55TBGKcovF73s
42905	payment	2132	2132	1874	1	1	1696	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqxi9onv4iXNSzhsQyw4PkaCzpp82UCMzc4GqEAjyvNLk6jbs
42926	payment	1397	1397	1678	1	1	16119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbB3sRKzN2WRN23cvYmFqunGcqsxg6LKxE1kpb6gVJEVkBuKN
42927	payment	1397	1397	1678	1	1	16120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTyPkmsPGxpkieXkf38QpkVkAs25ASuLmPi4c9JdM6DAuTXbdh
42928	payment	2132	2132	1874	1	1	1698	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk4iGh91GCYeogMp9GrFzqUprg6wEUDbnCLeeGAzAoUjbnWMAQ
42929	payment	2133	2133	1874	1	1	5935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYeKW4d7XnnjUZvhBMnj6Ep2ZYRoWRwjdgxhKmm38tr8Nc87ru
42930	payment	2133	2133	1874	1	1	5936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTm4ftqLEKKN71B6bYr2KkgBci69UajSjjwcK7by1PFPgW4xa
42931	payment	2134	2134	1874	1	1	6429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bGE13w1CSWyLPd9amuuVDqXjYMgjGy3YhnhRq59r2NVY2NJs
42932	payment	2134	2134	1874	1	1	6430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwnitAVet6AcbiYwfHCjx8eoKhLXwhVG4EEq6qHDV1TdL21FVW
42953	payment	1397	1397	1678	1	1	16126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDRHyMXDfWhQmptzAzevGm54N8Rr5ywTQbjgX6mdU68QA23r8
42957	payment	1397	1397	1678	1	1	16128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeiU6s5LL9Hc5aaXdCyccer1jbkPNK99TCvJRL3eAe5GuD39Y
42958	payment	2133	2133	1874	1	1	5944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSxXExp9hoP55PSpfE1okkEZx5ZGx7BHD8ZZrBuLhpNhfF2c7
42959	payment	2134	2134	1874	1	1	6438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkEMCJyHBvhmczUUH2xW1VWS2Ug85xW83aVcgaZhpJWTrXTBmB
42960	payment	1397	1397	1678	1	1	16129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XQ3iT19njqQMyjk1BeRMyKCvRvW5F8uE9vtht9Z1n5wGXJLT
42961	payment	2132	2132	1874	1	1	1701	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VW5YGRvrSsYoiya7PpXm1NKz23ZFwZ3FMYeR92WXNEu9g7di
42962	payment	2134	2134	1874	1	1	6439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMdkRupEZUqr52GiFHURdxh57rEZTTUndTsDfixH9MSXgMzJfy
42963	payment	2133	2133	1874	1	1	5945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy4Rxi5r4KPCg1XDm9oYXbyVHyqcgmCbt1pUGYZWDYRwKTDgPD
42915	payment	2133	2133	1874	1	1	5931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmz8pGVTzMNvt6cR1c4z4vSUKunbDUMn81znBX5gHaYBc7wcR
42916	payment	2134	2134	1874	1	1	6424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCz61LUU3aGVwao2rcxCUoXGadDtWjVBvEVuMjXPHhHjHqMpGq
42917	payment	2134	2134	1874	1	1	6425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeV2MjmnoNrLEawa6yefkT9sN3HmWMETRsaWSaLRwv5geRTR6S
42918	payment	2134	2134	1874	1	1	6426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6nxMqsN9N79GAab3oyumJBAC66hoShRtHm4RV6J2BeGNG5YP
42919	payment	2133	2133	1874	1	1	5932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoRBPG7HyXRcdikCf8tTv4wY6FVNVHSiFUPr7ymdPNcckjoSD
42933	payment	1397	1397	1678	1	1	16121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5ncEvHKDvuozRNem9ENYFqH8rtXAycDSWjMc5PGqXBVyc8rL
42934	payment	1397	1397	1678	1	1	16122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEEouPfkK2hAKoSy6qoB6wWPFXq6e6Qw3pmrHNw8SNM8X5W2WC
42935	payment	1397	1397	1678	1	1	16123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjEiW8ef6igfcuHvDuFPG7oPA1nkW6f6tkCDN2fJm9wjx5Xuz
42936	payment	1397	1397	1678	1	1	16124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6fCDXHFwxKaoefefz15y4M7R9X6Khy1dm2n1DkRfADa7cGDE
42937	payment	2132	2132	1874	1	1	1699	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFyVAve46ssmeNDc2zu95xa2itNxw3WrViddpmppao6u1KtLzR
42938	payment	2134	2134	1874	1	1	6431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitGuZnRkDVAAoSPAo9nh34EYYzAs6VhtvcTGEYuuhH9imk5wy
42939	payment	2134	2134	1874	1	1	6432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9e968emjFs1nnCRbEooLmLuN5JHvqYDMWtWM2PyATofvdJkVs
42940	payment	2134	2134	1874	1	1	6433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVrY5VRSjiLWkLwSDEFLdKMqFt9m9FruENzmJsRuSpXrvCbJg7
42941	payment	2134	2134	1874	1	1	6434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKbT9F7agdcidAmwrjUdqczP3wM5LqdWMgHT1fQz9pR7hv8heR
42942	payment	2133	2133	1874	1	1	5937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQYrx1MUE8dbcD2qfvqm4KJLWNik4nxn33Mn81nANaKwH24RM
42943	payment	2133	2133	1874	1	1	5938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9L3jwqSwUhXP4fVHzr5guRCDzLADDt2DTrCcJ1GqUrwu8Cgc
42944	payment	2133	2133	1874	1	1	5939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2vRa6q6qwYaH5MvFE2Mn8eqPDXnhkjQ8mVtWbaYNLxYMMPuL8
42945	payment	2133	2133	1874	1	1	5940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaVUdbhTUZ3rhgifRkyT7ZUkahzTvK4svvp4iY6h4uSRMqYiWS
42969	payment	1397	1397	1678	1	1	16132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv5EqAd7neZaHZHh6Aow4q7ZGhkiccjq9awcvXwQKQ7fFvnR7T
42970	payment	2132	2132	1874	1	1	1702	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tDZsuxurSsPhPX5B7rVzj2bnAW7dfcaQeyJFtRnfGACaHuja
42971	payment	2133	2133	1874	1	1	5948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKCBfXjnYTvsyZ13RuLZCWDHAgFwy2kWq6jjbTRaJBxjgnFQy
42972	payment	2134	2134	1874	1	1	6441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnznBx8kZVgCi9WWpfj4ex1QXHnvQtmAmq3t24N2dMCLVAXqhN
42976	payment	1397	1397	1678	1	1	16134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4ABFvVcLuSzfFie5omDjWRZDvhBW9KVBBLJMfNEi2wRQPRJ4
42977	payment	1397	1397	1678	1	1	16135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFq2mDMuryTNbNZ652krTJCx3m29FgfofG1hY6dpKfkg5Qpyr
42978	payment	1397	1397	1678	1	1	16136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9x5mssy3ezcQjMA3BCQRxiF2ayLCD27kiCkoR3sbGU7Uvc5V
42979	payment	2133	2133	1874	1	1	5950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnjZ5ZmDMypqDJCU5LHxiSMeENeNrRg6Rm7ncQ78WD1V1DSrB2
42980	payment	2134	2134	1874	1	1	6443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNzPSnb2vWKqQw5g8crPM9AbEuV91tTAoc4doTg2HBqPbwHSq
42981	payment	2134	2134	1874	1	1	6444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7w2hd6H1AwE7M5UJ6tQbFWsqxDUZHBKMXQmbntm9HZGWHQtP
42982	payment	2134	2134	1874	1	1	6445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYUzareJiaW3krYnCzaiHhmckFZww1RXaRgGGqqH5o3pJMxTs2
42983	payment	2132	2132	1874	1	1	1703	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHa1cc1EoenkmFYdmLYsfogwgeFLHQ1r4UcJcEmm8uHsvkG4j
42984	payment	2133	2133	1874	1	1	5951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGpvvwhgbiPPVKuURLGRLVKzb5iZzzbvyFc1rj9uk1CkWTxtvL
42985	payment	2133	2133	1874	1	1	5952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsF9c8jrHGtaZgz8M5LcqrVicHDFPzNEiMi8FF5MgT5ouJcmM4
42999	payment	1397	1397	1678	1	1	16141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECQDZBaHoWt4DEggdBbTeRRNMvQZP6YPTzqoXqLGM1SKiGrAb
43000	payment	2134	2134	1874	1	1	6450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDgXKw6nSFQXCMD8QhgdjR3c5zBernV6efAyLq5JpuVS3zYmrA
43001	payment	2133	2133	1874	1	1	5957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHTGpNpap4V8B1KZYLgdQUM4g658xBoX6aoesMKkTQunyz7Rg3
43019	payment	1397	1397	1678	1	1	16147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZooGPabYxN7zWf29gKBrzzgCmV5TnoMMkGa69qLRLNJUnxWf4L
43020	payment	2133	2133	1874	1	1	5963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9WLuKhmczSCZMJBzfWXDjC4sgirFWnsrYXLBzDAnRDG2WJKW
43034	payment	1397	1397	1678	1	1	16152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUTsqQW3VqiABKBRRuRNaqXVtBBzYKuZYTcNBeUhFwMcsFq8q
42964	payment	1397	1397	1678	1	1	16130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gDbZqqYG7uFPLMVHdg9tuLyn4665ng9EE14GdE7BB4S7W7or
42965	payment	2133	2133	1874	1	1	5946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLD34z6SLeh5SD3KiWYowuTVbbTipZUfvUTxARzi6NpFtHAsai
42986	payment	1397	1397	1678	1	1	16137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVoboMNmX6Ao2eWUzDhgBoL8v6rLjBwVoftUhz3RvrDuCkn8oE
42987	payment	2133	2133	1874	1	1	5953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEyrdmjotqszVRMtXuRJzNPQaYrak4zC9iNGD74EZCHdsSseR
42988	payment	2134	2134	1874	1	1	6446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsq1jaHQSLc31EXEQj2jk3LVa7mYfksUyxQ3JBZsFbzTD26oJ
43021	payment	1397	1397	1678	1	1	16148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZafia3ophyfqX3AuXi5fZ6GfeQA3mcDJCRBxkLpRx1Tf6g8Fg
43022	payment	1397	1397	1678	1	1	16149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyENe3npp9762kv2KQFZ8j8UPCet96GjqGXa5ATyEhuqQobePB
43023	payment	2134	2134	1874	1	1	6456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7UBt1N6kfS9kZAiqM9ri42qrYqm9uCn752w5me7cy2g98usK
43024	payment	2133	2133	1874	1	1	5964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwkorLEjYzaU5ojJ4sLZfDXsGGXB14xjjn2yQjmaFooiaJXaXz
43025	payment	2134	2134	1874	1	1	6457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nkRjWKY6HVNWaQiiA2McwEN6WB6J7g1hSHoPnrHwEzChChis
43026	payment	2133	2133	1874	1	1	5965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucL6wrGsyqFgA7smvifwLzkM93M8A31a5LjHDTR6BGBAEWMpR
43027	payment	2132	2132	1874	1	1	1707	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4A9UQw6Kue9cnoAHAA9PXDed4VYx6mTHUtuvbgmzohFDuCZT
43054	payment	1397	1397	1678	1	1	16158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqi3CDJANVYFMdUwZ7CjQvDc2P7SJL5BEMHvB2PRu4wtn1TR2J
43055	payment	2133	2133	1874	1	1	5974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCLGgrQB7kTRQaFAEPiupfavaHQ4mBQFemtsV8PgUeymnvdM7
43056	payment	2134	2134	1874	1	1	6466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAPeW1npuU8V4A7NXrbURvMNEvAssARogUKa88JCnCAHx6SYT7
43067	payment	1397	1397	1678	1	1	16162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdu9DJo5kZmpmo7RCoKm3crVSWCptLes8yZz5KM4Ey2W3eZLdg
43068	payment	2133	2133	1874	1	1	5978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpi812xEGLYXn5SvaknBPFmb5inYiK1okCTJxrVfS4NkQDZGC6
43069	payment	2134	2134	1874	1	1	6470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH2ogCZepmUsGeoiR9py832F5uKFYk5PrHewLXuHiDsrgqgx6o
43070	payment	2132	2132	1874	1	1	1711	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8UE2RyXedcgX54PPVQx3ku72qzwTKYfyyzqVtX1F1PQRtys4
43077	payment	1397	1397	1678	1	1	16165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnuRpWRyzVoyBoaa2eFSZrud3UNeaZtn4xsg3UAcEka9cPcvd
43078	payment	2133	2133	1874	1	1	5981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxB541jZ67GpjxgU6qAFFu4XG98EaC5jhnjT5HzJxX8mmEE1Cg
43079	payment	2134	2134	1874	1	1	6473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVEVts7tSNHP1hSUq94jiPst6T3oqsSttKXo8SCf8GXVgg2b2
43080	payment	1639	1639	1841	1	1	3	720012000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ86mHE9MNL42t7smEeH1Su5qNMCSyun9CTq2o2VjYi8o4BBgsA
43081	payment	2132	2132	1874	1	1	1712	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoB6ck27Ume5rbAojVwyUEgt9gfKvb3peMbGFFZhCQkCKrbmLL
43088	payment	1397	1397	1678	1	1	16168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSH1fnwtNRFB9Pr8ebvf4Kct8SbYHCL4qDTnh9zp7BbshY9ieF
43089	payment	1397	1397	1678	1	1	16169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZND3tEmsnirA3D4SkJzmhDwjJf8RbQnwHeCWUXnrGqUAhstipw
43090	payment	1397	1397	1678	1	1	16170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXd3PQRVpSxuzCLrnKNp1r8LcpFC1KKyMhnwqBhpkCVAPFPgYP
43091	payment	2133	2133	1874	1	1	5984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuSHS1NiGqHboo5UmkVNses4Z3nbZgFfG4gmphmzBK7F5c5mMz
43092	payment	2133	2133	1874	1	1	5985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcajAQGvgaTK236BEKnJ78NZcmnabuQM3esNJeFuUrAAWV4Ne1
43093	payment	2132	2132	1874	1	1	1713	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8tVSVGtfAGDFEzurjrvhHZvTSacrMUrzrUNYodFH5sydbyVD
43094	payment	2134	2134	1874	1	1	6476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9dPQFQ1WkkDJYBjeTej5uADtCSzvDZTN3qFSmtzEXPwSsZAp
43095	payment	2134	2134	1874	1	1	6477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxL7suKNeKJPmaHSe5p33aFVhUyb9rYNXyWWEMUKMX29LRQpfw
43096	payment	2134	2134	1874	1	1	6478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJvVzeXch76Dmt64Pps9vgDsy9jkkG1jLMCTpYE9GNGxAFVbU
43097	payment	2133	2133	1874	1	1	5986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBdg2NyVSR3xNfxoEJvrgXv6guww5uHsqr1D991TWAGFcFK4oT
43115	payment	1397	1397	1678	1	1	16176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowDG23uV82Z3ZtYEuBJXougwRnKQwQGnj3S4X2iB1smRMSFns
43116	payment	2133	2133	1874	1	1	5992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZorp5Rjond1N8oXTg5UzUVBFcQUtHdNCXdgcG8G6XrqtriXfTT
43117	payment	2134	2134	1874	1	1	6484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabadB3bn1euxw6xyLn55j8Zgsw2ejD32sn7nyzvxjqc27UgKT
43124	payment	1397	1397	1678	1	1	16179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX8oZ55Qf8Ro8gPZQYec88cqNFuGGHjreA2z3TFXgW7dty5xur
42996	payment	1397	1397	1678	1	1	16140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbqexswUq7QC5ZQwRvDxjgy1K3sKzqr7eNLzwh6m87TiHQdrK
42997	payment	2133	2133	1874	1	1	5956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX45EDBck7tJpxTbsJC3LeQQsu9nAuaJz6PyWhgRmva8WbKCPX
42998	payment	2134	2134	1874	1	1	6449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbZ3pYUeKjKtyrTcKSVtQFHGPPgPvytHHP13tLNBDrXbyhFEK
43031	payment	1397	1397	1678	1	1	16151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22enrFpRNaVrmKxLRRJtrFjQ8hTuwAJ2hnGXrEBkjzHC1vL9o
43032	payment	2134	2134	1874	1	1	6459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUh9HGfb3KsPFfsCUf9MMA6Exx3ktw6kZTtUrCDYewV43jv3KX
43033	payment	2133	2133	1874	1	1	5967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqyaQ8AuGr7UWsNMwAYr1W6szZ6Hzchyf6AdbyYpHVYvzGs2Ej
43105	payment	1397	1397	1678	1	1	16173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZknjA2ZNYPYjHqkzFwSfCCY6pTNATwSj4j1ushcSMLo6jr5JP
43106	payment	2134	2134	1874	1	1	6481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZiVyaz6cgWMUFw2E6E2sojK934X38Ehx5Tbd1h6QoepQnJJt
43107	payment	2133	2133	1874	1	1	5989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTaSW49BEgk5sdtPZMvkf3seiYKx6uCb57coKd3DQ4vH6A9wFZ
43157	payment	1397	1397	1678	1	1	16190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4bPuQYQYUdHV3WtnDZybFRuh6Nkt7NpG71to7GGgVmq1watp7
43158	payment	1397	1397	1678	1	1	16191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsVQFNwAXTxRb9fJkWQqAiQMJowfg7hQFYLXWCZUKgc6Aq6yf
43159	payment	2133	2133	1874	1	1	6005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWmoMj91ZPB7bBoDLbmJhWBkxYp393aS5AMo2f4zo5oJYYwy2
43160	payment	2134	2134	1874	1	1	6498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqmQrumYNQfGGJK5s4T2NWjyR8KL6XSaXsuVncB9u11wD3H7p
43161	payment	2134	2134	1874	1	1	6499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwALpMsFWPGNHXJFnsjAcpeBrWsbq5eiS1HTDxahAz827Sdm2
43162	payment	2133	2133	1874	1	1	6006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpRcZ2BrMkwD1gCXA1UxyRjSPRK5FiLYsDRMRErEa3JSPTwGN
43174	payment	1397	1397	1678	1	1	16196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSg9cXpmUFy6YahMdEVV4ajtQpUN7v2frELQtQCZNgvpa9mFF
43175	payment	2133	2133	1874	1	1	6011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCwc1zMPXJADqCwqgLmaSGUghWZUZiyS4tZW8rhxSZfGChqGp
43176	payment	2134	2134	1874	1	1	6503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitnBVrJsfGGLZfcveNG2X5P2EvNKmwV1ezQuH3QKn5PaquA9M
43183	payment	1397	1397	1678	1	1	16199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27vT5kcruE8NVviLVVA5p2Ksao4R1Q6f3Luz1dpMaXsWar99o
43184	payment	1397	1397	1678	1	1	16200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjpq6QpPLg2JyjpDqfuYpqJWgq79Gxke2D8drcjXiudUyoijgM
43185	payment	2133	2133	1874	1	1	6014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo942ttUdwcvztDbcfGzzn1UfgGf2eChUQmiTjHt7R2ENNPNhE
43186	payment	2134	2134	1874	1	1	6506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv39H1DKrCC9Pwg8Uq9sjjjVvsjQ9EPwMjsBgaUoo3KSnNrG7v
43187	payment	2134	2134	1874	1	1	6507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhSGyP3TZSn6cZya2PDXvrM4YEcaqQKTnB5WJoW9oLvxkJ5YXL
43188	payment	2133	2133	1874	1	1	6015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKofD87CEDw6PKzGC5vJv1EPQCnfUfpZQ7BaqLz7WYc8NsXL44
43189	payment	1397	1397	1678	1	1	16201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFzC5mR8D9NHXDZw1qUTWB26jWHftzu4v29u6ghcPsxgtsDaPx
43190	payment	2134	2134	1874	1	1	6508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAqPNiNZF4sPzjq98BzScbtDQUfpu4cFmJyfmPc8GDGbd44Dbj
43191	payment	2133	2133	1874	1	1	6016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpGs727NGZnfhwGaCKkNCMDvM2tbBXiAHHZnyqnzoqfZ7rDnq
43198	payment	1397	1397	1678	1	1	16204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55ATUkwFuD4N2UMzweiMH6afyzuPY9bfYp7R96Q6aUNbCuKCa
43199	payment	2134	2134	1874	1	1	6511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZers2qG9aLfVDQ2R8C4tGaDCfRhgCwSR45tXvgnHJV61ERYf2Q
43200	payment	2133	2133	1874	1	1	6019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRCmtTeB6JXy7yoVTsDyEtGWWUhov4V3Djdp8dP5E9RzsUTD3
43201	payment	1397	1397	1678	1	1	16205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdB8v6YY6FRWb9poD7efB789CG4sESiq1Qu4FjDAJUaccDfPh
43202	payment	2134	2134	1874	1	1	6512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzyeVkuve2NFJdwkTLeuus4HuMp854DR9AQ9tnu1Kkm7JdRwa
43203	payment	2133	2133	1874	1	1	6020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6eScjS2ygd2v8vc87sug3H1K4BvqSKFLcTAPVuEr3AjwLRqDV
43204	payment	1397	1397	1678	1	1	16206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF6RKGhH9eSfdn2N9goPkB5idD7HrddQ1SyJmFTQkw1qK2q67j
43205	payment	1397	1397	1678	1	1	16207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9hPT1rXLZ4C3AkJ5WNgjCqXLRR73RhJDqHbBhH6BFa6uw9By
43206	payment	1397	1397	1678	1	1	16208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygGkxt6HSQVRyV2YE6ZdV3e85p453E51PKsjoUZ5CUohgpjiw
43207	payment	2133	2133	1874	1	1	6021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDiJUMfX96gJKCmDdFg1fonERrjuvi22C7E9jpGULMhqX5KGM
43208	payment	2133	2133	1874	1	1	6022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqDfDgBB7VqJcbbxhCwzv9oFQbCWVvgocNvMHDXV95PZncUSv
43002	payment	1397	1397	1678	1	1	16142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzpNipVtQheh3MSkT6b59e4Tqrk7Xni4is2yN489bmW6biN7u
43003	payment	2133	2133	1874	1	1	5958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YHa5AtuYwjJjVUiARuS1M4XckhVtDJ9K7EGWvhKqP8ZfDyPV
43004	payment	2134	2134	1874	1	1	6451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZXznyu3hjti4GGVD26DNzMV5oAQRmJnXhL9Ghnm4UKroSiXE
43005	payment	2132	2132	1874	1	1	1705	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt9foB8Yo33o6KSef8wXE2XN14nQ8nYwnyyYpvQZkk4TaMXUpS
43006	payment	1397	1397	1678	1	1	16143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpto4UwwDet6gaNFZ7nZnAGotdSi9aT2Ydc5K47UGnukN63tQ
43007	payment	1397	1397	1678	1	1	16144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrahC2TFEk886zkdtxjjcUYweWht8TbL2mYhdPdRZNUR61icVk
43008	payment	1397	1397	1678	1	1	16145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KbEQt34XnmEutaGwfehKNheKoX2BTLNUJiatiJxeCoEcDQrj
43009	payment	1397	1397	1678	1	1	16146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTErWhdBtYjQEceGaX7Vn11Mzi2BrbGh4L52FUvwURQWLqJJpk
43010	payment	2133	2133	1874	1	1	5959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ28tYuobSpVzuLhkVpRgmvKwjdAS2sBF1gsBJCCwdqJ1NAScdM
43011	payment	2134	2134	1874	1	1	6452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbqgiSjNpBD8REUphwtCMFbj12wQw29V6XLTBcyu42jRsEHxk
43012	payment	2133	2133	1874	1	1	5960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRBVU5hMhBKxYGR68LS7VZuCKGt1SZDhFJUJR7Mz8EpRb5Gpn
43013	payment	2133	2133	1874	1	1	5961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCRiqRZ7YXbJgkoFs8agmRxr9a1zSJnUUmR6h6Xty1LYkppKm
43014	payment	2133	2133	1874	1	1	5962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc6YMVr2FqXx65jMN2WFpn42MgLNPnpG95TxUvJxxuRNNQwdi
43015	payment	2132	2132	1874	1	1	1706	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALiRpvF92KZWcKnjZiru44u97QN3pWmEgQyKBe4UVLKDTdnFk
43016	payment	2134	2134	1874	1	1	6453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2ZNAMZGxs1HoyAGJrWFJMUztXzXerSQ7zSFoZ9Y8GGJsRSaF
43017	payment	2134	2134	1874	1	1	6454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1194S7sbeBakZthnAnnAZqfcxCNzZD3zKXpvNg9rHtn3zzBp
43018	payment	2134	2134	1874	1	1	6455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4gy3PAcasq9UdbTLqC6pbTFVZDwJJUSZecRnhHRohhkogNmc
43028	payment	1397	1397	1678	1	1	16150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLsLh58mN1bjihq4ciXEYQAXcMe63UnDFGYP3X5QXnvkFtTHe
43029	payment	2133	2133	1874	1	1	5966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXj4mdNLZYQoaAjiRenbHM91QhyZq2RxshRFiEmuRqvWaCJfv
43030	payment	2134	2134	1874	1	1	6458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZ8T1NMYUPH6W5kNPMMBxjRxdJ4EaJ3kwggB8cdyPhpdVFzkS
43041	payment	1397	1397	1678	1	1	16154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEp7yoPXiaPb22DH21wTdrPmrZeptMJvS8jDVxd8nQfEPfwvx
43042	payment	2134	2134	1874	1	1	6462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsozXR7nz8Ze66oFBwcetQHVNmAnaUf8LtC1M2Wnncdt2Meoqg
43043	payment	2133	2133	1874	1	1	5970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm8b8hjcTbRRHa8rpQQid1U3ddsyumw3F98Vs41WJ3WGPqMEVY
43044	payment	1397	1397	1678	1	1	16155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwcvhuQtXtabL8V4c4i1UmGHfYBb86YUA8ZGNR38sUrQKNFgob
43045	payment	1397	1397	1678	1	1	16156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5LLnAxaohedQc8LPSpx9iNcDDEb15Qn8CBdY6JAHiPMoCF14
43046	payment	1397	1397	1678	1	1	16157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ5MPiamkyqdcDpmxnoXsEdiZf4BML3d31g7KE7AKGxWJzcHoi
43047	payment	2132	2132	1874	1	1	1709	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSjDsHxAVBTuwmDXEFJMLyuZakR2P25eto7eYEfJkJPBT3PCqX
43048	payment	2134	2134	1874	1	1	6463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk1aEuwzbYuGnfFvx885zqgpQ7VMVJruq2gW8hVkzhU12sG9H
43049	payment	2134	2134	1874	1	1	6464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyrPy1PS5e1YxHzzcHpe6RtrFdFUZx3uR62vZXcuKbRw56UA71
43050	payment	2134	2134	1874	1	1	6465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2q1M2cLsB8kfFD9g3GMCf3wYy4QpFSZ4WnM2Wynkz6uSbo25
43051	payment	2133	2133	1874	1	1	5971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P24gzKx22NHfoqn76We99zTtjZZndVPFgQzCihSLixW6V3XQ
43052	payment	2133	2133	1874	1	1	5972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZohnDzGQ9Go2Ryxkz2Q96v2ZnE6khFZdWbsmS66vxQNgCbNJEQ
43053	payment	2133	2133	1874	1	1	5973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXEBwU4SmxZdnv4Wm7XuksjexcPfSbQrXeq9cnLyBngrBNKU6
43064	payment	1397	1397	1678	1	1	16161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6taABHyzjfdo6DsFFfivqpCVembeav286tBu8DJf8YdWAbgG
43065	payment	2134	2134	1874	1	1	6469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUSW8K3qNgAKUyZ74TSYNPYgSAj8RJHpKaFSTMLcnuoJvCRwPS
43066	payment	2133	2133	1874	1	1	5977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPLuh7QnHTsYzzvh6Rh6cUoa7rTh32SCVRk3osLGRK7AGLUrV
43071	payment	1397	1397	1678	1	1	16163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoocUU6mwvDnMDuM82pq7ppAYdEBvnc78cs5pD62fFtZCTYAtN
43072	payment	2134	2134	1874	1	1	6471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYiJ8EsQCfgH9G8NT73CD9d6MmLPGaGaCCiXQyWX6ZHuykJ5e
43035	payment	1397	1397	1678	1	1	16153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVNvvKY9Pv5RuL3Lph2TrojSBbnGZcG55EXhqbjDUzAq5Vf45
43036	payment	2133	2133	1874	1	1	5968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCaWLoq4wammJVzzXC4TiXMWmGct71434gUaXBjqMSAzeAJdf
43037	payment	2134	2134	1874	1	1	6460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4SGVKjnnZmtvHPymvopWsr82ZU2NrrGHSP7WMJUbHP1K9NTY
43038	payment	2133	2133	1874	1	1	5969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTaXLF1sZ7fwgGG1CvTNotfszkn5KnA7rMJZrMLk3xmpmwWSo
43039	payment	2132	2132	1874	1	1	1708	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeH5MNfTdzuiSZa2bK1BFxux36GQrcLpWjSzJ1jncTHKSMqq4c
43040	payment	2134	2134	1874	1	1	6461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtF21PPqhjCzZXzBed2ywk9o6vMrfffaUESzKQ1nDWr8tbFXkS
43057	payment	1397	1397	1678	1	1	16159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYXjTEcYXidNrxMNxGUV5sm8rQv1dsrY4NjF9QuWeevvX8zhp
43058	payment	1397	1397	1678	1	1	16160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8GDJNXPBRySeFYouWwWwiq5f1fPmMtW8H4icJc2hseVvCM2R
43059	payment	2134	2134	1874	1	1	6467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qWc9yZZ2oofZRwGkBxqmyg6n2WscF8H5G1bjP7Ptf9D6rPnP
43060	payment	2133	2133	1874	1	1	5975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLsr6SmaCRbgs17yiV86HqLr6G4shAnErh6HV5RwbvNpagSVYS
43061	payment	2133	2133	1874	1	1	5976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHshX1QcBwEG3nN3P1WugTdUzUYPAFGi6CoWqawtWin3x7Qr5B
43062	payment	2134	2134	1874	1	1	6468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzedNsRSUY741bMS15EBGgRHUr8AyG4x2SG5emxKdY1f9vXbE
43063	payment	2132	2132	1874	1	1	1710	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9sgZUta1TcTcfKtYMG4eHKMhuq1c3S1aETkEEdnwXs7rkTyg
43074	payment	1397	1397	1678	1	1	16164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsgSgaXKyhbCYnfmtkcciJHVyh7TnKMSg6cHXoe5HaehNxuynU
43075	payment	2133	2133	1874	1	1	5980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUhsgYBvUN9fJ5EetpWEoYxEXwnQAxkD672gdh3s1yJKjDnhVx
43076	payment	2134	2134	1874	1	1	6472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsoa7x58WB4HWjuDdJCepdEaeoiYgJu8VRG7iGWP48TSd4d8x5
43101	payment	1397	1397	1678	1	1	16172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkjHDZS9FmZ3Rw4DQKu8n7hnLsQPd9EjEgdvTZ1rHBN9Z72oG
43102	payment	2133	2133	1874	1	1	5988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2kdCPKKeaBdEm9r8rjs5dcjRHUJLpfig3LgknwFHscDJiKFxv
43103	payment	2132	2132	1874	1	1	1714	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkmfUJZpGMd3QXZ2iaphGc8iudjQMx83qXbmmVKx8sWkgVB7R
43104	payment	2134	2134	1874	1	1	6480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5Z4ug2vGPPPg7NNxeu6DBwHmPpPC2p5rTxrFTRMqqFvQv2uX
43108	payment	1397	1397	1678	1	1	16174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKQ6H4CDSEyc4KLho3X63w81TuZv4g1gaeaNXx6RkkJfMBZsSA
43109	payment	2134	2134	1874	1	1	6482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5cSNQuXBF6QpK2avBqpCkbjW2Wu5cdTsUzeMrECR4kNLsuwP
43110	payment	2133	2133	1874	1	1	5990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2R2hL1zNshR6Q8naBNGqmCtccNEKLsBxgPN658svWtKN4KZq9
43163	payment	1397	1397	1678	1	1	16192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgdMTXxcHh2uPXSJ3wQ7H66zgr3RKkg2t98t8u9WjqYW34ZvLM
43164	payment	2133	2133	1874	1	1	6007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhG6YGJrcpDdv15wzaX1wahD6LcgCX1NG4NZRUrUPvyvg5WDu
43165	payment	2134	2134	1874	1	1	6500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8KvUcnNA8rHAgTamQDjZxhBEwMiCJXbG8qzfAdcMVcmZPviN
43166	payment	1397	1397	1678	1	1	16193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6tSfP4ZSmp35MZmamRQ2cMho21eXjN4eBKDpwsdr6ZfikFoqj
43167	payment	2133	2133	1874	1	1	6008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSKJFi15wdS9NzgeSPZCcwri7guh4whwjPtBZdnx9k21DPApn
43168	payment	2134	2134	1874	1	1	6501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZngFkAWPoLCbeumf13Gn1WNVspcM5wm5ykEVzvCQfCLjZCvZvk
43219	payment	1397	1397	1678	1	1	16211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjC7nEFUdj8ASerMnHub5hSajHe6m1i94ntHj7ajfjhDmL8Mf
43220	payment	2134	2134	1874	1	1	6518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvrtc9TfSZBuNgmfrYEQj8ixPFeZ63d8yLqPZkQgY1Ccmcoxrx
43221	payment	2133	2133	1874	1	1	6026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYVxDnaAMCTikXx5vbmkgenejnE7mCasnVXQPYQrfVVrmR6tXy
43259	payment	1397	1397	1678	1	1	16224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDuJRFdJhXPzBhj3RGj4QJfrhZZVefZCdvuWe9Tgfcx8FY3UR
43260	payment	2134	2134	1874	1	1	6531	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ51VsmzwWNXQC3n9vAGnpxHSX7QUA2JKPZXGZqBMvxzfwLi2oP
43261	payment	2133	2133	1874	1	1	6039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCR1FMTfztqcYRT21GEXaYUZxLjrhWPRei6uZVUQoimVhHV2p
43262	payment	1397	1397	1678	1	1	16225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCWyYWT2FqPX9cF8JSBjcSuuu5nZBcwFVn8cVpTejYfSLAYHK
43263	payment	2133	2133	1874	1	1	6040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYba2L4bL2yMkwTvWkBSfkmpNN1Nx5eDTUWhYDmNWXQbGqNHHvC
43264	payment	2134	2134	1874	1	1	6532	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4bA9ZwtkHbSkBR3wDrQTWBYRLR6hTCkA5EpvPjBzm4aYvMn3
43073	payment	2133	2133	1874	1	1	5979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXSu3u7e9ZpobiUoG2VSPK4iHj8MzG9W91wS3H3Lb8RAfdk5Dc
43082	payment	1397	1397	1678	1	1	16166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPSyjgSExmb55rAVarEZGaBFAV9rUrsG7yqgEY9gSc1eiizKf
43083	payment	2134	2134	1874	1	1	6474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyxzysrCfYcvjXmhzZtoKDNQqqPRKJr9NnTem7XB3Edco7fTPw
43084	payment	2133	2133	1874	1	1	5982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjFxpxgNTGnnrdt3hMJUgvaTnt6mgEsqD1cxm3EKfHwKtLK9uS
43085	payment	1397	1397	1678	1	1	16167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwk1TJut4Z78wD8yq8DwV46UMzxFQTRurft1uKFLXPU2WzbzFU
43086	payment	2134	2134	1874	1	1	6475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbt5v6RZWTNcoG6Sx6mKaZt784tebaFGmuPFCVjNZA4XpdDXP
43087	payment	2133	2133	1874	1	1	5983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfk6ZReVo7T7noVPhMGagyNDebea4JWy1xNLiHZJ4urE7cgLv
43098	payment	1397	1397	1678	1	1	16171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Wvmt6MDmdDz1v58QweuQ3F3YSGw6BZ8Ky8DJoj9MDdzXA8FS
43099	payment	2133	2133	1874	1	1	5987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBC1N2tCoEcjB4v6tvKwh5SsQtL8KbpptXxPnR3uDco5G37pZs
43100	payment	2134	2134	1874	1	1	6479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkdmnFKe47RWEZSBUFL3BHdmD3BMQzaibGQy5AhwMwXh1Nzro
43111	payment	1397	1397	1678	1	1	16175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHTb4svpJX7DPA9jBRWJoUNRUb3PQeSY7NiWiN2bW4AcRS1N2
43112	payment	2132	2132	1874	1	1	1715	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZ3aqR6QggdHnWxxjvJUKfW8tvVnfuvcRmu8FkEtvHGPE9hY2
43113	payment	2134	2134	1874	1	1	6483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAPhr7qocw48PJVCmoyuQNVcxXdzQwMeueXp1DgBDfC9K9LQ2
43114	payment	2133	2133	1874	1	1	5991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYL8UFk1Fjw6urVEbffRqGv9E6ijzt6x7YoDmEFsennhBL2mNY
43118	payment	1397	1397	1678	1	1	16177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEhSgbu3mHRB7ocdJDnXbrvV1UMs4UpcSJS8VUs2dK9UvLzR9p
43119	payment	1397	1397	1678	1	1	16178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR25jitUFj7wDH99JY1pT38TGUsPjZhtbjWG4hq8ctPoitLKu2
43120	payment	2134	2134	1874	1	1	6485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsNiWv8GEsrK5MzuaYTSthKKCFjx6cHfcM7CRqJvDj8cAwBcga
43121	payment	2134	2134	1874	1	1	6486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeTarxHSvjqdPLY93TWghjUDtrB5bgdG49qfi8PbZNqqptyJsR
43122	payment	2133	2133	1874	1	1	5993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrPUfxtJ1R8CYo7E8YM8RPmV51vquov8Q1DkzE51BzRX8UGxDF
43123	payment	2133	2133	1874	1	1	5994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXYWAG79f5b2pMKKxhqCoyYmwhqK2bL59FxZS82vWNRp4rGV7
43131	payment	1397	1397	1678	1	1	16181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSY8JCn5uBxo2r9TC82dHqELZHbBnAgwzfzNLt2QTpSzrQoJWE
43132	payment	1397	1397	1678	1	1	16182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HhU36MniXnFijzWq6Gc4FJDDD3rBB6ci38uZE5EnVS65rqCC
43133	payment	1397	1397	1678	1	1	16183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6g1dV5nPDuG9TL8SD7XWXPDMmD9keXnXojqyc1aLo9HAPvZxs
43134	payment	1397	1397	1678	1	1	16184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6aBDx4Pbkn3unCGwzb85CUsiCrnzgRDUDZ2TAAzv2Q6WoyhU
43135	payment	2134	2134	1874	1	1	6489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqgPetGCA3HjuHTG7pzSYWZEfrSW9ywzhZxNnRoS84Y9njxshc
43136	payment	2133	2133	1874	1	1	5997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnqkqcCFmefXAEqD9RXm3cKb9uw6uPpDQzYuRJYwfBCxBwfsPu
43137	payment	2133	2133	1874	1	1	5998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmoFXMoosN9EwnbmdAoRfKQzcdfrUr4fYYTJhq1C7sR1gectDS
43138	payment	2134	2134	1874	1	1	6490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2RHqjjmLog99DSHSTkwB9GrE8Agt2fRc8jFm4LQeVxUAGmF9B
43139	payment	2133	2133	1874	1	1	5999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLkR1Y6sC2jNMyr926JfQsWWWkLamWPzuqDa9c8aKXnmdpG2k
43140	payment	2134	2134	1874	1	1	6491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3rwSsZjL7BM39kiwLeo6LwoE8JVQL9h3PJ6EcVq5r7Uj8MNG
43141	payment	2134	2134	1874	1	1	6492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXxeCxnRBDXrdHADGvoSxVe9rKACQz9HwF949YzdM8dzYvzZ1
43151	payment	1397	1397	1678	1	1	16188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuAHWHGfZ6gwR1BANfBzehUAbFygsReWFHD3mTz4ZE7ikoH8xi
43152	payment	2133	2133	1874	1	1	6003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhyvf6A9KG88JAWogdAFEXwDeZPnQ8nsrHL6mp7k99YRozbrzV
43153	payment	2134	2134	1874	1	1	6496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrz8kiAYPJcA5Qg3uS3EcUvMCp3dwLCuQ3pu6SsGy6bxeHTwpA
43154	payment	1397	1397	1678	1	1	16189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7PNCaGyJi41k9nBgisRrsCSVHsaYS63SbSJysRmQdz6ko8Yqv
43155	payment	2134	2134	1874	1	1	6497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoxtV5myDRy7SFKJA38zN3Br7GcjKvhSao84YKuLPGPSpCoDER
43156	payment	2133	2133	1874	1	1	6004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FPs2F9aNWCHnD8kjsMUAkXf7XGdAm1rNW84EVDo8x7KVh5uX
43169	payment	1397	1397	1678	1	1	16194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ugBedPsos12eygjteUuwKVEnrSf2BEsf77z7GNFZGdDX58hz
43125	payment	1397	1397	1678	1	1	16180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfpvMdmhpgt3JPyWqomeo9qmi6LonqdYMsnjyacSXCHV1W4fu
43126	payment	2133	2133	1874	1	1	5995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCBs9x1zwJkLZA2KwXTrksvvjAa2WNRKZaiJj1QKfrc5DrTAC
43127	payment	2133	2133	1874	1	1	5996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiWhrtNJtoK1BfDa6txEpKJ5fu7zvyPwriEgWDET1NTN132rdS
43128	payment	2134	2134	1874	1	1	6487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJi3siCLRhFU1uJv4j51NDbKF7Ggym2CEMH7KTbiUSgxtsD1XY
43129	payment	2132	2132	1874	1	1	1716	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedy7Gb5fcBMxSk8MMVrzBPUv6yjye7yBw9joJT8kXUHSb8eqd
43130	payment	2134	2134	1874	1	1	6488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xc32R4BnBDB6gEa5h8PrT1DL6msDHvBXxUZuzwQwQtUmaHsp
43142	payment	1397	1397	1678	1	1	16185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZSHcGgrRN5kkGFnB7WFwTBp22WiC5VJ7NNhwGWZjCS3fHrNU
43143	payment	1397	1397	1678	1	1	16186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKvTxk5PBtXK8SbgXQpKW7jvrv9XyTtYwkZcwvDUqD3pw5Aej
43144	payment	2133	2133	1874	1	1	6000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzFrVgzwLNvJu5YEYuBrVjBTCUrtUoCtTfiXZ7dK3ettdZ6hw
43145	payment	2133	2133	1874	1	1	6001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZURo7dEtuQoXYYfxfcBQsFWdXRztfhSCnMnda5VtCGPW9JirZ3
43146	payment	2134	2134	1874	1	1	6493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcAXg9Pbe5ZXAt9cg8pk5eH43qy4atmBBDykBdZnPUSkmqf1S
43147	payment	2134	2134	1874	1	1	6494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZY1pH64hCBUpi6TQydD5Yf1Zsmm2TtUN2B8ncH6jF8XvBjkn
43148	payment	1397	1397	1678	1	1	16187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SXGdP8G5guKkViM7rEuAbkqLyqyH4PUwjScQVuNzBw9hBYJV
43149	payment	2134	2134	1874	1	1	6495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPWBiRV6KwEeaJ2Wmj9zwBkSng6jTsPz8EPdpqjHmNctvwBhmy
43150	payment	2133	2133	1874	1	1	6002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezwQ14Qky4cd5hWTGQjRBK9DtUV5HSqmbXizuNBeaB592feSp
43195	payment	1397	1397	1678	1	1	16203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLmEWwR3p2NXB9PFi5L9YC8mA6gDV3Zyk3ngRfyhasxxPFyRJ
43196	payment	2134	2134	1874	1	1	6510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKx876pFyefk8F99Zp52SaRCCSnXgZ4DTbRjs47yLRhi4b9ot
43197	payment	2133	2133	1874	1	1	6018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPJ4ucDEXJngNEnHJE6iH2HyPtxe8ZCTvnyeKAVmC9AevkKs9v
43225	payment	1397	1397	1678	1	1	16213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZUSj5q8JJeXU3yPe8wLYpjXf1ssxAGLQvaGT1AeCff9szirT8
43226	payment	2133	2133	1874	1	1	6028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDFTzG1edgBrVwHFoDTAj75zcDhdosch4GtSsQBi8X46BTR9vU
43227	payment	2134	2134	1874	1	1	6520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbCTCnXFbnFevvG3TM4Qm2NQVG6B6Vg48fBxJb5otYTB72d6M
43228	payment	1397	1397	1678	1	1	16214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygTQDjW8DeGcX6c695tuFX3tpbZzANqdTsnvJ1yNsHZNHwdSk
43229	payment	2133	2133	1874	1	1	6029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBEpwTCczwpsG1VoMN666CGpBByzPgJ2iRj72wNxZhJJEKxqY
43230	payment	2134	2134	1874	1	1	6521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQKcmzRwNXwhWzdyhubEcjELaC3gomwGThChMQmzc2ovdCrXD
43240	payment	1397	1397	1678	1	1	16218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7TpKWzpCutcQJu7uzz5ayHr4w6N8hzP3UNmQs9CnrJQkf5J4m
43241	payment	1397	1397	1678	1	1	16219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZ1ssc5DvxUDHNtrsCpVtdCzugufywfXvnY8kWTJNW6db7nxL
43242	payment	1397	1397	1678	1	1	16220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAfqWY7fTmiVGKW8JThDp1syrvjgtK6an34rWQ3jdYVfzeTdVX
43243	payment	1397	1397	1678	1	1	16221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumTNTRVQ5KF91KNUALkbXv7dm6kRW3JuZfe9oVauMLDX2qY14
43244	payment	2047	2047	2369	1	1	0	20000000	1000000	65535	E4YhMeNTJaRuqHVQHAqXMFeXRuHJDzPvGRYmunHRnJ4vFTpyQ9APC	CkpYpQtM3F5DoivgSiLukPhG4tibkxQtuew5RSVfeoQD3WgdJ7VYZ
43245	payment	2134	2134	1874	1	1	6525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuiAkzDrpM9dxT8LWx7ite3Giyb81WQfsVpuGw2p8MytfRdYG
43246	payment	2133	2133	1874	1	1	6033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7dqHPzJ7UbzrGMus4NiJK4J5RXUAZMtZDEqYnHjUWGZcZvM3
43247	payment	2133	2133	1874	1	1	6034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymJsB6T1AWT8B7PVxkPj7iDvQfNjuv3xdSC6gxYSuiEo7HtdB
43248	payment	2133	2133	1874	1	1	6035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBWrKsLm5VRQvjgWgTSye2dw9nztDwTaZFRLeaPrvX7G952rgN
43249	payment	2133	2133	1874	1	1	6036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdBAh6Nv5AcVLuNT2TtHTRvwYTeLMpabKExsJYwXUEuxxFhrm4
43250	payment	2134	2134	1874	1	1	6526	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEa5xyX1hErSgUeub4qcLrt1knxDHfox332yhwDmpP6gAmLUV
43251	payment	2134	2134	1874	1	1	6527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95axm3GS9uMiNhfrvSViXmVLQDp1mPb312M3ZSbAtPJwJawjA
43252	payment	2134	2134	1874	1	1	6528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkqfqsVqjymapG8S4CguA4FugW5fhaNyxMcNGmfxH3cbJtaR1y
43256	payment	1397	1397	1678	1	1	16223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65oRR7yPkjrwqn8HGvmZon5d7XVBMoXrJ4nbbsMf5Rw2LSfRc
43170	payment	2134	2134	1874	1	1	6502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzPA6XivWi8G44boLT2ct2LU4hveWUSeeLsxwL6xbQSNcqSdFT
43171	payment	2133	2133	1874	1	1	6009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHPndtUq6tvZeAcfyBJoN91u69YySXgF6fpm23sAq4sFztESDh
43172	payment	1397	1397	1678	1	1	16195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRZYVDdSEevTrPhnC3SnQ3KPsnVsqShxnkGXBZUngRN8R9D46P
43173	payment	2133	2133	1874	1	1	6010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXn9E59PZXELQ8UMAe8MNk3PAi6UtgZR3GnTwh8t743m33pNu
43177	payment	1397	1397	1678	1	1	16197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQW7Z9HDB9ToKbH3BbKKW3dwqj8ySznzWS7SpFb3x6LbxFygr
43178	payment	1397	1397	1678	1	1	16198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjjbeQu4kyWScMHp2SZnc35zvhciiWK9oBfKNLGKu5627Y4uyM
43179	payment	2133	2133	1874	1	1	6012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsfVscnaLZsRj5Aoe5Ku59XEp5UDr3zWgBphNVffWv2kTJcsJ
43180	payment	2133	2133	1874	1	1	6013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXReUox9eLfen1RMMnrvSv96L6GbGAtaJhrGGzFyoSmKbymaJY
43181	payment	2134	2134	1874	1	1	6504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvHAJFLRpzeYmSv7s338rXk5n6GN9htt7KbqQvDHmbHRMFFTur
43182	payment	2134	2134	1874	1	1	6505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpA9N78uGcwvBftSS8oHrrdunGQuqvqiNCtq6kWGkjmYqa5jC
43192	payment	1397	1397	1678	1	1	16202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8xe5ZPJQzcuxWwZeV5YjTCXJ2ESdvZqwpGGQUfJhDaB4mqk4
43193	payment	2134	2134	1874	1	1	6509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8tTGsVE3oHiUDmeJLD4dSv3wSFEVbL1WpYRCBM1n21V39MwEH
43194	payment	2133	2133	1874	1	1	6017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiE3quSbHMjSz2NgxoxxKEbPWTASR6FK2VqKk7dVotjFNndiW
43213	payment	1397	1397	1678	1	1	16209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMdaJocdRhhapye1QRqagp8ULFPTSBAmZpy1tTnMd6JjXRard
43214	payment	1397	1397	1678	1	1	16210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMsoYoCR23si8ygB28RqHf8gUuVqLp7skGoeP8Z74zJu8Wuth
43215	payment	2133	2133	1874	1	1	6024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ18q2yxv1cVbJdCXw8v9GBuEPxiVk3fPcYKNEzHGfsN8m9cudX
43216	payment	2134	2134	1874	1	1	6516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1etYayw5AYaZFAxR38XCpzRiwQNiha958dgY7hFvf3xwCVwE
43217	payment	2133	2133	1874	1	1	6025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhK2RAQSJqn2UsdBKwmNVufCCj8VdfucVLwYxSrJhuzMxsWkHH
43218	payment	2134	2134	1874	1	1	6517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ejX8f6sxGqH372YJCnKMYMxr9yvYYTyu2Feydr4RnmLmsU4M
43253	payment	1397	1397	1678	1	1	16222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnGe6Hp5yFYT6MkUtU4jb1G6jbbHVVN19vr9QqQcb4SghEWGY
43254	payment	2133	2133	1874	1	1	6037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYccwRjGGHrq4SgeXmZizRm7k2J9FR3XM2awzC4ZZzmRqyZkLn8
43255	payment	2134	2134	1874	1	1	6529	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6ysn7Po1QLP5hSGHhiPvrtNJT5CW2kWkBy9Su8cvKHi2CuZJ
43265	payment	1397	1397	1678	1	1	16226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEVdawEp7MFriu6CpRPFp99RWcez6imnEgY5E8jpraWFHu93W
43266	payment	1775	1775	2047	1	1	17	11000000	1000000	65535	E4YZaffXFa7o9C7vDsdhHxNVeV5BQ1AEqonnxirpbBXHWCxxLZCHP	CkpZ7Ekx98eAafB9TZijwjMK9zpRL6f7oq4k61EBCzGBfb8DT43kb
43267	payment	2134	2134	1874	1	1	6533	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1STjRDKJ3h6Uhc6vpKugrukVo13dfQs5hSASvSpHcWv7L3yJQ
43268	payment	2133	2133	1874	1	1	6041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQ28ymVvGZEcPT3R1MUVffPsjXRE2NiB19W1BwxXZgREEhade
43279	payment	1397	1397	1678	1	1	16230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfnkyfjE7fZyAXCNejbqTz4ugFYh7t3dNtZ8b7toLHgW29dSc
43280	payment	1397	1397	1678	1	1	16231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwoJ8Zt9ozTXQkCMRLULemgqxSAPb3Nws7WuxuatawB31pzgn
43281	payment	2133	2133	1874	1	1	6045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbQQsxcG5VAKSbVRTEMFThxQ4r8RASfMXRKyjhfvs9ZSqWyTq
43282	payment	2134	2134	1874	1	1	6537	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtG9H2mHT2oG9qhn8mC4nA98afhPX2XU5yEQ2UcaewsPy63E7q
43283	payment	2133	2133	1874	1	1	6046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyc4x7oiWLn4RHiDPMok87HT87RSQp3MbSh1UN4KJ8HGk8AnM9
43287	payment	1397	1397	1678	1	1	16233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLJGFewRohS3SioBoXZFZjFN1ynHzt1QQna8FTda6qasaBoKb
43288	payment	2134	2134	1874	1	1	6539	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU69dnBQN313W2trEdPLs9WhmmaFvKDmfEb9btgKmfFEr8Bd5t
43289	payment	2133	2133	1874	1	1	6048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwF8Vx2gfhkXCSzNYS2Kb1sSfm8JxRKnZ7BWrAeEnrquwC2YYb
43317	payment	1397	1397	1678	1	1	16243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLUu2sJtNE7t4xWGxw5fiCMRnzathzEXiHtLeiJYWJ5Jc2fnH
43318	payment	1397	1397	1678	1	1	16244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWx2St6QZgkqGUBBw7NFRptKqCDkApZHewXc92iky1Fb3NtvJV
43319	payment	2133	2133	1874	1	1	6058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuSHYueS2baKM8crFhGwFgMDuaP2N5MoB1UVhGEiKeVUm7E6h
43320	payment	2133	2133	1874	1	1	6059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjFBDg4rQmkUFbqdEPn3QWmxLfQJksxiNkvM73bMf59Rrhmi7B
43209	payment	2133	2133	1874	1	1	6023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2f13ZHcoWQaDWPLFLw1VGzaSyFSZ2PWRyn1sFwagK7LAKgkL
43210	payment	2134	2134	1874	1	1	6513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSVGi7kNy2pEmBipu3bgFni5kaJ2QwLHn57RauSxmxUXgFjYz
43211	payment	2134	2134	1874	1	1	6514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9mknub7jCQXzpdmmwnFjrxnj3tA51AkPaJbBfLjSYHPDn4YV
43212	payment	2134	2134	1874	1	1	6515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zFQGek3HSj8wbaYszQVnjRKnt7QefYyh7mzV8pULGCxLrQtj
43222	payment	1397	1397	1678	1	1	16212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYriWSmicUgyDZ3GL6VpC9L6fQDR1x9ZGPptTmfBHqrk4T5Z96G
43223	payment	2133	2133	1874	1	1	6027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGiPQosqhhgH7zB1wsixjLEmppche9v8M4ycBLUouPYjvzf1m
43224	payment	2134	2134	1874	1	1	6519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrcmBLe6aqRVM6XicmdU7SSCyVMvHZwT7XBt6cZNuE3CLhbeUm
43231	payment	1397	1397	1678	1	1	16215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw1GfMN5iGTSTWJsXgSjpMNByeFVpLeSQrB3BTYCQz1YMLm9rq
43232	payment	1397	1397	1678	1	1	16216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxNvBTZWvwENETXXthyy8Ebj8gvUCXQDqAr3n7rd3Km5tmkYAx
43233	payment	1397	1397	1678	1	1	16217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93ZG2ZpujiRhGMmVptfMTdA6U76RvsCCsYBtFMuRbKe2Lz7Mx
43234	payment	2134	2134	1874	1	1	6522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAYDZfeWGwUqBnabZmYopMAeWmAQokvCSuY5NLYbced2SdUFpg
43235	payment	2134	2134	1874	1	1	6523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBnD6N9wR8VBNzwhvh4wXdPwGwpBjDpP1irn3c3iX4hqs33Hc
43236	payment	2134	2134	1874	1	1	6524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvFNjh4zHJgkXGPAniuopRnJMZWu9b1kbCysYszMh7mFegfU5s
43237	payment	2133	2133	1874	1	1	6030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtHabDDY3u5psunMAusn6Ugf6cBxZKXuz3q2MPu5jHTDMMeuUY
43238	payment	2133	2133	1874	1	1	6031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjgnNnYFnVgFizdEJpb6UU7BJNa99sMY5bFYcLcMS6wrXeSY9
43239	payment	2133	2133	1874	1	1	6032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkZ54NfqXkqEsdjf4eKiDg8SvkgKSdk6uuqRb49KaXsJMMV1y
43272	payment	1397	1397	1678	1	1	16228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNyzVj3WTvmeocCUxhGEdeDGQuy6DevHetNFjpYGmPCTR2Kiyp
43273	payment	1397	1397	1678	1	1	16229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1FDiUqd76Zix2Urbi7UErSqs2XgkcuMUD6XXEYWCw67Xkx5G
43274	payment	2058	2058	2059	1	1	13	200000000	2000000	65535	E4YhMeNTHQ3tCww7VpyVzN9x3y142UDNKZvBFpQurfMjuFWETyzUr	CkpYf5zQc4u5cPwnY5mpwZwqNCJNGBvyZZrRxwDFYhhQFBBTyxVgL
43275	payment	2134	2134	1874	1	1	6535	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kuYzsc2UeMu7C9RY33mqvEuEqkHYMzpjyiw3Fd6rtV8q63s5
43276	payment	2133	2133	1874	1	1	6043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9t8MhLhswMGmLN1c88ZgYg7vPn6RDy2tk3bQ2VApBtnbcgvDz
43277	payment	2134	2134	1874	1	1	6536	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1eWVvMH7dE6FU8aV6iDk34K6tzWXwqUg4J5drFD22g6pNFn2
43278	payment	2133	2133	1874	1	1	6044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNp6DsB566FTZo1XjynXaFA3H3J31wtTjRpRS4H5hvNULm2kw
43293	payment	1397	1397	1678	1	1	16235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3h5X3cwF9N1QX5suKAZFSApA1H3UFqaH4DhD8inxdPBprh3tg
43294	payment	2133	2133	1874	1	1	6050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN4VHyYwWvWxhFCkdQafWYJfUzjZfYcJTjFD3hBtdAhKZyXhVA
43295	payment	2134	2134	1874	1	1	6541	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj1P9Y3VYopgdRKnTrhTaFkmJxAihCXanbxjWdZYyxR3JZwijY
43299	payment	2133	2133	1874	1	1	6052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWG6nMJ3ZvnfKsD1ZCHaXgXHJ3Aegr2vz41QTndL77sqAipt41
43300	payment	2134	2134	1874	1	1	6543	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2UsHQ6bYQawvJANwyWb29naLvaMrpSiLfst12ecyUxRvyLUm
43326	payment	1397	1397	1678	1	1	16246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EEKXTZPMfRis8ZU3mEnN5dmGVpBeR4Ho3ENWfmtijtTUZYBw
43327	payment	2133	2133	1874	1	1	6061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWG9NQu7zKvNQx88bigfJnHHgJ7JrfzWuuSjCeTnmR5PtqfVFn
43328	payment	2134	2134	1874	1	1	6552	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLfpmBr9Cr3rq6XmXGSgxr34q2oxNA9j8bdh5k9HFftxqw7Bu
43334	payment	1397	1397	1678	1	1	16248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxdB7xQ1ETM84i1qoxBNN8zNbTzoFGnsh6376erBjg1c9TyLx
43335	payment	1397	1397	1678	1	1	16249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFsRzB1wWqeVgYBgVLXzTNF2hbeCWXCxPanbrjiykWtBEmWAVo
43336	payment	2134	2134	1874	1	1	6555	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUURwpBntWLmf9fyqRRPZfGpBxcrFC4PMkVqGVLXwyNk7BvhX4
43337	payment	2134	2134	1874	1	1	6556	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYapnksu3Hya3PEpjuUcB4eZ3TnWtRJQgjKDc9ojUuE5q98CBhw
43338	payment	2133	2133	1874	1	1	6064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAmmomZSCzw799FtCQZ7PyGBVzyDMXBPhofHtDME7tUjrNHXn
43339	payment	2133	2133	1874	1	1	6065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHd5j9wk62fqZ4FUpxXfwTop3i9W7xZmiSoQXJxcJEEUKFiX6
43384	payment	1397	1397	1678	1	1	16265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyv5VkNL4fxPAHqu1E4SFCZGsFgQgUoubtm7Ez9xNzVF7ipDuG
43257	payment	2133	2133	1874	1	1	6038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYms1gXoMSLmBumGy28mWoGw6uQdG9B3XWrHxFGYtQ2QP9scKBj
43258	payment	2134	2134	1874	1	1	6530	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpw4jjxQLTV1UJ1qc3XwRLHAXK7wjeWvVXLkbKcLzjjgug7KtL
43269	payment	1397	1397	1678	1	1	16227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYZGd9cwfsU4uAxinXZerLwMvweku1YjYcPzRRkMCoCk6jJWN
43270	payment	2134	2134	1874	1	1	6534	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPZv9KPWpm1zhHDAAvDmYU9ARTmW4RmjS7ZTJW4KDF89i4kvf
43271	payment	2133	2133	1874	1	1	6042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZve2CVWhKpLCVhKxGJ37wLqAmFd17SCdJsKmi2786Fc8UETnEC
43290	payment	1397	1397	1678	1	1	16234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxKPVL6veXuBcxfsVHDCfWLEFSER8DLZEfvAMTpjtjwntrNyJW
43291	payment	2134	2134	1874	1	1	6540	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4chdPvZ4ituuqphiPUbdFi6vxYpfoP2291HEC3KeKTqR4x9Gt
43292	payment	2133	2133	1874	1	1	6049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMbdzKRviPcvpEebaTxn41g2D6xRX5afn9MQ4C5Ey9H1Foo4c
43296	payment	1397	1397	1678	1	1	16236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzc9epubJrzW2NZR8GfVWPQRFa7kCynzoAzCWffELRxKr9CnD
43297	payment	2133	2133	1874	1	1	6051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE42qV6SoZL96UzXTtuc9ygbnEVQ5Ksm7FkqvgX7MLUpYho3PW
43298	payment	2134	2134	1874	1	1	6542	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa62vM7V1CgrVNcEnWxWJRqyAb4im7pEuBGAY2Duy6CnxYbNtXr
43301	payment	1397	1397	1678	1	1	16237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZNf88qxEeNUUj6M2Ss1f6tYEX41a2ErbqeaGWo5YEfMk3tirD
43302	payment	1397	1397	1678	1	1	16238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MHAY81kRCUbaWzmT2awD77eW2LtFRooDNTHukgMkzTuVWiCg
43303	payment	1397	1397	1678	1	1	16239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4cX5ihD9GNrFFXhQ7W9pqHu8AqA4ZTqqc3RKqv18bq9paPEXe
43304	payment	2134	2134	1874	1	1	6544	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdedRARKB2ooizyqxoAfcSNzN5d6f2qNcyncq7jk8Q7tg8Ebd
43305	payment	2134	2134	1874	1	1	6545	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7s2gYLyxzmm9tK4S2mwYYuy4qDxKbyxJse6w8CNmHXRHN4k9
43306	payment	2133	2133	1874	1	1	6053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyNRBBtB7DfMHoRxueiE7Q64e1zaUMMhJeKmy1xrBRsXejxwb
43307	payment	2133	2133	1874	1	1	6054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwEQiayNksEacuVPumnUBa1sbAnkQHU9PfhxTwNFWjrjzAvpm
43323	payment	1397	1397	1678	1	1	16245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWULUPQKmUZ2bzmqB4emN2zjaph4ibhgE2jbo8qDcQqbKEJ2f9
43324	payment	2134	2134	1874	1	1	6551	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTGoYgoVKaX67vV1T63iBuhsovMdmw8th1H24G4PzaCSuXthia
43325	payment	2133	2133	1874	1	1	6060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiSHKuPTvmtu4sHpagGHzR8a2BgBCMTgMyQuYQMMCkUeMVMaH
43389	payment	1397	1397	1678	1	1	16267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYiGi59qJcRN7Q3VeAjAhumbR6pgh7hzQgoNnNJgkUi4q6Pfz
43390	payment	2133	2133	1874	1	1	6082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbR2tTmfBnsBBqy3ePs94nApMhyS84ndRAZn67Z2KVL1LVifcj
43391	payment	2134	2134	1874	1	1	6573	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97BoGrLEDVfKkQYiiTxefkyoKVhtPEJLhRFDjjAHZoiPmUWmT
43398	payment	1397	1397	1678	1	1	16270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcY11ZPmo9eAjVjuJtChZs1hJds6RGH11XHwFJHyd8Fhn94mQq
43399	payment	2134	2134	1874	1	1	6576	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJ28pxJqtyyoWPtxKD54p9pcTAbe7H1HeCuKAra5JYF6qcpEv
43400	payment	2133	2133	1874	1	1	6085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkjafe2AkQfCAzLfs791UVbMtxQYz4mGtLPiMLmgQoJiGAASVw
43406	payment	2134	2134	1874	1	1	6578	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhGHcnNrjoD9itV7PJwDEGLrjyLYvBSEHPBf8SxAp2kXGgooH9
43407	payment	1397	1397	1678	1	1	16273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWvFpvnBwS2yFT8jdhry6LK8gb4au4N8afXBpaP711RKBDD5j
43408	payment	2134	2134	1874	1	1	6579	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgcWp8B7ofhEXcUxc9QunjCp1qXW1ztU27E5WwbPuBbH19xmYh
43409	payment	2133	2133	1874	1	1	6088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLWPsy7o2wGvjg46zT4vCuU1hEMDsufGiPcnoiVhSzRWHNcxw
43410	payment	1726	1726	2370	1	1	8323	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaEbUz2kZz7tNYzchqCpVsse5mktGZHWTs1C86PogPxwziiGNcC
43416	payment	1397	1397	1678	1	1	16275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLc2GWAAUh1u2k1UgfWM4duDEzrifDQnTkzdt69nX2abwEEK1
43417	payment	2133	2133	1874	1	1	6090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UH5FPdMa6E1X53kLE2fF4DAYXxE7T35avTyeW5wHkcfar3KL
43418	payment	2134	2134	1874	1	1	6580	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUxXv4fkAqyXDTeKGzzza69n5E978kHQmuetLbcfRhDhbSDoU
43425	payment	1397	1397	1678	1	1	16278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTb7yhELxkZW4vLQZjV8aF9qnKQGydp8a55tkGGLn2LbvoaBp8
43426	payment	1397	1397	1678	1	1	16279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLri5hxkVazcXwn2AguhkA5XGKxBu7fADAbMSrTNRF5eRq4nJ
43427	payment	2134	2134	1874	1	1	6583	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuGFbntX1C1XzY6nBRuNXUgs4hkKchkweH4A6Wg2gbV7bnrHw
43284	payment	1397	1397	1678	1	1	16232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbiQBQHdTWbKSScghB3QS4rdcquFmeuzsp8YTxYFFr9op1qUQq
43285	payment	2134	2134	1874	1	1	6538	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWth7Nx3W5Aphpz5EBsv5wLst81mqhy8kSjoxNzQLh4eB6SEkc
43286	payment	2133	2133	1874	1	1	6047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNmgB2moDsA1Pg8oUJVufdFfNkMvDgA6nDwZ7rpaJ3cA7WkRt
43308	payment	1397	1397	1678	1	1	16240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KHjAHAwAmaKxDLNEDLfmBLzgYVn1bCUDuzVX1CddaKrMdfnd
43309	payment	1397	1397	1678	1	1	16241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDkeTzoZ91po89ppithCSvgCKLJpi5ovJwkNV9VRQE1NmvEb7
43310	payment	1397	1397	1678	1	1	16242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQiLAHEVe5Dv94vmgbPT6pVUEFDjLmoXTW6Vx9kC7KBwD5W22
43311	payment	2133	2133	1874	1	1	6055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmaCYtdn2zn5JJwh7oQbqL4Zux3eGqExLjRMPAnLC9MC4BLrsG
43312	payment	2133	2133	1874	1	1	6056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZarG7aQqQHnkpv8a7xgZNceA1hzEkbRRiHXwdgUFa1EzQNA8H5
43313	payment	2133	2133	1874	1	1	6057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvDBfXHJTn2Vkvj1QAuqVkQRpWiXZiwBKhwrYjdshwQzC1dLh
43314	payment	2134	2134	1874	1	1	6546	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wWU4iQsfubkQbVMTwbiNy1fn4GKHbQsUCgh9b5FgniGYa49L
43315	payment	2134	2134	1874	1	1	6547	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvKKcikfJXGiXSgVPyLSQpu69qxMCWbo43qcVtg6rwnSE7uCx
43316	payment	2134	2134	1874	1	1	6548	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCSKz76RVYNfZRp7FDfMYNoDSW5eiWFxVy7jWpGLrHihF4Ar4
43329	payment	2133	2133	1874	1	1	6062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvZGqHRGrFe1iAXmWVXa1dnMetw2PfH5gdpzFCkZwKTqbSsqG
43330	payment	2134	2134	1874	1	1	6553	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QyfSxTz593CSdY8kKNpHdw32oYzguLaH3SB13o91xfY2TyNv
43340	payment	1397	1397	1678	1	1	16250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm664132L2UNextmNCHXMk5NSRWV2QhccBEDEjRomkdA2Cukw4
43341	payment	2133	2133	1874	1	1	6066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFW2EYnak4LSab3kjnHmKvbh2woHqvWxPWATP3nzwkWkDneP3P
43342	payment	2134	2134	1874	1	1	6557	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmfpxJdY35pJcqHfX5mFF6AR4qiES6vxT5tL1u1Gc9sH1rYqz
43360	payment	1397	1397	1678	1	1	16257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZChTLcp6RZdcAb9opRVahuNRb9dd25F39SkPQmZzEoQrjC2V6F
43361	payment	2134	2134	1874	1	1	6563	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMapa2RgwLd61yqgjMx3UhGrZYNGqXM8V5zpeMNMfskZEcNzz
43362	payment	1397	1397	1678	1	1	16258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DfvDnCXRD78ZSVcweX275D2MCuQXpFqSPmbGLnFgVW2NJAV5
43363	payment	2133	2133	1874	1	1	6073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWu28CvTjYVS9UT3uzpMv8CdpseGJKSjnwJiDuQpSBbtSou4m
43364	payment	2133	2133	1874	1	1	6074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWorBBcLX47CMVGqr8vGmDkeb5yWna3PDB9huHHr3BHJMZioUz
43365	payment	2134	2134	1874	1	1	6564	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoMScWyQWpcs5BB943uQThYc2KThWtUfm5DCH8ZhoDSa5HXgum
43369	payment	1397	1397	1678	1	1	16260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr88PPEeoBHivS25E75FjSCSPJjZLqjRY26BLowU9NQwVHdEqU
43370	payment	1397	1397	1678	1	1	16261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh9f7qMG4578hbYdVU3TivNgsb2pUNCLcK2QoPQgAAderSnVud
43371	payment	2133	2133	1874	1	1	6076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JTg78pwzZ4DF487YLy2JwSbsBnm4UAG5AqeyrvTNLYtD5F8G
43372	payment	2133	2133	1874	1	1	6077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDCpHsHiLuRabwnqzQFj3tMpQT12q7pVw74TkSNBvrGszoFdF
43373	payment	2134	2134	1874	1	1	6566	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YF5q3N9bSckhrSdeE6XSPAYMnc3m52vngwmPrj8LPuTALSTR
43374	payment	2134	2134	1874	1	1	6567	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3BUj3R5vhSNahZwcuFRqXJjPg7BW7Y2j4tmXeHKdMBaWwobo
43375	payment	1397	1397	1678	1	1	16262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzoBriCz67MhmJ3wSKSV9jrhhP3sTnxTXabqnDHnKhJwwUtcWF
43376	payment	2134	2134	1874	1	1	6568	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJWtBmYxv1T5iYhZziCgFefM29PJqXizcL3QXuKtRi44aG2aG
43377	payment	2133	2133	1874	1	1	6078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoWFzxKMnGgtzuMXzThFeD8ABgYjU1WWwkFnbBJhCd55Bwdc4
43395	payment	1397	1397	1678	1	1	16269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcetAKc2QPCG7amYwMLs2UH1jGNsxjGy7U9czhT5Mrfr8XDWPx
43396	payment	2134	2134	1874	1	1	6575	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzDhoHLnfR5y3cZmffjyjk9zDv19wpdiuRdnsLKX1rKJRthcG
43397	payment	2133	2133	1874	1	1	6084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvXsWHcCdCkxKbGLV2ArSP8MWL8q85uKEe3nG28QGxGLZJ89hg
43419	payment	1397	1397	1678	1	1	16276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDCZ98AQF5UqQR954mz7UowCwDkx9ZN6GUwcFnXZcCVJNQcxZ
43420	payment	1397	1397	1678	1	1	16277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAJA8dJ65rzvRsm6VD53RtX1Dz2m7bKQ7LYarzPVzbkAHcM4d
43421	payment	2133	2133	1874	1	1	6091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhANCHRMCBhcGhAZJi3f8FPJJM5RqEygCTbiYCLaekvLpne72L
43321	payment	2134	2134	1874	1	1	6549	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2oQStPEbL4zLqk8dx5exjEfd1vkZQ9RdR73SAtZVVrCndBRBW
43322	payment	2134	2134	1874	1	1	6550	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvjuE9EGJeSEYaTfDLRyiaKct1UtgUBErigftaQmBQGft1j1K8
43331	payment	1397	1397	1678	1	1	16247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSZWi4hciNRwvZkiKrthBkC4cdrkHvnxymPP98cpGDeP466t3C
43332	payment	2133	2133	1874	1	1	6063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4b12qGk6Dm4noHu7eBqw5nHNQx3Ak4sawzX7dUdqjD8orVDZW
43333	payment	2134	2134	1874	1	1	6554	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMU1tBPLGXkR5yVkUJ9sz9QnPTQAPjocwC75BdazhLu9f8BuJ
43343	payment	1397	1397	1678	1	1	16251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVac3kvwthuGb8uBNKyNDSKEDDrwzZukHs1izk6iuTnPBzz1Z
43344	payment	2134	2134	1874	1	1	6558	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ48FexZwAFYxe86HVTkYZttuQP4MSgVdYj9oALNnD8HSZDwSZQ
43345	payment	2133	2133	1874	1	1	6067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHooCAiCnudvHViqjeYDETzKcfDksnx8Qkq6Jr3MSM3KzSP7H
43346	payment	1397	1397	1678	1	1	16252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KNPL1sg79y34gr2X2yhNEqkFHkovHknUMWhahLDZj2WnLr1y
43347	payment	2133	2133	1874	1	1	6068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgq7pmo1NbhN424YBLyPFAfQW6CAzSxskxyfRrjHPFDiAY4J4W
43348	payment	2134	2134	1874	1	1	6559	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZknaN5C4yS1YwESsbUcC6311AuDauKBUH7vujbu1G2UuxZRxNw
43349	payment	1397	1397	1678	1	1	16253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBruamuYNTVwVPsxUCfmUhm92rsuAqYqkoH4Eaf4CyanK4CPbz
43350	payment	1397	1397	1678	1	1	16254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdtNa18tLcJ8gHPq1HLdC339pWhe1tcrwjyk1CY8VsbSTQgS8d
43351	payment	1397	1397	1678	1	1	16255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6taF8gxVPqFw5okxuR3WoPVvgmaAtdcadWuivHoaePKx92rnM
43352	payment	2134	2134	1874	1	1	6560	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrjzuhpkiD8wGp81p5QgLK513MFs8zRyXi5b3mB1cSiMwgGAZB
43353	payment	2134	2134	1874	1	1	6561	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc45qBArPufSryJRWQJXJrUMshLwM9UYEgkDrax8bYqcEsREMD
43354	payment	2133	2133	1874	1	1	6069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZoCM4n95AXpH7sZniiVQUXsgR53Q11CgJdyhwDLTQWREiJFZ
43355	payment	2133	2133	1874	1	1	6070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDviVn7CnY8eRPvbFPvJWvB2cD2PqMnfpEf9HXp2nZVrXXw9ye
43356	payment	2133	2133	1874	1	1	6071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8w3rR1ehSixJjGVwryBY3gKSzveAwKQF7sy3q9o7A4VLuTKd
43357	payment	1397	1397	1678	1	1	16256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvPtunkKkL1H2WFMMWdky9Zn2DA8pXGJTMJzNuLtVPqQzmgnYq
43358	payment	2134	2134	1874	1	1	6562	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXa5m4WsdLdFE7PWtBbJV1JmVFtUW9tYsN8yDFD5zJTA7XhaHF
43359	payment	2133	2133	1874	1	1	6072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cQkU9t5ByqnD2of6uaDyA2KBSnkBsX2FiRKT96z4mGGHFq5m
43366	payment	1397	1397	1678	1	1	16259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiDhQyY88XTY7a3H3Y88yfusEiZ6VVvnSmLmNfrZ6rrTziZYEY
43367	payment	2134	2134	1874	1	1	6565	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUouq15uYSNy467ioyhdoApKNN1gVETXzUnJ2ppA2fyAyfdUBd
43368	payment	2133	2133	1874	1	1	6075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiSC53esVQcp4UpRbyQBDKqVWUbe2BNPkG44R6Vi5AdskxNtmj
43378	payment	1397	1397	1678	1	1	16263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYckDdheMrLyAWsBBY3ovRj5rbpkGHbyfcSoDvmAf7ctmb4bity
43379	payment	1397	1397	1678	1	1	16264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCXLVJya1WSMkRpMRUzbTgBJrHNsBSMfcD9mLbKrEAvkeGUqDg
43380	payment	2133	2133	1874	1	1	6079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNq9uvHNuhh9bBG8knd2RhKwY9JPXn3LAoDWh165K74z58ZteN
43381	payment	2133	2133	1874	1	1	6080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLJDeCAoNaHz6ReKYGvHaACEBpzULsptzmCDQCiNqU1gSS4wg1
43382	payment	2134	2134	1874	1	1	6569	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe8jjSbkjYySEVVpGJFMvoFn9EiAhnPYC7U2DxArVcA2SKcWWV
43383	payment	2134	2134	1874	1	1	6570	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYW4PTVpV38qHeWWBvcAmT5DNDpCZThN7J1bRne4HuAAH25f2V
43387	payment	1397	1397	1678	1	1	16266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRM3srxywc1bjBKPYdFGeGkwse2SWSQuvevGZ6MXuvZq1RwUd
43388	payment	2134	2134	1874	1	1	6572	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQPWmx9e9ccpinxonsDm3sabwbWLzMHdKf1waaWTaZUDCzbax
43401	payment	1397	1397	1678	1	1	16271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7goksprkvTP2HwXFsSGmWdjfHcWsR9ZKvDyzaEeXr6d8VEfux
43402	payment	2134	2134	1874	1	1	6577	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJJNsNB2xF6gDzqvopeqhZNdvCUUMoe8H4nFA4HoAFjvYNjRF
43403	payment	2133	2133	1874	1	1	6086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFe5sqGc9qxwmzryk4Df9hgPUbKtSm9gyAdPR7QEjtq2f8CJyT
43404	payment	1397	1397	1678	1	1	16272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSRDjvELv9VU1LQhSXC3H9mZB2vQCZa5TbCZbu4WVhBB5Dfx1
43405	payment	2133	2133	1874	1	1	6087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTjT17u4gwv78RYyqaPL9DqvCE1aVy3whyGW8KHjzbZkfdzyH
43385	payment	2133	2133	1874	1	1	6081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtLKbWpu8bHEPNJHMg3C7M1d4rKNg2gACrot6qYsRR7VXy8Yo
43386	payment	2134	2134	1874	1	1	6571	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4FZBcv3ooVoXrpkdRvGzcSqqBFaVvsPRKm7WckYtNjhcMou4
43392	payment	1397	1397	1678	1	1	16268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArAUFSrxiVBx35UmQWsKCVYQsBgctCE2Gj3agc6gyLjVXS1ZT
43393	payment	2134	2134	1874	1	1	6574	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRpiwGKEJEd6bsLG9T6PMteikFw3Y2JpfyvPz7aCsK93dChaY
43394	payment	2133	2133	1874	1	1	6083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJzMYiia5czga14AoKrkBXHefhESSzjMiznJfAG1RFv9Jyj4P
43434	payment	1397	1397	1678	1	1	16281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ZvwBq5XUw61DguwTapYGTnbAF3xu62mMi8RVkP94sB1yYdiR
43435	payment	1397	1397	1678	1	1	16282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1XfkHP5cuK3yPZ5hBbZmmLvoc8vWJzai9yQSKFpZng8xUXAP
43436	payment	2134	2134	1874	1	1	6586	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PDVDw5wBxXTULyALs7ZB4ws57V3FC9KRhsRFRxeJEZgnjLwo
43437	payment	2134	2134	1874	1	1	6587	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqYbm5tungcFuCjjYYUN625aTHSj2qycEMpHn57oU3AEFmLuM
43438	payment	2133	2133	1874	1	1	6096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDUR5ZZFrcxxkZaJiLs5sSEb9EgVV6qusZ4e6AUweMdK7ygHr
43439	payment	2133	2133	1874	1	1	6097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSwpnPzbPaEtd8SJvZNPzET9zQTgKfLWMBybJiPSn3ZbWd6LJ
43458	payment	1397	1397	1678	1	1	16289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9paHVhQDK7RG1Nh5crp6YoebMw9hJRfp8uivERW6TwYVPppAP
43459	payment	2133	2133	1874	1	1	6104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbEbKiWK69SMpPD5eQzMvbwdPmutU87aMempbhAv4iW55fthN3
43460	payment	1611	1611	975	1	1	13	554780787792	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZjSEAX4p4htMYQhWG7o7W9Ha6hPFgdYUw8W1Uaj3r5gVcbN2Nw
43461	payment	1611	1611	1095	1	1	14	994162418364	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpYaWsoRXqYriM7hYpqkhAkAiKrjZje1nDHkqGiWcLJ6AzvM9hv8
43462	payment	1611	1611	1215	1	1	15	670781193756	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZnT9LQEE3hSjxFUGgU1HwfgVAFZ3d2K2JndPVH42oAPBu41iG5
43463	payment	1611	1611	1341	1	1	16	1869191438946	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	Ckpa3HtE1YAVSuRybYpQLogi2Z7oSmuTe7RzgZGTDk1eFSGW2cF3p
43464	payment	1611	1611	1611	1	1	17	15158261124	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZ6WJTUhqUdXbAhYZQxEDy158Ttq6Cm8AHFqbcwsQHWEGWiwo4K
43465	payment	2134	2134	1874	1	1	6594	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKe4Rex1wjfoEagMjwqDFXhGYcpHvHdmqtcHVMpWNiQL8pAQVN
43484	payment	1397	1397	1678	1	1	16296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6exFon28v12VYKr98qLCjobqvnvVi9oJnHMyt9gZmxGTqph2n
43485	payment	2133	2133	1874	1	1	6111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdyCj5VM6p34oXtcLceMZbZraE15SUmkiazHNk2yQB9u76gLkN
43486	payment	2134	2134	1874	1	1	6601	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ixTCrJwJgN32u529njkSiEgLfuTWG9JQTYVj1h4zrKPnMPaT
43487	payment	1397	1397	1678	1	1	16297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWZuwpNPRDyRsDrpnBUXHvXk2rAC1jxEyssuWDqBBs1cAENtW
43488	payment	1397	1397	1678	1	1	16298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hgJPSRxF6m7uLjgQaEnAxTCMqzMbSvxAShkfVYHSQfv53xwr
43489	payment	2134	2134	1874	1	1	6602	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrfsMfEvtZdPZCpdpY5tfacaEkjBiPPHgrMSikEMDZ5Pte5d2n
43490	payment	2133	2133	1874	1	1	6112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokdgLMqm4qCEH881pu4uoJBmbqRbdKeYquugAgYgmhbpr2kLZ
43491	payment	2133	2133	1874	1	1	6113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRsTyb3xCTxxd624iR4A98rc96TSSHimt3poBJdd6HLkJjSPMF
43495	payment	1397	1397	1678	1	1	16300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn4NYNkgf2WgS23uBgmrJzELutjx2vPyZykhtv7ULVG8sBhDzE
43496	payment	2134	2134	1874	1	1	6604	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJ1LyHVtSCbtjZ8MYpaxH9qYv1dfm5E4xHs8EmnWLVtrG3tZC
43497	payment	2133	2133	1874	1	1	6115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7sSPisfYM7jjJwHqgvWHaYvxKH3Mm2W2CcFo2L5PaJRQvXQT
43498	payment	1397	1397	1678	1	1	16301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHo2jv6ybWxSL4tMXHAbTbpqtqiKGxbKjMSGhH6aoxybtsa1gu
43499	payment	2134	2134	1874	1	1	6605	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWEmYuvPDNZUtnmGTexBifZkB5ohvJUahXoXn9WeYxpycTWsx
43500	payment	2133	2133	1874	1	1	6116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZQkoqdyPahJLcMTiJ6u7JXBDE78wC4SyNctc84AVABQZ8Srd
43523	payment	1397	1397	1678	1	1	16309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdS44kVsM8GXDWGeyF7qk25NrvsTFAgaJTE35nVJf8HAzpXh9
43524	payment	2133	2133	1874	1	1	6124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrbciAjMEuYkCPm8hPHugRL3meFWtJ6dihemQneGzFazRD891D
43525	payment	2134	2134	1874	1	1	6613	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2DkLf5Atv9capsipNpBefpQcTvoRUB2JTcUxsAmkQzNkqczU5
43535	payment	1397	1397	1678	1	1	16313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFRa5ZgkAqK785SYLpcV4dHeUmw7CeCvoN6pmRfXMCBbUjviH
43536	payment	2133	2133	1874	1	1	6128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mWU5NxAtBvF99VQvWZL3aUajMn1jQziDa3Twzyr7uH4kpnZ7
43411	payment	1397	1397	1678	1	1	16274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCNNcz85igKf9SGUFLm9263jWAvSwkg3iTtxtq6m8UYTvR7Px
43412	payment	2133	2133	1874	1	1	6089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2a9v1t6AKawBguNvvQQpxH6VozKcYiVZDec12guD29GRc3PZ4
43413	payment	1726	1726	2371	1	1	8324	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaCwZR4kTBDcceejpbX7uyHrMn2DjW1PdGViRa8j8cyzitHqHnz
43414	payment	1726	1726	2372	1	1	8325	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYsMu3P1DtzfwejxvDqYCMwTkSJCu8iCTwLT1Ev9wUnT2cURgEp
43415	payment	1726	1726	2373	1	1	8326	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYRuNasUdySMPkNmgPF5996JEEMSjRu9AUycNhHCoUDpibQMNyD
43440	payment	1397	1397	1678	1	1	16283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUxeoZiYxXz9vhRD4VdYxvKR87yn3TnB9UNmFvQkZUGs6tGhS
43441	payment	1397	1397	1678	1	1	16284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrX6okC3ZZqi3NBZfCF4NHVsk7rY9jT87bmhsbNkMGPcnd7fMx
43442	payment	2133	2133	1874	1	1	6098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamXLQ1EbY5zFH6vids74BioPvgprL5HfNWbhq6HeH8NzGwVTd
43443	payment	2134	2134	1874	1	1	6588	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYes1fWN1qeWedFmvLGNZoFwhcRHiHMczAWwzTaZ63uJyeVuTN1
43444	payment	2133	2133	1874	1	1	6099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsQ86qwiPwCWBoF5vHuQRGJWjpFNZjoBTwf5gF8BT2Bniw5Ku
43445	payment	2134	2134	1874	1	1	6589	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTEV3p5knKJD24yeVhJopKWrMfwCm85M85vKbiKZUVHctfFWQ7
43514	payment	1397	1397	1678	1	1	16306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFY7NAGBv2S9T91Ksuieesw4amN2N91aaZXsDjikJFMZ5z8Yi
43515	payment	1397	1397	1678	1	1	16307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxvCeaM3iMrEfb6z1dbzpLW5MQuiRSnexyWwCqgGtjmd5r3fW
43516	payment	2134	2134	1874	1	1	6610	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqN1RGSLumXWvvzhL5MyvSZbWPEab8BgW2s8f6J2H2RRUmzTb
43517	payment	2133	2133	1874	1	1	6121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHH5cMLek3yddyAMRq5prHyxFfrpmK8G4BYG7Bpg5dkibMewRk
43518	payment	2134	2134	1874	1	1	6611	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgb4zEmwG3bu7u34yVgm7yX5ovfrmGdpT96WGDbuiHb6doT18U
43519	payment	2133	2133	1874	1	1	6122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA47c5569XtNWdm6wgdPTGdyNCjEUn8hdQYAgNBgd7BozDnkce
43538	payment	1397	1397	1678	1	1	16314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeiJG3Judm4NRDDaSERx4ogqiTj9mRHEM7nYkDPbDBDrWRMTN
43539	payment	1397	1397	1678	1	1	16315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQbe5RyhD5DgrY8TfWZ6UV1z62ro8Y88FnFCuBLzAEnEskAB1
43540	payment	2134	2134	1874	1	1	6618	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcX4iLaLHz7AGJnw9ukVF8LN6pGPMfDfUR5iZtqDKnB2bfZkr
43541	payment	2134	2134	1874	1	1	6619	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1U3vCJoUbwHjzz3aWBP9uW9kn8iomEha3ajHk2b9Rbt8DMSK
43542	payment	2133	2133	1874	1	1	6129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBA7ynBun8aV2La8jh9AidsHAUCTgCDvs8cCGy9qBcCxsjhuj4
43543	payment	2133	2133	1874	1	1	6130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTefT5c2GGX3kdhxXQWR9tTeKUZDK2WrVGYG3X5vC8vuFCU3bA
43550	payment	1397	1397	1678	1	1	16318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPtsAE6P1SLMD3gt4rttw8sLFVaMzFog984Kq5GqNsWMioH4n5
43551	payment	1397	1397	1678	1	1	16319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2SjM2drieGvVpQnbcGQJGbqUoGnSzNFXyxNW4NBtsdoRapS8
43552	payment	2133	2133	1874	1	1	6133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1Ao8bR3xzGAAgq8UCANcq6zSFHs5UDfJZzkEhEZ5Uk84Q8Pf
43553	payment	2134	2134	1874	1	1	6622	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnouMJDUrz5JS1z2qjjR28Q1kCF3Ph6vVyxi8XPPp36VTtfqqK
43554	payment	2133	2133	1874	1	1	6134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnxAopB7AC5d2FBH4LKvbk1sSNXs1GyRQDp6Z51AnwbNbQChdk
43555	payment	2134	2134	1874	1	1	6623	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJwW81pxQPZPLemRPjidEbF2DaoXEbS1KodkuV3eAi6QgfTd9
43573	payment	1397	1397	1678	1	1	16326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5oMz43Zfnrp3YAnsPtcKsuespXTxGSNJXLFbmhLwCs1PC3Gmy
43574	payment	2133	2133	1874	1	1	6141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi837fiVAm45t8e2u4ixURSUreks3ECYFpZpDVmhSgyxkAHuRS
43575	payment	2134	2134	1874	1	1	6629	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqW4nJReiEsA5rnvayWNwjSDG4psPDjrqfipci24cK9UdBe1NP
43579	payment	1397	1397	1678	1	1	16328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryJW4L5CYLCYvx9DrRkiK72yYHhznX4MC8rdWbqrZPJ4yYyDo
43580	payment	2134	2134	1874	1	1	6631	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHy9FTVQbAL1TJfAbfdTrjqtE2mzbEWLRQD2ioEeoKgWGEVcos
43581	payment	2133	2133	1874	1	1	6143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGM7Pr5TVjd6UpPn682GrXz72hfa2b6QmdLwPFjyjn5qZ4paC6
43588	payment	1397	1397	1678	1	1	16331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTAkx8gdjBmv3EbWZGBbztMqWSLTAwAykg48MkuQkLKQpuKDS
43589	payment	2133	2133	1874	1	1	6146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh3BjoQqmtH8PqEXJsuuzaYeQfqiiHLYrQZp1wFs4wiyWuPVVw
43590	payment	2134	2134	1874	1	1	6634	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9aSzqxtigMqYXQr9t36hma3JHk3Vg8UbN4RNVXdjHmvcTMRD
43422	payment	2134	2134	1874	1	1	6581	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyoC9Up6KnvtUtFpLmT5856aVxX45yCoNrBpkvviETrL9fg4mW
43423	payment	2134	2134	1874	1	1	6582	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYewpxG732MZrUD5m7qUjHLHYnfbwWE2MuBsALb6jw4PUbkQDiF
43424	payment	2133	2133	1874	1	1	6092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3Nu8EG2eKybh3z1aB8inuiti8Z6mzz6zKjkquC5C6ni3hfik
43446	payment	1397	1397	1678	1	1	16285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRYvF3CNktV9tV6aRiqeLhwsBvpLNAjypkNdJQwH3QpbBpstyA
43447	payment	2133	2133	1874	1	1	6100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZ7bvJVFxjSB5E3cGfZVCmFNsJDYEuXQNRq56YRogdYA3ZBRa
43448	payment	2134	2134	1874	1	1	6590	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibzd7h8NmFcdKZKFstASAUBE9QUTwGTDnMiSrP1j1apy7uGGY
43452	payment	1397	1397	1678	1	1	16287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMjPmgqUtbwTFtYebXTwdgR8VwBwQewz24C7T46q3wBiXJ8fD
43453	payment	1397	1397	1678	1	1	16288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpsdGZQKbcrMZMTPMpQ14a1JPffYv7ELyhTtULRrfWTp8wiKP
43454	payment	2133	2133	1874	1	1	6102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhejCTWNvxabHxuaRytRp1FzBbeefk6FxAJFk7V39a6CppfHy6
43455	payment	2133	2133	1874	1	1	6103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpDkbyyGRDTFs6TWtTJhDV8AuKojxSpvno6RKpH1fe8YJ6EGS1
43456	payment	2134	2134	1874	1	1	6592	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp78jxa1hy9tJ1pfrsVQQNaCi7uj9StV9shYDzzc3zBZ61cZXr
43457	payment	2134	2134	1874	1	1	6593	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeitdmocC3dFBzHEqKry8aCY1ioUmkNCv4Ke1wQbw7v4tZyxx
43466	payment	1397	1397	1678	1	1	16290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZAU7sdUCPF8NN4qYGMD1spuuSRRACRUiCMB1Lksgxr4qXYSze
43467	payment	2133	2133	1874	1	1	6105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbwaPBfCs8KGDBpoprzWFMfsGCY5JxKN9YsLNFY8hbHVGqewr
43468	payment	2134	2134	1874	1	1	6595	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJzixwGLkhbswLWc9r5gMqpk6zuXtmWewmfcWtYMKM2yU5yUB
43483	payment	2133	2133	1874	1	1	6110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFuSM5zTtP1WQ6uA9Sb4Ebu2A8XA5eAjvneMw2BzSHbmDQKT1
43501	payment	1397	1397	1678	1	1	16302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNNhKH5eUShfqAjbAMVStn1c6dSc8JY7j6DZUGf3oKiqJ77ea
43502	payment	2134	2134	1874	1	1	6606	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjKzNDCur8FSCMvqyijHeHU3TDvgqP1vciEujENccCG27MkGy
43503	payment	2133	2133	1874	1	1	6117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXP4yChGhPhGncCdF41hdwPcFrkYTwudRBJa9vovFU1gmYqHBh
43504	payment	1397	1397	1678	1	1	16303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5tzMZpZZTKSLZ9h4iwMbWFPpZ47aPZoWjR1SEXL29nMFwhJn
43505	payment	1397	1397	1678	1	1	16304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcrkXv4zMEJZq8P1VCPdgPX3HjUEwvAnsEzG1NQ2EPHwNo1JdR
43506	payment	1397	1397	1678	1	1	16305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeV6fdYZLKMTLAtFF2HjV9n4w1B4Fp85SPRp3JeLKSRLmqHxCe
43507	payment	2134	2134	1874	1	1	6607	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHTijiLqY7wRGqGeLdZ6aStAKcuWqP8hqPyZRpTeXLPo6CyBa
43508	payment	2134	2134	1874	1	1	6608	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmyNzeLoZEu41NW55czgzdhnr8EzXDL2sM8CqYSCKMQowaNoX7
43509	payment	2134	2134	1874	1	1	6609	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGSofBor9x6ymqg6WnEqvxSSvASmr7DpSae62xJfiyLhsHcKC
43510	payment	364	364	1933	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZa685E4qTXcwUdB54Sbyf59de8r1QvngevRWHQHqNfMnggbd6
43511	payment	2133	2133	1874	1	1	6118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vj3DM5qwnEQzpg7rWkfQ5QfSujvTTFtEAzu734b1kgk1G3EA
43512	payment	2133	2133	1874	1	1	6119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPdkpF1zKt5QTDSbUWoQtXfcsuZn3jZ4JmdxdmSAHEH7P1XkE
43513	payment	2133	2133	1874	1	1	6120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYk7V2YorQdFkYBvyUZePVBsnAXLznTozWNQcK1YTUHSoKD8iP
43526	payment	1397	1397	1678	1	1	16310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KS8bwAjnDjyzZejYwajFKCzohqEVgRGsrNxJf5X4WtjkkL2o
43527	payment	2133	2133	1874	1	1	6125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUsSHdJtc69rxCHB4VWmVunLXwyEcj4J5jbFsRc3uuQJ3kwvp8
43528	payment	2134	2134	1874	1	1	6614	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1H29GXLZ74PQhKxQ54dWucb2f3TFfueKCqoNa2TofBT2zpTq
43529	payment	1397	1397	1678	1	1	16311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5k7WiEBB6vv5Atb6vNA8hFzcV1jx45yC1twsbZGBqsec8LUY
43530	payment	1397	1397	1678	1	1	16312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZws6ZGLyL7QSAUb8QMVLdZ7h1iuSTqo1JkLvsS5Z8Fk54E8Hu2
43531	payment	2134	2134	1874	1	1	6615	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBx3rx68JksXNNYicTokJT1ueVurKuk5dDt4ebP96tE2jivrmi
43532	payment	2133	2133	1874	1	1	6126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtA1ccAkxkYQ6MjMtvigo6c2YrDa6AivzpHPxpeoToouMW3P2u
43533	payment	2133	2133	1874	1	1	6127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdzEj4SFsb7fCZHg7sJ55NxkFKaQ4LDAzzZpfM2JrCjFpxjyt
43534	payment	2134	2134	1874	1	1	6616	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtMFNbYi1zcgqHt8hSsMNrrcomGrAdiafTPBYumEhPze1D5LY
43428	payment	2134	2134	1874	1	1	6584	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVko5ojuR1Q1YjzXEXzr9GHEjCsFe6jZKAsWRgqJyDNrs1jxG
43429	payment	2133	2133	1874	1	1	6093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGWnsKVMwZ8xARE31R6iexZeDEptYe7MW6oCdGLuUGrHG5ZVKi
43430	payment	2133	2133	1874	1	1	6094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJJHWpoCPDrj6Lam9RwDM8gehTrx8bNTH89tiYPcmaGbB2F26
43431	payment	1397	1397	1678	1	1	16280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJvs8hnHkmoaRUDGvrDjFWkMhtwCss8rezA3iSrcebBUzXi1b
43432	payment	2134	2134	1874	1	1	6585	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MiPU25xFNJY71jcHQfw4eLsMKwXUgDMULvWYffxE2iDmXrPc
43433	payment	2133	2133	1874	1	1	6095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMhuX5sDGckcMM5VPhnzd9HtL6VxoNQwMjF8x42oUAeGZd8ue
43449	payment	1397	1397	1678	1	1	16286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhPy64HYHPfgUShDp8jnGDetMM5X5Md1KTatjk5VAyB4zTudRq
43450	payment	2134	2134	1874	1	1	6591	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CQv9qTE896PCixTzVVAmQdo9euzWUKJ8P1DUSEyDQAViXLqK
43451	payment	2133	2133	1874	1	1	6101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD3BopWPevgVTTkguzHGLXWNNj1JDgnBYBh8e6PDpMt7tgceiT
43469	payment	1397	1397	1678	1	1	16291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7b7btmFZQk9NAD3adffrng47s7NabVjyH1q5v6GWWL5GhWojq
43470	payment	1397	1397	1678	1	1	16292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQzqgLMFQZJ6PqH3NBAJfR7BisfhC4jVRCqsCVXFQABkDrt2N
43471	payment	2133	2133	1874	1	1	6106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjkJrDqnNQ9Eoqc89eRGiUjLkuXNinmJP794f3w8LT3BCM64Pw
43472	payment	2133	2133	1874	1	1	6107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTFNGQiuv3scY21K9RdiTdt1wAu1qKbmp2z3JfS16ZTsm5hatx
43473	payment	2134	2134	1874	1	1	6596	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDHCVC9JyqJa9TRDrfbfCpcWhfWvD6fFRgcPHuBhxPq19kWRQ
43474	payment	2134	2134	1874	1	1	6597	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThB4HPqftAc9edyArMJqcQjprLcjTRkfYuBynXyus2recwv1r
43475	payment	1397	1397	1678	1	1	16293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpvaSgVh2gtmm3SEWf11KXLCNJV5nusKsej8XnpZDXecdxmi31
43476	payment	1397	1397	1678	1	1	16294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5x6CpPjCmv9qvyYq1zf354acHpe9bxMu39QeZ7batcx42tbZ
43477	payment	2133	2133	1874	1	1	6108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQyAApfLqJDwXeBwMb7fiMgfTibXyFk9xxZgTX74imE6JL5QFt
43478	payment	2134	2134	1874	1	1	6598	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHT9KmR4GpyRWf6D2vjv9arpM3vGYmX3iQbCs9acsKJe84dUnJ
43479	payment	2134	2134	1874	1	1	6599	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkGFHL6PyHc6Kz4hMwxay1CLGeBL1vVFXdAyQW8KMJsbvz5vJ
43480	payment	2133	2133	1874	1	1	6109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwyz5UGtZc9Q5eQkZhDSSw5PGtdwd3yTQ4xAQVDMFGrrxpxDW
43481	payment	1397	1397	1678	1	1	16295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyVww5X6jPGn7oyLdgMhjgg47nsUBrGizgmSoYMDxdUXZSaGSm
43482	payment	2134	2134	1874	1	1	6600	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgA8pbMELAQUdkHnfC2CkTKmmVE6uqWCzZJVrPjW3uVnXH6cV
43492	payment	1397	1397	1678	1	1	16299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYtDUUVKavemgjPmG45Q9UENbVJbop2s5u6HoGT3wmNtiSru6
43493	payment	2133	2133	1874	1	1	6114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPp7mRdWFNbmvvZRmt7uQycprTJ6PbwwBfU9NPtp8g9YC1Xtmm
43494	payment	2134	2134	1874	1	1	6603	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpiWWpSvKDsL66YRZaHQtfghbsvZQ5TUa2DWpRaJTmScwkbLfK
43520	payment	1397	1397	1678	1	1	16308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfGXrpnBQpLDFPMxkFxAZox5vMCwRQTi5eSwK8JyLXjoYuXv3r
43521	payment	2134	2134	1874	1	1	6612	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENZNu6oNAx8fiB26gFSChLvsngbDX8K3TT8QZw5fffHbhiAJ2
43522	payment	2133	2133	1874	1	1	6123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bQFbiSBizG7YG8P3nNfDg5nWQKCo9jGFtnmmXyKJ1rBvQH8A
43565	payment	1397	1397	1678	1	1	16323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy6QupwTuhHmkkDpKyHGECeHPi1Cm1e1PsZVKtg2cZJvyeJTfp
43566	payment	2133	2133	1874	1	1	6138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBaU2vnQsvTJoJg1sCNBp7DzKzJ5veh39bjfCKEpT8VBEFNVbJ
43567	payment	1397	1397	1678	1	1	16324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7D5sJFVXTUT2E9sKQUEYBsfseuneAfzq1gXWdg4MeKJQjEx5
43568	payment	2134	2134	1874	1	1	6627	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcFCjBes6fvGaXjZEmgz9ZGtyC7rwM74xXi4dr23HMxGj9FFa
43569	payment	2133	2133	1874	1	1	6139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1XH483hfGj1cBqtXraWFrvoakR13w2umpKqbQuHubPfVmN6X
43576	payment	1397	1397	1678	1	1	16327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDxuATYU5q8hdkwT6pJXrzJCKpki7vbX1nrUhvXn2gFu3CGb1s
43577	payment	2134	2134	1874	1	1	6630	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeDMhQBPtv8ic8HSedBNaW2uBBUxsFvSy2qiETVgkgWvaZB1xS
43578	payment	2133	2133	1874	1	1	6142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUpZB712ivw2FjCGLr9pZq6fve5Zuk5zpxnoHDX6WoMuGjZXy
43599	payment	1397	1397	1678	1	1	16334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddAbdaXRuUz995Fz5H1PhtfnL8WQLSSn31XwR6uLViFb2yUqG
43537	payment	2134	2134	1874	1	1	6617	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7okLF4u8mstyLg6ZZgeuag9rbwvNAydkqCrZsNjsWrAaKf9fC
43544	payment	1397	1397	1678	1	1	16316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NPnmLTkcp31jwazAonD6ub3j4yTFJXP6nomc1mrgQ6xJNayK
43545	payment	1397	1397	1678	1	1	16317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAEnay2D169t1c7YWbHk1WEsrd11jwqsTKwYYKsSYzmYstGTA
43546	payment	2134	2134	1874	1	1	6620	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDLSi8F9zcSMoviNmC8vXKs1PFr61osuzrHt4ZzaqHdUHzE23
43547	payment	2133	2133	1874	1	1	6131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDnEDdw5GBLN2Qk6UTM7xSH7m5NK2bZNH6RzV9srZJpxiWVMP
43548	payment	2134	2134	1874	1	1	6621	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrh6HquBcMWHE2k4PmkgaCd6UqwH8VSbJXvBwDTEMnU6nVC2E
43549	payment	2133	2133	1874	1	1	6132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdYTbyb6AwWJSGJncoiqjCF4LphNqtLD6SeQMj941KkAJ6cWU
43556	payment	1397	1397	1678	1	1	16320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFAmLofxupCYEWkTZJEkYVYpuipWZoVBmJd8MwyBUUQBpYvFH
43557	payment	2133	2133	1874	1	1	6135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmC7fp8Az64rMhpgqVR5Wk2yvCCQSAf4bfqfX49eGVMkJ47EC
43558	payment	2134	2134	1874	1	1	6624	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBq7H1RvZtcdEti8UgGsNL7JprDxpJuKmkHettgo5orwWnoDsH
43559	payment	1397	1397	1678	1	1	16321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYjCx1aLnRhcp65PRm9XYfHvyohBoZXP6HMbni6gksEvqXWVZ
43560	payment	2134	2134	1874	1	1	6625	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEQVy3tjnCvcfvNCDR2G8oZnhYme4m3UiXsAxAHvYJ7JEuneF2
43561	payment	2133	2133	1874	1	1	6136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRD261Ja3kEGSpk1gGvUTeA2xBVM6ztC5naCPzmFAZd3XXrxA4
43570	payment	1397	1397	1678	1	1	16325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8EwFL9WM2riNtPygZ9265o2ShKe5caDqgC9HkEGb8foTkE6dw
43571	payment	2133	2133	1874	1	1	6140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTGw7LfoNxAj8j8m1FzDa4DaeWPNB9V1Kd1xQzHnmmHALioKn
43572	payment	2134	2134	1874	1	1	6628	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtrM6sVUAXTiBEF4a9TPNSoxrCbBgj175yfA4vQLabUVo6cHx
43605	payment	1397	1397	1678	1	1	16336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGyUrim6umhPeQqj2HPWP7Xtuaesutrpav2tSrWUD2FNaLUQSj
43606	payment	2134	2134	1874	1	1	6640	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbd5zw3Y2cUtxK9YdnweMgkzsvPig6Ao8pBkNn36QH3zhMHQQh
43607	payment	2133	2133	1874	1	1	6152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCNRPHNv9KSPwuw2t2ogz6N9V2TJBGijTy1PB48B4aMWU8qHNa
43646	payment	1397	1397	1678	1	1	16348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKGy7ZfEJRqEmgc8CtD1ayHNXGZ1iSX7XAMZ3fmXshz1KifV8E
43647	payment	1397	1397	1678	1	1	16349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9sLUMPAM3NGPDrryvoejmGvvvf8FTTDUMT1ZHQtAS49u2uWY
43648	payment	1397	1397	1678	1	1	16350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8HhFyv4dAA17V65MwuSEFLJYujQXimZ5RJbrkbc6d5TSUf4u
43649	payment	1397	1397	1678	1	1	16351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZRDnWKvkFG7t6hiffWatLsj2t8seKdCUyczEQgcBrpVf5sS7Y
43650	payment	2134	2134	1874	1	1	6654	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Qd2f3dZuokmXzbBQ3KHz2tbRc9ybjFy7che1wHRVkpuWyrrH
43651	payment	2133	2133	1874	1	1	6167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtppcsQWvYjLfrdqUQDtvFQnem2GbhtzzQC7zLkAUqypQ4KbcA
43661	payment	1397	1397	1678	1	1	16355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy813Jc6nUxoBbg9ZzFmka4p9nSs8y1b2mJP1dQ8qSV4CGPgun
43662	payment	2134	2134	1874	1	1	6658	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQi5FGxp8GVvfprRpVH5gySzHnoKWjsNiHskdzi2iaajRUBqiC
43663	payment	2133	2133	1874	1	1	6171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqGYW4oRL5yM8MUL1cLueEtJ1AGcrYgWs4JahJr7R5Ptcacphv
43685	payment	1397	1397	1678	1	1	16363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMDgJRywy71b5JyACzXsLWGkSo9XUfjkZn9Qkx9GbefzSUdmz
43686	payment	1397	1397	1678	1	1	16364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxh1HSHhUWz8uEuarB9ifQWojWeYQdvMbgwBCZdmW5jK969wjt
43687	payment	2134	2134	1874	1	1	6666	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMaj7XhDqBhzsXqV7w5DT76cDqSs9SJ7UxvNcnqk27qY7EHmn
43688	payment	2133	2133	1874	1	1	6179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEwihLwyZY4eG2sSU5SCyBj36oeKQNYDeoGP7Q1Zpt2CbiMwSZ
43689	payment	2133	2133	1874	1	1	6180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4dyQX22D3mxEVkRp5uGDY1sJefUfQQhLXoZy4B3yiZR5bh15k
43690	payment	1397	1397	1678	1	1	16365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiALKBxAnzp2v6BuXvHfvb4rF1nobAMQNyhRaAq9yq8kN7rpsw
43691	payment	2134	2134	1874	1	1	6667	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLwgHH3ZtGK6ZR4vuXPJ1QSb1MmrneKSK4QBaQEYruhc8i14cU
43692	payment	2133	2133	1874	1	1	6181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4QUMWzBTjWuU7CLWoEXnvHLrDPoQUerQ3irTg6Zb1SX5iKXew
43699	payment	1397	1397	1678	1	1	16368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhvphyZKnxmC3HV5eGPkrQgUoGyrZYoSSsVwARKwGeEhWmpXf
43700	payment	2133	2133	1874	1	1	6184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyhCBFuDk44AJSAMUC7XQau4sbKxgKGJKq52GnMp85yZY5bJMz
43562	payment	1397	1397	1678	1	1	16322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sL2WTaN5otWuCrM9xaL6tXeqyKMVbNSUjY6Ymx88uzWPEs1d
43563	payment	2133	2133	1874	1	1	6137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYue62QVzapfTJB4L735dnRwHxDrfCZmRpFXR7cDGGF3zYnAHCA
43564	payment	2134	2134	1874	1	1	6626	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZVtYa1HCxvKtLZkoiJFe9vYpcmaxVUH99THB2hMVPhVdoTzC
43582	payment	1397	1397	1678	1	1	16329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TC1mdBwH42sv5bBQsH8sXwDybTb1nGkJv7gkJ6qmLYmax2qF
43583	payment	1397	1397	1678	1	1	16330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwwVGyE23sm14ma5A9m713UJbSCuCTsuhDby77FfP32RiCdar
43584	payment	2133	2133	1874	1	1	6144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUudTb5y4bmtUy4P9e1ZMZuV5v5b51E5VgudJNvxrxuLbEJr3F
43585	payment	2134	2134	1874	1	1	6632	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTFcD26YxQ8D9ffaoyNZfdqGqwW3RQbbjPqUnD2x2i1Go3jKX
43586	payment	2133	2133	1874	1	1	6145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJn6zHJXCnv9WXoyA3nYQaNyuLJKLMdxCvPSBfc2QY6cXMJvue
43587	payment	2134	2134	1874	1	1	6633	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3HR71VVKvgETBEEiks3dyqwmcERHLdjvBXBuSAcj8NxixLqdM
43593	payment	1397	1397	1678	1	1	16332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb91krnKodJ3HgXKniETypNyogZRJAbiAMdFuJrpytrbwAkJwj
43594	payment	2133	2133	1874	1	1	6148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpQBGKoWVXzUQwhbsoBTSLusC4w2c9xo4nj2WsaXvtBorhLzX
43595	payment	2134	2134	1874	1	1	6636	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPV66pU3WKFyQPMRYz1hsqF5A7etNfyZnSniJ2hBfgVA8qyV9y
43617	payment	1397	1397	1678	1	1	16340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3hQcgitf7QYxJCEgqrWAAw1fPFZogK28akcuSipA9EwyjzmP
43618	payment	2133	2133	1874	1	1	6156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCgekpuomD1RcC1z88HdxZcb1gna4LQyvpszVMCjDgicrPL7d
43619	payment	2134	2134	1874	1	1	6644	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ8gvHBxmKp5HfnburotwE4VEKWhKsCohgkx89XrLqiKsvJ4Z2
43626	payment	1397	1397	1678	1	1	16343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUrEB8smVq1KFsgGZcATZ92PV4WuDqKYtFCqsWRuAMi7YUqmA
43627	payment	2133	2133	1874	1	1	6159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRp3zbVFtf71HBmJQhVaHmATQxMqzv5gJtoJSHrrKSV4DYvHKn
43628	payment	2134	2134	1874	1	1	6647	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtP9RPvuVxXY55JkiGEZLUiHcFvVniPW7Q5WWmm7k2Q9V7LuXr
43644	payment	2133	2133	1874	1	1	6166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqn9yDwXEfjC3GgXCoCHCuMNxTtbsWWfU13qJKbhCNQZ4uJHpr
43645	payment	2134	2134	1874	1	1	6653	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhPKBDNSYL66ocQmtqhwNMGB2RCuNdqg5WTaNsk9CDui8qQeQ
43652	payment	1397	1397	1678	1	1	16352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkzktUpDJK1a6ARFsYUDR1Yjtz6CdKhEvQ2cgKpuNo7AavtRmT
43653	payment	2134	2134	1874	1	1	6655	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8HGh9tJWYb4E6HuVUxokBf213ymratHTn3QAUDkZan5d6vD8
43654	payment	2133	2133	1874	1	1	6168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VpFNti9K6Z9J7Kpos4uiWgPy66f7Q99nPbPrCtWmowkyE5v1
43676	payment	1397	1397	1678	1	1	16360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRxXNgZGbXzs76ACSAp1dtwtrk7TU5N4csGji7xVwszv5LMh5A
43677	payment	2133	2133	1874	1	1	6176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cCEFpweodPcP9hNtBWNotAnMHR2G6UTA3JJg7R8tA9V7UdWF
43678	payment	2134	2134	1874	1	1	6663	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM6UqDdNjmX1KZP67Fbivx5GhWfqZrrYcHxYcGQXtkUw5avBE7
43696	payment	1397	1397	1678	1	1	16367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbDWWnAoUwGhaKCE87vQqoZ2iNTSbofKtqazf4N9SVEzbKoDV
43697	payment	2133	2133	1874	1	1	6183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRzcvaFAv3brobCin5RR4BwvViYzLrZpGmpsG9XuwthyPTHAkU
43698	payment	2134	2134	1874	1	1	6669	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6owwo3Wx5k53zm647qwaYLo8MScpfDWzeJKJc7kUGj5Au2BWw
43720	payment	1397	1397	1678	1	1	16375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmjqaN7brMuoSKHdCdaTnVHZJmk3zaENidSbBg6RGg5wgCSvfz
43721	payment	2133	2133	1874	1	1	6191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsvfJXmpWTRQsDhMkxwrN5n5oEiSgkYXp9pE4PZ1q2WUNk5GP
43722	payment	2134	2134	1874	1	1	6677	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjogwrRCDMSzwR9PVZ1rzKDr75DupgGstkJHmacxqRhFWtgPYY
43746	payment	1397	1397	1678	1	1	16384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqavupkiJqchVHxHHdN4HRyVmE5afqrWB9fw5cakn34dgfs4JJ
43747	payment	2134	2134	1874	1	1	6686	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLQRDu7BFCCYeTJJdbPjMWAraN6YaNPZ8gZUbJkoMPWqFg39Tg
43778	payment	1397	1397	1678	1	1	16394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdDBCZfmfewFU64CRLQHSac5qzvX1GZuE9y1gx6JVwZm9oPSEg
43779	payment	2133	2133	1874	1	1	6209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdtcrDmUiTdMZ5iXL7KBpUVHTuERhurEMXcmmFMEZjXis5j6v
43780	payment	2134	2134	1874	1	1	6695	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLYB9xN7BfM5NCdBDi7BsXMWpUtggRrAmL6bnUWM5vFEbj5a15
43789	payment	1397	1397	1678	1	1	16401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ3W8CHigqwoSv6FuBSLH6G4WpKXLNrLPjp52iZTDCefws2GKr
43591	payment	2134	2134	1874	1	1	6635	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvvJ3CsDuQT4dhNnEX7etBCMYWQGLQPPr25ankEwHY41DWTNqC
43592	payment	2133	2133	1874	1	1	6147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHu3PNR8jGqo5B9DYNxtQumTXoWJHYeSBy9SMrJnBapNpqBcLv
43596	payment	1397	1397	1678	1	1	16333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNtg8Gva5e5rMoU2Pqv9ULb1pE8Qwgu41es8GZBCaQBjGcKEe
43597	payment	2133	2133	1874	1	1	6149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHv7FV497UpL9x3LMTM9AicXtZDHJAfrTDKxTwZFu7p1JQKPLs
43598	payment	2134	2134	1874	1	1	6637	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8UbELn96ZYRBZtkgbGQ8h1Nb2THcz5DftCrKRgs2L13tWgM4
43602	payment	1397	1397	1678	1	1	16335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxPRcWxDACtXeJeseG71wTEy5SQve9yQBA4iThZq8bVthFp9c
43603	payment	2134	2134	1874	1	1	6639	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYjUCC2z94hLLXDoZCVsncgANFv1Sp6f5c4cLkrWcnv46TNDA
43604	payment	2133	2133	1874	1	1	6151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQMfgMeV7arazcRddF3T9PhXjmyiGUXDroyWVrzp48DLv3xjCE
43608	payment	1397	1397	1678	1	1	16337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxA9rp6hk4Fipq5jkRCrbenUpUVYdP3fKoQZP2iMHTZWuLnw2
43609	payment	1397	1397	1678	1	1	16338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdW6KAXpLSzLBaVdNBpa6uNgFfKukCuL9c86YBY9afJVfdrgZd
43610	payment	1397	1397	1678	1	1	16339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbUtXnehqfCmV3q4w2EUenEQhkErmpHRSC27w7ayPva4pNSZe
43611	payment	2133	2133	1874	1	1	6153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67pus5HRPcfadW9basa4hgQSEJDYExGfCFJvprcRrn6qgnUgC
43612	payment	2134	2134	1874	1	1	6641	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6dr5vkYcmjkMd16QdbK7GPYwCe4oKpjbmYNAxjkeuJGDegZjP
43613	payment	2134	2134	1874	1	1	6642	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfsJhoFrsTCYL3qAgcMyy2sGZy1Ht1AsmSccAoijFovX2DJxdg
43614	payment	2134	2134	1874	1	1	6643	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvEDaJNUpKrHck1EnJVvLRDZ33WQtLBSDv6aGXeGQUmhPFj5Jw
43615	payment	2133	2133	1874	1	1	6154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEquFzdW8cSKsPeQN7or2ktFxTBcTCpKDtk9zP79MfrN4p4Rsh
43616	payment	2133	2133	1874	1	1	6155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmgrnZE8B6mGYUrUn2vVWDB5a2MvoCczgngtG7L46enx7Xwmbk
43623	payment	1397	1397	1678	1	1	16342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkEZx6ZCpvN9XaxtqXiTgwGaQdG8xxTWb2Wv9yqbs65Rtqev6
43624	payment	2134	2134	1874	1	1	6646	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMajvxUPWeHoQZM2u4jmKkznas3StYjptWDCXc8rvibh82aME
43625	payment	2133	2133	1874	1	1	6158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZob8oJTdCTzgAYsdBnx8RMybf4N7bZj7QabopSg6E3Yy5Qa4nX
43629	payment	1397	1397	1678	1	1	16344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZratG7fe2zAkXKatfAg4JeyqwJZSA6YRE8pWLDXcAqEdt398YK
43630	payment	1397	1397	1678	1	1	16345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfriWRWqcSdkHxgDb9G68MPhGNNcjgKhEunNkzdT3tVjGB2t5U
43631	payment	1397	1397	1678	1	1	16346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAesc4is1jpTXwN5PecSVbkQgtxMSnbwdfZByvsAvDxuAZraSs
43632	payment	2133	2133	1874	1	1	6160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGY7J9u3yZNKwuXsRfUeBdCsDKNHme7KrZ9gb7vJbKgx6XcXx
43633	payment	2133	2133	1874	1	1	6161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkKkJZFh2aVwzjkSWANUdrFu1Uj5GAjQLxvPK91CZk7BHXg1tF
43634	payment	2134	2134	1874	1	1	6648	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ848cJpGNEUng2rV1siyXTdCDFTypJTV8sfmzWJqKa69wJLXWk
43635	payment	2134	2134	1874	1	1	6649	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR44VmBAiy7mEWLsxSc8TrkRKQfa3EbTMb8KjV4dK5oFbqVuSD
43636	payment	2133	2133	1874	1	1	6162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC2UrNuGyNwDA78Dkd8gf463D8B4PEoNDL14rQzaNSALJk6fTe
43637	payment	1397	1397	1678	1	1	16347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8ufuRR8R82N3FL2wMq1SMnoUHCB96vm1pR3JXeG7b8dH7DNPX
43638	payment	2134	2134	1874	1	1	6650	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsLVz4jWYodG4q6jPhE1QASnTwwJj9UqxxexuPeyCQGhtEdSbh
43639	payment	2133	2133	1874	1	1	6163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWPMfTqkzeRdzXNHDd21SZnY9xpNQQjs1phLZKqHUdA24taRc
43640	payment	2134	2134	1874	1	1	6651	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbhrocZMRrmPYJAyPhLn3aukyVvvMrSmNiCdn3MydodrHjSNb
43641	payment	2134	2134	1874	1	1	6652	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GGUzpZToz2Q349rAiGpDoXLmHRR7zrGrQefqSzWeJU2BNXqG
43642	payment	2133	2133	1874	1	1	6164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWGpTea3sjeaE5BnictLBWW6nHEqNtYXPYwR4ALSnri3L3AGC
43643	payment	2133	2133	1874	1	1	6165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS56WXdc89isWbjAbQAiZ9Svw7eANuB6XGhBzpTBJ8yEAaWR8o
43673	payment	1397	1397	1678	1	1	16359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2CuiSYRHSHkAD8kLYERz83m63KwtqZp1nRGffX77AqumZkP85
43674	payment	2134	2134	1874	1	1	6662	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKnZx9zxpEbDszL8VvtJyhyGAmEUZNCCKStyhwo2VyJxnQrdv
43675	payment	2133	2133	1874	1	1	6175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxqaktP8xjzoW1idq1Jy53uYuKBHSnKL9hXmJFhfiMJE4Z9Bw
43600	payment	2134	2134	1874	1	1	6638	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hoSVMZDHrJtJvJLe2GtWXZvCLrUj4oKhevFSbu4ZZX7nJptq
43601	payment	2133	2133	1874	1	1	6150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCtjo4hYhGdi7HzWaKCusadPhVumuuFyj1E1xtNC8xA1cR4HFG
43620	payment	1397	1397	1678	1	1	16341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjqrhFHfjXMYGrhiiVMz47aVxL3f8wcGCV5AeEeHbpFmghjqh
43621	payment	2134	2134	1874	1	1	6645	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWvFpjyNxVPhuGk6f6iMKJ3THy6Mn19UpYCbscEcBLrzx3ihb
43622	payment	2133	2133	1874	1	1	6157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtu5U2zpzRsyAhRGBs7rqPcv6XYo8AH2ZbVG1JFL8zEqJsexZJ
43655	payment	1397	1397	1678	1	1	16353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFZCvfrXGE93raZiqk9WZnCH1CmK9qjimsh5ngkq4nDmAZPWy
43656	payment	1397	1397	1678	1	1	16354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhVBMD7nXpZtHdHeZdLrrTTtbjbcF8syvxaBMUxAR4TsJTr42
43657	payment	2133	2133	1874	1	1	6169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPgpfXAH7MPTCVgCjrX4vy4c1S33m7VT8SCczKyh93Ha2a4ks
43658	payment	2133	2133	1874	1	1	6170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGu9y97AnqSUrfkKvgFdt7y44TqvVcQ6YAuueWPmUtF2SKp1D
43659	payment	2134	2134	1874	1	1	6656	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3YbwYU4Q2iPsFoZjxwK1jXcvowQFBQhHX9adtcxwpzPFvenr9
43660	payment	2134	2134	1874	1	1	6657	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa43byXXgWCaJ2r3vpVvgihz52EALRmabLt7k4WvR2u99CAZzGD
43664	payment	1397	1397	1678	1	1	16356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCHWu7hZdnc9wTVBsPhiJN4SF9tfeYiK1KVQBnQkGSdJq1KjXg
43665	payment	1397	1397	1678	1	1	16357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGimxd5cYq4BKec9fLXMRTaHcWRCC6WrtjQJRXBdSujFapoCvD
43666	payment	1397	1397	1678	1	1	16358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUHu4TYFs3bGdguRM1iKYakkQ3Q1HpwZoTrhGHhAi93zcNc6uJ
43667	payment	2133	2133	1874	1	1	6172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhmw6HxrGTMDAsWcpw36pD1azqhyY2faWsyAF3JTPRkCxpRgP
43668	payment	2133	2133	1874	1	1	6173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdCGgmFsTySE2h9gaaTyhNLSxXQjE5mazC68TF9HNsN3g5JqgQ
43669	payment	2134	2134	1874	1	1	6659	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXwA5ZpVUsbhEDzGSkMphAK74EeKMMQiosfYLxTfUwndAfQK8
43670	payment	2134	2134	1874	1	1	6660	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDPTFzmTqTwU8tYxssZmCjWi4FGMqMdd2PjTzEQhvTgA6CMZN
43671	payment	2134	2134	1874	1	1	6661	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxXDxF3Cb6zb9NTNCYjzifmb9ZjYDQaprDuT95CDy813nuV26U
43672	payment	2133	2133	1874	1	1	6174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzKMMXDnkvmiznj8Jagp8bPHCk44dG6D9d3D2ypnsXMoEp5tm
43679	payment	1397	1397	1678	1	1	16361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAC2oLvY4iZqr5FGU8mW51UmZLHvwTk1s3CmqZVU488Sc5eRyf
43680	payment	2134	2134	1874	1	1	6664	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ3ALHrdQfX7dEZ32KY2zfN2vWcq2nEKTG7yz5wbRbm5JnqVEf
43681	payment	2133	2133	1874	1	1	6177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JnWihL74qYpLvDLNTwzEHpF8EHh83RJdzi3qNdG2fMfSjK5M
43693	payment	1397	1397	1678	1	1	16366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiPkZgupueRs99Sd4CEd37J2A6Uza9fLHyLsqeyAFFrpN2JETC
43694	payment	2134	2134	1874	1	1	6668	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRwEWMSkDcajrdyHRJzJLhHEKa1GPeAQE1V4Y4u6vbWqck8vt
43695	payment	2133	2133	1874	1	1	6182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaSz9GPfpAEmFyqGuLNsHUgperiQrsc96zfzAgur376qynspo
43702	payment	1397	1397	1678	1	1	16369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1rxm7FkoBjhMu5TvkWLqS3bHbeRyiyQCxBBZq2YQX2gHdCPpR
43703	payment	2134	2134	1874	1	1	6671	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpnAkR3615Y8HSHQSJCNiYEXPdnkH9koLqsAevpCgb2yiSLkA
43704	payment	2133	2133	1874	1	1	6185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt399fQY4tTqJP3LtkUJxDvpeav8xdc8teB261crLqwtQ5LQVk
43714	payment	1397	1397	1678	1	1	16373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mTNz92L4bJZFjVy5MvdxMTm7czXeAftDDc1ox7fbQht7AKbt
43715	payment	1397	1397	1678	1	1	16374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwZJoia9U9hym6iMtmAg8oHd3Y57fWb4ZDfeNppGKmUbh6W9F6
43716	payment	2134	2134	1874	1	1	6675	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbnPbQBywkT5JLhYNE1x17hUVdhGqGvKrt1RbwQR1jyAEhskYP
43717	payment	2133	2133	1874	1	1	6189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjPm6mBrwjCW3zyesNd79DyJJ9cgZSP9zAadrLMeAGTpmn8a9S
43718	payment	2133	2133	1874	1	1	6190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EkQtpXaPrYwaqa8nS1doGPeuwDy5kcMacU1FPinR9dBuHMka
43719	payment	2134	2134	1874	1	1	6676	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4TVVFPUMduS7guXztqwfnQBbqoXTVagxzXTXHntMi1Vc2oGnH
43729	payment	1397	1397	1678	1	1	16378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbRwgZML835UUsXXN241xmXWYx1a2QRT8L7ixLU8nFkrYqE72n
43730	payment	2134	2134	1874	1	1	6680	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYokAQaePingUpLPmt434YbN9MCQTD76QSAVxaWeLTqAUpPwvQN
43731	payment	2133	2133	1874	1	1	6194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZATr9mJphpG9vjFWCDoXPuyXKBSbVMCauzqHpNzcGmX5cSzP
43682	payment	1397	1397	1678	1	1	16362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuUDcM9rNsnuzx3cuTDeeBBdQFEPYDnqnSwYdL5zSkWnf2iKk
43683	payment	2133	2133	1874	1	1	6178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9TZMdGst84dnFoGmgaB5XuyTxEQqiuGTL1yGXRfxE771KdYZ
43684	payment	2134	2134	1874	1	1	6665	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKqR8HqZgRL6nDx6ftuk8DBr5JbP5ZGHFqsum4HYNodaquWqJ
43705	payment	1397	1397	1678	1	1	16370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6SEw4p5msi1crsATgPbL4i3AVy1AMYmWrtdHqfALYFUTMWs9
43706	payment	2133	2133	1874	1	1	6186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHX91tVjvy9ff16tuwmc8BfeRRz74soD8x6PW2Z1dafDwJd9N
43707	payment	2134	2134	1874	1	1	6672	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63TiHeb4wyk6hD9HRVEXFMpzG8ATqj6CQDWDwGcKfk8fCEKC8
43723	payment	1397	1397	1678	1	1	16376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdgLKPKubdhArLa2Rvy35jK1EsFwQ2yeEg3e1SYuiuj6XBNgp
43724	payment	1397	1397	1678	1	1	16377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB84SmbybzQ3fynBxWRQESRAF7CWLe3Z98AfCAm4RHRWnnLZEE
43725	payment	2133	2133	1874	1	1	6192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFJL3ZALGt3cokWH1sR751VBGhWAcUfVaYmoaV91WdECtPSz5
43726	payment	2134	2134	1874	1	1	6678	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbfAZdk5b1oMbjawK1fhNaSUbFzHW4SLoeLYnY2vXfwHH1MaR
43727	payment	2134	2134	1874	1	1	6679	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6iNSTe5c52cpnodShUhC1PCot9ogGhSCwc4dtxYRMFR8y8ms
43728	payment	2133	2133	1874	1	1	6193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKR2Gfw1WJGbW49YZ62aTHZNRLoMrMnUgpJ5T6vESczAQtHRsA
43732	payment	1397	1397	1678	1	1	16379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcG9jLYG2nN9zXPJUzDSfgZwTW3jLJV2X7Qqsn6xEG96Heur2o
43733	payment	2133	2133	1874	1	1	6195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4spsiEvhsu9sAfYMxUJ7Cc35gfQ11ajZdQrqDWTFv3aSZfWf
43744	payment	1397	1397	1678	1	1	16383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFm5T8fB1cmAzDwsaD2fwvuT8A3sfPDC76WqGJNfiwF1NZUhhM
43745	payment	2134	2134	1874	1	1	6685	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmjCGisF1ScbqzeZN5NhJo5CLk8bGWM6UpbhKgNHbPNyrdbrc
43755	payment	1397	1397	1678	1	1	16387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdDEWqBQ67Poews5aSo29uoubgoYwv37UuCFP8h9iB38E8qSS3
43756	payment	2134	2134	1874	1	1	6689	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2tsuZ6Y4yY3g4mBPztTRSYR3iv5DLg85ncedu1Yh7RNY7cTk
43757	payment	1726	1726	2374	1	1	8327	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYgWgmsJiBYMT2B9W8EShY9gu8i6RV6K3SB5MDLreMvauNzT7zF
43758	payment	2133	2133	1874	1	1	6202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWFNdcR9eAgFNRDvWu4ybtd3iKXzys2VcEDKnjmNKVUGGapjK
43759	payment	1726	1726	2375	1	1	8328	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKqiXeWmrBN6J5RpDZ7jopNzs9uveK4Wx54kdZkjo81QrGHZND
43760	payment	1397	1397	1678	1	1	16388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm42NfoFqssy8WtxZD7NaQ64fciNiVmXap2tEAfcVDsQuDRjY2
43761	payment	2133	2133	1874	1	1	6203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRhj3FnApbHA2W93tvexrNrT7KPT7XKbAk4zHUxoXn1FM1Mx8b
43762	payment	2134	2134	1874	1	1	6690	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQnwbvzHsQGFP86oEh2QRyCheU8tdsQu9pEANiAL2DrpQUCyYN
43770	payment	1397	1397	1678	1	1	16391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNptNVJWtLq9UNV9MjrtTnPpbfmPPEXyg3YjmbkVqbAEfHhUyT
43771	payment	2133	2133	1874	1	1	6206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ16jG3vtk6KLagVbrD9XpH6kkqPkoT1xRPACgJfBXSfanXehEm
43772	payment	2134	2134	1874	1	1	6693	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ442krtG1qjBpa1sKWGiBD8zBkMMLq2yEGJyAEbDu2bxtFjmnY
43773	payment	1397	1397	1678	1	1	16392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKs3C3uC3Xbzm54JhVEtseJPKRUHfUov4ccLowDsC9VY1Y3px4
43774	payment	1397	1397	1678	1	1	16393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAZqbpQwbiPK91qPfRcTmgG7W99wf5XRYHqKUWQcV3MAiYG5j
43775	payment	2134	2134	1874	1	1	6694	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrw6Dv7fTxXw6Kic6itX5m3SUqzFrfmrszNFQPM9DBoPLHuUdz
43776	payment	2133	2133	1874	1	1	6207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUY7Sn2RWtKbKoTQcNrJwEgBEKxKebSFExTAPZSnF5cxLY6b5T
43777	payment	2133	2133	1874	1	1	6208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLEjKV3j1iuz1eder2iLALKgGi49a9jzuLZX9chMBGFP5AkuK
43784	payment	1397	1397	1678	1	1	16396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6LnKFn6ZrJFbt28uJqxPnZkmDYLGfR6Jh99eq1mfBA55UeKG
43785	payment	1397	1397	1678	1	1	16397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRp7P1KWe3X7pfJPxrYKpuNE9tdAxxpQChonaFL4my8sLUzyoc
43786	payment	1397	1397	1678	1	1	16398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoppQPcf7Xo5T6EUh89JTAhg2UT2C1gtqAMGeYhyBrYwzj16BG
43787	payment	1397	1397	1678	1	1	16399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzY4xE7KRKdup43sYwHXtLZ1WLkZnmVVktWEmetqNEFtXZ7mfB
43788	payment	1397	1397	1678	1	1	16400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7sjdKWgmwqqHhv3Jk9PkH2mZGureQi1qhvcyhYeToBvhfhGot
43811	payment	1397	1397	1678	1	1	16405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGzqq3JFMRJTuLuDqmrn43tcTPYT5L5mVQ1rK7CZsBbvNbz5T
43701	payment	2134	2134	1874	1	1	6670	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rYHWvESNNET2qnTQB1eCDMfS9p79Bv75o8eibSkQ58hB95n6
43708	payment	1397	1397	1678	1	1	16371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCsMYuCrcGvtHnzFtm6LWPV3UDsMkttLuNKd4zoZD33RFRdsi
43709	payment	1397	1397	1678	1	1	16372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYop4P1DoirnG5LYX5K3X3VbKsajssJ1i1HwjbJHMiYNqJSc1fi
43710	payment	2134	2134	1874	1	1	6673	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHtdY4iGMD8nyTwmonEKyXckygz4g7Hb6AfnzQhWNkptnVMyo
43711	payment	2134	2134	1874	1	1	6674	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1SRRr8aJ3ZSYKMGfFbcrvpnEZ8mH25gGFR4ax21uy3MgrHd6u
43712	payment	2133	2133	1874	1	1	6187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qc6N493XShfYcovroRWGapmt1tkCV1CPijGQjUFtpbeCEjHu
43713	payment	2133	2133	1874	1	1	6188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeKKVDBhaXPZgB4H3J9Q5qrZb6pEncrKnMwwfbwNwoeBpTfph
43734	payment	2134	2134	1874	1	1	6681	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPLRKWdZZ9ejPdqxBpLDM7PoxncBRxiDTp5MoDKTPkAnHr3Rs
43735	payment	1397	1397	1678	1	1	16380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKhYDD1HCw1JS7J81y2DrgYtJ884Nu3TBUta5yJtJLxGscmy6r
43736	payment	2134	2134	1874	1	1	6682	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnX4c4CvTS3Ubn2mk9qcrHisXuKe1YVijWHhW812cASu5A6yT
43737	payment	2133	2133	1874	1	1	6196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUTrZTTRDQ8Nj57W3gJnPZXbLftXJiRWpYvnCWYEpnN9gJCvA
43763	payment	1397	1397	1678	1	1	16389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJtgPV7azBySKj5TUDUUDXLJaPhrQaAkYvgncz2NXgvVZjZf2u
43764	payment	1397	1397	1678	1	1	16390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYEeY7DP75EtTPufRbdDPcDcg2JyGmzRYXte4R9E5UEqH78vjk
43765	payment	2134	2134	1874	1	1	6691	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGLtvrpy1Dde8sRWYePWRDJrwwq5uEnmMHN2quNgCvrT2C94X
43766	payment	1726	1726	2376	1	1	8329	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZa27ozs7oAVs6Twdpjd8Y26F7H6E1KHLbFT2XemssEyYgEKSmK
43767	payment	2133	2133	1874	1	1	6204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2udGZrw1p8HdUwKsptgX7dJima1QsTeqnzfiDQ4yT7JTfFSDd
43768	payment	2133	2133	1874	1	1	6205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyCMoTf9JBZXV44y61wQ3rLJBR3qDgtanzwR6GGBCK4Z7LyTs
43769	payment	2134	2134	1874	1	1	6692	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3bAS1L2eJkAg6ThzZpaKRm696jVRrncXE5UdrSuuhdqLs5G1r
43781	payment	1397	1397	1678	1	1	16395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQxyV9sRYjigCYCS1PyeB7owZ6wtxJu8phJvfdZBqvDSLCp5Xp
43782	payment	2134	2134	1874	1	1	6696	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1AmSjMAfrJVJmxUQfmeYRtY7kqLXmcp8eoBZDiTZ3LsLCXLL
43783	payment	2133	2133	1874	1	1	6210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhbG1L1cYBcNeVh7J2VRAZJt3rpQpAWtGjhcDMaxf4N7A1BR1n
43814	payment	1397	1397	1678	1	1	16406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwseKtA5LVQG7MRmi1bN44VtY6rjvNJoitHGQ5tjxDXfKVmfp8
43815	payment	2134	2134	1874	1	1	6707	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTdEPn6vMMB68WCkRZbKpy4Hjovim1UkYtAAZyS1bMLLWJmKK5
43816	payment	2133	2133	1874	1	1	6221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDY6f8cjj9LoGSy1wWHqAjzNwCPotzFy8CAs5BZnUjdmpVsTyD
43829	payment	1397	1397	1678	1	1	16411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ65zNz6AjzJgoBHTtffW5wmXCBWR7FaocGcFUJPKozV2ePkxuF
43830	payment	2133	2133	1874	1	1	6226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFS11kxn7tgXCXSuHvS8Rvh4hN5nXgQ2hdtmJEmFSrbdUXxvy
43831	payment	2134	2134	1874	1	1	6712	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa1cDr5CPGQ4dNJ2FanY8apFp6gui8uec8idPn9cWSrLvcn6Ce
43844	payment	1397	1397	1678	1	1	16416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzzn8YRoxcsEpzkYbuLng6LseBnp3G6pAYdzjSRpG3p6Zn6XRu
43845	payment	2133	2133	1874	1	1	6231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCadPVnQBgc4EBRvny1qxTxZ2rvz44g7xVmrKxiCMDXA6GewN
43852	payment	1397	1397	1678	1	1	16419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq1obXuVgVvnMnnYTTxPojuBQntntAJCpaH2Uofgxw6gqJ7oCW
43853	payment	2134	2134	1874	1	1	6716	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbboYuQc5WDsokikiJ34R6id48vyWgwVoE538m6WQEUHqjwbXs
43854	payment	2133	2133	1874	1	1	6234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfJL8y3iWEv5AyuqtwgZUC24c2UkX7us6ZJHH8VqDj8x2xD3R
43855	payment	1397	1397	1678	1	1	16420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMW22PgfEvKZY571wgw6c1V1XgRao2w2j5YSVNUEddbCpfNes
43856	payment	2134	2134	1874	1	1	6717	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe346f5i83YZSzSHd2NKprnGthEjLD9FzHaQBFmdR4B5LcCemP
43857	payment	2133	2133	1874	1	1	6235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfvHCgbhJy9avzUR2KuWpXwEDsqVEEDK1sq2t4vDcGhvzHjrE
43882	payment	1397	1397	1678	1	1	16429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZivbBnZbHZvUg9wC8by8iozYCxE6TXgaCz6J7DAhqVQHQYGZvS
43883	payment	2133	2133	1874	1	1	6244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8hmXwNcRb6Z1M91F1mLvhASTeNE87BgEWv2uogsr5jgCU7Hfe
43884	payment	2134	2134	1874	1	1	6726	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSbU3vp2DXNr673mjrx23UcP2t3odN1RnW19xumBSkoBqrExW
43738	payment	1397	1397	1678	1	1	16381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXaNfnD1KUpH59UkHUqz7qQHzkBzkwKzS9Bqu5BR5Dn9Mw2Zr
43739	payment	1397	1397	1678	1	1	16382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGcqQbqMdJ7KjwkuMumNhitXYJUcoaiPLDXDzfqGFARuNXu64
43740	payment	2133	2133	1874	1	1	6197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDzkjDry7NP4yA457aNaJn2f2L7R9pTxsLMtFTj2YFna4Pypm
43741	payment	2133	2133	1874	1	1	6198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUXBoRsg9hMqMJNrZJ8Nn3MsPC3uUYtzkREkF5SVPy7XL4YMV
43742	payment	2134	2134	1874	1	1	6683	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jR2nexYjDP4ZtG1m6RoJeWxvzFCs7zRCCKSXyS856DJcEmBs
43743	payment	2134	2134	1874	1	1	6684	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKm9KuVZBvCtt2EFGvLvdrP8bbety2FyerhKaXVemuRMgZbwbc
43748	payment	1397	1397	1678	1	1	16385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnnF7PCsDR4mhi8vV7Jd4fvYVCSPbhvMUi98phMUBJsDNFbVK2
43749	payment	2133	2133	1874	1	1	6199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSuU7fkwVz4hEfhdgfyjkGUYEYH9ScBYyEmVAjzyE4fFythYvh
43750	payment	2133	2133	1874	1	1	6200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHjYWptUqmRSJw9w38Cd64p8CPtj3yt8RmJC7R4oYnhZ7CGMnE
43751	payment	2134	2134	1874	1	1	6687	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2mBWWNhmKGAWknSD6bNLehfhkTAagoU8hMsF5rGMZWSjAinfK
43752	payment	1397	1397	1678	1	1	16386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa21JRw3BQpG9DpcVfvgqqGR3TQitAR22bnN5C8Vx5yPUoFdJHH
43753	payment	2133	2133	1874	1	1	6201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVLMjafBoAKZmRZqTeHKRqVveQsvncvkCVVhGufRPpWMWsfoN
43754	payment	2134	2134	1874	1	1	6688	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAuPkizoGLP1XbVNMQPixZyeTtqmopkuesS9xTQwW6rgWVpAt
43805	payment	1397	1397	1678	1	1	16403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7vmvMP9E8VAg4jrN1sYGBPTJfuBGau3HSdrCFr4GxjS3p8cs3
43806	payment	1397	1397	1678	1	1	16404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsh5DYyBxTN33MmH8cWBkTjtErm3UUh5JaK9cdj3VTWy4xkb4H
43807	payment	2134	2134	1874	1	1	6704	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgyDATq2FzCMneM6q3puCAJnpLZyQXavionkpmATJkb7Mb7tWM
43808	payment	2134	2134	1874	1	1	6705	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJstC2xtGLn3mF7KgsvpQ7ZXnruoJNbZLAXsnFF2UyhHvVRnx2
43809	payment	2133	2133	1874	1	1	6218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzyzDEn8cxwHKHBm5rCeVh98bYvoxeqCXXEQ3nJDtNKLhhmYPm
43810	payment	2133	2133	1874	1	1	6219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWPcMry9eHWmTd9pkaowxqJ6v1bdy6wJcQjx42L4t7PPSBf9V6
43832	payment	1397	1397	1678	1	1	16412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WVjZGaXy5fcRVcUuuvmhfwB8mqGvvevVD24nJ35XKzV3bVHq
43833	payment	2133	2133	1874	1	1	6227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJgUbCvZ2ED66UKDVuAaJPaW8iEEJ7ZdmDA2S7ZhwSpsndyYv
43834	payment	2134	2134	1874	1	1	6713	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzEyVDZzGcN5zRHnhMpa9HUpviasxbqGesQTAHWJooHX5DsEg
43846	payment	1397	1397	1678	1	1	16417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnptJbSF1HpXhXBA9HtRNuxUQAvAXhCDCAPiCmXM3axDCw1iL
43847	payment	2133	2133	1874	1	1	6232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZySLDPPVe96u8B4otCPUxxjiq5YuiaT8cTwmgw4639mWpesBRS
43858	payment	1397	1397	1678	1	1	16421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmfr3p3hx1neL6zsNCrTx9HuFCjgf1f6SfBWKszVttuCPARAuS
43859	payment	2134	2134	1874	1	1	6718	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAFNmyJJVRWF7Xka7hBjS6Q8s5sbh3nGYQLhcmBgLXaCTby23
43860	payment	2133	2133	1874	1	1	6236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQkxygshRaqE6ksGktyJTRtsPzVYbLt8QByaY3uCy7ngUUeL2
43861	payment	1397	1397	1678	1	1	16422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzT6dmSsDEMGY9NovCLeJWHdHdknxW2Ec79qBBtc2d8S2AzXSP
43862	payment	2134	2134	1874	1	1	6719	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBBUTz1kE8pGTyrfNErjnEDhhvLPGgyXEeCccorpDU5HFtymPK
43863	payment	2133	2133	1874	1	1	6237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBTXjzAg8NGJJYwQywQAywSFWBqWQWSNybyHJcPCiUGqAvByxB
43867	payment	1397	1397	1678	1	1	16424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8VANNbxce7uEeivGfQRvH7FLqADvTdpdKpHQQoue3TLJEmWtR
43868	payment	2133	2133	1874	1	1	6239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5DzsK3o99KtS5cjvvGLK5VZgTU3bMXFUTkK1eJGG3PRUgKBp
43869	payment	2134	2134	1874	1	1	6721	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDa3KnnKHFdFrTS2qmZzHe7XU7tByRpRyAFW8oyVrkEgtpnQ33
43888	payment	1397	1397	1678	1	1	16431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYmcBLs18C1Uv4sYRUMgP7wbBy1Bb6q4XbV3CFhTVLZMfoZXy
43889	payment	2134	2134	1874	1	1	6728	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV5yKu4PMjWEEDjGgaBwnH2ELTpff9m7q5fcjbCcy7ngZJbvds
43890	payment	2133	2133	1874	1	1	6246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHR69Hbvmj8czyaAfWkzHsaHMgwUpTG3eSjwc2z7cPak8TBiyV
43900	payment	2133	2133	1874	1	1	6250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhFieo11A4qfsJ8KyL4YW1H1fPDFDUp4TQxrUR8WMjNYVaqC5
43901	payment	2134	2134	1874	1	1	6732	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9XTbJ1zCuL7JEzvkQUsf9mPBUYo1nzgLZGnm2bieMHxFGjt83
43790	payment	1397	1397	1678	1	1	16402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGZ39iW9CkVJnw3yCgWjgdzAFwekhoWe2o1rGcJRBuSWiShee
43791	payment	2133	2133	1874	1	1	6211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbNiUeEzH62AWBsZWEB8sbyK1RnUHHqDRUvPjTHpZ9v6fVp3y
43792	payment	2134	2134	1874	1	1	6697	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cWntSwaDXUv3ZaoFniaBdTftu6gRwKwf4Le8QuKxzATdspf3
43793	payment	2134	2134	1874	1	1	6698	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45ZbBf8LLvWkgM7rA4boXwP1Vku1wN6Jt4KhzwDwrFq4bA366
43794	payment	2134	2134	1874	1	1	6699	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1ns9cTvBhQ97KS4Vx3x4m8MmkWAA8CzRkcsB4ykrmJDh8BuH
43795	payment	2134	2134	1874	1	1	6700	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYvmfehPtFwF3E3iSkdmzPpKJhaL2UU1Vw8MAePW8ZeniNJ7Tn
43796	payment	2134	2134	1874	1	1	6701	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi6QP8DpVZLZjPjXeHvauSsepefDmkmGGyBn8AQm2WNcvLZH9j
43797	payment	2134	2134	1874	1	1	6702	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKsGWuwnxheLZ1JnqdfVTzwrnqVaanAVLrgDHhBBxd1GNYvwd
43798	payment	2134	2134	1874	1	1	6703	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXnAxwGi8kmYoTtkjSogdpBLdDShP67X7VuNDTuUHXyLZTNyhn
43799	payment	2133	2133	1874	1	1	6212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLgxbAd2LmJEBVZ88AZfeYsRuAjRc9ZMaXhAkLuvyT9e992kjo
43800	payment	2133	2133	1874	1	1	6213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmYWkfCFENbEHaB3RCBZWXGj5vUULCbVm3M95ioJ1rj8mz22xQ
43801	payment	2133	2133	1874	1	1	6214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEbZCvBZ88bUcHVFKdmKK7XPMsYUsTU3QRRJ8auKroa7bQoqFE
43802	payment	2133	2133	1874	1	1	6215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhezMTwjTXGA5aQnRYW3Wm8RMi9oGzAVGLriefksWC93CvuAXN
43803	payment	2133	2133	1874	1	1	6216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJDfijjWqqaoQihzAfxmnHPtaeXDt8mjshhEzyYXvKHZLVNnm
43804	payment	2133	2133	1874	1	1	6217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVn2Yh5orA1g7cxfr53EVic3UAaE3gtzu8DcZDmwbm7yKVmapD
43817	payment	1397	1397	1678	1	1	16407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYK3Nzep6qsv7ML5wzaUot3HMskAspu52TProxuxzAnEyU5bg
43818	payment	2134	2134	1874	1	1	6708	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFSq11mD32yuTYaPpcRM8udGC68P9o5fyzY6KH8ym5N4bsmxF
43819	payment	2133	2133	1874	1	1	6222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3ftrfvzS5Nrs7eSWUbaUoAHVBJy5P75zUehT7Y4R3Quf8bMg
43826	payment	1397	1397	1678	1	1	16410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrSzzsPZPBtmHv1kofLEtAJ1dQUCSYfBDSZbRE49iVEWs3eQo
43827	payment	2134	2134	1874	1	1	6711	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkj2Njj1mvyo1diWarsvHY1BDVPhzqJFbn9DyWnZwaH1tDRmw2
43828	payment	2133	2133	1874	1	1	6225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrDubpXYavqKTyJTKWtUCgv9KNyg1bYBes4W7P3t9jtQznjMk
43864	payment	1397	1397	1678	1	1	16423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSu2P3D9ocixvLompw9BfLW3nFsmGZiRdQRx2EMvzyhNEbKdN1
43865	payment	2133	2133	1874	1	1	6238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ULXEhrfbRwcqD3QKtJ24zwJT67ERo9bhh7YRycQBfwM5h7zW
43866	payment	2134	2134	1874	1	1	6720	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzFuTUmVvWFFcWdbd3L3vNWfyKy7H8138WpRMmyU9HgwMhjwE
43870	payment	1397	1397	1678	1	1	16425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBwoovDvtXkY8QZDH16MA5pMXFumDSFLhvK7ZwKki85UADKbK
43871	payment	2134	2134	1874	1	1	6722	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JgDUVGWt6NhafRi1fDTdJxG7SWAFursvL7fvfAJ9fah2B51M
43873	payment	1397	1397	1678	1	1	16426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ35hvimpMkTnPEpz52Pk5bhFAoSw2GNAAcMgpZn7tUnjp4MMUK
43874	payment	2133	2133	1874	1	1	6241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHMBGiUqubzHmkYgcdvCx7WrDLHGra4QBdT9dw7NxwoAuYzZhc
43875	payment	2134	2134	1874	1	1	6723	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu4Gn7AePdfsbdPPK5seNQMLSPTGQZTrMnEfCqSgJvmg45nNK3
43876	payment	1397	1397	1678	1	1	16427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDNhYvAjb7E8R2SNkLsYpCZgedYaAE4mMwYf1mJabRYoHzgVrH
43877	payment	1397	1397	1678	1	1	16428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5x384fHSLAtkRdchbUtTfShVYDzkkreve2cqhDYcMPgyWA3W
43878	payment	2133	2133	1874	1	1	6242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgVjZkP1JKpnTgGcDhxPxubn6Wz9PCAJgTcZqFt8T29tB2sDB
43879	payment	2133	2133	1874	1	1	6243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZAZ1kUGNWSTuB5r3CwZozL38oRmqHLkrh2YyikeKT1mvwe3J
43880	payment	2134	2134	1874	1	1	6724	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB8ATkNE7NJVArYDj23EuvYDqE2jZSn8f7NfxLAWdssjK6exw
43881	payment	2134	2134	1874	1	1	6725	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vetPrWp8AKXBRddGJU8T2BWEk9TmDkq28VftHybhzcf6bKxq
43907	payment	1397	1397	1678	1	1	16437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6bYJMwy8L3bUHpG7v5ifXboZUBYf2EvzBxiPMPi31uXPCpHBQ
43908	payment	2134	2134	1874	1	1	6735	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvt2nHyNW3wynT7ZuRx3orpqB9rz7RA2ELNaZXnTAGUtQUVrdy
43909	payment	1397	1397	1678	1	1	16438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmGn5x6A16JTNPqGpujbNXeQKuKH3GuMiXRGw1xWonUMRW8W1f
43812	payment	2134	2134	1874	1	1	6706	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ2C8k8gZhr3bKAqWYXYphbCHDBfDBwBrdXjc3FEFgvRBf9wUX
43813	payment	2133	2133	1874	1	1	6220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYP9kRH5Qv4oHZFAPUfMVWZWhxYUQX4Pn561gp6Pjo2HxrUHuT
43820	payment	1397	1397	1678	1	1	16408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCwv2DbaCzKoLfoZ6pGeNpjuSLWNQ62pCuSgSvpnJTTWNdeQq9
43821	payment	1397	1397	1678	1	1	16409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkS1mM6k6hfKRyfFBQVaYnHB5CycDqJsUYFYzDF6Q1r5ERjZFE
43822	payment	2133	2133	1874	1	1	6223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLzz7wTniJ9NFb8YVsLPwYRoJphhG5eAeemFwMJxnB1omHd6Mg
43823	payment	2133	2133	1874	1	1	6224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMKBC87yjy6FqY2xuTkyoomA5ZUERGi1U15YDDwrH8RNaPRWer
43824	payment	2134	2134	1874	1	1	6709	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxQ2imbBEP5tt6Tu2DoZMtrbVgjHtriRWS1Z5tE8pa6maCapW
43825	payment	2134	2134	1874	1	1	6710	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQiHJxewTBqQJjFCqRhxygTu3MD7L9TvZzv7Lo2qSLjwqvNgd
43835	payment	1397	1397	1678	1	1	16413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSnXwzgaWQKjoV4J6KMuaZ5T8j3i5MeQi4Q1kvssgLTy4yvsmE
43836	payment	1397	1397	1678	1	1	16414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmcUFRDTyEJzX95fYSB4ZjNH84nVntmiPpKvt8NGQVtSD5wsx
43837	payment	1397	1397	1678	1	1	16415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNq56Fvo3VB2qYdAb4dR2ebp7LASuX3EPq3CMcfb6FeCzBY4rs
43838	payment	2134	2134	1874	1	1	6714	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrsYKNKY49hokP7JWhgJMRYVvr7AoxoPHT7SXdgHzQcHaQsfe
43839	payment	1726	1726	2377	1	1	8330	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkKYPt2wh5BmgtFL7pPhcp8Qwun3vMmsewmVQamsVLnHmQYW4k
43840	payment	1726	1726	2378	1	1	8331	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYcRuDUsfCVaCEhuHU8YWBaf5A4e2cQ3rZtB5NBoviPkXa7w17K
43841	payment	2133	2133	1874	1	1	6228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruaP5y9HXttqdPjUJiSrK61cyekwjEvV2KPgoDvyqcVgMW8vw
43842	payment	2133	2133	1874	1	1	6229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCSTKRP3McFTsYnfSC8cQ7omYjpqDdm7kx3QrsMpzytFuduqE
43843	payment	2133	2133	1874	1	1	6230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkwLjwuK5DNbYGHLSPMdzeMHcbEPiEh9FpKVXez5siaAhAvzy
43848	payment	1397	1397	1678	1	1	16418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosqjVTFLu37ypfkp59axtZyZL3CkCt82ZBigxZgzrXRa5kN3N
43849	payment	2133	2133	1874	1	1	6233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ24CbEqMBJ3m26Luy622psHVNASyw4GkLQHR599pubsLxqbYsx
43850	payment	2134	2134	1874	1	1	6715	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxe4WiBPQwKMuXyxuBXmUdnzSxvcsss3Zz31c6opmbsup4Xhd
43851	payment	1726	1726	2379	1	1	8332	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZzZojVohq8EpidxWD9fdbzs1YZofHedve2wv2G8HDA1UsVRuhp
43872	payment	2133	2133	1874	1	1	6240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkLG8RPDzrG3mGAvpuHheL38rgqGb6gjD11EnfPyzP4HcYwhz
43891	payment	1397	1397	1678	1	1	16432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzBJQ7sJ7tADmXGrKdyFsSZ5Vp1877sci4Jm9pie1N3q9nS5nC
43892	payment	1397	1397	1678	1	1	16433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4XzA47msmG811Xtykv6mDPRUDaxr6UrMNVZWn2HQ4563JdCrg
43893	payment	1397	1397	1678	1	1	16434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShJxwGdn6kdAT4eFDiTG4ucJLCCxhnkcwxGxejtde1X9Cimnn
43894	payment	2134	2134	1874	1	1	6729	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmXHvj1tjnwfgkJBwUiLXf4YEcjU6SAFtSFHnhVPVtk1uNyBmV
43895	payment	2134	2134	1874	1	1	6730	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoE4AZdXMDbLruU1G6hnwfL6DYetmmAQ6yyJ7reizTbC7opGX
43896	payment	2133	2133	1874	1	1	6247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Zt95saAiez2sV5RnfqdWgh8r3ePgTZTCP7jvyzzjaXzNKp3p
43897	payment	2134	2134	1874	1	1	6731	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCET2mS5R8M9gjdk9s1Qk1Hj3rW3ZNnENHAXDsQybZQFjJzfo
43898	payment	2133	2133	1874	1	1	6248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7XVunnDP68iD9Mm8TTqTD4QYrkbKypJAzpp6JaYitAMPUb4s
43899	payment	2133	2133	1874	1	1	6249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBzKEWckfDUbBrecdkWpT1a4QHLxPAB7JgmHAnnuQkCS16H6wj
43902	payment	1397	1397	1678	1	1	16435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdeuxg5WExaKUx73gQ3Wv9CSHemUynxiVzzsbh1tU4gnUzLmAE
43918	payment	1397	1397	1678	1	1	16442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYRTMw2uE9CYJLYiJ8FpyRGbfhxZFMcbD4mSnAaDzTEKA7rNZy
43919	payment	2134	2134	1874	1	1	6740	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeXNFT9MX9bseVog4zHgsv68JogcvgTAwpfagErPYQBxggAit
43944	payment	1397	1397	1678	1	1	16451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasJjhXg1KGYYVQAAfbNfR5Ae1tPq8NCQnZb9kM6QCMdz3WEmK
43945	payment	2134	2134	1874	1	1	6749	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW8aim5W3sxb69GhLcnd5zjSgq16Mhu7cMyGZqQZdWQtEzzVyh
43946	payment	2133	2133	1874	1	1	6261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdnZByx81NoKLkNJFSHroLjXdySqHKNjnGZdLPSPNkGEF5yTeK
43968	payment	1397	1397	1678	1	1	16459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiCfM3KdXPFBAiri3d4WHKiBqhJ8vSAD76wvybknCLwcamRgCQ
43885	payment	1397	1397	1678	1	1	16430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRzEh1W7wUzXJFLaZNJgN7939aBrByVH2JMXrFSYGP55H2VK9
43886	payment	2133	2133	1874	1	1	6245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeEFbW7xAR6zmkyYdBgLDNdfTsU2xZLn5EmUGwtuHMVeXUoFX
43887	payment	2134	2134	1874	1	1	6727	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vEypYsXPVGAFw7DmDtUvfs6jPxioogJdVEHGD7WMiAqUnJta
43911	payment	1397	1397	1678	1	1	16439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKx7FaPp6NB3qpZfe5PVwjcr247RhuJEftvdiN2WRKyJF7SC8
43912	payment	2134	2134	1874	1	1	6737	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4j1FGDdnxnxD1cztzkjk7pGhn1hzpB193sZW3GNpv29svVqi
43917	payment	2133	2133	1874	1	1	6252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DWeS8cUnovkKsBFXgtzxwndbVAZayg7pWUFoJpdvbQ26QiYz
43920	payment	1397	1397	1678	1	1	16443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ69EZ2eHQc2GWgUQX3djZ9kHR72tsr5mAdCKTeKf9XECN3VmB
43921	payment	1397	1397	1678	1	1	16444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6VtTvdJ2LecgDa44he5MBmMmVAbLCWAnphKLF5RGshrtKnH2M
43922	payment	2133	2133	1874	1	1	6253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZrfUS4RzGYSnohkXh45DESTmJyBAMRcXbag5zjuYZNNqjHXEb
43923	payment	2134	2134	1874	1	1	6741	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAj5ziD3YVHvUp1REeFVuG6K2xdrzciTJjBeUGw8XGje8jeLbd
43924	payment	2133	2133	1874	1	1	6254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn3khgPKBbesJViwXuMYHZ5HeMUj1uyz5c9BnwFUGDYtWovf6x
43925	payment	2134	2134	1874	1	1	6742	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBRrvG5npzzK6WJ5xDoX7Ws162jKkoC84VjiXarpthGmq3cVdH
43956	payment	1397	1397	1678	1	1	16455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpWS4z2Fwmd27yKpEPd8G37zx9W1tT8Uy6Auaq8KbK2wYPihZK
43957	payment	1397	1397	1678	1	1	16456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjXzKu2dpRfrSyfAr7i8UgCepjjU4QjJgGcCtRNJVdEY9wWvQQ
43958	payment	2134	2134	1874	1	1	6753	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowKq7CHMCQgvTsrfQwSXB6SbRYHfdxcuubFdNFi6bftMN2oNN
43959	payment	2134	2134	1874	1	1	6754	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs1Q2Mt5aVWVscLWvKnaa32kvLci13CiqRNfTMUxeXRdEiKrfH
43960	payment	2133	2133	1874	1	1	6265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVCnwDZW9fPd6vxgnhw9k2kw4V9xiguVSLCFQwjT6JsqWJTAx
43961	payment	2133	2133	1874	1	1	6266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJDiQBDge2f5tU2Sk3iMSSpLn83bXqWqCVDgN3sGcBKaKrXo4a
43992	payment	1397	1397	1678	1	1	16467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwY3iieyjWUYPLHd1KLfiXPa8UqYCeBYmzxrV7zqYzkZEHxP7F
43993	delegation	1751	1751	1454	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV35dWN4Tjp7H8Ei2ztVuDktrT3g5oc9jBbA179sLp9KbDJsvK
43994	payment	2133	2133	1874	1	1	6277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7j6mD8puKUGXMRG23aDMg12ba3xx8TCxBYYgKb1ssUmWs6rNd
43995	payment	2134	2134	1874	1	1	6765	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG3CeBAQ6wG8TQrC5eRegDupcy2bHxrLXYQJqG2vLEosamFsxT
43999	payment	1397	1397	1678	1	1	16469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNY2nh9enQrPByqfqD5w2QKpDrgrmom7Ph7w4eW5vTA8uV7YG
44000	payment	1397	1397	1678	1	1	16470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomppR8YCnMLpT8JLE3ZzA7BpDFSuHESr1344ReKDCzQMHTx94
44001	payment	1397	1397	1678	1	1	16471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJmtX2f8Ba4Psgr4XL9u3dakRFphppZnbQvJvYSXuj7azhTJ2
44002	payment	2134	2134	1874	1	1	6767	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ85jw12wvCxLM81LziHfDMfbpAtojY6iw4Up5eoy7jgBEQNfE
44003	payment	2133	2133	1874	1	1	6279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApYn96Uf5G2J7PNN8AMkTCqVWK2izrbUwD4aG3KEpP2xZ8HwV
44004	payment	2133	2133	1874	1	1	6280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoB8ajLt7yjDeAdC3bSa2tZq6h6t7QAG3ptMtgtuFjrkix3GqT
44005	payment	2133	2133	1874	1	1	6281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyPL5pLMYCGuVij3SxHCZzkMZPPZJwtrYyoSu82ASeGY9TNJvy
44006	payment	2134	2134	1874	1	1	6768	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmwiJxLdV4a7utx1g86cDEzcHc36hVmLwFEhQsETc9pjEew6P
44007	payment	2134	2134	1874	1	1	6769	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2sz13UEJf6dD6z91tCstcL7gRrQv2QtCepNoXyyH8eMEEUBQA
44032	payment	1397	1397	1678	1	1	16480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4gdZu1AQyWqudsMF3E2BXKUzaC8R8AKpU13r1P11yA44WYEp
44033	payment	2134	2134	1874	1	1	6778	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW4p1YCKyFG69XUTkM4ZGSiZdS4TtKQgJbe1UDXoj9PiyvyHiZ
44034	payment	2133	2133	1874	1	1	6290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9L7XcsNWQ1cpZUVaPEgoJnPd9qBNjs8Z5ynf7ZN6QNtLXpz5C
44093	payment	1397	1397	1678	1	1	16499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36DPSRY4H5KesLXWU74JohLNLopv4CUZ8np6u2UbwqUpcUTsN
44094	payment	2134	2134	1874	1	1	6797	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdrXKoaAwCep6KEY8hk53mmXNKJB2XHCJqh48cY21mCEUZs6qX
44095	payment	2133	2133	1874	1	1	6309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2q697a31mVCYPPyN2aVYJC2UpWCsAq7SpuRnp1SgkqcQx423L
44123	payment	1397	1397	1678	1	1	16509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYspg94hZMuuNhQ7DGgHHG1YdWNYF3eb22kME7TCdnjQLRd5HLt
43903	payment	1397	1397	1678	1	1	16436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKotXkHtWtvXBWkd1p2qsSbThiLwDEYF24zqrfW8bAiLAEs6F
43904	payment	2134	2134	1874	1	1	6733	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjU1drBzjHsdCMGEcZCQKPubHVVNcFWFPDbztiYXebBWgPBCFM
43905	payment	2134	2134	1874	1	1	6734	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDYAJeADz6nmgEhkMfm5AKdMFnJvAhnWA9GWMr2ybCEk5arHi
43906	payment	2133	2133	1874	1	1	6251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4xNB2Q9sNHCAPZuzytWxbbQ1e6eRDKYKs28eDWnVFTYDw7Yt
43913	payment	1397	1397	1678	1	1	16440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDc9apvdxHXxDkBsMbnKvTLgYkWaE4bRJPJp6NXXV3WnsVcsk
43914	payment	1397	1397	1678	1	1	16441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWYGrhunkRCKNG54fzfyHWvqGLkfdWiRFCMoiEXVXrVanJdTF
43915	payment	2134	2134	1874	1	1	6738	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2DFp2RUQn5k1vTcodWxJckdwPgoFvBVDzAx7gRL7GPgC1C9G
43916	payment	2134	2134	1874	1	1	6739	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPtCxX6RG42uWNiijZeuagYXR7Amy1xkJkn1zqaThS36mKV5t
43926	payment	1397	1397	1678	1	1	16445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawvvU8NVkyHDE9ZLweBm5ayCyLE5MHgVnuofW8R8apjjxWpNv
43927	payment	2134	2134	1874	1	1	6743	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQhbXt1htqTrGbAvCMvK9Hz1uRMTGXYHGB9eNrkCdFbLkznjV
43928	payment	2133	2133	1874	1	1	6255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8BNNZjuMeJ4BnR8sUZFubLbfimpiyzRAVQi7utBj5T549JgQS
43932	payment	1397	1397	1678	1	1	16447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaeQriXQus5p5Ruw5CX9bFqaVa9fSkRi2m49e6EnK2kUGvU5wh
43933	payment	1397	1397	1678	1	1	16448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd3xWPMQRaMz3vX6dEWBu8aPEyH2M5PpX3gvRXfbAU6m7ZVY2u
43934	payment	2134	2134	1874	1	1	6745	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUBix48FtuN5uzjVFvDa1yr1F2eh5x6K39qpwbggauCQiVh5V
43935	payment	2133	2133	1874	1	1	6257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4SEEiXrDRaHekemCnaiK1pZbBsgbroyp2zeCrq6iSufePdQWr
43936	payment	2133	2133	1874	1	1	6258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWTWUrUppRT7HWWo8sVshJziYU3eknXDx5iRyYb4gYhjjdtiD2
43937	payment	2134	2134	1874	1	1	6746	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yu3BNPThHKraUEK234TFm2NrfwvHDsvncY2SGaHw1MnRLU7c
43941	payment	1397	1397	1678	1	1	16450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXatwVgk9rfMHxbLSUmuni1YSLUhia56G2jX9tAZcnikUYWffF
43942	payment	2134	2134	1874	1	1	6748	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQHZHqfcuAbHDVLTtukVH2VShBbhnhph8ri3gdBkh4EfuE9X7d
43943	payment	2133	2133	1874	1	1	6260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2hgsfQfGg4cgYtLEwN5bH4zkujWUtZQPasLz3Mn44iao8Nw1t
43950	payment	1397	1397	1678	1	1	16453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqz2qr2UTRvc16NBHBpFFWNrYanyKRgEg3XiZFqFRFYJcpFwMS
43951	payment	2133	2133	1874	1	1	6263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGJSsLKW4nwUNeVS3xSv5EruchBFo8QmmoaXKqwDeqKLARoxs
43952	payment	2134	2134	1874	1	1	6751	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1JFCNQaS6ykVmGog8vzX8cCf5JBGY7VwwyiQxrsWGy1Tv21WC
43965	payment	1397	1397	1678	1	1	16458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxSNHzzZtWL6JjHxCvMiopHnap24c5H28iMLfPSg49cHSSgZy
43966	payment	2134	2134	1874	1	1	6756	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXAjL7ngJ1bi2kwKW4mMYePRRFXoEpdEyvCfLkmapUWVTparhd
43967	payment	2133	2133	1874	1	1	6268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVWYS6UYUe22jMpeYEvyECnXuLK5AUYjeS2pkFVH3zxEM7PpN
43986	payment	1397	1397	1678	1	1	16465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgMci7rgy3pHWa8Z95o49jtn3TQFc5gbUpGY75WvxWXk1webvJ
43987	payment	2133	2133	1874	1	1	6275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzLqEdmBQgmiyEHPgdF3t5NiahPnTkKZ6bsj4KXTyvFndmS4D
43988	payment	2134	2134	1874	1	1	6763	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYypS22QHEdvqMUKLnHW4s8HuVoVK1SpSkRDFRsGEpergkTBaEX
44011	payment	1397	1397	1678	1	1	16473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJibYZREWqz1ne4LPCDVGow51EuspTacannabHYSfMfXaMFYGz
44012	payment	2133	2133	1874	1	1	6283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnw3ps7EjR52kdXE3JUhx6cmNX9bLUKucEy1Bdkk4YgG9pPaP
44013	payment	2134	2134	1874	1	1	6771	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7xxeFsTjEbhPuZ4qhdSNWCCmkMBb4LU4N6gviRnHGnEF9QeL
44023	payment	1397	1397	1678	1	1	16477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZ5sv76LdGdjE2JuQRJ4SseVGw5T4MfZkVn8amf4FQpEWSK5j
44024	payment	2133	2133	1874	1	1	6287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSeu5683nqRNQPfVUaZxJVqJGJATX4WKbcAfHSc7M5Ybipz8rV
44025	payment	2134	2134	1874	1	1	6775	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ia5UbCcJHPZg1bK2xBhCsDnrrdfBArHredJC8TAyXSFjzqLN
44047	payment	1397	1397	1678	1	1	16485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZjx7mY2MjFQiL1XxFvyUTccqUNBPKzgecZTk4wAM87mS3JnB
44048	payment	1397	1397	1678	1	1	16486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRkk2YZ6Gt5wimXSmFb4tbqMPQD9Q5goKg29haFS1y4uae8Qpb
44049	payment	2133	2133	1874	1	1	6295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCp4MP7ipH7wC5cZzZKW2dwe6mjMUto8N6Pfeiz4gDwY2HXGu
43910	payment	2134	2134	1874	1	1	6736	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcxKXT7kDHGVRnZ1J2yYdKHjZUJS4dFdWpjWmpBLAA2d1JCDBH
43929	payment	1397	1397	1678	1	1	16446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqx7K4SMoCfUGj4HFJRwB5a5Q7fft5r9fcGa2QcvBS9mXQEFsV
43930	payment	2134	2134	1874	1	1	6744	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfkqbGFne92yLcf23ERwhcRbPn3J9GiwZPN8ekRUSdL4uY9zM4
43931	payment	2133	2133	1874	1	1	6256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhidtiKfcw82MQicXqeFSadvgJUY8KNpdrodeeEqEb9caYQz12
43938	payment	1397	1397	1678	1	1	16449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1n19iH558ADiHbwvxfrpwYvCsnbbSJDLnmgkaqEtoTkKTi9t4
43939	payment	2134	2134	1874	1	1	6747	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv7kgyUGcFZqk36Ub36XoKMQMBU9ocRLXivzE6vQixrDWGzj93
43940	payment	2133	2133	1874	1	1	6259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhLePKDheUdXW7MxNC1zJgNjqgozuWUT6gZPhhWsBsGFCN212
43947	payment	1397	1397	1678	1	1	16452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzitng1ShJuSCfkB43vuVCrvHr97Cp5f6io9VfDFKFjFxmh5xB
43948	payment	2134	2134	1874	1	1	6750	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99m298wump3WL619py5MZmmzP5dG9eQQyePfGwXZ5cgxUoTbW
43949	payment	2133	2133	1874	1	1	6262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3urKykL9wBn3fPdQsJDt2GQ3DWxFiKwwHFJLaEhNBKWWJZ6X
43953	payment	1397	1397	1678	1	1	16454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfGxr79WaC5BFhZEatdtxgTXHR6TCPxPwvY6XAT15e6Lrisvs
43954	payment	2134	2134	1874	1	1	6752	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUjN5kHzRRWDh1MkZL63UMgYx3Dzxoq6cpWP7ucWcQdEVAEmRm
43955	payment	2133	2133	1874	1	1	6264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhe64Ltap6Fr1AAfqKSFrPgjr936E2Lsz74T4FBTDCiNoeuxAr
43962	payment	1397	1397	1678	1	1	16457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRR5zb3FP2Q5N8E955ghPMDefU4rgAktfBcdofoWi1TCqrgYsH
43963	payment	2134	2134	1874	1	1	6755	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzGk6sHL3gqzLNQWznkkMULVEUopfkmVQARWzDSabGzqQTBkT
43964	payment	2133	2133	1874	1	1	6267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5nXY9AcDc9rr4pBVq4vCCLmok1RWpdUS29JuUrcWeRyk5jJ6e
43974	payment	1397	1397	1678	1	1	16461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1QCbSMnh62gtKLaAqgsLiDeFsYcSw9aXxW5LKZQ3wa9pm2Fr
43975	payment	2134	2134	1874	1	1	6759	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbi5zNZrVTpixDameBdxKLRAJdWkBqsB2GTsMf13M6rohdtXCL
43976	payment	2133	2133	1874	1	1	6271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttvAetmWsqin8iSA9Rzef7uu7vyN3LBXu719MFLxHBv13de55
43996	payment	1397	1397	1678	1	1	16468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgWcp4vLz2Pc35o7CGShRVf6Cerdm4ScYS163evC3S8JLR6M1
43997	payment	2134	2134	1874	1	1	6766	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVFpaEWbpJ9qgCJK3j77FzQoH26h5SNS5f9cXxof7HXzxZDrr
43998	payment	2133	2133	1874	1	1	6278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmnnVh1Ei4r7bXxhjq6qhH3hg76mLTWY9kM1MGhNapXAzZAUm
44014	payment	1397	1397	1678	1	1	16474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDbKNeiw3Sav7pTAgeu37zbupNidcBThUZi8pd1QRA8NZ32TR
44015	payment	2133	2133	1874	1	1	6284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHcNUZ45AA2KPVkmGJSwANmJi7NSoRK5Zg7zfanezaCF6zfF6
44016	payment	2134	2134	1874	1	1	6772	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtU1FPA9AE11NzuBfhkQCdPjRC3s5yi5c2B1qNttGHmQGvSAPa
44017	payment	1397	1397	1678	1	1	16475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YCnKF9oPyVEzoK7igvK5zHd9u2foNeMiATsQAEArE7G436fy
44018	payment	1397	1397	1678	1	1	16476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWS1LShqaj2RjFbKw1veAtWazzeg3BX5HXhA57A12yM8RG1HU
44019	payment	2133	2133	1874	1	1	6285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkW9GPgg2GZ117MPBewvWqM1zJUMDtdEATEVj5bUD2biUXvQM5
44020	payment	2134	2134	1874	1	1	6773	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSE3DJnmZZDUNQReBe9obphtZLKXae73ygT6Ewdw1Ks71GmgvV
44021	payment	2134	2134	1874	1	1	6774	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJa5ph4yp5NGBBqQmtKXPBdf7h7Y1pT9hjr86MxPsDbRPahkQ
44022	payment	2133	2133	1874	1	1	6286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnEBf1zp1bsGKHLJfezYyxAwyGSgY1XvvHKtPHhcvAZkTdB19
44026	payment	1397	1397	1678	1	1	16478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPERAscUQvu7LJzvwxiQAD7YGt6YSasPTCQpsXqQ3XPD2oec7e
44027	payment	2134	2134	1874	1	1	6776	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN59JopGDSf4Hs24fVXUHCrNhWeH7veqHd2LeEDDUG6nHeGVrF
44028	payment	2133	2133	1874	1	1	6288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACzecGgvdJerpgSwKopmia7nJ6fM4kNZs4Ly6Ubeypw6KvALU
44035	payment	1397	1397	1678	1	1	16481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAicH9u4zJsxBsoUeC9CBdLBSKop9VSHdxzzLJ1oPygUFHwrJd
44036	payment	2134	2134	1874	1	1	6779	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDVf2cpWQSPmLJK2BTwKnBEqNwxSk7WKrUS3bpHCgHEWEey82
44037	payment	2133	2133	1874	1	1	6291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDXsZSqGyLaZtNasv45sY4JxV6NWEUBjKkMsfsUmv6TFrstRfy
44053	payment	1397	1397	1678	1	1	16487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWaxQtT1aabP2a5MEYFVkUWUNeP7qETUwtSf4S5mfwnkVLXgqC
43969	payment	1397	1397	1678	1	1	16460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiEckMPbHuCkiDgYZBbjMUuiu97Jf8gZoriy3AGH9KJP3FjMk
43970	payment	2133	2133	1874	1	1	6269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JUmgU3tVUv2oLhcPbsCyYJ6h1pdKUtUcToUvFfewKL2GYbEg
43971	payment	2133	2133	1874	1	1	6270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcEkRwy4pccda5Fh3t5dbPUccih4dL1sqR1XLYNZBCvhuqFex
43972	payment	2134	2134	1874	1	1	6757	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVUTgCbwTE5CXm3wncHU5FNowZfJAs9x1aYFSSgfqZqigYFTg
43973	payment	2134	2134	1874	1	1	6758	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2brSAqFZSLKi1enTm24TGZ6XciUmWSt358W3crChnhHu9FNxg
43977	payment	1397	1397	1678	1	1	16462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1ULjEWAwvj2qTk7rX1odC4KcBLcWYo6C4FBwJEMU8d5MjhfX
43978	payment	1397	1397	1678	1	1	16463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsHpBBM2UbTRGfQgFAtdLYrCXQtWSrgSPKF7XnB8TUYiccJok
43979	payment	2133	2133	1874	1	1	6272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSDuToES6tebBi4UhmGuSYKGNaxnMgiuwtiUgvbTTTc6qiD3PF
43980	payment	2133	2133	1874	1	1	6273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigqpSihey9kZUGs29fD43qGsA8YD6VxDto3n85f7tiBvUBUrJ
43981	payment	2134	2134	1874	1	1	6760	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBLJcYb6uv2cE7Dwgx3GSKjddGzbtC2FQgae7zDH4xkkxmctG
43982	payment	2134	2134	1874	1	1	6761	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGsTQfVrcM2VFpx8aNLMTg3eAa6Hi3AhmEvB4hfqEWpuzHMV42
43983	payment	1397	1397	1678	1	1	16464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvsphagDn4tvnv9JrfwTCDfBGaR93XiwzXFcUSuY8SSeDZCY81
43984	payment	2133	2133	1874	1	1	6274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiGVCQRRWFrPmSdeWMg2uLYNYNVfpauwFARewQGoGqLK6T11v8
43985	payment	2134	2134	1874	1	1	6762	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1PKN7NVaNvKJsxkDHdKLjTrvCYamDM1Jytd4TvK9C1ojp2iU
43989	payment	1397	1397	1678	1	1	16466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXgc3DVcPFsbyHSiZn1ufiG2YLXbnKhn9TKVvEvFnqeEJsJbJo
43990	payment	2134	2134	1874	1	1	6764	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJaCWDrEj3nm5Lddh4hTP3pNAscL7oHSxecAqTkY3AVaP3yCK
43991	payment	2133	2133	1874	1	1	6276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf8CWDjS3jHbJAYbLNirbHN1Hv1ocZbXn1b3gS3Sm63cgxKC8v
44008	payment	1397	1397	1678	1	1	16472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpz1LFhM3xhZYVzya37w3fG4Dq38ZfF8vfFqb857s6qCNSzGtH
44009	payment	2134	2134	1874	1	1	6770	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpdVvfUyhEBerBrbRa6jgeP2n1oYNGTRG3hJGVLzexBCWr5Nvi
44010	payment	2133	2133	1874	1	1	6282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAZjSAuHzcmtCxFgmxnJvEidJSWpZnZTAsirCwdhMgVcrCtid
44029	payment	1397	1397	1678	1	1	16479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbj55pAxHx5BKY2cAGCnSTjkM9bT9c94QFJ454FvcLvea5fpXx
44030	payment	2134	2134	1874	1	1	6777	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHaKqi7QpVP5BoBe56wooXKo6wVMqr1ENNMz5cQFgS3vYSpoM
44031	payment	2133	2133	1874	1	1	6289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HgsZCbf5uBR9LSrfJBXRQn9XoadmACRtLAKGbVsRfLzWRGGC
44038	payment	1397	1397	1678	1	1	16482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMe193qaT3BAdsoB4AevJ5JHHxMkxNfWfcgxQHrXS3rR76HZr
44039	payment	1397	1397	1678	1	1	16483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdmM4gK2KiGMBWRHJAPL9ohjfbawF9tjYMH87FmtiXmymE8Za
44040	payment	1397	1397	1678	1	1	16484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QvtMneMAD424drkfFiz2mE9x5c7QshkMYoSv7idrCcqiFwNP
44041	payment	2133	2133	1874	1	1	6292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRshq7fWQYwe8GGxFaEp5PKmU79qer32oL7uHSLq6DnhGCNc71
44042	payment	2133	2133	1874	1	1	6293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJXX7wLpv1q3TVw1zupDfHsXhGnhD8US8EVitorGPJZAondJq
44043	payment	2134	2134	1874	1	1	6780	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVmXvaXRL3uknEjUXPdz6wbtkjdGAoqn8gf3ccLfqRjMfHhGKE
44044	payment	2134	2134	1874	1	1	6781	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmnDMrzq4ikjnZRhjR1VdfDGRCV8hEizZKD3E3WDevAqspUt7a
44045	payment	2134	2134	1874	1	1	6782	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxafZLj7FkV8fxntMPVw7Ft5LiFFGYdapaKpDC4tAh83RHxyYF
44046	payment	2133	2133	1874	1	1	6294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHMShkpaMCadEk8yqe7Zv9wUYQwdLCbLDZnJjY89iQvSe8oJP
44074	payment	1397	1397	1678	1	1	16493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMwi9CnBjACHDVbPGNErBSySsMNTmTjYfz3vJQWRpja1p3Zhw
44075	payment	1397	1397	1678	1	1	16494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgYsVCgqwm7jHLJvQzRNggMYrkxBig84HuSfsQDYq7cxVMCgG
44076	payment	1397	1397	1678	1	1	16495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwUBQBdv3obvhXFBRVD7eAKNahrofFj12VctZ3X6B9gTZkdDA
44077	payment	2133	2133	1874	1	1	6303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZj6hiUjWsiFeNQR58KvYJkmoGJoCUVUTXbGvf1oPDzhGkgdr
44078	payment	2133	2133	1874	1	1	6304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHt4AuqfJ4qTM4AoMtxb8uuuudScWdtBKUz8mnBtB4XpcfQ8qK
44079	payment	2133	2133	1874	1	1	6305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUnkmvvAo1mNaqyeYhhj3LwTNngMbdd5yaWevThT965jGCXBe
44050	payment	2133	2133	1874	1	1	6296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajWcwKMaDn6by86h84wTCgMwMjBGjPgwTGGsm1NtBQS3L72jR
44051	payment	2134	2134	1874	1	1	6783	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrP7eb1qjiZYxMgDeu6w28vtBwNDquPYzEBemuHJ7mSpSnvqvc
44052	payment	2134	2134	1874	1	1	6784	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWSx3LQstMnSwWBL9srZXBP8dL3hyTpKR9ysdHSbeh9Wqta7k
44062	payment	1397	1397	1678	1	1	16490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAjLdq8X7ZGAxBKTgAqVmNF7ruyuQE4DXYThWtSCpL3tT5Joqp
44063	payment	1397	1397	1678	1	1	16491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQDcFZjiupytxHMkNHpd4djnAPm5f3p4Aa2UyZMa71THn59Xd
44064	payment	1397	1397	1678	1	1	16492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxY15e2JyZKt94BV2phSGhGAdCARQCsG5bXu2FByuBzuZyRGXq
44065	payment	2133	2133	1874	1	1	6300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxCcWSKPuZYCYg6QGGxirSRhKGL8raGX86XdAqrZEvubiX94u
44066	payment	2133	2133	1874	1	1	6301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRTahYzE4BH2bJtbWBLzkWQFMV4aGKGQjrQKNcCwMY3GUzfwwC
44067	payment	2133	2133	1874	1	1	6302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTr9DQ1CVhbDCwFdRMmsYTMKBeUF791Xpnc4UYVoSdjMq9MvYa
44068	payment	2134	2134	1874	1	1	6788	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifGxJZ1QqjT1thyeSgRAmvFHUbgDFm56MF5ybpXHvdLeqPToT
44069	payment	2134	2134	1874	1	1	6789	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrSs5SeWkbrf3UiHMPGdmQeNuRGXsmTLr8oSEpvpvi2guZmT4k
44070	payment	2134	2134	1874	1	1	6790	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtmuUPKru42z2NGTERcVixKBCaZSS9pi9BYX8MexU34AvRRdbx
44071	payment	497	497	657	1	1	2	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DneypZpmXYHuJpkRgisWbpmZ3BHcpL1onUQQCJUdpncMTrZc
44072	payment	497	497	590	1	1	3	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpfb9S17nmPfJj1EJQzUhg3RmsmoeMGzW1P2X6c7czdUkPZWd
44073	payment	497	497	553	1	1	4	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Jz3uwwnfHaR1TALMEMZxhT6wfnGcPhd8FZXEyZQaQV3vCWYy
44083	payment	1397	1397	1678	1	1	16496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPDKhKfKKKMQBTuNsnWSndjniVNfbqYLcGsKCdRz3YQ2MZdDpA
44084	payment	2134	2134	1874	1	1	6794	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83msMrKwxWf54UdVW6Xp67zVZ2Ga47rb3PtWMUBynUh95gjYz
44085	payment	2133	2133	1874	1	1	6306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSWcPhV737iD3bQbchC7LZSLKx9AxbuTbwMpaEWHhiz6Ph9CZ4
44089	payment	1397	1397	1678	1	1	16498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAnzvnuet8cD3PCbozWRZdw7eanpWC45B157fEgSRXmCqtq9H
44090	payment	2134	2134	1874	1	1	6796	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBhGjgyQHFYEngyJioCK8krAA4sgBY6aCQUf77edVBLKReNjSc
44091	payment	2133	2133	1874	1	1	6308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJ6qfRz4yT7fpXyHs8pScRDC3ySrJyur2hoTookaiPTe5Gh4o
44092	payment	1726	1726	2380	1	1	8333	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaKa28v2u517LRpEstkWC4knRLP5GmHKEfGoc52xL9obUPR58HN
44099	payment	1397	1397	1678	1	1	16501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUnyYgmcr1hQ4QeVfMWWoHorCcysFW9KbakFAicicFTA4U6NCF
44100	payment	2133	2133	1874	1	1	6311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFacJtu1DhK8FB9QhC3o4cpGFAswKKeu8oyhs5gnytaz5NawW
44101	payment	2134	2134	1874	1	1	6799	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LDWWdaqob8b63xpMQvmAhT7tzuTnvfn3LyCdqrkbkX8VenfJ
44147	payment	1397	1397	1678	1	1	16517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkJCXPLGRUtBirzFxqC9kfxqNainVeJsH4FkrW65sLakCJX8i
44148	payment	1397	1397	1678	1	1	16518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVq2TWa6RiPE8oEurHESXNuN57tHQoVM9Co6eGjx8EXB6FrsVe
44149	payment	2133	2133	1874	1	1	6327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxRXcYEUXRK2MaiS41qNnHSMjFh2h7dGVogRAwPyup9TjCzY5
44150	payment	2133	2133	1874	1	1	6328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TBqjAT749wKwFmBNjB4PaEmA3KrYu2ajJLxSSdMU9zRjk2Gj
44151	payment	2134	2134	1874	1	1	6815	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZveJFJshDEJ3Ph82sXAoGSp5hSGAQehy7yks9SjWGcaUX5ni
44152	payment	2134	2134	1874	1	1	6816	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxU2MZ6RhKVHNPsoaai9UczzECNqxQNVnnBbfkPzFDWGDzopHS
44177	payment	1397	1397	1678	1	1	16527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYymFQpR19vWD5vXQCxwR4zZwomt87YUoPU1AngvWQZv73gXr1Q
44178	payment	1397	1397	1678	1	1	16528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTpFiP1ucRPsq9wQEjx7TD46V23EGktWir2eQrx6ca6mMQqPs
44179	payment	2134	2134	1874	1	1	6825	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvgCP3fwTjK1cbJLce7iPGmRS336PjpcKyG741vaDjE8ijbzCx
44180	payment	2133	2133	1874	1	1	6337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoV1MH93T6h4BfC69rELkxYK4ECcYAJ2BwSv7iyRPCbVCfe7Gu
44181	payment	2134	2134	1874	1	1	6826	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8bJRKbr6YTmb8Qn1JUtAqfWGJisV9u9ZSJuUcvP5RN8xCD4y
44182	payment	2133	2133	1874	1	1	6338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuRAkeWnNkbh124Uh3i51x8AjzzaULPqRmS9oJbcHztdE2ia7
44186	payment	1397	1397	1678	1	1	16530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHkYBg6LbcghGq6gKzno4TxMLqfPWZdmMA2ifZQ5BKMgS11WN
44054	payment	1397	1397	1678	1	1	16488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHuEmtCMA1PVwN1UsopputCtpi8RAuKuefwXqSoLbPKkdQgLp
44055	payment	1397	1397	1678	1	1	16489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1mnL63KztZpPrvL1D8xvR15mBo1NKbSHaTQUraV883iqUTVp
44056	payment	2134	2134	1874	1	1	6785	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8g2pyEE9faDWFhb1ih3Uw3bMRj9WDDHYeVVkyamBb7iPbUnf
44057	payment	2134	2134	1874	1	1	6786	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfW5Bpa1WtkZnzZVxDyfojLz78TtKCHgVENrjaypsaoh2pvsG8
44058	payment	2134	2134	1874	1	1	6787	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY2wK4e2B1EHBYpJoAR4gEASypTHeNJjJhhuvB815AyydfXHXM
44059	payment	2133	2133	1874	1	1	6297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKVKqF8vscBXQdv3VkUJvQUQugx45P9sod6yWi6CBq8RvVk5Hn
44060	payment	2133	2133	1874	1	1	6298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1f6r5FfYnnMDFnFaYwjsDD6L7W1M73ioLCXomR5sKgjbL4FC
44061	payment	2133	2133	1874	1	1	6299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLoJZMQur33bvYzFLFdt2jDN7yHM8jdHUkobPYo7sEQekdgEM
44086	payment	1397	1397	1678	1	1	16497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbprhU3hMnAoAVRQfgqBVvZ5k2anqRjTk1YjLo5FaP8DBwuXX
44087	payment	2133	2133	1874	1	1	6307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNejQvZpYHBc1YB7n45rJUaRU6SASMbM9UszLtB5fCkra92E5
44088	payment	2134	2134	1874	1	1	6795	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwbqyc8XBhaTDqShXSz31kQmc2Zee29GUfVMcbUaqFToxCXEr
44159	payment	1397	1397	1678	1	1	16521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgaxCujzPyX5YqtqFkSWxYES63xsnfUSLd8QBaiXHgKxSi9rH
44160	payment	2134	2134	1874	1	1	6819	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9Sy4bLUDajroFgzK5hcitYCon9x4zcMAZFTf2nRDxssZsGD3
44161	payment	2133	2133	1874	1	1	6331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCkZypqefK1Q3LdFhocctWZoQXFg9ngksbuCjmpJbeVtex1TQ
44183	payment	1397	1397	1678	1	1	16529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5U3sjnQawwJ58i2Ki7HqRLJo23zv7pHTLT5t32doyYdKj8i1
44184	payment	2134	2134	1874	1	1	6827	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAinVcX6JijJYAanF2S8uNrfQHUa9ToUdBLekW9384Lt7GG7p
44185	payment	2133	2133	1874	1	1	6339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qbgcqFQ6nqgCjwSEFX4vUKHHEQNjhcocKWZx1N55rjedyMcH
44192	payment	1397	1397	1678	1	1	16532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpKLC7oRqj6RUctEe3ktaUuC5kZn1vv26XP55E9q7YAm7jy961
44193	payment	2133	2133	1874	1	1	6342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoie9qRhBRrZiLsX65zzruQSZVofiodCAdviHGkeXFjTS27Au
44194	payment	2134	2134	1874	1	1	6830	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vtHY6rjHhABs1zpPsMXWRxhv9nqpAynRmsosiKJbx21bzFVE
44198	payment	1397	1397	1678	1	1	16534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhufnVktc3LGciiKksnKendkSFYYubm4k8Ry4wA5PqEGxcpzU
44199	payment	2134	2134	1874	1	1	6832	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWc2UtGWjXR7Hh6RPC26s5C9Dszmj6SmcKNWZPR8TqYriWV8uY
44200	payment	2133	2133	1874	1	1	6344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxeY1zf46vRje8dcE1e8kYYwdDJmMm1bwUGfEnrLiQCquttGKQ
44201	payment	1397	1397	1678	1	1	16535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwQB5JVMyBNpKxfgb8mmYnoaSMXGhaWpGVeBN9PjCz7SfRe8fH
44202	payment	2134	2134	1874	1	1	6833	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRrG7rphHiVL29dwfWXJuqYhydKgFRYn513fthdXJciCPE4Vrx
44203	payment	2133	2133	1874	1	1	6345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQTUbQBS5vZzWruiNy97RiJDiHWc4VgW8cbh9Uuw4QpWXjnE3
44210	payment	1397	1397	1678	1	1	16538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3epdxU9s2nmwEjrTPgYKYSGseHNsemCSmMxefuz7uAd5VB5cX
44211	payment	1397	1397	1678	1	1	16539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5xeTGrdgGeLtMJuxAwAogGcwn4QrX5RFMzv4C5Rzs5eXzpST
44212	payment	1397	1397	1678	1	1	16540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5eowVq3cNYANrBKr2WpR6G2FYbaaGwiJQvTe7DJpTvvvn24V
44213	payment	2134	2134	1874	1	1	6836	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1WQQMAjwZqcvq43uxnk1ThpbK7GXbo2cMSETJtyTzTog1EzJZ
44214	payment	2133	2133	1874	1	1	6348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BpAXTKe2zjSajEDwh8WtHxgXRZe27BMwzxhr9xprLcsdmvey
44215	payment	2133	2133	1874	1	1	6349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgSKGuUM2fZwxTYvDB6syuCYmeVZWZJFK2smbvUiohQx7fif9
44216	payment	2134	2134	1874	1	1	6837	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBMitsbqS9iJoXvknRzDXgAz3uXnJms29UZdi6b6fvGAa28sU
44217	payment	2134	2134	1874	1	1	6838	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZfe3khYwRUZj81SZi8jfPuQZwh3ay2VJrPcLFno9bVsSJdge9
44218	payment	2133	2133	1874	1	1	6350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJq4MegXDNHJXpoaCjkPDyanMeoTg8xR4Ug55s81egVwBWPqg
44244	payment	1397	1397	1678	1	1	16549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJwxV9e2Q4bCY9Sa4PJASv9PUapWMk2ZoqJK49AvfiED1mq19
44245	payment	1397	1397	1678	1	1	16550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoCu2R64aeVukuTJLF5vXYhde8ugtjj2NHMJTBgtt3u9ajqceP
44246	payment	2133	2133	1874	1	1	6359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTgvZ6dBebjiwrnnSsNWbUmSxYrUz9iHooXL8Q3hK2r8xrnRjU
44080	payment	2134	2134	1874	1	1	6791	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKgzqe8uHc6f5AD8qp1Xa33ahiNMXX54cx2LdgG1Nct6cYvuL
44081	payment	2134	2134	1874	1	1	6792	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6U2g7vegtVgqDXAMnVDZpy7aW9v6R8qPssuVmVy6iU1ps6hu
44082	payment	2134	2134	1874	1	1	6793	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFh5TdmrBktfUczEogtADGrNkpkH1L5VAB6nAq3W9ZwdXGU9U
44096	payment	1397	1397	1678	1	1	16500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX3LWHc3gC2vBYWPoXXTrnpYKAvSn9SKwx9F8dxZCeV8JbNk6k
44097	payment	2134	2134	1874	1	1	6798	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvPMNimgiLZgmcmhmWFH3ug7yT217B1aJefYvfp13W7z6YVqT
44098	payment	2133	2133	1874	1	1	6310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGRf2cWcj75poppdgkgBp1yFyVN7TkSDEuRGZeXypaYH5F7Nx7
44102	payment	1397	1397	1678	1	1	16502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdBst3DnD1djTmqm9hTGRePq1wrQJXekPBnosgCKiSBvbM9y7
44103	payment	2134	2134	1874	1	1	6800	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5TDvYhcrNvgHKRdqqB4mZqgtdt82bndty6Z96BQPWsmZ27Gw
44104	payment	2133	2133	1874	1	1	6312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNPcs3LKKZ3UWEFgsdYiBWCGuGeJ5pDsWrvhrNN9eBhzitLMv
44105	payment	1397	1397	1678	1	1	16503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ai8wrYsRcfH8Q7PpDG2sAwj3q3PjUoBT5vgNKPtCgB6wAFps
44106	payment	2134	2134	1874	1	1	6801	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydkkL7Snhhgiv5UmhoL3VcjiiaKuY8Jm9qU5X66HQ4LqpjXTj
44107	payment	2133	2133	1874	1	1	6313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNYBApeSixbNY1u4WjgRfdcdytFzUKgMRwSn8nzaVsRJRzJX6
44108	payment	1397	1397	1678	1	1	16504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Mf7aCFRJ2AcLkYMfWBhNeytQ3wM6BVWyAafhHq2abccGFqis
44109	payment	1397	1397	1678	1	1	16505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Pqu8bMutc3Dw25XU3rbuyaMHXS5x7HYXZBXRSFnjkr1MqToj
44110	payment	1397	1397	1678	1	1	16506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZefu2duhTk4kCTA4a1bP36re3ZQcgUaCJPan4pEaDmSb8wQQPb
44111	payment	1397	1397	1678	1	1	16507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyv5H54nmvq4mmP7V4UeEjigxsSHx4jmXBUBPQAqDVsuv48dqB
44112	payment	1397	1397	1678	1	1	16508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8iptGQBYeAaSufLAQPZQQdMo4HPVDYgkqN9ZdzRbH8btxaU9
44113	payment	2133	2133	1874	1	1	6314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG6CsHni947yQPUAPBCQk24Yrphnj3AvQVTjKYSnoTuTnH1s5
44114	payment	2133	2133	1874	1	1	6315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXXDNK4byui7CeKSKSEDsMPz27PJKjjfP7NRfb7zScooLQ92C
44115	payment	2134	2134	1874	1	1	6802	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMnwpdqCpjD7FKSU1oz7vjsvATp996Cw7VdNiTFYGEz3EhiW8q
44116	payment	2134	2134	1874	1	1	6803	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa2SkvYQmmYwNHV8DCRcxCuGJ6Mi6mB4oFavZFhNsaySqEi2HD
44117	payment	2134	2134	1874	1	1	6804	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgn1dXy53UyxDLXTq5dh6WoXEMyhGJedAKvTt1Fg1GDdaoi4jT
44118	payment	2134	2134	1874	1	1	6805	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMYzSETVBDrpERzpELoxiq7dvXVwfVMtU8p8vvMPoLhRj8o63
44119	payment	2134	2134	1874	1	1	6806	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ137YGVg4ziy4B3gbbcFkko6AStSKU1xD4Qdm8TzqF9fSybNDZ
44120	payment	2133	2133	1874	1	1	6316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsbhegcbXVv64iQBMFdJXyjKbQgUecUDGTLVjH3BDTigyaEhD
44121	payment	2133	2133	1874	1	1	6317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQeBix4tV8BjfpSYyyqaWo4u2U1NbCxNP7gasFPn14VsTNDrWc
44122	payment	2133	2133	1874	1	1	6318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTtPzQn5vemtAHTF8RH9WMZ22eqhYEAnwZtoNJUM2711DsDNh
44132	payment	1397	1397	1678	1	1	16512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T2Y8QbrANciG1EtsjyqmKf8UqbAxgT7VrrqSzczPiLJ5Mkxr
44133	payment	2133	2133	1874	1	1	6322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8zCekPce4sobhTtp7tM2NpmZyQZRt19ScMY741abUdJNaa43L
44134	payment	2134	2134	1874	1	1	6810	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSCZpZmzAGe6WmqwyNxRAYZJntrSg5PeD5YVYFf6FjvHnhYWub
44162	payment	1397	1397	1678	1	1	16522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa674h7cWr5owZ5nav3uCivYG76xQj3jXDqjVoxcgcuCPh2J41s
44163	payment	1397	1397	1678	1	1	16523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAMRxjxzD6YARqWNf94tAL91VQCcZGn9P2m46j5HQSpujGM6dt
44164	payment	1397	1397	1678	1	1	16524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkhjwNnaM14HnMyRA6hX3pLEZn9fX9ZGYLYZHu3W9JhmjikEQ
44165	payment	1397	1397	1678	1	1	16525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FkCRKMA6GGkf15wUAAmRgT2iUXxJzXVEhCk1LFnWHWsdHJPN
44166	payment	1397	1397	1678	1	1	16526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5rGdyjbjmCBUAZ2FSvWimrTXbMUdL3zywtLMGiTFXzyLj1Bw
44167	payment	2134	2134	1874	1	1	6820	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAaMEVX8ZrsqMGsLXZPxZSeTAZXr2hAg7GqgDG6tgJURoqb2Yj
44168	payment	2134	2134	1874	1	1	6821	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo8uXN1ktvDwX67zHaNafkSidwnp9BexEKoGykDUW2gSFmEZgn
44169	payment	2134	2134	1874	1	1	6822	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGnKuTAawzeWSeF87WXNai5mh17kUbebJjbePFMAt3JecviL1Q
44124	payment	1397	1397	1678	1	1	16510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGq9quG6NE41eDTJmGpCB6n4nYUkJY8MFgAkQxDcugG26Ph5aP
44125	payment	2134	2134	1874	1	1	6807	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh6ccfsJRQwD7esT9R8Y57SbTtmsEhb85S3JbvBeYNiLByUNk5
44126	payment	2133	2133	1874	1	1	6319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNuvXo3MZX64LnZRGWzrPMiefwYEEkabPPzf9h1xGSmzpghWF
44127	payment	2133	2133	1874	1	1	6320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5s2rJYQ14ZKj6xuQceLh53A4r51SuDdmH3aZ5xj8PRuWdxDV9
44128	payment	2134	2134	1874	1	1	6808	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sSuiuf8WAbJJKEroXhuLYbW9m7DkZ9RAsALiJu2zgnghz5Uy
44129	payment	1397	1397	1678	1	1	16511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zuC5aeyQDBtEFbBcgwvJym5x8wzcqHYxEdavo8fsZCipbyp2
44130	payment	2134	2134	1874	1	1	6809	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsT5ChcrxXG2qXKkZR2zGN8ydpEi4bUAKgvFCg9frRZTKLtLkW
44131	payment	2133	2133	1874	1	1	6321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBYxUstzdkLpS765DE4rQBr66f1A21JGCiXDzVczV6uYf16GH
44135	payment	1397	1397	1678	1	1	16513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBtXCBVRn6FiMK3HiD4TbuuNBzhWycbahiN97e9hLf99EEWwMG
44136	payment	1397	1397	1678	1	1	16514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtFeRnAcs4MtDGwaci4iVsYQbyQiDA4qm1mRsfhj9aUyYSwCY
44137	payment	1397	1397	1678	1	1	16515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVaeTNJSqQRmtQ5kWU2vsdK6mjZYD7sew99TfD1cjhCC6dKAtm
44138	payment	2134	2134	1874	1	1	6811	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDRFGBaS3q5bMjbs2WjxtyZzTCdqDCo8AZyC23V7UgHpVvfpa
44139	payment	2133	2133	1874	1	1	6323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrUq1yW8GK2rkV6i1ezE7BG7qNMo3Kc2PXbtEuXSxfmnx8mG6q
44140	payment	2134	2134	1874	1	1	6812	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Pg45hKEZr7Bf1CAUJs43jkFNw6MZVgb3uYdHqKYfAe7Hi5gr
44141	payment	2134	2134	1874	1	1	6813	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrEuUJed1HnQPMLVpZPQy8CMBdUydb688NZseZEG9Zbu27Tu1t
44142	payment	2133	2133	1874	1	1	6324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bMRHKX9vAPSgUw5pby9Rk9CigSpT6x4th93yjXWFDsRpfcRn
44143	payment	2133	2133	1874	1	1	6325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VtqjHhs4DKjm64BZwbxhdmVrBAvBDksxpaVsgrb5McsFdeP5
44144	payment	1397	1397	1678	1	1	16516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbUDWC3e87RbGG3vyUkrFYLtskvhebWbDMJgM3hTZ39HNJnfo
44145	payment	2133	2133	1874	1	1	6326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64bSCTpH9ZcSv1HBqrbvdsoyjwnQgyVG7U7gW4sLTTH1Gaqz6
44146	payment	2134	2134	1874	1	1	6814	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhN5gtpM5mSMXJGKAHmeUecWGLkRNfPXosZPbAz5bX9mBsRxEL
44153	payment	1397	1397	1678	1	1	16519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqh6kUkTrLsherygNpRYCrQLYDEv6Pc7oPdwJz9JgeJAqgPAL9
44154	payment	1397	1397	1678	1	1	16520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWcMoa96QzbAhU2n6nrRkv814kyEFEFwbVMfj9hjXbs8zgfv7j
44155	payment	2134	2134	1874	1	1	6817	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3VmGWMEDbRhJBTRgdEokuFb3MKCakGwD9VzVxAAR2M2uUtA46
44156	payment	2133	2133	1874	1	1	6329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJewENWzDc8qWxftB9gGjeN8EknsXM7if4QFM6r2ZRANd164r
44157	payment	2134	2134	1874	1	1	6818	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSquhdyREBFZVfhX8VR3mmRhD7cq7GKrR9WAZqn38e6kjQt9Dr
44158	payment	2133	2133	1874	1	1	6330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTq4yet64PV7ouQi6uKC8gtd33GWkJbM76wGjNotx2f5DhRVFi
44189	payment	1397	1397	1678	1	1	16531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvXL1EYNztChWLXhR2tEZEhUnCLk2PgQHH5Yi3Yvj5WkEZKuLZ
44190	payment	2134	2134	1874	1	1	6829	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbAGXvhw2Gm5CNRjmVcfxHpAcJxrJ671v6vWqWfaXufVmjS6r7
44191	payment	2133	2133	1874	1	1	6341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnr9qFUoek9U3GDPG4RUkNwUwJMapGKCHeto67Hap6FAjnM2xa
44195	payment	1397	1397	1678	1	1	16533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjFXAWQfSymqs9ZKQZCTcEVfYfEKCZQwV4junmzR7cSxopx2c
44196	payment	2134	2134	1874	1	1	6831	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcU8FcKR8rZSZg3mST98PqzZpUKDtsum8cFsgUDMiWrKRNrBfx
44197	payment	2133	2133	1874	1	1	6343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6bVvbQf59XySJXob7AUYhhJZgw9NQNReL1qLFaanzjeHy3hD
44207	payment	1397	1397	1678	1	1	16537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZK2uyrTkH4XxuP4zCpSTuhsVK9icNDKqtD1fCRcTv3d9hktm
44208	payment	2134	2134	1874	1	1	6835	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWbqXEEfNJBU9Qvh5bknuonNeSxpy2eG9PzVX385RjwbsaNxj3
44209	payment	2133	2133	1874	1	1	6347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYempBzixA9EmSHzeuD1iSonwv3eUMZpQuX8YDUA3bzADmMPfEt
44243	payment	1515	1515	315	1	1	1	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8sqYdZ8seCvRgBBHrHKcpFPDA6BtqzGZnqmuprDVB6Jrr4Xrm
44268	payment	1397	1397	1678	1	1	16557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9To2J2W93XnzK1f2YjsVGXDzQQp2PfFh15Rn441YfWswMW52b
44269	payment	2133	2133	1874	1	1	6367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4wyzxPHerFz6bG6KFyevuTiFAKEmWq75RTijQWTh2a3FwJyc4
44170	payment	2134	2134	1874	1	1	6823	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqeGNbJBqFbJviMs7A43ktDJ8dVfa7TrycNEB4YzutbETvU2r
44171	payment	2134	2134	1874	1	1	6824	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCRfHk7griAKQBGE81As7WRDRuMNhaKitB3etUGopmYQ9zZtK
44172	payment	2133	2133	1874	1	1	6332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AHr6K75iE4YpYyNdvavwfMzFtRTGvzYRGgzvWMCGPNeaWN6k
44173	payment	2133	2133	1874	1	1	6333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQbZctXspfgm8TCMh5AXDtMU2GL2JxfvCPutJUYxKZUmjLYk47
44174	payment	2133	2133	1874	1	1	6334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5JKKvPcaGZBcWqVu63cxGxJjYMsQhA4fnZ8yN2xV9uNnQD92
44175	payment	2133	2133	1874	1	1	6335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhRxLhtrRKywpAMoQcZcNa63NpTSADTGL81j5gB5jtaRUYsvR
44176	payment	2133	2133	1874	1	1	6336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjn5yH2mFADmCc47woYb9z662f3fedUvZ8H1zYAT5nGjRUi5T
44231	payment	1397	1397	1678	1	1	16545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1PENS9JCgrYQqu9JEoayCyPauj6gFwZCtn9txbK6zwMd2PFMc
44232	payment	2134	2134	1874	1	1	6843	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUz1ozazoPi8pxobcH96KRQTLt5UAy6BznBqCXRnjK7Df7AKBH
44233	payment	2133	2133	1874	1	1	6355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbbQ2nLc1r2bn63LDDWToLTp4nWWtpRHpx1fL2mapPR9Af3Ri
44234	payment	1397	1397	1678	1	1	16546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJa6XQdYegpkMJ6o7DGytWJfo1HAKNjG2rypbzdzccpfsarmQB
44235	payment	2133	2133	1874	1	1	6356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQwpLa8GymNTLzjBTQ3FkxTv1Wkm6zZU9Fv7Wt7CyyYkaZLoB
44236	payment	2134	2134	1874	1	1	6844	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLtuUWeLFssud3CcxcUbq8XkoiCrWdfcY3bETGruZ3PgJBh7H
44240	payment	1397	1397	1678	1	1	16548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyeq1DuWtFdikLqDbgQ8qojAHcQ3bvZMGvKw4azWgjSdSjxz6K
44241	payment	2134	2134	1874	1	1	6846	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjG6zxVKYFpxLcRmqZYAMeq2px4aNQ6nqvsuVfrXCMm75fEaU7
44242	payment	2133	2133	1874	1	1	6358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKbWwtn2eNQ5o7X6aceA2wahgtrrUJM663gGLfEAUpKqnjTELB
44253	payment	1397	1397	1678	1	1	16552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzjjB8o9wYiobMbqBCsRukX9dQpH17naqm2uzgXm7fECW3NBLA
44254	payment	1397	1397	1678	1	1	16553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZemgVPhUhBmXpmvBUqhQrdnxeCF499QhvFkZC4BGXBoTyNrwwK
44255	payment	2134	2134	1874	1	1	6850	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGFkPc5kNFew3gywo9gtgmX2fem7nSRyNSSJz6MAtoakPXeBHV
44256	payment	2133	2133	1874	1	1	6362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbwA5b9pS5j1T9L6XfudtkyWuX4Wbpy8wBeceWArNssTQKEG7v
44257	payment	2134	2134	1874	1	1	6851	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkovUq1RmEbVHX437RCMAHmeMWPqqV4CNGLHSEAQHdxUR9X9Hr
44258	payment	2133	2133	1874	1	1	6363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnpNHVJVp9uK1JFGRzRSMhGsEEWMXEWrWDaudKWvauDXZG1P9c
44294	payment	1397	1397	1678	1	1	16561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5h9e46tLpHnW1PVioFrw8wWg5TKaKVswz1xv9Xs8KMkFfN66
44295	payment	2134	2134	1874	1	1	6859	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs7QVuNKqskNAQReaKf31H4bhmEpAYKuxrbgZQ833eSHduZdjb
44296	payment	2133	2133	1874	1	1	6371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3qWjFq9eFoPKswgdaFr9Fj3MNuu5P4JhkeyY9SpT65tqvaHk
44297	payment	1693	1693	452	1	1	1263	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa4fB24WKnPTTm4PgZz5zFATwifbc4BM7E3nuKPs9q79cKnGJLU
44298	payment	1693	1693	275	1	1	1264	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYa92zBXziPJu3v5DuzKbYK1tPJKKcp79DCf4euzDjoSYSuJSxK
44299	payment	1693	1693	402	1	1	1265	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZEps4ENwDtk7cz2EGqEK1bzRUw5rJhUhiqKRmBGoGVT2gmn56A
44300	payment	1693	1693	2181	1	1	1266	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ7FZDnoE8MqLis8Y4mKz1hGWxRynXq121DeqZchrKD281MPf3h
44301	payment	1693	1693	458	1	1	1267	68310385306	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZAXfEZ8PWcMWFSdr8a8dV2ubYbhMYXZry24SwTZSVYrJTEc86N
44302	payment	1693	1693	690	1	1	1268	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZSRj1hBaexDLNAtQQiB6xxpCSpvrDqjduaDj8ASuaoE5U1tbno
44311	payment	1397	1397	1678	1	1	16563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojujU94XKX2NkuB8gvjVnNcGhNkisvDgJZCbfpN9fXDUwJUd5
44312	payment	1397	1397	1678	1	1	16564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS89wDBztEtf8nGQ6tnqFSXeWcJm8PTZeN6y3mFJk4oRTyc9XV
44313	payment	1397	1397	1678	1	1	16565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCU4EvdDJt7dGkBqYV5S83Xg5VydAHn5kRwxnKGjvUVi38xjcf
44314	payment	1693	1693	894	1	1	1274	318909198285	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYnnmPgLGyBKPcZxXA52PUJYFKzDRtriazqqtH2jdhUbhYYMMPK
44315	payment	1693	1693	342	1	1	1275	68309050196	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYh5qNMUpcvNZzhuEz9KBxDrEeAysoNnn6rtQHZLF9MsuWJS4na
44316	payment	1693	1693	1811	1	1	1276	188491275292	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsSWa95JCci6aSDYizfN85ufasRKG6ptvWfNiLadGyjxY4uF13
44317	payment	1693	1693	499	1	1	1277	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZUR3aHZDKUCvXi4ijsEcT4SiQXGHPfJafTZR6S7We7U13QQcnQ
44187	payment	2134	2134	1874	1	1	6828	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqNWNNs9bHGqyyu3pDnQEsidZLsouJcPh382QdRez5Czgjn8W
44188	payment	2133	2133	1874	1	1	6340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLruFWC9g7ERxkHJz2QmcmTqbkN3nD8fpDnmQ8uj5JHShuyWq
44204	payment	1397	1397	1678	1	1	16536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YnNkgq39jZ4CduWd8iWRAoBgT5nv7yQNgeF4aUTTmaJkiMfE
44205	payment	2134	2134	1874	1	1	6834	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ27snyWyvqQgryZwmML39iaDedp9K6PdWJYkciEnEujcSG3Y7T
44206	payment	2133	2133	1874	1	1	6346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazR6Jw9VWpmM7LR78nfLccZK13EEyUT5PHQWpiQHmoJqDWzq5
44219	payment	1397	1397	1678	1	1	16541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfXuLFeshNySkgvZPzYjXWHijMKcxcDaTqDQwrW3kJUpNin4P
44220	payment	1397	1397	1678	1	1	16542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvFEFRYgcxDpCAnQcVuWvB4aJPqeJmLZxHFPt8qjAFvgBChVq
44221	payment	1397	1397	1678	1	1	16543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJun62Xfvkfh6NLGo8xoFQVHvpk9yngPvR6pU7EQtTaWbKRmh
44222	payment	2133	2133	1874	1	1	6351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zX7v645LS9N3QKi4o4KrVA26vSGXc4M9Cc7ym4qMxgpTvZkA
44223	payment	2133	2133	1874	1	1	6352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXSucxjkfgFneVF5UzsoW7EQShCUr2G474fjdcyJUtMLeERbbu
44224	payment	2133	2133	1874	1	1	6353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXC7tyYjX1ENvsdcdzUYdYf7qWdMU9K8d6Te8eFXmh2Zr4gVQm
44225	payment	2134	2134	1874	1	1	6839	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnahzQ9aojCeiz8P5WuWpedUy9NLxSir6fFGMsUx8EQehbZK4
44226	payment	2134	2134	1874	1	1	6840	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKPd5DqHeMqWz1gvpwYf4tbNLCbTQxKabnXjx7BVgVFJnk2q5U
44227	payment	2134	2134	1874	1	1	6841	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSdPwuTNmmAH8WwsAREpZMaGbdPaRDrw3LinQqmoKeGFjo2EQ
44228	payment	1397	1397	1678	1	1	16544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEooA7RaipGxneeuCeD1v6h3GXpgw5XeeV2svMuzJPX2NTn9xK
44229	payment	2133	2133	1874	1	1	6354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLDUqih1tBjgRTfVPb1aJNdFsM5Mc7c53zGUCfu6HgYyjjz1WY
44230	payment	2134	2134	1874	1	1	6842	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY3kDt76X4V55ZHFTzP5qVr7jxtcmw9CDX3UB5XWrfTb6qNgkE
44237	payment	1397	1397	1678	1	1	16547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAqhhWkavaVKfPYr9sbaH8svWMtuUxXFrixWrn3y3RsF5eMZB8
44238	payment	2134	2134	1874	1	1	6845	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX6nHwef7Fhw6No9HnCovv519pbMJyLr4FruvMKRvxtYm8Rd8G
44239	payment	2133	2133	1874	1	1	6357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuTJQ4CBi9Vqin7xwKr5WuE8TQDxbPy7YC94eLz2PBPHX5mP7
44259	payment	1397	1397	1678	1	1	16554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZAE3GzuE5Jhf3BznReuxSZyzgmy58pDsmYn97cig2AQAoTbW
44260	payment	2134	2134	1874	1	1	6852	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ996t25PYLiYL5L8YFJxnwsRpzgTviHobpF4CbSPiL99GjtUmY
44261	payment	2133	2133	1874	1	1	6364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KgBTkMLN6DEmQGScFdJBvjfSehYWqtipjaNGYdveTa1XoJ19
44262	payment	1397	1397	1678	1	1	16555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrpVH6Luq7S1L5afYbe5S2wckg89B7qZsaAr1MYFtUzHuc4HRg
44263	payment	2134	2134	1874	1	1	6853	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgSdMSadVXw4SiQpPrwC6A65Lkv5TsE56aiF4VQL91hnAoXZ39
44264	payment	2133	2133	1874	1	1	6365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxHFFyUM72Rnv5wq2Tw64p17XatkKCA8ZNLRQMgosscysCRC7r
44271	payment	1397	1397	1678	1	1	16558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNXDF4pqfsv82qjSoEgNUs3Bi2PLvqBH7v5JRGNqBBXP1dFWy
44272	payment	1397	1397	1678	1	1	16559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzN1dCwHuWVzPnzJ7jyzBFkz8MzWWifo1fx3vMd1YbCGUSsJ69
44273	payment	1693	1693	383	1	1	1249	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYVJAtY52p773VSefEbgDuBwfz9daCPpGoMLqa7U6rJuSd8BsLr
44274	payment	1693	1693	327	1	1	1250	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHdNxkqbdn14aNGzKdhEhLrq9dpF3vLntzPEnx5JJsdZ2J2Apk
44275	payment	1693	1693	652	1	1	1251	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZPMRyJupN9GhSso2bjxRE1bG2kW8j4p65TaqmSbZDEgyCAjgFs
44276	payment	1693	1693	266	1	1	1252	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZqBsyKcQ21ZPeahWSdAVq1AwomKVpLj6M8bk9mhqCqythgN8ce
44277	payment	1693	1693	352	1	1	1253	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYzH3pZRT1y2J6YnwgM8f5rQXDjZeWyxA2fq3pNS6GcQyYf1PWK
44278	payment	1693	1693	191	1	1	1254	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ8knUiM2TGyVz4HeyqryL7M1JcEyw7F6n5yajrRqoB6rgTqwGz
44279	payment	1693	1693	520	1	1	1255	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZQDnEA94Rxra558rBs8ST4T3FK4wCxhM2ydgzy4WqLN93zvV7u
44280	payment	1693	1693	421	1	1	1256	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGXkJGoQtEnT1TbZyPjsXxukHWBqwqvpJSYd1rJBSk12n55r4u
44281	payment	2133	2133	1874	1	1	6368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3DKDD7CjWwbpoR71uYnAUMBoeBcyYkPaSwGJ17qSpTtdYGvkd
44282	payment	2133	2133	1874	1	1	6369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahYti2LCwpp1PkeaXkV6fV1zZX9Tda5ktiDbHefiNvwuc3FFy
44247	payment	2133	2133	1874	1	1	6360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsR6qgE2fzrELyx2PX9k4j53XMuS77n3pbuQqYBAR8wSDqQqk
44248	payment	2134	2134	1874	1	1	6847	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf27Mk1nsvYJ3vjjAvLGcfurFn438cXt8sngJki4f8zFAL2gtQ
44249	payment	2134	2134	1874	1	1	6848	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVwFxtqtTNtjmiz2V6vqxF3GJpox31JSxqSY9gLbHFqrk8QQW
44250	payment	1397	1397	1678	1	1	16551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7U98zsNsqMXLiPnNjx45y3Fgsc87yXMbgfkDay1hPVYAkM43
44251	payment	2134	2134	1874	1	1	6849	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSyCmhEmCuqsuLGtFt8VpEKEdvFL6UVAR4yh8AwatYLEwwcp5M
44252	payment	2133	2133	1874	1	1	6361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyusFGBVjes1V52pGZ7XdZnXr313g136r2yCVEmEkKNPJLAum7
44265	payment	1397	1397	1678	1	1	16556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1aCYotHJsyXXFqcGJzXmdrF7DAUeYyCY3mpMAZw695MDVUAv
44266	payment	2133	2133	1874	1	1	6366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTXQe1VKfZtDYZZwFiRkSzmzifX8EMZ7csCwh5Qj6zubZJQipy
44267	payment	2134	2134	1874	1	1	6854	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVnFtkJf7sBaGKntRyh6xnS6BW2H1DL42bVQBC754rK3Nje6gc
44350	payment	1397	1397	1678	1	1	16568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobYdfLmeqLN5hMYTiomrTJHCD82o7p5aBNiGJco8fNFb3Rohu
44351	payment	1397	1397	1678	1	1	16569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3J7k9Fqfqn9qJ3MHkwqhGVFGM1gvQFNmRiJZatuXnR7XjMLq
44352	payment	1397	1397	1678	1	1	16570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKL6BVtRkmTy1hyBZWxQdMMFcVRQyqwrQgwRVtzTkUpapCCdiu
44353	payment	2133	2133	1874	1	1	6379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVhWV8WvqTTXpCn3FoLxV983kdPcxR1Dw85nqDK6yTNR7PF7mH
44354	payment	2133	2133	1874	1	1	6380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXsCt9to2HTg2792xmXTxqMdxkZuvDaTqEn1UVs6H7nw6k7QX
44355	payment	2133	2133	1874	1	1	6381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhr14uBgCSVsEkifrU4RWbDtgMwwY3MrtYMDdwgJJ99hU58Lec
44356	payment	1693	1693	500	1	1	1296	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa6QSuh3YQsBf7MpgLuWRhDonUoE7GSdChXZJT9GCYpu6Wdejc2
44357	payment	2134	2134	1874	1	1	6867	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YpWkvt9Ns2GYucBEe9LGXDp7K23HM7EPedr7hC3SJFtQEx55
44358	payment	1693	1693	587	1	1	1297	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaBv5iDvZi2xvtxbxspsUJwzXKepJUgjwBYu3xGyJwSiohyoWMg
44359	payment	1693	1693	138	1	1	1298	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ3oBLWZyFgjiZUzH2aR196r5V1KZPhEFZRtC9cnm5ea6oycpWb
44360	payment	1693	1693	114	1	1	1299	68310747543	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaBvwwMBWL5MRHJWawQheL3UZEhohjtrgqrvF4mjdMxnnoUC7Er
44361	payment	1693	1693	443	1	1	1300	68308313303	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZTZeShJxPp8z3aZLpovBsXUonjCaAnws6i78JKHjhEHVQ6FJRt
44362	payment	1693	1693	649	1	1	1301	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa1C5xL2WGeCLe1bHvsEKmCGy1pTqadDMJedtEUEX4gpRMJzZfQ
44363	payment	1693	1693	578	1	1	1302	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYWmMDSF3mcRBBTuZ9r1WdkF5kSvhWSJ4vPEJbnHnPZ43nouegH
44364	payment	1693	1693	205	1	1	1303	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ7hxijceDNkyK2HsoVn7xu1rcwjXCHT9yEdnPV3TXafqvoZ9Zd
44365	payment	1693	1693	504	1	1	1304	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZH679r6KnxzKXFA53PHPeXzrg5ZcLY7GaDHimce8Yd1b4KxQ7o
44366	payment	1693	1693	339	1	1	1305	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsp1yDJtjinFD3T187SNCArsybEbBTeYaDDrYfXNL91giqmsZ5
44367	payment	1693	1693	301	1	1	1306	68308418862	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ97Ld8RfEH8uPeXntYREQxDZ7KRQtu7Cm2aSWhcm9McHzC4U6i
44368	payment	1693	1693	408	1	1	1307	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYhxcAbJFD9wyPr6ib6CXJbgRnADxDb4JrDbYBP7gzTScqehx8c
44369	payment	1693	1693	601	1	1	1308	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHuz8BimUMaLyBNpCQakh7HKCZL1d78gZJyKK7DqWSXDyc2Lj5
44370	payment	1693	1693	1821	1	1	1309	68754015081	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZYiSzuGxVC7zuSBVqCBUdS82iR1yEGEwz9dK5nn713vtu3Gdav
44371	payment	1693	1693	450	1	1	1310	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGaJSY7DUsgpfeRp4jRmiFjwGPTWDMtWenyv4qSNhXD7wpyFvH
44372	payment	1693	1693	10	1	1	1311	33697524468	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZqiA3eZPyHkWAs1Nf25LMsVY4z4Lb7XrFz95WXi6sJr887VxVx
44373	payment	1693	1693	322	1	1	1312	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZhvS32283tYEiTDxHLZPpPQuEEL3vkx6PK318Mi7ja8NVpSVg2
44374	payment	2134	2134	1874	1	1	6868	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcHZ2i2T36MXRjpsJRhzs3FCDGcw9gUrFafmAhjSKCKqeoU4t
44375	payment	2134	2134	1874	1	1	6869	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEUwWLPfTcsRnXQ4dcRngXmNN7zimT4pk1SFRfFp1X9YzMNBKH
44376	payment	1397	1397	1678	1	1	16571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHjPYTjMbG5BWePywsK4E1yPfEg6LNBQyw8e5wt8WPNSEPGgs
44377	payment	1693	1693	366	1	1	1313	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa9bspQk27mp69yZNtgrfFZC2gqUJqzTJEm1f6caDBwzCWrsfKN
44378	payment	1693	1693	2017	1	1	1314	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYQEPjBnVQF1t1pESjjGZQUkw5QHq9o61CNvzXmtAoxfJhi6ZJh
44270	payment	2134	2134	1874	1	1	6855	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6NMQwxFcTaiPafpcQm5zbYgNZjj9cnRP1m12kTZHQar9P2sJN
44285	payment	1397	1397	1678	1	1	16560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEh2m3zHmjQVysjWNszzzY2FRKM9LQeAAgEmW7VQAMHzXo2d6c
44286	payment	1693	1693	534	1	1	1257	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYSFxwFcJbpuQHvRSKE6UgAAXhXjnabT7773Qka9TXvPmDMPPDx
44287	payment	1693	1693	680	1	1	1258	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYehZxGkQcGVD3bWTE8TwKFoQxLML3kqaBw6bm5aGGoenCs98M5
44288	payment	2134	2134	1874	1	1	6858	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfD3xu5253nHjXQdWS8L1eXP9Q7jz4tj7HTq8PtqPgVfrakTt2
44289	payment	2133	2133	1874	1	1	6370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmddgeCAqD7J8zi3BZLJou5Quf2N34wcip8rkdYtXC9qo91M1S
44290	payment	1693	1693	82	1	1	1259	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYo78fCU76AS8NqFLCbknUbx4vTFFYomUns4UHMHitDAqg8rfkY
44291	payment	1693	1693	309	1	1	1260	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZcrvwSy8WyjCfUqctY7Db1yupSKGrgJzXeRviNRou4pRE2NsrM
44292	payment	1693	1693	361	1	1	1261	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZmfqThGqjTZEmUFor8kJmUz8cKR9eDSJKupyx8MYbaQvDwaYqo
44293	payment	1693	1693	731	1	1	1262	2078783426	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTGWLdV2QegMnugJVihxQ5hkuNNSUdnLgpLfyM9wmUfvze4try
44303	payment	1397	1397	1678	1	1	16562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPZh52nD8BGpDwtBNpmXzQyoM5KLTKkH3wS77kuQ9miP6yvyh
44304	payment	1693	1693	391	1	1	1269	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYU9YtAyTis4F7MKYchFHcWEbHzUEGuJhnPbGPeigCyq2EsvKR3
44305	payment	1693	1693	1772	1	1	1270	492788206733	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ3PRk37etABEGsJRAMnZcsLRw3P5ZpAqUXoHuA6iWsBsYZSdrX
44306	payment	1693	1693	570	1	1	1271	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZQ6MQXpyWViTSkHrfpRYNbpW2Bn1w61gjcZi5GfHoSPADnnGzT
44307	payment	1693	1693	390	1	1	1272	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ1Vsw3KUahLn1Hkx8QvAoTPJaRngNdCjRrtjZ8bE6wgLmXZuN9
44308	payment	1693	1693	569	1	1	1273	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYwGyngPzmwBNCSW9WDLHXmeowgpbiek1pgKGmLGhyitsU3gNjg
44309	payment	2133	2133	1874	1	1	6372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVn5N13RJqo42ZmrcZcCALKZ6xSf8mEuYFpuAznzpdtH5mjcwH
44310	payment	2134	2134	1874	1	1	6860	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEkx3g5mTy9Wh7yuVSz1n3cc6VNjd5Vgp1wyhMrbvsWjjbDGj
44335	payment	1397	1397	1678	1	1	16566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Eeacnm71JvcUtWdF4eYQZ3BLfwqU8fr6Qj89YP7nUzTq5gFL
44336	payment	1397	1397	1678	1	1	16567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTXsPuusECGAxAS7vK7V5bLxkGbR9amZ4WPGc3uetgj72vRSg1
44337	payment	2133	2133	1874	1	1	6376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYagqUKFXgxEfRC91cC8XwHDgmdQtkhbRaJXADNrTNPf4VXQTv
44338	payment	1693	1693	206	1	1	1289	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYpyaK2GRexDdKMuCod2Z4bmJCaSjb5Se4XbpiEiiAmXeAa52A8
44339	payment	1693	1693	636	1	1	1290	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYb6Jscgv7fgYYzfLmPyEqmekzQ8gdqBsDbqTeejfuJdGKCfbNh
44340	payment	2134	2134	1874	1	1	6864	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLuSaAkxwWtBeeLW9sEb9QnhZgvEJGBFrVjTQcBKvcVAB2hP4
44341	payment	2134	2134	1874	1	1	6865	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ99ec73zNQuUSFr15HpS5kMz7iXN9TxV2Cdu6PpG1KidFj8EBU
44342	payment	2133	2133	1874	1	1	6377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZavX1oe1M8FL28VhBCo8Rewy3U3rHHdbXkmF7u7B8h7T5W9kkD
44343	payment	2134	2134	1874	1	1	6866	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAWr1LtcPWZcVJhPPHGFMJiNRcTRr9rru3tE3eaYUkzUVHs4E
44344	payment	1693	1693	399	1	1	1291	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZDHfsnfHxmqsCcKyejA73MgBC162pqYpVvDiuv3Dw9my5GKggP
44345	payment	2133	2133	1874	1	1	6378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qeJytSM5S9jbHRXe6C9rEJzzvdE4ZNMrW9ixfw7qk1ivAvEs
44346	payment	1693	1693	721	1	1	1292	2078783426	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa8Nd776xH1wK63uS12FXacAsb1fmwiPe7DcchYRK5hsDL77y6i
44347	payment	1693	1693	105	1	1	1293	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa5asgNiKw7ThMBVQnxJfU8CKr8Q19Kz7zk7J7e4NA2RaFUMXKT
44348	payment	1693	1693	146	1	1	1294	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYpA9BNA3ubhf4jPy3nZHSVuXAAz3JCusdDE5B8WasZg36FPJm4
44349	payment	1693	1693	611	1	1	1295	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZiSCZP9YweTPVrkhTrGoEjMncrQFpn65VUGiokf5RFrVrQp57a
44417	payment	1397	1397	1678	1	1	16576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1x5nXzhfjbNEski19oWdBAYvdK6JnA1m5ZuRkkaxZVXtsTSsL
44418	payment	1397	1397	1678	1	1	16577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSCz5WSPKtWEgrdFeRsqAnBFb8q4TsBJkE77uDbeggT8uvnWH
44419	payment	1397	1397	1678	1	1	16578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe9Vy34Ke2fSiUK9RE7qZyYg99NbrZ4V4dpMetk9UQysoMYoa9
44420	payment	2134	2134	1874	1	1	6875	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojUNiXSdsrDAbeuC7y6tgaSY6cknXGGkqDeTVPAKFBKWtXRWr
44421	payment	1693	1693	560	1	1	1339	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ6585k4n8x4oZY3k9RYWRxS91SaphBiYGamq5MoEMYPVPseUQJ
44283	payment	2134	2134	1874	1	1	6856	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDeWDa88GGm97birxk55DpPJ2cUK8yX975PQJzSDcrkCsJ3XgU
44284	payment	2134	2134	1874	1	1	6857	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQxrHni1A2Hu6sgFcfDWa3qjK3obq1cFi39SF7DXh3yiRtBiFw
44384	payment	1397	1397	1678	1	1	16572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7qXxS1wNgRjNVNpmzw1o72oHUth7xuFpLAZv7n9qnsFgrjBK
44385	payment	1397	1397	1678	1	1	16573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZnzDT8vpyAEkapcYBpAwE6HnKnvbKkgwETm6of9FYekU282Y
44386	payment	1693	1693	180	1	1	1319	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsfPCDzz47Qn5Uy2mgE14pER76LoA6e1WGmq6UED9MCWWK4mYu
44387	payment	686	686	2358	1	1	0	50000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfn6APjzUdBzBQrH5B94bFsQmi7ctRwxpApmfhDxkm3zC43Sv
44388	payment	2134	2134	1874	1	1	6871	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ66C1YoyaV1U3v1Frmichcab99y2ZdaEJNXAxf9ZNEbFnAAyLi
44389	payment	1693	1693	165	1	1	1320	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZMrZXGnssSsRdkSBkJQjGmpfDfQ46PkANUWQ6kD3LKVDTGHX8q
44390	payment	1693	1693	237	1	1	1321	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTXX8fKHEYE4pfNVur3mPDC76MavGHbBHqgxpzUS2BDyzcmsiQ
44391	payment	1693	1693	2164	1	1	1322	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYycga5NyeutmmAPT9XTf3Q4kxsjKLGJ9Yw45UbKHSiJz2Zkyc9
44392	payment	2134	2134	1874	1	1	6872	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgTkeNvQAEudfi26FMC4KmrtxgPgdSinP9k8qd3MLX2WsddcJ
44393	payment	2133	2133	1874	1	1	6382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAL81wQtkDs3Ue9L6NNECxk2sxKLhSpKYt66KYLgM3ajviNRg
44394	payment	2133	2133	1874	1	1	6383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifzwDd6GpiZfD5pWP6k7T2GyDboXpPnbS5qJwVUj9hFtpta41
44395	payment	1693	1693	691	1	1	1323	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZeuq5ShwNGARvpJdvUqDXDAevuiXMgA1eMA2NpCPAbfpD2okdF
44396	payment	1693	1693	600	1	1	1324	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaGRKZejPyjEcKAJHZsP1KE5gGb58qXtvJNhjN4Rxv5S5YZaWsN
44397	payment	1693	1693	245	1	1	1325	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYyacuTvdzQjGBhyRLq3CBH1NLwR2ibcTmnotR8fSA2kS7TbgNE
44398	payment	1693	1693	620	1	1	1326	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHaoFWbQc18DpQAfEpJHFiZRdwTurUTY6x5SH2PMDmobqF9p2v
44399	payment	1693	1693	594	1	1	1327	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZCzAqADGPyE8dSWKcKLEe3CKtgFAbB6LqUNKvstD5Fkovqj6dU
44400	payment	1693	1693	201	1	1	1328	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYV9RTh9hEa2TLkpRCTuisaA4fvG6rRjbJSiUFFNB8kVJU6Fm8X
44401	payment	1693	1693	163	1	1	1329	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZkXeodntjqzzqU216DZkhP2y2rxHzwhPg7yswJpgsyxUVMfYSq
44411	payment	1397	1397	1678	1	1	16575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9RBP5KybLAc6aVnBorwArWbJnbQroAJTP6bmEMQhBnX8fhwnD
44412	payment	1693	1693	252	1	1	1336	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYmEqe3DHk6mitodXHWUSBk3UPej3t4Pg879jUcDNQECyUBUhAp
44413	payment	2133	2133	1874	1	1	6385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRn2XhNqew8kWdBq1a5wGeUX5Wbdd61CPorqWVjtByyau1GJSd
44414	payment	1693	1693	377	1	1	1337	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZe1y3xbY8VD9bC59e39Ngsp4LtVwAMvCLrSX5ih9SDFY8Uvqsy
44415	payment	1693	1693	225	1	1	1338	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsumPbz5YwPvtkQzP3FDS6UonpLgLYC8dyBwA8UQirRCV72TpE
44416	payment	2134	2134	1874	1	1	6874	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCVMJKGu4WJ5MT4b7EVMRKxWfhv98m2QSPANiAXMvtXCvBHcVX
44486	payment	1397	1397	1678	1	1	16585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYie6cr9A2bdRZr1jknPcgLUQeQQj55pRsYaNaydptLJEDZbW7V
44487	payment	2134	2134	1874	1	1	6884	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWBGh7UpC1XWvYcRNfsWPtHhL1vnG91vgwBgp6J2i23UhwhCTR
44488	payment	2133	2133	1874	1	1	6395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwy4xvtG3ztVtHuoPcvGsqUiD5zgFdwT9jRywuuxr63zBZs92
44493	payment	1397	1397	1678	1	1	16587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYht6fCgZuvtbZBoHaA65rre1jXaDeCoJwMSJeszNjTgthUuFM3
44494	payment	1397	1397	1678	1	1	16588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7gvPEtT5iEG1c8PAa88UMDfKYa3xaBERTaohqHZddnebj6RQ
44495	payment	2133	2133	1874	1	1	6397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi48hV5AT8RarkJUHPmxEweNuqQxugNZrHzHCHiKQ9T2UbcpDc
44496	payment	2133	2133	1874	1	1	6398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUDZvT22ykqdJwrAR7FiyFJnjM2iFLWfo7v2AXBhLmFGcmsG9
44497	payment	2134	2134	1874	1	1	6886	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfQrg8ZRybLVUULXeoTEBp4gucqPt7st7qPvuPUoSCaAVzRtg
44498	payment	2134	2134	1874	1	1	6887	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsb9JcTtnBAwGS3awPqQvFjmn4ZpwacXgJDzDBLFg1wnR1ydT5
44518	payment	1397	1397	1678	1	1	16595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmjBoreYFzbCL7EKGW2kt2x2SVGR594K2dStEjRFMqrwjqDC8E
44519	payment	2134	2134	1874	1	1	6894	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nFkxP4pCc5JUpeK5MN6Lc6EgP3iz1Uf9ERB9kLA9kGFcHM5H
44520	payment	2133	2133	1874	1	1	6405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJmcUTHUhkCBhDBstsmDFd92iw6Ep56WohaseaytKxmseHQJSK
44318	payment	1693	1693	710	1	1	1278	5196958580	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTbNWQ2AfRHuvfRZZT7V7ujvyxjaZ54Z1xPw5s3MmhjiCfiuN3
44319	payment	1693	1693	120	1	1	1279	68308843202	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYnmvj2Y8bLCcdLtMvnj7p71FU4Zb936C3iZafD6mKM49H2GFLP
44320	payment	1693	1693	663	1	1	1280	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ41HsfzwEu6yPBpEA549WHy1hdos3VBFHJovToZvGTTE3D5osH
44321	payment	1693	1693	1030	1	1	1281	936820245072	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZTx6cL9mCmiyoeHvT2vXbpVXa7nGMLT5yBPMxvzbCLpvC51uJ9
44322	payment	1693	1693	238	1	1	1282	68308077325	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYp5LTjUphiNtj7TSqyxeD6PXhQegyHcsSBJX3mWmk8RvHYqFv4
44323	payment	2134	2134	1874	1	1	6861	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcF3CKoSuJBnAdntgTQTprP4xYSfZmCAS1J1LudeR5ehEfyRvX
44324	payment	2134	2134	1874	1	1	6862	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUu4hp3LDnvZcvr8221JgKo6EHf5nvJ88evKQgYPWewXKPqS5K
44325	payment	2134	2134	1874	1	1	6863	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm43mHHvXVUaWWD3MDb7rtBRwmTHwCH1iRrzobrmcC6FWR1KJm
44326	payment	1693	1693	312	1	1	1283	68307911729	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa2v78JaEs9qSi9vw1DsaBnAhZbaLv5kSSVAtCLgSKPRtUSwYM3
44327	payment	1693	1693	251	1	1	1284	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYjnftfGHG6PuP6dfUn84qm1cLN89WVnsEUEfT7NFHK2ZLbNM12
44328	payment	1693	1693	320	1	1	1285	68308820251	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYqg4rPTUMFQynAzQwz6EdBf2krFJRZtaLzCGoT99bZhuKA7MkB
44329	payment	1693	1693	354	1	1	1286	68310385306	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZZKcopGK3XwzcKUieBKFA7gNa9HYiCivNBmbvfya3UeHpRfuvN
44330	payment	1693	1693	1276	1	1	1287	1761378573132	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZR17LxcefnPfWde2Tty1mrw1RPAXoRBUY8HHqioY4EZCaZ3Rp4
44331	payment	1693	1693	194	1	1	1288	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa6yNXx8KFFUYzP77Su3QtRMs2Ff2hpnppBwN7pEXLyVrn4VKKF
44332	payment	2133	2133	1874	1	1	6373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4By7As8BFhJHdnYeazsUioL7C2c35jHVH6vYDsqEVZzBgyKN
44333	payment	2133	2133	1874	1	1	6374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFumBcdQuLsf3RTKdttNpzMX9eBwKfddek9SQg45BVb2iJRSz
44334	payment	2133	2133	1874	1	1	6375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLeEt6SfhzQVqo7dY87YTJAG7gVXm6GhckU2ebxpsSaFNsjWxA
44441	payment	1397	1397	1678	1	1	16579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Qa3dtJmHe44aT3thWNAkruYWpUQ6sTznvAxKzspqx4o4GK17
44442	payment	1693	1693	2308	1	1	1353	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZRANefAHhaZS9u6iYr2irw2EUTMWiGWWvN9RgJoYLizKX85gj8
44443	payment	1693	1693	122	1	1	1354	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYWv1LT4vAKPZsoi7Mk66Sa4SDRfRYk3pQNobGfW8wvbv5wJUDp
44444	payment	1693	1693	910	1	1	1355	522781654157	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ9LtNJCR6H7PNRm82gKUHJ2ZtPY72Hm6KWFTXMLueqGXsaL8xM
44445	payment	2133	2133	1874	1	1	6389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqT8quoAdGRss56C4XBp7c6jNG45i7qxYdWyo498kRvKVuhVwg
44446	payment	1693	1693	29	1	1	1356	7275742011	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaB6vjiXoDZx2xj7pwfN2hZbYUwg6NVBZLWBPGQPhMMwoXKsZ4T
44447	payment	1693	1693	78	1	1	1357	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa7oFjkQvKJPxqwVcDNPPV8bwWdB3jaeJzv2EKPgtuPCZoraaeq
44448	payment	2134	2134	1874	1	1	6878	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBNVrNctnutUJjqy2wnb56gcfk3Wt2WQzLUErshH6kum4EVnWv
44476	payment	1397	1397	1678	1	1	16583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZduFhJ2PCkuACN3fJzNZQBr8wB2HP1watgJhTtAeD5Th9asVp
44477	payment	1397	1397	1678	1	1	16584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpGQDzv1GTmwq2mTJkyTnpkEJ1ZzgVRKoWfTgRjPyZbEqot6R
44478	payment	2134	2134	1874	1	1	6882	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWCFVqRDT5bTzBuQWSyge7XhnTjxKU2Fku6k4fTy47tcjKL3fz
44479	payment	1693	1693	84	1	1	1376	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZEnW4qULa9b1ZGHzLnwbfg5BM94jpJjr17tKsfToudwFDD3STy
44480	payment	1693	1693	1150	1	1	1377	632091286816	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZFcVhhd4Mdr2cEeEucLjcgMoNxCQWyTUzqmuGWtKHCuhG8fmuT
44481	payment	1693	1693	678	1	1	1378	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZRx8sux8KS6Pc4P6kKevSijUEaTspAsGDxrufHpFwYuzXdx7fX
44482	payment	2134	2134	1874	1	1	6883	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLJxqcqWGDCwKCRcemZbemCTqZPXPZFgXThhCZkarDbz531RB
44483	payment	1693	1693	89	1	1	1379	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa4y3zfL21jU1r8Fs6d8UXcpc5mVKRMgyk3N6kNuwY7vB7VeK2t
44484	payment	2133	2133	1874	1	1	6393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJW4Gp6nR6tGjmbSG9xpxTKAKYM2QgzkP9LBX8xYgvBk6fRppj
44485	payment	2133	2133	1874	1	1	6394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4z5oPRMixGbETjffrc3woLBQB6hqxYT3H9GzbFDmU8ssBDrfZ
44509	payment	1397	1397	1678	1	1	16592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzuY19mxnFzeRWj1qf5gY6zH1UMoCZ3yZDRsNU1oXyLpnMrUVC
44510	payment	2133	2133	1874	1	1	6402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAqUKBN4pnBun3YYfdH9e2cupxarrQm78zvuVXCwpxT7a7Ggp
44511	payment	2134	2134	1874	1	1	6891	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nAVC9NDWN8JtZAuR32pMv633wb8YGRgaE9y8FDCxd8rweLMc
44379	payment	1693	1693	283	1	1	1315	68308418862	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYhk1QAYPVef8sK8Cy78M1h4KXQzbAgnsgHSVyBbRsh3HcG372V
44380	payment	1693	1693	308	1	1	1316	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYakcvYnn88vUBW8wr5ZykNUcrRMhd78g2MVtUtwYWoFiCYs7Gk
44381	payment	1693	1693	392	1	1	1317	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa11h2mBFLcS4xHYif7K1VQ5Xwq4VaeKQyCePB3DyQxoQJGmMHa
44382	payment	1693	1693	186	1	1	1318	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZy4T4PVeN7ZnWYj74FNaoHQQ9xgm2Lp6d2R736fhAYXGRLsWUp
44383	payment	2134	2134	1874	1	1	6870	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFzFjwkyV6McgNeVwhgdRLwxVbexTriR3UZPTkbEZd8A8wFkZ
44402	payment	1397	1397	1678	1	1	16574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpMmXD7GmzPQUqAtuNMENkvR4QM6jk5esCT2sFX9VYFjd11yH
44403	payment	2134	2134	1874	1	1	6873	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC89rU9PARjHhVmBPqDoFKHLNzhTtzsSuZUZXaR2djdvriusjW
44404	payment	2133	2133	1874	1	1	6384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5aEHardEHe6xW4mVvjBJPHqX8kV6rwcGmzekZS71dBJB1qUX2
44405	payment	1693	1693	1962	1	1	1330	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaBzXEg3hnAaAUv6oCFX6XF88vKFJEWRAJmbDasp7GnnjsGrxZ6
44406	payment	1693	1693	748	1	1	1331	2072410282	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZJcMypU8PjPFF8HXbqZZ3xm7uEL9bDyVzswkv8LY8oLzFxbY8x
44407	payment	1693	1693	2073	1	1	1332	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa1NkcBNSoeBXArPtVJ7HcaydyV751bj2ezrQaxSyYbQ34ccmuc
44408	payment	1693	1693	99	1	1	1333	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZyLsCK98RtzTrSFqY4JiRErtdTApPFyfGqDRAHbV11Fq34taeq
44409	payment	1693	1693	1778	1	1	1334	2070075331	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZHu73dxrHzuMcYBkztnGZQ1HfT59waYhNFHNUbt8PzhUTrBCba
44410	payment	1693	1693	108	1	1	1335	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGAhpcUTvh7gym7rjSgkmjsURazjnynpqKXi4HfEmpwm6kaNU7
44449	payment	1397	1397	1678	1	1	16580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3Vxv87QXLbaZpqC7vR2XFMU1tD2MNivpLktN3MkLRozw9EfT
44450	payment	1397	1397	1678	1	1	16581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszbo5cdidXKDtbijy3W1CfLkrvbnykc953f2CX6tdCRgPkTdB
44451	payment	1397	1397	1678	1	1	16582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpy8sjQSAUXMRwxfU6v2jCoKTmGfK7oeSaDzEwipmeKd81jSa
44452	payment	2133	2133	1874	1	1	6390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSCGaya9gMACB3jKysHGVWFwXBUCdhv4rvrYVqtPFy95Gc4pE
44453	payment	2133	2133	1874	1	1	6391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ANZqsywqgTtRy1zXL3yRAF4WVp8mQXVv7BxnWdE8FLsyVtiE
44454	payment	2133	2133	1874	1	1	6392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMQmnhZ8VW7TWQqBrtdNYF38LVoKKkYT7rDE6LY9GDkcX6HxXT
44455	payment	1693	1693	395	1	1	1358	68596717405	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa7B8anSkugsTeEg7zmZiixRnqK37Ae1GJmoNcTbPpHbS5rRxww
44456	payment	1693	1693	593	1	1	1359	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ3h5tEGFCdJJz9hWqy3v8gvbFQZjHeoqkbriF9fNL9qRAbX3gN
44457	payment	1693	1693	1961	1	1	1360	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZFoewUtR42LVrzi3dRTReQcsyNtMiZYUhyCkLdRaYpzMn6Na2q
44458	payment	1693	1693	154	1	1	1361	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaACWQie848VGRaB3qTkdeJSfG9LZLaRdQKBXH431S1A2n5Bwv2
44459	payment	1693	1693	658	1	1	1362	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ7P2oC986MfKJf1wsUNC49Uih1sDjrXEZZcz6yV5jqpWyEhpLF
44460	payment	1693	1693	660	1	1	1363	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZXyrWGDMYV36XQDxUPCAwenN2HH5uLBjTzb7eWNDpux3S84XPn
44461	payment	1693	1693	745	1	1	1364	2078783426	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYTgE4Wmq41H1hL62Vq86jxWzNJxfBMUSCExxNf4pRbjMKrQKYt
44462	payment	2134	2134	1874	1	1	6879	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAt9NJazcyqu1LJXtztmQE6BpBho1cddCRtDaLa5w4vwDwbfcU
44463	payment	2134	2134	1874	1	1	6880	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXeeqeUhTTEcawWDasFqJMs2C5hiRfCqEDibyKRMvGyJW9igm
44464	payment	2134	2134	1874	1	1	6881	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58ktfNtizDbqWLq2u1WBL8SQLTY4xuZ8T6jjrXnJixWa27DLY
44465	payment	1693	1693	91	1	1	1365	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaHvkWxzHgaeQtRLvBQ5eFGx5Jt9k4p4kuwtTA2BqcRVxnnN3DP
44466	payment	1693	1693	438	1	1	1366	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa5ikUff7A9bzv4ih1cNfNRzZmy3w7FS9cu9RsKiLcXLD6Y3V31
44467	payment	1693	1693	373	1	1	1367	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaG6txXAFK1z7msKkn1Hk4LKDHgeW7t75MPsrRvbznrUbNPyj5C
44468	payment	1693	1693	453	1	1	1368	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYmaUeWGRD1MaaZuHEXV36UhqbWLxFRC75NV3SGg7fwgAWb53oP
44469	payment	1693	1693	92	1	1	1369	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYqAs8x9bxfKj2QBHxpQFi8rE6XYvEB7N2EpGXFHtQU7VkPBf2f
44470	payment	1693	1693	150	1	1	1370	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa9mDB9WH9j77jHkrd9kpj1DqYnJai1J86PmDJYq3KjgD8aGZTq
44471	payment	1693	1693	63	1	1	1371	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZCisTSB4nbAQoiGEdXW249XroPSotgvLaMFPkmDc8Hi7rBQ8Gc
44472	payment	1693	1693	562	1	1	1372	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa5VgJuGirHJD9bMro75fqmoCPq1gWpFEN9pSz7Sgrk1Kd6nVAU
44422	payment	1693	1693	893	1	1	1340	318909198285	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpYsrB9kDL6dHQNgf1x6dBSKtMaTsvkgm27Sr1hobegvPdMo7jdG
44423	payment	1693	1693	103	1	1	1341	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZNCh9UVWUpxH92yBDVN1UzBS78n2bJXoSJ4a8NjXSN7G9JTafX
44424	payment	2134	2134	1874	1	1	6876	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9dm5cagyW63qQhcqm3YRVUMHM9Vq6n3ZNM5zHhgf6zMLZPxj
44425	payment	2134	2134	1874	1	1	6877	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhm1Z8mxoQd6kP3SCzVMDEznPDaRcyBAbxHXNZ7wALKqrLbQoK
44426	payment	2133	2133	1874	1	1	6386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMQZd8AnqhJ3BKoNCFVC8rCEA6SZVBggJiTwwRYLVYmUv2M3Z
44427	payment	2133	2133	1874	1	1	6387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEBayZUr36LLtBgjhHoYfoVFCCr862YjrqDVHSVSWNEh7W3HrT
44428	payment	2133	2133	1874	1	1	6388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rTYNJHmaFDh9B2gcmdytANxgeX1wzZChj9wJffBphG92wJQN
44429	delegation	315	315	1515	1	1	0	\N	1000000	\N	E4YhNESmm7Y4rDWMNS3xvunSd1oguQWiqJn1pHQQM72kJ8Wbp8Hw5	CkpZphqbHj7yhykqCNVLtsqmRBDQupDAcfWh5uWnvQqi8Ry45DiMh
44430	payment	1693	1693	217	1	1	1342	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaKhgrerNWpAeGfWBjmcjdEv7YWWg9jN4fq2RT6Cp8jms1zGV9x
44431	payment	1693	1693	530	1	1	1343	68308014195	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZNJfKuxroGc7E4S7uq3xbEknZe324kq9FsAsC4ogEzXrMY92Lr
44432	payment	1693	1693	54	1	1	1344	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZGUM7MKLBa71B7Lg6YQrruqbGgXWx35MQv9qvuQpWAHjgQjcHb
44433	payment	1693	1693	603	1	1	1345	69054134271	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZDHMUMighom4oKHymDsVpFMQZYh69U3i51qjjkazZEVj8JTHtY
44434	payment	1693	1693	35	1	1	1346	19956320964	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZdWUYEhdAcBuCCkp4nFGQFgYsnxShSdCDMBR7fHtcFXuQspePy
44435	payment	1693	1693	49	1	1	1347	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	Ckpa3L7byUBapzoKfCWZCgnSUUtHrAka1yp1qFtenosigHGT3rtNB
44436	payment	1693	1693	240	1	1	1348	68309050196	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ8q4RVrYikbhiJXC9g32twv38mTREzyUyLeiBZBcE7EQ8VzH1w
44437	payment	1693	1693	262	1	1	1349	68308014195	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZSA82kwRwhg5X6HAFNqjt3QHzoDFvdx6cFephq3WtKshuTP4iq
44438	payment	1693	1693	441	1	1	1350	68307922083	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaA72iKsxTYh5Mggv68tMkoMQmXjdAqfCE8FF9ZVdvVMRJTjKGW
44439	payment	1693	1693	304	1	1	1351	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZ8sNKvnimXdh5jDNj76P63Z5iUp74vg6S8jgSwa9EsnFRLKreG
44440	payment	1693	1693	653	1	1	1352	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpaGvTmJkX9T7BmQmipzNK3sbaQvEhcp5tTA2Jatr8qMuWQU85dg
44489	payment	1693	1693	1778	1	1	1380	68599853356	2000000000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpYhsJuLePGTHimk8KbWC3ATnEGebvNLdwBvR4HyHyKGNuQ1XXTS
44490	payment	1397	1397	1678	1	1	16586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDAhdghuzKka1gtoz2z1Dgj3UL9EeQMwBHSTpk5Z8FMtXPYny
44491	payment	2134	2134	1874	1	1	6885	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpsEXGCDqo1WsAhBJ55Fe76BLemtEjB6gNW7VAHCKpo4FQ14HV
44492	payment	2133	2133	1874	1	1	6396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TLQRYegW3XRPEPTXyKRhbeFWewNSjRforjK4E8au7AkqkP3E
44499	payment	1397	1397	1678	1	1	16589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwC8hzBEJaZ3tHPRepCErHpTdyvYUzKo7eRE1Y8Rb8X1mwQJge
44500	payment	2134	2134	1874	1	1	6888	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZicvF2EcgVu7g8jm38CW6q2vUjW9uxQBwg4kQ9V77FQYrG2jka
44501	payment	2133	2133	1874	1	1	6399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL65okA9h4WriFPU6GjRWDVtvG4qVjrPoXLG4Q7fTChxGMecv1
44527	payment	1397	1397	1678	1	1	16598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8cYesVSt33HLkA3YtRE3XSba3gar2C7N7J9HRtkRqHhptZe6
44528	payment	2133	2133	1874	1	1	6408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS98yLrTKe3uiyUEABEHHFhojHCvxbFAiyBwhvCuHD8th77JCi
44529	payment	2134	2134	1874	1	1	6897	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrDGjiDsPRNsKdp7agimq4NerwF14ptL3SLRfS4Wn9VJxB3FDn
44554	payment	1397	1397	1678	1	1	16607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvRhARx9p2C4QHhZ5tzeqamND2RrMjNLhjF4r2Pz3oqHzo78mW
44555	payment	2133	2133	1874	1	1	6417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Ar92RWBH8W77JGZ6U2sJSP1HbhjuwJXyy8FPneLHYL2hiKgz
44556	payment	2134	2134	1874	1	1	6906	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrudLTVCksXS5zztgd7snqKGET9fDzKce1jzyzunKyq4Wtfzs
44559	payment	2133	2133	1874	1	1	6418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQtKGTpMGzMLVRvMyRzsZ5en8Z4NTkrzp2UPmjc1n4Lvq94Fzd
44586	payment	1397	1397	1678	1	1	16615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyk8Ke3WXVyAFUDjm2wqB7XT7f9G2XvT6dGmquKHTwiBRL1u9
44587	payment	2134	2134	1874	1	1	6914	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT9Bkg9SAPftx1mmHxAfpQQCbu9wcoVkNJ2Ca1YjESUinMtNid
44588	payment	2133	2133	1874	1	1	6425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY4ATbV1wjspbHAfEnj2UjedsiDyAYVzH513bviqfqeXHivdSh
44599	payment	1397	1397	1678	1	1	16619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcmLZLT7m9vKMiy6fVXkPudxzjDqo1SzeqEBkoSKo37wB2M3VR
44600	payment	1397	1397	1678	1	1	16620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9VQ8jM1SrMTg2hTcmBA3owXVgSAjxszoxkK3hFRjcfU1wQVY
44473	payment	1693	1693	711	1	1	1373	3107378639	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZMkwgWE88THQwM1pNLcJunvey16wieu1AURDcdRCF5j1rGXV3S
44474	payment	1693	1693	551	1	1	1374	68599853356	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZq6TubDSqqTj4wN7UVR7MGgWnrF9umE1UX4XmYXufFZsNmfWg9
44475	payment	1693	1693	379	1	1	1375	68308004884	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzPPkFH1Bnuye3bQDJebeL	CkpZezoob6Y9qykj5bECDPDMBLAizcMCRC9PHm2wTG7C3e3rP2iAz
44502	payment	1397	1397	1678	1	1	16590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnUKuQ7jfi7NN3RGgR2DzowFFHHD6FTWQHjRfh2Lo2bfyhQBoY
44503	payment	2133	2133	1874	1	1	6400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmiczSQcGpCtbXkq1sDXKPXCYtphiCR2MJ1Dsu38FW2DLxvPXK
44504	payment	2134	2134	1874	1	1	6889	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbSravrZXMD47cPZs6ccHQYVwziWPeE2on1VX9TCxPLVsfHtU
44505	payment	1397	1397	1678	1	1	16591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRW5Q8n17F4jeCvhSTuCLwQNYpdwEWUUVSCTi38Qcp9qDiEWc1
44506	delegation	2338	2338	2346	1	1	2	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtLgSx9EE9GdRWzCLBdVdyuqtVfqsfvye2MCRhWVEYhP7GC81
44507	payment	2133	2133	1874	1	1	6401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Qzc9v42YZNLVTEdwLqoqmyS8S32RQYoUEJCJGfiBV14afeZq
44508	payment	2134	2134	1874	1	1	6890	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzhg7FGQZu2bSSiMtSf97fGMHQ1onhfUfbosQ4aft27wsDT5W
44512	payment	1397	1397	1678	1	1	16593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmS7rNqNkZysZXbghigqFxkDhj1T3uCc6aPb9TfNfyCe1dw2ro
44513	payment	1397	1397	1678	1	1	16594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fdgauQQbueitZidzxbcQdBT2Kvp3hqtB1FwUeCxtqxBPsRi8
44514	payment	2134	2134	1874	1	1	6892	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38Dd9atASQxrKrbwD5peabZhJ5KpxpHwfYrnpt6CnikZdLMur
44515	payment	2134	2134	1874	1	1	6893	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpWCoaw1HefxZfNeJxHNnnaEAHwryPGgPjY1nDSqcdNng4hEZn
44516	payment	2133	2133	1874	1	1	6403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1QW5RRPkCAp1n5QYoC8n2x2EtgD7nTkrd77wYJf93qL5bFr2e
44517	payment	2133	2133	1874	1	1	6404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG5cgUkn86CKp8z4zw12KkkeGth68FsjbT9aP4EJtxgMKhSVc
44557	payment	1397	1397	1678	1	1	16608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZennahHCaGKJCEdpJAg9XuuvLVQffFGoxFvFoSBi9oZcvJ64hH
44558	payment	2134	2134	1874	1	1	6907	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtRaL6RS1CfeLZ7pCWH9D7YV6i7gX28QwEiGYYKUaLMqDHb9Z
44560	payment	1397	1397	1678	1	1	16609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaCz8RaQQ8fDu5P7iQ5Bzp5LueX6SgR3qH9MpzsF7tiCb5AWA
44561	payment	2133	2133	1874	1	1	6419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCxFjobXLFW6LfaUjsQodBroU8AXor9juNg5mwbAhz58MPX9f
44562	payment	2134	2134	1874	1	1	6908	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4hFFW4CQnTY1RfN5VnoYJ1xEZr2fTfdsoN2AimQHhinMBGYew
44568	payment	1397	1397	1678	1	1	16611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKwgRuyqsG1esbHSAM1jPPcYcVVBMS7KSKvDfdUzmeW9bucPCa
44569	payment	1397	1397	1678	1	1	16612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFW5Zx8AxXnZMvqif6FLr3SpLBxTXfET7ircL8SQhoevqrDm98
44570	payment	1397	1397	1678	1	1	16613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qK1BhULmGgqq7gBgJvmZb6mydnFNPtMYCcYv6msvg5NCqSEd
44571	payment	2132	2132	1874	1	1	1718	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUo9PFCq1L3gdoQq9SswsdApGfQVpMfatQf99KFZ1qXnHJ7r39
44572	payment	2134	2134	1874	1	1	6910	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKXwGvM8gnyCM7k2pCXR9coHYqEUXdmfV9vW6PWNy3H1N81da
44573	payment	2133	2133	1874	1	1	6421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4DYtLq3gxHBkb7Sp7EEtQ146WiM89D8dbaQ9ag5z4KeZfY6d9
44574	payment	2133	2133	1874	1	1	6422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYatwGghnymHFzANwvvNCBGCwYj9NKrvvGyLkJGLQHBcG3NUFGn
44575	payment	1726	1726	2381	1	1	8334	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZMrKmJdqFuGrnHaxNcgbY7AsjWPZieUdah493zq9k6WudxFFuU
44576	payment	2134	2134	1874	1	1	6911	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUvTVQ25k2zSM3UNoANY9sQSffvW8kCcxEbixP5wcD5HDYGNms
44577	payment	2133	2133	1874	1	1	6423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb1iiDe8v3QmDSoEqcCuknbNFBLBBt9UzRfvDQedKS8uw7iDAn
44578	payment	1726	1726	2382	1	1	8335	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZeRSZvRuWY24rWoqKnnZ2KDjz2wfrJNWHXo55jGxPTc2jdAQUH
44579	payment	1726	1726	2381	1	1	8336	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZCd39FvT8pDs9s3sPdgpL1EGtZRBk6h2tBNBZfPCqZMZAfXEUc
44580	payment	1726	1726	2383	1	1	8337	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ3K86SX6brh9zVPzBTsE1jexs9izMpMGEoyKuenhwCR2sbQ2fU
44581	payment	2134	2134	1874	1	1	6912	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjcdCXgfDBRxMz66jd6S9pDkiWUyhVWe21LGQrvHbxQqSXjjsy
44589	payment	1397	1397	1678	1	1	16616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTnsrrzjjKdMX2gP6cxLa7WSgcBh9ZrNXWqEkBFZb68SGsrsG
44590	payment	1397	1397	1678	1	1	16617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8FGNb5fMstTZaKBXkLGLW8JUmFZQW9gZsHcLWcDXjTNzZVji
44591	payment	2134	2134	1874	1	1	6915	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRG1o6SqLJ4guon2TGEr17atTTxHmxaYuLoo95Yo3JQS6AtmZz
44521	payment	1397	1397	1678	1	1	16596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFrCc925V9FLttmjxN5kjkdLPAwPMBjgK22rAmKBFqZ2hmxca
44522	payment	1397	1397	1678	1	1	16597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwRUTgrNMXMyofknSCAVLrRn1M55znQQKqMd3sY8m5CbUWGu9
44523	payment	2134	2134	1874	1	1	6895	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgC7ta43JVEVw6K9idWdTbwGmhnorANT6C1M1Z3oCsktF74S8C
44524	payment	2133	2133	1874	1	1	6406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRJfgJ3Winx1svYD81PPK3rhzqLimU4Yix8sth649tZQdZ9hA
44525	payment	2134	2134	1874	1	1	6896	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKBHFETyA86ugBTxXgNzqVqKXokLoY6aCCwhxE6VSaYTgt3hr
44526	payment	2133	2133	1874	1	1	6407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33R4mPjLogjHKv2ibnJa7G7dXcQ84gLx7BvWkBghGZxMDtc9H
44530	payment	1397	1397	1678	1	1	16599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUoJ3gc3FgqVkzSVrZpXWBPA4ZujtAkyPPCnGJNuE1zrPku8s8
44531	payment	1397	1397	1678	1	1	16600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTS9CuovVhv3m2gxNAa4Fi9pzhdL7ovU8qMkPsxMp6eyty2qWM
44532	payment	1397	1397	1678	1	1	16601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc53aiGE9NSZetjDid6ZmLVDHn7YXCYvRLaQTmoMCT6wLhigyZ
44533	payment	1397	1397	1678	1	1	16602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDSTKDdrNJJRyXyPaxjTizCHij2TMRJyQYWCLcsHfM1oL6JEWU
44534	payment	1397	1397	1678	1	1	16603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE7od6s9mmpEmQACvVdJgz52Ux2c6wifHuXtZKAS43WVMPZkDM
44535	payment	2134	2134	1874	1	1	6898	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXmE8RhRVcKrfB4u6AX369paKsifn9FUdvJ8EZUAgxbAE9dGw
44536	payment	2133	2133	1874	1	1	6409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtxAoPfktdot9G5UMe2iypp8uSK8hhk2p3vXaGqu8WCihTMZHu
44537	payment	2133	2133	1874	1	1	6410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCgc7v9bwqZKieCxMHixyfmbjBquo2DMfXusXFTJ5vLZkuZaFA
44538	payment	2134	2134	1874	1	1	6899	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijZQrZHZjQpSDMwqt4bxQcHenerMDugBbhmRPJ68QdX9GxN2B
44539	payment	2134	2134	1874	1	1	6900	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeVYVvq6qb965xh1crUcUp2WsyXAMb2LnL6hjBACLK61X2Z7zA
44540	payment	2134	2134	1874	1	1	6901	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm494vpELAtABcL1EfjP4DDEaH8YCnGefW8ckq7vccyqjeqNZ4
44541	payment	2134	2134	1874	1	1	6902	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGd2ovBoEDpe1Xw5pUaaREbYFJ7aP7nyVmjpfMfQPn5tJhG2gL
44542	payment	2133	2133	1874	1	1	6411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx4pL5ruBuFhfhfj2JQTRYAwND33mh1J7PGHSsau9iEN5cs2Ai
44543	payment	2133	2133	1874	1	1	6412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsQG1JchPJHtGy6VQdUEGRGUn8ZLV5rFCdTV8Xc4p3HnG2Dpqh
44544	payment	2133	2133	1874	1	1	6413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNmLAajDWMRmsvY8PSLc2xvMM6XSP4XFSSHHQGSfGHoZaAnVDb
44563	payment	1444	1444	1693	1	1	12	2000000000000	10000000	\N	E4YmEgWXS5JzW1tKAN2mYnqYKmXsQ3jHPwnBsW2FSQtK1MzHpN8XU	CkpZCejUMmhRxfvs1ycrg6oDT4wQmFuCtyeLZ38ETvefQeMHLMyK6
44564	payment	1397	1397	1678	1	1	16610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3zsFwQCp9oz6gB2a1WjCUWAtabNqpUpDB9tyHCNFkikLEJ6Vs
44565	payment	2132	2132	1874	1	1	1717	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeAcCi3wzv14bCN9v56aZWf47C3gLRn7SDfMQw9FLgX4ixW9Q
44566	payment	2133	2133	1874	1	1	6420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2cCu5HG4zYWYgdH9c6coiRoKZoxm5LPs42EfSsw62s8MSp89B
44567	payment	2134	2134	1874	1	1	6909	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjmWqjxAv1sridn2zCrsDM7VRWJN5Red9FgVYQBqy4rB61PfZq
44607	payment	1397	1397	1678	1	1	16622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe6nhFoE9kaeL3rJBd8MtyioufqQR7cKNXBygfCYQExwrW4R27
44608	payment	2133	2133	1874	1	1	6432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndqgDLaomAdDhdWtGBcbmxdqtusS1PF5TRqJ6MXoJXPdiZmfZ
44609	payment	2134	2134	1874	1	1	6920	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRseUy58wndM4WeoWhGJ9QrsEeVMRkWC17CEDkjFjPmk78oUxJ
44617	payment	1397	1397	1678	1	1	16625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqKKEWm5QU2ow42U6YQh4wT1CQLndA23aFdS8x7Kh2ZZr8DqP
44618	payment	2133	2133	1874	1	1	6435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdyGfLxkWLEpBgQ7LxTDgiAmZHc6xDd1i5C1yWzkHQCdsoYrCS
44619	payment	2134	2134	1874	1	1	6923	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsP2QUCjwD5n8RVX1mr13EXixehKveQG158Ge4cXBLeuLHJFc
44651	payment	2134	2134	1874	1	1	6934	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1Zi8hCddKFVCJdViCPcvE4Tb3TnjGjZCderujjfiMjp97VDh
44652	payment	2133	2133	1874	1	1	6446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99XUeehPhP45D6zrsTi33se3Zh6of2kavbCqEEzsqpfZeW4Co
44653	payment	1397	1397	1678	1	1	16636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquGR2gsPmdPM8qZ3VS9MX5fqZ4Gdy2f6snr5Jj79sdgnu6uRn
44654	payment	2134	2134	1874	1	1	6935	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfkSgyWDqoYkaSpqA1FnxoD12DvLNd3EFbzx2qSBwDV7S6gXw2
44655	delegation	2382	2382	1403	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9h6U7UdDPN5PjYygYftZgy6pdb4UuJfvJvrRNKZg5rQrwhqar
44656	payment	2133	2133	1874	1	1	6447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9pY3jMMpcq8YYns13bD3GGK6SYgvQCAyzBfZvMtWij8T9gin3
44545	payment	1397	1397	1678	1	1	16604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfjuk1zNK13k16h9ikUmVVeSboGVjs6YoYJo9mPDmeowRUKCm
44546	payment	1397	1397	1678	1	1	16605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTH2bQ3jqTgZhcoxQwjCJDgqcqt6Je6G99Wd6TxjDQ25mxhdsD
44547	payment	1397	1397	1678	1	1	16606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp8SgiwTdzGzcM5szbhbFim4SgtjfGX1CFZUK1jYVc45inoLNX
44548	payment	2134	2134	1874	1	1	6903	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBDy5NY4j8xiX3RCtsR6gSa3TbFtCrSG2nsvbLawEJLLa1zgL
44549	payment	2134	2134	1874	1	1	6904	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxWXk8seeXf6S5oR5mbWkov7arwtN1BWNRmDdM6AyowwvFuFBU
44550	payment	2134	2134	1874	1	1	6905	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfinmvaP8ADri4Ger4S7rMEH9K2iVHAJ4kjqc45mV1jUHN7sMR
44551	payment	2133	2133	1874	1	1	6414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AvKUp66Wy5XYzvfD8HiD2DJe1mFxr6dHZWnLKodVrNK3auPd
44552	payment	2133	2133	1874	1	1	6415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTFPdunMnuGJgk4LXb1o5epANSFyLpyK3wF3FVBhAgeoqwLLY
44553	payment	2133	2133	1874	1	1	6416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEjnJFrpzmNZ11FhdN7sQbdtjhb2fmyeWoimsZpEFp6poYnSE
44582	payment	1397	1397	1678	1	1	16614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXgsqTZ12qfm27YpeWHW8PfXKsQUP1hjUqyJynpv2obf4nxdJh
44583	payment	2132	2132	1874	1	1	1719	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdn5dfmH43qDugaQMGYBs4re7JMhShe43kQrk5gJSLNiEPJZ6
44584	payment	2134	2134	1874	1	1	6913	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd76rBfCdSyytBGBLhPaEjEnVX1VJkcR3rhiHz67ebz41oBetc
44585	payment	2133	2133	1874	1	1	6424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyqQiJH9HiASLzBiQB42sfrhig76gKNmDXpS8cfJhra8MBuhJ
44596	payment	1397	1397	1678	1	1	16618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQUC4gEWjGeb83Zg2yfpo4ra8Y5x5o7hbCJBm49VvvUhD7jGK
44597	payment	2133	2133	1874	1	1	6428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5qbqQdhXUac6oTHbBRajxSQDgmfv4h2xgHazGSbw86RUkWqEe
44598	payment	2134	2134	1874	1	1	6917	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyEamMwY2AyMz9xZCpgLcWacNuDPQY88NoHHtFGq8JqkEUhih
44605	payment	1397	1397	1678	1	1	16621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaykhjKp7r7EgQhH3L8AFehjN3LDDSTWuynFY5FmBxHV4pYkH
44606	payment	2133	2133	1874	1	1	6431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1fLUsyH7hx5iUZ6jbRFJNJZZoKxo84BnCd34bpoqzsroZYX2z
44610	payment	1693	1693	1444	1	1	1381	100000000000	10000000	\N	E4Yh7YJPCbnRF3VwWkmz8QiL1eQ3x7u1qY7zjFsozgFdoxrP3fWpt	Ckpa6h8urjW8aoZNr7BGzX1xGwJBiP6atXqL7d8kqJAK23q42wMbw
44611	payment	1397	1397	1678	1	1	16623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCEXdfLodBLpCq2E4iRjNAmrz7P4Q4Qu6hcSkhhVSmfcQVMekq
44612	payment	1397	1397	1678	1	1	16624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHw8LE8mbFLCghhkZUM9ivbtEdDm9tpzmtPVBWpVP3rdG89cDR
44613	payment	2134	2134	1874	1	1	6921	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXFukZLMXAnVwVRsXViEUEyjKz5baGg9Bn4oAtqHQwcVh22qgY
44614	payment	2133	2133	1874	1	1	6433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZmQ3j2a5AUF5Dw52Gc8y5N2Z6WGyAQoVST2w2LCpAZo8yzEeF
44615	payment	2133	2133	1874	1	1	6434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQAaSzC7t48DUJrqZMh2qbED2BdLqUMcSDqtSqotzd68TbAEFL
44616	payment	2134	2134	1874	1	1	6922	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgXiGbRgW2RmjiRNbfj3e2mRJuGzDJThuwzfBjzw1jzXoAa1vR
44623	payment	2133	2133	1874	1	1	6436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXUWpb8tm12Ed9xd54udnHY6fmg2j98fTemF8tzyzJbZqiVhi
44639	payment	1397	1397	1678	1	1	16632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdReRgdo9gzFPwLdPdWZphfxeBtPSatdQKqQbDusmztzt2ipv7
44640	payment	2133	2133	1874	1	1	6442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8djHu5X1ocq7UMdhbTRpPVgmYHcHqZyx3qJ2je6bnDLQS7FA3
44641	payment	2134	2134	1874	1	1	6930	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FSewM84wumzui4qSDi8EnTAsiBsT5QEXFzafNu6yVnqv9Mdg
44642	payment	1397	1397	1678	1	1	16633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUN11vs7KmYCVyDGuoW5T5JeUomXi8sAxL1vLuMyxznJPragqs
44643	payment	2134	2134	1874	1	1	6931	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqFMPPeopYekiYqAdtQ9FGGBmieKbemickHR69qy6zFrfiPePa
44672	payment	1397	1397	1678	1	1	16642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXupQFyCc4X5AzX2yZzad9GykwsQQ8nZTBEvgtR2m7c44btKs
44673	payment	1397	1397	1678	1	1	16643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm76AdevQDPQsW1gWZGaLLzS4kh1XGL3Neskoja1Dq6Nh9Cf1u
44674	payment	2134	2134	1874	1	1	6941	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHYQq7iNA66swKpkdqRAkpJDyLLyFetAj2wSAGPAoTWJDeLLN
44675	payment	2133	2133	1874	1	1	6453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmifJS2GeCJVBcMjhQUNaPZxBLuqJrbKNje9xS2t5d2QA1D8iX
44676	payment	2133	2133	1874	1	1	6454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRCvzexKTWqE29jU9Luu5VKGZjgAPzDHigXREHPT4Au9z74XHw
44677	payment	2134	2134	1874	1	1	6942	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZoeZgL94eSeGHijjMNtZJ2MYqcjgGjYrrY4XCwam1HZhnsid
44681	payment	1397	1397	1678	1	1	16645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEmWqb9KSkuJEVMjKWqiAHaNSVovXr2xvx6BzssY5tFce8LV3
44592	payment	2133	2133	1874	1	1	6426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpaB4BXruHv6VBZcNiy27uw26U4Ynyz5iRmY6NgSVyjELKKHns
44593	payment	2133	2133	1874	1	1	6427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVmNBKffpKBTvKbRsbC6bcfib2FngxMffAPgu4zSVbh6ChKhU
44594	payment	2134	2134	1874	1	1	6916	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQbcj8TzNdVvoBGBuk8Sc7f5FirbA1EAMcBvPVFDQcmVp8bVX
44595	payment	2132	2132	1874	1	1	1720	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59j2YjRGjc7CAP3mW2Ubj19gRmdzqvhSaSafyA5dwWdRUWTJH
44620	payment	1397	1397	1678	1	1	16626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCjm7GCBq6StCF6Scmkw9res7yCLtvvEqSsiJTBF6N6BA5g8L
44621	payment	1693	1693	1778	1	1	1382	1900000000000	10000000	\N	E4Z8L8tkcncDsimpS6uGAS3z7kWkpRpkU4tCX582UX6zdNuqX6Th1	CkpZ5kGua62oGgg25GQSgLxhAQMm1dEq6kCioVCskUkgbPfdzBdV1
44622	payment	2134	2134	1874	1	1	6924	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvj9XpH5nE4FpVU5XtGZzsLBqVXLTkxbzc2H9vVmttdjdq9RUy
44633	payment	1397	1397	1678	1	1	16630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUAuptZN7fakRcdPLNNiGTPPiDJmRHLyuoWZB3APAjco9jPpv
44634	payment	1397	1397	1678	1	1	16631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6mVdLjW8rAnRqGXQWbNRWfGXVcmVdAJAUVuunay8XfaMz52s
44635	payment	2134	2134	1874	1	1	6928	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw73o2pzdFMNvamPrW3RJP46q866Q85c7e9KoHjVWozbDzneda
44636	payment	2134	2134	1874	1	1	6929	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1aum5nNjvQXPFJqKHU2orwr2Catn2rQcnbUtmLS4wRXcNhd1m
44637	payment	2133	2133	1874	1	1	6440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8EXwjpPuyAzUnWLETetdU3cE5nCFPAjFR96Fbm7qFaHzkhREN
44638	payment	2133	2133	1874	1	1	6441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz5rynt5DkwNGNLohpzk5cEiKC6niCT1PXHeAyuK1zMuhL6mva
44660	payment	1397	1397	1678	1	1	16638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULp88nVsabhrKjhLvcHrcqZu9Y7bTGmAap2CjXQNjPKiudk9w
44661	payment	2134	2134	1874	1	1	6937	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjJRtiWzja5ZJeDpwZYk6YLA5gGLnCVGacsPZjqgpr6zYvLwyF
44662	payment	2133	2133	1874	1	1	6449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDgEGg6ka1yhxGs33zRmLvxkrUPwEngPUt414tPgApbPW76wBZ
44669	payment	1397	1397	1678	1	1	16641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLrC7vDLDC4pUwP68Bzb76JpDf1mW69qRspeNZu5a3uj3rZFEK
44670	payment	2134	2134	1874	1	1	6940	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtUkpMZ1cm78ekmNBG5q4axBF1g1CA1dLgLyqp2w5xpmekgRh7
44671	payment	2133	2133	1874	1	1	6452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jEdbexeZkX4uUQpNRe2ZeNCqodHmrcttnu7r6SQtBet9nAVS
44678	payment	1397	1397	1678	1	1	16644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYQ7nJhdmiSTVDkThMdtnNhghoSnexciLVNFBxtKicmFaf6Re
44679	payment	2134	2134	1874	1	1	6943	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMx4jKa1Gzr6JNL9G2qDwpYFyazvmrXJo2RfVPRzWGhrqDPmM
44680	payment	2133	2133	1874	1	1	6455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkjk1s4Fx5HKT7i7VmNKasw66tFgz3fqKrvvjbmArKibxaCqp
44706	payment	1397	1397	1678	1	1	16653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsk2P5MRTEemS8o9hK49XWCag9645iPsDNiHRx1KQeA9Dp5sDh
44707	payment	1397	1397	1678	1	1	16654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAboE8Hq7DmX4CcPjZtNXqmZFPQ97xZp1wRiFhaW29Nypp5dz
44708	payment	2134	2134	1874	1	1	6952	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7Xa4NHGtsukPALegn3Ef2b9AoR1A3TAav99kTWFyeyyNgK9r
44709	payment	2134	2134	1874	1	1	6953	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETK9qtKvFs3Pp6VYv9atHFwit8popYiUh7BRKCnZ7HMSrVRxA
44730	payment	1397	1397	1678	1	1	16659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbsT3dKFgUTyoRFCrcShaP4Mj66VsVUHoWN4Ajcu5SvZFGPvU
44731	payment	1397	1397	1678	1	1	16660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5tTEaEJfHybcKdi3ZYHfKJJHmttTMmbEzmPpqRvDRxXb86QoQ
44732	payment	2068	2068	2152	1	1	1	2000000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4Vg2wLnpmQwToiyLWhHRQmfYwzDTcvEu54tJSsWqnELmmgM9
44733	payment	2133	2133	1874	1	1	6470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZpPePiQW3wiJt8x2cep3Gg6oVVtroqNgfWyqdcZLyuvX9uH5
44734	payment	2134	2134	1874	1	1	6958	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNViKq24Ed4J9NyKxbnJQR3EhKrdytzGSsVFcwGjtoVVFrGFc
44735	payment	2134	2134	1874	1	1	6959	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj5MXHsR4YhnWHqg6K62AN6p7HHgFD7aKUET63Qt9Dv4Abd1ep
44736	payment	2133	2133	1874	1	1	6471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHnCkNJsysah16i943YzEtKybfX48v8RMmFmbDQEAHAbBN6byn
44737	payment	1397	1397	1678	1	1	16661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJX2sdDk6Ta9PxNU1DLX3oi7SEX68PrazoS2K3k5WR6hG5xNoA
44738	payment	1397	1397	1678	1	1	16662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpStpRP6PrcQpZd2TPmzrXnNuVQ8v4sWAChqenUN7mX2rFa2P
44739	payment	2133	2133	1874	1	1	6472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqAcrNoP9nNZJRwDYEF4B7tXAR5Hik8Xar3SnioYFH2y92KwW
44740	payment	2133	2133	1874	1	1	6473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJY1WZ4nDqZtRKRfbR8w562nnwiC6ZMFCJvhBtVnJEHcqu1gFj
44741	payment	2134	2134	1874	1	1	6960	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJK4zvcRFwz2a7M8JGZ82263qnRnpzym8fXenzsL1UB5C9191
44601	payment	2134	2134	1874	1	1	6918	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZ6CMcRZNL3UGTJZU8LhwCqBib4wURrC7Xcj1ioTUbF1qybgJ
44602	payment	2133	2133	1874	1	1	6429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoaRG51FzG5cFjVwqRjHgq5MehFmupvrEGM2ToTHXZvAcukGjE
44603	payment	2133	2133	1874	1	1	6430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzVpJsgYKJoBFm9Wo8YWtpg3cpdFR8AAAn4hWsuW887wUoxVXJ
44604	payment	2134	2134	1874	1	1	6919	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8WY1iwVt8CUikapCYA1hTNRyTWyQPhiBhgwqTuZesDrpdYs2U
44624	payment	1397	1397	1678	1	1	16627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb2Y3QvcwHse3gQBq6QE83Jxidn6xpgWAuxZXSZmji9cU4kt2e
44625	payment	1397	1397	1678	1	1	16628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuEBagzZr32VMG1LEr9U3qHau1SWUPLDqcLEBbxRNMiexpDm9a
44626	payment	1397	1397	1678	1	1	16629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFgEWfxeMXGyveeuw768JK7XRejVPwzoqfs1LsCJWVv73qAFE
44627	payment	2134	2134	1874	1	1	6925	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugU6FQHhJg2bBZo6tcwJWjV67ws5YRuVyH2ruw7Dv85GmD1Zu
44628	payment	2133	2133	1874	1	1	6437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQzVCrePtrN7BaDdgDkTsdVGeP3eawCvZypswocNWnT2WFeK1
44629	payment	2133	2133	1874	1	1	6438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3sha2TDYdqG4RiFMqMszCubWupcbKUVYr8Us7y3sjLCobDXZb
44630	payment	2133	2133	1874	1	1	6439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH6frgVTsE8pAeZFYWbaCcyJPcRJEDwZ33H7HRCYo1xJqWVh5j
44631	payment	2134	2134	1874	1	1	6926	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYkSRwwJL9ke4267Bu93cNCxZPE1HiW4Moh7cg8WTLrsm1Q56X
44632	payment	2134	2134	1874	1	1	6927	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa3d6i8SwbJkhmyxixzbWoBHoH2YwE5vUVZfLUv9VGCdumazZu
44644	payment	1397	1397	1678	1	1	16634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojBARNjedBaogA4VN5TeEAhCHGUFJVCP784DQTbnGpMvKi4zD
44645	payment	2133	2133	1874	1	1	6443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCkcgZh1hR8JCXELAXo6b13KWx9Roh2aP7JcNMD2sTgtYPPJL
44646	payment	2134	2134	1874	1	1	6932	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWaf4XN1k3snFJr1KUQ13ZiG5aC2H5CFvntBPXNdfSvSvpMcM
44647	payment	2133	2133	1874	1	1	6444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoKHnydQr5gNfhida5fRsUiViLumVqemrKQA12kC8dcYk64Ez
44648	payment	1397	1397	1678	1	1	16635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcZQWLoqAjTnPJt4UZCcqRUNqJvi9iKZFDPkvH4FnDmLwxNXa
44649	payment	2133	2133	1874	1	1	6445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesRB4v6fyBYWEEPtt8AKu5cKAZVs2xyUEDNgwf8WCvrhHZAGL
44650	payment	2134	2134	1874	1	1	6933	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kbPYVQNRvfC6b8ptBz4y5L3waJ4FxNZBym7dPmCheKfCUKWt
44657	payment	1397	1397	1678	1	1	16637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTPtx3Qttk3mmCgc4Aa3XV5xp6tn7PZdoU6wHRSarixdrGr45
44658	payment	2133	2133	1874	1	1	6448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJScnZHXGVCJGHV4ACJAv71nJdMZFTAHKVAKoEyUdapCRYBkA
44659	payment	2134	2134	1874	1	1	6936	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbCz31Vs1HXkawMszBiXEGVHpDC8FQsUZ6numUn5YsZZwyjgZf
44703	payment	1397	1397	1678	1	1	16652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXASuEHu1cDJg77jos4CSrM5uRAKTbSWQTh1gGrE4mvpFn1p23
44704	payment	2133	2133	1874	1	1	6463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ2cinYpFo9dPgn2ihZp5GTucpMosdSYwa57sX4oYQ947V1Ps7
44705	payment	2134	2134	1874	1	1	6951	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywwr6X6HQCEFEt3MpbgXDMZt2cN4oJpDq4Py5RSymozMpvaCo
44710	payment	2133	2133	1874	1	1	6464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcC8WnMK9KQaVN5gzszqC1K88Htz3jwRgSRxPyjEE4G1dK2kf
44711	payment	2133	2133	1874	1	1	6465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDQjgCcMWR5JfWXtESY6YbWZt9ohE83pLMRAczmkfnwZuch3Gc
44718	payment	1397	1397	1678	1	1	16657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDwy78Z3zqHXjTaR4QxUnhL2D7JnVs3mvuhqdesS7Zijy9hSqk
44719	payment	2134	2134	1874	1	1	6956	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHFLj5W2P8r36HMwCmRiDWh2jisESaeL8mt8dsPzaWgv76aE2
44720	payment	2133	2133	1874	1	1	6468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZas9RNmRSd3ZiRz4JLqzwhKB9bm6mkP4evzyZi1kao2qWLTatk
44721	payment	1571	1571	38	1	1	47	95557229712	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYxoNesTwLacc93jHTgfih9RZwg1Fr9yz4379znn7S3kCxU4qLJ
44722	payment	1571	1571	969	1	1	48	727084981456	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZALpjkJQ1B5VkGE9AVrCcXZrWjT5r33vCDWUm4BwpcU75TR4h7
44723	payment	1571	1571	1089	1	1	49	1302930057112	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaEJ5AHuPzPjvvRogTNycLwnsBT6qtzo9AGMVRyjTBYtsU3DgwH
44724	payment	1571	1571	1209	1	1	50	879112872248	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZDH1E3UcP6vQx1jhrNGBokP7ZsZn9yDdaUSkAMGFzL6ca4gPcb
44725	payment	1571	1571	1335	1	1	51	2449726184880	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZVYSXV5q5h9XLjf2STnXcgCYFJt8MR8o65GTXc7K6ahbUaVhZg
44726	payment	1571	1571	1571	1	1	52	17742574568	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZXFUguNycga64BwMZc3gT4wXpTqyGNRoQgpmpsAJKzkJEqjKfA
44727	payment	1397	1397	1678	1	1	16658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEsT52mnHFhX7cGz3c8YqWXEqdJ4ZDFpKQ4CnRTgQwD3wCo8m
44663	payment	1397	1397	1678	1	1	16639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSVywpBdV2tev9AeJwWyXf487DyNmDykzXtUEsRRRrJEUmqVDJ
44664	payment	1397	1397	1678	1	1	16640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfEaYaH3bA3LKZVZyXXU98ZYGVVeDTtmoMezMXqgs2E4WcAKh
44665	payment	2133	2133	1874	1	1	6450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaGJege11jpS7GxRksfG7dKB4oVzE8tdAwwdx573susGGAyVJT
44666	payment	2133	2133	1874	1	1	6451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr2eWtx81EhARK1tpLTjfQ44XNCcGVdh5NvthA3fwe3oZJryQN
44667	payment	2134	2134	1874	1	1	6938	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMhC2hghrYnqnqXhZmT3TyVygoiYwTzuKSQuAtZWVDR9yTG5c
44668	payment	2134	2134	1874	1	1	6939	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS66RXoyvr628EMK7f6GS82rjwHk5nw2CA4icG4cSFQ9EDmoKH
44693	payment	1397	1397	1678	1	1	16649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUYFzkSvagbpvMJrKuo3QoiQiMEbikoUw6s2QFVmf5LqXqdYt
44694	payment	1397	1397	1678	1	1	16650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bhX9Yp2iWmZWFfkeLKsAijP67eD38J7KLtTxsseq9nPiRmhH
44695	payment	2133	2133	1874	1	1	6460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbYDK6G4TfFwGrmMgxyPqZSHmrnD9PfPJ7ksJw1qzXvsGUhLEW
44696	payment	2134	2134	1874	1	1	6948	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtBb9QhpegDK42BpQfxmEswyrRrN5HkiGY2HFJq5vzyDHAuGEB
44697	payment	2133	2133	1874	1	1	6461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqdmG2M2tStfg9pZBEfmi6dzS2YNbvERioAT6UAk8JTgkjLET
44698	payment	2134	2134	1874	1	1	6949	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtxJQi8wotmFVXJ5UWCNfyf8krb1VJ8y7hZxjGDsyyW1d5Y7t
44712	payment	1397	1397	1678	1	1	16655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcipdp1zjE8H5pdxeUo3fgJKQtyLitQkazkrGUtaiAFGt2rXyp
44713	payment	2134	2134	1874	1	1	6954	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VLYNMAFDQ9b5tPWgShbiue2XBY9hvSR8g71kPpTECQDM1BPM
44715	payment	1397	1397	1678	1	1	16656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qzGqBfCYWd4fuN1yitWdz3X6gmqTB2RHL4JtHWD2U1VzKtyz
44716	payment	2134	2134	1874	1	1	6955	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTc97UyCRHSSKbwfgsdunYRMfY1VxxWNz7noaWoSNvRp9dZ6fL
44717	payment	2133	2133	1874	1	1	6467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrQgdeLxLjzbtQjFjNUvcE8x4HCqKFpzFZvZNkHQxR3oWcy2e
44743	payment	1397	1397	1678	1	1	16663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJdyMesuePQuEKmYtz3x9RkqpxgJKoAmjPWQfQnhtxeQjmAyz
44744	payment	1571	1571	38	1	1	53	35825125689	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZrMmw1UujJACpfrS8e46YZw28HUnwk5AQnFGeZzMNLwAT7F8BA
44745	payment	1571	1571	969	1	1	54	272656868046	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZW9YMfH44snnJtNYZYZMLdgTB61piQHAUsyTGXRT3QziU6Bojt
44746	payment	1571	1571	1089	1	1	55	488598771417	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZgvB1LfcBR4bgMyfAtahbksuB7kgbEf9VxhRzuwjqPcUMRKPS3
44747	payment	1571	1571	1209	1	1	56	329667327093	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpZi7xR6tuUxpqgRhL3o3dVWxJhAwcnP1D9XkC8FEHWrcRg8pksN
44748	payment	1571	1571	1335	1	1	57	918647319330	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpYoEUJ1CFidHC778qDZvbMpZYC4s1nWzAWftnaQrS3tWcjpALS4
44749	payment	1571	1571	1571	1	1	58	6650188416	10000000	\N	E4YfP8envB9QugUpFTKseBWWDs5XyS8f3qtJGSoq8JvLj3iyALFzh	CkpaE2kgvYEVkW2o8DAnPBSWXgbwmfkEYYrEAubm5NMwVSJARqKrK
44750	payment	2134	2134	1874	1	1	6962	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa96QFn6RPn8RNs4DteUf47itfTAjCaDsZVxNvZvaMfVVf7r3z
44751	payment	2133	2133	1874	1	1	6474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3neRGbDmur4AgEgntxSwb7tQYwDNyrYKEFNrzVjXP1cGDpg1
44752	payment	1397	1397	1678	1	1	16664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVh1dB7fRfDF3LARR8SfnYg5QGEVtVTJKeJEWfsWah6BsBTEP
44753	payment	2134	2134	1874	1	1	6963	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uG3PTJQHiA8gLJaXyDS66JH2mPYiz4NNmSC7BtfvqD2cdLp2
44754	payment	2133	2133	1874	1	1	6475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJEWrMh6rw6aTn4ykqNCo8KngWCv6ntNrQW227mWerowMbjH4
44755	payment	1397	1397	1678	1	1	16665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbMdfCK3kojeDYS4mdTThJR3Etis8XnPdpBhLW4XpgU6hzn7ea
44756	payment	1397	1397	1678	1	1	16666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHradYfbWaQUHwTZvEm8yjH6Sm6PwHPCR3UsvtmytoPj4XtAob
44757	payment	1397	1397	1678	1	1	16667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5QGkyjPSKr4gRps1aYqJSeyfDf1q3oJKh2xotaYy46tTRjvtp
44758	payment	1397	1397	1678	1	1	16668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedazf8f7hAtH6FaAL7RR8DRzZ9XXAJjGtXwgsmUXbaZd7Y11A
44759	payment	2133	2133	1874	1	1	6476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpic29bEoMbkRN1aCP1hURAFYLSJruL64FX5tXmh6zehtMvfAY
44760	payment	2133	2133	1874	1	1	6477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLvvmnAnEfc4AHQv4wQF8yr2itHnjQW3dw1CNSuhMD58HEAT7
44761	payment	2134	2134	1874	1	1	6964	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVgX1Q58SthvhJcWMZRSmJjd7yRSZBMfxNJ5BjKtbs9PSedbNX
44762	payment	2134	2134	1874	1	1	6965	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3ZxaSd6G6eqA8L35823QRKSoqH2rUXtb5wnhEoYLLrhXDcKH
44763	payment	2133	2133	1874	1	1	6478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEip8rstHgdsZj8MvgRHdSz6ngaopqkd3qCV24BW8YKw64Ab6
44682	payment	1397	1397	1678	1	1	16646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbu4PxPgeRt7xKrvJ8LeqBHjJN3SR38VscoRuyKit5J9NUD9kc
44683	payment	2134	2134	1874	1	1	6944	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKy5SCQnarKQzJXWByjcFkAV62ZC9fksPc7XkHum7c4q44kyMU
44684	payment	2133	2133	1874	1	1	6456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoQEmmnQZMii6y2AzwDY7ihkmbqKJpqUoVqXvBGVSRc5oPCpuD
44685	payment	2133	2133	1874	1	1	6457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBg1fCgWCvsxbrGki2nDtcXQ6hUfb6XQDxsUqPYs19gUpxjX9m
44686	payment	2134	2134	1874	1	1	6945	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaACuVNkEDYgLY43LzfQBCzYhKaKuUN6pWDnSZ6vdC7J2691Rbo
44687	payment	1397	1397	1678	1	1	16647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr76QRG26RY8M944PW1zjXUigR1jjdfULiUnxnSh2xMQHYRr4u
44688	payment	1397	1397	1678	1	1	16648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbi3yadKyVNzu9eBBzd8d64hFsADPsA4AbnPKXbGENJUCvpz6
44689	payment	2134	2134	1874	1	1	6946	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjVszaFSyZFRV81UrwgZermkSXvcf46E5ABYb4EouRfKJuGBH1
44690	payment	2134	2134	1874	1	1	6947	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAhpifd2Ydsy8Ty9iw52bWJQQ8wUHxGKnncPBJr6acpTFy9HE1
44691	payment	2133	2133	1874	1	1	6458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC3bTPnTy4hkjrFnUWCPuV6AkDM4afocg99FbFFTq3pHb4yE5C
44692	payment	2133	2133	1874	1	1	6459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAMDu4bvXYSB3foDXpVNuMcgxmUZzQeNWxBZDoZ4HNigm4QTc2
44699	payment	1588	1588	2068	1	1	12	1057100000000	10000000	\N	E4YTFoiyqbRtQcmNEnoT9czG4jLFwuy6MAGp8VQiuQD9jMBAgW8vf	CkpZWHkqfS5BTWWy9bTZBVieXd38abwHAmLa81L1b1y8mj9hKxMAk
44700	payment	1397	1397	1678	1	1	16651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnAPWgiGUtMdk6kcgZhvdHybKDjA5SS7WC7xLzv5rAQEmkZwAE
44701	payment	2133	2133	1874	1	1	6462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pi9eX86TQ5Ykx2DeYDU5HgeCKc8aS5fpttQ6LRqpWXWVSwMD
44702	payment	2134	2134	1874	1	1	6950	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCM2PWV2VSp5T8Awy9Xrzbeuy9Ak59Bwf4cwbd4NauDboY4K3
44714	payment	2133	2133	1874	1	1	6466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1SQ6m1whDA7pY8AqoebLaPJf2c5MmcHFBn7SagezjPWWC7yf
44767	payment	1397	1397	1678	1	1	16669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqSRPBwb4gzF84A28oiXwxKPZ3tQG9bwooFVXJsG1xwKE4YLNu
44768	payment	2133	2133	1874	1	1	6480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9VBGwE3gMxqzxxEkykgxeBT8W5H7psA2j2MkNLi62HmFMask
44769	payment	2134	2134	1874	1	1	6968	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYuYUhJBUBEtJTffgnwXvQk8ZiLPJaHkMCaTw1eFdyrfm4qvf
44770	payment	1397	1397	1678	1	1	16670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqkkTeBhiim64D2Wq9ExB3rhhKDReDV2EEVPPjGhpZRidhHk2H
44771	payment	2133	2133	1874	1	1	6481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8CH9dpWQg8nYnC6AYemfu9t2ih2g6HVrwyGL6TpwwiAmdcwW
44772	payment	2134	2134	1874	1	1	6969	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrbz8L332T92qVdz2xtoL3qKMkj6uVcdNEnFDf6bLiFz7mcoTA
44773	payment	1397	1397	1678	1	1	16671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJ3XVzGfhHNK3ZZKEsWgoUorASifQnMmekHH6kwbyjGexgFr2
44774	payment	1397	1397	1678	1	1	16672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCLZYddHuZKkQsQbhLC4VG3VZznmZoRTueva3nJW3zsaS7EuuY
44775	payment	1397	1397	1678	1	1	16673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuwQnjASkGQFjiBSQaakSRJGFBwcgPkaN38uAvr5mjDED4ygJ
44776	payment	1397	1397	1678	1	1	16674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLMWD8HBzyzqKWQzAMwp7br156wMAPppLmGhog9nPwbVZ4xgC2
44794	payment	1397	1397	1678	1	1	16678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7grzjjxobqfommzfmruEY5c2gfySQg37yqVTw2e4j2G66EYE1
44795	payment	2134	2134	1874	1	1	6977	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMa27ry7XBovatUc1Xf12oSMC4FCys8qGf1H8tLd95igXFFR8q
44796	payment	2133	2133	1874	1	1	6489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4idvS8m1LZF5ds3EoSdmdLbtxUtpZczxCGQD8TFG9miB4Tcx
44878	payment	1397	1397	1678	1	1	16704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfmHkkP7ZsV7H8WQFfNcLkZcmMhcZc7BtScCy7WbS8UsKgsJXM
44879	payment	2133	2133	1874	1	1	6515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWc9tfpeNAQ3pHfFGRbwhwA1hQPF1ouGLsho7Tp8xjhqYg4riF
44880	payment	2134	2134	1874	1	1	7003	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkoDu1Qh6WTpxgSm5HVKxyiCZcVzyCkszC385hWwZjdwzg9WwP
44895	payment	1397	1397	1678	1	1	16709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNpv78nhWP3GRxfm1kvDdjRyZGoPDdGYE6UDqUP33T8HSmskp
44896	payment	2134	2134	1874	1	1	7008	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVkSobk5EL1EA3f1vjDAtmPkzUXvKHQzCCdUKWyYd9GoVHceJE
44897	payment	2133	2133	1874	1	1	6520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpMBrCRJoedqeiSFoHTdRgpWJMz1wb3hK6LwTQ76iZ6p7XDUVK
44915	payment	526	526	1474	1	1	2	9360000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuq7hSGM6C9SbSAc6DCX1bgvj9CyHxeSneQkMwkGWhqj74G3Y
44916	payment	1397	1397	1678	1	1	16716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZPXM6bwLB8VBGP222zmDfoJmM42LWWiQfUuNjnNXr79k1AbRV
44917	payment	1397	1397	1678	1	1	16717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgWhzBrw3uKs2ivZPJn4g3UciuYYaMYnnWq6fJQUs6YPAw1Ai
44728	payment	2133	2133	1874	1	1	6469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcSweCtjZt74Aa3NLwD9fPgJMBU2wKy2mPwwv3LUaM3XfC3edx
44729	payment	2134	2134	1874	1	1	6957	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAgtRykg7MnBLSVXwJydK8SytxeSc2wcCBL9yMJEdGCd7x9MBr
44777	payment	2134	2134	1874	1	1	6970	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDPjRKTP4cjbc2RDgoiy8WoKifNdR7Q9EcsdqJriWU4EiebuLs
44778	payment	2133	2133	1874	1	1	6482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGAVdAYh7A4u2LkdzFniNb6YhL68WEtHLjZYN9LLLaYjRFGdN
44779	payment	2133	2133	1874	1	1	6483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoHbh3mrYHhsRAT9UKf6J4QcYK6X32HgzunBh4rK3qAoMVNma
44780	payment	2133	2133	1874	1	1	6484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnnHkU5WCT3yTjQsQ4t1T5vYkgLKEuxx9SwbJRTXBCKdsoVmf
44781	payment	2133	2133	1874	1	1	6485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmhsRaqEDnKoeCG69DWMpQ2A7iWUSk4JqkTC8HqPAXMX44voK
44782	payment	2134	2134	1874	1	1	6971	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1CE9No6Mp1GXfmyJK99yZ9BhCvWSNV4RwABjgMzLMprJNQgL
44783	payment	2134	2134	1874	1	1	6972	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxr8EioiCoV1Y4vzREDJEAVDhR6N6YRXCb2c13UWe3szspxWez
44784	payment	2134	2134	1874	1	1	6973	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSB5HG7KpcFjjSV6NTzsZEPA3sT8P5CMhTv6zUqDUk3pfQUJR
44785	payment	1397	1397	1678	1	1	16675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyCipafF4wRC4pEx8ACGTbmBccFYsUNwVqwVDUwSihZiANuta
44786	payment	1397	1397	1678	1	1	16676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqeDM4F1odsDft6rngCpqFjqKzaCcUyTWyaRhoxj9GxgCPxAQN
44787	payment	1397	1397	1678	1	1	16677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZE5vKDtDWXuuQXDCZNbw1NQpvpfQTAaxgAG4a5Gfy5DKbcfvS
44788	payment	2133	2133	1874	1	1	6486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkhacBydQuiWM7ebh6sWyp2h61bZiY4Hy1gAxjFfwib3b57ivx
44789	payment	2133	2133	1874	1	1	6487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG23b2nsza1AgEmYk8Qs4nW3F7Rx7ySgrMBnVWoUeudiiCYc2n
44790	payment	2133	2133	1874	1	1	6488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLZZpx8uPg1K35HbpohX2NmVNZhwq1NhQedA71Q7CPo4451rH
44791	payment	2134	2134	1874	1	1	6974	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZojzXjGadYz4Qn2rYA7XqwQSPBngz4PcwZ8nZcGSWzm76UK6zs
44792	payment	2134	2134	1874	1	1	6975	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCQi39v47AYCEWrwBxah59LfncCH4yxG5qssK7qHUwK3VMSLQL
44793	payment	2134	2134	1874	1	1	6976	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h8jX1EUVqEn85BbWjGWLiLk6GodMAHuGneKgaza4A7KCrWdt
44803	payment	1397	1397	1678	1	1	16681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6HNGYymLSuyfTkegD18yJKorpi94MLogUPGKPbdQUFBFGUFmY
44804	payment	1397	1397	1678	1	1	16682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6Jg3A3E525zFHmfE6VqyiNdGTKrPaLKAx59hwnJDTXA8Eka2
44805	payment	2133	2133	1874	1	1	6492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFY4LuFFqby98oi2dS4ncxToQ18wE93mDrNq8ewSKhw5DXDJt
44806	payment	2133	2133	1874	1	1	6493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJgKCuVmnGEWFsmF63Pom3dV6EFvaPLsQvzuNB911PW3m5uQN
44807	payment	2134	2134	1874	1	1	6980	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpi1RvYbpYudiDCTHMvud6XWvJEWukYwx6ZodYPihmZNq5hRw
44808	payment	2134	2134	1874	1	1	6981	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEirJn9rnDLpSLBhb4RknoQtyiAroexDSkDoeMLBUmLMgpPXyY
44813	payment	1397	1397	1678	1	1	16684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQzfCf17711iZj7C8x8PHRcKX5YtFNcHoZoq1Upoex4qGSyjrW
44814	payment	1397	1397	1678	1	1	16685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAH4r3WffceYJA57xYhWY6NyCuiV2sv9mBnNs2dcdYsbRuzT2
44815	payment	2134	2134	1874	1	1	6983	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJYRPmwFEgGNs6bkPrL9GATjgZf5dVhjb4k2jfHWZaRVNp8nG
44816	payment	2134	2134	1874	1	1	6984	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirF61yVtpNwgN4wN9t6UbgzDjf21kauXgDhgLEWaNuDhVup7Q
44817	payment	2133	2133	1874	1	1	6495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmR9SfHtXr54CYypaw7sde19swFnS4rtuaVHfC1afqtbSnJeMK
44818	payment	2133	2133	1874	1	1	6496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HMSrm5Dx4YgZzWTJNtcbqRXpcT2eJo654ADRxAC5KuYMZEft
44840	payment	1397	1397	1678	1	1	16693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6spP9JzcPWmzmy8HeBLhmDttoVoywDafGRYuDPkMATNY7WcGQ
44841	delegation	553	553	1474	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ4mXEgAdrSgDD8ioC6fnGQ8SjufSbEPnvtbwXDEKfAFzUUVo2
44842	payment	2134	2134	1874	1	1	6992	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxMUVLvVR4fuZrBaitLF1o2QXHTvgzuFq9Z5SCYF5m51KPwRx
44843	payment	2133	2133	1874	1	1	6504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVqUM9dt4KVXkxyARufGvYU6oydaEEfjZgh6L4hKW3jQNqe1a
44850	payment	1397	1397	1678	1	1	16696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKSJT9u1pTSmsEbpxoLmUBGF46LNWn61e27QTftPUZGeKTpCJ
44851	payment	1397	1397	1678	1	1	16697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiBH8iQ4Vqs1kEZjDqXkZpBBTUbY59JXQP2NVm8Xb2iKBNXL73
44852	payment	2133	2133	1874	1	1	6507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxqHuNKr8yWFKZiBmpbqcHSGFc4be8vDE3xpbRgt5QyrKEXLp
44742	payment	2134	2134	1874	1	1	6961	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdKtPHvLToU29Kgxk4aGWH7dLVnkjdqJwA1YRqLMtZZStLZ9P3
44809	payment	1397	1397	1678	1	1	16683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUtJVLR3tc7EYbJoWjxTUaXirXSsttgYFED5ZqCnfHu9CCHhEF
44810	payment	2134	2134	1874	1	1	6982	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQpHjPvQ8fa5cmd2Sg6pvZACjM9qdhSLSnutrYy92x9zS84QXn
44811	delegation	321	321	1635	1	1	1	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjsNU3LvuL6fxuzDUTm8McGkDgHpYTFdq4rDwmDoUfA5SkxL6
44812	payment	2133	2133	1874	1	1	6494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFMNZHsmonVJMzAc4m8TknX9NHiPpmgAGJK4Ax7EbqdN2Bc8Pb
44819	payment	1397	1397	1678	1	1	16686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZctP83aiz6aob4YqqZcswjusjQURTqAHJ5GESYVVLZ4V5k1vBk
44820	payment	2133	2133	1874	1	1	6497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEcBfdqucPLo162ZZZg7fZxfGij9fRW84jKDLMxcxhri8uUPP
44821	payment	2134	2134	1874	1	1	6985	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzMkMwmiQAbenL5HTyupNA4wEr2iDx8LUTbmfV5e5zmnagqb6
44856	delegation	497	497	1474	1	1	5	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYH3HaQEgRJpXjEg9DbDSpPkrD7kzrgJ9zrk7YejQGknrvhmm
44857	delegation	657	657	1474	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWN8u4k7S9JvWu1EiUtqBLvEsKf92chah4RgYkeR3Ab2ABcuVm
44858	payment	1397	1397	1678	1	1	16698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwo43TWXPDWAr8suhVVheM1NfimrEuG2Ri1V7kGGp26AWPyTR
44859	payment	1397	1397	1678	1	1	16699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkkMCibRbLvd1JHeHKKVHqWZuPnNkRp6xQBAw3xihGcqaTeMSU
44860	payment	238	238	2314	1	1	6	179000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MssJi5SG1A7AsTG9ZRBEnoToAoGMbh1DvX18r7qq5XKmFkwV
44861	delegation	590	590	1474	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6GGP4DGxH8WZv9cr92S3LcK5ZpppKBPrnL3KoWJXCaXd2m8X
44862	payment	2133	2133	1874	1	1	6509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2V6sbQZun5bWHsN5V5s5DY7JQEogENUsF52dynAoQ3ngb7DUS
44863	payment	2133	2133	1874	1	1	6510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDYAaD3Sbnd4WC4gaXZBdvBHLJ5AzBcNfyLpV7Wbyg9GVPgDTR
44864	payment	2134	2134	1874	1	1	6997	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHPNrbzByGTJ93DjpywaCu8svDyY4dXUu2R2Q2ve1smcPC2QP
44865	payment	2134	2134	1874	1	1	6998	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHoQjwzpfZSYyR4KQ3pj8KXHxxVg9VcAuksTRgMYwboSUuWhMx
44884	payment	1397	1397	1678	1	1	16706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Hd5G8xQWYud7tC97DccUun62SXLQseGzwSEZGzG5Ub8KB7rH
44885	payment	1397	1397	1678	1	1	16707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEtKNstzSLEPqL3VGaY2RtsH81tUm3XngoQzBSagVUyTfsWuPR
44886	delegation	2305	2305	1460	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ85WKNzmZu7r8QabU2YqhKxYxjox8EtRfpjaELqrAW9h38bmmU
44887	payment	2133	2133	1874	1	1	6517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3iBSCb4126vr8wb74McTDsi7zDG5e8tMJvE9DHBTia1z4doW
44888	payment	2133	2133	1874	1	1	6518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRp2JmgM4YmWJ2UfJT6YfSEsUx94rUhmASZEbuGYoAB5yYdJbt
44889	payment	2131	2131	2172	1	1	8	1000	1000000	\N	E4YcxyxYw86Wz5LxMNat2eXx3UewVVm1RoKBENJv42wdt3nXH2YLT	Ckpa1Timhtpv9UoMDFkVzEg5bTmQ8Zw2LQZoAqsrfhE5wUZysGebw
44890	payment	2134	2134	1874	1	1	7005	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLLgip5wJsHzskr7PBDCbYNcv5CUaCVRUdj43numgUFXbQ4JSP
44891	payment	2134	2134	1874	1	1	7006	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxWfgZLLtpojQv7rDTRsyPEPJHcNhchbTfMVzcxg5QxFaJUvP
44892	payment	1397	1397	1678	1	1	16708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYidQHXXy33SndBGbjnbEoJQQ4aoF4SSEr9euapkC3ZsVS1D1V6
44893	payment	2134	2134	1874	1	1	7007	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYknKebudYmsEtFfH96HHt2cptTuEYnQGhPW44NUREX75eLyLJT
44894	payment	2133	2133	1874	1	1	6519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeGjZNGhY68YpzxTgUNaCVr1wwercJ4YVmGW7PVgtZfESqwkc
44901	payment	1397	1397	1678	1	1	16711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzAikrnbkaLrERjPipQ2PDmBWyVCQHVF4XEVCvZaycyrdS5Bv
44902	payment	2134	2134	1874	1	1	7010	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3vmpekiW8cJyjLKWjT6ayKCvaANW49NHE9QXAeKz6RfAoB1BQ
44903	payment	2133	2133	1874	1	1	6522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGr2yMdAQsD4tJg1pK2qjryEvdQS3cHHoTuXqyRykw5p1UBf6m
44912	payment	1397	1397	1678	1	1	16715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqEUKCtCLBwCJWotkFsWFoCUV3nij51UW1kdBMnYqopbyuLEz
44913	payment	2133	2133	1874	1	1	6526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLb8ipS1EeLrxfj8Ce8RZKCqximNgxN7jKZiggB9d3uVq3NPW
44914	payment	2134	2134	1874	1	1	7013	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcwsX9ZKq8j3bQ8Rkb2GoHStT4DCjwHhCvPm2gvbEha1UYgGt1
44922	payment	1397	1397	1678	1	1	16718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfnJyXjhqbtuezX1aCM4i2NENZTWPRwWU5kwLuLwjYtRwM8TtE
44923	payment	1397	1397	1678	1	1	16719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2MviEwiaaMtJdPhDeohVSbZux5ayvy3HjFbRDMRJ1g5YEDh5
44924	payment	2134	2134	1874	1	1	7016	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Ef7LqVjEpKDxY86rknT8wmx3CRnAGdfeuEmiu4dzR3ddituF
44764	payment	2133	2133	1874	1	1	6479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WR4uj7GjHsuJCRYgaRVtZBoiJRwP8wB2UYAyAXcyQhFHZvkd
44765	payment	2134	2134	1874	1	1	6966	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGT6k6Sb8mRdj5Qx5RafLTsCQPa2UWWEoozpc3bq8TpH3YM5mj
44766	payment	2134	2134	1874	1	1	6967	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhhVJMFEmXfEkpc6SEDtFRD5nvNqaQuwVpHXvu7m3V51beJbL
44797	payment	1397	1397	1678	1	1	16679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhm9evZ4LMaFjTXweodwp4JLQ3v4rkemdJJa1rMdtKm6rGP5d9
44798	payment	2134	2134	1874	1	1	6978	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgkUJf6iKzjQFWASNgBenUCL3mKbzFNHxwdnPiBZfZrkhfsrXS
44799	payment	2133	2133	1874	1	1	6490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxao5zshM5x8DsqF2L9nrPDEkWL3AnGUT4dd35nNXPMrwmCYwR
44800	payment	1397	1397	1678	1	1	16680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcNYoQWusQXkV7u1z6cars5GULg9awHF2NjziXoVvJCG3redoA
44801	payment	2133	2133	1874	1	1	6491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpFrGsg8tfp7vFCzJ2GbLSYeTY9TexpZjb1zUgYbMVVjKLeDuY
44802	payment	2134	2134	1874	1	1	6979	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqfjFTKF9eK9eJCPEMVtCcWDgpqDj3cRKeLvtCpfAxWKitwVnp
44822	payment	1397	1397	1678	1	1	16687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6hvVc5N7x1uSUEiCfVobhdyRWQTrMgZgqecfaYJQH8FDP1As
44823	payment	2134	2134	1874	1	1	6986	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU1rro2LNDRHEMDqKNzao4J3fdJ6CuBdnBD61PUgX6XCCQr63V
44824	payment	2133	2133	1874	1	1	6498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNNDuk9AJgCQq1etuAZ1aGknhxYVpsd3gHnFbkrPN2h9SP4Qy
44825	payment	1397	1397	1678	1	1	16688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwj8iFfNQ3e7oAUgmFs2XQMqLkEhyib14PXjvfsWUuvWJk1F9
44826	payment	2134	2134	1874	1	1	6987	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmMzwAXMnts4tDFyn2X6CfdQwbyqGgSbccvCyhCHBiPxHmnkJi
44827	payment	2133	2133	1874	1	1	6499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8curN6LWbYVLh5vacVFYCa2i6jx1Hn6AGDCGmyBuxQTgTQmZy
44828	payment	1397	1397	1678	1	1	16689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEh1YKEyDfLznCnzo2R54X5keTEHNyP29A4syfhyPFg7gPuBuY
44829	payment	1397	1397	1678	1	1	16690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRbQ4rqfDg7SRRZxMD5195xcUgBXyifZuNrupPmuLmdY6DGk6
44830	payment	1397	1397	1678	1	1	16691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpVkY9rVU7h1NMNwjRvZLgWBPZRR2h5YzaWAKVx8B7fJUy9Rxw
44831	payment	1397	1397	1678	1	1	16692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6MTjn5BL8NjAkaedh29gSsWqFdTbbTkob8LFGuQp7ioVWmkD
44832	payment	2133	2133	1874	1	1	6500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4VoYVgibDTZgaZv5iFpXdwFsHf6gXWL1YEiietcDqtgzWuZpt
44833	payment	2134	2134	1874	1	1	6988	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcY7TvAX7ops4VrDjRcGgjjx1bo5ieUPjV42hdvA9Ng1VCmDB
44834	payment	2134	2134	1874	1	1	6989	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrCEtwvwZmY1Bzs4tp2aLK65jZrbXWMMK3H6vJKd9Dz4d8ZwAG
44835	payment	2134	2134	1874	1	1	6990	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrMSFLf46DM12jwdvi3QVAZMFYmKn3MvF12r3gAkfgDZkoKoCP
44836	payment	2134	2134	1874	1	1	6991	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtkK8xzoB7qxk39SYK2FsDdD8CupGcqS4NAZy4zFmGLGwhapYf
44837	payment	2133	2133	1874	1	1	6501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHRpACgynLVeePLqmB4PxVFPvF1jKDLWWvxjXoaKADCFEDjx1M
44838	payment	2133	2133	1874	1	1	6502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCa7Y3KyngAKq9zJUbj7bMY585SdFtpz5fSdYznaHo36wzYkk8
44839	payment	2133	2133	1874	1	1	6503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLFVVhNWfo96qnZ5ZtXrF4E32pBA2J3djrqyay9rNM49zKfdPR
44844	payment	1397	1397	1678	1	1	16694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCyzQmMirEmHThfJYtb5HpSft2YNf5pbxgVfAtqHnGZyxCE5Ze
44845	payment	1397	1397	1678	1	1	16695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmVhNe6By8aMSri2a1CSpwY5MiZxogG8Wxp7PVHF7TyqHkFVn
44846	payment	2133	2133	1874	1	1	6505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvq2kyZLmezbmhM8gSy18gDRJZ5FmHW4PrLubWqghQtsMAxB3Q
44847	payment	2133	2133	1874	1	1	6506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtzsP86YJEHfxb5vthKDiKHNjxK29LHdXQRoTT14oqLGHuT5W
44848	payment	2134	2134	1874	1	1	6993	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERGtQiH1R3Fdk2T3MiD4dr1QaGpAUBpmdXTth7B6CegvxWNPT
44849	payment	2134	2134	1874	1	1	6994	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjM83euPLLPSgzd2ipnTS8uMPvWfYkrAm1sALBxb9EYVbVrVwA
44866	payment	1397	1397	1678	1	1	16700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpihpUZPzXLdGbbCHq6b8SJ9a5AuHFPQ7wW4RUoiLYoaz7qwTj
44867	payment	2133	2133	1874	1	1	6511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67MAo24Gu5c6CjqnwscLfc4Ce34rHZ1cE6r2Q5FZ9FdwnUEVh
44868	payment	2134	2134	1874	1	1	6999	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XgcBuii7Ejq8bXiyB7M9uabab2n5W3nsoLx9AKboDkVVugNi
44875	payment	1397	1397	1678	1	1	16703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCUGZvzxFvMunF7oMYeWSFYuGc1Db9tPX9FRguqWCjjZXtNng
44876	payment	2133	2133	1874	1	1	6514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVVDqpvh1XAH3MbuucTK2u8mPfD6NJpewHA8NW2McsZrpbSpS9
44853	payment	2133	2133	1874	1	1	6508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKQkzVuPKR9KgfBk9byb6S13jzdsSsY8DuugDn6edmuQH2C95
44854	payment	2134	2134	1874	1	1	6995	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKtY7PiSehhz6YXFG3EcumGNo7JigXacotoKa2vk3tqmndxBvr
44855	payment	2134	2134	1874	1	1	6996	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbzFBDBFXQrWYwq8QsKmiVSWbUmJQXxNJU365LKUtX11WK5EA
44869	payment	1397	1397	1678	1	1	16701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxmUGZ7PUqiEKuQcX7qKGDiHW3zAxoZGTse7YEZ3da9RjWTBU
44870	payment	2133	2133	1874	1	1	6512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfKoAFDa1Kn6Y929rYyTpEhNQq2y8GRs1RWBe89R3S7cj9MokH
44871	payment	2134	2134	1874	1	1	7000	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vhqTEwzmRtuY9cTQugcCyCpth75U2tDGMPJxNMXTnmBrh63E
44872	payment	1397	1397	1678	1	1	16702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcDLJRACaeWtz1RGXfD4Qwg6BbF3wkFhHKAuoiNSzw1G3QbQq
44873	payment	2134	2134	1874	1	1	7001	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCVar7yxMJxDqKm25HYAqvitW7k6TFN1zNEEGkNFFBK92SLE8
44874	payment	2133	2133	1874	1	1	6513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAZPqjhnQYwL8CBqkfoCuvjzbBuEeo6pdsPr767E7U64enZQu
44881	payment	1397	1397	1678	1	1	16705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7bVM8ZoZYz9c16HXh3go3PSuHMfP628SvvHFTkjoG2LE7BFY
44882	payment	2133	2133	1874	1	1	6516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9vs6tr9kgJLqu5J2m4wyLJsTdrerZ7Wytbqwi2rG37PtBn8W
44883	payment	2134	2134	1874	1	1	7004	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Q24rwYdNQZWNDAv9vJ6s5sDCE87NJiFoVBqimQ6XCZkobVko
44898	payment	1397	1397	1678	1	1	16710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtToDWFReaEySCJybw4D4Ut8bfStZXRiPqoj8pgqkZYTwWbJsP
44899	payment	2134	2134	1874	1	1	7009	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ229hiHgxDDfn3znnZYnGLukYBSsExH4edP6eQTgQBdHq85Fjc
44900	payment	2133	2133	1874	1	1	6521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRU3w6gyzAYYmQaTGSQvjEBeZLLwj43kGPmsUNRW8jNTdUekg
44907	payment	1397	1397	1678	1	1	16713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGGBMjhKa3YzQJyScBacCHCpwWR2iYxnnFH8KqRWFHVbY6mPu
44908	payment	2133	2133	1874	1	1	6524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAg8za2gsQF7Vd83MyyHmWPePLqpjRxe39T6uBWcUZ2UScGh4k
44909	payment	1397	1397	1678	1	1	16714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8ViUe3bkxWrYaCFnk6jpoB5FxqQA9wWqZu35uZu5wYBbXcPp
44910	payment	2133	2133	1874	1	1	6525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBnTTWLin1AwPhS82sLAnAc9X3YekPtJ5nYptKVzXHWR7T9aV
44911	payment	2134	2134	1874	1	1	7012	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGX5M3DxGesHKMjvNQUsCCbiKuaX1qCgzbBM4NVbLgamSdC2gn
44931	payment	1397	1397	1678	1	1	16721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDAK1qguUUNAcag1dFHrmHRJHC7T91n86hytq6eqkNhy4zBKiF
44932	payment	2133	2133	1874	1	1	6532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYpRBDiJBKfSXRet8LLK8tnfD4W3dQ5w1N9EYtMpJBsRx2Rn88
44933	payment	2134	2134	1874	1	1	7019	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNjY5b2BdE4WnmRDcivHpuihy7jdpHf4r3FTBPA3YZZUBwJ2m
44944	payment	1397	1397	1678	1	1	16727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXhEmm4VMsb2tbj2TXYAYkpdF94GwSSYnVc2aQopLJN3i2FPJ
44945	payment	1397	1397	1678	1	1	16728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnQn9EHHepwm9GE4P5UFDp4rVjQLLZLADB2R2ynwxGW7SPcWx
44946	payment	1397	1397	1678	1	1	16729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdNHFED5DPYgUjFMinHKwyNazytXQMBFZnNF8HRTAexDj9W5tP
44947	payment	1397	1397	1678	1	1	16730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWq21aJHDchzcD6Kv8KEr9bJcXMkX9Mc8qLksYq8FaNiADeKz8
44948	payment	2133	2133	1874	1	1	6538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNgEwwgjnAWBtkrR9NeeffSYRUEVFzb4de2eJ59qzSfTtt9Bi
44949	payment	2133	2133	1874	1	1	6539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qg5b7nkSotWeufAy13Ztoa93cqnF9oxpcFxw2ha4Trp5uK78
44950	payment	2133	2133	1874	1	1	6540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMHuqEnTjSeCiQXGg6cSj8JBbLJeLwQ5HcHqJwBS1rWh2epwx8
44951	payment	2133	2133	1874	1	1	6541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnaBte3n84P5XWLAFbeEtHJedTzzDAxjSVeCVA3NQ8iPc2Zvw4
44952	payment	1397	1397	1678	1	1	16731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWgPMKhfBwnadkproRRcj2EcRoFVAjt5QaeN6z3ZCdjc4uMeNE
44953	payment	1397	1397	1678	1	1	16732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgto15JNvPxfVZ1xgMzCEBUxYrEoj5vYZtx89qGuMMdXc1dk4
44954	payment	114	114	2314	1	1	12	69000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvyp4v586yBrdAhUWKNED4tPKHieh53FMzzCZQoEmDiU4aC2ez
44955	payment	301	301	2314	1	1	3	69000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMY7uvpCnSPLdiWpxaiM29fGaFRFugZoxQXjAddtzB3NoXH419
44956	payment	1397	1397	1678	1	1	16733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX61f7v5ieSBU58fBMuVKyQVPUsMkuftiXsMppDAsvw4kdEr7R
44957	payment	283	283	2314	1	1	2	69000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmMxMxk6QkjEmKkJdyz2cZiq9Ay1BTXdzXMTZg4aN2EFJhmXij
44958	payment	10	10	2314	1	1	2	32000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qug19TD1EdvGed4MWsXvQJrSTvCRV7tjYrqjYPyQRfsZZeRV
44877	payment	2134	2134	1874	1	1	7002	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs7kMqSisFohAjoCBeFcbek61sixtoBA2sbwTRg3YCwM77VQ8V
44904	payment	1397	1397	1678	1	1	16712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCE9MBmjeQD9acoqsuWNSoJGuLytt9BaVcKDoyrW4DNvrxCPq
44905	payment	2133	2133	1874	1	1	6523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC35WBYZgKHyKvgA2khzNREH6TuFzc8fxHqPzV4M5jrQBtkJ5b
44906	payment	2134	2134	1874	1	1	7011	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZurYrz2peB6jQpwYzRP8QcT8Cgswtwg1MjdP5MNQ6e2DBzRWca
44918	payment	2133	2133	1874	1	1	6527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvkJjSjprK36AN5z5Con7QjktiW2N2modgFbG17ZusdchD58e4
44919	payment	2133	2133	1874	1	1	6528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFrYdTr9dtPsuUmJy5j3Jjjzzp7GHw3wbiiBXbXxkDUEhNecy
44920	payment	2134	2134	1874	1	1	7014	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ufnUxS4BychwHrCWKCFCZ928aPKWFKUFXUV6mTnxiRvi7veH
44921	payment	2134	2134	1874	1	1	7015	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQtjUDGNB7RdTV6NppqsSEwafB4UfgXmQk1Mqqqz7QemfCADp9
44934	payment	1397	1397	1678	1	1	16722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJNBacX1kUEdwkVbZqGAdcPQb24W5cBCxhm8GSKUVf7ygQSMmT
44935	payment	2133	2133	1874	1	1	6533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPZw5qxx6SaQYoDPR3rcDZy7VkBkxFKmLDjfX3C19d9i9nRZN
44938	payment	1397	1397	1678	1	1	16724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTS6w7CSA94X62g4jiUy3ruJWDWAfPaSfa8EAYDSABYvnKvf6
44939	payment	1397	1397	1678	1	1	16725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiDiAPCFqG3CfWEXJH99igZNj55ZPjEyuBjjpBBNgPhQdQ6Jc
44940	payment	1397	1397	1678	1	1	16726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ3APZffV3ZGZiUP1HC7SBosC7c7rn351KM2CyGzqTW2jvGGuK
44941	payment	2133	2133	1874	1	1	6535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmxRuYqaAB1MRFGtNTFozDjWHXcJEibD5B2rMPAmtiqmj8vGS
44942	payment	2133	2133	1874	1	1	6536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9co9Gi9Qpz2aEgTAG2TxxU42GkF9HCi2dow5z6kpxJdXq97y
44943	payment	2133	2133	1874	1	1	6537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCScsbsbiZbxgBE768ndiCyBXqd7vRrE6nDciV8AFWZt9XiQ93
44966	payment	1397	1397	1678	1	1	16736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAXKiTDvxxGPYipryoyyjkACgdKoEZ4zB8iQuCgpJ2bF7Rg7N1
44967	payment	1397	1397	1678	1	1	16737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgW6M8jpPCaC4cLfor2imUtzXc7eL3arh1KSRvK579Dx3xhMv
44968	payment	1397	1397	1678	1	1	16738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLKguhvZS7VL9hyekTy8oh8X9BbY35K7qpupCos1TCPpFdEmKS
44969	payment	2133	2133	1874	1	1	6547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTscP2dp4kBtN7Z9ngvADB7dJZ6WvfspNGymnRw4rGQNn7tQU
44970	payment	2133	2133	1874	1	1	6548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqihz6RkWXHEcM2LbedRgPorvCxE1w5DrjYbaiMazz9EVwsw5
44971	payment	2133	2133	1874	1	1	6549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9RCWyzezC3iGKE9qrduJ2DMcLKtqnBu37Zub2yiyrRcqcbvFe
44925	payment	2133	2133	1874	1	1	6529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dkish9zLSpuBz8CwEgDoibYt2SnJAU96iTPicwpTQTDnUGNT
44926	payment	2133	2133	1874	1	1	6530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7XisWmuiEbeC7xvpEfTRnDdHLQNU74JYCF87WYh2Ys4Djtk5
44927	payment	2134	2134	1874	1	1	7017	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MCTmEF7iVrWiZey4qBiqorsCmDoDGq3YVhBzAYWLHgUTzLHi
44928	payment	1397	1397	1678	1	1	16720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuvoDeSqY324Lk6HWJXMjBEm25SHixwrKCzuFWGG5k6NbFZwF
44929	payment	2134	2134	1874	1	1	7018	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXG1hBZVQ28pi9wJ14b9jzJFxPy8VLMmjfJUoTbC4itPCs1aPX
44930	payment	2133	2133	1874	1	1	6531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYro7s8SHjXSui3Zfrh1Kx6SCy8dZ4zhUoKKGToLiiF47AxYf58
44936	payment	1397	1397	1678	1	1	16723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApEZhCV3thmShu8BJM8TNMYZ6PsrNaPd8KZk4atyW8UZEqDNU
44937	payment	2133	2133	1874	1	1	6534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbvaQozR6911WFtFpottHcMFZS2sVN4TXViY68o1T3r5aYixu
44962	payment	1397	1397	1678	1	1	16734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JKamtbzg9vrHNCPU8puH3ePF7amrKF7Es9LLitw5CVa3NaQX
44963	payment	1397	1397	1678	1	1	16735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFQFMTkQHBryf85Vtm7Xc4gsE7SBy9ZcES321Danw1YmBi3oX
44964	payment	2133	2133	1874	1	1	6545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxyV755xjnetFJeBCuN523qgLvSRALUfHMtHuWoCQyDJVn3xKq
44965	payment	2133	2133	1874	1	1	6546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ13ww6EX4X1GLz3Fy15cLFFv4WW8krV9577PHwV8GRePtJZNQ8
44959	payment	2133	2133	1874	1	1	6542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHdMzHz5vr6cxLnzcv1MjBpGnsfjGMjZeSucvag3bK8ac6psvN
44960	payment	2133	2133	1874	1	1	6543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUc86Rc11DbEByDUgV5YPxuJHXLk1w2tbRbCWH28jt1SvUb3o
44961	payment	2133	2133	1874	1	1	6544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJivaQs7YVdXx4UZH5DtihteVgrnKVUgUgGyukdNDiFkBr6Sp
44972	payment	1397	1397	1678	1	1	16739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JeGnAon5tdaDwc9kgKUHjgPpyDpYGfBKTwqrxnjcMThNVE2f
44973	payment	2133	2133	1874	1	1	6550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4tZLYsmQXnHniLXdJMbi82foxFy3muyuhpTDHfvRqsGUTYrJ
44974	payment	1397	1397	1678	1	1	16740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJPApBZ85ruvf1bWSoGHF3eXAefRU6NJV6ws51bc7NvBZ978eu
44975	payment	1397	1397	1678	1	1	16741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYbTL6PfF1Efo1n8wUapfrueTidJC5hjqb3E73qzVZEonYwTL
44976	payment	2133	2133	1874	1	1	6551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY555BYiM5R2mtoh28UpdWVYv6NSGiHw1DwXgtK3TUE91h1Y2p
44977	payment	2133	2133	1874	1	1	6552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7eUFtpCdirnSZ458jSRuuo7LgLgQ7d7iHc3Tt9Z7ayFRK1Pg
44978	payment	1397	1397	1678	1	1	16742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7uYEktvfEWMfYDVjMz6j8KaH8RyknkjPyak8fAXfu5MpcVwqm
44979	payment	2133	2133	1874	1	1	6553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGojjWRRCRgYmThUtXU2DzyVLQ7x3kYT2QE9XkBcXrgmHsjz2
44980	payment	1397	1397	1678	1	1	16743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7UEa16ny5pxpwQ1VsetysV4th3JdDUzKDoC1X1pxccjGCTvKX
44981	payment	2133	2133	1874	1	1	6554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2se9VhGy3gRKG7obDLdWi8Bgk8nykNTsDPJEpLNwm9D52eWFS
44982	payment	1397	1397	1678	1	1	16744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAuTqKSfaAmfjA1bX3VaktU4tb2gEtWVZq5dENxE45jqdYX8P
44983	payment	2133	2133	1874	1	1	6555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38Bt9ay9GpFLAraaBneHz3jdVoEJjGJXxHbefnZSaruMVRdgy
44984	payment	1397	1397	1678	1	1	16745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxY9TgavCu4oxK8NygF5MXHWHve2pYuUqrZu5qddUQddDgn58H
44985	payment	2314	2314	1950	1	1	4	418000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmL4N6Yd2kFFyRZt9nfWspyb3NnJgyPBMgUFLsEp4oQrhEqXi
44986	payment	2133	2133	1874	1	1	6556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFViP9YJmNZczjDvaV6ARMYQRWmoyTMoRmemqFzKoSTnhyW9m
44987	payment	1397	1397	1678	1	1	16746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbopVa7hPUoBwYs5YUJ4svA9TpnCc2ekEZ4utsDAvdKu3jkyNN
44988	payment	1397	1397	1678	1	1	16747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4Gox248ZKbyWtK96YiCiQsDmiL2qQkghVkBiHPK527PT1RWN
44989	payment	2133	2133	1874	1	1	6557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHLYVvmNafPM8tWJmuyFgTB5KWo8cBPy3F4tMzNj15dJLvxWgz
44990	payment	2133	2133	1874	1	1	6558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxSDPu9FuN4mnaUh2fMUTq5YdupdEQWhenmdMPVzB8kEGSm9t3
44991	payment	1397	1397	1678	1	1	16748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjMsYDV8SpZySHaZYWpwLBuWeZBy2Cc9qTxT8Rfpo3zcX6L7z
44992	payment	2133	2133	1874	1	1	6559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6MBYK2Krk3s42ocRNg5B4XBnuuwi9xr83CKV8M4YY3xcisLG7
44993	payment	1397	1397	1678	1	1	16749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ79mo1CWeV5jbcviEohakcKY5A2b2bfDp72TJHZroRaq2uhXG1
44994	payment	2133	2133	1874	1	1	6560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVJRxMVkyZ1QyBvvwV9RDrgCy5puvvfQZ2z2gmvTScyobvLtDm
44995	payment	1397	1397	1678	1	1	16750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBxeGLB9Ebxzi5MnvSY2TTd3JdiQ7ZsDPefn4ZWV6U3uq6CwY
44996	payment	1397	1397	1678	1	1	16751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQexmdrjuLo1WbzpcbiUvrYhmxFXRFymjEWooi8FmJ9KnSqQEG
44997	payment	1397	1397	1678	1	1	16752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoomdgdvwzYCs1inhoydwQv7pRj9uMVsEggq4bj8xMzXAKZMjv
44998	payment	2133	2133	1874	1	1	6561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rXZqkAYCvQzN2EQZCBBBEJke7MEFufKdtciTYiWhZRVonApT
44999	payment	2133	2133	1874	1	1	6562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYWiRQSG2W2LfDfEhsX3NZMZid7o1iaJEnPAuNxFRGma7yTLDE
45000	payment	2133	2133	1874	1	1	6563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4fz5dwef7hnpyLSHk54xRSMfYdVbaxZfvR2PyR6MrzFVAnmJt
45001	payment	1397	1397	1678	1	1	16753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSaYnsT4qg67x7uW3kmpE9toWjrLcnXH3oRh3YAeSjmXVGGNH
45002	payment	2133	2133	1874	1	1	6564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATZsVStedmjcsM9a3MmMoqfHQNt2mGBGFFVfSqr2aEYZurxbc
45003	payment	1397	1397	1678	1	1	16754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccQAgjnbRCRYpgpxp7QuvU1C9LNNgV3Zf963bGLsnhisVXRRc
45004	payment	2133	2133	1874	1	1	6565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSdPRyMtDM6LDxHQhtzpuYp8wTFw3DkXKsvyFZEe3Nwohy9yb
45005	payment	1397	1397	1678	1	1	16755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgG6TByqLj9cWrj2W7SdY5MD7f2juJdejzS2g4mbsNgLDfEJq7
45006	payment	2133	2133	1874	1	1	6566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLCNvBHRS5McJFrAkceQKXWsLpCcyzWh2AiKRDwx5zEAWR2K9
45007	payment	1397	1397	1678	1	1	16756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKtS9xDDbVvSD9KPHBzjTbfrRfaJWwoMUg9NR8X7oC1TS8ykjB
45008	payment	1397	1397	1678	1	1	16757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqrwE5ooL9aGYeEDzuNnVT5YEWDAtm3v2KqG5DRccyeeaZnxDB
45009	payment	1397	1397	1678	1	1	16758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1FyPLYkwPMzX66DNn3fzt2fPrW4nm5a4qEvdq9sWtTYZLFhj
45010	payment	1397	1397	1678	1	1	16759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67FvVizefPWL9a1YB6W9Yiwf2e9wvYFRbKx2FG2B9Y1n9Lgmp
45011	payment	1397	1397	1678	1	1	16760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDB8UPgu1W3FfiErs7gNuJtt4TV7eDpksde6RzifwnTdGuVEWp
45012	payment	1397	1397	1678	1	1	16761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR62eoBk1AW5Z9JScwfsoKQCCGLiRrQeogSYQ5knvEADFpNQ4A
45013	payment	1397	1397	1678	1	1	16762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGWzmwfx9VSAfA1ySE2EqmsWpkoCdK8vRSgxX9GggnwF44ZGN
45014	payment	2133	2133	1874	1	1	6567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGxYcWt8FBYvoWYByNiRnyUem2FbXTAuVVWiPy7GFuA3Xyd5M
45015	payment	2133	2133	1874	1	1	6568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEfJKcGLTJ38ddQeiXk6w5y4cU75sPKpDA2DuPFoK4X2VxkMb
45016	payment	2133	2133	1874	1	1	6569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzaWakmNwVaLSAFuDdwDYeMY3oHpAdjTApJBcNXBvY1fzWbF4t
45017	payment	2133	2133	1874	1	1	6570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGXLUQZuNYU9UYrV4o63yKPsEMqf52ywD2YNnGcrcxgYUUyvo
45018	payment	2133	2133	1874	1	1	6571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3tjDc75B53ghEwufQfR72dGQ76WbJ4ps243qTPqFJSZTHuyJ
45019	payment	2133	2133	1874	1	1	6572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEggA7k5cmv97ZGGcjdrvV5hY1SmwUjkgz1XvE5QfpHCG8aRS
45020	payment	2133	2133	1874	1	1	6573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEy3TqwzWgYnDEFMnSmM8JMTaQa9KvPG36qGQTrkK8zeHgj1Ee
45023	payment	1397	1397	1678	1	1	16764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxefN62FXcqjLNVuC36mKYZd1gjEHYUNRuVvsRJ6oJuN7LFwyP
45024	payment	1397	1397	1678	1	1	16765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA4yJr8fawijpJj3qbEELJW5eVUrW2SLhA2dFRRbQsECwmjDCL
45025	payment	2133	2133	1874	1	1	6575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqvdrvqj9gkSStaUFdT1KoH4TxhaHuq2EaEbGREz2GjCieLhcQ
45026	payment	2133	2133	1874	1	1	6576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hcSMVFMbBNjGhaFuTebAXKeRz6221RHQR3XcNmPehmHpJ3iB
45027	payment	1397	1397	1678	1	1	16766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjnD8JpAKuMZMDbkZnoTB7Cm77DikJyDHDZkgG8G6pDiCVXyHk
45028	payment	2133	2133	1874	1	1	6577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiY7vuXv5QT2ee9kLXxEtXBkTX9Vsrw87zErwnNSfUz9zkx7bP
45035	payment	1397	1397	1678	1	1	16770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBu8nRp3CndnFZ9ryvk1H7X3sFBnrqAur8G173UyneQDzhYoLo
45036	payment	2133	2133	1874	1	1	6581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMpo9NkVcNMvpd4FSopPGUFNsYRNTdrAbiciWp7CdCJmQdr1q
45021	payment	1397	1397	1678	1	1	16763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJohp9aDdtanws4mmkWmakPFP8Zj6ybWjMVxj5K4szP8RLLas
45022	payment	2133	2133	1874	1	1	6574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmuffYCJch8fYXrz94ZFWtWrFUwJ2W9n2XnXA1TGLmr4ovTis
45029	payment	1397	1397	1678	1	1	16767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwFiHqWMR5NxqjsjnJpwKRRBE7ZHjDTgvsESsssXZ7seyAfpGA
45030	payment	2133	2133	1874	1	1	6578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTsYps1Lft5VEY5NDGNQqa4yeTka8SULVZ3YqEWoFKnWJzaXV
45031	payment	1397	1397	1678	1	1	16768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamDb1PmmkVLbCzq2Re8vNi7t5huZVUvfWGvWtxhyYDt6yoib2
45032	payment	2133	2133	1874	1	1	6579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYUnW64Ps4w5c7FXfPMs451WqU9EKVGn4muSLD9WxbH3ckXB3
45033	payment	1397	1397	1678	1	1	16769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3tNqAmdA56T6QxNAeSWtp3jGkW5gCXe8RSy3P6gmeiWgiemLP
45034	payment	2133	2133	1874	1	1	6580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxYYmv4ZH45KrBX3FBKcvQs2fkn2pfrJshWjDMt7PE9uPjdce
45037	payment	1397	1397	1678	1	1	16771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxSMYkfaMCfgAQKsKG6fGetG5y7fzpQEqmDdwoq68nwFY5FbF
45038	payment	1397	1397	1678	1	1	16772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE96q3XmQKFxVgwUZTgcd28L3J2k19Q6YT4fF8TRGbEH1oEWd2
45039	payment	1397	1397	1678	1	1	16773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVUZdoBpRkNtBeCAbkdEGPurWUJZVWTmEDDQECxqvDs5tYnT3
45040	payment	1397	1397	1678	1	1	16774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4mRmnrzEGjSJRiwtbjsahjZurGtqTDQ4twvHUcgf3dKnASXzL
45041	payment	1397	1397	1678	1	1	16775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeiEaWEfJbqgq4F6FjU5W9mNswBjmBkyPiiM8kms4qMKqaGcD5
45042	payment	2133	2133	1874	1	1	6582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1khfpYETsDP7JvaDeqtVo6xqkkpa8jVi8umDb3kXqnDXnoDJ1
45043	payment	2133	2133	1874	1	1	6583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqR94bLDU2y1BXrnoR33npj4rvXH8tfUFrCAh4xnSVqKhipZS3
45044	payment	2133	2133	1874	1	1	6584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxdavHZxyXFJDFQQakgrNmVoKNh4mtvqMWs6bDHsF4UitEicwX
45045	payment	2133	2133	1874	1	1	6585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXhNJRdoQDt3YXG2C41bCVK4tnLWRAnYwREJ846BAJbGmCKNg
45046	payment	2133	2133	1874	1	1	6586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGGtkkzrCP14Gd2hdczt28C4LCu5XYZmwNo5KvAfFQwbH8yE7
45047	payment	1397	1397	1678	1	1	16776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtp6Wty9dERf8yyJivf3RSdPkoKgKYb3MWPeyz9gmfh7WjwCv
45048	payment	2133	2133	1874	1	1	6587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYvpJiVLq7V2cwa9xL7eEJHevhcA2sSNuWGr1Lgd2NmR67Re6
45049	payment	1397	1397	1678	1	1	16777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDGeKwnFdFgJqAkuK1FxBGDNeitnohwtCAMWDQd55o3wifBQbM
45050	payment	2133	2133	1874	1	1	6588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSa7B4b3gamNuxVAnVLagP4tBqanfrdvWd4rbNX8QVoHG6NMJ
45051	payment	1397	1397	1678	1	1	16778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVBmFWb4CeTQUuLLGFbm1898kKgo7bbMyjrumkeuC7hftHDBX
45052	payment	2133	2133	1874	1	1	6589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu53ytepnjrCgS82mho7fZFfVPF5UbG8NjTq73MLbsqScZV1CM
45053	payment	1397	1397	1678	1	1	16779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyAm9Q5nLK9bhXMTRFGKcxjxWXhNtqoJh3ruKGk4gLBuT2jH6V
45054	payment	2133	2133	1874	1	1	6590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2yECTVFfPcJ4uD7DakmxUGeY3J2ahDEZRqVecXebh3kgPYqpX
45055	payment	1397	1397	1678	1	1	16780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9nfpXfWKeNu4WZD1XtYoj6JrThQUEXbzqHmg6XjjabyPkGR6A
45056	payment	2133	2133	1874	1	1	6591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDq88muETZEzqwqMJDeCG6tLUxK4g3ChGAgyDqCp4H7Zjh2nB3
45057	payment	1397	1397	1678	1	1	16781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeW8QpWQSXUvqZqBKgPvDchp7zmMBQQLYBURarXkLrm88ypXBL
45058	payment	2133	2133	1874	1	1	6592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJiTPMDkNkom8tFsHvAt6v5cLAVLrFrz8hrVWQYtAFUvDt5SDk
45059	payment	1397	1397	1678	1	1	16782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcoJKzqM51W9ziun17uhnxTRaVPiUoSg8Zoi29URnuaV8eTsJ
45060	payment	1397	1397	1678	1	1	16783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKCcknMcdYBwPd8j2iVXUL4qgdiFb1iRC2TUTFxVZq4i8oLPi
45061	payment	2133	2133	1874	1	1	6593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbKZShSuJnAr5citg3f5uxkhXW2mbderxTzAdpL4ZZFtmP4FV
45062	payment	2133	2133	1874	1	1	6594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4ddC5mjxy7LFx7ad1LAEt9dFj7HSCZNxo3yhPj4HEZ5cY8qj
45063	payment	1397	1397	1678	1	1	16784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycnA1TyETTwQqS2SqXyFncv3C8Frn2Y7AWY5svwFTPj24T4d2
45064	payment	1397	1397	1678	1	1	16785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNw4FqSi6npAiKdWZG6B62WvbvV8BEhw2eGsnirfhYYRjeucB
45065	payment	1397	1397	1678	1	1	16786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5SdpkAQA3RUqD3PPgAk5hYAdbZeyit9G7Eba7Vo488Mjn47zW
45066	payment	2133	2133	1874	1	1	6595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCne9uEbVTTFxEdDckHgAAUnCXg1FiVumsGtk4dnzxTkZr4Zc
45067	payment	2133	2133	1874	1	1	6596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbXkYs9T4oRsf9PndsNM1zucdRpcKLtHtiKwDT7JfGQ4XgGZio
45068	payment	2133	2133	1874	1	1	6597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUX86dtKbPZGP62Jcbpc7RctC7jXbzL9a8mrqcb3qNJTxsC6hJ
45069	payment	2318	2318	2152	1	1	0	9990000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9EyXDwbn8bk95YAyTznv9L9HRqZj3p3Yiz1xzNjdaRJTKwVF
45070	payment	1397	1397	1678	1	1	16787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYezTK4pE43hrj61JF5nbBGo59Xz4fLqRVCXBTAkbuFhKeNiK6y
45071	payment	2133	2133	1874	1	1	6598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1HDS4eTiunvYEBiR2qGeYwkTdoKqGbYFMx2yEWJ8Piq6Hkk6
45072	payment	1397	1397	1678	1	1	16788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsW4NdXZFgPHN4x5G2VVJfUq8Qwwt2Jc7XTkKb6tBnPGu1u8D
45073	payment	1397	1397	1678	1	1	16789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPFrLRMwnDz4LwFWP8mZmCEUd48ymHUJMFCfqtwfBDpuF82za
45074	payment	2133	2133	1874	1	1	6599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyi5UmMEjxwju2HBiyLdCBvV5iup7B5ozXAQX7ueXWZ9sVkD6W
45075	payment	2133	2133	1874	1	1	6600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYPdPMieB1incLwrkHKs93RJrDJkQidG6b6EpBP2AzqyxdxM9
45093	payment	1397	1397	1678	1	1	16798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxz6dLRdyfvsn1kcqhPGtWuzqVBq7ayLCC86HMMDpr6KzGHEDX
45094	payment	1397	1397	1678	1	1	16799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpBnoB62jMosobChYdJPr6ZKCykpUd9hN9fZxKJseUBHaF6kJ
45095	payment	2133	2133	1874	1	1	6609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS44EmDqumRDYy5h72vY5dRVWE97PBc9txY7vNcxNoyAowdKoH
45096	payment	2133	2133	1874	1	1	6610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMB6HPkTvtDmXGtyb1xm1GTdKQALVEx4UDzTyhsDMTkU9PaERq
45112	payment	1397	1397	1678	1	1	16806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwTbpRTffExKHXBv5DWbkHU7aPpiKHqXp8veniyx4EPceyoSr
45113	payment	1397	1397	1678	1	1	16807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1X3oXsXsSzk4kB47286UGB14VovTLk52SJuW3tgGynxt1Lww
45114	payment	2134	2134	1874	1	1	7021	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG861EdVDFwKnjToBP4GRfwn1Ncff8TgCUSBgaQzNoSCt8AikR
45115	payment	2134	2134	1874	1	1	7022	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGgL8o8oiWtWAk3yajHxLQynmcDeJT66ruDGguyQ58wDQKwnA
45116	payment	2133	2133	1874	1	1	6617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Fc6hpgw1qUaCA37ACs1wEb4gaJrvtsnfk79FHiY3MCfSkBhs
45117	payment	2133	2133	1874	1	1	6618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjE3XPcg1fPtKzrNwqbFvzD343Brc6VGvNjNb7x5375NyJZ1dR
45134	payment	1397	1397	1678	1	1	16813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6qDa9BFwPSVaFKRNp4PsQpDBES5oTz4ia3TERMZmHn9Km9yy4
45135	payment	1397	1397	1678	1	1	16814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGBX5AmTJeAsoSLUUjhg6Cey1oHtN4hkS3e2harG9D7dHTJFxC
45136	payment	2133	2133	1874	1	1	6624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeKoeqnoJg9buaQqc2rbzBCh7fvbzqduAyiFndMUJ4GQWoha3u
45137	payment	2134	2134	1874	1	1	7028	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZqNm8ZCQXSt3EU6A8aLq1KGFFrEm4tixEv8jZxyKcFbniP1r
45138	payment	2134	2134	1874	1	1	7029	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrxq3eYsSDDQKmSH5stuitxzLoEoMZjDJdvvEk9ABBT35Ht5uC
45139	payment	2133	2133	1874	1	1	6625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfVKLn5HojhYpn1K4qY5o9TDGNdhYSYy7x6FgqQ5zxeYs4tC1
45149	payment	1397	1397	1678	1	1	16818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4adi9usCM6V8bDWM325Th3Y4RVSExWPogUdNuCKAh6FVoumRg
45150	payment	1397	1397	1678	1	1	16819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG19AcGf1GU7hGHgs8d6irBF2u7DMYdvNXpZEFLbsWN8croypY
45151	payment	2134	2134	1874	1	1	7033	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfAqMSszi47zHdfBj87BWoWAhkPfdkxLe4pBWgc4yaNnW9uTR
45152	payment	2134	2134	1874	1	1	7034	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcoz2Aa9bcPk6DJCgF18VstbjpLLqHRR4MmFg4TPzFQZdacft
45153	payment	2133	2133	1874	1	1	6629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nwWJuPJjZ2XKA3GSMjfKvoRa2Tj4LQBnbjArP8eFuqpvwZjR
45154	payment	2133	2133	1874	1	1	6630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZArrx4RDUE6ee3dQKPZy7cX3BvbvjmgvEiozbyxdvby6M2ZEU4
45170	payment	1397	1397	1678	1	1	16825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYWQW2751d6Tn9Huf7oDMp1WgjnpUCa73svDeq6GxEDSHxZeoc
45171	payment	2134	2134	1874	1	1	7040	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpU2gwCz5aqCdkZ3qxX4Eo6nrbmEBM1x6PbHiVMPReW5CVNCeG
45172	payment	2133	2133	1874	1	1	6636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9HFy17bHU8UD1rctpVBUxe6wBen93YMLsYcTEa4axX9K47TLX
45176	payment	1397	1397	1678	1	1	16827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3b2mjgjSGNUPLnH63t5F9dkx9fV9GnVUhJaRA4sWf5LFqaLt9
45177	payment	2133	2133	1874	1	1	6638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeV5YfXGFqKBd2h7BVCyW4mfdDgAwyUWfQUGEnaHFDDqcTK8Ed
45178	payment	2134	2134	1874	1	1	7042	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAGL8NCGsi9WLiyjwtLwWUHbUs71R7kMxTHNSBdfWmdFCsrrw
45185	payment	1397	1397	1678	1	1	16830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUybLxAHN13nQjEwdDy74wE8frvbfxm6NexrkndBYVEbAUj8yz
45186	payment	2133	2133	1874	1	1	6641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYN3W9AmRVC7J7zj3AXWdA7F2MhB2f9C6NYNnv8oKuZMH8yYFP
45187	payment	2134	2134	1874	1	1	7045	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wpxdCM5L3vhMEXWtv4Rg1eBPPvok3ati2uLNwfkEF4LUzwDU
45209	payment	1397	1397	1678	1	1	16838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZttmiFVJEjmqwqQttAFXsQqU8JfUXxfMeSxtzLK1NapbsNM2kJ
45210	payment	2134	2134	1874	1	1	7053	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZrNwjopXSsTWmNT6JSxECZGbqKeNtnb1L8exFK8gSCmuhPdZ
45211	payment	2133	2133	1874	1	1	6649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLinPT1YF4SL57sfipXdq3npSZAatr3QnB2NzBpbsfK4Ji7kq
45221	payment	1397	1397	1678	1	1	16842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJoonyCtMvfpnNMixBSmej1TJ4A9qnYMkenkri5w1RS1YSeY6
45076	payment	1397	1397	1678	1	1	16790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLzyQRCTaNe3ResAC3dGXpMs3qqiNGX87gCqDBqWqGgzM45QJ
45077	payment	2133	2133	1874	1	1	6601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToZJmiqkE15Zssok8P638K64kvhj7vvQzmeANaSmFEXUviLUj
45078	payment	1397	1397	1678	1	1	16791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ665rHDWyR7zdhfBFVQR7B76EiuavSY6Ak99YTca8XoxHS9mJ
45079	payment	1397	1397	1678	1	1	16792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEuqq37Yq8vMGJdFswvk15uKENyj3xCF1nXBZUiPD7V8H14hN
45080	payment	2133	2133	1874	1	1	6602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDy9KtpNBQebS7as4521fg7Ugxj68SAFpJJC7xpTSQhtTqJdM1
45081	payment	2133	2133	1874	1	1	6603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1yruunnb4yrqt7s7YUqm8q32EfaMJvP64z3exGzAwohhAyX41
45082	delegation	2317	2317	1600	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZRzeE3pfDCG4kcbwsQ346PZo8pbZnmXEmAP8HzxqFCStVnBh
45083	payment	1397	1397	1678	1	1	16793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkndChzTv4x2vbdEzKXsK6YDb3FDEjeBp8DuDffkjgw84pYXo
45084	payment	1397	1397	1678	1	1	16794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPs4QxCiZCbrw9PkrtJVFaeZxcHqQUviHXwFtxJqh24ThUPcU
45085	payment	1397	1397	1678	1	1	16795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVVreUVaKYSakE8qAnsJa2cde9e9Vhog7qNAsrV7Ubd5WqTBwN
45086	payment	2133	2133	1874	1	1	6604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYsCH1KdwRP1czXJPZko5kkzELSKzQqnnaX63yZ2ZrL6iY5Wta
45087	payment	2133	2133	1874	1	1	6605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTMamLfz99PkdJLNd7NKo63srwPz3rLiQpV3KMGkvLNc1RXmUd
45088	payment	2133	2133	1874	1	1	6606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfH63FQitYLyqeK2VzzCXNzsuUNBHuumPxuWSmTYTCH8vkgr6
45097	payment	1397	1397	1678	1	1	16800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xmxYvhv71NUwpqmZWZC96Q7rwTaBYuxzyYEqZrn5iVJMTcPW
45098	payment	2133	2133	1874	1	1	6611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4JRt178psudL7FK9kCpEVCuEj4kbvYzENApqHVPjMYPjCQ8B
45104	payment	1397	1397	1678	1	1	16803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQjvjQnyBhRcaxHC4BWdkC65qYDX8xnffggLKaScYXsZdAV56
45105	payment	2133	2133	1874	1	1	6614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9DEv3LZLa5eTzYg7APXkTQfezAh4Ma5Ktgvm6roJsL8tuYuW
45118	payment	1397	1397	1678	1	1	16808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8uXb8hqkyhZ6JqBF3sov3kxwZFpAdyuZQBeEmLenzfTm9hiY
45119	payment	2133	2133	1874	1	1	6619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsCTtCnFAW2ybGUo4AYEb42UcofV7eH23EnMBKA7B3DQbmvdH1
45120	payment	2134	2134	1874	1	1	7023	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLzzXbQmN7ww3h5VqZ9yGrYYxFzCwPdZbYjVar6umc5pLZxgx
45121	payment	1397	1397	1678	1	1	16809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9hDtez8AVZ9g1xExTj56gCaRCZQTPd5YkwiNgkF7NZUJGEgEK
45122	payment	121	121	1816	1	1	0	0	1000000	\N	E4YrncE7KmCzc13wLELNtP13WuZbmfVpopmebkPd4TMFfeUfmfdRz	CkpZDxauv3k7whnXNQa3NFMa2xfRHCqUYkUYBcQjUiR5vrZsWNHQv
45123	payment	2134	2134	1874	1	1	7024	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsx7ohmv4CKg79ffFmS1oMSRi7wKhji7FpMa4GggmHUAzz9pDL
45124	payment	2133	2133	1874	1	1	6620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGB6sELhHYwLXp4TJNZMGYFgAuofS9RTTaQ7MRDRVsKqGnb2gi
45128	payment	1397	1397	1678	1	1	16811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXAcKMjzAwJzrTairebNCBAddx2h2DXFFe5KyaiAhp9N4VnWe
45129	payment	1397	1397	1678	1	1	16812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZDe8VuxXiNj7vFARKV5AeNAFFk5g7JPw49eNwGHAwJR1JYEt6
45130	payment	2133	2133	1874	1	1	6622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWuyL5eg3gyzqsecz92x6TDKKKrSu1oHAX6zMSzKCpWhh1piJ
45131	payment	2134	2134	1874	1	1	7026	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfaoGyV3a3BVtpQkRNXdrBMFinZ2e5dxNrmn5Hc4iZRxCtGHkd
45132	payment	2134	2134	1874	1	1	7027	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaM6afCHiqn5Y4CYnhxRMFXAy9ZrpZfx3UtDfPsZ9Tg6MaxNBj
45133	payment	2133	2133	1874	1	1	6623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA93jdCJzfbAkh74ZYsvgQa6UbZw16KHUUpoR2S87f6FQAsSib
45140	payment	1397	1397	1678	1	1	16815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWfmft3a5dQjaNcB3tFmxUSnr4HkJQ3vf8NWbFGFgaKZY3rYz
45141	payment	1397	1397	1678	1	1	16816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUn4MgHo1trnbSc3YdzwN82zgMMw1pLNAtSkJuEoi4fq6mVN2Z
45142	payment	2134	2134	1874	1	1	7030	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepbnixpTJm4Xz2FMujMGZ64TmtPiTMFnSTcTTgF3Sn5FbjeLi
45143	payment	2134	2134	1874	1	1	7031	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL3nobFTPss5MueUaL7tSLD6yR82oD67baoM78L7UWeWZXMCP
45144	payment	2133	2133	1874	1	1	6626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVpNtEWpA9FLv3LsenaAKvmj1p2LMNW2L4QNTmER3qLYVaSbw
45145	payment	2133	2133	1874	1	1	6627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrd9k7CEdCiG2faoMB9qpio8qrntwu5J2h1ZzK1dmn1Fb2nu4
45155	payment	1397	1397	1678	1	1	16820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5WSGPt3KCCbDivpLwFW8nszGBFeVnTCuihbGpYTZfecZ3TNg
45156	payment	2134	2134	1874	1	1	7035	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSdvJJqz4NMQEAVYobwDMeniR2W5viabTG2agkhMdCoyAbREt8
45089	payment	1397	1397	1678	1	1	16796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCwnPh8JEvzRNSrXLFg5S1tj6vEGtiqr48qdKTqDrNDJvdmp4
45090	payment	1397	1397	1678	1	1	16797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1oZmzFxRbkHWLTLQrNpxd5vvGjAoC9qA749r1n9pPodcHCav
45091	payment	2133	2133	1874	1	1	6607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJZ2BSC7cpnVRCbqgQTcRau7dWBcY7yhqnpYdz6rVPEAVC74ty
45092	payment	2133	2133	1874	1	1	6608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoy1rxRuEafQrFsb6vKLkWx8J4w3FfbYmhe3xQfXumbNoS6k4j
45099	payment	1397	1397	1678	1	1	16801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG83tc3v3ns8Q9D4FtTXNgtTK7pc628cQsGg9di7dcS6GAm1va
45100	payment	1397	1397	1678	1	1	16802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrwEnd2P7GQEd4n1nzRSgbC56F79Shw4iCC6U5gHw3Qco7qutu
45101	payment	2133	2133	1874	1	1	6612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsesenNwjHq2DkgtrK8muQ8jxTnTmRuLDBAX3umbmBUFkrZJEs
45102	payment	2133	2133	1874	1	1	6613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrhKobVyHoJjwkfHpuqiQjovLmNK9mUpQpmcQtKziAHi9Tjxrt
45103	payment	329	329	2385	1	1	5	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSukuko1rTZme291wKPJ7gxePX3iy8bJz9hAkrXciztNJiTWV
45106	payment	1397	1397	1678	1	1	16804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNjqtWK7mbJYVVT8CzXXnvdYayzsWkZ7Ez6T8rGLnEL8hVpq5
45107	payment	2385	2385	121	1	1	0	100000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQ8HFbpaxAJi2gpfaXRAvtPMnSKFKcFpm1dW1e2QBNy4vQYXt
45108	payment	2133	2133	1874	1	1	6615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDFzewKXabxZ9rTMmMg9GQoH7uxgtGdioAqC57o7xXAXay6SK
45109	payment	1397	1397	1678	1	1	16805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXikb2xNq3znTYri6qztmTszL4ywtVJVww6cKpy3BBKK1n1kYx
45110	payment	2134	2134	1874	1	1	7020	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkXPheFQYoYHrqu2Pgfx3NBrWFVK83Aqm71nBjGvNGuBMf99ef
45111	payment	2133	2133	1874	1	1	6616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKoaNS92tkkXbZD9KePTYz2xYBDmQve7Sn8VbiyGD9sx8R4XN
45125	payment	1397	1397	1678	1	1	16810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVawnvYReqQFPc5P4eYfZBRqEpEJXKD4uyuBCc5GHcbFSpQSrN
45126	payment	2133	2133	1874	1	1	6621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVf1xjTousrzkPYmsttNaFgVXPCxjytCX7VgDgrqDAXXTmaz1K
45127	payment	2134	2134	1874	1	1	7025	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq5e4vWnjRFxZNuUm6V85s63Y95Ro7zFrWW5VdVdKuWsxvdZ6P
45146	payment	1397	1397	1678	1	1	16817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYda5w7BweqjsxJNgavjmCeWsiwnmHAWE23vKFNLeFoxKzWG3N7
45147	payment	2134	2134	1874	1	1	7032	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6otrrhbCqEFemnfNHDHv73PYL6aZCsgEPZfWgmyoiW3WH84f
45148	payment	2133	2133	1874	1	1	6628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6DrwDDYLhcEnGwJ5tPTBodS2DHJYtQejdW9oLqzvdY3CbYmfb
45158	payment	1397	1397	1678	1	1	16821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMgF6eMep5LvSUSqEpTq7MSswJZXHkechvkEmy4f9iKJxAEGR
45159	payment	1397	1397	1678	1	1	16822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJrTrNBrFwm3wecTvMYfYHvXS2oMh9TgM1yyHUTEZEkNKTr4j
45160	payment	2133	2133	1874	1	1	6632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZZKL46C9FK3LohJsDH1hJoENyHxHtPR9QEQd9g7siUWabPtig
45161	payment	2134	2134	1874	1	1	7036	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugrwgKsgd6Ky7FGVdapwqWoF2f1wiWs9RxBcptqFXJWFnwdpc
45162	payment	2134	2134	1874	1	1	7037	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCRBB5wAAh7iCK7JWFAP9pBCbu9cyWZ78dV6GrRJGBP6XtRHo
45163	payment	2133	2133	1874	1	1	6633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq6rgrgq4CzZM5YGrp18r3qHWFTtz1qBhrUGhYLeo7VxqL4n5D
45167	payment	1397	1397	1678	1	1	16824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxJs3k3NWv4MA9Zo6CEP7r8ARQjVxkVYozLoiTMY9arq8iXVVs
45168	payment	2134	2134	1874	1	1	7039	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGyQA2FLAFUjH4hp5rJ95Wd41oW1vAQztVTqrZW8AM4BxsYxF
45169	payment	2133	2133	1874	1	1	6635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zpqZvtjFSMM83faax83mAy2o8GMgg6v8jSMgVZtyb4pSuVaR
45173	payment	1397	1397	1678	1	1	16826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrnN9Jdxp7Qwz5ZHVFPWtad6desq6cdqdsfC9ZN9rMBeLHVjk
45174	payment	2134	2134	1874	1	1	7041	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnUP2cgS6CxT9Dgv2L2yhyrLmKJiUZCY4pmAj6Bqs7mEDB6ViM
45175	payment	2133	2133	1874	1	1	6637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnrMaLxf7sc14JM9yv62L4Uke1Djq4UjYXnoos8bGPhMib8gRT
45179	payment	1397	1397	1678	1	1	16828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1v28FF6eCM1LaFrjZzXpbHdtosBu6auRNnFBkbvohAR2mZEDk
45180	payment	2133	2133	1874	1	1	6639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepzxUqSrxnzT38VAJnh7qHnQoKj9dnGzAqE95Ffz26tEL3wC4
45181	payment	2134	2134	1874	1	1	7043	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqMJY1vs1xmjAJhobd5aLNB7WWRG14Hiq6TPhEMZnFvrGdjxdJ
45191	payment	1397	1397	1678	1	1	16832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGxgMGjZW1MeA5vhRnUpRAZTTHGFiDU9mnoFYHKi9o99K7oXdy
45192	payment	1397	1397	1678	1	1	16833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5fPxp8AvUCm1oHAwPTVjn8v3QMN5FW1wKCUnZHfn39eKJUanj
45157	payment	2133	2133	1874	1	1	6631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4MAGrUbNzpZBzQWZR5unLbXBpN4dcoP2Kd7eLRJru1dZB9Gu
45164	payment	1397	1397	1678	1	1	16823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmUk6ESXaJRDjrcdWrprPbtt3ENrAXuiPUgr7AzFQW7Y6cCyr9
45165	payment	2133	2133	1874	1	1	6634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSaNz2TxrMf77PhouYqPP9GW21rKwQVRBKCf5Eb6sSMfcTKmk
45166	payment	2134	2134	1874	1	1	7038	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QP1KhpCkyDpsaekZS6uvpGJE9j5F6mkfc52DJikH53NqVcNX
45182	payment	1397	1397	1678	1	1	16829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3giQRBByLcT98wby5QjGKytYo1TZmhtorAZRxYJhBXgP26gvs
45183	payment	2134	2134	1874	1	1	7044	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfNxwN2tN4BzkxJYz8h4ZBaoYQ8eUkoWHJMrDRzL2cQ633jRUL
45184	payment	2133	2133	1874	1	1	6640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9JQqFLHet8z7DDE7NbzJgBRpCetK8P8yWyHbUitVKFkMsQHF
45188	payment	1397	1397	1678	1	1	16831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsZr5hMo99vhSfAu386DbGV7HMQWKq47pfdbr49dZoj7sGSTEm
45189	payment	2134	2134	1874	1	1	7046	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWd2HbyTAdC8LK9keyHMjV2iGzDBnn9tuDU2a1XtLXmpjDLoJW
45190	payment	2133	2133	1874	1	1	6642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcW8G2gS4NvWxcgF6UPxnKdSvv6gufB9kdg4AYkTqumHJt7erT
45212	payment	1397	1397	1678	1	1	16839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpNXq8yKnQRfvHei369YmfpS4AzcsVBp1NuhC6Nv8sgDm3BDM
45213	payment	2134	2134	1874	1	1	7054	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhZGnf7QnCgMenkn9cdP4YMBWeZQzXwsx9dKJ4zaMMPex8rJC
45214	payment	2133	2133	1874	1	1	6650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcCRhHGPN4oEnn4V7d8hzecxHK6WbwXGwjuW5wbKhjg2TCWxL
45242	payment	1397	1397	1678	1	1	16849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeuy9Uf83MKYiCDuwNBCWJdkU9muzQ4Cn52azUzbCTta5pvdp
45243	payment	2133	2133	1874	1	1	6660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPzwpXJgji1yJnGNH1crpGpC9SyJWN5W9eZatgZQYzzgjAwp6q
45244	payment	2134	2134	1874	1	1	7064	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVd8iA7555PWUvRc9yiT3VNJqgdMQXf3Rz3huF8zR81LQH8YSG
45245	payment	1397	1397	1678	1	1	16850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3qbBX5QoZijBrJwJ2m2MceJKsJ7MeCya23ki64yChrbf8oCGc
45246	payment	2133	2133	1874	1	1	6661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2AEeSFzscyoMCN59bb51dB5vEGxz9KuSe9RfnWrH7mAhfG891
45247	payment	2134	2134	1874	1	1	7065	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBCDrNSUUvKufGYxJMhw1Xr3wZiMEw3UkVptCDzrEw7Qr8immq
45248	payment	1397	1397	1678	1	1	16851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVAZndvyxEN9mPowyxuXXhpazZ5qaQsuqrAknaSFKPCeh36pLh
45249	payment	2133	2133	1874	1	1	6662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cRXpv7qTyrLT4a1JLgqa2tAVkWAHMjt5fLJaGRUjqmUcenCf
45250	payment	2134	2134	1874	1	1	7066	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjCJD3LyqXTaxammfnNfz3eTCBLxtzNAMsm3q7tJ42FnFzgjAV
45254	payment	1397	1397	1678	1	1	16853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGdeShpd9yyMJ6FM9JbiAgvdskDQwnqHRZWp5ia18WA1YroRA
45255	payment	1397	1397	1678	1	1	16854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGAeBV6BtsEkP18HMVFQkppMJ3N9s6546gtKdQfSTLgES3S1j6
45256	payment	2134	2134	1874	1	1	7068	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXN9fi3S5mUmVvDwMJ13rJQQro3ePJnVSPwkXusRV1WjaR1gQ
45257	payment	2134	2134	1874	1	1	7069	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVq5vDiuwjJ8HzYhqGdKEbm7AEvPddoZNzX9abJND2n5hwEytm
45258	payment	2133	2133	1874	1	1	6664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKd1U52PVJr9PKRB3Q6L13tbJYLw4xN8P1GfiSVohWCmnHcJ15
45259	payment	2133	2133	1874	1	1	6665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkhzwWLdRT2JUhH2RQK63FopfhA6zZKMjyTDAwJL83nvbbbWCk
45272	payment	1397	1397	1678	1	1	16859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9wQxEQBUhc48ue5FCNH7Y3V7kQ8A5pGzw1YZyxZ3TwGYGfy7r
45273	payment	2134	2134	1874	1	1	7074	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg6Wpaox8nzZHA7MkJdnHXthmTWZVRJEqCKkE91Sh65g7pxdVt
45274	payment	2133	2133	1874	1	1	6670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaBNQPeXftAp8zPSYYUEyv2ciUs5T4rNcziBrV6mMMDGGuRfUJ
45278	payment	1397	1397	1678	1	1	16861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQLq4nuVR8mLpn3tdR8Y3WfYqf1YYsBhyikLP4mEPFBrkpNqSR
45279	payment	2134	2134	1874	1	1	7076	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWoXcZ4MVwBd5kZSvBWh3SB4VYUrKZBqCZ1Rkw4aNEZhMdqaHd
45280	payment	2133	2133	1874	1	1	6672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76qfvkKdiQHnn1zZ823kKrKWACKxhTeXFQPhBovoNXoBnLTed
45292	payment	1397	1397	1678	1	1	16865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTPc2hJ62LKMgdZaeoud2AHZT9XTB2ovcxQToLYr9z6EZUGTTg
45293	payment	2134	2134	1874	1	1	7080	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCYTixWXL2zGvk4XrjXYjBQuC58eMSJ7pBemu38Bh7ATF7xFJ
45294	payment	2133	2133	1874	1	1	6676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvueYtT6xUtxPo7YgCWLuUqvMJjT9jbTXsYKjsbwNr1XhSD5v
45304	payment	1397	1397	1678	1	1	16869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtCfzQrJUWzyVQTnD2Rzpus9uBqEpMVGeNctZLW76BNGxEM3MG
45193	payment	1397	1397	1678	1	1	16834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUJ479a46wPPfJqYkjEm7MX6UJo3tmFi6pUYGVs7Yiagjd8ew
45194	payment	1397	1397	1678	1	1	16835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmeh4PAcurN6iVEQiaQKy5f3hhHHn1sZrZQwKmotFvr6cDcuGh
45195	payment	2134	2134	1874	1	1	7047	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYNnsGnvxAwMWS9gjz9pRx3oPtSgvz5WdwusN1gpQcieGNTiXB
45196	payment	2133	2133	1874	1	1	6643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eSMrmBefKjLmrD5czJMa5s93DbcgZXpMWmH1fa4C5eNVqDcu
45197	payment	2133	2133	1874	1	1	6644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiMf1ds2sfhEYbFVzJsFoXYohcVeQiJMZSeLHayRK1hnBqnxpd
45198	payment	2133	2133	1874	1	1	6645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHywQuWAX8wu4HygXBSKmJCssb8E7v1BWenxb59Pe2k9jLB8P
45199	payment	2133	2133	1874	1	1	6646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZAsTvQzCyJvbpXwwfxdD2vs2vUvyXTu5SugF6BamXvg7p3ad
45200	payment	2134	2134	1874	1	1	7048	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKcFQVAMDYuDVr9Y6bRjLDSSAosjEV2GqKaWKdaGBdg2PdE4Qu
45201	payment	2134	2134	1874	1	1	7049	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtEsTbGuiz2mSqNnkCsfLoPEnmSDfiNNAGrFsZhRRTNQ6jaUB
45202	payment	2134	2134	1874	1	1	7050	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdZvjKQ4qaryYy8cMJAJsLmEQChS6v2MFHkNG2aiuyNwYp4o1Q
45203	payment	1397	1397	1678	1	1	16836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBWWTMiV2RxMAV85ycFqehjGq61JVRrefEhE7EmW4DxP2ZW7D
45204	payment	2134	2134	1874	1	1	7051	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwPxHyX3xtZx8xWcfEpgC9rs2j1jfJdEaNUHpWTZhu1Hgzpki
45205	payment	2133	2133	1874	1	1	6647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTbzJqor7WyRKxwKGuA8yKzoPYzF2KfNnYLzto5RJ8qu1Lnwn
45206	payment	1397	1397	1678	1	1	16837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqg6SvGAA6poy7nWaKxLiCHAgCJNT7EwCvt1pxms54DM6n9poP
45207	payment	2133	2133	1874	1	1	6648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9RnfB5L21mUb4YVmzfd7CzLdoRmk92JM2LFyDtZzLmvxB3L8
45208	payment	2134	2134	1874	1	1	7052	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjD25e4F44xWqtaWAfofzBgBcTG1KjSEVBWmtyqYuEyEctQDfe
45215	payment	1397	1397	1678	1	1	16840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn5LPWvju9BcNdvdSGMNZr9UzXEmX9T7wJhdSaC3ncpn3NEchU
45216	payment	1397	1397	1678	1	1	16841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsW4uLt75pjmAPb8CteBKUkmH5AfeMbbPmy2vKty8AXn1sgy6i
45217	payment	2134	2134	1874	1	1	7055	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBQ2phgBZefgvHvM2oPcgmqiqNjSZCTgjwUz1VAGj11MTXFdV9
45218	payment	2133	2133	1874	1	1	6651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWHbBfk9BwawsuQZY99o61zinn3UW6Z1fxFL32bRMvsS2tatb
45219	payment	2133	2133	1874	1	1	6652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iDmebgSYK2YeStWd6JoFyEzSRrVN7EFfj9FoWTHVAq6giE66
45220	payment	2134	2134	1874	1	1	7056	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXEoC4hZ25eyGgtjQkSJpZ9PrgejdoAfkPABTKv6GeUpSJVSm
45233	payment	1397	1397	1678	1	1	16846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLm1HRivoFw1PN94ht4PnhRGiU7pzMWuf4Aqc16xiRyx7TP6Y
45234	payment	1397	1397	1678	1	1	16847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtqrcf4mYEitPfLhDLkSZ2He6dd6AtxWbP76BXqj8NnwA3Vefc
45235	payment	2134	2134	1874	1	1	7061	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfjaMmKHRNGgACrK1itvYwGUhXEo17kZXZv1Y5VLhWiYEKSto
45236	payment	2133	2133	1874	1	1	6657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbz2o4FuzDF1uEJ5aZBRM4AHJkvJRohpyAQ599W6iX4QMm7ndW
45237	payment	2133	2133	1874	1	1	6658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5V9wAJG3JvqxLt4Vp6ZT4TURxaTHbCdcTwe6rLmXwmwoFnMn
45238	payment	2134	2134	1874	1	1	7062	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuab692MkvYzqX2tzWTLDEpxWaBngdabC9MV1NsuvYAcvsjES
45251	payment	1397	1397	1678	1	1	16852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnEX1zpManFdg2SxZmPogauNUUNTetw4jGc1wAYPj8BdvWMqh
45252	payment	2134	2134	1874	1	1	7067	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuZqRtAKWPsaKdafsvBGxqSFsxgmjd7tkcQoNfo9CSGvUxqjeE
45253	payment	2133	2133	1874	1	1	6663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5kVtZwviT9Tz3YAvT5QHm6GDE2MkbVdwFT2cGU49TJEG9vHjK
45263	payment	1397	1397	1678	1	1	16856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Gt1HPZw3dmSJmTuwvmrntxL1v6eBZouXKSfYa9WW2MRcZCAb
45264	payment	1397	1397	1678	1	1	16857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy7FhcqsSEq1ryYwR3Nbr2xCTMzzXsfPJAF3qjJKvCz2fRmM1W
45265	payment	2134	2134	1874	1	1	7071	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfHVwXgkdDKKc4da197wAdxWSdw9q1ATX6Ku2a9GqnwrcAdSh
45266	payment	2133	2133	1874	1	1	6667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX5c3kFBwqUwgREu7eewtkcQZcFik9LctBx5mAiPbKPKGcR96Y
45267	payment	2133	2133	1874	1	1	6668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HKXKspr3KNyAiJEe63L3VEn97QwE752rcxhgxemYG6G3kEQP
45268	payment	2134	2134	1874	1	1	7072	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvuE94TgBDXcwDuW59Ji6ZmwaMHMJuaY1wWDR6yyH7m7hvmQhx
45281	payment	1397	1397	1678	1	1	16862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDCchDwZCw8c5zbyS9tXrDUCbqpTRKJHcfXa9UhfmsodnZ3gwt
45222	payment	2134	2134	1874	1	1	7057	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNuQNSMw1pJNxZHCYD8NCawin9nmvYifn1kTBC1um4m87imdWG
45223	payment	2133	2133	1874	1	1	6653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39SGCLpWyv2VAPPSQYGGPqsWqemSNraWEBwcXqfCR1X3obE2F
45224	payment	1397	1397	1678	1	1	16843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYruYpbdRTG5E2ruueBAiUK8yjKSBuahF2B2Kz6WGnBA1Daa2dp
45225	payment	1397	1397	1678	1	1	16844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGcbemuMoSuxW55ZaN38QUN1jB8MSAAHF4uSP1Z9fh8MKK3GW
45226	payment	1397	1397	1678	1	1	16845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyFkQUMbCddRmLcsSoF73VRBbYjE4GuSDEijFCxkepQbCZStLF
45227	payment	2133	2133	1874	1	1	6654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgXjkYqMUP9nAskAfDP9UhNvba6g8xDi1VszDiqDx3ozvA2QVB
45228	payment	2134	2134	1874	1	1	7058	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13kPq3asZTUEiEUW4Y32uwcmkXiPt57XLJQYeHJAdwCwHXRTP
45229	payment	2134	2134	1874	1	1	7059	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnsfNiVw19apeJhMu8AL1mNcYVaFVwX8wXsXdHnyPzEypKNaMB
45230	payment	2134	2134	1874	1	1	7060	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vrtajWNGhQg8TzuzHNoXgULRWEF4a7rBGz1Qsprqy96FLqH9
45231	payment	2133	2133	1874	1	1	6655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4PwzG2Zrj9ap5mbyWogVUcYhLEFpNmPPa6pJKqPtm1geWWRWk
45232	payment	2133	2133	1874	1	1	6656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qufwTULdsWcLwnkwiKUAQWY2SJhr9bqJd7ecSzkrDy5NMBbX
45239	payment	1397	1397	1678	1	1	16848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMSEJBytvF8p1WAF9gSLo1JfW1EMBguD6K6YH9Bbn6Ev9qByB
45240	payment	2133	2133	1874	1	1	6659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYow7pqcsWd7c75SdaUgwJng6h4BqnR59MfpgwPqryHzLQSPt
45241	payment	2134	2134	1874	1	1	7063	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57Yw8Rk8K9TnECWy4Ls4pGgbb8r3N6rtqp3qJWwe14brvF5b4
45260	payment	1397	1397	1678	1	1	16855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuwTJmmjRyoi2SAiKnGRWxYZNMkJmSVL4cRDPXe7dqjx6rgyLo
45261	payment	2133	2133	1874	1	1	6666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFyHHsuMR6dQRU8bxMwMExTXq6MxRmtctnqdbLgadZ8qAnWHV
45262	payment	2134	2134	1874	1	1	7070	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPc8JqGHen7jFgeGyZSUU1dZB9oiTXkgFaXttsQNWP3Nz2M6r
45269	payment	1397	1397	1678	1	1	16858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWfQHan6CFHJczciL4TATqwYVUdUuaR1xcFTZYvYke3pzYE1jW
45270	payment	2134	2134	1874	1	1	7073	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqAAxpz2X68T6EsH5BUCPcrsR9C8eu63e7mLMFmKHDGh5eHH9
45271	payment	2133	2133	1874	1	1	6669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLqQKvR48tbSFxZCrFSdqodiKEMamExNGfWPKFbD1wRtMFjBC
45275	payment	1397	1397	1678	1	1	16860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCqLiLG91r69j8yWULVThxfzQEuWRDRoQGd4NS9wU8bpScbDeC
45276	payment	2134	2134	1874	1	1	7075	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTs5vBj9xoXCEM2ZNjW4N3ujHiocrnhU6BuNXaNq6SHMuTDD5n
45277	payment	2133	2133	1874	1	1	6671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMboHeTW2YFzqBVoswgNzdR89DTDku37pK2eRYV93ubHeRrYzY
45285	payment	1397	1397	1678	1	1	16863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdwqCLrSMDqjJNmGYZKYJEiNdZ5LXvScV6MoR5bvJxayq4xBW
45286	payment	1397	1397	1678	1	1	16864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2G2DbsnnG5STiDWDv25bVV17tZmE6ok5wvtk1r16D8TnuHfjE
45287	payment	2351	2351	2355	1	1	3	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXXQ1M9Q4bqWpygjvLcEQmykMDaQcRe9NXitg7LnNRYdohkvv2
45288	payment	2133	2133	1874	1	1	6674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdeh6vhUNW8QK6kmCyzerviYBsGmEUYdzaDX5HhvhBwGvva5xF
45289	payment	2133	2133	1874	1	1	6675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMxC7NbijF7x28UKQa722vXkFLHDaYARHasqqMjgawEpESXjBN
45290	payment	2134	2134	1874	1	1	7078	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JLL4JEY9AyS2MdoqwevYe7ac6z2ojsyScsS1Y7iTe5NsGsCV
45291	payment	2134	2134	1874	1	1	7079	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRNwKMVxU3mrJk1uRg4Aemhhm5oUvEb2H9QMVwLTrcjiEoQRY
45298	payment	1397	1397	1678	1	1	16867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAfsexJ3jxLz6kFRwUSHAWBTbUoDuUXbBuwFqANDViRQchdQd
45299	payment	2133	2133	1874	1	1	6678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xWESRSnoiLEHv6FTjCyBRyAfN32gT6PRtTKcnWRKUHsU6B26
45300	payment	2134	2134	1874	1	1	7082	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKRPLvZzxR2rgyfvKySMRYgWDqoW8uxWcWrnvh1H6vUHaT1Es
45318	payment	1397	1397	1678	1	1	16873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtw96yJAubWFy1FPRKWNAm5qDYKZgrY8GjHdrqFumMgZZkWcts
45319	payment	2134	2134	1874	1	1	7089	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rb28qaSkAozEWjp7xHWPqxL83bbwMG47LygQuyFmW17mc2UN
45320	payment	2133	2133	1874	1	1	6685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfzRPVU9L1XaVHNhtbkbWnT4J39QK8mAgckhbac9MhK1fCWso
45330	payment	1397	1397	1678	1	1	16877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDkLgt1UzWiJnW2HdFtgbkEm7rz8J3vywAdopRbtdERRTZVVyt
45331	payment	2134	2134	1874	1	1	7093	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcn1XmKyv5dNEWU4Fb8zoJ4mJ8iVFDafLZxjNUd55JMC3wiBNG
45282	payment	2134	2134	1874	1	1	7077	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDgW9S5rujEq5tDC8R3bJg4tRnZ7rDS8aPLtzx18ddi93aFfA
45283	payment	1726	1726	2386	1	1	8338	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZagk5LgLze5v31j2rzacDSfWUx4B9xN1P35JbzkUTpkV5GrjuC
45284	payment	2133	2133	1874	1	1	6673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjjNL2j5SfvK9JmgQzKti5Uk9eqkSoHQBeQ8pj91YGD4t41jC1
45295	payment	1397	1397	1678	1	1	16866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi7tBLrYgHdBftL5LUeNaFSMFKDC9Pwqcxt6FyD4QQCtPB5N8k
45296	payment	2134	2134	1874	1	1	7081	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXmtNjiNEN93oCP17ki2k7teJja489iLUWqdv6Vvr32wpM4zGS
45297	payment	2133	2133	1874	1	1	6677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51GrpM8EWeQUM91F9QCkW49ctQYUnfHbQgwQZdWSmsELnVTRL
45301	payment	1397	1397	1678	1	1	16868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfpWeJR79myvcyo3mFqrGBhTC825sBnrcKMyDbAcd7nmu3fEjf
45302	payment	2133	2133	1874	1	1	6679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsDETpWbbJQymxhCY6eWiAs6jYCTZE7y3uaQ3abLBQXdN4WASV
45303	payment	2134	2134	1874	1	1	7083	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzm8u3fKZpKkQWwq7e8WoJ3VWqK1czsXySpo1YDhfCFRw2Z1m
45307	payment	1397	1397	1678	1	1	16870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9Cc9xeCdkmbGsvWwp1nd1JSRoediGpHDNfTC9omYfjiiCZnW
45308	payment	2134	2134	1874	1	1	7085	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6M1KC7QqDnm3tRvXMvypJCjVGaVTUGQthaJcrfj7aNNd4eSxM
45309	payment	2133	2133	1874	1	1	6681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzohn2LYH6QPfYzzxfJTaLrMgJtX6bh2B4tjbnhDb26pfnuJHv
45310	payment	1397	1397	1678	1	1	16871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5kwgxfqSwwmdPyVaRjmWBYeQ5iBC6oDEpmQ25Kf2vagFoYit
45311	payment	1397	1397	1678	1	1	16872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutRkBapoRGZe63vCshEMp7K1an1vdLzYK1j3CSzoDTshAd5b2
45312	payment	2133	2133	1874	1	1	6682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLMyJDmdhWZweodS5PbSHMAKcXnK6NVS1cdEDw3kWvP7h5Bbu
45313	payment	2134	2134	1874	1	1	7086	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKoXYMY3UioNPNY6YayNX2ppXacgoqhivmQR5JAJfdYmmf8xcQ
45314	payment	2134	2134	1874	1	1	7087	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxxMJctx3ciai4zyFhdWLiFcBXj13sByp1gzpvN6d1U4DB9xhF
45315	payment	2134	2134	1874	1	1	7088	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrE8MPZXVDVVhZTv4i9PV26MpcoWPG6ihSUBtG2GBN2dhXxyyE
45316	payment	2133	2133	1874	1	1	6683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58EWEwnsWJopWfS3JPnS29rEXK6tAWkKf82Ra1yoVZDtba67p
45317	payment	2133	2133	1874	1	1	6684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGodfNjkPq2NHKrxYJhijbLBdeJW97rFLQ6Xgp5B8CbUkWkuPY
45321	payment	1397	1397	1678	1	1	16874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFZesYbo3QHbt5vR3D4V8wic86v5VG8x3PB4bCsvjtg88teySg
45322	payment	1397	1397	1678	1	1	16875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pxgqBpJeDcRUCHckYKkDm2iSLfZnsS8HSwYSQvbbKWLSHxNZ
45323	payment	1397	1397	1678	1	1	16876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMpbcVnSTDvBMYkBdUZz5YcX7YChtGFX4YLaD9jAWNGCEWcjy
45324	payment	2134	2134	1874	1	1	7090	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTgwo6BTJ91wM4vGjnU6jXcAXa9MRnZMHhgh9hrzYnbZuhyDe7
45325	payment	2133	2133	1874	1	1	6686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpze2umsUBFhRqZknLUKAEpn3sUi1uTpit7AGYkAA4Do4exYwJ
45326	payment	2133	2133	1874	1	1	6687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC9TrQueaHdpXwd7pSFj4oZA1YFyJV6KavG6w8ctVQ7P8LgWZN
45327	payment	2133	2133	1874	1	1	6688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYUaoeHLzkjYSqXUt5w2a3ftWLfJ6k8Yk3XDBZKHeCabzXNZNq
45328	payment	2134	2134	1874	1	1	7091	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNCwsmcSf27SFvhsHtYxZ4dnsuqWDQtwX2Dn5MSU1Uzuovq54B
45329	payment	2134	2134	1874	1	1	7092	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG6fRJxR4S3WYDT6uHbvES3eSF62qg2Du1A9awdhCqxFPA2HdA
45342	payment	1397	1397	1678	1	1	16881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2odEvmrnE3WcTqkZqm5iXH2vxr3mwJ9druGhXiBrHEVWHLuy
45343	payment	2134	2134	1874	1	1	7097	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiR8r8TkAAC7TutC1Zfb15JEqFJpZHWvenawkQAD4SZKq5xQ7v
45344	payment	2133	2133	1874	1	1	6693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsV9m8nPvpSUyJT9e74oV81uQBEgwgtPGSoTdNC36g4Hafi2Ck
45345	payment	1397	1397	1678	1	1	16882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWRy98k3cW3wWvWUCAhvmXDpufPz2iRAGPDV5K2HR7969CeJU4
45346	payment	2133	2133	1874	1	1	6694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHES6k2Vii4PPooGsSc31bQBdaM7htFdbAKWa2mRbujzP4uda
45347	payment	2134	2134	1874	1	1	7098	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxRLN5wncU9KAMLkkNRJLxh9koeWiA5xN84NjCBCCqQPnRoBR3
45373	payment	1397	1397	1678	1	1	16891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmFgAe5WmY2w1Ahr6kP7cknvtUJYiLrg2tu3AmemQWRfWNhsj
45374	payment	2133	2133	1874	1	1	6703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5vRFanfC6qSnvHcXs5XyJVjf8quHcyHNTCfp7dyNPeTwRhJP
45375	payment	2134	2134	1874	1	1	7107	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpq81agnUNBeL4GWhujd4n17xEmeKvFQWcMdfGSgAGcDT2K9s
45305	payment	2134	2134	1874	1	1	7084	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsys5pXCB3VKc2WC62Me1Qiaxv68mqv5LvQZmN2dgnfcvzTjX
45306	payment	2133	2133	1874	1	1	6680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsfyG2tFyw8vDLRL9ih48Wgeq7i7EQDEzTkPTzAdC1fUQSV6SD
45333	payment	1397	1397	1678	1	1	16878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpPPKzsKhMbSssC2mMxscC3RtAQsU6rXLgwC5Vfpvq9DA75BxQ
45334	payment	1397	1397	1678	1	1	16879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ59K1zzu74GnbP9gCE39i19gpiibEo4KU9eJSSxRpe5AgGJ3F1
45335	payment	1397	1397	1678	1	1	16880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVghAWNMh1o9tJjEJYqRbhXnXsWkB5kz8PxNsk5p3QftBFbAVx
45336	payment	2134	2134	1874	1	1	7094	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLM2sMK5iAGrA8xPttcknfKEmmkbEZf53TLbVhqxag56ge4Y7
45337	payment	2134	2134	1874	1	1	7095	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf4zWPHY9i612zfdG9U5euAJt4UXrjpuficWAz9HCZfBYRheNz
45338	payment	2134	2134	1874	1	1	7096	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzFnFbXYfDxrTfwnXVQS7g2mimetfQiS21GhS27oEdcvYVrZcr
45339	payment	2133	2133	1874	1	1	6690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtDXCe3EkwJY4GUiGWt2imuWfC1nYxEMEDkS9UYpDpVUUsR5tG
45340	payment	2133	2133	1874	1	1	6691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpCCMqNPbWyDwWxaMVegnZ9Q57rxwzXWhGSP93uNqdbwSSquLP
45341	payment	2133	2133	1874	1	1	6692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXajsLf35HJYfRdMgbPG1Gv1s7QT1XVJ5zyhbiDrHfpbKTg6cW
45351	payment	1397	1397	1678	1	1	16884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYzoMasLWap3SuwhPFMp8j8n14cwLp1AKfJVaJq4hmGC4GrbFr
45352	payment	2134	2134	1874	1	1	7100	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRBgBrjXVxTE9wyZ374ZHSrrPL2n7aHHzcziNUCdvu9EreyfTS
45353	payment	2133	2133	1874	1	1	6696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfMFMrWbXJ8XhPa6PrkeUNczH5vchy8f1PosjYhhB8rFzQkaF4
45354	payment	1397	1397	1678	1	1	16885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ33DqLGP9FvTbr6BsthLjPYm4t4ZrL4XVeVAtWfcvqx6HHKyD7
45355	payment	1397	1397	1678	1	1	16886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZCquRQDPEsUuoxLCT9ERmXQDoAqFZHtAx4Qk3C7WAZ1QZEqCF
45356	payment	1521	1521	1931	1	1	7	2880000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiSsw2e7nHYiMUsjuXLaJcV3QT6DXwbpsitkhWXn4dSvqD339
45357	payment	2133	2133	1874	1	1	6697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB99b1ee1wgGiyD8HqhrchZTP4u4ocnAbGTnBZ3vo6dBeKGWqm
45358	payment	2133	2133	1874	1	1	6698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3afg48V2dHy9NB8j7cG8fXfw4wEjVWM5X9ZyJ2MR8CddQsvVt
45359	payment	2134	2134	1874	1	1	7101	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTzWtCsTyTuGxbvja4jx82DtsigiNgf72wd5G4wgpBv8vi4iG
45360	payment	2134	2134	1874	1	1	7102	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdVGvZvgLHCHVbMTf2cTxqDnhxA15bfEY43nKZT7usb5pNzAJ
45361	payment	1397	1397	1678	1	1	16887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeeQgxB1BcH8S7BA7abhdwGqbtWDZ5thPQc4PCobnSSZnXb4q3
45362	payment	2133	2133	1874	1	1	6699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZEKzfYQfd2VQvh3AyJWXcVJVNVx2r7M54QMMdTA8MQdvSbe6
45363	payment	2134	2134	1874	1	1	7103	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaANjpusmhciMms5jsxTGxFabUotxHBzsvmot64kG8ZuuV4bxgz
45367	payment	1397	1397	1678	1	1	16889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5N3psnR5mhj3kgaTP6vyyxGQdH74XVvCqWDbTvBGYR5H9FPbX
45368	payment	1397	1397	1678	1	1	16890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfoJYbjwBw5NV92dGoE3cMsnPTex2pE7bM55w583oAwekXCG3C
45369	payment	2134	2134	1874	1	1	7105	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV32mQGqvkmytn4SrWfLp7Ha4grKN8wY6BRdQMLx3UEFR2oNet
45370	payment	2134	2134	1874	1	1	7106	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38FQG2bUeobMqpyUENG5ABoCp93nnuSzNeax9yrFfEJJSJn9D
45371	payment	2133	2133	1874	1	1	6701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtGKYB7VmwaJ2S98StBktH2Lf5ss2ZRBRgFUg8VQVwcNjcaLJd
45372	payment	2133	2133	1874	1	1	6702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2rN98tN9socpd97MWzTCwDutydMkcrTRuPUAu96wwrG5JAH2C
45379	payment	1397	1397	1678	1	1	16893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55J7sqWN8bSR1XZQBBNKZ3pRAx4g1xWVKLaeBczw5rVuQDpNP
45380	payment	2134	2134	1874	1	1	7109	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3hNBBbGXq4m2Pdd9eTM5Wyn7N4H72cdFS7kiTUU7dDrUYgJ8
45381	payment	2133	2133	1874	1	1	6705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpJJxwFAfNzDvjMTH2rkGt2oJFNy4MEpc5K338TG75x5Ncffa8
45404	payment	1397	1397	1678	1	1	16900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHXgmpUG6dgbkEqiogxKru6Hs7CLaZbeYMNseRykZgXiUH2pT
45405	payment	1397	1397	1678	1	1	16901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW1pAPC5jAJAQeKzKDLDt6kzCGT4k1LcLM4nTHjdV6BFRj3ay5
45406	payment	2133	2133	1874	1	1	6712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgX8bbFMBA89Fvqn6huXEXSPV6imSHKDSm3iB14YtVNnN8ooN
45407	payment	2134	2134	1874	1	1	7116	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi36nmLXDqD2LxJUb9uBwC8YADuk7ZN166AuohAdZ1u6Z3GqTR
45408	payment	2134	2134	1874	1	1	7117	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDpqHZJog1tEcANRtechgnLEsTtuwo14qUZXpiup5cn5WZxDg
45332	payment	2133	2133	1874	1	1	6689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbM7zHkXVNpC687pjPdLhc9QgAvvpt2VLSW1rabB2YWd3eU6oq
45348	payment	1397	1397	1678	1	1	16883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtYJJzjr9KWFQuetfYhhfoAwvD8C1TS7iCJiAUMcoUq35pKAmx
45349	payment	2133	2133	1874	1	1	6695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8UK8u7Nbu3Rt2CFCWaGFo8n3wx6PUxsqJnFbsYspL4WRL7Uzt
45350	payment	2134	2134	1874	1	1	7099	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGUNrQJhghM5rqWncG2c5FitnAdk3mcuN7JexAiwbKBVL3rFge
45364	payment	1397	1397	1678	1	1	16888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWkU8BdRcwKLjbAuctUTiAMYpohUDBbFZFeiHM1GdGSwYJY8uX
45365	payment	2134	2134	1874	1	1	7104	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjcEzcGr2Ka9GVWCFbaRAN8FQhGWxS6hWU7vVaqn8fDP3qaAwR
45366	payment	2133	2133	1874	1	1	6700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa45mWUtoASv6uNDgHrvYkQezF3mJBVEZ2Bk3DMLLU2ALKuUkoT
45376	payment	1397	1397	1678	1	1	16892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvJ4BqWBZn7zbxugY5Xuizva1KnJYw5541XziH2E9k28B11ZL
45377	payment	2133	2133	1874	1	1	6704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG68bYSbcLbYLmsXARAeyVBAZjL6NgQ6hXnt6cL8TPmvxdS5sk
45378	payment	2134	2134	1874	1	1	7108	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6uCzw9g62mjRTb8eoBHWVkSAAERFUn96r7aZUvc5BK6Awb8Z
45401	payment	1397	1397	1678	1	1	16899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZaPyc8Xv4NWU2p5jaQoXtK52vn7DGeWBcekwMu4yJG2gKRBt
45402	payment	2134	2134	1874	1	1	7115	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdz4oYqaqHLCjK7youGkruEa6xQJbgwPhqiBdBhdTMC8tVz8zv
45403	payment	2133	2133	1874	1	1	6711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBZJQQXHjCrxX58L8RHAKVCPcz3VYqFMWvLqRFSKsXCyHHvPv4
45425	payment	1397	1397	1678	1	1	16907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudt2d7cwifSiNyrCQDuFdHFQLhBjpMZ11eawY6kiCgVFGjzGX
45426	payment	1397	1397	1678	1	1	16908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNRYy432WY4wsXELBFUbBjpsvaEeVzQivhsDVx2t1dzGUbc4eS
45427	payment	2134	2134	1874	1	1	7122	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAnaYFJqa3H9hh8kUfDRAmDLdcrXPM4a6udi7k9kY43gqtDVUq
45428	payment	2134	2134	1874	1	1	7123	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNfuAhwzZ6AGH89fqvbRTDyLKqdciPVRm5oCYkwmfsufb45H3w
45429	payment	2133	2133	1874	1	1	6719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSw2RsHjas3wjwh1VJyW3XyDkKTXhWb7YXxnGfw4EJbv33FMY
45430	payment	2133	2133	1874	1	1	6720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEyEQTkkyALA1C7ahPJuudwoyHsSNrJ4E1cRoP6Bnr8BT7NERe
45437	payment	1397	1397	1678	1	1	16911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRFsH9YwrJyAAZrPc253a9VpHJQhcYx16cN5YhwR3QQsy2dGNx
45438	payment	2134	2134	1874	1	1	7126	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnz2SHK1JLF2WYRuAixXoF2kvq2CWWguQEgZUDACh9EPQXXmFU
45439	payment	2133	2133	1874	1	1	6723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqUiHBZx3jvVVnuK5jmRiFMX4vBeiy9JPVjuYubJRgZh282wbc
45443	payment	1397	1397	1678	1	1	16913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9vg21FdUQs7Fcf6Ef93zpNuHS2vJLqNnGa6TUauhGmwFJX5U9
45444	payment	2134	2134	1874	1	1	7128	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2BdBrATFv2CUBYJZ1mhn4Dq1dfTcnz82pnvUwobVo3ep8LBt
45445	payment	2133	2133	1874	1	1	6725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGL3CUHMubrDuXKHT35QtVW6TgMTTit7W11KcWGompophaUWMk
45450	payment	1397	1397	1678	1	1	16915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXegu1Lfgv6nM77xknyycfut4USo8f9wWRfMQgGZsjoBfHruY4
45451	payment	2133	2133	1874	1	1	6727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZXr5sSbLyTR8FBsUM856zvxVJ2bA6QE7U7ReVvaCYL4e4RW2Q
45452	payment	2134	2134	1874	1	1	7130	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMuctBSJu2ZhHPbo9rkTEDvWj1wYaGGcwCSjyoyrq3iN8Mabp
45475	payment	1397	1397	1678	1	1	16923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaLWNwfbpPT58et6hq7dcpFLRw2a3gVKhRTJuenfK5JeX9Hf9i
45476	payment	1397	1397	1678	1	1	16924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoaruM3dEW2yGACQXobgkdBRCF7SFNqu52NVwwC6rKJyvysnrz
45477	payment	2133	2133	1874	1	1	6734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnP3NXWJnGSKk3Aug2jx1oQvz8aeopJebxyxKeC8cY6znqLrK
45478	payment	2133	2133	1874	1	1	6735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQkhGRn2hE6Gx5PhQ2t7F1SEjV7Wj374aeJXrQohQCruwnxB1G
45479	payment	2134	2134	1874	1	1	7138	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2VGXaXNBqmdYDPdWJozn925RdrT5nvWaanrVNfQUjiZNFx4yW
45480	payment	2134	2134	1874	1	1	7139	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYK4GT9Xau2iJ3wa5sMN3qE1f1whUZaZ1eBJ89LBxoAiCWSDx
45491	payment	1397	1397	1678	1	1	16928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1eeGCw7ZYS1dzhb2R4knmAvmTsTJkjcUTTT1AMixbwYpHLucZ
45492	payment	1397	1397	1678	1	1	16929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbZfNkMa6z6yCtNcjiy22MTPP6tCXrCETPCFxvr3Wwc44bUaN
45493	payment	2134	2134	1874	1	1	7143	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQCdpcfkxHYqMwVHxja1eXxZvLCmTQcWs3Z2Kra28HUsQy36FW
45494	payment	2133	2133	1874	1	1	6739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh87Xyvs4GNg6His9uDgzxYSsKmKCiYYzLzkhB46AuD9wgfm2e
45382	payment	1397	1397	1678	1	1	16894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkxQMdodk8mJH3jcLKw9g9jw9jd3qG5YqBCTQikTiFvGcw3my
45383	payment	1397	1397	1678	1	1	16895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKEGBpT6HmosZ6EQUDhHjuQ3jkBRFv5FWtD9eh6ZLxwxwkPMJL
45384	payment	1397	1397	1678	1	1	16896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvmxnuuWvv7hqXrGdVvvYd1Fbaudj4WDSmZXTd3jzZ1mw84X4
45385	payment	1397	1397	1678	1	1	16897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujTCubv1nnTJn8fxo2hedJrDqyU6TmMXjg9ecJj2F1kE3CxVk
45386	payment	1397	1397	1678	1	1	16898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzbHEENvZLQoghSLR7xH1iPQa83GSY4asdJ9EoA9GrEhzpAnSL
45387	payment	2133	2133	1874	1	1	6706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq79D85p4ZFLxvy5hdQ6MRSeHb26hV8RtEiRakGycBqTCoQEYp
45388	payment	1726	1726	1865	1	1	8339	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYrzyH93JK1FWqCAXSLqtiQshMRsm2FLAaQXVGGA89p6xPhprkQ
45389	payment	2133	2133	1874	1	1	6707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ACQHGHMQb87VTyGBAFBzDA3wHu4Vva3AiuZoiAmMgMQRUAa1
45390	payment	2133	2133	1874	1	1	6708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3w1fGJXFCzMJLfLL4MNSDyfMcfSsSiEmziX36h8axMatxwnkn
45391	payment	1726	1726	2387	1	1	8340	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZ5YsDoLMZXpbZLcnEmwAbqXGshCWSVnRn8NuK7HoRb9kNPXQeN
45392	payment	1726	1726	2388	1	1	8341	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZRubX99rPLA1Rz54Aqt5DdauLkpCVR96KEPRjxsgvpi7rC7Toc
45393	payment	1726	1726	2389	1	1	8342	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYx3eW25JE8NKZ7FWwxdJFF8qX7ZwoBzw9J2zjguQqY6dhKuH7p
45394	payment	2134	2134	1874	1	1	7110	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1hd4Fj8pU1RdjeN9ksGnDK8F6tpXsoEpbustKMTw3Knp8SB9N
45395	payment	2134	2134	1874	1	1	7111	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uQ26ny8JV4WZy7adMRKrPrkSdvCUSzEjVqB9Q9Yk7W9P3TNy
45396	payment	2134	2134	1874	1	1	7112	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgN4JzLH1XfjT3Q8SuEUJA2Gn68gz5tQtW3FVEBgUeK29L6j1
45397	payment	2134	2134	1874	1	1	7113	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVFC8ZiEbCaPohHCs1DvU7QsJKvRTk3MSKq6MCKzAQXfGAqJJM
45398	payment	2134	2134	1874	1	1	7114	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ijwbnWFsJ3YmXb9hqTqgJ5b9AZvsdQLyDZXrUN3D5LyPE7is
45399	payment	2133	2133	1874	1	1	6709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRWSBAuwitq1VNw89ym8kDpVvQYCmUvDbvVRVkqLhSv8icSsT
45400	payment	2133	2133	1874	1	1	6710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLpZ6CPcPUx89Dyyp3nq2B25gghxCXHA3ajXAdYgBgFnjQB2sz
45410	payment	1397	1397	1678	1	1	16902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6EsTWhjWP4J1VPwoifi83tDWjZcXJe3tPVYsHEsS3aGAmDQ91
45411	payment	2133	2133	1874	1	1	6714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo7XDwUFLvb9cSoXimxN1ughKPRpQHSLQffhUfhBtv4ZPxReZd
45412	payment	2134	2134	1874	1	1	7118	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYD4aJRTVPBgUf9twdAbqGdbXvzt31zbetsXpWcBxqHA7y7jEA
45413	payment	1397	1397	1678	1	1	16903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiQX8BQRXzs2rvCTzv66Zdb4c1s1jTcg1c3PXRT1hjU9dK36vd
45414	payment	1397	1397	1678	1	1	16904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa57JaTeTCxd76y5FKWFSJRj1QLkFVfWYe5qd2Cf91Kq64RxP9F
45415	payment	2133	2133	1874	1	1	6715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfn7BTnbeSCLEYPC5PwTU9ZG4ju8UccRNh9pNuZgDg9SvG2XPm
45416	payment	2133	2133	1874	1	1	6716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnK7aA7qACisAhSyDwHpKQGh3wM4RdQBWTzq1gxc17od1o93SZ
45417	payment	2134	2134	1874	1	1	7119	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqd1TwVVYkntVynCAwR1Y97zAV1fTptaXZtC18Dj84DFXhNGoB
45418	payment	2134	2134	1874	1	1	7120	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZQLRC2J5ZnZBuxy8JEczi1mJ11stWEihQg2SByJPyN6LGssB
45422	payment	1397	1397	1678	1	1	16906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxe2hhwAxrUUHYMFALAGLJ2H3cKAb6kfxnHya6tSHNtuj6nWXB
45423	payment	1474	1474	2192	1	1	29	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ547jGPZUKyUAtjH8eCzMuq7zaETsKceuLfUcRmvfBbgtnbLRf
45424	payment	2133	2133	1874	1	1	6718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAg6TXZRtdA7SppzunujTVwDLANx8X5VPAWDGcfNp6vgRDFghn
45465	payment	1397	1397	1678	1	1	16920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYoD781UnnQMFe5rVhxvpyZnNsQZy9Gcj5mMPwF9ueZ8LCXkwi
45466	payment	2133	2133	1874	1	1	6731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjMZZTMqrmeQPJQ2vb3hpi3Espwvef1JXT6f6qYRLCTe6mtu2
45467	payment	2134	2134	1874	1	1	7135	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbV3SqsELKjKvaVt9cMC6DG1NJs8K7jBzAauFxcxB4a8jWAeg
45487	payment	1397	1397	1678	1	1	16927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjyJAhKRPBC6bWnH4kyxLRbZWXG2nogXWtBGYBMSZ2Mz5Uegtm
45488	payment	2134	2134	1874	1	1	7142	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkuCizEVTeniDdx4rbSArWhv6BvjbYU3xz7QRde922v3f99Wzk
45489	payment	2133	2133	1874	1	1	6738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrdTphzeXKtQHvKTQyLYduSX859uyjNiqszCuXkK5Lx8o2SvQ9
45490	payment	1726	1726	2391	1	1	8343	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpVtTfxAcnqBWJbR3GMGWTS8mm5cqevh89mpeT3sEvd6jA5CnC
45409	payment	2133	2133	1874	1	1	6713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDYC1ArkG8zPguXomwXry7ELg7RHC8GCHfC3LNZ8hzonC8Ahe
45419	payment	1397	1397	1678	1	1	16905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEKxLnbCY2Y74r53FnifAXfHBdSqtRtEKzWSixyZMF5RnS49k
45420	payment	2134	2134	1874	1	1	7121	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobtztJ8Z1wzehszTUoYKfZD7NkPc1puxTzitfKBMdFs6DWi4d
45421	payment	2133	2133	1874	1	1	6717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6S2ZQaS2HLoUvTFpSPR6fXYfbHvAxaQ3qKNVPd5BWjiojvDav
45431	payment	1397	1397	1678	1	1	16909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVtsyCAjGaptDqxRbhZvft15x4sMkSnpDfehyF2dQte1tDvHM
45432	payment	2133	2133	1874	1	1	6721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdJjTTYKXK43sMJnuF1sCFQX6eFXGEwmU584bz2ve8YKt36sXc
45433	payment	2134	2134	1874	1	1	7124	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEfd3xbXd996brYeDajCnrLgSqmxMtJPaTbrS4Y56Xsf18LaBo
45434	payment	1397	1397	1678	1	1	16910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa46vJboKGYmTBFkn44h8Q8QegKuKG4G7dBfU4YDLL4NJZKfJeb
45435	payment	2133	2133	1874	1	1	6722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5a2qDBvg3UuUrCkjsvTVNdteGJTFBzGAYciUXbf2BGo4dh9U
45436	payment	2134	2134	1874	1	1	7125	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeSujd1qQ5iqRiq2VX5WXQNFzp711GdsLU6u3XNTqds8pk8TMj
45440	payment	1397	1397	1678	1	1	16912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ZBQBMWhVEpuZfuZCgiSyETWjLN4qWULALPFqPoLEQw6w7mZv
45441	payment	2134	2134	1874	1	1	7127	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXuTZ21MmkzoL83DJaGzT5FGipQfwAm2RWkZhKAs6W1y3AAi7
45442	payment	2133	2133	1874	1	1	6724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf9FUxLHo67hwxnYi7fiZ4BoSoPBs8fgBzd8Xx1TB3Q6N42Ztc
45446	payment	1397	1397	1678	1	1	16914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBci2sMFxUAM3c2Wqoy2gUVVKhNMaD5H2M1ksovu3dWyvk9SMQ
45447	delegation	2199	2199	289	1	1	0	\N	10000000	\N	E4YhEahnSRexdoJXcr6exArn6qvcafbWdvicynXNWHzD2j5k8yCWo	CkpZVuPnv6r9tLQT6HAzpxi8MjGJkH6FVmRDkrH1hUE1hKdWKfQ8B
45448	payment	2134	2134	1874	1	1	7129	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtdBQHtxrMoTCgmJU4HrgCPwLDWAWXDgj8wiKviDSMaNQq7g4
45449	payment	2133	2133	1874	1	1	6726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDcYmnnediDCGxpP3qxt5f8Hxhj7wwgeqQWANWjkkdUdrQkfW
45453	payment	1397	1397	1678	1	1	16916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyd4UbC4JdmDc2dhAdPeY5RxcMeySiuysjWPDiAK9ES4wtNNJk
45454	payment	2134	2134	1874	1	1	7131	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHPdbX84cV8m18YuJ3qCSFFWAQf4HfEhq82Wa1Fbh1Ps89YP2A
45455	payment	2133	2133	1874	1	1	6728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmjqD9hLek4pL8ZEGS1iw46eh7s1mueNfKQDqPyujF6tUcU8x
45456	payment	1397	1397	1678	1	1	16917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7b4WJskJ7tiAnCtbZcBiYXSneo4gKPXKdxaMKsFMSHnpDtVr
45457	payment	1397	1397	1678	1	1	16918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoUaDv4BnQapnJhwxEMHURpjXYyQzDXXsozzmyqNAauzUibjN7
45458	payment	1397	1397	1678	1	1	16919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzy2h4Kd1fVjNt8ejYPbzfUwdnnSFuy77NXq5CA4CrBr3MJPGv
45459	payment	2192	2192	2390	1	1	0	100000000000	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiuoxnmPUcKBVJ9E4QwCgxS4FcDQrnuBMuye9SJMQEJXy3wp2
45460	payment	2133	2133	1874	1	1	6729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWKbYc91QaDB7zLmsHLJYZFia5qXAJ1dHQnv9uC812ngo7RYB9
45461	payment	2133	2133	1874	1	1	6730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1sBs8Ek2xr2TwHS4V43zSA1fR1PfcrrmeRiEPQd2fnHHpRKHj
45462	payment	2134	2134	1874	1	1	7132	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAj7zA4NrS3JvDMEct2EbA4r4VT14snt7YSn4G2aDARA4iiQD
45463	payment	2134	2134	1874	1	1	7133	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrKPvAiq99LS7RxvwTR5tyF1zG8hTUNJEPL6knRofhKra7Mkk
45464	payment	2134	2134	1874	1	1	7134	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsg9XqWvmxBYCFWbFNSUzSQJ69j3wnXSRWTQM6x1e3Z52Woer
45468	payment	1397	1397	1678	1	1	16921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVrptjVSLZZskfgKjagMzDq3FKqgYWXdpr22hc52c475kQzb5
45469	payment	1397	1397	1678	1	1	16922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmPVJoRS7eswskHr61gtrCxWb4aXG8MX3NkAJxMxSEPJ12N28
45470	payment	2133	2133	1874	1	1	6732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5xT6oMcUWxCAm2uyybwcMfrXbLh3PgaJfU2YwQtaeLrxnUaF6
45471	payment	2133	2133	1874	1	1	6733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtokwrMLKqZKkZV2g52smyAQ1vQ8pgDrvjd6rHSYS5mJfgvBK
45472	payment	395	395	1760	1	1	2	299000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ815ZTPxmtfk6AmVnbY7Rz1VAj9BAR2Ffow5Eta4eVPpmcvsss
45473	payment	2134	2134	1874	1	1	7136	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx3YePsH13Fa4gv6yUQnmoSqsM9EzSby36fhGoCWtpgKxeCFvM
45474	payment	2134	2134	1874	1	1	7137	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cNvyRHzDebX558wn9YZJsWcQNanJUPQPGgdQdWGo9VuXMdJw
45481	payment	1397	1397	1678	1	1	16925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtb6fo4wbeVG7FkwVPtyxvpPYEbdGKzjxPAmsvATABiAc5BWG
45482	payment	2133	2133	1874	1	1	6736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1sbb4rALst3cXr5nTuMG1fEmxpFyMsxhR6bofWTQNRBi3f4t
45483	payment	2134	2134	1874	1	1	7140	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwWNbinDRzeHBo8fPoufujKuV7wNkq9sTFk3uqLDrPy18Z8qG
45484	payment	1397	1397	1678	1	1	16926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBT9d3sSLGTbbt3pQWDAgRCgsa7x5xdqyHUPA6xuyATZ4ZUuJ
45485	payment	2134	2134	1874	1	1	7141	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhgmVrAgonZgxiMHQh2TAZF5dCSTbxmDJp1ycLGgkbACxHkapf
45486	payment	2133	2133	1874	1	1	6737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqBiXV9Ga9K2Egrnk7AEpA1hjy48QvY7hmR9GAqjL8MzFuHjA
45506	payment	1397	1397	1678	1	1	16933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXPU4tVXBR1BHkPEkwgNS8M7AsKguaa5mThJsJYawgGL9pT7M
45507	payment	2133	2133	1874	1	1	6744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMRA7Fja1nrZTbmbjjzCJEfxZ8dauHPdTZJaaKtzewLPXci9T
45508	payment	2134	2134	1874	1	1	7148	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkiDwFAabgnCZofCHMrtV7Etk5vsA8EdmQ3kkwDe7AhnU68umb
45509	payment	1397	1397	1678	1	1	16934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6QGQoXrMxUb4sfjk5fHuJDQAyqDmHN4u7czRAL1n9MLzUiejA
45510	payment	1397	1397	1678	1	1	16935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM8pC5h32tN6bHtMhWWF14t8hwAAyUMaHe8w2pfGmR32icjRLk
45511	payment	2134	2134	1874	1	1	7149	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5ix36ug65CrFmvZYqBsSwhjRD29ubvkWhdS5t4aWfUmbuUyf
45512	payment	2134	2134	1874	1	1	7150	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KHuUW2mutU61JTMX94XPyCvr7jumtpXWkkyG55tDFPA8i9Fe
45513	payment	2133	2133	1874	1	1	6745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQmCyad8wqMYd97kJUxaVJpNYE7SH8Audxtw5kSM1psRiUrML1
45514	payment	2133	2133	1874	1	1	6746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRSrw65Qpn931H5yeq9VmJup58KiXDyTCYSyc3QQanCPmUpR6
45521	payment	1397	1397	1678	1	1	16938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzQwPoctffdAAKs8uFwszv49NRkPfN7ZcH1G1rbxNPx74KGkj8
45522	payment	1397	1397	1678	1	1	16939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyBVM8Mxwmj3fBP5qQuX4ssYK1Vvba5Uey4eVic93AGeU3iit9
45523	payment	2134	2134	1874	1	1	7153	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeowDF547Bshd2wcMQSirM2PSdPx5z8RUoxLvKKmMJugQtiVqP
45524	payment	2133	2133	1874	1	1	6749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1urcgsyvse8tgwF1NtL8Du62kA8QorSDLToVXtg6FAL8NRx5N
45525	payment	2134	2134	1874	1	1	7154	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ToB1bUe7bQUXqruhL2bBJ4gFme7k14xZ36aTsxek7QVnqCBm
45526	payment	2133	2133	1874	1	1	6750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsoRV73EJ1rZ1YsHcQaNfrKNLett7ZVd5cmuL9SgZfQ3ivCMpQ
45536	payment	1397	1397	1678	1	1	16943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdWKYycXDkUVJG7MS8ojwZpqti4MXUTghiv9WP9epBX8vR9dPT
45537	payment	1397	1397	1678	1	1	16944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnR5zWz5QzTGw2haWYvx5rpaP2PkWeAPUCGsV1GxYXt2k1Rkzs
45538	payment	2134	2134	1874	1	1	7158	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxjYWYg3SrY2c13VE8y3VSh5GyEoBNioubhbsenJghzxbT4w1
45539	payment	2134	2134	1874	1	1	7159	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuRvM12MVb1KwsudLXgndPnBRzmASqYbnyooEqtQUETyPCHZqM
45542	payment	1397	1397	1678	1	1	16945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkjfpqfd2cz5H6Bzki835vEr23RGRHxtk7jWcJs4DVsx6ULQ4
45543	payment	1397	1397	1678	1	1	16946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJzvv4YkoZKCrMVLM5LrQwpaG7p1Vyky9pxFfMgCqn6goVyAZ
45544	payment	1397	1397	1678	1	1	16947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyQAiH76WT6CzPizMg1J2FH99Q46RQkFdNjXhCKE2RWc4h7EHX
45545	payment	2134	2134	1874	1	1	7160	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQNt19FvHVAupnNV7h61SKGnrAdyjeuF58y2hcrAxAbhQEdssE
45546	payment	2133	2133	1874	1	1	6756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYLUB54DRhMGBUkwqAi3y9ApGBGp7TfYLe1HhNFxwSBrxmpUGJ
45547	payment	2133	2133	1874	1	1	6757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK3Fqj15ec8beuSEmFyrMXqvSA5v6aRPNJdaCBGkLNvXaZ34vH
45548	payment	2133	2133	1874	1	1	6758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYavxowJZwTDiaSgYUEzAbff2LEaWjPN7zy53PoxdPz5SycwcmP
45549	payment	2134	2134	1874	1	1	7161	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxW2LKLL1Ny99ozNwLJFpSuEj4Fd8pCTHWHBtEBisY6jjtAB8k
45550	payment	2134	2134	1874	1	1	7162	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdmrtpB3M4PZknqfAmm3aQ5xZLvihM3UHSwpBkLHfh2KuBAXQX
45566	payment	1397	1397	1678	1	1	16953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4sgZTUjANs54bFkZaFBhQjNbipMJXCwtJWGHRZzZjuK7tknL
45567	payment	2133	2133	1874	1	1	6764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwjv1GeonLxUssVpeMcPajzqBbnTARKPrSm9PN2crWC6JN9iC
45568	payment	2134	2134	1874	1	1	7168	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB1SkQ6DvtmPh5dfyUoQvcgPehjwPBGJtBrcpvaT6nVmYCKffT
45583	payment	1397	1397	1678	1	1	16958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTjqzRPW5d5J4YpNK5NoFZ6oE4uTCfWcL5hYcHn33bo6bv9Rzp
45584	payment	2133	2133	1874	1	1	6770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ7Kei4dfix5aFXAUamt1RYJ5pSRqrCCKHZPBBZFXhBjgnPQFo
45585	payment	2134	2134	1874	1	1	7174	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVvymrbAApgRww8EbqQ5WFmC4K1Q5xub7MbwxpcgRm4TzM4hi
45495	payment	2133	2133	1874	1	1	6740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYqTuTNspfHeCunbUJMaGppm5kMvw9BkzfMLnC5HccSq4ibTV
45496	payment	2134	2134	1874	1	1	7144	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa79ioKsyAWxCCVM1KGbxNhjRCVxHi12RVjQGFPs9q5Eoc5xp4E
45515	payment	1397	1397	1678	1	1	16936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8aEK6kbQk9g1VpW6A7me8NPS4svgNXG9KFecuMmMc9LYcZ7b
45516	payment	1397	1397	1678	1	1	16937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaJU3sJdssax1GBv1LEAqrvRT9i5hMPbgZkSXeVLsgbFu8TukC
45517	payment	2133	2133	1874	1	1	6747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUw47myNWSX2y6aJYMCTctUesU1pHysgQm8wyw7nuGNPRtxD7u
45518	payment	2133	2133	1874	1	1	6748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAr2FDVuWgJ1ftosKPCYa8egTcznNwpDvotoRFN1mWDAhutoG
45519	payment	2134	2134	1874	1	1	7151	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9emdbAqeNDGpjRMwfC18DPJAg1axsxfwu3LQ5txg6kFBXC1tw
45520	payment	2134	2134	1874	1	1	7152	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37qC8wEJqx866RVtP4YbTTxxPfysLDMEWDwUfeuBijesNztGf
45533	payment	1397	1397	1678	1	1	16942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuBaHMCUbdSxU5J3xmVouA38ajwG7F6Tm4BSwdqK48DGrDYcS
45534	payment	2134	2134	1874	1	1	7157	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWaonBja1NYjyUrxHFfGX1FibWSSqu1LuDQeeUC3qhomLRhuP
45535	payment	2133	2133	1874	1	1	6753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcv6dLXLmPGaAwqZNFAp7MUsD8xXGCspWL4699VX55pK3V9RT5
45551	payment	1397	1397	1678	1	1	16948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1wCJAgKry3SjJvLtJb7PfZYNJdK6MN9JGYZkbZiyS3qQhbLU
45552	payment	1397	1397	1678	1	1	16949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVzTsYvd6Y8wd9KxPRZ295M7avnBuFuGJBdaGPVVxgKd1TZJj
45553	payment	2134	2134	1874	1	1	7163	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfPpJD4UKG5wwAJmAwHrNo9YGJZPcjKNc4NHKfYbEAVr62s8w
45554	payment	2134	2134	1874	1	1	7164	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrF1T8FRfRv325ZvhVoXCusuZr4wTPXBCisztRVrJQXxqZvt1
45569	payment	1397	1397	1678	1	1	16954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBm76nvc8aMDtUN9kcAA6Tt317DLtfXFH2vGAix8PQhwgrNeU
45570	payment	2133	2133	1874	1	1	6765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1thqqpQdhMw66uierqCsKv6ydFZLeJYajjjA3ZrnxAnmBW7wX
45571	payment	2134	2134	1874	1	1	7169	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLPTtJzgZ8okKrv5feuuCCYW5ikdR74nc76GQp5rwPCXP6oaa
45572	payment	1397	1397	1678	1	1	16955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotwgi5tj4SXPrRBViwqtksCWfgWmrvYmHdombgPEzRMJ3DBSH
45573	payment	1397	1397	1678	1	1	16956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuYjdHJh3sb4hAEEJNcYFUCeWnRWUVmERyiYEyHH992UHNMTx
45574	payment	2133	2133	1874	1	1	6766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MkVSLcckBQLPuKtqZpniyM5TzicmTDoKgVDWXdcVDVbRQdKV
45575	payment	2133	2133	1874	1	1	6767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJAHYuZqTw3zMmi1C1B8TWMHEpT4WgdEPnuDL4dbXHBjiEffzM
45576	payment	2133	2133	1874	1	1	6768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVV2riTHuuBt8sNpocBbNsG6hHdtA8exhmho2B5dXXHuMJdU2S
45577	payment	2134	2134	1874	1	1	7170	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH3Lrzxhcc6FPWDVJ6qVp71yKUq4BLRcgRkAc7U3tGL7W1JSSd
45578	payment	2134	2134	1874	1	1	7171	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4EwoY9uQ7MXw8e99EvSej6bFCdJW24a6SQ8Nfb2zCUMLNfF8
45579	payment	2134	2134	1874	1	1	7172	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCZ2BDwB4NQeTEtGm66Hv6XiUPKgMSs1bEcPtcdDpp5kckJVQ
45601	payment	1397	1397	1678	1	1	16964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbW7SiuEkSLpuYEvbz7hE9PP7H6A1WUprquxhDSPvJFE2dZGqC
45602	payment	1397	1397	1678	1	1	16965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ47FWPcVUD3QqAeuoZU1p35TS96WnNcYa91sbtr7Q7tkuD2zxM
45603	payment	1397	1397	1678	1	1	16966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkDNwjSDcGi9Axsn4uwt49MpQT44NaKnnXUjdie2CR6BaXunbV
45604	payment	2134	2134	1874	1	1	7180	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQTJfZE3R1x3YEGUjr6gwajUALGabmvSCneheR95FYL2Q6uKW
45605	payment	2134	2134	1874	1	1	7181	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4vY58fizjmSuxMCaRZWdRJ6RcaiSRobetJcRPYD1Wbpxmmkf
45606	payment	2134	2134	1874	1	1	7182	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoMBgiH5VzhUFysFJvV1CSk2yWA55YYYYDK8YrWd7wvW86QRr4
45607	payment	2133	2133	1874	1	1	6776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKC5LnrDkbDTSMWVAxVmhs9Dj1QceARDmwsGoNZHt1TQLkg2t2
45608	payment	2133	2133	1874	1	1	6777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHsShuUKZVKdpp2b8vFJqsZyCdrQXo2ggem8J4kKrEHPpaPds
45609	payment	2133	2133	1874	1	1	6778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeLSiUd1KU7uVNn85GMzb7ArxVapYS47w4rvG5mbvcf2SuhUS
45619	payment	1397	1397	1678	1	1	16970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKdMMZNZppJ3jukCtYqAGmum6E5C6YcbPK8nHXQcqSFo7PNpH
45620	payment	2134	2134	1874	1	1	7186	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVbTqkKc5e8mgsoxVw3rgbGpd2Ziynuazyy3GazdByEriT617
45621	payment	2133	2133	1874	1	1	6782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLVq47TJWpDegqs2ZHres8RoWG371T3y9R4VRpVCxLNoriJ7SW
45497	payment	1397	1397	1678	1	1	16930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCXNY7J3xP5F1t8JswTzRrC93Ap66GsckZSbvHVn4rr4PPUVY
45498	payment	1397	1397	1678	1	1	16931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe215oerq4CtXkYLLzzpoKBxm188B45dxAZTXzf5AyDZtex3Xc
45499	payment	1397	1397	1678	1	1	16932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzqdrBBwP5AsQtjzx9Bs3jxTU8oipqm61biJQruM1aHfstzTnu
45500	payment	2133	2133	1874	1	1	6741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6zffTYhF2jwNaKyuSo9trNfpEEznrgRS538PgVrwpXAhB8dtF
45501	payment	2133	2133	1874	1	1	6742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUM3mi7w4q3bPbKKS98X2mPYwfUPU4QZX6BSCMav4yCNrQxZE
45502	payment	2133	2133	1874	1	1	6743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQNqbBpY8J5sf8FPXjQkvXTx5brUwFS6zSDTeRfrEzDgi6dRS
45503	payment	2134	2134	1874	1	1	7145	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkyCJiN2APjDJaskqgqDofd8MmvkrPu4nUGupnv35uzBZ7c5Zh
45504	payment	2134	2134	1874	1	1	7146	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwuagveYmGtGPWrBni219tom7TQKjE88hz2EXE9kay2xyfWKo
45505	payment	2134	2134	1874	1	1	7147	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJwCAYtyarb9qMY3UFeEmfgCfyyx4p99nofmzMfnGd2PY16Rw
45527	payment	1397	1397	1678	1	1	16940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vnN2NEqCgT9sXTmgeH3ZB1a9oo6xwJpyRVaTxxYgRYpBVvYi
45528	payment	1397	1397	1678	1	1	16941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JkHvoYD1hTddYKnzwYfvCsT8nH1W9qLVhmNiDj2gWuoS3uph
45529	payment	2134	2134	1874	1	1	7155	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRwfwzj641Ci9nkhkTYTk2R5TM6zovi5qV86YTmBjhg6xoDQw
45530	payment	2134	2134	1874	1	1	7156	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHTGBrSeGxafXLYXPB4aTTZQnyq366pTLAJeJtnafEMhMUH7AL
45531	payment	2133	2133	1874	1	1	6751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWcFNPEaMiJzDUmGFdrTZsTvig5cEGvgpKSVCuPq86y9d3RA7
45532	payment	2133	2133	1874	1	1	6752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mMQu7v7qZqvKcLKVf9hNMEaaN6P5FVu99YpCfvk1sSLUMRC3
45540	payment	2133	2133	1874	1	1	6754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGTFK7f3YPQPv1AuUEFrKEz7JUadLgbv44EMjKizvNYsDF7zdk
45541	payment	2133	2133	1874	1	1	6755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgirZqX5nvercYYsH1gCahkK1VgHdbFt5n2zpkFRM6azK8w9SG
45555	payment	1397	1397	1678	1	1	16950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWkyfWasyuPsPz2eLhkLjUw7F1fJAngQy4Gv26cGtXvdSfcYT
45556	payment	1397	1397	1678	1	1	16951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2LhFdFxmrQFw3cZbBsJtYZFShzgn2Yy8sqw26JUrXXtsmnY3
45557	payment	1397	1397	1678	1	1	16952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWSEGG5bySRmJhUeBN7WvU9Nhe2Vj76g8uGHox7Q1GTpx3u3RX
45558	payment	2134	2134	1874	1	1	7165	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgQU5yziez6ZZ8AQSqXFya9fGCgAfMWRvwnVWhAe3nGE4Csos
45559	payment	2133	2133	1874	1	1	6759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUeP269XGHzFpFoNQ5AoCB3KixTmbRkBzcpFbunqVSv9twB2BE
45560	payment	2133	2133	1874	1	1	6760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31urknxY1NSHuHYPm84aqrC2qPfw3VV6CKDNRwVGQBG2jS6Ef
45561	payment	2134	2134	1874	1	1	7166	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrYJAD2vACXBYvb33oe9P9E8hC2iuapY49fYttxZgPmdvPdoe4
45562	payment	2134	2134	1874	1	1	7167	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHs5rbt2xoj7KYHfkN1TGYctMokcJmpotAH6stYztinLQhe42
45563	payment	2133	2133	1874	1	1	6761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1T8kFcCgxhP8Wv9WfbStGqYUBLjjTNsYjAYqeRvoFyijnyDTB
45564	payment	2133	2133	1874	1	1	6762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqESTjPVGbVEa4Rw4qgeTrjzsk5YwwfRPTcFtJwA4hHZdRpRLa
45565	payment	2133	2133	1874	1	1	6763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9adNx2UugRrPBQfxsSAY6ZhzheK5wWfwA5eKeyB3RhuCZkayq
45580	payment	1397	1397	1678	1	1	16957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqBAmHNvASzUGqsQMHeZCdN4nR4vH85GkYiBbZW2fzthHN9XM
45581	payment	2133	2133	1874	1	1	6769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QfeeZVGHKFm5kkg93b5WBfearuV6R3TCkT3pfUH5uqq996KW
45582	payment	2134	2134	1874	1	1	7173	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHRejVh1t18py7cWpFjADLF5cyT5CvSE8h35X2zrWhEukt8GMU
45592	payment	1397	1397	1678	1	1	16961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdWkC4GNEnLqRmeod8fAFzgd69HHnSKSY1okbUCgDXYNzJeLy6
45593	payment	2133	2133	1874	1	1	6773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSZFy6W6m4jSwyyLenbXnovdPps3Ji3TonfvdgEPUAiF86tQo
45594	payment	2134	2134	1874	1	1	7177	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLfyF9sT4fDRPqoS65MnGFmdbrSUt3cobPNizAtKPrjyX3f6Az
45610	payment	1397	1397	1678	1	1	16967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLDrRR6afGCDU9ZXrhXofaN4NohsH5DcrhMuqPnv8Q5bNXWqG8
45611	payment	2134	2134	1874	1	1	7183	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQWZxvkLK3y1VDh6jrQtEBJhmrTv3MEf2YSUsj6hqZFB8oMDN
45612	payment	2133	2133	1874	1	1	6779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfiELcZRgMLKqAcEry2FAnnTdqtnQjJtKH9tPo67RngrtwjQZ
45622	payment	1397	1397	1678	1	1	16971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZs5pGSP9LH1hnYpZ1xTBgzgCGttEfd9t5QiPvC7hNKqCZVRP
45586	payment	1397	1397	1678	1	1	16959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUnAUxDR1SU6NVF3739PXfwXY7MLU7D5YnZ47kfsR7kbn9YjSW
45587	payment	1397	1397	1678	1	1	16960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5pQxTNFVCeoqtqRXXRzPAuXtzsHuEjVYD7ZYdzyW3HXYY4U8
45588	payment	2133	2133	1874	1	1	6771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2RjoFipGZjh5QfgYZQ2G7qJt4zNozUwDtiaCJeHxeaB2YC15X
45589	payment	2133	2133	1874	1	1	6772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFXGTVw64Sqbu6nRz869MatnLyiduJe9KfUcx3utKJKLfxB3a
45590	payment	2134	2134	1874	1	1	7175	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgZ2x7xZARdSLmFocjG7Twu6hjvP95sk53bYEozFiMkXjtdsEx
45591	payment	2134	2134	1874	1	1	7176	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxAq1e6UogC8NvQhpDo2oUZxqHUZyTyGbas6uUDuxHHy7s9Kc
45595	payment	1397	1397	1678	1	1	16962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa88QtfXXdsjXGKZi9K2sGzPwtZnVtyGadbKZ6zm57Mwzkt8gCB
45596	payment	1397	1397	1678	1	1	16963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88jJMCaRkPT4QvDUbVWX31F4P1vYpeVxZg7AjtEqtbj2Mf2yo
45597	payment	2134	2134	1874	1	1	7178	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVA5DP3X2jeptF3mTcbPSZ6er8CyhTkj8TUqTANzqKQumdzcCW
45598	payment	2133	2133	1874	1	1	6774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ7JBDKMKRuzNZx7g58X1cfR3rufXoFf4tSE5AcDYCHF1ydyaS
45599	payment	2133	2133	1874	1	1	6775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQVqySw3wpf6hYa3UmhapGagUyg53QxmJCfswBSYhDhUSg6xbv
45600	payment	2134	2134	1874	1	1	7179	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJeBgfbkufcabbYuu1SJn2fu6BT3rPJnNGcweLSTu651PKDza
45613	payment	1397	1397	1678	1	1	16968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX53cDTBNjo8cuz6J42ZHvLECvhm8srEip4SiBkjgXTGwFEvDm
45614	payment	2134	2134	1874	1	1	7184	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbSRWKgRouu2J6AcGcUtf4npFeBSurToBhGWBLMULraCjTKHtM
45615	payment	2133	2133	1874	1	1	6780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbVTvT1u57gqBZUo2kmBNGKhuRfb6c59xMbPMmukoihNwYYWf
45616	payment	1397	1397	1678	1	1	16969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAxt2z9Zn7wkQTsSHYma4axKoKijVyYKPNVByXCGgZrKQX1DC
45617	payment	2133	2133	1874	1	1	6781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCb9hwafhr8BjHda6KgSpsnQU6bHcdCezsKG22Fmh2vjcEzSx
45618	payment	2134	2134	1874	1	1	7185	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQe6ZDb7oc3u4NT6RZVhkp8HjtWkfGkbDpuFtYgKWarMM4B3H
45623	payment	1397	1397	1678	1	1	16972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUpZ49whS6ngs48C3SYvZPzZqgfqsh2JZMM6661hkChp99ZCXy
45624	payment	2134	2134	1874	1	1	7187	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTbomu4MfkPHSxVXftkm8jWByrfg1PAFHJmbgJRivdZbRgsy4m
45625	payment	2134	2134	1874	1	1	7188	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCCE2Cbsg7VuAHocrnex5AVe9vwNjMhPdMVjEr12FteR6cpVP
45626	payment	2133	2133	1874	1	1	6783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLWHuAkjk8JmxyGrTfYMWUBE8AEx32KnKKViApykZaeFbLe9T9
45627	payment	2133	2133	1874	1	1	6784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMASGhXidFGJj62caYrVFqb9RoFFaenhTGAmYip8ri62ohuuQ6
45628	payment	1397	1397	1678	1	1	16973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutBFxhumxLMdvTsWcKPDQDTMeTHmjdAVD1iUMdVmVyBjeccm6
45629	payment	2134	2134	1874	1	1	7189	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaxLr96CVH4QUHjrtuxr9ktpRpZefEEuiMkReg8K7mVoDnzan
45630	payment	2133	2133	1874	1	1	6785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5mxSVwHtpKfLE46fb743fQuUF2TJFnMFXKSxfdPSNTqn2BSJn
45636	payment	1397	1397	1678	1	1	16976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphYeALmgzPvWLwurDVojJ7srmxAsG6d9mqntDUPghhevrZks4
45637	payment	1397	1397	1678	1	1	16977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPe71Hx55dJYSBT9xRYQptHBTvSzieDU6co22d2oa13R3kFQtd
45638	payment	2133	2133	1874	1	1	6787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw6Wmw5zP3J3REsCuvCb4xTo81WzvtyZC6Kyipcf5xnRBCiyVt
45639	payment	2134	2134	1874	1	1	7192	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TDU4jyKURFEnjxP1m9764LjLQ1m45zdMFv1RfN58cGLHn8WE
45640	payment	2133	2133	1874	1	1	6788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjswX1UvHYPU3yzskCEBtp8dahEkb4uZstcsH8r8HJAkJJSbyH
45641	payment	2134	2134	1874	1	1	7193	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1EtXm3vgN2JY3pV3n8dAPYwigrgsosfEdc8zQEcnZPCfLQUg
45645	payment	1397	1397	1678	1	1	16979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasjuVfjqajUdbAcDB4LKv9jfxFGq89suxGXjkXpqZKautHxYz
45646	payment	2133	2133	1874	1	1	6790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwn7UNeCy3X3BWMrYyePfC3upf8qRJwKW78hFQDHsMNbphPSJU
45647	payment	2134	2134	1874	1	1	7195	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ25EKUGKXDcGDKhH97G5WwGwCtYZMaWmxP2dhjjDHbaC5WfpEj
45660	payment	1397	1397	1678	1	1	16984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgycA2ELR5ss94GxwrBEh54mpxDxFCfVrohdeRgfnSDmgfdG5
45662	payment	1397	1397	1678	1	1	16985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKe5Na9FwoopFs5McQHcrXWoENcp7Yzn61bymgRvBqS4Qi79T
45663	payment	2134	2134	1874	1	1	7200	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVaoxtKzNxkFNXGQTrY6cAaSeHa5CqAmWPWnhxLwWqmZMFVgZ
45631	payment	1397	1397	1678	1	1	16974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWDVQQm8pw3dnEf7kRivQRVcjtofN3X3kGU1Wm5UTC1ftKyeN2
45632	payment	2134	2134	1874	1	1	7190	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYDCfW4MbF2YPwD6cXy9qi9VitfkGftGnKVQHE28BHh16wS7s
45642	payment	1397	1397	1678	1	1	16978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpeSjQzdDNhuvFEdHPrxH9qj3EoLpw5mJD5P8nxiXGQX7VWGY
45643	payment	2134	2134	1874	1	1	7194	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTY8aRTQfowAPz9nbenPyf8B59LpSgaW842LPrtqASPnQA1cdw
45644	payment	2133	2133	1874	1	1	6789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87SebD3H1AhxKx7aSuWDHS9eSv4XWjW6vUQgdoPwBDo9VTinM
45648	payment	1397	1397	1678	1	1	16980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkThyGwFusNEoYrjuz5Lpe8SuruV6vwzgc1TCrAxFZPXAFSVfD
45649	payment	2134	2134	1874	1	1	7196	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkmGDWEwUQtQ9Ymg53P1oZmJdsxHoMb2W4Rrcjg4Dkax8edPi
45650	payment	2133	2133	1874	1	1	6791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpDyEa9sRHvbYdhhea64HLBZPz7nRPzej99PF1zpDy7UQdXPC5
45661	payment	2133	2133	1874	1	1	6795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiTWuv652v2FkgXrbJEC3H4gSU2EX25x2Yb229YbrvaxBeWKH
45674	payment	1397	1397	1678	1	1	16989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA9LQoSc15pPR8mT7bgk8YLUJc7fBERVF1f5r9dRJkvoxauz98
45675	payment	2133	2133	1874	1	1	6800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgJYwxDK786ckdHbiVy8R6ojTW9v1nEw35qgTfgvuCDTGN4AhX
45676	payment	2134	2134	1874	1	1	7204	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXrAawbXeP4YxAoQH19ucQSC4jC728QX1RcfpYcFweN9drYn3D
45677	delegation	2388	2388	1560	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecj711YdWZN4zHXK96icTqGzuVUvfr848M5BHpzmhrNPCTHG4
45693	payment	1397	1397	1678	1	1	16995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCczJXjWNwCa7ESweCw9xsHKq2qcaW7QLjrYSHpNsbcMMx26Dw
45694	payment	2133	2133	1874	1	1	6806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVi7TcvRwnRA6FSh16xWvVJ3vS2Q7TArrU2ympughfCQDLYhB
45695	payment	2134	2134	1874	1	1	7210	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcYnot7kYqcMwsWfGkRMBLx9gAufQQV8eqZR1njyM5BLrZbN7
45702	payment	1397	1397	1678	1	1	16998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9eu1F98AgPWqhkJS79KSYhZXedN432ytcAFW7YpCM3arcx8x4
45703	payment	2134	2134	1874	1	1	7213	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzVxbGZuYKxAQ3vnSpxMSFeZdzfmGn7hwkBvDHyYsE7xTnQbB
45704	payment	2133	2133	1874	1	1	6809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2wzPBdyKUPGT6Vx8uNvogSTxN35jcWqUJwXCkEfnq2rPo6gV2
45707	payment	1397	1397	1678	1	1	16999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKUF714vW8r85mhz2MC2M3GgnQ21sE4bbSMYWpAxdusauv57B
45708	payment	1397	1397	1678	1	1	17000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEw9z2wjiF9eArfzyuwuUxsjNXtzFdgtnzhbUTdsjuDt89Rqg
45709	payment	2134	2134	1874	1	1	7215	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqMGpeFC1Sa1BtgyN66eEx3Ypp6rC6c9oiVQnFbUchxtLLV9w
45710	payment	2134	2134	1874	1	1	7216	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3p5T4H3RK3E3PSa9Y5RFU8pNoWkUKTQMnrYoUJHSJz3B6VAgm
45711	payment	2133	2133	1874	1	1	6811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi8tNNs4e17gzrufwxd5UVZpN16LXu9aZuNHAnzDSkTRPvTy3z
45712	payment	2133	2133	1874	1	1	6812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkdYguNezL2TY8pNvSrL69KgbjrygvdAgkgknuKQ9gUPD5ePgt
45713	payment	1397	1397	1678	1	1	17001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBUnLniQqA1eGdSeuQLcEiom3QKqF1bhgPtkjV3wbMkZErDZb
45714	payment	2134	2134	1874	1	1	7217	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaN2qF24iKBqWYMG6baGcXb9oE4M18wmd8NCxzcgKa1RFu4ak
45715	payment	2133	2133	1874	1	1	6813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjaR9Qb9pnSKuYJy8nLgrBmycSxj1fcj5bpN3CGt2Ppp1XX8c
45719	payment	1397	1397	1678	1	1	17003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmgJrgU3s3i2nFTcvvJNst6UMFbm957TiBg9uT7opCeavhNe6T
45720	payment	2133	2133	1874	1	1	6815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmuv7DwrutYTdjpdRwaUoyBGWnpmYbNL6ufbkuZai4mADRNcmT
45721	payment	2134	2134	1874	1	1	7219	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmmMCLirv2CDrJbtdPekqAWnhKiwa9q4x2LPqJJSFyyxLu7qt
45728	payment	1397	1397	1678	1	1	17006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZokA6KXEuVY24G98xZbQa5Pf8rciFTfkVLsteU7ptsyNxASfuE
45729	payment	2133	2133	1874	1	1	6818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1a7HdBACYi1J2dAmGV4AKvPYfXmjiKwLNFom1JrKmLsZErkZ
45730	payment	2134	2134	1874	1	1	7222	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEt1zaAZpVsYxTitR2wUQoWKoY77H2sgzA5LVbvdk3maFr8ph6
45731	payment	1397	1397	1678	1	1	17007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9aTjhPwLWcUppMDe5mm2dB9aqTYXntPHnMWUXfA34XYeaFyUm
45732	payment	1397	1397	1678	1	1	17008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1BaNKjnrG8fX6fkAXMkY55pqBfSVrxKYKrLyFeiAvXpEMAtrm
45733	payment	1397	1397	1678	1	1	17009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbfnZw83WaFSmoHHbceqU9jURSKX87kePFn2Uy5r5d2L2sguLo
45734	payment	2133	2133	1874	1	1	6819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRbQUF4h4ALdycTTtcEujECPacZtXTZBMdrEEfk4VVDqe1CUw
45633	payment	1397	1397	1678	1	1	16975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5EMsZ9zVguqpPW4BvtMkkz1bmTCG3ZQaD6pTmaujA7JhuRq5w
45634	payment	2133	2133	1874	1	1	6786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrSCrAjoetuiGoZ8w9A1M8WBTcEtkNcWhPUQLGu8VvMM8g6CQz
45635	payment	2134	2134	1874	1	1	7191	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt64D5H2ysetFGueiyYzbMBWvUjuq3BL3kPQjkChszMrccUZZH
45651	payment	1397	1397	1678	1	1	16981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBKf3DfTY1pgefXuuXjB9iX429ChQSf9N2A6hyJM94A51zVVvv
45652	payment	1397	1397	1678	1	1	16982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YzfyMCXa527qdLu1ikpbV7YoiXUk9f5awr2ovueTS9Qa848a
45653	payment	1397	1397	1678	1	1	16983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZny3esuYqbHCdVGzKyF1JrWwJgKUtbQ4ECFQQqqRrXg1Bo7AUu
45654	payment	2133	2133	1874	1	1	6792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYya2LfqprgZV8nZ1eVDyT1CnVK5iqoxMELVhyoWr8BHjVFhq21
45655	payment	2133	2133	1874	1	1	6793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVVEw9b2CKqKBtyXZtgtQ1E6uN8feDtZJmLqwaqLWud4hSA3FH
45656	payment	2133	2133	1874	1	1	6794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwzZnujtjt8XUgfrUijRiEj4kzWA6SGTFepEQFoZnXqcyrQ6k
45657	payment	2134	2134	1874	1	1	7197	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtzUiHSUYWHjYj6AWDi38PVYgj5ANKrFfppPVSVvLoYVtRxVJh
45658	payment	2134	2134	1874	1	1	7198	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf9UTued5gffEumJVpdfXSkagQnRnPEirjSzJr2prJSdpPUpP
45659	payment	2134	2134	1874	1	1	7199	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3hZzzsGuJp6M823Badn5cyf14mM7muCr83GHt6NKCDA5xZfBh
45665	payment	1397	1397	1678	1	1	16986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf3xFEfv2JGRUofCu1vwt5bWJC3DyWpwJdxcedbph2USLrWgPp
45666	payment	1397	1397	1678	1	1	16987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGh85CF9qURQEWomzEpFdD3mZtuAM9gZVqs1AyuJcC1CbkNTFT
45667	payment	2133	2133	1874	1	1	6797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2rvPYcaJcHZF5oX3bazqxapu7mASvE9Sf4DpFqUR27t4k3Eq
45668	payment	2134	2134	1874	1	1	7201	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHL7roRWQZyJivKNevL1d6j3g6xCbqPdF29JGXWGFmDuSJPtZW
45669	payment	2134	2134	1874	1	1	7202	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3YpjJftM3phokuy9oSLsUN1T6p8JYw9MH2rM3EqharpTnPo3U
45670	payment	2133	2133	1874	1	1	6798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtZpJo6QzC7FCpxmA7SVQ598yLDguiF5kjrEjhL3FZ9mR1nMf
45671	payment	1397	1397	1678	1	1	16988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRXaPhVaoobBAwqbjUaMjimQvxhzLXp4t5rAKwcqK46eqfPn1
45672	payment	2133	2133	1874	1	1	6799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYannnvHrEa9JXspjC3cW9qVeiW1Ausvdvq39FexDWMvRbeJJvH
45673	payment	2134	2134	1874	1	1	7203	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ZeCTLxq1fvSbQ5xLBDr8vcPGuRHeTEFNJFvAQvkRZbSxs3nk
45678	payment	1397	1397	1678	1	1	16990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrAoD6Cq3vKnEFH4J9tFLSnSKimtxPYuHEWUVKjwruQWrWW6ye
45679	payment	1397	1397	1678	1	1	16991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD1MhvvYMWEUVf6tjuiBRUovmW1jMCr1tGW3YmTysLZDXkJWsK
45680	payment	1397	1397	1678	1	1	16992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnKPDP8kpHhHkf42amDxLjCd7kEsuwPZYAmHLJeewcYCq6DjJW
45681	payment	1397	1397	1678	1	1	16993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFEjzFi3N7CVK66Y7LzmxRYZB7LrumSMdEdYQ3B9C5EyKdHjV
45682	payment	1397	1397	1678	1	1	16994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgkicJvS1Cm2BHQa19ELoHbcvAtsLVfeWopg9aJ4wZQu5Yq2X
45683	payment	2134	2134	1874	1	1	7205	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcW3CpynaWdSZWebTrQ9wXQtpCXEoA62tDixDmn7pBXzZCZcw
45684	payment	2134	2134	1874	1	1	7206	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHXu4fizUkyTt81YQuKwcFzQtq5AVQNimfGViVRZ7vWJkJJPh
45685	payment	2134	2134	1874	1	1	7207	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhuCqR33kgQCXaikf9omNfKDt7FcWYdzusdUKKgJNJvx5ZxMC9
45686	payment	2134	2134	1874	1	1	7208	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTmLdKVULa68ejgnpmiub3AAVXV4Dunid8FnY5PkmSy9LtSuhN
45687	payment	2133	2133	1874	1	1	6801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyDkik8GY2MR42JA2z4WNUH9iVVYn4nF6uhTvoyEoMec8vstBo
45688	payment	2133	2133	1874	1	1	6802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Jc48Affk925iFuhARQrHutwfNzZNgABz1bHo9K4T3uUZMQJi
45689	payment	2133	2133	1874	1	1	6803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZVbzjdQzY79xpBXrAm5aQ1MWVHXpwbg7XDhqywL4trp3YRde
45690	payment	2133	2133	1874	1	1	6804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7AUZCFhBxWMfenTUBuGKmNmhPeKGmkkey7LCoEMdQAY5M7zb
45691	payment	2133	2133	1874	1	1	6805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQzEcG6Nf6B8AnGstXevTWvPRJ7B4utFqqFnxzeMpu6nNnni1f
45692	payment	2134	2134	1874	1	1	7209	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJBu9wDdnXLHNaDgdi7XBynDmbb3daVXLePjY6aGv2rr1yb44x
45699	payment	1397	1397	1678	1	1	16997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQ7Mqic9njsUdDNYuU1dyQq7Gabp8HtxEeJxT9uq2apZJhxCs
45700	payment	2134	2134	1874	1	1	7212	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeXzmi9SBSJdfqTFzMBrXgEwHbdBg3mNUDJDxkDGMdSdA73hR2
45664	payment	2133	2133	1874	1	1	6796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovzUhDHyVoxdUNjCWytLYARXWYU9Eqge39y8WSFHxfUgoMNod
45696	payment	1397	1397	1678	1	1	16996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6mEGk2ejZcVZTS5bXxtDcjXBm7YYdLTNMd3A36Goqn7z66y7a
45697	payment	2133	2133	1874	1	1	6807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxW2o6h3zPzqe5SEpe1XXEBwLqG3kG7psadVz9V6arYHt5jmzt
45698	payment	2134	2134	1874	1	1	7211	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJjov3JmjFjshts5XmoVW9G2Q3LYyLDHRpDvNcPqFNXUyP1zT
45701	payment	2133	2133	1874	1	1	6808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqY5iqC3JgDDUKvoABWnQMFX2CZFS2zW2Esifm1GiurXMgfBa9
45705	payment	2133	2133	1874	1	1	6810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTScn1Bc5d1wV8btobM3WzuPsmUse2zTypSmShQFhn3wFtYwj6
45706	payment	2134	2134	1874	1	1	7214	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVqT2H5rUDKxxcDqwWekmFzvCDgFw9enJfC21qxG54uUsaVYQY
45717	payment	2134	2134	1874	1	1	7218	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXL1b4CryFQQJ6EsD9Hfy5EhUsACwkgu1scZAow3DNqcAnw7e
45718	payment	2133	2133	1874	1	1	6814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMKZwL8rxmGfPPQVMCsRs3X5c7X2TeGokdB9tBQzmTxpxYPgu
45725	payment	1397	1397	1678	1	1	17005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4hno7L1N9XLzBVC8cbEkoF24xkZjDJLzFH4zJrAhfMaLvgak
45726	payment	2134	2134	1874	1	1	7221	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBwha2gwd77Rnh5zHtDVXuGvefu5qyRcigAoFz95M73XuTzM2X
45727	payment	2133	2133	1874	1	1	6817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeyLKkw2db2sJYpMsj3dfswHk1sHNMurK4EkXwhP4Lnv5Ak9x
45750	payment	1397	1397	1678	1	1	17013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdcs9EuHB9wAS3csejgFAUfTBiuskx9MEq7PukNbhbEV9vDHic
45751	payment	1397	1397	1678	1	1	17014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5CHPaAZe6Nkq98ZW5ne9GE5btb5hFgKjqLadSPd7twygqGkC
45752	payment	2133	2133	1874	1	1	6825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvbujorM3adqLfNoXGa32sQHvEkxZtzWsSh4Nbsam6WUY8Jpq6
45753	payment	2133	2133	1874	1	1	6826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSnqHXDRV2bbUULELXkZhNuv6yKp1sA9nhRbViFvMMc93Y9F6N
45771	payment	1397	1397	1678	1	1	17020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3fT1fp1pAxzyubiqWKCYRc7RpqD8ZyFRh4McS26HFhrHPrgc
45772	payment	1397	1397	1678	1	1	17021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUsGbHZqgT3DtoQNnoYsydu9isHjxPHHHLnXRreFnUGfiRivL
45773	payment	1397	1397	1678	1	1	17022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ih5g5mxQikoMDPMy2VaRw3QwuuMT7pJTnTKHcrmBAv9KyR1z
45774	payment	2133	2133	1874	1	1	6832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvnUsFh5SqACDHDWjW4WYfLvFsJt7wNUjf5vhvLEi9VvFbNrTK
45775	payment	2133	2133	1874	1	1	6833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4uHafWRGj2FVfT4fiXioGqDX4erqGhuAribvtjkcwjsxbvksh
45776	payment	2133	2133	1874	1	1	6834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6FRozK8rfXjTMrjH8xs4F9DA1gaXDagMTsZqC2M5cPTBMnjek
45777	payment	2134	2134	1874	1	1	7236	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZwmJ1ohAWKPAn2ey5GZQ8sfKB3J7saLNX5336nTy1KQZjQFX
45778	payment	2134	2134	1874	1	1	7237	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJ5dGgRMiRdiiikBgihHW5wcM9g4aShiCYtdA4WeHdongW7YU
45779	payment	2134	2134	1874	1	1	7238	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZ5oiqjZaUSu8GCEteuXfZsdhfciKBVf1MLAtXo8xnM66YX9B
45780	payment	1397	1397	1678	1	1	17023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ99rsYjAf8FRhomKk9SptR4Du3AfgALA7p9YhEzfGUcZno9Tr
45781	payment	2134	2134	1874	1	1	7239	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbs44RBtoLqwrBWEuW6WVTz2cv9T1WVTf168N4FUC5PnknQz8a
45782	payment	2133	2133	1874	1	1	6835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxwLkW2dcTd3tfT155J24hK1sd2M6cBNPALTY8UmP7wv2WoF3V
45799	payment	1397	1397	1678	1	1	17029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjwGbUQgZAtBL8PLRPB8Qg5u9Dhn7cNdZPSyFNLYBMN6wNqEEA
45800	payment	2134	2134	1874	1	1	7245	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGpY7jq59yJe6U8ipnDj8Dg3Vi44a18mJvGmqczgP88u68JZg
45801	payment	2132	2132	1874	1	1	1722	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvozoQ8hapcoSXKXvqq16V556GY2ckfQVTfPfUNa37zk49KV77
45802	payment	2133	2133	1874	1	1	6841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaESNqfoEfnxgfFFxzpCtPxYLBrmkPz9gi4shrziVZoqpRW2GFM
45803	payment	1397	1397	1678	1	1	17030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE9EnSsyoTu54uGymYDLxdF6BdX2sk7Cnk3urKDhtwyeodscEn
45804	payment	2134	2134	1874	1	1	7246	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJeWpnHdabduG9AmvF8916PUCeX5HQ7f8rPbyCpFWFXr8d1B9S
45805	payment	2133	2133	1874	1	1	6842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBhWmyWbJDKzS1bBXtuZSaBpJkww2xVpbwpd79oQuP18ryX69
45826	payment	1397	1397	1678	1	1	17037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjh1jmGaqDBHVimz2QMo6ad8nSE29gqbDRbi3JSUHNt83UJ4CQ
45827	payment	2134	2134	1874	1	1	7253	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFJZ4ijcTEHdjDxm4bYXujKGuxc8dTD8KFjciokF8e2DBj7SkC
45828	payment	2133	2133	1874	1	1	6849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNpGYCYad1YZ79TqMQucnVyppDfrcqo1d5fPintc2pP7GfzDZt
45716	payment	1397	1397	1678	1	1	17002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAeDiLs2D1gYFk4zuZ8QJHsNyddqJTjCGntBWujeKz8fYcrFqQ
45722	payment	1397	1397	1678	1	1	17004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYceQmBnEa2xJHhcJiFCDnviCYyRLwBXZWEWRhvxTMcnyvjKfrp
45723	payment	2133	2133	1874	1	1	6816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkj5FMCKTCC3KfNsBsUbtUqF4mmMXvAPi8jTdGeqMzc6xXAHCt
45724	payment	2134	2134	1874	1	1	7220	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZQpWeeEhM3c1np6rbWnNTrDy41Z1cbHNBgWYg9ZjxgYS94xc
45740	payment	1397	1397	1678	1	1	17010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf2WedcV3myGNNahMM72QSQTadymMtDW5VPEaH7M9rrCLozSGM
45741	payment	1397	1397	1678	1	1	17011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45VpH6dbEkw95hjKcRKGsVR9LaJ2goWW6Jrzvk3JhS1MhbyLT
45742	payment	2133	2133	1874	1	1	6822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyaZMXfgFAL1TbeKH5zWnV1eyqUxtg85L5PACQ28jfnUifr7kU
45743	payment	2133	2133	1874	1	1	6823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfYE6xJpzgxmUZSkThht43x6XjBVqzF1YBqwPLm8xRgtX6a7zf
45744	payment	2134	2134	1874	1	1	7226	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZycFacBT9biwhx2cW2Qbx6LrRBPbBuWCig4Zxpisfp4YsLXWgg
45745	payment	2134	2134	1874	1	1	7227	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiUgq7z7WQMzzFgYYQd26HiYX9dzzh4T7fJotGYn9cgGhrEsm
45793	payment	1397	1397	1678	1	1	17027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG2JE3nsEoBvEW3AupPhY9So2HARZ29WxVKDR7Jn5Rw8f6idh
45794	payment	1397	1397	1678	1	1	17028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD77WLNF6abYo4LPha3qTfzLm9gdrVxUPz1cBNuJk3nGu3s6xa
45795	payment	2133	2133	1874	1	1	6839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBnfyjuwSsRN6zrQtfkDi5q56svkT7b9k1UrSuVx8VxfYSiGPh
45796	payment	2133	2133	1874	1	1	6840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbrVw6oyfbAvGxY3g7gZRD4PBo1CGJojBHaCeJg3bf4htVtQ8k
45797	payment	2134	2134	1874	1	1	7243	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxrCwoMkYc196Q5Zt8RbmaivoaZsvhJ9kYYtpeHPcN754j5d3b
45798	payment	2134	2134	1874	1	1	7244	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFwjtpJkk9kGxjNGCih2cFLmFECrfryXcEyKanjJQekvzy6e1
45806	payment	1397	1397	1678	1	1	17031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7KZqAt13wjASy57hFyDm2JghdhFa9Km5fF7kMYQ8SrgroEKeB
45807	payment	2133	2133	1874	1	1	6843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRWkMP8HzHtcXUdsGSASGNeH2boQ5nUCUGFxLXSD8SQMCVpkn
45808	payment	2134	2134	1874	1	1	7247	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsMfU75UATNxmJpyuJLTp9ta725BBhRNqwLWiBSyagZjk7XYys
45813	payment	1397	1397	1678	1	1	17033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJXmRXBDnrhimjteDntKR9MZ728b8GEPY7Rh9ADgav6ax6Cfhj
45814	payment	1397	1397	1678	1	1	17034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqoSgJJGa2rSSvanemKXTtb2eHDSTEpKbhJvJY4GuizWT7fSd
45815	payment	1397	1397	1678	1	1	17035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFfbdMmTtu4CHC9gwZ5bPiaKywk1owCaXCAQPL8WU5GBN5h4Uu
45816	payment	2134	2134	1874	1	1	7249	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcJi5756jevTyL3HfNKvwEvJhVNuints6BL5ipLST38SJDBwCu
45817	payment	2133	2133	1874	1	1	6845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWrUDfdjrwehDF4L8Vhm3PbA15eKjkYHezNcE3BoDJssuXH3g
45818	payment	2132	2132	1874	1	1	1724	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmTHTH12xktq38NLsW1srNryugMY39QNqx3ibtjzWs9xY8XPam
45819	payment	2133	2133	1874	1	1	6846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1YKrotEzSfq7voK9RPjd4vbt3xvVTHFafjg3r9j3GYE6FUiXb
45820	payment	2133	2133	1874	1	1	6847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9A4g38KQL2GUoj6hvCpiwy4LCKzHGVVyC9r4JgxjN9CbCN1M
45821	payment	2134	2134	1874	1	1	7250	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4xNkWkQC2N2JPZoVDf1rC5RCw1xeGgGcQxNCYzNHzwns5pLt
45822	payment	2134	2134	1874	1	1	7251	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTDMBHUW1n6eZ9mpDdCYzD1xuLcHLZwFp48vbJhJNR8Mrhppv
45823	payment	1397	1397	1678	1	1	17036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEcZQFDGCHmYenJMrM21Ym5C4Mw2sGh9kWYETkzh3rkjZJqqn
45824	payment	2134	2134	1874	1	1	7252	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2SxKuTp1gVTCJAnjRauoYYjL8BUJhu9Tepy5r3Ntt78MjfEgc
45825	payment	2133	2133	1874	1	1	6848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaPmk5KzaNtarHwDgtzMCVn9UujieV4jNcRYiP8K8HVCXaQLh
45836	payment	1397	1397	1678	1	1	17040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa27SSMt2B3eyYMPhcM6txbZNjx3Uph7DVdVCk1TSazqNrYLqCb
45837	payment	2133	2133	1874	1	1	6852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRzoW6hm32b242qMEY3GycoPfYa5GBGmS2niAMz6hbXUmR3aJW
45838	payment	2134	2134	1874	1	1	7256	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Yv2g4hLwtVnGmMTn7Xngm2gtZ1yMF82i78FeoEEsKqmC33pn
45839	payment	1397	1397	1678	1	1	17041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUMdwyxXAPMTVKSqJ5pqpjpwkoAvcyoXxNkPQvy2gxzQhQrKsC
45840	payment	1397	1397	1678	1	1	17042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ67PSS5npueePcJECM6865ThEhiAqi9xvxwX6t12yizRPrjz2v
45841	payment	2134	2134	1874	1	1	7257	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1os7rHJwpxz4Ht2rBsJjZW5jmXhGc4RzLeCK8m3PwoisDB4v
45735	payment	2133	2133	1874	1	1	6820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1XNc1ULkuhtG5AYoAkFeV7MmjgfZpfKZx5PhD3nFJUmgRuFWY
45736	payment	2133	2133	1874	1	1	6821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNPdaHRWtY71xZZifkeDcaNbhTobdf7Ggc7TG8Lo7zdDeMZTBg
45737	payment	2134	2134	1874	1	1	7223	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5U6UbTm3gNq69651GCEGxvS2JsYB6f3V9HWCvdKwf5iGaEFUN
45738	payment	2134	2134	1874	1	1	7224	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPZ6wvDiagjytNDjH9wHEgocAyRMLVDkV8R3ALods2tjRisf9w
45739	payment	2134	2134	1874	1	1	7225	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptPuiGr3wMZ4z8dZeHPdAQhzkkB4xGJukFw1NQbJ29i6A1Ep6
45746	payment	1397	1397	1678	1	1	17012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ehixduE23PjCFjerDzSStYmpF8y9Rp6bED4FW6QrtDw9L9V2
45747	payment	2133	2133	1874	1	1	6824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQShLqY9pnrtQ46zyYG2Qt58z9bNZEELPo5QxyHu5eXA62C3S7
45748	payment	2134	2134	1874	1	1	7228	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAzEfB37R4tVKjdRp8U6fNw8nTdetrkC8UKcYDjVjudG7g4U1
45749	payment	1726	1726	2392	1	1	8344	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYiyvNxuTnTY1CHA3Fduyq2Ws3xhXK7BDcbSHrbciKDFKjUzNDJ
45754	payment	2134	2134	1874	1	1	7229	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQ8wiLtqiGHyTvQiV5e9PSLErxSKrwW1WswxP2HCj2NHwCmQ4
45755	payment	2134	2134	1874	1	1	7230	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeS9mx6QRb2TZjxGxvs4nrXerFscVSNA8Aotu6Jkz6ApntP7zM
45756	payment	1397	1397	1678	1	1	17015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fBECvDi1rton4CVyLKBS4QJsy4rS5E1w8jbtm9m5MFeHRu8y
45757	payment	1397	1397	1678	1	1	17016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGgGCWZpLZx4Qo4z4uzVdZcyrkDJuZsErqH2txEPR1Fsp87Jj
45758	payment	1397	1397	1678	1	1	17017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ztjMDQhFNWbbTWdo7j5AHqo61MLus3L7kUn296YDtoBGsXE7
45759	payment	1397	1397	1678	1	1	17018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd61ka1iU1qkPm2pWLjdqhdBE5FJosVF32VFXgCQ97dea1ez6y
45760	payment	1397	1397	1678	1	1	17019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLtcBYZ27LgCdx5NiEpD8HdhsxgCARjR4vFjpTez5dF7r3o1x
45761	payment	2133	2133	1874	1	1	6827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3BcqTdCcYQ2kSkZrvuh9qzyASSCQmekLrMUCHXisMwfPfqYjL
45762	payment	2133	2133	1874	1	1	6828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaN8CEzm4tdnCCaGnU2hsvSHo7YWJzfJeH4CnHr9pUwMFfR23
45763	payment	2133	2133	1874	1	1	6829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJmS62YEEMmj4nr9MHEe36TuNSRM3p2fz8v495suMVa9dYcoNM
45764	payment	2133	2133	1874	1	1	6830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfrUVRCvyUk8nTWuVFGCU3n28YqwP6fR4TwKz8TjNKK544AVNw
45765	payment	2133	2133	1874	1	1	6831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUDu1DzhWRJNxKFygo8tqULPVnXvUL2fdxSSAQCyanmJaEWsF
45766	payment	2134	2134	1874	1	1	7231	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqoYoUXVqmwV5ifPERDfsR6iaW7dMYyDAQg87miFDe3gJe7bqh
45767	payment	2134	2134	1874	1	1	7232	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy1eBXDpwZhYpyeVcKASt4EB9cum3oRSpek7psKjqzzdaToNkk
45768	payment	2134	2134	1874	1	1	7233	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcafLHYXbWR1gkoKZrYjM7qGkujeeqzU2f4bjMR76QowWycmTB
45769	payment	2134	2134	1874	1	1	7234	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyduBTiwSnykPprzace1TPccaMT77zfv1bwHSd8nSX1VfKPY3C
45770	payment	2134	2134	1874	1	1	7235	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYskXXfi6ptowZhS7byuopqxiXvFWedkduW3c52EPCtKjAUfy5t
45783	payment	1397	1397	1678	1	1	17024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsB5NqrQ7ZGALMWG3mrn35jvBoG5qR1CFFFREPvZ3ARYuRCqxR
45784	payment	1397	1397	1678	1	1	17025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonKgLgzEYmdJ5odCeB3HtmJcw58MbVzWtJJaN4s96bmjN3Emd
45785	payment	1397	1397	1678	1	1	17026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfu1AxKuLz4j9R6VsZxDFuP1L5CxddSP6zqUJ37QPuXeVo5YF
45786	payment	2133	2133	1874	1	1	6836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHFxQ2yuKaSmdzV5FLQ7KZKMzy8Sqimvd3QuoKSuqu2rp4bFp6
45787	payment	2134	2134	1874	1	1	7240	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6sDR835SW5XZrZ75aE9PGUkJSLXnCb1ox1tyoChaoeosgdPN
45788	payment	2133	2133	1874	1	1	6837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQQMiWRBNja1bCoLRNMfbbC5gbSjVsQCcfBqT6N9PLidsaMjJ
45789	payment	2133	2133	1874	1	1	6838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV7zuEWg5KgPCdMWhupkUe1d9cFdHb1jYnQvmBBk5q7K2hGABA
45790	payment	2132	2132	1874	1	1	1721	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyYxuFq2L5asjEkmCUPaN7GA8xNDovSJBFmb1YSFk8FJFyKHJx
45791	payment	2134	2134	1874	1	1	7241	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkFANFWF3TmNcXnkw1gkUTf2Ld986LwpNb3SLa6UiebKJwF81
45792	payment	2134	2134	1874	1	1	7242	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qQT4Jsn5rLaFZkyTH6nF4orKs8BSCfTbzCAT8SfM57vwJe1C
45809	payment	1397	1397	1678	1	1	17032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrWtbCYTxdakyjCZiZGLRfZX2poPX2ZxHBP4J4h9Mgcfy7FETz
45810	payment	2134	2134	1874	1	1	7248	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs9gUjWnNzhknbvKRNSKuib6w2C3R8CnDSLEYMFNdorjx2oTKF
45811	payment	2132	2132	1874	1	1	1723	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpPqwV66DPFBPsnKEQGqXagHQEtXStxLUibrUpMbVBTzbrroZ
45812	payment	2133	2133	1874	1	1	6844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrLyfvNPFWmjGCfuTsvuthYMsVS7qbSfNahUx5qGRVJgjbEFwc
45829	payment	1397	1397	1678	1	1	17038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr3t5dWjVzcK9kGZwtFD9Ap7QGSg2u5DEAKwT7na8zYAwDgrHZ
45830	payment	1397	1397	1678	1	1	17039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7BHSzzvBdpLQxG2VFfTHtfqzDoW4D8BkR9tXMGV3iz1zDsKy
45831	payment	2134	2134	1874	1	1	7254	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFNqkHjc3q3UEXTneGitE879AzBumDE7dNsPaB8pMZomR7wLx
45832	payment	2132	2132	1874	1	1	1725	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTC11D6JpuBLVzCZ8Sp43N7Aj3YVUVvKk9Johjrkq7ZyE5Jpk
45833	payment	2133	2133	1874	1	1	6850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkHE4pezaQzEcgsrnZ6re8xkg8dWTZUVSGjquz66yBQuGK1oG
45834	payment	2133	2133	1874	1	1	6851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2uBMK45nz7xRffHxVYBDyuQNAh22JZ5nwTNFbE7a36NUga8U
45835	payment	2134	2134	1874	1	1	7255	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNrvLDb9mjCiH4yfnBBYgoJGJMbcmBXGMtkgAFM1rfDCu8UmJ
45873	payment	1397	1397	1678	1	1	17051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdQn4y4h6xKtte1tA1MrdSgWsEFZf4YNfXy9gSTVQxg3KFmnE
45874	payment	1397	1397	1678	1	1	17052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBs2Eg4LFdDwP34UYuFd19zLsfeYP6jGZqTtFGa1mCrXKVvvve
45875	payment	2132	2132	1874	1	1	1729	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEsR5MSgeB51ixAzdd6U82KY6EoxoNLqRGxebdtLEf4Btjfjo
45876	payment	2134	2134	1874	1	1	7267	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLwyQrmrYGeNFQ84Y4J5E8xWYx2B7VGxQ5MbD2PpqwdzFqk5d
45877	payment	2134	2134	1874	1	1	7268	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgR8r4aRiGziboJEkEMj3W65JeUm92XdUEiXTq8jTb5RjtZwsw
45883	payment	1397	1397	1678	1	1	17055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf6ULhCRJyBY3G5PZFBxYKDhCS47MkouvLhPsUswJ6LeKygMGn
45893	payment	1397	1397	1678	1	1	17059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPu1f3L4DzwbayddtLaMwS1jmnv1UagNrp9SDHYDf69FrZ9oj5
45894	payment	2134	2134	1874	1	1	7274	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhiYTFoejya3XtQ3Qdyq7pBi9CY1tJVgKuqhYthRGiNvK2aTS
45895	payment	2132	2132	1874	1	1	1731	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm5HGoh1XQijPayh1azXZ9nK6jAq6UUazoGpCMT4PpTDQ7fgPm
45906	payment	1397	1397	1678	1	1	17064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofCqn78kWacZSRXCvB5EppuLt9M76o3SdLFv7KYKwDzwRmZTw
45907	payment	2134	2134	1874	1	1	7279	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7nsU45uTgod62QuWSkQDoTYz7vsCQYUeM2FGHtwhm7EjTpJFN
45915	payment	1397	1397	1678	1	1	17068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZJfKBzVLFefz1eBECQP4YwpfrakKUWSPD1cLgsJnVx2tgyCw
45916	payment	2134	2134	1874	1	1	7283	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpQDxb2qtsWzdZD6m4QzSAR6w5ht3WKvLGtdJTUSgPCGc6URPh
45924	payment	1397	1397	1678	1	1	17072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GM7ZGBHgmnrseMi7HUtTJ8ANzo6t64TaDffVGwdhaaEvnnFo
45925	payment	1397	1397	1678	1	1	17073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUcu74TfNPr9DwWqz7AsPcZVgBTqfSbPcFD8PuCsY4L15Lcqw
45926	payment	2134	2134	1874	1	1	7287	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpNRV9srZjJbaTJdJzBvkEScCWtbKd7275WzTSpBgbhsNWWryB
45927	payment	2132	2132	1874	1	1	1735	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6nix9GWux2tHsXPjDBWLg9vcoyGau5CQvvz8zMC2Tgkg6LXG
45928	payment	2134	2134	1874	1	1	7288	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVRXp4rCCxiKWWyY4ExkYBr3w8Phn2YddyQbBDJs4XdzwE962i
45932	payment	1397	1397	1678	1	1	17075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXyqskPTfyru7pZ1m4Uv9PX47mfkayYo9ay1AHLd8BhT4nKDr
45933	payment	2134	2134	1874	1	1	7290	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmENPd4uVBzPj6Nqen7wnJ31A8YFpMFj7d4qjrqrdMnqSmyUwQ
45948	payment	1397	1397	1678	1	1	17082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYabXCZSXwn7uDPgjokXBUSkExbrpLa13HbgC6oszVJ2ScDFP
45949	payment	1397	1397	1678	1	1	17083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevRnjznkw2GjtBeySpxvXwQ398WHdc6DUPg8b9p3tr51RhPJu
45950	payment	1397	1397	1678	1	1	17084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYULZqc1ySKjShjX9csmYusb4wouAYwSBK6z8z8qKsR7TMoWr99
45951	payment	2134	2134	1874	1	1	7297	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HCsuGrYGUfuSG2ZoQaNcqGnWD2Tjpmo5Wt2Lw7Wc93by8WQ5
45952	payment	2134	2134	1874	1	1	7298	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjzakm8R9RS9uG7UqEkaiv9F4tLbS4x3YsSgA85pU2nUCBSMhL
45953	payment	2134	2134	1874	1	1	7299	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpy4ycW9CcL3TyqTPUAgafZTyQeyDNbjJ3p9FqUpJAnr7LT6FW
45954	payment	2132	2132	1874	1	1	1738	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWpnFGoSZrcUG7dTD4B4GjdEMjsQKLzTyERrEUzUq14a9D3wRJ
45955	payment	1397	1397	1678	1	1	17085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVheakfZqm5RbfgY6euGthj4PWiLEhYbAd2T1y1uBmJ6deRTKE
45956	payment	2134	2134	1874	1	1	7300	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd1Vuq3AzZqczkvZqUH7xXERVzANmXLoxohL7ZMQeoE8oUtHBy
45842	payment	2134	2134	1874	1	1	7258	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy2aHuT6oXvPTrnGqGsjfPGesBmjZoQzVVPrCzR6ozBeonLJj
45843	payment	2133	2133	1874	1	1	6853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevgzjUpxbhytUybny4KYcYi3tU2JRLQtGCYbGZWrq3VkL3XZ4
45844	payment	2132	2132	1874	1	1	1726	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2JGZEJWYDGeCYbEZmbBhC2m3EHseTHkxxsRQVp7fviZaLc2p
45845	payment	2133	2133	1874	1	1	6854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykELA9iPu7UYvKHa4AYwyF6YDRXv1Mm9CLt6CVuZ2tqJtg131
45850	payment	1397	1397	1678	1	1	17044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSEuKaBxtWLv219YTodXMMVJRmBpfvbn9kZadHCBBmwJ9J7C8
45851	payment	1397	1397	1678	1	1	17045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9qgiD41NhyWogkRVafd71AybJTPu2ge4hhdXWLDmyZgnofJt
45852	payment	2133	2133	1874	1	1	6856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLHPwmHmVxjEHXuEb1fWdGMqJU43kyuqS3i6PJahJNYas1tpZ
45853	payment	2132	2132	1874	1	1	1727	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGi5368xRAAbzqZ1ccJkivMhFkzsjfVrYzkaVMyCzJJZWsyKT2
45854	payment	2133	2133	1874	1	1	6857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfumsxUgq73QYyzMBPNiUaFEtAiPrdFMb2N39GsPbiMzaMPgaa
45855	payment	2134	2134	1874	1	1	7260	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhnU5eP43RG6uD4NfGY3zbdNVcgWE8snSwAxus6ebhy7rmSh5
45856	payment	2134	2134	1874	1	1	7261	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtuyk2bvhMDn2gcq9SygkNLu7a1SH4LLryGRnUCnNCt4uyn6eZ
45863	payment	1397	1397	1678	1	1	17048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2gXvbRt33tpXnBsht7ghGwtcVSMPDV4wMssYvKT5oLCW9XqA
45864	payment	2133	2133	1874	1	1	6860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFczwSanjGNRbK2L5aPtyU4r6TwinN2Afr8VDU6UwUTYu1ChL
45865	payment	2134	2134	1874	1	1	7264	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVvn5469Fi8rFkyfdSM9gH9Z9mhqBXkdvyjetHZb1Q2TsMoeFJ
45870	payment	1397	1397	1678	1	1	17050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU1go5ceRJ98kZZNGoSQTU44ApHYX29NczxEY7YXbD9XznY4o7
45871	payment	1464	1464	2393	1	1	1	2158000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ZHV7ffMzLRrzr3wnyEeLiXbf93T1foa2sGVGagSJSk6jNu3D
45872	payment	2134	2134	1874	1	1	7266	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZpApARxpor8sQ9ndWwAHgk3mmeF1rZJb341jSXjjsG7yMEPA
45882	payment	2132	2132	1874	1	1	1730	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWkhD7ZaPBSo6g6Nwqo4WPRxi8wxw9cN65kJuWZykjNmb967P
45891	payment	1397	1397	1678	1	1	17058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YUrXCxDhDpiRtR6cbshUHjLXEer91PWp7rngGCsNz4a8xdJn
45892	payment	2134	2134	1874	1	1	7273	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpZC4cWnuYrFQyu8Fkwdji2YW8ZvsMVzGkix487dAXzN4wzB4U
45898	payment	1397	1397	1678	1	1	17061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2JMaMB7eoYfiRBswtKvbSDH4SALzwCVay41BbjxLSvMYLhWK
45899	payment	2134	2134	1874	1	1	7276	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYus1DLB1qBX2FHqiANQEwMQzmuxtTQVfrktxqXbFGQAaN1dEWc
45900	payment	1397	1397	1678	1	1	17062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXr11jrq5r55BNGjoXYmmhgM6c2KHpFNcDpq6x6qDvxshHycyV
45901	payment	1397	1397	1678	1	1	17063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtCCqNja4j9gJkk2ZMsTq8eWgKZdsWxT7DJ4H1ynuTZEmg4A1V
45902	delegation	2394	2394	1483	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMjoCGdeLruPBCmHCfu8ESUneef1sPy2W184fQHtJpGftXdp6f
45903	payment	2132	2132	1874	1	1	1732	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqifhwq44Yp2WSZJdtKjRQL83Sz5QYiCbfisRw43v2jhs72Rxr
45904	payment	2134	2134	1874	1	1	7277	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBeFR2kXo7XhuMWpqvW6M31xQijVAfCbeum4fECGPTHpk12HPQ
45905	payment	2134	2134	1874	1	1	7278	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Ujtbrhs3sEx9JyK6KNEdSErLnEbgpgbZTG1K24aBYzHJMhT3
45913	payment	1397	1397	1678	1	1	17067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwWC6RuL8JBLcCs5zPbJxV8rWy1bvuTeHC1ucb1NgqDasSHJu
45914	payment	2134	2134	1874	1	1	7282	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdqd4acad8o7qZMyg5DiiNDx4VZcvF2HsycBk2Moae2o1A26x
45922	payment	1397	1397	1678	1	1	17071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcsqN6hRqXoDVQoWDbz8F381mE3Cu1smnosz2LCkuGr9cpqPi
45923	payment	2134	2134	1874	1	1	7286	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZENVNhG5amCvUTYotxeFoa3Kg76Z7dgEAkjtMnespwwuXBEX8S
45931	payment	2132	2132	1874	1	1	1736	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75uN3p2twVh5B3yQ2nuxPgUvDyAmVjQVP5BSbFBX8f5q1WYej
45944	payment	1397	1397	1678	1	1	17080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfbNxB79aB5GaAgs1XAXZmcSQbmbSdTDi6usVBR1b6KULHWgpb
45945	payment	1397	1397	1678	1	1	17081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJvMFunMeSVdoHsATPJujFxcTvnVQf33uTF87Ysjt9uSVLkKf
45946	payment	2134	2134	1874	1	1	7295	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCJL6Di75XCdqysxsTUga2EVGPYsSbQNGZZeMGCkfgcWEPGuED
45947	payment	2134	2134	1874	1	1	7296	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBZwpN68j3MH4eXTkWfaao9aZ7FRH3QKULah3WqrVekrB2FZX
45977	payment	1397	1397	1678	1	1	17094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4JefMqCeLRH9mMaiv57FDB13bsTc71z8zrzZLB28S1mmqdTJ
45846	payment	1397	1397	1678	1	1	17043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6J4SDxZzQJcEMmPCct626EXc62QfCatbWCr5zUemkffAWuDpj
45847	payment	1464	1464	2393	1	1	0	2000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB7fJ7nYq9rPMitxD8bZqPFRVe7mdK4XjRWC2kQH99UJvNMgci
45848	payment	2133	2133	1874	1	1	6855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrvu8C5JjkLfjrZsrBFGz7Y6dvs1vkTnzyoj5m1HNVX7mRNnNM
45849	payment	2134	2134	1874	1	1	7259	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JQ4ByDUoXmg9ero3P6mbqEvrbQzrw1VSpfouDB7ajWbW2HTh
45857	payment	1397	1397	1678	1	1	17046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQXzXgGXM1BLLhAYnvn2vgjLtQPtxKEJvZbpeF9HCTaLRyukN
45858	payment	1397	1397	1678	1	1	17047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwmW8ro5dNj1JpVPArd9wDj1Y6QZKGj695JvJxwAxSKfkmDGfM
45859	payment	2133	2133	1874	1	1	6858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5QYN4V6K2nsyehr138zyFSDmynD6crfdAPKnX1pcDQuz8XbD
45860	payment	2134	2134	1874	1	1	7262	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEHsd4296HUdT74EFPiasMtKidYyQsR9yueXufW7BWs7HXYsM8
45861	payment	2134	2134	1874	1	1	7263	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoAox2Z6dv6kWPy4B3gewZ5jvEvAWrmPp4cmGzT79EobT18X4L
45862	payment	2133	2133	1874	1	1	6859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6LEkmcXKAp3F3a9m1puQWXU75LjsxAGZLSgtjaaVb9X8EaAa
45866	payment	1397	1397	1678	1	1	17049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRedr8a49dGyJn2GRSDeZ8TTvj5uKB5NF1qDsGa5kcNzv1WYU
45867	payment	2134	2134	1874	1	1	7265	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ChRU1q1jydyL2TCsEEAMHbwEcX9mMVDjAXF23zTwrLVKDDwD
45868	payment	2132	2132	1874	1	1	1728	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9YBhMBkm5rmgv87HWQCiaqHTRTvxhX63zfZgY6rZFnpkQ7qgJ
45869	payment	2133	2133	1874	1	1	6861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ys3bLHCQMViXXdY4eDqGLXenRh4GWzLasrJeNfmQmLH2kWk2
45878	payment	1397	1397	1678	1	1	17053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RJY47pvhTkcuQiuwYkfiC9RKfxQXWr8X6zT7ZPM5J8S7egw5
45879	payment	2134	2134	1874	1	1	7269	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hEk56nGY7hNqVunutne4UEbkhZiHWcexFxYc11EcKRXUZzbo
45880	payment	1397	1397	1678	1	1	17054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYqNE5viYTKrdpfGNWfSSJZCK2NWmKA6YD8S4dVvji1xCjY8VU
45881	payment	2134	2134	1874	1	1	7270	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJX7VQ1oeh7eiTBpY8WpQXSEyiuoJzA66Jccj1dNjejDahyr6f
45884	payment	1397	1397	1678	1	1	17056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdXBz5AGLqNb4mQoKfcDvb8KwTrKsvPWGuGcG4xo8pVRrYZzYj
45885	payment	96	96	2394	1	1	0	1440000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rBL3qmo1wwh3xYqWBVyw3zauuNi1hzCL3LCcJDZ9dspN5v98
45886	payment	2134	2134	1874	1	1	7271	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaP2jmpCeAs1uXoqQhTkGwBc6S4R6eKBEyZ6gUA9p7dez7n6T
45887	payment	1397	1397	1678	1	1	17057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8B67NTAyd3DZ4vwbeZyGoGNFyC5HJH3h6dxcRSrKs5rqbHwc
45888	payment	2134	2134	1874	1	1	7272	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAtaQdYs1USAfesRVLaUJ4XHLgN5Hvkk8rcH2ZVY61xRTuwXB
45889	payment	1726	1726	2395	1	1	8345	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZdSekhfVMvjxPS2fcHv6H5cuZE9m1bWeUk5iKpf9fbD787Simp
45890	payment	1726	1726	2396	1	1	8346	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYoQJNWPW1Bgxg4M5MSMXJmabeMoFnW2UMquuKaE828Z32G9ohC
45896	payment	1397	1397	1678	1	1	17060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhuQ2662z9koC6X6b8o5GTwnyEF8ZxSu9eenQFjEpJA3PzHASv
45897	payment	2134	2134	1874	1	1	7275	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4yYdoiRZU48qr2C3N5qv3cAndmqrtK1ZRk33JLXxdGZGPnUPs
45908	payment	1397	1397	1678	1	1	17065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxoinB7qtWzANKVcFjaSWy5NAK6htYxgX9KogaLGZFZbUEHLxv
45909	payment	2132	2132	1874	1	1	1733	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBh55LfrK24GpFiezDeaAbfiPjXCbYPGHcakYduDE5pFnBZem
45910	payment	2134	2134	1874	1	1	7280	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8zpPj1QoPibE6vDSFgBTVDJYQYKu8mpnK7YXV52g3227pBq9L
45911	payment	1397	1397	1678	1	1	17066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPXfZuNua5qNG7v5RW5YSS2fEHMG1eDhWLtLcSoBKaFy7sXvm
45912	payment	2134	2134	1874	1	1	7281	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhC4nBDHXW4QiSeQae7Lv64PRKHNTCq58KvybeK85UegCc3RSk
45917	payment	1397	1397	1678	1	1	17069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoVU7ZPcNinskRxTYgNazdFMCghLj9fRwVaV17P4YxXGk7ApeM
45918	payment	1397	1397	1678	1	1	17070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrUd4faUSLb2QHmyAdKyeaoHobG1P4F1R4a1Yogkdi6y2Yw2s
45919	payment	2132	2132	1874	1	1	1734	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYBLHqCztPhjg1YCdHFxK5MTBrgAv7krJ7y7ASLtLMqZfsJjjy
45920	payment	2134	2134	1874	1	1	7284	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKePFbDq2mpxJURqSeFXwrH9CpubDW9UMNsMxzTvqsYXViBjCw
45921	payment	2134	2134	1874	1	1	7285	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmLEUjZxxmfmAevrm6pnFUjiutb1v9m7GbyLeLFEDEyYfUmYaK
45929	payment	1397	1397	1678	1	1	17074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVaaJZxRe1VMPQ6AwkkrKKyZanqsz71DS1z6JY4aqHHU4TJpQm
45930	payment	2134	2134	1874	1	1	7289	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6nHPfuVaSJfraAEwakMKaouQiZaBjfkSzjCekwZka1YYNqNGb
45934	payment	1397	1397	1678	1	1	17076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYBHyrG8n2ZofxQaymWL1WWVXkV6RhrG37nJ8W5GZGFbBZHnFf
45935	payment	1397	1397	1678	1	1	17077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqy7TXwF8cTeSkhFErtJNUFZy1vKQMpupBkiFjpjU3dM384CtC
45936	payment	1397	1397	1678	1	1	17078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJvhxDhh1ruEQDzuU1R3iAAMHLNmbXv6xe38bqAX2AN3DiT4en
45937	payment	1397	1397	1678	1	1	17079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTP3GqATv75nuugfQP6XS4gWNsJTD38YLx42DriXJVoSUEACg
45938	payment	2132	2132	1874	1	1	1737	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANG3pQq4Bo7fiMCEJc9y2L53pK1PQzVHcK9UGcznDpT68ZHiz
45939	payment	2134	2134	1874	1	1	7291	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG7o2eAuYosTDnhSRrkzjREo3zsCzPxrjvxqzCmXZqCo7WPhFZ
45940	payment	2134	2134	1874	1	1	7292	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgdgvKmNV6XPgkSpqP7w7Kvboy1rg1SFXerMGmpubn3T1288B
45941	payment	2358	2358	1816	1	1	0	0	1000000	\N	E4Ynu7seRhW9GYFf4Tig6NDymTQc5chEQXhXHdYFr7Caw9DfbVYLP	CkpZjTbC32BTZu9mXaHemibZcjyAQbvTwioB1B5m4GMmNoRKdrXfs
45942	payment	2134	2134	1874	1	1	7293	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1Dg6QojKouSnxTp2RnvA4EGKBZDmxjz6wZWZg5ys26PaRR5mh
45943	payment	2134	2134	1874	1	1	7294	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5SaQhLjSop3vdxn6BBLKbx1TxWANHRk9Digq3MV1jrnRUf5x
45958	payment	1397	1397	1678	1	1	17086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVHhvJLUbqish2cKU7x8wUpApX3Xh8oD2bWJ5e3FZZ3i2e1R5
45959	payment	2134	2134	1874	1	1	7301	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuChaxGmCD89dwrUa8v8NiZ3zonDFbu8c6tVXFwmkyxmZVnB2
45980	payment	1397	1397	1678	1	1	17095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZswLnbFEbQbPoudHPHhvZFx7wwd6QeTpGNsLy643SKb8YpDcvo
45981	payment	2134	2134	1874	1	1	7311	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgAxyrBCgj1KcwonQZq65jQBmCDXkhurY9HEMQdiDNLmYp3ic
45989	payment	1397	1397	1678	1	1	17099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmquSaYSzRr8KrPVvF5SvKmpMk7bUbhuPGM5AB2Mibzmkcv2Zf
45990	payment	2134	2134	1874	1	1	7315	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ6N2p5FR3YF8d3pfsRR7dTfA39r34CZp2fRMcoUf7aSGkMZf7
45998	payment	1397	1397	1678	1	1	17103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu9HU5yKMWrNUGZgefF7gc2SmU6kqK487zCt9owhLgDdEGAwgQ
45999	payment	2134	2134	1874	1	1	7319	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hi6tHA2xiCQBQJw2R8Xeirf6N8ZL3HruDpWLyqWxSuXWW629
46016	payment	1397	1397	1678	1	1	17111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVs4SA9TmRsAnTQHr8CZBFNDdiCzPVV3Uop1AyZcxAVUCV515U
46017	payment	2132	2132	1874	1	1	1747	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRreqdgy8tLPKporieUf5MgNQqXkJ28ZtsDF1USSFsmutMKdcA
46018	payment	2134	2134	1874	1	1	7327	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9aYbjuQWf93C43QsyZayhLRhBmVmzQ4dgKgryTPCx2wVgSiX
46023	payment	1397	1397	1678	1	1	17114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqqpuQVuYNedMY7yCCEWWddaCojideDAe2AccAKoLKP56Uwbk
46024	payment	2132	2132	1874	1	1	1748	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQwJMPFjbPYXH6ZsLJ8XumYoG1yS4WifprLYd3Z64irQhczM8w
46025	payment	2134	2134	1874	1	1	7330	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1GzEnfexyfEq1X3oLYVYxX3wA7RYgx8N5m3LHM752SQ8L5RV
46059	payment	1397	1397	1678	1	1	17128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfFJ9mEFtv7QY43R7i7p8fZYnAL8gGuX8TTJDzijqweUJxjiJ
46060	payment	2134	2134	1874	1	1	7344	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4rXvhyKLpsxD9N2cEisp9xP7dX7Aoo8ksgc4PstemwHDtPkx
46061	payment	2132	2132	1874	1	1	1752	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRa173xZtTWX7tXyWToVDUfCTMPf3MvUhJAC2syZwAG5L4vR6u
46069	payment	1397	1397	1678	1	1	17132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCMpwi8GakXoeLd7b59wgxQMgbET3Y8ZuPex4uGGJ5ze6uvSzh
46070	payment	2358	2358	2358	1	1	1	0	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZeibqe22edsjnXD4UYvRXaw3WvPWNVxBKqtKF9kNnnc6Whss2v
46071	payment	2134	2134	1874	1	1	7348	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrkS2d71BcuPb21a1NreAYWpKU6PqqKXqXt1YzUZQvZPDjySm5
46080	payment	1397	1397	1678	1	1	17136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBwjoGBVtPCzYfnBoLtcGTQF6hMSpAeiTfw1VL7gUBHUGx4jx
46081	payment	2134	2134	1874	1	1	7352	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSR2jMFNKzekZCRpz46gUwVq6aA3N1T4dhoiGPF8wNtDd84xiU
46082	payment	1397	1397	1678	1	1	17137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQFtEg49BpujFns3GTBL2utYjDA4iGr4Lmf9yV4oBYanmUUWEx
46083	payment	2134	2134	1874	1	1	7353	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSP3QU3JhbmUUWRFvGraN6coBoBTSK5FSqFRhMix2NatLagTV
46091	payment	1397	1397	1678	1	1	17141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31GfUQmS4DV2qv9y8V6H2ETPZK4f9Jt2CRzsQws3T6YDMhJvr
46092	payment	2134	2134	1874	1	1	7357	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNWS4ZVFcs6CXVsX87GXwEqsuxNbs3tQ1z2wAnUSoivb7UjCx
46093	payment	2132	2132	1874	1	1	1756	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZMonJaeFsZZTdq8NazDgMc5KC4K6h9KZ5CnxWiizUTqmNxLv
45957	payment	2132	2132	1874	1	1	1739	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtFSZAKXcEysxoUw3jDi7FoSJN42bZEPxzx9dZf6Prvtp5sBqf
45960	payment	1397	1397	1678	1	1	17087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTRd4nPvqk6yiFcpz4fCeSRt5M5n8QirJodPFLo25qbAShrGHN
45961	payment	1397	1397	1678	1	1	17088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQcTX9co3x5aGntgW35jVdW9wRfHEusPGixVPcDZ9kM5D7DXk
45962	payment	1397	1397	1678	1	1	17089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF53GM3DKwYnXjzzup57gY9rYb3EcgNZjZMvKyitoit4xQ8J79
45963	payment	2134	2134	1874	1	1	7302	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT3Xfe2rqCDyVP7LkycRQvxwYD5NoR3CgNW4kPLkXBjhsZWkms
45964	payment	2134	2134	1874	1	1	7303	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjszxrJ3NWnehYD7DpNn6V21iydgBgE97g1nRtiDsx2tpLSHm
45965	payment	2134	2134	1874	1	1	7304	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn1AsPmghxxxBwGZ5tcCqpenadStp2n6K45aUGryjq3f3J4252
45966	payment	2132	2132	1874	1	1	1740	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCgNJTiD32ygHpjsfRhUFpuK9R69KNgvdzht8h4Y3xBgGMXyr
45967	payment	1397	1397	1678	1	1	17090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEiTunPK66eyHEN9RNu8aJ4A93cAnmnmPrxwvj4Z7sorm1eNT8
45968	payment	2134	2134	1874	1	1	7305	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7noE8g2ZJJKwYgtww2Au6gAtPyUGsHa4t8neFXNdzyenjpU2a
45969	payment	1397	1397	1678	1	1	17091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2xMn8zDhBqsrW9mmhVRYqNwnn6Xzq9LBZDCCeB6WFT3gKSwZH
45970	payment	1397	1397	1678	1	1	17092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdMowH4H2MAYekHwypydFUXPpaZvdkpXNncm8WW2Q3oL5BfYuB
45971	payment	2132	2132	1874	1	1	1741	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXMgn9cc3P81jZrzJmEsSMJ5CG5FXiHLr19JSM7FokrSVpCSC
45972	payment	2134	2134	1874	1	1	7306	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTEfUvQv2TKkEFUsS3673PkAUpvDfxntCopECqtLAQH5ufRJc
45973	payment	2134	2134	1874	1	1	7307	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdJDgNA3ApxwYvqmYUxCgP7BN5DpqWqB2Z646ueBWjKHurvevp
45974	payment	2134	2134	1874	1	1	7308	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ2cMrjdfc6EGx8rBxVFDtopENpJpg8e6Z8T1bPMarU3h4Ynq
45975	payment	1397	1397	1678	1	1	17093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZCQxJLpvqGbxRLKj23m3tj2FHHgDBjn8FdzJhPZ7wSNVTfcF
45976	payment	2134	2134	1874	1	1	7309	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLFsXUP4QN9WeGNNcLi4V74pqSp9bTY9xHa2VhDLwFXKmAVFh
45982	payment	1397	1397	1678	1	1	17096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEGgmrjtjwjtgdpN8MtZZxe7jUxaz5kuXpNRQWNk45hRuLHhHy
45983	payment	2134	2134	1874	1	1	7312	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwaH5TSd3PkvZ78xdF29u4T8g6uSgyhdTi77hG8zYsr3igVtz
45991	payment	1397	1397	1678	1	1	17100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoGJ2pep6mRcG2NWvRfCyCnyUVEhYM8cYnCTrf6cJpYcy7fXTA
45992	payment	2134	2134	1874	1	1	7316	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwHfgqHm4QK6oGLBQCFaHNfLrc7wVbWZwET3etCBjefjEaWr7o
45993	payment	1397	1397	1678	1	1	17101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ88zSYaU9EeWyM7csyS3Vy3Rr77P9PNWUWikQauHDuP7EVgTU
45994	payment	2132	2132	1874	1	1	1744	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2sL9n26RbpgZZL18szBvEfkGMm2TA894fXFp2CeRMTS2t4LFV
45995	payment	2134	2134	1874	1	1	7317	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3yTYJc3LCV2bnaLcLHBME3sBRWkf2Csc7kPPRatsbB6KgTZuQ
46000	payment	1397	1397	1678	1	1	17104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtawTaH4grimcecWxt8hhB5ruLBgJ3ECTZXsRNYeMoTUJbdRiu
46001	payment	2132	2132	1874	1	1	1745	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYntHY1NNn1Fo2PN6Pic7XvgyURrLY9x6eUdxiMSXx1exRH1zc2
46002	payment	2134	2134	1874	1	1	7320	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZdEa8Mza2m92RW45SAfn8UcpemR5au11xNk2PvTmVCpVAZFZ
46003	payment	1397	1397	1678	1	1	17105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWknzVcgm4PvXRz4WfvE1u2sTkUR7bmVoVCw6D17CurL4wrKFC
46004	payment	1397	1397	1678	1	1	17106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4kUtehP4d2js63nU2e4PUu8dgh4tNWQ39a2D2zxVtGX72NAb
46005	payment	2134	2134	1874	1	1	7321	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8d4saL6c3bj2TGazvLEdVf9gjcwhvQYj3KAZf88JnvjDDAYF8
46007	payment	1397	1397	1678	1	1	17107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS7rHtWpXGHQhqurGVf2CYvxhYJQ59GBvFb2EXwSsqsWG2TZqn
46008	payment	1397	1397	1678	1	1	17108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmTbjTbtZK8xmoHiW3CypVTXyRZH2T7UUYnGNcAGEQN61RkrS
46009	payment	2134	2134	1874	1	1	7323	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVeGVjvbudVqzFyvatXM9A6zMgnDa7XtEQPgdwdUJePVQAGDJ
46010	payment	2134	2134	1874	1	1	7324	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUVxDrscw76dshUfCeaNcbMfT1WJUhACgmNCU6UtuRfc9nyubU
46011	payment	2132	2132	1874	1	1	1746	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRq69TsHettF5NjcyqmPyh5KHAA23fui3XsXpXWYapXQLoFcp
46012	payment	1397	1397	1678	1	1	17109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYTdr5EdhsLwtE9jsd5UmH8BPAZqhkkEfs85Fg3d57a2ewQpc
46013	payment	2134	2134	1874	1	1	7325	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14gK37jyJZHnh51EL3TyTFSrwT5JCVA5G3AaQAQb53PoPiGr9
45978	payment	2132	2132	1874	1	1	1742	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwiJNGH3jaa5pdynJpSk93MLi5va7xa5gr3uyjWD9EcXJpD6J
45979	payment	2134	2134	1874	1	1	7310	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCYpwpZngCnKcVhUbhpjCdoJw8ZDzcPMMMEn9Hboy1nrSLNPrN
45984	payment	1397	1397	1678	1	1	17097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMLVTZfwJzN4ieMP71sk6DAJYqXk4yZj7xFAtFjc3r1k5ReNF
45985	payment	1397	1397	1678	1	1	17098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrnvGrzREcWzP1hx8Bjev8oE1q6bYNH4ncoYJGF7azecnDofAK
45986	payment	2134	2134	1874	1	1	7313	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsX3bnC2PAmzvSbr9RA8KcfLw2jEw5LVCB9yi39G7zPZKET3og
45987	payment	2134	2134	1874	1	1	7314	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQoX4GPLhm2Bdvx3kj8PvUywokogpdUvZLswN9YsUPTqVb3YJ8
45988	payment	2132	2132	1874	1	1	1743	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeBVnXd1tPB3afUuiSoebpPMULxeZKxtDHi3j5TgcogpevEuZr
45996	payment	1397	1397	1678	1	1	17102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKQT9ii45M23ew9pUbqpToHNgFQoGtBoerm9nWiCtKMBnETrb
45997	payment	2134	2134	1874	1	1	7318	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoEsgaCivNDaQg1LJy8ZCs1ht1xt81nEWCrRSz7gyKTFkvr5hA
46006	payment	2134	2134	1874	1	1	7322	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBFkKdrHcc9EYb2WF12YtaeFqsd5YrTGf5MzizvJv54A9FGxrE
46014	payment	1397	1397	1678	1	1	17110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzJ7ZA6wyv2jMvFCR4MAApKtHxNCXz1Dqb1GKBGPnjE1DQv6E
46015	payment	2134	2134	1874	1	1	7326	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwic3dszSG9PAP3jrZUn3VLeUqoBg8HW1RC73BX4b93fFhiDwT
46026	delegation	2394	2394	96	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhhsHi132Qzf98qvoU7w8EJg2K9D7nGDpwjvtywL7ufkhyKT3H
46027	payment	1397	1397	1678	1	1	17115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vsgdS3euKHL922BZTE5gYPetxsTyocZ4w1JfGdj9a81PCjVQ
46028	payment	2134	2134	1874	1	1	7331	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQrEeZgAyUpvgf7gcPQC7fB6XXNfcQ75RfNQdAxAqJCp4mymaf
46034	payment	1397	1397	1678	1	1	17118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz2Jj44t4CFAdvcDoWtPjMyTKFafLnYWzWcvuV5QRUzmKpb12S
46035	payment	2134	2134	1874	1	1	7334	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiLLjgttqXK9gieGuYw7SM5fAAPjoaLX1bfckeE5bdtpMMkCF1
46036	payment	2132	2132	1874	1	1	1749	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKU2mcwkBHCYWWutq412pcREmbhS1RqjoGFELxPzHqDYMNNCZ
46039	payment	1397	1397	1678	1	1	17120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnYDePNxPN8ocrCcVQbJUfwK4YJZeHJL3uy7ZN7WvYS6XV4Xp
46040	payment	2134	2134	1874	1	1	7336	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwLhBBfb6aaJ1bA4BKCeuh4rHM8cnbBrhqmWTrgF3sVFKvWEpZ
46041	payment	1397	1397	1678	1	1	17121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGtpb65caZHSjQNk6Tz3bUCzqjbF1kPxYdNanQgCkpEYLupKyC
46042	payment	2134	2134	1874	1	1	7337	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDCqFJYR988EnGK7zinepyXMH76LZ3SCkdVCqYfkpgzQFhzk8
46043	payment	2132	2132	1874	1	1	1750	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqK57gcaEPfQqXsUXtFLZunW5rJmzhG1qXBrNfr6hZT7zyowDw
46050	payment	1397	1397	1678	1	1	17124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihVzZXKQjKHhW2gXDAjaFmHhNL58T2jFvyAFa7GHZvUMp4Bdi
46051	payment	2132	2132	1874	1	1	1751	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbssxuaRDFm4YC6EVnUfbSQ68WempUYAGnFbfyLsKqif79LWt
46052	payment	2134	2134	1874	1	1	7340	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwhhbf14HwCAwmuzWMPyn6r41fCKmzhxEZAdHFNrfWAW2NQmJJ
46062	payment	1397	1397	1678	1	1	17129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFuLpENof9s4YXkZ3iFzktqToJgeTQbiSuqnS2Z1xKHRfCQnTS
46063	payment	2134	2134	1874	1	1	7345	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEf8S4zPTyFRoFrEMNtr3sF6h5a9Ss3Nqi6ofEzpLtSLZjbkG
46087	payment	1397	1397	1678	1	1	17139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtJYAHtzm2ntESCesyVnH1GFJ1NHUKdaWHi3gvzDzG1rhAT5Z
46088	payment	2134	2134	1874	1	1	7355	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhMb59seKBkKZjsgPB2feDdRD4oKBSP3EFjCwEBZDziv9zFhSY
46096	payment	1397	1397	1678	1	1	17143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDaGS5vj9i5fJF5BqaY5gE7tDLDicrBGtMVpkUkFxagmPoGr4Q
46097	payment	2134	2134	1874	1	1	7359	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGVCg17vMnbhGZmfKivdgF7xKx8rWst4rSTMFNXpqJRDiSnLMS
46105	payment	1397	1397	1678	1	1	17147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBmV65chGusvrQqFfE5AUQiPjmQKFFbnG71qo8Rz7mkYLd5isg
46106	payment	2358	2358	2358	1	1	2	100	1000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpYaNPQ4syiTqh4QtosUYZsz7p4RD3gYzFkcz2bg5xWqCSiXzQgK
46107	payment	2134	2134	1874	1	1	7363	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96nnCW47AdXfcoCVNHFSpyxjMf69P8cFai745JM524phTUdjv
46115	payment	1397	1397	1678	1	1	17151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibrYv8n28kkzf5afKbb56phQP4AJ9HdcQ4QrEcXFoFvvWvJy2
46116	payment	2132	2132	1874	1	1	1759	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxJ6M5FtNtmhd4fPm9GhkY6uuSS4bPnfdeZezawXLhgGWpqRX
46117	payment	2134	2134	1874	1	1	7367	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzW1hzsMHki83pJi5cJycSo5sjyR7obLLqKsME1meAqYZBbo2A
46019	payment	1397	1397	1678	1	1	17112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFZe5huFngpKYdAbm1PdieCuGdXT6rTfkB9bFc6tWjEfHRMVo
46020	payment	2134	2134	1874	1	1	7328	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDaKwDCyu2JoJXPgtZEck5f1iNa8AGMngdjtJvdVV7H67U6xJ
46029	payment	1397	1397	1678	1	1	17116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEyNwo2J1w4A1cna7d6jzTN8NNTEeSYxtXroZUhyRzE3KukH5
46030	delegation	2394	2394	96	1	1	2	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZXYBBk84gtwLTDbWLAbhiivAJe4a7odwDfZ8E4aSwbPvRB5C
46031	payment	2134	2134	1874	1	1	7332	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC2fX6fZtcDG5dr4nvBkiGQENZfLoofgrHeTxaL6EWgQA7fak
46044	payment	1397	1397	1678	1	1	17122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcZvXQ9r6uTFwTS1YExYQptxX9jZKV8XhCCxvyRvnkXEyeBkK
46045	payment	1397	1397	1678	1	1	17123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YNpJeWumLouBCk7dUvU79WAym92an5tZhh7GaFDmFrCSP4oP
46046	payment	2134	2134	1874	1	1	7338	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi79P4tktDEv7yENFea2eL6d68jv8iNKiS3fxEjGGbYbr9YgVS
46047	payment	1769	1769	2397	1	1	63	10000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9jjcokZ7q5FxCE4vYBT6xGUaZF1DXGd8bPZiuwHnuyoALJdgt
46048	payment	2134	2134	1874	1	1	7339	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9qie4ter1NCBMWXL8UUu4gdxspdhRpHgcR3wFELkiUEey4FBp
46049	payment	1769	1769	2397	1	1	64	50000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ajwgAn7zTZBXwoWRvBZJLLtrX8pKXZi1hH55wKZgagrXnVK3
46053	payment	1397	1397	1678	1	1	17125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zqhQK38LgGWphpzhxzQg18MFumG9vX9JcT2XC9PQ9xi3ChFs
46054	payment	2134	2134	1874	1	1	7341	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5iVqNCvgP1ZLEGdoGpUMe5YwF9Susqet99AdPDc4dxPVU9bY
46066	payment	1397	1397	1678	1	1	17131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhZ9GYe2Wmm3JbdeXDsAM8zvsijQKroG18qinQSyiA21kYrTZt
46067	payment	2132	2132	1874	1	1	1753	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfq17Rg8gbf3zp7zCcy5aaecTGbSHdDaUyRpmGG1GqZ6TFs6Z4
46068	payment	2134	2134	1874	1	1	7347	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6zvhnckQwa82DLmEJSjnzsNMSq1dKCUzFnDvJZyGhRhUzfYGu
46072	payment	1397	1397	1678	1	1	17133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1spqsgHDzZjyTvFz28CRbGa2S6ak2dWHctZRVpZDhA6NgYtV9
46073	payment	1397	1397	1678	1	1	17134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcuPSxn3wEy2bykAF6RwVcNiPj435NfzpyS3sbNuWGfjYbfPYP
46074	payment	2134	2134	1874	1	1	7349	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NcEwKVUmfHs9hn7YvAQB6tqUZ7RGvXiu5HNmiALMJfZDKAZM
46075	payment	2134	2134	1874	1	1	7350	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpr1cWnTKGgWJmwmAgJH7h4T2rCH3ynt1pLt3ZGevRx8csGxZZ
46076	payment	1253	1253	2398	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNHeS5Hea1ZnPgB51LXsHQgZfwAwVuq7aYsqUgatwmPytVHMr
46077	payment	2132	2132	1874	1	1	1754	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa56V5x4JCUegsbvEbzP4n1oeCTjqSNK8vNht95yhsLVovtV2PD
46078	payment	1397	1397	1678	1	1	17135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL6PwzfpgmKJYWUURJejjLxkkC9kHCS7nQxv6oA2ru6Sg98DeW
46079	payment	2134	2134	1874	1	1	7351	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxasbXvYNNzW42QcefjE6UjVAEjRLrg3uPa9SsyvBmxcmWuyZQ
46089	payment	1397	1397	1678	1	1	17140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqc7UdX36HefVBoRiCPctZJ7sTrBu4mxowQFocj8QjzjqhRXsM
46090	payment	2134	2134	1874	1	1	7356	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NEmqazvnHpopDBShBAemw9zevaTZ6dYP7aJzWdpiuDHiy3mm
46094	payment	1397	1397	1678	1	1	17142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7a1LqaLLnxMZfRh3ThUESjBXeoRnGnXCx58qLjLynFmDCYFYh
46095	payment	2134	2134	1874	1	1	7358	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHDnaMRoUFKxZwW4sXR8RDAzFo3ozHzut3DBFVCvzhVQeXvtFn
46101	payment	1397	1397	1678	1	1	17145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3rRZxtmkThvDmAyZBKHD5EdHggcrxALxyv1TsqPmtZXEE57b
46102	payment	2134	2134	1874	1	1	7361	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa4bvXBMKmSzWtsiJdLyERxVLMBzRL6mHQuj5sLe8fzZqrvVAC
46108	payment	1397	1397	1678	1	1	17148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTWqBwVdFwxGd5mtiSdSX8GCWFgVvEHxcPD5yy4CeuURYiSYdV
46109	payment	2132	2132	1874	1	1	1758	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWojrNF8WLSMCZo9dJAT9QpQFRnD6bmX6LcqSkn3ntYoSeoU8r
46110	payment	2134	2134	1874	1	1	7364	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkomUMej328yuWPyYPaxTfMiekxSg8NSEp7zok3LuZ4v4ZLkBx
46111	payment	1397	1397	1678	1	1	17149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcxYFTokJgZUdKVzs8E9zuG9fobhmpVtADyyXvdY8iCWY8qxCA
46112	payment	2134	2134	1874	1	1	7365	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfp3VwETQgdBqgb4MNGevBMuo4fTe5WfyESmrJqFFuVgUtoVEw
46125	payment	1397	1397	1678	1	1	17155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ21UcF9BF1umH2zpasCKknebnfPHx9FMvEGM6fVGgAq6gwhXrS
46126	payment	1397	1397	1678	1	1	17156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTfDdhgEWTPNm9UWSxDZLz6YHpAdyUQ2rYhHB5u4LYz3RA2m5i
46127	payment	2358	2358	2358	1	1	3	0	1000000	\N	E4YWdsZTt7Ytd6GuudRH1w4YmxCi3uBFmALVwdhJ5bUqnXtX4CeU8	CkpZsiHbLN6VB51dUtsM6LpnnKAFJDifHgKoDQ6LahpL1HkYUU65M
46021	payment	1397	1397	1678	1	1	17113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCAPbuJYLxhwLNa9LvCGj1xNNttCBYtTTVHB2kXvr9sq3EpAPo
46022	payment	2134	2134	1874	1	1	7329	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtALw6w5gCBbRsYReXnVB5B8hs6v2nEiqR9gTX9ERrsE8jm3Ww
46032	payment	1397	1397	1678	1	1	17117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNcswyyLG245UXWdfcpuv3XEf5g1ohkwd93YbrbmbxvQ7Lo8S
46033	payment	2134	2134	1874	1	1	7333	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpiZDkYLL1MuS9xJtRT95dka4uqNJWVLTWumLztqGqeTbTYk3
46037	payment	1397	1397	1678	1	1	17119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFV115EvnTHwcFVrdMQDRet5mBtac2AapACGNYyJJ3b1Tihfz
46038	payment	2134	2134	1874	1	1	7335	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tdh6KZqmCsWnbWym4U6KcANyhUS5LAVxUxki5QJ6ygy6t4Zi
46055	payment	1397	1397	1678	1	1	17126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAJ9MyRw9jMeZC7cPCJnKEd1CoCmdVD4kWCsfTj6FDj9Tpv5NB
46056	payment	2134	2134	1874	1	1	7342	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHS7UXDaZfayWvFQdYwhL2FYQpNL8CSa4brEgm1XbQ2YRVarH6
46057	payment	1397	1397	1678	1	1	17127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5MtVZy8R7dvXu3ENBdkv43eD6syeNSFnJfReLb8bHA1xYD5iy
46058	payment	2134	2134	1874	1	1	7343	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYK4RGQQ4JLpToDLaY8VvGgVxGH3UgLwibCjr9ZNPbLJuqwwR
46064	payment	1397	1397	1678	1	1	17130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbawpUZ9CqUmEqK2einKz8V6HqkKDLJHTqDmB4BghKLvCTwwgs
46065	payment	2134	2134	1874	1	1	7346	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaDiyChjiKrhTGrvAdGRJLMeGj1jmS9XrFpR4VUajsVvWQPtrB
46084	payment	1397	1397	1678	1	1	17138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRh69CMiuJ1ExV2TsMAfCbUkYM2Vm6GJv6HwKjaDpSRWhN6Z5J
46085	payment	2134	2134	1874	1	1	7354	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVirYth8sHXfPUfyUwHRGNjCbrNQ6yALkQ8KT3d72SkXs18n8V
46086	payment	2132	2132	1874	1	1	1755	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmY7uiY6oR7kDyq5YTsK6UxzrwkHnbGhjyxYQjjYAiMvNGZdXM
46103	payment	1397	1397	1678	1	1	17146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5gJ25z1MwLGVJZxsaaTKmbn4WWXMNk7k9KdXozTs3xnspQhnR
46104	payment	2134	2134	1874	1	1	7362	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXacsPkY2V7vtVKabha7eYvWGLciWbeiJRhwLNyfR17mQFaDaT
46113	payment	1397	1397	1678	1	1	17150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVpTHYMvv9ZP9fXTvkkQsKQmKhD5Jg2oNqjYVfyL8v1yfU7nu
46114	payment	2134	2134	1874	1	1	7366	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gnuogc9YFopirHbNpymYXMYKzFV6PxTkdZYNNxSmur7FQwsp
46120	payment	1397	1397	1678	1	1	17153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9ix2GBhxq7qzYMveGSaE6sUFGCUvmjJGENUSKmpg5PRRjoQo
46121	payment	1397	1397	1678	1	1	17154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfi5Tga7BWs3PcAHiD7ByjRrrYHjNFr2YLu1UvpRNxietxHQhs
46122	payment	2134	2134	1874	1	1	7369	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1i94hcu6CCzr7wg9cT3EGNbLueEWZnXafBjtxRFhZU4N7JE6
46123	payment	2132	2132	1874	1	1	1760	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiEn6XcgwXG729ehNcdR4yvh4mXnsemjZv9tcBHD4Q2HWrHCw
46124	payment	2134	2134	1874	1	1	7370	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4QLqT7zVJK9wpn9h6MgWnz9Ucxq327pmar6Sb4zpepkwFEaN
46132	payment	1397	1397	1678	1	1	17158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJkxPhXPvzeLY3DhxUEh7gK2emS5dgqWVRuXjp1gKSCizgHeX4
46133	payment	1397	1397	1678	1	1	17159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcdGi2LESwRVBAGBGbu8VACLHTqunyVBGjTYGqj8ZgReK6k3g
46134	payment	2134	2134	1874	1	1	7374	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjNyjqdnVv6ABcMPF2vcNyQSN6hdedgikxCNxZR1KnFo8RbGF
46135	payment	2132	2132	1874	1	1	1761	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxtDYR75n4Te6Br6npfHvzYJX4jXixoiwTGRvbvvieFFyrmDu
46136	delegation	2280	2280	1483	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmJ6Y67qBn7g3z7pnX9mSN4WVjuozALwywN6PCwrqj7CsFDbt
46137	payment	2134	2134	1874	1	1	7375	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8pqt2pVTRRQBwh9BxrfLZr7QyhcAvTpwwUTMWYCisrk6ntw2u
46160	payment	1397	1397	1678	1	1	17170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNSqiFt2TMHGJhrchMefCMvaTDAtekNRRoXNssbCyqPVfFZDJ
46161	payment	1397	1397	1678	1	1	17171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZunGvWyKHi2htQaiBGhYSt2uq5DiFULsNT8hY4tb1WysydXQgo
46162	payment	2132	2132	1874	1	1	1765	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNV5o7D3yHbo3cD56ECJTzUzLzoveXPw8XZDhdmi3ofSjd3ti8
46163	payment	2134	2134	1874	1	1	7385	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH6vfZqHmqaTkmuVxrSzdYmdRzuEbPb7xEi3r55jvigHNwNRTv
46164	payment	2134	2134	1874	1	1	7386	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9TxSVD2oQByMNY1nSoD9SrTguVktvzPvRBNEkSyCeEGv9pugG
46191	payment	1397	1397	1678	1	1	17184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzj5dcoj2fnxzxFjkJyjDmsFEShDH28YKUunJAmZ3VjrAMSmm
46192	payment	1397	1397	1678	1	1	17185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRMxV32buPwRGVWaNdNuiu6ThH8EgjvXKTwVsMCMY5PPjZSAnH
46193	payment	1397	1397	1678	1	1	17186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy3FYvVTeSr15RUntvyK8fQ6TgBuKttbG6Znj82TUyLsx36tnn
46098	payment	1397	1397	1678	1	1	17144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWhALHBMcHDjtmeEQDVFhM5xDJSXYErNHDbychWirBdQJcLiG
46099	payment	2134	2134	1874	1	1	7360	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBs9wLFjHtHMNxXWufnkrNk6QV6gE9Kikd8PWJzYU6QrTa3UPa
46100	payment	2132	2132	1874	1	1	1757	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1edxBuZsHwuiw9cd8YgohZwkNDMjm5phLA29NyDtTygCsMAvd
46118	payment	1397	1397	1678	1	1	17152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi5ZzUJqfCXUuhj7Y2jCmcnvGwEuymyBgRZGBeX86NPws4MMxX
46119	payment	2134	2134	1874	1	1	7368	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6i6zixM9f7B7WQpw5NVaxG3szPCPQCUnpkLuzKBSCt9KssMkp
46130	payment	1397	1397	1678	1	1	17157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5GJLgN8hnUgx8kUvtjjK8UQQ7biSs3bHYs1DNHyuKDWXSis21
46131	payment	2134	2134	1874	1	1	7373	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYdGZoqAYYBhW8tT1XgWnwthCiDFCYSkDBJW7h5LhgAxf3N1A
46140	payment	1397	1397	1678	1	1	17161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwsb6d8QXLFvmhNzVRTfhHSQfpJzY1Dsgm63gPZUsD2mhktCL
46141	payment	2132	2132	1874	1	1	1762	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qAuny52RvWqvd7CW6SDdvBoWzWWQVucHgepFShsS3fyTVVPm
46142	payment	2134	2134	1874	1	1	7377	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa86ABQcEXnWXrDmueGQzkWwDwjPDqsDHaLESS4i19PuUQgFops
46143	payment	1397	1397	1678	1	1	17162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9Y6XHDrg1nfdbvfLN5aCvy9wU3xaErFCkPnxHXuM2Zt7majN
46144	payment	1397	1397	1678	1	1	17163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ufQFi7A8ik8tb5RzaAYYJMDjfCXYwEn7GEZiuvTY1Kn2oBLc
46145	payment	2134	2134	1874	1	1	7378	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqvgFFbvZ8USytBuQN4vJrzEjpoXPWSQmDheRcQaKnZVULBrV
46146	payment	2134	2134	1874	1	1	7379	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPgMmMZW7kJMkX5EPqYVGTn4z6EQtphS58ipSLS6caCHMM28i
46147	payment	1397	1397	1678	1	1	17164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBbAbTPyctbpEt3SSzgQnkRSbrVcYDmknUBfeyQ2HXWg3N4UB
46148	payment	2132	2132	1874	1	1	1763	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEyDeU9WJFZBgLw4Ygsjk5jx9DVtQfP7QTjYxxVHiQuSsqv4Mh
46149	payment	2134	2134	1874	1	1	7380	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJg5ERFeRnwmaFDEq57CegWSeFSwYmDwaYMZ8uvLE3P1fZNKvJ
46165	payment	1397	1397	1678	1	1	17172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHwpUtp8ewj8BoHiB7h7J6ntxSLh6mcNHH1XnXAc8Gb2Ry2JpQ
46166	payment	2134	2134	1874	1	1	7387	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QxVCxjbnXXFEDMCpx58yW34BphoUk9ZSYrkR32y1Eedgr4DF
46167	payment	1397	1397	1678	1	1	17173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybnKwSJBmTvR1rhmArfnVeTcCyyyfpthmawfH3GCfxy3pfJ7c
46168	payment	2134	2134	1874	1	1	7388	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbkx3FdeUZka3Yh8oFy3mikNAj6hQnT5GJbRs3EGnS7pL7wnBJ
46174	payment	1397	1397	1678	1	1	17176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfKMbivWtmHqKc7bF9uMKDrvGHpJktr6Eprq4d18cFXVefkDb
46175	payment	2134	2134	1874	1	1	7391	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1BajvXeDWdP2TRWqKNouVreMPrzX6QWNrZrDu8LMai237GXAn
46180	payment	1397	1397	1678	1	1	17179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmeoLgVGuDaoMHYTbTu3VSsRRjb39zmYK2MLxn2jCz77N2hJuR
46181	payment	1397	1397	1678	1	1	17180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddMMFeeqC7R8GUGbwtJtnTndC1cRAkrPR3SUDamzaYiZtMbjA
46182	payment	1397	1397	1678	1	1	17181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGuurzNhZS56fE4JZYdSJyJXLLjZyucebG769ZWQskXd3TK14m
46183	payment	2398	2398	1253	1	1	0	999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi1mfmgRyVzt6LSpeARfx7sxZPywSpLG16h6PSEevY1ydyxwfG
46184	payment	2134	2134	1874	1	1	7394	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx778tMSYcuyKfkYEfXdNDj8MTeGumnsuugGWUiMeScmWo2fNN
46185	payment	2134	2134	1874	1	1	7395	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxRrt3BYEp5Q1vUi8BLMvVRLAcz8tuLte7p7Rzk22qBDQGch3
46186	payment	2134	2134	1874	1	1	7396	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38HGTZVa7ENnWodrGp1sXPAyBYZLq1TZ28Y7FHzdEc6vWxLxd
46207	payment	1397	1397	1678	1	1	17192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvGWwP9ECoB568pL9ixWhKNGSYk8iaD9rdkr28pcQYFhzzfhYs
46208	payment	2134	2134	1874	1	1	7407	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt2Y52gBZUUw9rXpSdj393uLAKGEwdtLhKKG6oBerhRuETYh5c
46209	payment	1397	1397	1678	1	1	17193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzL6pamPpVuLy4D2RdGmQmRorc58r7fMNz65DS5A121DCeRzPn
46210	payment	2134	2134	1874	1	1	7408	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY9gXYqKrjdwH4HYKToFfvxx1gf5dbcxJvYzVRkVVxfoe738p1
46211	payment	1397	1397	1678	1	1	17194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc9SVAhndmMpThxQ1d6Xu973MSrJERv2is2SE8NyAsN65ZBaJi
46212	payment	1397	1397	1678	1	1	17195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7FC4Mb8DqZAqFbjjfu9QnA1aqrNMTRPKMVChGoR52tzfRMN4
46213	payment	1397	1397	1678	1	1	17196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFNZL5V5eVj9F7izDY45rfqCdZD55LhSAB1d4hmbMLo6VECN9Z
46214	payment	1397	1397	1678	1	1	17197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw57Tx27Dkru4dmF51FoNQeUw3ZGUodzKPLZ21KWe5VPGuau7X
46128	payment	2134	2134	1874	1	1	7371	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqAWv4LxBEFoUJ4WVDSd1EjjJArxYKDFrEmHfQtoskyZrtSLH
46129	payment	2134	2134	1874	1	1	7372	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHjqs48KQCEM4LuJMcn1wz3PwjSUdvpEZSYenw3SPYJLRm6dgS
46138	payment	1397	1397	1678	1	1	17160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtn5QauJnbyhQbijM5g51YoQdXt2cZ5DkPSSx79y3BQdUEfdpR
46139	payment	2134	2134	1874	1	1	7376	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBUhGraa4bQwbDd2sh5buWovWfomYiY1cKkA2s4ZB9TnfPymyR
46150	payment	1397	1397	1678	1	1	17165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9Jr2gpphHNS6SsSPKNKV9L3HnF7rqdzR1Hup9qoTVsvGr9tz
46151	payment	1397	1397	1678	1	1	17166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ29MbDS5PyLeTJQZBoHFRpbtqJrd19RZ1TXX1ggLzuAm5u4dx
46152	payment	1397	1397	1678	1	1	17167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrPWPCXpUYzxgfbB6FbmHMXgPpivgfuwgWUuUwCT3cx4oxXJbT
46153	payment	1397	1397	1678	1	1	17168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pauZhMsmhJMsHe4YW5onxuJDZ8RLLEG41bS64vwbC2MbQP6f
46154	payment	1397	1397	1678	1	1	17169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4Xqw68YBWGae8arpG4w1cNg52UriuaW9ncRLpyfjTUvfxRG9
46155	payment	2132	2132	1874	1	1	1764	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdovpVPXw5bWo4bfr3sgwywhgdhiamo52gFQXKxEZLTEwm4cyc
46156	payment	2134	2134	1874	1	1	7381	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xvDueFmo1fzMD3d2hpMaoXXUQKZM3sZoba8c5if4tKTKu8A7
46157	payment	2134	2134	1874	1	1	7382	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXMFtB4BAY9H9HGTGYyAyCyH4nyrsNjVphMr8xaSnnVw2ufL8U
46158	payment	2134	2134	1874	1	1	7383	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJKvFA5oF3Ewyqkc9dA6XY669yoCXYEmjDcoBEft27Md6YyBi
46159	payment	2134	2134	1874	1	1	7384	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XRMN5NYgaF9RBw697WW7samKpPuz6MErSNYR23udgpyYvQLm
46176	payment	1397	1397	1678	1	1	17177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxErC6WmUmP5FAoNwrtfWEdp35HPTSFEA6SQxCGdh2MS64GCx8
46177	payment	2134	2134	1874	1	1	7392	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbgXgHZapypZYapCXygD1YUCEnPUuchyUb5kLbLz1Hh3QV9V9n
46233	payment	1397	1397	1678	1	1	17203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkLJfifUQLMVnCEznRhajqzboeLQaCtx7nwHyGqxKtKYNURGYB
46234	payment	2134	2134	1874	1	1	7419	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSMri1p6rT98pb82phNU3wggKJKXaUdf1uSe668biXbcknW6DW
46235	payment	1397	1397	1678	1	1	17204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusZfCKSYnL1kfsEAj1MVBtmnBqGX6aRMxggQ6qJwaSWeZojBt
46236	payment	2134	2134	1874	1	1	7420	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmJjWxtDKujXsHSYdXvgYN6sKNpYK84gurw67wNGDWu63AJm8U
46244	payment	1397	1397	1678	1	1	17208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPcmRhCMqC3mpaXu9vgszQKaMbEXmHbUaEb1frkevBfzdzVFp
46245	payment	2134	2134	1874	1	1	7424	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMHnhmbswd2tkRC5VRnuzy61kuTBAjAPEJR6GuorZzKguu5Xi
46273	payment	1397	1397	1678	1	1	17222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNboRtNmn9sqKLYRP97uLuJthsBdynF6ZTZda9NxGHLTBEycqF
46274	payment	2134	2134	1874	1	1	7438	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4UqnHmHckYiJGj5dbfMCbhvPvSb3ZwofkCzKwvmrNW9tnxvKQ
46280	payment	1397	1397	1678	1	1	17225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYojZ8XVyXrEYn6c8oRNAeZiFoSNexq8ucPJ25gVRkWv78BRH6g
46281	payment	2134	2134	1874	1	1	7441	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwLNkvgCDFxq4wUCFrbL62sjmLBYc41KFZT5ArxRPMCMrnesR
46298	payment	1397	1397	1678	1	1	17233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpui89u6k8AhCngHzA5NDgs2NQATSYhSN4JQVKHGnv2nW7RmGp
46299	payment	1397	1397	1678	1	1	17234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzoHoSya6ttfUZ2kJJLcd4dtpXTBhLqaf2nrkQrFawNmkoaAd
46300	payment	2134	2134	1874	1	1	7449	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqR8ZqgVbuKxJx92rHQqp78mxhpJYq3kEMCKC6FPFgQLFusAM
46301	payment	2134	2134	1874	1	1	7450	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVW56AvRTjs3qjKuGhkMLiWqrP5hN8sNnAAbRh75mbXnRWo4MN
46306	payment	1397	1397	1678	1	1	17237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcbdu46q57D2WumbescNeZoCoCeNfaewXuoZDVDmgSXrEDF1Pn
46307	payment	1397	1397	1678	1	1	17238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM885XCebqPyk15ovsZygZnLW9BHQyCPASLAntfcsvbqkeM6ah
46308	delegation	2402	2402	1507	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVLj5gcwFFFZiDou1q26dqYkBdsRXuvB9Dk1RrqFV3ZfekGcQx
46309	payment	2134	2134	1874	1	1	7453	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQQ3dCF7GDayc2dKvsByYVjt81mBhL12LSdJXbJmxVmZQRXAND
46310	payment	2134	2134	1874	1	1	7454	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8FqA96gvvUta7eXfhAKkkcSNw5n1ZTv7UTK1DuxijDzPvtTDW
46315	payment	1397	1397	1678	1	1	17241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRYiVGu31qgMHJNf6hnXoJmWSqgQFEXreqCVoptmVLWTHUVjQ
46316	payment	2134	2134	1874	1	1	7457	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHHj3g5t8Lwk3DAv2ya7pkoMN7xjovYTZPjjQ9YGExiFs1m1C8
46331	payment	1397	1397	1678	1	1	17249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4FP7Z32pnsqX7i4FJonBKjSLrDwGMrJsjs9oisA4V7DoWgGGS
46169	payment	1397	1397	1678	1	1	17174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2cN16X6eTKsG3YnnEWTBBvhcUrLhzfAkYBwPbjdSDRdUB5Y4E
46170	payment	1397	1397	1678	1	1	17175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWtqdgKCE8TcE8Pha75nN6uPFBmo3Lphtj2okYZSJySKiYA2st
46171	payment	2132	2132	1874	1	1	1766	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpCmTCVQJSzYCPNPwCp99jZAyJHJp5qwsMSgJ5y15FswriCqzy
46172	payment	2134	2134	1874	1	1	7389	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhiFp6mxtJkvocSg2zhqPZMmkxzzHazofoppiPmh7UA72UKX6
46173	payment	2134	2134	1874	1	1	7390	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuiS81RD9rjbZQ6NHD6NYwfNs89CwAWedTjLfb4ACtJU6wW7XN
46178	payment	1397	1397	1678	1	1	17178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCZXQHm9oP9UwaD1p7yWtXoqmN36pdp17a2LLxorEXZ5yFrAh
46179	payment	2134	2134	1874	1	1	7393	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcen6V9vjBken71kfCCWdd3vxBJgM47thn4o5cFUAkaEZF41X
46187	payment	1397	1397	1678	1	1	17182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1UN7zF6qSgiHa8kPQ59PXv2wxJ8gst1oPoqoPoDLARUubUmh
46188	payment	2134	2134	1874	1	1	7397	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuqCW9bPwyYnN6BGUgqdPu7gKgLX9LQHqbKhKLSsFNaKnotkfk
46189	payment	1397	1397	1678	1	1	17183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWii4Ta1cSoCG4F7xhm4B56GG6dzxpJcrY1TiSUpk46K11TMo4
46190	payment	2134	2134	1874	1	1	7398	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYPAu4ca7xzXz9rwDZy2nk7XHFRVnhH4ZrZCcRKCXtm6JELcbG
46197	payment	1397	1397	1678	1	1	17187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QnZFTRHeoiBedp4JUXwpW6cs8gADDib3dQPtQ1ScwQL2PjuY
46198	payment	2134	2134	1874	1	1	7402	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMRDToXuCyqNv6hLMMzkpBLjcyu3tKEybc6mzSkDYN3rV4Ah9d
46199	payment	1397	1397	1678	1	1	17188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75bmAYuNgwZCoE3HyERVGKtoJeCpX5MbYFtEVGt3dcZnfZMPY
46200	payment	1397	1397	1678	1	1	17189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8evAVvNwjBZY3Z8bYSbRJuAW2zkJtFSaZ5byh1NkkQbafZzR
46201	payment	1397	1397	1678	1	1	17190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYff7rSDHdqknFngqWmvNc7U9vr6fE2nEPvtrujZpPpbP99i12c
46202	payment	1397	1397	1678	1	1	17191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDgfZ6Pgf7Qk3YLBtyout9d1QCsndm6PBznqM3vdPphxwVQ1e
46203	payment	2134	2134	1874	1	1	7403	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ41NdMaFSbznh1QBXDUqdWh8acjGyRfLJawc2o9psPb8c3pdrU
46204	payment	2134	2134	1874	1	1	7404	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa6dH6gw6NDY5vFKEnXxkm5CNY9Xi5sqCCDkk4BMyqoGyj3A6U
46205	payment	2134	2134	1874	1	1	7405	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PBtTVSEHruuq4SAoM2WMdzabXnPrqdnmjYLswAdX5tnnz57r
46206	payment	2134	2134	1874	1	1	7406	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eV1VjbYnMdqGAq9ZqMbKZVcm5MfhCpXTQoY3aJHrpiMPCTfa
46219	payment	1397	1397	1678	1	1	17198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEAj3psomMGRHcwkzLh2aMFajhEdTgKDAcDuccmZ5UPft9NWT
46220	payment	2134	2134	1874	1	1	7413	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsp7qPm7FTwNvCRqFZA58CKiEEXZhPh1jnwbsEuRw3xk5znjrD
46256	payment	1397	1397	1678	1	1	17214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1VzqzsR1KkgsD6NT9jv6ABiPkswTcj3GUQVwHhuzdXiKHUXE4
46257	payment	2134	2134	1874	1	1	7430	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzA8BrS3DwJPLKHfTpw8SfkJjYku6TmfEGbLTKHPv4fk3NPk82
46275	payment	1789	1789	2401	1	1	2	2880000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcakE86wbKUA9tfAcF2T1k8qRQHViNBmZVpUDPnxDQiUZVmo3
46276	payment	1397	1397	1678	1	1	17223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5NVLXYcmfs51TTwLfYkTZ4YecG4Tx2TU1rafgZKnPLRDSyd6
46277	payment	2134	2134	1874	1	1	7439	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSMXUwUHSnrCeZrQu7rWdCB1wsEqPD4vxLpn9NHQsSELAsYuSP
46278	payment	1397	1397	1678	1	1	17224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZjnEbm24ZCnsjKP9GFE7Q8hs7vLkYcX8MxLciiqvdkEYGnLbr
46279	payment	2134	2134	1874	1	1	7440	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPcVVB6Cx18ka89L9n7mAsXgiWWvGr4QdtnZzyYDGeA6fCAS9
46284	payment	1397	1397	1678	1	1	17227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCjjEKdCdkYKNDSMiGYwt3oxfuV7KRLwCstvdn1sE4ovaxgRU3
46285	payment	2400	2400	1379	1	1	0	999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjBWDzYG2titx6mPU5wyqXaJCfwnehZaoDCyogQYgYJdGp2Wj
46286	payment	2134	2134	1874	1	1	7443	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktPRfnxMJdFmAURMHKBe6A9XUuZHL929hePUq77egbRgvxySH
46293	payment	1397	1397	1678	1	1	17231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZxJSRkrQfPoDK6cvRQaD67SYM6PxVmV63jyEsAcJLJAoAPRbS
46294	payment	1507	1507	2402	1	1	0	50000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhQW8FFmmZPcWQjupPDTaShZdMJv1F3fAyFzjuMk19XWuis13m
46295	payment	2134	2134	1874	1	1	7447	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5TjZqCKqga4UcGdJGg6sg37j2ag64GNV8v3Eow5ag42Nq9HVv
46296	payment	1397	1397	1678	1	1	17232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqJyMjTQE7Wu2kLLzmY5C44yThJ7kNGYnzYfE8zJZ1pKGC5SL
46297	payment	2134	2134	1874	1	1	7448	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUf1vm98K1Yf1KQ4wR376cXGgEPMk6vcxi1tM7iaNjMJFNofa4
46194	payment	2134	2134	1874	1	1	7399	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiefRs4xyn34Gh4XbYRTZHwMktHeDt2ujNjWW3g7LGBpN2May2
46195	payment	2134	2134	1874	1	1	7400	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1DQEoGrnYZZbf8kyUHVwCSvE5Pa8SnyuWnaMPPJwd2BcCC45
46196	payment	2134	2134	1874	1	1	7401	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGJrMuzmW2NQqnVzR1EiaSrEvmG4HeEtvhuiV32RznUpN38y1k
46237	payment	329	329	2401	1	1	7	1367000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pJvzNYbcsyn3r8ZGDPyEmcsfAMRWb4W3tPf46PtWyngdFDGB
46238	payment	1397	1397	1678	1	1	17205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAKfVFAbg1kAfCNgegy9TyLSy2gcXvD3YrKXBpysheazieq4av
46239	payment	1397	1397	1678	1	1	17206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsPsUDSMAxE27YAaNnhg53CCfEzCYgnDoVByRJxtfNyxNoEcb
46240	payment	2134	2134	1874	1	1	7421	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFJLGRywV4Pa2VwGK5AbUArVkFBW4S3FHCiYJ4hNWp5VKrmQjD
46241	payment	2134	2134	1874	1	1	7422	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7bKP3fe4kU9yr2gcHnosHMzxUQdBbLLTr5xCaehNQ5eohLM5
46246	payment	1397	1397	1678	1	1	17209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYixzBu86sQDR4bmBUEpKR13vYXgc6A4kyMU4oEZzihU4rYgnX3
46247	payment	2134	2134	1874	1	1	7425	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnBBja7yCEWh4VKwS8vcxZ3vpkzRpfbN8Ro3k2pheiRwFAWxKT
46248	payment	1397	1397	1678	1	1	17210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDmLmLte15NuX5dtLCSdqgEfhet3fpS5tJhkBrMX49HcfQGqxV
46249	payment	2134	2134	1874	1	1	7426	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbY6AP7Xm9FedGDzES6iWKfxg23BWvLFRC9NA6HBAvbLcRZwC
46254	payment	1397	1397	1678	1	1	17213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGEQXas5SNZBwGzKWi9qUyPuekBRgyLhZ84YKMj48FkLsDdA4j
46255	payment	2134	2134	1874	1	1	7429	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodhRPKmYa27o9DpknrMyn5S5fU8WCpvK6WzUSq8iCHqv3xpBY
46262	payment	1397	1397	1678	1	1	17217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEohhAiCRbZLagTGkBKxuApP8fLXEhUZhLT62jprrLM1fiLsAB
46263	payment	2134	2134	1874	1	1	7433	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoWZeRWMU5cLpuvdjGAMWKwPpRqRDCQMWUH294AjxhTvS58sY
46264	payment	1397	1397	1678	1	1	17218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZtU17FuecwNSF3yyrLThK7qdxLWy9VqJSFhg9dTciHb4CCBG
46265	payment	2134	2134	1874	1	1	7434	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jWKTGtbsnc53DRGdPm9ntnddfMd6n42URNLMDq3sUQWzhrdo
46266	payment	1397	1397	1678	1	1	17219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7gKkVTApak9SGYfcoTQC1ZxSjfmbopnd88uT1TP4p3JezkbwN
46267	payment	2134	2134	1874	1	1	7435	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwoCqCYTDSsoH69kCXwN6Z1P9hSHXsuVbPt9eZ37sGWNrgcLC
46268	payment	1397	1397	1678	1	1	17220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvZa2M6bjHXJ98ALnP3gZzjE9WKZmwoR12U4RbeNYgi7UUnGJu
46269	payment	2134	2134	1874	1	1	7436	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDd9LshhCiCYSbh45MuS3r774bVPDXkKpszqjAQSDTz2BRjTv
46302	payment	1397	1397	1678	1	1	17235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnv3UWNMoCKAZKyzdVCAggH5djhPvyoU8Taf9heneeXTu5o84D
46303	payment	2134	2134	1874	1	1	7451	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfh5xop4j9GvipSsey4Z3UiC38HqbNhs6S1UVQuXGkGNaXhdn
46311	payment	1397	1397	1678	1	1	17239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwS7yLTcP1JBVQutfWon11cnDDXVu4mKZTHY3c2bqyTTiYsxBL
46312	payment	1397	1397	1678	1	1	17240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCeQEBv18aCSacJyGjoY1MCLQu5u3LvkFaqDoCWXN9PDDuCGA
46313	payment	2134	2134	1874	1	1	7455	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEV4wwHP7hMQS6qXoH8AXM1Zjt1nCDL2YaDScP6n2zVXpgTkZN
46314	payment	2134	2134	1874	1	1	7456	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFaUZTGJT4Z7D3FCeQGRPsreDdRkfz3FSLnzMg82yjCvtT2iiz
46337	payment	1397	1397	1678	1	1	17252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9Qnk3BH2FJWxn1aePdDVEXmWbVy7xW5T8kmLUcRgjrKjinLkC
46338	payment	2134	2134	1874	1	1	7468	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbb43o4egZwAjrcyf3oFubET5ZakGXejWn2Z1GgDoaibzDzZnB
46355	payment	1397	1397	1678	1	1	17260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqsWRvnZtZ4JpfcjVt3HeR5x4bYDnca7zZ9vBKzUz1SALKjQw
46356	payment	2134	2134	1874	1	1	7476	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFu7L3SY8HbmwZdficqFPVohsgfiuPWiThqzTDBG9RdD3vkDX
46394	payment	1397	1397	1678	1	1	17279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGrhrqWXdJfeyVi2BPnxKeWgSPUuJydhsmsBZNzxEv22LSqDWC
46395	payment	2134	2134	1874	1	1	7495	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrT3MNE8EWBcNvYoAcqrDXukBa5BN7X2ffY4a9rLnde1ozm9uv
46411	payment	1397	1397	1678	1	1	17287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3vXZu3vAmThXeVaAy8XxVKj2uiYJZXvk7h5mxhR73H213vuFo
46412	delegation	2385	2385	121	1	1	1	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9xNjmchMrNHWW2PRAxn63ssghNa6TT9pjEZSg3EnxA2ymTwT
46413	payment	2134	2134	1874	1	1	7503	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwuYGpMDoRA5SnMAsbaCVf8xWkxuRW28ij6RBy5RKXRj8k8YQ5
46423	payment	1397	1397	1678	1	1	17292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5o8zN9fTs5f5jyhtrD6j95ciezFwPCmnNoYiiLbvy1zSpDCD
46215	payment	2134	2134	1874	1	1	7409	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX5kxxdoxKirsNyWchw7Te3FB43wpXRwwRD4BvkmeNy9t9PKt3
46216	payment	2134	2134	1874	1	1	7410	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxrp5qLCjTTMZS9tkkSsR9Tc8etztJaQyKm52SD2GP96CXpBTg
46217	payment	2134	2134	1874	1	1	7411	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1ALYWG5ufR9h8jLcFWVqMGohSsdWemmg6SEef12fXsjfzBm5
46218	payment	2134	2134	1874	1	1	7412	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZpyCevdvNZn1vGrnVxp9hVDejEFWZDn5LVdm4hY3WSBq3X7v
46221	payment	1397	1397	1678	1	1	17199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDU5axkoKPPrtDKkfW7v9txNttKhkrqwvzmBwPR5DbWM9J1FJ8
46222	payment	1397	1397	1678	1	1	17200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxUhbzuDUXqY1sqnarBg8U2cCSRQeKpfjzoTH9aHwAmcXCdnB
46223	payment	329	329	2399	1	1	6	75000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSBbVh69uRLihqxm3svMNPPCC61gKy3kVaGD9hw4RUJuonrab
46224	payment	1379	1379	2400	1	1	0	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGirJbNNyeeGR7893uZwjSsxin9TqqAWy5M2FeDktWqQdJKYNG
46225	payment	2134	2134	1874	1	1	7414	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQEysJthPotBmCF29ESHMAWiAtC7d1MT8DXRuNWpSWt1z8ShW
46226	payment	2134	2134	1874	1	1	7415	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiBGSqrZeHEwKMKKDZUC3ogroyVvWoEYNxP4GKLbJhez6f4xzU
46227	payment	2134	2134	1874	1	1	7416	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafvzj6aYdjAtwG9j7brn72oTSzgCtMCt5Se81fw7MDiutQFfJ
46228	payment	1253	1253	2398	1	1	1	607902747000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAxZkF9Qc9i4ud4kjEZ9dZjH1R4v8PE6mp5kWtH8u4EwQzersq
46229	payment	1397	1397	1678	1	1	17201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdsAsX8TzFcnuQDdEZ6dg4d58aqFsRo54ejAAm14gs9EsuLn4C
46230	payment	1397	1397	1678	1	1	17202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz1dcRZHr5auZ9bfowqKn8cse94fWkN5D21E5RLrP6PT5ZJC4H
46231	payment	2134	2134	1874	1	1	7417	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZrKfhopYMBeJFKhT13WqT7BD9mKFo6JVq1ra8uDxJcT2ScAv
46232	payment	2134	2134	1874	1	1	7418	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgEmgZPz3RAfGwxSs9V95ZoQPi3SLWKkX4WXR9ovx58A6gxy4g
46242	payment	1397	1397	1678	1	1	17207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBqALjQkQpk3gcWP42M1eqzkV4zayAB4jNy84G9dM6i9TwT2g
46243	payment	2134	2134	1874	1	1	7423	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSzsGkJMiG2izhdBrejNXiJuURPsqBViXPA8trhJcjdcEjejK5
46250	payment	1397	1397	1678	1	1	17211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz5JmUHV2dbDmmCpWxvdMnzv7CNWufJEQUeze1zDmX8YG6R3zf
46251	payment	1397	1397	1678	1	1	17212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwrNwSJ6qBgxtYRbtkWSipFbGV8NUMiL3Ez8BjEGy7RD9ZJbJr
46252	payment	2134	2134	1874	1	1	7427	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5DLBkS7XenEgT6XPWKsTw3s96L8rSimt2EB3aJrCRrrviTpzR
46253	payment	2134	2134	1874	1	1	7428	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1CJEBohnd86116xiVk8JDYz3czbEuVyxgJLEJxPmpFXVQVEvg
46258	payment	1397	1397	1678	1	1	17215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjn3pmdnAiRNHgE9XFazrv7uH51rjGip9CgmbgdpdYmAyS43ft
46259	payment	2134	2134	1874	1	1	7431	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9YTkMnrrXfNSp6NZB838rhYCoB2xU9QuW7WUWoymTr3NgPTZ
46260	payment	1397	1397	1678	1	1	17216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA5YAZtFnjo9YjRp89tPT9hv8fQTsT1RVGfZeA275hWbApKwhx
46261	payment	2134	2134	1874	1	1	7432	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7iwVL5aBa3VyizgUqrSvHCzJFyEbSv7jZPkGX4RrEYHsMSxPd
46270	payment	1789	1789	2401	1	1	1	710000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyoJy7Zi5iEh2KJRfMMcrX6oSFp637LzSkntA38TspGMXqaD1J
46271	payment	1397	1397	1678	1	1	17221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Ew31JCm4kEboyVz6gT9AosNRW7Pt5UF4ovBKvfnfKQxn6zN8
46272	payment	2134	2134	1874	1	1	7437	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Cw7VELbmDYW5GNXdYCrHdbUanSGyz6BzGU5F7cDDnJ8Q79Hq
46282	payment	1397	1397	1678	1	1	17226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq7Mt7Ev5f2rhKWHdPjfsGMCLbJphRPabD2AHa2fVemxqm4bwP
46283	payment	2134	2134	1874	1	1	7442	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDtTaWBMxd1AmMiunYUDJTgtTJebk9ZYqSvuR5cvCcnyS8DWXv
46287	payment	1397	1397	1678	1	1	17228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYabhz17Q4GPeReeZqJq57KcgWTvC3PwNHUBb6QoVjVRCQCW2Jq
46288	payment	1397	1397	1678	1	1	17229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZii8u2CpYKThNzEwKmVP9DkJMGmmEbmQrYAfKHRiQshDhPXpVW
46289	payment	2134	2134	1874	1	1	7444	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzFBoPBT2Xz3736JfKCLaqJ6ufKrnyMu3fgHLYN7oRetw9vcZ
46290	payment	2134	2134	1874	1	1	7445	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKP8Db7qq2uHk1QJd7Ja7aU5Z1zcVngaZPMiohdJp8giufPvS
46291	payment	1397	1397	1678	1	1	17230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGurjyz4qeDmgvMKFQQCD4DDAzFTmQdfJcadHub1TYDgxLFf2
46292	payment	2134	2134	1874	1	1	7446	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxsndBc4tzAf6KXwJbQm2jnMm2m7hGbcw5DTCCb2obFJ8h3gj
46350	payment	1397	1397	1678	1	1	17258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQsgbHaPpZxHdt6CHSWwt13ZXES5CkyPcNWJUnFRvRYQ4pJ4gw
46304	payment	1397	1397	1678	1	1	17236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnHnbDdvH3zuFic4LGkAv3mVh6pE9NWKjCwvNuHSWpEBFnqp57
46305	payment	2134	2134	1874	1	1	7452	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHq73xc46HYV1bejj3KJxsfEciTWoYhAWvo1tbcUiDDJu9guN
46317	payment	1397	1397	1678	1	1	17242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHSENhdyCUPFx9Pqd33WcmBUvtFoaHaiZjkZJkMw8jszpMLZQp
46318	payment	1397	1397	1678	1	1	17243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpzMYmiiDxxzsEaU1f3TBeNjpwjiiJ7qXUdKdiiiXHA5yemMgP
46319	payment	1397	1397	1678	1	1	17244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgpGdKGQBCjkdbJhEN3ASK9ZxEt87xEMMEHqi4qfmnpxMnL9M1
46320	payment	1397	1397	1678	1	1	17245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWpAAHGtwRNuwxxgDsPqd1rjjZcySBBykXbFkEsJEy33QGTaC8
46321	payment	1397	1397	1678	1	1	17246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAGvysCiAJ2BDUwqUbR42LpL6o7PwspNavf97i8whXG7cFoVe
46322	payment	1397	1397	1678	1	1	17247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaSPZtsXSvZ2j7WfGq1z9o1MkUEEQKc6ST8XPeEeRoP4Q8jTPw
46323	payment	1397	1397	1678	1	1	17248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7JsZhAz2wJ8LDE49m794FdaK2DdeJ5rgeM3RQ36EbvNaaoNd
46324	payment	2134	2134	1874	1	1	7458	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCsYwrGNPgYtTjjEjAa3JPPSCsZv59rfLcASHsDXBuu3z1XeYh
46325	payment	2134	2134	1874	1	1	7459	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6ZEZvPAVP8S8wfKr6adhjFHVppNbgG5FJYCYVpJfEhG9mm3o
46326	payment	2134	2134	1874	1	1	7460	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW38ZThAo7mQYjtDRAgwce8yCtXyUDbYFEfFw5kC8RM2PnGYmz
46327	payment	2134	2134	1874	1	1	7461	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqgPmunUkxUEj6VM95o7gg9jdS3vxcPcU18Ly2JgwDjY5NFuFe
46328	payment	2134	2134	1874	1	1	7462	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhkkAMmHBMETboHWYFD3894rjimN5yZ6w2buxrxfnjWmN5kM8x
46329	payment	2134	2134	1874	1	1	7463	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg7xic91EUKV5QKapbsqC63pbPRnujQ5f4USGYqnpWqyw3uK2Q
46330	payment	2134	2134	1874	1	1	7464	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9c1Fvwz1H3jUtE1DPixukCAhd9EVwoNegbZw2vqgzpgWkki6C
46333	payment	1397	1397	1678	1	1	17250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6T9G59fG5B4ociTHRdxaeG1D6gjAqWKSjRRTLgNjt836L5at
46334	payment	1397	1397	1678	1	1	17251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6Xq3GN5BYPXXH5EHU8coXAty2Gwjdofwrm69SAcsxSKcfcQbj
46335	payment	2134	2134	1874	1	1	7466	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgqgoyAz6qGZYFXigwDNjN3VgZax2LqExmEivQFqgUiPuwsmSG
46336	payment	2134	2134	1874	1	1	7467	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTefUfepiWHAs5w1zVt252qPbg8WGiLPMAsvzX7oGdZtFZtCd3
46341	payment	1397	1397	1678	1	1	17254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpE41mp2mBeZhTaHPnARDHpBJjMZyBzrkekycHEHgENtUqBM4v
46342	payment	1397	1397	1678	1	1	17255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPhctTPM1xvTR4So7oVtLEAUbGHbVPzANBeVMoPmRW7D4uNxkp
46343	payment	1397	1397	1678	1	1	17256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppPnpacWo14BLmFwUL35nunduZPVaJC9wUymqoeZU7ccaVUsw
46344	payment	338	338	2403	1	1	1	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8WiDtSj6E6i24RNFVb9cKSh5DQAjrhHyQr1CfbNdV3agFBXm
46345	payment	2134	2134	1874	1	1	7470	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpGiWAkQcxzK8Hvn1eZ3aksKSSywnPHffX7kEjtjK9Xd3MZdxT
46346	payment	2134	2134	1874	1	1	7471	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGsVKkp2UwgfgBqxqEazuwgkgJSqbM8GtXHe6NvqPztbmMDUwW
46347	payment	2134	2134	1874	1	1	7472	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZM7dcQz7hVvQwBSXT6LiLUTe222xdscLVdVyo1HWohThXB3v
46352	payment	1397	1397	1678	1	1	17259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMrZ3G1PN5YbdeyqQGXa5HjDFysaiywjZ2tL6hkasbcUT3ypq
46353	payment	2134	2134	1874	1	1	7475	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXF2JaUj4iQWUtrrXTFkGxedAMmswkXPBUUPye3KgnvhLdMBdt
46354	payment	338	338	2403	1	1	2	438000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZzZuoE8eeYdCLufnqkjWtoYRPSe62rKytnKBf2ideBgwKw1t
46362	payment	1397	1397	1678	1	1	17263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeXz9ERWFrJEncMkAU6FTvp921DKyUTnE4oV2X14Uor3UpRjQD
46363	payment	1397	1397	1678	1	1	17264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjkHomMp6tUfCq3rTpQgkbs43SsSBjCZiABWKVrR8iFmitZt1b
46364	payment	2134	2134	1874	1	1	7479	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp15gWNA1dCCDbsfcanUbzUBDVTQSGhr1e2ZxqDTZRjkdh75GW
46365	payment	2134	2134	1874	1	1	7480	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUEN72VRSEvBjzSidrnxH8THozEdY88HhYuj3hd7Hau91z3me
46368	payment	1397	1397	1678	1	1	17266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZmja6R9tiVhZNshzRugtZtjnwDgcK2efm5FFAJz5mcmSvt3m
46369	payment	1397	1397	1678	1	1	17267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPoPNQopxxMZJgSzUrLabCguRFAXS4wchDu7BX218tDEp1YkT
46370	payment	1397	1397	1678	1	1	17268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaywARCn5VRVr8r6zkhx4mahYyVnw9fwQm8VcjzKvU66Xjkqfn
46371	payment	2134	2134	1874	1	1	7482	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuN7mwcCCUGRcetdDKinC4ZroA35b7pBKxAoF5FrJGKGUPazA8
46332	payment	2134	2134	1874	1	1	7465	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQqkaB6BhkcbUL7BVWwtFoTu6NJnLWDaKwkoMcrZqwyYP2ByXx
46339	payment	1397	1397	1678	1	1	17253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyHGzXtT3diM56F2pYjmC5eiRsiyti2pjHJGF9DqibWLLW8hm
46340	payment	2134	2134	1874	1	1	7469	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifeqcbZokUN1e7TqMErKneJBJyLHRSJyLGeySudp4jrBSamC5
46348	payment	1397	1397	1678	1	1	17257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaAUUf7PAZ4jbUoSxamNs9MvEEg33seZnX5kmCS73KodBK7EzB
46349	payment	2134	2134	1874	1	1	7473	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBLBiy98MweUJRTBYMcCJqxQoAuDiDEh1QSFnU5gxhntMtMMHh
46357	payment	1397	1397	1678	1	1	17261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGf3bY6mmQUzZ5vyuc2B8gXWm9QJmYZwRWdHeH7id4PioQyegn
46358	payment	1397	1397	1678	1	1	17262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKPrSFJgK3MMwxBkqfNNACy29neKteo9iDHKSfA5LV191dgf8
46359	delegation	2403	2403	338	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhcK8aE68mBhrkCwCvfqryxQoN86uqZTqNY1gSorCNK4uBqFUP
46360	payment	2134	2134	1874	1	1	7477	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCDx2LQupS2WrD8xBv5regVQWaSrDzyRSViab2zEHkSG6vAD8Z
46361	payment	2134	2134	1874	1	1	7478	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VNs46KWDP55Pn75bqbJkvFvMVzU8hsopGE8iQXbck1GRgwbx
46378	payment	1397	1397	1678	1	1	17271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UR7opnJ4QseSoMhfP4qcMHwHNDFL2eqeK5Vc56nvffq23E1R
46379	payment	2134	2134	1874	1	1	7487	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7t86WaCJa25J24NpDfpwiEYbrq9btwLhNdfeWLJXXNPSb9TkM
46380	payment	1397	1397	1678	1	1	17272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSpyh77tdSFkJzWJjfrs5oqoPrZGEnT5PRvC9QmWuNwnUNiQFj
46381	payment	2134	2134	1874	1	1	7488	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtnfKHQT9NB6PfRerr7a86K81Lgx8bUcj6oHSnYuea5px6TLt4
46384	payment	1397	1397	1678	1	1	17274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShtD8TfS9Q5ijRLwUCNQZxAjgMb8PjxtZwgf2sPhPj6QBYs5J
46385	payment	2134	2134	1874	1	1	7490	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnWJP8uqp1fSCcPVNfkDh1NN39XhR1NJ5EipZkgLQyQQqvbw9m
46386	payment	1397	1397	1678	1	1	17275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcLqJ9YBAGBBt3Pifcq6t2R1E64btqpPU7fYm39YGRFjyNKez
46387	payment	1397	1397	1678	1	1	17276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTcRHXiCv6LwqMdD7BLacA5VyvXRHJYcW5vm3QddtMejyU25yu
46388	payment	2134	2134	1874	1	1	7491	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqfsxnKaWgZukteXGS6tAeizzRvy3tjKgFK7bU8mCUx9CTEub
46389	payment	2134	2134	1874	1	1	7492	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZoRfWNB4aVjwSphQuNmD2mDtg79YePR6PfRF5pY1Preu35DE
46390	payment	1397	1397	1678	1	1	17277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqi1XUDPwtfcifS59r6VLcgUt72bBEefe6RXh9sbyRDmVkPN4
46391	payment	1397	1397	1678	1	1	17278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCotAh33fhen8MdwTjceFcnKGRfTVF6KSyCrJB7i39QvkJW7nU
46392	payment	2134	2134	1874	1	1	7493	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTpk1o3TFNvNN9Kk2w5u9qtSRdp2LHqJGCFtHqtZxgGvCfJSMk
46393	payment	2134	2134	1874	1	1	7494	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUsdisam2TfoutEvvvYefpAvWp8k6HMgEJtgAYVZtgRwcu5Xuw
46399	payment	1397	1397	1678	1	1	17281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TtmPvEKboQRgkUTbghU4S5FkuokjjxEQkC2q1T7jMgdYmtac
46400	payment	2134	2134	1874	1	1	7497	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5FbWXCAUUMNxz2nG9xg4xUiaV5pg8ukFo3ghBvM7HZdt4YWrf
46407	payment	1397	1397	1678	1	1	17285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzzZQEBBMU9MjHAebhhkEX4jhpAKtAcjW2k71MRVbspXJtZi23
46408	payment	2134	2134	1874	1	1	7501	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1467ZkL4UJxvwp5RVua1eYp1CegBvkJH7iKr6KWyxcTMVC9fA
46409	payment	1397	1397	1678	1	1	17286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQaEZ2eKnzHGkZSmj3EdJ1KsnuKx6bnVbxKh1ZDwyHeUq5qywP
46410	payment	2134	2134	1874	1	1	7502	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5xy4sofkaKH5JR1aPjHpCCMorHHCX73XzAPhfjHPoBCiKrEK
46425	payment	1397	1397	1678	1	1	17293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacQEBnuNscPKJoNWGb7f9X5KjE1cGtikjqbeuYFiJMEi7WFcL
46426	payment	2134	2134	1874	1	1	7509	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TZZu7sDzWwGz6A5927sMKzyqJe15m7rF7VmZbaj7Wj5VqPBc
46436	payment	1397	1397	1678	1	1	17298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkMSS9L92GZbEmr2H6UA2mnuf9QyUK6YKMSJCSNMN4V3qvwU5
46437	payment	2134	2134	1874	1	1	7514	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYpAZ7Cx9n4k3dtR4x84FiLRx7k9admQUs3ickWrfhFivXeLv8
46438	payment	2133	2133	1874	1	1	6863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnP61NSD2XCzGZtRMyQqb42SoMaPxi8hH8yE4U8iMuKA3JnKF
46452	payment	1397	1397	1678	1	1	17303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFPRGQ54yLSG8GKMi2x3aKBmL2EchmVqpEMA6EtEwKAGzTqMpr
46453	payment	2134	2134	1874	1	1	7518	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkA17k2ndvLoNtsFX7Ba6x9LpWj1LbmdhEC7gGTfPEfsbus1fk
46454	payment	2132	2132	1874	1	1	1767	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QWTZ4aU7m6sfFBtvLcCXQVubY6e7QXKPsRo5HkeaVMuJuxDa
46351	payment	2134	2134	1874	1	1	7474	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCLKPxFwpnCuneTwixLTMfTRcQtzF5YAmkWTcAZb5djbkGBiVZ
46366	payment	1397	1397	1678	1	1	17265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjtYbwSBKNHWPQUZL2KFwTVXPC5Yt7oK6cm1c7vwDxTQGCB4Y
46367	payment	2134	2134	1874	1	1	7481	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQdrBvfgPpLv1UVjsMcXpYVoTUdzvntGHr4ZrjNeJvMBFJFoYe
46382	payment	1397	1397	1678	1	1	17273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYS1abFs6f6e9RGaW86HmT2GvyhEXCJ7j4kts8GjYo1bYpsF5j
46383	payment	2134	2134	1874	1	1	7489	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTBh1BexsbmaDgeHP99oVgteVnCi7NGViyya8SavSFoGSFUoq
46401	payment	1397	1397	1678	1	1	17282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrifRnUZisNQzoHUuEd6bhV5fVNFTS1ZqpKZcKyLZ9CdU88uU
46402	payment	2134	2134	1874	1	1	7498	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzKJ9FUuRXoXq9TE7XCh8qKTQoiEwxJnhQYrBJArsNzoF8ebq
46434	payment	1397	1397	1678	1	1	17297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTksAdQSuLt4peXRxb4GxkiHKBN5vcWgp9Xuz2n8NNkhDUExsU
46435	payment	2134	2134	1874	1	1	7513	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF46W9hx92YH8BvyLpMKgyqFqujjvZLj6dHdj9pcbmzHHAbf2e
46473	payment	1397	1397	1678	1	1	17308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wmh24BCz7J9wpycsBmigd2UnChvJKqVhwvVdKqgZwrViLXai
46474	payment	2133	2133	1874	1	1	6874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1DLqhj2QFyPHbkmcvHEoAh4bjHLq5Ph57nox5axXCupkiUrF
46475	payment	2132	2132	2386	1	1	1769	140000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwuETW8zxgWbJaUvzv6rkK1ZyeuQzWBtTk9CjPh4X4M7jpj52m
46476	payment	2134	2134	1874	1	1	7523	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG8JioYc9twMfkWtSGzDd5fzXXVRi2E41fXJer2i98TdzRPiVD
46488	payment	1397	1397	1678	1	1	17312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBKue32K7MhLFB6sHRvYcV4xVxrQSzr7HRe2tddyBdvUyXUopL
46489	payment	2133	2133	1874	1	1	6878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSAcM6ubh8zkqz1gGjd3AyeokcwYFT7BnCYKzKxP53hzmfRDW
46496	payment	1397	1397	1678	1	1	17315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRw8KSd285Adtiqy8rWG4LMqr2iQ5BcbzhaeGwQ7sh6eZmi3AP
46497	payment	2133	2133	1874	1	1	6881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBemQeMZRyjYP3pTKzqY8dNBg9UHDk2t5h8GToYLos9qoaoZD
46522	payment	1397	1397	1678	1	1	17323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7Bf5ujoSvYoxr4zfiLNFu7adz3EGrvMoNrC4hgezrcF71zGx
46523	payment	2134	2134	1874	1	1	7533	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC4TLfoZDDwtWCYsjwtvXyC1EfNMM5Tfifiuhwr1nT6whR5oj
46524	payment	2133	2133	1874	1	1	6890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1TsjT3isHhLKDsQ74frYahgBiRmgxNfk841kcJ84GU3MZzER
46544	payment	1397	1397	1678	1	1	17330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAtFNuxivu8v7t5Z4mPWQgMhYaGCsneKGCpNpNQvp9zkttQMYK
46545	payment	1397	1397	1678	1	1	17331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1KDiQnqGtWPKxVH9tiiaq7oRh7DxaZWvYjEpp9oJh8DkKBKFC
46546	payment	1397	1397	1678	1	1	17332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK8mRNDjGSm7ex3DZT54wo1h5RQwtRhnEPQVrAW7XTgffGKpWZ
46547	payment	2134	2134	1874	1	1	7539	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2D7NsEg2ncv1hWx6N7ftgb44d2QhwXZu65czLMznh1wypy8i9
46548	payment	2134	2134	1874	1	1	7540	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy4gS8tCSM1SijqxeUPcXFgBE7CNFspUKNMJNB4osf6hvQUbCy
46549	payment	2132	2132	1874	1	1	1777	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yP8fhVJ2muYUTw6xKwWGtoPobb2wKyTX3yf6GNBaPgGR3tY9
46550	payment	2133	2133	1874	1	1	6897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxQeqcGZsUBv8yayDrPsQ2nrFqZGE3diKRWyEYydBzDr5iHDh
46551	payment	2133	2133	1874	1	1	6898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8CDo4QFQ2dTBocM2XUVq4Uj2oya4RmpUejy5MZTdU7TzPiFxn
46552	payment	2133	2133	1874	1	1	6899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb78zEWozMjmg5L7uiTvysUCW6i41REUJKfDsS1qS6iJksP5wc
46572	payment	1397	1397	1678	1	1	17339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1C817USkH4uCQe6sZFMWi1FkPzm8VnAGmUiz4pzLmEqXeMeg
46573	payment	2133	2133	1874	1	1	6906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxoXc74E93EYp3shpjnA4hKpLrPmzX88p3Cd4EzEuJc4DkBFb
46574	payment	2132	2132	1874	1	1	1779	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFi6NxUnofjBjAcrQrYVL7yqThL1DqDrp7M4KNi8PBgRFyMq3c
46575	payment	2134	2134	1874	1	1	7545	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqqEdcJbfkYF2srJhkkSDFND4dA87YoW9ZHVdX5KkhM8Z3Z8ES
46585	payment	1397	1397	1678	1	1	17343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz2EQPVEoJAmTWqHNnApBza5Ee64PBgrW8Ep7jz2L3pa4nD5Cs
46586	payment	2133	2133	1874	1	1	6910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bJCqFsB7iV98Pqix14M61SPAEFzm6ou8ZmnMfBes92aXfKjv
46587	payment	2134	2134	1874	1	1	7548	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK5SQ4ZUNkwowkuGWh9NFCgJgYxs8jLChVArbtWegute1SDK8t
46588	payment	1397	1397	1678	1	1	17344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmMq7Pku3WoZr9um7REpKwWnPTVYJ513fQKDAineSsTwUsNHpP
46589	payment	2133	2133	1874	1	1	6911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcVsaRCJqFAX4TfrNRPcik3RkmNV8EewqADhZLfQMz9fCA4Up
46372	payment	2134	2134	1874	1	1	7483	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJMUnFiNfrN6FLjm7QEpVbsQis4pyBifaSNQdx1nq3EsVEG19K
46373	payment	2134	2134	1874	1	1	7484	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpt3n3NYdtxe17QnQLzYbPv2qB4DXXwo5KYnWc1kmE4Bx7rm4F
46374	payment	1397	1397	1678	1	1	17269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMmVQami1eC8zhUm5RhjopEHGQdVx9DHbuxHXB6B8SHPYPZYFL
46375	payment	2134	2134	1874	1	1	7485	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvULLL51JXxsB9LdfwrKn8WHitEoza2tKuTXkrnQUTugbH6L1B
46376	payment	1397	1397	1678	1	1	17270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8g9EqJMknm8TU3cdCkqhJsvjzzNLYp8x12rjhuaPMfHHSoJr
46377	payment	2134	2134	1874	1	1	7486	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvpYTcE2egG7ZBKybWmFKfkNQn4DzpKBpHBcsbpJp5rZ42us3H
46396	payment	1397	1397	1678	1	1	17280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vWFGAfGucEvEtMDgMmxwL2ViS2hj7FZxAUKRPQcZCAtL2eqM
46397	delegation	2401	2401	329	1	1	0	\N	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFE5LniLz7KSzMRxcttn64gnyrpy6KCeMcLFJ1CbsnJnPaepKV
46398	payment	2134	2134	1874	1	1	7496	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYki9dEXTyAL4tJ5YLkWjbNdALWvc5CD8NED32zMq7ZwcBmxYC7
46403	payment	1397	1397	1678	1	1	17283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRH4W4PxChkz5Sx1DMkRwhYH9Ke7diGkLnMjLFrd6ZLv18A39
46404	payment	2134	2134	1874	1	1	7499	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZitRDBfaLnLyz2Bb2BavoggCZCvaU9ok1rNdvvBJn4HjTzHdrm
46405	payment	1397	1397	1678	1	1	17284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmpgK6svSbYNwqnMo2nRw6k77jymfqGtLBAAadwttaaWFjtkG6
46406	payment	2134	2134	1874	1	1	7500	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjfefRycazo9oznaD4p551fbxW1skfgatGucj6MzSXEV2gRxSb
46414	payment	1397	1397	1678	1	1	17288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Hf4yP4btcXXdDzgGP6Yom3Gm5VKg3vnh4ETwMNTNyRKriXia
46415	payment	2134	2134	1874	1	1	7504	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqWCRTtp2Jrd8oWETFWBv18cutK3ZUb8hF5ZU51c7HsGoF1gF9
46416	payment	1397	1397	1678	1	1	17289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3GEFzDY2Q2WBNAjxvgcXD1ZoYXxbFpzNxKyjCFEYSccPc8xyv
46417	payment	1397	1397	1678	1	1	17290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Nca8KkEydFpicwm61hGdVZWQVE9x6eV7YWViy3pxva8emgc5
46418	payment	1397	1397	1678	1	1	17291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ221E486H4rB1G3bcuJQR7Ada9pUaoo7Bk8ywJzTSk6Pr7PpwJ
46419	payment	2385	2385	835	1	1	2	100000000	3666670	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhafKmfPvVhDtW2NNkny9Bw8r6kGaydQh1u8CVuLjzhFZNgrj
46420	payment	2134	2134	1874	1	1	7505	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovrb5WuwcypFV2svHPzDjVnrK6BsrBFbG8CrZYmMiZoD4LkxT
46421	payment	2134	2134	1874	1	1	7506	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUS2FiVoRMpDthtnfWKsYwQaiZ8GFwD9mk847Qa7xrdxGiNfM
46422	payment	2134	2134	1874	1	1	7507	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg31Uj7UvFn2omAgNFFDm4h7g3nFst6kiG2L9UeJ3BCGi9Xmh2
46447	payment	1397	1397	1678	1	1	17302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHisqF5hkxfpDPfPoaxJew8XbPa3e1Wd5ks5YMABJZCPPzYa1k
46448	payment	2134	2134	1874	1	1	7517	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnVD5ZLtvv8mMbJrj8A9TwovPGxPT4uBYcQyqYVU4gaojt2eoh
46449	payment	1726	1726	2404	1	1	8347	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKE94b6ap3qEtFVfVUM8fe98n18hnf14WJjRBqTwTJmw7GZYUU
46450	payment	1726	1726	2404	1	1	8348	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYeFshb6BRugZGXKpL2D4ZBtp6G73Z5ZZQtEGuMiK1A8bkDyT3B
46451	payment	2133	2133	1874	1	1	6867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPqu2ojevKUHw9Buig5g4Vat5L2CrGLxoBkVXE3Tb4nf1JBRtm
46462	payment	2133	2133	2386	1	1	6871	80000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHXUgc2iBnVqqvzrqQ7LKohyQuRL5q1vPi1s3gCpUr4LFxj7J
46463	payment	1397	1397	1678	1	1	17306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Hi8YjPwWrX5DByQgViogu87Au4DaLVLmCMRWgcg6SDT4ZiSR
46464	payment	2134	2134	1874	1	1	7521	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW5NiMBojA6Bwec9Us1WRX3SwkcMEqKBKjwiy924xKGXRYC3v9
46465	payment	1725	1725	2386	1	1	1	98000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4G9ebmhjeK3TWGGNboUfEk9b42vrwFTsAQJXECJig3TnjUMqt
46466	payment	2133	2133	1874	1	1	6872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8mPRVr61nutSWzhMEfbrkmpiZWZYm9gLrW5cthVd7eBzK9zV
46477	payment	1397	1397	1678	1	1	17309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEttsxJ6PKrq5x78ozaDUk5jptx8A6uH3TSfRcpN1uJZDvewuR
46478	payment	2133	2133	1874	1	1	6875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJgurVvCanKRKbikf2oR4M1CD6dj6sPaTKL4EeEnJ4GPiy9Geq
46479	payment	2134	2134	1874	1	1	7524	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKTQLwgRGA4sR9CXXteBcLU5fdqyiZ17xaP9ivv2NndKCwWuFq
46494	payment	1397	1397	1678	1	1	17314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuvhi8TGG9drrkL4hZTJ4Zhuj3MrRYZKm9iT6N9sfL1Nms5fT
46495	payment	2133	2133	1874	1	1	6880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uBHbXCo1Ap6FErYgqidbRaxdWfd6usdpav2vW5FoH1RpiyWu
46498	payment	2132	2132	1874	1	1	1772	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZam1EJXS2FcgigNnU1rNiA2Dz2Jnh2igbZejV5JNPYxNzMUgdY
46424	payment	2134	2134	1874	1	1	7508	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8DXYbXNuxomesfoMq8Tdktn9Wb2vG4fe33drfP9KEJLK8oHSc
46427	payment	1397	1397	1678	1	1	17294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYigVtHr3QnTi6q8sU8a3yk6S9JVYoUS4kBMWAtQhSiqvZzisbR
46428	payment	1397	1397	1678	1	1	17295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd3j8RktTEyXzDpYtUe6pFjw8bykS56VGNCF8oHudCXyLj5L8x
46429	payment	1397	1397	1678	1	1	17296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTe4sUhAvy11ny6jeSiY3nhzNjmZY3VzfUbb2sQyRdUM4sYJf
46430	payment	2134	2134	1874	1	1	7510	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1dfYTcGC8ZoSqRhgzSBdqWLTqCTg7w1EZgyTA2P6KrtxnSPZ
46431	payment	2133	2133	1874	1	1	6862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhz7NZHRPYSNzBfuQY6dp4neBrh8dr3y6NhopZQUDZdrVGHeRN
46432	payment	2134	2134	1874	1	1	7511	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZniN61cc3jmeDCZK3yLsqVJCy6PSbDoHM8pkPWxiTjGp42pQjc
46433	payment	2134	2134	1874	1	1	7512	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYomQ2EW88usNiYZD2Qahg536TdSLf4Xj7teY439qYZAcJmSUhG
46439	payment	1397	1397	1678	1	1	17299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9tJuoAX3VwzAEFj3i7k2LMR6tSWfSgSPbKxCnkJnD1b8zzqm
46440	payment	2134	2134	1874	1	1	7515	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNUtw7zkmRCjEXxxTNneCF52HufkmXgx6ye7h9dX8sR8ob8rf
46441	payment	2133	2133	1874	1	1	6864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMiuwvmNhyzjmBN6MaXfPCv7GvFUYWtuPzvF4RF69772orqZy2
46442	payment	1397	1397	1678	1	1	17300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpegeaASUmiLAdrKzti3CMpd8DoB46cGcvUkfkfmJhVrQvk4X
46443	payment	2133	2133	1874	1	1	6865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXQuKSj24h61kKxc2PamSWYHzaGsGJReJw8YWZEU7ngX6CNQd
46444	payment	1397	1397	1678	1	1	17301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaXmiFZSccJetLXkkAZfj7B73kuxL8tRmTH6zww9HWofBLy9y8
46445	payment	2133	2133	1874	1	1	6866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSLUW7Jw8AhqPMKTbJHQBp2mVrMejDoNJWWkZqjwD1UPJM8Lv
46446	payment	2134	2134	1874	1	1	7516	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2Tf8uKPYjNqoZRVqp6KCkvyDe8LabTiGSJMr3dZAgLte4rfR
46459	payment	1397	1397	1678	1	1	17305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFk3MeKw9vNtsW2aRKR257RGcDk4a8di1WdJ86PADjRiUsCYxm
46460	payment	2134	2134	1874	1	1	7520	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT9gdLScoQX82iNUp6R1CTPgfmURDfZWRuDpD2ayxGWcsKLpxh
46461	payment	2133	2133	1874	1	1	6870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEo9CWDj1saZXoBKAJbvGT1id9khmpjzZeXy2aAJSJ9aDm2J5P
46490	payment	1397	1397	1678	1	1	17313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3NbEdvkw6JqHQeiXNgaFmQHpya1J8zdbA5KxWuNEYuRArmqf
46491	payment	1726	1726	2405	1	1	8350	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYUCTPh4koAvazGbT1J44euGhhso9nLihkBEZma6qt1bvgNDMSg
46492	payment	2132	2132	1874	1	1	1771	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4U5VZkLxKipaXnddFZHLjChaUYaUtExA6VHVwdvT1tNcL8c1
46493	payment	2133	2133	1874	1	1	6879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpJ2myw8RbZwXUsL1DhsXm3DrbT2hsjbc9P4bN9BNjn4imGWk
46499	payment	1397	1397	1678	1	1	17316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYrfbS3tZgWkuKWczPGEshAssBW5SZgprJPgKuX7Wf6XZvHARW
46500	payment	2133	2133	1874	1	1	6882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHLaBL4ShP2qmvRt7z3tkWBJ9ELAU2frAzYJNpcvZ94RtJr8q
46501	payment	2134	2134	1874	1	1	7528	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KZKv7UcTsqsvyZih1opGmTVTC2gct2rG9MzzQuEnLHf7A1Yw
46502	payment	2133	2133	1874	1	1	6883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRU6yHihgaYkhztzuRMN6rgDNttFHUYoMko5Q4zunW8ZTS1LRw
46537	payment	1397	1397	1678	1	1	17328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNEPWM5KuTdQDaw6mdhBqDqPuQVaTnQAh1riVccUQEQEZrKJT
46538	payment	1397	1397	1678	1	1	17329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3o1yNTjeZTVAT77LKt1CYmwNrPtcPupcKqWiNFqot2ZVFawT7
46539	payment	2134	2134	1874	1	1	7537	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVmqyuNydJHrCqiq7C3TLqBFjJ6X1uVaLdEp3mhdizanR3ZNN
46540	payment	2132	2132	1874	1	1	1776	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZBSqAxtjMfBxknQpFQ8DYd5A6Eh2Est9ESTfmTALwNf6AUzPM
46541	payment	2133	2133	1874	1	1	6895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAXF7nZHPHymtH6wjLkuhexTgeKbLAx8bJvhAHP1mMXiGTXnz
46542	payment	2133	2133	1874	1	1	6896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQycUcGCDjWuCQnnfcFHX64PAi4wBdqkXJ7M6zz9YzhdTarmsV
46543	payment	2134	2134	1874	1	1	7538	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDdvddSSzU4mMJNKPFf2WVRdShAygTYNacrFbtBRwgoHKSCkJT
46560	payment	1397	1397	1678	1	1	17335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6Y3tWhGKKPd1T3UFnBsj4S9wL6Zfb38EZG2GmNhWFQTbxszd
46561	payment	1397	1397	1678	1	1	17336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9be3iPbSTUPVZPrWUSacmwA8JJKKhNVdYZt3vV21ZWNWpQmUJ
46562	payment	2133	2133	1874	1	1	6902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkvyGeNHZ2U2P9FMJxt1Ks3tmtvA24rnAujeacLPxk5Fg9nxbX
46563	payment	2133	2133	1874	1	1	6903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwbYFoQ7FSU36Dxe7w9v69Vxf3joMnUu8cEkbfk5u3sXeNs2zP
46455	payment	2133	2133	1874	1	1	6868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TcDGisFbTAGKAKLkwevqvnv9STWAb7FJMrUCG6KDtivg3TPH
46456	payment	1397	1397	1678	1	1	17304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTH3oxwzSkb7JUWTkgRRfZYNdZCb1s7U2NraLyjeAMaW8HLYSf
46457	payment	2133	2133	1874	1	1	6869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpS6bhaozmW7ToCfqZfWau1LD59qu3QoMtLBB3ySYyV4zF8f2h
46458	payment	2134	2134	1874	1	1	7519	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtRaboXndmaAtJ8R7QhjHY7MR3BRZmVNdYYWQM55QvCMr4nQQ
46467	payment	1397	1397	1678	1	1	17307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPdxvGF1GmzvMDhrhZwYH1m536yyNnvcaX8GRfu49Q3PrkTLo
46468	payment	1874	1874	2386	1	1	2	30000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQQaBpPVsMHdFxf5H9itb3KjpX9HoiayTF4jDiMd4BuM8sJyvm
46469	payment	2133	2133	1874	1	1	6873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZECUra74hB3FBMCSu9YhyAaxboHwv3WPtRhECkMKs3CQ7V9mm5
46470	payment	2134	2134	1874	1	1	7522	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1EePb3sQuN2UGnV6YhpyKBteYjjJurdgVJQBPoM4QnAUZSjAp
46471	payment	2132	2132	1874	1	1	1768	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4nrBoj1UDE3cW2DSQR2tUa8RaevdMaJMkEdXoLnPDG4ityTC4
46472	payment	1726	1726	2386	1	1	8349	800000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vagDNmJvs7cy3bGi3w2p4JaM5XkSAWJk3nBb1dWD34X8i8sF
46480	payment	1397	1397	1678	1	1	17310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZesAJCzDmFZKxDyuVLcZ2QS7iR6G4o4annrHf2QX2ByZ6pLWyC
46481	payment	1397	1397	1678	1	1	17311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa2KVVBomK8EJ85EV6cEYAzFmb9XosW3aXsxiUhwNGiCP5TvQh
46482	payment	2133	2133	1874	1	1	6876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgeBvTS3WVoSUjKVPx3AKAjCeAUL2iYAUBxXHuPBjKFZnH2pcf
46483	payment	2133	2133	1874	1	1	6877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkn1aQLZqMfeJyihzTgQfeNV6dEJdNJsybEfAgePSwHqQhxpQ
46484	payment	2134	2134	1874	1	1	7525	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGj4ivb7wb1PnMyChzrU3B6QxtKCdZS1BdTidf3LS3WWetHYt
46485	payment	2134	2134	2386	1	1	7526	70000000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBBkBacHG3Yr8b26oV5aQsCFxKW3MKW8MVRZwVcZ8HPKzmLfgE
46486	payment	2134	2134	1874	1	1	7527	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRm4F8bncFMxmF8Litym5YmSpC8oUtwbmyzqRUNo66y53VVNSV
46487	payment	2132	2132	1874	1	1	1770	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWvKmf5Mu7Qy3BwTSkDHEnawvGPZ4igxzpNVyUbt6M7EZ7QRV
46506	payment	1397	1397	1678	1	1	17318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdC4wdb9Df1VeFC9mCHacBjdyWtfhXJR3mYhX9WqNJeJdrtGX6
46507	payment	2133	2133	1874	1	1	6885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fQ7vxNfvC7agc4N8uh4w4K8Ls8LPz5RYGqn1KSCTMYLLxe6m
46508	payment	1397	1397	1678	1	1	17319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYGq6BQ92muGwF5m8G8WuQZqQsgZHRpLCPaZA5jUrQLcv2PsB
46509	payment	2132	2132	1874	1	1	1773	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSzB7x5k9EczAMPrxk2kdw7RoSJVoQEzYcHvZExb8P7vaTpR8
46510	payment	2133	2133	1874	1	1	6886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa4XCJgADTiRHpDUys1DmrEW8BYhHVRBhEiKxfZmcqA4Wn5YXk
46511	payment	2134	2134	1874	1	1	7530	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9ofSDZbPjguZaB2HWf79ihTeTS3hBiZArYoGAsqVS8WMRJaL
46515	payment	1397	1397	1678	1	1	17321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpmkd46fxwvDLKyffTdYbpxEqXTDsFx3mY1FKVga4LF9tuMb6
46516	payment	1397	1397	1678	1	1	17322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGdsysNpCUEB7VTVYRUMJBP5WTNh84VkGrDGehgikTo41g8Ap1
46517	payment	1726	1726	2406	1	1	8351	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYpEzzXWYhWJkbJBBYq6qubriA69NMHq1BvzcvRZZUrGtYhQwdz
46518	payment	2134	2134	1874	1	1	7532	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVb2PFhNbJYozVJepayBkUBP1Bb76GxUj4wufARCohDjf5yNSy
46519	payment	2133	2133	1874	1	1	6888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZca6eJ69kXaZStUysjFFdGaBExrT3RArbghWM45RD62PFPcrk9
46520	payment	2133	2133	1874	1	1	6889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqagr4EW8CXXhG7Dc2GGEjQ9cX9mHanNcXAe5M6Ckmn6NYYgkV
46521	payment	2132	2132	1874	1	1	1774	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfEc8NkKzwbT462GjwXYeLJELqv617wiJUMqX8RRmKyAyTQGMB
46525	payment	1397	1397	1678	1	1	17324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy21F1EURykJYthcGBRFftG6LaWP7g7mBB6ZnnJmQG9BLFGVvB
46526	payment	1397	1397	1678	1	1	17325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy22HvTzPb2t2wGAz4yh9bpsL8X3QQ8xCQrzpgYDaid1xGDEpG
46527	payment	1397	1397	1678	1	1	17326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD2h8HGrnXG5igQpfNTD3KjFqmVF3GBTRWj7rfG64wDEpk9Dsz
46528	payment	2134	2134	1874	1	1	7534	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc6VwSQcfiAE7pmnybq2G6oR5B61i4SRtGGdyxpetXR74SYvmP
46529	payment	2134	2134	1874	1	1	7535	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkFPRNTX8Zgf5G25578zCn3KhK9ErgYrYrTCJ9vvtR5c1pcget
46530	payment	2133	2133	1874	1	1	6891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxDKuuX7DjXVJthaNE3u7EnH6PboeRv4eXduUigNvqK7iqBtNA
46531	payment	2133	2133	1874	1	1	6892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs43dVKEFFGcFqBRuGeH3uS1FSsF5oUqNjJ14oU4bEF2JxrAWE
46503	payment	1397	1397	1678	1	1	17317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSFAdeMZYc9sYjruohPgoaxNoz4kGDE8cqt2tf8B3JJgvjm76P
46504	payment	2133	2133	1874	1	1	6884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tVfFJ75rhu326wiAXnwPpK6vtjNTeRroBZcNx1Dv49QbUCjL
46505	payment	2134	2134	1874	1	1	7529	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTp5fiyvj6vtJ43j29TFvyW6tCPnJMNKd5zch9gfuhx9N3mC7v
46512	payment	1397	1397	1678	1	1	17320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5T7r4vtUL6bo84kFwvSqVSgs5s5hzJ5aQPWcKhLwYPkeXXiZ2
46513	payment	2134	2134	1874	1	1	7531	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3AhbXzvjdUB3X7aAeoueMS5nwU5dfK7CKXHC8qVp4ydweygCf
46514	payment	2133	2133	1874	1	1	6887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHLcEJAwa66wDNkZp4yC76FBYhurjLaEFjBgRu76nW6DR4xsq
46610	payment	1397	1397	1678	1	1	17349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzkMvhzL1u6DVHxev4LzsyZ3Z8x1eiC6pvcULGV5vwvbDxWHY
46611	payment	2133	2133	1874	1	1	6917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcGJiNiWDmVNuxhnWwXhkXKABMGbMMdaPsU3C3jHbsyRLmQxJF
46612	payment	2134	2134	1874	1	1	7553	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1NHxhQPUD715mVYbdwMRvz1HJP1JNQuVgCZnAXt9SSNHRHPm
46637	payment	1397	1397	1678	1	1	17358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkw9hapsiQDR4SMUw45cH4mUUXYcFT78ZNTiX8GQaRZDN63y5Y
46638	payment	2132	2132	1874	1	1	1785	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBepaxV8sFZqxHSL4ff6WVe1ZKs4s4gHznZcdbJid9oahAZtU
46639	payment	2133	2133	1874	1	1	6926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8T6uJ6Pz91PEcGegHuHCveEZSYeLyREjzf3zTBoZh4GXvsJwQ
46640	payment	2134	2134	1874	1	1	7560	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpNpSe3ofyK87LhX5EzscRaRQsiDg3zvsYkazFrft5yea5pLx
46645	payment	1397	1397	1678	1	1	17361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbofSGYGeet6iew2w7p3mUqtisFG2HqJzvbWXYacGKc8vfENf
46646	payment	2133	2133	1874	1	1	6928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztQRN1rsEXB2yRH7Ygczzk4ERpeDAuVN21SCCBpt3tBmp1Nr5
46647	payment	2134	2134	1874	1	1	7562	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZga9BmXwrqKjhDwVjkuxU6kmEMjtkMwfszgYNrnAhnMBUo7kdF
46648	payment	2132	2132	1874	1	1	1786	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvSRZzWHGPvQFRktkEvSjTVaHrhZ36Dv7vJecm8TGz2vgw5FrP
46682	payment	1397	1397	1678	1	1	17374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPtDWMYKdHxj2ZaTMcppTZisaqxiyNHkom6LZQk7Tw3P2A6xh
46708	payment	1397	1397	1678	1	1	17387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUNrimSRko2M8zFyoKdpDebdcAe8divaYacB6kRQmvczbjTo8
46709	payment	1397	1397	1678	1	1	17388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzajhEFcFCjzUAyqAw24GqmRgNhHCgh3TL8DzUcZAcxLwEVeb
46710	payment	2132	2132	1874	1	1	1794	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ53vmGg69E5mQMPwkMiBupqPh8bTNja1rZ5vYQHxexJZLG4ieo
46711	payment	2134	2134	1874	1	1	7582	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZja4Jy7Dpwgtr6pSzjXQKy2XdtAv7cYGsxAVdyQP38UQBZNaNd
46735	payment	1397	1397	1678	1	1	17399	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYobXq9HD9rbrw8ghprvwKTjDX2ieyRQEN6VzFdBQ8qQw4t5rb8
46736	payment	2133	2133	1874	1	1	6937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC8ai7kg2TmoPPkTxpkBrKGi82KBsgPdHwWRFzcEEEhpTqJyYP
46737	payment	1397	1397	1678	1	1	17400	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx8yh7rHg9N49QF1kLbnH6cRep9j93xTzdbmqouBKdHTX8p7qP
46738	payment	2134	2134	1874	1	1	7591	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yTq9LrHjsgvPpbwHxnzRLShDt5WsSpeTFcKGKmuS17PYtKn9
46739	payment	2133	2133	1874	1	1	6938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZan6q8AHKMfobzB88BfqnPR8eTTCDNQvZodRv7svofypLHn4Sp
46749	payment	1397	1397	1678	1	1	17404	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMH37FP3Mx7byy1bRXqk88uJHUUxJirHg3MrdY8NtxRb48Vwm
46750	payment	2133	2133	1874	1	1	6942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFLg2FX9HLGC82fXAxDwSvghuVo3Q2SmbjeiNk7s21JByBTR3
46751	payment	2132	2132	1874	1	1	1799	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtBsvej97XvV4zUqmknmMekvpWwcDHVnyAHe1jW9YWcU3tvXX8
46752	payment	2134	2134	1874	1	1	7594	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGWQiwSXZx5WRRgqcj6FrS2BDgXq911Y76sDw9Bt121nBiVCL
46761	payment	1397	1397	1678	1	1	17408	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8rsK538TEu9L7TMRzuEjBcPHXUQEcQjB6aGE7L2xDezUrwf7j
46762	payment	2132	2132	1874	1	1	1800	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZevLVAv66SKdf8PCDUd19CANAub3BjF2FZuCamB8AgVr6o3u8y
46763	payment	2134	2134	1874	1	1	7597	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCeSfx7j9CsMNXVjqwfRgdgrngt6dMYgEo24XDqgLjZyp8Zx9g
46764	payment	2133	2133	1874	1	1	6946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGP1w14WkU8Hk5DkWWRbKDvp3QC5k5S1pXoFVsJGdnV1DoV2RH
46774	payment	1397	1397	1678	1	1	17412	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgWSavMzw7hzYrRG4EkCHZYb4cNm9FW89QYt6kwTy1QPwoh7V
46775	payment	2133	2133	1874	1	1	6950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1PuSa7LBkVMdUuHu1wcUBqCJFEqoAAcxSKjdt4JMXLp4f4HD
46776	payment	2134	2134	1874	1	1	7600	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdVd1MjaU6Hk4B3iWZP8jLj3NBBQB2Rokj9oovczan9PUPC5V
46532	payment	2133	2133	1874	1	1	6893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUv7i7PM9BrJVb1YZhbyoaHwHSnBvSA7VwifY5xzHCF1DFPtr
46533	payment	2132	2132	1874	1	1	1775	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzgqRcmby3kHE3CskXrNJjeb99KrvXjWdT9TSy967GNngj5bzd
46534	payment	1397	1397	1678	1	1	17327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpBy6BXH8gsYLyGoctidtw6Bsd6JuTdawwULwa96CwciMfZqsd
46535	payment	2134	2134	1874	1	1	7536	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSBhzM4GacJDwzrSKLngNhRY4ESA21MaWUQS6gr4DRQa1a6JeH
46536	payment	2133	2133	1874	1	1	6894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRoEo2h8Nc5AzMzBEBTF9J59QVTi9NVeG3PtQF5HnbVVcXpRE
46553	payment	1397	1397	1678	1	1	17333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8v1ZxpNXExhSqQZSDi6UBKmkJnCbJDkDyZh71Bv3Nk16YiM8m
46554	payment	1397	1397	1678	1	1	17334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqNF86Dk4HX6fV9z3B5V1BCT8hJdsxRHrdgCxNt73AieMF7e6g
46555	payment	2134	2134	1874	1	1	7541	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWeZCQek6vosyiP9G2kgwPwMqqoquJjpPjPpHGghrVXSzPcR6A
46556	delegation	2386	2386	1540	1	1	0	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvoHrA2Zguec7ktAEbbSaMX9VRP5EvwijLeCNBrutNDXU4HWG
46557	payment	2133	2133	1874	1	1	6900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7x7UuSRzJPKCeVXeJtFrs1DaqZoZ2VtgJ7j2cLEn63MR14XKY
46558	payment	2133	2133	1874	1	1	6901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK9fUfJH9MjHdAkkBpEuM3nnsjs7m7vqLrAxThAgwYxe2cJocQ
46559	payment	2134	2134	1874	1	1	7528	3000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPMA7C2yPomjoK4ifqxnGfBmmaLdd7tZX1kxs9F8xwHyS3owg
46567	payment	1397	1397	1678	1	1	17337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNWJugPdae9uxapdM7cmDamy7Pz1VntnQep6LYUC6twz5Uuhw
46568	payment	1397	1397	1678	1	1	17338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGuvTq2LM6YryugfeFBUq9ghGK7AmrgBRQnaG36WjnX4YPwNh
46569	payment	2134	2134	1874	1	1	7544	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QYSeCHkBKjpksNbt4fc2C7KuoxVuPEYi6ECUGChazTLj9iZp
46570	payment	2133	2133	1874	1	1	6904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsdGDHoitCUSBbXqC7RacW6ZzKDV56d6ccTQbK9FF3QUj8nrv
46571	payment	2133	2133	1874	1	1	6905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPmhQn8rwXaxPDQQXwmXMfMfUZ1KdzxJYpvKN3mjvFsHYFJiP
46576	payment	1397	1397	1678	1	1	17340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCZd8PaZ5Rp1mUwgRe7co69LVbUDLZAXDpDsaXtpnikKzbygr4
46577	payment	1397	1397	1678	1	1	17341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwEzvfSKaF8kFBxMwBmaA6RvakGpRMyXsyCuDfNPpRyLN1dCEP
46578	payment	1397	1397	1678	1	1	17342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3UXDtYxE932dsbKX4VodpA9giYWDo2NUkMiaB7wxxGugoU5Cu
46579	payment	2133	2133	1874	1	1	6907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2r6HfGemtSb2Uyngab1aPK3Pbo6jVbUoJB3Fr44iLXpQMd7rx
46580	payment	2132	2132	1874	1	1	1780	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWMj7VGgBkr74QcUrMyQjuWU9vHsRPsdYq1LZqbAWgfph2RggC
46581	payment	2133	2133	1874	1	1	6908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaELszGeBHwLfPeLcKdLCykNezok9fh85bbkoGgHYVXsBhARPG
46582	payment	2133	2133	1874	1	1	6909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYD5ZbuJy4MggVL14hNqJtXmV26AHYXj8ZE9rG1e1d3MnxVuZD
46583	payment	2134	2134	1874	1	1	7546	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZetaEDqtu3kqbq5HfPXW4JQ7VS36AUgGdE23qA9xuxf5XUanhg
46584	payment	2134	2134	1874	1	1	7547	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwMVSpsCMvkz5GHnE2JBNPG5Vkey7HmgiHpfTNv6myPx3pvAk
46616	payment	1397	1397	1678	1	1	17351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs449oCb7HqyDi6sxna3YS1MBeKNAi6oEXSJxLjVaJVWwjJMyR
46617	payment	2133	2133	1874	1	1	6919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehmFsC5xBeDXBiiiLZMyZqZtsmWqKsBqjedSrC6FV6PL5sF5x
46618	payment	2134	2134	1874	1	1	7555	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzeLBX297zjuDquVxxzXCeYkYPRiESh8CeGeX9SHcRwcG4QjGq
46619	payment	2132	2132	1874	1	1	1783	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcf2JaAn3f1TTUzvw3i4NDpbaSLAsKJcW6NdmP3msJ12DdYJuQ
46625	payment	1397	1397	1678	1	1	17354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhYDoeXNkYpgiZMEFUx89jyhJNwHGuWRifE7mcBAnq2M8ksoyy
46626	payment	1397	1397	1678	1	1	17355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqCSLQkEjWkvLpyEW439BL72aVgqZgS4CztRGnzWsgwUvnyvUD
46627	payment	2134	2134	1874	1	1	7557	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkGSWDyJVNAizCzGY8A5sMC2G9BdwY1dgpyMaKPGGqS9iZRM9W
46628	payment	2134	2134	1874	1	1	7558	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRj4F7yczCsNkskZQGRg4t29uh2cFuXmDj2GNAqdUQ5WAFbc4M
46629	payment	2133	2133	1874	1	1	6922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2nYEfnkTfhNRAA37edMnrwqut1t2BPhxFTaZtxECanMca8yMV
46630	payment	2133	2133	1874	1	1	6923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpfQiL5jMEgDxiGHNuPsURenzvZ54c8bqH9eJ6ME4kjjxWsrWJ
46631	payment	2132	2132	1874	1	1	1784	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFkvoKZEvFRMLotTgU74ARrVqLXnKwadqx9vQ48EntvUnnfgDf
46664	payment	1397	1397	1678	1	1	17367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsE2jzNvonAYCzDhAgfiSfUgm27XVp5QUaDMZvy6nwZuGDtCgz
46564	payment	2134	2134	1874	1	1	7542	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJ8m7pX4KaVix62sA1x7x8u2jW19vBTSdv2172XoTwVTCoqQX
46565	payment	2132	2132	1874	1	1	1778	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwtLinFA9vSnX74AA5syGPDtsLSgAKhP2TGv2g4bFnc1GX48fT
46566	payment	2134	2134	1874	1	1	7543	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5wmfdJ8fQ4SWWFdRe5kSVZohf7anYdwJMiDCcFCZmeBYGuS91
46591	payment	1397	1397	1678	1	1	17345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNR6z8RMx3ughWkJLhHHk4vsVGeJGQhLSmgBgNg36gd1FWfnR3
46592	payment	2133	2133	1874	1	1	6912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQUFMiooobMdi5zJX4cP1jVt1WrU8qABBBbRfbxYvgFb6r957
46593	payment	1726	1726	2407	1	1	8352	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZXABtoQARQ94R2iXfD416MgAaRAgRzzCezXGsmYx2ngv3gHuQM
46594	payment	2132	2132	1874	1	1	1781	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZppfCScJdbMXyK1PW7rjgibze3J5BVVYHLHRbWaCZd7QSRKE6r
46613	payment	1397	1397	1678	1	1	17350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbbEUG4VVmKfcUXTHxVn9on2yqE8zTzqZ2dgj6VgSH3FmwJwc3
46614	payment	2134	2134	1874	1	1	7554	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLHxKSSFQ8wdmvvJR5rxnGR4KP1ko6XEjK7zbHXFMeG7YbHuw
46615	payment	2133	2133	1874	1	1	6918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1iqeAejnYPyx4u3etXuECQRpzX7g4i7AwUAmNj6NA9nsM8G4
46620	payment	1397	1397	1678	1	1	17352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvWhDvPb6dbpn5MutgK7kGa9so2ogS87hqDGjqu9YKfsz3vYJt
46621	payment	2133	2133	1874	1	1	6920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXLzgo5YTF3FDzLNzshx8LPLn7jMxhMwdPKWx6gkh33Qnj9XLW
46634	payment	1397	1397	1678	1	1	17357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcnuHmo5hXTPDStUj57G37CmVCBWHctmNaPuWptLtSjJw2g6Yf
46635	payment	2133	2133	1874	1	1	6925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzYiX1gsbfwtGBd48LQ3Y1nFRSgakinrU2jhZHhWVySwrfJfs9
46636	payment	2134	2134	1874	1	1	7559	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdoYEontPzfb3rAhtMMaPvYrxkWb564kBKubitFr7N9L8XK5rP
46649	payment	1397	1397	1678	1	1	17362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZju1LV4gFxHg1NMcdE6KHfkA5kDBPsXXU7RuZBnTAvxNFhFhct
46650	payment	2134	2134	1874	1	1	7563	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPon6DZ8P3FJs9yXGNxf2M8ZoQgUh4nrYhmPSA2jRy8hXVYM9
46651	payment	2133	2133	1874	1	1	6929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbypQY1xgB8o1Fz4ZNFLubhzYTfNR7BXfJ8FVGbDK4ahFvzWiV
46652	payment	1397	1397	1678	1	1	17363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcha8ubi88pcY7aLvUg9YNXJMuu5MQkb1p51oA7psCoTx6ZRb
46653	payment	1397	1397	1678	1	1	17364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaSL7jQu9TYw5D7QaEpwfjGRXy3JWgvi4GxnNiYwfDQP4hxta
46654	payment	1397	1397	1678	1	1	17365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPpU9omqajEvYgTntw8ScmNvCPNhSj64VWXeyt2ZZzRVgEKjmY
46655	payment	1397	1397	1678	1	1	17366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEjCjFbCfG6KUMfnstopGBYKz7JXAgApHeomQhG79a1poZ6yC
46656	payment	2133	2133	1874	1	1	6930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjB7anCfAoBChGzn1wnNqxSaMP81sXmxG5hD66subEmf61sqz1
46657	payment	2134	2134	1874	1	1	7564	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsKowxoitAqpy8dVwpwaXvmn6eFZttRkvrbSN5R5zHvr14YSec
46658	payment	2132	2132	1874	1	1	1787	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiQnpe6RmmHau95wqWTWSXT252u2NyFX4dAS8NVKEwrETbRWQ
46659	payment	2134	2134	1874	1	1	7565	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXhDtNFq6jF9HHfhJbabVfJ3NirvjRUjiEYaxhXgj53RXREa2
46660	payment	2134	2134	1874	1	1	7566	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFhWR6opLDd2FrZ3RMWdeopqyN6Guifx9h66V3n3DDQWGfqbb
46661	payment	2133	2133	1874	1	1	6931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTwcBnyaQKqimGowJDHCfhDH59Cjr1GsCskdSHaqp6ogtvwTg
46662	payment	2133	2133	1874	1	1	6932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2S1fu6xB31rpYZRYFXN9f7cUoLamJGL3HQt9A1LhFsNckh3vx
46663	payment	2133	2133	1874	1	1	6933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjckdZoU22vaHhnF9hnb8M7ZoGbagV3CZoeuQrjFhLNZazrCJ
46666	payment	1397	1397	1678	1	1	17368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkFcyzUJ3cjBi5J4qNE7veEF878be7a3ZnvCbcMk6wEeiTLMSM
46667	payment	1397	1397	1678	1	1	17369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5sKHJE8ManivmHsNJ9oaQgy8iUFqeJ8nCaPt9MCDLMCh9dyb6
46668	payment	2132	2132	1874	1	1	1788	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWR1iPk4q7vzdJ59YiLiVJ1Ra9rPJPgnFDSM5dC9sCYC5SXBTp
46669	payment	2133	2133	1874	1	1	6935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZUNkjZiixLVNetqEPwpDTZvktdyB7AAmz9Jysw2nowpqbAwX
46670	payment	2134	2134	1874	1	1	7567	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiBfZAfgCbDoMBkJ1CTkNvxte98GeaAVp9A2vmyPCw5NWSDiG
46671	payment	2134	2134	1874	1	1	7568	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9GBRfQLzmRXA9hubWTSHToXJ9qkB14DVdKCWcVVRqwcWuzPHr
46672	payment	1397	1397	1678	1	1	17370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGYojBVtQ7LuPiXAph9vFyatjrDxjdx72bE4ZN7xmBnwMxoMW
46673	payment	2134	2134	1874	1	1	7569	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcewYDXiPnSnKuV6K63iyXdw8doJDjsfTPaWDnWrnnfAdwLzm
46590	payment	2134	2134	1874	1	1	7549	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwTQtAcUFYmGSonfiAm5JAtw3vjeLecaAJnQx85fENNo68g6ub
46595	payment	1588	1588	1392	1	1	13	312803000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	CkpYtfApVyf1KxLos9ApygpNGVdyL6FGkY3x1KoKN11CTqmzVyVhP
46596	payment	1397	1397	1678	1	1	17346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDwTKV36WPeMZJcEebzVqcG4DXxqjqH7VyRPX5Ud8vDx8HJ7fb
46597	payment	1588	1588	1146	1	1	14	166370000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	Ckpa8AzUcavn583KAxiNRTLnrj5U3Cu6QXErNvMi47booadAh2Nrb
46598	payment	1588	1588	1266	1	1	15	111987000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	CkpYsmHtxVqxgZ1Tkq2ZVznaWSeWqsfZ6AhMPd9SeNbdrrQpDtb61
46599	payment	1588	1588	1026	1	1	16	92841000000	10000000	\N	E4ZG77bo4YTRTP6oZLPziFZ3hGG7KQAq57PNopbpB8LudAhNWu2PY	CkpYQnVT1HiLkDGiEM232xhCsBThucNNzJNw7gE1TtkNPEv3uApr6
46600	payment	2134	2134	1874	1	1	7550	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8uLqSdV9NhKBqwjERxUYT4nRnDXoV2Piu33HAMLFj3D2qE64S
46601	payment	2134	2134	1874	1	1	7551	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE58tcBH6cYu9yYkUxtQKGA5iVLCQnyAYrmLPonF1bQW77oB8i
46602	payment	2133	2133	1874	1	1	6913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWwitfPWeYf75cpMWbvkNpJ4jxwmEZCebyqWhDpHiXb2bPmAA
46603	payment	2133	2133	1874	1	1	6914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Pkn23oQ2tCxQn2Trsgky6MYj24FiVPTr2eb5kKbNmfdAbFgf
46604	payment	1397	1397	1678	1	1	17347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALPcTcUc4iYyh4gH9cTpqnG52eFcqon5gfThG4HumsDGrTcJy
46605	payment	2134	2134	1874	1	1	7552	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDnS7Qfv3bGu9NY4vH8RNmwrHBkFyfeXRNpd1hFECSjHkCdaL
46606	payment	2133	2133	1874	1	1	6915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnmDSFfk1dNsWdw2BfCF68BrvMF6sQ8VG3JcsL84Wygp7cpW4S
46607	payment	1397	1397	1678	1	1	17348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAE1FUv18xXirn391GbT2S11ySX3qFxWEKSncVzQGAUTq3sqyv
46608	payment	2133	2133	1874	1	1	6916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazGnNy1Pu86VKFpRsmegL3WH6TrAkNMdwmqh1v5VFZfayBHyi
46609	payment	2132	2132	1874	1	1	1782	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcuD5uEYTBgqW7aUc5t1UhMzdvq98UVPGXQD8h5KEebqQSFkp2
46622	payment	1397	1397	1678	1	1	17353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvuxUf7xCy4RJ2Q2aoBHtb9GuDyTZW1AEABXU7zF9Kz3cipyLd
46623	payment	2133	2133	1874	1	1	6921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhRdoduca1tcVaTwjV4Y1rarPxNQzNEC8g9DheaBtd7aNUvYre
46624	payment	2134	2134	1874	1	1	7556	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdQGtV3jiRZuSaVjazybm1hAkVviaWmjCa4w65jKYcS6LibDY
46632	payment	1397	1397	1678	1	1	17356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ALtQ3uHGVen6tStR1D1dANMGLCP1mx9YywPAM5wLRps3gq2e
46633	payment	2133	2133	1874	1	1	6924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw2QgxEH6VChLMhuE2Tb2h8zZAfdrfv2segf872mQ3Xqm21xje
46641	payment	1397	1397	1678	1	1	17359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeojZStddSsTqJoX1kwX6gUhsw1G5t9uZdLcEkD5gjALgzxeWC
46642	payment	2133	2133	1874	1	1	6927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNwNawrNdtvYYrDTt89NUskMs6g372mHXyFk2ooYaCN2fKcgg
46643	payment	2134	2134	1874	1	1	7561	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpA5X6WWSLQkGc2SSMkgEi1joctrbhoip5dVvRQoHXjdhv6oSh
46644	payment	1397	1397	1678	1	1	17360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3WaKJ7kvuRxSe8RXo87fS7ZR7WDSPk5KevU6Dgkd6E5sFTXp
46676	payment	1397	1397	1678	1	1	17372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6L62fPvpnzkecisNaV81LYKv8i8xPYJoEb1naVgpNMZSE2eD
46677	payment	1397	1397	1678	1	1	17373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrAXrWq2ePt44rGmehWNFt1ruwA2V3aRfZtXR66PZ3CNe8g6PE
46678	payment	2134	2134	1874	1	1	7570	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzXanGbVSGcbLyTZYgMgcaC33jPrG3hib4Yb2znKzyaHW25sB
46679	payment	2134	2134	1874	1	1	7571	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3w7FXWKBTM538cVzSVTxDCZyUf7tYUfZiMP3vfK6u88onxD6a
46684	payment	1397	1397	1678	1	1	17376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQcfE3cWtbxR2HTmqZd4CG2ZFg8F9GvpxdtjJAKSWBy6jDu7z
46685	payment	1397	1397	1678	1	1	17377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMd7V4wbXKWav51X1jymmLs9UjfkFFDtGmfhzLjgk1gqe2GyRv
46686	payment	2134	2134	1874	1	1	7573	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAYy9dekMTNJXKPhP8kBAJqTqCTsL57fiDofaurT6jUiPp12X
46687	payment	2134	2134	1874	1	1	7574	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUPMGDs126Mez4RiXs4LAih1aoqRFoq1QFN5SyydhsqJvrkjB
46706	payment	1397	1397	1678	1	1	17386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4TqgN3jfKQ7DQk3eWTEWhcCF5SQpeWtaLXRgbFhnbBMX4GTgM
46707	payment	2134	2134	1874	1	1	7581	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8DCarFS9cZjGMGHU5LDgNAWCfe7VUwMXdmYRHQNXBgHNdYaE
46712	payment	1397	1397	1678	1	1	17389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw8GwVHDU1PpswbSxdM87Wu8NKQDz779uH7SALpQJorhNcwz8w
46713	payment	2134	2134	1874	1	1	7583	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNFShb8BFXGYTkuz3oX2ZMYWvjyrAxYqna6XUe18tAcQLxxVBF
46731	payment	1397	1397	1678	1	1	17398	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8F2KSvgn4YbUVeVVF81desFjzsiqeGb44fcPTsAkJ7qWBx6t
46665	payment	2133	2133	1874	1	1	6934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7n7AfXvwL1i2aTNBaw4v9zZwJvcXGQMTprBLvMsK2ySujSKwe
46674	payment	1397	1397	1678	1	1	17371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqJv8WWcgcpX2mCcoGzNMdPag7Jmaw3nXrxY1o7sZA7Cnmxur
46675	payment	2132	2132	1874	1	1	1789	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuYQLYryHp5JvtkScHfqJmhCUXg7BsYsrkH2eLgDqK2LaxyWnC
46683	payment	1397	1397	1678	1	1	17375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxemd72VBAkJSxGr3CC9kKFxDEceQCFZtkKGLNiRFWuYL9CYBE
46688	payment	1397	1397	1678	1	1	17378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy2gYkcWMRSmQx7Pd7s88vdUhNGXEDD7tW2d4SRdJ85r3VqdS
46689	payment	1397	1397	1678	1	1	17379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TxaW7aQcsRDQvFyq7CnSw8m2b5pX9K4oAJ7YTPgr9mTZFbLL
46690	payment	1754	1754	1779	1	1	4	2000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8zVTLaZBbjdKJqy1ueMJJN2hBstFad6TdyvmPDC4zauahLPT
46691	payment	2132	2132	1874	1	1	1791	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4PCWS9a6pMTWFg6Nw6CHQB6amDbUdCm6GaSCSgZj31vkH8GM
46692	payment	2134	2134	1874	1	1	7575	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE7vFkZs6cPhdZ6sgh62ifQeLjDXjKw1usRqYQy8tW8zo7ttwz
46716	payment	1397	1397	1678	1	1	17391	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZASnDnm5bbHcQNGQ88a1yGpQJ3aevanpfY6FwjhKsAd8x5QKC9
46717	payment	1397	1397	1678	1	1	17392	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJGJxjETQzKjVvx4qnNqesShDnBHrQihkmq63k3oi9NorUf6e
46718	payment	2132	2132	1874	1	1	1795	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaszJEFNfGtci8tPYuv9x7s7Se51GokpDrHRfw71U9GmsAZoiH
46719	payment	2134	2134	1874	1	1	7585	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHK33XYRj1xhBSksVPLgARc1GafQGp6UePQxTUYe9SrBfTVUTU
46723	payment	1397	1397	1678	1	1	17394	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoGSXRb6CS2s7UVSwHTWAM76jjpKX83ZtSFfMmERrV5iLQ17Ee
46724	payment	1397	1397	1678	1	1	17395	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTbjyp5VaPihj228uvnLAsfFJUJoxxfkeEUopHoCh4HG9hZ1L
46725	payment	2132	2132	1874	1	1	1796	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjwakVyFPxw83P2tUaBTpPkyauFfMeUx9sFCqutB3Q23BSkV5
46726	payment	2134	2134	1874	1	1	7587	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoJbe9XjxZc2G4YHp5DMTxqg8Lxx7F52yKVfsmb1RgZQdVwre
46727	payment	1397	1397	1678	1	1	17396	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19ZZT42Ky1CMwbKNySHfUf9dEPK9W4MPDxsX66U52qEuiTQJx
46728	payment	1397	1397	1678	1	1	17397	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSywMjG4tQdZj5BrNkGUHroCcuqCrVNVm58NLdnukjQ1k4x8Vk
46729	payment	2134	2134	1874	1	1	7588	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3D7dZ6DqFP9pQMMBC91UQXP38yHd778nZyeAqRT4Bnnbr3wfp
46730	payment	2134	2134	1874	1	1	7589	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCRoPDw36EGFHb2x2URARRWWjz5RVMufpjc6CS4p82wwFf5XMC
46747	payment	1397	1397	1678	1	1	17403	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqG8TxGVJ3xNmHcmpA4f89BHjuWb8xsSY9SAVvdhEqFruneD2
46748	payment	2133	2133	1874	1	1	6941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKqZpkcQXPdFtqZXz5ymLAh9AUd8Hpd7MpFmw3kxSjyzAB7sZ
46758	payment	1397	1397	1678	1	1	17407	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHpoWmpfSULGhaEtdKnduL6yGSSpoNkmzhEXUjRPs7KBCWUsq
46759	payment	2133	2133	1874	1	1	6945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8as9ifrKRFWN3LpFsJnG7fcphn6NMk52TCQufq5KQYb17z5QZ
46760	payment	2134	2134	1874	1	1	7596	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNiajNU66UncT2v8oiUzvF7tZBD9Yh1BZreFMEkJT8qRByw1V
46770	payment	1397	1397	1678	1	1	17411	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTT1SrrcsGGiBVe7YC9jfUQNRbRKvQpYXmVm6xZj9Qsd4G5FtS
46771	payment	2134	2134	1874	1	1	7599	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnAhv8spt5FqFH9e6ovB1UBeZCf3ZiTVaBJGQH1jBYLF3VdDTa
46772	payment	2133	2133	1874	1	1	6949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrZt9ntn3ecwYq1LXdnXZs3E1ZEqXbGQaRCcgUJQawaANNFDWL
46773	payment	2132	2132	1874	1	1	1801	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpCqSLWijGWisMj7L13DcnhAtRn4A2GhY61uD92ChSML6UEpn
46781	payment	2133	2133	1874	1	1	6952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHya2vMgn2xn6b43ZbcBvuScodH3UXJ9y2woybaCBXAnzHBeNL
46782	payment	1397	1397	1678	1	1	17414	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKUkBkP7jNqrXSVNQ1TgfU6EShGc1YfRbFuW2119Y8A8LKEVJ
46783	payment	1397	1397	1678	1	1	17415	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcM7AKmNabxqFuXd25uptRsWSFTfA6pyvavyBybjtdqkt7EnP8
46784	payment	2134	2134	1874	1	1	7602	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYynyGvLMJ9z3kVxJgY1AFQh6cXfUvo285U3G6sH3iAo7k4nExh
46785	payment	2134	2134	1874	1	1	7603	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRcFSLPsPTKfqjwcLbjvXotqXQ8GEB9pTU7bZ54jMjXwC3SEge
46786	payment	2133	2133	1874	1	1	6953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMgstcfUzmht9m4jtGojSmQ3o5pcSUTkrbSq9bZrzT4s7gtBa
46787	payment	2133	2133	1874	1	1	6954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmeUnLyuYQwXGY2PGqvog2YPbbgyKHvtQQmxNUABkqzqh8zmt
46799	payment	2134	2134	1874	1	1	7606	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXQuRqCFCEtiDLztKn1WCAUbJWBkap6M5PdqPWabdUVufCdc7n
46680	payment	2134	2134	1874	1	1	7572	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5zSZYTgGjam28cjWmEpkr1EMtN58T9HZApFVPNRJwjEkjNhM
46681	payment	2132	2132	1874	1	1	1790	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZLcDdo42dN9LX8Vvtk9EkFw2PSjzzJ7axan22kkyuKkCT6j6
46693	payment	1397	1397	1678	1	1	17380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfUv412fhkwmirbxSJwCJvDjYKANcgt7KZXg54rr3G2yp2dKc
46694	payment	1397	1397	1678	1	1	17381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYPx25buh36kPbtaswPbewbBMTeg9GJsZSbxLEBkhzfr4Y2RSz
46695	payment	1397	1397	1678	1	1	17382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiwkRGK3TH3LH7LY88Hit915p5tYfFeaAf19NKQhRt5DqXzFub
46696	payment	2132	2132	1874	1	1	1792	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUfu3scv6h63zM7aC6ovzBpvkZ7SzKVVKrmS9J2tKaAFeKgLot
46697	payment	2134	2134	1874	1	1	7576	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HH4P4wceJeqobfh4WQAJ2e2Ym9khPDXyYPphHCbRPhjP71Cx
46698	payment	2134	2134	1874	1	1	7577	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH7rSjkWnNMFmy8U6KbQjcVcLXByHqN94FnZV7qj3VQw8TNcgn
46699	payment	2134	2134	1874	1	1	7578	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZPtB1ygM8gpV2gjrnN4rFRBGhP4Jp2RENDEWBzhQeUHxV8N8K
46700	payment	1397	1397	1678	1	1	17383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEKhjNXk9tSGpsj4ZnpFPBMbAd5KfNENxJhNGntwsps74KwU4k
46701	payment	1397	1397	1678	1	1	17384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGQj49rciaGS6Xcpn8P4ue8wLMGoqNFsKoiUkXxd8c2ANSwKZy
46702	payment	1397	1397	1678	1	1	17385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4rZmtEUHp7vX6q5X8ijdFzHkw8uSvYp4FiVP2Aajs9yUSi2oS
46703	payment	2134	2134	1874	1	1	7579	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSM5tvdLKkzWsAeAPyUqwFnMneZ2wYvPKyCmpRpnhyYfiwLP6j
46704	payment	2134	2134	1874	1	1	7580	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnxZs49Mos1zgnRh9QPhiFrwM62qWubY7Sy5rQSrfCCisHL5o
46705	payment	2132	2132	1874	1	1	1793	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCBCvHqFM4ViL7LG4arEx7ZSSP27x12bTpRuhKH9jMJLXLSjx
46714	payment	1397	1397	1678	1	1	17390	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mXwqxRWLt4gKavHWtFX8TCVmfe885f85GKE1hmuPZ6suZFh1
46715	payment	2134	2134	1874	1	1	7584	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLXCdwg3zXSJsXwcajSzHkCYGWLQFUPRsPCiUc2yzAKu6fG4JN
46720	payment	1397	1397	1678	1	1	17393	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFnUrRN4knnXZQdDHckQicy5mT6UYAATg6bW2LgFZ73a659Tmc
46721	payment	1379	1379	2400	1	1	1	1693977634750000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMm2VZBaheYF2ySdXmu3eJMyJ4enSL2SawBf8bFR77q7V9oJ2
46722	payment	2134	2134	1874	1	1	7586	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YSoBZ6ECnMeyTsTsufQ7Foqd11iuGmr5Y58cXNAZsrgmG4Qn
46740	payment	1397	1397	1678	1	1	17401	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXNHSQxYPdKcpJeSTXx9kkMTfprZNcMm3AXkfBVDxCeWHQnhS
46741	payment	2133	2133	1874	1	1	6939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjLRkEjgY85rNoor2GFTjuiqenrBYhUkk8Yeo71tQa8c4FfYR
46742	payment	2132	2132	1874	1	1	1798	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwYLDVAEckTYmUUPXicLcZ2HtytyUEr9k6JcxBaxmkbSjFZRgT
46743	payment	2134	2134	1874	1	1	7592	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDYy7nn2v3SjJ5KzLqtCbUc3b34mfzGWh6YAoDXC4PnXbb3K7v
46756	payment	1397	1397	1678	1	1	17406	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo8VS88QG89uGUN1GnVW5PJ8j23yLxWEPnkVfbTTzKcdE2nALn
46757	payment	2133	2133	1874	1	1	6944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GddcgRXZzRf87cqixLxaHCaAxqFK3wLasVKKcMQgSEtXSPVj
46788	payment	1397	1397	1678	1	1	17416	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE41HFx9E245t71G6fpcM7BVhzLHtKo41LDJtZCDb4MrbqM6ta
46789	payment	2133	2133	1874	1	1	6955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJvAaBucsbKvmohgP52zin1v3fthLNP1W7DFuZjnDtjNzTHkS
46801	payment	1397	1397	1678	1	1	17420	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmERrUebee2LA9nm5pnhgKt2xNKkmxHwzapXQYsLPMYxmEu7NA
46802	payment	2132	2132	1874	1	1	1804	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKXn26atDA7LTpf42fnuknpP3nMzt8yAQR3znoMbVyrr2hPEd
46803	payment	1397	1397	1678	1	1	17421	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpLhiAgUtQ6VPENUzjPDdsnfsAGozta2D5QDXYyuWVfKAeSCW
46804	payment	2134	2134	1874	1	1	7607	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLpm5LpHSsZwTKLz6DwBEizX5gabvjapFDvticaba6YvxAVZ1
46810	payment	1397	1397	1678	1	1	17424	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AYBppvRbUpdYXbGcLZm39S42K5rcMtcYkmNti8hwBHKL8hTx
46811	payment	2134	2134	1874	1	1	7610	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFXsyckjNFEUK3X11KU9dvDTKwoJRb7aQzNXmSmWkatUhXQ5jP
46843	delegation	2408	2408	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYornr8bXA56Daeu6ZyPqQBeoeggC45eGukCXtrFh4bwiRZ97Q8
46844	payment	1397	1397	1678	1	1	17434	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziMgqvBhY5icVTy2LUfdQEWGuCv11tdunDcuAzkCn1ECUusj3
46845	payment	2133	2133	1874	1	1	6968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE3LL8j4fEHgNa8stBas8i2StHH5MRiXrundSGhKZ83k7Feyiy
46846	payment	1397	1397	1678	1	1	17435	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcn2bAbriTMFh1RoXFAVeVh7xBPcxyHaFp8TGLBoSn6DWWLDA
46732	payment	2134	2134	1874	1	1	7590	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmyYChiBBLuHnxh7AAQPwPgrH3ySqv3sYBTJNmLAVnP9PmYPZ
46733	payment	2132	2132	1874	1	1	1797	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQTQyziKQLsZdu3co6pLqX4cdrgtp27W5NxqCGyowTWzH6dw9f
46734	payment	2133	2133	1874	1	1	6936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtVGBCQbQnydXmAQtq2Ld3mXfvfeXa6i2Rvmqk6MizdnVRZouK
46744	payment	1397	1397	1678	1	1	17402	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSkgGdwbEMFVLLrcUnsdfvuRgp92zuAB34nc844sNDJgFTsMog
46745	payment	2133	2133	1874	1	1	6940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn8m87YKQcHsE89JLcvvu99rGdCH2us8VsX3rGAbxYUvNtR685
46746	payment	2134	2134	1874	1	1	7593	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiEgjjU4QZhsDBt7Gp4ZHSPyvv7rGT2RY2hio2HQFfcpWzcNzp
46753	payment	1397	1397	1678	1	1	17405	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2w6RoMbbHdSW44pUjUXXnb1ZT3WjAKTUfJcGpan8y51X6QJe
46754	payment	2134	2134	1874	1	1	7595	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXEouqJKZ8sBo125hNDD8r9j1hbjpFKbfFS6jfJqAy46a48mb3
46755	payment	2133	2133	1874	1	1	6943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2MSUk5WQ71ZRadnmHKS1MBBgHDHdn7TuKiuk7i1MyHWZjLwPR
46765	payment	1397	1397	1678	1	1	17409	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1CTk3jZUkYogjrJsTMF1bCCkbVcDnbBA4bEFNWR9KQNTujitF
46766	payment	2133	2133	1874	1	1	6947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUwrtZortCFnLDziqoHqgXqwU4mgQ93NBNEMJ424bgMsTJ3Du
46767	payment	2134	2134	1874	1	1	7598	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ZaYmF6jzeh9VYe98T1D5TM3Wt7DXPDJBrkp8iTKjFyHWLQst
46768	payment	1397	1397	1678	1	1	17410	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCUhCevKriLfmuTTKQJbvGbaiiDHeVqpEhYSDFG8k3yUBwMdjC
46769	payment	2133	2133	1874	1	1	6948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAv4irNusAX4E4oVCjRd3EzPzMLEPQrJE3YfHQsg1JQksmRhtt
46777	payment	2133	2133	1874	1	1	6951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8P5U3PSo2iwGyHao5VnZ2PVvjK2eSSvduhMS9HcGiAV1SVSFu
46778	payment	1397	1397	1678	1	1	17413	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFtT8b6iuKaqtfmunqg4va7zspBWcwfZLQQExbv8dx4NQDFi55
46779	payment	2134	2134	1874	1	1	7601	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSePpiD1PVDU1GAzgP6g1BoURjGU8971PxhRdiMSKjGshPQSsG
46780	payment	2132	2132	1874	1	1	1802	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNhvbncgvgwwuubkhsCcw1zrRpaxnkmrhU3cmCJYA7wBAxZVUS
46790	payment	1397	1397	1678	1	1	17417	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapNcoA3A5VgihLKW8uWQJbcAQWu1FBeGSy4pjJKQiimrJSnEt
46791	payment	2132	2132	1874	1	1	1803	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjAxqyZMPqh6gCc8jqU1ASzJsesdXbtWHNRd4J9gVutbg9Peqs
46792	payment	2134	2134	1874	1	1	7604	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSgVB2ZHLb78Zs5ruuTRsZbw6RribtDgomKcrgRGRmfzxoSFh
46793	payment	2133	2133	1874	1	1	6956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4UTTzfUKbiGv2FhavpVbA7fB7YWygN13X4LZAoUd7t6KHb1jw
46807	payment	1397	1397	1678	1	1	17423	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvToqLbDcZ2rBhGJbQx7B5PMXkaLKyrnLo9g36o9h6S6eekazz
46808	payment	2132	2132	1874	1	1	1805	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYAxRHj6vnzu4SbMe529sZKVYJjFFGf6NSGBsEJYDvmWMn9bZ
46809	payment	2134	2134	1874	1	1	7609	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWW5H3SNDnDx4odp4RrtUiiLRzzfe264Gis4eRvtP5yvzPmBh
46818	payment	1397	1397	1678	1	1	17427	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8W1aKFgMBr7hb4SrKEVb4Z7HgLn17wUALWmyoKtGWmRo5fEfr
46819	payment	2133	2133	1874	1	1	6960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRf1Lqe5yxBSnXdxCDQrexbVWMpSFG4C5SMKU5ykxwKm5nbkwU
46828	payment	1397	1397	1678	1	1	17430	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMjfH6dW1BDN6zpJXLC1j5Gjb9YAakgeLZ95yzmEwsPVqEtnw
46829	payment	1397	1397	1678	1	1	17431	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBeayPvdruRJfXuU6yV4obj7t81CkKDUtmLxLNtWcUxJcE5f6B
46830	payment	2133	2133	1874	1	1	6963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzYfa4sezGRgr4gUshaFhQKTGzXZFEm1h6LXrRx7pNDhYJzHVL
46831	payment	2133	2133	1874	1	1	6964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNJsJBzQjA8AB4YuSFMqUGKzJko7YHMEGwhcPxjRQAWVGsZxJ
46832	payment	2133	2133	1874	1	1	6965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYPkQCMWNoUqByHsr3pCUzmLLE7rao7oWZyEMqus4Rxym5Uvz
46833	payment	2132	2132	1874	1	1	1808	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEu4kY5XdjEHGF426tYh5B81o6JFvM98R1N8Fb5xWERh5ncXM5
46834	payment	2134	2134	1874	1	1	7615	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQU64bH9WDwVF1Q4M57a6JFXycD9D35yxewFTZkYkf1Fftxqp
46835	payment	2134	2134	1874	1	1	7616	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwSXADSn23gZzMuD8dpHiYU1n56U5Qj4MCex7jpxqfHckTr5sK
46881	payment	1397	1397	1678	1	1	17446	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBkmvgAyLQwdrVVumE2SFvc8QvR9gS3Ukp8N8eZNEoVZAYxwbN
46882	payment	2133	2133	1874	1	1	6980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ4pJ7KQodHJAodjwZcweKY36h5Rys8f8hemBXV9Fvcxdr7Do7
46895	payment	1397	1397	1678	1	1	17451	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpoZXm5X8ULEzZTxNMPzDNw84qGEXjgAQ5LtkfC4oG3RJ5cP47
46794	payment	1397	1397	1678	1	1	17418	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTU8CvRrWeDRgkNgtZmoyKvXwtamTBq3YMoCMBpEnydoEDq1g9
46795	payment	2133	2133	1874	1	1	6957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoXqQXiGwyUmdYSpTpGEGb31rW9nBWPjdrAAuwDG8Lz9M75vRj
46796	payment	2134	2134	1874	1	1	7605	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyiRJdb8kkEteddfA4CjP6CUVQ1weAySy6yMRaN7sxwq2N2jr
46797	payment	2393	2393	1464	1	1	0	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeivn6RCvYYJA6Xi8uo2ZEf6BUncqsWVe5c9rVavsiLwAGEHF
46798	payment	1397	1397	1678	1	1	17419	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkZCsJsqxKoJ6zRfcLwK2YionSQcD6UdDpr3TeEnSjdmWYWgT
46824	payment	1397	1397	1678	1	1	17429	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwzSvAFEKZrxX1nGsas8PCXg8Q3Dma4nVpzkyo6BFSv6HEJQYE
46825	payment	2132	2132	1874	1	1	1807	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUobRpZtNW352L3DiAWJF8PgoFBt2aHd2baoMdwhYAmQMvejEw
46850	payment	2134	2134	1874	1	1	7620	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1ER4gwAJFs7x7BeQhticY7oSmoBiJuNDhfqSE3ZdYhDaykJL
46874	payment	1397	1397	1678	1	1	17444	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gVK6NfdudDhBmf5vnJULBetM1zXqJnA86ivLj1stxrAbpVbt
46875	payment	2133	2133	1874	1	1	6978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb6NBurvHqEooQjo2qeBPx2KrfaABD9X7GsaBJP12vWfnfTM5b
46876	payment	2134	2134	1874	1	1	7626	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZpVwswbmaApNxgpu14xtWm9swJ2Govz4uRS9RvDaHk9DEaQo
46910	payment	1397	1397	1678	1	1	17455	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPhy8W7xDe6GBXVMLJuLXro2TuA1FrLPAUJ3r7nmUsV1bxdwP
46911	payment	2134	2134	1874	1	1	7635	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwmHV8gQtAaov77KxVmLzVqNEctNCMRecSvbnihkr3YtHKo9N
46912	payment	2133	2133	1874	1	1	6990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajSo39nvFyVYdFPNyQj7ndcN4J7Ep9Ux2Dna6cY7zQR8zd93E
46922	payment	1397	1397	1678	1	1	17459	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe5PGMo2r5w4LACaspMCXJEdkBJMHwEabGFT2zpGxzwYjxnXZy
46923	payment	2133	2133	1874	1	1	6994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEWbmaKPEDEYsJhrwMuzAtn71M5CA16E1yn2Zga61Ms3RpQmi
46924	payment	2134	2134	1874	1	1	7638	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvAxDsasqtDpU5KLosN2sgaMxzfB3ePiTZbvyGdZHeBiMW16PJ
46925	payment	1397	1397	1678	1	1	17460	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYLs9SWTXBbiqhtWzGcgYrA5TCjdyzRSfJsuQPUW67obMWDyf
46926	payment	2132	2132	1874	1	1	1817	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuzXAvadexuRYFe3SjwJBZ3dsCyveof5uhTZQHwPcm1JcJqjc
46927	payment	2133	2133	1874	1	1	6995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcGouioS4YvXdgNonGXUGzzobGBe9auUiRNbZwuJyFsFMmKDDB
46934	payment	1397	1397	1678	1	1	17463	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWJsjwq4nABiaYh5cC8N7JkbLQz1iTnH5pEyP1USVWHmwyoXvE
46935	payment	2133	2133	1874	1	1	6998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2wNwn7c9QrR9ReahJ3ti8dHXktMMnDqdmD9by6VJmQiCeKCf
46966	payment	1397	1397	1678	1	1	17473	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9szVU6mGZAyxAmpvnxKniQfEKMPN182buDTRTcQmYgBjz9bf
46967	payment	1397	1397	1678	1	1	17474	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPpFBVczY44JrdQGBt78gKewaYkX1tqEmKGeazKSmXU7KeKvQ
46968	payment	2133	2133	1874	1	1	7009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJRN2zRXq2XPx9GgJQGu4u65hERow9b7hrj2zDTTDymYsYbp1
46969	payment	2134	2134	1874	1	1	7649	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyvKp97EhKzBVJyphpAfynHcMapkJajumT2hKhCRxH6VSaDjEQ
46970	payment	2133	2133	1874	1	1	7010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGYNxhy5pKPkYyzMU4vLPxfXUgZmGWSx2etVQPTXGVpooRq4Af
46971	payment	2132	2132	1874	1	1	1821	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8LZ17rFcL4m6BQGo2HnwWvmf11oo6NFcKcbC16tMBk6PE1q3
46994	payment	1397	1397	1678	1	1	17482	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM24o8eL7zMwzjaqpJsdZYdS6qvMMiHcJkYdPPR9n3Bb2hSdUS
46995	payment	1397	1397	1678	1	1	17483	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbuDqhv7mbUwvQxwQ3ibEqJuEge9LBc2LSVCYLKyi8y7muDVcT
46996	payment	2132	2132	1874	1	1	1824	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbP4G4gSX5o8ooCCM9xSyJUcjE9r5Fg7D61LvmcQZJGKnVhfpu
46997	payment	2134	2134	1874	1	1	7656	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ75qQVkwcQKxhyk2Es1CjfHMnca1LARy4Bv685xZV6hMMbervq
46998	payment	2133	2133	1874	1	1	7018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoXutphUrzLndAX4xQdxUZF6DfL5785vA97YFRMCwpakWbrjCf
46999	payment	2133	2133	1874	1	1	7019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1kY2hxspSPoK1DwMkmnB3ztuktPSSZP7F5UdgAc6FkVweqTt6
47009	payment	1397	1397	1678	1	1	17487	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Gu1J341UAV78u16gUmKxiQgxd9dtHiKxHzSCEBZegpdZmwDb
47010	payment	1397	1397	1678	1	1	17488	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZd5KH47HMFy8nYRd7627NNn74MuXHJGBYLBwdLhhxZHonXwVf
47011	payment	1397	1397	1678	1	1	17489	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDKNedPsGwiHkuZ58cE2YCH95eCgGWGLGdUhBA2z54gQz1ZVdE
47012	payment	2133	2133	1874	1	1	7023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFso9PiGxGHdjHo28HsGuwspoLNhsEn9HDdZDraecrU4UhnDD
46800	payment	2133	2133	1874	1	1	6958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGDzZM3K2Zu61gx7LtJvcvotnP2QypKS2EmHVPH6nLujxESF7w
46805	payment	1397	1397	1678	1	1	17422	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXNYwHYMYcYr67v8815idbESHcjqtzZrjuqjqTHgfi4BDNjR6
46806	payment	2134	2134	1874	1	1	7608	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCco3ZxbGMEbE3eAmGFXFq1JVJ82RxCvJ3ibHDzA6eZjxxizK6
46812	payment	1397	1397	1678	1	1	17425	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37HjQpZPgSgnvrczRnGsE9DY1784ijDXpgVKybVqxiUurASo5
46813	payment	2134	2134	1874	1	1	7611	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQAZ6HdHsDB68YYzmwpPynkjipqWxzEgGZzhqPQSTUVtuKKaV
46814	payment	1397	1397	1678	1	1	17426	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVnWqNWox5yRPisSfMFAJtkfyBtgqxX1L2Pe8zQydX5zCXuPD
46815	payment	2133	2133	1874	1	1	6959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTs5w7qi6hPPf74pmA3NcVYFfov12RimtBSxrchMu7ytYHQLPC
46816	payment	2132	2132	1874	1	1	1806	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbMghvidzAHE2pFSfYEPVNfiNmUGuDDa4b286Toc8ee1XGjGJ
46817	payment	2134	2134	1874	1	1	7612	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJcRa2jLgV2gXf78CwQnBvZJ1wX2uLYifw2AJ6odznLmqxd2DW
46820	payment	421	421	2408	1	1	0	3000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYHdzZMqBjRv6f3LKoZc3ZQeUx2q4d89SPrhZZfw1NW3pFwafu
46821	payment	1397	1397	1678	1	1	17428	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VJrJREdgSAZjhuqp3MAC7j97gi2L2L6BVaKTniYHvnUBwjx5
46822	payment	2134	2134	1874	1	1	7613	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6ZKXdMksVaBq8o5ErPXToFCsRvfWuYWQe4tfkJVXi8Tv7YJL
46823	payment	2133	2133	1874	1	1	6961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPSeLqW6DiQv5dEv7pa1ZhRYNTLFxmdgBuccEWhgGZu4HvaYkr
46826	payment	2133	2133	1874	1	1	6962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj7Hun8C18GWBBLxs26jNRzMMt2GHWVrLHmBycqWwmdvoUYJYi
46827	payment	2134	2134	1874	1	1	7614	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4oUAFbxqJJyvvfpkKNKoEvFzbvu4CL2apC7hoZqESktiiyKP
46836	payment	1397	1397	1678	1	1	17432	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iRKX7jXL6RHFy76XX4655D8CKnyB1BCUdkq1JW14u2KoH7jH
46837	payment	1397	1397	1678	1	1	17433	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7sRWiRh1y4RCfzaaEsZivTbALoL1pGsfVESkjAKtJbf9a43Sc
46838	payment	2134	2134	1874	1	1	7617	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyAee6UMDB5RTsox16viNBciR4yotaAV4XcBNWUoErd39pw5Vd
46839	payment	2134	2134	1874	1	1	7618	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZei6GJ77D5WhXu7cVrE6tmF8kGb73MxExwbvep56uCMx6QMKUa
46840	payment	2133	2133	1874	1	1	6966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfioEQPC4gePX1aBWsiSVuFWMys9qz7HYT56xWZQSqb6SPPJn9
46841	payment	1726	1726	2409	1	1	8353	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZgY9TPQW3KncDe3HSFJkK5M6ibmsEAMAbtd3uU1gHwRoS2coFG
46842	payment	2133	2133	1874	1	1	6967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFVukBXhFZ8Jh84agzmFuZZoA3TzyeXYXEphdWEmJnudrJrHe
46851	payment	1397	1397	1678	1	1	17436	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnJLkPAczm6Wxm3caX4grrGyVQfMghvJWs4VnH5LSE9pbbrzfN
46852	payment	2133	2133	1874	1	1	6970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYKTihCRm9yr3uxgAyiAZuMPNdLaRh7Sf8VqkHRDNXCisyore6
46859	payment	1397	1397	1678	1	1	17439	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYvy5AdSyjDXrzbi6mYwbMeB4NResVE9damKiBNmM9KCTE63vY
46860	payment	1397	1397	1678	1	1	17440	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWVGcJ2nxQvSzbzgyeFs9saSZK8x3QUc5GEwqsMrvBTMZrgiq
46861	payment	2133	2133	1874	1	1	6973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbSBBibT2DXL6yyngMd2ktSfwtRYsrKH8iwAv1SBf8GZpcCaWF
46862	payment	2134	2134	1874	1	1	7622	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAK5tNCjyqZGN7y6sb9bbLmahXHT5Uz9rg5XRbVdqDpfBNvnNH
46863	payment	2134	2134	1874	1	1	7623	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYacDwdTuBiV7wMhn7NLitqtVgVaVfvgCGTkwXLrmbXK5uwFrQd
46864	payment	2133	2133	1874	1	1	6974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbFm7bwp4eFeJ692nXUh7HgZNnHrkmMRCqaTTodKj5HjbkREVj
46865	payment	1397	1397	1678	1	1	17441	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDHkhmdzsTDrUA4fs1DjpdCZU5fce9xZCpWz5M8e9vpS5mrek8
46866	payment	2132	2132	1874	1	1	1811	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYST4u3J8szRdiKTL82dsbGh8AG6LGVhopNLWYAGspj7q3cNRLP
46867	payment	2134	2134	1874	1	1	7624	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWGQ3uqNoqfeXdJ7Vg65SCX8X7zxx5HRCAARYTckKg79WzeQ6
46868	payment	2133	2133	1874	1	1	6975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRNXunxN9dCVV5rTTViNUwP4QuuyTiHEzaaWB1o3uNUgJmhKTt
46883	payment	1397	1397	1678	1	1	17447	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QukrgpvuAo2M6MpiokCfjSsmS4hPVQb4BPtGEdPUYueKWf3B
46884	payment	1397	1397	1678	1	1	17448	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF3YHPwnxXDCvE5NBNRVmfg1LTz9qFxQUpG5uiGex95TQqWuwp
46885	payment	1397	1397	1678	1	1	17449	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9D21i5rwDYrfukkUKxPUJ9G4jTgLJCVVrfgxSTtvLZCUURPJ
46886	payment	2132	2132	1874	1	1	1813	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxHwUmB6NF2Q8ECthgVmgFj2zTrystmJsNXHZHgfbSTkBGvvj
46847	payment	2132	2132	1874	1	1	1809	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhtfERyxgeLJCqTkSdMxJvbNd1XKBAhZqwfvA7NNhox7CVCFMs
46848	payment	2134	2134	1874	1	1	7619	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuexoAkcsvFkviPz9Dy9Sxw4oqiMpb9fdmSLMVhi84NRLa8zm4
46849	payment	2133	2133	1874	1	1	6969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZin1C9zs63ttAN8T37cXhYNRV3kUhBKpjkyx7fx7LQv44Vdw16
46853	payment	1397	1397	1678	1	1	17437	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEugXsJKqYSurSXCzRahaQj6c41PJ4HViJ1P8UzcMvaXAKySCN
46854	payment	1397	1397	1678	1	1	17438	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnUXKE5SmESbP6ewwwM25y2532w5WYhjduYbEwhXXWdL6xjEb6
46855	payment	2133	2133	1874	1	1	6971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWaX5msLpg37P7MjkD5aPeNTK5WFs7qC89CVTHpDw8diV4LCvo
46856	payment	2132	2132	1874	1	1	1810	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KTYvMD4qvBQsfhYQ6sYuWQRrkhzthpP8pcp1vWSKZAL9unFn
46857	payment	2133	2133	1874	1	1	6972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGvsNSGQ7bx3D3cqapF6V37QsS89cRceNzGuirbUuJ75BtvBBg
46858	payment	2134	2134	1874	1	1	7621	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3i76jra9cJ1uihW3ohoUdEvAVo2iTP4Fnwcy6FuDgYYi9wMJ8
46869	payment	1397	1397	1678	1	1	17442	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwyUTDuQcdUfVJou4zVi2m8uayfsXw3yHEW8zsQELvqCr9aogn
46870	payment	1397	1397	1678	1	1	17443	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddVGHgRtGtTjC1rEKAid6L6RXzz2NHRP1C5rrePAKuuFYuqDz
46871	payment	2134	2134	1874	1	1	7625	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXhCMt41Pewy7vLwSdYpdwbWxFXv5hDdheVVdPHKmLCgrWrn8R
46872	payment	2133	2133	1874	1	1	6976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzEeWWX9p6ijg2egX8KZy8Sg6rqm52H1nqvDabuHof2s2PbuX8
46873	payment	2133	2133	1874	1	1	6977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4cJyGcHa9SufPeGjcGNCZMRmYrK2bcgByCBxhYD5SAe6Y6bcp
46877	payment	1397	1397	1678	1	1	17445	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfuUsMwCRvS2kycGRVAzCraJTP1b3xFvy1C4zdd9ENc4hLtT4E
46878	payment	2132	2132	1874	1	1	1812	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWjCnczaC58Mo5yj6wS9iviU5QaCpcn2vQr9Gm8zuideVjNGyf
46879	payment	2133	2133	1874	1	1	6979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrN9bRf9E1x67dLGQ4SxxG2LwsFi4oRoBvNsUUSn7P6iVY6gvc
46880	payment	2134	2134	1874	1	1	7627	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwGefb7KBxsWWx96BAcBRf6WZCv873aY3gtNgzqb6fy12kgL5n
46893	payment	1397	1397	1678	1	1	17450	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd1yt5MbUxqG9dCBGotzqz7WFWbKduRiv4A4d9YyipHrpcZsUU
46894	payment	2133	2133	1874	1	1	6984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLpUTLQgSXqJWRkpC2ZWVppprRXhvBoAUeBh28imgmrHQBced
46904	payment	1397	1397	1678	1	1	17454	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeYqJJeHVYZpvUgSLotuuvmQ5jdZ7nH4CmeT8NvhLECrnnT3i
46905	payment	2133	2133	1874	1	1	6988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqpTZQdCjLot9yTRwRuGCeby7N4vtJSXrdXBLeHHrQKGT227qg
46906	payment	2134	2134	1874	1	1	7633	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEaVwbZhTvxPhVPsVngeaHWUn5fE35Qir14T6ouJJcpczdU54g
46928	payment	1397	1397	1678	1	1	17461	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCh8csPpMWSNEcGJv76E5UGDsEedhppHJp6S92Znc1oePy33nn
46929	payment	2134	2134	1874	1	1	7639	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS4YgVFW4e7TrUnyrE7K4qQijQyu1orHBonmDgV742bNUs9Edx
46930	payment	2133	2133	1874	1	1	6996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXveDJzJHvrFhPHatNyheCeQRENYf7QB4oiuAfjnFRGn15uuPq
46939	payment	1397	1397	1678	1	1	17465	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFFB5aiNNwaLPfKxdarQyw5HdUnGXtmwKpiYfbkGhjgAtVaS3S
46940	payment	2134	2134	1874	1	1	7642	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiBTJKfgTEHswhJp8E2k2nEoMi1bExTfRNoipHewVtw5DybE8y
46949	payment	1397	1397	1678	1	1	17468	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKMg5QnrMZHph7wHcWVc6ii2hko8jaAqi1Mpqk31rxMLNdytt
46950	payment	2133	2133	1874	1	1	7003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKeT8i3Ud87ZonmPUcF5uAafWo2zYk1CvZwaTP7wi6v5ofCoYV
46951	payment	2134	2134	1874	1	1	7644	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzcPqxWivgywKp9QAPCwAj6PaFau5iZb7KNMtydD8jnqehVQq
46960	payment	1397	1397	1678	1	1	17471	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBTKU31uUhrDaaBDCG1cpRShiQhWMJ3DZGHc5Wk4zoxZwELAnv
46961	payment	1397	1397	1678	1	1	17472	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ88yAMVqQSNrmkRaZBYhPeG6hKGR3XeGwC2nzLWjfbpQ6MA45k
46962	payment	2134	2134	1874	1	1	7647	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSgyf9DHbLWatNk5F5QHsSLz78hrWReZJS7nQq15N6pgNiZH36
46963	payment	2133	2133	1874	1	1	7007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHHRinZhJFV9RN5mYd8SP3bsJ8fUJtjVkvm2TMs3n75GSErLN
46964	payment	2133	2133	1874	1	1	7008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXT3brcVRiVg8cvFWwyKjXSGcd6vvkgLFTQMdRXkrWn44CYLP
46965	payment	2134	2134	1874	1	1	7648	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69DurHu4AD6cEziwQRabBdeejc99FQcaPH7HvjxfJCuyYZGub
46988	payment	1397	1397	1678	1	1	17480	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyuyeHbpz9UKjpJkmXrQ91ccW1z1QQACPgUPL6td4WyEzLUe9L
46887	payment	2134	2134	1874	1	1	7628	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpwpFVS4u7M7sgDWdQmNFMsajmfSPtAqaAADLsYg5XZDWSRZTk
46888	payment	2133	2133	1874	1	1	6981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxN58N1Wzo4XmoRieXfQQczt9DdV46BXNUtzaPBJ4PBD2UUhbU
46889	payment	2133	2133	1874	1	1	6982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk3Kfr9VJSCcMNFumTaoj4GdbpTSdvVgUfPKnGXBQjW7HiSopV
46890	payment	2133	2133	1874	1	1	6983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnzGuNKc2WFPcu1w6mtmeLCt34xvai6e8dXzM5iK6BZ7Q2Mfag
46891	payment	2134	2134	1874	1	1	7629	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFzf4GcAJbTY958R4k2nbNpiuZfwQLzRujHktXwKHNVc28cnfK
46892	payment	2134	2134	1874	1	1	7630	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfAhrdVjQBEVevhRfSnsLDjARX2sSzF1y9tbABGxNKtvz1acPa
46899	payment	1397	1397	1678	1	1	17452	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2urhHjs71WrjkH5CN5AMFdgAwuB5QkEcK3zxQFLGw326A19Zm
46900	payment	1397	1397	1678	1	1	17453	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcDgdydgh7PxyrXBjZQpF1b5gjKxLN1yt3qX6V6gmoNjZRMuXF
46901	payment	2134	2134	1874	1	1	7632	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVd4JJt23bE6GCG4moW9DNJtMThUMsuzon6ENuJ9F8KVvhumro
46902	payment	2133	2133	1874	1	1	6986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7i2CcFQW9dC3WQbsfFN7GkYvnCy8DNKvsgx5CdBRT3Eshm78i
46903	payment	2133	2133	1874	1	1	6987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vtuM5yNmKQas4tU8hA1uosvuVuk3UhFvJnQSpnfHE8BavUaP
46936	payment	1397	1397	1678	1	1	17464	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZwzougkBVz1CWdAzvMor6Upqhi1PgRvPK793Y2Mu9p3mem9F2
46937	payment	2134	2134	1874	1	1	7641	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn7qJ6G5DQnVLZrsjZ3VQKMyH9sUY6zSc7cRQypN3JggkC9qNW
46938	payment	2132	2132	1874	1	1	1818	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4oqvB2poBmEKrL19yCBJe7BgSab48ka1WsjVqj8dRd7ifrgF
46941	payment	1397	1397	1678	1	1	17466	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh7DNoq63ESABeWTJVZxXjCZP5tpc8oNKfZEPs648tZTh3LD5g
46942	payment	1397	1397	1678	1	1	17467	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXjmYs8zoQ8q124PTUL4XRevNmJfmX4kZk4FyqDpKdAZuvQH7
46943	payment	2133	2133	1874	1	1	6999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ93T2JTBBS32S8Dq8GF3DwxXvgVydLj9og7jhas6onofSeottV
46944	payment	2132	2132	1874	1	1	1819	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAAnk5hbWvDrtY7G3JxRGFfuuorjEKusCJYAaoowWZGAEPWHTT
46945	payment	2134	2134	1874	1	1	7643	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSdwAwSfEnA93mL19hyTsU3C6qLqT6jtZMHGxLW8L2jujkV4T
46946	payment	2133	2133	1874	1	1	7000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5ajPNV3bGjuSHuToPyTXeiRsofhw5onRNDBr7sdtVAeLZABj
46947	payment	2133	2133	1874	1	1	7001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc4yrpeiaCXSTnCMQCLujz4XHgXe3iRC8niiqPCsSthCwzUMir
46948	payment	2133	2133	1874	1	1	7002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNmmfLgDvqL69hBMH8xsgiG3po4R41k2GkwP3dhTUN1RaYSgNg
46959	payment	2133	2133	1874	1	1	7006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZWKrSjJkugRaxb5rMm6UTfFwzqJ32Mot2z6VXacr83zK19k5
46972	payment	1397	1397	1678	1	1	17475	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51c4upCt8q77MvNRcABxPRt7Q2LbhVdYXtoxpMup3Pa7RGYSC
46973	payment	2134	2134	1874	1	1	7650	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3KRsb1RNrdUkA3uabJiy3RqDhHQXB9QNMD419xDtu6i45p3g
46974	payment	2133	2133	1874	1	1	7011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7JtebGTJ9zJPQkoVL5v3UkscW4X5asizgFBqdsgWhnZ8mAALp
46982	payment	1397	1397	1678	1	1	17478	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWddnYVLNSReZk2WB4ZPYtkUQBR2BBUhBbgUFRDTkLiDTiwVSf
46983	payment	2133	2133	1874	1	1	7014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqXoCt3eihHJoqXCz2PSQSZtB1kvgo1HWqaah27rN8cvGKX1dV
46984	payment	1397	1397	1678	1	1	17479	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38AxsoPvhpsJD3kFWPLP1Mxo2p1X82zeqd5KvkH2JZgYdvLrL
46985	payment	2132	2132	1874	1	1	1823	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yTJVTt9HqvqmrAVFRQ5t45si2JPtK4SRiNycFtLPVUAheHov
46986	payment	2133	2133	1874	1	1	7015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZomGvdxydQWgf4zsug5RUD2WU1igh9YH6uAxLijH4BgQVESMpZ
46987	payment	2134	2134	1874	1	1	7653	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFUSF4tGvvnJ8tizJf7mbK3JE4XAJPvtrakiYSBMoVvxVKMub
47039	payment	1397	1397	1678	1	1	17496	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZc7APjfKcC78NfTF1wSsjfWz4mA92kdVzTJRJD45V2CrfVnuC
47040	payment	2133	2133	1874	1	1	7032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpbyp5Po3VGqFfEFTiQ4dZDV97eo7G3oEBCfQkvVPSgrieZMcz
47041	payment	2132	2132	1874	1	1	1828	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVFB3TDnEfM9WbkLmEy3U3m91TXZzENyWu7SQQWnko3hbxJWK
47042	payment	2134	2134	1874	1	1	7666	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH3rrwtGwZhEYqDxfNJM5Ursq7sTLTG5NsVgwppyAeGLEiTbj
47054	payment	1397	1397	1678	1	1	17500	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRhjhYQVXh7gDNNTgqKDUmox69iAuxCL3Nmq9PM3z8xL5eE99J
47055	payment	2133	2133	1874	1	1	7036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCwqK2jTX1VdE57LQVAqn5CNsTMU1BfVPcX9KaqxrKG6KXPVS
46896	payment	2134	2134	1874	1	1	7631	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpf1QFiFR3Le2eG8zKTj7MqFM5bT6UQhKT9XVZyNpEt5RZksuz
46897	payment	2132	2132	1874	1	1	1814	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PYL7PPTbrvfhy2nY5kgxPUup88HAQJ2rUUkswVdQyvLe4zdv
46898	payment	2133	2133	1874	1	1	6985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5SMo9J31u5YAfPskvJr6S9y8YLSCX5apPGpYn92wenYRgnj5y
46907	payment	2132	2132	1874	1	1	1815	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZqK5vdZfrWKkdRr7ofLd7YswBZDkPGBorJR2e8cDd3Y8is8aW
46908	payment	2134	2134	1874	1	1	7634	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfyRHH9cFq3twXTTnKciL88VfDPTQHv9NchmgRaX7SCMnJDCh9
46909	payment	2133	2133	1874	1	1	6989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJwYGmNJLsZFaYVyM9XYpNn8ZrjC34PRUPeBuGAwZZZd1peMH
46913	payment	1397	1397	1678	1	1	17456	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhG7eyZUt7sG73MkLh27VqrfgMzBKrsq23bD6tFLqCuAHLjkhn
46914	payment	1397	1397	1678	1	1	17457	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt4C3dKicijeEhM44UzDVrJpFZ7mtsPcreq2avkYzhQk4unqUb
46915	payment	2134	2134	1874	1	1	7636	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36wWsaRXrmWtu77Ys6eCf2bqo3Re6j6zS1F9L93FZuBGrNf4d
46916	payment	2132	2132	1874	1	1	1816	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCfpEnBHckd6QZXb44kmi1Rbn16T2osZ3n7dBV6i5WVX2DAr1
46917	payment	2133	2133	1874	1	1	6991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYacNh6hoJKNLmwv6uPxNaWBDrsE9o9QEQKR5YwzcsKTtYe8J
46918	payment	2133	2133	1874	1	1	6992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9PikUwyTr8MsekPL3YxX683ck11cnQGVRwg1Ds4EFE8xeUJeX
46919	payment	1397	1397	1678	1	1	17458	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfLWQ2tgoQbyu1ftQLczX7kbDdFGofuKCGD7A4N5CVWCHCt1tf
46920	payment	2134	2134	1874	1	1	7637	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQC2YjLUSTpcHYCPdo8csbQFcaBuVECYkgzfQcfyxFNh7YLFi
46921	payment	2133	2133	1874	1	1	6993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhJUvhVFvjMwptVumEnvF8LPFXumMVgKnXoie2G6XDG2CYkXa
46931	payment	1397	1397	1678	1	1	17462	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9A8CaEBg1faeewmCq6GDBo6sPX2E5oVvRqiZho1RwkkizQfX7
46932	payment	2134	2134	1874	1	1	7640	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5kns6NXt6cAPeqVitGCVk33Pt65SXLkXHYSh7jJs5HyDN2n7
46933	payment	2133	2133	1874	1	1	6997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyu9tSJtXdpeuhSWhvZCKk6PmNDHqNRMv7vbijbWQzf2TJduwU
46952	payment	1397	1397	1678	1	1	17469	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqTJJMEoEriHFGJJDCPzz85y3h8xHV6mBWNzF9wPtjyNdzW5k
46953	payment	1397	1397	1678	1	1	17470	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4fTr5a18vVitZt3ZRTSSASzZp44WBHSrhfnPXEDYYffBnmbP
46954	payment	2132	2132	1874	1	1	1820	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZERdRdb4Cniv9c2UQqX9vMTJCAt3P7EWp67RJ5pqVMFHEFr4oZ
46955	payment	2133	2133	1874	1	1	7004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk4NihudyebajHFFkt498ow2cVrLfedRs7q1XdLvydp4WLCYQs
46956	payment	2133	2133	1874	1	1	7005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugJV17JnNDNT7bMTpFtcRCj1NHJPw5YBHWEK2EgcCmDzDncMR
46957	payment	2134	2134	1874	1	1	7645	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1V8tpJMk5CdAgT1WFR4EyJjEDUuLMe1QMzBPH4m7uHcfZ53Qi
46958	payment	2134	2134	1874	1	1	7646	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MiVTketREwWySTMzWQ4wuzzBFcmHJDnXGsaKbA9J2su3kggk
46975	payment	1397	1397	1678	1	1	17476	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD8SmjVGvXtBBxtkw3m8babghorCpCY4BRKprD2CRPsh5SWYW6
46976	payment	1397	1397	1678	1	1	17477	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgNAKqXCSZeK1D13MdX9AkS8kfX63apsZ5oGoJ7qzGCd5p3NxB
46977	payment	2132	2132	1874	1	1	1822	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaxUGNZA2wxWqNdeZ7nkdEqCKne1VdzbkLCjNQSKTJsDZfpUma
46978	payment	2133	2133	1874	1	1	7012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtpmnGUR2qFJtfx3GnBMnZi5CPqBVacmiEcMTaogsufJBkGz7V
46979	payment	2134	2134	1874	1	1	7651	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKYsKxw5VEsv84yL9ZXMrJPiLd116orUG7tttzou5F8PDS14DZ
46980	payment	2133	2133	1874	1	1	7013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAwASz5LYt8m2ox4e648Qk7b8kJ5Df499a4nUU92vraEbtLqm8
46981	payment	2134	2134	1874	1	1	7652	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD9n1Ad13SZaEa7HRC2HuvyPsc63cKRcm983N1eK37b8rnwb9u
47000	payment	1397	1397	1678	1	1	17484	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYagBzMZmrMNDC2tefAnQQxnviN2JX4s2SezioZQyfrb4hh5Xe
47001	payment	2134	2134	1874	1	1	7657	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCywxNcLwmX3S3ri8gvDh47vxbGFUWwWC9pYb3T1kuvSLyrCif
47002	payment	2133	2133	1874	1	1	7020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuJ3EcDhtfEGkDXsU8rtRbp2TczpvuwrcWXKuooCdqWsQ4dpa
47043	payment	656	656	2411	1	1	0	30000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78HKYCdcBqhgfdrPDw6XNmg5HYjxYmjzMxreBh3GeiTYRyqsm
47044	payment	1397	1397	1678	1	1	17497	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzvSvjPk6Z1WZg8bX88FEyzWwmszXYJoWTVYBDgeRdKDwemzXL
47045	payment	2133	2133	1874	1	1	7033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjXi6b5M4KWrpXR8972epCuvcSWmjs4c7Xx8EXm6ahdZM5rgk
46989	payment	1397	1397	1678	1	1	17481	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDmTNVhfVNPi2a7HUk6tVVWdroBoz7nDghxskZUhH4NeGcW33S
46990	payment	2133	2133	1874	1	1	7016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAFLhhjtKhbAfEj5R3neuPMyDZAHg1JSN3BFvHdxoQpLnrfPzx
46991	payment	2133	2133	1874	1	1	7017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmo7TqXXVbteYzcER1gWqzq4AhhKp8Jr4Hy7gSXJKaXwHY3LyB
46992	payment	2134	2134	1874	1	1	7654	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bre9s3Dz3nhtjuZrKUyAn6hgNEtGGdCF172RMLgExyALeq4u
46993	payment	2134	2134	1874	1	1	7655	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEooqN2Ctu9MRvFqEGpHniR5heU1Pv9EniRKTmphR7THefUHAi
47003	payment	1397	1397	1678	1	1	17485	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcSY9GrfKNoUnnx3ppUoxSQGVuhoFCL1H1xMqyc5vsSzqnXJCY
47004	payment	1397	1397	1678	1	1	17486	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWEBmq2ZQt127c21phkzVnGRcTaKrvmAufZ6NaR2cnTS5QYff
47005	payment	2132	2132	1874	1	1	1825	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfdp3nwhVPDJ3Eib5ygZYgYG7P8MRq3VWPNK7Ruip3wUxwQjW
47006	payment	2133	2133	1874	1	1	7021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMCNVAzCMQJgjvVSYLhpGcfHjqNxaRJ9EFarBDZS9R3J792a27
47007	payment	2133	2133	1874	1	1	7022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrM4B5NdHjRZFJjBm4sKAXi6qB22VVZWdHvzjPHuYVxRWfXmM
47008	payment	2134	2134	1874	1	1	7658	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxBdLXKiJqfsEVXSHz3e2K2fjphMJxGEHDmqSmEAaKUbUCMHG
47019	payment	1397	1397	1678	1	1	17490	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRe7KYJqY8iDchUDgDbLknp7mob2UhmWA9HYsCE7Cr3EFcJJnd
47020	payment	1397	1397	1678	1	1	17491	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5dcJtgb4dYRvFGUMJeLYHBNoqxpbThJKZP3eyg8mQRCvZNcg
47021	payment	1397	1397	1678	1	1	17492	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6Utc9z8vkWe9yzKpVb3TLfF6YMqLAWJ6enDbLnBNDnG93MVp
47022	payment	1397	1397	1678	1	1	17493	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGFCUZ8KcNaCZYGfwoJYnhxyy3yNFfRCqhA9ZYpE86G8tvXML
47023	payment	1397	1397	1678	1	1	17494	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4CwLk1WkyhfBZxxjfUer9MnqjMS6VRXziZSW83H91Ykr9d5sn
47024	delegation	2405	2405	1406	1	1	0	\N	3769230	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC5EoehAABoroT3yjHpDJ2m2U4g1hpwtaw7zXAfkn5XFUra8JU
47025	delegation	2405	2405	1406	1	1	1	\N	3769230	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYywfZSbCTCbiizWBqv8RQxNPVFqhzkaZVQ9n4XFuGt9mYX2FZw
47026	payment	2133	2133	1874	1	1	7026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1qJDvwRZpXkinU3juyz2BE6pRApR2tSv5PU6ywGSsDGDypqvp
47027	payment	2133	2133	1874	1	1	7027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaHhYMc2dX6gpqnd3ha3QNMG2eQB9koLzDFYr3aeewdPKbNJdG
47028	payment	2133	2133	1874	1	1	7028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNy6xEm9xztbWtwEg5yfVwrLUW9UHvgm8v2ugaADwobDTSwWVB
47029	payment	2133	2133	1874	1	1	7029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZovGTPY1gbEUrkBUdmJCkGbvwSsZPG2s1BNSXETHaT42XruK3T
47030	payment	2133	2133	1874	1	1	7030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD8kNLuLZSGj57CftvyV8MwMFfSG3cN8yU61KMkoFyGPvxvM9
47031	payment	2134	2134	1874	1	1	7661	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwS8MLZFgWrnPgVYuYsny9DFc5CPdoNKYkUQFGiRbrfSJyrafi
47032	payment	2134	2134	1874	1	1	7662	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyEgkfvrxjhjKdsFwTjfmzzvSzHSYiThxnUjFakVzuiJgqzHAu
47033	payment	2134	2134	1874	1	1	7663	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1zWUnQTRgqoWFgD5KiWWpgH3uJ4s8YBieosgzYCn14jTDomBc
47034	payment	2134	2134	1874	1	1	7664	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWmcijcjo34Cuf9CiC3xWP3jnerxZiQAFZgJHX9nxUBsUR9Bd
47035	payment	2132	2132	1874	1	1	1827	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94RgpWfDyN1PfWuqVHeCCDq7pftuhwQnkUrFJNsbHSqxERPtH
47049	payment	1397	1397	1678	1	1	17499	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnde9baUTrb46PSW3vGB6nkUzT9xaNg9xFMsfYVXCJpzV8YAyP
47050	payment	656	656	2411	1	1	1	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZncChwcLKL1x8JSB8Bj7cvfuQE7rQdj8QRNLimJAG1EkTtqHuu
47051	payment	2134	2134	1874	1	1	7668	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW4EWKJZq6bXJgCPiDXFoPoEVqGvTGzNDUCCFwnWch3a19d78p
47052	payment	2133	2133	1874	1	1	7035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvxS7Miu8nuYenT7pcUr1VPshqX1t4KtiB6238EpMpzpvitiQK
47053	payment	2132	2132	1874	1	1	1829	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa49zbcnZWX5MJxa4Wd8Q8qT4BG4jn4LzgEHdJk1YFxk6nBRAcK
47069	payment	1397	1397	1678	1	1	17504	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1pYkM9eiKDGankp4zKigUyQTKmQegGDpzodgWqdYR8HKeQTNN
47070	payment	2134	2134	1874	1	1	7672	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAWBLYbqHyL1HcT3ZhyiR97AtjoTUfNByNaVDzjxTCGSACy7pf
47071	payment	2133	2133	1874	1	1	7041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPkPHtkVEV38tH2QpwCKDpJjEtnDxPVwbiyF2GrXPjAYT7Na8k
47080	payment	1397	1397	1678	1	1	17507	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhrixgufoJ6a9mDi583ABhvBMarvcegHsiv1tk1EhhJGV53LdH
47081	payment	1013	1013	2412	1	1	0	502775774000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4NPnrz9Jdo6Hsf7tGcGQGa8vozm3JWcZxXbjg9ztENuPHLRes
47013	payment	2133	2133	1874	1	1	7024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZexi6CvDim6s9p51eaGPgoyjSjrNwCLopDXxvY67jfR753j4cE
47014	payment	2134	2134	1874	1	1	7659	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5TtvmkdZzNQL1Mbj9LhNz1wh5Q6aY7Vmsg9yfGTR9hT4ohpp
47015	payment	2133	2133	1874	1	1	7025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFDKs7MSD6kqAm3mHUSdc6bfWJ4gKHWp6jNwiXNPkrFDN7kJw
47016	payment	2132	2132	1874	1	1	1826	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCwuMH7LAQcHbm3iYfXPfSbwdWXEgiq6rRbMncprnRmqYUVdF
47017	payment	2134	2134	1874	1	1	7660	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxR7jg5kW6PCFu4CgEy4aBKrxbcQzgBWBYyxLiNPQFvDk3arMS
47018	payment	1726	1726	2410	1	1	8354	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa72h7kyvUMSdDrLt48pkobmhY4BbZmFhHFKvHPwuk4Wxey1iYk
47036	payment	1397	1397	1678	1	1	17495	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEvKZJZzJD3iAkzu8N8gcCwVsYdecNbqjsfpgpE2MHhRi7qTNC
47037	payment	2133	2133	1874	1	1	7031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZS5m89JaMn1nNnT5Shni5nQpSivZxvd5WL3zZdtDPpBrSPVf
47038	payment	2134	2134	1874	1	1	7665	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJje5RGeNmS9wKuUtiwu2U8db4ezwZPqzQAeQmNGPT5AgZHepk
47046	payment	1397	1397	1678	1	1	17498	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsaM3ATumwa4QWXGeo7Afu13pekgs7ePCEu9FKdfiy9D94TBiC
47047	payment	2133	2133	1874	1	1	7034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVviFrdGrwhMfpENQq7UHnLfQY2cXhJoafR3FosS9k8iehzUwX
47048	payment	2134	2134	1874	1	1	7667	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfbgrsqDhSQwSWLKgotv2rQrLVsKKwBATLEsAmZMDEpYEeu4sv
47059	payment	1397	1397	1678	1	1	17502	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCoVx5DqGMyYZruFu2oQ97R5m9sYVT5o1tz5xWVmvfR2GmYQ6N
47060	payment	656	656	2411	1	1	2	30000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFVKVdc6Ld63cqRMX7y3MLzVZTmQaYsFmXoXypw3n3cAvoPnD
47061	payment	2133	2133	1874	1	1	7038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoABqSAMztPtLCLNVQA3KFjU5hvtQUmzvtp3LvsAo2FZRrbkSN
47062	payment	2134	2134	1874	1	1	7670	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv92dLLpcv5UQhMGhXqmheQuGpUpmifX4o7dTEZZhutjt7VFJY
47072	payment	656	656	2411	1	1	3	543000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotfwweL84DNCpFK7FCgMf9GdZbMurcJAPK3wqMZHjPQTEhcjP
47073	payment	1397	1397	1678	1	1	17505	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq9nnV72bNTCz8R9wZixSnCzuPh3zyRNjVPeiyWKZECrpAuRSY
47074	payment	2134	2134	1874	1	1	7673	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMfuegRkAx6fw6Ws7bBLAt4KhkxgFjPXufxfbe41YWSJ3j7Pt
47075	payment	2132	2132	1874	1	1	1831	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrBX1K9nEGWjgxcWDxYCnRobePSjcjcEci1CL8D9tCY3vtNYk
47076	payment	2133	2133	1874	1	1	7042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpaCDJLgeYoZK47c22UGFqU6SofS1MB1MpcfdX7LD9apphExH1
47077	payment	1397	1397	1678	1	1	17506	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSS8kGuK3TPjwFZwHSaDfGk1FkemjxD3cTzqckaoBebVY8v2V
47078	payment	2134	2134	1874	1	1	7674	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAKMgJYjotMgGbV7E2zKRhThB87LUhKhqvKX4WpprGKdVYke7
47079	payment	2133	2133	1874	1	1	7043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE98ARtbaGAkYV34AEjfMCNV9GUFpvmectqXs9514cWdykx4sJ
47097	payment	1397	1397	1678	1	1	17512	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHwyRm1wRuwxMpafY98VPTL1pLkn61XujPfsoyARZhakB62vt
47098	payment	2132	2132	1874	1	1	1833	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1SPAjbLV7rXzdbVeKzC5qFMxeoT8bVmEemTT8zd3TSJWGvi8
47099	payment	2133	2133	1874	1	1	7049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHMdEpEW3Uo2Dp5q2gepGB2aQfC5jKw71EHspAtoA7BznbEVT
47100	payment	2134	2134	1874	1	1	7678	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8qz3UNbcRXWHeM4vr3kHDtcqXYRbMQrLWXL86HtjCmGCWhBRb
47101	payment	1397	1397	1678	1	1	17513	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAkcA7wjXuGuzAb2tdTKmtHtCnN1UJgaFQvuGiiEhNPEMwGevZ
47102	payment	1397	1397	1678	1	1	17514	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsqqcZs97BCwEoZbboTakyuDco1LbAo451pjvdZnsGaCXSfet
47103	payment	2134	2134	1874	1	1	7679	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW7r4TUswuGY52uXHmdQ4rgeTh182GZfqG1CZ5VgUF53pJZcqh
47104	payment	1726	1726	2414	1	1	8355	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZu7Vb72shmQYWexjmNi34taB1FUfjSSEKdZuNc9txiLukF4Pvt
47105	payment	2133	2133	1874	1	1	7050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UGpxbeU2iWW33ijJSS1mv6ZCrunNWro4aMPTgmSgHvnH4Tnp
47106	payment	2133	2133	1874	1	1	7051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGD1P7D6CGQEL3tM1PEGYZdV336Z6attETAF8ijAR5MgH3AmX
47114	payment	1397	1397	1678	1	1	17517	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa84MPrVC29aVrpdDRJeo83p3pEZph46VoUwKVb7z5MtmzVP1n7
47115	payment	2134	2134	1874	1	1	7682	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPTJx7FbhvtzchQTgoPKx77Rz1nWnL71QT4qiMjBmr1SwYnEgc
47116	payment	2133	2133	1874	1	1	7054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmnRmgQrPke4nGGtwZFvDXo99q15eRsDYSuE8pQwCJvfVsYcv
47141	payment	2133	2133	1874	1	1	7064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDo8Xx4RxMKQDLsG3FSybrVRths2fLw85dGHHFDGfamDAsTby
47056	payment	1397	1397	1678	1	1	17501	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWgtAAryB68XNvNzyBKuTUu1wMeAKNvN1ApA77mzSMsicbBeK
47057	payment	2133	2133	1874	1	1	7037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8ndc4oAHxet3MtVNbLXodFQY4aDp2YDZ7pBvxUy1XkcX694S
47058	payment	2134	2134	1874	1	1	7669	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiXZAuDjb2WTeqAr1zCxXB8NSiVZXRatLf7erw1g6G9gLAmry
47083	delegation	2411	2411	1546	1	1	1	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVQJwamRo8gBGpP2bobuMF1zUDpf1t8xeosLwVqAHXkXwWcdfw
47084	payment	1397	1397	1678	1	1	17508	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqud2LxZhauHsiBH2AF8nRrfLWoTxCRn9EUey4gqKpLpWRgHv
47085	payment	2133	2133	1874	1	1	7045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvL7rSF2vmcovKKC5dPPX811Y6oqxcd94fVWaaskmu4bCtMHHp
47086	payment	2134	2134	1874	1	1	7675	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmzxNwZEjr7d8CWQ8yAKF7AUEqQ61mmGbnQMsSMU9Uo6GE9ax
47087	payment	2132	2132	1874	1	1	1832	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XA72tWdk17CWZDBpqZ3DHH2FrvmFRf3r9FtCH4muhAEdxasA
47088	payment	1397	1397	1678	1	1	17509	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUj8j2U4uVCW5YcqcPFbAzC9XipwoEqXbUD2ChVVFX2oF8tYP
47089	payment	1397	1397	1678	1	1	17510	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLz2KmzpEafw9ffrKfDB5sSniXd94DBdtX66UpbNAujo6TJ8Le
47090	payment	2133	2133	1874	1	1	7046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNftfyrMCgqpenBmAW4NSLErJo6GuWGycb9UZ75XsgGUprhRe
47091	payment	2134	2134	1874	1	1	7676	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgwVNPdBPFjgDRdK3z5CL7dWpzR5PWa3KVxjSn7yFGHwxTfv19
47092	payment	2134	2134	1874	1	1	7677	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2phtZ4sVyiLka7FvEbYSywpuM1fb7qQnC9iBitx3VVymmw3D
47093	payment	2133	2133	1874	1	1	7047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZps4ZjiPxjkbNriVbGBjUfZjKRWzgchynC3XM3spihprtLELSQ
47094	payment	1133	1133	2413	1	1	0	900972464000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFjDFH5C5rjRHr7v7FNHA3QzZ3K2PvwicPt51ZtbC58KnhGLSB
47095	payment	1397	1397	1678	1	1	17511	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguy94Ki6oHuL8kw99VqyoHsQzMf3aa9VdSDTAyyTT3Vx4K1b6
47096	payment	2133	2133	1874	1	1	7048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnUrDWDoM86ciMY4hUEenVgWuNL6GcDXzJM47x5S645ZSnZqW
47123	payment	1397	1397	1678	1	1	17520	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt48Fnum8Y4W5RATav2XQbRsXNZWRRP6qYc3gSRFW2q8Q8v96M
47124	payment	2134	2134	1874	1	1	7684	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoZfnUHsYhyTyUe7ZqrWTHkw2ncNfzjJZtHVwJjQAoq7KQewtX
47125	payment	2133	2133	1874	1	1	7057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsD1S4tYefZyUQRQod7ibKbLNvjQAAFXqXQTicDYf3HSiAw5iX
47126	payment	2134	2134	1874	1	1	7685	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKzEw3noe2mU5aZ3BmJTotgzzJsV95rkKeWmpRDxsfoUNy7r5S
47127	payment	1726	1726	2415	1	1	8356	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZNwdJ5mQpW4t9cAfHtXZe6D7Xe53HW2XCp4HVmN92BUQTihQqm
47128	payment	2133	2133	1874	1	1	7058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZiy1YkU6BSJK1EKroJhP3kALJ17NbBo28i3gKFUBLgb41BtYp
47135	payment	2133	2133	1874	1	1	7061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYysP34G8AXc9XEnVwtgHRo1sYVcN79bXHHrR5bRnujRpzpLost
47136	payment	2133	2133	1874	1	1	7062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVjYFANtJ2XRogN9GQ9Du4h3mSJ7hkc2UXLMigrS4h1ppwnSD
47137	payment	2132	2132	1874	1	1	1837	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ19DPu56JjEKMTeAKvF58ZWgKZLqmf6sLA4hKEhE7vj32GYPYY
47138	payment	2134	2134	1874	1	1	7687	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYGyNtTV6fVkea6XasmzwsWHQ1GYJad7MkWUjpPryNnRWo9uHU
47139	payment	2134	2134	1874	1	1	7688	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHSXTe91uik3BRNxtYZFettcDAJyLw7h5EzLFxLJ4ZasaANaY
47143	payment	2133	2133	1874	1	1	7065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZv39w9JDvyYn3kE5FsvQFp3ByzqWiUo54BBubaxR8yvH29jJA
47144	payment	2132	2132	1874	1	1	1838	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmH6zMfJsmq8d2aTSfeXmq6iGkJoTe2HiAaTK7xb9HJBNcRBNi
47145	payment	2134	2134	1874	1	1	7690	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq85qrnGRhUmXMFtByoyYFTG6YNxcQ99g9LYtv8oDrS6egYojL
47158	payment	1397	1397	1678	1	1	17527	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCcHx9EmpCBoSm8jWCemBwuiKUFj7rW6Yccue8xsoqBoXuMf6
47159	payment	1726	1726	2416	1	1	8357	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYjnNFkVjzBuo8M3XCo7zPSVwEc718U7f1Y3oJ1NVZBXxdFHFsn
47160	payment	2133	2133	1874	1	1	7070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYEMuSJq4bPpb8PgM2vDRuTTcWgN8HZmknXYQRXjE575jAAXRZ
47161	payment	2134	2134	1874	1	1	7694	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoDUXmsW6CfbxbHSDbHAzPnNTfguuAUwc7KyAc7tUaj8cUAkTQ
47162	payment	1397	1397	1678	1	1	17528	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6Wv1xegWCNGQhsNW2Uvs39fCsmTSoEgfFonqopktcPnne3Nn
47163	payment	2133	2133	1874	1	1	7071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4LUmsP9VUcL4HnJvkxwZYqva1wFHc5cwFtraV6eiVmrnhwDRZ
47174	payment	1397	1397	1678	1	1	17532	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQpFuE5aZniybCvnzB7CugwnNyxTNooQEH7sZFcfvJ1xKP2K9
47063	payment	2411	2411	656	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfF4ogJVHt7eMxpdGKY71pWTMdjgTq7AwkxDZWWknZvk8J2uJa
47064	payment	1397	1397	1678	1	1	17503	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Knk6jBr2TZs7Xtt22VsPUvcik3RUpJjq8DZTBQKT6VwED8tQ
47065	payment	2134	2134	1874	1	1	7671	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXRHm41CnYxwyMw11mvwc8uFXz8ypBPJHNNaJdsS57AtYQauRq
47066	payment	2133	2133	1874	1	1	7039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuNt39TUdhv7QtgbjUnFG2UKdbfrnCQgGRq35mRj6bpCkHqQfe
47067	payment	2132	2132	1874	1	1	1830	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGxxXWVyrWLHjXCBfFBq7vf1HYBABxuUbtHhaGH9PVHmQMkFX
47068	payment	2133	2133	1874	1	1	7040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsddQq8Us4YGhwPDQkJXhrLiw44vtmgJr2wkdXtiaDazaiGQ77
47107	payment	1397	1397	1678	1	1	17515	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQKPZujrfrPUS1aXzPPWtVd6H9JxquJFDE7hhFxVQgPPPTzmKe
47108	payment	2133	2133	1874	1	1	7052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcRtmSDoc1EK9ApHYGKGdhuzWkantzesZ341G9cdn2HUn2u43C
47109	payment	2134	2134	1874	1	1	7680	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE5iY8PX51Mty1y5sL3pfTeKxBnBexZFaN4XprWAPGRsBNMzk4
47110	payment	2132	2132	1874	1	1	1834	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEQdwynRMMPGZxMwmoMG678L5LDy1WZkD3TMqDcU3BxLRqRCX
47111	payment	1397	1397	1678	1	1	17516	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5azWLnVywQ8n2XUWNi11dXLc7WWSZzfcydeVSwsdcKFD5Eun
47112	payment	2133	2133	1874	1	1	7053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpTboYTCnZUQ8c1o3A8CKWMwXTaWnwFJxTtEFPfbZf8bSfMWRy
47113	payment	2134	2134	1874	1	1	7681	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt1tPAiYYyyjSdkz43ZwNh46eU3RnMLdiqPMnA6xtUNx6RjujD
47129	payment	1397	1397	1678	1	1	17521	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoU3cneL7h6pborzZcxeftDZQxTYJA7YqdrnaqzL4qJKRd3g5G
47130	payment	2133	2133	1874	1	1	7059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAjktPUHEH1QCTaoCNPYqTNAJFckw1BV5wHkeE89JZAanizrG
47131	payment	2132	2132	1874	1	1	1836	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2uByNx8C2weJJ9t3eL2eTrDvVTidfnEm1DRTsCc71PEJ2ogsW
47151	payment	1397	1397	1678	1	1	17525	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9oiduSEoA1p1JWu5nXLG8zksyUg1CDvbEdn2WHrvr2VKNZ5Ra
47152	payment	1397	1397	1678	1	1	17526	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qsB5jJnVnyDvwwiHivytCZgtKdLHcxjxu3LKU8VRg3co6HTb
47153	payment	2133	2133	1874	1	1	7068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76C5X2G4bB58udVFukVB1vukoSXtbyxbs8orxsc7D219kr2FP
47154	payment	2133	2133	1874	1	1	7069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuoT4myNGrgxkqi3jMAYUkayasG8xozQ4VFVMnukpDbX9bF5vk
47155	payment	2134	2134	1874	1	1	7692	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX4LekLHmtRWY987Ri1LcFS5HMJKNNdPdsVLx9XoEJS7oEteGs
47156	payment	2134	2134	1874	1	1	7693	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzV52AuENYcoUpZX4dV9fqqbneV2s7eHeX5ZpEzXcRQdiEWAZv
47157	payment	2132	2132	1874	1	1	1839	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFeECczDL2fAn2jUrEEwnM8JKRcQacASdC5RryNm2y4Kh5LkC7
47177	payment	1397	1397	1678	1	1	17533	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo4sw7P58VMDmoCcy7h7aKNeJWT9mmn29UgMUm2jXboMsBjzMK
47178	payment	2133	2133	1874	1	1	7076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWS4GALAyfiEHypbsx5tRYXRMjmFcuUFua3djsjLM2eZA1mgd7
47179	payment	2134	2134	1874	1	1	7698	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9B29deRbuXPpCfur1JXm2LDgLSRimCmwXKX3K2qf1nYiafuMQ
47189	payment	1397	1397	1678	1	1	17537	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUbsYWLVrC3pPUgu9LCYYEzLY9yYdsqPWKujufnBYFVSYmwY5X
47190	payment	1397	1397	1678	1	1	17538	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFQe5GtVRwDXYr6MqDLdjRu3Zvhrwkysk3scxDDMV9sBHQXezx
47191	payment	1397	1397	1678	1	1	17539	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3H7JgoC32zmwKZKYi6Gb4T89zMJMo83UcumBbpL57SQSmcqig
47192	payment	2132	2132	1874	1	1	1843	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUWvkbMFHgEpbBxv4J4h9DsKie9iWfi8PfTQFnFDFzSYwugtus
47193	payment	2133	2133	1874	1	1	7080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uNRxvZuUnPfsJqwRrJyZdLUbvkKkMuzmqQ3CF38LvwozeJ14
47194	payment	2133	2133	1874	1	1	7081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Sa2mrpKJqDUdGztZh5EXEycysJjAogjV1RxwXp3H8JyjXnYn
47195	payment	2133	2133	1874	1	1	7082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2UFU6XXE99QwW1jB9sMiyqzp5kCe6zZTcAjYERtrBoLXztT6K
47196	payment	2134	2134	1874	1	1	7701	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JDxk4GvKG3yBPmfzV261zJge1ZfuAX7hrSEjqBMSVYKynRgo
47197	payment	2134	2134	1874	1	1	7702	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ysdK4GzWfaGxvGT4psR2qofxww4gB8gz3DbXEToxtheWZS7m
47198	payment	2134	2134	1874	1	1	7703	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJeDKizCbkxFUA79pfy49e7gzeRhTD8n2VukiBVF8idbJXGgGy
47214	payment	1397	1397	1678	1	1	17545	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyoTYFnwhp4daTHfVKy3rzDDsBSB6VittnSbc7pWBakUs7Gq6h
47215	payment	2133	2133	1874	1	1	7088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNPEhWpQjKVbUpNpwPp7Zr5wspd3F2ZUPhXJoYb6a6hDpZirn
47082	payment	2133	2133	1874	1	1	7044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ9vzPjs27iYXiiZ6Ehz8Kp3Z6KBUyhaKg472vTWnc1VtDPPWt
47117	payment	1397	1397	1678	1	1	17518	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYydZYf97ii49wfE3r58FfF86KeQZTVzHseyGaBT6P8RqkkDoQk
47118	payment	1397	1397	1678	1	1	17519	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU3rp9BRLNd8kghxavgbS6QQDtfE8EjWxKPYifVhsZq5y2oB85
47119	payment	2134	2134	1874	1	1	7683	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcahKfgNYhn2rkoHvd7RbMK6ANLu1YSpf2F9FbLrd3A5LPpkk
47120	payment	2132	2132	1874	1	1	1835	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyn3eqUMXqYEDCbj3AkVQ8cYnE5onraqXRtqwgZiSHZtouRvnw
47121	payment	2133	2133	1874	1	1	7055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDP5NU3Fd8vnssYgzMfCLmTCY8WA7ZTiJneqwm9JzsMx2ZHfHX
47122	payment	2133	2133	1874	1	1	7056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2JrUaPdF1LcAhzepyA4vwXgJtwyXgtwUpfz5r9cWuaHV1phu
47132	payment	1397	1397	1678	1	1	17522	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRx6VYibv42ZyG7ZoPYeJHaY8L8DwsACwgEhgdqDuY3su53Eq
47133	payment	2133	2133	1874	1	1	7060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYis1JKiBwtLDXZdf7zkkxu3siS44zzzj5DBdaTaJkotFwCVUs7
47134	payment	2134	2134	1874	1	1	7686	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Q51STgXqnL9Szso5xQqxqrA3KPVxnLsrKMBHCq8pU2cQHkiv
47140	payment	2133	2133	1874	1	1	7063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsxqkZZdgi8fcUhLysJ7dME5w9qGfnYRv6qbo2hxw6XijUfWU
47146	payment	1397	1397	1678	1	1	17523	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Yz16yS5v586jVoCkbvc3t96ohrei251FHFnq3DWo9Q5znxFU
47147	payment	1397	1397	1678	1	1	17524	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQQzWAe6hwxiK5XrGfteMM1uqCPYDHUZA1SsXwxQUo2Zb2tRX
47148	payment	2134	2134	1874	1	1	7691	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDzMExyZm3Yw89EwWoC4VVwgu4veEK1uGK7Vjs9GrC8HDoQA3
47149	payment	2133	2133	1874	1	1	7066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBCjYEwiUZk8yo38viz5KULVEPqWNDc7K8xtvgQghmZYUoXfP8
47150	payment	2133	2133	1874	1	1	7067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3mtAJZDxgZkUcHr9vPc3rVwjWsFLFgwF9HKT3hXQse6FAMZnx
47171	payment	1397	1397	1678	1	1	17531	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4gC2VmYLJ6Hi2GqPXEJt47etTW3cmFtAa4KQD8TBf73zcjzrZ
47172	payment	2134	2134	1874	1	1	7697	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHWW9aceoacgc4223E9dTiXpE7RTnqYWMNFfRfAuNNb8EZyMn
47173	payment	2133	2133	1874	1	1	7074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfz7ds37nAM59pN9UCB1n8dnC1aVWvxJusx2w9UtDZChNgCrw
47205	payment	1397	1397	1678	1	1	17542	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MFeDJVLgGj6Pv4Dc26NubW3bhNmioVA13t3jVGDe9enn4EQF
47206	payment	2134	2134	1874	1	1	7705	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnbUkvPHkHBB7jgPQojUDGYMEMFWzeGJ5GwFLSa7jswJpETZh
47207	payment	2133	2133	1874	1	1	7085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAoHFEGHKmjL9jgrn7XvD5bXPwUdTStdfh2VZ63F1icUA6r7E4
47208	payment	2132	2132	1874	1	1	1844	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFygwHT7hFRpPvzWmswZFdkBYXhnwe7bkKbWMo7g41wEzdXyeW
47217	payment	1397	1397	1678	1	1	17546	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXWsKZzSe7UTkUQQHyybYsGCyyogQchqjhQkwZ5XTnxUkkKMPx
47218	payment	1397	1397	1678	1	1	17547	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhXhXnHKGfiPpo9NQ9b5XU37nHbgJ6TNprKCFgu2vWZimpsyc
47219	payment	2134	2134	1874	1	1	7708	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqaZiZrL4Gb2Lw9qrBaAA6GX5LKXX3xDNbsErWBmmordfwgTNB
47220	payment	2132	2132	1874	1	1	1845	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9Z7LDuKGnWzrEAZbp9sNobHgLPCE7fT57YvsoYE5oekAmokD
47221	payment	2133	2133	1874	1	1	7089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4BjyXEnXehNxLSCSoquuxZXBTmR88ELkKvecEr2YEgxG1cyX
47222	payment	2133	2133	1874	1	1	7090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjnRgyhLJ1zXQvFTBT7CMLvMqd92tPvhfeZncrcqRRQSR3umn
47223	payment	1726	1726	2417	1	1	8358	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpaHofw5a29w4DGshEEQVA3f7PQ5e5QzX1MsNHwN1YP9VMw1FQof
47231	payment	2134	2134	1874	1	1	7711	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo56qK9916uZVQE4Tnirs3TCHySGmDxaoGr4gzUvPB8YkSFiQ
47239	payment	2132	2132	1874	1	1	1847	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiwetcZDJME4iMvXHK6QAqsKixFSj2TyQs93BPzLWUvpmC1bun
47246	payment	1397	1397	1678	1	1	17555	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyTNcsDWNwv7LGYG5mpY8E3RYznznE8Lnu1pEQzZL1ffwdeVC
47247	payment	1397	1397	1678	1	1	17556	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZairNbC6W1Y9e4D6TUfjdpzkK54qcZrBV2GUipk2mFnZXpKr9
47248	payment	2133	2133	1874	1	1	7098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8wCDiiT45wNJ42ZH2MFeCp7ytNBgZXX4Rdtnjj5noCpMJwFhC
47249	payment	2133	2133	1874	1	1	7099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZuPF2SzKgSY4fsYGfQfCZfyUZ948T5smwWB7QA6UXKPTV6uE
47250	payment	2132	2132	1874	1	1	1848	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJXCKMyxgUp8u45cgv4g57b5ogzmboiEBi9PgfsFemR6tuKqh
47251	payment	2134	2134	1874	1	1	7715	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDShFt3az5qy2pGGDSzWUCfawAuATLNjeraY8tRACR53XVkzdc
47142	payment	2134	2134	1874	1	1	7689	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwHK91zLD7LNbbEUANrhPJ9EMRHdGaGodud8L4GvFgbbKqKLq
47164	payment	1397	1397	1678	1	1	17529	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9yGFXDbRfn3PwEjh3CuGRQc8guz9SMQHBHCnXAWj3bJzRK2jK
47165	payment	1397	1397	1678	1	1	17530	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRXVHXbhhssBCnm5SJemchEQ1dEbqEyKK7dvpDNFyx1gJXqZv6
47166	payment	2132	2132	1874	1	1	1840	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFrXZuodsFoLWoLu1nrjXkNBvHLhofEsaLCZng1rKNxuEmHc3K
47167	payment	2134	2134	1874	1	1	7695	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8bwDKS2Jwhfy45DjakJTZya1smfd9fdivBAQQ1Bg6rBSrYRBU
47168	payment	2134	2134	1874	1	1	7696	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzc4FRqSw4tauKPJBHFzyr62C6j6cifw27RrXqEyrGNKCgQCvH
47169	payment	2133	2133	1874	1	1	7072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLMoRNvs7j54XqFRHC8MPkTqu6eiUyZAqNYk9ABGCXDPnYX8y
47170	payment	2133	2133	1874	1	1	7073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwXoRUTDK4qLbgay7C65CBEjxYfWKaEYu1ukP6n6ySfDZUWaP
47183	payment	1397	1397	1678	1	1	17535	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiAo5sKCjsWL3KWtYqjuSBeBRFaBc3GaevMGVHR8uyXwnwbNTL
47184	payment	2133	2133	1874	1	1	7078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdj5BTuw2J9aEEiV5KDmcEJRbGmCHLcamAXybKBKTjRcWDy4fM
47185	payment	2134	2134	1874	1	1	7700	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ878EQyX8hG3LocKTqGjTyYwg4jhVKA88ATRz3JDBApM3vtgjb
47186	payment	1397	1397	1678	1	1	17536	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyxqSwuokeoxv3b59WQFq4wtMJxMZPgEzLVGp74MeDc62bMVD7
47187	payment	2133	2133	1874	1	1	7079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbRkX18jDbcvQYuYAybYwZ5ZMsDtA9ZLT9GwepcWRrMsKbxTnH
47188	payment	2132	2132	1874	1	1	1842	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9NTJgZUeRW7NxgerqGm8Ux3cYWDaGXQRuzGWEp5DTT5QNSzsN
47211	payment	1397	1397	1678	1	1	17544	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEydWmtFta7MfCUanNiWTtvnx293YuxBAJv3hQX8X51xRUuoWX
47212	payment	2133	2133	1874	1	1	7087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNS8FMu86FPChMALKNp1Ty4jgEsGHqzfYkWv8BQwtqxa83xQy8
47213	payment	2134	2134	1874	1	1	7706	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKrVwQebavqKwUtc23UdPX5knnKbT4J2RhB2STDVprJQeLtMX
47224	payment	1397	1397	1678	1	1	17548	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMbutw3ikE1v4P5Vz99RLYWYHisaapW8ogxWBW529XRmaRevz
47225	payment	2134	2134	1874	1	1	7709	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVkTstQHbju5ckS4VkTochsjwGuDcKGGxn89WmETNKL5QR2xu
47226	payment	2133	2133	1874	1	1	7091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXRT1QsBD5ZYiNDDetBbkcDY3MNhN8hf28esbsZr1mWZuzABx
47232	payment	1397	1397	1678	1	1	17550	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkizYDzBSrrT4LidPXBxHQGBocew4De5iiMZUrMfDx51zt4cQG
47233	payment	1397	1397	1678	1	1	17551	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkPQZKWgKUt7VyRHrqWpr7TNMx2HTJDN83Ux8o9g57XmBQvfK
47234	payment	2133	2133	1874	1	1	7093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqv8P1LnZVqMgLtDSwUSwAQHotG48gfoF2N4nwSL5is5NtgkA
47235	payment	2133	2133	1874	1	1	7094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyfPsM5yD13yTQDsqpM7J4AnUtRmZptgfQmvUmkZYRtVBU4eMu
47255	payment	1397	1397	1678	1	1	17558	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSV1WNpegMbtsBoncn7uzUcCC3YZaagjw1KJhsHjGr5YSAvQA
47256	payment	2133	2133	1874	1	1	7101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9htcog5TtgUcNsS4EHh4Xj1FriBudV7sDttH47yeNYAbhvJB
47257	payment	2134	2134	1874	1	1	7717	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTNU7o7HTzR7SkttbhPqdWSqcL272ycnN5TosdjWNSDyt5yS8K
47267	payment	2134	2134	1874	1	1	7719	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK45ufmfDBPNhgWFuwig83HqRNRPbUghNBHVoLZXoXcp2fLy24
47268	payment	2133	2133	1874	1	1	7104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKFgaxxGXf5X6p2YJ9txVVNqoNXng89ztVc9axiCUwa2E9DBQE
47269	payment	1397	1397	1678	1	1	17562	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVRjqwa4cijKZjRFeu7H3sxYeDZb97EHLGFSah3bff1xfNL1R
47270	payment	2133	2133	1874	1	1	7105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTRPTW5KxQfmAaoCE3MXySxHoc2aqxkjr8bSyT9afoQzdJHo5
47271	payment	2132	2132	1874	1	1	1850	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYCyoqVZZ5oFHUuGYwzyVBMrVcuEpSerKD1ppBzuhAYDi3zpK
47278	payment	1397	1397	1678	1	1	17565	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvFDekbpqBBsTZSezXHir9KtWzDMq1ueUsj4FceArhZZJs6bu
47279	payment	2133	2133	1874	1	1	7108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPd69DBCwvfXpo5Wbm6YCbmVArCeKRokEhFLtZGa7Cqjf4GAV
47280	payment	2134	2134	1874	1	1	7722	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuk6ossDhnLGA7ynbW5BFhKiMaPHWp4wp1rDmzTyoBfGntoZw9
47303	payment	1397	1397	1678	1	1	17573	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGHPfXqtfVqhawaG8AqQxTs7FtyQjwJsM3JuHQfLN2cw5LEZ8
47304	payment	2133	2133	1874	1	1	7116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzofj2QtehEt4Km5fFi1KwAYTqPGnTw7vHo6aAbRyZ56hhB9eo
47305	payment	2134	2134	1874	1	1	7728	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZnPSN3XCj3kf4xwvMY9jmuqGpnorMi6zjc8mf9PcEJsb51j3
47175	payment	2133	2133	1874	1	1	7075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCkWF1Z6vC8qQTgGFe5aV6zXTmaZi6HVQ76hJCYmca5uLAfro
47176	payment	2132	2132	1874	1	1	1841	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJKRzaLH3hdeGjS73hgbDtzkcJew3aKQ4mfeoW8MeC1jgqx5XH
47180	payment	1397	1397	1678	1	1	17534	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCoYmDAfVCgtwPQfJznKV9QKkpwxcxHMSfNqFsyLyibL9dsTDH
47181	payment	2134	2134	1874	1	1	7699	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf4opDmodEiFT9WWrHP97jWZUGeVnmHrdB7asbsygYGeXtrMsg
47182	payment	2133	2133	1874	1	1	7077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuFVgTK7J9EK5ybQJWAQMHsMJKuefpHDp8u4Z429HcJU7QMNSx
47199	payment	1397	1397	1678	1	1	17540	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7zow9nNfbSsRLfSPhZX8ct4sZ3y9yNGioXbDqpPEkrH2FKEY
47200	payment	2133	2133	1874	1	1	7083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwHX5sod3dXXtWQMfzya28mmSFoSmSetH8NoPoG8gfo5pPAvc
47201	payment	1397	1397	1678	1	1	17541	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz7nd1deCUm9fPvtLXR4uWGZ4nt3msecm4fsHGtopJk71ii51E
47202	delegation	2416	2416	1600	1	1	0	\N	4857140	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjgDcT71pBjXprhfHzg198aUmpSBPQd7WFYRzPHjAkMaAYNbH
47203	payment	2134	2134	1874	1	1	7704	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyjnxB9Cf3FLxx3dxZUszprkXj26HsDba8EAajdtfYxpwRrq5N
47204	payment	2133	2133	1874	1	1	7084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9tRxL33R1CMLdw6gbjb7VRHRBTiJKVQYAYrSRFBjGfo9HTS6
47209	payment	1397	1397	1678	1	1	17543	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5KdZ4ufWBX1y49xaakLybVXq7BSrk2wM8mayZnJdGnnfonzp7
47210	payment	2133	2133	1874	1	1	7086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1P81RzNeB4U96QciFS4oKd3ktYCMRSNuecpEnHTq2TDZNJmbB
47227	payment	1397	1397	1678	1	1	17549	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDQGj9yYTtMnkSzxKWLaTrE8hU7XsbkxncKNn5hVYPZAqfGLe
47228	payment	2134	2134	1874	1	1	7710	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9pk3DhFPSZrraoiuaqMPRQekqdYQqc9h54ELn6xuQHeiL96E
47229	payment	2132	2132	1874	1	1	1846	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZALWyzL8wSxGVh2xBRHJDJYWvKHkzDgp58eNJwJaWnbsBKKKvs
47230	payment	2133	2133	1874	1	1	7092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxTK6529YDeS56e4a1b3yS6GHT3gYqBpV3JzdSHP7YY7iCWWG
47272	payment	1397	1397	1678	1	1	17563	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZddsEbWPUpduxKhX7gXM6aJkkhhff1n62Lx1aMW8YhB67qYnRS
47273	payment	2133	2133	1874	1	1	7106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVfDaKWQhtMGUHk39Q5gnguasknQfz5qfpVQi7GFncBS4UXUbw
47274	payment	2134	2134	1874	1	1	7720	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmtcoq7grrznGieWoJam9dmzpNM6RNqYahBFgtiQp436yqAYUg
47275	payment	1397	1397	1678	1	1	17564	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnb6ZuWRVFp9vTsBUGYjrHyJ8sgMJH9GKbNasgYcqP4Fnt1qR
47276	payment	2134	2134	1874	1	1	7721	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQUZfwQN7k3keeE3Pnb5WJFLZbxrUSvRxajoiCvZ4pFTRqq5wL
47277	payment	2133	2133	1874	1	1	7107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVWZcLu9UNegXPcPpdybT7kPqZr2GvG1WJjHq1hmB9cN9PVi16
47281	payment	1397	1397	1678	1	1	17566	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9asYyT6A1SXDu4PjasSWQzYWYC4GYkZthEFaeTLFb99sbXmL
47282	payment	2132	2132	1874	1	1	1851	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrggbH1DcyDvSsV2yes5Ky91YXXWdTjof57aZ7GDNHPtJE6iTG
47283	payment	2133	2133	1874	1	1	7109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMJEU2CDiZxcPsS4gGBAT8do3c6Pge2rpgvVQfm4A64z3FyADf
47284	payment	1397	1397	1678	1	1	17567	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvSmxMMk5qyPvy7jbhkGY7YkUi7fy7XPibuR1nMGXCiQjzwh5
47285	payment	1397	1397	1678	1	1	17568	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy5bfqjUNJpSag5f4Y4NqB5HGBTAbnfYSjTsYRHVCsuFXZ4AZB
47286	payment	2133	2133	1874	1	1	7110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrgiu4f3evzgxkXvVPkJstPuzgUPB1S8NS9jyEoxnsVQMs5DMR
47287	payment	2134	2134	1874	1	1	7723	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5Tusukhb3hB6m9ENGbG3SWFyyvyaV5VnCyM2cj6zsHCsWcwL
47288	payment	2133	2133	1874	1	1	7111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqx5Es1ojiFmpA5kc5bvpR5Notr82rt27SEun6HUv44GRC6tEL
47289	payment	2134	2134	1874	1	1	7724	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFEmxWThvZtQJoD4TgpAiTPNfQZuKa39LjWoZG7n27Nnygm6U3
47294	payment	1397	1397	1678	1	1	17570	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBY9se2kHHwnsXsMxXKWJosMJLxuAGKunFHXPvBdQTa7dhJg2P
47295	payment	2133	2133	1874	1	1	7113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGVdQKSsmQ5vrPZvxYSdye8fk2cbQtY7VrCPDtUJMBt1j3dcW
47315	payment	1397	1397	1678	1	1	17577	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLmCfcu2cuUDcTjaDp7QCcd5DgmVzSKgLABDywJHgW8TMHZkQ
47316	payment	2134	2134	1874	1	1	7731	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4u85yoYLWAEvbTNf9LzTcnWfDvn49BCQR7kxYJrkEqJUM7gt
47317	payment	2133	2133	1874	1	1	7120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvfCSbqiRFtvUFnmJfU1U4FCRuLMjiviUuLeS1gx6PGLASec9
47327	delegation	296	296	1540	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vhtKTFhLKXEdamFdv1NmNNo4bWMim2tDHH74zQNMQvHUyw65
47216	payment	2134	2134	1874	1	1	7707	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq91GFwBHstvNfziNPC4yLYwEqadBa4cKhdCCW3nEyWQS3pUmw
47236	payment	1397	1397	1678	1	1	17552	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkHrMiZGzkPqFuppLjKkGJGLLZPxd6FQ9GPA6eCyFD6eMMPMP
47237	payment	2133	2133	1874	1	1	7095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp6TJVDX73cBChygbxusrwjkxpRXS1LZSr42GmML48Y9Q8dtTi
47238	payment	2134	2134	1874	1	1	7712	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2QTmtoKnbkVRTQa1JS6XNGn8y45UE3NntvFGukvDq7Vnt7NE
47240	payment	1397	1397	1678	1	1	17553	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKso4QV6C9rw5dW3UbpVJPksMfDa4emnWG1TBwQDDCLDR6YFm9
47241	payment	2133	2133	1874	1	1	7096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbyZ2Q4m57gHQZWg3H8qBbQLvjCkgyr7KxkeKfaRGrG1FXUCm
47242	payment	2134	2134	1874	1	1	7713	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLbnvNhskBBNadqXWPgWnHDZdvG7Pq8WZqcYS3M7USHTrxMiu
47243	payment	1397	1397	1678	1	1	17554	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgWyX35jXhv1e33DQrV8H8GqUzit7Lrq4hZUjJxNbieFd5EVu
47244	payment	2134	2134	1874	1	1	7714	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQ4S5XuXzpppYU1j6Dqv2knRCNcTA9aNbVdqBLdb3k46gG433
47245	payment	2133	2133	1874	1	1	7097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYprEhw62CLTKLbvDPHKiNqpTVKoJu6Unh5Scrojx95XZE9NSZz
47252	payment	1397	1397	1678	1	1	17557	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9ZBazVueXfw2NsWjz1rvzedWQFoDGbT2QLBZyELi7M93yw5W
47253	payment	2134	2134	1874	1	1	7716	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxzSWWoJQ2HDWNwqcQAfGLYDfk9SMuhdnyfKjf3hYfYY2W8hZ
47254	payment	2133	2133	1874	1	1	7100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk1wB5Prh6Ls66KCSSzh7QvhZbxQYpvTr7wWGaoE9rMWcFeZLz
47290	payment	1397	1397	1678	1	1	17569	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxTiU4kbeKhfXVRRGdGTKqFPiaxkoQ1omoZtUhWFiYRfgtatyA
47291	payment	2134	2134	1874	1	1	7725	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYguUN2owTpUDbKC5qkJfUXdTmssj5uTp9xSDX1XbJ5mJTqwSxJ
47292	payment	2132	2132	1874	1	1	1852	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGviWqxwTGScVri1jSj3XU6vfVp9iTy9pJTt1L1GFbJHxipjK4
47293	payment	2133	2133	1874	1	1	7112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJz9TRJPfLxoxnav8oeUnuWSLSUMEzVpsBN8yfVXPNCaHDCHo4
47318	payment	1397	1397	1678	1	1	17578	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1a2bhSzrUHnPuK89N1nHVHRuje2CPwWdj8eRgHwuimivwE2nv
47319	payment	1397	1397	1678	1	1	17579	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8dDbTwYdUtiZZEfhgTfNkohBgFeccUnSRjLKMPanGqi2KEqi
47320	payment	2132	2132	1874	1	1	1855	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJS4uzmoJ7ZYJuXXZndDigC48REv45XGG6jm3Tpq5u6zKqoA1
47321	payment	2134	2134	1874	1	1	7732	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifxNuNczQhXmV1vbzh68haqJ5obCZB3aY9sbxnF17LxRKyATu
47322	payment	2133	2133	1874	1	1	7121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDfaejhjz2BjANwpaVEPb9WeXwyWWNWidXA7drL2V1MDv3tXr
47323	payment	2133	2133	1874	1	1	7122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEK167D26J71VqBfnE9T4TTiaZkANtn2AMg5xskzv6xFiB7wc
47324	payment	1397	1397	1678	1	1	17580	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgxWjaW93dUxBog3PDiGu7haDqM1ALch2JURQ5dPYNag3ox8th
47325	payment	2134	2134	1874	1	1	7733	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibJE49sMx7oaUqJxG4x9CAybsg4VS3KUdyH5ehpbku8p613Mf
47326	payment	2133	2133	1874	1	1	7123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ijAY1jJ3TcF1tRqVkPjKMHBf924M39UMYcR5FAhUrQq8wHHq
47340	payment	1397	1397	1678	1	1	17585	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXRqGPB9YuSAe3UizvcEjTjCJiYM2FoCGTLTw2azkgortLWKy
47341	payment	2133	2133	1874	1	1	7128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6VBWFU9e71xNAf7vGtXzytKRbvSpnbgxqaV3tXf6PxJnzXqxa
47342	payment	1397	1397	1678	1	1	17586	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bmg55nRVkn8NgCQpXKQRLe2npfXq814sByAenhUguegMdX6G
47343	payment	2133	2133	1874	1	1	7129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZWUw93t4WLqVgvByyqxXNRQVvRL7fhsh5UjsEP6sKxAy6ArQc
47344	payment	2134	2134	1874	1	1	7737	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBAN6U75iAcwxxJz86yQTEE5GqwoHDEXcNpA4VSZVuLazCN2gS
47345	payment	2132	2132	1874	1	1	1857	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx34vFHEZFHyRffsGtco5Hhhdi27ktpSeFbReUF7QUvZvozLfs
47358	payment	1397	1397	1678	1	1	17591	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLzP8XhmEVg4Pv6B1iwEr6uEuBiYjM3JJJrKcbkGN3jskymgs
47359	payment	1397	1397	1678	1	1	17592	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dRtZLjfYAoyKVjTNANaNeSiYXR7dYqNWfZ6REt5QxdkMDPyp
47360	payment	2133	2133	1874	1	1	7133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUpruzqJhN8ELbDu4sg2Sb82yrMHD6aD7ewLimhvYRJL2auGXZ
47361	payment	2134	2134	1874	1	1	7741	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWEPN34MPhZCnFsvVhwMyUHkvUvwhZmow27SpC8YVd3YkdYT8H
47362	payment	2132	2132	1874	1	1	1859	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwpo4bAEPcDkxkSeNkCL1Mo1y4HBqTVuDSPGuj5TiXzU4x4q7
47363	payment	2133	2133	1874	1	1	7134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTXbm38DVLUaedFo3YFZYgmh6b5JM4vYsHu2J7QP1aE216qSp
47258	delegation	2381	2381	2381	1	1	0	\N	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSL5J48SK3AWq8X5HS62G3FagLMLqq9GMQgHeDVjHJj31ZeCyV
47259	payment	1397	1397	1678	1	1	17559	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8cZ3JbBAmgExMapLjf3Ja6Eg6NHPDQUbsM1WWSN822n4UZqA9
47260	payment	1397	1397	1678	1	1	17560	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ygiNWULLMBHjz9gzq4xM6ZWy27mgkzGmpaWUEdo2oQF34t2m
47261	payment	1963	1963	296	1	1	1	2000000000	4000000	\N	E4Yu1eXC1XmF5hDf5d66pyq6YKeTzCkSL3Zam8ZXwnkio2CwLP8rS	CkpYkABco5Fm6EJu4qcAFgNSkXPJ3QkhPYGaPuBAqeKqvNUPmU5ag
47262	payment	2132	2132	1874	1	1	1849	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAZwyichTggPn3SoU6gGXzdBHsCWi86ZJNwJLZqg4a57hhPzFX
47263	payment	2133	2133	1874	1	1	7102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSg9FzmrVZzLUTwPsFoicYNVo7UhDRc8J6AowteKtch8Fogsr
47264	payment	2133	2133	1874	1	1	7103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx22nhXrhXfxNLU99aQNntjJSEevAeJBM7rjRTC4Lfnb2a5Uef
47265	payment	2134	2134	1874	1	1	7718	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygXx9zX9Xp8rqJecw5JgMyUZKdUfh9S7g2oPQPEfACHiZHE6Y
47266	payment	1397	1397	1678	1	1	17561	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcEPHjRsQD9eiiCtKtjMFD3FPG5sxcAzb2acQoJXhUYCtb9PxJ
47296	payment	1397	1397	1678	1	1	17571	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWWxHMyWf7YwJUc5JZuU7zCsaXWazxDx6aubBYiikPQ56rg6f2
47297	payment	1397	1397	1678	1	1	17572	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUF2UVYsbpFjBVPfetGurt9ruLTDPvnXtxvfwWzYRH7BphxqnX
47298	payment	2133	2133	1874	1	1	7114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZfbTexz7HFTmCSRECVxyJhg4rRJ2ER83o9gBHehmi1ZzC2Jff
47299	payment	2134	2134	1874	1	1	7726	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxeZHDkfQMX1B1CVQsMKWqzZ9iKwHJ2q9webQhLQNBFVxwxQow
47300	payment	2133	2133	1874	1	1	7115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT9cqgzHjgDftXRk79p8WVSSkpbuuga8AkUL7QbygQJwNd1jQ
47301	payment	2134	2134	1874	1	1	7727	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2jzXDpFEX39R6P6Y1MttuXrpoe85M9RCMrRJrPdYSdidzBhr
47302	payment	2132	2132	1874	1	1	1853	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7WtZMW2esmMHmZkXfwk6g4HbJTJXQY8bN4BMWGNT5s5cWTWJP
47306	payment	1397	1397	1678	1	1	17574	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJrhDcPSo2VXk9uDB4Q4zYG5UyiFR4qyLfjoFN48279skxzYTb
47307	payment	1397	1397	1678	1	1	17575	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLb5s1Nkcg4SYu7uYLhEXmMcDhLEAx1s1BffRvesLK3CxrdNfz
47308	payment	2134	2134	1874	1	1	7729	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWmTGyVmTXcyGbk2LJeZuCtm5qsqPkWTTUzMdxtU3jetDYyWP
47309	payment	2133	2133	1874	1	1	7117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxqy2dmZZHyaGLEfDCyvQ8VR383YXKBiqxgdsNAaSm541P4ZMi
47310	payment	2133	2133	1874	1	1	7118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxskV8FcxstbYpdRFqWMLsU8xdigMNLRBxLHLzJ4RAgBDfEE6L
47311	payment	1397	1397	1678	1	1	17576	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhyEH2mV7mZiYb1nc4YFhVNv5seB83U8Jx8SDYkrw8677ckYp
47312	payment	2132	2132	1874	1	1	1854	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2LH4Rd6WT6WRfGRgKvsENYc9x6EuzUxsSbrXr5eup64h8VCa1
47313	payment	2133	2133	1874	1	1	7119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2dp54ugE64rH67kC5dytMWx5Ez2Li6J8SACMSZcBTrHFdjpU7
47314	payment	2134	2134	1874	1	1	7730	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1H7q9cTzon9hQcfU9yCs36grNuiLUwuDNkkmmkKztz7fV2Ns
47334	payment	1397	1397	1678	1	1	17583	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYig4WEzmV8XEhFPDruuFvHK2uqnRrK72Wruko4XXCMhaFHkoSZ
47335	payment	2133	2133	1874	1	1	7126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhybUirrTA7uw6ZFetFF15cWNwzumWMz7apcEH4W2yacnvCeAm
47336	payment	2134	2134	1874	1	1	7735	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZusPM4DEncmoS2kWEFBKQhda27uy62dV8Yx7F7sn1d2BHWKtmi
47351	delegation	693	693	1726	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdgo8YbmBVPRokhZVQE2gaDMA21c5QA2x25JRyUUseLmTx6YsM
47352	payment	1397	1397	1678	1	1	17589	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxJVpuTcHwTji7CsUAPvFRmZAKwpnxUW2KaXae9Dv4Gd58qfMB
47353	payment	1397	1397	1678	1	1	17590	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2wfi5ja5G2cq7o487rZYKQCZA2SHdthrcWVqBBfgFhCmuqZW4
47354	payment	2134	2134	1874	1	1	7739	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDjQb2prWvhXJwvprVwcraWcTDiEWofNGswybDhvY1krDzLSo
47355	payment	2134	2134	1874	1	1	7740	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiqhL22U3kWNqWEwMS9pHof4HhGCLF2YQmyhjenzcsTBvmn8jX
47356	payment	2133	2133	1874	1	1	7132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZD9VrMtoxkJCtekVeBW9RNFRXunU8kjXn2SoaWDEd3Qv8uSZw
47357	payment	2132	2132	1874	1	1	1858	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFDTWSW2giGTdi7xvMkQFbm21bjDtan1vtcY8qoZC46s5aeSFF
47364	payment	1397	1397	1678	1	1	17593	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGEZfHjTRkbGNMLYonkHeuCKWt8uTKWjAbstNfL8ChWbCqKiex
47365	payment	2134	2134	1874	1	1	7742	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtWKoMa47PxyFyMMXqXQmGjGrCv5vyXNjsHRvcFTEzDZTNMUi3
47366	payment	2133	2133	1874	1	1	7135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDBuAgNc623xEyYtN9oaNht9dMY88fcNXeoZS5gm1LCvEhdGUF
47328	payment	1397	1397	1678	1	1	17581	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6pm6ZczETiCtjELBmNLir9paaxfHwQSRvSR5WieH9oHyPUT5k
47329	payment	1397	1397	1678	1	1	17582	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4b5FnbJJ7jz3q43gchqqj3BwiYmdgzic95HL3kUxyva3r8gBR
47330	payment	2133	2133	1874	1	1	7124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiw9Yj5o71LDKEBcWcumq9jqjzTLhcH9zEqFbdCHqEGr4gL8rz
47331	payment	2132	2132	1874	1	1	1856	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ78p4EA6ruFJAhTtinNeGKSSamCtt6BDC55k3fb1KfGjGa1X33
47332	payment	2133	2133	1874	1	1	7125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLqeaoHYELofNnLc2vfiCrnRATP8TiS1ir8KU6ubmC5Zam9sb2
47333	payment	2134	2134	1874	1	1	7734	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3C3p6shEQCC8rcMLBiBgFK7bECGA84sKQruFcQgcCE4YsVodY
47337	payment	1397	1397	1678	1	1	17584	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTn6jnKULvXR9DbKRvcxY4HBvRDVHnZ4wDxobCCepyoyi3MaM5
47338	payment	2133	2133	1874	1	1	7127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNXRLM4qKX2R5ztLTB9V7fVLMFNaHXYMCKqEfD9sfEbUFH5KB
47339	payment	2134	2134	1874	1	1	7736	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3wZ1TZXDTs4YE1zUSnzdbN4kucUeDNgm5hGkdyJ4JFJiz1RE
47383	payment	1397	1397	1678	1	1	17599	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZshzoUwpkekFuNoHYGzZrGqSUci5U1EqBHrTFj8XfY4tAzwD6V
47384	payment	1397	1397	1678	1	1	17600	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTB5WA83NiBme7JRmRKj8t8gKJGS3jLxJa9kiCHbZ7Nr5Tqvmd
47385	payment	2133	2133	1874	1	1	7141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8NSNChMau6BmvsQZXdRzjX8smKFBVMgYg4o48k3gXBaNACsM4
47386	payment	2133	2133	1874	1	1	7142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHRtNnUcTffMmgvNpQrYnKW6eke9M2kGVvSqPi5NvnFnDW7Bd
47387	payment	2134	2134	1874	1	1	7747	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1FaUBAX4QgNcGNgii6Fr8b88euAsW53UEa3Pd8jmPygGfygNT
47388	payment	2132	2132	1874	1	1	1861	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1j64stL48b4qxfS7CxjWiNRTet4TGqgzpWaAUsuA8TibbnWga
47413	payment	1397	1397	1678	1	1	17609	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbps3aQ9NDhbFWYUy3nR5ujoGeTSjRTG7iNSwGmup7UEEfPhpa
47414	payment	1397	1397	1678	1	1	17610	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyTGhZ3xLGyK6f5ENhsXqxRxK3YvQBBxsHNuU3SfW8KHdzswe6
47415	payment	1397	1397	1678	1	1	17611	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8Z5pRGLXdvxtrpH5KFSLdxWZgQiLKPQYet4xPtyB5AaTU4YN
47416	payment	2132	2132	1874	1	1	1864	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6Zg5Qs9M6mjhJW1YrguZvfTdwCxJbfqWr3Ho2vEUD6g8BszF
47417	payment	2134	2134	1874	1	1	7754	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwvsJZVKSaxvDh7huJBQE9usKvBkK31Z14JLRUpAhNunhJpoyr
47418	payment	2133	2133	1874	1	1	7151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywdeUXt82o5g6SPeyEqc3Bi6mvY2p777DAX8b24q9nD1HUnQY
47419	payment	2133	2133	1874	1	1	7152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR8knotrwSjVtWJC3jN1aSiDag5CUj7kvHWn7ARVev2sQjj3hG
47420	payment	2133	2133	1874	1	1	7153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWw5p8UY1xDoU5T459oAXprqvFpCM5HK9L99UnXQJEdrtpYjF
47421	payment	2134	2134	1874	1	1	7755	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2e1JNJHPAYhfQCzjeeeVyNSBfHAcZL66xaJPbTczVEYVgoPid
47422	payment	1397	1397	1678	1	1	17612	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45HdFh46hRTqYmTaULaw7NTzv4NDeeGg5s35BHwKe5K3waXnN
47423	payment	2134	2134	1874	1	1	7756	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdYr5kGnb9sXNmBmoo7VVchw38ZZpREfFSjzBZ9cCdij3mnw1
47424	payment	2132	2132	1874	1	1	1865	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx6JfjyUi22Bv4EoVixbHdtK6VAAJ9uNZ51pSyyNQAGKWXNyro
47425	payment	2133	2133	1874	1	1	7154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5TUtPsGoBAGs3a3odPEwP471w6tAcbWkRNWN6mUAfcdazBPp
47440	payment	1397	1397	1678	1	1	17618	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ZZLbHQzf37ZZEZcGWMusEXTBoRqQ9TsvdV5QKnmhumNSkYK4
47441	payment	2133	2133	1874	1	1	7160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnLKo8DbCqJFn24iudYqwoEhMQNzQ4eMuqLewNgUt7UdcuhrjB
47442	payment	2134	2134	1874	1	1	7760	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5w49GLPq7wDYovx42WoQ2SmcC2KpUP1r6DGrs9cWHsDjq7gFS
47452	payment	1397	1397	1678	1	1	17622	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQ4LygYhLtywMz8uMHJPmqqHsirziYx1ojmZgRBydmcWLcQLf
47453	payment	2133	2133	1874	1	1	7164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrGewk3okQHFPzJaKJdxPiJ6NGmjvt8M2c19vTFuo6k5f2qZap
47454	payment	2132	2132	1874	1	1	1868	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gsE1EedvEHPUzwkvreANUcjbMG8MLFfQMsqZAccrd9Bo2won
47455	payment	2134	2134	1874	1	1	7763	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaArR4BRP8dCjbN54z2JvqePmEPMdvbGo63j9AGxnVDyNxHcNmc
47487	payment	1397	1397	1678	1	1	17633	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLkBPxs9kfc5tsrsSrcLjLQDFNqQd7SWjrHn284urwwdfJjdU
47488	payment	2133	2133	1874	1	1	7175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa22cDxJCeDzyPViMXuu1V6ZPLwThZSiwGYKh9w8dWYxiABM21
47489	payment	2134	2134	1874	1	1	7771	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2i5pB3tQGJsaiCGr6ZQyZU59UnLHt4F3TVj2T1HsF8t4QVu1Q
47346	payment	1397	1397	1678	1	1	17587	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg6ehoSdntiMiLujDABrkmxMchJ6raSWpA1hJGRRkBeNgfogFm
47347	payment	1397	1397	1678	1	1	17588	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYiCWq6LLKBFyHY3n7XiDGC5DYU9rXzENEfJuDXSSUYaFCK1o
47348	payment	2133	2133	1874	1	1	7130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdXKozkGcf8taht21zSdC7cAC24k551RWo6wAqibQ2mmWnCta1
47349	payment	2134	2134	1874	1	1	7738	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3Ba1WirZzPf6rpu1vVgEACpsReMbS9b5bZSMt9TknMaLxgpV
47350	payment	2133	2133	1874	1	1	7131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4fk6L8gc4Hop8eGHxg3p5ESGNWHvthJwWf5DcSGZ9DVRBWVD
47373	payment	1397	1397	1678	1	1	17596	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhG9rC4GFtX5m3U9hja7kCvLLxeFEdEipjJfdxfmahTVG7izBa
47374	payment	2134	2134	1874	1	1	7744	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqTgrvp1JXm3hAjMjZ5x1kXQzCKDSuywEDzT1LC6zJ8fqPt5y
47375	payment	2132	2132	1874	1	1	1860	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCCkqnNS5ZHUYo377LyjoHxMbT3ycmbZswLb1aToV8bMXVDpP
47376	payment	2133	2133	1874	1	1	7138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QZKCM3yHUnaKNdmsV3qk5hwPxbfNDWy4w4u4R2JxzZFx3ApW
47389	payment	1397	1397	1678	1	1	17601	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvo3fA6FaqpccpD16TPkCdcFPo69FNXNtpYjErnzm72nkQ6HQD
47390	payment	2133	2133	1874	1	1	7143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZS2gnB2xdGWKgMap6n5347hyq7qVXPEfDGWJ2PXANiMdtJJud
47391	payment	2134	2134	1874	1	1	7748	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7cZ7NDcBcTyaZP2Rbf3pM6APL8ETd9xJknTSXNyAtARx1e1kK
47401	payment	1397	1397	1678	1	1	17605	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyU8Vf8KbBcDPMMN91jm5qkGwkNjaCmM5t7XLUBnjyQe1JP6JW
47402	payment	2133	2133	1874	1	1	7147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1S1BNf4wAj6AWw5YjBJpqSjAoasT1eigbAqnVykJSWGgtjKYx
47403	payment	2134	2134	1874	1	1	7751	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ1qHgpFZrHgobYkmH5VvPNALM3Yk8U1E7YFRogqExQDHLQSsC
47428	payment	1397	1397	1678	1	1	17614	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXnoN8maYHB7imsecnpuh91gNe1JF2MCPjDWFeaF1EfzSXVhni
47429	payment	2134	2134	1874	1	1	7757	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUK5oxL2SmHhonj8CzYA4vrvCQfawmbG3hdU5s4JWiGg6uubLL
47430	payment	2133	2133	1874	1	1	7156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb1ymZkgZcpM4yYVQV1r62zt6i6DFLWYM8E1ZeqgMP4MqQGyQm
47443	payment	1397	1397	1678	1	1	17619	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2rasfbF4VTKbQzpRb2sPApAyD1Dm8xFvYLFjZifSkvCmKiD8
47444	payment	2132	2132	1874	1	1	1867	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5ieWFyQdNz9vK4BJ272pkYGhUqy9uWNda2xAHMNAZGhFUBto
47445	payment	2133	2133	1874	1	1	7161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8LzJuSrkBBsimZTiGXPjA5ELi9G8oesZcvYSFLnzdgHMQuFRv
47446	payment	2134	2134	1874	1	1	7761	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEoVazCsdEXWWTQULZFyAXEaYAuVYkdZhFroW1LaH8i71Sgh5L
47447	payment	1397	1397	1678	1	1	17620	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujAxiwqJUSc1eJ6Mrw6HPdfzb7nW7iM3QMvcXAqTm1PcmDUTY
47448	payment	2133	2133	1874	1	1	7162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRbjqF2qeX5bntThwJS3z8UHCTNkX4ykuPCWbeMQcwkTKtSp4Z
47469	payment	1397	1397	1678	1	1	17627	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiJQXHNmTt6FugEwxZmuoY5xfF6CVmgvoJ6NdhGpi2DU55MGXU
47470	payment	2133	2133	1874	1	1	7169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh2xwBT8e4JVAEjuRYETig5J2VpNTH5RuPMjPLeyJ1ZRproeSF
47483	payment	1397	1397	1678	1	1	17632	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXQ8FgQ5EfeQ4KWqVteLWkPFWKvmmC5hRUziCcrULDHMTmPNcX
47484	payment	2133	2133	1874	1	1	7174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdSxT8DJVZr2tzFWBYPBE8bt8hNSxoFPxy8SVv7hhHch5MsjSx
47485	payment	2132	2132	1874	1	1	1871	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodctr8darjdnpFoKyCGToSDZVbwb5YSdffeiGiLzuVBhRcg5K
47486	payment	2134	2134	1874	1	1	7770	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDf1NGUXf4t6hoQntuMbLB3uqLNdhYFv5xHme8y5xnLA57b9xg
47495	payment	1397	1397	1678	1	1	17636	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzZicLPtGx34XeeH9RwuRpVfh3LEdKp3FRds2Smpz7cWvyjKXw
47496	payment	2134	2134	1874	1	1	7773	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjZmXUYbrRwK1CTHJ3hgR9BdqKkAfyc6QPtkM6T3dh6AXotjm
47497	payment	2133	2133	1874	1	1	7178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrahYqA5PcEpzx41KVmY53EKo4rz24Hvqs245mBnG3X7nghkv
47498	payment	2132	2132	1874	1	1	1872	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ89qxDd39s8gUxw7RbLyLTFv4uLmgoVPUAS1bh5Hh1nsdbY9cP
47508	payment	1397	1397	1678	1	1	17640	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVffudbNN3rviXHKhcuMW94d9NPgNx1HBSPaPDfEjgZEgnLyFU
47509	payment	1397	1397	1678	1	1	17641	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnosGpgB5ipztnkMmT3atUS7oFvcRPDSHnnz75GcA6ispWPjaj
47510	payment	1397	1397	1678	1	1	17642	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKjBLDKpSYj2Q4SSujJqLyxTpjT5ZNSeXQWn2AXbF2g869kEHP
47511	payment	2134	2134	1874	1	1	7776	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRgFx4e1w2ahxg8fYXMK8iSpD2hgpjDdtxpjNBnD2DYsqZ4pUs
47367	delegation	2414	2414	2414	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYW324vit2rchQot7UwLHfxZd8LBPwkCNM2rEU9VUgeTdfd29C
47368	payment	1397	1397	1678	1	1	17594	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEhtaHaSNMUYwGuW4M8TXKUFqJG7HT3nXioMGydXziXr4yv1S
47369	payment	2133	2133	1874	1	1	7136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqomNUEKaMEvApNasrAjqq4Bd6meLf3EadsCkNQrwdNvZzNFwC
47370	payment	2134	2134	1874	1	1	7743	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKkofKppzqGNo6GftUysLp61UMSwZ54QHeBiGQ4EFECSTLP4Zr
47371	payment	1397	1397	1678	1	1	17595	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ftQxaNajRUQBMH8k9heQZnKp4rMoK72Li2hyyguiHpuenS55
47372	payment	2133	2133	1874	1	1	7137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdJSHzatf1mgGXz2qBxgZs9s1QTj23BpQQwvY3Fnay1n9jQan
47380	payment	1397	1397	1678	1	1	17598	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgqzfuydA1HHqVkrYyD5pRbAAugbNqSvj63ngyXWjkNfvBAPs
47381	payment	2134	2134	1874	1	1	7746	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSGadK1dMzK5TXd9f2F8FFSC9rJiT94EgQi3Ym5b7KZQMc8uP
47382	payment	2133	2133	1874	1	1	7140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrVWygLKNbf1nuoudY9zxFQTKfnvCf2HmYK4voeWxGYpSSNJtH
47398	payment	1397	1397	1678	1	1	17604	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnaz1wHXwxfDVR4CU3nc5ma2EKmwAfdCaZ15dinQPvRSxY3hT
47399	payment	2133	2133	1874	1	1	7146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuhAWQ9T1tn3cG2Y6S38PtoK8uSeDQvAQgkV99cA5cfpaMsPzM
47400	payment	2134	2134	1874	1	1	7750	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1uDPinXN4Gqevfy6RD7719CekdM34LQSbuGaVpudVjrtqUEQF
47426	payment	1397	1397	1678	1	1	17613	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXGPmvUenocVXAD8qLTtnqA3iJqqSyW7sqGrQbV6aXhy1uUyFS
47427	payment	2133	2133	1874	1	1	7155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZUFrkeg1RKXrYqq3kK8u7x4d7k7v5xH7js2D1wtAZzScnKheh
47432	payment	2134	2134	1874	1	1	7758	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsWVX2rcqXNr2uo6dx2QEcaWHzDHD32DVhx5UfnMbbYLo3CSbg
47433	payment	2133	2133	1874	1	1	7157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoERgRUSEAyNyBP8wD962TqhSbyQQgcuoH5TCHdkXmXX8G8ia
47434	payment	1397	1397	1678	1	1	17616	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFen669HH8twKHvbU9QGpjbtiTzAAJZZgf1K6yEV7KE55DL2en
47435	payment	2132	2132	1874	1	1	1866	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDEhh1rWnWQ1rK8iLQwwh1pGXjqze4svh6qdRFuupKdscMiFR
47436	payment	2133	2133	1874	1	1	7158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxGDMqv7EQkFu2k7QYFi16KaYHwvmUKe2bR3bAP7JqENSPLom
47437	payment	2134	2134	1874	1	1	7759	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkfCDSkQ1GxqYZV4ba7ioyP7dXmoyMUczT2prPFhuY4NiAfrU
47438	payment	1397	1397	1678	1	1	17617	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8ZPMQo4dpAdVHEXvPwrXAvLYiJvx4iKsXLEoZkB3fTTFytcv
47439	payment	2133	2133	1874	1	1	7159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZip1XehQqChskzj85RfKGfVvMy124AEmAYSMFLMZR7hPqC9DpS
47449	payment	1397	1397	1678	1	1	17621	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDFWcNHyFGqaxfg5jugG4dhdyyybdpByyyD795gT1NU6xjRaDv
47450	payment	2133	2133	1874	1	1	7163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcWUbJTx9MUm2uDZmwsSP2fmiZ2TfZ688hcu3zV8WNiVHy8Mod
47451	payment	2134	2134	1874	1	1	7762	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh57LdTLtorrjVUrsMtm9nT7yCUFWJ7zMeD5R9wtG9sv7aFVn4
47456	payment	1397	1397	1678	1	1	17623	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAFU7ARy9gyxUZ2TpegMD3amB4pfwnE4doyrXJhTiRmR54X9V
47457	delegation	835	835	121	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrz5jvymY9R3d4a23CMAT7LMUVE3tUqTxSY6nGk4MTZ5ysAxTK
47458	payment	1397	1397	1678	1	1	17624	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoi4s4rU8NmSFJymsQ2tTY4GAD3oAPZC6VphToLdzCRzmFX7kt
47459	payment	2133	2133	1874	1	1	7165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhm2r9ncXjAfHUUNtvC2KEPdHoijPJRgtM4d97o4PRWLAnBdF7
47460	payment	2133	2133	1874	1	1	7166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVf9jS8px9x1wVQH3a6cD2x6JB4Mjwo6givK5sQTytzMKd9aEy
47461	payment	2134	2134	1874	1	1	7764	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJb8rXRg9JS5KD2Q9uGJ7Xu3aiKUdB1SEXxTpRYBovfsuHbcK
47462	payment	1397	1397	1678	1	1	17625	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqaowek1J9vrqa1pLXFvR5bwnLJoyyhSanZEG7NqdemMfNVxA8
47463	payment	2134	2134	1874	1	1	7765	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHEGr333vt4JKNhCZ4ybCKJpbsNANRXUzxpyuAAczZBdvrCVe
47464	payment	2133	2133	1874	1	1	7167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKmvqa64726H7v82EXRR1NC423nU8jSa6jRbThvivjETk7qHvS
47465	payment	1397	1397	1678	1	1	17626	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1LqDFkWV1KBezLcSPpBWPNNpVtHTVscq9djUJaKQsrAcfH2G5
47466	payment	2134	2134	1874	1	1	7766	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnTns6e5dAbzMgTm8nTaemqqYhpuD94GhjksayNbQL9LringTf
47467	payment	2132	2132	1874	1	1	1869	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP8gMjyW8fMzyqQQiuei6dBGepvJ3sT2BfzxJk7vKuB45u5CCS
47468	payment	2133	2133	1874	1	1	7168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tmogmDtew8jaAuc2m5Kv2BiCNwe9KqUg9HZuRJgXj8iNaH5o
47377	payment	1397	1397	1678	1	1	17597	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa9LjVzwpiQbJGncDZM2oSSTjip6n5NQaBzWpLdhnBFwkjgAq
47378	payment	2133	2133	1874	1	1	7139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH3gc3jVLvwTTN35Xh31Qv41HA9NhqyLifDEECWnVx5XvYVZmd
47379	payment	2134	2134	1874	1	1	7745	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa38MQ1AeHfRs14vaNpxB3FC8vZiwFkf954rei9g4si3BiCSfJw
47392	payment	1397	1397	1678	1	1	17602	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijf95SfZYXRaixyroGsjFZNZa2NsaJADEcYMQ1USUUyvJz4Ub
47393	payment	1397	1397	1678	1	1	17603	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpnLbxXFvAFEUZZMBR7YdjnEkiF6LJuSvwAVcQRbp8DySAgmS7
47394	payment	2134	2134	1874	1	1	7749	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1p49hbNsmUKPfitGn8S7AKMWJeYxwLSFF1VH1GmEEvSJrjKsg
47395	payment	2132	2132	1874	1	1	1862	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPELTgYobTamGjFTAwxoCoCxkAnCtvvAtnWw4iQMVfJT2MMfcA
47396	payment	2133	2133	1874	1	1	7144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxccCrLN9s2MaS5iBKZoHjSSV2YArVMQyxZ5wrh5wRvTZr4Xfh
47397	payment	2133	2133	1874	1	1	7145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8xjAbEp7ZYVQS7bysKJL9pxrcuaD9kqMgYt8CnBBGkFY8VMg
47404	payment	1397	1397	1678	1	1	17606	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRM9ERGEnHypvF41gvqfrGVzrT7YuWMoCkYs8eGtUM88pZv9WB
47405	payment	1397	1397	1678	1	1	17607	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSC7cxNLLtV4bKKNMcQoJQNMKz7ur2Pb27NF2Qgec3AgNpZiG3
47406	payment	2133	2133	1874	1	1	7148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjNTTjdihYFY9dvH3QAtpiekrQborU22EVkrHHCtAfb9CwroE
47407	payment	2133	2133	1874	1	1	7149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4URKqVYxzLAhsTYogMqMVAWvURaRTmH6f9zGzFUSLd9RYqiM
47408	payment	2134	2134	1874	1	1	7752	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfrDLhxGF7RW39s6g9zhzdrkTvdEuYWV9zWcEFiVpYkFbcbiw
47409	payment	2132	2132	1874	1	1	1863	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkxfxWPZTMFSrn8Hfw7PiJsPQGugJoWcKMTqCiqgdLtwTsugV
47410	payment	1397	1397	1678	1	1	17608	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnGbfVfXGBVH86bYSxcPaTZPecN269QkkCJfnLaWmjSxEKn8mf
47411	payment	2134	2134	1874	1	1	7753	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcVK39bma3bLhVL7m6WdyCus23rwQWGkvP17s7D5VTcYaGhnni
47412	payment	2133	2133	1874	1	1	7150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ74mPq4AuTriZ8An6JgpT13Lbe3y5TmpvyjWyQsTa5QXrq5GAT
47431	payment	1397	1397	1678	1	1	17615	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUukdFdj3eU1jBcg7NyuuUZRwj1baBiU5UUd49ni1vjoQRXRt
47490	payment	1397	1397	1678	1	1	17634	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYToykTUX386En1oXFjanhoutDUTTKsFYYwdKuPZwHvrCUEqC
47491	payment	1397	1397	1678	1	1	17635	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhUs4RRtJEqChikDdjzEE5ohTeBwT4EYd65mFEUN2WFZiGjuXL
47492	payment	2134	2134	1874	1	1	7772	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtyMuZ5fzwZqRTyT4bmc8sFFoJ1BG8jUusvRzHgxac6QhB6agM
47493	payment	2133	2133	1874	1	1	7176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDw4spFLFpAScRvYgnVyz3GtLHG63ogmtjkkdxxU2YzJUXnLvE
47494	payment	2133	2133	1874	1	1	7177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWyJqreJPMvRTUs7EicD2SjqfrvEDEk5HZo2sXvnJCxvTrToS
47554	payment	1397	1397	1678	1	1	17656	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Jr5a8XemzMCebYZKmbEHdrp6vBK6aaNWYLGCU8TDHG1CjUyh
47555	payment	1397	1397	1678	1	1	17657	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbphTbm12dEhntbuoHvovWqBt9Qe1xy9jnyG8ku3DB6maeo3x4
47556	payment	2134	2134	1874	1	1	7786	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFhQjryjMNmjZh8HrkXwdtXksypRmERyK7xoWMNEChW2HMf7S
47557	payment	2134	2134	1874	1	1	7787	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvUNxXoWUwgvMiqC8oHnPEtktXZjceWxdmrDMWE5kxJ4Yr6dx
47558	payment	2134	2134	1874	1	1	7788	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRm4ByiVqs5CJYEyZvZX8ciUT39w9LD6zvzPzuUoHFBWrheJ7F
47559	payment	2132	2132	1874	1	1	1878	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpuKfkeWAj1sXuCXKrbvvKcqcbGRaWzbbjzKvRxBr9D6DLEBUb
47560	payment	2133	2133	1874	1	1	7198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWMPhvDhVLrbs75yhKgRypRzwNwhd79phjxMzdHPsEMBkg8Qn
47561	payment	2133	2133	1874	1	1	7199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUMFJr3HAEMqFC8z8gVj6SyJgV3V87KtE3WYAWUQY4RW4EFtpx
47572	payment	1397	1397	1678	1	1	17661	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAUbAgUpC4W7WTtLGk8PXzxs8vWVr1KcxJdqPnQcsEnJjhx2WX
47573	payment	2133	2133	1874	1	1	7203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5wPQGgxz8F748j2Nd7iYaz8BumDGG7Nw1CEC6bYAnngDbqch
47589	payment	1397	1397	1678	1	1	17667	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLw7MHcgDpvkrpG4Ji2bDqYzjFkEUmid3bHZwCoc2vCgkQA3Zx
47590	payment	2133	2133	1874	1	1	7208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxYSjNxiCoZey47RUSXjeudT5Z9DBwE9g8EfQAAjFPQjgZ2zA
47591	payment	2134	2134	1874	1	1	7796	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAmstxiQyXz3XtxPi1K6W6K294h49HR9pqmPRFo7sngz6KKcnZ
47610	payment	1397	1397	1678	1	1	17674	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6wKnPk9pYJUXTwDsv3B8GW7PaeGPGuoZQ1r5FzZndrQqd4ps
47471	payment	1397	1397	1678	1	1	17628	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb7dQfHYgm3n7tjTunNiijpWuQ1gcVGTx57grrp59sk78cAL3x
47472	payment	1397	1397	1678	1	1	17629	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAaSkD1YiikHqDeJ34mqhkFKSMqDjwA9iPYVrZgp7auAijo4T
47473	payment	1397	1397	1678	1	1	17630	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH5rZghFPNR3YC9ZL3iSNZUDg63RwnppthTm8ucPiKte7Ybh75
47474	payment	2133	2133	1874	1	1	7170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZHTkCv9pCCH1d2H8HxgGeGo3WPep7fkFALuapHuckAwhPSwV
47475	payment	2133	2133	1874	1	1	7171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDn9E1TxeJxb9HkB28xyhXit1jdHeaBmoBQq5aN2dSUsP4i75D
47476	payment	2133	2133	1874	1	1	7172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBdGY6C5CLbWqALHDxMvNYYDJB4N552X7FNB9cgkhx4cJ9vYkh
47477	payment	2134	2134	1874	1	1	7767	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYAzbJ34b4gsmmz3DHvj7zfBJyVHSi4Dqv9XXkGk1J65jUwj6A
47478	payment	2134	2134	1874	1	1	7768	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo1N6P7B9z2KjPgQt4P5Rr51sXDbW61BdXdxHSakPdZa9fQxg9
47479	payment	2134	2134	1874	1	1	7769	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr8oWj3pSAuC8iHNWRV9gzoU2Zxw5SnxP5WCJtyvth4p62SwMk
47480	payment	2132	2132	1874	1	1	1870	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJYGcUxajFY3CwPpPLfAqgrMku9Mwprc2GQcZV9yUcgswR2KcV
47481	payment	1397	1397	1678	1	1	17631	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZN4BKcwSzopAMgvRmhT8yznnT9b87BGAfSshP3mVtceBdAr5G
47482	payment	2133	2133	1874	1	1	7173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWH4MjvRjzSBm1VKT9KKsW1uFGeu5RahhkgZtWTzBTMX4f1q7B
47502	payment	1397	1397	1678	1	1	17638	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAUy5P3sWVvtLcmZXYeWBmEdiSqUyHRShgPFYb8G6mEZPJ4VP4
47503	payment	1397	1397	1678	1	1	17639	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB5B9PS5uY85kb8Nu3AgqYqQdXNyeA9S1tUJT52kvWEceEB4aF
47504	payment	2132	2132	1874	1	1	1873	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP6WhLkgWRfu2FQWktxCs2s8EYUFFUUBTBHA1tdwLo2jdUuptp
47505	payment	2133	2133	1874	1	1	7180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiYe6Xn8DWjGmjRfT5Qc4YExWiUMSu8DnvKC48Czpzo1T9Xdxm
47506	payment	2133	2133	1874	1	1	7181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWjc78KYwaaqpbftJUTJDiZNAg59rngBxeZ1tCHLiL2eoznXdP
47507	payment	2134	2134	1874	1	1	7775	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa596uuxxs9rhvVTg1Gzs17TJhxYCKEKYNnWHJUs3qyiiVEZkjG
47529	payment	1397	1397	1678	1	1	17647	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGYcysWkjvvDwzgq3zuqFcYkSahnMb87TtfEAbrusoeN5c5yU
47530	payment	2133	2133	1874	1	1	7189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWjNWLMcVkwfKMqepDFM8gpeMpQCjUntE6WkjSSVYB9zhkQc5
47531	payment	2134	2134	1874	1	1	7781	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJr4kptDSR6N3TD2HaVr6vpjJQ7G7sXt9kpNY1txKgpas2CDN2
47550	payment	1397	1397	1678	1	1	17654	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgD5nWR5C62JzBECp3KHfRjcpqHKTkc44psf9WzBPsy5vJLBm1
47551	payment	1397	1397	1678	1	1	17655	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZfWqipFZDfoyuzXgkLV7jY3hi651h9RLkP8UMsxP4L1qGKZX
47552	payment	2133	2133	1874	1	1	7196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHrX8Q5M3ZSdE7YsHE7M3AdkZaeuiBaTYGPPrKqsiPwYpdvvAt
47553	payment	2133	2133	1874	1	1	7197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxpV9bXJ52JtLRY8ePn5PBmfMEGzeRQreV6Ai9yJQR9ztnoGLP
47583	payment	1397	1397	1678	1	1	17665	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGftKHEDTuLrGC2asf5VdkFNoFskgFjzos6BJKwqfjxB9FiMNR
47584	payment	1397	1397	1678	1	1	17666	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtFk5EY2JAxraRYCkQbb2b3PrjREqNrMjr8Y4kgxAeZK6NAaau
47585	payment	2133	2133	1874	1	1	7207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAgbeNbr2cVAnfeKduVZBbJAPoeJnENYvdB6MgEdtW9ET97Z2
47586	payment	2132	2132	1874	1	1	1881	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfW2uuEn4jZw7Tp5mxhkRZR7uPtKuPEHPg6reWwgDGnPyg9xP3
47587	payment	2134	2134	1874	1	1	7794	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2BPD1pT2fLfMr2oZJ3GTKV7JHdw1nGhaeUEDaMxEfsnGt47dV
47588	payment	2134	2134	1874	1	1	7795	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5hmycoGPVmkGHqXc1PajazmMa2bu8fiRZQi7r3g4wdJuCJNT
47592	payment	1397	1397	1678	1	1	17668	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDPGdLqsgYMZqop5Nf3wNq523XrsxknbNEEqAwEcT6zBvRALmc
47593	payment	1397	1397	1678	1	1	17669	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpSbnLav5rnHRoWJ6MPURL59xUzsktCzCUrjkYAvpLdhTDBpKk
47594	payment	1397	1397	1678	1	1	17670	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcjUDfZBbAcW6HdTk7hvNihdPCDTCegJSbp5Dphm4dhgpmCJyw
47595	payment	2133	2133	1874	1	1	7209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwfzfzdxXCcG8oxPrxiNBjFYS9skUD24QTqBWcidJ5nK877rk
47596	payment	2133	2133	1874	1	1	7210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfQTCXrEN6gW2f7ZHaUL2ifKvYMDHZx73LvmyaFG2MZamKRjb
47597	payment	2132	2132	1874	1	1	1882	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzc96fVV54HcX3RsLcBT2KYPig8VGH9VshcsYvABc3sWR5rXB6
47598	payment	2134	2134	1874	1	1	7797	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcpYfQXyDb3hKv6LrBNv7TBt5exusXQaBprAtsRLVq3qBjYdML
47499	payment	1397	1397	1678	1	1	17637	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRPfD1rqmQDZpJXdhpbpvZHL87XugP2oZMBkDLu5RiFfLXMvK
47500	payment	2133	2133	1874	1	1	7179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEY1SjG4APW3jL31y3Qe9Gr83dtiRMn4JJz7rH76AFheN34mH6
47501	payment	2134	2134	1874	1	1	7774	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTtATc8eFfC2cawr5KcG1fZPJskeHAx2kbctqjygCdtAWjHhc
47525	payment	1397	1397	1678	1	1	17646	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeY3fQ3URG83evLhTLJvJ7mK5NEvnZRv2uNCw836CBYKS6NfXn
47526	payment	2132	2132	1874	1	1	1875	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVLuNJXcKNPZEJ1Tzs6n9ccdApMz8416cNNaroU2dY5Rn7cJ7T
47527	payment	2134	2134	1874	1	1	7780	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtNoVmVVqwHzjn9CMrwUkKyJPj8WityWUgdXbuSLL98BStvLjF
47528	payment	2133	2133	1874	1	1	7188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQcHPhz9hVMfUibtWkgVfNyT7ySL3rXmvUoNa2NgJq8yCwmh4
47532	payment	1397	1397	1678	1	1	17648	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCYMnFMmgXsQBxh6FcaCmJp3HrRHqCgD5NueEZgKKUrtvkrp7b
47533	payment	1397	1397	1678	1	1	17649	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3s48wLTQe7eNVFXZMFcpmGzudjM8KdgT5BVXiLptJT46a11Uk
47534	payment	2134	2134	1874	1	1	7782	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsA1B42C38GMUWXqLbSuqdCzJw7Lj39F3dEMVsD65Q4rFWsmHf
47535	payment	2132	2132	1874	1	1	1876	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu3XNdRLGB6uvQx78jrZPz8zH6mVruMucqSs3vjWFr4EbnHPKX
47536	payment	2133	2133	1874	1	1	7190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAVvmHwhZYeJG3CsVyPE3UZj4s7WSVrjhbRLVrtutjUKEmvmN7
47537	payment	2133	2133	1874	1	1	7191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXom4bVbmxeXyFnnW9URVJg17uuXAh8sAUUt9V2cakNFB5z9WW
47581	payment	1397	1397	1678	1	1	17664	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT5kTuFGmd2xzYrwYbeeMSxR8EXK2SYdiA8bP4x8XqKHV9Seb
47582	payment	2133	2133	1874	1	1	7206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTuwsHUERJ7kqk3uiy8SuozqpRvuhTVzg83V3YY8iUbwnhjcft
47606	payment	1397	1397	1678	1	1	17673	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVj7cQQ4Xce5fdVQ8Bbwx3F8EimU3sBVBVwPQc1TC4RijDj2i
47607	payment	2132	2132	1874	1	1	1883	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbeGtKk19ezhh6amK57Tcdk1kYtWq8cxawtYNQJBSMH4f7qg19
47608	payment	2134	2134	1874	1	1	7800	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7HogdQJ1ycvg8rzQdWmcEn47NTQBjBpAnYmbUNkMvtdc9ZHvE
47609	payment	2133	2133	1874	1	1	7214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBy1oqKATA9VQVe1ycRUKNKpgf8SGdFrQU12n88bm4Xmf5few4
47616	payment	1397	1397	1678	1	1	17676	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPgJJk5t5F28ZbGLtxwQuxiFdv8wrjtrd4fxz4GpmniS6ZXwRX
47617	payment	1397	1397	1678	1	1	17677	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tiN6qV3dWPxXfGkPXg7Sq72JCvwqNshd42EbKTRyZCittJr3
47618	payment	2133	2133	1874	1	1	7217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVWxAas6kCVpKt7SgxnzARUAKHP9eJzL38syTB5fEbj3TocPQ
47619	payment	2133	2133	1874	1	1	7218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRb9o7foLkhP6Drb7FasGE5zQwr4jz2U7qb6RzNjMS2MGHrxB
47620	payment	2134	2134	1874	1	1	7803	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq3B2x65jjFbv5QEfc1eVso3WazBm3BeG5eSd9K6Mv4J1PUjf9
47627	payment	1397	1397	1678	1	1	17680	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgSRKWoxsXGEQb2YTrz2ChBtjeL8gJtY6nzvC5tDpX6fiYvZq
47628	payment	1397	1397	1678	1	1	17681	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRgfyzDtdQ4wXcQA9pjXgMnfsSbJywjyHBfCiZgc7Y4fY3wv7
47629	payment	1397	1397	1678	1	1	17682	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAtZSKJkYQe1RdofkUqUDDb7QHVH1AzstKkWWRmRPSZLKTGkJ
47630	payment	2134	2134	1874	1	1	7806	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSiraVozCCzcmhEjFF8k78YfgVFhcFs3y9mTiKXumptLQpbNcP
47631	payment	2133	2133	1874	1	1	7221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgnCEX98G55uiL7rMdmR6cgjYAZUwQtNxYhVZyM7AikbksHzD
47632	payment	2134	2134	1874	1	1	7807	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnQfm11FQFJwNgVxUezJkGSiwosUZU4b8JBKoUXp3uzvnpQnGV
47633	payment	2133	2133	1874	1	1	7222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwkpYvxqpBUvgS1wZ2r1p8f4YzQEBirCHFRMTBCMmAvrXhEzsF
47634	payment	2133	2133	1874	1	1	7223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoFh87et7RULwc7xZqusTnj6ygePf9iTyaAzRPk35t4jw98n3
47637	payment	2133	2133	1874	1	1	7225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UocH9VSkG45NfvVoKfqM8rSYqq7zLPR1tpfz1yPWDbXdjdcT
47638	payment	2134	2134	1874	1	1	7808	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRV7JZt5cAWa2FaBSaTgo5R7xho6DDe4B3dsTFJHGozj52V32Q
47641	payment	1397	1397	1678	1	1	17684	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZLr6UKw6kxBfuXxMxbnTHSRGbbV8nK5bCNJudSAefeFCJC8q
47642	payment	1397	1397	1678	1	1	17685	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWzLSeET8R47P4nMswDpg398za6f96Mjf4UUpdGw9kmSvDYSAg
47643	payment	1397	1397	1678	1	1	17686	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZVCxGhxpmCszq5hY4xHEx1XKkfs5GSGk5VYN6jiDp8RBYsDEj
47644	payment	2134	2134	1874	1	1	7810	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzHFBX4LJinJCHUQ4VkR8QNgJAikRhowMrk9fb1T1ww99UAE4Z
47512	payment	2133	2133	1874	1	1	7182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv1s1GYeya8RudEk3EpNdiu685GDdpy7Z8Afc7cP2vRENrNZpA
47513	payment	2133	2133	1874	1	1	7183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuXknWuF3DN2dABoUAWQTfhhTDRSh38E3vGd2C1PYTLsBGSSrg
47514	payment	2133	2133	1874	1	1	7184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDHyRS3oz5zjdsMRCB8aXFVfDrt4Mf4VfGy9zhQZepRvLA7F5x
47515	payment	2134	2134	1874	1	1	7777	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpU7bEXUktCf71ErCoeefgycnpHPzpnhpTRTApRUEjXTVpLQoS
47516	payment	1397	1397	1678	1	1	17643	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi92N2nR5XqqtMEgtLuryDEddussgFPwHvpfwXmmGtPwoi6UG4
47517	payment	2134	2134	1874	1	1	7778	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXGkFzhQqMxP9Rd5pvmQCTXkiC5oWYkh2gj68t4tU64pax3mm
47518	payment	2133	2133	1874	1	1	7185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj1GUnrUvd2wDw5Pjr4PKBgdoeCHF4YMfMYGq8mLiu6z361m4
47519	payment	2132	2132	1874	1	1	1874	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhjnjUmRyyz9SjKXj1HAtjsqVJ1aHJDj8tV5U5Yj6jVsqQyEyZ
47520	payment	1397	1397	1678	1	1	17644	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4guJso7inN4ay4oLW7ZhYAPTEhnyb3rqmCqvKP4QAXtib9wN
47521	payment	1397	1397	1678	1	1	17645	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7DTrCWC2R8syRrbF2zpJ6YNL9aU2tqygtEJtbgdzq7CCWW2GM
47522	payment	2133	2133	1874	1	1	7186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYipSC8qXtR2vQSZBL9VyPYsFU6UAP5NeeTVNLhgUDfzJQmpE8C
47523	payment	2133	2133	1874	1	1	7187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKqPXBzd7Ebnt3idwSBUcr9W8ZARwRcqxXj8s4VdNA6VddthQ2
47524	payment	2134	2134	1874	1	1	7779	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9paLamJ4r4VAk5rD6UJM65YFHjikJi3squedgZuePdiJsSu6y
47538	payment	1397	1397	1678	1	1	17650	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxivt4TP21919qWU4kwTMq4YufbpkWm8VwUUtf1K2XX4TUjufC
47539	payment	1397	1397	1678	1	1	17651	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXQQanTiPgboem6TZFaJGkkcZyfkjXp3FJocshGzrUZNvtGT5
47540	payment	1397	1397	1678	1	1	17652	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqPcV4y6yyFW97azx3SxMY89jWz7GdtmFBge3NMDKAw76hmx2
47541	payment	1397	1397	1678	1	1	17653	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUC4GFiLuUW6Bd2LAqiYAHqvVEg23KKyr6hiy6JAJXAhXtobQD
47542	payment	2133	2133	1874	1	1	7192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwA9e9zm1rCfJRvwZw9pnrzPAdJgax9VuSVV5tdsE3jmT9yXF4
47543	payment	2133	2133	1874	1	1	7193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZu1Ue4KN6j4tTW5PAy5Hef9iGTBzfjEWTWbxhhktxnNakfbyi
47544	payment	2133	2133	1874	1	1	7194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq3DmyvVX3evG2JxGdAw9wuAiSz5y5s37kBkCNRV9MhNchYQe7
47545	payment	2132	2132	1874	1	1	1877	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTL4oWCis5Ruw9EsBZdxjhMRFXMjSPwWPH5BApwVTKsYJMWBW
47546	payment	2133	2133	1874	1	1	7195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxanyuffkuJ84adUxsJLGU7oWaNeUr1PKPK8R353YCGd4q3VQQ
47547	payment	2134	2134	1874	1	1	7783	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy5K7PZQtw5VY2kp4RLaJsjmv4w6Vue7fwvKoe7UXGxZbD9uA6
47548	payment	2134	2134	1874	1	1	7784	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr8wdDN8oeijt9n7r9fBPhbG8g2wQiTVaqHbQAnVSByHF17Qhu
47549	payment	2134	2134	1874	1	1	7785	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUKsgEmfBZRdZVEus3nZNRrui7qn11jYxRGmhewXrUb3fwMcpK
47562	payment	1397	1397	1678	1	1	17658	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQD2hja9avP6C2YdMV4xvRRfCtUHvTR5cQ88n9trMKacZB4h49
47563	payment	1397	1397	1678	1	1	17659	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLSRFpLaJeRr3uDsdiw3eG2pLoCKBNzE1evzcm6vvrgh1wH95
47564	payment	1397	1397	1678	1	1	17660	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkAPARE7ch8wMbfL6WDmyTZjUDrPuudzt7Z6SkXPj5pQJcZjqp
47565	payment	2133	2133	1874	1	1	7200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWYFQwQEog9kG56E2A2ASLdgG52BWxBpDYL488SGdtrF4CdiTs
47566	payment	2132	2132	1874	1	1	1879	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbkqhvnWVMSd3baasEoCTBHjQpKzoAbekMtbhwmgChHWEFNmw
47567	payment	2133	2133	1874	1	1	7201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbJm8wKjX9xPn9xFsGaSMJSmJMpXmLfUHPUV6QvKcMBRGAMdN
47568	payment	2133	2133	1874	1	1	7202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5dAdnisqQiTLs74oPUVgkYE7R94myaVMg63iS1dZypRuQprWi
47569	payment	2134	2134	1874	1	1	7789	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DRzs9TbRAoVxJJYcHrCUuzxXeSBV47jWDxZAgtgc3HjLDK1N
47570	payment	2134	2134	1874	1	1	7790	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhW1FkSy8tmfgB76PDNy9wSRAiQXMoJypyXEitcuaELW4uwNR
47571	payment	2134	2134	1874	1	1	7791	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt3biXLhRM4w3svotq5ENx9sbwf4EMdcMePu5RpMoZV6RaQQVP
47574	payment	1397	1397	1678	1	1	17662	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ471LZwmQYW8WWx54APw5Y6TH9CnFggznbbJY1icBJRt6MVfyi
47575	payment	1397	1397	1678	1	1	17663	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAythc5JkVc9ncFfFhmzaDQYwziPcvt74sTzhC88U7mpUCv2za
47576	payment	2132	2132	1874	1	1	1880	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfwPAJM9UUEQKmCtEQVFqYaH3deXBRJommXiAG3HdtxBAugKva
47577	payment	2133	2133	1874	1	1	7204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGTh3heDm27nd4J7GiGf6hVBXBHJSVr3HcHeJQamX5PFQnjM6
47578	payment	2133	2133	1874	1	1	7205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkU92EqvjXMieG3ZVkDahbN4b7F5ZvgVne5hakBnpowL1TBQ7A
47579	payment	2134	2134	1874	1	1	7792	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpz8Mre51DBYdEaJKqkVgochD7srxokm2SiN3DrCyMwkgZKE6
47580	payment	2134	2134	1874	1	1	7793	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQYe6hieUa1mfdrvqAHEZbK9LFvHNmTYvaHv14GSbH5gbNWzZ
47601	payment	1397	1397	1678	1	1	17671	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2QTBfPqff1TsX4XuGqgk9av7DDKtkh4ogZhfzVkwNDUfvD319
47602	payment	2133	2133	1874	1	1	7212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnRUorgN9jPMeZuxmDFgUFN23pAEw1DLuNaXbonN7DiPqTiWDq
47603	payment	2134	2134	1874	1	1	7799	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hExLXCXgGu4mkEmqPz7wwE6cmAPkJVk9mvUswNDKVLaz4iqR
47639	payment	2134	2134	1874	1	1	7809	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxE4z4qNWUaQL5WE7H98JbkKKAWJ3UUxnTxNFpNjmkCx8qoNK
47640	payment	2133	2133	1874	1	1	7226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXdBGdZBLejN2D7BnjG9Um3HnLjfa4KtBiTmkSAK8R2eu4efg
47657	payment	1397	1397	1678	1	1	17690	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzTKW79iNgU7xWexD8hyHp1fc1avc26GuUdwxekAb1nAHS3zv7
47658	payment	2134	2134	1874	1	1	7814	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPTJCjU1KQuEU1FtTZFnL8WvLWpuSxwrd4KQa2FQwr3uM7QGT
47659	payment	2133	2133	1874	1	1	7233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHGMxLWDV6HKbY9V2XerXGn9HTWiVdsuZ6hnXrmwbcowq8VhQV
47689	payment	1397	1397	1678	1	1	17701	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSwNPijN8iHSX1LBiwhKj9CbgLr2EnN1K5Rp8vAENMWtxxQ9p
47690	payment	1397	1397	1678	1	1	17702	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSwUp3r2kinp4sMhZXEdKDhAZACTxcWuC45vWjWk3JrtymB1ii
47691	payment	1397	1397	1678	1	1	17703	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfH9JPHYgw2rNH5j6diqi8ChJ9JWmDzLxr7uMWPZZeVuvqi6K
47692	payment	2133	2133	1874	1	1	7244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhu6BcQpxJu93v1FN22d4MjHbZ7fiK3McyzuQwkSnANuS8HMeY
47693	payment	2133	2133	1874	1	1	7245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfLAw598jX9f2qpzfNXmEW1x344CTrXaF9KGL4hTAmvcY3zJB
47694	payment	2133	2133	1874	1	1	7246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SosqxE3vj76uR7ZYFVMkmXqJJQdtGvSXf2T8Ti35b4WEWMpk
47695	payment	2134	2134	1874	1	1	7822	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VRCuTgt2uqvGKjRhB1e83KdVywTgiEfnGpHnNv3QNGydjaro
47696	payment	2134	2134	1874	1	1	7823	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJEQdzj4eKXf7Er3iNfMQWKoSxhHBqYzDxvm7dvUuMHdZaBta
47715	payment	2133	2133	1874	1	1	7252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq8N6hCgScSXjfUeF4ZyP4W3XNb9GhYLzQftWJpK23nf5AAZRb
47716	payment	1397	1397	1678	1	1	17710	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQe7jMgxmFmVNY6xBUMuvh7JzXvN3bm2jMH9HTZcu2RAn13v4T
47717	payment	2132	2132	1874	1	1	1888	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJUixSCtgD7Acsk9oUGu88dXGWUJ9zBM4qSpsw5M75ygR2ZUdS
47734	payment	1397	1397	1678	1	1	17716	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG6pR5G4LgKLERXmkMXT7tWaZQ7QRsrdxcJbxGWG4MNzVW1MVt
47735	payment	1397	1397	1678	1	1	17717	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1e3ADTifPYjSNEYXRNqmfZnSN3xo5q8264sWNPDkSdmmVkHi
47736	payment	2132	2132	1874	1	1	1890	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLEWj6RLvFF4NXZg2jx7UcUuk7rKiLtHqu7G57yPhE8daQH4U
47737	payment	2133	2133	1874	1	1	7259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzbCzXf6ogB5GVQt3AZcao5wvW26bf9TLMQQmTar2cfM5NeLu2
47738	payment	2134	2134	1874	1	1	7833	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSuSNGU8tVCAqDkq2y9s2B4opPF7ji8LKYP7zwL5sg5JgdPuAT
47739	payment	2133	2133	1874	1	1	7260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiRYzL492gMuqKDEHeVLyCq8eTsFe5RK2mtN2VNqx5CH11g3F7
47747	payment	1397	1397	1678	1	1	17720	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYhGy2YFS3RmpCdENai7rAgYbZzWryptD4aVrZfE8UNMkETWcJ
47748	payment	2132	2132	1874	1	1	1891	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVwqM2F81G47EYzTwKWUd2aWMWXzELVqbNeVTWNYM4ri7bki41
47749	payment	2133	2133	1874	1	1	7263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgw8Czx46qeT4ib8NaPCCyN2Tj6LqM44wJBVqaKkNWs8iczKG3
47750	payment	2134	2134	1874	1	1	7836	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZxFecnXZn3BM7Z2dvCtLo7MctfWBeW1QfAZLYmqfCVLKASCTK
47756	payment	1397	1397	1678	1	1	17723	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXYpqW79dEqg6ik4xWMFQKVxeAUkkWjGRzA2WBAYAMNEPyEvo
47757	payment	2133	2133	1874	1	1	7266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7G8c1XuCn59AXYnTZ1ohGp2AWs1w6mF21TnhM9nYLKHTbjBfx
47758	payment	2134	2134	1874	1	1	7838	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7mvppaySBWUJa5LCB1GbHZyhwLKEJbvqkeA8K3AFmEazdcQa8
47774	payment	1397	1397	1678	1	1	17729	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbHr9zjFDh5ZWvdGEVBS6h6FQ6FSiB6KhhCHd7n3SqrrKty3w8
47775	payment	2133	2133	1874	1	1	7272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7pewSwPfZm2TjyZ8z4mTuSUePs71LBcFusF1tM7yKc6UUqCP
47599	payment	2134	2134	1874	1	1	7798	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLbJeed7UcAJkiT9SKey5FhEBoGsZiwq25HwtXzYeK7uXQnwes
47600	payment	2133	2133	1874	1	1	7211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDdjZSoGJ9U9bMMCcmHLwwSMCRro9NdQqBHDJCxw78GjtjZFT
47604	payment	1397	1397	1678	1	1	17672	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Ezeg4Mmsb29We11pNdERLsva8QvZE95kie31NmoiUYLwjJtj
47605	payment	2133	2133	1874	1	1	7213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3PLv8PsRzUvtqZy38EgzanybCPJMTdQmwwU28ibTZmjYx6gH4
47624	payment	1397	1397	1678	1	1	17679	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnDmHMjyFqduVbAzaLqM7AbUtxrDEKnKjTxXofSrLmB83S6F8R
47625	payment	2134	2134	1874	1	1	7805	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsr1pJsq8f1kpAfJENXrdMPfx36vngJ6gJMjkmNjuyNQmwsjdz
47626	payment	2133	2133	1874	1	1	7220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdwm1DjUx7Nh232wZpVihmjY4XzXHsMh8JtpGx6Ax5yjNow3YA
47646	payment	2133	2133	1874	1	1	7227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtgYE2FqmAqipr6kZWSiwvLMep5QYa4dCKSqfnhMfkfD9J2u7b
47647	payment	2133	2133	1874	1	1	7228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KjGyGefJxtaJoUX4GzLRgJwSLn1g68ZDPEwqNYopnS2ustFz
47648	payment	2133	2133	1874	1	1	7229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJG2YXFtmYagkjgG6WCts84SJcmGep43HG9Yg4sYsVsghx9EyQ
47652	payment	1397	1397	1678	1	1	17688	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsVnEJiBAhzdX2hi3K9V7Ht8kopYjiGmqL6HsNC1Dph3BMYcKY
47653	payment	2134	2134	1874	1	1	7813	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJtAyC8jGUrcHk5E8EpraFkbaqoBzcYroWxx4wfoMsf8oduxrK
47654	payment	2133	2133	1874	1	1	7231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKb4x3Yfeth3eGkC9aPjtcmve9XkRjjP5NvjnETsQhxzX6kuER
47660	payment	1397	1397	1678	1	1	17691	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyjgppUT52xy9Dv1SUNUXnPnEQ4dWcXuWe2ntPR1uXcSuwZj5A
47661	payment	2133	2133	1874	1	1	7234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ4Fm9Zw2h3XrcNHE52b5WCiqWX1MzegADZX6myz149br5X22E
47662	payment	2134	2134	1874	1	1	7815	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ka1WT8CYSZDGbsfjMGjrGM3bWKYJ5ctRzU7UQLBjRaGe6ZSB
47674	payment	1397	1397	1678	1	1	17696	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAg7T8WwhxxXMzWwsqbiyGGVdCF52ocb7N1qyttX8kw49UtujP
47675	payment	2133	2133	1874	1	1	7239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6dtvW8nFPAwMA38LLBt3jduoue5eZhHPZViKmsA8o6v7P5NbY
47680	payment	1397	1397	1678	1	1	17698	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE8FDMumkfggaRJkExfsu4EJLwN6EUkU9TQkXUrAjFGiqks7Dw
47681	payment	1397	1397	1678	1	1	17699	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrK9cj7Ga8cZ8dw9qrhA2i5UZ1d5pCYwcK3Rk2yECy68gkH7Up
47682	payment	2133	2133	1874	1	1	7241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUAZrgtNvU6G9bS9UBTYeFwADPZf3DnCAJi4wtvfHgZvAKRixA
47683	payment	2133	2133	1874	1	1	7242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvoXu1harTitYEdHr9YeeEmxHg6KGZkgj34ZLan3iUhEUUCPYv
47684	payment	2134	2134	1874	1	1	7820	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3N3LibiiAPHvu9eNT3iT4Mgn2rmCdkwGkSobRWgMAas83UHWi
47718	payment	2133	2133	1874	1	1	7253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6JvmNSHQ17WVRrRDiKjXrsUUtMy48SVh4bomGyWAY5kDBjoXP
47719	payment	1397	1397	1678	1	1	17711	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEjf4vYYUM5rdxHHUZ51XCsphswvjya8ySrCRSqk4bZs91fYM
47720	payment	2134	2134	1874	1	1	7829	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYs7M6RsiisHmzz7oABATDio18vyBPbJoRC4tWhF6mqEmVcQf4
47721	payment	2133	2133	1874	1	1	7254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsn8T74WjerPo76dj95ELtGRLggPCKSWxZskuCdxh3BjbfEZZ
47731	payment	1397	1397	1678	1	1	17715	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvaJTsW3fEppZKye5HJiG94REZKhCoykGrA3nhAgC3qmWMp7zy
47732	payment	2134	2134	1874	1	1	7832	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWV2PLjEm2jczp1YnUQZ1YVGdyGn1tr4ymMv6QngwkKNCVggaX
47733	payment	2133	2133	1874	1	1	7258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsYNDpPPydGB8ww6CXGecpZ9Ep5BW2MgsckMenG2ykgAsQ7pjd
47768	payment	1397	1397	1678	1	1	17727	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFjHsoSZt22M2nNeM9HZb18fdC3SKYZF6omjZbL7cU6cayVPq
47769	payment	2133	2133	1874	1	1	7270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZb5AoE9fdGCemnTCxmVXwLQePBCatrKVu1d7zN2yaxWtgGFbq
47770	payment	2132	2132	1874	1	1	1893	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu5Crmp72f35wbkYmoWY9uVGttHBmrDbAGVXUM72XV2T1JX6j9
47771	payment	2134	2134	1874	1	1	7841	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpgt21XvFq1cicQTxMSQV98wzTVCpx4zNxkWyxbih2EGsbR2R6
47781	payment	1397	1397	1678	1	1	17731	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzz7eLmSz7usPxnKMANiiwcF2pfgB5BXqpApweHTtruCRZn8g2
47782	payment	2133	2133	1874	1	1	7274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbicqfsEL9NT6o4aZEM1pX2xnTPPSLKVfgioD2a1MpVfFAKXet
47783	payment	2134	2134	1874	1	1	7844	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvK8uHamz57D7hUY24gWuqowbkNsbaR7eqiaziZcLMC5T24jH
47784	payment	1397	1397	1678	1	1	17732	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDLQc2PVKPeVUiifptbasU1Z8egRz451JFfQTshqQmizxC2QJq
47611	payment	1397	1397	1678	1	1	17675	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVDHTKHyPBMUAB9G61qy5k5CQWxEqfuEgYpnZu6X8WavBwQgXo
47612	payment	2134	2134	1874	1	1	7801	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVMhZeeQCL6pwJVA4irAWnDgfouVsvcaxkaQsYDpYczMRSokgQ
47613	payment	2134	2134	1874	1	1	7802	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrt6CrFpA1mfHLiMrLpXUzNZ7aKV23fUP1KTaddHRJaELjS6P
47614	payment	2133	2133	1874	1	1	7215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqWaWfhcPDYess7x5d19mm766EXW1HvmgfdfJpo4FUZ4H8Cvs
47615	payment	2133	2133	1874	1	1	7216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwT6JPHo1g1am6uytDTWrzkQ4Hi63dsB5vGkMX5QmXH3G6HKLs
47621	payment	1397	1397	1678	1	1	17678	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnCqH9KWUxKo2xxG7v6rp65vDtBdymEknis9XpsN7q1RWzPNJu
47622	payment	2133	2133	1874	1	1	7219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRrpNbtFJM2hMFJsNdVJwt5aWcZh61P3WCFvbiZpFVYSVMuDM
47623	payment	2134	2134	1874	1	1	7804	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiquGcRrwRwSUpoW8ovTpteNnCm2gWyjL8pjYMRQL9saW5BoDA
47635	payment	1397	1397	1678	1	1	17683	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeNzrYcfXPX9yNDURtjbPxXAJPTsgtuUrjVxH2ssZ1WPL6VxxY
47636	payment	2133	2133	1874	1	1	7224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrBjLT7oeQLDWsoGnLwakxnJuL1sxfroF5SQXT94Xtakezai5
47649	payment	1397	1397	1678	1	1	17687	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2AXTspSj5aVwgFGZDgreZZfaYBktpbRtepn7FZPMyo3TfRPk
47650	payment	2133	2133	1874	1	1	7230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK61Q9baHsuU4Upbg38NtBdhPoYBpJNP5uQttrUKNddHXoVoQq
47651	payment	2134	2134	1874	1	1	7812	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFd3WL8967hQFpop1ozbSewGa2v4tamtcaNChEMvXf7EPjXfgs
47655	payment	1397	1397	1678	1	1	17689	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPAGovgWtfphqyubJSYxCZyDh8KS7HqXAsYvJE5vaRtuUQ3H9x
47656	payment	2133	2133	1874	1	1	7232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsUeJPaN1peY2kzCi72BqDbw3UA6jCYKSpmqDVeU4N9XpRJ5kb
47671	payment	1397	1397	1678	1	1	17695	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwSHDftE6uQYcRBUwMjN6ZQxKUa5oBDyLqf4ytohZVF6ucRSP
47672	payment	2133	2133	1874	1	1	7238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrWYnKSspvmksQ7mDdwGrTRXyiGbGD86xqBVr7gTuPoYTgZRbV
47673	payment	2134	2134	1874	1	1	7818	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw93ZBrR49m4K8YDxXRWMV5W2Ys3V1hv7sGU6V8BYhjGbuxdCh
47685	payment	1397	1397	1678	1	1	17700	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqt9YgADQyPqLb3JMXsH2BkoM4MGo21ryeTz8fWFJxZWu2x8N
47686	payment	2133	2133	1874	1	1	7243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxfv4E5bZSTmDpTzcC8dbLqth2HLYydLtsn8HgYSH6RXsfU3ue
47687	payment	2132	2132	1874	1	1	1885	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9254q6F2QxDSFP3Q1Sw4tvYzQu6Ssdm5ywzJcjQSd2moaEqMt
47688	payment	2134	2134	1874	1	1	7821	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6P7K5cgzyGs5y3MCWR33Qx6c1cPJhrWF7kME5xzLMTJMt7zWS
47697	payment	1397	1397	1678	1	1	17704	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNwEBT92GjZfV6dLHDrDCvwgywBfA2QvdQ4UDEgYckbQ1M27h2
47698	payment	2133	2133	1874	1	1	7247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUV5MWArnLwBKgy1Zd7LPHfe2PhReA2wBHatv6fWhQvNTBRkj
47699	payment	2132	2132	1874	1	1	1886	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUWQwhGxntqaigsGpHrWKBvNqmEeYTfznThgF1bZYaxh4KULhi
47700	payment	2134	2134	1874	1	1	7824	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtctNJpCbtC14MgXuwvGQGyA6guUgEopGxtHE6mWSkzNxYPRT
47704	payment	1397	1397	1678	1	1	17706	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZixE464B7vbiuUHrqmnwrpVJWJb1hYah9i15BmbhezBfBur9RA
47705	payment	2134	2134	1874	1	1	7826	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWdEvQpVFtffkhjFsJgn4d2mWpJY1dCJVHEBPv5pAa8L9SdGSR
47706	payment	2133	2133	1874	1	1	7249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PW6NaCsrZztney5B7inypsBe9vggDeDgsZJakDWg5bauv7tk
47707	payment	1397	1397	1678	1	1	17707	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEf73q48kn5yTmTp2kWtaYp92ky9m7HiLsV6nACNU2zTxfp7Fx
47708	payment	2133	2133	1874	1	1	7250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXa3R9rwz7XnZdchfAG1xbc2x9NcS1f1JY76qfVUxhyjLjDKjh
47709	payment	2132	2132	1874	1	1	1887	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU74wSQxjeiALKvrnvbQwzdByikEBLn2gUWVWLQXVdvppFTuKP
47710	payment	1397	1397	1678	1	1	17708	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNAdMcwHswY3crnwKDxte989954EPQPMduptHbiYDZJjiExkj
47711	payment	2134	2134	1874	1	1	7827	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSu2H1Jmo3WzNX9bG5MyGdB7WtLYCunSEtAk2qMXjBDs3MxBTP
47712	payment	2133	2133	1874	1	1	7251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgR85cJiX8sf4jiQaoxRfdb19rxSyR2axzpr9wPvQTnTed726
47713	payment	1397	1397	1678	1	1	17709	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWkGdYwQvhrDQv6CKkCMUHFC6u6Y4sAoZBAVsr1iW2qV451iU
47714	payment	2134	2134	1874	1	1	7828	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFC7HnhGKuSMouUzzwoRAxAVmfup5QWyHMKJ8aRmdsds5mA21b
47722	payment	1397	1397	1678	1	1	17712	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVXvRp1QfdBqeRJP24MFTZbA7sL5stKe6ozCMLZGLiwtNu1tzg
47645	payment	2134	2134	1874	1	1	7811	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrXne6EiJ4FCAx8iMBNbzWDQJzC4vo2fr2MYyZB8JHcL4dFsY6
47663	payment	1397	1397	1678	1	1	17692	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyuQZyZw2RZoiNPWtjuhYjbmE5WFs9koFp17ourb4TjKAPtntu
47664	payment	2133	2133	1874	1	1	7235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrUxqa2hBCqGEgHoB1xNgZFFwLjoYh8Te3htcVuc46azUYtDS
47665	payment	1397	1397	1678	1	1	17693	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPaHp3oSYpoJqNu3z5icWnnRxXZirube53XTReJ9Y5xgqksEw
47666	payment	1397	1397	1678	1	1	17694	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYappV9CAZRuMLYR3aexPmE72rAq55rvf8oaE45X5NJbZunJmH9
47667	payment	2134	2134	1874	1	1	7816	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYay3535fdo4tupnLuHnthqcTuJTd59dcTW6LgAUux1fYkc6U4B
47668	payment	2134	2134	1874	1	1	7817	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsRLJiRSbUNnnYhPF8thMCb6wrt2aeortqvp25Td8sqRJEWWxB
47669	payment	2133	2133	1874	1	1	7236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxm5amTqdD7ZqeJbDyN4yRSbS7ZHueDHqKGo5cKt2Ya1b4a78
47670	payment	2133	2133	1874	1	1	7237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6SNwfdsgZQjSTkF2JPfmP8raeQY1PP1KdtqSHoxg636DbeWR3
47676	payment	1397	1397	1678	1	1	17697	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayRT5yEuo7M2MBPazSpsjzwGX8dWN4oKJ9hLmKzBDVQfABZzG
47677	payment	2133	2133	1874	1	1	7240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYco28LEMEHnW9iNckRHN9mpsttBQGo51WMi5Wq4VpZbNyVaR9K
47678	payment	2132	2132	1874	1	1	1884	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVk66wXJ16qUY3H1R5qLfibMug6zN92WnK6EirbLtvaKBcTpdH
47679	payment	2134	2134	1874	1	1	7819	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYcvaUSMdYXr44gM5ohBqqgLvWSY9jHAfr1M7bW47V9jrKXFcA
47701	payment	1397	1397	1678	1	1	17705	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT3t5XxaJA4QGHkR2aQF6tz8Wc4KVXhHFc3L5HhTep1q9TkrjS
47702	payment	2134	2134	1874	1	1	7825	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyGDFmoxijmdRuNbNRtujCSm762jTWkhsd1ATNCQHLBQ4rtVi
47703	payment	2133	2133	1874	1	1	7248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUezsuftFEGPwDSPEHotqCbUNeZtjwt4N7VnWeZoKXAbje3Vt4
47751	payment	1397	1397	1678	1	1	17721	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8v3wE7bnjx6ZimERMKVherPW9woNf6seaSWkwHcKZKBQrZLyr
47752	payment	2133	2133	1874	1	1	7264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLjjhgYg1gZLUPXGA9jxYEVEDvLc21p6n99dd7HxE9U6NzbuXM
47759	payment	1397	1397	1678	1	1	17724	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkSUAAhRmry2jY21JEE4AKsEusmuM6LGz9Xicq1MKXxDx5UBkg
47760	payment	2133	2133	1874	1	1	7267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnopwogSuotZGUkyicFmFC31pKXXjrMw79yh8gr3fwVKBZAFd6
47761	payment	2132	2132	1874	1	1	1892	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJkWWW8G5ZfoWzswF71bZcAt9YfEj3uPLD2wfTNLqcfGx7rvH
47830	payment	1397	1397	1678	1	1	17747	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRLtTUvC2zZ3DZd2BHFMVjfi9sXnkwb3KeHyfaMMPbjy4QSz6x
47831	payment	1397	1397	1678	1	1	17748	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55GTKiEhjJxKpQxZR3Aveff84ciZCFdQV4yQBykKNYj2JQfua
47832	payment	2133	2133	1874	1	1	7290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcTidJB8n9A5rN87CdgcgJT6keZuh2TzikoKefCNdczazogPaK
47833	payment	2132	2132	1874	1	1	1899	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtaKRCTkYmaiRb86jeyELPtV33yBQbfQtKTi6kAMTDVQCwUiqy
47834	payment	2134	2134	1874	1	1	7856	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxRY7MThwu3de6dZAL3nnvzY9BBPqEZMrPcF32FC1aqMv1Z6xW
47835	payment	2133	2133	1874	1	1	7291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiyrCqnr2vwb2xe8ssHkKoViQ3sBvJq2Ja78kxDskBqc13PTHD
47855	payment	1397	1397	1678	1	1	17755	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZSRTppmqUdS5n3GiuNemHCMv5aKjoUSVzTcJkWvmpct9dWqMB
47856	payment	2133	2133	1874	1	1	7298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHvA7oh6n5vqU1wSLbUhVrFrNDMbHBb84duDjJEmzMZ4aiegZ
47857	payment	2134	2134	1874	1	1	7861	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHeRZoQxNV9VXCNH6eiTthtq6tgGQzGqDdnSYwg61QvG3adf8f
47865	payment	1397	1397	1678	1	1	17758	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4biZ8pZxGuEEpM4osWjWfDjvBdWN5a9xmMk5pzhUJPLachyS8
47866	payment	2133	2133	1874	1	1	7301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxuWWS71bWcL32TGMYp7bLgdY9j4ZjHGNHMi4kqrK3CtsPykex
47867	payment	1397	1397	1678	1	1	17759	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDe95KJtdYQ81Gb6LFoLydxZCoERQXFChfuLHuCA5Mikw7Dq8e
47868	payment	2133	2133	1874	1	1	7302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkLLrAuyXDLjziSgXPYV3Wvb8em8jT4z5zAENbtUSG9jB4r8n
47869	payment	2134	2134	1874	1	1	7864	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa92TjCQ8oFFyqeBw9AotGS2u5dVVTUZXTRgtbf85UdhrvdbKeJ
47870	payment	1397	1397	1678	1	1	17760	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdxJUeUe91HLCsEmTirqyqTyg1EvT56VobpzXA6GgETPE3h6A
47871	payment	2132	2132	1874	1	1	1903	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPn3gbhd9R7nxA5sGPfYgZgLVXjQtUG944WQBpHfX5rfnTwfY
47872	payment	2133	2133	1874	1	1	7303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhnkhCGQAPzVnNjGurYqoyuUKzbf4g1TC8aAN2TmVXduDUvJ69
47723	payment	1397	1397	1678	1	1	17713	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6X4g2oUCxaau7PrSaUrHMq13KSkXZAkn7xdHKT6mByGRggmGP
47724	payment	2134	2134	1874	1	1	7830	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxi7einrRudZXVrY4zwRQWrwgYDMph5HxMCPfqZD7XA21FsXob
47725	payment	2133	2133	1874	1	1	7255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJaV3Nz57yGipcZGg3V7QdoJxp9B9Ls7ewh5Zzcfnrv4AXCd5m
47726	payment	2133	2133	1874	1	1	7256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaFVzPp6J9WWznJvcv9mrfgNtvK3oByqzKUhx3PbRav7oLPtnR
47727	payment	1397	1397	1678	1	1	17714	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiZRdyLDaKwriry33uLqL4sXopGwFn3JcBTqCUF3t6M7Wwki3g
47728	payment	2133	2133	1874	1	1	7257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDMbfYUvcERZtqe7Vj4k6GJgxTcso8y2D95sTf6c1eg1dzFu4
47729	payment	2134	2134	1874	1	1	7831	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhUPwKx3S2hBybiuVPjoQCPq3KkoR6z5ffVpQCA1DYup1fkyBd
47730	payment	2132	2132	1874	1	1	1889	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYznGaWvo44HQwmsBUnbzp6UcrBLiW4Gc7QwR9oiWXNFbVPBRSP
47740	payment	1397	1397	1678	1	1	17718	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBU2yH6tYBkk5B3uifbmsR2M3C732pNhRLAR1Rf7YAjCKsvXT
47741	payment	1397	1397	1678	1	1	17719	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJbDB3fsiWnTbe8h8yiPuEryzT6rpnMCBPuqdTKubvfY5tPj6J
47742	payment	338	338	2403	1	1	3	990000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZogW1utJqJbaufCcEmSqC1W8LU1pfNa8viUt27jeeeTz2HtD
47743	payment	2133	2133	1874	1	1	7261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyUrSjTSvNo1A74e5gzAAXwpSRFE4p4rWkkerbj6gCYKFukq5
47744	payment	2133	2133	1874	1	1	7262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqq2SrejnA8bN5j4PMkK5cTZC61gUQNcCLofzQEdRyuqGTKeS
47745	payment	2134	2134	1874	1	1	7834	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZysTH1AtgTnavK2tjzX1fSC3xiazdetoX1wef6vJPJALFYJBLX
47746	payment	2134	2134	1874	1	1	7835	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4SSnhU73uVzmq91d9ZBrsSo8tRaNRc61v8sUGuDF8VAwW9n8h
47753	payment	1397	1397	1678	1	1	17722	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPtdZ1TAkvwg8hRCx9u4cQ2oAK1wyaSvEymM4HQBnVYJCFvb9
47754	payment	2133	2133	1874	1	1	7265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdKDHAGksRrMjtPkraNC5mKf9sytrE9E4y7vEhMLbSpFGy9AzX
47755	payment	2134	2134	1874	1	1	7837	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggEm76X7MxmbrwksS9f9ZdgfYgF8rqUWU7GUNNetFvbKhHbj3
47762	payment	1397	1397	1678	1	1	17725	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJCZzivWrL2hHsn4qXF2DY7Yiu9e5RDtEYbi3nsSY2kKNwdWme
47763	payment	1397	1397	1678	1	1	17726	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoTMtU7bDszKYqrbDhudT7my7XCJgtcs2quUD3xNMXkFnBG93E
47764	payment	2134	2134	1874	1	1	7839	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp14GuV5YpooeZzajijisH2HdjW4zmsdStFELmYS79xKEHdGnQ
47765	payment	2134	2134	1874	1	1	7840	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqoaCApHpwKbo7P5Mr3G7XqRnP5BSspSYgmpZC4Nrh9x3akP3H
47766	payment	2133	2133	1874	1	1	7268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAzpAoZ1BHG8LtZAgieZtsrdGgmj8ksedyyRPxwUp1pVBzKFJW
47767	payment	2133	2133	1874	1	1	7269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEoxs5zHDidVLeQet7o8VBstBbDjWAa5TJRnxECD3HNgnZ1cce
47772	payment	1397	1397	1678	1	1	17728	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tmRqGKaqe5xGFZaK43hKEN5gFm2LS28wRxdLKajmUbymCF8u
47773	payment	2133	2133	1874	1	1	7271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdqBUCc55fn1HWrQyw36EFXHFnFcRb14m3QbViswraQuR9ZwE
47777	payment	1397	1397	1678	1	1	17730	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHg587axkcATP4HGJsds4SPo5Fx6wEGBPc3pZb8m8y3KXL4iUG
47778	payment	2134	2134	1874	1	1	7843	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsuhhaq2jSJrwSrb8BXhtdd6VuFpHENH44BSzdVVnUCDUd6em6
47779	payment	2133	2133	1874	1	1	7273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MaRgEEsFQzk93hhiYLLuKwoCdewM8ijwffCU5yT9Sh6NYnxX
47780	payment	2132	2132	1874	1	1	1894	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa63sXb6oaSba3sf7VXLgnvv2dcBNYd6ffbXsc5AyU5PNbAQLs7
47789	payment	2134	2134	1874	1	1	7846	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwmsQKAsY1mfYoNDwpWQ8u63RWm9BuR1EStGADVfTUJK3DBx4
47790	payment	2133	2133	1874	1	1	7277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcx6fZtvj8T6AKT9hAGL67Yb9EBMQs7LH1PxhQeLtQHP6mKSgQ
47791	payment	2132	2132	1874	1	1	1895	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmNczT4LJCRJS74D359PPLSBJJnXe7nTe8gZaB2B6Ka5WY9TS1
47839	payment	1397	1397	1678	1	1	17750	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVCno5PDFVqbRR1BFgNCJDRSSgod79188AfowXhWqxNypgHswm
47840	payment	1397	1397	1678	1	1	17751	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYir5w7BxeXhM9BFnY7TeVFb9qbBekj4nmTLVyFSa7HDsAgf3Mn
47841	payment	2133	2133	1874	1	1	7293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqthaETJDf2CDiC3QrkgyKAmuCkjRyRXvrC21aTtw7APmhuX7w
47842	payment	2132	2132	1874	1	1	1900	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmTTWoqYsVymyiVxAg7TiAh9Y84hSSjsQD2vAuSD2gyuRRo2G
47843	payment	2133	2133	1874	1	1	7294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLma2rQvYSWzfEcbW8gUd9tt8wYVYqFpY5Mw48jrxK2UTFHeQk
47776	payment	2134	2134	1874	1	1	7842	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGRQVmwVWf4JjoPAR2P5Yx37akYhNsgCFWFv7gUiymBS4hi8Vu
47792	payment	1397	1397	1678	1	1	17734	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSGnaZbWPABJMq2rGyiRV1uZBNvtCRKoeLAUwbE36rmBrQxDqs
47793	payment	1992	1992	596	1	1	5	15840000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStEUNGykoX7nZcH9khTGeHkLEa9N3hPExAxUkKjV6DRoyzDaf
47794	payment	1397	1397	1678	1	1	17735	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYSswPbbpUwSTj9SjmsVKF5FxgKhoUpoP23xrHkYGRacaT3Qbf
47795	payment	2133	2133	1874	1	1	7278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ3gaAToj4hWhAck6vNj31jBPmw1ZQdqzbsKikexKjFudXeQk
47808	payment	1397	1397	1678	1	1	17740	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCwUTVSA5q293tpHuwLkFkg4BqEpfBrU2oXiWsrRYAagpvs8Az
47809	payment	2132	2132	1874	1	1	1897	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZer5iVTubXB1aiPWDfqiVbaFcQwuMrRDn2Azo1n7KsRn5mxBK8
47810	payment	2134	2134	1874	1	1	7850	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnFsjV37mSu2Af5d15MxU91V48pLTcUkWXXyYDjKN9bnDtZVrE
47811	payment	2133	2133	1874	1	1	7283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL53yg5Mu7Uk26dtT97s8ohWp7Npb3oj3QnXLybSzFMmhh71Mf
47812	payment	1397	1397	1678	1	1	17741	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycNGZ3v7CaRrAxFFFxtSPUjZspMAiBR5ucHAZ3CGVZbPHkokB
47813	payment	1397	1397	1678	1	1	17742	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa54SSGaLe6Vcu8VfYik3qfn1d58bXAc99WBw1qCt2Zaw7HnzAu
47814	payment	2134	2134	1874	1	1	7851	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUSeD6Zgw1mdAp7QaqERaxrxH298n3ztsS7qp5EA8Z9Y8Yvd6H
47815	payment	2134	2134	1874	1	1	7852	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1LEVU31hvQLorsoCmNZZZ1nQfBaLS7cv39ssk1xFv8gWg8FY
47816	payment	2133	2133	1874	1	1	7284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxqR4gX9VRGqJBKw5tj3QAskBULtnRxHUjVYKKdGCrYAx7yoHA
47817	payment	2133	2133	1874	1	1	7285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqahL6WcYzS1vfUrSx7bqWG7w2LRSyesoGf4pUzEGdvu8C19FE
47818	payment	1397	1397	1678	1	1	17743	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvKGRC9coTpKjZJBK6SvyBYabEGs6LQsUeTfAGSdvGoFTWi3NV
47819	payment	1397	1397	1678	1	1	17744	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMbXk58NFrCMwhrnAksNQxGQaUZuWF7maMj2R84bFjE9JBnXde
47820	payment	1397	1397	1678	1	1	17745	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbDVoBnPubYPAYdJC1krrfWJsZQuBo5tc9S3o1h25CXf6tQAuN
47821	payment	1397	1397	1678	1	1	17746	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXrhUaxv4P7ifqKocJwSHPSMKiAr47iH2MDeGfdaZe4kYaFom
47822	payment	2133	2133	1874	1	1	7286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAr1Nxo4wZ4DazYQ75weceHig6qcjHjFxByTDzizcW6iYFSia
47823	payment	2132	2132	1874	1	1	1898	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsmmymXdizG6j5n3A7L83JoFXkCt9etKBFtF8yEpV19JJ2Xkii
47824	payment	2133	2133	1874	1	1	7287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa241w9xEEmg7VmiKzTWuNJ7BocuHKMKoJ3uoztxSB69tNcJHX9
47825	payment	2133	2133	1874	1	1	7288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZErnbXfbpc3WFj7DhHj14vuqUrpiD9nL2mYrfJ821Hk619P2MJ
47826	payment	2133	2133	1874	1	1	7289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuB2TAigJScsfMrtrPwTsamMEj7ne87C9tGt7gukFRvoFqTHt
47827	payment	2134	2134	1874	1	1	7853	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFeZiJZ3f9aYnbmkf9XqfMtPuZVMVC4RRfR6eFfUNtd3mn729T
47828	payment	2134	2134	1874	1	1	7854	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5xHWGdXz4tA5Vud2PoYUB6WmzEJxer9WWUJBhudcGwRj9WUdR
47829	payment	2134	2134	1874	1	1	7855	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDdqLAbfvMFbnSbfXS7wDVnVpnA1a2JCMJoJUHKF6kBd9soxaS
47877	payment	1397	1397	1678	1	1	17762	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBv7kWF3KCF6hJPa85SALpsJdG9yEja8AiiYqkMsK2yjSfa5ba
47878	payment	1397	1397	1678	1	1	17763	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKXFHazYMyiGkfqhMNcDBmjsfFCCk9ykzsUkv9f4MxBbHRi1qM
47879	payment	2133	2133	1874	1	1	7305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXxUwy7craRHUZBAeCjoE81kup5Vrap7FJdRWFZZ4inxinVg4
47880	payment	2134	2134	1874	1	1	7867	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSanspQJwMcExbXFb4okE1y4n9Nyk71AELK4iq6SuKSuziwtNX
47881	payment	2133	2133	1874	1	1	7306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoy7F1e7H7CV24mMKvDL2dGq9Gw2dpvcLTyGm1ijY1TnM9nXeP
47906	payment	1397	1397	1678	1	1	17772	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9YXgHD9MBd8QNqeF7azH5zzYjXBEmcQBCUP8od8vtm8RkKxX
47907	payment	2133	2133	1874	1	1	7314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8p7XYqQ2mZMKqRovuKuq1YnwtF9umc1Pa73AKfGtWHCYAErq
47917	payment	2134	2134	1874	1	1	7876	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Nojjfj4jABztxYqFYVnR6kCQHdY1KPYtDkUk8gpTf46GCajn
47941	payment	1397	1397	1678	1	1	17783	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcn7uQRJfcfMEMgxZxbGWfbYxQrEcXjDbVD4kPF6zwyic2agG
47942	payment	1576	1576	605	1	1	0	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ejUCrTzWZv9A6uUniCRdRwTdXjk2ZZK8xYMhMrpxA5PzhYKg
47943	payment	2133	2133	1874	1	1	7325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvWrHGSGEz6K2tbN3VxNJFTfvVqbw4ip4ZwX5y9sg6J1uELJb
47785	payment	2133	2133	1874	1	1	7275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu23RQDiMUYAGj2LQtVTQQehyGWXnSxDhwKMP5jXynCRWRx8j5
47786	payment	1397	1397	1678	1	1	17733	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwwjeScpYrUtZ1r4xvXEoR5158rQn252fjfKmWDEqsMndVchaL
47787	payment	2133	2133	1874	1	1	7276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGEpTB6QHNpvtASL3LceEBahSW6Nw9o4kMCRPdZ5xKtoytaeE
47788	payment	2134	2134	1874	1	1	7845	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMSw1ry2Z66AGQqngBAkE8p4p7dct1gCmE9CxsYhP9ztTDypbc
47796	payment	1397	1397	1678	1	1	17736	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZjWMigdoVdutSovbmzn6CkpFf7LfDtyiFA4rkYuQfD8NUThX3
47797	payment	1397	1397	1678	1	1	17737	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4DT83WFx4cbfPq2s719WXxc4G3zgxj15rPe6TgbEo9rZ6eeQu
47798	payment	1397	1397	1678	1	1	17738	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BQ7S1PVnePWb5goBBwGnFUcHot5bWzqN3XSURV8ruo1FWrja
47799	payment	1397	1397	1678	1	1	17739	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrQ9QvMP69USrDTf898jYeEbJH7Z2onadDs4uTdX2i2FL6aFr2
47800	payment	2134	2134	1874	1	1	7847	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdud1oJnC3AzSoaueSATkY9Sjnw5ssFyvzv8mhmaixYVnsvZz8
47801	payment	2134	2134	1874	1	1	7848	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajeHf4vXyKrbxCNcGWqkLfnPiNtqKWheGPHqnLU3XkjZFYuLd
47802	payment	2134	2134	1874	1	1	7849	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhAsztBMCEATYCtcnS6Smhi757h2emw1UE6N9sBMpPsrwd5YFb
47803	payment	2133	2133	1874	1	1	7279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXKPJBwLJHKaJ64xV6EL1KNPCo5i7oXxgYFuvxvVnvFjeQZ9t
47804	payment	2133	2133	1874	1	1	7280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCGzUr1R1XZntLojQC4nCPxh6T2vW4ZYbrzMcF8QyxCnmPVc3Z
47805	payment	2133	2133	1874	1	1	7281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvDccCsh7cFvnPb75nkSKaVSN9uTRpKUmNZeQ8NU1Yaqub5cde
47806	payment	2133	2133	1874	1	1	7282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmKq7ZJKugZUZ7Kqz3CGJgcyGzmoJFPKsLy5QU3oHMjCaMFQH7
47807	payment	2132	2132	1874	1	1	1896	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6TqZ74y1ycF4hP7DW1hh3XjwqLtww115njvC48Vxut8Eza16k
47836	payment	1397	1397	1678	1	1	17749	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiXFiUwGv2ZAxu3WqZ8MiYyuRa5BdEjRHHJ1pHj3ysuBKE7kfc
47837	payment	2134	2134	1874	1	1	7857	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvH8uavKcuYhGwCVkHhbsdhPuxJm8EoS24HLLCaB3uH11jNorb
47838	payment	2133	2133	1874	1	1	7292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD1LKiTP8PjQPqqG9fPGgoEFJsWWwGVkcoXeEJVf7Xou5WM5ju
47845	payment	1397	1397	1678	1	1	17752	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMFQepjCGYSX3yyL2DN5EfPeHH7den3db42Nfy3iFGEPRiK5h
47846	payment	1397	1397	1678	1	1	17753	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnPcosBfSB3RGFWTTRYdJvPdzKh6EYTaDt4N9rJ4HHAui8ZGg
47847	payment	1726	1726	2418	1	1	8359	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYY5KpGQRHn9kxPtBwB7KDGuZvowzccKpqMh47uEum2qkYF74gG
47848	payment	2133	2133	1874	1	1	7295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8YoLsRhX1Fx3hgiAfrhcgTwBhMdr8vpkAvXAXg2rcXAw2icbQ
47849	payment	2134	2134	1874	1	1	7859	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBJfhH7c6vjsFkpY1Z1LBGwFEqCaTuDKzMmNRtebrn7hGZQvD
47850	payment	2134	2134	1874	1	1	7860	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9fFBi1LoCpt34cTvCXgJdNVymuybYbHCaXEgariVUzD4PSPF5
47851	payment	2133	2133	1874	1	1	7296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKAMRoohi6ZN63MKUBCQGiHYqR2CaPqpSVzkqDoEo71izg222n
47858	payment	1397	1397	1678	1	1	17756	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg132mLsj2YqYW8DadmSDQ1ixRkJQgHKan99Ht4cKqwgdJh29c
47859	payment	1397	1397	1678	1	1	17757	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpLzBae8G1CPajqYYtThwmmeMHMXpExjvo9cDRmFr2NYfdxcAJ
47860	payment	2132	2132	1874	1	1	1902	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSo6Wzo88NZCcKBpUAxGHrZSyztoY2LdnZLYzbA9HHVCtexMnQ
47861	payment	2134	2134	1874	1	1	7862	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiyxBtu6qcvAMiPig5P73YZpRvLKTbkVP2KwPXUnkrZGczDnT
47862	payment	2134	2134	1874	1	1	7863	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS4NMczXdLkwGW7A2vAG5xcdTqJnDAjPqaqAudCSkC16i4fkhj
47863	payment	2133	2133	1874	1	1	7299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNqiTvBXjzV6TV8nD5wu6xT7zvQHcaP2DqEVn54G3Z6thwkoS
47864	payment	2133	2133	1874	1	1	7300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQd9wqZTHuHQB1voxF8WF1kkGXjNquf3MoXWALPK9C2J8chqtT
47886	payment	1397	1397	1678	1	1	17765	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLxY1kHW9dVTngvpDEGbPiyQKhtfZrdn9vNKTewCEf1Pjnwxfk
47887	payment	1397	1397	1678	1	1	17766	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHddggtEU3YFLChGbLmm7nFthx3VbPxzxTU1YyceqRW9HTwKm1
47888	payment	2133	2133	1874	1	1	7308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3bFy7x8f3YBxuqPqLxrD1R7ywR5vGSU4vS3wBBr6eVVVkk35
47889	payment	2133	2133	1874	1	1	7309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKv3W1q5joGobJDHVDJtKMrJpHXYvhXz866rLBhoGGUSY2e79T
47890	payment	2134	2134	1874	1	1	7869	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnxQwJKG4L3t32emo7ByvMdFEWpWNS4NGpnaFnaX3AKP7aaoKp
47844	payment	2134	2134	1874	1	1	7858	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8hdZhkR9NNCPD2G3v3JhoSgh1wVhh7UtCpaqhiHeBoqwQKWcX
47852	payment	1397	1397	1678	1	1	17754	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXMKiU8Ek1eS39m4hNnqCwJQoNFNYSxrTG8sgKw5oTtrRcR9VN
47853	payment	2132	2132	1874	1	1	1901	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVBgQZLD6Ww8UVHAX92Ug4L6rL93WbNLcxubq6bvTc8mQcZP1j
47854	payment	2133	2133	1874	1	1	7297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH4gXE7fokYwsHhMmR28JAgSuhB5zFDXjayvoYgYzsbqBke7Ct
47874	payment	1397	1397	1678	1	1	17761	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhASWfMFP6zWFM6EeCVj8ttVrX1bXAQcJLRAcqeNco3x9UuASu
47875	payment	2133	2133	1874	1	1	7304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdHxinuwX576M9YvN4ofsJFpcPj7WvABb7JrbE1GfLUkwtMQx
47876	payment	2134	2134	1874	1	1	7866	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZebvkNiS6QkMtuv99MN3MqoE9d9grApbqkafHjVD5eFGD4kod7
47882	payment	1397	1397	1678	1	1	17764	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRoHzrMZyMnVBZVBKninzbnaWifwfNQWNWhz281rcga6wNqVLo
47883	payment	2133	2133	1874	1	1	7307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgxhQqXG7RqsrPRDT4YKXcvDKaAiFd98bYP92jR8c3XskxjWYS
47884	payment	2134	2134	1874	1	1	7868	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzfPexyJ6CDTmP5RbQfHWs9A8fp7ePdrPNaoxGasv2NBytAaQT
47885	payment	2132	2132	1874	1	1	1904	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaMafr8HvqXBF6dTMsCpnrDCXeV1ZYFnVHjX3RcVXThBJnX3qL
47911	payment	1397	1397	1678	1	1	17774	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezcemyQhknEDnYnMioxYw2xPfKQycFmsUceB5AEW8PgWqNzqM
47912	payment	2134	2134	1874	1	1	7875	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfMUAZJ9Cdg9hxEdQgoi1i8JuQfJ68eZHJNLvoBkhS5VFFSF5u
47913	payment	2133	2133	1874	1	1	7316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqF6JmHjuzFvK6uLcFfNecHPpKmdVKd3FBMu6PtDnHZ1LzZwFE
47914	payment	2132	2132	1874	1	1	1907	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzfrXSnmaZqv9kQgp5mjXCKmZeqt6ALYbHmgYyQCCbjAg9pUa
47927	payment	1397	1397	1678	1	1	17779	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8DvUmwRGGF9PAFmbTauakjaYNe6JZMYiLgLxeoasdFW8ovk4
47928	payment	2133	2133	1874	1	1	7321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNcnJZm3oCCvouY59N4aDM7pQh7CUXQ3eaQNafBS9Hibz6Fkwd
47936	payment	1397	1397	1678	1	1	17782	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTUWkhfkp3bUMtrGEbbJHx9516qvjXanquNSs6PePmX2RyQhq
47937	payment	2133	2133	1874	1	1	7324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTUZeGfnrcXdD6jbCyBiFuhFFoJicMBgvzSRRga7BU5M9CCmfM
47938	payment	1419	1419	2419	1	1	8	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoujspcWXCz3w4HpqCZJ4oj5Hy45EZyNkSDiJ3W2HLcQkNayww
47939	payment	1419	1419	2420	1	1	9	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV2vtg2BR1BPZzGndw8oXHJ9P25hcYxskbK8N6E4qkEXyFVPwD
47940	payment	2134	2134	1874	1	1	7881	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9ANMdA1AEj7z8QHRHgBY9xWW8NH9wxmV5ze5j9MCHkxxJ9md
47948	payment	1397	1397	1678	1	1	17785	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6LKYTKLFYtNT9444aVE63rhndSmaHQyoa4EnEsEFUxbksAgE
47949	payment	1397	1397	1678	1	1	17786	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ja8hNg6ULetCZzJUnwJVNDdrFa2GEEMcVNbDCMJYimE6Ehec
47950	payment	1659	1659	548	1	1	1	720000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGfNwhSKShbigztLP4VHbziudfMWe1Ai5iXmJ4nBDZ7MDjUkH
47951	payment	2133	2133	1874	1	1	7327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDdycNiDUZmvosc26VZmKoY5CFH7NjWrnwestk8gye1ASXtbx
47952	payment	2133	2133	1874	1	1	7328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8KEWsGE2u1HmjVwUys9Y8145QXqTpW7GnjJT6ziVfxXTcMjA
47953	payment	2134	2134	1874	1	1	7883	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4jDkXFCqZXyXKjdfaQv5W19qBsMFxEgTKvR5drBFAksmDZG2X
47973	payment	1397	1397	1678	1	1	17793	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqWKqMizrn8KU6xHkMisKdXz6LXM3bysYVqewn9no8GpZRRjq
47974	payment	2134	2134	1874	1	1	7889	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7GsVwvkH72vGQFUwvLqHWvAAf9A2N5L56DDZwn8sGVbKFEftx
47975	payment	2133	2133	1874	1	1	7335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHmxoUAbi4qRxCyRE1T5TPjH6aJMoewMo2ZTffb4oL1gcDynCD
47976	payment	1397	1397	1678	1	1	17794	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuyZFW2D1uXsna4eUymHaGffBvNHbYjVEsUYaNhABB54xiiKZw
47977	payment	2133	2133	1874	1	1	7336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRfKCu9XrBRyFVUYg4VpKE7rJSS9LAMQJraCSNtPQ9xXB1jkXu
47978	payment	2132	2132	1874	1	1	1913	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9oFxpLiPYWC75MFyE9Ek24t3t69bmfRWjLLKe5hgxN5uzrTvh
48000	payment	1397	1397	1678	1	1	17802	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx2LWmyXNCTHNzG6BFcaJxskaNV3VtuDqfkwQyw97PmQjX2fyV
48001	payment	2133	2133	1874	1	1	7344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzfZ4eZj2FuEmgENZFARGn9huvn4A6FPS9r68CexnqSpbcZXz
48002	payment	2134	2134	1874	1	1	7895	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLpM6Kxc44wQfYMrg4CC82FUrtmUWs43FBb8uf8E4jbe1JBB2
48044	payment	1397	1397	1678	1	1	17817	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG24EnirmUZknTxYsi3Z3q37SAqFXXJquCgKZi22UrTee3xZ56
47873	payment	2134	2134	1874	1	1	7865	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtWKx7T7fTZsFpsKJSXdbKDt5iYCjAG16wgWfqJKzd2zNTkHUz
47891	payment	1397	1397	1678	1	1	17767	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRUm3cqRukUMon7z2nEHcpP9EAqJMNhAogQVZEm4NxpK4sZKFK
47892	payment	2133	2133	1874	1	1	7310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsG6rXBrvKVWy8ygJzLoLgjMqXPwuuu3FMT2zQrMMVCcEC6aD
47893	payment	2132	2132	1874	1	1	1905	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZ5hBFULPQPDq5qvfJ1dMYi3TYG4wZ124Gnrgyz9PLYP9D8X7
47894	payment	2134	2134	1874	1	1	7870	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWTH5F2MX6tF4s7WMdtmveZhqmA1rBzVsizXs9GXQvuyrok3e
47895	payment	1397	1397	1678	1	1	17768	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSV1XnE2VvkAKgAzzzZMPgtXCs2gik4k2XWbu9qhUnz7J2XgCc
47896	payment	1397	1397	1678	1	1	17769	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpSQ3xdi6dk31gbpQPRuWPrJYuiD2FPtafno5ZsmRLUzojnRF
47897	payment	2134	2134	1874	1	1	7871	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUBT71AxHcY8fQd14pYH5So1WcJreLAjzB5ibrsgrZCGDCRV8s
47898	payment	2133	2133	1874	1	1	7311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhd6SD72N8LBRK3yf5UK1As4m82uaHnb6ekDJ6QRSPNotxtY1K
47908	payment	1397	1397	1678	1	1	17773	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhKKDYycbmBmFRK4zDcbnLFfFVF4R8u5hpzWFpYbYHKro3Yzf
47909	payment	2134	2134	1874	1	1	7874	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6UyaMUnnY5fLjAX5z83fmL2Lzw4hZwTEq7jRMtwGNJhSPcgQW
47910	payment	2133	2133	1874	1	1	7315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr2h3VDP5a2n7CmTFyANL79n7eTjJe8V9vz5xvkqSGDhbNhGCN
47920	payment	1397	1397	1678	1	1	17777	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTtvRdoPdfok59WQBSJ33tXCK8k6P3ymrkBDT3oceqKb2hbF5
47921	payment	2132	2132	1874	1	1	1908	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDW2G7YZj1mn2W2nRvWLK5FWqsd3Z2yHi5XgZWoxjdidtWBvpY
47922	payment	2133	2133	1874	1	1	7319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZojEAz4DkaJBt9Wv647ft5imH78M1FeTUuqNGfJqa6DBUafQD
47923	payment	2134	2134	1874	1	1	7877	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaTht5mt59rDVEtADa36dW7kPfGwLLC4FntAiJiyF7nijReazB
47929	payment	1397	1397	1678	1	1	17780	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa74u4dQcxY2rfUc8JJD9WxarVxAiucNEai794eMKZSLfFz92mH
47930	payment	1397	1397	1678	1	1	17781	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgGCGNqpcZzWfy6unuawgjehw93RHj2mDQZm3UyQJwCiFnJcNT
47931	payment	2134	2134	1874	1	1	7879	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWDYcaKwTX5AvYv9UyAYjLnp82jXLTJ7w99RGjAzb9MwPuGta
47932	payment	2133	2133	1874	1	1	7322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiNwJTHYKQxFNNRVt6pgEvWvsj1K3PCfhqP1Rab9eGcvBAk6X
47933	payment	2133	2133	1874	1	1	7323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLZC3wrwh6Pmk2fgCdJ8a731qFGzgwVQ2iDNT58MDW5pZ7kjJ
47934	payment	2134	2134	1874	1	1	7880	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqMkJWKgnLd37CkzLdSuMPWkMCgBhpL8jNjQFfHGdGDqSonpAV
47935	payment	2132	2132	1874	1	1	1909	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuuRyoXTrtRMWaSwMhJzPxJ8JKwXtq3YvHK3Z6aNYDHZ2JkFwC
47944	payment	1397	1397	1678	1	1	17784	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTVRrJK5C5P9aKCuxbrJXVt1WyQmTQJXzT9PSEqWB8cXZuMTQ
47945	payment	2132	2132	1874	1	1	1910	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbJP6JnS8eFHCX41ssaewU5rpyn6SNHSyfTrcqJ9NLBsLznLP
47946	payment	2134	2134	1874	1	1	7882	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTCAxZXnuX9YqWhUR3juWFsYcA3hQ1JHDCZfPdCogSZRvYWpnT
47947	payment	2133	2133	1874	1	1	7326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHm521BPr5gqAri4jL4B42tFhGJhxkEKA7qsb4NzGX6XZjsV2A
47954	payment	1397	1397	1678	1	1	17787	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Y1mVyY3rdGoxgxsUe8gq59i9KteTqBfy4AKvgqExnMYy3u95
47955	payment	2133	2133	1874	1	1	7329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAcVPFSvtrcrmxVoCfbvn6kL4599M6ux4uhZhFSnGW9n1uwYPW
47956	payment	2134	2134	1874	1	1	7884	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWuhG8ukfP3HDZ5MosFPW6eQfsDSRd9CkjPngZ1zQxtTcYh9tG
47957	payment	2132	2132	1874	1	1	1911	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpKGBKNQo36F6u7TwScYn5wJHkT4m9WxCAVqiNMnWqFd87R1j
47958	payment	1397	1397	1678	1	1	17788	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUcnGxymDw6HDbochBSKf6nfLK1HntPswiBZ4R2aEkuLdWywF
47959	payment	2133	2133	1874	1	1	7330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFTiuhsvUipPZiJ3bNNM5rqNFt4ttRBdM1cqz7X1MhGeXyaYo
47960	payment	2134	2134	1874	1	1	7885	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyrLen4HAFMw784M4uzrb39L5fhWFzHtisa4N76hwu4CYB5NY
47985	payment	1397	1397	1678	1	1	17797	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe96LqvfQCYKXvHUzf9yvQsR2kgSmDVXkbN8Cy7LJkGAos1ivU
47986	payment	1397	1397	1678	1	1	17798	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyewPwA97v36A1Jb96SmKyc3dt7g7kMZFycKoJrnooUAM3ZoFB
47987	payment	2132	2132	1874	1	1	1914	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9TqwJt7grcKRPEXWxwKoGwaHs6VRFxz2zYPJ9TMKfgdkUXKv
47988	payment	2133	2133	1874	1	1	7339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZphE3cwufc9PLm9GhTYZKBH5HByVMCZa3JemVor6qaerc2mPfk
47899	payment	1397	1397	1678	1	1	17770	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxcp71onpFetSyNUJP19JkX4Bnmc56Wh216XdQ3EzVEsiYxgiq
47900	payment	1397	1397	1678	1	1	17771	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX59gXgR9XBLZan3kT7KGM4asrmwhzsWPpNrKVQ2TYj91qvSRF
47901	payment	2133	2133	1874	1	1	7312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYkRR8H6wYSPEUwzwQpYcUWTCJPD93NZo2Syj3YXUFpTJt95vD
47902	payment	2132	2132	1874	1	1	1906	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrkzFTPAFuau5D3r6Auc6HhkK1GnbsYWgC1SEZatky3Tw3b8v
47903	payment	2133	2133	1874	1	1	7313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa36BT95jRyB3eEuiEugCAp8mj76UpaEYpuMyRhtYgNGL2N3UTq
47904	payment	2134	2134	1874	1	1	7872	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDkQG7PRSMHe9cakGeBiLmeYC3L4KzhjD2Uc8A1YwL1Fajm9QR
47905	payment	2134	2134	1874	1	1	7873	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZauL2RgFKRdvtdFdhZkBEiiroVzUiFGkpxsjtEgtCBsqNpnytC
47915	payment	1397	1397	1678	1	1	17775	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBYZdrPsgJYw49NYfVFWL8UpU1EtouDtceEKHtMRXZxgoAzuWt
47916	payment	2133	2133	1874	1	1	7317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhDGeDDPLtRPFSL38dkR9nZsFy7LzfCLPXAQkqp9u8cCKpX2b5
47918	payment	1397	1397	1678	1	1	17776	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhg5AgWQYU1WAWAyz7AuKCQbSF52absC3PpRUGEBvK9ieLuKq3
47919	payment	2133	2133	1874	1	1	7318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD6kGNi8ZGTCiy94ZMwbFX2n6jBgcK1RVDE9TiBAdXti943M1Z
47924	payment	1397	1397	1678	1	1	17778	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7pp6jF6ytMgQFd1X5x8jZE24FsaGQkuFVnAKPKSKgc4V3He8
47925	payment	2134	2134	1874	1	1	7878	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb5GUJpuAy55XRcoCv1kiPfLfw7s2zgUDV7aAWgp6drFv4r5fD
47926	payment	2133	2133	1874	1	1	7320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2bF6ZmiigLihZYwTYoq1MzuY7bFAJaFRzEKBx3GwQ2n4o5Z3
47961	payment	1397	1397	1678	1	1	17789	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3RsHjzyDC9JTANMFEYugSGZbw8jbSospPgJLeFnRPFoRPCYmd
47962	payment	2134	2134	1874	1	1	7886	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxwTiLmuPpGEaubatksDhg6wGBgrhoGu698RZpiXJdEvaCWk6
47963	payment	2133	2133	1874	1	1	7331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAoqgsY1aAzwZBYZWv9Jjv39JbtFiU8saTmq74z55Tm4BdCGC
47970	payment	1397	1397	1678	1	1	17792	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwuZqLxJRccB1aqy57ifNs32jr1RBG3ifepYDWeXhH9WMiv47A
47971	payment	2133	2133	1874	1	1	7334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQcPpZhrY1a2aaG5YgFnjfosRB3YQmp3P9b4upD92vp63W3jBp
47972	payment	2134	2134	1874	1	1	7888	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwCfetGvMGrs8B4goFiGfiPZvHxz9quc4tX5oDWhRE7vod1My
47991	payment	1397	1397	1678	1	1	17799	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQrGjYLhHv6nHVQqYNY6ir72wbwfcV7ZJ4cG31SFkCgnh15rA
47992	payment	2133	2133	1874	1	1	7341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3H5P7U64SLU7ov5pa6VJt9amZpasHAbaUwcF17Eopw7JrqcPn
47993	payment	2134	2134	1874	1	1	7893	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhGwoRse6CMVrCQ5sQevLk9HgGkVHigXwCM3f34BZryUAWmPX
47994	payment	1397	1397	1678	1	1	17800	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwe9Fzgw7gsAcpSYXQXtBVt3LPjcx5RPc7HCxjwuR3LvuYiXFT
47995	payment	2133	2133	1874	1	1	7342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4n39LYTawfHtTsrtG8oc9chgfnYtg7Ecn3RayRnWRxXjPKs8b
47996	payment	2132	2132	1874	1	1	1915	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvQRPqpCHzAZU7deacdnTpz31egq7tgtyVruadnyNSRKqWaYW
47997	payment	2134	2134	1874	1	1	7894	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTo1yDgg3dJeRw1X8BnqncqvJFfVynGow2V2YihgAoFkTJ6fUM
47998	payment	1397	1397	1678	1	1	17801	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGC4To39QmW3VuRVU81Vx5ctD1KxPZsD7am8Xkkoz5B8MCaK7
47999	payment	2133	2133	1874	1	1	7343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4vA8vHKArjsi8ZG4LGk23HtNnqMzMjGtmhAoM722vWEX8estP
48006	payment	1397	1397	1678	1	1	17804	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvK3fBifsdthe4LLPZ7Pin5Exhcr7LAF8oQosWphKmKrZ9SSo
48007	payment	2132	2132	1874	1	1	1916	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ38oQTcr4rsEAVvzE5cFjkUNr9zF8p4DVzBZ7y8H4vvxEd4M6o
48008	payment	2133	2133	1874	1	1	7346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm9XKQmBEyAUb1kKyqKjJkspssyeiFY31HDdmdwjyzHGwoqyvA
48012	payment	1397	1397	1678	1	1	17806	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv5BGaQBLN2Zniux4VAFuPguTXpzb5UP2QdKVZtGzvoYzzm6eZ
48013	payment	2133	2133	1874	1	1	7348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR1df7n8G9vVvK4u6YykKakqbUi8ZXvhxfDZXRj74PD3D1Cw1T
48014	payment	2134	2134	1874	1	1	7898	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi1bCGo2LA7SuxsjxDFsbrLigHn2YomJvJTbkT3fF7Ax5HU5Cf
48041	payment	1397	1397	1678	1	1	17816	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqbvskXBuXy6ysU3CziccioTU4mwCkKNwT191tQQR7djE2gJm9
48042	payment	2134	2134	1874	1	1	7905	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCc17RjQ3TgNeySCHhbBSByATsApf9tsE6CGcNVt6XgvqeQWA
48043	payment	2133	2133	1874	1	1	7357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKCowf7ZKLGWPiHGNxAo3doiJajuHQ9vRYq8YPiXKD41Y41dzP
47964	payment	1397	1397	1678	1	1	17790	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfa2JU2LKk4BREZXisRTPNity3NgJCUB94TFGKueyXrrFFpwmT
47965	payment	1397	1397	1678	1	1	17791	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa51b3EgmEB6n5VNMjzRx2GqNbQDYP6AYNrF4wF5xLBqhKzC4Kb
47966	payment	2134	2134	1874	1	1	7887	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XnKhJHFyjo336GJ4Qw4FkcQ4uoL9GXPD2VNZwe7PvJJhxaKs
47967	payment	2133	2133	1874	1	1	7332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrZDuXMshYjNhJxmyecVcNeyXWdA5D67CNTcKUV5At52vNtHC
47968	payment	2133	2133	1874	1	1	7333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFsYPRpbRhUMr8CW7xNQAvTKc2mWwtoEaDyd2WRLo6V7SGH34s
47969	payment	2132	2132	1874	1	1	1912	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwZ7BbJx8isvfpSNvnTRAJesX5CD25GyF9p9KzZ8sGnQ7VTGi
47979	payment	1397	1397	1678	1	1	17795	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6N8QExjuE7AUQzujrrfhxqsXCeGJtvBK6bb62CncwUB9jUTYW
47980	payment	1397	1397	1678	1	1	17796	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAbGXoerHB2Hbu5rckUQ6M2sXKHwFeTyxnqGM78yCVe2AdpiC
47981	payment	2134	2134	1874	1	1	7890	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXU83eQxmTtPcPPSU6QPeLhXx4co9rU5prfkt2TTrsm4nQK7PP
47982	payment	2134	2134	1874	1	1	7891	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyRyfTuUeJ4csoxVXHEey9Kex7Weq1d4XMVvsBm2CjwhMox3xq
47983	payment	2133	2133	1874	1	1	7337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx6ThHka57BcU7hSRWCEwDUePznKrX7XJUpaPdzuvcb5FyheqR
47984	payment	2133	2133	1874	1	1	7338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgbqNdUvQLxHDiNtuZwR6ACN6Cw1A35QzhJNmevGkBGYiKtqCR
48009	payment	1397	1397	1678	1	1	17805	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecu9h4msQ8dRnVtBveNunYKghh84642QUUFJjX4UwBCsSszwt
48010	payment	2133	2133	1874	1	1	7347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHos3ATTbpTREdC9ioJUHZjtnG87cdJpzGBRzEmbbR3QbgNN2u
48011	payment	2134	2134	1874	1	1	7897	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9WjVkRceMi6rzWK1SpE2jJuqdrLEagmAQYc9CcNco8MysNG4c
48018	payment	1397	1397	1678	1	1	17808	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWKMaGGH44U9K7FuZ7NWVCfUjeMwVYYojEcxcACZJu7hkS3or
48019	payment	2134	2134	1874	1	1	7899	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd8YuTL9No2nGUXxtFHsPnC3RD8LVDQh8AzXo7QpTgohXUt99d
48020	payment	2133	2133	1874	1	1	7350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaABqskZEjozEriZXyk82vf7jMUtUN5Anmb1KgZwkfrqZhhE5e1
48027	payment	1397	1397	1678	1	1	17811	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTj3MVG9aZ6ges5KY5bVwqaDT4X6eknhzRosUrgexanPnMCe97
48028	payment	1397	1397	1678	1	1	17812	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZnxWorvxEzG2LGEg2RZ3RBzaDxFAXFSVCvaPbvVKYdAK1C6d
48029	payment	2133	2133	1874	1	1	7352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS73rebHd4FMyPeLv6gp8GKzRhdqWDiZLPPyaXxcYscGvZRZet
48030	payment	2134	2134	1874	1	1	7902	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWSwyXVp9G5h5dQnNhgaxUM3GrDHSJp8U8mKt4DLBSAyL7gSBX
48031	payment	2133	2133	1874	1	1	7353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbQ4BjPkMFAwQdi7shP4hYZsMDicKVTHo6CmEwYTm6HeXCu9fe
48048	payment	1397	1397	1678	1	1	17818	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUDwUYzPhj4Tbe7Fi9VeZsDK4KvN82T4adE31TfJdoxcjjiw7L
48049	payment	2133	2133	1874	1	1	7359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcAt9BuJ5Q5keMbaGPP2NQeVFgCpiz6jfVCdo4qjERdHXgtaar
48062	payment	1397	1397	1678	1	1	17823	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgCZDPwPpAyQk8vmRMHU7xaKUXLZPMHGaxaxkf2uHRsdD73St
48063	payment	1397	1397	1678	1	1	17824	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBN6v6SXfLSfRopBR6soQKdMLDcXMRi7eFHMFy6Zo225fkQ5bU
48064	payment	1397	1397	1678	1	1	17825	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN9iRdv1c1qEeXBUy4e7yStu4cuJ8enhNikZ5QuYQRkMTMezbx
48065	payment	2132	2132	1874	1	1	1922	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqoLrBEPJFajNUcAKhiN9xuvVRAjxJrQzMYTFD4djXUdsQFzh
48066	payment	2134	2134	1874	1	1	7910	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZoVDza8LnJDjTKUe35qW2fKH1AZG73ov6a9LnMHDtWHicfAU
48067	payment	1680	1680	80	1	1	12	1000000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZGJvkyP4RPz1fDHjrCJe9pPC58W45au2Ns3qUcaYu7sxVgPvDB
48068	payment	2133	2133	1874	1	1	7364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAHC5XcSMETiNfdPpzUHiPeXqsLzk7XkvGssT8FFJTNF5wpo57
48069	payment	2133	2133	1874	1	1	7365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVxbo3ebPN9eSXP3RxBh7HAEvnJ6F274JubQpqxDY7QTGtvFwg
48070	payment	2133	2133	1874	1	1	7366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhax7ioKjXziQH2Um5mJ5TmPsoVwxA4qeGVScFT27gSCWgPZZG
48071	payment	2133	2133	1874	1	1	7367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNqNbgHq6d6yewrgJDeiJ3Awa8LoubpinmG79FNCuTf1BPdXt
48072	payment	2134	2134	1874	1	1	7911	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJ8M2AEsjEaP53tAD9JV1Jx919tDFPNWGDbfKRsgRZv61Mcfb
48073	payment	2134	2134	1874	1	1	7912	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXxNosbGp1gBwDpwYoZp1ufJVmCRXuDeE4d1iFraPyq1nL8SfY
48078	payment	1397	1397	1678	1	1	17827	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhKf9Cs33YwDqLWKBDNRfTmcSS4HuE78SaGHX6GLiRn9wbEJ1q
47989	payment	2133	2133	1874	1	1	7340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6mWA98TNhxbDFr9XtUYfvgJEoiqaUs3UpyvVwEwZaTF3abGye
47990	payment	2134	2134	1874	1	1	7892	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uZfF4NP6fynmNKCtBnZeesVFve8mpWRnkjDEJiGg3eFZL1qb
48003	payment	1397	1397	1678	1	1	17803	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGSs2YmWD3zHZPNCu3NtskeLtdrEKKHyYKpLFJTvtT5omY2oZy
48004	payment	2134	2134	1874	1	1	7896	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzkxsqcR7N6rvmkyvmw9mQMjDV5CFNdjP311q8ruaX3q9STME
48005	payment	2133	2133	1874	1	1	7345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB3r1MuNxgwR1g1276ZEQbduTALuFzVGLPSvaZrDUbP9iWeT4F
48015	payment	1397	1397	1678	1	1	17807	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgC836FtGR16SNWXPHDG8BuSqAWMJ3Qvg41ai9XvFiYNTfAsQZ
48016	payment	2132	2132	1874	1	1	1917	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpiM3WUtwPh1smF2ngwb9txdAVVZq4t3gH7zRy7SDhJLgFuw28
48017	payment	2133	2133	1874	1	1	7349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnF4kYmApCJimRXq8qkAdqej7fkey7jvdwsUE5oERY9C4iTWC
48021	payment	1397	1397	1678	1	1	17809	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHoYd4rkSP8FbYgGnRXs5sPFVUCoAJ8ybneGDnEaKD44c3Byxa
48022	payment	2134	2134	1874	1	1	7900	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMMVHsNv8JubUyHN2LjprtH3PbTNc5TRghTpAYsmcSkVhEFmk
48023	payment	2133	2133	1874	1	1	7351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVUFGeUC6pGStzkmr6HbZbzpKtW6gzD8RB6cay1wtJBexBGY5h
48024	payment	1397	1397	1678	1	1	17810	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7L1rTMdSWMq3S2qoY7YLmm5vHo43yzHXWxgL5BH1e14eCRPt4
48025	payment	2134	2134	1874	1	1	7901	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwa2WEcxg4o83sU6X1ARyohAbegU3n1JsfbJgJK9JgqPKDMHw
48026	payment	2132	2132	1874	1	1	1918	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGCj5ZQQ5hurE27WAgs6yMwbkY7kcFXduMxFiZj2ys66nAchdg
48032	payment	1397	1397	1678	1	1	17813	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrV9VVbRw4FFE1CCmXKgJiKVYJwTGCAfcW5jYbEKCfZkkhTZFE
48033	payment	1397	1397	1678	1	1	17814	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSzJ7qNYG336PPYYgTMycDo19Zdisq5E8dzjsuVzfs5mgrHuL
48034	payment	1397	1397	1678	1	1	17815	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXyVLVKjyfTwkSub5FCznMce8hPonKzva9nBF235srMZCCx8KY
48035	payment	2133	2133	1874	1	1	7354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgd9WRj2L1UwZ2zKM5Smsf7mp6p5TDWqqauQLS1A662KwxMtA
48036	payment	2133	2133	1874	1	1	7355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVo7JmkUR5LJXvffRDVDAFr8z5k184rBNWGFLEh92qXowEEi9
48037	payment	2132	2132	1874	1	1	1919	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCu3k3P4BT4FAQiRoFbK3t8o8ob8EY9BHAT1FKkZFCN5H2qhN
48038	payment	2133	2133	1874	1	1	7356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2FJeg72fVzpeHF8R2JaMvBw7krHDbqjSA8wkfT3nCpHYxZ1Z
48039	payment	2134	2134	1874	1	1	7903	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnVbpACBJtwNm5nckV1WpmrHjS6HoFqYEknAsS5zCdLAyU1dA
48040	payment	2134	2134	1874	1	1	7904	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyFAGP2xe1RgwWBRhDnamTsiTBbcpM2pja3khQorkwauvFPEez
48053	payment	1397	1397	1678	1	1	17820	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWs25JnWzXWkFogkU2DjKDmxBfxyajmRWCjojaEf76RDyd57Ui
48054	payment	1397	1397	1678	1	1	17821	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYTVUhNcGE4tRkfxvRoKxBz1cnmnqytB9baudqnCksw4VSpMvL
48055	payment	2132	2132	1874	1	1	1921	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZazeT7MzUhs37wDGVEEb63XHQQ4Gsk3S8GojfBe1HoqQnXp6Fu
48056	payment	2133	2133	1874	1	1	7361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZihgacRgGnKcibbrq58if3UXVywni8FgGbtVnfTxop5yWu3kLq
48057	payment	2133	2133	1874	1	1	7362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhW9uM6PpwSt9HNJj7MkHxKNf82SgnPq43P86h4N2nQTyauTwv
48058	payment	2134	2134	1874	1	1	7908	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfcR7CtkasgwyEMvDfgmWAKYFnfc9sBWaGcTSCPJuEAttWiV5
48059	payment	2134	2134	1874	1	1	7909	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ9rDpCufRRCEXJzCuwfd336vX9HPLK4L8EbWUJfB8F5RYbFb5
48092	payment	1397	1397	1678	1	1	17831	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqGwGkzoE72zkhryw9Dj24WJcjQdje55WnmcM4jx5LpzZSetjq
48093	payment	2134	2134	1874	1	1	7917	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiHjQsS5s1GsWVycj3fgpHHov7i23a4DkjvXmtXUetD9DVdLG
48094	payment	2133	2133	1874	1	1	7373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWtuWrzc7Z1HL1Yda7BYTAYHrKP4biCfbo68c8ErArqAAoGiqg
48141	payment	1397	1397	1678	1	1	17846	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3cztxvmPsMJ6NvVGP6tPuF5LX6mEjHFxVSHNMWhMN5qpcuzx
48142	payment	2132	2132	1874	1	1	1929	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyToPRGNBn3oVMAYS5BfPqCMEfvyfsu1DDyrHEU6uXZ7nHStj
48198	payment	1397	1397	1678	1	1	17862	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdsqrp8QwgevsTEkHQvkJaEsyac9tqqDJZDCCRSLQFA2Jsv7V9
48199	payment	2133	2133	1874	1	1	7403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8tCMZuxzTHnNeQb6ZFCaMSKzU4cmLHxGVY4xEj2FVKuAkAAt
48209	payment	1397	1397	1678	1	1	17865	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPFwDVeLNkrif6hqwYyA1h1swnVS6DXcsF8nNSAUjLGwbdtpCU
48045	payment	2133	2133	1874	1	1	7358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQVrcrMfQit1NBTkxN3x7V1c1x8g5bUoChFw59jAHgs4CWutf
48046	payment	2134	2134	1874	1	1	7906	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoxptc4C2NgpJKcFRtLf9ivuWot9WwufYBtvrfY1QcstpENL89
48047	payment	2132	2132	1874	1	1	1920	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa81bVyHFSPqSbxL6nRQ2MD5FmJBZMhEqypDrpEft6bSYZiwPNZ
48060	payment	1397	1397	1678	1	1	17822	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFH3FoDtbukpHqbDtBvEvKxKPRKmTtHKfueqcfsKVBR8w7hCnM
48061	payment	2133	2133	1874	1	1	7363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk7bJVC8YjJqw5C1hDxrvxQMiBVoJMNDguujKBEbLfRX7doBW9
48082	payment	1397	1397	1678	1	1	17828	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq97SfgehJ3dnPVJSogSsC2wxRAjuCkRgKe4HwuatvR1cGkSga
48083	payment	2133	2133	1874	1	1	7370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv342WLERDx5zyuMSprVLG5C2nufLD3BhHAexFXU9ZSdw4kGcb
48084	payment	1397	1397	1678	1	1	17829	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ABRQx4QizVR87mvUPjBspSreQVJAVDRKXiD56Cf9WJeSbhJ2
48085	payment	2132	2132	1874	1	1	1924	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHjtNaNEUNX3PDCVSimWUqesPiD1weHT4bDeP8BXssqgubvK5
48086	payment	2133	2133	1874	1	1	7371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcCvbVWQyXCNUmdbtoiXL16HGDKH6Y2ecQodFC4jwUCx8zV6DK
48087	payment	599	599	613	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqZoNLQsywohCy8mHZGwpUwpMtM3FG3A9vNeDGLQbozgFwKUA1
48088	payment	2134	2134	1874	1	1	7915	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxxULfD3F71GWEGCd7nFauKw8YG2NUsFPrrUa3GKwQiJLDNsgA
48111	payment	1397	1397	1678	1	1	17837	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHpV6KPgxrGz6wQrG8ijoQaTW8eX8iJnA2UXGBECczzUXVZUM
48112	payment	2134	2134	1874	1	1	7921	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnT4xc6kNerUFHPWFHb6R9NjAAizomgYEs2sGMrRGHKi37D3nj
48113	payment	2133	2133	1874	1	1	7379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTYi9gprdMRBbWmC6Vro9hPtE12VvUuWRLWE69HUW7CcopLmn
48118	payment	1397	1397	1678	1	1	17839	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmedmLxYbdQ1FnRNw6Dd5Dm26XThfqfwweoYyAL8E4JYXokpr5
48119	payment	1397	1397	1678	1	1	17840	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ5UvHppqjKgfuUK42YQGxkJCHWmVWUDm9d5PXDCmJFcTwqh5B
48120	payment	1397	1397	1678	1	1	17841	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzGs1BN3Vj9V3Dyz7JLU145C8EUBjBPGmJpTpRnUafYgz5SDK
48121	payment	2134	2134	1874	1	1	7923	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp7jM1Mb6jpY5N3tdzXBQSJp2BjhQpM15xVgd6drcXwWoXxaZX
48122	payment	2132	2132	1874	1	1	1927	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mFKHr4LBwAAhV2n49Skyi2C3kgqevDrcws5sF3NkPaqfHmKF
48123	payment	2134	2134	1874	1	1	7924	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8paWyQTu5nn9j4oYuNJpL5TP3rmGvtv2RfQuFY9mYupSXmYb
48124	payment	2133	2133	1874	1	1	7381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7TevQWE6cAFZ7rJcLEiMa3PXBoHWaPNZ7VoTPGDMU1egQC3Wk
48125	payment	2133	2133	1874	1	1	7382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpze1cZ8RhkC48J6Ng7eLzGHStjQYfFuuwvEh2Bg1FDdkhGFVZ
48126	payment	2133	2133	1874	1	1	7383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZWtBqcAVj4DqVFdNyTBwn9AW6Yz3CWPEhQF8knrjR8aHFpc6e
48128	payment	1397	1397	1678	1	1	17842	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwVjG83KM3sgAPCuSFZi9JfxQ5pVYb6QcwSqgPWjyCQUPgHHkx
48129	payment	1397	1397	1678	1	1	17843	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU8NmKx9SowA1vcbe93CAF4WvEeZPf9a1tAoHJXw2DE5wgG8EB
48130	payment	1397	1397	1678	1	1	17844	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2rGr8PPW24xJVHhdBAZgUfr3yJ12E2w4XYQ7xa433giN4btAP
48131	payment	2132	2132	1874	1	1	1928	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1ucocLCjFX6755UC7rC59AToqB4X9VCY2KJe4fpdZfp8F1io
48132	payment	2134	2134	1874	1	1	7925	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYggeFo6p8mz9TUZzJbAocQ5bZfy1qaSWc9vCtpP5qeUnYceiBC
48133	payment	2134	2134	1874	1	1	7926	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeaZfo9TriyDqBwSSCJgxG9rmc8xPMtmujunEFYaSHBTYG2EXo
48134	payment	2133	2133	1874	1	1	7384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhmRe2mgSxbkB56nt6P3yb2AHkuiGHBN366DWbqxQRjGukJA1N
48135	payment	2005	2005	2422	1	1	0	1399000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuMcvaepWTCSMXXbxLxmChRYVcWsmiZWHuy8GLQ1DQVxmZWPBW
48136	payment	2133	2133	1874	1	1	7385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa93gicJoJoxi4PKQ1ZV2QFtiR21ay4XGxy768MnW9Vsng2K5ET
48137	payment	2133	2133	1874	1	1	7386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7kve7UChfGgzTiJVQ6vwwngeNTPEUa1Ydxx47gWrTLgdUxTEX
48138	payment	1397	1397	1678	1	1	17845	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQS1y5PG7chyisGRs7vxmqmY8mxJP2xcfMEpmEG9o1r7wYq5Cg
48139	payment	2134	2134	1874	1	1	7927	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpASxH3SHzFD3J4GoWdKaiHZwtJVtXi3KhtycWn2Ny6skib53
48140	payment	2133	2133	1874	1	1	7387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3fDiXSG6e249xSqPFvs2mCnDu9KERoy7WE8hGKKHSybHPPH3f
48155	payment	612	612	2423	1	1	3	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd7GH4ZLrCViRcagMww527hsy97PLyaB3RwKAh6rDJb4hTUkEE
48050	payment	1397	1397	1678	1	1	17819	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGo7WruqwSioMh5pxqNzgNgTNxj78MfPnFbGMaUmqTpX5g9xPU
48051	payment	2133	2133	1874	1	1	7360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzo8oYeEA8ChvYBRTjgtsqj33Ey6BkHXiqtyivD3Z17RhZhbHH
48052	payment	2134	2134	1874	1	1	7907	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk38GkQDxGS5a2Kd1VqcntBmvKRPyfqCjZrQV9bM1iaC4SEfp9
48074	payment	1397	1397	1678	1	1	17826	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS8j9nov9VfpeA8UcLfF6BSaEgszC5CQzUR2v12VV3UqZ2xXta
48075	payment	2132	2132	1874	1	1	1923	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqDtbmLaPb71FFgskxqgnvyLA4jTEkWwXCxLgXqPG5F4yiJqN
48076	payment	2133	2133	1874	1	1	7368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVL1nneiu2k15rDfddzQgm92zHzkgfvmSiSR5ZLeBMyTm7UY1
48077	payment	2134	2134	1874	1	1	7913	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz1qixFuVY6e5WSKLBFtTYgonXSq9yUgNEPXF3UjqvrPjvGdm1
48095	payment	1397	1397	1678	1	1	17832	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFho4nktCay6GX7riPAZHQCH2yGFpJuFmANXDjc5LFnTg3Jg1
48096	payment	1397	1397	1678	1	1	17833	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNiMH5ksrZWjQfAWesWjWVoNRhj2uVFCJCcsmrPBVgxGmamXb
48097	payment	2133	2133	1874	1	1	7374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa5erWK2JqkSQNZntvKhBU9M5DxsHgZxaLbBdMgi7Y3ysgdCu9
48098	payment	2133	2133	1874	1	1	7375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRhTfVQYmS58Lwn51Zck484DYiNpDN8ZZBC2BK3EjGbvv5L1z
48099	payment	2134	2134	1874	1	1	7918	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPiCJSmzBxo9MCidbpiFP5bVpzv4VTEqQSX5jQ68LfBiJir9Ke
48100	payment	2132	2132	1874	1	1	1925	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbHcxdy9komrCs9PjqMLptcSU4g7igH6s42jAZoy9PmS7BWjuu
48105	payment	1397	1397	1678	1	1	17835	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZtLp51en3LzqSLYXuNpHDDMutjaVMSkcd4Qb2wBgHnyuTgEb
48106	payment	2133	2133	1874	1	1	7377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvDEBowYhaQGLegCP2fvnZKV1bSEnGmSmD9CPA1Mb8fYQBQFz
48107	payment	1397	1397	1678	1	1	17836	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSbr4PR4t2yKX8kSgmPA7Fhra34X21Sf9pbEAnHaqZ5e1t8DAN
48108	payment	2134	2134	1874	1	1	7920	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7YdVMQ2qtDfuxHnspFnudjZPScfMKcwuoRn7pH3uZGr5Zfru
48109	payment	2132	2132	1874	1	1	1926	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5sVd4x6wWrAWBYss7NRKsiKHcbEQpZftG9KzUoWZXHWR8fBN6
48110	payment	2133	2133	1874	1	1	7378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLCFW7nxwBeu4qvLEbKdwjDKMtkB6RHUhPApzj72rKiU7PE5h
48146	payment	612	612	2423	1	1	0	1500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUwp2ma5ovd2r7vrB23kjz3m3gwDTAhPbLx85SMzXRALA7BWzS
48147	payment	1397	1397	1678	1	1	17848	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmbgJ9jxmUGgnNRTnkfp8NXxR6ktHiewuWWt6nV68fygvmjoGM
48148	payment	2134	2134	1874	1	1	7929	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzGh64oAUQcys9FfvNws72GtnDBtsQhwkbhauTX14LNvHykFE
48149	payment	2133	2133	1874	1	1	7389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvNLq9kF3tVt6sjdYK58zZzDScLYNu8oiHFxk43EBqxZZPqhA
48170	payment	1397	1397	1678	1	1	17854	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCmGGxNJGBraxKN16X5CozsQ5ScEmNEyTSj61q3JfKor1xhze
48171	payment	126	126	1776	1	1	0	100000000	7750000	\N	E4YZZmcVKrYdUcsr3cNXsNmLwTo7ML1CR8t8534rm99wpe2Cck83R	CkpYpwtTTjRhUF5Ho1BrvjNm4njLJhpufgBZc54tD2G3vagQhEveh
48172	payment	2133	2133	1874	1	1	7395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8gLoGrHmuj4RgtfB6qYuVVU2uBY2keqWhgRJ6tVWUssdvaYap
48173	payment	2134	2134	1874	1	1	7933	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdfcfBfiCFEKcH7F8UdWiryn71E6sdrCk3sb2iV36JtjbC7WZw
48184	payment	1397	1397	1678	1	1	17858	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXSb11PGWy9Mi6r8ghkfzr6TxrRc48bQ4nZWpBibxNCxzWTpb
48185	payment	1397	1397	1678	1	1	17859	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkWX1Cf6Pipvt6ZjJ3AqVBnQSr8qgtdaEk2zSX5FGUHhCoiZxv
48186	payment	1397	1397	1678	1	1	17860	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBDAArDDYw7yNCWEA5hwfE3LwAgQYvFfGcpxGS8y3LqtFEBDV
48187	payment	1397	1397	1678	1	1	17861	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSJwHC3A3bCJ56KHefJQ3dAhdxEeFr1pVccJgUy3qQkxgNNoPv
48188	payment	2134	2134	1874	1	1	7936	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPsyPdCCV9UtC1MjrEWvBV44KfaEgfHDpkxsa855Da3mf8AX6
48189	payment	2134	2134	1874	1	1	7937	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3n3q9W5VaCBf8KaE3zyUncBSxBdUzSftqtdAQRMunfyWFwAgA
48190	payment	2134	2134	1874	1	1	7938	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd5eiKmMhmv7JYJ1U1gCZjWRry9j27pi15abmMjTQgHDEd2rsv
48191	payment	1726	1726	2424	1	1	8360	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqJt337x6mtcrJvrU8Ex952dUS4aUGnZ9EfYH99BahvBTtyqry
48192	payment	1726	1726	2425	1	1	8361	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZDqH9JaXvFyZmGCfGDm1DqF68j1Ert9dcjmzT1yuWe7E6rZKLH
48193	payment	2133	2133	1874	1	1	7399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxF63FayVJkpSv2jgEqmBtccqRC5GFbtzFRqEWuSdJ6H7ho93r
48194	payment	2133	2133	1874	1	1	7400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU9d9hB4EZRPrK4j1bci65k7CM3wC8kBxPqzw9gKgUy96Fm9fR
48079	payment	80	80	1993	1	1	0	500000000	1000000	\N	E4YiuukfxBop5pn8WEtbJK43NnkgssdFF5RTPdQRYSm3GckdX9BBP	CkpZbkbi3ohPN5XC7k1mFRwEdmNZTLifq8sSyukxEZrbsDx5gdbks
48080	payment	2134	2134	1874	1	1	7914	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2W6Mzjxzwn5uqPzacYZEnAoXnxGK5tUhhuy6E6AXLHxJxkBz
48081	payment	2133	2133	1874	1	1	7369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRk7Tki7URuPcouf4YM9Drj8rBfQYWYtdeGgrAek3kgGkbNhD
48089	payment	1397	1397	1678	1	1	17830	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBfjJ57Db166NGABpKNsrocK1bosi41XCik2BF1SdwWMYTfXKZ
48090	payment	2134	2134	1874	1	1	7916	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa1Pn8kJKQJsUZjwQUxjqSbeA6NtPwLt93WkjDBAnLxp64QAoh
48091	payment	2133	2133	1874	1	1	7372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr7QZ9rtNR6fJHZv99PUK1oAkT9chRomtbBX24jwojrL3BjRqs
48101	payment	1397	1397	1678	1	1	17834	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVDcXBMePBLccwSo4tvjJDgmMXHwrNXjSGSTi3eog5xdFAD68
48102	payment	2134	2134	1874	1	1	7919	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4xXHZDY2J6pZy932CUTD4Guc6nafB6V5Hwc2XeQAfanYV9VpJ
48103	payment	584	584	2421	1	1	0	335083938283	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8XGBad6yQNvoAVuF7GJYTh7eBVRCSTYcuyWpJMqWADAeooMBr
48104	payment	2133	2133	1874	1	1	7376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZceifLJ7jBWrKJDBkDet9RW9tTQMVpHx8ZiiAnQHPP3xtqdSo7
48114	payment	1397	1397	1678	1	1	17838	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYY8Hq1LJfRTaddWBkQ7LmyXGUiNSivKZxvS1itfubNfaQrbZP
48115	payment	2133	2133	1874	1	1	7380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTybTieVZ7LnT43vUyp8NFnGgPVExZXtUmR2yh5wNGnENXzxk7
48116	payment	584	584	2421	1	1	1	209424788612	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqHvGcwJ5yqQBaVLiU9u3SaiGmXavwBjGRUgUjSeopymC9VtwF
48117	payment	2134	2134	1874	1	1	7922	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUDqLkpAvh7L8gdEGSG22erWEJ5Xc8KebWMQ1DV2iq3rDgXtE
48127	payment	511	511	1684	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULcrmhEAZjURk5vJ2f6szoZ6KcuyZkNENA8yYzYkq1vTqmbDd
48143	payment	1397	1397	1678	1	1	17847	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1WwTWSkC59b6pvQZ8ixeR9LWJTbnS9fMpCn1TGCKzbTku3nsi
48144	payment	2134	2134	1874	1	1	7928	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmYz1aHbpcgCeR3QDgni5KqjM25WToLxWXpju4ygQY6AM9qF3
48145	payment	2133	2133	1874	1	1	7388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5H3oyvUcanKMyBgFpGANwLGh5S8i9oRmXk9ZUJBC49E6wyTBs
48150	payment	612	612	2423	1	1	1	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xUoziFJy3VpF65gq3RGbQ86KT53LxSGwUW44UHuX3rk2yG5N
48151	payment	1397	1397	1678	1	1	17849	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEHvxRWfroKATqRzTLqGB3M9FC2W4q13uS5p2fTbjCo6eoALw8
48152	payment	612	612	2423	1	1	2	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFtSNTWSXnW1cEH86wbzVLy6NEDN5KjTfeWDcQ6feBEy5XmVh
48153	payment	2132	2132	1874	1	1	1930	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYVsAFnfNApvkpcY6eUopcgiwLLKft5mLe9iszuNvFzVX68L8k
48154	payment	2133	2133	1874	1	1	7390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPE2zHoVYxLHDnWadGm6gaAhYnhibjey5yuGZRMewS1WpdR86t
48160	payment	1397	1397	1678	1	1	17851	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AC6FqDNxkxrbdJ2X7ZHzgnruijGicvbiECK2YoHF8ntbb8gj
48161	payment	1776	1776	706	1	1	2	1000000000	7750000	\N	E4YXduXJHkJWbj2aj8MY5iDLTLP4L1Z74CyygDamEbNCwiqE9osDV	CkpYuNZtv4WWr8BGDeAyHjW2qusTa4YB9sz3mcRvExt9bTpAKF3Dm
48162	payment	2133	2133	1874	1	1	7392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWD9bGymBEyRp5Qjr2LyiNPfEXEXgnBB21StiGPHVFwaEuQxL
48163	payment	2134	2134	1874	1	1	7931	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3VfpLK5CsZJzKTrW3ZyeR2RUCkgfCQKWjtoqstFwCFUe1uEED
48164	payment	1397	1397	1678	1	1	17852	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQD3SmgpsZz6oyRDpQqXVMpgkzC7FP7zZBY5hcSQrWQx5teuQt
48165	payment	2133	2133	1874	1	1	7393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5Dy94FdJQ2Mo6HPufm6Xn5XJJ2P78KBGL3d2Cx4avJUokz3L
48166	payment	2134	2134	1874	1	1	7932	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJHj7fYWuuvd6qRcY9oYA3VWD1DXmAYjvdr6kQyYFEkECzb9y
48167	payment	1397	1397	1678	1	1	17853	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRaymjt8BBrtuSaJaTdvNvywGLg8AAXAuR5Ej4HAdVZxSMzoZf
48168	payment	2133	2133	1874	1	1	7394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77CHLRYefhXJty2WShQJWTzJiMHuEuoKrNDFw1HEcE5kxMgaH
48169	payment	2132	2132	1874	1	1	1931	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtKCr3sUcnUpC7SupU1y63mYwTrYXhX7bPc5vBDwr3ujyQsM1
48174	payment	1397	1397	1678	1	1	17855	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd87nKakBqjXpGxYUovHGWH3GnXUiaGPcKcgibL1nqdLdsp7bj
48175	payment	706	706	1776	1	1	0	100000000	4937500	\N	E4YbWWnimtQ4KfUMWm8a3cY6BghYRodMf5MV8y8qgxrgMzuVz5jyb	CkpZLFceWd7xBxMTAjmiYCogCA3KPKRtLSVMUmNvka4aJKcptWCvo
48176	payment	2134	2134	1874	1	1	7934	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVk48Y5DodGpeAaRwnnHWhsQtHmra3oee5PeMCihc6rCmTwurk
48177	payment	2133	2133	1874	1	1	7396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTwSaf31u3bEZwmaUn9XwMJfRWWKPdYJiiMSpfLf3DGBEr52L
48181	payment	1397	1397	1678	1	1	17857	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQPahtZuSFbMF724tM5tmwWKbFzvm8pjqCA2Ucw1aoaKa3K6tB
48156	payment	1397	1397	1678	1	1	17850	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuGEDABceXCBmHbTnxgxgP5kL4CC1wLRhssVmSbWpxF1uQgPuU
48157	payment	1776	1776	126	1	1	1	1000000000	7750000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	CkpZ278Rfns7CyW33Qxf2ghgAHn4CSdbPHKDxpRxc2VWFn8DBNFMb
48158	payment	2134	2134	1874	1	1	7930	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEVwPYyKGhriM2mXudBMx8bgL5rp6peWEYvFCNBGkAYoncLocY
48159	payment	2133	2133	1874	1	1	7391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUVmj5AGjnkvdLnVHTg5op2Us2P4RjpBnSQyPY8jqWCyAvdDDx
48178	payment	1397	1397	1678	1	1	17856	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH1BWrGL9ynEaETjZq9Te7qmU5rgyJKg3o7fMURAeAyZU9Un8C
48179	payment	2132	2132	1874	1	1	1932	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeTZhr5nWSZypsvaFvyfG3YbEJLoBfLXQbFRTu67tuXPDDgVsc
48180	payment	2133	2133	1874	1	1	7397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ7uJjD9DwpayUB1FacdtTAeGHqGKqZDrzKMbLCZDsgjm8XqFs
48206	payment	1397	1397	1678	1	1	17864	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2JnqPNTw3DjfBTUVVENk2JDXsZXXxMBemEpkxVSA8cFAw9uM5
48207	payment	2134	2134	1874	1	1	7940	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6FSStLbr7VmnqQorU8fCp2cw4NosuHfekNjNrSwPzJ4rRwCQ
48208	payment	2133	2133	1874	1	1	7405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ2uDqBnQYgSstGSTuDNCUw2vCdoPMWFW1ankiaC4uifpBxp7p
48237	payment	1397	1397	1678	1	1	17874	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnw7675SfNn1V5RWK2ojbsoTv7frq6AMZkwaFGBP2j6TKw87ed
48238	payment	2133	2133	1874	1	1	7415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWh7iGdSYUMsgWHm4h5bXa99JnL8edyNAkKNDZgxCuEGAGYu4u
48239	payment	2134	2134	1874	1	1	7947	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTx5s4mKAx8gfNtcAjgvjTvrAPJ55FdSfSvYFhq5A6rqfKniMe
48253	payment	345	345	2402	1	1	0	50000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQLQLLxkeSv2eDdh3zk29WH9mR1tS7Ah1xoHdwYiAQ3DPXESnH
48254	payment	1397	1397	1678	1	1	17879	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSq1MDqFh1sagv7aiWTtBprmQa95AVTZzjnMZm7ZMcZMbUqWUo
48255	payment	2039	2039	1445	1	1	6	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsKcUPFnjtNvJpyo6tbtTnb4FKGKGCSPwBZpNg8UvejvX4hyg
48256	payment	1397	1397	1678	1	1	17880	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJ18F3Pj8dx56rmqJZ8tytpE9aMNVtKFzYfRSkJ46ccgjk3y2
48257	payment	2133	2133	1874	1	1	7420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSc2MvuSAYd6MWs46k1kwfAeHCvdaGn8rngfvXcLNggy86B9MP
48258	payment	2132	2132	1874	1	1	1939	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMSyFVz31pZegyTBwUoCHz3CBbtrQELpeW7NkEKsdPR8eBGhr
48259	payment	2133	2133	1874	1	1	7421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5c8MY2929EvhPUT5DZt4qrgPRP7UNQX7TDx1zPRmX8CdWNN5
48260	payment	2134	2134	1874	1	1	7951	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVTX1mTb6SktqLt1gMdorKXGC2EDXsdJsTXYNEbtbBAJabwa8z
48261	payment	1397	1397	1678	1	1	17881	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjzRMVtZeHFxokvNC7vBsnN3f644SoXykK8NC5WFWZ8nU79XLt
48262	payment	532	532	1724	1	1	1	1000000000	6000000	\N	E4YVhAM4qf5uYB8UvjeCmHg198EdPXa8nPi64oqXDW18YAb7XZRSj	Ckpa5Q2bcXZ6SGnhbzAEUVWWxaTtNkskVKtqVDm6KPZroQFGQpkH7
48263	payment	2133	2133	1874	1	1	7422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Yjbeq2Qf2HN2KaRX7P4LKvtBb2rvdP5Rpm1KXMiEmpS1VHUA
48264	payment	2134	2134	1874	1	1	7952	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBGvUemi3fTVdh8mS7hSC8qrn182r4LHNup49GYGan6vgWPyPi
48277	payment	1397	1397	1678	1	1	17885	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvHWxq4QXHNYPCEp2a42bw9rYKyKR9hjz2KJTXPVj9ep418h8
48278	payment	2134	2134	1874	1	1	7955	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsqwG8tXUUVx154oDtaHdcaQNdHu7WW2w5fvQAGB9yQwEXG9d
48279	payment	2133	2133	1874	1	1	7426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZthSs2JSZG25SRAkMoLXEfb4sSAnJsayWznR4SDbdaJsPPeK52
48284	payment	1397	1397	1678	1	1	17887	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkNoHmhSEvUjTDL39sQGiySiazfABkT3xYhPXATSck4saY6r1G
48285	delegation	2426	2426	1507	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRMczm9fhE7QRsoHvwVXrXPV9YH4YmAr15xnXgH3Joy7kAMSd
48286	payment	1397	1397	1678	1	1	17888	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa796Q11UTN9FGH6gij6kooF3hd4KxeCYhLWux9xfir6oW6ow6T
48287	payment	2133	2133	1874	1	1	7428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqQM6KVLBNYLkCKSXgArWdMXt7ibKTqBgCBPtQJcFYVVCMqH3F
48288	payment	2134	2134	1874	1	1	7957	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZdFQoUKf5aQ7zPr69wwsjWQAcKCTpFiTY27ytZfJRqZirzaj
48289	payment	2133	2133	1874	1	1	7429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4ihrx8NcR4wm8Wq7K7RoTnTGgxmtWkngguWX8d8sZ6pVq3rZr
48290	payment	182	182	2298	1	1	0	770026864240	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KrJ4L3tHbk76RFVfikAgaVJ1D7crQp5uCxkXTkHBGdRj8KTA
48320	payment	1397	1397	1678	1	1	17898	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9ftfZo7xi67jwxJLbgL62xMMMbw1PxkFBpcKZGX5U3NckP25
48321	payment	1397	1397	1678	1	1	17899	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6jPLxgy9FKBrTqgS4H8u5mqZSA8Hn9qn7jKyDgVbV2edPgURG
48322	payment	2132	2132	1874	1	1	1945	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZTjK5LteqTqy5AZ7aZyQuWH56ZC7DNXujcgBSsUrXzuBS2bXx
48182	payment	2134	2134	1874	1	1	7935	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Wk6u5iCAT56dkGX4XTsKeXfwYDei5kXYbnQ7y1YHd7YS9FRc
48183	payment	2133	2133	1874	1	1	7398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6s7Eznb6dB5bPybXwCX4kQGax4CNB1U5PLYRpgzzV8VtLe6Hh
48221	payment	1397	1397	1678	1	1	17869	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRPiYzQNg1TSWnS8kdZp1WxtKR676D9bVrewJg69uUvWbZbzwU
48222	payment	1397	1397	1678	1	1	17870	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbevYxRC1N8NPVnvo6XdTSHM7N39WpxQChwW5zbcStEoU891Qr
48223	payment	2132	2132	1874	1	1	1936	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmy7NpbeKgbsAeJm8t5iN3bqm4NHLpgwJoHeSyAwtG3rwP3m3
48224	payment	2134	2134	1874	1	1	7944	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN3Mmd8VspHY4uYA9pK469oxD7F1dehPm4y6Xrk2Sgg4pqqKyC
48225	payment	2133	2133	1874	1	1	7410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8PL5o8HoYP6Edxcf4QjwaXRTCMSTdT6F1r35fPn5KgBYijSD8
48226	payment	2133	2133	1874	1	1	7411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE4otPDKJLr55XQVyod7Yd576HTKQ5jxGewnGQ91WBHS2aZeh3
48233	payment	1397	1397	1678	1	1	17873	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ5xPEbAsKCkUnVA1s14LsEiP7ezEBdQwApMr1vAtkHMj8Dw9G
48234	payment	2133	2133	1874	1	1	7414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvYqMJWX36zFzPZyuFECn3Rui34YvAHeMd8NzU43AdkFLPMxzh
48235	payment	2132	2132	1874	1	1	1937	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW9g13oNfZ2cAjezNLQ53wAaheGRDc3wvLPNz5fkjh1YsVx7Gd
48236	payment	2134	2134	1874	1	1	7946	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2Z7nGrCacive6BVsAQzMNpa5v7gULbqXnuF1wQ7qFzGj483K
48291	payment	560	560	560	1	1	0	10000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqAWBqkbh1szccnnhnALgrR1uvzKhvJQnsSFCaNum9GsYisPqj
48292	payment	1397	1397	1678	1	1	17889	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEXgmAJwvsoidiBjiWhzcGcVQ7CVM5Geiu5mNAKH4ZEg9MMUM5
48293	payment	1397	1397	1678	1	1	17890	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Bp7tC1JCE1heGHhoSyBNg3s3WZjmP96odTwNUtGFyKvRnwFb
48294	payment	1397	1397	1678	1	1	17891	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYStTJ4s1emKGoQbVZQynw3p6p6TKg9STtchgSbLYpYHCM3ZRYx
48295	payment	2133	2133	1874	1	1	7430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde4NiYyWeqLAPM1B4iQUUwfeKfptVxigdNn9RxENToBoWMGwG
48296	payment	2132	2132	1874	1	1	1942	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETn1NwSKodJgdBD4QSfuEYWzKt8UbvB8gah2SwdT4wpDuu9k6
48297	payment	2133	2133	1874	1	1	7431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZbaYKLc9SF6oAJLTXaveciURaAzYyqURSU2ejHCy9kxy1tSG
48298	payment	2133	2133	1874	1	1	7432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8SjkHKBiXCEwBh31ZmbEfgK6JttL2YSRwLmNf57uyDJ57VP9g
48299	payment	2134	2134	1874	1	1	7958	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN7kDcUeH9s4j9CNm4W5u2iSDZuBBkkLpPGA1SXbLu8fTDYUeA
48300	payment	702	702	2298	1	1	0	513350909000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxAZvxyGTqni6FNTDfBNWkFLatn3qoMRG2GEs6XVoqrrnUDww6
48301	payment	2134	2134	1874	1	1	7959	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzaUyM2PJCFCHt9U56ASFZWfDm28fQm2eqPWyEpNMve1rUXirw
48314	payment	1397	1397	1678	1	1	17896	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyzevq5ZnxLZVJdV8psm42XnactGrPCmfNbRZbg5VXqxBKFxsj
48315	payment	1397	1397	1678	1	1	17897	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaSgX9ebdqJWbiRD2ih8C5ffm3mdc1dFr61pWP9aFMZeKjKv2D
48316	payment	2133	2133	1874	1	1	7437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQpL9wbxLuM8EXvpdzmMxqx29vvnoz6xuCKFCqhjqAxzmi5hj
48317	payment	2133	2133	1874	1	1	7438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwMeSMTUrnxFvcDMM1fZQnpUSH1oFGjGMxvH299fVcGzLxy8cc
48318	payment	2132	2132	1874	1	1	1944	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxUPcfhHXYqwFGp44TfdQ6jGFgfRwXNsJJ7FEj2GcT7HdSVHEi
48319	payment	2134	2134	1874	1	1	7963	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMoHZYocJ1JehUJrt6Y1ot4uQcEHQ9X485fGT6EwBXC2sso5e
48350	payment	1397	1397	1678	1	1	17908	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLipsTyhA6jp91rVQuG57ZRH72DGzyFZkEejvVLmGFEyDJbPXf
48351	payment	2134	2134	1874	1	1	7971	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmVLxpE8FdT1NKagf9uXX9aNY7LHHZ1FohKXDuhQ7WWBPssA7D
48352	payment	1397	1397	1678	1	1	17909	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKVzHjveVgGtGmwfHxKJFXySB7wgvEEQ2X1asLJrtxbeumJoAn
48353	payment	2132	2132	1874	1	1	1948	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhCdkR3vSSkctJGEZRborjWz25dxTYXgSE3PjkqPvUqJBBxqPj
48354	payment	2133	2133	1874	1	1	7449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZJscH6DanJLAZkuDY4J7DCgR2GJLyFL5NvKZMbMR9TC2LmXp
48355	payment	2134	2134	1874	1	1	7972	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXcYvms3AoGTgtxp3n7wyPA5puXSSPGt2whjfGrKBmHvte99Y8
48358	payment	1397	1397	1678	1	1	17911	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgeCbAbJZn7aNfEC9VRRnUyowA1aA3UosDoQ9YkeRmput2UZvP
48359	payment	2134	2134	1874	1	1	7973	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZcnjij5HnrwBR49tAXtTzwJokvc9b7bGk3mHqfjFk5qLCViFZ
48360	payment	2133	2133	1874	1	1	7451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2LEVxMaQdDiwrXhXGf1RrqEzTznUDcUMrZdeKbNFccQFosjLp
48195	payment	2133	2133	1874	1	1	7401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi2z5pTr5ukk49D4rfR1CxuC5hLK4JHJigxy98MwooQ6xw2tDL
48196	payment	2133	2133	1874	1	1	7402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt4BsDULmx1n8iUUhSQ1wekT6EugZ8MNeBsneHNXPDVLo42QFg
48197	payment	2132	2132	1874	1	1	1933	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEGYnT2WNm4wDDkotBkxDyDcaTmEiDkwqezLVbrTbAPuhhVcph
48200	payment	1539	1539	1539	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzLStpP2T14QoxMED6dqmyEdepR3gRBaFNCCGPxWoq6h9kxktg
48201	payment	363	363	363	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJBhJYyB9ZybXnSZbv8ub17KumXvyBQXGFT2PCJF1nNsstDYJ
48202	payment	1397	1397	1678	1	1	17863	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKMSXVRrDJvaUvAMpHMYHyxsvWo5npBeyBGQEsWB8qA4PUV5Ui
48203	payment	2134	2134	1874	1	1	7939	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiHzUtVmjF35F3LorQ1GqP3RD1GDAMTp75r8Vb1phNPRbPTkJg
48204	payment	2133	2133	1874	1	1	7404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVG9Kg92FTJtjVCsMyg4jiH2jnSkSjYASvbAucLLMcj43HtJsG
48205	payment	2132	2132	1874	1	1	1934	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyY1ups1BFd6i4ePojKXPkPmsE59z9cj1a3xMZLV2hpgFqRUs
48218	payment	1397	1397	1678	1	1	17868	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2yo11x8RZ6CdHMKVZp8SDztm4TqmpmU7c5KakZvoTm2q11mY3
48219	payment	2134	2134	1874	1	1	7943	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJkJw4FRPLXQzCSQUNLEtN5kKAdyegGwX9n2w5DYDFqVfWVKC
48231	payment	1397	1397	1678	1	1	17872	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhoGxRAUizpgePWkbTsqB6HQBahRJjCeGifkF9UGRP8Krwk5To
48232	payment	2133	2133	1874	1	1	7413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSRFvBbT68XSPpzP4sWfbLopSgpD9aQ8NtysPp7gm9toXcMqr
48240	payment	1397	1397	1678	1	1	17875	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhupZnvEkWtCHtMgwHQV5RjvgEgT87kPGzG7MpFTkutr4F69Sj
48241	payment	1397	1397	1678	1	1	17876	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcx4KygrNiHjCWGCy1whYKNwtJGAxhf9rjqz1f15hQxGS8zfw
48242	payment	2402	2402	345	1	1	1	1000000000	5500000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSzePDeWMmHxefAJNYxweW5No4B9YKaVaJCySdnuD2sCnwK5EV
48243	payment	2134	2134	1874	1	1	7948	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnQEHq8fYSmWHQwxR5EyWNTABrdBqrt3JR1J3CtapKNEqpAmKF
48244	payment	2132	2132	1874	1	1	1938	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkYYskQXoVs81i2Qkm44DsxJ5YTVLtmV29MZcA3q2dZBEcUW7
48245	payment	2133	2133	1874	1	1	7416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxzwhWCRGe7aTcLDkx7aJvZSpx6xQcuFnTHBqTGagJ5N6Wfgm
48246	payment	2133	2133	1874	1	1	7417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxZHjismxFNCcnWHmbaYAfg6dYGFHtLNcmDX48g7YhxGRWssMi
48247	payment	1397	1397	1678	1	1	17877	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QJojQ97n1hZgjYLtFJZWTLVrEZZ8H2Bz5cmt62nUcLhHgYg8
48248	payment	2134	2134	1874	1	1	7949	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEakzK1rn2J14mVBzo3btZVbmZH2AHzQesgoduGNc2DayLNHZ
48249	payment	2133	2133	1874	1	1	7418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Mh8Cr3yodKbJakPbys5DR8cgmwymLACYSfLdk8fRSSNVygdq
48273	payment	2402	2402	2426	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoJinuFXK2hGR52jrSfxxfraDhwS1y13pyDmjBjEXtCfsyHEnR
48274	payment	1397	1397	1678	1	1	17884	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3P7n2n2a7bazwh4AQHc5mogYZee7fWfuacosioDbMGfV2agN
48275	payment	2133	2133	1874	1	1	7425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgruhqGvf7F3LmGi6oQb5cknCtThcDHxtNabpFBJrQWGtkag4C
48276	payment	2134	2134	1874	1	1	7954	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KxTxpdvcWNWqyxFfMBrByshbFk3RTJaLUEn3JMQ9GdRCfvE4
48327	payment	1397	1397	1678	1	1	17900	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqncRS5XB6Yv3fQqhXBk1pv7E6CYodpATPK1c5dc3kpMqniqp
48328	payment	1397	1397	1678	1	1	17901	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKLPYqWcdbchQpnEWVRYithGuB3kRbbo9HTxK8UBJy37sEqEWJ
48329	payment	1397	1397	1678	1	1	17902	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSofUeoCWwzG9mtsUUbfzHgjQq9fWEhncyfdtxXWRMcbXj4TGq
48330	payment	1397	1397	1678	1	1	17903	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNSkkYoG1yE9nSfPKH57jtL7LHDQ8z5jazaLyaXr1afm1mr8Ne
48331	payment	2132	2132	1874	1	1	1946	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYquhNJW5H9czAtCp5LPxo3Bf5wbre7m818wcEXZBhVJeE3Zsg8
48332	payment	2134	2134	1874	1	1	7966	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUwwKTq4QtDtNXVXL343JKhLqFrQi6zyz4uztvfUyt9gJy8795
48333	payment	2134	2134	1874	1	1	7967	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaPCzT73moFt8gmoTArtQX7kjXGa4PPtcbLTH6MrJ3bKdqKDVZ
48334	payment	2133	2133	1874	1	1	7441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpK1oqYiNULN53Ue59MBvheWDMkgkvSiL1jqWcax69vYbMEnn6
48335	payment	2133	2133	1874	1	1	7442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7MdAXizWC5MAxX773ao5rYokYxApQ6Xsaoj5RnxXfwi6ry8oS
48336	payment	2133	2133	1874	1	1	7443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSt9AZHwxD8GBJ43tYkZQsekj7PkAM4LehzR7vxjSco3qs1RmH
48337	payment	2133	2133	1874	1	1	7444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC8eCL1sAnswwTFK9SKhhtgcGLkpAyvUJKLzJm76RSWAAQXtKn
48210	payment	1397	1397	1678	1	1	17866	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhjrkjGnCHC2WfgqBipCDNKMqjkAiC1VRBiqcMsnTit9N8Hh2
48211	payment	1397	1397	1678	1	1	17867	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGiwy8xvWwN9PBUpauMe9ZM96suQAjh4mhNvLupUS6L4W6gnr
48212	payment	2134	2134	1874	1	1	7941	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQECZvVxwuV7Gbw3btGtSQnvugbp6koydwSjcLvRYGDipp2Mb
48213	payment	2132	2132	1874	1	1	1935	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3PDTuVFKxa4G8Br8GFV297H3mk1qp9frik1m3Q984vLnGXaL
48214	payment	2133	2133	1874	1	1	7406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmudMtKbWw92gcVp9H7UAYZKVqM4kahS2JhV72RDCcPSSUyYy1
48215	payment	2133	2133	1874	1	1	7407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1d51e3ME9dSpt8gvs8g8psk3vTnt5MfGAX7XwE2v9kc2fx5qn
48216	payment	2133	2133	1874	1	1	7408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV8PMPnM7o2R4AD8p1ZbLvWtkb13FMezkkAf8i3zKB3DiKdP87
48217	payment	2134	2134	1874	1	1	7942	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaADj5kZ7XidGwgDzUjpxMKi8J3q3RjLJ8imsv4D6BGQWFDPZ5J
48220	payment	2133	2133	1874	1	1	7409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNT9pd51xebXMwBe99QJgbGVXJd9aDeWA7XK78naqySBszcc29
48227	payment	186	186	180	1	1	0	1010000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5sKZuNU1BkeQ5A1d7viSXpTBPSV56DvCKfCqB1GCuM9uWeAK
48228	payment	1397	1397	1678	1	1	17871	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QoghqmLjcuZw3of3TbC2XPwHaUKg4csgHrkfB2mc8uFRgedb
48229	payment	2134	2134	1874	1	1	7945	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWxKQvWsv3QFrSdVeVAFDzPVC2AFUPJx3mDzPWQkmYL8moh8YB
48230	payment	2133	2133	1874	1	1	7412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNBpBmTyZExbb15nJBRDo48ebbN5WD9wN3nFxqGQwr8ckNgr3
48250	payment	1397	1397	1678	1	1	17878	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAGsBHdZRZs6sEoMGwKKCBe4e88HcE58XfzpaSFKgWHAobPsQY
48251	payment	2133	2133	1874	1	1	7419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnLjWp7sbxhwbinJuLMVJq2cZWPTyU6YbLvtYJiynE1jMV9Mj
48252	payment	2134	2134	1874	1	1	7950	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCin5L23MkheJNvH5Wd2NNxi3JyRarMKMLprorTVJA15wATZBD
48265	payment	2039	2039	1445	1	1	7	19153000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVbfm4nrYia9AoNRN4oNwL559Wrk65EFBDEHBHfZfx1zNPyGMj
48266	payment	1397	1397	1678	1	1	17882	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9bS6xmVVTpm351FxUaiaWwYm9ofgmdECerZZtSk6ZaLMmphN5
48267	payment	1397	1397	1678	1	1	17883	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmimNDgSDt27qPNZXBuH4Tjws8iuPSU31vHTqyUYRpKwrfNLEy
48268	payment	2402	2402	2426	1	1	2	1000000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PFhizJBDK5KNSm68gfzEwjrKM6j2oxidotdBrqoVc8heJ7z6
48269	payment	2134	2134	1874	1	1	7953	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1f6zDgxCh1JLUAAe1Zp7c1a7sRCVwdSAFKcNoXrRzZVf6vxD
48270	payment	2132	2132	1874	1	1	1940	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZji5o18hygG4piKaoFV5bKh2Z67ay5gCY64tg7gDu6AURfECu9
48271	payment	2133	2133	1874	1	1	7423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXVdfJbqbjBvQEp3LWRZVoEHGdFAm94gABkXGtmMAEmCqPCCP
48272	payment	2133	2133	1874	1	1	7424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS9m5hvNe2Gwo9B6xDTwe8uBLtHEzrH2th6E9inmoXoHK7WuAi
48280	payment	1397	1397	1678	1	1	17886	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKDEoHgAcC5QmWgFeCoKEA2XP3g8vVhkzMQnnpWitrixCzkuF9
48281	payment	2133	2133	1874	1	1	7427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oXrSuAHboES3L3vZxYWrW3dv2LMaRcw9Qb8ZJdpWrdoGeq9U
48282	payment	2134	2134	1874	1	1	7956	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4Ls4rRPTJFx9HVefDgbbZuYCinehH2gTeQUPeRfZJQkkNsXd
48283	payment	2132	2132	1874	1	1	1941	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZStePfQX1bAao9AqtNr2drGbuA8mBQDWtmv9cyfGUZ1dMX8dQY
48302	payment	1397	1397	1678	1	1	17892	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSmaa1WYTwZr6uo9LirHpc5gavr6BovPaerLqYnVpktcbeCrEU
48303	payment	2133	2133	1874	1	1	7433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoN7aE41VWZWqJKg1TNS3QZVZLmFzbTHQgroGyii339Y3eRVmo
48304	payment	2134	2134	1874	1	1	7960	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDtMaYmd1L52BUKpWxBkb8QhR1VBM6KWtyWfq1mLRnFvi87o6o
48305	payment	1397	1397	1678	1	1	17893	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKKE3izLkQLzg3C8vgU2YhBq7MNRUqdwe32pUEMhaZdJ6GXUT5
48306	payment	1397	1397	1678	1	1	17894	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM3hMvYCTxJM8QYSbU1ScXqHXs5t2PXHFj4YisPK8hhn7jLa3H
48307	payment	1397	1397	1678	1	1	17895	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQN73NDAF27y2SzSRHMfcuvQt4gm16CpksMaBPP8xRGBNdNVok
48308	payment	2132	2132	1874	1	1	1943	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoRTtQdSRwNHurvHS4wTeUFEurn6o5tebhKigGRr39cKE7QfhF
48309	payment	2134	2134	1874	1	1	7961	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7ykfbgLEypQNQP4H9Vt4kV4tE9zL7q3X3W3QMMB97Xz6WkCmi
48310	payment	2134	2134	1874	1	1	7962	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZys9yiauuorxnnp4GdKkdLtrxUJ7JEeUH8KC2XEx9TqZr6sxuB
48311	payment	2133	2133	1874	1	1	7434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcFTbaKfkP8VAB7MZcoAkzEfV2Pw3zqhXKmZZLQeqRjD9zjMk
48312	payment	2133	2133	1874	1	1	7435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ83CNi5BMbJBpZ4nQMVayrnyWeQeqXufiUB9jHFGWo359WLiLd
48313	payment	2133	2133	1874	1	1	7436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtm4gNPQzVZ38H9kaG98QTSwpXb4hioSD12zVgrPhg9LSwmjaR
48339	payment	1397	1397	1678	1	1	17904	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEDaCk2kPFUzQ7MhkJagN24JskM9d2hoTubxi5XWw4QrvBRtDi
48340	payment	2133	2133	1874	1	1	7445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvqZHoeQdpRHhT6Gq8J4kkhYnJUoGLrpem6XVsAhgUTzUmZ8Re
48341	payment	1397	1397	1678	1	1	17905	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLA48x8udBwuZqtLbqXiL29z3o4kUnCkhADdScwd5i9F4mMoY
48342	payment	2133	2133	1874	1	1	7446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMPvodakiGYa4HfG6qozLFm3JGYBALPyLzwAZqXTUusCBwXEAo
48343	payment	2134	2134	1874	1	1	7969	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbJFRk8JLpieDpJFLkgmw4MTHVzKLr71xfm5vf4Q9orST6HgG
48361	payment	1397	1397	1678	1	1	17912	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9KJME3XHaKuUcrbyWHgYXTbtYi5QCQ86ukTBXEufjyNCqW3PV
48362	payment	2133	2133	1874	1	1	7452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE8sRLrfcj45PDwigw2uagMqsLk8pq9sjy7DpQALxBctA24ZzC
48363	payment	2134	2134	1874	1	1	7974	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTVgaEXVmu75KqrMYfpGiav43nDBbohJv9J6EhzKBHdAnUJ7sp
48376	payment	1397	1397	1678	1	1	17916	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Mr2XHJmyYsepSmSv6B3LHtpyB2WNQDE65jJYxcY6gm3muAL8
48377	payment	1397	1397	1678	1	1	17917	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJDRTBQaMfTP6QLTG8BuL13dWtRjfweSz4rQXYUWGRWsamjJN
48378	payment	1769	1769	1769	1	1	65	20000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXdgJ3FRinUFS4vJgdvMun6GhM2iDb4nR7ubvMM4E7gBj7wrhP
48379	payment	2132	2132	1874	1	1	1950	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj8bqTsCwxTZNp1RZqHRhdv9zzKofCFvfnHqrDotJkwPc8ZF4J
48380	payment	2134	2134	1874	1	1	7977	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVzZjZRWmn8QciJZbxo2DGu4xWSM2pMxr7QWPikTTpBBcnKfbA
48381	payment	2133	2133	1874	1	1	7456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCTHLjDZ94GnwRYu8N6Kox1Fu5WMTatUssfXetEFR5tA8CmJ9n
48382	payment	2133	2133	1874	1	1	7457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVH6KErKgxJTr94niZN45Ev4k9vDJ4EtgfuQRyMHuZtsoRmsV
48413	payment	1397	1397	1678	1	1	17926	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsmNEndznQLExCYnFU5y36ujRDPz7jkQ5DgNmRwnGXaSWh9XwU
48414	payment	1726	1726	693	1	1	8362	100000000	1000000	\N	E4Yh7V6ZEdJQ5nc9AB9yb2YXffS7YKSGDtb46aoVJJKJ3m9QPjsxi	CkpYrqw6Y985aWJkbyaTkG1C9v73eizFmdKCWsdMPQ413J2UcRhRL
48415	payment	2133	2133	1874	1	1	7467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBj1rmgQjdzXfjJ6QCT1z4MKDDoqS3FA6EviCnRC8ZQPMS71tk
48416	payment	2134	2134	1874	1	1	7985	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCesK1DUULq85kS4EPL3ypu81MpHP6MpsgHznSjxovqd91ktpi
48417	payment	1397	1397	1678	1	1	17927	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBPGbNHzKM8xFR4FiURwVcttEsPpHdgw7JFZ6THUj395cFAk1n
48418	payment	2133	2133	1874	1	1	7468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZnge5YS3FDzMJzaKrjpZYSAFvVJ7hC5egZUAwZP4BQj3nD7v
48419	payment	1397	1397	1678	1	1	17928	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KHvDaD7b752avXw6SimoW6jbrecqQTq6cxuxa5otFVgC86KT
48420	payment	2133	2133	1874	1	1	7469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVEwuR3Hxf4iMZVdpBtoUe8EBq4cG7ovZbb95d76PFVT6rThV9
48421	payment	2132	2132	1874	1	1	1954	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1xAn93bzsV2X6hF9Y8ciNpXsFf41MzQ5m1dv3zpNACKpwieVc
48422	payment	2134	2134	1874	1	1	7986	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQNU7smggxb8SsxFVaivNgGJVbhWNE1R5QvBKhbXbj5eE9oeX
48423	payment	1397	1397	1678	1	1	17929	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2uxzDrBontYtixZfbyA4wXDRSNevUz8tr8muB9QKR1eNQTziE
48424	payment	2133	2133	1874	1	1	7470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ8995M2TU7yAa7Pevro9LNRkyfRHyX6fkdFZpnYRd5HByrD4f
48425	payment	2134	2134	1874	1	1	7987	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZecoJxME7i7oLLMWHJxECLyY7ycg7PxC37GjDeR6FZw4qszGW
48449	payment	1397	1397	1678	1	1	17937	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpLncQoiMxmTd5ZHvP8obVDSK4RnMsMkDLnWHYpVLejxQimGhn
48450	payment	2133	2133	1874	1	1	7478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyJiDUui7F6SPmQRR26aZyWe1napvqv8q3bjBkGBH1bpBvQpCQ
48462	payment	1397	1397	1678	1	1	17941	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVZp8wyDBQCYVu5tQgJQekJFoHadqkmn84Z1xQCQa6TmGPN3Hx
48463	payment	2134	2134	1874	1	1	7995	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7mxTSXLBX2CVmVwZgZm1wceNs7dZmGLkiN2ViGKJW7YkT7Tf
48464	payment	2133	2133	1874	1	1	7482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJnprVfbu4xVA85kb3XPxeeGExia2DgfgmxAqdvsc4M2WsTfFF
48481	payment	1397	1397	1678	1	1	17947	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGw338WBAuajFpPJn6KbsXdiXBQmyXsBgY3deyz2CoRVkBvdAs
48482	payment	2133	2133	1874	1	1	7488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZgSxizjNbY7L1UkQrqxois1UvUzAPemVZExv2hh9gE1RUo5eC
48483	payment	1397	1397	1678	1	1	17948	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSQrZC9M6vB1XdBQ2X6Zd4DBf1bHTgK7cgiwugKkr1AnnXHao
48323	payment	2134	2134	1874	1	1	7964	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXgVJcLNwwzgg6zro5YS4nmwG65eFKdCMuypo9QVckNF41uW3
48324	payment	2133	2133	1874	1	1	7439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUJUKZzj1E1JzRcd17AqmE2J9SBuAx7qX7HDhQ2Prrkv6fgzfd
48325	payment	2134	2134	1874	1	1	7965	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXKzpvn9EicsdwVtVNsaB8BRT5n12iXy6WFScDi53YmyzjcHaG
48326	payment	2133	2133	1874	1	1	7440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFdRwqDYVD7FXGXNp7dGijZz2H1Cme3xYodpJJXTcW1rQyycTk
48348	payment	1397	1397	1678	1	1	17907	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ByED2wmyj5BAJHBQEBm5tDtb1qimwfEJVCrApreX1WgJh998
48349	payment	2133	2133	1874	1	1	7448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrFM5Mpd7AC8eUCDYa7uK7hTwbB7SJFgxhV7JudrQ4Mpjf83E5
48369	payment	1397	1397	1678	1	1	17914	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZST9XHxa4YmCL15BZWx9pKwQXuaFi8KQYNQQNGqtpz9LpV2PLz
48370	payment	2133	2133	1874	1	1	7454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXUv6cTZqqJbZcYt9w6S4ZVE98bVvZ3wXKiPseGWBoQw1LB8tY
48371	payment	1419	1419	2419	1	1	10	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYazkLzoWc2yfx6RXDtLW5yzsZXTPHAeW9Sivq5dek3n2wvNFJy
48372	payment	1397	1397	1678	1	1	17915	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJBRNfdXvuaFPynM2e6E3PNqrE5r78ycDSyzAopeFEqzgzCQAW
48373	payment	1419	1419	1419	1	1	11	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiTqQHB1bdujxTR8z5CzsZWZjho8AzmPPF6Y8soDRgoW2PLo9b
48374	payment	2133	2133	1874	1	1	7455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDzp57D5vhvH5Mw3V9r2KCZ3MjxRXqCS1ExWNPCZHyZVcseRs
48375	payment	2134	2134	1874	1	1	7976	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gG4o1Q349y6TRewWBsM9csZjCpjWx7a5DhuGB8BmNX1f956N
48387	payment	1397	1397	1678	1	1	17919	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiJF1vY9NX6JFBrCuSMvhcG8aQnUdoamfMioshs7dpChGEnEYF
48388	payment	1397	1397	1678	1	1	17920	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59DwL6UipyzfrofBSV6D2ycWrP7sXx8KbWjPJt5RRurq7fu2D
48389	payment	2132	2132	1874	1	1	1951	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN34YLzFBZ5vS8Nb2QoRGANSnvPmKp2d9YT8DHYX79xfeSxR2H
48390	payment	2134	2134	1874	1	1	7979	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT1qqUhZJhPXFFvELrZAN3rVXDBkrDKNaEHgXBhbDpz3iL4UeQ
48391	payment	2134	2134	1874	1	1	7980	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiVJwDmvurcPH28ioBWCTnzZHDwn2o6KtvFRHcEDJzBFG2zLeq
48392	payment	2133	2133	1874	1	1	7459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNSVdJ6Pk1jEmMn6Uw9hBr3Sxzta2cizRMXUATtcoGoo33vzN
48393	payment	2133	2133	1874	1	1	7460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwgp8FLc8CGpuYBW4Qs3ZbNiz84CvB63jzcLmHekUgsz2W8oRj
48407	payment	1397	1397	1678	1	1	17924	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk8ZNY2DfvUeZoJf5H2gUEewyFW4pKL5MvFLgyNhxDZuDPGB2z
48408	payment	1397	1397	1678	1	1	17925	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsPLEmm9Gw3vJu7rtrmpPR1Trog71rXQPmt33DXoJhBocxAJT
48409	payment	2133	2133	1874	1	1	7465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiFuD7C4GJaAk199RVnjGQcPeXgNfQn33SsUfrEqyojivdWrs
48410	payment	2132	2132	1874	1	1	1953	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpnsUom7gJ9MTrw2hc761iydZLQsj8pK6z38P8oeoDgWa5uPB
48411	payment	2133	2133	1874	1	1	7466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiKbRuvHkdd6YpgPDovwvpPG2yQZfuQ7k4WhR4kkvmPofoSBQ4
48412	payment	2134	2134	1874	1	1	7984	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj8td3mwYTrybrukhYr1yJKws1Dger3V1JYZmFCQT1jY8u5JBk
48433	payment	1397	1397	1678	1	1	17932	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJs23NoS9aghcpkhvzDV1FTrnHYzjmwdhNdWypU8PEXusoRtKx
48434	payment	1397	1397	1678	1	1	17933	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMMWmTXWvWScYQ98V2VE5CcZ8chTf3gBsDL6AtjqcBoZYEMJB
48435	payment	2134	2134	1874	1	1	7989	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdUmFoWip8YdrtmbbFm7QnK2zemJVVZGm3kjBrNRn8qaJNESU
48436	payment	2132	2132	1874	1	1	1955	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYnDRb9fJc4kkBVR4H4buYvAfKfSxLRDnrvbUvLjABYNyPegBi
48437	payment	2133	2133	1874	1	1	7473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqrAxWRo3nfXqu2j1JWZkw91ZRZJjpPgEN6Bvmo7eUpyqWdwsR
48438	payment	2133	2133	1874	1	1	7474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJRGdmWJKCHZ3MsB6MzikajhYweHmi9bG4y94n2cDQcGKPYdiu
48459	payment	1397	1397	1678	1	1	17940	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNThw1FbFyCFHevbJXM4DLiCcrf4VRPheYCmu43nceVpS3UXV
48460	payment	388	388	1560	1	1	0	1000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdCuHENWX7of1zhqxZscSRaEr5B6fToHfukuKvYgK66UkSpVCf
48461	payment	2133	2133	1874	1	1	7481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa53kgXXgTFH5rcaxaiZmhg3owVj3MpvHmuGx3B6YoGZix4Tt6r
48469	payment	1397	1397	1678	1	1	17943	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5bQFADPMk9Dg7qMaZPp8VFnNdpeZ3U4ekVcEdeL5QkFDK2uUt
48470	payment	2133	2133	1874	1	1	7484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2RpJYnUyFBqniAdW7rfuxq2XZHeasWMo19DvfpXPdntwZSjks
48487	payment	1397	1397	1678	1	1	17949	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRKuy1nbvQVpnsbHgSGp6m5Mu9caZrWxZRPtHbpibcSgSp8P6
48338	payment	2134	2134	1874	1	1	7968	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHAxfmYAvA4b7Hg5LbGSsJWDZzagMSCrRdVwbSZaTV1gtjBGuC
48344	payment	1397	1397	1678	1	1	17906	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTaBfGwfo5BnTKdFzDsA3Unn3pNy2wsDAgxZNPHdoa5MtCBAqb
48345	payment	2132	2132	1874	1	1	1947	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkSfS5EqE9XLhoNuQNtL9njbk8hjzuww3LLYwR7CeLXjaWrvy
48346	payment	2134	2134	1874	1	1	7970	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKeandm3Ydn81yRNQA3rSn35itM452pLEAsXRReSEBosWVfmx
48347	payment	2133	2133	1874	1	1	7447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM1hG81p21LhNpk2GJqgyHkWpahWnYc32njSgxs9x1YvtqNvCd
48356	payment	1397	1397	1678	1	1	17910	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8q7UbmDxF5Di6XVFJZsKr23Je71p68EgiD2NSwoBZt5tDFsDz
48357	payment	2133	2133	1874	1	1	7450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVvc9AsPUQrgxJDwo83SXben8NictkjY2THX6GEZFKnk7nHnr
48405	payment	2134	2134	1874	1	1	7983	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTTbnK5VTvLxwM344XsQAifjJGD9C7qa8nP6J49MAtuMCQ1nFP
48406	payment	2133	2133	1874	1	1	7464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZQS6k622tH9avSsezoFYqc7CTUAx5jVkV31ZA8bKpN6gGt82v
48442	payment	1397	1397	1678	1	1	17935	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBVDgxRLV5sA5xyLuetJ8jVT93X4XxQqjMSADmNiU53x3ardwq
48443	payment	1397	1397	1678	1	1	17936	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsJRqLdmCzzXkxvp9fsTA7NQtQ5X2fi8D84chrv8x1Tbb8xTgW
48444	payment	2134	2134	1874	1	1	7991	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj1H8Ho9nS6o9RwG2ArtnZ9B4mCoEwoa7izCKBXiYyBraLdi4p
48445	payment	2133	2133	1874	1	1	7476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEsFJpKdhKCLVbduj9yxTwTijYZjFpphHDqBKduUoswjpbTrpX
48446	payment	2133	2133	1874	1	1	7477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWre4Q4a5R7VkRwjQTZRaTUjrcFzptsJnpYJwDkcCdZFgeTTig
48447	payment	2132	2132	1874	1	1	1956	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NDuaMGDJgnPSwawrwerc9hsUmwxqpPeivex9YPERZpU7Rh21
48448	payment	2134	2134	1874	1	1	7992	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T7wxtwTc5xifAAt8cB4aYQmR2ZYgBEiWiS4q6WQSqNRZJAE9
48451	payment	1397	1397	1678	1	1	17938	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9qQYzP3Ywdq2QSeFgbd8r2QLmW7P52qzdF9TNgDySrmTtte1o
48452	payment	1397	1397	1678	1	1	17939	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdPhB5y8XmK1JSpBxpiTCK81yNVjp5QmQJ28kannhFjgfDWr7S
48453	payment	2132	2132	1874	1	1	1957	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjxjUuVUqdNq4NYracyMfGKx5RAAjdT9AV5FX6uzdUj9mp6ccZ
48454	payment	2134	2134	1874	1	1	7993	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUkeqThxKgZXrqWXMYfezCm2wzyzJTG15brb9XS2BNaBabooU
48455	payment	2133	2133	1874	1	1	7479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZr7myK8aiUdKC9tc4EkQFc4jbjNMaKgYtBTzJVpjrcaTNKZP
48456	payment	113	113	1504	1	1	0	999000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgR9YFKGKoWtxur2rMoFqkCEHZKNJ8t7tyLBPiDvSuoMDkxrm
48457	payment	2133	2133	1874	1	1	7480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzHGCL9WjpmfCSetjvrbFVizWb6jSaCXYk7VaK3nBuD8CndxFV
48458	payment	2134	2134	1874	1	1	7994	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3eMSkLEHDTUnQV5s7NnPfycFZnCaEuALRPUH5JK3JjWzzA5p3
48493	payment	1397	1397	1678	1	1	17951	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyyBZoCi1BDzbsmESofPhevuytgq1yYQ1rzqv6HVZTB1Kaysa5
48494	payment	1397	1397	1678	1	1	17952	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghipYAMfZuBaL2KK2yr7BXQgS68yt9TA2VuwLd1vLvMTEiS2S
48495	payment	2133	2133	1874	1	1	7492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrMDe8DWje8kMUdtJzqzZDpBtkqrQKfASXFHrA3t1Rkhg4hMQr
48496	payment	2132	2132	1874	1	1	1961	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuepNPWpmP1D4DXUWHhbyERnSgrDagU24Hm1VTrJLzpo2UKtjf
48497	payment	2133	2133	1874	1	1	7493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykAKTgLer8F416ZqTat4MkZk9rwP2DBLFDE5gKmS1ddg6hVeg
48498	payment	2134	2134	1874	1	1	8003	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzxUMN8pCxuZV8BjUpmVzXMXcvEnedyArgPRP8qyuvCSeVYras
48502	payment	1397	1397	1678	1	1	17954	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3XAxH5oPnup3d151dvjyJNYWZhkevznfNN5ZtZYCDdr8Y4mQW
48503	payment	2133	2133	1874	1	1	7495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaKc2LqM2EEipKwGf4tD56GUmr4uFXTSPbm87Munp9ttzZKkqe
48508	payment	1420	1420	403	1	1	1	300000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAsL7GyYNKDonMsrXvao3D8M18WeNyeRBotRFHN5Bd32Vq8zTf
48509	payment	1428	1428	472	1	1	0	500000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3KiS2vVuXfcwQJNdjyEAGyVZVLxJVv1Dho1vt9vPYuxTE1N4S
48510	payment	1397	1397	1678	1	1	17956	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDnRMW5WXWfiqqGtJcdtfQ16zPPR68irpjBjaJQygXTmeJSL19
48511	payment	2134	2134	1874	1	1	8006	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrRsSPTEGszTaSFyXdWAGHmcDW133BtB6dFxhqyKqMkuJEcaNb
48512	payment	2133	2133	1874	1	1	7497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2TqNesRpHh8TkU8w2uxBboyxuNwCUippx3ujgyet6wdzfn6f2
48522	payment	1428	1428	472	1	1	1	600000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbLNnMZXKSVMQuCcZhXJ4vpjrB6NG21nv8xeMGGAvw2GmY2ztS
48364	payment	613	613	599	1	1	0	900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaxEJbz7Etqq6B5zGo55VHPgaZqMKZP3MsKYH4Nbr9iQjh9uG
48365	payment	1397	1397	1678	1	1	17913	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAft9qwUPtpNxbB1jf8iARMm7uS6PK2CvkzBWUoDf4XRVqQnj
48366	payment	2133	2133	1874	1	1	7453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqbP8FG64a56mCmzh9Hg8f87oiNrB12kD5mPjnNLCq9Qoxhzza
48367	payment	2132	2132	1874	1	1	1949	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2eathzdoVLyVk3w3apG8McZnMS6grnAvCLx4bZEw65zpX5PH6
48368	payment	2134	2134	1874	1	1	7975	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYjewNpDiNRweTiSkEo1UoNUWHAiCqSQQbUCH18SQfT1dCXt2
48383	payment	1397	1397	1678	1	1	17918	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhXamNMm6aLguRYAkyuHf7KFgk7kdFxfwXhFA9VLUsc1WhAL61
48384	payment	2133	2133	1874	1	1	7458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwH1JZhg7Uh3iQyw14t9uiD2W5zMMNBFW2sK2enCpkdxvZ193P
48385	payment	2134	2134	1874	1	1	7978	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMHnhDofHLvnMrtounp22pVEJxzbRqK7BUx29H7xyyPTYmrfG
48386	delegation	1769	1769	1406	1	1	66	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYauXFRD7QtHUwrxDY5Wdv8VETctBeZ6GDXbUH82X3KDPjpTW
48394	payment	1397	1397	1678	1	1	17921	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWUqEDq4gGRtTr5WT9kWybfRuW7dif8hEzswPjRCMYt7EbnSb9
48395	payment	1397	1397	1678	1	1	17922	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmeJL7gqvYLbKAwqx5VzucB6BkhtVRswYKyZUnn6X5VPnLaWW
48396	payment	1397	1397	1678	1	1	17923	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gpwSgzpEkW7Sg15fTnbNS8NW8vvxwECkByY9uvqecsnFvVRQ
48397	payment	2132	2132	1874	1	1	1952	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYsB15WCXKZPXgStjwJVdd6Je3dMeKsRYZpd9eJBwJTqr2FPiR
48398	payment	2133	2133	1874	1	1	7461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcqFJY5pPzsrvJJatakP7Bxc4sFWEAZCK8fjCvDyzUsDyAJtpH
48399	payment	2133	2133	1874	1	1	7462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyQ61PLR63oFnpRkDD2t9KyCHvAouo9tZYyejBbpEuKNAmZLo7
48400	payment	2134	2134	1874	1	1	7981	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHeen2cF3u4fQ6MkDK1hpt3ZdVSmvjCsMAndN9ktqc1sYXZuKj
48401	payment	2134	2134	1874	1	1	7982	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmBU3GQL1HYTm1ieJm3RssU9zJRPESu4ud64gdr9QEUXhWWMu
48402	payment	613	613	599	1	1	1	90000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4VVWgZJ4tVB2LsRySf2kvXcbjwGZNiFvmDwbptKMZanXqzk2
48403	payment	613	613	599	1	1	2	90000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVtrTNYftBd1rWk3NHvmBLm85e4HEhWFtBAdhzsfKi1dVvxf5y
48404	payment	2133	2133	1874	1	1	7463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKXSQ4xURRKXS9Tve9HxKRp1WKGCxe3sFAhtj8Urf66gncHC2
48426	payment	1397	1397	1678	1	1	17930	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpzy4rgHaV7ayRkKhtwx5rG63BHYM9q6WzJM1fEcSNQ2iXgbiH
48427	payment	1397	1397	1678	1	1	17931	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzydEVgoSHGrLoSZKuCLJtXeZeBV8g1C52NSdjppENYjKE1hTt
48428	payment	2133	2133	1874	1	1	7471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcbgEMmAf4vD8QQ89njUs2WX14ZzoNahoNq7moqrkQamHfhegq
48429	payment	2134	2134	1874	1	1	7988	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk8SGBTLv7NwQajREKWxRfH7cndn7yMUYvQ71ceRfnLM1D7m1t
48430	payment	693	693	693	1	1	1	1000000	1000000	\N	E4YXPnp379EAjxe6YZWiu8n2abZM4GuCpa2pZyxc7SeJfcu8BUjsL	CkpZiq9J6ojfgT2yn6YfB17GqKwakJMymiurg8vW1vfQG6ujLFvaV
48431	payment	1504	1504	113	1	1	11	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynEMEG8ykn7cATrbDEpVAaQuwq5VWoXAmPy3x8ruo24aG42Bq
48432	payment	2133	2133	1874	1	1	7472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK7fKY6768Pvh7AcBW8Zc6JxX9xDBRW6osWq9dUJXf6rk2q5Fe
48439	payment	1397	1397	1678	1	1	17934	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWYBiEeeAU2FJA5dXtbJ9sYjEfByZPiAwSCZDDBtB4DFCHGVt
48440	payment	2133	2133	1874	1	1	7475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeYrEMSTroBkbJPEkMv8YnbucwW4tdeh3YLA5U5uu2q769DzQt
48441	payment	2134	2134	1874	1	1	7990	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJwWqSo3JqJy6Z6ZNyLziNuyrJbo85ZtCCXFi4hMi24bpnuafM
48465	payment	1397	1397	1678	1	1	17942	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS6zK2TRsenJwNDQiJ7dVhED94R9MrFbE6MPU46cAuGXH4XpgR
48466	payment	2133	2133	1874	1	1	7483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHNKryDLeTewFsRfw94rpYKVxJDwmnygFyyvs33qR2PSnbpyWP
48467	payment	2134	2134	1874	1	1	7996	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeLz7HpDRzu8xPTAUCAdUTwSAZQq7CG3d99PcVFrD6XsfuCuNS
48468	payment	2132	2132	1874	1	1	1958	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiusxcgYEU9Eh2DxfeEzPh2ajdBRJFMhzxVkpWTSMvNiNyegWA
48471	payment	1397	1397	1678	1	1	17944	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLkanELsE8keT7hbYxd7rxsYn77iarTrtKw92km9KGShdoxYA
48472	payment	1397	1397	1678	1	1	17945	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZytE7mKyusCoELFhGpWLnRjewqvybpisobCi6okVgUEbeXpfof
48473	payment	1397	1397	1678	1	1	17946	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbTega4WZ5paz9pHGf75F8kf7hYNSrspbro5xpZ3JH6ZKVm8JX
48474	payment	2133	2133	1874	1	1	7485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLhgzx5FHBM8ekwwLKK3cLcHtkKHFuSfvLsQXKg7GLp4VARck
48475	payment	2134	2134	1874	1	1	7997	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCW81KcrdsYjWvwhA3vEyjRghztAH84CtUYjgUqPgyxb21Yy6
48476	payment	2134	2134	1874	1	1	7998	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE95fxnU8przJRzRbzooHyAqPiY6t6scnEiSRYvohn3hoS6Bym
48477	payment	2134	2134	1874	1	1	7999	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6x29JjwxSF6pt4pWir9SntXysDtcRUNpSAjgDHCtRWwyBMxcs
48478	payment	2132	2132	1874	1	1	1959	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuB1TMm8LmrEq5Sn24cLf5equksW2bZaHAsXiQRzDFXEdKpmN7
48479	payment	2133	2133	1874	1	1	7486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1iiKL3uQL5TnCA9Eh6LeGuA7AhfWzigvNiXYMgzNXfgxhfdyR
48480	payment	2133	2133	1874	1	1	7487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDXGeJAiaoVYemaZLAPzKYtNNGY8SKZjHZWmvQ8mQYre5aAzu
48499	payment	1397	1397	1678	1	1	17953	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwxSjoj52qx8SH1Ww2yLGX11FtR9VvqG3gsCYVjXvw2dNTAma3
48500	payment	2133	2133	1874	1	1	7494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZnJqwuEGrhkakey4uMDzaowPXHye1Z6UAZyCvLvJerYu9jh1i
48501	payment	2134	2134	1874	1	1	8004	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq1dXP7LYV8CZ1VD9aRpxzcipr8ZzckYvkUPvdGz8xTf7XwfiX
48519	payment	1397	1397	1678	1	1	17959	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDENYQjzwcQzPsqSoB9AimeJnkw9icSStCWT7mqvZufNgwyXqe
48520	payment	2134	2134	1874	1	1	8008	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjMhBvwJYGtD2sh2hSbxcvaUByYoHdGcbMoTLRGpfprRio4Rc
48521	payment	2133	2133	1874	1	1	7500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ92ZLAB3WW7kyWthGJ7xNNuVvLAFWvozuDipxnzi6Sqqvgq2uj
48533	payment	1397	1397	1678	1	1	17963	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnkH4x3fjFPJKcgrLqvAcDvdPorTXN98UNkZEKroyNoSNKWPuZ
48534	payment	2134	2134	1874	1	1	8011	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHMtLk3N6m7Y7mRvvVyJVfj2ytcvHXFV9Wn8YMrfr8aYkjWwTW
48535	payment	2133	2133	1874	1	1	7504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRvbRo2fXLbcyhhgs5gTMhfywJGq6iHSsgoGSzY4HR3TXZ4FC
48549	payment	1397	1397	1678	1	1	17968	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMkU5VQ2iSGvyDYeJvRh5eFhk7PG2miXZfXDFhmrS1TrMpGEzC
48550	payment	1397	1397	1678	1	1	17969	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrQBv9arSvMybRnYqTXeGHgUAskA5UTB9A2pNSiXH4NVksZ56R
48551	payment	2134	2134	1874	1	1	8015	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq89o8F9ioXaMtDS8932EHHXn6bJz8RKZQ9enuk2WT7fxh8uKZ
48552	payment	2133	2133	1874	1	1	7508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2vHY8zxQy5LuWiBkSiJERZrpaZgmaN9UYYZpmsuZZhJW3BJ8k
48553	payment	2133	2133	1874	1	1	7509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1iGP54g2hvYnyG4kCLjv2PhA8Sm8b7c9AUCLvp8hguTKniDuf
48554	payment	2132	2132	1874	1	1	1966	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVPPwtNkaF8kSEA159etYefwcn2PZoVoLcPXFDE6K5yawQLne
48555	payment	1397	1397	1678	1	1	17970	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZToKTD3dCmEwWB4Zo98RgKC9GeHQaqYWxPmjjo7tztZQNU4kyD
48556	payment	2134	2134	1874	1	1	8016	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXDEvzcrMc1hm96bRtDLBS88XJXVBNYhvrjjV6xCJQXQznbidd
48557	payment	2133	2133	1874	1	1	7510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNTe3diFjS7mpmABEq6RuKY8iRQg4kjdH5EK4owgk72E9scMbm
48614	payment	1397	1397	1678	1	1	17989	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbLNSBoHi74Cm1x9RuEZFWTXxVucR4Pz5YyvoupGLFuf2chK2V
48615	payment	1397	1397	1678	1	1	17990	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAikuzm8ymNfgq6dGjBEhGPtjL8UyDn2PShZHGK5Cjp1oFsy2S
48616	payment	2055	2055	718	1	1	0	2000000	1000000	\N	E4Yyk7ir4jPmppNr3sELP2QryGmG9sL2s2nS2rou7uFt1eb2tmcq1	CkpYponhxdYWjeF6BrUccJQXnVrYodsMfXSPpWm8PAeWCfPmbCou5
48617	payment	2133	2133	1874	1	1	7529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuN9WWpVuonhFJEiAA1NvZQmnQBeXkar1SPVvdZ68sqnuAj73i
48618	payment	2133	2133	1874	1	1	7530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaZMCWu7Gz5S7J7pNKnPtzpA2e9js5FevXfH39132gWxsFhMoT
48619	payment	2134	2134	1874	1	1	8029	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3g1C3yPiMFv2xWvoHaoCTyVobxDUmTV22uTaj1WVxdAa3DkqC
48620	payment	2134	2134	1874	1	1	8030	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7bYehqYQUhykuvA2FMD2tsPb9QamEcDncAVipASM7xST2P771
48634	payment	1397	1397	1678	1	1	17995	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ArYnV7xaJ73CNbyYyFbFP1hw9JFmd2kQFvEK9HC4DeiPa2aG
48635	payment	1397	1397	1678	1	1	17996	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZajhoVZaXScQ2t1RTvdaqdrE9d38HTP39hZmNhWXRkJdDzNefD
48636	payment	2133	2133	1874	1	1	7535	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS5gRKvB3KUwupszf63BTAChXH4MGgoa1D2nndaWhXMK9TQgZg
48637	payment	2133	2133	1874	1	1	7536	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaizh1PBoVkpSxkEkHwH1HP3U78kEXGzrZTB449z2EJM2Zk1dQ
48638	payment	2132	2132	1874	1	1	1974	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSXSVwPNA8n1Az9HEdC8hc7Xfa7LAj31M4qa76MorxE5fJ1N4u
48639	payment	2134	2134	1874	1	1	8034	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5XJBafhFuo6DAV28sxxDdFd37auXvcPLBa4Rjsh6QhMJ7Qitw
48646	payment	1397	1397	1678	1	1	17999	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa6Sfdozz2tH2RUHs3SpBtTfcFKZjzdcBEtWmvSHKMUjr4ieBp
48484	payment	2132	2132	1874	1	1	1960	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ1whGjS5eYmv4cufaekgc9h5fFB6wgZKjWZ4YWDLyaSE3L9oc
48485	payment	2133	2133	1874	1	1	7489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ14NyALhzRhyAcR7PGgMVHQovxy9JB4JSNiFGNqrkp6vZsxLLj
48486	payment	2134	2134	1874	1	1	8000	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHVVDRFrJguNGVvYP56JptfmtZ11S83RXAG7USAeyCc6tWqUGX
48504	payment	1397	1397	1678	1	1	17955	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpf8nJ1jK76kwr4TysNB2vHypw2b7icgno87KSNASdy6eX5xoQ
48505	payment	2133	2133	1874	1	1	7496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLu3g3u179oaPohvTLWLrErxQBkCatVZgGG6yZ7sdfho5nbYsb
48506	payment	2132	2132	1874	1	1	1962	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkZEXGXjshKhFLPKR3ASXkdo7jBf5e4WnhUJ1sTdGcLBPgUgwF
48507	payment	2134	2134	1874	1	1	8005	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1zkcapP73GatNiBafCoACmPuWasXwFgVJoJXYeUtYQKZEwZPZ
48544	payment	1397	1397	1678	1	1	17966	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYycD8SR3XNzjDdwYNRuCyYDP6XnFaBrLU3cNXTwLwpX6Zfmk6W
48545	payment	1397	1397	1678	1	1	17967	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDvHVhXtdzzTNoxCZkbDBX4LkqupQAx6aXXfRCoZv1r4fqKz1C
48546	payment	2134	2134	1874	1	1	8013	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnZWWCSqhQ8FhoZm5TSDmNPN8JmaVsvyAoKKcLnGC2Z2Tdam3G
48547	payment	2133	2133	1874	1	1	7507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WSNSYYGnr3yHeG1BLqpCtXwVHUnKK7iQxk4DJEsFD1UbEGzV
48548	payment	2134	2134	1874	1	1	8014	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPV5KhDeTfdcS4M3saQCWvR3hkDHwiwXnsRBpK4XYM4jdogGF
48576	payment	1397	1397	1678	1	1	17977	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv9BXWGaojsmuFPUHrDqaYbnsX65dNwT45CQ7VPsjsiWzQidoi
48577	payment	2133	2133	1874	1	1	7517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsLjvnSPnra9Mq6udp2ZWuoQF5ALokCG8ZM7hVu6pSa1kq3aai
48595	payment	1397	1397	1678	1	1	17983	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ32XbJDCpc1e9ghdmG1bdgfzE5NyGJ8UPJseqEEbN1K5jnUFef
48596	payment	2134	2134	1874	1	1	8025	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDGiWqM4XbqMWP6bSUk2jh3VxsjAVuGrTyitycLcH6nPe6Qn8
48597	payment	2133	2133	1874	1	1	7523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTkMtcZ1wgBeg5hDixgjcDE5JYkhvBrV8cN78zPR3SFbZVTia
48621	payment	1397	1397	1678	1	1	17991	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAuV4QUMEruMVZbCZN4c8hGqfEiWA4m9hgBS8fPizLw21SjtFF
48622	payment	2133	2133	1874	1	1	7531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQHQtGMzTtfUkWLwdoHDzHFzaLyRFcmCYxHXPWmuCyenvymWqo
48623	payment	2134	2134	1874	1	1	8031	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQNfTTCyFrtWXSpQEfD6S2AGb3Va3w5qA5uHgGbWY4deFjTQK
48640	payment	1397	1397	1678	1	1	17997	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kBeZDqHV8a5GRJBfifp1TkvkKdnP6ZStxdRpvxmx2w3rT9Kv
48641	payment	1397	1397	1678	1	1	17998	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuK3iP5176EUXp5TwZ88TA81BVLot5iyrGP8pAChQzz26SVUjn
48642	delegation	2427	2427	1600	1	1	0	\N	3250000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9bT42632FP5rWaUT2UdrH7nh1hevVctc2eXxvcFUASPLPCndY
48643	payment	2133	2133	1874	1	1	7537	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZckt8zB7xTTbgQiERsEPC47HXgs81AdfgU1h4mmd9vaHUW5E9
48644	payment	2133	2133	1874	1	1	7538	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTWQ7ocuaxveCpPzeVPjdetW1otP6VYiC8xpssodq7yXCfYYZ5
48645	payment	2134	2134	1874	1	1	8035	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgTJV8AB6xSCHPD1UP6BZgz1E4wgyz9Cz6i591gUUTSFo26Ck
48673	payment	1397	1397	1678	1	1	18007	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8MwdeszHztBHJiyY5uxfvKHoehhHLCZyTS4yBkyUr5G2nsi76
48674	payment	2134	2134	1874	1	1	8042	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUJTASaZU2YDR7E8SFwpyK2vh2YYsUT6KU5qqb5WsibvvRTxmX
48675	payment	2133	2133	1874	1	1	7547	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ611hx1mcBFAVvCuQ2CuQsJS7kk5xhUSbwcj2q6L6tkH6gGLQa
48679	payment	1397	1397	1678	1	1	18009	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTETe5pF8ddSRAPzhrE1DLKweFHyfH5Jsazm2ruCVdvGhWXea
48680	payment	2132	2132	1874	1	1	1978	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqp1wHVzj5mWvmvfm543ZLUDujPLCECBzGNzWoNoL64NLXSaY
48681	payment	2133	2133	1874	1	1	7549	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcUJUubDpWTQAeTtApxhsEhDRG4n1kVi7rLXqYRjVHPCavVMx
48682	payment	2134	2134	1874	1	1	8043	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56bexzqqyQMPUeqfE5ahZwmSGLpUxJEsHgHrh249SWwtjQtjt
48683	delegation	718	718	1655	1	1	0	\N	1000000	\N	E4ZKwytHYi1tLKQVpehYwgCM9isAogrGvK4Zvhp7A56cv4UePf6RQ	CkpaCQ8skJafFaCByPHqia9Sv1xR4vyKfcep5jvRBiTX2o4nhfLMw
48690	payment	1397	1397	1678	1	1	18012	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgKhoNwKUokmKUPMJCa8Yk4kwzPLq9fmpYrqroH6Q4MhzD5nRj
48691	payment	2132	2132	1874	1	1	1979	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wkESKVgBm24nUR7mYMKwLkBYbCr6uQWHyTztzDvD7f6CR63A
48692	payment	2133	2133	1874	1	1	7552	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FE6mpbRpyo9VThsXmr21DuEcxrNweyM422WHTQoTeLBF8bY3
48704	payment	2133	2133	1874	1	1	7554	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WHtsmVLxi1FB8RgZ6JQXh9xzPNVaMWVQX7WVgRMJBps89V4L
48488	payment	1397	1397	1678	1	1	17950	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYphL5FPLdxgciyBS1DVDJAxDdpURWWC3xQ6CBUCTbWUdQ8v9AA
48489	payment	2134	2134	1874	1	1	8001	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmaoedY1zzRrsgCF3StxWymU6N9nLdrZAkGQPGEryGeNGYBpUY
48490	payment	2134	2134	1874	1	1	8002	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHVsWB86C6ee2X8NNVCqSKdtmrZNA7SjQPnTQeQfGD2BsLxotF
48491	payment	2133	2133	1874	1	1	7490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxWmM4h3DYFuYP3A1EAQ5rWp8Fb4AXGh3LXAkpuBTtBJRYCDoV
48492	payment	2133	2133	1874	1	1	7491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZciUuaPahTW7fyUeDkw11viiQNbxAGsL7w7sriM1CeozWsYHcL
48513	payment	1397	1397	1678	1	1	17957	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E9Kjd995S4k9DCc1gRiBcdXhYkUt9qWB3WpzfV5mFrNJEk72
48514	payment	2133	2133	1874	1	1	7498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9Nc244E4d21nYhNBnYPwLzxwSeAmbfM8G3PAtyozFLGgGik6
48515	payment	1397	1397	1678	1	1	17958	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUjFGz2HRmKDiFdWkkvAGhvAVSk6GQrTGFRWw3YrwXHuBP87y
48516	payment	2132	2132	1874	1	1	1963	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiFaBbi6vtodMpb7RoXyyvxQXAVRVeJL1GUtQx2L5S8JwBWuS
48517	payment	2133	2133	1874	1	1	7499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaG8C3oFrQdUGTNyJnkzsTn1VuWE12tshK6pthhnqXfsYdtjB
48518	payment	2134	2134	1874	1	1	8007	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5YXvLyoSwSuTgUWyAf84C9NQg7YMTUTx3WKtoEFH2DM4VnPa
48536	payment	1397	1397	1678	1	1	17964	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL3C36hhvhyWMjFgkm8fFCrrzAQLRfHaMtHQcnkrj7CiLoXdn1
48537	payment	1397	1397	1678	1	1	17965	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4vbGuJmWeEVnagUdMBsHh5UvLGAhmsCwj36Qt2Aykvicpr3mw
48538	payment	2134	2134	1874	1	1	8012	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVqovxDmZW3qioQZSYpVU6bzk2Qc18yojzkHNTwP2i2pbSUzYb
48539	payment	2132	2132	1874	1	1	1965	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyD6rcV1cNPrtsH6gBNSNtiS8SsNtRD7if6nS9C9SYT1yHrUXr
48540	payment	281	281	1591	1	1	1	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8sJDrgCSA3VBXXvWvZ8jhBrJnxzdk4Nnw92mchPhtAPfzbZHu
48541	payment	1726	1726	2427	1	1	8363	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZKNx4jyfn6B9fz9piA2jbhTsdPsnJpteneXY3kZfXURRfxUCQT
48542	payment	2133	2133	1874	1	1	7505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgmMQ7FHTPzKVLCxQLcWTWRs4WZymViWVcfPReXA2v3E1vYzA
48543	payment	2133	2133	1874	1	1	7506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9VF6mmHJLyvbfZzzPYF2aoPiaZ4wKsWPrFskJaqHpCs6yjD5
48570	payment	1397	1397	1678	1	1	17975	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD56rfw3vxjEMDyo4vgjg69fhqLhXRci8fqZAjebQZk52waQHn
48571	payment	1397	1397	1678	1	1	17976	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqm6NpfhchcFEZUZeyNKP6MbZ2hL1NspPKMhaJyEWMKkJxuhhV
48572	payment	2133	2133	1874	1	1	7515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyYhTVx6asDJxSGJXNLuqKbTTgRRXhfS94aPF4CGd8vrEoGn5
48573	payment	2132	2132	1874	1	1	1968	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtsGY9m9Fw8Bespv2dishGkWJjuh6ArnX5i9gr9ceZSgvMdQ8A
48574	payment	2133	2133	1874	1	1	7516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa24MgiMMZrvatJFiwgfSoLv9ycV1REFB7jRKKHkJVYMkWawWLo
48575	payment	2134	2134	1874	1	1	8020	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsxtVLv1JgmJoaveBPp6HCBHhSfBb44ydm5GwdMq2YCcMcCvr
48578	payment	1397	1397	1678	1	1	17978	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYykFt7AYArFdEXYGLdL5yTBEkT3hr9fam1mVGbYRPFeHu2BDgg
48579	payment	2132	2132	1874	1	1	1969	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzk52NPBq51PBsuSJedjYYeiJPawz9Ti6Gk9U4jh9B89GRE3Dn
48580	payment	2134	2134	1874	1	1	8021	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2Y6zajQcemW8rg8KiquxBqGGbyBvVF4yWJ51tr3WTGZYfRqi
48581	payment	2133	2133	1874	1	1	7518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4oV7koXLokvZ8hvg2TUV5stoAgLNg65HrecJMrrSqreqfcTjZ
48582	payment	1397	1397	1678	1	1	17979	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkrDTNdugZsnTZXywGeYFNPkrxBKMytQSWsa7aqGR3fYcgqJsc
48583	payment	2134	2134	1874	1	1	8022	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagoDp7wiMzWQPaU57jamQKrSe5nDUgPuUj8w77FhVa3TUmNAL
48584	payment	1597	1597	2428	1	1	5	1200000000	1000000	\N	E4YVcLG59cWG1h54yu3vNi5z8eXei7VNDc1FgCqkdS2wv4DtVs4e9	CkpZKzgyiSPQ1etb2N5mPRz9cCyUR3yc71qJpBP2NacfaQhH6wfcf
48585	payment	2133	2133	1874	1	1	7519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA75jybHq3vWpheGvGSyUciEBz5KV4v1vCYXzLm7FsP2xjV3hx
48589	payment	1397	1397	1678	1	1	17981	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFuNdsawTCiqytArK6XKaFBDvkEVqKfEyt58sXuePgfevXV2G
48590	payment	2133	2133	1874	1	1	7521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXb5KmyYotGJAKJ8DGU37ffvJN8i8ZsDq4v36jFv6hTNcdyfa
48591	payment	1397	1397	1678	1	1	17982	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa529yxtiM12Nnj36vZ46j7DTrbGaWGaswQWnKU9X23qp1TFPxe
48592	payment	2134	2134	1874	1	1	8024	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDWYMxy7CpQV8Ap1yvYzDnuwkSTD1MktGxhtMJogj1tSmSdKXA
48593	payment	2132	2132	1874	1	1	1970	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLixVNPdJpALjqXiALVBj1UZBHsQe3KE4C3tQan3PjcXduMY7H
48523	payment	1428	1428	735	1	1	2	1100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsp1DzxvtP59ySvRLt2CxeBSLo2KSAv8193K4BqL2cF7bRwZHz
48524	payment	1397	1397	1678	1	1	17960	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHYQyeVMEbyH8tPLRo9vVUP7HhMmPGnkFKr9qoTdFngfqoupyi
48525	payment	1397	1397	1678	1	1	17961	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXNz8u5CRmKGrLd4awe16afGHuuPc9SpwwgwE4QbdSx68myRXk
48526	payment	1397	1397	1678	1	1	17962	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vRMnQwqY1yL38jqk5s11YuKwBBqEx7ySktftCdFvMuPhW6LT
48527	payment	2134	2134	1874	1	1	8009	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7iX2T9Rx6S78mKwwv5pVhPeYNa9T9STt3J3jvTW24wr2qDve
48528	payment	2134	2134	1874	1	1	8010	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTcfxfr8Sebkq8ZqXh8eeoT1ZGLsEGU1hio2M6fuqWF9Pt2qMV
48529	payment	2133	2133	1874	1	1	7501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjJKeuCoEMLP1T7Xf6o3bhdXRCxv5UYZDsCwNZk68H4Jx6a6P1
48530	payment	2133	2133	1874	1	1	7502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdFZwYgNWD8fdxvWr59PWoAbNNQj1fvRGWXnJ7ZsZXqjjPtYL
48531	payment	2133	2133	1874	1	1	7503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXZ6TqLFjYm3kdj5EMLfLRXfURsu9CTA2r4HPaM85EhBVpeHXp
48532	payment	2132	2132	1874	1	1	1964	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEUdU4HUMyyhwppfDrPv8KWHitUhFF3yAFuAW9Hf5dfs5kCH8j
48558	payment	1397	1397	1678	1	1	17971	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPD1DRqWynS7ARaKxC6J8NuWePmmpc2W78oU9gzcS4kZU6ajKo
48559	payment	1397	1397	1678	1	1	17972	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYdd5VbPvvqudkpgVWbSwT5u3dtDNmzypxNqjwRs8qXYeBBRZ6
48560	payment	1397	1397	1678	1	1	17973	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa453xUnJR3vPVwHXPoz4UsbM1YugYQj9xuMBiBa4K235rTgM3q
48561	payment	1397	1397	1678	1	1	17974	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3oBwM9G5HAwrvY9VBAE4Gp2bzFKeNeirN6oKUW9WR3658qv4b
48562	payment	2134	2134	1874	1	1	8017	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDzZ9ds7ML3ejBWSCURCQd1BnGViempZF8442UPB74vYtHH87
48563	payment	2134	2134	1874	1	1	8018	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsGNjp3CoYzmRNKXjpUA26pyAxoLP3s9rcWBx4zbusxZQ4nSZQ
48564	payment	2133	2133	1874	1	1	7511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNdgLjFgZDK4oxPE6qPxpeHL1F4fuZ3VjDTjFj6PAnqJ88Uqu
48565	payment	2133	2133	1874	1	1	7512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL4Hnnea733Hvab9DySuezF93cwrxNSoBo4TUb8rs3Va92eVyC
48566	payment	2134	2134	1874	1	1	8019	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjnkbgFH7zmyXj3DrRTQngjP7eDifScRoUNFAcjxCtftmnXQLd
48567	payment	2133	2133	1874	1	1	7513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2iebSF88NVUTwuKHCfyZXLGTs9oecJZSrPzbFAqAezqVMpTDN
48568	payment	2133	2133	1874	1	1	7514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhQZ9QswpAwqQ4ipgLhCN9DdLozxZEg8W5A6hQcL5r9vxfeyV
48569	payment	2132	2132	1874	1	1	1967	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa96xov64xRzrYn4wS7ww4FGbfb1qcfh7moVJoH4K2WdCoRfzLn
48586	payment	1397	1397	1678	1	1	17980	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKsHKJtZwexWT2b3A5vGmXK5XSu3RgaMwuV99oPFjxjLQ8AKwh
48587	payment	2133	2133	1874	1	1	7520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVbSk2N9Aj1MTaEeGHTKvrwMwFDTHsreea7dKzrnzVvDi16WW
48588	payment	2134	2134	1874	1	1	8023	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2vo92A6ETQ5EKP3rPH8swQBzuPSShwgWE4DfvvHgVJJs1GjC
48676	payment	1397	1397	1678	1	1	18008	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXcm5KPzn319Ey8YE3PwK4o6Kr5HnuZ57jAPxA2Vs8PYFk8h4
48677	payment	309	309	309	1	1	0	3000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEbp2Mjq7Kham19TrGpUWRRcEf5pZQyYpM2sZaQVoS6EDUrxhv
48678	payment	2133	2133	1874	1	1	7548	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iHaoB571zzZp3XwYMPRW5ZNztsosiUREFT5a5VQ3LfjZyFjJ
48687	payment	1397	1397	1678	1	1	18011	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXbhmLqneRFF5gPRCBWpShV6jQs2wBEcvtowHdGQkc8PCyWGs8
48688	payment	2134	2134	1874	1	1	8045	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2GyyGDfFGLAiCR75Yz9HLibWkhNeRVMbCRNMtHVkX9GXfcJg
48805	payment	2132	2132	1874	1	1	1997	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGfyGbG4N5XTAhYRKwKM4HXB3sW2uDQHrxwuXMfhXgHGQeFaZ
48961	payment	651	651	677	1	1	0	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh2sGQKf35Lr3NFjxbkKtxrgK3J2GMLpGHm2pWwYYMtpdkREAb
48962	payment	1397	1397	1678	1	1	18042	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDrvG1A6QuKZdxaBuRV1xQftLnu8bjUYVT9v5YmZjsCFwcnLDS
48963	payment	472	472	1428	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj4UoxXBCtSmevc8fWRwGC9tmZDjjwChSTkriYAAY4U9F945L1
48964	payment	2133	2133	1874	1	1	7634	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj4muuhuh5j1ZFRZEExRYVBBfiH2HENruVXbMNGHP4SXWbhBuZ
48965	payment	2134	2134	1874	1	1	8147	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzBPPNHhmnruftYkH5EkS6JHgCfqpL4sfUMRosDXqHwMUzXX3i
48966	payment	2134	2134	1874	1	1	8148	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uLWjFYc4sGnoWzjCujYUzw4KzjQyHqQ9gKoR91inaa6BWDkt
48967	payment	180	180	186	1	1	0	1000000000	1000000	\N	E4YXPnp379EAjxe6YZWiu8n2abZM4GuCpa2pZyxc7SeJfcu8BUjsL	CkpZS5Z8o89ANPj6qtXUs3511FtxC17Rxes1f6udaGLvQDJwcrDrA
48594	payment	2133	2133	1874	1	1	7522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaaMsMcQ6Vt36fnie1eRj5bsjqCLU8491RhZg4tp3yrQFYjSRn
48598	payment	556	556	1578	1	1	0	23000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaERuZViy83JNPhKWLbRnpSziTGUVCGtu3kGmjq27NHXYVUXmWU
48599	payment	1397	1397	1678	1	1	17984	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYowhdUDSiadTKoASqTyAyPt9fXWrTaLKhbXyU53yyTNFEsP6nY
48600	payment	2133	2133	1874	1	1	7524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7qnUzfgcvuCzTqoKbLfYy5Ct49vRbk12dEjZN298cgth6Xv2P
48601	payment	1397	1397	1678	1	1	17985	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9tgSM4tbkh93xHmHXfgSvcjDHfA52ytLpsK1VqZ3QQDyyJF4
48602	payment	1397	1397	1678	1	1	17986	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi3Fe3K681GrDGfoCZ1KirmK2YeNG96s34SR32gCw8VGLCPVaJ
48603	payment	1397	1397	1678	1	1	17987	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYok1MkE6i9aKpZyQpTafJxca2Y1VF3BZGhsX8wUqkrzLZah3BP
48604	payment	1397	1397	1678	1	1	17988	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtDurHQxVFiKfzmuEeuKSWNHtwEeviSg2y2wEQgWkDPLMBsks
48605	payment	2134	2134	1874	1	1	8026	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ACy984CyYs8gJuKofzfG6YVG3iiQGQezQswvJLS6iLKKrSfD
48606	payment	2134	2134	1874	1	1	8027	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQsux3iqHqHBgqwoBAUFFsXqPHa3yN37izaC18LexY8AvibXf
48607	payment	2132	2132	1874	1	1	1971	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtET8AETWJw8d98v9XkadMiQrzX9NXQRJsEpXU4PpoNKp5haS
48608	payment	2134	2134	1874	1	1	8028	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfM6zSgafwviGYPkp8XbiFZWS8y61t9hz3dFCqgU6ZDh78VQs
48609	payment	2133	2133	1874	1	1	7525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxNLqb2FuxEpKg7cFVycQiMQg7aXQiFtT7WmzdDNvP3auVvGoL
48610	payment	2133	2133	1874	1	1	7526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2bY7ayzcta14K73qpADox5ozKFf4CzAFJDhR2NmLMHoUCJsxB
48611	payment	2133	2133	1874	1	1	7527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFQ1VcEZA752yK2rALbqhh6aa5f9APziugCR8xadPCLQCbG1Jh
48612	payment	2133	2133	1874	1	1	7528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLncjRGE72dFoXGmWn6VWnEwEUu9BJfkpCkreVNFBZ2BHAJ7En
48613	payment	2132	2132	1874	1	1	1972	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAayAHEFLkxzFrY8ARuHz9XztGiD4tzgpMm2VDVFTAYMhoe7um
48624	payment	1397	1397	1678	1	1	17992	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG3tqE9XVND9LRkp4ncF96AKSPCS92MCeunAZBSrMA6RpnrXak
48625	payment	2133	2133	1874	1	1	7532	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ11xYgXUgK4dGWnepaodiSwfBxdnYG4iM8HtXD6Ddsi1pGfoE8
48626	payment	2132	2132	1874	1	1	1973	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx5iG3FCZvyJ3mGLwMWANZGD2L5gm4g3cH52mqbboZejEXM7Zy
48627	delegation	2425	2425	1483	1	1	0	\N	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcKw735jxgMiF36SuL9Lz9k9bpVr5CV5Cq2ZeD1SzTZzo3Yuif
48628	payment	1397	1397	1678	1	1	17993	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMKpqwtXGEehuRDjpEw9KQXaQmBnJLnmixFx4Rqp9dfiZMMQ1
48629	payment	1397	1397	1678	1	1	17994	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVYaSGR9qHpyKErmVAzZWGNbiSRx5zU2PUL2yLFvQAuM1Cdx1F
48630	payment	2134	2134	1874	1	1	8032	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuxcTzpG1uEz8B4ecvmRyE6QXgp7pmrXDZvgbu7Nky8u86ss3T
48631	payment	2133	2133	1874	1	1	7533	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkTi8aVzmjDjiz3QxGN3JEHcmnD81RFzksVgXBZhNam1SVuf2a
48632	payment	2133	2133	1874	1	1	7534	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxTTmFnocTaUmdw6RaYf8HkD13H5zz8iGnS3AhMz1mLghWW3S
48633	payment	2134	2134	1874	1	1	8033	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFLQG5DDhxPuecrZCMYraYSc8aF3Kc82pX8atZE8yJvQTEUCWQ
48693	payment	1397	1397	1678	1	1	18013	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Anr1zJcLDGKW5TfgfVN6tib2UPZE1dZFrew5X57ZbvFf49k2
48694	payment	2134	2134	1874	1	1	8046	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSJ4ZiDmpQLCwjc92ZiTYeUq5qHt48UDrLBB9WEqYq9cGnuB22
48695	payment	2132	2132	1874	1	1	1980	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTKuCjGj3cS6iG81GbtyaTp7tWyL4GVYyqvPfUje47iUJLuvWV
48696	payment	2134	2134	1874	1	1	8047	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpk9hrmzYEeTq2fnDmy8GakuYB5r12y84g8ZgoLv5KX7mt8fRF
48697	payment	2133	2133	1874	1	1	7553	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJg5J8n19h6GgL26BcXjeotbFXu41ADiR8eXuytVbUWgiEsthV
48698	payment	1397	1397	1678	1	1	18014	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpUYwVenW41tbw5Vg6CpnXWfheraPXWKunNiRWhKobMit9iDG
48699	payment	2132	2132	1874	1	1	1981	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdkZfkB7ptuxEqBmWxXNYYLKTb7S5cuTcGpHsLaZrtDJ4ALcDE
48700	payment	2134	2134	1874	1	1	8048	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRHwWH2T4jhWia934U2cVtx27ipDQayhABLqSZdM2VtscM1uN3
48701	payment	2134	2134	1874	1	1	8049	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcJWx9NBJXtXPNXPCSQZe4RaZf2et1bspxaG7E7UQgkE6UNjm
48702	payment	2134	2134	1874	1	1	8050	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJJRvubMtkg4yj51Emk6dWX4zSWfGzf46vdSDUYq8CFce4DC9c
48703	payment	2134	2134	1874	1	1	8051	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RKvvuZjzPjZGwGQkbZMdXCmhnAUpRQ94DoJDm2sfMN1Xu2A7
48647	payment	1397	1397	1678	1	1	18000	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtQHqqk3XrTcZzs6HS2ydMcW4gM2D9XqvpcqS23kxGQHP9yxeC
48648	payment	1397	1397	1678	1	1	18001	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiCcjGivMVt6mFJZ5MTTZcpY318LFnA6q9aM7p1BtUGEhjSRs
48649	payment	1397	1397	1678	1	1	18002	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw3DbHcNkvv1522xu15Ad58A3YtY9Sz91TxDHB5AgrzirkavKC
48650	payment	2134	2134	1874	1	1	8036	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVS8ttq8KDG6sZ46oE82mZLRZEeJJBo9V9TxBcuobWLwy7Qpin
48651	payment	2134	2134	1874	1	1	8037	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRKbxLis6eEfHMp6szBxKzWBgnm9rsfCyCDE6xXzoZMgVnmG7
48652	payment	2132	2132	1874	1	1	1975	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2mLLQBsu7V8fdetwB1Ca1bt435ZQk2P67qmSPHixtPT9K1Kir
48653	payment	2134	2134	1874	1	1	8038	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwoqhwvuPxyWuc8Fta295wC72Tf8cUjy2czbFR1Ui6cUXBRWVu
48654	payment	2133	2133	1874	1	1	7539	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy8rhh2M5CpYsuTzekMFebCNf16NeAND1gJGa1KadWZRfHYkut
48655	payment	2133	2133	1874	1	1	7540	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNpR8DJd46wdH8y5LmdfTHjedLvLz8K5mQWBNtGpAXYXg53JF
48656	payment	2133	2133	1874	1	1	7541	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBgbfkkUGLKEBFe3ZWtcTgd8qrdbF2aD96txSgPfUoyeiPiVjR
48657	payment	2133	2133	1874	1	1	7542	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZezipBoJa1p4784oqMeovs7ZuR6TgKV1RM38iVsRrPUVxSw1ir
48658	payment	2132	2132	1874	1	1	1976	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEdchQktPtcU2CVhZwZ3bTeDerVHdZn3YmKQ6KEpfkT2pN2b5r
48659	payment	1397	1397	1678	1	1	18003	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzdGF7N4W4g2VsccMcypTuVMZYPjUZfQwxYaQrHWhKKBXCUJFy
48660	payment	2134	2134	1874	1	1	8039	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYffo5FWTEBBSw6k1kTE5GdLJgeH2v3FdiRJqL6LAzrqsfn1dP5
48661	payment	2133	2133	1874	1	1	7543	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhi9gk5ybttxSfmh17ZQXcVMXcMRWAn2kS8KCQ9gcS2bwZEF2W
48662	payment	1397	1397	1678	1	1	18004	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJ6MzpnSqanWSvyxfqTU9JNBdeq5a8aQyF2Ey8cStxs2fJCR9d
48663	payment	1397	1397	1678	1	1	18005	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgsNEtPJyVbLu5nRJoeZg58YYtcq1xH3z4Pqizy2sEXknLi35R
48664	payment	1397	1397	1678	1	1	18006	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD3W2CeyzLTwBsmjiFkNtn4oBJwgP8v92JH3oJ1inJp7ezJQQf
48665	payment	2428	2428	1597	1	1	0	10000000	1000000	\N	E4YZZmcAyBPgg8NMPE6pHENXffHaHo1tbSvhNByXwj3xJByZNR2qM	CkpYws6e3MtyaUJUeUC33mLvnUq8iuFtcMLnF4UDhq9MuyzQZoeqd
48666	payment	2132	2132	1874	1	1	1977	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWhjc18FMvSrRW3ikwtT5HXmUg36MT5qN2u54KBQ8Dg8ke9qYQ
48667	payment	1726	1726	2429	1	1	8364	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZiWLPMZJCE7WPMJLbxkf6Ls6Q32KJ7FpRhrP2zqMXLB6gege2L
48668	payment	2134	2134	1874	1	1	8040	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnE36v83J4biTPQFuGNjYRiZzGNhuQAsVMSx2AnBWq5NnJFMJb
48669	payment	2134	2134	1874	1	1	8041	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQA2uYc1tsQihsfZ7vTPM2dfTbZ3ZPWaTSwSicXDYYzhcHshdX
48670	payment	2133	2133	1874	1	1	7544	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpE1mnqpBNkCctoehTY1xumeDG7FYLzwNjJLPVECfh81TuTiEX
48671	payment	2133	2133	1874	1	1	7545	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnknJqMi29Pqhq8RtKNP4HGjE4SZnC7k2W2yrNwWeeCH8enQL
48672	payment	2133	2133	1874	1	1	7546	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYie8nC5aWe7QY7LRuqdT9Q4S92cC2RWJWHNzHtPHX4Mj1venDM
48684	payment	1397	1397	1678	1	1	18010	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUZKmUVpW5Kf27145MA8XdnPnb2yLTsURhTqMAAqfQ2tmnwNay
48685	payment	2133	2133	1874	1	1	7550	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQmKBjYa3wxy6afZ3bCd1FrYkjZzvja9h7i1zyTTwBfejfxGcs
48686	payment	2134	2134	1874	1	1	8044	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvHxvSDRGHGY5YB4MqXDNUzG4Z9QKyUbrVtKLwQUCsp77supF4
48689	payment	2133	2133	1874	1	1	7551	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBF56aNUJtNNgJfbce2kCwaKeHXuzVwN5SSNbN93v3M23kTBu7
48707	payment	451	451	1646	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAiWyNt9AJCYRjxH9HnfBAync4a1oUEWzqKG4Gw3rdfGbob9e4
48708	payment	1397	1397	1678	1	1	18015	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Wxhgn9ZHgrDSrrBWa4G9Vsock5YsLQoGLywZy4W8N2qkZHh8
48709	payment	1397	1397	1678	1	1	18016	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa19zzeansE4ZqDSXWmxkVj3UBwuJRVZjtF5GXGAY15y2uzEVjY
48710	payment	2133	2133	1874	1	1	7557	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsrjmZ4hE9CNohpwRgDpFMuyCKxMNwF3j4HvGyNmrrUGfHT9n2
48711	payment	2133	2133	1874	1	1	7558	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEcuniJY8TVR2A2Yb9mjNbM3Sp1RSHmtAAJritrg7FDGeXepE
48712	payment	2133	2133	1874	1	1	7559	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2XDprgY55C5bsbNKHy8szzsJCc5GvYutPH1GAcHwzJsGEBi4p
48713	payment	2134	2134	1874	1	1	8052	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBsjbrKpYcL5jaE5RJ9PML9ckpbqsYr87SVNDV11Wmsriuffkr
48714	payment	2134	2134	1874	1	1	8053	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSgNMagDHsj7HqnWXzGkYccdWTjdsD7eCWLqtMroxDgdj7opA
48705	payment	2133	2133	1874	1	1	7555	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAbvCJXKQZvQmxks8uDWwyGAGVigUoCycwKn546Ko26SuiK1r
48706	payment	2133	2133	1874	1	1	7556	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu58zs4sFAutkpwkbj52gXhsJN8TyinVVRdyeEggwN4cjPf4cm
48733	payment	389	389	389	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwqG8ofUo1nvk6iQH2d6M7kYn8vSKnMRSmmxMxAizasMiU59Zw
48734	payment	744	744	1646	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujyxGPRqDM12dF7HvGnDWXrmXNgQXUHT9RbAXAdoG3oteQLdi
48735	payment	1397	1397	1678	1	1	18018	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtn9DRa1VvnxNd8xJRdDSjs96NjSWwS8kRATE2VK1fEQ9DFHq
48736	payment	1397	1397	1678	1	1	18019	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYLzXbegwMQnJNRDPkRjYCb3kFi6ftRRbR1pQbLNC5Pp2XYtX
48737	payment	2133	2133	1874	1	1	7565	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffWtcgSZh1yQz9a69EYkN7Cm7ARmUgprejXD4muyb5JBcGmyQ
48738	payment	2133	2133	1874	1	1	7566	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdBvbvc5D1PtxTKCWaGAC5BbvmmXFurEMfNPoz9XfZUetqcexD
48739	payment	2133	2133	1874	1	1	7567	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRiAZ7TARXBurSGBariH5T1Ds3Wps6dGpofR4UQx7NfkFSnjvd
48740	payment	2133	2133	1874	1	1	7568	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJajTgQvdBWXUPpDFvDu7umKM6so3V2L6fSwJsrXmGubHak9W
48741	payment	2133	2133	1874	1	1	7569	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gmsfnoSDD8LUhzmbxRJN8GuAKu1tFw9juDcNPQazrn9VPzuk
48742	payment	2133	2133	1874	1	1	7570	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1HZGkn8LdzgRiYLEAXJpnzktXH8uJCd1Lte7tBKfQnF9AqYLD
48743	payment	2134	2134	1874	1	1	8061	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Q5LaXB4zZQsF9Jd68PwaqXVfgN2g8izgCK1NKduCbWDW4EXi
48744	payment	2134	2134	1874	1	1	8062	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTT5Fv6JteBc8LN6LV4c5SzgAohM2rpYFXV27McxQQMkQPavu2
48745	payment	2134	2134	1874	1	1	8063	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcjkVuSJw69Ls6jFcGMn7LDysaAvtcAEKvK23gPamMxDHQWouW
48746	payment	2134	2134	1874	1	1	8064	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCiEHG3iaaXfGeZvtxbCJ3y7fk3QsvdcsYJg6dWyGU4Rq6DrJd
48747	payment	2134	2134	1874	1	1	8065	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAscgnTZVqt5MTcjzykkJ8DtehCpLurvWyjfSnNtzL6BZrqvoP
48748	payment	2134	2134	1874	1	1	8066	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUmgr9m22X9XBfERF2PwHxqyKPoeRY13rQdwhgN1Gx1QqmVNL
48749	payment	2134	2134	1874	1	1	8067	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfSw9d3N97LV33mkoy6BkqFnM5cHP3hnZXvb2XkCCVJ8MpunR4
48750	payment	2132	2132	1874	1	1	1987	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL4JzsoMdYe2bcT5thoQfkJrrUhXFJktxY1XCvPLjth6mp8jwa
48751	payment	2132	2132	1874	1	1	1988	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmYK3ooJbeXHCvKFaS16RaR4cb4TnxEbCQJGxvXKkNVQZpA4rp
48752	payment	2132	2132	1874	1	1	1989	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6PeC733ADCb8Qiz2vpLguboHonBQqViQEeQvHWA8QBQjeNT2p
48783	payment	2134	2134	1874	1	1	8080	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVfUAqNcPQyhYceUcpMjPqzLXwFxeH6Qdc7ZEWjWUzEDT2EZ2Z
48784	payment	2132	2132	1874	1	1	1994	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsFiQ14aAkS3J3FeLCQog2h3oRuSuWfLXU6a6PzfLoyTi2R6dN
48785	payment	2132	2132	1874	1	1	1995	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnbVrbeDER25QJivus3tF6d817d9qYaUFPmznZF3uuX5tpxZzs
48786	payment	2133	2133	1874	1	1	7580	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAkqHc4cLK9nX5WyKm3MouNHV4eirjLCDYtBhLB5eoQzTReLD
48787	payment	2133	2133	1874	1	1	7581	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCtkKQxPt5ksEfrENdNaC9Lt2pYTNxvTMWcBNrpkxx1Kowzvq
48788	payment	2134	2134	1874	1	1	8081	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwBkU3bmj8KjAtkhNoYD8fAYbT5y1291UH9bPLhDyagim4gpEw
48789	payment	2134	2134	1874	1	1	8082	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa94Qxx5Lvqz5s2zSErYGPdzXkcVNi1tJt4SdJHA6sMz3xzDN7i
48790	payment	2134	2134	1874	1	1	8083	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUk14guquYMdU4msyn2Yh5KQEusNgdTkGUxYNCP8JLmCAv4NJ
48791	delegation	718	718	718	1	1	1	\N	1000000	\N	E4ZKwytHYi1tLKQVpehYwgCM9isAogrGvK4Zvhp7A56cv4UePf6RQ	Ckpa9enpkM9aZQ5P1yxyCDFmkq497AHcZ4Y9Yt8zs8wM3VfXbkX4M
48835	payment	2133	2133	1874	1	1	7593	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLNS1DND6LKWEqmQ25de5qGJZuKnGkEKaevQCsmd6SpPrF6gZD
48836	payment	2133	2133	1874	1	1	7594	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKYdnXkt9Y5ZvbrskPJ4C67Zgcf3bQcofzKJt7SXYvJLf9Ggw
48837	payment	2133	2133	1874	1	1	7595	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtU6W9zQfSPhW94SNc7on5LdpyYTsrtpjhTCe9XfnnSL2nxSZE
48838	payment	1397	1397	1678	1	1	18029	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL1wUrVnBMxfwVF6Mw6Ve4bZzE5RY14riD383mRmcjWejkdaRZ
48839	payment	2134	2134	1874	1	1	8101	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfq91USe6ajJd8WHbry3PmCc7yrWCd8aQ6rbphkCeQq5kSZi8q
48840	payment	2134	2134	1874	1	1	8102	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnV8o2Ma4RLQcf2HnqfnzwNEHosQ469EWy6hzqhx1sCrTvjn47
48841	payment	2132	2132	1874	1	1	2003	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfPVSYRmKfmVQ2Y6kk7Mz8vJiAnNADnZWS22XSLmTGE8F1bhP
48715	payment	2134	2134	1874	1	1	8054	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn6VRE8WXVV1vnKSD6qS9t1hw8Ku8GiSM3sAFqBZTESn4FSFPP
48716	payment	2133	2133	1874	1	1	7560	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDDDQ3RhV2zijNYrjTzZ5iiMhQ2Yiq9gcnnxTXxhS2BMrhTrmM
48717	payment	2134	2134	1874	1	1	8055	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFiq4pTohnXYGfYJYaEPLCVieja58gMFdP2L9yRTGdX8RbVKgN
48718	payment	2133	2133	1874	1	1	7561	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHpu4EtU1g4HC2E955KsAMFkcVtTbkDBzzjrsvT1KJ3UYzzybt
48719	payment	2132	2132	1874	1	1	1982	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgfUHTnH6bqjwp2UAJzt92tpac8h84FAPQAdMzrqH94ypn1oLz
48720	payment	2132	2132	1874	1	1	1983	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1QYzTxgsBAuhVZZFkG6DX6aJ4Sf7uugGYR7ZYNWxURpjMtHWV
48721	payment	2132	2132	1874	1	1	1984	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Wwg4CDSxhVxpcCkodkK8tpnXgCHDvDHYUHW6aQaNMi9fsDWQ
48722	payment	2132	2132	1874	1	1	1985	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMSwxKTccjpVu1HJkA851JGSgz1WLFUtTtEebnRu8TPTFBpEL
48723	payment	2133	2133	1874	1	1	7562	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9G7JmZpNtd39jjLFp8gjJ3LYtBk4kQEwh9Tfi5a6stznY88MD
48724	payment	2134	2134	1874	1	1	8056	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMtHh2BcAbrEGUhDpJbcseh3PJXRKympBFyYKZz1Ke4h17oPP
48725	payment	2134	2134	1874	1	1	8057	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NAFUAb1XZjbyMrSZQ7bhobWbDkhnG6hrSMZK5y4cXgjMdUg4
48753	payment	379	379	1483	1	1	1	0	100000000	\N	E4ZRf5ht4bxBXbLjaJWNRAB8bZChdS46ij3NhSGtGnJr5ndUd6r76	CkpaDp2C2mWSQFpGEii1T5tqr2zXZnWWbKRRb2jxrqfgeWN4cVNk3
48754	payment	379	379	2430	1	1	2	190526998000	10000000	\N	E4YxrX1XXDAwicB1jaM3487uDeJdzJ5HsExypxCfWfLFRPpWqyX3M	CkpZaBt8GqWeUcNR1sD19YVBupfceb3LtSuaHBa1HifetAdTucLN5
48755	payment	1397	1397	1678	1	1	18020	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvG3dbceiPEfgevMQqX94vVrECrvsEBzWH3BnNa2Zf948CA1hC
48756	payment	1397	1397	1678	1	1	18021	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7NjXykUHp561oaAqWDVo6EMYoioGj34Ao9J8RntTdsQGYWpgC
48757	payment	1397	1397	1678	1	1	18022	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjc5CLH1CyrMwL8v6c4mVWhH79d3rT1PvExRV1KPy3rnzY9WS
48758	payment	2134	2134	1874	1	1	8068	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbbHChVF3nn11oMna14awSDQG3d5fjEicRwnT4NZzFZLnfgTbi
48759	payment	2134	2134	1874	1	1	8069	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXjyTjeZg1hRHvdcfZRngypqBAsXxACwVfHcMPkX4m6FUHHJ6n
48760	payment	2132	2132	1874	1	1	1990	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdTT7owesp2dYgn56jeAkwrMQgD2dEUdwqLSmkZLZR9fcgvzXb
48761	payment	2133	2133	1874	1	1	7571	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqtgXEu58zE2gdMW72dGr7FxKUgC31wnd5LuiyDHLu5QqcAhQt
48762	payment	2133	2133	1874	1	1	7572	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAGvGtce2NcotnFfFfVtstmM66mqoT6cJmAgqB2TMkFkRVqhX
48763	payment	2133	2133	1874	1	1	7573	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8JaScVtb1UW2WuwvmwWuiHEL9EjBXFn1dNviFSUwcMiNzPzF
48764	payment	2132	2132	1874	1	1	1991	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmArYUspbjaVCHVoxWycPsKY8S5sgLRjD1kecDA4dh2uoDk6Le
48765	payment	2132	2132	1874	1	1	1992	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHLxWrgrmbGfVECu1iosxX2hJT9XG26x4sgvxLtHATUDKvcrn
48766	payment	2133	2133	1874	1	1	7574	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqRQriy7yriY45cWhZ27zvBDWFp3pcQxmN6efhR8Jq5r4X3zuF
48767	payment	2133	2133	1874	1	1	7575	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZryYfHGCgUnQBho636ruxhcvm4d6XX1TGqhZXN6D52jFa2F42x
48768	payment	2133	2133	1874	1	1	7576	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtuJeKev25ZeEL1Uy2W5gruQPAgCQ1hzK8JCegAdxSfCpsV97F
48769	payment	2133	2133	1874	1	1	7577	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwHMPUND2WT38DX5w9ciEdUgWErh98BgxrgUDaGn7Zmvf5QCCL
48770	payment	2133	2133	1874	1	1	7578	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfeodjF6F4942wHtLPY5wteZ8vRSbGKDCqD3sYPT3L3mmsuoS1
48771	payment	2133	2133	1874	1	1	7579	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ64udueWXD6oBvGguCT9BY6GSJtXZQubc2juZsxjebiyjzw5SL
48772	payment	2132	2132	1874	1	1	1993	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCkizz9338wLoxSo5vNnHE8gFC9qSeFgTCz5AMdhhehn7w2QU
48773	payment	2134	2134	1874	1	1	8070	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPbJiynJivtywxeawggoUKcrV5YBkJiLCpiJF76Q5pzbszhTQ
48774	payment	2134	2134	1874	1	1	8071	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCqJeB6ab11cvuXkrHx7bnWCjBdF62PyR3LaVAviLe2aw9E8BY
48775	payment	2134	2134	1874	1	1	8072	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPrvDG5fETW13WTqxyTmHNNiVs8Qf3e4jymQUUz8bGKtYrdSh2
48776	payment	2134	2134	1874	1	1	8073	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pVTyQhoJkvaMs6HDKiTi8wfRyouisrufFeWmnxMotPADVEr7
48777	payment	2134	2134	1874	1	1	8074	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNgvz9QRTTqyfq4oCdwewD4UjMvueZXzwyeFCWC4N62eq7mFeX
48778	payment	2134	2134	1874	1	1	8075	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqEHdubCBMPqwj4CSvFFGuvZD4oiHm51QaVmtfLRRDb66Zmge4
48779	payment	2134	2134	1874	1	1	8076	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvBqvdLdA61MW6xFvxVkGCFKzhYxa2cPXdQHRGEGwh7VbAK8Cr
48726	payment	1397	1397	1678	1	1	18017	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkASKUNweuJdNfWThkXxwHKEtYgWsCL49EvjDzPaUwuXW2Qzn
48727	payment	2134	2134	1874	1	1	8058	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrzpgZMbMpAeW5PiTNdCWZwEHxMGrhgrpxzgZM4UYWf2hdob5h
48728	payment	2133	2133	1874	1	1	7563	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9W6U6h6iJAP7sAiwtvFjvYttBa8Egx7wVzVJd64fMGYdSywBB
48729	payment	2132	2132	1874	1	1	1986	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWF7D4Y1XXDiGFPtXAHbXq2aJpwVTCACfmrXqML9Htv1uFNuzF
48730	payment	2134	2134	1874	1	1	8059	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZasVhdh93yENmd9N5GhYYQy5K6raaTR5U95ugRDncjZJ92fb4S
48731	payment	2134	2134	1874	1	1	8060	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjwBaCanbWZ48Ggrjm8mrkmpz7KiG7gh9vqgHNvZzb2natfoj
48732	payment	2133	2133	1874	1	1	7564	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB65j5LsMoLyUWqbsQJqMoDFqSohysR7uwk7MDgwCMwD8wNb99
48821	payment	1397	1397	1678	1	1	18027	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfPWw4utJZPUoppjhLfpX5WT1FoCuaFwoGR9cDWkeujLiNRdBf
48822	payment	2132	2132	1874	1	1	2000	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHfS6JUaZepCa4h5WeqE2i5CXN2s3yFthQyf79GpHYHjSLQcH
48823	payment	2132	2132	1874	1	1	2001	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CCSMEHrFJdbWMz98mGs4wwBP7DYEgTP6EGkPA91L6AfYhUUL
48824	payment	2134	2134	1874	1	1	8095	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4xBzThhk6wS3XuatFc8AhoT7uDRzDKv1viT29LD7TyN8dbYr
48825	payment	2134	2134	1874	1	1	8096	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuG3kVfowrH7P277UYSue9F6KVuiHjyewnbp18VuxMNyMwvvL9
48826	payment	2134	2134	1874	1	1	8097	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa69cVmSdssFF1XbbRKone2X1knPipF8VC7b2aNe8ikEbJUJCft
48827	payment	2133	2133	1874	1	1	7591	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZ5uMiGratM5UiF72Avku4L7RbRxxMCEiEvuGeJhY7cFUPRi6
48828	payment	2133	2133	1874	1	1	7592	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTz4HiSfAh2JdPQA9m6rAEsPwHrewEeqbpt95F6FUqfTZLBp9
48845	delegation	2430	2430	1483	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTdVJT8d1hNC5kr63NYgKxhxwAgcPec1miJ8AS8yB1gxcWtVVU
48846	payment	50	50	2431	1	1	0	770714905251	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncguppCuyCE7cAboqWMncHxiuUPy7xUXBKN2PqAjNTTcnqSGu
48847	payment	1397	1397	1678	1	1	18030	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkdbYNuKFqTzW1Jjh7cKrpLHjGAwGptuGGuP2HJ5ubNtKhaKp
48848	payment	1397	1397	1678	1	1	18031	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZehbsf4XJ1r9DEXrNCkba89seCsyfSs3JEnzmD93QABY3PfaPH
48849	payment	1397	1397	1678	1	1	18032	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQkhRqz8fsqk67uBR2TRQ64FMb1eGaP1hHDTMCQJocqWJXAPr
48850	payment	2134	2134	1874	1	1	8103	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbc1AbAbDcNp47pTTP8Zik2pFBwRkndnWDSmXiFTbKZTuFvD41
48851	payment	2134	2134	1874	1	1	8104	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm9PJAAa3UXeu6nAkeh5HxPzK2KdnMMvWGXKaCSL974PvBvqbv
48852	payment	2132	2132	1874	1	1	2005	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSiME6HqxYjhvfrKWprVspf19YhNB3d8X3fv9C4QHZR4xN8HJL
48853	payment	2132	2132	1874	1	1	2006	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPzfZVbpFCmAn4ushzatLSGKvckYwjm6WLVMbtBEhixzvqz2p
48854	payment	2132	2132	1874	1	1	2007	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkK4thLZQxWVR5T6Kj94cBh7CjeWziMZ1CqxzxGf5nx779KLAU
48855	payment	2132	2132	1874	1	1	2008	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdhEzELbkVtLbRVaLRj4TVoxqTUx5rKwkpx419TYhh4KoLbZmr
48856	payment	2134	2134	1874	1	1	8105	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1utHKt96Ncng2wMq8C3bFwNHkEAjzxTVh55dhpTaLfxjLqr66
48857	payment	2133	2133	1874	1	1	7598	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2otabTMoqWXR39s1eSnMNWiEone2tRLUtTswzmeZqoLaq1WsG
48858	payment	2133	2133	1874	1	1	7599	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnMg7o51jULUTP9CwAHREdUiFTM462XNE9YNpMJisVwQaU3RJS
48859	payment	2133	2133	1874	1	1	7600	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrERgLmVy9GUy77CGkBcwyupn2NEh7Fa2fDUjjLavjdKfzyuCv
48860	payment	2133	2133	1874	1	1	7601	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfQ88mr5bPMRhgDnJ4DbPPXjBUmmUqGx6kkvmYK4N1wgpeFYcZ
48861	payment	2133	2133	1874	1	1	7602	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtwR5ssuWefk5Q2tEJtfvdwRBHHbfojfnK3mb1CGe5whU4Yjei
48862	payment	2133	2133	1874	1	1	7603	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsbVySJiYQ9oMS8fiY9odCfKaEiSTqwkFmZoTHBa5yN4o8zsXx
48863	payment	2133	2133	1874	1	1	7604	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtXh1wAsd6ML6zo34K14XSDkcYrigWojCRjPzJ3yWSyBjUSevC
48864	payment	2133	2133	1874	1	1	7605	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNwguK5HjrxDoiTSRUKN72xZCTeEUpzRdPoCFbrar52EPLZLR
48865	payment	2133	2133	1874	1	1	7606	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCENgL8upFeuxAMa6mMHYA62eSWn23X4KLLY9See9qtZjmGnAC
48866	payment	2134	2134	1874	1	1	8106	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9n3ESqsCaUAfmi6mpTiB6wtcmm4nUU4G33Jy7ALNaL4YmBWQU
48867	payment	2134	2134	1874	1	1	8107	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmV3AonUNBkF3f9X3kZeH1RQggjj7AfLQe73AMxxMKw8PjXY7
48780	payment	2134	2134	1874	1	1	8077	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8KTqRANBoHccaS7e6W1QG9J6CejWDqPQ1cvCixcBJLYCNSHqn
48781	payment	2134	2134	1874	1	1	8078	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCWfupcFvoWfgHxjHWuftdi6PXekSWSoFmYosPPWREbS7P2s5s
48782	payment	2134	2134	1874	1	1	8079	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKnyWVKAdeKCjnf3teMiw9gHYFCSsipGLZF292fbKEzBgXG3vq
48792	payment	1397	1397	1678	1	1	18023	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGC3pzCNF7kRS8yEPNYfqwVzXXj5wVsGPnCegSAf8zt1HAM23
48793	payment	1397	1397	1678	1	1	18024	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VBirCvcKWMbQu52YXkhXHEj6vG8XHXA8JZF8Q8GSembavuXp
48794	payment	2132	2132	1874	1	1	1996	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYyNo7V73vf4mJMuW2J4rQWh7cm722s8g95LrvXBWVKNBUdPVe
48795	payment	2055	2055	718	1	1	1	1000000	1000000	\N	E4Yyk7ir4jPmppNr3sELP2QryGmG9sL2s2nS2rou7uFt1eb2tmcq1	CkpZwUoJnA6ZBNFmm3t5QD7Fr3Dtj5VTzcsuN2UZAUJeLiuvbhg68
48796	payment	2134	2134	1874	1	1	8084	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLU46Am9NZXYoekLtoTBWY9H2aPjpKT7ordztsbWQLNRzU4qe5
48797	payment	2134	2134	1874	1	1	8085	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJT3XebX4LfqpRxJhSAFqN2FZdYxBignfq8Qq26CvB8rxU1tXQ
48798	payment	2134	2134	1874	1	1	8086	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWK6S8WumMzjHsqwNRMzZLq5PZsDqUP1GFuq2vGKF1rSXn8Wo
48799	payment	2134	2134	1874	1	1	8087	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwQY49jPy2mWsLTxepW1RvoBhKBw2a9oNf18VeyLt5CnKfVnM
48800	payment	2134	2134	1874	1	1	8088	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeWochhwPpd7zJasRY9PoG4JEXTbGs7n8Y3b4btd3Jw1ZKwqsU
48801	payment	2133	2133	1874	1	1	7582	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKV53gwR4AUzVjb88iAFCNUDsQdG72zFF9bo6ozM2krZcfKVAp
48802	payment	2133	2133	1874	1	1	7583	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTmMPh9R96hsX88hZnApEwWZsGCRNDfDWwpzAzE9WSQUK9nh6o
48803	payment	2133	2133	1874	1	1	7584	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9gT4tgnRKCSry6w1xfY2uceTcBkRXCA2zxb4yN66Lvy1ZpaQ2
48804	payment	2133	2133	1874	1	1	7585	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjySa7SnvpFwCnrCxUYGwxGRXmM9vn15Zhh2Tf8v5hy7GADs1
48806	payment	1397	1397	1678	1	1	18025	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5zVZiYBKR1uBDnQvv8VtXQX4beNCLvSFQsfLB9hLP4uNFYao
48807	payment	1397	1397	1678	1	1	18026	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjk5qeVLeuYUQiXg1qjscbbEhkA7JHYpCr9s7NMwydkCy6JQto
48808	payment	2132	2132	1874	1	1	1998	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt94MJqFejaWX5qMRGvujqwdkrtk6YtT891E95E3SUgoqMoVFc
48809	payment	2134	2134	1874	1	1	8089	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1nBFdSqjrf8JRJgQFtAyETbwvXNugRwvcmJkxddEaNRyMtZzf
48810	payment	2134	2134	1874	1	1	8090	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ZyqwpUDUk16RHWixWxbQuU875a8s4KLVSrqR5U8YMvqCSEFK
48811	payment	2134	2134	1874	1	1	8091	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJu8nv5pD1GXE5iHbVrgEHamtohs96CKQKKvGPjPLzE8MB6mme
48812	payment	2134	2134	1874	1	1	8092	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKgMr3poRoDoPVaL9TPPZHFtRTMgQ5DiwjbXuwzYYFLqU17u8
48813	payment	2134	2134	1874	1	1	8093	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzLZRtAxmPCeBFCibxP8EVjFtBAXkssKUTBYDWPvcMk5YHQJRV
48814	payment	2134	2134	1874	1	1	8094	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3tUeUc7tedNfJyLhWKpi9N2d1mFEm62VuhDghGwrTBeY2c7Ge
48815	payment	2132	2132	1874	1	1	1999	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LuVT2HVXD1QaUfPuP1U43k5YYC3kSUUFbtGy4VfHRDFVrx82
48816	payment	2133	2133	1874	1	1	7586	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHUHEd7DTsZdLJY8t3yCZ5aLYYUk2LFXY39qWsuHh47SEGwLWC
48817	payment	2133	2133	1874	1	1	7587	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8AG5NvziGnjzKhTXChbmTWGY2poZnDXJw8eVy2rRwmkHGqyP9
48818	payment	2133	2133	1874	1	1	7588	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnZbVbT2LRqfYopE77nQ5BxCsJR8uSv63MUfKmD9Vf4BMMXyw
48819	payment	2133	2133	1874	1	1	7589	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYghDzY3mGGXYAGLFSAxh1nKmLDvFMWpeWZ7w61VasxVg2kiEVG
48820	payment	2133	2133	1874	1	1	7590	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDbcKntCACT2NRKUu2sSgSxXTsX2R8tnXq86kuaV73Xv3kuLw
48829	payment	1397	1397	1678	1	1	18028	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZFB8YQDSnzvScQdf3qjsFEnTCzvmQs6UQ835qtuPzSJYN2w3g
48830	payment	2134	2134	1874	1	1	8098	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUtxpRbbegLYwhzbDq9fTLN6pQkU6E6JD14rV8Mg4mjjrwApNo
48831	payment	2134	2134	1874	1	1	8099	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4rZtFywVCGFXEaUjiwJXsy89LY7jZFrPa5JApPZtfV5F4qz6t
48832	payment	2134	2134	1874	1	1	8100	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfVyB8PjNZNgduhtYFkzt7HzrE5jUeRrCA8PxTgoZa6AJDFoPU
48833	payment	2132	2132	1874	1	1	2002	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8gdL1SUtoww5gbZhjQBPgv2awZPf59CjfEBarq1SgmEgCcaW
48834	delegation	718	718	1655	1	1	2	\N	1000000	\N	E4Z2YZicix9BzkqqVjDVfjJVMw8TPDgDj45czaVqg7JhfP9bKQfdk	CkpaBk4UBXrBy6Tdev2R2qkmmCqfESnqQZCbH719LnKC55BmC7Pek
48874	payment	1397	1397	1678	1	1	18033	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx5psbBBkSxyfZVW5c1ZKHvAy9UtGV1gKv8k6mESLosC8uGSNz
48842	payment	2132	2132	1874	1	1	2004	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3W9MzTHQTkwGg5q42B2Ry2uB5RjWbztf1nCEjR44Jo283226a
48843	payment	2133	2133	1874	1	1	7596	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8CqSqkEou67e1kPrWCfDQa9B97na1yu3uxVD8vJtp6eMntmVj
48844	payment	2133	2133	1874	1	1	7597	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwk6gNxKyvj3wNQdmQq7DsSSSFzLVMuRGfXWcUpf9bzdsr7VaZ
48919	payment	1397	1397	1678	1	1	18038	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9SGUqjRNkyibUbtB3cxnTXmHCt9FCSJhUt5hQfMUnggS1mQua
48920	payment	1397	1397	1678	1	1	18039	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gmRnq9KR2etMq4CDiUz6kUcZbbMZxiShyFjUR9AM2F5QJ4ym
48921	payment	2134	2134	1874	1	1	8131	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYppWm5UmKyXW5cspxPrfkdf2VzBeEfnQQn5gDsFiu7XfrEWcZP
48922	payment	2133	2133	1874	1	1	7620	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCc8jZFuJcKRfqYCkBxxsJkPvUBXeyjjTvSo9LYPQAD5B4xUxK
48923	payment	2132	2132	1874	1	1	2017	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpG78W8GFuoh4TWJecrm1shWKYXTEwXzYS7EJPznhSEmbf1ES
48924	payment	2132	2132	1874	1	1	2018	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjzjLhGv1vWRWJvtXEUuW7ceyyY7sXxx145KqdwsnbEkUUkEX
48925	payment	2132	2132	1874	1	1	2019	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbZstMjwskRSHG1t2Q6CpWswLdFPSCgZRGqmXcVmxRJfU4667K
48926	payment	2134	2134	1874	1	1	8132	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyJ8JWsSJMDYydja4EHYH3HuX3D8NL3SuYPMrDL6AM9um3zKh
48927	payment	2133	2133	1874	1	1	7621	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwpAG2Wt9TCjXR4LFcVjh8viDpZwuiXwGB1U86DVkt31NP8gF
48928	payment	2133	2133	1874	1	1	7622	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoLtpKfK5vMw43ziKHjXegrCyPgMWZ9wEmDnzE3QXfC82Uhius
48929	payment	2133	2133	1874	1	1	7623	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3nthazBBXWMeEMzaHY9C3DHnu5AfzC3nQHy3baGFGf24U7iB2
48930	payment	2133	2133	1874	1	1	7624	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Kbnyw47MGrYqS1HqQX34biMwPFnXULZHoBdDPiF7PbHWRBye
48931	payment	2134	2134	1874	1	1	8133	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7C1Z9Fbnj3yrWHrbXTk4GLydMnu6zjyCG9YVCN7Fzzwb8wYf7
48932	payment	2134	2134	1874	1	1	8134	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDwHrF6EyggbX5KRncPVMG42cVXob97z1mrdqTdBCpcMmcg1B
48933	payment	2134	2134	1874	1	1	8135	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkrnNn1hBS98B7Rn8QsxTjczTx4jy5Puh9jZJQdaxdFWRG8B2a
48952	payment	1397	1397	1678	1	1	18041	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZewVZjFGLFSG26mVWoFd5Px9RF1uMciARrkQQN5FPYLjbpmaCu
48953	payment	2132	2132	1874	1	1	2023	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9tcXbiofJqB9Fa3BL4f4J7Eh6QZJWorVTyDk6SDD3CN3FBo8k
48954	payment	2133	2133	1874	1	1	7631	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6qZizCiDQhuoGofTeH5deDfHuFvh1qsShAKrKJhAs2USKAdHm
48955	payment	2133	2133	1874	1	1	7632	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4RzH58SybkPuDn7xp2PaiFXjrsHRSKviM9NNAmYQZcgvDrfps
48956	payment	2133	2133	1874	1	1	7633	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRLQYxci478XoYDLrjiokEszGbJ38y65GUd29wu8z6C4qPBod7
48957	payment	2134	2134	1874	1	1	8143	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBi2eoBAC643Txpbeu7yMrG5aPGx6HC7dEH3ha39WdXtNZmmfY
48958	payment	2134	2134	1874	1	1	8144	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8mvnPXFgkrSFQqLVs2bMjatfHzwrPE9stNezkJprJZGdjhzR2
48959	payment	2134	2134	1874	1	1	8145	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWQ5kjj2B1vdS3u3NeaF4SNgTT61XXsYaW5PnUpDmiJmDgMfPS
48960	payment	2134	2134	1874	1	1	8146	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AL33hBHm3vNeKJbVjQqi5kEWQT8u4sA4sYc4p5YBo7n5rCKU
48973	payment	735	735	1428	1	1	0	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVt57hMZAFnB1wJmKihhwrCr4CsW8NB8bantMuTLXBgu4fPxyR
48974	payment	1397	1397	1678	1	1	18043	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBMmjFBDhnBAAp4JjfWvPn5gWeoKq9xFra4ey9jBR7yG9VE7Vo
48975	payment	2133	2133	1874	1	1	7637	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZs3F5hj9Q39MddBUw2XpQLFQLU3DZ1Q3X2i3j6kKh1nPFuh4Y
48976	payment	2134	2134	1874	1	1	8150	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj34qvGMUzCf9wZTqM7C77p9PTKmyjHGt5onD8SSovbXBzwhj4
48977	payment	2134	2134	1874	1	1	8151	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQZpVyWEW9oGtVi5aMZZUReds8EPUtNj6UCk19NkxjTLMfGDKv
48978	payment	2134	2134	1874	1	1	8152	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFgWkcCPDajFA5Y6YjwpnzoUShnie7mHpBzea3FWdNhPSk1tNg
48979	payment	2132	2132	1874	1	1	2026	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvNtTLMv4xZNJx9gUrdRHd5UidwucqDjFhGWRR4xKEF8rJi4FV
48980	payment	2133	2133	1874	1	1	7638	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDiMRwAagD3uttUhG7pvKwJqbth9x7SeKkB6pUsd7fMU3n7n6X
48981	payment	2133	2133	1874	1	1	7639	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrKrLLTWTTBY4ArCYggdXmKs95ZkhYxxNKBYsC9RrHKucwTuTA
49040	payment	1397	1397	1678	1	1	18051	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3yG2LhUxw57yqksLhU1JBbx7vFQWWkKy4P2KCEurNcL5K6i1e
49041	payment	2134	2134	1874	1	1	8173	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6JMijV6mn6W2NdzRcwT7ZarUttGNcTs6usWZGp5jiaWNB8mz
48868	payment	2134	2134	1874	1	1	8108	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZibbipZiTgz8CyKRwSxjYA9GMXfTpwmiA3gRQhMcykzXv4Cx3m
48869	payment	2134	2134	1874	1	1	8109	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmaZWrWgj8wweetgsh9gFWc3EzK19SJw8K9RUiXgu8j4msjEGJ
48870	payment	2134	2134	1874	1	1	8110	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU9Wyw1d8mLKz6yKfwFgcXDm7cPfRkLTkiu7JnxabPF25qMkAU
48871	payment	2134	2134	1874	1	1	8111	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYjtV3FBURY7u8pCAQDCV6hdkHhJq5iWmxdNMKnnwFJcrg9Uk
48872	payment	2134	2134	1874	1	1	8112	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK1M6hwP8CXZ1nznKZ7whWiDJ36ihmgsc4qZsRz5bK4RwUypZ8
48873	payment	2134	2134	1874	1	1	8113	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagY9bJqDfbTrQMxjo11z54oETgVHKLQJoaoC7mY6MnuAJzEAE
48892	payment	1397	1397	1678	1	1	18035	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosepJd1XDr5wPThJps4T1eemF2qryieXy91vT25MD9nQiNoa9
48893	payment	2133	2133	1874	1	1	7612	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ61ezJjBmPm4n5utaSJhXQPTeqoexvQgSSbjDwLWfPMmbGxU3
48894	payment	2132	2132	1874	1	1	2012	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjLRBuZRCVFLN26MiVmxQr6DUk3TQgoEoJKqGPrK4zUwsQbPHa
48895	payment	2132	2132	1874	1	1	2013	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1b8g63gXMM88JMTDrqKKdivJHmwkcwyrPBDHjAvLxKJPqGFop
48896	payment	2133	2133	1874	1	1	7613	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Z7UU8Wjo97vPNyRZJTEyNHY2YsKovt8Uz9Y1dSeqnPGeCnw4
48897	payment	2133	2133	1874	1	1	7614	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeGXkAByrpDZEJb56ekuXvN69EM8zyF2xQh3ckmbNbt1w6hNkk
48898	payment	2134	2134	1874	1	1	8122	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXb9y2Ly8BNRMtrMwoZnuTiiZsbcZsFPNRibqTMBusdcLsUdw
48899	payment	2134	2134	1874	1	1	8123	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjo2Zid3mYCSWFeoarp1YqfxpVaYpQJygtick17S9qG7rGwWw8
48900	payment	2134	2134	1874	1	1	8124	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKc5VZBJv7RK2CrkdU8GnG2EjVgYuwi8F1pazns4sD1KWgvkTg
48934	payment	1397	1397	1678	1	1	18040	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TCJanQGs72UznHZwkfP1VsezniE9bine37JQwuJ56AwPRzLi
48935	payment	146	146	146	1	1	0	1	2125000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpdBHRs9d5a6uFcdufWwJq2SfGjT2npFk4nyXWtVJPSxU8eE5o
48936	payment	2133	2133	1874	1	1	7625	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhAXUmxyknokDCMbXUJwbP2rpA1f1JdoAvFsBMYtfUrGLuUw6
48937	payment	2132	2132	1874	1	1	2020	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rN6xqfYFzo2CacKeLaCjRFm9uVJWMYnnchqtPUQnrbDV7yfJ
48938	payment	2133	2133	1874	1	1	7626	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8apzYk2KuqVgRspgRRhoB3Q8oPGFXSkiu6RrU4i6jCpjW9JcW
48939	payment	2133	2133	1874	1	1	7627	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYteJ7nuFwNqrdKfjyke8S2BQoj6otBrmd5So83QavTvhLss3if
48940	payment	2133	2133	1874	1	1	7628	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6DtcXeZHdwhftebr7amV61k4i9KKaxfLC3E2EGFKXC7Vq6Zh7
48941	payment	2134	2134	1874	1	1	8136	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRZ4y3tZPSfvqXgvtoQmuFeJABerYw4kaR89ZDAAGjKUnmn71z
48942	payment	2132	2132	1874	1	1	2021	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAiVrtvdM2A7Qi7YGTrmqBnWqqvoPBZMHhK6gzdSb7L4AbS7P
48943	payment	2132	2132	1874	1	1	2022	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgojbx5CeEPRkzzvE1AzuLCHtSZrV1wvMKvri5DGoLS87jvctt
48944	payment	2134	2134	1874	1	1	8137	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqpFs7tGa2Ykt6eF1T4CswpnBCQoJaHRuL1ph6JmA4sT2T3M66
48945	payment	2134	2134	1874	1	1	8138	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCm5cHTLVQk6VQH9t4QxSEGRHrZgWB7MoFkyw8je8xDqhEJJX
48946	payment	2133	2133	1874	1	1	7629	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv4dTdm7sNJHaeQArgKPP45JB6mbvqTE2AXoT1HXACtchVpWut
48947	payment	2134	2134	1874	1	1	8139	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGgFTkn9HYtLGCA4QreP7xBCrwtcm8sm9BZqnNoBHokm8jPBfq
48948	payment	2134	2134	1874	1	1	8140	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiXE5bmmgWZtH7451bXFgEqQkzQR4arumx4a5ahmj9puXYDhfG
48949	payment	2134	2134	1874	1	1	8141	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9XuA8TTDx9N9x66fXBmQDu6JTvYpi9StzsdrQEPZoErB3ZMWJ
48950	payment	2134	2134	1874	1	1	8142	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUHbELTLo5cNATeupKv7s37sij5ujHr1PFdC47bot673iSXxs5
48951	payment	2133	2133	1874	1	1	7630	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJnwjoVP6YDJEcACFZfgAsPM1aWzirTvMkk3yGbNRhtzcE3nyX
48982	payment	1397	1397	1678	1	1	18044	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjGUySG3Ahxa1agXfWDDLePt5DMq2DR8cjptSRtxyu8ZRSoz2
48983	payment	1397	1397	1678	1	1	18045	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc5UsWYPAebwQgR3JNwKnFrmSYRk4FkgipekdekQkcpSeAE9qg
48984	payment	2132	2132	1874	1	1	2027	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeBWtvX7NNm15i8hnS7GSYsMPrZ6B4DwAJ21MX9GE9ntJgW79
48985	payment	2132	2132	1874	1	1	2028	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsGbcBK6wZcrczqzyUyLyzj6CK9L4aNdFpp6iESVWnwH2WuG3
48986	payment	2132	2132	1874	1	1	2029	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEcWVpmSEsAbMPh7ZCpyyX45zU5fNbQV5RJFChdwvxMkZYWFnN
48875	payment	1397	1397	1678	1	1	18034	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa99udxxZsXsGKdtZkXjdEJXcy8wW6jLBxSmhWN2Mhg1urHnmHd
48876	payment	2132	2132	1874	1	1	2009	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYe4PWehwBXrZtr1kibokbj2g8DTNdueCh8cvMVTAYcnipZvAWC
48877	payment	2133	2133	1874	1	1	7607	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkRH5KKH8Hk1MKNLjRXPJDwHLDnvAM1QA6kqVGvv1rce8Ne2Di
48878	payment	2133	2133	1874	1	1	7608	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNmPvY1mEtTdwRRkCfnu4wQWH1NxoXjA2Zm4RG2RwJL4dwjFt
48879	payment	2133	2133	1874	1	1	7609	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo3UjZKfh8ZHQUkQ4jGepU2s3SXGp2Y7JwYV8hstJu1FNxhgeG
48880	payment	2133	2133	1874	1	1	7610	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjrJLeR3FcUJ5mrtiqfhvZiw1UKCdqiYPwkwk3PDHhrVKKro9J
48881	payment	2133	2133	1874	1	1	7611	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbdGqirB4a4pWkBjxZTtne33S8mR3nG8Fy6y8sMJi7vrvfk6KC
48882	payment	2134	2134	1874	1	1	8114	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFKWXaKTkMSoBepoNekrguxfGKApoRqud4htysDL9PXKGcXpAD
48883	payment	2134	2134	1874	1	1	8115	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEgQtBofgLwmWy7z6KLpmRdRvvB7UifB7pXHAEoKCLBzZSqxB
48884	payment	2134	2134	1874	1	1	8116	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpamQ3dqYKxwvT78SSDfV2zc139C9drntERm6r8EZHQ8EUyh8P
48885	payment	2134	2134	1874	1	1	8117	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZGah7mzjidNb93uCtdBnTmamUKJXdnR1ACHzNEyMCWY9uAbdJ
48886	payment	2134	2134	1874	1	1	8118	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZha4ekfftkeFnBn1RudAH8BWjdwsg5tEmVJ94AKLkwnQzAP5gN
48887	payment	2134	2134	1874	1	1	8119	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXpLe9DdwR87KdXFtgYcNDLLi5JEc6Yp9QY4DcrKfCLzwLWqiy
48888	payment	2134	2134	1874	1	1	8120	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsrQbr7XiPv4x9K1PzEgPGgYAn6fWpe8oswSJvJL11R8kHs8QW
48889	payment	2134	2134	1874	1	1	8121	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnZW2jQLbXbVNUPxmsjUkYvK4Htj7GPMTGcfxy25g6LzpsEzCG
48890	payment	2132	2132	1874	1	1	2010	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKh6HRuyM2MkkrogfNnAzTotvWCkd5BK59sDAfRed5KidRjjkV
48891	payment	2132	2132	1874	1	1	2011	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWWCzwUmCHTZrdM3Eg6mnWdtffTzwWfcsvfvZfZbnwTwhgm5fR
48901	delegation	2431	2431	1600	1	1	0	\N	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6q22Vqkoy2nZ4cVKYMyBSnpmAR8aPMyQUvRKug95hEhyYjRrQ
48902	payment	1397	1397	1678	1	1	18036	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiB6rL28J6hcfEBZfWAezq21JPELNQASr59iXwCyQCuxT4fbnN
48903	payment	1397	1397	1678	1	1	18037	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrh1j3rBmDWB6GoG29AA4awZmbTStusqbD31Hd3eXC3kfY7izT
48904	payment	2133	2133	1874	1	1	7615	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4mixK7fyFXjKaVzgXXc2w4kCoavb1DWFHo4JVxwTJ7oBvaZZ
48905	payment	453	453	712	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVHfKeQ2gUDyyxWfwvLavWFeBsxRj5TH34CcW7BNfcTiAUAsyJ
48906	payment	2132	2132	1874	1	1	2014	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQogRnsvE3uUyB215KVbRiMGFc62Pui7DpbNEnvrwgVciwMUG
48907	payment	2132	2132	1874	1	1	2015	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVz6RfveFSuZUHfHrfDiA61HAb49bXc2QTq25tqCe3VgkgPQ6
48908	payment	2132	2132	1874	1	1	2016	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoUPJP9EYEgfKvE6JSnTLS6qsby73Rzn4Mw6AeVsBCYjXDq7NL
48909	payment	2133	2133	1874	1	1	7616	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFgFLKBhQi6u32gZ9nxzPqXVa6c3LHRV8bFNCUN4ZacxLi5oK3
48910	payment	2133	2133	1874	1	1	7617	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVQkc2fb7pbMEDcVwVcN9ZgqfbPaNfqV2rk2RCFEBAU1zNFd3
48911	payment	2133	2133	1874	1	1	7618	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqspxwGpggCzVAyLnUenE7oMGkc7A4HP7wYgK4Jxs2DSAHzUkH
48912	payment	2133	2133	1874	1	1	7619	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWsDBrwiUCrGz77A5NucjGYDzKsTqnkGuyZpgJCLmqvYPwRwbm
48913	payment	2134	2134	1874	1	1	8125	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHdt7bC3gH5dpfC917NyxVHAXnwuckt5VCYBAiWPMVNfZ2siLf
48914	payment	2134	2134	1874	1	1	8126	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2qxiJB9NNF8fg4yrYpsXrqrTtX59pWxEiiRnjgRACbvXvvynV
48915	payment	2134	2134	1874	1	1	8127	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJ8PYGVJVnpMBkWRLi9GWKAQq8ygvEHaoA8xCAaCainMxPs8j
48916	payment	2134	2134	1874	1	1	8128	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjrKTJXZ6LwZxvA4GZUMKimfXRffcikmt8V4iJUV4WGLaYV7Qz
48917	payment	2134	2134	1874	1	1	8129	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuZZ8AeSWNrrE6qA3BV4VEwUJ897jkMTqumhpgN8zPt98ZwUmo
48918	payment	2134	2134	1874	1	1	8130	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyZB98Lu8qBMuTb9HHipz7B1XNRSkVd6znP6MAYdSSfx7aR2Bq
49009	payment	1397	1397	1678	1	1	18047	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFe4884HCihYNx1hX3UKoM5zaZQU7iBdKy5Rd2T2Fpaiy3eD96
49010	payment	2133	2133	1874	1	1	7648	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLw9oaK3MdgbfeNZ8xvdraLSjdPUDbZMstbzpUuLyuC49HttPR
49011	payment	2133	2133	1874	1	1	7649	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABuh2A12VdoMBJpbzx5ByLyBkCpGnB3BeUuQs6YK3FE4Xmp1r
48968	payment	2134	2134	1874	1	1	8149	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYozRGW4TyYW5y4LpTKcUM1W2JGEVSJ5Gi2Z7WnKXtnhw3et1c
48969	payment	2132	2132	1874	1	1	2024	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4T6vyxsLrroV5gAivoyypZUzDKnEqzeCUDSiqTGEngjvMbpKA
48970	payment	2132	2132	1874	1	1	2025	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSs76avtZAPkDJn3gZMEx66rqwddthf972LxtFSTt1hxLRjzG8
48971	payment	2133	2133	1874	1	1	7635	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC7NZwU9JAC88Pjit5i5nk3kQV7HJFzvnkeD8dWRyqp7Zuz2n4
48972	payment	2133	2133	1874	1	1	7636	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cJaUjUxzA96RjHqobWut3LweMLWbhepVg7KPf3E6h9DrdZJj
49023	payment	1397	1397	1678	1	1	18049	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4k7uWtVkNgaFKJb4znAJML62rKounJXb91QGdbSSLafp25Nj
49024	payment	2134	2134	1874	1	1	8167	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXX8bRf448wHj9bRFzQqmwg4J4hVaorzgs6ET4oJPQkEFro5ZV
49025	payment	2134	2134	1874	1	1	8168	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxdL9T6pk6jAn5YeWPSF68DPdpARt5yQoLF5KjerrkcFEGTvX
49026	payment	2132	2132	1874	1	1	2035	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT4YqTgozoFqRfcmZtbyc5tpUXrRa3xEyEg6GJDAhKJdeGZf8
49027	payment	2134	2134	1874	1	1	8169	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7qSxtm9Y1pygBcjhvYfgmaU6KQpVyoUSKPRuBdSrAtFW4LJz5
49028	payment	2133	2133	1874	1	1	7654	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKjSE3GGgyegpC1dmBCaFXH4p4DBLeLxtN5g88cuiQ8mriEdux
49029	payment	2133	2133	1874	1	1	7655	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYncvCdATL5N32nTrLymFwBjugkRpfMtB9fnH1sQmF7tSnYzvR4
49092	payment	1397	1397	1678	1	1	18057	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNk3UTkuSTZYG3sm8CFU8g6D4iqMkDasrzVznqryqrcj6s1mXE
49093	payment	1268	1268	1269	1	1	3	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanbFuLT6vwh5ihhtGjEKNj2Gw3qWKZJCfA3XPE1QjBrCwu6cs
49094	payment	1268	1268	1269	1	1	4	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuMtWSwF4fZPAg84CiJ37MU4KGc599bwgkkYnc6CfZaEWMz15
49095	payment	2134	2134	1874	1	1	8192	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo3L2bJMWD9ZqVKEHtFkdrKw9vywb5S855cWh1tjf3mJmavw95
49096	payment	2134	2134	1874	1	1	8193	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkMQW7HMBmAiQSho5KpqmsYxRw5Ayiu4Qpbqmz8bfJNaocZzu3
49097	payment	1268	1268	1269	1	1	5	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFKUkTcj2ZS6t2UMGRMB3z8rokY8ASDDVMW7m4oruXHaHw6Xho
49098	payment	1268	1268	1269	1	1	6	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTf8WRRoAYhurKrZgzNMopZRK6Kiaj2td5JNB2gf1L3wyDsbi4
49099	payment	2133	2133	1874	1	1	7675	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhvjAz7FT6vRQUQAKT6LRqVingu1kAA7YmFCYg6H5Hpo5MKXKw
49100	payment	2133	2133	1874	1	1	7676	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUBykGVYHEMr27y4y5W19GTuMH7cV6qfDNodnJpLKTkXC95Y1F
49101	payment	2133	2133	1874	1	1	7677	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYieixGF9Xv9DqycydJr4D6bQusBKe4V9deEvUd7TQ2LPZ6wvVh
49102	payment	2134	2134	1874	1	1	8194	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Hos1BHi6FW5euJDFCj6wb4NfUUNZTBnWpRFWAQjhjYLQEeE8
49103	payment	1268	1268	1269	1	1	7	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FeUeARpsFzjpRNj3mPERerxY17JvEwsvGxqyR52VimVT7QYP
49104	payment	1268	1268	1269	1	1	8	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4hva1fwYNwaQRHXmDZ6hPGAKGqnCkZMWcw1qfLnoTAvdMP2Ja
49105	payment	1268	1268	1269	1	1	9	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DsT6tXMpLk6uuiE9sFX9zkk3raCeKJJ3M82BczMs9kV2V1E5
49106	payment	1268	1268	1269	1	1	10	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8pPF6jqwm3Sh6MPjQPvzYXhuJYh8nc53p1kfmWKhsphhdptz
49107	payment	1268	1268	1269	1	1	11	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfWxeXJucF73GKpepfixqUY1iHimWkr4fkovpGKfCuYEmUDpoQ
49108	payment	1268	1268	1269	1	1	12	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkCgtackW8VumUGTYnB13hkfgCCYbvy3iSVkX64kqKrasg8pL
49109	payment	1268	1268	1269	1	1	13	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtfpB87ZK9Ze895qKMoQUuEkXDYPCjTB9qGFK9LeryjFjKHdC2
49110	payment	2132	2132	1874	1	1	2046	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7SJCWLNfMZ61npnxaLcz3BjEu14zLCBnHV4DhryusZvQpZ5TP
49111	payment	2132	2132	1874	1	1	2047	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwUv28D2GmtFFk6Bhi1TkxqPcZjqtuYLpAWAx45ytRg3wUnbf
49112	payment	1397	1397	1678	1	1	18058	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3MmCyoCUw9pHdmdUher6MoS1g8qtRVPFxNSoWBbpu9yweY5LW
49113	payment	1268	1268	1269	1	1	14	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZ557G1P98ZSvPDx5rXmwzZMwAZVi8HLJFpUuRQ8Ym9jRQnT7
49114	payment	2134	2134	1874	1	1	8195	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfJz4c7hrLwYT46x3pLyv43ubHMSrgJkdbXauGsoYkRjke4dnb
49115	payment	2134	2134	1874	1	1	8196	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqcT6NgzUKMfkxwdN3HZXf6ydrGyhkFogPhn4xkJBm2SAGiMLJ
49116	payment	2134	2134	1874	1	1	8197	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsARLEUZKpn52j88uvFJNrQyWNSeRQtyGEm3PkxPXwF6brm8LG
49117	payment	2132	2132	1874	1	1	2048	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy4Ve6Q2gYo3m9HUSzfMurF1RSLLBSF745JBu4HZwpAuYBjSGW
48987	payment	2133	2133	1874	1	1	7640	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkP17r4tcZK8Kezkvg47t7K6Q4qRvGSUzC77dXNUoEFdvLoFbf
48988	payment	2134	2134	1874	1	1	8153	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz3A46vokps8ijusM1kcXrpn5JTDQgd5wDKM4Da57GVEJAdMbN
48989	payment	2134	2134	1874	1	1	8154	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJTsucZZdFx4fDdCGh8tykShZ2TK2DPtWwJF14SxDQzg5NKN15
48990	payment	2134	2134	1874	1	1	8155	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYjkvaiHFuK3pmruCDW8qB63Kj6dMQwd7XJj5KpGKxRffECXEd
48991	payment	2133	2133	1874	1	1	7641	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJUZr6H1x2hm4UX52drB2x21T9WG23b9JzA1ZjV9zJovhatuM5
48992	payment	2133	2133	1874	1	1	7642	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbEb661GWvuF6poHs5KMpv2PGxUMQPsMGZwwR1GZ3TZyjS1Xd3
48993	payment	2133	2133	1874	1	1	7643	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZBFN2JgnzQwZFVkMEf1iY7xScRCpnL28X3iuYJjxqCDgQdhh
48994	payment	2133	2133	1874	1	1	7644	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVHLfUiNqqQJBwfQh2MQTNBjeazMk3sjNWdzH4hYAKKsgXX7a
48995	payment	2134	2134	1874	1	1	8156	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJb9AaFYT9v5KQok2xwSC7Dfbsu1MSLeE3Zs5ZhRFUUfzzykYq
48996	payment	2134	2134	1874	1	1	8157	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYktnsvmTHDtQ18A1TwzYWvQG26yK6i51nYnJvgnK95soHJavnA
48997	payment	2134	2134	1874	1	1	8158	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHZxZryxixzXM8VFTBeDyGdbsBa8H6vXzjv5VzZSpQp5wNap2A
48998	payment	2134	2134	1874	1	1	8159	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjKLH23FdfBLi3MvvcDiXEeST68PpGPAHTQ7jenXuDrXZfY5Yh
48999	payment	1397	1397	1678	1	1	18046	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ42REaFQzvEd3FsJtqJxggHcRVFqQKYFdNZrxeEEATqqMZ8c69
49000	payment	2133	2133	1874	1	1	7645	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcErQLbeg5oKQL5ES1aLF57MM4eMUuZ7uUXKFeTPov3p8Vs1Ui
49001	payment	2132	2132	1874	1	1	2030	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgMLCupyNQvVhZxpmps1b2rtDXYtVLTqnQQkzWp1VxTi4HwqUK
49002	payment	2133	2133	1874	1	1	7646	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihz4mg6A1yrPyXVng3eMDzVNW6iUA1KjcRh5y9pS3UHVW7PPJ
49003	payment	2132	2132	1874	1	1	2031	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkMFFerdeW2PAC5fEomWyUGJWHS5D2oZvMsvDLvtMBBkxBm3yE
49004	payment	2133	2133	1874	1	1	7647	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt7ZwgE3fAgnAWgCQow9282GN3N7KvuBeBQbHgK3YFrspFJbtZ
49005	payment	2134	2134	1874	1	1	8160	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx85yjQtMyWqM1VKdvznabRdzRUvJvmkuZAkzzYK1GpURchoZs
49006	payment	2134	2134	1874	1	1	8161	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LXCGhkiQ4VjpZYtVJQ252zEKrrA3VkWPbBChHPHjXDCBrmQy
49007	payment	2134	2134	1874	1	1	8162	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapfzvgwznfpcn7basjPJpqaV2rCyox4eeHEQhEWgjpPtAMZz1
49008	payment	2134	2134	1874	1	1	8163	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcaccNDAtkHsBckvyujvjBE9inMvSAfwicxGVMyWuc2hfSK775
49015	payment	1397	1397	1678	1	1	18048	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMPfWi3HaUk5hyG5s6MymFAzEnaM53QRPARfGmHR32XKY7A37
49016	payment	2134	2134	1874	1	1	8165	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjQ9mbvusr9RjWPXwANn5uLYXEDmqmbndGUFca3UHnctHprQvT
49017	payment	2133	2133	1874	1	1	7651	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnmHy7qFepoavNWcKDz9DLSEQ3UQE3Jqetc6WQ5rgpcKbJDwCX
49018	payment	2132	2132	1874	1	1	2033	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrEpsK7UA86aUb8DyrUHH5hDoKxYZ2o4LmiQf4Unoes6u1yrFN
49019	payment	2132	2132	1874	1	1	2034	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJfMCSfGo1ve1R9nvouNsodQfnhFVPwxkWeNy7jYyy6CGhMdS
49020	payment	2134	2134	1874	1	1	8166	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1UbAjHtGhaMJpXBsWQvH4XHmqEd98hLtT2H2c6oDLq11rnhRU
49021	payment	2133	2133	1874	1	1	7652	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhDPabnYfGY75HCa5gF3awNaRxAMWhTc6YuBe4m8Vz8F7nvG98
49022	payment	2133	2133	1874	1	1	7653	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34psM9Nf7emnfPapv7eRbA1GdAVfXitMtRhQGxQPZwFRqdPf1
49030	payment	1397	1397	1678	1	1	18050	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnS3u73eom2DQVfT26AY4Ay9z95FRR5vJF12tnn8yr1J2fC1bB
49031	payment	2134	2134	1874	1	1	8170	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2jmfsY6FURZPxeDYt7ZqGGsqraH3BU5Q1jCZ2UDwHGbP6UhST
49032	payment	2134	2134	1874	1	1	8171	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXN3Jf8AQBZPST42zJyMiBCs5vz18Wpw88MZPhChq7ZSdjkT4p
49033	payment	2134	2134	1874	1	1	8172	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYridCvkWUJpZSbgcgdXmktcABTpHPLGgpd8N5XugBiqb4UuZFf
49034	payment	2133	2133	1874	1	1	7656	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLainrdy52ey8zJDdibSUQHFA2QXurdcz9qA4zWcf12316WrHb
49035	payment	2132	2132	1874	1	1	2036	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd95UkogXNnKUduKvpacNtVuFdm4vSAmPkbkkiJSZz1dbcD5vR
49036	payment	1726	1726	2432	1	1	8365	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZpdWsMyxGnzcb4CQzvMMWL7QzYr2peZDuFMrJBCAsfetibnSMh
49037	payment	2132	2132	1874	1	1	2037	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1qHt6a8M18NgVzTQmjwkuFND97ZtwidSizEmR3pfR3DiVpgvf
49012	payment	2133	2133	1874	1	1	7650	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7pZsTnTP6aVMqtrB7EMrjbcao6hZtHx7Xv8o34ZegdK8HeoCN
49013	payment	2132	2132	1874	1	1	2032	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuJfkozU85zQr71oWRkyVtMU11ySNsaYF5furQnai7So9DCL1
49014	payment	2134	2134	1874	1	1	8164	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGqJTWrpDFGQjnGU4aKaQQiKWHbw6uv7YiMVLF3aHBW5wVvDco
49046	payment	1397	1397	1678	1	1	18052	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJbgQadtCgy7sziaNCUDhQYeHbh8Xe1nLj5CVJHikQG9jTLK2
49047	payment	2134	2134	1874	1	1	8175	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYii7AHC9FLQoPFvR3oKkGSx51omtUXmqjmAtATFLU5h1FdytxD
49048	payment	2132	2132	1874	1	1	2039	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATA74v1HQ7yx4Nqb2vhSC6CyGCRnAXYd3JF1s6JCRtGXiZewY
49049	payment	2134	2134	1874	1	1	8176	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJF5FTZXCKivXE7AkaBAZa7hLBgDA8h13thijg4cfoqhwjYZui
49050	payment	2134	2134	1874	1	1	8177	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRNCg1QhSXTWc2NqfuaCnGRY2j5wGriPPAnJuesiPe7dn5dn6G
49051	payment	2132	2132	1874	1	1	2040	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcB9vBdE5K9Dwd4roPkWTVjNqqP259bX5F3R8D2UVMV6ou84jG
49052	payment	2133	2133	1874	1	1	7661	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8fBwCeTfVAnyKyJ4eFQABkvPnP87vZaoVG64RLtFA1j8yJffU
49053	payment	2133	2133	1874	1	1	7662	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgrhb1Wb3c5W8cNgCxXLsWoSxtzHFA2XRXTDiMcVx9kinvwi8Z
49054	payment	2133	2133	1874	1	1	7663	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZznLhRjpCR72hnYmKhrTusfV7di1JDDuKXHdvJ827PrXhMMn47
49055	payment	1397	1397	1678	1	1	18053	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZo2ARyg3scn7J5hN1i2sFkRswF36hK3eEFDNF4sGfCrkh5wbx
49056	payment	2134	2134	1874	1	1	8178	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjqhDbL1Wdc6kzwM8KXaiR388iAFP1zuRRzDgzhiZigNsV5BJx
49057	payment	2133	2133	1874	1	1	7664	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCEj1X9idvgPRbDwVuFgBPn1CSfCmKv38q2rmrbxP7PtH4xyam
49058	payment	2133	2133	1874	1	1	7665	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3pjq8UwqN1yvvCZPWmGXfAS7BvwwnAMff9rUngi979TMsxhuc
49059	payment	2133	2133	1874	1	1	7666	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtooWKjB2GaB83j9aZEstoUqNv5Gv7mpTnPtQTfXE3kSGZoGFn
49060	payment	2134	2134	1874	1	1	8179	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEN5sh5KAzy3UQp1UsFgTzdqMGN5SC2Y73tT4yTkRpTpLBqX8q
49061	payment	2132	2132	1874	1	1	2041	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpz7pi7jL4DzsVVGRZ6STNEuamst2e15wBYprJqmpSn5LUZJd
49127	payment	1268	1268	1269	1	1	21	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXL3UeCE5ULpotfgL8aepQJV5uo4fBfUvp7TKoWn58bwcrSMSF
49128	payment	1268	1268	1269	1	1	22	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMLL1Wm9MUE4FHJy5JKtELB9q5em7LaUgeYwx2bfpJfDznqL9i
49129	payment	1268	1268	1269	1	1	23	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKaPA7i4hr8LvPYS6FR1pa1ChKW3bJMEwX6jgv8gqUEC6CgN98
49130	payment	1268	1268	1269	1	1	24	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFn3ezWamr7GKVEUN4ZEPXBeUjJdRFi2pegB95kpyL6VrqcUHP
49131	payment	1268	1268	1269	1	1	25	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpe2ZfUeJRXAsM2HGqM2xFEY7Cz7uz3vKHFQW88497W4WiAhFT
49132	payment	1268	1268	1269	1	1	26	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKSQUainAZskjy2FsF54xUr4xbqR92eA94DnqB9rnKAYVm9bs
49133	payment	1268	1268	1269	1	1	27	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqT4kTvH5PafuqKEPLQLuJLv9bnV3waEyuTtyzBJsrswGU7CiQ
49134	payment	1268	1268	1269	1	1	28	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxBL9SCafA1y4KZa57q5PuuKQKKUTXUcgsbL55PgCsmp7EgyJZ
49135	payment	1268	1268	1269	1	1	29	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmd5PtoM4MfrdSQWuViw2nntEnsbFoiQhtfiWveS2Tr3tfpvpo
49136	payment	1268	1268	1269	1	1	30	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtJtryDJUAWj9rXyJz9Cugvi9v3riE7QQjSFipx93qq8rNB8n
49137	payment	1268	1268	1269	1	1	31	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1hpXgcyNrySuvphiDQ2B1rfgbq3YYnAHKQe4cKvePpkuTyHcu
49148	payment	498	498	724	1	1	3	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJfH4uq5UiLd6YM8kzrYTrb1wD7EutdAUMh6issy9LswUknVBA
49149	payment	1397	1397	1678	1	1	18060	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZraXgA1vDkxRy83C2EWs6ugok9w2YNdijaCagohgZkcbDC6R
49150	payment	2134	2134	1874	1	1	8202	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyibvJKnZitM1v5tsdtTrsG9ZrKARfcDxSa6cQhC8mv1qEKnd
49151	payment	2134	2134	1874	1	1	8203	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3A4bQpA2oQyFHDGiVfNdZD13DrEiHfdoe2kFYHjxgzLo4SboS
49152	payment	2134	2134	1874	1	1	8204	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqhQYwYdSRiPkZwGgWyH67efAMkf66r5Psok8LG8UUZDvzgddJ
49153	payment	2133	2133	1874	1	1	7683	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCpxCG94GrcPrSs6FjZoygpBhMmW2Cmc2mpNcG6kU8S23pRLm
49154	payment	2132	2132	1874	1	1	2051	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaATmQo36seCFix9ipY5cHRBtE7NRuTm4HKr6Ln3DkNXvEsyw2x
49155	payment	2133	2133	1874	1	1	7684	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFV1Z7FKXSLEfPSU9qsN3meoPXnBwrN3wupS4hAyJqccZ4P3hQ
49038	payment	2133	2133	1874	1	1	7657	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Fpqx814Lq8NPS6sY5y5UQGDskXhHG7S4HYcv2cp8PQshLv9S
49039	payment	2133	2133	1874	1	1	7658	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpQch7gyHgFo4sfPZRqFphuVXVTjgdVnhrF8zCjAkB1ALZ5jVM
49062	payment	1397	1397	1678	1	1	18054	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqjHr2oUXr54TF77FFng6QKAYR4MmdQCQapryxRNBSt1ZtHf2m
49063	payment	1397	1397	1678	1	1	18055	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN6cA5aWoXWPmexPSxaMUrYqNmU2cDni2WhSJNpMnYDzgx2w5F
49064	payment	1397	1397	1678	1	1	18056	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRK1mC4Z1P9TnbS66yr6HRwr3fCoGAyEayurYNJobtHTsmxo8y
49065	payment	2132	2132	1874	1	1	2042	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdEev8wqNRbvvnx4LhfrPYWhK8ZYsLM6ZBqQ8Z8nkPC7gDmWpq
49066	payment	686	686	686	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuCzYYep9aCrLQUCywy75ocrjGmGkfiCA3rWKyx52wdQDiKhvf
49067	payment	2132	2132	1874	1	1	2043	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Xz9mjkeye5HvXPaQRVqJTGM3Zx2ApWzUzaT6bSWputDYcKS3
49068	payment	2132	2132	1874	1	1	2044	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaqFDyEkNG9U2THDgGsWfxFHHGSErxu4ypWxb7WMziZbY6Xv9D
49069	payment	2132	2132	1874	1	1	2045	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rtGwD3AWM3jmUzSMZCMGigceM9SfnWUADm8vdFKQHATQNXpV
49070	payment	2134	2134	1874	1	1	8180	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZoQo29Th9dYF1sc4ekMrewx3EJGrhxTZJ57LSQTgG9naApe81
49071	payment	2134	2134	1874	1	1	8181	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZnYf5WuNLzML1QfCv6A2Bw7toZtbGFjnBZGexDiQszuGiGsRr
49072	payment	2133	2133	1874	1	1	7667	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkGwfgfjhNCdHKuDisER5J8XwZVHwSeT799Q2CRof1mtu97xtG
49073	payment	2133	2133	1874	1	1	7668	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiaEaxS6Er73mNrJGdx5Un8brMfWzJU2zWgN7XNLue37XHJ3UL
49074	payment	2133	2133	1874	1	1	7669	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4d1jVYKVWorZ9D1ZRdqKKKw1oLjpb8zok6hop9dUGmSVaC6X
49075	payment	2133	2133	1874	1	1	7670	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLwkQtdC1ZVVPFkTZn51szGqcELQMTH3qdFiKxbh3bz3t4JVa
49076	payment	2133	2133	1874	1	1	7671	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKgdTFrbxxUcSF4eQWiXLBSU8d3r8bQz2AKiQeMyJevm6ZmykR
49077	payment	2133	2133	1874	1	1	7672	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDksQAeDVeKxw68qGKrMUHuvo1iL6V7wyKRX5gnxFkChUr1fU
49078	payment	2133	2133	1874	1	1	7673	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy6zhuZYLvVLkmdQuLaExaw2o7VPZUyquvvx4G8FWsZfw2UswE
49079	payment	2133	2133	1874	1	1	7674	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKmYkTvAyqyc8GjJKkhicwXjZqTnadMbWtJDyLcLM3QEqVFSiP
49080	payment	2432	2432	2432	1	1	0	100	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZybeLpkj7LYLyYCnySQVZMddvszk8ZMWSs6CjZfms63yV1wRDY
49081	payment	487	487	1737	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL57PunZJMCKi3ujnzRJVXNZ5gsfQ1bZgi9zEUg4EkFpWeR12s
49082	payment	2134	2134	1874	1	1	8182	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTZgn576oxqn6ABKUMKef1KYTDpXMf1kU3D7WrDadZhhnDSSB
49083	payment	2134	2134	1874	1	1	8183	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjAwjYbJiNhnk9pmQmX7t7A1igbJawXnsmmuZZynubDeBYy5H5
49084	payment	2134	2134	1874	1	1	8184	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1kCdJcPUucjom5sMYyJu2akP16yf8Fmzcgksz5KoysfnQcjWK
49085	payment	2134	2134	1874	1	1	8185	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYavnLHVL67k5tSTEVhXZhnCK8YZwmMhsHe7btQxp6e7Fad1S
49086	payment	2134	2134	1874	1	1	8186	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzp1izjbfvm3XSPeJAcdTc2qZFEhwiixESV8SnUAHK6gnG6XR
49087	payment	2134	2134	1874	1	1	8187	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9TQDv8jP7mmWjVdQsxsx1erMdkM4z7TsBp82UCAMaVo721FV
49088	payment	2134	2134	1874	1	1	8188	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkYWoS5C7kRpTBEJrTw5PBXSzrp1GgzJC7e4Fbro76g8g35hmi
49089	payment	2134	2134	1874	1	1	8189	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4MKVdLXgYKoaD3ZMMhs3924fBnnvB5TMGvarVXBM3s8dUgkm1
49090	payment	2134	2134	1874	1	1	8190	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4S7ERAqxeu6VE51fYccwe2pMJ2G2eNG26pmiSx2prxAXtcfyf
49091	payment	2134	2134	1874	1	1	8191	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZkwZxQCae2AcqbqctUmozmtrftpfkYmJc3jkkDeWp64bPBVuf
49183	payment	1397	1397	1678	1	1	18064	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhQy2vTewBuG23CMpPeXqtME7szKmx2z4PEs6QmB8fEsWzuqap
49184	payment	2133	2133	1874	1	1	7695	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt8SQhGpgk3Um25B6ZgrmwekCP43DYZtwbzVbqf9uEVRVCVjeX
49185	payment	2133	2133	1874	1	1	7696	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN49V2LWnFEHQyPe51ZWbf4wi6PcoXq33LqSdxxZWoLEijc1Gr
49186	payment	2132	2132	1874	1	1	2057	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZutkNpVZRxg2JKyVmWQGUhxZR2Ge2rAGZSNLNpmCAHQRCGVi64
49187	payment	2134	2134	1874	1	1	8213	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGKuzvZpwu8KidNoGCRZtmDQuXGoJoyqVY2eEQWWjrXubpbcRY
49188	payment	2134	2134	1874	1	1	8214	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1NkZ6Z6Hw64A5GzTaZT7RHqkzA7PYhG65g2kQM3SBwi6Nt6E
49042	payment	2133	2133	1874	1	1	7659	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hn4oJG3cn6MRK8of7fWN9vanzGsczDYx2YaKT2asJ546q7vj
49043	payment	2133	2133	1874	1	1	7660	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZDo5QCFoiCBMiTKWnLMFYtzrBAdPR3BAmNa32MZJU6hUcCcWa
49044	payment	2132	2132	1874	1	1	2038	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgmWLizV7BoebdxLjvSn3K3knV2ccL9XaLpGB8a25peKW8e92i
49045	payment	2134	2134	1874	1	1	8174	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh8gTiDQV9maJzJ3dDL9fLpEUMaRTmvanmve5e9Jh1z5Pb4R5V
49174	payment	1397	1397	1678	1	1	18063	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ7dfKYJupqJMv87hEbPzXknZ8RAwxtKuDjFUv6LrsJGYwkL7d
49175	payment	2133	2133	1874	1	1	7692	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3cM6nvXaTF8yUp4FuJpfJUaWyCt9VDdaP2KnYauaMAgd19RmU
49176	payment	2132	2132	1874	1	1	2055	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3t5SgirYC2wJemxx6CT9Pr3CJvwPrbnK3D56kcymV3gCRNvPE
49177	payment	2134	2134	1874	1	1	8210	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ezLegvEb2ceJn6fMQ1wsntg2YUjhtPbUHnVXEe3XgJp4JntF
49178	payment	2134	2134	1874	1	1	8211	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzr7DgvzSCPdgphqXsCNHQtmWdX5pe87dWQVvMNm129wHah3XT
49179	payment	2134	2134	1874	1	1	8212	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhZRfk6r9cqybzSt2jP5BNrEJfzkxbGF5A3w161FcWRAWjNb9c
49180	payment	2133	2133	1874	1	1	7693	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZThgEJPznEnSmPfRq8rLMKDw66TPAqNp7Hm2uQhkRFoNDv61GS
49181	payment	2132	2132	1874	1	1	2056	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhpWXL88pugUrrPDbLkpZXz3D3dvKfAPxTBefRzReguFyqnLY
49182	payment	2133	2133	1874	1	1	7694	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEWRrouiKvyoYigjkcxwsnBu5uN7nncbyQvqV8uHYLnS9JeAEQ
49243	payment	1397	1397	1678	1	1	18070	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7nHgbWtAyF18VBKmzj9mivXzxquBNN4LLweMMsKPr8GgQm1e
49244	payment	1397	1397	1678	1	1	18071	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZroTQUttkLzqVmj176hHGTMx49g44Asziw4SQcsGE8gYcFYuoe
49245	payment	2133	2133	1874	1	1	7711	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjNg8KcefvAzeyb5KNd2jpWXNkiMrYPWzTFMQoaEcrSSLr49PX
49246	payment	2133	2133	1874	1	1	7712	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYamisND696aitmqLdLctTBw9sNhYXLidSGpY3eU9aPbiuU5us9
49247	payment	2134	2134	1874	1	1	8231	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUGGepnoprPK3fepu1RefLEtdsxAryZXgtGY6EowcD2P4fW5cm
49248	payment	2134	2134	1874	1	1	8232	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5kAma5s7WrqNzns2B3dwsaCoSoGURivHR4fnMxtghoMfq6rjn
49249	payment	2134	2134	1874	1	1	8233	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHi1RFM9hdzXptC1vJmhqvN3qupmtPKxusM881TKEPYSL7JKRk
49250	payment	2134	2134	1874	1	1	8234	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4RF7Wa76qiR8mtncYnFY8Wih4PSZFMxcbtrTBKrpUUEoME51
49251	payment	2134	2134	1874	1	1	8235	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGzsJbaCEDKaeBrHMQKyX3T4nAwm7YEMkNNTFZaCuMAVJ1RmS
49252	payment	2134	2134	1874	1	1	8236	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRDKHh9tjYG7jb8ey6SvxZh5d3z5FUXhr6iUVp7bg8aChYoWeo
49253	payment	2133	2133	1874	1	1	7713	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuTZWo4eE9p31BCNC15zNTWWijSzCivEmejiLdvsVSKfa7Mbjx
49254	payment	2133	2133	1874	1	1	7714	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mjdSc1WBMxoddHyY6UFG1UGMxyv2iNKBPy1G6WYdUj7DGbbW
49255	payment	2133	2133	1874	1	1	7715	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvbXwjP4QfAjGRsx3dY3NTwFMY3gKV6aa8TyhBRm1LvHrUuAEe
49256	payment	2132	2132	1874	1	1	2066	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2pvH14YFbLEQgKWr64ZtdA425VMrSPBCoPUnDfKm412w6rE3H
49257	payment	2132	2132	1874	1	1	2067	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZodZkmNo5FukCQbVjFmPQePAmorzh3Co4YLq74Ld6gaRzyc6Cd
49258	payment	2132	2132	1874	1	1	2068	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkY18JgbwUUNy6P5d74gixd9N3cZXu2iT1aBpZvKix4Q7bxVom
49271	payment	2133	2133	1874	1	1	7716	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4y8xB6rtTG7pwfEHNESrxx969oX1vo5rGQgCVZ7EhpMduEbCx
49272	payment	2133	2133	1874	1	1	7717	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuf9aoMyBY1yLvvdrs4MqXz8ZhjhBLUSzmBNufUQsEhvDirT5X
49273	payment	2133	2133	1874	1	1	7718	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfR37ZRSVxdwa1hE2FpihCNoEZv8xaAKUTXc5SicwFm3QQk8KG
49274	payment	2133	2133	1874	1	1	7719	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjarhoawwjEATiYj3cqgyPseqhwGyfpzNVfWCfLLZKSmY2dKn
49275	payment	2133	2133	1874	1	1	7720	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSp6VDgq7pXU5F2TSyr7ppPAZ39tj3VHtD5hRzLDCk9KMWWWAp
49276	payment	2133	2133	1874	1	1	7721	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZktz6fgRuuzxwmo5fLoHuZ9sCc55Gj2YMGajjuL76N5D5J1fwT
49293	payment	2133	2133	1874	1	1	7722	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWw98Q44AhGkv7LE4fYBv4EzY43JU5teWNiqnic28Ck7J1UahM
49294	payment	2133	2133	1874	1	1	7723	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdjM1qmULtDVhja4UWDQ1gqA952TnD3JMz2S3GzjjvjUjMtDHz
49295	payment	2133	2133	1874	1	1	7724	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSjhacCjrJ5qHFzo7ddsLjX5JMFBqBFqpmgjUNbhjSQmc51X7v
49118	payment	1268	1268	1269	1	1	15	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZBbGQJsMZvEBmFpSWUWftcWcvxPWHZ7Nsb7nVZWEwL4fbjqn
49119	payment	1268	1268	1269	1	1	16	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZonea3kZtocCreZm8YhA84vpgRbcViVHJwisDyzTyFmLEvKeDX
49120	payment	2133	2133	1874	1	1	7678	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pF7xinnfZExWHRELYL3ZjszZMedGVKW4hRPuBjCKRpDAHoPp
49121	payment	2133	2133	1874	1	1	7679	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp593t7hmNfL95piaZ4tDWRo2d4YtSSCRzxy1vY8urw1gxTbL6
49122	payment	2133	2133	1874	1	1	7680	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjYsjkSNz78VWpSR1WsfQ2PgouhGGdncHsQ5aGtNCrwnxVHwAj
49123	payment	1268	1268	1269	1	1	17	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAiAS7Ki2uJKZNRp6PAaNdpBE2EYuhn5u1N1QRPttexXJCtckF
49124	payment	1268	1268	1269	1	1	18	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6s2xwrfhTZ1RsgtASCEtnNu4zpEZp5wqyT3tvcjajAPf9FHgx
49125	payment	1268	1268	1269	1	1	19	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL7BirnGb2TMBp9jEUc1Dcha9J9qFhursRCenUo66SQ13Z5DYt
49126	payment	1268	1268	1269	1	1	20	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWVcwT9k5TKdrTB9ipPKirBSe5CkJK2qXHphQAUxuzjVC7t5R9
49138	payment	472	472	1428	1	1	1	900000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7X3mNYwcFjRRPogvvCq9EQLviQvYLTaWPgfNA7RSv8UiQ7Fm
49139	payment	1397	1397	1678	1	1	18059	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsujFca4sHcA75rKns6dLpynSAgi4jbYJiXv1YPRBquoua9ZEN
49140	payment	2133	2133	1874	1	1	7681	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfUDcaZrqNzZ1N8DF6K48niuwCzxnKnLPmZJFcBy8vxC3pDNe
49141	payment	2133	2133	1874	1	1	7682	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvpBEC5HCBphWTzvJP2HZh1SobFCvyfiVAz5JjL5aZdVT2SXZb
49142	payment	2132	2132	1874	1	1	2049	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgHi5fa3WvrSRy9Yq1Q5q1HiCPwJbmRmmbG1YnWtzN6BQJZVaP
49143	payment	2132	2132	1874	1	1	2050	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMcw2jQskAgtipi2AKKNAAfWQasK8kBYEVj98hyuuP37BAxqG
49144	payment	2134	2134	1874	1	1	8198	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuCFLxCuUJqfeMXySYsBhqEoj57T4VF478LmATwJD7XRMLdHNy
49145	payment	2134	2134	1874	1	1	8199	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv1BfH8oXR87yski8M6rdySXHRoC53fKFabdp9ajF7YEx5aUaj
49146	payment	2134	2134	1874	1	1	8200	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBxi7pDZUdRsUY4pDpuQtQ4qcBkAsfVY3vNYX1MBKpBNuMZ121
49147	payment	2134	2134	1874	1	1	8201	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr5cvwRSbUN6MpnBD1iG24n5A7oZtHwGHQNzUYTwgJgit7bJ14
49190	payment	1397	1397	1678	1	1	18065	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfRJhJp1KkkURGfJbXYfgJXyZsSo3sbkeHmemk4oWZw2UhW1KH
49191	payment	2134	2134	1874	1	1	8216	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfwbzRS6Zre8wDVP3Re5GbfGFtAHr7ENkHrExS3X5ikUY4Zma
49192	payment	2132	2132	1874	1	1	2058	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY2ifoT5K2CGvcovnbE5qg444BspgRWu3i6eeLgibQosyKaunG
49193	payment	2132	2132	1874	1	1	2059	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkERJ4LvfLp2hWxG7SWYp5MzHYCQ3ch9F4dnThEhyjQAByNKi
49194	payment	2134	2134	1874	1	1	8217	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2Hmqi2Q6WcJr5AgtBnajepg4GGmcNq6XdNHSFmsdNtkcyjnS
49195	payment	2133	2133	1874	1	1	7697	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhShQp1YsbxN9dzJu3CmuFjParXBDLoCEa5EHTFjwWdaM2ABJ
49196	payment	2133	2133	1874	1	1	7698	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsVWcDyWFgvXY3A9vtDuY5VDHoZPStmaW69Z9z7jkagSvK1Ja
49234	payment	1397	1397	1678	1	1	18069	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrGFMpCPG1zftUW5pVGhGeduP5wT5dhruXo1kRKhSjaWiwUmEN
49235	payment	2132	2132	1874	1	1	2064	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNuhkUBSBHJ3XhH1x2c625LEuixidFZQrJjqYYAn5DqKuYido
49236	payment	2134	2134	1874	1	1	8228	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGZeDR6RpV7aX7duoEvzNKWAUBBbQSmDNY7jF2j44CV9TjD7Jp
49237	payment	2132	2132	1874	1	1	2065	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYL4kU113vE1H4zqdKQgmw8kC1bNXYBAtBwKC1HBFKbWGdbGL
49238	payment	2134	2134	1874	1	1	8229	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FLh14sg3z8ZY4GFGRboFJUpwQSv24nkhTacjsmyXKPzQfZnK
49239	payment	2134	2134	1874	1	1	8230	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgBN6FSw4SLNknnhSxdkn5Bfj7SN26x7ACm89FcU5AWv4bmmRf
49240	payment	2133	2133	1874	1	1	7708	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApH5nr3vNL67hooYgcjAKwoMRG8kjJnPaKaxWVJfVwxrBqFMe
49241	payment	2133	2133	1874	1	1	7709	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRy9rui3wvveH97kTGYSWez65PVyakaURR7JrCDsH946YtXwx1
49242	payment	2133	2133	1874	1	1	7710	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfPAKCEhxFfPB3EtBd9UtC2QWSJJHy6xY8ZiProzzu6shdaoKE
49277	payment	1397	1397	1678	1	1	18074	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MYcC3xnApf6RfHUTiPXasa7T9S9L3urZqedqz2ydct9bonkc
49278	payment	1397	1397	1678	1	1	18075	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgb9ja3awzo7KAacBWUCNF1hWQH4YTTckXFEdbeGzz3FWQdGV
49279	payment	1397	1397	1678	1	1	18076	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP5xA29aDAiVsCam39FsM3MjJcanMeS1S3Wczt5ayw9UZ6CxFy
49156	payment	2133	2133	1874	1	1	7685	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYxZZEsJSF6f46LQozYCLuyMmkQEnJZYV9UwtCEAzSYubg4VH2
49157	payment	724	724	1956	1	1	5	1000000000	20000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqD7uwo1CgiPcBHGBZ35zvLN9sJLDD4N4ojczobiKqx8kQhMon
49158	payment	1397	1397	1678	1	1	18061	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgepnfg1ikKCiaA5rqUuerpBbq8bK33yVD7r7HrGUskrAqU7pW
49159	payment	1397	1397	1678	1	1	18062	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtwdR9YGevkUf2tvDjosnX5zH9S7XspsZEDcATyhWavQKXtttS
49160	payment	2134	2134	1874	1	1	8205	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZpmVzL2akQLUHxW2ckLQ4YB2Q1U1vqdGnNMsdhznmegNgXe6T
49161	payment	2133	2133	1874	1	1	7686	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzZMiMvjCSYoj3VdWhoWXCnp3fBrJeDbCG6Dy5S7sCh4kE7QKN
49162	payment	2133	2133	1874	1	1	7687	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzjsejiGjDgeeEgazq1nTMXXBKXPeFUhjnHYRjxBfHnbKhdDEr
49163	payment	2134	2134	1874	1	1	8206	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7DeM2a8UzxbtGfkxSSmf4yWkJaXog1gfnfHcdgiZR4U1RvpN
49164	payment	2134	2134	1874	1	1	8207	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQDPQtEU7PyBw4xB68PtHktdZgd53gMSykohMSexX27ynhVZje
49165	payment	2132	2132	1874	1	1	2052	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgRciJNVE5WjcE6FRTtTuGZE9rAp3Qg9DJPbwzMssyFDJ9f16T
49166	payment	2132	2132	1874	1	1	2053	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWLYJvp5fdrnx8pWzM6huTeZrK7RCdc8cHvcvA6DgGszh7A9CH
49167	payment	2132	2132	1874	1	1	2054	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2txDi4a1ZqWMbsQpfYtr2JAkiu6s7kqb95RSC6Qpqe7mZvZ6Q
49168	payment	2133	2133	1874	1	1	7688	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5b4Wra4AHPRJzq11Qhk7iPeSQWdLSmTv315GTfA2m5Kigfx2R
49169	payment	2133	2133	1874	1	1	7689	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNKNJN5skoGsRuQyyJi9nkmJKM5WbuosiCZeQTUbHEeBDeqRP
49170	payment	2133	2133	1874	1	1	7690	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyy8MKpdT74qFHDUBmwCghs4JKDbv6soMdSbu1e5R4JGgMv4bk
49171	payment	2133	2133	1874	1	1	7691	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbxNjnAj7ESmWoYE9yS2gwLNJ8DK4GMm4gaVJ1H3p5pwYdr29n
49172	payment	2134	2134	1874	1	1	8208	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGHajqo6ShHgbiYjg3oeof4rs85KuF2kYtr19rGqwCkx4Uq4j1
49173	payment	2134	2134	1874	1	1	8209	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuaXqFpQa4EXAT8SY1CeyKNVE2TGyhD2Xph66gMLwe5TxV2ES
49259	payment	1397	1397	1678	1	1	18072	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcMzw4nnCmzjnsj6jhmCCstM6hVUTYQY8fph5avyzyVT63fnJs
49260	payment	1397	1397	1678	1	1	18073	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiUBgvTip5GJxuW8PqeUjRfkunmrcDuS61gVnk6QvxcvE947Z
49261	payment	2132	2132	1874	1	1	2069	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb9JZ8dHFeJhErnaZw5VcR7gwiGBd9sHrPbmqrPYjmdUGvbRig
49262	payment	2134	2134	1874	1	1	8237	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZaEBJmztbCn8nwYTVcEzMZ3m3d9a3B2hujP2dKRT8oWQZyQq
49263	payment	2132	2132	1874	1	1	2070	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaxtCkhFr6LSkWUa94aXxYPSPDSEEvHHZHfu4H5v2UyGCm8uoa
49264	payment	2132	2132	1874	1	1	2071	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQfRJ3NVEG9HUy7Xn6ZgEwTCK7Mn4b66s4JD7kvo1Zv1okD8G
49265	payment	2134	2134	1874	1	1	8238	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqb6Q5VcW1srAGYsTZu5wb2xKC9sKPyUm6A96gLLmAk5PyF5G
49266	payment	2134	2134	1874	1	1	8239	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN1wDPRbjgwpaAkP8xy8Jn8QcezEBxgwEAex1Bq4zKijAk2NyE
49267	payment	2134	2134	1874	1	1	8240	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8fyfJai8p2Cv4jgPjJaVqGVVRTd2iKhK7TQ21G7VW3bGK8xJU
49268	payment	2134	2134	1874	1	1	8241	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSNYTaReZ7FvPwbK5ZH8g4RfBDt86dyCzuc9H3ciaPMm2p3SE
49269	payment	2134	2134	1874	1	1	8242	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAVP4E2mqHpy2ByqztibxC1o32LXWzd6UfvP9WfqkFisMSaxGb
49270	payment	2134	2134	1874	1	1	8243	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8toYMqpgJ1oCDvDXrPJxQNVotNcjeUS3mcmh1qk38rg6VGcFo
49317	payment	1397	1397	1678	1	1	18079	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqhMTcnheoPhPGiyaZrrXzXCLX6HaGpjUUcF79kQda876XGZfz
49318	payment	1397	1397	1678	1	1	18080	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjDa2AvMy84rsxqf8c13Vs6Mpgn7KBM86FdP5A5LDQdZiMtJ6t
49319	payment	1693	1693	342	1	1	1383	86281724001	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYscpYvobjqR6ZzaPrhksDKEQynUJz1LyGJJwYTBeVcHMnLAPkC
49320	payment	1693	1693	894	1	1	1384	402816835368	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZXbwnvfUC8Y3JvSNYXG4ThxGkfSMuhMDXWuxMw5kh9KhvtbAhi
49321	payment	1693	1693	569	1	1	1385	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZYbddF6nYnb7JiBHfDP3AGhoXVXgxuhrAr9xTar6qTiMA7UhNK
49322	payment	1693	1693	390	1	1	1386	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYc1mngr1eJ8QFU5AUfGFGNjxzJtjvWNow8WHXMszgQHj2RL7De
49323	payment	1693	1693	570	1	1	1387	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYmBu3JMRFc7aTVubh6aCYLNr7SJ8zHuZXEDzbPweHVt1Cdytbg
49324	payment	1693	1693	251	1	1	1388	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZRRNc3higtDXsFAEsCYvecQWY3oFxaaHSKkWuZid9sjLtAMqhS
49189	payment	2134	2134	1874	1	1	8215	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpG8mwgunkUwhk97j2UZpKEnBG5zdbpwkScnAioXYFMFueHvno
49197	payment	1397	1397	1678	1	1	18066	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYyNhoSZgX39pHKbJ5ekgA9TfEJxW9y9XWjtVipFxJHbZgw2FG
49198	payment	1397	1397	1678	1	1	18067	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuJ2EXERUoiWR9RaN878gFWS4AnhwCFFJXjGCsgDahZt4qnBH
49199	payment	1397	1397	1678	1	1	18068	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFpcFn6JFNexcDQiydLBjpnopFQAv6e2CtQxusvgNoL6XZDmAM
49200	payment	2133	2133	1874	1	1	7699	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kDV9CFaMjCLRMCKKYNnXXmNE4gzw7uqQ6cHpDYcnrSaCKL4Z
49201	payment	2134	2134	1874	1	1	8218	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQjCeMkKBx3LWQpJiA6v4YvwCJTZdZu4xCThZKsTPAEmyL1c4R
49202	payment	2133	2133	1874	1	1	7700	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe9K4dzsDiNAMEPDPYLVuv1HkGvhzKZV69xUrmZpyTpz7RuVx2
49203	payment	2133	2133	1874	1	1	7701	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZXaVRK4tLirAe1NP2Pz1v3BxhViB715GoXPW9V51DwwBamqs
49204	payment	2133	2133	1874	1	1	7702	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWYt5XJrLe8XPjzKGG863bY8wQn2zwqytBxWHMbchf4EkQ1J3Y
49205	payment	2132	2132	1874	1	1	2060	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jTCyTVtCp8x7ybZ7ZfSpLFcYRgGeL4tp7is7VmrfK9ncNP4E
49206	payment	2132	2132	1874	1	1	2061	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeBmx8YwkKHdbcPmQccxraP6TxR99YXx54dCCLFrT4BTeo6gCD
49207	payment	2132	2132	1874	1	1	2062	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvkVV8HG4vhFcRSfVJYXWDfb3CRLvNSTGaSKDxywZY8ySQ92Km
49208	payment	2132	2132	1874	1	1	2063	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmBj7t19FVwvevQfs6GbJYibVND28yP3Q7GcsdUoEL7XciybkB
49209	payment	1268	1268	1269	1	1	32	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa55jaPD3DCDX4z5e4sM7ynMhoT5GZfswhREimXw3MSUnSWgV14
49210	payment	1268	1268	1269	1	1	33	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRVsEgfaaf5ZgM1ha9Us9nYrNmz8fpaZEWtxdZLkLHz2jCfqbB
49211	payment	1268	1268	1269	1	1	34	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcgzv5m2WdQBo9tonqFynKFrJneYUPiW2yxGNrNXrcQoUczUhP
49212	payment	1268	1268	1269	1	1	35	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw4RcJY73j1bQkjRnUzri1KNJZuEjgr9nSSjKynmnVKhsYQwuG
49213	payment	2133	2133	1874	1	1	7703	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7YCXxxZ4kUoZ9BmHgAEkKQqgPqE6oiY6pHZ9gwb1Pekxtnqdk
49214	payment	2133	2133	1874	1	1	7704	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLYobo3YpcRi1q7StSEHfdj7ApFZHbN1k5BuA44PcQDeQbSQbS
49215	payment	2133	2133	1874	1	1	7705	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiWr5ap8B7YWFnA6MmfwRksSdg16iDQpLeQ9oQJHgi5bAJ3RyE
49216	payment	2134	2134	1874	1	1	8219	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8HMUhU4hyyxz5HcTn6GqaDq7PsZjpyg77myBDSXpYonyKZAjg
49217	payment	2134	2134	1874	1	1	8220	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7WmUAqAiDrczeWb3BT4bKRBmg6reLqNZ7w6F9VmeDV4TaYDpN
49218	payment	2134	2134	1874	1	1	8221	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGQnn4yYhDEnvqdnTR8qjSNEkN1JZJFzYEcJMxPuitVPpxtoK
49219	payment	2134	2134	1874	1	1	8222	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLPhCdcK9JpHKgmpRS1GAhZLKr4Gaa67o8tzdnTy9JVTVvMcfA
49220	payment	2134	2134	1874	1	1	8223	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvVcn2nYBL3vNGfo3fVJrGQzep24BJAyTpuwZsUyZhSnJsE9fn
49221	payment	2134	2134	1874	1	1	8224	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxcxuZUKY9erb2UWSd8w3XMWSC7e4mc6ipcUE9msjV8f5mXxfp
49222	payment	2134	2134	1874	1	1	8225	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYViP5oMdArD6oLvhTLKXDdaGUZK7ghprkL7xBSpUCet47R9dX7
49223	payment	2134	2134	1874	1	1	8226	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqPMQaVLFxj89MJ8WrLFxEpxTDPJbNTyjVFsQa4qrdt3NvqUd4
49224	payment	2134	2134	1874	1	1	8227	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa868AuJViCeRbKdfSJdvqvMsJ8EZ8wx7ds8mWCNuM9cYLD88EP
49225	payment	1268	1268	1269	1	1	36	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8YwhjpggKWNYRYeV1kf3iUbar8wtbmGxB4RymazU1XVuNyADE
49226	payment	1268	1268	1269	1	1	37	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQQQNrk85igyTb9jg2RLHTGoME3w2SM4HhDJvMzKedihFDE9w
49227	payment	1268	1268	1269	1	1	38	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzCGSxWNb4QuBcXsv9xjCNEMALp6yKeh12HJ7eoMSaCMgvH3iX
49228	payment	1268	1268	1269	1	1	39	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95DdQLZhV1KDKWE5jA5p8NkzWKX3wxFnzKF5Z31LX76CuQBQq
49229	payment	1268	1268	1269	1	1	40	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgoPcwQPJRuBckeYzV4SGnews3sEHuAJUSxGsC85XQM69TLZDJ
49230	payment	1268	1268	1269	1	1	41	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMe7UJ6CzaD1FpTpX8gYSVvNzSpwLvbMu6TrD9KPjRCEUDsDTQ
49231	payment	1268	1268	1269	1	1	42	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6uQ4GZHkfUvBdQzrKPfxKvKCTBTu2r7kbrqdsnwpb3SuBHvSj
49232	payment	2133	2133	1874	1	1	7706	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkgcp9XMNgQuT7DmXovJium83xngt7gZaLs6Tsvpa5HfYhGex
49233	payment	2133	2133	1874	1	1	7707	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsUVxgcCj3XMKHzw6LWCgysJ6zu63sThtHDTt6ztPTtDEAY1zp
49280	payment	2132	2132	1874	1	1	2072	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9QvKWGXFyfJxCrPAwqS1yKRBUmDkJHN96i3ziu5a5negawLYw
49281	payment	2132	2132	1874	1	1	2073	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYicr8eaPBJAq4rA12qmS16A58rYevp9JfVBAkrKdWktTYR4it8
49282	payment	2132	2132	1874	1	1	2074	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy3uiP8BmcDaArCj57QLMQptMMLrEkD4yBWBKqsEMhGcNikfyM
49283	payment	2132	2132	1874	1	1	2075	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfHRECiU7n7QJ2hLsFniCEEfcWkXL7t3yg26mrWJqDvKds5PNZ
49284	payment	2134	2134	1874	1	1	8244	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg3pMC5Uf3MpqNMyWP3TV9GE817jZvZ9qoHQAuc1tXBftkK8G3
49285	payment	2134	2134	1874	1	1	8245	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYP9qZvZBm2Sx9M7jF14ViQqwYcuSz8qsJQfYt1MG2Gq6hTjXu
49286	payment	2134	2134	1874	1	1	8246	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pPcLoRyMqdsygJ7iizYCrAnsPzVB3adKpuzzA23kpSg3JJTB
49287	payment	2134	2134	1874	1	1	8247	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEkWX6maJnFMNJLm5hM171jwa9Vs9ecpjUwNo23VmzHhABLGty
49288	payment	2134	2134	1874	1	1	8248	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfhC5tE9zSVjSdXQzRBqcWohex91psEUtnzocj4SdPapTDVua
49289	payment	2134	2134	1874	1	1	8249	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBs6FoKRvB2pXnvAmjVhMpVWZqR7oFnayyPTqq1q8zYLiBLve3
49290	payment	2134	2134	1874	1	1	8250	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwX5xqYerNCS6zvAshE4GwS6nzgcErbfZQusVYBfnRbHMUhvnw
49291	payment	2134	2134	1874	1	1	8251	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLP7V3YvgZUUHvxsUPyp1DNn58PLTycbj86Q6CXzoUuJX9oFh
49292	payment	2134	2134	1874	1	1	8252	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4wdkhGehJcEtTWmfrHdNAPYHiDumMNWe77e6N5JCoCi4gHw3E
49301	payment	1397	1397	1678	1	1	18077	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtX3ZrTPxnwXArgU3xr4xYBp8Ypr3ZKQCCRogqq3t5acagWZA
49302	payment	2132	2132	1874	1	1	2076	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8h75R6Wd4tEojCxbmPwhv56SqVR1eQbrto7MSie357Dwku8VV
49309	payment	1397	1397	1678	1	1	18078	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAM8X4PpLscMEbgSbFqSb4Sn9FYoefXCuZ6gJrs2H7k3Tku3Zd
49310	payment	2132	2132	1874	1	1	2077	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyMEcUpmkoEbEhU74Nq68Yc5Ndj5isM9AsiJuTu9P9Bfbfruqh
49311	payment	2132	2132	1874	1	1	2078	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLD213TFpioAamMfuQXo64QuTKTpewiBpUjR7DucDyTeA9pHLN
49355	payment	1397	1397	1678	1	1	18082	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJezKPNpkQBdydKur18MwrALiJiXtkkyDsmiGAuhFRLyBGYupu
49356	payment	2134	2134	1874	1	1	8265	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSpBjJjtX2hLXDfZZRsfu8tEQnSPLFPPTvfyfnHmPRpwhNZ5J
49357	payment	2134	2134	1874	1	1	8266	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmDnXmoCfN5Zz7mYfBiufyMgYGmvn8vgxjAXR4LQsVx3oJCGH
49358	payment	2132	2132	1874	1	1	2083	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtkqdHDb2HxWgJTZkfMtgHNxmE8RUdKizvwYmJcwRhcEkxgQh
49359	payment	2132	2132	1874	1	1	2084	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvUVfKQJ8Q6r4ayCMhcoKp8mmu5nTrRKvdU9vXbspZAtQETka9
49360	payment	2133	2133	1874	1	1	7744	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8K6MG3o37PCtBfVWjnjaoCHxDRcTHF7WKvhSAZ8UVDhHJqLSV
49361	payment	2133	2133	1874	1	1	7745	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtzCxTB2rHc8FtKukWLhYhzFs6yKfuFc171fexSVti8nofmaSU
49362	payment	2133	2133	1874	1	1	7746	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9EvGb5VLSzE6P6ZJwttm2uCD9aHoH7v5esYxMs8VRZwUsTDyx
49363	payment	1693	1693	1811	1	1	1399	238084910275	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaE2tzX7W46Cyw27YGw7tf1T6rh8Ue6JzefbMpj6xNYFzda8i5y
49364	payment	1693	1693	520	1	1	1400	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZtrFMA8UQuBMbKWYCxGSpBBrk4BYLrForCZHSDTWJEGbZj1qGk
49365	payment	1693	1693	191	1	1	1401	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYrsGiM98vKDdVs7YQg8H9TSS2M7VHGnRKzeF9AQtuwcXej7fRt
49366	payment	1693	1693	421	1	1	1402	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa977JYAN2yW7U2VEhSfuicb3nHRghuthasZN8FkyT2fUbpF8aF
49367	payment	1693	1693	266	1	1	1403	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZAfCkyXf5qwSS3HsYLeXtApDB4dEepNYeAws9fpREf6NW6ViKX
49368	payment	1693	1693	352	1	1	1404	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZnzUvfgA4hptjeTJN1j89bShTEtGWsx4YDfZp2GibSrneT8sfb
49369	payment	2134	2134	1874	1	1	8267	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfvwA6E7iKNY9xZWzyuS61p5e2CWLd8KhbyxHvPTN46phSfVRh
49370	payment	2134	2134	1874	1	1	8268	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ZQipbBsMv1kn6VqubU46Yh9zfbNd2YSv6e5pDH8WbV6Q8Jh9
49371	payment	2134	2134	1874	1	1	8269	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4YSC4GtS7PpxkmBd4xocB55AGm6VLRFxuMBveZEQLCMDBuQBi
49372	payment	2133	2133	1874	1	1	7747	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBidJkbzeYh8aLGvvmucBLgT799FQrQJHgau4dYP7B49kZJTBx
49373	payment	2132	2132	1874	1	1	2085	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYD8yaQc73pbU347KoBzLUsPF7SBiyg645TagePiUnEENgjcc5
49374	payment	2133	2133	1874	1	1	7748	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8KqZKCHiDcoeiFptLn8cgDHsE7kSmheze1dXvTnqZ9YikpVN
49296	payment	2133	2133	1874	1	1	7725	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5cSW6E2AdXx9ARw6xE3hk9Xs3wEi8tg6q1ogoJaorFmZozSQ4
49297	payment	2133	2133	1874	1	1	7726	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx8XfwyWJX5F7JX6gdW22a4jbZm2XXmeLoNmG9anQ9aaiifFWe
49298	payment	2133	2133	1874	1	1	7727	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpeQ2egj5CrgdWe41FzY9rP2eRGFNthVLFxSWLrLk9xP8t5Kii
49299	payment	2133	2133	1874	1	1	7728	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3UNHVexRB2SMQjTWjWNpp6UzgZTuRd1s7ZQ2geSfxiNvn3H5
49300	payment	2133	2133	1874	1	1	7729	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6aa3X7HSB8u36LtkNJAWiSL4LwvAVFBMAptAxMM4cQErDKa8K
49380	payment	1397	1397	1678	1	1	18083	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegDJgYh78ukfk7PDiSjBN1BPcP3XCpkgrM9SSMWZeQpHSu6GK
49381	payment	2132	2132	1874	1	1	2086	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ek5pEgHQZEHWA5QLpFkCL1doPFxpyPudrB2tdtxN2uHa2UZ7
49382	payment	1693	1693	402	1	1	1410	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZPo4i9g1zgUnFnXCLATSPFqPVRpQ7PKBFdKPyGAhMwytK5iTGR
49383	payment	1693	1693	275	1	1	1411	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZKe4gz75pZJFc1CosmCvXiyuJwpZG1Rodw5BfA5bELmiFhGexB
49384	payment	2132	2132	1874	1	1	2087	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVsRz6m69nAaJWwpHVvqYGDYUtYhJp93yBbUk8JV2GKirYXXJ3
49385	payment	1693	1693	452	1	1	1412	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZtDdTG9vR6mAbK5oR1Tj9ufmdu9fDvJTY8W11A8qTqo4ne5zrD
49386	payment	1693	1693	458	1	1	1413	86283410386	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZcvUafJeYDVxQqiZYpWRmE11h6eNitsUeXB97LrGTenmqb2qtU
49387	payment	1693	1693	690	1	1	1414	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaFCZS7Qrjuaz7FBg69tP8JKKrjespqufrtCM8eht3rzjRpXVp4
49388	payment	2134	2134	1874	1	1	8270	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKKWzoHYGkpMVA4favDjNyFLvxNJqASBT4ax5YHAZiJHH9DWMW
49389	payment	2134	2134	1874	1	1	8271	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb55JrNak6xHzaMRN7DzwNMkiGWRJXpfrBfjXMVJXkySST2xJd
49390	payment	2133	2133	1874	1	1	7749	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLQoXERUJDD8CwzFsog8hS2me3nF8voD4Y7PsFxoY9tYj82dNE
49391	payment	2133	2133	1874	1	1	7750	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9EBo7uhPmQihPeYJx5gKUPD9EvbVwZrnK9GeVAJ22ApCyxGGB
49480	payment	1397	1397	1678	1	1	18091	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgCNUYLxCmSj3u7G3o4SfaHZWAeQzV87DaU7YTwwLYENVXMZuE
49481	payment	1397	1397	1678	1	1	18092	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVj2NbLtWSabzw9BEuqdm2PZFsFimFUc2B3E3f8P7myKmH6XQj
49482	payment	2132	2132	1874	1	1	2098	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCpfm5DesKgLSpHP2JqoVgWcfybFa7gWgfUiVGDQjACrEPEnu
49483	payment	2132	2132	1874	1	1	2099	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNG6r2tZKcuvxLArzfcHc1dw63BTWNPkEwve7QGi2yxSUAme1
49484	payment	2132	2132	1874	1	1	2100	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZffzPUG1KMDRrmLjcNfxfgXh8zr7A9zRbMiYvpJqp1L3YoBMyD
49485	payment	2134	2134	1874	1	1	8295	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsxfUsbDcXzbu8wcZzenNGY4ofkToPrwMbcHLRB8ivrTaSrB7N
49486	payment	2134	2134	1874	1	1	8296	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUz2YE4PCfBd51vxBeaQmgRmZCHFgegyjGXqHimbwL2Soad7Lj
49487	payment	2134	2134	1874	1	1	8297	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb5EaCfna3yDb5pboEYchJk93sBJbesaPCXZ8spXH6WUx8tvZg
49488	payment	2134	2134	1874	1	1	8298	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSFygGKa3Kfb75LvCndx9ZCLQ1fBd5pi858f4UFctSVoBUNa5t
49489	payment	2134	2134	1874	1	1	8299	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5bQsQxV16RrRbYAkhHW6sSCZf6uq1GFYu89pWsTRafL5k7Vcz
49490	payment	2134	2134	1874	1	1	8300	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx8Mhck91qsPboodYvmjvTsRqSZ1f9KQSvEj28cEQGke7i2Mq
49491	payment	2134	2134	1874	1	1	8301	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtP4bt9JAq7jWa3uGMU9xGuyYNeKKZ6UA6ZEk95XznMQkhbLNk
49492	payment	1693	1693	578	1	1	1443	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa6BGRRsozAemQJAMULrNdY1H2TXDCApSfr9wyE3UVwRt9qqbin
49493	payment	2133	2133	1874	1	1	7771	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDC2Gqr32KyqkaiXkgfjhhmRFsDMU2e5yoG2MjHuRuDveQvpJU
49494	payment	2133	2133	1874	1	1	7772	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZuwbQ1VAUSu3tPkKsztGJf6P1pNHNa9u1zH1hNszo7foC5zmu
49495	payment	2133	2133	1874	1	1	7773	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZud7LE2x29qn8pJ4UZ7uKiJoZpZS5bnzVMynfWmdZZd8SfMAnn
49496	payment	2133	2133	1874	1	1	7774	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiqQ14oJqAySDvUmkkKu37tuXU5ArKBxZmzjsbDnwP7fFSQDoX
49497	payment	2133	2133	1874	1	1	7775	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Rmtj7YW2VKWhX7V5rChBGKPa2eBnJ3p8XPREghgbone4o9rY
49498	payment	1693	1693	649	1	1	1444	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaEqh7UHokvjnSTGoyXaJ6gfLsMRfdXna4PwcDnqs7LcMGv4U5J
49499	payment	1693	1693	114	1	1	1445	86283867930	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYkFLePqngDkNTGSbbxLkkBKti4Rxz48B9RqCB5mxmpJaRBs3gx
49500	payment	1693	1693	443	1	1	1446	86280793223	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa37dZuRnTVg5BPx6S1yX8j4JtTiJ32gXu7iyk6KeaBTsvw8s7q
49303	payment	2133	2133	1874	1	1	7730	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhWWzWGQvjnfEKNuotfpoNx6MviyYQiEh9P5PGXL6mfC8yjrUE
49304	payment	2133	2133	1874	1	1	7731	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg4kk9NTANnMPMpc48Upj3rB9ZDp3HSUWjEGVoRWP8juoSpE7X
49305	payment	2134	2134	1874	1	1	8253	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGmMZLAetgndJwMEqJCjVAC1NhwJdfkz56sDNhU4FLq4yTCTP4
49306	payment	2134	2134	1874	1	1	8254	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoB9UeceApyFMcKNNcXiDkoPyffoEsBe4gW1JgEgj9J4uW9Gga
49307	payment	2134	2134	1874	1	1	8255	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLS3n26eXiTJQZ4WNtyRdnMSaGnhD8Z9yekWhFsDqfj1z9coi
49308	payment	2133	2133	1874	1	1	7732	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZufWr7k6wah2h1ZKpizn27azrfWCNWHUaDGC2nCTTzmvqpS9FG
49312	payment	2133	2133	1874	1	1	7733	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFDo46Xpowza52EqewnBkWbwkrUo2FTbu9SYgaCy4y7HcaZUxF
49313	payment	2133	2133	1874	1	1	7734	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwjPKtVW1z9XtaTAS3dq5zXikxgF78Di8nJ4TvSEePyZoSciVf
49314	payment	2133	2133	1874	1	1	7735	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcrqKhnKBtcVC7e9VYkJ7oQFPU55FRv2HDsBr1svTBu7vmPbF6
49315	payment	2134	2134	1874	1	1	8256	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHWNMqn9EEpNN9aKrBgNCE9QEKAfNQm4Th3opMVETjzV2nkBwo
49316	payment	2134	2134	1874	1	1	8257	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4KRQgEFjVp9autsWvQLDcewXuFDCNfGiFy79DyD8WitHCooC3
49341	payment	1397	1397	1678	1	1	18081	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpnSt6ecDvjDG6jyRzj6BBtivFq8hkoxbgrDz2QQse641L5can
49342	payment	1693	1693	120	1	1	1393	86281462545	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYq5nUdC9hb4rBfpQ2Mp8ywxLKqnKdBACZu13wVoS1rCJ3X2cxH
49343	payment	1693	1693	320	1	1	1394	86281433556	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYoTdHtyXBmHSNSMqgYGpNqknoKna2WuwhHmAVeayDJwb9GzQYu
49344	payment	1693	1693	354	1	1	1395	86283410386	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYZk9jYQsTAMmdeGStSxQx6UiUueexx7ZP52EwZQMaD8vsvY3YM
49345	payment	1693	1693	663	1	1	1396	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZCHixYAw2BxB8pPcsfrLHfopMtXU6EKBac3NPAYuZGvvufbUr7
49346	payment	1693	1693	710	1	1	1397	6564321195	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYvmikcysDJnYLdx16zv6YszmzmVpHZeL5v4wWBoFzX8Ed8rmws
49347	payment	1693	1693	499	1	1	1398	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYwoG2pV9JiUQ13vYUX1ZcQWi2tx37Pim2HDPJD4jXjVFuor2Jc
49348	payment	2132	2132	1874	1	1	2082	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaWm2QwEW4etR4T74kc5c58CaGYr4T4weZGEy2BmVGJqvhFTGZ
49349	payment	2134	2134	1874	1	1	8262	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZd7cUyJG63AGnDZuWA2v5DvKZPB68d4C7schou4rGikeV5vke3
49350	payment	2133	2133	1874	1	1	7741	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiiejRHPcRPea93Nm68sk9UksxR9iAg1rXoZtdud8RKdAKsfpV
49351	payment	2133	2133	1874	1	1	7742	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8D7nqDy9UVjXgQCx7tHnYEh7eAnQ4dtbsHQVzQMkNRpG8Kbo
49352	payment	2133	2133	1874	1	1	7743	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoFfJJBV4tvBiKAh3KS1nA7CLspW1Jacgpd4RMwtj2PEdPcdi3
49353	payment	2134	2134	1874	1	1	8263	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7siCWib9oTKP973CiwPwVvUh6RuF51zoH3tBVDajz6j7RtUQA
49354	payment	2134	2134	1874	1	1	8264	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa75FWjxPJhCG8avmukYS4JWwDdfaHCkTDbZyimzeFNPPDMPnwy
49424	payment	1397	1397	1678	1	1	18087	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQnUUBTgyeAr5kN4t27Yz5YKvyEzXrkHpzF6ZrtukLGmTeCkXN
49425	payment	1397	1397	1678	1	1	18088	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVzA17Rt3sHgkms32tRuaK9mm7HmtMqrsbeFmcPuoywddNaLNg
49426	payment	2133	2133	1874	1	1	7759	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeMq6nbs7Ae3sEHAaWd9F5oJTxWM1DTDTeNAsrSeviTmUKWBUq
49427	payment	2134	2134	1874	1	1	8281	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYumtEt1pDaToZVV9DeAG5brnFY8rdPbwJ9VpEtr2Pks37HiwuA
49428	payment	2134	2134	1874	1	1	8282	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnimp4yrofaXW628pGUBY5kXBX6veNj9dS6tY55qpp7FLcQtGF
49429	payment	2134	2134	1874	1	1	8283	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ54DHAjyKoPEUJLQLshVnrekixPh1ez8WxTvJ4hXSakYLd1yiZ
49430	payment	2133	2133	1874	1	1	7760	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LBoBaWEpoGk1cvyAfFhoc4qvRdy9Wp7DvqnRvPSe7ZKsxdzr
49431	payment	2133	2133	1874	1	1	7761	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QtoQTFCrMhPuVhWaucns8s38tf1BpGPae3Zb7gnQ8ePRcZDs
49432	payment	2133	2133	1874	1	1	7762	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWBpvJ6ATs6aAniHdhjPRyQ6TkrYoTqQxouuFhBTx8cUBvcaa2
49433	payment	2133	2133	1874	1	1	7763	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzwNAM8vzU1eH6AUNuRsRfeoUf1AWF3U7MRxD3Qe19g9FhUTJZ
49434	payment	2133	2133	1874	1	1	7764	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfCiBd5nrk5Eib94bfMg93XcmVH1Pzrb6eofwLfqQJfy1JBacq
49435	payment	2132	2132	1874	1	1	2092	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaVV7w2kZVuVeuSj14NzNBbYs7Hnm8W8VZgT8DxfV2H6us36rY
49436	payment	2134	2134	1874	1	1	8284	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosCXgYewxetUEnj4AVtzs2yBsf1EX1KpbMMjtRsMawr96iWDn
49325	payment	1693	1693	312	1	1	1389	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZDKEVNSDm1heZq2anZ9mgjPwP4UAN5bi2SPjd9BheixmS5Qsjm
49326	payment	1693	1693	1772	1	1	1390	622444916156	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZDT5aVADriX412TgzPS2bQ4DXjC7AnGPB9BGcJx3MaTUNmufTk
49327	payment	1693	1693	1030	1	1	1391	1183351888512	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYrEDjx5wsdXdAtJqQtcSg4oyHRRxs6zYLtkUs5dmq6hQSMhpUG
49328	payment	1693	1693	238	1	1	1392	86280495155	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYsA8dNDpH1gHqB77ydb42L7jqxoeDCDdpbwH34o8GLv6RNqceZ
49329	payment	2132	2132	1874	1	1	2079	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhNp7XB6ggXRMHmxcpFbM2kr2oVYaGGnR9pqbH5r3Jgt9ZN1vF
49330	payment	2132	2132	1874	1	1	2080	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLCommPQGuqkSxbKMDjeaufM4JvTyVVuAphTnFWJR8TWLTe5J
49331	payment	2132	2132	1874	1	1	2081	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSuzSXoRDTmZ7vKduUg2owJe1dx8a15CjrjHF42xmrEEMzZvNa
49332	payment	2134	2134	1874	1	1	8258	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQH6XwYVYiPPK2VbtjfiGLbGZfAyUgVFdwGTKEtD2Ezxqfvwg
49333	payment	2134	2134	1874	1	1	8259	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBiSS6Qhj7S2KeCv3fhpvoqLGwk8XUoqUoSzqrCabm31mu7sRv
49334	payment	2134	2134	1874	1	1	8260	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZdartyg6p6JUspNwHJD19eZDFxeZ4RgA6R7ShABZFByNNvtX
49335	payment	2134	2134	1874	1	1	8261	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYi92kBmKMusz8AC5jx67dHdH4JthP5gguWRigXDkUhV2bxu63L
49336	payment	2133	2133	1874	1	1	7736	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLaavWC9GvNrgZyo1ebg5TVGYnhHVZrX3bPSXK8t28MDsDMYq
49337	payment	2133	2133	1874	1	1	7737	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxPRhY6XSbKP81jhQF44yt3txUgr78oDhvAzZcVpcrCuumdcrV
49338	payment	2133	2133	1874	1	1	7738	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNeBKCqUoDwNgbKB1EMHwhhzWKMWuqxzKTBABsxbL75YDC9hz
49339	payment	2133	2133	1874	1	1	7739	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmb7MUckZ8w2wrnN7Ve1k5BYx7YtGeVqKmVSNthgXfyYyH6UR
49340	payment	2133	2133	1874	1	1	7740	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mwLvzSTVRpsoLUxCdhNFwYvAXHttoL2ziJt5DKLTgoBPTEkb
49405	payment	1397	1397	1678	1	1	18085	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNSBQuh48KsENfUowsg2ztLimPAHacuwGTqGzSsZZYkNdg3xG
49406	payment	1397	1397	1678	1	1	18086	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGe8tUhCX3SxcFAwoKTAHz1UACQxeeDjtsXK6ynUXLP2Ze4cPu
49407	payment	2132	2132	1874	1	1	2089	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYK5iuTQBhyXjGTDjwr9fwgJ5CYwBencctyQNerfLuNU37uUmH
49408	payment	2133	2133	1874	1	1	7754	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgL2Lu1bKmJt6mvmfNAKbys6iHDXXE1SDvjTSg539VEUoM3bzj
49409	payment	1693	1693	322	1	1	1421	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZBzqbaVwMJXWGzext2fr8dLH563pksidSzwGDMSLRSigDvthxw
49410	payment	1693	1693	10	1	1	1422	42563620739	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYxkf4GY3Lkh3nDgmJK62mib8jkVid6Mrv4rvJMRJUbqFkf1NM1
49411	payment	2132	2132	1874	1	1	2090	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHgD7o7zjxPWmC6oMqX9uVj6tT8bJb37AcaNHVof1sywh2poKt
49412	payment	2134	2134	1874	1	1	8274	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb4BQmSVzksQk1k2eb2F4iGcCadNcYBvccN8TFZNwVrvuKuVf7
49413	payment	2134	2134	1874	1	1	8275	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQXnGUMvmb77Yt2hAHNyffzwaYxJR7ZKQWvVQvGRQuLATvYLgs
49414	payment	2133	2133	1874	1	1	7755	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6FTvAHAyqZ62H8rAtkCFDc1EjppxAXhpSqX4DumJX28QL3Mnq
49415	payment	2133	2133	1874	1	1	7756	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcScfKPWHrt5kGuYPsxFXHVem5qZcYtGGGuLYZ5MM5FkU4s9wM
49416	payment	2132	2132	1874	1	1	2091	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa815PWZ1MTfAcTnoBGuzbBgdq9dA14dyko9jEobP3anmbRdkZN
49417	payment	2134	2134	1874	1	1	8276	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEvt1vLx1M93Liut6Ye5KQc52CskDvDJ4g7BdQQFGdW7LNSryK
49418	payment	2134	2134	1874	1	1	8277	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdtGp4gJXmnazSEwLV9GRDbDu5ndZebbQ87ty6Tssmn6EAbFx
49419	payment	2134	2134	1874	1	1	8278	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJymW6dnY56Z2e4mVfihc2njoAPnjzF9U9fF3zmfYWvRz3f1T
49420	payment	2134	2134	1874	1	1	8279	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9YzNDSrEV3mxBQjGLhFaJ1BFXTU7AETmy1mpvtekLfWYWh6F
49421	payment	2134	2134	1874	1	1	8280	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSf6oaYxUTUi1zE9SiY1yXNNP3qXnrUZXrFUct2xgy3MvHnKYS
49422	payment	2133	2133	1874	1	1	7757	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKZebNShN9QukFFStPJPWn1qfPFZEXvpMECESZfv1JVyrinTS1
49423	payment	2133	2133	1874	1	1	7758	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2Ne4NdF1jFsT7LW3NeWGvWdtf5uKYLGck6MJ1n2HmmJJRjdLM
49522	payment	2132	2132	1874	1	1	2102	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4bqpPn5jVxTtVV9EsXtCRRMadybhpzjVvt1GhDHgR6JsL6r91
49375	payment	1693	1693	534	1	1	1405	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaAr9EM5fUEn75XUHvx8yAUNQY2xgaAwsy8YoSyWiRF6uhB3Whj
49376	payment	1693	1693	327	1	1	1406	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZK51iYFo4MbSHMtX6z596ku75cGnFatuYf3hPegC7wXJT3EuUq
49377	payment	1693	1693	652	1	1	1407	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYsvT2r8yEe5pEwBRpbeCZ384eg9gkxCwNXYDF53zjiQie2mnjg
49378	payment	1693	1693	391	1	1	1408	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaGvRUj67iNZTm2UScTwmFJaXYpnhziUXZg9h4LPDr1FbBVFfyy
49379	payment	1693	1693	2181	1	1	1409	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZK3kktAUTzwpofLDnVUX3u5gtDn9215n6pAEvCWTCFZV3vhP6G
49392	payment	1397	1397	1678	1	1	18084	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEEUmBajP7kSzkLZ6BDcf21DytT9iymNZnag8eob6dJ5XRAbb
49393	payment	1693	1693	309	1	1	1415	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYT1Tdb3dRtYNEmJzj7mJzUq8FYwAWXwNgQka4Lfx5XP15NXY5y
49394	payment	2134	2134	1874	1	1	8272	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUgTjMGwvpdHJcknKLpMW2zThpsfYtjMAVkFcT1F64nX6akZSK
49395	payment	2134	2134	1874	1	1	8273	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ76RKu1LPJDbe5aMSKoQUax4saD9yq5WfitSS291PYSDJHcD2y
49396	payment	2132	2132	1874	1	1	2088	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W3vYPkPLMuGoo3tA2brZXMfcPK6dpGRpC9h9jLY76fJzdoW8
49397	payment	2133	2133	1874	1	1	7751	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7p9aU4XZRVpHhPpTzAduauHxzqyKeQP6Rp7PkFYzfVDSpX5Az
49398	payment	2133	2133	1874	1	1	7752	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBo87PvdQtysKUf1MEfRmHrrCCnoFnhBjeA4TrukLuukUviQUS
49399	payment	2133	2133	1874	1	1	7753	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ57JvFjBstLLkueF1gnXfQp6c7kGX63sbBQop55Hw8ucGSuDX8
49400	payment	1693	1693	82	1	1	1416	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaFH78a7NSrhaE5LDhaoznKyofNS5KfwJADEgi6EsynWotcrhLy
49401	payment	1693	1693	361	1	1	1417	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZgVr12MoKuXk7CXsmxz1Gs8pz3x5tqCVpRkZWSWq5BZ7fk7RNQ
49402	payment	1693	1693	680	1	1	1418	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaA2XnspuMU1BLM2gUuNQaDYGsyTdu6JKDfbYe2kC1HAMuBtFaU
49403	payment	1693	1693	731	1	1	1419	2625728471	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZqhQZUrN94bbngU6th5cTqpeVu41ATvMKhr96Mrpj18mGfqt1B
49404	payment	1693	1693	366	1	1	1420	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYeyQ1Sn8p8Kq18zNZAyaGLdj2tJqHEJkyuykTTDgtFLwG1Z6tP
49508	payment	1397	1397	1678	1	1	18093	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoUe77Hueh4ZNPpBiSwsu3qbMxeo56fe5vFVjfPMfWbgnpLqt
49509	payment	2133	2133	1874	1	1	7776	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJcEGTVET4UvWc7eynTM8LGrJpeJQNysVGF66GdxWg2dzdcGK2
49510	payment	2133	2133	1874	1	1	7777	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDryxK54dwpDbfoNz2qewXLsXg49W6rUVES5pvun3TJXghtm4H
49511	payment	1693	1693	611	1	1	1454	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZK5q29FsFDgkczUgMNaj8uonh89fPUcgHtDMXunTutrxfFg6iW
49512	payment	2134	2134	1874	1	1	8302	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLarL7W8HSXiXp9yf2162DSoPRfVPdhMhbEuuvHv6shm3E2gSi
49513	payment	2134	2134	1874	1	1	8303	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZiB7o1BJbgCeNfeTno7VzZqxJfqKzDN9y79vVNnyteuYWC6t
49514	payment	2134	2134	1874	1	1	8304	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgqeu3Jdu1supM8t8i7pg5Eujuc5Sx7kjhgP4mKBdc5XUKbENm
49515	payment	2134	2134	1874	1	1	8305	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMWgY2FpA6zdSAQwN3eYU3KtjT6FRwkGExgNVC8yFUsVRPaFjr
49516	payment	1693	1693	252	1	1	1455	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkwk6mZ5H5rmvzaF9GWZKJVTxVP17MbuFt3beebPSXXJjA1mvs
49517	payment	1693	1693	108	1	1	1456	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYxrxZXtsMwdUsJiUCxmptomtHcvqTazkWJVBMgzVoiMmG15UcU
49518	payment	1693	1693	1778	1	1	1457	2614765358	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZSanEShkK8F8q8hjF9xd1Nrgg22yxTDG2mrMeh73dDhjazwvLv
49519	payment	1693	1693	99	1	1	1458	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZQVRzRm6uee7z9MWyV8dZKZsJLtBZBmW8xWuUz19BGZUYqyire
49520	payment	1693	1693	35	1	1	1459	25206993399	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkSNN63jZLXKS1xwFd4C3NBuNZ4EHo8GRZDjArnEzbZtkQCuy4
49521	payment	2132	2132	1874	1	1	2101	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PJAkEoLiVUoUgWK26jNtcBRE5KkUFEDgNtgyZEP7UWA77xaw
49437	payment	2134	2134	1874	1	1	8285	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcuP7BsBx2A6P5or5hTirj7DVcw53bRNiAHbe9mXWyU9rP6w4m
49438	payment	2134	2134	1874	1	1	8286	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp8XQ4Yy3owYzrwEcsPKJXAVGd1kVdSbmrRNHK1YutpFTYe6A6
49439	payment	1693	1693	450	1	1	1423	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZqVm26YW9GkpWsiNET5nyCwCGUnEkiehZzn984fd9P6aFgrjFP
49440	payment	1693	1693	601	1	1	1424	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ8SffqVkZZXwwiCa7MnWQ5B85ansraSonFNn25ERdwZ46cVY7w
49441	payment	1693	1693	408	1	1	1425	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZFeUMzebWQmzjdkfneohs8fF867V5pvyJsDjh7xEWARvQS5Hp7
49442	payment	2132	2132	1874	1	1	2093	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6jimXVRY8R9dpbw8iVpEMtMWde12JUPa639648R9HuJgmLAHy
49443	payment	2132	2132	1874	1	1	2094	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxXadLBzv7hi6MAtxv6PWSFKZR2myfUe62wBBUeZFsdMrEXpnK
49444	payment	1693	1693	1821	1	1	1426	86843768235	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaCc79PtdRNfgYCPosGNVUfzBGhY6U5msBBW8sWFhmyshMC5dGd
49445	payment	1693	1693	301	1	1	1427	86280926556	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZFhEMaKZxPsquwpoChsvswZ7g2iPyRL6wDsFsRoqQbxH3XZUc2
49446	payment	1693	1693	339	1	1	1428	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaFWZ7d96vVvJnKcqQbJ9YXcNJncM967sqMoGuLNvj7ZViQE5Wi
49447	payment	1693	1693	186	1	1	1429	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZg5SSWVnHzv9p8hBTEcZZ1JVy3QKxvWPvnbkZCvTtKdC1UwqiK
49448	payment	1693	1693	392	1	1	1430	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYUfwPC6tY2z16nToZtZfF8C91BHxmJFobgLpXjE3YnGY1fqpDj
49449	payment	1397	1397	1678	1	1	18089	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn9yXJNGRsBHHj754d5259Z826JGS7D2diEKvc41sHgwfJGAoc
49450	payment	1397	1397	1678	1	1	18090	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgu1uxSL58si8TPiy2Xup4pBrkaFrTrvaJhDcRwVc5yMFNvHR
49451	payment	2132	2132	1874	1	1	2095	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdR5i1puS3NH1AekdpK4kPD5i61VNntPZ9bqQZCQ8FehqcW9VZ
49452	payment	2132	2132	1874	1	1	2096	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYo8PUumpqa3ZEZnanEDFPA2hQiupFdssHMcaiyAGYcyyGQ7K
49453	payment	2134	2134	1874	1	1	8287	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDQFkwVSeTjpR3dXEYMZDCuVsbzbj2e1FbFMsEK7obmMvGxL7k
49454	payment	2132	2132	1874	1	1	2097	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNUuoG6BCXhMEjA4NbJ5CpYu6EmYJK3JtKWWjLFXRdQjGCvPXx
49455	payment	2134	2134	1874	1	1	8288	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1iHsy6D3dkh8NxzEqwexknCnFEGcRmEfZx2GQpmsN5N1yDvA
49456	payment	2134	2134	1874	1	1	8289	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkX9PPsAaxpTPrSedHGbj4N49YM7vm4dY2oKDxYsVvyLHLJQFr
49457	payment	2134	2134	1874	1	1	8290	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFjsD1rApCLxTr3pScbXhGEDivCkfiFXXT7deibkFbxDwTN65j
49458	payment	2134	2134	1874	1	1	8291	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcM4rDmck6MkLtpYTPWaJ2VD9f37FQQkcWKhQ64Xz6vmHjeMCp
49459	payment	2133	2133	1874	1	1	7765	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRoRXeiLsgnG3fGVrwTYQZ2WRwvkTi1PuUCpyESfmgfmaMLh6w
49460	payment	2134	2134	1874	1	1	8292	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUcTGcMjdYfh2knqfQp6wuFBh9A6BzyT8Lqzi21hqJqcz1Hh14
49461	payment	2134	2134	1874	1	1	8293	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV83HnMDNSNveubb8sT9fnv5iZxm1KZUtVpW5iJUzZw27FSQYf
49462	payment	2134	2134	1874	1	1	8294	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjMZnZE1jbq3nkz3tHJJBoAMozUgKZwR453TaAqdGkkVNEwzmZ
49463	payment	1693	1693	283	1	1	1431	86280926556	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa2JecXqn4o9New3sg7bJSkwbQFwoJJMzGGEtRDbWm4G5iTdQNP
49464	payment	1693	1693	308	1	1	1432	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZXjMoWbQTSKTQR43NhqpiE7vm9CSvS7mjTYH91HdPdSfbXTEpg
49465	payment	1693	1693	2017	1	1	1433	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYzpGb9zdcVoGZ4dB7QpMPZLVp2bbnphSoaW5wyqeL9M2JjNMkx
49466	payment	1693	1693	105	1	1	1434	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ26BnxpxKNvynYBsF61X2MGMkLiNHnoovBCfB21LEiTuKcygvK
49467	payment	1693	1693	399	1	1	1435	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ3ZJVdFfkU6BSLDytyfMPUL94nrKYcfdFwdAYeC6GXtdFs8yKd
49468	payment	1693	1693	636	1	1	1436	86280285993	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYfVdjtL3JsdTLyZ7az6kwzkf15QTcpyrRUjzCvw2X6Zhf6d2F8
49469	payment	1693	1693	721	1	1	1437	2625728471	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZDcukTKSonRUhhS1GrCss9KCVf1ojyJ9Bn1hTvmiK5a9bq8DqP
49470	payment	2133	2133	1874	1	1	7766	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kPJ7gRZi4Gy7ncfmmYMZx6UcdkQRZWoTQ5mn32FRzTZjLrZ9
49471	payment	2133	2133	1874	1	1	7767	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQYqKT3JtEdm9DZKs5S1YjSw1eQDa23umTPtoc6Xjttez6CHDx
49472	payment	2133	2133	1874	1	1	7768	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5pjw3uzWcbutKnKuc3JusWjoRBwVB4o9Qhpeg1TXiDahGvtPa
49473	payment	1693	1693	206	1	1	1438	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaBL6DtZAZp2vPFvAn2mLCq8qdM9qv5ZTj7o1Loez24NWVcrKKw
49474	payment	1693	1693	194	1	1	1439	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa6accG5DkRvLbLr9uBCgJsZWaom6rqnAFV2UJxkbj9XRbP6Erc
49475	payment	2133	2133	1874	1	1	7769	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDH8a1QPmWuSTeY2YkNVnHb4VesYTcf3g1D32xdP6L4iY9HYcK
49476	payment	2133	2133	1874	1	1	7770	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyTRGeNRawLF1QToEHnnQqZNgsDVrGSP6TQGUHGbUWzjdBELNB
49477	payment	1693	1693	1276	1	1	1440	2224899250272	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaG9jpWoR75VqcRKz2298LyZ8Yik2dBJ2QynSnvtwfsSYFkoCbm
49478	payment	1693	1693	504	1	1	1441	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaB5RDV1FtumicHY3HZkQ74DvkLrNbpZMCZqcQsxYNRd2TmVZCS
49479	payment	1693	1693	205	1	1	1442	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaAjvDQtpfSnxHsVZu8c3UoY9NA9P3bpxcUehSBPK3jpTVVUAho
49501	payment	1693	1693	138	1	1	1447	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYT7ZQRNcR5jdPqpyBgmhg2gexbz78ub3wzFuMLVGcHbZhbcqxn
49502	payment	1693	1693	500	1	1	1448	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZJddhcoiTzbpLucQEsf7roWtv33FG6gJpHQV26Eg8giwLpQCgr
49503	payment	1693	1693	587	1	1	1449	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYa9n6BbvRCUP4zTCX5XRXGTvNq4NZG3b9g9qSJuxkRx66pcNjW
49504	payment	1693	1693	146	1	1	1450	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZCcJ13qKgjY7H6y7sjiYRFHwHAaM5NWpBN1qQGyg7wh3aGVHXy
49505	payment	1693	1693	225	1	1	1451	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZMwq1Y3hdspk5NXDD1j3Y7vUKpdn3EXxaxFSDWeEYXH3rGeRdE
49506	payment	1693	1693	377	1	1	1452	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa7TUNzKL52zo1XtUJGCmvqo95VvixQ1nRgyYuMdhkq3ngwniNr
49507	payment	1693	1693	560	1	1	1453	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYkW9hnHqUtBTb1Cbv7b1e58nXeFwzL8uzz79tHn9R5q4sxJGgQ
49523	payment	1397	1397	1678	1	1	18094	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiepGCnyCbAgEVmP9zrHgu69RL3JR9Dq5V5AwRSAoMRZmh5bs
49524	payment	1397	1397	1678	1	1	18095	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYorShMCneJ6XfExG1HTGBTXPfRHdvMzAcyWLVJ1vM1C68uwg3e
49525	payment	2133	2133	1874	1	1	7778	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmaJfCysCMsnShyu9VE2wfeUjEZPHp9Gnkb5DJEAK95bJpTW7Q
49526	payment	1693	1693	49	1	1	1460	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZKxCRxnnyppyYXJhMWz4VsZnr8DKuiFPqnac1RKSBK7y9gwne1
49527	payment	1693	1693	603	1	1	1461	87222845832	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYoxyTtvMUG4vtuVHfZXJDwH3u5f9ToGdFYqesRp5F3kmiHak9J
49528	payment	2132	2132	1874	1	1	2103	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3TFdbc1vsaJrvAas17ARn7ZAxEMGha7BWc6HjG5jn3GWw25vi
49529	payment	2132	2132	1874	1	1	2104	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUkzJ8Upfy3figKgEWpKgW4f2hkfrtqeYWsUJJd4BfXK6B8cFM
49530	payment	2132	2132	1874	1	1	2105	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfY8sEdXMrFMkjKniDamVgn3cMqDhKSzBrhafPHz4d8wxvbidn
49531	payment	2134	2134	1874	1	1	8306	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa59ot662gwTrhxvvCTjqiDUQiw6eQRvS6EK6Ajj5CtfZmqsPAq
49532	payment	2134	2134	1874	1	1	8307	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVQcAP9N9BJfVVAhne6pskEUx1o8wKp9pvu2GQmH1qnFFhrpE
49533	payment	2134	2134	1874	1	1	8308	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEqygxUx1ZB2fV6aymDxwwqD381h6CzqPvC4VTKcSUZks8Hi8
49534	payment	2134	2134	1874	1	1	8309	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePBrEZVSxZoz7fC5Kf4HWrrqLU8nq1cDXkfY5M2k9u12KjcoC
49535	payment	2133	2133	1874	1	1	7779	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa62oaRhBPRoLjKZ1uBaLz47f7z5uajfed8rydcpjjdBEtqnLFS
49536	payment	2133	2133	1874	1	1	7780	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9Bc3JVq7Hs37qFTTtAoH52H5faJnvxa89rqYm2GpNJoZY47r
49537	payment	1693	1693	54	1	1	1462	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaHDR6pikKZeWKK1Svu25s96n1c7vrwFviZUVZH7no6hXH1REAb
49538	payment	2133	2133	1874	1	1	7781	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHgVa9Yitw4fDp4iwppUqwc4teUbe6M9xw8HRHUqJdz7SaFDBk
49539	payment	2133	2133	1874	1	1	7782	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABN4TRL2YLarnp2hV6DL96sAwEYfyE31XAGybV7L59WFykBJn
49540	payment	2133	2133	1874	1	1	7783	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQu1RbdzsR2sYzeBrZ7WjeqsUBTPUHpiUabzMRTSdeETVBMR9X
49541	payment	1397	1397	1678	1	1	18096	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUdynLXeU1xXgoK9A73tDrdZjH67Wr7SqUzMzQBFaFeACeBXbZ
49542	payment	2132	2132	1874	1	1	2106	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ455RKLEydXvN19hhFGmEqNdrbCrbmVCzUhGUPaYAFXX2TMSsk
49543	payment	1693	1693	530	1	1	1463	86280415414	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZQPRNPy9bZ3GBHdP13r4az3DkHqRfrDF7YVaT7AA7bYqe7tT97
49544	payment	1693	1693	217	1	1	1464	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZeG5aSuZiWzXBqoB2kDsfE84KwBYU4zryweCx5J92C6HGUgEKs
49545	payment	1693	1693	103	1	1	1465	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZE8trEPPfQViYvuRU2bcFY6pASKQrUqcsxacE4xxCmyXzv7FZ8
49546	payment	1693	1693	893	1	1	1466	402816835368	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ4SDE2U3ZFFhFX9KnUomhGTMXLa6zai4Dv7UimL2W5bVyWCGJn
49547	payment	1693	1693	620	1	1	1467	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZWJexAJtaNXHwYozsgscFsn38rPZnJ9rCbM2jLy1psZ2EYTKiA
49548	payment	2133	2133	1874	1	1	7784	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeT2EWSDXZVSPj1fGTQQzqsT2mJqMxxpHbCD7RNMNcBdtisCU3
49549	payment	2133	2133	1874	1	1	7785	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5HEfSHPTZmSGuH795y2vssNhosFyaNUfCCj3yK152GAUZTpFF
49550	payment	2134	2134	1874	1	1	8310	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfoNvwUPouwyrUaUKJdrtrxL8MvAUawpb3LVCyW1Gu5vNYZLsc
49551	payment	2134	2134	1874	1	1	8311	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAmtJ2V32uuJy96axPYLngbaa5662Tr3nsPTPjv9ExysvSgWx8
49552	payment	2134	2134	1874	1	1	8312	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs4BPJ36mmfMPJ1Jn4doVWXW6YhoVESc9VqPrhM7Wm98jorp6F
49553	payment	1397	1397	1678	1	1	18097	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3jYmyMwwqkGPwqz3eHMC3qhGHXABzhJ2Luz4cj1rfzXy5dexX
49554	payment	1397	1397	1678	1	1	18098	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL78bT1nmoeAKw3ktoSzDX4nk2yAWLiEafrS5vun8QQA66zyqL
49555	payment	2133	2133	1874	1	1	7786	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc9PYuMtfQxnrGCMNzkzuwfWNhksRgHqxdQ4LQKC5ZUbUJDXPK
49556	payment	2133	2133	1874	1	1	7787	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwiAhkphX992pX4JRYCzqDAm8Vi9TkUB1vtLyZxmdSU9DZJcvH
49557	payment	2132	2132	1874	1	1	2107	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZANP1eSVX8HiVd5UTurdrwFyLvocNg8MNvW5ceEBWBNUqoLTCX
49558	payment	2133	2133	1874	1	1	7788	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeHNsTDoSq3Lc7p3f9HDBgndtHVFVwxxWTucFzVmCu3JZ7ZaL
49559	payment	2133	2133	1874	1	1	7789	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbs7C8K9iWaFcY1ANeH5SAwnEfXT7BYFzxJwn2Yy1NSFhNFvmY
49560	payment	2133	2133	1874	1	1	7790	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvsyT6FJBrdYVqBXY1zmuzxxTzvgYo7UFmVpPCjaZ7hN8B2n87
49561	payment	2133	2133	1874	1	1	7791	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPjZUX6Uq2bdxzA8ia1pi6xs9vKStDVEKzC8TBoQMyPumcpC8
49562	payment	1693	1693	245	1	1	1468	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa4PDmjyBTtbmv7FQaUxu7CrqvyegzGbqLqMuiFB3eTE2kb16Ay
49563	payment	1693	1693	600	1	1	1469	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa733gpaMJUWoKBNeW5mGN9h1Zh2NLgH3Rw4bmdT1zQzfgAPepd
49564	payment	1693	1693	691	1	1	1470	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYRdjqES3rxQ3wDYv3Qw46QvEqpJWVEgBhXMNG9vNLmQxMBawhx
49565	payment	1693	1693	2164	1	1	1471	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZv7ut6M5QmFe4MTdFdy9skzNG7zntV8CEHNMKuCCA5ZVuAfxiH
49566	payment	1693	1693	165	1	1	1472	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZnfurXfspHkgNwrZ3B4pG7uq69N9Ai9SnGtonkukP7b23qa68B
49567	payment	1693	1693	180	1	1	1473	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYzEPspzgQyRhysc1gpLuCfUqHgT3SvdzSaBEsuqETsZYs3GDw9
49568	payment	1693	1693	237	1	1	1474	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZvFBfhL5V8gHA48TkqhekcjLxVxfwMSBWQtouqrNN7yP43KPFV
49569	payment	1693	1693	2073	1	1	1475	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYZBsWuTmDyyaPnAnRTSX5NfhDSfa9HYJVRxvuCKJoi7DsMLXjw
49570	payment	2132	2132	1874	1	1	2108	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7SanDfkfpeE2CikZeiL626DAm1DrSanVz5kPVVrQgWVceRJPp
49571	payment	2132	2132	1874	1	1	2109	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QCnv34fwxX2Y82nP8SxmcfLJokYr8f17nGx6hBGcWi5MScT1
49572	payment	1693	1693	748	1	1	1476	2617678499	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaEvUxAMeUQtfbJmHTTXWji3j9etP4TCfGSKjmfd4V2GtkhemPr
49573	payment	1693	1693	163	1	1	1477	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYg7rYgh9emEDgWgNQx3QrzLpyc8NqQnbNKHG2AR4WJHwrHdLMi
49574	payment	1693	1693	201	1	1	1478	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkG1WQifk9rsqJ6cE7pYXX7b3CMqchZzX1PW5GgRmYzFY9FsvM
49575	payment	1693	1693	1962	1	1	1479	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYQX6V2CnmFVvm6VuMpii68o8nW5G1oZZCukMGR6Xm3myC9tBDC
49576	payment	2134	2134	1874	1	1	8313	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJuwii74C1jNzg2eYEo73nJ5AjL2tRtG3KAUgz639Qfcn9eG9E
49577	payment	2134	2134	1874	1	1	8314	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvdZ5Z8WzgBnwHned2XkGUpWrkpC5Yywk5YWH3HMe37GZyoqeQ
49578	payment	2134	2134	1874	1	1	8315	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnK81GKBa65stcyzyvVp7tjNuFVYK1YHVK2oEDRmad38KorSjA
49579	payment	2134	2134	1874	1	1	8316	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYmTcmi37n5c3FxEXzKHGPe2m5Mv2J6k9ojquVNWDo2gPQFs29
49580	payment	2134	2134	1874	1	1	8317	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9uF8FuaxCHCpvvxWmv2K3jZMANDZ4bPwk9qmM4S2cj6UG6XFV
49581	payment	2134	2134	1874	1	1	8318	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7UYAgVfarkXLXv3XaUfLBLEfJND7cA9WCQ6ipW2UsjBBHPLB
49582	payment	1397	1397	1678	1	1	18099	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7d9BVai9Cg6EyAbaTcaUGqmVHM4DwNQG3icMnQdqXDidCYT7v
49583	payment	2133	2133	1874	1	1	7792	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPXAL95wZXxJsUioJA6iAJARYRBtcKsD3rXSQX4DwLSCJneKSh
49584	payment	1693	1693	594	1	1	1480	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZbodpQyXe8ahTpa8ZJCpLQiDDo2P2LjTWcpaqeXXa3TnCkQ3Et
49585	payment	2132	2132	1874	1	1	2110	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgY49SAUmJDnzjPXR6soN4io1Wnv5aLmaNYb66Fk7ocaZoVH1
49586	payment	1693	1693	63	1	1	1481	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZkucgp5peMzYGARASzjNzjiN77tyKkQ6rw2grW3QdQeYYm2hR5
49587	payment	1693	1693	150	1	1	1482	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZg8GTWMctucVGsMJa5jb3y64BDNNiuXSKchA58sGnncor8KdVh
49588	payment	1693	1693	562	1	1	1483	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYdGPc2y6D2mwv4Qoz6dbfC2BfCj96VrE3cpveEBxoDkE9QTwzF
49589	payment	1693	1693	92	1	1	1484	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYnMqgH3vBtxBS4uSTtHemXizfjkNF3HS5Z3Bo1TthpLhys1b5L
49590	payment	2134	2134	1874	1	1	8319	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZBvtLz3Hk82kwq8ZHGmvXGFQBbYzGz1wHeiP3VqXBWQsMeae
49591	payment	2134	2134	1874	1	1	8320	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHAVuF3mqMaxSZLDLDbzb31ZfZKP961QjdW1fUrFeQNN7abQq5
49592	payment	2134	2134	1874	1	1	8321	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqTojQKkki2YcGYZrGo9WX7m5wRCQQCv2K2vGsPgJc6aa4ri1P
49593	payment	2133	2133	1874	1	1	7793	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ZYPCebU3sDjBJq9D5GshMogtxwyxyoj2Q4hYNuHArPg4PfXX
49594	payment	2133	2133	1874	1	1	7794	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzWWUYoNNb1YeypcsLy7MxoqE6iUPWZ2asAZVa4U3L73kW1r5
49667	payment	1397	1397	1678	1	1	18105	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqdaGP4QcDmbHJfmPGspDkUFbvjWh6i1JMSeZ5s7TCF2DFFH9R
49668	payment	2133	2133	1874	1	1	7807	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqXbnm8gFJKTBa9A2PkbMQ6wub1BUc5YErAftgB5ZD6hXaeNet
49669	payment	2132	2132	1874	1	1	2119	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvCMCLkLzjPb9nb7tE3otNoZX2oQoBysC4MGCrUzKDrVSckWLu
49670	payment	2134	2134	1874	1	1	8339	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQ7bDN5frkWJwGHgRcvax96s2emzgYW5D8nrPVyaVyyddRER7
49671	payment	2134	2134	1874	1	1	8340	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUejSMVGxCARWzAe2tNsEztDgdDn3NPB3camz9ybsRUqiiaSQ
49672	payment	2134	2134	1874	1	1	8341	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrR2oibuto4nNyWjRkFTxMTLhhpWLNN3Yy1ww1heoZpUMYT2SW
49673	payment	2134	2134	1874	1	1	8342	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMtmqkEmExnqLdPt7AoiP2e66YfHd6nmgMzxL4STGcJeGhGwRX
49674	payment	2133	2133	1874	1	1	7808	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEomYsNJPg9df4TkvM7dEySpvTP66Vq6FxJa3VzdSTvgkhbsd2
49675	payment	2133	2133	1874	1	1	7809	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3cu4X8qqFFt38edH5HTysN9PW4GH84j4Z7xQds15x2aoxGWp
49720	payment	1397	1397	1678	1	1	18111	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrDgqRq9FhzuxvadzaEcvZozjN4Zw7XhBpNyGSg9yUX9LEdpPi
49721	payment	2133	2133	1874	1	1	7822	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRyUGDUdqUxV8RemgYJNSc3knSJV1Y9JQL1uytAySvVLpMCGqt
49722	payment	2133	2133	1874	1	1	7823	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZAjH1MU3JWnT9pZs8Gb4UUgXTAcDyzonerJBdsPA44Lejw7Hf
49723	payment	2132	2132	1874	1	1	2128	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZawwoN1ogxBx9GkWJ8so5VB7pjm12a3GNWHsXRo1suPa5GhP35
49724	payment	2133	2133	1874	1	1	7824	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkWVUGfL9y2bQJQSZG8mcf3j9GgtVdLJj2KtspELtrwWRVXs7y
49725	payment	1397	1397	1678	1	1	18112	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8D37DractU5qgeAwgiCsFK4QDJQnCbWDaZkzqYDcY8FRWZjSA
49726	payment	1397	1397	1678	1	1	18113	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbu2ShDAFxSHJNCxzVHETfYsq5nzg731CdZdX9oD3H7shxV4tr
49727	payment	2132	2132	1874	1	1	2129	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT4y4tVAucy2fy6eQLFRh3rvyNbCJ7qoic1cy16mpNrZ6nRW2s
49728	payment	2133	2133	1874	1	1	7825	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdTu6zTbNiUddkaGzfu34jCc8Y5GPYwgiptpVDiDYrZEMWhFBE
49729	payment	2133	2133	1874	1	1	7826	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtstNfQDa5DznbpWHsjpUHqm715ngdskEmrKgow7hWSBSvgS7L
49730	payment	2133	2133	1874	1	1	7827	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqLrx87y9yWmQyk9R41cYuENZzcmNqvRyuxFQH7oKJR1qwDqr
49731	payment	2133	2133	1874	1	1	7828	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ31cCydjynmFuuQV2XWQNjAdUx6xt6m5uZaN3ns59mpTKBEMzc
49732	payment	2133	2133	1874	1	1	7829	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CpSHYp3XfjV6wHLHRtsfzFGcjQdZSRJqYTQcUEpdb1suepgD
49733	payment	2133	2133	1874	1	1	7830	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpeE29F29GKxB2XwDYXsuz5bfRWqeVtgmXRy5h1wwqNAbg6b7Z
49734	payment	2132	2132	1874	1	1	2130	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAvStrQWMGWVaB9DiHYfmZ3tPV2aegJH5TA7JJYpH4non5NeC
49735	payment	2132	2132	1874	1	1	2131	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRdXjPkiix6tCv3A5o8fBdJWR7LZ2eMRu4zHs1xJxRw52dLB8G
49787	payment	1397	1397	1678	1	1	18118	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv32rDtwQZrvLkFqCyYGXXDguPpmcazauRDfzybsasq5vhVREh
49788	payment	2134	2134	1874	1	1	8388	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkze36EhJqKGEwEoiiadzPBnVJMjad1VLVGuGh216WjR6vRrW
49789	payment	2134	2134	1874	1	1	8389	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3SNk9FVAdi5txrcqc9DjSZPe6pC6jmokhw8XE3DKWDmzR7kPF
49790	payment	2134	2134	1874	1	1	8390	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4WcJPYMCz3Ep4cKvFrGiwbLusr3WBPowhkBj9fD3MWiikZDK
49791	payment	2133	2133	1874	1	1	7845	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcHDjKGr1PBZXbq3Yes7XP7m4CBUQLgq2uLUgBafqzUBvL2URL
49792	payment	2134	2134	1874	1	1	8391	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtvGQyqS7UmrZbJfBcWkgFWKWTj5eZ4mwPLCAG1YpFddidARr1
49793	payment	2134	2134	1874	1	1	8392	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgCvkQPgy4Hytreiu72BFmCS4Qx6HJ8cGM5UTyuCCjnvS1MqU
49794	payment	2132	2132	1874	1	1	2139	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu8QnaAErxjVR1Fudc4uayzNBjDHzPmyyGByB4kjQA6tCJ3gNt
49795	payment	2132	2132	1874	1	1	2140	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsiu2H4ZonePCpJQxp8vtDTqndb76kKgnJoLXkqa1ckBw4otmF
49796	payment	2133	2133	1874	1	1	7846	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHaMPhE8fMSZY8QnDeRfxsNYgaxgXojniJTWwW9iZ89WMqSsSx
49595	payment	1397	1397	1678	1	1	18100	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHqrvgyYsGbqWoXbWNopzAn8ADexQ9Mm5R5EobynsPhH1kqDb
49596	payment	1693	1693	373	1	1	1485	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYhv5jazp9Kg4gKZtWSocfCPXN5Wc8rt7AUvWbgKA1a9NtQdD7h
49597	payment	2132	2132	1874	1	1	2111	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX1M3EBvpyr69pvzYyr69nLKQwCuQVaaqqBMb9C62KHf7SQLLu
49598	payment	2132	2132	1874	1	1	2112	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCin9H7xoZANY9q4LPgDFmbqM3cV6tS9c84LxU58F32i7Znxo
49599	payment	2133	2133	1874	1	1	7795	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkg5DJB5p86qQeHsJaF6ygRfF2cXLNzYyRryA9mZyF9cYoJd6p
49600	payment	2134	2134	1874	1	1	8322	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZprJ8GmFTz9oz6DQxBD9RUNj1Cc2dvxBmrBjpsQDBsPB8GZnG4
49601	payment	2134	2134	1874	1	1	8323	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGgRx4R1HTdci6ptPBcERPYmJAUZt6jGYCoENdQQ3T39NAtoPm
49602	payment	1693	1693	453	1	1	1486	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	Ckpa4QpyXruMzqM3c39g8G2jsMP8RVRZWkhghceLCDDZP6yD9Asdi
49603	payment	1693	1693	711	1	1	1487	3924955555	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ3YthZa4AmFev3soHduWYZzkhaPWG2XuMZzaotkyeochq2Hibs
49604	payment	1693	1693	91	1	1	1488	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYyrLTovBgNWi9QsDAaNAKhZsKARbfeNdvQxEzWV4uqAMqAcMUd
49605	payment	1693	1693	438	1	1	1489	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZc4vq7FJLcryxZT3T6zqsqSgiGA7Zdx3SAjAbrwJWpJfPWPZ35
49606	payment	1693	1693	745	1	1	1490	2625728471	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYkBGrjvgoYdPXiGvnfoGRjJfz3A1dCCqKN83WFN4FK3LsUMpo4
49607	payment	1643	1643	1299	1	1	25	1563405850000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77fkfned3Lwk6SenzPVCpV38hiwspazC9LerM6pgpzPAn93Ho
49608	payment	1397	1397	1678	1	1	18101	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq8tBW748TxpopDc3xaxU6nzoUhB6iUsF3vh3hCD2ARSxRPVyi
49609	payment	1397	1397	1678	1	1	18102	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfxXw1v6vkt1EESvbnfTQRzDnKSkVkhejNCW2SL4TxescrUmhA
49610	payment	1397	1397	1678	1	1	18103	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYanDdDNkSkecNV58dZjtdZdGDFdNXSTG2AnaASnCTairLBrrnr
49611	payment	1397	1397	1678	1	1	18104	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndmLbZxQKQhNqjK2pGbpm78qdVkEMHGygEiuieneKaZdkQWU7
49612	payment	1693	1693	89	1	1	1491	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZWgmbv1qYQeUoYqbwkHFcWRawd1SXoYqrz26VfLD3tKbZ7VNGf
49613	payment	1693	1693	383	1	1	1492	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYjYzzCWMYyxFFahmCrJv5GxMTojX2KppbrMTho1b6M3jiFx4YZ
49614	payment	1693	1693	678	1	1	1493	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZX2Xp5LinjWLkKc1bW3hXaZdjANi4AoVQ6Wm45d21qFUBgvP57
49615	payment	2132	2132	1874	1	1	2113	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbPVHunpMV6tDBQkQPzX3TqMDWEkfn3Jd2EhbaRJzzxCv7yz7Y
49616	payment	2134	2134	1874	1	1	8324	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZp1v41yAXWLLdP1oKzbPatNyK9yZx59JBZS7h5QuX6z7EMojRV
49617	payment	2134	2134	1874	1	1	8325	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkkLw59twDYwan5mcuPVfLptunvkzc6kLUR9r5Qe3w3AJi7yVE
49618	payment	2134	2134	1874	1	1	8326	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWJJq2fYLpgvnScSRzQVf3VbpzRxwzyCQJdJejAodTf3d8LMPo
49619	payment	2134	2134	1874	1	1	8327	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuS9PMZBXKNjr36eVs5o6qbSuH1i37y5KTpyjMRvVbAp2nnwpD
49620	payment	2132	2132	1874	1	1	2114	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpn6XqXBjm3jo5Zr6fRp7kPJ19fktgxMXJdWWDuv37jpc6T16k
49621	payment	2132	2132	1874	1	1	2115	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3xXMWTBXnbhD3ahh2uTBWRm5vmht2mNvUxqLekMj91oBuY8YT
49622	payment	2132	2132	1874	1	1	2116	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg53rxSyK9W98cdHkkZhLDy4Kf9oesgFF3BR9f7WUm94NGQrZm
49623	payment	2132	2132	1874	1	1	2117	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2N8E4pg1ScucDdEtoTwfaHSYUU72iRQJv6jgcACvdfpMDQcQy
49624	payment	2132	2132	1874	1	1	2118	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjHDTzC51sinYLjbeWK7b3XuXZe7GoT5wSpgAofqQbq6uam1m7
49625	payment	2134	2134	1874	1	1	8328	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJr522AzPuVvuroCoYVPaLwgBSetzHLCh7j2YRQ8XbrwbD88c
49626	payment	2134	2134	1874	1	1	8329	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWL4hDjRdN4BVFiBsBZ8GhgwFDhmGENebXLD9Je5SKiEdqGEKf
49627	payment	2134	2134	1874	1	1	8330	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZotzoR9SNLDiUEgixdosK43bufXTYX9u3zEKMWfd8ftd3crd2K
49628	payment	2134	2134	1874	1	1	8331	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUenebPfozXWZPpGMWPQjfh8CobBj3z3eZEtmaGLWwbs1FHCJX
49629	payment	2134	2134	1874	1	1	8332	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7UWxPy5thAqmNYGtdS845PtPe7RF6Y1w7k1txgCHTdHnexZxC
49630	payment	2134	2134	1874	1	1	8333	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUDLhTTyE6crXwQ3Bm7by2BP7pewM99ZECbAjL89qVi95g23C
49631	payment	2134	2134	1874	1	1	8334	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7zDQgvYCWwxzcXogq7a7SncFJfSf9JF8gyxXPdR7feC33EQ1w
49632	payment	2134	2134	1874	1	1	8335	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccw4mG7z9ZHhsvBjU7ZhLBqKmD3jtVjZ5HxMJpuiqpXRKgyFZ
49633	payment	2134	2134	1874	1	1	8336	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsGnmp2o5djvgiZB7rXoGscynzJqJT1FvUaadWbZu27xX82Dj
49634	payment	2134	2134	1874	1	1	8337	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu7Q62AJNeFGdUsQEbTQf8UEDW4fv53QbgMgzkp1h6CavdBnx9
49635	payment	2134	2134	1874	1	1	8338	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxhcqD5P9jbjmJohmMbxJu6QKxdxfoLgJvxFAVUv7H7v3455R6
49636	payment	1693	1693	1150	1	1	1494	798431099136	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaL22Ahq4kfUcN2L9eKYn18E5WbjNa3ERWi1NZqXzgfhNLjE4Fk
49637	payment	1693	1693	84	1	1	1495	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaKwQtnyVVtpW6eJfHh9LiRtQucMnFGoJ88U82KNQhXo4kHaqyu
49638	payment	1693	1693	2430	1	1	1496	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZhgtkXoRaG6MVyQvQ5JwQTQcDLk8XBhvMirHPkGYeT7XBRpjFB
49639	payment	1693	1693	551	1	1	1497	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaDFeo494jWZ5m4tUiq62eJu32yT4sMKbx4ybdgu4P8Byh2hNMD
49640	payment	1693	1693	122	1	1	1498	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZcQipPFMUE5rsf2aLmT8xHis72s69ZGF9ng7pJzbgtpZNg2jwU
49641	payment	1693	1693	2308	1	1	1499	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZEna2iCQopi4tytixXK6DrqYdpyu2VvRtpdg2dm3oDhZ6ZreUJ
49642	payment	1693	1693	653	1	1	1500	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYrktWaPV5eeW6aQi3RQDTTeEkuXEChiFcdyq6MwroZo2eNRrdL
49643	payment	1693	1693	304	1	1	1501	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZP5YMgnsVkUypMqFEcFLunziNdP2D56JYaqk8tzCXK8SySRkFL
49644	payment	1693	1693	441	1	1	1502	86280299069	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYYUnXuRFdmhPtg9Rb89o7kriEzTMyg1mcjrxskYkwRwJV341NP
49645	payment	1693	1693	240	1	1	1503	86281724001	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ91ngJ1cS2miXmK6ZUMKVJYM4k1waDsF5PBTDPE1PV8NB7uQiW
49646	payment	1693	1693	262	1	1	1504	86280415414	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYxm2wCwdCwLgP3JsNi3X7cmTj4C7aXxZzHBhV7c7de3qDBgVYd
49647	payment	1693	1693	154	1	1	1505	86280403654	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ53duteiMAXNKZWihZ624Ejvi9Y8dzVQpboKB7Eav4gxpejjW6
49648	payment	1693	1693	1961	1	1	1506	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZX4mH6SmQ4HvKiV78inR82MWad5yS71cfKXtG8aWqhBjiJKyvr
49649	payment	1693	1693	658	1	1	1507	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZA28ssbsyym4koFn1HfYKm4DYKQEaUPNvfbiPCWNyMmUscgA4T
49650	payment	1693	1693	660	1	1	1508	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZ6qkysjZVE9BB6xV59sEsZofv51qjgys1bjpGReDimdHiddGu7
49651	payment	1693	1693	593	1	1	1509	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZbWxDKCogx9EzUQQ1Mm66vsoxoCAFA6YKzMzth4G4L4ud6Xjyu
49652	payment	1693	1693	395	1	1	1510	86645078818	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYQqSr5R1shxmaeHN7JjjopmzeREEGmcW3yByV63z9sT9tScCPy
49653	payment	1693	1693	78	1	1	1511	86649039865	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpZjDA3nJDbz6KEwKG7tvQzRmLHrseyPB4wtaqbEMEbZLp6AD1Wv
49654	payment	1693	1693	29	1	1	1512	9190049669	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpaJcewo788D81L8zHD48AUXy3TgghRotptDb71oXKHbum2yZcCx
49655	payment	1693	1693	910	1	1	1513	660355773672	1000000	\N	E4ZKzbx9Jyimw5ajvLLjtRysTnWbpTtmzR1rsntqbLXu8cS8zfpZ3	CkpYptAF2JMQkj9GRvoR96ytErCs4YUKsVrRhjoEHCHsQcsdwxFVd
49656	payment	2133	2133	1874	1	1	7796	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLd5xr4TLFQkJxykEKmPDrw8b18iP9CVMKfk6ArP4RsVNMNF8u
49657	payment	2133	2133	1874	1	1	7797	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWewr9QMoYj8rdcdWKg5M3Ds1Zw3y6KZakhuYh8mjPh6dgpifg
49658	payment	2133	2133	1874	1	1	7798	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVvf1YBU6bhTW5j5ecNhDkyR73tAGUXuEUbsAobGABruoqa9K
49659	payment	2133	2133	1874	1	1	7799	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP1gR2wvYHtvfh9ETTF16UVzmxdf54DRPpw8DxJ2GDTB9G1p4D
49660	payment	2133	2133	1874	1	1	7800	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUT1RPDcLrC9dzWvRZ7QT8MpMFWcF6VRzkR1FuLVRuYVZwocru
49661	payment	2133	2133	1874	1	1	7801	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrARoasY3HsrGsdigFQUJMFxF82tMSosHTNSaDGZ9Bb1SLiRHF
49662	payment	2133	2133	1874	1	1	7802	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEVa6ejQ1X7HYCdoGAKTiZSPXPsMjFgGh5oCgvtVTYLWPEgnZe
49663	payment	2133	2133	1874	1	1	7803	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLen9khTK4XFT3PQdB5q9AT9x2SJZsegcPhC1p4a7sjxRY95ey
49664	payment	2133	2133	1874	1	1	7804	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf7KE1CXkY3j4qWzHNZHfPhdRX6wKTMFcnN3RzJkh4gik873Cg
49665	payment	2133	2133	1874	1	1	7805	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFkVavAH4TXqrAcn1ANq5Nq3f1joxbMR5ZP6ePPLbzgrihutr
49666	payment	2133	2133	1874	1	1	7806	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6GGDff4H1r47416yvA1WMfqisouGS5qdN7BHwxgbo1TNDEvN
49676	payment	1397	1397	1678	1	1	18106	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApCKWUA4A7bdr9cj6PN9yDEXjNshanotGdF5CDeY49i3kgBaW
49677	payment	2133	2133	1874	1	1	7810	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjT92k8pxjxiqqGUjmUGhgwo986Evjc7uRGM8gXQ723xpvDFDK
49678	payment	2132	2132	1874	1	1	2120	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkA3QEhtZ4mymVVEaXNCaGfqjNWUvg9M365jE4QHyhJ8rQ9PWE
49679	payment	2132	2132	1874	1	1	2121	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjWH2TYZLXkHT159GkhWwCSdc1zioZAicRy9f3gmCfbG7W8ScM
49680	payment	2133	2133	1874	1	1	7811	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkA47w1QfchHDYkRjE5aRJ7jM8hHJBqyL5qb5r99s8KAeYyRfE
49681	payment	2134	2134	1874	1	1	8343	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA9V6xUR78R7ui2e3frWZAW5yRPbqqvHbzgeEdT8guKDmQXGwK
49682	payment	2134	2134	1874	1	1	8344	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBSgRu7qWk2vTXLPszmxC5wsSMe2mn1kBjVJCme1XXE3PNMCx4
49683	payment	2134	2134	1874	1	1	8345	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZory84HcGFZAqcLB3afY4HezV2FN1CoGzQxnQ9UeYvWoXsZrSV
49684	payment	2134	2134	1874	1	1	8346	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY5v8NEWTrZ1atEePkBux6mQgiMQggytkQTXVS1s9x4JE57WxL
49685	payment	2134	2134	1874	1	1	8347	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzC8po7vPAbg5pCR7epYhpNPm2VTa5Rr3USXoFh8FsVe5oNkuy
49686	payment	1397	1397	1678	1	1	18107	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnFwqBqPhdmqpzsvK67BpHfCDk475fx4MQQaDiGzvpJV1QrGGt
49687	payment	1397	1397	1678	1	1	18108	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpkwT3w78EcPQrxtD2yMzNaXDsexTrfcYAK9xMxKFNR5zPZNwW
49688	payment	2132	2132	1874	1	1	2122	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbe3F78936EZYYNtQ29AJnqv4ktPR1ocQYGn6n4TNMj4R44Djy
49689	payment	2134	2134	1874	1	1	8348	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj7KnSxeztEE29FLxjHLmBeJiBUyuaWnrKrzDKkuC5cNrPGTrB
49690	payment	2134	2134	1874	1	1	8349	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmNjCCcVSNYeVzupFucVHEtz22K8iXNh93SLH6NoHL2xqMpT4w
49691	payment	2132	2132	1874	1	1	2123	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZypWzrU7sVbrM8WPBg8LxbWY29iVy85w8WKcaU5zd9ZeuoLz1u
49692	payment	2132	2132	1874	1	1	2124	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkyJUy6utUNRrwUvRm6rbtYCb9r4MGiCHXGLHtk3dZgoBxxAd5
49693	payment	2134	2134	1874	1	1	8350	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzJwQgkqJ7LpNS17wTd8k6a1YzHNVZHhjz4WKrEEV5MERHh4xv
49694	payment	2134	2134	1874	1	1	8351	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhMFHN9gqUq4pV7P46Yx9giUGyx3icqwi4n69MLfeXC7Up8gSq
49695	payment	2134	2134	1874	1	1	8352	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbCZkrhMShuksSocoYyUWa7aBzEZWxkVPoKjyGDRKTBy7tQcNu
49696	payment	2133	2133	1874	1	1	7812	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4aQz6d4cVK83yperKvK6Mz3xwwiRZjiJBwUzavNKZWz7VY2uJ
49697	payment	2133	2133	1874	1	1	7813	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf9tC648Emg1r6UFp2ASXtykzTzk5zR4WvhLhvrcWrH9rGjj3Z
49698	payment	2133	2133	1874	1	1	7814	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZRFswwBoP4bwDb61F5gVEmionnuiqHYqN4rnyZrcXmRuYRae
49699	payment	2133	2133	1874	1	1	7815	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTsXYsnd8WmMyPJJm6p6EvfYTA324JUt3skDDjAJpDuwg7CXC
49700	payment	2133	2133	1874	1	1	7816	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwc6Fy2tgBx2LrrQ92fsxJFcFBkTkHdqZd4hLvRLfyUVnwa83P
49701	payment	2134	2134	1874	1	1	8353	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDu773YT6HZ3hYRJ94teP8GsCWUUU7XNQTRa9DTPFxsAkCJv1D
49702	payment	2134	2134	1874	1	1	8354	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFScn82hQJGkJr3AUFWj5XEgJMCbq5g7pM3iUXCa82a4NjqDdM
49703	payment	2134	2134	1874	1	1	8355	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBAfkhFs5eCpUtsFqVcF3n8vbkdcqF1tsjwnDHAmk8kkTU2Uaz
49704	payment	2134	2134	1874	1	1	8356	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcsSA1qTLK8SRK6DnFuaxZvSCDygktRWe3gwcm5TLnVwbUEHpM
49705	payment	1397	1397	1678	1	1	18109	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtrhctdfMgoGbGgf548AwBxK9GDYTJEjJfPmskYDM3q3ym3uR
49706	payment	2134	2134	1874	1	1	8357	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvgrMcKDHGn77bS5jUptkisbZi5dGdLbihoq79h1UiBNqvWUc
49707	payment	2134	2134	1874	1	1	8358	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYFfEtijzuhYVssjMSMnXbhfa1ZTc81wATNX5EK3BmmtYUZmxN
49708	payment	2132	2132	1874	1	1	2125	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuLMWJKVrg57FV4mtbXSfMGSMqTn6SbaK9dTdubhkTG1UTbcW
49709	payment	2134	2134	1874	1	1	8359	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3iC6vEivrxRfo8LQwFAaZFeHne4597tnFHHUxBWYSekNTFQrY
49710	payment	2134	2134	1874	1	1	8360	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxCf8kztTvBkNbDb42ZhpPf1cxRGHoHsujYQjur6tpUDreLeek
49711	payment	2133	2133	1874	1	1	7817	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDTKuSxekVzYawEKZrY6mno5PLonEnNKhuQAEQXmyubawiyT6U
49712	payment	2133	2133	1874	1	1	7818	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRv8HeWtb7AjNZQp6MthVQhvJSBURXr19Co4r31FWV17MgX2ks
49713	payment	2133	2133	1874	1	1	7819	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7xfhDUd3shd8ABZvjid5aUWZn3JdaMCgizZVqBMywZzTpmmFN
49714	payment	1397	1397	1678	1	1	18110	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK44gMX7tDb4xuNLAx6Cy5EEcRAw1HH8zTcVai9EtvSkE59qCu
49715	payment	2134	2134	1874	1	1	8361	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtC5rWJJT5cg1HnYkcg3vDVX5C9dGD6Ps2G1BheZAtLotTCLoB
49716	payment	2133	2133	1874	1	1	7820	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ91cbJ9TrkyEkXWXUDkfqmKit3PkndUZ38SgAZ4ehAA2cQsgM2
49717	payment	2132	2132	1874	1	1	2126	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6tGkz9TLYHBZHqhMz3mrSTZKiK8tmT9ztcu9fzYXDQt7SGMs
49718	payment	2132	2132	1874	1	1	2127	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLsxXbJVC3PAqfBs5xbDa98zrHgyuXnzqnxP2JwmWtaiYi7Z3
49719	payment	2133	2133	1874	1	1	7821	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFECSfd9gYGAzawLrUQwnEfKxTeshsxAULytUAALiDvEaRf8JG
49736	payment	1397	1397	1678	1	1	18114	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjmNrJDkustHrzMm7cGsBjNxv7F81osBpXWC9QFEor5jo8e3BE
49737	payment	2134	2134	1874	1	1	8362	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9p7BSURRAriQmdpHbARsTCRMpGLBfjcitogv7e82VcxmUig5g
49738	payment	2132	2132	1874	1	1	2132	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDR6XLwuMhUY3gEWQ3iFiAmVhBUgKucpGy1EfDrgKrE8EJBtZ
49739	payment	2132	2132	1874	1	1	2133	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9EgRiwbRupbWkWMfrHket6eHw1hJir1oRtp7w15JrCcHysb8
49740	payment	2134	2134	1874	1	1	8363	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaa5PaUi6ygXShZYnHKwsQ8qKxkA4EN8gNiXbqUkSDkVG6Nw2t
49741	payment	2134	2134	1874	1	1	8364	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5MeGw54fXShTVFuurX3FGCA34QZCnM4RhL6oXyPMUg8yE7BAQ
49742	payment	2133	2133	1874	1	1	7831	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm3yqFQHWQsm5Kqe5wY9Cr6ndzXRYDfJv1wDQUykWYvPCkXcPx
49743	payment	2134	2134	1874	1	1	8365	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9JsEj5RsWMLYHjyGRrMp24jjmdfVZgmJApERzHFxGhfKxsqn2
49744	payment	2134	2134	1874	1	1	8366	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv2h4yZPVxRcDrKbqdHqW4s5G55QdzphEn4X9ZKYjTXMKZFQai
49745	payment	2134	2134	1874	1	1	8367	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ95AccnAtLcQCJdFXczwNgFWu9fur1kxNMyVrHxzrTzZLJGP5m
49746	payment	2134	2134	1874	1	1	8368	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeMHkzGHhnoxWQrdBn8GfWdi7Fch4vDDscAR6e6tQc7M1586AF
49747	payment	2134	2134	1874	1	1	8369	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVSTk4WaaQZBrmX2HkMmk3RTi7pcwdutKQ38PcPyT12hgCDk1N
49748	payment	2134	2134	1874	1	1	8370	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyryvojZa38LLhMbb5ujfbPhPJ9aadhRrAF4XypjkzsUZ7hsB7
49749	payment	2134	2134	1874	1	1	8371	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqnwrxxPNSNWuz9enYNrQquf8qJtk3n4nQhDweU3Xja625PzLT
49750	payment	2134	2134	1874	1	1	8372	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45KqjkgtEZy9qohTzjBiVEyLLBNwK29qy4zfswB8C29uSQRxA
49751	payment	2134	2134	1874	1	1	8373	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAdoooNF1DeJh3LQGGfhcFzwGj5rcNxE7mxQfRZ5F6WJDEVf51
49752	payment	2133	2133	1874	1	1	7832	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKARUYwZPQUQgELwksb4k6pTcwBzQxtLTEEFTazXybbgCqXCbU
49753	payment	2133	2133	1874	1	1	7833	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFRpEPJMGBU1SNW674eLfKCk7qvDpBxENmpPbn8pTj6SXpBme
49758	payment	1397	1397	1678	1	1	18116	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwpSmjMUXqsSfMProiNAPpJqbUm8F2QMdhY88y7QUoQu5BXLt2
49759	payment	2133	2133	1874	1	1	7836	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjLYEbse9BEFJMg2zCzqys1VKfWHm2gomorkzZfVAgG9uckDp
49760	payment	2132	2132	1874	1	1	2135	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ22BNvUMCLyFzLzg2nBVfD2Ustf1mpDFtJ9ybX9kJtVMYsvyPJ
49761	payment	2134	2134	1874	1	1	8374	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73f7GiYCdWDLJEwA49tNxsB4wcuYqdQPJmzfxoSUw9u8UKg4e
49762	payment	2133	2133	1874	1	1	7837	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZbk5uVpDaGNoQURvoeNH46cPqzP8bTo2XqB2sR2GTwgikzvS7
49763	payment	2133	2133	1874	1	1	7838	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLkSrbUhNcDVqhh5vPcYn8LJ6kmxWKQoJ1uyktGJUyHoQ6aUZW
49764	payment	2134	2134	1874	1	1	8375	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLUF7bqTb1ZMZqVjhEuppFoneFnCtLsvNhd1f4k5cr5k3AEhUa
49765	payment	2134	2134	1874	1	1	8376	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkXAzha77XiFpBPeaMfFVSa4DfKeHoGMFGa4VQ9FkQVpmSEbg
49766	payment	2134	2134	1874	1	1	8377	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmEktjAZ8p13ryxZDwaAFf6pLPhCfPr1hifzactD4vuxbNujk
49767	payment	2134	2134	1874	1	1	8378	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqYHQoJfu2c3pNie7KAvaSXMgy4qYCEaPUURayYP7zHd4kew8H
49797	payment	1397	1397	1678	1	1	18119	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTLnxGAtySHcWeyMPBCp9qVYRqFw9paTXY1QXZSeGAwQaRDoHx
49798	payment	2133	2133	1874	1	1	7847	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZanwL3fod1fiMw2n42BR6ga3aTdEhVdx8fbgcaBMiiMQmgbM2Q
49799	payment	2133	2133	1874	1	1	7848	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbyXpBdz3eXHBuvADs5L3hGcwGbqr53sjGAr7hSxXDQxQzQc8S
49800	payment	2133	2133	1874	1	1	7849	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZZo6nJfhkewDXG5L49WmB6k2C5EGp3BUq3HQEnwhB4KGuNMPU
49801	payment	2132	2132	1874	1	1	2141	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygsPtp5CbZma1TjvCLvEnDv55KnFgr45Z7Y3WH778DUi1mFL3
49802	payment	2134	2134	1874	1	1	8393	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHxS8vWtSmknDFDkVGBbKiDHm7whofn4WXa1MCwx5ZuResek5D
49803	payment	2134	2134	1874	1	1	8394	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRQDRXf2bjjoTKh6nb1nu7v9RcvvemcsVChNqUB6ombvu1AaaF
49804	payment	2134	2134	1874	1	1	8395	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAvFvQ1fSNoxn56o4ErTYVzbadETKDUgAtgthdR7R9fbdq4qq
49754	payment	1397	1397	1678	1	1	18115	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ1i7pUeewn9EDWqRtWvV3H4jXwuZRiY79H8eB7CyxLrtCcQaL
49755	payment	2132	2132	1874	1	1	2134	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnGqAK4pMYyzSGDWefyZJcEoNLarrSoDcv5YbiFhM628psge6
49756	payment	2133	2133	1874	1	1	7834	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpSjckBge9sXG9TQ83SSbGfnr9a1XMNUt6hXbatqfsWJeytLm
49757	payment	2133	2133	1874	1	1	7835	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVy1WjA24YwKLXcaGeumHAiRmV7ez2p51k1crZHackiFA8or7F
49768	payment	1397	1397	1678	1	1	18117	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZMWW4eJ2hxsMUHQNqTGWmbidv9cvGCtkLZrNoGmMEasTjELxZ
49769	payment	2132	2132	1874	1	1	2136	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTZTX7zLJzAahHhinWaM65rEi7mzgxXtHRVnbssSjEsd7K7VF3
49770	payment	2132	2132	1874	1	1	2137	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHCewbANzhPG6MEkvM7p9ppJL5N1dn79ZYq1Pm3Dhb38FV8fxx
49771	payment	2132	2132	1874	1	1	2138	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczPZeeDfgMLXEM2oumwYdL459njrb5Yq1EF8Eon4nfLCz673s
49772	payment	2134	2134	1874	1	1	8379	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEB7jdeRQ2ZPYxiMv6aDA8xe9r1zceFGhca7F64QmuXShtJDhY
49773	payment	2134	2134	1874	1	1	8380	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHxUy9xE2PhxQYd1NCA6HdT5BLgqFgqdKk1RwYmomf97Lv55WP
49774	payment	2134	2134	1874	1	1	8381	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYifuUQgAXMrLZfgyymoYUarvkyL2k8PNVMp1MXPq61NXgiavxH
49775	payment	2134	2134	1874	1	1	8382	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjerfbYT2FwdMviGABcx75pyyZBDbpa4Ys5Zh7YtdvZ4eWXzm2
49776	payment	2134	2134	1874	1	1	8383	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CW778TFArRtmCo6d1U8ud1Cbuc9KSE3AAqJv2NG4E5Gjtim7
49777	payment	2134	2134	1874	1	1	8384	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEBpCN2xFEv52ys5SUEaDvvHhiVVpC7MrGXLHCiYaawacySik7
49778	payment	2134	2134	1874	1	1	8385	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVEBhVmSBSGssEAvwuFrsR4LTRx8PS74YvWJQoGWA86SFasb89
49779	payment	2134	2134	1874	1	1	8386	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFrDpp1xNaB8HSDoKA2msLccnRSCshZV521KUostg6adKenohL
49780	payment	2134	2134	1874	1	1	8387	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwc3bCYqgPbqrkQPqzQQb2f6vw7W3QpW8Cj5BSBNvbAkHXcwVL
49781	payment	2133	2133	1874	1	1	7839	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpS7JGvDSS3FeSmz1aJKbwZCbCfCzVfbTB6qCj9g412bNa6HT
49782	payment	2133	2133	1874	1	1	7840	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3wXkcktgPdWKjuHWTreDsgXjMMohcDdhFfHFvLS6wAUen5NsE
49783	payment	2133	2133	1874	1	1	7841	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJWmshqLwzDMdB9ppPv2F2uhpFevnkWjibHnUGBnYfnPTfsKK2
49784	payment	2133	2133	1874	1	1	7842	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BMdvSg9Ds5ZPKVxdoipVwpcAGvAYHtmpMr8Zu2d8Hc5btpp4
49785	payment	2133	2133	1874	1	1	7843	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMuoCvA4cmVsVPnTXiDECXgF3A34LorXd52i3AHJMq29m55qB
49786	payment	2133	2133	1874	1	1	7844	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbezEiQ2GXUy83Aezp6EpkbrwdZTo5W4AKjXbu5DcjNJgv6UrG
49806	payment	238	238	2314	1	1	7	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYibPYp1oa1v9M1KXhKMdRsJs5YaLQjMw7CJzbssATugZhcSAg9
49807	payment	1397	1397	1678	1	1	18120	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6h4xBFr1BvLcHKTGSXKtozqFgqksP6Hmpz7cp3jWqzAkXg7Cg
49808	payment	2132	2132	1874	1	1	2142	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbX7ms4GutV8BGErRDGhGE5sdnAkLjPcoL9Mxb5JXN7kn2nexU
49809	payment	2134	2134	1874	1	1	8397	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp2AS9nCVtNVVpJ7MSWfKeQRy7YTv7dfSvBSCng9Qio3rNruSB
49810	payment	2134	2134	1874	1	1	8398	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbz67LyqpskxNS3yyXNG2bRQVL1yHJwyye57SPUn7C4N78RkUD
49811	payment	2134	2134	1874	1	1	8399	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3wrXL8Yeqp4tTCEWa3HKVjM1bVLv4Umw2PMwcoy5KRaf7WET
49812	payment	2134	2134	1874	1	1	8400	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7suEx3c1BoHmBS5SE2ayd1DoA5u1uSAV3Hdcx1jp5V8ceFoHh
49813	payment	2133	2133	1874	1	1	7850	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEXXvFZgJ4LytCWR5RYskozCgaUhpqnLWKW7x5zkF4jreyyNbT
49814	payment	2133	2133	1874	1	1	7851	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQstQU8gBacxuB4mC8UsyEtQ8RYB1FeVeRxzGrwopkZS4hgXWW
49815	payment	2132	2132	1874	1	1	2143	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKcVL1bQCGvmJnpTCd1i9WzNuzpsa2zNa786Noycyb11j6ve39
49816	payment	2134	2134	1874	1	1	8401	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXTh7Kn5uwkeY6irrRHZb6T3ZMuM18ub9RyQQfqZT6dGKk1tr2
49947	payment	1397	1397	1678	1	1	18131	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnPYZySRXkbeh2BA6c5qH72CrU8DdYhrZTh2tnkEAm1BgiAQJb
49948	payment	2133	2133	1874	1	1	7899	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmSXTCkyk1xCaqnjYEWczFK1Pk1hYXFB8maQnRk68kNkBtxWQ4
49949	payment	2132	2132	1874	1	1	2169	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDLdnip4xzR99pXNNo7HgELeqagUsb37EkVrhpaELt8YiER6su
49950	payment	2132	2132	1874	1	1	2170	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwjbsNXaWvWmgtt4DXPd1NZBqj7zAq5UDdDbAD4bQ7osx6nLv
49805	payment	2134	2134	1874	1	1	8396	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgvgj4xEH78KbsLkEmN5Qy29R6vcGD79GrqfnwkPng4xkguLbP
49826	payment	1397	1397	1678	1	1	18122	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYstQuyydVR7g1HCt6cTSzXygwz5NxUmekv6bA35zqCcX3VR8HJ
49827	payment	2132	2132	1874	1	1	2145	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDQiGcTTsuAq5BqU6wKKUZ3Hnb5CLZq7ieZbWiexFZSo5kjma
49828	payment	2132	2132	1874	1	1	2146	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc7pv5pTkJAR22nPJ5yX2B7rN95C9rVaWaU7uxjQVJMTXE5kij
49829	payment	2133	2133	1874	1	1	7855	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvohVLxYQoNF3AaQEcRcyozYsRpNw3gHH9jbegoTJKiyjYtPn
49830	payment	2134	2134	1874	1	1	8406	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAj1sLacFzfC3KGdWrghBxakWHhpRdKoqo5W4iFc2UenEcjzaR
49831	payment	2133	2133	1874	1	1	7856	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxspJjHTPsEBNUpWex11rzC3z9BPcSztdacZsAc829o3sgPAy
49843	payment	1397	1397	1678	1	1	18124	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFZnaPQJRt5EKVNvVMi1iTEaqz7KPUEY17L1Y1xXsnKXD5vwEp
49844	payment	2132	2132	1874	1	1	2148	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcHJxGibJ56uWYJe9uH69ooFvCKmqRiJGtnaqE898DqZzVxHvE
49845	payment	2133	2133	1874	1	1	7860	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeYqmbkNjNuZhEc4XzQMGwVyBs96BQWTaLA5P7hrRzuxWjgeE6
49846	payment	2133	2133	1874	1	1	7861	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmwfNDG6C8i7BBnWGNBu6Prn3W4GsN5AZaZgaeraSP54zwKH9
49847	payment	2133	2133	1874	1	1	7862	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx4i9tZ4qEeLWXxNnYge3D2V1hNdXKrrxZ6cwKvB34dcpwJDrv
49848	payment	2132	2132	1874	1	1	2149	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV8S8Xnjps4vLLGjMzKqmf7dF1mLZdptmNV8cKF63aZBh3LcuF
49917	payment	2134	2134	1874	1	1	8441	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhffMUr8dtie3HXKESRRPHygE8ZtRCryW1rBdxcdVB7eWP3nph
49918	payment	2134	2134	1874	1	1	8442	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeX35PVLqvhEYvRHniNaN3VFCe6TtvkNrKtZbab9jZvZBxrpWA
49919	payment	2132	2132	1874	1	1	2162	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXabNCmVdsR2Xgw7FNAcTmqV4WHQqta4hyu2fAnwYBu96tNQ2
49920	payment	2133	2133	1874	1	1	7885	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNEH4YkXFcMtZfp7PSFqWuzJ1LUu7LHUkaLtaLG4SeTsBKJ1PB
49921	payment	2133	2133	1874	1	1	7886	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLt8uNmwsRTaw8z25RRfurkqnmqK6VnDhn4eMfpwxzCxgNVut
49922	payment	2133	2133	1874	1	1	7887	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcPpSJjee9QDj8SyuXiXrDWbBYpUn8G1poHf1mXDQXXFfPvpwY
49923	payment	2134	2134	1874	1	1	8443	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcX1zENDJWVpsdKtLqYggLdPhnJZp5gWU3GsymW7qAs7vqQ6jZ
49924	payment	2134	2134	1874	1	1	8444	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ45z7Wv8eEWVRa3EtroGeqMpCbMyNy3i6t7KwF64u2QUF8k38c
49925	payment	2134	2134	1874	1	1	8445	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFzLSJPK9WqCMEw7HVNtTdhVsqZdP1zRm7ub379mTpfL61drBU
49958	payment	1397	1397	1678	1	1	18133	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3Cq8k99VBWvD3MKfEids6y8fCGHFx2F76F1Du9ScJe1ub6KAd
49959	payment	1397	1397	1678	1	1	18134	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3PQtujimUYgNxEAAkv5VixmoB2N4kPVW8p7Lc5MiK9pnChu1U
49960	payment	2132	2132	1874	1	1	2172	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdH28ipqt24ZFzjtFA2dd6oP8VWGqfwcRyU7jB8HkKXEaUKasx
49961	payment	2132	2132	1874	1	1	2173	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiFaucrPimLPihuHE2Ur2YbxxkQXap9xUS6FJSokdT9jHvLoZt
49962	payment	2132	2132	1874	1	1	2174	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiQki996Un7gpkSDRKTLA7Ymy5Z8WpBKriBrFx24EDSvRKx4pG
49963	payment	2133	2133	1874	1	1	7905	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTFEAcu2kiQUrtH4JMV7bo9NqQgwWZfz1CpJ4bi6tnCne89dRB
49964	payment	2133	2133	1874	1	1	7906	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAog5wMMcbXf2Q93ztqe8GnopBPdhgNNVQ8xYmvcFAJqZhd44F
49965	payment	2133	2133	1874	1	1	7907	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7b7HCQZtFw2sRetJBwhbsoeYk3JHxz94ykVUXgyUPeUHWHAZT
49966	payment	2133	2133	1874	1	1	7908	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVTrjnAUCJQ6N3Y7UH42T7XDc8z4JbyD1tTn5u6wKfBLqTcu4X
49967	payment	2134	2134	1874	1	1	8450	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbQZWbEduLfQPYweaGrbWjDfhARFMRog1t2Fnj8aio8JfSNn7
49968	payment	2134	2134	1874	1	1	8451	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZN9TkywLYqudjytNGArgpYrHA8qoAxrKvbMhcHMgjh4YdA6bL
49969	payment	2134	2134	1874	1	1	8452	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmPcczCxJfHz3UgWfGLTuf52JnMgzRTqp31NJJDtkbsMR7qjCv
49970	payment	2134	2134	1874	1	1	8453	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Uq7rLA1hbKnkki8D8vKtQqAa5fjotkvz1M2xj5FkNXKbhRaM
49971	payment	2134	2134	1874	1	1	8454	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3NWBKbhmaYFAcQWmMFHtzzEmMFSfV7eEmPaXBtSpf4VKwLTbU
49972	payment	2134	2134	1874	1	1	8455	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoNkWQ3zav98eFrcsMqfFFEpeqmGaf8jkiihXQidtiNEZQtcN5
49973	payment	2134	2134	1874	1	1	8456	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BszaefjppTLEVAerqq3yurZvNeT6XsY7fmf9gp7pkMLyZ1ZJ
49817	payment	1397	1397	1678	1	1	18121	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjQKEQovgDJZs76KjDSBPEvZ5FrtyPQRnTBjHAE18bLmjB3svh
49818	payment	2133	2133	1874	1	1	7852	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWx48W3xRCQ8bVswX6h8USNnhxCyDk5TjbS7Dd48cMvBytZ7Hs
49819	payment	2133	2133	1874	1	1	7853	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaESr2mr3xFiFYy2J6nELJhVa7CGrbmnZZXEBjHY96WC39s55j
49820	payment	2133	2133	1874	1	1	7854	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqDmVovEZ4Ee8Bp7XQQA8p7FYJq2SxR6eftuNpMQe1Vvodv1UY
49821	payment	2132	2132	1874	1	1	2144	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcUrmT54nFzjm5upZ5afe4sagRAZd79pzGzcW9Mu1zi6jpcdA
49822	payment	2134	2134	1874	1	1	8402	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMx4TVTWPD4NbFqQZAKjtP5gv9hqnHeyMsknB2yTneKuAy8bpg
49823	payment	2134	2134	1874	1	1	8403	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLmY4nnNsuzHVw8b9ESaPdZz6qFjsm69M2NdVKPSTqqumjPKiW
49824	payment	2134	2134	1874	1	1	8404	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHWnFUtDXLZUgPw8dzhGmNRJQsnLF6bQnyAEcN2mfRTx8vpDP2
49825	payment	2134	2134	1874	1	1	8405	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdjG9XKxxEYpAXcgaPWomYuYMd5UqxFcQXpUnZmmbCNNbMnwYG
49832	payment	1397	1397	1678	1	1	18123	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9KubwnSv3T9GLwfEZtx2oN7akuDYU3XmHSTaM8mxRJt648Pru
49833	payment	2132	2132	1874	1	1	2147	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuHFMZC1i8GYjr4fBcKWj1FBtNAisCtJNK7hTQRAqCkci9ASTb
49834	payment	2134	2134	1874	1	1	8407	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2h8YWSunYUV8JD68ro2x4hnEkj3ngjN5JtDy8JbD1Qf6iJq9r
49835	payment	2134	2134	1874	1	1	8408	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwFJYKLMwib2zn84MWF3e6mWW4a7UNBjXM4tK3FfXkK3rbvj7u
49836	payment	2134	2134	1874	1	1	8409	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXiLAHXSwob1pkr5FkMKSbmwPGS5wftGqzWgUg9z5i46zP9Dd5
49837	payment	2134	2134	1874	1	1	8410	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNBGwGaje9dqHj9NrYFX17ZZye8oGLo75waARg8PHRzT9DpYSk
49838	payment	2134	2134	1874	1	1	8411	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkuo3du1PMyY2hbMX1VxKdcjeB135jC4Q3wG5ykSnoW38PqLsm
49839	payment	2134	2134	1874	1	1	8412	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4JNiFX8JKFymdDnPH6U6XuU5PGtdG3V1BEWGUMSrAtM6m455H
49840	payment	2133	2133	1874	1	1	7857	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZveetdNoFUHYy3nxRNZEU7m1jSYHeTGa7q716AAq8N81LWp9ix
49841	payment	2133	2133	1874	1	1	7858	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEjFGBLxKGCUhAXugiLsqvhjALiG2zj2hsc7hrQBAeSoYLnWCa
49842	payment	2133	2133	1874	1	1	7859	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnT2hbnUUS6nKheyvR8d5PwbfggeBG5BWmr7p7PSqKWFYTcL5W
49849	payment	1397	1397	1678	1	1	18125	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrs7uAPWWm4cdYPvrpTw3fkFsAexTU12yLAoX14jdgKbPcnxT
49850	payment	2133	2133	1874	1	1	7863	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQLRX5aVwmJzwXX26zaB2ymb6VjyodL9AGSymawehqKLS9TSs
49851	payment	2132	2132	1874	1	1	2150	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj84jA85maxVdrVHcUSXjq4wruGw8EBnx8kdBMfiwzvTg81hus
49852	payment	2133	2133	1874	1	1	7864	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkW5ncK3QVgrn6ftS49VVW2uVq78yoZFZ9dZu2m6pky1ZcRFKF
49853	payment	2133	2133	1874	1	1	7865	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpYXsF5c191VToQdj9xRSBy7xLyMd6iK81fd8QF3NxG8dNX9FQ
49854	payment	1397	1397	1678	1	1	18126	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRJe1e48gPPCtZa7HSXPcfZE2xaqyySn3J7adTrzvZnSbVxgxQ
49855	payment	2132	2132	1874	1	1	2151	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT7yDKtfnf7gE2aFeT9A7oXjoumva7hSEsWoPhktZsc2oi6GhW
49856	payment	2132	2132	1874	1	1	2152	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbiAhYGWpUr6HWLYSxRKqksGTrGtCjrUzifiviud7TJJmJYGxX
49857	payment	2133	2133	1874	1	1	7866	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZccdMnWckcBW9tUH8UGWNz1mArTYRhUnF7F4ZxDSSCxeqzyzPS
49858	payment	2133	2133	1874	1	1	7867	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6vhS4HaFCe5urJ6Do9a88hiYPGnDu8G4QUvFpZJQEXcknd4EF
49867	payment	1397	1397	1678	1	1	18128	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAppBauSrvL9Qk7DLsTJER7qC5TGdiBdL7zpbdGkAkhh5i7gd
49868	payment	1397	1397	1678	1	1	18129	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpCia7go6eGVsLCU4gHnZzTYyR9nsyEk9y66e2BwsVq3yi1PM
49869	payment	2132	2132	1874	1	1	2154	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjeJXdUbm1MQeB6oVsui9W8aHrbfrbQkgR899eTTFbS2YuZ79Z
49870	payment	2132	2132	1874	1	1	2155	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ69sDXS71qvazeVb3mXJLcknnSv3wpwXPQod1Ei5f24MR9mD9E
49871	payment	2132	2132	1874	1	1	2156	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt1pSZCXjMEXDVyEGX5SXuQcWkvxEBuGHRRB7bjhbNtpifU6ux
49872	payment	2134	2134	1874	1	1	8416	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJP78CMtWJaqd7zwhHePJeNVL8zUpxAjdceN5xmhcsEEQa2d3o
49873	payment	2134	2134	1874	1	1	8417	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahk2sLz6YusTKanmSBkUfduRg3Q2gUxhN1f1EbackcZxrEU6b
49874	payment	2134	2134	1874	1	1	8418	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw38NxYex6qnUEUiyMZ8XR7UPq3SNNbawGE1nnFepe8mLQ2BDL
49859	payment	1397	1397	1678	1	1	18127	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSmzBqo7SSxKLLsK9M1t6CTuwxx3j6n68mk2W1gPmvnVEZTmx
49860	payment	2133	2133	1874	1	1	7868	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSPF544yRdrVUR6MjVUUZ8yzuXmDNR5PXr5F8zHtxTdb1ieir
49861	payment	2134	2134	1874	1	1	8413	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQNCPTecDMdYHeAC3VZhw7eh3jNTH3dKUuHqJjqDL8NFDMSsNu
49862	payment	2132	2132	1874	1	1	2153	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV2WoHq1uEaXdzeZDDwawa5BqW3feTQZefm7LzFYcTGzvA24Vz
49863	payment	2134	2134	1874	1	1	8414	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJBAqshEqkLMHwyKJjHHYR6AhdYFC86r5rRtRDs8fYpodD6t1
49864	payment	2133	2133	1874	1	1	7869	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvUJ6wSLFCjGU9AKVx187bYvggDhQooqNNc8jGHnfnoj6BRyVS
49865	payment	2133	2133	1874	1	1	7870	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTnBAHK4xiA8v3m9zjVgnJqSvnc3CNsKfSoJX1u7RwRKhtD29G
49866	payment	2134	2134	1874	1	1	8415	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDhbU5XvVuN5un4wPQppfMRQwBaebCmz2houYRUbsECgAYXc3h
49890	payment	1397	1397	1678	1	1	18130	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTqRzjZUhqWoaHoaqsXuBRSk8RpeHqM1YNcfJViixchfw6q7DA
49891	payment	2134	2134	1874	1	1	8428	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYX585xKPVN8RdVsvQ1UsoCnNnLniQon7aKYEwfcrYeYQVa7HU
49892	payment	2132	2132	1874	1	1	2157	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn7so9wNSxXrddgNgPNSGLdzQuu5iuSFqvjyL1tDBPKrMoPm8w
49893	payment	2132	2132	1874	1	1	2158	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8rUV78EGiDcijbDXbwDLCu3Z5E9jTtRSYnsD8fDjSmiT6pz6A
49894	payment	2132	2132	1874	1	1	2159	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZy45s4NStL6rkLomD3ftRfZFAFn2MeJfGLvtdDTGPWthBb4oN
49895	payment	2132	2132	1874	1	1	2160	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmngrqtL94pqEq3DZJS4K4miN6WwGSJGpPqb3uEK1Jz7xR6Gf9
49896	payment	2132	2132	1874	1	1	2161	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3weXfFy3ercmj8aJmSDeBcDkVYzbcawJYTzzKwg93NuF1kaox
49897	payment	2134	2134	1874	1	1	8429	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5VDsCaLX8AJnQnY4c7spzhe5Der9yBHBUx1yYrGhYinxDsidk
49898	payment	2134	2134	1874	1	1	8430	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoBKPfkHkUXCBWQ3Xzprz2dsJSCzfKQN1P7Yvg87P8ZXZi5Vyw
49899	payment	2134	2134	1874	1	1	8431	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo8cNKUrU1MrMB8AJwuxWA5fNoiqDfJ45wrisrhFMa1GQYjLed
49900	payment	2134	2134	1874	1	1	8432	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJZAZQjSG8tZJmKfnn5t623gAACTiEYKUSuVxWkfHzNfmsJ5gz
49901	payment	2134	2134	1874	1	1	8433	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3kTm6maBrTLyci58ZE7q998acNyt94hUCwtdrbV2B6jokycre
49902	payment	2134	2134	1874	1	1	8434	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwpaxw5pwVAvZ3GmsF65urYhfXCZJnAztTUEbFeNerqyq9vvb
49903	payment	2134	2134	1874	1	1	8435	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQKzjacfdzZ5HV1y4wxp5JcA17Md9caKRASKx2CSPHBZZDnE3
49904	payment	2134	2134	1874	1	1	8436	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LnLAzcqqbmbXF1noporndf3uitdGYghtdGq4gqiaY2teezrz
49905	payment	2134	2134	1874	1	1	8437	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLtgZXKgo3gEc6pfwmrunUTi8Xhaw2UrQL7zfm7fANgirNa1F
49906	payment	2134	2134	1874	1	1	8438	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnYxUDXsCdCx4iyWRVPtfZn85DasoH7pqaYCBRQGgGrXwoZcZe
49907	payment	2134	2134	1874	1	1	8439	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSYHcJSN4geVz8CDcwV9AL4Y7M1Fy71boHgwdp1mcK517nDdhj
49908	payment	2134	2134	1874	1	1	8440	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRMiXEP23Z73SBF4FUBbDX2jYgoJZTvD4r2jWCPGrCSRZbPbYA
49909	payment	2133	2133	1874	1	1	7877	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68f6wGAbFw6oJ4cVgXJEVhGeXYsXBCHGXpkfFifzZd7ph993F
49910	payment	2133	2133	1874	1	1	7878	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjPnZnTCKFhcFeM8XhogRVirnG4fSe7k5UZLopuxTPxiM9mZnH
49911	payment	2133	2133	1874	1	1	7879	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJFc3HtBCW33PErBApkzbP6KhLMoCwEq1BKiuPZjWkLbMKAtzV
49912	payment	2133	2133	1874	1	1	7880	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrNBsva7WQkM9zai2rjDviYvHKiRf94ZwY3uCW3ukmtshDgAoE
49913	payment	2133	2133	1874	1	1	7881	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7VTeqEDbHeNkaWDwEGaVnoQkCkjvW884w4cEiEXe59WGPo57
49914	payment	2133	2133	1874	1	1	7882	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9Ss9NyAWxzzbsxuxfhWFYabTxeNsRyBHYfjG4eddymgJZsSm
49915	payment	2133	2133	1874	1	1	7883	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDVXU3cyzAysBGbxLxzXfb3cFNisz6tSVzNwj8h1c39TmEyDTB
49916	payment	2133	2133	1874	1	1	7884	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ44cBbf16FSqkPb8CkiGP5YqN5MZbNL72HDRq9xmsiUXTrASU7
50023	payment	2134	2134	1874	1	1	8490	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS3grPPejxJhetLHaTEgPFgTmK31WxVubYwExoN8S5eLM5CRoS
50070	payment	1397	1397	1678	1	1	18142	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1uTG1pQzVdeD6rbygiKLzd5mpdS4L2zVBmgrfr6naTXeNpwG9
50071	payment	2132	2132	1874	1	1	2185	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1jxatfTagAr2rZWt84x6pUWUNUZ2XRk7x9GYyx9pqqaMiPir
49875	payment	2134	2134	1874	1	1	8419	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP9AZNB6SPdXrBuPDouoRF8Eh6HhmGzTinhjEtg5cc9CvZvZXp
49876	payment	2133	2133	1874	1	1	7871	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa73bMtf3CHKFzNLJhkcPFL2g3ddWbG75Y9hsWHtthFRiMkdQ9p
49877	payment	2133	2133	1874	1	1	7872	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfzCe8vnfBdy8QvWEh1YmDzRXDuymEiR9D6F24CavHiidssZr6
49878	payment	2133	2133	1874	1	1	7873	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7eVFyxjGKUHQKQknfsbTtYNxLmhiPtHny7iWA7rstfBuWEYa
49879	payment	2134	2134	1874	1	1	8420	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJXjCSyehBvJUCN8CvwwvUybVMHv47cmmAsJPeEyiRdpwdZkzX
49880	payment	2134	2134	1874	1	1	8421	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQJ4Cmp841DfxsQQJEJPMiFNHGcY1chzcHAdgLGgiRCWiXTa65
49881	payment	2134	2134	1874	1	1	8422	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGrGYYMSWG9gsukQxuoz27hqSYpJUwwxDjA5323itgrjLS9g19
49882	payment	2134	2134	1874	1	1	8423	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ96aKzm8ghekXHcT78CE6wRGdnv3ovqBcMS7QukVJkjm9gUfSc
49883	payment	2133	2133	1874	1	1	7874	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKDKqZRiyUJFqiQjhYe6mwfmK2DTsiC5qqNWQVHHDXb1GPAj3H
49884	payment	2133	2133	1874	1	1	7875	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf1cYYVKmwC8u72iiEhiKuZLJTWjsJdHwfJT9XjsDfJrwyZba6
49885	payment	2133	2133	1874	1	1	7876	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8BWtChhikuFmVHDJzr4vVvT1UrxiiBMGYdLSsAVhRtHNRNWHr
49886	payment	2134	2134	1874	1	1	8424	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHStvtN6AotVu29KanJL2xpxTEkmtdF2j8FFhrXyHGjgbLHMe
49887	payment	2134	2134	1874	1	1	8425	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTExyabDXF6fM83aRvErwJ2LVGVYqK8UBX8dt89tVcdJ4GCgv5
49888	payment	2134	2134	1874	1	1	8426	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwVz5MnZ3nEmNxJRhk4niTbirbFSgMPE4onUx2mT5k9ZQgVNRT
49889	payment	2134	2134	1874	1	1	8427	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsHDTJm9Vq1H4ZTTqK2ZCLiK5UUzoZQ64wabGvA8UCuktxdeV1
49926	payment	2132	2132	1874	1	1	2163	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU8Sb3x6akAJ95pfk19ekAf56r9a1JUvBrpr5dYUusPjB15WmK
49927	payment	2134	2134	1874	1	1	8446	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZr7HpS4fFrcJHahnqSHhsTFJRBhsgMPkkFfuM1JZNVzsdF1dM
49928	payment	2134	2134	1874	1	1	8447	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1u4QKwSX3uCpxsJbsqrGg8vGqvhqw3iA84wanhAYSdoJuNqnm
49929	payment	2134	2134	1874	1	1	8448	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWuHUjEG3172hAPFW4JJLQqdWXGmgXqUJKhivQR8rx3Wy7By3F
49930	payment	2134	2134	1874	1	1	8449	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUaeG1vBXwoGpY6w1uBD7zJYnfgpEKXPJFWijmStR6g8noENBY
49931	payment	2132	2132	1874	1	1	2164	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiGRuuTHexfYLNRPJyUru6LyokZiMSr1MtfPHHuUWKGi6CQC3U
49932	payment	2133	2133	1874	1	1	7888	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiVsigoksAoKGEPaBWEUXCZFfx5oz2HuF56cmnvrqNbwvNkiG7
49933	payment	2133	2133	1874	1	1	7889	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSeaE41hekFB7vRFRNTbbdLpKJS4SgidvgAu4gUbLZsM2TTpJ2
49934	payment	2133	2133	1874	1	1	7890	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeq1fmuVSmnwSVu2A7G3s49XtoHPY29QGNvDnWFTgxrJdekCri
49935	payment	2132	2132	1874	1	1	2165	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjiGp6PhfUAkiukGoXdYDvTga9nx2tzVsxRtFeWgqrtNTzbjG7
49936	payment	2132	2132	1874	1	1	2166	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuKFZ3nAL3SFrHXvQ3Cttbdo9ZmRxbmuijTtN4vzxAMascHzr1
49937	payment	2132	2132	1874	1	1	2167	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe5pWGNA8FW4wmqB81Deqrs98npx2CgXkuPDZGK5fR22sRufrx
49938	payment	2132	2132	1874	1	1	2168	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8KURbmsnzXc6EwMuvAbB5aJ1dfVYQNesmN69efL5kgp15gYRH
49939	payment	2133	2133	1874	1	1	7891	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSAhaTPo9iy9RVtVjeeKWV8kTmL1GFZjRQu9S59HkwR3TCVZS
49940	payment	2133	2133	1874	1	1	7892	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6K9XhwWj3QvN8Co7XtMj8G6aUwG9RM9Re6gVn5H5CrGCTTEBU
49941	payment	2133	2133	1874	1	1	7893	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFktMmLLrQN7nyHKQ2LfeWbzUqWF6wkJHmd1VRXqqtH47FMwVh
49942	payment	2133	2133	1874	1	1	7894	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdc2RgbpRgJ5EcAPoopxmEcb4KAQKsjhRM9AgwPD8D2xG35bNQ
49943	payment	2133	2133	1874	1	1	7895	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXv52cZnPpub1SNURZHSa1dQg3NsEitEydQvQTbLUM14nAu57
49944	payment	2133	2133	1874	1	1	7896	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwj4GRxSifzixyx6CrAQ11epQpXbcAva9k11SdF4TYinGYzSmn
49945	payment	2133	2133	1874	1	1	7897	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdPcHQWwFsrvsSRzr6tmSVBfGm4zV1d6pqeTNWCQEiefhQGTnJ
49946	payment	2133	2133	1874	1	1	7898	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs44dvPa61scK9QLCexoDsqcUA8wv6pFEpvS4SGNkdqjwqPNJN
49953	payment	1397	1397	1678	1	1	18132	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgtzrdMiFWQ9E17tGqPPkowmpBt898mbZCmzKwrjtLFwSoZbWM
49954	payment	2133	2133	1874	1	1	7902	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQGVErxCXMTB8earzHRgt4c5cADD5deNfijLtcpaxYgnEkxEdy
49951	payment	2133	2133	1874	1	1	7900	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg972GiAXYT1zAcsjNRL8Uu1jyFcnHq7UgfXdbDNpGb4xCisuR
49952	payment	2133	2133	1874	1	1	7901	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrF4wh3egizUjjSSuK2ErHMi96cqLbXS7tGp7rtbhzmgffpnhZ
50042	payment	1397	1397	1678	1	1	18139	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSV71TDGyY47xtYrGyv3xh1i5uVJ1xJCs99aVFzL5xC2y9Uz3q
50043	payment	2134	2134	1874	1	1	8499	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZwq2MynSUnfa11KVHXWwRyGDsCoisPjfRrxFWUiKWMNddsuQa
50044	payment	2134	2134	1874	1	1	8500	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJa8m7mcjkBMPdPnpSkEP6bRRktgK2sH2o1KcC3PVT9Aa9ZUs
50045	payment	2134	2134	1874	1	1	8501	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsAmEEwqSeXJMPFy4mX8QwKkwzKSjabmh5EKmmNymUXGFpuzeR
50046	payment	2134	2134	1874	1	1	8502	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWgbggycHiWvWmN4hBRVdZ8LWshYp4s5L6CBMG6Z9Ut6NXp3j8
50047	payment	2134	2134	1874	1	1	8503	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkcBHrMpoM7pyHMJ4uGfCKgUeezznSXj8uWxiCaqJxFqkUb8e5
50048	payment	2133	2133	1874	1	1	7921	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa68QcpPbpHAyvw6LXyVTbbjUEA7eh26EcsbpQR5XWokawJEcm9
50049	payment	2133	2133	1874	1	1	7922	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZjNJKVt8htScJXiW9uMWFyJMTmhvFAEA7enLdPAVocB2YBPg
50050	payment	2132	2132	1874	1	1	2181	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAZBoFV39P1947rBRbPkaEPpWxbtJEVD7y5doxGNcrd56FuV3R
50090	payment	1397	1397	1678	1	1	18144	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDfKAYYgNVTxd8EBVBhA2geBuxEBMGm92mQJQSUaFVJkPMECRr
50091	payment	1397	1397	1678	1	1	18145	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBDpsndrfyiaL6hq9j5UyphciTvf64CJmAhBfAg4t14AqHV4Kd
50092	payment	2133	2133	1874	1	1	7934	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZn14pM4Dz3z4aJMV6ufpTMryBqSELWTHLF9otUsYrVLHDaiN
50093	payment	2134	2134	1874	1	1	8522	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNm8KRvB2f1B7sPABddUgiWjvVMxqv1EcHCDpa8Qf5Bd2vsFU4
50094	payment	2134	2134	1874	1	1	8523	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoqeJxv4ctCgUxXFnbFpoZEBvEBHeMgiiBQjhBVc3THZoxprWj
50095	payment	2132	2132	1874	1	1	2188	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz25hBMss4b9p1WP1DbDfJDsSWdyixUHp1BZ86dJgPHbHxYi7z
50096	payment	2132	2132	1874	1	1	2189	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBDr5siqS2JZga4jvjz751scP3xYgDjYRbuPYJ3vgU8PoLbGtU
50097	payment	2132	2132	1874	1	1	2190	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZD52CypgzqXjucWdwa1YEk7KgjUdwMg7SxZE9rCUFhxg9feq
50098	payment	2134	2134	1874	1	1	8524	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa67GzizGSTB4hSNx7mJo3DBGvpuqqa9EMJNK4kxnv5pkcy7CBj
50099	payment	2134	2134	1874	1	1	8525	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfNc839xSXYGqw7EetW5c9MZU7Vjp2sYyytVu1woRrc3iM7vYC
50100	payment	2134	2134	1874	1	1	8526	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbtdDk41cPyPiqEBXqgHAZcE2ycEhT8TMRj4MJz6SJWp2Qa9jm
50101	payment	2134	2134	1874	1	1	8527	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjEv4ywTCCLHuG71oPLqr3fsf8NoLHUQ4Q5eE4MYKRaELpb8H
50102	payment	2134	2134	1874	1	1	8528	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvVqjJCkL2YNYHMFPmH4uzKRaLwsiYq6KNUhd5bqEoFPBRMz7
50103	payment	2134	2134	1874	1	1	8529	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaie78DwvSfDHKkMoi5NTCrTqTNeztyf1hgtoUBLe5kzFrL8GQ
50104	payment	2134	2134	1874	1	1	8530	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWwu5EMXEBfi6LbgvVSgREBUcxQbTTBAgjRoNwd8W8kgQZUSci
50105	payment	2133	2133	1874	1	1	7935	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDrfiTwBxRTRW4SXDgCbcpDHVtuQSAkfCkXvcRsFERq5sUabrb
50106	payment	2133	2133	1874	1	1	7936	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJhWQpFLbkr6A1pTfRUHrtEAeHkUzdRNGAzonq5Rf5fbhzP9z
50107	payment	2133	2133	1874	1	1	7937	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiTE8fo4m78tu3wvxtAnMLxnGyZEEDg5nGt21RQMr4pBmSB3x
50108	payment	2133	2133	1874	1	1	7938	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF38ctFD34qgtdVZSNiYA4akwFvFAFZpBDXg5KBiAxNQnaNY6B
50148	payment	1397	1397	1678	1	1	18150	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9hMxgSK8ZPAdvKe6aZvkNWrfJPh7tgr4oSrpGTRh8yQJp1Lm4
50149	payment	2132	2132	1874	1	1	2197	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZquxgU1NnegmVjKsEGSERJpw6ymvFyKQwdiCSCuou5PF8vDEeg
50150	payment	2132	2132	1874	1	1	2198	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4K5ufhYs4dCPMf4KZfNVwesxWzb54TvMk5VzftXCvxCmeDfK
50151	payment	2134	2134	1874	1	1	8549	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHEx7WAMpLo3bGPNZYhmy5rwXUPpp4KBd9hB3zsB7DgpYtVAMM
50152	payment	2134	2134	1874	1	1	8550	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAMP2PosaZ48oKBztyK7LPkGMURJTSjoPnKG6rGrnn4MLYiu3
50153	payment	2134	2134	1874	1	1	8551	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYukPrV32VmoaxRGboSw9eWd1daiMumxVkdpXnz72JNbnBeawjJ
50154	payment	2134	2134	1874	1	1	8552	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpUsK3gYW9kFA9qjvXyA78wwxA4cSeCxkRYzvLPMrBY2Ypm8xT
50187	payment	1397	1397	1678	1	1	18154	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAT2WruomSVHgGkeREbkgPQuN7R1GRYtmy2JwwvwZpRwcpjLg
49955	payment	2132	2132	1874	1	1	2171	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzrho7gXpbSnqNMwX1ryBRmDBeAFKWV84Pyy3ubooDqDshPs1
49956	payment	2133	2133	1874	1	1	7903	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiw7GpD6DjtXzYK8BCLKQjBGjdoPyWmkraWxD9oMTxkm6A16uq
49957	payment	2133	2133	1874	1	1	7904	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvzHwxqxeWgDtimAMoLgibu248kbZSYEDQoRz9nBdDR5UErHPL
50080	payment	1397	1397	1678	1	1	18143	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhLf92QJWdKtpbCTw8XkRoTDb1XB8jpwUGhFHYFRotzAhp7KB
50081	payment	2133	2133	1874	1	1	7931	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbW1Ye4DGpA8eswf4dxxjpecEY4vBpqrHk4D8iEaCPaJBBtQDe
50082	payment	2133	2133	1874	1	1	7932	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuWDh1CwnxfkeXrNMmeMKpTCFUjaua2C9YGrXWqXTqxqqRt378
50083	payment	2133	2133	1874	1	1	7933	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEYN8a6cpdWK6TaF5eq5beX4xbZMLNburdF415xY9af9bH7Qfw
50084	payment	2134	2134	1874	1	1	8517	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVQZvqyHJAwK7reThCmm3Fd6ERNYefttSxQmQAHVogVxRd6xge
50085	payment	2134	2134	1874	1	1	8518	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHvid7XydA2BUoHWoqhuTurJDCQcMuxjQNqbbtZ1GAWNrtEgkY
50086	payment	2134	2134	1874	1	1	8519	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwYgXMiVe51mb2c6UU97BR6vgq1qB8yPEv6Uf7gdzSXQa9t1HA
50087	payment	2134	2134	1874	1	1	8520	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYebDriEZTHkKGq7aqxSyFuvn1Ln4QoR2C2theny1aeU97NYFxT
50088	payment	2132	2132	1874	1	1	2187	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwQkM35A1UQaxHFPb3PVi1bD2ZNdgbLqFDNjFaygTuQ164z3kq
50089	payment	2134	2134	1874	1	1	8521	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyrgeWizEZvGgaePR34y4LTqhe6ZDtksnPmSM5jojwcgKyALcR
50246	payment	1397	1397	1678	1	1	18160	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzUxhNRKiQPHhq9RUkfaZVyTDi3ZbxLCqVPMxr1qQLv5WAHPyg
50247	payment	2133	2133	1874	1	1	7977	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzJnSs38wL5BbZtXU968FcT8SGrsJfujKoyyZw2ehUVGAG5TMz
50248	payment	2133	2133	1874	1	1	7978	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVa1HMmhwGotATXd526NuLsVW1KzEgiKnLPNQxd8c2wAcTd1oV
50249	payment	2134	2134	1874	1	1	8593	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkaT6auZUty4iTeeZajV5u4X43HuirEDJRgdreDte4SMXXugBs
50250	payment	2134	2134	1874	1	1	8594	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAwkuQzThWxzv4HgjGadM8EdcHNJbCfhsnuHBNPwsPVrpKzLEe
50251	payment	2134	2134	1874	1	1	8595	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYchPGEfDudxBtUikEFExdtqcj4mxdoGHE4zBbP3QY2ZfYKKchv
50252	payment	2134	2134	1874	1	1	8596	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKUVupXzghxEZ3FTxCzUZtcEdKWcAudazebk4KoPm4XDzFG53
50253	payment	2132	2132	1874	1	1	2212	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBcBkggdmMjkGJaZNoziKwcv92VVus3hcTiQD1JSsH1ne38ss2
50254	payment	2133	2133	1874	1	1	7979	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLde1CrytZjZmwRQSVCjn7zBmtPgKsYBZu6jjMykT3H8T4tFff
50286	payment	1397	1397	1678	1	1	18164	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGpXULiXfVxKCYMuWvNEsf3mUXapVdQ9snk7xcSnKJN1KGQgmf
50287	payment	2134	2134	1874	1	1	8611	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWkfdUeRZnogWbuGtwzurnxC3ZcqfpFrfZe6PMHdJuzHQta8MQ
50288	payment	2133	2133	1874	1	1	7986	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZepvbRuyH3B7RNWECbB5zft84k9CEhRcRFMg51jpEh83csSxCt
50289	payment	2134	2134	1874	1	1	8612	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkvrUahg2mUsgdHFtHGZRMEY4DzbryX3N6zt8ZdcJa5p539bnn
50290	payment	2134	2134	1874	1	1	8613	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ85GSocHp6WHHYPduqQ5rAtUprW6XFTLY3P4Snn5HTrbTxxFgP
50291	payment	2134	2134	1874	1	1	8614	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqvqLcvf5RDUbmReFfr6mnhPEzr8JmHkaWkmBnmdAJBJ3ti8dr
50292	payment	2132	2132	1874	1	1	2218	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3n6Aet3RhDY3ZQ1MzSsikYVTFccj4kUXLjtkSsXtnCiksjoCU
50293	payment	2133	2133	1874	1	1	7987	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMxUjHBntwXcrqUsV4aJYizyefg5Bo92Umn5UrUWvoqCdDsbA
50294	payment	2133	2133	1874	1	1	7988	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDCB6mHDHSVhhToXTu9iy2ZkEoPbz3CCWC5RWNuR1fp67PZeS
50295	payment	1397	1397	1678	1	1	18165	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDLgCx3sNAg63uiHGZZAmscBuqWHVCqXdpqmAiH7B7bniTM43
50296	payment	2132	2132	1874	1	1	2219	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU647ZCG3X8eTqNXzwYSC3fevEoFL2Wbuh5KpKs64tFco9EJMg
50297	payment	2133	2133	1874	1	1	7989	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHbfGB5ofvGsXRqYrVj9qQWEgit7gabLtVtdvSzZDsTC6PLd7s
50298	payment	2133	2133	1874	1	1	7990	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdLSk5VLaFQfRR6HEzRux1zLuAduPzxe7RxLm58nYQaUX1sxXf
50299	payment	2418	2418	2418	1	1	2	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZogzrGnbvFsCs9TNMJv93hdrwJLk3dsp5HMYyiR3GLQmj2BXU5
50300	payment	2132	2132	1874	1	1	2220	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpHYW9juTisnCDJgmieSCrWEtBioeaEYwo41F98E5hmh6kcPJi
50301	payment	2134	2134	1874	1	1	8615	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8xUNYKEmcGXR3LNDu5u3acCNbvXdccVjXeetc2fWfthb6v69d
49974	payment	2134	2134	1874	1	1	8457	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuKRf1R3kCdfSHb12NLBXo6kkUUqDsqcQUfJDSxxQjHuWERgZL
49975	payment	2134	2134	1874	1	1	8458	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvrr9QCDovwxnADP9bF7S5ySkxVbF4KpvtXLfUrAphayS2oQFE
49976	payment	2134	2134	1874	1	1	8459	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZhFWs5h8Pj8n1UcGuk65y85ZuvJPEBgXE99Txb1H5btVCgaV
49977	payment	2134	2134	1874	1	1	8460	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUPiDHErymTF2865XXrZseM8LxWGYwHokobsRx6jdAG5zTrPug
49978	payment	2134	2134	1874	1	1	8461	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhSj3JaLc9rtx1rrYVqG2ieNaFUfVoiD2U3aZ7m9sksvxwMnjJ
49979	payment	2134	2134	1874	1	1	8462	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9knWt4MBqBCxsxGccngCC2YYN13Cu5c9sJi6euWtPn12tj7Cv
49980	payment	2134	2134	1874	1	1	8463	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3badSCxKNqa15GbRckqrf1QuxKLFxQMEuvwCc8NiGXs7so6Ak
49981	payment	2134	2134	1874	1	1	8464	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBVGhm7zFLwhFGZtwQqwi2Y58YyCKEF5PvNERXA2hMfqUngNbi
49982	payment	2134	2134	1874	1	1	8465	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmrno5Vkez6r5P1hJXtBVQmcGjtNn7qhpiz5YMrm4JDVYd4qs
49983	payment	2134	2134	1874	1	1	8466	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJdnL9bXXH5Gc8WoNj1RuH2cg5k6EkyrQtBrnwjqz2SbR25n6
49984	payment	2134	2134	1874	1	1	8467	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaeLZYfCRgoDqqo4UpieFTmGEehXkewXaLG3Fh4fzuHqbE81EJ
49985	payment	2134	2134	1874	1	1	8468	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqLkMBq21L1w1KmnW28ytZPyGTT4pQaMmc9LH419MrtC8hBQ2U
49986	payment	2133	2133	1874	1	1	7909	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaETnsmF5kUeDue6YojRKaLgizrnE7NzQLjv8idQZ8AMPytYGZW
49987	payment	2134	2134	1874	1	1	8469	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZ91mrQ1osmCjPTjXvo26M3ou3fytsc8JpZgvKjWWLRcWCkLQ
49988	payment	2134	2134	1874	1	1	8470	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWTJBEzgJNJNXrZ7LFG5twAso9Bz9HjBX2uJuaAD7bjWTMLDYq
49989	payment	2134	2134	1874	1	1	8471	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr4S7u1dHhdz9uD4FzhP5366x3y38PEqQHbTbANGwXcZ7rjzmT
49990	payment	2134	2134	1874	1	1	8472	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt42xMemvaDn574NwTQK7YPxRz3YZZnebfZtDzukbgjuKohoqj
49991	payment	2134	2134	1874	1	1	8473	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc8DAqzg8n65Zt3ERYYE1k4owuQdeLtyAZjVSo9P95awtCYcZ7
49992	payment	2134	2134	1874	1	1	8474	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeSCpWTofxfrhMmpofpA3KHKsS59b9ZhSatWJYjaQatREk1HVh
49993	payment	2134	2134	1874	1	1	8475	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WLHEL22KShht15SCGpW7B9Nc2azno7eSpr1BhtNKyZCyShgc
49994	payment	2134	2134	1874	1	1	8476	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg5ZsdfdKxL8PgFFi7haCUjtqVTFQrLW49pzM4vdi59iDS8rQH
49995	payment	2134	2134	1874	1	1	8477	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfFjuCMmh9nSFjBCPmgR31tznoReHK1eUwv22MD7vFFNzdzpAK
49996	payment	2134	2134	1874	1	1	8478	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9MgXUXWQpEHoTgU5XAWayXaJGajFsoQd7b2j66kr1R1PPbNp
49997	payment	2134	2134	1874	1	1	8479	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWRpR9YKmGx8pd7bT2M74ANdKVydCV1Q8JLjv9PvmE2Ai3swxa
49998	payment	2134	2134	1874	1	1	8480	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjzPGteWKjx8vah99376ZKXnZv8xbdom2eMDXn2uDs9cBMG6r
49999	payment	2134	2134	1874	1	1	8481	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbNeajDJf4gvsVQQYWDWmWYcyYjKBFHFUUHtCEdF3gsG2qweet
50000	payment	1397	1397	1678	1	1	18135	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa28DWH3XTF13HZZ2r6dBG5AkVi7N4dKUcjueQB3cecafCw4qy
50001	payment	2134	2134	1874	1	1	8482	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMPE7EnbCCAVmimPt5bB5jm6ouuiWU8WxbNJxzipto7v4sgaN
50002	payment	2134	2134	1874	1	1	8483	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa9Ed1eNqoqtyWPsrAtGTPThuCjMFtpS9mHgM6XxuRYHbgBzAz
50003	payment	2134	2134	1874	1	1	8484	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc3rHMM5x1CVEtmeAHsMBTiXdw1h2wP381KzNDv6HGkjUQni7N
50004	payment	2134	2134	1874	1	1	8485	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGPtmbJgbJPS4qPYLicyMk4vYRW72q3N2GDTsxaQouk6ygPmq
50005	payment	2132	2132	1874	1	1	2175	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbUoXc3xVgJ2v6ns16vGguLBD592cynMkGz1J4HJvyDtpcSndF
50006	payment	2133	2133	1874	1	1	7910	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3WZbBbneu9kXdf4Hzxb9cqTCE4jqYvBg7kcRUxzaChZtDVEE
50007	payment	2133	2133	1874	1	1	7911	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbgC6FjZRKf38KxjSQRMhQVb3d6JXGhBVSP7GfQzvCMnW3gsKG
50008	payment	2133	2133	1874	1	1	7912	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKZyy1shyNbyY3QQ71VH4F82VMBVKJJgPxGCqdPiAwFrefyN5J
50009	payment	10	10	2314	1	1	3	43000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYddNJCxqBTgATRqrgRxqFbVX6r8hGpEqvxFtqi4wPNSUnR7jPZ
50010	payment	301	301	2314	1	1	4	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYndQpc8tB7woFB2AiZT6Q2rV63gssFQWLRGHWbiGx8oXnzkGZ2
50011	payment	283	283	2314	1	1	3	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcLTNaYUqRwppKM3Dt1NJvME9eKKMswK6yCNEgdz85NXtJma3v
50012	payment	1397	1397	1678	1	1	18136	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmHqQ7rW862jVB1APm8Gs4MSDx1AVz2vQ3TnTv7dMKT5wL6LZS
50013	payment	114	114	2314	1	1	13	86000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGm81qfREjXbM6qzdj6xka8vDBQvPA6ZNtbcaLvVazHSqHMacq
50014	payment	2134	2134	1874	1	1	8486	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYGXikTFsQZE7cMTSx4ah6518yXNRZymci7sr7xcfrxDivUJBt
50015	payment	2134	2134	1874	1	1	8487	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUxk4yYSJoagyDLHdHnfyraJez2deH7mkPHyChDADpeT2fY13m
50016	payment	2133	2133	1874	1	1	7913	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcYfEmvP1cyxcSRdUEgM58iWEpH3ZjBHTBcusuQYFLFUDdFb5z
50017	payment	2133	2133	1874	1	1	7914	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2w6GB1fVij5mLFs4YhvggVp7JKNZxeiEbucJAnnyDNT3FkQuD
50018	payment	2133	2133	1874	1	1	7915	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYozJ6T2b1agkWvZ4utsCowyVqo2Xk3SM8NQ5hyN62Hwfex2ggB
50019	payment	2132	2132	1874	1	1	2176	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nNjxaT4SGGcuJSySdrG1fKTakdvzgiL3YLCC3GHR9AFCjC98
50020	payment	2134	2134	1874	1	1	8488	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FVsN1FSisWvpQw4m2wXFzAvdc9x7Rpjoe3HXG9abY1jAYpXU
50021	payment	2134	2134	1874	1	1	8489	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv8KdDvcan95JnDVoPh9kwoc2VEfiEHHYgdzcXap6KCEd5xG3V
50022	payment	2132	2132	1874	1	1	2177	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG7cEa92YViAUHsWX1F2eKZzCqA2SEB2ktZ52DMZk19sPg5ybN
50024	payment	1397	1397	1678	1	1	18137	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbraTgcUhGwGA9qyWxenCYSmvGpZMvZgNL3iVwM1LwJoAnytVg
50025	payment	1397	1397	1678	1	1	18138	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmSSw8k26s8aNT6Kak3oAmJVWpehe5rdd3j9AuCDv4icLxfCbr
50026	payment	2132	2132	1874	1	1	2178	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxn4bnC75QrvkB2NLi3aqCa2DYqZEYJYwLRNu8bRLKJVeCYnDy
50027	payment	2132	2132	1874	1	1	2179	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU84WapNEZyF6dom1mXxF7snRwq9SFcShhsCMCbppxJb4mRGDU
50028	payment	2132	2132	1874	1	1	2180	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxt3aspDEJdpvRMEb2monsJmPKbDqAZ7CZFsTb6Jkv3T29jyCZ
50029	payment	2134	2134	1874	1	1	8491	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYcAwMZysYHK1CK8DsmRwHrHcpgfjMFWoYDDXxEKyeBHAPn4Sp
50030	payment	2134	2134	1874	1	1	8492	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSPeNSibf7ioqEfNZZaEWzSf1dAEUH56fnbQobKCfQvBfsy9nP
50031	payment	2133	2133	1874	1	1	7916	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoPFBz9ov5QrL6JK5VXRgMeS2KDC9VwSP5ymkBpSb4vHvUYrqw
50032	payment	2133	2133	1874	1	1	7917	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYftCBdZL14d3a8UGx6smjwER7YmYJtzZwLyjbUzd96N5XDuGiY
50033	payment	2134	2134	1874	1	1	8493	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa34RuCBpQohafppYJiBizekCHEvPbTcdjW43WgusjfZDrc2fgY
50034	payment	2134	2134	1874	1	1	8494	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX7WzMcGMa2ft8ePJad2j5GMTFswksncTouGuHstGf1YXBUMvw
50035	payment	2134	2134	1874	1	1	8495	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAyH4tPwsESzXApGjqbX2ssSChok2M1sr4KjQAjYAmzkH7v27N
50036	payment	2134	2134	1874	1	1	8496	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTtEVq1Ufx1gR35t5epd3kVe2RHayzWAfadhfv4QHp2LGxcvNe
50037	payment	2134	2134	1874	1	1	8497	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdQ6fCHajsEbMM6w3R21ggL1BiZKF42uNgfbCZB7upaiyK7Jh1
50038	payment	2134	2134	1874	1	1	8498	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6AjnontKXRa5ExUTSr21t6v9679tyQnFjEbX82G1Znc6VcEmd
50039	payment	2133	2133	1874	1	1	7918	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2PYynrXvgEzBHXFoY6V1MW2ytohRYqFUXi4rMxUF8AYBphTP
50040	payment	2133	2133	1874	1	1	7919	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTBhDRF9maYkqeTEtGTegYxB3dCGQvUVuhUDgcJiMpKVthDHpr
50041	payment	2133	2133	1874	1	1	7920	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNxNMF5u8j1iNXknoCgGjQgqLPxpz176ZruYjxKaN8pwNpr3Z
50051	payment	1397	1397	1678	1	1	18140	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVjxQwkHMGHy6tnTuyva1L5GXH5gN9M8NWCgombqvsijft6f4F
50052	payment	2133	2133	1874	1	1	7923	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCrWwYgfZpdznZmGM8mMpbvSb5tu53pZxfUQVvccTmdoyVwNFP
50053	payment	2133	2133	1874	1	1	7924	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQSyd2FaRyZQmoojtU21oAeNAAnceiwj2b3YyfT7dzZ2jwiGYe
50054	payment	2133	2133	1874	1	1	7925	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrxHgzLAQSWtcrUp1boeKMkXPBDQw2h6iRjiWkHJ8zfR3GhWcc
50055	payment	2132	2132	1874	1	1	2182	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo9N9WZV5uk8Q5vVgHiahdyGMzkcfzcPnGDYus8HdMS5jGSegj
50056	payment	2132	2132	1874	1	1	2183	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6D8kSEMxqnWRsSgmgiCMqwg2zuwMZRPNMYeY6g1JHra1ukYKP
50057	payment	2134	2134	1874	1	1	8504	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2jypH5Ev5Bk8HKjmHDZvptGEP7YJFx7qf7HMPW3ZQyyC6sSur
50058	payment	2134	2134	1874	1	1	8505	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4g2wM9N9uSh2Z7sUFL6nvCqc1BN6MLLtzjzCQ62hwrxfACFiV
50059	payment	2134	2134	1874	1	1	8506	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVH3YgNUnCtQ7oUPFgxqjXjPjmicjrQZ3bjjQrQN7fru7XVCK8
50060	payment	2134	2134	1874	1	1	8507	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb38VaJaCGKrFy2s2r1C9bbii5FyUeMR6Ptp5cw6mxahyAzkUt
50061	payment	1397	1397	1678	1	1	18141	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnas4sz8yYKzBmpW1tRigAbcFScsJev357rqrwxKbHzz82KPE
50062	payment	2133	2133	1874	1	1	7926	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUqf1MFUq5oYK9kJNhramRqtdGNEbL1QRkTg6Zygz77omdzd4x
50063	payment	2134	2134	1874	1	1	8508	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu4ZWzJJmAjrvjfWxCrx81JJ1dd7vuiCtFU717QB9fSgnMtG4g
50064	payment	2133	2133	1874	1	1	7927	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLrFc43RAo8wCs8ASGHDzkRLL9PsQgv4LvYVG1dCwby3qMBAt
50065	payment	2132	2132	1874	1	1	2184	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSEqF7Ruc39qsWo3NY9BeShcr3ie2np2hFvbEJqskNc9utGojy
50066	payment	2134	2134	1874	1	1	8509	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvdXj4hs3AJPgTWquuSXyxJk7XRAqfPmQ9twkPy26dub8kgrz
50067	payment	2134	2134	1874	1	1	8510	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVocHAX2mXqjy1p6QgDFvzBPoqd66LMD36H1UqSb3YA5oRDqqG
50068	payment	2134	2134	1874	1	1	8511	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9yqLp1Zv9t5t5AcTvupHfFBn8QeEroz5qrYUu4nHpswHZBAfJ
50069	payment	2134	2134	1874	1	1	8512	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6hxEkhwkduvvK9oVDAKfrrCH2PhyZFYXwWRTsmsiPTJfxENQf
50118	payment	2314	2314	1950	1	1	5	387000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE1uQwAqvMvFih5gMqqr9ewHAw1j8cTeJz9Ax6KvXjhQoPPBU8
50119	payment	1397	1397	1678	1	1	18147	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEjdeV521ZEtsEqzWVpAqNkTb5S1vPPML5X9UF7JkQ48y9rAa
50120	payment	2133	2133	1874	1	1	7941	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgj7MoGb3B685ZKNiPVFuLRmh1ZsHTC2k22UHQ7KS9Zc7UXP2r
50121	payment	2133	2133	1874	1	1	7942	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3isyiFFnHCyE6cJUekEGKMVrKgcCqymD4CdL5jWw8fCqaqAdS
50122	payment	2132	2132	1874	1	1	2193	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQhGrYFT53jdUudJcef1A5qRByhkhxDUD3StgyBeY6AXeM2rU2
50123	payment	2134	2134	1874	1	1	8535	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sZSHAt27ZtiDkdwU7F7yyKDeVibHeo8D6GGGhJyvwtZEpYNn
50124	payment	2134	2134	1874	1	1	8536	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnB6ahmdG9ToLnEHnzvQbKVDqhWuoEVcRxRNHXGjUMkG8ZY1aK
50125	payment	2134	2134	1874	1	1	8537	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRWagec6wH7npYvUs54PXq3mD7tB8T875TUy2X4AGWsup8Bivo
50126	payment	2134	2134	1874	1	1	8538	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhCRppuoweAyFpjCbqEqrqb2PCdiWJ1J8LTgfBG27iJT88VYHY
50127	payment	2134	2134	1874	1	1	8539	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoWnU2i8tES3Nr4EMaNHHxuipWVTsNiDFCS29CSBhYivgmVQFz
50158	payment	689	689	1876	1	1	0	1500000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhWhwg6eGULSE9wSUPqNje6nxjzEh2hYggMDBdpADPevXYccSa
50159	payment	1397	1397	1678	1	1	18151	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6YeLKcGdpjXzzJ4bWikh7xtWtQyMbWXtBHYsfRA2RtVxeNz5
50160	payment	1397	1397	1678	1	1	18152	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbQKEyYHYomRWkJUcPzuthgZeupMzsbMzdvaiboV372hELjXGC
50161	payment	2132	2132	1874	1	1	2199	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcvtscUEttVnBqmJg2SutfeqrKFVMCcPMK7uMcoNHChYf4wrs
50162	payment	2134	2134	1874	1	1	8553	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkj7VKTjhL1X4SFoRze1vhtp8uWx89dtYvkfJQoq5Pi7KUzJFu
50163	payment	2134	2134	1874	1	1	8554	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMDT7NLpubnsbvRgR7BJN2CQLTx73CeYc47dGZsPqptpNVrvT6
50164	payment	2134	2134	1874	1	1	8555	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeuanswCD3kBJ2bcwZ1g8NW15QuSKHerSRq7GoQvrDyTJYucSZ
50165	payment	2134	2134	1874	1	1	8556	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL23zg3r8rCMkh7wcpod2QiHMuqYPTecW35DjQ9VfaAZgnJ26R
50166	payment	2132	2132	1874	1	1	2200	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9rqScY8ZPwQ4WpcDndornHrJj5iPrY5tyM6PtbV4WHLr3Fv3H
50167	payment	2134	2134	1874	1	1	8557	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfWHo936XvFJKrt9dmY5jTaQW99jPZVQxA81PWJxA8TT4koW7
50168	payment	2134	2134	1874	1	1	8558	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiEXZYgEMK1dL4i3i18erAbZequXHZqBRDYv7weNrAdMJXpdBE
50169	payment	2134	2134	1874	1	1	8559	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWw8EZUdUzBgW5sQn4aJSBpoG7eAtGk2qV8KGaN6bLxjDSZ6Qn
50170	payment	2134	2134	1874	1	1	8560	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU269HmLYxaCGYL9WAs8NjKe8MUU2qEyUajKDSjSLYL8cRybea
50171	payment	2134	2134	1874	1	1	8561	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZouyvRDZ7ZoJEc5rto4qfThcsRvQMeGLqTTFnuCwtNrUBKwRMo
50172	payment	2133	2133	1874	1	1	7952	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJsm9LHd4kvqoFnRWNEDQX9i3dUGp4n3Siy91SDM7ox1nHAAta
50173	payment	2133	2133	1874	1	1	7953	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwfAKiRWJ7CFeR8ZGFQ395A1AzYcgqboWT1eZaUHe5Nj7V7R6M
50174	payment	2133	2133	1874	1	1	7954	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuvbxf2a663QwVa1zMro69w5x26gWBkcxwak2LqyzKCVubEA27
50175	payment	2133	2133	1874	1	1	7955	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1PkkbwzvrgTTLnmHxTGLxWwzLJQAgQvZ7K9ufUn4eHh49PQd4
50072	payment	2134	2134	1874	1	1	8513	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUEyNR2jSMo2GksEGowyp74p5PerFD6GLiGusMToXmnaNqeQNN
50073	payment	2133	2133	1874	1	1	7928	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUewSn5LUrW9vhQJbEk9uzy4SzEveiyRikmTVXMRxefW2v3Hmp
50074	payment	2133	2133	1874	1	1	7929	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBaGmcjQfu9R4BwG5ceKmP83vhTAQyS2ucUaaF2KGyMb4n8RBZ
50075	payment	2133	2133	1874	1	1	7930	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ325M9ysevcq4RGevoLr3cLzxmHiWZXY3JT3ses3ytgvcC2VR6
50076	payment	2132	2132	1874	1	1	2186	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrqpNE2N8bCLU91NB4tcNJDR8T8c7WRfYybeFgE5auwAqkGJK
50077	payment	2134	2134	1874	1	1	8514	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs1ptyGKzPrcc9Mqzt93R8H6VzezbKUW8aoohhRQUD6j5wEnWp
50078	payment	2134	2134	1874	1	1	8515	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSCRoX4QhQ9j6G2bNS3MNMBfZ8eZAwi6D29XkXMYNrmwyMWRms
50079	payment	2134	2134	1874	1	1	8516	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnqfYudJpL7omiNcPPJPSmsd98Bo2NhkXt9X3N9crwp2Ld5DPA
50109	payment	1397	1397	1678	1	1	18146	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzNReXhrdbvkYCGXLdSNFw4LMMM23FXDMMJVnD7BNzKA5K7aib
50110	payment	2134	2134	1874	1	1	8531	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTqU4YsDPeuSp8edcLh9NPgvTeLCYVhGce52zzTjH3vmh6bfY
50111	payment	2134	2134	1874	1	1	8532	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5XgaKD17EEDfJadgqfMB1KnzW3sp3ukSzCMovUKcGqkY4x2rv
50112	payment	2132	2132	1874	1	1	2191	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7h1EoWiDbmwHLHLFLbTk2y4WXxUU2aT2AhmnB13cjKWjKzUkP
50113	payment	2132	2132	1874	1	1	2192	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHfMTkYqBbo3pAgzoLrmJuGWkSm1o7Fq6bB5hZHkMQ5FkFYGzq
50114	payment	2133	2133	1874	1	1	7939	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgVAnjk96r47ArxgVdnMVg1wYRt9M2vE6ihzCSsoqMM7x87NiJ
50115	payment	2133	2133	1874	1	1	7940	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBP5bXDWtXB5QSYJyfDd29HUyTZBuWGjh3etBRJQhHBhMYGHk
50116	payment	2134	2134	1874	1	1	8533	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLajiE6gn4ya2esYUUtvVNz4fknLiXeaovJu98zhVMXJQ1iTEL
50117	payment	2134	2134	1874	1	1	8534	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZqCsmYg3BvcmHg9L13FNYHyPuPtnBapSzNtqxfRx466MNAG6
50128	payment	1397	1397	1678	1	1	18148	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiR77qgou7gwDARiFvstQCrMAZVdbcvMjge9zPdh7vkSQpHnUu
50129	payment	1397	1397	1678	1	1	18149	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVkvoUTL9x3g88b2Vn5xyy7yHEUWTYPyFhAKMpF15Rky3SW5gA
50130	payment	2132	2132	1874	1	1	2194	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpJ2djXK4A8bXf37CbUcMe4PznB9cNKzfjN6wixpaRBAiZvLJ6
50131	payment	2133	2133	1874	1	1	7943	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwKiFb5qNpwdKHZU7Nm3rxoqsNAestdg2PoDNcLrHobF694yEA
50132	payment	2132	2132	1874	1	1	2195	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6JisZfNEdyDPQhdsZ25rxTHAihMxM4gcUfwjYRR5Z4c5na1xV
50133	payment	2132	2132	1874	1	1	2196	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZACbBrT1EiVbiRYWhsb5UTtQ6ABjXBi3w4tzUge8Ronf3yMVDw
50134	payment	2134	2134	1874	1	1	8540	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtW8CEovkngu2cMQFHYem2JTurk64bQMKn5xfhHR2kWY58X4T
50135	payment	2134	2134	1874	1	1	8541	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNkRUEdigLzSFLYpLgrAtPAStadc255P66vEpSTmnv5AUpLTz
50136	payment	2133	2133	1874	1	1	7944	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeFAzWBgTtL47vvJSiEsPqkxKKy5fAsFnYVJZZLwzPTH4YCcSa
50137	payment	2134	2134	1874	1	1	8542	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxk1Lq6yDDAC5q48CDjvJ1ysju2LyVE4pEX8MnfGyH6rjw49MS
50138	payment	2134	2134	1874	1	1	8543	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2f5Rkf3bLtsknNAPHSBmEW1XhA51PxwdNC3RnY4gFPFBWGZXt
50139	payment	2134	2134	1874	1	1	8544	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj9k9fYstD2FjHP3vBtFuPKjh4PqWnTR933siRR9bUvZGUnyZk
50140	payment	2134	2134	1874	1	1	8545	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUoxQGcPG2MWa5SakQhygbM4pSiuBSfGCzk2AVigT6sNPVrjF4
50141	payment	2133	2133	1874	1	1	7945	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6EXGdDA8HaEwT29CWv1SKxFiS7C8ERBKt5RXp7PAe74tdtdmi
50142	payment	2133	2133	1874	1	1	7946	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJQxRBsPFL4eirSvnBVYaqyynoExEzC796XoL4kCnkgjmN39vg
50143	payment	2133	2133	1874	1	1	7947	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PpBuX7DZRCGpR8pf2v3933UaifeFWJyLRTpgY5PEkoZ2AiiY
50144	payment	2133	2133	1874	1	1	7948	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDSkaCY8S2WN6KwsVJY8uxXShUbER7dzUeezyMoXkV572aQu8g
50145	payment	2134	2134	1874	1	1	8546	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE3bDu8GqMw8DcdCWMQnfbRiZfYEgKCpDrgiWku1vyKGHzBKWk
50146	payment	2134	2134	1874	1	1	8547	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtoMMASiwaycsaekXVaij6ArqWstGAV7j55bk9K9V9jPi4HdAy
50147	payment	2134	2134	1874	1	1	8548	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu33Qsvf7d4o4aDdy69waNdUfnUc9ysk8oNSXZmo77b6SK38EG
50155	payment	2133	2133	1874	1	1	7949	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwuPs4kCnWGbujR8bBM8NMLg5ciwP1d3CarUivTXi77xtwwLft
50156	payment	2133	2133	1874	1	1	7950	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1izpFkJoZmPtCNNA9QykKUvJhU3oXWNxYhMFtPhsF2KYS1qzt
50157	payment	2133	2133	1874	1	1	7951	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKpyWMUPXwgdFeeFvoRB6NHeftEddBeqidMmF39F2tHVXYYhET
50315	payment	1397	1397	1678	1	1	18167	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrKvsBfBeV8GRcBnDnoU8yTymGWgtZjK4gE3bSnR8jnVte4Xv3
50316	payment	2133	2133	1874	1	1	7994	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbwXE8Ha1HNgMFbeVktkowfEZPsSJTLeHJWv4HMiD2DEqeGYEq
50317	payment	2134	2134	1874	1	1	8624	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiLnic7k7XJxbGPRppQjiYQVuDdZ6cZKynZybJuahxdXbP1WZ4
50318	payment	2132	2132	1874	1	1	2222	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEKXoJcNCP9ZeAGNtQ9R3Q6cNEU2riTr8d8Jd5Yczsn3hzVp9r
50319	payment	2132	2132	1874	1	1	2223	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQTpTEm3QAxjwgUNNMY6XXEJGbDQmZuuMDK9yDwHm2aEC8ZYwr
50320	payment	2133	2133	1874	1	1	7995	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQGDnuFGjSivFS4MHDHwdqBPnMZ3KCC5Ttz4DsV33pZFF7xKop
50321	payment	2134	2134	1874	1	1	8625	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqFmTDdvgheNj5r65TfRRiavfPzTBKhaA7CNh7gjvHuLjoNbbM
50322	payment	2134	2134	1874	1	1	8626	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgSaG2xsmbj2kNFP7TNB75oc58MuKKVK3kGNhZggjdwuW9hS9G
50323	payment	2134	2134	1874	1	1	8627	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY4qfPk8eXhp6TTgtDWCtN8KnncvqRA8ceWBjZDQfC3XcEtTxK
50324	payment	2134	2134	1874	1	1	8628	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujMx8e4H19D9kswrJZrHKmkcWF6bQ2z1ynjXWPbLLxwzqQXkY
50352	payment	1397	1397	1678	1	1	18171	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMecqU6Y3wkRgJWpHurSkNsVPcS74FF8aMZyu2GRw6ndNMbYag
50353	payment	2132	2132	1874	1	1	2228	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcU52FawtLaGt2Pg5h385xVByH1neceCTybrLhjanwdFvArgQo
50354	payment	2133	2133	1874	1	1	8003	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDZ5YUWnmJLTdKGs1gV41Fa4wDDhigFXY97FhgoNRrHkNSyjtQ
50355	payment	2133	2133	1874	1	1	8004	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU269YgTmcQp7ipLTC5EMBJ9j6FaiU9236JUJvAGGmDrBTHDSG
50356	payment	2134	2134	1874	1	1	8642	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJ767vbvkjhxt6PrRbajBeenwPuSzXiLUttAb5ohDmUE8WgmS
50357	payment	2134	2134	1874	1	1	8643	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCGXX9oc2uyTjxDt8jFVvLqCxZP5AJFf3hCZxDLxnB2KEiubsr
50358	payment	2134	2134	1874	1	1	8644	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTxsseaG88CQwRn6xYjfFYnXtY1BbLR1syT5C6dGKMnqPhKAZ1
50359	payment	2134	2134	1874	1	1	8645	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5V69AAMAEswx1275YhpSFFhLQyX31j2qnucbmMpoqdKHXdT8p
50365	payment	2134	2134	1874	1	1	8646	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLsTuQeE5JpmiYoCUYapNmdNgSUwFUfuwn7RrAaYSfvUZwrjX
50366	payment	2133	2133	1874	1	1	8005	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJi1zWjTFviqrJszfUPBguFNdHJ2XtYQU9ZuxB8h5Tf4jGg5Ay
50367	payment	2133	2133	1874	1	1	8006	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfBBEifzUXo3v2GSJfChT2K3zFMVs4zFHQSrLgYGc3UyXeDJ11
50368	payment	2133	2133	1874	1	1	8007	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbutuL6w8KPiqEZCBkh9aabciD59iNKmGcesWC6M4ui2trrHzm
50369	payment	2133	2133	1874	1	1	8008	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmwhhouzHP4BqWB3NmSPAjspVbU9iQt7CqNFs5aaReW8Vfda2
50370	payment	2133	2133	1874	1	1	8009	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCZe7SksgtPPdHivVjnDtWFAitLCfzJSp8Twk3CQPqoBmrgbSw
50371	payment	2134	2134	1874	1	1	8647	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gTkcAsR2n1827jCMo4vN16GEgQqpm8zCW8ghvw5FybG9EsUd
50372	payment	2134	2134	1874	1	1	8648	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbNnfaHPc4J942vYXu2Q11m93UhmVey2Fwf6Q7ySWLN5GbimSA
50373	payment	2134	2134	1874	1	1	8649	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB2ZedaJwSBRAvWrUWCdx6D7med3dLCBRAPPQygDaBf5DSUhNM
50374	payment	2134	2134	1874	1	1	8650	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2TsJjmJcXfdHCiFgoZdQx2U98f93j1CpE1QMTqjrpLB5FTKpf
50375	payment	2134	2134	1874	1	1	8651	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5QVN1znz4fyFxphpXEoE9KGJhUwywrAUZS8vfnhE7hT5yZ5FE
50376	payment	2134	2134	1874	1	1	8652	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa496WVGYnvFcrYuwmMcndcHDKWC2eBwtYxuV1ZPfmUj9hZdMD4
50377	payment	2134	2134	1874	1	1	8653	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSejKCb8zsFtGtbR1ev9vYrimzKSSREffTUCTcxeq7txJ5KpfR
50378	payment	2134	2134	1874	1	1	8654	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYhZqPGVjx9YfEEhnxVUi6wCgyZAkpRRBu33kKG9XVmSTZzyMz
50432	payment	1397	1397	1678	1	1	18181	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHsxBqBqUCkavajnQQcc92zNLqfvQF3pekLMgS5EKgWF3iGaz
50443	payment	1397	1397	1678	1	1	18183	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiKgqhZMFAFce3ogEFYYLmuhYCxbv3nMtiYKxNnp2BMaCoGeEU
50444	payment	2133	2133	1874	1	1	8034	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxmwm6Qdgbsp4gBa8HWVewzXS7s1b9FLxYpzrfkNzWKJQW365G
50445	payment	2133	2133	1874	1	1	8035	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeQ9TgHNipw8SKpL4hpWZFmMybxJ4LB5c8QMc7ckdrycVogRHx
50176	payment	2133	2133	1874	1	1	7956	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYgySrvR5gqubMY1rWxX6vTvPRfZnix8d5AkRSKTvoxQu8kQ5
50177	payment	1397	1397	1678	1	1	18153	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRC6221pN8wF8wc8nTERZ6j5QfFr5ooWy9rv1jEa5GH2Kr5jcn
50178	payment	2133	2133	1874	1	1	7957	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhTgWHzCcvXBBoATNYDv82joZKthA82FTK2tYEApdrPDCjtNKF
50179	payment	2132	2132	1874	1	1	2201	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyayA5NiHhDQzHr7Qc7rp1vCAhsEQQRhgUBQCCpkqqUPgNvzs
50180	payment	2132	2132	1874	1	1	2202	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR9yH2ee9uQaHebn3oDFQsXMHZhfQDsr3kgAMbaaCdRizCeMYx
50181	payment	2134	2134	1874	1	1	8562	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKJR1uiLrLc7xEG3daKuHJ9ntL7ZuqnxuUUK4jxRdCdcApDVkn
50182	payment	2134	2134	1874	1	1	8563	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSn55BHUL3EK9END1BgtRYnaQzgS4wKmkLYQgM52U1SwGWDsmW
50183	payment	2134	2134	1874	1	1	8564	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLmrwL6Ujkd65d88WfYHK5HvmAVvWRtT4TeskcLfz6azC8HyD
50184	payment	2134	2134	1874	1	1	8565	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqdsNyBssHcRbDxZxf5BEavk2rTKUL56tRSxwPvzcmi752DBq7
50185	payment	2133	2133	1874	1	1	7958	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB2kT4SQq4wMNUp9w73amfea53Se7WFQzCiRGC6MkCJGaWgxZM
50186	payment	2133	2133	1874	1	1	7959	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzskBYgJG9zqA5rGvHjrwzc4hhwYj5j51655vDyWa5XEAgce6P
50207	payment	1397	1397	1678	1	1	18156	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZpAKgx9a8CHJJZya9twhPhUNdnxNXzHArWYsTDBwoPC7Y8JMh
50208	payment	1397	1397	1678	1	1	18157	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcfZqRVieKDKg8KUAWaigpTdsaQYBENWwspYNTiTRRfhBtygzh
50209	payment	2133	2133	1874	1	1	7966	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgz1KYse6ikp7yH6Dqx3RaYz9DtTRU9K7ngGuxrtBXKg3mPwWh
50210	payment	2133	2133	1874	1	1	7967	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjKxV7sMVik37CsBs3Dwq2CqCehA5BLEqMozDNq5xumo6bztXN
50211	payment	2133	2133	1874	1	1	7968	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9LpXVWmFzWi8WFrrGpfRgVWQCCmZzw1cBV5qmi3ZfarGWYP4
50212	payment	2133	2133	1874	1	1	7969	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiUWERqwLxzS9e5B7a15y9hhS6i4zrCD9RaYaqWx1fnLAJ5uk5
50213	payment	2132	2132	1874	1	1	2206	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHR54AAc3f2LSc13jrUxV9ZoF6HkakvnJ6LekhXMeJ72yiiTN
50214	payment	2132	2132	1874	1	1	2207	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwgsKZry61poBtH6pHzjbbUEy9oZbUbECQQStFBig9NgZXwQGm
50215	payment	2132	2132	1874	1	1	2208	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZt6SwTvhRzbqXfwrYuuop3auiamr365ivHbdnQNMeSGkLYb4Lk
50216	payment	2133	2133	1874	1	1	7970	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33g2YmAzQgy63b7iReUnUNTBGgNABCqFLcNnVxQgLSkhAt3UJ
50217	payment	2133	2133	1874	1	1	7971	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWfiUtiAzKYTmGU75ocFxAHFn1mBBa5BeiNQ8jVA7k7uv1qsR
50218	payment	2134	2134	1874	1	1	8575	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE9jvzF9T9dUkNLmkqm4pZuGBM7dKDZxzYwRDcCcdLiQbeiGuB
50219	payment	2134	2134	1874	1	1	8576	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9psH7gUrvvuxiwht86h8qqhDXR9JXUfRNL5qjiKeFmZJAavRJ
50220	payment	2134	2134	1874	1	1	8577	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSSKCAZeFFAMVDnvc5dC3nXidMJtfmtFQiGthMtHqvJnEA8mWV
50221	payment	2134	2134	1874	1	1	8578	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL1DujvBJa8ExaJq115gG2omfbrGgrMy5eZe6vec7oYT1fVU1M
50222	payment	2134	2134	1874	1	1	8579	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE6zNuQwVBAq3oMRSQoRcTGYPHVU99djsNqgeHu5ysup2ZM4Zk
50223	payment	2134	2134	1874	1	1	8580	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtYSy9tH4At1MicZdCFWtTE9NcaC6obpP1NrtPpfruJme5D6TT
50224	payment	2134	2134	1874	1	1	8581	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa72TPXMHY9rvUT57vMGM1WKV9dPMdGu8TY9gSghzR7NieFRVh4
50225	payment	2134	2134	1874	1	1	8582	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNUdMDu5QS17A8FsihUz3z496R4qX4CriCXJnjeG9R2Dd3EG7
50226	payment	2134	2134	1874	1	1	8583	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaoBFXkhpzm1bJRxGxvpY2xRTVex2AtKj72ZS6yDDAwH1Cgmru
50236	payment	1397	1397	1678	1	1	18159	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSG9mKeFQcGcVenUcqXc1cqPKRCjVnkFTCrFuyyPPwn7mQoQy4
50237	payment	2133	2133	1874	1	1	7974	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajW44b6JNx4ntxiqU3ojZNz6NzKiY3587jgF5quepRV3o8tm4
50238	payment	2134	2134	1874	1	1	8589	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2aXpyPKKpNU7Wu5duyrxVY2TTLGmMJw2hNbtwLVXcxw9XpeK
50239	payment	2132	2132	1874	1	1	2210	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJTHio5WhTCHdvZxV4Feg1x2pm8xDwgnhgSkU49RkKN2JNxtgm
50240	payment	2134	2134	1874	1	1	8590	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZueVnGDtFNBfPEsFzD1sfT6uDASfTXUQWBozbJPDmp44uLegxK
50241	payment	2134	2134	1874	1	1	8591	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBWBe9oefYhF31zAAJUsZfiNxEfKwixLmopx52wX7M9QGx5cg
50242	payment	2132	2132	1874	1	1	2211	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyvCVsCpDbkggtmL5LK62wHWoEVYGkSbgmUfwdCsFcH9UjMz5Q
50188	payment	1397	1397	1678	1	1	18155	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVaXTGKQhhXKymNNotEJhvsjFTE8hvpufxNBb6B9YJEvULCFVV
50189	payment	2134	2134	1874	1	1	8566	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyfH8EfhLeU7EHZF1r4KncgETLLo1fzYY9EQUxZXXBHL5FcktV
50190	payment	2134	2134	1874	1	1	8567	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC3DoHdu75BoFKahDTdU2YRHgPjaFehz7WkQjzaYuwpTR7dVoF
50191	payment	2132	2132	1874	1	1	2203	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCS9wY3J42Hg91tZoxRgzLL5E789A28bFAMNfABSHJocoDrFu
50192	payment	2134	2134	1874	1	1	8568	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJixhUADx7rcFWv6q1AK7XMSXAUhJJi51ZGwNaukQk6eQYUwT
50193	payment	2134	2134	1874	1	1	8569	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2vVkCasFx3Z7i2rKoTJsog5wAvGDaDVaQYoqpYMW7h58536Kg
50194	payment	2134	2134	1874	1	1	8570	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjF9XrqXcmvCQSv4Yh6Gs73ACd47jJKy8wwDyGAjh6RvddgFvi
50195	payment	2133	2133	1874	1	1	7960	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJpFxExQ54vEb3NsWDsh3LNZMHHAr4RWd6LBiws2B9r3c1h7S
50196	payment	2133	2133	1874	1	1	7961	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvywGAL6dszwVMEwNp3V1qCMWiq6eFDo4yE3bvC4QR1E3JQ2Nq
50197	payment	2133	2133	1874	1	1	7962	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5Kt7YJiZFvnirxZkeNDLv8VNmfH5vgvzZ6XoPGqpChcT2gaZ6
50198	payment	2133	2133	1874	1	1	7963	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdv3bkiF9PAcKUxMjqNSQM3bcWd6cd8eyDBcvBQcnQrA2j8k3i
50199	payment	2133	2133	1874	1	1	7964	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCDG4JBZuPcq6TXxBpUJWYitit3c2CtSnctYVZHbq4rgQCVFxo
50200	payment	2133	2133	1874	1	1	7965	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAL1ryjiz2TRJ9dpH3ZFvsitzWnY7HCqfqG57yVuzNMMk2fGz7
50201	payment	2132	2132	1874	1	1	2204	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHufnSEUwWExtMi3VHeLB5e577rn1REC43eogFJujUx2NU8tCG
50202	payment	2132	2132	1874	1	1	2205	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaENDFVZd9iQwaT739mzKoJpRgPhYMtdvqeZ691Hr1mPsUsLVSJ
50203	payment	2134	2134	1874	1	1	8571	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKHYQyNcXrCG19dhvbtNse4Sy79LdwpHYnm3mz6ECg9Z2X9GzD
50204	payment	2134	2134	1874	1	1	8572	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfC5KcGMidNxejZ7sYng9F5ckfq4Kv3hd7swiXzYHy5e2uFbSP
50205	payment	2134	2134	1874	1	1	8573	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSLLN1MsW6ybWoENiChcy31x3Euunj33eKhDdkz9fznaiBx6Bx
50206	payment	2134	2134	1874	1	1	8574	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSGngiBSp8DjpJTadppr7zUb783XQutGGq7U39zqqQ4ogVg7Vr
50227	payment	1397	1397	1678	1	1	18158	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6wLevRuDXzTj6qocgQurLfBpn6FgQCsfcaqy9mtyqW6xhw7m
50228	payment	2132	2132	1874	1	1	2209	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6YDL7MuriW29LnZYtcbtfrG7eEApati9KWxwcEFJwc8m9UMdS
50229	payment	2133	2133	1874	1	1	7972	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGkW74SXpVBDfGA6At9EttTXr1RYuyNRKa1Yk1UBEvz2CrMreo
50230	payment	2134	2134	1874	1	1	8584	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjdwyAAmZjqyQR3Bz7MrJ4vjv49SNrpzNTnCoeYYokCaT6uCFt
50231	payment	2134	2134	1874	1	1	8585	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCKXZnUqPxzTEZFz2aMM5ut9JGKXqkix1dwkWrj71wboLmfkG2
50232	payment	2134	2134	1874	1	1	8586	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1E2zmsiQ4rRJNuAfqVXzo5TS2mWS6GReoB92igrkUhe749Wo2
50233	payment	2134	2134	1874	1	1	8587	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1kn4QUtEKpe2qsJ8tjwnDBUyXhybAjQrDffn2Hb3gWiJfWKq
50234	payment	2134	2134	1874	1	1	8588	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCPzpRSmvdfzJUEyWBzbfVntfFwSoXB9REVz2AKaKn6GYYfKbL
50235	payment	2133	2133	1874	1	1	7973	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLG9cxVatpyePKDEy8heg4PU8CQLAMfmhGyS3hWZG7tvkpXxeh
50265	payment	606	606	2238	1	1	18	1000000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKRHu1Vrc9yHiN4kqZA8WYyEyaLrdj5ejhykNSPBiNPeSkdVzJ
50266	payment	1397	1397	1678	1	1	18162	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9AqVK54E5qzxEQPY8cFLMS3KChUNqhfNhkhMHQUCBQCg7AkH
50267	payment	2134	2134	1874	1	1	8602	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW7mzpiN5Jyksnpu3KFP3ExPKKpSAkXc3eQ859GvNRbkt8YZn7
50268	payment	2133	2133	1874	1	1	7982	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz8mWPGR729uxsfnBZBDK9GoSQQh6MM3LzQUuYuNp81iqSfSyg
50269	payment	2132	2132	1874	1	1	2215	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6CxXdtuc3c5JYu3go911DfE4mUx7jGb4reaApmQejCB1g6Vvp
50270	payment	2134	2134	1874	1	1	8603	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRnqENLMvZvqKcVfmDBYad8Bg1MtybNUvGhVgLk5XqCLccJVLx
50271	payment	2134	2134	1874	1	1	8604	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLLkMszpgqQe3Ym9ZYgYoz1kurQgdCtsgaxphBEB5FwNnQHwb5
50272	payment	2134	2134	1874	1	1	8605	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhk7bxFZgfbB78NnwnKEzA5cAZozSZF9QL6fAawotVTUgYhRac
50273	payment	2418	2418	2418	1	1	0	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeZxDeWwWzisHvxiB8LXY9jcAJyQsvhpNv5CEvyDqBCcp17zbB
50274	payment	2133	2133	1874	1	1	7983	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC2fBEg16JWQP4NRkzYYrwYDVG8Rk7t3ZLd5rhVGRoDZzoapeC
50243	payment	2133	2133	1874	1	1	7975	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzGsQp751WXBkxMeV5nspBVk9L6AYi5KKxFJ2AUrg43kmCfNkD
50244	payment	2133	2133	1874	1	1	7976	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVuFAMiaGdCKFwHTWA1JZjKT1e9twf1TenEdibGbsUY7nWCa9G
50245	payment	2134	2134	1874	1	1	8592	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7adAeuubXmVJygbbp8K6YXcDz88LdGJfJB2CLSUhymCZAznk
50255	payment	1397	1397	1678	1	1	18161	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqDpZgg2VCbPJa4KUocyHpFFRzdQeGgNbRyKHRt1iaMdUi8472
50256	payment	2133	2133	1874	1	1	7980	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ39gjn6Z62Fv7XWFK4nK5f1qsMGZmqjZZ81x5zrasUgJLbTPXm
50257	payment	2134	2134	1874	1	1	8597	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRKtcSbi421LWEsH2nsjK7obaHoFaT9fNMNRqigXbC6oSPUDkB
50258	payment	2134	2134	1874	1	1	8598	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEqQp2T1neeaGxdyDrSF88UAaKNdFuoNeyUsjWyBGGnVpTqkmb
50259	payment	2134	2134	1874	1	1	8599	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA1Nx2RVDfeu3wsA72ErpDFJU9aMbSbraJWb9ogMegBSC5Thkm
50260	payment	2133	2133	1874	1	1	7981	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMeFxojjNisRFhkWCeAiXuHexJR9ErgfMGjsSthbNNoJHWQp7
50261	payment	2132	2132	1874	1	1	2213	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcG3LzSZBmDgnBT12MxHQVv4YeX7EU8oH9rTykCQQXS2gxQH2h
50262	payment	2132	2132	1874	1	1	2214	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRjhF9mDCdmRJfYwDi1wma9hAqrto6qntw56WCLToBiynFL5s6
50263	payment	2134	2134	1874	1	1	8600	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxpmTfkoT3uwcaF3AD9eovubtkEVk4qVgkZfYvZgfktN3Tugg9
50264	payment	2134	2134	1874	1	1	8601	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw4eJrZwvziCx5KacnT44fmYTsmaK9QWC2LPP8V5H9HaJovrBf
50275	payment	1397	1397	1678	1	1	18163	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM799fpB2N8jbzXFYb1AoZdyr84MS8pF6ujqCqMsNUWsbghLGT
50276	payment	2132	2132	1874	1	1	2216	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRUvwx4RJ3zgCcgqEiLzHwjVEpqQ5p6WohsHa1tvMNWe8P5rQS
50277	payment	2418	2418	2418	1	1	1	0	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUGpdmxBZ6CBvBe7oPJK6bPiQaTJzuUjmy2dB7HW1Ff9mWFVs
50278	payment	2134	2134	1874	1	1	8606	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmga6pH3bAdHiddWCnAk55wEBBeBSBggtsxBGFyowvc5adm4ao
50279	payment	2134	2134	1874	1	1	8607	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYduBJC9ECwbJGoYdK1dmoYEx5Dz2hnaaw4vYjzmub3qDDwgtnf
50280	payment	2134	2134	1874	1	1	8608	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTjcv452SvtzYthwPvqojzf5RX7qe3gBuh8z9Q6CwoaURXyrYo
50281	payment	2134	2134	1874	1	1	8609	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtGTxd8B2DPgDgA4E9S7GjwUP6pTDstqiaEFRZNvT7BRqV8AVj
50282	payment	2134	2134	1874	1	1	8610	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs6RUx97k29X4ic3ziSaEjJF6hjmciV7cXoCjnWGR12Y7WNapi
50283	payment	2132	2132	1874	1	1	2217	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ksMsUdW3UYbJnTQMhXZqYxyg3waDtiVqGoVH5ANh5ZuWX3gw
50284	payment	2133	2133	1874	1	1	7984	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa83v64RAf4Zn1KVwGZhFDtQXhdbPjkZ4bSfW5RyFoodYRSWbGm
50285	payment	2133	2133	1874	1	1	7985	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYweGkcx74CFC68fcDxiuqKGLBek8MrRhSrKG5TpYunstdFzBba
50310	payment	1397	1397	1678	1	1	18166	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo4KG6ky5i3kBstWVhR47bTDDvzFmtphP5VSbreQVj62y3sr1G
50311	payment	2134	2134	1874	1	1	8620	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZEQeCi1RVsFb1PY7yV7WC1T72sky468uN8dDP3AkTobjFU9j6
50312	payment	2134	2134	1874	1	1	8621	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsMRJcjBURqG53cSfPMTGKc5vXDHXs4g6YjVJfySrMJsKQbQ3
50313	payment	2134	2134	1874	1	1	8622	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4QgwRt7PSRQvqsoaCC71Ss1NM58CmzNT4qa3GF91YJ9q6K8X
50314	payment	2134	2134	1874	1	1	8623	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZczSaEGopVJ98rxrf3bpHYDKMKNg588g5vAukexEHaj3reSEUX
50332	payment	2134	2134	1874	1	1	8632	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCx8stLnPfHNJRQ2JoL38YToZpKuVSiGnJHBZJMMtPACnA1EP
50343	payment	1397	1397	1678	1	1	18170	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJzWvXc5Kkf9czpRh3iwHtzz8jHcWgBkg4MAcPCnoMQUPaZaZ
50344	payment	2133	2133	1874	1	1	8001	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLhNcBACvEWs3XAZ4j6FRobawy6vbw94g2HoTTeaaxbphwrmf3
50345	payment	2132	2132	1874	1	1	2227	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ1V8PCCAD2UcgLvUHtm59uncPTjL6GCSPsry9hT46ZUCUPXux
50346	payment	2133	2133	1874	1	1	8002	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QRWLpV2SewCpe1NNcrQFRGjgtyrA1wAsxQ8vSAKyedCK6S2V
50360	payment	1397	1397	1678	1	1	18172	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgUSR8tXMDxXEjzy6kK6DgWVFShuaUtnA3ARrdXqCQibq1oSGL
50361	payment	1397	1397	1678	1	1	18173	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuqJGzVkrmKzPzXGUP6Z89T7AgxAbPYWdrgbtzgFitzajy4iSC
50362	payment	2132	2132	1874	1	1	2229	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMvx7MFXdZPEhUHRSSpLFAci5J5nsfn2PTicDiFy1A1dWv1Ww
50363	payment	2132	2132	1874	1	1	2230	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgutqw2MCoZrTrEY7WUcNe21m1xgRi1xNA93xB6KBn7qevrRLw
50302	payment	2134	2134	1874	1	1	8616	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpz45A3pocuJ2gt2YSYrT6EXuqjhJagYqWJVEkQMbfw9ZKkwQi
50303	payment	2134	2134	1874	1	1	8617	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuVhaY36aHTnbbUV1vgnTUX6DjwToiqnWeEF4QhgboC2zZKktt
50304	payment	2134	2134	1874	1	1	8618	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWiBbVzyR95NrG5pTgrcGTsNUec1ZL7NjDAVNnSKt695ybntJm
50305	payment	2134	2134	1874	1	1	8619	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYegsmJPB7Ja73gAeu1zzdyujXe4utJmmPjRkjNp9DMM67X9bhU
50306	payment	2132	2132	1874	1	1	2221	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZahjcexHyFyho7ZZ8ckWra1dWJ7NpCwqxm9DK8BGzUNxCXwExs
50325	payment	1397	1397	1678	1	1	18168	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztUw4hthmyjHKXmwMZ2reNXvZW3EU15uvcY8LTXrZ2pZ9aYY2
50326	payment	2133	2133	1874	1	1	7996	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFwFsbo6as7z9nbHgaAuGxv9ZjEfU6EfABBqk6yf23RV3MvvG
50327	payment	2133	2133	1874	1	1	7997	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTiQ6cLPnEhhiuSX1wet4WLnksCkVhfS8WD3o82tVd8NzCvrWy
50328	payment	2132	2132	1874	1	1	2224	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKSkcGugpU8kb4x1KhpRiXCKvNTj3eAmqxWPBatdHXbPCmKT82
50329	payment	2134	2134	1874	1	1	8629	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKvaNcMcWAkhpd9TnWCDVmTViAM7aTZF8YSL7XCMFs2KRaZCf8
50330	payment	2134	2134	1874	1	1	8630	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXYUj1x8WsXDLc8wqNBogLTU8SapjZvm5xhTKRhAEyFi2YMpSr
50331	payment	2134	2134	1874	1	1	8631	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSVnV1EYg4T17iSDRpUwsuR88MGwQMwutFjSiZj6HBNgbpphzp
50333	payment	1397	1397	1678	1	1	18169	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpTrRwhKXKA7wYC6pxcKQrdfofWE9pFWyo4jPKubgPjdYYW1N
50334	payment	2134	2134	1874	1	1	8633	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtgiVdZxYhee8kuQ3BYtVBexkJmfPJLYRnBxKNwbhdNZVq7GNX
50335	payment	2134	2134	1874	1	1	8634	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYge5gV4f1SM4Y77pgCExqYwBE3W5sfHjPFK8A5cxqiLSSPodFr
50336	payment	2132	2132	1874	1	1	2225	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWDnof6pHGzXaRqQcDezXq2GS7KBPLWNiJoPcQFAzrMkrcK71r
50337	payment	2132	2132	1874	1	1	2226	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6wESrFhaCjuowzgcrZGzTsPTe5RjYWtsxubSeC1TYnsHKATw5
50338	payment	2133	2133	1874	1	1	7998	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoJTYRusxvB71xdA3UVdrp4vVyCCX9UYaufdhZNpyTdg1AuUW2
50339	payment	2133	2133	1874	1	1	7999	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB3CTE2mXjsBjHDkDXB9gcur5Sokk4zoBtFHFgsfR2xtnorQMH
50340	payment	2133	2133	1874	1	1	8000	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2Dm5dzYcAoNp4nJmnPQEyFnUa9qnpgkDU6h69KhfzaLnpXXgG
50341	payment	2134	2134	1874	1	1	8635	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZB6RoQsYNofKvieSLjMS2TG37MmBp5WM61mHehMUKkShbBMq
50342	payment	2134	2134	1874	1	1	8636	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9mc36rnyg3qKwfhBwSPnb45qhy5MkAW2w9GSmpv8PHSdLBAnb
50347	payment	2134	2134	1874	1	1	8637	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGijZPwpAgTDknpYQ2S78cEuY3UhzZiP4FQUJPjYejigMoYDT
50348	payment	2134	2134	1874	1	1	8638	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1DfLuuc4pKpyHA5646nJ3Qvn8cenGNokuNRoeHXZr99pvB3Mw
50349	payment	2134	2134	1874	1	1	8639	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEJSCDKZkwY89q9hPPd1BStWwyabeKHhZtgAxTuG5BPSLFXYLs
50350	payment	2134	2134	1874	1	1	8640	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEH2j2rVfPaicaniFup746tLwmnGWsnD2HLiqmBL3z6A9933EU
50351	payment	2134	2134	1874	1	1	8641	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxYby7P7JWNRyLSHXnNwzaT28aPbxGroPaZ1tf6cdiMQ2Dz51V
50419	payment	1397	1397	1678	1	1	18180	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7voPoV2U1ZNuCrLefbGWGn5dkFDXab2ySir7cJ5VGVUWsgzvf
50420	payment	2133	2133	1874	1	1	8026	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8i3VyxG3Fwme5Ruwpa4JACVoKWHUmpsFUGagvZqDwBJQtknFN
50421	payment	2132	2132	1874	1	1	2241	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAeFv5i2ZtAFZwffWJT69MpmP3HchSXLML2vDnMiEJk9zmSPJQ
50422	payment	2133	2133	1874	1	1	8027	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtUJrgz21bn9Wow3pjPAkFGmWdr9NSn6rEdpxAsdg9HnQkHcnk
50423	payment	2132	2132	1874	1	1	2242	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1mNMcJj2JQd2VhvsPLBkyjbaEHkm7mBCo21N7To9HAAw1XgRe
50424	payment	2133	2133	1874	1	1	8028	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6T7uvFCfuBSiqt1frfnqtMxT44FLPSSQbeMCf5bt3kDhsYRqb
50425	payment	2132	2132	1874	1	1	2243	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuc39R7Mbkw5jT1WF7qTrF7RuWcPxsidkmQXqt2cKFMV8cHpxN
50426	payment	2134	2134	1874	1	1	8662	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkpD9kSHpKL7WiwjTSLQnEHSRHCstVxFzHVfzRtbeKnxJcstPC
50427	payment	2134	2134	1874	1	1	8663	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfRmA1cTb3ogYxpfSzHynEidqGaiFqGPwyMKfK47SUoKYmBDK
50428	payment	2133	2133	1874	1	1	8029	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoizujmfgFUTZ75VnCR4m3M9MuQMHV5aaw2SEgAV8bxeFfEUHQ
50429	payment	2133	2133	1874	1	1	8030	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8Bg8gbnCBTkwhu3wUsVvupSQyxNCfvVfLVkCcJB4Zz68gUXGi
50307	payment	2133	2133	1874	1	1	7991	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfZta2hHe9DWoLYUja2nXYqq3uVfKekedoQNMoPHP7eBCHk3Ey
50308	payment	2133	2133	1874	1	1	7992	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzkt3eW8aUt7tFqYqCWUeKMCtZruj2dWJUpktyfnDFzhaoRpyv
50309	payment	2133	2133	1874	1	1	7993	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvwHCK8MJjoQvCjs1rbGv9qtsFoU3JxzTZZYeY2iuXTn51Snc5
50379	payment	1397	1397	1678	1	1	18174	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTeno3VbFjQxj2Aa3UnitZ9jxdfCryezb5t2wuuiWVrCFWDRfh
50380	payment	2132	2132	1874	1	1	2232	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAsQnDtDjt8M1r6yexiQBRiHenDUDpXyGsbMRjPCuV8CqruMka
50381	payment	2133	2133	1874	1	1	8010	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZhLLR4jsBkX4hbbDCG79cNC9GyEPQxgUYuDiA4gt38uBZRuYB
50382	payment	2133	2133	1874	1	1	8011	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNzahyHpb7Z5MVqZjFYU5uTqDq5ZdoVfkfhH45RaKvppUERPx
50383	payment	2134	2134	1874	1	1	8655	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtNAmjbJeagqxrnbrm9RKDjLfom4X5naSegRMv212amxPHjECZ
50384	payment	2134	2134	1874	1	1	8656	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDpTifexcfMkncomwJqrMzHfawz9RbjnbLd8Vp5yNyMV6sXBkG
50385	payment	2134	2134	1874	1	1	8657	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYctMxzNTE3ojfay8UBB8j3fj3vvVhmjQNbsF8mTd4zS4sRcQTp
50386	payment	2134	2134	1874	1	1	8658	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvRWAtSdhpqMK1u3Vci5XxbjZ9iHnqVp45FdpUiS91TqDw51qj
50387	payment	2134	2134	1874	1	1	8659	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbz4vJXLFxo8vFPwLH5FWqoeZFKerqezNRNjqo99VKhdLx2z5i
50388	payment	2132	2132	1874	1	1	2233	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7yruniecVBdJHYJNm9JTWQWmgJRSbbFJzzrAN61WDJTvXGPeQ
50414	payment	1397	1397	1678	1	1	18179	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXiE5ABwS792kUvjziXTwhzHtcdynKXASjDbLwWbtkRJMP9JE
50415	payment	2133	2133	1874	1	1	8023	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgktD4qNPb84D4eq93VE7ozgZJ6L2ybNFF3hkM4teXyrLC7sia
50416	payment	2133	2133	1874	1	1	8024	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUGKPgpPZhbXeYzN6E3Vego2i4LeRi4PbWr268NgYKVStEZnvk
50417	payment	2132	2132	1874	1	1	2240	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCvZczJSCLZonrWnAYcc5Lwk2KDStPdeXsiTCks9WKuYQMHztU
50418	payment	2133	2133	1874	1	1	8025	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXYbrCGBbQMkrzRE7YnvtybAmiLPyVkpS8KkWbKYcUidhYMEA7
50480	payment	1397	1397	1678	1	1	18187	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLRUiGe5gg5LQv8MDrw6hY4bRLpFn4UfQfSx9RFx8KEWiBCw2P
50481	payment	2133	2133	1874	1	1	8043	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJhxk6fLxBJyoXsogNerdhxJ5NPkF1Y6qCUKQGUUJjHfvmygFu
50482	payment	2134	2134	1874	1	1	8688	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVdbxqiajaocr5TpjNuiVG11KDFr6AWZJKABrcBhMzXLUmU6Sq
50483	payment	2134	2134	1874	1	1	8689	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZ3UWKtPBSPc9n7rmzGiwGQNaVsvcYQKrvZPkMMdJL4MPqYeM
50484	payment	2134	2134	1874	1	1	8690	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJSkAabTLvjqNaL9J8DTzn81yk2QcnjfQpjSEFB5WkfXNytjLj
50485	payment	2133	2133	1874	1	1	8044	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXh5BRprrozqYpLnQ7iMiF2ajgyWg5cdk1vowM2NjdgcoadFH
50486	payment	2132	2132	1874	1	1	2252	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoscDmAUzDAmHcu2A4QmmDKcQK1Pz4iQtM8M2m5J1dvh3DjzBx
50487	payment	2133	2133	1874	1	1	8045	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAY3VM14u6hJ4LMwo2dKDdqsB3SPK7idPn23b1eYbWJVEKf97x
50488	payment	2134	2134	1874	1	1	8691	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHzMQocUa2LXMCfQfKymwBRf6xmJooLKHVHPed2yFdGbsDikCB
50489	payment	2134	2134	1874	1	1	8692	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXRxwhgg53icg9cisjjP49FBDuJ9dLUi8ppDuhPztwGzTvMkdG
50511	payment	1397	1397	1678	1	1	18191	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCubzKCTEotsnomastx14U19q2J7qvJmcNhhnC3v3abGQvE5y
50512	payment	2132	2132	1874	1	1	2257	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZLJRKZKP1ex3by89kFLZXfZTwV5Pdaet9rQbeU19FaksPq2DB
50513	payment	2132	2132	1874	1	1	2258	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHV9QFdrcDYgaxLgtrwNoa8jMNNRGH5KvmcSFGkKvFRLCPiU5j
50514	payment	2133	2133	1874	1	1	8054	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAoze78XdSJHGczMGvoEto4z9FvQ8TgEuZvH9kWvhQFASCiXCy
50515	payment	2133	2133	1874	1	1	8055	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAz3gzRPYBsxgarokeWzE1PCnTUicHthxXrsbNf2ouZ7ZD1UEX
50516	payment	1397	1397	1678	1	1	18192	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJA9Sv1HEVe4o17iNe35abQVxRE8oGTexdfk54j8jeQQPxFKGE
50517	payment	2134	2134	1874	1	1	8699	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaMxpjEabJHKAgJKQ7BMsdTB2gviSD4wQTciS8xzLmdyZ31xqq
50518	payment	2132	2132	1874	1	1	2259	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb3bo6eKqURswCtzAngyWpm1zr4N824R3X8JHbeyLKnpoVWK6T
50519	payment	2133	2133	1874	1	1	8056	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuYp6fngJiDX7Gb8eNsYDWM129G83EtRPAD8hBZHHPvFF7AoVp
50520	payment	2133	2133	1874	1	1	8057	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoLdAjDScEtzZWT35Yvq7G55PmMNoiWqvWmpsByfExeGJhk83w
50364	payment	2132	2132	1874	1	1	2231	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbhVzmhHHeWmyowieLqbXiJdUXcEK7EFmBTUUrvcaKaLDEGaUv
50389	payment	1397	1397	1678	1	1	18175	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZia4A4889FLiHfQ4jmtacY2dVX6Dpir2bxoFoiJVZ4oFUVi3uh
50390	payment	1397	1397	1678	1	1	18176	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyE6E7bqZLXJzUb7DwApBXviLSWjPYY24xngK3NHNWWUgxVnUb
50391	payment	2132	2132	1874	1	1	2234	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTapJ7dER7Gx77kSc5UKx31RXk8g2jouDLmM3rpoYdciVu9zVA
50392	payment	2134	2134	1874	1	1	8660	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksmw3gdvu95SoC2aDa2EV7jKKAG8ee2a4sTkuatuSHxmSwhNA
50393	payment	2134	2134	1874	1	1	8661	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbv6D3jia9PJTD3mF8S8KShEZu6Re2mzYmnQJZE3oPVoJ7dNw9
50394	payment	2132	2132	1874	1	1	2235	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZssdKURYE9sQnbCrf52fyn7H18CJpKrPFag7Lw7Q9g53U98WdG
50395	payment	2132	2132	1874	1	1	2236	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2yj8HGCiZ36p5QJvXTc4NhXRRe1Z1H5Y2WQCsn2BGPhY5vckn
50396	payment	1726	1726	2433	1	1	8366	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa7njsfCdG8xiTyztMLnn6CoVTvkx1Mj4kVWYJznRJcPhTZUuc5
50397	payment	1726	1726	2434	1	1	8367	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZnt91bKLmApCZnhyagvdA5WuXP9AzjnbGvr9Fhgqs5PhqTci7w
50398	payment	2133	2133	1874	1	1	8012	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD7FnV6znyfdrgbbj7juW1Rzz42kZZARPh2JbgXratmLnEvBx2
50399	payment	2133	2133	1874	1	1	8013	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvyTh6pZBA7pY1Fh4tcNVPieY7civSx9R3NiteF6iXTDwHV3yi
50400	payment	2133	2133	1874	1	1	8014	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZYrWCbUjjaSpKagJNuqqCbLmXzgx4dGHNYwLbWevw9ZEFm2yf
50401	payment	2133	2133	1874	1	1	8015	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa33EZDwgAyaSG9aYHwzRWqwJ4pJtQxj5XE1jyj6u6Wqa7AD2jF
50402	payment	2133	2133	1874	1	1	8016	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGa3NJovFDiZ47rR6JLJqxbPyz7w2RXJvUh8XpiSLNjvn8inTe
50403	payment	2133	2133	1874	1	1	8017	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ4Qy5WbECyugm8JYBwc852qPvaHdmxSJhDzaCXoEwMkco4oFX
50404	payment	1397	1397	1678	1	1	18177	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZovVm43gewqRwZCiGSB3nnksMKhueZPF4AKtfKHfreLVvaJA6
50405	payment	1397	1397	1678	1	1	18178	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXFJEUXRxb97x9eHVB5ASyqw4itsNhE3KoNC2HYV7cadUjXnQL
50406	payment	2132	2132	1874	1	1	2237	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wt5RmRfAE7a52vNNHWbxovA3ebt56iFU2wMns5LgEMSLCb9E
50407	payment	2132	2132	1874	1	1	2238	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkt7QQAGJLyx2hjRNZJPJMACE6vrTALjcPdEXUGhAb1uj1iCK1
50408	payment	2132	2132	1874	1	1	2239	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxnQvB3UrkSi8Wbh6ACVwxJib41wnHuh4xfQqmACi65eimzLJi
50409	payment	2133	2133	1874	1	1	8018	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDCyNEcJ62KrCeowuEtLoGCxmdhZNToM13SaEeQ7toMWYH1Eau
50410	payment	2133	2133	1874	1	1	8019	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7M6UdogistG9YqsB6vCbK2MrSGFVQTDSzgeM9jZ3KPz2JV7BM
50411	payment	2133	2133	1874	1	1	8020	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdAVnsG6dZ21Q61dG2N39xwiPoYQtDdPGkd24hRxY2ZpfshnLM
50412	payment	2133	2133	1874	1	1	8021	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpn2xRBUfYR1EsKaT7QiztUGWdj6d5FhwmgjNuWE8H6qVyaW6w
50413	payment	2133	2133	1874	1	1	8022	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFFyD38KJTZrMDXF6pguQeaJHaaJJeqivPEWbtxNj6UWRBfZ6
50452	payment	1397	1397	1678	1	1	18184	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmxYMH5QGxLgW47RMB5TRgiL3h8PanJDKr5E2X38kSvFRAbiej
50453	payment	1397	1397	1678	1	1	18185	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNJ9N79zkqGhzcMroea2o9P2ENqs8HVL9PXyQc2idpAhLh6hh2
50454	payment	2133	2133	1874	1	1	8036	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxuCKi1tEri3RV3enudz9x8PiPiDMgqfBAAsK37qcCB7BLZLJD
50455	payment	2132	2132	1874	1	1	2247	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBqGCfkn56vxWAi8UVWijULrJMTAjx2z6fKPtVBrdQGtnLVWhi
50456	payment	2132	2132	1874	1	1	2248	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTLVXdXmEGDWrWqdXjsEMpdu5taTDZ7XxYKMmWVBbM4s36sV1H
50457	payment	2132	2132	1874	1	1	2249	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLnatREUiWTzRUTBta5w7cNbt6xD97LvpKwy3pHEsZFmCgeQfi
50458	payment	2134	2134	1874	1	1	8675	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkUvrepnzbRJVupJHMzXPiJQwe7YL7T6VdxJM1KmXres6hkvv3
50459	payment	2133	2133	1874	1	1	8037	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa28xMqN7yrtJBJJo4Nd8hn5oCVdkmT6KTEw6r4WLojf3BoqVDK
50460	payment	2134	2134	1874	1	1	8676	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3pRRZsVrZ2m1QNxsG87XiDnNJF3Kwe4jGHZmgFZtdFUC9nzpG
50461	payment	2134	2134	1874	1	1	8677	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nu94k2gm22f2NZLTrP1DsC5k4oKfEy7LaG618qpwNb5k2z1f
50462	payment	2133	2133	1874	1	1	8038	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8vzoYyUYMvKLe3te1tCu2kJMfah2hVFyABgu35i4mpfwtKC7a
50463	payment	2133	2133	1874	1	1	8039	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4JiRfBW6cRoKqsMkWGWot3RhMYzNP3D76UXmr8WeuYWsiWKEF
50430	payment	2134	2134	1874	1	1	8664	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwaga32NHGKy9vedYqn9KfJHjrV3A5oYgxWGm7iQJjXMWTZ8yc
50431	payment	2134	2134	1874	1	1	8665	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWAcyB3WRoojesnLS6oCgA72A8tBDCGro8V6Uh3xi1xpNcUd2M
50433	payment	1397	1397	1678	1	1	18182	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUeRN5gPWqDAGdQauBDQWQihYqDjqMvqa7USjYEu5Tkjvm75dH
50434	payment	2134	2134	1874	1	1	8666	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYqd6FYi5ieuPXsCxSRZULFYr4JxDBi84kUy3x56a3frojU87T
50435	payment	2132	2132	1874	1	1	2244	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqb4pToT5829ADoMGfpVYEkCkybokLJrP9VkvmFPxiuCUsnwBQ
50436	payment	2132	2132	1874	1	1	2245	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBr3xK7VYc6y9B5wFPpwXc9TdGKQibrepDpq9NeA5RqGijhhE8
50437	payment	2133	2133	1874	1	1	8031	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz9hoNKJDtY3MJWibWVZpzsR3vDfXRnGxN3xEqbgjF48MP1kyi
50438	payment	2133	2133	1874	1	1	8032	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqYy7s23Z8PCVYEb2G44YQUwa8U1a46MjkzJFDee4wS9xeBcg
50439	payment	2133	2133	1874	1	1	8033	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtnc9KNgqQMsAbBemtJSoXXB8MPVyrMR4CrtHCSzbWQt1yp7hF
50440	payment	2134	2134	1874	1	1	8667	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6PEtnPz49FQBsGfGGotY8eN9fvRB1MK1Rg93UKtJ6S9GfKTsR
50441	payment	2134	2134	1874	1	1	8668	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ3s8RacjH1h8tDsXqLfgxAXPZLPcnkGkiHjNVaCGrdsN1CMTo
50442	payment	2134	2134	1874	1	1	8669	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsvXtgV3QEAjHfGtZZdDyxSiwtZhjSDSDT1xJBgeJVqJvTm2TV
50490	payment	1397	1397	1678	1	1	18188	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMqiu74Ngm29uoPzESn5KEF6ut1SmnySL6YEXSxBwEg2Q7b4Sc
50491	payment	2133	2133	1874	1	1	8046	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtgVoWLBGVTRegQsxjFLgbwRFBVcntd5wY6Nk4HJvYB22HFUvb
50492	payment	2132	2132	1874	1	1	2253	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKQTg1ymPaS4KXXDwFxydhm2XAa7meP88DwcumddZann6CaNby
50493	payment	2134	2134	1874	1	1	8693	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUUkMvtnCydytuQMtkFZEHdbRY1oDtovZryv67CVgyhehg92tM
50494	payment	2132	2132	1874	1	1	2254	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxfwAZL3M6gA5hLxbWR5Tck9QAGz3gpAHAeh9MdHknhw7U8aH
50495	payment	2133	2133	1874	1	1	8047	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJQwn6GYJ4MvBVnKzrT8vuP46ya6zxYCQ4Pvrh2kZiGhukBw6
50496	payment	2133	2133	1874	1	1	8048	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDogGxtf8n1NuDtkMZwfgQRue6unD8T9PgRxvChwwqPWwkKuy9
50497	payment	2134	2134	1874	1	1	8694	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCcJLodDGESBaihcednNszi1Q8ytHZMNxTrwbo76CsM2TmvYA2
50498	payment	2134	2134	1874	1	1	8695	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYQawXmfCC6RePvMfaN8EQfewq1KiPknMQ3dk76hDxP1FD5w1y
50499	payment	2134	2134	1874	1	1	8696	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW8mfeeCszhxHNKpFJGSMF3ZUdTqbJJi6Pfr8MGQvcHg4ifEuq
50500	payment	1397	1397	1678	1	1	18189	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv1U9qQZm9iCtrjz3gDANEUWntccX8BmRJPriqUMKiWeakxsWb
50501	payment	2134	2134	1874	1	1	8697	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSxVqFmmBexN7JJz6bFPEG5RCW7EoirEKofGeygu1TFi52Hh9J
50502	payment	2134	2134	1874	1	1	8698	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ36zGbrDeABwhPGFr6H8DjtzZ6a9ZGdkSv8rZRVVpabVGBTKMd
50503	payment	2133	2133	1874	1	1	8049	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDJdCTjM3ZCHSBUSXG1jZzGrwF7s9p1F1S3pZ3EFpJ5NiZ9Rwe
50504	payment	2133	2133	1874	1	1	8050	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZbQ2MCiDPqATc7yhJrPuk1we4jSr12YRV4GmpADcxUNYFDr1
50505	payment	2132	2132	1874	1	1	2255	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZby1RoxUzjSoFHCf8B3GvT6AYS4RWRKvtQM3kGGabVTZKNCQhY
50507	payment	1397	1397	1678	1	1	18190	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTnMAnjYDbs83x79occRMuZw6p2wi5Vf1aCPnmVhengVQ3Nz4s
50508	payment	2133	2133	1874	1	1	8052	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcRCjCB1dJ1ttCgBczyykwaHzyCiKkiDrV3xXQM3BuUkrL7KDs
50509	payment	2133	2133	1874	1	1	8053	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9veCtdfPeRmNCN3Wzp2LXJYVLRdD9aPmyGPYpoGqdyLQqcSwF
50510	payment	2132	2132	1874	1	1	2256	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJsaYbgzKzuAuycoRpwDhzh4E18TeZvimNPsUskw9wUeXcrPu
50593	payment	1397	1397	1678	1	1	18199	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiYEAiVr1u8P2aMcwC84TJVDaycpKU4VZNPdxdrwEpbjCEG2Ma
50594	payment	1397	1397	1678	1	1	18200	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoAKNN5Ww6HJRYUxyjzcJC5zvhV34A3y5hS4pDZVVchUmtk63c
50595	payment	2133	2133	1874	1	1	8074	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyKmeX7qCbeiTKdRZWut9DFNcsWn1RMiwr5NMCAbE7ZaCoY7nw
50596	payment	2132	2132	1874	1	1	2269	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYrc1ant63Lxjgw1GZAzBT5mdfar56ZQ9zi15fi5PkEhaB9zV
50597	payment	2132	2132	1874	1	1	2270	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfMrQrcH1RaHW13jF7wek7rexQup1rb8AssyyvK9kEnS26KNd
50598	payment	2133	2133	1874	1	1	8075	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXD7LAjorxzcqwu9c1gCb8Av6FLb2K5LZTNE2v556kAfpizuU8
50446	payment	2132	2132	1874	1	1	2246	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29wtWrw3P8Y2suFweXMsF8zJeCpDhgoNYeMNcjeQkKk7mcXfX
50447	payment	2134	2134	1874	1	1	8670	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9kmFkG5Mj77oVu6ikejKoHEmu2LQnuubVztqAYJUtZe8xh1Az
50448	payment	2134	2134	1874	1	1	8671	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMhzZAgqdPBj3UV9q6mFVCXaXkDgQG3vrC7KUga7JFL7nP1kY
50449	payment	2134	2134	1874	1	1	8672	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LguyEKYRg4oroGrQvUFNeMQS5c6jsCHXBMxp9jyfoVYQdwng
50450	payment	2134	2134	1874	1	1	8673	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYXJEpFhMkPfDU62JwPX4QSkuMMkveW4hUEqqRHCdkiQ81mhGs
50451	payment	2134	2134	1874	1	1	8674	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUqcvd7VM3Mz4GtMfnCXRaA68oF7ftJCqvtVLnqWKWBv1M6mgJ
50471	payment	1397	1397	1678	1	1	18186	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbosXzwjAafSvrFQU6cD4Dv8vCav2G3HYRaiAsJnJwRQFQwHH3
50472	payment	2134	2134	1874	1	1	8684	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmh9gEmoVR4tu2E4A5p4mL89GoREjJr1QdCZJhpHWzmBRoA3bn
50473	payment	2132	2132	1874	1	1	2250	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDRMAgdNZW9CwM7ERqnaHGZEFnRnu8Auvsa49GbLXRBk21eU2w
50474	payment	2134	2134	1874	1	1	8685	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdVDzwFcZYHqohSLaYt6xrWMrpEHG5NjitArgtMwZ1SUQXELDv
50475	payment	2134	2134	1874	1	1	8686	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYv8JxaSCDULqEaERMvhYUCEerQYWfbauGUdBunsupJU4MUo5n6
50476	payment	2133	2133	1874	1	1	8041	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1u9cJRTqzjdgqDBkXeLdEuRScySDPasy4VWMdwAyTTEBM4ehG
50477	payment	2133	2133	1874	1	1	8042	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo2Sf8faKp8cypNHM7tAQqYe3pj6BeyKyBEDc8rsuHKZumw74X
50478	payment	2134	2134	1874	1	1	8687	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YpsTLd14pzjagVwsVxUhdM6P67SgmijfsrzfTf6EsqSisb5b
50479	payment	2132	2132	1874	1	1	2251	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLedvmQVoAkAGSse3hdEAaXGQSTDqJvdGH8AsiGMPGS3fuZY7M
50506	payment	2133	2133	1874	1	1	8051	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvybVb3eqLtW8ccMouxCjSqLBcdKpYY7F7FmSyhahmVxF3v17
50533	payment	2134	2134	1874	1	1	8712	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqmnFyNQ8CaXYYFms8meZr31X1LiZMpVvcKXq4vVwCpqMoTYBo
50534	payment	2134	2134	1874	1	1	8713	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmAhZoN8qpWymbwMuH1WQwzvSEcpa3cjJEZepo22nTmECyjJvJ
50641	payment	1397	1397	1678	1	1	18204	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsuTAESWkbvRmyHGTA7pGXu6rogYD2swWuD1Szm9Y98EtYMLnm
50642	payment	1397	1397	1678	1	1	18205	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuf4P2x1Rt3Z2HDt2TXZee499fiNzNVfYLS21gEMxmreQc7T3E
50643	payment	2132	2132	1874	1	1	2277	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhjrvT4tTE2z5EggxWn39u5xsR3Zf6bLqouarsPBkTpjoDYS1R
50644	payment	2134	2134	1874	1	1	8763	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2iWDQ2K2y2Hiz8W1b6maBb5MisQr3yGGYD6p6khB9pWYZwS62
50645	payment	2134	2134	1874	1	1	8764	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaFSeHA3o3mAwo52tzmFYd2Se6qu8G7U6oSkhaJzbtdbVvRn4C
50646	payment	2134	2134	1874	1	1	8765	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2JHp8GGY56iZ4PhjVicFA1kn3wFU7iZUJP9hkRgZC3gcqmjdc
50647	payment	2132	2132	1874	1	1	2278	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4QkgyLoikwHpwkZGJowdf8nKmbGdSWRyzy1kXENmzNicXgKff
50648	payment	2134	2134	1874	1	1	8766	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUiNnr1R6DKKkn3bo3qFxtFK7FLZLLdpwPoFxxsMxSLoez87KB
50649	payment	2134	2134	1874	1	1	8767	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmDqkxEvJWbV6BRr1apoJJ51qr1ofSbGfGED2fd8de9QBEnWB7
50650	payment	2134	2134	1874	1	1	8768	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgzT2PCb2SXPdLCwTFgRmNgkhngjmRnCdH9fYJvEEFBp7Cn2Y
50651	payment	2133	2133	1874	1	1	8087	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZofy7ThUeV6QwYp5toppbwMEDU7LYSKGveVwiWzpFBXA6d6pHr
50652	payment	2133	2133	1874	1	1	8088	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFMUoJAg7K9s5RZic7fJ4WeYjT6oWwK4Q8YNGBzEw1oKjYgzNt
50653	payment	2133	2133	1874	1	1	8089	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbUFYyUJoYcRqettwACbjAzZTVpQ2GGasV6dc13YW1H9vtdZha
50654	payment	2133	2133	1874	1	1	8090	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV9qg4mrfxN1i99dQnaNwaK8n7RRsiXhrBWY3ngKh24XtaMm8R
50655	payment	2133	2133	1874	1	1	8091	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjEkr12UPATcRrbZ4Qi8AF5LtMZwuRPiTqdFUPWe8Rb8jhWCvG
50656	payment	2132	2132	1874	1	1	2279	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuLuvEBKpJ3YMSqibbq6AobwhWXV71E89LiMCJ5o4nvEsdipNZ
50657	payment	2134	2134	1874	1	1	8769	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZucMiZc6KR8gM5Ba4NSADoUkK4FbJA1xwXcZxhgTbdoLJiKKJv
50658	payment	2134	2134	1874	1	1	8770	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPYj1CKtLVqWEzwnifwshFcRCQVZEcJrK8gKPBW6qRA2jfGAku
50659	payment	2134	2134	1874	1	1	8771	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJd2urdvJ8mZChmskTbWE5CEpc2xnn5JqRmUkxuiX9BiXQh9Pz
50679	payment	1397	1397	1678	1	1	18208	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdY2qvLDSHVhhQifs4jcN1H4RjyjsWD7KCJu5UKCEf8wPcqZ1x
50464	payment	2133	2133	1874	1	1	8040	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBkP7C3xGgWju2TKhpJotALYG215ApEtudcB5HV6BrAYiCwGQA
50465	payment	2134	2134	1874	1	1	8678	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaChhjCAzKQn7Kr5Bw4nfHtyBdTwaTCXhv7wUjqSUssx2ziKkEC
50466	payment	2134	2134	1874	1	1	8679	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRfW6haFRLHawp3VHdAit2V5YoCLEBR3jKkcCYDVUfkP3e9B9q
50467	payment	2134	2134	1874	1	1	8680	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqSxitgTQyGVXrbLLDqVLFcbearVZhJxQyAP1UEScUVcNoi4ZX
50468	payment	2134	2134	1874	1	1	8681	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ73yPK1oMakzBPBfa91iKjz5yma1K8txjHNN1xjpSwWbMtZfta
50469	payment	2134	2134	1874	1	1	8682	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJBnxP5MDLGbRcS994K4CYB2r2swRobe8QnbU7MWTBGcrHtyn
50470	payment	2134	2134	1874	1	1	8683	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMfqBfKLSwjPNrYqF2xZGHLhfyY8ZvRC3eDAhyJAJGhG65oYif
50535	payment	1397	1397	1678	1	1	18193	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzYWGgXkEHpfuJHfWvJzGZnjmi5UT8bGebVjfUQQW82tZEuNU
50536	payment	2134	2134	1874	1	1	8714	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnhrBVNXe5x5arxC2ig89tsXrTaUMRyLS2zGifzoMPQYJn3z8Y
50537	payment	2133	2133	1874	1	1	8058	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFuQ1UbkW86BaRTuCt9Be7ERtVcVEqHtWa9dtimyRCLGGFg2TS
50538	payment	2132	2132	1874	1	1	2260	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagT5Cwy6dUdPF5adgbxpt6PK6maHE6kBGShum3KByi5szckf5
50539	payment	2133	2133	1874	1	1	8059	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkwdhi1Zsb3i8bd3SDnu2AREnDMvhKwYDKYhPVGJcdvNzTq4Bj
50540	payment	2133	2133	1874	1	1	8060	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt326f5D3euKh7nhLJyKUSJizFkUr8x3VMzH2rwHsT2DLrCzLH
50541	payment	2132	2132	1874	1	1	2261	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8dQ3Qe8yzC56ewXcPHgeYnHEKedmCB9iM2XWctMmC8YvwQsKP
50542	payment	2134	2134	1874	1	1	8715	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEopYzRLVVwpL8rUBTD89ZFHbZT2RfKwZsWxX5dMPKueQQ6pmB
50543	payment	2134	2134	1874	1	1	8716	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgd12mV2PtDCjsQm4b3ZeuCmWFKRPrL3PRNChDKxJLmV1EKVBb
50544	payment	2134	2134	1874	1	1	8717	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfLJPeKwsurpkZVXBJ4fKMf5uk7RHFAJqLwGTHt1vENJmtuR7p
50545	payment	2134	2134	1874	1	1	8718	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZosjePKcsSFxZgHANR2jZZrHsCni4efG69WRUD8gxx53BbdSeP
50546	payment	1397	1397	1678	1	1	18194	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1m2pnMpEPt8GxrBodghcU72tMofKJEB6npVsssVbESydiapoM
50547	payment	2133	2133	1874	1	1	8061	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkJ9mFnxHhLa93bjQ7yX6Y7WZvPeYJDFKriN3DnADVAikZN2n5
50548	payment	2134	2134	1874	1	1	8719	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsw2nJpk75H4qXGWaSHjam18945km1fNBChvtu9e4vEVjdAVP
50549	payment	2132	2132	1874	1	1	2262	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6CvqaktFhRsCAnJySMThbJLKc5wzJXxrFLue4W6mb9jJbuacK
50550	payment	2134	2134	1874	1	1	8720	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8a54pYZgQ5FZtpGvf2Nywxc3xDWgWQiFEES1cKPaHqge3bnbV
50551	payment	2134	2134	1874	1	1	8721	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMgaDBwnPwD5x8tSNuUtBMLFa1Vvj5TESGbhjTySzHVbebQcd
50552	payment	2134	2134	1874	1	1	8722	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmwcFYVKWbfwGMUyTJJN1Fe1UJvJRzBNjtEgMBZdMNKEpNRQdj
50553	payment	2133	2133	1874	1	1	8062	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHJQsD3rNjjPsyHg189M4xPrU4ecaiQADSyRups2Tw1S5zPPi3
50554	payment	2133	2133	1874	1	1	8063	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVntzzr9jT3ouZhdDQ8hfXsngEiCaFfqp61zdoruFKJXeyPB47
50612	payment	1397	1397	1678	1	1	18201	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvWxeQjfNDY8fTTbKb1Yzambnq5cL6t1f4YZrT7idGPdXTxTJ
50613	payment	2134	2134	1874	1	1	8750	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZME1X1qfzAimDmvKYXDmxNcNMaydifz9T58VKD3miuYKKBzxok
50614	payment	2133	2133	1874	1	1	8079	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNkwhQuzPuJxQkrttBiAgykkvmyjwoVcBQLd8jUWSFrFaypMbQ
50615	payment	2133	2133	1874	1	1	8080	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPUwyMDULzWQDb9gzvcVxLJhnbpHKvMzziqtrmR54YQA2na9UT
50616	payment	2133	2133	1874	1	1	8081	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSG4PV4ob6zZwoiUNjRt2bdMpn1BSU1zcCw6ecyg1XyWTHNzHR
50617	payment	2132	2132	1874	1	1	2272	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJ1DsE3tzkXoB59RwmWDuud2yNREkcEexbjgJxpZoBVxj4Tv7
50618	payment	2134	2134	1874	1	1	8751	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnhGnNmBd95wjmLVXCfyLxTUfHyBZWY358K7xFWRLRz5pr2iiA
50619	payment	2134	2134	1874	1	1	8752	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedpLFrNzKQyzbRMFh3erhpVLvgrzNvoW79d59aAfNFLw4zmgs
50620	payment	2134	2134	1874	1	1	8753	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfgpsvVDoLM74YuG7u2M2oqJTYe1ZyBhbPzMYAvrQAGfa8AgfV
50621	payment	2132	2132	1874	1	1	2273	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxgPsYsWYuGdiGCE75SS18xADa92KK3sP2WykCwC3tAYMpZXi2
50660	payment	1397	1397	1678	1	1	18206	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Re2FwqMRZN8nT8bK8s6QWC6J2DG8mk1dLX6BCH82mQVQRNN7
50521	payment	2134	2134	1874	1	1	8700	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh4jfH9rYU9Wh3M2WRPjjnnWE22hK8HTbqxYZD8jUzJyZbLS4q
50522	payment	2134	2134	1874	1	1	8701	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm58ZeaMBMgMg5RMuW3N4NyTVCDRTxyBGMRVG5gSjDohM2ViyD
50523	payment	2134	2134	1874	1	1	8702	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFU1zr2S8nkZaEpknQhUwRXreF1iZe1Aswm4fn3jmc1JQy8c9t
50524	payment	2134	2134	1874	1	1	8703	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFUwTKyL8ujHa8eGGyCnqsPoPihaNPAdvqLajCNpjbC4mFpJE7
50525	payment	2134	2134	1874	1	1	8704	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSADD8DAzktWbSsBENETc8QKRwCpPp8TxZSjKVmMwYjnz5bYNS
50526	payment	2134	2134	1874	1	1	8705	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfv3UrrKJF3BjTY4RR1qsCsZXvfUear5ydU1nrzRS1JpWUtDLx
50527	payment	2134	2134	1874	1	1	8706	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa396YVMq7wchdJkBJo6FYA8zExEhpsnmmXeMHKche2yUCF2bF6
50528	payment	2134	2134	1874	1	1	8707	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzHQcqfXyd4bzWgp7xhmgj15uRjes1LFZNJvuPtasSR2Sb15p
50529	payment	2134	2134	1874	1	1	8708	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgNrxqQEFPqwVRNc5MgFPzhfxfyQLYTf82Nz6jN1eH9NyxYQb5
50530	payment	2134	2134	1874	1	1	8709	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfZgX9MPdHNyEWZcnPi8vKdyKZ7AM6fTnv5UswbFHzfWWDutu5
50531	payment	2134	2134	1874	1	1	8710	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu1X1N6RFjTqT949G1Vd14iq7MG166ncp5B31Li4EqjFbih89o
50532	payment	2134	2134	1874	1	1	8711	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEy3C3711Nf2LZ9D3qHdbdzJucJNHsz5XuC7hM63j9W8NvHh9v
50555	payment	1397	1397	1678	1	1	18195	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK6mHXJBRvLJ4aGQy25wrUUvgQq1FhyAvpLckTqbG4wd9BLfmm
50556	payment	1397	1397	1678	1	1	18196	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxVRAMqEkfGM6Jg3vGo3Er9sDqUFCj7FgBfHisB5TTYMHsJazc
50557	payment	2133	2133	1874	1	1	8064	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQK71WrcCdw8GDZWUoXqAnwFtRjcMMLygLdEYxkPpNp1qeUzfD
50558	payment	2133	2133	1874	1	1	8065	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2tmt6SWM66utG3LvvfQu3NQR9RM7tAUisQXwPJUhpcGc2k5E
50559	payment	2133	2133	1874	1	1	8066	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrFMnMMqM2QMQjpyZ6H4PMEdfjiyZ4wugxLeRu3MTaTeqkfHSb
50560	payment	2134	2134	1874	1	1	8723	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1r9uEesgLkZNwYEViLXqjMBcwuNd2ZDB6fthKC4j7U1GmeQhQ
50561	payment	2134	2134	1874	1	1	8724	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJuVAQk9bsRL29LDoYwHVP2j62tZpuueetp3Ma7DMAKYBkBVvo
50562	payment	2134	2134	1874	1	1	8725	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVNPW6buWafymttfn3ErM2DgGS6G4vdiswVExiFuBLZAnPkWyp
50563	payment	2134	2134	1874	1	1	8726	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhzhitRK9e83adKFyQNesU2tPLr4ZJhyBRxtR9rTj5ewhgPEvA
50564	payment	2132	2132	1874	1	1	2263	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqrBRk355VWeSHWDnXDKf1UnURzU35jK1acTh3KgU3XTPPEorx
50565	payment	2132	2132	1874	1	1	2264	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvDaHYzyzsPkuCMCtZgZ9f4ajQThVYRqLmzcZhVifmX2zN3Kb9
50566	payment	2132	2132	1874	1	1	2265	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdK3uzu88DcFCTQnWWe4N8hDiTQeYKjcGzpX2mfaTq3BpA6adr
50567	payment	2134	2134	1874	1	1	8727	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs2D9RE5CqApLAwjgm7KzT3bRnc9DBDW6NKn6yMig9WACvrhkv
50568	payment	2134	2134	1874	1	1	8728	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszaqHmHadNcYyyP4y7hoC1q1fdgJjAKtLCQp5cthnQU33Xxyy
50569	payment	2134	2134	1874	1	1	8729	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuDCZsgV41cSyogayxbR3yN4ZC2QbJAJYNfg4ALaR45WLGQBn1
50570	payment	2134	2134	1874	1	1	8730	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrtEivMUFW6LTHt9hWHUX44Raakx6G6hm4zhGC8LNtMzqKQkyi
50571	payment	2134	2134	1874	1	1	8731	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFX9WxpfGLnWaQGTtQPbnm7B755tMX3jPG8Sj2KZJYBvTLq237
50572	payment	2133	2133	1874	1	1	8067	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bxhgAC6DZapWXL1whqYe6ALDxxRW43Hv62HepV54QLR7L17U
50573	payment	1397	1397	1678	1	1	18197	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw73qbXdw2og5g8Bs7zwykLYGEayVVLPkgJspXMf8yiQ4nU2ux
50574	payment	1397	1397	1678	1	1	18198	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh5aZbgZa8WV5iB6TncrpjikMSsc4S622DCwRosSKHQPXZaJtb
50575	payment	2134	2134	1874	1	1	8732	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHn4ExUCPkE8qBABBDtVGQQWWERzkaoNUki3Uouf2PSdkMNJBv
50576	payment	2133	2133	1874	1	1	8068	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKBn3RBpjQdwaTduDorC8EA4a7C8ki3nMMP8AoR37Fh7evR3j2
50577	payment	2133	2133	1874	1	1	8069	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ58cjnQMamgZFJhVVY8wn7QE4JZeYZf89QMvYzFxEcZqfknEi
50578	payment	2132	2132	1874	1	1	2266	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT986LMg4uWGAjyMceZtaTHvofn6DhorKTsarJRy4FihRsJbLb
50579	payment	2133	2133	1874	1	1	8070	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxzPqXdqWGyhtRnT2TvNM842uVorcXgf4ytXUzu1G68RxAkDrm
50580	payment	2133	2133	1874	1	1	8071	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZEoZoBGN7fmHkZ6PKLbjnesGsRrKtaR1LjavVzanWLka3W5GJ
50581	payment	2133	2133	1874	1	1	8072	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNm9wM19jC2df69b6pqFPqQUG8iS17jhComnZC9FVNLkCdog7D
50582	payment	2133	2133	1874	1	1	8073	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPmgLpngLUR2W1FscHxvdohDcedxr73iVtC6gBx1BbMD7BRJ9w
50583	payment	2132	2132	1874	1	1	2267	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz8b8o2HuxruVHAfhPsMNH6JW3ctW3ozy5GvXW8RiubWAi5PLh
50584	payment	2132	2132	1874	1	1	2268	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgq4WGc41poUKoYjTnaSgtPka3aJUXUBuA8rRHPTnAx9u5ie1f
50585	payment	2134	2134	1874	1	1	8733	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzrfYpJRbeYpQ3WPVbJacBRjD8K8DnQQsRowoTRbDMDhUHvbVV
50586	payment	2134	2134	1874	1	1	8734	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbri5jSA2KkqkcCy52c1Xs2MgWWM7TXkpxG7dBBsPsPFLwqQp
50587	payment	2134	2134	1874	1	1	8735	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3gLfeDPkaMFP628hQPg9dVRV8baveimBCjyEi9FdBWUZtYA5d
50588	payment	2134	2134	1874	1	1	8736	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrMKfH9BapQCmtjgnhE6WHaVbGSBPvN6rdQtMUpxaC8xtHKbnW
50589	payment	2134	2134	1874	1	1	8737	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqC4zaWThkMT94D7C8F2jdGXS2ordCVAUFfY3QG4Kd7BEdPffg
50590	payment	2134	2134	1874	1	1	8738	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqAG6jLuuaDbYo7BrfB7UyeDMs87PXW8HMuBXHHAMEqXyGUHT4
50591	payment	2134	2134	1874	1	1	8739	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYafvhVzRwb76jVqXxGCtdzsZGqgAViU1AVvvt8s6KiXZJH6zto
50592	payment	2134	2134	1874	1	1	8740	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDjnYvBq7BLgcnUpZDY9JSBc3hFi27PhkTAi7TNmAQrqCtkZG8
50622	payment	1397	1397	1678	1	1	18202	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYonaD2NgvQxvT1WP3bKsdRDnNxiQXrJC7VXPDTuaWf5YpowQvn
50623	payment	1397	1397	1678	1	1	18203	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzvNeAbHrJrqiXjaXHbQ3kBZ2n4QnxY841CtwNGPLiTRPvCFKh
50624	payment	2134	2134	1874	1	1	8754	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfhHRBmed8Les6PoqAkCZ87Cvx5778bZm4pYy9YZCbw9j3eniM
50625	payment	2133	2133	1874	1	1	8082	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsXAW468oSjML1toNSMkXtmf8J1Na6VDymsaYphh1bb2eQqWKv
50626	payment	2133	2133	1874	1	1	8083	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7ZKgLyUV4LMCEuPfV1ZY7ufPjJYXg1qNTcHBY7SiuhzLMYk3p
50627	payment	2133	2133	1874	1	1	8084	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx1PbXYZmDQvwpdUaG69F3n8bxCDYwjDiZGsUJ3xLYDeWgXhCA
50628	payment	2132	2132	1874	1	1	2274	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdCqVRxbQpSDukUk2KTLbtDFX8hLJCBV1RZTbxFD585uLFeRE
50629	payment	2132	2132	1874	1	1	2275	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ77JTXQATshoqW5r1QZRkxj7iTnZoGjGaVw5YDfVeAoVjTFve9
50630	payment	2132	2132	1874	1	1	2276	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbsUa1tKACZbFKF5nJeLjJ8ukGeaJP9PsVfRCkW1B6gtSRZfVY
50631	payment	2133	2133	1874	1	1	8085	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XmbcZP9My9VhrGRsf1hSLDy6ES6Ba5YvD68SbQbvHjX172ae
50632	payment	2133	2133	1874	1	1	8086	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMH4zvzv8G12h7yqFbP4pzB1TjqwyU8WyTWRAsviT2TicxUwLG
50633	payment	2134	2134	1874	1	1	8755	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFSEAKQ9RZ3BamibvRQShTRxyE9q1Tf7MrZegqENe3fM3K36WR
50634	payment	2134	2134	1874	1	1	8756	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf2ry7nhr3ke54HpoS3De4R9pM3Zh9FWr4BBq1dBjaTvc1aRYR
50635	payment	2134	2134	1874	1	1	8757	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp3VxDjjW4HDCfaaq14VyP2fYwvQwRManHEXqyysDipZygGrDM
50636	payment	2134	2134	1874	1	1	8758	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrRcZxskgWaaSB2mboctp1sGRDFtWzEo2DcMWs8S3RcumyHsCU
50637	payment	2134	2134	1874	1	1	8759	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4Xd8YthixwzVJsmAdprP5K866BCb6GsHdZujaLrCEdjSNvyjr
50638	payment	2134	2134	1874	1	1	8760	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF3RmZGbqUKiaEXadpAb5KUvm4arpFM7KTCmfUB9iYo7NRVZPs
50639	payment	2134	2134	1874	1	1	8761	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaLAaduegW4NSLsjYQFAfc7BsG3VDu8JHDWyjVsJekUH5DtGf
50640	payment	2134	2134	1874	1	1	8762	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj5s9e5WGYgntbnCyzKUBSnKBkNFiXb48BcWk3tp17aLwwTe6R
50669	payment	1397	1397	1678	1	1	18207	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZ3RGoHKqCKFbGBk4cYBzeJhLbDBFCyR6FT3YiXYWVQ73MPTi
50670	payment	2134	2134	1874	1	1	8777	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeSQks7JjDyXeabXV9L6YweXpxWP6tWzs1DTJc984yugiZMg5
50671	payment	2134	2134	1874	1	1	8778	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm17DTiX7cxfb6TgX8TqznU2UCWJFJuDKeuaZc6wLLDc6Kbxim
50672	payment	2134	2134	1874	1	1	8779	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYouweePh7GCRFAsmGwR1yT4hCaT8XSBZpYCwFLXP7SqX8EFX1q
50673	payment	2133	2133	1874	1	1	8094	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuHxUoSgdte2zxsgN5sfcRkEwCbVHddfnNntCJzJx32evbEbFH
50674	payment	2133	2133	1874	1	1	8095	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7V9ABDvhGQNQ7cS2Zq7kmvGoxkMsSmdwYKJCmQnyvSYVorvwg
50675	payment	2133	2133	1874	1	1	8096	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYimtwMgfUMBA8Ja41QGXjUJ8885S6qxzf1QG7NVDmemGj6zDR8
50599	payment	2134	2134	1874	1	1	8741	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsjU7ufFJeSAQig5zhhs5WXX8W3jRTCvFRtozZd76eJLyprbSv
50600	payment	2134	2134	1874	1	1	8742	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZULPb2tJhDGtDo2PLMUNSF8SXmt1Z7c5vGPTDPXg4TUmjN8Yio
50601	payment	2134	2134	1874	1	1	8743	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZKrZAYTFYBCDRKyMdQt8em4q5yCKSupwHcMsdtigPTy1VQ9qo
50602	payment	2134	2134	1874	1	1	8744	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHtQVkSB5ivou5JqUUn7nH1aKzuVUtoH526Wt6DUMfFV7pcmx
50603	payment	2134	2134	1874	1	1	8745	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuMLAkdSc5kCMJZ9QnYcq7tVxzTrtLjU6JmZfeyBxzpjKthH8
50604	payment	2134	2134	1874	1	1	8746	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYN97YdumyYLHqa5oKrvRS29RacQHQHz6GwQr87WdRqQzZnBV4
50605	payment	2134	2134	1874	1	1	8747	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfMtYcV8fNdnndHXnpPbC9JaX5RJo3HH7P8gquXuBCiX3sJQH
50606	payment	2134	2134	1874	1	1	8748	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpEj3kBZdjb7uCjmqo5q5T7c3DWwV7YqiS2NNwHGV8hJLAAgfJ
50607	payment	2134	2134	1874	1	1	8749	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMaWtTcv3trPV9TTbtj5qsCHbQ3Dx336YxcfdXqqMd7XTeLYPp
50608	payment	2132	2132	1874	1	1	2271	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJacXQ5vvgBXeMgwhDeeXMMAAg6HvX5xwo7XDvdM1nDvq2nxSb
50609	payment	2133	2133	1874	1	1	8076	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYz9xajLQrA5NGzSyjFftSCmmzNAQL7exadsgrBnkJwF34v6S
50610	payment	2133	2133	1874	1	1	8077	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTfj9oEAzS21nJz8ntxFMrvmS4vWsFjxaS6FZPtQwaNqYWb6gn
50611	payment	2133	2133	1874	1	1	8078	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYygf7AYX29gqMg4nzmf8zeeAGKUDT2boQYuh5cdttscXuCTgue
50743	payment	1397	1397	1678	1	1	18215	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCRoSRSgLhPpU2PJB4HR6tK2GabkhSzoAuyBLsbmYcEirWrvz
50744	payment	1397	1397	1678	1	1	18216	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDMHCJ46BkP1qq5C9EKHCwkYepkouZgenCoJLANTiSEnreNGKs
50745	payment	2133	2133	1874	1	1	8113	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmmGhKLvdQZ4taAcB5ngr4b9u3crAM6TfcRkt7aeeJWcohEHHy
50746	payment	2132	2132	1874	1	1	2293	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZop6KSW5nqFY2tXxytniBWkwvyDoRcNPGEqrV6qxTXUkLSGTHs
50747	payment	2132	2132	1874	1	1	2294	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdV3XVf78ZvSzzyjM4JhKnafdj65bsowrVixs2ZCqW1L7LxQZ8
50748	payment	2132	2132	1874	1	1	2295	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEMw3bbckADCmGqF7t19g79Kn5vBUfmMkEwRvCenUhkRXay45r
50749	payment	2133	2133	1874	1	1	8114	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKSMvhURH4inTg1awfvQpE4YHxmQCsntHVj3ddLq3ae1eKosPE
50750	payment	2133	2133	1874	1	1	8115	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUjc4nrc4K2avmdgVEnhEJkyfZEnA6jRH7fP5KdLAHBWtkNeKT
50751	payment	2133	2133	1874	1	1	8116	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZo7fYGKBDfaiJYKZsBui8fSxdT8piPVczUbfqLGBBcYFNuBWir
50752	payment	2133	2133	1874	1	1	8117	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbpRmESNd85Zhq2K1MqXQ5HLns96aPfztvke2T4VuGv8wr9VZ5
50753	payment	2133	2133	1874	1	1	8118	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvwmSyVWCWFn4fJJP5X6zPH7pp7LSSsKtuRyTgmJNSSqgHw7GC
50754	payment	2134	2134	1874	1	1	8812	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8Tz8tWVps8mZABbMUhDzCj1DcXhK6ZXFrdkp8cvq5iPHGWKa
50755	payment	2134	2134	1874	1	1	8813	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZowD4r532ph8Viki9BftC5kD95MtUZMVyBxsbvhDt898kqKCKs
50756	payment	2134	2134	1874	1	1	8814	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNjFEAYotysdCn3ZXoSehmBDUfgzeZ6T7VLhvHqyF4zCqEPAhF
50757	payment	2134	2134	1874	1	1	8815	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWUrWuy7ruAbW7cjhVWbkhht9KxVLqUn95T56nQC8CMaDxEHuS
50758	payment	2134	2134	1874	1	1	8816	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBnNrCXToD6BrAEKBFuFWmnip4pokeP9qwP6H766qCC35xnYve
50759	payment	2134	2134	1874	1	1	8817	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXx7pmR74gaRNiLFk4PG7fZCm6NnCcBcTvJHy27cnKkwg14hE
50760	payment	2134	2134	1874	1	1	8818	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZU5qdUuNsBYjohESj7XQNtjEtF5QgPkB4jQ4fkhtgj4SGLT9PG
50761	payment	2134	2134	1874	1	1	8819	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaGjyNTMjDHZZp2Vcz7jBipmV2YAUKzSZL81DoUeMRcxz7SaKB
50762	payment	2134	2134	1874	1	1	8820	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeqMs57MLg22P8erA9xYyzHhrkXJZQNhhMXiY4iWV3XqbvozzC
50782	payment	1397	1397	1678	1	1	18219	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6K13pUCHGvgKERcijV1veW8gpFPQ8wWimvScXryqMazQS6LJF
50783	payment	1397	1397	1678	1	1	18220	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGEHiSz2VF7P9WAS2MeygWNVUoPVR8wToV1REnf6a6Srv1awax
50784	payment	1397	1397	1678	1	1	18221	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBt34t7DSWdExDkw7Mez6HJuavajw2X2M8fktkHy7eAGbWoc5R
50785	payment	2132	2132	1874	1	1	2299	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGNwWys2QKa7htQyXBRpD9Pw8hXuZ3pdr73biihiG8FUzHjdAV
50786	payment	2134	2134	1874	1	1	8830	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWMokzGYFXvAnWXUECR1MTZNuKEfmAmFU5VkGHu6pqCJPjwVo
50661	payment	2132	2132	1874	1	1	2280	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEMaSsXwJrc3K4ko8HEsnuhxXJn8K552EQpx66ZsHMEQTBbTV
50662	payment	2134	2134	1874	1	1	8772	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwcWZpZVANSjigEAYfdQ5wx2TcEzBHZQcQoG8Myp33iftWmWTe
50663	payment	2134	2134	1874	1	1	8773	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBpnBqcmBKgAbUUur4dWyna1edNmCU5AW2PefcDqmFYFvqCNq
50664	payment	2133	2133	1874	1	1	8092	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6LbYrrVS8ioeSFmSFboroxShCGtNoKKsMEteWBSNoRohRDQD1
50665	payment	2133	2133	1874	1	1	8093	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiZE2obQTq5A49bvTTfe5Zh1tkCTiif4ZF7bey19bxoRT1rJ18
50666	payment	2134	2134	1874	1	1	8774	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuxPijQ4MeQ2WyNxbVvS76AsUUzAzgR4MvBWnG2jSQhnmp7JCf
50667	payment	2134	2134	1874	1	1	8775	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ9cJzNUdiDkVX8fGBUp8SM2S21cJSJL7ZYW5YZx3mFV1seKJr
50668	payment	2134	2134	1874	1	1	8776	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZ8yw8egCHrGxczhfN8HsVSdBrzE3U8WBcgpJ5uAfzK9ULf4K
50688	payment	1397	1397	1678	1	1	18209	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3eRqSCfVQtNBAPZeq6gVfsDRuwEqkMkiMRYcY6zUHo8jddPn5
50689	payment	2134	2134	1874	1	1	8786	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYgNYbUQfD5rde59oocjz2jihPUJmpEzV3WSNtMr88V52ammJC
50690	payment	2134	2134	1874	1	1	8787	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL9MMRP5XtZ5hmPcBdhjUAUtMH9wbuX5PS6sbg1tULa1E2Kca8
50691	payment	2133	2133	1874	1	1	8099	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tBpwz6FRHyFZBs8iVg7CCrwDTZmdQjsHyHCbPdKtXEmQTa82
50692	payment	2133	2133	1874	1	1	8100	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU2LAi9ViLh1331x8BZCemSy5mZzqbsdZbzcbTKJ7sCfnN2MqK
50693	payment	2132	2132	1874	1	1	2284	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJHtbbn29wd3Sro1DABkW3EyuFZVJMtGeAe6i9eAKbpZj8mZom
50694	payment	2134	2134	1874	1	1	8788	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLB2YFcwadSsU4NC6SBDz3PjqdiG7WHDPT83ZHaVbi7A9EZSk
50695	payment	2134	2134	1874	1	1	8789	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeyoC6AVBuiTuaMD6aDf4aTvAyZ9Xzdm7QX6PivU24GKK3JFX3
50952	payment	1992	1992	596	1	1	6	2160000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhks3GdPaQTLq47vxX9yYJnc1wahqCdG3b2txP4yMLuqKypbfX
50953	payment	1397	1397	1678	1	1	18237	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK39bzC2fMqWJwqhSP4frDmaHf2J1vcX2H8ue4HnHjPRqp2iZu
50954	payment	1397	1397	1678	1	1	18238	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQD2sjYDJMDwDaZ5yTBT4KAuGkWwhkHX8zZD87aoWRfPeUwevr
50955	payment	2134	2134	1874	1	1	8909	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcH39bqCRVt5GdCLXqFjgDDYwsCfY3bds6t43bPQPR6gpq4cr8
50956	payment	2134	2134	1874	1	1	8910	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QKShQ6hacx8EQsHWsfM7Ky8Kkwrt836ARALUFhicrwEcGDwu
50957	payment	2134	2134	1874	1	1	8911	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHMHzLWNZQLerwP3Nqf8KGcvTBvu6AbYgmTugqNBWg8xBwUyY
50958	payment	2134	2134	1874	1	1	8912	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYu9wF3tX4GrxorjKQuZrt6U9fVXXRCJt4eox5Hwepnog3S44bw
50959	payment	2132	2132	1874	1	1	2325	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtPa2kuvJfnT4avZLdHzMsGMvrwqZTvuRUfJgUhG3jbLnDCKuw
50960	payment	2133	2133	1874	1	1	8169	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuPhUosk5HspMibHwrs8vDh2Arg4KfXVg3qxgz6ZvHWBw1XfNf
50961	payment	2133	2133	1874	1	1	8170	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTJD97h1zRhgbDxyEKyR5QG1syPXbrkjwoFUzWg7peaYhh7fR
50962	payment	2133	2133	1874	1	1	8171	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtX9toYgTp25F7Mz4Z92ysdonZtChJmVM5oU2A5WRdaZPKGvfG
50963	payment	2133	2133	1874	1	1	8172	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkiWLR5DLsoSJqFyVh346d3otWCKPmcQLjhADowZtB4Qhwfkwb
50964	payment	1726	1726	355	1	1	8370	100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZwyzEvk9kKfQiWWpcMxzRChgQ83opV6AyzhwfSpjwdHLfbp7PR
50965	payment	2133	2133	1874	1	1	8173	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZygy8ZCN8bNcVMCqnBpAjvij5MK33LGx3gbSAikAP1jexdy23p
50966	payment	2133	2133	1874	1	1	8174	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2YUtzDaVAdAK4Eab1dMYu9MimffHrxbqJK2qNuiwJWpfcaXuh
50967	payment	2134	2134	1874	1	1	8913	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAXyz7GaTEsQkeDdTeLnoZqWj5k9eXyKis53t3zjFmErXLuTf5
50968	payment	2134	2134	1874	1	1	8914	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnEFqKhESM553tw2hWvuCCMYP819tUXfDL68PfMByCWuGn1hEn
50969	payment	2134	2134	1874	1	1	8915	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgFfnnfSdQvmSGegByQbxef7R69iWvutTZt4ccatxDEgHzW4Ya
50970	payment	2134	2134	1874	1	1	8916	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsz7pdPgh6jkXMJEdXsLp5PEgbT4oejNrjTmoBZRVKUvhAHe13
50971	payment	2134	2134	1874	1	1	8917	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWqznPEK35FPmqsgVSp1YZW8gkMgjJWkc5mkGMXEFsH3W6BeR7
50972	payment	2132	2132	1874	1	1	2326	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBgbBH8AMm57AK5QVSURehRY27358qAfcoVrBnvuR1hPjQAcNr
50973	payment	2132	2132	1874	1	1	2327	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk5sCpe4CDSBpyDJwvja5BicHjoZRrwHq8j642jKn4Z3Kt3pxD
50676	payment	2132	2132	1874	1	1	2281	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKY53ZbaQhmYRzKWHmX5XcET5891FmvJ4pSBj2NFZQoEp7Vup
50677	payment	2134	2134	1874	1	1	8780	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7P9CcqkVaETuMHXCfGNi5RDdVPAFTPrgHGBnrdSeziQTcwNtg
50678	payment	2132	2132	1874	1	1	2282	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcdTRZkLkVtHJQetDqDKMiMr9q6Q4BJWX7ZFHnAJFZ9535dCF
50686	payment	2133	2133	1874	1	1	8097	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFxBiW41anADS68n33CCFqcJTvUfjpg9yj4WfbLhEprdEXHkWz
50687	payment	2133	2133	1874	1	1	8098	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZptWP4mqznqgvFfW7fcCJed7Vs8aNaqpR3EC9SGpvpix49Wiac
50734	payment	1397	1397	1678	1	1	18214	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHUAxMjKLyoUCFTsMGVjABB8kJ4z3QncQbWVixrVJ4Nyw2KYGz
50735	payment	2133	2133	1874	1	1	8111	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjGEjH2PsonDmiGbM4dhZ1WU7XAfHWqi3pMgvGdFct3i6zZjFZ
50736	payment	2132	2132	1874	1	1	2291	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPTBHjbzUKednsB5Z1tEGGSguLXrLU3WENZGZUSDqLKbKMKV4
50737	payment	2132	2132	1874	1	1	2292	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMHyzgFicL45YtrTqBbyF9cZUkn1MUsNmHNXvhmkYgiwTxJKZ
50738	payment	2134	2134	1874	1	1	8808	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2fYCTdxno7ABtwJYmMS8hFLeKRiMsbzaaxi8h3SVGnsFVW3J
50739	payment	2134	2134	1874	1	1	8809	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8xSnDCS38aBrWiKGX7Jgz9mKCmBiAzPTMyooTF3aLbWzRiQPZ
50740	payment	2134	2134	1874	1	1	8810	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF5GFH9TEPqBW3xUYdTMiNVHKDbUXsSK3sR7Buomvkkoj6cbHH
50741	payment	2134	2134	1874	1	1	8811	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmdKyS9zJwj3yHits1BajttXmnkSziw1wJ5GZcsnBGStUoFHSu
50742	payment	2133	2133	1874	1	1	8112	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKBhzSF6vJQbobPYBGMsZaLtdvmuyh2TDfGefvJVVgdP9zJi6Q
50773	payment	1397	1397	1678	1	1	18218	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvUoommjvU13nkStfHr8NMt3kLF72SLB3qc6woGhnTRMgrkcE
50774	payment	2132	2132	1874	1	1	2297	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeMZDtmJf5hyuWRtQpMfKepFoyB5HpY8tBRozdr3YxtDyDhmP
50775	payment	2132	2132	1874	1	1	2298	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9hRAfUXTTopjjrSTEPv1qFo9uwEXDgvwDbTqwoXKdZ5Wr115
50776	payment	2133	2133	1874	1	1	8122	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9BEPRPnTdtW4xtx8WzcaxXWyccDSJskqVXG5wGTrYNni4Qk8H
50777	payment	2134	2134	1874	1	1	8826	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfXCGAQ8fTTaX5oVov1Teef6ibnXahMEUj28yKuv9t8QbatAc
50778	payment	2134	2134	1874	1	1	8827	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZvTN1fn2kCbh6AcyvZHRDxpN8ifG5EdPCE5RNZhnEvtymcHPw
50779	payment	2134	2134	1874	1	1	8828	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB6jjBeL7DZVxoZ2PuwDCb96z1fL4Mv3AN99fP7wRSwnKZvYyd
50780	payment	2134	2134	1874	1	1	8829	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv7SLb3bDwHpHuXrkXa83Kne1uW4RXT4hgZ7gCbBKxuwT9MYzb
50781	payment	2133	2133	1874	1	1	8123	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4sL4kTnVGAGYy9SoyG8U9xHLqrqBx1zcLHmGkJAeiT8dDdeWA
50811	payment	1397	1397	1678	1	1	18222	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2csWK1qfRoCmUgwqT8e4USTGBKC3McKSuSzzYiePPhexbCRiq
50812	payment	2133	2133	1874	1	1	8132	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRAfzRDj9n9YLMSuXZhzHXSr3phr1SxzZRVVLKrCaN3T3Myvu7
50813	payment	2133	2133	1874	1	1	8133	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXjXQfGYSqDzsZQZsk1iX4GhTqCkGh23yqiUmi45zydPajHKiU
50814	payment	2132	2132	1874	1	1	2303	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoR2Q81rU7V4CaixKFw5ED6SozMWa1EjWasm7irxgc4hT5fQph
50815	payment	2132	2132	1874	1	1	2304	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFP3MVg6pdX1afC9t5GzxREdHXNkCRwi7cDc8Mxa1WCV5Gpb1f
50816	payment	2134	2134	1874	1	1	8844	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZruQzKDZWvb9aiQ3ivF9A5drxU2c5v1JAenjavVG9eqg6qNJAy
50817	payment	2134	2134	1874	1	1	8845	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrNDZdjfuASR8SBoBsKoW18XnsUduGjFRFAr6YbiQcXVcSewxL
50818	payment	2134	2134	1874	1	1	8846	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrgrnD85ZZbws2JQas4AMbumNLePJ7DnC5zjnGYpfDsP3ovUyg
50819	payment	2134	2134	1874	1	1	8847	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG53waoui8Wyv1bnkRQEkTT3SzXZ2Qpc2GPUBEWag6JVpXGhBq
50942	payment	1397	1397	1678	1	1	18236	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoQrDLcbNJdgZ6c2bpnX6jNdYzZEPBCJs8PL28AG9tscmD6m9E
50943	payment	2134	2134	1874	1	1	8905	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDpsYzq5fPGbcYvWekRu8RHNhFMHMN21doKYu3sbkECW62qaW
50944	payment	2132	2132	1874	1	1	2324	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf3spowywfkwmfFmyBub1mEBoMsvrRvoiAU6BzvaFDnqp6STuL
50945	payment	1726	1726	2435	1	1	8368	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYzWnRWffu392r2q7DgQKGmmi2qoijqmGbxLPgw3gzG2fpV3mxe
50946	payment	1726	1726	2436	1	1	8369	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYkfQ96Ho9k9suffyRV2PbkD5QafCDq9hjHLTExprMXn6G4SmYb
50947	payment	2134	2134	1874	1	1	8906	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvTKUFPGNPkMYTaRSCP7x11kMZy5XnWBj6qTCnfzCH29iB9KVb
50680	payment	2134	2134	1874	1	1	8781	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQqNdQ15idWt9VuzkH6EJpsoSfhK24kMEiMRwYkSMbBD5kDETY
50681	payment	2132	2132	1874	1	1	2283	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGbqsCVHRkLscDKHXssRadKdCaCa9kvNMRAuEYkySXGs7BXsk
50682	payment	2134	2134	1874	1	1	8782	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvCYXhEzq4yXQxmAnUMBNXwGoVjty3nRf8H6gg1ETQH76bqc46
50683	payment	2134	2134	1874	1	1	8783	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQCn5qzYwiQADb6789tXJsFonmiAXjcKoYqScrxiu5YuPYjS3L
50684	payment	2134	2134	1874	1	1	8784	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukTHWek2ZFxxUqPra4ek7fkZCbhfwkzxPUj6wPQcpyMeTUnhZ
50685	payment	2134	2134	1874	1	1	8785	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFBG7rrd8fYoe59yxFXcsf5PZy93cvuLVMm5tLJpBVBQTMm8yX
50696	payment	1397	1397	1678	1	1	18210	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZedDQiwmEjaFwz1PdJAVtCfY7Faepej5UadnXprMdpagtUG5Hi
50697	payment	1397	1397	1678	1	1	18211	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZvFAgHqa2HfZsQYQaZiugDzcuZCUKAf7p7y5HpnJRctA1aqSv
50698	payment	2134	2134	1874	1	1	8790	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsHKoHCUqAGER1VfaU1e6NjW9qaH27U1EBWRQBBdhrPJARLR9p
50699	payment	2134	2134	1874	1	1	8791	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgfZaTva7P46NspytQA61eUPi1U2131iGmNp9HdwUnhVwreHxp
50700	payment	2134	2134	1874	1	1	8792	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7CzNT8qJSgoVPuw1uY8buQcJf77k1UGy23gKJ7H4j5NpPAfaE
50701	payment	2132	2132	1874	1	1	2285	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeJGiJ29FjCUeebCCidneLuMBGCBQ4wrFmy5aYpsprGrPywk7v
50702	payment	2132	2132	1874	1	1	2286	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgTh9dUBHtQixEo9Dn36EhkgAMTv5WBoagHkt4BeHNbjzLSo1Z
50703	payment	2134	2134	1874	1	1	8793	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm1YJffnBDyGnb7MknzgJwKxxpkzjzVfZsj9KZTAF8wtYQ4Wg4
50704	payment	2134	2134	1874	1	1	8794	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRmn99qdyqzeSQxjkxT4RmsWLYG9WPLBXQEqyVW7YrFW6196DP
50705	payment	2133	2133	1874	1	1	8101	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1n4UixVX4RrbVD2gyVh6K7JKU5F5nrEeYAUybcGLCdD8kgBrj
50706	payment	2134	2134	1874	1	1	8795	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa97nNXveJsFkg2n71GnyqkASB3uzNobx5kMAddHxZMWaoUdyrS
50707	payment	2134	2134	1874	1	1	8796	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6j8P7SULQbAn2Z15L2S6ZNzqDaAY7CsJuHoXyNkFAH3ZxjCZV
50708	payment	2134	2134	1874	1	1	8797	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvWJWSwnYsM2M4Buuqpf1MtyzMRRd7XUfV3rg1dAm5p2hzPUpb
50709	payment	2132	2132	1874	1	1	2287	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBJQg6UL8tg5JFJpsJHiyfvWkNc7Qaug7TidwMfhEexAvw8B5S
50710	payment	2133	2133	1874	1	1	8102	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGzQ97so5aoCmLqPzJQ8cGF6bgTpBpFX1SUgwzgt8erDmU3kUj
50711	payment	2133	2133	1874	1	1	8103	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPoVGaBvhhwAwnpTskQJSAK5ZYDHzne1S2vMQc7iy1m2NnbgKy
50712	payment	2133	2133	1874	1	1	8104	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XqwRqqPLPb23vhmT6uetqVBQ9xWttkgXoXuNsQqrrXhC62RM
50713	payment	2133	2133	1874	1	1	8105	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvR94bZq3CTB477yLXMG1u6B1P8ef4E9xssQkTwiVVW7EjrFJx
50714	payment	2134	2134	1874	1	1	8798	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKANooPW68UhQQftEURd3kqJ4vfA6omXkVhHwm6u3gUnb2MeDU
50715	payment	1397	1397	1678	1	1	18212	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjU256n5nWLAjSTrRrUSuns9NPfzJJsnHsZ8HvWjMKwkHUg7ng
50716	payment	2133	2133	1874	1	1	8106	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyDczinAHZGnZ4Cr1BkRMHj71kNx3S7bYTiFYcpimaBqM8MBQj
50717	payment	2133	2133	1874	1	1	8107	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT8vZBGtrY8CKbFABkLLHeVJm4C8mQu3mSnc7zLUvmsTbUZwVT
50718	payment	2134	2134	1874	1	1	8799	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYztiYrjMUwbA7fXbq4AA7ANj9XSTueXZJMF62ep38Yq2Z2dCDC
50719	payment	2132	2132	1874	1	1	2288	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR1dqVVuF4LvHC3NxPHxQ2y4sBrMBbohXNqA91Hk6pjxCAQci8
50720	payment	2134	2134	1874	1	1	8800	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgJM6WtBrG41ris2u1VjTXyAsjfSBU3vPpucLHPvwED2j6fbg1
50721	payment	2134	2134	1874	1	1	8801	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9xSPKAoaXEeutjED7WFUoV6QnU3ktiouUzQyTiDCfG7fFLY8g
50722	payment	2134	2134	1874	1	1	8802	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZywyNBcxTipQfmtg6Hs8urRNEYiE5Eznc4r3d2RmTn3kXv8ufH
50723	payment	2132	2132	1874	1	1	2289	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jNcgJwAvtLP4bJjP7dfqPJThh32UM58UQ9qJeXqRcNwPwy7R
50724	payment	2133	2133	1874	1	1	8108	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDzVgEfKkQuNDJs9SFg1NBgLgYiG25fcGWPoQhMtby4C1PeQmM
50725	payment	1397	1397	1678	1	1	18213	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiriyr4dK5tSB5HDrt3AJn6gYErvdvNqbdLam5N3XtL3LJmAU7
50726	payment	2134	2134	1874	1	1	8803	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5CCfxG1zghDVxaGLztgkfbqxu9SFEDERFPrYAN4KFHCDzozY
50727	payment	2134	2134	1874	1	1	8804	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfdxVTTiWwruhHojZQSBs6s3mi5HxY8RVZiMX14Qko69PbzCjJ
50728	payment	2132	2132	1874	1	1	2290	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZN2k8iNRRBUkP3vsqREDNKbajLFcU55SBp39V4dXfTmKz4UaUv
50729	payment	2133	2133	1874	1	1	8109	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiWN18m3pucZYcjoFH8gpAR26o25RLH3HuWFXk1Lu3AqaNa8G
50730	payment	2133	2133	1874	1	1	8110	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEZbsu7p93QzCVYTnfVgV3bwQa6VpWv2yNHXE8gTGBQB6R9NS
50731	payment	2134	2134	1874	1	1	8805	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHbosyYc6vnnUMm5PEG9ke33QSQ1EFYypgJmwZJEH5Hgs42D6F
50732	payment	2134	2134	1874	1	1	8806	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL3ZCbVtmtEVNgjBLQ6c3y6ULzm152LpWHLozpVhitWdCXswvB
50733	payment	2134	2134	1874	1	1	8807	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefmKpQQoa7hbw7dtaNCQJz12uj2K613fbh5mCow1VVYPbKpoG
50763	payment	1397	1397	1678	1	1	18217	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ552cFfN7MT9ogqCLsd3kcJS31asRoSMFahCaRRieCt4tibT9J
50764	payment	2133	2133	1874	1	1	8119	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH2V5oNDJEYmTU7V51LK8ZFLwFbDmVAQQdu2zbaXVay1obKiWq
50765	payment	2132	2132	1874	1	1	2296	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMBap4Lzif84CJtE5nzS9uNmYp6zu1Ecm4Ahdgr3dYjEPs1RiF
50766	payment	2134	2134	1874	1	1	8821	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTDUeWWTDrq3ZvDdCVhR1Uy52YRox34N7U4NBASHH5u8qe5JJ6
50767	payment	2134	2134	1874	1	1	8822	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtKFquwwsue6jrXWpSmw77LPx3JhLzjT6yqtxawG15kK4CTSVX
50768	payment	2134	2134	1874	1	1	8823	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW5gLj7tJX3hBphZVvqAp7AkBwQGxjvyW1gVhgU54tYQTW6343
50769	payment	2134	2134	1874	1	1	8824	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRwFox1ZztSUBu59BqyraPL5T3R6m64wqZvo6xQEUrnNSgPEzU
50770	payment	2134	2134	1874	1	1	8825	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdnt3prnDPysCpH8MkoD9KEyBbe2Fovd1SPzCn2ohu8A91sXJe
50771	payment	2133	2133	1874	1	1	8120	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7BMTtMrAkAiMW8mgBKRDX5bXWyzLAfQVm8BVZMmFcsoDVeTyg
50772	payment	2133	2133	1874	1	1	8121	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyHNz8Rhq22zFSUprNrWGQYK3pq8pGHhGL9hGo2oEeG5qiJAyx
50820	payment	1397	1397	1678	1	1	18223	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ87S4Xtc6rvoBBN6vRfUSX2WBq4XqtMwN4mhjYF4MbTmrW6e85
50821	payment	2133	2133	1874	1	1	8134	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSAFkRepVk3uZzwaQDkrSHUnDDwhCFG5tU9n17udfbtPU92h1j
50822	payment	2133	2133	1874	1	1	8135	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrY5BwUYWtQXh32DBSjoWSAwqhVrEJmzS8xrHZ22R68HUK1R53
50823	payment	2133	2133	1874	1	1	8136	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpT4jxPD5FRcCcQaXYrhE2uSHpYUhTbHZrRqxZrCFjBU5HVRrv
50824	payment	2132	2132	1874	1	1	2305	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJLaLiwcVetia9UeprKMp3tZuWVFzFFu3Rv9fEaak18oWbUPGo
50825	payment	2134	2134	1874	1	1	8848	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3LJL19EckBv4sm3i5t49QJtYJEeewBjPUsKwbXsVVgDpzZinC
50826	payment	2134	2134	1874	1	1	8849	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS1PxnmB18rKegMKiK59f1P6xEqaWtgdnWfFLMaqu8PAJeRpPY
50827	payment	2134	2134	1874	1	1	8850	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxtWmDxBmHu1SjtgfsFS1WHkhM9mtGkctLr3uYmguLUv1nUhyU
50828	payment	2134	2134	1874	1	1	8851	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvy1P4nuyk69aBWb83Lzxi3CoxMfgGFEREde48RaTrZPxW7QTb
50894	payment	1397	1397	1678	1	1	18231	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ztFWm6axYzZ1TkCPVeGeLmknSn1e8zdjzXP9owsCrPxAn5Cj
50895	payment	1397	1397	1678	1	1	18232	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5K4YZ3XqpaWKB9xRQMUgPgesnyUN33M3hkAZkd6JTfdND57H
50896	payment	2132	2132	1874	1	1	2316	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmBAC7VeSWhfft4EuonGYadgsEiBHr1ScJdMzgyVkWE9ktumqF
50897	payment	2133	2133	1874	1	1	8154	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGPRMdqb22xAMLxHeuQRpde8Y9bx68QDijV26WVcR489qLBJ69
50898	payment	2133	2133	1874	1	1	8155	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJSPrnLZ1mNVfobC3HZmvJWjmHXUYL8rAXU78zWXiceN4P87u
50899	payment	2133	2133	1874	1	1	8156	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD24A3QSANrE13fKXxUmvyjZWmQS6BJHa18JbM7fBc2RhAKC7i
50900	payment	2133	2133	1874	1	1	8157	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1gZhTqtNL22Z7ehzEyz5q1Ais7Xqzh6HQBjU3ajuSZNtFWf6x
50901	payment	2133	2133	1874	1	1	8158	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYubSzR2DpUuf6jqLmXLqBCcpoaFhfVb7ZW5fn6viAH3N4MAoW8
50902	payment	2134	2134	1874	1	1	8883	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaNJJSdYibGtbTqsB97vGMoErxSu7H39jaA1R6tDkp2oxxuWey
50903	payment	2134	2134	1874	1	1	8884	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhmHz9k4HcmouA6T4zAS2C83zyJxzNfUhyNA4s9pnW71xs3Bj1
50904	payment	2134	2134	1874	1	1	8885	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX9VX8uMdBaM9YrrreibL5BYrTyFAkzmZmBEjc5xCK3Bgxy2qg
50905	payment	2134	2134	1874	1	1	8886	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa5jSWgZW3kV2unqSjxooQHZ6W3kK2hGbwrpHNMtHCfQneHMbd
50906	payment	2132	2132	1874	1	1	2317	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa29Ddov3qwUQ2obB6TuAL4FeHrDxPedTb1BpDzvBM5ihb7aqjd
50787	payment	2133	2133	1874	1	1	8124	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3cGaiYRhqWLFmYBYLAagJPX98iug85zzySubh7BDApUKND7Ki
50788	payment	2133	2133	1874	1	1	8125	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTH5pTeqdvb1Wc6Yt712M2CZ51SZquVBbRbexDXk1t83F2ZsWz
50789	payment	2133	2133	1874	1	1	8126	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaYSmYgTwjeY5L3axCDVS5b5nv4EgGbB7gWQGQtqKpaqH218ST
50790	payment	2133	2133	1874	1	1	8127	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr1nnuogsjSwxYqdcW1p6xmLbfwGBF1qYhJS9TriNrfZCs4atJ
50791	payment	2133	2133	1874	1	1	8128	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbMoFTkpSdECqeofw4ob9qYAHSS9LPc4BvLm4F9PdekXzVS5pe
50792	payment	2133	2133	1874	1	1	8129	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBuf6hX4H3F417g5qySHgpGgsNjMTWUuCBqa6aozb1hHxqLFsK
50793	payment	2133	2133	1874	1	1	8130	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaCWSbE5XARR6XYP5pkQJ3dyJvGyyehGNv6UidpVTjcn5jSi6q
50794	payment	2133	2133	1874	1	1	8131	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWGkJaQzpsiJuzhLDVmecDNyLv9e3D7niomXhHSgByjwuxD6y9
50795	payment	2134	2134	1874	1	1	8831	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDaRQtpGvvSS4aATDjxuZsE1vVpopTa5hVpJpxqRstcHkDmY7x
50796	payment	2134	2134	1874	1	1	8832	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsEPZbsQDLLbjVmdPrMmAtmyvgGKHegoDKW5VArNdoKwPoKRnS
50797	payment	2134	2134	1874	1	1	8833	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyNdLmjCXGY4hUSzrW2JvPnCkbPA27WP1SftK1hYres1mYQyP4
50798	payment	2134	2134	1874	1	1	8834	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTQtPBoQtduE2a8srP16Cob84h6M33PoizZra6SmHF5KoZeprT
50799	payment	2134	2134	1874	1	1	8835	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa39ScGNpMJaPB2FmjJ82agexkFK1erPB8wRRvSwEVrATVnF3fP
50800	payment	2132	2132	1874	1	1	2300	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEhaMAYjX3rdX9isAaF4srrXsUCY1tJqv1t2FaedJJguM9LQ9n
50801	payment	2132	2132	1874	1	1	2301	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgK795QMoScW2Wi4NYzdYx8WSCva5edB7cnhm3xxsmVXmKMsB5
50802	payment	2132	2132	1874	1	1	2302	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfGGCjshCPo7DnNpnpV3owocZ4BpHXsty5pw5xeHmTzsvA8qMv
50803	payment	2134	2134	1874	1	1	8836	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGx8UcaYTRRgTtvWqx5ZXMEHMpBchnL5n1YePKHWLL276pY9ae
50804	payment	2134	2134	1874	1	1	8837	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4qhHvs5g25MnNZxdAPLSRTtLviitaLtxP3Abwx49tnZaH8njU
50805	payment	2134	2134	1874	1	1	8838	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrJEcFJxm4D98jBrb5jRBeTeFBTVLwDYgRxRj9nAeunDd6bhsR
50806	payment	2134	2134	1874	1	1	8839	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7RkqFPdCtzLvhnEZw2H9hRWZmnHa98RjF5N7a5bhFJpPNTN78
50807	payment	2134	2134	1874	1	1	8840	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwPYnuLCJDwMxYsBLxVXvwRy1feSbeFN9AWrjS2SsENbnShLeD
50808	payment	2134	2134	1874	1	1	8841	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZye4ZnCxLupCmPbyBXcwCt64q2fqd6yYgvrvS2fuPk4cymus92
50809	payment	2134	2134	1874	1	1	8842	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZweqtPPYU9GDkDAoebSMksLCyw65Tyoe7ef5Gv9V79wMtcz5Jf
50810	payment	2134	2134	1874	1	1	8843	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhiqRUJ4Sme75mJCnXbNRRJ4n2VbFhjtwVvYRdkCiF3PLJRkBq
50829	payment	1397	1397	1678	1	1	18224	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwAAEP3nga7srERqEQj86g35iqeJpgxpABdNYwRkXpiVCPQUYL
50830	payment	2134	2134	1874	1	1	8852	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuVwtQ1HXbu2obVr7tftyxKyYNHDQZ7hrKyTv5SR66w3p2o27v
50831	payment	2134	2134	1874	1	1	8853	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyZbgDTJojFjbHUrjAuTX8MkX3VFdsTzW3m1KQFpvcQ9WMzoKR
50832	payment	2132	2132	1874	1	1	2306	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ZysF7ChT7j3vD2tjgaDb6CeCRpGKyAcZimkmRAxdnAHXJ8cZ
50833	payment	2134	2134	1874	1	1	8854	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjqqRbR2ydENYW8U95Cw9rzypZuSKXZmD5X6zYojvj5tqdwwtX
50834	payment	2133	2133	1874	1	1	8137	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzmkm4eQbBoLb7PknnWZQc5zXkTHwammQJXj6WbsCyPAfynF4o
50835	payment	2134	2134	1874	1	1	8855	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8FfKP9EemvYN1SwHsPV2dDWF3zsonbzh6rjSbgFaiiZ9pvvkb
50836	payment	2134	2134	1874	1	1	8856	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnG8in6if8xievMA6htpn9ZEXnH2JYvtgHZRk4BoMYoSrSBTis
50837	payment	2133	2133	1874	1	1	8138	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA6mDZW5ZTqXXuyZoGbqYC411mw1NLpWwqbNmn4Vwmr4QYJ4Ns
50838	payment	1397	1397	1678	1	1	18225	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLafMonCcQ4htoGpdLfjwAS9F1LNvPWPDXS5d38p6vDEHPMKzG
50839	payment	1397	1397	1678	1	1	18226	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHj9MDfS1HAwtQrLyDfiq9sP1kc1pxd255aE6no3eNdNMJCFpd
50840	payment	1397	1397	1678	1	1	18227	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4gFTbBftsGwyzWqMFCur8by7FZ3Zs7DTi6SvqNBnXaYN8ZSHG
50841	payment	2132	2132	1874	1	1	2307	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyUxMTmtBomkNpEeWBnGmvJPuuzuUoiW4jXg8njjfYLzcnzRn6
50842	payment	2133	2133	1874	1	1	8139	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9vZ9LJeTPPahRbce6D4sbgkZET3hDpfrgYgc1riENY7tcjccr
50843	payment	2132	2132	1874	1	1	2308	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZM4QFsmU5DMgeBC751jZ5JGVV8ahPSQKxcTEHKPv9X84DfxW9h
50844	payment	2132	2132	1874	1	1	2309	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJGMaVvL4nG4ENhMsAkbQ7CJqqg2PT2XXycpqYZxvgFEkpuZoH
50845	payment	2132	2132	1874	1	1	2310	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKAUqV9EJQWBf5P2zip9zksBvLFQiNjHexvfRwfSez3Vkd1Xtu
50846	payment	2132	2132	1874	1	1	2311	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTauVuNMUc6QG65LLUbkhambjvnfsGDmPgtMjNTbqggtYjqMDe
50847	payment	2133	2133	1874	1	1	8140	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpcFFUcHnFVydE7NsZbWUSGRnXARE4KpJBfwcYVwEGmbQqyahH
50848	payment	2133	2133	1874	1	1	8141	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ26ywsLziofMCKPcFptEmC7ssGbUz4ygZaAiY7CueXRdTN3KiL
50849	payment	2133	2133	1874	1	1	8142	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6rSauw3DPSCzzjSGYozWTQjoSHVfcC2VrbjpmTVaYxhoGpc3z
50850	payment	2133	2133	1874	1	1	8143	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PVZH3jvax8EWxEWdvtwkAXKF3tdeNS5JZSfEVHof2fCoJYXw
50851	payment	2133	2133	1874	1	1	8144	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkBZe23PToZoU2rCQDgyiH6pzXTHQ9HR8R8htgAZGBTaV4fVGr
50852	payment	2133	2133	1874	1	1	8145	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcNe4F1etym2QGq1uQbh7k434qnkF1Yvs8gmyQfBaJBP2FMY5N
50853	payment	2133	2133	1874	1	1	8146	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5D5q6g53W9CQ8C1gapwukfX9N47FknT4ThHuFmiPhKux4bAxc
50854	payment	2133	2133	1874	1	1	8147	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUbEQ8kw9fCeGJf6kAyHWWL8L3bgfca3PdFSqU3qxPLh72QxaG
50855	payment	2134	2134	1874	1	1	8857	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE732CQh4SAqYxppqUYm1HeDFJUuhudaEtUiNgN5uVy4tGB7o7
50856	payment	2134	2134	1874	1	1	8858	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCfspesaP5X4VbDVoPasbxfNxB1FaLjgPmirns1XWtfEnQDTuh
50857	payment	2134	2134	1874	1	1	8859	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5ZP9EScGrhuzQbbFzYYL6eeLD2nfubPdin19XYwpQpqh7qVQg
50858	payment	2134	2134	1874	1	1	8860	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiDz6GUMMSos7K3V3LmeRwhoLHSgWfT3p456Ny3s7472SRji7
50859	payment	2134	2134	1874	1	1	8861	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7P6T7nAQdy5MiTm9PXHhd2jfQKuFCC13JzpEnBV3N8RAcUjVf
50860	payment	2134	2134	1874	1	1	8862	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsVk9A8uq42TTzdgequRbXcJT3qkVim31eXcNAXgbkZdZ766bJ
50861	payment	2134	2134	1874	1	1	8863	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ43y7ixE8ner54MvAPXak8kxy9sLzteqXS1fkT9YqxpfLDmZzP
50862	payment	2134	2134	1874	1	1	8864	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVDA9oFU9Ttr6th5pZFaRF8Cuh7HnKeESv4CH3cvJAjdVH7trN
50863	payment	2134	2134	1874	1	1	8865	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZayGyksxeGnMBYVXB9HWmZZHSSpxhjdHMDGzS7jinRpyPxHkv3
50864	payment	2134	2134	1874	1	1	8866	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ5PPDvLntrf7iWGuYip3Sb3ukjnD4f8MYTg3AwrGvo9dfmctd
50865	payment	2134	2134	1874	1	1	8867	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu1LtzB3B7YvriqL8gGnKEQf3CfA9rZMcYv6JpWCVzBHLc6DK7
50866	payment	2134	2134	1874	1	1	8868	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKA5q226NXNCb4MaMg9JKfiTPPYQyTZdswyv72M7mdif1QzfmJ
50867	payment	2134	2134	1874	1	1	8869	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAjRFXZdqov4m6MZoDzFNjHmAcbPka1mW1uAPnCTFHvssXAeX
50868	payment	1397	1397	1678	1	1	18228	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwZNEFXbW8xbV6UzkkvfGTaMFXGti2egnMELQdJDbUEmCWiaJv
50869	payment	2134	2134	1874	1	1	8870	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYkKZg3EAtW9FFRqpvJbWTEbD2iCQmDtZifLikSK2DZhRs5L9T
50870	payment	2133	2133	1874	1	1	8148	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4KMLRjGH4bUMm1KxqZhikxmemPe1hfNDimrvyrBJYRqDR79E
50871	payment	2134	2134	1874	1	1	8871	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYZQRVHG9cDqVpuUpNAJHkgxauK39USMzG2GuVtKFrf8De7U5V
50872	payment	2134	2134	1874	1	1	8872	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZe1fQHwAJ2PRSd5ZoF6yuqumDKyXpTgzuWmSWnvy33wPTMMwD1
50873	payment	2134	2134	1874	1	1	8873	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoakYVstjTYbtyh2SBrfXuvqb8Aa1qXKbagd7Mj9X4zrwzLJrt
50874	payment	2133	2133	1874	1	1	8149	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoZHFHqr3N9KfV8r7ExFk8Jdmx96qLyGtVc76HWYPVufthu2kW
50875	payment	2132	2132	1874	1	1	2312	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxFSC8B5ZVHyQhkEh33eXJJJjP8SKb31bf6QvovAjoudqKJGbJ
50876	payment	1397	1397	1678	1	1	18229	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ81kpYTnUq8Gk53pyLGhkkwfZCinsrHAbS2FzNRLUkeDurdcVA
50877	payment	2133	2133	1874	1	1	8150	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZV1qTxmedmviJJEEYHSrTGaXaF5Vx9EW8L6cRM9Pw2vX5D8Tq
50878	payment	2132	2132	1874	1	1	2313	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzAPMigh7UsDbeEZpybwQWCwyzKdHJ1gXr7HJrjos1gax32zop
50879	payment	2132	2132	1874	1	1	2314	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmHfJpezyd5nZf9o3B4V69pXT5uCtvgb6BixsoNrVqKbWXF97n
50880	payment	2133	2133	1874	1	1	8151	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVpxCGadaoZuAWXu93ZhCURySsKtLTUgKRyKipY6nAcuZBh5hN
50881	payment	1397	1397	1678	1	1	18230	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMzDKGvjBzjT6VDDuHVBPTCA5mVu7hRP4pATpR6AevfGMpzYt8
50882	payment	2134	2134	1874	1	1	8874	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZm7Ry6TpqR8YmyV5AkLRCKHLYAhb1G8Zk1eHTVrdn27wMNGQhB
50883	payment	2134	2134	1874	1	1	8875	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqWhbg95FMga3B11uPVyzB2sYVZHKGwaoZYSY54TKmLWFsYcTr
50884	payment	2134	2134	1874	1	1	8876	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWvogs34NESWTRCMxzh3ZhYCGp5Z13dX5id6ZUCbihiHSkLeHE
50885	payment	2134	2134	1874	1	1	8877	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk6zLJjAg6Us1tGwFrQwKN2i3n32w9hWzf6VfuwxBAA1RaMhKC
50886	payment	2134	2134	1874	1	1	8878	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbq2vXuLRnfFKqVdUEn4Bk7WyqmfDHP1aQGB4fy3JXKKL7o9bp
50887	payment	2134	2134	1874	1	1	8879	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1cjaa5XztYDT1UWgMmGbTtpBRQYosTNVR4kH9ztnCmrEYyPjv
50888	payment	2134	2134	1874	1	1	8880	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbzjmGunWmagnmGRkTrCBHq12AjDzb1XRpeLhcWHvPU8Ep23SS
50889	payment	2134	2134	1874	1	1	8881	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd2XoHuT24DjYkAXTQNGTkufUnFngEe9GqYD6MsbwvTkwjKuUa
50890	payment	2134	2134	1874	1	1	8882	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbonFGksz2wZFpcoSDobVPr7TdMYMceiqg4koK9c4mhrnhHTE6
50891	payment	2133	2133	1874	1	1	8152	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8Dyd2fK8caWFZ2rk1NWtXsuV7Tgex8NVt3s1AbmWEDMgjfroK
50892	payment	2133	2133	1874	1	1	8153	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQMqq2BjfYrszsHTdgcjytNHGCHN6xNxdRn6W1kPGXkNQDSgM
50893	payment	2132	2132	1874	1	1	2315	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGnMTzRJoNLwmx1GLAuzNrGnCk9wsYYfsnbK2oZziB4fptLqiN
50913	payment	1397	1397	1678	1	1	18233	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpm6MX8867kT916XYUFkeQvJtHqXkf82rwHzQupNmPz5QtWp1x
50914	payment	1397	1397	1678	1	1	18234	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1e3pnQ6BdjVGJpBfc3J1epTF8MwEejPQSfGgu5WVySEtH6EVa
50915	payment	2133	2133	1874	1	1	8159	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoEAAS5hP5rTKNYvn5Vt8L8TN4HdKMw5fRWWez9mPHtMuXnyG
50916	payment	2132	2132	1874	1	1	2319	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRAs2dsaHyZbQZjGsEzT4H5oosJxjnLdFvNqq7weMU4BuijkF5
50917	payment	2133	2133	1874	1	1	8160	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiq1J7gMzKymJdjyM5zZpDd4DM4EXBXWFkV83sV1CvEF8FKv4s
50918	payment	2134	2134	1874	1	1	8892	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtJAkaW9w5U2CGW8Gd8KUDhUXaWNe6oAW6a46Bgq6Ha2XV1yyT
50919	payment	2134	2134	1874	1	1	8893	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf5i4Jn8HgqgrDeFpC6Qojg3KDLc9wNxtW66NPzK8YuWKCYPL4
50920	payment	2132	2132	1874	1	1	2320	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtRPkFefrba8QZxpJCD6PP2uPKQAp57yMz6CmUfGuEPoLB3dvz
50921	payment	2132	2132	1874	1	1	2321	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7n7Jq5oD8onN1F4JgFR4YRHAukkL2ZrqnhKofDvn42TCTF882
50922	payment	2133	2133	1874	1	1	8161	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCfScqEZdKiKpV55se5ZNHwQTpaRkqbfdfLVoT3q3bx2fGBADs
50923	payment	2133	2133	1874	1	1	8162	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhqw367ZrqcoiZCiA7b9qM48CFvMwFPZGYtXUDUZyAAwfoz2go
50924	payment	2133	2133	1874	1	1	8163	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP4iZ3zmchftcbK7AwytYWaDwmm6CHcshiqPrMTaXRnWwxpkBP
50925	payment	2134	2134	1874	1	1	8894	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHcyGtosMP65oYJysUj5Qv4qjYFCpkJJBYADuJQWidnaveUJAn
50926	payment	2134	2134	1874	1	1	8895	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpni187D5csWkcnvegRKbubyWtZibNXHQkthtB17MHfgXG7D9
50927	payment	2134	2134	1874	1	1	8896	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLgQBqHSAYTEdWiDKVjMb5YhYk63HifBxwCgYjZFMLSpKvRg7B
50928	payment	2134	2134	1874	1	1	8897	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTz99wddu1rmpKgReYLukDKb6ZUH3T9bTqNAH3zFg6puktqfqb
50929	payment	2134	2134	1874	1	1	8898	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmrSevJWiJ8zvCYStRL1L1JYSzBpsSm57GfDNjntnYT6eRB8py
50930	payment	2134	2134	1874	1	1	8899	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ74xAfLbeU4gYQGPAzq12WscznnLHTjhZfq1U85tygzwrQSLe
51025	payment	1397	1397	1678	1	1	18244	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXzfoUpweVnNAUwDpBcLB5bSsx47tv6esVqfx1uXxoDvAw88Q3
51026	payment	1397	1397	1678	1	1	18245	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkmFvyqCWttAV3BmU5jd6AV6sWMEu5yL5g53YHtMnciyTWKiue
51027	payment	2133	2133	1874	1	1	8188	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXhouZb3PNeHMEmoPLUsjkajESzikQnzkitMNM1v5ihTAhB2fS
51028	payment	2132	2132	1874	1	1	2336	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNWb3tM72vFjyVQYrHXJZypbpy5qSyPFCGVwLqoo3NDZHpYv2D
51029	payment	2132	2132	1874	1	1	2337	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9ogYbCbuvovJBHxsAXhrCgdnWRxCkJNr2SPBdS8MDHjTMq663
51030	payment	2133	2133	1874	1	1	8189	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAS1WRJyVkQ1Lp65nJbGpexJsX7NiPCTTqrZWQWZBa1CgCn8QP
51031	payment	2133	2133	1874	1	1	8190	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFbqJBoBi5K6Mx4YsHZs1XEpWJYcjXYEb3xbJ4ud5PSP3mujda
50907	payment	2132	2132	1874	1	1	2318	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYCUDAvVsVeG13yhZw6umKCDa7jj9rfJCnug734BZS6DpyKmv1
50908	payment	2134	2134	1874	1	1	8887	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2hhGpmY3Dd18XCGNoe6RaR8vFYMUtYjMwhMP3RinUBp3YPeTv
50909	payment	2134	2134	1874	1	1	8888	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZz6o9qAW7qRrivWquNNXdBpeFPWVqytMNzM3kjMUos9MxKgwRt
50910	payment	2134	2134	1874	1	1	8889	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7xwpNu1ve82GjRgm65vBqM6yh3NfZcb1mWqqSEnZspm3RLfDh
50911	payment	2134	2134	1874	1	1	8890	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLmJh53YKYhNE7bzVPCx176ZChw2u5CAmXbBgyANzUYfFkb6t
50912	payment	2134	2134	1874	1	1	8891	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXJBsPnKfBw3VyPwVL3vdFosUSbaRPwMHWYMhkaZwKbUBDHq7t
50931	payment	1397	1397	1678	1	1	18235	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF6zRcNfvayNMtrqi3zCfiGtc1iKsDehwtrmcM8PdDJj2hVRbR
50932	payment	2134	2134	1874	1	1	8900	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiSF2SiiYPo8J5sf2MDzxTc1XGTAmyUQAfqVC7wuhqeu6TYQGd
50933	payment	2133	2133	1874	1	1	8164	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZecFtsLBoYARwpkAt7gkDXNp8gpPq8MqBcnkQo1mnCVFtazYRZ
50934	payment	2133	2133	1874	1	1	8165	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkX1Z9VoC4WYQynvAouaS9GTsCRuBtpjsxFSPdvWdd6Wh2NFEA
50935	payment	2133	2133	1874	1	1	8166	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbe3jncRLGtHprLVuZAqKex5kicHj2RsKeyz8SeHS1WxVNX1em
50936	payment	2134	2134	1874	1	1	8901	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoFFsqeP6JeHEVMmjuDTyaXHurMA75JGLb4cqknKpe49vnMcW4
50937	payment	2134	2134	1874	1	1	8902	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLafV5f1TGEGMB7nGmtuLLcWXJ1cUaQohbR6vZsWWqcNKLvSKT
50938	payment	2132	2132	1874	1	1	2322	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6AgT8U6zNiDGmfsSZoAZujKeiLt2FqtMxtiob9rRWBrtXQjc8
50939	payment	2134	2134	1874	1	1	8903	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7FnW2qzYAhupLYcamB7NyokTmCKWBhvRBFATqgihPHmaWjChY
50940	payment	2134	2134	1874	1	1	8904	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBMQibzatxELcAfB1RkPcSzpiEJTioi5tkoJpEo6Rq7m7HE92k
50941	payment	2132	2132	1874	1	1	2323	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcTpQduXZaaXfhVkStjiCxZr6hNjqTyzSGs61igPktihX3of9
50974	payment	1397	1397	1678	1	1	18239	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9pof4cjKMy3FnnQB5gZ5cMVHW6MFoK8AJQEsaQQuiZGZ78Hrv
50975	payment	1397	1397	1678	1	1	18240	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWLVMJ6pLUZt9h1SLTcxWmAqefkF8xLz7trsMcnA7E8aewcVF4
50976	payment	2133	2133	1874	1	1	8175	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYajMr5fzaXce64YhJnxCYsj2cZSmCrgGvAzdo9NujT3yAc1Qcf
50977	payment	2132	2132	1874	1	1	2328	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnXJWr8QktTKnGy93KDK82jJPEBnZXCSHBBoVDiEedq9Ci3UhV
50978	payment	2134	2134	1874	1	1	8918	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZ3ASxm3reCqvz6aki5sMpvWyW81c1UDtWNdK4B5CxrgJraLq
50979	payment	355	355	355	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVjXprEVNZyBwCAzYfD2ra84GCsLjGvHXjnNYkebFWCYJxYmK
50980	payment	1726	1726	2437	1	1	8371	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZqqb2J8AnPhT3L14wspZ4VFPvvLhxKuP1DZz2tTjSCqpwNw6EV
50981	payment	2134	2134	1874	1	1	8919	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3ijVjSHFKyiDpDVrQ8739QakQfXNfe8vtoLQDUiYroYnE6t1v
50982	payment	2134	2134	1874	1	1	8920	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5grRt4gV8AN4hFraAVv9evXhz9DYNegaz4Dk23UhgWUzSsf4s
50983	payment	2134	2134	1874	1	1	8921	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyzgceSz67hr6e5sHr5Do7sueHpgNLWEodBFqCL8NAYDaFKeyV
50984	payment	2134	2134	1874	1	1	8922	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqsyRGoCY74gb9QtzaoaZJf9z4Efo7eEkf2s96yuUEgy57MAkj
50985	payment	2134	2134	1874	1	1	8923	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVw4cDYuvS61V5DnbEZt8vKuBkVhXJZ1nsMtD2z8EQyAc9HNq
50986	payment	2134	2134	1874	1	1	8924	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7yanYXkHYnXV7iWPMmWjYhcota2rKhdmmFRukBxXy1u9bsuBT
50987	payment	2134	2134	1874	1	1	8925	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgdBL4JpnLAuAUg5YLkaxRSigLJBLpGWahxV4gdtLJSmJfdfPD
50988	payment	2134	2134	1874	1	1	8926	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa48pk73TZviYVbwYtTfZEGXX3Y6mCGGb9goJWc3WcE5u1tkpbP
50989	payment	2133	2133	1874	1	1	8176	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8XxNGzjWkJWSRDapsFuoxxYXAwrS6Cwb6UVzn8tGyvZnYpc9s
50990	payment	2133	2133	1874	1	1	8177	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL71g5VFuY686eFUenpguUjiQkk6FBm9rjabSebxL8sTPGwEPW
50991	payment	2133	2133	1874	1	1	8178	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgVhfPJe8UQ9FpmBvPgWhFXcDoSz74fDvjtSrvcD8HLc4gAz9t
50992	payment	2133	2133	1874	1	1	8179	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxMEgZmgm72cnG3NwcndgtZ6EjegAHP1AkCYD2T9qtVwNkA7yD
50993	payment	2132	2132	1874	1	1	2329	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG2XzMWJsZN2oBwnETnY11A6ETSDAZ7T8fNdUpiAAmRrYStkH4
50994	payment	2132	2132	1874	1	1	2330	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7wLSix4sMXbFkMvA3F4iHY5uT29SKa2eqzh2CHr2HUDTkqXQG
50948	payment	2134	2134	1874	1	1	8907	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6anUbG8s1aKotTHunUPVcvwtxCoTiJFZesv8e2cmAocjvXzwp
50949	payment	2134	2134	1874	1	1	8908	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF1NRAUKMKQUahfsKD7h8mhHDeG1EvnybDSigrfvYzQhv2oPxi
50950	payment	2133	2133	1874	1	1	8167	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDJ8vH1CwSL5EZz34hVENhsarUEhttjjAnVn7uUAmnPEU6bRoe
50951	payment	2133	2133	1874	1	1	8168	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPaUS38TixyxLFAs9wwAyE2rRYdR5pjVyFzVHg51jQjv7mDwJM
51108	payment	2133	2133	1874	1	1	8207	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEv8ftLVYzkJcz9dWSrSdyM1WYDuubDwRNqf8UQ9tjyeBxTJLG
51109	payment	2133	2133	1874	1	1	8208	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZspbTg31ckvpcpUiQgCsp73ggWhjhzC9v1Tym4DKJ17GGy6Zv6
51110	payment	2134	2134	1874	1	1	8975	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvJ6wKor2metxZW5ogpJf3wMpaChL8FmN5dy4uk1iXaKiuWD3D
51111	payment	2134	2134	1874	1	1	8976	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzG4xmhwktRY5qESHri4fnNX8EiDzKy3sK9CJabB9NhDxPDRRY
51112	payment	2133	2133	1874	1	1	8209	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwANnHAXUCVqAAyUrjtHrdK7E5yPW4boYMkgvCdC6XVTFfBzXB
51113	payment	2133	2133	1874	1	1	8210	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX82RkFLRXhz8CoTMt7rVfhrc1qSqvvyUqHnKt3esk5vDW7bTP
51114	payment	2133	2133	1874	1	1	8211	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVmsjbiac83rRvq3kajbSNWoCz6FNzSAxZzYhvfYJSFb3VDUCv
51115	payment	2133	2133	1874	1	1	8212	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2gRGvdNowCeJ3QRdY38LMr6n2scN1mtX4TWrwSJigj4bFqxhM
51116	payment	2133	2133	1874	1	1	8213	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAvipoykqaiqo35hHCrotuYzLDnmA6akmLwe4mydWbeU4hu1E
51117	payment	2133	2133	1874	1	1	8214	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfsL8JQoHKvWneqnx1Qk3dVtPG93wgpkTHaaBigReZytjYmKj
51118	payment	2133	2133	1874	1	1	8215	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhgchdgMBnngovSZ3RZB5dg7yNuupxShKo4iyAhiR2dYbsJtyj
51119	payment	2134	2134	1874	1	1	8977	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL8QE6P26FciwqFioCgE6oiX4qsWLpi4MnneVWnMdcsjWZq5mT
51120	payment	2134	2134	1874	1	1	8978	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YmgkMQYGzvXPdVk7hFxnZS8DLkcAdDffiR39gdrHRgEYSKy2
51121	payment	2134	2134	1874	1	1	8979	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwEHQmr8oSc2Xyp1rW926piKvZ3pRKyJYuHNgVoH73u4Hvf1D
51122	payment	2134	2134	1874	1	1	8980	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYddvKWDpCQXYaAtC1KLpcrepXy2tTtjLtpBtjigLefqbAREQM
51123	payment	2134	2134	1874	1	1	8981	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa745yqcQutPN7KKZCKn3wgGb5N4RR5LyckB8LbBNvQswg8XNYH
51124	payment	2134	2134	1874	1	1	8982	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEu5oY1GGiVD8w6MQ8yeorvxy1pefG6CvGtzMxVqBc74uvhEzF
51125	payment	2134	2134	1874	1	1	8983	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhwVuxk5PwKudkve7XhjWVx5d4PvCVK7BmUCMwScVe3ixkDBie
51126	payment	2134	2134	1874	1	1	8984	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY7EUaSxGzMXAoQ7CNC7HnNvpNAv6knRxpc5XTPwzARcF6REjA
51127	payment	2134	2134	1874	1	1	8985	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8ormw9Yxk8SvQoEewNZfnbJWR8ACosa5FQHvPFMdEECcrBBYn
51128	payment	2134	2134	1874	1	1	8986	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEdUFw6368RtEovEaWRKx52tukj8GBwWH3sNs2PJ5G5mwVkLr7
51129	payment	2134	2134	1874	1	1	8987	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh7hgjfYgMpKCsEzv632EHJcz44wthF7C8BG16Aeu9R8zjniXK
51130	payment	2134	2134	1874	1	1	8988	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyvWc3kicyp2sysBSyjksH3tDPVV4x8jQgzSk3C84rqErax8X
51178	payment	1397	1397	1678	1	1	18260	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfmoUgkKbdWqh1HKKYRUHvL9doyWg991MhkRNbzGzn9RWexbK5
51179	payment	2133	2133	1874	1	1	8228	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoVdPbH3mjCJazuwFNigQp21evVZiqeY2PiPNYKM4UJMxGhmyi
51180	payment	2133	2133	1874	1	1	8229	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GucFRdPZo5j7ne8YTNR8rb44zjwQnYRYG96Gt7vxgheuaiJJ
51181	payment	2134	2134	1874	1	1	9011	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8s1HY6srGdYbbq9uPzWvWRCwQSqv6g5Vt8UaetE7oAEd2a2nR
51182	payment	2134	2134	1874	1	1	9012	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYectZRbaZxjst2xK2dcFXaEyv4GExv4E3qpkL76775veoSWP5e
51183	payment	2134	2134	1874	1	1	9013	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQ6toyLSREMHK1yGkw7YQo9Vwud8adsQ7zEY4mnTRXtLf8cmuQ
51184	payment	2134	2134	1874	1	1	9014	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcLKwtx1t5X3TZCNmqN9pzPWcNckTJkZYwafeUX35F7HrcXzuR
51185	payment	2132	2132	1874	1	1	2359	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRPUaDZoSRLyLumZZetDEDXqdxqo41ds8FAXgnKHqmSQYb7sZk
51235	payment	2134	2134	1874	1	1	9036	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtAkr1Gu8hGKjMvdVpT5sS2xjpX8Kq5csqKKGqLU9bBy5nswwa
51245	payment	1397	1397	1678	1	1	18267	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfM7hxn4Lgh6YdxJ5PUonaS5bYF8kbhyzwWXrvJF9SENUozYsu
51246	payment	2133	2133	1874	1	1	8246	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKHYFQrSDTmGpobjjc3kvuf4DVwnHHzCcqkhJzZmsNdwCy55S5
50995	payment	1397	1397	1678	1	1	18241	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsnVxd6LR5e62ZPZkpyahV1jKPBEAUr4bsYafvmik5DiHrBiJv
50996	payment	1397	1397	1678	1	1	18242	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsGxk9DhuLtRCnK5fYNyqFj2mvud5gmQ3a4Qd48Mgr1Q8y6m7U
50997	payment	2041	2041	155	1	1	1	435000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqkf9frLLeuXDgXHtTdc3mGVGCqVQcGGwSNM9qKcrHRCHmzjzz
50998	payment	2132	2132	1874	1	1	2331	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMAE7oo9g6eKoCGzhPcpAgEC9eJWfvQz1ypte1jm2rZeBYo48U
50999	payment	2132	2132	1874	1	1	2332	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQBnHnjjuGZnfJVtkbPHoaVvij8FhfLmwEuR89vkiEFKvQ9RR
51000	payment	2132	2132	1874	1	1	2333	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3diKECd3H7E8rNPY9NAinmLR9k8GsCqbzTir2yV1hSQwg3Xuz
51001	payment	2134	2134	1874	1	1	8927	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyKGM1ZVXmW9iDSjqjeevrXdu7NruvVgNMHsaznywvaHwPYVuh
51002	payment	2134	2134	1874	1	1	8928	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbNCMsvG6o46Rrh3tE38j7iCNYUfzGiq55tyoPW8TonbXqo2vM
51003	payment	2134	2134	1874	1	1	8929	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHcfqUAUqi6HxoXrg6tuY7eZsYxqWGwf3VkumiAwXuds8uYQ8j
51004	payment	2134	2134	1874	1	1	8930	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhcprGdp2Sr9epnrWZHK3jpeE85NBrenDGG6KjxEDUp8GL1E2V
51005	payment	2133	2133	1874	1	1	8180	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58uQvHZZQcTdC65u3xrC9yYxtdXnhEcRkQyyBVuN2qGV8xDrh
51006	payment	2133	2133	1874	1	1	8181	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiH51U3rM52H7kGK6Bt7CS5z8qDjbYqSgQLzxq1UKbknS4zQWX
51007	payment	2133	2133	1874	1	1	8182	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HpPbZG2ggMKu5wcon1xZDnA1mZ4f4eDjNtAwUuCm4APzTK62
51008	payment	2133	2133	1874	1	1	8183	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhnTurTLQNeSBQJTEhTq8SbcR1PnKS62nQVq5nveujpKqFDQLg
51009	payment	2133	2133	1874	1	1	8184	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZD8yFJgXpx7C2GrGk8uXNccBhtLEeaDZYEjSurjHNuWPkCY9dL
51010	payment	2134	2134	1874	1	1	8931	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7Va9TV3CQUHWv7ikbpvijBhWTKVJ685j8ubH7KPD2y2wLA2M5
51011	payment	2134	2134	1874	1	1	8932	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZauGuFKq3JmY6WWAdKUmZzU63bfYa4yr2WjUYxGz34fX55ND8U
51012	payment	2134	2134	1874	1	1	8933	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuy7vnQHq9obmzzmLzRAJZWSg9MRn2PaGWW1psAb59Nz31TntZ
51013	payment	2134	2134	1874	1	1	8934	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeGT4dCeGvE1mZPSHpiqKSjy1V394zbpXvT5WriawG1Wuki4Zp
51014	payment	2134	2134	1874	1	1	8935	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3BQGnGAFSKXLdaNJXgyxgceq5bYYyHiUAzTspyNjBDZ6PaMYr
51042	payment	1397	1397	1678	1	1	18246	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUF4yDoUxiCPqiX9K4E3MvHYP34bqrCTdgCeQpY1JHgq8MAZes
51043	payment	2134	2134	1874	1	1	8949	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt7s5ckb8wXfVpsy5sE3oeWnSawWxDdyqydpjg4TU47iZXBZp4
51044	payment	2133	2133	1874	1	1	8192	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFkrJBPjqPHcdhSUgK3Ueqq8Kz4iaRKNRyVX9YFUVkHt64KFHt
51045	payment	2133	2133	1874	1	1	8193	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRyNci23GX1PA8D63EEUDfDC5yC4ZTQPuuC6PJ8G2i4Ldn1LB8
51046	payment	2132	2132	1874	1	1	2338	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSrZTh3FPjE1Bu9P8NtYg2P6vvzXsUrRM4NNF3J7Rs4XnvJYz5
51047	payment	2132	2132	1874	1	1	2339	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZgRUnDkfj5akksEJ8gmci5H6jzW8BW9tuE5Hbt2TddeLd8XWn
51048	payment	2134	2134	1874	1	1	8950	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdYk9eyjopUHAczAhKxK3Cbf77kiYvFQqpNMh1nMJXjzyPycuK
51049	payment	2134	2134	1874	1	1	8951	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgqESkafGiWNsdyuf3HwK7TyR2c3voLCjC22JNZ3TMk9UoGnH
51050	payment	2134	2134	1874	1	1	8952	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWsSjdCaBMemVptvsqy6ti2UCrnBNT96L3iXAvadn4Rp4HBWft
51051	payment	155	155	2041	1	1	0	100000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1m1RYk741efntVtpF3DtdxcrFY4ax8se6TVmKVBh1DiKcTrFF
51052	payment	1397	1397	1678	1	1	18247	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeDj5nEYGVnAZCUUHiXHLzpQQuEdY3MH7o2jpFUt4H8PRdXdNC
51053	payment	1397	1397	1678	1	1	18248	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMwqS1LLsNXP7mf72DzZTr1twcQQdT26NPPNnTzGsfAejp9QGY
51054	payment	2134	2134	1874	1	1	8953	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkQumWHD8M4db2nYeR6Whwy17TV4eiHo1H22geDfXsUZvHeP4D
51055	payment	2132	2132	1874	1	1	2340	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ49YqFKKfm4zyGkYAnNB2WKgeKnH7FF6y6nzUpwQXCBU1QrBcN
51056	payment	2133	2133	1874	1	1	8194	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ6cEPxQChRZ22Xk2e3FzszyfGzPBt3VcTudTUtH66WMof916k
51057	payment	2133	2133	1874	1	1	8195	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG5xJmeQjoKqTdzTcHeF2UWQbNUiQxchqyFskcLkJYRJWetGjc
51058	payment	2133	2133	1874	1	1	8196	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfkNdqFmeqjPzM3fa5A8JavHNp8bsMu5bN2P3Yuiu4x584ENH
51059	payment	2133	2133	1874	1	1	8197	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7tsyhsdXiTsFmWk87M39tGe8js85gStipnE4wiBNhvHi4DPjw
51015	payment	1397	1397	1678	1	1	18243	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnHrxx5V4Xj7K8eHZFgXTiTAQKFAqoxa7bQfah7LQmX5R7jVMk
51016	payment	2132	2132	1874	1	1	2334	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVAKf4nrfxcoRaFfqhR68QwR3tWz4dzEeKSgM5uN8VmujYnBNk
51017	payment	2132	2132	1874	1	1	2335	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBXXoqdkxwpoS99Wp7RNVDSetkCuJUdWuZ7eQktEEYZfWissCS
51018	payment	2134	2134	1874	1	1	8936	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRH5M9Pw6niKxzVWXLdm3dK82AUAf5gm8L2sNfdePoPiZQpKW9
51019	payment	2133	2133	1874	1	1	8185	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEedBUoimPnW4A8VuPRqH5dsXWKC3GRzYjJHTXeG9ArEG6Nun1
51020	payment	2133	2133	1874	1	1	8186	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYSHeoTjYjGQJLUqYF5LmNFhZ4Dhu1wh7gX9xfVQozvoGawGAu
51021	payment	2133	2133	1874	1	1	8187	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwDrJsyGKHbbc5smD8MnCRYrwhCzxCg8241zVjtrFrCSZrVJ33
51022	payment	2134	2134	1874	1	1	8937	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK1B6tej4E5Jr3tFqCgQPfxoaqTiWYhrcgVMjDKeLXUSndPhXt
51023	payment	2134	2134	1874	1	1	8938	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9sPcCRgXaFgFbNzLQ14rXiixENd8nbcM4p3PQG4BnAqaa5gP
51024	payment	2134	2134	1874	1	1	8939	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ46evEuJ8Lu43jdvA3FSPYX638wNVM2rYrPPXDi92CWYSE8G1
51131	payment	1397	1397	1678	1	1	18255	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1AYT4s1jvhNszaFTEDX2mXXDr6os2BEVN4oRGtDrvmNFtMa5j
51132	payment	2133	2133	1874	1	1	8216	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpshRjU3Uu72oqqutzrGBZuFnjx18heB4ZahHPocyRdh8HWRfi
51133	payment	2132	2132	1874	1	1	2352	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYybNCK1pJRhkpbFrxQ2UBDW4Re39RP1e4DmRGN6x7AgmKgTKUq
51134	payment	2133	2133	1874	1	1	8217	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDR4XuVMkRZ2krX75bddNkR5kmquSKK5buM7XXkkVfD8TQcCqF
51135	payment	2134	2134	1874	1	1	8989	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZanMYSiG2hRNn6vkQ18AiP6rEax5KHFQ6iTXFPghpvgV5gZYTw
51136	payment	2134	2134	1874	1	1	8990	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTnDBLzP4SiLJzLW5cvtvber9vaUo3rKo5MyjXm6CpC21Fjqhe
51137	payment	2134	2134	1874	1	1	8991	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEuB5fteqkdJoKEcnLbxq531W8W3E9FKeyw9imsWi72DUh5YZQ
51138	payment	2134	2134	1874	1	1	8992	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaiFSS53DkmAPTTc4EY8DuLJrW37GshBrCvhQMkcN7jGyxTvNc
51139	payment	1397	1397	1678	1	1	18256	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3oCwWmqeHt3qPwj4r7mAdkoHNGM7mW4gEkTx3AUssCxkbJbjv
51140	payment	2133	2133	1874	1	1	8218	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCpVscyvr71yVH8qXHPgrFGJ9VvTkc3Pp7DtrtkXBRESkBRfUp
51141	payment	2133	2133	1874	1	1	8219	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJpWk5mQU1cFdX8feCDM7tMhaQhsmsUhD6yXj8nU2qYd4e4JeC
51142	payment	2133	2133	1874	1	1	8220	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH1NfjWGPaHyLsM3NEiEoGF6yb9E6i3ujiuKGmLvyxDXcfVoAG
51143	payment	2134	2134	1874	1	1	8993	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTvzuPsLBJHW2bqUbjw2vM9SAjbbt5PKoPypurGzXUSeXQXzEL
51144	payment	2134	2134	1874	1	1	8994	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhrJ66Wb2wVznoQmTZpUuUFgvjUszAAbvkjEYEfX2y7FtT22os
51145	payment	2134	2134	1874	1	1	8995	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKF6E23GmPtAui3c4w7uXtP9tLHEg1nYjLTq9YE8s53M9xDkgW
51146	payment	2134	2134	1874	1	1	8996	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAvYjzVkDUsQ2aVs2bWGAtwCMoDe3bJX4rziqsD1ifHsj9G4nE
51147	payment	2132	2132	1874	1	1	2353	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxiQCWMoymjvtHUyMhtRXXZYGo7YbhxDMfqEAJ6DHjZuwbfZjK
51159	payment	1397	1397	1678	1	1	18258	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnke5eLxoCHQkSWNbjGXTNagkt9cHwBMCoCPBGpokZHDucqdpn
51160	payment	2132	2132	1874	1	1	2356	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVa8a51WSo5aQ5XDYwvtGuZfUFZVrVQLuz3roQCMNPaRMBRAMX
51161	payment	2133	2133	1874	1	1	8223	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoHKbpQK1ebgDQzD6cTuQmU2Rq1ZFKU3WzGaGB4Snss4Ak8khK
51162	payment	2134	2134	1874	1	1	9002	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7C67ThMEDC2UAQamfPjKDFiPLHHdgrwP9zSwETwK6KNQDZPXz
51163	payment	2134	2134	1874	1	1	9003	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTNEG6Q8ycJBKBStECP52WPzJ73q5u5PmcZXXMBREYSmN1B2dd
51164	payment	2133	2133	1874	1	1	8224	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhqnZkUB5Up7qpXyEBniQ2F1AjKDsqePr8bh1Y4X3YzxyJhc3
51165	payment	2134	2134	1874	1	1	9004	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzKaf6LedRaYpthAjBzEwG42SAtwUhHz4pyE4qcavUMUPozjMp
51166	payment	2134	2134	1874	1	1	9005	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8F4LeoPvY2TgeEVKcTvBDU2abfU28rhZ9vLUSJPGiARqqbiZ2
51173	payment	2134	2134	1874	1	1	9006	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyJdX5i41TJxFmQXymNhpixGVne81vasxGxZgWRxeMYZrpT5ih
51174	payment	2134	2134	1874	1	1	9007	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSQAFSZQT7efMecR4BWvaNCW7fXuPvDfhLL5i2wxD46Jca8YAs
51175	payment	2134	2134	1874	1	1	9008	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7VUAQRZ6XUMT6nyfDk9ZZJ21XxKF1qwNJ6YjyXZ5SCWA4asuw
51032	payment	2133	2133	1874	1	1	8191	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5aXGV5ExLgthkzWJyrQuY4YAJNedMbmCpVxEaD1fzQyM553j3
51033	payment	2134	2134	1874	1	1	8940	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAhSPrwp5JNC9bbBrCJaNZr7mBiG47LXzyeoo4rw3jnMHfb6d7
51034	payment	2134	2134	1874	1	1	8941	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFRiPJEqzZ6RZnvn7V3iCzvR24mByJiPLakpkC3YzfDB4rK51
51035	payment	2134	2134	1874	1	1	8942	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDcDvZdTrsVUJ8naM17xQpLLVtTHxoKpqNbzRebYCV27VLFPTn
51036	payment	2134	2134	1874	1	1	8943	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaeBEKmsm2GEzH8BSBbzZ4SgJReci4MdgAYb9x8oAyu9FtbLPc
51037	payment	2134	2134	1874	1	1	8944	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8wBha6aE8GFKhUHns6AakwAyHkZfDaS2kRB4cGdb1742AeBuS
51038	payment	2134	2134	1874	1	1	8945	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeLatSBVDXPKDDXcUyWpZypWMBJ3GGkMHDnmurHWh6cornSWib
51039	payment	2134	2134	1874	1	1	8946	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQVzy74Rf1etitKSNhebWhnxoW2qSvMePMn7eKJR6EuDVeXon5
51040	payment	2134	2134	1874	1	1	8947	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmAnnKPcFEAzVyTeB5cdhggWaKUpQcwjBpJiNjTgABRAxVeCrh
51041	payment	2134	2134	1874	1	1	8948	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZHvJgsZm8AoiczkLQxa3iQkgAXKNERLdGqjtF9gH9rQDcSSKr
51091	payment	1397	1397	1678	1	1	18251	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYurV99uaDZcfopg3SHrzjN9nq5h6tqEVe7aHtFTEi18m7Y4t6t
51092	payment	2133	2133	1874	1	1	8205	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQAtfBja3ptysJGYWByCj7x5GYnEnxuvADTdxLCQ7ANLQdDaz8
51093	payment	2132	2132	1874	1	1	2346	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYesa1SqA5JoNxueJxRqiRpKPbTu5NCUqcLw72EAQsC8Ao4QHjR
51094	payment	2134	2134	1874	1	1	8971	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHkmzsaZPq2iCYYK9nQjQQW2M2rf3eombfGZZk2656eYzF2ne3
51095	payment	2134	2134	1874	1	1	8972	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcCYht2C8VE621nt31uVY6TqEbWioZei6Uz5X9KHqfN91irsqX
51096	payment	2134	2134	1874	1	1	8973	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfjTWaLFkbFDXmuTjtzP7QSjYcJ6J1yoDr8VfDvmHQ3EYSz1AX
51097	payment	2134	2134	1874	1	1	8974	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4uH8bkNbMPznBFzCrEq3FXTt4H5h97Goa3X2bMB7aJoAwwEUr
51098	payment	2133	2133	1874	1	1	8206	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDW3wVaFbaCbnwNnaPWxznx22cpTCoYXw7Nqi3TFK69anFM4Hv
51167	payment	1397	1397	1678	1	1	18259	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpjRr7jNm7tftPTXpGP7ShaVgCbD5hVNLiqTo7yUwHr14JaKxv
51168	payment	2133	2133	1874	1	1	8225	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7H4YV3ZBoYSrZRdTGYVCwhCu1MsPEp979NsQodd71ew1hrUg8
51169	payment	2132	2132	1874	1	1	2357	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrmFEdnARNHwNcjz1gMcrbWuAiJkxjFcYAeEGipxm4aGALZan4
51170	payment	2132	2132	1874	1	1	2358	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn2513xjKDWzibSTLENYLCKEosWAicmgjaSmQhPYfyyrTDUQdn
51171	payment	2133	2133	1874	1	1	8226	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFCi8KotWsRdDFS1oYSGqCWqy8SVAwHjYZqsxxpFq3gNfurfPa
51172	payment	2133	2133	1874	1	1	8227	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3rvGa32UWt354LQgZpqo4hBbCBuGTpCJaLZ1XNQ8CBzPzpMV1
51225	payment	1397	1397	1678	1	1	18265	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYShnnVsaEU877NdkEEU7mRgjD5RPCxZwAhF6w78jYhVYD2bdb7
51226	payment	2133	2133	1874	1	1	8240	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYRSxb3EoFGTryyN1oYpEzjiMLGqHpeTkYiHfyjQ655RUbaFAw
51227	payment	2134	2134	1874	1	1	9032	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tknrb1KgpMUx4orvmR42hGKanZicREkLwnyc3E4ntKvsTqUd
51228	payment	2134	2134	1874	1	1	9033	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6fwTRmVxDsiUD1Ba9bwXDqE99Tojztbn9ZQ3QVAvaNqh7sh6G
51229	payment	2134	2134	1874	1	1	9034	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkEgwi6kiSAd7RJP9c7K3sHpWVq6r5yMzFag8XxddBLLdan56V
51230	payment	2132	2132	1874	1	1	2366	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEJr3XBHy4J2J7UxT1ZDHvorRNis13vjyseZTNeeauNSQDXrrg
51231	payment	2132	2132	1874	1	1	2367	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoKqJD73NWCWcp43ThJ1Eatz6GvSnmYrb51apKhqsrAtGrwirk
51232	payment	2133	2133	1874	1	1	8241	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8ekTzMtRbSebJoB5cAcAhMbt88479szHV2ztCxGU3fSVFd9z
51233	payment	2133	2133	1874	1	1	8242	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHnp3Ma3ba2m9Ur3g2pZW5uc27Z7hhpjE5GByZPsrKaGeBVg8Z
51234	payment	2134	2134	1874	1	1	9035	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGFJP2jxWNpmVriAR2rZJxD29XYQtgiMe1eQiDZH59QrzTR2QR
51236	payment	1397	1397	1678	1	1	18266	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGNSL4VVqgRJ2NyW5ybYiiKYGEs48Hbhp3eCSTy4egAq6V8orm
51237	payment	2134	2134	1874	1	1	9037	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWNp1bRX5bpaEn5WuBPaK1j3TAmJ1Y6nyLDxbjMvrD7b4rQgrq
51238	payment	2133	2133	1874	1	1	8243	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYb4YhZiECwzFuuL56V6rqPmrPWSuhB2Gz8cuJnkpxMRYX6hq7U
51239	payment	2134	2134	1874	1	1	9038	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHyYcJMhyiYjtiGti1YSwwHKr5ABTDhFQ6395z3bcXNxRo8iNG
51060	payment	2133	2133	1874	1	1	8198	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbewLiu85f9SWkuJz27VsDE2LXTihin3PwJstHkZCbuJLopvmk
51061	payment	2133	2133	1874	1	1	8199	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS3GwwetNf11mFfMZZNf4814ovjscUpwAp2QP6ivnxTWew53YW
51062	payment	2134	2134	1874	1	1	8954	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZro6WEQFJ4Wf2iy1RfG6Lxwu8UGJi1t4dGWLe6qEe4erqLbBeY
51063	payment	2132	2132	1874	1	1	2341	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsep4uU4xciz4jygREd39YUB3AQ27dRWMXmXaiSBnGhcGA5xvW
51064	payment	2134	2134	1874	1	1	8955	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3S71xkHTUS6yaipCFjAsdAG7H2sB4q3GwGYXGXuSJ8tfSBigS
51065	payment	2134	2134	1874	1	1	8956	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZ5q8iHFUi4umhpe1S126CJ3v6LPjngmqkC5Eu98gintQzCgTm
51066	payment	2134	2134	1874	1	1	8957	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU7ouBK4vJg1ywDqMcgwxGxZR8r9k8eTkQPhnYfQCg8s4PLVUu
51067	payment	2134	2134	1874	1	1	8958	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV5joYm9jMUJKPGUyA5HWEfGiw4yh5f48P6w5Zv1zVRSokqPXg
51068	payment	2134	2134	1874	1	1	8959	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtiwmfCoPayrf3CuUa8Mbx9y8dD4wGHrKY5njsrhdpyoi6RoHz
51069	payment	2132	2132	1874	1	1	2342	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE1hTVn8TQ3eAqJ4RSA9VSg15NCJ7Q3n5ngB94uiz3voo9wWdL
51070	payment	2134	2134	1874	1	1	8960	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJjCmmGxUcDXJbFoLgNGgNaGLzKPRRaNjZkTWzHXYfyAHFeo2W
51071	payment	2134	2134	1874	1	1	8961	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPVbcbXfsCextx3jGznUgDfG4fGgaUhSJw5Rq1mVsvoDFPN7i3
51072	payment	1397	1397	1678	1	1	18249	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW95ZA7zYEGwV3SvzXLfpYsPDWQnc3vSDFe7R12UZrow182Cj9
51073	payment	1397	1397	1678	1	1	18250	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWPHoMxx3GMvoyVbpod7g2evqd3s6AJcs6B3VPjtwKkLQJ6Ran
51074	payment	2134	2134	1874	1	1	8962	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYLY55xNaVULqzbnX1fJSEqbmKTFtuQNnN2jedA11MhofxaXjn
51075	payment	2133	2133	1874	1	1	8200	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxsqPQijKiupuZ9NUQrAM8o38wZdWLAyjM1w5NfVcwCwERt5LB
51076	payment	2133	2133	1874	1	1	8201	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRXePqk4VecL3xUgk9HQPMFakHzRfsLgSDzw5SDd2ut5X6FiRv
51077	payment	2133	2133	1874	1	1	8202	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtjFxbBnmPSZvvoxp1fboWaBjyhupoxkc2A2zWhEE5gFceEFvP
51078	payment	2134	2134	1874	1	1	8963	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrnD7qLyyYJe7DBaEUtMdAaB6XfLLUd5P1vFcEkRYQWr6cxYLg
51079	payment	2134	2134	1874	1	1	8964	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZziMQd27Qu5NSVxHWZHm8tJEyD3jaqYqt78ebSZBXP8zcSxUH6
51080	payment	2134	2134	1874	1	1	8965	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa42k8kFecZPyUt4AaEbgow971jTfaxyNqxqy1vbKNVpZsPPwA
51081	payment	2134	2134	1874	1	1	8966	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwM3TzqtCf1hYx7stN6iQPPSsUJ4JVirhBmGsVjyqsZ9RD2uzo
51082	payment	2134	2134	1874	1	1	8967	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn6VvUbK5LWYQfhuof463pLiYb2eSvJ3AeDQ3HGWg3fG15eWvk
51083	payment	2134	2134	1874	1	1	8968	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZocZL7XxhZ7acXDebWWfkHs57fQ1BwcoCuwss27djpedzFeLid
51084	payment	2134	2134	1874	1	1	8969	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSTALuAJvvmMfAe8KSM1Nsa2y6FtKHru8P3eu4x5e6YjXLejBP
51085	payment	2134	2134	1874	1	1	8970	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa22E9F3nPb78Sjadf4ZB9m6eyvnsR5FSKyRwCNuzpHfzdQnpST
51086	payment	2132	2132	1874	1	1	2343	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YmzPHXWvSXSXu1xKVpnQ5gxGWbzNPMsRnaULS2XXBLPZf7gy
51087	payment	2132	2132	1874	1	1	2344	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMNVPDWtRNhPEr7RYGurwnkF8QNLGB7kyphWTgQebextgJ6ztd
51088	payment	2132	2132	1874	1	1	2345	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrsskhk2HDNxATvH2jw6CjffA1LFeLdF6PVYeHAbwcdVq9qrsp
51089	payment	2133	2133	1874	1	1	8203	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJfKg4paAYNQFmwEPjxDv7covC2N6cUoSwhQkexWwUBoBQxc8k
51090	payment	2133	2133	1874	1	1	8204	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXnyVCBZWg9tsQ1GS1Efe5TepK4wpgb9Fo5Qc6utYR2C5kHNC
51099	payment	1397	1397	1678	1	1	18252	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRLAiDv8xtyLC3cF4qacQTeUQBz3cSgN37hY2aLFTRcMhovxU
51100	payment	1397	1397	1678	1	1	18253	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEqhDEcCEqZEmv2xtsd1L3z41qHbTSa1Hut91PSJpCSDKZF9EM
51101	payment	1397	1397	1678	1	1	18254	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzPcW3ZWaMMdwiMWEjd2fNA4XWJ7WDje2NBkAFCke9bDHR47yY
51102	payment	1726	1726	2438	1	1	8372	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	Ckpa8PQFRDKPw498BkVmRoQW21b8UEXpqK7tQL28a7T3waBkA5fis
51103	payment	2132	2132	1874	1	1	2347	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9MYgWT9mes93WRZJmqVVDKiaBoHupDCfS7fbHvSJQxi7Gugbb
51104	payment	2132	2132	1874	1	1	2348	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvpCrNSpwkgShY8F8wALwziyQaH7My3ozBvmL13mBcDBzqqrB
51105	payment	2132	2132	1874	1	1	2349	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4o4B5iMxiE39dQc2WjNdeuBbHh3K5rWYqeRa98Z8zR7j6vyh
51106	payment	2132	2132	1874	1	1	2350	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXBef3cCzYzPF5k2rUjt8C7v4nMTt5mKF5juumezdE8Nynztfo
51107	payment	2132	2132	1874	1	1	2351	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXCUdBc3mYYviMqzg5vh4igBiM3iqUhjD9EpwdsWtbLTZYAf1Z
51148	payment	1397	1397	1678	1	1	18257	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvSuGxsz98zSRfMbE7vGwmwaRANYHqUEXNRgfQFj9ApZRB9ek2
51149	delegation	2338	2338	2338	1	1	3	\N	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaWVydMnXDEidzKzX3xxjKqekjUpXtowPjyBAH923WEKqxUKiC
51150	payment	2133	2133	1874	1	1	8221	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAdHZZGuuxkRyGDKdjGiKAtN7UhboqprQqnLxU3wgZoceuKnN
51151	payment	2134	2134	1874	1	1	8997	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuAqJZxNsTq6dyqcmvRiTfgeHiTwPepV7T7hstkgfiPQQcv8NZ
51152	payment	2134	2134	1874	1	1	8998	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqKDSwErgdBR9dbN6tt3LrDGnbpKybZ2eBNDTmLN1W2Wk4Dm3s
51153	payment	2132	2132	1874	1	1	2354	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1vZG41dohk8SUh3R3ep2gUqVBwE8MKKJLzHmmRhBvUDBjQVwN
51154	payment	2132	2132	1874	1	1	2355	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkbCzgy4G7VDEnwzjJPX8Jqejdhj1oD4pmQCjTRbiwnvQbfJt3
51155	payment	2133	2133	1874	1	1	8222	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5iQez45kT2GWzGKCcVwmBWXzHA1ePQ2ZWmps3Jfnfo7zREahy
51156	payment	2134	2134	1874	1	1	8999	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHujZQ9trigHaU6hm2ttZRVmeJx8J5byy3PvzG8ybwiE4u2WDv
51157	payment	2134	2134	1874	1	1	9000	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXzZZC81f9yaMa4HRV9oFHnuPWv7VPrgfL8J1saNCY9QGvXZqw
51158	payment	2134	2134	1874	1	1	9001	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPBo6dew3BRQmu3na6K9Uczfp5W1QyhM2kULY9954K7xAPCwM5
51197	payment	1397	1397	1678	1	1	18262	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHf2RUFoJ9znTTub7x1yrP4uyrLVdk8rxqSYhQV4NJBButuSNc
51198	payment	1397	1397	1678	1	1	18263	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaTBWzVhb6jaxJTcuvYzLkHB36FFMWEh2TaUgrdeUYErZPaqEo
51199	payment	2133	2133	1874	1	1	8232	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcphdz2cKcioycJFTGRcA3CP4HdecuUGUEZ1HXDZP4UpZ9fuyq
51200	payment	2133	2133	1874	1	1	8233	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNJA2DiWETFZxwZw3Y17B164y99Gwt697mr2Cv9hiaiK23uRv
51201	payment	2133	2133	1874	1	1	8234	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1SqjrZPgZNVjy3ovvnnrjh9XAvrLwiVKHDZFExAiaH5YMfDWe
51202	payment	2133	2133	1874	1	1	8235	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtS4PsuvNxeMHd3fgS4T8GcQ57M832mQEwXGqXrZjo5p15kK6L
51203	payment	2133	2133	1874	1	1	8236	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6TkmZMY25TWR6jVQpYKo3NEWWSvYWvvfMsHbvbubZAThz61nj
51204	payment	2134	2134	1874	1	1	9019	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmes7Sf7LXAaXHxgDx2scA5WXGjmvtkVhta3VYioqYdmjjaYeN
51205	payment	2134	2134	1874	1	1	9020	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbkPmk2awPBQ1EhrL98wNx6ZwViqpPnfb11ZdXnKvmwXBHcUWy
51206	payment	2134	2134	1874	1	1	9021	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwziZSivsAzDTGo64Lj7bXx8Qni4o9LugUJAtyEB6AyWHtHir6
51207	payment	2134	2134	1874	1	1	9022	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWFJMpm6gKp7AGMd1KQn2pisGSBAdw95WgB9jDEKa2BbGo4JoQ
51208	payment	2134	2134	1874	1	1	9023	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDGTuRwiDpUmtM18YRREsbjhS2HD2kr6qcf8fgn8ZhhYk7JA9x
51209	payment	2134	2134	1874	1	1	9024	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUCQm3K3yHY3tcwanCJ3BWYuwethJHSnC1Ri5AmzPQkpTvTNQp
51210	payment	2134	2134	1874	1	1	9025	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKyfkkqUMu5QmrotC2Z6nx87UrHBWEmXeX3St9aa6RGBYK5yhr
51211	payment	2134	2134	1874	1	1	9026	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8pbyumtBXh8k3AYXX5Ja6SGQdSH8UibxYSd4NDNZ6YokXHdTd
51212	payment	2134	2134	1874	1	1	9027	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZyq52ccPdxniNbefEPyyq2p5JyBUHoJLoVMxYBqVw4MsAQPyU
51213	payment	2132	2132	1874	1	1	2362	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAcwAEwi7jknnBsEeMmsFZLV3P1NSpUifWMjTDJYkRwPjXbRcQ
51214	payment	2132	2132	1874	1	1	2363	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkryp2SXvjXuUA2dCfUykRupXdSQQGx4mDjigZb2qutRGh3VeW
51215	payment	2132	2132	1874	1	1	2364	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRkAEjGaSUf2ZbyfWdmyHdiU93tH469ExaYD3boGacuHnzvTwR
51282	payment	1397	1397	1678	1	1	18271	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQRyHC6ZSULnoi9Wu2AoYJbdXZEfuNpwoQ5xdpJnCiUuqTqhG7
51283	payment	2133	2133	1874	1	1	8256	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9vHtG7wTidtwgBtS3AgxZT8rYiWyxarenAgzNeumdHv8Fadn
51284	payment	2132	2132	1874	1	1	2375	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1GhBDS2J8RX1qxVb6nxD7BEoDxhSR7F3LWaesThTW2ehK7yun
51285	payment	2133	2133	1874	1	1	8257	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR7GhqCvsnMDGfgZZ97TgMkxeRersY4ggdhnvgrbe5Sor7Amxo
51286	payment	2132	2132	1874	1	1	2376	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRGpwghw1FNkj3qAwTS9EeR3HUXXpiZifYTTHdbmzzctFh4bim
51287	payment	2134	2134	1874	1	1	9058	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfuYgWewBF7CzB5RxLCvVSVFdCk14GcraLQ8JhYBD51cjZm8Wi
51176	payment	2134	2134	1874	1	1	9009	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwC3fhE13Yy1MkFkM6g1RSMzsbyD4hZsLA45zRhpYeS1Qv7Gk3
51177	payment	2134	2134	1874	1	1	9010	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRmLc3VtY4CSYE5zSATwhGai95XYNnyVACGx7vsJw1C16oRsfy
51186	payment	1533	1533	455	1	1	0	2000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfFPM4CTyZoR6TKPnWGTxKGGiVkoUJJyGmKh427tpEZ1xoyEra
51187	payment	1533	1533	707	1	1	1	2000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5KsR622nmyyHx8ojhtqt4nwzPKxvD8xtXCiEAX1tjwo73y1CT
51188	payment	1397	1397	1678	1	1	18261	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw5uz4ZqMTMRu1eKJqfdbuQvMN3n9AsakoxXK8xgxx8AawGLvz
51189	payment	2133	2133	1874	1	1	8230	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr1VVyrd8jjGswy1WEE8fD4yGeLfcYH71TS4NrMHrYLgxpQfNr
51190	payment	2133	2133	1874	1	1	8231	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuGsuJGAA7jQtibH6k2gZxFtWyLpjrspEF7KrUn3PxrB1PtVv3
51191	payment	2134	2134	1874	1	1	9015	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzddA59JWLHYeJqNpuW6AJBDsEez5V169GsZan6jbdtKz94vBw
51192	payment	2134	2134	1874	1	1	9016	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApiUjnBNnbXUn4x8DFeKmdvJAVJwi5GahieaG25SP52Wym7QJ
51193	payment	2134	2134	1874	1	1	9017	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFTMaQAueWHz6419W1BUx4ZZ2atWAuv5arbTb9nu8kvzQGWuar
51194	payment	2134	2134	1874	1	1	9018	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8RQpurD37xcghTr6VCNbsiMwern5CypWf3MzPKP8T8GuDfH3
51195	payment	2132	2132	1874	1	1	2360	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLchXTrrcEJDWYT6ciHsvgHGgDqfute3YsgKsQAZ2UDocdgiPM
51196	payment	2132	2132	1874	1	1	2361	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZETF8qJwx7oiWnwho8GuKtxLTohu7j9brVeqi5kSEVVdpfkFx7
51216	payment	1397	1397	1678	1	1	18264	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS9FUMadqtfjrjXnc14pNuW7Dip56eN8tCMBv1Ge9aJUuHMr6w
51217	payment	2134	2134	1874	1	1	9028	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZbMNP245xroKbp8ygrtXvxUpmJGM9M4ZLA9Tu9Gntv4Zmorxg
51218	payment	2133	2133	1874	1	1	8237	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYscDUxTbviJRoC9G6fDmabQvAASuXJSFT5HQuq3JEKkiueTi86
51219	payment	2133	2133	1874	1	1	8238	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcZk3TewAdL54uX28aca6diWxWUj5XocPC4bPvUTTL57NFBCPg
51220	payment	2132	2132	1874	1	1	2365	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA8ufbuneRgo2R9KgT8fTy9MHKFwpUuCqAiyhCQjRKQMRDQaZ2
51221	payment	2134	2134	1874	1	1	9029	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZok4PV6stFbb3JEetRHav64S3FCgL2rpw7hSSDZWxGmbvxWwYr
51222	payment	2133	2133	1874	1	1	8239	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqM2taw3wVSgUdiMN19M6N7cAq2R4VXQqkw7ZgCoH8M4rcMXAS
51223	payment	2134	2134	1874	1	1	9030	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZs9XfGvAErhDB4oJR7GdmPtG5kkJogmcyVbvUVypSnUqsqQKfe
51224	payment	2134	2134	1874	1	1	9031	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbdZ8ojxyrQPMon5Qg98oxPyMTa3pyTL16q8bQiCnaEQ8PfEdx
51254	payment	1397	1397	1678	1	1	18268	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYujzP6KxY2mnTUdWcebEhJm3pnYkEroGQ4TV9AGfN59NRPCVcc
51255	payment	1397	1397	1678	1	1	18269	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoHU7QbjrBiuDV9tDCUszbeHDHwAhqiqqP9PLFKMxEvP7ihQTu
51256	payment	1397	1397	1678	1	1	18270	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu17DaiHgf8cUZnPksewoyvq5TEbhgdZS8Ctb8tR6scwbhMnEa
51257	payment	2133	2133	1874	1	1	8248	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGqcazruGKP6bsKCZbBUfgFN8UfQYcMXA6NCvP7RQJwfNLVLYd
51258	payment	2132	2132	1874	1	1	2371	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcgN2wHWddDV3KEhohK1f22sk9E2Hgxhrzi61gx7yE4HroW7Ep
51259	payment	2134	2134	1874	1	1	9045	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjaiUC8Dz7qAN8xMznv6mfJExvgbsAQf7G7TminYbC2Afvt8td
51260	payment	2134	2134	1874	1	1	9046	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS8pyqyHVJmDWu4BBvWir7jdP4YssgoJb7dJzac3KrTve5LFGL
51261	payment	2134	2134	1874	1	1	9047	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkLL3r9q2NQSXVDhgBVxAsvgSHprGeUZdwjeW3DEqwAhnp61Dy
51262	payment	2134	2134	1874	1	1	9048	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbG4RJyCg1ko5bNbrvr3Hf8AfnQTcDxjR1rz33wJ16Emp8rLBx
51263	payment	2132	2132	1874	1	1	2372	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpwLWrckrvHCvkao1DEQPapwRRbPxPr77KuSvhX8cxCqD7YcRu
51264	payment	2132	2132	1874	1	1	2373	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnm7tZZgdqqYspcCC1hJQYfS8m5eSQbGuGkweqBxFm14rq7xxk
51265	payment	2132	2132	1874	1	1	2374	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVGjDa4Vo6F2qSZi3ZvfhZXjLnV7x6vKvxg1o7UZjf4mu2U2CJ
51266	payment	2134	2134	1874	1	1	9049	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5vvQXfqaZ5w9DTTcFH651AHQW7HxuiH2hRAS6nQjYscxg4Ftx
51267	payment	2133	2133	1874	1	1	8249	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9DiGo8uLyEAwQyEMSKdxsyxHDKKKAesbLrDzsSvC73JqUTAZW
51268	payment	2133	2133	1874	1	1	8250	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyEx5NgqoFBxw58xfofcx14Rk829tDuYhPkF1dVb5nBV2ouLj9
51269	payment	2133	2133	1874	1	1	8251	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvh4i2XjAAsdytbtfnVM3Y9RVvPFibTNDvb6mvacuY26AKYgJd
51240	payment	2134	2134	1874	1	1	9039	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw9HBhLbGuu1BXBQ5qAMs6k6EPv4WvMsCans74e4wc5EQ35F84
51241	payment	2134	2134	1874	1	1	9040	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBcXcHngFsDEWW1cXVKFABpbgaVcv2z8VQDurqbigX5JiZ6ELB
51242	payment	2133	2133	1874	1	1	8244	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUhGfYVhNrEZiwsoawyphfuiB6nVNuzbWw8GqdVLDXdCJNWKb5
51243	payment	2133	2133	1874	1	1	8245	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVn4offf28FSHcJPPYjugW6XLfRHTQrm6sJqiEzBGitQZNqhM
51244	payment	2132	2132	1874	1	1	2368	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhHwcB7NMSSRWFRJhbfydDaNR2u7FQMx8XJ2qaGaQ5DJgPixoV
51328	payment	1397	1397	1678	1	1	18276	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTtc5cCThK7hgZjQRsxKKE4Zq5CmNZvDp5EEtE6q1Vkoxg4J5Q
51329	payment	2133	2133	1874	1	1	8267	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYrHuhDDYyHDWkGiEZC7zRQ8uqmwtv6YtkzxC9Z5FqgwrW56Vz
51330	payment	2132	2132	1874	1	1	2383	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4ChsswatscXxqmqGBnQauwTXqs2f4A8V1pFteGGjQLzu4S2co
51331	payment	2134	2134	1874	1	1	9080	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPR2FznEVTN62HQJBUDiZHVZMrMoPYvHDtMN8jJ4LDsy7oshLm
51332	payment	2133	2133	1874	1	1	8268	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZJmRP1fCazGZach9VCxdnhKNA3G48pa8gZ2bH7zpymSgjgX3Y
51333	payment	2133	2133	1874	1	1	8269	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZg8veLiwDTAYqk3FE5LjWeQZhp6RgNBkm4giiE6KZRNLfWsvuV
51334	payment	2134	2134	1874	1	1	9081	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvjGGDiLk1hKwxdB1Cuge3V1hrUrZhVaJZPB9dfJPcCFqTD9WD
51335	payment	2134	2134	1874	1	1	9082	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1rLso5ncp9MTQGJqCnxQ9pozW6Mr18wMNgMGBbFaRpdAbvTNL
51336	payment	2134	2134	1874	1	1	9083	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtAiBKtWv7evi4rnKG9BW44VoavJYnuH6i6fcN9vmGbXd3FpVD
51365	payment	234	234	2439	1	1	0	100000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZApgitWdK5KoGGyJAPPFjWJELZ7ThazcFxko9zpoWD2dBz4Z8Y
51366	payment	1397	1397	1678	1	1	18280	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZszpmqnSbG6CJ4quVTHyJ6NkVxsH6BXKB8u9XnsBAzGZMZMSMc
51367	payment	1397	1397	1678	1	1	18281	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5PgiihuwsL5HhGsDUspyWFZrJfkFiMgmqdc7PS7pojiEeiYVN
51368	payment	2132	2132	1874	1	1	2388	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoPubpvXVCHbt2fD3LGBjsZQX5ZCZup3NZSUv7m26WP1twC9px
51369	payment	2132	2132	1874	1	1	2389	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiuXKk7QSMbriiUXXyaqCA1uhxN7KBYDTNm2p8dM35AMS9pVW2
51370	payment	2133	2133	1874	1	1	8278	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtdAynKRS7BenVxcfjnQk6piH55xmzwZUvZtSPhFbDhafrciMr
51371	payment	2132	2132	1874	1	1	2390	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvn9s4YJs2CMtxN79Xu6iAgDwU2FYFwyCPXW1ZkwNYYcEVoXyf
51372	payment	2134	2134	1874	1	1	9097	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhXsbJuqYuSLVqS4WGKVsSbAuJpvLZRS3mySRZ6Qpw43y7Xxg6
51373	payment	2134	2134	1874	1	1	9098	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFT8n3VNidTwyqV9HhVK3a3G434g16NnW9FjokwcDU2FxkqUkN
51374	payment	2134	2134	1874	1	1	9099	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBxq4VGLazWtPwMncczSkg7johuV3Mam9VLyH8L5rPuvwecaxy
51375	payment	2134	2134	1874	1	1	9100	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE21Fdei7rP7AquNpfYELqFe8Tf7SEz7ZNjig6bci41rkUQNrR
51376	payment	2134	2134	1874	1	1	9101	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB4Urfg3zwPPZGqTyGC5HSKknyvqrmpQ8KEkXshFRL7DET2isZ
51377	payment	2134	2134	1874	1	1	9102	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw6ZCu9vgWqkXREQvxau3SvCx6wCJGACTVCib8MMune5jgBXm3
51378	payment	2134	2134	1874	1	1	9103	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAbE2XSS1iPVP84W5MdWecC92qnAmy6CUWm9UV7HS3Rsc6gao
51379	payment	2134	2134	1874	1	1	9104	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk3wLaxonWQu6yVZGi4fomo5wPSsRpaKe8bCeY9yFShZ4z7AeV
51380	payment	2134	2134	1874	1	1	9105	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBaSQkmF7AcaxvHka2HF8b1q3HGQneymzmyPTtpjPtqTxdWueU
51381	payment	2133	2133	1874	1	1	8279	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGvHyx3iwi4B1XoJwbw6u8Rb1tqPKxhS9MRjK7tyu9C3KFnVXP
51382	payment	2133	2133	1874	1	1	8280	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgrL6G46AhPCnkjfWVFYHZVwmgvFRRnzkJQ9z67TNCucqCPou7
51383	payment	2133	2133	1874	1	1	8281	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjoWoyHFAVU5qKcBDxdke5dPdau5dZG8qiAwnZwWUZnxkA2wof
51384	payment	2133	2133	1874	1	1	8282	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZATwHBMEy3TA21dQdp6MixcS8S78ZeApfWpouuLmymAD7hjxvS
51385	payment	2132	2132	1874	1	1	2391	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUTcbxtAA99h6erHrVaX2JSL5u1PuU5D86VA9kWuKmsT9A6fUC
51386	payment	2133	2133	1874	1	1	8283	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWZw2c94UrnRZFHTnt5sZFKAscHWGz44yAnL2t9b2p1k1oub9A
51387	payment	2133	2133	1874	1	1	8284	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhwc98FWQdnfaFtb7UmEj8XxZqMnZWUS2445pnMRwPjoozNAHV
51388	payment	2134	2134	1874	1	1	9106	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7pYi1kBtNGqC35BHdWrVfVQ4pA3vtdpKooGVUqB2nCpFiMADZ
51247	payment	2134	2134	1874	1	1	9041	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZX9WtegRC95SSQXXwd27M6Y5ZmuvQFVbBgUi1ucCBEYyQBvYL
51248	payment	2134	2134	1874	1	1	9042	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFctD3B9VXPFESfpBJNnLCeDhguUMDHMmx2MGZBrrhrF2faCsf
51249	payment	2134	2134	1874	1	1	9043	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYenchkfXNuz5pjPEqpz7SsfTFQTSnTYD75CAqkdbBn9ShX1688
51250	payment	2134	2134	1874	1	1	9044	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUxJU8XNsE9X2A7PrrSHNQ9GuxwDtaCpWq5jAEcxwD1BrbcBwn
51251	payment	2133	2133	1874	1	1	8247	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB5GA4iGfkNe5nJnCjXv3JCAamyEsG1tja7TDwVCmST7XdBn81
51252	payment	2132	2132	1874	1	1	2369	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFVJUMddFKS67bzhTuFz8rakxpkzWyvFKH5h69V9iAkhoKNXU7
51253	payment	2132	2132	1874	1	1	2370	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB4sECWEGRAyvEaMzXAvpvGiZGquzBbohEwMAan1a5trT8cLDf
51337	payment	1397	1397	1678	1	1	18277	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbR2sAcBRvafd1W7HJru4kVWFpE5fKFYZgSpzuPmunNUozF6dK
51338	payment	1397	1397	1678	1	1	18278	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1wxe2HXDE6KGFkAAfzDYEkXfjBNBopoJtDfWPiFjFbp1HSgUk
51339	payment	1397	1397	1678	1	1	18279	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHQwAXxjyFzkYDyJcs2AcSxzb3rLmJqhChyUurs7XofgcmW7LU
51352	payment	2134	2134	1874	1	1	9084	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9y8cEUc7bUrGBiJDodvFwo3rJJKn3MTqRFtW7NNR1V2AdGXk4
51353	payment	2134	2134	1874	1	1	9085	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5Mbcc5jdc9Lodk4whq4drcq6H2LH8DNZbbwgEV2eUThQEMMN
51354	payment	2134	2134	1874	1	1	9086	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGVzNLnJxVDMVGW2XB332n72JrBrmC9q39KFFHuPed4BUCGDbo
51355	payment	2134	2134	1874	1	1	9087	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2Bqq36hUHgDj4JTnWzXAAfLuncr5yQ1kscg3H2x2fNGWzNtw
51356	payment	2134	2134	1874	1	1	9088	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZY8Cswk81xxAw73h9qH7UF1m7PrSxZQDqUCkJ5kU2gUWBeYAfr
51357	payment	2134	2134	1874	1	1	9089	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2DTH4wBcbokRkHjuSPbVHs9v3DA92rKPGT8md7RWNNfjeN8mt
51358	payment	2134	2134	1874	1	1	9090	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxgotZ88hc9vDWExUR3rYauSR3sgTpwW8KfzVPaWfreVNLLR3n
51359	payment	2134	2134	1874	1	1	9091	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXCBH4yvmsZVcU4j39ZNg8jNczASrLiGSzn9Jy75cLnakLUyVN
51360	payment	2134	2134	1874	1	1	9092	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd6unH3AQMSfhwveeBGqJmsEqVS4Q7mZjq7QqGRgLLKxjqXZoV
51361	payment	2134	2134	1874	1	1	9093	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmLnMwtS7N8kfwf6cFbcsXs9oGbq6rSt1gziGoFP7onx1V3Spi
51362	payment	2134	2134	1874	1	1	9094	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7mQE98k43XQzL55fAa3zWGWmzpco8Q3neWPFqPjSTjadednLn
51363	payment	2134	2134	1874	1	1	9095	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSCBXWVak3TGUXty4i3LVmjFiUYNfhZ63cL3d8ym4HzN6o9p6
51364	payment	2134	2134	1874	1	1	9096	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1b2pDB8EqfQ9HUX8VAhoSbFdZJFbV3hvq5NkrLwQyTCDoiHN
51396	payment	1397	1397	1678	1	1	18283	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnKLyzJUJxVrAwsrJaQ34e3xaZssanDq4q7HvpnUjzV9NPCXgX
51397	payment	1397	1397	1678	1	1	18284	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYofkayYx7RasoiBuxqfuQYKJGn1Dtk7rqVSqSpZahsQuE7rNAL
51398	delegation	2163	2163	1483	1	1	1	\N	3031580	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7oeXDhB9taMKe9oTkpRq9LWQyD35kimWS3K1f7R7JAfLwyyC
51399	payment	2134	2134	1874	1	1	9110	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgmSnJjjrWFDmNXwkvtjQn8xjLmKZSYMESm6R2JEgebHAjLKSQ
51400	payment	2133	2133	1874	1	1	8286	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGKo6B81ndEwLY1Rm6LQiocszZRb8PFbkj9R7aEVPyZtbC61Qv
51401	payment	2134	2134	1874	1	1	9111	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZhJyE3fabQvu9NDDhJ9VUvnMeqKYU7KWdWseNSAt21udz4MUD
51402	payment	2133	2133	1874	1	1	8287	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAY4z1DqQc1U17K9NNX4Kd6mNgXN3xaaw4i2ehfZiaRhKRu4q4
51403	payment	2133	2133	1874	1	1	8288	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5YKLRbwGPCzWiPwEG9f8o22oAej5bVPi1ff5Tnj4yXJKNCZta
51404	payment	2133	2133	1874	1	1	8289	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdHhARCreZLcjCrKJ4EmZ8JyWAaH7BTjHZxpp72xWFjtZhmjbA
51405	payment	2134	2134	1874	1	1	9112	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAo7aLncy15Wu97pbjZrUHAt7QbvSTia3JSQDZRW6LQ3FGpE2b
51406	payment	2134	2134	1874	1	1	9113	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCFQNpbgoCqUhcchDs2K4KnfJe4cd19dUF4jnKkXDXTJ4MExLd
51407	payment	2134	2134	1874	1	1	9114	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLRrr1Ss3HGcLHJXMp81CwVrE97ditGbKhUBDqLhEaDoinAXkn
51408	payment	2134	2134	1874	1	1	9115	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrJXgtgDYns7QrykPYMHwSn9ib8PxNLomKk8SYPsoqVD8tYW9r
51409	payment	2134	2134	1874	1	1	9116	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGbj9TnNVVKFVN1YfjwsCQKFugjKAmJtWGabbBFuScEpSPyVqT
51410	payment	2134	2134	1874	1	1	9117	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCBo8NDXd3XPzGSyEwpfJ429zLHwueCsRx9QbhSXFU65y9tG4E
51270	payment	2133	2133	1874	1	1	8252	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirAPYQGwRRFWf73gQTMta1DNXNKxjqCSoKrNLnCNe7qAwcwjN
51271	payment	2133	2133	1874	1	1	8253	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZh9Fo7CkZicYm3baCJa8diP4FNfF6gY2Te7rb5oHVNhwxL2Mwy
51272	payment	2133	2133	1874	1	1	8254	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYvUgkW4ZV8Q8meJ56T3Zur5sCp9ryxbCSPb5sro6jALMPMWzq
51273	payment	2133	2133	1874	1	1	8255	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa74s5qaonPBdGWT3JhuXf8wzALkfXvgmoL1KDWQVUghcR5hbqh
51274	payment	2134	2134	1874	1	1	9050	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGC8ziRH1CKG78eougZPgTDHfiFwstu5jGCYUwxZTo9Udun53k
51275	payment	2134	2134	1874	1	1	9051	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD4bNb9xt9Keubg9E2Tcx9cfSUeaXkxC3c9y3RQjwsTUqvRtBA
51276	payment	2134	2134	1874	1	1	9052	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFFQ6kuEQC2WBN3QSCbsHFRcxbLKKvVX5AC8VWw7i2d3mh2cSf
51277	payment	2134	2134	1874	1	1	9053	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7XxpDfuRpoPsMDyisN3tonY4BgrRVhhTL4nmofRetz49Vs1wx
51278	payment	2134	2134	1874	1	1	9054	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9H64QYBRmyNN6v34HqemGWPxNBwXeu64thTkEfSo6UD1XDhar
51279	payment	2134	2134	1874	1	1	9055	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ82dQk1Pm18S3NhGaf62noavnQvsLSAZsskw2mnbNHouvK275S
51280	payment	2134	2134	1874	1	1	9056	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhdC2bB3VMLVXeykAhMoc12Wm3TpzicbSSTkHrBPYoa8EXhUmz
51281	payment	2134	2134	1874	1	1	9057	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5b9GuqU2jn3cYn57Ae4kJQvoZK1afTpeiCwEcGiDgKc4DkX2U
51291	payment	1397	1397	1678	1	1	18272	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZx7pFyCZJ267rYqzBs6tbuWbcQSYy3cJEVXJiAx7zHU9iW6rCw
51292	payment	2133	2133	1874	1	1	8258	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyXk88dVKaXQqzAEA4kp94pPjQ8CzRWEGuF7QRiFePSkUyD4v8
51293	payment	2132	2132	1874	1	1	2377	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPMYfsEFzLG4VTWMUMAoWXWCFkMfkNcaeFuVS5hwRUZxwE3vKM
51294	payment	2134	2134	1874	1	1	9062	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZc1ikKyqr3egkW3XW4SecLujqoKP5wUhken5E9sG24KkiHZj3u
51295	payment	2134	2134	1874	1	1	9063	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFYtEM2k9oALj6STgK4USuyahuWmih2sMst2VjcRcQuU9pAcTM
51296	payment	2133	2133	1874	1	1	8259	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK2T1ZrvE7oE2K2GLQfWknEQAs9SSqZmKdUnswP88TeFyYT1HF
51297	payment	2134	2134	1874	1	1	9064	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLPRwsrFtus3pd8gLrZdB1HCoFqHC4bhnsNxLkBKFNQTMZToHq
51298	payment	2134	2134	1874	1	1	9065	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKNE9oMfo2m1PYgNgoBKV7gB9tAHgUsuUCSKrx39jnpF8i2KrD
51299	payment	2134	2134	1874	1	1	9066	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT2kuRDcUhDs8wDc5aumQyHAbbdqQWjkagq1qr8wXyEAjRAcrd
51300	payment	1397	1397	1678	1	1	18273	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBLDYbxfUECnHjaHiebjodeQ5wkfRn15PcEYu5V8gz6DoTXCU7
51301	payment	2132	2132	1874	1	1	2378	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiMnsfhWbZPeNbcDz9BgBjjXp2qFS2sLQ5aFK7YoAFDjMPY2QM
51302	payment	2134	2134	1874	1	1	9067	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvc8tNaG7Xuozdgct8Sgbe2nzdXm22aHAsrYTRYeQEF8nGfbt3
51303	payment	2134	2134	1874	1	1	9068	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyyRpHD8kL2cS2aB8R26ZFUkJZbUekmJGgH6AMjp5qQWmB924f
51304	payment	2134	2134	1874	1	1	9069	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRQTKVf4MC4d62jYfcjf3HQQHT9JnEenRejxXMkU91bFMQieQj
51305	payment	2134	2134	1874	1	1	9070	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd9QrsD6V26Lz7NDMJTs68SWu73vUbU2q58ct58AyFizNX8mmQ
51306	payment	2133	2133	1874	1	1	8260	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPozvcwenBENRUao7ARggGz9Mh9MRrLK8ttwr93WSSJW52Ge2J
51307	payment	2133	2133	1874	1	1	8261	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZumYc1iT71sTQDZLiKYcF43KW2WaoBNEb76DroZWToobFGtmN3
51308	payment	2132	2132	1874	1	1	2379	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLsssRYqfJBpigjmLwy8GBiypNcVhhLa8DV4WoymCTG64c8ye
51340	payment	2132	2132	1874	1	1	2384	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUFN2FLAi3fE5UeUynFAvdqN7g7rwxyBwS6Yrm2q8J2Er3znXK
51341	payment	2132	2132	1874	1	1	2385	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYq5PY7MqMmFtWYyPKsxvGxxYciqDPHzGi6szd83jyJSsuhNSB6
51342	payment	2132	2132	1874	1	1	2386	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgLB6LpX6Y73ZDEkADmn19tuYsLV6h9GJgF4JPUKcvMV99FCJA
51343	payment	2132	2132	1874	1	1	2387	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4X3bSbLbHyBr95mVqdcr9WcP8jeSxEQjtDsZqJZw1WYvxwN7h
51344	payment	2133	2133	1874	1	1	8270	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAZ9KXGR75aGbJMt59P1F7PxgH7VhjJZuce3fuZ3vdhPQzLbj
51345	payment	2133	2133	1874	1	1	8271	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbrXpav7Sk89bRxVtmhQVMzvDF9S8o2Hx3y1acfxeuMWfxviFV
51346	payment	2133	2133	1874	1	1	8272	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV63NNwi57njq9LLnnyBM2mp6CtdqKffPUJNY1fyw16eYjmx7g
51347	payment	2133	2133	1874	1	1	8273	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXTCZjtFyCLW1b8ng982dpi8kqTQ1PQofUvkZeVP8faztGhCv
51288	payment	2134	2134	1874	1	1	9059	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkfT85JLDwqSZK7wYTAYuacTTi1XVGCCxB4Mb3YadXdipsm53o
51289	payment	2134	2134	1874	1	1	9060	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqntYpuRZcEYL7zAN8sh3vTEeZivVfHroZ2Jk1gfmacbx3Hmu7
51290	payment	2134	2134	1874	1	1	9061	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6BDXkr14MFuEEBfYSNNXmQ3TGW26WKC4ZCMdhDcNoEQNs8o6X
51309	payment	1397	1397	1678	1	1	18274	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyhZqmsWb7AQVqoqXP8rv9dcRZ9xThzxUr3NxdztgikjAtguC5
51310	payment	1397	1397	1678	1	1	18275	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdUEXj1XTAtSQhKThM1De29RsPhGdCyLBVVaNEf7qrkcexhrRS
51311	payment	2134	2134	1874	1	1	9071	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyqBjBrXLykzWaYY7amELJkx6MogvqBh7FXC4PUE85D7rbxxvJ
51312	payment	2134	2134	1874	1	1	9072	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG2ywuUnTVaopXHBkFZaaeLTomrBY3VapEA7QyhD8wU9CZPc8g
51313	payment	2134	2134	1874	1	1	9073	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeFg75LrgwTVz182WcmsifnpytKMdAZk8NNsDPTDBxiCLAQmHm
51314	payment	2134	2134	1874	1	1	9074	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZagiyZ8DKCntUE7ybNf86Ri8zRcCzVccaDjfxauQLF7rgKJ5kT
51315	payment	2134	2134	1874	1	1	9075	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRCsvo79aQT8u1PoXdrjqdLinsWx1jo33Nq1wPVFhoxnLMhEWB
51316	payment	2134	2134	1874	1	1	9076	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFLGLwrHzAGS4rT9vJYAZFzegsE9S7e1JB7dG5EpjfWZ1u25Fk
51317	payment	2134	2134	1874	1	1	9077	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiLpD4f7HSq8vDDebGGqAcN5JcBKEYVRAeFwKGYLV591zJKEVZ
51318	payment	2134	2134	1874	1	1	9078	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3WWst8sFPqpSS5vh8m9xMyoNsHHnAvA1J5yPDbVLBJ7oQvBrJ
51319	payment	2134	2134	1874	1	1	9079	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYutD1Qzaiou887h64K9DCGBtHknLEEfzSqw4ienaQNdcZW4q49
51320	payment	2132	2132	1874	1	1	2380	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeEwEmTH5wj5yUfem9Pywk4UfnVM9KM99bwH48UcwfJBDGoJU1
51321	payment	2132	2132	1874	1	1	2381	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHobddWDAaP1aVUog8LS3UP6hCJJmM7FSQPhwRv79RD3CrSkHS
51322	payment	2132	2132	1874	1	1	2382	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiG4xphjQKPBp2gTCTH8YHNvcG4Xza1J7jPeVPu9DpS5MFSK7v
51323	payment	2133	2133	1874	1	1	8262	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFtNnur8cneBWYWgttv8f418XNP4enAJXTJCi4sxDfbo1KpWVA
51324	payment	2133	2133	1874	1	1	8263	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLegKKcSD4UcnPjTBtb1YPN8CnZHPfH2aNguDxu14YK8YkfUJo
51325	payment	2133	2133	1874	1	1	8264	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa564njUh5ieR1ZXmXVGMBW8oNzVSx58kbQyiVje5FssrGZdrAa
51326	payment	2133	2133	1874	1	1	8265	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kDqVEP3vKeWrrrmxY6LLqcXvbsBzrVoBpVbGTkx78t5j7Gcg
51327	payment	2133	2133	1874	1	1	8266	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsBMmyCnb1fKSKL4ztxsCFuDRzW5TiCA2FSbrfTb2GvmLsNvD9
51392	payment	1397	1397	1678	1	1	18282	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeU3Feyfpv2Y5LtMSg9SLCWvCsPxBeRoAjG3c4Qkfpsm5EL8tZ
51393	payment	2133	2133	1874	1	1	8285	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZMPAfDQ9PhzwRLSnZBUf2Py8bQppm26Eyjp6XbanhzPwjhFWz
51394	payment	664	664	664	1	1	0	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiFLe51oWEgrFLZ4bqHwmpMZsLu2zgntXLmWJKmsap1jLGfcQm
51395	payment	2132	2132	1874	1	1	2392	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvH7LiM2Vc2AY4ei7rHepehx2yjki14VdEEnRXG4GMth9pusgh
51443	payment	1397	1397	1678	1	1	18288	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKJUqPcL5jCKCg4uwaw1zM9UN71ft94MTPedM59pcEnF7uKdJF
51444	payment	1397	1397	1678	1	1	18289	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxL4NQdnui2KR647V7GeCXKa1CjY2mrybAVMwDFhFeo27gpCWa
51445	payment	2132	2132	1874	1	1	2400	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvNuzPbLSEwykzubCy6XwLqMsAcKJmRjxq11XHQFiQYSdwEjww
51446	payment	2133	2133	1874	1	1	8298	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaucJJ5b8pknS1vy2wh5anSVUQTfQLkfE4oN7gnV26yGU7kk5K
51447	payment	2133	2133	1874	1	1	8299	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYagtRWaFLrfXSbcc6bRmMsMKqcUdjcBSDSdVrTFJ7DEkoEWXq5
51448	payment	2133	2133	1874	1	1	8300	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjWhSkPbRVsbeCcoSvzmr3Pr1GGBVDJwkDYzYY8UQNiHJTfYM
51449	payment	2134	2134	1874	1	1	9132	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZho7VbD7DtdMrgbHRcJvhwWURZCCWfjWR5PRhwmL6MnWdPY28s
51450	payment	2134	2134	1874	1	1	9133	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFN3EapqQutGM5ViWGYddWDe3o4b6yBwp5wCn74SjjCiDsF1EZ
51451	payment	2134	2134	1874	1	1	9134	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1boEChQhcQcm6ZC4BPwBdjnMcLtLuDs7dJ1qePHtGohQTwRv9
51452	payment	2134	2134	1874	1	1	9135	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhJ95yjeZWqC7k1Vys1PqWAz1VJawrF2JmCJEP3stWDB8sJ4wa
51453	payment	2134	2134	1874	1	1	9136	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj3Cm8P1HoGBPKGF6TNou154fPCf5gu999DGPrezj4QGFP3KP8
51454	payment	2133	2133	1874	1	1	8301	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqebZPXFm3uzg5dGz2uenpZDabywqWXrjxkVqdjLdWn1S6dF62
51348	payment	2133	2133	1874	1	1	8274	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpp1rD17EgawK5JJLNGsaLApbfcb8miy1f6UWnxktXYUiMcXve
51349	payment	2133	2133	1874	1	1	8275	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTbGiecMDgSKzga7qN6rd81BALu9QMUxYDpyBV1F2cQwVhzNMH
51350	payment	2133	2133	1874	1	1	8276	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBk53YCRMfLr5hb2LRnFcKjxXSpJrx8uvkLnQBzq2gz6iQTf8E
51351	payment	2133	2133	1874	1	1	8277	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMTmnMrhh2qaimnEupAdFPvJLdcjYuAErErBSyHReTDRiaa7e
51482	payment	1397	1397	1678	1	1	18291	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDZ7Tx3SW1ZF6LwYkcc2LKyQCdvF1BsArte57PV69kkCdTzxu
51483	payment	2134	2134	1874	1	1	9150	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS95j4wG6LWLS8QLNB5Z3nbHg25KDo3cLwSv72JTbYo8u23tMe
51484	payment	2133	2133	1874	1	1	8310	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQPtX6gzdcAk6CdZGPc4rHJ36uRR3cw2zD5Q43D3zJEZ6PC4QP
51485	payment	2133	2133	1874	1	1	8311	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMZk1zqURhVPMB1p9aXv26xudJkkUarLX8vCpLoNkHsYv31M7s
51486	payment	2134	2134	1874	1	1	9151	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCwuFzAvE6ndZHAgGRwxbLqtXzuhwL2zTxtnaUAuRWVVgMT3W
51487	payment	2132	2132	1874	1	1	2406	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYonrEiGGuFgvAYVEp5oTh4LBvWmvxiMfGuvzckaY5SVSJ5MBn
51488	payment	2134	2134	1874	1	1	9152	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC9yCf95Dvx9eUuZgT8cDKAJBG5MFAFeyuPwbFCKqk6qL3Qfgb
51489	payment	2134	2134	1874	1	1	9153	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkzF8sLZ2nmSJtRko8SRaSd6Tj4cVhABV8srvcyBhFbmhU3Ys
51496	payment	2134	2134	1874	1	1	9154	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJiNfpghMtvcMdoDKw8A3AVvFjwDgCfpZRSX7sYKP8ThDc7aSB
51497	payment	2134	2134	1874	1	1	9155	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjpAyJRyqwcWKZCE85QLdeVkqua6c4gxVGXnNhbvrWZKGQSr2k
51498	payment	2134	2134	1874	1	1	9156	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjgTqShaz7Kpoxi1H7BR5FTuvKijfR1mCy231i57n1LPX49KRB
51499	payment	2134	2134	1874	1	1	9157	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeoxf6zQnkYjL24huCyecVWQbux86g9zA6is7b9DM6oRCjTo3q
51631	payment	1397	1397	1678	1	1	18307	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVi5e9djgsU1DDcamh4uwni22gJYAREh7r6VD9pdWwW7w4ZbLx
51632	payment	2134	2134	1874	1	1	9219	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepttFxAZrJYvnEK9dgedFpunkgsgQDVHRtC87JawuVzVGYBmB
51633	payment	2134	2134	1874	1	1	9220	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuL7AQySRMckpPGALtj8b8P5XGmj3LGv2VgQUEac67RNDijffb
51634	payment	2132	2132	1874	1	1	2429	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNqyRbyRLycB38RZKhJ1LXQppwQe5HgB3zphyxqgSG33roHKbH
51635	payment	2134	2134	1874	1	1	9221	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2dZ9cbxckphgUrcRPckwPfTT8nU7FMpohXdQviAfF3JVVpMpj
51636	payment	2134	2134	1874	1	1	9222	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSKXFyjsUVNqHHEjEPqty6BbuuMT3LPV288djMkWEBg8jJ7jnQ
51637	payment	2133	2133	1874	1	1	8348	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaExwy6nbL65QRBpYkhNKfA3gEVU7RmPrHTB3WVwvmuzUfjFRXq
51638	payment	2133	2133	1874	1	1	8349	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3zJmAJxS7aCXUeYjHaCgw8SDyPDwuuYX8pBWj8cDa3maY3Umb
51744	payment	1397	1397	1678	1	1	18319	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBsobvnFGMZjJS5Lb3rBEVkQdJG1ynt2ijLFgYmJuPHcNjfPu
51745	payment	2133	2133	1874	1	1	8378	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSmBfWk43vVTQMdaMoUwsC829mFhE3ge7pVufxQ2tHV1z59neU
51746	payment	2133	2133	1874	1	1	8379	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZdtCzLjaF9qwQj8XQ5TLsPTP8MTbMzLD4Fj6Tzt7jjk5GTpQo
51747	payment	2132	2132	1874	1	1	2446	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5WHkNr37w7iHxL3PSevymm14P8KiRqQsVyRWQHUN5YBE2cSsa
51748	payment	2134	2134	1874	1	1	9272	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtpcedLar3frccRpBrrJSyK6tfce22iiU6eUbffyLfHuiPuf6s
51749	payment	2134	2134	1874	1	1	9273	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYZR9je4FtzbAY3Xs5cdZuBh7MdA3Sg1vGa7otvofS17MgvcLZ
51750	payment	2134	2134	1874	1	1	9274	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuSpaPGg42eF6jMH6nAcfgTDZ72YfTvraLmQY3Qn1ahqFW8f3N
51751	payment	2134	2134	1874	1	1	9275	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2FXw4Wan4UYZzmFZtapc43JEgkqmT4mh3zCjLF8eUo47ew5Uu
51768	payment	1397	1397	1678	1	1	18322	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZGB8PCEm7M316ua2WRL3oE9Wy6JHc7V9FVo1jHciTwcH8paF6
51769	payment	1397	1397	1678	1	1	18323	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJRvJ1ZzUiwkNvaDsTxwWBKmFwA5CMeJqSEzFv3su9ktJXcSSP
51770	payment	2133	2133	1874	1	1	8383	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcysCyfou71Yg9j5y5xhGtXbUznRWhfyp922kLvfbSQZHsMmy2
51771	payment	2133	2133	1874	1	1	8384	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcb6RebHjJTMjxs9eWULzcYvbt3D26RuzpFzFmB4ThQ6BHw63s
51772	payment	2133	2133	1874	1	1	8385	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2ckJtjjkhn7Gm8BoWtgT6YBdiXEybJFixoTu3EjR9HvMVCDYh
51773	payment	2133	2133	1874	1	1	8386	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfVwfoGh3omEvMgnyFp581DTFrxc5KLVH9hJD4T5zudTqbfUQr
51389	payment	2134	2134	1874	1	1	9107	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcr2UUxVCXpBroVm35YargDcGtwtRuhZbf1FvAdYYHLzrAz6YP
51390	payment	2134	2134	1874	1	1	9108	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu17usF46B8mRpUeJv6aJANpFXZUmNjPrn4YRdWYuH2s8qBwC5
51391	payment	2134	2134	1874	1	1	9109	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi3v7VQVi2nywNBBNaFXs7NDoyKRr6K8z94Aje1mB3iPcnxvYN
51415	payment	1397	1397	1678	1	1	18285	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3RLGN1zRNqcv9KJhfpEzvFmeqawWBEkQ5QrJRDVXPiVq3bGPz
51416	payment	1397	1397	1678	1	1	18286	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaRehGyuKmVzVkanuFyWpyx5QR1jRPydG9RFXKU5H5jt7ZcjBe
51417	payment	1397	1397	1678	1	1	18287	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbPKTcnHpDoDFB488qvPFR7Xig5epQGGrkgG4F3nggytHYNqKe
51418	payment	2132	2132	1874	1	1	2396	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYotgHsumoEiNDmxRqFNYhkfVEYee5NGVLCF2yMR7i5myNVaDkP
51419	payment	2134	2134	1874	1	1	9119	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtifV96ij8gmL4nK2xE7zZHkCcu7rNm4qSuJ8CTxJeJU7JUbsu
51420	payment	2134	2134	1874	1	1	9120	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEND2VL6pcV7732ax2K3ggHe8PPU5APkfKys1WFxeeUSVpm2Dx
51421	payment	2134	2134	1874	1	1	9121	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7EprTM2kC4mfTsLHhHTKnpSLS7f6BFyuHmTZWoD3pC9DnpQFA
51422	payment	2134	2134	1874	1	1	9122	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZujKbfuschMEBpbuNTJE1GsAXznwXxKV4Wt3erJ76USDG6NaUF
51423	payment	2132	2132	1874	1	1	2397	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvMxyaXgpKSrCY1bzyYFS31vG32BoL5rG7eRrnYbgHGyb9ikS7
51424	payment	2132	2132	1874	1	1	2398	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQvkmYHwcu9WZy7A9JAUHibbDDx4aAbBeLPWtsRoiBpvZLjQQL
51425	payment	2132	2132	1874	1	1	2399	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJzvqRKHChsgniosYB3VRCqT1gStUk1hXwfUM4isyVHxy22n43
51426	payment	2134	2134	1874	1	1	9123	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLTAdETeQX7tGxnW1HyujnbTcttHoYMHJiXV5ktL1QZEkQGfZp
51427	payment	2134	2134	1874	1	1	9124	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQ9pwhnWFhXtmxtYhujK8hkBX5fDY9MkzjRMcMFEaKXGiHC4J
51428	payment	2134	2134	1874	1	1	9125	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkZXQRGX8Chxg9WEL3DbvUPLJCR3TrvqM68GE3zNMooedD6k6K
51429	payment	2134	2134	1874	1	1	9126	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsYqe5gnvjPYPXpoRtWWEcgqQ166nH5y5tiqVTSWyX8NLDdPNY
51430	payment	2134	2134	1874	1	1	9127	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoBU9uSEDr3bsxzhw6oh6XcbvoNgjv88tcSopk3FTb7HVZswn9
51431	payment	2134	2134	1874	1	1	9128	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyDQWLkV87ZefTf2Z6qYkx3FmvdicUjWoq7aoPSga2UPAF5qs
51432	payment	2134	2134	1874	1	1	9129	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3FYPNkXnU3BNZKnHujDerCouosiD5azJ18FLNDB1QaKPrCKDd
51433	payment	2134	2134	1874	1	1	9130	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnExSR94wNWNGjmemjN7XtNE4xbcGtDbsoSYWKSWzUn9GXvpXv
51434	payment	2134	2134	1874	1	1	9131	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCXFXuHPFJAmBCftfh5JNyYMKqR1jVTWuGG3swDteKV7wZDjqr
51435	payment	2133	2133	1874	1	1	8290	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLdYM4sBGSZJPmtCwoTJXbyHmvB8PrTmWscTWy3SzK9Tnp6RBP
51436	payment	2133	2133	1874	1	1	8291	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVXS4mBhanvqBCsZVCLRcXBK5nJtZDnW5NnaJzEn1RVZEB351T
51437	payment	2133	2133	1874	1	1	8292	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjyYUjqNurhfFruMy5Fr2fMa4enjDsDZs2rGyQsR3wpJ4XfqiH
51438	payment	2133	2133	1874	1	1	8293	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6ouBoL6yksBxPNJ7A1C8mXwUsmMHexPV2etkmE1KtJHeStU2S
51439	payment	2133	2133	1874	1	1	8294	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuym1knSAVLxAaSU3wyLc5wZRU57G9bAjgeYxf2HS6MCSpC74W
51440	payment	2133	2133	1874	1	1	8295	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxGunmHLZT9pjZjhEakATbLYh6Du7s5Yv2HNiJkwsw17BdNGGq
51441	payment	2133	2133	1874	1	1	8296	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdmZfN4JAtWN4cyMd3b32U2sUrRPGz8R44eU4DM5uZRRYUMTDq
51442	payment	2133	2133	1874	1	1	8297	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjHtg89AP6RpzLLH2C7MfQBaXxxnG4f1n6vPm5q34jF5t5bDRc
51527	payment	1397	1397	1678	1	1	18296	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWerKy5wTjfx3jrzQ1SsJZKSi9kVxG1DZqYwHLsSwbJmmwVqQX
51528	payment	2133	2133	1874	1	1	8321	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfLUACszugbzX2zWDuxogFSBxhAuyGY4CuCs7Td7TPFZeim2KX
51529	payment	2132	2132	1874	1	1	2413	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKkEygvoNrRT7bZcM6e34dax1Duvsq12E3L68ZV6RMf7wxhhhw
51530	payment	2134	2134	1874	1	1	9171	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfqvTaB9C51gthUAEyybJFqQ7RsHTWBgRQvDDWk6bCc7suGnfA
51531	payment	2134	2134	1874	1	1	9172	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYredEmJsKAJzfuWDL7dNYG88DtNim6CPCJPLLW8asYFf2a8CBP
51532	payment	2133	2133	1874	1	1	8322	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiUUgv4D1cPizWbA1t787qKQyGdaSVL3HS5xeAFCyUtR5ZQYm
51533	payment	2134	2134	1874	1	1	9173	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4HyP8DDynKfQz853oooUYdbYoGpmxyTJcdNp7XqX72pgswY9F
51411	payment	2134	2134	1874	1	1	9118	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa44SVFz57EeiRmYh3TduHRmECjNvcCPWMMqibUMJN7fbNXPMDF
51412	payment	2132	2132	1874	1	1	2393	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9WV8mkcsfZ1TDyB972mvT6KJzQoyM352esXKF6QfT4REn3Wd
51413	payment	2132	2132	1874	1	1	2394	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzoCz5oY4ip9pM8VXWRjAvcUr56bH1wzAbTrsHHfimhvEFuCSn
51414	payment	2132	2132	1874	1	1	2395	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5JUTXBGqjF3QsXpaWrVdpbgCjywE3GDNKHe2yxY6i33SQN7vk
51463	payment	1397	1397	1678	1	1	18290	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn1nfdSo9wNbCGofg6TsSUZoCo4QL9gfB7C4dwzUkAmHtxpTpQ
51464	payment	2132	2132	1874	1	1	2403	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCsHFAJ6GNtPJRJyYPZRM7TvgXtRRVMjcSR96unvx1wdngRBJ6
51465	payment	2133	2133	1874	1	1	8304	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMsjMTf3aGqMc2c1J1td32N58rP24zvMK3xLWaKokWbxK6o11X
51466	payment	2133	2133	1874	1	1	8305	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsi5NWvzbBs7x8wFwZ6w11EjtfxsdTWZFsQBtMQ9btemQmpAzu
51467	payment	2134	2134	1874	1	1	9141	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXf8py4aPAz8gbacRKHgwqwqu8cANZSBvEgGh84J1RSXjjYPLs
51468	payment	2134	2134	1874	1	1	9142	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCznUT5dqzEE43cX8XxTXgRETnqVpcBgxA1DgWM3AdDcoMxMZ
51469	payment	2134	2134	1874	1	1	9143	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcyWLLsBTjje7LBwnDyWBTp3t5v6nA8knUPSuWKv7eoFFaTY4Z
51470	payment	2132	2132	1874	1	1	2404	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAtqv3ZyngiaHiDJq2a9oTkcaGYWUNdzAqYReGqJAZFoLdpGP
51471	payment	2132	2132	1874	1	1	2405	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrkjNawHqeukoKMU5Kbaysc1jkQaVS2rToykm4uycG5HXfQXjo
51472	payment	2133	2133	1874	1	1	8306	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHU4DJL1q8tx2YQXpmNV52x8awgcs1xpByKBGmW8yxd6pxQcrX
51473	payment	2133	2133	1874	1	1	8307	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYa9jGsuwnqxUPRzFPWbAKg7hMGtfP97SAnqaAqqgTw68qpyzEF
51474	payment	2133	2133	1874	1	1	8308	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUDa3CF32RAuuaThN6HHhhPZDwxsFeKRNGhzmtM6eZhwQkj4ze
51475	payment	2133	2133	1874	1	1	8309	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxEvCq4FTzokMnXYciyc4RqG7JnQuYBvwREuviw3bqvr7qLWXh
51476	payment	2134	2134	1874	1	1	9144	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKYyS5wpoyzCGPLZM7jdfzjGb6y6ZEd8cJRZkRsyqzUSpBYmwB
51477	payment	2134	2134	1874	1	1	9145	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqumcWebVHWdokQrtczVjrMKYxkiMQ1m5gzHMEzaWB2PhYPnwW
51478	payment	2134	2134	1874	1	1	9146	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdEF2iu6dXBFJMFPjyhov3NEsFDJCJeu8nHxtS84HjNfRzPKon
51479	payment	2134	2134	1874	1	1	9147	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjB7yX3Fpdss6xuAqG9xHB2BwJRwWAUCrewfzJPDewpDYvTeSL
51480	payment	2134	2134	1874	1	1	9148	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTVTT8kP4J9VRDyB6TYS6HUcb11cSWFGx99VxyssgfRzFBgnPY
51481	payment	2134	2134	1874	1	1	9149	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6RqkUvpvK4ypKCZCamZ7NcSENWzHihH8XKRioUhvi3nUu93gw
51500	payment	2134	2134	1874	1	1	9158	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwSqufBmxiCz4MtWXEGtH6ftcABfZ24QaZw5GZL84jTSH9iYmC
51501	payment	1397	1397	1678	1	1	18293	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYitemgd2sykzQc3hwQuWTQ2yTuWuTVQi56VPwHaudzc2LMqJG3
51502	payment	2132	2132	1874	1	1	2409	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZE2pMexu9qNmu5SJGmQWaXC99p2FrRU1indkrJjogTHKckyKnP
51503	payment	2134	2134	1874	1	1	9159	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCL5qQvXNEBuXQb4yzoZc4V5xSP7kHD7sdyJVor339wNpYemrg
51504	payment	2134	2134	1874	1	1	9160	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYetzXQ8dJ9fYzZz6Ta9h85zXhZL6bxb4DVXYQc2v8TTGVTYTSd
51505	payment	2134	2134	1874	1	1	9161	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvVTYBUfRfxBaLLMuMFWYcbH5MS5f3bAGLp7VHTiva2HqHhAVU
51506	payment	2133	2133	1874	1	1	8315	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG4byJSsroQQDqS77RYSRWTEr6VG8JPC5mEKQwjEPQ7VLnEvoH
51507	payment	2133	2133	1874	1	1	8316	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo1hiJJsSgTPCVaitx3YTNUzSZBBgFzNrguVCW4bzxpDvimhSG
51554	payment	1397	1397	1678	1	1	18299	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh8Q7KEKTpS6mMdLTRvfz3tA4Jv6PuxWrJc9a27hNeVTaQjRnK
51555	payment	2133	2133	1874	1	1	8328	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNx86rK8mzwMAjpwypjFmV2d4JohYtLoFF2Rp2zxyHcUgDENie
51556	payment	2134	2134	1874	1	1	9184	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPNcQjw98FA6FDFHyMyHpHwJAjVZwUXUBDyNSLzwHAdyQfVgP8
51557	payment	2134	2134	1874	1	1	9185	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY1mNAfSE3jAvzKmx8Yv6aQM5yNCWtN3pLiHQbS2Umm3MsBAUJ
51558	payment	2134	2134	1874	1	1	9186	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYehhLiQfhyq6a2GXdv8txA8f9kRdR93uneo58XSYmRkDzWqh3X
51559	payment	2134	2134	1874	1	1	9187	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbt8MAp8PDRj4u2idjjujZSrVigHnmhN9LnuP9nNurDyPemHfX
51560	payment	2134	2134	1874	1	1	9188	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4qq8bK662kvbk4ixc1ZGZFqtLUEGxhEsBe4nJCvXgfVt7EJGB
51455	payment	2133	2133	1874	1	1	8302	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKfcWYhNcMTPypSTmbiuph77g2J7j1hkxyay1tZ68ejD6uD4DY
51456	payment	2133	2133	1874	1	1	8303	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7bwRuuntRrDKuvJLyJ4cVKgqeZFeXpDnFVeyZ89jAW5927Vyg
51457	payment	2132	2132	1874	1	1	2401	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa76vqf47TMWYYeQsk7BmKw8GiHqFrLtxi61HLXyNQSrwpjDDFD
51458	payment	2132	2132	1874	1	1	2402	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNNtQ34KypLWHCY2mXzeGjZE94XZbuQdfZDaTivsX8s9tuuvGp
51459	payment	2134	2134	1874	1	1	9137	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8qYG7G9wwpRUKJxUDeRhok1pMiBfEV3TqkNaSF8HjGfFnJ2Yw
51460	payment	2134	2134	1874	1	1	9138	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKimaZaYdL397Jbrw4EusNziFajdXV2yVLPQAG1rXLQnAcTM3
51461	payment	2134	2134	1874	1	1	9139	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4m5RJR8TrNmfFQu6F1kKm7MpRdytwYgCM6hTQFdG4GkphZV95
51462	payment	2134	2134	1874	1	1	9140	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXTV69oDh7mwbG73EmnrHwQkcN3p9ZfsGRSp2HRKtdhcSNzBEz
51490	payment	1397	1397	1678	1	1	18292	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZy2bdB5tDsDQAygA5KQaemdc1SezUHaQBirkfw6TqcYuTXPrmA
51491	payment	2133	2133	1874	1	1	8312	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9ysxD2T3Hu5xtmwmNGQNgSXyKNXrhTnr8RSDDTNQ1poQVfzaQ
51492	payment	2133	2133	1874	1	1	8313	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7HDm1do6yarGokazzgZLbmsohmPu87Hjr7f8dNyQxbcX9kEYj
51493	payment	2133	2133	1874	1	1	8314	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJEPbEanjXvvftz8ZQDZY5xhEqvHRFYagyTtXibtsyQQYmFWHt
51494	payment	2132	2132	1874	1	1	2407	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcANdaKSEj6twFWyt6J1TUmv9FG4Kveqy5SGBrGKiEDPTo4s2T
51495	payment	2132	2132	1874	1	1	2408	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYisEM8AfB5BtbdVgrrF4sK3bnu91WGb4ezn2fECBPyUEU5kpJD
51508	payment	1397	1397	1678	1	1	18294	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgk1VtqwvUFW56KJubHgn1ZR5UWUtBn4NnFMbGHjMK9i62hs2f
51509	payment	2134	2134	1874	1	1	9162	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmoZkUBW6yFoScveBYKDx5Ahya3yqJJY5DMkGQA7EkpcynKMW9
51510	payment	2134	2134	1874	1	1	9163	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYU6sUwPVUA5MA1Si64YrBg1fHA7hoR4Z74cWToc8Gi3KVxL3Xg
51511	payment	2133	2133	1874	1	1	8317	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3Nv1FnNQueodB3EEMkwAmo4dsprRbuTBy7MV17fk1wTUK5FAB
51512	payment	2133	2133	1874	1	1	8318	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkHBphE8KSv1a1G28yhS8AFpsWt3KPWF7m5gb3eFZcsAnCn3WZ
51513	payment	2134	2134	1874	1	1	9164	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpRsLirRRShTLSpqhQ141yPbUhim3VQLBX2u5Mwy5aUi5iTnrZ
51514	payment	2134	2134	1874	1	1	9165	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmCcFHSJW7Hf5HfGZ3eCoCUrM82aQoCnKjaJ6isEU4thKRsfQD
51515	payment	2134	2134	1874	1	1	9166	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdDKZKav1W6dtGzguRhkAwvM2zt4ndtRWcfRFErHcY4AMPuvbs
51516	payment	2132	2132	1874	1	1	2410	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJpRnjdhPBuVW9et14VScAFUYEJrfaC5Pgckk5VK61m2tZ3YcQ
51517	payment	2132	2132	1874	1	1	2411	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLesKUfhfqwa8h6M7943d5KoT8NezYo64A9q91uK7vu7A1dbMy
51518	payment	1397	1397	1678	1	1	18295	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgEKSRJZ4A53qYafUtcisVzQCzNgEDrTNh1RfF3HbaeeSmY7Nx
51519	payment	2133	2133	1874	1	1	8319	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwNVNfuHHwFKrZfDdiBq89ATy3JA3gaL68XjBKwiX648Sw6zN
51520	payment	664	664	2440	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTcNRTCgHdojaZLGeLj4n96fj5oQCvrSyC5RssWbhiuQMGJis
51521	payment	2133	2133	1874	1	1	8320	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQDpGm4WNKkTM1vYHjXTSTLXT7fZkVSaSnmHborYL2iX7FM5VY
51522	payment	2132	2132	1874	1	1	2412	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnizYPFkU47oM5FrpbR56FyCwkq8hAENuNhzMxVaE4m1RmnfpJ
51523	payment	2134	2134	1874	1	1	9167	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUfYDnLUFHgKBo9uoCBCgC6M9JLJsuiMgJ9BtLxDLK7quxEEVt
51524	payment	2134	2134	1874	1	1	9168	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1WaygsYWfX9NnaExHuiuhHsnAJt2WbyDz8LSsbsd7oxywGJHq
51525	payment	2134	2134	1874	1	1	9169	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpBmQPxduRi6xSzxPRb7EgBgtJfFSjfKb2byDhANeon5a3RsBF
51526	payment	2134	2134	1874	1	1	9170	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVK2tarSDanMDE1Yu7LidfwjpusSyPS67NKTtBAPZqbQAfPJr8
51698	payment	1397	1397	1678	1	1	18314	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2z34uBYzm5S4ZBpPGNtKbpsq4z2icd7Ke79QPSgN75ZzJUJ1h
51699	payment	2133	2133	1874	1	1	8367	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS79cGJ4ZYPmwSUoLCpmmSpCFeCG1b5tGvULooaq2YVTwhvnjC
51700	payment	2134	2134	1874	1	1	9250	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97LWuCdsgKUxzMbcBzC3uwnfp7YxKQH9aPmYcEaEwTK8unJ9B
51701	payment	2133	2133	1874	1	1	8368	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLv2CdcYhZUxfFd7g6F6zqfeYBdiWUqbFUHJCD6PydK3EL2p4t
51702	payment	2132	2132	1874	1	1	2439	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8GP5ne3nBYU6aqQ4KqyMJXkRbpkHbcrLdCiTrYKcnxjxXsePk
51534	payment	2134	2134	1874	1	1	9174	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHtDhsC4LpFJhLy6QYYZ6JBxCf8kHE5tYTTFKAdhJhWWqocDga
51535	payment	2134	2134	1874	1	1	9175	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWHcZZV8zQCsnnB2VAtdE8WPHBD5Ukjpu17ztjBrsPsov9eK7C
51536	payment	1397	1397	1678	1	1	18297	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbiWMyAeCmkmXQuks48FLUsgs83QhfFkEQa9znHDvKqy71GbF
51537	payment	2133	2133	1874	1	1	8323	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmFsqPFmetAd1ZDPwQBsWgYgMMdTddW7g9HHmNfguKBepsAhpE
51538	payment	2134	2134	1874	1	1	9176	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7Yxg2nnJzwkR6rJV3X2raAT1V2ChfVUQCcFwwpLcVgb6C85EM
51539	payment	2133	2133	1874	1	1	8324	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZtoU7W9pfmeKahPBvoMDqAEsyYmw7imG3YK733c4SQWA5Eg8z
51540	payment	2133	2133	1874	1	1	8325	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk7zw3s4zLKnXguorbZNARLcfNEDTepLuVoMF1Egq9tJrphvG6
51541	payment	2132	2132	1874	1	1	2414	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnfsC7BNKLEHzDzX4TZH9T8JtMwEkQHmGz1F37DTArehVPAFHH
51542	payment	2132	2132	1874	1	1	2415	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt5WA1FiMuFCiMKgnHRqd411bUctnHNtHcBkkWuXjervHxbYmY
51543	payment	2134	2134	1874	1	1	9177	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5ZnEUapQnR9zbFhecZU6WsZLJ9dm3dE8a6WKLFr7xHz6LZBSt
51544	payment	2134	2134	1874	1	1	9178	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTHVUGcwe7NQyskvkb1ZnRKj58QALu7XstSiM1nkdphta6mCC3
51545	payment	2134	2134	1874	1	1	9179	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjTiRa7uqb4sh587HxsfLXpKput9rSg4AXseszXyovTLZWjCTz
51546	payment	1397	1397	1678	1	1	18298	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZynY1y4SQ15cxtS26FiyrPLwQ6q5Hdp9K5C6NByfDUHwaxu2Sm
51547	payment	2133	2133	1874	1	1	8326	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXLxnsMbuQyEMavXm8natgQ6gnCzBCfmLCmn7uRpxHDZxLR9Br
51548	payment	2133	2133	1874	1	1	8327	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYQqLywJPnsZHZc9UFWX7Ru4sgash3SwwUL8h1Z4siqWsFKYU
51549	payment	2134	2134	1874	1	1	9180	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmbirV3yjYkRieB8P92BgHkqDUCg44t3wRMhMYiq9ZYYN92JiW
51550	payment	2134	2134	1874	1	1	9181	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZifDVKgEXNUvuvKrSj4ySPzjCgEbPbCLaMj7ctWJ1Wp7ZJHbut
51551	payment	2134	2134	1874	1	1	9182	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHD58LgS42wy2kJgzjfygFobp7Rx4g8T6SduY6cnoW7RC44h5W
51552	payment	2134	2134	1874	1	1	9183	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvKE4uJqj2cQTLXNbUvDncRxsWtdhUHZXMNnPBRDKCSJqMiwi
51553	payment	2132	2132	1874	1	1	2416	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AZWkgKYiuEyug69zHWgjkSVQ92uEdMCNr7A1VMJjXMBwmzj1
51564	payment	1397	1397	1678	1	1	18300	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk9gcw8XnEwfer1AW6Gdt2WkBzVcyZErZhGtAztwUaGdcNA6QL
51565	payment	1397	1397	1678	1	1	18301	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZNchj9Ed4Qod7T3VAsQ9tYJZ1zGNqL6a6UGFg59jgNTQ6EnkT
51566	payment	1397	1397	1678	1	1	18302	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYo9a6owPNHrfhipbEyQPWDbjcvRLaiMnrWFqrpZDNdkszTjZjE
51567	payment	1397	1397	1678	1	1	18303	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYt9V6TSs3DP2siRPhLY2a1QZWRVQ1D3UamY5L3uPpiceBW6j4a
51568	payment	1397	1397	1678	1	1	18304	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1ztLLAbgTttRvFjBG1vssV7YiUEUtjwFsbRwbCEYDcT89pXfz
51569	payment	2133	2133	1874	1	1	8330	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7r1GDzYMieALR2eSvu1LggErdGS1JHB66eT6Q839MVeM7GGW9
51570	payment	2134	2134	1874	1	1	9189	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVBJmkEAQjxBRLW17433tkLVr2r5mNQTXYCjCsemgDoPbRdcmu
51571	payment	2134	2134	1874	1	1	9190	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNU8N2RR7wTC1LXF2wDSdt4Ghg3h5RGyc8wsVvJ8MxJBD5JCn
51572	payment	2133	2133	1874	1	1	8331	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYYwtbJUKDitRFeSbMie53rqmo5tG5Q3WkzWeVBoTUi6w2pRTd
51573	payment	2134	2134	1874	1	1	9191	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtZ5AgfBnyM5e6P12sEDzkNyBVdksuB3T8qdxXg1pURWbuZriR
51574	payment	2134	2134	1874	1	1	9192	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDMx67hYuWx7v2QhAvhBrwuUj8rEqt5PvaMahTvYZArnFx81VH
51575	payment	2134	2134	1874	1	1	9193	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPb3T4co1gKR38C1ufF37Fbv5Lhm1rZufD3sZwpETbrgFtvF46
51576	payment	2134	2134	1874	1	1	9194	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3nBqgTk4B2UsWT5mMhHrWhETvfdE14Q7A3bvyBtVM1a1vhPy
51577	payment	2134	2134	1874	1	1	9195	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6NKaTRWWwcfn9ukueso5ntAE7Td7Dp8jUSTWLhLzDfJpzoa3j
51578	payment	2134	2134	1874	1	1	9196	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQBJ1aKnMfKCKQ8xh3uDyqk61LAPV4AFTqHprfBMWx1VvkAjNJ
51579	payment	2134	2134	1874	1	1	9197	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJKXXghNjYm5eVWrShj9GQDJP4yo7d7fLWnx7MaT5aUBAtoJ1z
51580	payment	2134	2134	1874	1	1	9198	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuLJJ5pbJCnoU5yBs9Vf6vZxBugAcgJ36FApGikFZvAMy22f2Y
51581	payment	2134	2134	1874	1	1	9199	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNbnbgT6RUo8xKDagVokgq43nmGcnwnWrFcahhnX22wBLNZwxS
51561	payment	2132	2132	1874	1	1	2417	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsM18ptvDJWypmDQbWLXdATfaeQ1Eri1R1UDiME1eq3FfeCta
51562	payment	2132	2132	1874	1	1	2418	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPcWYLdN9b8B6ueCSrcWRmk49f4xCNxzX95Vx8TRJUNaSiyyCS
51563	payment	2133	2133	1874	1	1	8329	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6ryvATH8dHFs6zZSpvkFBseGeioMou7quNjNU89RwvY9zQJPG
51623	payment	1397	1397	1678	1	1	18306	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqmPonbyReFrcY2qcRk5NdMpGhZDhujPhTL3VHVNuyZPpTmh3R
51624	payment	2132	2132	1874	1	1	2428	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcTyw4GZw12T6nG6XeeKLT9AdpWrgcF8fAiuGQb8ZM7ANoichh
51625	payment	2134	2134	1874	1	1	9215	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnYZjrireZtwnDx1aq5GeEWRViUPhY3zNUacyWzgMYzGzFFT1y
51626	payment	2134	2134	1874	1	1	9216	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcXn6t59Xcnajd6DbwiPTjiNwz6ezThGsYisWs8k1MhqCErJWF
51627	payment	2134	2134	1874	1	1	9217	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZShXvFHr4rj4fDwAEMEPwy6g3hBg3Uc6P7uxFwmrvpXkFLF4e6
51628	payment	2134	2134	1874	1	1	9218	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBWhCx4kLKMbtF6qfxzVH1nwp8akf3gfyEDjASHbD1uD2Lw3ns
51629	payment	2133	2133	1874	1	1	8346	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLi8bxSnD8jUpssvaAo7j2vWwayHHtmYNvWZc4SKU8Xuk8D4q2
51630	payment	2133	2133	1874	1	1	8347	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuUp4EjqNj2fwgLwXnea6eNEGH1SgW87WJ7ojCEadLMBAbC5Cn
51639	payment	1397	1397	1678	1	1	18308	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEgLe3anEpTGLhNdbeLBsYHXQWcCRwMWVTFvrmoF2jTHfE3rw
51640	payment	2133	2133	1874	1	1	8350	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYde61RYzdPutjoo72MmgnSmAmaBmkRLCpaoagk9mWZdizuq5eT
51641	payment	2134	2134	1874	1	1	9223	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFfJSWtpd2ne32wJqXSoXeJ9oq6q2ttWbkodaTaJT4Wt8HWaHr
51642	payment	2134	2134	1874	1	1	9224	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYan9PMVPzEXu9Lu6KnmnpUbxzFhAEAjQyM9PKb8BQ4gmRmTfaB
51643	payment	2132	2132	1874	1	1	2430	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMG9c9Ho3xhMjLBbdMdrLJJs7AYPUyhWjQix6wt1Z4pxRDh7FK
51644	payment	2132	2132	1874	1	1	2431	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8v3W3Xt7vNZz6o9729qR6vWyLsS5Wxo7E6r2iY4wenMdAgCUq
51645	payment	2134	2134	1874	1	1	9225	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTiVP1fdrV5HjmQHtFfrJPfZnSAxtHzcvuhfG9fzAxunRheRcj
51646	payment	2134	2134	1874	1	1	9226	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5AswNoz2i69886sPtNe1PY5QmaBLK4cN8svH2TnZ9wbpMWqtv
51647	payment	2134	2134	1874	1	1	9227	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6RDwFG8TMH1H8JME7gGd5uiMRycLFZE2yCUzwF5j3Uiwf8yMZ
51648	payment	2133	2133	1874	1	1	8351	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDpxS3bkg4YeZwaCFKUSW9YnKB8bdpJo4p9a5SQscPosqqX77B
51649	payment	2133	2133	1874	1	1	8352	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEmYZ4bg1CYPYGnrn9jj8BTBbH1nm2PTxMEqbruABAViAaPKsM
51706	payment	1397	1397	1678	1	1	18315	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX3QVfsCitdEztaKYF8WTi85fyjFhreEY7wBD1cA1s2E437mCh
51707	payment	2134	2134	1874	1	1	9254	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRYuGqJV7jtxuQphhRmkQyyZdmpvfw7nPfN8Qn8fUwAubx2urp
51708	payment	2133	2133	1874	1	1	8369	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgcSQCCJq3rtF77JLmrVkTqWX9nZ3WwNsPutMTUz6rxkDHs2GN
51709	payment	2133	2133	1874	1	1	8370	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmYh8vbCfd98pAtqaEfrFMEyjeUJu2cV8L1CYgpM1yGRyT5bo
51710	payment	2134	2134	1874	1	1	9255	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmFbeBP6dB6BnrEutThzUvV6f3arC5eJPc3RrhceJtN2y9pNqP
51711	payment	2134	2134	1874	1	1	9256	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHd6sFNLocFRcy8Wh58gBur1zRH9qgm4i8TWHbYZaVcupjkYB2
51712	payment	2134	2134	1874	1	1	9257	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVa4iBFVKRq7SAvNNgQc8WEqGfhcUkGLAexT3G2M5SpB9kiWoY
51713	payment	2132	2132	1874	1	1	2440	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqg8pAkGbDtjEvG4vhTTUmsXiqGvbzbVQAN6YVhjWKw5yzABSj
51714	payment	2132	2132	1874	1	1	2441	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XRUv1ZdnEJPfWZna5WT3wDsLfZ437oofEJkcLoxbvsz3kzN1
51715	payment	1397	1397	1678	1	1	18316	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHXmCynn1yJdn6i3YnfCHbQDRUF6sRSHdbWv4wkjYbgq7YmzRq
51716	payment	2133	2133	1874	1	1	8371	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmnXPVAm54yfv29z4nghPC4UEPwTZj1T9vecJMfWpB8NvHxsKB
51717	payment	2133	2133	1874	1	1	8372	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrHs9WUgBZCoSDc98d8DESMKBV2XGbZv5b1b4ehd3krT31MpNQ
51718	payment	2132	2132	1874	1	1	2442	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8QQsBU76C6BZAQL613NnfRHjHhf9i8H1q67m5Qkmofe5gcfss
51719	payment	180	180	2441	1	1	1	1000000000	1000000	\N	E4YRZZFjJmEArwEqcpGVqPy2EHFP1JEfVT536cqEAMd3xBzvR1BtS	CkpZDHTumthckTdg5Cb6qfwmU5x7eNY9gmqrDsM3ApQBT9sWwdtmd
51720	payment	2134	2134	1874	1	1	9258	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4efevKicKikB8tXeWDzWsYuJmoPnRzXW1KrAdoa8jeoGQGrkS
51721	payment	2134	2134	1874	1	1	9259	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFGLUM265iMJAboHLW1SL78Qh14NCvGdM2goXKkekWYH4oCG5N
51582	payment	2134	2134	1874	1	1	9200	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdxjgKJ2ThrX1WeBUkeVWrP6D9wP2nnMSUKNtBAbcpN37WDknm
51583	payment	2133	2133	1874	1	1	8332	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxm1HzRgoV7qaVbH7db7hGGcH5ZJ7z29fhBnfUHpQ5Ra1K19Jz
51584	payment	2133	2133	1874	1	1	8333	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdm4nqoR3LU3Jg3R4ZT4nydX5YoVk6DieKN2yF32V7bgbg9L3Y
51585	payment	2133	2133	1874	1	1	8334	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZb3Wo3D7wx9P3n7zSMgXbjHmzucmvm9ws8gRAME1uB7QtHDm9P
51586	payment	2133	2133	1874	1	1	8335	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQp36Qw7SFqukedF2zwNkADzCY7NpGA9jj3uLFeLXNUceamwfr
51587	payment	2133	2133	1874	1	1	8336	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMo4e7bvzjyZfXtKdaS1TV2drRAq1XZEaB1YrN9pSzL6xVseNe
51588	payment	2133	2133	1874	1	1	8337	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeT7fnJAMHRNneofieoC4rQ3vpDYHJM7gCYdm2c73ZySPtzBor
51589	payment	2133	2133	1874	1	1	8338	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2YeZwdkWrptmw1cZHzi5mZDYDMgMdQFLsvxnMMdAQm6LPXqX6
51590	payment	2133	2133	1874	1	1	8339	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzGcmLqt936NscctzanSdNtuzhu3Mcp7mMryViJPsm4cqVWHF3
51591	payment	2132	2132	1874	1	1	2419	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7GmhSYysG6dguNbr8FXEPZpXGjwJ7zY1EKEJZdahw5dQt57zA
51592	payment	2132	2132	1874	1	1	2420	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZirskejfyymc7FHUcmsrAXdQXHmeCxhuemyyh5L5nsnNkdy7XS
51593	payment	2132	2132	1874	1	1	2421	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZavjpx48J8sJukKZ2jzDHrgvu5nyzrK5apoFdqdBn2WXbQBMPj
51594	payment	2133	2133	1874	1	1	8340	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa89NLdpR5rPn4kfQXxuBJS3MRzVM2Ap3dmJbFMQNKsesdCkhxs
51595	payment	2133	2133	1874	1	1	8341	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8LTyXgZR4MCVtL3qygNmBJVkc67YwNzepyyNC1Bei9gA2dmh1
51596	payment	2133	2133	1874	1	1	8342	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVsDvRsyMyvL2ZGm9XRGkpKkqYxpgCfJyZ8cpx15bSuBeMn5yZ
51597	payment	2133	2133	1874	1	1	8343	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZa3GPYQWMjghe2ZrooEyQ4QJfV9MsxsiXR6ruvvu4LVGgEfTNu
51598	payment	664	664	2440	1	1	2	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9YuxuVi7DM8EEnPHwprVkZQhnQY6w2QUd4G9BVWeDsQT5rsfw
51599	payment	2134	2134	1874	1	1	9201	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaC4fMBxZhHfLw9Pu3dwGnaKqmmtqeBnG6YjmMY12ZCUsJQS214
51600	payment	2134	2134	1874	1	1	9202	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVtd1weGkJPDCV8ULbZavFJhGPHiHyjGUjBsdsigmGLfZwUmPn
51601	payment	2134	2134	1874	1	1	9203	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQRYoH5sjFuVaPggdSVh7EeJDpx5aNpiMNGHPnCs3AAZt3qNWy
51602	payment	2134	2134	1874	1	1	9204	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSNYVwRLQywGCMbRdSvLwCaBwQkVf6Exad5o5W6u2rzTbRBoTP
51603	payment	2134	2134	1874	1	1	9205	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAKLCtZcLndvTpNvyyuM6o2qMBS7ExUkEYD8CispHnqEgb8me5
51604	payment	2134	2134	1874	1	1	9206	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr6VRG7AfJ8H2m54UoB2qt2TG7ZiDKcKrHsd86RxkkAhqfSQxK
51605	payment	2134	2134	1874	1	1	9207	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W5euyAdfiaBJ5mk3bwxxRuKSMFzxX6nT6YnxT38FvB1yqWMm
51606	payment	2134	2134	1874	1	1	9208	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEcNXstu7QMeYeHkXLTh8z5hysyRVkVZmYGZUusvdCfaBBJD9u
51607	payment	2134	2134	1874	1	1	9209	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxzzoWX8tMbzTMyU9QGfK9xAxnMmQzZw4h2nmp3sTcv87SGULc
51608	payment	2134	2134	1874	1	1	9210	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNQZkPpNih8A59D9mp69pFLssW1v35xhnP5gccvpD4GaBLW1MN
51609	payment	2132	2132	1874	1	1	2422	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKvZAJjyRNDTbbHBTCbyBUompdYHkMMyEUdQFLZqHryj9msqzJ
51610	payment	2132	2132	1874	1	1	2423	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8TUPrN5F7uFL2CVjrMjxfhn1q7KjuFEMAnPSEuA7zTomCD6oE
51611	payment	2132	2132	1874	1	1	2424	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXZ28NAgZuUhpbD5dMry9erN44vL3u24qsos1KT5X9Y7Wsdcqa
51612	payment	2132	2132	1874	1	1	2425	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwNdRxJJeCc8v58NKs4GcAe31Fx3B3bTY6zYR5kcsyeVP2vFs6
51613	payment	664	664	2440	1	1	3	1000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyW9LXQqmvZVNHqsbvdGXsttfARJtcvD6D9xVkvAjjs9nnMvjy
51614	payment	1397	1397	1678	1	1	18305	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9juNs3YJEfoNUJvoMznQwj5m3oYWSjKLSaACTj47vPzBBe6mM
51615	payment	2132	2132	1874	1	1	2426	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuDyoUcm5ptaxsCT2Nece6VzS61Xi78cPq9KgaF2HGvwwGf1wg
51616	payment	2134	2134	1874	1	1	9211	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzyt63dqL7fXvocFz3ivwA1UxMBgT6kjkavSz2d5NQp7gSGXjS
51617	payment	2132	2132	1874	1	1	2427	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2o9eTQYWQ4BY1Ect8EJfUirC8QNfvG91G8txCYjag6MDUHbnP
51618	payment	2133	2133	1874	1	1	8344	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvcCFsz8BhViNAnaGofHqRCULrupk2b7fzRkHbbFTh8hDuU4K5
51619	payment	2133	2133	1874	1	1	8345	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHHTZBGr3i7zVSM2UxzwkQMYYp1EeDvrzhZfDyyTHXubWnYrVB
51620	payment	2134	2134	1874	1	1	9212	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAM8cBHQKuXHWCBMmcHn4JeT4VExSAPiS9Ub1EvAqUaMVuc6Jt
51621	payment	2134	2134	1874	1	1	9213	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYefSPXGi8iYuB7qJfbcyC1WK7V2DeBZuEWS4Hoj6sm3g6qw3Dm
51622	payment	2134	2134	1874	1	1	9214	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSfj9Xm9iNUgJS5m51rp3nyhT5LmEp3sTaQyfvY4HfX5sezZii
51650	payment	1397	1397	1678	1	1	18309	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhEDfS8DqhjqiSSFP3zGa3AZYdkGTaNZpYtDghoRffFDMKV62Z
51651	payment	1397	1397	1678	1	1	18310	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxVufkUUmTzyo7gEi1SN9mpmzzHrJWAmdRVWpRsVhz5uYderS6
51652	payment	1397	1397	1678	1	1	18311	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYScKgpsXRV91LcecbDMmbypQbN4BLHxWL8jg1Uh5tgBVifnj9y
51653	payment	1397	1397	1678	1	1	18312	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8J8EKCdFjQazFtf1drRk9a4YAPZ7cJxGzuhLT1AhC2p9gSxeV
51654	payment	2133	2133	1874	1	1	8353	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqVyPFLgpX9B2c5MHLUMjcCnAYNMhdBZ1CgknyhCv37NTSzizQ
51655	payment	2134	2134	1874	1	1	9228	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx3ufSHGdnztQGmGpwtRSGBN6nHSngY4gRPfZEcdsFGuQAWC6n
51656	payment	2132	2132	1874	1	1	2432	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZyVhk9tjp6TqKtGVnKnqFVvFzWpnig2aETgVm7EftFGT6PM7P
51657	payment	2132	2132	1874	1	1	2433	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPiLSAvqdNg2DYHMc5GPqeT12Vswc7MjS6CKR12p6x9NsC9qQ
51658	payment	2132	2132	1874	1	1	2434	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiiDe8KxDScxHF1V3RnruoYRqdDcywmiHo2YRUTsuMxsYCUVhH
51659	payment	2132	2132	1874	1	1	2435	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4NUejtfH1sHZQgGLCwMVaUTUY3KrsvQRaeVMzjN8QKHtrSY7E
51660	payment	2132	2132	1874	1	1	2436	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ37zd6tgmD4dJ9Yo1iegxMYEFYczjksvA5bwSpixM7mz5fo5Fy
51661	payment	2133	2133	1874	1	1	8354	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHfJRUA7xEbmAbL8mEkeh9YRUuMv5Mey4U9YXErSuC9kPGbXMf
51662	payment	2133	2133	1874	1	1	8355	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBuD99fDnoBiPSqgX7NLsbHQMWXyupufRvSMGshUtmE36broE8
51663	payment	2133	2133	1874	1	1	8356	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdirX5dSYTfCmzmA66FHDi356WAvoYKuCgypj2Gt1Yzrr77yKF
51664	payment	2133	2133	1874	1	1	8357	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg8XLq7wdYyHQrinJQuV1st8wqextNPDrmReMEE3TnsNV6k4EV
51665	payment	2133	2133	1874	1	1	8358	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa13YQcxEwiuhVcMDpxCsM76b1VzFaiGpSzbHG2QiRKvepeLvcM
51666	payment	2133	2133	1874	1	1	8359	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVRybuMsy3uLsAZRswuQtiYsbMuAS7STNGK1zsE9ktALSh4pqT
51667	payment	2133	2133	1874	1	1	8360	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9jzuqSFZK8H6kGydKiehDj1dCBW2uxmh7WrTbrM5MZf5kB8zp
51668	payment	2133	2133	1874	1	1	8361	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcBTdhApQF7G1ZQ3Lr598TU61eHY5BpfxkKmMt5FzVcp1x1tiF
51669	payment	2133	2133	1874	1	1	8362	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfcTBcMeS655GnHanKi5HK3jyDeGhxSpFzacCU4Wfsdd7YBk77
51670	payment	2133	2133	1874	1	1	8363	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJMRxR7tZNt5s6U6mAi1K31pELVwGyM6WB29ZZARZGeYFizU3Q
51671	payment	2133	2133	1874	1	1	8364	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWg8RUxpSBQF3irzJX53Y3FviGmx1qDBiKXYET3hgKhVbmPDVi
51672	payment	2134	2134	1874	1	1	9229	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHpsJMkMR1S7XzKbuGkgX5uWKfi2HwqiqdnT9M5MCHquZcPhoi
51673	payment	2134	2134	1874	1	1	9230	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhVyL2AdxsSFxHgkzi477nwD7gi5gc9s3QEayZJAcnMnR23TVv
51674	payment	2134	2134	1874	1	1	9231	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYuzz8sPMxPSbSuWBuN5UHyQv7LGafhVgZ986EHe8h1hBQEPgia
51675	payment	2134	2134	1874	1	1	9232	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnJ954CbirvrYSZ5Nghsha6XcFBHSshcnNsknrQqiq7d95k2bc
51676	payment	2134	2134	1874	1	1	9233	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCtwy7dYJ1mV8JT2PHC7WAgrCDqdroantoYXsSF4Z3CyPLpLGX
51677	payment	2134	2134	1874	1	1	9234	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhJRzDr5fXhFhaA2Hx8trpGo3mHCoZpq5H7rDBKRzaGF57EYD7
51678	payment	2134	2134	1874	1	1	9235	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhxbMJ64uGoGABcxGAmdopMgxCnRWrsQczCUSJdm921snAun8x
51679	payment	2134	2134	1874	1	1	9236	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqi7JeXUjP49KhHrX9mTMN4fhNjY7WF9krF3ArBUrMzNjHp7EM
51680	payment	2134	2134	1874	1	1	9237	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDZSLqFmNQEYq7MSVRg2EBZrwMSK2ydTy7NmAZgLP1oJYGvB3K
51681	payment	2134	2134	1874	1	1	9238	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvcq2hZ9NWzM9ZP3GdxuTEDfbnrb3zxqod5eSjo5MKiem3gmiA
51682	payment	2134	2134	1874	1	1	9239	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnXs5npSaXPQvupwTFPp5wPsw4EoAtTXmNrqrEv8DA5R4zatjT
51683	payment	2134	2134	1874	1	1	9240	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFAqkKqzBiifsEZmq3Hz4Y8GsYQkfFttK6vt3WcS5FvzbTsVYs
51684	payment	2134	2134	1874	1	1	9241	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9tTXGG9wTxR17gxViz6PvXzMESNCQ3JRm4fUnUmRwMJGbVpiv
51685	payment	2134	2134	1874	1	1	9242	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ493RN3UFhg5wCExPTYpQ2qWCaSf4JpmTPaNAruSLdnp2czznT
51686	payment	2134	2134	1874	1	1	9243	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyRTUprL9FSuGGRVqAaSTtdcdFrX8yySDPYD32XGqiXQHsvA8b
51687	payment	2134	2134	1874	1	1	9244	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ca4G7vamJo7QdQyRSST1RJQNG5LVHyDpRN21UJcti1K1u2LE
51688	payment	2134	2134	1874	1	1	9245	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp1iTpQsXytqmBGC6ttFFLqjWsunmJQy9prJLHWFNktf6jTZLZ
51689	payment	1397	1397	1678	1	1	18313	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYyVed1HeH1gtmuh43JTMjHeZvcMaP1XNNQhjjarrE6sU3KBfW6
51690	payment	2133	2133	1874	1	1	8365	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWBjSTBrDKoydwsbHd4CjEHfQUT5QsYgDgYWpLgD2hgL943w7K
51691	payment	2132	2132	1874	1	1	2437	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Y11C9PbVm2GM6221vjKtnEpQhDKm7qRimqrvBVoV1CoAW9pN
51692	payment	2133	2133	1874	1	1	8366	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9utRp5EPgdQJGK6Z1bJTcccdMWrPX2g83nVZSzodQ4EKmTocY
51693	payment	2134	2134	1874	1	1	9246	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGsPNpS3AoTPc2ZGLXwxmUQ679nUKKsumr759S9LD9y9ZwsMb
51694	payment	2134	2134	1874	1	1	9247	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF4ZKJQZzs6kBxxokBw7KByMMhJTSTyJy9bevH3SyBeDFNj1pM
51695	payment	2134	2134	1874	1	1	9248	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZKeDHxnnuiUGUkwDF9HwycYM9cnsaozrwkyuxKZqVhUGC3eeU
51696	payment	2134	2134	1874	1	1	9249	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs5Wsp3gSJ9vhzEQojoQNfek2KzncBKJ26e2SBCkBbF58SmyK5
51697	payment	2132	2132	1874	1	1	2438	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCKh3p9iSAcEVVZaiPtTRbzS2fKtNuGK777NRDTQbapDFzJNDW
51752	payment	1397	1397	1678	1	1	18320	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmQnBZW4MCj2PWzDFpkDrXVp9zbGw2rRFaNoWiu25aXoakargg
51753	payment	2132	2132	1874	1	1	2447	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJoYLf3bLX3D11u1RQNx1UfGnBJLJwoGLE3ABqRbvfDzg732LT
51754	payment	2133	2133	1874	1	1	8380	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpx39vUeeeqQi3ZZ14mQ2KVZQ4DB7q9kS5LzGYmHEfGHiVkRvh
51755	payment	2133	2133	1874	1	1	8381	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvqvDoUSNv2j2aXaJDB1CxfgjZA8QnttMm7bN9PGoWc7FcDmvu
51756	payment	2132	2132	1874	1	1	2448	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa58apfVNytPYtpxs1j9tCy1EmL5x439TGvakiD6fkNmieD5EWy
51757	payment	2134	2134	1874	1	1	9276	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9j1ASkto8tGnpLehhqWYuD9aqaBMRJrruNKrcenJLpd9F2XRu
51758	payment	2134	2134	1874	1	1	9277	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyBKQZDgffQxtUy5do8KTsbzccdn2Z8gg7n8qQqGwc84iNa1KS
51759	payment	2134	2134	1874	1	1	9278	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5CigLRkS2z5qZeWwNYK9HNc3WykGPPMAX5SrPF3KMp3gE85Hi
51760	payment	2134	2134	1874	1	1	9279	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrNfakiM2cKntAmfvamsC3QEbeTfSPPkkxnLte834PEDo1LjS
51827	payment	2134	2134	1874	1	1	9306	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtDk3RgPPJkRypEiZrQt82PybBh6uScfcSL3dsbhEzu6SgeFuB
51828	payment	2134	2134	1874	1	1	9307	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsDCXR9ycny1v7SAo9Tja6THmD5AtekeXF2UEBQ7cM2cKCdYEK
51829	payment	2134	2134	1874	1	1	9308	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhLkNRQ5hTYDi1kQzgMyVezSo5JE7dzzAdbfCeuRdEqfPEFJQ5
51830	payment	2134	2134	1874	1	1	9309	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjfDY9wBh6NpLSmrcKQUW4KLKZWs5n2F7tZRtnJk5BLVRJU2qZ
51922	payment	1397	1397	1678	1	1	18333	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdu9BGGbPxp6LxbHA6ts8cM9r5Q6fz284FUrqfkzdqe2TYnXFE
51923	payment	2133	2133	1874	1	1	8420	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd65g45CHzsWsRcDZWeyeTntWDRRvtBjEV6vbo7QbhRCvhKMSV
51924	payment	2132	2132	1874	1	1	2473	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB7aH5AnMQixpKsCEKHjcQJ74EftULdq2ABU5k2oY7HvXPS74k
51925	payment	2133	2133	1874	1	1	8421	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEHjNuK1Ek9wTSULyFVcgqQpBYH2T6cmUbSfBgomfD5w8UATD
51926	payment	2134	2134	1874	1	1	9349	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrHE8oK1HShwyyCJbPehKWsxWyLoSM97FnR3E2UZK7u5wccoH8
51927	payment	2134	2134	1874	1	1	9350	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGfGpmGVxgiM2weno7FZYmpL2fWgvFWo6wjD3Gfjmas4vwuoBg
51928	payment	2134	2134	1874	1	1	9351	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMK11xZkDFhpANU1gedK54eCHmb7JYfewT4ACTGFhqXLRzk5Xu
51929	payment	2134	2134	1874	1	1	9352	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2aUbsPHX3jAMpsLYRmDCqBAXaZRxiZzK55s9KCKGupRRrQCgZ
51977	payment	1397	1397	1678	1	1	18339	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrB1yE7yqZ39jGBjPauwbUrcQVND3bh1xHqBz5spYQiEsRHCTC
51978	payment	2134	2134	1874	1	1	9375	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9E2hxkZzUTc4nfsNxaPUpjr2suXsZW9FQ6TYdP8A5JHBfCkgx
51979	payment	2134	2134	1874	1	1	9376	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnARA6cdHwRJX4EvhpbKWC9GgQTBVgQNqeK2heUTA5fQ6DUADA
51980	payment	2132	2132	1874	1	1	2481	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXfG24Kv1HLa7pcWchpVzxf2YNTCFCCse8zkhH8euX6wpg7h7o
51703	payment	2134	2134	1874	1	1	9251	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGoDr16U9f9g3k16oXj6RpSeqbdCXSMpcdJdphDA2iNbc99Ypt
51704	payment	2134	2134	1874	1	1	9252	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR2ZZPT64yHouc9ki3RN8YjCrx74rMWftSzDfVBQbrwpQVHz6g
51705	payment	2134	2134	1874	1	1	9253	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQbtd2pZsgZfUkBcfmaRumPRA3iGXymMF8QYjJXEXBDgCpmQ3R
51761	payment	1397	1397	1678	1	1	18321	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhpsTmfYw3TzARipBribnWyKz9tJGSpwyCvtepCdvvD5fG3NVF
51762	payment	2134	2134	1874	1	1	9280	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoqkBgMBHEhkFtGAVHNtj48bph2xhPBDgiJEHCWtHiVyvdKKMh
51763	payment	2132	2132	1874	1	1	2449	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2MWX4zRAT13csKRh9Cr1UoybwXNqFKRFW2dwxhu8dBkTh7F2U
51764	payment	2133	2133	1874	1	1	8382	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJjjvVWGMisoRfGf6rqJmK5PDtoqoiT3DgDh4q3KYMs9t23NEW
51765	payment	2134	2134	1874	1	1	9281	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdMGbZniexk4VvQZCvMtiN22sTywZ5weQg3LvPo5P3frSwMEH1
51766	payment	2134	2134	1874	1	1	9282	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRqFsVnhb9xYbG79usWhgqzcKvdV7Hj8s35TfDtihB6W1WjwxR
51767	payment	2134	2134	1874	1	1	9283	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRK9kGwALpEfjQPyn4CXPku15tH7GV2QuHWf57t7uxhPi1uQkw
51798	payment	180	180	2441	1	1	2	2010000000	250000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjsMBWFznTs6ihxufsia18qkf3s1RQMM9uNSJAuR471vivcLRK
51799	payment	180	180	1726	1	1	3	5000000000	25000000	\N	E4YPpzX82oQ6gjyBztx8ZyU7nxPAwMyQX9qR81wK4JphdyU6MkYms	CkpYRZCimRoVVDALiHE6qHqCzn7jnJUPNqUZqmJmbpE15s8qTkMJF
51800	delegation	2439	2439	1540	1	1	0	\N	7000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMMcCNvUCdRZ3EmpbyYZHu786zhZjwTfvizY5Xe88tQF7DqqXS
51801	payment	2132	2132	1874	1	1	2455	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkbnt8Lit2rpax9PTs1xogHD4zoHFZZuFGidH7kebKhrYLBSof
51802	payment	2133	2133	1874	1	1	8391	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrqc4WVM6S9mnrWtBTmo8LgveCaLimc3wiC86EonjuNxR262aJ
51803	payment	2132	2132	1874	1	1	2456	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1ijVY1QaGXFshMPAQ4MsfCHrZZu7tXzjWsmS2zEJUHDCu4puD
51804	payment	2132	2132	1874	1	1	2457	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtu3iWxpn2voHaHBjJZdZVYdbihdv3xErv6Ei1NfAGGQAXTvP5
51805	payment	2133	2133	1874	1	1	8392	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH86LjVeUamURjmbKjS5yAAAAC1bQ6j3RdCCpaTtTf95AcXozP
51806	payment	2133	2133	1874	1	1	8393	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHGff9f2DNpJThUCKdeRogvWQ87Witm4Cm5JvXW8nQDSntYyUe
51807	payment	512	512	2442	1	1	0	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNxuSbDwbeFh3go9vim3WL7uJYtCfUSQcUofVdSETiaoW8GuFG
51808	payment	2134	2134	1874	1	1	9297	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUCLwntxcuLY9BCsESb95tEjt2iXpCDSZRs533JPubet4Lrwkm
51809	payment	2134	2134	1874	1	1	9298	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4shBZqowxkPyykmaSiA5a9sv21uCHBpM163R3vWpaoZ9CduRn
51810	payment	2133	2133	1874	1	1	8394	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZijhdjNiiwxSES1PEtGkfnNgLe29FbCDbhrjQ8dx8hrGMTudcs
51811	payment	1611	1611	975	1	1	18	462317323160	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZmECbwWqPNcCYJu6Fe2TvrejoH9xuHfD7FxT7zUEMPYHAoZEg7
51812	payment	2134	2134	1874	1	1	9299	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuJAW3zfqtTx5HdZUNePtkzGy1VLG5x89Uj1UdxgDLo6JfhoAn
51813	payment	2134	2134	1874	1	1	9300	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjm1DWZj7dhDdnWS1oK7m7zjs5zyStK2h4DXZpLWzqstH1FxBd
51814	payment	2134	2134	1874	1	1	9301	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2V9PFYhoer2yLzJHkim7Z1F6QsRWNSQFvkr1BquvH7crjxF2y
51815	payment	2134	2134	1874	1	1	9302	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4vwhyRiBX3VpZPnQagwpGqEXtuzP1JB8HTQQVWH9F9bHJC74b
51816	payment	2134	2134	1874	1	1	9303	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7HpW4BJtonjFYvakGN5Lsx3h7QNR8DsthV6tsxUgGMA41PCv
51817	payment	2134	2134	1874	1	1	9304	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZk2qqZsg4g9napeVR4cxEmqdpC15QRj6D1FSwxcrfibPr7RgE3
51818	payment	1611	1611	1095	1	1	19	828468681970	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	Ckpa7PeagMrzQ8uqeZu9pmj4huMhib4haJvFpKKuqpxYsRiZCGKbU
51819	payment	1611	1611	1215	1	1	20	558984328130	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpZbSXfUnzCpNcBzhBmNWju48GU2iWjP3URio1oQeFBSwZ9sS21E
51820	payment	1611	1611	1341	1	1	21	1557659532455	1000000	\N	E4Yty24AA3Fs7Tjs7X5VGsjkmJZgmzxznM4bnLNHom6dsGSqUH2wU	CkpYnLhviagTGsoXEGx9DqYP7LfjeEYfKgoLid1E2bYFZ5W8iLFwG
51821	payment	2134	2134	1874	1	1	9305	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAS5XgRYMFVLFEYowdKSksNiq1Y8m5ie7TAdHHjhSzwzVZkqXk
51831	payment	1397	1397	1678	1	1	18325	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ2wSAAzea3hB8xSgGxAhe8n2fdH5BcD1LdFPW8wPNa1PeC9Vr
51832	payment	2132	2132	1874	1	1	2459	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz3j6CiL3XXpzETuQxJCWMsyf9AEDcDFYNkz2WSmGBTQrfZjqB
51833	payment	2133	2133	1874	1	1	8398	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3jTdGPP2e63Ynpazi9DhcZfyezDfWW2vNsU3KBQDVyzUbJ2D7
51834	payment	2133	2133	1874	1	1	8399	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFSNYxo34fTTE77vnVjZVGvfKkwDE8apspaknYDubongMYzEzv
51722	payment	2134	2134	1874	1	1	9260	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkaXfDkkQ29MW9MbZoioxtDccNRkRoR7EAAbm1biDpHni22K7e
51723	payment	2134	2134	1874	1	1	9261	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiiVKMyHEvcDujHVCf3RgcxWrLXCadjnWfxpQKnMLHRUepS1Q
51724	payment	2134	2134	1874	1	1	9262	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLJLdRC2iRtBEePGKs2iagvXSuxmvgtDhYbqk17cML3AWEz4BA
51725	payment	1397	1397	1678	1	1	18317	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv3YZj6AhNxrAzpa7HbpbAij2QFsQ45u65XuaBgXnodqEkaj2M
51726	payment	1397	1397	1678	1	1	18318	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz98dQ4UEgxEZ4ETCn4TvBc1Hqi1g2gfvqy6ctZKqRDAHA9xZS
51727	payment	2133	2133	1874	1	1	8373	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYretv9jt798TxdH7r47XVK4iPARcd7RcUckamh6GSJvqc3d44w
51728	payment	2133	2133	1874	1	1	8374	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSAf7WGHVgKWuLv5E8117psDnQJpQgH5u6uJteQoMHPMgBbthp
51729	payment	2132	2132	1874	1	1	2443	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcXMDz7ueQDZruU1xqQtDr5m2Gr3Gu5xjtLQr4wD2GrxZKSqLC
51730	payment	2133	2133	1874	1	1	8375	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkF4bn4hR35yyd34WbjBn7ovxqmaFBXfm3DuLU6oRVBuVzN6LG
51731	payment	2133	2133	1874	1	1	8376	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5eFhVWTbxMZxSfLYGUSJNDKEZhmjDVQmFekpzdn7NNHM99uwp
51732	payment	2133	2133	1874	1	1	8377	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvvJ9c1qErBnfTBtgMjEamLsGAhDgbsPrxuS58gjsnpFAu4nmz
51733	payment	2132	2132	1874	1	1	2444	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF5JTjdUWTsAdcba6FoJSjd6u6vVucPxPMyScuQ7xNbhcugRNm
51734	payment	2132	2132	1874	1	1	2445	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbBwoCtoYxq5sqMKBNAV5EZKfRYkobpaJFMt8GFVyK8EUvZEVa
51735	payment	2134	2134	1874	1	1	9263	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFpSAhQuaEUgKZkQfJs9oyxzjNgVBp172LzYJdG2jmR1wTWkNV
51736	payment	2134	2134	1874	1	1	9264	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdcaNYr4uNgd4EchLmYHwqmUr7eghTiAnsrsK1mt3RKQoH56yS
51737	payment	2134	2134	1874	1	1	9265	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzxWnTSKvxpQVLx68m7amneVFKcVP166pG6pRdLUgfB9E8vwcM
51738	payment	2134	2134	1874	1	1	9266	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJhkHN3nhM1V8XNmH2kfuHwAyitjZuEhu3DnRq41xcFeoKUKt1
51739	payment	2134	2134	1874	1	1	9267	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUzLrKuE1C8v5WbRagY17z9wVkro2B6uB2e7SF2RuARWPZL7xf
51740	payment	2134	2134	1874	1	1	9268	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdusr4NjjP3Vh8hsLNFLbm1JEcQfRGnYHVypoHuQz1gs8LomxV
51741	payment	2134	2134	1874	1	1	9269	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZw1qnbwm5eMAz4b3Qijh1pRo3X1EJ7aLYsWckMzuyRiJ9dm4bX
51742	payment	2134	2134	1874	1	1	9270	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYVzCoQCGWUqE2spox3WSkgwsRHQP7NJKYhymutK4h38xAfWJ
51743	payment	2134	2134	1874	1	1	9271	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKRJSVEfapxJswd8H2B1DMspdeQb6ri8c33uPiyMcmhz2Aq17x
51776	payment	2132	2132	1874	1	1	2450	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrLfT3RkqgLTJQXrqL15UCykvb2681cFYJZvMVHDTXX6DKyNi
51777	payment	2134	2134	1874	1	1	9284	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFGK91KFyfZ9eYaXFCQNQoZwXWu2EvKr8kuemDxQxt53FeLzF1
51778	payment	2134	2134	1874	1	1	9285	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoyafBhzuBsZhxHnLeTsMUMVQHHVCYkWnUtARhX9je3UQqGEDJ
51779	payment	2132	2132	1874	1	1	2451	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGZ82A8cVWtxUa5pKZbLfqKQ1mwQZr3VNz1SQD19Q46y9c3JSb
51780	payment	2132	2132	1874	1	1	2452	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGMFQkXwhLfopTiajsEuwneC8JApUNtZcPVKBhPr7VJHg2i3mL
51781	payment	2134	2134	1874	1	1	9286	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLFcQYzW7kB5P7gAwRmqsLCixYMUZycJGXhVx7n8CSJzW8RKwU
51782	payment	2134	2134	1874	1	1	9287	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nfcNyTBSfUMc1XkG6kEKSRbCJPzCkUJWhMftMQS1gmrkWsnN
51783	payment	2134	2134	1874	1	1	9288	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSkBU6dhTU5XqdpWXmWUrGKjsr7BiDut268SZjdigGpmMDkcr4
51784	payment	2134	2134	1874	1	1	9289	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvkG5oy3T6c22HJP9NpyzWK5w6X2qAnEDzXotJJcjSjYYrhJD9
51785	payment	2134	2134	1874	1	1	9290	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoiw62bRSnQUXQGkQH8qD86iHq4v2zvndRgZth2feLAucz31vi
51786	payment	2134	2134	1874	1	1	9291	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaqUjEjbquvdco9PRuassrtYYGMr252fZQmvpYKqN92dUitYhG
51787	payment	2134	2134	1874	1	1	9292	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8GN9JWEFJxnP2xKDKskQSqrykG9PHiqkd9uR7Y9Jm5mB6pU5d
51788	payment	234	234	2439	1	1	1	530000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3apxg5ryzWYzDpS8d51HyDNdmR9GyqmRWDQ1fivzirsvSaL9v
51789	payment	1397	1397	1678	1	1	18324	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHhnYfJJkyDmH8aqfhvYZqskPLcCpcPCPmF9utHwst18au76V4
51790	payment	2133	2133	1874	1	1	8389	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7s48WMUBzbUuVqSiaUZ3kFzkJB9A7CkzLq4vGgMDLbyULox2x
51791	payment	2133	2133	1874	1	1	8390	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUNddcaWtfeGWkLAw6RS7KYzty4ncsBHnRdfdwWFXgX7exjynH
51774	payment	2133	2133	1874	1	1	8387	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6yd67Ly1noFC4LzEjd2zrHWakgPWHRWE5ZELthhHnWT18WprA
51775	payment	2133	2133	1874	1	1	8388	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9VT78LwvbSFw7xmCur11BL2CXk4SKPYHqAUKah3xGa5PaviEv
51847	payment	180	180	2441	1	1	4	5000000000	25000000	\N	E4YPpzX82oQ6gjyBztx8ZyU7nxPAwMyQX9qR81wK4JphdyU6MkYms	CkpaBW47MEcLWjn28qRLggapBwVTFbpkqFmAVWHfxXKs4E2HoNSb3
51848	payment	1397	1397	1678	1	1	18326	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkShuBi2xZxKEbEzpjh4xDLTgE6fz3Bm73KYDaxxsw8juFCsfj
51849	payment	1397	1397	1678	1	1	18327	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGDjy9zjCqq8wKEkokLmSaUQ1FRfRRTifmQt169UQA6AEkNk3g
51850	payment	2133	2133	1874	1	1	8402	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWvsa6Y9ybRbpGDDL43pob83wxqSsamYj2zQfpJdaEVRWxHcNo
51851	payment	2132	2132	1874	1	1	2462	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmZ4k1TcfdP4cbo2sDUKf3jmuYXfQcphitmprjEFPEixV7UXrf
51852	payment	2134	2134	1874	1	1	9318	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEpQKVqr5nH6Mc4oizYT18gGUfGcfDjEAGjzSLjNdfwEFAW3Sd
51853	payment	2132	2132	1874	1	1	2463	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWmZ6iNpTK6vDyXxLTtuMfFedKEQCDyiw2FZPS1J19ssjRCH4H
51854	payment	2132	2132	1874	1	1	2464	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYXjEbMcrztiBHvmFkdZd7y2DGs5MAXChNTnLenV9J5ZwC6pQr
51855	payment	2134	2134	1874	1	1	9319	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgsdungq3fsCnGZjtvG6Q5ssAiLB61WDWm6wkEjYNnWX3ATukt
51856	payment	2134	2134	1874	1	1	9320	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkCoicrZpba62VMmWFPXMntaJA8kugsJonQE7zdMRYRKUfqaGg
51857	payment	2133	2133	1874	1	1	8403	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5HPiD8r2EyiDJokMdojyjmNyfsE1UxCtWnyakhUFVTnKBdAR2
51858	payment	2134	2134	1874	1	1	9321	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9sV3Nyfmh9L3Yyh1o6uYDo9HvSF823yQC9UnncSMVUQKzTaMh
51859	payment	2134	2134	1874	1	1	9322	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvk2P4WuwQS32oD4zi4LNYxZrks4tp7cg2iYYDh25GqmZcmEa1
51860	payment	2134	2134	1874	1	1	9323	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYzpBm3WdwuZZ8Q55MZrEcMbHF3Zxyn9B4zKztTh4ozbwu1G5S
51861	payment	2134	2134	1874	1	1	9324	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrrvxMdvnG1hBh7bGS73w1oJggsokRZCAsmogZsaiR8NJLLbG2
51862	payment	2134	2134	1874	1	1	9325	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZttURF1UR8BcMghtXqUUsb6VYsjcq4itPYfWe5Qk9DCA4MtGi
51863	payment	2134	2134	1874	1	1	9326	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZf7upQr8U6zNyPJymB41erwXxYopEZvFn48BdNPKYZNjHNdDUQ
51864	payment	2133	2133	1874	1	1	8404	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDVouEeYQimwSkHtHGmr9KSbB4eVL1kLELYjey6VdHw1TiUpRT
51865	payment	2133	2133	1874	1	1	8405	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGQY5pDZe9wWzh6vUPmdjpVGYKtqcQKJQkNzkJWtANHyuVZMQx
51866	payment	2133	2133	1874	1	1	8406	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjADi6vSMU9BmKyrPzr7dHrCLih4w4295M9UP8tbk8iC6WnF3Q
51867	payment	2133	2133	1874	1	1	8407	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9i114ACEH9CC7VJ65CovuP5EazC4FMPZez8xn2EgmMb9yV7QQ
51868	payment	180	180	2441	1	1	5	920000000000	25000000	\N	E4YhEahnSRexdzCTMLLQ9SWbr2QiLP8FuK4FDh199hRvcuUw86wpA	CkpZiuGBXxa8wx8q8QbMuGVQNj3aH5ddMcen5vRPkcvC6yRwPqaS5
51869	payment	1397	1397	1678	1	1	18328	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVeWpUiagTBorVJcWPgvQmaTBJDGqvTyZQJaoWoH3atLWqciBw
51870	payment	2132	2132	1874	1	1	2465	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeAgfGAHfpabZR9uuMsodvYHYVUArMh2TKwbbsEHi3r8JtJWjf
51871	payment	2132	2132	1874	1	1	2466	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYW1UU7Gma2dV8aLD5WJRvv5hFZFgzC4w45d6ihP6qkZJ8GpzdL
51872	payment	2134	2134	1874	1	1	9327	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf5CUNLSG5ouNVpS38vZ8HC4dQuFZRDhBDpC4aGez3BSLAbKfZ
51873	payment	2134	2134	1874	1	1	9328	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJG5ucEUGXqL98vpyBwBLtKx1njhWUu8JeujYKxSXeZqECQqM
51874	payment	512	512	2442	1	1	1	1000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYudBhPAp67Q1zc2XbuoDFuzY6Z89LEZ8XSyXrM2Bgk5xifmPY4
51875	payment	2134	2134	1874	1	1	9329	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWCKtvfd8j8YTYKA9ynSvhurki4kowmJhvyM6mmumHGdPW1Wq2
51876	payment	2134	2134	1874	1	1	9330	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrXwYy2Efijt8BHosXaXSbCfix6FjmX1VnLb6seywssy7gMzZy
51877	payment	2134	2134	1874	1	1	9331	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS7osAYQ9QXRfjZK2VfSkLD4R9X64gBMYkk4LfxerTGcqtuK7n
51878	payment	2133	2133	1874	1	1	8408	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZxN15VLmtznEqwnyfY7WDuamHCzfmTsxqks6PUtvzR2EsJ9o
51879	payment	2133	2133	1874	1	1	8409	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbpwLEsh7ixw3toRkTDnvct8dqA1zHk4ajUo8s7i3J3izfaZ8B
51880	payment	1397	1397	1678	1	1	18329	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6YXFLP8BVLqLWC6Zqd7AGqS2jobkQu84BzmPHK9aS9QT3B2u6
51881	payment	1397	1397	1678	1	1	18330	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZTCPjrtF8Zo5UL4vCm14fugujyhveY1i3n5MjukB1DD4EBfCJ
51882	payment	2132	2132	1874	1	1	2467	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9XTYP3L5p1en6zkwms3F4a9RHocmjdVCNJ92eqR3hEgewEzve
51792	payment	2134	2134	1874	1	1	9293	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCd1BsCco8rYGDozYeKCoDKV1f8vpA75qLLqiWfeP7gRp5iNrP
51793	payment	2132	2132	1874	1	1	2453	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcQgM7dh2wniFpbAY4Adx7AhUPKCdTcfTzz2bJSus6MN89UHiH
51794	payment	2132	2132	1874	1	1	2454	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBpE77c1aG4JjhiU1GCcik89WA1KN65rKdaXqLuEx45LEffBKY
51795	payment	2134	2134	1874	1	1	9294	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZj6xXxVxoeBrRBhsz51HD4N3DXTKgDJUeTW9iT5TKyRBujKQ7d
51796	payment	2134	2134	1874	1	1	9295	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQ8wAFnAnQ3NLnqBEsTSMpn4znDTBUDQxw4hhit7baP49YXhhT
51797	payment	2134	2134	1874	1	1	9296	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXAuAjxybUia9ZKtfDuxuG6PqL43qijwq4yDjEx3hUDXVT5uZx
51822	payment	664	664	2440	1	1	4	1000000000	3000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhzAE4UuABhnkuTuzzMKDAx8tA3vrejDVKiFU62XhKbnBGPzQp
51823	payment	2132	2132	1874	1	1	2458	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYg1V2ievczhipN7o5LJQzfiLcVTrKcbvYob3g2soU1ALEHY5Fn
51824	payment	2133	2133	1874	1	1	8395	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5JSNLEDfFsoM285SWAeeKaAxvPncgTYsPqQyiDnUNgCYRVXmR
51825	payment	2133	2133	1874	1	1	8396	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx7VDf3e2jv7A4ca8JMeHrTrWKLcX2FzTETHcPq3BafkZY92dC
51826	payment	2133	2133	1874	1	1	8397	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1bMrWvPpUHw7JwKBEbRis5CVwfNM9bQVUAVfYWK467MXjyMgQ
51903	payment	664	664	2440	1	1	5	530000000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpuEJes8KVw33Dy5iNSfqq54tcfK4VgX3s3eXGpddtEjiQyEZV
51904	payment	1397	1397	1678	1	1	18331	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwk26y8XnExJtskV4gk6bQ6KNKQ8UFQ3tCX8BLjD3F77zgZ847
51905	payment	2132	2132	1874	1	1	2470	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZC1QyhoKVgqgmh4UpvCAnMgXaf5A8PQVHtGdL1CxAnxtVAwmyy
51906	payment	2134	2134	1874	1	1	9341	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJ5y3ha6tbyeTvwdvevA2wTgRf3ZaHF9RtoUgW1tyXX8fJwkhn
51907	payment	2134	2134	1874	1	1	9342	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxAxkipU1eEKjQkZPPc7zX5tneCG6Y4TPWxk2Ku8udh3atZp3S
51908	payment	2133	2133	1874	1	1	8416	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP2CbmQbRJz1bBTkajGQd61BpCr5cBotaiKpjR6GzVm6t8C96T
51909	payment	2133	2133	1874	1	1	8417	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZT8KuyWPsz1xwg5xiTAeWF5A3HFhnRLNsEiNR5d4PrZLnmc93i
51910	payment	2134	2134	1874	1	1	9343	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvzvPxTF5MParmdjyPq6ezS8AMSJ1h7w4qwbVrGDXmN4C87rU2
51911	payment	2134	2134	1874	1	1	9344	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7AD9xDvJ4Nm4gND6diobQXXS8vxAwaD8Z1fRZHrTBQ8YySv2V
51912	payment	512	512	2442	1	1	2	1000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAngWtsFyrnxkZqdM3ikmviXN2bSJdoX13Ahh99FaiSWEQtgXY
51913	payment	1397	1397	1678	1	1	18332	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYiNtMrG1CrtZmeMYai9j3rjZcivDTLyqYGgZyzb6QNEZ6iNetc
51914	payment	2133	2133	1874	1	1	8418	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeNsap9Zn3MhbfwnumDCdwDDdtdpwN96DwhG4rf3GH3mqb2mjd
51915	payment	2132	2132	1874	1	1	2471	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwJgHnGHXKLwDKLz5kxkQ2zyyNTvifPpHfCiuYVdcWzppg4HNs
51916	payment	2132	2132	1874	1	1	2472	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvQi5P9rTGrc5LPjDriP8UapSi4tLXJt2GEkpBDXqfz38aejqM
51917	payment	2133	2133	1874	1	1	8419	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5Nq13GFwtsdgfWASgmyb15ciTdNryXzaW6o5tpHEkDi3nw9Fz
51918	payment	2134	2134	1874	1	1	9345	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLNoqXXGGdi9AWainC5AnJjSWcH8ch8pUtV4z2nEP2QY3VETEq
51919	payment	2134	2134	1874	1	1	9346	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvZ3n3qD95QFmyTPsknVYx8Eg4fJfkeULVdqkfJUoJDCz4Q64P
51920	payment	2134	2134	1874	1	1	9347	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYX68cDqVfD5zwnF7wJbyQ4jmU3qT5H8gXLmHWypmAn9t3eUdX4
51921	payment	2134	2134	1874	1	1	9348	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH4RidFem9yDKccNyTbCFJJTkR1so3QkSkjQD9d3VWeZavJJPG
51930	payment	1397	1397	1678	1	1	18334	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8MLZq2xSDvMrMVhcYmuuEceSa926wNUasKQJHtmXqDedcWv9D
51931	delegation	2440	2440	1540	1	1	0	\N	3250000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnd5LeLfMA8GvyTvcj9MZupJ4ZDcGTr4ShWcoGecP5nJpib7na
51932	payment	2134	2134	1874	1	1	9353	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYw2vqPpGyPoPbXHra5QZL1EMphJXdEX69vkCXKK1WEfRCu7kV3
51933	payment	2133	2133	1874	1	1	8422	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZH9NBJy1FGE4nUG4TakgzbS56Dis6UKD6dYLMJLppyi44XsJn8
51934	payment	2133	2133	1874	1	1	8423	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBP6cu8EQsN9s7W5Z1ThbR4Phodg2uX53EmMpXqxJBykKKFXj8
51935	payment	2134	2134	1874	1	1	9354	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHQUWFaLiyZWWLq3SFbCGrKXdb75ex6pHjbus6Lnvfo5yQow7g
51936	payment	2132	2132	1874	1	1	2474	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgaNScpYALJqSTtXhbVokcD9oEmABjqvGj1RUKxx9EnLCeunz
51937	payment	2134	2134	1874	1	1	9355	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxY48h4wTuChYKXAjmtopqAetmeJLRmcv7Bm23VsbvUXPKZhRX
51835	payment	2133	2133	1874	1	1	8400	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpofUpH5cF8Pt6CYPbhCe2bKjvUeZFT7H2XAVi6ZXqEo7dZfZt
51836	payment	2132	2132	1874	1	1	2460	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTTVbZZ5Fr389WsPJ8J8hY4Z6N2LgBG3unXBhpHLrrCrRtZHgV
51837	payment	2134	2134	1874	1	1	9310	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NJ316xsbKodBLLvyeo4WEPD3ohiz5FCE39Jsik8kt95Eak6S
51838	payment	2134	2134	1874	1	1	9311	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbh649yxEHGdTvRLxpDAWcM1Ae5r27eJrBsK3pBmxwWMS2maYP
51839	payment	2134	2134	1874	1	1	9312	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3QBdRZ2nvA4V9vU86Pn9kf7fntB4yoJxPfTLGCu7HREKy46sL
51840	payment	2134	2134	1874	1	1	9313	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZR9a5BJ78xisTNpTMeH3a5JJXMnS24zq7nzR5bmmcK3471DQV4
51841	payment	2134	2134	1874	1	1	9314	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnEvxMXAdYKfpfLvDJknEvpT6JWRjWwJSXfeVRNmXRNivxYDxF
51842	payment	2134	2134	1874	1	1	9315	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwAkgMKiKMKtS4pSvmTW7e7CNwyJujuPSpyLAMkdRU67fd3PA
51843	payment	2132	2132	1874	1	1	2461	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9RnPtjsa5KDjNxhkUJEoUwXrbDvuT5mL36oU2iwv8Rm687Hs7
51844	payment	2134	2134	1874	1	1	9316	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF9CyqkJCi41SUbFoVYMoE6S157w3VXY3ZCsVB6hj32TEwLmav
51845	payment	2134	2134	1874	1	1	9317	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpMdAv7K9Wqajxb9vHraHeh2hmngyYz15Nxnq2eSBK3oq8afyt
51846	payment	2133	2133	1874	1	1	8401	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGjsbhCHRr6SWEwPcA4fDHz6XmemGTqys39iX7d92C5YJj2ASD
52013	payment	1397	1397	1678	1	1	18343	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoyVG1rWtyhi5h3hszysQZrTUNjCH5QE3srCkWb1mUxje2hXfd
52014	payment	2133	2133	1874	1	1	8442	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS6qLyENpKb6BwDDGFpvcnWZEQsiT4NLgEJ6K5qJ4dHcBNB7E3
52015	payment	2134	2134	1874	1	1	9392	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm7nzTcJMSFR3DaSBGFczo8otteByAE3ggmN8P76NSSg1Gmas9
52016	payment	2132	2132	1874	1	1	2487	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodRo3541K8ou79UAgMxhQAeGf2tqkngQzDrqJXumqTmjxneYf
52017	payment	2132	2132	1874	1	1	2488	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaZF11b6mRzKMxg2Qg4sJABrKs8RecUC9wGefQBGkQTkWLagtd
52018	payment	2134	2134	1874	1	1	9393	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxkXKysWN16r2Jaqd64xgndR6kxiKi8oD7C1dwd4xjSw75ma9T
52019	payment	2134	2134	1874	1	1	9394	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgCLH8nNr64wQQ29oBjuWyupi8QcMv9GuT2Ua3ksCZfgaj4otp
52020	payment	2134	2134	1874	1	1	9395	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVbMMnpK78jsToiLhzicU68sUmqot9SDK1zwRuPgeM57Pkeaw1
52021	payment	2133	2133	1874	1	1	8443	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFA6xrrkdWkNgXaB6pHhLwsTkGBXummRFNvbjs7k8kzCpodKDP
52022	payment	2133	2133	1874	1	1	8444	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYdEjjpCW6M2KJduuqbKAaghX8eDFQqCZz2Knfg1epUPMxvqM9
52030	payment	391	391	2226	1	1	1	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYepvsdgxU4KAPN9Lh5okaCjFb332XddDneahNNAgJmgWSPqnkx
52088	payment	1397	1397	1678	1	1	18351	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHD7AkfGPkMCSTsHnx54D8xkSsV8NrUriKe53orJgBXwUTRcAq
52089	payment	2133	2133	1874	1	1	8460	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaYKcv1o5hqZaNVQuXTjmRaGZjR2f3pdkjLbMPX7Bt56B4douH
52090	payment	2133	2133	1874	1	1	8461	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgdWGMWGWcgtTezQrg9zgQZtAYAN8rTUs2mgxG36MY2iEB8u1f
52091	payment	2134	2134	1874	1	1	9426	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjZxACp6B3bPZGThMPkXFyisCRdd1wWusDv8dEZoEMhhbPVtt2
52092	payment	2132	2132	1874	1	1	2499	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYssbSges49MbgSXggpQu5nuQgMPAb5P7VcEE6xZ1HX4Y8TkRYi
52093	payment	2133	2133	1874	1	1	8462	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEon5xuYvr6dqGAMKkvnX3nPLohLQNTxgQa2q7oHMSn6YH8DMD
52094	payment	2134	2134	1874	1	1	9427	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNLYuxzfKTRc3GDuWk8JVSpwgegUNzy3vjWAheYHNtRB7NAGtU
52095	payment	2134	2134	1874	1	1	9428	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqzwBFDe93S4bRYk8iz9YxDPKfs3ZiUBZh4kP4KLzkRL3jDHcu
52096	payment	2134	2134	1874	1	1	9429	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxPhBj7wJNPPgTw3T7J5Wa7RTaJpunHWizoYN4h1iZMKE2mj9n
52156	payment	1397	1397	1678	1	1	18358	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfjqPgGkcExjzHbyiUiDZfZvpdenbcmSMn7NZ3FLyke2XMKz7L
52157	payment	2132	2132	1874	1	1	2509	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqU6YhBbC8CLfVjz7vxdzXfes9TsfgSfezQrvL5f9dERcsd2wv
52158	payment	2134	2134	1874	1	1	9457	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRd8bNGuSuLvipHUtXjSx4wSFcN1nx8u6NknzQ48tWqt6X3FUr
52159	payment	2134	2134	1874	1	1	9458	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7MzHMRWB1ZPmQ1PtLk8sYi121uPe1cKS1ZAaWjP7JcGrcnB8T
52160	payment	2134	2134	1874	1	1	9459	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNAiDtds8iy3vsKbw3uDz2wuNYwxABFHxhoGLhtL1bFRR3Mutn
52161	payment	2134	2134	1874	1	1	9460	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbqpYjXmURmqhwNGt1EvpVifPb9tbrEhAmdELoTpXx6cfuKbeP
51883	payment	2134	2134	1874	1	1	9332	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNYzL4y9AMXUxYB3Mqi6nwUUAp3sKozrfUHoPV6fx5MNcxHadi
51884	payment	1726	1726	2444	1	1	8373	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZX8aVgDku1ztrcgh7iMb2LFa8wsNKfDjeCpByNA6745JFNXtVh
51885	payment	1726	1726	2445	1	1	8374	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYyB84AcppqC9LBRJi86HwUbJnbBd87kv1sTGvwfBkXXzuujjcD
51886	payment	1726	1726	2446	1	1	8375	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZAfdNCwNmry7yMJLZpvrnDkzviEXzuorebJSxwJxTJWWZ4HdvE
51887	payment	2134	2134	1874	1	1	9333	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXGQvuwSVDbTHpYcqLdFzJgwbSmP5v1WyYE759K16H41UBr4p5
51888	payment	2134	2134	1874	1	1	9334	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYeaZW5skDAEuAGZUVzTzmmXdhTbkLqNWxi1PdEnDz1Coe7YqW
51889	payment	2132	2132	1874	1	1	2468	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZukHkWCcc7ipTz5XKRbX63xnfxCcKeLpBNpTFFtf84NPJ6jrVb
51890	payment	2132	2132	1874	1	1	2469	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4a4QvDtVVJgbu2uYZNUSqWpAhwxvr2zy2tmqB5bZAXLRvxfqj
51891	payment	2134	2134	1874	1	1	9335	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzMNSUxqKLdxaydnfNoQVi8YXv31NAHLv2zKdAG3cvZudkpLUF
51892	payment	2133	2133	1874	1	1	8410	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xwMKR9t1frMtWhEZ52rjPYUF4a1j7jGxKEc4Y56abFZwD3wt
51893	payment	2133	2133	1874	1	1	8411	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1H6hXcDVCEmCUx3ACDym1NcY9asuB283ztytrLUSiFNpYtAnF
51894	payment	2133	2133	1874	1	1	8412	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaG9ciSad5xRZk5LHrxUXvurASyPMbpidcWbSB9L1ejdENL2Xkf
51895	payment	2133	2133	1874	1	1	8413	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvYGTmcuYRSy1ACgCQqspNaPFm745CJyaWUhDchTcaBMdXXxX6
51896	payment	2133	2133	1874	1	1	8414	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFmfwszk5rRK57kBzcGqq2zqs6b9q43dWF92ioyFEmrh8JBoci
51897	payment	2133	2133	1874	1	1	8415	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYy1u8MactZm6CQRv3LX8Fm321PCrnJuAnu3dL4Xk7fNGLE2NeR
51898	payment	2134	2134	1874	1	1	9336	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH7BkK1sdRVMLZjsMBznmMbGMpWoMLmntkUJiV3nUsu9exVPs3
51899	payment	2134	2134	1874	1	1	9337	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgTsUjkbyee1mAG4szZ9YN2uauQnopRYpwz6jNrZtqbdCnc8jG
51900	payment	2134	2134	1874	1	1	9338	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV1zQbD8VRwYooJyVKLHmf38PyVnGS4rFm3QpzRp2qLRHL2Nkt
51901	payment	2134	2134	1874	1	1	9339	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6M1B6KFcxwwrFrQeqE8TUZdzoD7YzYNLBB3hjzomSw1XMNupH
51902	payment	2134	2134	1874	1	1	9340	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQEM19uUMbWZZNLfwhRA1XmMbgxWqQSnMabNX9K62f8kuRyfXK
51939	payment	1397	1397	1678	1	1	18335	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzgu6weHkCMWzU7G5y6BZhY2C3mhKLp8SMBfeCjDK6k8Wg7tr5
51940	delegation	2441	2441	1560	1	1	0	\N	3000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6mZnjTSDhF39ymVsQeHVV1janutusCPxwYzdnReHodLaGqWF
51941	payment	2133	2133	1874	1	1	8424	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQiQjWxgKeuLSU37YbaaR557Y3y4AveaY7sX3nRG31mUGTGiY7
51942	payment	2132	2132	1874	1	1	2475	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYDX5tsCCU1ADEHb7Y8tUKqnX4SbwNp3Z94xdebkamfws8e4rN
51943	payment	2134	2134	1874	1	1	9357	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzuWVf9zu3Uh1AvR2VTrvak52quWxHa8DGXfjVN9yupc8xanNw
51944	payment	2133	2133	1874	1	1	8425	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1JgiXbQibGt3xtDea2CdLohBAaUw9SBSAR74qY6farwi6LXZ3
51945	payment	2134	2134	1874	1	1	9358	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4XZCmvkWt3BQKN2ncUGeNJds5zaLZxpmk2P7o6j33D26tJY4P
51946	payment	2134	2134	1874	1	1	9359	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhAWeNcAeDQgkTqWU7rkZ3Mko6MxfD1jEceuZYdd62ng3cViVi
51947	payment	2134	2134	1874	1	1	9360	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYVekZRBEquE9V7zWFN8PEWYHzQiLzx1kUXyzvoZXzFfddcVK2
51948	payment	2134	2134	1874	1	1	9361	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQwxM9ShMTGbXkt9dTtwAWt1CEA2QgxAFTqFf2w7mWBvAMX8i7
51949	payment	2132	2132	1874	1	1	2476	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKLqE7CPGALT5Zf9y4RqSM3MZfvejMjetpj8cpioqmB82adJaB
51950	payment	1397	1397	1678	1	1	18336	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEZZBegtjGQzAs4Cjc8S1doqGj4s5LEG5KXcB8vDH6R31yVwiJ
51951	payment	1397	1397	1678	1	1	18337	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtjqtyayGbo3wp6AFfUCbeBxuWxEj1W8JndvzLzAAQFpXDUsRQ
51952	payment	1397	1397	1678	1	1	18338	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYp4GVSFkXdVhioRLPnXeFGLLBH6C8M51MVUPiqeQMzm6kKvMSt
51953	payment	2134	2134	1874	1	1	9362	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYh6WiapmXmLrZXkpy6RiY53Z8TCmqdytmGWmgjXLhMkRccMcnp
51954	payment	2132	2132	1874	1	1	2477	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHe7zuyJZRF4q5sFeH63bp28TaKvmhh9zRFZJYMsG7jtBz98m9
51955	payment	2132	2132	1874	1	1	2478	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXDL1WahPRQ7LidAhMkNq5Eodiz77hnz7KCuJTJqdTb62SwJ6t
51956	payment	2132	2132	1874	1	1	2479	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNdu6xNjewgyxanPwMq8afnCkqTpjqS5R7fMybyo4biaJgjAfi
51938	payment	2134	2134	1874	1	1	9356	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYT1Gw7GVHce3Pt9zNXqcuiKPzgj4bP9uXYMoacnTXuDb8wrwHY
52005	payment	1397	1397	1678	1	1	18342	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzm7HpFynhPN1oPxGw3t5T2mDT4pxDYhwXpFnJn5LQDQPeeHTM
52006	payment	2134	2134	1874	1	1	9388	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgHQfNk6XPvMxnq4tLsDgr7ZUDXUxmd633iSsJFB7Li664h1FQ
52007	payment	2134	2134	1874	1	1	9389	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYf75ZvCXexGCBp3AXzfxk6rtSSxjoeU2eVoVbihpNGMTqH5Cj8
52008	payment	2134	2134	1874	1	1	9390	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJVzrtFoArDktvzesMRPw3XS1u8ywhYLXuQmgyuf2b7J2VwGWb
52009	payment	2134	2134	1874	1	1	9391	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUQ9nkGA1Tu45omZ5kz3kqQ3a8XChQHTdYpFEB5ySsFN3N35x8
52010	payment	2132	2132	1874	1	1	2486	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq7cqa3BnMrM4ugrkPzXNFC8mLCA4Raukn7Q4pAkt8XyD8WsQC
52011	payment	2133	2133	1874	1	1	8440	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK4f7QHzqQtrjniMgxZhhRSUtDspeVezvk9ESzoKGsoRDh5Lq9
52012	payment	2133	2133	1874	1	1	8441	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaRvoEt6DJB6ZVtctqt9SnXACZ5MJNSSJjGBZeTtpmKLPNNJfn
52023	payment	1397	1397	1678	1	1	18344	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz9hxGJAZQS7WppeVy3HPLM9d1YGMGvQUA1nUnViNa6pWQbGKq
52024	payment	2134	2134	1874	1	1	9396	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDicJ7Cvgc8dqLSFiTpphtjBhB4dG4ifDf264oHmoagKuU5p2i
52025	payment	2134	2134	1874	1	1	9397	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV7tB7rXskt5Q3bswHrs2YwWbaqZJHduCVw41XVtybRK1ejW2N
52026	payment	2134	2134	1874	1	1	9398	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqN6bz83RBFPAZPGU7MU3nyfkg6VQjXCHSU2S12iPkWyBkc2qW
52027	payment	2134	2134	1874	1	1	9399	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2ZinK87vtmMxHAqT4fv8q8Q8Jja8wGVLAAHhvztFb52xtmXfh
52028	payment	2132	2132	1874	1	1	2489	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFth19FvjXY92jYLPSNPFp8XFrQSvSMQyqe4MYXg2Vhtapvr7M
52029	payment	2133	2133	1874	1	1	8445	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZksLT4ouBsMb3rMDuMzcLM78c3KAcJWecDSu2mf6imsGVfTu1W
52050	payment	1397	1397	1678	1	1	18347	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9iaBCYo3Nd2d8q4xifzGv6wX11iBZbd7oCkKYwze7cTQN3b3N
52051	payment	1397	1397	1678	1	1	18348	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDcRUTZ8p9X8ef3qyGg1hgF13jZ6WV8QGcEbWDHLuCE4mrfWn8
52052	payment	2133	2133	1874	1	1	8451	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd5r2UpLjHhyiNK5W7rbTjfVcniUPbDh2hYug9T5uwfPmw34ya
52053	payment	2132	2132	1874	1	1	2493	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz6WZ7XXpTng98vFAEAXgKw7UCN1oEBZfzcG3jJTe2Pq5hoRhe
52054	payment	2133	2133	1874	1	1	8452	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1xr12AcPRCB63xiGFAqp8UpTkHkf1cLyGHGsYnYvmkhDfy7ry
52055	payment	2133	2133	1874	1	1	8453	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSqqX97hbfggG3GLkVybb9phJ5Y8BKujADBbLpXUV16hFSoVAy
52056	payment	2133	2133	1874	1	1	8454	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSW2ar9CLhTz9jvk9BBSK1d7Q91ZuZkB6s2bQzZpnyrcBwh9jT
52057	payment	2133	2133	1874	1	1	8455	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkw5jatADPWHB1V9p6hFqYD5vLbuoZzgrKN1X2Pj8zdFdhbVJE
52058	payment	2132	2132	1874	1	1	2494	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7jPYmy2UrtziaVqokfRRPXNtvTmv381gM83FTFMZ5MrGmwKDk
52059	payment	2132	2132	1874	1	1	2495	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQMQpUVosCGsmgPARCWD3f9mdbaz2nDpfeyBhSXQRx1A8QchHn
52060	payment	2134	2134	1874	1	1	9409	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLhbDZW734JbMVGYyG7ZPTEr7yiLjWHS7LAuBuwocNdQbVtUov
52061	payment	2134	2134	1874	1	1	9410	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYePkAqCGL6SdUYcYH5JLpHQGyajtLkSecKbE6vafngpnGLk2vz
52062	payment	2134	2134	1874	1	1	9411	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjRTfPz5rjpkWZvCk2xWF3iaPE9g9vtC2AcCPFiP493J61tw6v
52063	payment	2134	2134	1874	1	1	9412	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdtU8pjJwCuokYn3XnSD6B9c3cLTsa2y1rTp5iauEvJXg3xmdx
52064	payment	2134	2134	1874	1	1	9413	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ71mjspiinGwWAXhHtQRJMSFCpytUmjpvJ9MJmwamcQmvxJWgF
52065	payment	2134	2134	1874	1	1	9414	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTYt6ZRV5CSCJZm7dUaFB4CHQsTC7s4oDJ6u4ToBGyVfie2kzB
52066	payment	2134	2134	1874	1	1	9415	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFif6WQ7fsohwg4CqC7MaBVXTQBwNFtqyBV4pUSFS53MX9aGeF
52067	payment	2134	2134	1874	1	1	9416	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYrmiJ3z2osmkQdv7tshGvireT1U6uYKHyDXTfoxaK6bamyhAXu
52068	payment	2134	2134	1874	1	1	9417	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaAFZFuXYMPUtBynEG9sWLdK9QUWoBTmebWpSYKsE5iB33AyYkD
52166	payment	436	436	1396	1	1	5	1000000000	50000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVxRnNAx3eyNaeu3bApRUrTHPGQCZTPvDLLjt9Zz6c9ygAW5q
52167	payment	1397	1397	1678	1	1	18359	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYS19LsE7bZzp61WGWB232s5VmmgNFrdcAHUk3aHJyBe6tgJJAx
52168	payment	1397	1397	1678	1	1	18360	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZG1zmcMyZbUNTD2atiVzsy1i3EVdFG2KyinRbQp31LE5oPhYgU
51957	payment	2132	2132	1874	1	1	2480	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZeCZtQGsTaVfVmw993c6HtuDqDa44qjXsdckqZQEg78rsC916B
51958	payment	2134	2134	1874	1	1	9363	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZiUFaXcupiBFHatsKHpnV9gUhYzZCmaeUveHRu7dhAtDWibv1P
51959	payment	2134	2134	1874	1	1	9364	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFVvTGPCEzZi1tsYiAzCjDbFHdMHsN8CwGL8fAZTr19hRTiQf3
51960	payment	2134	2134	1874	1	1	9365	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxjV6zxbBLDAsRcZNFXPPYiEpuPYqmivGtcCA53qRCnXawgtKM
51961	payment	2134	2134	1874	1	1	9366	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZikNtAnd88LYr41Lq6kuRThVFvErfsCDrovXNk3yiLChYQa24n
51962	payment	2134	2134	1874	1	1	9367	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYr9k4vAge27Guii4c6Y6WZR3Tuuaxmov1BdAsRsAQRmyWBYnkZ
51963	payment	2134	2134	1874	1	1	9368	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZJgpbh1sTZcku96QQCGDKeUNw8FfJgP2kVKDi14HnGwMcoSAz
51964	payment	2133	2133	1874	1	1	8426	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZym9ik84eUR7FhVWfDmuahWMGTacK4tC9poQ4i4YYBKhdmYo7B
51965	payment	2133	2133	1874	1	1	8427	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfTqVuU2H6rcmw9L9vHcUdDUuotQtXPdd8khW1LhRYbj9Uo7BV
51966	payment	2133	2133	1874	1	1	8428	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYtdDwyUaSn2fasC7ahtTFNNR2mP5nPAukWG2kUG998QX1EsDc
51967	payment	2134	2134	1874	1	1	9369	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7XK5tXzMqKyA9xmFMxCMnhN95rQS6LGC7anYwDR5pmbhAW8Hn
51968	payment	2134	2134	1874	1	1	9370	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5YbAq2QZSV8HzCjpPMi6kkiwW4QopLvVzBt5jByzihtMS1CUc
51969	payment	2134	2134	1874	1	1	9371	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5BTZyyHHzNtpyBiPuB4m3assjfhKr4QsAHgq2k2vYyDmsNyMy
51970	payment	2134	2134	1874	1	1	9372	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGPhmQAK7wskS7QF88HhXEK952xZkorkWamvSqsKrfnyoC7aq7
51971	payment	2134	2134	1874	1	1	9373	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLVEJXKorydmojUh7pwv3pH6jGQZjVzpxP52uDknqJV1y7UQnQ
51972	payment	2134	2134	1874	1	1	9374	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcYg4MAAnJYsGBAkxNUVd4FYky8grMtus6J9x11JRKPWoGVYgt
51973	payment	2133	2133	1874	1	1	8429	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKFbvbbBKsurHyM5rkY9iXgi5zfJk5pvRk2nMRFHft8m1nhJM9
51974	payment	2133	2133	1874	1	1	8430	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWXPmsKQ28c7gbzZH6vhwmbSsDk4qmPYXmWDrSayxvkM2sc8qb
51975	payment	2133	2133	1874	1	1	8431	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWxUvCNscK7yFN3VqhLYwjKwG1qiv774BZ4PMZETZEHEWi3xgG
51976	payment	2133	2133	1874	1	1	8432	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUrGgeZjWGxKNyBsU1YAtsGnAWeJDM8RfG5FKqESo2W5gvWopr
52069	payment	1397	1397	1678	1	1	18349	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsEzX8UkmseX1Tk8UYiHzFtfZ1ZNRE2u8kTw33ZZDHhehiSfDJ
52070	payment	2134	2134	1874	1	1	9418	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYhVxnvDJ9MD5NU9TsEdj1dGf1HNaXP7gufs5Q9gUk6oBMuMWc
52071	payment	2133	2133	1874	1	1	8456	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbybDHTwe2f3z6oFN9s51aCwSFBmrBtLR5qRxiaGqL7X5KGJYy
52072	payment	2133	2133	1874	1	1	8457	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgwtPdFceeBrNRtfwfaVvzGttg4P91j4mwRFJfZXo1oAqwj295
52073	payment	2132	2132	1874	1	1	2496	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfDgk1TJjHoAJ3FHjUXts3Rqb7cCRrV2gCoN2D13Gwkae862kv
52074	payment	1726	1726	2447	1	1	8376	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZhLHD25eCzR1k7Rq5VPDq2SKtXhpiMvKQPiuvwCrNFXQT5zomu
52075	payment	1726	1726	1538	1	1	8377	100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpYewVDBGJQz2ZQEXztmHNuLz5mVhF9tqHU8jHR5GtWphJAkYQNA
52076	payment	2132	2132	1874	1	1	2497	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmwTqcz6MQG7E92N263n5NKXyPriXvk45mrL6mcr6jP4sj3Z7b
52077	payment	2134	2134	1874	1	1	9419	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJLkruKEPTxEmEDLKtYHFp7BzjUtUKobFBxm9TY68iDAVvjRgx
52078	payment	2134	2134	1874	1	1	9420	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYoC2ub3BWugA3NKFu7QNG9srtWeUxsVHgJeZS4GzshcMYAtGVA
52079	payment	2134	2134	1874	1	1	9421	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjtnoSYu54BXko2R7drVyCSsvmmb2XY7XE1mJajeUsNaiNieGm
52080	payment	1397	1397	1678	1	1	18350	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZABW8RSUnu2hQyXtszDQg5a6N86NHgMRWz9AVQLMxiJDCEMjqS
52081	payment	2134	2134	1874	1	1	9422	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQJP9NnGw8q3Lhsfwac59djNUwEfsntvAzVPoZc6H3m49179eR
52082	payment	2134	2134	1874	1	1	9423	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZht11pDWJdJu1hN42xn6LKXx2nHdx13ZqmssM65bvdvmEXjxtp
52083	payment	2132	2132	1874	1	1	2498	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNj4jRnuu4EGnr29TAeCeHQxRYJirFwTZFmfakaBuHT5e9uw47
52084	payment	2134	2134	1874	1	1	9424	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzVYsa7aviGCTntuq8Q26VebFLVrabG16wLgwJsS7S4FNdqnj2
52085	payment	2133	2133	1874	1	1	8458	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFbCgEANcnFBgHQRakyuLrSkF9YwUyVtrDfKU2nuTqZ11GczyT
52086	payment	2133	2133	1874	1	1	8459	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCzYXjCwJi6oz9w16C9GDosCA2VX2Ha7xhHgWBe9obcLoksLHx
51981	payment	2133	2133	1874	1	1	8433	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcZ9pJ27NAwX7Ck2uzH5uPA6EcUoG6ZMJZ2JRfgdRMUtxaK6k7
51982	payment	2133	2133	1874	1	1	8434	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvt9dxayZJyW1TQqMiPkYy5iyYcNpirwwwRFCRkavE3LtAwgCF
51983	payment	2133	2133	1874	1	1	8435	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHSdm86zxbnH6NcwgAeyvBtGNW3e2R2SHnvq16yVE4UzAAAFAe
51984	payment	2134	2134	1874	1	1	9377	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi4tKq7hfTzpkadWANvGyh25LmaJeFegcMrwWFkjThdfDvrxd1
51985	payment	2134	2134	1874	1	1	9378	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYd4xYpxUqpfYhUFT4qKDHX8tEjdv9GCbyysbz8BWZVSZBhfATd
51986	payment	2132	2132	1874	1	1	2482	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGXks4EHutcTFNEjnV9fxrzTkXgHPGXs1NsKyuHMW9reYuXtP1
51987	payment	1397	1397	1678	1	1	18340	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuY4w2sQgH5ZeEgSkPoLC5PRQKUdp3vEwecmCGpCksEEtVjJnQ
51988	payment	1397	1397	1678	1	1	18341	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAnc1n6gfxmrm6wPCqqR2iqmBrjEHVphFPfaJxDDvaK8ddJua
51989	payment	2132	2132	1874	1	1	2483	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvAEdFWnmEDAXjugSeZSqfzkYYAYqb9LQtv2EXBR4J2n4x9BH1
51990	payment	2134	2134	1874	1	1	9379	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYNJewrxj9V7t2LbM7JbTHBufUbS9bHPJkcanL5SykuVCYKDkh
51991	payment	2134	2134	1874	1	1	9380	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpXXF5JT36CiTwYRXAPcYhFhbwGc64W1j7yaXwj4BXRR6nEcTF
51992	payment	2134	2134	1874	1	1	9381	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQWCfcJSDDRbJU5PjSMGQmDm8xzuwvaHuL86RrCndnY4A34Xy5
51993	payment	2133	2133	1874	1	1	8436	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZisNtxSSk97mgqmTDgaggWPyuccRQso5knjE2MvvZD7y971hN1
51994	payment	2133	2133	1874	1	1	8437	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZK83asSacJ11wA3z45uzyfpvBUEPRXR3a3mLvV1gyJDfuyrjNW
51995	payment	2133	2133	1874	1	1	8438	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAtcWLHAffhmH4GSWS6yECD2qqPEUkrT4cKUHKt8vVJ2hnGXsB
51996	payment	2133	2133	1874	1	1	8439	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWZAnG2d7QSmzrHbf6KXw7eYRB9pS5CKW5ATGCvHAt8GkAuig2
51997	payment	2132	2132	1874	1	1	2484	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZzXV1msZ3Lt9uf5GSiSvzTTisjP2Dp1wjyDe2gK8bnaNj1RUjS
51998	payment	2132	2132	1874	1	1	2485	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYdVAN7b4n4U2YE1MvU7MsQGYgZp63FPAPkpRG5qDLBm8RzYC64
51999	payment	2134	2134	1874	1	1	9382	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6Ry96Fy6Z75exUAjT1M39vdXf7JxjiDfur6f3r53KLXH7gtbn
52000	payment	2134	2134	1874	1	1	9383	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkUTRcHrRNsrbLZwNGw12HF9Xg2WrDFWnjWbVU4JVX5zbvKYrY
52001	payment	2134	2134	1874	1	1	9384	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2fge3Kj9fMPhBJ4xNtfNxzNFAAd5ZDcJGTRw3AWRg8SC7oNeU
52002	payment	2134	2134	1874	1	1	9385	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9dVMogBqV6d1ybc78aj9mnMk847Tda5ZEkMJx95WrcxH6LzsM
52003	payment	2134	2134	1874	1	1	9386	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZwCFSQxbwqnEpp8yACNAAGxUmBq7fGXKnZfUHfHkrgYqQZGMx1
52004	payment	2134	2134	1874	1	1	9387	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4W3cfDRrn1zbVEPP1g5Pd4TQAp92aG6cXcvoraqj4r2HTiSEi
52031	payment	1397	1397	1678	1	1	18345	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTSEBhdDKpdmqNiBXHiXxKfvtgoTvq226TzbZpNhYf2752rEzC
52032	payment	1397	1397	1678	1	1	18346	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV4SYQG9LNCUYMR23x8yzJ2GAcqZYGwpPuQWGLoPpLsvjgeqXL
52033	payment	2134	2134	1874	1	1	9400	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfHiyJ7TqhkncdPEbGm3zXq3SPQp4HKjqtietCsaCNA85Y4AjE
52034	payment	2134	2134	1874	1	1	9401	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYszrkFRYSD3TUvkjqayRuar16tit7CPh2dTSTjvwuHDUfFGamY
52035	payment	2132	2132	1874	1	1	2490	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYMJBd3PvUD1Esn9rgnX3V1sbL1Jh32btNQoFYXXRSagGNK5Bj
52036	payment	2132	2132	1874	1	1	2491	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTM87W88ZemDW1nqPnypADNGRSy6BxWPDfaYwYera4EhZUj3T5
52037	payment	2132	2132	1874	1	1	2492	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZFksWR6yEr8bmS69tNfW2std22EfXMA51GNWAbMbCjKRWiGk2o
52038	payment	2133	2133	1874	1	1	8446	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTGX48ueuT9uzX9kMyHwAzZe1SepmcBU8CYu5fsmvXqsLN41F
52039	payment	2133	2133	1874	1	1	8447	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAgczgStn2YG3y27Cj4sKtAV44Bo6UqTGSknHwsF4VtU5fMrd4
52040	payment	2133	2133	1874	1	1	8448	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXBCwzHCeaHMSgBeN7h5giok3d9v5uJ5ofaQUPB4wtLp2JNupf
52041	payment	2133	2133	1874	1	1	8449	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXieQfEuzFSjFDyrEtSr5W1v2ncspWrsP81sWeeByxaGQrh8an
52042	payment	2133	2133	1874	1	1	8450	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4jyvVwDkRPKabS8nrvsfDEULcwz7PjdsdeGTMRqfdm6ihojB6
52043	payment	2134	2134	1874	1	1	9402	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaLMJHTvBUrXYYrkracXb9L1eud8b1nwBnBMKAqJJmyCCMqqi25
52044	payment	2134	2134	1874	1	1	9403	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7W9E8d5sa9qdLZy4fQVCwX6dQobWsYt93jquR5bsTHDMRDivU
52045	payment	2134	2134	1874	1	1	9404	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5UXy3KVWcqpBgNVxHqCEPEkemBYxws1nHTEhJaetM6wPGTqjt
52046	payment	2134	2134	1874	1	1	9405	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHn4SWSSNmPYYXpLUMLnxgWm7Bj6u3G5VNRMZuGTaHoDPPgmAp
52047	payment	2134	2134	1874	1	1	9406	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZW547x9M7yhBw5Vgfb8LSC3MDPVkvLTfu4SaUtT41jkwjNnkVC
52048	payment	2134	2134	1874	1	1	9407	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7LqT3MgoucufcPWs6cdBX1atVy9yeSfcZN5AYufZbLckE5Csz
52049	payment	2134	2134	1874	1	1	9408	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfk8nF4iZbTs9mSwdYwppS7FyptaVvT6fG4uQ6L1rh2vLVHPi
52087	payment	2134	2134	1874	1	1	9425	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPH33H8Z88S9tX2oc92NtS3PyULEtcXq2z7NxmLuoTXm7J8hkw
52115	payment	333	333	2015	1	1	2	50000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWyXavXxCxSS5x6m643s3dujA876vTgtB92uN9uKM4q9p7YTJ1
52116	payment	1397	1397	1678	1	1	18354	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrd5Zf37FuFx3cCC1jbjUg8Q4L1fVT49knjCas9RNaGzDPqyFi
52117	payment	1397	1397	1678	1	1	18355	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7tNRXE1av5vFAnDDriyKfpXywEsH3SJ7piig4kBYK5TMEM532
52118	payment	1397	1397	1678	1	1	18356	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2NZFfWjFKf1DFBwHhBE796iGbyKZUiJRHP1mS1By4Bb9u1GAU
52119	payment	1397	1397	1678	1	1	18357	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgodVdiH1muqAm9wX1BbJa2QMwsFEYmYXMutXjWZYJzR9D2cuz
52120	payment	2440	2440	664	1	1	1	1000000000	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ56CEecg6pLWmLaWXDqpduTGAuhB3weLg5KUGj1E9sjUe3qT3m
52121	payment	2132	2132	1874	1	1	2503	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpxvY1AjLAXzYsRCNaTSB7aZ8atGx3vWd1uTcHirTsP6z6aBSB
52122	payment	2134	2134	1874	1	1	9439	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1tLMuL8S19K1xoiFzhLzju1ttrA7wYT2g1p8MKjUaaBbct7eX
52123	payment	2132	2132	1874	1	1	2504	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPEsgGp8fuj2yJKnoTfVaGffAnpVVvchNyoQVk5A1g4wD71N6u
52124	payment	2132	2132	1874	1	1	2505	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZixfMs4kSPynDtzDmmKDVGkHhYa5UMLYj4CHH29u9zmsKqTzz
52125	payment	2132	2132	1874	1	1	2506	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBv5KEAXX1d9BvsWWoL5neqkeGfxAmfKsfC3NM6exjsEFHbCRh
52126	payment	2132	2132	1874	1	1	2507	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4PwUZLXbUJWegX5umVmzojZJvmi9x1ruzyynRFkWCXkCXqb1o
52127	payment	2134	2134	1874	1	1	9440	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZuQDgcVGUevyTRdWrTaqxrv4bYtW5MnzDDYL99yZ4UazPVkb4u
52128	payment	2134	2134	1874	1	1	9441	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZfudb2SqD5M52qqxVHhLGwa5xpTAb2YtQtynLob7uqRkYJgv2p
52129	payment	2134	2134	1874	1	1	9442	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQX3ZUVXcxMcaENUkNRLuKCrJDhxy1VSWJwSNAu9E4rYCAAJ2y
52130	payment	2134	2134	1874	1	1	9443	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmrAGnX4tFFVbYpVVAjMM9j74AcXd4sfegxY24hKE6ViZsZGmY
52131	payment	2134	2134	1874	1	1	9444	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3ZWDgrqCjkNUm6jvCTMrmVb6nVNJB6qBVHtBsZxRc5ZzQ2krK
52132	payment	2132	2132	1874	1	1	2508	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QArLDoAuwKSKLQZY2LJVMQLwWQsbDAohyEemdRELcYRwMpW2
52133	payment	2133	2133	1874	1	1	8467	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaB8eLRqY3nTUYfpMfQ5QArLyAWREutoGcJ3JDrFNRKxz7dbanM
52134	payment	2133	2133	1874	1	1	8468	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkEsL9hvq5e4C7LXt4U7wamWv2Q7TTEx6iSZhNv1JjAnNDCqov
52135	payment	2133	2133	1874	1	1	8469	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZapMfYoHPb36cyVBqy7bEzJD5QKHcQp3AB3ykCwv4UkFLnJmcV
52136	payment	2133	2133	1874	1	1	8470	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwwwUY3LmTPfRiuafrAmNbYQT52uBhKk996EkyYpZbMbwV24BA
52137	payment	2133	2133	1874	1	1	8471	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHsyQJRkHuUHrTBnhRaNXU1x8WpTYSoqrAgFbMkhdiVjadpWog
52138	payment	2133	2133	1874	1	1	8472	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUZoSDzjcsmLroPLs54gXZYBuV24xLNbqH2d3fbRu3cujpeapE
52139	payment	2134	2134	1874	1	1	9445	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCpgnyDbtGzora2QyiZLiH5yi9LQ8zV1wfoSi3xsb52fjyrSYh
52140	payment	2134	2134	1874	1	1	9446	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZr7H4Tjp6QqbnRySz1Ac1U3WYiqczxvhy4qyz3q9V4iUsEFLET
52141	payment	2134	2134	1874	1	1	9447	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYihebPeThtbGQkTtUemGr8qnQsaXMwJww261hPf1rtYCfbU66r
52142	payment	2134	2134	1874	1	1	9448	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnMhXhyhqTAbvWwdM54oFAqwQjw62Q2attijdVjhWwEjnjrtez
52143	payment	2134	2134	1874	1	1	9449	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpVDvzU21JrCeEk7YJZkTtzeiBi87Sn4cntmCGseVJhTiLsRS5
52144	payment	2134	2134	1874	1	1	9450	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaCCunPNXJ7yacSKuUc9sC1143wJjXEQq3XLG8EW5Cu2BbqpDfc
52145	payment	2134	2134	1874	1	1	9451	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8TDXmDZnbUwyBC65CkbbivXwJUeN8wrU8GUw8zjFPiTkAQ4Dy
52146	payment	2134	2134	1874	1	1	9452	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkxkGDfmeCpGY5z1sjQXyU8GqRQMibXuQjxmPqB4Z6MigSbqDK
52097	payment	1397	1397	1678	1	1	18352	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCmioSiNC3YBQdGfED3FsWy7XtW3paYqvGoYh7obQnvma9gvYe
52098	payment	1397	1397	1678	1	1	18353	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9UD8s48VMBagL9nqSHfqXU9B8kYjSZ3SEb9Lh3XPEw7KCKoUN
52099	payment	2133	2133	1874	1	1	8463	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZLBX91hweGiG28Xhb5trF3ZSkdocSiTegjkFtnArDTLBnduMX
52100	payment	2133	2133	1874	1	1	8464	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbeDQZB6UnwiiNBjP3gkTiffUKSS9ZS1txAeVfMKhGPBpnQW6N
52101	payment	2134	2134	1874	1	1	9430	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnyzHmYwaC5TGyXJQ57GMDBFhKLWxLH6hTfgamqiE1mFBtG8Pq
52102	payment	2133	2133	1874	1	1	8465	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ1Y1LkNZhaYuf8mbqJyMmEjURxHWY451rq4NRW1N7tsu5S9bbY
52103	payment	2132	2132	1874	1	1	2500	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5mVaLCCdRVnMGVP5jiwardt4iwZjDZE9gvb922snZ8VyyCHaS
52104	payment	2134	2134	1874	1	1	9431	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ5nCE2KNJfjRbnCqkyZctH64UpsXt3C1yE2UByY4r9WdLvhhJP
52105	payment	2133	2133	1874	1	1	8466	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCJonknV3FKbDrHwVywvTN2PQnvG7shJfYZ9Jofrw77Ms4GShL
52106	payment	2132	2132	1874	1	1	2501	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLEG5mZEh9xSoUSpBdVG7nQCcuyAW5FAXDFBUvB91T4oXbsDq1
52107	payment	2134	2134	1874	1	1	9432	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPvA8wHv6JR5zckxLt9aZRorkitEcuUrHt8i6maLLZVLPU9fic
52108	payment	2134	2134	1874	1	1	9433	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhK9XRipBiNyJqnE7yVPSAsS6iV8nQ7rhgvys86xdRLsy1Bs7a
52109	payment	2132	2132	1874	1	1	2502	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6U3z8ijhouTiGTKbDREPCuXtUW4HKdkayLeQwkfwUdUhNt5Mp
52110	payment	2134	2134	1874	1	1	9434	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9s7m3JppfMBfmi81yD3bemFTonUARLTzj5tWf8N94WyGqpK1
52111	payment	2134	2134	1874	1	1	9435	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxYsYXCBJzmzUJgyUaaHJmBBgkf99CF1CH28tE9z6RKD52igLr
52112	payment	2134	2134	1874	1	1	9436	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYJKT8MSvK8dXYcYH3kw1uy2n7JeTHnvtpkacNsFVZHrd8nFBe
52113	payment	2134	2134	1874	1	1	9437	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhLZYgvBvCtJDoJGMntBoHJFHqnGk1omyTdvmMEr3K9thuBHZs
52114	payment	2134	2134	1874	1	1	9438	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV3MAu6zsiyuxY51LfSuSo79y9a73JvyZ93ZgRbeeWR2un3uRk
52195	payment	1397	1397	1678	1	1	18362	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZu52DNTjY92KwKLxyP11WuWYBta4EmP1eycpsL3Voc5AWVzn9J
52196	payment	1397	1397	1678	1	1	18363	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEPGtoagKevBeKqzajr6erCCWC49V45D7g5QwTdd7CchDcvSNo
52197	payment	1397	1397	1678	1	1	18364	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaX4oyQKnssZZMxbotYRWzuZqY2pPM1HiEJypwqa6FxDMounx2
52198	payment	2132	2132	1874	1	1	2515	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfi7NAB4sWHehqsLJeW8Us7bebXThCr4cYDo1nNJR7TzBrcVpW
52199	payment	2133	2133	1874	1	1	8488	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmDSJwrjLvDWY39EdCvjQQTsSwRtrh7znfX9GZngsQ34RPvv7A
52200	payment	2132	2132	1874	1	1	2516	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2a65cLX4AMZFqCfh3xjx4X74fqYnZS2k8gvEe8jeW27iE1wAD
52201	payment	2133	2133	1874	1	1	8489	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8iC3VdHnf1MivW24wGRgvtaz4Z53hssofPWb462RbxLCmzWNQ
52202	payment	2133	2133	1874	1	1	8490	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYfTepCZkTytJRV1bGadya7hPnLF529QdT5C7HGg5gRurcSk1Qv
52203	payment	2133	2133	1874	1	1	8491	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz4iLn8h8kWAuYa5L2f8obUx5wNi58Ye8WkFAbZkjLPfA96e1X
52204	payment	2134	2134	1874	1	1	9475	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZdmXwCaLPyKxzkLBULQTxW8rh3Mq9x5VLphSM9ha8hW7uU2MC
52205	payment	2134	2134	1874	1	1	9476	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAve36HEhiah6vYSqnDmZ3HfJhtiHTWmkcXaNzK1ZphpSGvMBz
52206	payment	2134	2134	1874	1	1	9477	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY8ksr8gdjbmHHTcmnjYGEeSURDu2MFn32Ey8wzuHu5RdeQ9vN
52207	payment	2132	2132	1874	1	1	2517	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjq849PBqSGetDHBcbKh2YoPvLVLDBJpNQkEbRLMxBJbgY3R24
52208	payment	2132	2132	1874	1	1	2518	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZi1nJxxz9NmsoaNsiJonmTj5x2sqQSPAttCDR5UN9uQiaTH7NS
52209	payment	2133	2133	1874	1	1	8492	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnBSi1LgxTRGktJvV9wPJY7cHWwn8369S6FygwrZocojHFnu1Z
52210	payment	2134	2134	1874	1	1	9478	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpEcDSjcUTZpaby1r6qBEDn12E9DU5Ln84NEJPoiFXUHtoxQ7V
52211	payment	2134	2134	1874	1	1	9479	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYgnJpCi21U8uKSyGpRtxvnaBhhhGZs6Fq23thnGscvciejwXpq
52212	payment	2134	2134	1874	1	1	9480	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtMRQVbY3cqzms3vaMHNp24NV4mHm4c2dWGyVRFhnDZD44BDg8
52213	payment	2134	2134	1874	1	1	9481	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZchzBqWs97kG2HidmZxDNKHLHhRUVpDpdXzqdq1eTQ1TCbRF6L
52214	payment	2134	2134	1874	1	1	9482	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZGJDHN5pagdPx29NVciuyZBixNDqvvmyUGxr3xiRZW3SWpcEUy
52147	payment	2134	2134	1874	1	1	9453	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcgQPBRdK4eaFA9psNmu7Cg9uaeRCxTDBG2FfA5TF12F7fHEWu
52148	payment	2134	2134	1874	1	1	9454	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ262nERmPZ3tKw9cewas8EhkBecbLJeAqBcXLvnpSzgAKcJ7my
52149	payment	2134	2134	1874	1	1	9455	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZV6npq69FmD188eyuamHqyXMEnbv2stNrN5Y19f8Z3UCJ6VZA6
52150	payment	2134	2134	1874	1	1	9456	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqNnfwuzpdwArVxGk72QvyY3izH5KqJfBJ9Zo6UiviDXx8dG1T
52151	payment	2133	2133	1874	1	1	8473	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaDxmbszwfAZwZcq9H8UAHJHUnQ6p2zNimyr8jqZRS98CjRwMe1
52152	payment	2133	2133	1874	1	1	8474	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUhzgyKJxrScTRKQR58JdLQsDNRXhwKNj7RfPjhpXbAqS5bhhe
52153	payment	2133	2133	1874	1	1	8475	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkJfmbuxnzqabJWghHjrmzFLLvENskVCgHET3TR3wrBojxkVHb
52154	payment	2133	2133	1874	1	1	8476	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaKUHTKqLHpvL3w7nfvR3QvWWHYgGW1LkXS9jfdbVywNxmwoP1N
52155	payment	2133	2133	1874	1	1	8477	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBW1hcbP5JTMhuKnnXZ9TW7burWUQpqeWnVxvReMzX79HshpjQ
52186	payment	1397	1397	1678	1	1	18361	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXEywjpYEeHcepde9rRremXWUUcN4QKPMP83WXir5Dfk5pUZKs
52187	payment	2132	2132	1874	1	1	2514	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSe2sXTPjEgYRH2z9z9Hane4t8TCsH72GE9QPgQctRQpAWvTSP
52188	payment	2133	2133	1874	1	1	8485	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYURHCAb8FGG84YxF5YikEVWxa9pgT4vgANDuWAmJjcSsBGhD35
52189	payment	2133	2133	1874	1	1	8486	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTy8ddW1GkgjcnFEEkKACp5bGN6uqsNvhrGifU38fzexD14ZKr
52190	payment	2133	2133	1874	1	1	8487	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYahwh2DSuErNZySo8V888DANWiLYkYsxE45N2Q3FtfYJeH6QSc
52265	payment	1397	1397	1678	1	1	18369	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZL6WpaVj7i6S3c9rkQFQhhsHtH1meqprCwSe87FVKA9sPfU6ng
52266	payment	1397	1397	1678	1	1	18370	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhNvXfCbPgMbZPGYL28SoejP3BBVf1vv27DhxoUiCEJ3CV6X2P
52267	payment	1397	1397	1678	1	1	18371	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpouK1hBY8G9AEVbxUrAa9TWBZU5WrJkmHNK7x4irJMHNFGSDn
52268	payment	1397	1397	1678	1	1	18372	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBu63haV7AiAjB7G3qHK3un8XREX6ps1DDhAiDGmRx3YuMZ5qc
52269	payment	150	150	2449	1	1	0	1000000000	2687500	\N	E4ZLCVEKTosvitHyDMwKzSrci7E1BcnE5zs7CvEvZZQxCDcFr3Lyh	CkpaCrmJazSRJT2mdtuxG9FqwYZnCo7H4AtenkwFjtHrpozNtSQKN
52270	payment	2133	2133	1874	1	1	8508	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4Xa7UQaTvY1Ke2CmHzMPJej4DhR9fZSwvBFhYQKwustygn8RW
52271	payment	2133	2133	1874	1	1	8509	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZWrLxncinYTrFnKGxn6CYWgKR5Gmy1BnPzpzVLrDz7hCzLMQEH
52272	payment	2132	2132	1874	1	1	2525	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpxw7xEcrELrNLJdzGTLReTJwfXvDFDFLdd4a5MPPZoyeP6Uez
52273	payment	2132	2132	1874	1	1	2526	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3KHspei6yyGiqd38pp7AiRH1ddrsVD8R7e4uJvF5z2GqEZpN2
52274	payment	2132	2132	1874	1	1	2527	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhKXXqtJqQEHPjvzJYcq7YkV2KtfKm5RRYFs8rzTrjVXKzx4B1
52275	payment	2132	2132	1874	1	1	2528	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtKoYuNCT4PJGUfUwSweEodwCsMMwmVNPLZAf9pbQG2pv4FzPV
52276	payment	2132	2132	1874	1	1	2529	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYj6hmfrYsTpaqTPteKt9XnwAJmvtpvxNJy22HgFtGppuBuDT6A
52277	payment	2132	2132	1874	1	1	2530	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjBUXiAx29JyqH8Bx6YZNhCpjKsGjrVzimLRKF3wrvWTXurjfd
52278	payment	2133	2133	1874	1	1	8510	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa7KVL6Q44L1CoDGQAQMs1Xg5E7CsXQPwSi88CGiBmVKHPLnh63
52279	payment	2133	2133	1874	1	1	8511	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYeRaKBGoHBe7pcArewsyMK8Lp3mW6GuQdbhd6GcRBznLsCgPJo
52280	payment	2133	2133	1874	1	1	8512	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYz7qqsbPjDXEq64XL5qppNWm9cBSB1oPjj9Pi3F229eG5BCKsz
52281	payment	2133	2133	1874	1	1	8513	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZZ52svoy2CHJ4fsBxQNk8CnyFXEhwv8q3ECioTnkoCiYXncyyV
52282	payment	2133	2133	1874	1	1	8514	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZF9rpXasTh9ZSN25uXAp2tz2TChhDQ2WUBqJrCdAULazp8Nvjz
52283	payment	2133	2133	1874	1	1	8515	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3FiLqTMRzFH24Cm8HGaqaKgfoa8shnTCg9zzHPjK3ozXYFSUM
52284	payment	2133	2133	1874	1	1	8516	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrfzbj59pdkThSfJB6GioVKw2FjUAPkQAbBTzaJRhCHqZMoQ7T
52285	payment	2133	2133	1874	1	1	8517	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpvzpK38YpvQd75sJEnXdeFp1idhDzHgyDWazQoD7gHVctv4Jx
52286	payment	2133	2133	1874	1	1	8518	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYVYtdmcpQiuHxxV5K7q8Q3sNBeqw5cfykYFmzPxEdnpw5R683d
52347	payment	2134	2134	1874	1	1	9543	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBca3zon7fTfHxjzdDJhomBCF8MbvJcYcx66H1aPrWgYDEFs4D
52350	payment	2134	2134	1874	1	1	9544	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYk2CmYpZizLpZYcQUh3MJe4eRQMfGzb378r7c7wufkTu3xBycU
52162	payment	2134	2134	1874	1	1	9461	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZqK4RDfqpHYTCEY2UWuauFceHUBT477FYqf7XZYtDoZpYVDh1p
52163	payment	2132	2132	1874	1	1	2510	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFa84SPFj4x1C9hZSJkDQko4TQuuTrbqJe8TuvtRduGyM47DNk
52164	payment	2133	2133	1874	1	1	8478	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRwz8HqLrt3MdZ3iFexrcrQbucQ8K8BgZuHcufNmFNPWS2MzZn
52165	payment	2133	2133	1874	1	1	8479	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxiu3BpW55Ddr2zNTQxmzQLZjxyLPmCg9ywVaUxj6ZhfDVjKcQ
52191	payment	2134	2134	1874	1	1	9471	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYK8fSbDofGwXSpAkrShhFSccyv6vb11VUkY85dE9XWruBW4RF
52192	payment	2134	2134	1874	1	1	9472	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYtVVRm28eKGaFFhZh2noPT7AjKySrPkjGqDSDwB35LhiynrBvd
52193	payment	2134	2134	1874	1	1	9473	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYawjEBq51Yy5K4d7JTyWwmo3S5q3zWcKxZjibsqNqYGkfiJ59w
52194	payment	2134	2134	1874	1	1	9474	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYW8cCumqKtLKV4GPBXQmjZ7TQfjBmhSkcDqcLCC3awreVUe8g
52308	payment	1397	1397	1678	1	1	18374	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ97peXCUriXwXvDZJeUyoFr6R4koZyf9j3z3HUy3XVeSqyjKGP
52309	payment	2132	2132	1874	1	1	2531	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZn2JuAvcGijgu2fchXbsiHh41vzEXmQzFY9CaduJC7vnuGenBA
52310	payment	2132	2132	1874	1	1	2532	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZELnqyfeVXcGzdU1XS9ho1NJUWDEsbcNXHawrYnkmPzXgTovfA
52311	payment	2133	2133	1874	1	1	8522	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZyLczXXcsFe36Ec2hBz3J9puek2SKCqsZxwERfgiuoqYjnowie
52312	payment	2133	2133	1874	1	1	8523	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZkxBVfrYP716JuwUpQx3EseQJo3K5gd8R85BaFagvoXnzFFKDR
52313	payment	2133	2133	1874	1	1	8524	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZXwM58uEin5QyxypU1mrwPByYZKuuZSKrW8Gshcj99VPbbnY4L
52314	payment	2134	2134	1874	1	1	9523	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZtfU3oTEq5bTsGeQohP8JABfjrWQrjqddf6wwvFTv1Gg7HP56v
52315	payment	2134	2134	1874	1	1	9524	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQzXBNK3ay6h59Hr2fH2tdnJXDegonoSdLXfwRVhYQwx1iVAok
52316	payment	2134	2134	1874	1	1	9525	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZYTtGJx1VrTVsBPEFdHM7tt4DUtRMx8U1xYwtUCv3GwEJ76yXa
52317	payment	2134	2134	1874	1	1	9526	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPratseCuBHpGbj3gRusPSvfAaJ4sKubGbK3KxdbypThtmue78
52318	payment	2134	2134	1874	1	1	9527	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWB4ukTRUKUE4h8WMpfVQDQnrLXpKvqBmELZ6wdsHNjhd2y8DV
52319	payment	2134	2134	1874	1	1	9528	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbucHz7KLLTedWvrGMvhgVH4naB6VGQ2ZrijFFt1g2E5cKTkgN
52320	payment	2134	2134	1874	1	1	9529	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjbTrnQEewFZfGJ7wsUd3VBHukKXvviJ8GPcSmqq8nxnY2HRpJ
52321	payment	2134	2134	1874	1	1	9530	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdaAfr6hPxbwcLKrMqMDRWR5sYKkxUctRKqLvyUKUAkd3pz3J5
52322	payment	2132	2132	1874	1	1	2533	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaK9zavs6Coq4gxUM33ZD99sGgiGt3mTMCEvbfmjg6GFhKjjCCv
52334	payment	1397	1397	1678	1	1	18376	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsvH4J9PgUMtRewTsxYNKYRJJa2WyvFFfugaqcnNFvnnHYH36X
52335	payment	2134	2134	1874	1	1	9536	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhbhchfjoMzxVz2Uo9STcDRPMA7P5BmPHNLutErZ6nJWYcLKAd
52336	payment	2134	2134	1874	1	1	9537	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYodqzEm7B7B5XA7RiKfoJ4DC2SJtgLXzsmzV62nm1SWt6HgCYa
52337	payment	1726	1726	2450	1	1	8379	1100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZJeCgHYCy1zGUnj2MikArrRy2y4LvDdo7gETTxNHEFoG1kSZGp
52338	payment	2132	2132	1874	1	1	2535	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoC4PZDKMZMvdjFjvFNpNU5EAPsgrHk4RGrNEL6yy57KAj75e6
52339	payment	2132	2132	1874	1	1	2536	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqa511VpW4UkgBW4jWTxkiwV8ksgGXnG652YbcDt5cbiUMboPx
52340	payment	2134	2134	1874	1	1	9538	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFyq7qW7WjTHQBoywXbibYfDLkZzZdVrF8n2n1wy4zBqTBWJeb
52341	payment	2134	2134	1874	1	1	9539	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaH9kUv51Y9LQWGcUBeVjU5M4C6fmaNQ9pd7zFn7kWDcH2nNgNg
52342	payment	1397	1397	1678	1	1	18377	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaUmbctC6prk8GYQuU4EEHzZzqvGhtHbkry6wMzyhN9SAreZSt
52343	payment	2132	2132	1874	1	1	2537	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYaDgZXTuR4F4PryYPn9rpWBJZefFHUj2T2yEiSs8rGC1jE7kdE
52344	payment	2134	2134	1874	1	1	9540	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVL84o26byw7VEAoMhzsTTBTdRF9DJPD3hvXrKeDFD1BQzjsDS
52345	payment	2134	2134	1874	1	1	9541	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAHuVVqKVSTnDNkqT6fotmHQHjzmXmDvaUbtwPwDXXTWZ4nhWP
52346	payment	2134	2134	1874	1	1	9542	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ7PqVyUjJPyMoLXQrK3TFpMowvoV2NQUMe9ukFrJVjYA6N71Jo
52359	payment	2134	2134	1874	1	1	9548	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYc1hx1zdHhbK43CB2tk6MQBcJmQE1P7AcT8shEErXCWswLfLoZ
52360	payment	2134	2134	1874	1	1	9549	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaByzCoK7ogx9ZbrWBz2UFMGC7tqrxUt9XzH7FHJ85QvWUDPwsu
52169	payment	2133	2133	1874	1	1	8480	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxohYAAVQr7XDg6xYAaELcqJw5RD6eyTywMnPaBZSKYUL8r7N8
52170	payment	2132	2132	1874	1	1	2511	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnoS93sMYPNRyRN69AMrZnFqohFfLHy4WieWsFBWDGoHxmkRGD
52171	payment	2132	2132	1874	1	1	2512	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYea6sngMxSZEAGwfqY6eTRx5AiZ3zjR5uJz4aeUNVdCc9XRAmz
52172	payment	2132	2132	1874	1	1	2513	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZq2DZU3qsjV61eUoEZW4bGcKhswFWPNYTgq7Xxki7NbKPcGYPF
52173	payment	2133	2133	1874	1	1	8481	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa9gBxCyxVrXt2qRzwERZYLKBZ1BRsPKdmDCTeXRCiJP7mUxpbU
52174	payment	2133	2133	1874	1	1	8482	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhaSE7cgnkDnDYbkNWRqPiqYPjjkz7kNeDG9AR4b3NB8Cfy645
52175	payment	2133	2133	1874	1	1	8483	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYSWJxEsoY1CLanrGFaRmfQyWSEgbNSJ7pXdg3deEioNRyqwdXM
52176	payment	2133	2133	1874	1	1	8484	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZP7bgLLQ2FbZKZ2qKVd4BHjXSk6wXWdT8M4QxNitzXxbjSwwW4
52177	payment	2134	2134	1874	1	1	9462	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9TUZGw9reeDJqQJprUo33btZk8mesSR1MtyPT8wh8MFb8TKz
52178	payment	2134	2134	1874	1	1	9463	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnj1p2dLCjHiane6jJoA9StDDrPkU92msDgXApeux4aFbUZFYc
52179	payment	2134	2134	1874	1	1	9464	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZafkSu5rvqEfcRhnkEePCF1pxcvManqVDAe3PBF1v45ebXWUBp
52180	payment	2134	2134	1874	1	1	9465	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBQbccuJ9FcCzm9Pv13FehedRqqg7P6NLU8bxu4t2M3S9V4zde
52181	payment	2134	2134	1874	1	1	9466	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjuFvoGqW2FJodRyVjivY3KK6z39nayxtBDGPmTZYfi64emH4B
52182	payment	2134	2134	1874	1	1	9467	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpRBZXYgJqGzwUDTVffpYjtcz3uv56Q9qTSh7fCGb5gMEBF4SJ
52183	payment	2134	2134	1874	1	1	9468	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYvtexvk4y1VbkXuVNCtkTsbhUSyP1GDYzsXWqoMH2wc5UQ67aw
52184	payment	2134	2134	1874	1	1	9469	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZS1huUwnCPtCj3yR2VVwy7AvSfwpPzw5AKWBXJTyXGZdL7qK2W
52185	payment	2134	2134	1874	1	1	9470	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRt7tknEsdA6HnYSk3o7ygoKsQdSvP4Gu58QRmR3GogUaQJfkU
52224	payment	1397	1397	1678	1	1	18365	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ4WJ6Z3cWNRiBm3XtS7o5hXSEbyfrx1aH6ZsqwMCt8RDChaeDu
52225	payment	1397	1397	1678	1	1	18366	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa3k4YGLJmZ2a6hkZuV15rJuRsuPJbUA9DoMFzki5TMUvXSedfW
52226	payment	163	163	2448	1	1	0	1000000000	4000000	\N	E4YRXM38gcPRn5Nye7qejXpai4HdxoiudvZvGEBMSnKe4DDn9iEYQ	CkpaBKvmR31tjatvNRR6jEm15WQUhvpRoYdwK1UzR4zGxP4t4BKQW
52227	payment	2134	2134	1874	1	1	9488	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwRzjPcccr7fyKEhe8eGYp79WrLBGnJJd9aFLQ3AyH4NFHYGFH
52228	payment	2132	2132	1874	1	1	2519	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwjHkPuwnk2cfrejGwQi7QK5nQca9AUexK3nyUoWdKJLwB6bgQ
52229	payment	2132	2132	1874	1	1	2520	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYbcEDdyARHaDXnS1j3UFNikhWoAbkqyWtag2fQxpmy8CbYGD79
52230	payment	2133	2133	1874	1	1	8497	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSNdg442br3ibUxZHgTxmwtdGxLhzwYCV7DrZcfx6AsCZ2XVjf
52231	payment	2134	2134	1874	1	1	9489	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTwFSxnthTdXZDchweWXVdxxBi38CyRFfjJPk8p4X1WHk6aAME
52232	payment	2134	2134	1874	1	1	9490	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqTKS3CFWf9hB7YgSMUbrcbd5uZexWKFBF64m4zJTMEM8LTgex
52233	payment	2134	2134	1874	1	1	9491	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYqb5Rkjt9aMKTrw4jGREZ41DdCH9TfNLnv4A3t4bGCSYT8eC4V
52234	payment	2134	2134	1874	1	1	9492	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnWUVDLW9jzPZuo4bxQq8KecnsqFRYju9tyAPLckx5h9DtXPro
52235	payment	2134	2134	1874	1	1	9493	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcFeLHitYNcQ6d8zqW2cPv7FAYSwV17s8H9zzTmaUfFiPCNg6E
52236	payment	2134	2134	1874	1	1	9494	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNzjdb4SKLndo88XddxYhKT6pFUGXtG2EY8h31EmZDjnUPLoRi
52237	payment	2134	2134	1874	1	1	9495	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYUUEAQNbHBREvgfj4j6HGRndsc4dcfcg4Sdr5gP4nvXjRBtL8z
52238	payment	2134	2134	1874	1	1	9496	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZv9cF4NTEF4esZphFCzg8WcL1aQerK2PgerEbrpNJPx65nASNK
52239	payment	2133	2133	1874	1	1	8498	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxSVx5k6u5V7HV615Ju3D4Quc2cAxGF6k4AdmRPy2hkN4gsrUP
52240	payment	2133	2133	1874	1	1	8499	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZaKMQuDuMEF872wbHzckWMsRdbsNNsDCg8Vt74TP9WReA3girj
52241	payment	2133	2133	1874	1	1	8500	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa2g7qVyTbBGhXmNSRwsVYAXuqfPj6VRHWVjAokpR9iLSDhauEa
52242	payment	2133	2133	1874	1	1	8501	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmkDpeAGyE19KrUuRafrgcroF7kMyUdyeG1MmVPEs7hi2f57ru
52243	payment	2132	2132	1874	1	1	2521	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaE2ymSJeZ2Jge93E9QocoDkkkcrx7t1YVE7AYyH3CEbx44R9Ne
52244	payment	1397	1397	1678	1	1	18367	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1gw866TySg6NgmN5uZE7wuMmyfGPBQrWqgP4jTYd5S6fZH21w
52215	payment	2134	2134	1874	1	1	9483	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYY2AhwB2MSmF4GKYb5VwEwKzxnYcGjetb7d2M57XJ9k98VCaDU
52216	payment	2134	2134	1874	1	1	9484	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZsRzZ87hut3pgQ73r8EKHRThyaeDZPxAZwbZe5kkoHMJq4qkJV
52217	payment	2133	2133	1874	1	1	8493	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZykmzY1AU6NCoxUQ7onFYE9G3zGKSezei2NXQbUDXEJRvWWVoc
52218	payment	2133	2133	1874	1	1	8494	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZRiPCqWCXDqu4n8paNcnVzyT5LoB8xQpvVdEpWs7yXWCmcMREc
52219	payment	2133	2133	1874	1	1	8495	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCCfjHsrASRepzmHQfYSFZqTXDP2zBz2qhrdHxq6pNKMGSu2jU
52220	payment	2133	2133	1874	1	1	8496	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2tsbyyKnddJ3gnPnQvUeJsGLdTaNjEMMqucS9oTPzYqU2vMse
52221	payment	2134	2134	1874	1	1	9485	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8td87axn3EeEGfAMwCibP8fTt8gzfD4gWoCi8iSkqEGVjjcFK
52222	payment	2134	2134	1874	1	1	9486	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYV4f9ts6tfFztEc12QP5jHSTvhVZnnXfesgEVzUnCuEnF2bBNb
52223	payment	2134	2134	1874	1	1	9487	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6snsgjumj4giirykeifNdfmQG5KdBoWjKqPQYC4M3t11MMGoV
52254	payment	1397	1397	1678	1	1	18368	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYkHqrEZpYAs9LPv1JqVXAV1b5xdusYR1Quh84pGzKZMmpRVt9j
52255	payment	597	597	2446	1	1	0	1000000000	1642860	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBrV3oDinxDc7DWphtaksofZ7HeReMQcrRXFezc6MXaGyAGeZB
52256	payment	2132	2132	1874	1	1	2524	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZB2aMY3SkqR2iMrAQJcjMA5tJSirvENQeAEQG6RuT7GfTMoEPJ
52257	payment	2134	2134	1874	1	1	9501	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZio8gSWjosLLubTCQGge4XuVPRV4egen8w3qzXyxKoHZGXLB24
52258	payment	2134	2134	1874	1	1	9502	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYn3CawCB4wL6fw3pLyEAbz33zQSia2t24xTkFBhxKy3X8rcW42
52259	payment	2133	2133	1874	1	1	8505	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjZkrsPyQ72uxHyeRgwpuSxXgQBfWT6bU83339PvKfG1zjBWFd
52260	payment	2134	2134	1874	1	1	9503	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBG2DFQxS48mKfLtTW1fXdWVzAJsFZviFzt4nNtFob7NQWVRjs
52261	payment	2134	2134	1874	1	1	9504	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYxTjNVgn7CZoBoaV4XQ9uZc9Jh9px1giLD1J4B2TCXeDGy8fBQ
52262	payment	2134	2134	1874	1	1	9505	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSYpoY7tgDpfAzM4jsH3TiqrPwbFkL9rrVCL3JqGQrxx4SS6YR
52263	payment	2133	2133	1874	1	1	8506	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHNSQRWTthQEEeeoagYYEXdP9aimP1w7yBXk9fSrxKL1zvoHe2
52264	payment	2133	2133	1874	1	1	8507	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZQgAE2c8hVmWJWPpRefySBfjUdTjBFAs1fAB4mp6yJUmw19y1X
52304	payment	1397	1397	1678	1	1	18373	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZNZq4tNj1RJ7CgBjwQMMJVNiBU1JxcppSRcaQgdvKwzhxMGPPb
52305	payment	2133	2133	1874	1	1	8519	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZJyrgNjW4rJ9aeQUygFCM6zs34QdJ4rgA7q6woYUMuRTi4c2JP
52306	payment	2133	2133	1874	1	1	8520	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ8mZwee6yWEJvfaRwntEPeG3LHowAYDUwjHx25qujqGHY3859n
52307	payment	2133	2133	1874	1	1	8521	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzUMQVgbxcBR34soR8fdtD4MzBNhGyuExK1NpwZg1r1xKTgzdo
52354	payment	1397	1397	1678	1	1	18379	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYm4Gc1zrwA4nBNPWjdPMvsKS5gReoQnGmS9LZcygHtH9nd3rKF
52355	payment	1397	1397	1678	1	1	18380	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6uDTepDXWVriTYxJYs3LJFmkRm6DU9EtY73vsijuWBFFgwmgQ
52356	payment	2132	2132	1874	1	1	2539	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmZW66QXogpYH7ydgwmgWgzjs8WfRNy7fnc49CohA36MW34uq6
52357	payment	2132	2132	1874	1	1	2540	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaHkhCrtSaxJgVVPQSbghfLj6eGG11P8UF1eHdvJ7V2LBoC1PmB
52358	payment	2132	2132	1874	1	1	2541	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwoz2CJW7GaCjsaDzTwTufjnXfvqHQF9qyKLTirtrGJeGFszMo
52389	payment	1397	1397	1678	1	1	18384	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZA7buo7QncCc2GKktwr37gXyj8vZV8EUnquCvbKYCGUJDGbCKC
52390	payment	1397	1397	1678	1	1	18385	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZdRgA4m9GEpX7FeT6DWZTmfNBdTFQaHmCM3J4VRgNkF8aVgkk6
52391	payment	2133	2133	1874	1	1	8528	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ3wCyA23s36cth3VEzgycx8R2FQvx52w3KSpPmTuvNjwxyMv3c
52392	payment	2133	2133	1874	1	1	8529	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYnNCeiK1FvPCtrAsxvuJHPddNYxRRtEmu546o4HMj1RESt4G2u
52393	payment	2134	2134	1874	1	1	9567	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHp5d2J8Ab3jG46pBYeria8gPxsj5chPdhkdsKg9T1mvadWnhN
52394	payment	1541	1541	1718	1	1	4	4320000000000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZrANXNMChjXbyqDvBLjc7UzdNMuXzkKnHxydv3AmSizPRqwfrp
52395	payment	2134	2134	1874	1	1	9568	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaA73cHzKscE61ej11FmBYaKfML8iMMuMcmjrwfMVCSJY1kbmPn
52245	payment	2132	2132	1874	1	1	2522	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9AUeVTFozp3uTX84dNvESgtTp5StvSn5ixRERhP2oNpDntJfN
52246	payment	2132	2132	1874	1	1	2523	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2WkLkkBSf2Ae8pEmxkWJ1Yuk191AAMAheKqCTEkE6cMLCpFH4
52247	payment	2133	2133	1874	1	1	8502	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnTD4hFYMMSBn63GmrA8efk2Z9C9E8kwj1GiRZ4bFiLEfDRAT1
52248	payment	2133	2133	1874	1	1	8503	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYTwvoLJ1TEgEi1EUssWdRiSwdZQuVFrD8F9VEm9ScWKcfkLu1T
52249	payment	2133	2133	1874	1	1	8504	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZPbeGadMmmpCKG9noYiuKBapDhFP7dQTGR77zgBoJk2r5a9cb6
52250	payment	2134	2134	1874	1	1	9497	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYpSqr8GwoyyZ5TLGddMaND8Kj51J31zXi5qKA6P64Lisn62HY2
52251	payment	2134	2134	1874	1	1	9498	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZHU8ZNHsq1S5ZCp738f73PUHaxekmEbx21yDmMeZAqs4YwUjxJ
52252	payment	2134	2134	1874	1	1	9499	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF36VpzXdvADuYoYGCf5uHRyQQkGE4A1jRrRLJJ5qdR6TeYron
52253	payment	2134	2134	1874	1	1	9500	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaF2rSMbejAAfuMiUF4LevSHoPGbFw2CAYfmVs3VVyZ6SEaeYXQ
52287	payment	2134	2134	1874	1	1	9506	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoRZHDfQxUXXvC9RBNeWBQYuKBFB2PQ5PHuUGianT3M23ELyG3
52288	payment	2134	2134	1874	1	1	9507	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYau57FEDEk5w4QZaoxt68Tpoh22QYTCtDN8ErX2gY3hUf95imf
52289	payment	2134	2134	1874	1	1	9508	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZvQKUvHbZMdLxGyjrrwNDpAWKHELqdcyFZbUTyAE1fAxosbPT5
52290	payment	2134	2134	1874	1	1	9509	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa14GG1Cmp9kkyC6YV9MneHJ8qMDiKyAsfFm5k8hLctE64AxYfe
52291	payment	2134	2134	1874	1	1	9510	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa5cKbrzpwbTdcLyk3BQHXaRxaYu43XZBEQ9do9QrJCFTSMJbt6
52292	payment	2134	2134	1874	1	1	9511	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZhRUkwW5ZeXG3jmiZAKAh8Ti4PcJJzXiidFoPfYSpQiim9GxQP
52293	payment	2134	2134	1874	1	1	9512	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa1fXpSUX6AR8JMmJTvimt2TGxR6r8QB1hoiZzyKtFyfqNq7A75
52294	payment	2134	2134	1874	1	1	9513	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYcdgkrov6rsqSHSQR4Lz2HTMvCScmQ6hXHwQU2WDDgE5jgrWY7
52295	payment	2134	2134	1874	1	1	9514	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZKXRPK1aft8o91bG8FDVtgL7AS8FepRrSX9x6YtmxkzXYmhuyA
52296	payment	2134	2134	1874	1	1	9515	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYmXuJvtEAviDt23S8ga5LCqjuybvN1qW9JeZrdJDC2sf1nsFEp
52297	payment	2134	2134	1874	1	1	9516	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYjerdKuBTR32AThmW7GZ7bSD4GvC82cTKFf5ZSdfRnbMot1GN2
52298	payment	2134	2134	1874	1	1	9517	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYs3gr34XVsaEjHMSi3jWCSvKsubBux3m51tiz3AEWKWQEyJZUr
52299	payment	2134	2134	1874	1	1	9518	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZVR4eY9XimorHY2eqqmMaSu6CWA5C4c6mGpC2o3sybCzmLEx6J
52300	payment	2134	2134	1874	1	1	9519	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa8QDJo5B9iMTkySkLvdYsAP4WZsxjjFLPiSPzwAwkhjS2ViJ7v
52301	payment	2134	2134	1874	1	1	9520	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYwXXGKYof9cmu6ubcz9q3zfKCm95ipPbqKPa42rapzbV5q63qd
52302	payment	2134	2134	1874	1	1	9521	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa12YJKgfpfz1qEVRbsd6oiHS6fT3EdWJKcZ8kpTg1N8Gy8vjW9
52303	payment	2134	2134	1874	1	1	9522	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaD45rx14JpeHUQbPUTC9GghHfayaDu12eGhFpazQ6QFLZHVdZ2
52323	payment	1397	1397	1678	1	1	18375	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUrNTV9P9dm3d7ar98cX2qX71rT4FELU4xrwGpg1vksuVbV4uL
52324	payment	2133	2133	1874	1	1	8525	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTJaNLPogjRf99mF8J5raQVLKANv7PEz1SHXaHDcNNUYgw8wYD
52325	payment	2133	2133	1874	1	1	8526	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZAGFx29jouTzvsqse1dZ3M5r67WjAfwdUaBMe42DWjwScXW6mi
52326	payment	2133	2133	1874	1	1	8527	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZTpS6BSV69yFXgRghQWfeZbsovvRcneH1C3x32e6ifZAzYniYV
52327	payment	2134	2134	1874	1	1	9531	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZnNypkTrKMhSuQtoZRGNs41kgURy8pja5Ex5Nqiz84Khn9EP1B
52328	payment	2134	2134	1874	1	1	9532	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWAku6Gz4PF9KBdX2cVKNL1P59trZuWyRX3HT6RLTusFsp4Wa5
52329	payment	2134	2134	1874	1	1	9533	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZpsAC6VrqEzCZDVNXrWLt12A7xqsVpw4GkvDf8BNMnE5L3sUJu
52330	payment	2132	2132	1874	1	1	2534	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZreSYs8Hqw82PHJfJsfwnxSQSwXHjb5LJsmzfYyfQMeZLCdiju
52331	payment	1726	1726	1538	1	1	8378	100000000	1000000	\N	E4YixWbvm87jApntt2dm4RsRonNMdiuaanjcpy8BZFpNeqJpPEdBZ	CkpZywKevwhVBnatVbkpYTJf77mZjJsoLuzQ16Ld7gQnr6EWCXHsK
52332	payment	2134	2134	1874	1	1	9534	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaBqvfy5mesF6Um6e5CA6kmaKiGmYQK1JRNFZ7MNtmXuGfu8QHA
52333	payment	2134	2134	1874	1	1	9535	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaFwNVed5btSCefZwzLTVf9Hk61VPr46w4Y6rzmbP3Z5Sy1Qpkr
52348	payment	1397	1397	1678	1	1	18378	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgAjNETAq3Q2y4HknA5Ee7foxqYJXwaKCxFN5gQcz3boD632cG
52349	payment	2132	2132	1874	1	1	2538	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYugb6FzeWafwY1n1ULVsunKDcsmgCWStAxYgyY96H9Vn3GeV48
52377	payment	100	100	100	1	1	1	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZLTnCPrsbaYxRiaAZtKFhZ6rp59JKE2WmprSQA41k1ddPRKGgA
52378	payment	100	100	100	1	1	2	100000000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYx9XkdTnN2ajugawbfb2tPUGQMHrJsMpTpDJ35tcGy2Jo7xTj9
52379	payment	2134	2134	1874	1	1	9560	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZcij2KWkQidE5cXqG97dur1FCZzkVFBqpiGtB3JNNLXhLhFJsv
52380	payment	2134	2134	1874	1	1	9561	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ6kqq1hdWaMJQQpLf9X7dmFJi9CkwN1PH3cFNDeR6DKYaGhwzz
52381	payment	2134	2134	1874	1	1	9562	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZoAM2a67gnpSXhD6EPVnNQoJqWjh6ELspMg7rmyuinC6zXYUNn
52396	payment	1397	1397	1678	1	1	18386	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZBJknGKbDFEGQmZMyZq6BUZhsuPWV3ctAoUDuNg93LNMoJPsse
52397	payment	2134	2134	1874	1	1	9569	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYXcJPzppiYYujPGWZJER6RnpUHPQYVNw1z6G6vFgpLLdJfze75
52351	payment	2134	2134	1874	1	1	9545	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYYJ7HmKhtNDnZZHEodgk4iNLr1ZBqSrDVdFFBNtmpEisFBR1XP
52352	payment	2134	2134	1874	1	1	9546	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa6kdHe9yLAVN9V3yTPcwFm4fT4uj8unnbNvkYsdf8wrbc2RVLH
52353	payment	2134	2134	1874	1	1	9547	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZUTNiHD52vyrvnqrT8n4wNBGUfMfEdSTdGi1xDfwGz2LkwYLew
52367	payment	1397	1397	1678	1	1	18381	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYzRgDbghbz8FhNGYMTA1i1YUzDYAwrMVQDeQcNHQg9idyMUhfN
52368	payment	2132	2132	1874	1	1	2542	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYZVJy2Gse9qHA4V6DWp2GtPsucuwY1vQVUjkzd8TLXzj6gmNxS
52369	payment	2132	2132	1874	1	1	2543	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZMFxW95YXkTYanwLokfb62VWBVHXYVm3tEpkXzb7D9rMWHKxzR
52370	payment	2134	2134	1874	1	1	9556	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaALWjXncdfU3XUEWbrnqdUWg9pQkQZv9aqnFjJWMMFqh5kffgK
52371	payment	2134	2134	1874	1	1	9557	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJPRT2XdbN1a6aS7HHEQxQKK7e4Q9BZ1gh1NaMfUmwr5BD15rM
52372	payment	2134	2134	1874	1	1	9558	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYRHza8L5Mtv9gU3KLcgxUCFPzTXXYyyZrrHJwE7BQ8CFqeZmpt
52373	payment	2134	2134	1874	1	1	9559	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZSa4HUu5m76F5Hjmzus3qfLSj7AwjtU4ej7ewdVwTbY9PkLK23
52374	payment	100	100	100	1	1	0	100000000	100000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaJSK9uU91vmPV3Gc71Zc3haWfB3Yemnea86RdhW42uiMfiWukp
52375	payment	1397	1397	1678	1	1	18382	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZxnypKDN9np5su7jfdgBy9pBTGCYT3fNuoC3pYJz3RcpH53GSF
52376	payment	2132	2132	1874	1	1	2544	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZbizfcyJqZTT2UDAGxXTavwSvBkdEXKdSF5vns2afQjY1mYRBV
52405	payment	1397	1397	1678	1	1	18389	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYsH54DkZVtkWBZBzm63ypG38Ytm7T5UDjek4Wx91Gb9xCMwtkG
52406	payment	2134	2134	1874	1	1	9572	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWQ5aGxRUnCk8SrvwTJ72cW38oEEu7BzGcjnmeb9a3zPVWgopQ
52407	payment	2133	2133	1874	1	1	8531	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ9P3kHiwd6JDvqcrZw7G7gyD95TH4Umdy9gTZPXHciucYmu8AZ
52361	payment	2134	2134	1874	1	1	9550	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaL9mViMmtFHZuZQVGXvTUuspXCEj59i56AviHHmmoTHPrpZvfc
52362	payment	2134	2134	1874	1	1	9551	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZ2nRRXWvHDP8zmU51tmS2oyWuC1PGPuZFiMm7G3UR2yFgM6Pp1
52363	payment	2134	2134	1874	1	1	9552	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZmvrVHcC1jCR8R17KCduFnoeFtgwmRSVhzbv2K9oRvq6Fn1cno
52364	payment	2134	2134	1874	1	1	9553	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZDEUGG6X8LjbKfamPWdckBqbWRdg19hv8hmr2VwYkHD8j6RQcY
52365	payment	2134	2134	1874	1	1	9554	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaGScUvhfjuphpeK1xvjCeUyRGgr49QLWzMmp5ZFN8AAuhLzbea
52366	payment	2134	2134	1874	1	1	9555	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZCB5E81YaUZ42CXnyRCUyUKv81Bg3MsSV6BLUSa7fk5FhA64gm
52382	payment	1397	1397	1678	1	1	18383	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZX6qd2RJtnyBETQHRb4a921K7Yw9TE7Wd4AXB4bKtsqtU8KdGV
52383	payment	2132	2132	1874	1	1	2545	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZgpRLoSwapZHcMxZ5hBkRerBQ5B2CS6xPnKtoXEujZHSKFXMhS
52384	payment	2134	2134	1874	1	1	9563	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZjTMRfvXcqTKKkY7DqLLUBGY8XuxjGCG2AojR25EfPFNQr1JLG
52385	payment	2132	2132	1874	1	1	2546	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa23juP86b6fJ2YxUNTUEDymgeGy2UJXxcELreXmvbt7X1PcCjt
52386	payment	2134	2134	1874	1	1	9564	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaEpKJaA92powWLwzdq3hafgGERZiogPfG6ZVoNACxkRnvq3cC9
52387	payment	2134	2134	1874	1	1	9565	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa4g5tTsihdSDvhTcZaaVfi7MAxwMLXeA8xNiUSwHvqttCAjMM8
52388	payment	2134	2134	1874	1	1	9566	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYhSuKmQMKFT7q8V24AWKHFfcGq3zzXLaZaS3vzxnBBLLFe7X24
52398	payment	1397	1397	1678	1	1	18387	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYQdmyN5WpmR7FHZ16xVU9iEinW73dje4DJyuPjc6Dem93FR3ap
52399	delegation	2440	2440	1534	1	1	2	\N	4000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYejR5Nz2cWEYnzyfyt5Rv9qfu3MwFKsHrukHRpMRZULSBabLLD
52400	payment	2132	2132	1874	1	1	2547	1000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYR3h1P2N6598K4GmXmVKGgWE3Stbyo7UgEoFLPHSVdZcvYJd9V
52401	payment	2134	2134	1874	1	1	9570	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpZEWsLPaEe3C9wf4XDeFgcMdz8tAa7tLEKxiwetQ65KeyTBQsy4
52402	payment	2133	2133	1874	1	1	8530	2000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	Ckpa17w429QUktEY6PfxpgTkkLx12Sb11gUiRXXtTf8d5XsT2uMvp
52403	payment	1397	1397	1678	1	1	18388	1000	10000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpaApqjSErptF2upbRHFhaNouQjUMayu4gDTE5g6Eui82tnd3PAe
52404	payment	2134	2134	1874	1	1	9571	4000	1000000	\N	E4YM2vTHhWEg66xpj52JErHUBU4pZ1yageL4TVDDpTTSsv8mK6YaH	CkpYWhj4Ngz2thhVjMgCjytaszS1ZLrHPZSYJbss5D36ntDfMPF8f
\.


--
-- Name: balances_temp_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.balances_temp_id_seq', 396576, true);


--
-- Name: blocks_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.blocks_id_seq', 30318, true);


--
-- Name: epoch_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.epoch_data_id_seq', 18974, true);


--
-- Name: internal_commands_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.internal_commands_id_seq', 8644, true);


--
-- Name: public_keys_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.public_keys_id_seq', 2450, true);


--
-- Name: snarked_ledger_hashes_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.snarked_ledger_hashes_id_seq', 618, true);


--
-- Name: timing_info_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.timing_info_id_seq', 1675, true);


--
-- Name: user_commands_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.user_commands_id_seq', 52407, true);


--
-- Name: balances balances_temp_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances
    ADD CONSTRAINT balances_temp_pkey PRIMARY KEY (id);


--
-- Name: balances balances_temp_public_key_id_balance_block_id_block_height_b_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances
    ADD CONSTRAINT balances_temp_public_key_id_balance_block_id_block_height_b_key UNIQUE (public_key_id, balance, block_id, block_height, block_sequence_no, block_secondary_sequence_no);


--
-- Name: blocks blocks_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_pkey PRIMARY KEY (id);


--
-- Name: blocks blocks_state_hash_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_state_hash_key UNIQUE (state_hash);


--
-- Name: epoch_data epoch_data_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.epoch_data
    ADD CONSTRAINT epoch_data_pkey PRIMARY KEY (id);


--
-- Name: internal_commands internal_commands_hash_type_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands
    ADD CONSTRAINT internal_commands_hash_type_key UNIQUE (hash, type);


--
-- Name: internal_commands internal_commands_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands
    ADD CONSTRAINT internal_commands_pkey PRIMARY KEY (id);


--
-- Name: public_keys public_keys_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_keys
    ADD CONSTRAINT public_keys_pkey PRIMARY KEY (id);


--
-- Name: public_keys public_keys_value_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_keys
    ADD CONSTRAINT public_keys_value_key UNIQUE (value);


--
-- Name: snarked_ledger_hashes snarked_ledger_hashes_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.snarked_ledger_hashes
    ADD CONSTRAINT snarked_ledger_hashes_pkey PRIMARY KEY (id);


--
-- Name: snarked_ledger_hashes snarked_ledger_hashes_value_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.snarked_ledger_hashes
    ADD CONSTRAINT snarked_ledger_hashes_value_key UNIQUE (value);


--
-- Name: timing_info timing_info_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.timing_info
    ADD CONSTRAINT timing_info_pkey PRIMARY KEY (id);


--
-- Name: user_commands user_commands_hash_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_hash_key UNIQUE (hash);


--
-- Name: user_commands user_commands_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_pkey PRIMARY KEY (id);


--
-- Name: idx_balances_block_height; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_block_height ON public.balances USING btree (block_height);


--
-- Name: idx_balances_block_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_block_id ON public.balances USING btree (block_id);


--
-- Name: idx_balances_block_secondary_sequence_no; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_block_secondary_sequence_no ON public.balances USING btree (block_secondary_sequence_no);


--
-- Name: idx_balances_block_sequence_no; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_block_sequence_no ON public.balances USING btree (block_sequence_no);


--
-- Name: idx_balances_height_seq_nos; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_height_seq_nos ON public.balances USING btree (block_height, block_sequence_no, block_secondary_sequence_no);


--
-- Name: idx_balances_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_id ON public.balances USING btree (id);


--
-- Name: idx_balances_public_key_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_balances_public_key_id ON public.balances USING btree (public_key_id);


--
-- Name: idx_blocks_creator_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_creator_id ON public.blocks USING btree (creator_id);


--
-- Name: idx_blocks_height; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_height ON public.blocks USING btree (height);


--
-- Name: idx_blocks_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_id ON public.blocks USING btree (id);


--
-- Name: idx_blocks_internal_commands_block_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_block_id ON public.blocks_internal_commands USING btree (block_id);


--
-- Name: idx_blocks_internal_commands_internal_command_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_internal_command_id ON public.blocks_internal_commands USING btree (internal_command_id);


--
-- Name: idx_blocks_internal_commands_receiver_balance; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_receiver_balance ON public.blocks_internal_commands USING btree (receiver_balance);


--
-- Name: idx_blocks_internal_commands_secondary_sequence_no; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_secondary_sequence_no ON public.blocks_internal_commands USING btree (secondary_sequence_no);


--
-- Name: idx_blocks_internal_commands_sequence_no; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_internal_commands_sequence_no ON public.blocks_internal_commands USING btree (sequence_no);


--
-- Name: idx_blocks_parent_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_parent_id ON public.blocks USING btree (parent_id);


--
-- Name: idx_blocks_state_hash; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_state_hash ON public.blocks USING btree (state_hash);


--
-- Name: idx_blocks_user_commands_block_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_user_commands_block_id ON public.blocks_user_commands USING btree (block_id);


--
-- Name: idx_blocks_user_commands_sequence_no; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_user_commands_sequence_no ON public.blocks_user_commands USING btree (sequence_no);


--
-- Name: idx_blocks_user_commands_user_command_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_blocks_user_commands_user_command_id ON public.blocks_user_commands USING btree (user_command_id);


--
-- Name: idx_chain_status; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_chain_status ON public.blocks USING btree (chain_status);


--
-- Name: idx_public_key_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_public_key_id ON public.timing_info USING btree (public_key_id);


--
-- Name: idx_public_keys_value; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_public_keys_value ON public.public_keys USING btree (value);


--
-- Name: idx_snarked_ledger_hashes_value; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX idx_snarked_ledger_hashes_value ON public.snarked_ledger_hashes USING btree (value);


--
-- Name: balances balances_block_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances
    ADD CONSTRAINT balances_block_id_fkey FOREIGN KEY (block_id) REFERENCES public.blocks(id) ON DELETE CASCADE;


--
-- Name: balances balances_public_key_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.balances
    ADD CONSTRAINT balances_public_key_id_fkey FOREIGN KEY (public_key_id) REFERENCES public.public_keys(id);


--
-- Name: blocks blocks_block_winner_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_block_winner_id_fkey FOREIGN KEY (block_winner_id) REFERENCES public.public_keys(id);


--
-- Name: blocks blocks_creator_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_creator_id_fkey FOREIGN KEY (creator_id) REFERENCES public.public_keys(id);


--
-- Name: blocks_internal_commands blocks_internal_commands_block_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_internal_commands
    ADD CONSTRAINT blocks_internal_commands_block_id_fkey FOREIGN KEY (block_id) REFERENCES public.blocks(id) ON DELETE CASCADE;


--
-- Name: blocks_internal_commands blocks_internal_commands_receiver_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_internal_commands
    ADD CONSTRAINT blocks_internal_commands_receiver_balance_fkey FOREIGN KEY (receiver_balance) REFERENCES public.balances(id);


--
-- Name: blocks blocks_next_epoch_data_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_next_epoch_data_id_fkey FOREIGN KEY (next_epoch_data_id) REFERENCES public.epoch_data(id);


--
-- Name: blocks blocks_parent_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_parent_id_fkey FOREIGN KEY (parent_id) REFERENCES public.blocks(id);


--
-- Name: blocks blocks_snarked_ledger_hash_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_snarked_ledger_hash_id_fkey FOREIGN KEY (snarked_ledger_hash_id) REFERENCES public.snarked_ledger_hashes(id);


--
-- Name: blocks blocks_staking_epoch_data_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_staking_epoch_data_id_fkey FOREIGN KEY (staking_epoch_data_id) REFERENCES public.epoch_data(id);


--
-- Name: blocks_user_commands blocks_user_commands_block_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_block_id_fkey FOREIGN KEY (block_id) REFERENCES public.blocks(id) ON DELETE CASCADE;


--
-- Name: blocks_user_commands blocks_user_commands_fee_payer_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_fee_payer_balance_fkey FOREIGN KEY (fee_payer_balance) REFERENCES public.balances(id);


--
-- Name: blocks_user_commands blocks_user_commands_receiver_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_receiver_balance_fkey FOREIGN KEY (receiver_balance) REFERENCES public.balances(id);


--
-- Name: blocks_user_commands blocks_user_commands_source_balance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.blocks_user_commands
    ADD CONSTRAINT blocks_user_commands_source_balance_fkey FOREIGN KEY (source_balance) REFERENCES public.balances(id);


--
-- Name: epoch_data epoch_data_ledger_hash_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.epoch_data
    ADD CONSTRAINT epoch_data_ledger_hash_id_fkey FOREIGN KEY (ledger_hash_id) REFERENCES public.snarked_ledger_hashes(id);


--
-- Name: internal_commands internal_commands_receiver_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.internal_commands
    ADD CONSTRAINT internal_commands_receiver_id_fkey FOREIGN KEY (receiver_id) REFERENCES public.public_keys(id);


--
-- Name: timing_info timing_info_public_key_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.timing_info
    ADD CONSTRAINT timing_info_public_key_id_fkey FOREIGN KEY (public_key_id) REFERENCES public.public_keys(id);


--
-- Name: user_commands user_commands_fee_payer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_fee_payer_id_fkey FOREIGN KEY (fee_payer_id) REFERENCES public.public_keys(id);


--
-- Name: user_commands user_commands_receiver_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_receiver_id_fkey FOREIGN KEY (receiver_id) REFERENCES public.public_keys(id);


--
-- Name: user_commands user_commands_source_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_commands
    ADD CONSTRAINT user_commands_source_id_fkey FOREIGN KEY (source_id) REFERENCES public.public_keys(id);


--
-- PostgreSQL database dump complete
--

